// Note: Some Emscripten settings will significantly limit the speed of the generated code.
// Note: Some Emscripten settings may limit the speed of the generated code.
// TODO: " u s e   s t r i c t ";


// *** Environment setup code ***
var arguments_ = [];

var ENVIRONMENT_IS_NODE = typeof process === 'object';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  print = function(x) {
    process['stdout'].write(x + '\n');
  };
  printErr = function(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');

  read = function(filename) {
    var ret = nodeFS['readFileSync'](filename).toString();
    if (!ret && filename[0] != '/') {
      filename = __dirname.split('/').slice(0, -1).join('/') + '/src/' + filename;
      ret = nodeFS['readFileSync'](filename).toString();
    }
    return ret;
  };

  arguments_ = process['argv'].slice(2);

} else if (ENVIRONMENT_IS_SHELL) {
  // Polyfill over SpiderMonkey/V8 differences
  if (!this['read']) {
    read = function(f) { snarf(f) };
  }

  if (!this['arguments']) {
    arguments_ = scriptArgs;
  } else {
    arguments_ = arguments;
  }

} else if (ENVIRONMENT_IS_WEB) {
  print = printErr = function(x) {
    console.log(x);
  };

  read = function(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (this['arguments']) {
    arguments_ = arguments;
  }
} else if (ENVIRONMENT_IS_WORKER) {
  // We can do very little here...

  load = importScripts;

} else {
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}

if (typeof load == 'undefined' && typeof read != 'undefined') {
  load = function(f) {
    globalEval(read(f));
  };
}

if (typeof printErr === 'undefined') {
  printErr = function(){};
}

if (typeof print === 'undefined') {
  print = printErr;
}
// *** Environment setup code ***


try {
  this['Module'] = Module;
} catch(e) {
  this['Module'] = Module = {};
}
if (!Module.arguments) {
  Module.arguments = arguments_;
}
if (Module.print) {
  print = Module.print;
}

  
// Warning: .ll contains i64 or double values. These 64-bit values are dangerous in USE_TYPED_ARRAYS == 2. We store i64 as i32, and double as float. This can cause serious problems!
// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      var logg = log2(quantum);
      return '((((' +target + ')+' + (quantum-1) + ')>>' + logg + ')<<' + logg + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (/^\[\d+\ x\ (.*)\]/.test(type)) return true; // [15 x ?] blocks. Like structs
  if (/<?{ [^}]* }>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  bitshift64: function (low, high, op, bits) {
    var ander = Math.pow(2, bits)-1;
    if (bits < 32) {
      switch (op) {
        case 'shl':
          return [low << bits, (high << bits) | ((low&(ander << (32 - bits))) >>> (32 - bits))];
        case 'ashr':
          return [(((low >>> bits ) | ((high&ander) << (32 - bits))) >> 0) >>> 0, (high >> bits) >>> 0];
        case 'lshr':
          return [((low >>> bits) | ((high&ander) << (32 - bits))) >>> 0, high >>> bits];
      }
    } else if (bits == 32) {
      switch (op) {
        case 'shl':
          return [0, low];
        case 'ashr':
          return [high, (high|0) < 0 ? ander : 0];
        case 'lshr':
          return [high, 0];
      }
    } else { // bits > 32
      switch (op) {
        case 'shl':
          return [0, low << (bits - 32)];
        case 'ashr':
          return [(high >> (bits - 32)) >>> 0, (high|0) < 0 ? ander : 0];
        case 'lshr':
          return [high >>>  (bits - 32) , 0];
      }
    }
    abort('unknown bitshift64 op: ' + [value, op, bits]);
  },
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type, quantumSize) {
    if (Runtime.QUANTUM_SIZE == 1) return 1;
    var size = {
      '%i1': 1,
      '%i8': 1,
      '%i16': 2,
      '%i32': 4,
      '%i64': 8,
      "%float": 4,
      "%double": 8
    }['%'+type]; // add '%' since float and double confuse Closure compiler as keys, and also spidermonkey as a compiler will remove 's from '_i8' etc
    if (!size) {
      if (type[type.length-1] == '*') {
        size = Runtime.QUANTUM_SIZE; // A pointer
      } else if (type[0] == 'i') {
        var bits = parseInt(type.substr(1));
        assert(bits % 8 == 0);
        size = bits/8;
      }
    }
    return size;
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    type.flatIndexes = type.fields.map(function(field) {
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = size;
      } else if (Runtime.isStructType(field)) {
        size = Types.types[field].flatSize;
        alignSize = Types.types[field].alignSize;
      } else {
        throw 'Unclear type in struct: ' + field + ', in ' + type.name_ + ' :: ' + dump(Types.types[type.name_]);
      }
      alignSize = type.packed ? 1 : Math.min(alignSize, Runtime.QUANTUM_SIZE);
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      assert(type.fields.length === struct.length, 'Number of named fields must match the type for ' + typeName);
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  stackAlloc: function stackAlloc(size) { var ret = STACKTOP;STACKTOP += size;STACKTOP = ((((STACKTOP)+3)>>2)<<2);assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"); return ret; },
  staticAlloc: function staticAlloc(size) { var ret = STATICTOP;STATICTOP += size;STATICTOP = ((((STATICTOP)+3)>>2)<<2); if (STATICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function alignMemory(size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 4))*(quantum ? quantum : 4); return ret; },
  makeBigInt: function makeBigInt(low,high,unsigned) { var ret = (unsigned ? (((low)>>>0)+(((high)>>>0)*4294967296)) : (((low)>>>0)+(((high)|0)*4294967296))); return ret; },
  QUANTUM_SIZE: 4,
  __dummy__: 0
}



var CorrectionsMonitor = {
  MAX_ALLOWED: 0, // XXX
  corrections: 0,
  sigs: {},

  note: function(type, succeed, sig) {
    if (!succeed) {
      this.corrections++;
      if (this.corrections >= this.MAX_ALLOWED) abort('\n\nToo many corrections!');
    }
  },

  print: function() {
  }
};





//========================================
// Runtime essentials
//========================================

var __THREW__ = false; // Used in checking for thrown exceptions.

var ABORT = false;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD;
var tempI64, tempI64b;

function abort(text) {
  print(text + ':\n' + (new Error).stack);
  ABORT = true;
  throw "Assertion: " + text;
}

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Adding
//
//         __attribute__((used))
//
//       to the function definition will prevent that.
//
// Note: Closure optimizations will minify function names, making
//       functions no longer callable. If you run closure (on by default
//       in -O2 and above), you should export the functions you will call
//       by calling emcc with something like
//
//         -s EXPORTED_FUNCTIONS='["_func1","_func2"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number' or 'string' (use 'number' for any C pointer).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType.
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  function toC(value, type) {
    if (type == 'string') {
      var ret = STACKTOP;
      Runtime.stackAlloc(value.length+1);
      writeStringToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    return value;
  }
  try {
    var func = eval('_' + ident);
  } catch(e) {
    try {
      func = globalScope['Module']['_' + ident]; // closure exported function
    } catch(e) {}
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  return fromC(func.apply(null, cArgs), returnType);
}
Module["ccall"] = ccall;

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  // TODO: optimize this, eval the whole function once instead of going through ccall each time
  return function() {
    return ccall(ident, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type[type.length-1] === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': HEAP32[((ptr)>>2)]=value; break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': (tempDoubleF64[0]=value,HEAP32[((ptr)>>2)]=tempDoubleI32[0],HEAP32[((ptr+4)>>2)]=tempDoubleI32[1]); break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type[type.length-1] === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return (tempDoubleI32[0]=HEAP32[((ptr)>>2)],tempDoubleI32[1]=HEAP32[((ptr+4)>>2)],tempDoubleF64[0]);
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

// Allocates memory for some data and initializes it properly.

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;

function allocate(slab, types, allocator) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));

  if (zeroinit) {
      _memset(ret, 0, size);
      return ret;
  }
  
  var i = 0, type;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    assert(type, 'Must know what type to store in allocate!');

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);
    i += Runtime.getNativeTypeSize(type);
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  var nullTerminated = typeof(length) == "undefined";
  var ret = "";
  var i = 0;
  var t;
  var nullByte = String.fromCharCode(0);
  while (1) {
    t = String.fromCharCode(HEAPU8[(ptr+i)]);
    if (nullTerminated && t == nullByte) { break; } else {}
    ret += t;
    i += 1;
    if (!nullTerminated && i == length) { break; }
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

function Array_stringify(array) {
  var ret = "";
  for (var i = 0; i < array.length; i++) {
    ret += String.fromCharCode(array[i]);
  }
  return ret;
}
Module['Array_stringify'] = Array_stringify;

// Memory management

var FUNCTION_TABLE; // XXX: In theory the indexes here can be equal to pointers to stacked or malloced memory. Such comparisons should
                    //      be false, but can turn out true. We should probably set the top bit to prevent such issues.

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return Math.ceil(x/PAGE_SIZE)*PAGE_SIZE;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32;

var STACK_ROOT, STACKTOP, STACK_MAX;
var STATICTOP;
function enlargeMemory() {
  // TOTAL_MEMORY is the current size of the actual array, and STATICTOP is the new top.
  printErr('Warning: Enlarging memory arrays, this is not fast! ' + [STATICTOP, TOTAL_MEMORY]);
  assert(STATICTOP >= TOTAL_MEMORY);
  assert(TOTAL_MEMORY > 4); // So the loop below will not be infinite
  while (TOTAL_MEMORY <= STATICTOP) { // Simple heuristic. Override enlargeMemory() if your program has something more optimal for it
    TOTAL_MEMORY = alignMemoryPage(2*TOTAL_MEMORY);
  }
  var oldHEAP8 = HEAP8;
  var buffer = new ArrayBuffer(TOTAL_MEMORY);
  HEAP8 = new Int8Array(buffer);
  HEAP16 = new Int16Array(buffer);
  HEAP32 = new Int32Array(buffer);
  HEAPU8 = new Uint8Array(buffer);
  HEAPU16 = new Uint16Array(buffer);
  HEAPU32 = new Uint32Array(buffer);
  HEAPF32 = new Float32Array(buffer);
  HEAP8.set(oldHEAP8);
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 10485760;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
  assert(!!Int32Array && !!Float64Array && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
         'Cannot fallback to non-typed array case: Code is too specialized');

  var buffer = new ArrayBuffer(TOTAL_MEMORY);
  HEAP8 = new Int8Array(buffer);
  HEAP16 = new Int16Array(buffer);
  HEAP32 = new Int32Array(buffer);
  HEAPU8 = new Uint8Array(buffer);
  HEAPU16 = new Uint16Array(buffer);
  HEAPU32 = new Uint32Array(buffer);
  HEAPF32 = new Float32Array(buffer);

  // Endianness check (note: assumes compiler arch was little-endian)
  HEAP32[0] = 255;
  assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

var base = intArrayFromString('(null)'); // So printing %s of NULL gives '(null)'
                                         // Also this ensures we leave 0 as an invalid address, 'NULL'
STATICTOP = base.length;
for (var i = 0; i < base.length; i++) {
  HEAP8[(i)]=base[i]
}

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;

STACK_ROOT = STACKTOP = Runtime.alignMemory(STATICTOP);
STACK_MAX = STACK_ROOT + TOTAL_STACK;

var tempDoublePtr = Runtime.alignMemory(STACK_MAX, 8);
var tempDoubleI8  = HEAP8.subarray(tempDoublePtr);
var tempDoubleI32 = HEAP32.subarray(tempDoublePtr >> 2);
var tempDoubleF32 = HEAPF32.subarray(tempDoublePtr >> 2);
var tempDoubleF64 = new Float64Array(HEAP8.buffer).subarray(tempDoublePtr >> 3);
function copyTempFloat(ptr) { // functions, because inlining this code is increases code size too much
  tempDoubleI8[0] = HEAP8[ptr];
  tempDoubleI8[1] = HEAP8[ptr+1];
  tempDoubleI8[2] = HEAP8[ptr+2];
  tempDoubleI8[3] = HEAP8[ptr+3];
}
function copyTempDouble(ptr) {
  tempDoubleI8[0] = HEAP8[ptr];
  tempDoubleI8[1] = HEAP8[ptr+1];
  tempDoubleI8[2] = HEAP8[ptr+2];
  tempDoubleI8[3] = HEAP8[ptr+3];
  tempDoubleI8[4] = HEAP8[ptr+4];
  tempDoubleI8[5] = HEAP8[ptr+5];
  tempDoubleI8[6] = HEAP8[ptr+6];
  tempDoubleI8[7] = HEAP8[ptr+7];
}
STACK_MAX = tempDoublePtr + 8;

STATICTOP = alignMemoryPage(STACK_MAX);

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    var func = callback.func;
    if (typeof func === 'number') {
      func = FUNCTION_TABLE[func];
    }
    func(callback.arg === undefined ? null : callback.arg);
  }
}

var __ATINIT__ = []; // functions called during startup
var __ATEXIT__ = []; // functions called during shutdown

function initRuntime() {
  callRuntimeCallbacks(__ATINIT__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);

  // Print summary of correction activity
  CorrectionsMonitor.print();
}


// Copies a list of num items on the HEAP into a
// a normal JavaScript array of numbers
function Array_copy(ptr, num) {
  return Array.prototype.slice.call(HEAP8.subarray(ptr, ptr+num)); // Make a normal array out of the typed 'view'
                                                                   // Consider making a typed array here, for speed?
  return HEAP.slice(ptr, ptr+num);
}
Module['Array_copy'] = Array_copy;

// Copies a list of num items on the HEAP into a
// JavaScript typed array.
function TypedArray_copy(ptr, num) {
  // TODO: optimize this!
  var arr = new Uint8Array(num);
  for (var i = 0; i < num; ++i) {
    arr[i] = HEAP8[(ptr+i)];
  }
  return arr.buffer;
}
Module['TypedArray_copy'] = TypedArray_copy;

function String_len(ptr) {
  var i = 0;
  while (HEAP8[(ptr+i)]) i++; // Note: should be |!= 0|, technically. But this helps catch bugs with undefineds
  return i;
}
Module['String_len'] = String_len;

// Copies a C-style string, terminated by a zero, from the HEAP into
// a normal JavaScript array of numbers
function String_copy(ptr, addZero) {
  var len = String_len(ptr);
  if (addZero) len++;
  var ret = Array_copy(ptr, len);
  if (addZero) ret[len-1] = 0;
  return ret;
}
Module['String_copy'] = String_copy;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull) {
  var ret = [];
  var t;
  var i = 0;
  while (i < stringy.length) {
    var chr = stringy.charCodeAt(i);
    if (chr > 0xFF) {
        assert(false, 'Character code ' + chr + ' (' + stringy[i] + ')  at offset ' + i + ' not in 0x00-0xFF.');
      chr &= 0xFF;
    }
    ret.push(chr);
    i = i + 1;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
        assert(false, 'Character code ' + chr + ' (' + String.fromCharCode(chr) + ')  at offset ' + i + ' not in 0x00-0xFF.');
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var i = 0;
  while (i < string.length) {
    var chr = string.charCodeAt(i);
    if (chr > 0xFF) {
        assert(false, 'Character code ' + chr + ' (' + string[i] + ')  at offset ' + i + ' not in 0x00-0xFF.');
      chr &= 0xFF;
    }
    HEAP8[(buffer+i)]=chr
    i = i + 1;
  }
  if (!dontAddNull) {
    HEAP8[(buffer+i)]=0
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

var STRING_TABLE = [];

function unSign(value, bits, ignore, sig) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
  // TODO: clean up previous line
}
function reSign(value, bits, ignore, sig) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// === Body ===




function __ZN18resource_pool_itemD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN18resource_pool_itemC2EPvj($this, $ptr, $size) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$ptr;
  $3=$size;
  var $4=$1;
  var $5=$4;
  HEAP32[(($5)>>2)]=((__ZTV18resource_pool_item+8)|0);
  var $6=(($4+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($4+8)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($4+12)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($4+16)|0);
  var $10=$2;
  HEAP32[(($9)>>2)]=$10;
  var $11=(($4+20)|0);
  var $12=$3;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+24)|0);
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $st$24$0=(($13)|0);
  HEAP32[(($st$24$0)>>2)]=$$emscripten$temp$0$0;
  var $st$24$1=(($13+4)|0);
  HEAP32[(($st$24$1)>>2)]=$$emscripten$temp$0$1;
  ;
  return;
}


function __ZNK8device_t7machineEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+280)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12coleco_state12paddle_off_wER13address_spacejhh($this, $space, $offset, $data, $mem_mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mem_mask;
  var $6=$1;
  var $7=(($6+404)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN12coleco_state11paddle_on_wER13address_spacejhh($this, $space, $offset, $data, $mem_mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mem_mask;
  var $6=$1;
  var $7=(($6+404)|0);
  HEAP32[(($7)>>2)]=1;
  ;
  return;
}


function __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEptEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13memory_region4baseEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+72)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astringC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN7astringC2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13driver_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13driver_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13driver_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 388);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13driver_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13driver_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13driver_deviceED2Ev($2);
  ;
  return;
}


function __ZN18resource_pool_itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18resource_pool_itemD2Ev($2);
  ;
  return;
}


function __ZN7astringC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZN7astring4initEv($2);
  ;
  return;
}


function __ZN12coleco_state10paddle_1_rER13address_spacejh($this, $space, $offset, $mem_mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mem_mask;
  var $5=$1;
  var $6=$5;
  var $7=__ZNK8device_t7machineEv($6);
  var $8=(($5+404)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($5+408)|0);
  var $11=(($10)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=__Z19coleco_paddle1_readR15running_machineii($7, $9, $12);
  ;
  return $13;
}


function __ZN12coleco_state10paddle_2_rER13address_spacejh($this, $space, $offset, $mem_mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mem_mask;
  var $5=$1;
  var $6=$5;
  var $7=__ZNK8device_t7machineEv($6);
  var $8=(($5+404)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($5+408)|0);
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=__Z19coleco_paddle2_readR15running_machineii($7, $9, $12);
  ;
  return $13;
}


function __ZN12coleco_state13machine_startEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __Z18TMS9928A_configurePK18TMS9928a_interface(__ZL18tms9928a_interface);
  ;
  return;
}


function __ZN12coleco_state13machine_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+416)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+388)|0);
  var $5=$4;
  var $6=__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEptEv($5);
  var $7=$6;
  var $8=(($7+356)|0);
  var $9=$8;
  __ZN24device_execute_interface21set_input_line_vectorEii($9, 0, 255);
  var $10=$2;
  var $11=__ZNK8device_t7machineEv($10);
  var $12=__ZN15running_machine6regionEPKc($11, ((STRING_TABLE.__str11)|0));
  var $13=__ZNK13memory_region4baseEv($12);
  var $14=(($13+24576)|0);
  _memset($14, -1, 1024, 1);
  ;
  return;
}


function __ZN24device_execute_interface21set_input_line_vectorEii($this, $linenum, $vector) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$linenum;
  $3=$vector;
  var $4=$1;
  var $5=$2;
  var $6=(($4+52)|0);
  var $7=(($6+$5*156)|0);
  var $8=$3;
  __ZN24device_execute_interface12device_input10set_vectorEi($7, $8);
  ;
  return;
}


function __ZN15running_machine6regionEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($3+680)|0);
  var $5=$2;
  var $6=__ZNK11tagged_listI13memory_regionE4findEPKc($4, $5);
  ;
  return $6;
}


function __Z21driver_device_creatorI13driver_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      $11=$mconfig;
      $12=$tag;
      $13=$owner;
      $14=$clock;
      __label__ = 1; break;
    case 1: // $17
      __label__ = 2; break;
    case 2: // $18
      __label__ = 3; break;
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$5;
      var $22=$6;
      var $23=$7;
      var $24=$8;
      var $25=$result_i;
      var $26=$9;
      var $27=$10;
      HEAP32[(($5)>>2)]=388;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str10)|0);
      HEAP32[(($7)>>2)]=599;
      HEAP32[(($8)>>2)]=_zeromem;
      var $28=HEAP32[(($5)>>2)];
      var $29=HEAP32[(($6)>>2)];
      var $30=HEAP32[(($7)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($9)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($10)>>2)]=$41;
      var $42=HEAP32[(($10)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $44
      var $45=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 9: // $46
      var $47=HEAP32[(($9)>>2)];
      var $48=HEAP32[(($9)>>2)];
      var $49=HEAP32[(($10)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $52
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKciRK9zeromem_t_exit
      var $53=HEAP32[(($result_i)>>2)];
      var $54=HEAP32[(($5)>>2)];
      _memset($53, 0, $54, 1);
      var $55=HEAP32[(($result_i)>>2)];
      var $56=$5;
      var $57=$6;
      var $58=$7;
      var $59=$8;
      var $60=$result_i;
      var $61=$9;
      var $62=$10;
      var $63=$55;
      var $64=$11;
      var $65=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13driver_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_]($63, $64, 4, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $66
      var $67=__ZN13resource_pool10add_objectI13driver_deviceEEPT_S3_(_global_resource_pool, $63);
      var $68=$67;
      STACKTOP = __stackBase__;
      return $68;
    case 13: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $71=$70.f0;
      $15=$71;
      var $72=$70.f1;
      $16=$72;
      var $73=$1;
      var $74=$2;
      var $75=$3;
      var $76=$4;
      HEAP32[(($1)>>2)]=$55;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str10)|0);
      HEAP32[(($3)>>2)]=599;
      HEAP32[(($4)>>2)]=_zeromem;
      var $77=HEAP32[(($1)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $79
      var $80=HEAP32[(($1)>>2)];
      var $81=HEAP32[(($2)>>2)];
      var $82=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($80, $81, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $_noexc
      __label__ = 16; break;
    case 16: // $_ZdlPvPKciRK9zeromem_t_exit
      var $83=$1;
      var $84=$2;
      var $85=$3;
      var $86=$4;
      __label__ = 17; break;
    case 17: // $87
      __label__ = 18; break;
    case 18: // $88
      var $89=$15;
      var $90=$15;
      var $91=$16;
      var $92=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $90, tempValue);
      var $93=($92.f1 = $91, $92);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21driver_device_creatorI13driver_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN13resource_pool10add_objectI13driver_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13driver_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13driver_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI13driver_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13driver_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13driver_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI13driver_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI13driver_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18resource_pool_itemD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18resource_pool_itemD0Ev["X"]=1;
// Warning: Arithmetic on 64-bit integers in mode 1 is rounded and flaky, like mode 0!

function __Z8downcastIP12coleco_state13driver_deviceET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13emu_exceptionC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$3;
  var $5=$1;
  HEAP32[(($1)>>2)]=$4;
  var $6=HEAP32[(($1)>>2)];
  var $7=$6;
  HEAP32[(($7)>>2)]=((__ZTVSt9exception+8)|0);
  var $8=$1;
  var $9=$3;
  HEAP32[(($9)>>2)]=((__ZTV13emu_exception+8)|0);
  STACKTOP = __stackBase__;
  return;
}


function __ZN10input_codeC2E18input_device_classi16input_item_class19input_item_modifier13input_item_id($this, $devclass, $devindex, $itemclass, $modifier, $itemid) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$devclass;
      $3=$devindex;
      $4=$itemclass;
      $5=$modifier;
      $6=$itemid;
      var $7=$1;
      var $8=(($7)|0);
      var $9=$2;
      var $10=$9 & 15;
      var $11=$10 << 28;
      var $12=$3;
      var $13=$12 & 255;
      var $14=$13 << 20;
      var $15=$11 | $14;
      var $16=$4;
      var $17=$16 & 15;
      var $18=$17 << 16;
      var $19=$15 | $18;
      var $20=$5;
      var $21=$20 & 15;
      var $22=$21 << 12;
      var $23=$19 | $22;
      var $24=$6;
      var $25=$24 & 4095;
      var $26=$23 | $25;
      HEAP32[(($8)>>2)]=$26;
      __label__ = 1; break;
    case 1: // $27
      __label__ = 2; break;
    case 2: // $28
      __label__ = 3; break;
    case 3: // $29
      __label__ = 4; break;
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      __label__ = 6; break;
    case 6: // $32
      __label__ = 7; break;
    case 7: // $33
      __label__ = 8; break;
    case 8: // $34
      __label__ = 9; break;
    case 9: // $35
      __label__ = 10; break;
    case 10: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8attotimeC2Eix($this, $secs, $attos$0, $attos$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$secs;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$attos$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$attos$1;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $st$14$0=(($3)|0);
  var $8$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$14$1)>>2)];
  var $st$18$0=(($7)|0);
  HEAP32[(($st$18$0)>>2)]=$8$0;
  var $st$18$1=(($7+4)|0);
  HEAP32[(($st$18$1)>>2)]=$8$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZN16device_interface6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN22device_image_interface14software_entryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+412)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12coleco_stateD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12coleco_stateD2Ev($2);
  ;
  return;
}


function __ZN8device_t15required_deviceI10cpu_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8device_t15required_deviceI10cpu_deviceED2Ev($2);
  ;
  return;
}


function __ZN8device_t15required_deviceI10cpu_deviceED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED2Ev($3);
  ;
  return;
}


function __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8device_t16auto_finder_baseD2Ev($3);
  ;
  return;
}


function __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($this, $devclass, $devindex, $itemclass, $modifier, $itemid) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$devclass;
  $3=$devindex;
  $4=$itemclass;
  $5=$modifier;
  $6=$itemid;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$5;
  var $12=$6;
  __ZN10input_codeC2E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, $8, $9, $10, $11, $12);
  ;
  return;
}


function __ZL16coleco_interruptP8device_t($device) {
  ;
  var __label__;

  var $1;
  $1=$device;
  var $2=$1;
  var $3=__ZNK8device_t7machineEv($2);
  var $4=__Z18TMS9928A_interruptR15running_machine($3);
  ;
  return;
}


function __ZL15paddle_callbackR12timer_devicePvi($timer, $ptr, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      $1=$timer;
      $2=$ptr;
      $3=$param;
      var $4=$1;
      var $5=$4;
      var $6=__ZNK8device_t7machineEv($5);
      var $7=__ZNK15running_machine11driver_dataI12coleco_stateEEPT_v($6);
      $state=$7;
      var $8=$1;
      var $9=$8;
      var $10=__ZNK8device_t7machineEv($9);
      var $11=$state;
      var $12=(($11+408)|0);
      var $13=(($12)|0);
      var $14=$state;
      var $15=(($14+408)|0);
      var $16=(($15+4)|0);
      __Z19coleco_scan_paddlesR15running_machinePiS1_($10, $13, $16);
      var $17=$state;
      var $18=(($17+408)|0);
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $22
      var $23=$state;
      var $24=(($23+408)|0);
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $28
      var $29=$state;
      var $30=(($29+388)|0);
      var $31=$30;
      var $32=__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEptEv($31);
      var $33=$32;
      var $34=(($33+356)|0);
      var $35=$34;
      __ZN24device_execute_interface14set_input_lineEii($35, 0, 2);
      __label__ = 3; break;
    case 3: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8attotime9from_msecEx($agg_result, $msec$0, $msec$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $st$1$0=(($1)|0);
  HEAP32[(($st$1$0)>>2)]=$msec$0;
  var $st$1$1=(($1+4)|0);
  HEAP32[(($st$1$1)>>2)]=$msec$1;
  var $st$5$0=(($1)|0);
  var $2$0=HEAP32[(($st$5$0)>>2)];
  var $st$5$1=(($1+4)|0);
  var $2$1=HEAP32[(($st$5$1)>>2)];
  var $$emscripten$temp$0$0=1000;
  var $$emscripten$temp$0$1=0;
  var $3$0 = (tempBigIntR=((($2$0)>>>0)+((($2$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $3$1 = Math.min(Math.floor(((tempBigIntR=((($2$0)>>>0)+((($2$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $4$0=$3$0;
  var $4=$4$0;
  var $st$14$0=(($1)|0);
  var $5$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($1+4)|0);
  var $5$1=HEAP32[(($st$14$1)>>2)];
  var $$emscripten$temp$1$0=1000;
  var $$emscripten$temp$1$1=0;
  var $6$0 = ((($5$0)>>>0)+((($5$1)|0)*4294967296))%((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $6$1 = Math.min(Math.floor((((($5$0)>>>0)+((($5$1)|0)*4294967296))%((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
  var $$emscripten$temp$2$0=-1530494976;
  var $$emscripten$temp$2$1=232830;
  var $7$0 = ((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
  __ZN8attotimeC1Eix($agg_result, $4, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8attotimeC1Eix($this, $secs, $attos$0, $attos$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$secs;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$attos$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$attos$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  __ZN8attotimeC2Eix($4, $5, $6$0, $6$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK15running_machine11driver_dataI12coleco_stateEEPT_v($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1300)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__Z8downcastIP12coleco_state13driver_deviceET_PT0_($4);
  ;
  return $5;
}


function __ZN24device_execute_interface14set_input_lineEii($this, $linenum, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$linenum;
  $3=$state;
  var $4=$1;
  var $5=$2;
  var $6=(($4+52)|0);
  var $7=(($6+$5*156)|0);
  var $8=$3;
  __ZN24device_execute_interface12device_input16set_state_syncedEii($7, $8, -16777216);
  ;
  return;
}


function __ZN22device_image_interface6lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22device_image_interface14check_for_fileEv($2);
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__Z10core_fsizeP10_core_file($4);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22device_image_interface5freadEPvj($this, $buffer, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$buffer;
  $3=$length;
  var $4=$1;
  __ZN22device_image_interface14check_for_fileEv($4);
  var $5=(($4+80)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  var $8=$3;
  var $9=__Z10core_freadP10_core_filePvj($6, $7, $8);
  ;
  return $9;
}


function __ZN14emu_fatalerrorC1EPKcz($this, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ap=__stackBase__;
      var $3;
      var $4;
      $1=$this;
      $2=$format;
      var $5=$1;
      var $6=$5;
      __ZN13emu_exceptionC2Ev($6);
      var $7=$5;
      HEAP32[(($7)>>2)]=((__ZTV14emu_fatalerror+8)|0);
      var $8=(($5+1028)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=$ap;
      HEAP32[(($9)>>2)]=arguments[__ZN14emu_fatalerrorC1EPKcz.length];
      var $10=(($5+4)|0);
      var $11=(($10)|0);
      var $12=$2;
      var $13=HEAP32[(($ap)>>2)];
      var $14=(function() { try { __THREW__ = false; return _vsprintf($11, $12, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $15
      var $16=$ap;
      ;
      var $17=(($5+4)|0);
      var $18=(($17)|0);
      (function() { try { __THREW__ = false; return _osd_break_into_debugger($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      STACKTOP = __stackBase__;
      return;
    case 3: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $3=$22;
      var $23=$21.f1;
      $4=$23;
      var $24=$5;
      __ZN13emu_exceptionD2Ev($24);
      __label__ = 4; break;
    case 4: // $25
      var $26=$3;
      var $27=$3;
      var $28=$4;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14emu_fatalerrorD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN14emu_fatalerrorD2Ev($2);
  ;
  return;
}


function __ZN14emu_fatalerrorD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13emu_exceptionD2Ev($3);
  ;
  return;
}


function __ZN13emu_exceptionD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt9exceptionD2Ev($3);
  ;
  return;
}


function __ZL31construct_machine_config_colecoR14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6=__stackBase__+64;
      var $7;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=$2;
      var $12=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($11, 0, ((STRING_TABLE.__str48)|0), 6, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $13
      $3=$12;
      __label__ = 4; break;
    case 3: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $4=$16;
      var $17=$15.f1;
      $5=$17;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 4: // $18
      var $19=$2;
      var $20=$3;
      var $21=HEAP32[((_Z80)>>2)];
      var $22=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($19, $20, ((STRING_TABLE.__str11)|0), $21, 3579545) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 3; break; };
    case 5: // $23
      $device=$22;
      var $24=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($24, 0, 8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 6: // $25
      var $26=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($26, 2, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 3; break; }
    case 7: // $27
      var $28=$device;
      (function() { try { __THREW__ = false; return __ZN24device_execute_interface21static_set_vblank_intER8device_tPFvPS0_EPKci($28, 12, ((STRING_TABLE.__str32)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 3; break; }
    case 8: // $29
      var $30=$2;
      var $31=$3;
      var $32=(function() { try { __THREW__ = false; return __Z33construct_machine_config_tms9928aR14machine_configP8device_t($30, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 3; break; };
    case 9: // $33
      var $34=$2;
      var $35=$3;
      var $36=(function() { try { __THREW__ = false; return __ZN14machine_config11device_findEP8device_tPKc($34, $35, ((STRING_TABLE.__str32)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 3; break; };
    case 10: // $37
      $device=$36;
      var $38=$device;
      var $$emscripten$temp$0$0=-2147483648;
      var $$emscripten$temp$0$1=3885513;
      (function() { try { __THREW__ = false; return __ZN13screen_device18static_set_refreshER8device_tx($38, $$emscripten$temp$0$0, $$emscripten$temp$0$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 3; break; }
    case 11: // $39
      var $40=$device;
      var $$emscripten$temp$1$0=-1678753792;
      var $$emscripten$temp$1$1=582076;
      (function() { try { __THREW__ = false; return __ZN13screen_device22static_set_vblank_timeER8device_tx($40, $$emscripten$temp$1$0, $$emscripten$temp$1$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 3; break; }
    case 12: // $41
      var $42=$2;
      var $43=$3;
      var $44=HEAP32[((_CARTSLOT)>>2)];
      var $45=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($42, $43, ((STRING_TABLE.__str314)|0), $44, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 3; break; };
    case 13: // $46
      $device=$45;
      var $47=$device;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_base19static_set_inline32ER8device_tjjj($47, 0, 4, (STRING_TABLE.__str49)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 3; break; }
    case 14: // $48
      var $49=$device;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_base19static_set_inline32ER8device_tjjj($49, 8, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 3; break; }
    case 15: // $50
      var $51=$device;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_base19static_set_inline32ER8device_tjjj($51, 4, 4, (STRING_TABLE.__str50)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 3; break; }
    case 16: // $52
      var $53=$2;
      var $54=$3;
      var $55=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $56=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($53, $54, ((STRING_TABLE.__str51)|0), $55, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 3; break; };
    case 17: // $57
      $device=$56;
      var $58=$device;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_base19static_set_inline32ER8device_tjjj($58, 0, 4, (STRING_TABLE.__str12)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 3; break; }
    case 18: // $59
      var $60=$device;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_base19static_set_inline32ER8device_tjjj($60, 40, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 3; break; }
    case 19: // $61
      var $62=$2;
      var $63=$3;
      var $64=HEAP32[((_TIMER)>>2)];
      var $65=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($62, $63, ((STRING_TABLE.__str52)|0), $64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 3; break; };
    case 20: // $66
      $device=$65;
      var $67=$device;
      var $$emscripten$temp$2$0=20;
      var $$emscripten$temp$2$1=0;
      (function() { try { __THREW__ = false; return __ZN8attotime9from_msecEx($6, $$emscripten$temp$2$0, $$emscripten$temp$2$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 3; break; }
    case 21: // $68
      (function() { try { __THREW__ = false; return __ZN12timer_device25static_configure_periodicER8device_tPFvRS_PviE8attotime($67, 14, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 3; break; }
    case 22: // $69
      var $70=$3;
      $1=$70;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $71=$1;
      STACKTOP = __stackBase__;
      return $71;
    case 23: // $72
      __label__ = 24; break;
    case 24: // $73
      var $74=$4;
      var $75=$4;
      var $76=$5;
      var $77=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $75, tempValue);
      var $78=($77.f1 = $76, $77);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL31construct_machine_config_colecoR14machine_configP8device_t["X"]=1;

function __ZN12coleco_stateD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN12coleco_stateD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12coleco_stateD0Ev["X"]=1;

function __ZN12coleco_stateD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV12coleco_state+8)|0);
      var $6=(($4+388)|0);
      (function() { try { __THREW__ = false; return __ZN8device_t15required_deviceI10cpu_deviceED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      __ZN13driver_deviceD2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN13driver_deviceD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21driver_device_creatorI12coleco_stateEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      $11=$mconfig;
      $12=$tag;
      $13=$owner;
      $14=$clock;
      __label__ = 1; break;
    case 1: // $17
      __label__ = 2; break;
    case 2: // $18
      __label__ = 3; break;
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$5;
      var $22=$6;
      var $23=$7;
      var $24=$8;
      var $25=$result_i;
      var $26=$9;
      var $27=$10;
      HEAP32[(($5)>>2)]=420;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str67)|0);
      HEAP32[(($7)>>2)]=599;
      HEAP32[(($8)>>2)]=_zeromem;
      var $28=HEAP32[(($5)>>2)];
      var $29=HEAP32[(($6)>>2)];
      var $30=HEAP32[(($7)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($9)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($10)>>2)]=$41;
      var $42=HEAP32[(($10)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $44
      var $45=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 9: // $46
      var $47=HEAP32[(($9)>>2)];
      var $48=HEAP32[(($9)>>2)];
      var $49=HEAP32[(($10)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $52
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKciRK9zeromem_t_exit
      var $53=HEAP32[(($result_i)>>2)];
      var $54=HEAP32[(($5)>>2)];
      _memset($53, 0, $54, 1);
      var $55=HEAP32[(($result_i)>>2)];
      var $56=$5;
      var $57=$6;
      var $58=$7;
      var $59=$8;
      var $60=$result_i;
      var $61=$9;
      var $62=$10;
      var $63=$55;
      var $64=$11;
      var $65=$12;
      (function() { try { __THREW__ = false; return __ZN12coleco_stateC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_($63, $64, 6, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $66
      var $67=__ZN13resource_pool10add_objectI12coleco_stateEEPT_S3_(_global_resource_pool, $63);
      var $68=$67;
      STACKTOP = __stackBase__;
      return $68;
    case 13: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $71=$70.f0;
      $15=$71;
      var $72=$70.f1;
      $16=$72;
      var $73=$1;
      var $74=$2;
      var $75=$3;
      var $76=$4;
      HEAP32[(($1)>>2)]=$55;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str67)|0);
      HEAP32[(($3)>>2)]=599;
      HEAP32[(($4)>>2)]=_zeromem;
      var $77=HEAP32[(($1)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $79
      var $80=HEAP32[(($1)>>2)];
      var $81=HEAP32[(($2)>>2)];
      var $82=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($80, $81, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $_noexc
      __label__ = 16; break;
    case 16: // $_ZdlPvPKciRK9zeromem_t_exit
      var $83=$1;
      var $84=$2;
      var $85=$3;
      var $86=$4;
      __label__ = 17; break;
    case 17: // $87
      __label__ = 18; break;
    case 18: // $88
      var $89=$15;
      var $90=$15;
      var $91=$16;
      var $92=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $90, tempValue);
      var $93=($92.f1 = $91, $92);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21driver_device_creatorI12coleco_stateEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN22device_image_interface14check_for_fileEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=(($4+80)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=___cxa_allocate_exception(1032);
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($11, ((STRING_TABLE.__str54)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str55)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str56)|0),HEAP32[((tempInt+8)>>2)]=262,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      ___cxa_throw($10, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      ___cxa_free_exception($10);
      __label__ = 7; break;
    case 5: // $17
      __label__ = 6; break;
    case 6: // $18
      ;
      return;
    case 7: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM12coleco_stateFhR13address_spacejhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM12coleco_stateFvR13address_spacejhhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17address_map_entry10set_mirrorEj($this, $_mirror) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$_mirror;
  var $3=$1;
  var $4=$2;
  var $5=(($3+80)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN21delegate_internal_mfpC2ERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  ;
  return;
}


function __ZN17address_map_entry13set_read_typeE16map_handler_type($this, $_type) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$_type;
  var $3=$1;
  var $4=$2;
  var $5=(($3+88)|0);
  var $6=(($5)|0);
  HEAP32[(($6)>>2)]=$4;
  ;
  return;
}


function __ZN17address_map_entry14set_write_typeE16map_handler_type($this, $_type) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$_type;
  var $3=$1;
  var $4=$2;
  var $5=(($3+176)|0);
  var $6=(($5)|0);
  HEAP32[(($6)>>2)]=$4;
  ;
  return;
}


function __ZN13emu_exceptionD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13emu_exceptionD2Ev($2);
  ;
  return;
}


function __ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEE($this, $device, $tag, $func) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$device;
  $3=$tag;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  __ZN8delegateIFvR13address_spacejhhEEC1ERKS3_($4, $func);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN17address_map_entry20internal_set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEEy($6, $7, $8, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC1I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejhhEEC2I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($this, $rfunc, $rstring, $wfunc, $wstring) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$rfunc;
  $3=$rstring;
  $4=$wfunc;
  $5=$wstring;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$5;
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_y($7, $8, $9, $10, $11, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function __ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEE($this, $device, $tag, $func) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$device;
  $3=$tag;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  __ZN8delegateIFhR13address_spacejhEEC1ERKS3_($4, $func);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN17address_map_entry20internal_set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEEy($6, $7, $8, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC1I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFhR13address_spacejhEEC2I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC2I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIhR13address_spacejh8_noparamEC2I12coleco_stateEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamEC2I12coleco_stateEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM12coleco_stateFhR13address_spacejhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=18;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIhR13address_spacejh8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM12coleco_stateFhR13address_spacejhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM12coleco_stateFhR13address_spacejhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI12coleco_stateEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI12coleco_state, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhR13address_spacejhEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFhR13address_spacejhEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIhR13address_spacejh8_noparamEC2ERKS3_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamEC2ERKS3_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN21delegate_internal_mfpC1ERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  __ZN21delegate_internal_mfpC2ERKS_($3, $4);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC2I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejhhEC2I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhEC2I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM12coleco_stateFvR13address_spacejhhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=20;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejhhE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM12coleco_stateFvR13address_spacejhhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM12coleco_stateFvR13address_spacejhhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI12coleco_stateEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI12coleco_state, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvR13address_spacejhhE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejhhEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvR13address_spacejhhEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIvR13address_spacejhhEC2ERKS2_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhEC2ERKS2_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN12coleco_stateC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_($this, $mconfig, $type, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  var $5=$1;
  var $6=$3;
  var $7=$4;
  var $8=$2;
  __ZN12coleco_stateC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_($5, $8, $6, $7);
  ;
  return;
}


function __ZN8device_t15required_deviceI10cpu_deviceEC1ERS_PKc($this, $base, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$base;
  $3=$tag;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN8device_t15required_deviceI10cpu_deviceEC2ERS_PKc($4, $6, $5);
  ;
  return;
}


function __ZN8device_t15required_deviceI10cpu_deviceEC2ERS_PKc($this, $base, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$base;
  $3=$tag;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEC2ERS_PKc($5, $6, $7);
  var $8=$4;
  HEAP32[(($8)>>2)]=((__ZTVN8device_t15required_deviceI10cpu_deviceEE+8)|0);
  ;
  return;
}


function __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEC2ERS_PKc($this, $base, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$base;
  $3=$tag;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN8device_t16auto_finder_baseC2ERS_PKc($5, $6, $7);
  var $8=$4;
  HEAP32[(($8)>>2)]=((__ZTVN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE+8)|0);
  var $9=(($4+12)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN14emu_fatalerrorD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      __ZN14emu_fatalerrorD1Ev($5);
      var $6=$5;
      var $7=$1;
      var $8=$2;
      var $9=$3;
      HEAP32[(($1)>>2)]=$6;
      var $10=HEAP32[(($1)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($13, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      __label__ = 4; break;
    case 3: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      HEAP32[(($2)>>2)]=$17;
      var $18=$16.f1;
      HEAP32[(($3)>>2)]=$18;
      var $19=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($19);
      throw "Reached an unreachable!"
    case 4: // $_ZdlPv_exit
      var $20=$1;
      var $21=$2;
      var $22=$3;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13emu_exceptionD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      __ZN13emu_exceptionD1Ev($5);
      var $6=$5;
      var $7=$1;
      var $8=$2;
      var $9=$3;
      HEAP32[(($1)>>2)]=$6;
      var $10=HEAP32[(($1)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($13, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      __label__ = 4; break;
    case 3: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      HEAP32[(($2)>>2)]=$17;
      var $18=$16.f1;
      HEAP32[(($3)>>2)]=$18;
      var $19=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($19);
      throw "Reached an unreachable!"
    case 4: // $_ZdlPv_exit
      var $20=$1;
      var $21=$2;
      var $22=$3;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI12coleco_stateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12coleco_stateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12coleco_stateEEPT_S3_["X"]=1;

function __ZN12coleco_stateC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_($this, $mconfig, $type, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$mconfig;
      $3=$type;
      $4=$tag;
      var $7=$1;
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      __ZN13driver_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_($8, $9, $10, $11);
      var $12=$7;
      HEAP32[(($12)>>2)]=((__ZTV12coleco_state+8)|0);
      var $13=(($7+388)|0);
      var $14=$7;
      (function() { try { __THREW__ = false; return __ZN8device_t15required_deviceI10cpu_deviceEC1ERS_PKc($13, $14, ((STRING_TABLE.__str11)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      ;
      return;
    case 2: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $5=$18;
      var $19=$17.f1;
      $6=$19;
      var $20=$7;
      (function() { try { __THREW__ = false; return __ZN13driver_deviceD2Ev($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $21
      __label__ = 4; break;
    case 4: // $22
      var $23=$5;
      var $24=$5;
      var $25=$6;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIP10cpu_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11tagmap_hashPKc($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface12device_input10set_vectorEi($this, $vector) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$vector;
  var $3=$1;
  var $4=$2;
  var $5=(($3+12)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN8device_t15required_deviceI10cpu_deviceE6finditERS_($this, $base) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$base;
  var $3=$1;
  var $4=$3;
  var $5=$3;
  var $6=$2;
  var $7=$3;
  var $8=(($7+8)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZN8device_t16auto_finder_base11find_deviceERS_PKc($5, $6, $9);
  var $11=__Z8downcastIP10cpu_device8device_tET_PT0_($10);
  __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EE10set_targetES2_($4, $11);
  ;
  return;
}


function __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12coleco_stateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12coleco_stateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12coleco_stateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 420);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12coleco_stateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12coleco_stateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12coleco_stateED2Ev($2);
  ;
  return;
}


function __ZL32construct_address_map_coleco_mapR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 0, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 8191, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 2);
  var $9=$1;
  var $10=$curentry;
  var $11=__ZN11address_map3addEjjP18address_map_entry8($9, 24576, 25599, $10);
  $curentry=$11;
  var $12=$curentry;
  var $13=$12;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($13, 1);
  var $14=$curentry;
  var $15=$14;
  __ZN17address_map_entry14set_write_typeE16map_handler_type($15, 1);
  var $16=$curentry;
  var $17=$16;
  __ZN17address_map_entry10set_mirrorEj($17, 7168);
  var $18=$1;
  var $19=$curentry;
  var $20=__ZN11address_map3addEjjP18address_map_entry8($18, 32768, 65535, $19);
  $curentry=$20;
  var $21=$curentry;
  var $22=$21;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($22, 2);
  ;
  return;
}


function __ZL35construct_address_map_coleco_io_mapR11address_mapRK8device_t($map, $device) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $curentry;
  var $3=__stackBase__;
  var $4=__stackBase__+24;
  var $5=__stackBase__+32;
  var $6=__stackBase__+56;
  var $7=__stackBase__+64;
  var $8=__stackBase__+88;
  var $9=__stackBase__+96;
  var $10=__stackBase__+120;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $11=$1;
  __ZN11address_map9configureE16address_spacenumh($11, 2, 8);
  var $12=$1;
  __ZN11address_map15set_global_maskEj($12, 255);
  var $13=$1;
  var $14=$curentry;
  var $15=__ZN11address_map3addEjjP18address_map_entry8($13, 128, 128, $14);
  $curentry=$15;
  var $16=$curentry;
  var $17=$16;
  __ZN17address_map_entry10set_mirrorEj($17, 31);
  var $18=$curentry;
  var $19=$2;
  HEAP32[(($4)>>2)]={ f0: 22, f1: 0 }.f0; HEAP32[(($4+4)>>2)]={ f0: 22, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejhhEEC1I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($3, $4, ((STRING_TABLE.__str57)|0), 0);
  __ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEE($18, $19, ((__ZL11DEVICE_SELF)|0), $3);
  var $20=$1;
  var $21=$curentry;
  var $22=__ZN11address_map3addEjjP18address_map_entry8($20, 160, 160, $21);
  $curentry=$22;
  var $23=$curentry;
  var $24=$23;
  __ZN17address_map_entry10set_mirrorEj($24, 30);
  var $25=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($25, 30, ((STRING_TABLE.__str58)|0), 32, ((STRING_TABLE.__str59)|0));
  var $26=$1;
  var $27=$curentry;
  var $28=__ZN11address_map3addEjjP18address_map_entry8($26, 161, 161, $27);
  $curentry=$28;
  var $29=$curentry;
  var $30=$29;
  __ZN17address_map_entry10set_mirrorEj($30, 30);
  var $31=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($31, 34, ((STRING_TABLE.__str60)|0), 36, ((STRING_TABLE.__str61)|0));
  var $32=$1;
  var $33=$curentry;
  var $34=__ZN11address_map3addEjjP18address_map_entry8($32, 192, 192, $33);
  $curentry=$34;
  var $35=$curentry;
  var $36=$35;
  __ZN17address_map_entry10set_mirrorEj($36, 31);
  var $37=$curentry;
  var $38=$2;
  HEAP32[(($6)>>2)]={ f0: 24, f1: 0 }.f0; HEAP32[(($6+4)>>2)]={ f0: 24, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejhhEEC1I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($5, $6, ((STRING_TABLE.__str62)|0), 0);
  __ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEE($37, $38, ((__ZL11DEVICE_SELF)|0), $5);
  var $39=$1;
  var $40=$curentry;
  var $41=__ZN11address_map3addEjjP18address_map_entry8($39, 224, 224, $40);
  $curentry=$41;
  var $42=$curentry;
  var $43=$42;
  __ZN17address_map_entry10set_mirrorEj($43, 29);
  var $44=$curentry;
  var $45=$2;
  HEAP32[(($8)>>2)]={ f0: 26, f1: 0 }.f0; HEAP32[(($8+4)>>2)]={ f0: 26, f1: 0 }.f1;
  __ZN8delegateIFhR13address_spacejhEEC1I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($7, $8, ((STRING_TABLE.__str65)|0), 0);
  __ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEE($44, $45, ((__ZL11DEVICE_SELF)|0), $7);
  var $46=$1;
  var $47=$curentry;
  var $48=__ZN11address_map3addEjjP18address_map_entry8($46, 226, 226, $47);
  $curentry=$48;
  var $49=$curentry;
  var $50=$49;
  __ZN17address_map_entry10set_mirrorEj($50, 29);
  var $51=$curentry;
  var $52=$2;
  HEAP32[(($10)>>2)]={ f0: 28, f1: 0 }.f0; HEAP32[(($10+4)>>2)]={ f0: 28, f1: 0 }.f1;
  __ZN8delegateIFhR13address_spacejhEEC1I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($9, $10, ((STRING_TABLE.__str66)|0), 0);
  __ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEE($51, $52, ((__ZL11DEVICE_SELF)|0), $9);
  STACKTOP = __stackBase__;
  return;
}
__ZL35construct_address_map_coleco_io_mapR11address_mapRK8device_t["X"]=1;

function __ZNK11tagged_listI13memory_regionE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  var $6=__ZNK8tagmap_tIP13memory_regionE14find_hash_onlyEPKc($4, $5);
  ;
  return $6;
}


function __ZNK8tagmap_tIP13memory_regionE14find_hash_onlyEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL21tagmap_find_hash_onlyPK7_tagmapPKc($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZL21tagmap_find_hash_onlyPK7_tagmapPKc($map, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fullhash;
      var $entry;
      $2=$map;
      $3=$tag;
      var $4=$3;
      var $5=__ZL11tagmap_hashPKc($4);
      $fullhash=$5;
      var $6=$fullhash;
      var $7=(($6)>>>0)%97;
      var $8=$2;
      var $9=(($8)|0);
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $entry=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$entry;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $15
      var $16=$entry;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$fullhash;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$entry;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      $1=$24;
      __label__ = 7; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$entry;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $entry=$29;
      __label__ = 1; break;
    case 6: // $30
      $1=0;
      __label__ = 7; break;
    case 7: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20coleco_vdp_interruptR15running_machinei($machine, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drvstate;
      $1=$machine;
      $2=$state;
      var $3=$1;
      var $4=__ZNK15running_machine11driver_dataI12coleco_stateEEPT_v($3);
      $drvstate=$4;
      var $5=$2;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$drvstate;
      var $9=(($8+416)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      var $13=$drvstate;
      var $14=(($13+388)|0);
      var $15=$14;
      var $16=__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEptEv($15);
      var $17=$16;
      var $18=(($17+356)|0);
      var $19=$18;
      __ZN24device_execute_interface14set_input_lineEii($19, 32, 3);
      __label__ = 3; break;
    case 3: // $20
      var $21=$2;
      var $22=$drvstate;
      var $23=(($22+416)|0);
      HEAP32[(($23)>>2)]=$21;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19coleco_scan_paddlesR15running_machinePiS1_($machine, $joy_status0, $joy_status1) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $analog1;
      var $analog2;
      var $ctrl_sel;
      $1=$machine;
      $2=$joy_status0;
      $3=$joy_status1;
      $analog1=0;
      $analog2=0;
      var $4=$1;
      var $5=__Z20input_port_read_safeR15running_machinePKcj($4, ((STRING_TABLE.__str69)|0), 0);
      var $6=(($5) & 255);
      $ctrl_sel=$6;
      var $7=$ctrl_sel;
      var $8=(($7)&255);
      var $9=$8 & 7;
      var $10=(($9)|0)==3;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$1;
      var $13=__Z20input_port_read_safeR15running_machinePKcj($12, ((STRING_TABLE.__str170)|0), 0);
      var $14=(($13) & 255);
      $analog1=$14;
      __label__ = 9; break;
    case 2: // $15
      var $16=$ctrl_sel;
      var $17=(($16)&255);
      var $18=$17 & 7;
      var $19=(($18)|0)==2;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=__Z20input_port_read_safeR15running_machinePKcj($21, ((STRING_TABLE.__str271)|0), 0);
      var $23=(($22) & 255);
      $analog1=$23;
      __label__ = 4; break;
    case 4: // $24
      var $25=$ctrl_sel;
      var $26=(($25)&255);
      var $27=$26 & 112;
      var $28=(($27)|0)==32;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$1;
      var $31=__Z20input_port_read_safeR15running_machinePKcj($30, ((STRING_TABLE.__str372)|0), 0);
      var $32=(($31) & 255);
      $analog2=$32;
      __label__ = 6; break;
    case 6: // $33
      var $34=$ctrl_sel;
      var $35=(($34)&255);
      var $36=$35 & 128;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      var $39=$1;
      var $40=__Z20input_port_read_safeR15running_machinePKcj($39, ((STRING_TABLE.__str473)|0), 0);
      var $41=(($40) & 255);
      $analog1=$41;
      var $42=$1;
      var $43=__Z20input_port_read_safeR15running_machinePKcj($42, ((STRING_TABLE.__str574)|0), 0);
      var $44=(($43) & 255);
      $analog2=$44;
      __label__ = 8; break;
    case 8: // $45
      __label__ = 9; break;
    case 9: // $46
      var $47=$analog1;
      var $48=(($47)&255);
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $50
      var $51=$2;
      HEAP32[(($51)>>2)]=0;
      __label__ = 15; break;
    case 11: // $52
      var $53=$analog1;
      var $54=(($53)&255);
      var $55=$54 & 8;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $57
      var $58=$2;
      HEAP32[(($58)>>2)]=-1;
      __label__ = 14; break;
    case 13: // $59
      var $60=$2;
      HEAP32[(($60)>>2)]=1;
      __label__ = 14; break;
    case 14: // $61
      __label__ = 15; break;
    case 15: // $62
      var $63=$analog2;
      var $64=(($63)&255);
      var $65=(($64)|0)==0;
      if ($65) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $66
      var $67=$3;
      HEAP32[(($67)>>2)]=0;
      __label__ = 21; break;
    case 17: // $68
      var $69=$analog2;
      var $70=(($69)&255);
      var $71=$70 & 8;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $73
      var $74=$3;
      HEAP32[(($74)>>2)]=-1;
      __label__ = 20; break;
    case 19: // $75
      var $76=$3;
      HEAP32[(($76)>>2)]=1;
      __label__ = 20; break;
    case 20: // $77
      __label__ = 21; break;
    case 21: // $78
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19coleco_scan_paddlesR15running_machinePiS1_["X"]=1;

function __ZN8device_t15required_deviceI10cpu_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN8device_t15required_deviceI10cpu_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_t15required_deviceI10cpu_deviceED0Ev["X"]=1;

function __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EE10set_targetES2_($this, $target) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$target;
      var $5=$1;
      var $6=$2;
      var $7=(($5+12)|0);
      HEAP32[(($7)>>2)]=$6;
      var $8=$2;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=___cxa_allocate_exception(1032);
      var $12=$11;
      var $13=$5;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($12, ((STRING_TABLE.__str68)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      ___cxa_throw($11, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $3=$19;
      var $20=$18.f1;
      $4=$20;
      ___cxa_free_exception($11);
      __label__ = 5; break;
    case 4: // $21
      ;
      return;
    case 5: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED0Ev["X"]=1;

function __ZN20resource_pool_objectI12coleco_stateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12coleco_stateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12coleco_stateED0Ev["X"]=1;

function __ZN20resource_pool_objectI12coleco_stateED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI12coleco_stateE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19coleco_paddle1_readR15running_machineii($machine, $joy_mode, $joy_status) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $ctrl_sel;
      var $data;
      var $ipt1;
      var $data1;
      $2=$machine;
      $3=$joy_mode;
      $4=$joy_status;
      var $5=$2;
      var $6=__Z20input_port_read_safeR15running_machinePKcj($5, ((STRING_TABLE.__str69)|0), 0);
      var $7=(($6) & 255);
      $ctrl_sel=$7;
      var $8=$ctrl_sel;
      var $9=(($8)&255);
      var $10=$9 & 7;
      var $11=(($10)|0)!=1;
      if ($11) { __label__ = 1; break; } else { __label__ = 53; break; }
    case 1: // $12
      var $13=$3;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 38; break; }
    case 2: // $15
      $data=15;
      $ipt1=0;
      var $16=$ctrl_sel;
      var $17=(($16)&255);
      var $18=$17 & 7;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$2;
      var $22=__Z15input_port_readR15running_machinePKc($21, ((STRING_TABLE.__str675)|0));
      var $23=(($22) & 65535);
      $ipt1=$23;
      __label__ = 7; break;
    case 4: // $24
      var $25=$ctrl_sel;
      var $26=(($25)&255);
      var $27=$26 & 7;
      var $28=(($27)|0)==2;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$2;
      var $31=__Z15input_port_readR15running_machinePKc($30, ((STRING_TABLE.__str776)|0));
      var $32=(($31) & 65535);
      $ipt1=$32;
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$ctrl_sel;
      var $36=(($35)&255);
      var $37=$36 & 7;
      var $38=(($37)|0)!=3;
      if ($38) { __label__ = 8; break; } else { __label__ = 37; break; }
    case 8: // $39
      var $40=$ipt1;
      var $41=(($40)&65535);
      var $42=$41 & 1;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $44
      var $45=$data;
      var $46=(($45)&255);
      var $47=$46 & 10;
      var $48=(($47) & 255);
      $data=$48;
      __label__ = 10; break;
    case 10: // $49
      var $50=$ipt1;
      var $51=(($50)&65535);
      var $52=$51 & 2;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $54
      var $55=$data;
      var $56=(($55)&255);
      var $57=$56 & 13;
      var $58=(($57) & 255);
      $data=$58;
      __label__ = 12; break;
    case 12: // $59
      var $60=$ipt1;
      var $61=(($60)&65535);
      var $62=$61 & 4;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $64
      var $65=$data;
      var $66=(($65)&255);
      var $67=$66 & 7;
      var $68=(($67) & 255);
      $data=$68;
      __label__ = 14; break;
    case 14: // $69
      var $70=$ipt1;
      var $71=(($70)&65535);
      var $72=$71 & 8;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $74
      var $75=$data;
      var $76=(($75)&255);
      var $77=$76 & 12;
      var $78=(($77) & 255);
      $data=$78;
      __label__ = 16; break;
    case 16: // $79
      var $80=$ipt1;
      var $81=(($80)&65535);
      var $82=$81 & 16;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $84
      var $85=$data;
      var $86=(($85)&255);
      var $87=$86 & 2;
      var $88=(($87) & 255);
      $data=$88;
      __label__ = 18; break;
    case 18: // $89
      var $90=$ipt1;
      var $91=(($90)&65535);
      var $92=$91 & 32;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $94
      var $95=$data;
      var $96=(($95)&255);
      var $97=$96 & 3;
      var $98=(($97) & 255);
      $data=$98;
      __label__ = 20; break;
    case 20: // $99
      var $100=$ipt1;
      var $101=(($100)&65535);
      var $102=$101 & 64;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $104
      var $105=$data;
      var $106=(($105)&255);
      var $107=$106 & 14;
      var $108=(($107) & 255);
      $data=$108;
      __label__ = 22; break;
    case 22: // $109
      var $110=$ipt1;
      var $111=(($110)&65535);
      var $112=$111 & 128;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $114
      var $115=$data;
      var $116=(($115)&255);
      var $117=$116 & 5;
      var $118=(($117) & 255);
      $data=$118;
      __label__ = 24; break;
    case 24: // $119
      var $120=$ipt1;
      var $121=(($120)&65535);
      var $122=$121 & 256;
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $124
      var $125=$data;
      var $126=(($125)&255);
      var $127=$126 & 1;
      var $128=(($127) & 255);
      $data=$128;
      __label__ = 26; break;
    case 26: // $129
      var $130=$ipt1;
      var $131=(($130)&65535);
      var $132=$131 & 512;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $134
      var $135=$data;
      var $136=(($135)&255);
      var $137=$136 & 11;
      var $138=(($137) & 255);
      $data=$138;
      __label__ = 28; break;
    case 28: // $139
      var $140=$ipt1;
      var $141=(($140)&65535);
      var $142=$141 & 1024;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $144
      var $145=$data;
      var $146=(($145)&255);
      var $147=$146 & 6;
      var $148=(($147) & 255);
      $data=$148;
      __label__ = 30; break;
    case 30: // $149
      var $150=$ipt1;
      var $151=(($150)&65535);
      var $152=$151 & 2048;
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $154
      var $155=$data;
      var $156=(($155)&255);
      var $157=$156 & 9;
      var $158=(($157) & 255);
      $data=$158;
      __label__ = 32; break;
    case 32: // $159
      var $160=$ipt1;
      var $161=(($160)&65535);
      var $162=$161 & 4096;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $164
      var $165=$data;
      var $166=(($165)&255);
      var $167=$166 & 4;
      var $168=(($167) & 255);
      $data=$168;
      __label__ = 34; break;
    case 34: // $169
      var $170=$ipt1;
      var $171=(($170)&65535);
      var $172=$171 & 8192;
      var $173=(($172)|0)!=0;
      if ($173) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $174
      var $175=$data;
      var $176=(($175)&255);
      var $177=$176 & 8;
      var $178=(($177) & 255);
      $data=$178;
      __label__ = 36; break;
    case 36: // $179
      __label__ = 37; break;
    case 37: // $180
      var $181=$ipt1;
      var $182=(($181)&65535);
      var $183=$182 & 16384;
      var $184=$183 >> 8;
      var $185=$184 | 48;
      var $186=$data;
      var $187=(($186)&255);
      var $188=$185 | $187;
      var $189=(($188) & 255);
      $1=$189;
      __label__ = 54; break;
    case 38: // $190
      $data1=15;
      var $191=$ctrl_sel;
      var $192=(($191)&255);
      var $193=$192 & 7;
      var $194=(($193)|0)==0;
      if ($194) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $195
      var $196=$2;
      var $197=__Z15input_port_readR15running_machinePKc($196, ((STRING_TABLE.__str877)|0));
      var $198=$197 & 207;
      var $199=(($198) & 255);
      $data1=$199;
      __label__ = 43; break;
    case 40: // $200
      var $201=$ctrl_sel;
      var $202=(($201)&255);
      var $203=$202 & 7;
      var $204=(($203)|0)==2;
      if ($204) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $205
      var $206=$2;
      var $207=__Z15input_port_readR15running_machinePKc($206, ((STRING_TABLE.__str978)|0));
      var $208=$207 & 207;
      var $209=(($208) & 255);
      $data1=$209;
      __label__ = 42; break;
    case 42: // $210
      __label__ = 43; break;
    case 43: // $211
      var $212=$ctrl_sel;
      var $213=(($212)&255);
      var $214=$213 & 128;
      var $215=(($214)|0)!=0;
      if ($215) { __label__ = 46; break; } else { __label__ = 44; break; }
    case 44: // $216
      var $217=$ctrl_sel;
      var $218=(($217)&255);
      var $219=$218 & 7;
      var $220=(($219)|0)==2;
      if ($220) { __label__ = 46; break; } else { __label__ = 45; break; }
    case 45: // $221
      var $222=$ctrl_sel;
      var $223=(($222)&255);
      var $224=$223 & 7;
      var $225=(($224)|0)==3;
      if ($225) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $226
      var $227=$4;
      var $228=(($227)|0)==0;
      if ($228) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $229
      var $230=$data1;
      var $231=(($230)&255);
      var $232=$231 | 48;
      var $233=(($232) & 255);
      $data1=$233;
      __label__ = 51; break;
    case 48: // $234
      var $235=$4;
      var $236=(($235)|0)==1;
      if ($236) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $237
      var $238=$data1;
      var $239=(($238)&255);
      var $240=$239 | 32;
      var $241=(($240) & 255);
      $data1=$241;
      __label__ = 50; break;
    case 50: // $242
      __label__ = 51; break;
    case 51: // $243
      __label__ = 52; break;
    case 52: // $244
      var $245=$data1;
      var $246=(($245)&255);
      var $247=$246 | 128;
      var $248=(($247) & 255);
      $1=$248;
      __label__ = 54; break;
    case 53: // $249
      $1=15;
      __label__ = 54; break;
    case 54: // $250
      var $251=$1;
      ;
      return $251;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19coleco_paddle1_readR15running_machineii["X"]=1;

function __Z19coleco_paddle2_readR15running_machineii($machine, $joy_mode, $joy_status) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $ctrl_sel;
      var $data;
      var $ipt2;
      var $data1;
      $2=$machine;
      $3=$joy_mode;
      $4=$joy_status;
      var $5=$2;
      var $6=__Z20input_port_read_safeR15running_machinePKcj($5, ((STRING_TABLE.__str69)|0), 0);
      var $7=(($6) & 255);
      $ctrl_sel=$7;
      var $8=$ctrl_sel;
      var $9=(($8)&255);
      var $10=$9 & 112;
      var $11=(($10)|0)!=16;
      if ($11) { __label__ = 1; break; } else { __label__ = 50; break; }
    case 1: // $12
      var $13=$3;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 36; break; }
    case 2: // $15
      $data=15;
      $ipt2=0;
      var $16=$ctrl_sel;
      var $17=(($16)&255);
      var $18=$17 & 112;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$2;
      var $22=__Z15input_port_readR15running_machinePKc($21, ((STRING_TABLE.__str1079)|0));
      var $23=(($22) & 65535);
      $ipt2=$23;
      __label__ = 7; break;
    case 4: // $24
      var $25=$ctrl_sel;
      var $26=(($25)&255);
      var $27=$26 & 112;
      var $28=(($27)|0)==32;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$2;
      var $31=__Z15input_port_readR15running_machinePKc($30, ((STRING_TABLE.__str1180)|0));
      var $32=(($31) & 65535);
      $ipt2=$32;
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$ipt2;
      var $36=(($35)&65535);
      var $37=$36 & 1;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $39
      var $40=$data;
      var $41=(($40)&255);
      var $42=$41 & 10;
      var $43=(($42) & 255);
      $data=$43;
      __label__ = 9; break;
    case 9: // $44
      var $45=$ipt2;
      var $46=(($45)&65535);
      var $47=$46 & 2;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $49
      var $50=$data;
      var $51=(($50)&255);
      var $52=$51 & 13;
      var $53=(($52) & 255);
      $data=$53;
      __label__ = 11; break;
    case 11: // $54
      var $55=$ipt2;
      var $56=(($55)&65535);
      var $57=$56 & 4;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $59
      var $60=$data;
      var $61=(($60)&255);
      var $62=$61 & 7;
      var $63=(($62) & 255);
      $data=$63;
      __label__ = 13; break;
    case 13: // $64
      var $65=$ipt2;
      var $66=(($65)&65535);
      var $67=$66 & 8;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $69
      var $70=$data;
      var $71=(($70)&255);
      var $72=$71 & 12;
      var $73=(($72) & 255);
      $data=$73;
      __label__ = 15; break;
    case 15: // $74
      var $75=$ipt2;
      var $76=(($75)&65535);
      var $77=$76 & 16;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $79
      var $80=$data;
      var $81=(($80)&255);
      var $82=$81 & 2;
      var $83=(($82) & 255);
      $data=$83;
      __label__ = 17; break;
    case 17: // $84
      var $85=$ipt2;
      var $86=(($85)&65535);
      var $87=$86 & 32;
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=$data;
      var $91=(($90)&255);
      var $92=$91 & 3;
      var $93=(($92) & 255);
      $data=$93;
      __label__ = 19; break;
    case 19: // $94
      var $95=$ipt2;
      var $96=(($95)&65535);
      var $97=$96 & 64;
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $99
      var $100=$data;
      var $101=(($100)&255);
      var $102=$101 & 14;
      var $103=(($102) & 255);
      $data=$103;
      __label__ = 21; break;
    case 21: // $104
      var $105=$ipt2;
      var $106=(($105)&65535);
      var $107=$106 & 128;
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $109
      var $110=$data;
      var $111=(($110)&255);
      var $112=$111 & 5;
      var $113=(($112) & 255);
      $data=$113;
      __label__ = 23; break;
    case 23: // $114
      var $115=$ipt2;
      var $116=(($115)&65535);
      var $117=$116 & 256;
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 25; break; } else { __label__ = 24; break; }
    case 24: // $119
      var $120=$data;
      var $121=(($120)&255);
      var $122=$121 & 1;
      var $123=(($122) & 255);
      $data=$123;
      __label__ = 25; break;
    case 25: // $124
      var $125=$ipt2;
      var $126=(($125)&65535);
      var $127=$126 & 512;
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $129
      var $130=$data;
      var $131=(($130)&255);
      var $132=$131 & 11;
      var $133=(($132) & 255);
      $data=$133;
      __label__ = 27; break;
    case 27: // $134
      var $135=$ipt2;
      var $136=(($135)&65535);
      var $137=$136 & 1024;
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $139
      var $140=$data;
      var $141=(($140)&255);
      var $142=$141 & 6;
      var $143=(($142) & 255);
      $data=$143;
      __label__ = 29; break;
    case 29: // $144
      var $145=$ipt2;
      var $146=(($145)&65535);
      var $147=$146 & 2048;
      var $148=(($147)|0)!=0;
      if ($148) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $149
      var $150=$data;
      var $151=(($150)&255);
      var $152=$151 & 9;
      var $153=(($152) & 255);
      $data=$153;
      __label__ = 31; break;
    case 31: // $154
      var $155=$ipt2;
      var $156=(($155)&65535);
      var $157=$156 & 4096;
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $159
      var $160=$data;
      var $161=(($160)&255);
      var $162=$161 & 4;
      var $163=(($162) & 255);
      $data=$163;
      __label__ = 33; break;
    case 33: // $164
      var $165=$ipt2;
      var $166=(($165)&65535);
      var $167=$166 & 8192;
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $169
      var $170=$data;
      var $171=(($170)&255);
      var $172=$171 & 8;
      var $173=(($172) & 255);
      $data=$173;
      __label__ = 35; break;
    case 35: // $174
      var $175=$ipt2;
      var $176=(($175)&65535);
      var $177=$176 & 16384;
      var $178=$177 >> 8;
      var $179=$178 | 48;
      var $180=$data;
      var $181=(($180)&255);
      var $182=$179 | $181;
      var $183=(($182) & 255);
      $1=$183;
      __label__ = 51; break;
    case 36: // $184
      $data1=15;
      var $185=$ctrl_sel;
      var $186=(($185)&255);
      var $187=$186 & 112;
      var $188=(($187)|0)==0;
      if ($188) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $189
      var $190=$2;
      var $191=__Z15input_port_readR15running_machinePKc($190, ((STRING_TABLE.__str1281)|0));
      var $192=$191 & 207;
      var $193=(($192) & 255);
      $data1=$193;
      __label__ = 41; break;
    case 38: // $194
      var $195=$ctrl_sel;
      var $196=(($195)&255);
      var $197=$196 & 112;
      var $198=(($197)|0)==32;
      if ($198) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $199
      var $200=$2;
      var $201=__Z15input_port_readR15running_machinePKc($200, ((STRING_TABLE.__str1382)|0));
      var $202=$201 & 207;
      var $203=(($202) & 255);
      $data1=$203;
      __label__ = 40; break;
    case 40: // $204
      __label__ = 41; break;
    case 41: // $205
      var $206=$ctrl_sel;
      var $207=(($206)&255);
      var $208=$207 & 128;
      var $209=(($208)|0)!=0;
      if ($209) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $210
      var $211=$ctrl_sel;
      var $212=(($211)&255);
      var $213=$212 & 112;
      var $214=(($213)|0)==32;
      if ($214) { __label__ = 43; break; } else { __label__ = 49; break; }
    case 43: // $215
      var $216=$4;
      var $217=(($216)|0)==0;
      if ($217) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $218
      var $219=$data1;
      var $220=(($219)&255);
      var $221=$220 | 48;
      var $222=(($221) & 255);
      $data1=$222;
      __label__ = 48; break;
    case 45: // $223
      var $224=$4;
      var $225=(($224)|0)==1;
      if ($225) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $226
      var $227=$data1;
      var $228=(($227)&255);
      var $229=$228 | 32;
      var $230=(($229) & 255);
      $data1=$230;
      __label__ = 47; break;
    case 47: // $231
      __label__ = 48; break;
    case 48: // $232
      __label__ = 49; break;
    case 49: // $233
      var $234=$data1;
      var $235=(($234)&255);
      var $236=$235 | 128;
      var $237=(($236) & 255);
      $1=$237;
      __label__ = 51; break;
    case 50: // $238
      $1=15;
      __label__ = 51; break;
    case 51: // $239
      var $240=$1;
      ;
      return $240;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19coleco_paddle2_readR15running_machineii["X"]=1;

function __Z23construct_ioport_colecoR8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $6=$2;
      var $7=$1;
      var $8=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($6, $7, ((STRING_TABLE.__str69)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 20; break; };
    case 1: // $9
      $curport=$8;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $10=$curport;
      var $11=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($10, 8, 0, 7, ((STRING_TABLE.__str1483)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 20; break; };
    case 2: // $12
      $curfield=$11;
      $cursetting=0;
      var $13=$curfield;
      var $14=$curfield;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=1 & $16;
      var $18=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($13, $17, 115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 20; break; };
    case 3: // $19
      $cursetting=$18;
      var $20=$cursetting;
      var $21=(($20+24)|0);
      HEAP16[(($21)>>1)]=0;
      var $22=$curfield;
      var $23=$curfield;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=0 & $25;
      var $27=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($22, $26, ((STRING_TABLE.__str1584)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 20; break; };
    case 4: // $28
      $cursetting=$27;
      var $29=$cursetting;
      var $30=(($29+24)|0);
      HEAP16[(($30)>>1)]=1;
      var $31=$curfield;
      var $32=$curfield;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=2 & $34;
      var $36=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($31, $35, ((STRING_TABLE.__str1685)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 20; break; };
    case 5: // $37
      $cursetting=$36;
      var $38=$cursetting;
      var $39=(($38+24)|0);
      HEAP16[(($39)>>1)]=3;
      var $40=$curfield;
      var $41=$curfield;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=3 & $43;
      var $45=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($40, $44, ((STRING_TABLE.__str1786)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 20; break; };
    case 6: // $46
      $cursetting=$45;
      var $47=$cursetting;
      var $48=(($47+24)|0);
      HEAP16[(($48)>>1)]=5;
      var $49=$curport;
      var $50=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($49, 8, 0, 112, ((STRING_TABLE.__str1887)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 20; break; };
    case 7: // $51
      $curfield=$50;
      $cursetting=0;
      var $52=$curfield;
      var $53=$curfield;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=16 & $55;
      var $57=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($52, $56, 115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 20; break; };
    case 8: // $58
      $cursetting=$57;
      var $59=$cursetting;
      var $60=(($59+24)|0);
      HEAP16[(($60)>>1)]=0;
      var $61=$curfield;
      var $62=$curfield;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=0 & $64;
      var $66=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($61, $65, ((STRING_TABLE.__str1584)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 20; break; };
    case 9: // $67
      $cursetting=$66;
      var $68=$cursetting;
      var $69=(($68+24)|0);
      HEAP16[(($69)>>1)]=2;
      var $70=$curfield;
      var $71=$curfield;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=32 & $73;
      var $75=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($70, $74, ((STRING_TABLE.__str1685)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 20; break; };
    case 10: // $76
      $cursetting=$75;
      var $77=$cursetting;
      var $78=(($77+24)|0);
      HEAP16[(($78)>>1)]=4;
      var $79=$curport;
      var $80=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($79, 8, 0, 128, ((STRING_TABLE.__str1988)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 20; break; };
    case 11: // $81
      $curfield=$80;
      $cursetting=0;
      var $82=$curfield;
      var $83=$curfield;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=0 & $85;
      var $87=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($82, $86, 115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 20; break; };
    case 12: // $88
      $cursetting=$87;
      var $89=$cursetting;
      var $90=(($89+24)|0);
      HEAP16[(($90)>>1)]=0;
      var $91=$curfield;
      var $92=$curfield;
      var $93=(($92)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=128 & $94;
      var $96=(function() { try { __THREW__ = false; return __Z22ioconfig_alloc_settingR18input_field_configjPKc($91, $95, ((STRING_TABLE.__str2089)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; };
    case 13: // $97
      $cursetting=$96;
      var $98=$cursetting;
      var $99=(($98+24)|0);
      HEAP16[(($99)>>1)]=6;
      var $100=$1;
      var $101=$2;
      var $102=$3;
      (function() { try { __THREW__ = false; return __ZL22construct_ioport_ctrl1R8device_tR11tagged_listI17input_port_configER7astring($100, $101, $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $103
      var $104=$1;
      var $105=$2;
      var $106=$3;
      (function() { try { __THREW__ = false; return __ZL22construct_ioport_ctrl2R8device_tR11tagged_listI17input_port_configER7astring($104, $105, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $107
      var $108=$1;
      var $109=$2;
      var $110=$3;
      (function() { try { __THREW__ = false; return __ZL21construct_ioport_sac1R8device_tR11tagged_listI17input_port_configER7astring($108, $109, $110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $111
      var $112=$1;
      var $113=$2;
      var $114=$3;
      (function() { try { __THREW__ = false; return __ZL21construct_ioport_sac2R8device_tR11tagged_listI17input_port_configER7astring($112, $113, $114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $115
      var $116=$1;
      var $117=$2;
      var $118=$3;
      (function() { try { __THREW__ = false; return __ZL24construct_ioport_drivingR8device_tR11tagged_listI17input_port_configER7astring($116, $117, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $119
      var $120=$1;
      var $121=$2;
      var $122=$3;
      (function() { try { __THREW__ = false; return __ZL23construct_ioport_rollerR8device_tR11tagged_listI17input_port_configER7astring($120, $121, $122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $123
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 20: // $124
      var $125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $126=$125.f0;
      $4=$126;
      var $127=$125.f1;
      $5=$127;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $128
      __label__ = 22; break;
    case 22: // $129
      var $130=$4;
      var $131=$4;
      var $132=$5;
      var $133=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $131, tempValue);
      var $134=($133.f1 = $132, $133);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $135
      var $136=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z23construct_ioport_colecoR8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function __ZL22construct_ioport_ctrl1R8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      var $6=__stackBase__+64;
      var $7=__stackBase__+68;
      var $8=__stackBase__+72;
      var $9=__stackBase__+76;
      var $10=__stackBase__+80;
      var $11=__stackBase__+84;
      var $12=__stackBase__+88;
      var $13=__stackBase__+92;
      var $14=__stackBase__+96;
      var $15=__stackBase__+100;
      var $16=__stackBase__+104;
      var $17=__stackBase__+108;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $18=$2;
      var $19=$1;
      var $20=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($18, $19, ((STRING_TABLE.__str675)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 59; break; };
    case 1: // $21
      $curport=$20;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $22=$curport;
      var $23=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($22, 45, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 59; break; };
    case 2: // $24
      $curfield=$23;
      $cursetting=0;
      var $25=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str65134)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 59; break; };
    case 3: // $26
      var $27=$curfield;
      var $28=(($27+40)|0);
      HEAP32[(($28)>>2)]=$25;
      var $29=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 59; break; }
    case 4: // $30
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($29, 0, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 59; break; }
    case 5: // $31
      var $32=$curfield;
      var $33=(($32+30)|0);
      HEAP16[(($33)>>1)]=1;
      var $34=$curport;
      var $35=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($34, 45, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 59; break; };
    case 6: // $36
      $curfield=$35;
      $cursetting=0;
      var $37=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str66135)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 59; break; };
    case 7: // $38
      var $39=$curfield;
      var $40=(($39+40)|0);
      HEAP32[(($40)>>2)]=$37;
      var $41=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 59; break; }
    case 8: // $42
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($41, 0, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 59; break; }
    case 9: // $43
      var $44=$curfield;
      var $45=(($44+30)|0);
      HEAP16[(($45)>>1)]=1;
      var $46=$curport;
      var $47=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($46, 45, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 59; break; };
    case 10: // $48
      $curfield=$47;
      $cursetting=0;
      var $49=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str67136)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 59; break; };
    case 11: // $50
      var $51=$curfield;
      var $52=(($51+40)|0);
      HEAP32[(($52)>>2)]=$49;
      var $53=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 1, 0, 1, 0, 81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 59; break; }
    case 12: // $54
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($53, 0, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 59; break; }
    case 13: // $55
      var $56=$curfield;
      var $57=(($56+30)|0);
      HEAP16[(($57)>>1)]=1;
      var $58=$curport;
      var $59=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($58, 45, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 59; break; };
    case 14: // $60
      $curfield=$59;
      $cursetting=0;
      var $61=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str68137)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 59; break; };
    case 15: // $62
      var $63=$curfield;
      var $64=(($63+40)|0);
      HEAP32[(($64)>>2)]=$61;
      var $65=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9, 1, 0, 1, 0, 82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 59; break; }
    case 16: // $66
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($65, 0, $9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 59; break; }
    case 17: // $67
      var $68=$curfield;
      var $69=(($68+30)|0);
      HEAP16[(($69)>>1)]=1;
      var $70=$curport;
      var $71=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($70, 45, -1, 16, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 59; break; };
    case 18: // $72
      $curfield=$71;
      $cursetting=0;
      var $73=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str69138)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 59; break; };
    case 19: // $74
      var $75=$curfield;
      var $76=(($75+40)|0);
      HEAP32[(($76)>>2)]=$73;
      var $77=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10, 1, 0, 1, 0, 83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 59; break; }
    case 20: // $78
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($77, 0, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 59; break; }
    case 21: // $79
      var $80=$curfield;
      var $81=(($80+30)|0);
      HEAP16[(($81)>>1)]=1;
      var $82=$curport;
      var $83=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($82, 45, -1, 32, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 59; break; };
    case 22: // $84
      $curfield=$83;
      $cursetting=0;
      var $85=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str70)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 59; break; };
    case 23: // $86
      var $87=$curfield;
      var $88=(($87+40)|0);
      HEAP32[(($88)>>2)]=$85;
      var $89=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11, 1, 0, 1, 0, 84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 59; break; }
    case 24: // $90
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($89, 0, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 59; break; }
    case 25: // $91
      var $92=$curfield;
      var $93=(($92+30)|0);
      HEAP16[(($93)>>1)]=1;
      var $94=$curport;
      var $95=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($94, 45, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 59; break; };
    case 26: // $96
      $curfield=$95;
      $cursetting=0;
      var $97=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str71)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 59; break; };
    case 27: // $98
      var $99=$curfield;
      var $100=(($99+40)|0);
      HEAP32[(($100)>>2)]=$97;
      var $101=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($12, 1, 0, 1, 0, 85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 59; break; }
    case 28: // $102
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($101, 0, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 59; break; }
    case 29: // $103
      var $104=$curfield;
      var $105=(($104+30)|0);
      HEAP16[(($105)>>1)]=1;
      var $106=$curport;
      var $107=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($106, 45, -1, 128, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 59; break; };
    case 30: // $108
      $curfield=$107;
      $cursetting=0;
      var $109=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str72)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 59; break; };
    case 31: // $110
      var $111=$curfield;
      var $112=(($111+40)|0);
      HEAP32[(($112)>>2)]=$109;
      var $113=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($13, 1, 0, 1, 0, 86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 59; break; }
    case 32: // $114
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($113, 0, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 59; break; }
    case 33: // $115
      var $116=$curfield;
      var $117=(($116+30)|0);
      HEAP16[(($117)>>1)]=1;
      var $118=$curport;
      var $119=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($118, 45, -1, 256, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 59; break; };
    case 34: // $120
      $curfield=$119;
      $cursetting=0;
      var $121=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str73)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 59; break; };
    case 35: // $122
      var $123=$curfield;
      var $124=(($123+40)|0);
      HEAP32[(($124)>>2)]=$121;
      var $125=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($14, 1, 0, 1, 0, 87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 59; break; }
    case 36: // $126
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($125, 0, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 59; break; }
    case 37: // $127
      var $128=$curfield;
      var $129=(($128+30)|0);
      HEAP16[(($129)>>1)]=1;
      var $130=$curport;
      var $131=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($130, 45, -1, 512, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 59; break; };
    case 38: // $132
      $curfield=$131;
      $cursetting=0;
      var $133=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str74)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 59; break; };
    case 39: // $134
      var $135=$curfield;
      var $136=(($135+40)|0);
      HEAP32[(($136)>>2)]=$133;
      var $137=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($15, 1, 0, 1, 0, 88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 59; break; }
    case 40: // $138
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($137, 0, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 59; break; }
    case 41: // $139
      var $140=$curfield;
      var $141=(($140+30)|0);
      HEAP16[(($141)>>1)]=1;
      var $142=$curport;
      var $143=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($142, 45, -1, 1024, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 59; break; };
    case 42: // $144
      $curfield=$143;
      $cursetting=0;
      var $145=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str75)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 59; break; };
    case 43: // $146
      var $147=$curfield;
      var $148=(($147+40)|0);
      HEAP32[(($148)>>2)]=$145;
      var $149=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($16, 1, 0, 1, 0, 91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 59; break; }
    case 44: // $150
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($149, 0, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 59; break; }
    case 45: // $151
      var $152=$curfield;
      var $153=(($152+30)|0);
      HEAP16[(($153)>>1)]=1;
      var $154=$curport;
      var $155=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($154, 45, -1, 2048, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 59; break; };
    case 46: // $156
      $curfield=$155;
      $cursetting=0;
      var $157=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str76)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 59; break; };
    case 47: // $158
      var $159=$curfield;
      var $160=(($159+40)|0);
      HEAP32[(($160)>>2)]=$157;
      var $161=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($17, 1, 0, 1, 0, 92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 59; break; }
    case 48: // $162
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($161, 0, $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 59; break; }
    case 49: // $163
      var $164=$curfield;
      var $165=(($164+30)|0);
      HEAP16[(($165)>>1)]=1;
      var $166=$curport;
      var $167=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($166, 60, -1, 16384, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 59; break; };
    case 50: // $168
      $curfield=$167;
      $cursetting=0;
      var $169=$curfield;
      var $170=(($169+28)|0);
      HEAP8[($170)]=0;
      var $171=$curfield;
      var $172=(($171+30)|0);
      HEAP16[(($172)>>1)]=1;
      var $173=$curport;
      var $174=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($173, 3, -1, 45056, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 59; break; };
    case 51: // $175
      $curfield=$174;
      $cursetting=0;
      var $176=$curfield;
      var $177=(($176+30)|0);
      HEAP16[(($177)>>1)]=1;
      var $178=$2;
      var $179=$1;
      var $180=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($178, $179, ((STRING_TABLE.__str877)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 59; break; };
    case 52: // $181
      $curport=$180;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $182=$curport;
      var $183=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($182, 47, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 59; break; };
    case 53: // $184
      $curfield=$183;
      $cursetting=0;
      var $185=$curfield;
      var $186=(($185+28)|0);
      HEAP8[($186)]=0;
      var $187=$curfield;
      var $188=(($187+30)|0);
      HEAP16[(($188)>>1)]=1;
      var $189=$curport;
      var $190=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($189, 50, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 59; break; };
    case 54: // $191
      $curfield=$190;
      $cursetting=0;
      var $192=$curfield;
      var $193=(($192+28)|0);
      HEAP8[($193)]=0;
      var $194=$curfield;
      var $195=(($194+30)|0);
      HEAP16[(($195)>>1)]=1;
      var $196=$curport;
      var $197=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($196, 48, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 59; break; };
    case 55: // $198
      $curfield=$197;
      $cursetting=0;
      var $199=$curfield;
      var $200=(($199+28)|0);
      HEAP8[($200)]=0;
      var $201=$curfield;
      var $202=(($201+30)|0);
      HEAP16[(($202)>>1)]=1;
      var $203=$curport;
      var $204=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($203, 49, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 59; break; };
    case 56: // $205
      $curfield=$204;
      $cursetting=0;
      var $206=$curfield;
      var $207=(($206+28)|0);
      HEAP8[($207)]=0;
      var $208=$curfield;
      var $209=(($208+30)|0);
      HEAP16[(($209)>>1)]=1;
      var $210=$curport;
      var $211=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($210, 59, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 59; break; };
    case 57: // $212
      $curfield=$211;
      $cursetting=0;
      var $213=$curfield;
      var $214=(($213+28)|0);
      HEAP8[($214)]=0;
      var $215=$curfield;
      var $216=(($215+30)|0);
      HEAP16[(($216)>>1)]=1;
      var $217=$curport;
      var $218=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($217, 3, -1, 176, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 59; break; };
    case 58: // $219
      $curfield=$218;
      $cursetting=0;
      var $220=$curfield;
      var $221=(($220+30)|0);
      HEAP16[(($221)>>1)]=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 59: // $222
      var $223=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $224=$223.f0;
      $4=$224;
      var $225=$223.f1;
      $5=$225;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $226
      __label__ = 61; break;
    case 61: // $227
      var $228=$4;
      var $229=$4;
      var $230=$5;
      var $231=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $229, tempValue);
      var $232=($231.f1 = $230, $231);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $233
      var $234=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22construct_ioport_ctrl1R8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function __ZL22construct_ioport_ctrl2R8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $6=$2;
      var $7=$1;
      var $8=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($6, $7, ((STRING_TABLE.__str1079)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 35; break; };
    case 1: // $9
      $curport=$8;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $10=$curport;
      var $11=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($10, 45, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 35; break; };
    case 2: // $12
      $curfield=$11;
      $cursetting=0;
      var $13=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str53122)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 35; break; };
    case 3: // $14
      var $15=$curfield;
      var $16=(($15+40)|0);
      HEAP32[(($16)>>2)]=$13;
      var $17=$curfield;
      var $18=(($17+30)|0);
      HEAP16[(($18)>>1)]=2;
      var $19=$curport;
      var $20=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($19, 45, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 35; break; };
    case 4: // $21
      $curfield=$20;
      $cursetting=0;
      var $22=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str54123)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 35; break; };
    case 5: // $23
      var $24=$curfield;
      var $25=(($24+40)|0);
      HEAP32[(($25)>>2)]=$22;
      var $26=$curfield;
      var $27=(($26+30)|0);
      HEAP16[(($27)>>1)]=2;
      var $28=$curport;
      var $29=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($28, 45, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 35; break; };
    case 6: // $30
      $curfield=$29;
      $cursetting=0;
      var $31=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str55124)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 35; break; };
    case 7: // $32
      var $33=$curfield;
      var $34=(($33+40)|0);
      HEAP32[(($34)>>2)]=$31;
      var $35=$curfield;
      var $36=(($35+30)|0);
      HEAP16[(($36)>>1)]=2;
      var $37=$curport;
      var $38=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($37, 45, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 35; break; };
    case 8: // $39
      $curfield=$38;
      $cursetting=0;
      var $40=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str56125)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 35; break; };
    case 9: // $41
      var $42=$curfield;
      var $43=(($42+40)|0);
      HEAP32[(($43)>>2)]=$40;
      var $44=$curfield;
      var $45=(($44+30)|0);
      HEAP16[(($45)>>1)]=2;
      var $46=$curport;
      var $47=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($46, 45, -1, 16, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 35; break; };
    case 10: // $48
      $curfield=$47;
      $cursetting=0;
      var $49=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str57126)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 35; break; };
    case 11: // $50
      var $51=$curfield;
      var $52=(($51+40)|0);
      HEAP32[(($52)>>2)]=$49;
      var $53=$curfield;
      var $54=(($53+30)|0);
      HEAP16[(($54)>>1)]=2;
      var $55=$curport;
      var $56=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($55, 45, -1, 32, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 35; break; };
    case 12: // $57
      $curfield=$56;
      $cursetting=0;
      var $58=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str58127)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 35; break; };
    case 13: // $59
      var $60=$curfield;
      var $61=(($60+40)|0);
      HEAP32[(($61)>>2)]=$58;
      var $62=$curfield;
      var $63=(($62+30)|0);
      HEAP16[(($63)>>1)]=2;
      var $64=$curport;
      var $65=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($64, 45, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 35; break; };
    case 14: // $66
      $curfield=$65;
      $cursetting=0;
      var $67=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str59128)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 35; break; };
    case 15: // $68
      var $69=$curfield;
      var $70=(($69+40)|0);
      HEAP32[(($70)>>2)]=$67;
      var $71=$curfield;
      var $72=(($71+30)|0);
      HEAP16[(($72)>>1)]=2;
      var $73=$curport;
      var $74=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($73, 45, -1, 128, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 35; break; };
    case 16: // $75
      $curfield=$74;
      $cursetting=0;
      var $76=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str60129)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 35; break; };
    case 17: // $77
      var $78=$curfield;
      var $79=(($78+40)|0);
      HEAP32[(($79)>>2)]=$76;
      var $80=$curfield;
      var $81=(($80+30)|0);
      HEAP16[(($81)>>1)]=2;
      var $82=$curport;
      var $83=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($82, 45, -1, 256, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 35; break; };
    case 18: // $84
      $curfield=$83;
      $cursetting=0;
      var $85=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str61130)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 35; break; };
    case 19: // $86
      var $87=$curfield;
      var $88=(($87+40)|0);
      HEAP32[(($88)>>2)]=$85;
      var $89=$curfield;
      var $90=(($89+30)|0);
      HEAP16[(($90)>>1)]=2;
      var $91=$curport;
      var $92=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($91, 45, -1, 512, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 35; break; };
    case 20: // $93
      $curfield=$92;
      $cursetting=0;
      var $94=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str62131)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 35; break; };
    case 21: // $95
      var $96=$curfield;
      var $97=(($96+40)|0);
      HEAP32[(($97)>>2)]=$94;
      var $98=$curfield;
      var $99=(($98+30)|0);
      HEAP16[(($99)>>1)]=2;
      var $100=$curport;
      var $101=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($100, 45, -1, 1024, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 35; break; };
    case 22: // $102
      $curfield=$101;
      $cursetting=0;
      var $103=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str63132)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 35; break; };
    case 23: // $104
      var $105=$curfield;
      var $106=(($105+40)|0);
      HEAP32[(($106)>>2)]=$103;
      var $107=$curfield;
      var $108=(($107+30)|0);
      HEAP16[(($108)>>1)]=2;
      var $109=$curport;
      var $110=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($109, 45, -1, 2048, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 35; break; };
    case 24: // $111
      $curfield=$110;
      $cursetting=0;
      var $112=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str64133)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 35; break; };
    case 25: // $113
      var $114=$curfield;
      var $115=(($114+40)|0);
      HEAP32[(($115)>>2)]=$112;
      var $116=$curfield;
      var $117=(($116+30)|0);
      HEAP16[(($117)>>1)]=2;
      var $118=$curport;
      var $119=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($118, 60, -1, 16384, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 35; break; };
    case 26: // $120
      $curfield=$119;
      $cursetting=0;
      var $121=$curfield;
      var $122=(($121+28)|0);
      HEAP8[($122)]=1;
      var $123=$curfield;
      var $124=(($123+30)|0);
      HEAP16[(($124)>>1)]=2;
      var $125=$curport;
      var $126=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($125, 3, -1, 45056, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 35; break; };
    case 27: // $127
      $curfield=$126;
      $cursetting=0;
      var $128=$curfield;
      var $129=(($128+30)|0);
      HEAP16[(($129)>>1)]=2;
      var $130=$2;
      var $131=$1;
      var $132=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($130, $131, ((STRING_TABLE.__str1281)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 35; break; };
    case 28: // $133
      $curport=$132;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $134=$curport;
      var $135=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($134, 47, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 35; break; };
    case 29: // $136
      $curfield=$135;
      $cursetting=0;
      var $137=$curfield;
      var $138=(($137+28)|0);
      HEAP8[($138)]=1;
      var $139=$curfield;
      var $140=(($139+30)|0);
      HEAP16[(($140)>>1)]=2;
      var $141=$curport;
      var $142=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($141, 50, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; };
    case 30: // $143
      $curfield=$142;
      $cursetting=0;
      var $144=$curfield;
      var $145=(($144+28)|0);
      HEAP8[($145)]=1;
      var $146=$curfield;
      var $147=(($146+30)|0);
      HEAP16[(($147)>>1)]=2;
      var $148=$curport;
      var $149=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($148, 48, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 35; break; };
    case 31: // $150
      $curfield=$149;
      $cursetting=0;
      var $151=$curfield;
      var $152=(($151+28)|0);
      HEAP8[($152)]=1;
      var $153=$curfield;
      var $154=(($153+30)|0);
      HEAP16[(($154)>>1)]=2;
      var $155=$curport;
      var $156=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($155, 49, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 35; break; };
    case 32: // $157
      $curfield=$156;
      $cursetting=0;
      var $158=$curfield;
      var $159=(($158+28)|0);
      HEAP8[($159)]=1;
      var $160=$curfield;
      var $161=(($160+30)|0);
      HEAP16[(($161)>>1)]=2;
      var $162=$curport;
      var $163=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($162, 59, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; };
    case 33: // $164
      $curfield=$163;
      $cursetting=0;
      var $165=$curfield;
      var $166=(($165+28)|0);
      HEAP8[($166)]=1;
      var $167=$curfield;
      var $168=(($167+30)|0);
      HEAP16[(($168)>>1)]=2;
      var $169=$curport;
      var $170=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($169, 3, -1, 176, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 35; break; };
    case 34: // $171
      $curfield=$170;
      $cursetting=0;
      var $172=$curfield;
      var $173=(($172+30)|0);
      HEAP16[(($173)>>1)]=2;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 35: // $174
      var $175=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $176=$175.f0;
      $4=$176;
      var $177=$175.f1;
      $5=$177;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $178
      __label__ = 37; break;
    case 37: // $179
      var $180=$4;
      var $181=$4;
      var $182=$5;
      var $183=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $181, tempValue);
      var $184=($183.f1 = $182, $183);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $185
      var $186=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22construct_ioport_ctrl2R8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function __ZL21construct_ioport_sac1R8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 120; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      var $6=__stackBase__+64;
      var $7=__stackBase__+68;
      var $8=__stackBase__+72;
      var $9=__stackBase__+76;
      var $10=__stackBase__+80;
      var $11=__stackBase__+84;
      var $12=__stackBase__+88;
      var $13=__stackBase__+92;
      var $14=__stackBase__+96;
      var $15=__stackBase__+100;
      var $16=__stackBase__+104;
      var $17=__stackBase__+108;
      var $18=__stackBase__+112;
      var $19=__stackBase__+116;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $20=$2;
      var $21=$1;
      var $22=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($20, $21, ((STRING_TABLE.__str776)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 71; break; };
    case 1: // $23
      $curport=$22;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $24=$curport;
      var $25=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($24, 45, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 71; break; };
    case 2: // $26
      $curfield=$25;
      $cursetting=0;
      var $27=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str37106)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 71; break; };
    case 3: // $28
      var $29=$curfield;
      var $30=(($29+40)|0);
      HEAP32[(($30)>>2)]=$27;
      var $31=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 71; break; }
    case 4: // $32
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($31, 0, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 71; break; }
    case 5: // $33
      var $34=$curfield;
      var $35=(($34+30)|0);
      HEAP16[(($35)>>1)]=3;
      var $36=$curport;
      var $37=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($36, 45, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 71; break; };
    case 6: // $38
      $curfield=$37;
      $cursetting=0;
      var $39=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str38107)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 71; break; };
    case 7: // $40
      var $41=$curfield;
      var $42=(($41+40)|0);
      HEAP32[(($42)>>2)]=$39;
      var $43=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 71; break; }
    case 8: // $44
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($43, 0, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 71; break; }
    case 9: // $45
      var $46=$curfield;
      var $47=(($46+30)|0);
      HEAP16[(($47)>>1)]=3;
      var $48=$curport;
      var $49=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($48, 45, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 71; break; };
    case 10: // $50
      $curfield=$49;
      $cursetting=0;
      var $51=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str39108)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 71; break; };
    case 11: // $52
      var $53=$curfield;
      var $54=(($53+40)|0);
      HEAP32[(($54)>>2)]=$51;
      var $55=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 1, 0, 1, 0, 81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 71; break; }
    case 12: // $56
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($55, 0, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 71; break; }
    case 13: // $57
      var $58=$curfield;
      var $59=(($58+30)|0);
      HEAP16[(($59)>>1)]=3;
      var $60=$curport;
      var $61=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($60, 45, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 71; break; };
    case 14: // $62
      $curfield=$61;
      $cursetting=0;
      var $63=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str40109)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 71; break; };
    case 15: // $64
      var $65=$curfield;
      var $66=(($65+40)|0);
      HEAP32[(($66)>>2)]=$63;
      var $67=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9, 1, 0, 1, 0, 82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 71; break; }
    case 16: // $68
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($67, 0, $9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 71; break; }
    case 17: // $69
      var $70=$curfield;
      var $71=(($70+30)|0);
      HEAP16[(($71)>>1)]=3;
      var $72=$curport;
      var $73=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($72, 45, -1, 16, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 71; break; };
    case 18: // $74
      $curfield=$73;
      $cursetting=0;
      var $75=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str41110)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 71; break; };
    case 19: // $76
      var $77=$curfield;
      var $78=(($77+40)|0);
      HEAP32[(($78)>>2)]=$75;
      var $79=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10, 1, 0, 1, 0, 83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 71; break; }
    case 20: // $80
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($79, 0, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 71; break; }
    case 21: // $81
      var $82=$curfield;
      var $83=(($82+30)|0);
      HEAP16[(($83)>>1)]=3;
      var $84=$curport;
      var $85=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($84, 45, -1, 32, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 71; break; };
    case 22: // $86
      $curfield=$85;
      $cursetting=0;
      var $87=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str42111)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 71; break; };
    case 23: // $88
      var $89=$curfield;
      var $90=(($89+40)|0);
      HEAP32[(($90)>>2)]=$87;
      var $91=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11, 1, 0, 1, 0, 84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 71; break; }
    case 24: // $92
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($91, 0, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 71; break; }
    case 25: // $93
      var $94=$curfield;
      var $95=(($94+30)|0);
      HEAP16[(($95)>>1)]=3;
      var $96=$curport;
      var $97=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($96, 45, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 71; break; };
    case 26: // $98
      $curfield=$97;
      $cursetting=0;
      var $99=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str43112)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 71; break; };
    case 27: // $100
      var $101=$curfield;
      var $102=(($101+40)|0);
      HEAP32[(($102)>>2)]=$99;
      var $103=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($12, 1, 0, 1, 0, 85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 71; break; }
    case 28: // $104
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($103, 0, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 71; break; }
    case 29: // $105
      var $106=$curfield;
      var $107=(($106+30)|0);
      HEAP16[(($107)>>1)]=3;
      var $108=$curport;
      var $109=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($108, 45, -1, 128, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 71; break; };
    case 30: // $110
      $curfield=$109;
      $cursetting=0;
      var $111=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str44113)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 71; break; };
    case 31: // $112
      var $113=$curfield;
      var $114=(($113+40)|0);
      HEAP32[(($114)>>2)]=$111;
      var $115=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($13, 1, 0, 1, 0, 86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 71; break; }
    case 32: // $116
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($115, 0, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 71; break; }
    case 33: // $117
      var $118=$curfield;
      var $119=(($118+30)|0);
      HEAP16[(($119)>>1)]=3;
      var $120=$curport;
      var $121=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($120, 45, -1, 256, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 71; break; };
    case 34: // $122
      $curfield=$121;
      $cursetting=0;
      var $123=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str45114)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 71; break; };
    case 35: // $124
      var $125=$curfield;
      var $126=(($125+40)|0);
      HEAP32[(($126)>>2)]=$123;
      var $127=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($14, 1, 0, 1, 0, 87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 71; break; }
    case 36: // $128
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($127, 0, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 71; break; }
    case 37: // $129
      var $130=$curfield;
      var $131=(($130+30)|0);
      HEAP16[(($131)>>1)]=3;
      var $132=$curport;
      var $133=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($132, 45, -1, 512, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 71; break; };
    case 38: // $134
      $curfield=$133;
      $cursetting=0;
      var $135=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str46115)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 71; break; };
    case 39: // $136
      var $137=$curfield;
      var $138=(($137+40)|0);
      HEAP32[(($138)>>2)]=$135;
      var $139=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($15, 1, 0, 1, 0, 88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 71; break; }
    case 40: // $140
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($139, 0, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 71; break; }
    case 41: // $141
      var $142=$curfield;
      var $143=(($142+30)|0);
      HEAP16[(($143)>>1)]=3;
      var $144=$curport;
      var $145=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($144, 45, -1, 1024, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 71; break; };
    case 42: // $146
      $curfield=$145;
      $cursetting=0;
      var $147=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str47116)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 71; break; };
    case 43: // $148
      var $149=$curfield;
      var $150=(($149+40)|0);
      HEAP32[(($150)>>2)]=$147;
      var $151=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($16, 1, 0, 1, 0, 91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 71; break; }
    case 44: // $152
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($151, 0, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 71; break; }
    case 45: // $153
      var $154=$curfield;
      var $155=(($154+30)|0);
      HEAP16[(($155)>>1)]=3;
      var $156=$curport;
      var $157=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($156, 45, -1, 2048, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 71; break; };
    case 46: // $158
      $curfield=$157;
      $cursetting=0;
      var $159=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str48117)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 71; break; };
    case 47: // $160
      var $161=$curfield;
      var $162=(($161+40)|0);
      HEAP32[(($162)>>2)]=$159;
      var $163=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($17, 1, 0, 1, 0, 92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 71; break; }
    case 48: // $164
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($163, 0, $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 71; break; }
    case 49: // $165
      var $166=$curfield;
      var $167=(($166+30)|0);
      HEAP16[(($167)>>1)]=3;
      var $168=$curport;
      var $169=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($168, 61, -1, 4096, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 71; break; };
    case 50: // $170
      $curfield=$169;
      $cursetting=0;
      var $171=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str49118)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 71; break; };
    case 51: // $172
      var $173=$curfield;
      var $174=(($173+40)|0);
      HEAP32[(($174)>>2)]=$171;
      var $175=$curfield;
      var $176=(($175+28)|0);
      HEAP8[($176)]=0;
      var $177=$curfield;
      var $178=(($177+30)|0);
      HEAP16[(($178)>>1)]=3;
      var $179=$curport;
      var $180=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($179, 62, -1, 8192, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 71; break; };
    case 52: // $181
      $curfield=$180;
      $cursetting=0;
      var $182=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str50119)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 71; break; };
    case 53: // $183
      var $184=$curfield;
      var $185=(($184+40)|0);
      HEAP32[(($185)>>2)]=$182;
      var $186=$curfield;
      var $187=(($186+28)|0);
      HEAP8[($187)]=0;
      var $188=$curfield;
      var $189=(($188+30)|0);
      HEAP16[(($189)>>1)]=3;
      var $190=$curport;
      var $191=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($190, 60, -1, 16384, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 71; break; };
    case 54: // $192
      $curfield=$191;
      $cursetting=0;
      var $193=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str51120)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 71; break; };
    case 55: // $194
      var $195=$curfield;
      var $196=(($195+40)|0);
      HEAP32[(($196)>>2)]=$193;
      var $197=$curfield;
      var $198=(($197+28)|0);
      HEAP8[($198)]=0;
      var $199=$curfield;
      var $200=(($199+30)|0);
      HEAP16[(($200)>>1)]=3;
      var $201=$curport;
      var $202=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($201, 3, -1, 32768, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 71; break; };
    case 56: // $203
      $curfield=$202;
      $cursetting=0;
      var $204=$curfield;
      var $205=(($204+30)|0);
      HEAP16[(($205)>>1)]=3;
      var $206=$2;
      var $207=$1;
      var $208=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($206, $207, ((STRING_TABLE.__str978)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 71; break; };
    case 57: // $209
      $curport=$208;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $210=$curport;
      var $211=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($210, 47, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 71; break; };
    case 58: // $212
      $curfield=$211;
      $cursetting=0;
      var $213=$curfield;
      var $214=(($213+28)|0);
      HEAP8[($214)]=0;
      var $215=$curfield;
      var $216=(($215+30)|0);
      HEAP16[(($216)>>1)]=3;
      var $217=$curport;
      var $218=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($217, 50, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 71; break; };
    case 59: // $219
      $curfield=$218;
      $cursetting=0;
      var $220=$curfield;
      var $221=(($220+28)|0);
      HEAP8[($221)]=0;
      var $222=$curfield;
      var $223=(($222+30)|0);
      HEAP16[(($223)>>1)]=3;
      var $224=$curport;
      var $225=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($224, 48, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 71; break; };
    case 60: // $226
      $curfield=$225;
      $cursetting=0;
      var $227=$curfield;
      var $228=(($227+28)|0);
      HEAP8[($228)]=0;
      var $229=$curfield;
      var $230=(($229+30)|0);
      HEAP16[(($230)>>1)]=3;
      var $231=$curport;
      var $232=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($231, 49, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 71; break; };
    case 61: // $233
      $curfield=$232;
      $cursetting=0;
      var $234=$curfield;
      var $235=(($234+28)|0);
      HEAP8[($235)]=0;
      var $236=$curfield;
      var $237=(($236+30)|0);
      HEAP16[(($237)>>1)]=3;
      var $238=$curport;
      var $239=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($238, 59, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 71; break; };
    case 62: // $240
      $curfield=$239;
      $cursetting=0;
      var $241=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str52121)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 71; break; };
    case 63: // $242
      var $243=$curfield;
      var $244=(($243+40)|0);
      HEAP32[(($244)>>2)]=$241;
      var $245=$curfield;
      var $246=(($245+28)|0);
      HEAP8[($246)]=0;
      var $247=$curfield;
      var $248=(($247+30)|0);
      HEAP16[(($248)>>1)]=3;
      var $249=$curport;
      var $250=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($249, 3, -1, 176, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 71; break; };
    case 64: // $251
      $curfield=$250;
      $cursetting=0;
      var $252=$curfield;
      var $253=(($252+30)|0);
      HEAP16[(($253)>>1)]=3;
      var $254=$2;
      var $255=$1;
      var $256=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($254, $255, ((STRING_TABLE.__str271)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 71; break; };
    case 65: // $257
      $curport=$256;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $258=$curport;
      var $259=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($258, 152, 0, 15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 71; break; };
    case 66: // $260
      $curfield=$259;
      $cursetting=0;
      var $261=$curfield;
      var $262=(($261+308)|0);
      HEAP32[(($262)>>2)]=20;
      var $263=$curfield;
      var $264=(($263+316)|0);
      HEAP32[(($264)>>2)]=10;
      var $265=$curfield;
      var $266=(($265+312)|0);
      HEAP32[(($266)>>2)]=10;
      var $267=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($18, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 71; break; }
    case 67: // $268
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($267, 2, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 71; break; }
    case 68: // $269
      var $270=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($19, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $271
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($270, 1, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $272
      var $273=$curfield;
      var $274=(($273+32)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=$275 | 32;
      HEAP32[(($274)>>2)]=$276;
      var $277=$curfield;
      var $278=(($277+28)|0);
      HEAP8[($278)]=0;
      var $279=$curfield;
      var $280=(($279+30)|0);
      HEAP16[(($280)>>1)]=3;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 71: // $281
      var $282=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $283=$282.f0;
      $4=$283;
      var $284=$282.f1;
      $5=$284;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $285
      __label__ = 73; break;
    case 73: // $286
      var $287=$4;
      var $288=$4;
      var $289=$5;
      var $290=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $288, tempValue);
      var $291=($290.f1 = $289, $290);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 74: // $292
      var $293=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21construct_ioport_sac1R8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function __ZN11cli_optionsD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11cli_optionsD2Ev($2);
  ;
  return;
}


function __ZN18mini_osd_interfaceC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13osd_interfaceC2Ev($3);
  var $4=$2;
  HEAP32[(($4)>>2)]=((__ZTV18mini_osd_interface+8)|0);
  ;
  return;
}


function __ZN18mini_osd_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13osd_interfaceD2Ev($3);
  ;
  return;
}


function __ZL21construct_ioport_sac2R8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      var $6=__stackBase__+64;
      var $7=__stackBase__+68;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $8=$2;
      var $9=$1;
      var $10=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($8, $9, ((STRING_TABLE.__str1180)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 47; break; };
    case 1: // $11
      $curport=$10;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $12=$curport;
      var $13=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($12, 45, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 47; break; };
    case 2: // $14
      $curfield=$13;
      $cursetting=0;
      var $15=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2190)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 47; break; };
    case 3: // $16
      var $17=$curfield;
      var $18=(($17+40)|0);
      HEAP32[(($18)>>2)]=$15;
      var $19=$curfield;
      var $20=(($19+30)|0);
      HEAP16[(($20)>>1)]=4;
      var $21=$curport;
      var $22=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($21, 45, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 47; break; };
    case 4: // $23
      $curfield=$22;
      $cursetting=0;
      var $24=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2291)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 47; break; };
    case 5: // $25
      var $26=$curfield;
      var $27=(($26+40)|0);
      HEAP32[(($27)>>2)]=$24;
      var $28=$curfield;
      var $29=(($28+30)|0);
      HEAP16[(($29)>>1)]=4;
      var $30=$curport;
      var $31=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($30, 45, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 47; break; };
    case 6: // $32
      $curfield=$31;
      $cursetting=0;
      var $33=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2392)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 47; break; };
    case 7: // $34
      var $35=$curfield;
      var $36=(($35+40)|0);
      HEAP32[(($36)>>2)]=$33;
      var $37=$curfield;
      var $38=(($37+30)|0);
      HEAP16[(($38)>>1)]=4;
      var $39=$curport;
      var $40=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($39, 45, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 47; break; };
    case 8: // $41
      $curfield=$40;
      $cursetting=0;
      var $42=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2493)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 47; break; };
    case 9: // $43
      var $44=$curfield;
      var $45=(($44+40)|0);
      HEAP32[(($45)>>2)]=$42;
      var $46=$curfield;
      var $47=(($46+30)|0);
      HEAP16[(($47)>>1)]=4;
      var $48=$curport;
      var $49=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($48, 45, -1, 16, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 47; break; };
    case 10: // $50
      $curfield=$49;
      $cursetting=0;
      var $51=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2594)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 47; break; };
    case 11: // $52
      var $53=$curfield;
      var $54=(($53+40)|0);
      HEAP32[(($54)>>2)]=$51;
      var $55=$curfield;
      var $56=(($55+30)|0);
      HEAP16[(($56)>>1)]=4;
      var $57=$curport;
      var $58=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($57, 45, -1, 32, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 47; break; };
    case 12: // $59
      $curfield=$58;
      $cursetting=0;
      var $60=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2695)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 47; break; };
    case 13: // $61
      var $62=$curfield;
      var $63=(($62+40)|0);
      HEAP32[(($63)>>2)]=$60;
      var $64=$curfield;
      var $65=(($64+30)|0);
      HEAP16[(($65)>>1)]=4;
      var $66=$curport;
      var $67=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($66, 45, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 47; break; };
    case 14: // $68
      $curfield=$67;
      $cursetting=0;
      var $69=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2796)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 47; break; };
    case 15: // $70
      var $71=$curfield;
      var $72=(($71+40)|0);
      HEAP32[(($72)>>2)]=$69;
      var $73=$curfield;
      var $74=(($73+30)|0);
      HEAP16[(($74)>>1)]=4;
      var $75=$curport;
      var $76=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($75, 45, -1, 128, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 47; break; };
    case 16: // $77
      $curfield=$76;
      $cursetting=0;
      var $78=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2897)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 47; break; };
    case 17: // $79
      var $80=$curfield;
      var $81=(($80+40)|0);
      HEAP32[(($81)>>2)]=$78;
      var $82=$curfield;
      var $83=(($82+30)|0);
      HEAP16[(($83)>>1)]=4;
      var $84=$curport;
      var $85=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($84, 45, -1, 256, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 47; break; };
    case 18: // $86
      $curfield=$85;
      $cursetting=0;
      var $87=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str2998)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 47; break; };
    case 19: // $88
      var $89=$curfield;
      var $90=(($89+40)|0);
      HEAP32[(($90)>>2)]=$87;
      var $91=$curfield;
      var $92=(($91+30)|0);
      HEAP16[(($92)>>1)]=4;
      var $93=$curport;
      var $94=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($93, 45, -1, 512, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 47; break; };
    case 20: // $95
      $curfield=$94;
      $cursetting=0;
      var $96=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str3099)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 47; break; };
    case 21: // $97
      var $98=$curfield;
      var $99=(($98+40)|0);
      HEAP32[(($99)>>2)]=$96;
      var $100=$curfield;
      var $101=(($100+30)|0);
      HEAP16[(($101)>>1)]=4;
      var $102=$curport;
      var $103=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($102, 45, -1, 1024, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 47; break; };
    case 22: // $104
      $curfield=$103;
      $cursetting=0;
      var $105=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str31100)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 47; break; };
    case 23: // $106
      var $107=$curfield;
      var $108=(($107+40)|0);
      HEAP32[(($108)>>2)]=$105;
      var $109=$curfield;
      var $110=(($109+30)|0);
      HEAP16[(($110)>>1)]=4;
      var $111=$curport;
      var $112=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($111, 45, -1, 2048, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 47; break; };
    case 24: // $113
      $curfield=$112;
      $cursetting=0;
      var $114=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str32101)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 47; break; };
    case 25: // $115
      var $116=$curfield;
      var $117=(($116+40)|0);
      HEAP32[(($117)>>2)]=$114;
      var $118=$curfield;
      var $119=(($118+30)|0);
      HEAP16[(($119)>>1)]=4;
      var $120=$curport;
      var $121=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($120, 61, -1, 4096, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 47; break; };
    case 26: // $122
      $curfield=$121;
      $cursetting=0;
      var $123=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str33102)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 47; break; };
    case 27: // $124
      var $125=$curfield;
      var $126=(($125+40)|0);
      HEAP32[(($126)>>2)]=$123;
      var $127=$curfield;
      var $128=(($127+28)|0);
      HEAP8[($128)]=1;
      var $129=$curfield;
      var $130=(($129+30)|0);
      HEAP16[(($130)>>1)]=4;
      var $131=$curport;
      var $132=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($131, 62, -1, 8192, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 47; break; };
    case 28: // $133
      $curfield=$132;
      $cursetting=0;
      var $134=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str34103)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 47; break; };
    case 29: // $135
      var $136=$curfield;
      var $137=(($136+40)|0);
      HEAP32[(($137)>>2)]=$134;
      var $138=$curfield;
      var $139=(($138+28)|0);
      HEAP8[($139)]=1;
      var $140=$curfield;
      var $141=(($140+30)|0);
      HEAP16[(($141)>>1)]=4;
      var $142=$curport;
      var $143=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($142, 60, -1, 16384, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 47; break; };
    case 30: // $144
      $curfield=$143;
      $cursetting=0;
      var $145=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str35104)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 47; break; };
    case 31: // $146
      var $147=$curfield;
      var $148=(($147+40)|0);
      HEAP32[(($148)>>2)]=$145;
      var $149=$curfield;
      var $150=(($149+28)|0);
      HEAP8[($150)]=1;
      var $151=$curfield;
      var $152=(($151+30)|0);
      HEAP16[(($152)>>1)]=4;
      var $153=$curport;
      var $154=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($153, 3, -1, 32768, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 47; break; };
    case 32: // $155
      $curfield=$154;
      $cursetting=0;
      var $156=$curfield;
      var $157=(($156+30)|0);
      HEAP16[(($157)>>1)]=4;
      var $158=$2;
      var $159=$1;
      var $160=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($158, $159, ((STRING_TABLE.__str1382)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 47; break; };
    case 33: // $161
      $curport=$160;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $162=$curport;
      var $163=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($162, 47, -1, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 47; break; };
    case 34: // $164
      $curfield=$163;
      $cursetting=0;
      var $165=$curfield;
      var $166=(($165+28)|0);
      HEAP8[($166)]=1;
      var $167=$curfield;
      var $168=(($167+30)|0);
      HEAP16[(($168)>>1)]=4;
      var $169=$curport;
      var $170=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($169, 50, -1, 2, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 47; break; };
    case 35: // $171
      $curfield=$170;
      $cursetting=0;
      var $172=$curfield;
      var $173=(($172+28)|0);
      HEAP8[($173)]=1;
      var $174=$curfield;
      var $175=(($174+30)|0);
      HEAP16[(($175)>>1)]=4;
      var $176=$curport;
      var $177=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($176, 48, -1, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 47; break; };
    case 36: // $178
      $curfield=$177;
      $cursetting=0;
      var $179=$curfield;
      var $180=(($179+28)|0);
      HEAP8[($180)]=1;
      var $181=$curfield;
      var $182=(($181+30)|0);
      HEAP16[(($182)>>1)]=4;
      var $183=$curport;
      var $184=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($183, 49, -1, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 47; break; };
    case 37: // $185
      $curfield=$184;
      $cursetting=0;
      var $186=$curfield;
      var $187=(($186+28)|0);
      HEAP8[($187)]=1;
      var $188=$curfield;
      var $189=(($188+30)|0);
      HEAP16[(($189)>>1)]=4;
      var $190=$curport;
      var $191=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($190, 59, -1, 64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 47; break; };
    case 38: // $192
      $curfield=$191;
      $cursetting=0;
      var $193=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc(((STRING_TABLE.__str36105)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 47; break; };
    case 39: // $194
      var $195=$curfield;
      var $196=(($195+40)|0);
      HEAP32[(($196)>>2)]=$193;
      var $197=$curfield;
      var $198=(($197+28)|0);
      HEAP8[($198)]=1;
      var $199=$curfield;
      var $200=(($199+30)|0);
      HEAP16[(($200)>>1)]=4;
      var $201=$curport;
      var $202=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($201, 3, -1, 176, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 47; break; };
    case 40: // $203
      $curfield=$202;
      $cursetting=0;
      var $204=$curfield;
      var $205=(($204+30)|0);
      HEAP16[(($205)>>1)]=4;
      var $206=$2;
      var $207=$1;
      var $208=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($206, $207, ((STRING_TABLE.__str372)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 47; break; };
    case 41: // $209
      $curport=$208;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $210=$curport;
      var $211=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($210, 152, 0, 15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 47; break; };
    case 42: // $212
      $curfield=$211;
      $cursetting=0;
      var $213=$curfield;
      var $214=(($213+308)|0);
      HEAP32[(($214)>>2)]=20;
      var $215=$curfield;
      var $216=(($215+316)|0);
      HEAP32[(($216)>>2)]=10;
      var $217=$curfield;
      var $218=(($217+312)|0);
      HEAP32[(($218)>>2)]=10;
      var $219=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 47; break; }
    case 43: // $220
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($219, 2, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 47; break; }
    case 44: // $221
      var $222=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $223
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($222, 1, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $224
      var $225=$curfield;
      var $226=(($225+32)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$227 | 32;
      HEAP32[(($226)>>2)]=$228;
      var $229=$curfield;
      var $230=(($229+28)|0);
      HEAP8[($230)]=1;
      var $231=$curfield;
      var $232=(($231+30)|0);
      HEAP16[(($232)>>1)]=4;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 47: // $233
      var $234=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $235=$234.f0;
      $4=$235;
      var $236=$234.f1;
      $5=$236;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $237
      __label__ = 49; break;
    case 49: // $238
      var $239=$4;
      var $240=$4;
      var $241=$5;
      var $242=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $240, tempValue);
      var $243=($242.f1 = $241, $242);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $244
      var $245=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21construct_ioport_sac2R8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function __ZL24construct_ioport_drivingR8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      var $6=__stackBase__+64;
      var $7=__stackBase__+68;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $8=$2;
      var $9=$1;
      var $10=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($8, $9, ((STRING_TABLE.__str170)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; };
    case 1: // $11
      $curport=$10;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $12=$curport;
      var $13=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($12, 152, 0, 15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; };
    case 2: // $14
      $curfield=$13;
      $cursetting=0;
      var $15=$curfield;
      var $16=(($15+308)|0);
      HEAP32[(($16)>>2)]=20;
      var $17=$curfield;
      var $18=(($17+316)|0);
      HEAP32[(($18)>>2)]=10;
      var $19=$curfield;
      var $20=(($19+312)|0);
      HEAP32[(($20)>>2)]=10;
      var $21=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $22
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($21, 2, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $23
      var $24=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $25
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($24, 1, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$curfield;
      var $28=(($27+32)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 | 32;
      HEAP32[(($28)>>2)]=$30;
      var $31=$curfield;
      var $32=(($31+30)|0);
      HEAP16[(($32)>>1)]=5;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 7: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $4=$35;
      var $36=$34.f1;
      $5=$36;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $37
      __label__ = 9; break;
    case 9: // $38
      var $39=$4;
      var $40=$4;
      var $41=$5;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24construct_ioport_drivingR8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function __ZL23construct_ioport_rollerR8device_tR11tagged_listI17input_port_configER7astring($owner, $portlist, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fulltag=__stackBase__;
      var $cursetting;
      var $curfield;
      var $curport;
      var $maskbits;
      var $4;
      var $5;
      var $6=__stackBase__+64;
      var $7=__stackBase__+68;
      var $8=__stackBase__+72;
      var $9=__stackBase__+76;
      $1=$owner;
      $2=$portlist;
      $3=$errorbuf;
      __ZN7astringC1Ev($fulltag);
      $cursetting=0;
      $curfield=0;
      $curport=0;
      $maskbits=0;
      var $10=$2;
      var $11=$1;
      var $12=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($10, $11, ((STRING_TABLE.__str473)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 13; break; };
    case 1: // $13
      $curport=$12;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $14=$curport;
      var $15=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($14, 154, 0, 15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 13; break; };
    case 2: // $16
      $curfield=$15;
      $cursetting=0;
      var $17=$curfield;
      var $18=(($17+308)|0);
      HEAP32[(($18)>>2)]=20;
      var $19=$curfield;
      var $20=(($19+316)|0);
      HEAP32[(($20)>>2)]=10;
      var $21=$curfield;
      var $22=(($21+312)|0);
      HEAP32[(($22)>>2)]=10;
      var $23=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $24
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($23, 2, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $25
      var $26=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $27
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($26, 1, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $28
      var $29=$curfield;
      var $30=(($29+32)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$31 | 32;
      HEAP32[(($30)>>2)]=$32;
      var $33=$curfield;
      var $34=(($33+30)|0);
      HEAP16[(($34)>>1)]=6;
      var $35=$2;
      var $36=$1;
      var $37=(function() { try { __THREW__ = false; return __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($35, $36, ((STRING_TABLE.__str574)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $38
      $curport=$37;
      $curfield=0;
      $cursetting=0;
      $maskbits=0;
      var $39=$curport;
      var $40=(function() { try { __THREW__ = false; return __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($39, 155, 0, 15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 13; break; };
    case 8: // $41
      $curfield=$40;
      $cursetting=0;
      var $42=$curfield;
      var $43=(($42+308)|0);
      HEAP32[(($43)>>2)]=20;
      var $44=$curfield;
      var $45=(($44+316)|0);
      HEAP32[(($45)>>2)]=10;
      var $46=$curfield;
      var $47=(($46+312)|0);
      HEAP32[(($47)>>2)]=10;
      var $48=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $49
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($48, 2, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $50
      var $51=$curfield;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $52
      (function() { try { __THREW__ = false; return __Z17ioconfig_add_codeR18input_field_configi10input_code($51, 1, $9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $53
      var $54=$curfield;
      var $55=(($54+32)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56 | 32;
      HEAP32[(($55)>>2)]=$57;
      var $58=$curfield;
      var $59=(($58+30)|0);
      HEAP16[(($59)>>1)]=6;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      STACKTOP = __stackBase__;
      return;
    case 13: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $4=$62;
      var $63=$61.f1;
      $5=$63;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $64
      __label__ = 15; break;
    case 15: // $65
      var $66=$4;
      var $67=$4;
      var $68=$5;
      var $69=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $67, tempValue);
      var $70=($69.f1 = $68, $69);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23construct_ioport_rollerR8device_tR11tagged_listI17input_port_configER7astring["X"]=1;

function _main($argc, $argv) {
  var __stackBase__  = STACKTOP; STACKTOP += 484; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $options=__stackBase__;
      var $osd=__stackBase__+464;
      var $4;
      var $5;
      var $frontend=__stackBase__+472;
      var $6;
      $1=0;
      $2=$argc;
      $3=$argv;
      FUNCTION_TABLE[__ZN11cli_optionsC1Ev]($options);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18mini_osd_interfaceC1Ev]($osd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$osd;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cli_frontendC1ER11cli_optionsR13osd_interface]($frontend, $options, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $9
      var $10=$2;
      var $11=$3;
      var $12=(function() { try { __THREW__ = false; return __ZN12cli_frontend7executeEiPPc($frontend, $10, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $13
      $1=$12;
      $6=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cli_frontendD1Ev]($frontend) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 4: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $4=$16;
      var $17=$15.f1;
      $5=$17;
      __label__ = 12; break;
    case 5: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $4=$20;
      var $21=$19.f1;
      $5=$21;
      __label__ = 10; break;
    case 6: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $4=$24;
      var $25=$23.f1;
      $5=$25;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cli_frontendD1Ev]($frontend) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 7: // $26
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18mini_osd_interfaceD1Ev]($osd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; }
    case 8: // $27
      __label__ = 10; break;
    case 9: // $28
      __ZN11cli_optionsD1Ev($options);
      var $29=$1;
      STACKTOP = __stackBase__;
      return $29;
    case 10: // $30
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18mini_osd_interfaceD1Ev]($osd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $31
      __label__ = 12; break;
    case 12: // $32
      (function() { try { __THREW__ = false; return __ZN11cli_optionsD1Ev($options) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $33
      __label__ = 14; break;
    case 14: // $34
      var $35=$4;
      var $36=$4;
      var $37=$5;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
Module["_main"] = _main;_main["X"]=1;

function __ZN18mini_osd_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18mini_osd_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18mini_osd_interfaceD0Ev["X"]=1;
// WARNING: content after a branch in a label, line: 21698

function __ZN18mini_osd_interface19update_audio_streamEPKsi($this, $buffer, $samples_this_frame) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$buffer;
  $3=$samples_this_frame;
  var $4=$1;
  ;
  return;
}


function __ZN18mini_osd_interface16set_mastervolumeEi($this, $attenuation) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$attenuation;
  var $3=$1;
  ;
  return;
}


function __ZN18mini_osd_interface25customize_input_type_listER11simple_listI16input_type_entryE($this, $typelist) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$typelist;
  var $3=$1;
  ;
  return;
}


function __ZL18keyboard_get_statePvS_($device_internal, $item_internal) {
  ;
  var __label__;

  var $1;
  var $2;
  var $keystate;
  $1=$device_internal;
  $2=$item_internal;
  var $3=$2;
  $keystate=$3;
  var $4=$keystate;
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  ;
  return $6;
}


function __Z8downcastIP17legacy_cpu_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15running_machine6renderEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+1280)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15running_machine5inputEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+1284)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13input_manager12device_classE18input_device_class($this, $devclass) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$devclass;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      __label__ = 3; break;
    case 3: // $6
      __label__ = 4; break;
    case 4: // $7
      var $8=$2;
      var $9=(($3+4404)|0);
      var $10=(($9+($8<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZgtRK8attotimeS1_($left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) > (($8)|0);
      if ($9) { var $29 = 1;__label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0)==(($16)|0);
      if ($17) { __label__ = 2; break; } else { var $27 = 0;__label__ = 3; break; }
    case 2: // $18
      var $19=$1;
      var $20=(($19+4)|0);
      var $st$2$0=(($20)|0);
      var $21$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$2$1)>>2)];
      var $22=$2;
      var $23=(($22+4)|0);
      var $st$8$0=(($23)|0);
      var $24$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($23+4)|0);
      var $24$1=HEAP32[(($st$8$1)>>2)];
      var $25=($21$1|0) > ($24$1|0) || (($21$1|0) == ($24$1|0) && ($21$0|0) >  ($24$0|0));
      var $27 = $25;__label__ = 3; break;
    case 3: // $26
      var $27;
      var $29 = $27;__label__ = 4; break;
    case 4: // $28
      var $29;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13osd_interface7machineEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+4)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine9schedulerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1160)|0);
  ;
  return $3;
}


function __ZN18mini_osd_interface6updateEb($this, $skip_redraw) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $minwidth=__stackBase__;
      var $minheight=__stackBase__+4;
      var $primlist;
      var $3=__stackBase__+8;
      var $4=__stackBase__+20;
      $1=$this;
      var $5=(($skip_redraw)&1);
      $2=$5;
      var $6=$1;
      var $7=HEAP32[((__ZL10our_target)>>2)];
      __ZN13render_target20compute_minimum_sizeERiS0_($7, $minwidth, $minheight);
      var $8=HEAP32[((__ZL10our_target)>>2)];
      var $9=HEAP32[(($minwidth)>>2)];
      var $10=HEAP32[(($minheight)>>2)];
      __ZN13render_target10set_boundsEiif($8, $9, $10, 0);
      var $11=HEAP32[((__ZL10our_target)>>2)];
      var $12=__ZN13render_target14get_primitivesEv($11);
      $primlist=$12;
      var $13=$primlist;
      __ZN21render_primitive_list12acquire_lockEv($13);
      var $14=$primlist;
      __ZN21render_primitive_list12release_lockEv($14);
      var $15=$6;
      var $16=__ZNK13osd_interface7machineEv($15);
      __ZNK15running_machine4timeEv($3, $16);
      __ZN8attotime12from_secondsEi($4, 5);
      var $17=__ZgtRK8attotimeS1_($3, $4);
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$6;
      var $20=__ZNK13osd_interface7machineEv($19);
      __ZN15running_machine13schedule_exitEv($20);
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21render_primitive_list12acquire_lockEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  _osd_lock_acquire($4);
  ;
  return;
}


function __ZN21render_primitive_list12release_lockEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  _osd_lock_release($4);
  ;
  return;
}


function __ZNK15running_machine4timeEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1160)|0);
  __ZNK16device_scheduler4timeEv($agg_result, $3);
  ;
  return;
}


function __ZN8attotime12from_secondsEi($agg_result, $seconds) {
  ;
  var __label__;

  var $1;
  $1=$seconds;
  var $2=$1;
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN8attotimeC1Eix($agg_result, $2, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function __ZN14emu_fatalerrorC1EPKcPc($this, $format, $ap) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$format;
  $3=$ap;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN14emu_fatalerrorC2EPKcPc($4, $5, $6);
  ;
  return;
}


function __ZN14emu_fatalerrorC2EPKcPc($this, $format, $ap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$format;
      $3=$ap;
      var $6=$1;
      var $7=$6;
      __ZN13emu_exceptionC2Ev($7);
      var $8=$6;
      HEAP32[(($8)>>2)]=((__ZTV14emu_fatalerror+8)|0);
      var $9=(($6+1028)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($6+4)|0);
      var $11=(($10)|0);
      var $12=$2;
      var $13=$3;
      var $14=(function() { try { __THREW__ = false; return _vsprintf($11, $12, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $15
      var $16=(($6+4)|0);
      var $17=(($16)|0);
      (function() { try { __THREW__ = false; return _osd_break_into_debugger($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      ;
      return;
    case 3: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $4=$21;
      var $22=$20.f1;
      $5=$22;
      var $23=$6;
      __ZN13emu_exceptionD2Ev($23);
      __label__ = 4; break;
    case 4: // $24
      var $25=$4;
      var $26=$4;
      var $27=$5;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cli_optionsD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN11emu_optionsD2Ev($3);
  ;
  return;
}


function __ZN11emu_optionsD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN12core_optionsD2Ev($3);
  ;
  return;
}


function __ZL14get_safe_tokenP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP17legacy_cpu_device8device_tET_PT0_($6);
      var $8=__ZNK17legacy_cpu_device5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler11synchronizeEPFvR15running_machinePviEPKciS2_($this, $callback, $name, $param, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6=__stackBase__;
  $1=$this;
  $2=$callback;
  $3=$name;
  $4=$param;
  $5=$ptr;
  var $7=$1;
  var $8=$6;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($7, $6, $9, $10, $11, $12);
  STACKTOP = __stackBase__;
  return;
}


function __Z18cpu_get_info_i8748P17legacy_cpu_devicejP7cpuinfo($device, $state, $info) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$device;
  $2=$state;
  $3=$info;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZL22mcs48_generic_get_infoP17legacy_cpu_devicejP7cpuinfohiiPKc($4, $5, $6, 1, 1024, 64, ((STRING_TABLE.__str6164)|0));
  ;
  return;
}


function __Z18cpu_get_info_i8049P17legacy_cpu_devicejP7cpuinfo($device, $state, $info) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$device;
  $2=$state;
  $3=$info;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZL22mcs48_generic_get_infoP17legacy_cpu_devicejP7cpuinfohiiPKc($4, $5, $6, 1, 2048, 128, ((STRING_TABLE.__str8166)|0));
  ;
  return;
}


function __ZN12i8748_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN17legacy_cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPS_jP7cpuinfoE($8, $9, $10, $11, $12, $13, 70);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV12i8748_device+8)|0);
  var $15=$7;
  var $16=(($15+356)|0);
  var $17=$16;
  HEAP32[(($17)>>2)]=((__ZTV12i8748_device+156)|0);
  var $18=$7;
  var $19=(($18+5968)|0);
  var $20=$19;
  HEAP32[(($20)>>2)]=((__ZTV12i8748_device+256)|0);
  var $21=$7;
  var $22=(($21+6012)|0);
  var $23=$22;
  HEAP32[(($23)>>2)]=((__ZTV12i8748_device+340)|0);
  var $24=$7;
  var $25=(($24+7088)|0);
  var $26=$25;
  HEAP32[(($26)>>2)]=((__ZTV12i8748_device+420)|0);
  ;
  return;
}


function __ZN18mini_osd_interface4initER15running_machine($this, $machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$machine;
      var $3=$1;
      var $4=$3;
      var $5=$2;
      __ZN13osd_interface4initER15running_machine($4, $5);
      var $6=$2;
      var $7=__ZNK15running_machine6renderEv($6);
      var $8=__ZN14render_manager12target_allocEPKcj($7, 0, 0);
      HEAP32[((__ZL10our_target)>>2)]=$8;
      var $9=$2;
      var $10=__ZNK15running_machine5inputEv($9);
      var $11=__ZN13input_manager12device_classE18input_device_class($10, 1);
      var $12=__ZN11input_class10add_deviceEPKcPv($11, ((STRING_TABLE.__str147)|0), 0);
      HEAP32[((__ZL15keyboard_device)>>2)]=$12;
      var $13=HEAP32[((__ZL15keyboard_device)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1148)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $16
      var $17=HEAP32[((__ZL15keyboard_device)>>2)];
      var $18=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($17, ((STRING_TABLE.__str2149)|0), 52, 68, ((__ZL14keyboard_state)|0));
      var $19=HEAP32[((__ZL15keyboard_device)>>2)];
      var $20=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($19, ((STRING_TABLE.__str3150)|0), 28, 68, ((__ZL14keyboard_state+1)|0));
      var $21=HEAP32[((__ZL15keyboard_device)>>2)];
      var $22=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($21, ((STRING_TABLE.__str4151)|0), 99, 68, ((__ZL14keyboard_state+2)|0));
      var $23=HEAP32[((__ZL15keyboard_device)>>2)];
      var $24=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($23, ((STRING_TABLE.__str5152)|0), 101, 68, ((__ZL14keyboard_state+3)|0));
      var $25=HEAP32[((__ZL15keyboard_device)>>2)];
      var $26=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($25, ((STRING_TABLE.__str6153)|0), 68, 68, ((__ZL14keyboard_state+4)|0));
      var $27=HEAP32[((__ZL15keyboard_device)>>2)];
      var $28=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($27, ((STRING_TABLE.__str7154)|0), 77, 68, ((__ZL14keyboard_state+5)|0));
      var $29=HEAP32[((__ZL15keyboard_device)>>2)];
      var $30=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($29, ((STRING_TABLE.__str8155)|0), 78, 68, ((__ZL14keyboard_state+6)|0));
      var $31=HEAP32[((__ZL15keyboard_device)>>2)];
      var $32=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($31, ((STRING_TABLE.__str9156)|0), 75, 68, ((__ZL14keyboard_state+7)|0));
      var $33=HEAP32[((__ZL15keyboard_device)>>2)];
      var $34=__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($33, ((STRING_TABLE.__str10157)|0), 76, 68, ((__ZL14keyboard_state+8)|0));
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10fatalerrorPKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ap=__stackBase__;
      var $2;
      var $3;
      $1=$format;
      var $4=$ap;
      HEAP32[(($4)>>2)]=arguments[__Z10fatalerrorPKcz.length];
      var $5=___cxa_allocate_exception(1032);
      var $6=$5;
      var $7=$1;
      var $8=HEAP32[(($ap)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcPc($6, $7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      ___cxa_throw($5, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      ___cxa_free_exception($5);
      __label__ = 3; break;
    case 3: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22mcs48_generic_get_infoP17legacy_cpu_devicejP7cpuinfohiiPKc($device, $state, $info, $features, $romsize, $ramsize, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$device;
      $2=$state;
      $3=$info;
      $4=$features;
      $5=$romsize;
      $6=$ramsize;
      $7=$name;
      var $8=$2;
      if ($8 == 8) {
        __label__ = 1; break;
      }
      else if ($8 == 147457) {
        __label__ = 11; break;
      }
      else if ($8 == 147462) {
        __label__ = 30; break;
      }
      else if ($8 == 65539) {
        __label__ = 34; break;
      }
      else if ($8 == 65540) {
        __label__ = 47; break;
      }
      else if ($8 == 196608) {
        __label__ = 57; break;
      }
      else {
      __label__ = 58; break;
      }
      
    case 1: // $9
      var $10=$6;
      var $11=(($10)|0)==64;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$3;
      var $14=$13;
      var $$emscripten$temp$0$0=6;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($14)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($14+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 10; break;
    case 3: // $15
      var $16=$6;
      var $17=(($16)|0)==128;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$3;
      var $20=$19;
      var $$emscripten$temp$1$0=7;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($20)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($20+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 9; break;
    case 5: // $21
      var $22=$6;
      var $23=(($22)|0)==256;
      if ($23) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $24
      var $25=$3;
      var $26=$25;
      var $$emscripten$temp$2$0=8;
      var $$emscripten$temp$2$1=0;
      var $st$4$0=(($26)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$2$0;
      var $st$4$1=(($26+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 8; break;
    case 7: // $27
      __Z10fatalerrorPKcz(((STRING_TABLE.__str21183)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 8: // $28
      __label__ = 9; break;
    case 9: // $29
      __label__ = 10; break;
    case 10: // $30
      __label__ = 59; break;
    case 11: // $31
      var $32=$5;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $34
      var $35=$3;
      var $36=$35;
      HEAP32[(($36)>>2)]=38;
      __label__ = 29; break;
    case 13: // $37
      var $38=$5;
      var $39=(($38)|0)==1024;
      if ($39) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $40
      var $41=$4;
      var $42=(($41)&255);
      var $43=(($42)|0)==2;
      if ($43) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $44
      var $47 = 58;__label__ = 17; break;
    case 16: // $45
      var $47 = 60;__label__ = 17; break;
    case 17: // $46
      var $47;
      var $48=$3;
      var $49=$48;
      HEAP32[(($49)>>2)]=$47;
      __label__ = 28; break;
    case 18: // $50
      var $51=$5;
      var $52=(($51)|0)==2048;
      if ($52) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $53
      var $54=$4;
      var $55=(($54)&255);
      var $56=(($55)|0)==2;
      if ($56) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $57
      var $60 = 62;__label__ = 22; break;
    case 21: // $58
      var $60 = 64;__label__ = 22; break;
    case 22: // $59
      var $60;
      var $61=$3;
      var $62=$61;
      HEAP32[(($62)>>2)]=$60;
      __label__ = 27; break;
    case 23: // $63
      var $64=$5;
      var $65=(($64)|0)==4096;
      if ($65) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $66
      var $67=$3;
      var $68=$67;
      HEAP32[(($68)>>2)]=40;
      __label__ = 26; break;
    case 25: // $69
      __Z10fatalerrorPKcz(((STRING_TABLE.__str22184)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 26: // $70
      __label__ = 27; break;
    case 27: // $71
      __label__ = 28; break;
    case 28: // $72
      __label__ = 29; break;
    case 29: // $73
      __label__ = 59; break;
    case 30: // $74
      var $75=$4;
      var $76=(($75)&255);
      var $77=(($76)|0)==2;
      if ($77) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $78
      var $79=$3;
      var $80=$79;
      HEAP32[(($80)>>2)]=42;
      __label__ = 33; break;
    case 32: // $81
      var $82=$3;
      var $83=$82;
      HEAP32[(($83)>>2)]=44;
      __label__ = 33; break;
    case 33: // $84
      __label__ = 59; break;
    case 34: // $85
      var $86=$5;
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $88
      var $89=$3;
      var $90=$89;
      HEAP32[(($90)>>2)]=0;
      __label__ = 46; break;
    case 36: // $91
      var $92=$5;
      var $93=(($92)|0)==1024;
      if ($93) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $94
      var $95=$3;
      var $96=$95;
      HEAP32[(($96)>>2)]=46;
      __label__ = 45; break;
    case 38: // $97
      var $98=$5;
      var $99=(($98)|0)==2048;
      if ($99) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $100
      var $101=$3;
      var $102=$101;
      HEAP32[(($102)>>2)]=48;
      __label__ = 44; break;
    case 40: // $103
      var $104=$5;
      var $105=(($104)|0)==4096;
      if ($105) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $106
      var $107=$3;
      var $108=$107;
      HEAP32[(($108)>>2)]=50;
      __label__ = 43; break;
    case 42: // $109
      __Z10fatalerrorPKcz(((STRING_TABLE.__str21183)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 43: // $110
      __label__ = 44; break;
    case 44: // $111
      __label__ = 45; break;
    case 45: // $112
      __label__ = 46; break;
    case 46: // $113
      __label__ = 59; break;
    case 47: // $114
      var $115=$6;
      var $116=(($115)|0)==64;
      if ($116) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $117
      var $118=$3;
      var $119=$118;
      HEAP32[(($119)>>2)]=52;
      __label__ = 56; break;
    case 49: // $120
      var $121=$6;
      var $122=(($121)|0)==128;
      if ($122) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $123
      var $124=$3;
      var $125=$124;
      HEAP32[(($125)>>2)]=54;
      __label__ = 55; break;
    case 51: // $126
      var $127=$6;
      var $128=(($127)|0)==256;
      if ($128) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $129
      var $130=$3;
      var $131=$130;
      HEAP32[(($131)>>2)]=56;
      __label__ = 54; break;
    case 53: // $132
      __Z10fatalerrorPKcz(((STRING_TABLE.__str21183)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 54: // $133
      __label__ = 55; break;
    case 55: // $134
      __label__ = 56; break;
    case 56: // $135
      __label__ = 59; break;
    case 57: // $136
      var $137=$3;
      var $138=$137;
      var $139=HEAP32[(($138)>>2)];
      var $140=$7;
      var $141=_strcpy($139, $140);
      __label__ = 59; break;
    case 58: // $142
      var $143=$1;
      var $144=$2;
      var $145=$3;
      __ZL18cpu_get_info_mcs48P17legacy_cpu_devicejP7cpuinfo($143, $144, $145);
      __label__ = 59; break;
    case 59: // $146
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22mcs48_generic_get_infoP17legacy_cpu_devicejP7cpuinfohiiPKc["X"]=1;

function __Z21legacy_device_creatorI12i8748_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=7240;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str20182)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12i8748_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 66, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI12i8748_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str20182)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI12i8748_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZNK17legacy_cpu_device19memory_space_configE16address_spacenum($this, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$spacenum;
      var $3=$1;
      var $4=$2;
      var $5=(($4)>>>0) < 3;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($3+7104)|0);
      var $9=(($8+$7*24)|0);
      var $10=(($9+9)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$2;
      var $16=(($3+7104)|0);
      var $17=(($16+$15*24)|0);
      var $20 = $17;__label__ = 4; break;
    case 3: // $18
      var $20 = 0;__label__ = 4; break;
    case 4: // $19
      var $20;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12i8049_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN17legacy_cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPS_jP7cpuinfoE($8, $9, $10, $11, $12, $13, 74);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV12i8049_device+8)|0);
  var $15=$7;
  var $16=(($15+356)|0);
  var $17=$16;
  HEAP32[(($17)>>2)]=((__ZTV12i8049_device+156)|0);
  var $18=$7;
  var $19=(($18+5968)|0);
  var $20=$19;
  HEAP32[(($20)>>2)]=((__ZTV12i8049_device+256)|0);
  var $21=$7;
  var $22=(($21+6012)|0);
  var $23=$22;
  HEAP32[(($23)>>2)]=((__ZTV12i8049_device+340)|0);
  var $24=$7;
  var $25=(($24+7088)|0);
  var $26=$25;
  HEAP32[(($26)>>2)]=((__ZTV12i8049_device+420)|0);
  ;
  return;
}


function __ZNK17legacy_cpu_device17device_rom_regionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_ptrEj($2, 65536);
  var $4=$3;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device24device_mconfig_additionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_ptrEj($2, 65537);
  var $4=$3;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device18device_input_portsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_ptrEj($2, 65538);
  var $4=$3;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device18execute_min_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_intEj($2, 16391);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device18execute_max_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_intEj($2, 16392);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device19execute_input_linesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_intEj($2, 16385);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device26execute_default_irq_vectorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_intEj($2, 16386);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZN17legacy_cpu_device17execute_set_inputEii($this, $inputnum, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$inputnum;
  $3=$state;
  var $4=$1;
  var $5=$2;
  var $6=(($5+16401)|0);
  var $7=$3;
  var $8$0=$7;
  var $8$1=(($7|0) < 0 ? -1 : 0);
  __ZN17legacy_cpu_device14set_legacy_intEjx($4, $6, $8$0, $8$1);
  ;
  return;
}


function __ZNK17legacy_cpu_device23disasm_min_opcode_bytesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_intEj($2, 16389);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZNK17legacy_cpu_device23disasm_max_opcode_bytesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK17legacy_cpu_device14get_legacy_intEj($2, 16390);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZThn356_NK17legacy_cpu_device18execute_min_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  var $6=__ZNK17legacy_cpu_device18execute_min_cyclesEv($5);
  ;
  return $6;
}


function __ZThn356_NK17legacy_cpu_device18execute_max_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  var $6=__ZNK17legacy_cpu_device18execute_max_cyclesEv($5);
  ;
  return $6;
}


function __ZThn356_NK17legacy_cpu_device19execute_input_linesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  var $6=__ZNK17legacy_cpu_device19execute_input_linesEv($5);
  ;
  return $6;
}


function __ZThn356_NK17legacy_cpu_device26execute_default_irq_vectorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  var $6=__ZNK17legacy_cpu_device26execute_default_irq_vectorEv($5);
  ;
  return $6;
}


function __ZThn356_N17legacy_cpu_device17execute_set_inputEii($this, $inputnum, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$inputnum;
  $3=$state;
  var $4=$1;
  var $5=$4;
  var $6=(($5-356)|0);
  var $7=$6;
  var $8=$2;
  var $9=$3;
  __ZN17legacy_cpu_device17execute_set_inputEii($7, $8, $9);
  ;
  return;
}


function __ZThn5968_NK17legacy_cpu_device19memory_space_configE16address_spacenum($this, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$spacenum;
  var $3=$1;
  var $4=$3;
  var $5=(($4-5968)|0);
  var $6=$5;
  var $7=$2;
  var $8=__ZNK17legacy_cpu_device19memory_space_configE16address_spacenum($6, $7);
  ;
  return $8;
}


function __ZThn7088_NK17legacy_cpu_device23disasm_min_opcode_bytesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  var $6=__ZNK17legacy_cpu_device23disasm_min_opcode_bytesEv($5);
  ;
  return $6;
}


function __ZThn7088_NK17legacy_cpu_device23disasm_max_opcode_bytesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  var $6=__ZNK17legacy_cpu_device23disasm_max_opcode_bytesEv($5);
  ;
  return $6;
}


function __ZN12i8049_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12i8049_deviceD2Ev($2);
  ;
  return;
}


function __ZThn356_N12i8049_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN12i8049_deviceD1Ev($5);
  ;
  return;
}


function __ZThn356_N12i8049_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN12i8049_deviceD0Ev($5);
  ;
  return;
}


function __ZThn5968_N12i8049_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN12i8049_deviceD1Ev($5);
  ;
  return;
}


function __ZThn5968_N12i8049_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN12i8049_deviceD0Ev($5);
  ;
  return;
}


function __ZThn6012_N12i8049_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN12i8049_deviceD1Ev($5);
  ;
  return;
}


function __ZThn6012_N12i8049_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN12i8049_deviceD0Ev($5);
  ;
  return;
}


function __ZThn7088_N12i8049_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN12i8049_deviceD1Ev($5);
  ;
  return;
}


function __ZThn7088_N12i8049_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN12i8049_deviceD0Ev($5);
  ;
  return;
}


function __ZN12i8748_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12i8748_deviceD2Ev($2);
  ;
  return;
}


function __ZThn356_N12i8748_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN12i8748_deviceD1Ev($5);
  ;
  return;
}


function __ZThn356_N12i8748_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN12i8748_deviceD0Ev($5);
  ;
  return;
}


function __ZThn5968_N12i8748_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN12i8748_deviceD1Ev($5);
  ;
  return;
}


function __ZThn5968_N12i8748_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN12i8748_deviceD0Ev($5);
  ;
  return;
}


function __ZThn6012_N12i8748_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN12i8748_deviceD1Ev($5);
  ;
  return;
}


function __ZThn6012_N12i8748_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN12i8748_deviceD0Ev($5);
  ;
  return;
}


function __ZThn7088_N12i8748_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN12i8748_deviceD1Ev($5);
  ;
  return;
}


function __ZThn7088_N12i8748_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN12i8748_deviceD0Ev($5);
  ;
  return;
}


function __ZN12i8748_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17legacy_cpu_deviceD2Ev($3);
  ;
  return;
}


function __ZN12i8049_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17legacy_cpu_deviceD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI12i8049_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12i8049_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12i8049_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 7240);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12i8049_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __Z21legacy_device_creatorI12i8049_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=7240;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str20182)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12i8049_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 72, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI12i8049_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str20182)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI12i8049_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN12i8049_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN12i8049_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12i8049_deviceD0Ev["X"]=1;

function __ZN12i8748_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN12i8748_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12i8748_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI12i8049_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12i8049_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12i8049_deviceEEPT_S3_["X"]=1;

function __ZNK17legacy_cpu_device5tokenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+7176)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectI12i8049_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12i8049_deviceED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12i8748_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12i8748_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12i8748_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 7240);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12i8748_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12i8748_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12i8748_deviceED2Ev($2);
  ;
  return;
}


function __ZL20cpu_init_mcs48_noromP17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqcallback;
  var $3=$1;
  var $4=$2;
  __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($3, $4, 1, 0);
  ;
  return;
}


function __ZL21cpu_init_upi41_1k_romP17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqcallback;
  var $3=$1;
  var $4=$2;
  __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($3, $4, 2, 1024);
  ;
  return;
}


function __ZL21cpu_init_mcs48_1k_romP17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqcallback;
  var $3=$1;
  var $4=$2;
  __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($3, $4, 1, 1024);
  ;
  return;
}


function __ZL21cpu_init_upi41_2k_romP17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqcallback;
  var $3=$1;
  var $4=$2;
  __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($3, $4, 2, 2048);
  ;
  return;
}


function __ZL21cpu_init_mcs48_2k_romP17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqcallback;
  var $3=$1;
  var $4=$2;
  __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($3, $4, 1, 2048);
  ;
  return;
}


function __ZL21cpu_init_mcs48_4k_romP17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqcallback;
  var $3=$1;
  var $4=$2;
  __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($3, $4, 1, 4096);
  ;
  return;
}


function __ZL35construct_address_map_program_10bitR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 0, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 1023, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 2);
  ;
  return;
}


function __ZL35construct_address_map_program_11bitR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 0, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 2047, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 2);
  ;
  return;
}


function __ZL35construct_address_map_program_12bitR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 0, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 4095, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 2);
  ;
  return;
}


function __ZL31construct_address_map_data_6bitR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 1, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 63, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 1);
  var $9=$curentry;
  var $10=$9;
  __ZN17address_map_entry14set_write_typeE16map_handler_type($10, 1);
  ;
  return;
}


function __ZL31construct_address_map_data_7bitR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 1, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 127, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 1);
  var $9=$curentry;
  var $10=$9;
  __ZN17address_map_entry14set_write_typeE16map_handler_type($10, 1);
  ;
  return;
}


function __ZL31construct_address_map_data_8bitR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 1, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 255, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($8, 1);
  var $9=$curentry;
  var $10=$9;
  __ZN17address_map_entry14set_write_typeE16map_handler_type($10, 1);
  ;
  return;
}


function __ZL18cpu_get_info_mcs48P17legacy_cpu_devicejP7cpuinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cpustate;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$1;
      var $8=__ZNK17legacy_cpu_device5tokenEv($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$1;
      var $12=$11;
      var $13=__ZL14get_safe_tokenP8device_t($12);
      var $16 = $13;__label__ = 4; break;
    case 3: // $14
      var $16 = 0;__label__ = 4; break;
    case 4: // $15
      var $16;
      $cpustate=$16;
      var $17=$2;
      if ($17 == 16384) {
        __label__ = 5; break;
      }
      else if ($17 == 16385) {
        __label__ = 6; break;
      }
      else if ($17 == 16386) {
        __label__ = 7; break;
      }
      else if ($17 == 2) {
        __label__ = 8; break;
      }
      else if ($17 == 16387) {
        __label__ = 9; break;
      }
      else if ($17 == 16388) {
        __label__ = 10; break;
      }
      else if ($17 == 16389) {
        __label__ = 11; break;
      }
      else if ($17 == 16390) {
        __label__ = 12; break;
      }
      else if ($17 == 16391) {
        __label__ = 13; break;
      }
      else if ($17 == 16392) {
        __label__ = 14; break;
      }
      else if ($17 == 3) {
        __label__ = 15; break;
      }
      else if ($17 == 7) {
        __label__ = 16; break;
      }
      else if ($17 == 11) {
        __label__ = 17; break;
      }
      else if ($17 == 4) {
        __label__ = 18; break;
      }
      else if ($17 == 8 || $17 == 147457 || $17 == 65539 || $17 == 65540 || $17 == 196608) {
        __label__ = 37; break;
      }
      else if ($17 == 12) {
        __label__ = 19; break;
      }
      else if ($17 == 5) {
        __label__ = 20; break;
      }
      else if ($17 == 9) {
        __label__ = 21; break;
      }
      else if ($17 == 13) {
        __label__ = 22; break;
      }
      else if ($17 == 16401) {
        __label__ = 23; break;
      }
      else if ($17 == 16402) {
        __label__ = 24; break;
      }
      else if ($17 == 147456) {
        __label__ = 25; break;
      }
      else if ($17 == 147458) {
        __label__ = 26; break;
      }
      else if ($17 == 147460) {
        __label__ = 27; break;
      }
      else if ($17 == 147462) {
        __label__ = 28; break;
      }
      else if ($17 == 147468) {
        __label__ = 29; break;
      }
      else if ($17 == 147469) {
        __label__ = 30; break;
      }
      else if ($17 == 147471) {
        __label__ = 31; break;
      }
      else if ($17 == 81920) {
        __label__ = 32; break;
      }
      else if ($17 == 196610) {
        __label__ = 33; break;
      }
      else if ($17 == 196611) {
        __label__ = 34; break;
      }
      else if ($17 == 196612) {
        __label__ = 35; break;
      }
      else if ($17 == 196613) {
        __label__ = 36; break;
      }
      else {
      __label__ = 37; break;
      }
      
    case 5: // $18
      var $19=$3;
      var $20=$19;
      var $$emscripten$temp$0$0=72;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($20)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($20+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 37; break;
    case 6: // $21
      var $22=$3;
      var $23=$22;
      var $$emscripten$temp$1$0=2;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($23)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($23+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 37; break;
    case 7: // $24
      var $25=$3;
      var $26=$25;
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$4$0=(($26)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$2$0;
      var $st$4$1=(($26+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 37; break;
    case 8: // $27
      var $28=$3;
      var $29=$28;
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$4$0=(($29)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$3$0;
      var $st$4$1=(($29+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 37; break;
    case 9: // $30
      var $31=$3;
      var $32=$31;
      var $$emscripten$temp$4$0=1;
      var $$emscripten$temp$4$1=0;
      var $st$4$0=(($32)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$4$0;
      var $st$4$1=(($32+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 37; break;
    case 10: // $33
      var $34=$3;
      var $35=$34;
      var $$emscripten$temp$5$0=15;
      var $$emscripten$temp$5$1=0;
      var $st$4$0=(($35)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$5$0;
      var $st$4$1=(($35+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 37; break;
    case 11: // $36
      var $37=$3;
      var $38=$37;
      var $$emscripten$temp$6$0=1;
      var $$emscripten$temp$6$1=0;
      var $st$4$0=(($38)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$6$0;
      var $st$4$1=(($38+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$6$1;
      __label__ = 37; break;
    case 12: // $39
      var $40=$3;
      var $41=$40;
      var $$emscripten$temp$7$0=2;
      var $$emscripten$temp$7$1=0;
      var $st$4$0=(($41)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$7$0;
      var $st$4$1=(($41+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$7$1;
      __label__ = 37; break;
    case 13: // $42
      var $43=$3;
      var $44=$43;
      var $$emscripten$temp$8$0=1;
      var $$emscripten$temp$8$1=0;
      var $st$4$0=(($44)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$8$0;
      var $st$4$1=(($44+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$8$1;
      __label__ = 37; break;
    case 14: // $45
      var $46=$3;
      var $47=$46;
      var $$emscripten$temp$9$0=3;
      var $$emscripten$temp$9$1=0;
      var $st$4$0=(($47)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$9$0;
      var $st$4$1=(($47+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$9$1;
      __label__ = 37; break;
    case 15: // $48
      var $49=$3;
      var $50=$49;
      var $$emscripten$temp$10$0=8;
      var $$emscripten$temp$10$1=0;
      var $st$4$0=(($50)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$10$0;
      var $st$4$1=(($50+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$10$1;
      __label__ = 37; break;
    case 16: // $51
      var $52=$3;
      var $53=$52;
      var $$emscripten$temp$11$0=12;
      var $$emscripten$temp$11$1=0;
      var $st$4$0=(($53)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$11$0;
      var $st$4$1=(($53+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$11$1;
      __label__ = 37; break;
    case 17: // $54
      var $55=$3;
      var $56=$55;
      var $$emscripten$temp$12$0=0;
      var $$emscripten$temp$12$1=0;
      var $st$4$0=(($56)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$12$0;
      var $st$4$1=(($56+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$12$1;
      __label__ = 37; break;
    case 18: // $57
      var $58=$3;
      var $59=$58;
      var $$emscripten$temp$13$0=8;
      var $$emscripten$temp$13$1=0;
      var $st$4$0=(($59)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$13$0;
      var $st$4$1=(($59+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$13$1;
      __label__ = 37; break;
    case 19: // $60
      var $61=$3;
      var $62=$61;
      var $$emscripten$temp$14$0=0;
      var $$emscripten$temp$14$1=0;
      var $st$4$0=(($62)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$14$0;
      var $st$4$1=(($62+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$14$1;
      __label__ = 37; break;
    case 20: // $63
      var $64=$3;
      var $65=$64;
      var $$emscripten$temp$15$0=8;
      var $$emscripten$temp$15$1=0;
      var $st$4$0=(($65)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$15$0;
      var $st$4$1=(($65+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$15$1;
      __label__ = 37; break;
    case 21: // $66
      var $67=$3;
      var $68=$67;
      var $$emscripten$temp$16$0=9;
      var $$emscripten$temp$16$1=0;
      var $st$4$0=(($68)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$16$0;
      var $st$4$1=(($68+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$16$1;
      __label__ = 37; break;
    case 22: // $69
      var $70=$3;
      var $71=$70;
      var $$emscripten$temp$17$0=0;
      var $$emscripten$temp$17$1=0;
      var $st$4$0=(($71)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$17$0;
      var $st$4$1=(($71+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$17$1;
      __label__ = 37; break;
    case 23: // $72
      var $73=$cpustate;
      var $74=(($73+22)|0);
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24)!=0;
      var $77=$76 ? 1 : 0;
      var $78$0=$77;
      var $78$1=0;
      var $79=$3;
      var $80=$79;
      var $st$9$0=(($80)|0);
      HEAP32[(($st$9$0)>>2)]=$78$0;
      var $st$9$1=(($80+4)|0);
      HEAP32[(($st$9$1)>>2)]=$78$1;
      __label__ = 37; break;
    case 24: // $81
      var $82=$cpustate;
      var $83=(($82+15)|0);
      var $84=HEAP8[($83)];
      var $85$0=$84;
      var $85$1=0;
      var $86=$3;
      var $87=$86;
      var $st$7$0=(($87)|0);
      HEAP32[(($st$7$0)>>2)]=$85$0;
      var $st$7$1=(($87+4)|0);
      HEAP32[(($st$7$1)>>2)]=$85$1;
      __label__ = 37; break;
    case 25: // $88
      var $89=$3;
      var $90=$89;
      HEAP32[(($90)>>2)]=76;
      __label__ = 37; break;
    case 26: // $91
      var $92=$3;
      var $93=$92;
      HEAP32[(($93)>>2)]=78;
      __label__ = 37; break;
    case 27: // $94
      var $95=$3;
      var $96=$95;
      HEAP32[(($96)>>2)]=80;
      __label__ = 37; break;
    case 28: // $97
      var $98=$3;
      var $99=$98;
      HEAP32[(($99)>>2)]=44;
      __label__ = 37; break;
    case 29: // $100
      var $101=$3;
      var $102=$101;
      HEAP32[(($102)>>2)]=82;
      __label__ = 37; break;
    case 30: // $103
      var $104=$3;
      var $105=$104;
      HEAP32[(($105)>>2)]=84;
      __label__ = 37; break;
    case 31: // $106
      var $107=$3;
      var $108=$107;
      HEAP32[(($108)>>2)]=86;
      __label__ = 37; break;
    case 32: // $109
      var $110=$cpustate;
      var $111=(($110+44)|0);
      var $112=$3;
      var $113=$112;
      HEAP32[(($113)>>2)]=$111;
      __label__ = 37; break;
    case 33: // $114
      var $115=$3;
      var $116=$115;
      var $117=HEAP32[(($116)>>2)];
      var $118=_strcpy($117, ((STRING_TABLE.__str23185)|0));
      __label__ = 37; break;
    case 34: // $119
      var $120=$3;
      var $121=$120;
      var $122=HEAP32[(($121)>>2)];
      var $123=_strcpy($122, ((STRING_TABLE.__str24186)|0));
      __label__ = 37; break;
    case 35: // $124
      var $125=$3;
      var $126=$125;
      var $127=HEAP32[(($126)>>2)];
      var $128=_strcpy($127, ((STRING_TABLE.__str25187)|0));
      __label__ = 37; break;
    case 36: // $129
      var $130=$3;
      var $131=$130;
      var $132=HEAP32[(($131)>>2)];
      var $133=_strcpy($132, ((STRING_TABLE.__str26188)|0));
      __label__ = 37; break;
    case 37: // $134
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18cpu_get_info_mcs48P17legacy_cpu_devicejP7cpuinfo["X"]=1;

function __ZN20resource_pool_objectI12i8049_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12i8049_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12i8049_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI12i8049_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI12i8049_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI12i8748_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12i8748_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12i8748_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI12i8748_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12i8748_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12i8748_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI12i8748_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI12i8748_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL3nopP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  ;
  return 1;
}


function __ZNK18device_state_entry5indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL5dec_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=(($4-1)&255);
  HEAP8[($3)]=$5;
  ;
  return 1;
}


function __ZL18cpu_set_info_mcs48P17legacy_cpu_devicejP7cpuinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cpustate;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$1;
      var $5=$4;
      var $6=__ZL14get_safe_tokenP8device_t($5);
      $cpustate=$6;
      var $7=$2;
      if ($7 == 16401) {
        __label__ = 1; break;
      }
      else if ($7 == 16402) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      var $9=$3;
      var $10=$9;
      var $st$2$0=(($10)|0);
      var $11$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($10+4)|0);
      var $11$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $12=$11$0 != $$emscripten$temp$0$0 || $11$1 != $$emscripten$temp$0$1;
      var $13=(($12)&1);
      var $14=$cpustate;
      var $15=(($14+22)|0);
      HEAP8[($15)]=$13;
      __label__ = 3; break;
    case 2: // $16
      var $17=$3;
      var $18=$17;
      var $st$2$0=(($18)|0);
      var $19$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $20=$19$0 != $$emscripten$temp$1$0 || $19$1 != $$emscripten$temp$1$1;
      var $21=(($20)&1);
      var $22=$cpustate;
      var $23=(($22+15)|0);
      HEAP8[($23)]=$21;
      __label__ = 3; break;
    case 3: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15cpu_reset_mcs48P17legacy_cpu_device($device) {
  ;
  var __label__;

  var $1;
  var $cpustate;
  $1=$device;
  var $2=$1;
  var $3=$2;
  var $4=__ZL14get_safe_tokenP8device_t($3);
  $cpustate=$4;
  var $5=$cpustate;
  var $6=(($5+2)|0);
  HEAP16[(($6)>>1)]=0;
  var $7=$cpustate;
  var $8=(($7+12)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 & 192;
  var $12=$11 | 8;
  var $13=(($12) & 255);
  var $14=$cpustate;
  var $15=(($14+12)|0);
  HEAP8[($15)]=$13;
  var $16=$cpustate;
  var $17=(($16+32)|0);
  HEAP16[(($17)>>1)]=0;
  var $18=$cpustate;
  var $19=(($18+60)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  FUNCTION_TABLE[$24]($20, 288, -1);
  var $25=$cpustate;
  var $26=(($25+13)|0);
  HEAP8[($26)]=-1;
  var $27=$cpustate;
  var $28=(($27+14)|0);
  HEAP8[($28)]=-1;
  var $29=$cpustate;
  var $30=(($29+60)|0);
  var $31=HEAP32[(($30)>>2)];
  var $32=$31;
  var $33=HEAP32[(($32)>>2)];
  var $34=(($33+80)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$cpustate;
  var $37=(($36+13)|0);
  var $38=HEAP8[($37)];
  FUNCTION_TABLE[$35]($31, 257, $38);
  var $39=$cpustate;
  var $40=(($39+60)|0);
  var $41=HEAP32[(($40)>>2)];
  var $42=$41;
  var $43=HEAP32[(($42)>>2)];
  var $44=(($43+80)|0);
  var $45=HEAP32[(($44)>>2)];
  var $46=$cpustate;
  var $47=(($46+14)|0);
  var $48=HEAP8[($47)];
  FUNCTION_TABLE[$45]($41, 258, $48);
  var $49=$cpustate;
  var $50=(($49+26)|0);
  HEAP8[($50)]=0;
  var $51=$cpustate;
  var $52=(($51+27)|0);
  HEAP8[($52)]=0;
  var $53=$cpustate;
  var $54=(($53+28)|0);
  HEAP8[($54)]=0;
  var $55=$cpustate;
  var $56=(($55+25)|0);
  HEAP8[($56)]=0;
  var $57=$cpustate;
  var $58=(($57+19)|0);
  HEAP8[($58)]=0;
  var $59=$cpustate;
  var $60=(($59+29)|0);
  HEAP8[($60)]=0;
  var $61=$cpustate;
  var $62=(($61+30)|0);
  HEAP8[($62)]=0;
  var $63=$cpustate;
  var $64=(($63+23)|0);
  HEAP8[($64)]=0;
  var $65=$cpustate;
  var $66=(($65+24)|0);
  HEAP8[($66)]=0;
  ;
  return;
}
__ZL15cpu_reset_mcs48P17legacy_cpu_device["X"]=1;

function __ZL17cpu_execute_mcs48P17legacy_cpu_device($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cpustate;
      var $curcycles;
      var $opcode;
      $1=$device;
      var $2=$1;
      var $3=$2;
      var $4=__ZL14get_safe_tokenP8device_t($3);
      $cpustate=$4;
      var $5=$cpustate;
      __ZL13update_regptrP12_mcs48_state($5);
      var $6=$cpustate;
      var $7=__ZL10check_irqsP12_mcs48_state($6);
      $curcycles=$7;
      var $8=$curcycles;
      var $9=$cpustate;
      var $10=(($9+44)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11-$8)|0);
      HEAP32[(($10)>>2)]=$12;
      var $13=$cpustate;
      var $14=(($13+28)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$cpustate;
      var $20=$curcycles;
      __ZL11burn_cyclesP12_mcs48_statei($19, $20);
      __label__ = 2; break;
    case 2: // $21
      __label__ = 3; break;
    case 3: // $22
      var $23=$cpustate;
      var $24=(($23+2)|0);
      var $25=HEAP16[(($24)>>1)];
      var $26=$cpustate;
      var $27=(($26)|0);
      HEAP16[(($27)>>1)]=$25;
      var $28=$1;
      var $29=$28;
      var $30=$cpustate;
      var $31=(($30+2)|0);
      var $32=HEAPU16[(($31)>>1)];
      var $33=(($32)&65535);
      __ZL25debugger_instruction_hookP8device_tj($29, $33);
      var $34=$cpustate;
      var $35=__ZL12opcode_fetchP12_mcs48_state($34);
      var $36=(($35)&255);
      $opcode=$36;
      var $37=$opcode;
      var $38=((__ZL12opcode_table+($37<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$cpustate;
      var $41=FUNCTION_TABLE[$39]($40);
      $curcycles=$41;
      var $42=$curcycles;
      var $43=$cpustate;
      var $44=(($43+44)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-$42)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$cpustate;
      var $48=(($47+28)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $52
      var $53=$cpustate;
      var $54=$curcycles;
      __ZL11burn_cyclesP12_mcs48_statei($53, $54);
      __label__ = 5; break;
    case 5: // $55
      __label__ = 6; break;
    case 6: // $56
      var $57=$cpustate;
      var $58=(($57+44)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0) > 0;
      if ($60) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 7: // $61
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17cpu_execute_mcs48P17legacy_cpu_device["X"]=1;

function __ZL23cpu_string_export_mcs48P17legacy_cpu_deviceRK18device_state_entryR7astring($device, $entry, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cpustate;
      $1=$device;
      $2=$entry;
      $3=$string;
      var $4=$1;
      var $5=$4;
      var $6=__ZL14get_safe_tokenP8device_t($5);
      $cpustate=$6;
      var $7=$2;
      var $8=__ZNK18device_state_entry5indexEv($7);
      if ($8 == 212998) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $9
      var $10=$3;
      var $11=$cpustate;
      var $12=(($11+22)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24)!=0;
      var $15=$14 ? 73 : 46;
      var $16=(($15 << 24) >> 24);
      var $17=$cpustate;
      var $18=(($17+32)|0);
      var $19=HEAP16[(($18)>>1)];
      var $20=(($19 << 16) >> 16)!=0;
      var $21=$20 ? 77 : 46;
      var $22=(($21 << 24) >> 24);
      var $23=$cpustate;
      var $24=(($23+12)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & 128;
      var $28=(($27)|0)!=0;
      var $29=$28 ? 67 : 46;
      var $30=(($29 << 24) >> 24);
      var $31=$cpustate;
      var $32=(($31+12)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$34 & 64;
      var $36=(($35)|0)!=0;
      var $37=$36 ? 65 : 46;
      var $38=(($37 << 24) >> 24);
      var $39=$cpustate;
      var $40=(($39+12)|0);
      var $41=HEAPU8[($40)];
      var $42=(($41)&255);
      var $43=$42 & 32;
      var $44=(($43)|0)!=0;
      var $45=$44 ? 70 : 46;
      var $46=(($45 << 24) >> 24);
      var $47=$cpustate;
      var $48=(($47+12)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 & 16;
      var $52=(($51)|0)!=0;
      var $53=$52 ? 66 : 46;
      var $54=(($53 << 24) >> 24);
      var $55=$cpustate;
      var $56=(($55+12)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=$58 & 8;
      var $60=(($59)|0)!=0;
      var $61=$60 ? 63 : 46;
      var $62=(($61 << 24) >> 24);
      var $63=$cpustate;
      var $64=(($63+12)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=$66 & 4;
      var $68=(($67)|0)!=0;
      var $69=$68 ? 52 : 46;
      var $70=(($69 << 24) >> 24);
      var $71=$cpustate;
      var $72=(($71+12)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$74 & 2;
      var $76=(($75)|0)!=0;
      var $77=$76 ? 50 : 46;
      var $78=(($77 << 24) >> 24);
      var $79=$cpustate;
      var $80=(($79+12)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=$82 & 1;
      var $84=(($83)|0)!=0;
      var $85=$84 ? 49 : 46;
      var $86=(($85 << 24) >> 24);
      var $87=__ZN7astring6printfEPKcz($10, ((STRING_TABLE.__str27189)|0), (tempInt=STACKTOP,STACKTOP += 40,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,HEAP32[((tempInt+4)>>2)]=$22,HEAP32[((tempInt+8)>>2)]=$30,HEAP32[((tempInt+12)>>2)]=$38,HEAP32[((tempInt+16)>>2)]=$46,HEAP32[((tempInt+20)>>2)]=$54,HEAP32[((tempInt+24)>>2)]=$62,HEAP32[((tempInt+28)>>2)]=$70,HEAP32[((tempInt+32)>>2)]=$78,HEAP32[((tempInt+36)>>2)]=$86,tempInt));
      __label__ = 2; break;
    case 2: // $88
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23cpu_string_export_mcs48P17legacy_cpu_deviceRK18device_state_entryR7astring["X"]=1;

function __ZN7astring6printfEPKcz($this, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $ap=__stackBase__;
  var $result;
  $1=$this;
  $2=$format;
  var $3=$1;
  var $4=$ap;
  HEAP32[(($4)>>2)]=arguments[__ZN7astring6printfEPKcz.length];
  var $5=$2;
  var $6=HEAP32[(($ap)>>2)];
  var $7=__Z15astring_vprintfP7astringPKcPc($3, $5, $6);
  $result=$7;
  var $8=$ap;
  ;
  var $9=$result;
  STACKTOP = __stackBase__;
  return $9;
}


function __ZL13update_regptrP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+24)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 & 16;
  var $14=(($13)|0)!=0;
  var $15=$14 ? 24 : 0;
  var $16=FUNCTION_TABLE[$8]($4, $15);
  var $17=$1;
  var $18=(($17+8)|0);
  HEAP32[(($18)>>2)]=$16;
  ;
  return;
}


function __ZL10check_irqsP12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$cpustate;
      var $3=$2;
      var $4=(($3+23)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 12; break;
    case 2: // $8
      var $9=$2;
      var $10=(($9+22)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$2;
      var $15=(($14+19)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 2;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $20
      var $21=$2;
      var $22=(($21+27)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $25
      var $26=$2;
      var $27=(($26+23)|0);
      HEAP8[($27)]=1;
      var $28=$2;
      __ZL11push_pc_pswP12_mcs48_state($28);
      var $29=$2;
      var $30=(($29+2)|0);
      HEAP16[(($30)>>1)]=3;
      var $31=$2;
      var $32=(($31+36)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=$2;
      var $37=(($36+36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=(($39+40)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$41;
      var $43=FUNCTION_TABLE[$38]($42, 0);
      __label__ = 7; break;
    case 7: // $44
      $1=2;
      __label__ = 12; break;
    case 8: // $45
      var $46=$2;
      var $47=(($46+24)|0);
      var $48=HEAP8[($47)];
      var $49=(($48 << 24) >> 24)!=0;
      if ($49) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $50
      var $51=$2;
      var $52=(($51+26)|0);
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24)!=0;
      if ($54) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $55
      var $56=$2;
      var $57=(($56+23)|0);
      HEAP8[($57)]=1;
      var $58=$2;
      __ZL11push_pc_pswP12_mcs48_state($58);
      var $59=$2;
      var $60=(($59+2)|0);
      HEAP16[(($60)>>1)]=7;
      var $61=$2;
      var $62=(($61+24)|0);
      HEAP8[($62)]=0;
      $1=2;
      __label__ = 12; break;
    case 11: // $63
      $1=0;
      __label__ = 12; break;
    case 12: // $64
      var $65=$1;
      ;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10check_irqsP12_mcs48_state["X"]=1;

function __ZL11burn_cyclesP12_mcs48_statei($cpustate, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $timerover;
      var $oldtimer;
      $1=$cpustate;
      $2=$count;
      $timerover=0;
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$6 & 1;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=HEAP8[($11)];
      $oldtimer=$12;
      var $13=$2;
      var $14=$1;
      var $15=(($14+17)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=(($17+$13)|0);
      var $19=(($18) & 255);
      HEAP8[($15)]=$19;
      var $20=$1;
      var $21=(($20+17)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 >> 5;
      var $25=$1;
      var $26=(($25+16)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28+$24)|0);
      var $30=(($29) & 255);
      HEAP8[($26)]=$30;
      var $31=$1;
      var $32=(($31+17)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$34 & 31;
      var $36=(($35) & 255);
      HEAP8[($32)]=$36;
      var $37=$oldtimer;
      var $38=(($37)&255);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 2; break; } else { var $47 = 0;__label__ = 3; break; }
    case 2: // $40
      var $41=$1;
      var $42=(($41+16)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==0;
      var $47 = $45;__label__ = 3; break;
    case 3: // $46
      var $47;
      var $48=(($47)&1);
      $timerover=$48;
      __label__ = 13; break;
    case 4: // $49
      var $50=$1;
      var $51=(($50+28)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$53 & 2;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $56
      __label__ = 6; break;
    case 6: // $57
      var $58=$2;
      var $59=(($58)|0) > 0;
      if ($59) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $60
      var $61=$1;
      var $62=(($61+18)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=$64 << 1;
      var $66=$1;
      var $67=(($66+60)|0);
      var $68=HEAPU32[(($67)>>2)];
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+28)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=FUNCTION_TABLE[$72]($68, 273);
      var $74=(($73)&255);
      var $75=$74 & 1;
      var $76=$65 | $75;
      var $77=(($76) & 255);
      var $78=$1;
      var $79=(($78+18)|0);
      HEAP8[($79)]=$77;
      var $80=$1;
      var $81=(($80+18)|0);
      var $82=HEAPU8[($81)];
      var $83=(($82)&255);
      var $84=$83 & 3;
      var $85=(($84)|0)==2;
      if ($85) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $86
      var $87=$1;
      var $88=(($87+16)|0);
      var $89=HEAP8[($88)];
      var $90=(($89+1)&255);
      HEAP8[($88)]=$90;
      var $91=(($90)&255);
      var $92=(($91)|0)==0;
      var $93=(($92)&1);
      $timerover=$93;
      __label__ = 9; break;
    case 9: // $94
      __label__ = 10; break;
    case 10: // $95
      var $96=$2;
      var $97=(($96-1)|0);
      $2=$97;
      __label__ = 6; break;
    case 11: // $98
      __label__ = 12; break;
    case 12: // $99
      __label__ = 13; break;
    case 13: // $100
      var $101=$timerover;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $103
      var $104=$1;
      var $105=(($104+25)|0);
      HEAP8[($105)]=1;
      var $106=$1;
      var $107=(($106+26)|0);
      var $108=HEAP8[($107)];
      var $109=(($108 << 24) >> 24)!=0;
      if ($109) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $110
      var $111=$1;
      var $112=(($111+24)|0);
      HEAP8[($112)]=1;
      var $113=$1;
      var $114=__ZL10check_irqsP12_mcs48_state($113);
      __label__ = 16; break;
    case 16: // $115
      __label__ = 17; break;
    case 17: // $116
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11burn_cyclesP12_mcs48_statei["X"]=1;

function __ZL25debugger_instruction_hookP8device_tj($device, $curpc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$device;
      $2=$curpc;
      var $3=$1;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=(($4+584)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 2;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=__ZNK8device_t5debugEv($10);
      var $12=$2;
      __ZN12device_debug16instruction_hookEj($11, $12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12opcode_fetchP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5+2)|0);
  var $7=HEAPU16[(($6)>>1)];
  var $8=(($7+1)&65535);
  HEAP16[(($6)>>1)]=$8;
  var $9=(($7)&65535);
  var $10=__ZN16direct_read_data19read_decrypted_byteEjj($4, $9, 0);
  ;
  return $10;
}


function __ZL7illegalP12_mcs48_state($cpustate) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+2)|0);
  var $4=HEAPU16[(($3)>>1)];
  var $5=(($4)&65535);
  var $6=(($5-1)|0);
  var $7=$1;
  var $8=(($7+48)|0);
  var $9=HEAPU32[(($8)>>2)];
  var $10=$9;
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+28)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$1;
  var $15=(($14+2)|0);
  var $16=HEAPU16[(($15)>>1)];
  var $17=(($16)&65535);
  var $18=(($17-1)|0);
  var $19=FUNCTION_TABLE[$13]($9, $18);
  var $20=(($19)&255);
  __Z8logerrorPKcz(((STRING_TABLE.__str31193)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$6,HEAP32[((tempInt+4)>>2)]=$20,tempInt));
  STACKTOP = __stackBase__;
  return 1;
}


function __ZL8split_02P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL10outl_bus_aP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL9out_dbb_aP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7add_a_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  __ZL11execute_addP12_mcs48_stateh($2, $4);
  ;
  return 2;
}


function __ZL5jmp_0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=(($5) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $6);
  ;
  return 2;
}


function __ZL4en_iP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+27)|0);
  HEAP8[($3)]=1;
  var $4=$1;
  var $5=__ZL10check_irqsP12_mcs48_state($4);
  var $6=(($5+1)|0);
  ;
  return $6;
}


function __ZL8split_08P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL9ins_a_busP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7in_a_p1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=FUNCTION_TABLE[$8]($4, 257);
  var $10=(($9)&255);
  var $11=$1;
  var $12=(($11+13)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$10 & $14;
  var $16=(($15) & 255);
  var $17=$1;
  var $18=(($17+4)|0);
  HEAP8[($18)]=$16;
  ;
  return 2;
}


function __ZL7in_a_p2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=FUNCTION_TABLE[$8]($4, 258);
  var $10=(($9)&255);
  var $11=$1;
  var $12=(($11+14)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$10 & $14;
  var $16=(($15) & 255);
  var $17=$1;
  var $18=(($17+4)|0);
  HEAP8[($18)]=$16;
  ;
  return 2;
}


function __ZL9movd_a_p4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 0, 4);
  ;
  return 2;
}


function __ZL9movd_a_p5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 0, 5);
  ;
  return 2;
}


function __ZL9movd_a_p6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 0, 6);
  ;
  return 2;
}


function __ZL9movd_a_p7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 0, 7);
  ;
  return 2;
}


function __ZL22cpu_state_import_mcs48P17legacy_cpu_deviceRK18device_state_entry($device, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cpustate;
      $1=$device;
      $2=$entry;
      var $3=$1;
      var $4=$3;
      var $5=__ZL14get_safe_tokenP8device_t($4);
      $cpustate=$5;
      var $6=$2;
      var $7=__ZNK18device_state_entry5indexEv($6);
      if ($7 == 7 || $7 == 8 || $7 == 9 || $7 == 10 || $7 == 11 || $7 == 12 || $7 == 13 || $7 == 14) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $8
      var $9=$cpustate;
      var $10=(($9+68)|0);
      var $11=HEAP8[($10)];
      var $12=$2;
      var $13=__ZNK18device_state_entry5indexEv($12);
      var $14=(($13-7)|0);
      var $15=$cpustate;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+$14)|0);
      HEAP8[($18)]=$11;
      __label__ = 3; break;
    case 2: // $19
      __Z10fatalerrorPKcz(((STRING_TABLE.__str29191)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22cpu_state_export_mcs48P17legacy_cpu_deviceRK18device_state_entry($device, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cpustate;
      $1=$device;
      $2=$entry;
      var $3=$1;
      var $4=$3;
      var $5=__ZL14get_safe_tokenP8device_t($4);
      $cpustate=$5;
      var $6=$2;
      var $7=__ZNK18device_state_entry5indexEv($6);
      if ($7 == 7 || $7 == 8 || $7 == 9 || $7 == 10 || $7 == 11 || $7 == 12 || $7 == 13 || $7 == 14) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $8
      var $9=$2;
      var $10=__ZNK18device_state_entry5indexEv($9);
      var $11=(($10-7)|0);
      var $12=$cpustate;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+$11)|0);
      var $16=HEAP8[($15)];
      var $17=$cpustate;
      var $18=(($17+68)|0);
      HEAP8[($18)]=$16;
      __label__ = 3; break;
    case 2: // $19
      __Z10fatalerrorPKcz(((STRING_TABLE.__str28190)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dis_iP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+27)|0);
  HEAP8[($3)]=0;
  ;
  return 1;
}


function __ZL5inc_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=(($4+1)&255);
  HEAP8[($3)]=$5;
  ;
  return 1;
}


function __ZL6inc_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+2)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+3)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+5)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+6)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6inc_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+7)|0);
  var $6=HEAP8[($5)];
  var $7=(($6+1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL5clr_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  HEAP8[($3)]=0;
  ;
  return 1;
}


function __ZL8xch_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+1)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+1)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+2)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+2)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+3)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+3)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+4)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+4)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+5)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+5)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+6)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+6)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL8xch_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+7)|0);
  var $9=HEAP8[($8)];
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  var $12=$tmp;
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+7)|0);
  HEAP8[($16)]=$12;
  ;
  return 1;
}


function __ZL9dis_tcntiP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+26)|0);
  HEAP8[($3)]=0;
  var $4=$1;
  var $5=(($4+24)|0);
  HEAP8[($5)]=0;
  ;
  return 1;
}


function __ZL5cpl_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 ^ 255;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return 1;
}


function __ZL7mov_a_tP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+4)|0);
  HEAP8[($6)]=$4;
  ;
  return 1;
}


function __ZL7inc_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=(($15+56)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+8)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=(($24)|0);
  var $26=HEAPU8[($25)];
  var $27=(($26)&255);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=(($28)&255);
  var $30=(($29+1)|0);
  var $31=(($30) & 255);
  FUNCTION_TABLE[$8]($4, $14, $31);
  ;
  return 1;
}


function __ZL7inc_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=(($15+56)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+8)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=(($24+1)|0);
  var $26=HEAPU8[($25)];
  var $27=(($26)&255);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=(($28)&255);
  var $30=(($29+1)|0);
  var $31=(($30) & 255);
  FUNCTION_TABLE[$8]($4, $14, $31);
  ;
  return 1;
}


function __ZL4jb_0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 1;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL7adc_a_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  __ZL12execute_addcP12_mcs48_stateh($2, $4);
  ;
  return 2;
}


function __ZL6call_0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=(($5) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $6);
  ;
  return 2;
}


function __ZL3jtfP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+25)|0);
  var $5=HEAP8[($4)];
  __ZL11execute_jccP12_mcs48_stateh($2, $5);
  var $6=$1;
  var $7=(($6+25)|0);
  HEAP8[($7)]=0;
  ;
  return 2;
}


function __ZL9xch_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+56)|0);
  var $7=HEAPU32[(($6)>>2)];
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+28)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+8)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14)|0);
  var $16=HEAPU8[($15)];
  var $17=(($16)&255);
  var $18=FUNCTION_TABLE[$11]($7, $17);
  var $19=$1;
  var $20=(($19+4)|0);
  HEAP8[($20)]=$18;
  var $21=$1;
  var $22=(($21+56)|0);
  var $23=HEAPU32[(($22)>>2)];
  var $24=$23;
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25+80)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+8)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30)|0);
  var $32=HEAPU8[($31)];
  var $33=(($32)&255);
  var $34=$tmp;
  FUNCTION_TABLE[$27]($23, $33, $34);
  ;
  return 1;
}


function __ZL9xch_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $tmp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  $tmp=$4;
  var $5=$1;
  var $6=(($5+56)|0);
  var $7=HEAPU32[(($6)>>2)];
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+28)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+8)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=HEAPU8[($15)];
  var $17=(($16)&255);
  var $18=FUNCTION_TABLE[$11]($7, $17);
  var $19=$1;
  var $20=(($19+4)|0);
  HEAP8[($20)]=$18;
  var $21=$1;
  var $22=(($21+56)|0);
  var $23=HEAPU32[(($22)>>2)];
  var $24=$23;
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25+80)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+8)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30+1)|0);
  var $32=HEAPU8[($31)];
  var $33=(($32)&255);
  var $34=$tmp;
  FUNCTION_TABLE[$27]($23, $33, $34);
  ;
  return 1;
}


function __ZL8split_22P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL7illegalP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL8in_a_dbbP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7mov_a_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+4)|0);
  HEAP8[($5)]=$3;
  ;
  return 2;
}


function __ZL5jmp_1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 256;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8en_tcntiP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+26)|0);
  HEAP8[($3)]=1;
  var $4=$1;
  var $5=__ZL10check_irqsP12_mcs48_state($4);
  var $6=(($5+1)|0);
  ;
  return $6;
}


function __ZL5jnt_0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+60)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$9]($5, 272);
  var $11=(($10)&255);
  var $12=(($11)|0)==0;
  var $13=(($12)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $13);
  ;
  return 2;
}


function __ZL10xchd_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $oldram;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  $oldram=$15;
  var $16=$1;
  var $17=(($16+56)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+80)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+8)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25)|0);
  var $27=HEAPU8[($26)];
  var $28=(($27)&255);
  var $29=$oldram;
  var $30=(($29)&255);
  var $31=$30 & 240;
  var $32=$1;
  var $33=(($32+4)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$35 & 15;
  var $37=$31 | $36;
  var $38=(($37) & 255);
  FUNCTION_TABLE[$22]($18, $28, $38);
  var $39=$1;
  var $40=(($39+4)|0);
  var $41=HEAPU8[($40)];
  var $42=(($41)&255);
  var $43=$42 & 240;
  var $44=$oldram;
  var $45=(($44)&255);
  var $46=$45 & 15;
  var $47=$43 | $46;
  var $48=(($47) & 255);
  var $49=$1;
  var $50=(($49+4)|0);
  HEAP8[($50)]=$48;
  ;
  return 1;
}
__ZL10xchd_a_xr0P12_mcs48_state["X"]=1;

function __ZL10xchd_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $oldram;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  $oldram=$15;
  var $16=$1;
  var $17=(($16+56)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+80)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+8)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25+1)|0);
  var $27=HEAPU8[($26)];
  var $28=(($27)&255);
  var $29=$oldram;
  var $30=(($29)&255);
  var $31=$30 & 240;
  var $32=$1;
  var $33=(($32+4)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$35 & 15;
  var $37=$31 | $36;
  var $38=(($37) & 255);
  FUNCTION_TABLE[$22]($18, $28, $38);
  var $39=$1;
  var $40=(($39+4)|0);
  var $41=HEAPU8[($40)];
  var $42=(($41)&255);
  var $43=$42 & 240;
  var $44=$oldram;
  var $45=(($44)&255);
  var $46=$45 & 15;
  var $47=$43 | $46;
  var $48=(($47) & 255);
  var $49=$1;
  var $50=(($49+4)|0);
  HEAP8[($50)]=$48;
  ;
  return 1;
}
__ZL10xchd_a_xr1P12_mcs48_state["X"]=1;

function __ZL4jb_1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 2;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL6call_1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 256;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL4jt_0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+60)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$9]($5, 272);
  var $11=(($10)&255);
  var $12=(($11)|0)!=0;
  var $13=(($12)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $13);
  ;
  return 2;
}


function __ZL9outl_p1_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+4)|0);
  var $11=HEAP8[($10)];
  var $12=$1;
  var $13=(($12+13)|0);
  HEAP8[($13)]=$11;
  FUNCTION_TABLE[$8]($4, 257, $11);
  ;
  return 2;
}


function __ZL9outl_p2_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $mask;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL7p2_maskP12_mcs48_state($2);
  $mask=$3;
  var $4=$1;
  var $5=(($4+60)|0);
  var $6=HEAPU32[(($5)>>2)];
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+80)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$1;
  var $12=(($11+14)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$mask;
  var $16=(($15)&255);
  var $17=$16 ^ -1;
  var $18=$14 & $17;
  var $19=$1;
  var $20=(($19+4)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=$mask;
  var $24=(($23)&255);
  var $25=$22 & $24;
  var $26=$18 | $25;
  var $27=(($26) & 255);
  var $28=$1;
  var $29=(($28+14)|0);
  HEAP8[($29)]=$27;
  FUNCTION_TABLE[$10]($6, 258, $27);
  ;
  return 2;
}


function __ZL9movd_p4_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 1, 4);
  ;
  return 2;
}


function __ZL9movd_p5_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 1, 5);
  ;
  return 2;
}


function __ZL9movd_p6_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 1, 6);
  ;
  return 2;
}


function __ZL9movd_p7_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 1, 7);
  ;
  return 2;
}


function __ZL9orl_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=(($15)&255);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 | $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  ;
  return 1;
}


function __ZL9orl_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=(($15)&255);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 | $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  ;
  return 1;
}


function __ZL7orl_a_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5+4)|0);
  var $7=HEAPU8[($6)];
  var $8=(($7)&255);
  var $9=$8 | $4;
  var $10=(($9) & 255);
  HEAP8[($6)]=$10;
  ;
  return 2;
}


function __ZL5jmp_2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 512;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8strt_cntP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+28)|0);
  HEAP8[($3)]=2;
  var $4=$1;
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+28)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=FUNCTION_TABLE[$10]($6, 273);
  var $12=$1;
  var $13=(($12+18)|0);
  HEAP8[($13)]=$11;
  ;
  return 1;
}


function __ZL5jnt_1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+60)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$9]($5, 273);
  var $11=(($10)&255);
  var $12=(($11)|0)==0;
  var $13=(($12)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $13);
  ;
  return 2;
}


function __ZL6swap_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 4;
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 >> 4;
  var $12=$6 | $11;
  var $13=(($12) & 255);
  var $14=$1;
  var $15=(($14+4)|0);
  HEAP8[($15)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+2)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+3)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+5)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+6)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8orl_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+7)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 | $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL6strt_tP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+28)|0);
  HEAP8[($3)]=1;
  var $4=$1;
  var $5=(($4+17)|0);
  HEAP8[($5)]=0;
  ;
  return 1;
}


function __ZL4da_aP12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 15;
      var $7=(($6)|0) > 9;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 & 64;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $15
      var $16=$1;
      var $17=(($16+4)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=(($19+6)|0);
      var $21=(($20) & 255);
      HEAP8[($17)]=$21;
      var $22=$1;
      var $23=(($22+4)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 & 240;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$1;
      var $30=(($29+12)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=$32 | 128;
      var $34=(($33) & 255);
      HEAP8[($30)]=$34;
      __label__ = 4; break;
    case 4: // $35
      __label__ = 5; break;
    case 5: // $36
      var $37=$1;
      var $38=(($37+4)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=$40 & 240;
      var $42=(($41)|0) > 144;
      if ($42) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $43
      var $44=$1;
      var $45=(($44+12)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=$47 & 128;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $50
      var $51=$1;
      var $52=(($51+4)|0);
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=(($54+96)|0);
      var $56=(($55) & 255);
      HEAP8[($52)]=$56;
      var $57=$1;
      var $58=(($57+12)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=$60 | 128;
      var $62=(($61) & 255);
      HEAP8[($58)]=$62;
      __label__ = 9; break;
    case 8: // $63
      var $64=$1;
      var $65=(($64+12)|0);
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$67 & -129;
      var $69=(($68) & 255);
      HEAP8[($65)]=$69;
      __label__ = 9; break;
    case 9: // $70
      ;
      return 1;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL4da_aP12_mcs48_state["X"]=1;

function __ZL8anl_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+2)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+3)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+5)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+6)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8anl_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+7)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL7mov_t_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+16)|0);
  HEAP8[($6)]=$4;
  ;
  return 1;
}


function __ZL9stop_tcntP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+28)|0);
  HEAP8[($3)]=0;
  ;
  return 1;
}


function __ZL5rrc_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $newc;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 7;
  var $7=$6 & 128;
  var $8=(($7) & 255);
  $newc=$8;
  var $9=$1;
  var $10=(($9+4)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 >> 1;
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=HEAPU8[($15)];
  var $17=(($16)&255);
  var $18=$17 & 128;
  var $19=$13 | $18;
  var $20=(($19) & 255);
  var $21=$1;
  var $22=(($21+4)|0);
  HEAP8[($22)]=$20;
  var $23=$1;
  var $24=(($23+12)|0);
  var $25=HEAPU8[($24)];
  var $26=(($25)&255);
  var $27=$26 & -129;
  var $28=$newc;
  var $29=(($28)&255);
  var $30=$27 | $29;
  var $31=(($30) & 255);
  var $32=$1;
  var $33=(($32+12)|0);
  HEAP8[($33)]=$31;
  ;
  return 1;
}


function __ZL4rr_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 >> 1;
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 << 7;
  var $12=$6 | $11;
  var $13=(($12) & 255);
  var $14=$1;
  var $15=(($14+4)|0);
  HEAP8[($15)]=$13;
  ;
  return 1;
}


function __ZL9anl_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=(($15)&255);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 & $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  ;
  return 1;
}


function __ZL9anl_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=(($15)&255);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 & $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  ;
  return 1;
}


function __ZL4jb_2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 4;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL7anl_a_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5+4)|0);
  var $7=HEAPU8[($6)];
  var $8=(($7)&255);
  var $9=$8 & $4;
  var $10=(($9) & 255);
  HEAP8[($6)]=$10;
  ;
  return 2;
}


function __ZL6call_2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 512;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL4jt_1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+60)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$9]($5, 273);
  var $11=(($10)&255);
  var $12=(($11)|0)!=0;
  var $13=(($12)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $13);
  ;
  return 2;
}


function __ZL9add_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+56)|0);
  var $5=HEAPU32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+8)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=FUNCTION_TABLE[$9]($5, $15);
  __ZL11execute_addP12_mcs48_stateh($2, $16);
  ;
  return 1;
}


function __ZL9add_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+56)|0);
  var $5=HEAPU32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+8)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+1)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=FUNCTION_TABLE[$9]($5, $15);
  __ZL11execute_addP12_mcs48_stateh($2, $16);
  ;
  return 1;
}


function __ZL5jmp_3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 768;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8add_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+2)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+3)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+4)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+5)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+6)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8add_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+7)|0);
  var $7=HEAP8[($6)];
  __ZL11execute_addP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL9adc_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+56)|0);
  var $5=HEAPU32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+8)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=FUNCTION_TABLE[$9]($5, $15);
  __ZL12execute_addcP12_mcs48_stateh($2, $16);
  ;
  return 1;
}


function __ZL9adc_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+56)|0);
  var $5=HEAPU32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+8)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+1)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=FUNCTION_TABLE[$9]($5, $15);
  __ZL12execute_addcP12_mcs48_stateh($2, $16);
  ;
  return 1;
}


function __ZL4jb_3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 8;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL6call_3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 768;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8split_75P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL8ent0_clkP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL3jf1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+19)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 8;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL8adc_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+2)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+3)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+4)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+5)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+6)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8adc_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+7)|0);
  var $7=HEAP8[($6)];
  __ZL12execute_addcP12_mcs48_stateh($2, $7);
  ;
  return 1;
}


function __ZL8split_80P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL10movx_a_xr0P12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL6clr_f0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & -33;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  var $8=$1;
  var $9=(($8+19)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 & -5;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL6cpl_f0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 ^ 32;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  var $8=$1;
  var $9=(($8+19)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ 4;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL5clr_cP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & -129;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return 1;
}


function __ZL6clr_f1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+19)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & -9;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return 1;
}


function __ZL5cpl_cP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 ^ 128;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return 1;
}


function __ZL8mov_r0_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r1_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+1)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r2_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+2)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r3_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+3)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r4_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+4)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r5_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+5)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r6_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+6)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL8mov_r7_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+7)|0);
  HEAP8[($8)]=$4;
  ;
  return 1;
}


function __ZL6cpl_f1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+19)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 ^ 8;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return 1;
}


function __ZL9mov_a_pswP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+4)|0);
  HEAP8[($6)]=$4;
  ;
  return 1;
}


function __ZL6dec_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6dec_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6dec_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+2)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6dec_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+3)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6dec_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6dec_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+5)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL6dec_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+6)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL8split_81P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL10movx_a_xr1P12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL3retP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL7pull_pcP12_mcs48_state($2);
  ;
  return 2;
}


function __ZL5jmp_4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1024;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8split_86P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL3jniP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL4jobfP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8split_88P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL9orl_bus_nP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8orl_p1_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=__ZL14argument_fetchP12_mcs48_state($9);
  var $11=(($10)&255);
  var $12=$1;
  var $13=(($12+13)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=$15 | $11;
  var $17=(($16) & 255);
  HEAP8[($13)]=$17;
  FUNCTION_TABLE[$8]($4, 257, $17);
  ;
  return 2;
}


function __ZL8orl_p2_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=__ZL14argument_fetchP12_mcs48_state($9);
  var $11=(($10)&255);
  var $12=$1;
  var $13=__ZL7p2_maskP12_mcs48_state($12);
  var $14=(($13)&255);
  var $15=$11 & $14;
  var $16=$1;
  var $17=(($16+14)|0);
  var $18=HEAPU8[($17)];
  var $19=(($18)&255);
  var $20=$19 | $15;
  var $21=(($20) & 255);
  HEAP8[($17)]=$21;
  FUNCTION_TABLE[$8]($4, 258, $21);
  ;
  return 2;
}


function __ZL9orld_p4_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 2, 4);
  ;
  return 2;
}


function __ZL9orld_p5_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 2, 5);
  ;
  return 2;
}


function __ZL9orld_p6_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 2, 6);
  ;
  return 2;
}


function __ZL9orld_p7_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 2, 7);
  ;
  return 2;
}


function __ZL8split_90P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL10movx_xr0_aP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL9mov_sts_aP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8split_91P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL10movx_xr1_aP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL4jb_4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 16;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL4retrP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL11pull_pc_pswP12_mcs48_state($2);
  var $3=$1;
  var $4=(($3+23)|0);
  HEAP8[($4)]=0;
  var $5=$1;
  var $6=__ZL10check_irqsP12_mcs48_state($5);
  var $7=(($6+2)|0);
  ;
  return $7;
}


function __ZL6call_4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1024;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL3jnzP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=(($6)|0)!=0;
  var $8=(($7)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $8);
  ;
  return 2;
}


function __ZL8split_98P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL9anl_bus_nP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL7illegalP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8anl_p1_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=__ZL14argument_fetchP12_mcs48_state($9);
  var $11=(($10)&255);
  var $12=$1;
  var $13=(($12+13)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=$15 & $11;
  var $17=(($16) & 255);
  HEAP8[($13)]=$17;
  FUNCTION_TABLE[$8]($4, 257, $17);
  ;
  return 2;
}


function __ZL8anl_p2_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=__ZL14argument_fetchP12_mcs48_state($9);
  var $11=(($10)&255);
  var $12=$1;
  var $13=__ZL7p2_maskP12_mcs48_state($12);
  var $14=(($13)&255);
  var $15=$14 ^ -1;
  var $16=$11 | $15;
  var $17=$1;
  var $18=(($17+14)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 & $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  FUNCTION_TABLE[$8]($4, 258, $22);
  ;
  return 2;
}


function __ZL9anld_p4_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 3, 4);
  ;
  return 2;
}


function __ZL9anld_p5_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 3, 5);
  ;
  return 2;
}


function __ZL9anld_p6_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 3, 6);
  ;
  return 2;
}


function __ZL9anld_p7_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  __ZL18expander_operationP12_mcs48_statehh($2, 3, 7);
  ;
  return 2;
}


function __ZL9mov_xr0_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=(($15+4)|0);
  var $17=HEAP8[($16)];
  FUNCTION_TABLE[$8]($4, $14, $17);
  ;
  return 1;
}


function __ZL9mov_xr1_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=(($15+4)|0);
  var $17=HEAP8[($16)];
  FUNCTION_TABLE[$8]($4, $14, $17);
  ;
  return 1;
}


function __ZL9movp_a_xaP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+48)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+2)|0);
  var $11=HEAPU16[(($10)>>1)];
  var $12=(($11)&65535);
  var $13=$12 & 3840;
  var $14=$1;
  var $15=(($14+4)|0);
  var $16=HEAPU8[($15)];
  var $17=(($16)&255);
  var $18=$13 | $17;
  var $19=FUNCTION_TABLE[$8]($4, $18);
  var $20=$1;
  var $21=(($20+4)|0);
  HEAP8[($21)]=$19;
  ;
  return 2;
}


function __ZL5jmp_5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1280;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL9mov_xr0_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=__ZL14argument_fetchP12_mcs48_state($15);
  FUNCTION_TABLE[$8]($4, $14, $16);
  ;
  return 2;
}


function __ZL9mov_xr1_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=__ZL14argument_fetchP12_mcs48_state($15);
  FUNCTION_TABLE[$8]($4, $14, $16);
  ;
  return 2;
}


function __ZL4jb_5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 32;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL7jmpp_xaP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+2)|0);
  var $4=HEAPU16[(($3)>>1)];
  var $5=(($4)&65535);
  var $6=$5 & 3840;
  var $7=(($6) & 65535);
  HEAP16[(($3)>>1)]=$7;
  var $8=$1;
  var $9=(($8+48)|0);
  var $10=HEAPU32[(($9)>>2)];
  var $11=$10;
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+28)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$1;
  var $16=(($15+2)|0);
  var $17=HEAPU16[(($16)>>1)];
  var $18=(($17)&65535);
  var $19=$1;
  var $20=(($19+4)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=$18 | $22;
  var $24=FUNCTION_TABLE[$14]($10, $23);
  var $25=(($24)&255);
  var $26=$1;
  var $27=(($26+2)|0);
  var $28=HEAPU16[(($27)>>1)];
  var $29=(($28)&65535);
  var $30=$29 | $25;
  var $31=(($30) & 65535);
  HEAP16[(($27)>>1)]=$31;
  ;
  return 2;
}


function __ZL6call_5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1280;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL3jf0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 32;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL8mov_r0_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r1_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r2_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+2)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r3_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+3)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r4_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+4)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r5_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+5)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r6_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+6)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL8mov_r7_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+7)|0);
  HEAP8[($7)]=$3;
  ;
  return 2;
}


function __ZL5jmp_6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1536;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL7sel_rb0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & -17;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  var $8=$1;
  __ZL13update_regptrP12_mcs48_state($8);
  ;
  return 1;
}


function __ZL2jzP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=(($6)|0)==0;
  var $8=(($7)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $8);
  ;
  return 2;
}


function __ZL6dec_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+7)|0);
  var $6=HEAP8[($5)];
  var $7=(($6-1)&255);
  HEAP8[($5)]=$7;
  ;
  return 1;
}


function __ZL8xrl_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+2)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+3)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+5)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+6)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL8xrl_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+7)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 ^ $7;
  var $13=(($12) & 255);
  HEAP8[($9)]=$13;
  ;
  return 1;
}


function __ZL4rl_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 1;
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 >> 7;
  var $12=$6 | $11;
  var $13=(($12) & 255);
  var $14=$1;
  var $15=(($14+4)|0);
  HEAP8[($15)]=$13;
  ;
  return 1;
}


function __ZL5rlc_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $newc;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 128;
  var $7=(($6) & 255);
  $newc=$7;
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 << 1;
  var $13=$1;
  var $14=(($13+12)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 >> 7;
  var $18=$12 | $17;
  var $19=(($18) & 255);
  var $20=$1;
  var $21=(($20+4)|0);
  HEAP8[($21)]=$19;
  var $22=$1;
  var $23=(($22+12)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & -129;
  var $27=$newc;
  var $28=(($27)&255);
  var $29=$26 | $28;
  var $30=(($29) & 255);
  var $31=$1;
  var $32=(($31+12)|0);
  HEAP8[($32)]=$30;
  ;
  return 1;
}


function __ZL8mov_a_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+2)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+3)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+5)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+6)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL8mov_a_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+7)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+4)|0);
  HEAP8[($8)]=$6;
  ;
  return 1;
}


function __ZL7sel_mb1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+32)|0);
  HEAP16[(($3)>>1)]=2048;
  ;
  return 1;
}


function __ZL9xrl_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=(($15)&255);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 ^ $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  ;
  return 1;
}


function __ZL9xrl_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=(($15)&255);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 ^ $16;
  var $22=(($21) & 255);
  HEAP8[($18)]=$22;
  ;
  return 1;
}


function __ZL4jb_6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 64;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL7xrl_a_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=__ZL14argument_fetchP12_mcs48_state($2);
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5+4)|0);
  var $7=HEAPU8[($6)];
  var $8=(($7)&255);
  var $9=$8 ^ $4;
  var $10=(($9) & 255);
  HEAP8[($6)]=$10;
  ;
  return 2;
}


function __ZL6call_6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1536;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL7sel_rb1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 | 16;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  var $8=$1;
  __ZL13update_regptrP12_mcs48_state($8);
  ;
  return 1;
}


function __ZL8split_d6P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL7illegalP12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL5jnibfP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9mov_psw_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=$1;
  var $6=(($5+12)|0);
  HEAP8[($6)]=$4;
  var $7=$1;
  __ZL13update_regptrP12_mcs48_state($7);
  ;
  return 1;
}


function __ZL10movp3_a_xaP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+48)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+4)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=768 | $12;
  var $14=FUNCTION_TABLE[$8]($4, $13);
  var $15=$1;
  var $16=(($15+4)|0);
  HEAP8[($16)]=$14;
  ;
  return 2;
}


function __ZL5jmp_7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1792;
  var $7=(($6) & 65535);
  __ZL11execute_jmpP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8split_e5P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL7sel_mb0P12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL6en_dmaP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL3jncP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 128;
  var $8=(($7)|0)==0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL7djnz_r0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r2P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+2)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r3P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+3)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r4P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+4)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r5P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+5)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r6P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+6)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL7djnz_r7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+7)|0);
  var $7=HEAP8[($6)];
  var $8=(($7-1)&255);
  HEAP8[($6)]=$8;
  var $9=(($8)&255);
  var $10=(($9)|0)!=0;
  var $11=(($10)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $11);
  ;
  return 2;
}


function __ZL9mov_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+4)|0);
  HEAP8[($17)]=$15;
  ;
  return 1;
}


function __ZL9mov_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+4)|0);
  HEAP8[($17)]=$15;
  ;
  return 1;
}


function __ZL4jb_7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 128;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL6call_7P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=__ZL14argument_fetchP12_mcs48_state($3);
  var $5=(($4)&255);
  var $6=$5 | 1792;
  var $7=(($6) & 65535);
  __ZL12execute_callP12_mcs48_statet($2, $7);
  ;
  return 2;
}


function __ZL8split_f5P12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZL7sel_mb1P12_mcs48_state($9);
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $13=__ZL8en_flagsP12_mcs48_state($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL2jcP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 128;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL11execute_jccP12_mcs48_stateh($cpustate, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $offset;
      $1=$cpustate;
      $2=$result;
      var $3=$1;
      var $4=__ZL14argument_fetchP12_mcs48_state($3);
      $offset=$4;
      var $5=$2;
      var $6=(($5)&255);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$1;
      var $10=(($9+2)|0);
      var $11=HEAPU16[(($10)>>1)];
      var $12=(($11)&65535);
      var $13=(($12-1)|0);
      var $14=$13 & 3840;
      var $15=$offset;
      var $16=(($15)&255);
      var $17=$14 | $16;
      var $18=(($17) & 65535);
      var $19=$1;
      var $20=(($19+2)|0);
      HEAP16[(($20)>>1)]=$18;
      __label__ = 2; break;
    case 2: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14argument_fetchP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5+2)|0);
  var $7=HEAPU16[(($6)>>1)];
  var $8=(($7+1)&65535);
  HEAP16[(($6)>>1)]=$8;
  var $9=(($7)&65535);
  var $10=__ZN16direct_read_data13read_raw_byteEjj($4, $9, 0);
  ;
  return $10;
}


function __ZN16direct_read_data13read_raw_byteEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=HEAP8[($17)];
      $1=$18;
      __label__ = 3; break;
    case 2: // $19
      var $20=(($5)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+28)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$3;
      var $27=FUNCTION_TABLE[$25]($21, $26);
      $1=$27;
      __label__ = 3; break;
    case 3: // $28
      var $29=$1;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data16address_is_validEj($this, $byteaddress) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$this;
      HEAP32[(($2)>>2)]=$byteaddress;
      var $3=$1;
      var $4=HEAPU32[(($2)>>2)];
      var $5=(($3+16)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=(($4)>>>0) >= (($6)>>>0);
      if ($7) { __label__ = 1; break; } else { var $14 = 0;__label__ = 2; break; }
    case 1: // $8
      var $9=HEAPU32[(($2)>>2)];
      var $10=(($3+20)|0);
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($9)>>>0) <= (($11)>>>0);
      var $14 = $12;__label__ = 2; break;
    case 2: // $13
      var $14;
      var $15=$14 ^ 1;
      var $16=$15 ^ 1;
      var $17=(($16)&1);
      var $18=(($17)==(1));
      var $19=(($18)|0)!=0;
      if ($19) { var $23 = 1;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=__ZN16direct_read_data17set_direct_regionERj($3, $2);
      var $23 = $21;__label__ = 4; break;
    case 4: // $22
      var $23;
      STACKTOP = __stackBase__;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8en_flagsP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+29)|0);
  HEAP8[($3)]=1;
  var $4=$1;
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+80)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$1;
  var $12=(($11+14)|0);
  var $13=HEAP8[($12)];
  FUNCTION_TABLE[$10]($6, 258, $13);
  ;
  return 1;
}


function __ZL12execute_callP12_mcs48_statet($cpustate, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$cpustate;
  $2=$address;
  var $3=$1;
  __ZL11push_pc_pswP12_mcs48_state($3);
  var $4=$1;
  var $5=$2;
  __ZL11execute_jmpP12_mcs48_statet($4, $5);
  ;
  return;
}


function __ZL11execute_jmpP12_mcs48_statet($cpustate, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $a11;
      $1=$cpustate;
      $2=$address;
      var $3=$1;
      var $4=(($3+23)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $14 = 0;__label__ = 3; break;
    case 2: // $8
      var $9=$1;
      var $10=(($9+32)|0);
      var $11=HEAPU16[(($10)>>1)];
      var $12=(($11)&65535);
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      var $15=(($14) & 65535);
      $a11=$15;
      var $16=$2;
      var $17=(($16)&65535);
      var $18=$a11;
      var $19=(($18)&65535);
      var $20=$17 | $19;
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+2)|0);
      HEAP16[(($23)>>1)]=$21;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7sel_mb0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+32)|0);
  HEAP16[(($3)>>1)]=0;
  ;
  return 1;
}


function __ZL7p2_maskP12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      $2=$cpustate;
      $result=-1;
      var $3=$2;
      var $4=(($3+64)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$6 & 2;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$result;
      $1=$10;
      __label__ = 7; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12+29)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$result;
      var $18=(($17)&255);
      var $19=$18 & -49;
      var $20=(($19) & 255);
      $result=$20;
      __label__ = 4; break;
    case 4: // $21
      var $22=$2;
      var $23=(($22+30)|0);
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$result;
      var $28=(($27)&255);
      var $29=$28 & -193;
      var $30=(($29) & 255);
      $result=$30;
      __label__ = 6; break;
    case 6: // $31
      var $32=$result;
      $1=$32;
      __label__ = 7; break;
    case 7: // $33
      var $34=$1;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9mov_sts_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+19)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 15;
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 & 240;
  var $12=$6 | $11;
  var $13=(($12) & 255);
  var $14=$1;
  var $15=(($14+19)|0);
  HEAP8[($15)]=$13;
  ;
  return 1;
}


function __ZL12execute_addcP12_mcs48_stateh($cpustate, $dat) {
  ;
  var __label__;

  var $1;
  var $2;
  var $carryin;
  var $temp;
  var $temp4;
  $1=$cpustate;
  $2=$dat;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 128;
  var $8=$7 >> 7;
  var $9=(($8) & 255);
  $carryin=$9;
  var $10=$1;
  var $11=(($10+4)|0);
  var $12=HEAPU8[($11)];
  var $13=(($12)&255);
  var $14=$2;
  var $15=(($14)&255);
  var $16=(($13+$15)|0);
  var $17=$carryin;
  var $18=(($17)&255);
  var $19=(($16+$18)|0);
  var $20=(($19) & 65535);
  $temp=$20;
  var $21=$1;
  var $22=(($21+4)|0);
  var $23=HEAPU8[($22)];
  var $24=(($23)&255);
  var $25=$24 & 15;
  var $26=$2;
  var $27=(($26)&255);
  var $28=$27 & 15;
  var $29=(($25+$28)|0);
  var $30=$carryin;
  var $31=(($30)&255);
  var $32=(($29+$31)|0);
  var $33=(($32) & 65535);
  $temp4=$33;
  var $34=$1;
  var $35=(($34+12)|0);
  var $36=HEAPU8[($35)];
  var $37=(($36)&255);
  var $38=$37 & -193;
  var $39=(($38) & 255);
  HEAP8[($35)]=$39;
  var $40=$temp4;
  var $41=(($40)&65535);
  var $42=$41 << 2;
  var $43=$42 & 64;
  var $44=$1;
  var $45=(($44+12)|0);
  var $46=HEAPU8[($45)];
  var $47=(($46)&255);
  var $48=$47 | $43;
  var $49=(($48) & 255);
  HEAP8[($45)]=$49;
  var $50=$temp;
  var $51=(($50)&65535);
  var $52=$51 >> 1;
  var $53=$52 & 128;
  var $54=$1;
  var $55=(($54+12)|0);
  var $56=HEAPU8[($55)];
  var $57=(($56)&255);
  var $58=$57 | $53;
  var $59=(($58) & 255);
  HEAP8[($55)]=$59;
  var $60=$temp;
  var $61=(($60) & 255);
  var $62=$1;
  var $63=(($62+4)|0);
  HEAP8[($63)]=$61;
  ;
  return;
}
__ZL12execute_addcP12_mcs48_stateh["X"]=1;

function __ZL11execute_addP12_mcs48_stateh($cpustate, $dat) {
  ;
  var __label__;

  var $1;
  var $2;
  var $temp;
  var $temp4;
  $1=$cpustate;
  $2=$dat;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$2;
  var $8=(($7)&255);
  var $9=(($6+$8)|0);
  var $10=(($9) & 65535);
  $temp=$10;
  var $11=$1;
  var $12=(($11+4)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$14 & 15;
  var $16=$2;
  var $17=(($16)&255);
  var $18=$17 & 15;
  var $19=(($15+$18)|0);
  var $20=(($19) & 65535);
  $temp4=$20;
  var $21=$1;
  var $22=(($21+12)|0);
  var $23=HEAPU8[($22)];
  var $24=(($23)&255);
  var $25=$24 & -193;
  var $26=(($25) & 255);
  HEAP8[($22)]=$26;
  var $27=$temp4;
  var $28=(($27)&65535);
  var $29=$28 << 2;
  var $30=$29 & 64;
  var $31=$1;
  var $32=(($31+12)|0);
  var $33=HEAPU8[($32)];
  var $34=(($33)&255);
  var $35=$34 | $30;
  var $36=(($35) & 255);
  HEAP8[($32)]=$36;
  var $37=$temp;
  var $38=(($37)&65535);
  var $39=$38 >> 1;
  var $40=$39 & 128;
  var $41=$1;
  var $42=(($41+12)|0);
  var $43=HEAPU8[($42)];
  var $44=(($43)&255);
  var $45=$44 | $40;
  var $46=(($45) & 255);
  HEAP8[($42)]=$46;
  var $47=$temp;
  var $48=(($47) & 255);
  var $49=$1;
  var $50=(($49+4)|0);
  HEAP8[($50)]=$48;
  ;
  return;
}
__ZL11execute_addP12_mcs48_stateh["X"]=1;

function __ZL11push_pc_pswP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $sp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 7;
  var $7=(($6) & 255);
  $sp=$7;
  var $8=$1;
  var $9=(($8+56)|0);
  var $10=HEAPU32[(($9)>>2)];
  var $11=$10;
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+80)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$sp;
  var $16=(($15)&255);
  var $17=((($16<<1))|0);
  var $18=(($17+8)|0);
  var $19=$1;
  var $20=(($19+2)|0);
  var $21=HEAP16[(($20)>>1)];
  var $22=(($21) & 255);
  FUNCTION_TABLE[$14]($10, $18, $22);
  var $23=$1;
  var $24=(($23+56)|0);
  var $25=HEAPU32[(($24)>>2)];
  var $26=$25;
  var $27=HEAP32[(($26)>>2)];
  var $28=(($27+80)|0);
  var $29=HEAP32[(($28)>>2)];
  var $30=$sp;
  var $31=(($30)&255);
  var $32=((($31<<1))|0);
  var $33=(($32+9)|0);
  var $34=$1;
  var $35=(($34+2)|0);
  var $36=HEAPU16[(($35)>>1)];
  var $37=(($36)&65535);
  var $38=$37 >> 8;
  var $39=$38 & 15;
  var $40=$1;
  var $41=(($40+12)|0);
  var $42=HEAPU8[($41)];
  var $43=(($42)&255);
  var $44=$43 & 240;
  var $45=$39 | $44;
  var $46=(($45) & 255);
  FUNCTION_TABLE[$29]($25, $33, $46);
  var $47=$1;
  var $48=(($47+12)|0);
  var $49=HEAPU8[($48)];
  var $50=(($49)&255);
  var $51=$50 & 248;
  var $52=$sp;
  var $53=(($52)&255);
  var $54=(($53+1)|0);
  var $55=$54 & 7;
  var $56=$51 | $55;
  var $57=(($56) & 255);
  var $58=$1;
  var $59=(($58+12)|0);
  HEAP8[($59)]=$57;
  ;
  return;
}
__ZL11push_pc_pswP12_mcs48_state["X"]=1;

function __ZL6en_dmaP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+30)|0);
  HEAP8[($3)]=1;
  var $4=$1;
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+80)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$1;
  var $12=(($11+14)|0);
  var $13=HEAP8[($12)];
  FUNCTION_TABLE[$10]($6, 258, $13);
  ;
  return 1;
}


function __ZL5jnibfP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+19)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 2;
  var $8=(($7)|0)==0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL18expander_operationP12_mcs48_statehh($cpustate, $operation, $port) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$cpustate;
      $2=$operation;
      $3=$port;
      var $4=$1;
      var $5=(($4+60)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+80)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+14)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & 240;
      var $16=$2;
      var $17=(($16)&255);
      var $18=$17 << 2;
      var $19=$15 | $18;
      var $20=$3;
      var $21=(($20)&255);
      var $22=$21 & 3;
      var $23=$19 | $22;
      var $24=(($23) & 255);
      var $25=$1;
      var $26=(($25+14)|0);
      HEAP8[($26)]=$24;
      FUNCTION_TABLE[$10]($6, 258, $24);
      var $27=$1;
      var $28=(($27+60)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+80)|0);
      var $33=HEAP32[(($32)>>2)];
      FUNCTION_TABLE[$33]($29, 289, 0);
      var $34=$2;
      var $35=(($34)&255);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $37
      var $38=$1;
      var $39=(($38+60)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+80)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$1;
      var $46=(($45+14)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 & 240;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$53 & 15;
      var $55=$49 | $54;
      var $56=(($55) & 255);
      var $57=$1;
      var $58=(($57+14)|0);
      HEAP8[($58)]=$56;
      FUNCTION_TABLE[$44]($40, 258, $56);
      __label__ = 3; break;
    case 2: // $59
      var $60=$1;
      var $61=(($60+60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+28)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=FUNCTION_TABLE[$66]($62, 258);
      var $68=(($67)&255);
      var $69=$68 | 15;
      var $70=(($69) & 255);
      var $71=$1;
      var $72=(($71+4)|0);
      HEAP8[($72)]=$70;
      __label__ = 3; break;
    case 3: // $73
      var $74=$1;
      var $75=(($74+60)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$76;
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+80)|0);
      var $80=HEAP32[(($79)>>2)];
      FUNCTION_TABLE[$80]($76, 289, 1);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18expander_operationP12_mcs48_statehh["X"]=1;

function __ZL9anl_bus_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+60)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13+28)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=FUNCTION_TABLE[$15]($11, 288);
  var $17=(($16)&255);
  var $18=$1;
  var $19=__ZL14argument_fetchP12_mcs48_state($18);
  var $20=(($19)&255);
  var $21=$17 & $20;
  var $22=(($21) & 255);
  FUNCTION_TABLE[$8]($4, 288, $22);
  ;
  return 2;
}


function __ZL11pull_pc_pswP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $sp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=(($5-1)|0);
  var $7=$6 & 7;
  var $8=(($7) & 255);
  $sp=$8;
  var $9=$1;
  var $10=(($9+56)|0);
  var $11=HEAPU32[(($10)>>2)];
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13+28)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$sp;
  var $17=(($16)&255);
  var $18=((($17<<1))|0);
  var $19=(($18+8)|0);
  var $20=FUNCTION_TABLE[$15]($11, $19);
  var $21=(($20)&255);
  var $22=$1;
  var $23=(($22+2)|0);
  HEAP16[(($23)>>1)]=$21;
  var $24=$1;
  var $25=(($24+56)|0);
  var $26=HEAPU32[(($25)>>2)];
  var $27=$26;
  var $28=HEAP32[(($27)>>2)];
  var $29=(($28+28)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=$sp;
  var $32=(($31)&255);
  var $33=((($32<<1))|0);
  var $34=(($33+9)|0);
  var $35=FUNCTION_TABLE[$30]($26, $34);
  var $36=(($35)&255);
  var $37=$36 << 8;
  var $38=$1;
  var $39=(($38+2)|0);
  var $40=HEAPU16[(($39)>>1)];
  var $41=(($40)&65535);
  var $42=$41 | $37;
  var $43=(($42) & 65535);
  HEAP16[(($39)>>1)]=$43;
  var $44=$1;
  var $45=(($44+2)|0);
  var $46=HEAPU16[(($45)>>1)];
  var $47=(($46)&65535);
  var $48=$47 >> 8;
  var $49=$48 & 240;
  var $50=$49 | 8;
  var $51=$sp;
  var $52=(($51)&255);
  var $53=$50 | $52;
  var $54=(($53) & 255);
  var $55=$1;
  var $56=(($55+12)|0);
  HEAP8[($56)]=$54;
  var $57=$1;
  var $58=(($57+2)|0);
  var $59=HEAPU16[(($58)>>1)];
  var $60=(($59)&65535);
  var $61=$60 & 4095;
  var $62=(($61) & 65535);
  HEAP16[(($58)>>1)]=$62;
  var $63=$1;
  __ZL13update_regptrP12_mcs48_state($63);
  ;
  return;
}
__ZL11pull_pc_pswP12_mcs48_state["X"]=1;

function __ZL10movx_xr1_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=(($15+4)|0);
  var $17=HEAP8[($16)];
  FUNCTION_TABLE[$8]($4, $14, $17);
  ;
  return 2;
}


function __ZL10movx_xr0_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$1;
  var $16=(($15+4)|0);
  var $17=HEAP8[($16)];
  FUNCTION_TABLE[$8]($4, $14, $17);
  ;
  return 2;
}


function __ZL9orl_bus_nP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+60)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13+28)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=FUNCTION_TABLE[$15]($11, 288);
  var $17=(($16)&255);
  var $18=$1;
  var $19=__ZL14argument_fetchP12_mcs48_state($18);
  var $20=(($19)&255);
  var $21=$17 | $20;
  var $22=(($21) & 255);
  FUNCTION_TABLE[$8]($4, 288, $22);
  ;
  return 2;
}


function __ZL3jniP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+22)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=(($6)|0)!=0;
  var $8=(($7)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $8);
  ;
  return 2;
}


function __ZL4jobfP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=$1;
  var $4=(($3+19)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 1;
  var $8=(($7)|0)!=0;
  var $9=(($8)&1);
  __ZL11execute_jccP12_mcs48_stateh($2, $9);
  ;
  return 2;
}


function __ZL7pull_pcP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  var $sp;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=(($5-1)|0);
  var $7=$6 & 7;
  var $8=(($7) & 255);
  $sp=$8;
  var $9=$1;
  var $10=(($9+56)|0);
  var $11=HEAPU32[(($10)>>2)];
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13+28)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$sp;
  var $17=(($16)&255);
  var $18=((($17<<1))|0);
  var $19=(($18+8)|0);
  var $20=FUNCTION_TABLE[$15]($11, $19);
  var $21=(($20)&255);
  var $22=$1;
  var $23=(($22+2)|0);
  HEAP16[(($23)>>1)]=$21;
  var $24=$1;
  var $25=(($24+56)|0);
  var $26=HEAPU32[(($25)>>2)];
  var $27=$26;
  var $28=HEAP32[(($27)>>2)];
  var $29=(($28+28)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=$sp;
  var $32=(($31)&255);
  var $33=((($32<<1))|0);
  var $34=(($33+9)|0);
  var $35=FUNCTION_TABLE[$30]($26, $34);
  var $36=(($35)&255);
  var $37=$36 << 8;
  var $38=$1;
  var $39=(($38+2)|0);
  var $40=HEAPU16[(($39)>>1)];
  var $41=(($40)&65535);
  var $42=$41 | $37;
  var $43=(($42) & 65535);
  HEAP16[(($39)>>1)]=$43;
  var $44=$1;
  var $45=(($44+2)|0);
  var $46=HEAPU16[(($45)>>1)];
  var $47=(($46)&65535);
  var $48=$47 & 4095;
  var $49=(($48) & 65535);
  HEAP16[(($45)>>1)]=$49;
  var $50=$1;
  var $51=(($50+12)|0);
  var $52=HEAPU8[($51)];
  var $53=(($52)&255);
  var $54=$53 & 240;
  var $55=$54 | 8;
  var $56=$sp;
  var $57=(($56)&255);
  var $58=$55 | $57;
  var $59=(($58) & 255);
  var $60=$1;
  var $61=(($60+12)|0);
  HEAP8[($61)]=$59;
  ;
  return;
}
__ZL7pull_pcP12_mcs48_state["X"]=1;

function __ZL10movx_a_xr1P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+4)|0);
  HEAP8[($17)]=$15;
  ;
  return 2;
}


function __ZL10movx_a_xr0P12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+4)|0);
  HEAP8[($17)]=$15;
  ;
  return 2;
}


function __ZL8ent0_clkP12_mcs48_state($cpustate) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+2)|0);
  var $4=HEAPU16[(($3)>>1)];
  var $5=(($4)&65535);
  var $6=(($5-1)|0);
  var $7=$1;
  var $8=(($7+48)|0);
  var $9=HEAPU32[(($8)>>2)];
  var $10=$9;
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+28)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$1;
  var $15=(($14+2)|0);
  var $16=HEAPU16[(($15)>>1)];
  var $17=(($16)&65535);
  var $18=(($17-1)|0);
  var $19=FUNCTION_TABLE[$13]($9, $18);
  var $20=(($19)&255);
  __Z8logerrorPKcz(((STRING_TABLE.__str30192)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$6,HEAP32[((tempInt+4)>>2)]=$20,tempInt));
  STACKTOP = __stackBase__;
  return 1;
}


function __ZL8in_a_dbbP12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+19)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=$5 & 2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=$1;
      var $10=(($9+36)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$1;
      var $15=(($14+36)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+40)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      var $21=FUNCTION_TABLE[$16]($20, 0);
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      var $24=(($23+19)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -3;
      var $28=(($27) & 255);
      HEAP8[($24)]=$28;
      var $29=$1;
      var $30=(($29+29)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24)!=0;
      if ($32) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      var $34=$1;
      var $35=(($34+14)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 32;
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$1;
      var $42=(($41+60)|0);
      var $43=HEAPU32[(($42)>>2)];
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+80)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$1;
      var $49=(($48+14)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$51 | 32;
      var $53=(($52) & 255);
      HEAP8[($49)]=$53;
      FUNCTION_TABLE[$47]($43, 258, $53);
      __label__ = 6; break;
    case 6: // $54
      var $55=$1;
      var $56=(($55+20)|0);
      var $57=HEAP8[($56)];
      var $58=$1;
      var $59=(($58+4)|0);
      HEAP8[($59)]=$57;
      ;
      return 2;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8in_a_dbbP12_mcs48_state["X"]=1;

function __ZL9ins_a_busP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=FUNCTION_TABLE[$8]($4, 288);
  var $10=$1;
  var $11=(($10+4)|0);
  HEAP8[($11)]=$9;
  ;
  return 2;
}


function __ZL10outl_bus_aP12_mcs48_state($cpustate) {
  ;
  var __label__;

  var $1;
  $1=$cpustate;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+4)|0);
  var $11=HEAP8[($10)];
  FUNCTION_TABLE[$8]($4, 288, $11);
  ;
  return 2;
}


function __ZL9out_dbb_aP12_mcs48_state($cpustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cpustate;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP8[($3)];
      var $5=$1;
      var $6=(($5+21)|0);
      HEAP8[($6)]=$4;
      var $7=$1;
      var $8=(($7+19)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 1;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      var $13=$1;
      var $14=(($13+29)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $17
      var $18=$1;
      var $19=(($18+14)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$21 & 16;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $24
      var $25=$1;
      var $26=(($25+60)|0);
      var $27=HEAPU32[(($26)>>2)];
      var $28=$27;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+80)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$1;
      var $33=(($32+14)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=$35 | 16;
      var $37=(($36) & 255);
      HEAP8[($33)]=$37;
      FUNCTION_TABLE[$31]($27, 258, $37);
      __label__ = 3; break;
    case 3: // $38
      ;
      return 2;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t5debugEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK23device_memory_interface5spaceE16address_spacenum($this, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$index;
  var $3=$1;
  var $4=$2;
  var $5=(($3+28)|0);
  var $6=(($5+($4<<2))|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __ZNK13address_space6directEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN8device_t9interfaceERP22device_state_interface($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  HEAP32[(($6)>>2)]=$5;
  var $7=$2;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0)!=0;
  ;
  return $9;
}


function __ZN18device_state_entry6noshowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 | 1;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return $2;
}


function __ZN18device_state_entry10callimportEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 | 2;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return $2;
}


function __ZN18device_state_entry10callexportEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 | 8;
  var $7=(($6) & 255);
  HEAP8[($3)]=$7;
  ;
  return $2;
}


function __ZNK16device_scheduler7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN21delegate_internal_mfpC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  ;
  return;
}


function __ZN16direct_read_data19read_decrypted_byteEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=HEAP8[($17)];
      $1=$18;
      __label__ = 3; break;
    case 2: // $19
      var $20=(($5)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+28)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$3;
      var $27=FUNCTION_TABLE[$25]($21, $26);
      $1=$27;
      __label__ = 3; break;
    case 3: // $28
      var $29=$1;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($this, $index, $symbol, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$index;
  $3=$symbol;
  $4=$data;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=$8;
  var $10=__ZN22device_state_interface9state_addEiPKcPvh($5, $6, $7, $9, 2);
  ;
  return $10;
}


function __ZN18device_state_entry4maskEy($this, $_mask$0, $_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$_mask$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$_mask$1;
  var $3=$1;
  var $st$8$0=(($2)|0);
  var $4$0=HEAP32[(($st$8$0)>>2)];
  var $st$8$1=(($2+4)|0);
  var $4$1=HEAP32[(($st$8$1)>>2)];
  var $5=(($3+12)|0);
  var $st$13$0=(($5)|0);
  HEAP32[(($st$13$0)>>2)]=$4$0;
  var $st$13$1=(($5+4)|0);
  HEAP32[(($st$13$1)>>2)]=$4$1;
  __ZN18device_state_entry16format_from_maskEv($3);
  STACKTOP = __stackBase__;
  return $3;
}


function __ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($this, $index, $symbol, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$index;
  $3=$symbol;
  $4=$data;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZN22device_state_interface9state_addEiPKcPvh($5, $6, $7, $8, 1);
  ;
  return $9;
}


function __ZN7astring6formatEPKcz($this, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $ap=__stackBase__;
  $1=$this;
  $2=$format;
  var $3=$1;
  var $4=$ap;
  HEAP32[(($4)>>2)]=arguments[__ZN7astring6formatEPKcz.length];
  var $5=$2;
  var $6=HEAP32[(($ap)>>2)];
  var $7=__Z15astring_vprintfP7astringPKcPc($3, $5, $6);
  var $8=$ap;
  ;
  STACKTOP = __stackBase__;
  return $3;
}


function __ZNK7astringcvPKcEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__Z9astring_cPK7astring($2);
  ;
  return $3;
}


function __ZN8device_t9save_itemItEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemItEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9save_itemIhEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $12, 1, 1);
  ;
  return;
}


function __ZNK8device_t4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK8device_t3tagEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+288)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN12save_manager9save_itemItEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 2, 1);
  ;
  return;
}


function __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($this, $duration, $callback, $name, $param, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $duration; $duration = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($duration)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($duration+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($duration+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6=__stackBase__;
  var $7=__stackBase__+12;
  $1=$this;
  $2=$callback;
  $3=$name;
  $4=$param;
  $5=$ptr;
  var $8=$1;
  var $9=$6;
  var $10=$duration;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[(($10+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[(($10+8)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=__ZNK16device_scheduler7machineEv($8);
  __ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_($7, $11, $12, $13);
  var $14=$4;
  var $15=$5;
  __ZN16device_scheduler9timer_setE8attotime8delegateIFvPviEEiS2_($8, $6, $7, $14, $15);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvPviEEC2I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_($5, $6, $7, $8);
  ;
  return;
}


function __ZN8delegateIFvPviEEC2I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIvPvi8_noparamS1_EC2I15running_machineEEN15delegate_traitsIT_vS0_iS1_S1_E20static_ref_func_typeEPKcPS6_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_EC2I15running_machineEEN15delegate_traitsIT_vS0_iS1_S1_E20static_ref_func_typeEPKcPS6_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=88;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIvPvi8_noparamS1_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN21delegate_internal_mfpC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN21delegate_internal_mfpC2Ev($2);
  ;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI15running_machine, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvPvi8_noparamS1_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14get_safe_tokenP8device_t305($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP17legacy_cpu_device8device_tET_PT0_($6);
      var $8=__ZNK17legacy_cpu_device5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht($device, $irqcallback, $feature_mask, $romsize) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpustate;
      var $state=__stackBase__;
      var $tempstr=__stackBase__+4;
      var $regnum;
      var $5;
      var $6;
      $1=$device;
      $2=$irqcallback;
      $3=$feature_mask;
      $4=$romsize;
      var $7=$1;
      var $8=$7;
      var $9=__ZL14get_safe_tokenP8device_t($8);
      $cpustate=$9;
      var $10=$4;
      var $11=(($10 << 16) >> 16)!=0;
      var $12=$11 ? 0 : 1;
      var $13=(($12) & 255);
      var $14=$cpustate;
      var $15=(($14+15)|0);
      HEAP8[($15)]=$13;
      var $16=$2;
      var $17=$cpustate;
      var $18=(($17+36)|0);
      HEAP32[(($18)>>2)]=$16;
      var $19=$1;
      var $20=$cpustate;
      var $21=(($20+40)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$4;
      var $23=$cpustate;
      var $24=(($23+66)|0);
      HEAP16[(($24)>>1)]=$22;
      var $25=$3;
      var $26=$cpustate;
      var $27=(($26+64)|0);
      HEAP8[($27)]=$25;
      var $28=$1;
      var $29=$28;
      var $30=(($29+5968)|0);
      var $31=$30;
      var $32=__ZNK23device_memory_interface5spaceE16address_spacenum($31, 0);
      var $33=$cpustate;
      var $34=(($33+48)|0);
      HEAP32[(($34)>>2)]=$32;
      var $35=$cpustate;
      var $36=(($35+48)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=__ZNK13address_space6directEv($37);
      var $39=$cpustate;
      var $40=(($39+52)|0);
      HEAP32[(($40)>>2)]=$38;
      var $41=$1;
      var $42=$41;
      var $43=(($42+5968)|0);
      var $44=$43;
      var $45=__ZNK23device_memory_interface5spaceE16address_spacenum($44, 1);
      var $46=$cpustate;
      var $47=(($46+56)|0);
      HEAP32[(($47)>>2)]=$45;
      var $48=$1;
      var $49=$48;
      var $50=(($49+5968)|0);
      var $51=$50;
      var $52=__ZNK23device_memory_interface5spaceE16address_spacenum($51, 2);
      var $53=$cpustate;
      var $54=(($53+60)|0);
      HEAP32[(($54)>>2)]=$52;
      var $55=$1;
      var $56=$55;
      var $57=__ZN8device_t9interfaceERP22device_state_interface($56, $state);
      var $58=HEAP32[(($state)>>2)];
      var $59=$cpustate;
      var $60=(($59+2)|0);
      var $61=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($58, 0, ((STRING_TABLE.__str32194)|0), $60);
      var $$emscripten$temp$0$0=4095;
      var $$emscripten$temp$0$1=0;
      var $62=__ZN18device_state_entry4maskEy($61, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $63=HEAP32[(($state)>>2)];
      var $64=$cpustate;
      var $65=(($64+2)|0);
      var $66=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($63, -1, ((STRING_TABLE.__str33195)|0), $65);
      var $$emscripten$temp$1$0=4095;
      var $$emscripten$temp$1$1=0;
      var $67=__ZN18device_state_entry4maskEy($66, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      var $68=__ZN18device_state_entry6noshowEv($67);
      var $69=HEAP32[(($state)>>2)];
      var $70=$cpustate;
      var $71=(($70)|0);
      var $72=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($69, -2, ((STRING_TABLE.__str34196)|0), $71);
      var $$emscripten$temp$2$0=4095;
      var $$emscripten$temp$2$1=0;
      var $73=__ZN18device_state_entry4maskEy($72, $$emscripten$temp$2$0, $$emscripten$temp$2$1);
      var $74=__ZN18device_state_entry6noshowEv($73);
      var $75=HEAP32[(($state)>>2)];
      var $76=$cpustate;
      var $77=(($76+12)|0);
      var $78=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($75, -3, ((STRING_TABLE.__str35197)|0), $77);
      var $$emscripten$temp$3$0=7;
      var $$emscripten$temp$3$1=0;
      var $79=__ZN18device_state_entry4maskEy($78, $$emscripten$temp$3$0, $$emscripten$temp$3$1);
      var $80=__ZN18device_state_entry6noshowEv($79);
      var $81=HEAP32[(($state)>>2)];
      var $82=$cpustate;
      var $83=(($82+12)|0);
      var $84=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($81, -4, ((STRING_TABLE.__str36198)|0), $83);
      var $85=__ZN18device_state_entry6noshowEv($84);
      var $86=__ZN18device_state_entry9formatstrEPKc($85, ((STRING_TABLE.__str37199)|0));
      var $87=HEAP32[(($state)>>2)];
      var $88=$cpustate;
      var $89=(($88+4)|0);
      var $90=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($87, 2, ((STRING_TABLE.__str38200)|0), $89);
      var $91=HEAP32[(($state)>>2)];
      var $92=$cpustate;
      var $93=(($92+16)|0);
      var $94=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($91, 3, ((STRING_TABLE.__str39201)|0), $93);
      var $95=HEAP32[(($state)>>2)];
      var $96=$cpustate;
      var $97=(($96+17)|0);
      var $98=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($95, 4, ((STRING_TABLE.__str40202)|0), $97);
      var $$emscripten$temp$4$0=31;
      var $$emscripten$temp$4$1=0;
      var $99=__ZN18device_state_entry4maskEy($98, $$emscripten$temp$4$0, $$emscripten$temp$4$1);
      var $100=HEAP32[(($state)>>2)];
      var $101=$cpustate;
      var $102=(($101+13)|0);
      var $103=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($100, 5, ((STRING_TABLE.__str41203)|0), $102);
      var $104=HEAP32[(($state)>>2)];
      var $105=$cpustate;
      var $106=(($105+14)|0);
      var $107=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($104, 6, ((STRING_TABLE.__str42204)|0), $106);
      __ZN7astringC1Ev($tempstr);
      $regnum=0;
      __label__ = 1; break;
    case 1: // $108
      var $109=$regnum;
      var $110=(($109)|0) < 8;
      if ($110) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $111
      var $112=HEAP32[(($state)>>2)];
      var $113=$regnum;
      var $114=(($113+7)|0);
      var $115=$regnum;
      var $116=(function() { try { __THREW__ = false; return __ZN7astring6formatEPKcz($tempstr, ((STRING_TABLE.__str43205)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$115,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 9; break; };
    case 3: // $117
      var $118=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; };
    case 4: // $119
      var $120=$cpustate;
      var $121=(($120+68)|0);
      var $122=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($112, $114, $118, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; };
    case 5: // $123
      var $124=(function() { try { __THREW__ = false; return __ZN18device_state_entry10callimportEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $125
      var $126=(function() { try { __THREW__ = false; return __ZN18device_state_entry10callexportEv($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $127
      __label__ = 8; break;
    case 8: // $128
      var $129=$regnum;
      var $130=(($129+1)|0);
      $regnum=$130;
      __label__ = 1; break;
    case 9: // $131
      var $132=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $133=$132.f0;
      $5=$133;
      var $134=$132.f1;
      $6=$134;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 10: // $135
      var $136=HEAP32[(($state)>>2)];
      var $137=$cpustate;
      var $138=(($137+15)|0);
      var $139=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($136, 15, ((STRING_TABLE.__str44206)|0), $138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $140
      var $$emscripten$temp$5$0=1;
      var $$emscripten$temp$5$1=0;
      var $141=(function() { try { __THREW__ = false; return __ZN18device_state_entry4maskEy($139, $$emscripten$temp$5$0, $$emscripten$temp$5$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $142
      var $143=$3;
      var $144=(($143)&255);
      var $145=$144 & 2;
      var $146=(($145)|0)!=0;
      if ($146) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $147
      var $148=HEAP32[(($state)>>2)];
      var $149=$cpustate;
      var $150=(($149+19)|0);
      var $151=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($148, 16, ((STRING_TABLE.__str45207)|0), $150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 9; break; };
    case 14: // $152
      var $153=HEAP32[(($state)>>2)];
      var $154=$cpustate;
      var $155=(($154+20)|0);
      var $156=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($153, 18, ((STRING_TABLE.__str46208)|0), $155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 9; break; };
    case 15: // $157
      var $158=HEAP32[(($state)>>2)];
      var $159=$cpustate;
      var $160=(($159+21)|0);
      var $161=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($158, 17, ((STRING_TABLE.__str47209)|0), $160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 9; break; };
    case 16: // $162
      __label__ = 17; break;
    case 17: // $163
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      var $164=$cpustate;
      __ZL13update_regptrP12_mcs48_state($164);
      var $165=$1;
      var $166=$165;
      var $167=$cpustate;
      var $168=(($167)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($166, $168, ((STRING_TABLE.__str48210)|0), 0);
      var $169=$1;
      var $170=$169;
      var $171=$cpustate;
      var $172=(($171+2)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($170, $172, ((STRING_TABLE.__str49211)|0), 0);
      var $173=$1;
      var $174=$173;
      var $175=$cpustate;
      var $176=(($175+4)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($174, $176, ((STRING_TABLE.__str50212)|0), 0);
      var $177=$1;
      var $178=$177;
      var $179=$cpustate;
      var $180=(($179+12)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($178, $180, ((STRING_TABLE.__str51213)|0), 0);
      var $181=$1;
      var $182=$181;
      var $183=$cpustate;
      var $184=(($183+13)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($182, $184, ((STRING_TABLE.__str52214)|0), 0);
      var $185=$1;
      var $186=$185;
      var $187=$cpustate;
      var $188=(($187+14)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($186, $188, ((STRING_TABLE.__str53215)|0), 0);
      var $189=$1;
      var $190=$189;
      var $191=$cpustate;
      var $192=(($191+15)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($190, $192, ((STRING_TABLE.__str54216)|0), 0);
      var $193=$1;
      var $194=$193;
      var $195=$cpustate;
      var $196=(($195+16)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($194, $196, ((STRING_TABLE.__str55217)|0), 0);
      var $197=$1;
      var $198=$197;
      var $199=$cpustate;
      var $200=(($199+17)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($198, $200, ((STRING_TABLE.__str56218)|0), 0);
      var $201=$1;
      var $202=$201;
      var $203=$cpustate;
      var $204=(($203+18)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($202, $204, ((STRING_TABLE.__str57219)|0), 0);
      var $205=$1;
      var $206=$205;
      var $207=$cpustate;
      var $208=(($207+19)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($206, $208, ((STRING_TABLE.__str58220)|0), 0);
      var $209=$1;
      var $210=$209;
      var $211=$cpustate;
      var $212=(($211+20)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($210, $212, ((STRING_TABLE.__str59221)|0), 0);
      var $213=$1;
      var $214=$213;
      var $215=$cpustate;
      var $216=(($215+21)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($214, $216, ((STRING_TABLE.__str60222)|0), 0);
      var $217=$1;
      var $218=$217;
      var $219=$cpustate;
      var $220=(($219+22)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($218, $220, ((STRING_TABLE.__str61223)|0), 0);
      var $221=$1;
      var $222=$221;
      var $223=$cpustate;
      var $224=(($223+23)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($222, $224, ((STRING_TABLE.__str62224)|0), 0);
      var $225=$1;
      var $226=$225;
      var $227=$cpustate;
      var $228=(($227+24)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($226, $228, ((STRING_TABLE.__str63225)|0), 0);
      var $229=$1;
      var $230=$229;
      var $231=$cpustate;
      var $232=(($231+25)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($230, $232, ((STRING_TABLE.__str64226)|0), 0);
      var $233=$1;
      var $234=$233;
      var $235=$cpustate;
      var $236=(($235+26)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($234, $236, ((STRING_TABLE.__str65227)|0), 0);
      var $237=$1;
      var $238=$237;
      var $239=$cpustate;
      var $240=(($239+27)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($238, $240, ((STRING_TABLE.__str66228)|0), 0);
      var $241=$1;
      var $242=$241;
      var $243=$cpustate;
      var $244=(($243+28)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($242, $244, ((STRING_TABLE.__str67229)|0), 0);
      var $245=$1;
      var $246=$245;
      var $247=$cpustate;
      var $248=(($247+29)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($246, $248, ((STRING_TABLE.__str68230)|0), 0);
      var $249=$1;
      var $250=$249;
      var $251=$cpustate;
      var $252=(($251+30)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($250, $252, ((STRING_TABLE.__str69231)|0), 0);
      var $253=$1;
      var $254=$253;
      var $255=$cpustate;
      var $256=(($255+32)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($254, $256, ((STRING_TABLE.__str70232)|0), 0);
      STACKTOP = __stackBase__;
      return;
    case 18: // $257
      __label__ = 19; break;
    case 19: // $258
      var $259=$5;
      var $260=$5;
      var $261=$6;
      var $262=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $260, tempValue);
      var $263=($262.f1 = $261, $262);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $264
      var $265=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht["X"]=1;

function __Z16cpu_get_info_z80P17legacy_cpu_devicejP7cpuinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $z80;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$1;
      var $8=__ZNK17legacy_cpu_device5tokenEv($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$1;
      var $12=$11;
      var $13=__ZL14get_safe_tokenP8device_t305($12);
      var $16 = $13;__label__ = 4; break;
    case 3: // $14
      var $16 = 0;__label__ = 4; break;
    case 4: // $15
      var $16;
      $z80=$16;
      var $17=$2;
      if ($17 == 16384) {
        __label__ = 5; break;
      }
      else if ($17 == 16385) {
        __label__ = 6; break;
      }
      else if ($17 == 16386) {
        __label__ = 7; break;
      }
      else if ($17 == 2) {
        __label__ = 8; break;
      }
      else if ($17 == 16387) {
        __label__ = 9; break;
      }
      else if ($17 == 16388) {
        __label__ = 10; break;
      }
      else if ($17 == 16389) {
        __label__ = 11; break;
      }
      else if ($17 == 16390) {
        __label__ = 12; break;
      }
      else if ($17 == 16391) {
        __label__ = 13; break;
      }
      else if ($17 == 16392) {
        __label__ = 14; break;
      }
      else if ($17 == 3) {
        __label__ = 15; break;
      }
      else if ($17 == 7) {
        __label__ = 16; break;
      }
      else if ($17 == 11) {
        __label__ = 17; break;
      }
      else if ($17 == 5) {
        __label__ = 18; break;
      }
      else if ($17 == 9) {
        __label__ = 19; break;
      }
      else if ($17 == 13) {
        __label__ = 20; break;
      }
      else if ($17 == 16433) {
        __label__ = 21; break;
      }
      else if ($17 == 16401) {
        __label__ = 22; break;
      }
      else if ($17 == 147456) {
        __label__ = 23; break;
      }
      else if ($17 == 147457) {
        __label__ = 24; break;
      }
      else if ($17 == 147458) {
        __label__ = 25; break;
      }
      else if ($17 == 147459) {
        __label__ = 26; break;
      }
      else if ($17 == 147460) {
        __label__ = 27; break;
      }
      else if ($17 == 147462) {
        __label__ = 28; break;
      }
      else if ($17 == 147468) {
        __label__ = 29; break;
      }
      else if ($17 == 147469) {
        __label__ = 30; break;
      }
      else if ($17 == 147471) {
        __label__ = 31; break;
      }
      else if ($17 == 81920) {
        __label__ = 32; break;
      }
      else if ($17 == 196608) {
        __label__ = 33; break;
      }
      else if ($17 == 196610) {
        __label__ = 34; break;
      }
      else if ($17 == 196611) {
        __label__ = 35; break;
      }
      else if ($17 == 196612) {
        __label__ = 36; break;
      }
      else if ($17 == 196613) {
        __label__ = 37; break;
      }
      else {
      __label__ = 38; break;
      }
      
    case 5: // $18
      var $19=$3;
      var $20=$19;
      var $$emscripten$temp$0$0=132;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($20)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($20+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 38; break;
    case 6: // $21
      var $22=$3;
      var $23=$22;
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($23)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($23+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 38; break;
    case 7: // $24
      var $25=$3;
      var $26=$25;
      var $$emscripten$temp$2$0=255;
      var $$emscripten$temp$2$1=0;
      var $st$4$0=(($26)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$2$0;
      var $st$4$1=(($26+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 38; break;
    case 8: // $27
      var $28=$3;
      var $29=$28;
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$4$0=(($29)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$3$0;
      var $st$4$1=(($29+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 38; break;
    case 9: // $30
      var $31=$3;
      var $32=$31;
      var $$emscripten$temp$4$0=1;
      var $$emscripten$temp$4$1=0;
      var $st$4$0=(($32)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$4$0;
      var $st$4$1=(($32+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 38; break;
    case 10: // $33
      var $34=$3;
      var $35=$34;
      var $$emscripten$temp$5$0=1;
      var $$emscripten$temp$5$1=0;
      var $st$4$0=(($35)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$5$0;
      var $st$4$1=(($35+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 38; break;
    case 11: // $36
      var $37=$3;
      var $38=$37;
      var $$emscripten$temp$6$0=1;
      var $$emscripten$temp$6$1=0;
      var $st$4$0=(($38)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$6$0;
      var $st$4$1=(($38+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$6$1;
      __label__ = 38; break;
    case 12: // $39
      var $40=$3;
      var $41=$40;
      var $$emscripten$temp$7$0=4;
      var $$emscripten$temp$7$1=0;
      var $st$4$0=(($41)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$7$0;
      var $st$4$1=(($41+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$7$1;
      __label__ = 38; break;
    case 13: // $42
      var $43=$3;
      var $44=$43;
      var $$emscripten$temp$8$0=2;
      var $$emscripten$temp$8$1=0;
      var $st$4$0=(($44)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$8$0;
      var $st$4$1=(($44+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$8$1;
      __label__ = 38; break;
    case 14: // $45
      var $46=$3;
      var $47=$46;
      var $$emscripten$temp$9$0=16;
      var $$emscripten$temp$9$1=0;
      var $st$4$0=(($47)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$9$0;
      var $st$4$1=(($47+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$9$1;
      __label__ = 38; break;
    case 15: // $48
      var $49=$3;
      var $50=$49;
      var $$emscripten$temp$10$0=8;
      var $$emscripten$temp$10$1=0;
      var $st$4$0=(($50)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$10$0;
      var $st$4$1=(($50+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$10$1;
      __label__ = 38; break;
    case 16: // $51
      var $52=$3;
      var $53=$52;
      var $$emscripten$temp$11$0=16;
      var $$emscripten$temp$11$1=0;
      var $st$4$0=(($53)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$11$0;
      var $st$4$1=(($53+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$11$1;
      __label__ = 38; break;
    case 17: // $54
      var $55=$3;
      var $56=$55;
      var $$emscripten$temp$12$0=0;
      var $$emscripten$temp$12$1=0;
      var $st$4$0=(($56)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$12$0;
      var $st$4$1=(($56+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$12$1;
      __label__ = 38; break;
    case 18: // $57
      var $58=$3;
      var $59=$58;
      var $$emscripten$temp$13$0=8;
      var $$emscripten$temp$13$1=0;
      var $st$4$0=(($59)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$13$0;
      var $st$4$1=(($59+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$13$1;
      __label__ = 38; break;
    case 19: // $60
      var $61=$3;
      var $62=$61;
      var $$emscripten$temp$14$0=16;
      var $$emscripten$temp$14$1=0;
      var $st$4$0=(($62)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$14$0;
      var $st$4$1=(($62+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$14$1;
      __label__ = 38; break;
    case 20: // $63
      var $64=$3;
      var $65=$64;
      var $$emscripten$temp$15$0=0;
      var $$emscripten$temp$15$1=0;
      var $st$4$0=(($65)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$15$0;
      var $st$4$1=(($65+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$15$1;
      __label__ = 38; break;
    case 21: // $66
      var $67=$z80;
      var $68=(($67+63)|0);
      var $69=HEAP8[($68)];
      var $70$0=$69;
      var $70$1=0;
      var $71=$3;
      var $72=$71;
      var $st$7$0=(($72)|0);
      HEAP32[(($st$7$0)>>2)]=$70$0;
      var $st$7$1=(($72+4)|0);
      HEAP32[(($st$7$1)>>2)]=$70$1;
      __label__ = 38; break;
    case 22: // $73
      var $74=$z80;
      var $75=(($74+65)|0);
      var $76=HEAP8[($75)];
      var $77$0=$76;
      var $77$1=0;
      var $78=$3;
      var $79=$78;
      var $st$7$0=(($79)|0);
      HEAP32[(($st$7$0)>>2)]=$77$0;
      var $st$7$1=(($79+4)|0);
      HEAP32[(($st$7$1)>>2)]=$77$1;
      __label__ = 38; break;
    case 23: // $80
      var $81=$3;
      var $82=$81;
      HEAP32[(($82)>>2)]=90;
      __label__ = 38; break;
    case 24: // $83
      var $84=$3;
      var $85=$84;
      HEAP32[(($85)>>2)]=92;
      __label__ = 38; break;
    case 25: // $86
      var $87=$3;
      var $88=$87;
      HEAP32[(($88)>>2)]=94;
      __label__ = 38; break;
    case 26: // $89
      var $90=$3;
      var $91=$90;
      HEAP32[(($91)>>2)]=96;
      __label__ = 38; break;
    case 27: // $92
      var $93=$3;
      var $94=$93;
      HEAP32[(($94)>>2)]=98;
      __label__ = 38; break;
    case 28: // $95
      var $96=$3;
      var $97=$96;
      HEAP32[(($97)>>2)]=100;
      __label__ = 38; break;
    case 29: // $98
      var $99=$3;
      var $100=$99;
      HEAP32[(($100)>>2)]=102;
      __label__ = 38; break;
    case 30: // $101
      var $102=$3;
      var $103=$102;
      HEAP32[(($103)>>2)]=104;
      __label__ = 38; break;
    case 31: // $104
      var $105=$3;
      var $106=$105;
      HEAP32[(($106)>>2)]=106;
      __label__ = 38; break;
    case 32: // $107
      var $108=$z80;
      var $109=(($108+96)|0);
      var $110=$3;
      var $111=$110;
      HEAP32[(($111)>>2)]=$109;
      __label__ = 38; break;
    case 33: // $112
      var $113=$3;
      var $114=$113;
      var $115=HEAP32[(($114)>>2)];
      var $116=_strcpy($115, ((STRING_TABLE.__str233)|0));
      __label__ = 38; break;
    case 34: // $117
      var $118=$3;
      var $119=$118;
      var $120=HEAP32[(($119)>>2)];
      var $121=_strcpy($120, ((STRING_TABLE.__str1234)|0));
      __label__ = 38; break;
    case 35: // $122
      var $123=$3;
      var $124=$123;
      var $125=HEAP32[(($124)>>2)];
      var $126=_strcpy($125, ((STRING_TABLE.__str2235)|0));
      __label__ = 38; break;
    case 36: // $127
      var $128=$3;
      var $129=$128;
      var $130=HEAP32[(($129)>>2)];
      var $131=_strcpy($130, ((STRING_TABLE.__str3236)|0));
      __label__ = 38; break;
    case 37: // $132
      var $133=$3;
      var $134=$133;
      var $135=HEAP32[(($134)>>2)];
      var $136=_strcpy($135, ((STRING_TABLE.__str4237)|0));
      __label__ = 38; break;
    case 38: // $137
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16cpu_get_info_z80P17legacy_cpu_devicejP7cpuinfo["X"]=1;

function __ZL16cpu_set_info_z80P17legacy_cpu_devicejP7cpuinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $z80;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$1;
      var $5=$4;
      var $6=__ZL14get_safe_tokenP8device_t305($5);
      $z80=$6;
      var $7=$2;
      if ($7 == 16433) {
        __label__ = 1; break;
      }
      else if ($7 == 16401) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      var $9=$z80;
      var $10=$3;
      var $11=$10;
      var $st$3$0=(($11)|0);
      var $12$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$3$1)>>2)];
      var $13$0=$12$0;
      var $13=$13$0;
      __ZL12set_irq_lineP10_z80_stateii($9, 32, $13);
      __label__ = 3; break;
    case 2: // $14
      var $15=$z80;
      var $16=$3;
      var $17=$16;
      var $st$3$0=(($17)|0);
      var $18$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($17+4)|0);
      var $18$1=HEAP32[(($st$3$1)>>2)];
      var $19$0=$18$0;
      var $19=$19$0;
      __ZL12set_irq_lineP10_z80_stateii($15, 0, $19);
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12cpu_init_z80P17legacy_cpu_devicePFiP8device_tiE($device, $irqcallback) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i1=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $12;
      var $z80;
      var $i;
      var $p;
      var $oldval;
      var $newval;
      var $val;
      var $padd;
      var $padc;
      var $psub;
      var $psbc;
      var $state=__stackBase__+48;
      $11=$device;
      $12=$irqcallback;
      var $13=$11;
      var $14=$13;
      var $15=__ZL14get_safe_tokenP8device_t305($14);
      $z80=$15;
      var $16=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 61; break; } else { __label__ = 2; break; }
    case 2: // $21
      var $22=$6;
      var $23=$7;
      var $24=$8;
      var $25=$result_i;
      var $26=$9;
      var $27=$10;
      HEAP32[(($6)>>2)]=131072;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str3236)|0);
      HEAP32[(($8)>>2)]=3351;
      var $28=HEAP32[(($6)>>2)];
      var $29=HEAP32[(($7)>>2)];
      var $30=HEAP32[(($8)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($9)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($10)>>2)]=$41;
      var $42=HEAP32[(($10)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $44
      var $45=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 7: // $46
      var $47=HEAP32[(($9)>>2)];
      var $48=HEAP32[(($9)>>2)];
      var $49=HEAP32[(($10)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $52
      throw "Reached an unreachable!"
    case 9: // $_ZnajPKci_exit
      var $53=HEAP32[(($result_i)>>2)];
      var $54=$6;
      var $55=$7;
      var $56=$8;
      var $57=$result_i;
      var $58=$9;
      var $59=$10;
      var $60=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $53, 131072);
      HEAP32[((__ZL9SZHVC_add)>>2)]=$60;
      var $61=$1;
      var $62=$2;
      var $63=$3;
      var $64=$result_i1;
      var $65=$4;
      var $66=$5;
      HEAP32[(($1)>>2)]=131072;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3236)|0);
      HEAP32[(($3)>>2)]=3352;
      var $67=HEAP32[(($1)>>2)];
      var $68=HEAP32[(($2)>>2)];
      var $69=HEAP32[(($3)>>2)];
      var $70=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($67, $68, $69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $71
      HEAP32[(($result_i1)>>2)]=$70;
      var $72=HEAP32[(($result_i1)>>2)];
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $74
      var $75=___cxa_allocate_exception(4);
      var $76=$75;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($76);
      (function() { try { __THREW__ = false; return ___cxa_throw($75, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $77
      var $78=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $79=$78.f0;
      HEAP32[(($4)>>2)]=$79;
      var $80=$78.f1;
      HEAP32[(($5)>>2)]=$80;
      var $81=HEAP32[(($5)>>2)];
      var $82=(($81)|0) < 0;
      if ($82) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $83
      var $84=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($84);
      throw "Reached an unreachable!"
    case 14: // $85
      var $86=HEAP32[(($4)>>2)];
      var $87=HEAP32[(($4)>>2)];
      var $88=HEAP32[(($5)>>2)];
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $91
      throw "Reached an unreachable!"
    case 16: // $_ZnajPKci_exit2
      var $92=HEAP32[(($result_i1)>>2)];
      var $93=$1;
      var $94=$2;
      var $95=$3;
      var $96=$result_i1;
      var $97=$4;
      var $98=$5;
      var $99=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $92, 131072);
      HEAP32[((__ZL9SZHVC_sub)>>2)]=$99;
      var $100=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $101=(($100)|0);
      $padd=$101;
      var $102=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $103=(($102+65536)|0);
      $padc=$103;
      var $104=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $105=(($104)|0);
      $psub=$105;
      var $106=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $107=(($106+65536)|0);
      $psbc=$107;
      $oldval=0;
      __label__ = 17; break;
    case 17: // $108
      var $109=$oldval;
      var $110=(($109)|0) < 256;
      if ($110) { __label__ = 18; break; } else { __label__ = 60; break; }
    case 18: // $111
      $newval=0;
      __label__ = 19; break;
    case 19: // $112
      var $113=$newval;
      var $114=(($113)|0) < 256;
      if ($114) { __label__ = 20; break; } else { __label__ = 58; break; }
    case 20: // $115
      var $116=$newval;
      var $117=$oldval;
      var $118=(($116-$117)|0);
      $val=$118;
      var $119=$newval;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $121
      var $122=$newval;
      var $123=$122 & 128;
      var $124=(($123)|0)!=0;
      var $125=$124 ? 128 : 0;
      var $128 = $125;__label__ = 23; break;
    case 22: // $126
      var $128 = 64;__label__ = 23; break;
    case 23: // $127
      var $128;
      var $129=(($128) & 255);
      var $130=$padd;
      HEAP8[($130)]=$129;
      var $131=$newval;
      var $132=$131 & 40;
      var $133=$padd;
      var $134=HEAPU8[($133)];
      var $135=(($134)&255);
      var $136=$135 | $132;
      var $137=(($136) & 255);
      HEAP8[($133)]=$137;
      var $138=$newval;
      var $139=$138 & 15;
      var $140=$oldval;
      var $141=$140 & 15;
      var $142=(($139)|0) < (($141)|0);
      if ($142) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $143
      var $144=$padd;
      var $145=HEAPU8[($144)];
      var $146=(($145)&255);
      var $147=$146 | 16;
      var $148=(($147) & 255);
      HEAP8[($144)]=$148;
      __label__ = 25; break;
    case 25: // $149
      var $150=$newval;
      var $151=$oldval;
      var $152=(($150)|0) < (($151)|0);
      if ($152) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $153
      var $154=$padd;
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$156 | 1;
      var $158=(($157) & 255);
      HEAP8[($154)]=$158;
      __label__ = 27; break;
    case 27: // $159
      var $160=$val;
      var $161=$oldval;
      var $162=$160 ^ $161;
      var $163=$162 ^ 128;
      var $164=$val;
      var $165=$newval;
      var $166=$164 ^ $165;
      var $167=$163 & $166;
      var $168=$167 & 128;
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $170
      var $171=$padd;
      var $172=HEAPU8[($171)];
      var $173=(($172)&255);
      var $174=$173 | 4;
      var $175=(($174) & 255);
      HEAP8[($171)]=$175;
      __label__ = 29; break;
    case 29: // $176
      var $177=$padd;
      var $178=(($177+1)|0);
      $padd=$178;
      var $179=$newval;
      var $180=$oldval;
      var $181=(($179-$180)|0);
      var $182=(($181-1)|0);
      $val=$182;
      var $183=$newval;
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $185
      var $186=$newval;
      var $187=$186 & 128;
      var $188=(($187)|0)!=0;
      var $189=$188 ? 128 : 0;
      var $192 = $189;__label__ = 32; break;
    case 31: // $190
      var $192 = 64;__label__ = 32; break;
    case 32: // $191
      var $192;
      var $193=(($192) & 255);
      var $194=$padc;
      HEAP8[($194)]=$193;
      var $195=$newval;
      var $196=$195 & 40;
      var $197=$padc;
      var $198=HEAPU8[($197)];
      var $199=(($198)&255);
      var $200=$199 | $196;
      var $201=(($200) & 255);
      HEAP8[($197)]=$201;
      var $202=$newval;
      var $203=$202 & 15;
      var $204=$oldval;
      var $205=$204 & 15;
      var $206=(($203)|0) <= (($205)|0);
      if ($206) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $207
      var $208=$padc;
      var $209=HEAPU8[($208)];
      var $210=(($209)&255);
      var $211=$210 | 16;
      var $212=(($211) & 255);
      HEAP8[($208)]=$212;
      __label__ = 34; break;
    case 34: // $213
      var $214=$newval;
      var $215=$oldval;
      var $216=(($214)|0) <= (($215)|0);
      if ($216) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $217
      var $218=$padc;
      var $219=HEAPU8[($218)];
      var $220=(($219)&255);
      var $221=$220 | 1;
      var $222=(($221) & 255);
      HEAP8[($218)]=$222;
      __label__ = 36; break;
    case 36: // $223
      var $224=$val;
      var $225=$oldval;
      var $226=$224 ^ $225;
      var $227=$226 ^ 128;
      var $228=$val;
      var $229=$newval;
      var $230=$228 ^ $229;
      var $231=$227 & $230;
      var $232=$231 & 128;
      var $233=(($232)|0)!=0;
      if ($233) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $234
      var $235=$padc;
      var $236=HEAPU8[($235)];
      var $237=(($236)&255);
      var $238=$237 | 4;
      var $239=(($238) & 255);
      HEAP8[($235)]=$239;
      __label__ = 38; break;
    case 38: // $240
      var $241=$padc;
      var $242=(($241+1)|0);
      $padc=$242;
      var $243=$oldval;
      var $244=$newval;
      var $245=(($243-$244)|0);
      $val=$245;
      var $246=$newval;
      var $247=(($246)|0)!=0;
      if ($247) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $248
      var $249=$newval;
      var $250=$249 & 128;
      var $251=(($250)|0)!=0;
      var $252=$251 ? 128 : 0;
      var $255 = $252;__label__ = 41; break;
    case 40: // $253
      var $255 = 64;__label__ = 41; break;
    case 41: // $254
      var $255;
      var $256=2 | $255;
      var $257=(($256) & 255);
      var $258=$psub;
      HEAP8[($258)]=$257;
      var $259=$newval;
      var $260=$259 & 40;
      var $261=$psub;
      var $262=HEAPU8[($261)];
      var $263=(($262)&255);
      var $264=$263 | $260;
      var $265=(($264) & 255);
      HEAP8[($261)]=$265;
      var $266=$newval;
      var $267=$266 & 15;
      var $268=$oldval;
      var $269=$268 & 15;
      var $270=(($267)|0) > (($269)|0);
      if ($270) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $271
      var $272=$psub;
      var $273=HEAPU8[($272)];
      var $274=(($273)&255);
      var $275=$274 | 16;
      var $276=(($275) & 255);
      HEAP8[($272)]=$276;
      __label__ = 43; break;
    case 43: // $277
      var $278=$newval;
      var $279=$oldval;
      var $280=(($278)|0) > (($279)|0);
      if ($280) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $281
      var $282=$psub;
      var $283=HEAPU8[($282)];
      var $284=(($283)&255);
      var $285=$284 | 1;
      var $286=(($285) & 255);
      HEAP8[($282)]=$286;
      __label__ = 45; break;
    case 45: // $287
      var $288=$val;
      var $289=$oldval;
      var $290=$288 ^ $289;
      var $291=$oldval;
      var $292=$newval;
      var $293=$291 ^ $292;
      var $294=$290 & $293;
      var $295=$294 & 128;
      var $296=(($295)|0)!=0;
      if ($296) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $297
      var $298=$psub;
      var $299=HEAPU8[($298)];
      var $300=(($299)&255);
      var $301=$300 | 4;
      var $302=(($301) & 255);
      HEAP8[($298)]=$302;
      __label__ = 47; break;
    case 47: // $303
      var $304=$psub;
      var $305=(($304+1)|0);
      $psub=$305;
      var $306=$oldval;
      var $307=$newval;
      var $308=(($306-$307)|0);
      var $309=(($308-1)|0);
      $val=$309;
      var $310=$newval;
      var $311=(($310)|0)!=0;
      if ($311) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $312
      var $313=$newval;
      var $314=$313 & 128;
      var $315=(($314)|0)!=0;
      var $316=$315 ? 128 : 0;
      var $319 = $316;__label__ = 50; break;
    case 49: // $317
      var $319 = 64;__label__ = 50; break;
    case 50: // $318
      var $319;
      var $320=2 | $319;
      var $321=(($320) & 255);
      var $322=$psbc;
      HEAP8[($322)]=$321;
      var $323=$newval;
      var $324=$323 & 40;
      var $325=$psbc;
      var $326=HEAPU8[($325)];
      var $327=(($326)&255);
      var $328=$327 | $324;
      var $329=(($328) & 255);
      HEAP8[($325)]=$329;
      var $330=$newval;
      var $331=$330 & 15;
      var $332=$oldval;
      var $333=$332 & 15;
      var $334=(($331)|0) >= (($333)|0);
      if ($334) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $335
      var $336=$psbc;
      var $337=HEAPU8[($336)];
      var $338=(($337)&255);
      var $339=$338 | 16;
      var $340=(($339) & 255);
      HEAP8[($336)]=$340;
      __label__ = 52; break;
    case 52: // $341
      var $342=$newval;
      var $343=$oldval;
      var $344=(($342)|0) >= (($343)|0);
      if ($344) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $345
      var $346=$psbc;
      var $347=HEAPU8[($346)];
      var $348=(($347)&255);
      var $349=$348 | 1;
      var $350=(($349) & 255);
      HEAP8[($346)]=$350;
      __label__ = 54; break;
    case 54: // $351
      var $352=$val;
      var $353=$oldval;
      var $354=$352 ^ $353;
      var $355=$oldval;
      var $356=$newval;
      var $357=$355 ^ $356;
      var $358=$354 & $357;
      var $359=$358 & 128;
      var $360=(($359)|0)!=0;
      if ($360) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $361
      var $362=$psbc;
      var $363=HEAPU8[($362)];
      var $364=(($363)&255);
      var $365=$364 | 4;
      var $366=(($365) & 255);
      HEAP8[($362)]=$366;
      __label__ = 56; break;
    case 56: // $367
      var $368=$psbc;
      var $369=(($368+1)|0);
      $psbc=$369;
      __label__ = 57; break;
    case 57: // $370
      var $371=$newval;
      var $372=(($371+1)|0);
      $newval=$372;
      __label__ = 19; break;
    case 58: // $373
      __label__ = 59; break;
    case 59: // $374
      var $375=$oldval;
      var $376=(($375+1)|0);
      $oldval=$376;
      __label__ = 17; break;
    case 60: // $377
      __label__ = 61; break;
    case 61: // $378
      $i=0;
      __label__ = 62; break;
    case 62: // $379
      var $380=$i;
      var $381=(($380)|0) < 256;
      if ($381) { __label__ = 63; break; } else { __label__ = 95; break; }
    case 63: // $382
      $p=0;
      var $383=$i;
      var $384=$383 & 1;
      var $385=(($384)|0)!=0;
      if ($385) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $386
      var $387=$p;
      var $388=(($387+1)|0);
      $p=$388;
      __label__ = 65; break;
    case 65: // $389
      var $390=$i;
      var $391=$390 & 2;
      var $392=(($391)|0)!=0;
      if ($392) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $393
      var $394=$p;
      var $395=(($394+1)|0);
      $p=$395;
      __label__ = 67; break;
    case 67: // $396
      var $397=$i;
      var $398=$397 & 4;
      var $399=(($398)|0)!=0;
      if ($399) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $400
      var $401=$p;
      var $402=(($401+1)|0);
      $p=$402;
      __label__ = 69; break;
    case 69: // $403
      var $404=$i;
      var $405=$404 & 8;
      var $406=(($405)|0)!=0;
      if ($406) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $407
      var $408=$p;
      var $409=(($408+1)|0);
      $p=$409;
      __label__ = 71; break;
    case 71: // $410
      var $411=$i;
      var $412=$411 & 16;
      var $413=(($412)|0)!=0;
      if ($413) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $414
      var $415=$p;
      var $416=(($415+1)|0);
      $p=$416;
      __label__ = 73; break;
    case 73: // $417
      var $418=$i;
      var $419=$418 & 32;
      var $420=(($419)|0)!=0;
      if ($420) { __label__ = 74; break; } else { __label__ = 75; break; }
    case 74: // $421
      var $422=$p;
      var $423=(($422+1)|0);
      $p=$423;
      __label__ = 75; break;
    case 75: // $424
      var $425=$i;
      var $426=$425 & 64;
      var $427=(($426)|0)!=0;
      if ($427) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $428
      var $429=$p;
      var $430=(($429+1)|0);
      $p=$430;
      __label__ = 77; break;
    case 77: // $431
      var $432=$i;
      var $433=$432 & 128;
      var $434=(($433)|0)!=0;
      if ($434) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $435
      var $436=$p;
      var $437=(($436+1)|0);
      $p=$437;
      __label__ = 79; break;
    case 79: // $438
      var $439=$i;
      var $440=(($439)|0)!=0;
      if ($440) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $441
      var $442=$i;
      var $443=$442 & 128;
      var $446 = $443;__label__ = 82; break;
    case 81: // $444
      var $446 = 64;__label__ = 82; break;
    case 82: // $445
      var $446;
      var $447=(($446) & 255);
      var $448=$i;
      var $449=((__ZL2SZ+$448)|0);
      HEAP8[($449)]=$447;
      var $450=$i;
      var $451=$450 & 40;
      var $452=$i;
      var $453=((__ZL2SZ+$452)|0);
      var $454=HEAPU8[($453)];
      var $455=(($454)&255);
      var $456=$455 | $451;
      var $457=(($456) & 255);
      HEAP8[($453)]=$457;
      var $458=$i;
      var $459=(($458)|0)!=0;
      if ($459) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $460
      var $461=$i;
      var $462=$461 & 128;
      var $465 = $462;__label__ = 85; break;
    case 84: // $463
      var $465 = 68;__label__ = 85; break;
    case 85: // $464
      var $465;
      var $466=(($465) & 255);
      var $467=$i;
      var $468=((__ZL6SZ_BIT+$467)|0);
      HEAP8[($468)]=$466;
      var $469=$i;
      var $470=$469 & 40;
      var $471=$i;
      var $472=((__ZL6SZ_BIT+$471)|0);
      var $473=HEAPU8[($472)];
      var $474=(($473)&255);
      var $475=$474 | $470;
      var $476=(($475) & 255);
      HEAP8[($472)]=$476;
      var $477=$i;
      var $478=((__ZL2SZ+$477)|0);
      var $479=HEAPU8[($478)];
      var $480=(($479)&255);
      var $481=$p;
      var $482=$481 & 1;
      var $483=(($482)|0)!=0;
      var $484=$483 ? 0 : 4;
      var $485=$480 | $484;
      var $486=(($485) & 255);
      var $487=$i;
      var $488=((__ZL3SZP+$487)|0);
      HEAP8[($488)]=$486;
      var $489=$i;
      var $490=((__ZL2SZ+$489)|0);
      var $491=HEAP8[($490)];
      var $492=$i;
      var $493=((__ZL8SZHV_inc+$492)|0);
      HEAP8[($493)]=$491;
      var $494=$i;
      var $495=(($494)|0)==128;
      if ($495) { __label__ = 86; break; } else { __label__ = 87; break; }
    case 86: // $496
      var $497=$i;
      var $498=((__ZL8SZHV_inc+$497)|0);
      var $499=HEAPU8[($498)];
      var $500=(($499)&255);
      var $501=$500 | 4;
      var $502=(($501) & 255);
      HEAP8[($498)]=$502;
      __label__ = 87; break;
    case 87: // $503
      var $504=$i;
      var $505=$504 & 15;
      var $506=(($505)|0)==0;
      if ($506) { __label__ = 88; break; } else { __label__ = 89; break; }
    case 88: // $507
      var $508=$i;
      var $509=((__ZL8SZHV_inc+$508)|0);
      var $510=HEAPU8[($509)];
      var $511=(($510)&255);
      var $512=$511 | 16;
      var $513=(($512) & 255);
      HEAP8[($509)]=$513;
      __label__ = 89; break;
    case 89: // $514
      var $515=$i;
      var $516=((__ZL2SZ+$515)|0);
      var $517=HEAPU8[($516)];
      var $518=(($517)&255);
      var $519=$518 | 2;
      var $520=(($519) & 255);
      var $521=$i;
      var $522=((__ZL8SZHV_dec+$521)|0);
      HEAP8[($522)]=$520;
      var $523=$i;
      var $524=(($523)|0)==127;
      if ($524) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $525
      var $526=$i;
      var $527=((__ZL8SZHV_dec+$526)|0);
      var $528=HEAPU8[($527)];
      var $529=(($528)&255);
      var $530=$529 | 4;
      var $531=(($530) & 255);
      HEAP8[($527)]=$531;
      __label__ = 91; break;
    case 91: // $532
      var $533=$i;
      var $534=$533 & 15;
      var $535=(($534)|0)==15;
      if ($535) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $536
      var $537=$i;
      var $538=((__ZL8SZHV_dec+$537)|0);
      var $539=HEAPU8[($538)];
      var $540=(($539)&255);
      var $541=$540 | 16;
      var $542=(($541) & 255);
      HEAP8[($538)]=$542;
      __label__ = 93; break;
    case 93: // $543
      __label__ = 94; break;
    case 94: // $544
      var $545=$i;
      var $546=(($545+1)|0);
      $i=$546;
      __label__ = 62; break;
    case 95: // $547
      var $548=$11;
      var $549=$548;
      var $550=$z80;
      var $551=(($550)|0);
      var $552=$551;
      var $553=(($552)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($549, $553, ((STRING_TABLE.__str13248)|0), 0);
      var $554=$11;
      var $555=$554;
      var $556=$z80;
      var $557=(($556+4)|0);
      var $558=$557;
      var $559=(($558)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($555, $559, ((STRING_TABLE.__str14249)|0), 0);
      var $560=$11;
      var $561=$560;
      var $562=$z80;
      var $563=(($562+8)|0);
      var $564=$563;
      var $565=(($564)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($561, $565, ((STRING_TABLE.__str15250)|0), 0);
      var $566=$11;
      var $567=$566;
      var $568=$z80;
      var $569=(($568+12)|0);
      var $570=$569;
      var $571=(($570)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($567, $571, ((STRING_TABLE.__str16251)|0), 0);
      var $572=$11;
      var $573=$572;
      var $574=$z80;
      var $575=(($574+16)|0);
      var $576=$575;
      var $577=(($576)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($573, $577, ((STRING_TABLE.__str17252)|0), 0);
      var $578=$11;
      var $579=$578;
      var $580=$z80;
      var $581=(($580+20)|0);
      var $582=$581;
      var $583=(($582)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($579, $583, ((STRING_TABLE.__str18253)|0), 0);
      var $584=$11;
      var $585=$584;
      var $586=$z80;
      var $587=(($586+24)|0);
      var $588=$587;
      var $589=(($588)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($585, $589, ((STRING_TABLE.__str19254)|0), 0);
      var $590=$11;
      var $591=$590;
      var $592=$z80;
      var $593=(($592+28)|0);
      var $594=$593;
      var $595=(($594)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($591, $595, ((STRING_TABLE.__str20255)|0), 0);
      var $596=$11;
      var $597=$596;
      var $598=$z80;
      var $599=(($598+32)|0);
      var $600=$599;
      var $601=(($600)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($597, $601, ((STRING_TABLE.__str21256)|0), 0);
      var $602=$11;
      var $603=$602;
      var $604=$z80;
      var $605=(($604+36)|0);
      var $606=$605;
      var $607=(($606)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($603, $607, ((STRING_TABLE.__str22257)|0), 0);
      var $608=$11;
      var $609=$608;
      var $610=$z80;
      var $611=(($610+40)|0);
      var $612=$611;
      var $613=(($612)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($609, $613, ((STRING_TABLE.__str23258)|0), 0);
      var $614=$11;
      var $615=$614;
      var $616=$z80;
      var $617=(($616+44)|0);
      var $618=$617;
      var $619=(($618)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($615, $619, ((STRING_TABLE.__str24259)|0), 0);
      var $620=$11;
      var $621=$620;
      var $622=$z80;
      var $623=(($622+48)|0);
      var $624=$623;
      var $625=(($624)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($621, $625, ((STRING_TABLE.__str25260)|0), 0);
      var $626=$11;
      var $627=$626;
      var $628=$z80;
      var $629=(($628+52)|0);
      var $630=$629;
      var $631=(($630)|0);
      __ZN8device_t9save_itemItEEvRT_PKci($627, $631, ((STRING_TABLE.__str26261)|0), 0);
      var $632=$11;
      var $633=$632;
      var $634=$z80;
      var $635=(($634+56)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($633, $635, ((STRING_TABLE.__str27262)|0), 0);
      var $636=$11;
      var $637=$636;
      var $638=$z80;
      var $639=(($638+57)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($637, $639, ((STRING_TABLE.__str28263)|0), 0);
      var $640=$11;
      var $641=$640;
      var $642=$z80;
      var $643=(($642+58)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($641, $643, ((STRING_TABLE.__str29264)|0), 0);
      var $644=$11;
      var $645=$644;
      var $646=$z80;
      var $647=(($646+59)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($645, $647, ((STRING_TABLE.__str30265)|0), 0);
      var $648=$11;
      var $649=$648;
      var $650=$z80;
      var $651=(($650+60)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($649, $651, ((STRING_TABLE.__str31266)|0), 0);
      var $652=$11;
      var $653=$652;
      var $654=$z80;
      var $655=(($654+61)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($653, $655, ((STRING_TABLE.__str32267)|0), 0);
      var $656=$11;
      var $657=$656;
      var $658=$z80;
      var $659=(($658+62)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($657, $659, ((STRING_TABLE.__str33268)|0), 0);
      var $660=$11;
      var $661=$660;
      var $662=$z80;
      var $663=(($662+63)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($661, $663, ((STRING_TABLE.__str34269)|0), 0);
      var $664=$11;
      var $665=$664;
      var $666=$z80;
      var $667=(($666+64)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($665, $667, ((STRING_TABLE.__str35270)|0), 0);
      var $668=$11;
      var $669=$668;
      var $670=$z80;
      var $671=(($670+65)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($669, $671, ((STRING_TABLE.__str36271)|0), 0);
      var $672=$11;
      var $673=$672;
      var $674=$z80;
      var $675=(($674+70)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($673, $675, ((STRING_TABLE.__str37272)|0), 0);
      var $676=$11;
      var $677=$676;
      var $678=$z80;
      var $679=(($678+71)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($677, $679, ((STRING_TABLE.__str38273)|0), 0);
      var $680=$z80;
      var $681=(($680)|0);
      var $682=$681;
      HEAP32[(($682)>>2)]=0;
      var $683=$z80;
      var $684=(($683+4)|0);
      var $685=$684;
      HEAP32[(($685)>>2)]=0;
      var $686=$z80;
      var $687=(($686+8)|0);
      var $688=$687;
      HEAP32[(($688)>>2)]=0;
      var $689=$z80;
      var $690=(($689+12)|0);
      var $691=$690;
      HEAP32[(($691)>>2)]=0;
      var $692=$z80;
      var $693=(($692+16)|0);
      var $694=$693;
      HEAP32[(($694)>>2)]=0;
      var $695=$z80;
      var $696=(($695+20)|0);
      var $697=$696;
      HEAP32[(($697)>>2)]=0;
      var $698=$z80;
      var $699=(($698+24)|0);
      var $700=$699;
      HEAP32[(($700)>>2)]=0;
      var $701=$z80;
      var $702=(($701+28)|0);
      var $703=$702;
      HEAP32[(($703)>>2)]=0;
      var $704=$z80;
      var $705=(($704+32)|0);
      var $706=$705;
      HEAP32[(($706)>>2)]=0;
      var $707=$z80;
      var $708=(($707+36)|0);
      var $709=$708;
      var $710=(($709)|0);
      HEAP16[(($710)>>1)]=0;
      var $711=$z80;
      var $712=(($711+40)|0);
      var $713=$712;
      HEAP32[(($713)>>2)]=0;
      var $714=$z80;
      var $715=(($714+44)|0);
      var $716=$715;
      HEAP32[(($716)>>2)]=0;
      var $717=$z80;
      var $718=(($717+48)|0);
      var $719=$718;
      HEAP32[(($719)>>2)]=0;
      var $720=$z80;
      var $721=(($720+52)|0);
      var $722=$721;
      HEAP32[(($722)>>2)]=0;
      var $723=$z80;
      var $724=(($723+56)|0);
      HEAP8[($724)]=0;
      var $725=$z80;
      var $726=(($725+57)|0);
      HEAP8[($726)]=0;
      var $727=$z80;
      var $728=(($727+58)|0);
      HEAP8[($728)]=0;
      var $729=$z80;
      var $730=(($729+59)|0);
      HEAP8[($730)]=0;
      var $731=$z80;
      var $732=(($731+60)|0);
      HEAP8[($732)]=0;
      var $733=$z80;
      var $734=(($733+61)|0);
      HEAP8[($734)]=0;
      var $735=$z80;
      var $736=(($735+62)|0);
      HEAP8[($736)]=0;
      var $737=$z80;
      var $738=(($737+63)|0);
      HEAP8[($738)]=0;
      var $739=$z80;
      var $740=(($739+64)|0);
      HEAP8[($740)]=0;
      var $741=$z80;
      var $742=(($741+65)|0);
      HEAP8[($742)]=0;
      var $743=$z80;
      var $744=(($743+70)|0);
      HEAP8[($744)]=0;
      var $745=$z80;
      var $746=(($745+71)|0);
      HEAP8[($746)]=0;
      var $747=$z80;
      var $748=(($747+72)|0);
      HEAP32[(($748)>>2)]=0;
      var $749=$11;
      var $750=$749;
      var $751=__ZNK8device_t13static_configEv($750);
      var $752=(($751)|0)!=0;
      if ($752) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $753
      var $754=$z80;
      var $755=(($754+100)|0);
      var $756=$11;
      var $757=$756;
      var $758=$11;
      var $759=$758;
      var $760=__ZNK8device_t13static_configEv($759);
      var $761=$760;
      __ZN15z80_daisy_chain4initEP8device_tPK16z80_daisy_config($755, $757, $761);
      __label__ = 97; break;
    case 97: // $762
      var $763=$12;
      var $764=$z80;
      var $765=(($764+76)|0);
      HEAP32[(($765)>>2)]=$763;
      var $766=$11;
      var $767=$z80;
      var $768=(($767+80)|0);
      HEAP32[(($768)>>2)]=$766;
      var $769=$11;
      var $770=$769;
      var $771=(($770+5968)|0);
      var $772=$771;
      var $773=__ZNK23device_memory_interface5spaceE16address_spacenum($772, 0);
      var $774=$z80;
      var $775=(($774+84)|0);
      HEAP32[(($775)>>2)]=$773;
      var $776=$z80;
      var $777=(($776+84)|0);
      var $778=HEAP32[(($777)>>2)];
      var $779=__ZNK13address_space6directEv($778);
      var $780=$z80;
      var $781=(($780+88)|0);
      HEAP32[(($781)>>2)]=$779;
      var $782=$11;
      var $783=$782;
      var $784=(($783+5968)|0);
      var $785=$784;
      var $786=__ZNK23device_memory_interface5spaceE16address_spacenum($785, 2);
      var $787=$z80;
      var $788=(($787+92)|0);
      HEAP32[(($788)>>2)]=$786;
      var $789=$z80;
      var $790=(($789+32)|0);
      var $791=$790;
      var $792=(($791)|0);
      HEAP16[(($792)>>1)]=-1;
      var $793=$z80;
      var $794=(($793+28)|0);
      var $795=$794;
      var $796=(($795)|0);
      HEAP16[(($796)>>1)]=-1;
      var $797=$z80;
      var $798=(($797+12)|0);
      var $799=$798;
      var $800=(($799)|0);
      HEAP8[($800)]=64;
      var $801=$11;
      var $802=$801;
      var $803=__ZN8device_t9interfaceERP22device_state_interface($802, $state);
      var $804=HEAP32[(($state)>>2)];
      var $805=$z80;
      var $806=(($805+4)|0);
      var $807=$806;
      var $808=(($807)|0);
      var $809=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($804, 0, ((STRING_TABLE.__str39274)|0), $808);
      var $810=HEAP32[(($state)>>2)];
      var $811=$z80;
      var $812=(($811+4)|0);
      var $813=$812;
      var $814=(($813)|0);
      var $815=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($810, -1, ((STRING_TABLE.__str40275)|0), $814);
      var $816=__ZN18device_state_entry6noshowEv($815);
      var $817=HEAP32[(($state)>>2)];
      var $818=$z80;
      var $819=(($818)|0);
      var $820=$819;
      var $821=(($820)|0);
      var $822=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($817, -2, ((STRING_TABLE.__str41276)|0), $821);
      var $823=__ZN18device_state_entry6noshowEv($822);
      var $824=HEAP32[(($state)>>2)];
      var $825=$z80;
      var $826=(($825+8)|0);
      var $827=$826;
      var $828=(($827)|0);
      var $829=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($824, 1, ((STRING_TABLE.__str42277)|0), $828);
      var $830=HEAP32[(($state)>>2)];
      var $831=$z80;
      var $832=(($831+8)|0);
      var $833=$832;
      var $834=(($833)|0);
      var $835=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($830, -3, ((STRING_TABLE.__str43278)|0), $834);
      var $836=__ZN18device_state_entry6noshowEv($835);
      var $837=HEAP32[(($state)>>2)];
      var $838=$z80;
      var $839=(($838+12)|0);
      var $840=$839;
      var $841=(($840)|0);
      var $842=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($837, -4, ((STRING_TABLE.__str44279)|0), $841);
      var $843=__ZN18device_state_entry6noshowEv($842);
      var $844=__ZN18device_state_entry9formatstrEPKc($843, ((STRING_TABLE.__str45280)|0));
      var $845=HEAP32[(($state)>>2)];
      var $846=$z80;
      var $847=(($846+12)|0);
      var $848=$847;
      var $849=(($848+1)|0);
      var $850=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($845, 2, ((STRING_TABLE.__str46281)|0), $849);
      var $851=__ZN18device_state_entry6noshowEv($850);
      var $852=HEAP32[(($state)>>2)];
      var $853=$z80;
      var $854=(($853+16)|0);
      var $855=$854;
      var $856=(($855+1)|0);
      var $857=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($852, 3, ((STRING_TABLE.__str47282)|0), $856);
      var $858=__ZN18device_state_entry6noshowEv($857);
      var $859=HEAP32[(($state)>>2)];
      var $860=$z80;
      var $861=(($860+16)|0);
      var $862=$861;
      var $863=(($862)|0);
      var $864=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($859, 4, ((STRING_TABLE.__str48283)|0), $863);
      var $865=__ZN18device_state_entry6noshowEv($864);
      var $866=HEAP32[(($state)>>2)];
      var $867=$z80;
      var $868=(($867+20)|0);
      var $869=$868;
      var $870=(($869+1)|0);
      var $871=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($866, 5, ((STRING_TABLE.__str49284)|0), $870);
      var $872=__ZN18device_state_entry6noshowEv($871);
      var $873=HEAP32[(($state)>>2)];
      var $874=$z80;
      var $875=(($874+20)|0);
      var $876=$875;
      var $877=(($876)|0);
      var $878=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($873, 6, ((STRING_TABLE.__str50285)|0), $877);
      var $879=__ZN18device_state_entry6noshowEv($878);
      var $880=HEAP32[(($state)>>2)];
      var $881=$z80;
      var $882=(($881+24)|0);
      var $883=$882;
      var $884=(($883+1)|0);
      var $885=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($880, 7, ((STRING_TABLE.__str51286)|0), $884);
      var $886=__ZN18device_state_entry6noshowEv($885);
      var $887=HEAP32[(($state)>>2)];
      var $888=$z80;
      var $889=(($888+24)|0);
      var $890=$889;
      var $891=(($890)|0);
      var $892=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($887, 8, ((STRING_TABLE.__str52287)|0), $891);
      var $893=__ZN18device_state_entry6noshowEv($892);
      var $894=HEAP32[(($state)>>2)];
      var $895=$z80;
      var $896=(($895+12)|0);
      var $897=$896;
      var $898=(($897)|0);
      var $899=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($894, 9, ((STRING_TABLE.__str53288)|0), $898);
      var $900=HEAP32[(($state)>>2)];
      var $901=$z80;
      var $902=(($901+16)|0);
      var $903=$902;
      var $904=(($903)|0);
      var $905=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($900, 10, ((STRING_TABLE.__str54289)|0), $904);
      var $906=HEAP32[(($state)>>2)];
      var $907=$z80;
      var $908=(($907+20)|0);
      var $909=$908;
      var $910=(($909)|0);
      var $911=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($906, 11, ((STRING_TABLE.__str55290)|0), $910);
      var $912=HEAP32[(($state)>>2)];
      var $913=$z80;
      var $914=(($913+24)|0);
      var $915=$914;
      var $916=(($915)|0);
      var $917=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($912, 12, ((STRING_TABLE.__str56291)|0), $916);
      var $918=HEAP32[(($state)>>2)];
      var $919=$z80;
      var $920=(($919+28)|0);
      var $921=$920;
      var $922=(($921)|0);
      var $923=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($918, 13, ((STRING_TABLE.__str57292)|0), $922);
      var $924=HEAP32[(($state)>>2)];
      var $925=$z80;
      var $926=(($925+32)|0);
      var $927=$926;
      var $928=(($927)|0);
      var $929=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($924, 14, ((STRING_TABLE.__str58293)|0), $928);
      var $930=HEAP32[(($state)>>2)];
      var $931=$z80;
      var $932=(($931+40)|0);
      var $933=$932;
      var $934=(($933)|0);
      var $935=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($930, 15, ((STRING_TABLE.__str59294)|0), $934);
      var $936=HEAP32[(($state)>>2)];
      var $937=$z80;
      var $938=(($937+44)|0);
      var $939=$938;
      var $940=(($939)|0);
      var $941=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($936, 16, ((STRING_TABLE.__str60295)|0), $940);
      var $942=HEAP32[(($state)>>2)];
      var $943=$z80;
      var $944=(($943+48)|0);
      var $945=$944;
      var $946=(($945)|0);
      var $947=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($942, 17, ((STRING_TABLE.__str61296)|0), $946);
      var $948=HEAP32[(($state)>>2)];
      var $949=$z80;
      var $950=(($949+52)|0);
      var $951=$950;
      var $952=(($951)|0);
      var $953=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($948, 18, ((STRING_TABLE.__str62297)|0), $952);
      var $954=HEAP32[(($state)>>2)];
      var $955=$z80;
      var $956=(($955+36)|0);
      var $957=$956;
      var $958=(($957)|0);
      var $959=__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_($954, 29, ((STRING_TABLE.__str63298)|0), $958);
      var $960=HEAP32[(($state)>>2)];
      var $961=$z80;
      var $962=(($961+104)|0);
      var $963=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($960, 19, ((STRING_TABLE.__str64299)|0), $962);
      var $964=__ZN18device_state_entry10callimportEv($963);
      var $965=__ZN18device_state_entry10callexportEv($964);
      var $966=HEAP32[(($state)>>2)];
      var $967=$z80;
      var $968=(($967+62)|0);
      var $969=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($966, 20, ((STRING_TABLE.__str65300)|0), $968);
      var $970=HEAP32[(($state)>>2)];
      var $971=$z80;
      var $972=(($971+61)|0);
      var $973=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($970, 21, ((STRING_TABLE.__str66301)|0), $972);
      var $$emscripten$temp$0$0=3;
      var $$emscripten$temp$0$1=0;
      var $974=__ZN18device_state_entry4maskEy($973, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $975=HEAP32[(($state)>>2)];
      var $976=$z80;
      var $977=(($976+58)|0);
      var $978=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($975, 22, ((STRING_TABLE.__str67302)|0), $977);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $979=__ZN18device_state_entry4maskEy($978, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      var $980=HEAP32[(($state)>>2)];
      var $981=$z80;
      var $982=(($981+59)|0);
      var $983=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($980, 23, ((STRING_TABLE.__str68303)|0), $982);
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $984=__ZN18device_state_entry4maskEy($983, $$emscripten$temp$2$0, $$emscripten$temp$2$1);
      var $985=HEAP32[(($state)>>2)];
      var $986=$z80;
      var $987=(($986+60)|0);
      var $988=__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_($985, 24, ((STRING_TABLE.__str69304)|0), $987);
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $989=__ZN18device_state_entry4maskEy($988, $$emscripten$temp$3$0, $$emscripten$temp$3$1);
      var $990=$z80;
      var $991=(($990+108)|0);
      HEAP32[(($991)>>2)]=((STRING_TABLE.__ZL5cc_op)|0);
      var $992=$z80;
      var $993=(($992+112)|0);
      HEAP32[(($993)>>2)]=((STRING_TABLE.__ZL5cc_cb)|0);
      var $994=$z80;
      var $995=(($994+116)|0);
      HEAP32[(($995)>>2)]=((STRING_TABLE.__ZL5cc_ed)|0);
      var $996=$z80;
      var $997=(($996+120)|0);
      HEAP32[(($997)>>2)]=((STRING_TABLE.__ZL5cc_xy)|0);
      var $998=$z80;
      var $999=(($998+124)|0);
      HEAP32[(($999)>>2)]=((STRING_TABLE.__ZL7cc_xycb)|0);
      var $1000=$z80;
      var $1001=(($1000+128)|0);
      HEAP32[(($1001)>>2)]=((STRING_TABLE.__ZL5cc_ex)|0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12cpu_init_z80P17legacy_cpu_devicePFiP8device_tiE["X"]=1;

function __ZL13cpu_reset_z80P17legacy_cpu_device($device) {
  ;
  var __label__;

  var $1;
  var $z80;
  $1=$device;
  var $2=$1;
  var $3=$2;
  var $4=__ZL14get_safe_tokenP8device_t305($3);
  $z80=$4;
  var $5=$z80;
  var $6=(($5+4)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=0;
  var $9=$z80;
  var $10=(($9+62)|0);
  HEAP8[($10)]=0;
  var $11=$z80;
  var $12=(($11+56)|0);
  HEAP8[($12)]=0;
  var $13=$z80;
  var $14=(($13+57)|0);
  HEAP8[($14)]=0;
  var $15=$z80;
  var $16=(($15+63)|0);
  HEAP8[($16)]=0;
  var $17=$z80;
  var $18=(($17+64)|0);
  HEAP8[($18)]=0;
  var $19=$z80;
  var $20=(($19+65)|0);
  HEAP8[($20)]=0;
  var $21=$z80;
  var $22=(($21+70)|0);
  HEAP8[($22)]=0;
  var $23=$z80;
  var $24=(($23+71)|0);
  HEAP8[($24)]=0;
  var $25=$z80;
  var $26=(($25+58)|0);
  HEAP8[($26)]=0;
  var $27=$z80;
  var $28=(($27+59)|0);
  HEAP8[($28)]=0;
  var $29=$z80;
  var $30=(($29+100)|0);
  __ZN15z80_daisy_chain5resetEv($30);
  var $31=$z80;
  var $32=(($31+4)|0);
  var $33=$32;
  var $34=HEAP32[(($33)>>2)];
  var $35=(($34) & 65535);
  var $36=$z80;
  var $37=(($36+36)|0);
  var $38=$37;
  var $39=(($38)|0);
  HEAP16[(($39)>>1)]=$35;
  ;
  return;
}
__ZL13cpu_reset_z80P17legacy_cpu_device["X"]=1;

function __ZL12cpu_exit_z80P17legacy_cpu_device($device) {
  ;
  var __label__;

  var $1;
  $1=$device;
  var $2=HEAP32[((__ZL9SZHVC_add)>>2)];
  __ZN13resource_pool6removeEPv(_global_resource_pool, $2);
  HEAP32[((__ZL9SZHVC_add)>>2)]=0;
  var $3=HEAP32[((__ZL9SZHVC_sub)>>2)];
  __ZN13resource_pool6removeEPv(_global_resource_pool, $3);
  HEAP32[((__ZL9SZHVC_sub)>>2)]=0;
  ;
  return;
}


function __ZL15cpu_execute_z80P17legacy_cpu_device($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $z80;
      var $op;
      $1=$device;
      var $2=$1;
      var $3=$2;
      var $4=__ZL14get_safe_tokenP8device_t305($3);
      $z80=$4;
      var $5=$z80;
      var $6=(($5+64)|0);
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      __label__ = 3; break;
    case 3: // $11
      var $12=$z80;
      var $13=(($12)|0);
      var $14=$13;
      HEAP32[(($14)>>2)]=-1;
      __label__ = 4; break;
    case 4: // $15
      var $16=$z80;
      var $17=(($16+60)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $20
      var $21=$z80;
      var $22=(($21+60)|0);
      HEAP8[($22)]=0;
      var $23=$z80;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=(($27+1)&65535);
      HEAP16[(($26)>>1)]=$28;
      __label__ = 6; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=$z80;
      var $32=(($31+71)|0);
      HEAP8[($32)]=0;
      var $33=$z80;
      var $34=(($33+58)|0);
      HEAP8[($34)]=0;
      __label__ = 8; break;
    case 8: // $35
      var $36=$z80;
      var $37=(($36+8)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAPU16[(($39)>>1)];
      var $41=(($40)&65535);
      var $42=(($41-2)|0);
      var $43=(($42) & 65535);
      HEAP16[(($39)>>1)]=$43;
      var $44=$z80;
      var $45=$z80;
      var $46=(($45+8)|0);
      var $47=$46;
      var $48=HEAP32[(($47)>>2)];
      var $49=$z80;
      var $50=(($49+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($44, $48, $50);
      __label__ = 9; break;
    case 9: // $51
      var $52=$z80;
      var $53=(($52+4)|0);
      var $54=$53;
      HEAP32[(($54)>>2)]=102;
      var $55=$z80;
      var $56=(($55+4)|0);
      var $57=$56;
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58) & 65535);
      var $60=$z80;
      var $61=(($60+36)|0);
      var $62=$61;
      var $63=(($62)|0);
      HEAP16[(($63)>>1)]=$59;
      var $64=$z80;
      var $65=(($64+96)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66-11)|0);
      HEAP32[(($65)>>2)]=$67;
      var $68=$z80;
      var $69=(($68+64)|0);
      HEAP8[($69)]=0;
      __label__ = 10; break;
    case 10: // $70
      __label__ = 11; break;
    case 11: // $71
      var $72=$z80;
      var $73=(($72+65)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $77
      var $78=$z80;
      var $79=(($78+58)|0);
      var $80=HEAP8[($79)];
      var $81=(($80 << 24) >> 24)!=0;
      if ($81) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $82
      var $83=$z80;
      var $84=(($83+70)|0);
      var $85=HEAP8[($84)];
      var $86=(($85 << 24) >> 24)!=0;
      if ($86) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $87
      var $88=$z80;
      __ZL14take_interruptP10_z80_state($88);
      __label__ = 15; break;
    case 15: // $89
      var $90=$z80;
      var $91=(($90+70)|0);
      HEAP8[($91)]=0;
      var $92=$z80;
      var $93=(($92+71)|0);
      HEAP8[($93)]=0;
      var $94=$z80;
      var $95=(($94+4)|0);
      var $96=$95;
      var $97=HEAP32[(($96)>>2)];
      var $98=$z80;
      var $99=(($98)|0);
      var $100=$99;
      HEAP32[(($100)>>2)]=$97;
      var $101=$1;
      var $102=$101;
      var $103=$z80;
      var $104=(($103+4)|0);
      var $105=$104;
      var $106=HEAP32[(($105)>>2)];
      __ZL25debugger_instruction_hookP8device_tj306($102, $106);
      var $107=$z80;
      var $108=(($107+56)|0);
      var $109=HEAP8[($108)];
      var $110=(($109+1)&255);
      HEAP8[($108)]=$110;
      var $111=$z80;
      var $112=__ZL3ROPP10_z80_state($111);
      var $113=(($112)&255);
      $op=$113;
      __label__ = 16; break;
    case 16: // $114
      var $115=$op;
      var $116=$z80;
      var $117=(($116+108)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118+$115)|0);
      var $120=HEAPU8[($119)];
      var $121=(($120)&255);
      var $122=$z80;
      var $123=(($122+96)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124-$121)|0);
      HEAP32[(($123)>>2)]=$125;
      __label__ = 17; break;
    case 17: // $126
      var $127=$op;
      if ($127 == 0) {
        __label__ = 18; break;
      }
      else if ($127 == 1) {
        __label__ = 19; break;
      }
      else if ($127 == 2) {
        __label__ = 20; break;
      }
      else if ($127 == 3) {
        __label__ = 21; break;
      }
      else if ($127 == 4) {
        __label__ = 22; break;
      }
      else if ($127 == 5) {
        __label__ = 23; break;
      }
      else if ($127 == 6) {
        __label__ = 24; break;
      }
      else if ($127 == 7) {
        __label__ = 25; break;
      }
      else if ($127 == 8) {
        __label__ = 26; break;
      }
      else if ($127 == 9) {
        __label__ = 27; break;
      }
      else if ($127 == 10) {
        __label__ = 28; break;
      }
      else if ($127 == 11) {
        __label__ = 29; break;
      }
      else if ($127 == 12) {
        __label__ = 30; break;
      }
      else if ($127 == 13) {
        __label__ = 31; break;
      }
      else if ($127 == 14) {
        __label__ = 32; break;
      }
      else if ($127 == 15) {
        __label__ = 33; break;
      }
      else if ($127 == 16) {
        __label__ = 34; break;
      }
      else if ($127 == 17) {
        __label__ = 35; break;
      }
      else if ($127 == 18) {
        __label__ = 36; break;
      }
      else if ($127 == 19) {
        __label__ = 37; break;
      }
      else if ($127 == 20) {
        __label__ = 38; break;
      }
      else if ($127 == 21) {
        __label__ = 39; break;
      }
      else if ($127 == 22) {
        __label__ = 40; break;
      }
      else if ($127 == 23) {
        __label__ = 41; break;
      }
      else if ($127 == 24) {
        __label__ = 42; break;
      }
      else if ($127 == 25) {
        __label__ = 43; break;
      }
      else if ($127 == 26) {
        __label__ = 44; break;
      }
      else if ($127 == 27) {
        __label__ = 45; break;
      }
      else if ($127 == 28) {
        __label__ = 46; break;
      }
      else if ($127 == 29) {
        __label__ = 47; break;
      }
      else if ($127 == 30) {
        __label__ = 48; break;
      }
      else if ($127 == 31) {
        __label__ = 49; break;
      }
      else if ($127 == 32) {
        __label__ = 50; break;
      }
      else if ($127 == 33) {
        __label__ = 51; break;
      }
      else if ($127 == 34) {
        __label__ = 52; break;
      }
      else if ($127 == 35) {
        __label__ = 53; break;
      }
      else if ($127 == 36) {
        __label__ = 54; break;
      }
      else if ($127 == 37) {
        __label__ = 55; break;
      }
      else if ($127 == 38) {
        __label__ = 56; break;
      }
      else if ($127 == 39) {
        __label__ = 57; break;
      }
      else if ($127 == 40) {
        __label__ = 58; break;
      }
      else if ($127 == 41) {
        __label__ = 59; break;
      }
      else if ($127 == 42) {
        __label__ = 60; break;
      }
      else if ($127 == 43) {
        __label__ = 61; break;
      }
      else if ($127 == 44) {
        __label__ = 62; break;
      }
      else if ($127 == 45) {
        __label__ = 63; break;
      }
      else if ($127 == 46) {
        __label__ = 64; break;
      }
      else if ($127 == 47) {
        __label__ = 65; break;
      }
      else if ($127 == 48) {
        __label__ = 66; break;
      }
      else if ($127 == 49) {
        __label__ = 67; break;
      }
      else if ($127 == 50) {
        __label__ = 68; break;
      }
      else if ($127 == 51) {
        __label__ = 69; break;
      }
      else if ($127 == 52) {
        __label__ = 70; break;
      }
      else if ($127 == 53) {
        __label__ = 71; break;
      }
      else if ($127 == 54) {
        __label__ = 72; break;
      }
      else if ($127 == 55) {
        __label__ = 73; break;
      }
      else if ($127 == 56) {
        __label__ = 74; break;
      }
      else if ($127 == 57) {
        __label__ = 75; break;
      }
      else if ($127 == 58) {
        __label__ = 76; break;
      }
      else if ($127 == 59) {
        __label__ = 77; break;
      }
      else if ($127 == 60) {
        __label__ = 78; break;
      }
      else if ($127 == 61) {
        __label__ = 79; break;
      }
      else if ($127 == 62) {
        __label__ = 80; break;
      }
      else if ($127 == 63) {
        __label__ = 81; break;
      }
      else if ($127 == 64) {
        __label__ = 82; break;
      }
      else if ($127 == 65) {
        __label__ = 83; break;
      }
      else if ($127 == 66) {
        __label__ = 84; break;
      }
      else if ($127 == 67) {
        __label__ = 85; break;
      }
      else if ($127 == 68) {
        __label__ = 86; break;
      }
      else if ($127 == 69) {
        __label__ = 87; break;
      }
      else if ($127 == 70) {
        __label__ = 88; break;
      }
      else if ($127 == 71) {
        __label__ = 89; break;
      }
      else if ($127 == 72) {
        __label__ = 90; break;
      }
      else if ($127 == 73) {
        __label__ = 91; break;
      }
      else if ($127 == 74) {
        __label__ = 92; break;
      }
      else if ($127 == 75) {
        __label__ = 93; break;
      }
      else if ($127 == 76) {
        __label__ = 94; break;
      }
      else if ($127 == 77) {
        __label__ = 95; break;
      }
      else if ($127 == 78) {
        __label__ = 96; break;
      }
      else if ($127 == 79) {
        __label__ = 97; break;
      }
      else if ($127 == 80) {
        __label__ = 98; break;
      }
      else if ($127 == 81) {
        __label__ = 99; break;
      }
      else if ($127 == 82) {
        __label__ = 100; break;
      }
      else if ($127 == 83) {
        __label__ = 101; break;
      }
      else if ($127 == 84) {
        __label__ = 102; break;
      }
      else if ($127 == 85) {
        __label__ = 103; break;
      }
      else if ($127 == 86) {
        __label__ = 104; break;
      }
      else if ($127 == 87) {
        __label__ = 105; break;
      }
      else if ($127 == 88) {
        __label__ = 106; break;
      }
      else if ($127 == 89) {
        __label__ = 107; break;
      }
      else if ($127 == 90) {
        __label__ = 108; break;
      }
      else if ($127 == 91) {
        __label__ = 109; break;
      }
      else if ($127 == 92) {
        __label__ = 110; break;
      }
      else if ($127 == 93) {
        __label__ = 111; break;
      }
      else if ($127 == 94) {
        __label__ = 112; break;
      }
      else if ($127 == 95) {
        __label__ = 113; break;
      }
      else if ($127 == 96) {
        __label__ = 114; break;
      }
      else if ($127 == 97) {
        __label__ = 115; break;
      }
      else if ($127 == 98) {
        __label__ = 116; break;
      }
      else if ($127 == 99) {
        __label__ = 117; break;
      }
      else if ($127 == 100) {
        __label__ = 118; break;
      }
      else if ($127 == 101) {
        __label__ = 119; break;
      }
      else if ($127 == 102) {
        __label__ = 120; break;
      }
      else if ($127 == 103) {
        __label__ = 121; break;
      }
      else if ($127 == 104) {
        __label__ = 122; break;
      }
      else if ($127 == 105) {
        __label__ = 123; break;
      }
      else if ($127 == 106) {
        __label__ = 124; break;
      }
      else if ($127 == 107) {
        __label__ = 125; break;
      }
      else if ($127 == 108) {
        __label__ = 126; break;
      }
      else if ($127 == 109) {
        __label__ = 127; break;
      }
      else if ($127 == 110) {
        __label__ = 128; break;
      }
      else if ($127 == 111) {
        __label__ = 129; break;
      }
      else if ($127 == 112) {
        __label__ = 130; break;
      }
      else if ($127 == 113) {
        __label__ = 131; break;
      }
      else if ($127 == 114) {
        __label__ = 132; break;
      }
      else if ($127 == 115) {
        __label__ = 133; break;
      }
      else if ($127 == 116) {
        __label__ = 134; break;
      }
      else if ($127 == 117) {
        __label__ = 135; break;
      }
      else if ($127 == 118) {
        __label__ = 136; break;
      }
      else if ($127 == 119) {
        __label__ = 137; break;
      }
      else if ($127 == 120) {
        __label__ = 138; break;
      }
      else if ($127 == 121) {
        __label__ = 139; break;
      }
      else if ($127 == 122) {
        __label__ = 140; break;
      }
      else if ($127 == 123) {
        __label__ = 141; break;
      }
      else if ($127 == 124) {
        __label__ = 142; break;
      }
      else if ($127 == 125) {
        __label__ = 143; break;
      }
      else if ($127 == 126) {
        __label__ = 144; break;
      }
      else if ($127 == 127) {
        __label__ = 145; break;
      }
      else if ($127 == 128) {
        __label__ = 146; break;
      }
      else if ($127 == 129) {
        __label__ = 147; break;
      }
      else if ($127 == 130) {
        __label__ = 148; break;
      }
      else if ($127 == 131) {
        __label__ = 149; break;
      }
      else if ($127 == 132) {
        __label__ = 150; break;
      }
      else if ($127 == 133) {
        __label__ = 151; break;
      }
      else if ($127 == 134) {
        __label__ = 152; break;
      }
      else if ($127 == 135) {
        __label__ = 153; break;
      }
      else if ($127 == 136) {
        __label__ = 154; break;
      }
      else if ($127 == 137) {
        __label__ = 155; break;
      }
      else if ($127 == 138) {
        __label__ = 156; break;
      }
      else if ($127 == 139) {
        __label__ = 157; break;
      }
      else if ($127 == 140) {
        __label__ = 158; break;
      }
      else if ($127 == 141) {
        __label__ = 159; break;
      }
      else if ($127 == 142) {
        __label__ = 160; break;
      }
      else if ($127 == 143) {
        __label__ = 161; break;
      }
      else if ($127 == 144) {
        __label__ = 162; break;
      }
      else if ($127 == 145) {
        __label__ = 163; break;
      }
      else if ($127 == 146) {
        __label__ = 164; break;
      }
      else if ($127 == 147) {
        __label__ = 165; break;
      }
      else if ($127 == 148) {
        __label__ = 166; break;
      }
      else if ($127 == 149) {
        __label__ = 167; break;
      }
      else if ($127 == 150) {
        __label__ = 168; break;
      }
      else if ($127 == 151) {
        __label__ = 169; break;
      }
      else if ($127 == 152) {
        __label__ = 170; break;
      }
      else if ($127 == 153) {
        __label__ = 171; break;
      }
      else if ($127 == 154) {
        __label__ = 172; break;
      }
      else if ($127 == 155) {
        __label__ = 173; break;
      }
      else if ($127 == 156) {
        __label__ = 174; break;
      }
      else if ($127 == 157) {
        __label__ = 175; break;
      }
      else if ($127 == 158) {
        __label__ = 176; break;
      }
      else if ($127 == 159) {
        __label__ = 177; break;
      }
      else if ($127 == 160) {
        __label__ = 178; break;
      }
      else if ($127 == 161) {
        __label__ = 179; break;
      }
      else if ($127 == 162) {
        __label__ = 180; break;
      }
      else if ($127 == 163) {
        __label__ = 181; break;
      }
      else if ($127 == 164) {
        __label__ = 182; break;
      }
      else if ($127 == 165) {
        __label__ = 183; break;
      }
      else if ($127 == 166) {
        __label__ = 184; break;
      }
      else if ($127 == 167) {
        __label__ = 185; break;
      }
      else if ($127 == 168) {
        __label__ = 186; break;
      }
      else if ($127 == 169) {
        __label__ = 187; break;
      }
      else if ($127 == 170) {
        __label__ = 188; break;
      }
      else if ($127 == 171) {
        __label__ = 189; break;
      }
      else if ($127 == 172) {
        __label__ = 190; break;
      }
      else if ($127 == 173) {
        __label__ = 191; break;
      }
      else if ($127 == 174) {
        __label__ = 192; break;
      }
      else if ($127 == 175) {
        __label__ = 193; break;
      }
      else if ($127 == 176) {
        __label__ = 194; break;
      }
      else if ($127 == 177) {
        __label__ = 195; break;
      }
      else if ($127 == 178) {
        __label__ = 196; break;
      }
      else if ($127 == 179) {
        __label__ = 197; break;
      }
      else if ($127 == 180) {
        __label__ = 198; break;
      }
      else if ($127 == 181) {
        __label__ = 199; break;
      }
      else if ($127 == 182) {
        __label__ = 200; break;
      }
      else if ($127 == 183) {
        __label__ = 201; break;
      }
      else if ($127 == 184) {
        __label__ = 202; break;
      }
      else if ($127 == 185) {
        __label__ = 203; break;
      }
      else if ($127 == 186) {
        __label__ = 204; break;
      }
      else if ($127 == 187) {
        __label__ = 205; break;
      }
      else if ($127 == 188) {
        __label__ = 206; break;
      }
      else if ($127 == 189) {
        __label__ = 207; break;
      }
      else if ($127 == 190) {
        __label__ = 208; break;
      }
      else if ($127 == 191) {
        __label__ = 209; break;
      }
      else if ($127 == 192) {
        __label__ = 210; break;
      }
      else if ($127 == 193) {
        __label__ = 211; break;
      }
      else if ($127 == 194) {
        __label__ = 212; break;
      }
      else if ($127 == 195) {
        __label__ = 213; break;
      }
      else if ($127 == 196) {
        __label__ = 214; break;
      }
      else if ($127 == 197) {
        __label__ = 215; break;
      }
      else if ($127 == 198) {
        __label__ = 216; break;
      }
      else if ($127 == 199) {
        __label__ = 217; break;
      }
      else if ($127 == 200) {
        __label__ = 218; break;
      }
      else if ($127 == 201) {
        __label__ = 219; break;
      }
      else if ($127 == 202) {
        __label__ = 220; break;
      }
      else if ($127 == 203) {
        __label__ = 221; break;
      }
      else if ($127 == 204) {
        __label__ = 222; break;
      }
      else if ($127 == 205) {
        __label__ = 223; break;
      }
      else if ($127 == 206) {
        __label__ = 224; break;
      }
      else if ($127 == 207) {
        __label__ = 225; break;
      }
      else if ($127 == 208) {
        __label__ = 226; break;
      }
      else if ($127 == 209) {
        __label__ = 227; break;
      }
      else if ($127 == 210) {
        __label__ = 228; break;
      }
      else if ($127 == 211) {
        __label__ = 229; break;
      }
      else if ($127 == 212) {
        __label__ = 230; break;
      }
      else if ($127 == 213) {
        __label__ = 231; break;
      }
      else if ($127 == 214) {
        __label__ = 232; break;
      }
      else if ($127 == 215) {
        __label__ = 233; break;
      }
      else if ($127 == 216) {
        __label__ = 234; break;
      }
      else if ($127 == 217) {
        __label__ = 235; break;
      }
      else if ($127 == 218) {
        __label__ = 236; break;
      }
      else if ($127 == 219) {
        __label__ = 237; break;
      }
      else if ($127 == 220) {
        __label__ = 238; break;
      }
      else if ($127 == 221) {
        __label__ = 239; break;
      }
      else if ($127 == 222) {
        __label__ = 240; break;
      }
      else if ($127 == 223) {
        __label__ = 241; break;
      }
      else if ($127 == 224) {
        __label__ = 242; break;
      }
      else if ($127 == 225) {
        __label__ = 243; break;
      }
      else if ($127 == 226) {
        __label__ = 244; break;
      }
      else if ($127 == 227) {
        __label__ = 245; break;
      }
      else if ($127 == 228) {
        __label__ = 246; break;
      }
      else if ($127 == 229) {
        __label__ = 247; break;
      }
      else if ($127 == 230) {
        __label__ = 248; break;
      }
      else if ($127 == 231) {
        __label__ = 249; break;
      }
      else if ($127 == 232) {
        __label__ = 250; break;
      }
      else if ($127 == 233) {
        __label__ = 251; break;
      }
      else if ($127 == 234) {
        __label__ = 252; break;
      }
      else if ($127 == 235) {
        __label__ = 253; break;
      }
      else if ($127 == 236) {
        __label__ = 254; break;
      }
      else if ($127 == 237) {
        __label__ = 255; break;
      }
      else if ($127 == 238) {
        __label__ = 256; break;
      }
      else if ($127 == 239) {
        __label__ = 257; break;
      }
      else if ($127 == 240) {
        __label__ = 258; break;
      }
      else if ($127 == 241) {
        __label__ = 259; break;
      }
      else if ($127 == 242) {
        __label__ = 260; break;
      }
      else if ($127 == 243) {
        __label__ = 261; break;
      }
      else if ($127 == 244) {
        __label__ = 262; break;
      }
      else if ($127 == 245) {
        __label__ = 263; break;
      }
      else if ($127 == 246) {
        __label__ = 264; break;
      }
      else if ($127 == 247) {
        __label__ = 265; break;
      }
      else if ($127 == 248) {
        __label__ = 266; break;
      }
      else if ($127 == 249) {
        __label__ = 267; break;
      }
      else if ($127 == 250) {
        __label__ = 268; break;
      }
      else if ($127 == 251) {
        __label__ = 269; break;
      }
      else if ($127 == 252) {
        __label__ = 270; break;
      }
      else if ($127 == 253) {
        __label__ = 271; break;
      }
      else if ($127 == 254) {
        __label__ = 272; break;
      }
      else if ($127 == 255) {
        __label__ = 273; break;
      }
      else {
      __label__ = 274; break;
      }
      
    case 18: // $128
      var $129=$z80;
      __ZL5op_00P10_z80_state($129);
      __label__ = 274; break;
    case 19: // $130
      var $131=$z80;
      __ZL5op_01P10_z80_state($131);
      __label__ = 274; break;
    case 20: // $132
      var $133=$z80;
      __ZL5op_02P10_z80_state($133);
      __label__ = 274; break;
    case 21: // $134
      var $135=$z80;
      __ZL5op_03P10_z80_state($135);
      __label__ = 274; break;
    case 22: // $136
      var $137=$z80;
      __ZL5op_04P10_z80_state($137);
      __label__ = 274; break;
    case 23: // $138
      var $139=$z80;
      __ZL5op_05P10_z80_state($139);
      __label__ = 274; break;
    case 24: // $140
      var $141=$z80;
      __ZL5op_06P10_z80_state($141);
      __label__ = 274; break;
    case 25: // $142
      var $143=$z80;
      __ZL5op_07P10_z80_state($143);
      __label__ = 274; break;
    case 26: // $144
      var $145=$z80;
      __ZL5op_08P10_z80_state($145);
      __label__ = 274; break;
    case 27: // $146
      var $147=$z80;
      __ZL5op_09P10_z80_state($147);
      __label__ = 274; break;
    case 28: // $148
      var $149=$z80;
      __ZL5op_0aP10_z80_state($149);
      __label__ = 274; break;
    case 29: // $150
      var $151=$z80;
      __ZL5op_0bP10_z80_state($151);
      __label__ = 274; break;
    case 30: // $152
      var $153=$z80;
      __ZL5op_0cP10_z80_state($153);
      __label__ = 274; break;
    case 31: // $154
      var $155=$z80;
      __ZL5op_0dP10_z80_state($155);
      __label__ = 274; break;
    case 32: // $156
      var $157=$z80;
      __ZL5op_0eP10_z80_state($157);
      __label__ = 274; break;
    case 33: // $158
      var $159=$z80;
      __ZL5op_0fP10_z80_state($159);
      __label__ = 274; break;
    case 34: // $160
      var $161=$z80;
      __ZL5op_10P10_z80_state($161);
      __label__ = 274; break;
    case 35: // $162
      var $163=$z80;
      __ZL5op_11P10_z80_state($163);
      __label__ = 274; break;
    case 36: // $164
      var $165=$z80;
      __ZL5op_12P10_z80_state($165);
      __label__ = 274; break;
    case 37: // $166
      var $167=$z80;
      __ZL5op_13P10_z80_state($167);
      __label__ = 274; break;
    case 38: // $168
      var $169=$z80;
      __ZL5op_14P10_z80_state($169);
      __label__ = 274; break;
    case 39: // $170
      var $171=$z80;
      __ZL5op_15P10_z80_state($171);
      __label__ = 274; break;
    case 40: // $172
      var $173=$z80;
      __ZL5op_16P10_z80_state($173);
      __label__ = 274; break;
    case 41: // $174
      var $175=$z80;
      __ZL5op_17P10_z80_state($175);
      __label__ = 274; break;
    case 42: // $176
      var $177=$z80;
      __ZL5op_18P10_z80_state($177);
      __label__ = 274; break;
    case 43: // $178
      var $179=$z80;
      __ZL5op_19P10_z80_state($179);
      __label__ = 274; break;
    case 44: // $180
      var $181=$z80;
      __ZL5op_1aP10_z80_state($181);
      __label__ = 274; break;
    case 45: // $182
      var $183=$z80;
      __ZL5op_1bP10_z80_state($183);
      __label__ = 274; break;
    case 46: // $184
      var $185=$z80;
      __ZL5op_1cP10_z80_state($185);
      __label__ = 274; break;
    case 47: // $186
      var $187=$z80;
      __ZL5op_1dP10_z80_state($187);
      __label__ = 274; break;
    case 48: // $188
      var $189=$z80;
      __ZL5op_1eP10_z80_state($189);
      __label__ = 274; break;
    case 49: // $190
      var $191=$z80;
      __ZL5op_1fP10_z80_state($191);
      __label__ = 274; break;
    case 50: // $192
      var $193=$z80;
      __ZL5op_20P10_z80_state($193);
      __label__ = 274; break;
    case 51: // $194
      var $195=$z80;
      __ZL5op_21P10_z80_state($195);
      __label__ = 274; break;
    case 52: // $196
      var $197=$z80;
      __ZL5op_22P10_z80_state($197);
      __label__ = 274; break;
    case 53: // $198
      var $199=$z80;
      __ZL5op_23P10_z80_state($199);
      __label__ = 274; break;
    case 54: // $200
      var $201=$z80;
      __ZL5op_24P10_z80_state($201);
      __label__ = 274; break;
    case 55: // $202
      var $203=$z80;
      __ZL5op_25P10_z80_state($203);
      __label__ = 274; break;
    case 56: // $204
      var $205=$z80;
      __ZL5op_26P10_z80_state($205);
      __label__ = 274; break;
    case 57: // $206
      var $207=$z80;
      __ZL5op_27P10_z80_state($207);
      __label__ = 274; break;
    case 58: // $208
      var $209=$z80;
      __ZL5op_28P10_z80_state($209);
      __label__ = 274; break;
    case 59: // $210
      var $211=$z80;
      __ZL5op_29P10_z80_state($211);
      __label__ = 274; break;
    case 60: // $212
      var $213=$z80;
      __ZL5op_2aP10_z80_state($213);
      __label__ = 274; break;
    case 61: // $214
      var $215=$z80;
      __ZL5op_2bP10_z80_state($215);
      __label__ = 274; break;
    case 62: // $216
      var $217=$z80;
      __ZL5op_2cP10_z80_state($217);
      __label__ = 274; break;
    case 63: // $218
      var $219=$z80;
      __ZL5op_2dP10_z80_state($219);
      __label__ = 274; break;
    case 64: // $220
      var $221=$z80;
      __ZL5op_2eP10_z80_state($221);
      __label__ = 274; break;
    case 65: // $222
      var $223=$z80;
      __ZL5op_2fP10_z80_state($223);
      __label__ = 274; break;
    case 66: // $224
      var $225=$z80;
      __ZL5op_30P10_z80_state($225);
      __label__ = 274; break;
    case 67: // $226
      var $227=$z80;
      __ZL5op_31P10_z80_state($227);
      __label__ = 274; break;
    case 68: // $228
      var $229=$z80;
      __ZL5op_32P10_z80_state($229);
      __label__ = 274; break;
    case 69: // $230
      var $231=$z80;
      __ZL5op_33P10_z80_state($231);
      __label__ = 274; break;
    case 70: // $232
      var $233=$z80;
      __ZL5op_34P10_z80_state($233);
      __label__ = 274; break;
    case 71: // $234
      var $235=$z80;
      __ZL5op_35P10_z80_state($235);
      __label__ = 274; break;
    case 72: // $236
      var $237=$z80;
      __ZL5op_36P10_z80_state($237);
      __label__ = 274; break;
    case 73: // $238
      var $239=$z80;
      __ZL5op_37P10_z80_state($239);
      __label__ = 274; break;
    case 74: // $240
      var $241=$z80;
      __ZL5op_38P10_z80_state($241);
      __label__ = 274; break;
    case 75: // $242
      var $243=$z80;
      __ZL5op_39P10_z80_state($243);
      __label__ = 274; break;
    case 76: // $244
      var $245=$z80;
      __ZL5op_3aP10_z80_state($245);
      __label__ = 274; break;
    case 77: // $246
      var $247=$z80;
      __ZL5op_3bP10_z80_state($247);
      __label__ = 274; break;
    case 78: // $248
      var $249=$z80;
      __ZL5op_3cP10_z80_state($249);
      __label__ = 274; break;
    case 79: // $250
      var $251=$z80;
      __ZL5op_3dP10_z80_state($251);
      __label__ = 274; break;
    case 80: // $252
      var $253=$z80;
      __ZL5op_3eP10_z80_state($253);
      __label__ = 274; break;
    case 81: // $254
      var $255=$z80;
      __ZL5op_3fP10_z80_state($255);
      __label__ = 274; break;
    case 82: // $256
      var $257=$z80;
      __ZL5op_40P10_z80_state($257);
      __label__ = 274; break;
    case 83: // $258
      var $259=$z80;
      __ZL5op_41P10_z80_state($259);
      __label__ = 274; break;
    case 84: // $260
      var $261=$z80;
      __ZL5op_42P10_z80_state($261);
      __label__ = 274; break;
    case 85: // $262
      var $263=$z80;
      __ZL5op_43P10_z80_state($263);
      __label__ = 274; break;
    case 86: // $264
      var $265=$z80;
      __ZL5op_44P10_z80_state($265);
      __label__ = 274; break;
    case 87: // $266
      var $267=$z80;
      __ZL5op_45P10_z80_state($267);
      __label__ = 274; break;
    case 88: // $268
      var $269=$z80;
      __ZL5op_46P10_z80_state($269);
      __label__ = 274; break;
    case 89: // $270
      var $271=$z80;
      __ZL5op_47P10_z80_state($271);
      __label__ = 274; break;
    case 90: // $272
      var $273=$z80;
      __ZL5op_48P10_z80_state($273);
      __label__ = 274; break;
    case 91: // $274
      var $275=$z80;
      __ZL5op_49P10_z80_state($275);
      __label__ = 274; break;
    case 92: // $276
      var $277=$z80;
      __ZL5op_4aP10_z80_state($277);
      __label__ = 274; break;
    case 93: // $278
      var $279=$z80;
      __ZL5op_4bP10_z80_state($279);
      __label__ = 274; break;
    case 94: // $280
      var $281=$z80;
      __ZL5op_4cP10_z80_state($281);
      __label__ = 274; break;
    case 95: // $282
      var $283=$z80;
      __ZL5op_4dP10_z80_state($283);
      __label__ = 274; break;
    case 96: // $284
      var $285=$z80;
      __ZL5op_4eP10_z80_state($285);
      __label__ = 274; break;
    case 97: // $286
      var $287=$z80;
      __ZL5op_4fP10_z80_state($287);
      __label__ = 274; break;
    case 98: // $288
      var $289=$z80;
      __ZL5op_50P10_z80_state($289);
      __label__ = 274; break;
    case 99: // $290
      var $291=$z80;
      __ZL5op_51P10_z80_state($291);
      __label__ = 274; break;
    case 100: // $292
      var $293=$z80;
      __ZL5op_52P10_z80_state($293);
      __label__ = 274; break;
    case 101: // $294
      var $295=$z80;
      __ZL5op_53P10_z80_state($295);
      __label__ = 274; break;
    case 102: // $296
      var $297=$z80;
      __ZL5op_54P10_z80_state($297);
      __label__ = 274; break;
    case 103: // $298
      var $299=$z80;
      __ZL5op_55P10_z80_state($299);
      __label__ = 274; break;
    case 104: // $300
      var $301=$z80;
      __ZL5op_56P10_z80_state($301);
      __label__ = 274; break;
    case 105: // $302
      var $303=$z80;
      __ZL5op_57P10_z80_state($303);
      __label__ = 274; break;
    case 106: // $304
      var $305=$z80;
      __ZL5op_58P10_z80_state($305);
      __label__ = 274; break;
    case 107: // $306
      var $307=$z80;
      __ZL5op_59P10_z80_state($307);
      __label__ = 274; break;
    case 108: // $308
      var $309=$z80;
      __ZL5op_5aP10_z80_state($309);
      __label__ = 274; break;
    case 109: // $310
      var $311=$z80;
      __ZL5op_5bP10_z80_state($311);
      __label__ = 274; break;
    case 110: // $312
      var $313=$z80;
      __ZL5op_5cP10_z80_state($313);
      __label__ = 274; break;
    case 111: // $314
      var $315=$z80;
      __ZL5op_5dP10_z80_state($315);
      __label__ = 274; break;
    case 112: // $316
      var $317=$z80;
      __ZL5op_5eP10_z80_state($317);
      __label__ = 274; break;
    case 113: // $318
      var $319=$z80;
      __ZL5op_5fP10_z80_state($319);
      __label__ = 274; break;
    case 114: // $320
      var $321=$z80;
      __ZL5op_60P10_z80_state($321);
      __label__ = 274; break;
    case 115: // $322
      var $323=$z80;
      __ZL5op_61P10_z80_state($323);
      __label__ = 274; break;
    case 116: // $324
      var $325=$z80;
      __ZL5op_62P10_z80_state($325);
      __label__ = 274; break;
    case 117: // $326
      var $327=$z80;
      __ZL5op_63P10_z80_state($327);
      __label__ = 274; break;
    case 118: // $328
      var $329=$z80;
      __ZL5op_64P10_z80_state($329);
      __label__ = 274; break;
    case 119: // $330
      var $331=$z80;
      __ZL5op_65P10_z80_state($331);
      __label__ = 274; break;
    case 120: // $332
      var $333=$z80;
      __ZL5op_66P10_z80_state($333);
      __label__ = 274; break;
    case 121: // $334
      var $335=$z80;
      __ZL5op_67P10_z80_state($335);
      __label__ = 274; break;
    case 122: // $336
      var $337=$z80;
      __ZL5op_68P10_z80_state($337);
      __label__ = 274; break;
    case 123: // $338
      var $339=$z80;
      __ZL5op_69P10_z80_state($339);
      __label__ = 274; break;
    case 124: // $340
      var $341=$z80;
      __ZL5op_6aP10_z80_state($341);
      __label__ = 274; break;
    case 125: // $342
      var $343=$z80;
      __ZL5op_6bP10_z80_state($343);
      __label__ = 274; break;
    case 126: // $344
      var $345=$z80;
      __ZL5op_6cP10_z80_state($345);
      __label__ = 274; break;
    case 127: // $346
      var $347=$z80;
      __ZL5op_6dP10_z80_state($347);
      __label__ = 274; break;
    case 128: // $348
      var $349=$z80;
      __ZL5op_6eP10_z80_state($349);
      __label__ = 274; break;
    case 129: // $350
      var $351=$z80;
      __ZL5op_6fP10_z80_state($351);
      __label__ = 274; break;
    case 130: // $352
      var $353=$z80;
      __ZL5op_70P10_z80_state($353);
      __label__ = 274; break;
    case 131: // $354
      var $355=$z80;
      __ZL5op_71P10_z80_state($355);
      __label__ = 274; break;
    case 132: // $356
      var $357=$z80;
      __ZL5op_72P10_z80_state($357);
      __label__ = 274; break;
    case 133: // $358
      var $359=$z80;
      __ZL5op_73P10_z80_state($359);
      __label__ = 274; break;
    case 134: // $360
      var $361=$z80;
      __ZL5op_74P10_z80_state($361);
      __label__ = 274; break;
    case 135: // $362
      var $363=$z80;
      __ZL5op_75P10_z80_state($363);
      __label__ = 274; break;
    case 136: // $364
      var $365=$z80;
      __ZL5op_76P10_z80_state($365);
      __label__ = 274; break;
    case 137: // $366
      var $367=$z80;
      __ZL5op_77P10_z80_state($367);
      __label__ = 274; break;
    case 138: // $368
      var $369=$z80;
      __ZL5op_78P10_z80_state($369);
      __label__ = 274; break;
    case 139: // $370
      var $371=$z80;
      __ZL5op_79P10_z80_state($371);
      __label__ = 274; break;
    case 140: // $372
      var $373=$z80;
      __ZL5op_7aP10_z80_state($373);
      __label__ = 274; break;
    case 141: // $374
      var $375=$z80;
      __ZL5op_7bP10_z80_state($375);
      __label__ = 274; break;
    case 142: // $376
      var $377=$z80;
      __ZL5op_7cP10_z80_state($377);
      __label__ = 274; break;
    case 143: // $378
      var $379=$z80;
      __ZL5op_7dP10_z80_state($379);
      __label__ = 274; break;
    case 144: // $380
      var $381=$z80;
      __ZL5op_7eP10_z80_state($381);
      __label__ = 274; break;
    case 145: // $382
      var $383=$z80;
      __ZL5op_7fP10_z80_state($383);
      __label__ = 274; break;
    case 146: // $384
      var $385=$z80;
      __ZL5op_80P10_z80_state($385);
      __label__ = 274; break;
    case 147: // $386
      var $387=$z80;
      __ZL5op_81P10_z80_state($387);
      __label__ = 274; break;
    case 148: // $388
      var $389=$z80;
      __ZL5op_82P10_z80_state($389);
      __label__ = 274; break;
    case 149: // $390
      var $391=$z80;
      __ZL5op_83P10_z80_state($391);
      __label__ = 274; break;
    case 150: // $392
      var $393=$z80;
      __ZL5op_84P10_z80_state($393);
      __label__ = 274; break;
    case 151: // $394
      var $395=$z80;
      __ZL5op_85P10_z80_state($395);
      __label__ = 274; break;
    case 152: // $396
      var $397=$z80;
      __ZL5op_86P10_z80_state($397);
      __label__ = 274; break;
    case 153: // $398
      var $399=$z80;
      __ZL5op_87P10_z80_state($399);
      __label__ = 274; break;
    case 154: // $400
      var $401=$z80;
      __ZL5op_88P10_z80_state($401);
      __label__ = 274; break;
    case 155: // $402
      var $403=$z80;
      __ZL5op_89P10_z80_state($403);
      __label__ = 274; break;
    case 156: // $404
      var $405=$z80;
      __ZL5op_8aP10_z80_state($405);
      __label__ = 274; break;
    case 157: // $406
      var $407=$z80;
      __ZL5op_8bP10_z80_state($407);
      __label__ = 274; break;
    case 158: // $408
      var $409=$z80;
      __ZL5op_8cP10_z80_state($409);
      __label__ = 274; break;
    case 159: // $410
      var $411=$z80;
      __ZL5op_8dP10_z80_state($411);
      __label__ = 274; break;
    case 160: // $412
      var $413=$z80;
      __ZL5op_8eP10_z80_state($413);
      __label__ = 274; break;
    case 161: // $414
      var $415=$z80;
      __ZL5op_8fP10_z80_state($415);
      __label__ = 274; break;
    case 162: // $416
      var $417=$z80;
      __ZL5op_90P10_z80_state($417);
      __label__ = 274; break;
    case 163: // $418
      var $419=$z80;
      __ZL5op_91P10_z80_state($419);
      __label__ = 274; break;
    case 164: // $420
      var $421=$z80;
      __ZL5op_92P10_z80_state($421);
      __label__ = 274; break;
    case 165: // $422
      var $423=$z80;
      __ZL5op_93P10_z80_state($423);
      __label__ = 274; break;
    case 166: // $424
      var $425=$z80;
      __ZL5op_94P10_z80_state($425);
      __label__ = 274; break;
    case 167: // $426
      var $427=$z80;
      __ZL5op_95P10_z80_state($427);
      __label__ = 274; break;
    case 168: // $428
      var $429=$z80;
      __ZL5op_96P10_z80_state($429);
      __label__ = 274; break;
    case 169: // $430
      var $431=$z80;
      __ZL5op_97P10_z80_state($431);
      __label__ = 274; break;
    case 170: // $432
      var $433=$z80;
      __ZL5op_98P10_z80_state($433);
      __label__ = 274; break;
    case 171: // $434
      var $435=$z80;
      __ZL5op_99P10_z80_state($435);
      __label__ = 274; break;
    case 172: // $436
      var $437=$z80;
      __ZL5op_9aP10_z80_state($437);
      __label__ = 274; break;
    case 173: // $438
      var $439=$z80;
      __ZL5op_9bP10_z80_state($439);
      __label__ = 274; break;
    case 174: // $440
      var $441=$z80;
      __ZL5op_9cP10_z80_state($441);
      __label__ = 274; break;
    case 175: // $442
      var $443=$z80;
      __ZL5op_9dP10_z80_state($443);
      __label__ = 274; break;
    case 176: // $444
      var $445=$z80;
      __ZL5op_9eP10_z80_state($445);
      __label__ = 274; break;
    case 177: // $446
      var $447=$z80;
      __ZL5op_9fP10_z80_state($447);
      __label__ = 274; break;
    case 178: // $448
      var $449=$z80;
      __ZL5op_a0P10_z80_state($449);
      __label__ = 274; break;
    case 179: // $450
      var $451=$z80;
      __ZL5op_a1P10_z80_state($451);
      __label__ = 274; break;
    case 180: // $452
      var $453=$z80;
      __ZL5op_a2P10_z80_state($453);
      __label__ = 274; break;
    case 181: // $454
      var $455=$z80;
      __ZL5op_a3P10_z80_state($455);
      __label__ = 274; break;
    case 182: // $456
      var $457=$z80;
      __ZL5op_a4P10_z80_state($457);
      __label__ = 274; break;
    case 183: // $458
      var $459=$z80;
      __ZL5op_a5P10_z80_state($459);
      __label__ = 274; break;
    case 184: // $460
      var $461=$z80;
      __ZL5op_a6P10_z80_state($461);
      __label__ = 274; break;
    case 185: // $462
      var $463=$z80;
      __ZL5op_a7P10_z80_state($463);
      __label__ = 274; break;
    case 186: // $464
      var $465=$z80;
      __ZL5op_a8P10_z80_state($465);
      __label__ = 274; break;
    case 187: // $466
      var $467=$z80;
      __ZL5op_a9P10_z80_state($467);
      __label__ = 274; break;
    case 188: // $468
      var $469=$z80;
      __ZL5op_aaP10_z80_state($469);
      __label__ = 274; break;
    case 189: // $470
      var $471=$z80;
      __ZL5op_abP10_z80_state($471);
      __label__ = 274; break;
    case 190: // $472
      var $473=$z80;
      __ZL5op_acP10_z80_state($473);
      __label__ = 274; break;
    case 191: // $474
      var $475=$z80;
      __ZL5op_adP10_z80_state($475);
      __label__ = 274; break;
    case 192: // $476
      var $477=$z80;
      __ZL5op_aeP10_z80_state($477);
      __label__ = 274; break;
    case 193: // $478
      var $479=$z80;
      __ZL5op_afP10_z80_state($479);
      __label__ = 274; break;
    case 194: // $480
      var $481=$z80;
      __ZL5op_b0P10_z80_state($481);
      __label__ = 274; break;
    case 195: // $482
      var $483=$z80;
      __ZL5op_b1P10_z80_state($483);
      __label__ = 274; break;
    case 196: // $484
      var $485=$z80;
      __ZL5op_b2P10_z80_state($485);
      __label__ = 274; break;
    case 197: // $486
      var $487=$z80;
      __ZL5op_b3P10_z80_state($487);
      __label__ = 274; break;
    case 198: // $488
      var $489=$z80;
      __ZL5op_b4P10_z80_state($489);
      __label__ = 274; break;
    case 199: // $490
      var $491=$z80;
      __ZL5op_b5P10_z80_state($491);
      __label__ = 274; break;
    case 200: // $492
      var $493=$z80;
      __ZL5op_b6P10_z80_state($493);
      __label__ = 274; break;
    case 201: // $494
      var $495=$z80;
      __ZL5op_b7P10_z80_state($495);
      __label__ = 274; break;
    case 202: // $496
      var $497=$z80;
      __ZL5op_b8P10_z80_state($497);
      __label__ = 274; break;
    case 203: // $498
      var $499=$z80;
      __ZL5op_b9P10_z80_state($499);
      __label__ = 274; break;
    case 204: // $500
      var $501=$z80;
      __ZL5op_baP10_z80_state($501);
      __label__ = 274; break;
    case 205: // $502
      var $503=$z80;
      __ZL5op_bbP10_z80_state($503);
      __label__ = 274; break;
    case 206: // $504
      var $505=$z80;
      __ZL5op_bcP10_z80_state($505);
      __label__ = 274; break;
    case 207: // $506
      var $507=$z80;
      __ZL5op_bdP10_z80_state($507);
      __label__ = 274; break;
    case 208: // $508
      var $509=$z80;
      __ZL5op_beP10_z80_state($509);
      __label__ = 274; break;
    case 209: // $510
      var $511=$z80;
      __ZL5op_bfP10_z80_state($511);
      __label__ = 274; break;
    case 210: // $512
      var $513=$z80;
      __ZL5op_c0P10_z80_state($513);
      __label__ = 274; break;
    case 211: // $514
      var $515=$z80;
      __ZL5op_c1P10_z80_state($515);
      __label__ = 274; break;
    case 212: // $516
      var $517=$z80;
      __ZL5op_c2P10_z80_state($517);
      __label__ = 274; break;
    case 213: // $518
      var $519=$z80;
      __ZL5op_c3P10_z80_state($519);
      __label__ = 274; break;
    case 214: // $520
      var $521=$z80;
      __ZL5op_c4P10_z80_state($521);
      __label__ = 274; break;
    case 215: // $522
      var $523=$z80;
      __ZL5op_c5P10_z80_state($523);
      __label__ = 274; break;
    case 216: // $524
      var $525=$z80;
      __ZL5op_c6P10_z80_state($525);
      __label__ = 274; break;
    case 217: // $526
      var $527=$z80;
      __ZL5op_c7P10_z80_state($527);
      __label__ = 274; break;
    case 218: // $528
      var $529=$z80;
      __ZL5op_c8P10_z80_state($529);
      __label__ = 274; break;
    case 219: // $530
      var $531=$z80;
      __ZL5op_c9P10_z80_state($531);
      __label__ = 274; break;
    case 220: // $532
      var $533=$z80;
      __ZL5op_caP10_z80_state($533);
      __label__ = 274; break;
    case 221: // $534
      var $535=$z80;
      __ZL5op_cbP10_z80_state($535);
      __label__ = 274; break;
    case 222: // $536
      var $537=$z80;
      __ZL5op_ccP10_z80_state($537);
      __label__ = 274; break;
    case 223: // $538
      var $539=$z80;
      __ZL5op_cdP10_z80_state($539);
      __label__ = 274; break;
    case 224: // $540
      var $541=$z80;
      __ZL5op_ceP10_z80_state($541);
      __label__ = 274; break;
    case 225: // $542
      var $543=$z80;
      __ZL5op_cfP10_z80_state($543);
      __label__ = 274; break;
    case 226: // $544
      var $545=$z80;
      __ZL5op_d0P10_z80_state($545);
      __label__ = 274; break;
    case 227: // $546
      var $547=$z80;
      __ZL5op_d1P10_z80_state($547);
      __label__ = 274; break;
    case 228: // $548
      var $549=$z80;
      __ZL5op_d2P10_z80_state($549);
      __label__ = 274; break;
    case 229: // $550
      var $551=$z80;
      __ZL5op_d3P10_z80_state($551);
      __label__ = 274; break;
    case 230: // $552
      var $553=$z80;
      __ZL5op_d4P10_z80_state($553);
      __label__ = 274; break;
    case 231: // $554
      var $555=$z80;
      __ZL5op_d5P10_z80_state($555);
      __label__ = 274; break;
    case 232: // $556
      var $557=$z80;
      __ZL5op_d6P10_z80_state($557);
      __label__ = 274; break;
    case 233: // $558
      var $559=$z80;
      __ZL5op_d7P10_z80_state($559);
      __label__ = 274; break;
    case 234: // $560
      var $561=$z80;
      __ZL5op_d8P10_z80_state($561);
      __label__ = 274; break;
    case 235: // $562
      var $563=$z80;
      __ZL5op_d9P10_z80_state($563);
      __label__ = 274; break;
    case 236: // $564
      var $565=$z80;
      __ZL5op_daP10_z80_state($565);
      __label__ = 274; break;
    case 237: // $566
      var $567=$z80;
      __ZL5op_dbP10_z80_state($567);
      __label__ = 274; break;
    case 238: // $568
      var $569=$z80;
      __ZL5op_dcP10_z80_state($569);
      __label__ = 274; break;
    case 239: // $570
      var $571=$z80;
      __ZL5op_ddP10_z80_state($571);
      __label__ = 274; break;
    case 240: // $572
      var $573=$z80;
      __ZL5op_deP10_z80_state($573);
      __label__ = 274; break;
    case 241: // $574
      var $575=$z80;
      __ZL5op_dfP10_z80_state($575);
      __label__ = 274; break;
    case 242: // $576
      var $577=$z80;
      __ZL5op_e0P10_z80_state($577);
      __label__ = 274; break;
    case 243: // $578
      var $579=$z80;
      __ZL5op_e1P10_z80_state($579);
      __label__ = 274; break;
    case 244: // $580
      var $581=$z80;
      __ZL5op_e2P10_z80_state($581);
      __label__ = 274; break;
    case 245: // $582
      var $583=$z80;
      __ZL5op_e3P10_z80_state($583);
      __label__ = 274; break;
    case 246: // $584
      var $585=$z80;
      __ZL5op_e4P10_z80_state($585);
      __label__ = 274; break;
    case 247: // $586
      var $587=$z80;
      __ZL5op_e5P10_z80_state($587);
      __label__ = 274; break;
    case 248: // $588
      var $589=$z80;
      __ZL5op_e6P10_z80_state($589);
      __label__ = 274; break;
    case 249: // $590
      var $591=$z80;
      __ZL5op_e7P10_z80_state($591);
      __label__ = 274; break;
    case 250: // $592
      var $593=$z80;
      __ZL5op_e8P10_z80_state($593);
      __label__ = 274; break;
    case 251: // $594
      var $595=$z80;
      __ZL5op_e9P10_z80_state($595);
      __label__ = 274; break;
    case 252: // $596
      var $597=$z80;
      __ZL5op_eaP10_z80_state($597);
      __label__ = 274; break;
    case 253: // $598
      var $599=$z80;
      __ZL5op_ebP10_z80_state($599);
      __label__ = 274; break;
    case 254: // $600
      var $601=$z80;
      __ZL5op_ecP10_z80_state($601);
      __label__ = 274; break;
    case 255: // $602
      var $603=$z80;
      __ZL5op_edP10_z80_state($603);
      __label__ = 274; break;
    case 256: // $604
      var $605=$z80;
      __ZL5op_eeP10_z80_state($605);
      __label__ = 274; break;
    case 257: // $606
      var $607=$z80;
      __ZL5op_efP10_z80_state($607);
      __label__ = 274; break;
    case 258: // $608
      var $609=$z80;
      __ZL5op_f0P10_z80_state($609);
      __label__ = 274; break;
    case 259: // $610
      var $611=$z80;
      __ZL5op_f1P10_z80_state($611);
      __label__ = 274; break;
    case 260: // $612
      var $613=$z80;
      __ZL5op_f2P10_z80_state($613);
      __label__ = 274; break;
    case 261: // $614
      var $615=$z80;
      __ZL5op_f3P10_z80_state($615);
      __label__ = 274; break;
    case 262: // $616
      var $617=$z80;
      __ZL5op_f4P10_z80_state($617);
      __label__ = 274; break;
    case 263: // $618
      var $619=$z80;
      __ZL5op_f5P10_z80_state($619);
      __label__ = 274; break;
    case 264: // $620
      var $621=$z80;
      __ZL5op_f6P10_z80_state($621);
      __label__ = 274; break;
    case 265: // $622
      var $623=$z80;
      __ZL5op_f7P10_z80_state($623);
      __label__ = 274; break;
    case 266: // $624
      var $625=$z80;
      __ZL5op_f8P10_z80_state($625);
      __label__ = 274; break;
    case 267: // $626
      var $627=$z80;
      __ZL5op_f9P10_z80_state($627);
      __label__ = 274; break;
    case 268: // $628
      var $629=$z80;
      __ZL5op_faP10_z80_state($629);
      __label__ = 274; break;
    case 269: // $630
      var $631=$z80;
      __ZL5op_fbP10_z80_state($631);
      __label__ = 274; break;
    case 270: // $632
      var $633=$z80;
      __ZL5op_fcP10_z80_state($633);
      __label__ = 274; break;
    case 271: // $634
      var $635=$z80;
      __ZL5op_fdP10_z80_state($635);
      __label__ = 274; break;
    case 272: // $636
      var $637=$z80;
      __ZL5op_feP10_z80_state($637);
      __label__ = 274; break;
    case 273: // $638
      var $639=$z80;
      __ZL5op_ffP10_z80_state($639);
      __label__ = 274; break;
    case 274: // $640
      __label__ = 275; break;
    case 275: // $641
      var $642=$z80;
      var $643=(($642+96)|0);
      var $644=HEAP32[(($643)>>2)];
      var $645=(($644)|0) > 0;
      if ($645) { __label__ = 11; break; } else { __label__ = 276; break; }
    case 276: // $646
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15cpu_execute_z80P17legacy_cpu_device["X"]=1;

function __ZL21cpu_string_export_z80P17legacy_cpu_deviceRK18device_state_entryR7astring($device, $entry, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cpustate;
      $1=$device;
      $2=$entry;
      $3=$string;
      var $4=$1;
      var $5=$4;
      var $6=__ZL14get_safe_tokenP8device_t305($5);
      $cpustate=$6;
      var $7=$2;
      var $8=__ZNK18device_state_entry5indexEv($7);
      if ($8 == -4) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $9
      var $10=$3;
      var $11=$cpustate;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=(($17)|0)!=0;
      var $19=$18 ? 83 : 46;
      var $20=(($19 << 24) >> 24);
      var $21=$cpustate;
      var $22=(($21+12)|0);
      var $23=$22;
      var $24=(($23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & 64;
      var $28=(($27)|0)!=0;
      var $29=$28 ? 90 : 46;
      var $30=(($29 << 24) >> 24);
      var $31=$cpustate;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$36 & 32;
      var $38=(($37)|0)!=0;
      var $39=$38 ? 89 : 46;
      var $40=(($39 << 24) >> 24);
      var $41=$cpustate;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$46 & 16;
      var $48=(($47)|0)!=0;
      var $49=$48 ? 72 : 46;
      var $50=(($49 << 24) >> 24);
      var $51=$cpustate;
      var $52=(($51+12)|0);
      var $53=$52;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 8;
      var $58=(($57)|0)!=0;
      var $59=$58 ? 88 : 46;
      var $60=(($59 << 24) >> 24);
      var $61=$cpustate;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=$66 & 4;
      var $68=(($67)|0)!=0;
      var $69=$68 ? 80 : 46;
      var $70=(($69 << 24) >> 24);
      var $71=$cpustate;
      var $72=(($71+12)|0);
      var $73=$72;
      var $74=(($73)|0);
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=$76 & 2;
      var $78=(($77)|0)!=0;
      var $79=$78 ? 78 : 46;
      var $80=(($79 << 24) >> 24);
      var $81=$cpustate;
      var $82=(($81+12)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$86 & 1;
      var $88=(($87)|0)!=0;
      var $89=$88 ? 67 : 46;
      var $90=(($89 << 24) >> 24);
      var $91=__ZN7astring6printfEPKcz($10, ((STRING_TABLE.__str10245)|0), (tempInt=STACKTOP,STACKTOP += 32,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,HEAP32[((tempInt+4)>>2)]=$30,HEAP32[((tempInt+8)>>2)]=$40,HEAP32[((tempInt+12)>>2)]=$50,HEAP32[((tempInt+16)>>2)]=$60,HEAP32[((tempInt+20)>>2)]=$70,HEAP32[((tempInt+24)>>2)]=$80,HEAP32[((tempInt+28)>>2)]=$90,tempInt));
      __label__ = 2; break;
    case 2: // $92
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21cpu_string_export_z80P17legacy_cpu_deviceRK18device_state_entryR7astring["X"]=1;

function __ZN10z80_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN17legacy_cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPS_jP7cpuinfoE($8, $9, $10, $11, $12, $13, 110);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV10z80_device+8)|0);
  var $15=$7;
  var $16=(($15+356)|0);
  var $17=$16;
  HEAP32[(($17)>>2)]=((__ZTV10z80_device+156)|0);
  var $18=$7;
  var $19=(($18+5968)|0);
  var $20=$19;
  HEAP32[(($20)>>2)]=((__ZTV10z80_device+256)|0);
  var $21=$7;
  var $22=(($21+6012)|0);
  var $23=$22;
  HEAP32[(($23)>>2)]=((__ZTV10z80_device+340)|0);
  var $24=$7;
  var $25=(($24+7088)|0);
  var $26=$25;
  HEAP32[(($26)>>2)]=((__ZTV10z80_device+420)|0);
  ;
  return;
}


function __ZN10z80_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10z80_deviceD2Ev($2);
  ;
  return;
}


function __ZThn356_N10z80_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN10z80_deviceD1Ev($5);
  ;
  return;
}


function __ZThn356_N10z80_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN10z80_deviceD0Ev($5);
  ;
  return;
}


function __ZThn5968_N10z80_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN10z80_deviceD1Ev($5);
  ;
  return;
}


function __ZThn5968_N10z80_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN10z80_deviceD0Ev($5);
  ;
  return;
}


function __ZThn6012_N10z80_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN10z80_deviceD1Ev($5);
  ;
  return;
}


function __ZThn6012_N10z80_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN10z80_deviceD0Ev($5);
  ;
  return;
}


function __ZThn7088_N10z80_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN10z80_deviceD1Ev($5);
  ;
  return;
}


function __ZThn7088_N10z80_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN10z80_deviceD0Ev($5);
  ;
  return;
}


function __ZN10z80_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17legacy_cpu_deviceD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI10z80_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI10z80_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI10z80_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 7240);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI10z80_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI10z80_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI10z80_deviceED2Ev($2);
  ;
  return;
}


function __ZL4WM16P10_z80_statejP4PAIR($z80, $addr, $r) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$z80;
  $2=$addr;
  $3=$r;
  var $4=$1;
  var $5=(($4+84)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+80)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$12;
  var $14=(($13)|0);
  var $15=HEAP8[($14)];
  FUNCTION_TABLE[$10]($6, $11, $15);
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+80)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$2;
  var $24=(($23+1)|0);
  var $25=$24 & 65535;
  var $26=$3;
  var $27=$26;
  var $28=(($27+1)|0);
  var $29=HEAP8[($28)];
  FUNCTION_TABLE[$22]($18, $25, $29);
  ;
  return;
}


function __ZL20cpu_state_import_z80P17legacy_cpu_deviceRK18device_state_entry($device, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cpustate;
      $1=$device;
      $2=$entry;
      var $3=$1;
      var $4=$3;
      var $5=__ZL14get_safe_tokenP8device_t305($4);
      $cpustate=$5;
      var $6=$2;
      var $7=__ZNK18device_state_entry5indexEv($6);
      if ($7 == 19) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $8
      var $9=$cpustate;
      var $10=(($9+104)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 & 127;
      var $14=(($13) & 255);
      var $15=$cpustate;
      var $16=(($15+56)|0);
      HEAP8[($16)]=$14;
      var $17=$cpustate;
      var $18=(($17+104)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & 128;
      var $22=(($21) & 255);
      var $23=$cpustate;
      var $24=(($23+57)|0);
      HEAP8[($24)]=$22;
      __label__ = 3; break;
    case 2: // $25
      __Z10fatalerrorPKcz(((STRING_TABLE.__str12247)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 3: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20cpu_state_export_z80P17legacy_cpu_deviceRK18device_state_entry($device, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cpustate;
      $1=$device;
      $2=$entry;
      var $3=$1;
      var $4=$3;
      var $5=__ZL14get_safe_tokenP8device_t305($4);
      $cpustate=$5;
      var $6=$2;
      var $7=__ZNK18device_state_entry5indexEv($6);
      if ($7 == 19) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $8
      var $9=$cpustate;
      var $10=(($9+56)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 & 127;
      var $14=$cpustate;
      var $15=(($14+57)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 128;
      var $19=$13 | $18;
      var $20=(($19) & 255);
      var $21=$cpustate;
      var $22=(($21+104)|0);
      HEAP8[($22)]=$20;
      __label__ = 3; break;
    case 2: // $23
      __Z10fatalerrorPKcz(((STRING_TABLE.__str11246)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 3: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21legacy_device_creatorI10z80_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=7240;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str6241)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10z80_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 108, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI10z80_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str6241)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI10z80_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN10z80_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN10z80_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10z80_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI10z80_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI10z80_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI10z80_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI10z80_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI10z80_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI10z80_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI10z80_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI10z80_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_00P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_03P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6+1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_07P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 << 1;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 >> 7;
      var $17=$9 | $16;
      var $18=(($17) & 255);
      var $19=$1;
      var $20=(($19+12)|0);
      var $21=$20;
      var $22=(($21+1)|0);
      HEAP8[($22)]=$18;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 196;
      var $30=$1;
      var $31=(($30+12)|0);
      var $32=$31;
      var $33=(($32+1)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=$35 & 41;
      var $37=$29 | $36;
      var $38=(($37) & 255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41)|0);
      HEAP8[($42)]=$38;
      __label__ = 2; break;
    case 2: // $43
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_09P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+16)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+24)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+24)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+16)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+24)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_09P10_z80_state["X"]=1;

function __ZL5op_0bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6-1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_0fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 196;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 1;
      var $17=$9 | $16;
      var $18=(($17) & 255);
      var $19=$1;
      var $20=(($19+12)|0);
      var $21=$20;
      var $22=(($21)|0);
      HEAP8[($22)]=$18;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 >> 1;
      var $30=$1;
      var $31=(($30+12)|0);
      var $32=$31;
      var $33=(($32+1)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=$35 << 7;
      var $37=$29 | $36;
      var $38=(($37) & 255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      HEAP8[($42)]=$38;
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=$44;
      var $46=(($45+1)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 & 40;
      var $50=$1;
      var $51=(($50+12)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$55 | $49;
      var $57=(($56) & 255);
      HEAP8[($53)]=$57;
      __label__ = 2; break;
    case 2: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_0fP10_z80_state["X"]=1;

function __ZL14take_interruptP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $irq_vector;
      $1=$z80;
      var $2=$1;
      var $3=(($2)|0);
      var $4=$3;
      HEAP32[(($4)>>2)]=-1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$1;
      var $7=(($6+60)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$1;
      var $12=(($11+60)|0);
      HEAP8[($12)]=0;
      var $13=$1;
      var $14=(($13+4)|0);
      var $15=$14;
      var $16=(($15)|0);
      var $17=HEAP16[(($16)>>1)];
      var $18=(($17+1)&65535);
      HEAP16[(($16)>>1)]=$18;
      __label__ = 3; break;
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      var $22=(($21+59)|0);
      HEAP8[($22)]=0;
      var $23=$1;
      var $24=(($23+58)|0);
      HEAP8[($24)]=0;
      var $25=$1;
      var $26=(($25+100)|0);
      var $27=__ZNK15z80_daisy_chain7presentEv($26);
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      var $29=$1;
      var $30=(($29+100)|0);
      var $31=__ZN15z80_daisy_chain15call_ack_deviceEv($30);
      $irq_vector=$31;
      __label__ = 7; break;
    case 6: // $32
      var $33=$1;
      var $34=(($33+76)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+80)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38;
      var $40=FUNCTION_TABLE[$35]($39, 0);
      $irq_vector=$40;
      __label__ = 7; break;
    case 7: // $41
      __label__ = 8; break;
    case 8: // $42
      __label__ = 9; break;
    case 9: // $43
      var $44=$1;
      var $45=(($44+61)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=(($47)|0)==2;
      if ($48) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $49
      var $50=$irq_vector;
      var $51=$50 & 255;
      var $52=$1;
      var $53=(($52+62)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$55 << 8;
      var $57=$51 | $56;
      $irq_vector=$57;
      __label__ = 11; break;
    case 11: // $58
      var $59=$1;
      var $60=(($59+8)|0);
      var $61=$60;
      var $62=(($61)|0);
      var $63=HEAPU16[(($62)>>1)];
      var $64=(($63)&65535);
      var $65=(($64-2)|0);
      var $66=(($65) & 65535);
      HEAP16[(($62)>>1)]=$66;
      var $67=$1;
      var $68=$1;
      var $69=(($68+8)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$1;
      var $73=(($72+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($67, $71, $73);
      __label__ = 12; break;
    case 12: // $74
      var $75=$1;
      var $76=$irq_vector;
      var $77=$1;
      var $78=(($77+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($75, $76, $78);
      __label__ = 13; break;
    case 13: // $79
      __label__ = 14; break;
    case 14: // $80
      var $81=$1;
      var $82=(($81+108)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+205)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$1;
      var $88=(($87+128)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+255)|0);
      var $91=HEAPU8[($90)];
      var $92=(($91)&255);
      var $93=(($86+$92)|0);
      var $94=$1;
      var $95=(($94+96)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96-$93)|0);
      HEAP32[(($95)>>2)]=$97;
      __label__ = 35; break;
    case 15: // $98
      var $99=$1;
      var $100=(($99+61)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      var $103=(($102)|0)==1;
      if ($103) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $104
      __label__ = 17; break;
    case 17: // $105
      __label__ = 18; break;
    case 18: // $106
      __label__ = 19; break;
    case 19: // $107
      var $108=$1;
      var $109=(($108+8)|0);
      var $110=$109;
      var $111=(($110)|0);
      var $112=HEAPU16[(($111)>>1)];
      var $113=(($112)&65535);
      var $114=(($113-2)|0);
      var $115=(($114) & 65535);
      HEAP16[(($111)>>1)]=$115;
      var $116=$1;
      var $117=$1;
      var $118=(($117+8)|0);
      var $119=$118;
      var $120=HEAP32[(($119)>>2)];
      var $121=$1;
      var $122=(($121+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($116, $120, $122);
      __label__ = 20; break;
    case 20: // $123
      var $124=$1;
      var $125=(($124+4)|0);
      var $126=$125;
      HEAP32[(($126)>>2)]=56;
      var $127=$1;
      var $128=(($127+108)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+255)|0);
      var $131=HEAPU8[($130)];
      var $132=(($131)&255);
      var $133=HEAPU8[(((STRING_TABLE.__ZL5cc_ex+255)|0))];
      var $134=(($133)&255);
      var $135=(($132+$134)|0);
      var $136=$1;
      var $137=(($136+96)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138-$135)|0);
      HEAP32[(($137)>>2)]=$139;
      __label__ = 34; break;
    case 21: // $140
      __label__ = 22; break;
    case 22: // $141
      __label__ = 23; break;
    case 23: // $142
      var $143=$irq_vector;
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 24; break; } else { __label__ = 33; break; }
    case 24: // $145
      var $146=$irq_vector;
      var $147=$146 & 16711680;
      if ($147 == 13434880) {
        __label__ = 25; break;
      }
      else if ($147 == 12779520) {
        __label__ = 28; break;
      }
      else {
      __label__ = 29; break;
      }
      
    case 25: // $148
      __label__ = 26; break;
    case 26: // $149
      var $150=$1;
      var $151=(($150+8)|0);
      var $152=$151;
      var $153=(($152)|0);
      var $154=HEAPU16[(($153)>>1)];
      var $155=(($154)&65535);
      var $156=(($155-2)|0);
      var $157=(($156) & 65535);
      HEAP16[(($153)>>1)]=$157;
      var $158=$1;
      var $159=$1;
      var $160=(($159+8)|0);
      var $161=$160;
      var $162=HEAP32[(($161)>>2)];
      var $163=$1;
      var $164=(($163+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($158, $162, $164);
      __label__ = 27; break;
    case 27: // $165
      var $166=$irq_vector;
      var $167=$166 & 65535;
      var $168=$1;
      var $169=(($168+4)|0);
      var $170=$169;
      HEAP32[(($170)>>2)]=$167;
      var $171=$1;
      var $172=(($171+108)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=(($173+205)|0);
      var $175=HEAPU8[($174)];
      var $176=(($175)&255);
      var $177=$1;
      var $178=(($177+96)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179-$176)|0);
      HEAP32[(($178)>>2)]=$180;
      __label__ = 32; break;
    case 28: // $181
      var $182=$irq_vector;
      var $183=$182 & 65535;
      var $184=$1;
      var $185=(($184+4)|0);
      var $186=$185;
      HEAP32[(($186)>>2)]=$183;
      var $187=$1;
      var $188=(($187+108)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189+195)|0);
      var $191=HEAPU8[($190)];
      var $192=(($191)&255);
      var $193=$1;
      var $194=(($193+96)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195-$192)|0);
      HEAP32[(($194)>>2)]=$196;
      __label__ = 32; break;
    case 29: // $197
      __label__ = 30; break;
    case 30: // $198
      var $199=$1;
      var $200=(($199+8)|0);
      var $201=$200;
      var $202=(($201)|0);
      var $203=HEAPU16[(($202)>>1)];
      var $204=(($203)&65535);
      var $205=(($204-2)|0);
      var $206=(($205) & 65535);
      HEAP16[(($202)>>1)]=$206;
      var $207=$1;
      var $208=$1;
      var $209=(($208+8)|0);
      var $210=$209;
      var $211=HEAP32[(($210)>>2)];
      var $212=$1;
      var $213=(($212+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($207, $211, $213);
      __label__ = 31; break;
    case 31: // $214
      var $215=$irq_vector;
      var $216=$215 & 56;
      var $217=$1;
      var $218=(($217+4)|0);
      var $219=$218;
      HEAP32[(($219)>>2)]=$216;
      var $220=$1;
      var $221=(($220+108)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($222+255)|0);
      var $224=HEAPU8[($223)];
      var $225=(($224)&255);
      var $226=$1;
      var $227=(($226+96)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=(($228-$225)|0);
      HEAP32[(($227)>>2)]=$229;
      __label__ = 32; break;
    case 32: // $230
      __label__ = 33; break;
    case 33: // $231
      var $232=$1;
      var $233=(($232+128)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=(($234+255)|0);
      var $236=HEAPU8[($235)];
      var $237=(($236)&255);
      var $238=$1;
      var $239=(($238+96)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=(($240-$237)|0);
      HEAP32[(($239)>>2)]=$241;
      __label__ = 34; break;
    case 34: // $242
      __label__ = 35; break;
    case 35: // $243
      var $244=$1;
      var $245=(($244+4)|0);
      var $246=$245;
      var $247=HEAP32[(($246)>>2)];
      var $248=(($247) & 65535);
      var $249=$1;
      var $250=(($249+36)|0);
      var $251=$250;
      var $252=(($251)|0);
      HEAP16[(($252)>>1)]=$248;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14take_interruptP10_z80_state["X"]=1;

function __ZL25debugger_instruction_hookP8device_tj306($device, $curpc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$device;
      $2=$curpc;
      var $3=$1;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=(($4+584)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 2;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=__ZNK8device_t5debugEv($10);
      var $12=$2;
      __ZN12device_debug16instruction_hookEj($11, $12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL3ROPP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  var $pc;
  $1=$z80;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  $pc=$5;
  var $6=$1;
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=(($8)|0);
  var $10=HEAP16[(($9)>>1)];
  var $11=(($10+1)&65535);
  HEAP16[(($9)>>1)]=$11;
  var $12=$1;
  var $13=(($12+88)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$pc;
  var $16=__ZN16direct_read_data19read_decrypted_byteEjj($14, $15, 0);
  ;
  return $16;
}


function __ZL5op_01P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=(($3) & 65535);
  var $5=$1;
  var $6=(($5+16)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=$4;
  ;
  return;
}


function __ZL5op_02P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  var $20=$1;
  var $21=(($20+16)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU16[(($23)>>1)];
  var $25=(($24)&65535);
  var $26=(($25+1)|0);
  var $27=$26 & 255;
  var $28=(($27) & 255);
  var $29=$1;
  var $30=(($29+36)|0);
  var $31=$30;
  var $32=(($31)|0);
  HEAP8[($32)]=$28;
  var $33=$1;
  var $34=(($33+12)|0);
  var $35=$34;
  var $36=(($35+1)|0);
  var $37=HEAP8[($36)];
  var $38=$1;
  var $39=(($38+36)|0);
  var $40=$39;
  var $41=(($40+1)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5op_04P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_05P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_06P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+16)|0);
  var $6=$5;
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_08P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmp=__stackBase__;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$tmp;
      var $6=$4;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];
      var $7=$1;
      var $8=(($7+12)|0);
      var $9=$1;
      var $10=(($9+40)|0);
      var $11=$8;
      var $12=$10;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];
      var $13=$1;
      var $14=(($13+40)|0);
      var $15=$14;
      var $16=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];
      __label__ = 2; break;
    case 2: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_0aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+12)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+16)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU16[(($23)>>1)];
  var $25=(($24)&65535);
  var $26=(($25+1)|0);
  var $27=(($26) & 65535);
  var $28=$1;
  var $29=(($28+36)|0);
  var $30=$29;
  var $31=(($30)|0);
  HEAP16[(($31)>>1)]=$27;
  ;
  return;
}


function __ZL5op_0cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_0dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_0eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+16)|0);
  var $6=$5;
  var $7=(($6)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_10P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg;
      $1=$z80;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=$3;
      var $5=(($4+1)|0);
      var $6=HEAP8[($5)];
      var $7=(($6-1)&255);
      HEAP8[($5)]=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$1;
      var $10=(($9+16)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $15
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      var $18=__ZL3ARGP10_z80_state($17);
      $arg=$18;
      var $19=$arg;
      var $20=(($19 << 24) >> 24);
      var $21=$1;
      var $22=(($21+4)|0);
      var $23=$22;
      var $24=(($23)|0);
      var $25=HEAPU16[(($24)>>1)];
      var $26=(($25)&65535);
      var $27=(($26+$20)|0);
      var $28=(($27) & 65535);
      HEAP16[(($24)>>1)]=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 4; break;
    case 4: // $38
      __label__ = 5; break;
    case 5: // $39
      var $40=$1;
      var $41=(($40+128)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+16)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$1;
      var $47=(($46+96)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48-$45)|0);
      HEAP32[(($47)>>2)]=$49;
      __label__ = 6; break;
    case 6: // $50
      __label__ = 8; break;
    case 7: // $51
      var $52=$1;
      var $53=(($52+4)|0);
      var $54=$53;
      var $55=(($54)|0);
      var $56=HEAP16[(($55)>>1)];
      var $57=(($56+1)&65535);
      HEAP16[(($55)>>1)]=$57;
      __label__ = 8; break;
    case 8: // $58
      __label__ = 9; break;
    case 9: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_10P10_z80_state["X"]=1;

function __ZL5op_11P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=(($3) & 65535);
  var $5=$1;
  var $6=(($5+20)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=$4;
  ;
  return;
}


function __ZL5op_12P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  var $20=$1;
  var $21=(($20+20)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU16[(($23)>>1)];
  var $25=(($24)&65535);
  var $26=(($25+1)|0);
  var $27=$26 & 255;
  var $28=(($27) & 255);
  var $29=$1;
  var $30=(($29+36)|0);
  var $31=$30;
  var $32=(($31)|0);
  HEAP8[($32)]=$28;
  var $33=$1;
  var $34=(($33+12)|0);
  var $35=$34;
  var $36=(($35+1)|0);
  var $37=HEAP8[($36)];
  var $38=$1;
  var $39=(($38+36)|0);
  var $40=$39;
  var $41=(($40+1)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5op_13P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6+1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_17P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      var $c;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 << 1;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 1;
      var $17=$9 | $16;
      var $18=(($17) & 255);
      $res=$18;
      var $19=$1;
      var $20=(($19+12)|0);
      var $21=$20;
      var $22=(($21+1)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$24 & 128;
      var $26=(($25)|0)!=0;
      var $27=$26 ? 1 : 0;
      var $28=(($27) & 255);
      $c=$28;
      var $29=$1;
      var $30=(($29+12)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$34 & 196;
      var $36=$c;
      var $37=(($36)&255);
      var $38=$35 | $37;
      var $39=$res;
      var $40=(($39)&255);
      var $41=$40 & 40;
      var $42=$38 | $41;
      var $43=(($42) & 255);
      var $44=$1;
      var $45=(($44+12)|0);
      var $46=$45;
      var $47=(($46)|0);
      HEAP8[($47)]=$43;
      var $48=$res;
      var $49=$1;
      var $50=(($49+12)|0);
      var $51=$50;
      var $52=(($51+1)|0);
      HEAP8[($52)]=$48;
      __label__ = 2; break;
    case 2: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_17P10_z80_state["X"]=1;

function __ZL5op_19P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+24)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+24)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+20)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+24)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_19P10_z80_state["X"]=1;

function __ZL5op_1bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6-1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_1fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      var $c;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 >> 1;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 << 7;
      var $17=$9 | $16;
      var $18=(($17) & 255);
      $res=$18;
      var $19=$1;
      var $20=(($19+12)|0);
      var $21=$20;
      var $22=(($21+1)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$24 & 1;
      var $26=(($25)|0)!=0;
      var $27=$26 ? 1 : 0;
      var $28=(($27) & 255);
      $c=$28;
      var $29=$1;
      var $30=(($29+12)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$34 & 196;
      var $36=$c;
      var $37=(($36)&255);
      var $38=$35 | $37;
      var $39=$res;
      var $40=(($39)&255);
      var $41=$40 & 40;
      var $42=$38 | $41;
      var $43=(($42) & 255);
      var $44=$1;
      var $45=(($44+12)|0);
      var $46=$45;
      var $47=(($46)|0);
      HEAP8[($47)]=$43;
      var $48=$res;
      var $49=$1;
      var $50=(($49+12)|0);
      var $51=$50;
      var $52=(($51+1)|0);
      HEAP8[($52)]=$48;
      __label__ = 2; break;
    case 2: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_1fP10_z80_state["X"]=1;

function __ZL5op_23P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6+1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_27P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $a;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $a=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$13 & 2;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $16
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$22 & 16;
      var $24=$1;
      var $25=(($24+12)|0);
      var $26=$25;
      var $27=(($26+1)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & 15;
      var $31=(($30)|0) > 9;
      var $32=(($31)&1);
      var $33=$23 | $32;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$a;
      var $37=(($36)&255);
      var $38=(($37-6)|0);
      var $39=(($38) & 255);
      $a=$39;
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$46 & 1;
      var $48=$1;
      var $49=(($48+12)|0);
      var $50=$49;
      var $51=(($50+1)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=(($53)|0) > 153;
      var $55=(($54)&1);
      var $56=$47 | $55;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$a;
      var $60=(($59)&255);
      var $61=(($60-96)|0);
      var $62=(($61) & 255);
      $a=$62;
      __label__ = 6; break;
    case 6: // $63
      __label__ = 12; break;
    case 7: // $64
      var $65=$1;
      var $66=(($65+12)|0);
      var $67=$66;
      var $68=(($67)|0);
      var $69=HEAPU8[($68)];
      var $70=(($69)&255);
      var $71=$70 & 16;
      var $72=$1;
      var $73=(($72+12)|0);
      var $74=$73;
      var $75=(($74+1)|0);
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$77 & 15;
      var $79=(($78)|0) > 9;
      var $80=(($79)&1);
      var $81=$71 | $80;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $83
      var $84=$a;
      var $85=(($84)&255);
      var $86=(($85+6)|0);
      var $87=(($86) & 255);
      $a=$87;
      __label__ = 9; break;
    case 9: // $88
      var $89=$1;
      var $90=(($89+12)|0);
      var $91=$90;
      var $92=(($91)|0);
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=$94 & 1;
      var $96=$1;
      var $97=(($96+12)|0);
      var $98=$97;
      var $99=(($98+1)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=(($101)|0) > 153;
      var $103=(($102)&1);
      var $104=$95 | $103;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $106
      var $107=$a;
      var $108=(($107)&255);
      var $109=(($108+96)|0);
      var $110=(($109) & 255);
      $a=$110;
      __label__ = 11; break;
    case 11: // $111
      __label__ = 12; break;
    case 12: // $112
      var $113=$1;
      var $114=(($113+12)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$118 & 3;
      var $120=$1;
      var $121=(($120+12)|0);
      var $122=$121;
      var $123=(($122+1)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $126=(($125)|0) > 153;
      var $127=(($126)&1);
      var $128=$119 | $127;
      var $129=$1;
      var $130=(($129+12)|0);
      var $131=$130;
      var $132=(($131+1)|0);
      var $133=HEAPU8[($132)];
      var $134=(($133)&255);
      var $135=$a;
      var $136=(($135)&255);
      var $137=$134 ^ $136;
      var $138=$137 & 16;
      var $139=$128 | $138;
      var $140=$a;
      var $141=(($140)&255);
      var $142=((__ZL3SZP+$141)|0);
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=$139 | $144;
      var $146=(($145) & 255);
      var $147=$1;
      var $148=(($147+12)|0);
      var $149=$148;
      var $150=(($149)|0);
      HEAP8[($150)]=$146;
      var $151=$a;
      var $152=$1;
      var $153=(($152+12)|0);
      var $154=$153;
      var $155=(($154+1)|0);
      HEAP8[($155)]=$151;
      __label__ = 13; break;
    case 13: // $156
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_27P10_z80_state["X"]=1;

function __ZL5op_29P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+24)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+24)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+24)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+24)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+24)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_29P10_z80_state["X"]=1;

function __ZL5op_2bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6-1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_14P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_15P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+20)|0);
  var $6=$5;
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_18P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL3ARGP10_z80_state($3);
      $arg=$4;
      var $5=$arg;
      var $6=(($5 << 24) >> 24);
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=$8;
      var $10=(($9)|0);
      var $11=HEAPU16[(($10)>>1)];
      var $12=(($11)&65535);
      var $13=(($12+$6)|0);
      var $14=(($13) & 65535);
      HEAP16[(($10)>>1)]=$14;
      var $15=$1;
      var $16=(($15+4)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAP16[(($18)>>1)];
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 2; break;
    case 2: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_1aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+12)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+20)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU16[(($23)>>1)];
  var $25=(($24)&65535);
  var $26=(($25+1)|0);
  var $27=(($26) & 65535);
  var $28=$1;
  var $29=(($28+36)|0);
  var $30=$29;
  var $31=(($30)|0);
  HEAP16[(($31)>>1)]=$27;
  ;
  return;
}


function __ZL5op_1cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_1dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_1eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+20)|0);
  var $6=$5;
  var $7=(($6)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_20P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=__ZL3ARGP10_z80_state($13);
      $arg=$14;
      var $15=$arg;
      var $16=(($15 << 24) >> 24);
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+$16)|0);
      var $24=(($23) & 65535);
      HEAP16[(($20)>>1)]=$24;
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAP16[(($28)>>1)];
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      var $36=$1;
      var $37=(($36+128)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+32)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$1;
      var $43=(($42+96)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-$41)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 6; break;
    case 6: // $46
      __label__ = 8; break;
    case 7: // $47
      var $48=$1;
      var $49=(($48+4)|0);
      var $50=$49;
      var $51=(($50)|0);
      var $52=HEAP16[(($51)>>1)];
      var $53=(($52+1)&65535);
      HEAP16[(($51)>>1)]=$53;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_20P10_z80_state["X"]=1;

function __ZL5op_21P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=(($3) & 65535);
  var $5=$1;
  var $6=(($5+24)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=$4;
  ;
  return;
}


function __ZL5op_22P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+24)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5op_24P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_25P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_26P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+24)|0);
  var $6=$5;
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_28P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=__ZL3ARGP10_z80_state($13);
      $arg=$14;
      var $15=$arg;
      var $16=(($15 << 24) >> 24);
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+$16)|0);
      var $24=(($23) & 65535);
      HEAP16[(($20)>>1)]=$24;
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAP16[(($28)>>1)];
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      var $36=$1;
      var $37=(($36+128)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+40)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$1;
      var $43=(($42+96)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-$41)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 6; break;
    case 6: // $46
      __label__ = 8; break;
    case 7: // $47
      var $48=$1;
      var $49=(($48+4)|0);
      var $50=$49;
      var $51=(($50)|0);
      var $52=HEAP16[(($51)>>1)];
      var $53=(($52+1)&65535);
      HEAP16[(($51)>>1)]=$53;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_28P10_z80_state["X"]=1;

function __ZL5op_2aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+24)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5op_2cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_40P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_49P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_52P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_2fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$7 ^ 255;
  var $9=(($8) & 255);
  HEAP8[($5)]=$9;
  var $10=$1;
  var $11=(($10+12)|0);
  var $12=$11;
  var $13=(($12)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=$15 & 197;
  var $17=$16 | 16;
  var $18=$17 | 2;
  var $19=$1;
  var $20=(($19+12)|0);
  var $21=$20;
  var $22=(($21+1)|0);
  var $23=HEAPU8[($22)];
  var $24=(($23)&255);
  var $25=$24 & 40;
  var $26=$18 | $25;
  var $27=(($26) & 255);
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30)|0);
  HEAP8[($31)]=$27;
  ;
  return;
}


function __ZL5op_33P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6+1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_37P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$7 & 236;
  var $9=$8 | 1;
  var $10=$1;
  var $11=(($10+12)|0);
  var $12=$11;
  var $13=(($12+1)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=$15 & 40;
  var $17=$9 | $16;
  var $18=(($17) & 255);
  var $19=$1;
  var $20=(($19+12)|0);
  var $21=$20;
  var $22=(($21)|0);
  HEAP8[($22)]=$18;
  ;
  return;
}


function __ZL5op_39P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+24)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+24)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+24)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_39P10_z80_state["X"]=1;

function __ZL5op_3bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6-1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_3fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$7 & 237;
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU8[($12)];
  var $14=(($13)&255);
  var $15=$14 & 1;
  var $16=$15 << 4;
  var $17=$8 | $16;
  var $18=$1;
  var $19=(($18+12)|0);
  var $20=$19;
  var $21=(($20+1)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$23 & 40;
  var $25=$17 | $24;
  var $26=$25 ^ 1;
  var $27=(($26) & 255);
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30)|0);
  HEAP8[($31)]=$27;
  ;
  return;
}


function __ZL5op_41P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_42P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_43P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_44P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_45P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_47P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_48P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_4aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_4bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_4cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_4dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_4fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_50P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_51P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_53P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_54P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_55P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_57P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_58P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_2dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_2eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+24)|0);
  var $6=$5;
  var $7=(($6)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_30P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=__ZL3ARGP10_z80_state($13);
      $arg=$14;
      var $15=$arg;
      var $16=(($15 << 24) >> 24);
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+$16)|0);
      var $24=(($23) & 65535);
      HEAP16[(($20)>>1)]=$24;
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAP16[(($28)>>1)];
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      var $36=$1;
      var $37=(($36+128)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+48)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$1;
      var $43=(($42+96)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-$41)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 6; break;
    case 6: // $46
      __label__ = 8; break;
    case 7: // $47
      var $48=$1;
      var $49=(($48+4)|0);
      var $50=$49;
      var $51=(($50)|0);
      var $52=HEAP16[(($51)>>1)];
      var $53=(($52+1)&65535);
      HEAP16[(($51)>>1)]=$53;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_30P10_z80_state["X"]=1;

function __ZL5op_31P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=(($3) & 65535);
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=$4;
  ;
  return;
}


function __ZL5op_32P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=(($6+84)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=(($10+80)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$1;
  var $14=(($13+72)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$1;
  var $17=(($16+12)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  var $20=HEAP8[($19)];
  FUNCTION_TABLE[$12]($8, $15, $20);
  var $21=$1;
  var $22=(($21+72)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+1)|0);
  var $25=$24 & 255;
  var $26=(($25) & 255);
  var $27=$1;
  var $28=(($27+36)|0);
  var $29=$28;
  var $30=(($29)|0);
  HEAP8[($30)]=$26;
  var $31=$1;
  var $32=(($31+12)|0);
  var $33=$32;
  var $34=(($33+1)|0);
  var $35=HEAP8[($34)];
  var $36=$1;
  var $37=(($36+36)|0);
  var $38=$37;
  var $39=(($38+1)|0);
  HEAP8[($39)]=$35;
  ;
  return;
}


function __ZL5op_34P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3INCP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5op_35P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3DECP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5op_36P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=__ZL3ARGP10_z80_state($15);
  FUNCTION_TABLE[$8]($4, $14, $16);
  ;
  return;
}


function __ZL5op_38P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=__ZL3ARGP10_z80_state($13);
      $arg=$14;
      var $15=$arg;
      var $16=(($15 << 24) >> 24);
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+$16)|0);
      var $24=(($23) & 65535);
      HEAP16[(($20)>>1)]=$24;
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAP16[(($28)>>1)];
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      var $36=$1;
      var $37=(($36+128)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+56)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$1;
      var $43=(($42+96)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-$41)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 6; break;
    case 6: // $46
      __label__ = 8; break;
    case 7: // $47
      var $48=$1;
      var $49=(($48+4)|0);
      var $50=$49;
      var $51=(($50)|0);
      var $52=HEAP16[(($51)>>1)];
      var $53=(($52+1)&65535);
      HEAP16[(($51)>>1)]=$53;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_38P10_z80_state["X"]=1;

function __ZL5op_3aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=(($6+84)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=(($10+28)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$1;
  var $14=(($13+72)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=FUNCTION_TABLE[$12]($8, $15);
  var $17=$1;
  var $18=(($17+12)|0);
  var $19=$18;
  var $20=(($19+1)|0);
  HEAP8[($20)]=$16;
  var $21=$1;
  var $22=(($21+72)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+1)|0);
  var $25=(($24) & 65535);
  var $26=$1;
  var $27=(($26+36)|0);
  var $28=$27;
  var $29=(($28)|0);
  HEAP16[(($29)>>1)]=$25;
  ;
  return;
}


function __ZL5op_3cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_3dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5op_3eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+12)|0);
  var $6=$5;
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5op_46P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+16)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_4eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+16)|0);
  var $18=$17;
  var $19=(($18)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_56P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+20)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_5bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_64P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_6dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_7fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5op_59P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_5aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_5cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_5dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_5fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_60P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_61P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_62P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_63P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_65P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_67P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_68P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_69P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_6aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_6bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_6cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_6fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_78P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_79P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_7aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_7bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_7cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_7dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5op_80P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_81P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_82P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+20)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_83P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+20)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_84P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_85P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_5eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+20)|0);
  var $18=$17;
  var $19=(($18)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_66P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+24)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_6eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+24)|0);
  var $18=$17;
  var $19=(($18)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_70P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_71P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_72P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_73P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_74P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_75P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_76P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP16[(($6)>>1)];
      var $8=(($7-1)&65535);
      HEAP16[(($6)>>1)]=$8;
      var $9=$1;
      var $10=(($9+60)|0);
      HEAP8[($10)]=1;
      var $11=$1;
      var $12=(($11+65)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$1;
      var $18=(($17+80)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      var $21=(($20+96)|0);
      var $22=HEAP32[(($21)>>2)];
      __ZL12cpu_burn_z80P17legacy_cpu_devicei($19, $22);
      __label__ = 3; break;
    case 3: // $23
      __label__ = 4; break;
    case 4: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_77P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5op_7eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+12)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  ;
  return;
}


function __ZL5op_87P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_88P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+16)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_88P10_z80_state["X"]=1;

function __ZL5op_89P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+16)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_89P10_z80_state["X"]=1;

function __ZL5op_8aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+20)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_8aP10_z80_state["X"]=1;

function __ZL5op_8bP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+20)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_8bP10_z80_state["X"]=1;

function __ZL5op_8cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+24)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_8cP10_z80_state["X"]=1;

function __ZL5op_8dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+24)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_8dP10_z80_state["X"]=1;

function __ZL5op_8fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+12)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_8fP10_z80_state["X"]=1;

function __ZL5op_90P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_91P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_92P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+20)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_93P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+20)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_94P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_95P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_86P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+84)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+28)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+24)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=FUNCTION_TABLE[$16]($12, $22);
      var $24=(($23)&255);
      var $25=(($9+$24)|0);
      var $26=(($25) & 255);
      var $27=(($26)&255);
      $res=$27;
      var $28=$ah;
      var $29=$res;
      var $30=$28 | $29;
      var $31=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $32=(($31+$30)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+12)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP8[($37)]=$33;
      var $38=$res;
      var $39=(($38) & 255);
      var $40=$1;
      var $41=(($40+12)|0);
      var $42=$41;
      var $43=(($42+1)|0);
      HEAP8[($43)]=$39;
      __label__ = 2; break;
    case 2: // $44
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_86P10_z80_state["X"]=1;

function __ZL5op_8eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+84)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+28)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$1;
      var $23=(($22+24)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      var $28=FUNCTION_TABLE[$21]($17, $27);
      var $29=(($28)&255);
      var $30=(($14+$29)|0);
      var $31=$c;
      var $32=(($30+$31)|0);
      var $33=(($32) & 255);
      var $34=(($33)&255);
      $res=$34;
      var $35=$c;
      var $36=$35 << 16;
      var $37=$ah;
      var $38=$36 | $37;
      var $39=$res;
      var $40=$38 | $39;
      var $41=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $42=(($41+$40)|0);
      var $43=HEAP8[($42)];
      var $44=$1;
      var $45=(($44+12)|0);
      var $46=$45;
      var $47=(($46)|0);
      HEAP8[($47)]=$43;
      var $48=$res;
      var $49=(($48) & 255);
      var $50=$1;
      var $51=(($50+12)|0);
      var $52=$51;
      var $53=(($52+1)|0);
      HEAP8[($53)]=$49;
      __label__ = 2; break;
    case 2: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_8eP10_z80_state["X"]=1;

function __ZL5op_96P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+84)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+28)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+24)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=FUNCTION_TABLE[$16]($12, $22);
      var $24=(($23)&255);
      var $25=(($9-$24)|0);
      var $26=(($25) & 255);
      var $27=(($26)&255);
      $res=$27;
      var $28=$ah;
      var $29=$res;
      var $30=$28 | $29;
      var $31=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $32=(($31+$30)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+12)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP8[($37)]=$33;
      var $38=$res;
      var $39=(($38) & 255);
      var $40=$1;
      var $41=(($40+12)|0);
      var $42=$41;
      var $43=(($42+1)|0);
      HEAP8[($43)]=$39;
      __label__ = 2; break;
    case 2: // $44
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_96P10_z80_state["X"]=1;

function __ZL5op_97P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_98P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+16)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_98P10_z80_state["X"]=1;

function __ZL5op_99P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+16)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_99P10_z80_state["X"]=1;

function __ZL5op_9aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+20)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_9aP10_z80_state["X"]=1;

function __ZL5op_9bP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+20)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_9bP10_z80_state["X"]=1;

function __ZL5op_9cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+24)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_9cP10_z80_state["X"]=1;

function __ZL5op_9dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+24)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_9dP10_z80_state["X"]=1;

function __ZL5op_9fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+12)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_9fP10_z80_state["X"]=1;

function __ZL5op_a0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a3P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a7P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_a9P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_9eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+84)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+28)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$1;
      var $23=(($22+24)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      var $28=FUNCTION_TABLE[$21]($17, $27);
      var $29=(($28)&255);
      var $30=(($14-$29)|0);
      var $31=$c;
      var $32=(($30-$31)|0);
      var $33=(($32) & 255);
      var $34=(($33)&255);
      $res=$34;
      var $35=$c;
      var $36=$35 << 16;
      var $37=$ah;
      var $38=$36 | $37;
      var $39=$res;
      var $40=$38 | $39;
      var $41=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $42=(($41+$40)|0);
      var $43=HEAP8[($42)];
      var $44=$1;
      var $45=(($44+12)|0);
      var $46=$45;
      var $47=(($46)|0);
      HEAP8[($47)]=$43;
      var $48=$res;
      var $49=(($48) & 255);
      var $50=$1;
      var $51=(($50+12)|0);
      var $52=$51;
      var $53=(($52+1)|0);
      HEAP8[($53)]=$49;
      __label__ = 2; break;
    case 2: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_9eP10_z80_state["X"]=1;

function __ZL5op_a6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      var $17=(($16)&255);
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 & $17;
      var $25=(($24) & 255);
      HEAP8[($21)]=$25;
      var $26=$1;
      var $27=(($26+12)|0);
      var $28=$27;
      var $29=(($28+1)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $32=((__ZL3SZP+$31)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$34 | 16;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      __label__ = 2; break;
    case 2: // $41
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_aaP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_abP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_acP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_adP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_afP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b3P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b7P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b9P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_baP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_bbP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_bcP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_bdP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_bfP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_aeP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      var $17=(($16)&255);
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 ^ $17;
      var $25=(($24) & 255);
      HEAP8[($21)]=$25;
      var $26=$1;
      var $27=(($26+12)|0);
      var $28=$27;
      var $29=(($28+1)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $32=((__ZL3SZP+$31)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+12)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP8[($37)]=$33;
      __label__ = 2; break;
    case 2: // $38
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_b6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      var $17=(($16)&255);
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 | $17;
      var $25=(($24) & 255);
      HEAP8[($21)]=$25;
      var $26=$1;
      var $27=(($26+12)|0);
      var $28=$27;
      var $29=(($28+1)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $32=((__ZL3SZP+$31)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+12)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP8[($37)]=$33;
      __label__ = 2; break;
    case 2: // $38
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_beP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      var $17=(($16)&255);
      $val=$17;
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 & 65280;
      $ah=$22;
      var $23=$ah;
      var $24=$23 >>> 8;
      var $25=$val;
      var $26=(($24-$25)|0);
      var $27=(($26) & 255);
      var $28=(($27)&255);
      $res=$28;
      var $29=$ah;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=$35 & -41;
      var $37=$val;
      var $38=$37 & 40;
      var $39=$36 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_beP10_z80_state["X"]=1;

function __ZL5op_c0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+192)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_c0P10_z80_state["X"]=1;

function __ZL5op_c1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+16)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_c2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_c3P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL5ARG16P10_z80_state($3);
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=$6;
      HEAP32[(($7)>>2)]=$4;
      var $8=$1;
      var $9=(($8+4)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11) & 65535);
      var $13=$1;
      var $14=(($13+36)|0);
      var $15=$14;
      var $16=(($15)|0);
      HEAP16[(($16)>>1)]=$12;
      __label__ = 2; break;
    case 2: // $17
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_c4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+196)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_c4P10_z80_state["X"]=1;

function __ZL5op_c5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=(($8-2)|0);
      var $10=(($9) & 65535);
      HEAP16[(($6)>>1)]=$10;
      var $11=$1;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($16+16)|0);
      __ZL4WM16P10_z80_statejP4PAIR($11, $15, $17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_c6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=__ZL3ARGP10_z80_state($10);
      var $12=(($11)&255);
      var $13=(($9+$12)|0);
      var $14=(($13) & 255);
      var $15=(($14)&255);
      $res=$15;
      var $16=$ah;
      var $17=$res;
      var $18=$16 | $17;
      var $19=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $20=(($19+$18)|0);
      var $21=HEAP8[($20)];
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP8[($25)]=$21;
      var $26=$res;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30+1)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_c7P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=0;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_c8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+200)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_c8P10_z80_state["X"]=1;

function __ZL5op_c9P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      var $19=$1;
      var $20=(($19+4)|0);
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22) & 65535);
      var $24=$1;
      var $25=(($24+36)|0);
      var $26=$25;
      var $27=(($26)|0);
      HEAP16[(($27)>>1)]=$23;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_caP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_cbP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $op;
      $1=$z80;
      var $2=$1;
      var $3=(($2+56)|0);
      var $4=HEAP8[($3)];
      var $5=(($4+1)&255);
      HEAP8[($3)]=$5;
      var $6=$1;
      var $7=__ZL3ROPP10_z80_state($6);
      var $8=(($7)&255);
      $op=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$op;
      var $11=$1;
      var $12=(($11+112)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$10)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$1;
      var $18=(($17+96)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-$16)|0);
      HEAP32[(($18)>>2)]=$20;
      __label__ = 2; break;
    case 2: // $21
      var $22=$op;
      var $23=((__ZL5Z80cb+($22<<2))|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      FUNCTION_TABLE[$24]($25);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_ccP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 64;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+204)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_ccP10_z80_state["X"]=1;

function __ZL5op_cdP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL5ARG16P10_z80_state($3);
      var $5=$1;
      var $6=(($5+72)|0);
      HEAP32[(($6)>>2)]=$4;
      var $7=$1;
      var $8=(($7+72)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9) & 65535);
      var $11=$1;
      var $12=(($11+36)|0);
      var $13=$12;
      var $14=(($13)|0);
      HEAP16[(($14)>>1)]=$10;
      __label__ = 2; break;
    case 2: // $15
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=$17;
      var $19=(($18)|0);
      var $20=HEAPU16[(($19)>>1)];
      var $21=(($20)&65535);
      var $22=(($21-2)|0);
      var $23=(($22) & 65535);
      HEAP16[(($19)>>1)]=$23;
      var $24=$1;
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=HEAP32[(($27)>>2)];
      var $29=$1;
      var $30=(($29+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($24, $28, $30);
      __label__ = 3; break;
    case 3: // $31
      var $32=$1;
      var $33=(($32+72)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$1;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=$34;
      __label__ = 4; break;
    case 4: // $38
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_ceP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=__ZL3ARGP10_z80_state($15);
      var $17=(($16)&255);
      var $18=(($14+$17)|0);
      var $19=$c;
      var $20=(($18+$19)|0);
      var $21=(($20) & 255);
      var $22=(($21)&255);
      $res=$22;
      var $23=$c;
      var $24=$23 << 16;
      var $25=$ah;
      var $26=$24 | $25;
      var $27=$res;
      var $28=$26 | $27;
      var $29=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $30=(($29+$28)|0);
      var $31=HEAP8[($30)];
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      var $36=$res;
      var $37=(($36) & 255);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=$39;
      var $41=(($40+1)|0);
      HEAP8[($41)]=$37;
      __label__ = 2; break;
    case 2: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_ceP10_z80_state["X"]=1;

function __ZL5op_cfP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=8;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_d0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+208)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_d0P10_z80_state["X"]=1;

function __ZL5op_d1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+20)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_d2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_d3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  var $n;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5+12)|0);
  var $7=$6;
  var $8=(($7+1)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 << 8;
  var $12=$4 | $11;
  $n=$12;
  var $13=$1;
  var $14=(($13+92)|0);
  var $15=HEAPU32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+80)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$n;
  var $21=$1;
  var $22=(($21+12)|0);
  var $23=$22;
  var $24=(($23+1)|0);
  var $25=HEAP8[($24)];
  FUNCTION_TABLE[$19]($15, $20, $25);
  var $26=$n;
  var $27=$26 & 255;
  var $28=(($27+1)|0);
  var $29=$28 & 255;
  var $30=(($29) & 255);
  var $31=$1;
  var $32=(($31+36)|0);
  var $33=$32;
  var $34=(($33)|0);
  HEAP8[($34)]=$30;
  var $35=$1;
  var $36=(($35+12)|0);
  var $37=$36;
  var $38=(($37+1)|0);
  var $39=HEAP8[($38)];
  var $40=$1;
  var $41=(($40+36)|0);
  var $42=$41;
  var $43=(($42+1)|0);
  HEAP8[($43)]=$39;
  ;
  return;
}
__ZL5op_d3P10_z80_state["X"]=1;

function __ZL5op_d4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+212)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_d4P10_z80_state["X"]=1;

function __ZL5op_d5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=(($8-2)|0);
      var $10=(($9) & 65535);
      HEAP16[(($6)>>1)]=$10;
      var $11=$1;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($16+20)|0);
      __ZL4WM16P10_z80_statejP4PAIR($11, $15, $17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_d6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=__ZL3ARGP10_z80_state($10);
      var $12=(($11)&255);
      var $13=(($9-$12)|0);
      var $14=(($13) & 255);
      var $15=(($14)&255);
      $res=$15;
      var $16=$ah;
      var $17=$res;
      var $18=$16 | $17;
      var $19=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $20=(($19+$18)|0);
      var $21=HEAP8[($20)];
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP8[($25)]=$21;
      var $26=$res;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30+1)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_d7P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=16;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_d8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+216)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_d8P10_z80_state["X"]=1;

function __ZL5op_d9P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmp=__stackBase__;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$tmp;
      var $6=$4;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];
      var $7=$1;
      var $8=(($7+16)|0);
      var $9=$1;
      var $10=(($9+44)|0);
      var $11=$8;
      var $12=$10;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];
      var $13=$1;
      var $14=(($13+44)|0);
      var $15=$14;
      var $16=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];
      var $17=$1;
      var $18=(($17+20)|0);
      var $19=$tmp;
      var $20=$18;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];
      var $21=$1;
      var $22=(($21+20)|0);
      var $23=$1;
      var $24=(($23+48)|0);
      var $25=$22;
      var $26=$24;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($25)>>2)]=HEAP32[(($26)>>2)];
      var $27=$1;
      var $28=(($27+48)|0);
      var $29=$28;
      var $30=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($29)>>2)]=HEAP32[(($30)>>2)];
      var $31=$1;
      var $32=(($31+24)|0);
      var $33=$tmp;
      var $34=$32;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($33)>>2)]=HEAP32[(($34)>>2)];
      var $35=$1;
      var $36=(($35+24)|0);
      var $37=$1;
      var $38=(($37+52)|0);
      var $39=$36;
      var $40=$38;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=$1;
      var $42=(($41+52)|0);
      var $43=$42;
      var $44=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($43)>>2)]=HEAP32[(($44)>>2)];
      __label__ = 2; break;
    case 2: // $45
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_d9P10_z80_state["X"]=1;

function __ZL5op_daP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_dbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  var $n;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5+12)|0);
  var $7=$6;
  var $8=(($7+1)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 << 8;
  var $12=$4 | $11;
  $n=$12;
  var $13=$1;
  var $14=(($13+92)|0);
  var $15=HEAPU32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$n;
  var $21=FUNCTION_TABLE[$19]($15, $20);
  var $22=$1;
  var $23=(($22+12)|0);
  var $24=$23;
  var $25=(($24+1)|0);
  HEAP8[($25)]=$21;
  var $26=$n;
  var $27=(($26+1)|0);
  var $28=(($27) & 65535);
  var $29=$1;
  var $30=(($29+36)|0);
  var $31=$30;
  var $32=(($31)|0);
  HEAP16[(($32)>>1)]=$28;
  ;
  return;
}


function __ZL5op_dcP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+220)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_dcP10_z80_state["X"]=1;

function __ZL5op_ddP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $op;
      $1=$z80;
      var $2=$1;
      var $3=(($2+56)|0);
      var $4=HEAP8[($3)];
      var $5=(($4+1)&255);
      HEAP8[($3)]=$5;
      var $6=$1;
      var $7=__ZL3ROPP10_z80_state($6);
      var $8=(($7)&255);
      $op=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$op;
      var $11=$1;
      var $12=(($11+120)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$10)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$1;
      var $18=(($17+96)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-$16)|0);
      HEAP32[(($18)>>2)]=$20;
      __label__ = 2; break;
    case 2: // $21
      var $22=$op;
      var $23=((__ZL5Z80dd+($22<<2))|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      FUNCTION_TABLE[$24]($25);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_deP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=__ZL3ARGP10_z80_state($15);
      var $17=(($16)&255);
      var $18=(($14-$17)|0);
      var $19=$c;
      var $20=(($18-$19)|0);
      var $21=(($20) & 255);
      var $22=(($21)&255);
      $res=$22;
      var $23=$c;
      var $24=$23 << 16;
      var $25=$ah;
      var $26=$24 | $25;
      var $27=$res;
      var $28=$26 | $27;
      var $29=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $30=(($29+$28)|0);
      var $31=HEAP8[($30)];
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      var $36=$res;
      var $37=(($36) & 255);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=$39;
      var $41=(($40+1)|0);
      HEAP8[($41)]=$37;
      __label__ = 2; break;
    case 2: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_deP10_z80_state["X"]=1;

function __ZL5op_dfP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=24;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+224)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_e0P10_z80_state["X"]=1;

function __ZL5op_e1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+24)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e3P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmp=__stackBase__;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$tmp;
      HEAP32[(($3)>>2)]=0;
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $tmp);
      var $9=$1;
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14+24)|0);
      __ZL4WM16P10_z80_statejP4PAIR($9, $13, $15);
      var $16=$1;
      var $17=(($16+24)|0);
      var $18=$17;
      var $19=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[(($19)>>2)];
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      __label__ = 2; break;
    case 2: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP16[(($10)>>1)]=$6;
  ;
  return;
}


function __ZL5op_f3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+59)|0);
  HEAP8[($3)]=0;
  var $4=$1;
  var $5=(($4+58)|0);
  HEAP8[($5)]=0;
  ;
  return;
}


function __ZL5op_e4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+228)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_e4P10_z80_state["X"]=1;

function __ZL5op_e5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=(($8-2)|0);
      var $10=(($9) & 65535);
      HEAP16[(($6)>>1)]=$10;
      var $11=$1;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($16+24)|0);
      __ZL4WM16P10_z80_statejP4PAIR($11, $15, $17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL3ARGP10_z80_state($3);
      var $5=(($4)&255);
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=$7;
      var $9=(($8+1)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=$11 & $5;
      var $13=(($12) & 255);
      HEAP8[($9)]=$13;
      var $14=$1;
      var $15=(($14+12)|0);
      var $16=$15;
      var $17=(($16+1)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=((__ZL3SZP+$19)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$22 | 16;
      var $24=(($23) & 255);
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e7P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=32;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_e8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+232)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_e8P10_z80_state["X"]=1;

function __ZL5op_eaP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_ebP10_z80_state($z80) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmp=__stackBase__;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=$tmp;
      var $6=$4;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=$1;
      var $10=(($9+24)|0);
      var $11=$8;
      var $12=$10;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];
      var $13=$1;
      var $14=(($13+24)|0);
      var $15=$14;
      var $16=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];
      __label__ = 2; break;
    case 2: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_ecP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+236)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_ecP10_z80_state["X"]=1;

function __ZL5op_edP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $op;
      $1=$z80;
      var $2=$1;
      var $3=(($2+56)|0);
      var $4=HEAP8[($3)];
      var $5=(($4+1)&255);
      HEAP8[($3)]=$5;
      var $6=$1;
      var $7=__ZL3ROPP10_z80_state($6);
      var $8=(($7)&255);
      $op=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$op;
      var $11=$1;
      var $12=(($11+116)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$10)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$1;
      var $18=(($17+96)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-$16)|0);
      HEAP32[(($18)>>2)]=$20;
      __label__ = 2; break;
    case 2: // $21
      var $22=$op;
      var $23=((__ZL5Z80ed+($22<<2))|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      FUNCTION_TABLE[$24]($25);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_eeP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL3ARGP10_z80_state($3);
      var $5=(($4)&255);
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=$7;
      var $9=(($8+1)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=$11 ^ $5;
      var $13=(($12) & 255);
      HEAP8[($9)]=$13;
      var $14=$1;
      var $15=(($14+12)|0);
      var $16=$15;
      var $17=(($16+1)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=((__ZL3SZP+$19)|0);
      var $21=HEAP8[($20)];
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP8[($25)]=$21;
      __label__ = 2; break;
    case 2: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_efP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=40;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_f0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 128;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+240)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_f0P10_z80_state["X"]=1;

function __ZL5op_f1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+12)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_f2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 128;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_f4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 128;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+244)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_f4P10_z80_state["X"]=1;

function __ZL5op_f5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=(($8-2)|0);
      var $10=(($9) & 65535);
      HEAP16[(($6)>>1)]=$10;
      var $11=$1;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($16+12)|0);
      __ZL4WM16P10_z80_statejP4PAIR($11, $15, $17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_f6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL3ARGP10_z80_state($3);
      var $5=(($4)&255);
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=$7;
      var $9=(($8+1)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=$11 | $5;
      var $13=(($12) & 255);
      HEAP8[($9)]=$13;
      var $14=$1;
      var $15=(($14+12)|0);
      var $16=$15;
      var $17=(($16+1)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=((__ZL3SZP+$19)|0);
      var $21=HEAP8[($20)];
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP8[($25)]=$21;
      __label__ = 2; break;
    case 2: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_f7P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=48;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_f9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=$1;
  var $8=(($7+8)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP16[(($10)>>1)]=$6;
  ;
  return;
}


function __ZL5op_fbP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+59)|0);
      HEAP8[($4)]=1;
      var $5=$1;
      var $6=(($5+58)|0);
      HEAP8[($6)]=1;
      var $7=$1;
      var $8=(($7+70)|0);
      HEAP8[($8)]=1;
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_09P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+16)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+32)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+32)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+16)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+32)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_09P10_z80_state["X"]=1;

function __ZL5fd_19P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+32)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+32)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+20)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+32)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_19P10_z80_state["X"]=1;

function __ZL5fd_23P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6+1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5op_f8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 128;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($13, $17, $19);
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+2)|0);
      var $27=(($26) & 65535);
      HEAP16[(($23)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP16[(($32)>>1)];
      var $34=$1;
      var $35=(($34+36)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP16[(($37)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+128)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+248)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$1;
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_f8P10_z80_state["X"]=1;

function __ZL5op_faP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 128;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=$15;
      HEAP32[(($16)>>2)]=$13;
      var $17=$1;
      var $18=(($17+4)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 65535);
      var $22=$1;
      var $23=(($22+36)|0);
      var $24=$23;
      var $25=(($24)|0);
      HEAP16[(($25)>>1)]=$21;
      __label__ = 4; break;
    case 3: // $26
      var $27=$1;
      var $28=__ZL5ARG16P10_z80_state($27);
      var $29=(($28) & 65535);
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=$31;
      var $33=(($32)|0);
      HEAP16[(($33)>>1)]=$29;
      __label__ = 4; break;
    case 4: // $34
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_fcP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 128;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL5ARG16P10_z80_state($12);
      var $14=$1;
      var $15=(($14+72)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=(($16+72)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18) & 65535);
      var $20=$1;
      var $21=(($20+36)|0);
      var $22=$21;
      var $23=(($22)|0);
      HEAP16[(($23)>>1)]=$19;
      __label__ = 3; break;
    case 3: // $24
      var $25=$1;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30-2)|0);
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=$1;
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=$1;
      var $39=(($38+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($33, $37, $39);
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=$43;
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+128)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+252)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$1;
      var $55=(($54+96)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56-$53)|0);
      HEAP32[(($55)>>2)]=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 8; break;
    case 7: // $59
      var $60=$1;
      var $61=__ZL5ARG16P10_z80_state($60);
      var $62=(($61) & 65535);
      var $63=$1;
      var $64=(($63+36)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP16[(($66)>>1)]=$62;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 9; break;
    case 9: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5op_fcP10_z80_state["X"]=1;

function __ZL5op_fdP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $op;
      $1=$z80;
      var $2=$1;
      var $3=(($2+56)|0);
      var $4=HEAP8[($3)];
      var $5=(($4+1)&255);
      HEAP8[($3)]=$5;
      var $6=$1;
      var $7=__ZL3ROPP10_z80_state($6);
      var $8=(($7)&255);
      $op=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$op;
      var $11=$1;
      var $12=(($11+120)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$10)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$1;
      var $18=(($17+96)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-$16)|0);
      HEAP32[(($18)>>2)]=$20;
      __label__ = 2; break;
    case 2: // $21
      var $22=$op;
      var $23=((__ZL5Z80fd+($22<<2))|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      FUNCTION_TABLE[$24]($25);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_feP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZL3ARGP10_z80_state($3);
      var $5=(($4)&255);
      $val=$5;
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=$7;
      var $9=HEAP32[(($8)>>2)];
      var $10=$9 & 65280;
      $ah=$10;
      var $11=$ah;
      var $12=$11 >>> 8;
      var $13=$val;
      var $14=(($12-$13)|0);
      var $15=(($14) & 255);
      var $16=(($15)&255);
      $res=$16;
      var $17=$ah;
      var $18=$res;
      var $19=$17 | $18;
      var $20=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $21=(($20+$19)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 & -41;
      var $25=$val;
      var $26=$25 & 40;
      var $27=$24 | $26;
      var $28=(($27) & 255);
      var $29=$1;
      var $30=(($29+12)|0);
      var $31=$30;
      var $32=(($31)|0);
      HEAP8[($32)]=$28;
      __label__ = 2; break;
    case 2: // $33
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5op_ffP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      var $10=(($9-2)|0);
      var $11=(($10) & 65535);
      HEAP16[(($7)>>1)]=$11;
      var $12=$1;
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+4)|0);
      __ZL4WM16P10_z80_statejP4PAIR($12, $16, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=56;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP16[(($26)>>1)];
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL3ARGP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  var $pc;
  $1=$z80;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  $pc=$5;
  var $6=$1;
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=(($8)|0);
  var $10=HEAP16[(($9)>>1)];
  var $11=(($10+1)&65535);
  HEAP16[(($9)>>1)]=$11;
  var $12=$1;
  var $13=(($12+88)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$pc;
  var $16=__ZN16direct_read_data13read_raw_byteEjj($14, $15, 0);
  ;
  return $16;
}


function __ZL5fd_00P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_00P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_01P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_01P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_02P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_02P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_03P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_03P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_04P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_04P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_05P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_05P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_06P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_06P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_07P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_07P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_08P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_08P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_0aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_0bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_0cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0cP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_0dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0dP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_0eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0eP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_0fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_10P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_10P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_11P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_11P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_12P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_12P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_13P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_13P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_14P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_14P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_15P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_15P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_16P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_17P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_17P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_18P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_18P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_1aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_1bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_1cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1cP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_1dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1dP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_1eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1eP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_1fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_20P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_20P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_21P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=(($3) & 65535);
  var $5=$1;
  var $6=(($5+32)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=$4;
  ;
  return;
}


function __ZL5fd_22P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+32)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5fd_24P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+32)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+32)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5fd_25P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+32)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+32)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5fd_26P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+32)|0);
  var $6=$5;
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5fd_27P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_27P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_28P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_28P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_29P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+32)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+32)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+32)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+32)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+32)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_29P10_z80_state["X"]=1;

function __ZL5fd_2bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6-1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5fd_39P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+32)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+32)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+32)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_39P10_z80_state["X"]=1;

function __ZL5fd_44P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_45P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_4cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_4dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_54P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_55P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_5cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_5dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_2aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+32)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5fd_2cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+32)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+32)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5fd_2dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+32)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+32)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5fd_2eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+32)|0);
  var $6=$5;
  var $7=(($6)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5fd_2fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_2fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_30P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_30P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_31P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_31P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_32P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_32P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_33P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_33P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_34P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=$1;
      var $38=(($37+84)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+28)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+72)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=FUNCTION_TABLE[$43]($39, $46);
      var $48=__ZL3INCP10_z80_stateh($36, $47);
      FUNCTION_TABLE[$32]($28, $35, $48);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_34P10_z80_state["X"]=1;

function __ZL5fd_35P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=$1;
      var $38=(($37+84)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+28)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+72)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=FUNCTION_TABLE[$43]($39, $46);
      var $48=__ZL3DECP10_z80_stateh($36, $47);
      FUNCTION_TABLE[$32]($28, $35, $48);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_35P10_z80_state["X"]=1;

function __ZL5fd_36P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=__ZL3ARGP10_z80_state($36);
      FUNCTION_TABLE[$32]($28, $35, $37);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_37P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_37P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_38P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_38P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_3aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_3bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_3cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3cP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_3dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3dP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_3eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3eP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_3fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_40P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_40P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_41P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_41P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_42P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_42P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_43P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_43P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_46P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+16)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_47P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_47P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_48P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_48P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_49P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_49P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_4aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_4aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_4bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_4bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_4eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+16)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_4fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_4fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_50P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_50P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_51P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_51P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_52P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_52P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_53P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_53P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_56P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+20)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_57P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_57P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_58P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_58P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_59P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_59P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_5aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_5aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_5bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_5bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_64P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5fd_6dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5fd_60P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_61P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_62P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_63P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_65P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_67P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_68P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_69P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_6aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_6bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_6cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_6fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+32)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_7cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_7dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5fd_84P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+32)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_85P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+32)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_5eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+20)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_5fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_5fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_66P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+24)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_6eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+24)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_70P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+16)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_71P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+16)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_72P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_73P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_74P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+24)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_75P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+24)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_76P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_76P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_77P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_78P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_78P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_79P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_79P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_7aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_7aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_7bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_7bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_7eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_7fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_7fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_80P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_80P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_81P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_81P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_82P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_82P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_83P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_83P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_8cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+32)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_8cP10_z80_state["X"]=1;

function __ZL5fd_8dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+32)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_8dP10_z80_state["X"]=1;

function __ZL5fd_94P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+32)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_95P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+32)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_9cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+32)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_9cP10_z80_state["X"]=1;

function __ZL5fd_9dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+32)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_9dP10_z80_state["X"]=1;

function __ZL5fd_a4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_a5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_86P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$ah;
      var $33=$32 >>> 8;
      var $34=$1;
      var $35=(($34+84)|0);
      var $36=HEAPU32[(($35)>>2)];
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=FUNCTION_TABLE[$40]($36, $43);
      var $45=(($44)&255);
      var $46=(($33+$45)|0);
      var $47=(($46) & 255);
      var $48=(($47)&255);
      $res=$48;
      var $49=$ah;
      var $50=$res;
      var $51=$49 | $50;
      var $52=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $53=(($52+$51)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      var $59=$res;
      var $60=(($59) & 255);
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63+1)|0);
      HEAP8[($64)]=$60;
      __label__ = 4; break;
    case 4: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_86P10_z80_state["X"]=1;

function __ZL5fd_87P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_87P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_88P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_88P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_89P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_89P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_8aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_8aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_8bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_8bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_8eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & 1;
      $c=$36;
      var $37=$ah;
      var $38=$37 >>> 8;
      var $39=$1;
      var $40=(($39+84)|0);
      var $41=HEAPU32[(($40)>>2)];
      var $42=$41;
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+28)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+72)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=FUNCTION_TABLE[$45]($41, $48);
      var $50=(($49)&255);
      var $51=(($38+$50)|0);
      var $52=$c;
      var $53=(($51+$52)|0);
      var $54=(($53) & 255);
      var $55=(($54)&255);
      $res=$55;
      var $56=$c;
      var $57=$56 << 16;
      var $58=$ah;
      var $59=$57 | $58;
      var $60=$res;
      var $61=$59 | $60;
      var $62=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $63=(($62+$61)|0);
      var $64=HEAP8[($63)];
      var $65=$1;
      var $66=(($65+12)|0);
      var $67=$66;
      var $68=(($67)|0);
      HEAP8[($68)]=$64;
      var $69=$res;
      var $70=(($69) & 255);
      var $71=$1;
      var $72=(($71+12)|0);
      var $73=$72;
      var $74=(($73+1)|0);
      HEAP8[($74)]=$70;
      __label__ = 4; break;
    case 4: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_8eP10_z80_state["X"]=1;

function __ZL5fd_8fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_8fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_90P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_90P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_91P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_91P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_92P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_92P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_93P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_93P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_96P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$ah;
      var $33=$32 >>> 8;
      var $34=$1;
      var $35=(($34+84)|0);
      var $36=HEAPU32[(($35)>>2)];
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=FUNCTION_TABLE[$40]($36, $43);
      var $45=(($44)&255);
      var $46=(($33-$45)|0);
      var $47=(($46) & 255);
      var $48=(($47)&255);
      $res=$48;
      var $49=$ah;
      var $50=$res;
      var $51=$49 | $50;
      var $52=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $53=(($52+$51)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      var $59=$res;
      var $60=(($59) & 255);
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63+1)|0);
      HEAP8[($64)]=$60;
      __label__ = 4; break;
    case 4: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_96P10_z80_state["X"]=1;

function __ZL5fd_97P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_97P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_98P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_98P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_99P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_99P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_9aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_9aP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_9bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_9bP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_9eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & 1;
      $c=$36;
      var $37=$ah;
      var $38=$37 >>> 8;
      var $39=$1;
      var $40=(($39+84)|0);
      var $41=HEAPU32[(($40)>>2)];
      var $42=$41;
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+28)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+72)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=FUNCTION_TABLE[$45]($41, $48);
      var $50=(($49)&255);
      var $51=(($38-$50)|0);
      var $52=$c;
      var $53=(($51-$52)|0);
      var $54=(($53) & 255);
      var $55=(($54)&255);
      $res=$55;
      var $56=$c;
      var $57=$56 << 16;
      var $58=$ah;
      var $59=$57 | $58;
      var $60=$res;
      var $61=$59 | $60;
      var $62=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $63=(($62+$61)|0);
      var $64=HEAP8[($63)];
      var $65=$1;
      var $66=(($65+12)|0);
      var $67=$66;
      var $68=(($67)|0);
      HEAP8[($68)]=$64;
      var $69=$res;
      var $70=(($69) & 255);
      var $71=$1;
      var $72=(($71+12)|0);
      var $73=$72;
      var $74=(($73+1)|0);
      HEAP8[($74)]=$70;
      __label__ = 4; break;
    case 4: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_9eP10_z80_state["X"]=1;

function __ZL5fd_9fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_9fP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_a0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a0P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_a1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a1P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_a2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a2P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_a3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a3P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_acP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_adP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_b4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_b5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_bcP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_bdP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_a6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 & $38;
      var $46=(($45) & 255);
      HEAP8[($42)]=$46;
      var $47=$1;
      var $48=(($47+12)|0);
      var $49=$48;
      var $50=(($49+1)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=((__ZL3SZP+$52)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$55 | 16;
      var $57=(($56) & 255);
      var $58=$1;
      var $59=(($58+12)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP8[($61)]=$57;
      __label__ = 4; break;
    case 4: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_a6P10_z80_state["X"]=1;

function __ZL5fd_a7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a7P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_a8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a8P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_a9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a9P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_aaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_aaP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_abP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_abP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_aeP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 ^ $38;
      var $46=(($45) & 255);
      HEAP8[($42)]=$46;
      var $47=$1;
      var $48=(($47+12)|0);
      var $49=$48;
      var $50=(($49+1)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=((__ZL3SZP+$52)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      __label__ = 4; break;
    case 4: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_aeP10_z80_state["X"]=1;

function __ZL5fd_afP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_afP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b0P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b1P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b2P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b3P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 | $38;
      var $46=(($45) & 255);
      HEAP8[($42)]=$46;
      var $47=$1;
      var $48=(($47+12)|0);
      var $49=$48;
      var $50=(($49+1)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=((__ZL3SZP+$52)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      __label__ = 4; break;
    case 4: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_b6P10_z80_state["X"]=1;

function __ZL5fd_b7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b7P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b8P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_b9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b9P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_baP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_baP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_bbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_bbP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_beP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      $val=$38;
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$42 & 65280;
      $ah=$43;
      var $44=$ah;
      var $45=$44 >>> 8;
      var $46=$val;
      var $47=(($45-$46)|0);
      var $48=(($47) & 255);
      var $49=(($48)&255);
      $res=$49;
      var $50=$ah;
      var $51=$res;
      var $52=$50 | $51;
      var $53=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $54=(($53+$52)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & -41;
      var $58=$val;
      var $59=$58 & 40;
      var $60=$57 | $59;
      var $61=(($60) & 255);
      var $62=$1;
      var $63=(($62+12)|0);
      var $64=$63;
      var $65=(($64)|0);
      HEAP8[($65)]=$61;
      __label__ = 4; break;
    case 4: // $66
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_beP10_z80_state["X"]=1;

function __ZL5fd_bfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_bfP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c0P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c1P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c2P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c3P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c4P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c5P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c6P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c7P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c8P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_c9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c9P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_caP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_caP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_cbP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $op;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=__ZL3ARGP10_z80_state($26);
      var $28=(($27)&255);
      $op=$28;
      __label__ = 3; break;
    case 3: // $29
      var $30=$op;
      var $31=$1;
      var $32=(($31+124)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$30)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$1;
      var $38=(($37+96)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-$36)|0);
      HEAP32[(($38)>>2)]=$40;
      __label__ = 4; break;
    case 4: // $41
      var $42=$op;
      var $43=((__ZL7Z80xycb+($42<<2))|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$1;
      FUNCTION_TABLE[$44]($45);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5fd_cbP10_z80_state["X"]=1;

function __ZL5fd_ccP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ccP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_cdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_cdP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_ceP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ceP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_cfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_cfP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d0P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d1P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d2P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d3P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d4P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d5P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d6P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d7P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_d8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d8P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP16[(($10)>>1)]=$6;
  ;
  return;
}


function __ZL5fd_f9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=$1;
  var $8=(($7+8)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP16[(($10)>>1)]=$6;
  ;
  return;
}


function __ZL5fd_d9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d9P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_daP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_daP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_dbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_dbP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_dcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_dcP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_ddP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ddP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_deP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_deP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_dfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_dfP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e0P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+32)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_e2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e2P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e3P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmp=__stackBase__;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$tmp;
      HEAP32[(($3)>>2)]=0;
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $tmp);
      var $9=$1;
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14+32)|0);
      __ZL4WM16P10_z80_statejP4PAIR($9, $13, $15);
      var $16=$1;
      var $17=(($16+32)|0);
      var $18=$17;
      var $19=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[(($19)>>2)];
      var $20=$1;
      var $21=(($20+32)|0);
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      __label__ = 2; break;
    case 2: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_e4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e4P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=(($8-2)|0);
      var $10=(($9) & 65535);
      HEAP16[(($6)>>1)]=$10;
      var $11=$1;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($16+32)|0);
      __ZL4WM16P10_z80_statejP4PAIR($11, $15, $17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5fd_e6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e6P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e7P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_e8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e8P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_eaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_eaP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_ebP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ebP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_ecP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ecP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_edP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_edP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_eeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_eeP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_efP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_efP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f0P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f1P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f2P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f3P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f4P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f5P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f6P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f7P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_f8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f8P10_z80_state($3);
  ;
  return;
}


function __ZL5fd_faP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_faP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_fbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_fbP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_fcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_fcP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_fdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_fdP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_feP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_feP10_z80_state($3);
  ;
  return;
}


function __ZL5fd_ffP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ffP10_z80_state($3);
  ;
  return;
}


function __ZL9illegal_1P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=__ZNK8device_t3tagEv($5);
  var $7=$1;
  var $8=(($7+88)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+4)|0);
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13-1)|0);
  var $15=$14 & 65535;
  var $16=__ZN16direct_read_data19read_decrypted_byteEjj($9, $15, 0);
  var $17=(($16)&255);
  var $18=$1;
  var $19=(($18+88)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$1;
  var $22=(($21+4)|0);
  var $23=$22;
  var $24=HEAP32[(($23)>>2)];
  var $25=__ZN16direct_read_data19read_decrypted_byteEjj($20, $24, 0);
  var $26=(($25)&255);
  __Z8logerrorPKcz(((STRING_TABLE.__str7242)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$6,HEAP32[((tempInt+4)>>2)]=$17,HEAP32[((tempInt+8)>>2)]=$26,tempInt));
  STACKTOP = __stackBase__;
  return;
}


function __ZL4RM16P10_z80_statejP4PAIR($z80, $addr, $r) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$z80;
  $2=$addr;
  $3=$r;
  var $4=$1;
  var $5=(($4+84)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+28)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=FUNCTION_TABLE[$10]($6, $11);
  var $13=$3;
  var $14=$13;
  var $15=(($14)|0);
  HEAP8[($15)]=$12;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$2;
  var $24=(($23+1)|0);
  var $25=$24 & 65535;
  var $26=FUNCTION_TABLE[$22]($18, $25);
  var $27=$3;
  var $28=$27;
  var $29=(($28+1)|0);
  HEAP8[($29)]=$26;
  ;
  return;
}


function __ZL7xycb_00P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_01P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_02P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_03P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_04P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_05P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_06P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL3RLCP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_07P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RLCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_08P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_09P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_0aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_0bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_0cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_0dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_0eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL3RRCP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_0fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3RRCP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_10P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_11P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_12P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_13P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_14P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_15P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL2RLP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_17P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_18P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_19P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_1aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_1bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_1cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_1dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_1eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL2RRP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_1fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL2RRP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_20P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_21P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_22P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_23P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_24P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_25P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_26P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL3SLAP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_27P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_28P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_29P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_2aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_2bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_2cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_2dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_2eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL3SRAP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_2fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRAP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_30P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_31P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_32P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_33P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_34P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_35P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_36P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL3SLLP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_37P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SLLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_38P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_39P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+16)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_3aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_3bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+20)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_3cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_3dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+24)|0);
  var $31=$30;
  var $32=(($31)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_3eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=$1;
  var $14=(($13+84)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+28)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  var $21=(($20+72)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=FUNCTION_TABLE[$19]($15, $22);
  var $24=__ZL3SRLP10_z80_stateh($12, $23);
  FUNCTION_TABLE[$8]($4, $11, $24);
  ;
  return;
}


function __ZL7xycb_3fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+84)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+28)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+72)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=FUNCTION_TABLE[$9]($5, $12);
  var $14=__ZL3SRLP10_z80_stateh($2, $13);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  HEAP8[($18)]=$14;
  var $19=$1;
  var $20=(($19+84)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+80)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=$1;
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$1;
  var $30=(($29+12)|0);
  var $31=$30;
  var $32=(($31+1)|0);
  var $33=HEAP8[($32)];
  FUNCTION_TABLE[$25]($21, $28, $33);
  ;
  return;
}


function __ZL7xycb_40P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_41P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_42P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_43P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_44P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_45P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_46P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 1;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_47P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_46P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_48P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_49P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_4aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_4bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_4cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_4dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_4eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 2;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_4fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_4eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_50P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_51P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_52P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_53P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_54P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_55P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_56P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 4;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_57P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_56P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_58P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_59P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_5aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_5bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_5cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_5dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_5eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 8;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_5fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_5eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_60P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_61P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_62P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_63P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_64P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_65P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_66P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 16;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_67P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_66P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_68P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_69P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_6aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_6bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_6cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_6dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_6eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 32;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_6fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_6eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_70P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_71P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_72P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_73P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_74P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_75P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_76P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 64;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_77P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_76P10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_78P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_79P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_7aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_7bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_7cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_7dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_7eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+72)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=FUNCTION_TABLE[$17]($13, $20);
      var $22=(($21)&255);
      var $23=$22 & 128;
      var $24=((__ZL6SZ_BIT+$23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$10 | $27;
      var $29=$1;
      var $30=(($29+72)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31 >>> 8;
      var $33=$32 & 40;
      var $34=$28 | $33;
      var $35=(($34) & 255);
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38)|0);
      HEAP8[($39)]=$35;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7xycb_7fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL7xycb_7eP10_z80_state($2);
  ;
  return;
}


function __ZL7xycb_80P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_81P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_82P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_83P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_84P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_85P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_86P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(0, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_87P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(0, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_88P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_89P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_8aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_8bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_8cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_8dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_8eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(1, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_8fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(1, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_90P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_91P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_92P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_93P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_94P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_95P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_96P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(2, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_97P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(2, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_98P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_99P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_9aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_9bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_9cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_9dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_9eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(3, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_9fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(3, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(4, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_a7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(4, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_a9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_aaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_abP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_acP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_adP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_aeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(5, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_afP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(5, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(6, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_b7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(6, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_b9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_baP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_bbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_bcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_bdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_beP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3REShh(7, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_bfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3REShh(7, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(0, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_c7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(0, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_c9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_caP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_cbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_ccP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_cdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_ceP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(1, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_cfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(1, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(2, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_d7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(2, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_d9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_daP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_dbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_dcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_ddP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_deP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(3, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_dfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(3, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(4, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_e7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(4, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_e9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_eaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_ebP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_ecP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_edP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_eeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(5, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_efP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(5, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL3SEThh($bit, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$bit;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5)&255);
  var $7=1 << $6;
  var $8=$4 | $7;
  var $9=(($8) & 255);
  ;
  return $9;
}


function __ZL3REShh($bit, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$bit;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  var $5=$1;
  var $6=(($5)&255);
  var $7=1 << $6;
  var $8=$7 ^ -1;
  var $9=$4 & $8;
  var $10=(($9) & 255);
  ;
  return $10;
}


function __ZL3SRLP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 1;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 >>> 1;
  var $11=$10 & 255;
  $res=$11;
  var $12=$res;
  var $13=((__ZL3SZP+$12)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=$c;
  var $17=$15 | $16;
  var $18=(($17) & 255);
  var $19=$1;
  var $20=(($19+12)|0);
  var $21=$20;
  var $22=(($21)|0);
  HEAP8[($22)]=$18;
  var $23=$res;
  var $24=(($23) & 255);
  ;
  return $24;
}


function __ZL3SLLP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 128;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 << 1;
  var $11=$10 | 1;
  var $12=$11 & 255;
  $res=$12;
  var $13=$res;
  var $14=((__ZL3SZP+$13)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$c;
  var $18=$16 | $17;
  var $19=(($18) & 255);
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  HEAP8[($23)]=$19;
  var $24=$res;
  var $25=(($24) & 255);
  ;
  return $25;
}


function __ZL3SRAP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 1;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 >>> 1;
  var $11=$res;
  var $12=$11 & 128;
  var $13=$10 | $12;
  var $14=$13 & 255;
  $res=$14;
  var $15=$res;
  var $16=((__ZL3SZP+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$c;
  var $20=$18 | $19;
  var $21=(($20) & 255);
  var $22=$1;
  var $23=(($22+12)|0);
  var $24=$23;
  var $25=(($24)|0);
  HEAP8[($25)]=$21;
  var $26=$res;
  var $27=(($26) & 255);
  ;
  return $27;
}


function __ZL3SLAP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 128;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 << 1;
  var $11=$10 & 255;
  $res=$11;
  var $12=$res;
  var $13=((__ZL3SZP+$12)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=$c;
  var $17=$15 | $16;
  var $18=(($17) & 255);
  var $19=$1;
  var $20=(($19+12)|0);
  var $21=$20;
  var $22=(($21)|0);
  HEAP8[($22)]=$18;
  var $23=$res;
  var $24=(($23) & 255);
  ;
  return $24;
}


function __ZL2RRP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 1;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 >>> 1;
  var $11=$1;
  var $12=(($11+12)|0);
  var $13=$12;
  var $14=(($13)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 << 7;
  var $18=$10 | $17;
  var $19=$18 & 255;
  $res=$19;
  var $20=$res;
  var $21=((__ZL3SZP+$20)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$c;
  var $25=$23 | $24;
  var $26=(($25) & 255);
  var $27=$1;
  var $28=(($27+12)|0);
  var $29=$28;
  var $30=(($29)|0);
  HEAP8[($30)]=$26;
  var $31=$res;
  var $32=(($31) & 255);
  ;
  return $32;
}


function __ZL2RLP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 128;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 << 1;
  var $11=$1;
  var $12=(($11+12)|0);
  var $13=$12;
  var $14=(($13)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 & 1;
  var $18=$10 | $17;
  var $19=$18 & 255;
  $res=$19;
  var $20=$res;
  var $21=((__ZL3SZP+$20)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$c;
  var $25=$23 | $24;
  var $26=(($25) & 255);
  var $27=$1;
  var $28=(($27+12)|0);
  var $29=$28;
  var $30=(($29)|0);
  HEAP8[($30)]=$26;
  var $31=$res;
  var $32=(($31) & 255);
  ;
  return $32;
}


function __ZL3RRCP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 1;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 >>> 1;
  var $11=$res;
  var $12=$11 << 7;
  var $13=$10 | $12;
  var $14=$13 & 255;
  $res=$14;
  var $15=$res;
  var $16=((__ZL3SZP+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$c;
  var $20=$18 | $19;
  var $21=(($20) & 255);
  var $22=$1;
  var $23=(($22+12)|0);
  var $24=$23;
  var $25=(($24)|0);
  HEAP8[($25)]=$21;
  var $26=$res;
  var $27=(($26) & 255);
  ;
  return $27;
}


function __ZL3RLCP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  var $c;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  $res=$4;
  var $5=$res;
  var $6=$5 & 128;
  var $7=(($6)|0)!=0;
  var $8=$7 ? 1 : 0;
  $c=$8;
  var $9=$res;
  var $10=$9 << 1;
  var $11=$res;
  var $12=$11 >>> 7;
  var $13=$10 | $12;
  var $14=$13 & 255;
  $res=$14;
  var $15=$res;
  var $16=((__ZL3SZP+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$c;
  var $20=$18 | $19;
  var $21=(($20) & 255);
  var $22=$1;
  var $23=(($22+12)|0);
  var $24=$23;
  var $25=(($24)|0);
  HEAP8[($25)]=$21;
  var $26=$res;
  var $27=(($26) & 255);
  ;
  return $27;
}


function __ZL3DECP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  var $5=(($4-1)|0);
  var $6=(($5) & 255);
  $res=$6;
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 & 1;
  var $14=$res;
  var $15=(($14)&255);
  var $16=((__ZL8SZHV_dec+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$13 | $18;
  var $20=(($19) & 255);
  var $21=$1;
  var $22=(($21+12)|0);
  var $23=$22;
  var $24=(($23)|0);
  HEAP8[($24)]=$20;
  var $25=$res;
  ;
  return $25;
}


function __ZL3INCP10_z80_stateh($z80, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $res;
  $1=$z80;
  $2=$value;
  var $3=$2;
  var $4=(($3)&255);
  var $5=(($4+1)|0);
  var $6=(($5) & 255);
  $res=$6;
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 & 1;
  var $14=$res;
  var $15=(($14)&255);
  var $16=((__ZL8SZHV_inc+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$13 | $18;
  var $20=(($19) & 255);
  var $21=$1;
  var $22=(($21+12)|0);
  var $23=$22;
  var $24=(($23)|0);
  HEAP8[($24)]=$20;
  var $25=$res;
  ;
  return $25;
}


function __ZL7xycb_f3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(6, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_f7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(6, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_f9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+16)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_faP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_fbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+20)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+20)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_fcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_fdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+24)|0);
  var $16=$15;
  var $17=(($16)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+24)|0);
  var $30=$29;
  var $31=(($30)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL7xycb_feP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+84)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+28)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$1;
  var $20=(($19+72)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=FUNCTION_TABLE[$18]($14, $21);
  var $23=__ZL3SEThh(7, $22);
  FUNCTION_TABLE[$8]($4, $11, $23);
  ;
  return;
}


function __ZL7xycb_ffP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+72)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=FUNCTION_TABLE[$8]($4, $11);
  var $13=__ZL3SEThh(7, $12);
  var $14=$1;
  var $15=(($14+12)|0);
  var $16=$15;
  var $17=(($16+1)|0);
  HEAP8[($17)]=$13;
  var $18=$1;
  var $19=(($18+84)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$20;
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22+80)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$1;
  var $26=(($25+72)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$1;
  var $29=(($28+12)|0);
  var $30=$29;
  var $31=(($30+1)|0);
  var $32=HEAP8[($31)];
  FUNCTION_TABLE[$24]($20, $27, $32);
  ;
  return;
}


function __ZL5ARG16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  var $pc;
  $1=$z80;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  $pc=$5;
  var $6=$1;
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=(($8)|0);
  var $10=HEAPU16[(($9)>>1)];
  var $11=(($10)&65535);
  var $12=(($11+2)|0);
  var $13=(($12) & 65535);
  HEAP16[(($9)>>1)]=$13;
  var $14=$1;
  var $15=(($14+88)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=$pc;
  var $18=__ZN16direct_read_data13read_raw_byteEjj($16, $17, 0);
  var $19=(($18)&255);
  var $20=$1;
  var $21=(($20+88)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$pc;
  var $24=(($23+1)|0);
  var $25=$24 & 65535;
  var $26=__ZN16direct_read_data13read_raw_byteEjj($22, $25, 0);
  var $27=(($26)&255);
  var $28=$27 << 8;
  var $29=$19 | $28;
  ;
  return $29;
}


function __ZL5ed_00P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_01P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_02P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_03P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_04P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_05P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_06P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_07P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_08P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_09P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_0aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_0bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_42P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+16)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6-$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11-$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+16)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$44 | 2;
      var $46=$res;
      var $47=$46 >>> 16;
      var $48=$47 & 1;
      var $49=$45 | $48;
      var $50=$res;
      var $51=$50 >>> 8;
      var $52=$51 & 168;
      var $53=$49 | $52;
      var $54=$res;
      var $55=$54 & 65535;
      var $56=(($55)|0)!=0;
      var $57=$56 ? 0 : 64;
      var $58=$53 | $57;
      var $59=$1;
      var $60=(($59+16)|0);
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=$1;
      var $64=(($63+24)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=$62 ^ $66;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$58 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_42P10_z80_state["X"]=1;

function __ZL5ed_44P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_44P10_z80_state["X"]=1;

function __ZL5ed_46P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=0;
  ;
  return;
}


function __ZL5ed_47P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      var $8=$1;
      var $9=(($8+62)|0);
      HEAP8[($9)]=$7;
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_4aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+16)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11+$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+16)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$res;
      var $46=$45 >>> 16;
      var $47=$46 & 1;
      var $48=$44 | $47;
      var $49=$res;
      var $50=$49 >>> 8;
      var $51=$50 & 168;
      var $52=$48 | $51;
      var $53=$res;
      var $54=$53 & 65535;
      var $55=(($54)|0)!=0;
      var $56=$55 ? 0 : 64;
      var $57=$52 | $56;
      var $58=$1;
      var $59=(($58+16)|0);
      var $60=$59;
      var $61=HEAP32[(($60)>>2)];
      var $62=$1;
      var $63=(($62+24)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      var $66=$61 ^ $65;
      var $67=$66 ^ 32768;
      var $68=$1;
      var $69=(($68+16)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$57 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_4aP10_z80_state["X"]=1;

function __ZL5ed_4cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_4cP10_z80_state["X"]=1;

function __ZL5ed_0cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_0dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_0eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_0fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_10P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_11P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_12P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_13P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_14P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_15P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_17P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_18P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_19P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_1aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_1bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_1cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_1dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_1eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_1fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_20P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_21P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_22P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_23P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_24P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_25P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_26P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_27P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_28P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_29P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_2aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_2bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_2cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_2dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_2eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_2fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_30P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_31P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_32P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_33P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_34P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_35P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_36P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_37P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_38P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_39P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_3aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_3bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_3cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_3dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_3eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_3fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_40P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+16)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+16)|0);
  var $29=$28;
  var $30=(($29+1)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5ed_41P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5ed_43P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+16)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_45P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($6, $10, $12);
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=(($15)|0);
      var $17=HEAPU16[(($16)>>1)];
      var $18=(($17)&65535);
      var $19=(($18+2)|0);
      var $20=(($19) & 65535);
      HEAP16[(($16)>>1)]=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAP16[(($25)>>1)];
      var $27=$1;
      var $28=(($27+36)|0);
      var $29=$28;
      var $30=(($29)|0);
      HEAP16[(($30)>>1)]=$26;
      var $31=$1;
      var $32=(($31+59)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+58)|0);
      HEAP8[($35)]=$33;
      __label__ = 6; break;
    case 6: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_48P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+16)|0);
  var $18=$17;
  var $19=(($18)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+16)|0);
  var $29=$28;
  var $30=(($29)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5ed_49P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=$16;
  var $18=(($17)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5ed_4bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+16)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_4eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=0;
  ;
  return;
}


function __ZL5ed_4fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      var $8=$1;
      var $9=(($8+56)|0);
      HEAP8[($9)]=$7;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 128;
      var $17=(($16) & 255);
      var $18=$1;
      var $19=(($18+57)|0);
      HEAP8[($19)]=$17;
      __label__ = 2; break;
    case 2: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_52P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6-$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11-$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+20)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$44 | 2;
      var $46=$res;
      var $47=$46 >>> 16;
      var $48=$47 & 1;
      var $49=$45 | $48;
      var $50=$res;
      var $51=$50 >>> 8;
      var $52=$51 & 168;
      var $53=$49 | $52;
      var $54=$res;
      var $55=$54 & 65535;
      var $56=(($55)|0)!=0;
      var $57=$56 ? 0 : 64;
      var $58=$53 | $57;
      var $59=$1;
      var $60=(($59+20)|0);
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=$1;
      var $64=(($63+24)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=$62 ^ $66;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$58 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_52P10_z80_state["X"]=1;

function __ZL5ed_54P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_54P10_z80_state["X"]=1;

function __ZL5ed_56P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=1;
  ;
  return;
}


function __ZL5ed_57P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+62)|0);
      var $5=HEAP8[($4)];
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=$7;
      var $9=(($8+1)|0);
      HEAP8[($9)]=$5;
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 1;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL2SZ+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$16 | $25;
      var $27=$1;
      var $28=(($27+59)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$30 << 2;
      var $32=$26 | $31;
      var $33=(($32) & 255);
      var $34=$1;
      var $35=(($34+12)|0);
      var $36=$35;
      var $37=(($36)|0);
      HEAP8[($37)]=$33;
      var $38=$1;
      var $39=(($38+71)|0);
      HEAP8[($39)]=1;
      __label__ = 2; break;
    case 2: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_5aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11+$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+20)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$res;
      var $46=$45 >>> 16;
      var $47=$46 & 1;
      var $48=$44 | $47;
      var $49=$res;
      var $50=$49 >>> 8;
      var $51=$50 & 168;
      var $52=$48 | $51;
      var $53=$res;
      var $54=$53 & 65535;
      var $55=(($54)|0)!=0;
      var $56=$55 ? 0 : 64;
      var $57=$52 | $56;
      var $58=$1;
      var $59=(($58+20)|0);
      var $60=$59;
      var $61=HEAP32[(($60)>>2)];
      var $62=$1;
      var $63=(($62+24)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      var $66=$61 ^ $65;
      var $67=$66 ^ 32768;
      var $68=$1;
      var $69=(($68+20)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$57 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_5aP10_z80_state["X"]=1;

function __ZL5ed_5cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_5cP10_z80_state["X"]=1;

function __ZL5ed_5eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=2;
  ;
  return;
}


function __ZL5ed_5fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+56)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$6 & 127;
      var $8=$1;
      var $9=(($8+57)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=$7 | $11;
      var $13=(($12) & 255);
      var $14=$1;
      var $15=(($14+12)|0);
      var $16=$15;
      var $17=(($16+1)|0);
      HEAP8[($17)]=$13;
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 & 1;
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27+1)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=((__ZL2SZ+$30)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$24 | $33;
      var $35=$1;
      var $36=(($35+59)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$38 << 2;
      var $40=$34 | $39;
      var $41=(($40) & 255);
      var $42=$1;
      var $43=(($42+12)|0);
      var $44=$43;
      var $45=(($44)|0);
      HEAP8[($45)]=$41;
      var $46=$1;
      var $47=(($46+71)|0);
      HEAP8[($47)]=1;
      __label__ = 2; break;
    case 2: // $48
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_5fP10_z80_state["X"]=1;

function __ZL5ed_4dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=$1;
      var $10=(($9+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $10);
      var $11=$1;
      var $12=(($11+8)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=(($16+2)|0);
      var $18=(($17) & 65535);
      HEAP16[(($14)>>1)]=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAP16[(($23)>>1)];
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+59)|0);
      var $31=HEAP8[($30)];
      var $32=$1;
      var $33=(($32+58)|0);
      HEAP8[($33)]=$31;
      var $34=$1;
      var $35=(($34+100)|0);
      __ZN15z80_daisy_chain16call_reti_deviceEv($35);
      __label__ = 4; break;
    case 4: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_50P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+20)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+20)|0);
  var $29=$28;
  var $30=(($29+1)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5ed_51P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5ed_53P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+20)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_55P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($6, $10, $12);
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=(($15)|0);
      var $17=HEAPU16[(($16)>>1)];
      var $18=(($17)&65535);
      var $19=(($18+2)|0);
      var $20=(($19) & 65535);
      HEAP16[(($16)>>1)]=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAP16[(($25)>>1)];
      var $27=$1;
      var $28=(($27+36)|0);
      var $29=$28;
      var $30=(($29)|0);
      HEAP16[(($30)>>1)]=$26;
      var $31=$1;
      var $32=(($31+59)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+58)|0);
      HEAP8[($35)]=$33;
      __label__ = 6; break;
    case 6: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_58P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+20)|0);
  var $18=$17;
  var $19=(($18)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+20)|0);
  var $29=$28;
  var $30=(($29)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5ed_59P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+20)|0);
  var $17=$16;
  var $18=(($17)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5ed_5bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+20)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_5dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=$1;
      var $10=(($9+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $10);
      var $11=$1;
      var $12=(($11+8)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=(($16+2)|0);
      var $18=(($17) & 65535);
      HEAP16[(($14)>>1)]=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAP16[(($23)>>1)];
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+59)|0);
      var $31=HEAP8[($30)];
      var $32=$1;
      var $33=(($32+58)|0);
      HEAP8[($33)]=$31;
      var $34=$1;
      var $35=(($34+100)|0);
      __ZN15z80_daisy_chain16call_reti_deviceEv($35);
      __label__ = 4; break;
    case 4: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_60P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+24)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+24)|0);
  var $29=$28;
  var $30=(($29+1)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5ed_61P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5ed_62P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+24)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6-$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11-$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+24)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$44 | 2;
      var $46=$res;
      var $47=$46 >>> 16;
      var $48=$47 & 1;
      var $49=$45 | $48;
      var $50=$res;
      var $51=$50 >>> 8;
      var $52=$51 & 168;
      var $53=$49 | $52;
      var $54=$res;
      var $55=$54 & 65535;
      var $56=(($55)|0)!=0;
      var $57=$56 ? 0 : 64;
      var $58=$53 | $57;
      var $59=$1;
      var $60=(($59+24)|0);
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=$1;
      var $64=(($63+24)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=$62 ^ $66;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$58 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_62P10_z80_state["X"]=1;

function __ZL5ed_64P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_64P10_z80_state["X"]=1;

function __ZL5ed_66P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=0;
  ;
  return;
}


function __ZL5ed_6aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+24)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11+$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+24)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$res;
      var $46=$45 >>> 16;
      var $47=$46 & 1;
      var $48=$44 | $47;
      var $49=$res;
      var $50=$49 >>> 8;
      var $51=$50 & 168;
      var $52=$48 | $51;
      var $53=$res;
      var $54=$53 & 65535;
      var $55=(($54)|0)!=0;
      var $56=$55 ? 0 : 64;
      var $57=$52 | $56;
      var $58=$1;
      var $59=(($58+24)|0);
      var $60=$59;
      var $61=HEAP32[(($60)>>2)];
      var $62=$1;
      var $63=(($62+24)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      var $66=$61 ^ $65;
      var $67=$66 ^ 32768;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$57 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_6aP10_z80_state["X"]=1;

function __ZL5ed_6cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_6cP10_z80_state["X"]=1;

function __ZL5ed_6eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=0;
  ;
  return;
}


function __ZL5ed_72P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6-$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11-$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+8)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$44 | 2;
      var $46=$res;
      var $47=$46 >>> 16;
      var $48=$47 & 1;
      var $49=$45 | $48;
      var $50=$res;
      var $51=$50 >>> 8;
      var $52=$51 & 168;
      var $53=$49 | $52;
      var $54=$res;
      var $55=$54 & 65535;
      var $56=(($55)|0)!=0;
      var $57=$56 ? 0 : 64;
      var $58=$53 | $57;
      var $59=$1;
      var $60=(($59+8)|0);
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=$1;
      var $64=(($63+24)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=$62 ^ $66;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$58 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_72P10_z80_state["X"]=1;

function __ZL5ed_63P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+24)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_65P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($6, $10, $12);
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=(($15)|0);
      var $17=HEAPU16[(($16)>>1)];
      var $18=(($17)&65535);
      var $19=(($18+2)|0);
      var $20=(($19) & 65535);
      HEAP16[(($16)>>1)]=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAP16[(($25)>>1)];
      var $27=$1;
      var $28=(($27+36)|0);
      var $29=$28;
      var $30=(($29)|0);
      HEAP16[(($30)>>1)]=$26;
      var $31=$1;
      var $32=(($31+59)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+58)|0);
      HEAP8[($35)]=$33;
      __label__ = 6; break;
    case 6: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_67P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $n;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $n=$16;
      var $17=$1;
      var $18=(($17+24)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+1)|0);
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+84)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+80)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+24)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAPU16[(($39)>>1)];
      var $41=(($40)&65535);
      var $42=$n;
      var $43=(($42)&255);
      var $44=$43 >> 4;
      var $45=$1;
      var $46=(($45+12)|0);
      var $47=$46;
      var $48=(($47+1)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 << 4;
      var $52=$44 | $51;
      var $53=(($52) & 255);
      FUNCTION_TABLE[$35]($31, $41, $53);
      var $54=$1;
      var $55=(($54+12)|0);
      var $56=$55;
      var $57=(($56+1)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=$59 & 240;
      var $61=$n;
      var $62=(($61)&255);
      var $63=$62 & 15;
      var $64=$60 | $63;
      var $65=(($64) & 255);
      var $66=$1;
      var $67=(($66+12)|0);
      var $68=$67;
      var $69=(($68+1)|0);
      HEAP8[($69)]=$65;
      var $70=$1;
      var $71=(($70+12)|0);
      var $72=$71;
      var $73=(($72)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=$75 & 1;
      var $77=$1;
      var $78=(($77+12)|0);
      var $79=$78;
      var $80=(($79+1)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=((__ZL3SZP+$82)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$76 | $85;
      var $87=(($86) & 255);
      var $88=$1;
      var $89=(($88+12)|0);
      var $90=$89;
      var $91=(($90)|0);
      HEAP8[($91)]=$87;
      __label__ = 2; break;
    case 2: // $92
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_67P10_z80_state["X"]=1;

function __ZL5ed_68P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+24)|0);
  var $18=$17;
  var $19=(($18)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+24)|0);
  var $29=$28;
  var $30=(($29)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  ;
  return;
}


function __ZL5ed_69P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+24)|0);
  var $17=$16;
  var $18=(($17)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  ;
  return;
}


function __ZL5ed_6bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+24)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_6dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=$1;
      var $10=(($9+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $10);
      var $11=$1;
      var $12=(($11+8)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=(($16+2)|0);
      var $18=(($17) & 65535);
      HEAP16[(($14)>>1)]=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAP16[(($23)>>1)];
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+59)|0);
      var $31=HEAP8[($30)];
      var $32=$1;
      var $33=(($32+58)|0);
      HEAP8[($33)]=$31;
      var $34=$1;
      var $35=(($34+100)|0);
      __ZN15z80_daisy_chain16call_reti_deviceEv($35);
      __label__ = 4; break;
    case 4: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_6fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $n;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $n=$16;
      var $17=$1;
      var $18=(($17+24)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+1)|0);
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+84)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=$31;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+80)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+24)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAPU16[(($39)>>1)];
      var $41=(($40)&65535);
      var $42=$n;
      var $43=(($42)&255);
      var $44=$43 << 4;
      var $45=$1;
      var $46=(($45+12)|0);
      var $47=$46;
      var $48=(($47+1)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 & 15;
      var $52=$44 | $51;
      var $53=(($52) & 255);
      FUNCTION_TABLE[$35]($31, $41, $53);
      var $54=$1;
      var $55=(($54+12)|0);
      var $56=$55;
      var $57=(($56+1)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=$59 & 240;
      var $61=$n;
      var $62=(($61)&255);
      var $63=$62 >> 4;
      var $64=$60 | $63;
      var $65=(($64) & 255);
      var $66=$1;
      var $67=(($66+12)|0);
      var $68=$67;
      var $69=(($68+1)|0);
      HEAP8[($69)]=$65;
      var $70=$1;
      var $71=(($70+12)|0);
      var $72=$71;
      var $73=(($72)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=$75 & 1;
      var $77=$1;
      var $78=(($77+12)|0);
      var $79=$78;
      var $80=(($79+1)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=((__ZL3SZP+$82)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$76 | $85;
      var $87=(($86) & 255);
      var $88=$1;
      var $89=(($88+12)|0);
      var $90=$89;
      var $91=(($90)|0);
      HEAP8[($91)]=$87;
      __label__ = 2; break;
    case 2: // $92
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_6fP10_z80_state["X"]=1;

function __ZL5ed_70P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  var $res;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  $res=$15;
  var $16=$1;
  var $17=(($16+12)|0);
  var $18=$17;
  var $19=(($18)|0);
  var $20=HEAPU8[($19)];
  var $21=(($20)&255);
  var $22=$21 & 1;
  var $23=$res;
  var $24=(($23)&255);
  var $25=((__ZL3SZP+$24)|0);
  var $26=HEAPU8[($25)];
  var $27=(($26)&255);
  var $28=$22 | $27;
  var $29=(($28) & 255);
  var $30=$1;
  var $31=(($30+12)|0);
  var $32=$31;
  var $33=(($32)|0);
  HEAP8[($33)]=$29;
  ;
  return;
}


function __ZL5ed_71P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  FUNCTION_TABLE[$8]($4, $14, 0);
  ;
  return;
}


function __ZL5ed_73P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+8)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_74P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_74P10_z80_state["X"]=1;

function __ZL5ed_76P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=1;
  ;
  return;
}


function __ZL5ed_7aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      var $12=$1;
      var $13=(($12+12)|0);
      var $14=$13;
      var $15=(($14)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$17 & 1;
      var $19=(($11+$18)|0);
      $res=$19;
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=(($25+1)|0);
      var $27=(($26) & 65535);
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP16[(($31)>>1)]=$27;
      var $32=$1;
      var $33=(($32+24)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$res;
      var $37=$35 ^ $36;
      var $38=$1;
      var $39=(($38+8)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=$37 ^ $41;
      var $43=$42 >>> 8;
      var $44=$43 & 16;
      var $45=$res;
      var $46=$45 >>> 16;
      var $47=$46 & 1;
      var $48=$44 | $47;
      var $49=$res;
      var $50=$49 >>> 8;
      var $51=$50 & 168;
      var $52=$48 | $51;
      var $53=$res;
      var $54=$53 & 65535;
      var $55=(($54)|0)!=0;
      var $56=$55 ? 0 : 64;
      var $57=$52 | $56;
      var $58=$1;
      var $59=(($58+8)|0);
      var $60=$59;
      var $61=HEAP32[(($60)>>2)];
      var $62=$1;
      var $63=(($62+24)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      var $66=$61 ^ $65;
      var $67=$66 ^ 32768;
      var $68=$1;
      var $69=(($68+8)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$res;
      var $73=$71 ^ $72;
      var $74=$67 & $73;
      var $75=$74 & 32768;
      var $76=$75 >>> 13;
      var $77=$57 | $76;
      var $78=(($77) & 255);
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      HEAP8[($82)]=$78;
      var $83=$res;
      var $84=(($83) & 65535);
      var $85=$1;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=(($87)|0);
      HEAP16[(($88)>>1)]=$84;
      __label__ = 2; break;
    case 2: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_7aP10_z80_state["X"]=1;

function __ZL5ed_7cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $value;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      $value=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=(($10+1)|0);
      HEAP8[($11)]=0;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 65280;
      $ah=$17;
      var $18=$ah;
      var $19=$18 >>> 8;
      var $20=$value;
      var $21=(($20)&255);
      var $22=(($19-$21)|0);
      var $23=(($22) & 255);
      var $24=(($23)&255);
      $res=$24;
      var $25=$ah;
      var $26=$res;
      var $27=$25 | $26;
      var $28=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $29=(($28+$27)|0);
      var $30=HEAP8[($29)];
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP8[($34)]=$30;
      var $35=$res;
      var $36=(($35) & 255);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      __label__ = 3; break;
    case 3: // $41
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_7cP10_z80_state["X"]=1;

function __ZL5ed_7eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+61)|0);
  HEAP8[($3)]=2;
  ;
  return;
}


function __ZL5ed_75P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($6, $10, $12);
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=$14;
      var $16=(($15)|0);
      var $17=HEAPU16[(($16)>>1)];
      var $18=(($17)&65535);
      var $19=(($18+2)|0);
      var $20=(($19) & 65535);
      HEAP16[(($16)>>1)]=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAP16[(($25)>>1)];
      var $27=$1;
      var $28=(($27+36)|0);
      var $29=$28;
      var $30=(($29)|0);
      HEAP16[(($30)>>1)]=$26;
      var $31=$1;
      var $32=(($31+59)|0);
      var $33=HEAP8[($32)];
      var $34=$1;
      var $35=(($34+58)|0);
      HEAP8[($35)]=$33;
      __label__ = 6; break;
    case 6: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_77P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_78P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+28)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=FUNCTION_TABLE[$8]($4, $14);
  var $16=$1;
  var $17=(($16+12)|0);
  var $18=$17;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$15;
  var $20=$1;
  var $21=(($20+12)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$25 & 1;
  var $27=$1;
  var $28=(($27+12)|0);
  var $29=$28;
  var $30=(($29+1)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=((__ZL3SZP+$32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$26 | $35;
  var $37=(($36) & 255);
  var $38=$1;
  var $39=(($38+12)|0);
  var $40=$39;
  var $41=(($40)|0);
  HEAP8[($41)]=$37;
  var $42=$1;
  var $43=(($42+16)|0);
  var $44=$43;
  var $45=(($44)|0);
  var $46=HEAPU16[(($45)>>1)];
  var $47=(($46)&65535);
  var $48=(($47+1)|0);
  var $49=(($48) & 65535);
  var $50=$1;
  var $51=(($50+36)|0);
  var $52=$51;
  var $53=(($52)|0);
  HEAP16[(($53)>>1)]=$49;
  ;
  return;
}
__ZL5ed_78P10_z80_state["X"]=1;

function __ZL5ed_79P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+12)|0);
  var $17=$16;
  var $18=(($17+1)|0);
  var $19=HEAP8[($18)];
  FUNCTION_TABLE[$8]($4, $14, $19);
  var $20=$1;
  var $21=(($20+16)|0);
  var $22=$21;
  var $23=(($22)|0);
  var $24=HEAPU16[(($23)>>1)];
  var $25=(($24)&65535);
  var $26=(($25+1)|0);
  var $27=(($26) & 65535);
  var $28=$1;
  var $29=(($28+36)|0);
  var $30=$29;
  var $31=(($30)|0);
  HEAP16[(($31)>>1)]=$27;
  ;
  return;
}


function __ZL5ed_7bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+8)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5ed_7dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=$1;
      var $10=(($9+4)|0);
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $10);
      var $11=$1;
      var $12=(($11+8)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=(($16+2)|0);
      var $18=(($17) & 65535);
      HEAP16[(($14)>>1)]=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAP16[(($23)>>1)];
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+59)|0);
      var $31=HEAP8[($30)];
      var $32=$1;
      var $33=(($32+58)|0);
      HEAP8[($33)]=$31;
      var $34=$1;
      var $35=(($34+100)|0);
      __ZN15z80_daisy_chain16call_reti_deviceEv($35);
      __label__ = 4; break;
    case 4: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ed_7fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_80P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_81P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_82P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_83P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_84P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_85P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_86P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_87P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_88P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_89P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_8aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_8bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_8cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_8dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_8eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_8fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_90P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_91P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_92P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_93P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_94P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_95P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_96P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_97P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_98P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_99P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_9aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_9bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_9cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_9dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_9eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_9fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_a0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $io=$16;
      var $17=$1;
      var $18=(($17+84)|0);
      var $19=HEAPU32[(($18)>>2)];
      var $20=$19;
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+80)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=$io;
      FUNCTION_TABLE[$23]($19, $29, $30);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$36 & 193;
      var $38=(($37) & 255);
      HEAP8[($34)]=$38;
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$io;
      var $46=(($45)&255);
      var $47=(($44+$46)|0);
      var $48=$47 & 2;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $50
      var $51=$1;
      var $52=(($51+12)|0);
      var $53=$52;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 | 32;
      var $58=(($57) & 255);
      HEAP8[($54)]=$58;
      __label__ = 3; break;
    case 3: // $59
      var $60=$1;
      var $61=(($60+12)|0);
      var $62=$61;
      var $63=(($62+1)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$io;
      var $67=(($66)&255);
      var $68=(($65+$67)|0);
      var $69=$68 & 8;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $71
      var $72=$1;
      var $73=(($72+12)|0);
      var $74=$73;
      var $75=(($74)|0);
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$77 | 8;
      var $79=(($78) & 255);
      HEAP8[($75)]=$79;
      __label__ = 5; break;
    case 5: // $80
      var $81=$1;
      var $82=(($81+24)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=HEAP16[(($84)>>1)];
      var $86=(($85+1)&65535);
      HEAP16[(($84)>>1)]=$86;
      var $87=$1;
      var $88=(($87+20)|0);
      var $89=$88;
      var $90=(($89)|0);
      var $91=HEAP16[(($90)>>1)];
      var $92=(($91+1)&65535);
      HEAP16[(($90)>>1)]=$92;
      var $93=$1;
      var $94=(($93+16)|0);
      var $95=$94;
      var $96=(($95)|0);
      var $97=HEAP16[(($96)>>1)];
      var $98=(($97-1)&65535);
      HEAP16[(($96)>>1)]=$98;
      var $99=$1;
      var $100=(($99+16)|0);
      var $101=$100;
      var $102=(($101)|0);
      var $103=HEAP16[(($102)>>1)];
      var $104=(($103 << 16) >> 16)!=0;
      if ($104) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $105
      var $106=$1;
      var $107=(($106+12)|0);
      var $108=$107;
      var $109=(($108)|0);
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$111 | 4;
      var $113=(($112) & 255);
      HEAP8[($109)]=$113;
      __label__ = 7; break;
    case 7: // $114
      __label__ = 8; break;
    case 8: // $115
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_a0P10_z80_state["X"]=1;

function __ZL5ed_a1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $val=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$val;
      var $24=(($23)&255);
      var $25=(($22-$24)|0);
      var $26=(($25) & 255);
      $res=$26;
      var $27=$1;
      var $28=(($27+36)|0);
      var $29=$28;
      var $30=(($29)|0);
      var $31=HEAP16[(($30)>>1)];
      var $32=(($31+1)&65535);
      HEAP16[(($30)>>1)]=$32;
      var $33=$1;
      var $34=(($33+24)|0);
      var $35=$34;
      var $36=(($35)|0);
      var $37=HEAP16[(($36)>>1)];
      var $38=(($37+1)&65535);
      HEAP16[(($36)>>1)]=$38;
      var $39=$1;
      var $40=(($39+16)|0);
      var $41=$40;
      var $42=(($41)|0);
      var $43=HEAP16[(($42)>>1)];
      var $44=(($43-1)&65535);
      HEAP16[(($42)>>1)]=$44;
      var $45=$1;
      var $46=(($45+12)|0);
      var $47=$46;
      var $48=(($47)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 & 1;
      var $52=$res;
      var $53=(($52)&255);
      var $54=((__ZL2SZ+$53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & -41;
      var $58=$51 | $57;
      var $59=$1;
      var $60=(($59+12)|0);
      var $61=$60;
      var $62=(($61+1)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=$val;
      var $66=(($65)&255);
      var $67=$64 ^ $66;
      var $68=$res;
      var $69=(($68)&255);
      var $70=$67 ^ $69;
      var $71=$70 & 16;
      var $72=$58 | $71;
      var $73=$72 | 2;
      var $74=(($73) & 255);
      var $75=$1;
      var $76=(($75+12)|0);
      var $77=$76;
      var $78=(($77)|0);
      HEAP8[($78)]=$74;
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$84 & 16;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $87
      var $88=$res;
      var $89=(($88)&255);
      var $90=(($89-1)|0);
      var $91=(($90) & 255);
      $res=$91;
      __label__ = 3; break;
    case 3: // $92
      var $93=$res;
      var $94=(($93)&255);
      var $95=$94 & 2;
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $97
      var $98=$1;
      var $99=(($98+12)|0);
      var $100=$99;
      var $101=(($100)|0);
      var $102=HEAPU8[($101)];
      var $103=(($102)&255);
      var $104=$103 | 32;
      var $105=(($104) & 255);
      HEAP8[($101)]=$105;
      __label__ = 5; break;
    case 5: // $106
      var $107=$res;
      var $108=(($107)&255);
      var $109=$108 & 8;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $111
      var $112=$1;
      var $113=(($112+12)|0);
      var $114=$113;
      var $115=(($114)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$117 | 8;
      var $119=(($118) & 255);
      HEAP8[($115)]=$119;
      __label__ = 7; break;
    case 7: // $120
      var $121=$1;
      var $122=(($121+16)|0);
      var $123=$122;
      var $124=(($123)|0);
      var $125=HEAP16[(($124)>>1)];
      var $126=(($125 << 16) >> 16)!=0;
      if ($126) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $127
      var $128=$1;
      var $129=(($128+12)|0);
      var $130=$129;
      var $131=(($130)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=$133 | 4;
      var $135=(($134) & 255);
      HEAP8[($131)]=$135;
      __label__ = 9; break;
    case 9: // $136
      __label__ = 10; break;
    case 10: // $137
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_a1P10_z80_state["X"]=1;

function __ZL5ed_a2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+92)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $io=$16;
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22+1)|0);
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+16)|0);
      var $31=$30;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=(($33-1)&255);
      HEAP8[($32)]=$34;
      var $35=$1;
      var $36=(($35+84)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=$37;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+80)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+24)|0);
      var $44=$43;
      var $45=(($44)|0);
      var $46=HEAPU16[(($45)>>1)];
      var $47=(($46)&65535);
      var $48=$io;
      FUNCTION_TABLE[$41]($37, $47, $48);
      var $49=$1;
      var $50=(($49+24)|0);
      var $51=$50;
      var $52=(($51)|0);
      var $53=HEAP16[(($52)>>1)];
      var $54=(($53+1)&65535);
      HEAP16[(($52)>>1)]=$54;
      var $55=$1;
      var $56=(($55+16)|0);
      var $57=$56;
      var $58=(($57+1)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=((__ZL2SZ+$60)|0);
      var $62=HEAP8[($61)];
      var $63=$1;
      var $64=(($63+12)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP8[($66)]=$62;
      var $67=$1;
      var $68=(($67+16)|0);
      var $69=$68;
      var $70=(($69)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=(($72+1)|0);
      var $74=$73 & 255;
      var $75=$io;
      var $76=(($75)&255);
      var $77=(($74+$76)|0);
      $t=$77;
      var $78=$io;
      var $79=(($78)&255);
      var $80=$79 & 128;
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $82
      var $83=$1;
      var $84=(($83+12)|0);
      var $85=$84;
      var $86=(($85)|0);
      var $87=HEAPU8[($86)];
      var $88=(($87)&255);
      var $89=$88 | 2;
      var $90=(($89) & 255);
      HEAP8[($86)]=$90;
      __label__ = 3; break;
    case 3: // $91
      var $92=$t;
      var $93=$92 & 256;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $95
      var $96=$1;
      var $97=(($96+12)|0);
      var $98=$97;
      var $99=(($98)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=$101 | 17;
      var $103=(($102) & 255);
      HEAP8[($99)]=$103;
      __label__ = 5; break;
    case 5: // $104
      var $105=$t;
      var $106=$105 & 7;
      var $107=(($106) & 255);
      var $108=(($107)&255);
      var $109=$1;
      var $110=(($109+16)|0);
      var $111=$110;
      var $112=(($111+1)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=$108 ^ $114;
      var $116=((__ZL3SZP+$115)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$118 & 4;
      var $120=$1;
      var $121=(($120+12)|0);
      var $122=$121;
      var $123=(($122)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $126=$125 | $119;
      var $127=(($126) & 255);
      HEAP8[($123)]=$127;
      __label__ = 6; break;
    case 6: // $128
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_a2P10_z80_state["X"]=1;

function __ZL5ed_a3P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $io=$16;
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAP8[($20)];
      var $22=(($21-1)&255);
      HEAP8[($20)]=$22;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU16[(($26)>>1)];
      var $28=(($27)&65535);
      var $29=(($28+1)|0);
      var $30=(($29) & 65535);
      var $31=$1;
      var $32=(($31+36)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP16[(($34)>>1)]=$30;
      var $35=$1;
      var $36=(($35+92)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=$37;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+80)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+16)|0);
      var $44=$43;
      var $45=(($44)|0);
      var $46=HEAPU16[(($45)>>1)];
      var $47=(($46)&65535);
      var $48=$io;
      FUNCTION_TABLE[$41]($37, $47, $48);
      var $49=$1;
      var $50=(($49+24)|0);
      var $51=$50;
      var $52=(($51)|0);
      var $53=HEAP16[(($52)>>1)];
      var $54=(($53+1)&65535);
      HEAP16[(($52)>>1)]=$54;
      var $55=$1;
      var $56=(($55+16)|0);
      var $57=$56;
      var $58=(($57+1)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=((__ZL2SZ+$60)|0);
      var $62=HEAP8[($61)];
      var $63=$1;
      var $64=(($63+12)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP8[($66)]=$62;
      var $67=$1;
      var $68=(($67+24)|0);
      var $69=$68;
      var $70=(($69)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=$io;
      var $74=(($73)&255);
      var $75=(($72+$74)|0);
      $t=$75;
      var $76=$io;
      var $77=(($76)&255);
      var $78=$77 & 128;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $80
      var $81=$1;
      var $82=(($81+12)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$86 | 2;
      var $88=(($87) & 255);
      HEAP8[($84)]=$88;
      __label__ = 3; break;
    case 3: // $89
      var $90=$t;
      var $91=$90 & 256;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $93
      var $94=$1;
      var $95=(($94+12)|0);
      var $96=$95;
      var $97=(($96)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$99 | 17;
      var $101=(($100) & 255);
      HEAP8[($97)]=$101;
      __label__ = 5; break;
    case 5: // $102
      var $103=$t;
      var $104=$103 & 7;
      var $105=(($104) & 255);
      var $106=(($105)&255);
      var $107=$1;
      var $108=(($107+16)|0);
      var $109=$108;
      var $110=(($109+1)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$106 ^ $112;
      var $114=((__ZL3SZP+$113)|0);
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $117=$116 & 4;
      var $118=$1;
      var $119=(($118+12)|0);
      var $120=$119;
      var $121=(($120)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=$123 | $117;
      var $125=(($124) & 255);
      HEAP8[($121)]=$125;
      __label__ = 6; break;
    case 6: // $126
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_a3P10_z80_state["X"]=1;

function __ZL5ed_a4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_a5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_a6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_a7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_a8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $io=$16;
      var $17=$1;
      var $18=(($17+84)|0);
      var $19=HEAPU32[(($18)>>2)];
      var $20=$19;
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+80)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=$io;
      FUNCTION_TABLE[$23]($19, $29, $30);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$36 & 193;
      var $38=(($37) & 255);
      HEAP8[($34)]=$38;
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$io;
      var $46=(($45)&255);
      var $47=(($44+$46)|0);
      var $48=$47 & 2;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $50
      var $51=$1;
      var $52=(($51+12)|0);
      var $53=$52;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 | 32;
      var $58=(($57) & 255);
      HEAP8[($54)]=$58;
      __label__ = 3; break;
    case 3: // $59
      var $60=$1;
      var $61=(($60+12)|0);
      var $62=$61;
      var $63=(($62+1)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$io;
      var $67=(($66)&255);
      var $68=(($65+$67)|0);
      var $69=$68 & 8;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $71
      var $72=$1;
      var $73=(($72+12)|0);
      var $74=$73;
      var $75=(($74)|0);
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$77 | 8;
      var $79=(($78) & 255);
      HEAP8[($75)]=$79;
      __label__ = 5; break;
    case 5: // $80
      var $81=$1;
      var $82=(($81+24)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=HEAP16[(($84)>>1)];
      var $86=(($85-1)&65535);
      HEAP16[(($84)>>1)]=$86;
      var $87=$1;
      var $88=(($87+20)|0);
      var $89=$88;
      var $90=(($89)|0);
      var $91=HEAP16[(($90)>>1)];
      var $92=(($91-1)&65535);
      HEAP16[(($90)>>1)]=$92;
      var $93=$1;
      var $94=(($93+16)|0);
      var $95=$94;
      var $96=(($95)|0);
      var $97=HEAP16[(($96)>>1)];
      var $98=(($97-1)&65535);
      HEAP16[(($96)>>1)]=$98;
      var $99=$1;
      var $100=(($99+16)|0);
      var $101=$100;
      var $102=(($101)|0);
      var $103=HEAP16[(($102)>>1)];
      var $104=(($103 << 16) >> 16)!=0;
      if ($104) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $105
      var $106=$1;
      var $107=(($106+12)|0);
      var $108=$107;
      var $109=(($108)|0);
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$111 | 4;
      var $113=(($112) & 255);
      HEAP8[($109)]=$113;
      __label__ = 7; break;
    case 7: // $114
      __label__ = 8; break;
    case 8: // $115
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_a8P10_z80_state["X"]=1;

function __ZL5ed_a9P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $val=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$val;
      var $24=(($23)&255);
      var $25=(($22-$24)|0);
      var $26=(($25) & 255);
      $res=$26;
      var $27=$1;
      var $28=(($27+36)|0);
      var $29=$28;
      var $30=(($29)|0);
      var $31=HEAP16[(($30)>>1)];
      var $32=(($31-1)&65535);
      HEAP16[(($30)>>1)]=$32;
      var $33=$1;
      var $34=(($33+24)|0);
      var $35=$34;
      var $36=(($35)|0);
      var $37=HEAP16[(($36)>>1)];
      var $38=(($37-1)&65535);
      HEAP16[(($36)>>1)]=$38;
      var $39=$1;
      var $40=(($39+16)|0);
      var $41=$40;
      var $42=(($41)|0);
      var $43=HEAP16[(($42)>>1)];
      var $44=(($43-1)&65535);
      HEAP16[(($42)>>1)]=$44;
      var $45=$1;
      var $46=(($45+12)|0);
      var $47=$46;
      var $48=(($47)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 & 1;
      var $52=$res;
      var $53=(($52)&255);
      var $54=((__ZL2SZ+$53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & -41;
      var $58=$51 | $57;
      var $59=$1;
      var $60=(($59+12)|0);
      var $61=$60;
      var $62=(($61+1)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=$val;
      var $66=(($65)&255);
      var $67=$64 ^ $66;
      var $68=$res;
      var $69=(($68)&255);
      var $70=$67 ^ $69;
      var $71=$70 & 16;
      var $72=$58 | $71;
      var $73=$72 | 2;
      var $74=(($73) & 255);
      var $75=$1;
      var $76=(($75+12)|0);
      var $77=$76;
      var $78=(($77)|0);
      HEAP8[($78)]=$74;
      var $79=$1;
      var $80=(($79+12)|0);
      var $81=$80;
      var $82=(($81)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$84 & 16;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $87
      var $88=$res;
      var $89=(($88)&255);
      var $90=(($89-1)|0);
      var $91=(($90) & 255);
      $res=$91;
      __label__ = 3; break;
    case 3: // $92
      var $93=$res;
      var $94=(($93)&255);
      var $95=$94 & 2;
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $97
      var $98=$1;
      var $99=(($98+12)|0);
      var $100=$99;
      var $101=(($100)|0);
      var $102=HEAPU8[($101)];
      var $103=(($102)&255);
      var $104=$103 | 32;
      var $105=(($104) & 255);
      HEAP8[($101)]=$105;
      __label__ = 5; break;
    case 5: // $106
      var $107=$res;
      var $108=(($107)&255);
      var $109=$108 & 8;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $111
      var $112=$1;
      var $113=(($112+12)|0);
      var $114=$113;
      var $115=(($114)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$117 | 8;
      var $119=(($118) & 255);
      HEAP8[($115)]=$119;
      __label__ = 7; break;
    case 7: // $120
      var $121=$1;
      var $122=(($121+16)|0);
      var $123=$122;
      var $124=(($123)|0);
      var $125=HEAP16[(($124)>>1)];
      var $126=(($125 << 16) >> 16)!=0;
      if ($126) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $127
      var $128=$1;
      var $129=(($128+12)|0);
      var $130=$129;
      var $131=(($130)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=$133 | 4;
      var $135=(($134) & 255);
      HEAP8[($131)]=$135;
      __label__ = 9; break;
    case 9: // $136
      __label__ = 10; break;
    case 10: // $137
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_a9P10_z80_state["X"]=1;

function __ZL5ed_aaP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+92)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $io=$16;
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=$18;
      var $20=(($19)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($22-1)|0);
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      var $29=$1;
      var $30=(($29+16)|0);
      var $31=$30;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=(($33-1)&255);
      HEAP8[($32)]=$34;
      var $35=$1;
      var $36=(($35+84)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=$37;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+80)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+24)|0);
      var $44=$43;
      var $45=(($44)|0);
      var $46=HEAPU16[(($45)>>1)];
      var $47=(($46)&65535);
      var $48=$io;
      FUNCTION_TABLE[$41]($37, $47, $48);
      var $49=$1;
      var $50=(($49+24)|0);
      var $51=$50;
      var $52=(($51)|0);
      var $53=HEAP16[(($52)>>1)];
      var $54=(($53-1)&65535);
      HEAP16[(($52)>>1)]=$54;
      var $55=$1;
      var $56=(($55+16)|0);
      var $57=$56;
      var $58=(($57+1)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=((__ZL2SZ+$60)|0);
      var $62=HEAP8[($61)];
      var $63=$1;
      var $64=(($63+12)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP8[($66)]=$62;
      var $67=$1;
      var $68=(($67+16)|0);
      var $69=$68;
      var $70=(($69)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=(($72-1)|0);
      var $74=$73 & 255;
      var $75=$io;
      var $76=(($75)&255);
      var $77=(($74+$76)|0);
      $t=$77;
      var $78=$io;
      var $79=(($78)&255);
      var $80=$79 & 128;
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $82
      var $83=$1;
      var $84=(($83+12)|0);
      var $85=$84;
      var $86=(($85)|0);
      var $87=HEAPU8[($86)];
      var $88=(($87)&255);
      var $89=$88 | 2;
      var $90=(($89) & 255);
      HEAP8[($86)]=$90;
      __label__ = 3; break;
    case 3: // $91
      var $92=$t;
      var $93=$92 & 256;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $95
      var $96=$1;
      var $97=(($96+12)|0);
      var $98=$97;
      var $99=(($98)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=$101 | 17;
      var $103=(($102) & 255);
      HEAP8[($99)]=$103;
      __label__ = 5; break;
    case 5: // $104
      var $105=$t;
      var $106=$105 & 7;
      var $107=(($106) & 255);
      var $108=(($107)&255);
      var $109=$1;
      var $110=(($109+16)|0);
      var $111=$110;
      var $112=(($111+1)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=$108 ^ $114;
      var $116=((__ZL3SZP+$115)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$118 & 4;
      var $120=$1;
      var $121=(($120+12)|0);
      var $122=$121;
      var $123=(($122)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $126=$125 | $119;
      var $127=(($126) & 255);
      HEAP8[($123)]=$127;
      __label__ = 6; break;
    case 6: // $128
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_aaP10_z80_state["X"]=1;

function __ZL5ed_abP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+84)|0);
      var $5=HEAPU32[(($4)>>2)];
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=FUNCTION_TABLE[$9]($5, $15);
      $io=$16;
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAP8[($20)];
      var $22=(($21-1)&255);
      HEAP8[($20)]=$22;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU16[(($26)>>1)];
      var $28=(($27)&65535);
      var $29=(($28-1)|0);
      var $30=(($29) & 65535);
      var $31=$1;
      var $32=(($31+36)|0);
      var $33=$32;
      var $34=(($33)|0);
      HEAP16[(($34)>>1)]=$30;
      var $35=$1;
      var $36=(($35+92)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=$37;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+80)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+16)|0);
      var $44=$43;
      var $45=(($44)|0);
      var $46=HEAPU16[(($45)>>1)];
      var $47=(($46)&65535);
      var $48=$io;
      FUNCTION_TABLE[$41]($37, $47, $48);
      var $49=$1;
      var $50=(($49+24)|0);
      var $51=$50;
      var $52=(($51)|0);
      var $53=HEAP16[(($52)>>1)];
      var $54=(($53-1)&65535);
      HEAP16[(($52)>>1)]=$54;
      var $55=$1;
      var $56=(($55+16)|0);
      var $57=$56;
      var $58=(($57+1)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=((__ZL2SZ+$60)|0);
      var $62=HEAP8[($61)];
      var $63=$1;
      var $64=(($63+12)|0);
      var $65=$64;
      var $66=(($65)|0);
      HEAP8[($66)]=$62;
      var $67=$1;
      var $68=(($67+24)|0);
      var $69=$68;
      var $70=(($69)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=$io;
      var $74=(($73)&255);
      var $75=(($72+$74)|0);
      $t=$75;
      var $76=$io;
      var $77=(($76)&255);
      var $78=$77 & 128;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $80
      var $81=$1;
      var $82=(($81+12)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$86 | 2;
      var $88=(($87) & 255);
      HEAP8[($84)]=$88;
      __label__ = 3; break;
    case 3: // $89
      var $90=$t;
      var $91=$90 & 256;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $93
      var $94=$1;
      var $95=(($94+12)|0);
      var $96=$95;
      var $97=(($96)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$99 | 17;
      var $101=(($100) & 255);
      HEAP8[($97)]=$101;
      __label__ = 5; break;
    case 5: // $102
      var $103=$t;
      var $104=$103 & 7;
      var $105=(($104) & 255);
      var $106=(($105)&255);
      var $107=$1;
      var $108=(($107+16)|0);
      var $109=$108;
      var $110=(($109+1)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$106 ^ $112;
      var $114=((__ZL3SZP+$113)|0);
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $117=$116 & 4;
      var $118=$1;
      var $119=(($118+12)|0);
      var $120=$119;
      var $121=(($120)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=$123 | $117;
      var $125=(($124) & 255);
      HEAP8[($121)]=$125;
      __label__ = 6; break;
    case 6: // $126
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_abP10_z80_state["X"]=1;

function __ZL5ed_acP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_adP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_aeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_afP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_b0P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+84)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $io=$17;
      var $18=$1;
      var $19=(($18+84)|0);
      var $20=HEAPU32[(($19)>>2)];
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+80)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      var $26=(($25+20)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$io;
      FUNCTION_TABLE[$24]($20, $30, $31);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 193;
      var $39=(($38) & 255);
      HEAP8[($35)]=$39;
      var $40=$1;
      var $41=(($40+12)|0);
      var $42=$41;
      var $43=(($42+1)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$io;
      var $47=(($46)&255);
      var $48=(($45+$47)|0);
      var $49=$48 & 2;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $51
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 | 32;
      var $59=(($58) & 255);
      HEAP8[($55)]=$59;
      __label__ = 4; break;
    case 4: // $60
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63+1)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=$io;
      var $68=(($67)&255);
      var $69=(($66+$68)|0);
      var $70=$69 & 8;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $72
      var $73=$1;
      var $74=(($73+12)|0);
      var $75=$74;
      var $76=(($75)|0);
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $79=$78 | 8;
      var $80=(($79) & 255);
      HEAP8[($76)]=$80;
      __label__ = 6; break;
    case 6: // $81
      var $82=$1;
      var $83=(($82+24)|0);
      var $84=$83;
      var $85=(($84)|0);
      var $86=HEAP16[(($85)>>1)];
      var $87=(($86+1)&65535);
      HEAP16[(($85)>>1)]=$87;
      var $88=$1;
      var $89=(($88+20)|0);
      var $90=$89;
      var $91=(($90)|0);
      var $92=HEAP16[(($91)>>1)];
      var $93=(($92+1)&65535);
      HEAP16[(($91)>>1)]=$93;
      var $94=$1;
      var $95=(($94+16)|0);
      var $96=$95;
      var $97=(($96)|0);
      var $98=HEAP16[(($97)>>1)];
      var $99=(($98-1)&65535);
      HEAP16[(($97)>>1)]=$99;
      var $100=$1;
      var $101=(($100+16)|0);
      var $102=$101;
      var $103=(($102)|0);
      var $104=HEAP16[(($103)>>1)];
      var $105=(($104 << 16) >> 16)!=0;
      if ($105) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $106
      var $107=$1;
      var $108=(($107+12)|0);
      var $109=$108;
      var $110=(($109)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$112 | 4;
      var $114=(($113) & 255);
      HEAP8[($110)]=$114;
      __label__ = 8; break;
    case 8: // $115
      __label__ = 9; break;
    case 9: // $116
      var $117=$1;
      var $118=(($117+16)|0);
      var $119=$118;
      var $120=(($119)|0);
      var $121=HEAPU16[(($120)>>1)];
      var $122=(($121)&65535);
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $124
      var $125=$1;
      var $126=(($125+4)|0);
      var $127=$126;
      var $128=(($127)|0);
      var $129=HEAPU16[(($128)>>1)];
      var $130=(($129)&65535);
      var $131=(($130-2)|0);
      var $132=(($131) & 65535);
      HEAP16[(($128)>>1)]=$132;
      var $133=$1;
      var $134=(($133+4)|0);
      var $135=$134;
      var $136=(($135)|0);
      var $137=HEAPU16[(($136)>>1)];
      var $138=(($137)&65535);
      var $139=(($138+1)|0);
      var $140=(($139) & 65535);
      var $141=$1;
      var $142=(($141+36)|0);
      var $143=$142;
      var $144=(($143)|0);
      HEAP16[(($144)>>1)]=$140;
      __label__ = 11; break;
    case 11: // $145
      var $146=$1;
      var $147=(($146+128)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+176)|0);
      var $150=HEAPU8[($149)];
      var $151=(($150)&255);
      var $152=$1;
      var $153=(($152+96)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($154-$151)|0);
      HEAP32[(($153)>>2)]=$155;
      __label__ = 12; break;
    case 12: // $156
      __label__ = 13; break;
    case 13: // $157
      __label__ = 14; break;
    case 14: // $158
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_b0P10_z80_state["X"]=1;

function __ZL5ed_b1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+84)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $val=$17;
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$val;
      var $25=(($24)&255);
      var $26=(($23-$25)|0);
      var $27=(($26) & 255);
      $res=$27;
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      var $32=HEAP16[(($31)>>1)];
      var $33=(($32+1)&65535);
      HEAP16[(($31)>>1)]=$33;
      var $34=$1;
      var $35=(($34+24)|0);
      var $36=$35;
      var $37=(($36)|0);
      var $38=HEAP16[(($37)>>1)];
      var $39=(($38+1)&65535);
      HEAP16[(($37)>>1)]=$39;
      var $40=$1;
      var $41=(($40+16)|0);
      var $42=$41;
      var $43=(($42)|0);
      var $44=HEAP16[(($43)>>1)];
      var $45=(($44-1)&65535);
      HEAP16[(($43)>>1)]=$45;
      var $46=$1;
      var $47=(($46+12)|0);
      var $48=$47;
      var $49=(($48)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$51 & 1;
      var $53=$res;
      var $54=(($53)&255);
      var $55=((__ZL2SZ+$54)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & -41;
      var $59=$52 | $58;
      var $60=$1;
      var $61=(($60+12)|0);
      var $62=$61;
      var $63=(($62+1)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$val;
      var $67=(($66)&255);
      var $68=$65 ^ $67;
      var $69=$res;
      var $70=(($69)&255);
      var $71=$68 ^ $70;
      var $72=$71 & 16;
      var $73=$59 | $72;
      var $74=$73 | 2;
      var $75=(($74) & 255);
      var $76=$1;
      var $77=(($76+12)|0);
      var $78=$77;
      var $79=(($78)|0);
      HEAP8[($79)]=$75;
      var $80=$1;
      var $81=(($80+12)|0);
      var $82=$81;
      var $83=(($82)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$85 & 16;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $88
      var $89=$res;
      var $90=(($89)&255);
      var $91=(($90-1)|0);
      var $92=(($91) & 255);
      $res=$92;
      __label__ = 4; break;
    case 4: // $93
      var $94=$res;
      var $95=(($94)&255);
      var $96=$95 & 2;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $98
      var $99=$1;
      var $100=(($99+12)|0);
      var $101=$100;
      var $102=(($101)|0);
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$104 | 32;
      var $106=(($105) & 255);
      HEAP8[($102)]=$106;
      __label__ = 6; break;
    case 6: // $107
      var $108=$res;
      var $109=(($108)&255);
      var $110=$109 & 8;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $112
      var $113=$1;
      var $114=(($113+12)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$118 | 8;
      var $120=(($119) & 255);
      HEAP8[($116)]=$120;
      __label__ = 8; break;
    case 8: // $121
      var $122=$1;
      var $123=(($122+16)|0);
      var $124=$123;
      var $125=(($124)|0);
      var $126=HEAP16[(($125)>>1)];
      var $127=(($126 << 16) >> 16)!=0;
      if ($127) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $128
      var $129=$1;
      var $130=(($129+12)|0);
      var $131=$130;
      var $132=(($131)|0);
      var $133=HEAPU8[($132)];
      var $134=(($133)&255);
      var $135=$134 | 4;
      var $136=(($135) & 255);
      HEAP8[($132)]=$136;
      __label__ = 10; break;
    case 10: // $137
      __label__ = 11; break;
    case 11: // $138
      var $139=$1;
      var $140=(($139+16)|0);
      var $141=$140;
      var $142=(($141)|0);
      var $143=HEAPU16[(($142)>>1)];
      var $144=(($143)&65535);
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $146
      var $147=$1;
      var $148=(($147+12)|0);
      var $149=$148;
      var $150=(($149)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$152 & 64;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $155
      var $156=$1;
      var $157=(($156+4)|0);
      var $158=$157;
      var $159=(($158)|0);
      var $160=HEAPU16[(($159)>>1)];
      var $161=(($160)&65535);
      var $162=(($161-2)|0);
      var $163=(($162) & 65535);
      HEAP16[(($159)>>1)]=$163;
      var $164=$1;
      var $165=(($164+4)|0);
      var $166=$165;
      var $167=(($166)|0);
      var $168=HEAPU16[(($167)>>1)];
      var $169=(($168)&65535);
      var $170=(($169+1)|0);
      var $171=(($170) & 65535);
      var $172=$1;
      var $173=(($172+36)|0);
      var $174=$173;
      var $175=(($174)|0);
      HEAP16[(($175)>>1)]=$171;
      __label__ = 14; break;
    case 14: // $176
      var $177=$1;
      var $178=(($177+128)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+177)|0);
      var $181=HEAPU8[($180)];
      var $182=(($181)&255);
      var $183=$1;
      var $184=(($183+96)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185-$182)|0);
      HEAP32[(($184)>>2)]=$186;
      __label__ = 15; break;
    case 15: // $187
      __label__ = 16; break;
    case 16: // $188
      __label__ = 17; break;
    case 17: // $189
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_b1P10_z80_state["X"]=1;

function __ZL5ed_b2P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+92)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $io=$17;
      var $18=$1;
      var $19=(($18+16)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=(($23+1)|0);
      var $25=(($24) & 65535);
      var $26=$1;
      var $27=(($26+36)|0);
      var $28=$27;
      var $29=(($28)|0);
      HEAP16[(($29)>>1)]=$25;
      var $30=$1;
      var $31=(($30+16)|0);
      var $32=$31;
      var $33=(($32+1)|0);
      var $34=HEAP8[($33)];
      var $35=(($34-1)&255);
      HEAP8[($33)]=$35;
      var $36=$1;
      var $37=(($36+84)|0);
      var $38=HEAPU32[(($37)>>2)];
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+80)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$1;
      var $44=(($43+24)|0);
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAPU16[(($46)>>1)];
      var $48=(($47)&65535);
      var $49=$io;
      FUNCTION_TABLE[$42]($38, $48, $49);
      var $50=$1;
      var $51=(($50+24)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAP16[(($53)>>1)];
      var $55=(($54+1)&65535);
      HEAP16[(($53)>>1)]=$55;
      var $56=$1;
      var $57=(($56+16)|0);
      var $58=$57;
      var $59=(($58+1)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=((__ZL2SZ+$61)|0);
      var $63=HEAP8[($62)];
      var $64=$1;
      var $65=(($64+12)|0);
      var $66=$65;
      var $67=(($66)|0);
      HEAP8[($67)]=$63;
      var $68=$1;
      var $69=(($68+16)|0);
      var $70=$69;
      var $71=(($70)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($73+1)|0);
      var $75=$74 & 255;
      var $76=$io;
      var $77=(($76)&255);
      var $78=(($75+$77)|0);
      $t=$78;
      var $79=$io;
      var $80=(($79)&255);
      var $81=$80 & 128;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $83
      var $84=$1;
      var $85=(($84+12)|0);
      var $86=$85;
      var $87=(($86)|0);
      var $88=HEAPU8[($87)];
      var $89=(($88)&255);
      var $90=$89 | 2;
      var $91=(($90) & 255);
      HEAP8[($87)]=$91;
      __label__ = 4; break;
    case 4: // $92
      var $93=$t;
      var $94=$93 & 256;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $96
      var $97=$1;
      var $98=(($97+12)|0);
      var $99=$98;
      var $100=(($99)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      var $103=$102 | 17;
      var $104=(($103) & 255);
      HEAP8[($100)]=$104;
      __label__ = 6; break;
    case 6: // $105
      var $106=$t;
      var $107=$106 & 7;
      var $108=(($107) & 255);
      var $109=(($108)&255);
      var $110=$1;
      var $111=(($110+16)|0);
      var $112=$111;
      var $113=(($112+1)|0);
      var $114=HEAPU8[($113)];
      var $115=(($114)&255);
      var $116=$109 ^ $115;
      var $117=((__ZL3SZP+$116)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 & 4;
      var $121=$1;
      var $122=(($121+12)|0);
      var $123=$122;
      var $124=(($123)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=$126 | $120;
      var $128=(($127) & 255);
      HEAP8[($124)]=$128;
      __label__ = 7; break;
    case 7: // $129
      var $130=$1;
      var $131=(($130+16)|0);
      var $132=$131;
      var $133=(($132+1)|0);
      var $134=HEAPU8[($133)];
      var $135=(($134)&255);
      var $136=(($135)|0)!=0;
      if ($136) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $137
      var $138=$1;
      var $139=(($138+4)|0);
      var $140=$139;
      var $141=(($140)|0);
      var $142=HEAPU16[(($141)>>1)];
      var $143=(($142)&65535);
      var $144=(($143-2)|0);
      var $145=(($144) & 65535);
      HEAP16[(($141)>>1)]=$145;
      __label__ = 9; break;
    case 9: // $146
      var $147=$1;
      var $148=(($147+128)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+178)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$1;
      var $154=(($153+96)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155-$152)|0);
      HEAP32[(($154)>>2)]=$156;
      __label__ = 10; break;
    case 10: // $157
      __label__ = 11; break;
    case 11: // $158
      __label__ = 12; break;
    case 12: // $159
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_b2P10_z80_state["X"]=1;

function __ZL5ed_b3P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+84)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $io=$17;
      var $18=$1;
      var $19=(($18+16)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAP8[($21)];
      var $23=(($22-1)&255);
      HEAP8[($21)]=$23;
      var $24=$1;
      var $25=(($24+16)|0);
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=(($29+1)|0);
      var $31=(($30) & 65535);
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP16[(($35)>>1)]=$31;
      var $36=$1;
      var $37=(($36+92)|0);
      var $38=HEAPU32[(($37)>>2)];
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+80)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$1;
      var $44=(($43+16)|0);
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAPU16[(($46)>>1)];
      var $48=(($47)&65535);
      var $49=$io;
      FUNCTION_TABLE[$42]($38, $48, $49);
      var $50=$1;
      var $51=(($50+24)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAP16[(($53)>>1)];
      var $55=(($54+1)&65535);
      HEAP16[(($53)>>1)]=$55;
      var $56=$1;
      var $57=(($56+16)|0);
      var $58=$57;
      var $59=(($58+1)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=((__ZL2SZ+$61)|0);
      var $63=HEAP8[($62)];
      var $64=$1;
      var $65=(($64+12)|0);
      var $66=$65;
      var $67=(($66)|0);
      HEAP8[($67)]=$63;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=(($70)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=$io;
      var $75=(($74)&255);
      var $76=(($73+$75)|0);
      $t=$76;
      var $77=$io;
      var $78=(($77)&255);
      var $79=$78 & 128;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $81
      var $82=$1;
      var $83=(($82+12)|0);
      var $84=$83;
      var $85=(($84)|0);
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$87 | 2;
      var $89=(($88) & 255);
      HEAP8[($85)]=$89;
      __label__ = 4; break;
    case 4: // $90
      var $91=$t;
      var $92=$91 & 256;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $94
      var $95=$1;
      var $96=(($95+12)|0);
      var $97=$96;
      var $98=(($97)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      var $101=$100 | 17;
      var $102=(($101) & 255);
      HEAP8[($98)]=$102;
      __label__ = 6; break;
    case 6: // $103
      var $104=$t;
      var $105=$104 & 7;
      var $106=(($105) & 255);
      var $107=(($106)&255);
      var $108=$1;
      var $109=(($108+16)|0);
      var $110=$109;
      var $111=(($110+1)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=$107 ^ $113;
      var $115=((__ZL3SZP+$114)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$117 & 4;
      var $119=$1;
      var $120=(($119+12)|0);
      var $121=$120;
      var $122=(($121)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=$124 | $118;
      var $126=(($125) & 255);
      HEAP8[($122)]=$126;
      __label__ = 7; break;
    case 7: // $127
      var $128=$1;
      var $129=(($128+16)|0);
      var $130=$129;
      var $131=(($130+1)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $135
      var $136=$1;
      var $137=(($136+4)|0);
      var $138=$137;
      var $139=(($138)|0);
      var $140=HEAPU16[(($139)>>1)];
      var $141=(($140)&65535);
      var $142=(($141-2)|0);
      var $143=(($142) & 65535);
      HEAP16[(($139)>>1)]=$143;
      __label__ = 9; break;
    case 9: // $144
      var $145=$1;
      var $146=(($145+128)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+179)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$1;
      var $152=(($151+96)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153-$150)|0);
      HEAP32[(($152)>>2)]=$154;
      __label__ = 10; break;
    case 10: // $155
      __label__ = 11; break;
    case 11: // $156
      __label__ = 12; break;
    case 12: // $157
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_b3P10_z80_state["X"]=1;

function __ZL5ed_b4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_b5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_b6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_b7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_b8P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+84)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $io=$17;
      var $18=$1;
      var $19=(($18+84)|0);
      var $20=HEAPU32[(($19)>>2)];
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+80)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      var $26=(($25+20)|0);
      var $27=$26;
      var $28=(($27)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$io;
      FUNCTION_TABLE[$24]($20, $30, $31);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 193;
      var $39=(($38) & 255);
      HEAP8[($35)]=$39;
      var $40=$1;
      var $41=(($40+12)|0);
      var $42=$41;
      var $43=(($42+1)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$io;
      var $47=(($46)&255);
      var $48=(($45+$47)|0);
      var $49=$48 & 2;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $51
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 | 32;
      var $59=(($58) & 255);
      HEAP8[($55)]=$59;
      __label__ = 4; break;
    case 4: // $60
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63+1)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=$io;
      var $68=(($67)&255);
      var $69=(($66+$68)|0);
      var $70=$69 & 8;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $72
      var $73=$1;
      var $74=(($73+12)|0);
      var $75=$74;
      var $76=(($75)|0);
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $79=$78 | 8;
      var $80=(($79) & 255);
      HEAP8[($76)]=$80;
      __label__ = 6; break;
    case 6: // $81
      var $82=$1;
      var $83=(($82+24)|0);
      var $84=$83;
      var $85=(($84)|0);
      var $86=HEAP16[(($85)>>1)];
      var $87=(($86-1)&65535);
      HEAP16[(($85)>>1)]=$87;
      var $88=$1;
      var $89=(($88+20)|0);
      var $90=$89;
      var $91=(($90)|0);
      var $92=HEAP16[(($91)>>1)];
      var $93=(($92-1)&65535);
      HEAP16[(($91)>>1)]=$93;
      var $94=$1;
      var $95=(($94+16)|0);
      var $96=$95;
      var $97=(($96)|0);
      var $98=HEAP16[(($97)>>1)];
      var $99=(($98-1)&65535);
      HEAP16[(($97)>>1)]=$99;
      var $100=$1;
      var $101=(($100+16)|0);
      var $102=$101;
      var $103=(($102)|0);
      var $104=HEAP16[(($103)>>1)];
      var $105=(($104 << 16) >> 16)!=0;
      if ($105) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $106
      var $107=$1;
      var $108=(($107+12)|0);
      var $109=$108;
      var $110=(($109)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$112 | 4;
      var $114=(($113) & 255);
      HEAP8[($110)]=$114;
      __label__ = 8; break;
    case 8: // $115
      __label__ = 9; break;
    case 9: // $116
      var $117=$1;
      var $118=(($117+16)|0);
      var $119=$118;
      var $120=(($119)|0);
      var $121=HEAPU16[(($120)>>1)];
      var $122=(($121)&65535);
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $124
      var $125=$1;
      var $126=(($125+4)|0);
      var $127=$126;
      var $128=(($127)|0);
      var $129=HEAPU16[(($128)>>1)];
      var $130=(($129)&65535);
      var $131=(($130-2)|0);
      var $132=(($131) & 65535);
      HEAP16[(($128)>>1)]=$132;
      var $133=$1;
      var $134=(($133+4)|0);
      var $135=$134;
      var $136=(($135)|0);
      var $137=HEAPU16[(($136)>>1)];
      var $138=(($137)&65535);
      var $139=(($138+1)|0);
      var $140=(($139) & 65535);
      var $141=$1;
      var $142=(($141+36)|0);
      var $143=$142;
      var $144=(($143)|0);
      HEAP16[(($144)>>1)]=$140;
      __label__ = 11; break;
    case 11: // $145
      var $146=$1;
      var $147=(($146+128)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+184)|0);
      var $150=HEAPU8[($149)];
      var $151=(($150)&255);
      var $152=$1;
      var $153=(($152+96)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($154-$151)|0);
      HEAP32[(($153)>>2)]=$155;
      __label__ = 12; break;
    case 12: // $156
      __label__ = 13; break;
    case 13: // $157
      __label__ = 14; break;
    case 14: // $158
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_b8P10_z80_state["X"]=1;

function __ZL5ed_b9P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+84)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $val=$17;
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$val;
      var $25=(($24)&255);
      var $26=(($23-$25)|0);
      var $27=(($26) & 255);
      $res=$27;
      var $28=$1;
      var $29=(($28+36)|0);
      var $30=$29;
      var $31=(($30)|0);
      var $32=HEAP16[(($31)>>1)];
      var $33=(($32-1)&65535);
      HEAP16[(($31)>>1)]=$33;
      var $34=$1;
      var $35=(($34+24)|0);
      var $36=$35;
      var $37=(($36)|0);
      var $38=HEAP16[(($37)>>1)];
      var $39=(($38-1)&65535);
      HEAP16[(($37)>>1)]=$39;
      var $40=$1;
      var $41=(($40+16)|0);
      var $42=$41;
      var $43=(($42)|0);
      var $44=HEAP16[(($43)>>1)];
      var $45=(($44-1)&65535);
      HEAP16[(($43)>>1)]=$45;
      var $46=$1;
      var $47=(($46+12)|0);
      var $48=$47;
      var $49=(($48)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$51 & 1;
      var $53=$res;
      var $54=(($53)&255);
      var $55=((__ZL2SZ+$54)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & -41;
      var $59=$52 | $58;
      var $60=$1;
      var $61=(($60+12)|0);
      var $62=$61;
      var $63=(($62+1)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$val;
      var $67=(($66)&255);
      var $68=$65 ^ $67;
      var $69=$res;
      var $70=(($69)&255);
      var $71=$68 ^ $70;
      var $72=$71 & 16;
      var $73=$59 | $72;
      var $74=$73 | 2;
      var $75=(($74) & 255);
      var $76=$1;
      var $77=(($76+12)|0);
      var $78=$77;
      var $79=(($78)|0);
      HEAP8[($79)]=$75;
      var $80=$1;
      var $81=(($80+12)|0);
      var $82=$81;
      var $83=(($82)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$85 & 16;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $88
      var $89=$res;
      var $90=(($89)&255);
      var $91=(($90-1)|0);
      var $92=(($91) & 255);
      $res=$92;
      __label__ = 4; break;
    case 4: // $93
      var $94=$res;
      var $95=(($94)&255);
      var $96=$95 & 2;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $98
      var $99=$1;
      var $100=(($99+12)|0);
      var $101=$100;
      var $102=(($101)|0);
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$104 | 32;
      var $106=(($105) & 255);
      HEAP8[($102)]=$106;
      __label__ = 6; break;
    case 6: // $107
      var $108=$res;
      var $109=(($108)&255);
      var $110=$109 & 8;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $112
      var $113=$1;
      var $114=(($113+12)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$118 | 8;
      var $120=(($119) & 255);
      HEAP8[($116)]=$120;
      __label__ = 8; break;
    case 8: // $121
      var $122=$1;
      var $123=(($122+16)|0);
      var $124=$123;
      var $125=(($124)|0);
      var $126=HEAP16[(($125)>>1)];
      var $127=(($126 << 16) >> 16)!=0;
      if ($127) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $128
      var $129=$1;
      var $130=(($129+12)|0);
      var $131=$130;
      var $132=(($131)|0);
      var $133=HEAPU8[($132)];
      var $134=(($133)&255);
      var $135=$134 | 4;
      var $136=(($135) & 255);
      HEAP8[($132)]=$136;
      __label__ = 10; break;
    case 10: // $137
      __label__ = 11; break;
    case 11: // $138
      var $139=$1;
      var $140=(($139+16)|0);
      var $141=$140;
      var $142=(($141)|0);
      var $143=HEAPU16[(($142)>>1)];
      var $144=(($143)&65535);
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $146
      var $147=$1;
      var $148=(($147+12)|0);
      var $149=$148;
      var $150=(($149)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$152 & 64;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $155
      var $156=$1;
      var $157=(($156+4)|0);
      var $158=$157;
      var $159=(($158)|0);
      var $160=HEAPU16[(($159)>>1)];
      var $161=(($160)&65535);
      var $162=(($161-2)|0);
      var $163=(($162) & 65535);
      HEAP16[(($159)>>1)]=$163;
      var $164=$1;
      var $165=(($164+4)|0);
      var $166=$165;
      var $167=(($166)|0);
      var $168=HEAPU16[(($167)>>1)];
      var $169=(($168)&65535);
      var $170=(($169+1)|0);
      var $171=(($170) & 65535);
      var $172=$1;
      var $173=(($172+36)|0);
      var $174=$173;
      var $175=(($174)|0);
      HEAP16[(($175)>>1)]=$171;
      __label__ = 14; break;
    case 14: // $176
      var $177=$1;
      var $178=(($177+128)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+185)|0);
      var $181=HEAPU8[($180)];
      var $182=(($181)&255);
      var $183=$1;
      var $184=(($183+96)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185-$182)|0);
      HEAP32[(($184)>>2)]=$186;
      __label__ = 15; break;
    case 15: // $187
      __label__ = 16; break;
    case 16: // $188
      __label__ = 17; break;
    case 17: // $189
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_b9P10_z80_state["X"]=1;

function __ZL5ed_baP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+92)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $io=$17;
      var $18=$1;
      var $19=(($18+16)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=(($23-1)|0);
      var $25=(($24) & 65535);
      var $26=$1;
      var $27=(($26+36)|0);
      var $28=$27;
      var $29=(($28)|0);
      HEAP16[(($29)>>1)]=$25;
      var $30=$1;
      var $31=(($30+16)|0);
      var $32=$31;
      var $33=(($32+1)|0);
      var $34=HEAP8[($33)];
      var $35=(($34-1)&255);
      HEAP8[($33)]=$35;
      var $36=$1;
      var $37=(($36+84)|0);
      var $38=HEAPU32[(($37)>>2)];
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+80)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$1;
      var $44=(($43+24)|0);
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAPU16[(($46)>>1)];
      var $48=(($47)&65535);
      var $49=$io;
      FUNCTION_TABLE[$42]($38, $48, $49);
      var $50=$1;
      var $51=(($50+24)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAP16[(($53)>>1)];
      var $55=(($54-1)&65535);
      HEAP16[(($53)>>1)]=$55;
      var $56=$1;
      var $57=(($56+16)|0);
      var $58=$57;
      var $59=(($58+1)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=((__ZL2SZ+$61)|0);
      var $63=HEAP8[($62)];
      var $64=$1;
      var $65=(($64+12)|0);
      var $66=$65;
      var $67=(($66)|0);
      HEAP8[($67)]=$63;
      var $68=$1;
      var $69=(($68+16)|0);
      var $70=$69;
      var $71=(($70)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($73-1)|0);
      var $75=$74 & 255;
      var $76=$io;
      var $77=(($76)&255);
      var $78=(($75+$77)|0);
      $t=$78;
      var $79=$io;
      var $80=(($79)&255);
      var $81=$80 & 128;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $83
      var $84=$1;
      var $85=(($84+12)|0);
      var $86=$85;
      var $87=(($86)|0);
      var $88=HEAPU8[($87)];
      var $89=(($88)&255);
      var $90=$89 | 2;
      var $91=(($90) & 255);
      HEAP8[($87)]=$91;
      __label__ = 4; break;
    case 4: // $92
      var $93=$t;
      var $94=$93 & 256;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $96
      var $97=$1;
      var $98=(($97+12)|0);
      var $99=$98;
      var $100=(($99)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      var $103=$102 | 17;
      var $104=(($103) & 255);
      HEAP8[($100)]=$104;
      __label__ = 6; break;
    case 6: // $105
      var $106=$t;
      var $107=$106 & 7;
      var $108=(($107) & 255);
      var $109=(($108)&255);
      var $110=$1;
      var $111=(($110+16)|0);
      var $112=$111;
      var $113=(($112+1)|0);
      var $114=HEAPU8[($113)];
      var $115=(($114)&255);
      var $116=$109 ^ $115;
      var $117=((__ZL3SZP+$116)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 & 4;
      var $121=$1;
      var $122=(($121+12)|0);
      var $123=$122;
      var $124=(($123)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=$126 | $120;
      var $128=(($127) & 255);
      HEAP8[($124)]=$128;
      __label__ = 7; break;
    case 7: // $129
      var $130=$1;
      var $131=(($130+16)|0);
      var $132=$131;
      var $133=(($132+1)|0);
      var $134=HEAPU8[($133)];
      var $135=(($134)&255);
      var $136=(($135)|0)!=0;
      if ($136) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $137
      var $138=$1;
      var $139=(($138+4)|0);
      var $140=$139;
      var $141=(($140)|0);
      var $142=HEAPU16[(($141)>>1)];
      var $143=(($142)&65535);
      var $144=(($143-2)|0);
      var $145=(($144) & 65535);
      HEAP16[(($141)>>1)]=$145;
      __label__ = 9; break;
    case 9: // $146
      var $147=$1;
      var $148=(($147+128)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+186)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$1;
      var $154=(($153+96)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155-$152)|0);
      HEAP32[(($154)>>2)]=$156;
      __label__ = 10; break;
    case 10: // $157
      __label__ = 11; break;
    case 11: // $158
      __label__ = 12; break;
    case 12: // $159
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_baP10_z80_state["X"]=1;

function __ZL5dd_09P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+16)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+28)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+28)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+16)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+28)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_09P10_z80_state["X"]=1;

function __ZL5ed_bbP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t;
      var $io;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+84)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=FUNCTION_TABLE[$10]($6, $16);
      $io=$17;
      var $18=$1;
      var $19=(($18+16)|0);
      var $20=$19;
      var $21=(($20+1)|0);
      var $22=HEAP8[($21)];
      var $23=(($22-1)&255);
      HEAP8[($21)]=$23;
      var $24=$1;
      var $25=(($24+16)|0);
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=(($29-1)|0);
      var $31=(($30) & 65535);
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP16[(($35)>>1)]=$31;
      var $36=$1;
      var $37=(($36+92)|0);
      var $38=HEAPU32[(($37)>>2)];
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+80)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$1;
      var $44=(($43+16)|0);
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAPU16[(($46)>>1)];
      var $48=(($47)&65535);
      var $49=$io;
      FUNCTION_TABLE[$42]($38, $48, $49);
      var $50=$1;
      var $51=(($50+24)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAP16[(($53)>>1)];
      var $55=(($54-1)&65535);
      HEAP16[(($53)>>1)]=$55;
      var $56=$1;
      var $57=(($56+16)|0);
      var $58=$57;
      var $59=(($58+1)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=((__ZL2SZ+$61)|0);
      var $63=HEAP8[($62)];
      var $64=$1;
      var $65=(($64+12)|0);
      var $66=$65;
      var $67=(($66)|0);
      HEAP8[($67)]=$63;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=$69;
      var $71=(($70)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=$io;
      var $75=(($74)&255);
      var $76=(($73+$75)|0);
      $t=$76;
      var $77=$io;
      var $78=(($77)&255);
      var $79=$78 & 128;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $81
      var $82=$1;
      var $83=(($82+12)|0);
      var $84=$83;
      var $85=(($84)|0);
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$87 | 2;
      var $89=(($88) & 255);
      HEAP8[($85)]=$89;
      __label__ = 4; break;
    case 4: // $90
      var $91=$t;
      var $92=$91 & 256;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $94
      var $95=$1;
      var $96=(($95+12)|0);
      var $97=$96;
      var $98=(($97)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      var $101=$100 | 17;
      var $102=(($101) & 255);
      HEAP8[($98)]=$102;
      __label__ = 6; break;
    case 6: // $103
      var $104=$t;
      var $105=$104 & 7;
      var $106=(($105) & 255);
      var $107=(($106)&255);
      var $108=$1;
      var $109=(($108+16)|0);
      var $110=$109;
      var $111=(($110+1)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=$107 ^ $113;
      var $115=((__ZL3SZP+$114)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$117 & 4;
      var $119=$1;
      var $120=(($119+12)|0);
      var $121=$120;
      var $122=(($121)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=$124 | $118;
      var $126=(($125) & 255);
      HEAP8[($122)]=$126;
      __label__ = 7; break;
    case 7: // $127
      var $128=$1;
      var $129=(($128+16)|0);
      var $130=$129;
      var $131=(($130+1)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $135
      var $136=$1;
      var $137=(($136+4)|0);
      var $138=$137;
      var $139=(($138)|0);
      var $140=HEAPU16[(($139)>>1)];
      var $141=(($140)&65535);
      var $142=(($141-2)|0);
      var $143=(($142) & 65535);
      HEAP16[(($139)>>1)]=$143;
      __label__ = 9; break;
    case 9: // $144
      var $145=$1;
      var $146=(($145+128)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+187)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$1;
      var $152=(($151+96)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153-$150)|0);
      HEAP32[(($152)>>2)]=$154;
      __label__ = 10; break;
    case 10: // $155
      __label__ = 11; break;
    case 11: // $156
      __label__ = 12; break;
    case 12: // $157
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5ed_bbP10_z80_state["X"]=1;

function __ZL5ed_bcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_bdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_beP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_bfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_c9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_caP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_cbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_ccP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_cdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_ceP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_cfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_d9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_daP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_dbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_dcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_ddP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_deP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_dfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_e9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_eaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_ebP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_ecP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_edP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_eeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_efP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_f9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_faP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_fbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_fcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_fdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_feP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL5ed_ffP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_2P10_z80_state($2);
  ;
  return;
}


function __ZL9illegal_2P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=__ZNK8device_t3tagEv($5);
  var $7=$1;
  var $8=(($7+88)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+4)|0);
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13-1)|0);
  var $15=$14 & 65535;
  var $16=__ZN16direct_read_data19read_decrypted_byteEjj($9, $15, 0);
  var $17=(($16)&255);
  __Z8logerrorPKcz(((STRING_TABLE.__str8243)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$6,HEAP32[((tempInt+4)>>2)]=$17,tempInt));
  STACKTOP = __stackBase__;
  return;
}


function __ZL5dd_00P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_00P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_01P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_01P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_02P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_02P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_03P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_03P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_04P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_04P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_05P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_05P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_06P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_06P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_07P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_07P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_08P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_08P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_0aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_0bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_0cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0cP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_0dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0dP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_0eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0eP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_0fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_0fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_10P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_10P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_11P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_11P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_12P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_12P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_13P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_13P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_14P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_14P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_15P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_15P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_16P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_17P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_17P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_18P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_18P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_19P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+28)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+28)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+20)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+28)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_19P10_z80_state["X"]=1;

function __ZL5dd_23P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6+1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5dd_29P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+28)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+28)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+28)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+28)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+28)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_29P10_z80_state["X"]=1;

function __ZL5dd_2bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=(($6-1)&65535);
  HEAP16[(($5)>>1)]=$7;
  ;
  return;
}


function __ZL5dd_39P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+$10)|0);
      $res=$11;
      var $12=$1;
      var $13=(($12+28)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($16) & 65535);
      var $18=$1;
      var $19=(($18+36)|0);
      var $20=$19;
      var $21=(($20)|0);
      HEAP16[(($21)>>1)]=$17;
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=$23;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 196;
      var $29=$1;
      var $30=(($29+28)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=$res;
      var $34=$32 ^ $33;
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=$34 ^ $38;
      var $40=$39 >>> 8;
      var $41=$40 & 16;
      var $42=$28 | $41;
      var $43=$res;
      var $44=$43 >>> 16;
      var $45=$44 & 1;
      var $46=$42 | $45;
      var $47=$res;
      var $48=$47 >>> 8;
      var $49=$48 & 40;
      var $50=$46 | $49;
      var $51=(($50) & 255);
      var $52=$1;
      var $53=(($52+12)|0);
      var $54=$53;
      var $55=(($54)|0);
      HEAP8[($55)]=$51;
      var $56=$res;
      var $57=(($56) & 65535);
      var $58=$1;
      var $59=(($58+28)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP16[(($61)>>1)]=$57;
      __label__ = 2; break;
    case 2: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_39P10_z80_state["X"]=1;

function __ZL5dd_44P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_45P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_4cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_4dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+16)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_1aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_1bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_1cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1cP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_1dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1dP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_1eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1eP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_1fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_1fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_20P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_20P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_21P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=(($3) & 65535);
  var $5=$1;
  var $6=(($5+28)|0);
  var $7=$6;
  var $8=(($7)|0);
  HEAP16[(($8)>>1)]=$4;
  ;
  return;
}


function __ZL5dd_22P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+28)|0);
  __ZL4WM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5dd_24P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+28)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+28)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5dd_25P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+28)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+28)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5dd_26P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+28)|0);
  var $6=$5;
  var $7=(($6+1)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5dd_27P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_27P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_28P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_28P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_2aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL5ARG16P10_z80_state($2);
  var $4=$1;
  var $5=(($4+72)|0);
  HEAP32[(($5)>>2)]=$3;
  var $6=$1;
  var $7=$1;
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=(($10+28)|0);
  __ZL4RM16P10_z80_statejP4PAIR($6, $9, $11);
  var $12=$1;
  var $13=(($12+72)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+1)|0);
  var $16=(($15) & 65535);
  var $17=$1;
  var $18=(($17+36)|0);
  var $19=$18;
  var $20=(($19)|0);
  HEAP16[(($20)>>1)]=$16;
  ;
  return;
}


function __ZL5dd_2cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+28)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3INCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+28)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5dd_2dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+28)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3DECP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+28)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5dd_2eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=__ZL3ARGP10_z80_state($2);
  var $4=$1;
  var $5=(($4+28)|0);
  var $6=$5;
  var $7=(($6)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL5dd_2fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_2fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_30P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_30P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_31P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_31P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_32P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_32P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_33P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_33P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_34P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=$1;
      var $38=(($37+84)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+28)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+72)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=FUNCTION_TABLE[$43]($39, $46);
      var $48=__ZL3INCP10_z80_stateh($36, $47);
      FUNCTION_TABLE[$32]($28, $35, $48);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_34P10_z80_state["X"]=1;

function __ZL5dd_35P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=$1;
      var $38=(($37+84)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+28)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+72)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=FUNCTION_TABLE[$43]($39, $46);
      var $48=__ZL3DECP10_z80_stateh($36, $47);
      FUNCTION_TABLE[$32]($28, $35, $48);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_35P10_z80_state["X"]=1;

function __ZL5dd_36P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=__ZL3ARGP10_z80_state($36);
      FUNCTION_TABLE[$32]($28, $35, $37);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_37P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_37P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_38P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_38P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_3aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_3bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_3cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3cP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_3dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3dP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_3eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3eP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_3fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_3fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_40P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_40P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_41P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_41P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_42P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_42P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_43P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_43P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_46P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+16)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_47P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_47P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_48P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_48P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_49P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_49P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_4aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_4aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_4bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_4bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_64P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5dd_6dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  ;
  return;
}


function __ZL5dd_54P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_55P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_5cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_5dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+20)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_60P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_61P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_62P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_63P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_65P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_67P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_68P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_69P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_6aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_6bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_6cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_6fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_4eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+16)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_4fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_4fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_50P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_50P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_51P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_51P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_52P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_52P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_53P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_53P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_56P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+20)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_57P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_57P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_58P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_58P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_59P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_59P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_5aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_5aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_5bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_5bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_5eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+20)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_5fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_5fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_66P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+24)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_6eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+24)|0);
      var $39=$38;
      var $40=(($39)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_70P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+16)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_71P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+16)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_72P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_73P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_74P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+24)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_75P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+24)|0);
      var $38=$37;
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_76P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_76P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_77P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+80)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=$37;
      var $39=(($38+1)|0);
      var $40=HEAP8[($39)];
      FUNCTION_TABLE[$32]($28, $35, $40);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_78P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_78P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_79P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_79P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_7aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_7aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_7cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_7dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=$8;
  var $10=(($9+1)|0);
  HEAP8[($10)]=$6;
  ;
  return;
}


function __ZL5dd_84P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+28)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_85P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+28)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9+$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_8cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+28)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_8cP10_z80_state["X"]=1;

function __ZL5dd_8dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+28)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14+$20)|0);
      var $22=$c;
      var $23=(($21+$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_8dP10_z80_state["X"]=1;

function __ZL5dd_94P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+28)|0);
      var $12=$11;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_95P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$ah;
      var $9=$8 >>> 8;
      var $10=$1;
      var $11=(($10+28)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=(($9-$15)|0);
      var $17=(($16) & 255);
      var $18=(($17)&255);
      $res=$18;
      var $19=$ah;
      var $20=$res;
      var $21=$19 | $20;
      var $22=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $23=(($22+$21)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      var $29=$res;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=$32;
      var $34=(($33+1)|0);
      HEAP8[($34)]=$30;
      __label__ = 2; break;
    case 2: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_9cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+28)|0);
      var $17=$16;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_9cP10_z80_state["X"]=1;

function __ZL5dd_9dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65280;
      $ah=$7;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      $c=$12;
      var $13=$ah;
      var $14=$13 >>> 8;
      var $15=$1;
      var $16=(($15+28)|0);
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=(($14-$20)|0);
      var $22=$c;
      var $23=(($21-$22)|0);
      var $24=(($23) & 255);
      var $25=(($24)&255);
      $res=$25;
      var $26=$c;
      var $27=$26 << 16;
      var $28=$ah;
      var $29=$27 | $28;
      var $30=$res;
      var $31=$29 | $30;
      var $32=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(($37)|0);
      HEAP8[($38)]=$34;
      var $39=$res;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43+1)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_9dP10_z80_state["X"]=1;

function __ZL5dd_7bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_7bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_7eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+84)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$32]($28, $35);
      var $37=$1;
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+1)|0);
      HEAP8[($40)]=$36;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_7fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_7fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_80P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_80P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_81P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_81P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_82P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_82P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_83P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_83P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_86P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$ah;
      var $33=$32 >>> 8;
      var $34=$1;
      var $35=(($34+84)|0);
      var $36=HEAPU32[(($35)>>2)];
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=FUNCTION_TABLE[$40]($36, $43);
      var $45=(($44)&255);
      var $46=(($33+$45)|0);
      var $47=(($46) & 255);
      var $48=(($47)&255);
      $res=$48;
      var $49=$ah;
      var $50=$res;
      var $51=$49 | $50;
      var $52=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $53=(($52+$51)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      var $59=$res;
      var $60=(($59) & 255);
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63+1)|0);
      HEAP8[($64)]=$60;
      __label__ = 4; break;
    case 4: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_86P10_z80_state["X"]=1;

function __ZL5dd_87P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_87P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_88P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_88P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_89P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_89P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_8aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_8aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_8bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_8bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_8eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & 1;
      $c=$36;
      var $37=$ah;
      var $38=$37 >>> 8;
      var $39=$1;
      var $40=(($39+84)|0);
      var $41=HEAPU32[(($40)>>2)];
      var $42=$41;
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+28)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+72)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=FUNCTION_TABLE[$45]($41, $48);
      var $50=(($49)&255);
      var $51=(($38+$50)|0);
      var $52=$c;
      var $53=(($51+$52)|0);
      var $54=(($53) & 255);
      var $55=(($54)&255);
      $res=$55;
      var $56=$c;
      var $57=$56 << 16;
      var $58=$ah;
      var $59=$57 | $58;
      var $60=$res;
      var $61=$59 | $60;
      var $62=HEAP32[((__ZL9SZHVC_add)>>2)];
      var $63=(($62+$61)|0);
      var $64=HEAP8[($63)];
      var $65=$1;
      var $66=(($65+12)|0);
      var $67=$66;
      var $68=(($67)|0);
      HEAP8[($68)]=$64;
      var $69=$res;
      var $70=(($69) & 255);
      var $71=$1;
      var $72=(($71+12)|0);
      var $73=$72;
      var $74=(($73+1)|0);
      HEAP8[($74)]=$70;
      __label__ = 4; break;
    case 4: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_8eP10_z80_state["X"]=1;

function __ZL5dd_8fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_8fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_90P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_90P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_91P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_91P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_92P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_92P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_93P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_93P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_96P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$ah;
      var $33=$32 >>> 8;
      var $34=$1;
      var $35=(($34+84)|0);
      var $36=HEAPU32[(($35)>>2)];
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$1;
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=FUNCTION_TABLE[$40]($36, $43);
      var $45=(($44)&255);
      var $46=(($33-$45)|0);
      var $47=(($46) & 255);
      var $48=(($47)&255);
      $res=$48;
      var $49=$ah;
      var $50=$res;
      var $51=$49 | $50;
      var $52=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $53=(($52+$51)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      var $59=$res;
      var $60=(($59) & 255);
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=$62;
      var $64=(($63+1)|0);
      HEAP8[($64)]=$60;
      __label__ = 4; break;
    case 4: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_96P10_z80_state["X"]=1;

function __ZL5dd_97P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_97P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_98P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_98P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_99P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_99P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_9aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_9aP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_9bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_9bP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_a5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$25 | 16;
      var $27=(($26) & 255);
      var $28=$1;
      var $29=(($28+12)|0);
      var $30=$29;
      var $31=(($30)|0);
      HEAP8[($31)]=$27;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_acP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_adP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 ^ $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_b4P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_b5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 | $8;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=$18;
      var $20=(($19+1)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=((__ZL3SZP+$22)|0);
      var $24=HEAP8[($23)];
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP8[($28)]=$24;
      __label__ = 2; break;
    case 2: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_bcP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5+1)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_bdP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      $val=$8;
      var $9=$1;
      var $10=(($9+12)|0);
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 65280;
      $ah=$13;
      var $14=$ah;
      var $15=$14 >>> 8;
      var $16=$val;
      var $17=(($15-$16)|0);
      var $18=(($17) & 255);
      var $19=(($18)&255);
      $res=$19;
      var $20=$ah;
      var $21=$res;
      var $22=$20 | $21;
      var $23=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & -41;
      var $28=$val;
      var $29=$28 & 40;
      var $30=$27 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_9eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ah;
      var $c;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 65280;
      $ah=$31;
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & 1;
      $c=$36;
      var $37=$ah;
      var $38=$37 >>> 8;
      var $39=$1;
      var $40=(($39+84)|0);
      var $41=HEAPU32[(($40)>>2)];
      var $42=$41;
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+28)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+72)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=FUNCTION_TABLE[$45]($41, $48);
      var $50=(($49)&255);
      var $51=(($38-$50)|0);
      var $52=$c;
      var $53=(($51-$52)|0);
      var $54=(($53) & 255);
      var $55=(($54)&255);
      $res=$55;
      var $56=$c;
      var $57=$56 << 16;
      var $58=$ah;
      var $59=$57 | $58;
      var $60=$res;
      var $61=$59 | $60;
      var $62=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $63=(($62+$61)|0);
      var $64=HEAP8[($63)];
      var $65=$1;
      var $66=(($65+12)|0);
      var $67=$66;
      var $68=(($67)|0);
      HEAP8[($68)]=$64;
      var $69=$res;
      var $70=(($69) & 255);
      var $71=$1;
      var $72=(($71+12)|0);
      var $73=$72;
      var $74=(($73+1)|0);
      HEAP8[($74)]=$70;
      __label__ = 4; break;
    case 4: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_9eP10_z80_state["X"]=1;

function __ZL5dd_9fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_9fP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a0P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a1P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a2P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a3P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 & $38;
      var $46=(($45) & 255);
      HEAP8[($42)]=$46;
      var $47=$1;
      var $48=(($47+12)|0);
      var $49=$48;
      var $50=(($49+1)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=((__ZL3SZP+$52)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$55 | 16;
      var $57=(($56) & 255);
      var $58=$1;
      var $59=(($58+12)|0);
      var $60=$59;
      var $61=(($60)|0);
      HEAP8[($61)]=$57;
      __label__ = 4; break;
    case 4: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_a6P10_z80_state["X"]=1;

function __ZL5dd_a7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a7P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a8P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_a9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_a9P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_aaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_aaP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_abP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_abP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_aeP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 ^ $38;
      var $46=(($45) & 255);
      HEAP8[($42)]=$46;
      var $47=$1;
      var $48=(($47+12)|0);
      var $49=$48;
      var $50=(($49+1)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=((__ZL3SZP+$52)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      __label__ = 4; break;
    case 4: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_aeP10_z80_state["X"]=1;

function __ZL5dd_afP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_afP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b0P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b1P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b2P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b3P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b6P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=(($41+1)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 | $38;
      var $46=(($45) & 255);
      HEAP8[($42)]=$46;
      var $47=$1;
      var $48=(($47+12)|0);
      var $49=$48;
      var $50=(($49+1)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=((__ZL3SZP+$52)|0);
      var $54=HEAP8[($53)];
      var $55=$1;
      var $56=(($55+12)|0);
      var $57=$56;
      var $58=(($57)|0);
      HEAP8[($58)]=$54;
      __label__ = 4; break;
    case 4: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_b6P10_z80_state["X"]=1;

function __ZL5dd_b7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b7P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b8P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_b9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_b9P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_baP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_baP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_bbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_bbP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_beP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $val;
      var $ah;
      var $res;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      var $28=(($27+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+72)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=FUNCTION_TABLE[$33]($29, $36);
      var $38=(($37)&255);
      $val=$38;
      var $39=$1;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$42 & 65280;
      $ah=$43;
      var $44=$ah;
      var $45=$44 >>> 8;
      var $46=$val;
      var $47=(($45-$46)|0);
      var $48=(($47) & 255);
      var $49=(($48)&255);
      $res=$49;
      var $50=$ah;
      var $51=$res;
      var $52=$50 | $51;
      var $53=HEAP32[((__ZL9SZHVC_sub)>>2)];
      var $54=(($53+$52)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & -41;
      var $58=$val;
      var $59=$58 & 40;
      var $60=$57 | $59;
      var $61=(($60) & 255);
      var $62=$1;
      var $63=(($62+12)|0);
      var $64=$63;
      var $65=(($64)|0);
      HEAP8[($65)]=$61;
      __label__ = 4; break;
    case 4: // $66
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_beP10_z80_state["X"]=1;

function __ZL5dd_bfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_bfP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c0P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c1P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c2P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c3P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c4P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c5P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP16[(($10)>>1)]=$6;
  ;
  return;
}


function __ZL5dd_f9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP16[(($5)>>1)];
  var $7=$1;
  var $8=(($7+8)|0);
  var $9=$8;
  var $10=(($9)|0);
  HEAP16[(($10)>>1)]=$6;
  ;
  return;
}


function __ZL5dd_c6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c6P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c7P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c8P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_c9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_c9P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_caP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_caP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_cbP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $op;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=$1;
      var $10=__ZL3ARGP10_z80_state($9);
      var $11=(($10 << 24) >> 24);
      var $12=(($8+$11)|0);
      var $13=(($12) & 65535);
      var $14=(($13)&65535);
      var $15=$1;
      var $16=(($15+72)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$1;
      var $18=(($17+72)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19) & 65535);
      var $21=$1;
      var $22=(($21+36)|0);
      var $23=$22;
      var $24=(($23)|0);
      HEAP16[(($24)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=__ZL3ARGP10_z80_state($26);
      var $28=(($27)&255);
      $op=$28;
      __label__ = 3; break;
    case 3: // $29
      var $30=$op;
      var $31=$1;
      var $32=(($31+124)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$30)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$1;
      var $38=(($37+96)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-$36)|0);
      HEAP32[(($38)>>2)]=$40;
      __label__ = 4; break;
    case 4: // $41
      var $42=$op;
      var $43=((__ZL7Z80xycb+($42<<2))|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$1;
      FUNCTION_TABLE[$44]($45);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL5dd_cbP10_z80_state["X"]=1;

function __ZL5dd_ccP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ccP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_cdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_cdP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_ceP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ceP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_cfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_cfP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d0P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d1P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d2P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d3P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d4P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d5P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d6P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d7P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d8P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_d9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_d9P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_daP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_daP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_dbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_dbP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_dcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_dcP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_ddP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ddP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_deP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_deP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_dfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_dfP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e0P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e1P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+28)|0);
      __ZL4RM16P10_z80_statejP4PAIR($3, $7, $9);
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15+2)|0);
      var $17=(($16) & 65535);
      HEAP16[(($13)>>1)]=$17;
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_e2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e2P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e3P10_z80_state($z80) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmp=__stackBase__;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$tmp;
      HEAP32[(($3)>>2)]=0;
      var $4=$1;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      __ZL4RM16P10_z80_statejP4PAIR($4, $8, $tmp);
      var $9=$1;
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14+28)|0);
      __ZL4WM16P10_z80_statejP4PAIR($9, $13, $15);
      var $16=$1;
      var $17=(($16+28)|0);
      var $18=$17;
      var $19=$tmp;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[(($19)>>2)];
      var $20=$1;
      var $21=(($20+28)|0);
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23) & 65535);
      var $25=$1;
      var $26=(($25+36)|0);
      var $27=$26;
      var $28=(($27)|0);
      HEAP16[(($28)>>1)]=$24;
      __label__ = 2; break;
    case 2: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_e4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e4P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e5P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU16[(($6)>>1)];
      var $8=(($7)&65535);
      var $9=(($8-2)|0);
      var $10=(($9) & 65535);
      HEAP16[(($6)>>1)]=$10;
      var $11=$1;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($16+28)|0);
      __ZL4WM16P10_z80_statejP4PAIR($11, $15, $17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5dd_e6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e6P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e7P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_e8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_e8P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_eaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_eaP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_ebP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ebP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_ecP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ecP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_edP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_edP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_eeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_eeP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_efP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_efP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f0P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f1P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f2P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f3P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f4P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f5P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f6P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f7P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_f8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_f8P10_z80_state($3);
  ;
  return;
}


function __ZL5dd_faP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_faP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_fbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_fbP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_fcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_fcP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_fdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_fdP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_feP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_feP10_z80_state($3);
  ;
  return;
}


function __ZL5dd_ffP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  __ZL9illegal_1P10_z80_state($2);
  var $3=$1;
  __ZL5op_ffP10_z80_state($3);
  ;
  return;
}


function __ZL5cb_00P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_01P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_02P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_03P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_04P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_05P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_06P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3RLCP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_07P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RLCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_08P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_09P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_0aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_0bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_0cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_0dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_0eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3RRCP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_0fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3RRCP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_10P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_40P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_41P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_11P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_12P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_13P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_14P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_15P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_16P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL2RLP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_17P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_18P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_19P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_1aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_1bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_1cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_1dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_1eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL2RRP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_1fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL2RRP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_20P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_21P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_22P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_23P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_24P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_25P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_26P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3SLAP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_27P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_28P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_29P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_2aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_2bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_2cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_2dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_2eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3SRAP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_2fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRAP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_30P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_31P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_32P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_33P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_34P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_35P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_36P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3SLLP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_37P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SLLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_38P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_39P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+16)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+16)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_3aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_3bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+20)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_3cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_3dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_3eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=$1;
  var $17=(($16+84)|0);
  var $18=HEAPU32[(($17)>>2)];
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+28)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23+24)|0);
  var $25=$24;
  var $26=(($25)|0);
  var $27=HEAPU16[(($26)>>1)];
  var $28=(($27)&65535);
  var $29=FUNCTION_TABLE[$22]($18, $28);
  var $30=__ZL3SRLP10_z80_stateh($15, $29);
  FUNCTION_TABLE[$8]($4, $14, $30);
  ;
  return;
}


function __ZL5cb_3fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=$4;
  var $6=(($5+1)|0);
  var $7=HEAP8[($6)];
  var $8=__ZL3SRLP10_z80_stateh($2, $7);
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=$10;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZL5cb_42P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_43P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_44P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_45P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_47P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 1;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_48P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_49P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_4aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_4bP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_4cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_4dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_4fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 2;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_50P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_51P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_52P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_53P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_54P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_55P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_46P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 1;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_4eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 2;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_56P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 4;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_57P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 4;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_58P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_59P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_5aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_5bP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_5cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_5dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_5fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 8;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_60P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_61P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_62P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_63P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_64P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_65P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_67P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 16;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_68P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_69P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_6aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_6bP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_5eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 8;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_66P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 16;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_6cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_6dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_6fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 32;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_70P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_71P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_72P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_73P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_74P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_75P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_77P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 64;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_78P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_79P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_7aP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_7bP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_7cP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_7dP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=$12;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+24)|0);
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_7fP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+12)|0);
      var $13=$12;
      var $14=(($13+1)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & 128;
      var $18=((__ZL6SZ_BIT+$17)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & -41;
      var $22=$10 | $21;
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=$24;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$28 & 40;
      var $30=$22 | $29;
      var $31=(($30) & 255);
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=$33;
      var $35=(($34)|0);
      HEAP8[($35)]=$31;
      __label__ = 2; break;
    case 2: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_6eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 32;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_76P10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 64;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_7eP10_z80_state($z80) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$z80;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$8 & 1;
      var $10=$9 | 16;
      var $11=$1;
      var $12=(($11+84)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+24)|0);
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=FUNCTION_TABLE[$17]($13, $23);
      var $25=(($24)&255);
      var $26=$25 & 128;
      var $27=((__ZL6SZ_BIT+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$29 & -41;
      var $31=$10 | $30;
      var $32=$1;
      var $33=(($32+36)|0);
      var $34=$33;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$37 & 40;
      var $39=$31 | $38;
      var $40=(($39) & 255);
      var $41=$1;
      var $42=(($41+12)|0);
      var $43=$42;
      var $44=(($43)|0);
      HEAP8[($44)]=$40;
      __label__ = 2; break;
    case 2: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5cb_80P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_81P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_82P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_83P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_84P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_85P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_86P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(0, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_87P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(0, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_88P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_89P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_8aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_8bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_8cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_8dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_8eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(1, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_8fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(1, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_90P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_91P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_92P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_93P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_94P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_95P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_96P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(2, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_97P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(2, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_98P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_99P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_9aP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_9bP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_9cP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_9dP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_9eP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(3, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_9fP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(3, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(4, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_a7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(4, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_a9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_aaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_abP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_acP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_adP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_aeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(5, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_afP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(5, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(6, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_b7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(6, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_b9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_baP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_bbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_bcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_bdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_beP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3REShh(7, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_bfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3REShh(7, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(0, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_c7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(0, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_c9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_caP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_cbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_ccP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_cdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_ceP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(1, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_cfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(1, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(2, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_d7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(2, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_d9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_daP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_dbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_dcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_ddP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_deP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(3, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_dfP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(3, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(4, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_e7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(4, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_e9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_eaP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_ebP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_ecP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_edP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_eeP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(5, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_efP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(5, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZNK15z80_daisy_chain7presentEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK8device_t13static_configEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+44)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL5cb_f0P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f1P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f2P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f3P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f4P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f5P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f6P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(6, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_f7P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(6, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f8P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_f9P10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+16)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_faP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_fbP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+20)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_fcP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_fdP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=$3;
  var $5=(($4)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+24)|0);
  var $10=$9;
  var $11=(($10)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL5cb_feP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+80)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$1;
  var $10=(($9+24)|0);
  var $11=$10;
  var $12=(($11)|0);
  var $13=HEAPU16[(($12)>>1)];
  var $14=(($13)&65535);
  var $15=$1;
  var $16=(($15+84)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+28)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$1;
  var $23=(($22+24)|0);
  var $24=$23;
  var $25=(($24)|0);
  var $26=HEAPU16[(($25)>>1)];
  var $27=(($26)&65535);
  var $28=FUNCTION_TABLE[$21]($17, $27);
  var $29=__ZL3SEThh(7, $28);
  FUNCTION_TABLE[$8]($4, $14, $29);
  ;
  return;
}


function __ZL5cb_ffP10_z80_state($z80) {
  ;
  var __label__;

  var $1;
  $1=$z80;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=$3;
  var $5=(($4+1)|0);
  var $6=HEAP8[($5)];
  var $7=__ZL3SEThh(7, $6);
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=$9;
  var $11=(($10+1)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL12cpu_burn_z80P17legacy_cpu_devicei($device, $cycles) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $z80;
      var $n;
      $1=$device;
      $2=$cycles;
      var $3=$1;
      var $4=$3;
      var $5=__ZL14get_safe_tokenP8device_t305($4);
      $z80=$5;
      var $6=$2;
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+3)|0);
      var $11=(((($10)|0)/4)|0);
      $n=$11;
      var $12=$n;
      var $13=$z80;
      var $14=(($13+56)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=(($16+$12)|0);
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      var $19=$n;
      var $20=((($19<<2))|0);
      var $21=$z80;
      var $22=(($21+96)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-$20)|0);
      HEAP32[(($22)>>2)]=$24;
      __label__ = 2; break;
    case 2: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9save_itemIhLj4EEEvPKcS2_iRAT0__T_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=(($12)|0);
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 1, 4);
  ;
  return;
}


function __ZN19resource_pool_arrayIhEC1EPhi($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIhEC2EPhi($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIhEC2EPhi($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  var $8=(($7)|0);
  __ZN18resource_pool_itemC2EPvj($5, $6, $8);
  var $9=$4;
  HEAP32[(($9)>>2)]=((__ZTV19resource_pool_arrayIhE+8)|0);
  var $10=(($4+32)|0);
  var $11=$2;
  HEAP32[(($10)>>2)]=$11;
  var $12=(($4+36)|0);
  var $13=$3;
  HEAP32[(($12)>>2)]=$13;
  ;
  return;
}


function __ZN19resource_pool_arrayIhED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIhED2Ev($2);
  ;
  return;
}


function __ZL12set_irq_lineP10_z80_stateii($z80, $irqline, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$z80;
      $2=$irqline;
      $3=$state;
      var $4=$2;
      var $5=(($4)|0)==32;
      if ($5) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+63)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$3;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16+64)|0);
      HEAP8[($17)]=1;
      __label__ = 4; break;
    case 4: // $18
      var $19=$3;
      var $20=(($19) & 255);
      var $21=$1;
      var $22=(($21+63)|0);
      HEAP8[($22)]=$20;
      __label__ = 11; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24) & 255);
      var $26=$1;
      var $27=(($26+65)|0);
      HEAP8[($27)]=$25;
      var $28=$1;
      var $29=(($28+100)|0);
      var $30=__ZNK15z80_daisy_chain7presentEv($29);
      if ($30) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $31
      var $32=$1;
      var $33=(($32+100)|0);
      var $34=__ZN15z80_daisy_chain16update_irq_stateEv($33);
      var $35=(($34)|0)==1;
      if ($35) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $36
      var $43 = 1;__label__ = 9; break;
    case 8: // $37
      var $38=$1;
      var $39=(($38+65)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $43 = $41;__label__ = 9; break;
    case 9: // $42
      var $43;
      var $44=(($43) & 255);
      var $45=$1;
      var $46=(($45+65)|0);
      HEAP8[($46)]=$44;
      __label__ = 10; break;
    case 10: // $47
      __label__ = 11; break;
    case 11: // $48
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12set_irq_lineP10_z80_stateii["X"]=1;

function __ZN25device_z80daisy_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$mconfig;
  $3=$device;
  var $4=$1;
  var $5=$4;
  var $6=$3;
  __ZN16device_interfaceC2ER8device_t($5, $6);
  var $7=$4;
  HEAP32[(($7)>>2)]=((__ZTV25device_z80daisy_interface+8)|0);
  ;
  return;
}


function __ZN25device_z80daisy_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN16device_interfaceD2Ev($3);
  ;
  return;
}


function __ZN13resource_pool9add_arrayIhEEPT_S2_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIhEC1EPhi($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIhEEPT_S2_i["X"]=1;

function __ZN19resource_pool_arrayIhED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIhED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIhED0Ev["X"]=1;

function __ZN19resource_pool_arrayIhED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIhE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      var $13=$3;
      HEAP32[(($1)>>2)]=$8;
      var $14=HEAP32[(($1)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $16
      var $17=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      __label__ = 5; break;
    case 4: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      HEAP32[(($2)>>2)]=$21;
      var $22=$20.f1;
      HEAP32[(($3)>>2)]=$22;
      var $23=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($23);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $24=$1;
      var $25=$2;
      var $26=$3;
      __label__ = 6; break;
    case 6: // $27
      var $28=$5;
      __ZN18resource_pool_itemD2Ev($28);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN25device_z80daisy_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN25device_z80daisy_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN25device_z80daisy_interfaceD0Ev["X"]=1;

function __ZN15running_machine7respoolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  ;
  return $3;
}


function __ZN8device_t9interfaceI25device_z80daisy_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI25device_z80daisy_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15z80_daisy_chain5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $daisy;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      $daisy=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$daisy;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$daisy;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      __ZN8device_t5resetEv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$daisy;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      $daisy=$15;
      __label__ = 1; break;
    case 4: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15z80_daisy_chain16update_irq_stateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $daisy;
      var $state;
      $2=$this;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $daisy=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$daisy;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      var $10=$daisy;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+56)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      $state=$17;
      var $18=$state;
      var $19=$18 & 1;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      $1=1;
      __label__ = 9; break;
    case 4: // $22
      var $23=$state;
      var $24=$23 & 2;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      $1=0;
      __label__ = 9; break;
    case 6: // $27
      __label__ = 7; break;
    case 7: // $28
      var $29=$daisy;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      $daisy=$31;
      __label__ = 1; break;
    case 8: // $32
      $1=0;
      __label__ = 9; break;
    case 9: // $33
      var $34=$1;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15z80_daisy_chain15call_ack_deviceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $vector;
      var $daisy;
      var $state;
      $2=$this;
      var $3=$2;
      $vector=0;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $daisy=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$daisy;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$daisy;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+56)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      $state=$17;
      var $18=$daisy;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+60)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=FUNCTION_TABLE[$24]($20);
      $vector=$25;
      var $26=$state;
      var $27=$26 & 1;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$vector;
      $1=$30;
      __label__ = 7; break;
    case 4: // $31
      __label__ = 5; break;
    case 5: // $32
      var $33=$daisy;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      $daisy=$35;
      __label__ = 1; break;
    case 6: // $36
      __Z8logerrorPKcz(((STRING_TABLE.__str3310)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $37=$vector;
      $1=$37;
      __label__ = 7; break;
    case 7: // $38
      var $39=$1;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15z80_daisy_chain15call_ack_deviceEv["X"]=1;

function __ZN15z80_daisy_chain16call_reti_deviceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $daisy;
      var $state;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      $daisy=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$daisy;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$daisy;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+56)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      $state=$16;
      var $17=$state;
      var $18=$17 & 2;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$daisy;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+64)|0);
      var $27=HEAP32[(($26)>>2)];
      FUNCTION_TABLE[$27]($23);
      __label__ = 6; break;
    case 4: // $28
      __label__ = 5; break;
    case 5: // $29
      var $30=$daisy;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      $daisy=$32;
      __label__ = 1; break;
    case 6: // $33
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15z80_daisy_chain11daisy_entryC2EP8device_t($this, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$device;
  var $3=$1;
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($3+4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($3+8)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$2;
  var $9=(($3+8)|0);
  var $10=__ZN8device_t9interfaceI25device_z80daisy_interfaceEEbRPT_($8, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 12);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED2Ev($2);
  ;
  return;
}


function __ZN15z80_daisy_chain4initEP8device_tPK16z80_daisy_config($this, $cpudevice, $daisy) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $tailptr;
      var $target;
      var $intf=__stackBase__+36;
      var $12;
      var $13;
      $9=$this;
      $10=$cpudevice;
      $11=$daisy;
      var $14=$9;
      var $15=(($14)|0);
      $tailptr=$15;
      __label__ = 1; break;
    case 1: // $16
      var $17=$11;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $21
      var $22=$10;
      var $23=$11;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZNK8device_t13siblingdeviceEPKc($22, $25);
      $target=$26;
      var $27=$target;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$11;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str307)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,tempInt));
      throw "Reached an unreachable!"
    case 4: // $33
      var $34=$target;
      var $35=__ZN8device_t9interfaceI25device_z80daisy_interfaceEEbRPT_($34, $intf);
      if ($35) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $36
      var $37=$11;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1308)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt));
      throw "Reached an unreachable!"
    case 6: // $40
      var $41=$10;
      var $42=__ZNK8device_t7machineEv($41);
      var $43=__ZN15running_machine7respoolEv($42);
      var $44=$4;
      var $45=$5;
      var $46=$6;
      var $47=$result_i;
      var $48=$7;
      var $49=$8;
      HEAP32[(($4)>>2)]=12;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2309)|0);
      HEAP32[(($6)>>2)]=73;
      var $50=HEAP32[(($4)>>2)];
      var $51=HEAP32[(($5)>>2)];
      var $52=HEAP32[(($6)>>2)];
      var $53=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($50, $51, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $54
      HEAP32[(($result_i)>>2)]=$53;
      var $55=HEAP32[(($result_i)>>2)];
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $57
      var $58=___cxa_allocate_exception(4);
      var $59=$58;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($59);
      (function() { try { __THREW__ = false; return ___cxa_throw($58, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      HEAP32[(($7)>>2)]=$62;
      var $63=$61.f1;
      HEAP32[(($8)>>2)]=$63;
      var $64=HEAP32[(($8)>>2)];
      var $65=(($64)|0) < 0;
      if ($65) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $66
      var $67=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 11: // $68
      var $69=HEAP32[(($7)>>2)];
      var $70=HEAP32[(($7)>>2)];
      var $71=HEAP32[(($8)>>2)];
      var $72=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $70, tempValue);
      var $73=($72.f1 = $71, $72);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $74
      throw "Reached an unreachable!"
    case 13: // $_ZnwjPKci_exit
      var $75=HEAP32[(($result_i)>>2)];
      var $76=$4;
      var $77=$5;
      var $78=$6;
      var $79=$result_i;
      var $80=$7;
      var $81=$8;
      var $82=$75;
      var $83=$target;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15z80_daisy_chain11daisy_entryC1EP8device_t]($82, $83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $84
      var $85=__ZN13resource_pool10add_objectIN15z80_daisy_chain11daisy_entryEEEPT_S4_($43, $82);
      var $86=$tailptr;
      HEAP32[(($86)>>2)]=$85;
      var $87=$tailptr;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0);
      $tailptr=$89;
      __label__ = 15; break;
    case 15: // $90
      var $91=$11;
      var $92=(($91+4)|0);
      $11=$92;
      __label__ = 1; break;
    case 16: // $93
      var $94=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $95=$94.f0;
      $12=$95;
      var $96=$94.f1;
      $13=$96;
      var $97=$1;
      var $98=$2;
      var $99=$3;
      HEAP32[(($1)>>2)]=$75;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2309)|0);
      HEAP32[(($3)>>2)]=73;
      var $100=HEAP32[(($1)>>2)];
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $102
      var $103=HEAP32[(($1)>>2)];
      var $104=HEAP32[(($2)>>2)];
      var $105=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($103, $104, $105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $_noexc
      __label__ = 19; break;
    case 19: // $_ZdlPvPKci_exit
      var $106=$1;
      var $107=$2;
      var $108=$3;
      __label__ = 20; break;
    case 20: // $109
      __label__ = 22; break;
    case 21: // $110
      STACKTOP = __stackBase__;
      return;
    case 22: // $111
      var $112=$12;
      var $113=$12;
      var $114=$13;
      var $115=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $113, tempValue);
      var $116=($115.f1 = $114, $115);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15z80_daisy_chain4initEP8device_tPK16z80_daisy_config["X"]=1;

function __ZN13resource_pool10add_objectIN15z80_daisy_chain11daisy_entryEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN15z80_daisy_chain11daisy_entryEEEPT_S4_["X"]=1;

function __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20construct_core_typesR11simple_listI16input_type_entryE($typelist) {
  var __stackBase__  = STACKTOP; STACKTOP += 101504; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $80=__stackBase__+316;
      var $81=__stackBase__+320;
      var $82=__stackBase__+324;
      var $83=__stackBase__+328;
      var $84=__stackBase__+332;
      var $85=__stackBase__+336;
      var $86=__stackBase__+340;
      var $87=__stackBase__+344;
      var $88=__stackBase__+348;
      var $89=__stackBase__+352;
      var $90=__stackBase__+356;
      var $91=__stackBase__+360;
      var $92=__stackBase__+364;
      var $93=__stackBase__+368;
      var $94=__stackBase__+372;
      var $95=__stackBase__+376;
      var $96=__stackBase__+380;
      var $97=__stackBase__+384;
      var $98=__stackBase__+388;
      var $99=__stackBase__+392;
      var $100=__stackBase__+396;
      var $101=__stackBase__+400;
      var $102=__stackBase__+404;
      var $103=__stackBase__+408;
      var $104=__stackBase__+412;
      var $105=__stackBase__+416;
      var $106=__stackBase__+420;
      var $107=__stackBase__+424;
      var $108=__stackBase__+428;
      var $109=__stackBase__+432;
      var $110=__stackBase__+436;
      var $111=__stackBase__+440;
      var $112=__stackBase__+444;
      var $113=__stackBase__+448;
      var $114=__stackBase__+452;
      var $115=__stackBase__+456;
      var $116=__stackBase__+460;
      var $117=__stackBase__+464;
      var $118=__stackBase__+468;
      var $119=__stackBase__+472;
      var $120=__stackBase__+476;
      var $121=__stackBase__+480;
      var $122=__stackBase__+484;
      var $123=__stackBase__+488;
      var $124=__stackBase__+492;
      var $125=__stackBase__+496;
      var $126=__stackBase__+500;
      var $127=__stackBase__+504;
      var $128=__stackBase__+508;
      var $129=__stackBase__+512;
      var $130=__stackBase__+516;
      var $131=__stackBase__+520;
      var $132=__stackBase__+524;
      var $133=__stackBase__+528;
      var $134=__stackBase__+532;
      var $135=__stackBase__+536;
      var $136=__stackBase__+540;
      var $137=__stackBase__+544;
      var $138=__stackBase__+548;
      var $139=__stackBase__+552;
      var $140=__stackBase__+556;
      var $141=__stackBase__+560;
      var $142=__stackBase__+564;
      var $143=__stackBase__+568;
      var $144=__stackBase__+572;
      var $145=__stackBase__+576;
      var $146=__stackBase__+580;
      var $147=__stackBase__+584;
      var $148=__stackBase__+588;
      var $149=__stackBase__+592;
      var $150=__stackBase__+596;
      var $151=__stackBase__+600;
      var $152=__stackBase__+604;
      var $153=__stackBase__+608;
      var $154=__stackBase__+612;
      var $155=__stackBase__+616;
      var $156=__stackBase__+620;
      var $157=__stackBase__+624;
      var $158=__stackBase__+628;
      var $159=__stackBase__+632;
      var $160=__stackBase__+636;
      var $161=__stackBase__+640;
      var $162=__stackBase__+644;
      var $163=__stackBase__+648;
      var $164=__stackBase__+652;
      var $165=__stackBase__+656;
      var $166=__stackBase__+660;
      var $167=__stackBase__+664;
      var $168=__stackBase__+668;
      var $169=__stackBase__+672;
      var $170=__stackBase__+676;
      var $171=__stackBase__+680;
      var $172=__stackBase__+684;
      var $173=__stackBase__+688;
      var $174=__stackBase__+692;
      var $175=__stackBase__+696;
      var $176=__stackBase__+700;
      var $177=__stackBase__+704;
      var $178=__stackBase__+708;
      var $179=__stackBase__+712;
      var $180=__stackBase__+716;
      var $181=__stackBase__+720;
      var $182=__stackBase__+724;
      var $183=__stackBase__+728;
      var $184=__stackBase__+732;
      var $185=__stackBase__+736;
      var $186=__stackBase__+740;
      var $187=__stackBase__+744;
      var $188=__stackBase__+748;
      var $189=__stackBase__+752;
      var $190=__stackBase__+756;
      var $191=__stackBase__+760;
      var $192=__stackBase__+764;
      var $193=__stackBase__+768;
      var $194=__stackBase__+772;
      var $195=__stackBase__+776;
      var $196=__stackBase__+780;
      var $197=__stackBase__+784;
      var $198=__stackBase__+788;
      var $199=__stackBase__+792;
      var $200=__stackBase__+796;
      var $201=__stackBase__+800;
      var $202=__stackBase__+804;
      var $203=__stackBase__+808;
      var $204=__stackBase__+812;
      var $205=__stackBase__+816;
      var $206=__stackBase__+820;
      var $207=__stackBase__+824;
      var $208=__stackBase__+828;
      var $209=__stackBase__+832;
      var $210=__stackBase__+836;
      var $211=__stackBase__+840;
      var $212=__stackBase__+844;
      var $213=__stackBase__+848;
      var $214=__stackBase__+852;
      var $215=__stackBase__+856;
      var $216=__stackBase__+860;
      var $217=__stackBase__+864;
      var $218=__stackBase__+868;
      var $219=__stackBase__+872;
      var $220=__stackBase__+876;
      var $221=__stackBase__+880;
      var $222=__stackBase__+884;
      var $223=__stackBase__+888;
      var $224=__stackBase__+892;
      var $225=__stackBase__+896;
      var $226=__stackBase__+900;
      var $227=__stackBase__+904;
      var $228=__stackBase__+908;
      var $229=__stackBase__+912;
      var $230=__stackBase__+916;
      var $231=__stackBase__+920;
      var $232=__stackBase__+924;
      var $233=__stackBase__+928;
      var $234=__stackBase__+932;
      var $235=__stackBase__+936;
      var $236=__stackBase__+940;
      var $237=__stackBase__+944;
      var $238=__stackBase__+948;
      var $239=__stackBase__+952;
      var $240=__stackBase__+956;
      var $241=__stackBase__+960;
      var $242=__stackBase__+964;
      var $243=__stackBase__+968;
      var $244=__stackBase__+972;
      var $245=__stackBase__+976;
      var $246=__stackBase__+980;
      var $247=__stackBase__+984;
      var $248=__stackBase__+988;
      var $249=__stackBase__+992;
      var $250=__stackBase__+996;
      var $251=__stackBase__+1000;
      var $252=__stackBase__+1004;
      var $253=__stackBase__+1008;
      var $254=__stackBase__+1012;
      var $255=__stackBase__+1016;
      var $256=__stackBase__+1020;
      var $257=__stackBase__+1024;
      var $258=__stackBase__+1028;
      var $259=__stackBase__+1032;
      var $260=__stackBase__+1036;
      var $261=__stackBase__+1040;
      var $262=__stackBase__+1044;
      var $263=__stackBase__+1048;
      var $264=__stackBase__+1052;
      var $265=__stackBase__+1056;
      var $266=__stackBase__+1060;
      var $267=__stackBase__+1064;
      var $268=__stackBase__+1068;
      var $269=__stackBase__+1072;
      var $270=__stackBase__+1076;
      var $271=__stackBase__+1080;
      var $272=__stackBase__+1084;
      var $273=__stackBase__+1088;
      var $274=__stackBase__+1092;
      var $275=__stackBase__+1096;
      var $276=__stackBase__+1100;
      var $277=__stackBase__+1104;
      var $278=__stackBase__+1108;
      var $279=__stackBase__+1112;
      var $280=__stackBase__+1116;
      var $281=__stackBase__+1120;
      var $282=__stackBase__+1124;
      var $283=__stackBase__+1128;
      var $284=__stackBase__+1132;
      var $285=__stackBase__+1136;
      var $286=__stackBase__+1140;
      var $287=__stackBase__+1144;
      var $288=__stackBase__+1148;
      var $289=__stackBase__+1152;
      var $290=__stackBase__+1156;
      var $291=__stackBase__+1160;
      var $292=__stackBase__+1164;
      var $293=__stackBase__+1168;
      var $294=__stackBase__+1172;
      var $295=__stackBase__+1176;
      var $296=__stackBase__+1180;
      var $297=__stackBase__+1184;
      var $298=__stackBase__+1188;
      var $299=__stackBase__+1192;
      var $300=__stackBase__+1196;
      var $301=__stackBase__+1200;
      var $302=__stackBase__+1204;
      var $303=__stackBase__+1208;
      var $304=__stackBase__+1212;
      var $305=__stackBase__+1216;
      var $306=__stackBase__+1220;
      var $307=__stackBase__+1224;
      var $308=__stackBase__+1228;
      var $309=__stackBase__+1232;
      var $310=__stackBase__+1236;
      var $311=__stackBase__+1240;
      var $312=__stackBase__+1244;
      var $313=__stackBase__+1248;
      var $314=__stackBase__+1252;
      var $315=__stackBase__+1256;
      var $316=__stackBase__+1260;
      var $317=__stackBase__+1264;
      var $318=__stackBase__+1268;
      var $319=__stackBase__+1272;
      var $320=__stackBase__+1276;
      var $321=__stackBase__+1280;
      var $322=__stackBase__+1284;
      var $323=__stackBase__+1288;
      var $324=__stackBase__+1292;
      var $325=__stackBase__+1296;
      var $326=__stackBase__+1300;
      var $327=__stackBase__+1304;
      var $328=__stackBase__+1308;
      var $329=__stackBase__+1312;
      var $330=__stackBase__+1316;
      var $331=__stackBase__+1320;
      var $332=__stackBase__+1324;
      var $333=__stackBase__+1328;
      var $334=__stackBase__+1332;
      var $335=__stackBase__+1336;
      var $336=__stackBase__+1340;
      var $337=__stackBase__+1344;
      var $338=__stackBase__+1348;
      var $339=__stackBase__+1352;
      var $340=__stackBase__+1356;
      var $341=__stackBase__+1360;
      var $342=__stackBase__+1364;
      var $343=__stackBase__+1368;
      var $344=__stackBase__+1372;
      var $345=__stackBase__+1376;
      var $346=__stackBase__+1380;
      var $347=__stackBase__+1384;
      var $348=__stackBase__+1388;
      var $349=__stackBase__+1392;
      var $350=__stackBase__+1396;
      var $351=__stackBase__+1400;
      var $352=__stackBase__+1404;
      var $353=__stackBase__+1408;
      var $354=__stackBase__+1412;
      var $355=__stackBase__+1416;
      var $356=__stackBase__+1420;
      var $357=__stackBase__+1424;
      var $358=__stackBase__+1428;
      var $359=__stackBase__+1432;
      var $360=__stackBase__+1436;
      var $361=__stackBase__+1440;
      var $362=__stackBase__+1444;
      var $363=__stackBase__+1448;
      var $364=__stackBase__+1452;
      var $365=__stackBase__+1456;
      var $366=__stackBase__+1460;
      var $367=__stackBase__+1464;
      var $368=__stackBase__+1468;
      var $369=__stackBase__+1472;
      var $370=__stackBase__+1476;
      var $371=__stackBase__+1480;
      var $372=__stackBase__+1484;
      var $373=__stackBase__+1488;
      var $374=__stackBase__+1492;
      var $375=__stackBase__+1496;
      var $376=__stackBase__+1500;
      var $377=__stackBase__+1504;
      var $378=__stackBase__+1508;
      var $379=__stackBase__+1512;
      var $380=__stackBase__+1516;
      var $381=__stackBase__+1520;
      var $382=__stackBase__+1524;
      var $383=__stackBase__+1528;
      var $384=__stackBase__+1532;
      var $385=__stackBase__+1536;
      var $386=__stackBase__+1540;
      var $387=__stackBase__+1544;
      var $388=__stackBase__+1548;
      var $389=__stackBase__+1552;
      var $390=__stackBase__+1556;
      var $391=__stackBase__+1560;
      var $392=__stackBase__+1564;
      var $393=__stackBase__+1568;
      var $394=__stackBase__+1572;
      var $395=__stackBase__+1576;
      var $396=__stackBase__+1580;
      var $397=__stackBase__+1584;
      var $398=__stackBase__+1588;
      var $399=__stackBase__+1592;
      var $400=__stackBase__+1596;
      var $401=__stackBase__+1600;
      var $402=__stackBase__+1604;
      var $403=__stackBase__+1608;
      var $404=__stackBase__+1612;
      var $405=__stackBase__+1616;
      var $406=__stackBase__+1620;
      var $407=__stackBase__+1624;
      var $408=__stackBase__+1628;
      var $409=__stackBase__+1632;
      var $410=__stackBase__+1636;
      var $411=__stackBase__+1640;
      var $412=__stackBase__+1644;
      var $413=__stackBase__+1648;
      var $414=__stackBase__+1652;
      var $415=__stackBase__+1656;
      var $416=__stackBase__+1660;
      var $417=__stackBase__+1664;
      var $418=__stackBase__+1668;
      var $419=__stackBase__+1672;
      var $420=__stackBase__+1676;
      var $421=__stackBase__+1680;
      var $422=__stackBase__+1684;
      var $423=__stackBase__+1688;
      var $424=__stackBase__+1692;
      var $425=__stackBase__+1696;
      var $426=__stackBase__+1700;
      var $427=__stackBase__+1704;
      var $428=__stackBase__+1708;
      var $429=__stackBase__+1712;
      var $430=__stackBase__+1716;
      var $431=__stackBase__+1720;
      var $432=__stackBase__+1724;
      var $433=__stackBase__+1728;
      var $434=__stackBase__+1732;
      var $435=__stackBase__+1736;
      var $436=__stackBase__+1740;
      var $437=__stackBase__+1744;
      var $438=__stackBase__+1748;
      var $439=__stackBase__+1752;
      var $440=__stackBase__+1756;
      var $441=__stackBase__+1760;
      var $442=__stackBase__+1764;
      var $443=__stackBase__+1768;
      var $444=__stackBase__+1772;
      var $445=__stackBase__+1776;
      var $446=__stackBase__+1780;
      var $447=__stackBase__+1784;
      var $448=__stackBase__+1788;
      var $449=__stackBase__+1792;
      var $450=__stackBase__+1796;
      var $451=__stackBase__+1800;
      var $452=__stackBase__+1804;
      var $453=__stackBase__+1808;
      var $454=__stackBase__+1812;
      var $455=__stackBase__+1816;
      var $456=__stackBase__+1820;
      var $457=__stackBase__+1824;
      var $458=__stackBase__+1828;
      var $459=__stackBase__+1832;
      var $460=__stackBase__+1836;
      var $461=__stackBase__+1840;
      var $462=__stackBase__+1844;
      var $463=__stackBase__+1848;
      var $464=__stackBase__+1852;
      var $465=__stackBase__+1856;
      var $466=__stackBase__+1860;
      var $467=__stackBase__+1864;
      var $468=__stackBase__+1868;
      var $469=__stackBase__+1872;
      var $470=__stackBase__+1876;
      var $471=__stackBase__+1880;
      var $472=__stackBase__+1884;
      var $473=__stackBase__+1888;
      var $474=__stackBase__+1892;
      var $475=__stackBase__+1896;
      var $476=__stackBase__+1900;
      var $477=__stackBase__+1904;
      var $478=__stackBase__+1908;
      var $479=__stackBase__+1912;
      var $480=__stackBase__+1916;
      var $481=__stackBase__+1920;
      var $482=__stackBase__+1924;
      var $483=__stackBase__+1928;
      var $484=__stackBase__+1932;
      var $485=__stackBase__+1936;
      var $486=__stackBase__+1940;
      var $487=__stackBase__+1944;
      var $488=__stackBase__+1948;
      var $489=__stackBase__+1952;
      var $490=__stackBase__+1956;
      var $491=__stackBase__+1960;
      var $492=__stackBase__+1964;
      var $493=__stackBase__+1968;
      var $494=__stackBase__+1972;
      var $495=__stackBase__+1976;
      var $496=__stackBase__+1980;
      var $497=__stackBase__+1984;
      var $498=__stackBase__+1988;
      var $499=__stackBase__+1992;
      var $500=__stackBase__+1996;
      var $501=__stackBase__+2000;
      var $502=__stackBase__+2004;
      var $503=__stackBase__+2008;
      var $504=__stackBase__+2012;
      var $505=__stackBase__+2016;
      var $506=__stackBase__+2020;
      var $507=__stackBase__+2024;
      var $508=__stackBase__+2028;
      var $509=__stackBase__+2032;
      var $510=__stackBase__+2036;
      var $511=__stackBase__+2040;
      var $512=__stackBase__+2044;
      var $513=__stackBase__+2048;
      var $514=__stackBase__+2052;
      var $515=__stackBase__+2056;
      var $516=__stackBase__+2060;
      var $517=__stackBase__+2064;
      var $518=__stackBase__+2068;
      var $519=__stackBase__+2072;
      var $520=__stackBase__+2076;
      var $521=__stackBase__+2080;
      var $522=__stackBase__+2084;
      var $523=__stackBase__+2088;
      var $524=__stackBase__+2092;
      var $525=__stackBase__+2096;
      var $526=__stackBase__+2100;
      var $527=__stackBase__+2104;
      var $528=__stackBase__+2108;
      var $529=__stackBase__+2112;
      var $530=__stackBase__+2116;
      var $531=__stackBase__+2120;
      var $532=__stackBase__+2124;
      var $533=__stackBase__+2128;
      var $534=__stackBase__+2132;
      var $535=__stackBase__+2136;
      var $536=__stackBase__+2140;
      var $537=__stackBase__+2144;
      var $538=__stackBase__+2148;
      var $539=__stackBase__+2152;
      var $540=__stackBase__+2156;
      var $541=__stackBase__+2160;
      var $542=__stackBase__+2164;
      var $543=__stackBase__+2168;
      var $544=__stackBase__+2172;
      var $545=__stackBase__+2176;
      var $546=__stackBase__+2180;
      var $547=__stackBase__+2184;
      var $548=__stackBase__+2188;
      var $549=__stackBase__+2192;
      var $550=__stackBase__+2196;
      var $551=__stackBase__+2200;
      var $552=__stackBase__+2204;
      var $553=__stackBase__+2208;
      var $554=__stackBase__+2212;
      var $555=__stackBase__+2216;
      var $556=__stackBase__+2220;
      var $557=__stackBase__+2224;
      var $558=__stackBase__+2228;
      var $559=__stackBase__+2232;
      var $560=__stackBase__+2236;
      var $561=__stackBase__+2240;
      var $562=__stackBase__+2244;
      var $563=__stackBase__+2248;
      var $564=__stackBase__+2252;
      var $565=__stackBase__+2256;
      var $566=__stackBase__+2260;
      var $567=__stackBase__+2264;
      var $568=__stackBase__+2268;
      var $569=__stackBase__+2272;
      var $570=__stackBase__+2276;
      var $571=__stackBase__+2280;
      var $572=__stackBase__+2284;
      var $573=__stackBase__+2288;
      var $574=__stackBase__+2292;
      var $575=__stackBase__+2296;
      var $576=__stackBase__+2300;
      var $577=__stackBase__+2304;
      var $578=__stackBase__+2308;
      var $579=__stackBase__+2312;
      var $580=__stackBase__+2316;
      var $581=__stackBase__+2320;
      var $582=__stackBase__+2324;
      var $583=__stackBase__+2328;
      var $584=__stackBase__+2332;
      var $585=__stackBase__+2336;
      var $586=__stackBase__+2340;
      var $587=__stackBase__+2344;
      var $588=__stackBase__+2348;
      var $589=__stackBase__+2352;
      var $590=__stackBase__+2356;
      var $591=__stackBase__+2360;
      var $592=__stackBase__+2364;
      var $593=__stackBase__+2368;
      var $594=__stackBase__+2372;
      var $595=__stackBase__+2376;
      var $596=__stackBase__+2380;
      var $597=__stackBase__+2384;
      var $598=__stackBase__+2388;
      var $599=__stackBase__+2392;
      var $600=__stackBase__+2396;
      var $601=__stackBase__+2400;
      var $602=__stackBase__+2404;
      var $603=__stackBase__+2408;
      var $604=__stackBase__+2412;
      var $605=__stackBase__+2416;
      var $606=__stackBase__+2420;
      var $607=__stackBase__+2424;
      var $608=__stackBase__+2428;
      var $609=__stackBase__+2432;
      var $610=__stackBase__+2436;
      var $611=__stackBase__+2440;
      var $612=__stackBase__+2444;
      var $613=__stackBase__+2448;
      var $614=__stackBase__+2452;
      var $615=__stackBase__+2456;
      var $616=__stackBase__+2460;
      var $617=__stackBase__+2464;
      var $618=__stackBase__+2468;
      var $619=__stackBase__+2472;
      var $620=__stackBase__+2476;
      var $621=__stackBase__+2480;
      var $622=__stackBase__+2484;
      var $623=__stackBase__+2488;
      var $624=__stackBase__+2492;
      var $625=__stackBase__+2496;
      var $626=__stackBase__+2500;
      var $627=__stackBase__+2504;
      var $628=__stackBase__+2508;
      var $629=__stackBase__+2512;
      var $630=__stackBase__+2516;
      var $631=__stackBase__+2520;
      var $632=__stackBase__+2524;
      var $633=__stackBase__+2528;
      var $634=__stackBase__+2532;
      var $635=__stackBase__+2536;
      var $636=__stackBase__+2540;
      var $637=__stackBase__+2544;
      var $638=__stackBase__+2548;
      var $639=__stackBase__+2552;
      var $640=__stackBase__+2556;
      var $641=__stackBase__+2560;
      var $642=__stackBase__+2564;
      var $643=__stackBase__+2568;
      var $644=__stackBase__+2572;
      var $645=__stackBase__+2576;
      var $646=__stackBase__+2580;
      var $647=__stackBase__+2584;
      var $648=__stackBase__+2588;
      var $649=__stackBase__+2592;
      var $650=__stackBase__+2596;
      var $651=__stackBase__+2600;
      var $652=__stackBase__+2604;
      var $653=__stackBase__+2608;
      var $654=__stackBase__+2612;
      var $655=__stackBase__+2616;
      var $656=__stackBase__+2620;
      var $657=__stackBase__+2624;
      var $658=__stackBase__+2628;
      var $659=__stackBase__+2632;
      var $660=__stackBase__+2636;
      var $661=__stackBase__+2640;
      var $662=__stackBase__+2644;
      var $663=__stackBase__+2648;
      var $664=__stackBase__+2652;
      var $665=__stackBase__+2656;
      var $666=__stackBase__+2660;
      var $667=__stackBase__+2664;
      var $668=__stackBase__+2668;
      var $669=__stackBase__+2672;
      var $670=__stackBase__+2676;
      var $671=__stackBase__+2680;
      var $672=__stackBase__+2684;
      var $673=__stackBase__+2688;
      var $674=__stackBase__+2692;
      var $675=__stackBase__+2696;
      var $676=__stackBase__+2700;
      var $677=__stackBase__+2704;
      var $678=__stackBase__+2708;
      var $679=__stackBase__+2712;
      var $680=__stackBase__+2716;
      var $681=__stackBase__+2720;
      var $682=__stackBase__+2724;
      var $683=__stackBase__+2728;
      var $684=__stackBase__+2732;
      var $685=__stackBase__+2736;
      var $686=__stackBase__+2740;
      var $687=__stackBase__+2744;
      var $688=__stackBase__+2748;
      var $689=__stackBase__+2752;
      var $690=__stackBase__+2756;
      var $691=__stackBase__+2760;
      var $692=__stackBase__+2764;
      var $693=__stackBase__+2768;
      var $694=__stackBase__+2772;
      var $695=__stackBase__+2776;
      var $696=__stackBase__+2780;
      var $697=__stackBase__+2784;
      var $698=__stackBase__+2788;
      var $699=__stackBase__+2792;
      var $700=__stackBase__+2796;
      var $701=__stackBase__+2800;
      var $702=__stackBase__+2804;
      var $703=__stackBase__+2808;
      var $704=__stackBase__+2812;
      var $705=__stackBase__+2816;
      var $706=__stackBase__+2820;
      var $707=__stackBase__+2824;
      var $708=__stackBase__+2828;
      var $709=__stackBase__+2832;
      var $710=__stackBase__+2836;
      var $711=__stackBase__+2840;
      var $712=__stackBase__+2844;
      var $713=__stackBase__+2848;
      var $714=__stackBase__+2852;
      var $715=__stackBase__+2856;
      var $716=__stackBase__+2860;
      var $717=__stackBase__+2864;
      var $718=__stackBase__+2868;
      var $719=__stackBase__+2872;
      var $720=__stackBase__+2876;
      var $721=__stackBase__+2880;
      var $722=__stackBase__+2884;
      var $723=__stackBase__+2888;
      var $724=__stackBase__+2892;
      var $725=__stackBase__+2896;
      var $726=__stackBase__+2900;
      var $727=__stackBase__+2904;
      var $728=__stackBase__+2908;
      var $729=__stackBase__+2912;
      var $730=__stackBase__+2916;
      var $731=__stackBase__+2920;
      var $732=__stackBase__+2924;
      var $733=__stackBase__+2928;
      var $734=__stackBase__+2932;
      var $735=__stackBase__+2936;
      var $736=__stackBase__+2940;
      var $737=__stackBase__+2944;
      var $738=__stackBase__+2948;
      var $739=__stackBase__+2952;
      var $740=__stackBase__+2956;
      var $741=__stackBase__+2960;
      var $742=__stackBase__+2964;
      var $743=__stackBase__+2968;
      var $744=__stackBase__+2972;
      var $745=__stackBase__+2976;
      var $746=__stackBase__+2980;
      var $747=__stackBase__+2984;
      var $748=__stackBase__+2988;
      var $749=__stackBase__+2992;
      var $750=__stackBase__+2996;
      var $751=__stackBase__+3000;
      var $752=__stackBase__+3004;
      var $753=__stackBase__+3008;
      var $754=__stackBase__+3012;
      var $755=__stackBase__+3016;
      var $756=__stackBase__+3020;
      var $757=__stackBase__+3024;
      var $758=__stackBase__+3028;
      var $759=__stackBase__+3032;
      var $760=__stackBase__+3036;
      var $761=__stackBase__+3040;
      var $762=__stackBase__+3044;
      var $763=__stackBase__+3048;
      var $764=__stackBase__+3052;
      var $765=__stackBase__+3056;
      var $766=__stackBase__+3060;
      var $767=__stackBase__+3064;
      var $768=__stackBase__+3068;
      var $769=__stackBase__+3072;
      var $770=__stackBase__+3076;
      var $771=__stackBase__+3080;
      var $772=__stackBase__+3084;
      var $773=__stackBase__+3088;
      var $774=__stackBase__+3092;
      var $775=__stackBase__+3096;
      var $776=__stackBase__+3100;
      var $777=__stackBase__+3104;
      var $778=__stackBase__+3108;
      var $779=__stackBase__+3112;
      var $780=__stackBase__+3116;
      var $781=__stackBase__+3120;
      var $782=__stackBase__+3124;
      var $783=__stackBase__+3128;
      var $784=__stackBase__+3132;
      var $785=__stackBase__+3136;
      var $786=__stackBase__+3140;
      var $787=__stackBase__+3144;
      var $788=__stackBase__+3148;
      var $789=__stackBase__+3152;
      var $790=__stackBase__+3156;
      var $791=__stackBase__+3160;
      var $792=__stackBase__+3164;
      var $793=__stackBase__+3168;
      var $794=__stackBase__+3172;
      var $795=__stackBase__+3176;
      var $796=__stackBase__+3180;
      var $797=__stackBase__+3184;
      var $798=__stackBase__+3188;
      var $799=__stackBase__+3192;
      var $800=__stackBase__+3196;
      var $801=__stackBase__+3200;
      var $802=__stackBase__+3204;
      var $803=__stackBase__+3208;
      var $804=__stackBase__+3212;
      var $805=__stackBase__+3216;
      var $806=__stackBase__+3220;
      var $807=__stackBase__+3224;
      var $808=__stackBase__+3228;
      var $809=__stackBase__+3232;
      var $810=__stackBase__+3236;
      var $811=__stackBase__+3240;
      var $812=__stackBase__+3244;
      var $813=__stackBase__+3248;
      var $814=__stackBase__+3252;
      var $815=__stackBase__+3256;
      var $816=__stackBase__+3260;
      var $817=__stackBase__+3264;
      var $818=__stackBase__+3268;
      var $819=__stackBase__+3272;
      var $820=__stackBase__+3276;
      var $821=__stackBase__+3280;
      var $822=__stackBase__+3284;
      var $823=__stackBase__+3288;
      var $824=__stackBase__+3292;
      var $825=__stackBase__+3296;
      var $826=__stackBase__+3300;
      var $827=__stackBase__+3304;
      var $828=__stackBase__+3308;
      var $829=__stackBase__+3312;
      var $830=__stackBase__+3316;
      var $831=__stackBase__+3320;
      var $832=__stackBase__+3324;
      var $833=__stackBase__+3328;
      var $834=__stackBase__+3332;
      var $835=__stackBase__+3336;
      var $836=__stackBase__+3340;
      var $837=__stackBase__+3344;
      var $838=__stackBase__+3348;
      var $839=__stackBase__+3352;
      var $840=__stackBase__+3356;
      var $841=__stackBase__+3360;
      var $842=__stackBase__+3364;
      var $843=__stackBase__+3368;
      var $844=__stackBase__+3372;
      var $845=__stackBase__+3376;
      var $846=__stackBase__+3380;
      var $847=__stackBase__+3384;
      var $848=__stackBase__+3388;
      var $849=__stackBase__+3392;
      var $850=__stackBase__+3396;
      var $851=__stackBase__+3400;
      var $852=__stackBase__+3404;
      var $853=__stackBase__+3408;
      var $854=__stackBase__+3412;
      var $855=__stackBase__+3416;
      var $856=__stackBase__+3420;
      var $857=__stackBase__+3424;
      var $858=__stackBase__+3428;
      var $859=__stackBase__+3432;
      var $860=__stackBase__+3436;
      var $861=__stackBase__+3440;
      var $862=__stackBase__+3444;
      var $863=__stackBase__+3448;
      var $864=__stackBase__+3452;
      var $865=__stackBase__+3456;
      var $866=__stackBase__+3460;
      var $867=__stackBase__+3464;
      var $868=__stackBase__+3468;
      var $869=__stackBase__+3472;
      var $870=__stackBase__+3476;
      var $871=__stackBase__+3480;
      var $872=__stackBase__+3484;
      var $873=__stackBase__+3488;
      var $874=__stackBase__+3492;
      var $875=__stackBase__+3496;
      var $876=__stackBase__+3500;
      var $877=__stackBase__+3504;
      var $878=__stackBase__+3508;
      var $879=__stackBase__+3512;
      var $880=__stackBase__+3516;
      var $881=__stackBase__+3520;
      var $882=__stackBase__+3524;
      var $883=__stackBase__+3528;
      var $884=__stackBase__+3532;
      var $885=__stackBase__+3536;
      var $886=__stackBase__+3540;
      var $887=__stackBase__+3544;
      var $888=__stackBase__+3548;
      var $889=__stackBase__+3552;
      var $890=__stackBase__+3556;
      var $891=__stackBase__+3560;
      var $892=__stackBase__+3564;
      var $893=__stackBase__+3568;
      var $894=__stackBase__+3572;
      var $895=__stackBase__+3576;
      var $896=__stackBase__+3580;
      var $897=__stackBase__+3584;
      var $898=__stackBase__+3588;
      var $899=__stackBase__+3592;
      var $900=__stackBase__+3596;
      var $901=__stackBase__+3600;
      var $902=__stackBase__+3604;
      var $903=__stackBase__+3608;
      var $904=__stackBase__+3612;
      var $905=__stackBase__+3616;
      var $906=__stackBase__+3620;
      var $907=__stackBase__+3624;
      var $908=__stackBase__+3628;
      var $909=__stackBase__+3632;
      var $910=__stackBase__+3636;
      var $911=__stackBase__+3640;
      var $912=__stackBase__+3644;
      var $913=__stackBase__+3648;
      var $914=__stackBase__+3652;
      var $915=__stackBase__+3656;
      var $916=__stackBase__+3660;
      var $917=__stackBase__+3664;
      var $918=__stackBase__+3668;
      var $919=__stackBase__+3672;
      var $920=__stackBase__+3676;
      var $921=__stackBase__+3680;
      var $922=__stackBase__+3684;
      var $923=__stackBase__+3688;
      var $924=__stackBase__+3692;
      var $925=__stackBase__+3696;
      var $926=__stackBase__+3700;
      var $927=__stackBase__+3704;
      var $928=__stackBase__+3708;
      var $929=__stackBase__+3712;
      var $930=__stackBase__+3716;
      var $931=__stackBase__+3720;
      var $932=__stackBase__+3724;
      var $933=__stackBase__+3728;
      var $934=__stackBase__+3732;
      var $935=__stackBase__+3736;
      var $936=__stackBase__+3740;
      var $937=__stackBase__+3744;
      var $938=__stackBase__+3748;
      var $939=__stackBase__+3752;
      var $940=__stackBase__+3756;
      var $941=__stackBase__+3760;
      var $942=__stackBase__+3764;
      var $943=__stackBase__+3768;
      var $944=__stackBase__+3772;
      var $945=__stackBase__+3776;
      var $946=__stackBase__+3780;
      var $947=__stackBase__+3784;
      var $948=__stackBase__+3788;
      var $949=__stackBase__+3792;
      var $950=__stackBase__+3796;
      var $951=__stackBase__+3800;
      var $952=__stackBase__+3804;
      var $953=__stackBase__+3808;
      var $954=__stackBase__+3812;
      var $955=__stackBase__+3816;
      var $956=__stackBase__+3820;
      var $957=__stackBase__+3824;
      var $958=__stackBase__+3828;
      var $959=__stackBase__+3832;
      var $960=__stackBase__+3836;
      var $961=__stackBase__+3840;
      var $962=__stackBase__+3844;
      var $963=__stackBase__+3848;
      var $964=__stackBase__+3852;
      var $965=__stackBase__+3856;
      var $966=__stackBase__+3860;
      var $967=__stackBase__+3864;
      var $968=__stackBase__+3868;
      var $969=__stackBase__+3872;
      var $970=__stackBase__+3876;
      var $971=__stackBase__+3880;
      var $972=__stackBase__+3884;
      var $973=__stackBase__+3888;
      var $974=__stackBase__+3892;
      var $975=__stackBase__+3896;
      var $976=__stackBase__+3900;
      var $977=__stackBase__+3904;
      var $978=__stackBase__+3908;
      var $979=__stackBase__+3912;
      var $980=__stackBase__+3916;
      var $981=__stackBase__+3920;
      var $982=__stackBase__+3924;
      var $983=__stackBase__+3928;
      var $984=__stackBase__+3932;
      var $985=__stackBase__+3936;
      var $986=__stackBase__+3940;
      var $987=__stackBase__+3944;
      var $988=__stackBase__+3948;
      var $989=__stackBase__+3952;
      var $990=__stackBase__+3956;
      var $991=__stackBase__+3960;
      var $992=__stackBase__+3964;
      var $993=__stackBase__+3968;
      var $994=__stackBase__+3972;
      var $995=__stackBase__+3976;
      var $996=__stackBase__+3980;
      var $997=__stackBase__+3984;
      var $998=__stackBase__+3988;
      var $999=__stackBase__+3992;
      var $1000=__stackBase__+3996;
      var $1001=__stackBase__+4000;
      var $1002=__stackBase__+4004;
      var $1003=__stackBase__+4008;
      var $1004=__stackBase__+4012;
      var $1005=__stackBase__+4016;
      var $1006=__stackBase__+4020;
      var $1007=__stackBase__+4024;
      var $1008=__stackBase__+4028;
      var $1009=__stackBase__+4032;
      var $1010=__stackBase__+4036;
      var $1011=__stackBase__+4040;
      var $1012=__stackBase__+4044;
      var $1013=__stackBase__+4048;
      var $1014=__stackBase__+4052;
      var $1015=__stackBase__+4056;
      var $1016=__stackBase__+4060;
      var $1017=__stackBase__+4064;
      var $1018=__stackBase__+4068;
      var $1019=__stackBase__+4072;
      var $1020=__stackBase__+4076;
      var $1021=__stackBase__+4080;
      var $1022=__stackBase__+4084;
      var $1023=__stackBase__+4088;
      var $1024=__stackBase__+4092;
      var $1025=__stackBase__+4096;
      var $1026=__stackBase__+4100;
      var $1027=__stackBase__+4104;
      var $1028=__stackBase__+4108;
      var $1029=__stackBase__+4112;
      var $1030=__stackBase__+4116;
      var $1031=__stackBase__+4120;
      var $1032=__stackBase__+4124;
      var $1033=__stackBase__+4128;
      var $1034=__stackBase__+4132;
      var $1035=__stackBase__+4136;
      var $1036=__stackBase__+4140;
      var $1037=__stackBase__+4144;
      var $1038=__stackBase__+4148;
      var $1039=__stackBase__+4152;
      var $1040=__stackBase__+4156;
      var $1041=__stackBase__+4160;
      var $1042=__stackBase__+4164;
      var $1043=__stackBase__+4168;
      var $1044=__stackBase__+4172;
      var $1045=__stackBase__+4176;
      var $1046=__stackBase__+4180;
      var $1047=__stackBase__+4184;
      var $1048=__stackBase__+4188;
      var $1049=__stackBase__+4192;
      var $1050=__stackBase__+4196;
      var $1051=__stackBase__+4200;
      var $1052=__stackBase__+4204;
      var $1053=__stackBase__+4208;
      var $1054=__stackBase__+4212;
      var $1055=__stackBase__+4216;
      var $1056=__stackBase__+4220;
      var $1057=__stackBase__+4224;
      var $1058=__stackBase__+4228;
      var $1059=__stackBase__+4232;
      var $1060=__stackBase__+4236;
      var $1061=__stackBase__+4240;
      var $1062=__stackBase__+4244;
      var $1063=__stackBase__+4248;
      var $1064=__stackBase__+4252;
      var $1065=__stackBase__+4256;
      var $1066=__stackBase__+4260;
      var $1067=__stackBase__+4264;
      var $1068=__stackBase__+4268;
      var $1069=__stackBase__+4272;
      var $1070=__stackBase__+4276;
      var $1071=__stackBase__+4280;
      var $1072=__stackBase__+4284;
      var $1073=__stackBase__+4288;
      var $1074=__stackBase__+4292;
      var $1075=__stackBase__+4296;
      var $1076=__stackBase__+4300;
      var $1077=__stackBase__+4304;
      var $1078=__stackBase__+4308;
      var $1079=__stackBase__+4312;
      var $1080=__stackBase__+4316;
      var $1081=__stackBase__+4320;
      var $1082=__stackBase__+4324;
      var $1083=__stackBase__+4328;
      var $1084=__stackBase__+4332;
      var $1085=__stackBase__+4336;
      var $1086=__stackBase__+4340;
      var $1087=__stackBase__+4344;
      var $1088=__stackBase__+4348;
      var $1089=__stackBase__+4352;
      var $1090=__stackBase__+4356;
      var $1091=__stackBase__+4360;
      var $1092=__stackBase__+4364;
      var $1093=__stackBase__+4368;
      var $1094=__stackBase__+4372;
      var $1095=__stackBase__+4376;
      var $1096=__stackBase__+4380;
      var $1097=__stackBase__+4384;
      var $1098=__stackBase__+4388;
      var $1099=__stackBase__+4392;
      var $1100=__stackBase__+4396;
      var $1101=__stackBase__+4400;
      var $1102=__stackBase__+4404;
      var $1103=__stackBase__+4408;
      var $1104=__stackBase__+4412;
      var $1105=__stackBase__+4416;
      var $1106=__stackBase__+4420;
      var $1107=__stackBase__+4424;
      var $1108=__stackBase__+4428;
      var $1109=__stackBase__+4432;
      var $1110=__stackBase__+4436;
      var $1111=__stackBase__+4440;
      var $1112=__stackBase__+4444;
      var $1113=__stackBase__+4448;
      var $1114=__stackBase__+4452;
      var $1115=__stackBase__+4456;
      var $1116=__stackBase__+4460;
      var $1117=__stackBase__+4464;
      var $1118=__stackBase__+4468;
      var $1119=__stackBase__+4472;
      var $1120=__stackBase__+4476;
      var $1121=__stackBase__+4480;
      var $1122=__stackBase__+4484;
      var $1123=__stackBase__+4488;
      var $1124=__stackBase__+4492;
      var $1125=__stackBase__+4496;
      var $1126=__stackBase__+4500;
      var $1127=__stackBase__+4504;
      var $1128=__stackBase__+4508;
      var $1129=__stackBase__+4512;
      var $1130=__stackBase__+4516;
      var $1131=__stackBase__+4520;
      var $1132=__stackBase__+4524;
      var $1133=__stackBase__+4528;
      var $1134=__stackBase__+4532;
      var $1135=__stackBase__+4536;
      var $1136=__stackBase__+4540;
      var $1137=__stackBase__+4544;
      var $1138=__stackBase__+4548;
      var $1139=__stackBase__+4552;
      var $1140=__stackBase__+4556;
      var $1141=__stackBase__+4560;
      var $1142=__stackBase__+4564;
      var $1143=__stackBase__+4568;
      var $1144=__stackBase__+4572;
      var $1145=__stackBase__+4576;
      var $1146=__stackBase__+4580;
      var $1147=__stackBase__+4584;
      var $1148=__stackBase__+4588;
      var $1149=__stackBase__+4592;
      var $1150=__stackBase__+4596;
      var $1151=__stackBase__+4600;
      var $1152=__stackBase__+4604;
      var $1153=__stackBase__+4608;
      var $1154=__stackBase__+4612;
      var $1155=__stackBase__+4616;
      var $1156=__stackBase__+4620;
      var $1157=__stackBase__+4624;
      var $1158=__stackBase__+4628;
      var $1159=__stackBase__+4632;
      var $1160=__stackBase__+4636;
      var $1161=__stackBase__+4640;
      var $1162=__stackBase__+4644;
      var $1163=__stackBase__+4648;
      var $1164=__stackBase__+4652;
      var $1165=__stackBase__+4656;
      var $1166=__stackBase__+4660;
      var $1167=__stackBase__+4664;
      var $1168=__stackBase__+4668;
      var $1169=__stackBase__+4672;
      var $1170=__stackBase__+4676;
      var $1171=__stackBase__+4680;
      var $1172=__stackBase__+4684;
      var $1173=__stackBase__+4688;
      var $1174=__stackBase__+4692;
      var $1175=__stackBase__+4696;
      var $1176=__stackBase__+4700;
      var $1177=__stackBase__+4704;
      var $1178=__stackBase__+4708;
      var $1179=__stackBase__+4712;
      var $1180=__stackBase__+4716;
      var $1181=__stackBase__+4720;
      var $1182=__stackBase__+4724;
      var $1183=__stackBase__+4728;
      var $1184=__stackBase__+4732;
      var $1185=__stackBase__+4736;
      var $1186=__stackBase__+4740;
      var $1187=__stackBase__+4744;
      var $1188=__stackBase__+4748;
      var $1189=__stackBase__+4752;
      var $1190=__stackBase__+4756;
      var $1191=__stackBase__+4760;
      var $1192=__stackBase__+4764;
      var $1193=__stackBase__+4768;
      var $1194=__stackBase__+4772;
      var $1195=__stackBase__+4776;
      var $1196=__stackBase__+4780;
      var $1197=__stackBase__+4784;
      var $1198=__stackBase__+4788;
      var $1199=__stackBase__+4792;
      var $1200=__stackBase__+4796;
      var $1201=__stackBase__+4800;
      var $1202=__stackBase__+4804;
      var $1203=__stackBase__+4808;
      var $1204=__stackBase__+4812;
      var $1205=__stackBase__+4816;
      var $1206=__stackBase__+4820;
      var $1207=__stackBase__+4824;
      var $1208=__stackBase__+4828;
      var $1209=__stackBase__+4832;
      var $1210=__stackBase__+4836;
      var $1211=__stackBase__+4840;
      var $1212=__stackBase__+4844;
      var $1213=__stackBase__+4848;
      var $1214=__stackBase__+4852;
      var $1215=__stackBase__+4856;
      var $1216=__stackBase__+4860;
      var $1217=__stackBase__+4864;
      var $1218=__stackBase__+4868;
      var $1219=__stackBase__+4872;
      var $1220=__stackBase__+4876;
      var $1221=__stackBase__+4880;
      var $1222=__stackBase__+4884;
      var $1223=__stackBase__+4888;
      var $1224=__stackBase__+4892;
      var $1225=__stackBase__+4896;
      var $1226=__stackBase__+4900;
      var $1227=__stackBase__+4904;
      var $1228=__stackBase__+4908;
      var $1229=__stackBase__+4912;
      var $1230=__stackBase__+4916;
      var $1231=__stackBase__+4920;
      var $1232=__stackBase__+4924;
      var $1233=__stackBase__+4928;
      var $1234=__stackBase__+4932;
      var $1235=__stackBase__+4936;
      var $1236=__stackBase__+4940;
      var $1237=__stackBase__+4944;
      var $1238=__stackBase__+4948;
      var $1239=__stackBase__+4952;
      var $1240=__stackBase__+4956;
      var $1241=__stackBase__+4960;
      var $1242=__stackBase__+4964;
      var $1243=__stackBase__+4968;
      var $1244=__stackBase__+4972;
      var $1245=__stackBase__+4976;
      var $1246=__stackBase__+4980;
      var $1247=__stackBase__+4984;
      var $1248=__stackBase__+4988;
      var $1249=__stackBase__+4992;
      var $1250=__stackBase__+4996;
      var $1251=__stackBase__+5000;
      var $1252=__stackBase__+5004;
      var $1253=__stackBase__+5008;
      var $1254=__stackBase__+5012;
      var $1255=__stackBase__+5016;
      var $1256=__stackBase__+5020;
      var $1257=__stackBase__+5024;
      var $1258=__stackBase__+5028;
      var $1259=__stackBase__+5032;
      var $1260=__stackBase__+5036;
      var $1261=__stackBase__+5040;
      var $1262=__stackBase__+5044;
      var $1263=__stackBase__+5048;
      var $1264=__stackBase__+5052;
      var $1265=__stackBase__+5056;
      var $1266=__stackBase__+5060;
      var $1267=__stackBase__+5064;
      var $1268=__stackBase__+5068;
      var $1269=__stackBase__+5072;
      var $1270=__stackBase__+5076;
      var $1271=__stackBase__+5080;
      var $1272=__stackBase__+5084;
      var $1273=__stackBase__+5088;
      var $1274=__stackBase__+5092;
      var $1275=__stackBase__+5096;
      var $1276=__stackBase__+5100;
      var $1277=__stackBase__+5104;
      var $1278=__stackBase__+5108;
      var $1279=__stackBase__+5112;
      var $1280=__stackBase__+5116;
      var $1281=__stackBase__+5120;
      var $1282=__stackBase__+5124;
      var $1283=__stackBase__+5128;
      var $1284=__stackBase__+5132;
      var $1285=__stackBase__+5136;
      var $1286=__stackBase__+5140;
      var $1287=__stackBase__+5144;
      var $1288=__stackBase__+5148;
      var $1289=__stackBase__+5152;
      var $1290=__stackBase__+5156;
      var $1291=__stackBase__+5160;
      var $1292=__stackBase__+5164;
      var $1293=__stackBase__+5168;
      var $1294=__stackBase__+5172;
      var $1295=__stackBase__+5176;
      var $1296=__stackBase__+5180;
      var $1297=__stackBase__+5184;
      var $1298=__stackBase__+5188;
      var $1299=__stackBase__+5192;
      var $1300=__stackBase__+5196;
      var $1301=__stackBase__+5200;
      var $1302=__stackBase__+5204;
      var $1303=__stackBase__+5208;
      var $1304=__stackBase__+5212;
      var $1305=__stackBase__+5216;
      var $1306=__stackBase__+5220;
      var $1307=__stackBase__+5224;
      var $1308=__stackBase__+5228;
      var $1309=__stackBase__+5232;
      var $1310=__stackBase__+5236;
      var $1311=__stackBase__+5240;
      var $1312=__stackBase__+5244;
      var $1313=__stackBase__+5248;
      var $1314=__stackBase__+5252;
      var $1315=__stackBase__+5256;
      var $1316=__stackBase__+5260;
      var $1317=__stackBase__+5264;
      var $1318=__stackBase__+5268;
      var $1319=__stackBase__+5272;
      var $1320=__stackBase__+5276;
      var $1321=__stackBase__+5280;
      var $1322=__stackBase__+5284;
      var $1323=__stackBase__+5288;
      var $1324=__stackBase__+5292;
      var $1325=__stackBase__+5296;
      var $1326=__stackBase__+5300;
      var $1327=__stackBase__+5304;
      var $1328=__stackBase__+5308;
      var $1329=__stackBase__+5312;
      var $1330=__stackBase__+5316;
      var $1331=__stackBase__+5320;
      var $1332=__stackBase__+5324;
      var $1333=__stackBase__+5328;
      var $1334=__stackBase__+5332;
      var $1335=__stackBase__+5336;
      var $1336=__stackBase__+5340;
      var $1337=__stackBase__+5344;
      var $1338=__stackBase__+5348;
      var $1339=__stackBase__+5352;
      var $1340=__stackBase__+5356;
      var $1341=__stackBase__+5360;
      var $1342=__stackBase__+5364;
      var $1343=__stackBase__+5368;
      var $1344=__stackBase__+5372;
      var $1345=__stackBase__+5376;
      var $1346=__stackBase__+5380;
      var $1347=__stackBase__+5384;
      var $1348=__stackBase__+5388;
      var $1349=__stackBase__+5392;
      var $1350=__stackBase__+5396;
      var $1351=__stackBase__+5400;
      var $1352=__stackBase__+5404;
      var $1353=__stackBase__+5408;
      var $1354=__stackBase__+5412;
      var $1355=__stackBase__+5416;
      var $1356=__stackBase__+5420;
      var $1357=__stackBase__+5424;
      var $1358=__stackBase__+5428;
      var $1359=__stackBase__+5432;
      var $1360=__stackBase__+5436;
      var $1361=__stackBase__+5440;
      var $1362=__stackBase__+5444;
      var $1363=__stackBase__+5448;
      var $1364=__stackBase__+5452;
      var $1365=__stackBase__+5456;
      var $1366=__stackBase__+5460;
      var $1367=__stackBase__+5464;
      var $1368=__stackBase__+5468;
      var $1369=__stackBase__+5472;
      var $1370=__stackBase__+5476;
      var $1371=__stackBase__+5480;
      var $1372=__stackBase__+5484;
      var $1373=__stackBase__+5488;
      var $1374=__stackBase__+5492;
      var $1375=__stackBase__+5496;
      var $1376=__stackBase__+5500;
      var $1377=__stackBase__+5504;
      var $1378=__stackBase__+5508;
      var $1379=__stackBase__+5512;
      var $1380=__stackBase__+5516;
      var $1381=__stackBase__+5520;
      var $1382=__stackBase__+5524;
      var $1383=__stackBase__+5528;
      var $1384=__stackBase__+5532;
      var $1385=__stackBase__+5536;
      var $1386=__stackBase__+5540;
      var $1387=__stackBase__+5544;
      var $1388=__stackBase__+5548;
      var $1389=__stackBase__+5552;
      var $1390=__stackBase__+5556;
      var $1391=__stackBase__+5560;
      var $1392=__stackBase__+5564;
      var $1393=__stackBase__+5568;
      var $1394=__stackBase__+5572;
      var $1395=__stackBase__+5576;
      var $1396=__stackBase__+5580;
      var $1397=__stackBase__+5584;
      var $1398=__stackBase__+5588;
      var $1399=__stackBase__+5592;
      var $1400=__stackBase__+5596;
      var $1401=__stackBase__+5600;
      var $1402=__stackBase__+5604;
      var $1403=__stackBase__+5608;
      var $1404=__stackBase__+5612;
      var $1405=__stackBase__+5616;
      var $1406=__stackBase__+5620;
      var $1407=__stackBase__+5624;
      var $1408=__stackBase__+5628;
      var $1409=__stackBase__+5632;
      var $1410=__stackBase__+5636;
      var $1411=__stackBase__+5640;
      var $1412=__stackBase__+5644;
      var $1413=__stackBase__+5648;
      var $1414=__stackBase__+5652;
      var $1415=__stackBase__+5656;
      var $1416=__stackBase__+5660;
      var $1417=__stackBase__+5664;
      var $1418=__stackBase__+5668;
      var $1419=__stackBase__+5672;
      var $1420=__stackBase__+5676;
      var $1421=__stackBase__+5680;
      var $1422=__stackBase__+5684;
      var $1423=__stackBase__+5688;
      var $1424=__stackBase__+5692;
      var $1425=__stackBase__+5696;
      var $1426=__stackBase__+5700;
      var $1427=__stackBase__+5704;
      var $1428=__stackBase__+5708;
      var $1429=__stackBase__+5712;
      var $1430=__stackBase__+5716;
      var $1431=__stackBase__+5720;
      var $1432=__stackBase__+5724;
      var $1433=__stackBase__+5728;
      var $1434=__stackBase__+5732;
      var $1435=__stackBase__+5736;
      var $1436=__stackBase__+5740;
      var $1437=__stackBase__+5744;
      var $1438=__stackBase__+5748;
      var $1439=__stackBase__+5752;
      var $1440=__stackBase__+5756;
      var $1441=__stackBase__+5760;
      var $1442=__stackBase__+5764;
      var $1443=__stackBase__+5768;
      var $1444=__stackBase__+5772;
      var $1445=__stackBase__+5776;
      var $1446=__stackBase__+5780;
      var $1447=__stackBase__+5784;
      var $1448=__stackBase__+5788;
      var $1449=__stackBase__+5792;
      var $1450=__stackBase__+5796;
      var $1451=__stackBase__+5800;
      var $1452=__stackBase__+5804;
      var $1453=__stackBase__+5808;
      var $1454=__stackBase__+5812;
      var $1455=__stackBase__+5816;
      var $1456=__stackBase__+5820;
      var $1457=__stackBase__+5824;
      var $1458=__stackBase__+5828;
      var $1459=__stackBase__+5832;
      var $1460=__stackBase__+5836;
      var $1461=__stackBase__+5840;
      var $1462=__stackBase__+5844;
      var $1463=__stackBase__+5848;
      var $1464=__stackBase__+5852;
      var $1465=__stackBase__+5856;
      var $1466=__stackBase__+5860;
      var $1467=__stackBase__+5864;
      var $1468=__stackBase__+5868;
      var $1469=__stackBase__+5872;
      var $1470=__stackBase__+5876;
      var $1471=__stackBase__+5880;
      var $1472=__stackBase__+5884;
      var $1473=__stackBase__+5888;
      var $1474=__stackBase__+5892;
      var $1475=__stackBase__+5896;
      var $1476=__stackBase__+5900;
      var $1477=__stackBase__+5904;
      var $1478=__stackBase__+5908;
      var $1479=__stackBase__+5912;
      var $1480=__stackBase__+5916;
      var $1481=__stackBase__+5920;
      var $1482=__stackBase__+5924;
      var $1483=__stackBase__+5928;
      var $1484=__stackBase__+5932;
      var $1485=__stackBase__+5936;
      var $1486=__stackBase__+5940;
      var $1487=__stackBase__+5944;
      var $1488=__stackBase__+5948;
      var $1489=__stackBase__+5952;
      var $1490=__stackBase__+5956;
      var $1491=__stackBase__+5960;
      var $1492=__stackBase__+5964;
      var $1493=__stackBase__+5968;
      var $1494=__stackBase__+5972;
      var $1495=__stackBase__+5976;
      var $1496=__stackBase__+5980;
      var $1497=__stackBase__+5984;
      var $1498=__stackBase__+5988;
      var $1499=__stackBase__+5992;
      var $1500=__stackBase__+5996;
      var $1501=__stackBase__+6000;
      var $1502=__stackBase__+6004;
      var $1503=__stackBase__+6008;
      var $1504=__stackBase__+6012;
      var $1505=__stackBase__+6016;
      var $1506=__stackBase__+6020;
      var $1507=__stackBase__+6024;
      var $1508=__stackBase__+6028;
      var $1509=__stackBase__+6032;
      var $1510=__stackBase__+6036;
      var $1511=__stackBase__+6040;
      var $1512=__stackBase__+6044;
      var $1513=__stackBase__+6048;
      var $1514=__stackBase__+6052;
      var $1515=__stackBase__+6056;
      var $1516=__stackBase__+6060;
      var $1517=__stackBase__+6064;
      var $1518=__stackBase__+6068;
      var $1519=__stackBase__+6072;
      var $1520=__stackBase__+6076;
      var $1521=__stackBase__+6080;
      var $1522=__stackBase__+6084;
      var $1523=__stackBase__+6088;
      var $1524=__stackBase__+6092;
      var $1525=__stackBase__+6096;
      var $1526=__stackBase__+6100;
      var $1527=__stackBase__+6104;
      var $1528=__stackBase__+6108;
      var $1529=__stackBase__+6112;
      var $1530=__stackBase__+6116;
      var $1531=__stackBase__+6120;
      var $1532=__stackBase__+6124;
      var $1533=__stackBase__+6128;
      var $1534=__stackBase__+6132;
      var $1535=__stackBase__+6136;
      var $1536=__stackBase__+6140;
      var $1537=__stackBase__+6144;
      var $1538=__stackBase__+6148;
      var $1539=__stackBase__+6152;
      var $1540=__stackBase__+6156;
      var $1541=__stackBase__+6160;
      var $1542=__stackBase__+6164;
      var $1543=__stackBase__+6168;
      var $1544=__stackBase__+6172;
      var $1545=__stackBase__+6176;
      var $1546=__stackBase__+6180;
      var $1547=__stackBase__+6184;
      var $1548=__stackBase__+6188;
      var $1549=__stackBase__+6192;
      var $1550=__stackBase__+6196;
      var $1551=__stackBase__+6200;
      var $1552=__stackBase__+6204;
      var $1553=__stackBase__+6208;
      var $1554=__stackBase__+6212;
      var $1555=__stackBase__+6216;
      var $1556=__stackBase__+6220;
      var $1557=__stackBase__+6224;
      var $1558=__stackBase__+6228;
      var $1559=__stackBase__+6232;
      var $1560=__stackBase__+6236;
      var $1561=__stackBase__+6240;
      var $1562=__stackBase__+6244;
      var $1563=__stackBase__+6248;
      var $1564=__stackBase__+6252;
      var $1565=__stackBase__+6256;
      var $1566=__stackBase__+6260;
      var $1567=__stackBase__+6264;
      var $1568=__stackBase__+6268;
      var $1569=__stackBase__+6272;
      var $1570=__stackBase__+6276;
      var $1571=__stackBase__+6280;
      var $1572=__stackBase__+6284;
      var $1573=__stackBase__+6288;
      var $1574=__stackBase__+6292;
      var $1575=__stackBase__+6296;
      var $1576=__stackBase__+6300;
      var $1577=__stackBase__+6304;
      var $1578=__stackBase__+6308;
      var $1579=__stackBase__+6312;
      var $1580=__stackBase__+6316;
      var $1581=__stackBase__+6320;
      var $1582=__stackBase__+6324;
      var $1583=__stackBase__+6328;
      var $1584=__stackBase__+6332;
      var $1585=__stackBase__+6336;
      var $1586=__stackBase__+6340;
      var $1587=__stackBase__+6344;
      var $1588=__stackBase__+6348;
      var $1589=__stackBase__+6352;
      var $1590=__stackBase__+6356;
      var $1591=__stackBase__+6360;
      var $1592=__stackBase__+6364;
      var $1593=__stackBase__+6368;
      var $1594=__stackBase__+6372;
      var $1595=__stackBase__+6376;
      var $1596=__stackBase__+6380;
      var $1597=__stackBase__+6384;
      var $1598=__stackBase__+6388;
      var $1599=__stackBase__+6392;
      var $1600=__stackBase__+6396;
      var $1601=__stackBase__+6400;
      var $1602=__stackBase__+6404;
      var $1603=__stackBase__+6408;
      var $1604=__stackBase__+6412;
      var $1605=__stackBase__+6416;
      var $1606=__stackBase__+6420;
      var $1607=__stackBase__+6424;
      var $1608=__stackBase__+6428;
      var $1609=__stackBase__+6432;
      var $1610=__stackBase__+6436;
      var $1611=__stackBase__+6440;
      var $1612=__stackBase__+6444;
      var $1613=__stackBase__+6448;
      var $1614=__stackBase__+6452;
      var $1615=__stackBase__+6456;
      var $1616=__stackBase__+6460;
      var $1617=__stackBase__+6464;
      var $1618=__stackBase__+6468;
      var $1619=__stackBase__+6472;
      var $1620=__stackBase__+6476;
      var $1621=__stackBase__+6480;
      var $1622=__stackBase__+6484;
      var $1623=__stackBase__+6488;
      var $1624=__stackBase__+6492;
      var $1625=__stackBase__+6496;
      var $1626=__stackBase__+6500;
      var $1627=__stackBase__+6504;
      var $1628=__stackBase__+6508;
      var $1629=__stackBase__+6512;
      var $1630=__stackBase__+6516;
      var $1631=__stackBase__+6520;
      var $1632=__stackBase__+6524;
      var $1633=__stackBase__+6528;
      var $1634=__stackBase__+6532;
      var $1635=__stackBase__+6536;
      var $1636=__stackBase__+6540;
      var $1637=__stackBase__+6544;
      var $1638=__stackBase__+6548;
      var $1639=__stackBase__+6552;
      var $1640=__stackBase__+6556;
      var $1641=__stackBase__+6560;
      var $1642=__stackBase__+6564;
      var $1643=__stackBase__+6568;
      var $1644=__stackBase__+6572;
      var $1645=__stackBase__+6576;
      var $1646=__stackBase__+6580;
      var $1647=__stackBase__+6584;
      var $1648=__stackBase__+6588;
      var $1649=__stackBase__+6592;
      var $1650=__stackBase__+6596;
      var $1651=__stackBase__+6600;
      var $1652=__stackBase__+6604;
      var $1653=__stackBase__+6608;
      var $1654=__stackBase__+6612;
      var $1655=__stackBase__+6616;
      var $1656=__stackBase__+6620;
      var $1657=__stackBase__+6624;
      var $1658=__stackBase__+6628;
      var $1659=__stackBase__+6632;
      var $1660=__stackBase__+6636;
      var $1661=__stackBase__+6640;
      var $1662=__stackBase__+6644;
      var $1663=__stackBase__+6648;
      var $1664=__stackBase__+6652;
      var $1665=__stackBase__+6656;
      var $1666=__stackBase__+6660;
      var $1667=__stackBase__+6664;
      var $1668=__stackBase__+6668;
      var $1669=__stackBase__+6672;
      var $1670=__stackBase__+6676;
      var $1671=__stackBase__+6680;
      var $1672=__stackBase__+6684;
      var $1673=__stackBase__+6688;
      var $1674=__stackBase__+6692;
      var $1675=__stackBase__+6696;
      var $1676=__stackBase__+6700;
      var $1677=__stackBase__+6704;
      var $1678=__stackBase__+6708;
      var $1679=__stackBase__+6712;
      var $1680=__stackBase__+6716;
      var $1681=__stackBase__+6720;
      var $1682=__stackBase__+6724;
      var $1683=__stackBase__+6728;
      var $1684=__stackBase__+6732;
      var $1685=__stackBase__+6736;
      var $1686=__stackBase__+6740;
      var $1687=__stackBase__+6744;
      var $1688=__stackBase__+6748;
      var $1689=__stackBase__+6752;
      var $1690=__stackBase__+6756;
      var $1691=__stackBase__+6760;
      var $1692=__stackBase__+6764;
      var $1693=__stackBase__+6768;
      var $1694=__stackBase__+6772;
      var $1695=__stackBase__+6776;
      var $1696=__stackBase__+6780;
      var $1697=__stackBase__+6784;
      var $1698=__stackBase__+6788;
      var $1699=__stackBase__+6792;
      var $1700=__stackBase__+6796;
      var $1701=__stackBase__+6800;
      var $1702=__stackBase__+6804;
      var $1703=__stackBase__+6808;
      var $1704=__stackBase__+6812;
      var $1705=__stackBase__+6816;
      var $1706=__stackBase__+6820;
      var $1707=__stackBase__+6824;
      var $1708=__stackBase__+6828;
      var $1709=__stackBase__+6832;
      var $1710=__stackBase__+6836;
      var $1711=__stackBase__+6840;
      var $1712=__stackBase__+6844;
      var $1713=__stackBase__+6848;
      var $1714=__stackBase__+6852;
      var $1715=__stackBase__+6856;
      var $1716=__stackBase__+6860;
      var $1717=__stackBase__+6864;
      var $1718=__stackBase__+6868;
      var $1719=__stackBase__+6872;
      var $1720=__stackBase__+6876;
      var $1721=__stackBase__+6880;
      var $1722=__stackBase__+6884;
      var $1723=__stackBase__+6888;
      var $1724=__stackBase__+6892;
      var $1725=__stackBase__+6896;
      var $1726=__stackBase__+6900;
      var $1727=__stackBase__+6904;
      var $1728=__stackBase__+6908;
      var $1729=__stackBase__+6912;
      var $1730=__stackBase__+6916;
      var $1731=__stackBase__+6920;
      var $1732=__stackBase__+6924;
      var $1733=__stackBase__+6928;
      var $1734=__stackBase__+6932;
      var $1735=__stackBase__+6936;
      var $1736=__stackBase__+6940;
      var $1737=__stackBase__+6944;
      var $1738=__stackBase__+6948;
      var $1739=__stackBase__+6952;
      var $1740=__stackBase__+6956;
      var $1741=__stackBase__+6960;
      var $1742=__stackBase__+6964;
      var $1743=__stackBase__+6968;
      var $1744=__stackBase__+6972;
      var $1745=__stackBase__+6976;
      var $1746=__stackBase__+6980;
      var $1747=__stackBase__+6984;
      var $1748=__stackBase__+6988;
      var $1749=__stackBase__+6992;
      var $1750=__stackBase__+6996;
      var $1751=__stackBase__+7000;
      var $1752=__stackBase__+7004;
      var $1753=__stackBase__+7008;
      var $1754=__stackBase__+7012;
      var $1755=__stackBase__+7016;
      var $1756=__stackBase__+7020;
      var $1757=__stackBase__+7024;
      var $1758=__stackBase__+7028;
      var $1759=__stackBase__+7032;
      var $1760=__stackBase__+7036;
      var $1761=__stackBase__+7040;
      var $result_i1169=__stackBase__+7044;
      var $1762=__stackBase__+7048;
      var $1763=__stackBase__+7052;
      var $1764=__stackBase__+7056;
      var $1765=__stackBase__+7060;
      var $1766=__stackBase__+7064;
      var $result_i1167=__stackBase__+7068;
      var $1767=__stackBase__+7072;
      var $1768=__stackBase__+7076;
      var $1769=__stackBase__+7080;
      var $1770=__stackBase__+7084;
      var $1771=__stackBase__+7088;
      var $result_i1165=__stackBase__+7092;
      var $1772=__stackBase__+7096;
      var $1773=__stackBase__+7100;
      var $1774=__stackBase__+7104;
      var $1775=__stackBase__+7108;
      var $1776=__stackBase__+7112;
      var $result_i1163=__stackBase__+7116;
      var $1777=__stackBase__+7120;
      var $1778=__stackBase__+7124;
      var $1779=__stackBase__+7128;
      var $1780=__stackBase__+7132;
      var $1781=__stackBase__+7136;
      var $result_i1161=__stackBase__+7140;
      var $1782=__stackBase__+7144;
      var $1783=__stackBase__+7148;
      var $1784=__stackBase__+7152;
      var $1785=__stackBase__+7156;
      var $1786=__stackBase__+7160;
      var $result_i1159=__stackBase__+7164;
      var $1787=__stackBase__+7168;
      var $1788=__stackBase__+7172;
      var $1789=__stackBase__+7176;
      var $1790=__stackBase__+7180;
      var $1791=__stackBase__+7184;
      var $result_i1157=__stackBase__+7188;
      var $1792=__stackBase__+7192;
      var $1793=__stackBase__+7196;
      var $1794=__stackBase__+7200;
      var $1795=__stackBase__+7204;
      var $1796=__stackBase__+7208;
      var $result_i1155=__stackBase__+7212;
      var $1797=__stackBase__+7216;
      var $1798=__stackBase__+7220;
      var $1799=__stackBase__+7224;
      var $1800=__stackBase__+7228;
      var $1801=__stackBase__+7232;
      var $result_i1153=__stackBase__+7236;
      var $1802=__stackBase__+7240;
      var $1803=__stackBase__+7244;
      var $1804=__stackBase__+7248;
      var $1805=__stackBase__+7252;
      var $1806=__stackBase__+7256;
      var $result_i1151=__stackBase__+7260;
      var $1807=__stackBase__+7264;
      var $1808=__stackBase__+7268;
      var $1809=__stackBase__+7272;
      var $1810=__stackBase__+7276;
      var $1811=__stackBase__+7280;
      var $result_i1149=__stackBase__+7284;
      var $1812=__stackBase__+7288;
      var $1813=__stackBase__+7292;
      var $1814=__stackBase__+7296;
      var $1815=__stackBase__+7300;
      var $1816=__stackBase__+7304;
      var $result_i1147=__stackBase__+7308;
      var $1817=__stackBase__+7312;
      var $1818=__stackBase__+7316;
      var $1819=__stackBase__+7320;
      var $1820=__stackBase__+7324;
      var $1821=__stackBase__+7328;
      var $result_i1145=__stackBase__+7332;
      var $1822=__stackBase__+7336;
      var $1823=__stackBase__+7340;
      var $1824=__stackBase__+7344;
      var $1825=__stackBase__+7348;
      var $1826=__stackBase__+7352;
      var $result_i1143=__stackBase__+7356;
      var $1827=__stackBase__+7360;
      var $1828=__stackBase__+7364;
      var $1829=__stackBase__+7368;
      var $1830=__stackBase__+7372;
      var $1831=__stackBase__+7376;
      var $result_i1141=__stackBase__+7380;
      var $1832=__stackBase__+7384;
      var $1833=__stackBase__+7388;
      var $1834=__stackBase__+7392;
      var $1835=__stackBase__+7396;
      var $1836=__stackBase__+7400;
      var $result_i1139=__stackBase__+7404;
      var $1837=__stackBase__+7408;
      var $1838=__stackBase__+7412;
      var $1839=__stackBase__+7416;
      var $1840=__stackBase__+7420;
      var $1841=__stackBase__+7424;
      var $result_i1137=__stackBase__+7428;
      var $1842=__stackBase__+7432;
      var $1843=__stackBase__+7436;
      var $1844=__stackBase__+7440;
      var $1845=__stackBase__+7444;
      var $1846=__stackBase__+7448;
      var $result_i1135=__stackBase__+7452;
      var $1847=__stackBase__+7456;
      var $1848=__stackBase__+7460;
      var $1849=__stackBase__+7464;
      var $1850=__stackBase__+7468;
      var $1851=__stackBase__+7472;
      var $result_i1133=__stackBase__+7476;
      var $1852=__stackBase__+7480;
      var $1853=__stackBase__+7484;
      var $1854=__stackBase__+7488;
      var $1855=__stackBase__+7492;
      var $1856=__stackBase__+7496;
      var $result_i1131=__stackBase__+7500;
      var $1857=__stackBase__+7504;
      var $1858=__stackBase__+7508;
      var $1859=__stackBase__+7512;
      var $1860=__stackBase__+7516;
      var $1861=__stackBase__+7520;
      var $result_i1129=__stackBase__+7524;
      var $1862=__stackBase__+7528;
      var $1863=__stackBase__+7532;
      var $1864=__stackBase__+7536;
      var $1865=__stackBase__+7540;
      var $1866=__stackBase__+7544;
      var $result_i1127=__stackBase__+7548;
      var $1867=__stackBase__+7552;
      var $1868=__stackBase__+7556;
      var $1869=__stackBase__+7560;
      var $1870=__stackBase__+7564;
      var $1871=__stackBase__+7568;
      var $result_i1125=__stackBase__+7572;
      var $1872=__stackBase__+7576;
      var $1873=__stackBase__+7580;
      var $1874=__stackBase__+7584;
      var $1875=__stackBase__+7588;
      var $1876=__stackBase__+7592;
      var $result_i1123=__stackBase__+7596;
      var $1877=__stackBase__+7600;
      var $1878=__stackBase__+7604;
      var $1879=__stackBase__+7608;
      var $1880=__stackBase__+7612;
      var $1881=__stackBase__+7616;
      var $result_i1121=__stackBase__+7620;
      var $1882=__stackBase__+7624;
      var $1883=__stackBase__+7628;
      var $1884=__stackBase__+7632;
      var $1885=__stackBase__+7636;
      var $1886=__stackBase__+7640;
      var $result_i1119=__stackBase__+7644;
      var $1887=__stackBase__+7648;
      var $1888=__stackBase__+7652;
      var $1889=__stackBase__+7656;
      var $1890=__stackBase__+7660;
      var $1891=__stackBase__+7664;
      var $result_i1117=__stackBase__+7668;
      var $1892=__stackBase__+7672;
      var $1893=__stackBase__+7676;
      var $1894=__stackBase__+7680;
      var $1895=__stackBase__+7684;
      var $1896=__stackBase__+7688;
      var $result_i1115=__stackBase__+7692;
      var $1897=__stackBase__+7696;
      var $1898=__stackBase__+7700;
      var $1899=__stackBase__+7704;
      var $1900=__stackBase__+7708;
      var $1901=__stackBase__+7712;
      var $result_i1113=__stackBase__+7716;
      var $1902=__stackBase__+7720;
      var $1903=__stackBase__+7724;
      var $1904=__stackBase__+7728;
      var $1905=__stackBase__+7732;
      var $1906=__stackBase__+7736;
      var $result_i1111=__stackBase__+7740;
      var $1907=__stackBase__+7744;
      var $1908=__stackBase__+7748;
      var $1909=__stackBase__+7752;
      var $1910=__stackBase__+7756;
      var $1911=__stackBase__+7760;
      var $result_i1109=__stackBase__+7764;
      var $1912=__stackBase__+7768;
      var $1913=__stackBase__+7772;
      var $1914=__stackBase__+7776;
      var $1915=__stackBase__+7780;
      var $1916=__stackBase__+7784;
      var $result_i1107=__stackBase__+7788;
      var $1917=__stackBase__+7792;
      var $1918=__stackBase__+7796;
      var $1919=__stackBase__+7800;
      var $1920=__stackBase__+7804;
      var $1921=__stackBase__+7808;
      var $result_i1105=__stackBase__+7812;
      var $1922=__stackBase__+7816;
      var $1923=__stackBase__+7820;
      var $1924=__stackBase__+7824;
      var $1925=__stackBase__+7828;
      var $1926=__stackBase__+7832;
      var $result_i1103=__stackBase__+7836;
      var $1927=__stackBase__+7840;
      var $1928=__stackBase__+7844;
      var $1929=__stackBase__+7848;
      var $1930=__stackBase__+7852;
      var $1931=__stackBase__+7856;
      var $result_i1101=__stackBase__+7860;
      var $1932=__stackBase__+7864;
      var $1933=__stackBase__+7868;
      var $1934=__stackBase__+7872;
      var $1935=__stackBase__+7876;
      var $1936=__stackBase__+7880;
      var $result_i1099=__stackBase__+7884;
      var $1937=__stackBase__+7888;
      var $1938=__stackBase__+7892;
      var $1939=__stackBase__+7896;
      var $1940=__stackBase__+7900;
      var $1941=__stackBase__+7904;
      var $result_i1097=__stackBase__+7908;
      var $1942=__stackBase__+7912;
      var $1943=__stackBase__+7916;
      var $1944=__stackBase__+7920;
      var $1945=__stackBase__+7924;
      var $1946=__stackBase__+7928;
      var $result_i1095=__stackBase__+7932;
      var $1947=__stackBase__+7936;
      var $1948=__stackBase__+7940;
      var $1949=__stackBase__+7944;
      var $1950=__stackBase__+7948;
      var $1951=__stackBase__+7952;
      var $result_i1093=__stackBase__+7956;
      var $1952=__stackBase__+7960;
      var $1953=__stackBase__+7964;
      var $1954=__stackBase__+7968;
      var $1955=__stackBase__+7972;
      var $1956=__stackBase__+7976;
      var $result_i1091=__stackBase__+7980;
      var $1957=__stackBase__+7984;
      var $1958=__stackBase__+7988;
      var $1959=__stackBase__+7992;
      var $1960=__stackBase__+7996;
      var $1961=__stackBase__+8000;
      var $result_i1089=__stackBase__+8004;
      var $1962=__stackBase__+8008;
      var $1963=__stackBase__+8012;
      var $1964=__stackBase__+8016;
      var $1965=__stackBase__+8020;
      var $1966=__stackBase__+8024;
      var $result_i1087=__stackBase__+8028;
      var $1967=__stackBase__+8032;
      var $1968=__stackBase__+8036;
      var $1969=__stackBase__+8040;
      var $1970=__stackBase__+8044;
      var $1971=__stackBase__+8048;
      var $result_i1085=__stackBase__+8052;
      var $1972=__stackBase__+8056;
      var $1973=__stackBase__+8060;
      var $1974=__stackBase__+8064;
      var $1975=__stackBase__+8068;
      var $1976=__stackBase__+8072;
      var $result_i1083=__stackBase__+8076;
      var $1977=__stackBase__+8080;
      var $1978=__stackBase__+8084;
      var $1979=__stackBase__+8088;
      var $1980=__stackBase__+8092;
      var $1981=__stackBase__+8096;
      var $result_i1081=__stackBase__+8100;
      var $1982=__stackBase__+8104;
      var $1983=__stackBase__+8108;
      var $1984=__stackBase__+8112;
      var $1985=__stackBase__+8116;
      var $1986=__stackBase__+8120;
      var $result_i1079=__stackBase__+8124;
      var $1987=__stackBase__+8128;
      var $1988=__stackBase__+8132;
      var $1989=__stackBase__+8136;
      var $1990=__stackBase__+8140;
      var $1991=__stackBase__+8144;
      var $result_i1077=__stackBase__+8148;
      var $1992=__stackBase__+8152;
      var $1993=__stackBase__+8156;
      var $1994=__stackBase__+8160;
      var $1995=__stackBase__+8164;
      var $1996=__stackBase__+8168;
      var $result_i1075=__stackBase__+8172;
      var $1997=__stackBase__+8176;
      var $1998=__stackBase__+8180;
      var $1999=__stackBase__+8184;
      var $2000=__stackBase__+8188;
      var $2001=__stackBase__+8192;
      var $result_i1073=__stackBase__+8196;
      var $2002=__stackBase__+8200;
      var $2003=__stackBase__+8204;
      var $2004=__stackBase__+8208;
      var $2005=__stackBase__+8212;
      var $2006=__stackBase__+8216;
      var $result_i1071=__stackBase__+8220;
      var $2007=__stackBase__+8224;
      var $2008=__stackBase__+8228;
      var $2009=__stackBase__+8232;
      var $2010=__stackBase__+8236;
      var $2011=__stackBase__+8240;
      var $result_i1069=__stackBase__+8244;
      var $2012=__stackBase__+8248;
      var $2013=__stackBase__+8252;
      var $2014=__stackBase__+8256;
      var $2015=__stackBase__+8260;
      var $2016=__stackBase__+8264;
      var $result_i1067=__stackBase__+8268;
      var $2017=__stackBase__+8272;
      var $2018=__stackBase__+8276;
      var $2019=__stackBase__+8280;
      var $2020=__stackBase__+8284;
      var $2021=__stackBase__+8288;
      var $result_i1065=__stackBase__+8292;
      var $2022=__stackBase__+8296;
      var $2023=__stackBase__+8300;
      var $2024=__stackBase__+8304;
      var $2025=__stackBase__+8308;
      var $2026=__stackBase__+8312;
      var $result_i1063=__stackBase__+8316;
      var $2027=__stackBase__+8320;
      var $2028=__stackBase__+8324;
      var $2029=__stackBase__+8328;
      var $2030=__stackBase__+8332;
      var $2031=__stackBase__+8336;
      var $result_i1061=__stackBase__+8340;
      var $2032=__stackBase__+8344;
      var $2033=__stackBase__+8348;
      var $2034=__stackBase__+8352;
      var $2035=__stackBase__+8356;
      var $2036=__stackBase__+8360;
      var $result_i1059=__stackBase__+8364;
      var $2037=__stackBase__+8368;
      var $2038=__stackBase__+8372;
      var $2039=__stackBase__+8376;
      var $2040=__stackBase__+8380;
      var $2041=__stackBase__+8384;
      var $result_i1057=__stackBase__+8388;
      var $2042=__stackBase__+8392;
      var $2043=__stackBase__+8396;
      var $2044=__stackBase__+8400;
      var $2045=__stackBase__+8404;
      var $2046=__stackBase__+8408;
      var $result_i1055=__stackBase__+8412;
      var $2047=__stackBase__+8416;
      var $2048=__stackBase__+8420;
      var $2049=__stackBase__+8424;
      var $2050=__stackBase__+8428;
      var $2051=__stackBase__+8432;
      var $result_i1053=__stackBase__+8436;
      var $2052=__stackBase__+8440;
      var $2053=__stackBase__+8444;
      var $2054=__stackBase__+8448;
      var $2055=__stackBase__+8452;
      var $2056=__stackBase__+8456;
      var $result_i1051=__stackBase__+8460;
      var $2057=__stackBase__+8464;
      var $2058=__stackBase__+8468;
      var $2059=__stackBase__+8472;
      var $2060=__stackBase__+8476;
      var $2061=__stackBase__+8480;
      var $result_i1049=__stackBase__+8484;
      var $2062=__stackBase__+8488;
      var $2063=__stackBase__+8492;
      var $2064=__stackBase__+8496;
      var $2065=__stackBase__+8500;
      var $2066=__stackBase__+8504;
      var $result_i1047=__stackBase__+8508;
      var $2067=__stackBase__+8512;
      var $2068=__stackBase__+8516;
      var $2069=__stackBase__+8520;
      var $2070=__stackBase__+8524;
      var $2071=__stackBase__+8528;
      var $result_i1045=__stackBase__+8532;
      var $2072=__stackBase__+8536;
      var $2073=__stackBase__+8540;
      var $2074=__stackBase__+8544;
      var $2075=__stackBase__+8548;
      var $2076=__stackBase__+8552;
      var $result_i1043=__stackBase__+8556;
      var $2077=__stackBase__+8560;
      var $2078=__stackBase__+8564;
      var $2079=__stackBase__+8568;
      var $2080=__stackBase__+8572;
      var $2081=__stackBase__+8576;
      var $result_i1041=__stackBase__+8580;
      var $2082=__stackBase__+8584;
      var $2083=__stackBase__+8588;
      var $2084=__stackBase__+8592;
      var $2085=__stackBase__+8596;
      var $2086=__stackBase__+8600;
      var $result_i1039=__stackBase__+8604;
      var $2087=__stackBase__+8608;
      var $2088=__stackBase__+8612;
      var $2089=__stackBase__+8616;
      var $2090=__stackBase__+8620;
      var $2091=__stackBase__+8624;
      var $result_i1037=__stackBase__+8628;
      var $2092=__stackBase__+8632;
      var $2093=__stackBase__+8636;
      var $2094=__stackBase__+8640;
      var $2095=__stackBase__+8644;
      var $2096=__stackBase__+8648;
      var $result_i1035=__stackBase__+8652;
      var $2097=__stackBase__+8656;
      var $2098=__stackBase__+8660;
      var $2099=__stackBase__+8664;
      var $2100=__stackBase__+8668;
      var $2101=__stackBase__+8672;
      var $result_i1033=__stackBase__+8676;
      var $2102=__stackBase__+8680;
      var $2103=__stackBase__+8684;
      var $2104=__stackBase__+8688;
      var $2105=__stackBase__+8692;
      var $2106=__stackBase__+8696;
      var $result_i1031=__stackBase__+8700;
      var $2107=__stackBase__+8704;
      var $2108=__stackBase__+8708;
      var $2109=__stackBase__+8712;
      var $2110=__stackBase__+8716;
      var $2111=__stackBase__+8720;
      var $result_i1029=__stackBase__+8724;
      var $2112=__stackBase__+8728;
      var $2113=__stackBase__+8732;
      var $2114=__stackBase__+8736;
      var $2115=__stackBase__+8740;
      var $2116=__stackBase__+8744;
      var $result_i1027=__stackBase__+8748;
      var $2117=__stackBase__+8752;
      var $2118=__stackBase__+8756;
      var $2119=__stackBase__+8760;
      var $2120=__stackBase__+8764;
      var $2121=__stackBase__+8768;
      var $result_i1025=__stackBase__+8772;
      var $2122=__stackBase__+8776;
      var $2123=__stackBase__+8780;
      var $2124=__stackBase__+8784;
      var $2125=__stackBase__+8788;
      var $2126=__stackBase__+8792;
      var $result_i1023=__stackBase__+8796;
      var $2127=__stackBase__+8800;
      var $2128=__stackBase__+8804;
      var $2129=__stackBase__+8808;
      var $2130=__stackBase__+8812;
      var $2131=__stackBase__+8816;
      var $result_i1021=__stackBase__+8820;
      var $2132=__stackBase__+8824;
      var $2133=__stackBase__+8828;
      var $2134=__stackBase__+8832;
      var $2135=__stackBase__+8836;
      var $2136=__stackBase__+8840;
      var $result_i1019=__stackBase__+8844;
      var $2137=__stackBase__+8848;
      var $2138=__stackBase__+8852;
      var $2139=__stackBase__+8856;
      var $2140=__stackBase__+8860;
      var $2141=__stackBase__+8864;
      var $result_i1017=__stackBase__+8868;
      var $2142=__stackBase__+8872;
      var $2143=__stackBase__+8876;
      var $2144=__stackBase__+8880;
      var $2145=__stackBase__+8884;
      var $2146=__stackBase__+8888;
      var $result_i1015=__stackBase__+8892;
      var $2147=__stackBase__+8896;
      var $2148=__stackBase__+8900;
      var $2149=__stackBase__+8904;
      var $2150=__stackBase__+8908;
      var $2151=__stackBase__+8912;
      var $result_i1013=__stackBase__+8916;
      var $2152=__stackBase__+8920;
      var $2153=__stackBase__+8924;
      var $2154=__stackBase__+8928;
      var $2155=__stackBase__+8932;
      var $2156=__stackBase__+8936;
      var $result_i1011=__stackBase__+8940;
      var $2157=__stackBase__+8944;
      var $2158=__stackBase__+8948;
      var $2159=__stackBase__+8952;
      var $2160=__stackBase__+8956;
      var $2161=__stackBase__+8960;
      var $result_i1009=__stackBase__+8964;
      var $2162=__stackBase__+8968;
      var $2163=__stackBase__+8972;
      var $2164=__stackBase__+8976;
      var $2165=__stackBase__+8980;
      var $2166=__stackBase__+8984;
      var $result_i1007=__stackBase__+8988;
      var $2167=__stackBase__+8992;
      var $2168=__stackBase__+8996;
      var $2169=__stackBase__+9000;
      var $2170=__stackBase__+9004;
      var $2171=__stackBase__+9008;
      var $result_i1005=__stackBase__+9012;
      var $2172=__stackBase__+9016;
      var $2173=__stackBase__+9020;
      var $2174=__stackBase__+9024;
      var $2175=__stackBase__+9028;
      var $2176=__stackBase__+9032;
      var $result_i1003=__stackBase__+9036;
      var $2177=__stackBase__+9040;
      var $2178=__stackBase__+9044;
      var $2179=__stackBase__+9048;
      var $2180=__stackBase__+9052;
      var $2181=__stackBase__+9056;
      var $result_i1001=__stackBase__+9060;
      var $2182=__stackBase__+9064;
      var $2183=__stackBase__+9068;
      var $2184=__stackBase__+9072;
      var $2185=__stackBase__+9076;
      var $2186=__stackBase__+9080;
      var $result_i999=__stackBase__+9084;
      var $2187=__stackBase__+9088;
      var $2188=__stackBase__+9092;
      var $2189=__stackBase__+9096;
      var $2190=__stackBase__+9100;
      var $2191=__stackBase__+9104;
      var $result_i997=__stackBase__+9108;
      var $2192=__stackBase__+9112;
      var $2193=__stackBase__+9116;
      var $2194=__stackBase__+9120;
      var $2195=__stackBase__+9124;
      var $2196=__stackBase__+9128;
      var $result_i995=__stackBase__+9132;
      var $2197=__stackBase__+9136;
      var $2198=__stackBase__+9140;
      var $2199=__stackBase__+9144;
      var $2200=__stackBase__+9148;
      var $2201=__stackBase__+9152;
      var $result_i993=__stackBase__+9156;
      var $2202=__stackBase__+9160;
      var $2203=__stackBase__+9164;
      var $2204=__stackBase__+9168;
      var $2205=__stackBase__+9172;
      var $2206=__stackBase__+9176;
      var $result_i991=__stackBase__+9180;
      var $2207=__stackBase__+9184;
      var $2208=__stackBase__+9188;
      var $2209=__stackBase__+9192;
      var $2210=__stackBase__+9196;
      var $2211=__stackBase__+9200;
      var $result_i989=__stackBase__+9204;
      var $2212=__stackBase__+9208;
      var $2213=__stackBase__+9212;
      var $2214=__stackBase__+9216;
      var $2215=__stackBase__+9220;
      var $2216=__stackBase__+9224;
      var $result_i987=__stackBase__+9228;
      var $2217=__stackBase__+9232;
      var $2218=__stackBase__+9236;
      var $2219=__stackBase__+9240;
      var $2220=__stackBase__+9244;
      var $2221=__stackBase__+9248;
      var $result_i985=__stackBase__+9252;
      var $2222=__stackBase__+9256;
      var $2223=__stackBase__+9260;
      var $2224=__stackBase__+9264;
      var $2225=__stackBase__+9268;
      var $2226=__stackBase__+9272;
      var $result_i983=__stackBase__+9276;
      var $2227=__stackBase__+9280;
      var $2228=__stackBase__+9284;
      var $2229=__stackBase__+9288;
      var $2230=__stackBase__+9292;
      var $2231=__stackBase__+9296;
      var $result_i981=__stackBase__+9300;
      var $2232=__stackBase__+9304;
      var $2233=__stackBase__+9308;
      var $2234=__stackBase__+9312;
      var $2235=__stackBase__+9316;
      var $2236=__stackBase__+9320;
      var $result_i979=__stackBase__+9324;
      var $2237=__stackBase__+9328;
      var $2238=__stackBase__+9332;
      var $2239=__stackBase__+9336;
      var $2240=__stackBase__+9340;
      var $2241=__stackBase__+9344;
      var $result_i977=__stackBase__+9348;
      var $2242=__stackBase__+9352;
      var $2243=__stackBase__+9356;
      var $2244=__stackBase__+9360;
      var $2245=__stackBase__+9364;
      var $2246=__stackBase__+9368;
      var $result_i975=__stackBase__+9372;
      var $2247=__stackBase__+9376;
      var $2248=__stackBase__+9380;
      var $2249=__stackBase__+9384;
      var $2250=__stackBase__+9388;
      var $2251=__stackBase__+9392;
      var $result_i973=__stackBase__+9396;
      var $2252=__stackBase__+9400;
      var $2253=__stackBase__+9404;
      var $2254=__stackBase__+9408;
      var $2255=__stackBase__+9412;
      var $2256=__stackBase__+9416;
      var $result_i971=__stackBase__+9420;
      var $2257=__stackBase__+9424;
      var $2258=__stackBase__+9428;
      var $2259=__stackBase__+9432;
      var $2260=__stackBase__+9436;
      var $2261=__stackBase__+9440;
      var $result_i969=__stackBase__+9444;
      var $2262=__stackBase__+9448;
      var $2263=__stackBase__+9452;
      var $2264=__stackBase__+9456;
      var $2265=__stackBase__+9460;
      var $2266=__stackBase__+9464;
      var $result_i967=__stackBase__+9468;
      var $2267=__stackBase__+9472;
      var $2268=__stackBase__+9476;
      var $2269=__stackBase__+9480;
      var $2270=__stackBase__+9484;
      var $2271=__stackBase__+9488;
      var $result_i965=__stackBase__+9492;
      var $2272=__stackBase__+9496;
      var $2273=__stackBase__+9500;
      var $2274=__stackBase__+9504;
      var $2275=__stackBase__+9508;
      var $2276=__stackBase__+9512;
      var $result_i963=__stackBase__+9516;
      var $2277=__stackBase__+9520;
      var $2278=__stackBase__+9524;
      var $2279=__stackBase__+9528;
      var $2280=__stackBase__+9532;
      var $2281=__stackBase__+9536;
      var $result_i961=__stackBase__+9540;
      var $2282=__stackBase__+9544;
      var $2283=__stackBase__+9548;
      var $2284=__stackBase__+9552;
      var $2285=__stackBase__+9556;
      var $2286=__stackBase__+9560;
      var $result_i959=__stackBase__+9564;
      var $2287=__stackBase__+9568;
      var $2288=__stackBase__+9572;
      var $2289=__stackBase__+9576;
      var $2290=__stackBase__+9580;
      var $2291=__stackBase__+9584;
      var $result_i957=__stackBase__+9588;
      var $2292=__stackBase__+9592;
      var $2293=__stackBase__+9596;
      var $2294=__stackBase__+9600;
      var $2295=__stackBase__+9604;
      var $2296=__stackBase__+9608;
      var $result_i955=__stackBase__+9612;
      var $2297=__stackBase__+9616;
      var $2298=__stackBase__+9620;
      var $2299=__stackBase__+9624;
      var $2300=__stackBase__+9628;
      var $2301=__stackBase__+9632;
      var $result_i953=__stackBase__+9636;
      var $2302=__stackBase__+9640;
      var $2303=__stackBase__+9644;
      var $2304=__stackBase__+9648;
      var $2305=__stackBase__+9652;
      var $2306=__stackBase__+9656;
      var $result_i951=__stackBase__+9660;
      var $2307=__stackBase__+9664;
      var $2308=__stackBase__+9668;
      var $2309=__stackBase__+9672;
      var $2310=__stackBase__+9676;
      var $2311=__stackBase__+9680;
      var $result_i949=__stackBase__+9684;
      var $2312=__stackBase__+9688;
      var $2313=__stackBase__+9692;
      var $2314=__stackBase__+9696;
      var $2315=__stackBase__+9700;
      var $2316=__stackBase__+9704;
      var $result_i947=__stackBase__+9708;
      var $2317=__stackBase__+9712;
      var $2318=__stackBase__+9716;
      var $2319=__stackBase__+9720;
      var $2320=__stackBase__+9724;
      var $2321=__stackBase__+9728;
      var $result_i945=__stackBase__+9732;
      var $2322=__stackBase__+9736;
      var $2323=__stackBase__+9740;
      var $2324=__stackBase__+9744;
      var $2325=__stackBase__+9748;
      var $2326=__stackBase__+9752;
      var $result_i943=__stackBase__+9756;
      var $2327=__stackBase__+9760;
      var $2328=__stackBase__+9764;
      var $2329=__stackBase__+9768;
      var $2330=__stackBase__+9772;
      var $2331=__stackBase__+9776;
      var $result_i941=__stackBase__+9780;
      var $2332=__stackBase__+9784;
      var $2333=__stackBase__+9788;
      var $2334=__stackBase__+9792;
      var $2335=__stackBase__+9796;
      var $2336=__stackBase__+9800;
      var $result_i939=__stackBase__+9804;
      var $2337=__stackBase__+9808;
      var $2338=__stackBase__+9812;
      var $2339=__stackBase__+9816;
      var $2340=__stackBase__+9820;
      var $2341=__stackBase__+9824;
      var $result_i937=__stackBase__+9828;
      var $2342=__stackBase__+9832;
      var $2343=__stackBase__+9836;
      var $2344=__stackBase__+9840;
      var $2345=__stackBase__+9844;
      var $2346=__stackBase__+9848;
      var $result_i935=__stackBase__+9852;
      var $2347=__stackBase__+9856;
      var $2348=__stackBase__+9860;
      var $2349=__stackBase__+9864;
      var $2350=__stackBase__+9868;
      var $2351=__stackBase__+9872;
      var $result_i933=__stackBase__+9876;
      var $2352=__stackBase__+9880;
      var $2353=__stackBase__+9884;
      var $2354=__stackBase__+9888;
      var $2355=__stackBase__+9892;
      var $2356=__stackBase__+9896;
      var $result_i931=__stackBase__+9900;
      var $2357=__stackBase__+9904;
      var $2358=__stackBase__+9908;
      var $2359=__stackBase__+9912;
      var $2360=__stackBase__+9916;
      var $2361=__stackBase__+9920;
      var $result_i929=__stackBase__+9924;
      var $2362=__stackBase__+9928;
      var $2363=__stackBase__+9932;
      var $2364=__stackBase__+9936;
      var $2365=__stackBase__+9940;
      var $2366=__stackBase__+9944;
      var $result_i927=__stackBase__+9948;
      var $2367=__stackBase__+9952;
      var $2368=__stackBase__+9956;
      var $2369=__stackBase__+9960;
      var $2370=__stackBase__+9964;
      var $2371=__stackBase__+9968;
      var $result_i925=__stackBase__+9972;
      var $2372=__stackBase__+9976;
      var $2373=__stackBase__+9980;
      var $2374=__stackBase__+9984;
      var $2375=__stackBase__+9988;
      var $2376=__stackBase__+9992;
      var $result_i923=__stackBase__+9996;
      var $2377=__stackBase__+10000;
      var $2378=__stackBase__+10004;
      var $2379=__stackBase__+10008;
      var $2380=__stackBase__+10012;
      var $2381=__stackBase__+10016;
      var $result_i921=__stackBase__+10020;
      var $2382=__stackBase__+10024;
      var $2383=__stackBase__+10028;
      var $2384=__stackBase__+10032;
      var $2385=__stackBase__+10036;
      var $2386=__stackBase__+10040;
      var $result_i919=__stackBase__+10044;
      var $2387=__stackBase__+10048;
      var $2388=__stackBase__+10052;
      var $2389=__stackBase__+10056;
      var $2390=__stackBase__+10060;
      var $2391=__stackBase__+10064;
      var $result_i917=__stackBase__+10068;
      var $2392=__stackBase__+10072;
      var $2393=__stackBase__+10076;
      var $2394=__stackBase__+10080;
      var $2395=__stackBase__+10084;
      var $2396=__stackBase__+10088;
      var $result_i915=__stackBase__+10092;
      var $2397=__stackBase__+10096;
      var $2398=__stackBase__+10100;
      var $2399=__stackBase__+10104;
      var $2400=__stackBase__+10108;
      var $2401=__stackBase__+10112;
      var $result_i913=__stackBase__+10116;
      var $2402=__stackBase__+10120;
      var $2403=__stackBase__+10124;
      var $2404=__stackBase__+10128;
      var $2405=__stackBase__+10132;
      var $2406=__stackBase__+10136;
      var $result_i911=__stackBase__+10140;
      var $2407=__stackBase__+10144;
      var $2408=__stackBase__+10148;
      var $2409=__stackBase__+10152;
      var $2410=__stackBase__+10156;
      var $2411=__stackBase__+10160;
      var $result_i909=__stackBase__+10164;
      var $2412=__stackBase__+10168;
      var $2413=__stackBase__+10172;
      var $2414=__stackBase__+10176;
      var $2415=__stackBase__+10180;
      var $2416=__stackBase__+10184;
      var $result_i907=__stackBase__+10188;
      var $2417=__stackBase__+10192;
      var $2418=__stackBase__+10196;
      var $2419=__stackBase__+10200;
      var $2420=__stackBase__+10204;
      var $2421=__stackBase__+10208;
      var $result_i905=__stackBase__+10212;
      var $2422=__stackBase__+10216;
      var $2423=__stackBase__+10220;
      var $2424=__stackBase__+10224;
      var $2425=__stackBase__+10228;
      var $2426=__stackBase__+10232;
      var $result_i903=__stackBase__+10236;
      var $2427=__stackBase__+10240;
      var $2428=__stackBase__+10244;
      var $2429=__stackBase__+10248;
      var $2430=__stackBase__+10252;
      var $2431=__stackBase__+10256;
      var $result_i901=__stackBase__+10260;
      var $2432=__stackBase__+10264;
      var $2433=__stackBase__+10268;
      var $2434=__stackBase__+10272;
      var $2435=__stackBase__+10276;
      var $2436=__stackBase__+10280;
      var $result_i899=__stackBase__+10284;
      var $2437=__stackBase__+10288;
      var $2438=__stackBase__+10292;
      var $2439=__stackBase__+10296;
      var $2440=__stackBase__+10300;
      var $2441=__stackBase__+10304;
      var $result_i897=__stackBase__+10308;
      var $2442=__stackBase__+10312;
      var $2443=__stackBase__+10316;
      var $2444=__stackBase__+10320;
      var $2445=__stackBase__+10324;
      var $2446=__stackBase__+10328;
      var $result_i895=__stackBase__+10332;
      var $2447=__stackBase__+10336;
      var $2448=__stackBase__+10340;
      var $2449=__stackBase__+10344;
      var $2450=__stackBase__+10348;
      var $2451=__stackBase__+10352;
      var $result_i893=__stackBase__+10356;
      var $2452=__stackBase__+10360;
      var $2453=__stackBase__+10364;
      var $2454=__stackBase__+10368;
      var $2455=__stackBase__+10372;
      var $2456=__stackBase__+10376;
      var $result_i891=__stackBase__+10380;
      var $2457=__stackBase__+10384;
      var $2458=__stackBase__+10388;
      var $2459=__stackBase__+10392;
      var $2460=__stackBase__+10396;
      var $2461=__stackBase__+10400;
      var $result_i889=__stackBase__+10404;
      var $2462=__stackBase__+10408;
      var $2463=__stackBase__+10412;
      var $2464=__stackBase__+10416;
      var $2465=__stackBase__+10420;
      var $2466=__stackBase__+10424;
      var $result_i887=__stackBase__+10428;
      var $2467=__stackBase__+10432;
      var $2468=__stackBase__+10436;
      var $2469=__stackBase__+10440;
      var $2470=__stackBase__+10444;
      var $2471=__stackBase__+10448;
      var $result_i885=__stackBase__+10452;
      var $2472=__stackBase__+10456;
      var $2473=__stackBase__+10460;
      var $2474=__stackBase__+10464;
      var $2475=__stackBase__+10468;
      var $2476=__stackBase__+10472;
      var $result_i883=__stackBase__+10476;
      var $2477=__stackBase__+10480;
      var $2478=__stackBase__+10484;
      var $2479=__stackBase__+10488;
      var $2480=__stackBase__+10492;
      var $2481=__stackBase__+10496;
      var $result_i881=__stackBase__+10500;
      var $2482=__stackBase__+10504;
      var $2483=__stackBase__+10508;
      var $2484=__stackBase__+10512;
      var $2485=__stackBase__+10516;
      var $2486=__stackBase__+10520;
      var $result_i879=__stackBase__+10524;
      var $2487=__stackBase__+10528;
      var $2488=__stackBase__+10532;
      var $2489=__stackBase__+10536;
      var $2490=__stackBase__+10540;
      var $2491=__stackBase__+10544;
      var $result_i877=__stackBase__+10548;
      var $2492=__stackBase__+10552;
      var $2493=__stackBase__+10556;
      var $2494=__stackBase__+10560;
      var $2495=__stackBase__+10564;
      var $2496=__stackBase__+10568;
      var $result_i875=__stackBase__+10572;
      var $2497=__stackBase__+10576;
      var $2498=__stackBase__+10580;
      var $2499=__stackBase__+10584;
      var $2500=__stackBase__+10588;
      var $2501=__stackBase__+10592;
      var $result_i873=__stackBase__+10596;
      var $2502=__stackBase__+10600;
      var $2503=__stackBase__+10604;
      var $2504=__stackBase__+10608;
      var $2505=__stackBase__+10612;
      var $2506=__stackBase__+10616;
      var $result_i871=__stackBase__+10620;
      var $2507=__stackBase__+10624;
      var $2508=__stackBase__+10628;
      var $2509=__stackBase__+10632;
      var $2510=__stackBase__+10636;
      var $2511=__stackBase__+10640;
      var $result_i869=__stackBase__+10644;
      var $2512=__stackBase__+10648;
      var $2513=__stackBase__+10652;
      var $2514=__stackBase__+10656;
      var $2515=__stackBase__+10660;
      var $2516=__stackBase__+10664;
      var $result_i867=__stackBase__+10668;
      var $2517=__stackBase__+10672;
      var $2518=__stackBase__+10676;
      var $2519=__stackBase__+10680;
      var $2520=__stackBase__+10684;
      var $2521=__stackBase__+10688;
      var $result_i865=__stackBase__+10692;
      var $2522=__stackBase__+10696;
      var $2523=__stackBase__+10700;
      var $2524=__stackBase__+10704;
      var $2525=__stackBase__+10708;
      var $2526=__stackBase__+10712;
      var $result_i863=__stackBase__+10716;
      var $2527=__stackBase__+10720;
      var $2528=__stackBase__+10724;
      var $2529=__stackBase__+10728;
      var $2530=__stackBase__+10732;
      var $2531=__stackBase__+10736;
      var $result_i861=__stackBase__+10740;
      var $2532=__stackBase__+10744;
      var $2533=__stackBase__+10748;
      var $2534=__stackBase__+10752;
      var $2535=__stackBase__+10756;
      var $2536=__stackBase__+10760;
      var $result_i859=__stackBase__+10764;
      var $2537=__stackBase__+10768;
      var $2538=__stackBase__+10772;
      var $2539=__stackBase__+10776;
      var $2540=__stackBase__+10780;
      var $2541=__stackBase__+10784;
      var $result_i857=__stackBase__+10788;
      var $2542=__stackBase__+10792;
      var $2543=__stackBase__+10796;
      var $2544=__stackBase__+10800;
      var $2545=__stackBase__+10804;
      var $2546=__stackBase__+10808;
      var $result_i855=__stackBase__+10812;
      var $2547=__stackBase__+10816;
      var $2548=__stackBase__+10820;
      var $2549=__stackBase__+10824;
      var $2550=__stackBase__+10828;
      var $2551=__stackBase__+10832;
      var $result_i853=__stackBase__+10836;
      var $2552=__stackBase__+10840;
      var $2553=__stackBase__+10844;
      var $2554=__stackBase__+10848;
      var $2555=__stackBase__+10852;
      var $2556=__stackBase__+10856;
      var $result_i851=__stackBase__+10860;
      var $2557=__stackBase__+10864;
      var $2558=__stackBase__+10868;
      var $2559=__stackBase__+10872;
      var $2560=__stackBase__+10876;
      var $2561=__stackBase__+10880;
      var $result_i849=__stackBase__+10884;
      var $2562=__stackBase__+10888;
      var $2563=__stackBase__+10892;
      var $2564=__stackBase__+10896;
      var $2565=__stackBase__+10900;
      var $2566=__stackBase__+10904;
      var $result_i847=__stackBase__+10908;
      var $2567=__stackBase__+10912;
      var $2568=__stackBase__+10916;
      var $2569=__stackBase__+10920;
      var $2570=__stackBase__+10924;
      var $2571=__stackBase__+10928;
      var $result_i845=__stackBase__+10932;
      var $2572=__stackBase__+10936;
      var $2573=__stackBase__+10940;
      var $2574=__stackBase__+10944;
      var $2575=__stackBase__+10948;
      var $2576=__stackBase__+10952;
      var $result_i843=__stackBase__+10956;
      var $2577=__stackBase__+10960;
      var $2578=__stackBase__+10964;
      var $2579=__stackBase__+10968;
      var $2580=__stackBase__+10972;
      var $2581=__stackBase__+10976;
      var $result_i841=__stackBase__+10980;
      var $2582=__stackBase__+10984;
      var $2583=__stackBase__+10988;
      var $2584=__stackBase__+10992;
      var $2585=__stackBase__+10996;
      var $2586=__stackBase__+11000;
      var $result_i839=__stackBase__+11004;
      var $2587=__stackBase__+11008;
      var $2588=__stackBase__+11012;
      var $2589=__stackBase__+11016;
      var $2590=__stackBase__+11020;
      var $2591=__stackBase__+11024;
      var $result_i837=__stackBase__+11028;
      var $2592=__stackBase__+11032;
      var $2593=__stackBase__+11036;
      var $2594=__stackBase__+11040;
      var $2595=__stackBase__+11044;
      var $2596=__stackBase__+11048;
      var $result_i835=__stackBase__+11052;
      var $2597=__stackBase__+11056;
      var $2598=__stackBase__+11060;
      var $2599=__stackBase__+11064;
      var $2600=__stackBase__+11068;
      var $2601=__stackBase__+11072;
      var $result_i833=__stackBase__+11076;
      var $2602=__stackBase__+11080;
      var $2603=__stackBase__+11084;
      var $2604=__stackBase__+11088;
      var $2605=__stackBase__+11092;
      var $2606=__stackBase__+11096;
      var $result_i831=__stackBase__+11100;
      var $2607=__stackBase__+11104;
      var $2608=__stackBase__+11108;
      var $2609=__stackBase__+11112;
      var $2610=__stackBase__+11116;
      var $2611=__stackBase__+11120;
      var $result_i829=__stackBase__+11124;
      var $2612=__stackBase__+11128;
      var $2613=__stackBase__+11132;
      var $2614=__stackBase__+11136;
      var $2615=__stackBase__+11140;
      var $2616=__stackBase__+11144;
      var $result_i827=__stackBase__+11148;
      var $2617=__stackBase__+11152;
      var $2618=__stackBase__+11156;
      var $2619=__stackBase__+11160;
      var $2620=__stackBase__+11164;
      var $2621=__stackBase__+11168;
      var $result_i825=__stackBase__+11172;
      var $2622=__stackBase__+11176;
      var $2623=__stackBase__+11180;
      var $2624=__stackBase__+11184;
      var $2625=__stackBase__+11188;
      var $2626=__stackBase__+11192;
      var $result_i823=__stackBase__+11196;
      var $2627=__stackBase__+11200;
      var $2628=__stackBase__+11204;
      var $2629=__stackBase__+11208;
      var $2630=__stackBase__+11212;
      var $2631=__stackBase__+11216;
      var $result_i821=__stackBase__+11220;
      var $2632=__stackBase__+11224;
      var $2633=__stackBase__+11228;
      var $2634=__stackBase__+11232;
      var $2635=__stackBase__+11236;
      var $2636=__stackBase__+11240;
      var $result_i819=__stackBase__+11244;
      var $2637=__stackBase__+11248;
      var $2638=__stackBase__+11252;
      var $2639=__stackBase__+11256;
      var $2640=__stackBase__+11260;
      var $2641=__stackBase__+11264;
      var $result_i817=__stackBase__+11268;
      var $2642=__stackBase__+11272;
      var $2643=__stackBase__+11276;
      var $2644=__stackBase__+11280;
      var $2645=__stackBase__+11284;
      var $2646=__stackBase__+11288;
      var $result_i815=__stackBase__+11292;
      var $2647=__stackBase__+11296;
      var $2648=__stackBase__+11300;
      var $2649=__stackBase__+11304;
      var $2650=__stackBase__+11308;
      var $2651=__stackBase__+11312;
      var $result_i813=__stackBase__+11316;
      var $2652=__stackBase__+11320;
      var $2653=__stackBase__+11324;
      var $2654=__stackBase__+11328;
      var $2655=__stackBase__+11332;
      var $2656=__stackBase__+11336;
      var $result_i811=__stackBase__+11340;
      var $2657=__stackBase__+11344;
      var $2658=__stackBase__+11348;
      var $2659=__stackBase__+11352;
      var $2660=__stackBase__+11356;
      var $2661=__stackBase__+11360;
      var $result_i809=__stackBase__+11364;
      var $2662=__stackBase__+11368;
      var $2663=__stackBase__+11372;
      var $2664=__stackBase__+11376;
      var $2665=__stackBase__+11380;
      var $2666=__stackBase__+11384;
      var $result_i807=__stackBase__+11388;
      var $2667=__stackBase__+11392;
      var $2668=__stackBase__+11396;
      var $2669=__stackBase__+11400;
      var $2670=__stackBase__+11404;
      var $2671=__stackBase__+11408;
      var $result_i805=__stackBase__+11412;
      var $2672=__stackBase__+11416;
      var $2673=__stackBase__+11420;
      var $2674=__stackBase__+11424;
      var $2675=__stackBase__+11428;
      var $2676=__stackBase__+11432;
      var $result_i803=__stackBase__+11436;
      var $2677=__stackBase__+11440;
      var $2678=__stackBase__+11444;
      var $2679=__stackBase__+11448;
      var $2680=__stackBase__+11452;
      var $2681=__stackBase__+11456;
      var $result_i801=__stackBase__+11460;
      var $2682=__stackBase__+11464;
      var $2683=__stackBase__+11468;
      var $2684=__stackBase__+11472;
      var $2685=__stackBase__+11476;
      var $2686=__stackBase__+11480;
      var $result_i799=__stackBase__+11484;
      var $2687=__stackBase__+11488;
      var $2688=__stackBase__+11492;
      var $2689=__stackBase__+11496;
      var $2690=__stackBase__+11500;
      var $2691=__stackBase__+11504;
      var $result_i797=__stackBase__+11508;
      var $2692=__stackBase__+11512;
      var $2693=__stackBase__+11516;
      var $2694=__stackBase__+11520;
      var $2695=__stackBase__+11524;
      var $2696=__stackBase__+11528;
      var $result_i795=__stackBase__+11532;
      var $2697=__stackBase__+11536;
      var $2698=__stackBase__+11540;
      var $2699=__stackBase__+11544;
      var $2700=__stackBase__+11548;
      var $2701=__stackBase__+11552;
      var $result_i793=__stackBase__+11556;
      var $2702=__stackBase__+11560;
      var $2703=__stackBase__+11564;
      var $2704=__stackBase__+11568;
      var $2705=__stackBase__+11572;
      var $2706=__stackBase__+11576;
      var $result_i791=__stackBase__+11580;
      var $2707=__stackBase__+11584;
      var $2708=__stackBase__+11588;
      var $2709=__stackBase__+11592;
      var $2710=__stackBase__+11596;
      var $2711=__stackBase__+11600;
      var $result_i789=__stackBase__+11604;
      var $2712=__stackBase__+11608;
      var $2713=__stackBase__+11612;
      var $2714=__stackBase__+11616;
      var $2715=__stackBase__+11620;
      var $2716=__stackBase__+11624;
      var $result_i787=__stackBase__+11628;
      var $2717=__stackBase__+11632;
      var $2718=__stackBase__+11636;
      var $2719=__stackBase__+11640;
      var $2720=__stackBase__+11644;
      var $2721=__stackBase__+11648;
      var $result_i785=__stackBase__+11652;
      var $2722=__stackBase__+11656;
      var $2723=__stackBase__+11660;
      var $2724=__stackBase__+11664;
      var $2725=__stackBase__+11668;
      var $2726=__stackBase__+11672;
      var $result_i783=__stackBase__+11676;
      var $2727=__stackBase__+11680;
      var $2728=__stackBase__+11684;
      var $2729=__stackBase__+11688;
      var $2730=__stackBase__+11692;
      var $2731=__stackBase__+11696;
      var $result_i781=__stackBase__+11700;
      var $2732=__stackBase__+11704;
      var $2733=__stackBase__+11708;
      var $2734=__stackBase__+11712;
      var $2735=__stackBase__+11716;
      var $2736=__stackBase__+11720;
      var $result_i779=__stackBase__+11724;
      var $2737=__stackBase__+11728;
      var $2738=__stackBase__+11732;
      var $2739=__stackBase__+11736;
      var $2740=__stackBase__+11740;
      var $2741=__stackBase__+11744;
      var $result_i777=__stackBase__+11748;
      var $2742=__stackBase__+11752;
      var $2743=__stackBase__+11756;
      var $2744=__stackBase__+11760;
      var $2745=__stackBase__+11764;
      var $2746=__stackBase__+11768;
      var $result_i775=__stackBase__+11772;
      var $2747=__stackBase__+11776;
      var $2748=__stackBase__+11780;
      var $2749=__stackBase__+11784;
      var $2750=__stackBase__+11788;
      var $2751=__stackBase__+11792;
      var $result_i773=__stackBase__+11796;
      var $2752=__stackBase__+11800;
      var $2753=__stackBase__+11804;
      var $2754=__stackBase__+11808;
      var $2755=__stackBase__+11812;
      var $2756=__stackBase__+11816;
      var $result_i771=__stackBase__+11820;
      var $2757=__stackBase__+11824;
      var $2758=__stackBase__+11828;
      var $2759=__stackBase__+11832;
      var $2760=__stackBase__+11836;
      var $2761=__stackBase__+11840;
      var $result_i769=__stackBase__+11844;
      var $2762=__stackBase__+11848;
      var $2763=__stackBase__+11852;
      var $2764=__stackBase__+11856;
      var $2765=__stackBase__+11860;
      var $2766=__stackBase__+11864;
      var $result_i767=__stackBase__+11868;
      var $2767=__stackBase__+11872;
      var $2768=__stackBase__+11876;
      var $2769=__stackBase__+11880;
      var $2770=__stackBase__+11884;
      var $2771=__stackBase__+11888;
      var $result_i765=__stackBase__+11892;
      var $2772=__stackBase__+11896;
      var $2773=__stackBase__+11900;
      var $2774=__stackBase__+11904;
      var $2775=__stackBase__+11908;
      var $2776=__stackBase__+11912;
      var $result_i763=__stackBase__+11916;
      var $2777=__stackBase__+11920;
      var $2778=__stackBase__+11924;
      var $2779=__stackBase__+11928;
      var $2780=__stackBase__+11932;
      var $2781=__stackBase__+11936;
      var $result_i761=__stackBase__+11940;
      var $2782=__stackBase__+11944;
      var $2783=__stackBase__+11948;
      var $2784=__stackBase__+11952;
      var $2785=__stackBase__+11956;
      var $2786=__stackBase__+11960;
      var $result_i759=__stackBase__+11964;
      var $2787=__stackBase__+11968;
      var $2788=__stackBase__+11972;
      var $2789=__stackBase__+11976;
      var $2790=__stackBase__+11980;
      var $2791=__stackBase__+11984;
      var $result_i757=__stackBase__+11988;
      var $2792=__stackBase__+11992;
      var $2793=__stackBase__+11996;
      var $2794=__stackBase__+12000;
      var $2795=__stackBase__+12004;
      var $2796=__stackBase__+12008;
      var $result_i755=__stackBase__+12012;
      var $2797=__stackBase__+12016;
      var $2798=__stackBase__+12020;
      var $2799=__stackBase__+12024;
      var $2800=__stackBase__+12028;
      var $2801=__stackBase__+12032;
      var $result_i753=__stackBase__+12036;
      var $2802=__stackBase__+12040;
      var $2803=__stackBase__+12044;
      var $2804=__stackBase__+12048;
      var $2805=__stackBase__+12052;
      var $2806=__stackBase__+12056;
      var $result_i751=__stackBase__+12060;
      var $2807=__stackBase__+12064;
      var $2808=__stackBase__+12068;
      var $2809=__stackBase__+12072;
      var $2810=__stackBase__+12076;
      var $2811=__stackBase__+12080;
      var $result_i749=__stackBase__+12084;
      var $2812=__stackBase__+12088;
      var $2813=__stackBase__+12092;
      var $2814=__stackBase__+12096;
      var $2815=__stackBase__+12100;
      var $2816=__stackBase__+12104;
      var $result_i747=__stackBase__+12108;
      var $2817=__stackBase__+12112;
      var $2818=__stackBase__+12116;
      var $2819=__stackBase__+12120;
      var $2820=__stackBase__+12124;
      var $2821=__stackBase__+12128;
      var $result_i745=__stackBase__+12132;
      var $2822=__stackBase__+12136;
      var $2823=__stackBase__+12140;
      var $2824=__stackBase__+12144;
      var $2825=__stackBase__+12148;
      var $2826=__stackBase__+12152;
      var $result_i743=__stackBase__+12156;
      var $2827=__stackBase__+12160;
      var $2828=__stackBase__+12164;
      var $2829=__stackBase__+12168;
      var $2830=__stackBase__+12172;
      var $2831=__stackBase__+12176;
      var $result_i741=__stackBase__+12180;
      var $2832=__stackBase__+12184;
      var $2833=__stackBase__+12188;
      var $2834=__stackBase__+12192;
      var $2835=__stackBase__+12196;
      var $2836=__stackBase__+12200;
      var $result_i739=__stackBase__+12204;
      var $2837=__stackBase__+12208;
      var $2838=__stackBase__+12212;
      var $2839=__stackBase__+12216;
      var $2840=__stackBase__+12220;
      var $2841=__stackBase__+12224;
      var $result_i737=__stackBase__+12228;
      var $2842=__stackBase__+12232;
      var $2843=__stackBase__+12236;
      var $2844=__stackBase__+12240;
      var $2845=__stackBase__+12244;
      var $2846=__stackBase__+12248;
      var $result_i735=__stackBase__+12252;
      var $2847=__stackBase__+12256;
      var $2848=__stackBase__+12260;
      var $2849=__stackBase__+12264;
      var $2850=__stackBase__+12268;
      var $2851=__stackBase__+12272;
      var $result_i733=__stackBase__+12276;
      var $2852=__stackBase__+12280;
      var $2853=__stackBase__+12284;
      var $2854=__stackBase__+12288;
      var $2855=__stackBase__+12292;
      var $2856=__stackBase__+12296;
      var $result_i731=__stackBase__+12300;
      var $2857=__stackBase__+12304;
      var $2858=__stackBase__+12308;
      var $2859=__stackBase__+12312;
      var $2860=__stackBase__+12316;
      var $2861=__stackBase__+12320;
      var $result_i729=__stackBase__+12324;
      var $2862=__stackBase__+12328;
      var $2863=__stackBase__+12332;
      var $2864=__stackBase__+12336;
      var $2865=__stackBase__+12340;
      var $2866=__stackBase__+12344;
      var $result_i727=__stackBase__+12348;
      var $2867=__stackBase__+12352;
      var $2868=__stackBase__+12356;
      var $2869=__stackBase__+12360;
      var $2870=__stackBase__+12364;
      var $2871=__stackBase__+12368;
      var $result_i725=__stackBase__+12372;
      var $2872=__stackBase__+12376;
      var $2873=__stackBase__+12380;
      var $2874=__stackBase__+12384;
      var $2875=__stackBase__+12388;
      var $2876=__stackBase__+12392;
      var $result_i723=__stackBase__+12396;
      var $2877=__stackBase__+12400;
      var $2878=__stackBase__+12404;
      var $2879=__stackBase__+12408;
      var $2880=__stackBase__+12412;
      var $2881=__stackBase__+12416;
      var $result_i721=__stackBase__+12420;
      var $2882=__stackBase__+12424;
      var $2883=__stackBase__+12428;
      var $2884=__stackBase__+12432;
      var $2885=__stackBase__+12436;
      var $2886=__stackBase__+12440;
      var $result_i719=__stackBase__+12444;
      var $2887=__stackBase__+12448;
      var $2888=__stackBase__+12452;
      var $2889=__stackBase__+12456;
      var $2890=__stackBase__+12460;
      var $2891=__stackBase__+12464;
      var $result_i717=__stackBase__+12468;
      var $2892=__stackBase__+12472;
      var $2893=__stackBase__+12476;
      var $2894=__stackBase__+12480;
      var $2895=__stackBase__+12484;
      var $2896=__stackBase__+12488;
      var $result_i715=__stackBase__+12492;
      var $2897=__stackBase__+12496;
      var $2898=__stackBase__+12500;
      var $2899=__stackBase__+12504;
      var $2900=__stackBase__+12508;
      var $2901=__stackBase__+12512;
      var $result_i713=__stackBase__+12516;
      var $2902=__stackBase__+12520;
      var $2903=__stackBase__+12524;
      var $2904=__stackBase__+12528;
      var $2905=__stackBase__+12532;
      var $2906=__stackBase__+12536;
      var $result_i711=__stackBase__+12540;
      var $2907=__stackBase__+12544;
      var $2908=__stackBase__+12548;
      var $2909=__stackBase__+12552;
      var $2910=__stackBase__+12556;
      var $2911=__stackBase__+12560;
      var $result_i709=__stackBase__+12564;
      var $2912=__stackBase__+12568;
      var $2913=__stackBase__+12572;
      var $2914=__stackBase__+12576;
      var $2915=__stackBase__+12580;
      var $2916=__stackBase__+12584;
      var $result_i707=__stackBase__+12588;
      var $2917=__stackBase__+12592;
      var $2918=__stackBase__+12596;
      var $2919=__stackBase__+12600;
      var $2920=__stackBase__+12604;
      var $2921=__stackBase__+12608;
      var $result_i705=__stackBase__+12612;
      var $2922=__stackBase__+12616;
      var $2923=__stackBase__+12620;
      var $2924=__stackBase__+12624;
      var $2925=__stackBase__+12628;
      var $2926=__stackBase__+12632;
      var $result_i703=__stackBase__+12636;
      var $2927=__stackBase__+12640;
      var $2928=__stackBase__+12644;
      var $2929=__stackBase__+12648;
      var $2930=__stackBase__+12652;
      var $2931=__stackBase__+12656;
      var $result_i701=__stackBase__+12660;
      var $2932=__stackBase__+12664;
      var $2933=__stackBase__+12668;
      var $2934=__stackBase__+12672;
      var $2935=__stackBase__+12676;
      var $2936=__stackBase__+12680;
      var $result_i699=__stackBase__+12684;
      var $2937=__stackBase__+12688;
      var $2938=__stackBase__+12692;
      var $2939=__stackBase__+12696;
      var $2940=__stackBase__+12700;
      var $2941=__stackBase__+12704;
      var $result_i697=__stackBase__+12708;
      var $2942=__stackBase__+12712;
      var $2943=__stackBase__+12716;
      var $2944=__stackBase__+12720;
      var $2945=__stackBase__+12724;
      var $2946=__stackBase__+12728;
      var $result_i695=__stackBase__+12732;
      var $2947=__stackBase__+12736;
      var $2948=__stackBase__+12740;
      var $2949=__stackBase__+12744;
      var $2950=__stackBase__+12748;
      var $2951=__stackBase__+12752;
      var $result_i693=__stackBase__+12756;
      var $2952=__stackBase__+12760;
      var $2953=__stackBase__+12764;
      var $2954=__stackBase__+12768;
      var $2955=__stackBase__+12772;
      var $2956=__stackBase__+12776;
      var $result_i691=__stackBase__+12780;
      var $2957=__stackBase__+12784;
      var $2958=__stackBase__+12788;
      var $2959=__stackBase__+12792;
      var $2960=__stackBase__+12796;
      var $2961=__stackBase__+12800;
      var $result_i689=__stackBase__+12804;
      var $2962=__stackBase__+12808;
      var $2963=__stackBase__+12812;
      var $2964=__stackBase__+12816;
      var $2965=__stackBase__+12820;
      var $2966=__stackBase__+12824;
      var $result_i687=__stackBase__+12828;
      var $2967=__stackBase__+12832;
      var $2968=__stackBase__+12836;
      var $2969=__stackBase__+12840;
      var $2970=__stackBase__+12844;
      var $2971=__stackBase__+12848;
      var $result_i685=__stackBase__+12852;
      var $2972=__stackBase__+12856;
      var $2973=__stackBase__+12860;
      var $2974=__stackBase__+12864;
      var $2975=__stackBase__+12868;
      var $2976=__stackBase__+12872;
      var $result_i683=__stackBase__+12876;
      var $2977=__stackBase__+12880;
      var $2978=__stackBase__+12884;
      var $2979=__stackBase__+12888;
      var $2980=__stackBase__+12892;
      var $2981=__stackBase__+12896;
      var $result_i681=__stackBase__+12900;
      var $2982=__stackBase__+12904;
      var $2983=__stackBase__+12908;
      var $2984=__stackBase__+12912;
      var $2985=__stackBase__+12916;
      var $2986=__stackBase__+12920;
      var $result_i679=__stackBase__+12924;
      var $2987=__stackBase__+12928;
      var $2988=__stackBase__+12932;
      var $2989=__stackBase__+12936;
      var $2990=__stackBase__+12940;
      var $2991=__stackBase__+12944;
      var $result_i677=__stackBase__+12948;
      var $2992=__stackBase__+12952;
      var $2993=__stackBase__+12956;
      var $2994=__stackBase__+12960;
      var $2995=__stackBase__+12964;
      var $2996=__stackBase__+12968;
      var $result_i675=__stackBase__+12972;
      var $2997=__stackBase__+12976;
      var $2998=__stackBase__+12980;
      var $2999=__stackBase__+12984;
      var $3000=__stackBase__+12988;
      var $3001=__stackBase__+12992;
      var $result_i673=__stackBase__+12996;
      var $3002=__stackBase__+13000;
      var $3003=__stackBase__+13004;
      var $3004=__stackBase__+13008;
      var $3005=__stackBase__+13012;
      var $3006=__stackBase__+13016;
      var $result_i671=__stackBase__+13020;
      var $3007=__stackBase__+13024;
      var $3008=__stackBase__+13028;
      var $3009=__stackBase__+13032;
      var $3010=__stackBase__+13036;
      var $3011=__stackBase__+13040;
      var $result_i669=__stackBase__+13044;
      var $3012=__stackBase__+13048;
      var $3013=__stackBase__+13052;
      var $3014=__stackBase__+13056;
      var $3015=__stackBase__+13060;
      var $3016=__stackBase__+13064;
      var $result_i667=__stackBase__+13068;
      var $3017=__stackBase__+13072;
      var $3018=__stackBase__+13076;
      var $3019=__stackBase__+13080;
      var $3020=__stackBase__+13084;
      var $3021=__stackBase__+13088;
      var $result_i665=__stackBase__+13092;
      var $3022=__stackBase__+13096;
      var $3023=__stackBase__+13100;
      var $3024=__stackBase__+13104;
      var $3025=__stackBase__+13108;
      var $3026=__stackBase__+13112;
      var $result_i663=__stackBase__+13116;
      var $3027=__stackBase__+13120;
      var $3028=__stackBase__+13124;
      var $3029=__stackBase__+13128;
      var $3030=__stackBase__+13132;
      var $3031=__stackBase__+13136;
      var $result_i661=__stackBase__+13140;
      var $3032=__stackBase__+13144;
      var $3033=__stackBase__+13148;
      var $3034=__stackBase__+13152;
      var $3035=__stackBase__+13156;
      var $3036=__stackBase__+13160;
      var $result_i659=__stackBase__+13164;
      var $3037=__stackBase__+13168;
      var $3038=__stackBase__+13172;
      var $3039=__stackBase__+13176;
      var $3040=__stackBase__+13180;
      var $3041=__stackBase__+13184;
      var $result_i657=__stackBase__+13188;
      var $3042=__stackBase__+13192;
      var $3043=__stackBase__+13196;
      var $3044=__stackBase__+13200;
      var $3045=__stackBase__+13204;
      var $3046=__stackBase__+13208;
      var $result_i655=__stackBase__+13212;
      var $3047=__stackBase__+13216;
      var $3048=__stackBase__+13220;
      var $3049=__stackBase__+13224;
      var $3050=__stackBase__+13228;
      var $3051=__stackBase__+13232;
      var $result_i653=__stackBase__+13236;
      var $3052=__stackBase__+13240;
      var $3053=__stackBase__+13244;
      var $3054=__stackBase__+13248;
      var $3055=__stackBase__+13252;
      var $3056=__stackBase__+13256;
      var $result_i651=__stackBase__+13260;
      var $3057=__stackBase__+13264;
      var $3058=__stackBase__+13268;
      var $3059=__stackBase__+13272;
      var $3060=__stackBase__+13276;
      var $3061=__stackBase__+13280;
      var $result_i649=__stackBase__+13284;
      var $3062=__stackBase__+13288;
      var $3063=__stackBase__+13292;
      var $3064=__stackBase__+13296;
      var $3065=__stackBase__+13300;
      var $3066=__stackBase__+13304;
      var $result_i647=__stackBase__+13308;
      var $3067=__stackBase__+13312;
      var $3068=__stackBase__+13316;
      var $3069=__stackBase__+13320;
      var $3070=__stackBase__+13324;
      var $3071=__stackBase__+13328;
      var $result_i645=__stackBase__+13332;
      var $3072=__stackBase__+13336;
      var $3073=__stackBase__+13340;
      var $3074=__stackBase__+13344;
      var $3075=__stackBase__+13348;
      var $3076=__stackBase__+13352;
      var $result_i643=__stackBase__+13356;
      var $3077=__stackBase__+13360;
      var $3078=__stackBase__+13364;
      var $3079=__stackBase__+13368;
      var $3080=__stackBase__+13372;
      var $3081=__stackBase__+13376;
      var $result_i641=__stackBase__+13380;
      var $3082=__stackBase__+13384;
      var $3083=__stackBase__+13388;
      var $3084=__stackBase__+13392;
      var $3085=__stackBase__+13396;
      var $3086=__stackBase__+13400;
      var $result_i639=__stackBase__+13404;
      var $3087=__stackBase__+13408;
      var $3088=__stackBase__+13412;
      var $3089=__stackBase__+13416;
      var $3090=__stackBase__+13420;
      var $3091=__stackBase__+13424;
      var $result_i637=__stackBase__+13428;
      var $3092=__stackBase__+13432;
      var $3093=__stackBase__+13436;
      var $3094=__stackBase__+13440;
      var $3095=__stackBase__+13444;
      var $3096=__stackBase__+13448;
      var $result_i635=__stackBase__+13452;
      var $3097=__stackBase__+13456;
      var $3098=__stackBase__+13460;
      var $3099=__stackBase__+13464;
      var $3100=__stackBase__+13468;
      var $3101=__stackBase__+13472;
      var $result_i633=__stackBase__+13476;
      var $3102=__stackBase__+13480;
      var $3103=__stackBase__+13484;
      var $3104=__stackBase__+13488;
      var $3105=__stackBase__+13492;
      var $3106=__stackBase__+13496;
      var $result_i631=__stackBase__+13500;
      var $3107=__stackBase__+13504;
      var $3108=__stackBase__+13508;
      var $3109=__stackBase__+13512;
      var $3110=__stackBase__+13516;
      var $3111=__stackBase__+13520;
      var $result_i629=__stackBase__+13524;
      var $3112=__stackBase__+13528;
      var $3113=__stackBase__+13532;
      var $3114=__stackBase__+13536;
      var $3115=__stackBase__+13540;
      var $3116=__stackBase__+13544;
      var $result_i627=__stackBase__+13548;
      var $3117=__stackBase__+13552;
      var $3118=__stackBase__+13556;
      var $3119=__stackBase__+13560;
      var $3120=__stackBase__+13564;
      var $3121=__stackBase__+13568;
      var $result_i625=__stackBase__+13572;
      var $3122=__stackBase__+13576;
      var $3123=__stackBase__+13580;
      var $3124=__stackBase__+13584;
      var $3125=__stackBase__+13588;
      var $3126=__stackBase__+13592;
      var $result_i623=__stackBase__+13596;
      var $3127=__stackBase__+13600;
      var $3128=__stackBase__+13604;
      var $3129=__stackBase__+13608;
      var $3130=__stackBase__+13612;
      var $3131=__stackBase__+13616;
      var $result_i621=__stackBase__+13620;
      var $3132=__stackBase__+13624;
      var $3133=__stackBase__+13628;
      var $3134=__stackBase__+13632;
      var $3135=__stackBase__+13636;
      var $3136=__stackBase__+13640;
      var $result_i619=__stackBase__+13644;
      var $3137=__stackBase__+13648;
      var $3138=__stackBase__+13652;
      var $3139=__stackBase__+13656;
      var $3140=__stackBase__+13660;
      var $3141=__stackBase__+13664;
      var $result_i617=__stackBase__+13668;
      var $3142=__stackBase__+13672;
      var $3143=__stackBase__+13676;
      var $3144=__stackBase__+13680;
      var $3145=__stackBase__+13684;
      var $3146=__stackBase__+13688;
      var $result_i615=__stackBase__+13692;
      var $3147=__stackBase__+13696;
      var $3148=__stackBase__+13700;
      var $3149=__stackBase__+13704;
      var $3150=__stackBase__+13708;
      var $3151=__stackBase__+13712;
      var $result_i613=__stackBase__+13716;
      var $3152=__stackBase__+13720;
      var $3153=__stackBase__+13724;
      var $3154=__stackBase__+13728;
      var $3155=__stackBase__+13732;
      var $3156=__stackBase__+13736;
      var $result_i611=__stackBase__+13740;
      var $3157=__stackBase__+13744;
      var $3158=__stackBase__+13748;
      var $3159=__stackBase__+13752;
      var $3160=__stackBase__+13756;
      var $3161=__stackBase__+13760;
      var $result_i609=__stackBase__+13764;
      var $3162=__stackBase__+13768;
      var $3163=__stackBase__+13772;
      var $3164=__stackBase__+13776;
      var $3165=__stackBase__+13780;
      var $3166=__stackBase__+13784;
      var $result_i607=__stackBase__+13788;
      var $3167=__stackBase__+13792;
      var $3168=__stackBase__+13796;
      var $3169=__stackBase__+13800;
      var $3170=__stackBase__+13804;
      var $3171=__stackBase__+13808;
      var $result_i605=__stackBase__+13812;
      var $3172=__stackBase__+13816;
      var $3173=__stackBase__+13820;
      var $3174=__stackBase__+13824;
      var $3175=__stackBase__+13828;
      var $3176=__stackBase__+13832;
      var $result_i603=__stackBase__+13836;
      var $3177=__stackBase__+13840;
      var $3178=__stackBase__+13844;
      var $3179=__stackBase__+13848;
      var $3180=__stackBase__+13852;
      var $3181=__stackBase__+13856;
      var $result_i601=__stackBase__+13860;
      var $3182=__stackBase__+13864;
      var $3183=__stackBase__+13868;
      var $3184=__stackBase__+13872;
      var $3185=__stackBase__+13876;
      var $3186=__stackBase__+13880;
      var $result_i599=__stackBase__+13884;
      var $3187=__stackBase__+13888;
      var $3188=__stackBase__+13892;
      var $3189=__stackBase__+13896;
      var $3190=__stackBase__+13900;
      var $3191=__stackBase__+13904;
      var $result_i597=__stackBase__+13908;
      var $3192=__stackBase__+13912;
      var $3193=__stackBase__+13916;
      var $3194=__stackBase__+13920;
      var $3195=__stackBase__+13924;
      var $3196=__stackBase__+13928;
      var $result_i595=__stackBase__+13932;
      var $3197=__stackBase__+13936;
      var $3198=__stackBase__+13940;
      var $3199=__stackBase__+13944;
      var $3200=__stackBase__+13948;
      var $3201=__stackBase__+13952;
      var $result_i593=__stackBase__+13956;
      var $3202=__stackBase__+13960;
      var $3203=__stackBase__+13964;
      var $3204=__stackBase__+13968;
      var $3205=__stackBase__+13972;
      var $3206=__stackBase__+13976;
      var $result_i591=__stackBase__+13980;
      var $3207=__stackBase__+13984;
      var $3208=__stackBase__+13988;
      var $3209=__stackBase__+13992;
      var $3210=__stackBase__+13996;
      var $3211=__stackBase__+14000;
      var $result_i589=__stackBase__+14004;
      var $3212=__stackBase__+14008;
      var $3213=__stackBase__+14012;
      var $3214=__stackBase__+14016;
      var $3215=__stackBase__+14020;
      var $3216=__stackBase__+14024;
      var $result_i587=__stackBase__+14028;
      var $3217=__stackBase__+14032;
      var $3218=__stackBase__+14036;
      var $3219=__stackBase__+14040;
      var $3220=__stackBase__+14044;
      var $3221=__stackBase__+14048;
      var $result_i585=__stackBase__+14052;
      var $3222=__stackBase__+14056;
      var $3223=__stackBase__+14060;
      var $3224=__stackBase__+14064;
      var $3225=__stackBase__+14068;
      var $3226=__stackBase__+14072;
      var $result_i583=__stackBase__+14076;
      var $3227=__stackBase__+14080;
      var $3228=__stackBase__+14084;
      var $3229=__stackBase__+14088;
      var $3230=__stackBase__+14092;
      var $3231=__stackBase__+14096;
      var $result_i581=__stackBase__+14100;
      var $3232=__stackBase__+14104;
      var $3233=__stackBase__+14108;
      var $3234=__stackBase__+14112;
      var $3235=__stackBase__+14116;
      var $3236=__stackBase__+14120;
      var $result_i579=__stackBase__+14124;
      var $3237=__stackBase__+14128;
      var $3238=__stackBase__+14132;
      var $3239=__stackBase__+14136;
      var $3240=__stackBase__+14140;
      var $3241=__stackBase__+14144;
      var $result_i577=__stackBase__+14148;
      var $3242=__stackBase__+14152;
      var $3243=__stackBase__+14156;
      var $3244=__stackBase__+14160;
      var $3245=__stackBase__+14164;
      var $3246=__stackBase__+14168;
      var $result_i575=__stackBase__+14172;
      var $3247=__stackBase__+14176;
      var $3248=__stackBase__+14180;
      var $3249=__stackBase__+14184;
      var $3250=__stackBase__+14188;
      var $3251=__stackBase__+14192;
      var $result_i573=__stackBase__+14196;
      var $3252=__stackBase__+14200;
      var $3253=__stackBase__+14204;
      var $3254=__stackBase__+14208;
      var $3255=__stackBase__+14212;
      var $3256=__stackBase__+14216;
      var $result_i571=__stackBase__+14220;
      var $3257=__stackBase__+14224;
      var $3258=__stackBase__+14228;
      var $3259=__stackBase__+14232;
      var $3260=__stackBase__+14236;
      var $3261=__stackBase__+14240;
      var $result_i569=__stackBase__+14244;
      var $3262=__stackBase__+14248;
      var $3263=__stackBase__+14252;
      var $3264=__stackBase__+14256;
      var $3265=__stackBase__+14260;
      var $3266=__stackBase__+14264;
      var $result_i567=__stackBase__+14268;
      var $3267=__stackBase__+14272;
      var $3268=__stackBase__+14276;
      var $3269=__stackBase__+14280;
      var $3270=__stackBase__+14284;
      var $3271=__stackBase__+14288;
      var $result_i565=__stackBase__+14292;
      var $3272=__stackBase__+14296;
      var $3273=__stackBase__+14300;
      var $3274=__stackBase__+14304;
      var $3275=__stackBase__+14308;
      var $3276=__stackBase__+14312;
      var $result_i563=__stackBase__+14316;
      var $3277=__stackBase__+14320;
      var $3278=__stackBase__+14324;
      var $3279=__stackBase__+14328;
      var $3280=__stackBase__+14332;
      var $3281=__stackBase__+14336;
      var $result_i561=__stackBase__+14340;
      var $3282=__stackBase__+14344;
      var $3283=__stackBase__+14348;
      var $3284=__stackBase__+14352;
      var $3285=__stackBase__+14356;
      var $3286=__stackBase__+14360;
      var $result_i559=__stackBase__+14364;
      var $3287=__stackBase__+14368;
      var $3288=__stackBase__+14372;
      var $3289=__stackBase__+14376;
      var $3290=__stackBase__+14380;
      var $3291=__stackBase__+14384;
      var $result_i557=__stackBase__+14388;
      var $3292=__stackBase__+14392;
      var $3293=__stackBase__+14396;
      var $3294=__stackBase__+14400;
      var $3295=__stackBase__+14404;
      var $3296=__stackBase__+14408;
      var $result_i555=__stackBase__+14412;
      var $3297=__stackBase__+14416;
      var $3298=__stackBase__+14420;
      var $3299=__stackBase__+14424;
      var $3300=__stackBase__+14428;
      var $3301=__stackBase__+14432;
      var $result_i553=__stackBase__+14436;
      var $3302=__stackBase__+14440;
      var $3303=__stackBase__+14444;
      var $3304=__stackBase__+14448;
      var $3305=__stackBase__+14452;
      var $3306=__stackBase__+14456;
      var $result_i551=__stackBase__+14460;
      var $3307=__stackBase__+14464;
      var $3308=__stackBase__+14468;
      var $3309=__stackBase__+14472;
      var $3310=__stackBase__+14476;
      var $3311=__stackBase__+14480;
      var $result_i549=__stackBase__+14484;
      var $3312=__stackBase__+14488;
      var $3313=__stackBase__+14492;
      var $3314=__stackBase__+14496;
      var $3315=__stackBase__+14500;
      var $3316=__stackBase__+14504;
      var $result_i547=__stackBase__+14508;
      var $3317=__stackBase__+14512;
      var $3318=__stackBase__+14516;
      var $3319=__stackBase__+14520;
      var $3320=__stackBase__+14524;
      var $3321=__stackBase__+14528;
      var $result_i545=__stackBase__+14532;
      var $3322=__stackBase__+14536;
      var $3323=__stackBase__+14540;
      var $3324=__stackBase__+14544;
      var $3325=__stackBase__+14548;
      var $3326=__stackBase__+14552;
      var $result_i543=__stackBase__+14556;
      var $3327=__stackBase__+14560;
      var $3328=__stackBase__+14564;
      var $3329=__stackBase__+14568;
      var $3330=__stackBase__+14572;
      var $3331=__stackBase__+14576;
      var $result_i541=__stackBase__+14580;
      var $3332=__stackBase__+14584;
      var $3333=__stackBase__+14588;
      var $3334=__stackBase__+14592;
      var $3335=__stackBase__+14596;
      var $3336=__stackBase__+14600;
      var $result_i539=__stackBase__+14604;
      var $3337=__stackBase__+14608;
      var $3338=__stackBase__+14612;
      var $3339=__stackBase__+14616;
      var $3340=__stackBase__+14620;
      var $3341=__stackBase__+14624;
      var $result_i537=__stackBase__+14628;
      var $3342=__stackBase__+14632;
      var $3343=__stackBase__+14636;
      var $3344=__stackBase__+14640;
      var $3345=__stackBase__+14644;
      var $3346=__stackBase__+14648;
      var $result_i535=__stackBase__+14652;
      var $3347=__stackBase__+14656;
      var $3348=__stackBase__+14660;
      var $3349=__stackBase__+14664;
      var $3350=__stackBase__+14668;
      var $3351=__stackBase__+14672;
      var $result_i533=__stackBase__+14676;
      var $3352=__stackBase__+14680;
      var $3353=__stackBase__+14684;
      var $3354=__stackBase__+14688;
      var $3355=__stackBase__+14692;
      var $3356=__stackBase__+14696;
      var $result_i531=__stackBase__+14700;
      var $3357=__stackBase__+14704;
      var $3358=__stackBase__+14708;
      var $3359=__stackBase__+14712;
      var $3360=__stackBase__+14716;
      var $3361=__stackBase__+14720;
      var $result_i529=__stackBase__+14724;
      var $3362=__stackBase__+14728;
      var $3363=__stackBase__+14732;
      var $3364=__stackBase__+14736;
      var $3365=__stackBase__+14740;
      var $3366=__stackBase__+14744;
      var $result_i527=__stackBase__+14748;
      var $3367=__stackBase__+14752;
      var $3368=__stackBase__+14756;
      var $3369=__stackBase__+14760;
      var $3370=__stackBase__+14764;
      var $3371=__stackBase__+14768;
      var $result_i525=__stackBase__+14772;
      var $3372=__stackBase__+14776;
      var $3373=__stackBase__+14780;
      var $3374=__stackBase__+14784;
      var $3375=__stackBase__+14788;
      var $3376=__stackBase__+14792;
      var $result_i523=__stackBase__+14796;
      var $3377=__stackBase__+14800;
      var $3378=__stackBase__+14804;
      var $3379=__stackBase__+14808;
      var $3380=__stackBase__+14812;
      var $3381=__stackBase__+14816;
      var $result_i521=__stackBase__+14820;
      var $3382=__stackBase__+14824;
      var $3383=__stackBase__+14828;
      var $3384=__stackBase__+14832;
      var $3385=__stackBase__+14836;
      var $3386=__stackBase__+14840;
      var $result_i519=__stackBase__+14844;
      var $3387=__stackBase__+14848;
      var $3388=__stackBase__+14852;
      var $3389=__stackBase__+14856;
      var $3390=__stackBase__+14860;
      var $3391=__stackBase__+14864;
      var $result_i517=__stackBase__+14868;
      var $3392=__stackBase__+14872;
      var $3393=__stackBase__+14876;
      var $3394=__stackBase__+14880;
      var $3395=__stackBase__+14884;
      var $3396=__stackBase__+14888;
      var $result_i515=__stackBase__+14892;
      var $3397=__stackBase__+14896;
      var $3398=__stackBase__+14900;
      var $3399=__stackBase__+14904;
      var $3400=__stackBase__+14908;
      var $3401=__stackBase__+14912;
      var $result_i513=__stackBase__+14916;
      var $3402=__stackBase__+14920;
      var $3403=__stackBase__+14924;
      var $3404=__stackBase__+14928;
      var $3405=__stackBase__+14932;
      var $3406=__stackBase__+14936;
      var $result_i511=__stackBase__+14940;
      var $3407=__stackBase__+14944;
      var $3408=__stackBase__+14948;
      var $3409=__stackBase__+14952;
      var $3410=__stackBase__+14956;
      var $3411=__stackBase__+14960;
      var $result_i509=__stackBase__+14964;
      var $3412=__stackBase__+14968;
      var $3413=__stackBase__+14972;
      var $3414=__stackBase__+14976;
      var $3415=__stackBase__+14980;
      var $3416=__stackBase__+14984;
      var $result_i507=__stackBase__+14988;
      var $3417=__stackBase__+14992;
      var $3418=__stackBase__+14996;
      var $3419=__stackBase__+15000;
      var $3420=__stackBase__+15004;
      var $3421=__stackBase__+15008;
      var $result_i505=__stackBase__+15012;
      var $3422=__stackBase__+15016;
      var $3423=__stackBase__+15020;
      var $3424=__stackBase__+15024;
      var $3425=__stackBase__+15028;
      var $3426=__stackBase__+15032;
      var $result_i503=__stackBase__+15036;
      var $3427=__stackBase__+15040;
      var $3428=__stackBase__+15044;
      var $3429=__stackBase__+15048;
      var $3430=__stackBase__+15052;
      var $3431=__stackBase__+15056;
      var $result_i501=__stackBase__+15060;
      var $3432=__stackBase__+15064;
      var $3433=__stackBase__+15068;
      var $3434=__stackBase__+15072;
      var $3435=__stackBase__+15076;
      var $3436=__stackBase__+15080;
      var $result_i499=__stackBase__+15084;
      var $3437=__stackBase__+15088;
      var $3438=__stackBase__+15092;
      var $3439=__stackBase__+15096;
      var $3440=__stackBase__+15100;
      var $3441=__stackBase__+15104;
      var $result_i497=__stackBase__+15108;
      var $3442=__stackBase__+15112;
      var $3443=__stackBase__+15116;
      var $3444=__stackBase__+15120;
      var $3445=__stackBase__+15124;
      var $3446=__stackBase__+15128;
      var $result_i495=__stackBase__+15132;
      var $3447=__stackBase__+15136;
      var $3448=__stackBase__+15140;
      var $3449=__stackBase__+15144;
      var $3450=__stackBase__+15148;
      var $3451=__stackBase__+15152;
      var $result_i493=__stackBase__+15156;
      var $3452=__stackBase__+15160;
      var $3453=__stackBase__+15164;
      var $3454=__stackBase__+15168;
      var $3455=__stackBase__+15172;
      var $3456=__stackBase__+15176;
      var $result_i491=__stackBase__+15180;
      var $3457=__stackBase__+15184;
      var $3458=__stackBase__+15188;
      var $3459=__stackBase__+15192;
      var $3460=__stackBase__+15196;
      var $3461=__stackBase__+15200;
      var $result_i489=__stackBase__+15204;
      var $3462=__stackBase__+15208;
      var $3463=__stackBase__+15212;
      var $3464=__stackBase__+15216;
      var $3465=__stackBase__+15220;
      var $3466=__stackBase__+15224;
      var $result_i487=__stackBase__+15228;
      var $3467=__stackBase__+15232;
      var $3468=__stackBase__+15236;
      var $3469=__stackBase__+15240;
      var $3470=__stackBase__+15244;
      var $3471=__stackBase__+15248;
      var $result_i485=__stackBase__+15252;
      var $3472=__stackBase__+15256;
      var $3473=__stackBase__+15260;
      var $3474=__stackBase__+15264;
      var $3475=__stackBase__+15268;
      var $3476=__stackBase__+15272;
      var $result_i483=__stackBase__+15276;
      var $3477=__stackBase__+15280;
      var $3478=__stackBase__+15284;
      var $3479=__stackBase__+15288;
      var $3480=__stackBase__+15292;
      var $3481=__stackBase__+15296;
      var $result_i481=__stackBase__+15300;
      var $3482=__stackBase__+15304;
      var $3483=__stackBase__+15308;
      var $3484=__stackBase__+15312;
      var $3485=__stackBase__+15316;
      var $3486=__stackBase__+15320;
      var $result_i479=__stackBase__+15324;
      var $3487=__stackBase__+15328;
      var $3488=__stackBase__+15332;
      var $3489=__stackBase__+15336;
      var $3490=__stackBase__+15340;
      var $3491=__stackBase__+15344;
      var $result_i477=__stackBase__+15348;
      var $3492=__stackBase__+15352;
      var $3493=__stackBase__+15356;
      var $3494=__stackBase__+15360;
      var $3495=__stackBase__+15364;
      var $3496=__stackBase__+15368;
      var $result_i475=__stackBase__+15372;
      var $3497=__stackBase__+15376;
      var $3498=__stackBase__+15380;
      var $3499=__stackBase__+15384;
      var $3500=__stackBase__+15388;
      var $3501=__stackBase__+15392;
      var $result_i473=__stackBase__+15396;
      var $3502=__stackBase__+15400;
      var $3503=__stackBase__+15404;
      var $3504=__stackBase__+15408;
      var $3505=__stackBase__+15412;
      var $3506=__stackBase__+15416;
      var $result_i471=__stackBase__+15420;
      var $3507=__stackBase__+15424;
      var $3508=__stackBase__+15428;
      var $3509=__stackBase__+15432;
      var $3510=__stackBase__+15436;
      var $3511=__stackBase__+15440;
      var $result_i469=__stackBase__+15444;
      var $3512=__stackBase__+15448;
      var $3513=__stackBase__+15452;
      var $3514=__stackBase__+15456;
      var $3515=__stackBase__+15460;
      var $3516=__stackBase__+15464;
      var $result_i467=__stackBase__+15468;
      var $3517=__stackBase__+15472;
      var $3518=__stackBase__+15476;
      var $3519=__stackBase__+15480;
      var $3520=__stackBase__+15484;
      var $3521=__stackBase__+15488;
      var $result_i465=__stackBase__+15492;
      var $3522=__stackBase__+15496;
      var $3523=__stackBase__+15500;
      var $3524=__stackBase__+15504;
      var $3525=__stackBase__+15508;
      var $3526=__stackBase__+15512;
      var $result_i463=__stackBase__+15516;
      var $3527=__stackBase__+15520;
      var $3528=__stackBase__+15524;
      var $3529=__stackBase__+15528;
      var $3530=__stackBase__+15532;
      var $3531=__stackBase__+15536;
      var $result_i461=__stackBase__+15540;
      var $3532=__stackBase__+15544;
      var $3533=__stackBase__+15548;
      var $3534=__stackBase__+15552;
      var $3535=__stackBase__+15556;
      var $3536=__stackBase__+15560;
      var $result_i459=__stackBase__+15564;
      var $3537=__stackBase__+15568;
      var $3538=__stackBase__+15572;
      var $3539=__stackBase__+15576;
      var $3540=__stackBase__+15580;
      var $3541=__stackBase__+15584;
      var $result_i457=__stackBase__+15588;
      var $3542=__stackBase__+15592;
      var $3543=__stackBase__+15596;
      var $3544=__stackBase__+15600;
      var $3545=__stackBase__+15604;
      var $3546=__stackBase__+15608;
      var $result_i455=__stackBase__+15612;
      var $3547=__stackBase__+15616;
      var $3548=__stackBase__+15620;
      var $3549=__stackBase__+15624;
      var $3550=__stackBase__+15628;
      var $3551=__stackBase__+15632;
      var $result_i453=__stackBase__+15636;
      var $3552=__stackBase__+15640;
      var $3553=__stackBase__+15644;
      var $3554=__stackBase__+15648;
      var $3555=__stackBase__+15652;
      var $3556=__stackBase__+15656;
      var $result_i451=__stackBase__+15660;
      var $3557=__stackBase__+15664;
      var $3558=__stackBase__+15668;
      var $3559=__stackBase__+15672;
      var $3560=__stackBase__+15676;
      var $3561=__stackBase__+15680;
      var $result_i449=__stackBase__+15684;
      var $3562=__stackBase__+15688;
      var $3563=__stackBase__+15692;
      var $3564=__stackBase__+15696;
      var $3565=__stackBase__+15700;
      var $3566=__stackBase__+15704;
      var $result_i447=__stackBase__+15708;
      var $3567=__stackBase__+15712;
      var $3568=__stackBase__+15716;
      var $3569=__stackBase__+15720;
      var $3570=__stackBase__+15724;
      var $3571=__stackBase__+15728;
      var $result_i445=__stackBase__+15732;
      var $3572=__stackBase__+15736;
      var $3573=__stackBase__+15740;
      var $3574=__stackBase__+15744;
      var $3575=__stackBase__+15748;
      var $3576=__stackBase__+15752;
      var $result_i443=__stackBase__+15756;
      var $3577=__stackBase__+15760;
      var $3578=__stackBase__+15764;
      var $3579=__stackBase__+15768;
      var $3580=__stackBase__+15772;
      var $3581=__stackBase__+15776;
      var $result_i441=__stackBase__+15780;
      var $3582=__stackBase__+15784;
      var $3583=__stackBase__+15788;
      var $3584=__stackBase__+15792;
      var $3585=__stackBase__+15796;
      var $3586=__stackBase__+15800;
      var $result_i439=__stackBase__+15804;
      var $3587=__stackBase__+15808;
      var $3588=__stackBase__+15812;
      var $3589=__stackBase__+15816;
      var $3590=__stackBase__+15820;
      var $3591=__stackBase__+15824;
      var $result_i437=__stackBase__+15828;
      var $3592=__stackBase__+15832;
      var $3593=__stackBase__+15836;
      var $3594=__stackBase__+15840;
      var $3595=__stackBase__+15844;
      var $3596=__stackBase__+15848;
      var $result_i435=__stackBase__+15852;
      var $3597=__stackBase__+15856;
      var $3598=__stackBase__+15860;
      var $3599=__stackBase__+15864;
      var $3600=__stackBase__+15868;
      var $3601=__stackBase__+15872;
      var $result_i433=__stackBase__+15876;
      var $3602=__stackBase__+15880;
      var $3603=__stackBase__+15884;
      var $3604=__stackBase__+15888;
      var $3605=__stackBase__+15892;
      var $3606=__stackBase__+15896;
      var $result_i431=__stackBase__+15900;
      var $3607=__stackBase__+15904;
      var $3608=__stackBase__+15908;
      var $3609=__stackBase__+15912;
      var $3610=__stackBase__+15916;
      var $3611=__stackBase__+15920;
      var $result_i429=__stackBase__+15924;
      var $3612=__stackBase__+15928;
      var $3613=__stackBase__+15932;
      var $3614=__stackBase__+15936;
      var $3615=__stackBase__+15940;
      var $3616=__stackBase__+15944;
      var $result_i427=__stackBase__+15948;
      var $3617=__stackBase__+15952;
      var $3618=__stackBase__+15956;
      var $3619=__stackBase__+15960;
      var $3620=__stackBase__+15964;
      var $3621=__stackBase__+15968;
      var $result_i425=__stackBase__+15972;
      var $3622=__stackBase__+15976;
      var $3623=__stackBase__+15980;
      var $3624=__stackBase__+15984;
      var $3625=__stackBase__+15988;
      var $3626=__stackBase__+15992;
      var $result_i423=__stackBase__+15996;
      var $3627=__stackBase__+16000;
      var $3628=__stackBase__+16004;
      var $3629=__stackBase__+16008;
      var $3630=__stackBase__+16012;
      var $3631=__stackBase__+16016;
      var $result_i421=__stackBase__+16020;
      var $3632=__stackBase__+16024;
      var $3633=__stackBase__+16028;
      var $3634=__stackBase__+16032;
      var $3635=__stackBase__+16036;
      var $3636=__stackBase__+16040;
      var $result_i419=__stackBase__+16044;
      var $3637=__stackBase__+16048;
      var $3638=__stackBase__+16052;
      var $3639=__stackBase__+16056;
      var $3640=__stackBase__+16060;
      var $3641=__stackBase__+16064;
      var $result_i417=__stackBase__+16068;
      var $3642=__stackBase__+16072;
      var $3643=__stackBase__+16076;
      var $3644=__stackBase__+16080;
      var $3645=__stackBase__+16084;
      var $3646=__stackBase__+16088;
      var $result_i415=__stackBase__+16092;
      var $3647=__stackBase__+16096;
      var $3648=__stackBase__+16100;
      var $3649=__stackBase__+16104;
      var $3650=__stackBase__+16108;
      var $3651=__stackBase__+16112;
      var $result_i413=__stackBase__+16116;
      var $3652=__stackBase__+16120;
      var $3653=__stackBase__+16124;
      var $3654=__stackBase__+16128;
      var $3655=__stackBase__+16132;
      var $3656=__stackBase__+16136;
      var $result_i411=__stackBase__+16140;
      var $3657=__stackBase__+16144;
      var $3658=__stackBase__+16148;
      var $3659=__stackBase__+16152;
      var $3660=__stackBase__+16156;
      var $3661=__stackBase__+16160;
      var $result_i409=__stackBase__+16164;
      var $3662=__stackBase__+16168;
      var $3663=__stackBase__+16172;
      var $3664=__stackBase__+16176;
      var $3665=__stackBase__+16180;
      var $3666=__stackBase__+16184;
      var $result_i407=__stackBase__+16188;
      var $3667=__stackBase__+16192;
      var $3668=__stackBase__+16196;
      var $3669=__stackBase__+16200;
      var $3670=__stackBase__+16204;
      var $3671=__stackBase__+16208;
      var $result_i405=__stackBase__+16212;
      var $3672=__stackBase__+16216;
      var $3673=__stackBase__+16220;
      var $3674=__stackBase__+16224;
      var $3675=__stackBase__+16228;
      var $3676=__stackBase__+16232;
      var $result_i403=__stackBase__+16236;
      var $3677=__stackBase__+16240;
      var $3678=__stackBase__+16244;
      var $3679=__stackBase__+16248;
      var $3680=__stackBase__+16252;
      var $3681=__stackBase__+16256;
      var $result_i401=__stackBase__+16260;
      var $3682=__stackBase__+16264;
      var $3683=__stackBase__+16268;
      var $3684=__stackBase__+16272;
      var $3685=__stackBase__+16276;
      var $3686=__stackBase__+16280;
      var $result_i399=__stackBase__+16284;
      var $3687=__stackBase__+16288;
      var $3688=__stackBase__+16292;
      var $3689=__stackBase__+16296;
      var $3690=__stackBase__+16300;
      var $3691=__stackBase__+16304;
      var $result_i397=__stackBase__+16308;
      var $3692=__stackBase__+16312;
      var $3693=__stackBase__+16316;
      var $3694=__stackBase__+16320;
      var $3695=__stackBase__+16324;
      var $3696=__stackBase__+16328;
      var $result_i395=__stackBase__+16332;
      var $3697=__stackBase__+16336;
      var $3698=__stackBase__+16340;
      var $3699=__stackBase__+16344;
      var $3700=__stackBase__+16348;
      var $3701=__stackBase__+16352;
      var $result_i393=__stackBase__+16356;
      var $3702=__stackBase__+16360;
      var $3703=__stackBase__+16364;
      var $3704=__stackBase__+16368;
      var $3705=__stackBase__+16372;
      var $3706=__stackBase__+16376;
      var $result_i391=__stackBase__+16380;
      var $3707=__stackBase__+16384;
      var $3708=__stackBase__+16388;
      var $3709=__stackBase__+16392;
      var $3710=__stackBase__+16396;
      var $3711=__stackBase__+16400;
      var $result_i389=__stackBase__+16404;
      var $3712=__stackBase__+16408;
      var $3713=__stackBase__+16412;
      var $3714=__stackBase__+16416;
      var $3715=__stackBase__+16420;
      var $3716=__stackBase__+16424;
      var $result_i387=__stackBase__+16428;
      var $3717=__stackBase__+16432;
      var $3718=__stackBase__+16436;
      var $3719=__stackBase__+16440;
      var $3720=__stackBase__+16444;
      var $3721=__stackBase__+16448;
      var $result_i385=__stackBase__+16452;
      var $3722=__stackBase__+16456;
      var $3723=__stackBase__+16460;
      var $3724=__stackBase__+16464;
      var $3725=__stackBase__+16468;
      var $3726=__stackBase__+16472;
      var $result_i383=__stackBase__+16476;
      var $3727=__stackBase__+16480;
      var $3728=__stackBase__+16484;
      var $3729=__stackBase__+16488;
      var $3730=__stackBase__+16492;
      var $3731=__stackBase__+16496;
      var $result_i381=__stackBase__+16500;
      var $3732=__stackBase__+16504;
      var $3733=__stackBase__+16508;
      var $3734=__stackBase__+16512;
      var $3735=__stackBase__+16516;
      var $3736=__stackBase__+16520;
      var $result_i379=__stackBase__+16524;
      var $3737=__stackBase__+16528;
      var $3738=__stackBase__+16532;
      var $3739=__stackBase__+16536;
      var $3740=__stackBase__+16540;
      var $3741=__stackBase__+16544;
      var $result_i377=__stackBase__+16548;
      var $3742=__stackBase__+16552;
      var $3743=__stackBase__+16556;
      var $3744=__stackBase__+16560;
      var $3745=__stackBase__+16564;
      var $3746=__stackBase__+16568;
      var $result_i375=__stackBase__+16572;
      var $3747=__stackBase__+16576;
      var $3748=__stackBase__+16580;
      var $3749=__stackBase__+16584;
      var $3750=__stackBase__+16588;
      var $3751=__stackBase__+16592;
      var $result_i373=__stackBase__+16596;
      var $3752=__stackBase__+16600;
      var $3753=__stackBase__+16604;
      var $3754=__stackBase__+16608;
      var $3755=__stackBase__+16612;
      var $3756=__stackBase__+16616;
      var $result_i371=__stackBase__+16620;
      var $3757=__stackBase__+16624;
      var $3758=__stackBase__+16628;
      var $3759=__stackBase__+16632;
      var $3760=__stackBase__+16636;
      var $3761=__stackBase__+16640;
      var $result_i369=__stackBase__+16644;
      var $3762=__stackBase__+16648;
      var $3763=__stackBase__+16652;
      var $3764=__stackBase__+16656;
      var $3765=__stackBase__+16660;
      var $3766=__stackBase__+16664;
      var $result_i367=__stackBase__+16668;
      var $3767=__stackBase__+16672;
      var $3768=__stackBase__+16676;
      var $3769=__stackBase__+16680;
      var $3770=__stackBase__+16684;
      var $3771=__stackBase__+16688;
      var $result_i365=__stackBase__+16692;
      var $3772=__stackBase__+16696;
      var $3773=__stackBase__+16700;
      var $3774=__stackBase__+16704;
      var $3775=__stackBase__+16708;
      var $3776=__stackBase__+16712;
      var $result_i363=__stackBase__+16716;
      var $3777=__stackBase__+16720;
      var $3778=__stackBase__+16724;
      var $3779=__stackBase__+16728;
      var $3780=__stackBase__+16732;
      var $3781=__stackBase__+16736;
      var $result_i361=__stackBase__+16740;
      var $3782=__stackBase__+16744;
      var $3783=__stackBase__+16748;
      var $3784=__stackBase__+16752;
      var $3785=__stackBase__+16756;
      var $3786=__stackBase__+16760;
      var $result_i359=__stackBase__+16764;
      var $3787=__stackBase__+16768;
      var $3788=__stackBase__+16772;
      var $3789=__stackBase__+16776;
      var $3790=__stackBase__+16780;
      var $3791=__stackBase__+16784;
      var $result_i357=__stackBase__+16788;
      var $3792=__stackBase__+16792;
      var $3793=__stackBase__+16796;
      var $3794=__stackBase__+16800;
      var $3795=__stackBase__+16804;
      var $3796=__stackBase__+16808;
      var $result_i355=__stackBase__+16812;
      var $3797=__stackBase__+16816;
      var $3798=__stackBase__+16820;
      var $3799=__stackBase__+16824;
      var $3800=__stackBase__+16828;
      var $3801=__stackBase__+16832;
      var $result_i353=__stackBase__+16836;
      var $3802=__stackBase__+16840;
      var $3803=__stackBase__+16844;
      var $3804=__stackBase__+16848;
      var $3805=__stackBase__+16852;
      var $3806=__stackBase__+16856;
      var $result_i351=__stackBase__+16860;
      var $3807=__stackBase__+16864;
      var $3808=__stackBase__+16868;
      var $3809=__stackBase__+16872;
      var $3810=__stackBase__+16876;
      var $3811=__stackBase__+16880;
      var $result_i349=__stackBase__+16884;
      var $3812=__stackBase__+16888;
      var $3813=__stackBase__+16892;
      var $3814=__stackBase__+16896;
      var $3815=__stackBase__+16900;
      var $3816=__stackBase__+16904;
      var $result_i347=__stackBase__+16908;
      var $3817=__stackBase__+16912;
      var $3818=__stackBase__+16916;
      var $3819=__stackBase__+16920;
      var $3820=__stackBase__+16924;
      var $3821=__stackBase__+16928;
      var $result_i345=__stackBase__+16932;
      var $3822=__stackBase__+16936;
      var $3823=__stackBase__+16940;
      var $3824=__stackBase__+16944;
      var $3825=__stackBase__+16948;
      var $3826=__stackBase__+16952;
      var $result_i343=__stackBase__+16956;
      var $3827=__stackBase__+16960;
      var $3828=__stackBase__+16964;
      var $3829=__stackBase__+16968;
      var $3830=__stackBase__+16972;
      var $3831=__stackBase__+16976;
      var $result_i341=__stackBase__+16980;
      var $3832=__stackBase__+16984;
      var $3833=__stackBase__+16988;
      var $3834=__stackBase__+16992;
      var $3835=__stackBase__+16996;
      var $3836=__stackBase__+17000;
      var $result_i339=__stackBase__+17004;
      var $3837=__stackBase__+17008;
      var $3838=__stackBase__+17012;
      var $3839=__stackBase__+17016;
      var $3840=__stackBase__+17020;
      var $3841=__stackBase__+17024;
      var $result_i337=__stackBase__+17028;
      var $3842=__stackBase__+17032;
      var $3843=__stackBase__+17036;
      var $3844=__stackBase__+17040;
      var $3845=__stackBase__+17044;
      var $3846=__stackBase__+17048;
      var $result_i335=__stackBase__+17052;
      var $3847=__stackBase__+17056;
      var $3848=__stackBase__+17060;
      var $3849=__stackBase__+17064;
      var $3850=__stackBase__+17068;
      var $3851=__stackBase__+17072;
      var $result_i333=__stackBase__+17076;
      var $3852=__stackBase__+17080;
      var $3853=__stackBase__+17084;
      var $3854=__stackBase__+17088;
      var $3855=__stackBase__+17092;
      var $3856=__stackBase__+17096;
      var $result_i331=__stackBase__+17100;
      var $3857=__stackBase__+17104;
      var $3858=__stackBase__+17108;
      var $3859=__stackBase__+17112;
      var $3860=__stackBase__+17116;
      var $3861=__stackBase__+17120;
      var $result_i329=__stackBase__+17124;
      var $3862=__stackBase__+17128;
      var $3863=__stackBase__+17132;
      var $3864=__stackBase__+17136;
      var $3865=__stackBase__+17140;
      var $3866=__stackBase__+17144;
      var $result_i327=__stackBase__+17148;
      var $3867=__stackBase__+17152;
      var $3868=__stackBase__+17156;
      var $3869=__stackBase__+17160;
      var $3870=__stackBase__+17164;
      var $3871=__stackBase__+17168;
      var $result_i325=__stackBase__+17172;
      var $3872=__stackBase__+17176;
      var $3873=__stackBase__+17180;
      var $3874=__stackBase__+17184;
      var $3875=__stackBase__+17188;
      var $3876=__stackBase__+17192;
      var $result_i323=__stackBase__+17196;
      var $3877=__stackBase__+17200;
      var $3878=__stackBase__+17204;
      var $3879=__stackBase__+17208;
      var $3880=__stackBase__+17212;
      var $3881=__stackBase__+17216;
      var $result_i321=__stackBase__+17220;
      var $3882=__stackBase__+17224;
      var $3883=__stackBase__+17228;
      var $3884=__stackBase__+17232;
      var $3885=__stackBase__+17236;
      var $3886=__stackBase__+17240;
      var $result_i319=__stackBase__+17244;
      var $3887=__stackBase__+17248;
      var $3888=__stackBase__+17252;
      var $3889=__stackBase__+17256;
      var $3890=__stackBase__+17260;
      var $3891=__stackBase__+17264;
      var $result_i317=__stackBase__+17268;
      var $3892=__stackBase__+17272;
      var $3893=__stackBase__+17276;
      var $3894=__stackBase__+17280;
      var $3895=__stackBase__+17284;
      var $3896=__stackBase__+17288;
      var $result_i315=__stackBase__+17292;
      var $3897=__stackBase__+17296;
      var $3898=__stackBase__+17300;
      var $3899=__stackBase__+17304;
      var $3900=__stackBase__+17308;
      var $3901=__stackBase__+17312;
      var $result_i313=__stackBase__+17316;
      var $3902=__stackBase__+17320;
      var $3903=__stackBase__+17324;
      var $3904=__stackBase__+17328;
      var $3905=__stackBase__+17332;
      var $3906=__stackBase__+17336;
      var $result_i311=__stackBase__+17340;
      var $3907=__stackBase__+17344;
      var $3908=__stackBase__+17348;
      var $3909=__stackBase__+17352;
      var $3910=__stackBase__+17356;
      var $3911=__stackBase__+17360;
      var $result_i309=__stackBase__+17364;
      var $3912=__stackBase__+17368;
      var $3913=__stackBase__+17372;
      var $3914=__stackBase__+17376;
      var $3915=__stackBase__+17380;
      var $3916=__stackBase__+17384;
      var $result_i307=__stackBase__+17388;
      var $3917=__stackBase__+17392;
      var $3918=__stackBase__+17396;
      var $3919=__stackBase__+17400;
      var $3920=__stackBase__+17404;
      var $3921=__stackBase__+17408;
      var $result_i305=__stackBase__+17412;
      var $3922=__stackBase__+17416;
      var $3923=__stackBase__+17420;
      var $3924=__stackBase__+17424;
      var $3925=__stackBase__+17428;
      var $3926=__stackBase__+17432;
      var $result_i303=__stackBase__+17436;
      var $3927=__stackBase__+17440;
      var $3928=__stackBase__+17444;
      var $3929=__stackBase__+17448;
      var $3930=__stackBase__+17452;
      var $3931=__stackBase__+17456;
      var $result_i301=__stackBase__+17460;
      var $3932=__stackBase__+17464;
      var $3933=__stackBase__+17468;
      var $3934=__stackBase__+17472;
      var $3935=__stackBase__+17476;
      var $3936=__stackBase__+17480;
      var $result_i299=__stackBase__+17484;
      var $3937=__stackBase__+17488;
      var $3938=__stackBase__+17492;
      var $3939=__stackBase__+17496;
      var $3940=__stackBase__+17500;
      var $3941=__stackBase__+17504;
      var $result_i297=__stackBase__+17508;
      var $3942=__stackBase__+17512;
      var $3943=__stackBase__+17516;
      var $3944=__stackBase__+17520;
      var $3945=__stackBase__+17524;
      var $3946=__stackBase__+17528;
      var $result_i295=__stackBase__+17532;
      var $3947=__stackBase__+17536;
      var $3948=__stackBase__+17540;
      var $3949=__stackBase__+17544;
      var $3950=__stackBase__+17548;
      var $3951=__stackBase__+17552;
      var $result_i293=__stackBase__+17556;
      var $3952=__stackBase__+17560;
      var $3953=__stackBase__+17564;
      var $3954=__stackBase__+17568;
      var $3955=__stackBase__+17572;
      var $3956=__stackBase__+17576;
      var $result_i291=__stackBase__+17580;
      var $3957=__stackBase__+17584;
      var $3958=__stackBase__+17588;
      var $3959=__stackBase__+17592;
      var $3960=__stackBase__+17596;
      var $3961=__stackBase__+17600;
      var $result_i289=__stackBase__+17604;
      var $3962=__stackBase__+17608;
      var $3963=__stackBase__+17612;
      var $3964=__stackBase__+17616;
      var $3965=__stackBase__+17620;
      var $3966=__stackBase__+17624;
      var $result_i287=__stackBase__+17628;
      var $3967=__stackBase__+17632;
      var $3968=__stackBase__+17636;
      var $3969=__stackBase__+17640;
      var $3970=__stackBase__+17644;
      var $3971=__stackBase__+17648;
      var $result_i285=__stackBase__+17652;
      var $3972=__stackBase__+17656;
      var $3973=__stackBase__+17660;
      var $3974=__stackBase__+17664;
      var $3975=__stackBase__+17668;
      var $3976=__stackBase__+17672;
      var $result_i283=__stackBase__+17676;
      var $3977=__stackBase__+17680;
      var $3978=__stackBase__+17684;
      var $3979=__stackBase__+17688;
      var $3980=__stackBase__+17692;
      var $3981=__stackBase__+17696;
      var $result_i281=__stackBase__+17700;
      var $3982=__stackBase__+17704;
      var $3983=__stackBase__+17708;
      var $3984=__stackBase__+17712;
      var $3985=__stackBase__+17716;
      var $3986=__stackBase__+17720;
      var $result_i279=__stackBase__+17724;
      var $3987=__stackBase__+17728;
      var $3988=__stackBase__+17732;
      var $3989=__stackBase__+17736;
      var $3990=__stackBase__+17740;
      var $3991=__stackBase__+17744;
      var $result_i277=__stackBase__+17748;
      var $3992=__stackBase__+17752;
      var $3993=__stackBase__+17756;
      var $3994=__stackBase__+17760;
      var $3995=__stackBase__+17764;
      var $3996=__stackBase__+17768;
      var $result_i275=__stackBase__+17772;
      var $3997=__stackBase__+17776;
      var $3998=__stackBase__+17780;
      var $3999=__stackBase__+17784;
      var $4000=__stackBase__+17788;
      var $4001=__stackBase__+17792;
      var $result_i273=__stackBase__+17796;
      var $4002=__stackBase__+17800;
      var $4003=__stackBase__+17804;
      var $4004=__stackBase__+17808;
      var $4005=__stackBase__+17812;
      var $4006=__stackBase__+17816;
      var $result_i271=__stackBase__+17820;
      var $4007=__stackBase__+17824;
      var $4008=__stackBase__+17828;
      var $4009=__stackBase__+17832;
      var $4010=__stackBase__+17836;
      var $4011=__stackBase__+17840;
      var $result_i269=__stackBase__+17844;
      var $4012=__stackBase__+17848;
      var $4013=__stackBase__+17852;
      var $4014=__stackBase__+17856;
      var $4015=__stackBase__+17860;
      var $4016=__stackBase__+17864;
      var $result_i267=__stackBase__+17868;
      var $4017=__stackBase__+17872;
      var $4018=__stackBase__+17876;
      var $4019=__stackBase__+17880;
      var $4020=__stackBase__+17884;
      var $4021=__stackBase__+17888;
      var $result_i265=__stackBase__+17892;
      var $4022=__stackBase__+17896;
      var $4023=__stackBase__+17900;
      var $4024=__stackBase__+17904;
      var $4025=__stackBase__+17908;
      var $4026=__stackBase__+17912;
      var $result_i263=__stackBase__+17916;
      var $4027=__stackBase__+17920;
      var $4028=__stackBase__+17924;
      var $4029=__stackBase__+17928;
      var $4030=__stackBase__+17932;
      var $4031=__stackBase__+17936;
      var $result_i261=__stackBase__+17940;
      var $4032=__stackBase__+17944;
      var $4033=__stackBase__+17948;
      var $4034=__stackBase__+17952;
      var $4035=__stackBase__+17956;
      var $4036=__stackBase__+17960;
      var $result_i259=__stackBase__+17964;
      var $4037=__stackBase__+17968;
      var $4038=__stackBase__+17972;
      var $4039=__stackBase__+17976;
      var $4040=__stackBase__+17980;
      var $4041=__stackBase__+17984;
      var $result_i257=__stackBase__+17988;
      var $4042=__stackBase__+17992;
      var $4043=__stackBase__+17996;
      var $4044=__stackBase__+18000;
      var $4045=__stackBase__+18004;
      var $4046=__stackBase__+18008;
      var $result_i255=__stackBase__+18012;
      var $4047=__stackBase__+18016;
      var $4048=__stackBase__+18020;
      var $4049=__stackBase__+18024;
      var $4050=__stackBase__+18028;
      var $4051=__stackBase__+18032;
      var $result_i253=__stackBase__+18036;
      var $4052=__stackBase__+18040;
      var $4053=__stackBase__+18044;
      var $4054=__stackBase__+18048;
      var $4055=__stackBase__+18052;
      var $4056=__stackBase__+18056;
      var $result_i251=__stackBase__+18060;
      var $4057=__stackBase__+18064;
      var $4058=__stackBase__+18068;
      var $4059=__stackBase__+18072;
      var $4060=__stackBase__+18076;
      var $4061=__stackBase__+18080;
      var $result_i249=__stackBase__+18084;
      var $4062=__stackBase__+18088;
      var $4063=__stackBase__+18092;
      var $4064=__stackBase__+18096;
      var $4065=__stackBase__+18100;
      var $4066=__stackBase__+18104;
      var $result_i247=__stackBase__+18108;
      var $4067=__stackBase__+18112;
      var $4068=__stackBase__+18116;
      var $4069=__stackBase__+18120;
      var $4070=__stackBase__+18124;
      var $4071=__stackBase__+18128;
      var $result_i245=__stackBase__+18132;
      var $4072=__stackBase__+18136;
      var $4073=__stackBase__+18140;
      var $4074=__stackBase__+18144;
      var $4075=__stackBase__+18148;
      var $4076=__stackBase__+18152;
      var $result_i243=__stackBase__+18156;
      var $4077=__stackBase__+18160;
      var $4078=__stackBase__+18164;
      var $4079=__stackBase__+18168;
      var $4080=__stackBase__+18172;
      var $4081=__stackBase__+18176;
      var $result_i241=__stackBase__+18180;
      var $4082=__stackBase__+18184;
      var $4083=__stackBase__+18188;
      var $4084=__stackBase__+18192;
      var $4085=__stackBase__+18196;
      var $4086=__stackBase__+18200;
      var $result_i239=__stackBase__+18204;
      var $4087=__stackBase__+18208;
      var $4088=__stackBase__+18212;
      var $4089=__stackBase__+18216;
      var $4090=__stackBase__+18220;
      var $4091=__stackBase__+18224;
      var $result_i237=__stackBase__+18228;
      var $4092=__stackBase__+18232;
      var $4093=__stackBase__+18236;
      var $4094=__stackBase__+18240;
      var $4095=__stackBase__+18244;
      var $4096=__stackBase__+18248;
      var $result_i235=__stackBase__+18252;
      var $4097=__stackBase__+18256;
      var $4098=__stackBase__+18260;
      var $4099=__stackBase__+18264;
      var $4100=__stackBase__+18268;
      var $4101=__stackBase__+18272;
      var $result_i233=__stackBase__+18276;
      var $4102=__stackBase__+18280;
      var $4103=__stackBase__+18284;
      var $4104=__stackBase__+18288;
      var $4105=__stackBase__+18292;
      var $4106=__stackBase__+18296;
      var $result_i231=__stackBase__+18300;
      var $4107=__stackBase__+18304;
      var $4108=__stackBase__+18308;
      var $4109=__stackBase__+18312;
      var $4110=__stackBase__+18316;
      var $4111=__stackBase__+18320;
      var $result_i229=__stackBase__+18324;
      var $4112=__stackBase__+18328;
      var $4113=__stackBase__+18332;
      var $4114=__stackBase__+18336;
      var $4115=__stackBase__+18340;
      var $4116=__stackBase__+18344;
      var $result_i227=__stackBase__+18348;
      var $4117=__stackBase__+18352;
      var $4118=__stackBase__+18356;
      var $4119=__stackBase__+18360;
      var $4120=__stackBase__+18364;
      var $4121=__stackBase__+18368;
      var $result_i225=__stackBase__+18372;
      var $4122=__stackBase__+18376;
      var $4123=__stackBase__+18380;
      var $4124=__stackBase__+18384;
      var $4125=__stackBase__+18388;
      var $4126=__stackBase__+18392;
      var $result_i223=__stackBase__+18396;
      var $4127=__stackBase__+18400;
      var $4128=__stackBase__+18404;
      var $4129=__stackBase__+18408;
      var $4130=__stackBase__+18412;
      var $4131=__stackBase__+18416;
      var $result_i221=__stackBase__+18420;
      var $4132=__stackBase__+18424;
      var $4133=__stackBase__+18428;
      var $4134=__stackBase__+18432;
      var $4135=__stackBase__+18436;
      var $4136=__stackBase__+18440;
      var $result_i219=__stackBase__+18444;
      var $4137=__stackBase__+18448;
      var $4138=__stackBase__+18452;
      var $4139=__stackBase__+18456;
      var $4140=__stackBase__+18460;
      var $4141=__stackBase__+18464;
      var $result_i217=__stackBase__+18468;
      var $4142=__stackBase__+18472;
      var $4143=__stackBase__+18476;
      var $4144=__stackBase__+18480;
      var $4145=__stackBase__+18484;
      var $4146=__stackBase__+18488;
      var $result_i215=__stackBase__+18492;
      var $4147=__stackBase__+18496;
      var $4148=__stackBase__+18500;
      var $4149=__stackBase__+18504;
      var $4150=__stackBase__+18508;
      var $4151=__stackBase__+18512;
      var $result_i213=__stackBase__+18516;
      var $4152=__stackBase__+18520;
      var $4153=__stackBase__+18524;
      var $4154=__stackBase__+18528;
      var $4155=__stackBase__+18532;
      var $4156=__stackBase__+18536;
      var $result_i211=__stackBase__+18540;
      var $4157=__stackBase__+18544;
      var $4158=__stackBase__+18548;
      var $4159=__stackBase__+18552;
      var $4160=__stackBase__+18556;
      var $4161=__stackBase__+18560;
      var $result_i209=__stackBase__+18564;
      var $4162=__stackBase__+18568;
      var $4163=__stackBase__+18572;
      var $4164=__stackBase__+18576;
      var $4165=__stackBase__+18580;
      var $4166=__stackBase__+18584;
      var $result_i207=__stackBase__+18588;
      var $4167=__stackBase__+18592;
      var $4168=__stackBase__+18596;
      var $4169=__stackBase__+18600;
      var $4170=__stackBase__+18604;
      var $4171=__stackBase__+18608;
      var $result_i205=__stackBase__+18612;
      var $4172=__stackBase__+18616;
      var $4173=__stackBase__+18620;
      var $4174=__stackBase__+18624;
      var $4175=__stackBase__+18628;
      var $4176=__stackBase__+18632;
      var $result_i203=__stackBase__+18636;
      var $4177=__stackBase__+18640;
      var $4178=__stackBase__+18644;
      var $4179=__stackBase__+18648;
      var $4180=__stackBase__+18652;
      var $4181=__stackBase__+18656;
      var $result_i201=__stackBase__+18660;
      var $4182=__stackBase__+18664;
      var $4183=__stackBase__+18668;
      var $4184=__stackBase__+18672;
      var $4185=__stackBase__+18676;
      var $4186=__stackBase__+18680;
      var $result_i199=__stackBase__+18684;
      var $4187=__stackBase__+18688;
      var $4188=__stackBase__+18692;
      var $4189=__stackBase__+18696;
      var $4190=__stackBase__+18700;
      var $4191=__stackBase__+18704;
      var $result_i197=__stackBase__+18708;
      var $4192=__stackBase__+18712;
      var $4193=__stackBase__+18716;
      var $4194=__stackBase__+18720;
      var $4195=__stackBase__+18724;
      var $4196=__stackBase__+18728;
      var $result_i195=__stackBase__+18732;
      var $4197=__stackBase__+18736;
      var $4198=__stackBase__+18740;
      var $4199=__stackBase__+18744;
      var $4200=__stackBase__+18748;
      var $4201=__stackBase__+18752;
      var $result_i193=__stackBase__+18756;
      var $4202=__stackBase__+18760;
      var $4203=__stackBase__+18764;
      var $4204=__stackBase__+18768;
      var $4205=__stackBase__+18772;
      var $4206=__stackBase__+18776;
      var $result_i191=__stackBase__+18780;
      var $4207=__stackBase__+18784;
      var $4208=__stackBase__+18788;
      var $4209=__stackBase__+18792;
      var $4210=__stackBase__+18796;
      var $4211=__stackBase__+18800;
      var $result_i189=__stackBase__+18804;
      var $4212=__stackBase__+18808;
      var $4213=__stackBase__+18812;
      var $4214=__stackBase__+18816;
      var $4215=__stackBase__+18820;
      var $4216=__stackBase__+18824;
      var $result_i187=__stackBase__+18828;
      var $4217=__stackBase__+18832;
      var $4218=__stackBase__+18836;
      var $4219=__stackBase__+18840;
      var $4220=__stackBase__+18844;
      var $4221=__stackBase__+18848;
      var $result_i185=__stackBase__+18852;
      var $4222=__stackBase__+18856;
      var $4223=__stackBase__+18860;
      var $4224=__stackBase__+18864;
      var $4225=__stackBase__+18868;
      var $4226=__stackBase__+18872;
      var $result_i183=__stackBase__+18876;
      var $4227=__stackBase__+18880;
      var $4228=__stackBase__+18884;
      var $4229=__stackBase__+18888;
      var $4230=__stackBase__+18892;
      var $4231=__stackBase__+18896;
      var $result_i181=__stackBase__+18900;
      var $4232=__stackBase__+18904;
      var $4233=__stackBase__+18908;
      var $4234=__stackBase__+18912;
      var $4235=__stackBase__+18916;
      var $4236=__stackBase__+18920;
      var $result_i179=__stackBase__+18924;
      var $4237=__stackBase__+18928;
      var $4238=__stackBase__+18932;
      var $4239=__stackBase__+18936;
      var $4240=__stackBase__+18940;
      var $4241=__stackBase__+18944;
      var $result_i177=__stackBase__+18948;
      var $4242=__stackBase__+18952;
      var $4243=__stackBase__+18956;
      var $4244=__stackBase__+18960;
      var $4245=__stackBase__+18964;
      var $4246=__stackBase__+18968;
      var $result_i175=__stackBase__+18972;
      var $4247=__stackBase__+18976;
      var $4248=__stackBase__+18980;
      var $4249=__stackBase__+18984;
      var $4250=__stackBase__+18988;
      var $4251=__stackBase__+18992;
      var $result_i173=__stackBase__+18996;
      var $4252=__stackBase__+19000;
      var $4253=__stackBase__+19004;
      var $4254=__stackBase__+19008;
      var $4255=__stackBase__+19012;
      var $4256=__stackBase__+19016;
      var $result_i171=__stackBase__+19020;
      var $4257=__stackBase__+19024;
      var $4258=__stackBase__+19028;
      var $4259=__stackBase__+19032;
      var $4260=__stackBase__+19036;
      var $4261=__stackBase__+19040;
      var $result_i169=__stackBase__+19044;
      var $4262=__stackBase__+19048;
      var $4263=__stackBase__+19052;
      var $4264=__stackBase__+19056;
      var $4265=__stackBase__+19060;
      var $4266=__stackBase__+19064;
      var $result_i167=__stackBase__+19068;
      var $4267=__stackBase__+19072;
      var $4268=__stackBase__+19076;
      var $4269=__stackBase__+19080;
      var $4270=__stackBase__+19084;
      var $4271=__stackBase__+19088;
      var $result_i165=__stackBase__+19092;
      var $4272=__stackBase__+19096;
      var $4273=__stackBase__+19100;
      var $4274=__stackBase__+19104;
      var $4275=__stackBase__+19108;
      var $4276=__stackBase__+19112;
      var $result_i163=__stackBase__+19116;
      var $4277=__stackBase__+19120;
      var $4278=__stackBase__+19124;
      var $4279=__stackBase__+19128;
      var $4280=__stackBase__+19132;
      var $4281=__stackBase__+19136;
      var $result_i161=__stackBase__+19140;
      var $4282=__stackBase__+19144;
      var $4283=__stackBase__+19148;
      var $4284=__stackBase__+19152;
      var $4285=__stackBase__+19156;
      var $4286=__stackBase__+19160;
      var $result_i159=__stackBase__+19164;
      var $4287=__stackBase__+19168;
      var $4288=__stackBase__+19172;
      var $4289=__stackBase__+19176;
      var $4290=__stackBase__+19180;
      var $4291=__stackBase__+19184;
      var $result_i157=__stackBase__+19188;
      var $4292=__stackBase__+19192;
      var $4293=__stackBase__+19196;
      var $4294=__stackBase__+19200;
      var $4295=__stackBase__+19204;
      var $4296=__stackBase__+19208;
      var $result_i155=__stackBase__+19212;
      var $4297=__stackBase__+19216;
      var $4298=__stackBase__+19220;
      var $4299=__stackBase__+19224;
      var $4300=__stackBase__+19228;
      var $4301=__stackBase__+19232;
      var $result_i153=__stackBase__+19236;
      var $4302=__stackBase__+19240;
      var $4303=__stackBase__+19244;
      var $4304=__stackBase__+19248;
      var $4305=__stackBase__+19252;
      var $4306=__stackBase__+19256;
      var $result_i151=__stackBase__+19260;
      var $4307=__stackBase__+19264;
      var $4308=__stackBase__+19268;
      var $4309=__stackBase__+19272;
      var $4310=__stackBase__+19276;
      var $4311=__stackBase__+19280;
      var $result_i149=__stackBase__+19284;
      var $4312=__stackBase__+19288;
      var $4313=__stackBase__+19292;
      var $4314=__stackBase__+19296;
      var $4315=__stackBase__+19300;
      var $4316=__stackBase__+19304;
      var $result_i147=__stackBase__+19308;
      var $4317=__stackBase__+19312;
      var $4318=__stackBase__+19316;
      var $4319=__stackBase__+19320;
      var $4320=__stackBase__+19324;
      var $4321=__stackBase__+19328;
      var $result_i145=__stackBase__+19332;
      var $4322=__stackBase__+19336;
      var $4323=__stackBase__+19340;
      var $4324=__stackBase__+19344;
      var $4325=__stackBase__+19348;
      var $4326=__stackBase__+19352;
      var $result_i143=__stackBase__+19356;
      var $4327=__stackBase__+19360;
      var $4328=__stackBase__+19364;
      var $4329=__stackBase__+19368;
      var $4330=__stackBase__+19372;
      var $4331=__stackBase__+19376;
      var $result_i141=__stackBase__+19380;
      var $4332=__stackBase__+19384;
      var $4333=__stackBase__+19388;
      var $4334=__stackBase__+19392;
      var $4335=__stackBase__+19396;
      var $4336=__stackBase__+19400;
      var $result_i139=__stackBase__+19404;
      var $4337=__stackBase__+19408;
      var $4338=__stackBase__+19412;
      var $4339=__stackBase__+19416;
      var $4340=__stackBase__+19420;
      var $4341=__stackBase__+19424;
      var $result_i137=__stackBase__+19428;
      var $4342=__stackBase__+19432;
      var $4343=__stackBase__+19436;
      var $4344=__stackBase__+19440;
      var $4345=__stackBase__+19444;
      var $4346=__stackBase__+19448;
      var $result_i135=__stackBase__+19452;
      var $4347=__stackBase__+19456;
      var $4348=__stackBase__+19460;
      var $4349=__stackBase__+19464;
      var $4350=__stackBase__+19468;
      var $4351=__stackBase__+19472;
      var $result_i133=__stackBase__+19476;
      var $4352=__stackBase__+19480;
      var $4353=__stackBase__+19484;
      var $4354=__stackBase__+19488;
      var $4355=__stackBase__+19492;
      var $4356=__stackBase__+19496;
      var $result_i131=__stackBase__+19500;
      var $4357=__stackBase__+19504;
      var $4358=__stackBase__+19508;
      var $4359=__stackBase__+19512;
      var $4360=__stackBase__+19516;
      var $4361=__stackBase__+19520;
      var $result_i129=__stackBase__+19524;
      var $4362=__stackBase__+19528;
      var $4363=__stackBase__+19532;
      var $4364=__stackBase__+19536;
      var $4365=__stackBase__+19540;
      var $4366=__stackBase__+19544;
      var $result_i127=__stackBase__+19548;
      var $4367=__stackBase__+19552;
      var $4368=__stackBase__+19556;
      var $4369=__stackBase__+19560;
      var $4370=__stackBase__+19564;
      var $4371=__stackBase__+19568;
      var $result_i125=__stackBase__+19572;
      var $4372=__stackBase__+19576;
      var $4373=__stackBase__+19580;
      var $4374=__stackBase__+19584;
      var $4375=__stackBase__+19588;
      var $4376=__stackBase__+19592;
      var $result_i123=__stackBase__+19596;
      var $4377=__stackBase__+19600;
      var $4378=__stackBase__+19604;
      var $4379=__stackBase__+19608;
      var $4380=__stackBase__+19612;
      var $4381=__stackBase__+19616;
      var $result_i121=__stackBase__+19620;
      var $4382=__stackBase__+19624;
      var $4383=__stackBase__+19628;
      var $4384=__stackBase__+19632;
      var $4385=__stackBase__+19636;
      var $4386=__stackBase__+19640;
      var $result_i119=__stackBase__+19644;
      var $4387=__stackBase__+19648;
      var $4388=__stackBase__+19652;
      var $4389=__stackBase__+19656;
      var $4390=__stackBase__+19660;
      var $4391=__stackBase__+19664;
      var $result_i117=__stackBase__+19668;
      var $4392=__stackBase__+19672;
      var $4393=__stackBase__+19676;
      var $4394=__stackBase__+19680;
      var $4395=__stackBase__+19684;
      var $4396=__stackBase__+19688;
      var $result_i115=__stackBase__+19692;
      var $4397=__stackBase__+19696;
      var $4398=__stackBase__+19700;
      var $4399=__stackBase__+19704;
      var $4400=__stackBase__+19708;
      var $4401=__stackBase__+19712;
      var $result_i113=__stackBase__+19716;
      var $4402=__stackBase__+19720;
      var $4403=__stackBase__+19724;
      var $4404=__stackBase__+19728;
      var $4405=__stackBase__+19732;
      var $4406=__stackBase__+19736;
      var $result_i111=__stackBase__+19740;
      var $4407=__stackBase__+19744;
      var $4408=__stackBase__+19748;
      var $4409=__stackBase__+19752;
      var $4410=__stackBase__+19756;
      var $4411=__stackBase__+19760;
      var $result_i109=__stackBase__+19764;
      var $4412=__stackBase__+19768;
      var $4413=__stackBase__+19772;
      var $4414=__stackBase__+19776;
      var $4415=__stackBase__+19780;
      var $4416=__stackBase__+19784;
      var $result_i107=__stackBase__+19788;
      var $4417=__stackBase__+19792;
      var $4418=__stackBase__+19796;
      var $4419=__stackBase__+19800;
      var $4420=__stackBase__+19804;
      var $4421=__stackBase__+19808;
      var $result_i105=__stackBase__+19812;
      var $4422=__stackBase__+19816;
      var $4423=__stackBase__+19820;
      var $4424=__stackBase__+19824;
      var $4425=__stackBase__+19828;
      var $4426=__stackBase__+19832;
      var $result_i103=__stackBase__+19836;
      var $4427=__stackBase__+19840;
      var $4428=__stackBase__+19844;
      var $4429=__stackBase__+19848;
      var $4430=__stackBase__+19852;
      var $4431=__stackBase__+19856;
      var $result_i101=__stackBase__+19860;
      var $4432=__stackBase__+19864;
      var $4433=__stackBase__+19868;
      var $4434=__stackBase__+19872;
      var $4435=__stackBase__+19876;
      var $4436=__stackBase__+19880;
      var $result_i99=__stackBase__+19884;
      var $4437=__stackBase__+19888;
      var $4438=__stackBase__+19892;
      var $4439=__stackBase__+19896;
      var $4440=__stackBase__+19900;
      var $4441=__stackBase__+19904;
      var $result_i97=__stackBase__+19908;
      var $4442=__stackBase__+19912;
      var $4443=__stackBase__+19916;
      var $4444=__stackBase__+19920;
      var $4445=__stackBase__+19924;
      var $4446=__stackBase__+19928;
      var $result_i95=__stackBase__+19932;
      var $4447=__stackBase__+19936;
      var $4448=__stackBase__+19940;
      var $4449=__stackBase__+19944;
      var $4450=__stackBase__+19948;
      var $4451=__stackBase__+19952;
      var $result_i93=__stackBase__+19956;
      var $4452=__stackBase__+19960;
      var $4453=__stackBase__+19964;
      var $4454=__stackBase__+19968;
      var $4455=__stackBase__+19972;
      var $4456=__stackBase__+19976;
      var $result_i91=__stackBase__+19980;
      var $4457=__stackBase__+19984;
      var $4458=__stackBase__+19988;
      var $4459=__stackBase__+19992;
      var $4460=__stackBase__+19996;
      var $4461=__stackBase__+20000;
      var $result_i89=__stackBase__+20004;
      var $4462=__stackBase__+20008;
      var $4463=__stackBase__+20012;
      var $4464=__stackBase__+20016;
      var $4465=__stackBase__+20020;
      var $4466=__stackBase__+20024;
      var $result_i87=__stackBase__+20028;
      var $4467=__stackBase__+20032;
      var $4468=__stackBase__+20036;
      var $4469=__stackBase__+20040;
      var $4470=__stackBase__+20044;
      var $4471=__stackBase__+20048;
      var $result_i85=__stackBase__+20052;
      var $4472=__stackBase__+20056;
      var $4473=__stackBase__+20060;
      var $4474=__stackBase__+20064;
      var $4475=__stackBase__+20068;
      var $4476=__stackBase__+20072;
      var $result_i83=__stackBase__+20076;
      var $4477=__stackBase__+20080;
      var $4478=__stackBase__+20084;
      var $4479=__stackBase__+20088;
      var $4480=__stackBase__+20092;
      var $4481=__stackBase__+20096;
      var $result_i81=__stackBase__+20100;
      var $4482=__stackBase__+20104;
      var $4483=__stackBase__+20108;
      var $4484=__stackBase__+20112;
      var $4485=__stackBase__+20116;
      var $4486=__stackBase__+20120;
      var $result_i79=__stackBase__+20124;
      var $4487=__stackBase__+20128;
      var $4488=__stackBase__+20132;
      var $4489=__stackBase__+20136;
      var $4490=__stackBase__+20140;
      var $4491=__stackBase__+20144;
      var $result_i77=__stackBase__+20148;
      var $4492=__stackBase__+20152;
      var $4493=__stackBase__+20156;
      var $4494=__stackBase__+20160;
      var $4495=__stackBase__+20164;
      var $4496=__stackBase__+20168;
      var $result_i75=__stackBase__+20172;
      var $4497=__stackBase__+20176;
      var $4498=__stackBase__+20180;
      var $4499=__stackBase__+20184;
      var $4500=__stackBase__+20188;
      var $4501=__stackBase__+20192;
      var $result_i73=__stackBase__+20196;
      var $4502=__stackBase__+20200;
      var $4503=__stackBase__+20204;
      var $4504=__stackBase__+20208;
      var $4505=__stackBase__+20212;
      var $4506=__stackBase__+20216;
      var $result_i71=__stackBase__+20220;
      var $4507=__stackBase__+20224;
      var $4508=__stackBase__+20228;
      var $4509=__stackBase__+20232;
      var $4510=__stackBase__+20236;
      var $4511=__stackBase__+20240;
      var $result_i69=__stackBase__+20244;
      var $4512=__stackBase__+20248;
      var $4513=__stackBase__+20252;
      var $4514=__stackBase__+20256;
      var $4515=__stackBase__+20260;
      var $4516=__stackBase__+20264;
      var $result_i67=__stackBase__+20268;
      var $4517=__stackBase__+20272;
      var $4518=__stackBase__+20276;
      var $4519=__stackBase__+20280;
      var $4520=__stackBase__+20284;
      var $4521=__stackBase__+20288;
      var $result_i65=__stackBase__+20292;
      var $4522=__stackBase__+20296;
      var $4523=__stackBase__+20300;
      var $4524=__stackBase__+20304;
      var $4525=__stackBase__+20308;
      var $4526=__stackBase__+20312;
      var $result_i63=__stackBase__+20316;
      var $4527=__stackBase__+20320;
      var $4528=__stackBase__+20324;
      var $4529=__stackBase__+20328;
      var $4530=__stackBase__+20332;
      var $4531=__stackBase__+20336;
      var $result_i61=__stackBase__+20340;
      var $4532=__stackBase__+20344;
      var $4533=__stackBase__+20348;
      var $4534=__stackBase__+20352;
      var $4535=__stackBase__+20356;
      var $4536=__stackBase__+20360;
      var $result_i59=__stackBase__+20364;
      var $4537=__stackBase__+20368;
      var $4538=__stackBase__+20372;
      var $4539=__stackBase__+20376;
      var $4540=__stackBase__+20380;
      var $4541=__stackBase__+20384;
      var $result_i57=__stackBase__+20388;
      var $4542=__stackBase__+20392;
      var $4543=__stackBase__+20396;
      var $4544=__stackBase__+20400;
      var $4545=__stackBase__+20404;
      var $4546=__stackBase__+20408;
      var $result_i55=__stackBase__+20412;
      var $4547=__stackBase__+20416;
      var $4548=__stackBase__+20420;
      var $4549=__stackBase__+20424;
      var $4550=__stackBase__+20428;
      var $4551=__stackBase__+20432;
      var $result_i53=__stackBase__+20436;
      var $4552=__stackBase__+20440;
      var $4553=__stackBase__+20444;
      var $4554=__stackBase__+20448;
      var $4555=__stackBase__+20452;
      var $4556=__stackBase__+20456;
      var $result_i51=__stackBase__+20460;
      var $4557=__stackBase__+20464;
      var $4558=__stackBase__+20468;
      var $4559=__stackBase__+20472;
      var $4560=__stackBase__+20476;
      var $4561=__stackBase__+20480;
      var $result_i49=__stackBase__+20484;
      var $4562=__stackBase__+20488;
      var $4563=__stackBase__+20492;
      var $4564=__stackBase__+20496;
      var $4565=__stackBase__+20500;
      var $4566=__stackBase__+20504;
      var $result_i47=__stackBase__+20508;
      var $4567=__stackBase__+20512;
      var $4568=__stackBase__+20516;
      var $4569=__stackBase__+20520;
      var $4570=__stackBase__+20524;
      var $4571=__stackBase__+20528;
      var $result_i45=__stackBase__+20532;
      var $4572=__stackBase__+20536;
      var $4573=__stackBase__+20540;
      var $4574=__stackBase__+20544;
      var $4575=__stackBase__+20548;
      var $4576=__stackBase__+20552;
      var $result_i43=__stackBase__+20556;
      var $4577=__stackBase__+20560;
      var $4578=__stackBase__+20564;
      var $4579=__stackBase__+20568;
      var $4580=__stackBase__+20572;
      var $4581=__stackBase__+20576;
      var $result_i41=__stackBase__+20580;
      var $4582=__stackBase__+20584;
      var $4583=__stackBase__+20588;
      var $4584=__stackBase__+20592;
      var $4585=__stackBase__+20596;
      var $4586=__stackBase__+20600;
      var $result_i39=__stackBase__+20604;
      var $4587=__stackBase__+20608;
      var $4588=__stackBase__+20612;
      var $4589=__stackBase__+20616;
      var $4590=__stackBase__+20620;
      var $4591=__stackBase__+20624;
      var $result_i37=__stackBase__+20628;
      var $4592=__stackBase__+20632;
      var $4593=__stackBase__+20636;
      var $4594=__stackBase__+20640;
      var $4595=__stackBase__+20644;
      var $4596=__stackBase__+20648;
      var $result_i35=__stackBase__+20652;
      var $4597=__stackBase__+20656;
      var $4598=__stackBase__+20660;
      var $4599=__stackBase__+20664;
      var $4600=__stackBase__+20668;
      var $4601=__stackBase__+20672;
      var $result_i33=__stackBase__+20676;
      var $4602=__stackBase__+20680;
      var $4603=__stackBase__+20684;
      var $4604=__stackBase__+20688;
      var $4605=__stackBase__+20692;
      var $4606=__stackBase__+20696;
      var $result_i31=__stackBase__+20700;
      var $4607=__stackBase__+20704;
      var $4608=__stackBase__+20708;
      var $4609=__stackBase__+20712;
      var $4610=__stackBase__+20716;
      var $4611=__stackBase__+20720;
      var $result_i29=__stackBase__+20724;
      var $4612=__stackBase__+20728;
      var $4613=__stackBase__+20732;
      var $4614=__stackBase__+20736;
      var $4615=__stackBase__+20740;
      var $4616=__stackBase__+20744;
      var $result_i27=__stackBase__+20748;
      var $4617=__stackBase__+20752;
      var $4618=__stackBase__+20756;
      var $4619=__stackBase__+20760;
      var $4620=__stackBase__+20764;
      var $4621=__stackBase__+20768;
      var $result_i25=__stackBase__+20772;
      var $4622=__stackBase__+20776;
      var $4623=__stackBase__+20780;
      var $4624=__stackBase__+20784;
      var $4625=__stackBase__+20788;
      var $4626=__stackBase__+20792;
      var $result_i23=__stackBase__+20796;
      var $4627=__stackBase__+20800;
      var $4628=__stackBase__+20804;
      var $4629=__stackBase__+20808;
      var $4630=__stackBase__+20812;
      var $4631=__stackBase__+20816;
      var $result_i21=__stackBase__+20820;
      var $4632=__stackBase__+20824;
      var $4633=__stackBase__+20828;
      var $4634=__stackBase__+20832;
      var $4635=__stackBase__+20836;
      var $4636=__stackBase__+20840;
      var $result_i19=__stackBase__+20844;
      var $4637=__stackBase__+20848;
      var $4638=__stackBase__+20852;
      var $4639=__stackBase__+20856;
      var $4640=__stackBase__+20860;
      var $4641=__stackBase__+20864;
      var $result_i17=__stackBase__+20868;
      var $4642=__stackBase__+20872;
      var $4643=__stackBase__+20876;
      var $4644=__stackBase__+20880;
      var $4645=__stackBase__+20884;
      var $4646=__stackBase__+20888;
      var $result_i15=__stackBase__+20892;
      var $4647=__stackBase__+20896;
      var $4648=__stackBase__+20900;
      var $4649=__stackBase__+20904;
      var $4650=__stackBase__+20908;
      var $4651=__stackBase__+20912;
      var $result_i13=__stackBase__+20916;
      var $4652=__stackBase__+20920;
      var $4653=__stackBase__+20924;
      var $4654=__stackBase__+20928;
      var $4655=__stackBase__+20932;
      var $4656=__stackBase__+20936;
      var $result_i11=__stackBase__+20940;
      var $4657=__stackBase__+20944;
      var $4658=__stackBase__+20948;
      var $4659=__stackBase__+20952;
      var $4660=__stackBase__+20956;
      var $4661=__stackBase__+20960;
      var $result_i9=__stackBase__+20964;
      var $4662=__stackBase__+20968;
      var $4663=__stackBase__+20972;
      var $4664=__stackBase__+20976;
      var $4665=__stackBase__+20980;
      var $4666=__stackBase__+20984;
      var $result_i7=__stackBase__+20988;
      var $4667=__stackBase__+20992;
      var $4668=__stackBase__+20996;
      var $4669=__stackBase__+21000;
      var $4670=__stackBase__+21004;
      var $4671=__stackBase__+21008;
      var $result_i5=__stackBase__+21012;
      var $4672=__stackBase__+21016;
      var $4673=__stackBase__+21020;
      var $4674=__stackBase__+21024;
      var $4675=__stackBase__+21028;
      var $4676=__stackBase__+21032;
      var $result_i3=__stackBase__+21036;
      var $4677=__stackBase__+21040;
      var $4678=__stackBase__+21044;
      var $4679=__stackBase__+21048;
      var $4680=__stackBase__+21052;
      var $4681=__stackBase__+21056;
      var $result_i1=__stackBase__+21060;
      var $4682=__stackBase__+21064;
      var $4683=__stackBase__+21068;
      var $4684=__stackBase__+21072;
      var $4685=__stackBase__+21076;
      var $4686=__stackBase__+21080;
      var $result_i=__stackBase__+21084;
      var $4687=__stackBase__+21088;
      var $4688=__stackBase__+21092;
      var $4689;
      var $4690=__stackBase__+21096;
      var $4691=__stackBase__+21160;
      var $4692;
      var $4693;
      var $4694=__stackBase__+21164;
      var $4695=__stackBase__+21168;
      var $4696=__stackBase__+21172;
      var $4697=__stackBase__+21176;
      var $4698=__stackBase__+21180;
      var $4699=__stackBase__+21184;
      var $4700=__stackBase__+21188;
      var $4701=__stackBase__+21252;
      var $4702=__stackBase__+21256;
      var $4703=__stackBase__+21260;
      var $4704=__stackBase__+21264;
      var $4705=__stackBase__+21268;
      var $4706=__stackBase__+21272;
      var $4707=__stackBase__+21276;
      var $4708=__stackBase__+21280;
      var $4709=__stackBase__+21344;
      var $4710=__stackBase__+21348;
      var $4711=__stackBase__+21352;
      var $4712=__stackBase__+21356;
      var $4713=__stackBase__+21360;
      var $4714=__stackBase__+21364;
      var $4715=__stackBase__+21368;
      var $4716=__stackBase__+21372;
      var $4717=__stackBase__+21436;
      var $4718=__stackBase__+21440;
      var $4719=__stackBase__+21444;
      var $4720=__stackBase__+21448;
      var $4721=__stackBase__+21452;
      var $4722=__stackBase__+21456;
      var $4723=__stackBase__+21460;
      var $4724=__stackBase__+21464;
      var $4725=__stackBase__+21528;
      var $4726=__stackBase__+21532;
      var $4727=__stackBase__+21536;
      var $4728=__stackBase__+21540;
      var $4729=__stackBase__+21544;
      var $4730=__stackBase__+21548;
      var $4731=__stackBase__+21552;
      var $4732=__stackBase__+21556;
      var $4733=__stackBase__+21620;
      var $4734=__stackBase__+21624;
      var $4735=__stackBase__+21628;
      var $4736=__stackBase__+21632;
      var $4737=__stackBase__+21636;
      var $4738=__stackBase__+21640;
      var $4739=__stackBase__+21644;
      var $4740=__stackBase__+21648;
      var $4741=__stackBase__+21712;
      var $4742=__stackBase__+21716;
      var $4743=__stackBase__+21720;
      var $4744=__stackBase__+21724;
      var $4745=__stackBase__+21728;
      var $4746=__stackBase__+21732;
      var $4747=__stackBase__+21736;
      var $4748=__stackBase__+21740;
      var $4749=__stackBase__+21804;
      var $4750=__stackBase__+21808;
      var $4751=__stackBase__+21812;
      var $4752=__stackBase__+21816;
      var $4753=__stackBase__+21820;
      var $4754=__stackBase__+21824;
      var $4755=__stackBase__+21828;
      var $4756=__stackBase__+21832;
      var $4757=__stackBase__+21896;
      var $4758=__stackBase__+21900;
      var $4759=__stackBase__+21904;
      var $4760=__stackBase__+21908;
      var $4761=__stackBase__+21912;
      var $4762=__stackBase__+21916;
      var $4763=__stackBase__+21920;
      var $4764=__stackBase__+21924;
      var $4765=__stackBase__+21988;
      var $4766=__stackBase__+21992;
      var $4767=__stackBase__+21996;
      var $4768=__stackBase__+22000;
      var $4769=__stackBase__+22004;
      var $4770=__stackBase__+22008;
      var $4771=__stackBase__+22012;
      var $4772=__stackBase__+22016;
      var $4773=__stackBase__+22080;
      var $4774=__stackBase__+22084;
      var $4775=__stackBase__+22088;
      var $4776=__stackBase__+22092;
      var $4777=__stackBase__+22096;
      var $4778=__stackBase__+22100;
      var $4779=__stackBase__+22104;
      var $4780=__stackBase__+22108;
      var $4781=__stackBase__+22172;
      var $4782=__stackBase__+22176;
      var $4783=__stackBase__+22180;
      var $4784=__stackBase__+22184;
      var $4785=__stackBase__+22188;
      var $4786=__stackBase__+22192;
      var $4787=__stackBase__+22196;
      var $4788=__stackBase__+22200;
      var $4789=__stackBase__+22264;
      var $4790=__stackBase__+22268;
      var $4791=__stackBase__+22272;
      var $4792=__stackBase__+22276;
      var $4793=__stackBase__+22280;
      var $4794=__stackBase__+22284;
      var $4795=__stackBase__+22288;
      var $4796=__stackBase__+22292;
      var $4797=__stackBase__+22356;
      var $4798=__stackBase__+22360;
      var $4799=__stackBase__+22364;
      var $4800=__stackBase__+22368;
      var $4801=__stackBase__+22372;
      var $4802=__stackBase__+22376;
      var $4803=__stackBase__+22380;
      var $4804=__stackBase__+22384;
      var $4805=__stackBase__+22448;
      var $4806=__stackBase__+22452;
      var $4807=__stackBase__+22456;
      var $4808=__stackBase__+22460;
      var $4809=__stackBase__+22464;
      var $4810=__stackBase__+22468;
      var $4811=__stackBase__+22472;
      var $4812=__stackBase__+22476;
      var $4813=__stackBase__+22540;
      var $4814=__stackBase__+22544;
      var $4815=__stackBase__+22548;
      var $4816=__stackBase__+22552;
      var $4817=__stackBase__+22556;
      var $4818=__stackBase__+22560;
      var $4819=__stackBase__+22564;
      var $4820=__stackBase__+22568;
      var $4821=__stackBase__+22632;
      var $4822=__stackBase__+22636;
      var $4823=__stackBase__+22640;
      var $4824=__stackBase__+22644;
      var $4825=__stackBase__+22648;
      var $4826=__stackBase__+22652;
      var $4827=__stackBase__+22656;
      var $4828=__stackBase__+22660;
      var $4829=__stackBase__+22724;
      var $4830=__stackBase__+22728;
      var $4831=__stackBase__+22732;
      var $4832=__stackBase__+22736;
      var $4833=__stackBase__+22740;
      var $4834=__stackBase__+22744;
      var $4835=__stackBase__+22748;
      var $4836=__stackBase__+22752;
      var $4837=__stackBase__+22816;
      var $4838=__stackBase__+22820;
      var $4839=__stackBase__+22824;
      var $4840=__stackBase__+22828;
      var $4841=__stackBase__+22832;
      var $4842=__stackBase__+22836;
      var $4843=__stackBase__+22840;
      var $4844=__stackBase__+22844;
      var $4845=__stackBase__+22908;
      var $4846=__stackBase__+22912;
      var $4847=__stackBase__+22916;
      var $4848=__stackBase__+22920;
      var $4849=__stackBase__+22924;
      var $4850=__stackBase__+22928;
      var $4851=__stackBase__+22932;
      var $4852=__stackBase__+22936;
      var $4853=__stackBase__+23000;
      var $4854=__stackBase__+23004;
      var $4855=__stackBase__+23008;
      var $4856=__stackBase__+23012;
      var $4857=__stackBase__+23016;
      var $4858=__stackBase__+23020;
      var $4859=__stackBase__+23024;
      var $4860=__stackBase__+23028;
      var $4861=__stackBase__+23092;
      var $4862=__stackBase__+23096;
      var $4863=__stackBase__+23100;
      var $4864=__stackBase__+23104;
      var $4865=__stackBase__+23108;
      var $4866=__stackBase__+23112;
      var $4867=__stackBase__+23116;
      var $4868=__stackBase__+23120;
      var $4869=__stackBase__+23184;
      var $4870=__stackBase__+23188;
      var $4871=__stackBase__+23192;
      var $4872=__stackBase__+23196;
      var $4873=__stackBase__+23200;
      var $4874=__stackBase__+23204;
      var $4875=__stackBase__+23208;
      var $4876=__stackBase__+23212;
      var $4877=__stackBase__+23276;
      var $4878=__stackBase__+23280;
      var $4879=__stackBase__+23284;
      var $4880=__stackBase__+23288;
      var $4881=__stackBase__+23292;
      var $4882=__stackBase__+23296;
      var $4883=__stackBase__+23300;
      var $4884=__stackBase__+23304;
      var $4885=__stackBase__+23368;
      var $4886=__stackBase__+23372;
      var $4887=__stackBase__+23376;
      var $4888=__stackBase__+23380;
      var $4889=__stackBase__+23384;
      var $4890=__stackBase__+23388;
      var $4891=__stackBase__+23392;
      var $4892=__stackBase__+23396;
      var $4893=__stackBase__+23460;
      var $4894=__stackBase__+23464;
      var $4895=__stackBase__+23468;
      var $4896=__stackBase__+23472;
      var $4897=__stackBase__+23476;
      var $4898=__stackBase__+23480;
      var $4899=__stackBase__+23484;
      var $4900=__stackBase__+23488;
      var $4901=__stackBase__+23552;
      var $4902=__stackBase__+23556;
      var $4903=__stackBase__+23560;
      var $4904=__stackBase__+23564;
      var $4905=__stackBase__+23568;
      var $4906=__stackBase__+23572;
      var $4907=__stackBase__+23576;
      var $4908=__stackBase__+23580;
      var $4909=__stackBase__+23644;
      var $4910=__stackBase__+23648;
      var $4911=__stackBase__+23652;
      var $4912=__stackBase__+23656;
      var $4913=__stackBase__+23660;
      var $4914=__stackBase__+23664;
      var $4915=__stackBase__+23668;
      var $4916=__stackBase__+23672;
      var $4917=__stackBase__+23736;
      var $4918=__stackBase__+23740;
      var $4919=__stackBase__+23744;
      var $4920=__stackBase__+23748;
      var $4921=__stackBase__+23752;
      var $4922=__stackBase__+23756;
      var $4923=__stackBase__+23760;
      var $4924=__stackBase__+23764;
      var $4925=__stackBase__+23828;
      var $4926=__stackBase__+23832;
      var $4927=__stackBase__+23836;
      var $4928=__stackBase__+23840;
      var $4929=__stackBase__+23844;
      var $4930=__stackBase__+23848;
      var $4931=__stackBase__+23852;
      var $4932=__stackBase__+23856;
      var $4933=__stackBase__+23920;
      var $4934=__stackBase__+23924;
      var $4935=__stackBase__+23928;
      var $4936=__stackBase__+23932;
      var $4937=__stackBase__+23936;
      var $4938=__stackBase__+23940;
      var $4939=__stackBase__+23944;
      var $4940=__stackBase__+23948;
      var $4941=__stackBase__+24012;
      var $4942=__stackBase__+24016;
      var $4943=__stackBase__+24020;
      var $4944=__stackBase__+24024;
      var $4945=__stackBase__+24028;
      var $4946=__stackBase__+24032;
      var $4947=__stackBase__+24036;
      var $4948=__stackBase__+24040;
      var $4949=__stackBase__+24104;
      var $4950=__stackBase__+24108;
      var $4951=__stackBase__+24112;
      var $4952=__stackBase__+24116;
      var $4953=__stackBase__+24120;
      var $4954=__stackBase__+24124;
      var $4955=__stackBase__+24128;
      var $4956=__stackBase__+24132;
      var $4957=__stackBase__+24196;
      var $4958=__stackBase__+24200;
      var $4959=__stackBase__+24204;
      var $4960=__stackBase__+24208;
      var $4961=__stackBase__+24212;
      var $4962=__stackBase__+24216;
      var $4963=__stackBase__+24220;
      var $4964=__stackBase__+24224;
      var $4965=__stackBase__+24288;
      var $4966=__stackBase__+24292;
      var $4967=__stackBase__+24296;
      var $4968=__stackBase__+24300;
      var $4969=__stackBase__+24304;
      var $4970=__stackBase__+24308;
      var $4971=__stackBase__+24312;
      var $4972=__stackBase__+24316;
      var $4973=__stackBase__+24380;
      var $4974=__stackBase__+24384;
      var $4975=__stackBase__+24388;
      var $4976=__stackBase__+24392;
      var $4977=__stackBase__+24396;
      var $4978=__stackBase__+24400;
      var $4979=__stackBase__+24404;
      var $4980=__stackBase__+24408;
      var $4981=__stackBase__+24472;
      var $4982=__stackBase__+24476;
      var $4983=__stackBase__+24480;
      var $4984=__stackBase__+24484;
      var $4985=__stackBase__+24488;
      var $4986=__stackBase__+24492;
      var $4987=__stackBase__+24496;
      var $4988=__stackBase__+24500;
      var $4989=__stackBase__+24564;
      var $4990=__stackBase__+24568;
      var $4991=__stackBase__+24572;
      var $4992=__stackBase__+24576;
      var $4993=__stackBase__+24580;
      var $4994=__stackBase__+24584;
      var $4995=__stackBase__+24588;
      var $4996=__stackBase__+24592;
      var $4997=__stackBase__+24656;
      var $4998=__stackBase__+24660;
      var $4999=__stackBase__+24664;
      var $5000=__stackBase__+24668;
      var $5001=__stackBase__+24672;
      var $5002=__stackBase__+24676;
      var $5003=__stackBase__+24680;
      var $5004=__stackBase__+24684;
      var $5005=__stackBase__+24748;
      var $5006=__stackBase__+24752;
      var $5007=__stackBase__+24756;
      var $5008=__stackBase__+24760;
      var $5009=__stackBase__+24764;
      var $5010=__stackBase__+24768;
      var $5011=__stackBase__+24772;
      var $5012=__stackBase__+24776;
      var $5013=__stackBase__+24840;
      var $5014=__stackBase__+24844;
      var $5015=__stackBase__+24848;
      var $5016=__stackBase__+24852;
      var $5017=__stackBase__+24856;
      var $5018=__stackBase__+24860;
      var $5019=__stackBase__+24864;
      var $5020=__stackBase__+24868;
      var $5021=__stackBase__+24932;
      var $5022=__stackBase__+24936;
      var $5023=__stackBase__+24940;
      var $5024=__stackBase__+24944;
      var $5025=__stackBase__+24948;
      var $5026=__stackBase__+24952;
      var $5027=__stackBase__+24956;
      var $5028=__stackBase__+24960;
      var $5029=__stackBase__+25024;
      var $5030=__stackBase__+25028;
      var $5031=__stackBase__+25032;
      var $5032=__stackBase__+25036;
      var $5033=__stackBase__+25040;
      var $5034=__stackBase__+25044;
      var $5035=__stackBase__+25048;
      var $5036=__stackBase__+25052;
      var $5037=__stackBase__+25116;
      var $5038=__stackBase__+25120;
      var $5039=__stackBase__+25124;
      var $5040=__stackBase__+25128;
      var $5041=__stackBase__+25132;
      var $5042=__stackBase__+25136;
      var $5043=__stackBase__+25140;
      var $5044=__stackBase__+25144;
      var $5045=__stackBase__+25208;
      var $5046=__stackBase__+25212;
      var $5047=__stackBase__+25216;
      var $5048=__stackBase__+25220;
      var $5049=__stackBase__+25224;
      var $5050=__stackBase__+25228;
      var $5051=__stackBase__+25232;
      var $5052=__stackBase__+25236;
      var $5053=__stackBase__+25300;
      var $5054=__stackBase__+25304;
      var $5055=__stackBase__+25308;
      var $5056=__stackBase__+25312;
      var $5057=__stackBase__+25316;
      var $5058=__stackBase__+25320;
      var $5059=__stackBase__+25324;
      var $5060=__stackBase__+25328;
      var $5061=__stackBase__+25392;
      var $5062=__stackBase__+25396;
      var $5063=__stackBase__+25400;
      var $5064=__stackBase__+25404;
      var $5065=__stackBase__+25408;
      var $5066=__stackBase__+25412;
      var $5067=__stackBase__+25416;
      var $5068=__stackBase__+25420;
      var $5069=__stackBase__+25484;
      var $5070=__stackBase__+25488;
      var $5071=__stackBase__+25492;
      var $5072=__stackBase__+25496;
      var $5073=__stackBase__+25500;
      var $5074=__stackBase__+25504;
      var $5075=__stackBase__+25508;
      var $5076=__stackBase__+25512;
      var $5077=__stackBase__+25576;
      var $5078=__stackBase__+25580;
      var $5079=__stackBase__+25584;
      var $5080=__stackBase__+25588;
      var $5081=__stackBase__+25592;
      var $5082=__stackBase__+25596;
      var $5083=__stackBase__+25600;
      var $5084=__stackBase__+25604;
      var $5085=__stackBase__+25668;
      var $5086=__stackBase__+25672;
      var $5087=__stackBase__+25676;
      var $5088=__stackBase__+25680;
      var $5089=__stackBase__+25684;
      var $5090=__stackBase__+25688;
      var $5091=__stackBase__+25692;
      var $5092=__stackBase__+25696;
      var $5093=__stackBase__+25760;
      var $5094=__stackBase__+25764;
      var $5095=__stackBase__+25768;
      var $5096=__stackBase__+25772;
      var $5097=__stackBase__+25776;
      var $5098=__stackBase__+25780;
      var $5099=__stackBase__+25784;
      var $5100=__stackBase__+25788;
      var $5101=__stackBase__+25852;
      var $5102=__stackBase__+25856;
      var $5103=__stackBase__+25860;
      var $5104=__stackBase__+25864;
      var $5105=__stackBase__+25868;
      var $5106=__stackBase__+25872;
      var $5107=__stackBase__+25876;
      var $5108=__stackBase__+25880;
      var $5109=__stackBase__+25944;
      var $5110=__stackBase__+25948;
      var $5111=__stackBase__+25952;
      var $5112=__stackBase__+25956;
      var $5113=__stackBase__+25960;
      var $5114=__stackBase__+25964;
      var $5115=__stackBase__+25968;
      var $5116=__stackBase__+25972;
      var $5117=__stackBase__+26036;
      var $5118=__stackBase__+26040;
      var $5119=__stackBase__+26044;
      var $5120=__stackBase__+26048;
      var $5121=__stackBase__+26052;
      var $5122=__stackBase__+26056;
      var $5123=__stackBase__+26060;
      var $5124=__stackBase__+26064;
      var $5125=__stackBase__+26128;
      var $5126=__stackBase__+26132;
      var $5127=__stackBase__+26136;
      var $5128=__stackBase__+26140;
      var $5129=__stackBase__+26144;
      var $5130=__stackBase__+26148;
      var $5131=__stackBase__+26152;
      var $5132=__stackBase__+26156;
      var $5133=__stackBase__+26220;
      var $5134=__stackBase__+26224;
      var $5135=__stackBase__+26228;
      var $5136=__stackBase__+26232;
      var $5137=__stackBase__+26236;
      var $5138=__stackBase__+26240;
      var $5139=__stackBase__+26244;
      var $5140=__stackBase__+26248;
      var $5141=__stackBase__+26312;
      var $5142=__stackBase__+26316;
      var $5143=__stackBase__+26320;
      var $5144=__stackBase__+26324;
      var $5145=__stackBase__+26328;
      var $5146=__stackBase__+26332;
      var $5147=__stackBase__+26336;
      var $5148=__stackBase__+26340;
      var $5149=__stackBase__+26404;
      var $5150=__stackBase__+26408;
      var $5151=__stackBase__+26412;
      var $5152=__stackBase__+26416;
      var $5153=__stackBase__+26420;
      var $5154=__stackBase__+26424;
      var $5155=__stackBase__+26428;
      var $5156=__stackBase__+26432;
      var $5157=__stackBase__+26496;
      var $5158=__stackBase__+26500;
      var $5159=__stackBase__+26504;
      var $5160=__stackBase__+26508;
      var $5161=__stackBase__+26512;
      var $5162=__stackBase__+26516;
      var $5163=__stackBase__+26520;
      var $5164=__stackBase__+26524;
      var $5165=__stackBase__+26588;
      var $5166=__stackBase__+26592;
      var $5167=__stackBase__+26596;
      var $5168=__stackBase__+26600;
      var $5169=__stackBase__+26604;
      var $5170=__stackBase__+26608;
      var $5171=__stackBase__+26612;
      var $5172=__stackBase__+26616;
      var $5173=__stackBase__+26680;
      var $5174=__stackBase__+26684;
      var $5175=__stackBase__+26688;
      var $5176=__stackBase__+26692;
      var $5177=__stackBase__+26696;
      var $5178=__stackBase__+26700;
      var $5179=__stackBase__+26704;
      var $5180=__stackBase__+26708;
      var $5181=__stackBase__+26772;
      var $5182=__stackBase__+26776;
      var $5183=__stackBase__+26780;
      var $5184=__stackBase__+26784;
      var $5185=__stackBase__+26788;
      var $5186=__stackBase__+26792;
      var $5187=__stackBase__+26796;
      var $5188=__stackBase__+26800;
      var $5189=__stackBase__+26864;
      var $5190=__stackBase__+26868;
      var $5191=__stackBase__+26872;
      var $5192=__stackBase__+26876;
      var $5193=__stackBase__+26880;
      var $5194=__stackBase__+26884;
      var $5195=__stackBase__+26888;
      var $5196=__stackBase__+26892;
      var $5197=__stackBase__+26956;
      var $5198=__stackBase__+26960;
      var $5199=__stackBase__+26964;
      var $5200=__stackBase__+26968;
      var $5201=__stackBase__+26972;
      var $5202=__stackBase__+26976;
      var $5203=__stackBase__+26980;
      var $5204=__stackBase__+26984;
      var $5205=__stackBase__+27048;
      var $5206=__stackBase__+27052;
      var $5207=__stackBase__+27056;
      var $5208=__stackBase__+27060;
      var $5209=__stackBase__+27064;
      var $5210=__stackBase__+27068;
      var $5211=__stackBase__+27072;
      var $5212=__stackBase__+27076;
      var $5213=__stackBase__+27140;
      var $5214=__stackBase__+27144;
      var $5215=__stackBase__+27148;
      var $5216=__stackBase__+27152;
      var $5217=__stackBase__+27156;
      var $5218=__stackBase__+27160;
      var $5219=__stackBase__+27164;
      var $5220=__stackBase__+27168;
      var $5221=__stackBase__+27232;
      var $5222=__stackBase__+27236;
      var $5223=__stackBase__+27240;
      var $5224=__stackBase__+27244;
      var $5225=__stackBase__+27248;
      var $5226=__stackBase__+27252;
      var $5227=__stackBase__+27256;
      var $5228=__stackBase__+27260;
      var $5229=__stackBase__+27324;
      var $5230=__stackBase__+27328;
      var $5231=__stackBase__+27332;
      var $5232=__stackBase__+27336;
      var $5233=__stackBase__+27340;
      var $5234=__stackBase__+27344;
      var $5235=__stackBase__+27348;
      var $5236=__stackBase__+27352;
      var $5237=__stackBase__+27416;
      var $5238=__stackBase__+27420;
      var $5239=__stackBase__+27424;
      var $5240=__stackBase__+27428;
      var $5241=__stackBase__+27432;
      var $5242=__stackBase__+27436;
      var $5243=__stackBase__+27440;
      var $5244=__stackBase__+27444;
      var $5245=__stackBase__+27508;
      var $5246=__stackBase__+27512;
      var $5247=__stackBase__+27516;
      var $5248=__stackBase__+27520;
      var $5249=__stackBase__+27524;
      var $5250=__stackBase__+27528;
      var $5251=__stackBase__+27532;
      var $5252=__stackBase__+27536;
      var $5253=__stackBase__+27600;
      var $5254=__stackBase__+27604;
      var $5255=__stackBase__+27608;
      var $5256=__stackBase__+27612;
      var $5257=__stackBase__+27616;
      var $5258=__stackBase__+27620;
      var $5259=__stackBase__+27624;
      var $5260=__stackBase__+27628;
      var $5261=__stackBase__+27692;
      var $5262=__stackBase__+27696;
      var $5263=__stackBase__+27700;
      var $5264=__stackBase__+27704;
      var $5265=__stackBase__+27708;
      var $5266=__stackBase__+27712;
      var $5267=__stackBase__+27716;
      var $5268=__stackBase__+27720;
      var $5269=__stackBase__+27784;
      var $5270=__stackBase__+27788;
      var $5271=__stackBase__+27792;
      var $5272=__stackBase__+27796;
      var $5273=__stackBase__+27800;
      var $5274=__stackBase__+27804;
      var $5275=__stackBase__+27808;
      var $5276=__stackBase__+27812;
      var $5277=__stackBase__+27876;
      var $5278=__stackBase__+27880;
      var $5279=__stackBase__+27884;
      var $5280=__stackBase__+27888;
      var $5281=__stackBase__+27892;
      var $5282=__stackBase__+27896;
      var $5283=__stackBase__+27900;
      var $5284=__stackBase__+27904;
      var $5285=__stackBase__+27968;
      var $5286=__stackBase__+27972;
      var $5287=__stackBase__+27976;
      var $5288=__stackBase__+27980;
      var $5289=__stackBase__+27984;
      var $5290=__stackBase__+27988;
      var $5291=__stackBase__+27992;
      var $5292=__stackBase__+27996;
      var $5293=__stackBase__+28060;
      var $5294=__stackBase__+28064;
      var $5295=__stackBase__+28068;
      var $5296=__stackBase__+28072;
      var $5297=__stackBase__+28076;
      var $5298=__stackBase__+28080;
      var $5299=__stackBase__+28084;
      var $5300=__stackBase__+28088;
      var $5301=__stackBase__+28152;
      var $5302=__stackBase__+28156;
      var $5303=__stackBase__+28160;
      var $5304=__stackBase__+28164;
      var $5305=__stackBase__+28168;
      var $5306=__stackBase__+28172;
      var $5307=__stackBase__+28176;
      var $5308=__stackBase__+28180;
      var $5309=__stackBase__+28244;
      var $5310=__stackBase__+28248;
      var $5311=__stackBase__+28252;
      var $5312=__stackBase__+28256;
      var $5313=__stackBase__+28260;
      var $5314=__stackBase__+28264;
      var $5315=__stackBase__+28268;
      var $5316=__stackBase__+28272;
      var $5317=__stackBase__+28336;
      var $5318=__stackBase__+28340;
      var $5319=__stackBase__+28344;
      var $5320=__stackBase__+28348;
      var $5321=__stackBase__+28352;
      var $5322=__stackBase__+28356;
      var $5323=__stackBase__+28360;
      var $5324=__stackBase__+28364;
      var $5325=__stackBase__+28428;
      var $5326=__stackBase__+28432;
      var $5327=__stackBase__+28436;
      var $5328=__stackBase__+28440;
      var $5329=__stackBase__+28444;
      var $5330=__stackBase__+28448;
      var $5331=__stackBase__+28452;
      var $5332=__stackBase__+28456;
      var $5333=__stackBase__+28520;
      var $5334=__stackBase__+28524;
      var $5335=__stackBase__+28528;
      var $5336=__stackBase__+28532;
      var $5337=__stackBase__+28536;
      var $5338=__stackBase__+28540;
      var $5339=__stackBase__+28544;
      var $5340=__stackBase__+28548;
      var $5341=__stackBase__+28612;
      var $5342=__stackBase__+28616;
      var $5343=__stackBase__+28620;
      var $5344=__stackBase__+28624;
      var $5345=__stackBase__+28628;
      var $5346=__stackBase__+28632;
      var $5347=__stackBase__+28636;
      var $5348=__stackBase__+28640;
      var $5349=__stackBase__+28704;
      var $5350=__stackBase__+28708;
      var $5351=__stackBase__+28712;
      var $5352=__stackBase__+28716;
      var $5353=__stackBase__+28720;
      var $5354=__stackBase__+28724;
      var $5355=__stackBase__+28728;
      var $5356=__stackBase__+28732;
      var $5357=__stackBase__+28796;
      var $5358=__stackBase__+28800;
      var $5359=__stackBase__+28804;
      var $5360=__stackBase__+28808;
      var $5361=__stackBase__+28812;
      var $5362=__stackBase__+28816;
      var $5363=__stackBase__+28820;
      var $5364=__stackBase__+28824;
      var $5365=__stackBase__+28888;
      var $5366=__stackBase__+28892;
      var $5367=__stackBase__+28896;
      var $5368=__stackBase__+28900;
      var $5369=__stackBase__+28904;
      var $5370=__stackBase__+28908;
      var $5371=__stackBase__+28912;
      var $5372=__stackBase__+28916;
      var $5373=__stackBase__+28980;
      var $5374=__stackBase__+28984;
      var $5375=__stackBase__+28988;
      var $5376=__stackBase__+28992;
      var $5377=__stackBase__+28996;
      var $5378=__stackBase__+29000;
      var $5379=__stackBase__+29004;
      var $5380=__stackBase__+29008;
      var $5381=__stackBase__+29072;
      var $5382=__stackBase__+29076;
      var $5383=__stackBase__+29080;
      var $5384=__stackBase__+29084;
      var $5385=__stackBase__+29088;
      var $5386=__stackBase__+29092;
      var $5387=__stackBase__+29096;
      var $5388=__stackBase__+29100;
      var $5389=__stackBase__+29164;
      var $5390=__stackBase__+29168;
      var $5391=__stackBase__+29172;
      var $5392=__stackBase__+29176;
      var $5393=__stackBase__+29180;
      var $5394=__stackBase__+29184;
      var $5395=__stackBase__+29188;
      var $5396=__stackBase__+29192;
      var $5397=__stackBase__+29256;
      var $5398=__stackBase__+29260;
      var $5399=__stackBase__+29264;
      var $5400=__stackBase__+29268;
      var $5401=__stackBase__+29272;
      var $5402=__stackBase__+29276;
      var $5403=__stackBase__+29280;
      var $5404=__stackBase__+29284;
      var $5405=__stackBase__+29348;
      var $5406=__stackBase__+29352;
      var $5407=__stackBase__+29356;
      var $5408=__stackBase__+29360;
      var $5409=__stackBase__+29364;
      var $5410=__stackBase__+29368;
      var $5411=__stackBase__+29372;
      var $5412=__stackBase__+29376;
      var $5413=__stackBase__+29440;
      var $5414=__stackBase__+29444;
      var $5415=__stackBase__+29448;
      var $5416=__stackBase__+29452;
      var $5417=__stackBase__+29456;
      var $5418=__stackBase__+29460;
      var $5419=__stackBase__+29464;
      var $5420=__stackBase__+29468;
      var $5421=__stackBase__+29532;
      var $5422=__stackBase__+29536;
      var $5423=__stackBase__+29540;
      var $5424=__stackBase__+29544;
      var $5425=__stackBase__+29548;
      var $5426=__stackBase__+29552;
      var $5427=__stackBase__+29556;
      var $5428=__stackBase__+29560;
      var $5429=__stackBase__+29624;
      var $5430=__stackBase__+29628;
      var $5431=__stackBase__+29632;
      var $5432=__stackBase__+29636;
      var $5433=__stackBase__+29640;
      var $5434=__stackBase__+29644;
      var $5435=__stackBase__+29648;
      var $5436=__stackBase__+29652;
      var $5437=__stackBase__+29716;
      var $5438=__stackBase__+29720;
      var $5439=__stackBase__+29724;
      var $5440=__stackBase__+29728;
      var $5441=__stackBase__+29732;
      var $5442=__stackBase__+29736;
      var $5443=__stackBase__+29740;
      var $5444=__stackBase__+29744;
      var $5445=__stackBase__+29808;
      var $5446=__stackBase__+29812;
      var $5447=__stackBase__+29816;
      var $5448=__stackBase__+29820;
      var $5449=__stackBase__+29824;
      var $5450=__stackBase__+29828;
      var $5451=__stackBase__+29832;
      var $5452=__stackBase__+29836;
      var $5453=__stackBase__+29900;
      var $5454=__stackBase__+29904;
      var $5455=__stackBase__+29908;
      var $5456=__stackBase__+29912;
      var $5457=__stackBase__+29916;
      var $5458=__stackBase__+29920;
      var $5459=__stackBase__+29924;
      var $5460=__stackBase__+29928;
      var $5461=__stackBase__+29992;
      var $5462=__stackBase__+29996;
      var $5463=__stackBase__+30000;
      var $5464=__stackBase__+30004;
      var $5465=__stackBase__+30008;
      var $5466=__stackBase__+30012;
      var $5467=__stackBase__+30016;
      var $5468=__stackBase__+30020;
      var $5469=__stackBase__+30084;
      var $5470=__stackBase__+30088;
      var $5471=__stackBase__+30092;
      var $5472=__stackBase__+30096;
      var $5473=__stackBase__+30100;
      var $5474=__stackBase__+30104;
      var $5475=__stackBase__+30108;
      var $5476=__stackBase__+30112;
      var $5477=__stackBase__+30176;
      var $5478=__stackBase__+30180;
      var $5479=__stackBase__+30184;
      var $5480=__stackBase__+30188;
      var $5481=__stackBase__+30192;
      var $5482=__stackBase__+30196;
      var $5483=__stackBase__+30200;
      var $5484=__stackBase__+30204;
      var $5485=__stackBase__+30268;
      var $5486=__stackBase__+30272;
      var $5487=__stackBase__+30276;
      var $5488=__stackBase__+30280;
      var $5489=__stackBase__+30284;
      var $5490=__stackBase__+30288;
      var $5491=__stackBase__+30292;
      var $5492=__stackBase__+30296;
      var $5493=__stackBase__+30360;
      var $5494=__stackBase__+30364;
      var $5495=__stackBase__+30368;
      var $5496=__stackBase__+30372;
      var $5497=__stackBase__+30376;
      var $5498=__stackBase__+30380;
      var $5499=__stackBase__+30384;
      var $5500=__stackBase__+30388;
      var $5501=__stackBase__+30452;
      var $5502=__stackBase__+30456;
      var $5503=__stackBase__+30460;
      var $5504=__stackBase__+30464;
      var $5505=__stackBase__+30468;
      var $5506=__stackBase__+30472;
      var $5507=__stackBase__+30476;
      var $5508=__stackBase__+30480;
      var $5509=__stackBase__+30544;
      var $5510=__stackBase__+30548;
      var $5511=__stackBase__+30552;
      var $5512=__stackBase__+30556;
      var $5513=__stackBase__+30560;
      var $5514=__stackBase__+30564;
      var $5515=__stackBase__+30568;
      var $5516=__stackBase__+30572;
      var $5517=__stackBase__+30636;
      var $5518=__stackBase__+30640;
      var $5519=__stackBase__+30644;
      var $5520=__stackBase__+30648;
      var $5521=__stackBase__+30652;
      var $5522=__stackBase__+30656;
      var $5523=__stackBase__+30660;
      var $5524=__stackBase__+30664;
      var $5525=__stackBase__+30728;
      var $5526=__stackBase__+30732;
      var $5527=__stackBase__+30736;
      var $5528=__stackBase__+30740;
      var $5529=__stackBase__+30744;
      var $5530=__stackBase__+30748;
      var $5531=__stackBase__+30752;
      var $5532=__stackBase__+30756;
      var $5533=__stackBase__+30820;
      var $5534=__stackBase__+30824;
      var $5535=__stackBase__+30828;
      var $5536=__stackBase__+30832;
      var $5537=__stackBase__+30836;
      var $5538=__stackBase__+30840;
      var $5539=__stackBase__+30844;
      var $5540=__stackBase__+30848;
      var $5541=__stackBase__+30912;
      var $5542=__stackBase__+30916;
      var $5543=__stackBase__+30920;
      var $5544=__stackBase__+30924;
      var $5545=__stackBase__+30928;
      var $5546=__stackBase__+30932;
      var $5547=__stackBase__+30936;
      var $5548=__stackBase__+30940;
      var $5549=__stackBase__+31004;
      var $5550=__stackBase__+31008;
      var $5551=__stackBase__+31012;
      var $5552=__stackBase__+31016;
      var $5553=__stackBase__+31020;
      var $5554=__stackBase__+31024;
      var $5555=__stackBase__+31028;
      var $5556=__stackBase__+31032;
      var $5557=__stackBase__+31096;
      var $5558=__stackBase__+31100;
      var $5559=__stackBase__+31104;
      var $5560=__stackBase__+31108;
      var $5561=__stackBase__+31112;
      var $5562=__stackBase__+31116;
      var $5563=__stackBase__+31120;
      var $5564=__stackBase__+31124;
      var $5565=__stackBase__+31188;
      var $5566=__stackBase__+31192;
      var $5567=__stackBase__+31196;
      var $5568=__stackBase__+31200;
      var $5569=__stackBase__+31204;
      var $5570=__stackBase__+31208;
      var $5571=__stackBase__+31212;
      var $5572=__stackBase__+31216;
      var $5573=__stackBase__+31280;
      var $5574=__stackBase__+31284;
      var $5575=__stackBase__+31288;
      var $5576=__stackBase__+31292;
      var $5577=__stackBase__+31296;
      var $5578=__stackBase__+31300;
      var $5579=__stackBase__+31304;
      var $5580=__stackBase__+31308;
      var $5581=__stackBase__+31372;
      var $5582=__stackBase__+31376;
      var $5583=__stackBase__+31380;
      var $5584=__stackBase__+31384;
      var $5585=__stackBase__+31388;
      var $5586=__stackBase__+31392;
      var $5587=__stackBase__+31396;
      var $5588=__stackBase__+31400;
      var $5589=__stackBase__+31464;
      var $5590=__stackBase__+31468;
      var $5591=__stackBase__+31472;
      var $5592=__stackBase__+31476;
      var $5593=__stackBase__+31480;
      var $5594=__stackBase__+31484;
      var $5595=__stackBase__+31488;
      var $5596=__stackBase__+31492;
      var $5597=__stackBase__+31556;
      var $5598=__stackBase__+31560;
      var $5599=__stackBase__+31564;
      var $5600=__stackBase__+31568;
      var $5601=__stackBase__+31572;
      var $5602=__stackBase__+31576;
      var $5603=__stackBase__+31580;
      var $5604=__stackBase__+31584;
      var $5605=__stackBase__+31648;
      var $5606=__stackBase__+31652;
      var $5607=__stackBase__+31656;
      var $5608=__stackBase__+31660;
      var $5609=__stackBase__+31664;
      var $5610=__stackBase__+31668;
      var $5611=__stackBase__+31672;
      var $5612=__stackBase__+31676;
      var $5613=__stackBase__+31740;
      var $5614=__stackBase__+31744;
      var $5615=__stackBase__+31748;
      var $5616=__stackBase__+31752;
      var $5617=__stackBase__+31756;
      var $5618=__stackBase__+31760;
      var $5619=__stackBase__+31764;
      var $5620=__stackBase__+31768;
      var $5621=__stackBase__+31832;
      var $5622=__stackBase__+31836;
      var $5623=__stackBase__+31840;
      var $5624=__stackBase__+31844;
      var $5625=__stackBase__+31848;
      var $5626=__stackBase__+31852;
      var $5627=__stackBase__+31856;
      var $5628=__stackBase__+31860;
      var $5629=__stackBase__+31924;
      var $5630=__stackBase__+31928;
      var $5631=__stackBase__+31932;
      var $5632=__stackBase__+31936;
      var $5633=__stackBase__+31940;
      var $5634=__stackBase__+31944;
      var $5635=__stackBase__+31948;
      var $5636=__stackBase__+31952;
      var $5637=__stackBase__+32016;
      var $5638=__stackBase__+32020;
      var $5639=__stackBase__+32024;
      var $5640=__stackBase__+32028;
      var $5641=__stackBase__+32032;
      var $5642=__stackBase__+32036;
      var $5643=__stackBase__+32040;
      var $5644=__stackBase__+32044;
      var $5645=__stackBase__+32108;
      var $5646=__stackBase__+32112;
      var $5647=__stackBase__+32116;
      var $5648=__stackBase__+32120;
      var $5649=__stackBase__+32124;
      var $5650=__stackBase__+32128;
      var $5651=__stackBase__+32132;
      var $5652=__stackBase__+32136;
      var $5653=__stackBase__+32200;
      var $5654=__stackBase__+32204;
      var $5655=__stackBase__+32208;
      var $5656=__stackBase__+32212;
      var $5657=__stackBase__+32216;
      var $5658=__stackBase__+32220;
      var $5659=__stackBase__+32224;
      var $5660=__stackBase__+32228;
      var $5661=__stackBase__+32292;
      var $5662=__stackBase__+32296;
      var $5663=__stackBase__+32300;
      var $5664=__stackBase__+32304;
      var $5665=__stackBase__+32308;
      var $5666=__stackBase__+32312;
      var $5667=__stackBase__+32316;
      var $5668=__stackBase__+32320;
      var $5669=__stackBase__+32384;
      var $5670=__stackBase__+32388;
      var $5671=__stackBase__+32392;
      var $5672=__stackBase__+32396;
      var $5673=__stackBase__+32400;
      var $5674=__stackBase__+32404;
      var $5675=__stackBase__+32408;
      var $5676=__stackBase__+32412;
      var $5677=__stackBase__+32476;
      var $5678=__stackBase__+32480;
      var $5679=__stackBase__+32484;
      var $5680=__stackBase__+32488;
      var $5681=__stackBase__+32492;
      var $5682=__stackBase__+32496;
      var $5683=__stackBase__+32500;
      var $5684=__stackBase__+32504;
      var $5685=__stackBase__+32568;
      var $5686=__stackBase__+32572;
      var $5687=__stackBase__+32576;
      var $5688=__stackBase__+32580;
      var $5689=__stackBase__+32584;
      var $5690=__stackBase__+32588;
      var $5691=__stackBase__+32592;
      var $5692=__stackBase__+32596;
      var $5693=__stackBase__+32660;
      var $5694=__stackBase__+32664;
      var $5695=__stackBase__+32668;
      var $5696=__stackBase__+32672;
      var $5697=__stackBase__+32676;
      var $5698=__stackBase__+32680;
      var $5699=__stackBase__+32684;
      var $5700=__stackBase__+32688;
      var $5701=__stackBase__+32752;
      var $5702=__stackBase__+32756;
      var $5703=__stackBase__+32760;
      var $5704=__stackBase__+32764;
      var $5705=__stackBase__+32768;
      var $5706=__stackBase__+32772;
      var $5707=__stackBase__+32776;
      var $5708=__stackBase__+32780;
      var $5709=__stackBase__+32844;
      var $5710=__stackBase__+32848;
      var $5711=__stackBase__+32852;
      var $5712=__stackBase__+32856;
      var $5713=__stackBase__+32860;
      var $5714=__stackBase__+32864;
      var $5715=__stackBase__+32868;
      var $5716=__stackBase__+32872;
      var $5717=__stackBase__+32936;
      var $5718=__stackBase__+32940;
      var $5719=__stackBase__+32944;
      var $5720=__stackBase__+32948;
      var $5721=__stackBase__+32952;
      var $5722=__stackBase__+32956;
      var $5723=__stackBase__+32960;
      var $5724=__stackBase__+32964;
      var $5725=__stackBase__+33028;
      var $5726=__stackBase__+33032;
      var $5727=__stackBase__+33036;
      var $5728=__stackBase__+33040;
      var $5729=__stackBase__+33044;
      var $5730=__stackBase__+33048;
      var $5731=__stackBase__+33052;
      var $5732=__stackBase__+33056;
      var $5733=__stackBase__+33120;
      var $5734=__stackBase__+33124;
      var $5735=__stackBase__+33128;
      var $5736=__stackBase__+33132;
      var $5737=__stackBase__+33136;
      var $5738=__stackBase__+33140;
      var $5739=__stackBase__+33144;
      var $5740=__stackBase__+33148;
      var $5741=__stackBase__+33212;
      var $5742=__stackBase__+33216;
      var $5743=__stackBase__+33220;
      var $5744=__stackBase__+33224;
      var $5745=__stackBase__+33228;
      var $5746=__stackBase__+33232;
      var $5747=__stackBase__+33236;
      var $5748=__stackBase__+33240;
      var $5749=__stackBase__+33304;
      var $5750=__stackBase__+33308;
      var $5751=__stackBase__+33312;
      var $5752=__stackBase__+33316;
      var $5753=__stackBase__+33320;
      var $5754=__stackBase__+33324;
      var $5755=__stackBase__+33328;
      var $5756=__stackBase__+33332;
      var $5757=__stackBase__+33396;
      var $5758=__stackBase__+33400;
      var $5759=__stackBase__+33404;
      var $5760=__stackBase__+33408;
      var $5761=__stackBase__+33412;
      var $5762=__stackBase__+33416;
      var $5763=__stackBase__+33420;
      var $5764=__stackBase__+33424;
      var $5765=__stackBase__+33488;
      var $5766=__stackBase__+33492;
      var $5767=__stackBase__+33496;
      var $5768=__stackBase__+33500;
      var $5769=__stackBase__+33504;
      var $5770=__stackBase__+33508;
      var $5771=__stackBase__+33512;
      var $5772=__stackBase__+33516;
      var $5773=__stackBase__+33580;
      var $5774=__stackBase__+33584;
      var $5775=__stackBase__+33588;
      var $5776=__stackBase__+33592;
      var $5777=__stackBase__+33596;
      var $5778=__stackBase__+33600;
      var $5779=__stackBase__+33604;
      var $5780=__stackBase__+33608;
      var $5781=__stackBase__+33672;
      var $5782=__stackBase__+33676;
      var $5783=__stackBase__+33680;
      var $5784=__stackBase__+33684;
      var $5785=__stackBase__+33688;
      var $5786=__stackBase__+33692;
      var $5787=__stackBase__+33696;
      var $5788=__stackBase__+33700;
      var $5789=__stackBase__+33764;
      var $5790=__stackBase__+33768;
      var $5791=__stackBase__+33772;
      var $5792=__stackBase__+33776;
      var $5793=__stackBase__+33780;
      var $5794=__stackBase__+33784;
      var $5795=__stackBase__+33788;
      var $5796=__stackBase__+33792;
      var $5797=__stackBase__+33856;
      var $5798=__stackBase__+33860;
      var $5799=__stackBase__+33864;
      var $5800=__stackBase__+33868;
      var $5801=__stackBase__+33872;
      var $5802=__stackBase__+33876;
      var $5803=__stackBase__+33880;
      var $5804=__stackBase__+33884;
      var $5805=__stackBase__+33948;
      var $5806=__stackBase__+33952;
      var $5807=__stackBase__+33956;
      var $5808=__stackBase__+33960;
      var $5809=__stackBase__+33964;
      var $5810=__stackBase__+33968;
      var $5811=__stackBase__+33972;
      var $5812=__stackBase__+33976;
      var $5813=__stackBase__+34040;
      var $5814=__stackBase__+34044;
      var $5815=__stackBase__+34048;
      var $5816=__stackBase__+34052;
      var $5817=__stackBase__+34056;
      var $5818=__stackBase__+34060;
      var $5819=__stackBase__+34064;
      var $5820=__stackBase__+34068;
      var $5821=__stackBase__+34132;
      var $5822=__stackBase__+34136;
      var $5823=__stackBase__+34140;
      var $5824=__stackBase__+34144;
      var $5825=__stackBase__+34148;
      var $5826=__stackBase__+34152;
      var $5827=__stackBase__+34156;
      var $5828=__stackBase__+34160;
      var $5829=__stackBase__+34224;
      var $5830=__stackBase__+34228;
      var $5831=__stackBase__+34232;
      var $5832=__stackBase__+34236;
      var $5833=__stackBase__+34240;
      var $5834=__stackBase__+34244;
      var $5835=__stackBase__+34248;
      var $5836=__stackBase__+34252;
      var $5837=__stackBase__+34316;
      var $5838=__stackBase__+34320;
      var $5839=__stackBase__+34324;
      var $5840=__stackBase__+34328;
      var $5841=__stackBase__+34332;
      var $5842=__stackBase__+34336;
      var $5843=__stackBase__+34340;
      var $5844=__stackBase__+34344;
      var $5845=__stackBase__+34408;
      var $5846=__stackBase__+34412;
      var $5847=__stackBase__+34416;
      var $5848=__stackBase__+34420;
      var $5849=__stackBase__+34424;
      var $5850=__stackBase__+34428;
      var $5851=__stackBase__+34432;
      var $5852=__stackBase__+34436;
      var $5853=__stackBase__+34500;
      var $5854=__stackBase__+34504;
      var $5855=__stackBase__+34508;
      var $5856=__stackBase__+34512;
      var $5857=__stackBase__+34516;
      var $5858=__stackBase__+34520;
      var $5859=__stackBase__+34524;
      var $5860=__stackBase__+34528;
      var $5861=__stackBase__+34592;
      var $5862=__stackBase__+34596;
      var $5863=__stackBase__+34600;
      var $5864=__stackBase__+34604;
      var $5865=__stackBase__+34608;
      var $5866=__stackBase__+34612;
      var $5867=__stackBase__+34616;
      var $5868=__stackBase__+34620;
      var $5869=__stackBase__+34684;
      var $5870=__stackBase__+34688;
      var $5871=__stackBase__+34692;
      var $5872=__stackBase__+34696;
      var $5873=__stackBase__+34700;
      var $5874=__stackBase__+34704;
      var $5875=__stackBase__+34708;
      var $5876=__stackBase__+34712;
      var $5877=__stackBase__+34776;
      var $5878=__stackBase__+34780;
      var $5879=__stackBase__+34784;
      var $5880=__stackBase__+34788;
      var $5881=__stackBase__+34792;
      var $5882=__stackBase__+34796;
      var $5883=__stackBase__+34800;
      var $5884=__stackBase__+34804;
      var $5885=__stackBase__+34868;
      var $5886=__stackBase__+34872;
      var $5887=__stackBase__+34876;
      var $5888=__stackBase__+34880;
      var $5889=__stackBase__+34884;
      var $5890=__stackBase__+34888;
      var $5891=__stackBase__+34892;
      var $5892=__stackBase__+34896;
      var $5893=__stackBase__+34960;
      var $5894=__stackBase__+34964;
      var $5895=__stackBase__+34968;
      var $5896=__stackBase__+34972;
      var $5897=__stackBase__+34976;
      var $5898=__stackBase__+34980;
      var $5899=__stackBase__+34984;
      var $5900=__stackBase__+34988;
      var $5901=__stackBase__+35052;
      var $5902=__stackBase__+35056;
      var $5903=__stackBase__+35060;
      var $5904=__stackBase__+35064;
      var $5905=__stackBase__+35068;
      var $5906=__stackBase__+35072;
      var $5907=__stackBase__+35076;
      var $5908=__stackBase__+35080;
      var $5909=__stackBase__+35144;
      var $5910=__stackBase__+35148;
      var $5911=__stackBase__+35152;
      var $5912=__stackBase__+35156;
      var $5913=__stackBase__+35160;
      var $5914=__stackBase__+35164;
      var $5915=__stackBase__+35168;
      var $5916=__stackBase__+35172;
      var $5917=__stackBase__+35236;
      var $5918=__stackBase__+35240;
      var $5919=__stackBase__+35244;
      var $5920=__stackBase__+35248;
      var $5921=__stackBase__+35252;
      var $5922=__stackBase__+35256;
      var $5923=__stackBase__+35260;
      var $5924=__stackBase__+35264;
      var $5925=__stackBase__+35328;
      var $5926=__stackBase__+35332;
      var $5927=__stackBase__+35336;
      var $5928=__stackBase__+35340;
      var $5929=__stackBase__+35344;
      var $5930=__stackBase__+35348;
      var $5931=__stackBase__+35352;
      var $5932=__stackBase__+35356;
      var $5933=__stackBase__+35420;
      var $5934=__stackBase__+35424;
      var $5935=__stackBase__+35428;
      var $5936=__stackBase__+35432;
      var $5937=__stackBase__+35436;
      var $5938=__stackBase__+35440;
      var $5939=__stackBase__+35444;
      var $5940=__stackBase__+35448;
      var $5941=__stackBase__+35512;
      var $5942=__stackBase__+35516;
      var $5943=__stackBase__+35520;
      var $5944=__stackBase__+35524;
      var $5945=__stackBase__+35528;
      var $5946=__stackBase__+35532;
      var $5947=__stackBase__+35536;
      var $5948=__stackBase__+35540;
      var $5949=__stackBase__+35604;
      var $5950=__stackBase__+35608;
      var $5951=__stackBase__+35612;
      var $5952=__stackBase__+35616;
      var $5953=__stackBase__+35620;
      var $5954=__stackBase__+35624;
      var $5955=__stackBase__+35628;
      var $5956=__stackBase__+35632;
      var $5957=__stackBase__+35696;
      var $5958=__stackBase__+35700;
      var $5959=__stackBase__+35704;
      var $5960=__stackBase__+35708;
      var $5961=__stackBase__+35712;
      var $5962=__stackBase__+35716;
      var $5963=__stackBase__+35720;
      var $5964=__stackBase__+35724;
      var $5965=__stackBase__+35788;
      var $5966=__stackBase__+35792;
      var $5967=__stackBase__+35796;
      var $5968=__stackBase__+35800;
      var $5969=__stackBase__+35804;
      var $5970=__stackBase__+35808;
      var $5971=__stackBase__+35812;
      var $5972=__stackBase__+35816;
      var $5973=__stackBase__+35880;
      var $5974=__stackBase__+35884;
      var $5975=__stackBase__+35888;
      var $5976=__stackBase__+35892;
      var $5977=__stackBase__+35896;
      var $5978=__stackBase__+35900;
      var $5979=__stackBase__+35904;
      var $5980=__stackBase__+35908;
      var $5981=__stackBase__+35972;
      var $5982=__stackBase__+35976;
      var $5983=__stackBase__+35980;
      var $5984=__stackBase__+35984;
      var $5985=__stackBase__+35988;
      var $5986=__stackBase__+35992;
      var $5987=__stackBase__+35996;
      var $5988=__stackBase__+36000;
      var $5989=__stackBase__+36064;
      var $5990=__stackBase__+36068;
      var $5991=__stackBase__+36072;
      var $5992=__stackBase__+36076;
      var $5993=__stackBase__+36080;
      var $5994=__stackBase__+36084;
      var $5995=__stackBase__+36088;
      var $5996=__stackBase__+36092;
      var $5997=__stackBase__+36156;
      var $5998=__stackBase__+36160;
      var $5999=__stackBase__+36164;
      var $6000=__stackBase__+36168;
      var $6001=__stackBase__+36172;
      var $6002=__stackBase__+36176;
      var $6003=__stackBase__+36180;
      var $6004=__stackBase__+36184;
      var $6005=__stackBase__+36248;
      var $6006=__stackBase__+36252;
      var $6007=__stackBase__+36256;
      var $6008=__stackBase__+36260;
      var $6009=__stackBase__+36264;
      var $6010=__stackBase__+36268;
      var $6011=__stackBase__+36272;
      var $6012=__stackBase__+36276;
      var $6013=__stackBase__+36340;
      var $6014=__stackBase__+36344;
      var $6015=__stackBase__+36348;
      var $6016=__stackBase__+36352;
      var $6017=__stackBase__+36356;
      var $6018=__stackBase__+36360;
      var $6019=__stackBase__+36364;
      var $6020=__stackBase__+36368;
      var $6021=__stackBase__+36432;
      var $6022=__stackBase__+36436;
      var $6023=__stackBase__+36440;
      var $6024=__stackBase__+36444;
      var $6025=__stackBase__+36448;
      var $6026=__stackBase__+36452;
      var $6027=__stackBase__+36456;
      var $6028=__stackBase__+36460;
      var $6029=__stackBase__+36524;
      var $6030=__stackBase__+36528;
      var $6031=__stackBase__+36532;
      var $6032=__stackBase__+36536;
      var $6033=__stackBase__+36540;
      var $6034=__stackBase__+36544;
      var $6035=__stackBase__+36548;
      var $6036=__stackBase__+36552;
      var $6037=__stackBase__+36616;
      var $6038=__stackBase__+36620;
      var $6039=__stackBase__+36624;
      var $6040=__stackBase__+36628;
      var $6041=__stackBase__+36632;
      var $6042=__stackBase__+36636;
      var $6043=__stackBase__+36640;
      var $6044=__stackBase__+36644;
      var $6045=__stackBase__+36708;
      var $6046=__stackBase__+36712;
      var $6047=__stackBase__+36716;
      var $6048=__stackBase__+36720;
      var $6049=__stackBase__+36724;
      var $6050=__stackBase__+36728;
      var $6051=__stackBase__+36732;
      var $6052=__stackBase__+36736;
      var $6053=__stackBase__+36800;
      var $6054=__stackBase__+36804;
      var $6055=__stackBase__+36808;
      var $6056=__stackBase__+36812;
      var $6057=__stackBase__+36816;
      var $6058=__stackBase__+36820;
      var $6059=__stackBase__+36824;
      var $6060=__stackBase__+36828;
      var $6061=__stackBase__+36892;
      var $6062=__stackBase__+36896;
      var $6063=__stackBase__+36900;
      var $6064=__stackBase__+36904;
      var $6065=__stackBase__+36908;
      var $6066=__stackBase__+36912;
      var $6067=__stackBase__+36916;
      var $6068=__stackBase__+36920;
      var $6069=__stackBase__+36984;
      var $6070=__stackBase__+36988;
      var $6071=__stackBase__+36992;
      var $6072=__stackBase__+36996;
      var $6073=__stackBase__+37000;
      var $6074=__stackBase__+37004;
      var $6075=__stackBase__+37008;
      var $6076=__stackBase__+37012;
      var $6077=__stackBase__+37076;
      var $6078=__stackBase__+37080;
      var $6079=__stackBase__+37084;
      var $6080=__stackBase__+37088;
      var $6081=__stackBase__+37092;
      var $6082=__stackBase__+37096;
      var $6083=__stackBase__+37100;
      var $6084=__stackBase__+37104;
      var $6085=__stackBase__+37168;
      var $6086=__stackBase__+37172;
      var $6087=__stackBase__+37176;
      var $6088=__stackBase__+37180;
      var $6089=__stackBase__+37184;
      var $6090=__stackBase__+37188;
      var $6091=__stackBase__+37192;
      var $6092=__stackBase__+37196;
      var $6093=__stackBase__+37260;
      var $6094=__stackBase__+37264;
      var $6095=__stackBase__+37268;
      var $6096=__stackBase__+37272;
      var $6097=__stackBase__+37276;
      var $6098=__stackBase__+37280;
      var $6099=__stackBase__+37284;
      var $6100=__stackBase__+37288;
      var $6101=__stackBase__+37352;
      var $6102=__stackBase__+37356;
      var $6103=__stackBase__+37360;
      var $6104=__stackBase__+37364;
      var $6105=__stackBase__+37368;
      var $6106=__stackBase__+37372;
      var $6107=__stackBase__+37376;
      var $6108=__stackBase__+37380;
      var $6109=__stackBase__+37444;
      var $6110=__stackBase__+37448;
      var $6111=__stackBase__+37452;
      var $6112=__stackBase__+37456;
      var $6113=__stackBase__+37460;
      var $6114=__stackBase__+37464;
      var $6115=__stackBase__+37468;
      var $6116=__stackBase__+37472;
      var $6117=__stackBase__+37536;
      var $6118=__stackBase__+37540;
      var $6119=__stackBase__+37544;
      var $6120=__stackBase__+37548;
      var $6121=__stackBase__+37552;
      var $6122=__stackBase__+37556;
      var $6123=__stackBase__+37560;
      var $6124=__stackBase__+37564;
      var $6125=__stackBase__+37628;
      var $6126=__stackBase__+37632;
      var $6127=__stackBase__+37636;
      var $6128=__stackBase__+37640;
      var $6129=__stackBase__+37644;
      var $6130=__stackBase__+37648;
      var $6131=__stackBase__+37652;
      var $6132=__stackBase__+37656;
      var $6133=__stackBase__+37720;
      var $6134=__stackBase__+37724;
      var $6135=__stackBase__+37728;
      var $6136=__stackBase__+37732;
      var $6137=__stackBase__+37736;
      var $6138=__stackBase__+37740;
      var $6139=__stackBase__+37744;
      var $6140=__stackBase__+37748;
      var $6141=__stackBase__+37812;
      var $6142=__stackBase__+37816;
      var $6143=__stackBase__+37820;
      var $6144=__stackBase__+37824;
      var $6145=__stackBase__+37828;
      var $6146=__stackBase__+37832;
      var $6147=__stackBase__+37836;
      var $6148=__stackBase__+37840;
      var $6149=__stackBase__+37904;
      var $6150=__stackBase__+37908;
      var $6151=__stackBase__+37912;
      var $6152=__stackBase__+37916;
      var $6153=__stackBase__+37920;
      var $6154=__stackBase__+37924;
      var $6155=__stackBase__+37928;
      var $6156=__stackBase__+37932;
      var $6157=__stackBase__+37996;
      var $6158=__stackBase__+38000;
      var $6159=__stackBase__+38004;
      var $6160=__stackBase__+38008;
      var $6161=__stackBase__+38012;
      var $6162=__stackBase__+38016;
      var $6163=__stackBase__+38020;
      var $6164=__stackBase__+38024;
      var $6165=__stackBase__+38088;
      var $6166=__stackBase__+38092;
      var $6167=__stackBase__+38096;
      var $6168=__stackBase__+38100;
      var $6169=__stackBase__+38104;
      var $6170=__stackBase__+38108;
      var $6171=__stackBase__+38112;
      var $6172=__stackBase__+38116;
      var $6173=__stackBase__+38180;
      var $6174=__stackBase__+38184;
      var $6175=__stackBase__+38188;
      var $6176=__stackBase__+38192;
      var $6177=__stackBase__+38196;
      var $6178=__stackBase__+38200;
      var $6179=__stackBase__+38204;
      var $6180=__stackBase__+38208;
      var $6181=__stackBase__+38272;
      var $6182=__stackBase__+38276;
      var $6183=__stackBase__+38280;
      var $6184=__stackBase__+38284;
      var $6185=__stackBase__+38288;
      var $6186=__stackBase__+38292;
      var $6187=__stackBase__+38296;
      var $6188=__stackBase__+38300;
      var $6189=__stackBase__+38364;
      var $6190=__stackBase__+38368;
      var $6191=__stackBase__+38372;
      var $6192=__stackBase__+38376;
      var $6193=__stackBase__+38380;
      var $6194=__stackBase__+38384;
      var $6195=__stackBase__+38388;
      var $6196=__stackBase__+38392;
      var $6197=__stackBase__+38456;
      var $6198=__stackBase__+38460;
      var $6199=__stackBase__+38464;
      var $6200=__stackBase__+38468;
      var $6201=__stackBase__+38472;
      var $6202=__stackBase__+38476;
      var $6203=__stackBase__+38480;
      var $6204=__stackBase__+38484;
      var $6205=__stackBase__+38548;
      var $6206=__stackBase__+38552;
      var $6207=__stackBase__+38556;
      var $6208=__stackBase__+38560;
      var $6209=__stackBase__+38564;
      var $6210=__stackBase__+38568;
      var $6211=__stackBase__+38572;
      var $6212=__stackBase__+38576;
      var $6213=__stackBase__+38640;
      var $6214=__stackBase__+38644;
      var $6215=__stackBase__+38648;
      var $6216=__stackBase__+38652;
      var $6217=__stackBase__+38656;
      var $6218=__stackBase__+38660;
      var $6219=__stackBase__+38664;
      var $6220=__stackBase__+38668;
      var $6221=__stackBase__+38732;
      var $6222=__stackBase__+38736;
      var $6223=__stackBase__+38740;
      var $6224=__stackBase__+38744;
      var $6225=__stackBase__+38748;
      var $6226=__stackBase__+38752;
      var $6227=__stackBase__+38756;
      var $6228=__stackBase__+38760;
      var $6229=__stackBase__+38824;
      var $6230=__stackBase__+38828;
      var $6231=__stackBase__+38832;
      var $6232=__stackBase__+38836;
      var $6233=__stackBase__+38840;
      var $6234=__stackBase__+38844;
      var $6235=__stackBase__+38848;
      var $6236=__stackBase__+38852;
      var $6237=__stackBase__+38916;
      var $6238=__stackBase__+38920;
      var $6239=__stackBase__+38924;
      var $6240=__stackBase__+38928;
      var $6241=__stackBase__+38932;
      var $6242=__stackBase__+38936;
      var $6243=__stackBase__+38940;
      var $6244=__stackBase__+38944;
      var $6245=__stackBase__+39008;
      var $6246=__stackBase__+39012;
      var $6247=__stackBase__+39016;
      var $6248=__stackBase__+39020;
      var $6249=__stackBase__+39024;
      var $6250=__stackBase__+39028;
      var $6251=__stackBase__+39032;
      var $6252=__stackBase__+39036;
      var $6253=__stackBase__+39100;
      var $6254=__stackBase__+39104;
      var $6255=__stackBase__+39108;
      var $6256=__stackBase__+39112;
      var $6257=__stackBase__+39116;
      var $6258=__stackBase__+39120;
      var $6259=__stackBase__+39124;
      var $6260=__stackBase__+39128;
      var $6261=__stackBase__+39192;
      var $6262=__stackBase__+39196;
      var $6263=__stackBase__+39200;
      var $6264=__stackBase__+39204;
      var $6265=__stackBase__+39208;
      var $6266=__stackBase__+39212;
      var $6267=__stackBase__+39216;
      var $6268=__stackBase__+39220;
      var $6269=__stackBase__+39284;
      var $6270=__stackBase__+39288;
      var $6271=__stackBase__+39292;
      var $6272=__stackBase__+39296;
      var $6273=__stackBase__+39300;
      var $6274=__stackBase__+39304;
      var $6275=__stackBase__+39308;
      var $6276=__stackBase__+39312;
      var $6277=__stackBase__+39376;
      var $6278=__stackBase__+39380;
      var $6279=__stackBase__+39384;
      var $6280=__stackBase__+39388;
      var $6281=__stackBase__+39392;
      var $6282=__stackBase__+39396;
      var $6283=__stackBase__+39400;
      var $6284=__stackBase__+39404;
      var $6285=__stackBase__+39468;
      var $6286=__stackBase__+39472;
      var $6287=__stackBase__+39476;
      var $6288=__stackBase__+39480;
      var $6289=__stackBase__+39484;
      var $6290=__stackBase__+39488;
      var $6291=__stackBase__+39492;
      var $6292=__stackBase__+39496;
      var $6293=__stackBase__+39560;
      var $6294=__stackBase__+39564;
      var $6295=__stackBase__+39568;
      var $6296=__stackBase__+39572;
      var $6297=__stackBase__+39576;
      var $6298=__stackBase__+39580;
      var $6299=__stackBase__+39584;
      var $6300=__stackBase__+39588;
      var $6301=__stackBase__+39652;
      var $6302=__stackBase__+39656;
      var $6303=__stackBase__+39660;
      var $6304=__stackBase__+39664;
      var $6305=__stackBase__+39668;
      var $6306=__stackBase__+39672;
      var $6307=__stackBase__+39676;
      var $6308=__stackBase__+39680;
      var $6309=__stackBase__+39744;
      var $6310=__stackBase__+39748;
      var $6311=__stackBase__+39752;
      var $6312=__stackBase__+39756;
      var $6313=__stackBase__+39760;
      var $6314=__stackBase__+39764;
      var $6315=__stackBase__+39768;
      var $6316=__stackBase__+39772;
      var $6317=__stackBase__+39836;
      var $6318=__stackBase__+39840;
      var $6319=__stackBase__+39844;
      var $6320=__stackBase__+39848;
      var $6321=__stackBase__+39852;
      var $6322=__stackBase__+39856;
      var $6323=__stackBase__+39860;
      var $6324=__stackBase__+39864;
      var $6325=__stackBase__+39928;
      var $6326=__stackBase__+39932;
      var $6327=__stackBase__+39936;
      var $6328=__stackBase__+39940;
      var $6329=__stackBase__+39944;
      var $6330=__stackBase__+39948;
      var $6331=__stackBase__+39952;
      var $6332=__stackBase__+39956;
      var $6333=__stackBase__+40020;
      var $6334=__stackBase__+40024;
      var $6335=__stackBase__+40028;
      var $6336=__stackBase__+40032;
      var $6337=__stackBase__+40036;
      var $6338=__stackBase__+40040;
      var $6339=__stackBase__+40044;
      var $6340=__stackBase__+40048;
      var $6341=__stackBase__+40112;
      var $6342=__stackBase__+40116;
      var $6343=__stackBase__+40120;
      var $6344=__stackBase__+40124;
      var $6345=__stackBase__+40128;
      var $6346=__stackBase__+40132;
      var $6347=__stackBase__+40136;
      var $6348=__stackBase__+40140;
      var $6349=__stackBase__+40204;
      var $6350=__stackBase__+40208;
      var $6351=__stackBase__+40212;
      var $6352=__stackBase__+40216;
      var $6353=__stackBase__+40220;
      var $6354=__stackBase__+40224;
      var $6355=__stackBase__+40228;
      var $6356=__stackBase__+40232;
      var $6357=__stackBase__+40296;
      var $6358=__stackBase__+40300;
      var $6359=__stackBase__+40304;
      var $6360=__stackBase__+40308;
      var $6361=__stackBase__+40312;
      var $6362=__stackBase__+40316;
      var $6363=__stackBase__+40320;
      var $6364=__stackBase__+40324;
      var $6365=__stackBase__+40388;
      var $6366=__stackBase__+40392;
      var $6367=__stackBase__+40396;
      var $6368=__stackBase__+40400;
      var $6369=__stackBase__+40404;
      var $6370=__stackBase__+40408;
      var $6371=__stackBase__+40412;
      var $6372=__stackBase__+40416;
      var $6373=__stackBase__+40480;
      var $6374=__stackBase__+40484;
      var $6375=__stackBase__+40488;
      var $6376=__stackBase__+40492;
      var $6377=__stackBase__+40496;
      var $6378=__stackBase__+40500;
      var $6379=__stackBase__+40504;
      var $6380=__stackBase__+40508;
      var $6381=__stackBase__+40572;
      var $6382=__stackBase__+40576;
      var $6383=__stackBase__+40580;
      var $6384=__stackBase__+40584;
      var $6385=__stackBase__+40588;
      var $6386=__stackBase__+40592;
      var $6387=__stackBase__+40596;
      var $6388=__stackBase__+40600;
      var $6389=__stackBase__+40664;
      var $6390=__stackBase__+40668;
      var $6391=__stackBase__+40672;
      var $6392=__stackBase__+40676;
      var $6393=__stackBase__+40680;
      var $6394=__stackBase__+40684;
      var $6395=__stackBase__+40688;
      var $6396=__stackBase__+40692;
      var $6397=__stackBase__+40756;
      var $6398=__stackBase__+40760;
      var $6399=__stackBase__+40764;
      var $6400=__stackBase__+40768;
      var $6401=__stackBase__+40772;
      var $6402=__stackBase__+40776;
      var $6403=__stackBase__+40780;
      var $6404=__stackBase__+40784;
      var $6405=__stackBase__+40848;
      var $6406=__stackBase__+40852;
      var $6407=__stackBase__+40856;
      var $6408=__stackBase__+40860;
      var $6409=__stackBase__+40864;
      var $6410=__stackBase__+40868;
      var $6411=__stackBase__+40872;
      var $6412=__stackBase__+40876;
      var $6413=__stackBase__+40940;
      var $6414=__stackBase__+40944;
      var $6415=__stackBase__+40948;
      var $6416=__stackBase__+40952;
      var $6417=__stackBase__+40956;
      var $6418=__stackBase__+40960;
      var $6419=__stackBase__+40964;
      var $6420=__stackBase__+40968;
      var $6421=__stackBase__+41032;
      var $6422=__stackBase__+41036;
      var $6423=__stackBase__+41040;
      var $6424=__stackBase__+41044;
      var $6425=__stackBase__+41048;
      var $6426=__stackBase__+41052;
      var $6427=__stackBase__+41056;
      var $6428=__stackBase__+41060;
      var $6429=__stackBase__+41124;
      var $6430=__stackBase__+41128;
      var $6431=__stackBase__+41132;
      var $6432=__stackBase__+41136;
      var $6433=__stackBase__+41140;
      var $6434=__stackBase__+41144;
      var $6435=__stackBase__+41148;
      var $6436=__stackBase__+41152;
      var $6437=__stackBase__+41216;
      var $6438=__stackBase__+41220;
      var $6439=__stackBase__+41224;
      var $6440=__stackBase__+41228;
      var $6441=__stackBase__+41232;
      var $6442=__stackBase__+41236;
      var $6443=__stackBase__+41240;
      var $6444=__stackBase__+41244;
      var $6445=__stackBase__+41308;
      var $6446=__stackBase__+41312;
      var $6447=__stackBase__+41316;
      var $6448=__stackBase__+41320;
      var $6449=__stackBase__+41324;
      var $6450=__stackBase__+41328;
      var $6451=__stackBase__+41332;
      var $6452=__stackBase__+41336;
      var $6453=__stackBase__+41400;
      var $6454=__stackBase__+41404;
      var $6455=__stackBase__+41408;
      var $6456=__stackBase__+41412;
      var $6457=__stackBase__+41416;
      var $6458=__stackBase__+41420;
      var $6459=__stackBase__+41424;
      var $6460=__stackBase__+41428;
      var $6461=__stackBase__+41492;
      var $6462=__stackBase__+41496;
      var $6463=__stackBase__+41500;
      var $6464=__stackBase__+41504;
      var $6465=__stackBase__+41508;
      var $6466=__stackBase__+41512;
      var $6467=__stackBase__+41516;
      var $6468=__stackBase__+41520;
      var $6469=__stackBase__+41584;
      var $6470=__stackBase__+41588;
      var $6471=__stackBase__+41592;
      var $6472=__stackBase__+41596;
      var $6473=__stackBase__+41600;
      var $6474=__stackBase__+41604;
      var $6475=__stackBase__+41608;
      var $6476=__stackBase__+41612;
      var $6477=__stackBase__+41676;
      var $6478=__stackBase__+41680;
      var $6479=__stackBase__+41684;
      var $6480=__stackBase__+41688;
      var $6481=__stackBase__+41692;
      var $6482=__stackBase__+41696;
      var $6483=__stackBase__+41700;
      var $6484=__stackBase__+41704;
      var $6485=__stackBase__+41768;
      var $6486=__stackBase__+41772;
      var $6487=__stackBase__+41776;
      var $6488=__stackBase__+41780;
      var $6489=__stackBase__+41784;
      var $6490=__stackBase__+41788;
      var $6491=__stackBase__+41792;
      var $6492=__stackBase__+41796;
      var $6493=__stackBase__+41860;
      var $6494=__stackBase__+41864;
      var $6495=__stackBase__+41868;
      var $6496=__stackBase__+41872;
      var $6497=__stackBase__+41876;
      var $6498=__stackBase__+41880;
      var $6499=__stackBase__+41884;
      var $6500=__stackBase__+41888;
      var $6501=__stackBase__+41952;
      var $6502=__stackBase__+41956;
      var $6503=__stackBase__+41960;
      var $6504=__stackBase__+41964;
      var $6505=__stackBase__+41968;
      var $6506=__stackBase__+41972;
      var $6507=__stackBase__+41976;
      var $6508=__stackBase__+41980;
      var $6509=__stackBase__+42044;
      var $6510=__stackBase__+42048;
      var $6511=__stackBase__+42052;
      var $6512=__stackBase__+42056;
      var $6513=__stackBase__+42060;
      var $6514=__stackBase__+42064;
      var $6515=__stackBase__+42068;
      var $6516=__stackBase__+42072;
      var $6517=__stackBase__+42136;
      var $6518=__stackBase__+42140;
      var $6519=__stackBase__+42144;
      var $6520=__stackBase__+42148;
      var $6521=__stackBase__+42152;
      var $6522=__stackBase__+42156;
      var $6523=__stackBase__+42160;
      var $6524=__stackBase__+42164;
      var $6525=__stackBase__+42228;
      var $6526=__stackBase__+42232;
      var $6527=__stackBase__+42236;
      var $6528=__stackBase__+42240;
      var $6529=__stackBase__+42244;
      var $6530=__stackBase__+42248;
      var $6531=__stackBase__+42252;
      var $6532=__stackBase__+42256;
      var $6533=__stackBase__+42320;
      var $6534=__stackBase__+42324;
      var $6535=__stackBase__+42328;
      var $6536=__stackBase__+42332;
      var $6537=__stackBase__+42336;
      var $6538=__stackBase__+42340;
      var $6539=__stackBase__+42344;
      var $6540=__stackBase__+42348;
      var $6541=__stackBase__+42412;
      var $6542=__stackBase__+42416;
      var $6543=__stackBase__+42420;
      var $6544=__stackBase__+42424;
      var $6545=__stackBase__+42428;
      var $6546=__stackBase__+42432;
      var $6547=__stackBase__+42436;
      var $6548=__stackBase__+42440;
      var $6549=__stackBase__+42504;
      var $6550=__stackBase__+42508;
      var $6551=__stackBase__+42512;
      var $6552=__stackBase__+42516;
      var $6553=__stackBase__+42520;
      var $6554=__stackBase__+42524;
      var $6555=__stackBase__+42528;
      var $6556=__stackBase__+42532;
      var $6557=__stackBase__+42596;
      var $6558=__stackBase__+42600;
      var $6559=__stackBase__+42604;
      var $6560=__stackBase__+42608;
      var $6561=__stackBase__+42612;
      var $6562=__stackBase__+42616;
      var $6563=__stackBase__+42620;
      var $6564=__stackBase__+42624;
      var $6565=__stackBase__+42688;
      var $6566=__stackBase__+42692;
      var $6567=__stackBase__+42696;
      var $6568=__stackBase__+42700;
      var $6569=__stackBase__+42704;
      var $6570=__stackBase__+42708;
      var $6571=__stackBase__+42712;
      var $6572=__stackBase__+42716;
      var $6573=__stackBase__+42780;
      var $6574=__stackBase__+42784;
      var $6575=__stackBase__+42788;
      var $6576=__stackBase__+42792;
      var $6577=__stackBase__+42796;
      var $6578=__stackBase__+42800;
      var $6579=__stackBase__+42804;
      var $6580=__stackBase__+42808;
      var $6581=__stackBase__+42872;
      var $6582=__stackBase__+42876;
      var $6583=__stackBase__+42880;
      var $6584=__stackBase__+42884;
      var $6585=__stackBase__+42888;
      var $6586=__stackBase__+42892;
      var $6587=__stackBase__+42896;
      var $6588=__stackBase__+42900;
      var $6589=__stackBase__+42964;
      var $6590=__stackBase__+42968;
      var $6591=__stackBase__+42972;
      var $6592=__stackBase__+42976;
      var $6593=__stackBase__+42980;
      var $6594=__stackBase__+42984;
      var $6595=__stackBase__+42988;
      var $6596=__stackBase__+42992;
      var $6597=__stackBase__+43056;
      var $6598=__stackBase__+43060;
      var $6599=__stackBase__+43064;
      var $6600=__stackBase__+43068;
      var $6601=__stackBase__+43072;
      var $6602=__stackBase__+43076;
      var $6603=__stackBase__+43080;
      var $6604=__stackBase__+43084;
      var $6605=__stackBase__+43148;
      var $6606=__stackBase__+43152;
      var $6607=__stackBase__+43156;
      var $6608=__stackBase__+43160;
      var $6609=__stackBase__+43164;
      var $6610=__stackBase__+43168;
      var $6611=__stackBase__+43172;
      var $6612=__stackBase__+43176;
      var $6613=__stackBase__+43240;
      var $6614=__stackBase__+43244;
      var $6615=__stackBase__+43248;
      var $6616=__stackBase__+43252;
      var $6617=__stackBase__+43256;
      var $6618=__stackBase__+43260;
      var $6619=__stackBase__+43264;
      var $6620=__stackBase__+43268;
      var $6621=__stackBase__+43332;
      var $6622=__stackBase__+43336;
      var $6623=__stackBase__+43340;
      var $6624=__stackBase__+43344;
      var $6625=__stackBase__+43348;
      var $6626=__stackBase__+43352;
      var $6627=__stackBase__+43356;
      var $6628=__stackBase__+43360;
      var $6629=__stackBase__+43424;
      var $6630=__stackBase__+43428;
      var $6631=__stackBase__+43432;
      var $6632=__stackBase__+43436;
      var $6633=__stackBase__+43440;
      var $6634=__stackBase__+43444;
      var $6635=__stackBase__+43448;
      var $6636=__stackBase__+43452;
      var $6637=__stackBase__+43516;
      var $6638=__stackBase__+43520;
      var $6639=__stackBase__+43524;
      var $6640=__stackBase__+43528;
      var $6641=__stackBase__+43532;
      var $6642=__stackBase__+43536;
      var $6643=__stackBase__+43540;
      var $6644=__stackBase__+43544;
      var $6645=__stackBase__+43608;
      var $6646=__stackBase__+43612;
      var $6647=__stackBase__+43616;
      var $6648=__stackBase__+43620;
      var $6649=__stackBase__+43624;
      var $6650=__stackBase__+43628;
      var $6651=__stackBase__+43632;
      var $6652=__stackBase__+43636;
      var $6653=__stackBase__+43700;
      var $6654=__stackBase__+43704;
      var $6655=__stackBase__+43708;
      var $6656=__stackBase__+43712;
      var $6657=__stackBase__+43716;
      var $6658=__stackBase__+43720;
      var $6659=__stackBase__+43724;
      var $6660=__stackBase__+43728;
      var $6661=__stackBase__+43792;
      var $6662=__stackBase__+43796;
      var $6663=__stackBase__+43800;
      var $6664=__stackBase__+43804;
      var $6665=__stackBase__+43808;
      var $6666=__stackBase__+43812;
      var $6667=__stackBase__+43816;
      var $6668=__stackBase__+43820;
      var $6669=__stackBase__+43884;
      var $6670=__stackBase__+43888;
      var $6671=__stackBase__+43892;
      var $6672=__stackBase__+43896;
      var $6673=__stackBase__+43900;
      var $6674=__stackBase__+43904;
      var $6675=__stackBase__+43908;
      var $6676=__stackBase__+43912;
      var $6677=__stackBase__+43976;
      var $6678=__stackBase__+43980;
      var $6679=__stackBase__+43984;
      var $6680=__stackBase__+43988;
      var $6681=__stackBase__+43992;
      var $6682=__stackBase__+43996;
      var $6683=__stackBase__+44000;
      var $6684=__stackBase__+44004;
      var $6685=__stackBase__+44068;
      var $6686=__stackBase__+44072;
      var $6687=__stackBase__+44076;
      var $6688=__stackBase__+44080;
      var $6689=__stackBase__+44084;
      var $6690=__stackBase__+44088;
      var $6691=__stackBase__+44092;
      var $6692=__stackBase__+44096;
      var $6693=__stackBase__+44160;
      var $6694=__stackBase__+44164;
      var $6695=__stackBase__+44168;
      var $6696=__stackBase__+44172;
      var $6697=__stackBase__+44176;
      var $6698=__stackBase__+44180;
      var $6699=__stackBase__+44184;
      var $6700=__stackBase__+44188;
      var $6701=__stackBase__+44252;
      var $6702=__stackBase__+44256;
      var $6703=__stackBase__+44260;
      var $6704=__stackBase__+44264;
      var $6705=__stackBase__+44268;
      var $6706=__stackBase__+44272;
      var $6707=__stackBase__+44276;
      var $6708=__stackBase__+44280;
      var $6709=__stackBase__+44344;
      var $6710=__stackBase__+44348;
      var $6711=__stackBase__+44352;
      var $6712=__stackBase__+44356;
      var $6713=__stackBase__+44360;
      var $6714=__stackBase__+44364;
      var $6715=__stackBase__+44368;
      var $6716=__stackBase__+44372;
      var $6717=__stackBase__+44436;
      var $6718=__stackBase__+44440;
      var $6719=__stackBase__+44444;
      var $6720=__stackBase__+44448;
      var $6721=__stackBase__+44452;
      var $6722=__stackBase__+44456;
      var $6723=__stackBase__+44460;
      var $6724=__stackBase__+44464;
      var $6725=__stackBase__+44528;
      var $6726=__stackBase__+44532;
      var $6727=__stackBase__+44536;
      var $6728=__stackBase__+44540;
      var $6729=__stackBase__+44544;
      var $6730=__stackBase__+44548;
      var $6731=__stackBase__+44552;
      var $6732=__stackBase__+44556;
      var $6733=__stackBase__+44620;
      var $6734=__stackBase__+44624;
      var $6735=__stackBase__+44628;
      var $6736=__stackBase__+44632;
      var $6737=__stackBase__+44636;
      var $6738=__stackBase__+44640;
      var $6739=__stackBase__+44644;
      var $6740=__stackBase__+44648;
      var $6741=__stackBase__+44712;
      var $6742=__stackBase__+44716;
      var $6743=__stackBase__+44720;
      var $6744=__stackBase__+44724;
      var $6745=__stackBase__+44728;
      var $6746=__stackBase__+44732;
      var $6747=__stackBase__+44736;
      var $6748=__stackBase__+44740;
      var $6749=__stackBase__+44804;
      var $6750=__stackBase__+44808;
      var $6751=__stackBase__+44812;
      var $6752=__stackBase__+44816;
      var $6753=__stackBase__+44820;
      var $6754=__stackBase__+44824;
      var $6755=__stackBase__+44828;
      var $6756=__stackBase__+44832;
      var $6757=__stackBase__+44896;
      var $6758=__stackBase__+44900;
      var $6759=__stackBase__+44904;
      var $6760=__stackBase__+44908;
      var $6761=__stackBase__+44912;
      var $6762=__stackBase__+44916;
      var $6763=__stackBase__+44920;
      var $6764=__stackBase__+44924;
      var $6765=__stackBase__+44988;
      var $6766=__stackBase__+44992;
      var $6767=__stackBase__+44996;
      var $6768=__stackBase__+45000;
      var $6769=__stackBase__+45004;
      var $6770=__stackBase__+45008;
      var $6771=__stackBase__+45012;
      var $6772=__stackBase__+45016;
      var $6773=__stackBase__+45080;
      var $6774=__stackBase__+45084;
      var $6775=__stackBase__+45088;
      var $6776=__stackBase__+45092;
      var $6777=__stackBase__+45096;
      var $6778=__stackBase__+45100;
      var $6779=__stackBase__+45104;
      var $6780=__stackBase__+45108;
      var $6781=__stackBase__+45172;
      var $6782=__stackBase__+45176;
      var $6783=__stackBase__+45180;
      var $6784=__stackBase__+45184;
      var $6785=__stackBase__+45188;
      var $6786=__stackBase__+45192;
      var $6787=__stackBase__+45196;
      var $6788=__stackBase__+45200;
      var $6789=__stackBase__+45264;
      var $6790=__stackBase__+45268;
      var $6791=__stackBase__+45272;
      var $6792=__stackBase__+45276;
      var $6793=__stackBase__+45280;
      var $6794=__stackBase__+45284;
      var $6795=__stackBase__+45288;
      var $6796=__stackBase__+45292;
      var $6797=__stackBase__+45356;
      var $6798=__stackBase__+45360;
      var $6799=__stackBase__+45364;
      var $6800=__stackBase__+45368;
      var $6801=__stackBase__+45372;
      var $6802=__stackBase__+45376;
      var $6803=__stackBase__+45380;
      var $6804=__stackBase__+45384;
      var $6805=__stackBase__+45448;
      var $6806=__stackBase__+45452;
      var $6807=__stackBase__+45456;
      var $6808=__stackBase__+45460;
      var $6809=__stackBase__+45464;
      var $6810=__stackBase__+45468;
      var $6811=__stackBase__+45472;
      var $6812=__stackBase__+45476;
      var $6813=__stackBase__+45540;
      var $6814=__stackBase__+45544;
      var $6815=__stackBase__+45548;
      var $6816=__stackBase__+45552;
      var $6817=__stackBase__+45556;
      var $6818=__stackBase__+45560;
      var $6819=__stackBase__+45564;
      var $6820=__stackBase__+45568;
      var $6821=__stackBase__+45632;
      var $6822=__stackBase__+45636;
      var $6823=__stackBase__+45640;
      var $6824=__stackBase__+45644;
      var $6825=__stackBase__+45648;
      var $6826=__stackBase__+45652;
      var $6827=__stackBase__+45656;
      var $6828=__stackBase__+45660;
      var $6829=__stackBase__+45724;
      var $6830=__stackBase__+45728;
      var $6831=__stackBase__+45732;
      var $6832=__stackBase__+45736;
      var $6833=__stackBase__+45740;
      var $6834=__stackBase__+45744;
      var $6835=__stackBase__+45748;
      var $6836=__stackBase__+45752;
      var $6837=__stackBase__+45816;
      var $6838=__stackBase__+45820;
      var $6839=__stackBase__+45824;
      var $6840=__stackBase__+45828;
      var $6841=__stackBase__+45832;
      var $6842=__stackBase__+45836;
      var $6843=__stackBase__+45840;
      var $6844=__stackBase__+45844;
      var $6845=__stackBase__+45908;
      var $6846=__stackBase__+45912;
      var $6847=__stackBase__+45916;
      var $6848=__stackBase__+45920;
      var $6849=__stackBase__+45924;
      var $6850=__stackBase__+45928;
      var $6851=__stackBase__+45932;
      var $6852=__stackBase__+45936;
      var $6853=__stackBase__+46000;
      var $6854=__stackBase__+46004;
      var $6855=__stackBase__+46008;
      var $6856=__stackBase__+46012;
      var $6857=__stackBase__+46016;
      var $6858=__stackBase__+46020;
      var $6859=__stackBase__+46024;
      var $6860=__stackBase__+46028;
      var $6861=__stackBase__+46092;
      var $6862=__stackBase__+46096;
      var $6863=__stackBase__+46100;
      var $6864=__stackBase__+46104;
      var $6865=__stackBase__+46108;
      var $6866=__stackBase__+46112;
      var $6867=__stackBase__+46116;
      var $6868=__stackBase__+46120;
      var $6869=__stackBase__+46184;
      var $6870=__stackBase__+46188;
      var $6871=__stackBase__+46192;
      var $6872=__stackBase__+46196;
      var $6873=__stackBase__+46200;
      var $6874=__stackBase__+46204;
      var $6875=__stackBase__+46208;
      var $6876=__stackBase__+46212;
      var $6877=__stackBase__+46276;
      var $6878=__stackBase__+46280;
      var $6879=__stackBase__+46284;
      var $6880=__stackBase__+46288;
      var $6881=__stackBase__+46292;
      var $6882=__stackBase__+46296;
      var $6883=__stackBase__+46300;
      var $6884=__stackBase__+46304;
      var $6885=__stackBase__+46368;
      var $6886=__stackBase__+46372;
      var $6887=__stackBase__+46376;
      var $6888=__stackBase__+46380;
      var $6889=__stackBase__+46384;
      var $6890=__stackBase__+46388;
      var $6891=__stackBase__+46392;
      var $6892=__stackBase__+46396;
      var $6893=__stackBase__+46460;
      var $6894=__stackBase__+46464;
      var $6895=__stackBase__+46468;
      var $6896=__stackBase__+46472;
      var $6897=__stackBase__+46476;
      var $6898=__stackBase__+46480;
      var $6899=__stackBase__+46484;
      var $6900=__stackBase__+46488;
      var $6901=__stackBase__+46552;
      var $6902=__stackBase__+46556;
      var $6903=__stackBase__+46560;
      var $6904=__stackBase__+46564;
      var $6905=__stackBase__+46568;
      var $6906=__stackBase__+46572;
      var $6907=__stackBase__+46576;
      var $6908=__stackBase__+46580;
      var $6909=__stackBase__+46644;
      var $6910=__stackBase__+46648;
      var $6911=__stackBase__+46652;
      var $6912=__stackBase__+46656;
      var $6913=__stackBase__+46660;
      var $6914=__stackBase__+46664;
      var $6915=__stackBase__+46668;
      var $6916=__stackBase__+46672;
      var $6917=__stackBase__+46736;
      var $6918=__stackBase__+46740;
      var $6919=__stackBase__+46744;
      var $6920=__stackBase__+46748;
      var $6921=__stackBase__+46752;
      var $6922=__stackBase__+46756;
      var $6923=__stackBase__+46760;
      var $6924=__stackBase__+46764;
      var $6925=__stackBase__+46828;
      var $6926=__stackBase__+46832;
      var $6927=__stackBase__+46836;
      var $6928=__stackBase__+46840;
      var $6929=__stackBase__+46844;
      var $6930=__stackBase__+46848;
      var $6931=__stackBase__+46852;
      var $6932=__stackBase__+46856;
      var $6933=__stackBase__+46920;
      var $6934=__stackBase__+46924;
      var $6935=__stackBase__+46928;
      var $6936=__stackBase__+46932;
      var $6937=__stackBase__+46936;
      var $6938=__stackBase__+46940;
      var $6939=__stackBase__+46944;
      var $6940=__stackBase__+46948;
      var $6941=__stackBase__+47012;
      var $6942=__stackBase__+47016;
      var $6943=__stackBase__+47020;
      var $6944=__stackBase__+47024;
      var $6945=__stackBase__+47028;
      var $6946=__stackBase__+47032;
      var $6947=__stackBase__+47036;
      var $6948=__stackBase__+47040;
      var $6949=__stackBase__+47104;
      var $6950=__stackBase__+47108;
      var $6951=__stackBase__+47112;
      var $6952=__stackBase__+47116;
      var $6953=__stackBase__+47120;
      var $6954=__stackBase__+47124;
      var $6955=__stackBase__+47128;
      var $6956=__stackBase__+47132;
      var $6957=__stackBase__+47196;
      var $6958=__stackBase__+47200;
      var $6959=__stackBase__+47204;
      var $6960=__stackBase__+47208;
      var $6961=__stackBase__+47212;
      var $6962=__stackBase__+47216;
      var $6963=__stackBase__+47220;
      var $6964=__stackBase__+47224;
      var $6965=__stackBase__+47288;
      var $6966=__stackBase__+47292;
      var $6967=__stackBase__+47296;
      var $6968=__stackBase__+47300;
      var $6969=__stackBase__+47304;
      var $6970=__stackBase__+47308;
      var $6971=__stackBase__+47312;
      var $6972=__stackBase__+47316;
      var $6973=__stackBase__+47380;
      var $6974=__stackBase__+47384;
      var $6975=__stackBase__+47388;
      var $6976=__stackBase__+47392;
      var $6977=__stackBase__+47396;
      var $6978=__stackBase__+47400;
      var $6979=__stackBase__+47404;
      var $6980=__stackBase__+47408;
      var $6981=__stackBase__+47472;
      var $6982=__stackBase__+47476;
      var $6983=__stackBase__+47480;
      var $6984=__stackBase__+47484;
      var $6985=__stackBase__+47488;
      var $6986=__stackBase__+47492;
      var $6987=__stackBase__+47496;
      var $6988=__stackBase__+47500;
      var $6989=__stackBase__+47564;
      var $6990=__stackBase__+47568;
      var $6991=__stackBase__+47572;
      var $6992=__stackBase__+47576;
      var $6993=__stackBase__+47580;
      var $6994=__stackBase__+47584;
      var $6995=__stackBase__+47588;
      var $6996=__stackBase__+47592;
      var $6997=__stackBase__+47656;
      var $6998=__stackBase__+47660;
      var $6999=__stackBase__+47664;
      var $7000=__stackBase__+47668;
      var $7001=__stackBase__+47672;
      var $7002=__stackBase__+47676;
      var $7003=__stackBase__+47680;
      var $7004=__stackBase__+47684;
      var $7005=__stackBase__+47748;
      var $7006=__stackBase__+47752;
      var $7007=__stackBase__+47756;
      var $7008=__stackBase__+47760;
      var $7009=__stackBase__+47764;
      var $7010=__stackBase__+47768;
      var $7011=__stackBase__+47772;
      var $7012=__stackBase__+47776;
      var $7013=__stackBase__+47840;
      var $7014=__stackBase__+47844;
      var $7015=__stackBase__+47848;
      var $7016=__stackBase__+47852;
      var $7017=__stackBase__+47856;
      var $7018=__stackBase__+47860;
      var $7019=__stackBase__+47864;
      var $7020=__stackBase__+47868;
      var $7021=__stackBase__+47932;
      var $7022=__stackBase__+47936;
      var $7023=__stackBase__+47940;
      var $7024=__stackBase__+47944;
      var $7025=__stackBase__+47948;
      var $7026=__stackBase__+47952;
      var $7027=__stackBase__+47956;
      var $7028=__stackBase__+47960;
      var $7029=__stackBase__+48024;
      var $7030=__stackBase__+48028;
      var $7031=__stackBase__+48032;
      var $7032=__stackBase__+48036;
      var $7033=__stackBase__+48040;
      var $7034=__stackBase__+48044;
      var $7035=__stackBase__+48048;
      var $7036=__stackBase__+48052;
      var $7037=__stackBase__+48116;
      var $7038=__stackBase__+48120;
      var $7039=__stackBase__+48124;
      var $7040=__stackBase__+48128;
      var $7041=__stackBase__+48132;
      var $7042=__stackBase__+48136;
      var $7043=__stackBase__+48140;
      var $7044=__stackBase__+48144;
      var $7045=__stackBase__+48208;
      var $7046=__stackBase__+48212;
      var $7047=__stackBase__+48216;
      var $7048=__stackBase__+48220;
      var $7049=__stackBase__+48224;
      var $7050=__stackBase__+48228;
      var $7051=__stackBase__+48232;
      var $7052=__stackBase__+48236;
      var $7053=__stackBase__+48300;
      var $7054=__stackBase__+48304;
      var $7055=__stackBase__+48308;
      var $7056=__stackBase__+48312;
      var $7057=__stackBase__+48316;
      var $7058=__stackBase__+48320;
      var $7059=__stackBase__+48324;
      var $7060=__stackBase__+48328;
      var $7061=__stackBase__+48392;
      var $7062=__stackBase__+48396;
      var $7063=__stackBase__+48400;
      var $7064=__stackBase__+48404;
      var $7065=__stackBase__+48408;
      var $7066=__stackBase__+48412;
      var $7067=__stackBase__+48416;
      var $7068=__stackBase__+48420;
      var $7069=__stackBase__+48484;
      var $7070=__stackBase__+48488;
      var $7071=__stackBase__+48492;
      var $7072=__stackBase__+48496;
      var $7073=__stackBase__+48500;
      var $7074=__stackBase__+48504;
      var $7075=__stackBase__+48508;
      var $7076=__stackBase__+48512;
      var $7077=__stackBase__+48576;
      var $7078=__stackBase__+48580;
      var $7079=__stackBase__+48584;
      var $7080=__stackBase__+48588;
      var $7081=__stackBase__+48592;
      var $7082=__stackBase__+48596;
      var $7083=__stackBase__+48600;
      var $7084=__stackBase__+48604;
      var $7085=__stackBase__+48668;
      var $7086=__stackBase__+48672;
      var $7087=__stackBase__+48676;
      var $7088=__stackBase__+48680;
      var $7089=__stackBase__+48684;
      var $7090=__stackBase__+48688;
      var $7091=__stackBase__+48692;
      var $7092=__stackBase__+48696;
      var $7093=__stackBase__+48760;
      var $7094=__stackBase__+48764;
      var $7095=__stackBase__+48768;
      var $7096=__stackBase__+48772;
      var $7097=__stackBase__+48776;
      var $7098=__stackBase__+48780;
      var $7099=__stackBase__+48784;
      var $7100=__stackBase__+48788;
      var $7101=__stackBase__+48852;
      var $7102=__stackBase__+48856;
      var $7103=__stackBase__+48860;
      var $7104=__stackBase__+48864;
      var $7105=__stackBase__+48868;
      var $7106=__stackBase__+48872;
      var $7107=__stackBase__+48876;
      var $7108=__stackBase__+48880;
      var $7109=__stackBase__+48944;
      var $7110=__stackBase__+48948;
      var $7111=__stackBase__+48952;
      var $7112=__stackBase__+48956;
      var $7113=__stackBase__+48960;
      var $7114=__stackBase__+48964;
      var $7115=__stackBase__+48968;
      var $7116=__stackBase__+48972;
      var $7117=__stackBase__+49036;
      var $7118=__stackBase__+49040;
      var $7119=__stackBase__+49044;
      var $7120=__stackBase__+49048;
      var $7121=__stackBase__+49052;
      var $7122=__stackBase__+49056;
      var $7123=__stackBase__+49060;
      var $7124=__stackBase__+49064;
      var $7125=__stackBase__+49128;
      var $7126=__stackBase__+49132;
      var $7127=__stackBase__+49136;
      var $7128=__stackBase__+49140;
      var $7129=__stackBase__+49144;
      var $7130=__stackBase__+49148;
      var $7131=__stackBase__+49152;
      var $7132=__stackBase__+49156;
      var $7133=__stackBase__+49220;
      var $7134=__stackBase__+49224;
      var $7135=__stackBase__+49228;
      var $7136=__stackBase__+49232;
      var $7137=__stackBase__+49236;
      var $7138=__stackBase__+49240;
      var $7139=__stackBase__+49244;
      var $7140=__stackBase__+49248;
      var $7141=__stackBase__+49312;
      var $7142=__stackBase__+49316;
      var $7143=__stackBase__+49320;
      var $7144=__stackBase__+49324;
      var $7145=__stackBase__+49328;
      var $7146=__stackBase__+49332;
      var $7147=__stackBase__+49336;
      var $7148=__stackBase__+49340;
      var $7149=__stackBase__+49404;
      var $7150=__stackBase__+49408;
      var $7151=__stackBase__+49412;
      var $7152=__stackBase__+49416;
      var $7153=__stackBase__+49420;
      var $7154=__stackBase__+49424;
      var $7155=__stackBase__+49428;
      var $7156=__stackBase__+49432;
      var $7157=__stackBase__+49496;
      var $7158=__stackBase__+49500;
      var $7159=__stackBase__+49504;
      var $7160=__stackBase__+49508;
      var $7161=__stackBase__+49512;
      var $7162=__stackBase__+49516;
      var $7163=__stackBase__+49520;
      var $7164=__stackBase__+49524;
      var $7165=__stackBase__+49588;
      var $7166=__stackBase__+49592;
      var $7167=__stackBase__+49596;
      var $7168=__stackBase__+49600;
      var $7169=__stackBase__+49604;
      var $7170=__stackBase__+49608;
      var $7171=__stackBase__+49612;
      var $7172=__stackBase__+49616;
      var $7173=__stackBase__+49680;
      var $7174=__stackBase__+49684;
      var $7175=__stackBase__+49688;
      var $7176=__stackBase__+49692;
      var $7177=__stackBase__+49696;
      var $7178=__stackBase__+49700;
      var $7179=__stackBase__+49704;
      var $7180=__stackBase__+49708;
      var $7181=__stackBase__+49772;
      var $7182=__stackBase__+49776;
      var $7183=__stackBase__+49780;
      var $7184=__stackBase__+49784;
      var $7185=__stackBase__+49788;
      var $7186=__stackBase__+49792;
      var $7187=__stackBase__+49796;
      var $7188=__stackBase__+49800;
      var $7189=__stackBase__+49864;
      var $7190=__stackBase__+49868;
      var $7191=__stackBase__+49872;
      var $7192=__stackBase__+49876;
      var $7193=__stackBase__+49880;
      var $7194=__stackBase__+49884;
      var $7195=__stackBase__+49888;
      var $7196=__stackBase__+49892;
      var $7197=__stackBase__+49956;
      var $7198=__stackBase__+49960;
      var $7199=__stackBase__+49964;
      var $7200=__stackBase__+49968;
      var $7201=__stackBase__+49972;
      var $7202=__stackBase__+49976;
      var $7203=__stackBase__+49980;
      var $7204=__stackBase__+49984;
      var $7205=__stackBase__+50048;
      var $7206=__stackBase__+50052;
      var $7207=__stackBase__+50056;
      var $7208=__stackBase__+50060;
      var $7209=__stackBase__+50064;
      var $7210=__stackBase__+50068;
      var $7211=__stackBase__+50072;
      var $7212=__stackBase__+50076;
      var $7213=__stackBase__+50140;
      var $7214=__stackBase__+50144;
      var $7215=__stackBase__+50148;
      var $7216=__stackBase__+50152;
      var $7217=__stackBase__+50156;
      var $7218=__stackBase__+50160;
      var $7219=__stackBase__+50164;
      var $7220=__stackBase__+50168;
      var $7221=__stackBase__+50232;
      var $7222=__stackBase__+50236;
      var $7223=__stackBase__+50240;
      var $7224=__stackBase__+50244;
      var $7225=__stackBase__+50248;
      var $7226=__stackBase__+50252;
      var $7227=__stackBase__+50256;
      var $7228=__stackBase__+50260;
      var $7229=__stackBase__+50324;
      var $7230=__stackBase__+50328;
      var $7231=__stackBase__+50332;
      var $7232=__stackBase__+50336;
      var $7233=__stackBase__+50340;
      var $7234=__stackBase__+50344;
      var $7235=__stackBase__+50348;
      var $7236=__stackBase__+50352;
      var $7237=__stackBase__+50416;
      var $7238=__stackBase__+50420;
      var $7239=__stackBase__+50424;
      var $7240=__stackBase__+50428;
      var $7241=__stackBase__+50432;
      var $7242=__stackBase__+50436;
      var $7243=__stackBase__+50440;
      var $7244=__stackBase__+50444;
      var $7245=__stackBase__+50508;
      var $7246=__stackBase__+50512;
      var $7247=__stackBase__+50516;
      var $7248=__stackBase__+50520;
      var $7249=__stackBase__+50524;
      var $7250=__stackBase__+50528;
      var $7251=__stackBase__+50532;
      var $7252=__stackBase__+50536;
      var $7253=__stackBase__+50600;
      var $7254=__stackBase__+50604;
      var $7255=__stackBase__+50608;
      var $7256=__stackBase__+50612;
      var $7257=__stackBase__+50616;
      var $7258=__stackBase__+50620;
      var $7259=__stackBase__+50624;
      var $7260=__stackBase__+50628;
      var $7261=__stackBase__+50692;
      var $7262=__stackBase__+50696;
      var $7263=__stackBase__+50700;
      var $7264=__stackBase__+50704;
      var $7265=__stackBase__+50708;
      var $7266=__stackBase__+50712;
      var $7267=__stackBase__+50716;
      var $7268=__stackBase__+50720;
      var $7269=__stackBase__+50784;
      var $7270=__stackBase__+50788;
      var $7271=__stackBase__+50792;
      var $7272=__stackBase__+50796;
      var $7273=__stackBase__+50800;
      var $7274=__stackBase__+50804;
      var $7275=__stackBase__+50808;
      var $7276=__stackBase__+50812;
      var $7277=__stackBase__+50876;
      var $7278=__stackBase__+50880;
      var $7279=__stackBase__+50884;
      var $7280=__stackBase__+50888;
      var $7281=__stackBase__+50892;
      var $7282=__stackBase__+50896;
      var $7283=__stackBase__+50900;
      var $7284=__stackBase__+50904;
      var $7285=__stackBase__+50968;
      var $7286=__stackBase__+50972;
      var $7287=__stackBase__+50976;
      var $7288=__stackBase__+50980;
      var $7289=__stackBase__+50984;
      var $7290=__stackBase__+50988;
      var $7291=__stackBase__+50992;
      var $7292=__stackBase__+50996;
      var $7293=__stackBase__+51060;
      var $7294=__stackBase__+51064;
      var $7295=__stackBase__+51068;
      var $7296=__stackBase__+51072;
      var $7297=__stackBase__+51076;
      var $7298=__stackBase__+51080;
      var $7299=__stackBase__+51084;
      var $7300=__stackBase__+51088;
      var $7301=__stackBase__+51152;
      var $7302=__stackBase__+51156;
      var $7303=__stackBase__+51160;
      var $7304=__stackBase__+51164;
      var $7305=__stackBase__+51168;
      var $7306=__stackBase__+51172;
      var $7307=__stackBase__+51176;
      var $7308=__stackBase__+51180;
      var $7309=__stackBase__+51244;
      var $7310=__stackBase__+51248;
      var $7311=__stackBase__+51252;
      var $7312=__stackBase__+51256;
      var $7313=__stackBase__+51260;
      var $7314=__stackBase__+51264;
      var $7315=__stackBase__+51268;
      var $7316=__stackBase__+51272;
      var $7317=__stackBase__+51336;
      var $7318=__stackBase__+51340;
      var $7319=__stackBase__+51344;
      var $7320=__stackBase__+51348;
      var $7321=__stackBase__+51352;
      var $7322=__stackBase__+51356;
      var $7323=__stackBase__+51360;
      var $7324=__stackBase__+51364;
      var $7325=__stackBase__+51428;
      var $7326=__stackBase__+51432;
      var $7327=__stackBase__+51436;
      var $7328=__stackBase__+51440;
      var $7329=__stackBase__+51444;
      var $7330=__stackBase__+51448;
      var $7331=__stackBase__+51452;
      var $7332=__stackBase__+51456;
      var $7333=__stackBase__+51520;
      var $7334=__stackBase__+51524;
      var $7335=__stackBase__+51528;
      var $7336=__stackBase__+51532;
      var $7337=__stackBase__+51536;
      var $7338=__stackBase__+51540;
      var $7339=__stackBase__+51544;
      var $7340=__stackBase__+51548;
      var $7341=__stackBase__+51612;
      var $7342=__stackBase__+51616;
      var $7343=__stackBase__+51620;
      var $7344=__stackBase__+51624;
      var $7345=__stackBase__+51628;
      var $7346=__stackBase__+51632;
      var $7347=__stackBase__+51636;
      var $7348=__stackBase__+51640;
      var $7349=__stackBase__+51704;
      var $7350=__stackBase__+51708;
      var $7351=__stackBase__+51712;
      var $7352=__stackBase__+51716;
      var $7353=__stackBase__+51720;
      var $7354=__stackBase__+51724;
      var $7355=__stackBase__+51728;
      var $7356=__stackBase__+51732;
      var $7357=__stackBase__+51796;
      var $7358=__stackBase__+51800;
      var $7359=__stackBase__+51804;
      var $7360=__stackBase__+51808;
      var $7361=__stackBase__+51812;
      var $7362=__stackBase__+51816;
      var $7363=__stackBase__+51820;
      var $7364=__stackBase__+51824;
      var $7365=__stackBase__+51888;
      var $7366=__stackBase__+51892;
      var $7367=__stackBase__+51896;
      var $7368=__stackBase__+51900;
      var $7369=__stackBase__+51904;
      var $7370=__stackBase__+51908;
      var $7371=__stackBase__+51912;
      var $7372=__stackBase__+51916;
      var $7373=__stackBase__+51980;
      var $7374=__stackBase__+51984;
      var $7375=__stackBase__+51988;
      var $7376=__stackBase__+51992;
      var $7377=__stackBase__+51996;
      var $7378=__stackBase__+52000;
      var $7379=__stackBase__+52004;
      var $7380=__stackBase__+52008;
      var $7381=__stackBase__+52072;
      var $7382=__stackBase__+52076;
      var $7383=__stackBase__+52080;
      var $7384=__stackBase__+52084;
      var $7385=__stackBase__+52088;
      var $7386=__stackBase__+52092;
      var $7387=__stackBase__+52096;
      var $7388=__stackBase__+52100;
      var $7389=__stackBase__+52164;
      var $7390=__stackBase__+52168;
      var $7391=__stackBase__+52172;
      var $7392=__stackBase__+52176;
      var $7393=__stackBase__+52180;
      var $7394=__stackBase__+52184;
      var $7395=__stackBase__+52188;
      var $7396=__stackBase__+52192;
      var $7397=__stackBase__+52256;
      var $7398=__stackBase__+52260;
      var $7399=__stackBase__+52264;
      var $7400=__stackBase__+52268;
      var $7401=__stackBase__+52272;
      var $7402=__stackBase__+52276;
      var $7403=__stackBase__+52280;
      var $7404=__stackBase__+52284;
      var $7405=__stackBase__+52348;
      var $7406=__stackBase__+52352;
      var $7407=__stackBase__+52356;
      var $7408=__stackBase__+52360;
      var $7409=__stackBase__+52364;
      var $7410=__stackBase__+52368;
      var $7411=__stackBase__+52372;
      var $7412=__stackBase__+52376;
      var $7413=__stackBase__+52440;
      var $7414=__stackBase__+52444;
      var $7415=__stackBase__+52448;
      var $7416=__stackBase__+52452;
      var $7417=__stackBase__+52456;
      var $7418=__stackBase__+52460;
      var $7419=__stackBase__+52464;
      var $7420=__stackBase__+52468;
      var $7421=__stackBase__+52532;
      var $7422=__stackBase__+52536;
      var $7423=__stackBase__+52540;
      var $7424=__stackBase__+52544;
      var $7425=__stackBase__+52548;
      var $7426=__stackBase__+52552;
      var $7427=__stackBase__+52556;
      var $7428=__stackBase__+52560;
      var $7429=__stackBase__+52624;
      var $7430=__stackBase__+52628;
      var $7431=__stackBase__+52632;
      var $7432=__stackBase__+52636;
      var $7433=__stackBase__+52640;
      var $7434=__stackBase__+52644;
      var $7435=__stackBase__+52648;
      var $7436=__stackBase__+52652;
      var $7437=__stackBase__+52716;
      var $7438=__stackBase__+52720;
      var $7439=__stackBase__+52724;
      var $7440=__stackBase__+52728;
      var $7441=__stackBase__+52732;
      var $7442=__stackBase__+52736;
      var $7443=__stackBase__+52740;
      var $7444=__stackBase__+52744;
      var $7445=__stackBase__+52808;
      var $7446=__stackBase__+52812;
      var $7447=__stackBase__+52816;
      var $7448=__stackBase__+52820;
      var $7449=__stackBase__+52824;
      var $7450=__stackBase__+52828;
      var $7451=__stackBase__+52832;
      var $7452=__stackBase__+52836;
      var $7453=__stackBase__+52900;
      var $7454=__stackBase__+52904;
      var $7455=__stackBase__+52908;
      var $7456=__stackBase__+52912;
      var $7457=__stackBase__+52916;
      var $7458=__stackBase__+52920;
      var $7459=__stackBase__+52924;
      var $7460=__stackBase__+52928;
      var $7461=__stackBase__+52992;
      var $7462=__stackBase__+52996;
      var $7463=__stackBase__+53000;
      var $7464=__stackBase__+53004;
      var $7465=__stackBase__+53008;
      var $7466=__stackBase__+53012;
      var $7467=__stackBase__+53016;
      var $7468=__stackBase__+53020;
      var $7469=__stackBase__+53084;
      var $7470=__stackBase__+53088;
      var $7471=__stackBase__+53092;
      var $7472=__stackBase__+53096;
      var $7473=__stackBase__+53100;
      var $7474=__stackBase__+53104;
      var $7475=__stackBase__+53108;
      var $7476=__stackBase__+53112;
      var $7477=__stackBase__+53176;
      var $7478=__stackBase__+53180;
      var $7479=__stackBase__+53184;
      var $7480=__stackBase__+53188;
      var $7481=__stackBase__+53192;
      var $7482=__stackBase__+53196;
      var $7483=__stackBase__+53200;
      var $7484=__stackBase__+53204;
      var $7485=__stackBase__+53268;
      var $7486=__stackBase__+53272;
      var $7487=__stackBase__+53276;
      var $7488=__stackBase__+53280;
      var $7489=__stackBase__+53284;
      var $7490=__stackBase__+53288;
      var $7491=__stackBase__+53292;
      var $7492=__stackBase__+53296;
      var $7493=__stackBase__+53360;
      var $7494=__stackBase__+53364;
      var $7495=__stackBase__+53368;
      var $7496=__stackBase__+53372;
      var $7497=__stackBase__+53376;
      var $7498=__stackBase__+53380;
      var $7499=__stackBase__+53384;
      var $7500=__stackBase__+53388;
      var $7501=__stackBase__+53452;
      var $7502=__stackBase__+53456;
      var $7503=__stackBase__+53460;
      var $7504=__stackBase__+53464;
      var $7505=__stackBase__+53468;
      var $7506=__stackBase__+53472;
      var $7507=__stackBase__+53476;
      var $7508=__stackBase__+53480;
      var $7509=__stackBase__+53544;
      var $7510=__stackBase__+53548;
      var $7511=__stackBase__+53552;
      var $7512=__stackBase__+53556;
      var $7513=__stackBase__+53560;
      var $7514=__stackBase__+53564;
      var $7515=__stackBase__+53568;
      var $7516=__stackBase__+53572;
      var $7517=__stackBase__+53636;
      var $7518=__stackBase__+53640;
      var $7519=__stackBase__+53644;
      var $7520=__stackBase__+53648;
      var $7521=__stackBase__+53652;
      var $7522=__stackBase__+53656;
      var $7523=__stackBase__+53660;
      var $7524=__stackBase__+53664;
      var $7525=__stackBase__+53728;
      var $7526=__stackBase__+53732;
      var $7527=__stackBase__+53736;
      var $7528=__stackBase__+53740;
      var $7529=__stackBase__+53744;
      var $7530=__stackBase__+53748;
      var $7531=__stackBase__+53752;
      var $7532=__stackBase__+53756;
      var $7533=__stackBase__+53820;
      var $7534=__stackBase__+53824;
      var $7535=__stackBase__+53828;
      var $7536=__stackBase__+53832;
      var $7537=__stackBase__+53836;
      var $7538=__stackBase__+53840;
      var $7539=__stackBase__+53844;
      var $7540=__stackBase__+53848;
      var $7541=__stackBase__+53912;
      var $7542=__stackBase__+53916;
      var $7543=__stackBase__+53920;
      var $7544=__stackBase__+53924;
      var $7545=__stackBase__+53928;
      var $7546=__stackBase__+53932;
      var $7547=__stackBase__+53936;
      var $7548=__stackBase__+53940;
      var $7549=__stackBase__+54004;
      var $7550=__stackBase__+54008;
      var $7551=__stackBase__+54012;
      var $7552=__stackBase__+54016;
      var $7553=__stackBase__+54020;
      var $7554=__stackBase__+54024;
      var $7555=__stackBase__+54028;
      var $7556=__stackBase__+54032;
      var $7557=__stackBase__+54096;
      var $7558=__stackBase__+54100;
      var $7559=__stackBase__+54104;
      var $7560=__stackBase__+54108;
      var $7561=__stackBase__+54112;
      var $7562=__stackBase__+54116;
      var $7563=__stackBase__+54120;
      var $7564=__stackBase__+54124;
      var $7565=__stackBase__+54188;
      var $7566=__stackBase__+54192;
      var $7567=__stackBase__+54196;
      var $7568=__stackBase__+54200;
      var $7569=__stackBase__+54204;
      var $7570=__stackBase__+54208;
      var $7571=__stackBase__+54212;
      var $7572=__stackBase__+54216;
      var $7573=__stackBase__+54280;
      var $7574=__stackBase__+54284;
      var $7575=__stackBase__+54288;
      var $7576=__stackBase__+54292;
      var $7577=__stackBase__+54296;
      var $7578=__stackBase__+54300;
      var $7579=__stackBase__+54304;
      var $7580=__stackBase__+54308;
      var $7581=__stackBase__+54372;
      var $7582=__stackBase__+54376;
      var $7583=__stackBase__+54380;
      var $7584=__stackBase__+54384;
      var $7585=__stackBase__+54388;
      var $7586=__stackBase__+54392;
      var $7587=__stackBase__+54396;
      var $7588=__stackBase__+54400;
      var $7589=__stackBase__+54464;
      var $7590=__stackBase__+54468;
      var $7591=__stackBase__+54472;
      var $7592=__stackBase__+54476;
      var $7593=__stackBase__+54480;
      var $7594=__stackBase__+54484;
      var $7595=__stackBase__+54488;
      var $7596=__stackBase__+54492;
      var $7597=__stackBase__+54556;
      var $7598=__stackBase__+54560;
      var $7599=__stackBase__+54564;
      var $7600=__stackBase__+54568;
      var $7601=__stackBase__+54572;
      var $7602=__stackBase__+54576;
      var $7603=__stackBase__+54580;
      var $7604=__stackBase__+54584;
      var $7605=__stackBase__+54648;
      var $7606=__stackBase__+54652;
      var $7607=__stackBase__+54656;
      var $7608=__stackBase__+54660;
      var $7609=__stackBase__+54664;
      var $7610=__stackBase__+54668;
      var $7611=__stackBase__+54672;
      var $7612=__stackBase__+54676;
      var $7613=__stackBase__+54740;
      var $7614=__stackBase__+54744;
      var $7615=__stackBase__+54748;
      var $7616=__stackBase__+54752;
      var $7617=__stackBase__+54756;
      var $7618=__stackBase__+54760;
      var $7619=__stackBase__+54764;
      var $7620=__stackBase__+54768;
      var $7621=__stackBase__+54832;
      var $7622=__stackBase__+54836;
      var $7623=__stackBase__+54840;
      var $7624=__stackBase__+54844;
      var $7625=__stackBase__+54848;
      var $7626=__stackBase__+54852;
      var $7627=__stackBase__+54856;
      var $7628=__stackBase__+54860;
      var $7629=__stackBase__+54924;
      var $7630=__stackBase__+54928;
      var $7631=__stackBase__+54932;
      var $7632=__stackBase__+54936;
      var $7633=__stackBase__+54940;
      var $7634=__stackBase__+54944;
      var $7635=__stackBase__+54948;
      var $7636=__stackBase__+54952;
      var $7637=__stackBase__+55016;
      var $7638=__stackBase__+55020;
      var $7639=__stackBase__+55024;
      var $7640=__stackBase__+55028;
      var $7641=__stackBase__+55032;
      var $7642=__stackBase__+55036;
      var $7643=__stackBase__+55040;
      var $7644=__stackBase__+55044;
      var $7645=__stackBase__+55108;
      var $7646=__stackBase__+55112;
      var $7647=__stackBase__+55116;
      var $7648=__stackBase__+55120;
      var $7649=__stackBase__+55124;
      var $7650=__stackBase__+55128;
      var $7651=__stackBase__+55132;
      var $7652=__stackBase__+55136;
      var $7653=__stackBase__+55200;
      var $7654=__stackBase__+55204;
      var $7655=__stackBase__+55208;
      var $7656=__stackBase__+55212;
      var $7657=__stackBase__+55216;
      var $7658=__stackBase__+55220;
      var $7659=__stackBase__+55224;
      var $7660=__stackBase__+55228;
      var $7661=__stackBase__+55292;
      var $7662=__stackBase__+55296;
      var $7663=__stackBase__+55300;
      var $7664=__stackBase__+55304;
      var $7665=__stackBase__+55308;
      var $7666=__stackBase__+55312;
      var $7667=__stackBase__+55316;
      var $7668=__stackBase__+55320;
      var $7669=__stackBase__+55384;
      var $7670=__stackBase__+55388;
      var $7671=__stackBase__+55392;
      var $7672=__stackBase__+55396;
      var $7673=__stackBase__+55400;
      var $7674=__stackBase__+55404;
      var $7675=__stackBase__+55408;
      var $7676=__stackBase__+55412;
      var $7677=__stackBase__+55476;
      var $7678=__stackBase__+55480;
      var $7679=__stackBase__+55484;
      var $7680=__stackBase__+55488;
      var $7681=__stackBase__+55492;
      var $7682=__stackBase__+55496;
      var $7683=__stackBase__+55500;
      var $7684=__stackBase__+55504;
      var $7685=__stackBase__+55568;
      var $7686=__stackBase__+55572;
      var $7687=__stackBase__+55576;
      var $7688=__stackBase__+55580;
      var $7689=__stackBase__+55584;
      var $7690=__stackBase__+55588;
      var $7691=__stackBase__+55592;
      var $7692=__stackBase__+55596;
      var $7693=__stackBase__+55660;
      var $7694=__stackBase__+55664;
      var $7695=__stackBase__+55668;
      var $7696=__stackBase__+55672;
      var $7697=__stackBase__+55676;
      var $7698=__stackBase__+55680;
      var $7699=__stackBase__+55684;
      var $7700=__stackBase__+55688;
      var $7701=__stackBase__+55752;
      var $7702=__stackBase__+55756;
      var $7703=__stackBase__+55760;
      var $7704=__stackBase__+55764;
      var $7705=__stackBase__+55768;
      var $7706=__stackBase__+55772;
      var $7707=__stackBase__+55776;
      var $7708=__stackBase__+55780;
      var $7709=__stackBase__+55844;
      var $7710=__stackBase__+55848;
      var $7711=__stackBase__+55852;
      var $7712=__stackBase__+55856;
      var $7713=__stackBase__+55860;
      var $7714=__stackBase__+55864;
      var $7715=__stackBase__+55868;
      var $7716=__stackBase__+55872;
      var $7717=__stackBase__+55936;
      var $7718=__stackBase__+55940;
      var $7719=__stackBase__+55944;
      var $7720=__stackBase__+55948;
      var $7721=__stackBase__+55952;
      var $7722=__stackBase__+55956;
      var $7723=__stackBase__+55960;
      var $7724=__stackBase__+55964;
      var $7725=__stackBase__+56028;
      var $7726=__stackBase__+56032;
      var $7727=__stackBase__+56036;
      var $7728=__stackBase__+56040;
      var $7729=__stackBase__+56044;
      var $7730=__stackBase__+56048;
      var $7731=__stackBase__+56052;
      var $7732=__stackBase__+56056;
      var $7733=__stackBase__+56120;
      var $7734=__stackBase__+56124;
      var $7735=__stackBase__+56128;
      var $7736=__stackBase__+56132;
      var $7737=__stackBase__+56136;
      var $7738=__stackBase__+56140;
      var $7739=__stackBase__+56144;
      var $7740=__stackBase__+56148;
      var $7741=__stackBase__+56212;
      var $7742=__stackBase__+56216;
      var $7743=__stackBase__+56220;
      var $7744=__stackBase__+56224;
      var $7745=__stackBase__+56228;
      var $7746=__stackBase__+56232;
      var $7747=__stackBase__+56236;
      var $7748=__stackBase__+56240;
      var $7749=__stackBase__+56304;
      var $7750=__stackBase__+56308;
      var $7751=__stackBase__+56312;
      var $7752=__stackBase__+56316;
      var $7753=__stackBase__+56320;
      var $7754=__stackBase__+56324;
      var $7755=__stackBase__+56328;
      var $7756=__stackBase__+56332;
      var $7757=__stackBase__+56396;
      var $7758=__stackBase__+56400;
      var $7759=__stackBase__+56404;
      var $7760=__stackBase__+56408;
      var $7761=__stackBase__+56412;
      var $7762=__stackBase__+56416;
      var $7763=__stackBase__+56420;
      var $7764=__stackBase__+56424;
      var $7765=__stackBase__+56488;
      var $7766=__stackBase__+56492;
      var $7767=__stackBase__+56496;
      var $7768=__stackBase__+56500;
      var $7769=__stackBase__+56504;
      var $7770=__stackBase__+56508;
      var $7771=__stackBase__+56512;
      var $7772=__stackBase__+56516;
      var $7773=__stackBase__+56580;
      var $7774=__stackBase__+56584;
      var $7775=__stackBase__+56588;
      var $7776=__stackBase__+56592;
      var $7777=__stackBase__+56596;
      var $7778=__stackBase__+56600;
      var $7779=__stackBase__+56604;
      var $7780=__stackBase__+56608;
      var $7781=__stackBase__+56672;
      var $7782=__stackBase__+56676;
      var $7783=__stackBase__+56680;
      var $7784=__stackBase__+56684;
      var $7785=__stackBase__+56688;
      var $7786=__stackBase__+56692;
      var $7787=__stackBase__+56696;
      var $7788=__stackBase__+56700;
      var $7789=__stackBase__+56764;
      var $7790=__stackBase__+56768;
      var $7791=__stackBase__+56772;
      var $7792=__stackBase__+56776;
      var $7793=__stackBase__+56780;
      var $7794=__stackBase__+56784;
      var $7795=__stackBase__+56788;
      var $7796=__stackBase__+56792;
      var $7797=__stackBase__+56856;
      var $7798=__stackBase__+56860;
      var $7799=__stackBase__+56864;
      var $7800=__stackBase__+56868;
      var $7801=__stackBase__+56872;
      var $7802=__stackBase__+56876;
      var $7803=__stackBase__+56880;
      var $7804=__stackBase__+56884;
      var $7805=__stackBase__+56948;
      var $7806=__stackBase__+56952;
      var $7807=__stackBase__+56956;
      var $7808=__stackBase__+56960;
      var $7809=__stackBase__+56964;
      var $7810=__stackBase__+56968;
      var $7811=__stackBase__+56972;
      var $7812=__stackBase__+56976;
      var $7813=__stackBase__+57040;
      var $7814=__stackBase__+57044;
      var $7815=__stackBase__+57048;
      var $7816=__stackBase__+57052;
      var $7817=__stackBase__+57056;
      var $7818=__stackBase__+57060;
      var $7819=__stackBase__+57064;
      var $7820=__stackBase__+57068;
      var $7821=__stackBase__+57132;
      var $7822=__stackBase__+57136;
      var $7823=__stackBase__+57140;
      var $7824=__stackBase__+57144;
      var $7825=__stackBase__+57148;
      var $7826=__stackBase__+57152;
      var $7827=__stackBase__+57156;
      var $7828=__stackBase__+57160;
      var $7829=__stackBase__+57224;
      var $7830=__stackBase__+57228;
      var $7831=__stackBase__+57232;
      var $7832=__stackBase__+57236;
      var $7833=__stackBase__+57240;
      var $7834=__stackBase__+57244;
      var $7835=__stackBase__+57248;
      var $7836=__stackBase__+57252;
      var $7837=__stackBase__+57316;
      var $7838=__stackBase__+57320;
      var $7839=__stackBase__+57324;
      var $7840=__stackBase__+57328;
      var $7841=__stackBase__+57332;
      var $7842=__stackBase__+57336;
      var $7843=__stackBase__+57340;
      var $7844=__stackBase__+57344;
      var $7845=__stackBase__+57408;
      var $7846=__stackBase__+57412;
      var $7847=__stackBase__+57416;
      var $7848=__stackBase__+57420;
      var $7849=__stackBase__+57424;
      var $7850=__stackBase__+57428;
      var $7851=__stackBase__+57432;
      var $7852=__stackBase__+57436;
      var $7853=__stackBase__+57500;
      var $7854=__stackBase__+57504;
      var $7855=__stackBase__+57508;
      var $7856=__stackBase__+57512;
      var $7857=__stackBase__+57516;
      var $7858=__stackBase__+57520;
      var $7859=__stackBase__+57524;
      var $7860=__stackBase__+57528;
      var $7861=__stackBase__+57592;
      var $7862=__stackBase__+57596;
      var $7863=__stackBase__+57600;
      var $7864=__stackBase__+57604;
      var $7865=__stackBase__+57608;
      var $7866=__stackBase__+57612;
      var $7867=__stackBase__+57616;
      var $7868=__stackBase__+57620;
      var $7869=__stackBase__+57684;
      var $7870=__stackBase__+57688;
      var $7871=__stackBase__+57692;
      var $7872=__stackBase__+57696;
      var $7873=__stackBase__+57700;
      var $7874=__stackBase__+57704;
      var $7875=__stackBase__+57708;
      var $7876=__stackBase__+57712;
      var $7877=__stackBase__+57776;
      var $7878=__stackBase__+57780;
      var $7879=__stackBase__+57784;
      var $7880=__stackBase__+57788;
      var $7881=__stackBase__+57792;
      var $7882=__stackBase__+57796;
      var $7883=__stackBase__+57800;
      var $7884=__stackBase__+57804;
      var $7885=__stackBase__+57868;
      var $7886=__stackBase__+57872;
      var $7887=__stackBase__+57876;
      var $7888=__stackBase__+57880;
      var $7889=__stackBase__+57884;
      var $7890=__stackBase__+57888;
      var $7891=__stackBase__+57892;
      var $7892=__stackBase__+57896;
      var $7893=__stackBase__+57960;
      var $7894=__stackBase__+57964;
      var $7895=__stackBase__+57968;
      var $7896=__stackBase__+57972;
      var $7897=__stackBase__+57976;
      var $7898=__stackBase__+57980;
      var $7899=__stackBase__+57984;
      var $7900=__stackBase__+57988;
      var $7901=__stackBase__+58052;
      var $7902=__stackBase__+58056;
      var $7903=__stackBase__+58060;
      var $7904=__stackBase__+58064;
      var $7905=__stackBase__+58068;
      var $7906=__stackBase__+58072;
      var $7907=__stackBase__+58076;
      var $7908=__stackBase__+58080;
      var $7909=__stackBase__+58144;
      var $7910=__stackBase__+58148;
      var $7911=__stackBase__+58152;
      var $7912=__stackBase__+58156;
      var $7913=__stackBase__+58160;
      var $7914=__stackBase__+58164;
      var $7915=__stackBase__+58168;
      var $7916=__stackBase__+58172;
      var $7917=__stackBase__+58236;
      var $7918=__stackBase__+58240;
      var $7919=__stackBase__+58244;
      var $7920=__stackBase__+58248;
      var $7921=__stackBase__+58252;
      var $7922=__stackBase__+58256;
      var $7923=__stackBase__+58260;
      var $7924=__stackBase__+58264;
      var $7925=__stackBase__+58328;
      var $7926=__stackBase__+58332;
      var $7927=__stackBase__+58336;
      var $7928=__stackBase__+58340;
      var $7929=__stackBase__+58344;
      var $7930=__stackBase__+58348;
      var $7931=__stackBase__+58352;
      var $7932=__stackBase__+58356;
      var $7933=__stackBase__+58420;
      var $7934=__stackBase__+58424;
      var $7935=__stackBase__+58428;
      var $7936=__stackBase__+58432;
      var $7937=__stackBase__+58436;
      var $7938=__stackBase__+58440;
      var $7939=__stackBase__+58444;
      var $7940=__stackBase__+58448;
      var $7941=__stackBase__+58512;
      var $7942=__stackBase__+58516;
      var $7943=__stackBase__+58520;
      var $7944=__stackBase__+58524;
      var $7945=__stackBase__+58528;
      var $7946=__stackBase__+58532;
      var $7947=__stackBase__+58536;
      var $7948=__stackBase__+58540;
      var $7949=__stackBase__+58604;
      var $7950=__stackBase__+58608;
      var $7951=__stackBase__+58612;
      var $7952=__stackBase__+58616;
      var $7953=__stackBase__+58620;
      var $7954=__stackBase__+58624;
      var $7955=__stackBase__+58628;
      var $7956=__stackBase__+58632;
      var $7957=__stackBase__+58696;
      var $7958=__stackBase__+58700;
      var $7959=__stackBase__+58704;
      var $7960=__stackBase__+58708;
      var $7961=__stackBase__+58712;
      var $7962=__stackBase__+58716;
      var $7963=__stackBase__+58720;
      var $7964=__stackBase__+58724;
      var $7965=__stackBase__+58788;
      var $7966=__stackBase__+58792;
      var $7967=__stackBase__+58796;
      var $7968=__stackBase__+58800;
      var $7969=__stackBase__+58804;
      var $7970=__stackBase__+58808;
      var $7971=__stackBase__+58812;
      var $7972=__stackBase__+58816;
      var $7973=__stackBase__+58880;
      var $7974=__stackBase__+58884;
      var $7975=__stackBase__+58888;
      var $7976=__stackBase__+58892;
      var $7977=__stackBase__+58896;
      var $7978=__stackBase__+58900;
      var $7979=__stackBase__+58904;
      var $7980=__stackBase__+58908;
      var $7981=__stackBase__+58972;
      var $7982=__stackBase__+58976;
      var $7983=__stackBase__+58980;
      var $7984=__stackBase__+58984;
      var $7985=__stackBase__+58988;
      var $7986=__stackBase__+58992;
      var $7987=__stackBase__+58996;
      var $7988=__stackBase__+59000;
      var $7989=__stackBase__+59064;
      var $7990=__stackBase__+59068;
      var $7991=__stackBase__+59072;
      var $7992=__stackBase__+59076;
      var $7993=__stackBase__+59080;
      var $7994=__stackBase__+59084;
      var $7995=__stackBase__+59088;
      var $7996=__stackBase__+59092;
      var $7997=__stackBase__+59156;
      var $7998=__stackBase__+59160;
      var $7999=__stackBase__+59164;
      var $8000=__stackBase__+59168;
      var $8001=__stackBase__+59172;
      var $8002=__stackBase__+59176;
      var $8003=__stackBase__+59180;
      var $8004=__stackBase__+59184;
      var $8005=__stackBase__+59248;
      var $8006=__stackBase__+59252;
      var $8007=__stackBase__+59256;
      var $8008=__stackBase__+59260;
      var $8009=__stackBase__+59264;
      var $8010=__stackBase__+59268;
      var $8011=__stackBase__+59272;
      var $8012=__stackBase__+59276;
      var $8013=__stackBase__+59340;
      var $8014=__stackBase__+59344;
      var $8015=__stackBase__+59348;
      var $8016=__stackBase__+59352;
      var $8017=__stackBase__+59356;
      var $8018=__stackBase__+59360;
      var $8019=__stackBase__+59364;
      var $8020=__stackBase__+59368;
      var $8021=__stackBase__+59432;
      var $8022=__stackBase__+59436;
      var $8023=__stackBase__+59440;
      var $8024=__stackBase__+59444;
      var $8025=__stackBase__+59448;
      var $8026=__stackBase__+59452;
      var $8027=__stackBase__+59456;
      var $8028=__stackBase__+59460;
      var $8029=__stackBase__+59524;
      var $8030=__stackBase__+59528;
      var $8031=__stackBase__+59532;
      var $8032=__stackBase__+59536;
      var $8033=__stackBase__+59540;
      var $8034=__stackBase__+59544;
      var $8035=__stackBase__+59548;
      var $8036=__stackBase__+59552;
      var $8037=__stackBase__+59616;
      var $8038=__stackBase__+59620;
      var $8039=__stackBase__+59624;
      var $8040=__stackBase__+59628;
      var $8041=__stackBase__+59632;
      var $8042=__stackBase__+59636;
      var $8043=__stackBase__+59640;
      var $8044=__stackBase__+59644;
      var $8045=__stackBase__+59708;
      var $8046=__stackBase__+59712;
      var $8047=__stackBase__+59716;
      var $8048=__stackBase__+59720;
      var $8049=__stackBase__+59724;
      var $8050=__stackBase__+59728;
      var $8051=__stackBase__+59732;
      var $8052=__stackBase__+59736;
      var $8053=__stackBase__+59800;
      var $8054=__stackBase__+59804;
      var $8055=__stackBase__+59808;
      var $8056=__stackBase__+59812;
      var $8057=__stackBase__+59816;
      var $8058=__stackBase__+59820;
      var $8059=__stackBase__+59824;
      var $8060=__stackBase__+59828;
      var $8061=__stackBase__+59892;
      var $8062=__stackBase__+59896;
      var $8063=__stackBase__+59900;
      var $8064=__stackBase__+59904;
      var $8065=__stackBase__+59908;
      var $8066=__stackBase__+59912;
      var $8067=__stackBase__+59916;
      var $8068=__stackBase__+59920;
      var $8069=__stackBase__+59984;
      var $8070=__stackBase__+59988;
      var $8071=__stackBase__+59992;
      var $8072=__stackBase__+59996;
      var $8073=__stackBase__+60000;
      var $8074=__stackBase__+60004;
      var $8075=__stackBase__+60008;
      var $8076=__stackBase__+60012;
      var $8077=__stackBase__+60076;
      var $8078=__stackBase__+60080;
      var $8079=__stackBase__+60084;
      var $8080=__stackBase__+60088;
      var $8081=__stackBase__+60092;
      var $8082=__stackBase__+60096;
      var $8083=__stackBase__+60100;
      var $8084=__stackBase__+60104;
      var $8085=__stackBase__+60168;
      var $8086=__stackBase__+60172;
      var $8087=__stackBase__+60176;
      var $8088=__stackBase__+60180;
      var $8089=__stackBase__+60184;
      var $8090=__stackBase__+60188;
      var $8091=__stackBase__+60192;
      var $8092=__stackBase__+60196;
      var $8093=__stackBase__+60260;
      var $8094=__stackBase__+60264;
      var $8095=__stackBase__+60268;
      var $8096=__stackBase__+60272;
      var $8097=__stackBase__+60276;
      var $8098=__stackBase__+60280;
      var $8099=__stackBase__+60284;
      var $8100=__stackBase__+60288;
      var $8101=__stackBase__+60352;
      var $8102=__stackBase__+60356;
      var $8103=__stackBase__+60360;
      var $8104=__stackBase__+60364;
      var $8105=__stackBase__+60368;
      var $8106=__stackBase__+60372;
      var $8107=__stackBase__+60376;
      var $8108=__stackBase__+60380;
      var $8109=__stackBase__+60444;
      var $8110=__stackBase__+60448;
      var $8111=__stackBase__+60452;
      var $8112=__stackBase__+60456;
      var $8113=__stackBase__+60460;
      var $8114=__stackBase__+60464;
      var $8115=__stackBase__+60468;
      var $8116=__stackBase__+60472;
      var $8117=__stackBase__+60536;
      var $8118=__stackBase__+60540;
      var $8119=__stackBase__+60544;
      var $8120=__stackBase__+60548;
      var $8121=__stackBase__+60552;
      var $8122=__stackBase__+60556;
      var $8123=__stackBase__+60560;
      var $8124=__stackBase__+60564;
      var $8125=__stackBase__+60628;
      var $8126=__stackBase__+60632;
      var $8127=__stackBase__+60636;
      var $8128=__stackBase__+60640;
      var $8129=__stackBase__+60644;
      var $8130=__stackBase__+60648;
      var $8131=__stackBase__+60652;
      var $8132=__stackBase__+60656;
      var $8133=__stackBase__+60720;
      var $8134=__stackBase__+60724;
      var $8135=__stackBase__+60728;
      var $8136=__stackBase__+60732;
      var $8137=__stackBase__+60736;
      var $8138=__stackBase__+60740;
      var $8139=__stackBase__+60744;
      var $8140=__stackBase__+60748;
      var $8141=__stackBase__+60812;
      var $8142=__stackBase__+60816;
      var $8143=__stackBase__+60820;
      var $8144=__stackBase__+60824;
      var $8145=__stackBase__+60828;
      var $8146=__stackBase__+60832;
      var $8147=__stackBase__+60836;
      var $8148=__stackBase__+60840;
      var $8149=__stackBase__+60904;
      var $8150=__stackBase__+60908;
      var $8151=__stackBase__+60912;
      var $8152=__stackBase__+60916;
      var $8153=__stackBase__+60920;
      var $8154=__stackBase__+60924;
      var $8155=__stackBase__+60928;
      var $8156=__stackBase__+60932;
      var $8157=__stackBase__+60996;
      var $8158=__stackBase__+61000;
      var $8159=__stackBase__+61004;
      var $8160=__stackBase__+61008;
      var $8161=__stackBase__+61012;
      var $8162=__stackBase__+61016;
      var $8163=__stackBase__+61020;
      var $8164=__stackBase__+61024;
      var $8165=__stackBase__+61088;
      var $8166=__stackBase__+61092;
      var $8167=__stackBase__+61096;
      var $8168=__stackBase__+61100;
      var $8169=__stackBase__+61104;
      var $8170=__stackBase__+61108;
      var $8171=__stackBase__+61112;
      var $8172=__stackBase__+61116;
      var $8173=__stackBase__+61180;
      var $8174=__stackBase__+61184;
      var $8175=__stackBase__+61188;
      var $8176=__stackBase__+61192;
      var $8177=__stackBase__+61196;
      var $8178=__stackBase__+61200;
      var $8179=__stackBase__+61204;
      var $8180=__stackBase__+61208;
      var $8181=__stackBase__+61272;
      var $8182=__stackBase__+61276;
      var $8183=__stackBase__+61280;
      var $8184=__stackBase__+61284;
      var $8185=__stackBase__+61288;
      var $8186=__stackBase__+61292;
      var $8187=__stackBase__+61296;
      var $8188=__stackBase__+61300;
      var $8189=__stackBase__+61364;
      var $8190=__stackBase__+61368;
      var $8191=__stackBase__+61372;
      var $8192=__stackBase__+61376;
      var $8193=__stackBase__+61380;
      var $8194=__stackBase__+61384;
      var $8195=__stackBase__+61388;
      var $8196=__stackBase__+61392;
      var $8197=__stackBase__+61456;
      var $8198=__stackBase__+61460;
      var $8199=__stackBase__+61464;
      var $8200=__stackBase__+61468;
      var $8201=__stackBase__+61472;
      var $8202=__stackBase__+61476;
      var $8203=__stackBase__+61480;
      var $8204=__stackBase__+61484;
      var $8205=__stackBase__+61548;
      var $8206=__stackBase__+61552;
      var $8207=__stackBase__+61556;
      var $8208=__stackBase__+61560;
      var $8209=__stackBase__+61564;
      var $8210=__stackBase__+61568;
      var $8211=__stackBase__+61572;
      var $8212=__stackBase__+61576;
      var $8213=__stackBase__+61640;
      var $8214=__stackBase__+61644;
      var $8215=__stackBase__+61648;
      var $8216=__stackBase__+61652;
      var $8217=__stackBase__+61656;
      var $8218=__stackBase__+61660;
      var $8219=__stackBase__+61664;
      var $8220=__stackBase__+61668;
      var $8221=__stackBase__+61732;
      var $8222=__stackBase__+61736;
      var $8223=__stackBase__+61740;
      var $8224=__stackBase__+61744;
      var $8225=__stackBase__+61748;
      var $8226=__stackBase__+61752;
      var $8227=__stackBase__+61756;
      var $8228=__stackBase__+61760;
      var $8229=__stackBase__+61824;
      var $8230=__stackBase__+61828;
      var $8231=__stackBase__+61832;
      var $8232=__stackBase__+61836;
      var $8233=__stackBase__+61840;
      var $8234=__stackBase__+61844;
      var $8235=__stackBase__+61848;
      var $8236=__stackBase__+61852;
      var $8237=__stackBase__+61916;
      var $8238=__stackBase__+61920;
      var $8239=__stackBase__+61924;
      var $8240=__stackBase__+61928;
      var $8241=__stackBase__+61932;
      var $8242=__stackBase__+61936;
      var $8243=__stackBase__+61940;
      var $8244=__stackBase__+61944;
      var $8245=__stackBase__+62008;
      var $8246=__stackBase__+62012;
      var $8247=__stackBase__+62016;
      var $8248=__stackBase__+62020;
      var $8249=__stackBase__+62024;
      var $8250=__stackBase__+62028;
      var $8251=__stackBase__+62032;
      var $8252=__stackBase__+62036;
      var $8253=__stackBase__+62100;
      var $8254=__stackBase__+62104;
      var $8255=__stackBase__+62108;
      var $8256=__stackBase__+62112;
      var $8257=__stackBase__+62116;
      var $8258=__stackBase__+62120;
      var $8259=__stackBase__+62124;
      var $8260=__stackBase__+62128;
      var $8261=__stackBase__+62192;
      var $8262=__stackBase__+62196;
      var $8263=__stackBase__+62200;
      var $8264=__stackBase__+62204;
      var $8265=__stackBase__+62208;
      var $8266=__stackBase__+62212;
      var $8267=__stackBase__+62216;
      var $8268=__stackBase__+62220;
      var $8269=__stackBase__+62284;
      var $8270=__stackBase__+62288;
      var $8271=__stackBase__+62292;
      var $8272=__stackBase__+62296;
      var $8273=__stackBase__+62300;
      var $8274=__stackBase__+62304;
      var $8275=__stackBase__+62308;
      var $8276=__stackBase__+62312;
      var $8277=__stackBase__+62376;
      var $8278=__stackBase__+62380;
      var $8279=__stackBase__+62384;
      var $8280=__stackBase__+62388;
      var $8281=__stackBase__+62392;
      var $8282=__stackBase__+62396;
      var $8283=__stackBase__+62400;
      var $8284=__stackBase__+62404;
      var $8285=__stackBase__+62468;
      var $8286=__stackBase__+62472;
      var $8287=__stackBase__+62476;
      var $8288=__stackBase__+62480;
      var $8289=__stackBase__+62484;
      var $8290=__stackBase__+62488;
      var $8291=__stackBase__+62492;
      var $8292=__stackBase__+62496;
      var $8293=__stackBase__+62560;
      var $8294=__stackBase__+62564;
      var $8295=__stackBase__+62568;
      var $8296=__stackBase__+62572;
      var $8297=__stackBase__+62576;
      var $8298=__stackBase__+62580;
      var $8299=__stackBase__+62584;
      var $8300=__stackBase__+62588;
      var $8301=__stackBase__+62652;
      var $8302=__stackBase__+62656;
      var $8303=__stackBase__+62660;
      var $8304=__stackBase__+62664;
      var $8305=__stackBase__+62668;
      var $8306=__stackBase__+62672;
      var $8307=__stackBase__+62676;
      var $8308=__stackBase__+62680;
      var $8309=__stackBase__+62744;
      var $8310=__stackBase__+62748;
      var $8311=__stackBase__+62752;
      var $8312=__stackBase__+62756;
      var $8313=__stackBase__+62760;
      var $8314=__stackBase__+62764;
      var $8315=__stackBase__+62768;
      var $8316=__stackBase__+62772;
      var $8317=__stackBase__+62836;
      var $8318=__stackBase__+62840;
      var $8319=__stackBase__+62844;
      var $8320=__stackBase__+62848;
      var $8321=__stackBase__+62852;
      var $8322=__stackBase__+62856;
      var $8323=__stackBase__+62860;
      var $8324=__stackBase__+62864;
      var $8325=__stackBase__+62928;
      var $8326=__stackBase__+62932;
      var $8327=__stackBase__+62936;
      var $8328=__stackBase__+62940;
      var $8329=__stackBase__+62944;
      var $8330=__stackBase__+62948;
      var $8331=__stackBase__+62952;
      var $8332=__stackBase__+62956;
      var $8333=__stackBase__+63020;
      var $8334=__stackBase__+63024;
      var $8335=__stackBase__+63028;
      var $8336=__stackBase__+63032;
      var $8337=__stackBase__+63036;
      var $8338=__stackBase__+63040;
      var $8339=__stackBase__+63044;
      var $8340=__stackBase__+63048;
      var $8341=__stackBase__+63112;
      var $8342=__stackBase__+63116;
      var $8343=__stackBase__+63120;
      var $8344=__stackBase__+63124;
      var $8345=__stackBase__+63128;
      var $8346=__stackBase__+63132;
      var $8347=__stackBase__+63136;
      var $8348=__stackBase__+63140;
      var $8349=__stackBase__+63204;
      var $8350=__stackBase__+63208;
      var $8351=__stackBase__+63212;
      var $8352=__stackBase__+63216;
      var $8353=__stackBase__+63220;
      var $8354=__stackBase__+63224;
      var $8355=__stackBase__+63228;
      var $8356=__stackBase__+63232;
      var $8357=__stackBase__+63296;
      var $8358=__stackBase__+63300;
      var $8359=__stackBase__+63304;
      var $8360=__stackBase__+63308;
      var $8361=__stackBase__+63312;
      var $8362=__stackBase__+63316;
      var $8363=__stackBase__+63320;
      var $8364=__stackBase__+63324;
      var $8365=__stackBase__+63388;
      var $8366=__stackBase__+63392;
      var $8367=__stackBase__+63396;
      var $8368=__stackBase__+63400;
      var $8369=__stackBase__+63404;
      var $8370=__stackBase__+63408;
      var $8371=__stackBase__+63412;
      var $8372=__stackBase__+63416;
      var $8373=__stackBase__+63480;
      var $8374=__stackBase__+63484;
      var $8375=__stackBase__+63488;
      var $8376=__stackBase__+63492;
      var $8377=__stackBase__+63496;
      var $8378=__stackBase__+63500;
      var $8379=__stackBase__+63504;
      var $8380=__stackBase__+63508;
      var $8381=__stackBase__+63572;
      var $8382=__stackBase__+63576;
      var $8383=__stackBase__+63580;
      var $8384=__stackBase__+63584;
      var $8385=__stackBase__+63588;
      var $8386=__stackBase__+63592;
      var $8387=__stackBase__+63596;
      var $8388=__stackBase__+63600;
      var $8389=__stackBase__+63664;
      var $8390=__stackBase__+63668;
      var $8391=__stackBase__+63672;
      var $8392=__stackBase__+63676;
      var $8393=__stackBase__+63680;
      var $8394=__stackBase__+63684;
      var $8395=__stackBase__+63688;
      var $8396=__stackBase__+63692;
      var $8397=__stackBase__+63756;
      var $8398=__stackBase__+63760;
      var $8399=__stackBase__+63764;
      var $8400=__stackBase__+63768;
      var $8401=__stackBase__+63772;
      var $8402=__stackBase__+63776;
      var $8403=__stackBase__+63780;
      var $8404=__stackBase__+63784;
      var $8405=__stackBase__+63848;
      var $8406=__stackBase__+63852;
      var $8407=__stackBase__+63856;
      var $8408=__stackBase__+63860;
      var $8409=__stackBase__+63864;
      var $8410=__stackBase__+63868;
      var $8411=__stackBase__+63872;
      var $8412=__stackBase__+63876;
      var $8413=__stackBase__+63940;
      var $8414=__stackBase__+63944;
      var $8415=__stackBase__+63948;
      var $8416=__stackBase__+63952;
      var $8417=__stackBase__+63956;
      var $8418=__stackBase__+63960;
      var $8419=__stackBase__+63964;
      var $8420=__stackBase__+63968;
      var $8421=__stackBase__+64032;
      var $8422=__stackBase__+64036;
      var $8423=__stackBase__+64040;
      var $8424=__stackBase__+64044;
      var $8425=__stackBase__+64048;
      var $8426=__stackBase__+64052;
      var $8427=__stackBase__+64056;
      var $8428=__stackBase__+64060;
      var $8429=__stackBase__+64124;
      var $8430=__stackBase__+64128;
      var $8431=__stackBase__+64132;
      var $8432=__stackBase__+64136;
      var $8433=__stackBase__+64140;
      var $8434=__stackBase__+64144;
      var $8435=__stackBase__+64148;
      var $8436=__stackBase__+64152;
      var $8437=__stackBase__+64216;
      var $8438=__stackBase__+64220;
      var $8439=__stackBase__+64224;
      var $8440=__stackBase__+64228;
      var $8441=__stackBase__+64232;
      var $8442=__stackBase__+64236;
      var $8443=__stackBase__+64240;
      var $8444=__stackBase__+64244;
      var $8445=__stackBase__+64308;
      var $8446=__stackBase__+64312;
      var $8447=__stackBase__+64316;
      var $8448=__stackBase__+64320;
      var $8449=__stackBase__+64324;
      var $8450=__stackBase__+64328;
      var $8451=__stackBase__+64332;
      var $8452=__stackBase__+64336;
      var $8453=__stackBase__+64400;
      var $8454=__stackBase__+64404;
      var $8455=__stackBase__+64408;
      var $8456=__stackBase__+64412;
      var $8457=__stackBase__+64416;
      var $8458=__stackBase__+64420;
      var $8459=__stackBase__+64424;
      var $8460=__stackBase__+64428;
      var $8461=__stackBase__+64492;
      var $8462=__stackBase__+64496;
      var $8463=__stackBase__+64500;
      var $8464=__stackBase__+64504;
      var $8465=__stackBase__+64508;
      var $8466=__stackBase__+64512;
      var $8467=__stackBase__+64516;
      var $8468=__stackBase__+64520;
      var $8469=__stackBase__+64584;
      var $8470=__stackBase__+64588;
      var $8471=__stackBase__+64592;
      var $8472=__stackBase__+64596;
      var $8473=__stackBase__+64600;
      var $8474=__stackBase__+64604;
      var $8475=__stackBase__+64608;
      var $8476=__stackBase__+64612;
      var $8477=__stackBase__+64676;
      var $8478=__stackBase__+64680;
      var $8479=__stackBase__+64684;
      var $8480=__stackBase__+64688;
      var $8481=__stackBase__+64692;
      var $8482=__stackBase__+64696;
      var $8483=__stackBase__+64700;
      var $8484=__stackBase__+64704;
      var $8485=__stackBase__+64768;
      var $8486=__stackBase__+64772;
      var $8487=__stackBase__+64776;
      var $8488=__stackBase__+64780;
      var $8489=__stackBase__+64784;
      var $8490=__stackBase__+64788;
      var $8491=__stackBase__+64792;
      var $8492=__stackBase__+64796;
      var $8493=__stackBase__+64860;
      var $8494=__stackBase__+64864;
      var $8495=__stackBase__+64868;
      var $8496=__stackBase__+64872;
      var $8497=__stackBase__+64876;
      var $8498=__stackBase__+64880;
      var $8499=__stackBase__+64884;
      var $8500=__stackBase__+64888;
      var $8501=__stackBase__+64952;
      var $8502=__stackBase__+64956;
      var $8503=__stackBase__+64960;
      var $8504=__stackBase__+64964;
      var $8505=__stackBase__+64968;
      var $8506=__stackBase__+64972;
      var $8507=__stackBase__+64976;
      var $8508=__stackBase__+64980;
      var $8509=__stackBase__+65044;
      var $8510=__stackBase__+65048;
      var $8511=__stackBase__+65052;
      var $8512=__stackBase__+65056;
      var $8513=__stackBase__+65060;
      var $8514=__stackBase__+65064;
      var $8515=__stackBase__+65068;
      var $8516=__stackBase__+65072;
      var $8517=__stackBase__+65136;
      var $8518=__stackBase__+65140;
      var $8519=__stackBase__+65144;
      var $8520=__stackBase__+65148;
      var $8521=__stackBase__+65152;
      var $8522=__stackBase__+65156;
      var $8523=__stackBase__+65160;
      var $8524=__stackBase__+65164;
      var $8525=__stackBase__+65228;
      var $8526=__stackBase__+65232;
      var $8527=__stackBase__+65236;
      var $8528=__stackBase__+65240;
      var $8529=__stackBase__+65244;
      var $8530=__stackBase__+65248;
      var $8531=__stackBase__+65252;
      var $8532=__stackBase__+65256;
      var $8533=__stackBase__+65320;
      var $8534=__stackBase__+65324;
      var $8535=__stackBase__+65328;
      var $8536=__stackBase__+65332;
      var $8537=__stackBase__+65336;
      var $8538=__stackBase__+65340;
      var $8539=__stackBase__+65344;
      var $8540=__stackBase__+65348;
      var $8541=__stackBase__+65412;
      var $8542=__stackBase__+65416;
      var $8543=__stackBase__+65420;
      var $8544=__stackBase__+65424;
      var $8545=__stackBase__+65428;
      var $8546=__stackBase__+65432;
      var $8547=__stackBase__+65436;
      var $8548=__stackBase__+65440;
      var $8549=__stackBase__+65504;
      var $8550=__stackBase__+65508;
      var $8551=__stackBase__+65512;
      var $8552=__stackBase__+65516;
      var $8553=__stackBase__+65520;
      var $8554=__stackBase__+65524;
      var $8555=__stackBase__+65528;
      var $8556=__stackBase__+65532;
      var $8557=__stackBase__+65596;
      var $8558=__stackBase__+65600;
      var $8559=__stackBase__+65604;
      var $8560=__stackBase__+65608;
      var $8561=__stackBase__+65612;
      var $8562=__stackBase__+65616;
      var $8563=__stackBase__+65620;
      var $8564=__stackBase__+65624;
      var $8565=__stackBase__+65688;
      var $8566=__stackBase__+65692;
      var $8567=__stackBase__+65696;
      var $8568=__stackBase__+65700;
      var $8569=__stackBase__+65704;
      var $8570=__stackBase__+65708;
      var $8571=__stackBase__+65712;
      var $8572=__stackBase__+65716;
      var $8573=__stackBase__+65780;
      var $8574=__stackBase__+65784;
      var $8575=__stackBase__+65788;
      var $8576=__stackBase__+65792;
      var $8577=__stackBase__+65796;
      var $8578=__stackBase__+65800;
      var $8579=__stackBase__+65804;
      var $8580=__stackBase__+65808;
      var $8581=__stackBase__+65872;
      var $8582=__stackBase__+65876;
      var $8583=__stackBase__+65880;
      var $8584=__stackBase__+65884;
      var $8585=__stackBase__+65888;
      var $8586=__stackBase__+65892;
      var $8587=__stackBase__+65896;
      var $8588=__stackBase__+65900;
      var $8589=__stackBase__+65964;
      var $8590=__stackBase__+65968;
      var $8591=__stackBase__+65972;
      var $8592=__stackBase__+65976;
      var $8593=__stackBase__+65980;
      var $8594=__stackBase__+65984;
      var $8595=__stackBase__+65988;
      var $8596=__stackBase__+65992;
      var $8597=__stackBase__+66056;
      var $8598=__stackBase__+66060;
      var $8599=__stackBase__+66064;
      var $8600=__stackBase__+66068;
      var $8601=__stackBase__+66072;
      var $8602=__stackBase__+66076;
      var $8603=__stackBase__+66080;
      var $8604=__stackBase__+66084;
      var $8605=__stackBase__+66148;
      var $8606=__stackBase__+66152;
      var $8607=__stackBase__+66156;
      var $8608=__stackBase__+66160;
      var $8609=__stackBase__+66164;
      var $8610=__stackBase__+66168;
      var $8611=__stackBase__+66172;
      var $8612=__stackBase__+66176;
      var $8613=__stackBase__+66240;
      var $8614=__stackBase__+66244;
      var $8615=__stackBase__+66248;
      var $8616=__stackBase__+66252;
      var $8617=__stackBase__+66256;
      var $8618=__stackBase__+66260;
      var $8619=__stackBase__+66264;
      var $8620=__stackBase__+66268;
      var $8621=__stackBase__+66332;
      var $8622=__stackBase__+66336;
      var $8623=__stackBase__+66340;
      var $8624=__stackBase__+66344;
      var $8625=__stackBase__+66348;
      var $8626=__stackBase__+66352;
      var $8627=__stackBase__+66356;
      var $8628=__stackBase__+66360;
      var $8629=__stackBase__+66424;
      var $8630=__stackBase__+66428;
      var $8631=__stackBase__+66432;
      var $8632=__stackBase__+66436;
      var $8633=__stackBase__+66440;
      var $8634=__stackBase__+66444;
      var $8635=__stackBase__+66448;
      var $8636=__stackBase__+66452;
      var $8637=__stackBase__+66516;
      var $8638=__stackBase__+66520;
      var $8639=__stackBase__+66524;
      var $8640=__stackBase__+66528;
      var $8641=__stackBase__+66532;
      var $8642=__stackBase__+66536;
      var $8643=__stackBase__+66540;
      var $8644=__stackBase__+66544;
      var $8645=__stackBase__+66608;
      var $8646=__stackBase__+66612;
      var $8647=__stackBase__+66616;
      var $8648=__stackBase__+66620;
      var $8649=__stackBase__+66624;
      var $8650=__stackBase__+66628;
      var $8651=__stackBase__+66632;
      var $8652=__stackBase__+66636;
      var $8653=__stackBase__+66700;
      var $8654=__stackBase__+66704;
      var $8655=__stackBase__+66708;
      var $8656=__stackBase__+66712;
      var $8657=__stackBase__+66716;
      var $8658=__stackBase__+66720;
      var $8659=__stackBase__+66724;
      var $8660=__stackBase__+66728;
      var $8661=__stackBase__+66792;
      var $8662=__stackBase__+66796;
      var $8663=__stackBase__+66800;
      var $8664=__stackBase__+66804;
      var $8665=__stackBase__+66808;
      var $8666=__stackBase__+66812;
      var $8667=__stackBase__+66816;
      var $8668=__stackBase__+66820;
      var $8669=__stackBase__+66884;
      var $8670=__stackBase__+66888;
      var $8671=__stackBase__+66892;
      var $8672=__stackBase__+66896;
      var $8673=__stackBase__+66900;
      var $8674=__stackBase__+66904;
      var $8675=__stackBase__+66908;
      var $8676=__stackBase__+66912;
      var $8677=__stackBase__+66976;
      var $8678=__stackBase__+66980;
      var $8679=__stackBase__+66984;
      var $8680=__stackBase__+66988;
      var $8681=__stackBase__+66992;
      var $8682=__stackBase__+66996;
      var $8683=__stackBase__+67000;
      var $8684=__stackBase__+67004;
      var $8685=__stackBase__+67068;
      var $8686=__stackBase__+67072;
      var $8687=__stackBase__+67076;
      var $8688=__stackBase__+67080;
      var $8689=__stackBase__+67084;
      var $8690=__stackBase__+67088;
      var $8691=__stackBase__+67092;
      var $8692=__stackBase__+67096;
      var $8693=__stackBase__+67160;
      var $8694=__stackBase__+67164;
      var $8695=__stackBase__+67168;
      var $8696=__stackBase__+67172;
      var $8697=__stackBase__+67176;
      var $8698=__stackBase__+67180;
      var $8699=__stackBase__+67184;
      var $8700=__stackBase__+67188;
      var $8701=__stackBase__+67252;
      var $8702=__stackBase__+67256;
      var $8703=__stackBase__+67260;
      var $8704=__stackBase__+67264;
      var $8705=__stackBase__+67268;
      var $8706=__stackBase__+67272;
      var $8707=__stackBase__+67276;
      var $8708=__stackBase__+67280;
      var $8709=__stackBase__+67344;
      var $8710=__stackBase__+67348;
      var $8711=__stackBase__+67352;
      var $8712=__stackBase__+67356;
      var $8713=__stackBase__+67360;
      var $8714=__stackBase__+67364;
      var $8715=__stackBase__+67368;
      var $8716=__stackBase__+67372;
      var $8717=__stackBase__+67436;
      var $8718=__stackBase__+67440;
      var $8719=__stackBase__+67444;
      var $8720=__stackBase__+67448;
      var $8721=__stackBase__+67452;
      var $8722=__stackBase__+67456;
      var $8723=__stackBase__+67460;
      var $8724=__stackBase__+67464;
      var $8725=__stackBase__+67528;
      var $8726=__stackBase__+67532;
      var $8727=__stackBase__+67536;
      var $8728=__stackBase__+67540;
      var $8729=__stackBase__+67544;
      var $8730=__stackBase__+67548;
      var $8731=__stackBase__+67552;
      var $8732=__stackBase__+67556;
      var $8733=__stackBase__+67620;
      var $8734=__stackBase__+67624;
      var $8735=__stackBase__+67628;
      var $8736=__stackBase__+67632;
      var $8737=__stackBase__+67636;
      var $8738=__stackBase__+67640;
      var $8739=__stackBase__+67644;
      var $8740=__stackBase__+67648;
      var $8741=__stackBase__+67712;
      var $8742=__stackBase__+67716;
      var $8743=__stackBase__+67720;
      var $8744=__stackBase__+67724;
      var $8745=__stackBase__+67728;
      var $8746=__stackBase__+67732;
      var $8747=__stackBase__+67736;
      var $8748=__stackBase__+67740;
      var $8749=__stackBase__+67804;
      var $8750=__stackBase__+67808;
      var $8751=__stackBase__+67812;
      var $8752=__stackBase__+67816;
      var $8753=__stackBase__+67820;
      var $8754=__stackBase__+67824;
      var $8755=__stackBase__+67828;
      var $8756=__stackBase__+67832;
      var $8757=__stackBase__+67896;
      var $8758=__stackBase__+67900;
      var $8759=__stackBase__+67904;
      var $8760=__stackBase__+67908;
      var $8761=__stackBase__+67912;
      var $8762=__stackBase__+67916;
      var $8763=__stackBase__+67920;
      var $8764=__stackBase__+67924;
      var $8765=__stackBase__+67988;
      var $8766=__stackBase__+67992;
      var $8767=__stackBase__+67996;
      var $8768=__stackBase__+68000;
      var $8769=__stackBase__+68004;
      var $8770=__stackBase__+68008;
      var $8771=__stackBase__+68012;
      var $8772=__stackBase__+68016;
      var $8773=__stackBase__+68080;
      var $8774=__stackBase__+68084;
      var $8775=__stackBase__+68088;
      var $8776=__stackBase__+68092;
      var $8777=__stackBase__+68096;
      var $8778=__stackBase__+68100;
      var $8779=__stackBase__+68104;
      var $8780=__stackBase__+68108;
      var $8781=__stackBase__+68172;
      var $8782=__stackBase__+68176;
      var $8783=__stackBase__+68180;
      var $8784=__stackBase__+68184;
      var $8785=__stackBase__+68188;
      var $8786=__stackBase__+68192;
      var $8787=__stackBase__+68196;
      var $8788=__stackBase__+68200;
      var $8789=__stackBase__+68264;
      var $8790=__stackBase__+68268;
      var $8791=__stackBase__+68272;
      var $8792=__stackBase__+68276;
      var $8793=__stackBase__+68280;
      var $8794=__stackBase__+68284;
      var $8795=__stackBase__+68288;
      var $8796=__stackBase__+68292;
      var $8797=__stackBase__+68356;
      var $8798=__stackBase__+68360;
      var $8799=__stackBase__+68364;
      var $8800=__stackBase__+68368;
      var $8801=__stackBase__+68372;
      var $8802=__stackBase__+68376;
      var $8803=__stackBase__+68380;
      var $8804=__stackBase__+68384;
      var $8805=__stackBase__+68448;
      var $8806=__stackBase__+68452;
      var $8807=__stackBase__+68456;
      var $8808=__stackBase__+68460;
      var $8809=__stackBase__+68464;
      var $8810=__stackBase__+68468;
      var $8811=__stackBase__+68472;
      var $8812=__stackBase__+68476;
      var $8813=__stackBase__+68540;
      var $8814=__stackBase__+68544;
      var $8815=__stackBase__+68548;
      var $8816=__stackBase__+68552;
      var $8817=__stackBase__+68556;
      var $8818=__stackBase__+68560;
      var $8819=__stackBase__+68564;
      var $8820=__stackBase__+68568;
      var $8821=__stackBase__+68632;
      var $8822=__stackBase__+68636;
      var $8823=__stackBase__+68640;
      var $8824=__stackBase__+68644;
      var $8825=__stackBase__+68648;
      var $8826=__stackBase__+68652;
      var $8827=__stackBase__+68656;
      var $8828=__stackBase__+68660;
      var $8829=__stackBase__+68724;
      var $8830=__stackBase__+68728;
      var $8831=__stackBase__+68732;
      var $8832=__stackBase__+68736;
      var $8833=__stackBase__+68740;
      var $8834=__stackBase__+68744;
      var $8835=__stackBase__+68748;
      var $8836=__stackBase__+68752;
      var $8837=__stackBase__+68816;
      var $8838=__stackBase__+68820;
      var $8839=__stackBase__+68824;
      var $8840=__stackBase__+68828;
      var $8841=__stackBase__+68832;
      var $8842=__stackBase__+68836;
      var $8843=__stackBase__+68840;
      var $8844=__stackBase__+68844;
      var $8845=__stackBase__+68908;
      var $8846=__stackBase__+68912;
      var $8847=__stackBase__+68916;
      var $8848=__stackBase__+68920;
      var $8849=__stackBase__+68924;
      var $8850=__stackBase__+68928;
      var $8851=__stackBase__+68932;
      var $8852=__stackBase__+68936;
      var $8853=__stackBase__+69000;
      var $8854=__stackBase__+69004;
      var $8855=__stackBase__+69008;
      var $8856=__stackBase__+69012;
      var $8857=__stackBase__+69016;
      var $8858=__stackBase__+69020;
      var $8859=__stackBase__+69024;
      var $8860=__stackBase__+69028;
      var $8861=__stackBase__+69092;
      var $8862=__stackBase__+69096;
      var $8863=__stackBase__+69100;
      var $8864=__stackBase__+69104;
      var $8865=__stackBase__+69108;
      var $8866=__stackBase__+69112;
      var $8867=__stackBase__+69116;
      var $8868=__stackBase__+69120;
      var $8869=__stackBase__+69184;
      var $8870=__stackBase__+69188;
      var $8871=__stackBase__+69192;
      var $8872=__stackBase__+69196;
      var $8873=__stackBase__+69200;
      var $8874=__stackBase__+69204;
      var $8875=__stackBase__+69208;
      var $8876=__stackBase__+69212;
      var $8877=__stackBase__+69276;
      var $8878=__stackBase__+69280;
      var $8879=__stackBase__+69284;
      var $8880=__stackBase__+69288;
      var $8881=__stackBase__+69292;
      var $8882=__stackBase__+69296;
      var $8883=__stackBase__+69300;
      var $8884=__stackBase__+69304;
      var $8885=__stackBase__+69368;
      var $8886=__stackBase__+69372;
      var $8887=__stackBase__+69376;
      var $8888=__stackBase__+69380;
      var $8889=__stackBase__+69384;
      var $8890=__stackBase__+69388;
      var $8891=__stackBase__+69392;
      var $8892=__stackBase__+69396;
      var $8893=__stackBase__+69460;
      var $8894=__stackBase__+69464;
      var $8895=__stackBase__+69468;
      var $8896=__stackBase__+69472;
      var $8897=__stackBase__+69476;
      var $8898=__stackBase__+69480;
      var $8899=__stackBase__+69484;
      var $8900=__stackBase__+69488;
      var $8901=__stackBase__+69552;
      var $8902=__stackBase__+69556;
      var $8903=__stackBase__+69560;
      var $8904=__stackBase__+69564;
      var $8905=__stackBase__+69568;
      var $8906=__stackBase__+69572;
      var $8907=__stackBase__+69576;
      var $8908=__stackBase__+69580;
      var $8909=__stackBase__+69644;
      var $8910=__stackBase__+69648;
      var $8911=__stackBase__+69652;
      var $8912=__stackBase__+69656;
      var $8913=__stackBase__+69660;
      var $8914=__stackBase__+69664;
      var $8915=__stackBase__+69668;
      var $8916=__stackBase__+69672;
      var $8917=__stackBase__+69736;
      var $8918=__stackBase__+69740;
      var $8919=__stackBase__+69744;
      var $8920=__stackBase__+69748;
      var $8921=__stackBase__+69752;
      var $8922=__stackBase__+69756;
      var $8923=__stackBase__+69760;
      var $8924=__stackBase__+69764;
      var $8925=__stackBase__+69828;
      var $8926=__stackBase__+69832;
      var $8927=__stackBase__+69836;
      var $8928=__stackBase__+69840;
      var $8929=__stackBase__+69844;
      var $8930=__stackBase__+69848;
      var $8931=__stackBase__+69852;
      var $8932=__stackBase__+69856;
      var $8933=__stackBase__+69920;
      var $8934=__stackBase__+69924;
      var $8935=__stackBase__+69928;
      var $8936=__stackBase__+69932;
      var $8937=__stackBase__+69936;
      var $8938=__stackBase__+69940;
      var $8939=__stackBase__+69944;
      var $8940=__stackBase__+69948;
      var $8941=__stackBase__+70012;
      var $8942=__stackBase__+70016;
      var $8943=__stackBase__+70020;
      var $8944=__stackBase__+70024;
      var $8945=__stackBase__+70028;
      var $8946=__stackBase__+70032;
      var $8947=__stackBase__+70036;
      var $8948=__stackBase__+70040;
      var $8949=__stackBase__+70104;
      var $8950=__stackBase__+70108;
      var $8951=__stackBase__+70112;
      var $8952=__stackBase__+70116;
      var $8953=__stackBase__+70120;
      var $8954=__stackBase__+70124;
      var $8955=__stackBase__+70128;
      var $8956=__stackBase__+70132;
      var $8957=__stackBase__+70196;
      var $8958=__stackBase__+70200;
      var $8959=__stackBase__+70204;
      var $8960=__stackBase__+70208;
      var $8961=__stackBase__+70212;
      var $8962=__stackBase__+70216;
      var $8963=__stackBase__+70220;
      var $8964=__stackBase__+70224;
      var $8965=__stackBase__+70288;
      var $8966=__stackBase__+70292;
      var $8967=__stackBase__+70296;
      var $8968=__stackBase__+70300;
      var $8969=__stackBase__+70304;
      var $8970=__stackBase__+70308;
      var $8971=__stackBase__+70312;
      var $8972=__stackBase__+70316;
      var $8973=__stackBase__+70380;
      var $8974=__stackBase__+70384;
      var $8975=__stackBase__+70388;
      var $8976=__stackBase__+70392;
      var $8977=__stackBase__+70396;
      var $8978=__stackBase__+70400;
      var $8979=__stackBase__+70404;
      var $8980=__stackBase__+70408;
      var $8981=__stackBase__+70472;
      var $8982=__stackBase__+70476;
      var $8983=__stackBase__+70480;
      var $8984=__stackBase__+70484;
      var $8985=__stackBase__+70488;
      var $8986=__stackBase__+70492;
      var $8987=__stackBase__+70496;
      var $8988=__stackBase__+70500;
      var $8989=__stackBase__+70564;
      var $8990=__stackBase__+70568;
      var $8991=__stackBase__+70572;
      var $8992=__stackBase__+70576;
      var $8993=__stackBase__+70580;
      var $8994=__stackBase__+70584;
      var $8995=__stackBase__+70588;
      var $8996=__stackBase__+70592;
      var $8997=__stackBase__+70656;
      var $8998=__stackBase__+70660;
      var $8999=__stackBase__+70664;
      var $9000=__stackBase__+70668;
      var $9001=__stackBase__+70672;
      var $9002=__stackBase__+70676;
      var $9003=__stackBase__+70680;
      var $9004=__stackBase__+70684;
      var $9005=__stackBase__+70748;
      var $9006=__stackBase__+70752;
      var $9007=__stackBase__+70756;
      var $9008=__stackBase__+70760;
      var $9009=__stackBase__+70764;
      var $9010=__stackBase__+70768;
      var $9011=__stackBase__+70772;
      var $9012=__stackBase__+70776;
      var $9013=__stackBase__+70840;
      var $9014=__stackBase__+70844;
      var $9015=__stackBase__+70848;
      var $9016=__stackBase__+70852;
      var $9017=__stackBase__+70856;
      var $9018=__stackBase__+70860;
      var $9019=__stackBase__+70864;
      var $9020=__stackBase__+70868;
      var $9021=__stackBase__+70932;
      var $9022=__stackBase__+70936;
      var $9023=__stackBase__+70940;
      var $9024=__stackBase__+70944;
      var $9025=__stackBase__+70948;
      var $9026=__stackBase__+70952;
      var $9027=__stackBase__+70956;
      var $9028=__stackBase__+70960;
      var $9029=__stackBase__+71024;
      var $9030=__stackBase__+71028;
      var $9031=__stackBase__+71032;
      var $9032=__stackBase__+71036;
      var $9033=__stackBase__+71040;
      var $9034=__stackBase__+71044;
      var $9035=__stackBase__+71048;
      var $9036=__stackBase__+71052;
      var $9037=__stackBase__+71116;
      var $9038=__stackBase__+71120;
      var $9039=__stackBase__+71124;
      var $9040=__stackBase__+71128;
      var $9041=__stackBase__+71132;
      var $9042=__stackBase__+71136;
      var $9043=__stackBase__+71140;
      var $9044=__stackBase__+71144;
      var $9045=__stackBase__+71208;
      var $9046=__stackBase__+71212;
      var $9047=__stackBase__+71216;
      var $9048=__stackBase__+71220;
      var $9049=__stackBase__+71224;
      var $9050=__stackBase__+71228;
      var $9051=__stackBase__+71232;
      var $9052=__stackBase__+71236;
      var $9053=__stackBase__+71300;
      var $9054=__stackBase__+71304;
      var $9055=__stackBase__+71308;
      var $9056=__stackBase__+71312;
      var $9057=__stackBase__+71316;
      var $9058=__stackBase__+71320;
      var $9059=__stackBase__+71324;
      var $9060=__stackBase__+71328;
      var $9061=__stackBase__+71392;
      var $9062=__stackBase__+71396;
      var $9063=__stackBase__+71400;
      var $9064=__stackBase__+71404;
      var $9065=__stackBase__+71408;
      var $9066=__stackBase__+71412;
      var $9067=__stackBase__+71416;
      var $9068=__stackBase__+71420;
      var $9069=__stackBase__+71484;
      var $9070=__stackBase__+71488;
      var $9071=__stackBase__+71492;
      var $9072=__stackBase__+71496;
      var $9073=__stackBase__+71500;
      var $9074=__stackBase__+71504;
      var $9075=__stackBase__+71508;
      var $9076=__stackBase__+71512;
      var $9077=__stackBase__+71576;
      var $9078=__stackBase__+71580;
      var $9079=__stackBase__+71584;
      var $9080=__stackBase__+71588;
      var $9081=__stackBase__+71592;
      var $9082=__stackBase__+71596;
      var $9083=__stackBase__+71600;
      var $9084=__stackBase__+71604;
      var $9085=__stackBase__+71668;
      var $9086=__stackBase__+71672;
      var $9087=__stackBase__+71676;
      var $9088=__stackBase__+71680;
      var $9089=__stackBase__+71684;
      var $9090=__stackBase__+71688;
      var $9091=__stackBase__+71692;
      var $9092=__stackBase__+71696;
      var $9093=__stackBase__+71760;
      var $9094=__stackBase__+71764;
      var $9095=__stackBase__+71768;
      var $9096=__stackBase__+71772;
      var $9097=__stackBase__+71776;
      var $9098=__stackBase__+71780;
      var $9099=__stackBase__+71784;
      var $9100=__stackBase__+71788;
      var $9101=__stackBase__+71852;
      var $9102=__stackBase__+71856;
      var $9103=__stackBase__+71860;
      var $9104=__stackBase__+71864;
      var $9105=__stackBase__+71868;
      var $9106=__stackBase__+71872;
      var $9107=__stackBase__+71876;
      var $9108=__stackBase__+71880;
      var $9109=__stackBase__+71944;
      var $9110=__stackBase__+71948;
      var $9111=__stackBase__+71952;
      var $9112=__stackBase__+71956;
      var $9113=__stackBase__+71960;
      var $9114=__stackBase__+71964;
      var $9115=__stackBase__+71968;
      var $9116=__stackBase__+71972;
      var $9117=__stackBase__+72036;
      var $9118=__stackBase__+72040;
      var $9119=__stackBase__+72044;
      var $9120=__stackBase__+72048;
      var $9121=__stackBase__+72052;
      var $9122=__stackBase__+72056;
      var $9123=__stackBase__+72060;
      var $9124=__stackBase__+72064;
      var $9125=__stackBase__+72128;
      var $9126=__stackBase__+72132;
      var $9127=__stackBase__+72136;
      var $9128=__stackBase__+72140;
      var $9129=__stackBase__+72144;
      var $9130=__stackBase__+72148;
      var $9131=__stackBase__+72152;
      var $9132=__stackBase__+72156;
      var $9133=__stackBase__+72220;
      var $9134=__stackBase__+72224;
      var $9135=__stackBase__+72228;
      var $9136=__stackBase__+72232;
      var $9137=__stackBase__+72236;
      var $9138=__stackBase__+72240;
      var $9139=__stackBase__+72244;
      var $9140=__stackBase__+72248;
      var $9141=__stackBase__+72312;
      var $9142=__stackBase__+72316;
      var $9143=__stackBase__+72320;
      var $9144=__stackBase__+72324;
      var $9145=__stackBase__+72328;
      var $9146=__stackBase__+72332;
      var $9147=__stackBase__+72336;
      var $9148=__stackBase__+72340;
      var $9149=__stackBase__+72404;
      var $9150=__stackBase__+72408;
      var $9151=__stackBase__+72412;
      var $9152=__stackBase__+72416;
      var $9153=__stackBase__+72420;
      var $9154=__stackBase__+72424;
      var $9155=__stackBase__+72428;
      var $9156=__stackBase__+72432;
      var $9157=__stackBase__+72496;
      var $9158=__stackBase__+72500;
      var $9159=__stackBase__+72504;
      var $9160=__stackBase__+72508;
      var $9161=__stackBase__+72512;
      var $9162=__stackBase__+72516;
      var $9163=__stackBase__+72520;
      var $9164=__stackBase__+72524;
      var $9165=__stackBase__+72588;
      var $9166=__stackBase__+72592;
      var $9167=__stackBase__+72596;
      var $9168=__stackBase__+72600;
      var $9169=__stackBase__+72604;
      var $9170=__stackBase__+72608;
      var $9171=__stackBase__+72612;
      var $9172=__stackBase__+72616;
      var $9173=__stackBase__+72680;
      var $9174=__stackBase__+72684;
      var $9175=__stackBase__+72688;
      var $9176=__stackBase__+72692;
      var $9177=__stackBase__+72696;
      var $9178=__stackBase__+72700;
      var $9179=__stackBase__+72704;
      var $9180=__stackBase__+72708;
      var $9181=__stackBase__+72772;
      var $9182=__stackBase__+72776;
      var $9183=__stackBase__+72780;
      var $9184=__stackBase__+72784;
      var $9185=__stackBase__+72788;
      var $9186=__stackBase__+72792;
      var $9187=__stackBase__+72796;
      var $9188=__stackBase__+72800;
      var $9189=__stackBase__+72864;
      var $9190=__stackBase__+72868;
      var $9191=__stackBase__+72872;
      var $9192=__stackBase__+72876;
      var $9193=__stackBase__+72880;
      var $9194=__stackBase__+72884;
      var $9195=__stackBase__+72888;
      var $9196=__stackBase__+72892;
      var $9197=__stackBase__+72956;
      var $9198=__stackBase__+72960;
      var $9199=__stackBase__+72964;
      var $9200=__stackBase__+72968;
      var $9201=__stackBase__+72972;
      var $9202=__stackBase__+72976;
      var $9203=__stackBase__+72980;
      var $9204=__stackBase__+72984;
      var $9205=__stackBase__+73048;
      var $9206=__stackBase__+73052;
      var $9207=__stackBase__+73056;
      var $9208=__stackBase__+73060;
      var $9209=__stackBase__+73064;
      var $9210=__stackBase__+73068;
      var $9211=__stackBase__+73072;
      var $9212=__stackBase__+73076;
      var $9213=__stackBase__+73140;
      var $9214=__stackBase__+73144;
      var $9215=__stackBase__+73148;
      var $9216=__stackBase__+73152;
      var $9217=__stackBase__+73156;
      var $9218=__stackBase__+73160;
      var $9219=__stackBase__+73164;
      var $9220=__stackBase__+73168;
      var $9221=__stackBase__+73232;
      var $9222=__stackBase__+73236;
      var $9223=__stackBase__+73240;
      var $9224=__stackBase__+73244;
      var $9225=__stackBase__+73248;
      var $9226=__stackBase__+73252;
      var $9227=__stackBase__+73256;
      var $9228=__stackBase__+73260;
      var $9229=__stackBase__+73324;
      var $9230=__stackBase__+73328;
      var $9231=__stackBase__+73332;
      var $9232=__stackBase__+73336;
      var $9233=__stackBase__+73340;
      var $9234=__stackBase__+73344;
      var $9235=__stackBase__+73348;
      var $9236=__stackBase__+73352;
      var $9237=__stackBase__+73416;
      var $9238=__stackBase__+73420;
      var $9239=__stackBase__+73424;
      var $9240=__stackBase__+73428;
      var $9241=__stackBase__+73432;
      var $9242=__stackBase__+73436;
      var $9243=__stackBase__+73440;
      var $9244=__stackBase__+73444;
      var $9245=__stackBase__+73508;
      var $9246=__stackBase__+73512;
      var $9247=__stackBase__+73516;
      var $9248=__stackBase__+73520;
      var $9249=__stackBase__+73524;
      var $9250=__stackBase__+73528;
      var $9251=__stackBase__+73532;
      var $9252=__stackBase__+73536;
      var $9253=__stackBase__+73600;
      var $9254=__stackBase__+73604;
      var $9255=__stackBase__+73608;
      var $9256=__stackBase__+73612;
      var $9257=__stackBase__+73616;
      var $9258=__stackBase__+73620;
      var $9259=__stackBase__+73624;
      var $9260=__stackBase__+73628;
      var $9261=__stackBase__+73692;
      var $9262=__stackBase__+73696;
      var $9263=__stackBase__+73700;
      var $9264=__stackBase__+73704;
      var $9265=__stackBase__+73708;
      var $9266=__stackBase__+73712;
      var $9267=__stackBase__+73716;
      var $9268=__stackBase__+73720;
      var $9269=__stackBase__+73784;
      var $9270=__stackBase__+73788;
      var $9271=__stackBase__+73792;
      var $9272=__stackBase__+73796;
      var $9273=__stackBase__+73800;
      var $9274=__stackBase__+73804;
      var $9275=__stackBase__+73808;
      var $9276=__stackBase__+73812;
      var $9277=__stackBase__+73876;
      var $9278=__stackBase__+73880;
      var $9279=__stackBase__+73884;
      var $9280=__stackBase__+73888;
      var $9281=__stackBase__+73892;
      var $9282=__stackBase__+73896;
      var $9283=__stackBase__+73900;
      var $9284=__stackBase__+73904;
      var $9285=__stackBase__+73968;
      var $9286=__stackBase__+73972;
      var $9287=__stackBase__+73976;
      var $9288=__stackBase__+73980;
      var $9289=__stackBase__+73984;
      var $9290=__stackBase__+73988;
      var $9291=__stackBase__+73992;
      var $9292=__stackBase__+73996;
      var $9293=__stackBase__+74060;
      var $9294=__stackBase__+74064;
      var $9295=__stackBase__+74068;
      var $9296=__stackBase__+74072;
      var $9297=__stackBase__+74076;
      var $9298=__stackBase__+74080;
      var $9299=__stackBase__+74084;
      var $9300=__stackBase__+74088;
      var $9301=__stackBase__+74152;
      var $9302=__stackBase__+74156;
      var $9303=__stackBase__+74160;
      var $9304=__stackBase__+74164;
      var $9305=__stackBase__+74168;
      var $9306=__stackBase__+74172;
      var $9307=__stackBase__+74176;
      var $9308=__stackBase__+74180;
      var $9309=__stackBase__+74244;
      var $9310=__stackBase__+74248;
      var $9311=__stackBase__+74252;
      var $9312=__stackBase__+74256;
      var $9313=__stackBase__+74260;
      var $9314=__stackBase__+74264;
      var $9315=__stackBase__+74268;
      var $9316=__stackBase__+74272;
      var $9317=__stackBase__+74336;
      var $9318=__stackBase__+74340;
      var $9319=__stackBase__+74344;
      var $9320=__stackBase__+74348;
      var $9321=__stackBase__+74352;
      var $9322=__stackBase__+74356;
      var $9323=__stackBase__+74360;
      var $9324=__stackBase__+74364;
      var $9325=__stackBase__+74428;
      var $9326=__stackBase__+74432;
      var $9327=__stackBase__+74436;
      var $9328=__stackBase__+74440;
      var $9329=__stackBase__+74444;
      var $9330=__stackBase__+74448;
      var $9331=__stackBase__+74452;
      var $9332=__stackBase__+74456;
      var $9333=__stackBase__+74520;
      var $9334=__stackBase__+74524;
      var $9335=__stackBase__+74528;
      var $9336=__stackBase__+74532;
      var $9337=__stackBase__+74536;
      var $9338=__stackBase__+74540;
      var $9339=__stackBase__+74544;
      var $9340=__stackBase__+74548;
      var $9341=__stackBase__+74612;
      var $9342=__stackBase__+74616;
      var $9343=__stackBase__+74620;
      var $9344=__stackBase__+74624;
      var $9345=__stackBase__+74628;
      var $9346=__stackBase__+74632;
      var $9347=__stackBase__+74636;
      var $9348=__stackBase__+74640;
      var $9349=__stackBase__+74704;
      var $9350=__stackBase__+74708;
      var $9351=__stackBase__+74712;
      var $9352=__stackBase__+74716;
      var $9353=__stackBase__+74720;
      var $9354=__stackBase__+74724;
      var $9355=__stackBase__+74728;
      var $9356=__stackBase__+74732;
      var $9357=__stackBase__+74796;
      var $9358=__stackBase__+74800;
      var $9359=__stackBase__+74804;
      var $9360=__stackBase__+74808;
      var $9361=__stackBase__+74812;
      var $9362=__stackBase__+74816;
      var $9363=__stackBase__+74820;
      var $9364=__stackBase__+74824;
      var $9365=__stackBase__+74888;
      var $9366=__stackBase__+74892;
      var $9367=__stackBase__+74896;
      var $9368=__stackBase__+74900;
      var $9369=__stackBase__+74904;
      var $9370=__stackBase__+74908;
      var $9371=__stackBase__+74912;
      var $9372=__stackBase__+74916;
      var $9373=__stackBase__+74980;
      var $9374=__stackBase__+74984;
      var $9375=__stackBase__+74988;
      var $9376=__stackBase__+74992;
      var $9377=__stackBase__+74996;
      var $9378=__stackBase__+75000;
      var $9379=__stackBase__+75004;
      var $9380=__stackBase__+75008;
      var $9381=__stackBase__+75072;
      var $9382=__stackBase__+75076;
      var $9383=__stackBase__+75080;
      var $9384=__stackBase__+75084;
      var $9385=__stackBase__+75088;
      var $9386=__stackBase__+75092;
      var $9387=__stackBase__+75096;
      var $9388=__stackBase__+75100;
      var $9389=__stackBase__+75164;
      var $9390=__stackBase__+75168;
      var $9391=__stackBase__+75172;
      var $9392=__stackBase__+75176;
      var $9393=__stackBase__+75180;
      var $9394=__stackBase__+75184;
      var $9395=__stackBase__+75188;
      var $9396=__stackBase__+75192;
      var $9397=__stackBase__+75256;
      var $9398=__stackBase__+75260;
      var $9399=__stackBase__+75264;
      var $9400=__stackBase__+75268;
      var $9401=__stackBase__+75272;
      var $9402=__stackBase__+75276;
      var $9403=__stackBase__+75280;
      var $9404=__stackBase__+75284;
      var $9405=__stackBase__+75348;
      var $9406=__stackBase__+75352;
      var $9407=__stackBase__+75356;
      var $9408=__stackBase__+75360;
      var $9409=__stackBase__+75364;
      var $9410=__stackBase__+75368;
      var $9411=__stackBase__+75372;
      var $9412=__stackBase__+75376;
      var $9413=__stackBase__+75440;
      var $9414=__stackBase__+75444;
      var $9415=__stackBase__+75448;
      var $9416=__stackBase__+75452;
      var $9417=__stackBase__+75456;
      var $9418=__stackBase__+75460;
      var $9419=__stackBase__+75464;
      var $9420=__stackBase__+75468;
      var $9421=__stackBase__+75532;
      var $9422=__stackBase__+75536;
      var $9423=__stackBase__+75540;
      var $9424=__stackBase__+75544;
      var $9425=__stackBase__+75548;
      var $9426=__stackBase__+75552;
      var $9427=__stackBase__+75556;
      var $9428=__stackBase__+75560;
      var $9429=__stackBase__+75624;
      var $9430=__stackBase__+75628;
      var $9431=__stackBase__+75632;
      var $9432=__stackBase__+75636;
      var $9433=__stackBase__+75640;
      var $9434=__stackBase__+75644;
      var $9435=__stackBase__+75648;
      var $9436=__stackBase__+75652;
      var $9437=__stackBase__+75716;
      var $9438=__stackBase__+75720;
      var $9439=__stackBase__+75724;
      var $9440=__stackBase__+75728;
      var $9441=__stackBase__+75732;
      var $9442=__stackBase__+75736;
      var $9443=__stackBase__+75740;
      var $9444=__stackBase__+75744;
      var $9445=__stackBase__+75808;
      var $9446=__stackBase__+75812;
      var $9447=__stackBase__+75816;
      var $9448=__stackBase__+75820;
      var $9449=__stackBase__+75824;
      var $9450=__stackBase__+75828;
      var $9451=__stackBase__+75832;
      var $9452=__stackBase__+75836;
      var $9453=__stackBase__+75900;
      var $9454=__stackBase__+75904;
      var $9455=__stackBase__+75908;
      var $9456=__stackBase__+75912;
      var $9457=__stackBase__+75916;
      var $9458=__stackBase__+75920;
      var $9459=__stackBase__+75924;
      var $9460=__stackBase__+75928;
      var $9461=__stackBase__+75992;
      var $9462=__stackBase__+75996;
      var $9463=__stackBase__+76000;
      var $9464=__stackBase__+76004;
      var $9465=__stackBase__+76008;
      var $9466=__stackBase__+76012;
      var $9467=__stackBase__+76016;
      var $9468=__stackBase__+76020;
      var $9469=__stackBase__+76084;
      var $9470=__stackBase__+76088;
      var $9471=__stackBase__+76092;
      var $9472=__stackBase__+76096;
      var $9473=__stackBase__+76100;
      var $9474=__stackBase__+76104;
      var $9475=__stackBase__+76108;
      var $9476=__stackBase__+76112;
      var $9477=__stackBase__+76176;
      var $9478=__stackBase__+76180;
      var $9479=__stackBase__+76184;
      var $9480=__stackBase__+76188;
      var $9481=__stackBase__+76192;
      var $9482=__stackBase__+76196;
      var $9483=__stackBase__+76200;
      var $9484=__stackBase__+76204;
      var $9485=__stackBase__+76268;
      var $9486=__stackBase__+76272;
      var $9487=__stackBase__+76276;
      var $9488=__stackBase__+76280;
      var $9489=__stackBase__+76284;
      var $9490=__stackBase__+76288;
      var $9491=__stackBase__+76292;
      var $9492=__stackBase__+76296;
      var $9493=__stackBase__+76360;
      var $9494=__stackBase__+76364;
      var $9495=__stackBase__+76368;
      var $9496=__stackBase__+76372;
      var $9497=__stackBase__+76376;
      var $9498=__stackBase__+76380;
      var $9499=__stackBase__+76384;
      var $9500=__stackBase__+76388;
      var $9501=__stackBase__+76452;
      var $9502=__stackBase__+76456;
      var $9503=__stackBase__+76460;
      var $9504=__stackBase__+76464;
      var $9505=__stackBase__+76468;
      var $9506=__stackBase__+76472;
      var $9507=__stackBase__+76476;
      var $9508=__stackBase__+76480;
      var $9509=__stackBase__+76544;
      var $9510=__stackBase__+76548;
      var $9511=__stackBase__+76552;
      var $9512=__stackBase__+76556;
      var $9513=__stackBase__+76560;
      var $9514=__stackBase__+76564;
      var $9515=__stackBase__+76568;
      var $9516=__stackBase__+76572;
      var $9517=__stackBase__+76636;
      var $9518=__stackBase__+76640;
      var $9519=__stackBase__+76644;
      var $9520=__stackBase__+76648;
      var $9521=__stackBase__+76652;
      var $9522=__stackBase__+76656;
      var $9523=__stackBase__+76660;
      var $9524=__stackBase__+76664;
      var $9525=__stackBase__+76728;
      var $9526=__stackBase__+76732;
      var $9527=__stackBase__+76736;
      var $9528=__stackBase__+76740;
      var $9529=__stackBase__+76744;
      var $9530=__stackBase__+76748;
      var $9531=__stackBase__+76752;
      var $9532=__stackBase__+76756;
      var $9533=__stackBase__+76820;
      var $9534=__stackBase__+76824;
      var $9535=__stackBase__+76828;
      var $9536=__stackBase__+76832;
      var $9537=__stackBase__+76836;
      var $9538=__stackBase__+76840;
      var $9539=__stackBase__+76844;
      var $9540=__stackBase__+76848;
      var $9541=__stackBase__+76912;
      var $9542=__stackBase__+76916;
      var $9543=__stackBase__+76920;
      var $9544=__stackBase__+76924;
      var $9545=__stackBase__+76928;
      var $9546=__stackBase__+76932;
      var $9547=__stackBase__+76936;
      var $9548=__stackBase__+76940;
      var $9549=__stackBase__+77004;
      var $9550=__stackBase__+77008;
      var $9551=__stackBase__+77012;
      var $9552=__stackBase__+77016;
      var $9553=__stackBase__+77020;
      var $9554=__stackBase__+77024;
      var $9555=__stackBase__+77028;
      var $9556=__stackBase__+77032;
      var $9557=__stackBase__+77096;
      var $9558=__stackBase__+77100;
      var $9559=__stackBase__+77104;
      var $9560=__stackBase__+77108;
      var $9561=__stackBase__+77112;
      var $9562=__stackBase__+77116;
      var $9563=__stackBase__+77120;
      var $9564=__stackBase__+77124;
      var $9565=__stackBase__+77188;
      var $9566=__stackBase__+77192;
      var $9567=__stackBase__+77196;
      var $9568=__stackBase__+77200;
      var $9569=__stackBase__+77204;
      var $9570=__stackBase__+77208;
      var $9571=__stackBase__+77212;
      var $9572=__stackBase__+77216;
      var $9573=__stackBase__+77280;
      var $9574=__stackBase__+77284;
      var $9575=__stackBase__+77288;
      var $9576=__stackBase__+77292;
      var $9577=__stackBase__+77296;
      var $9578=__stackBase__+77300;
      var $9579=__stackBase__+77304;
      var $9580=__stackBase__+77308;
      var $9581=__stackBase__+77372;
      var $9582=__stackBase__+77376;
      var $9583=__stackBase__+77380;
      var $9584=__stackBase__+77384;
      var $9585=__stackBase__+77388;
      var $9586=__stackBase__+77392;
      var $9587=__stackBase__+77396;
      var $9588=__stackBase__+77400;
      var $9589=__stackBase__+77464;
      var $9590=__stackBase__+77468;
      var $9591=__stackBase__+77472;
      var $9592=__stackBase__+77476;
      var $9593=__stackBase__+77480;
      var $9594=__stackBase__+77484;
      var $9595=__stackBase__+77488;
      var $9596=__stackBase__+77492;
      var $9597=__stackBase__+77556;
      var $9598=__stackBase__+77560;
      var $9599=__stackBase__+77564;
      var $9600=__stackBase__+77568;
      var $9601=__stackBase__+77572;
      var $9602=__stackBase__+77576;
      var $9603=__stackBase__+77580;
      var $9604=__stackBase__+77584;
      var $9605=__stackBase__+77648;
      var $9606=__stackBase__+77652;
      var $9607=__stackBase__+77656;
      var $9608=__stackBase__+77660;
      var $9609=__stackBase__+77664;
      var $9610=__stackBase__+77668;
      var $9611=__stackBase__+77672;
      var $9612=__stackBase__+77676;
      var $9613=__stackBase__+77740;
      var $9614=__stackBase__+77744;
      var $9615=__stackBase__+77748;
      var $9616=__stackBase__+77752;
      var $9617=__stackBase__+77756;
      var $9618=__stackBase__+77760;
      var $9619=__stackBase__+77764;
      var $9620=__stackBase__+77768;
      var $9621=__stackBase__+77832;
      var $9622=__stackBase__+77836;
      var $9623=__stackBase__+77840;
      var $9624=__stackBase__+77844;
      var $9625=__stackBase__+77848;
      var $9626=__stackBase__+77852;
      var $9627=__stackBase__+77856;
      var $9628=__stackBase__+77860;
      var $9629=__stackBase__+77924;
      var $9630=__stackBase__+77928;
      var $9631=__stackBase__+77932;
      var $9632=__stackBase__+77936;
      var $9633=__stackBase__+77940;
      var $9634=__stackBase__+77944;
      var $9635=__stackBase__+77948;
      var $9636=__stackBase__+77952;
      var $9637=__stackBase__+78016;
      var $9638=__stackBase__+78020;
      var $9639=__stackBase__+78024;
      var $9640=__stackBase__+78028;
      var $9641=__stackBase__+78032;
      var $9642=__stackBase__+78036;
      var $9643=__stackBase__+78040;
      var $9644=__stackBase__+78044;
      var $9645=__stackBase__+78108;
      var $9646=__stackBase__+78112;
      var $9647=__stackBase__+78116;
      var $9648=__stackBase__+78120;
      var $9649=__stackBase__+78124;
      var $9650=__stackBase__+78128;
      var $9651=__stackBase__+78132;
      var $9652=__stackBase__+78136;
      var $9653=__stackBase__+78200;
      var $9654=__stackBase__+78204;
      var $9655=__stackBase__+78208;
      var $9656=__stackBase__+78212;
      var $9657=__stackBase__+78216;
      var $9658=__stackBase__+78220;
      var $9659=__stackBase__+78224;
      var $9660=__stackBase__+78228;
      var $9661=__stackBase__+78292;
      var $9662=__stackBase__+78296;
      var $9663=__stackBase__+78300;
      var $9664=__stackBase__+78304;
      var $9665=__stackBase__+78308;
      var $9666=__stackBase__+78312;
      var $9667=__stackBase__+78316;
      var $9668=__stackBase__+78320;
      var $9669=__stackBase__+78384;
      var $9670=__stackBase__+78388;
      var $9671=__stackBase__+78392;
      var $9672=__stackBase__+78396;
      var $9673=__stackBase__+78400;
      var $9674=__stackBase__+78404;
      var $9675=__stackBase__+78408;
      var $9676=__stackBase__+78412;
      var $9677=__stackBase__+78476;
      var $9678=__stackBase__+78480;
      var $9679=__stackBase__+78484;
      var $9680=__stackBase__+78488;
      var $9681=__stackBase__+78492;
      var $9682=__stackBase__+78496;
      var $9683=__stackBase__+78500;
      var $9684=__stackBase__+78504;
      var $9685=__stackBase__+78568;
      var $9686=__stackBase__+78572;
      var $9687=__stackBase__+78576;
      var $9688=__stackBase__+78580;
      var $9689=__stackBase__+78584;
      var $9690=__stackBase__+78588;
      var $9691=__stackBase__+78592;
      var $9692=__stackBase__+78596;
      var $9693=__stackBase__+78660;
      var $9694=__stackBase__+78664;
      var $9695=__stackBase__+78668;
      var $9696=__stackBase__+78672;
      var $9697=__stackBase__+78676;
      var $9698=__stackBase__+78680;
      var $9699=__stackBase__+78684;
      var $9700=__stackBase__+78688;
      var $9701=__stackBase__+78752;
      var $9702=__stackBase__+78756;
      var $9703=__stackBase__+78760;
      var $9704=__stackBase__+78764;
      var $9705=__stackBase__+78768;
      var $9706=__stackBase__+78772;
      var $9707=__stackBase__+78776;
      var $9708=__stackBase__+78780;
      var $9709=__stackBase__+78844;
      var $9710=__stackBase__+78848;
      var $9711=__stackBase__+78852;
      var $9712=__stackBase__+78856;
      var $9713=__stackBase__+78860;
      var $9714=__stackBase__+78864;
      var $9715=__stackBase__+78868;
      var $9716=__stackBase__+78872;
      var $9717=__stackBase__+78936;
      var $9718=__stackBase__+78940;
      var $9719=__stackBase__+78944;
      var $9720=__stackBase__+78948;
      var $9721=__stackBase__+78952;
      var $9722=__stackBase__+78956;
      var $9723=__stackBase__+78960;
      var $9724=__stackBase__+78964;
      var $9725=__stackBase__+79028;
      var $9726=__stackBase__+79032;
      var $9727=__stackBase__+79036;
      var $9728=__stackBase__+79040;
      var $9729=__stackBase__+79044;
      var $9730=__stackBase__+79048;
      var $9731=__stackBase__+79052;
      var $9732=__stackBase__+79056;
      var $9733=__stackBase__+79120;
      var $9734=__stackBase__+79124;
      var $9735=__stackBase__+79128;
      var $9736=__stackBase__+79132;
      var $9737=__stackBase__+79136;
      var $9738=__stackBase__+79140;
      var $9739=__stackBase__+79144;
      var $9740=__stackBase__+79148;
      var $9741=__stackBase__+79212;
      var $9742=__stackBase__+79216;
      var $9743=__stackBase__+79220;
      var $9744=__stackBase__+79224;
      var $9745=__stackBase__+79228;
      var $9746=__stackBase__+79232;
      var $9747=__stackBase__+79236;
      var $9748=__stackBase__+79240;
      var $9749=__stackBase__+79304;
      var $9750=__stackBase__+79308;
      var $9751=__stackBase__+79312;
      var $9752=__stackBase__+79316;
      var $9753=__stackBase__+79320;
      var $9754=__stackBase__+79324;
      var $9755=__stackBase__+79328;
      var $9756=__stackBase__+79332;
      var $9757=__stackBase__+79396;
      var $9758=__stackBase__+79400;
      var $9759=__stackBase__+79404;
      var $9760=__stackBase__+79408;
      var $9761=__stackBase__+79412;
      var $9762=__stackBase__+79416;
      var $9763=__stackBase__+79420;
      var $9764=__stackBase__+79424;
      var $9765=__stackBase__+79488;
      var $9766=__stackBase__+79492;
      var $9767=__stackBase__+79496;
      var $9768=__stackBase__+79500;
      var $9769=__stackBase__+79504;
      var $9770=__stackBase__+79508;
      var $9771=__stackBase__+79512;
      var $9772=__stackBase__+79516;
      var $9773=__stackBase__+79580;
      var $9774=__stackBase__+79584;
      var $9775=__stackBase__+79588;
      var $9776=__stackBase__+79592;
      var $9777=__stackBase__+79596;
      var $9778=__stackBase__+79600;
      var $9779=__stackBase__+79604;
      var $9780=__stackBase__+79608;
      var $9781=__stackBase__+79672;
      var $9782=__stackBase__+79676;
      var $9783=__stackBase__+79680;
      var $9784=__stackBase__+79684;
      var $9785=__stackBase__+79688;
      var $9786=__stackBase__+79692;
      var $9787=__stackBase__+79696;
      var $9788=__stackBase__+79700;
      var $9789=__stackBase__+79764;
      var $9790=__stackBase__+79768;
      var $9791=__stackBase__+79772;
      var $9792=__stackBase__+79776;
      var $9793=__stackBase__+79780;
      var $9794=__stackBase__+79784;
      var $9795=__stackBase__+79788;
      var $9796=__stackBase__+79792;
      var $9797=__stackBase__+79856;
      var $9798=__stackBase__+79860;
      var $9799=__stackBase__+79864;
      var $9800=__stackBase__+79868;
      var $9801=__stackBase__+79872;
      var $9802=__stackBase__+79876;
      var $9803=__stackBase__+79880;
      var $9804=__stackBase__+79884;
      var $9805=__stackBase__+79948;
      var $9806=__stackBase__+79952;
      var $9807=__stackBase__+79956;
      var $9808=__stackBase__+79960;
      var $9809=__stackBase__+79964;
      var $9810=__stackBase__+79968;
      var $9811=__stackBase__+79972;
      var $9812=__stackBase__+79976;
      var $9813=__stackBase__+80040;
      var $9814=__stackBase__+80044;
      var $9815=__stackBase__+80048;
      var $9816=__stackBase__+80052;
      var $9817=__stackBase__+80056;
      var $9818=__stackBase__+80060;
      var $9819=__stackBase__+80064;
      var $9820=__stackBase__+80068;
      var $9821=__stackBase__+80132;
      var $9822=__stackBase__+80136;
      var $9823=__stackBase__+80140;
      var $9824=__stackBase__+80144;
      var $9825=__stackBase__+80148;
      var $9826=__stackBase__+80152;
      var $9827=__stackBase__+80156;
      var $9828=__stackBase__+80160;
      var $9829=__stackBase__+80224;
      var $9830=__stackBase__+80228;
      var $9831=__stackBase__+80232;
      var $9832=__stackBase__+80236;
      var $9833=__stackBase__+80240;
      var $9834=__stackBase__+80244;
      var $9835=__stackBase__+80248;
      var $9836=__stackBase__+80252;
      var $9837=__stackBase__+80316;
      var $9838=__stackBase__+80320;
      var $9839=__stackBase__+80324;
      var $9840=__stackBase__+80328;
      var $9841=__stackBase__+80332;
      var $9842=__stackBase__+80336;
      var $9843=__stackBase__+80340;
      var $9844=__stackBase__+80344;
      var $9845=__stackBase__+80408;
      var $9846=__stackBase__+80412;
      var $9847=__stackBase__+80416;
      var $9848=__stackBase__+80420;
      var $9849=__stackBase__+80424;
      var $9850=__stackBase__+80428;
      var $9851=__stackBase__+80432;
      var $9852=__stackBase__+80436;
      var $9853=__stackBase__+80500;
      var $9854=__stackBase__+80504;
      var $9855=__stackBase__+80508;
      var $9856=__stackBase__+80512;
      var $9857=__stackBase__+80516;
      var $9858=__stackBase__+80520;
      var $9859=__stackBase__+80524;
      var $9860=__stackBase__+80528;
      var $9861=__stackBase__+80592;
      var $9862=__stackBase__+80596;
      var $9863=__stackBase__+80600;
      var $9864=__stackBase__+80604;
      var $9865=__stackBase__+80608;
      var $9866=__stackBase__+80612;
      var $9867=__stackBase__+80616;
      var $9868=__stackBase__+80620;
      var $9869=__stackBase__+80684;
      var $9870=__stackBase__+80688;
      var $9871=__stackBase__+80692;
      var $9872=__stackBase__+80696;
      var $9873=__stackBase__+80700;
      var $9874=__stackBase__+80704;
      var $9875=__stackBase__+80708;
      var $9876=__stackBase__+80712;
      var $9877=__stackBase__+80776;
      var $9878=__stackBase__+80780;
      var $9879=__stackBase__+80784;
      var $9880=__stackBase__+80788;
      var $9881=__stackBase__+80792;
      var $9882=__stackBase__+80796;
      var $9883=__stackBase__+80800;
      var $9884=__stackBase__+80804;
      var $9885=__stackBase__+80868;
      var $9886=__stackBase__+80872;
      var $9887=__stackBase__+80876;
      var $9888=__stackBase__+80880;
      var $9889=__stackBase__+80884;
      var $9890=__stackBase__+80888;
      var $9891=__stackBase__+80892;
      var $9892=__stackBase__+80896;
      var $9893=__stackBase__+80960;
      var $9894=__stackBase__+80964;
      var $9895=__stackBase__+80968;
      var $9896=__stackBase__+80972;
      var $9897=__stackBase__+80976;
      var $9898=__stackBase__+80980;
      var $9899=__stackBase__+80984;
      var $9900=__stackBase__+80988;
      var $9901=__stackBase__+81052;
      var $9902=__stackBase__+81056;
      var $9903=__stackBase__+81060;
      var $9904=__stackBase__+81064;
      var $9905=__stackBase__+81068;
      var $9906=__stackBase__+81072;
      var $9907=__stackBase__+81076;
      var $9908=__stackBase__+81080;
      var $9909=__stackBase__+81144;
      var $9910=__stackBase__+81148;
      var $9911=__stackBase__+81152;
      var $9912=__stackBase__+81156;
      var $9913=__stackBase__+81160;
      var $9914=__stackBase__+81164;
      var $9915=__stackBase__+81168;
      var $9916=__stackBase__+81172;
      var $9917=__stackBase__+81236;
      var $9918=__stackBase__+81240;
      var $9919=__stackBase__+81244;
      var $9920=__stackBase__+81248;
      var $9921=__stackBase__+81252;
      var $9922=__stackBase__+81256;
      var $9923=__stackBase__+81260;
      var $9924=__stackBase__+81264;
      var $9925=__stackBase__+81328;
      var $9926=__stackBase__+81332;
      var $9927=__stackBase__+81336;
      var $9928=__stackBase__+81340;
      var $9929=__stackBase__+81344;
      var $9930=__stackBase__+81348;
      var $9931=__stackBase__+81352;
      var $9932=__stackBase__+81356;
      var $9933=__stackBase__+81420;
      var $9934=__stackBase__+81424;
      var $9935=__stackBase__+81428;
      var $9936=__stackBase__+81432;
      var $9937=__stackBase__+81436;
      var $9938=__stackBase__+81440;
      var $9939=__stackBase__+81444;
      var $9940=__stackBase__+81448;
      var $9941=__stackBase__+81512;
      var $9942=__stackBase__+81516;
      var $9943=__stackBase__+81520;
      var $9944=__stackBase__+81524;
      var $9945=__stackBase__+81528;
      var $9946=__stackBase__+81532;
      var $9947=__stackBase__+81536;
      var $9948=__stackBase__+81540;
      var $9949=__stackBase__+81604;
      var $9950=__stackBase__+81608;
      var $9951=__stackBase__+81612;
      var $9952=__stackBase__+81616;
      var $9953=__stackBase__+81620;
      var $9954=__stackBase__+81624;
      var $9955=__stackBase__+81628;
      var $9956=__stackBase__+81632;
      var $9957=__stackBase__+81696;
      var $9958=__stackBase__+81700;
      var $9959=__stackBase__+81704;
      var $9960=__stackBase__+81708;
      var $9961=__stackBase__+81712;
      var $9962=__stackBase__+81716;
      var $9963=__stackBase__+81720;
      var $9964=__stackBase__+81724;
      var $9965=__stackBase__+81788;
      var $9966=__stackBase__+81792;
      var $9967=__stackBase__+81796;
      var $9968=__stackBase__+81800;
      var $9969=__stackBase__+81804;
      var $9970=__stackBase__+81808;
      var $9971=__stackBase__+81812;
      var $9972=__stackBase__+81816;
      var $9973=__stackBase__+81880;
      var $9974=__stackBase__+81884;
      var $9975=__stackBase__+81888;
      var $9976=__stackBase__+81892;
      var $9977=__stackBase__+81896;
      var $9978=__stackBase__+81900;
      var $9979=__stackBase__+81904;
      var $9980=__stackBase__+81908;
      var $9981=__stackBase__+81972;
      var $9982=__stackBase__+81976;
      var $9983=__stackBase__+81980;
      var $9984=__stackBase__+81984;
      var $9985=__stackBase__+81988;
      var $9986=__stackBase__+81992;
      var $9987=__stackBase__+81996;
      var $9988=__stackBase__+82000;
      var $9989=__stackBase__+82064;
      var $9990=__stackBase__+82068;
      var $9991=__stackBase__+82072;
      var $9992=__stackBase__+82076;
      var $9993=__stackBase__+82080;
      var $9994=__stackBase__+82084;
      var $9995=__stackBase__+82088;
      var $9996=__stackBase__+82092;
      var $9997=__stackBase__+82156;
      var $9998=__stackBase__+82160;
      var $9999=__stackBase__+82164;
      var $10000=__stackBase__+82168;
      var $10001=__stackBase__+82172;
      var $10002=__stackBase__+82176;
      var $10003=__stackBase__+82180;
      var $10004=__stackBase__+82184;
      var $10005=__stackBase__+82248;
      var $10006=__stackBase__+82252;
      var $10007=__stackBase__+82256;
      var $10008=__stackBase__+82260;
      var $10009=__stackBase__+82264;
      var $10010=__stackBase__+82268;
      var $10011=__stackBase__+82272;
      var $10012=__stackBase__+82276;
      var $10013=__stackBase__+82340;
      var $10014=__stackBase__+82344;
      var $10015=__stackBase__+82348;
      var $10016=__stackBase__+82352;
      var $10017=__stackBase__+82356;
      var $10018=__stackBase__+82360;
      var $10019=__stackBase__+82364;
      var $10020=__stackBase__+82368;
      var $10021=__stackBase__+82432;
      var $10022=__stackBase__+82436;
      var $10023=__stackBase__+82440;
      var $10024=__stackBase__+82444;
      var $10025=__stackBase__+82448;
      var $10026=__stackBase__+82452;
      var $10027=__stackBase__+82456;
      var $10028=__stackBase__+82460;
      var $10029=__stackBase__+82524;
      var $10030=__stackBase__+82528;
      var $10031=__stackBase__+82532;
      var $10032=__stackBase__+82536;
      var $10033=__stackBase__+82540;
      var $10034=__stackBase__+82544;
      var $10035=__stackBase__+82548;
      var $10036=__stackBase__+82552;
      var $10037=__stackBase__+82616;
      var $10038=__stackBase__+82620;
      var $10039=__stackBase__+82624;
      var $10040=__stackBase__+82628;
      var $10041=__stackBase__+82632;
      var $10042=__stackBase__+82636;
      var $10043=__stackBase__+82640;
      var $10044=__stackBase__+82644;
      var $10045=__stackBase__+82708;
      var $10046=__stackBase__+82712;
      var $10047=__stackBase__+82716;
      var $10048=__stackBase__+82720;
      var $10049=__stackBase__+82724;
      var $10050=__stackBase__+82728;
      var $10051=__stackBase__+82732;
      var $10052=__stackBase__+82736;
      var $10053=__stackBase__+82800;
      var $10054=__stackBase__+82804;
      var $10055=__stackBase__+82808;
      var $10056=__stackBase__+82812;
      var $10057=__stackBase__+82816;
      var $10058=__stackBase__+82820;
      var $10059=__stackBase__+82824;
      var $10060=__stackBase__+82828;
      var $10061=__stackBase__+82892;
      var $10062=__stackBase__+82896;
      var $10063=__stackBase__+82900;
      var $10064=__stackBase__+82904;
      var $10065=__stackBase__+82908;
      var $10066=__stackBase__+82912;
      var $10067=__stackBase__+82916;
      var $10068=__stackBase__+82920;
      var $10069=__stackBase__+82984;
      var $10070=__stackBase__+82988;
      var $10071=__stackBase__+82992;
      var $10072=__stackBase__+82996;
      var $10073=__stackBase__+83000;
      var $10074=__stackBase__+83004;
      var $10075=__stackBase__+83008;
      var $10076=__stackBase__+83012;
      var $10077=__stackBase__+83076;
      var $10078=__stackBase__+83080;
      var $10079=__stackBase__+83084;
      var $10080=__stackBase__+83088;
      var $10081=__stackBase__+83092;
      var $10082=__stackBase__+83096;
      var $10083=__stackBase__+83100;
      var $10084=__stackBase__+83104;
      var $10085=__stackBase__+83168;
      var $10086=__stackBase__+83172;
      var $10087=__stackBase__+83176;
      var $10088=__stackBase__+83180;
      var $10089=__stackBase__+83184;
      var $10090=__stackBase__+83188;
      var $10091=__stackBase__+83192;
      var $10092=__stackBase__+83196;
      var $10093=__stackBase__+83260;
      var $10094=__stackBase__+83264;
      var $10095=__stackBase__+83268;
      var $10096=__stackBase__+83272;
      var $10097=__stackBase__+83276;
      var $10098=__stackBase__+83280;
      var $10099=__stackBase__+83284;
      var $10100=__stackBase__+83288;
      var $10101=__stackBase__+83352;
      var $10102=__stackBase__+83356;
      var $10103=__stackBase__+83360;
      var $10104=__stackBase__+83364;
      var $10105=__stackBase__+83368;
      var $10106=__stackBase__+83372;
      var $10107=__stackBase__+83376;
      var $10108=__stackBase__+83380;
      var $10109=__stackBase__+83444;
      var $10110=__stackBase__+83448;
      var $10111=__stackBase__+83452;
      var $10112=__stackBase__+83456;
      var $10113=__stackBase__+83460;
      var $10114=__stackBase__+83464;
      var $10115=__stackBase__+83468;
      var $10116=__stackBase__+83472;
      var $10117=__stackBase__+83536;
      var $10118=__stackBase__+83540;
      var $10119=__stackBase__+83544;
      var $10120=__stackBase__+83548;
      var $10121=__stackBase__+83552;
      var $10122=__stackBase__+83556;
      var $10123=__stackBase__+83560;
      var $10124=__stackBase__+83564;
      var $10125=__stackBase__+83628;
      var $10126=__stackBase__+83632;
      var $10127=__stackBase__+83636;
      var $10128=__stackBase__+83640;
      var $10129=__stackBase__+83644;
      var $10130=__stackBase__+83648;
      var $10131=__stackBase__+83652;
      var $10132=__stackBase__+83656;
      var $10133=__stackBase__+83720;
      var $10134=__stackBase__+83724;
      var $10135=__stackBase__+83728;
      var $10136=__stackBase__+83732;
      var $10137=__stackBase__+83736;
      var $10138=__stackBase__+83740;
      var $10139=__stackBase__+83744;
      var $10140=__stackBase__+83748;
      var $10141=__stackBase__+83812;
      var $10142=__stackBase__+83816;
      var $10143=__stackBase__+83820;
      var $10144=__stackBase__+83824;
      var $10145=__stackBase__+83828;
      var $10146=__stackBase__+83832;
      var $10147=__stackBase__+83836;
      var $10148=__stackBase__+83840;
      var $10149=__stackBase__+83904;
      var $10150=__stackBase__+83908;
      var $10151=__stackBase__+83912;
      var $10152=__stackBase__+83916;
      var $10153=__stackBase__+83920;
      var $10154=__stackBase__+83924;
      var $10155=__stackBase__+83928;
      var $10156=__stackBase__+83932;
      var $10157=__stackBase__+83996;
      var $10158=__stackBase__+84000;
      var $10159=__stackBase__+84004;
      var $10160=__stackBase__+84008;
      var $10161=__stackBase__+84012;
      var $10162=__stackBase__+84016;
      var $10163=__stackBase__+84020;
      var $10164=__stackBase__+84024;
      var $10165=__stackBase__+84088;
      var $10166=__stackBase__+84092;
      var $10167=__stackBase__+84096;
      var $10168=__stackBase__+84100;
      var $10169=__stackBase__+84104;
      var $10170=__stackBase__+84108;
      var $10171=__stackBase__+84112;
      var $10172=__stackBase__+84116;
      var $10173=__stackBase__+84180;
      var $10174=__stackBase__+84184;
      var $10175=__stackBase__+84188;
      var $10176=__stackBase__+84192;
      var $10177=__stackBase__+84196;
      var $10178=__stackBase__+84200;
      var $10179=__stackBase__+84204;
      var $10180=__stackBase__+84208;
      var $10181=__stackBase__+84272;
      var $10182=__stackBase__+84276;
      var $10183=__stackBase__+84280;
      var $10184=__stackBase__+84284;
      var $10185=__stackBase__+84288;
      var $10186=__stackBase__+84292;
      var $10187=__stackBase__+84296;
      var $10188=__stackBase__+84300;
      var $10189=__stackBase__+84364;
      var $10190=__stackBase__+84368;
      var $10191=__stackBase__+84372;
      var $10192=__stackBase__+84376;
      var $10193=__stackBase__+84380;
      var $10194=__stackBase__+84384;
      var $10195=__stackBase__+84388;
      var $10196=__stackBase__+84392;
      var $10197=__stackBase__+84456;
      var $10198=__stackBase__+84460;
      var $10199=__stackBase__+84464;
      var $10200=__stackBase__+84468;
      var $10201=__stackBase__+84472;
      var $10202=__stackBase__+84476;
      var $10203=__stackBase__+84480;
      var $10204=__stackBase__+84484;
      var $10205=__stackBase__+84548;
      var $10206=__stackBase__+84552;
      var $10207=__stackBase__+84556;
      var $10208=__stackBase__+84560;
      var $10209=__stackBase__+84564;
      var $10210=__stackBase__+84568;
      var $10211=__stackBase__+84572;
      var $10212=__stackBase__+84576;
      var $10213=__stackBase__+84640;
      var $10214=__stackBase__+84644;
      var $10215=__stackBase__+84648;
      var $10216=__stackBase__+84652;
      var $10217=__stackBase__+84656;
      var $10218=__stackBase__+84660;
      var $10219=__stackBase__+84664;
      var $10220=__stackBase__+84668;
      var $10221=__stackBase__+84732;
      var $10222=__stackBase__+84736;
      var $10223=__stackBase__+84740;
      var $10224=__stackBase__+84744;
      var $10225=__stackBase__+84748;
      var $10226=__stackBase__+84752;
      var $10227=__stackBase__+84756;
      var $10228=__stackBase__+84760;
      var $10229=__stackBase__+84824;
      var $10230=__stackBase__+84828;
      var $10231=__stackBase__+84832;
      var $10232=__stackBase__+84836;
      var $10233=__stackBase__+84840;
      var $10234=__stackBase__+84844;
      var $10235=__stackBase__+84848;
      var $10236=__stackBase__+84852;
      var $10237=__stackBase__+84916;
      var $10238=__stackBase__+84920;
      var $10239=__stackBase__+84924;
      var $10240=__stackBase__+84928;
      var $10241=__stackBase__+84932;
      var $10242=__stackBase__+84936;
      var $10243=__stackBase__+84940;
      var $10244=__stackBase__+84944;
      var $10245=__stackBase__+85008;
      var $10246=__stackBase__+85012;
      var $10247=__stackBase__+85016;
      var $10248=__stackBase__+85020;
      var $10249=__stackBase__+85024;
      var $10250=__stackBase__+85028;
      var $10251=__stackBase__+85032;
      var $10252=__stackBase__+85036;
      var $10253=__stackBase__+85100;
      var $10254=__stackBase__+85104;
      var $10255=__stackBase__+85108;
      var $10256=__stackBase__+85112;
      var $10257=__stackBase__+85116;
      var $10258=__stackBase__+85120;
      var $10259=__stackBase__+85124;
      var $10260=__stackBase__+85128;
      var $10261=__stackBase__+85192;
      var $10262=__stackBase__+85196;
      var $10263=__stackBase__+85200;
      var $10264=__stackBase__+85204;
      var $10265=__stackBase__+85208;
      var $10266=__stackBase__+85212;
      var $10267=__stackBase__+85216;
      var $10268=__stackBase__+85220;
      var $10269=__stackBase__+85284;
      var $10270=__stackBase__+85288;
      var $10271=__stackBase__+85292;
      var $10272=__stackBase__+85296;
      var $10273=__stackBase__+85300;
      var $10274=__stackBase__+85304;
      var $10275=__stackBase__+85308;
      var $10276=__stackBase__+85312;
      var $10277=__stackBase__+85376;
      var $10278=__stackBase__+85380;
      var $10279=__stackBase__+85384;
      var $10280=__stackBase__+85388;
      var $10281=__stackBase__+85392;
      var $10282=__stackBase__+85396;
      var $10283=__stackBase__+85400;
      var $10284=__stackBase__+85404;
      var $10285=__stackBase__+85468;
      var $10286=__stackBase__+85472;
      var $10287=__stackBase__+85476;
      var $10288=__stackBase__+85480;
      var $10289=__stackBase__+85484;
      var $10290=__stackBase__+85488;
      var $10291=__stackBase__+85492;
      var $10292=__stackBase__+85496;
      var $10293=__stackBase__+85560;
      var $10294=__stackBase__+85564;
      var $10295=__stackBase__+85568;
      var $10296=__stackBase__+85572;
      var $10297=__stackBase__+85576;
      var $10298=__stackBase__+85580;
      var $10299=__stackBase__+85584;
      var $10300=__stackBase__+85588;
      var $10301=__stackBase__+85652;
      var $10302=__stackBase__+85656;
      var $10303=__stackBase__+85660;
      var $10304=__stackBase__+85664;
      var $10305=__stackBase__+85668;
      var $10306=__stackBase__+85672;
      var $10307=__stackBase__+85676;
      var $10308=__stackBase__+85680;
      var $10309=__stackBase__+85744;
      var $10310=__stackBase__+85748;
      var $10311=__stackBase__+85752;
      var $10312=__stackBase__+85756;
      var $10313=__stackBase__+85760;
      var $10314=__stackBase__+85764;
      var $10315=__stackBase__+85768;
      var $10316=__stackBase__+85772;
      var $10317=__stackBase__+85836;
      var $10318=__stackBase__+85840;
      var $10319=__stackBase__+85844;
      var $10320=__stackBase__+85848;
      var $10321=__stackBase__+85852;
      var $10322=__stackBase__+85856;
      var $10323=__stackBase__+85860;
      var $10324=__stackBase__+85864;
      var $10325=__stackBase__+85928;
      var $10326=__stackBase__+85932;
      var $10327=__stackBase__+85936;
      var $10328=__stackBase__+85940;
      var $10329=__stackBase__+85944;
      var $10330=__stackBase__+85948;
      var $10331=__stackBase__+85952;
      var $10332=__stackBase__+85956;
      var $10333=__stackBase__+86020;
      var $10334=__stackBase__+86024;
      var $10335=__stackBase__+86028;
      var $10336=__stackBase__+86032;
      var $10337=__stackBase__+86036;
      var $10338=__stackBase__+86040;
      var $10339=__stackBase__+86044;
      var $10340=__stackBase__+86048;
      var $10341=__stackBase__+86112;
      var $10342=__stackBase__+86116;
      var $10343=__stackBase__+86120;
      var $10344=__stackBase__+86124;
      var $10345=__stackBase__+86128;
      var $10346=__stackBase__+86132;
      var $10347=__stackBase__+86136;
      var $10348=__stackBase__+86140;
      var $10349=__stackBase__+86204;
      var $10350=__stackBase__+86208;
      var $10351=__stackBase__+86212;
      var $10352=__stackBase__+86216;
      var $10353=__stackBase__+86220;
      var $10354=__stackBase__+86224;
      var $10355=__stackBase__+86228;
      var $10356=__stackBase__+86232;
      var $10357=__stackBase__+86296;
      var $10358=__stackBase__+86300;
      var $10359=__stackBase__+86304;
      var $10360=__stackBase__+86308;
      var $10361=__stackBase__+86312;
      var $10362=__stackBase__+86316;
      var $10363=__stackBase__+86320;
      var $10364=__stackBase__+86324;
      var $10365=__stackBase__+86388;
      var $10366=__stackBase__+86392;
      var $10367=__stackBase__+86396;
      var $10368=__stackBase__+86400;
      var $10369=__stackBase__+86404;
      var $10370=__stackBase__+86408;
      var $10371=__stackBase__+86412;
      var $10372=__stackBase__+86416;
      var $10373=__stackBase__+86480;
      var $10374=__stackBase__+86484;
      var $10375=__stackBase__+86488;
      var $10376=__stackBase__+86492;
      var $10377=__stackBase__+86496;
      var $10378=__stackBase__+86500;
      var $10379=__stackBase__+86504;
      var $10380=__stackBase__+86508;
      var $10381=__stackBase__+86572;
      var $10382=__stackBase__+86576;
      var $10383=__stackBase__+86580;
      var $10384=__stackBase__+86584;
      var $10385=__stackBase__+86588;
      var $10386=__stackBase__+86592;
      var $10387=__stackBase__+86596;
      var $10388=__stackBase__+86600;
      var $10389=__stackBase__+86664;
      var $10390=__stackBase__+86668;
      var $10391=__stackBase__+86672;
      var $10392=__stackBase__+86676;
      var $10393=__stackBase__+86680;
      var $10394=__stackBase__+86684;
      var $10395=__stackBase__+86688;
      var $10396=__stackBase__+86692;
      var $10397=__stackBase__+86756;
      var $10398=__stackBase__+86760;
      var $10399=__stackBase__+86764;
      var $10400=__stackBase__+86768;
      var $10401=__stackBase__+86772;
      var $10402=__stackBase__+86776;
      var $10403=__stackBase__+86780;
      var $10404=__stackBase__+86784;
      var $10405=__stackBase__+86848;
      var $10406=__stackBase__+86852;
      var $10407=__stackBase__+86856;
      var $10408=__stackBase__+86860;
      var $10409=__stackBase__+86864;
      var $10410=__stackBase__+86868;
      var $10411=__stackBase__+86872;
      var $10412=__stackBase__+86876;
      var $10413=__stackBase__+86940;
      var $10414=__stackBase__+86944;
      var $10415=__stackBase__+86948;
      var $10416=__stackBase__+86952;
      var $10417=__stackBase__+86956;
      var $10418=__stackBase__+86960;
      var $10419=__stackBase__+86964;
      var $10420=__stackBase__+86968;
      var $10421=__stackBase__+87032;
      var $10422=__stackBase__+87036;
      var $10423=__stackBase__+87040;
      var $10424=__stackBase__+87044;
      var $10425=__stackBase__+87048;
      var $10426=__stackBase__+87052;
      var $10427=__stackBase__+87056;
      var $10428=__stackBase__+87060;
      var $10429=__stackBase__+87124;
      var $10430=__stackBase__+87128;
      var $10431=__stackBase__+87132;
      var $10432=__stackBase__+87136;
      var $10433=__stackBase__+87140;
      var $10434=__stackBase__+87144;
      var $10435=__stackBase__+87148;
      var $10436=__stackBase__+87152;
      var $10437=__stackBase__+87216;
      var $10438=__stackBase__+87220;
      var $10439=__stackBase__+87224;
      var $10440=__stackBase__+87228;
      var $10441=__stackBase__+87232;
      var $10442=__stackBase__+87236;
      var $10443=__stackBase__+87240;
      var $10444=__stackBase__+87244;
      var $10445=__stackBase__+87308;
      var $10446=__stackBase__+87312;
      var $10447=__stackBase__+87316;
      var $10448=__stackBase__+87320;
      var $10449=__stackBase__+87324;
      var $10450=__stackBase__+87328;
      var $10451=__stackBase__+87332;
      var $10452=__stackBase__+87336;
      var $10453=__stackBase__+87400;
      var $10454=__stackBase__+87404;
      var $10455=__stackBase__+87408;
      var $10456=__stackBase__+87412;
      var $10457=__stackBase__+87416;
      var $10458=__stackBase__+87420;
      var $10459=__stackBase__+87424;
      var $10460=__stackBase__+87428;
      var $10461=__stackBase__+87492;
      var $10462=__stackBase__+87496;
      var $10463=__stackBase__+87500;
      var $10464=__stackBase__+87504;
      var $10465=__stackBase__+87508;
      var $10466=__stackBase__+87512;
      var $10467=__stackBase__+87516;
      var $10468=__stackBase__+87520;
      var $10469=__stackBase__+87584;
      var $10470=__stackBase__+87588;
      var $10471=__stackBase__+87592;
      var $10472=__stackBase__+87596;
      var $10473=__stackBase__+87600;
      var $10474=__stackBase__+87604;
      var $10475=__stackBase__+87608;
      var $10476=__stackBase__+87612;
      var $10477=__stackBase__+87676;
      var $10478=__stackBase__+87680;
      var $10479=__stackBase__+87684;
      var $10480=__stackBase__+87688;
      var $10481=__stackBase__+87692;
      var $10482=__stackBase__+87696;
      var $10483=__stackBase__+87700;
      var $10484=__stackBase__+87704;
      var $10485=__stackBase__+87768;
      var $10486=__stackBase__+87772;
      var $10487=__stackBase__+87776;
      var $10488=__stackBase__+87780;
      var $10489=__stackBase__+87784;
      var $10490=__stackBase__+87788;
      var $10491=__stackBase__+87792;
      var $10492=__stackBase__+87796;
      var $10493=__stackBase__+87860;
      var $10494=__stackBase__+87864;
      var $10495=__stackBase__+87868;
      var $10496=__stackBase__+87872;
      var $10497=__stackBase__+87876;
      var $10498=__stackBase__+87880;
      var $10499=__stackBase__+87884;
      var $10500=__stackBase__+87888;
      var $10501=__stackBase__+87952;
      var $10502=__stackBase__+87956;
      var $10503=__stackBase__+87960;
      var $10504=__stackBase__+87964;
      var $10505=__stackBase__+87968;
      var $10506=__stackBase__+87972;
      var $10507=__stackBase__+87976;
      var $10508=__stackBase__+87980;
      var $10509=__stackBase__+88044;
      var $10510=__stackBase__+88048;
      var $10511=__stackBase__+88052;
      var $10512=__stackBase__+88056;
      var $10513=__stackBase__+88060;
      var $10514=__stackBase__+88064;
      var $10515=__stackBase__+88068;
      var $10516=__stackBase__+88072;
      var $10517=__stackBase__+88136;
      var $10518=__stackBase__+88140;
      var $10519=__stackBase__+88144;
      var $10520=__stackBase__+88148;
      var $10521=__stackBase__+88152;
      var $10522=__stackBase__+88156;
      var $10523=__stackBase__+88160;
      var $10524=__stackBase__+88164;
      var $10525=__stackBase__+88228;
      var $10526=__stackBase__+88232;
      var $10527=__stackBase__+88236;
      var $10528=__stackBase__+88240;
      var $10529=__stackBase__+88244;
      var $10530=__stackBase__+88248;
      var $10531=__stackBase__+88252;
      var $10532=__stackBase__+88256;
      var $10533=__stackBase__+88320;
      var $10534=__stackBase__+88324;
      var $10535=__stackBase__+88328;
      var $10536=__stackBase__+88332;
      var $10537=__stackBase__+88336;
      var $10538=__stackBase__+88340;
      var $10539=__stackBase__+88344;
      var $10540=__stackBase__+88348;
      var $10541=__stackBase__+88412;
      var $10542=__stackBase__+88416;
      var $10543=__stackBase__+88420;
      var $10544=__stackBase__+88424;
      var $10545=__stackBase__+88428;
      var $10546=__stackBase__+88432;
      var $10547=__stackBase__+88436;
      var $10548=__stackBase__+88440;
      var $10549=__stackBase__+88504;
      var $10550=__stackBase__+88508;
      var $10551=__stackBase__+88512;
      var $10552=__stackBase__+88516;
      var $10553=__stackBase__+88520;
      var $10554=__stackBase__+88524;
      var $10555=__stackBase__+88528;
      var $10556=__stackBase__+88532;
      var $10557=__stackBase__+88596;
      var $10558=__stackBase__+88600;
      var $10559=__stackBase__+88604;
      var $10560=__stackBase__+88608;
      var $10561=__stackBase__+88612;
      var $10562=__stackBase__+88616;
      var $10563=__stackBase__+88620;
      var $10564=__stackBase__+88624;
      var $10565=__stackBase__+88688;
      var $10566=__stackBase__+88692;
      var $10567=__stackBase__+88696;
      var $10568=__stackBase__+88700;
      var $10569=__stackBase__+88704;
      var $10570=__stackBase__+88708;
      var $10571=__stackBase__+88712;
      var $10572=__stackBase__+88716;
      var $10573=__stackBase__+88780;
      var $10574=__stackBase__+88784;
      var $10575=__stackBase__+88788;
      var $10576=__stackBase__+88792;
      var $10577=__stackBase__+88796;
      var $10578=__stackBase__+88800;
      var $10579=__stackBase__+88804;
      var $10580=__stackBase__+88808;
      var $10581=__stackBase__+88872;
      var $10582=__stackBase__+88876;
      var $10583=__stackBase__+88880;
      var $10584=__stackBase__+88884;
      var $10585=__stackBase__+88888;
      var $10586=__stackBase__+88892;
      var $10587=__stackBase__+88896;
      var $10588=__stackBase__+88900;
      var $10589=__stackBase__+88964;
      var $10590=__stackBase__+88968;
      var $10591=__stackBase__+88972;
      var $10592=__stackBase__+88976;
      var $10593=__stackBase__+88980;
      var $10594=__stackBase__+88984;
      var $10595=__stackBase__+88988;
      var $10596=__stackBase__+88992;
      var $10597=__stackBase__+89056;
      var $10598=__stackBase__+89060;
      var $10599=__stackBase__+89064;
      var $10600=__stackBase__+89068;
      var $10601=__stackBase__+89072;
      var $10602=__stackBase__+89076;
      var $10603=__stackBase__+89080;
      var $10604=__stackBase__+89084;
      var $10605=__stackBase__+89148;
      var $10606=__stackBase__+89152;
      var $10607=__stackBase__+89156;
      var $10608=__stackBase__+89160;
      var $10609=__stackBase__+89164;
      var $10610=__stackBase__+89168;
      var $10611=__stackBase__+89172;
      var $10612=__stackBase__+89176;
      var $10613=__stackBase__+89240;
      var $10614=__stackBase__+89244;
      var $10615=__stackBase__+89248;
      var $10616=__stackBase__+89252;
      var $10617=__stackBase__+89256;
      var $10618=__stackBase__+89260;
      var $10619=__stackBase__+89264;
      var $10620=__stackBase__+89268;
      var $10621=__stackBase__+89332;
      var $10622=__stackBase__+89336;
      var $10623=__stackBase__+89340;
      var $10624=__stackBase__+89344;
      var $10625=__stackBase__+89348;
      var $10626=__stackBase__+89352;
      var $10627=__stackBase__+89356;
      var $10628=__stackBase__+89360;
      var $10629=__stackBase__+89424;
      var $10630=__stackBase__+89428;
      var $10631=__stackBase__+89432;
      var $10632=__stackBase__+89436;
      var $10633=__stackBase__+89440;
      var $10634=__stackBase__+89444;
      var $10635=__stackBase__+89448;
      var $10636=__stackBase__+89452;
      var $10637=__stackBase__+89516;
      var $10638=__stackBase__+89520;
      var $10639=__stackBase__+89524;
      var $10640=__stackBase__+89528;
      var $10641=__stackBase__+89532;
      var $10642=__stackBase__+89536;
      var $10643=__stackBase__+89540;
      var $10644=__stackBase__+89544;
      var $10645=__stackBase__+89608;
      var $10646=__stackBase__+89612;
      var $10647=__stackBase__+89616;
      var $10648=__stackBase__+89620;
      var $10649=__stackBase__+89624;
      var $10650=__stackBase__+89628;
      var $10651=__stackBase__+89632;
      var $10652=__stackBase__+89636;
      var $10653=__stackBase__+89700;
      var $10654=__stackBase__+89704;
      var $10655=__stackBase__+89708;
      var $10656=__stackBase__+89712;
      var $10657=__stackBase__+89716;
      var $10658=__stackBase__+89720;
      var $10659=__stackBase__+89724;
      var $10660=__stackBase__+89728;
      var $10661=__stackBase__+89792;
      var $10662=__stackBase__+89796;
      var $10663=__stackBase__+89800;
      var $10664=__stackBase__+89804;
      var $10665=__stackBase__+89808;
      var $10666=__stackBase__+89812;
      var $10667=__stackBase__+89816;
      var $10668=__stackBase__+89820;
      var $10669=__stackBase__+89884;
      var $10670=__stackBase__+89888;
      var $10671=__stackBase__+89892;
      var $10672=__stackBase__+89896;
      var $10673=__stackBase__+89900;
      var $10674=__stackBase__+89904;
      var $10675=__stackBase__+89908;
      var $10676=__stackBase__+89912;
      var $10677=__stackBase__+89976;
      var $10678=__stackBase__+89980;
      var $10679=__stackBase__+89984;
      var $10680=__stackBase__+89988;
      var $10681=__stackBase__+89992;
      var $10682=__stackBase__+89996;
      var $10683=__stackBase__+90000;
      var $10684=__stackBase__+90004;
      var $10685=__stackBase__+90068;
      var $10686=__stackBase__+90072;
      var $10687=__stackBase__+90076;
      var $10688=__stackBase__+90080;
      var $10689=__stackBase__+90084;
      var $10690=__stackBase__+90088;
      var $10691=__stackBase__+90092;
      var $10692=__stackBase__+90096;
      var $10693=__stackBase__+90160;
      var $10694=__stackBase__+90164;
      var $10695=__stackBase__+90168;
      var $10696=__stackBase__+90172;
      var $10697=__stackBase__+90176;
      var $10698=__stackBase__+90180;
      var $10699=__stackBase__+90184;
      var $10700=__stackBase__+90188;
      var $10701=__stackBase__+90252;
      var $10702=__stackBase__+90256;
      var $10703=__stackBase__+90260;
      var $10704=__stackBase__+90264;
      var $10705=__stackBase__+90268;
      var $10706=__stackBase__+90272;
      var $10707=__stackBase__+90276;
      var $10708=__stackBase__+90280;
      var $10709=__stackBase__+90344;
      var $10710=__stackBase__+90348;
      var $10711=__stackBase__+90352;
      var $10712=__stackBase__+90356;
      var $10713=__stackBase__+90360;
      var $10714=__stackBase__+90364;
      var $10715=__stackBase__+90368;
      var $10716=__stackBase__+90372;
      var $10717=__stackBase__+90436;
      var $10718=__stackBase__+90440;
      var $10719=__stackBase__+90444;
      var $10720=__stackBase__+90448;
      var $10721=__stackBase__+90452;
      var $10722=__stackBase__+90456;
      var $10723=__stackBase__+90460;
      var $10724=__stackBase__+90464;
      var $10725=__stackBase__+90528;
      var $10726=__stackBase__+90532;
      var $10727=__stackBase__+90536;
      var $10728=__stackBase__+90540;
      var $10729=__stackBase__+90544;
      var $10730=__stackBase__+90548;
      var $10731=__stackBase__+90552;
      var $10732=__stackBase__+90556;
      var $10733=__stackBase__+90620;
      var $10734=__stackBase__+90624;
      var $10735=__stackBase__+90628;
      var $10736=__stackBase__+90632;
      var $10737=__stackBase__+90636;
      var $10738=__stackBase__+90640;
      var $10739=__stackBase__+90644;
      var $10740=__stackBase__+90648;
      var $10741=__stackBase__+90712;
      var $10742=__stackBase__+90716;
      var $10743=__stackBase__+90720;
      var $10744=__stackBase__+90724;
      var $10745=__stackBase__+90728;
      var $10746=__stackBase__+90732;
      var $10747=__stackBase__+90736;
      var $10748=__stackBase__+90740;
      var $10749=__stackBase__+90804;
      var $10750=__stackBase__+90808;
      var $10751=__stackBase__+90812;
      var $10752=__stackBase__+90816;
      var $10753=__stackBase__+90820;
      var $10754=__stackBase__+90824;
      var $10755=__stackBase__+90828;
      var $10756=__stackBase__+90832;
      var $10757=__stackBase__+90896;
      var $10758=__stackBase__+90900;
      var $10759=__stackBase__+90904;
      var $10760=__stackBase__+90908;
      var $10761=__stackBase__+90912;
      var $10762=__stackBase__+90916;
      var $10763=__stackBase__+90920;
      var $10764=__stackBase__+90924;
      var $10765=__stackBase__+90988;
      var $10766=__stackBase__+90992;
      var $10767=__stackBase__+90996;
      var $10768=__stackBase__+91000;
      var $10769=__stackBase__+91004;
      var $10770=__stackBase__+91008;
      var $10771=__stackBase__+91012;
      var $10772=__stackBase__+91016;
      var $10773=__stackBase__+91080;
      var $10774=__stackBase__+91084;
      var $10775=__stackBase__+91088;
      var $10776=__stackBase__+91092;
      var $10777=__stackBase__+91096;
      var $10778=__stackBase__+91100;
      var $10779=__stackBase__+91104;
      var $10780=__stackBase__+91108;
      var $10781=__stackBase__+91172;
      var $10782=__stackBase__+91176;
      var $10783=__stackBase__+91180;
      var $10784=__stackBase__+91184;
      var $10785=__stackBase__+91188;
      var $10786=__stackBase__+91192;
      var $10787=__stackBase__+91196;
      var $10788=__stackBase__+91200;
      var $10789=__stackBase__+91264;
      var $10790=__stackBase__+91268;
      var $10791=__stackBase__+91272;
      var $10792=__stackBase__+91276;
      var $10793=__stackBase__+91280;
      var $10794=__stackBase__+91284;
      var $10795=__stackBase__+91288;
      var $10796=__stackBase__+91292;
      var $10797=__stackBase__+91356;
      var $10798=__stackBase__+91360;
      var $10799=__stackBase__+91364;
      var $10800=__stackBase__+91368;
      var $10801=__stackBase__+91372;
      var $10802=__stackBase__+91376;
      var $10803=__stackBase__+91380;
      var $10804=__stackBase__+91384;
      var $10805=__stackBase__+91448;
      var $10806=__stackBase__+91452;
      var $10807=__stackBase__+91456;
      var $10808=__stackBase__+91460;
      var $10809=__stackBase__+91464;
      var $10810=__stackBase__+91468;
      var $10811=__stackBase__+91472;
      var $10812=__stackBase__+91476;
      var $10813=__stackBase__+91540;
      var $10814=__stackBase__+91544;
      var $10815=__stackBase__+91548;
      var $10816=__stackBase__+91552;
      var $10817=__stackBase__+91556;
      var $10818=__stackBase__+91560;
      var $10819=__stackBase__+91564;
      var $10820=__stackBase__+91568;
      var $10821=__stackBase__+91632;
      var $10822=__stackBase__+91636;
      var $10823=__stackBase__+91640;
      var $10824=__stackBase__+91644;
      var $10825=__stackBase__+91648;
      var $10826=__stackBase__+91652;
      var $10827=__stackBase__+91656;
      var $10828=__stackBase__+91660;
      var $10829=__stackBase__+91724;
      var $10830=__stackBase__+91728;
      var $10831=__stackBase__+91732;
      var $10832=__stackBase__+91736;
      var $10833=__stackBase__+91740;
      var $10834=__stackBase__+91744;
      var $10835=__stackBase__+91748;
      var $10836=__stackBase__+91752;
      var $10837=__stackBase__+91816;
      var $10838=__stackBase__+91820;
      var $10839=__stackBase__+91824;
      var $10840=__stackBase__+91828;
      var $10841=__stackBase__+91832;
      var $10842=__stackBase__+91836;
      var $10843=__stackBase__+91840;
      var $10844=__stackBase__+91844;
      var $10845=__stackBase__+91908;
      var $10846=__stackBase__+91912;
      var $10847=__stackBase__+91916;
      var $10848=__stackBase__+91920;
      var $10849=__stackBase__+91924;
      var $10850=__stackBase__+91928;
      var $10851=__stackBase__+91932;
      var $10852=__stackBase__+91936;
      var $10853=__stackBase__+92000;
      var $10854=__stackBase__+92004;
      var $10855=__stackBase__+92008;
      var $10856=__stackBase__+92012;
      var $10857=__stackBase__+92016;
      var $10858=__stackBase__+92020;
      var $10859=__stackBase__+92024;
      var $10860=__stackBase__+92028;
      var $10861=__stackBase__+92092;
      var $10862=__stackBase__+92096;
      var $10863=__stackBase__+92100;
      var $10864=__stackBase__+92104;
      var $10865=__stackBase__+92108;
      var $10866=__stackBase__+92112;
      var $10867=__stackBase__+92116;
      var $10868=__stackBase__+92120;
      var $10869=__stackBase__+92184;
      var $10870=__stackBase__+92188;
      var $10871=__stackBase__+92192;
      var $10872=__stackBase__+92196;
      var $10873=__stackBase__+92200;
      var $10874=__stackBase__+92204;
      var $10875=__stackBase__+92208;
      var $10876=__stackBase__+92212;
      var $10877=__stackBase__+92276;
      var $10878=__stackBase__+92280;
      var $10879=__stackBase__+92284;
      var $10880=__stackBase__+92288;
      var $10881=__stackBase__+92292;
      var $10882=__stackBase__+92296;
      var $10883=__stackBase__+92300;
      var $10884=__stackBase__+92304;
      var $10885=__stackBase__+92368;
      var $10886=__stackBase__+92372;
      var $10887=__stackBase__+92376;
      var $10888=__stackBase__+92380;
      var $10889=__stackBase__+92384;
      var $10890=__stackBase__+92388;
      var $10891=__stackBase__+92392;
      var $10892=__stackBase__+92396;
      var $10893=__stackBase__+92460;
      var $10894=__stackBase__+92464;
      var $10895=__stackBase__+92468;
      var $10896=__stackBase__+92472;
      var $10897=__stackBase__+92476;
      var $10898=__stackBase__+92480;
      var $10899=__stackBase__+92484;
      var $10900=__stackBase__+92488;
      var $10901=__stackBase__+92552;
      var $10902=__stackBase__+92556;
      var $10903=__stackBase__+92560;
      var $10904=__stackBase__+92564;
      var $10905=__stackBase__+92568;
      var $10906=__stackBase__+92572;
      var $10907=__stackBase__+92576;
      var $10908=__stackBase__+92580;
      var $10909=__stackBase__+92644;
      var $10910=__stackBase__+92648;
      var $10911=__stackBase__+92652;
      var $10912=__stackBase__+92656;
      var $10913=__stackBase__+92660;
      var $10914=__stackBase__+92664;
      var $10915=__stackBase__+92668;
      var $10916=__stackBase__+92672;
      var $10917=__stackBase__+92736;
      var $10918=__stackBase__+92740;
      var $10919=__stackBase__+92744;
      var $10920=__stackBase__+92748;
      var $10921=__stackBase__+92752;
      var $10922=__stackBase__+92756;
      var $10923=__stackBase__+92760;
      var $10924=__stackBase__+92764;
      var $10925=__stackBase__+92828;
      var $10926=__stackBase__+92832;
      var $10927=__stackBase__+92836;
      var $10928=__stackBase__+92840;
      var $10929=__stackBase__+92844;
      var $10930=__stackBase__+92848;
      var $10931=__stackBase__+92852;
      var $10932=__stackBase__+92856;
      var $10933=__stackBase__+92920;
      var $10934=__stackBase__+92924;
      var $10935=__stackBase__+92928;
      var $10936=__stackBase__+92932;
      var $10937=__stackBase__+92936;
      var $10938=__stackBase__+92940;
      var $10939=__stackBase__+92944;
      var $10940=__stackBase__+92948;
      var $10941=__stackBase__+93012;
      var $10942=__stackBase__+93016;
      var $10943=__stackBase__+93020;
      var $10944=__stackBase__+93024;
      var $10945=__stackBase__+93028;
      var $10946=__stackBase__+93032;
      var $10947=__stackBase__+93036;
      var $10948=__stackBase__+93040;
      var $10949=__stackBase__+93104;
      var $10950=__stackBase__+93108;
      var $10951=__stackBase__+93112;
      var $10952=__stackBase__+93116;
      var $10953=__stackBase__+93120;
      var $10954=__stackBase__+93124;
      var $10955=__stackBase__+93128;
      var $10956=__stackBase__+93132;
      var $10957=__stackBase__+93196;
      var $10958=__stackBase__+93200;
      var $10959=__stackBase__+93204;
      var $10960=__stackBase__+93208;
      var $10961=__stackBase__+93212;
      var $10962=__stackBase__+93216;
      var $10963=__stackBase__+93220;
      var $10964=__stackBase__+93224;
      var $10965=__stackBase__+93288;
      var $10966=__stackBase__+93292;
      var $10967=__stackBase__+93296;
      var $10968=__stackBase__+93300;
      var $10969=__stackBase__+93304;
      var $10970=__stackBase__+93308;
      var $10971=__stackBase__+93312;
      var $10972=__stackBase__+93316;
      var $10973=__stackBase__+93380;
      var $10974=__stackBase__+93384;
      var $10975=__stackBase__+93388;
      var $10976=__stackBase__+93392;
      var $10977=__stackBase__+93396;
      var $10978=__stackBase__+93400;
      var $10979=__stackBase__+93404;
      var $10980=__stackBase__+93408;
      var $10981=__stackBase__+93472;
      var $10982=__stackBase__+93476;
      var $10983=__stackBase__+93480;
      var $10984=__stackBase__+93484;
      var $10985=__stackBase__+93488;
      var $10986=__stackBase__+93492;
      var $10987=__stackBase__+93496;
      var $10988=__stackBase__+93500;
      var $10989=__stackBase__+93564;
      var $10990=__stackBase__+93568;
      var $10991=__stackBase__+93572;
      var $10992=__stackBase__+93576;
      var $10993=__stackBase__+93580;
      var $10994=__stackBase__+93584;
      var $10995=__stackBase__+93588;
      var $10996=__stackBase__+93592;
      var $10997=__stackBase__+93656;
      var $10998=__stackBase__+93660;
      var $10999=__stackBase__+93664;
      var $11000=__stackBase__+93668;
      var $11001=__stackBase__+93672;
      var $11002=__stackBase__+93676;
      var $11003=__stackBase__+93680;
      var $11004=__stackBase__+93684;
      var $11005=__stackBase__+93748;
      var $11006=__stackBase__+93752;
      var $11007=__stackBase__+93756;
      var $11008=__stackBase__+93760;
      var $11009=__stackBase__+93764;
      var $11010=__stackBase__+93768;
      var $11011=__stackBase__+93772;
      var $11012=__stackBase__+93776;
      var $11013=__stackBase__+93840;
      var $11014=__stackBase__+93844;
      var $11015=__stackBase__+93848;
      var $11016=__stackBase__+93852;
      var $11017=__stackBase__+93856;
      var $11018=__stackBase__+93860;
      var $11019=__stackBase__+93864;
      var $11020=__stackBase__+93868;
      var $11021=__stackBase__+93932;
      var $11022=__stackBase__+93936;
      var $11023=__stackBase__+93940;
      var $11024=__stackBase__+93944;
      var $11025=__stackBase__+93948;
      var $11026=__stackBase__+93952;
      var $11027=__stackBase__+93956;
      var $11028=__stackBase__+93960;
      var $11029=__stackBase__+94024;
      var $11030=__stackBase__+94028;
      var $11031=__stackBase__+94032;
      var $11032=__stackBase__+94036;
      var $11033=__stackBase__+94040;
      var $11034=__stackBase__+94044;
      var $11035=__stackBase__+94048;
      var $11036=__stackBase__+94052;
      var $11037=__stackBase__+94116;
      var $11038=__stackBase__+94120;
      var $11039=__stackBase__+94124;
      var $11040=__stackBase__+94128;
      var $11041=__stackBase__+94132;
      var $11042=__stackBase__+94136;
      var $11043=__stackBase__+94140;
      var $11044=__stackBase__+94144;
      var $11045=__stackBase__+94208;
      var $11046=__stackBase__+94212;
      var $11047=__stackBase__+94216;
      var $11048=__stackBase__+94220;
      var $11049=__stackBase__+94224;
      var $11050=__stackBase__+94228;
      var $11051=__stackBase__+94232;
      var $11052=__stackBase__+94236;
      var $11053=__stackBase__+94300;
      var $11054=__stackBase__+94304;
      var $11055=__stackBase__+94308;
      var $11056=__stackBase__+94312;
      var $11057=__stackBase__+94316;
      var $11058=__stackBase__+94320;
      var $11059=__stackBase__+94324;
      var $11060=__stackBase__+94328;
      var $11061=__stackBase__+94392;
      var $11062=__stackBase__+94396;
      var $11063=__stackBase__+94400;
      var $11064=__stackBase__+94404;
      var $11065=__stackBase__+94408;
      var $11066=__stackBase__+94412;
      var $11067=__stackBase__+94416;
      var $11068=__stackBase__+94420;
      var $11069=__stackBase__+94484;
      var $11070=__stackBase__+94488;
      var $11071=__stackBase__+94492;
      var $11072=__stackBase__+94496;
      var $11073=__stackBase__+94500;
      var $11074=__stackBase__+94504;
      var $11075=__stackBase__+94508;
      var $11076=__stackBase__+94512;
      var $11077=__stackBase__+94576;
      var $11078=__stackBase__+94580;
      var $11079=__stackBase__+94584;
      var $11080=__stackBase__+94588;
      var $11081=__stackBase__+94592;
      var $11082=__stackBase__+94596;
      var $11083=__stackBase__+94600;
      var $11084=__stackBase__+94604;
      var $11085=__stackBase__+94668;
      var $11086=__stackBase__+94672;
      var $11087=__stackBase__+94676;
      var $11088=__stackBase__+94680;
      var $11089=__stackBase__+94684;
      var $11090=__stackBase__+94688;
      var $11091=__stackBase__+94692;
      var $11092=__stackBase__+94696;
      var $11093=__stackBase__+94760;
      var $11094=__stackBase__+94764;
      var $11095=__stackBase__+94768;
      var $11096=__stackBase__+94772;
      var $11097=__stackBase__+94776;
      var $11098=__stackBase__+94780;
      var $11099=__stackBase__+94784;
      var $11100=__stackBase__+94788;
      var $11101=__stackBase__+94852;
      var $11102=__stackBase__+94856;
      var $11103=__stackBase__+94860;
      var $11104=__stackBase__+94864;
      var $11105=__stackBase__+94868;
      var $11106=__stackBase__+94872;
      var $11107=__stackBase__+94876;
      var $11108=__stackBase__+94880;
      var $11109=__stackBase__+94944;
      var $11110=__stackBase__+94948;
      var $11111=__stackBase__+94952;
      var $11112=__stackBase__+94956;
      var $11113=__stackBase__+94960;
      var $11114=__stackBase__+94964;
      var $11115=__stackBase__+94968;
      var $11116=__stackBase__+94972;
      var $11117=__stackBase__+95036;
      var $11118=__stackBase__+95040;
      var $11119=__stackBase__+95044;
      var $11120=__stackBase__+95048;
      var $11121=__stackBase__+95052;
      var $11122=__stackBase__+95056;
      var $11123=__stackBase__+95060;
      var $11124=__stackBase__+95064;
      var $11125=__stackBase__+95128;
      var $11126=__stackBase__+95132;
      var $11127=__stackBase__+95136;
      var $11128=__stackBase__+95140;
      var $11129=__stackBase__+95144;
      var $11130=__stackBase__+95148;
      var $11131=__stackBase__+95152;
      var $11132=__stackBase__+95156;
      var $11133=__stackBase__+95220;
      var $11134=__stackBase__+95224;
      var $11135=__stackBase__+95228;
      var $11136=__stackBase__+95232;
      var $11137=__stackBase__+95236;
      var $11138=__stackBase__+95240;
      var $11139=__stackBase__+95244;
      var $11140=__stackBase__+95248;
      var $11141=__stackBase__+95312;
      var $11142=__stackBase__+95316;
      var $11143=__stackBase__+95320;
      var $11144=__stackBase__+95324;
      var $11145=__stackBase__+95328;
      var $11146=__stackBase__+95332;
      var $11147=__stackBase__+95336;
      var $11148=__stackBase__+95340;
      var $11149=__stackBase__+95404;
      var $11150=__stackBase__+95408;
      var $11151=__stackBase__+95412;
      var $11152=__stackBase__+95416;
      var $11153=__stackBase__+95420;
      var $11154=__stackBase__+95424;
      var $11155=__stackBase__+95428;
      var $11156=__stackBase__+95432;
      var $11157=__stackBase__+95496;
      var $11158=__stackBase__+95500;
      var $11159=__stackBase__+95504;
      var $11160=__stackBase__+95508;
      var $11161=__stackBase__+95512;
      var $11162=__stackBase__+95516;
      var $11163=__stackBase__+95520;
      var $11164=__stackBase__+95524;
      var $11165=__stackBase__+95588;
      var $11166=__stackBase__+95592;
      var $11167=__stackBase__+95596;
      var $11168=__stackBase__+95600;
      var $11169=__stackBase__+95604;
      var $11170=__stackBase__+95608;
      var $11171=__stackBase__+95612;
      var $11172=__stackBase__+95616;
      var $11173=__stackBase__+95680;
      var $11174=__stackBase__+95684;
      var $11175=__stackBase__+95688;
      var $11176=__stackBase__+95692;
      var $11177=__stackBase__+95696;
      var $11178=__stackBase__+95700;
      var $11179=__stackBase__+95704;
      var $11180=__stackBase__+95708;
      var $11181=__stackBase__+95772;
      var $11182=__stackBase__+95776;
      var $11183=__stackBase__+95780;
      var $11184=__stackBase__+95784;
      var $11185=__stackBase__+95788;
      var $11186=__stackBase__+95792;
      var $11187=__stackBase__+95796;
      var $11188=__stackBase__+95800;
      var $11189=__stackBase__+95864;
      var $11190=__stackBase__+95868;
      var $11191=__stackBase__+95872;
      var $11192=__stackBase__+95876;
      var $11193=__stackBase__+95880;
      var $11194=__stackBase__+95884;
      var $11195=__stackBase__+95888;
      var $11196=__stackBase__+95892;
      var $11197=__stackBase__+95956;
      var $11198=__stackBase__+95960;
      var $11199=__stackBase__+95964;
      var $11200=__stackBase__+95968;
      var $11201=__stackBase__+95972;
      var $11202=__stackBase__+95976;
      var $11203=__stackBase__+95980;
      var $11204=__stackBase__+95984;
      var $11205=__stackBase__+96048;
      var $11206=__stackBase__+96052;
      var $11207=__stackBase__+96056;
      var $11208=__stackBase__+96060;
      var $11209=__stackBase__+96064;
      var $11210=__stackBase__+96068;
      var $11211=__stackBase__+96072;
      var $11212=__stackBase__+96076;
      var $11213=__stackBase__+96140;
      var $11214=__stackBase__+96144;
      var $11215=__stackBase__+96148;
      var $11216=__stackBase__+96152;
      var $11217=__stackBase__+96156;
      var $11218=__stackBase__+96160;
      var $11219=__stackBase__+96164;
      var $11220=__stackBase__+96168;
      var $11221=__stackBase__+96232;
      var $11222=__stackBase__+96236;
      var $11223=__stackBase__+96240;
      var $11224=__stackBase__+96244;
      var $11225=__stackBase__+96248;
      var $11226=__stackBase__+96252;
      var $11227=__stackBase__+96256;
      var $11228=__stackBase__+96260;
      var $11229=__stackBase__+96324;
      var $11230=__stackBase__+96328;
      var $11231=__stackBase__+96332;
      var $11232=__stackBase__+96336;
      var $11233=__stackBase__+96340;
      var $11234=__stackBase__+96344;
      var $11235=__stackBase__+96348;
      var $11236=__stackBase__+96352;
      var $11237=__stackBase__+96416;
      var $11238=__stackBase__+96420;
      var $11239=__stackBase__+96424;
      var $11240=__stackBase__+96428;
      var $11241=__stackBase__+96432;
      var $11242=__stackBase__+96436;
      var $11243=__stackBase__+96440;
      var $11244=__stackBase__+96444;
      var $11245=__stackBase__+96508;
      var $11246=__stackBase__+96512;
      var $11247=__stackBase__+96516;
      var $11248=__stackBase__+96520;
      var $11249=__stackBase__+96524;
      var $11250=__stackBase__+96528;
      var $11251=__stackBase__+96532;
      var $11252=__stackBase__+96536;
      var $11253=__stackBase__+96600;
      var $11254=__stackBase__+96604;
      var $11255=__stackBase__+96608;
      var $11256=__stackBase__+96612;
      var $11257=__stackBase__+96616;
      var $11258=__stackBase__+96620;
      var $11259=__stackBase__+96624;
      var $11260=__stackBase__+96628;
      var $11261=__stackBase__+96692;
      var $11262=__stackBase__+96696;
      var $11263=__stackBase__+96700;
      var $11264=__stackBase__+96704;
      var $11265=__stackBase__+96708;
      var $11266=__stackBase__+96712;
      var $11267=__stackBase__+96716;
      var $11268=__stackBase__+96720;
      var $11269=__stackBase__+96784;
      var $11270=__stackBase__+96788;
      var $11271=__stackBase__+96792;
      var $11272=__stackBase__+96796;
      var $11273=__stackBase__+96800;
      var $11274=__stackBase__+96804;
      var $11275=__stackBase__+96808;
      var $11276=__stackBase__+96812;
      var $11277=__stackBase__+96876;
      var $11278=__stackBase__+96880;
      var $11279=__stackBase__+96884;
      var $11280=__stackBase__+96888;
      var $11281=__stackBase__+96892;
      var $11282=__stackBase__+96896;
      var $11283=__stackBase__+96900;
      var $11284=__stackBase__+96904;
      var $11285=__stackBase__+96968;
      var $11286=__stackBase__+96972;
      var $11287=__stackBase__+96976;
      var $11288=__stackBase__+96980;
      var $11289=__stackBase__+96984;
      var $11290=__stackBase__+96988;
      var $11291=__stackBase__+96992;
      var $11292=__stackBase__+96996;
      var $11293=__stackBase__+97060;
      var $11294=__stackBase__+97064;
      var $11295=__stackBase__+97068;
      var $11296=__stackBase__+97072;
      var $11297=__stackBase__+97076;
      var $11298=__stackBase__+97080;
      var $11299=__stackBase__+97084;
      var $11300=__stackBase__+97088;
      var $11301=__stackBase__+97152;
      var $11302=__stackBase__+97156;
      var $11303=__stackBase__+97160;
      var $11304=__stackBase__+97164;
      var $11305=__stackBase__+97168;
      var $11306=__stackBase__+97172;
      var $11307=__stackBase__+97176;
      var $11308=__stackBase__+97180;
      var $11309=__stackBase__+97244;
      var $11310=__stackBase__+97248;
      var $11311=__stackBase__+97252;
      var $11312=__stackBase__+97256;
      var $11313=__stackBase__+97260;
      var $11314=__stackBase__+97264;
      var $11315=__stackBase__+97268;
      var $11316=__stackBase__+97272;
      var $11317=__stackBase__+97336;
      var $11318=__stackBase__+97340;
      var $11319=__stackBase__+97344;
      var $11320=__stackBase__+97348;
      var $11321=__stackBase__+97352;
      var $11322=__stackBase__+97356;
      var $11323=__stackBase__+97360;
      var $11324=__stackBase__+97364;
      var $11325=__stackBase__+97428;
      var $11326=__stackBase__+97432;
      var $11327=__stackBase__+97436;
      var $11328=__stackBase__+97440;
      var $11329=__stackBase__+97444;
      var $11330=__stackBase__+97448;
      var $11331=__stackBase__+97452;
      var $11332=__stackBase__+97456;
      var $11333=__stackBase__+97520;
      var $11334=__stackBase__+97524;
      var $11335=__stackBase__+97528;
      var $11336=__stackBase__+97532;
      var $11337=__stackBase__+97536;
      var $11338=__stackBase__+97540;
      var $11339=__stackBase__+97544;
      var $11340=__stackBase__+97548;
      var $11341=__stackBase__+97612;
      var $11342=__stackBase__+97616;
      var $11343=__stackBase__+97620;
      var $11344=__stackBase__+97624;
      var $11345=__stackBase__+97628;
      var $11346=__stackBase__+97632;
      var $11347=__stackBase__+97636;
      var $11348=__stackBase__+97640;
      var $11349=__stackBase__+97704;
      var $11350=__stackBase__+97708;
      var $11351=__stackBase__+97712;
      var $11352=__stackBase__+97716;
      var $11353=__stackBase__+97720;
      var $11354=__stackBase__+97724;
      var $11355=__stackBase__+97728;
      var $11356=__stackBase__+97732;
      var $11357=__stackBase__+97796;
      var $11358=__stackBase__+97800;
      var $11359=__stackBase__+97804;
      var $11360=__stackBase__+97808;
      var $11361=__stackBase__+97812;
      var $11362=__stackBase__+97816;
      var $11363=__stackBase__+97820;
      var $11364=__stackBase__+97824;
      var $11365=__stackBase__+97888;
      var $11366=__stackBase__+97892;
      var $11367=__stackBase__+97896;
      var $11368=__stackBase__+97900;
      var $11369=__stackBase__+97904;
      var $11370=__stackBase__+97908;
      var $11371=__stackBase__+97912;
      var $11372=__stackBase__+97916;
      var $11373=__stackBase__+97980;
      var $11374=__stackBase__+97984;
      var $11375=__stackBase__+97988;
      var $11376=__stackBase__+97992;
      var $11377=__stackBase__+97996;
      var $11378=__stackBase__+98000;
      var $11379=__stackBase__+98004;
      var $11380=__stackBase__+98008;
      var $11381=__stackBase__+98072;
      var $11382=__stackBase__+98076;
      var $11383=__stackBase__+98080;
      var $11384=__stackBase__+98084;
      var $11385=__stackBase__+98088;
      var $11386=__stackBase__+98092;
      var $11387=__stackBase__+98096;
      var $11388=__stackBase__+98100;
      var $11389=__stackBase__+98164;
      var $11390=__stackBase__+98168;
      var $11391=__stackBase__+98172;
      var $11392=__stackBase__+98176;
      var $11393=__stackBase__+98180;
      var $11394=__stackBase__+98184;
      var $11395=__stackBase__+98188;
      var $11396=__stackBase__+98192;
      var $11397=__stackBase__+98256;
      var $11398=__stackBase__+98260;
      var $11399=__stackBase__+98264;
      var $11400=__stackBase__+98268;
      var $11401=__stackBase__+98272;
      var $11402=__stackBase__+98276;
      var $11403=__stackBase__+98280;
      var $11404=__stackBase__+98284;
      var $11405=__stackBase__+98348;
      var $11406=__stackBase__+98352;
      var $11407=__stackBase__+98356;
      var $11408=__stackBase__+98360;
      var $11409=__stackBase__+98364;
      var $11410=__stackBase__+98368;
      var $11411=__stackBase__+98372;
      var $11412=__stackBase__+98376;
      var $11413=__stackBase__+98440;
      var $11414=__stackBase__+98444;
      var $11415=__stackBase__+98448;
      var $11416=__stackBase__+98452;
      var $11417=__stackBase__+98456;
      var $11418=__stackBase__+98460;
      var $11419=__stackBase__+98464;
      var $11420=__stackBase__+98468;
      var $11421=__stackBase__+98532;
      var $11422=__stackBase__+98536;
      var $11423=__stackBase__+98540;
      var $11424=__stackBase__+98544;
      var $11425=__stackBase__+98548;
      var $11426=__stackBase__+98552;
      var $11427=__stackBase__+98556;
      var $11428=__stackBase__+98560;
      var $11429=__stackBase__+98624;
      var $11430=__stackBase__+98628;
      var $11431=__stackBase__+98632;
      var $11432=__stackBase__+98636;
      var $11433=__stackBase__+98640;
      var $11434=__stackBase__+98644;
      var $11435=__stackBase__+98648;
      var $11436=__stackBase__+98652;
      var $11437=__stackBase__+98716;
      var $11438=__stackBase__+98720;
      var $11439=__stackBase__+98724;
      var $11440=__stackBase__+98728;
      var $11441=__stackBase__+98732;
      var $11442=__stackBase__+98736;
      var $11443=__stackBase__+98740;
      var $11444=__stackBase__+98744;
      var $11445=__stackBase__+98808;
      var $11446=__stackBase__+98812;
      var $11447=__stackBase__+98816;
      var $11448=__stackBase__+98820;
      var $11449=__stackBase__+98824;
      var $11450=__stackBase__+98828;
      var $11451=__stackBase__+98832;
      var $11452=__stackBase__+98836;
      var $11453=__stackBase__+98900;
      var $11454=__stackBase__+98904;
      var $11455=__stackBase__+98908;
      var $11456=__stackBase__+98912;
      var $11457=__stackBase__+98916;
      var $11458=__stackBase__+98920;
      var $11459=__stackBase__+98924;
      var $11460=__stackBase__+98928;
      var $11461=__stackBase__+98992;
      var $11462=__stackBase__+98996;
      var $11463=__stackBase__+99000;
      var $11464=__stackBase__+99004;
      var $11465=__stackBase__+99008;
      var $11466=__stackBase__+99012;
      var $11467=__stackBase__+99016;
      var $11468=__stackBase__+99020;
      var $11469=__stackBase__+99084;
      var $11470=__stackBase__+99088;
      var $11471=__stackBase__+99092;
      var $11472=__stackBase__+99096;
      var $11473=__stackBase__+99100;
      var $11474=__stackBase__+99104;
      var $11475=__stackBase__+99108;
      var $11476=__stackBase__+99112;
      var $11477=__stackBase__+99176;
      var $11478=__stackBase__+99180;
      var $11479=__stackBase__+99184;
      var $11480=__stackBase__+99188;
      var $11481=__stackBase__+99192;
      var $11482=__stackBase__+99196;
      var $11483=__stackBase__+99200;
      var $11484=__stackBase__+99204;
      var $11485=__stackBase__+99268;
      var $11486=__stackBase__+99272;
      var $11487=__stackBase__+99276;
      var $11488=__stackBase__+99280;
      var $11489=__stackBase__+99284;
      var $11490=__stackBase__+99288;
      var $11491=__stackBase__+99292;
      var $11492=__stackBase__+99296;
      var $11493=__stackBase__+99360;
      var $11494=__stackBase__+99364;
      var $11495=__stackBase__+99368;
      var $11496=__stackBase__+99372;
      var $11497=__stackBase__+99376;
      var $11498=__stackBase__+99380;
      var $11499=__stackBase__+99384;
      var $11500=__stackBase__+99388;
      var $11501=__stackBase__+99452;
      var $11502=__stackBase__+99456;
      var $11503=__stackBase__+99460;
      var $11504=__stackBase__+99464;
      var $11505=__stackBase__+99468;
      var $11506=__stackBase__+99472;
      var $11507=__stackBase__+99476;
      var $11508=__stackBase__+99480;
      var $11509=__stackBase__+99544;
      var $11510=__stackBase__+99548;
      var $11511=__stackBase__+99552;
      var $11512=__stackBase__+99556;
      var $11513=__stackBase__+99560;
      var $11514=__stackBase__+99564;
      var $11515=__stackBase__+99568;
      var $11516=__stackBase__+99572;
      var $11517=__stackBase__+99636;
      var $11518=__stackBase__+99640;
      var $11519=__stackBase__+99644;
      var $11520=__stackBase__+99648;
      var $11521=__stackBase__+99652;
      var $11522=__stackBase__+99656;
      var $11523=__stackBase__+99660;
      var $11524=__stackBase__+99664;
      var $11525=__stackBase__+99728;
      var $11526=__stackBase__+99732;
      var $11527=__stackBase__+99736;
      var $11528=__stackBase__+99740;
      var $11529=__stackBase__+99744;
      var $11530=__stackBase__+99748;
      var $11531=__stackBase__+99752;
      var $11532=__stackBase__+99756;
      var $11533=__stackBase__+99820;
      var $11534=__stackBase__+99824;
      var $11535=__stackBase__+99828;
      var $11536=__stackBase__+99832;
      var $11537=__stackBase__+99836;
      var $11538=__stackBase__+99840;
      var $11539=__stackBase__+99844;
      var $11540=__stackBase__+99848;
      var $11541=__stackBase__+99912;
      var $11542=__stackBase__+99916;
      var $11543=__stackBase__+99920;
      var $11544=__stackBase__+99924;
      var $11545=__stackBase__+99928;
      var $11546=__stackBase__+99932;
      var $11547=__stackBase__+99936;
      var $11548=__stackBase__+99940;
      var $11549=__stackBase__+100004;
      var $11550=__stackBase__+100008;
      var $11551=__stackBase__+100012;
      var $11552=__stackBase__+100016;
      var $11553=__stackBase__+100020;
      var $11554=__stackBase__+100024;
      var $11555=__stackBase__+100028;
      var $11556=__stackBase__+100032;
      var $11557=__stackBase__+100096;
      var $11558=__stackBase__+100100;
      var $11559=__stackBase__+100104;
      var $11560=__stackBase__+100108;
      var $11561=__stackBase__+100112;
      var $11562=__stackBase__+100116;
      var $11563=__stackBase__+100120;
      var $11564=__stackBase__+100124;
      var $11565=__stackBase__+100188;
      var $11566=__stackBase__+100192;
      var $11567=__stackBase__+100196;
      var $11568=__stackBase__+100200;
      var $11569=__stackBase__+100204;
      var $11570=__stackBase__+100208;
      var $11571=__stackBase__+100212;
      var $11572=__stackBase__+100216;
      var $11573=__stackBase__+100280;
      var $11574=__stackBase__+100284;
      var $11575=__stackBase__+100288;
      var $11576=__stackBase__+100292;
      var $11577=__stackBase__+100296;
      var $11578=__stackBase__+100300;
      var $11579=__stackBase__+100304;
      var $11580=__stackBase__+100308;
      var $11581=__stackBase__+100372;
      var $11582=__stackBase__+100376;
      var $11583=__stackBase__+100380;
      var $11584=__stackBase__+100384;
      var $11585=__stackBase__+100388;
      var $11586=__stackBase__+100392;
      var $11587=__stackBase__+100396;
      var $11588=__stackBase__+100400;
      var $11589=__stackBase__+100464;
      var $11590=__stackBase__+100468;
      var $11591=__stackBase__+100472;
      var $11592=__stackBase__+100476;
      var $11593=__stackBase__+100480;
      var $11594=__stackBase__+100484;
      var $11595=__stackBase__+100488;
      var $11596=__stackBase__+100492;
      var $11597=__stackBase__+100556;
      var $11598=__stackBase__+100560;
      var $11599=__stackBase__+100564;
      var $11600=__stackBase__+100568;
      var $11601=__stackBase__+100572;
      var $11602=__stackBase__+100576;
      var $11603=__stackBase__+100580;
      var $11604=__stackBase__+100584;
      var $11605=__stackBase__+100648;
      var $11606=__stackBase__+100652;
      var $11607=__stackBase__+100656;
      var $11608=__stackBase__+100660;
      var $11609=__stackBase__+100664;
      var $11610=__stackBase__+100668;
      var $11611=__stackBase__+100672;
      var $11612=__stackBase__+100676;
      var $11613=__stackBase__+100740;
      var $11614=__stackBase__+100744;
      var $11615=__stackBase__+100748;
      var $11616=__stackBase__+100752;
      var $11617=__stackBase__+100756;
      var $11618=__stackBase__+100760;
      var $11619=__stackBase__+100764;
      var $11620=__stackBase__+100768;
      var $11621=__stackBase__+100832;
      var $11622=__stackBase__+100836;
      var $11623=__stackBase__+100840;
      var $11624=__stackBase__+100844;
      var $11625=__stackBase__+100848;
      var $11626=__stackBase__+100852;
      var $11627=__stackBase__+100856;
      var $11628=__stackBase__+100860;
      var $11629=__stackBase__+100924;
      var $11630=__stackBase__+100928;
      var $11631=__stackBase__+100932;
      var $11632=__stackBase__+100936;
      var $11633=__stackBase__+100940;
      var $11634=__stackBase__+100944;
      var $11635=__stackBase__+100948;
      var $11636=__stackBase__+100952;
      var $11637=__stackBase__+101016;
      var $11638=__stackBase__+101020;
      var $11639=__stackBase__+101024;
      var $11640=__stackBase__+101028;
      var $11641=__stackBase__+101032;
      var $11642=__stackBase__+101036;
      var $11643=__stackBase__+101040;
      var $11644=__stackBase__+101044;
      var $11645=__stackBase__+101108;
      var $11646=__stackBase__+101112;
      var $11647=__stackBase__+101116;
      var $11648=__stackBase__+101120;
      var $11649=__stackBase__+101124;
      var $11650=__stackBase__+101128;
      var $11651=__stackBase__+101132;
      var $11652=__stackBase__+101136;
      var $11653=__stackBase__+101200;
      var $11654=__stackBase__+101204;
      var $11655=__stackBase__+101208;
      var $11656=__stackBase__+101212;
      var $11657=__stackBase__+101216;
      var $11658=__stackBase__+101220;
      var $11659=__stackBase__+101224;
      var $11660=__stackBase__+101228;
      var $11661=__stackBase__+101292;
      var $11662=__stackBase__+101296;
      var $11663=__stackBase__+101300;
      var $11664=__stackBase__+101304;
      var $11665=__stackBase__+101308;
      var $11666=__stackBase__+101312;
      var $11667=__stackBase__+101316;
      var $11668=__stackBase__+101320;
      var $11669=__stackBase__+101384;
      var $11670=__stackBase__+101388;
      var $11671=__stackBase__+101392;
      var $11672=__stackBase__+101396;
      var $11673=__stackBase__+101400;
      var $11674=__stackBase__+101404;
      var $11675=__stackBase__+101408;
      var $11676=__stackBase__+101412;
      var $11677=__stackBase__+101476;
      var $11678=__stackBase__+101480;
      var $11679=__stackBase__+101484;
      var $11680=__stackBase__+101488;
      var $11681=__stackBase__+101492;
      var $11682=__stackBase__+101496;
      var $11683=__stackBase__+101500;
      $4689=$typelist;
      var $11684=$4689;
      var $11685=$4684;
      var $11686=$4685;
      var $11687=$4686;
      var $11688=$result_i;
      var $11689=$4687;
      var $11690=$4688;
      HEAP32[(($4684)>>2)]=408;
      HEAP32[(($4685)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4686)>>2)]=54;
      var $11691=HEAP32[(($4684)>>2)];
      var $11692=HEAP32[(($4685)>>2)];
      var $11693=HEAP32[(($4686)>>2)];
      var $11694=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11691, $11692, $11693) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $11695
      HEAP32[(($result_i)>>2)]=$11694;
      var $11696=HEAP32[(($result_i)>>2)];
      var $11697=(($11696)|0)==0;
      if ($11697) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11698
      var $11699=___cxa_allocate_exception(4);
      var $11700=$11699;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($11700);
      (function() { try { __THREW__ = false; return ___cxa_throw($11699, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $11701
      var $11702=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11703=$11702.f0;
      HEAP32[(($4687)>>2)]=$11703;
      var $11704=$11702.f1;
      HEAP32[(($4688)>>2)]=$11704;
      var $11705=HEAP32[(($4688)>>2)];
      var $11706=(($11705)|0) < 0;
      if ($11706) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $11707
      var $11708=HEAP32[(($4687)>>2)];
      ___cxa_call_unexpected($11708);
      throw "Reached an unreachable!"
    case 5: // $11709
      var $11710=HEAP32[(($4687)>>2)];
      var $11711=HEAP32[(($4687)>>2)];
      var $11712=HEAP32[(($4688)>>2)];
      var $11713=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $11711, tempValue);
      var $11714=($11713.f1 = $11712, $11713);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $11715
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $11716=HEAP32[(($result_i)>>2)];
      var $11717=$4684;
      var $11718=$4685;
      var $11719=$4686;
      var $11720=$result_i;
      var $11721=$4687;
      var $11722=$4688;
      var $11723=$11716;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4691, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11681; break; }
    case 8: // $11724
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4694, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11681; break; }
    case 9: // $11725
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4695, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11681; break; }
    case 10: // $11726
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4696, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 11681; break; }
    case 11: // $11727
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4697, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 11681; break; }
    case 12: // $11728
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 11681; break; }
    case 13: // $11729
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11681; break; }
    case 14: // $11730
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4690, $4691, $4694, $4695, $4696, $4697, $4698, $4699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11681; break; }
    case 15: // $11731
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($11723, 47, 1, 0, ((STRING_TABLE.__str192)|0), ((STRING_TABLE.__str193)|0), $4690) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 11681; break; }
    case 16: // $11732
      var $11733=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $11723);
      var $11734=__ZN11simple_listI16input_type_entryE6appendERS0_($11684, $11733);
      var $11735=$4689;
      var $11736=$4679;
      var $11737=$4680;
      var $11738=$4681;
      var $11739=$result_i1;
      var $11740=$4682;
      var $11741=$4683;
      HEAP32[(($4679)>>2)]=408;
      HEAP32[(($4680)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4681)>>2)]=55;
      var $11742=HEAP32[(($4679)>>2)];
      var $11743=HEAP32[(($4680)>>2)];
      var $11744=HEAP32[(($4681)>>2)];
      var $11745=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11742, $11743, $11744) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $11746
      HEAP32[(($result_i1)>>2)]=$11745;
      var $11747=HEAP32[(($result_i1)>>2)];
      var $11748=(($11747)|0)==0;
      if ($11748) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $11749
      var $11750=___cxa_allocate_exception(4);
      var $11751=$11750;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($11751);
      (function() { try { __THREW__ = false; return ___cxa_throw($11750, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $11752
      var $11753=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11754=$11753.f0;
      HEAP32[(($4682)>>2)]=$11754;
      var $11755=$11753.f1;
      HEAP32[(($4683)>>2)]=$11755;
      var $11756=HEAP32[(($4683)>>2)];
      var $11757=(($11756)|0) < 0;
      if ($11757) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $11758
      var $11759=HEAP32[(($4682)>>2)];
      ___cxa_call_unexpected($11759);
      throw "Reached an unreachable!"
    case 21: // $11760
      var $11761=HEAP32[(($4682)>>2)];
      var $11762=HEAP32[(($4682)>>2)];
      var $11763=HEAP32[(($4683)>>2)];
      var $11764=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $11762, tempValue);
      var $11765=($11764.f1 = $11763, $11764);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $11766
      throw "Reached an unreachable!"
    case 23: // $_ZnwjPKci_exit2
      var $11767=HEAP32[(($result_i1)>>2)];
      var $11768=$4679;
      var $11769=$4680;
      var $11770=$4681;
      var $11771=$result_i1;
      var $11772=$4682;
      var $11773=$4683;
      var $11774=$11767;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4701, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 11686; break; }
    case 24: // $11775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4702, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 11686; break; }
    case 25: // $11776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4703, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 11686; break; }
    case 26: // $11777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 11686; break; }
    case 27: // $11778
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 11686; break; }
    case 28: // $11779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 11686; break; }
    case 29: // $11780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 11686; break; }
    case 30: // $11781
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4700, $4701, $4702, $4703, $4704, $4705, $4706, $4707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 11686; break; }
    case 31: // $11782
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($11774, 48, 1, 0, ((STRING_TABLE.__str194)|0), ((STRING_TABLE.__str195)|0), $4700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 11686; break; }
    case 32: // $11783
      var $11784=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $11774);
      var $11785=__ZN11simple_listI16input_type_entryE6appendERS0_($11735, $11784);
      var $11786=$4689;
      var $11787=$4674;
      var $11788=$4675;
      var $11789=$4676;
      var $11790=$result_i3;
      var $11791=$4677;
      var $11792=$4678;
      HEAP32[(($4674)>>2)]=408;
      HEAP32[(($4675)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4676)>>2)]=56;
      var $11793=HEAP32[(($4674)>>2)];
      var $11794=HEAP32[(($4675)>>2)];
      var $11795=HEAP32[(($4676)>>2)];
      var $11796=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11793, $11794, $11795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; };
    case 33: // $11797
      HEAP32[(($result_i3)>>2)]=$11796;
      var $11798=HEAP32[(($result_i3)>>2)];
      var $11799=(($11798)|0)==0;
      if ($11799) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $11800
      var $11801=___cxa_allocate_exception(4);
      var $11802=$11801;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($11802);
      (function() { try { __THREW__ = false; return ___cxa_throw($11801, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $11803
      var $11804=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11805=$11804.f0;
      HEAP32[(($4677)>>2)]=$11805;
      var $11806=$11804.f1;
      HEAP32[(($4678)>>2)]=$11806;
      var $11807=HEAP32[(($4678)>>2)];
      var $11808=(($11807)|0) < 0;
      if ($11808) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $11809
      var $11810=HEAP32[(($4677)>>2)];
      ___cxa_call_unexpected($11810);
      throw "Reached an unreachable!"
    case 37: // $11811
      var $11812=HEAP32[(($4677)>>2)];
      var $11813=HEAP32[(($4677)>>2)];
      var $11814=HEAP32[(($4678)>>2)];
      var $11815=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $11813, tempValue);
      var $11816=($11815.f1 = $11814, $11815);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $11817
      throw "Reached an unreachable!"
    case 39: // $_ZnwjPKci_exit4
      var $11818=HEAP32[(($result_i3)>>2)];
      var $11819=$4674;
      var $11820=$4675;
      var $11821=$4676;
      var $11822=$result_i3;
      var $11823=$4677;
      var $11824=$4678;
      var $11825=$11818;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4709, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 11691; break; }
    case 40: // $11826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4710, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 11691; break; }
    case 41: // $11827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4711, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 11691; break; }
    case 42: // $11828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 11691; break; }
    case 43: // $11829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 11691; break; }
    case 44: // $11830
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 11691; break; }
    case 45: // $11831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 11691; break; }
    case 46: // $11832
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4708, $4709, $4710, $4711, $4712, $4713, $4714, $4715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 11691; break; }
    case 47: // $11833
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($11825, 49, 1, 0, ((STRING_TABLE.__str196)|0), ((STRING_TABLE.__str197)|0), $4708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 11691; break; }
    case 48: // $11834
      var $11835=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $11825);
      var $11836=__ZN11simple_listI16input_type_entryE6appendERS0_($11786, $11835);
      var $11837=$4689;
      var $11838=$4669;
      var $11839=$4670;
      var $11840=$4671;
      var $11841=$result_i5;
      var $11842=$4672;
      var $11843=$4673;
      HEAP32[(($4669)>>2)]=408;
      HEAP32[(($4670)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4671)>>2)]=57;
      var $11844=HEAP32[(($4669)>>2)];
      var $11845=HEAP32[(($4670)>>2)];
      var $11846=HEAP32[(($4671)>>2)];
      var $11847=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11844, $11845, $11846) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 51; break; };
    case 49: // $11848
      HEAP32[(($result_i5)>>2)]=$11847;
      var $11849=HEAP32[(($result_i5)>>2)];
      var $11850=(($11849)|0)==0;
      if ($11850) { __label__ = 50; break; } else { __label__ = 55; break; }
    case 50: // $11851
      var $11852=___cxa_allocate_exception(4);
      var $11853=$11852;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($11853);
      (function() { try { __THREW__ = false; return ___cxa_throw($11852, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 51; break; }
    case 51: // $11854
      var $11855=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11856=$11855.f0;
      HEAP32[(($4672)>>2)]=$11856;
      var $11857=$11855.f1;
      HEAP32[(($4673)>>2)]=$11857;
      var $11858=HEAP32[(($4673)>>2)];
      var $11859=(($11858)|0) < 0;
      if ($11859) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $11860
      var $11861=HEAP32[(($4672)>>2)];
      ___cxa_call_unexpected($11861);
      throw "Reached an unreachable!"
    case 53: // $11862
      var $11863=HEAP32[(($4672)>>2)];
      var $11864=HEAP32[(($4672)>>2)];
      var $11865=HEAP32[(($4673)>>2)];
      var $11866=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $11864, tempValue);
      var $11867=($11866.f1 = $11865, $11866);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 54: // $11868
      throw "Reached an unreachable!"
    case 55: // $_ZnwjPKci_exit6
      var $11869=HEAP32[(($result_i5)>>2)];
      var $11870=$4669;
      var $11871=$4670;
      var $11872=$4671;
      var $11873=$result_i5;
      var $11874=$4672;
      var $11875=$4673;
      var $11876=$11869;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4717, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 11696; break; }
    case 56: // $11877
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4718, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 11696; break; }
    case 57: // $11878
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4719, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 11696; break; }
    case 58: // $11879
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4720, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 11696; break; }
    case 59: // $11880
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4721, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 11696; break; }
    case 60: // $11881
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 11696; break; }
    case 61: // $11882
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 11696; break; }
    case 62: // $11883
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4716, $4717, $4718, $4719, $4720, $4721, $4722, $4723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 11696; break; }
    case 63: // $11884
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($11876, 50, 1, 0, ((STRING_TABLE.__str198)|0), ((STRING_TABLE.__str199)|0), $4716) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 11696; break; }
    case 64: // $11885
      var $11886=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $11876);
      var $11887=__ZN11simple_listI16input_type_entryE6appendERS0_($11837, $11886);
      var $11888=$4689;
      var $11889=$4664;
      var $11890=$4665;
      var $11891=$4666;
      var $11892=$result_i7;
      var $11893=$4667;
      var $11894=$4668;
      HEAP32[(($4664)>>2)]=408;
      HEAP32[(($4665)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4666)>>2)]=58;
      var $11895=HEAP32[(($4664)>>2)];
      var $11896=HEAP32[(($4665)>>2)];
      var $11897=HEAP32[(($4666)>>2)];
      var $11898=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11895, $11896, $11897) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 67; break; };
    case 65: // $11899
      HEAP32[(($result_i7)>>2)]=$11898;
      var $11900=HEAP32[(($result_i7)>>2)];
      var $11901=(($11900)|0)==0;
      if ($11901) { __label__ = 66; break; } else { __label__ = 71; break; }
    case 66: // $11902
      var $11903=___cxa_allocate_exception(4);
      var $11904=$11903;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($11904);
      (function() { try { __THREW__ = false; return ___cxa_throw($11903, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 67; break; }
    case 67: // $11905
      var $11906=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11907=$11906.f0;
      HEAP32[(($4667)>>2)]=$11907;
      var $11908=$11906.f1;
      HEAP32[(($4668)>>2)]=$11908;
      var $11909=HEAP32[(($4668)>>2)];
      var $11910=(($11909)|0) < 0;
      if ($11910) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $11911
      var $11912=HEAP32[(($4667)>>2)];
      ___cxa_call_unexpected($11912);
      throw "Reached an unreachable!"
    case 69: // $11913
      var $11914=HEAP32[(($4667)>>2)];
      var $11915=HEAP32[(($4667)>>2)];
      var $11916=HEAP32[(($4668)>>2)];
      var $11917=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $11915, tempValue);
      var $11918=($11917.f1 = $11916, $11917);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 70: // $11919
      throw "Reached an unreachable!"
    case 71: // $_ZnwjPKci_exit8
      var $11920=HEAP32[(($result_i7)>>2)];
      var $11921=$4664;
      var $11922=$4665;
      var $11923=$4666;
      var $11924=$result_i7;
      var $11925=$4667;
      var $11926=$4668;
      var $11927=$11920;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4725, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 11701; break; }
    case 72: // $11928
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4726, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 11701; break; }
    case 73: // $11929
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4727, 4, 0, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 11701; break; }
    case 74: // $11930
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 11701; break; }
    case 75: // $11931
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 11701; break; }
    case 76: // $11932
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 11701; break; }
    case 77: // $11933
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 11701; break; }
    case 78: // $11934
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4724, $4725, $4726, $4727, $4728, $4729, $4730, $4731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 11701; break; }
    case 79: // $11935
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($11927, 51, 1, 0, ((STRING_TABLE.__str200)|0), ((STRING_TABLE.__str201)|0), $4724) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 11701; break; }
    case 80: // $11936
      var $11937=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $11927);
      var $11938=__ZN11simple_listI16input_type_entryE6appendERS0_($11888, $11937);
      var $11939=$4689;
      var $11940=$4659;
      var $11941=$4660;
      var $11942=$4661;
      var $11943=$result_i9;
      var $11944=$4662;
      var $11945=$4663;
      HEAP32[(($4659)>>2)]=408;
      HEAP32[(($4660)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4661)>>2)]=59;
      var $11946=HEAP32[(($4659)>>2)];
      var $11947=HEAP32[(($4660)>>2)];
      var $11948=HEAP32[(($4661)>>2)];
      var $11949=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11946, $11947, $11948) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 83; break; };
    case 81: // $11950
      HEAP32[(($result_i9)>>2)]=$11949;
      var $11951=HEAP32[(($result_i9)>>2)];
      var $11952=(($11951)|0)==0;
      if ($11952) { __label__ = 82; break; } else { __label__ = 87; break; }
    case 82: // $11953
      var $11954=___cxa_allocate_exception(4);
      var $11955=$11954;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($11955);
      (function() { try { __THREW__ = false; return ___cxa_throw($11954, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 83; break; }
    case 83: // $11956
      var $11957=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11958=$11957.f0;
      HEAP32[(($4662)>>2)]=$11958;
      var $11959=$11957.f1;
      HEAP32[(($4663)>>2)]=$11959;
      var $11960=HEAP32[(($4663)>>2)];
      var $11961=(($11960)|0) < 0;
      if ($11961) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $11962
      var $11963=HEAP32[(($4662)>>2)];
      ___cxa_call_unexpected($11963);
      throw "Reached an unreachable!"
    case 85: // $11964
      var $11965=HEAP32[(($4662)>>2)];
      var $11966=HEAP32[(($4662)>>2)];
      var $11967=HEAP32[(($4663)>>2)];
      var $11968=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $11966, tempValue);
      var $11969=($11968.f1 = $11967, $11968);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 86: // $11970
      throw "Reached an unreachable!"
    case 87: // $_ZnwjPKci_exit10
      var $11971=HEAP32[(($result_i9)>>2)];
      var $11972=$4659;
      var $11973=$4660;
      var $11974=$4661;
      var $11975=$result_i9;
      var $11976=$4662;
      var $11977=$4663;
      var $11978=$11971;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4733, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 11706; break; }
    case 88: // $11979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4734, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 11706; break; }
    case 89: // $11980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4735, 4, 0, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 11706; break; }
    case 90: // $11981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 11706; break; }
    case 91: // $11982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 11706; break; }
    case 92: // $11983
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 11706; break; }
    case 93: // $11984
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 11706; break; }
    case 94: // $11985
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4732, $4733, $4734, $4735, $4736, $4737, $4738, $4739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 11706; break; }
    case 95: // $11986
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($11978, 52, 1, 0, ((STRING_TABLE.__str202)|0), ((STRING_TABLE.__str203)|0), $4732) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 11706; break; }
    case 96: // $11987
      var $11988=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $11978);
      var $11989=__ZN11simple_listI16input_type_entryE6appendERS0_($11939, $11988);
      var $11990=$4689;
      var $11991=$4654;
      var $11992=$4655;
      var $11993=$4656;
      var $11994=$result_i11;
      var $11995=$4657;
      var $11996=$4658;
      HEAP32[(($4654)>>2)]=408;
      HEAP32[(($4655)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4656)>>2)]=60;
      var $11997=HEAP32[(($4654)>>2)];
      var $11998=HEAP32[(($4655)>>2)];
      var $11999=HEAP32[(($4656)>>2)];
      var $12000=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($11997, $11998, $11999) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 99; break; };
    case 97: // $12001
      HEAP32[(($result_i11)>>2)]=$12000;
      var $12002=HEAP32[(($result_i11)>>2)];
      var $12003=(($12002)|0)==0;
      if ($12003) { __label__ = 98; break; } else { __label__ = 103; break; }
    case 98: // $12004
      var $12005=___cxa_allocate_exception(4);
      var $12006=$12005;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12006);
      (function() { try { __THREW__ = false; return ___cxa_throw($12005, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 99; break; }
    case 99: // $12007
      var $12008=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12009=$12008.f0;
      HEAP32[(($4657)>>2)]=$12009;
      var $12010=$12008.f1;
      HEAP32[(($4658)>>2)]=$12010;
      var $12011=HEAP32[(($4658)>>2)];
      var $12012=(($12011)|0) < 0;
      if ($12012) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $12013
      var $12014=HEAP32[(($4657)>>2)];
      ___cxa_call_unexpected($12014);
      throw "Reached an unreachable!"
    case 101: // $12015
      var $12016=HEAP32[(($4657)>>2)];
      var $12017=HEAP32[(($4657)>>2)];
      var $12018=HEAP32[(($4658)>>2)];
      var $12019=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12017, tempValue);
      var $12020=($12019.f1 = $12018, $12019);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 102: // $12021
      throw "Reached an unreachable!"
    case 103: // $_ZnwjPKci_exit12
      var $12022=HEAP32[(($result_i11)>>2)];
      var $12023=$4654;
      var $12024=$4655;
      var $12025=$4656;
      var $12026=$result_i11;
      var $12027=$4657;
      var $12028=$4658;
      var $12029=$12022;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4741, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 11711; break; }
    case 104: // $12030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4742, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 11711; break; }
    case 105: // $12031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4743, 4, 0, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 11711; break; }
    case 106: // $12032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4744, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 11711; break; }
    case 107: // $12033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4745, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 11711; break; }
    case 108: // $12034
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 11711; break; }
    case 109: // $12035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 11711; break; }
    case 110: // $12036
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4740, $4741, $4742, $4743, $4744, $4745, $4746, $4747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 11711; break; }
    case 111: // $12037
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12029, 53, 1, 0, ((STRING_TABLE.__str204)|0), ((STRING_TABLE.__str205)|0), $4740) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 11711; break; }
    case 112: // $12038
      var $12039=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12029);
      var $12040=__ZN11simple_listI16input_type_entryE6appendERS0_($11990, $12039);
      var $12041=$4689;
      var $12042=$4649;
      var $12043=$4650;
      var $12044=$4651;
      var $12045=$result_i13;
      var $12046=$4652;
      var $12047=$4653;
      HEAP32[(($4649)>>2)]=408;
      HEAP32[(($4650)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4651)>>2)]=61;
      var $12048=HEAP32[(($4649)>>2)];
      var $12049=HEAP32[(($4650)>>2)];
      var $12050=HEAP32[(($4651)>>2)];
      var $12051=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12048, $12049, $12050) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 115; break; };
    case 113: // $12052
      HEAP32[(($result_i13)>>2)]=$12051;
      var $12053=HEAP32[(($result_i13)>>2)];
      var $12054=(($12053)|0)==0;
      if ($12054) { __label__ = 114; break; } else { __label__ = 119; break; }
    case 114: // $12055
      var $12056=___cxa_allocate_exception(4);
      var $12057=$12056;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12057);
      (function() { try { __THREW__ = false; return ___cxa_throw($12056, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 115; break; }
    case 115: // $12058
      var $12059=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12060=$12059.f0;
      HEAP32[(($4652)>>2)]=$12060;
      var $12061=$12059.f1;
      HEAP32[(($4653)>>2)]=$12061;
      var $12062=HEAP32[(($4653)>>2)];
      var $12063=(($12062)|0) < 0;
      if ($12063) { __label__ = 116; break; } else { __label__ = 117; break; }
    case 116: // $12064
      var $12065=HEAP32[(($4652)>>2)];
      ___cxa_call_unexpected($12065);
      throw "Reached an unreachable!"
    case 117: // $12066
      var $12067=HEAP32[(($4652)>>2)];
      var $12068=HEAP32[(($4652)>>2)];
      var $12069=HEAP32[(($4653)>>2)];
      var $12070=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12068, tempValue);
      var $12071=($12070.f1 = $12069, $12070);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 118: // $12072
      throw "Reached an unreachable!"
    case 119: // $_ZnwjPKci_exit14
      var $12073=HEAP32[(($result_i13)>>2)];
      var $12074=$4649;
      var $12075=$4650;
      var $12076=$4651;
      var $12077=$result_i13;
      var $12078=$4652;
      var $12079=$4653;
      var $12080=$12073;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4749, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 120; break; } else { __label__ = 11716; break; }
    case 120: // $12081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4750, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 11716; break; }
    case 121: // $12082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4751, 4, 0, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 11716; break; }
    case 122: // $12083
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 123; break; } else { __label__ = 11716; break; }
    case 123: // $12084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 124; break; } else { __label__ = 11716; break; }
    case 124: // $12085
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 125; break; } else { __label__ = 11716; break; }
    case 125: // $12086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 126; break; } else { __label__ = 11716; break; }
    case 126: // $12087
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4748, $4749, $4750, $4751, $4752, $4753, $4754, $4755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 11716; break; }
    case 127: // $12088
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12080, 54, 1, 0, ((STRING_TABLE.__str206)|0), ((STRING_TABLE.__str207)|0), $4748) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 128; break; } else { __label__ = 11716; break; }
    case 128: // $12089
      var $12090=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12080);
      var $12091=__ZN11simple_listI16input_type_entryE6appendERS0_($12041, $12090);
      var $12092=$4689;
      var $12093=$4644;
      var $12094=$4645;
      var $12095=$4646;
      var $12096=$result_i15;
      var $12097=$4647;
      var $12098=$4648;
      HEAP32[(($4644)>>2)]=408;
      HEAP32[(($4645)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4646)>>2)]=62;
      var $12099=HEAP32[(($4644)>>2)];
      var $12100=HEAP32[(($4645)>>2)];
      var $12101=HEAP32[(($4646)>>2)];
      var $12102=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12099, $12100, $12101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 129; break; } else { __label__ = 131; break; };
    case 129: // $12103
      HEAP32[(($result_i15)>>2)]=$12102;
      var $12104=HEAP32[(($result_i15)>>2)];
      var $12105=(($12104)|0)==0;
      if ($12105) { __label__ = 130; break; } else { __label__ = 135; break; }
    case 130: // $12106
      var $12107=___cxa_allocate_exception(4);
      var $12108=$12107;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12108);
      (function() { try { __THREW__ = false; return ___cxa_throw($12107, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 134; break; } else { __label__ = 131; break; }
    case 131: // $12109
      var $12110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12111=$12110.f0;
      HEAP32[(($4647)>>2)]=$12111;
      var $12112=$12110.f1;
      HEAP32[(($4648)>>2)]=$12112;
      var $12113=HEAP32[(($4648)>>2)];
      var $12114=(($12113)|0) < 0;
      if ($12114) { __label__ = 132; break; } else { __label__ = 133; break; }
    case 132: // $12115
      var $12116=HEAP32[(($4647)>>2)];
      ___cxa_call_unexpected($12116);
      throw "Reached an unreachable!"
    case 133: // $12117
      var $12118=HEAP32[(($4647)>>2)];
      var $12119=HEAP32[(($4647)>>2)];
      var $12120=HEAP32[(($4648)>>2)];
      var $12121=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12119, tempValue);
      var $12122=($12121.f1 = $12120, $12121);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 134: // $12123
      throw "Reached an unreachable!"
    case 135: // $_ZnwjPKci_exit16
      var $12124=HEAP32[(($result_i15)>>2)];
      var $12125=$4644;
      var $12126=$4645;
      var $12127=$4646;
      var $12128=$result_i15;
      var $12129=$4647;
      var $12130=$4648;
      var $12131=$12124;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4757, 1, 0, 1, 0, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 11721; break; }
    case 136: // $12132
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4758, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 137; break; } else { __label__ = 11721; break; }
    case 137: // $12133
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4759, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 138; break; } else { __label__ = 11721; break; }
    case 138: // $12134
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 139; break; } else { __label__ = 11721; break; }
    case 139: // $12135
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 140; break; } else { __label__ = 11721; break; }
    case 140: // $12136
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 141; break; } else { __label__ = 11721; break; }
    case 141: // $12137
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 11721; break; }
    case 142: // $12138
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4756, $4757, $4758, $4759, $4760, $4761, $4762, $4763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 143; break; } else { __label__ = 11721; break; }
    case 143: // $12139
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12131, 55, 1, 0, ((STRING_TABLE.__str208)|0), ((STRING_TABLE.__str209)|0), $4756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 144; break; } else { __label__ = 11721; break; }
    case 144: // $12140
      var $12141=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12131);
      var $12142=__ZN11simple_listI16input_type_entryE6appendERS0_($12092, $12141);
      var $12143=$4689;
      var $12144=$4639;
      var $12145=$4640;
      var $12146=$4641;
      var $12147=$result_i17;
      var $12148=$4642;
      var $12149=$4643;
      HEAP32[(($4639)>>2)]=408;
      HEAP32[(($4640)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4641)>>2)]=63;
      var $12150=HEAP32[(($4639)>>2)];
      var $12151=HEAP32[(($4640)>>2)];
      var $12152=HEAP32[(($4641)>>2)];
      var $12153=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12150, $12151, $12152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 145; break; } else { __label__ = 147; break; };
    case 145: // $12154
      HEAP32[(($result_i17)>>2)]=$12153;
      var $12155=HEAP32[(($result_i17)>>2)];
      var $12156=(($12155)|0)==0;
      if ($12156) { __label__ = 146; break; } else { __label__ = 151; break; }
    case 146: // $12157
      var $12158=___cxa_allocate_exception(4);
      var $12159=$12158;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12159);
      (function() { try { __THREW__ = false; return ___cxa_throw($12158, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 150; break; } else { __label__ = 147; break; }
    case 147: // $12160
      var $12161=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12162=$12161.f0;
      HEAP32[(($4642)>>2)]=$12162;
      var $12163=$12161.f1;
      HEAP32[(($4643)>>2)]=$12163;
      var $12164=HEAP32[(($4643)>>2)];
      var $12165=(($12164)|0) < 0;
      if ($12165) { __label__ = 148; break; } else { __label__ = 149; break; }
    case 148: // $12166
      var $12167=HEAP32[(($4642)>>2)];
      ___cxa_call_unexpected($12167);
      throw "Reached an unreachable!"
    case 149: // $12168
      var $12169=HEAP32[(($4642)>>2)];
      var $12170=HEAP32[(($4642)>>2)];
      var $12171=HEAP32[(($4643)>>2)];
      var $12172=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12170, tempValue);
      var $12173=($12172.f1 = $12171, $12172);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 150: // $12174
      throw "Reached an unreachable!"
    case 151: // $_ZnwjPKci_exit18
      var $12175=HEAP32[(($result_i17)>>2)];
      var $12176=$4639;
      var $12177=$4640;
      var $12178=$4641;
      var $12179=$result_i17;
      var $12180=$4642;
      var $12181=$4643;
      var $12182=$12175;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4765, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 11726; break; }
    case 152: // $12183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4766, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 153; break; } else { __label__ = 11726; break; }
    case 153: // $12184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4767, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 154; break; } else { __label__ = 11726; break; }
    case 154: // $12185
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4768, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 155; break; } else { __label__ = 11726; break; }
    case 155: // $12186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4769, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 11726; break; }
    case 156: // $12187
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 157; break; } else { __label__ = 11726; break; }
    case 157: // $12188
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 158; break; } else { __label__ = 11726; break; }
    case 158: // $12189
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4764, $4765, $4766, $4767, $4768, $4769, $4770, $4771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 159; break; } else { __label__ = 11726; break; }
    case 159: // $12190
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12182, 56, 1, 0, ((STRING_TABLE.__str210)|0), ((STRING_TABLE.__str211)|0), $4764) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 160; break; } else { __label__ = 11726; break; }
    case 160: // $12191
      var $12192=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12182);
      var $12193=__ZN11simple_listI16input_type_entryE6appendERS0_($12143, $12192);
      var $12194=$4689;
      var $12195=$4634;
      var $12196=$4635;
      var $12197=$4636;
      var $12198=$result_i19;
      var $12199=$4637;
      var $12200=$4638;
      HEAP32[(($4634)>>2)]=408;
      HEAP32[(($4635)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4636)>>2)]=64;
      var $12201=HEAP32[(($4634)>>2)];
      var $12202=HEAP32[(($4635)>>2)];
      var $12203=HEAP32[(($4636)>>2)];
      var $12204=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12201, $12202, $12203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 161; break; } else { __label__ = 163; break; };
    case 161: // $12205
      HEAP32[(($result_i19)>>2)]=$12204;
      var $12206=HEAP32[(($result_i19)>>2)];
      var $12207=(($12206)|0)==0;
      if ($12207) { __label__ = 162; break; } else { __label__ = 167; break; }
    case 162: // $12208
      var $12209=___cxa_allocate_exception(4);
      var $12210=$12209;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12210);
      (function() { try { __THREW__ = false; return ___cxa_throw($12209, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 166; break; } else { __label__ = 163; break; }
    case 163: // $12211
      var $12212=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12213=$12212.f0;
      HEAP32[(($4637)>>2)]=$12213;
      var $12214=$12212.f1;
      HEAP32[(($4638)>>2)]=$12214;
      var $12215=HEAP32[(($4638)>>2)];
      var $12216=(($12215)|0) < 0;
      if ($12216) { __label__ = 164; break; } else { __label__ = 165; break; }
    case 164: // $12217
      var $12218=HEAP32[(($4637)>>2)];
      ___cxa_call_unexpected($12218);
      throw "Reached an unreachable!"
    case 165: // $12219
      var $12220=HEAP32[(($4637)>>2)];
      var $12221=HEAP32[(($4637)>>2)];
      var $12222=HEAP32[(($4638)>>2)];
      var $12223=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12221, tempValue);
      var $12224=($12223.f1 = $12222, $12223);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 166: // $12225
      throw "Reached an unreachable!"
    case 167: // $_ZnwjPKci_exit20
      var $12226=HEAP32[(($result_i19)>>2)];
      var $12227=$4634;
      var $12228=$4635;
      var $12229=$4636;
      var $12230=$result_i19;
      var $12231=$4637;
      var $12232=$4638;
      var $12233=$12226;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4773, 1, 0, 1, 0, 19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 168; break; } else { __label__ = 11731; break; }
    case 168: // $12234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4774, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 169; break; } else { __label__ = 11731; break; }
    case 169: // $12235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4775, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 170; break; } else { __label__ = 11731; break; }
    case 170: // $12236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 171; break; } else { __label__ = 11731; break; }
    case 171: // $12237
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 172; break; } else { __label__ = 11731; break; }
    case 172: // $12238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 173; break; } else { __label__ = 11731; break; }
    case 173: // $12239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 174; break; } else { __label__ = 11731; break; }
    case 174: // $12240
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4772, $4773, $4774, $4775, $4776, $4777, $4778, $4779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 175; break; } else { __label__ = 11731; break; }
    case 175: // $12241
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12233, 57, 1, 0, ((STRING_TABLE.__str212)|0), ((STRING_TABLE.__str213402)|0), $4772) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 176; break; } else { __label__ = 11731; break; }
    case 176: // $12242
      var $12243=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12233);
      var $12244=__ZN11simple_listI16input_type_entryE6appendERS0_($12194, $12243);
      var $12245=$4689;
      var $12246=$4629;
      var $12247=$4630;
      var $12248=$4631;
      var $12249=$result_i21;
      var $12250=$4632;
      var $12251=$4633;
      HEAP32[(($4629)>>2)]=408;
      HEAP32[(($4630)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4631)>>2)]=65;
      var $12252=HEAP32[(($4629)>>2)];
      var $12253=HEAP32[(($4630)>>2)];
      var $12254=HEAP32[(($4631)>>2)];
      var $12255=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12252, $12253, $12254) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 177; break; } else { __label__ = 179; break; };
    case 177: // $12256
      HEAP32[(($result_i21)>>2)]=$12255;
      var $12257=HEAP32[(($result_i21)>>2)];
      var $12258=(($12257)|0)==0;
      if ($12258) { __label__ = 178; break; } else { __label__ = 183; break; }
    case 178: // $12259
      var $12260=___cxa_allocate_exception(4);
      var $12261=$12260;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12261);
      (function() { try { __THREW__ = false; return ___cxa_throw($12260, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 182; break; } else { __label__ = 179; break; }
    case 179: // $12262
      var $12263=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12264=$12263.f0;
      HEAP32[(($4632)>>2)]=$12264;
      var $12265=$12263.f1;
      HEAP32[(($4633)>>2)]=$12265;
      var $12266=HEAP32[(($4633)>>2)];
      var $12267=(($12266)|0) < 0;
      if ($12267) { __label__ = 180; break; } else { __label__ = 181; break; }
    case 180: // $12268
      var $12269=HEAP32[(($4632)>>2)];
      ___cxa_call_unexpected($12269);
      throw "Reached an unreachable!"
    case 181: // $12270
      var $12271=HEAP32[(($4632)>>2)];
      var $12272=HEAP32[(($4632)>>2)];
      var $12273=HEAP32[(($4633)>>2)];
      var $12274=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12272, tempValue);
      var $12275=($12274.f1 = $12273, $12274);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 182: // $12276
      throw "Reached an unreachable!"
    case 183: // $_ZnwjPKci_exit22
      var $12277=HEAP32[(($result_i21)>>2)];
      var $12278=$4629;
      var $12279=$4630;
      var $12280=$4631;
      var $12281=$result_i21;
      var $12282=$4632;
      var $12283=$4633;
      var $12284=$12277;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4781, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 184; break; } else { __label__ = 11736; break; }
    case 184: // $12285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4782, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 185; break; } else { __label__ = 11736; break; }
    case 185: // $12286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4783, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 186; break; } else { __label__ = 11736; break; }
    case 186: // $12287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 187; break; } else { __label__ = 11736; break; }
    case 187: // $12288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 188; break; } else { __label__ = 11736; break; }
    case 188: // $12289
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 189; break; } else { __label__ = 11736; break; }
    case 189: // $12290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 190; break; } else { __label__ = 11736; break; }
    case 190: // $12291
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4780, $4781, $4782, $4783, $4784, $4785, $4786, $4787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 191; break; } else { __label__ = 11736; break; }
    case 191: // $12292
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12284, 58, 1, 0, ((STRING_TABLE.__str214)|0), ((STRING_TABLE.__str215)|0), $4780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 192; break; } else { __label__ = 11736; break; }
    case 192: // $12293
      var $12294=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12284);
      var $12295=__ZN11simple_listI16input_type_entryE6appendERS0_($12245, $12294);
      var $12296=$4689;
      var $12297=$4624;
      var $12298=$4625;
      var $12299=$4626;
      var $12300=$result_i23;
      var $12301=$4627;
      var $12302=$4628;
      HEAP32[(($4624)>>2)]=408;
      HEAP32[(($4625)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4626)>>2)]=66;
      var $12303=HEAP32[(($4624)>>2)];
      var $12304=HEAP32[(($4625)>>2)];
      var $12305=HEAP32[(($4626)>>2)];
      var $12306=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12303, $12304, $12305) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 193; break; } else { __label__ = 195; break; };
    case 193: // $12307
      HEAP32[(($result_i23)>>2)]=$12306;
      var $12308=HEAP32[(($result_i23)>>2)];
      var $12309=(($12308)|0)==0;
      if ($12309) { __label__ = 194; break; } else { __label__ = 199; break; }
    case 194: // $12310
      var $12311=___cxa_allocate_exception(4);
      var $12312=$12311;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12312);
      (function() { try { __THREW__ = false; return ___cxa_throw($12311, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 198; break; } else { __label__ = 195; break; }
    case 195: // $12313
      var $12314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12315=$12314.f0;
      HEAP32[(($4627)>>2)]=$12315;
      var $12316=$12314.f1;
      HEAP32[(($4628)>>2)]=$12316;
      var $12317=HEAP32[(($4628)>>2)];
      var $12318=(($12317)|0) < 0;
      if ($12318) { __label__ = 196; break; } else { __label__ = 197; break; }
    case 196: // $12319
      var $12320=HEAP32[(($4627)>>2)];
      ___cxa_call_unexpected($12320);
      throw "Reached an unreachable!"
    case 197: // $12321
      var $12322=HEAP32[(($4627)>>2)];
      var $12323=HEAP32[(($4627)>>2)];
      var $12324=HEAP32[(($4628)>>2)];
      var $12325=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12323, tempValue);
      var $12326=($12325.f1 = $12324, $12325);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 198: // $12327
      throw "Reached an unreachable!"
    case 199: // $_ZnwjPKci_exit24
      var $12328=HEAP32[(($result_i23)>>2)];
      var $12329=$4624;
      var $12330=$4625;
      var $12331=$4626;
      var $12332=$result_i23;
      var $12333=$4627;
      var $12334=$4628;
      var $12335=$12328;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4789, 1, 0, 1, 0, 99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 200; break; } else { __label__ = 11741; break; }
    case 200: // $12336
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4790, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 201; break; } else { __label__ = 11741; break; }
    case 201: // $12337
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4791, 4, 0, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 202; break; } else { __label__ = 11741; break; }
    case 202: // $12338
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4792, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 203; break; } else { __label__ = 11741; break; }
    case 203: // $12339
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4793, 2, 0, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 204; break; } else { __label__ = 11741; break; }
    case 204: // $12340
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4794, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 205; break; } else { __label__ = 11741; break; }
    case 205: // $12341
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4795, 3, 0, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 206; break; } else { __label__ = 11741; break; }
    case 206: // $12342
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4788, $4789, $4790, $4791, $4792, $4793, $4794, $4795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 207; break; } else { __label__ = 11741; break; }
    case 207: // $12343
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12335, 59, 1, 0, ((STRING_TABLE.__str216)|0), ((STRING_TABLE.__str217)|0), $4788) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 208; break; } else { __label__ = 11741; break; }
    case 208: // $12344
      var $12345=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12335);
      var $12346=__ZN11simple_listI16input_type_entryE6appendERS0_($12296, $12345);
      var $12347=$4689;
      var $12348=$4619;
      var $12349=$4620;
      var $12350=$4621;
      var $12351=$result_i25;
      var $12352=$4622;
      var $12353=$4623;
      HEAP32[(($4619)>>2)]=408;
      HEAP32[(($4620)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4621)>>2)]=67;
      var $12354=HEAP32[(($4619)>>2)];
      var $12355=HEAP32[(($4620)>>2)];
      var $12356=HEAP32[(($4621)>>2)];
      var $12357=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12354, $12355, $12356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 209; break; } else { __label__ = 211; break; };
    case 209: // $12358
      HEAP32[(($result_i25)>>2)]=$12357;
      var $12359=HEAP32[(($result_i25)>>2)];
      var $12360=(($12359)|0)==0;
      if ($12360) { __label__ = 210; break; } else { __label__ = 215; break; }
    case 210: // $12361
      var $12362=___cxa_allocate_exception(4);
      var $12363=$12362;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12363);
      (function() { try { __THREW__ = false; return ___cxa_throw($12362, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 214; break; } else { __label__ = 211; break; }
    case 211: // $12364
      var $12365=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12366=$12365.f0;
      HEAP32[(($4622)>>2)]=$12366;
      var $12367=$12365.f1;
      HEAP32[(($4623)>>2)]=$12367;
      var $12368=HEAP32[(($4623)>>2)];
      var $12369=(($12368)|0) < 0;
      if ($12369) { __label__ = 212; break; } else { __label__ = 213; break; }
    case 212: // $12370
      var $12371=HEAP32[(($4622)>>2)];
      ___cxa_call_unexpected($12371);
      throw "Reached an unreachable!"
    case 213: // $12372
      var $12373=HEAP32[(($4622)>>2)];
      var $12374=HEAP32[(($4622)>>2)];
      var $12375=HEAP32[(($4623)>>2)];
      var $12376=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12374, tempValue);
      var $12377=($12376.f1 = $12375, $12376);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 214: // $12378
      throw "Reached an unreachable!"
    case 215: // $_ZnwjPKci_exit26
      var $12379=HEAP32[(($result_i25)>>2)];
      var $12380=$4619;
      var $12381=$4620;
      var $12382=$4621;
      var $12383=$result_i25;
      var $12384=$4622;
      var $12385=$4623;
      var $12386=$12379;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4797, 1, 0, 1, 0, 101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 216; break; } else { __label__ = 11746; break; }
    case 216: // $12387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4798, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 217; break; } else { __label__ = 11746; break; }
    case 217: // $12388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4799, 4, 0, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 218; break; } else { __label__ = 11746; break; }
    case 218: // $12389
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4800, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 219; break; } else { __label__ = 11746; break; }
    case 219: // $12390
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4801, 2, 0, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 220; break; } else { __label__ = 11746; break; }
    case 220: // $12391
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4802, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 221; break; } else { __label__ = 11746; break; }
    case 221: // $12392
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4803, 3, 0, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 222; break; } else { __label__ = 11746; break; }
    case 222: // $12393
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4796, $4797, $4798, $4799, $4800, $4801, $4802, $4803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 223; break; } else { __label__ = 11746; break; }
    case 223: // $12394
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12386, 60, 1, 0, ((STRING_TABLE.__str218)|0), ((STRING_TABLE.__str219)|0), $4796) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 224; break; } else { __label__ = 11746; break; }
    case 224: // $12395
      var $12396=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12386);
      var $12397=__ZN11simple_listI16input_type_entryE6appendERS0_($12347, $12396);
      var $12398=$4689;
      var $12399=$4614;
      var $12400=$4615;
      var $12401=$4616;
      var $12402=$result_i27;
      var $12403=$4617;
      var $12404=$4618;
      HEAP32[(($4614)>>2)]=408;
      HEAP32[(($4615)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4616)>>2)]=68;
      var $12405=HEAP32[(($4614)>>2)];
      var $12406=HEAP32[(($4615)>>2)];
      var $12407=HEAP32[(($4616)>>2)];
      var $12408=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12405, $12406, $12407) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 225; break; } else { __label__ = 227; break; };
    case 225: // $12409
      HEAP32[(($result_i27)>>2)]=$12408;
      var $12410=HEAP32[(($result_i27)>>2)];
      var $12411=(($12410)|0)==0;
      if ($12411) { __label__ = 226; break; } else { __label__ = 231; break; }
    case 226: // $12412
      var $12413=___cxa_allocate_exception(4);
      var $12414=$12413;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12414);
      (function() { try { __THREW__ = false; return ___cxa_throw($12413, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 230; break; } else { __label__ = 227; break; }
    case 227: // $12415
      var $12416=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12417=$12416.f0;
      HEAP32[(($4617)>>2)]=$12417;
      var $12418=$12416.f1;
      HEAP32[(($4618)>>2)]=$12418;
      var $12419=HEAP32[(($4618)>>2)];
      var $12420=(($12419)|0) < 0;
      if ($12420) { __label__ = 228; break; } else { __label__ = 229; break; }
    case 228: // $12421
      var $12422=HEAP32[(($4617)>>2)];
      ___cxa_call_unexpected($12422);
      throw "Reached an unreachable!"
    case 229: // $12423
      var $12424=HEAP32[(($4617)>>2)];
      var $12425=HEAP32[(($4617)>>2)];
      var $12426=HEAP32[(($4618)>>2)];
      var $12427=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12425, tempValue);
      var $12428=($12427.f1 = $12426, $12427);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 230: // $12429
      throw "Reached an unreachable!"
    case 231: // $_ZnwjPKci_exit28
      var $12430=HEAP32[(($result_i27)>>2)];
      var $12431=$4614;
      var $12432=$4615;
      var $12433=$4616;
      var $12434=$result_i27;
      var $12435=$4617;
      var $12436=$4618;
      var $12437=$12430;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4805, 1, 0, 1, 0, 68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 232; break; } else { __label__ = 11751; break; }
    case 232: // $12438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4806, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 233; break; } else { __label__ = 11751; break; }
    case 233: // $12439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4807, 4, 0, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 234; break; } else { __label__ = 11751; break; }
    case 234: // $12440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4808, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 235; break; } else { __label__ = 11751; break; }
    case 235: // $12441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4809, 2, 0, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 236; break; } else { __label__ = 11751; break; }
    case 236: // $12442
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 237; break; } else { __label__ = 11751; break; }
    case 237: // $12443
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 238; break; } else { __label__ = 11751; break; }
    case 238: // $12444
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4804, $4805, $4806, $4807, $4808, $4809, $4810, $4811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 239; break; } else { __label__ = 11751; break; }
    case 239: // $12445
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12437, 61, 1, 0, ((STRING_TABLE.__str220)|0), ((STRING_TABLE.__str221)|0), $4804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 240; break; } else { __label__ = 11751; break; }
    case 240: // $12446
      var $12447=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12437);
      var $12448=__ZN11simple_listI16input_type_entryE6appendERS0_($12398, $12447);
      var $12449=$4689;
      var $12450=$4609;
      var $12451=$4610;
      var $12452=$4611;
      var $12453=$result_i29;
      var $12454=$4612;
      var $12455=$4613;
      HEAP32[(($4609)>>2)]=408;
      HEAP32[(($4610)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4611)>>2)]=69;
      var $12456=HEAP32[(($4609)>>2)];
      var $12457=HEAP32[(($4610)>>2)];
      var $12458=HEAP32[(($4611)>>2)];
      var $12459=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12456, $12457, $12458) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 241; break; } else { __label__ = 243; break; };
    case 241: // $12460
      HEAP32[(($result_i29)>>2)]=$12459;
      var $12461=HEAP32[(($result_i29)>>2)];
      var $12462=(($12461)|0)==0;
      if ($12462) { __label__ = 242; break; } else { __label__ = 247; break; }
    case 242: // $12463
      var $12464=___cxa_allocate_exception(4);
      var $12465=$12464;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12465);
      (function() { try { __THREW__ = false; return ___cxa_throw($12464, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 246; break; } else { __label__ = 243; break; }
    case 243: // $12466
      var $12467=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12468=$12467.f0;
      HEAP32[(($4612)>>2)]=$12468;
      var $12469=$12467.f1;
      HEAP32[(($4613)>>2)]=$12469;
      var $12470=HEAP32[(($4613)>>2)];
      var $12471=(($12470)|0) < 0;
      if ($12471) { __label__ = 244; break; } else { __label__ = 245; break; }
    case 244: // $12472
      var $12473=HEAP32[(($4612)>>2)];
      ___cxa_call_unexpected($12473);
      throw "Reached an unreachable!"
    case 245: // $12474
      var $12475=HEAP32[(($4612)>>2)];
      var $12476=HEAP32[(($4612)>>2)];
      var $12477=HEAP32[(($4613)>>2)];
      var $12478=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12476, tempValue);
      var $12479=($12478.f1 = $12477, $12478);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 246: // $12480
      throw "Reached an unreachable!"
    case 247: // $_ZnwjPKci_exit30
      var $12481=HEAP32[(($result_i29)>>2)];
      var $12482=$4609;
      var $12483=$4610;
      var $12484=$4611;
      var $12485=$result_i29;
      var $12486=$4612;
      var $12487=$4613;
      var $12488=$12481;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4813, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 248; break; } else { __label__ = 11756; break; }
    case 248: // $12489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4814, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 249; break; } else { __label__ = 11756; break; }
    case 249: // $12490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4815, 4, 0, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 250; break; } else { __label__ = 11756; break; }
    case 250: // $12491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 251; break; } else { __label__ = 11756; break; }
    case 251: // $12492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 252; break; } else { __label__ = 11756; break; }
    case 252: // $12493
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 253; break; } else { __label__ = 11756; break; }
    case 253: // $12494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 254; break; } else { __label__ = 11756; break; }
    case 254: // $12495
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4812, $4813, $4814, $4815, $4816, $4817, $4818, $4819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 255; break; } else { __label__ = 11756; break; }
    case 255: // $12496
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12488, 62, 1, 0, ((STRING_TABLE.__str222)|0), ((STRING_TABLE.__str223)|0), $4812) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 256; break; } else { __label__ = 11756; break; }
    case 256: // $12497
      var $12498=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12488);
      var $12499=__ZN11simple_listI16input_type_entryE6appendERS0_($12449, $12498);
      var $12500=$4689;
      var $12501=$4604;
      var $12502=$4605;
      var $12503=$4606;
      var $12504=$result_i31;
      var $12505=$4607;
      var $12506=$4608;
      HEAP32[(($4604)>>2)]=408;
      HEAP32[(($4605)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4606)>>2)]=70;
      var $12507=HEAP32[(($4604)>>2)];
      var $12508=HEAP32[(($4605)>>2)];
      var $12509=HEAP32[(($4606)>>2)];
      var $12510=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12507, $12508, $12509) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 257; break; } else { __label__ = 259; break; };
    case 257: // $12511
      HEAP32[(($result_i31)>>2)]=$12510;
      var $12512=HEAP32[(($result_i31)>>2)];
      var $12513=(($12512)|0)==0;
      if ($12513) { __label__ = 258; break; } else { __label__ = 263; break; }
    case 258: // $12514
      var $12515=___cxa_allocate_exception(4);
      var $12516=$12515;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12516);
      (function() { try { __THREW__ = false; return ___cxa_throw($12515, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 262; break; } else { __label__ = 259; break; }
    case 259: // $12517
      var $12518=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12519=$12518.f0;
      HEAP32[(($4607)>>2)]=$12519;
      var $12520=$12518.f1;
      HEAP32[(($4608)>>2)]=$12520;
      var $12521=HEAP32[(($4608)>>2)];
      var $12522=(($12521)|0) < 0;
      if ($12522) { __label__ = 260; break; } else { __label__ = 261; break; }
    case 260: // $12523
      var $12524=HEAP32[(($4607)>>2)];
      ___cxa_call_unexpected($12524);
      throw "Reached an unreachable!"
    case 261: // $12525
      var $12526=HEAP32[(($4607)>>2)];
      var $12527=HEAP32[(($4607)>>2)];
      var $12528=HEAP32[(($4608)>>2)];
      var $12529=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12527, tempValue);
      var $12530=($12529.f1 = $12528, $12529);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 262: // $12531
      throw "Reached an unreachable!"
    case 263: // $_ZnwjPKci_exit32
      var $12532=HEAP32[(($result_i31)>>2)];
      var $12533=$4604;
      var $12534=$4605;
      var $12535=$4606;
      var $12536=$result_i31;
      var $12537=$4607;
      var $12538=$4608;
      var $12539=$12532;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4821, 1, 0, 1, 0, 26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 264; break; } else { __label__ = 11761; break; }
    case 264: // $12540
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4822, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 265; break; } else { __label__ = 11761; break; }
    case 265: // $12541
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4823, 4, 0, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 266; break; } else { __label__ = 11761; break; }
    case 266: // $12542
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 267; break; } else { __label__ = 11761; break; }
    case 267: // $12543
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 268; break; } else { __label__ = 11761; break; }
    case 268: // $12544
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 269; break; } else { __label__ = 11761; break; }
    case 269: // $12545
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 270; break; } else { __label__ = 11761; break; }
    case 270: // $12546
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4820, $4821, $4822, $4823, $4824, $4825, $4826, $4827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 271; break; } else { __label__ = 11761; break; }
    case 271: // $12547
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12539, 63, 1, 0, ((STRING_TABLE.__str224)|0), ((STRING_TABLE.__str225)|0), $4820) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 272; break; } else { __label__ = 11761; break; }
    case 272: // $12548
      var $12549=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12539);
      var $12550=__ZN11simple_listI16input_type_entryE6appendERS0_($12500, $12549);
      var $12551=$4689;
      var $12552=$4599;
      var $12553=$4600;
      var $12554=$4601;
      var $12555=$result_i33;
      var $12556=$4602;
      var $12557=$4603;
      HEAP32[(($4599)>>2)]=408;
      HEAP32[(($4600)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4601)>>2)]=71;
      var $12558=HEAP32[(($4599)>>2)];
      var $12559=HEAP32[(($4600)>>2)];
      var $12560=HEAP32[(($4601)>>2)];
      var $12561=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12558, $12559, $12560) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 273; break; } else { __label__ = 275; break; };
    case 273: // $12562
      HEAP32[(($result_i33)>>2)]=$12561;
      var $12563=HEAP32[(($result_i33)>>2)];
      var $12564=(($12563)|0)==0;
      if ($12564) { __label__ = 274; break; } else { __label__ = 279; break; }
    case 274: // $12565
      var $12566=___cxa_allocate_exception(4);
      var $12567=$12566;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12567);
      (function() { try { __THREW__ = false; return ___cxa_throw($12566, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 278; break; } else { __label__ = 275; break; }
    case 275: // $12568
      var $12569=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12570=$12569.f0;
      HEAP32[(($4602)>>2)]=$12570;
      var $12571=$12569.f1;
      HEAP32[(($4603)>>2)]=$12571;
      var $12572=HEAP32[(($4603)>>2)];
      var $12573=(($12572)|0) < 0;
      if ($12573) { __label__ = 276; break; } else { __label__ = 277; break; }
    case 276: // $12574
      var $12575=HEAP32[(($4602)>>2)];
      ___cxa_call_unexpected($12575);
      throw "Reached an unreachable!"
    case 277: // $12576
      var $12577=HEAP32[(($4602)>>2)];
      var $12578=HEAP32[(($4602)>>2)];
      var $12579=HEAP32[(($4603)>>2)];
      var $12580=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12578, tempValue);
      var $12581=($12580.f1 = $12579, $12580);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 278: // $12582
      throw "Reached an unreachable!"
    case 279: // $_ZnwjPKci_exit34
      var $12583=HEAP32[(($result_i33)>>2)];
      var $12584=$4599;
      var $12585=$4600;
      var $12586=$4601;
      var $12587=$result_i33;
      var $12588=$4602;
      var $12589=$4603;
      var $12590=$12583;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4829, 1, 0, 1, 0, 24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 280; break; } else { __label__ = 11766; break; }
    case 280: // $12591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4830, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 281; break; } else { __label__ = 11766; break; }
    case 281: // $12592
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4831, 4, 0, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 282; break; } else { __label__ = 11766; break; }
    case 282: // $12593
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 283; break; } else { __label__ = 11766; break; }
    case 283: // $12594
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 284; break; } else { __label__ = 11766; break; }
    case 284: // $12595
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 285; break; } else { __label__ = 11766; break; }
    case 285: // $12596
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 286; break; } else { __label__ = 11766; break; }
    case 286: // $12597
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4828, $4829, $4830, $4831, $4832, $4833, $4834, $4835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 287; break; } else { __label__ = 11766; break; }
    case 287: // $12598
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12590, 64, 1, 0, ((STRING_TABLE.__str226)|0), ((STRING_TABLE.__str227)|0), $4828) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 288; break; } else { __label__ = 11766; break; }
    case 288: // $12599
      var $12600=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12590);
      var $12601=__ZN11simple_listI16input_type_entryE6appendERS0_($12551, $12600);
      var $12602=$4689;
      var $12603=$4594;
      var $12604=$4595;
      var $12605=$4596;
      var $12606=$result_i35;
      var $12607=$4597;
      var $12608=$4598;
      HEAP32[(($4594)>>2)]=408;
      HEAP32[(($4595)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4596)>>2)]=72;
      var $12609=HEAP32[(($4594)>>2)];
      var $12610=HEAP32[(($4595)>>2)];
      var $12611=HEAP32[(($4596)>>2)];
      var $12612=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12609, $12610, $12611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 289; break; } else { __label__ = 291; break; };
    case 289: // $12613
      HEAP32[(($result_i35)>>2)]=$12612;
      var $12614=HEAP32[(($result_i35)>>2)];
      var $12615=(($12614)|0)==0;
      if ($12615) { __label__ = 290; break; } else { __label__ = 295; break; }
    case 290: // $12616
      var $12617=___cxa_allocate_exception(4);
      var $12618=$12617;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12618);
      (function() { try { __THREW__ = false; return ___cxa_throw($12617, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 294; break; } else { __label__ = 291; break; }
    case 291: // $12619
      var $12620=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12621=$12620.f0;
      HEAP32[(($4597)>>2)]=$12621;
      var $12622=$12620.f1;
      HEAP32[(($4598)>>2)]=$12622;
      var $12623=HEAP32[(($4598)>>2)];
      var $12624=(($12623)|0) < 0;
      if ($12624) { __label__ = 292; break; } else { __label__ = 293; break; }
    case 292: // $12625
      var $12626=HEAP32[(($4597)>>2)];
      ___cxa_call_unexpected($12626);
      throw "Reached an unreachable!"
    case 293: // $12627
      var $12628=HEAP32[(($4597)>>2)];
      var $12629=HEAP32[(($4597)>>2)];
      var $12630=HEAP32[(($4598)>>2)];
      var $12631=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12629, tempValue);
      var $12632=($12631.f1 = $12630, $12631);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 294: // $12633
      throw "Reached an unreachable!"
    case 295: // $_ZnwjPKci_exit36
      var $12634=HEAP32[(($result_i35)>>2)];
      var $12635=$4594;
      var $12636=$4595;
      var $12637=$4596;
      var $12638=$result_i35;
      var $12639=$4597;
      var $12640=$4598;
      var $12641=$12634;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4837, 1, 0, 1, 0, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 296; break; } else { __label__ = 11771; break; }
    case 296: // $12642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4838, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 297; break; } else { __label__ = 11771; break; }
    case 297: // $12643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4839, 4, 0, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 298; break; } else { __label__ = 11771; break; }
    case 298: // $12644
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 299; break; } else { __label__ = 11771; break; }
    case 299: // $12645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 300; break; } else { __label__ = 11771; break; }
    case 300: // $12646
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 301; break; } else { __label__ = 11771; break; }
    case 301: // $12647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 302; break; } else { __label__ = 11771; break; }
    case 302: // $12648
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4836, $4837, $4838, $4839, $4840, $4841, $4842, $4843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 303; break; } else { __label__ = 11771; break; }
    case 303: // $12649
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12641, 65, 1, 0, ((STRING_TABLE.__str228)|0), ((STRING_TABLE.__str229)|0), $4836) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 304; break; } else { __label__ = 11771; break; }
    case 304: // $12650
      var $12651=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12641);
      var $12652=__ZN11simple_listI16input_type_entryE6appendERS0_($12602, $12651);
      var $12653=$4689;
      var $12654=$4589;
      var $12655=$4590;
      var $12656=$4591;
      var $12657=$result_i37;
      var $12658=$4592;
      var $12659=$4593;
      HEAP32[(($4589)>>2)]=408;
      HEAP32[(($4590)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4591)>>2)]=73;
      var $12660=HEAP32[(($4589)>>2)];
      var $12661=HEAP32[(($4590)>>2)];
      var $12662=HEAP32[(($4591)>>2)];
      var $12663=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12660, $12661, $12662) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 305; break; } else { __label__ = 307; break; };
    case 305: // $12664
      HEAP32[(($result_i37)>>2)]=$12663;
      var $12665=HEAP32[(($result_i37)>>2)];
      var $12666=(($12665)|0)==0;
      if ($12666) { __label__ = 306; break; } else { __label__ = 311; break; }
    case 306: // $12667
      var $12668=___cxa_allocate_exception(4);
      var $12669=$12668;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12669);
      (function() { try { __THREW__ = false; return ___cxa_throw($12668, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 310; break; } else { __label__ = 307; break; }
    case 307: // $12670
      var $12671=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12672=$12671.f0;
      HEAP32[(($4592)>>2)]=$12672;
      var $12673=$12671.f1;
      HEAP32[(($4593)>>2)]=$12673;
      var $12674=HEAP32[(($4593)>>2)];
      var $12675=(($12674)|0) < 0;
      if ($12675) { __label__ = 308; break; } else { __label__ = 309; break; }
    case 308: // $12676
      var $12677=HEAP32[(($4592)>>2)];
      ___cxa_call_unexpected($12677);
      throw "Reached an unreachable!"
    case 309: // $12678
      var $12679=HEAP32[(($4592)>>2)];
      var $12680=HEAP32[(($4592)>>2)];
      var $12681=HEAP32[(($4593)>>2)];
      var $12682=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12680, tempValue);
      var $12683=($12682.f1 = $12681, $12682);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 310: // $12684
      throw "Reached an unreachable!"
    case 311: // $_ZnwjPKci_exit38
      var $12685=HEAP32[(($result_i37)>>2)];
      var $12686=$4589;
      var $12687=$4590;
      var $12688=$4591;
      var $12689=$result_i37;
      var $12690=$4592;
      var $12691=$4593;
      var $12692=$12685;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4845, 1, 0, 1, 0, 22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 312; break; } else { __label__ = 11776; break; }
    case 312: // $12693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4846, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 313; break; } else { __label__ = 11776; break; }
    case 313: // $12694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4847, 4, 0, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 314; break; } else { __label__ = 11776; break; }
    case 314: // $12695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 315; break; } else { __label__ = 11776; break; }
    case 315: // $12696
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 316; break; } else { __label__ = 11776; break; }
    case 316: // $12697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 317; break; } else { __label__ = 11776; break; }
    case 317: // $12698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 318; break; } else { __label__ = 11776; break; }
    case 318: // $12699
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4844, $4845, $4846, $4847, $4848, $4849, $4850, $4851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 319; break; } else { __label__ = 11776; break; }
    case 319: // $12700
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12692, 66, 1, 0, ((STRING_TABLE.__str230)|0), ((STRING_TABLE.__str231)|0), $4844) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 320; break; } else { __label__ = 11776; break; }
    case 320: // $12701
      var $12702=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12692);
      var $12703=__ZN11simple_listI16input_type_entryE6appendERS0_($12653, $12702);
      var $12704=$4689;
      var $12705=$4584;
      var $12706=$4585;
      var $12707=$4586;
      var $12708=$result_i39;
      var $12709=$4587;
      var $12710=$4588;
      HEAP32[(($4584)>>2)]=408;
      HEAP32[(($4585)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4586)>>2)]=74;
      var $12711=HEAP32[(($4584)>>2)];
      var $12712=HEAP32[(($4585)>>2)];
      var $12713=HEAP32[(($4586)>>2)];
      var $12714=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12711, $12712, $12713) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 321; break; } else { __label__ = 323; break; };
    case 321: // $12715
      HEAP32[(($result_i39)>>2)]=$12714;
      var $12716=HEAP32[(($result_i39)>>2)];
      var $12717=(($12716)|0)==0;
      if ($12717) { __label__ = 322; break; } else { __label__ = 327; break; }
    case 322: // $12718
      var $12719=___cxa_allocate_exception(4);
      var $12720=$12719;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12720);
      (function() { try { __THREW__ = false; return ___cxa_throw($12719, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 326; break; } else { __label__ = 323; break; }
    case 323: // $12721
      var $12722=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12723=$12722.f0;
      HEAP32[(($4587)>>2)]=$12723;
      var $12724=$12722.f1;
      HEAP32[(($4588)>>2)]=$12724;
      var $12725=HEAP32[(($4588)>>2)];
      var $12726=(($12725)|0) < 0;
      if ($12726) { __label__ = 324; break; } else { __label__ = 325; break; }
    case 324: // $12727
      var $12728=HEAP32[(($4587)>>2)];
      ___cxa_call_unexpected($12728);
      throw "Reached an unreachable!"
    case 325: // $12729
      var $12730=HEAP32[(($4587)>>2)];
      var $12731=HEAP32[(($4587)>>2)];
      var $12732=HEAP32[(($4588)>>2)];
      var $12733=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12731, tempValue);
      var $12734=($12733.f1 = $12732, $12733);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 326: // $12735
      throw "Reached an unreachable!"
    case 327: // $_ZnwjPKci_exit40
      var $12736=HEAP32[(($result_i39)>>2)];
      var $12737=$4584;
      var $12738=$4585;
      var $12739=$4586;
      var $12740=$result_i39;
      var $12741=$4587;
      var $12742=$4588;
      var $12743=$12736;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4853, 1, 0, 1, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 328; break; } else { __label__ = 11781; break; }
    case 328: // $12744
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4854, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 329; break; } else { __label__ = 11781; break; }
    case 329: // $12745
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4855, 4, 0, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 330; break; } else { __label__ = 11781; break; }
    case 330: // $12746
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 331; break; } else { __label__ = 11781; break; }
    case 331: // $12747
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 332; break; } else { __label__ = 11781; break; }
    case 332: // $12748
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 333; break; } else { __label__ = 11781; break; }
    case 333: // $12749
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 334; break; } else { __label__ = 11781; break; }
    case 334: // $12750
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4852, $4853, $4854, $4855, $4856, $4857, $4858, $4859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 335; break; } else { __label__ = 11781; break; }
    case 335: // $12751
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12743, 67, 1, 0, ((STRING_TABLE.__str232)|0), ((STRING_TABLE.__str233403)|0), $4852) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 336; break; } else { __label__ = 11781; break; }
    case 336: // $12752
      var $12753=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12743);
      var $12754=__ZN11simple_listI16input_type_entryE6appendERS0_($12704, $12753);
      var $12755=$4689;
      var $12756=$4579;
      var $12757=$4580;
      var $12758=$4581;
      var $12759=$result_i41;
      var $12760=$4582;
      var $12761=$4583;
      HEAP32[(($4579)>>2)]=408;
      HEAP32[(($4580)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4581)>>2)]=75;
      var $12762=HEAP32[(($4579)>>2)];
      var $12763=HEAP32[(($4580)>>2)];
      var $12764=HEAP32[(($4581)>>2)];
      var $12765=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12762, $12763, $12764) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 337; break; } else { __label__ = 339; break; };
    case 337: // $12766
      HEAP32[(($result_i41)>>2)]=$12765;
      var $12767=HEAP32[(($result_i41)>>2)];
      var $12768=(($12767)|0)==0;
      if ($12768) { __label__ = 338; break; } else { __label__ = 343; break; }
    case 338: // $12769
      var $12770=___cxa_allocate_exception(4);
      var $12771=$12770;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12771);
      (function() { try { __THREW__ = false; return ___cxa_throw($12770, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 342; break; } else { __label__ = 339; break; }
    case 339: // $12772
      var $12773=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12774=$12773.f0;
      HEAP32[(($4582)>>2)]=$12774;
      var $12775=$12773.f1;
      HEAP32[(($4583)>>2)]=$12775;
      var $12776=HEAP32[(($4583)>>2)];
      var $12777=(($12776)|0) < 0;
      if ($12777) { __label__ = 340; break; } else { __label__ = 341; break; }
    case 340: // $12778
      var $12779=HEAP32[(($4582)>>2)];
      ___cxa_call_unexpected($12779);
      throw "Reached an unreachable!"
    case 341: // $12780
      var $12781=HEAP32[(($4582)>>2)];
      var $12782=HEAP32[(($4582)>>2)];
      var $12783=HEAP32[(($4583)>>2)];
      var $12784=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12782, tempValue);
      var $12785=($12784.f1 = $12783, $12784);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 342: // $12786
      throw "Reached an unreachable!"
    case 343: // $_ZnwjPKci_exit42
      var $12787=HEAP32[(($result_i41)>>2)];
      var $12788=$4579;
      var $12789=$4580;
      var $12790=$4581;
      var $12791=$result_i41;
      var $12792=$4582;
      var $12793=$4583;
      var $12794=$12787;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4861, 1, 0, 1, 0, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 344; break; } else { __label__ = 11786; break; }
    case 344: // $12795
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4862, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 345; break; } else { __label__ = 11786; break; }
    case 345: // $12796
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4863, 4, 0, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 346; break; } else { __label__ = 11786; break; }
    case 346: // $12797
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 347; break; } else { __label__ = 11786; break; }
    case 347: // $12798
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 348; break; } else { __label__ = 11786; break; }
    case 348: // $12799
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 349; break; } else { __label__ = 11786; break; }
    case 349: // $12800
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 350; break; } else { __label__ = 11786; break; }
    case 350: // $12801
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4860, $4861, $4862, $4863, $4864, $4865, $4866, $4867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 351; break; } else { __label__ = 11786; break; }
    case 351: // $12802
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12794, 68, 1, 0, ((STRING_TABLE.__str234)|0), ((STRING_TABLE.__str235)|0), $4860) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 352; break; } else { __label__ = 11786; break; }
    case 352: // $12803
      var $12804=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12794);
      var $12805=__ZN11simple_listI16input_type_entryE6appendERS0_($12755, $12804);
      var $12806=$4689;
      var $12807=$4574;
      var $12808=$4575;
      var $12809=$4576;
      var $12810=$result_i43;
      var $12811=$4577;
      var $12812=$4578;
      HEAP32[(($4574)>>2)]=408;
      HEAP32[(($4575)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4576)>>2)]=76;
      var $12813=HEAP32[(($4574)>>2)];
      var $12814=HEAP32[(($4575)>>2)];
      var $12815=HEAP32[(($4576)>>2)];
      var $12816=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12813, $12814, $12815) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 353; break; } else { __label__ = 355; break; };
    case 353: // $12817
      HEAP32[(($result_i43)>>2)]=$12816;
      var $12818=HEAP32[(($result_i43)>>2)];
      var $12819=(($12818)|0)==0;
      if ($12819) { __label__ = 354; break; } else { __label__ = 359; break; }
    case 354: // $12820
      var $12821=___cxa_allocate_exception(4);
      var $12822=$12821;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12822);
      (function() { try { __THREW__ = false; return ___cxa_throw($12821, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 358; break; } else { __label__ = 355; break; }
    case 355: // $12823
      var $12824=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12825=$12824.f0;
      HEAP32[(($4577)>>2)]=$12825;
      var $12826=$12824.f1;
      HEAP32[(($4578)>>2)]=$12826;
      var $12827=HEAP32[(($4578)>>2)];
      var $12828=(($12827)|0) < 0;
      if ($12828) { __label__ = 356; break; } else { __label__ = 357; break; }
    case 356: // $12829
      var $12830=HEAP32[(($4577)>>2)];
      ___cxa_call_unexpected($12830);
      throw "Reached an unreachable!"
    case 357: // $12831
      var $12832=HEAP32[(($4577)>>2)];
      var $12833=HEAP32[(($4577)>>2)];
      var $12834=HEAP32[(($4578)>>2)];
      var $12835=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12833, tempValue);
      var $12836=($12835.f1 = $12834, $12835);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 358: // $12837
      throw "Reached an unreachable!"
    case 359: // $_ZnwjPKci_exit44
      var $12838=HEAP32[(($result_i43)>>2)];
      var $12839=$4574;
      var $12840=$4575;
      var $12841=$4576;
      var $12842=$result_i43;
      var $12843=$4577;
      var $12844=$4578;
      var $12845=$12838;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4869, 1, 0, 1, 0, 13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 360; break; } else { __label__ = 11791; break; }
    case 360: // $12846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4870, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 361; break; } else { __label__ = 11791; break; }
    case 361: // $12847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4871, 4, 0, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 362; break; } else { __label__ = 11791; break; }
    case 362: // $12848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 363; break; } else { __label__ = 11791; break; }
    case 363: // $12849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 364; break; } else { __label__ = 11791; break; }
    case 364: // $12850
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 365; break; } else { __label__ = 11791; break; }
    case 365: // $12851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 366; break; } else { __label__ = 11791; break; }
    case 366: // $12852
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4868, $4869, $4870, $4871, $4872, $4873, $4874, $4875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 367; break; } else { __label__ = 11791; break; }
    case 367: // $12853
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12845, 69, 1, 0, ((STRING_TABLE.__str236)|0), ((STRING_TABLE.__str237)|0), $4868) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 368; break; } else { __label__ = 11791; break; }
    case 368: // $12854
      var $12855=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12845);
      var $12856=__ZN11simple_listI16input_type_entryE6appendERS0_($12806, $12855);
      var $12857=$4689;
      var $12858=$4569;
      var $12859=$4570;
      var $12860=$4571;
      var $12861=$result_i45;
      var $12862=$4572;
      var $12863=$4573;
      HEAP32[(($4569)>>2)]=408;
      HEAP32[(($4570)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4571)>>2)]=77;
      var $12864=HEAP32[(($4569)>>2)];
      var $12865=HEAP32[(($4570)>>2)];
      var $12866=HEAP32[(($4571)>>2)];
      var $12867=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12864, $12865, $12866) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 369; break; } else { __label__ = 371; break; };
    case 369: // $12868
      HEAP32[(($result_i45)>>2)]=$12867;
      var $12869=HEAP32[(($result_i45)>>2)];
      var $12870=(($12869)|0)==0;
      if ($12870) { __label__ = 370; break; } else { __label__ = 375; break; }
    case 370: // $12871
      var $12872=___cxa_allocate_exception(4);
      var $12873=$12872;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12873);
      (function() { try { __THREW__ = false; return ___cxa_throw($12872, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 374; break; } else { __label__ = 371; break; }
    case 371: // $12874
      var $12875=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12876=$12875.f0;
      HEAP32[(($4572)>>2)]=$12876;
      var $12877=$12875.f1;
      HEAP32[(($4573)>>2)]=$12877;
      var $12878=HEAP32[(($4573)>>2)];
      var $12879=(($12878)|0) < 0;
      if ($12879) { __label__ = 372; break; } else { __label__ = 373; break; }
    case 372: // $12880
      var $12881=HEAP32[(($4572)>>2)];
      ___cxa_call_unexpected($12881);
      throw "Reached an unreachable!"
    case 373: // $12882
      var $12883=HEAP32[(($4572)>>2)];
      var $12884=HEAP32[(($4572)>>2)];
      var $12885=HEAP32[(($4573)>>2)];
      var $12886=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12884, tempValue);
      var $12887=($12886.f1 = $12885, $12886);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 374: // $12888
      throw "Reached an unreachable!"
    case 375: // $_ZnwjPKci_exit46
      var $12889=HEAP32[(($result_i45)>>2)];
      var $12890=$4569;
      var $12891=$4570;
      var $12892=$4571;
      var $12893=$result_i45;
      var $12894=$4572;
      var $12895=$4573;
      var $12896=$12889;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4877, 1, 0, 1, 0, 65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 376; break; } else { __label__ = 11796; break; }
    case 376: // $12897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4878, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 377; break; } else { __label__ = 11796; break; }
    case 377: // $12898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4879, 4, 0, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 378; break; } else { __label__ = 11796; break; }
    case 378: // $12899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 379; break; } else { __label__ = 11796; break; }
    case 379: // $12900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 380; break; } else { __label__ = 11796; break; }
    case 380: // $12901
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 381; break; } else { __label__ = 11796; break; }
    case 381: // $12902
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 382; break; } else { __label__ = 11796; break; }
    case 382: // $12903
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4876, $4877, $4878, $4879, $4880, $4881, $4882, $4883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 383; break; } else { __label__ = 11796; break; }
    case 383: // $12904
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12896, 70, 1, 0, ((STRING_TABLE.__str238)|0), ((STRING_TABLE.__str239)|0), $4876) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 384; break; } else { __label__ = 11796; break; }
    case 384: // $12905
      var $12906=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12896);
      var $12907=__ZN11simple_listI16input_type_entryE6appendERS0_($12857, $12906);
      var $12908=$4689;
      var $12909=$4564;
      var $12910=$4565;
      var $12911=$4566;
      var $12912=$result_i47;
      var $12913=$4567;
      var $12914=$4568;
      HEAP32[(($4564)>>2)]=408;
      HEAP32[(($4565)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4566)>>2)]=78;
      var $12915=HEAP32[(($4564)>>2)];
      var $12916=HEAP32[(($4565)>>2)];
      var $12917=HEAP32[(($4566)>>2)];
      var $12918=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12915, $12916, $12917) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 385; break; } else { __label__ = 387; break; };
    case 385: // $12919
      HEAP32[(($result_i47)>>2)]=$12918;
      var $12920=HEAP32[(($result_i47)>>2)];
      var $12921=(($12920)|0)==0;
      if ($12921) { __label__ = 386; break; } else { __label__ = 391; break; }
    case 386: // $12922
      var $12923=___cxa_allocate_exception(4);
      var $12924=$12923;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12924);
      (function() { try { __THREW__ = false; return ___cxa_throw($12923, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 390; break; } else { __label__ = 387; break; }
    case 387: // $12925
      var $12926=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12927=$12926.f0;
      HEAP32[(($4567)>>2)]=$12927;
      var $12928=$12926.f1;
      HEAP32[(($4568)>>2)]=$12928;
      var $12929=HEAP32[(($4568)>>2)];
      var $12930=(($12929)|0) < 0;
      if ($12930) { __label__ = 388; break; } else { __label__ = 389; break; }
    case 388: // $12931
      var $12932=HEAP32[(($4567)>>2)];
      ___cxa_call_unexpected($12932);
      throw "Reached an unreachable!"
    case 389: // $12933
      var $12934=HEAP32[(($4567)>>2)];
      var $12935=HEAP32[(($4567)>>2)];
      var $12936=HEAP32[(($4568)>>2)];
      var $12937=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12935, tempValue);
      var $12938=($12937.f1 = $12936, $12937);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 390: // $12939
      throw "Reached an unreachable!"
    case 391: // $_ZnwjPKci_exit48
      var $12940=HEAP32[(($result_i47)>>2)];
      var $12941=$4564;
      var $12942=$4565;
      var $12943=$4566;
      var $12944=$result_i47;
      var $12945=$4567;
      var $12946=$4568;
      var $12947=$12940;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4885, 1, 0, 1, 0, 66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 392; break; } else { __label__ = 11801; break; }
    case 392: // $12948
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4886, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 393; break; } else { __label__ = 11801; break; }
    case 393: // $12949
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4887, 4, 0, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 394; break; } else { __label__ = 11801; break; }
    case 394: // $12950
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 395; break; } else { __label__ = 11801; break; }
    case 395: // $12951
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 396; break; } else { __label__ = 11801; break; }
    case 396: // $12952
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 397; break; } else { __label__ = 11801; break; }
    case 397: // $12953
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 398; break; } else { __label__ = 11801; break; }
    case 398: // $12954
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4884, $4885, $4886, $4887, $4888, $4889, $4890, $4891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 399; break; } else { __label__ = 11801; break; }
    case 399: // $12955
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12947, 71, 1, 0, ((STRING_TABLE.__str240)|0), ((STRING_TABLE.__str241)|0), $4884) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 400; break; } else { __label__ = 11801; break; }
    case 400: // $12956
      var $12957=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12947);
      var $12958=__ZN11simple_listI16input_type_entryE6appendERS0_($12908, $12957);
      var $12959=$4689;
      var $12960=$4559;
      var $12961=$4560;
      var $12962=$4561;
      var $12963=$result_i49;
      var $12964=$4562;
      var $12965=$4563;
      HEAP32[(($4559)>>2)]=408;
      HEAP32[(($4560)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4561)>>2)]=79;
      var $12966=HEAP32[(($4559)>>2)];
      var $12967=HEAP32[(($4560)>>2)];
      var $12968=HEAP32[(($4561)>>2)];
      var $12969=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($12966, $12967, $12968) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 401; break; } else { __label__ = 403; break; };
    case 401: // $12970
      HEAP32[(($result_i49)>>2)]=$12969;
      var $12971=HEAP32[(($result_i49)>>2)];
      var $12972=(($12971)|0)==0;
      if ($12972) { __label__ = 402; break; } else { __label__ = 407; break; }
    case 402: // $12973
      var $12974=___cxa_allocate_exception(4);
      var $12975=$12974;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($12975);
      (function() { try { __THREW__ = false; return ___cxa_throw($12974, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 406; break; } else { __label__ = 403; break; }
    case 403: // $12976
      var $12977=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12978=$12977.f0;
      HEAP32[(($4562)>>2)]=$12978;
      var $12979=$12977.f1;
      HEAP32[(($4563)>>2)]=$12979;
      var $12980=HEAP32[(($4563)>>2)];
      var $12981=(($12980)|0) < 0;
      if ($12981) { __label__ = 404; break; } else { __label__ = 405; break; }
    case 404: // $12982
      var $12983=HEAP32[(($4562)>>2)];
      ___cxa_call_unexpected($12983);
      throw "Reached an unreachable!"
    case 405: // $12984
      var $12985=HEAP32[(($4562)>>2)];
      var $12986=HEAP32[(($4562)>>2)];
      var $12987=HEAP32[(($4563)>>2)];
      var $12988=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $12986, tempValue);
      var $12989=($12988.f1 = $12987, $12988);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 406: // $12990
      throw "Reached an unreachable!"
    case 407: // $_ZnwjPKci_exit50
      var $12991=HEAP32[(($result_i49)>>2)];
      var $12992=$4559;
      var $12993=$4560;
      var $12994=$4561;
      var $12995=$result_i49;
      var $12996=$4562;
      var $12997=$4563;
      var $12998=$12991;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4893, 1, 0, 1, 0, 67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 408; break; } else { __label__ = 11806; break; }
    case 408: // $12999
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4894, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 409; break; } else { __label__ = 11806; break; }
    case 409: // $13000
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4895, 4, 0, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 410; break; } else { __label__ = 11806; break; }
    case 410: // $13001
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 411; break; } else { __label__ = 11806; break; }
    case 411: // $13002
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 412; break; } else { __label__ = 11806; break; }
    case 412: // $13003
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 413; break; } else { __label__ = 11806; break; }
    case 413: // $13004
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 414; break; } else { __label__ = 11806; break; }
    case 414: // $13005
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4892, $4893, $4894, $4895, $4896, $4897, $4898, $4899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 415; break; } else { __label__ = 11806; break; }
    case 415: // $13006
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($12998, 72, 1, 0, ((STRING_TABLE.__str242)|0), ((STRING_TABLE.__str243)|0), $4892) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 416; break; } else { __label__ = 11806; break; }
    case 416: // $13007
      var $13008=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $12998);
      var $13009=__ZN11simple_listI16input_type_entryE6appendERS0_($12959, $13008);
      var $13010=$4689;
      var $13011=$4554;
      var $13012=$4555;
      var $13013=$4556;
      var $13014=$result_i51;
      var $13015=$4557;
      var $13016=$4558;
      HEAP32[(($4554)>>2)]=408;
      HEAP32[(($4555)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4556)>>2)]=80;
      var $13017=HEAP32[(($4554)>>2)];
      var $13018=HEAP32[(($4555)>>2)];
      var $13019=HEAP32[(($4556)>>2)];
      var $13020=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13017, $13018, $13019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 417; break; } else { __label__ = 419; break; };
    case 417: // $13021
      HEAP32[(($result_i51)>>2)]=$13020;
      var $13022=HEAP32[(($result_i51)>>2)];
      var $13023=(($13022)|0)==0;
      if ($13023) { __label__ = 418; break; } else { __label__ = 423; break; }
    case 418: // $13024
      var $13025=___cxa_allocate_exception(4);
      var $13026=$13025;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13026);
      (function() { try { __THREW__ = false; return ___cxa_throw($13025, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 422; break; } else { __label__ = 419; break; }
    case 419: // $13027
      var $13028=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13029=$13028.f0;
      HEAP32[(($4557)>>2)]=$13029;
      var $13030=$13028.f1;
      HEAP32[(($4558)>>2)]=$13030;
      var $13031=HEAP32[(($4558)>>2)];
      var $13032=(($13031)|0) < 0;
      if ($13032) { __label__ = 420; break; } else { __label__ = 421; break; }
    case 420: // $13033
      var $13034=HEAP32[(($4557)>>2)];
      ___cxa_call_unexpected($13034);
      throw "Reached an unreachable!"
    case 421: // $13035
      var $13036=HEAP32[(($4557)>>2)];
      var $13037=HEAP32[(($4557)>>2)];
      var $13038=HEAP32[(($4558)>>2)];
      var $13039=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13037, tempValue);
      var $13040=($13039.f1 = $13038, $13039);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 422: // $13041
      throw "Reached an unreachable!"
    case 423: // $_ZnwjPKci_exit52
      var $13042=HEAP32[(($result_i51)>>2)];
      var $13043=$4554;
      var $13044=$4555;
      var $13045=$4556;
      var $13046=$result_i51;
      var $13047=$4557;
      var $13048=$4558;
      var $13049=$13042;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4901, 1, 0, 1, 0, 98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 424; break; } else { __label__ = 11811; break; }
    case 424: // $13050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4902, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 425; break; } else { __label__ = 11811; break; }
    case 425: // $13051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4903, 4, 0, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 426; break; } else { __label__ = 11811; break; }
    case 426: // $13052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 427; break; } else { __label__ = 11811; break; }
    case 427: // $13053
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 428; break; } else { __label__ = 11811; break; }
    case 428: // $13054
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 429; break; } else { __label__ = 11811; break; }
    case 429: // $13055
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 430; break; } else { __label__ = 11811; break; }
    case 430: // $13056
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4900, $4901, $4902, $4903, $4904, $4905, $4906, $4907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 431; break; } else { __label__ = 11811; break; }
    case 431: // $13057
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13049, 73, 1, 0, ((STRING_TABLE.__str244)|0), ((STRING_TABLE.__str245)|0), $4900) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 432; break; } else { __label__ = 11811; break; }
    case 432: // $13058
      var $13059=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13049);
      var $13060=__ZN11simple_listI16input_type_entryE6appendERS0_($13010, $13059);
      var $13061=$4689;
      var $13062=$4549;
      var $13063=$4550;
      var $13064=$4551;
      var $13065=$result_i53;
      var $13066=$4552;
      var $13067=$4553;
      HEAP32[(($4549)>>2)]=408;
      HEAP32[(($4550)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4551)>>2)]=81;
      var $13068=HEAP32[(($4549)>>2)];
      var $13069=HEAP32[(($4550)>>2)];
      var $13070=HEAP32[(($4551)>>2)];
      var $13071=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13068, $13069, $13070) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 433; break; } else { __label__ = 435; break; };
    case 433: // $13072
      HEAP32[(($result_i53)>>2)]=$13071;
      var $13073=HEAP32[(($result_i53)>>2)];
      var $13074=(($13073)|0)==0;
      if ($13074) { __label__ = 434; break; } else { __label__ = 439; break; }
    case 434: // $13075
      var $13076=___cxa_allocate_exception(4);
      var $13077=$13076;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13077);
      (function() { try { __THREW__ = false; return ___cxa_throw($13076, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 438; break; } else { __label__ = 435; break; }
    case 435: // $13078
      var $13079=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13080=$13079.f0;
      HEAP32[(($4552)>>2)]=$13080;
      var $13081=$13079.f1;
      HEAP32[(($4553)>>2)]=$13081;
      var $13082=HEAP32[(($4553)>>2)];
      var $13083=(($13082)|0) < 0;
      if ($13083) { __label__ = 436; break; } else { __label__ = 437; break; }
    case 436: // $13084
      var $13085=HEAP32[(($4552)>>2)];
      ___cxa_call_unexpected($13085);
      throw "Reached an unreachable!"
    case 437: // $13086
      var $13087=HEAP32[(($4552)>>2)];
      var $13088=HEAP32[(($4552)>>2)];
      var $13089=HEAP32[(($4553)>>2)];
      var $13090=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13088, tempValue);
      var $13091=($13090.f1 = $13089, $13090);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 438: // $13092
      throw "Reached an unreachable!"
    case 439: // $_ZnwjPKci_exit54
      var $13093=HEAP32[(($result_i53)>>2)];
      var $13094=$4549;
      var $13095=$4550;
      var $13096=$4551;
      var $13097=$result_i53;
      var $13098=$4552;
      var $13099=$4553;
      var $13100=$13093;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4909, 4, 0, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 440; break; } else { __label__ = 11816; break; }
    case 440: // $13101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4910, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 441; break; } else { __label__ = 11816; break; }
    case 441: // $13102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4911, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 442; break; } else { __label__ = 11816; break; }
    case 442: // $13103
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 443; break; } else { __label__ = 11816; break; }
    case 443: // $13104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 444; break; } else { __label__ = 11816; break; }
    case 444: // $13105
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 445; break; } else { __label__ = 11816; break; }
    case 445: // $13106
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 446; break; } else { __label__ = 11816; break; }
    case 446: // $13107
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4908, $4909, $4910, $4911, $4912, $4913, $4914, $4915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 447; break; } else { __label__ = 11816; break; }
    case 447: // $13108
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13100, 74, 1, 0, ((STRING_TABLE.__str246)|0), ((STRING_TABLE.__str247)|0), $4908) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 448; break; } else { __label__ = 11816; break; }
    case 448: // $13109
      var $13110=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13100);
      var $13111=__ZN11simple_listI16input_type_entryE6appendERS0_($13061, $13110);
      var $13112=$4689;
      var $13113=$4544;
      var $13114=$4545;
      var $13115=$4546;
      var $13116=$result_i55;
      var $13117=$4547;
      var $13118=$4548;
      HEAP32[(($4544)>>2)]=408;
      HEAP32[(($4545)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4546)>>2)]=82;
      var $13119=HEAP32[(($4544)>>2)];
      var $13120=HEAP32[(($4545)>>2)];
      var $13121=HEAP32[(($4546)>>2)];
      var $13122=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13119, $13120, $13121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 449; break; } else { __label__ = 451; break; };
    case 449: // $13123
      HEAP32[(($result_i55)>>2)]=$13122;
      var $13124=HEAP32[(($result_i55)>>2)];
      var $13125=(($13124)|0)==0;
      if ($13125) { __label__ = 450; break; } else { __label__ = 455; break; }
    case 450: // $13126
      var $13127=___cxa_allocate_exception(4);
      var $13128=$13127;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13128);
      (function() { try { __THREW__ = false; return ___cxa_throw($13127, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 454; break; } else { __label__ = 451; break; }
    case 451: // $13129
      var $13130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13131=$13130.f0;
      HEAP32[(($4547)>>2)]=$13131;
      var $13132=$13130.f1;
      HEAP32[(($4548)>>2)]=$13132;
      var $13133=HEAP32[(($4548)>>2)];
      var $13134=(($13133)|0) < 0;
      if ($13134) { __label__ = 452; break; } else { __label__ = 453; break; }
    case 452: // $13135
      var $13136=HEAP32[(($4547)>>2)];
      ___cxa_call_unexpected($13136);
      throw "Reached an unreachable!"
    case 453: // $13137
      var $13138=HEAP32[(($4547)>>2)];
      var $13139=HEAP32[(($4547)>>2)];
      var $13140=HEAP32[(($4548)>>2)];
      var $13141=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13139, tempValue);
      var $13142=($13141.f1 = $13140, $13141);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 454: // $13143
      throw "Reached an unreachable!"
    case 455: // $_ZnwjPKci_exit56
      var $13144=HEAP32[(($result_i55)>>2)];
      var $13145=$4544;
      var $13146=$4545;
      var $13147=$4546;
      var $13148=$result_i55;
      var $13149=$4547;
      var $13150=$4548;
      var $13151=$13144;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4917, 1, 0, 1, 0, 28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 456; break; } else { __label__ = 11821; break; }
    case 456: // $13152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4918, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 457; break; } else { __label__ = 11821; break; }
    case 457: // $13153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4919, 4, 0, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 458; break; } else { __label__ = 11821; break; }
    case 458: // $13154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 459; break; } else { __label__ = 11821; break; }
    case 459: // $13155
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 460; break; } else { __label__ = 11821; break; }
    case 460: // $13156
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 461; break; } else { __label__ = 11821; break; }
    case 461: // $13157
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 462; break; } else { __label__ = 11821; break; }
    case 462: // $13158
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4916, $4917, $4918, $4919, $4920, $4921, $4922, $4923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 463; break; } else { __label__ = 11821; break; }
    case 463: // $13159
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13151, 43, 1, 0, ((STRING_TABLE.__str248)|0), ((STRING_TABLE.__str249)|0), $4916) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 464; break; } else { __label__ = 11821; break; }
    case 464: // $13160
      var $13161=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13151);
      var $13162=__ZN11simple_listI16input_type_entryE6appendERS0_($13112, $13161);
      var $13163=$4689;
      var $13164=$4539;
      var $13165=$4540;
      var $13166=$4541;
      var $13167=$result_i57;
      var $13168=$4542;
      var $13169=$4543;
      HEAP32[(($4539)>>2)]=408;
      HEAP32[(($4540)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4541)>>2)]=83;
      var $13170=HEAP32[(($4539)>>2)];
      var $13171=HEAP32[(($4540)>>2)];
      var $13172=HEAP32[(($4541)>>2)];
      var $13173=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13170, $13171, $13172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 465; break; } else { __label__ = 467; break; };
    case 465: // $13174
      HEAP32[(($result_i57)>>2)]=$13173;
      var $13175=HEAP32[(($result_i57)>>2)];
      var $13176=(($13175)|0)==0;
      if ($13176) { __label__ = 466; break; } else { __label__ = 471; break; }
    case 466: // $13177
      var $13178=___cxa_allocate_exception(4);
      var $13179=$13178;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13179);
      (function() { try { __THREW__ = false; return ___cxa_throw($13178, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 470; break; } else { __label__ = 467; break; }
    case 467: // $13180
      var $13181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13182=$13181.f0;
      HEAP32[(($4542)>>2)]=$13182;
      var $13183=$13181.f1;
      HEAP32[(($4543)>>2)]=$13183;
      var $13184=HEAP32[(($4543)>>2)];
      var $13185=(($13184)|0) < 0;
      if ($13185) { __label__ = 468; break; } else { __label__ = 469; break; }
    case 468: // $13186
      var $13187=HEAP32[(($4542)>>2)];
      ___cxa_call_unexpected($13187);
      throw "Reached an unreachable!"
    case 469: // $13188
      var $13189=HEAP32[(($4542)>>2)];
      var $13190=HEAP32[(($4542)>>2)];
      var $13191=HEAP32[(($4543)>>2)];
      var $13192=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13190, tempValue);
      var $13193=($13192.f1 = $13191, $13192);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 470: // $13194
      throw "Reached an unreachable!"
    case 471: // $_ZnwjPKci_exit58
      var $13195=HEAP32[(($result_i57)>>2)];
      var $13196=$4539;
      var $13197=$4540;
      var $13198=$4541;
      var $13199=$result_i57;
      var $13200=$4542;
      var $13201=$4543;
      var $13202=$13195;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4925, 1, 0, 1, 0, 32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 472; break; } else { __label__ = 11826; break; }
    case 472: // $13203
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4926, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 473; break; } else { __label__ = 11826; break; }
    case 473: // $13204
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4927, 4, 0, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 474; break; } else { __label__ = 11826; break; }
    case 474: // $13205
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 475; break; } else { __label__ = 11826; break; }
    case 475: // $13206
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 476; break; } else { __label__ = 11826; break; }
    case 476: // $13207
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 477; break; } else { __label__ = 11826; break; }
    case 477: // $13208
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 478; break; } else { __label__ = 11826; break; }
    case 478: // $13209
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4924, $4925, $4926, $4927, $4928, $4929, $4930, $4931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 479; break; } else { __label__ = 11826; break; }
    case 479: // $13210
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13202, 44, 1, 0, ((STRING_TABLE.__str250)|0), ((STRING_TABLE.__str251)|0), $4924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 480; break; } else { __label__ = 11826; break; }
    case 480: // $13211
      var $13212=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13202);
      var $13213=__ZN11simple_listI16input_type_entryE6appendERS0_($13163, $13212);
      var $13214=$4689;
      var $13215=$4534;
      var $13216=$4535;
      var $13217=$4536;
      var $13218=$result_i59;
      var $13219=$4537;
      var $13220=$4538;
      HEAP32[(($4534)>>2)]=408;
      HEAP32[(($4535)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4536)>>2)]=84;
      var $13221=HEAP32[(($4534)>>2)];
      var $13222=HEAP32[(($4535)>>2)];
      var $13223=HEAP32[(($4536)>>2)];
      var $13224=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13221, $13222, $13223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 481; break; } else { __label__ = 483; break; };
    case 481: // $13225
      HEAP32[(($result_i59)>>2)]=$13224;
      var $13226=HEAP32[(($result_i59)>>2)];
      var $13227=(($13226)|0)==0;
      if ($13227) { __label__ = 482; break; } else { __label__ = 487; break; }
    case 482: // $13228
      var $13229=___cxa_allocate_exception(4);
      var $13230=$13229;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13230);
      (function() { try { __THREW__ = false; return ___cxa_throw($13229, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 486; break; } else { __label__ = 483; break; }
    case 483: // $13231
      var $13232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13233=$13232.f0;
      HEAP32[(($4537)>>2)]=$13233;
      var $13234=$13232.f1;
      HEAP32[(($4538)>>2)]=$13234;
      var $13235=HEAP32[(($4538)>>2)];
      var $13236=(($13235)|0) < 0;
      if ($13236) { __label__ = 484; break; } else { __label__ = 485; break; }
    case 484: // $13237
      var $13238=HEAP32[(($4537)>>2)];
      ___cxa_call_unexpected($13238);
      throw "Reached an unreachable!"
    case 485: // $13239
      var $13240=HEAP32[(($4537)>>2)];
      var $13241=HEAP32[(($4537)>>2)];
      var $13242=HEAP32[(($4538)>>2)];
      var $13243=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13241, tempValue);
      var $13244=($13243.f1 = $13242, $13243);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 486: // $13245
      throw "Reached an unreachable!"
    case 487: // $_ZnwjPKci_exit60
      var $13246=HEAP32[(($result_i59)>>2)];
      var $13247=$4534;
      var $13248=$4535;
      var $13249=$4536;
      var $13250=$result_i59;
      var $13251=$4537;
      var $13252=$4538;
      var $13253=$13246;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4933, 1, 0, 1, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 488; break; } else { __label__ = 11831; break; }
    case 488: // $13254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4934, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 489; break; } else { __label__ = 11831; break; }
    case 489: // $13255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4935, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 490; break; } else { __label__ = 11831; break; }
    case 490: // $13256
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 491; break; } else { __label__ = 11831; break; }
    case 491: // $13257
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 492; break; } else { __label__ = 11831; break; }
    case 492: // $13258
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 493; break; } else { __label__ = 11831; break; }
    case 493: // $13259
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 494; break; } else { __label__ = 11831; break; }
    case 494: // $13260
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4932, $4933, $4934, $4935, $4936, $4937, $4938, $4939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 495; break; } else { __label__ = 11831; break; }
    case 495: // $13261
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13253, 75, 1, 0, ((STRING_TABLE.__str252)|0), ((STRING_TABLE.__str253)|0), $4932) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 496; break; } else { __label__ = 11831; break; }
    case 496: // $13262
      var $13263=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13253);
      var $13264=__ZN11simple_listI16input_type_entryE6appendERS0_($13214, $13263);
      var $13265=$4689;
      var $13266=$4529;
      var $13267=$4530;
      var $13268=$4531;
      var $13269=$result_i61;
      var $13270=$4532;
      var $13271=$4533;
      HEAP32[(($4529)>>2)]=408;
      HEAP32[(($4530)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4531)>>2)]=85;
      var $13272=HEAP32[(($4529)>>2)];
      var $13273=HEAP32[(($4530)>>2)];
      var $13274=HEAP32[(($4531)>>2)];
      var $13275=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13272, $13273, $13274) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 497; break; } else { __label__ = 499; break; };
    case 497: // $13276
      HEAP32[(($result_i61)>>2)]=$13275;
      var $13277=HEAP32[(($result_i61)>>2)];
      var $13278=(($13277)|0)==0;
      if ($13278) { __label__ = 498; break; } else { __label__ = 503; break; }
    case 498: // $13279
      var $13280=___cxa_allocate_exception(4);
      var $13281=$13280;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13281);
      (function() { try { __THREW__ = false; return ___cxa_throw($13280, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 502; break; } else { __label__ = 499; break; }
    case 499: // $13282
      var $13283=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13284=$13283.f0;
      HEAP32[(($4532)>>2)]=$13284;
      var $13285=$13283.f1;
      HEAP32[(($4533)>>2)]=$13285;
      var $13286=HEAP32[(($4533)>>2)];
      var $13287=(($13286)|0) < 0;
      if ($13287) { __label__ = 500; break; } else { __label__ = 501; break; }
    case 500: // $13288
      var $13289=HEAP32[(($4532)>>2)];
      ___cxa_call_unexpected($13289);
      throw "Reached an unreachable!"
    case 501: // $13290
      var $13291=HEAP32[(($4532)>>2)];
      var $13292=HEAP32[(($4532)>>2)];
      var $13293=HEAP32[(($4533)>>2)];
      var $13294=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13292, tempValue);
      var $13295=($13294.f1 = $13293, $13294);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 502: // $13296
      throw "Reached an unreachable!"
    case 503: // $_ZnwjPKci_exit62
      var $13297=HEAP32[(($result_i61)>>2)];
      var $13298=$4529;
      var $13299=$4530;
      var $13300=$4531;
      var $13301=$result_i61;
      var $13302=$4532;
      var $13303=$4533;
      var $13304=$13297;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4941, 1, 0, 1, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 504; break; } else { __label__ = 11836; break; }
    case 504: // $13305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4942, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 505; break; } else { __label__ = 11836; break; }
    case 505: // $13306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4943, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 506; break; } else { __label__ = 11836; break; }
    case 506: // $13307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 507; break; } else { __label__ = 11836; break; }
    case 507: // $13308
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 508; break; } else { __label__ = 11836; break; }
    case 508: // $13309
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 509; break; } else { __label__ = 11836; break; }
    case 509: // $13310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 510; break; } else { __label__ = 11836; break; }
    case 510: // $13311
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4940, $4941, $4942, $4943, $4944, $4945, $4946, $4947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 511; break; } else { __label__ = 11836; break; }
    case 511: // $13312
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13304, 76, 1, 0, ((STRING_TABLE.__str254)|0), ((STRING_TABLE.__str255)|0), $4940) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 512; break; } else { __label__ = 11836; break; }
    case 512: // $13313
      var $13314=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13304);
      var $13315=__ZN11simple_listI16input_type_entryE6appendERS0_($13265, $13314);
      var $13316=$4689;
      var $13317=$4524;
      var $13318=$4525;
      var $13319=$4526;
      var $13320=$result_i63;
      var $13321=$4527;
      var $13322=$4528;
      HEAP32[(($4524)>>2)]=408;
      HEAP32[(($4525)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4526)>>2)]=86;
      var $13323=HEAP32[(($4524)>>2)];
      var $13324=HEAP32[(($4525)>>2)];
      var $13325=HEAP32[(($4526)>>2)];
      var $13326=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13323, $13324, $13325) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 513; break; } else { __label__ = 515; break; };
    case 513: // $13327
      HEAP32[(($result_i63)>>2)]=$13326;
      var $13328=HEAP32[(($result_i63)>>2)];
      var $13329=(($13328)|0)==0;
      if ($13329) { __label__ = 514; break; } else { __label__ = 519; break; }
    case 514: // $13330
      var $13331=___cxa_allocate_exception(4);
      var $13332=$13331;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13332);
      (function() { try { __THREW__ = false; return ___cxa_throw($13331, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 518; break; } else { __label__ = 515; break; }
    case 515: // $13333
      var $13334=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13335=$13334.f0;
      HEAP32[(($4527)>>2)]=$13335;
      var $13336=$13334.f1;
      HEAP32[(($4528)>>2)]=$13336;
      var $13337=HEAP32[(($4528)>>2)];
      var $13338=(($13337)|0) < 0;
      if ($13338) { __label__ = 516; break; } else { __label__ = 517; break; }
    case 516: // $13339
      var $13340=HEAP32[(($4527)>>2)];
      ___cxa_call_unexpected($13340);
      throw "Reached an unreachable!"
    case 517: // $13341
      var $13342=HEAP32[(($4527)>>2)];
      var $13343=HEAP32[(($4527)>>2)];
      var $13344=HEAP32[(($4528)>>2)];
      var $13345=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13343, tempValue);
      var $13346=($13345.f1 = $13344, $13345);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 518: // $13347
      throw "Reached an unreachable!"
    case 519: // $_ZnwjPKci_exit64
      var $13348=HEAP32[(($result_i63)>>2)];
      var $13349=$4524;
      var $13350=$4525;
      var $13351=$4526;
      var $13352=$result_i63;
      var $13353=$4527;
      var $13354=$4528;
      var $13355=$13348;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4949, 1, 0, 1, 0, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 520; break; } else { __label__ = 11841; break; }
    case 520: // $13356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4950, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 521; break; } else { __label__ = 11841; break; }
    case 521: // $13357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4951, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 522; break; } else { __label__ = 11841; break; }
    case 522: // $13358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 523; break; } else { __label__ = 11841; break; }
    case 523: // $13359
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 524; break; } else { __label__ = 11841; break; }
    case 524: // $13360
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 525; break; } else { __label__ = 11841; break; }
    case 525: // $13361
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 526; break; } else { __label__ = 11841; break; }
    case 526: // $13362
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4948, $4949, $4950, $4951, $4952, $4953, $4954, $4955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 527; break; } else { __label__ = 11841; break; }
    case 527: // $13363
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13355, 77, 1, 0, ((STRING_TABLE.__str256)|0), ((STRING_TABLE.__str257)|0), $4948) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 528; break; } else { __label__ = 11841; break; }
    case 528: // $13364
      var $13365=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13355);
      var $13366=__ZN11simple_listI16input_type_entryE6appendERS0_($13316, $13365);
      var $13367=$4689;
      var $13368=$4519;
      var $13369=$4520;
      var $13370=$4521;
      var $13371=$result_i65;
      var $13372=$4522;
      var $13373=$4523;
      HEAP32[(($4519)>>2)]=408;
      HEAP32[(($4520)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4521)>>2)]=87;
      var $13374=HEAP32[(($4519)>>2)];
      var $13375=HEAP32[(($4520)>>2)];
      var $13376=HEAP32[(($4521)>>2)];
      var $13377=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13374, $13375, $13376) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 529; break; } else { __label__ = 531; break; };
    case 529: // $13378
      HEAP32[(($result_i65)>>2)]=$13377;
      var $13379=HEAP32[(($result_i65)>>2)];
      var $13380=(($13379)|0)==0;
      if ($13380) { __label__ = 530; break; } else { __label__ = 535; break; }
    case 530: // $13381
      var $13382=___cxa_allocate_exception(4);
      var $13383=$13382;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13383);
      (function() { try { __THREW__ = false; return ___cxa_throw($13382, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 534; break; } else { __label__ = 531; break; }
    case 531: // $13384
      var $13385=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13386=$13385.f0;
      HEAP32[(($4522)>>2)]=$13386;
      var $13387=$13385.f1;
      HEAP32[(($4523)>>2)]=$13387;
      var $13388=HEAP32[(($4523)>>2)];
      var $13389=(($13388)|0) < 0;
      if ($13389) { __label__ = 532; break; } else { __label__ = 533; break; }
    case 532: // $13390
      var $13391=HEAP32[(($4522)>>2)];
      ___cxa_call_unexpected($13391);
      throw "Reached an unreachable!"
    case 533: // $13392
      var $13393=HEAP32[(($4522)>>2)];
      var $13394=HEAP32[(($4522)>>2)];
      var $13395=HEAP32[(($4523)>>2)];
      var $13396=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13394, tempValue);
      var $13397=($13396.f1 = $13395, $13396);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 534: // $13398
      throw "Reached an unreachable!"
    case 535: // $_ZnwjPKci_exit66
      var $13399=HEAP32[(($result_i65)>>2)];
      var $13400=$4519;
      var $13401=$4520;
      var $13402=$4521;
      var $13403=$result_i65;
      var $13404=$4522;
      var $13405=$4523;
      var $13406=$13399;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4957, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 536; break; } else { __label__ = 11846; break; }
    case 536: // $13407
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 537; break; } else { __label__ = 11846; break; }
    case 537: // $13408
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 538; break; } else { __label__ = 11846; break; }
    case 538: // $13409
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 539; break; } else { __label__ = 11846; break; }
    case 539: // $13410
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 540; break; } else { __label__ = 11846; break; }
    case 540: // $13411
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 541; break; } else { __label__ = 11846; break; }
    case 541: // $13412
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 542; break; } else { __label__ = 11846; break; }
    case 542: // $13413
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4956, $4957, $4958, $4959, $4960, $4961, $4962, $4963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 543; break; } else { __label__ = 11846; break; }
    case 543: // $13414
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13406, 78, 1, 0, ((STRING_TABLE.__str258)|0), ((STRING_TABLE.__str259)|0), $4956) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 544; break; } else { __label__ = 11846; break; }
    case 544: // $13415
      var $13416=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13406);
      var $13417=__ZN11simple_listI16input_type_entryE6appendERS0_($13367, $13416);
      var $13418=$4689;
      var $13419=$4514;
      var $13420=$4515;
      var $13421=$4516;
      var $13422=$result_i67;
      var $13423=$4517;
      var $13424=$4518;
      HEAP32[(($4514)>>2)]=408;
      HEAP32[(($4515)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4516)>>2)]=88;
      var $13425=HEAP32[(($4514)>>2)];
      var $13426=HEAP32[(($4515)>>2)];
      var $13427=HEAP32[(($4516)>>2)];
      var $13428=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13425, $13426, $13427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 545; break; } else { __label__ = 547; break; };
    case 545: // $13429
      HEAP32[(($result_i67)>>2)]=$13428;
      var $13430=HEAP32[(($result_i67)>>2)];
      var $13431=(($13430)|0)==0;
      if ($13431) { __label__ = 546; break; } else { __label__ = 551; break; }
    case 546: // $13432
      var $13433=___cxa_allocate_exception(4);
      var $13434=$13433;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13434);
      (function() { try { __THREW__ = false; return ___cxa_throw($13433, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 550; break; } else { __label__ = 547; break; }
    case 547: // $13435
      var $13436=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13437=$13436.f0;
      HEAP32[(($4517)>>2)]=$13437;
      var $13438=$13436.f1;
      HEAP32[(($4518)>>2)]=$13438;
      var $13439=HEAP32[(($4518)>>2)];
      var $13440=(($13439)|0) < 0;
      if ($13440) { __label__ = 548; break; } else { __label__ = 549; break; }
    case 548: // $13441
      var $13442=HEAP32[(($4517)>>2)];
      ___cxa_call_unexpected($13442);
      throw "Reached an unreachable!"
    case 549: // $13443
      var $13444=HEAP32[(($4517)>>2)];
      var $13445=HEAP32[(($4517)>>2)];
      var $13446=HEAP32[(($4518)>>2)];
      var $13447=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13445, tempValue);
      var $13448=($13447.f1 = $13446, $13447);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 550: // $13449
      throw "Reached an unreachable!"
    case 551: // $_ZnwjPKci_exit68
      var $13450=HEAP32[(($result_i67)>>2)];
      var $13451=$4514;
      var $13452=$4515;
      var $13453=$4516;
      var $13454=$result_i67;
      var $13455=$4517;
      var $13456=$4518;
      var $13457=$13450;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4965, 1, 0, 1, 0, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 552; break; } else { __label__ = 11851; break; }
    case 552: // $13458
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4966, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 553; break; } else { __label__ = 11851; break; }
    case 553: // $13459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4967, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 554; break; } else { __label__ = 11851; break; }
    case 554: // $13460
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 555; break; } else { __label__ = 11851; break; }
    case 555: // $13461
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 556; break; } else { __label__ = 11851; break; }
    case 556: // $13462
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 557; break; } else { __label__ = 11851; break; }
    case 557: // $13463
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 558; break; } else { __label__ = 11851; break; }
    case 558: // $13464
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4964, $4965, $4966, $4967, $4968, $4969, $4970, $4971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 559; break; } else { __label__ = 11851; break; }
    case 559: // $13465
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13457, 79, 1, 0, ((STRING_TABLE.__str260)|0), ((STRING_TABLE.__str261)|0), $4964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 560; break; } else { __label__ = 11851; break; }
    case 560: // $13466
      var $13467=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13457);
      var $13468=__ZN11simple_listI16input_type_entryE6appendERS0_($13418, $13467);
      var $13469=$4689;
      var $13470=$4509;
      var $13471=$4510;
      var $13472=$4511;
      var $13473=$result_i69;
      var $13474=$4512;
      var $13475=$4513;
      HEAP32[(($4509)>>2)]=408;
      HEAP32[(($4510)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4511)>>2)]=89;
      var $13476=HEAP32[(($4509)>>2)];
      var $13477=HEAP32[(($4510)>>2)];
      var $13478=HEAP32[(($4511)>>2)];
      var $13479=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13476, $13477, $13478) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 561; break; } else { __label__ = 563; break; };
    case 561: // $13480
      HEAP32[(($result_i69)>>2)]=$13479;
      var $13481=HEAP32[(($result_i69)>>2)];
      var $13482=(($13481)|0)==0;
      if ($13482) { __label__ = 562; break; } else { __label__ = 567; break; }
    case 562: // $13483
      var $13484=___cxa_allocate_exception(4);
      var $13485=$13484;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13485);
      (function() { try { __THREW__ = false; return ___cxa_throw($13484, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 566; break; } else { __label__ = 563; break; }
    case 563: // $13486
      var $13487=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13488=$13487.f0;
      HEAP32[(($4512)>>2)]=$13488;
      var $13489=$13487.f1;
      HEAP32[(($4513)>>2)]=$13489;
      var $13490=HEAP32[(($4513)>>2)];
      var $13491=(($13490)|0) < 0;
      if ($13491) { __label__ = 564; break; } else { __label__ = 565; break; }
    case 564: // $13492
      var $13493=HEAP32[(($4512)>>2)];
      ___cxa_call_unexpected($13493);
      throw "Reached an unreachable!"
    case 565: // $13494
      var $13495=HEAP32[(($4512)>>2)];
      var $13496=HEAP32[(($4512)>>2)];
      var $13497=HEAP32[(($4513)>>2)];
      var $13498=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13496, tempValue);
      var $13499=($13498.f1 = $13497, $13498);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 566: // $13500
      throw "Reached an unreachable!"
    case 567: // $_ZnwjPKci_exit70
      var $13501=HEAP32[(($result_i69)>>2)];
      var $13502=$4509;
      var $13503=$4510;
      var $13504=$4511;
      var $13505=$result_i69;
      var $13506=$4512;
      var $13507=$4513;
      var $13508=$13501;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4973, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 568; break; } else { __label__ = 11856; break; }
    case 568: // $13509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4974, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 569; break; } else { __label__ = 11856; break; }
    case 569: // $13510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4975, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 570; break; } else { __label__ = 11856; break; }
    case 570: // $13511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 571; break; } else { __label__ = 11856; break; }
    case 571: // $13512
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 572; break; } else { __label__ = 11856; break; }
    case 572: // $13513
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 573; break; } else { __label__ = 11856; break; }
    case 573: // $13514
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 574; break; } else { __label__ = 11856; break; }
    case 574: // $13515
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4972, $4973, $4974, $4975, $4976, $4977, $4978, $4979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 575; break; } else { __label__ = 11856; break; }
    case 575: // $13516
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13508, 80, 1, 0, ((STRING_TABLE.__str262)|0), ((STRING_TABLE.__str263)|0), $4972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 576; break; } else { __label__ = 11856; break; }
    case 576: // $13517
      var $13518=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13508);
      var $13519=__ZN11simple_listI16input_type_entryE6appendERS0_($13469, $13518);
      var $13520=$4689;
      var $13521=$4504;
      var $13522=$4505;
      var $13523=$4506;
      var $13524=$result_i71;
      var $13525=$4507;
      var $13526=$4508;
      HEAP32[(($4504)>>2)]=408;
      HEAP32[(($4505)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4506)>>2)]=90;
      var $13527=HEAP32[(($4504)>>2)];
      var $13528=HEAP32[(($4505)>>2)];
      var $13529=HEAP32[(($4506)>>2)];
      var $13530=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13527, $13528, $13529) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 577; break; } else { __label__ = 579; break; };
    case 577: // $13531
      HEAP32[(($result_i71)>>2)]=$13530;
      var $13532=HEAP32[(($result_i71)>>2)];
      var $13533=(($13532)|0)==0;
      if ($13533) { __label__ = 578; break; } else { __label__ = 583; break; }
    case 578: // $13534
      var $13535=___cxa_allocate_exception(4);
      var $13536=$13535;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13536);
      (function() { try { __THREW__ = false; return ___cxa_throw($13535, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 582; break; } else { __label__ = 579; break; }
    case 579: // $13537
      var $13538=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13539=$13538.f0;
      HEAP32[(($4507)>>2)]=$13539;
      var $13540=$13538.f1;
      HEAP32[(($4508)>>2)]=$13540;
      var $13541=HEAP32[(($4508)>>2)];
      var $13542=(($13541)|0) < 0;
      if ($13542) { __label__ = 580; break; } else { __label__ = 581; break; }
    case 580: // $13543
      var $13544=HEAP32[(($4507)>>2)];
      ___cxa_call_unexpected($13544);
      throw "Reached an unreachable!"
    case 581: // $13545
      var $13546=HEAP32[(($4507)>>2)];
      var $13547=HEAP32[(($4507)>>2)];
      var $13548=HEAP32[(($4508)>>2)];
      var $13549=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13547, tempValue);
      var $13550=($13549.f1 = $13548, $13549);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 582: // $13551
      throw "Reached an unreachable!"
    case 583: // $_ZnwjPKci_exit72
      var $13552=HEAP32[(($result_i71)>>2)];
      var $13553=$4504;
      var $13554=$4505;
      var $13555=$4506;
      var $13556=$result_i71;
      var $13557=$4507;
      var $13558=$4508;
      var $13559=$13552;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4981, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 584; break; } else { __label__ = 11861; break; }
    case 584: // $13560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 585; break; } else { __label__ = 11861; break; }
    case 585: // $13561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 586; break; } else { __label__ = 11861; break; }
    case 586: // $13562
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 587; break; } else { __label__ = 11861; break; }
    case 587: // $13563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 588; break; } else { __label__ = 11861; break; }
    case 588: // $13564
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 589; break; } else { __label__ = 11861; break; }
    case 589: // $13565
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 590; break; } else { __label__ = 11861; break; }
    case 590: // $13566
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4980, $4981, $4982, $4983, $4984, $4985, $4986, $4987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 591; break; } else { __label__ = 11861; break; }
    case 591: // $13567
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13559, 81, 1, 0, ((STRING_TABLE.__str264)|0), ((STRING_TABLE.__str265)|0), $4980) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 592; break; } else { __label__ = 11861; break; }
    case 592: // $13568
      var $13569=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13559);
      var $13570=__ZN11simple_listI16input_type_entryE6appendERS0_($13520, $13569);
      var $13571=$4689;
      var $13572=$4499;
      var $13573=$4500;
      var $13574=$4501;
      var $13575=$result_i73;
      var $13576=$4502;
      var $13577=$4503;
      HEAP32[(($4499)>>2)]=408;
      HEAP32[(($4500)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4501)>>2)]=91;
      var $13578=HEAP32[(($4499)>>2)];
      var $13579=HEAP32[(($4500)>>2)];
      var $13580=HEAP32[(($4501)>>2)];
      var $13581=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13578, $13579, $13580) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 593; break; } else { __label__ = 595; break; };
    case 593: // $13582
      HEAP32[(($result_i73)>>2)]=$13581;
      var $13583=HEAP32[(($result_i73)>>2)];
      var $13584=(($13583)|0)==0;
      if ($13584) { __label__ = 594; break; } else { __label__ = 599; break; }
    case 594: // $13585
      var $13586=___cxa_allocate_exception(4);
      var $13587=$13586;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13587);
      (function() { try { __THREW__ = false; return ___cxa_throw($13586, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 598; break; } else { __label__ = 595; break; }
    case 595: // $13588
      var $13589=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13590=$13589.f0;
      HEAP32[(($4502)>>2)]=$13590;
      var $13591=$13589.f1;
      HEAP32[(($4503)>>2)]=$13591;
      var $13592=HEAP32[(($4503)>>2)];
      var $13593=(($13592)|0) < 0;
      if ($13593) { __label__ = 596; break; } else { __label__ = 597; break; }
    case 596: // $13594
      var $13595=HEAP32[(($4502)>>2)];
      ___cxa_call_unexpected($13595);
      throw "Reached an unreachable!"
    case 597: // $13596
      var $13597=HEAP32[(($4502)>>2)];
      var $13598=HEAP32[(($4502)>>2)];
      var $13599=HEAP32[(($4503)>>2)];
      var $13600=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13598, tempValue);
      var $13601=($13600.f1 = $13599, $13600);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 598: // $13602
      throw "Reached an unreachable!"
    case 599: // $_ZnwjPKci_exit74
      var $13603=HEAP32[(($result_i73)>>2)];
      var $13604=$4499;
      var $13605=$4500;
      var $13606=$4501;
      var $13607=$result_i73;
      var $13608=$4502;
      var $13609=$4503;
      var $13610=$13603;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4989, 1, 0, 1, 0, 8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 600; break; } else { __label__ = 11866; break; }
    case 600: // $13611
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4990, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 601; break; } else { __label__ = 11866; break; }
    case 601: // $13612
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4991, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 602; break; } else { __label__ = 11866; break; }
    case 602: // $13613
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 603; break; } else { __label__ = 11866; break; }
    case 603: // $13614
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 604; break; } else { __label__ = 11866; break; }
    case 604: // $13615
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 605; break; } else { __label__ = 11866; break; }
    case 605: // $13616
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 606; break; } else { __label__ = 11866; break; }
    case 606: // $13617
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4988, $4989, $4990, $4991, $4992, $4993, $4994, $4995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 607; break; } else { __label__ = 11866; break; }
    case 607: // $13618
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13610, 82, 1, 0, ((STRING_TABLE.__str266)|0), ((STRING_TABLE.__str267)|0), $4988) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 608; break; } else { __label__ = 11866; break; }
    case 608: // $13619
      var $13620=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13610);
      var $13621=__ZN11simple_listI16input_type_entryE6appendERS0_($13571, $13620);
      var $13622=$4689;
      var $13623=$4494;
      var $13624=$4495;
      var $13625=$4496;
      var $13626=$result_i75;
      var $13627=$4497;
      var $13628=$4498;
      HEAP32[(($4494)>>2)]=408;
      HEAP32[(($4495)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4496)>>2)]=92;
      var $13629=HEAP32[(($4494)>>2)];
      var $13630=HEAP32[(($4495)>>2)];
      var $13631=HEAP32[(($4496)>>2)];
      var $13632=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13629, $13630, $13631) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 609; break; } else { __label__ = 611; break; };
    case 609: // $13633
      HEAP32[(($result_i75)>>2)]=$13632;
      var $13634=HEAP32[(($result_i75)>>2)];
      var $13635=(($13634)|0)==0;
      if ($13635) { __label__ = 610; break; } else { __label__ = 615; break; }
    case 610: // $13636
      var $13637=___cxa_allocate_exception(4);
      var $13638=$13637;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13638);
      (function() { try { __THREW__ = false; return ___cxa_throw($13637, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 614; break; } else { __label__ = 611; break; }
    case 611: // $13639
      var $13640=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13641=$13640.f0;
      HEAP32[(($4497)>>2)]=$13641;
      var $13642=$13640.f1;
      HEAP32[(($4498)>>2)]=$13642;
      var $13643=HEAP32[(($4498)>>2)];
      var $13644=(($13643)|0) < 0;
      if ($13644) { __label__ = 612; break; } else { __label__ = 613; break; }
    case 612: // $13645
      var $13646=HEAP32[(($4497)>>2)];
      ___cxa_call_unexpected($13646);
      throw "Reached an unreachable!"
    case 613: // $13647
      var $13648=HEAP32[(($4497)>>2)];
      var $13649=HEAP32[(($4497)>>2)];
      var $13650=HEAP32[(($4498)>>2)];
      var $13651=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13649, tempValue);
      var $13652=($13651.f1 = $13650, $13651);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 614: // $13653
      throw "Reached an unreachable!"
    case 615: // $_ZnwjPKci_exit76
      var $13654=HEAP32[(($result_i75)>>2)];
      var $13655=$4494;
      var $13656=$4495;
      var $13657=$4496;
      var $13658=$result_i75;
      var $13659=$4497;
      var $13660=$4498;
      var $13661=$13654;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4997, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 616; break; } else { __label__ = 11871; break; }
    case 616: // $13662
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4998, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 617; break; } else { __label__ = 11871; break; }
    case 617: // $13663
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($4999, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 618; break; } else { __label__ = 11871; break; }
    case 618: // $13664
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 619; break; } else { __label__ = 11871; break; }
    case 619: // $13665
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 620; break; } else { __label__ = 11871; break; }
    case 620: // $13666
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 621; break; } else { __label__ = 11871; break; }
    case 621: // $13667
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 622; break; } else { __label__ = 11871; break; }
    case 622: // $13668
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($4996, $4997, $4998, $4999, $5000, $5001, $5002, $5003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 623; break; } else { __label__ = 11871; break; }
    case 623: // $13669
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13661, 83, 1, 0, ((STRING_TABLE.__str268)|0), ((STRING_TABLE.__str269)|0), $4996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 624; break; } else { __label__ = 11871; break; }
    case 624: // $13670
      var $13671=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13661);
      var $13672=__ZN11simple_listI16input_type_entryE6appendERS0_($13622, $13671);
      var $13673=$4689;
      var $13674=$4489;
      var $13675=$4490;
      var $13676=$4491;
      var $13677=$result_i77;
      var $13678=$4492;
      var $13679=$4493;
      HEAP32[(($4489)>>2)]=408;
      HEAP32[(($4490)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4491)>>2)]=93;
      var $13680=HEAP32[(($4489)>>2)];
      var $13681=HEAP32[(($4490)>>2)];
      var $13682=HEAP32[(($4491)>>2)];
      var $13683=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13680, $13681, $13682) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 625; break; } else { __label__ = 627; break; };
    case 625: // $13684
      HEAP32[(($result_i77)>>2)]=$13683;
      var $13685=HEAP32[(($result_i77)>>2)];
      var $13686=(($13685)|0)==0;
      if ($13686) { __label__ = 626; break; } else { __label__ = 631; break; }
    case 626: // $13687
      var $13688=___cxa_allocate_exception(4);
      var $13689=$13688;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13689);
      (function() { try { __THREW__ = false; return ___cxa_throw($13688, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 630; break; } else { __label__ = 627; break; }
    case 627: // $13690
      var $13691=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13692=$13691.f0;
      HEAP32[(($4492)>>2)]=$13692;
      var $13693=$13691.f1;
      HEAP32[(($4493)>>2)]=$13693;
      var $13694=HEAP32[(($4493)>>2)];
      var $13695=(($13694)|0) < 0;
      if ($13695) { __label__ = 628; break; } else { __label__ = 629; break; }
    case 628: // $13696
      var $13697=HEAP32[(($4492)>>2)];
      ___cxa_call_unexpected($13697);
      throw "Reached an unreachable!"
    case 629: // $13698
      var $13699=HEAP32[(($4492)>>2)];
      var $13700=HEAP32[(($4492)>>2)];
      var $13701=HEAP32[(($4493)>>2)];
      var $13702=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13700, tempValue);
      var $13703=($13702.f1 = $13701, $13702);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 630: // $13704
      throw "Reached an unreachable!"
    case 631: // $_ZnwjPKci_exit78
      var $13705=HEAP32[(($result_i77)>>2)];
      var $13706=$4489;
      var $13707=$4490;
      var $13708=$4491;
      var $13709=$result_i77;
      var $13710=$4492;
      var $13711=$4493;
      var $13712=$13705;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5005, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 632; break; } else { __label__ = 11876; break; }
    case 632: // $13713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5006, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 633; break; } else { __label__ = 11876; break; }
    case 633: // $13714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5007, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 634; break; } else { __label__ = 11876; break; }
    case 634: // $13715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 635; break; } else { __label__ = 11876; break; }
    case 635: // $13716
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 636; break; } else { __label__ = 11876; break; }
    case 636: // $13717
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 637; break; } else { __label__ = 11876; break; }
    case 637: // $13718
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 638; break; } else { __label__ = 11876; break; }
    case 638: // $13719
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5004, $5005, $5006, $5007, $5008, $5009, $5010, $5011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 639; break; } else { __label__ = 11876; break; }
    case 639: // $13720
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13712, 84, 1, 0, ((STRING_TABLE.__str270)|0), ((STRING_TABLE.__str271404)|0), $5004) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 640; break; } else { __label__ = 11876; break; }
    case 640: // $13721
      var $13722=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13712);
      var $13723=__ZN11simple_listI16input_type_entryE6appendERS0_($13673, $13722);
      var $13724=$4689;
      var $13725=$4484;
      var $13726=$4485;
      var $13727=$4486;
      var $13728=$result_i79;
      var $13729=$4487;
      var $13730=$4488;
      HEAP32[(($4484)>>2)]=408;
      HEAP32[(($4485)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4486)>>2)]=94;
      var $13731=HEAP32[(($4484)>>2)];
      var $13732=HEAP32[(($4485)>>2)];
      var $13733=HEAP32[(($4486)>>2)];
      var $13734=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13731, $13732, $13733) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 641; break; } else { __label__ = 643; break; };
    case 641: // $13735
      HEAP32[(($result_i79)>>2)]=$13734;
      var $13736=HEAP32[(($result_i79)>>2)];
      var $13737=(($13736)|0)==0;
      if ($13737) { __label__ = 642; break; } else { __label__ = 647; break; }
    case 642: // $13738
      var $13739=___cxa_allocate_exception(4);
      var $13740=$13739;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13740);
      (function() { try { __THREW__ = false; return ___cxa_throw($13739, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 646; break; } else { __label__ = 643; break; }
    case 643: // $13741
      var $13742=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13743=$13742.f0;
      HEAP32[(($4487)>>2)]=$13743;
      var $13744=$13742.f1;
      HEAP32[(($4488)>>2)]=$13744;
      var $13745=HEAP32[(($4488)>>2)];
      var $13746=(($13745)|0) < 0;
      if ($13746) { __label__ = 644; break; } else { __label__ = 645; break; }
    case 644: // $13747
      var $13748=HEAP32[(($4487)>>2)];
      ___cxa_call_unexpected($13748);
      throw "Reached an unreachable!"
    case 645: // $13749
      var $13750=HEAP32[(($4487)>>2)];
      var $13751=HEAP32[(($4487)>>2)];
      var $13752=HEAP32[(($4488)>>2)];
      var $13753=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13751, tempValue);
      var $13754=($13753.f1 = $13752, $13753);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 646: // $13755
      throw "Reached an unreachable!"
    case 647: // $_ZnwjPKci_exit80
      var $13756=HEAP32[(($result_i79)>>2)];
      var $13757=$4484;
      var $13758=$4485;
      var $13759=$4486;
      var $13760=$result_i79;
      var $13761=$4487;
      var $13762=$4488;
      var $13763=$13756;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5013, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 648; break; } else { __label__ = 11881; break; }
    case 648: // $13764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5014, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 649; break; } else { __label__ = 11881; break; }
    case 649: // $13765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5015, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 650; break; } else { __label__ = 11881; break; }
    case 650: // $13766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 651; break; } else { __label__ = 11881; break; }
    case 651: // $13767
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 652; break; } else { __label__ = 11881; break; }
    case 652: // $13768
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 653; break; } else { __label__ = 11881; break; }
    case 653: // $13769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 654; break; } else { __label__ = 11881; break; }
    case 654: // $13770
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5012, $5013, $5014, $5015, $5016, $5017, $5018, $5019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 655; break; } else { __label__ = 11881; break; }
    case 655: // $13771
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13763, 85, 1, 0, ((STRING_TABLE.__str272)|0), ((STRING_TABLE.__str273)|0), $5012) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 656; break; } else { __label__ = 11881; break; }
    case 656: // $13772
      var $13773=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13763);
      var $13774=__ZN11simple_listI16input_type_entryE6appendERS0_($13724, $13773);
      var $13775=$4689;
      var $13776=$4479;
      var $13777=$4480;
      var $13778=$4481;
      var $13779=$result_i81;
      var $13780=$4482;
      var $13781=$4483;
      HEAP32[(($4479)>>2)]=408;
      HEAP32[(($4480)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4481)>>2)]=95;
      var $13782=HEAP32[(($4479)>>2)];
      var $13783=HEAP32[(($4480)>>2)];
      var $13784=HEAP32[(($4481)>>2)];
      var $13785=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13782, $13783, $13784) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 657; break; } else { __label__ = 659; break; };
    case 657: // $13786
      HEAP32[(($result_i81)>>2)]=$13785;
      var $13787=HEAP32[(($result_i81)>>2)];
      var $13788=(($13787)|0)==0;
      if ($13788) { __label__ = 658; break; } else { __label__ = 663; break; }
    case 658: // $13789
      var $13790=___cxa_allocate_exception(4);
      var $13791=$13790;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13791);
      (function() { try { __THREW__ = false; return ___cxa_throw($13790, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 662; break; } else { __label__ = 659; break; }
    case 659: // $13792
      var $13793=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13794=$13793.f0;
      HEAP32[(($4482)>>2)]=$13794;
      var $13795=$13793.f1;
      HEAP32[(($4483)>>2)]=$13795;
      var $13796=HEAP32[(($4483)>>2)];
      var $13797=(($13796)|0) < 0;
      if ($13797) { __label__ = 660; break; } else { __label__ = 661; break; }
    case 660: // $13798
      var $13799=HEAP32[(($4482)>>2)];
      ___cxa_call_unexpected($13799);
      throw "Reached an unreachable!"
    case 661: // $13800
      var $13801=HEAP32[(($4482)>>2)];
      var $13802=HEAP32[(($4482)>>2)];
      var $13803=HEAP32[(($4483)>>2)];
      var $13804=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13802, tempValue);
      var $13805=($13804.f1 = $13803, $13804);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 662: // $13806
      throw "Reached an unreachable!"
    case 663: // $_ZnwjPKci_exit82
      var $13807=HEAP32[(($result_i81)>>2)];
      var $13808=$4479;
      var $13809=$4480;
      var $13810=$4481;
      var $13811=$result_i81;
      var $13812=$4482;
      var $13813=$4483;
      var $13814=$13807;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5021, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 664; break; } else { __label__ = 11886; break; }
    case 664: // $13815
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5022, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 665; break; } else { __label__ = 11886; break; }
    case 665: // $13816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5023, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 666; break; } else { __label__ = 11886; break; }
    case 666: // $13817
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 667; break; } else { __label__ = 11886; break; }
    case 667: // $13818
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 668; break; } else { __label__ = 11886; break; }
    case 668: // $13819
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 669; break; } else { __label__ = 11886; break; }
    case 669: // $13820
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 670; break; } else { __label__ = 11886; break; }
    case 670: // $13821
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5020, $5021, $5022, $5023, $5024, $5025, $5026, $5027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 671; break; } else { __label__ = 11886; break; }
    case 671: // $13822
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13814, 86, 1, 0, ((STRING_TABLE.__str274)|0), ((STRING_TABLE.__str275)|0), $5020) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 672; break; } else { __label__ = 11886; break; }
    case 672: // $13823
      var $13824=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13814);
      var $13825=__ZN11simple_listI16input_type_entryE6appendERS0_($13775, $13824);
      var $13826=$4689;
      var $13827=$4474;
      var $13828=$4475;
      var $13829=$4476;
      var $13830=$result_i83;
      var $13831=$4477;
      var $13832=$4478;
      HEAP32[(($4474)>>2)]=408;
      HEAP32[(($4475)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4476)>>2)]=96;
      var $13833=HEAP32[(($4474)>>2)];
      var $13834=HEAP32[(($4475)>>2)];
      var $13835=HEAP32[(($4476)>>2)];
      var $13836=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13833, $13834, $13835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 673; break; } else { __label__ = 675; break; };
    case 673: // $13837
      HEAP32[(($result_i83)>>2)]=$13836;
      var $13838=HEAP32[(($result_i83)>>2)];
      var $13839=(($13838)|0)==0;
      if ($13839) { __label__ = 674; break; } else { __label__ = 679; break; }
    case 674: // $13840
      var $13841=___cxa_allocate_exception(4);
      var $13842=$13841;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13842);
      (function() { try { __THREW__ = false; return ___cxa_throw($13841, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 678; break; } else { __label__ = 675; break; }
    case 675: // $13843
      var $13844=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13845=$13844.f0;
      HEAP32[(($4477)>>2)]=$13845;
      var $13846=$13844.f1;
      HEAP32[(($4478)>>2)]=$13846;
      var $13847=HEAP32[(($4478)>>2)];
      var $13848=(($13847)|0) < 0;
      if ($13848) { __label__ = 676; break; } else { __label__ = 677; break; }
    case 676: // $13849
      var $13850=HEAP32[(($4477)>>2)];
      ___cxa_call_unexpected($13850);
      throw "Reached an unreachable!"
    case 677: // $13851
      var $13852=HEAP32[(($4477)>>2)];
      var $13853=HEAP32[(($4477)>>2)];
      var $13854=HEAP32[(($4478)>>2)];
      var $13855=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13853, tempValue);
      var $13856=($13855.f1 = $13854, $13855);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 678: // $13857
      throw "Reached an unreachable!"
    case 679: // $_ZnwjPKci_exit84
      var $13858=HEAP32[(($result_i83)>>2)];
      var $13859=$4474;
      var $13860=$4475;
      var $13861=$4476;
      var $13862=$result_i83;
      var $13863=$4477;
      var $13864=$4478;
      var $13865=$13858;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5029, 1, 0, 1, 0, 13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 680; break; } else { __label__ = 11891; break; }
    case 680: // $13866
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5030, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 681; break; } else { __label__ = 11891; break; }
    case 681: // $13867
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5031, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 682; break; } else { __label__ = 11891; break; }
    case 682: // $13868
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 683; break; } else { __label__ = 11891; break; }
    case 683: // $13869
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 684; break; } else { __label__ = 11891; break; }
    case 684: // $13870
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 685; break; } else { __label__ = 11891; break; }
    case 685: // $13871
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 686; break; } else { __label__ = 11891; break; }
    case 686: // $13872
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5028, $5029, $5030, $5031, $5032, $5033, $5034, $5035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 687; break; } else { __label__ = 11891; break; }
    case 687: // $13873
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13865, 87, 1, 0, ((STRING_TABLE.__str276)|0), ((STRING_TABLE.__str277)|0), $5028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 688; break; } else { __label__ = 11891; break; }
    case 688: // $13874
      var $13875=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13865);
      var $13876=__ZN11simple_listI16input_type_entryE6appendERS0_($13826, $13875);
      var $13877=$4689;
      var $13878=$4469;
      var $13879=$4470;
      var $13880=$4471;
      var $13881=$result_i85;
      var $13882=$4472;
      var $13883=$4473;
      HEAP32[(($4469)>>2)]=408;
      HEAP32[(($4470)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4471)>>2)]=97;
      var $13884=HEAP32[(($4469)>>2)];
      var $13885=HEAP32[(($4470)>>2)];
      var $13886=HEAP32[(($4471)>>2)];
      var $13887=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13884, $13885, $13886) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 689; break; } else { __label__ = 691; break; };
    case 689: // $13888
      HEAP32[(($result_i85)>>2)]=$13887;
      var $13889=HEAP32[(($result_i85)>>2)];
      var $13890=(($13889)|0)==0;
      if ($13890) { __label__ = 690; break; } else { __label__ = 695; break; }
    case 690: // $13891
      var $13892=___cxa_allocate_exception(4);
      var $13893=$13892;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13893);
      (function() { try { __THREW__ = false; return ___cxa_throw($13892, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 694; break; } else { __label__ = 691; break; }
    case 691: // $13894
      var $13895=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13896=$13895.f0;
      HEAP32[(($4472)>>2)]=$13896;
      var $13897=$13895.f1;
      HEAP32[(($4473)>>2)]=$13897;
      var $13898=HEAP32[(($4473)>>2)];
      var $13899=(($13898)|0) < 0;
      if ($13899) { __label__ = 692; break; } else { __label__ = 693; break; }
    case 692: // $13900
      var $13901=HEAP32[(($4472)>>2)];
      ___cxa_call_unexpected($13901);
      throw "Reached an unreachable!"
    case 693: // $13902
      var $13903=HEAP32[(($4472)>>2)];
      var $13904=HEAP32[(($4472)>>2)];
      var $13905=HEAP32[(($4473)>>2)];
      var $13906=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13904, tempValue);
      var $13907=($13906.f1 = $13905, $13906);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 694: // $13908
      throw "Reached an unreachable!"
    case 695: // $_ZnwjPKci_exit86
      var $13909=HEAP32[(($result_i85)>>2)];
      var $13910=$4469;
      var $13911=$4470;
      var $13912=$4471;
      var $13913=$result_i85;
      var $13914=$4472;
      var $13915=$4473;
      var $13916=$13909;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5037, 1, 0, 1, 0, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 696; break; } else { __label__ = 11896; break; }
    case 696: // $13917
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5038, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 697; break; } else { __label__ = 11896; break; }
    case 697: // $13918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5039, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 698; break; } else { __label__ = 11896; break; }
    case 698: // $13919
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 699; break; } else { __label__ = 11896; break; }
    case 699: // $13920
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 700; break; } else { __label__ = 11896; break; }
    case 700: // $13921
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 701; break; } else { __label__ = 11896; break; }
    case 701: // $13922
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 702; break; } else { __label__ = 11896; break; }
    case 702: // $13923
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5036, $5037, $5038, $5039, $5040, $5041, $5042, $5043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 703; break; } else { __label__ = 11896; break; }
    case 703: // $13924
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13916, 88, 1, 0, ((STRING_TABLE.__str278)|0), ((STRING_TABLE.__str279)|0), $5036) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 704; break; } else { __label__ = 11896; break; }
    case 704: // $13925
      var $13926=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13916);
      var $13927=__ZN11simple_listI16input_type_entryE6appendERS0_($13877, $13926);
      var $13928=$4689;
      var $13929=$4464;
      var $13930=$4465;
      var $13931=$4466;
      var $13932=$result_i87;
      var $13933=$4467;
      var $13934=$4468;
      HEAP32[(($4464)>>2)]=408;
      HEAP32[(($4465)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4466)>>2)]=98;
      var $13935=HEAP32[(($4464)>>2)];
      var $13936=HEAP32[(($4465)>>2)];
      var $13937=HEAP32[(($4466)>>2)];
      var $13938=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13935, $13936, $13937) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 705; break; } else { __label__ = 707; break; };
    case 705: // $13939
      HEAP32[(($result_i87)>>2)]=$13938;
      var $13940=HEAP32[(($result_i87)>>2)];
      var $13941=(($13940)|0)==0;
      if ($13941) { __label__ = 706; break; } else { __label__ = 711; break; }
    case 706: // $13942
      var $13943=___cxa_allocate_exception(4);
      var $13944=$13943;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13944);
      (function() { try { __THREW__ = false; return ___cxa_throw($13943, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 710; break; } else { __label__ = 707; break; }
    case 707: // $13945
      var $13946=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13947=$13946.f0;
      HEAP32[(($4467)>>2)]=$13947;
      var $13948=$13946.f1;
      HEAP32[(($4468)>>2)]=$13948;
      var $13949=HEAP32[(($4468)>>2)];
      var $13950=(($13949)|0) < 0;
      if ($13950) { __label__ = 708; break; } else { __label__ = 709; break; }
    case 708: // $13951
      var $13952=HEAP32[(($4467)>>2)];
      ___cxa_call_unexpected($13952);
      throw "Reached an unreachable!"
    case 709: // $13953
      var $13954=HEAP32[(($4467)>>2)];
      var $13955=HEAP32[(($4467)>>2)];
      var $13956=HEAP32[(($4468)>>2)];
      var $13957=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $13955, tempValue);
      var $13958=($13957.f1 = $13956, $13957);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 710: // $13959
      throw "Reached an unreachable!"
    case 711: // $_ZnwjPKci_exit88
      var $13960=HEAP32[(($result_i87)>>2)];
      var $13961=$4464;
      var $13962=$4465;
      var $13963=$4466;
      var $13964=$result_i87;
      var $13965=$4467;
      var $13966=$4468;
      var $13967=$13960;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5045, 1, 0, 1, 0, 15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 712; break; } else { __label__ = 11901; break; }
    case 712: // $13968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5046, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 713; break; } else { __label__ = 11901; break; }
    case 713: // $13969
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5047, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 714; break; } else { __label__ = 11901; break; }
    case 714: // $13970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 715; break; } else { __label__ = 11901; break; }
    case 715: // $13971
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 716; break; } else { __label__ = 11901; break; }
    case 716: // $13972
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 717; break; } else { __label__ = 11901; break; }
    case 717: // $13973
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 718; break; } else { __label__ = 11901; break; }
    case 718: // $13974
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5044, $5045, $5046, $5047, $5048, $5049, $5050, $5051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 719; break; } else { __label__ = 11901; break; }
    case 719: // $13975
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($13967, 89, 1, 0, ((STRING_TABLE.__str280)|0), ((STRING_TABLE.__str281)|0), $5044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 720; break; } else { __label__ = 11901; break; }
    case 720: // $13976
      var $13977=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $13967);
      var $13978=__ZN11simple_listI16input_type_entryE6appendERS0_($13928, $13977);
      var $13979=$4689;
      var $13980=$4459;
      var $13981=$4460;
      var $13982=$4461;
      var $13983=$result_i89;
      var $13984=$4462;
      var $13985=$4463;
      HEAP32[(($4459)>>2)]=408;
      HEAP32[(($4460)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4461)>>2)]=99;
      var $13986=HEAP32[(($4459)>>2)];
      var $13987=HEAP32[(($4460)>>2)];
      var $13988=HEAP32[(($4461)>>2)];
      var $13989=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($13986, $13987, $13988) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 721; break; } else { __label__ = 723; break; };
    case 721: // $13990
      HEAP32[(($result_i89)>>2)]=$13989;
      var $13991=HEAP32[(($result_i89)>>2)];
      var $13992=(($13991)|0)==0;
      if ($13992) { __label__ = 722; break; } else { __label__ = 727; break; }
    case 722: // $13993
      var $13994=___cxa_allocate_exception(4);
      var $13995=$13994;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($13995);
      (function() { try { __THREW__ = false; return ___cxa_throw($13994, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 726; break; } else { __label__ = 723; break; }
    case 723: // $13996
      var $13997=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13998=$13997.f0;
      HEAP32[(($4462)>>2)]=$13998;
      var $13999=$13997.f1;
      HEAP32[(($4463)>>2)]=$13999;
      var $14000=HEAP32[(($4463)>>2)];
      var $14001=(($14000)|0) < 0;
      if ($14001) { __label__ = 724; break; } else { __label__ = 725; break; }
    case 724: // $14002
      var $14003=HEAP32[(($4462)>>2)];
      ___cxa_call_unexpected($14003);
      throw "Reached an unreachable!"
    case 725: // $14004
      var $14005=HEAP32[(($4462)>>2)];
      var $14006=HEAP32[(($4462)>>2)];
      var $14007=HEAP32[(($4463)>>2)];
      var $14008=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14006, tempValue);
      var $14009=($14008.f1 = $14007, $14008);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 726: // $14010
      throw "Reached an unreachable!"
    case 727: // $_ZnwjPKci_exit90
      var $14011=HEAP32[(($result_i89)>>2)];
      var $14012=$4459;
      var $14013=$4460;
      var $14014=$4461;
      var $14015=$result_i89;
      var $14016=$4462;
      var $14017=$4463;
      var $14018=$14011;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5053, 1, 0, 1, 0, 61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 728; break; } else { __label__ = 11906; break; }
    case 728: // $14019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5054, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 729; break; } else { __label__ = 11906; break; }
    case 729: // $14020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5055, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 730; break; } else { __label__ = 11906; break; }
    case 730: // $14021
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 731; break; } else { __label__ = 11906; break; }
    case 731: // $14022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 732; break; } else { __label__ = 11906; break; }
    case 732: // $14023
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 733; break; } else { __label__ = 11906; break; }
    case 733: // $14024
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 734; break; } else { __label__ = 11906; break; }
    case 734: // $14025
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5052, $5053, $5054, $5055, $5056, $5057, $5058, $5059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 735; break; } else { __label__ = 11906; break; }
    case 735: // $14026
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14018, 90, 1, 0, ((STRING_TABLE.__str282)|0), ((STRING_TABLE.__str283)|0), $5052) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 736; break; } else { __label__ = 11906; break; }
    case 736: // $14027
      var $14028=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14018);
      var $14029=__ZN11simple_listI16input_type_entryE6appendERS0_($13979, $14028);
      var $14030=$4689;
      var $14031=$4454;
      var $14032=$4455;
      var $14033=$4456;
      var $14034=$result_i91;
      var $14035=$4457;
      var $14036=$4458;
      HEAP32[(($4454)>>2)]=408;
      HEAP32[(($4455)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4456)>>2)]=100;
      var $14037=HEAP32[(($4454)>>2)];
      var $14038=HEAP32[(($4455)>>2)];
      var $14039=HEAP32[(($4456)>>2)];
      var $14040=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14037, $14038, $14039) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 737; break; } else { __label__ = 739; break; };
    case 737: // $14041
      HEAP32[(($result_i91)>>2)]=$14040;
      var $14042=HEAP32[(($result_i91)>>2)];
      var $14043=(($14042)|0)==0;
      if ($14043) { __label__ = 738; break; } else { __label__ = 743; break; }
    case 738: // $14044
      var $14045=___cxa_allocate_exception(4);
      var $14046=$14045;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14046);
      (function() { try { __THREW__ = false; return ___cxa_throw($14045, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 742; break; } else { __label__ = 739; break; }
    case 739: // $14047
      var $14048=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14049=$14048.f0;
      HEAP32[(($4457)>>2)]=$14049;
      var $14050=$14048.f1;
      HEAP32[(($4458)>>2)]=$14050;
      var $14051=HEAP32[(($4458)>>2)];
      var $14052=(($14051)|0) < 0;
      if ($14052) { __label__ = 740; break; } else { __label__ = 741; break; }
    case 740: // $14053
      var $14054=HEAP32[(($4457)>>2)];
      ___cxa_call_unexpected($14054);
      throw "Reached an unreachable!"
    case 741: // $14055
      var $14056=HEAP32[(($4457)>>2)];
      var $14057=HEAP32[(($4457)>>2)];
      var $14058=HEAP32[(($4458)>>2)];
      var $14059=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14057, tempValue);
      var $14060=($14059.f1 = $14058, $14059);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 742: // $14061
      throw "Reached an unreachable!"
    case 743: // $_ZnwjPKci_exit92
      var $14062=HEAP32[(($result_i91)>>2)];
      var $14063=$4454;
      var $14064=$4455;
      var $14065=$4456;
      var $14066=$result_i91;
      var $14067=$4457;
      var $14068=$4458;
      var $14069=$14062;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5061, 1, 0, 1, 0, 17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 744; break; } else { __label__ = 11911; break; }
    case 744: // $14070
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5062, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 745; break; } else { __label__ = 11911; break; }
    case 745: // $14071
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5063, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 746; break; } else { __label__ = 11911; break; }
    case 746: // $14072
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 747; break; } else { __label__ = 11911; break; }
    case 747: // $14073
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 748; break; } else { __label__ = 11911; break; }
    case 748: // $14074
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 749; break; } else { __label__ = 11911; break; }
    case 749: // $14075
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 750; break; } else { __label__ = 11911; break; }
    case 750: // $14076
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5060, $5061, $5062, $5063, $5064, $5065, $5066, $5067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 751; break; } else { __label__ = 11911; break; }
    case 751: // $14077
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14069, 91, 1, 0, ((STRING_TABLE.__str284)|0), ((STRING_TABLE.__str285)|0), $5060) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 752; break; } else { __label__ = 11911; break; }
    case 752: // $14078
      var $14079=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14069);
      var $14080=__ZN11simple_listI16input_type_entryE6appendERS0_($14030, $14079);
      var $14081=$4689;
      var $14082=$4449;
      var $14083=$4450;
      var $14084=$4451;
      var $14085=$result_i93;
      var $14086=$4452;
      var $14087=$4453;
      HEAP32[(($4449)>>2)]=408;
      HEAP32[(($4450)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4451)>>2)]=101;
      var $14088=HEAP32[(($4449)>>2)];
      var $14089=HEAP32[(($4450)>>2)];
      var $14090=HEAP32[(($4451)>>2)];
      var $14091=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14088, $14089, $14090) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 753; break; } else { __label__ = 755; break; };
    case 753: // $14092
      HEAP32[(($result_i93)>>2)]=$14091;
      var $14093=HEAP32[(($result_i93)>>2)];
      var $14094=(($14093)|0)==0;
      if ($14094) { __label__ = 754; break; } else { __label__ = 759; break; }
    case 754: // $14095
      var $14096=___cxa_allocate_exception(4);
      var $14097=$14096;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14097);
      (function() { try { __THREW__ = false; return ___cxa_throw($14096, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 758; break; } else { __label__ = 755; break; }
    case 755: // $14098
      var $14099=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14100=$14099.f0;
      HEAP32[(($4452)>>2)]=$14100;
      var $14101=$14099.f1;
      HEAP32[(($4453)>>2)]=$14101;
      var $14102=HEAP32[(($4453)>>2)];
      var $14103=(($14102)|0) < 0;
      if ($14103) { __label__ = 756; break; } else { __label__ = 757; break; }
    case 756: // $14104
      var $14105=HEAP32[(($4452)>>2)];
      ___cxa_call_unexpected($14105);
      throw "Reached an unreachable!"
    case 757: // $14106
      var $14107=HEAP32[(($4452)>>2)];
      var $14108=HEAP32[(($4452)>>2)];
      var $14109=HEAP32[(($4453)>>2)];
      var $14110=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14108, tempValue);
      var $14111=($14110.f1 = $14109, $14110);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 758: // $14112
      throw "Reached an unreachable!"
    case 759: // $_ZnwjPKci_exit94
      var $14113=HEAP32[(($result_i93)>>2)];
      var $14114=$4449;
      var $14115=$4450;
      var $14116=$4451;
      var $14117=$result_i93;
      var $14118=$4452;
      var $14119=$4453;
      var $14120=$14113;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5069, 1, 0, 1, 0, 99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 760; break; } else { __label__ = 11916; break; }
    case 760: // $14121
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5070, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 761; break; } else { __label__ = 11916; break; }
    case 761: // $14122
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5071, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 762; break; } else { __label__ = 11916; break; }
    case 762: // $14123
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 763; break; } else { __label__ = 11916; break; }
    case 763: // $14124
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 764; break; } else { __label__ = 11916; break; }
    case 764: // $14125
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 765; break; } else { __label__ = 11916; break; }
    case 765: // $14126
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 766; break; } else { __label__ = 11916; break; }
    case 766: // $14127
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5068, $5069, $5070, $5071, $5072, $5073, $5074, $5075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 767; break; } else { __label__ = 11916; break; }
    case 767: // $14128
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14120, 92, 1, 0, ((STRING_TABLE.__str286)|0), ((STRING_TABLE.__str287)|0), $5068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 768; break; } else { __label__ = 11916; break; }
    case 768: // $14129
      var $14130=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14120);
      var $14131=__ZN11simple_listI16input_type_entryE6appendERS0_($14081, $14130);
      var $14132=$4689;
      var $14133=$4444;
      var $14134=$4445;
      var $14135=$4446;
      var $14136=$result_i95;
      var $14137=$4447;
      var $14138=$4448;
      HEAP32[(($4444)>>2)]=408;
      HEAP32[(($4445)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4446)>>2)]=102;
      var $14139=HEAP32[(($4444)>>2)];
      var $14140=HEAP32[(($4445)>>2)];
      var $14141=HEAP32[(($4446)>>2)];
      var $14142=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14139, $14140, $14141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 769; break; } else { __label__ = 771; break; };
    case 769: // $14143
      HEAP32[(($result_i95)>>2)]=$14142;
      var $14144=HEAP32[(($result_i95)>>2)];
      var $14145=(($14144)|0)==0;
      if ($14145) { __label__ = 770; break; } else { __label__ = 775; break; }
    case 770: // $14146
      var $14147=___cxa_allocate_exception(4);
      var $14148=$14147;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14148);
      (function() { try { __THREW__ = false; return ___cxa_throw($14147, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 774; break; } else { __label__ = 771; break; }
    case 771: // $14149
      var $14150=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14151=$14150.f0;
      HEAP32[(($4447)>>2)]=$14151;
      var $14152=$14150.f1;
      HEAP32[(($4448)>>2)]=$14152;
      var $14153=HEAP32[(($4448)>>2)];
      var $14154=(($14153)|0) < 0;
      if ($14154) { __label__ = 772; break; } else { __label__ = 773; break; }
    case 772: // $14155
      var $14156=HEAP32[(($4447)>>2)];
      ___cxa_call_unexpected($14156);
      throw "Reached an unreachable!"
    case 773: // $14157
      var $14158=HEAP32[(($4447)>>2)];
      var $14159=HEAP32[(($4447)>>2)];
      var $14160=HEAP32[(($4448)>>2)];
      var $14161=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14159, tempValue);
      var $14162=($14161.f1 = $14160, $14161);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 774: // $14163
      throw "Reached an unreachable!"
    case 775: // $_ZnwjPKci_exit96
      var $14164=HEAP32[(($result_i95)>>2)];
      var $14165=$4444;
      var $14166=$4445;
      var $14167=$4446;
      var $14168=$result_i95;
      var $14169=$4447;
      var $14170=$4448;
      var $14171=$14164;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5077, 1, 0, 1, 0, 101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 776; break; } else { __label__ = 11921; break; }
    case 776: // $14172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5078, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 777; break; } else { __label__ = 11921; break; }
    case 777: // $14173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5079, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 778; break; } else { __label__ = 11921; break; }
    case 778: // $14174
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 779; break; } else { __label__ = 11921; break; }
    case 779: // $14175
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 780; break; } else { __label__ = 11921; break; }
    case 780: // $14176
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 781; break; } else { __label__ = 11921; break; }
    case 781: // $14177
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 782; break; } else { __label__ = 11921; break; }
    case 782: // $14178
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5076, $5077, $5078, $5079, $5080, $5081, $5082, $5083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 783; break; } else { __label__ = 11921; break; }
    case 783: // $14179
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14171, 93, 1, 0, ((STRING_TABLE.__str288)|0), ((STRING_TABLE.__str289)|0), $5076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 784; break; } else { __label__ = 11921; break; }
    case 784: // $14180
      var $14181=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14171);
      var $14182=__ZN11simple_listI16input_type_entryE6appendERS0_($14132, $14181);
      var $14183=$4689;
      var $14184=$4439;
      var $14185=$4440;
      var $14186=$4441;
      var $14187=$result_i97;
      var $14188=$4442;
      var $14189=$4443;
      HEAP32[(($4439)>>2)]=408;
      HEAP32[(($4440)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4441)>>2)]=103;
      var $14190=HEAP32[(($4439)>>2)];
      var $14191=HEAP32[(($4440)>>2)];
      var $14192=HEAP32[(($4441)>>2)];
      var $14193=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14190, $14191, $14192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 785; break; } else { __label__ = 787; break; };
    case 785: // $14194
      HEAP32[(($result_i97)>>2)]=$14193;
      var $14195=HEAP32[(($result_i97)>>2)];
      var $14196=(($14195)|0)==0;
      if ($14196) { __label__ = 786; break; } else { __label__ = 791; break; }
    case 786: // $14197
      var $14198=___cxa_allocate_exception(4);
      var $14199=$14198;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14199);
      (function() { try { __THREW__ = false; return ___cxa_throw($14198, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 790; break; } else { __label__ = 787; break; }
    case 787: // $14200
      var $14201=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14202=$14201.f0;
      HEAP32[(($4442)>>2)]=$14202;
      var $14203=$14201.f1;
      HEAP32[(($4443)>>2)]=$14203;
      var $14204=HEAP32[(($4443)>>2)];
      var $14205=(($14204)|0) < 0;
      if ($14205) { __label__ = 788; break; } else { __label__ = 789; break; }
    case 788: // $14206
      var $14207=HEAP32[(($4442)>>2)];
      ___cxa_call_unexpected($14207);
      throw "Reached an unreachable!"
    case 789: // $14208
      var $14209=HEAP32[(($4442)>>2)];
      var $14210=HEAP32[(($4442)>>2)];
      var $14211=HEAP32[(($4443)>>2)];
      var $14212=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14210, tempValue);
      var $14213=($14212.f1 = $14211, $14212);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 790: // $14214
      throw "Reached an unreachable!"
    case 791: // $_ZnwjPKci_exit98
      var $14215=HEAP32[(($result_i97)>>2)];
      var $14216=$4439;
      var $14217=$4440;
      var $14218=$4441;
      var $14219=$result_i97;
      var $14220=$4442;
      var $14221=$4443;
      var $14222=$14215;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5085, 1, 0, 1, 0, 68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 792; break; } else { __label__ = 11926; break; }
    case 792: // $14223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5086, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 793; break; } else { __label__ = 11926; break; }
    case 793: // $14224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5087, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 794; break; } else { __label__ = 11926; break; }
    case 794: // $14225
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 795; break; } else { __label__ = 11926; break; }
    case 795: // $14226
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 796; break; } else { __label__ = 11926; break; }
    case 796: // $14227
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 797; break; } else { __label__ = 11926; break; }
    case 797: // $14228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 798; break; } else { __label__ = 11926; break; }
    case 798: // $14229
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5084, $5085, $5086, $5087, $5088, $5089, $5090, $5091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 799; break; } else { __label__ = 11926; break; }
    case 799: // $14230
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14222, 94, 1, 0, ((STRING_TABLE.__str290)|0), ((STRING_TABLE.__str291)|0), $5084) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 800; break; } else { __label__ = 11926; break; }
    case 800: // $14231
      var $14232=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14222);
      var $14233=__ZN11simple_listI16input_type_entryE6appendERS0_($14183, $14232);
      var $14234=$4689;
      var $14235=$4434;
      var $14236=$4435;
      var $14237=$4436;
      var $14238=$result_i99;
      var $14239=$4437;
      var $14240=$4438;
      HEAP32[(($4434)>>2)]=408;
      HEAP32[(($4435)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4436)>>2)]=104;
      var $14241=HEAP32[(($4434)>>2)];
      var $14242=HEAP32[(($4435)>>2)];
      var $14243=HEAP32[(($4436)>>2)];
      var $14244=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14241, $14242, $14243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 801; break; } else { __label__ = 803; break; };
    case 801: // $14245
      HEAP32[(($result_i99)>>2)]=$14244;
      var $14246=HEAP32[(($result_i99)>>2)];
      var $14247=(($14246)|0)==0;
      if ($14247) { __label__ = 802; break; } else { __label__ = 807; break; }
    case 802: // $14248
      var $14249=___cxa_allocate_exception(4);
      var $14250=$14249;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14250);
      (function() { try { __THREW__ = false; return ___cxa_throw($14249, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 806; break; } else { __label__ = 803; break; }
    case 803: // $14251
      var $14252=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14253=$14252.f0;
      HEAP32[(($4437)>>2)]=$14253;
      var $14254=$14252.f1;
      HEAP32[(($4438)>>2)]=$14254;
      var $14255=HEAP32[(($4438)>>2)];
      var $14256=(($14255)|0) < 0;
      if ($14256) { __label__ = 804; break; } else { __label__ = 805; break; }
    case 804: // $14257
      var $14258=HEAP32[(($4437)>>2)];
      ___cxa_call_unexpected($14258);
      throw "Reached an unreachable!"
    case 805: // $14259
      var $14260=HEAP32[(($4437)>>2)];
      var $14261=HEAP32[(($4437)>>2)];
      var $14262=HEAP32[(($4438)>>2)];
      var $14263=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14261, tempValue);
      var $14264=($14263.f1 = $14262, $14263);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 806: // $14265
      throw "Reached an unreachable!"
    case 807: // $_ZnwjPKci_exit100
      var $14266=HEAP32[(($result_i99)>>2)];
      var $14267=$4434;
      var $14268=$4435;
      var $14269=$4436;
      var $14270=$result_i99;
      var $14271=$4437;
      var $14272=$4438;
      var $14273=$14266;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5093, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 808; break; } else { __label__ = 11931; break; }
    case 808: // $14274
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5094, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 809; break; } else { __label__ = 11931; break; }
    case 809: // $14275
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5095, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 810; break; } else { __label__ = 11931; break; }
    case 810: // $14276
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 811; break; } else { __label__ = 11931; break; }
    case 811: // $14277
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 812; break; } else { __label__ = 11931; break; }
    case 812: // $14278
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 813; break; } else { __label__ = 11931; break; }
    case 813: // $14279
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 814; break; } else { __label__ = 11931; break; }
    case 814: // $14280
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5092, $5093, $5094, $5095, $5096, $5097, $5098, $5099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 815; break; } else { __label__ = 11931; break; }
    case 815: // $14281
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14273, 95, 1, 0, ((STRING_TABLE.__str292)|0), ((STRING_TABLE.__str293)|0), $5092) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 816; break; } else { __label__ = 11931; break; }
    case 816: // $14282
      var $14283=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14273);
      var $14284=__ZN11simple_listI16input_type_entryE6appendERS0_($14234, $14283);
      var $14285=$4689;
      var $14286=$4429;
      var $14287=$4430;
      var $14288=$4431;
      var $14289=$result_i101;
      var $14290=$4432;
      var $14291=$4433;
      HEAP32[(($4429)>>2)]=408;
      HEAP32[(($4430)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4431)>>2)]=105;
      var $14292=HEAP32[(($4429)>>2)];
      var $14293=HEAP32[(($4430)>>2)];
      var $14294=HEAP32[(($4431)>>2)];
      var $14295=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14292, $14293, $14294) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 817; break; } else { __label__ = 819; break; };
    case 817: // $14296
      HEAP32[(($result_i101)>>2)]=$14295;
      var $14297=HEAP32[(($result_i101)>>2)];
      var $14298=(($14297)|0)==0;
      if ($14298) { __label__ = 818; break; } else { __label__ = 823; break; }
    case 818: // $14299
      var $14300=___cxa_allocate_exception(4);
      var $14301=$14300;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14301);
      (function() { try { __THREW__ = false; return ___cxa_throw($14300, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 822; break; } else { __label__ = 819; break; }
    case 819: // $14302
      var $14303=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14304=$14303.f0;
      HEAP32[(($4432)>>2)]=$14304;
      var $14305=$14303.f1;
      HEAP32[(($4433)>>2)]=$14305;
      var $14306=HEAP32[(($4433)>>2)];
      var $14307=(($14306)|0) < 0;
      if ($14307) { __label__ = 820; break; } else { __label__ = 821; break; }
    case 820: // $14308
      var $14309=HEAP32[(($4432)>>2)];
      ___cxa_call_unexpected($14309);
      throw "Reached an unreachable!"
    case 821: // $14310
      var $14311=HEAP32[(($4432)>>2)];
      var $14312=HEAP32[(($4432)>>2)];
      var $14313=HEAP32[(($4433)>>2)];
      var $14314=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14312, tempValue);
      var $14315=($14314.f1 = $14313, $14314);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 822: // $14316
      throw "Reached an unreachable!"
    case 823: // $_ZnwjPKci_exit102
      var $14317=HEAP32[(($result_i101)>>2)];
      var $14318=$4429;
      var $14319=$4430;
      var $14320=$4431;
      var $14321=$result_i101;
      var $14322=$4432;
      var $14323=$4433;
      var $14324=$14317;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5101, 1, 0, 1, 0, 26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 824; break; } else { __label__ = 11936; break; }
    case 824: // $14325
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5102, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 825; break; } else { __label__ = 11936; break; }
    case 825: // $14326
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5103, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 826; break; } else { __label__ = 11936; break; }
    case 826: // $14327
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5104, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 827; break; } else { __label__ = 11936; break; }
    case 827: // $14328
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5105, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 828; break; } else { __label__ = 11936; break; }
    case 828: // $14329
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 829; break; } else { __label__ = 11936; break; }
    case 829: // $14330
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 830; break; } else { __label__ = 11936; break; }
    case 830: // $14331
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5100, $5101, $5102, $5103, $5104, $5105, $5106, $5107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 831; break; } else { __label__ = 11936; break; }
    case 831: // $14332
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14324, 96, 1, 0, ((STRING_TABLE.__str294)|0), ((STRING_TABLE.__str295)|0), $5100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 832; break; } else { __label__ = 11936; break; }
    case 832: // $14333
      var $14334=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14324);
      var $14335=__ZN11simple_listI16input_type_entryE6appendERS0_($14285, $14334);
      var $14336=$4689;
      var $14337=$4424;
      var $14338=$4425;
      var $14339=$4426;
      var $14340=$result_i103;
      var $14341=$4427;
      var $14342=$4428;
      HEAP32[(($4424)>>2)]=408;
      HEAP32[(($4425)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4426)>>2)]=106;
      var $14343=HEAP32[(($4424)>>2)];
      var $14344=HEAP32[(($4425)>>2)];
      var $14345=HEAP32[(($4426)>>2)];
      var $14346=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14343, $14344, $14345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 833; break; } else { __label__ = 835; break; };
    case 833: // $14347
      HEAP32[(($result_i103)>>2)]=$14346;
      var $14348=HEAP32[(($result_i103)>>2)];
      var $14349=(($14348)|0)==0;
      if ($14349) { __label__ = 834; break; } else { __label__ = 839; break; }
    case 834: // $14350
      var $14351=___cxa_allocate_exception(4);
      var $14352=$14351;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14352);
      (function() { try { __THREW__ = false; return ___cxa_throw($14351, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 838; break; } else { __label__ = 835; break; }
    case 835: // $14353
      var $14354=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14355=$14354.f0;
      HEAP32[(($4427)>>2)]=$14355;
      var $14356=$14354.f1;
      HEAP32[(($4428)>>2)]=$14356;
      var $14357=HEAP32[(($4428)>>2)];
      var $14358=(($14357)|0) < 0;
      if ($14358) { __label__ = 836; break; } else { __label__ = 837; break; }
    case 836: // $14359
      var $14360=HEAP32[(($4427)>>2)];
      ___cxa_call_unexpected($14360);
      throw "Reached an unreachable!"
    case 837: // $14361
      var $14362=HEAP32[(($4427)>>2)];
      var $14363=HEAP32[(($4427)>>2)];
      var $14364=HEAP32[(($4428)>>2)];
      var $14365=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14363, tempValue);
      var $14366=($14365.f1 = $14364, $14365);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 838: // $14367
      throw "Reached an unreachable!"
    case 839: // $_ZnwjPKci_exit104
      var $14368=HEAP32[(($result_i103)>>2)];
      var $14369=$4424;
      var $14370=$4425;
      var $14371=$4426;
      var $14372=$result_i103;
      var $14373=$4427;
      var $14374=$4428;
      var $14375=$14368;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5109, 1, 0, 1, 0, 30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 840; break; } else { __label__ = 11941; break; }
    case 840: // $14376
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5110, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 841; break; } else { __label__ = 11941; break; }
    case 841: // $14377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5111, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 842; break; } else { __label__ = 11941; break; }
    case 842: // $14378
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5112, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 843; break; } else { __label__ = 11941; break; }
    case 843: // $14379
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5113, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 844; break; } else { __label__ = 11941; break; }
    case 844: // $14380
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 845; break; } else { __label__ = 11941; break; }
    case 845: // $14381
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 846; break; } else { __label__ = 11941; break; }
    case 846: // $14382
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5108, $5109, $5110, $5111, $5112, $5113, $5114, $5115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 847; break; } else { __label__ = 11941; break; }
    case 847: // $14383
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14375, 97, 1, 0, ((STRING_TABLE.__str296)|0), ((STRING_TABLE.__str297)|0), $5108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 848; break; } else { __label__ = 11941; break; }
    case 848: // $14384
      var $14385=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14375);
      var $14386=__ZN11simple_listI16input_type_entryE6appendERS0_($14336, $14385);
      var $14387=$4689;
      var $14388=$4419;
      var $14389=$4420;
      var $14390=$4421;
      var $14391=$result_i105;
      var $14392=$4422;
      var $14393=$4423;
      HEAP32[(($4419)>>2)]=408;
      HEAP32[(($4420)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4421)>>2)]=107;
      var $14394=HEAP32[(($4419)>>2)];
      var $14395=HEAP32[(($4420)>>2)];
      var $14396=HEAP32[(($4421)>>2)];
      var $14397=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14394, $14395, $14396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 849; break; } else { __label__ = 851; break; };
    case 849: // $14398
      HEAP32[(($result_i105)>>2)]=$14397;
      var $14399=HEAP32[(($result_i105)>>2)];
      var $14400=(($14399)|0)==0;
      if ($14400) { __label__ = 850; break; } else { __label__ = 855; break; }
    case 850: // $14401
      var $14402=___cxa_allocate_exception(4);
      var $14403=$14402;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14403);
      (function() { try { __THREW__ = false; return ___cxa_throw($14402, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 854; break; } else { __label__ = 851; break; }
    case 851: // $14404
      var $14405=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14406=$14405.f0;
      HEAP32[(($4422)>>2)]=$14406;
      var $14407=$14405.f1;
      HEAP32[(($4423)>>2)]=$14407;
      var $14408=HEAP32[(($4423)>>2)];
      var $14409=(($14408)|0) < 0;
      if ($14409) { __label__ = 852; break; } else { __label__ = 853; break; }
    case 852: // $14410
      var $14411=HEAP32[(($4422)>>2)];
      ___cxa_call_unexpected($14411);
      throw "Reached an unreachable!"
    case 853: // $14412
      var $14413=HEAP32[(($4422)>>2)];
      var $14414=HEAP32[(($4422)>>2)];
      var $14415=HEAP32[(($4423)>>2)];
      var $14416=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14414, tempValue);
      var $14417=($14416.f1 = $14415, $14416);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 854: // $14418
      throw "Reached an unreachable!"
    case 855: // $_ZnwjPKci_exit106
      var $14419=HEAP32[(($result_i105)>>2)];
      var $14420=$4419;
      var $14421=$4420;
      var $14422=$4421;
      var $14423=$result_i105;
      var $14424=$4422;
      var $14425=$4423;
      var $14426=$14419;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5117, 1, 0, 1, 0, 102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 856; break; } else { __label__ = 11946; break; }
    case 856: // $14427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5118, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 857; break; } else { __label__ = 11946; break; }
    case 857: // $14428
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5119, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 858; break; } else { __label__ = 11946; break; }
    case 858: // $14429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 859; break; } else { __label__ = 11946; break; }
    case 859: // $14430
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 860; break; } else { __label__ = 11946; break; }
    case 860: // $14431
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 861; break; } else { __label__ = 11946; break; }
    case 861: // $14432
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 862; break; } else { __label__ = 11946; break; }
    case 862: // $14433
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5116, $5117, $5118, $5119, $5120, $5121, $5122, $5123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 863; break; } else { __label__ = 11946; break; }
    case 863: // $14434
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14426, 98, 1, 0, ((STRING_TABLE.__str298)|0), ((STRING_TABLE.__str299)|0), $5116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 864; break; } else { __label__ = 11946; break; }
    case 864: // $14435
      var $14436=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14426);
      var $14437=__ZN11simple_listI16input_type_entryE6appendERS0_($14387, $14436);
      var $14438=$4689;
      var $14439=$4414;
      var $14440=$4415;
      var $14441=$4416;
      var $14442=$result_i107;
      var $14443=$4417;
      var $14444=$4418;
      HEAP32[(($4414)>>2)]=408;
      HEAP32[(($4415)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4416)>>2)]=108;
      var $14445=HEAP32[(($4414)>>2)];
      var $14446=HEAP32[(($4415)>>2)];
      var $14447=HEAP32[(($4416)>>2)];
      var $14448=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14445, $14446, $14447) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 865; break; } else { __label__ = 867; break; };
    case 865: // $14449
      HEAP32[(($result_i107)>>2)]=$14448;
      var $14450=HEAP32[(($result_i107)>>2)];
      var $14451=(($14450)|0)==0;
      if ($14451) { __label__ = 866; break; } else { __label__ = 871; break; }
    case 866: // $14452
      var $14453=___cxa_allocate_exception(4);
      var $14454=$14453;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14454);
      (function() { try { __THREW__ = false; return ___cxa_throw($14453, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 870; break; } else { __label__ = 867; break; }
    case 867: // $14455
      var $14456=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14457=$14456.f0;
      HEAP32[(($4417)>>2)]=$14457;
      var $14458=$14456.f1;
      HEAP32[(($4418)>>2)]=$14458;
      var $14459=HEAP32[(($4418)>>2)];
      var $14460=(($14459)|0) < 0;
      if ($14460) { __label__ = 868; break; } else { __label__ = 869; break; }
    case 868: // $14461
      var $14462=HEAP32[(($4417)>>2)];
      ___cxa_call_unexpected($14462);
      throw "Reached an unreachable!"
    case 869: // $14463
      var $14464=HEAP32[(($4417)>>2)];
      var $14465=HEAP32[(($4417)>>2)];
      var $14466=HEAP32[(($4418)>>2)];
      var $14467=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14465, tempValue);
      var $14468=($14467.f1 = $14466, $14467);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 870: // $14469
      throw "Reached an unreachable!"
    case 871: // $_ZnwjPKci_exit108
      var $14470=HEAP32[(($result_i107)>>2)];
      var $14471=$4414;
      var $14472=$4415;
      var $14473=$4416;
      var $14474=$result_i107;
      var $14475=$4417;
      var $14476=$4418;
      var $14477=$14470;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5125, 1, 0, 1, 0, 100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 872; break; } else { __label__ = 11951; break; }
    case 872: // $14478
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5126, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 873; break; } else { __label__ = 11951; break; }
    case 873: // $14479
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5127, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 874; break; } else { __label__ = 11951; break; }
    case 874: // $14480
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 875; break; } else { __label__ = 11951; break; }
    case 875: // $14481
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 876; break; } else { __label__ = 11951; break; }
    case 876: // $14482
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 877; break; } else { __label__ = 11951; break; }
    case 877: // $14483
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 878; break; } else { __label__ = 11951; break; }
    case 878: // $14484
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5124, $5125, $5126, $5127, $5128, $5129, $5130, $5131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 879; break; } else { __label__ = 11951; break; }
    case 879: // $14485
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14477, 99, 1, 0, ((STRING_TABLE.__str300)|0), ((STRING_TABLE.__str301)|0), $5124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 880; break; } else { __label__ = 11951; break; }
    case 880: // $14486
      var $14487=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14477);
      var $14488=__ZN11simple_listI16input_type_entryE6appendERS0_($14438, $14487);
      var $14489=$4689;
      var $14490=$4409;
      var $14491=$4410;
      var $14492=$4411;
      var $14493=$result_i109;
      var $14494=$4412;
      var $14495=$4413;
      HEAP32[(($4409)>>2)]=408;
      HEAP32[(($4410)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4411)>>2)]=109;
      var $14496=HEAP32[(($4409)>>2)];
      var $14497=HEAP32[(($4410)>>2)];
      var $14498=HEAP32[(($4411)>>2)];
      var $14499=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14496, $14497, $14498) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 881; break; } else { __label__ = 883; break; };
    case 881: // $14500
      HEAP32[(($result_i109)>>2)]=$14499;
      var $14501=HEAP32[(($result_i109)>>2)];
      var $14502=(($14501)|0)==0;
      if ($14502) { __label__ = 882; break; } else { __label__ = 887; break; }
    case 882: // $14503
      var $14504=___cxa_allocate_exception(4);
      var $14505=$14504;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14505);
      (function() { try { __THREW__ = false; return ___cxa_throw($14504, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 886; break; } else { __label__ = 883; break; }
    case 883: // $14506
      var $14507=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14508=$14507.f0;
      HEAP32[(($4412)>>2)]=$14508;
      var $14509=$14507.f1;
      HEAP32[(($4413)>>2)]=$14509;
      var $14510=HEAP32[(($4413)>>2)];
      var $14511=(($14510)|0) < 0;
      if ($14511) { __label__ = 884; break; } else { __label__ = 885; break; }
    case 884: // $14512
      var $14513=HEAP32[(($4412)>>2)];
      ___cxa_call_unexpected($14513);
      throw "Reached an unreachable!"
    case 885: // $14514
      var $14515=HEAP32[(($4412)>>2)];
      var $14516=HEAP32[(($4412)>>2)];
      var $14517=HEAP32[(($4413)>>2)];
      var $14518=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14516, tempValue);
      var $14519=($14518.f1 = $14517, $14518);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 886: // $14520
      throw "Reached an unreachable!"
    case 887: // $_ZnwjPKci_exit110
      var $14521=HEAP32[(($result_i109)>>2)];
      var $14522=$4409;
      var $14523=$4410;
      var $14524=$4411;
      var $14525=$result_i109;
      var $14526=$4412;
      var $14527=$4413;
      var $14528=$14521;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5133, 1, 0, 1, 0, 98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 888; break; } else { __label__ = 11956; break; }
    case 888: // $14529
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5134, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 889; break; } else { __label__ = 11956; break; }
    case 889: // $14530
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5135, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 890; break; } else { __label__ = 11956; break; }
    case 890: // $14531
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 891; break; } else { __label__ = 11956; break; }
    case 891: // $14532
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 892; break; } else { __label__ = 11956; break; }
    case 892: // $14533
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 893; break; } else { __label__ = 11956; break; }
    case 893: // $14534
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 894; break; } else { __label__ = 11956; break; }
    case 894: // $14535
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5132, $5133, $5134, $5135, $5136, $5137, $5138, $5139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 895; break; } else { __label__ = 11956; break; }
    case 895: // $14536
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14528, 100, 1, 0, ((STRING_TABLE.__str302)|0), ((STRING_TABLE.__str303)|0), $5132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 896; break; } else { __label__ = 11956; break; }
    case 896: // $14537
      var $14538=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14528);
      var $14539=__ZN11simple_listI16input_type_entryE6appendERS0_($14489, $14538);
      var $14540=$4689;
      var $14541=$4404;
      var $14542=$4405;
      var $14543=$4406;
      var $14544=$result_i111;
      var $14545=$4407;
      var $14546=$4408;
      HEAP32[(($4404)>>2)]=408;
      HEAP32[(($4405)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4406)>>2)]=110;
      var $14547=HEAP32[(($4404)>>2)];
      var $14548=HEAP32[(($4405)>>2)];
      var $14549=HEAP32[(($4406)>>2)];
      var $14550=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14547, $14548, $14549) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 897; break; } else { __label__ = 899; break; };
    case 897: // $14551
      HEAP32[(($result_i111)>>2)]=$14550;
      var $14552=HEAP32[(($result_i111)>>2)];
      var $14553=(($14552)|0)==0;
      if ($14553) { __label__ = 898; break; } else { __label__ = 903; break; }
    case 898: // $14554
      var $14555=___cxa_allocate_exception(4);
      var $14556=$14555;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14556);
      (function() { try { __THREW__ = false; return ___cxa_throw($14555, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 902; break; } else { __label__ = 899; break; }
    case 899: // $14557
      var $14558=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14559=$14558.f0;
      HEAP32[(($4407)>>2)]=$14559;
      var $14560=$14558.f1;
      HEAP32[(($4408)>>2)]=$14560;
      var $14561=HEAP32[(($4408)>>2)];
      var $14562=(($14561)|0) < 0;
      if ($14562) { __label__ = 900; break; } else { __label__ = 901; break; }
    case 900: // $14563
      var $14564=HEAP32[(($4407)>>2)];
      ___cxa_call_unexpected($14564);
      throw "Reached an unreachable!"
    case 901: // $14565
      var $14566=HEAP32[(($4407)>>2)];
      var $14567=HEAP32[(($4407)>>2)];
      var $14568=HEAP32[(($4408)>>2)];
      var $14569=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14567, tempValue);
      var $14570=($14569.f1 = $14568, $14569);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 902: // $14571
      throw "Reached an unreachable!"
    case 903: // $_ZnwjPKci_exit112
      var $14572=HEAP32[(($result_i111)>>2)];
      var $14573=$4404;
      var $14574=$4405;
      var $14575=$4406;
      var $14576=$result_i111;
      var $14577=$4407;
      var $14578=$4408;
      var $14579=$14572;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5141, 1, 0, 1, 0, 25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 904; break; } else { __label__ = 11961; break; }
    case 904: // $14580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5142, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 905; break; } else { __label__ = 11961; break; }
    case 905: // $14581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5143, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 906; break; } else { __label__ = 11961; break; }
    case 906: // $14582
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 907; break; } else { __label__ = 11961; break; }
    case 907: // $14583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 908; break; } else { __label__ = 11961; break; }
    case 908: // $14584
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 909; break; } else { __label__ = 11961; break; }
    case 909: // $14585
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 910; break; } else { __label__ = 11961; break; }
    case 910: // $14586
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5140, $5141, $5142, $5143, $5144, $5145, $5146, $5147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 911; break; } else { __label__ = 11961; break; }
    case 911: // $14587
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14579, 101, 1, 0, ((STRING_TABLE.__str304)|0), ((STRING_TABLE.__str305)|0), $5140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 912; break; } else { __label__ = 11961; break; }
    case 912: // $14588
      var $14589=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14579);
      var $14590=__ZN11simple_listI16input_type_entryE6appendERS0_($14540, $14589);
      var $14591=$4689;
      var $14592=$4399;
      var $14593=$4400;
      var $14594=$4401;
      var $14595=$result_i113;
      var $14596=$4402;
      var $14597=$4403;
      HEAP32[(($4399)>>2)]=408;
      HEAP32[(($4400)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4401)>>2)]=111;
      var $14598=HEAP32[(($4399)>>2)];
      var $14599=HEAP32[(($4400)>>2)];
      var $14600=HEAP32[(($4401)>>2)];
      var $14601=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14598, $14599, $14600) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 913; break; } else { __label__ = 915; break; };
    case 913: // $14602
      HEAP32[(($result_i113)>>2)]=$14601;
      var $14603=HEAP32[(($result_i113)>>2)];
      var $14604=(($14603)|0)==0;
      if ($14604) { __label__ = 914; break; } else { __label__ = 919; break; }
    case 914: // $14605
      var $14606=___cxa_allocate_exception(4);
      var $14607=$14606;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14607);
      (function() { try { __THREW__ = false; return ___cxa_throw($14606, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 918; break; } else { __label__ = 915; break; }
    case 915: // $14608
      var $14609=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14610=$14609.f0;
      HEAP32[(($4402)>>2)]=$14610;
      var $14611=$14609.f1;
      HEAP32[(($4403)>>2)]=$14611;
      var $14612=HEAP32[(($4403)>>2)];
      var $14613=(($14612)|0) < 0;
      if ($14613) { __label__ = 916; break; } else { __label__ = 917; break; }
    case 916: // $14614
      var $14615=HEAP32[(($4402)>>2)];
      ___cxa_call_unexpected($14615);
      throw "Reached an unreachable!"
    case 917: // $14616
      var $14617=HEAP32[(($4402)>>2)];
      var $14618=HEAP32[(($4402)>>2)];
      var $14619=HEAP32[(($4403)>>2)];
      var $14620=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14618, tempValue);
      var $14621=($14620.f1 = $14619, $14620);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 918: // $14622
      throw "Reached an unreachable!"
    case 919: // $_ZnwjPKci_exit114
      var $14623=HEAP32[(($result_i113)>>2)];
      var $14624=$4399;
      var $14625=$4400;
      var $14626=$4401;
      var $14627=$result_i113;
      var $14628=$4402;
      var $14629=$4403;
      var $14630=$14623;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5149, 1, 0, 1, 0, 60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 920; break; } else { __label__ = 11966; break; }
    case 920: // $14631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 921; break; } else { __label__ = 11966; break; }
    case 921: // $14632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 922; break; } else { __label__ = 11966; break; }
    case 922: // $14633
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 923; break; } else { __label__ = 11966; break; }
    case 923: // $14634
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 924; break; } else { __label__ = 11966; break; }
    case 924: // $14635
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 925; break; } else { __label__ = 11966; break; }
    case 925: // $14636
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 926; break; } else { __label__ = 11966; break; }
    case 926: // $14637
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5148, $5149, $5150, $5151, $5152, $5153, $5154, $5155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 927; break; } else { __label__ = 11966; break; }
    case 927: // $14638
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14630, 102, 1, 0, ((STRING_TABLE.__str306)|0), ((STRING_TABLE.__str307405)|0), $5148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 928; break; } else { __label__ = 11966; break; }
    case 928: // $14639
      var $14640=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14630);
      var $14641=__ZN11simple_listI16input_type_entryE6appendERS0_($14591, $14640);
      var $14642=$4689;
      var $14643=$4394;
      var $14644=$4395;
      var $14645=$4396;
      var $14646=$result_i115;
      var $14647=$4397;
      var $14648=$4398;
      HEAP32[(($4394)>>2)]=408;
      HEAP32[(($4395)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4396)>>2)]=112;
      var $14649=HEAP32[(($4394)>>2)];
      var $14650=HEAP32[(($4395)>>2)];
      var $14651=HEAP32[(($4396)>>2)];
      var $14652=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14649, $14650, $14651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 929; break; } else { __label__ = 931; break; };
    case 929: // $14653
      HEAP32[(($result_i115)>>2)]=$14652;
      var $14654=HEAP32[(($result_i115)>>2)];
      var $14655=(($14654)|0)==0;
      if ($14655) { __label__ = 930; break; } else { __label__ = 935; break; }
    case 930: // $14656
      var $14657=___cxa_allocate_exception(4);
      var $14658=$14657;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14658);
      (function() { try { __THREW__ = false; return ___cxa_throw($14657, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 934; break; } else { __label__ = 931; break; }
    case 931: // $14659
      var $14660=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14661=$14660.f0;
      HEAP32[(($4397)>>2)]=$14661;
      var $14662=$14660.f1;
      HEAP32[(($4398)>>2)]=$14662;
      var $14663=HEAP32[(($4398)>>2)];
      var $14664=(($14663)|0) < 0;
      if ($14664) { __label__ = 932; break; } else { __label__ = 933; break; }
    case 932: // $14665
      var $14666=HEAP32[(($4397)>>2)];
      ___cxa_call_unexpected($14666);
      throw "Reached an unreachable!"
    case 933: // $14667
      var $14668=HEAP32[(($4397)>>2)];
      var $14669=HEAP32[(($4397)>>2)];
      var $14670=HEAP32[(($4398)>>2)];
      var $14671=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14669, tempValue);
      var $14672=($14671.f1 = $14670, $14671);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 934: // $14673
      throw "Reached an unreachable!"
    case 935: // $_ZnwjPKci_exit116
      var $14674=HEAP32[(($result_i115)>>2)];
      var $14675=$4394;
      var $14676=$4395;
      var $14677=$4396;
      var $14678=$result_i115;
      var $14679=$4397;
      var $14680=$4398;
      var $14681=$14674;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5157, 1, 0, 1, 0, 56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 936; break; } else { __label__ = 11971; break; }
    case 936: // $14682
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5158, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 937; break; } else { __label__ = 11971; break; }
    case 937: // $14683
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5159, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 938; break; } else { __label__ = 11971; break; }
    case 938: // $14684
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 939; break; } else { __label__ = 11971; break; }
    case 939: // $14685
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 940; break; } else { __label__ = 11971; break; }
    case 940: // $14686
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 941; break; } else { __label__ = 11971; break; }
    case 941: // $14687
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 942; break; } else { __label__ = 11971; break; }
    case 942: // $14688
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5156, $5157, $5158, $5159, $5160, $5161, $5162, $5163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 943; break; } else { __label__ = 11971; break; }
    case 943: // $14689
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14681, 103, 1, 0, ((STRING_TABLE.__str308)|0), ((STRING_TABLE.__str309)|0), $5156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 944; break; } else { __label__ = 11971; break; }
    case 944: // $14690
      var $14691=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14681);
      var $14692=__ZN11simple_listI16input_type_entryE6appendERS0_($14642, $14691);
      var $14693=$4689;
      var $14694=$4389;
      var $14695=$4390;
      var $14696=$4391;
      var $14697=$result_i117;
      var $14698=$4392;
      var $14699=$4393;
      HEAP32[(($4389)>>2)]=408;
      HEAP32[(($4390)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4391)>>2)]=113;
      var $14700=HEAP32[(($4389)>>2)];
      var $14701=HEAP32[(($4390)>>2)];
      var $14702=HEAP32[(($4391)>>2)];
      var $14703=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14700, $14701, $14702) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 945; break; } else { __label__ = 947; break; };
    case 945: // $14704
      HEAP32[(($result_i117)>>2)]=$14703;
      var $14705=HEAP32[(($result_i117)>>2)];
      var $14706=(($14705)|0)==0;
      if ($14706) { __label__ = 946; break; } else { __label__ = 951; break; }
    case 946: // $14707
      var $14708=___cxa_allocate_exception(4);
      var $14709=$14708;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14709);
      (function() { try { __THREW__ = false; return ___cxa_throw($14708, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 950; break; } else { __label__ = 947; break; }
    case 947: // $14710
      var $14711=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14712=$14711.f0;
      HEAP32[(($4392)>>2)]=$14712;
      var $14713=$14711.f1;
      HEAP32[(($4393)>>2)]=$14713;
      var $14714=HEAP32[(($4393)>>2)];
      var $14715=(($14714)|0) < 0;
      if ($14715) { __label__ = 948; break; } else { __label__ = 949; break; }
    case 948: // $14716
      var $14717=HEAP32[(($4392)>>2)];
      ___cxa_call_unexpected($14717);
      throw "Reached an unreachable!"
    case 949: // $14718
      var $14719=HEAP32[(($4392)>>2)];
      var $14720=HEAP32[(($4392)>>2)];
      var $14721=HEAP32[(($4393)>>2)];
      var $14722=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14720, tempValue);
      var $14723=($14722.f1 = $14721, $14722);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 950: // $14724
      throw "Reached an unreachable!"
    case 951: // $_ZnwjPKci_exit118
      var $14725=HEAP32[(($result_i117)>>2)];
      var $14726=$4389;
      var $14727=$4390;
      var $14728=$4391;
      var $14729=$result_i117;
      var $14730=$4392;
      var $14731=$4393;
      var $14732=$14725;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5165, 1, 0, 1, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 952; break; } else { __label__ = 11976; break; }
    case 952: // $14733
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5166, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 953; break; } else { __label__ = 11976; break; }
    case 953: // $14734
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5167, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 954; break; } else { __label__ = 11976; break; }
    case 954: // $14735
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 955; break; } else { __label__ = 11976; break; }
    case 955: // $14736
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 956; break; } else { __label__ = 11976; break; }
    case 956: // $14737
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 957; break; } else { __label__ = 11976; break; }
    case 957: // $14738
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 958; break; } else { __label__ = 11976; break; }
    case 958: // $14739
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5164, $5165, $5166, $5167, $5168, $5169, $5170, $5171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 959; break; } else { __label__ = 11976; break; }
    case 959: // $14740
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14732, 104, 1, 0, ((STRING_TABLE.__str310)|0), ((STRING_TABLE.__str311)|0), $5164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 960; break; } else { __label__ = 11976; break; }
    case 960: // $14741
      var $14742=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14732);
      var $14743=__ZN11simple_listI16input_type_entryE6appendERS0_($14693, $14742);
      var $14744=$4689;
      var $14745=$4384;
      var $14746=$4385;
      var $14747=$4386;
      var $14748=$result_i119;
      var $14749=$4387;
      var $14750=$4388;
      HEAP32[(($4384)>>2)]=408;
      HEAP32[(($4385)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4386)>>2)]=114;
      var $14751=HEAP32[(($4384)>>2)];
      var $14752=HEAP32[(($4385)>>2)];
      var $14753=HEAP32[(($4386)>>2)];
      var $14754=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14751, $14752, $14753) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 961; break; } else { __label__ = 963; break; };
    case 961: // $14755
      HEAP32[(($result_i119)>>2)]=$14754;
      var $14756=HEAP32[(($result_i119)>>2)];
      var $14757=(($14756)|0)==0;
      if ($14757) { __label__ = 962; break; } else { __label__ = 967; break; }
    case 962: // $14758
      var $14759=___cxa_allocate_exception(4);
      var $14760=$14759;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14760);
      (function() { try { __THREW__ = false; return ___cxa_throw($14759, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 966; break; } else { __label__ = 963; break; }
    case 963: // $14761
      var $14762=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14763=$14762.f0;
      HEAP32[(($4387)>>2)]=$14763;
      var $14764=$14762.f1;
      HEAP32[(($4388)>>2)]=$14764;
      var $14765=HEAP32[(($4388)>>2)];
      var $14766=(($14765)|0) < 0;
      if ($14766) { __label__ = 964; break; } else { __label__ = 965; break; }
    case 964: // $14767
      var $14768=HEAP32[(($4387)>>2)];
      ___cxa_call_unexpected($14768);
      throw "Reached an unreachable!"
    case 965: // $14769
      var $14770=HEAP32[(($4387)>>2)];
      var $14771=HEAP32[(($4387)>>2)];
      var $14772=HEAP32[(($4388)>>2)];
      var $14773=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14771, tempValue);
      var $14774=($14773.f1 = $14772, $14773);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 966: // $14775
      throw "Reached an unreachable!"
    case 967: // $_ZnwjPKci_exit120
      var $14776=HEAP32[(($result_i119)>>2)];
      var $14777=$4384;
      var $14778=$4385;
      var $14779=$4386;
      var $14780=$result_i119;
      var $14781=$4387;
      var $14782=$4388;
      var $14783=$14776;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5173, 1, 0, 1, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 968; break; } else { __label__ = 11981; break; }
    case 968: // $14784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 969; break; } else { __label__ = 11981; break; }
    case 969: // $14785
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 970; break; } else { __label__ = 11981; break; }
    case 970: // $14786
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 971; break; } else { __label__ = 11981; break; }
    case 971: // $14787
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 972; break; } else { __label__ = 11981; break; }
    case 972: // $14788
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 973; break; } else { __label__ = 11981; break; }
    case 973: // $14789
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 974; break; } else { __label__ = 11981; break; }
    case 974: // $14790
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5172, $5173, $5174, $5175, $5176, $5177, $5178, $5179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 975; break; } else { __label__ = 11981; break; }
    case 975: // $14791
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14783, 105, 1, 0, ((STRING_TABLE.__str312)|0), ((STRING_TABLE.__str313)|0), $5172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 976; break; } else { __label__ = 11981; break; }
    case 976: // $14792
      var $14793=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14783);
      var $14794=__ZN11simple_listI16input_type_entryE6appendERS0_($14744, $14793);
      var $14795=$4689;
      var $14796=$4379;
      var $14797=$4380;
      var $14798=$4381;
      var $14799=$result_i121;
      var $14800=$4382;
      var $14801=$4383;
      HEAP32[(($4379)>>2)]=408;
      HEAP32[(($4380)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4381)>>2)]=115;
      var $14802=HEAP32[(($4379)>>2)];
      var $14803=HEAP32[(($4380)>>2)];
      var $14804=HEAP32[(($4381)>>2)];
      var $14805=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14802, $14803, $14804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 977; break; } else { __label__ = 979; break; };
    case 977: // $14806
      HEAP32[(($result_i121)>>2)]=$14805;
      var $14807=HEAP32[(($result_i121)>>2)];
      var $14808=(($14807)|0)==0;
      if ($14808) { __label__ = 978; break; } else { __label__ = 983; break; }
    case 978: // $14809
      var $14810=___cxa_allocate_exception(4);
      var $14811=$14810;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14811);
      (function() { try { __THREW__ = false; return ___cxa_throw($14810, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 982; break; } else { __label__ = 979; break; }
    case 979: // $14812
      var $14813=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14814=$14813.f0;
      HEAP32[(($4382)>>2)]=$14814;
      var $14815=$14813.f1;
      HEAP32[(($4383)>>2)]=$14815;
      var $14816=HEAP32[(($4383)>>2)];
      var $14817=(($14816)|0) < 0;
      if ($14817) { __label__ = 980; break; } else { __label__ = 981; break; }
    case 980: // $14818
      var $14819=HEAP32[(($4382)>>2)];
      ___cxa_call_unexpected($14819);
      throw "Reached an unreachable!"
    case 981: // $14820
      var $14821=HEAP32[(($4382)>>2)];
      var $14822=HEAP32[(($4382)>>2)];
      var $14823=HEAP32[(($4383)>>2)];
      var $14824=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14822, tempValue);
      var $14825=($14824.f1 = $14823, $14824);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 982: // $14826
      throw "Reached an unreachable!"
    case 983: // $_ZnwjPKci_exit122
      var $14827=HEAP32[(($result_i121)>>2)];
      var $14828=$4379;
      var $14829=$4380;
      var $14830=$4381;
      var $14831=$result_i121;
      var $14832=$4382;
      var $14833=$4383;
      var $14834=$14827;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5181, 1, 0, 1, 0, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 984; break; } else { __label__ = 11986; break; }
    case 984: // $14835
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5182, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 985; break; } else { __label__ = 11986; break; }
    case 985: // $14836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5183, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 986; break; } else { __label__ = 11986; break; }
    case 986: // $14837
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 987; break; } else { __label__ = 11986; break; }
    case 987: // $14838
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 988; break; } else { __label__ = 11986; break; }
    case 988: // $14839
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 989; break; } else { __label__ = 11986; break; }
    case 989: // $14840
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 990; break; } else { __label__ = 11986; break; }
    case 990: // $14841
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5180, $5181, $5182, $5183, $5184, $5185, $5186, $5187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 991; break; } else { __label__ = 11986; break; }
    case 991: // $14842
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14834, 106, 1, 0, ((STRING_TABLE.__str314406)|0), ((STRING_TABLE.__str315)|0), $5180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 992; break; } else { __label__ = 11986; break; }
    case 992: // $14843
      var $14844=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14834);
      var $14845=__ZN11simple_listI16input_type_entryE6appendERS0_($14795, $14844);
      var $14846=$4689;
      var $14847=$4374;
      var $14848=$4375;
      var $14849=$4376;
      var $14850=$result_i123;
      var $14851=$4377;
      var $14852=$4378;
      HEAP32[(($4374)>>2)]=408;
      HEAP32[(($4375)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4376)>>2)]=116;
      var $14853=HEAP32[(($4374)>>2)];
      var $14854=HEAP32[(($4375)>>2)];
      var $14855=HEAP32[(($4376)>>2)];
      var $14856=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14853, $14854, $14855) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 993; break; } else { __label__ = 995; break; };
    case 993: // $14857
      HEAP32[(($result_i123)>>2)]=$14856;
      var $14858=HEAP32[(($result_i123)>>2)];
      var $14859=(($14858)|0)==0;
      if ($14859) { __label__ = 994; break; } else { __label__ = 999; break; }
    case 994: // $14860
      var $14861=___cxa_allocate_exception(4);
      var $14862=$14861;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14862);
      (function() { try { __THREW__ = false; return ___cxa_throw($14861, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 998; break; } else { __label__ = 995; break; }
    case 995: // $14863
      var $14864=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14865=$14864.f0;
      HEAP32[(($4377)>>2)]=$14865;
      var $14866=$14864.f1;
      HEAP32[(($4378)>>2)]=$14866;
      var $14867=HEAP32[(($4378)>>2)];
      var $14868=(($14867)|0) < 0;
      if ($14868) { __label__ = 996; break; } else { __label__ = 997; break; }
    case 996: // $14869
      var $14870=HEAP32[(($4377)>>2)];
      ___cxa_call_unexpected($14870);
      throw "Reached an unreachable!"
    case 997: // $14871
      var $14872=HEAP32[(($4377)>>2)];
      var $14873=HEAP32[(($4377)>>2)];
      var $14874=HEAP32[(($4378)>>2)];
      var $14875=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14873, tempValue);
      var $14876=($14875.f1 = $14874, $14875);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 998: // $14877
      throw "Reached an unreachable!"
    case 999: // $_ZnwjPKci_exit124
      var $14878=HEAP32[(($result_i123)>>2)];
      var $14879=$4374;
      var $14880=$4375;
      var $14881=$4376;
      var $14882=$result_i123;
      var $14883=$4377;
      var $14884=$4378;
      var $14885=$14878;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5189, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1000; break; } else { __label__ = 11991; break; }
    case 1000: // $14886
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5190, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1001; break; } else { __label__ = 11991; break; }
    case 1001: // $14887
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5191, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1002; break; } else { __label__ = 11991; break; }
    case 1002: // $14888
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1003; break; } else { __label__ = 11991; break; }
    case 1003: // $14889
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1004; break; } else { __label__ = 11991; break; }
    case 1004: // $14890
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1005; break; } else { __label__ = 11991; break; }
    case 1005: // $14891
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1006; break; } else { __label__ = 11991; break; }
    case 1006: // $14892
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5188, $5189, $5190, $5191, $5192, $5193, $5194, $5195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1007; break; } else { __label__ = 11991; break; }
    case 1007: // $14893
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14885, 107, 1, 0, ((STRING_TABLE.__str316)|0), ((STRING_TABLE.__str317)|0), $5188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1008; break; } else { __label__ = 11991; break; }
    case 1008: // $14894
      var $14895=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14885);
      var $14896=__ZN11simple_listI16input_type_entryE6appendERS0_($14846, $14895);
      var $14897=$4689;
      var $14898=$4369;
      var $14899=$4370;
      var $14900=$4371;
      var $14901=$result_i125;
      var $14902=$4372;
      var $14903=$4373;
      HEAP32[(($4369)>>2)]=408;
      HEAP32[(($4370)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4371)>>2)]=117;
      var $14904=HEAP32[(($4369)>>2)];
      var $14905=HEAP32[(($4370)>>2)];
      var $14906=HEAP32[(($4371)>>2)];
      var $14907=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14904, $14905, $14906) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1009; break; } else { __label__ = 1011; break; };
    case 1009: // $14908
      HEAP32[(($result_i125)>>2)]=$14907;
      var $14909=HEAP32[(($result_i125)>>2)];
      var $14910=(($14909)|0)==0;
      if ($14910) { __label__ = 1010; break; } else { __label__ = 1015; break; }
    case 1010: // $14911
      var $14912=___cxa_allocate_exception(4);
      var $14913=$14912;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14913);
      (function() { try { __THREW__ = false; return ___cxa_throw($14912, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1014; break; } else { __label__ = 1011; break; }
    case 1011: // $14914
      var $14915=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14916=$14915.f0;
      HEAP32[(($4372)>>2)]=$14916;
      var $14917=$14915.f1;
      HEAP32[(($4373)>>2)]=$14917;
      var $14918=HEAP32[(($4373)>>2)];
      var $14919=(($14918)|0) < 0;
      if ($14919) { __label__ = 1012; break; } else { __label__ = 1013; break; }
    case 1012: // $14920
      var $14921=HEAP32[(($4372)>>2)];
      ___cxa_call_unexpected($14921);
      throw "Reached an unreachable!"
    case 1013: // $14922
      var $14923=HEAP32[(($4372)>>2)];
      var $14924=HEAP32[(($4372)>>2)];
      var $14925=HEAP32[(($4373)>>2)];
      var $14926=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14924, tempValue);
      var $14927=($14926.f1 = $14925, $14926);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1014: // $14928
      throw "Reached an unreachable!"
    case 1015: // $_ZnwjPKci_exit126
      var $14929=HEAP32[(($result_i125)>>2)];
      var $14930=$4369;
      var $14931=$4370;
      var $14932=$4371;
      var $14933=$result_i125;
      var $14934=$4372;
      var $14935=$4373;
      var $14936=$14929;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5197, 1, 0, 1, 0, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1016; break; } else { __label__ = 11996; break; }
    case 1016: // $14937
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1017; break; } else { __label__ = 11996; break; }
    case 1017: // $14938
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1018; break; } else { __label__ = 11996; break; }
    case 1018: // $14939
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1019; break; } else { __label__ = 11996; break; }
    case 1019: // $14940
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1020; break; } else { __label__ = 11996; break; }
    case 1020: // $14941
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1021; break; } else { __label__ = 11996; break; }
    case 1021: // $14942
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1022; break; } else { __label__ = 11996; break; }
    case 1022: // $14943
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5196, $5197, $5198, $5199, $5200, $5201, $5202, $5203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1023; break; } else { __label__ = 11996; break; }
    case 1023: // $14944
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14936, 108, 1, 0, ((STRING_TABLE.__str318)|0), ((STRING_TABLE.__str319)|0), $5196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1024; break; } else { __label__ = 11996; break; }
    case 1024: // $14945
      var $14946=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14936);
      var $14947=__ZN11simple_listI16input_type_entryE6appendERS0_($14897, $14946);
      var $14948=$4689;
      var $14949=$4364;
      var $14950=$4365;
      var $14951=$4366;
      var $14952=$result_i127;
      var $14953=$4367;
      var $14954=$4368;
      HEAP32[(($4364)>>2)]=408;
      HEAP32[(($4365)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4366)>>2)]=118;
      var $14955=HEAP32[(($4364)>>2)];
      var $14956=HEAP32[(($4365)>>2)];
      var $14957=HEAP32[(($4366)>>2)];
      var $14958=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14955, $14956, $14957) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1025; break; } else { __label__ = 1027; break; };
    case 1025: // $14959
      HEAP32[(($result_i127)>>2)]=$14958;
      var $14960=HEAP32[(($result_i127)>>2)];
      var $14961=(($14960)|0)==0;
      if ($14961) { __label__ = 1026; break; } else { __label__ = 1031; break; }
    case 1026: // $14962
      var $14963=___cxa_allocate_exception(4);
      var $14964=$14963;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($14964);
      (function() { try { __THREW__ = false; return ___cxa_throw($14963, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1030; break; } else { __label__ = 1027; break; }
    case 1027: // $14965
      var $14966=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14967=$14966.f0;
      HEAP32[(($4367)>>2)]=$14967;
      var $14968=$14966.f1;
      HEAP32[(($4368)>>2)]=$14968;
      var $14969=HEAP32[(($4368)>>2)];
      var $14970=(($14969)|0) < 0;
      if ($14970) { __label__ = 1028; break; } else { __label__ = 1029; break; }
    case 1028: // $14971
      var $14972=HEAP32[(($4367)>>2)];
      ___cxa_call_unexpected($14972);
      throw "Reached an unreachable!"
    case 1029: // $14973
      var $14974=HEAP32[(($4367)>>2)];
      var $14975=HEAP32[(($4367)>>2)];
      var $14976=HEAP32[(($4368)>>2)];
      var $14977=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14975, tempValue);
      var $14978=($14977.f1 = $14976, $14977);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1030: // $14979
      throw "Reached an unreachable!"
    case 1031: // $_ZnwjPKci_exit128
      var $14980=HEAP32[(($result_i127)>>2)];
      var $14981=$4364;
      var $14982=$4365;
      var $14983=$4366;
      var $14984=$result_i127;
      var $14985=$4367;
      var $14986=$4368;
      var $14987=$14980;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5205, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1032; break; } else { __label__ = 12001; break; }
    case 1032: // $14988
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5206, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1033; break; } else { __label__ = 12001; break; }
    case 1033: // $14989
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5207, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1034; break; } else { __label__ = 12001; break; }
    case 1034: // $14990
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1035; break; } else { __label__ = 12001; break; }
    case 1035: // $14991
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1036; break; } else { __label__ = 12001; break; }
    case 1036: // $14992
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1037; break; } else { __label__ = 12001; break; }
    case 1037: // $14993
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1038; break; } else { __label__ = 12001; break; }
    case 1038: // $14994
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5204, $5205, $5206, $5207, $5208, $5209, $5210, $5211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1039; break; } else { __label__ = 12001; break; }
    case 1039: // $14995
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($14987, 109, 1, 0, ((STRING_TABLE.__str320)|0), ((STRING_TABLE.__str321407)|0), $5204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1040; break; } else { __label__ = 12001; break; }
    case 1040: // $14996
      var $14997=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $14987);
      var $14998=__ZN11simple_listI16input_type_entryE6appendERS0_($14948, $14997);
      var $14999=$4689;
      var $15000=$4359;
      var $15001=$4360;
      var $15002=$4361;
      var $15003=$result_i129;
      var $15004=$4362;
      var $15005=$4363;
      HEAP32[(($4359)>>2)]=408;
      HEAP32[(($4360)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4361)>>2)]=119;
      var $15006=HEAP32[(($4359)>>2)];
      var $15007=HEAP32[(($4360)>>2)];
      var $15008=HEAP32[(($4361)>>2)];
      var $15009=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15006, $15007, $15008) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1041; break; } else { __label__ = 1043; break; };
    case 1041: // $15010
      HEAP32[(($result_i129)>>2)]=$15009;
      var $15011=HEAP32[(($result_i129)>>2)];
      var $15012=(($15011)|0)==0;
      if ($15012) { __label__ = 1042; break; } else { __label__ = 1047; break; }
    case 1042: // $15013
      var $15014=___cxa_allocate_exception(4);
      var $15015=$15014;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15015);
      (function() { try { __THREW__ = false; return ___cxa_throw($15014, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1046; break; } else { __label__ = 1043; break; }
    case 1043: // $15016
      var $15017=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15018=$15017.f0;
      HEAP32[(($4362)>>2)]=$15018;
      var $15019=$15017.f1;
      HEAP32[(($4363)>>2)]=$15019;
      var $15020=HEAP32[(($4363)>>2)];
      var $15021=(($15020)|0) < 0;
      if ($15021) { __label__ = 1044; break; } else { __label__ = 1045; break; }
    case 1044: // $15022
      var $15023=HEAP32[(($4362)>>2)];
      ___cxa_call_unexpected($15023);
      throw "Reached an unreachable!"
    case 1045: // $15024
      var $15025=HEAP32[(($4362)>>2)];
      var $15026=HEAP32[(($4362)>>2)];
      var $15027=HEAP32[(($4363)>>2)];
      var $15028=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15026, tempValue);
      var $15029=($15028.f1 = $15027, $15028);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1046: // $15030
      throw "Reached an unreachable!"
    case 1047: // $_ZnwjPKci_exit130
      var $15031=HEAP32[(($result_i129)>>2)];
      var $15032=$4359;
      var $15033=$4360;
      var $15034=$4361;
      var $15035=$result_i129;
      var $15036=$4362;
      var $15037=$4363;
      var $15038=$15031;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5213, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1048; break; } else { __label__ = 12006; break; }
    case 1048: // $15039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1049; break; } else { __label__ = 12006; break; }
    case 1049: // $15040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1050; break; } else { __label__ = 12006; break; }
    case 1050: // $15041
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1051; break; } else { __label__ = 12006; break; }
    case 1051: // $15042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1052; break; } else { __label__ = 12006; break; }
    case 1052: // $15043
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1053; break; } else { __label__ = 12006; break; }
    case 1053: // $15044
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1054; break; } else { __label__ = 12006; break; }
    case 1054: // $15045
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5212, $5213, $5214, $5215, $5216, $5217, $5218, $5219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1055; break; } else { __label__ = 12006; break; }
    case 1055: // $15046
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15038, 110, 1, 0, ((STRING_TABLE.__str322)|0), ((STRING_TABLE.__str323)|0), $5212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1056; break; } else { __label__ = 12006; break; }
    case 1056: // $15047
      var $15048=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15038);
      var $15049=__ZN11simple_listI16input_type_entryE6appendERS0_($14999, $15048);
      var $15050=$4689;
      var $15051=$4354;
      var $15052=$4355;
      var $15053=$4356;
      var $15054=$result_i131;
      var $15055=$4357;
      var $15056=$4358;
      HEAP32[(($4354)>>2)]=408;
      HEAP32[(($4355)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4356)>>2)]=120;
      var $15057=HEAP32[(($4354)>>2)];
      var $15058=HEAP32[(($4355)>>2)];
      var $15059=HEAP32[(($4356)>>2)];
      var $15060=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15057, $15058, $15059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1057; break; } else { __label__ = 1059; break; };
    case 1057: // $15061
      HEAP32[(($result_i131)>>2)]=$15060;
      var $15062=HEAP32[(($result_i131)>>2)];
      var $15063=(($15062)|0)==0;
      if ($15063) { __label__ = 1058; break; } else { __label__ = 1063; break; }
    case 1058: // $15064
      var $15065=___cxa_allocate_exception(4);
      var $15066=$15065;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15066);
      (function() { try { __THREW__ = false; return ___cxa_throw($15065, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1062; break; } else { __label__ = 1059; break; }
    case 1059: // $15067
      var $15068=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15069=$15068.f0;
      HEAP32[(($4357)>>2)]=$15069;
      var $15070=$15068.f1;
      HEAP32[(($4358)>>2)]=$15070;
      var $15071=HEAP32[(($4358)>>2)];
      var $15072=(($15071)|0) < 0;
      if ($15072) { __label__ = 1060; break; } else { __label__ = 1061; break; }
    case 1060: // $15073
      var $15074=HEAP32[(($4357)>>2)];
      ___cxa_call_unexpected($15074);
      throw "Reached an unreachable!"
    case 1061: // $15075
      var $15076=HEAP32[(($4357)>>2)];
      var $15077=HEAP32[(($4357)>>2)];
      var $15078=HEAP32[(($4358)>>2)];
      var $15079=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15077, tempValue);
      var $15080=($15079.f1 = $15078, $15079);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1062: // $15081
      throw "Reached an unreachable!"
    case 1063: // $_ZnwjPKci_exit132
      var $15082=HEAP32[(($result_i131)>>2)];
      var $15083=$4354;
      var $15084=$4355;
      var $15085=$4356;
      var $15086=$result_i131;
      var $15087=$4357;
      var $15088=$4358;
      var $15089=$15082;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5221, 1, 0, 1, 0, 8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1064; break; } else { __label__ = 12011; break; }
    case 1064: // $15090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5222, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1065; break; } else { __label__ = 12011; break; }
    case 1065: // $15091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1066; break; } else { __label__ = 12011; break; }
    case 1066: // $15092
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1067; break; } else { __label__ = 12011; break; }
    case 1067: // $15093
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1068; break; } else { __label__ = 12011; break; }
    case 1068: // $15094
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1069; break; } else { __label__ = 12011; break; }
    case 1069: // $15095
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1070; break; } else { __label__ = 12011; break; }
    case 1070: // $15096
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5220, $5221, $5222, $5223, $5224, $5225, $5226, $5227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1071; break; } else { __label__ = 12011; break; }
    case 1071: // $15097
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15089, 111, 1, 0, ((STRING_TABLE.__str324)|0), ((STRING_TABLE.__str325)|0), $5220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1072; break; } else { __label__ = 12011; break; }
    case 1072: // $15098
      var $15099=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15089);
      var $15100=__ZN11simple_listI16input_type_entryE6appendERS0_($15050, $15099);
      var $15101=$4689;
      var $15102=$4349;
      var $15103=$4350;
      var $15104=$4351;
      var $15105=$result_i133;
      var $15106=$4352;
      var $15107=$4353;
      HEAP32[(($4349)>>2)]=408;
      HEAP32[(($4350)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4351)>>2)]=121;
      var $15108=HEAP32[(($4349)>>2)];
      var $15109=HEAP32[(($4350)>>2)];
      var $15110=HEAP32[(($4351)>>2)];
      var $15111=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15108, $15109, $15110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1073; break; } else { __label__ = 1075; break; };
    case 1073: // $15112
      HEAP32[(($result_i133)>>2)]=$15111;
      var $15113=HEAP32[(($result_i133)>>2)];
      var $15114=(($15113)|0)==0;
      if ($15114) { __label__ = 1074; break; } else { __label__ = 1079; break; }
    case 1074: // $15115
      var $15116=___cxa_allocate_exception(4);
      var $15117=$15116;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15117);
      (function() { try { __THREW__ = false; return ___cxa_throw($15116, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1078; break; } else { __label__ = 1075; break; }
    case 1075: // $15118
      var $15119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15120=$15119.f0;
      HEAP32[(($4352)>>2)]=$15120;
      var $15121=$15119.f1;
      HEAP32[(($4353)>>2)]=$15121;
      var $15122=HEAP32[(($4353)>>2)];
      var $15123=(($15122)|0) < 0;
      if ($15123) { __label__ = 1076; break; } else { __label__ = 1077; break; }
    case 1076: // $15124
      var $15125=HEAP32[(($4352)>>2)];
      ___cxa_call_unexpected($15125);
      throw "Reached an unreachable!"
    case 1077: // $15126
      var $15127=HEAP32[(($4352)>>2)];
      var $15128=HEAP32[(($4352)>>2)];
      var $15129=HEAP32[(($4353)>>2)];
      var $15130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15128, tempValue);
      var $15131=($15130.f1 = $15129, $15130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1078: // $15132
      throw "Reached an unreachable!"
    case 1079: // $_ZnwjPKci_exit134
      var $15133=HEAP32[(($result_i133)>>2)];
      var $15134=$4349;
      var $15135=$4350;
      var $15136=$4351;
      var $15137=$result_i133;
      var $15138=$4352;
      var $15139=$4353;
      var $15140=$15133;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5229, 1, 0, 1, 0, 13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1080; break; } else { __label__ = 12016; break; }
    case 1080: // $15141
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5230, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1081; break; } else { __label__ = 12016; break; }
    case 1081: // $15142
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5231, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1082; break; } else { __label__ = 12016; break; }
    case 1082: // $15143
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1083; break; } else { __label__ = 12016; break; }
    case 1083: // $15144
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1084; break; } else { __label__ = 12016; break; }
    case 1084: // $15145
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1085; break; } else { __label__ = 12016; break; }
    case 1085: // $15146
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1086; break; } else { __label__ = 12016; break; }
    case 1086: // $15147
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5228, $5229, $5230, $5231, $5232, $5233, $5234, $5235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1087; break; } else { __label__ = 12016; break; }
    case 1087: // $15148
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15140, 112, 1, 0, ((STRING_TABLE.__str326)|0), ((STRING_TABLE.__str327)|0), $5228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1088; break; } else { __label__ = 12016; break; }
    case 1088: // $15149
      var $15150=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15140);
      var $15151=__ZN11simple_listI16input_type_entryE6appendERS0_($15101, $15150);
      var $15152=$4689;
      var $15153=$4344;
      var $15154=$4345;
      var $15155=$4346;
      var $15156=$result_i135;
      var $15157=$4347;
      var $15158=$4348;
      HEAP32[(($4344)>>2)]=408;
      HEAP32[(($4345)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4346)>>2)]=122;
      var $15159=HEAP32[(($4344)>>2)];
      var $15160=HEAP32[(($4345)>>2)];
      var $15161=HEAP32[(($4346)>>2)];
      var $15162=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15159, $15160, $15161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1089; break; } else { __label__ = 1091; break; };
    case 1089: // $15163
      HEAP32[(($result_i135)>>2)]=$15162;
      var $15164=HEAP32[(($result_i135)>>2)];
      var $15165=(($15164)|0)==0;
      if ($15165) { __label__ = 1090; break; } else { __label__ = 1095; break; }
    case 1090: // $15166
      var $15167=___cxa_allocate_exception(4);
      var $15168=$15167;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15168);
      (function() { try { __THREW__ = false; return ___cxa_throw($15167, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1094; break; } else { __label__ = 1091; break; }
    case 1091: // $15169
      var $15170=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15171=$15170.f0;
      HEAP32[(($4347)>>2)]=$15171;
      var $15172=$15170.f1;
      HEAP32[(($4348)>>2)]=$15172;
      var $15173=HEAP32[(($4348)>>2)];
      var $15174=(($15173)|0) < 0;
      if ($15174) { __label__ = 1092; break; } else { __label__ = 1093; break; }
    case 1092: // $15175
      var $15176=HEAP32[(($4347)>>2)];
      ___cxa_call_unexpected($15176);
      throw "Reached an unreachable!"
    case 1093: // $15177
      var $15178=HEAP32[(($4347)>>2)];
      var $15179=HEAP32[(($4347)>>2)];
      var $15180=HEAP32[(($4348)>>2)];
      var $15181=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15179, tempValue);
      var $15182=($15181.f1 = $15180, $15181);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1094: // $15183
      throw "Reached an unreachable!"
    case 1095: // $_ZnwjPKci_exit136
      var $15184=HEAP32[(($result_i135)>>2)];
      var $15185=$4344;
      var $15186=$4345;
      var $15187=$4346;
      var $15188=$result_i135;
      var $15189=$4347;
      var $15190=$4348;
      var $15191=$15184;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5237, 1, 0, 1, 0, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1096; break; } else { __label__ = 12021; break; }
    case 1096: // $15192
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5238, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1097; break; } else { __label__ = 12021; break; }
    case 1097: // $15193
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5239, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1098; break; } else { __label__ = 12021; break; }
    case 1098: // $15194
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1099; break; } else { __label__ = 12021; break; }
    case 1099: // $15195
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1100; break; } else { __label__ = 12021; break; }
    case 1100: // $15196
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1101; break; } else { __label__ = 12021; break; }
    case 1101: // $15197
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1102; break; } else { __label__ = 12021; break; }
    case 1102: // $15198
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5236, $5237, $5238, $5239, $5240, $5241, $5242, $5243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1103; break; } else { __label__ = 12021; break; }
    case 1103: // $15199
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15191, 113, 1, 0, ((STRING_TABLE.__str328)|0), ((STRING_TABLE.__str329)|0), $5236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1104; break; } else { __label__ = 12021; break; }
    case 1104: // $15200
      var $15201=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15191);
      var $15202=__ZN11simple_listI16input_type_entryE6appendERS0_($15152, $15201);
      var $15203=$4689;
      var $15204=$4339;
      var $15205=$4340;
      var $15206=$4341;
      var $15207=$result_i137;
      var $15208=$4342;
      var $15209=$4343;
      HEAP32[(($4339)>>2)]=408;
      HEAP32[(($4340)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4341)>>2)]=123;
      var $15210=HEAP32[(($4339)>>2)];
      var $15211=HEAP32[(($4340)>>2)];
      var $15212=HEAP32[(($4341)>>2)];
      var $15213=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15210, $15211, $15212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1105; break; } else { __label__ = 1107; break; };
    case 1105: // $15214
      HEAP32[(($result_i137)>>2)]=$15213;
      var $15215=HEAP32[(($result_i137)>>2)];
      var $15216=(($15215)|0)==0;
      if ($15216) { __label__ = 1106; break; } else { __label__ = 1111; break; }
    case 1106: // $15217
      var $15218=___cxa_allocate_exception(4);
      var $15219=$15218;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15219);
      (function() { try { __THREW__ = false; return ___cxa_throw($15218, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1110; break; } else { __label__ = 1107; break; }
    case 1107: // $15220
      var $15221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15222=$15221.f0;
      HEAP32[(($4342)>>2)]=$15222;
      var $15223=$15221.f1;
      HEAP32[(($4343)>>2)]=$15223;
      var $15224=HEAP32[(($4343)>>2)];
      var $15225=(($15224)|0) < 0;
      if ($15225) { __label__ = 1108; break; } else { __label__ = 1109; break; }
    case 1108: // $15226
      var $15227=HEAP32[(($4342)>>2)];
      ___cxa_call_unexpected($15227);
      throw "Reached an unreachable!"
    case 1109: // $15228
      var $15229=HEAP32[(($4342)>>2)];
      var $15230=HEAP32[(($4342)>>2)];
      var $15231=HEAP32[(($4343)>>2)];
      var $15232=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15230, tempValue);
      var $15233=($15232.f1 = $15231, $15232);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1110: // $15234
      throw "Reached an unreachable!"
    case 1111: // $_ZnwjPKci_exit138
      var $15235=HEAP32[(($result_i137)>>2)];
      var $15236=$4339;
      var $15237=$4340;
      var $15238=$4341;
      var $15239=$result_i137;
      var $15240=$4342;
      var $15241=$4343;
      var $15242=$15235;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5245, 1, 0, 1, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1112; break; } else { __label__ = 12026; break; }
    case 1112: // $15243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5246, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1113; break; } else { __label__ = 12026; break; }
    case 1113: // $15244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5247, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1114; break; } else { __label__ = 12026; break; }
    case 1114: // $15245
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1115; break; } else { __label__ = 12026; break; }
    case 1115: // $15246
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1116; break; } else { __label__ = 12026; break; }
    case 1116: // $15247
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1117; break; } else { __label__ = 12026; break; }
    case 1117: // $15248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1118; break; } else { __label__ = 12026; break; }
    case 1118: // $15249
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5244, $5245, $5246, $5247, $5248, $5249, $5250, $5251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1119; break; } else { __label__ = 12026; break; }
    case 1119: // $15250
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15242, 114, 1, 0, ((STRING_TABLE.__str330)|0), ((STRING_TABLE.__str331)|0), $5244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1120; break; } else { __label__ = 12026; break; }
    case 1120: // $15251
      var $15252=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15242);
      var $15253=__ZN11simple_listI16input_type_entryE6appendERS0_($15203, $15252);
      var $15254=$4689;
      var $15255=$4334;
      var $15256=$4335;
      var $15257=$4336;
      var $15258=$result_i139;
      var $15259=$4337;
      var $15260=$4338;
      HEAP32[(($4334)>>2)]=408;
      HEAP32[(($4335)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4336)>>2)]=124;
      var $15261=HEAP32[(($4334)>>2)];
      var $15262=HEAP32[(($4335)>>2)];
      var $15263=HEAP32[(($4336)>>2)];
      var $15264=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15261, $15262, $15263) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1121; break; } else { __label__ = 1123; break; };
    case 1121: // $15265
      HEAP32[(($result_i139)>>2)]=$15264;
      var $15266=HEAP32[(($result_i139)>>2)];
      var $15267=(($15266)|0)==0;
      if ($15267) { __label__ = 1122; break; } else { __label__ = 1127; break; }
    case 1122: // $15268
      var $15269=___cxa_allocate_exception(4);
      var $15270=$15269;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15270);
      (function() { try { __THREW__ = false; return ___cxa_throw($15269, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1126; break; } else { __label__ = 1123; break; }
    case 1123: // $15271
      var $15272=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15273=$15272.f0;
      HEAP32[(($4337)>>2)]=$15273;
      var $15274=$15272.f1;
      HEAP32[(($4338)>>2)]=$15274;
      var $15275=HEAP32[(($4338)>>2)];
      var $15276=(($15275)|0) < 0;
      if ($15276) { __label__ = 1124; break; } else { __label__ = 1125; break; }
    case 1124: // $15277
      var $15278=HEAP32[(($4337)>>2)];
      ___cxa_call_unexpected($15278);
      throw "Reached an unreachable!"
    case 1125: // $15279
      var $15280=HEAP32[(($4337)>>2)];
      var $15281=HEAP32[(($4337)>>2)];
      var $15282=HEAP32[(($4338)>>2)];
      var $15283=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15281, tempValue);
      var $15284=($15283.f1 = $15282, $15283);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1126: // $15285
      throw "Reached an unreachable!"
    case 1127: // $_ZnwjPKci_exit140
      var $15286=HEAP32[(($result_i139)>>2)];
      var $15287=$4334;
      var $15288=$4335;
      var $15289=$4336;
      var $15290=$result_i139;
      var $15291=$4337;
      var $15292=$4338;
      var $15293=$15286;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5253, 1, 0, 1, 0, 19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1128; break; } else { __label__ = 12031; break; }
    case 1128: // $15294
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5254, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1129; break; } else { __label__ = 12031; break; }
    case 1129: // $15295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5255, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1130; break; } else { __label__ = 12031; break; }
    case 1130: // $15296
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1131; break; } else { __label__ = 12031; break; }
    case 1131: // $15297
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1132; break; } else { __label__ = 12031; break; }
    case 1132: // $15298
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1133; break; } else { __label__ = 12031; break; }
    case 1133: // $15299
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1134; break; } else { __label__ = 12031; break; }
    case 1134: // $15300
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5252, $5253, $5254, $5255, $5256, $5257, $5258, $5259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1135; break; } else { __label__ = 12031; break; }
    case 1135: // $15301
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15293, 115, 1, 0, ((STRING_TABLE.__str332)|0), ((STRING_TABLE.__str333)|0), $5252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1136; break; } else { __label__ = 12031; break; }
    case 1136: // $15302
      var $15303=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15293);
      var $15304=__ZN11simple_listI16input_type_entryE6appendERS0_($15254, $15303);
      var $15305=$4689;
      var $15306=$4329;
      var $15307=$4330;
      var $15308=$4331;
      var $15309=$result_i141;
      var $15310=$4332;
      var $15311=$4333;
      HEAP32[(($4329)>>2)]=408;
      HEAP32[(($4330)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4331)>>2)]=125;
      var $15312=HEAP32[(($4329)>>2)];
      var $15313=HEAP32[(($4330)>>2)];
      var $15314=HEAP32[(($4331)>>2)];
      var $15315=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15312, $15313, $15314) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1137; break; } else { __label__ = 1139; break; };
    case 1137: // $15316
      HEAP32[(($result_i141)>>2)]=$15315;
      var $15317=HEAP32[(($result_i141)>>2)];
      var $15318=(($15317)|0)==0;
      if ($15318) { __label__ = 1138; break; } else { __label__ = 1143; break; }
    case 1138: // $15319
      var $15320=___cxa_allocate_exception(4);
      var $15321=$15320;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15321);
      (function() { try { __THREW__ = false; return ___cxa_throw($15320, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1142; break; } else { __label__ = 1139; break; }
    case 1139: // $15322
      var $15323=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15324=$15323.f0;
      HEAP32[(($4332)>>2)]=$15324;
      var $15325=$15323.f1;
      HEAP32[(($4333)>>2)]=$15325;
      var $15326=HEAP32[(($4333)>>2)];
      var $15327=(($15326)|0) < 0;
      if ($15327) { __label__ = 1140; break; } else { __label__ = 1141; break; }
    case 1140: // $15328
      var $15329=HEAP32[(($4332)>>2)];
      ___cxa_call_unexpected($15329);
      throw "Reached an unreachable!"
    case 1141: // $15330
      var $15331=HEAP32[(($4332)>>2)];
      var $15332=HEAP32[(($4332)>>2)];
      var $15333=HEAP32[(($4333)>>2)];
      var $15334=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15332, tempValue);
      var $15335=($15334.f1 = $15333, $15334);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1142: // $15336
      throw "Reached an unreachable!"
    case 1143: // $_ZnwjPKci_exit142
      var $15337=HEAP32[(($result_i141)>>2)];
      var $15338=$4329;
      var $15339=$4330;
      var $15340=$4331;
      var $15341=$result_i141;
      var $15342=$4332;
      var $15343=$4333;
      var $15344=$15337;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5261, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1144; break; } else { __label__ = 12036; break; }
    case 1144: // $15345
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5262, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1145; break; } else { __label__ = 12036; break; }
    case 1145: // $15346
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5263, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1146; break; } else { __label__ = 12036; break; }
    case 1146: // $15347
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1147; break; } else { __label__ = 12036; break; }
    case 1147: // $15348
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1148; break; } else { __label__ = 12036; break; }
    case 1148: // $15349
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1149; break; } else { __label__ = 12036; break; }
    case 1149: // $15350
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1150; break; } else { __label__ = 12036; break; }
    case 1150: // $15351
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5260, $5261, $5262, $5263, $5264, $5265, $5266, $5267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1151; break; } else { __label__ = 12036; break; }
    case 1151: // $15352
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15344, 116, 1, 0, ((STRING_TABLE.__str334)|0), ((STRING_TABLE.__str335)|0), $5260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1152; break; } else { __label__ = 12036; break; }
    case 1152: // $15353
      var $15354=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15344);
      var $15355=__ZN11simple_listI16input_type_entryE6appendERS0_($15305, $15354);
      var $15356=$4689;
      var $15357=$4324;
      var $15358=$4325;
      var $15359=$4326;
      var $15360=$result_i143;
      var $15361=$4327;
      var $15362=$4328;
      HEAP32[(($4324)>>2)]=408;
      HEAP32[(($4325)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4326)>>2)]=126;
      var $15363=HEAP32[(($4324)>>2)];
      var $15364=HEAP32[(($4325)>>2)];
      var $15365=HEAP32[(($4326)>>2)];
      var $15366=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15363, $15364, $15365) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1153; break; } else { __label__ = 1155; break; };
    case 1153: // $15367
      HEAP32[(($result_i143)>>2)]=$15366;
      var $15368=HEAP32[(($result_i143)>>2)];
      var $15369=(($15368)|0)==0;
      if ($15369) { __label__ = 1154; break; } else { __label__ = 1159; break; }
    case 1154: // $15370
      var $15371=___cxa_allocate_exception(4);
      var $15372=$15371;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15372);
      (function() { try { __THREW__ = false; return ___cxa_throw($15371, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1158; break; } else { __label__ = 1155; break; }
    case 1155: // $15373
      var $15374=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15375=$15374.f0;
      HEAP32[(($4327)>>2)]=$15375;
      var $15376=$15374.f1;
      HEAP32[(($4328)>>2)]=$15376;
      var $15377=HEAP32[(($4328)>>2)];
      var $15378=(($15377)|0) < 0;
      if ($15378) { __label__ = 1156; break; } else { __label__ = 1157; break; }
    case 1156: // $15379
      var $15380=HEAP32[(($4327)>>2)];
      ___cxa_call_unexpected($15380);
      throw "Reached an unreachable!"
    case 1157: // $15381
      var $15382=HEAP32[(($4327)>>2)];
      var $15383=HEAP32[(($4327)>>2)];
      var $15384=HEAP32[(($4328)>>2)];
      var $15385=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15383, tempValue);
      var $15386=($15385.f1 = $15384, $15385);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1158: // $15387
      throw "Reached an unreachable!"
    case 1159: // $_ZnwjPKci_exit144
      var $15388=HEAP32[(($result_i143)>>2)];
      var $15389=$4324;
      var $15390=$4325;
      var $15391=$4326;
      var $15392=$result_i143;
      var $15393=$4327;
      var $15394=$4328;
      var $15395=$15388;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5269, 1, 0, 1, 0, 29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1160; break; } else { __label__ = 12041; break; }
    case 1160: // $15396
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5270, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1161; break; } else { __label__ = 12041; break; }
    case 1161: // $15397
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5271, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1162; break; } else { __label__ = 12041; break; }
    case 1162: // $15398
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1163; break; } else { __label__ = 12041; break; }
    case 1163: // $15399
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1164; break; } else { __label__ = 12041; break; }
    case 1164: // $15400
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1165; break; } else { __label__ = 12041; break; }
    case 1165: // $15401
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1166; break; } else { __label__ = 12041; break; }
    case 1166: // $15402
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5268, $5269, $5270, $5271, $5272, $5273, $5274, $5275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1167; break; } else { __label__ = 12041; break; }
    case 1167: // $15403
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15395, 117, 1, 0, ((STRING_TABLE.__str336)|0), ((STRING_TABLE.__str337)|0), $5268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1168; break; } else { __label__ = 12041; break; }
    case 1168: // $15404
      var $15405=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15395);
      var $15406=__ZN11simple_listI16input_type_entryE6appendERS0_($15356, $15405);
      var $15407=$4689;
      var $15408=$4319;
      var $15409=$4320;
      var $15410=$4321;
      var $15411=$result_i145;
      var $15412=$4322;
      var $15413=$4323;
      HEAP32[(($4319)>>2)]=408;
      HEAP32[(($4320)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4321)>>2)]=127;
      var $15414=HEAP32[(($4319)>>2)];
      var $15415=HEAP32[(($4320)>>2)];
      var $15416=HEAP32[(($4321)>>2)];
      var $15417=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15414, $15415, $15416) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1169; break; } else { __label__ = 1171; break; };
    case 1169: // $15418
      HEAP32[(($result_i145)>>2)]=$15417;
      var $15419=HEAP32[(($result_i145)>>2)];
      var $15420=(($15419)|0)==0;
      if ($15420) { __label__ = 1170; break; } else { __label__ = 1175; break; }
    case 1170: // $15421
      var $15422=___cxa_allocate_exception(4);
      var $15423=$15422;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15423);
      (function() { try { __THREW__ = false; return ___cxa_throw($15422, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1174; break; } else { __label__ = 1171; break; }
    case 1171: // $15424
      var $15425=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15426=$15425.f0;
      HEAP32[(($4322)>>2)]=$15426;
      var $15427=$15425.f1;
      HEAP32[(($4323)>>2)]=$15427;
      var $15428=HEAP32[(($4323)>>2)];
      var $15429=(($15428)|0) < 0;
      if ($15429) { __label__ = 1172; break; } else { __label__ = 1173; break; }
    case 1172: // $15430
      var $15431=HEAP32[(($4322)>>2)];
      ___cxa_call_unexpected($15431);
      throw "Reached an unreachable!"
    case 1173: // $15432
      var $15433=HEAP32[(($4322)>>2)];
      var $15434=HEAP32[(($4322)>>2)];
      var $15435=HEAP32[(($4323)>>2)];
      var $15436=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15434, tempValue);
      var $15437=($15436.f1 = $15435, $15436);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1174: // $15438
      throw "Reached an unreachable!"
    case 1175: // $_ZnwjPKci_exit146
      var $15439=HEAP32[(($result_i145)>>2)];
      var $15440=$4319;
      var $15441=$4320;
      var $15442=$4321;
      var $15443=$result_i145;
      var $15444=$4322;
      var $15445=$4323;
      var $15446=$15439;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5277, 1, 0, 1, 0, 30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1176; break; } else { __label__ = 12046; break; }
    case 1176: // $15447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5278, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1177; break; } else { __label__ = 12046; break; }
    case 1177: // $15448
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5279, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1178; break; } else { __label__ = 12046; break; }
    case 1178: // $15449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5280, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1179; break; } else { __label__ = 12046; break; }
    case 1179: // $15450
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5281, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1180; break; } else { __label__ = 12046; break; }
    case 1180: // $15451
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1181; break; } else { __label__ = 12046; break; }
    case 1181: // $15452
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1182; break; } else { __label__ = 12046; break; }
    case 1182: // $15453
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5276, $5277, $5278, $5279, $5280, $5281, $5282, $5283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1183; break; } else { __label__ = 12046; break; }
    case 1183: // $15454
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15446, 118, 1, 0, ((STRING_TABLE.__str338)|0), ((STRING_TABLE.__str339)|0), $5276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1184; break; } else { __label__ = 12046; break; }
    case 1184: // $15455
      var $15456=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15446);
      var $15457=__ZN11simple_listI16input_type_entryE6appendERS0_($15407, $15456);
      var $15458=$4689;
      var $15459=$4314;
      var $15460=$4315;
      var $15461=$4316;
      var $15462=$result_i147;
      var $15463=$4317;
      var $15464=$4318;
      HEAP32[(($4314)>>2)]=408;
      HEAP32[(($4315)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4316)>>2)]=128;
      var $15465=HEAP32[(($4314)>>2)];
      var $15466=HEAP32[(($4315)>>2)];
      var $15467=HEAP32[(($4316)>>2)];
      var $15468=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15465, $15466, $15467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1185; break; } else { __label__ = 1187; break; };
    case 1185: // $15469
      HEAP32[(($result_i147)>>2)]=$15468;
      var $15470=HEAP32[(($result_i147)>>2)];
      var $15471=(($15470)|0)==0;
      if ($15471) { __label__ = 1186; break; } else { __label__ = 1191; break; }
    case 1186: // $15472
      var $15473=___cxa_allocate_exception(4);
      var $15474=$15473;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15474);
      (function() { try { __THREW__ = false; return ___cxa_throw($15473, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1190; break; } else { __label__ = 1187; break; }
    case 1187: // $15475
      var $15476=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15477=$15476.f0;
      HEAP32[(($4317)>>2)]=$15477;
      var $15478=$15476.f1;
      HEAP32[(($4318)>>2)]=$15478;
      var $15479=HEAP32[(($4318)>>2)];
      var $15480=(($15479)|0) < 0;
      if ($15480) { __label__ = 1188; break; } else { __label__ = 1189; break; }
    case 1188: // $15481
      var $15482=HEAP32[(($4317)>>2)];
      ___cxa_call_unexpected($15482);
      throw "Reached an unreachable!"
    case 1189: // $15483
      var $15484=HEAP32[(($4317)>>2)];
      var $15485=HEAP32[(($4317)>>2)];
      var $15486=HEAP32[(($4318)>>2)];
      var $15487=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15485, tempValue);
      var $15488=($15487.f1 = $15486, $15487);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1190: // $15489
      throw "Reached an unreachable!"
    case 1191: // $_ZnwjPKci_exit148
      var $15490=HEAP32[(($result_i147)>>2)];
      var $15491=$4314;
      var $15492=$4315;
      var $15493=$4316;
      var $15494=$result_i147;
      var $15495=$4317;
      var $15496=$4318;
      var $15497=$15490;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5285, 1, 0, 1, 0, 31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1192; break; } else { __label__ = 12051; break; }
    case 1192: // $15498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5286, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1193; break; } else { __label__ = 12051; break; }
    case 1193: // $15499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5287, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1194; break; } else { __label__ = 12051; break; }
    case 1194: // $15500
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1195; break; } else { __label__ = 12051; break; }
    case 1195: // $15501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1196; break; } else { __label__ = 12051; break; }
    case 1196: // $15502
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1197; break; } else { __label__ = 12051; break; }
    case 1197: // $15503
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1198; break; } else { __label__ = 12051; break; }
    case 1198: // $15504
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5284, $5285, $5286, $5287, $5288, $5289, $5290, $5291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1199; break; } else { __label__ = 12051; break; }
    case 1199: // $15505
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15497, 119, 1, 0, ((STRING_TABLE.__str340)|0), ((STRING_TABLE.__str341)|0), $5284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1200; break; } else { __label__ = 12051; break; }
    case 1200: // $15506
      var $15507=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15497);
      var $15508=__ZN11simple_listI16input_type_entryE6appendERS0_($15458, $15507);
      var $15509=$4689;
      var $15510=$4309;
      var $15511=$4310;
      var $15512=$4311;
      var $15513=$result_i149;
      var $15514=$4312;
      var $15515=$4313;
      HEAP32[(($4309)>>2)]=408;
      HEAP32[(($4310)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4311)>>2)]=129;
      var $15516=HEAP32[(($4309)>>2)];
      var $15517=HEAP32[(($4310)>>2)];
      var $15518=HEAP32[(($4311)>>2)];
      var $15519=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15516, $15517, $15518) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1201; break; } else { __label__ = 1203; break; };
    case 1201: // $15520
      HEAP32[(($result_i149)>>2)]=$15519;
      var $15521=HEAP32[(($result_i149)>>2)];
      var $15522=(($15521)|0)==0;
      if ($15522) { __label__ = 1202; break; } else { __label__ = 1207; break; }
    case 1202: // $15523
      var $15524=___cxa_allocate_exception(4);
      var $15525=$15524;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15525);
      (function() { try { __THREW__ = false; return ___cxa_throw($15524, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1206; break; } else { __label__ = 1203; break; }
    case 1203: // $15526
      var $15527=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15528=$15527.f0;
      HEAP32[(($4312)>>2)]=$15528;
      var $15529=$15527.f1;
      HEAP32[(($4313)>>2)]=$15529;
      var $15530=HEAP32[(($4313)>>2)];
      var $15531=(($15530)|0) < 0;
      if ($15531) { __label__ = 1204; break; } else { __label__ = 1205; break; }
    case 1204: // $15532
      var $15533=HEAP32[(($4312)>>2)];
      ___cxa_call_unexpected($15533);
      throw "Reached an unreachable!"
    case 1205: // $15534
      var $15535=HEAP32[(($4312)>>2)];
      var $15536=HEAP32[(($4312)>>2)];
      var $15537=HEAP32[(($4313)>>2)];
      var $15538=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15536, tempValue);
      var $15539=($15538.f1 = $15537, $15538);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1206: // $15540
      throw "Reached an unreachable!"
    case 1207: // $_ZnwjPKci_exit150
      var $15541=HEAP32[(($result_i149)>>2)];
      var $15542=$4309;
      var $15543=$4310;
      var $15544=$4311;
      var $15545=$result_i149;
      var $15546=$4312;
      var $15547=$4313;
      var $15548=$15541;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5293, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1208; break; } else { __label__ = 12056; break; }
    case 1208: // $15549
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5294, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1209; break; } else { __label__ = 12056; break; }
    case 1209: // $15550
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5295, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1210; break; } else { __label__ = 12056; break; }
    case 1210: // $15551
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1211; break; } else { __label__ = 12056; break; }
    case 1211: // $15552
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1212; break; } else { __label__ = 12056; break; }
    case 1212: // $15553
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1213; break; } else { __label__ = 12056; break; }
    case 1213: // $15554
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1214; break; } else { __label__ = 12056; break; }
    case 1214: // $15555
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5292, $5293, $5294, $5295, $5296, $5297, $5298, $5299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1215; break; } else { __label__ = 12056; break; }
    case 1215: // $15556
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15548, 120, 1, 0, ((STRING_TABLE.__str342)|0), ((STRING_TABLE.__str343)|0), $5292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1216; break; } else { __label__ = 12056; break; }
    case 1216: // $15557
      var $15558=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15548);
      var $15559=__ZN11simple_listI16input_type_entryE6appendERS0_($15509, $15558);
      var $15560=$4689;
      var $15561=$4304;
      var $15562=$4305;
      var $15563=$4306;
      var $15564=$result_i151;
      var $15565=$4307;
      var $15566=$4308;
      HEAP32[(($4304)>>2)]=408;
      HEAP32[(($4305)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4306)>>2)]=130;
      var $15567=HEAP32[(($4304)>>2)];
      var $15568=HEAP32[(($4305)>>2)];
      var $15569=HEAP32[(($4306)>>2)];
      var $15570=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15567, $15568, $15569) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1217; break; } else { __label__ = 1219; break; };
    case 1217: // $15571
      HEAP32[(($result_i151)>>2)]=$15570;
      var $15572=HEAP32[(($result_i151)>>2)];
      var $15573=(($15572)|0)==0;
      if ($15573) { __label__ = 1218; break; } else { __label__ = 1223; break; }
    case 1218: // $15574
      var $15575=___cxa_allocate_exception(4);
      var $15576=$15575;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15576);
      (function() { try { __THREW__ = false; return ___cxa_throw($15575, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1222; break; } else { __label__ = 1219; break; }
    case 1219: // $15577
      var $15578=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15579=$15578.f0;
      HEAP32[(($4307)>>2)]=$15579;
      var $15580=$15578.f1;
      HEAP32[(($4308)>>2)]=$15580;
      var $15581=HEAP32[(($4308)>>2)];
      var $15582=(($15581)|0) < 0;
      if ($15582) { __label__ = 1220; break; } else { __label__ = 1221; break; }
    case 1220: // $15583
      var $15584=HEAP32[(($4307)>>2)];
      ___cxa_call_unexpected($15584);
      throw "Reached an unreachable!"
    case 1221: // $15585
      var $15586=HEAP32[(($4307)>>2)];
      var $15587=HEAP32[(($4307)>>2)];
      var $15588=HEAP32[(($4308)>>2)];
      var $15589=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15587, tempValue);
      var $15590=($15589.f1 = $15588, $15589);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1222: // $15591
      throw "Reached an unreachable!"
    case 1223: // $_ZnwjPKci_exit152
      var $15592=HEAP32[(($result_i151)>>2)];
      var $15593=$4304;
      var $15594=$4305;
      var $15595=$4306;
      var $15596=$result_i151;
      var $15597=$4307;
      var $15598=$4308;
      var $15599=$15592;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5301, 1, 0, 1, 0, 13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1224; break; } else { __label__ = 12061; break; }
    case 1224: // $15600
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5302, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1225; break; } else { __label__ = 12061; break; }
    case 1225: // $15601
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5303, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1226; break; } else { __label__ = 12061; break; }
    case 1226: // $15602
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1227; break; } else { __label__ = 12061; break; }
    case 1227: // $15603
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1228; break; } else { __label__ = 12061; break; }
    case 1228: // $15604
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1229; break; } else { __label__ = 12061; break; }
    case 1229: // $15605
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1230; break; } else { __label__ = 12061; break; }
    case 1230: // $15606
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5300, $5301, $5302, $5303, $5304, $5305, $5306, $5307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1231; break; } else { __label__ = 12061; break; }
    case 1231: // $15607
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15599, 121, 1, 0, ((STRING_TABLE.__str344)|0), ((STRING_TABLE.__str345)|0), $5300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1232; break; } else { __label__ = 12061; break; }
    case 1232: // $15608
      var $15609=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15599);
      var $15610=__ZN11simple_listI16input_type_entryE6appendERS0_($15560, $15609);
      var $15611=$4689;
      var $15612=$4299;
      var $15613=$4300;
      var $15614=$4301;
      var $15615=$result_i153;
      var $15616=$4302;
      var $15617=$4303;
      HEAP32[(($4299)>>2)]=408;
      HEAP32[(($4300)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4301)>>2)]=131;
      var $15618=HEAP32[(($4299)>>2)];
      var $15619=HEAP32[(($4300)>>2)];
      var $15620=HEAP32[(($4301)>>2)];
      var $15621=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15618, $15619, $15620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1233; break; } else { __label__ = 1235; break; };
    case 1233: // $15622
      HEAP32[(($result_i153)>>2)]=$15621;
      var $15623=HEAP32[(($result_i153)>>2)];
      var $15624=(($15623)|0)==0;
      if ($15624) { __label__ = 1234; break; } else { __label__ = 1239; break; }
    case 1234: // $15625
      var $15626=___cxa_allocate_exception(4);
      var $15627=$15626;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15627);
      (function() { try { __THREW__ = false; return ___cxa_throw($15626, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1238; break; } else { __label__ = 1235; break; }
    case 1235: // $15628
      var $15629=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15630=$15629.f0;
      HEAP32[(($4302)>>2)]=$15630;
      var $15631=$15629.f1;
      HEAP32[(($4303)>>2)]=$15631;
      var $15632=HEAP32[(($4303)>>2)];
      var $15633=(($15632)|0) < 0;
      if ($15633) { __label__ = 1236; break; } else { __label__ = 1237; break; }
    case 1236: // $15634
      var $15635=HEAP32[(($4302)>>2)];
      ___cxa_call_unexpected($15635);
      throw "Reached an unreachable!"
    case 1237: // $15636
      var $15637=HEAP32[(($4302)>>2)];
      var $15638=HEAP32[(($4302)>>2)];
      var $15639=HEAP32[(($4303)>>2)];
      var $15640=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15638, tempValue);
      var $15641=($15640.f1 = $15639, $15640);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1238: // $15642
      throw "Reached an unreachable!"
    case 1239: // $_ZnwjPKci_exit154
      var $15643=HEAP32[(($result_i153)>>2)];
      var $15644=$4299;
      var $15645=$4300;
      var $15646=$4301;
      var $15647=$result_i153;
      var $15648=$4302;
      var $15649=$4303;
      var $15650=$15643;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5309, 1, 0, 1, 0, 17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1240; break; } else { __label__ = 12066; break; }
    case 1240: // $15651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5310, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1241; break; } else { __label__ = 12066; break; }
    case 1241: // $15652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5311, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1242; break; } else { __label__ = 12066; break; }
    case 1242: // $15653
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1243; break; } else { __label__ = 12066; break; }
    case 1243: // $15654
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1244; break; } else { __label__ = 12066; break; }
    case 1244: // $15655
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1245; break; } else { __label__ = 12066; break; }
    case 1245: // $15656
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1246; break; } else { __label__ = 12066; break; }
    case 1246: // $15657
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5308, $5309, $5310, $5311, $5312, $5313, $5314, $5315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1247; break; } else { __label__ = 12066; break; }
    case 1247: // $15658
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15650, 122, 1, 0, ((STRING_TABLE.__str346)|0), ((STRING_TABLE.__str347)|0), $5308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1248; break; } else { __label__ = 12066; break; }
    case 1248: // $15659
      var $15660=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15650);
      var $15661=__ZN11simple_listI16input_type_entryE6appendERS0_($15611, $15660);
      var $15662=$4689;
      var $15663=$4294;
      var $15664=$4295;
      var $15665=$4296;
      var $15666=$result_i155;
      var $15667=$4297;
      var $15668=$4298;
      HEAP32[(($4294)>>2)]=408;
      HEAP32[(($4295)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4296)>>2)]=132;
      var $15669=HEAP32[(($4294)>>2)];
      var $15670=HEAP32[(($4295)>>2)];
      var $15671=HEAP32[(($4296)>>2)];
      var $15672=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15669, $15670, $15671) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1249; break; } else { __label__ = 1251; break; };
    case 1249: // $15673
      HEAP32[(($result_i155)>>2)]=$15672;
      var $15674=HEAP32[(($result_i155)>>2)];
      var $15675=(($15674)|0)==0;
      if ($15675) { __label__ = 1250; break; } else { __label__ = 1255; break; }
    case 1250: // $15676
      var $15677=___cxa_allocate_exception(4);
      var $15678=$15677;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15678);
      (function() { try { __THREW__ = false; return ___cxa_throw($15677, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1254; break; } else { __label__ = 1251; break; }
    case 1251: // $15679
      var $15680=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15681=$15680.f0;
      HEAP32[(($4297)>>2)]=$15681;
      var $15682=$15680.f1;
      HEAP32[(($4298)>>2)]=$15682;
      var $15683=HEAP32[(($4298)>>2)];
      var $15684=(($15683)|0) < 0;
      if ($15684) { __label__ = 1252; break; } else { __label__ = 1253; break; }
    case 1252: // $15685
      var $15686=HEAP32[(($4297)>>2)];
      ___cxa_call_unexpected($15686);
      throw "Reached an unreachable!"
    case 1253: // $15687
      var $15688=HEAP32[(($4297)>>2)];
      var $15689=HEAP32[(($4297)>>2)];
      var $15690=HEAP32[(($4298)>>2)];
      var $15691=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15689, tempValue);
      var $15692=($15691.f1 = $15690, $15691);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1254: // $15693
      throw "Reached an unreachable!"
    case 1255: // $_ZnwjPKci_exit156
      var $15694=HEAP32[(($result_i155)>>2)];
      var $15695=$4294;
      var $15696=$4295;
      var $15697=$4296;
      var $15698=$result_i155;
      var $15699=$4297;
      var $15700=$4298;
      var $15701=$15694;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5317, 1, 0, 1, 0, 23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1256; break; } else { __label__ = 12071; break; }
    case 1256: // $15702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5318, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1257; break; } else { __label__ = 12071; break; }
    case 1257: // $15703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5319, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1258; break; } else { __label__ = 12071; break; }
    case 1258: // $15704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1259; break; } else { __label__ = 12071; break; }
    case 1259: // $15705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1260; break; } else { __label__ = 12071; break; }
    case 1260: // $15706
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1261; break; } else { __label__ = 12071; break; }
    case 1261: // $15707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1262; break; } else { __label__ = 12071; break; }
    case 1262: // $15708
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5316, $5317, $5318, $5319, $5320, $5321, $5322, $5323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1263; break; } else { __label__ = 12071; break; }
    case 1263: // $15709
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15701, 123, 1, 0, ((STRING_TABLE.__str348)|0), ((STRING_TABLE.__str349)|0), $5316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1264; break; } else { __label__ = 12071; break; }
    case 1264: // $15710
      var $15711=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15701);
      var $15712=__ZN11simple_listI16input_type_entryE6appendERS0_($15662, $15711);
      var $15713=$4689;
      var $15714=$4289;
      var $15715=$4290;
      var $15716=$4291;
      var $15717=$result_i157;
      var $15718=$4292;
      var $15719=$4293;
      HEAP32[(($4289)>>2)]=408;
      HEAP32[(($4290)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4291)>>2)]=133;
      var $15720=HEAP32[(($4289)>>2)];
      var $15721=HEAP32[(($4290)>>2)];
      var $15722=HEAP32[(($4291)>>2)];
      var $15723=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15720, $15721, $15722) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1265; break; } else { __label__ = 1267; break; };
    case 1265: // $15724
      HEAP32[(($result_i157)>>2)]=$15723;
      var $15725=HEAP32[(($result_i157)>>2)];
      var $15726=(($15725)|0)==0;
      if ($15726) { __label__ = 1266; break; } else { __label__ = 1271; break; }
    case 1266: // $15727
      var $15728=___cxa_allocate_exception(4);
      var $15729=$15728;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15729);
      (function() { try { __THREW__ = false; return ___cxa_throw($15728, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1270; break; } else { __label__ = 1267; break; }
    case 1267: // $15730
      var $15731=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15732=$15731.f0;
      HEAP32[(($4292)>>2)]=$15732;
      var $15733=$15731.f1;
      HEAP32[(($4293)>>2)]=$15733;
      var $15734=HEAP32[(($4293)>>2)];
      var $15735=(($15734)|0) < 0;
      if ($15735) { __label__ = 1268; break; } else { __label__ = 1269; break; }
    case 1268: // $15736
      var $15737=HEAP32[(($4292)>>2)];
      ___cxa_call_unexpected($15737);
      throw "Reached an unreachable!"
    case 1269: // $15738
      var $15739=HEAP32[(($4292)>>2)];
      var $15740=HEAP32[(($4292)>>2)];
      var $15741=HEAP32[(($4293)>>2)];
      var $15742=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15740, tempValue);
      var $15743=($15742.f1 = $15741, $15742);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1270: // $15744
      throw "Reached an unreachable!"
    case 1271: // $_ZnwjPKci_exit158
      var $15745=HEAP32[(($result_i157)>>2)];
      var $15746=$4289;
      var $15747=$4290;
      var $15748=$4291;
      var $15749=$result_i157;
      var $15750=$4292;
      var $15751=$4293;
      var $15752=$15745;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5325, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1272; break; } else { __label__ = 12076; break; }
    case 1272: // $15753
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5326, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1273; break; } else { __label__ = 12076; break; }
    case 1273: // $15754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5327, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1274; break; } else { __label__ = 12076; break; }
    case 1274: // $15755
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1275; break; } else { __label__ = 12076; break; }
    case 1275: // $15756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1276; break; } else { __label__ = 12076; break; }
    case 1276: // $15757
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1277; break; } else { __label__ = 12076; break; }
    case 1277: // $15758
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1278; break; } else { __label__ = 12076; break; }
    case 1278: // $15759
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5324, $5325, $5326, $5327, $5328, $5329, $5330, $5331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1279; break; } else { __label__ = 12076; break; }
    case 1279: // $15760
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15752, 124, 1, 0, ((STRING_TABLE.__str350)|0), ((STRING_TABLE.__str351)|0), $5324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1280; break; } else { __label__ = 12076; break; }
    case 1280: // $15761
      var $15762=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15752);
      var $15763=__ZN11simple_listI16input_type_entryE6appendERS0_($15713, $15762);
      var $15764=$4689;
      var $15765=$4284;
      var $15766=$4285;
      var $15767=$4286;
      var $15768=$result_i159;
      var $15769=$4287;
      var $15770=$4288;
      HEAP32[(($4284)>>2)]=408;
      HEAP32[(($4285)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4286)>>2)]=134;
      var $15771=HEAP32[(($4284)>>2)];
      var $15772=HEAP32[(($4285)>>2)];
      var $15773=HEAP32[(($4286)>>2)];
      var $15774=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15771, $15772, $15773) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1281; break; } else { __label__ = 1283; break; };
    case 1281: // $15775
      HEAP32[(($result_i159)>>2)]=$15774;
      var $15776=HEAP32[(($result_i159)>>2)];
      var $15777=(($15776)|0)==0;
      if ($15777) { __label__ = 1282; break; } else { __label__ = 1287; break; }
    case 1282: // $15778
      var $15779=___cxa_allocate_exception(4);
      var $15780=$15779;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15780);
      (function() { try { __THREW__ = false; return ___cxa_throw($15779, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1286; break; } else { __label__ = 1283; break; }
    case 1283: // $15781
      var $15782=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15783=$15782.f0;
      HEAP32[(($4287)>>2)]=$15783;
      var $15784=$15782.f1;
      HEAP32[(($4288)>>2)]=$15784;
      var $15785=HEAP32[(($4288)>>2)];
      var $15786=(($15785)|0) < 0;
      if ($15786) { __label__ = 1284; break; } else { __label__ = 1285; break; }
    case 1284: // $15787
      var $15788=HEAP32[(($4287)>>2)];
      ___cxa_call_unexpected($15788);
      throw "Reached an unreachable!"
    case 1285: // $15789
      var $15790=HEAP32[(($4287)>>2)];
      var $15791=HEAP32[(($4287)>>2)];
      var $15792=HEAP32[(($4288)>>2)];
      var $15793=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15791, tempValue);
      var $15794=($15793.f1 = $15792, $15793);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1286: // $15795
      throw "Reached an unreachable!"
    case 1287: // $_ZnwjPKci_exit160
      var $15796=HEAP32[(($result_i159)>>2)];
      var $15797=$4284;
      var $15798=$4285;
      var $15799=$4286;
      var $15800=$result_i159;
      var $15801=$4287;
      var $15802=$4288;
      var $15803=$15796;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5333, 1, 0, 1, 0, 15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1288; break; } else { __label__ = 12081; break; }
    case 1288: // $15804
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5334, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1289; break; } else { __label__ = 12081; break; }
    case 1289: // $15805
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5335, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1290; break; } else { __label__ = 12081; break; }
    case 1290: // $15806
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1291; break; } else { __label__ = 12081; break; }
    case 1291: // $15807
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1292; break; } else { __label__ = 12081; break; }
    case 1292: // $15808
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1293; break; } else { __label__ = 12081; break; }
    case 1293: // $15809
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1294; break; } else { __label__ = 12081; break; }
    case 1294: // $15810
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5332, $5333, $5334, $5335, $5336, $5337, $5338, $5339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1295; break; } else { __label__ = 12081; break; }
    case 1295: // $15811
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15803, 125, 1, 0, ((STRING_TABLE.__str352)|0), ((STRING_TABLE.__str353)|0), $5332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1296; break; } else { __label__ = 12081; break; }
    case 1296: // $15812
      var $15813=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15803);
      var $15814=__ZN11simple_listI16input_type_entryE6appendERS0_($15764, $15813);
      var $15815=$4689;
      var $15816=$4279;
      var $15817=$4280;
      var $15818=$4281;
      var $15819=$result_i161;
      var $15820=$4282;
      var $15821=$4283;
      HEAP32[(($4279)>>2)]=408;
      HEAP32[(($4280)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4281)>>2)]=135;
      var $15822=HEAP32[(($4279)>>2)];
      var $15823=HEAP32[(($4280)>>2)];
      var $15824=HEAP32[(($4281)>>2)];
      var $15825=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15822, $15823, $15824) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1297; break; } else { __label__ = 1299; break; };
    case 1297: // $15826
      HEAP32[(($result_i161)>>2)]=$15825;
      var $15827=HEAP32[(($result_i161)>>2)];
      var $15828=(($15827)|0)==0;
      if ($15828) { __label__ = 1298; break; } else { __label__ = 1303; break; }
    case 1298: // $15829
      var $15830=___cxa_allocate_exception(4);
      var $15831=$15830;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15831);
      (function() { try { __THREW__ = false; return ___cxa_throw($15830, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1302; break; } else { __label__ = 1299; break; }
    case 1299: // $15832
      var $15833=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15834=$15833.f0;
      HEAP32[(($4282)>>2)]=$15834;
      var $15835=$15833.f1;
      HEAP32[(($4283)>>2)]=$15835;
      var $15836=HEAP32[(($4283)>>2)];
      var $15837=(($15836)|0) < 0;
      if ($15837) { __label__ = 1300; break; } else { __label__ = 1301; break; }
    case 1300: // $15838
      var $15839=HEAP32[(($4282)>>2)];
      ___cxa_call_unexpected($15839);
      throw "Reached an unreachable!"
    case 1301: // $15840
      var $15841=HEAP32[(($4282)>>2)];
      var $15842=HEAP32[(($4282)>>2)];
      var $15843=HEAP32[(($4283)>>2)];
      var $15844=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15842, tempValue);
      var $15845=($15844.f1 = $15843, $15844);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1302: // $15846
      throw "Reached an unreachable!"
    case 1303: // $_ZnwjPKci_exit162
      var $15847=HEAP32[(($result_i161)>>2)];
      var $15848=$4279;
      var $15849=$4280;
      var $15850=$4281;
      var $15851=$result_i161;
      var $15852=$4282;
      var $15853=$4283;
      var $15854=$15847;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5341, 1, 0, 1, 0, 36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1304; break; } else { __label__ = 12086; break; }
    case 1304: // $15855
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5342, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1305; break; } else { __label__ = 12086; break; }
    case 1305: // $15856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5343, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1306; break; } else { __label__ = 12086; break; }
    case 1306: // $15857
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1307; break; } else { __label__ = 12086; break; }
    case 1307: // $15858
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1308; break; } else { __label__ = 12086; break; }
    case 1308: // $15859
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1309; break; } else { __label__ = 12086; break; }
    case 1309: // $15860
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1310; break; } else { __label__ = 12086; break; }
    case 1310: // $15861
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5340, $5341, $5342, $5343, $5344, $5345, $5346, $5347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1311; break; } else { __label__ = 12086; break; }
    case 1311: // $15862
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15854, 126, 1, 0, ((STRING_TABLE.__str354)|0), ((STRING_TABLE.__str355)|0), $5340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1312; break; } else { __label__ = 12086; break; }
    case 1312: // $15863
      var $15864=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15854);
      var $15865=__ZN11simple_listI16input_type_entryE6appendERS0_($15815, $15864);
      var $15866=$4689;
      var $15867=$4274;
      var $15868=$4275;
      var $15869=$4276;
      var $15870=$result_i163;
      var $15871=$4277;
      var $15872=$4278;
      HEAP32[(($4274)>>2)]=408;
      HEAP32[(($4275)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4276)>>2)]=136;
      var $15873=HEAP32[(($4274)>>2)];
      var $15874=HEAP32[(($4275)>>2)];
      var $15875=HEAP32[(($4276)>>2)];
      var $15876=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15873, $15874, $15875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1313; break; } else { __label__ = 1315; break; };
    case 1313: // $15877
      HEAP32[(($result_i163)>>2)]=$15876;
      var $15878=HEAP32[(($result_i163)>>2)];
      var $15879=(($15878)|0)==0;
      if ($15879) { __label__ = 1314; break; } else { __label__ = 1319; break; }
    case 1314: // $15880
      var $15881=___cxa_allocate_exception(4);
      var $15882=$15881;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15882);
      (function() { try { __THREW__ = false; return ___cxa_throw($15881, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1318; break; } else { __label__ = 1315; break; }
    case 1315: // $15883
      var $15884=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15885=$15884.f0;
      HEAP32[(($4277)>>2)]=$15885;
      var $15886=$15884.f1;
      HEAP32[(($4278)>>2)]=$15886;
      var $15887=HEAP32[(($4278)>>2)];
      var $15888=(($15887)|0) < 0;
      if ($15888) { __label__ = 1316; break; } else { __label__ = 1317; break; }
    case 1316: // $15889
      var $15890=HEAP32[(($4277)>>2)];
      ___cxa_call_unexpected($15890);
      throw "Reached an unreachable!"
    case 1317: // $15891
      var $15892=HEAP32[(($4277)>>2)];
      var $15893=HEAP32[(($4277)>>2)];
      var $15894=HEAP32[(($4278)>>2)];
      var $15895=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15893, tempValue);
      var $15896=($15895.f1 = $15894, $15895);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1318: // $15897
      throw "Reached an unreachable!"
    case 1319: // $_ZnwjPKci_exit164
      var $15898=HEAP32[(($result_i163)>>2)];
      var $15899=$4274;
      var $15900=$4275;
      var $15901=$4276;
      var $15902=$result_i163;
      var $15903=$4277;
      var $15904=$4278;
      var $15905=$15898;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5349, 1, 0, 1, 0, 27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1320; break; } else { __label__ = 12091; break; }
    case 1320: // $15906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5350, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1321; break; } else { __label__ = 12091; break; }
    case 1321: // $15907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5351, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1322; break; } else { __label__ = 12091; break; }
    case 1322: // $15908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1323; break; } else { __label__ = 12091; break; }
    case 1323: // $15909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1324; break; } else { __label__ = 12091; break; }
    case 1324: // $15910
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1325; break; } else { __label__ = 12091; break; }
    case 1325: // $15911
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1326; break; } else { __label__ = 12091; break; }
    case 1326: // $15912
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5348, $5349, $5350, $5351, $5352, $5353, $5354, $5355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1327; break; } else { __label__ = 12091; break; }
    case 1327: // $15913
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15905, 127, 1, 0, ((STRING_TABLE.__str356)|0), ((STRING_TABLE.__str357)|0), $5348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1328; break; } else { __label__ = 12091; break; }
    case 1328: // $15914
      var $15915=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15905);
      var $15916=__ZN11simple_listI16input_type_entryE6appendERS0_($15866, $15915);
      var $15917=$4689;
      var $15918=$4269;
      var $15919=$4270;
      var $15920=$4271;
      var $15921=$result_i165;
      var $15922=$4272;
      var $15923=$4273;
      HEAP32[(($4269)>>2)]=408;
      HEAP32[(($4270)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4271)>>2)]=137;
      var $15924=HEAP32[(($4269)>>2)];
      var $15925=HEAP32[(($4270)>>2)];
      var $15926=HEAP32[(($4271)>>2)];
      var $15927=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15924, $15925, $15926) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1329; break; } else { __label__ = 1331; break; };
    case 1329: // $15928
      HEAP32[(($result_i165)>>2)]=$15927;
      var $15929=HEAP32[(($result_i165)>>2)];
      var $15930=(($15929)|0)==0;
      if ($15930) { __label__ = 1330; break; } else { __label__ = 1335; break; }
    case 1330: // $15931
      var $15932=___cxa_allocate_exception(4);
      var $15933=$15932;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15933);
      (function() { try { __THREW__ = false; return ___cxa_throw($15932, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1334; break; } else { __label__ = 1331; break; }
    case 1331: // $15934
      var $15935=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15936=$15935.f0;
      HEAP32[(($4272)>>2)]=$15936;
      var $15937=$15935.f1;
      HEAP32[(($4273)>>2)]=$15937;
      var $15938=HEAP32[(($4273)>>2)];
      var $15939=(($15938)|0) < 0;
      if ($15939) { __label__ = 1332; break; } else { __label__ = 1333; break; }
    case 1332: // $15940
      var $15941=HEAP32[(($4272)>>2)];
      ___cxa_call_unexpected($15941);
      throw "Reached an unreachable!"
    case 1333: // $15942
      var $15943=HEAP32[(($4272)>>2)];
      var $15944=HEAP32[(($4272)>>2)];
      var $15945=HEAP32[(($4273)>>2)];
      var $15946=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15944, tempValue);
      var $15947=($15946.f1 = $15945, $15946);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1334: // $15948
      throw "Reached an unreachable!"
    case 1335: // $_ZnwjPKci_exit166
      var $15949=HEAP32[(($result_i165)>>2)];
      var $15950=$4269;
      var $15951=$4270;
      var $15952=$4271;
      var $15953=$result_i165;
      var $15954=$4272;
      var $15955=$4273;
      var $15956=$15949;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5357, 1, 0, 1, 0, 26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1336; break; } else { __label__ = 12096; break; }
    case 1336: // $15957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5358, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1337; break; } else { __label__ = 12096; break; }
    case 1337: // $15958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5359, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1338; break; } else { __label__ = 12096; break; }
    case 1338: // $15959
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1339; break; } else { __label__ = 12096; break; }
    case 1339: // $15960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1340; break; } else { __label__ = 12096; break; }
    case 1340: // $15961
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1341; break; } else { __label__ = 12096; break; }
    case 1341: // $15962
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1342; break; } else { __label__ = 12096; break; }
    case 1342: // $15963
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5356, $5357, $5358, $5359, $5360, $5361, $5362, $5363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1343; break; } else { __label__ = 12096; break; }
    case 1343: // $15964
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($15956, 128, 1, 0, ((STRING_TABLE.__str358)|0), ((STRING_TABLE.__str359)|0), $5356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1344; break; } else { __label__ = 12096; break; }
    case 1344: // $15965
      var $15966=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $15956);
      var $15967=__ZN11simple_listI16input_type_entryE6appendERS0_($15917, $15966);
      var $15968=$4689;
      var $15969=$4264;
      var $15970=$4265;
      var $15971=$4266;
      var $15972=$result_i167;
      var $15973=$4267;
      var $15974=$4268;
      HEAP32[(($4264)>>2)]=408;
      HEAP32[(($4265)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4266)>>2)]=138;
      var $15975=HEAP32[(($4264)>>2)];
      var $15976=HEAP32[(($4265)>>2)];
      var $15977=HEAP32[(($4266)>>2)];
      var $15978=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($15975, $15976, $15977) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1345; break; } else { __label__ = 1347; break; };
    case 1345: // $15979
      HEAP32[(($result_i167)>>2)]=$15978;
      var $15980=HEAP32[(($result_i167)>>2)];
      var $15981=(($15980)|0)==0;
      if ($15981) { __label__ = 1346; break; } else { __label__ = 1351; break; }
    case 1346: // $15982
      var $15983=___cxa_allocate_exception(4);
      var $15984=$15983;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($15984);
      (function() { try { __THREW__ = false; return ___cxa_throw($15983, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1350; break; } else { __label__ = 1347; break; }
    case 1347: // $15985
      var $15986=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15987=$15986.f0;
      HEAP32[(($4267)>>2)]=$15987;
      var $15988=$15986.f1;
      HEAP32[(($4268)>>2)]=$15988;
      var $15989=HEAP32[(($4268)>>2)];
      var $15990=(($15989)|0) < 0;
      if ($15990) { __label__ = 1348; break; } else { __label__ = 1349; break; }
    case 1348: // $15991
      var $15992=HEAP32[(($4267)>>2)];
      ___cxa_call_unexpected($15992);
      throw "Reached an unreachable!"
    case 1349: // $15993
      var $15994=HEAP32[(($4267)>>2)];
      var $15995=HEAP32[(($4267)>>2)];
      var $15996=HEAP32[(($4268)>>2)];
      var $15997=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15995, tempValue);
      var $15998=($15997.f1 = $15996, $15997);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1350: // $15999
      throw "Reached an unreachable!"
    case 1351: // $_ZnwjPKci_exit168
      var $16000=HEAP32[(($result_i167)>>2)];
      var $16001=$4264;
      var $16002=$4265;
      var $16003=$4266;
      var $16004=$result_i167;
      var $16005=$4267;
      var $16006=$4268;
      var $16007=$16000;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5365, 1, 0, 1, 0, 24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1352; break; } else { __label__ = 12101; break; }
    case 1352: // $16008
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5366, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1353; break; } else { __label__ = 12101; break; }
    case 1353: // $16009
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5367, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1354; break; } else { __label__ = 12101; break; }
    case 1354: // $16010
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1355; break; } else { __label__ = 12101; break; }
    case 1355: // $16011
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1356; break; } else { __label__ = 12101; break; }
    case 1356: // $16012
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1357; break; } else { __label__ = 12101; break; }
    case 1357: // $16013
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1358; break; } else { __label__ = 12101; break; }
    case 1358: // $16014
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5364, $5365, $5366, $5367, $5368, $5369, $5370, $5371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1359; break; } else { __label__ = 12101; break; }
    case 1359: // $16015
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16007, 129, 1, 0, ((STRING_TABLE.__str360)|0), ((STRING_TABLE.__str361)|0), $5364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1360; break; } else { __label__ = 12101; break; }
    case 1360: // $16016
      var $16017=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16007);
      var $16018=__ZN11simple_listI16input_type_entryE6appendERS0_($15968, $16017);
      var $16019=$4689;
      var $16020=$4259;
      var $16021=$4260;
      var $16022=$4261;
      var $16023=$result_i169;
      var $16024=$4262;
      var $16025=$4263;
      HEAP32[(($4259)>>2)]=408;
      HEAP32[(($4260)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4261)>>2)]=139;
      var $16026=HEAP32[(($4259)>>2)];
      var $16027=HEAP32[(($4260)>>2)];
      var $16028=HEAP32[(($4261)>>2)];
      var $16029=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16026, $16027, $16028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1361; break; } else { __label__ = 1363; break; };
    case 1361: // $16030
      HEAP32[(($result_i169)>>2)]=$16029;
      var $16031=HEAP32[(($result_i169)>>2)];
      var $16032=(($16031)|0)==0;
      if ($16032) { __label__ = 1362; break; } else { __label__ = 1367; break; }
    case 1362: // $16033
      var $16034=___cxa_allocate_exception(4);
      var $16035=$16034;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16035);
      (function() { try { __THREW__ = false; return ___cxa_throw($16034, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1366; break; } else { __label__ = 1363; break; }
    case 1363: // $16036
      var $16037=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16038=$16037.f0;
      HEAP32[(($4262)>>2)]=$16038;
      var $16039=$16037.f1;
      HEAP32[(($4263)>>2)]=$16039;
      var $16040=HEAP32[(($4263)>>2)];
      var $16041=(($16040)|0) < 0;
      if ($16041) { __label__ = 1364; break; } else { __label__ = 1365; break; }
    case 1364: // $16042
      var $16043=HEAP32[(($4262)>>2)];
      ___cxa_call_unexpected($16043);
      throw "Reached an unreachable!"
    case 1365: // $16044
      var $16045=HEAP32[(($4262)>>2)];
      var $16046=HEAP32[(($4262)>>2)];
      var $16047=HEAP32[(($4263)>>2)];
      var $16048=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16046, tempValue);
      var $16049=($16048.f1 = $16047, $16048);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1366: // $16050
      throw "Reached an unreachable!"
    case 1367: // $_ZnwjPKci_exit170
      var $16051=HEAP32[(($result_i169)>>2)];
      var $16052=$4259;
      var $16053=$4260;
      var $16054=$4261;
      var $16055=$result_i169;
      var $16056=$4262;
      var $16057=$4263;
      var $16058=$16051;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5373, 1, 0, 1, 0, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1368; break; } else { __label__ = 12106; break; }
    case 1368: // $16059
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5374, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1369; break; } else { __label__ = 12106; break; }
    case 1369: // $16060
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5375, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1370; break; } else { __label__ = 12106; break; }
    case 1370: // $16061
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1371; break; } else { __label__ = 12106; break; }
    case 1371: // $16062
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1372; break; } else { __label__ = 12106; break; }
    case 1372: // $16063
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1373; break; } else { __label__ = 12106; break; }
    case 1373: // $16064
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1374; break; } else { __label__ = 12106; break; }
    case 1374: // $16065
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5372, $5373, $5374, $5375, $5376, $5377, $5378, $5379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1375; break; } else { __label__ = 12106; break; }
    case 1375: // $16066
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16058, 130, 1, 0, ((STRING_TABLE.__str362)|0), ((STRING_TABLE.__str363)|0), $5372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1376; break; } else { __label__ = 12106; break; }
    case 1376: // $16067
      var $16068=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16058);
      var $16069=__ZN11simple_listI16input_type_entryE6appendERS0_($16019, $16068);
      var $16070=$4689;
      var $16071=$4254;
      var $16072=$4255;
      var $16073=$4256;
      var $16074=$result_i171;
      var $16075=$4257;
      var $16076=$4258;
      HEAP32[(($4254)>>2)]=408;
      HEAP32[(($4255)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4256)>>2)]=140;
      var $16077=HEAP32[(($4254)>>2)];
      var $16078=HEAP32[(($4255)>>2)];
      var $16079=HEAP32[(($4256)>>2)];
      var $16080=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16077, $16078, $16079) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1377; break; } else { __label__ = 1379; break; };
    case 1377: // $16081
      HEAP32[(($result_i171)>>2)]=$16080;
      var $16082=HEAP32[(($result_i171)>>2)];
      var $16083=(($16082)|0)==0;
      if ($16083) { __label__ = 1378; break; } else { __label__ = 1383; break; }
    case 1378: // $16084
      var $16085=___cxa_allocate_exception(4);
      var $16086=$16085;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16086);
      (function() { try { __THREW__ = false; return ___cxa_throw($16085, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1382; break; } else { __label__ = 1379; break; }
    case 1379: // $16087
      var $16088=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16089=$16088.f0;
      HEAP32[(($4257)>>2)]=$16089;
      var $16090=$16088.f1;
      HEAP32[(($4258)>>2)]=$16090;
      var $16091=HEAP32[(($4258)>>2)];
      var $16092=(($16091)|0) < 0;
      if ($16092) { __label__ = 1380; break; } else { __label__ = 1381; break; }
    case 1380: // $16093
      var $16094=HEAP32[(($4257)>>2)];
      ___cxa_call_unexpected($16094);
      throw "Reached an unreachable!"
    case 1381: // $16095
      var $16096=HEAP32[(($4257)>>2)];
      var $16097=HEAP32[(($4257)>>2)];
      var $16098=HEAP32[(($4258)>>2)];
      var $16099=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16097, tempValue);
      var $16100=($16099.f1 = $16098, $16099);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1382: // $16101
      throw "Reached an unreachable!"
    case 1383: // $_ZnwjPKci_exit172
      var $16102=HEAP32[(($result_i171)>>2)];
      var $16103=$4254;
      var $16104=$4255;
      var $16105=$4256;
      var $16106=$result_i171;
      var $16107=$4257;
      var $16108=$4258;
      var $16109=$16102;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5381, 1, 0, 1, 0, 22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1384; break; } else { __label__ = 12111; break; }
    case 1384: // $16110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1385; break; } else { __label__ = 12111; break; }
    case 1385: // $16111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1386; break; } else { __label__ = 12111; break; }
    case 1386: // $16112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1387; break; } else { __label__ = 12111; break; }
    case 1387: // $16113
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1388; break; } else { __label__ = 12111; break; }
    case 1388: // $16114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1389; break; } else { __label__ = 12111; break; }
    case 1389: // $16115
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1390; break; } else { __label__ = 12111; break; }
    case 1390: // $16116
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5380, $5381, $5382, $5383, $5384, $5385, $5386, $5387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1391; break; } else { __label__ = 12111; break; }
    case 1391: // $16117
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16109, 131, 1, 0, ((STRING_TABLE.__str364)|0), ((STRING_TABLE.__str365)|0), $5380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1392; break; } else { __label__ = 12111; break; }
    case 1392: // $16118
      var $16119=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16109);
      var $16120=__ZN11simple_listI16input_type_entryE6appendERS0_($16070, $16119);
      var $16121=$4689;
      var $16122=$4249;
      var $16123=$4250;
      var $16124=$4251;
      var $16125=$result_i173;
      var $16126=$4252;
      var $16127=$4253;
      HEAP32[(($4249)>>2)]=408;
      HEAP32[(($4250)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4251)>>2)]=141;
      var $16128=HEAP32[(($4249)>>2)];
      var $16129=HEAP32[(($4250)>>2)];
      var $16130=HEAP32[(($4251)>>2)];
      var $16131=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16128, $16129, $16130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1393; break; } else { __label__ = 1395; break; };
    case 1393: // $16132
      HEAP32[(($result_i173)>>2)]=$16131;
      var $16133=HEAP32[(($result_i173)>>2)];
      var $16134=(($16133)|0)==0;
      if ($16134) { __label__ = 1394; break; } else { __label__ = 1399; break; }
    case 1394: // $16135
      var $16136=___cxa_allocate_exception(4);
      var $16137=$16136;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16137);
      (function() { try { __THREW__ = false; return ___cxa_throw($16136, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1398; break; } else { __label__ = 1395; break; }
    case 1395: // $16138
      var $16139=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16140=$16139.f0;
      HEAP32[(($4252)>>2)]=$16140;
      var $16141=$16139.f1;
      HEAP32[(($4253)>>2)]=$16141;
      var $16142=HEAP32[(($4253)>>2)];
      var $16143=(($16142)|0) < 0;
      if ($16143) { __label__ = 1396; break; } else { __label__ = 1397; break; }
    case 1396: // $16144
      var $16145=HEAP32[(($4252)>>2)];
      ___cxa_call_unexpected($16145);
      throw "Reached an unreachable!"
    case 1397: // $16146
      var $16147=HEAP32[(($4252)>>2)];
      var $16148=HEAP32[(($4252)>>2)];
      var $16149=HEAP32[(($4253)>>2)];
      var $16150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16148, tempValue);
      var $16151=($16150.f1 = $16149, $16150);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1398: // $16152
      throw "Reached an unreachable!"
    case 1399: // $_ZnwjPKci_exit174
      var $16153=HEAP32[(($result_i173)>>2)];
      var $16154=$4249;
      var $16155=$4250;
      var $16156=$4251;
      var $16157=$result_i173;
      var $16158=$4252;
      var $16159=$4253;
      var $16160=$16153;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5389, 1, 0, 1, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1400; break; } else { __label__ = 12116; break; }
    case 1400: // $16161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5390, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1401; break; } else { __label__ = 12116; break; }
    case 1401: // $16162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5391, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1402; break; } else { __label__ = 12116; break; }
    case 1402: // $16163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1403; break; } else { __label__ = 12116; break; }
    case 1403: // $16164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1404; break; } else { __label__ = 12116; break; }
    case 1404: // $16165
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1405; break; } else { __label__ = 12116; break; }
    case 1405: // $16166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1406; break; } else { __label__ = 12116; break; }
    case 1406: // $16167
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5388, $5389, $5390, $5391, $5392, $5393, $5394, $5395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1407; break; } else { __label__ = 12116; break; }
    case 1407: // $16168
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16160, 132, 1, 0, ((STRING_TABLE.__str366)|0), ((STRING_TABLE.__str367)|0), $5388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1408; break; } else { __label__ = 12116; break; }
    case 1408: // $16169
      var $16170=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16160);
      var $16171=__ZN11simple_listI16input_type_entryE6appendERS0_($16121, $16170);
      var $16172=$4689;
      var $16173=$4244;
      var $16174=$4245;
      var $16175=$4246;
      var $16176=$result_i175;
      var $16177=$4247;
      var $16178=$4248;
      HEAP32[(($4244)>>2)]=408;
      HEAP32[(($4245)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4246)>>2)]=142;
      var $16179=HEAP32[(($4244)>>2)];
      var $16180=HEAP32[(($4245)>>2)];
      var $16181=HEAP32[(($4246)>>2)];
      var $16182=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16179, $16180, $16181) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1409; break; } else { __label__ = 1411; break; };
    case 1409: // $16183
      HEAP32[(($result_i175)>>2)]=$16182;
      var $16184=HEAP32[(($result_i175)>>2)];
      var $16185=(($16184)|0)==0;
      if ($16185) { __label__ = 1410; break; } else { __label__ = 1415; break; }
    case 1410: // $16186
      var $16187=___cxa_allocate_exception(4);
      var $16188=$16187;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16188);
      (function() { try { __THREW__ = false; return ___cxa_throw($16187, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1414; break; } else { __label__ = 1411; break; }
    case 1411: // $16189
      var $16190=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16191=$16190.f0;
      HEAP32[(($4247)>>2)]=$16191;
      var $16192=$16190.f1;
      HEAP32[(($4248)>>2)]=$16192;
      var $16193=HEAP32[(($4248)>>2)];
      var $16194=(($16193)|0) < 0;
      if ($16194) { __label__ = 1412; break; } else { __label__ = 1413; break; }
    case 1412: // $16195
      var $16196=HEAP32[(($4247)>>2)];
      ___cxa_call_unexpected($16196);
      throw "Reached an unreachable!"
    case 1413: // $16197
      var $16198=HEAP32[(($4247)>>2)];
      var $16199=HEAP32[(($4247)>>2)];
      var $16200=HEAP32[(($4248)>>2)];
      var $16201=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16199, tempValue);
      var $16202=($16201.f1 = $16200, $16201);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1414: // $16203
      throw "Reached an unreachable!"
    case 1415: // $_ZnwjPKci_exit176
      var $16204=HEAP32[(($result_i175)>>2)];
      var $16205=$4244;
      var $16206=$4245;
      var $16207=$4246;
      var $16208=$result_i175;
      var $16209=$4247;
      var $16210=$4248;
      var $16211=$16204;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5397, 1, 0, 1, 0, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1416; break; } else { __label__ = 12121; break; }
    case 1416: // $16212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5398, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1417; break; } else { __label__ = 12121; break; }
    case 1417: // $16213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5399, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1418; break; } else { __label__ = 12121; break; }
    case 1418: // $16214
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1419; break; } else { __label__ = 12121; break; }
    case 1419: // $16215
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1420; break; } else { __label__ = 12121; break; }
    case 1420: // $16216
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1421; break; } else { __label__ = 12121; break; }
    case 1421: // $16217
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1422; break; } else { __label__ = 12121; break; }
    case 1422: // $16218
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5396, $5397, $5398, $5399, $5400, $5401, $5402, $5403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1423; break; } else { __label__ = 12121; break; }
    case 1423: // $16219
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16211, 133, 1, 0, ((STRING_TABLE.__str368)|0), ((STRING_TABLE.__str369)|0), $5396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1424; break; } else { __label__ = 12121; break; }
    case 1424: // $16220
      var $16221=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16211);
      var $16222=__ZN11simple_listI16input_type_entryE6appendERS0_($16172, $16221);
      var $16223=$4689;
      var $16224=$4239;
      var $16225=$4240;
      var $16226=$4241;
      var $16227=$result_i177;
      var $16228=$4242;
      var $16229=$4243;
      HEAP32[(($4239)>>2)]=408;
      HEAP32[(($4240)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4241)>>2)]=143;
      var $16230=HEAP32[(($4239)>>2)];
      var $16231=HEAP32[(($4240)>>2)];
      var $16232=HEAP32[(($4241)>>2)];
      var $16233=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16230, $16231, $16232) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1425; break; } else { __label__ = 1427; break; };
    case 1425: // $16234
      HEAP32[(($result_i177)>>2)]=$16233;
      var $16235=HEAP32[(($result_i177)>>2)];
      var $16236=(($16235)|0)==0;
      if ($16236) { __label__ = 1426; break; } else { __label__ = 1431; break; }
    case 1426: // $16237
      var $16238=___cxa_allocate_exception(4);
      var $16239=$16238;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16239);
      (function() { try { __THREW__ = false; return ___cxa_throw($16238, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1430; break; } else { __label__ = 1427; break; }
    case 1427: // $16240
      var $16241=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16242=$16241.f0;
      HEAP32[(($4242)>>2)]=$16242;
      var $16243=$16241.f1;
      HEAP32[(($4243)>>2)]=$16243;
      var $16244=HEAP32[(($4243)>>2)];
      var $16245=(($16244)|0) < 0;
      if ($16245) { __label__ = 1428; break; } else { __label__ = 1429; break; }
    case 1428: // $16246
      var $16247=HEAP32[(($4242)>>2)];
      ___cxa_call_unexpected($16247);
      throw "Reached an unreachable!"
    case 1429: // $16248
      var $16249=HEAP32[(($4242)>>2)];
      var $16250=HEAP32[(($4242)>>2)];
      var $16251=HEAP32[(($4243)>>2)];
      var $16252=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16250, tempValue);
      var $16253=($16252.f1 = $16251, $16252);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1430: // $16254
      throw "Reached an unreachable!"
    case 1431: // $_ZnwjPKci_exit178
      var $16255=HEAP32[(($result_i177)>>2)];
      var $16256=$4239;
      var $16257=$4240;
      var $16258=$4241;
      var $16259=$result_i177;
      var $16260=$4242;
      var $16261=$4243;
      var $16262=$16255;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5405, 1, 0, 1, 0, 28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1432; break; } else { __label__ = 12126; break; }
    case 1432: // $16263
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5406, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1433; break; } else { __label__ = 12126; break; }
    case 1433: // $16264
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5407, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1434; break; } else { __label__ = 12126; break; }
    case 1434: // $16265
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5408, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1435; break; } else { __label__ = 12126; break; }
    case 1435: // $16266
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5409, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1436; break; } else { __label__ = 12126; break; }
    case 1436: // $16267
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1437; break; } else { __label__ = 12126; break; }
    case 1437: // $16268
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1438; break; } else { __label__ = 12126; break; }
    case 1438: // $16269
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5404, $5405, $5406, $5407, $5408, $5409, $5410, $5411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1439; break; } else { __label__ = 12126; break; }
    case 1439: // $16270
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16262, 134, 1, 0, ((STRING_TABLE.__str370)|0), ((STRING_TABLE.__str345)|0), $5404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1440; break; } else { __label__ = 12126; break; }
    case 1440: // $16271
      var $16272=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16262);
      var $16273=__ZN11simple_listI16input_type_entryE6appendERS0_($16223, $16272);
      var $16274=$4689;
      var $16275=$4234;
      var $16276=$4235;
      var $16277=$4236;
      var $16278=$result_i179;
      var $16279=$4237;
      var $16280=$4238;
      HEAP32[(($4234)>>2)]=408;
      HEAP32[(($4235)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4236)>>2)]=144;
      var $16281=HEAP32[(($4234)>>2)];
      var $16282=HEAP32[(($4235)>>2)];
      var $16283=HEAP32[(($4236)>>2)];
      var $16284=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16281, $16282, $16283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1441; break; } else { __label__ = 1443; break; };
    case 1441: // $16285
      HEAP32[(($result_i179)>>2)]=$16284;
      var $16286=HEAP32[(($result_i179)>>2)];
      var $16287=(($16286)|0)==0;
      if ($16287) { __label__ = 1442; break; } else { __label__ = 1447; break; }
    case 1442: // $16288
      var $16289=___cxa_allocate_exception(4);
      var $16290=$16289;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16290);
      (function() { try { __THREW__ = false; return ___cxa_throw($16289, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1446; break; } else { __label__ = 1443; break; }
    case 1443: // $16291
      var $16292=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16293=$16292.f0;
      HEAP32[(($4237)>>2)]=$16293;
      var $16294=$16292.f1;
      HEAP32[(($4238)>>2)]=$16294;
      var $16295=HEAP32[(($4238)>>2)];
      var $16296=(($16295)|0) < 0;
      if ($16296) { __label__ = 1444; break; } else { __label__ = 1445; break; }
    case 1444: // $16297
      var $16298=HEAP32[(($4237)>>2)];
      ___cxa_call_unexpected($16298);
      throw "Reached an unreachable!"
    case 1445: // $16299
      var $16300=HEAP32[(($4237)>>2)];
      var $16301=HEAP32[(($4237)>>2)];
      var $16302=HEAP32[(($4238)>>2)];
      var $16303=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16301, tempValue);
      var $16304=($16303.f1 = $16302, $16303);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1446: // $16305
      throw "Reached an unreachable!"
    case 1447: // $_ZnwjPKci_exit180
      var $16306=HEAP32[(($result_i179)>>2)];
      var $16307=$4234;
      var $16308=$4235;
      var $16309=$4236;
      var $16310=$result_i179;
      var $16311=$4237;
      var $16312=$4238;
      var $16313=$16306;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5413, 1, 0, 1, 0, 24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1448; break; } else { __label__ = 12131; break; }
    case 1448: // $16314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5414, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1449; break; } else { __label__ = 12131; break; }
    case 1449: // $16315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5415, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1450; break; } else { __label__ = 12131; break; }
    case 1450: // $16316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1451; break; } else { __label__ = 12131; break; }
    case 1451: // $16317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1452; break; } else { __label__ = 12131; break; }
    case 1452: // $16318
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1453; break; } else { __label__ = 12131; break; }
    case 1453: // $16319
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1454; break; } else { __label__ = 12131; break; }
    case 1454: // $16320
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5412, $5413, $5414, $5415, $5416, $5417, $5418, $5419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1455; break; } else { __label__ = 12131; break; }
    case 1455: // $16321
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16313, 135, 1, 0, ((STRING_TABLE.__str371)|0), ((STRING_TABLE.__str372408)|0), $5412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1456; break; } else { __label__ = 12131; break; }
    case 1456: // $16322
      var $16323=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16313);
      var $16324=__ZN11simple_listI16input_type_entryE6appendERS0_($16274, $16323);
      var $16325=$4689;
      var $16326=$4229;
      var $16327=$4230;
      var $16328=$4231;
      var $16329=$result_i181;
      var $16330=$4232;
      var $16331=$4233;
      HEAP32[(($4229)>>2)]=408;
      HEAP32[(($4230)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4231)>>2)]=145;
      var $16332=HEAP32[(($4229)>>2)];
      var $16333=HEAP32[(($4230)>>2)];
      var $16334=HEAP32[(($4231)>>2)];
      var $16335=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16332, $16333, $16334) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1457; break; } else { __label__ = 1459; break; };
    case 1457: // $16336
      HEAP32[(($result_i181)>>2)]=$16335;
      var $16337=HEAP32[(($result_i181)>>2)];
      var $16338=(($16337)|0)==0;
      if ($16338) { __label__ = 1458; break; } else { __label__ = 1463; break; }
    case 1458: // $16339
      var $16340=___cxa_allocate_exception(4);
      var $16341=$16340;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16341);
      (function() { try { __THREW__ = false; return ___cxa_throw($16340, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1462; break; } else { __label__ = 1459; break; }
    case 1459: // $16342
      var $16343=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16344=$16343.f0;
      HEAP32[(($4232)>>2)]=$16344;
      var $16345=$16343.f1;
      HEAP32[(($4233)>>2)]=$16345;
      var $16346=HEAP32[(($4233)>>2)];
      var $16347=(($16346)|0) < 0;
      if ($16347) { __label__ = 1460; break; } else { __label__ = 1461; break; }
    case 1460: // $16348
      var $16349=HEAP32[(($4232)>>2)];
      ___cxa_call_unexpected($16349);
      throw "Reached an unreachable!"
    case 1461: // $16350
      var $16351=HEAP32[(($4232)>>2)];
      var $16352=HEAP32[(($4232)>>2)];
      var $16353=HEAP32[(($4233)>>2)];
      var $16354=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16352, tempValue);
      var $16355=($16354.f1 = $16353, $16354);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1462: // $16356
      throw "Reached an unreachable!"
    case 1463: // $_ZnwjPKci_exit182
      var $16357=HEAP32[(($result_i181)>>2)];
      var $16358=$4229;
      var $16359=$4230;
      var $16360=$4231;
      var $16361=$result_i181;
      var $16362=$4232;
      var $16363=$4233;
      var $16364=$16357;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5421, 1, 0, 1, 0, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1464; break; } else { __label__ = 12136; break; }
    case 1464: // $16365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5422, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1465; break; } else { __label__ = 12136; break; }
    case 1465: // $16366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5423, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1466; break; } else { __label__ = 12136; break; }
    case 1466: // $16367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1467; break; } else { __label__ = 12136; break; }
    case 1467: // $16368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1468; break; } else { __label__ = 12136; break; }
    case 1468: // $16369
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1469; break; } else { __label__ = 12136; break; }
    case 1469: // $16370
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1470; break; } else { __label__ = 12136; break; }
    case 1470: // $16371
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5420, $5421, $5422, $5423, $5424, $5425, $5426, $5427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1471; break; } else { __label__ = 12136; break; }
    case 1471: // $16372
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16364, 136, 1, 0, ((STRING_TABLE.__str373)|0), ((STRING_TABLE.__str374)|0), $5420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1472; break; } else { __label__ = 12136; break; }
    case 1472: // $16373
      var $16374=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16364);
      var $16375=__ZN11simple_listI16input_type_entryE6appendERS0_($16325, $16374);
      var $16376=$4689;
      var $16377=$4224;
      var $16378=$4225;
      var $16379=$4226;
      var $16380=$result_i183;
      var $16381=$4227;
      var $16382=$4228;
      HEAP32[(($4224)>>2)]=408;
      HEAP32[(($4225)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4226)>>2)]=146;
      var $16383=HEAP32[(($4224)>>2)];
      var $16384=HEAP32[(($4225)>>2)];
      var $16385=HEAP32[(($4226)>>2)];
      var $16386=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16383, $16384, $16385) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1473; break; } else { __label__ = 1475; break; };
    case 1473: // $16387
      HEAP32[(($result_i183)>>2)]=$16386;
      var $16388=HEAP32[(($result_i183)>>2)];
      var $16389=(($16388)|0)==0;
      if ($16389) { __label__ = 1474; break; } else { __label__ = 1479; break; }
    case 1474: // $16390
      var $16391=___cxa_allocate_exception(4);
      var $16392=$16391;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16392);
      (function() { try { __THREW__ = false; return ___cxa_throw($16391, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1478; break; } else { __label__ = 1475; break; }
    case 1475: // $16393
      var $16394=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16395=$16394.f0;
      HEAP32[(($4227)>>2)]=$16395;
      var $16396=$16394.f1;
      HEAP32[(($4228)>>2)]=$16396;
      var $16397=HEAP32[(($4228)>>2)];
      var $16398=(($16397)|0) < 0;
      if ($16398) { __label__ = 1476; break; } else { __label__ = 1477; break; }
    case 1476: // $16399
      var $16400=HEAP32[(($4227)>>2)];
      ___cxa_call_unexpected($16400);
      throw "Reached an unreachable!"
    case 1477: // $16401
      var $16402=HEAP32[(($4227)>>2)];
      var $16403=HEAP32[(($4227)>>2)];
      var $16404=HEAP32[(($4228)>>2)];
      var $16405=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16403, tempValue);
      var $16406=($16405.f1 = $16404, $16405);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1478: // $16407
      throw "Reached an unreachable!"
    case 1479: // $_ZnwjPKci_exit184
      var $16408=HEAP32[(($result_i183)>>2)];
      var $16409=$4224;
      var $16410=$4225;
      var $16411=$4226;
      var $16412=$result_i183;
      var $16413=$4227;
      var $16414=$4228;
      var $16415=$16408;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5429, 1, 0, 1, 0, 22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1480; break; } else { __label__ = 12141; break; }
    case 1480: // $16416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5430, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1481; break; } else { __label__ = 12141; break; }
    case 1481: // $16417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5431, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1482; break; } else { __label__ = 12141; break; }
    case 1482: // $16418
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5432, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1483; break; } else { __label__ = 12141; break; }
    case 1483: // $16419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5433, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1484; break; } else { __label__ = 12141; break; }
    case 1484: // $16420
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1485; break; } else { __label__ = 12141; break; }
    case 1485: // $16421
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1486; break; } else { __label__ = 12141; break; }
    case 1486: // $16422
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5428, $5429, $5430, $5431, $5432, $5433, $5434, $5435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1487; break; } else { __label__ = 12141; break; }
    case 1487: // $16423
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16415, 137, 1, 0, ((STRING_TABLE.__str375)|0), ((STRING_TABLE.__str376)|0), $5428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1488; break; } else { __label__ = 12141; break; }
    case 1488: // $16424
      var $16425=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16415);
      var $16426=__ZN11simple_listI16input_type_entryE6appendERS0_($16376, $16425);
      var $16427=$4689;
      var $16428=$4219;
      var $16429=$4220;
      var $16430=$4221;
      var $16431=$result_i185;
      var $16432=$4222;
      var $16433=$4223;
      HEAP32[(($4219)>>2)]=408;
      HEAP32[(($4220)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4221)>>2)]=147;
      var $16434=HEAP32[(($4219)>>2)];
      var $16435=HEAP32[(($4220)>>2)];
      var $16436=HEAP32[(($4221)>>2)];
      var $16437=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16434, $16435, $16436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1489; break; } else { __label__ = 1491; break; };
    case 1489: // $16438
      HEAP32[(($result_i185)>>2)]=$16437;
      var $16439=HEAP32[(($result_i185)>>2)];
      var $16440=(($16439)|0)==0;
      if ($16440) { __label__ = 1490; break; } else { __label__ = 1495; break; }
    case 1490: // $16441
      var $16442=___cxa_allocate_exception(4);
      var $16443=$16442;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16443);
      (function() { try { __THREW__ = false; return ___cxa_throw($16442, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1494; break; } else { __label__ = 1491; break; }
    case 1491: // $16444
      var $16445=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16446=$16445.f0;
      HEAP32[(($4222)>>2)]=$16446;
      var $16447=$16445.f1;
      HEAP32[(($4223)>>2)]=$16447;
      var $16448=HEAP32[(($4223)>>2)];
      var $16449=(($16448)|0) < 0;
      if ($16449) { __label__ = 1492; break; } else { __label__ = 1493; break; }
    case 1492: // $16450
      var $16451=HEAP32[(($4222)>>2)];
      ___cxa_call_unexpected($16451);
      throw "Reached an unreachable!"
    case 1493: // $16452
      var $16453=HEAP32[(($4222)>>2)];
      var $16454=HEAP32[(($4222)>>2)];
      var $16455=HEAP32[(($4223)>>2)];
      var $16456=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16454, tempValue);
      var $16457=($16456.f1 = $16455, $16456);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1494: // $16458
      throw "Reached an unreachable!"
    case 1495: // $_ZnwjPKci_exit186
      var $16459=HEAP32[(($result_i185)>>2)];
      var $16460=$4219;
      var $16461=$4220;
      var $16462=$4221;
      var $16463=$result_i185;
      var $16464=$4222;
      var $16465=$4223;
      var $16466=$16459;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5437, 1, 0, 1, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1496; break; } else { __label__ = 12146; break; }
    case 1496: // $16467
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5438, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1497; break; } else { __label__ = 12146; break; }
    case 1497: // $16468
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5439, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1498; break; } else { __label__ = 12146; break; }
    case 1498: // $16469
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1499; break; } else { __label__ = 12146; break; }
    case 1499: // $16470
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1500; break; } else { __label__ = 12146; break; }
    case 1500: // $16471
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1501; break; } else { __label__ = 12146; break; }
    case 1501: // $16472
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1502; break; } else { __label__ = 12146; break; }
    case 1502: // $16473
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5436, $5437, $5438, $5439, $5440, $5441, $5442, $5443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1503; break; } else { __label__ = 12146; break; }
    case 1503: // $16474
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16466, 138, 1, 0, ((STRING_TABLE.__str377)|0), ((STRING_TABLE.__str378)|0), $5436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1504; break; } else { __label__ = 12146; break; }
    case 1504: // $16475
      var $16476=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16466);
      var $16477=__ZN11simple_listI16input_type_entryE6appendERS0_($16427, $16476);
      var $16478=$4689;
      var $16479=$4214;
      var $16480=$4215;
      var $16481=$4216;
      var $16482=$result_i187;
      var $16483=$4217;
      var $16484=$4218;
      HEAP32[(($4214)>>2)]=408;
      HEAP32[(($4215)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4216)>>2)]=148;
      var $16485=HEAP32[(($4214)>>2)];
      var $16486=HEAP32[(($4215)>>2)];
      var $16487=HEAP32[(($4216)>>2)];
      var $16488=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16485, $16486, $16487) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1505; break; } else { __label__ = 1507; break; };
    case 1505: // $16489
      HEAP32[(($result_i187)>>2)]=$16488;
      var $16490=HEAP32[(($result_i187)>>2)];
      var $16491=(($16490)|0)==0;
      if ($16491) { __label__ = 1506; break; } else { __label__ = 1511; break; }
    case 1506: // $16492
      var $16493=___cxa_allocate_exception(4);
      var $16494=$16493;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16494);
      (function() { try { __THREW__ = false; return ___cxa_throw($16493, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1510; break; } else { __label__ = 1507; break; }
    case 1507: // $16495
      var $16496=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16497=$16496.f0;
      HEAP32[(($4217)>>2)]=$16497;
      var $16498=$16496.f1;
      HEAP32[(($4218)>>2)]=$16498;
      var $16499=HEAP32[(($4218)>>2)];
      var $16500=(($16499)|0) < 0;
      if ($16500) { __label__ = 1508; break; } else { __label__ = 1509; break; }
    case 1508: // $16501
      var $16502=HEAP32[(($4217)>>2)];
      ___cxa_call_unexpected($16502);
      throw "Reached an unreachable!"
    case 1509: // $16503
      var $16504=HEAP32[(($4217)>>2)];
      var $16505=HEAP32[(($4217)>>2)];
      var $16506=HEAP32[(($4218)>>2)];
      var $16507=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16505, tempValue);
      var $16508=($16507.f1 = $16506, $16507);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1510: // $16509
      throw "Reached an unreachable!"
    case 1511: // $_ZnwjPKci_exit188
      var $16510=HEAP32[(($result_i187)>>2)];
      var $16511=$4214;
      var $16512=$4215;
      var $16513=$4216;
      var $16514=$result_i187;
      var $16515=$4217;
      var $16516=$4218;
      var $16517=$16510;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5445, 1, 0, 1, 0, 26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1512; break; } else { __label__ = 12151; break; }
    case 1512: // $16518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5446, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1513; break; } else { __label__ = 12151; break; }
    case 1513: // $16519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5447, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1514; break; } else { __label__ = 12151; break; }
    case 1514: // $16520
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1515; break; } else { __label__ = 12151; break; }
    case 1515: // $16521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1516; break; } else { __label__ = 12151; break; }
    case 1516: // $16522
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1517; break; } else { __label__ = 12151; break; }
    case 1517: // $16523
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1518; break; } else { __label__ = 12151; break; }
    case 1518: // $16524
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5444, $5445, $5446, $5447, $5448, $5449, $5450, $5451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1519; break; } else { __label__ = 12151; break; }
    case 1519: // $16525
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16517, 139, 1, 0, ((STRING_TABLE.__str379)|0), ((STRING_TABLE.__str380)|0), $5444) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1520; break; } else { __label__ = 12151; break; }
    case 1520: // $16526
      var $16527=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16517);
      var $16528=__ZN11simple_listI16input_type_entryE6appendERS0_($16478, $16527);
      var $16529=$4689;
      var $16530=$4209;
      var $16531=$4210;
      var $16532=$4211;
      var $16533=$result_i189;
      var $16534=$4212;
      var $16535=$4213;
      HEAP32[(($4209)>>2)]=408;
      HEAP32[(($4210)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4211)>>2)]=150;
      var $16536=HEAP32[(($4209)>>2)];
      var $16537=HEAP32[(($4210)>>2)];
      var $16538=HEAP32[(($4211)>>2)];
      var $16539=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16536, $16537, $16538) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1521; break; } else { __label__ = 1523; break; };
    case 1521: // $16540
      HEAP32[(($result_i189)>>2)]=$16539;
      var $16541=HEAP32[(($result_i189)>>2)];
      var $16542=(($16541)|0)==0;
      if ($16542) { __label__ = 1522; break; } else { __label__ = 1527; break; }
    case 1522: // $16543
      var $16544=___cxa_allocate_exception(4);
      var $16545=$16544;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16545);
      (function() { try { __THREW__ = false; return ___cxa_throw($16544, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1526; break; } else { __label__ = 1523; break; }
    case 1523: // $16546
      var $16547=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16548=$16547.f0;
      HEAP32[(($4212)>>2)]=$16548;
      var $16549=$16547.f1;
      HEAP32[(($4213)>>2)]=$16549;
      var $16550=HEAP32[(($4213)>>2)];
      var $16551=(($16550)|0) < 0;
      if ($16551) { __label__ = 1524; break; } else { __label__ = 1525; break; }
    case 1524: // $16552
      var $16553=HEAP32[(($4212)>>2)];
      ___cxa_call_unexpected($16553);
      throw "Reached an unreachable!"
    case 1525: // $16554
      var $16555=HEAP32[(($4212)>>2)];
      var $16556=HEAP32[(($4212)>>2)];
      var $16557=HEAP32[(($4213)>>2)];
      var $16558=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16556, tempValue);
      var $16559=($16558.f1 = $16557, $16558);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1526: // $16560
      throw "Reached an unreachable!"
    case 1527: // $_ZnwjPKci_exit190
      var $16561=HEAP32[(($result_i189)>>2)];
      var $16562=$4209;
      var $16563=$4210;
      var $16564=$4211;
      var $16565=$result_i189;
      var $16566=$4212;
      var $16567=$4213;
      var $16568=$16561;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5453, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1528; break; } else { __label__ = 12156; break; }
    case 1528: // $16569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5454, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1529; break; } else { __label__ = 12156; break; }
    case 1529: // $16570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5455, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1530; break; } else { __label__ = 12156; break; }
    case 1530: // $16571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5456, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1531; break; } else { __label__ = 12156; break; }
    case 1531: // $16572
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5457, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1532; break; } else { __label__ = 12156; break; }
    case 1532: // $16573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1533; break; } else { __label__ = 12156; break; }
    case 1533: // $16574
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1534; break; } else { __label__ = 12156; break; }
    case 1534: // $16575
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5452, $5453, $5454, $5455, $5456, $5457, $5458, $5459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1535; break; } else { __label__ = 12156; break; }
    case 1535: // $16576
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16568, 47, 2, 1, ((STRING_TABLE.__str381)|0), ((STRING_TABLE.__str382)|0), $5452) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1536; break; } else { __label__ = 12156; break; }
    case 1536: // $16577
      var $16578=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16568);
      var $16579=__ZN11simple_listI16input_type_entryE6appendERS0_($16529, $16578);
      var $16580=$4689;
      var $16581=$4204;
      var $16582=$4205;
      var $16583=$4206;
      var $16584=$result_i191;
      var $16585=$4207;
      var $16586=$4208;
      HEAP32[(($4204)>>2)]=408;
      HEAP32[(($4205)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4206)>>2)]=151;
      var $16587=HEAP32[(($4204)>>2)];
      var $16588=HEAP32[(($4205)>>2)];
      var $16589=HEAP32[(($4206)>>2)];
      var $16590=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16587, $16588, $16589) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1537; break; } else { __label__ = 1539; break; };
    case 1537: // $16591
      HEAP32[(($result_i191)>>2)]=$16590;
      var $16592=HEAP32[(($result_i191)>>2)];
      var $16593=(($16592)|0)==0;
      if ($16593) { __label__ = 1538; break; } else { __label__ = 1543; break; }
    case 1538: // $16594
      var $16595=___cxa_allocate_exception(4);
      var $16596=$16595;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16596);
      (function() { try { __THREW__ = false; return ___cxa_throw($16595, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1542; break; } else { __label__ = 1539; break; }
    case 1539: // $16597
      var $16598=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16599=$16598.f0;
      HEAP32[(($4207)>>2)]=$16599;
      var $16600=$16598.f1;
      HEAP32[(($4208)>>2)]=$16600;
      var $16601=HEAP32[(($4208)>>2)];
      var $16602=(($16601)|0) < 0;
      if ($16602) { __label__ = 1540; break; } else { __label__ = 1541; break; }
    case 1540: // $16603
      var $16604=HEAP32[(($4207)>>2)];
      ___cxa_call_unexpected($16604);
      throw "Reached an unreachable!"
    case 1541: // $16605
      var $16606=HEAP32[(($4207)>>2)];
      var $16607=HEAP32[(($4207)>>2)];
      var $16608=HEAP32[(($4208)>>2)];
      var $16609=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16607, tempValue);
      var $16610=($16609.f1 = $16608, $16609);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1542: // $16611
      throw "Reached an unreachable!"
    case 1543: // $_ZnwjPKci_exit192
      var $16612=HEAP32[(($result_i191)>>2)];
      var $16613=$4204;
      var $16614=$4205;
      var $16615=$4206;
      var $16616=$result_i191;
      var $16617=$4207;
      var $16618=$4208;
      var $16619=$16612;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5461, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1544; break; } else { __label__ = 12161; break; }
    case 1544: // $16620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5462, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1545; break; } else { __label__ = 12161; break; }
    case 1545: // $16621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5463, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1546; break; } else { __label__ = 12161; break; }
    case 1546: // $16622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1547; break; } else { __label__ = 12161; break; }
    case 1547: // $16623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1548; break; } else { __label__ = 12161; break; }
    case 1548: // $16624
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1549; break; } else { __label__ = 12161; break; }
    case 1549: // $16625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1550; break; } else { __label__ = 12161; break; }
    case 1550: // $16626
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5460, $5461, $5462, $5463, $5464, $5465, $5466, $5467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1551; break; } else { __label__ = 12161; break; }
    case 1551: // $16627
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16619, 48, 2, 1, ((STRING_TABLE.__str383)|0), ((STRING_TABLE.__str384)|0), $5460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1552; break; } else { __label__ = 12161; break; }
    case 1552: // $16628
      var $16629=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16619);
      var $16630=__ZN11simple_listI16input_type_entryE6appendERS0_($16580, $16629);
      var $16631=$4689;
      var $16632=$4199;
      var $16633=$4200;
      var $16634=$4201;
      var $16635=$result_i193;
      var $16636=$4202;
      var $16637=$4203;
      HEAP32[(($4199)>>2)]=408;
      HEAP32[(($4200)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4201)>>2)]=152;
      var $16638=HEAP32[(($4199)>>2)];
      var $16639=HEAP32[(($4200)>>2)];
      var $16640=HEAP32[(($4201)>>2)];
      var $16641=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16638, $16639, $16640) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1553; break; } else { __label__ = 1555; break; };
    case 1553: // $16642
      HEAP32[(($result_i193)>>2)]=$16641;
      var $16643=HEAP32[(($result_i193)>>2)];
      var $16644=(($16643)|0)==0;
      if ($16644) { __label__ = 1554; break; } else { __label__ = 1559; break; }
    case 1554: // $16645
      var $16646=___cxa_allocate_exception(4);
      var $16647=$16646;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16647);
      (function() { try { __THREW__ = false; return ___cxa_throw($16646, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1558; break; } else { __label__ = 1555; break; }
    case 1555: // $16648
      var $16649=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16650=$16649.f0;
      HEAP32[(($4202)>>2)]=$16650;
      var $16651=$16649.f1;
      HEAP32[(($4203)>>2)]=$16651;
      var $16652=HEAP32[(($4203)>>2)];
      var $16653=(($16652)|0) < 0;
      if ($16653) { __label__ = 1556; break; } else { __label__ = 1557; break; }
    case 1556: // $16654
      var $16655=HEAP32[(($4202)>>2)];
      ___cxa_call_unexpected($16655);
      throw "Reached an unreachable!"
    case 1557: // $16656
      var $16657=HEAP32[(($4202)>>2)];
      var $16658=HEAP32[(($4202)>>2)];
      var $16659=HEAP32[(($4203)>>2)];
      var $16660=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16658, tempValue);
      var $16661=($16660.f1 = $16659, $16660);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1558: // $16662
      throw "Reached an unreachable!"
    case 1559: // $_ZnwjPKci_exit194
      var $16663=HEAP32[(($result_i193)>>2)];
      var $16664=$4199;
      var $16665=$4200;
      var $16666=$4201;
      var $16667=$result_i193;
      var $16668=$4202;
      var $16669=$4203;
      var $16670=$16663;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5469, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1560; break; } else { __label__ = 12166; break; }
    case 1560: // $16671
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5470, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1561; break; } else { __label__ = 12166; break; }
    case 1561: // $16672
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5471, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1562; break; } else { __label__ = 12166; break; }
    case 1562: // $16673
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1563; break; } else { __label__ = 12166; break; }
    case 1563: // $16674
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1564; break; } else { __label__ = 12166; break; }
    case 1564: // $16675
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1565; break; } else { __label__ = 12166; break; }
    case 1565: // $16676
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1566; break; } else { __label__ = 12166; break; }
    case 1566: // $16677
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5468, $5469, $5470, $5471, $5472, $5473, $5474, $5475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1567; break; } else { __label__ = 12166; break; }
    case 1567: // $16678
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16670, 49, 2, 1, ((STRING_TABLE.__str385)|0), ((STRING_TABLE.__str386)|0), $5468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1568; break; } else { __label__ = 12166; break; }
    case 1568: // $16679
      var $16680=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16670);
      var $16681=__ZN11simple_listI16input_type_entryE6appendERS0_($16631, $16680);
      var $16682=$4689;
      var $16683=$4194;
      var $16684=$4195;
      var $16685=$4196;
      var $16686=$result_i195;
      var $16687=$4197;
      var $16688=$4198;
      HEAP32[(($4194)>>2)]=408;
      HEAP32[(($4195)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4196)>>2)]=153;
      var $16689=HEAP32[(($4194)>>2)];
      var $16690=HEAP32[(($4195)>>2)];
      var $16691=HEAP32[(($4196)>>2)];
      var $16692=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16689, $16690, $16691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1569; break; } else { __label__ = 1571; break; };
    case 1569: // $16693
      HEAP32[(($result_i195)>>2)]=$16692;
      var $16694=HEAP32[(($result_i195)>>2)];
      var $16695=(($16694)|0)==0;
      if ($16695) { __label__ = 1570; break; } else { __label__ = 1575; break; }
    case 1570: // $16696
      var $16697=___cxa_allocate_exception(4);
      var $16698=$16697;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16698);
      (function() { try { __THREW__ = false; return ___cxa_throw($16697, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1574; break; } else { __label__ = 1571; break; }
    case 1571: // $16699
      var $16700=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16701=$16700.f0;
      HEAP32[(($4197)>>2)]=$16701;
      var $16702=$16700.f1;
      HEAP32[(($4198)>>2)]=$16702;
      var $16703=HEAP32[(($4198)>>2)];
      var $16704=(($16703)|0) < 0;
      if ($16704) { __label__ = 1572; break; } else { __label__ = 1573; break; }
    case 1572: // $16705
      var $16706=HEAP32[(($4197)>>2)];
      ___cxa_call_unexpected($16706);
      throw "Reached an unreachable!"
    case 1573: // $16707
      var $16708=HEAP32[(($4197)>>2)];
      var $16709=HEAP32[(($4197)>>2)];
      var $16710=HEAP32[(($4198)>>2)];
      var $16711=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16709, tempValue);
      var $16712=($16711.f1 = $16710, $16711);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1574: // $16713
      throw "Reached an unreachable!"
    case 1575: // $_ZnwjPKci_exit196
      var $16714=HEAP32[(($result_i195)>>2)];
      var $16715=$4194;
      var $16716=$4195;
      var $16717=$4196;
      var $16718=$result_i195;
      var $16719=$4197;
      var $16720=$4198;
      var $16721=$16714;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5477, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1576; break; } else { __label__ = 12171; break; }
    case 1576: // $16722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5478, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1577; break; } else { __label__ = 12171; break; }
    case 1577: // $16723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5479, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1578; break; } else { __label__ = 12171; break; }
    case 1578: // $16724
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5480, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1579; break; } else { __label__ = 12171; break; }
    case 1579: // $16725
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5481, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1580; break; } else { __label__ = 12171; break; }
    case 1580: // $16726
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1581; break; } else { __label__ = 12171; break; }
    case 1581: // $16727
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1582; break; } else { __label__ = 12171; break; }
    case 1582: // $16728
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5476, $5477, $5478, $5479, $5480, $5481, $5482, $5483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1583; break; } else { __label__ = 12171; break; }
    case 1583: // $16729
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16721, 50, 2, 1, ((STRING_TABLE.__str387)|0), ((STRING_TABLE.__str388)|0), $5476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1584; break; } else { __label__ = 12171; break; }
    case 1584: // $16730
      var $16731=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16721);
      var $16732=__ZN11simple_listI16input_type_entryE6appendERS0_($16682, $16731);
      var $16733=$4689;
      var $16734=$4189;
      var $16735=$4190;
      var $16736=$4191;
      var $16737=$result_i197;
      var $16738=$4192;
      var $16739=$4193;
      HEAP32[(($4189)>>2)]=408;
      HEAP32[(($4190)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4191)>>2)]=154;
      var $16740=HEAP32[(($4189)>>2)];
      var $16741=HEAP32[(($4190)>>2)];
      var $16742=HEAP32[(($4191)>>2)];
      var $16743=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16740, $16741, $16742) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1585; break; } else { __label__ = 1587; break; };
    case 1585: // $16744
      HEAP32[(($result_i197)>>2)]=$16743;
      var $16745=HEAP32[(($result_i197)>>2)];
      var $16746=(($16745)|0)==0;
      if ($16746) { __label__ = 1586; break; } else { __label__ = 1591; break; }
    case 1586: // $16747
      var $16748=___cxa_allocate_exception(4);
      var $16749=$16748;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16749);
      (function() { try { __THREW__ = false; return ___cxa_throw($16748, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1590; break; } else { __label__ = 1587; break; }
    case 1587: // $16750
      var $16751=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16752=$16751.f0;
      HEAP32[(($4192)>>2)]=$16752;
      var $16753=$16751.f1;
      HEAP32[(($4193)>>2)]=$16753;
      var $16754=HEAP32[(($4193)>>2)];
      var $16755=(($16754)|0) < 0;
      if ($16755) { __label__ = 1588; break; } else { __label__ = 1589; break; }
    case 1588: // $16756
      var $16757=HEAP32[(($4192)>>2)];
      ___cxa_call_unexpected($16757);
      throw "Reached an unreachable!"
    case 1589: // $16758
      var $16759=HEAP32[(($4192)>>2)];
      var $16760=HEAP32[(($4192)>>2)];
      var $16761=HEAP32[(($4193)>>2)];
      var $16762=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16760, tempValue);
      var $16763=($16762.f1 = $16761, $16762);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1590: // $16764
      throw "Reached an unreachable!"
    case 1591: // $_ZnwjPKci_exit198
      var $16765=HEAP32[(($result_i197)>>2)];
      var $16766=$4189;
      var $16767=$4190;
      var $16768=$4191;
      var $16769=$result_i197;
      var $16770=$4192;
      var $16771=$4193;
      var $16772=$16765;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5485, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1592; break; } else { __label__ = 12176; break; }
    case 1592: // $16773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5486, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1593; break; } else { __label__ = 12176; break; }
    case 1593: // $16774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5487, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1594; break; } else { __label__ = 12176; break; }
    case 1594: // $16775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1595; break; } else { __label__ = 12176; break; }
    case 1595: // $16776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1596; break; } else { __label__ = 12176; break; }
    case 1596: // $16777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1597; break; } else { __label__ = 12176; break; }
    case 1597: // $16778
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1598; break; } else { __label__ = 12176; break; }
    case 1598: // $16779
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5484, $5485, $5486, $5487, $5488, $5489, $5490, $5491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1599; break; } else { __label__ = 12176; break; }
    case 1599: // $16780
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16772, 51, 2, 1, ((STRING_TABLE.__str389)|0), ((STRING_TABLE.__str390)|0), $5484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1600; break; } else { __label__ = 12176; break; }
    case 1600: // $16781
      var $16782=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16772);
      var $16783=__ZN11simple_listI16input_type_entryE6appendERS0_($16733, $16782);
      var $16784=$4689;
      var $16785=$4184;
      var $16786=$4185;
      var $16787=$4186;
      var $16788=$result_i199;
      var $16789=$4187;
      var $16790=$4188;
      HEAP32[(($4184)>>2)]=408;
      HEAP32[(($4185)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4186)>>2)]=155;
      var $16791=HEAP32[(($4184)>>2)];
      var $16792=HEAP32[(($4185)>>2)];
      var $16793=HEAP32[(($4186)>>2)];
      var $16794=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16791, $16792, $16793) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1601; break; } else { __label__ = 1603; break; };
    case 1601: // $16795
      HEAP32[(($result_i199)>>2)]=$16794;
      var $16796=HEAP32[(($result_i199)>>2)];
      var $16797=(($16796)|0)==0;
      if ($16797) { __label__ = 1602; break; } else { __label__ = 1607; break; }
    case 1602: // $16798
      var $16799=___cxa_allocate_exception(4);
      var $16800=$16799;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16800);
      (function() { try { __THREW__ = false; return ___cxa_throw($16799, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1606; break; } else { __label__ = 1603; break; }
    case 1603: // $16801
      var $16802=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16803=$16802.f0;
      HEAP32[(($4187)>>2)]=$16803;
      var $16804=$16802.f1;
      HEAP32[(($4188)>>2)]=$16804;
      var $16805=HEAP32[(($4188)>>2)];
      var $16806=(($16805)|0) < 0;
      if ($16806) { __label__ = 1604; break; } else { __label__ = 1605; break; }
    case 1604: // $16807
      var $16808=HEAP32[(($4187)>>2)];
      ___cxa_call_unexpected($16808);
      throw "Reached an unreachable!"
    case 1605: // $16809
      var $16810=HEAP32[(($4187)>>2)];
      var $16811=HEAP32[(($4187)>>2)];
      var $16812=HEAP32[(($4188)>>2)];
      var $16813=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16811, tempValue);
      var $16814=($16813.f1 = $16812, $16813);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1606: // $16815
      throw "Reached an unreachable!"
    case 1607: // $_ZnwjPKci_exit200
      var $16816=HEAP32[(($result_i199)>>2)];
      var $16817=$4184;
      var $16818=$4185;
      var $16819=$4186;
      var $16820=$result_i199;
      var $16821=$4187;
      var $16822=$4188;
      var $16823=$16816;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5493, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1608; break; } else { __label__ = 12181; break; }
    case 1608: // $16824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5494, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1609; break; } else { __label__ = 12181; break; }
    case 1609: // $16825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5495, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1610; break; } else { __label__ = 12181; break; }
    case 1610: // $16826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1611; break; } else { __label__ = 12181; break; }
    case 1611: // $16827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1612; break; } else { __label__ = 12181; break; }
    case 1612: // $16828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1613; break; } else { __label__ = 12181; break; }
    case 1613: // $16829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1614; break; } else { __label__ = 12181; break; }
    case 1614: // $16830
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5492, $5493, $5494, $5495, $5496, $5497, $5498, $5499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1615; break; } else { __label__ = 12181; break; }
    case 1615: // $16831
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16823, 52, 2, 1, ((STRING_TABLE.__str391)|0), ((STRING_TABLE.__str392)|0), $5492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1616; break; } else { __label__ = 12181; break; }
    case 1616: // $16832
      var $16833=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16823);
      var $16834=__ZN11simple_listI16input_type_entryE6appendERS0_($16784, $16833);
      var $16835=$4689;
      var $16836=$4179;
      var $16837=$4180;
      var $16838=$4181;
      var $16839=$result_i201;
      var $16840=$4182;
      var $16841=$4183;
      HEAP32[(($4179)>>2)]=408;
      HEAP32[(($4180)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4181)>>2)]=156;
      var $16842=HEAP32[(($4179)>>2)];
      var $16843=HEAP32[(($4180)>>2)];
      var $16844=HEAP32[(($4181)>>2)];
      var $16845=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16842, $16843, $16844) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1617; break; } else { __label__ = 1619; break; };
    case 1617: // $16846
      HEAP32[(($result_i201)>>2)]=$16845;
      var $16847=HEAP32[(($result_i201)>>2)];
      var $16848=(($16847)|0)==0;
      if ($16848) { __label__ = 1618; break; } else { __label__ = 1623; break; }
    case 1618: // $16849
      var $16850=___cxa_allocate_exception(4);
      var $16851=$16850;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16851);
      (function() { try { __THREW__ = false; return ___cxa_throw($16850, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1622; break; } else { __label__ = 1619; break; }
    case 1619: // $16852
      var $16853=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16854=$16853.f0;
      HEAP32[(($4182)>>2)]=$16854;
      var $16855=$16853.f1;
      HEAP32[(($4183)>>2)]=$16855;
      var $16856=HEAP32[(($4183)>>2)];
      var $16857=(($16856)|0) < 0;
      if ($16857) { __label__ = 1620; break; } else { __label__ = 1621; break; }
    case 1620: // $16858
      var $16859=HEAP32[(($4182)>>2)];
      ___cxa_call_unexpected($16859);
      throw "Reached an unreachable!"
    case 1621: // $16860
      var $16861=HEAP32[(($4182)>>2)];
      var $16862=HEAP32[(($4182)>>2)];
      var $16863=HEAP32[(($4183)>>2)];
      var $16864=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16862, tempValue);
      var $16865=($16864.f1 = $16863, $16864);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1622: // $16866
      throw "Reached an unreachable!"
    case 1623: // $_ZnwjPKci_exit202
      var $16867=HEAP32[(($result_i201)>>2)];
      var $16868=$4179;
      var $16869=$4180;
      var $16870=$4181;
      var $16871=$result_i201;
      var $16872=$4182;
      var $16873=$4183;
      var $16874=$16867;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5501, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1624; break; } else { __label__ = 12186; break; }
    case 1624: // $16875
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5502, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1625; break; } else { __label__ = 12186; break; }
    case 1625: // $16876
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5503, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1626; break; } else { __label__ = 12186; break; }
    case 1626: // $16877
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5504, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1627; break; } else { __label__ = 12186; break; }
    case 1627: // $16878
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5505, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1628; break; } else { __label__ = 12186; break; }
    case 1628: // $16879
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1629; break; } else { __label__ = 12186; break; }
    case 1629: // $16880
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1630; break; } else { __label__ = 12186; break; }
    case 1630: // $16881
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5500, $5501, $5502, $5503, $5504, $5505, $5506, $5507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1631; break; } else { __label__ = 12186; break; }
    case 1631: // $16882
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16874, 53, 2, 1, ((STRING_TABLE.__str393)|0), ((STRING_TABLE.__str394)|0), $5500) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1632; break; } else { __label__ = 12186; break; }
    case 1632: // $16883
      var $16884=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16874);
      var $16885=__ZN11simple_listI16input_type_entryE6appendERS0_($16835, $16884);
      var $16886=$4689;
      var $16887=$4174;
      var $16888=$4175;
      var $16889=$4176;
      var $16890=$result_i203;
      var $16891=$4177;
      var $16892=$4178;
      HEAP32[(($4174)>>2)]=408;
      HEAP32[(($4175)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4176)>>2)]=157;
      var $16893=HEAP32[(($4174)>>2)];
      var $16894=HEAP32[(($4175)>>2)];
      var $16895=HEAP32[(($4176)>>2)];
      var $16896=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16893, $16894, $16895) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1633; break; } else { __label__ = 1635; break; };
    case 1633: // $16897
      HEAP32[(($result_i203)>>2)]=$16896;
      var $16898=HEAP32[(($result_i203)>>2)];
      var $16899=(($16898)|0)==0;
      if ($16899) { __label__ = 1634; break; } else { __label__ = 1639; break; }
    case 1634: // $16900
      var $16901=___cxa_allocate_exception(4);
      var $16902=$16901;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16902);
      (function() { try { __THREW__ = false; return ___cxa_throw($16901, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1638; break; } else { __label__ = 1635; break; }
    case 1635: // $16903
      var $16904=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16905=$16904.f0;
      HEAP32[(($4177)>>2)]=$16905;
      var $16906=$16904.f1;
      HEAP32[(($4178)>>2)]=$16906;
      var $16907=HEAP32[(($4178)>>2)];
      var $16908=(($16907)|0) < 0;
      if ($16908) { __label__ = 1636; break; } else { __label__ = 1637; break; }
    case 1636: // $16909
      var $16910=HEAP32[(($4177)>>2)];
      ___cxa_call_unexpected($16910);
      throw "Reached an unreachable!"
    case 1637: // $16911
      var $16912=HEAP32[(($4177)>>2)];
      var $16913=HEAP32[(($4177)>>2)];
      var $16914=HEAP32[(($4178)>>2)];
      var $16915=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16913, tempValue);
      var $16916=($16915.f1 = $16914, $16915);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1638: // $16917
      throw "Reached an unreachable!"
    case 1639: // $_ZnwjPKci_exit204
      var $16918=HEAP32[(($result_i203)>>2)];
      var $16919=$4174;
      var $16920=$4175;
      var $16921=$4176;
      var $16922=$result_i203;
      var $16923=$4177;
      var $16924=$4178;
      var $16925=$16918;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5509, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1640; break; } else { __label__ = 12191; break; }
    case 1640: // $16926
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5510, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1641; break; } else { __label__ = 12191; break; }
    case 1641: // $16927
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5511, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1642; break; } else { __label__ = 12191; break; }
    case 1642: // $16928
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1643; break; } else { __label__ = 12191; break; }
    case 1643: // $16929
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1644; break; } else { __label__ = 12191; break; }
    case 1644: // $16930
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1645; break; } else { __label__ = 12191; break; }
    case 1645: // $16931
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1646; break; } else { __label__ = 12191; break; }
    case 1646: // $16932
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5508, $5509, $5510, $5511, $5512, $5513, $5514, $5515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1647; break; } else { __label__ = 12191; break; }
    case 1647: // $16933
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16925, 54, 2, 1, ((STRING_TABLE.__str395)|0), ((STRING_TABLE.__str396)|0), $5508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1648; break; } else { __label__ = 12191; break; }
    case 1648: // $16934
      var $16935=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16925);
      var $16936=__ZN11simple_listI16input_type_entryE6appendERS0_($16886, $16935);
      var $16937=$4689;
      var $16938=$4169;
      var $16939=$4170;
      var $16940=$4171;
      var $16941=$result_i205;
      var $16942=$4172;
      var $16943=$4173;
      HEAP32[(($4169)>>2)]=408;
      HEAP32[(($4170)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4171)>>2)]=158;
      var $16944=HEAP32[(($4169)>>2)];
      var $16945=HEAP32[(($4170)>>2)];
      var $16946=HEAP32[(($4171)>>2)];
      var $16947=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16944, $16945, $16946) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1649; break; } else { __label__ = 1651; break; };
    case 1649: // $16948
      HEAP32[(($result_i205)>>2)]=$16947;
      var $16949=HEAP32[(($result_i205)>>2)];
      var $16950=(($16949)|0)==0;
      if ($16950) { __label__ = 1650; break; } else { __label__ = 1655; break; }
    case 1650: // $16951
      var $16952=___cxa_allocate_exception(4);
      var $16953=$16952;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($16953);
      (function() { try { __THREW__ = false; return ___cxa_throw($16952, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1654; break; } else { __label__ = 1651; break; }
    case 1651: // $16954
      var $16955=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16956=$16955.f0;
      HEAP32[(($4172)>>2)]=$16956;
      var $16957=$16955.f1;
      HEAP32[(($4173)>>2)]=$16957;
      var $16958=HEAP32[(($4173)>>2)];
      var $16959=(($16958)|0) < 0;
      if ($16959) { __label__ = 1652; break; } else { __label__ = 1653; break; }
    case 1652: // $16960
      var $16961=HEAP32[(($4172)>>2)];
      ___cxa_call_unexpected($16961);
      throw "Reached an unreachable!"
    case 1653: // $16962
      var $16963=HEAP32[(($4172)>>2)];
      var $16964=HEAP32[(($4172)>>2)];
      var $16965=HEAP32[(($4173)>>2)];
      var $16966=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16964, tempValue);
      var $16967=($16966.f1 = $16965, $16966);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1654: // $16968
      throw "Reached an unreachable!"
    case 1655: // $_ZnwjPKci_exit206
      var $16969=HEAP32[(($result_i205)>>2)];
      var $16970=$4169;
      var $16971=$4170;
      var $16972=$4171;
      var $16973=$result_i205;
      var $16974=$4172;
      var $16975=$4173;
      var $16976=$16969;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5517, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1656; break; } else { __label__ = 12196; break; }
    case 1656: // $16977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5518, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1657; break; } else { __label__ = 12196; break; }
    case 1657: // $16978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5519, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1658; break; } else { __label__ = 12196; break; }
    case 1658: // $16979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1659; break; } else { __label__ = 12196; break; }
    case 1659: // $16980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1660; break; } else { __label__ = 12196; break; }
    case 1660: // $16981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1661; break; } else { __label__ = 12196; break; }
    case 1661: // $16982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1662; break; } else { __label__ = 12196; break; }
    case 1662: // $16983
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5516, $5517, $5518, $5519, $5520, $5521, $5522, $5523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1663; break; } else { __label__ = 12196; break; }
    case 1663: // $16984
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($16976, 55, 2, 1, ((STRING_TABLE.__str397)|0), ((STRING_TABLE.__str398)|0), $5516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1664; break; } else { __label__ = 12196; break; }
    case 1664: // $16985
      var $16986=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $16976);
      var $16987=__ZN11simple_listI16input_type_entryE6appendERS0_($16937, $16986);
      var $16988=$4689;
      var $16989=$4164;
      var $16990=$4165;
      var $16991=$4166;
      var $16992=$result_i207;
      var $16993=$4167;
      var $16994=$4168;
      HEAP32[(($4164)>>2)]=408;
      HEAP32[(($4165)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4166)>>2)]=159;
      var $16995=HEAP32[(($4164)>>2)];
      var $16996=HEAP32[(($4165)>>2)];
      var $16997=HEAP32[(($4166)>>2)];
      var $16998=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16995, $16996, $16997) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1665; break; } else { __label__ = 1667; break; };
    case 1665: // $16999
      HEAP32[(($result_i207)>>2)]=$16998;
      var $17000=HEAP32[(($result_i207)>>2)];
      var $17001=(($17000)|0)==0;
      if ($17001) { __label__ = 1666; break; } else { __label__ = 1671; break; }
    case 1666: // $17002
      var $17003=___cxa_allocate_exception(4);
      var $17004=$17003;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17004);
      (function() { try { __THREW__ = false; return ___cxa_throw($17003, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1670; break; } else { __label__ = 1667; break; }
    case 1667: // $17005
      var $17006=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17007=$17006.f0;
      HEAP32[(($4167)>>2)]=$17007;
      var $17008=$17006.f1;
      HEAP32[(($4168)>>2)]=$17008;
      var $17009=HEAP32[(($4168)>>2)];
      var $17010=(($17009)|0) < 0;
      if ($17010) { __label__ = 1668; break; } else { __label__ = 1669; break; }
    case 1668: // $17011
      var $17012=HEAP32[(($4167)>>2)];
      ___cxa_call_unexpected($17012);
      throw "Reached an unreachable!"
    case 1669: // $17013
      var $17014=HEAP32[(($4167)>>2)];
      var $17015=HEAP32[(($4167)>>2)];
      var $17016=HEAP32[(($4168)>>2)];
      var $17017=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17015, tempValue);
      var $17018=($17017.f1 = $17016, $17017);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1670: // $17019
      throw "Reached an unreachable!"
    case 1671: // $_ZnwjPKci_exit208
      var $17020=HEAP32[(($result_i207)>>2)];
      var $17021=$4164;
      var $17022=$4165;
      var $17023=$4166;
      var $17024=$result_i207;
      var $17025=$4167;
      var $17026=$4168;
      var $17027=$17020;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5525, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1672; break; } else { __label__ = 12201; break; }
    case 1672: // $17028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5526, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1673; break; } else { __label__ = 12201; break; }
    case 1673: // $17029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5527, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1674; break; } else { __label__ = 12201; break; }
    case 1674: // $17030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5528, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1675; break; } else { __label__ = 12201; break; }
    case 1675: // $17031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5529, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1676; break; } else { __label__ = 12201; break; }
    case 1676: // $17032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1677; break; } else { __label__ = 12201; break; }
    case 1677: // $17033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1678; break; } else { __label__ = 12201; break; }
    case 1678: // $17034
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5524, $5525, $5526, $5527, $5528, $5529, $5530, $5531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1679; break; } else { __label__ = 12201; break; }
    case 1679: // $17035
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17027, 56, 2, 1, ((STRING_TABLE.__str399)|0), ((STRING_TABLE.__str400)|0), $5524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1680; break; } else { __label__ = 12201; break; }
    case 1680: // $17036
      var $17037=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17027);
      var $17038=__ZN11simple_listI16input_type_entryE6appendERS0_($16988, $17037);
      var $17039=$4689;
      var $17040=$4159;
      var $17041=$4160;
      var $17042=$4161;
      var $17043=$result_i209;
      var $17044=$4162;
      var $17045=$4163;
      HEAP32[(($4159)>>2)]=408;
      HEAP32[(($4160)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4161)>>2)]=160;
      var $17046=HEAP32[(($4159)>>2)];
      var $17047=HEAP32[(($4160)>>2)];
      var $17048=HEAP32[(($4161)>>2)];
      var $17049=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17046, $17047, $17048) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1681; break; } else { __label__ = 1683; break; };
    case 1681: // $17050
      HEAP32[(($result_i209)>>2)]=$17049;
      var $17051=HEAP32[(($result_i209)>>2)];
      var $17052=(($17051)|0)==0;
      if ($17052) { __label__ = 1682; break; } else { __label__ = 1687; break; }
    case 1682: // $17053
      var $17054=___cxa_allocate_exception(4);
      var $17055=$17054;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17055);
      (function() { try { __THREW__ = false; return ___cxa_throw($17054, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1686; break; } else { __label__ = 1683; break; }
    case 1683: // $17056
      var $17057=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17058=$17057.f0;
      HEAP32[(($4162)>>2)]=$17058;
      var $17059=$17057.f1;
      HEAP32[(($4163)>>2)]=$17059;
      var $17060=HEAP32[(($4163)>>2)];
      var $17061=(($17060)|0) < 0;
      if ($17061) { __label__ = 1684; break; } else { __label__ = 1685; break; }
    case 1684: // $17062
      var $17063=HEAP32[(($4162)>>2)];
      ___cxa_call_unexpected($17063);
      throw "Reached an unreachable!"
    case 1685: // $17064
      var $17065=HEAP32[(($4162)>>2)];
      var $17066=HEAP32[(($4162)>>2)];
      var $17067=HEAP32[(($4163)>>2)];
      var $17068=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17066, tempValue);
      var $17069=($17068.f1 = $17067, $17068);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1686: // $17070
      throw "Reached an unreachable!"
    case 1687: // $_ZnwjPKci_exit210
      var $17071=HEAP32[(($result_i209)>>2)];
      var $17072=$4159;
      var $17073=$4160;
      var $17074=$4161;
      var $17075=$result_i209;
      var $17076=$4162;
      var $17077=$4163;
      var $17078=$17071;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5533, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1688; break; } else { __label__ = 12206; break; }
    case 1688: // $17079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5534, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1689; break; } else { __label__ = 12206; break; }
    case 1689: // $17080
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5535, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1690; break; } else { __label__ = 12206; break; }
    case 1690: // $17081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1691; break; } else { __label__ = 12206; break; }
    case 1691: // $17082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1692; break; } else { __label__ = 12206; break; }
    case 1692: // $17083
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1693; break; } else { __label__ = 12206; break; }
    case 1693: // $17084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1694; break; } else { __label__ = 12206; break; }
    case 1694: // $17085
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5532, $5533, $5534, $5535, $5536, $5537, $5538, $5539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1695; break; } else { __label__ = 12206; break; }
    case 1695: // $17086
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17078, 57, 2, 1, ((STRING_TABLE.__str401)|0), ((STRING_TABLE.__str402)|0), $5532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1696; break; } else { __label__ = 12206; break; }
    case 1696: // $17087
      var $17088=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17078);
      var $17089=__ZN11simple_listI16input_type_entryE6appendERS0_($17039, $17088);
      var $17090=$4689;
      var $17091=$4154;
      var $17092=$4155;
      var $17093=$4156;
      var $17094=$result_i211;
      var $17095=$4157;
      var $17096=$4158;
      HEAP32[(($4154)>>2)]=408;
      HEAP32[(($4155)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4156)>>2)]=161;
      var $17097=HEAP32[(($4154)>>2)];
      var $17098=HEAP32[(($4155)>>2)];
      var $17099=HEAP32[(($4156)>>2)];
      var $17100=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17097, $17098, $17099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1697; break; } else { __label__ = 1699; break; };
    case 1697: // $17101
      HEAP32[(($result_i211)>>2)]=$17100;
      var $17102=HEAP32[(($result_i211)>>2)];
      var $17103=(($17102)|0)==0;
      if ($17103) { __label__ = 1698; break; } else { __label__ = 1703; break; }
    case 1698: // $17104
      var $17105=___cxa_allocate_exception(4);
      var $17106=$17105;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17106);
      (function() { try { __THREW__ = false; return ___cxa_throw($17105, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1702; break; } else { __label__ = 1699; break; }
    case 1699: // $17107
      var $17108=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17109=$17108.f0;
      HEAP32[(($4157)>>2)]=$17109;
      var $17110=$17108.f1;
      HEAP32[(($4158)>>2)]=$17110;
      var $17111=HEAP32[(($4158)>>2)];
      var $17112=(($17111)|0) < 0;
      if ($17112) { __label__ = 1700; break; } else { __label__ = 1701; break; }
    case 1700: // $17113
      var $17114=HEAP32[(($4157)>>2)];
      ___cxa_call_unexpected($17114);
      throw "Reached an unreachable!"
    case 1701: // $17115
      var $17116=HEAP32[(($4157)>>2)];
      var $17117=HEAP32[(($4157)>>2)];
      var $17118=HEAP32[(($4158)>>2)];
      var $17119=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17117, tempValue);
      var $17120=($17119.f1 = $17118, $17119);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1702: // $17121
      throw "Reached an unreachable!"
    case 1703: // $_ZnwjPKci_exit212
      var $17122=HEAP32[(($result_i211)>>2)];
      var $17123=$4154;
      var $17124=$4155;
      var $17125=$4156;
      var $17126=$result_i211;
      var $17127=$4157;
      var $17128=$4158;
      var $17129=$17122;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5541, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1704; break; } else { __label__ = 12211; break; }
    case 1704: // $17130
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5542, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1705; break; } else { __label__ = 12211; break; }
    case 1705: // $17131
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5543, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1706; break; } else { __label__ = 12211; break; }
    case 1706: // $17132
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1707; break; } else { __label__ = 12211; break; }
    case 1707: // $17133
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1708; break; } else { __label__ = 12211; break; }
    case 1708: // $17134
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1709; break; } else { __label__ = 12211; break; }
    case 1709: // $17135
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1710; break; } else { __label__ = 12211; break; }
    case 1710: // $17136
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5540, $5541, $5542, $5543, $5544, $5545, $5546, $5547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1711; break; } else { __label__ = 12211; break; }
    case 1711: // $17137
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17129, 58, 2, 1, ((STRING_TABLE.__str403)|0), ((STRING_TABLE.__str404)|0), $5540) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1712; break; } else { __label__ = 12211; break; }
    case 1712: // $17138
      var $17139=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17129);
      var $17140=__ZN11simple_listI16input_type_entryE6appendERS0_($17090, $17139);
      var $17141=$4689;
      var $17142=$4149;
      var $17143=$4150;
      var $17144=$4151;
      var $17145=$result_i213;
      var $17146=$4152;
      var $17147=$4153;
      HEAP32[(($4149)>>2)]=408;
      HEAP32[(($4150)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4151)>>2)]=162;
      var $17148=HEAP32[(($4149)>>2)];
      var $17149=HEAP32[(($4150)>>2)];
      var $17150=HEAP32[(($4151)>>2)];
      var $17151=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17148, $17149, $17150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1713; break; } else { __label__ = 1715; break; };
    case 1713: // $17152
      HEAP32[(($result_i213)>>2)]=$17151;
      var $17153=HEAP32[(($result_i213)>>2)];
      var $17154=(($17153)|0)==0;
      if ($17154) { __label__ = 1714; break; } else { __label__ = 1719; break; }
    case 1714: // $17155
      var $17156=___cxa_allocate_exception(4);
      var $17157=$17156;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17157);
      (function() { try { __THREW__ = false; return ___cxa_throw($17156, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1718; break; } else { __label__ = 1715; break; }
    case 1715: // $17158
      var $17159=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17160=$17159.f0;
      HEAP32[(($4152)>>2)]=$17160;
      var $17161=$17159.f1;
      HEAP32[(($4153)>>2)]=$17161;
      var $17162=HEAP32[(($4153)>>2)];
      var $17163=(($17162)|0) < 0;
      if ($17163) { __label__ = 1716; break; } else { __label__ = 1717; break; }
    case 1716: // $17164
      var $17165=HEAP32[(($4152)>>2)];
      ___cxa_call_unexpected($17165);
      throw "Reached an unreachable!"
    case 1717: // $17166
      var $17167=HEAP32[(($4152)>>2)];
      var $17168=HEAP32[(($4152)>>2)];
      var $17169=HEAP32[(($4153)>>2)];
      var $17170=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17168, tempValue);
      var $17171=($17170.f1 = $17169, $17170);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1718: // $17172
      throw "Reached an unreachable!"
    case 1719: // $_ZnwjPKci_exit214
      var $17173=HEAP32[(($result_i213)>>2)];
      var $17174=$4149;
      var $17175=$4150;
      var $17176=$4151;
      var $17177=$result_i213;
      var $17178=$4152;
      var $17179=$4153;
      var $17180=$17173;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5549, 1, 0, 1, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1720; break; } else { __label__ = 12216; break; }
    case 1720: // $17181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5550, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1721; break; } else { __label__ = 12216; break; }
    case 1721: // $17182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5551, 4, 1, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1722; break; } else { __label__ = 12216; break; }
    case 1722: // $17183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5552, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1723; break; } else { __label__ = 12216; break; }
    case 1723: // $17184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5553, 2, 1, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1724; break; } else { __label__ = 12216; break; }
    case 1724: // $17185
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5554, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1725; break; } else { __label__ = 12216; break; }
    case 1725: // $17186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5555, 3, 1, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1726; break; } else { __label__ = 12216; break; }
    case 1726: // $17187
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5548, $5549, $5550, $5551, $5552, $5553, $5554, $5555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1727; break; } else { __label__ = 12216; break; }
    case 1727: // $17188
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17180, 59, 2, 1, ((STRING_TABLE.__str405)|0), ((STRING_TABLE.__str406)|0), $5548) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1728; break; } else { __label__ = 12216; break; }
    case 1728: // $17189
      var $17190=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17180);
      var $17191=__ZN11simple_listI16input_type_entryE6appendERS0_($17141, $17190);
      var $17192=$4689;
      var $17193=$4144;
      var $17194=$4145;
      var $17195=$4146;
      var $17196=$result_i215;
      var $17197=$4147;
      var $17198=$4148;
      HEAP32[(($4144)>>2)]=408;
      HEAP32[(($4145)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4146)>>2)]=163;
      var $17199=HEAP32[(($4144)>>2)];
      var $17200=HEAP32[(($4145)>>2)];
      var $17201=HEAP32[(($4146)>>2)];
      var $17202=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17199, $17200, $17201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1729; break; } else { __label__ = 1731; break; };
    case 1729: // $17203
      HEAP32[(($result_i215)>>2)]=$17202;
      var $17204=HEAP32[(($result_i215)>>2)];
      var $17205=(($17204)|0)==0;
      if ($17205) { __label__ = 1730; break; } else { __label__ = 1735; break; }
    case 1730: // $17206
      var $17207=___cxa_allocate_exception(4);
      var $17208=$17207;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17208);
      (function() { try { __THREW__ = false; return ___cxa_throw($17207, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1734; break; } else { __label__ = 1731; break; }
    case 1731: // $17209
      var $17210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17211=$17210.f0;
      HEAP32[(($4147)>>2)]=$17211;
      var $17212=$17210.f1;
      HEAP32[(($4148)>>2)]=$17212;
      var $17213=HEAP32[(($4148)>>2)];
      var $17214=(($17213)|0) < 0;
      if ($17214) { __label__ = 1732; break; } else { __label__ = 1733; break; }
    case 1732: // $17215
      var $17216=HEAP32[(($4147)>>2)];
      ___cxa_call_unexpected($17216);
      throw "Reached an unreachable!"
    case 1733: // $17217
      var $17218=HEAP32[(($4147)>>2)];
      var $17219=HEAP32[(($4147)>>2)];
      var $17220=HEAP32[(($4148)>>2)];
      var $17221=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17219, tempValue);
      var $17222=($17221.f1 = $17220, $17221);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1734: // $17223
      throw "Reached an unreachable!"
    case 1735: // $_ZnwjPKci_exit216
      var $17224=HEAP32[(($result_i215)>>2)];
      var $17225=$4144;
      var $17226=$4145;
      var $17227=$4146;
      var $17228=$result_i215;
      var $17229=$4147;
      var $17230=$4148;
      var $17231=$17224;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5557, 1, 0, 1, 0, 19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1736; break; } else { __label__ = 12221; break; }
    case 1736: // $17232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5558, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1737; break; } else { __label__ = 12221; break; }
    case 1737: // $17233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5559, 4, 1, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1738; break; } else { __label__ = 12221; break; }
    case 1738: // $17234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5560, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1739; break; } else { __label__ = 12221; break; }
    case 1739: // $17235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5561, 2, 1, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1740; break; } else { __label__ = 12221; break; }
    case 1740: // $17236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5562, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1741; break; } else { __label__ = 12221; break; }
    case 1741: // $17237
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5563, 3, 1, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1742; break; } else { __label__ = 12221; break; }
    case 1742: // $17238
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5556, $5557, $5558, $5559, $5560, $5561, $5562, $5563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1743; break; } else { __label__ = 12221; break; }
    case 1743: // $17239
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17231, 60, 2, 1, ((STRING_TABLE.__str407)|0), ((STRING_TABLE.__str408)|0), $5556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1744; break; } else { __label__ = 12221; break; }
    case 1744: // $17240
      var $17241=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17231);
      var $17242=__ZN11simple_listI16input_type_entryE6appendERS0_($17192, $17241);
      var $17243=$4689;
      var $17244=$4139;
      var $17245=$4140;
      var $17246=$4141;
      var $17247=$result_i217;
      var $17248=$4142;
      var $17249=$4143;
      HEAP32[(($4139)>>2)]=408;
      HEAP32[(($4140)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4141)>>2)]=164;
      var $17250=HEAP32[(($4139)>>2)];
      var $17251=HEAP32[(($4140)>>2)];
      var $17252=HEAP32[(($4141)>>2)];
      var $17253=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17250, $17251, $17252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1745; break; } else { __label__ = 1747; break; };
    case 1745: // $17254
      HEAP32[(($result_i217)>>2)]=$17253;
      var $17255=HEAP32[(($result_i217)>>2)];
      var $17256=(($17255)|0)==0;
      if ($17256) { __label__ = 1746; break; } else { __label__ = 1751; break; }
    case 1746: // $17257
      var $17258=___cxa_allocate_exception(4);
      var $17259=$17258;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17259);
      (function() { try { __THREW__ = false; return ___cxa_throw($17258, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1750; break; } else { __label__ = 1747; break; }
    case 1747: // $17260
      var $17261=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17262=$17261.f0;
      HEAP32[(($4142)>>2)]=$17262;
      var $17263=$17261.f1;
      HEAP32[(($4143)>>2)]=$17263;
      var $17264=HEAP32[(($4143)>>2)];
      var $17265=(($17264)|0) < 0;
      if ($17265) { __label__ = 1748; break; } else { __label__ = 1749; break; }
    case 1748: // $17266
      var $17267=HEAP32[(($4142)>>2)];
      ___cxa_call_unexpected($17267);
      throw "Reached an unreachable!"
    case 1749: // $17268
      var $17269=HEAP32[(($4142)>>2)];
      var $17270=HEAP32[(($4142)>>2)];
      var $17271=HEAP32[(($4143)>>2)];
      var $17272=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17270, tempValue);
      var $17273=($17272.f1 = $17271, $17272);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1750: // $17274
      throw "Reached an unreachable!"
    case 1751: // $_ZnwjPKci_exit218
      var $17275=HEAP32[(($result_i217)>>2)];
      var $17276=$4139;
      var $17277=$4140;
      var $17278=$4141;
      var $17279=$result_i217;
      var $17280=$4142;
      var $17281=$4143;
      var $17282=$17275;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5565, 1, 0, 1, 0, 17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1752; break; } else { __label__ = 12226; break; }
    case 1752: // $17283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5566, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1753; break; } else { __label__ = 12226; break; }
    case 1753: // $17284
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5567, 4, 1, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1754; break; } else { __label__ = 12226; break; }
    case 1754: // $17285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5568, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1755; break; } else { __label__ = 12226; break; }
    case 1755: // $17286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5569, 2, 1, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1756; break; } else { __label__ = 12226; break; }
    case 1756: // $17287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1757; break; } else { __label__ = 12226; break; }
    case 1757: // $17288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1758; break; } else { __label__ = 12226; break; }
    case 1758: // $17289
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5564, $5565, $5566, $5567, $5568, $5569, $5570, $5571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1759; break; } else { __label__ = 12226; break; }
    case 1759: // $17290
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17282, 61, 2, 1, ((STRING_TABLE.__str409)|0), ((STRING_TABLE.__str410)|0), $5564) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1760; break; } else { __label__ = 12226; break; }
    case 1760: // $17291
      var $17292=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17282);
      var $17293=__ZN11simple_listI16input_type_entryE6appendERS0_($17243, $17292);
      var $17294=$4689;
      var $17295=$4134;
      var $17296=$4135;
      var $17297=$4136;
      var $17298=$result_i219;
      var $17299=$4137;
      var $17300=$4138;
      HEAP32[(($4134)>>2)]=408;
      HEAP32[(($4135)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4136)>>2)]=165;
      var $17301=HEAP32[(($4134)>>2)];
      var $17302=HEAP32[(($4135)>>2)];
      var $17303=HEAP32[(($4136)>>2)];
      var $17304=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17301, $17302, $17303) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1761; break; } else { __label__ = 1763; break; };
    case 1761: // $17305
      HEAP32[(($result_i219)>>2)]=$17304;
      var $17306=HEAP32[(($result_i219)>>2)];
      var $17307=(($17306)|0)==0;
      if ($17307) { __label__ = 1762; break; } else { __label__ = 1767; break; }
    case 1762: // $17308
      var $17309=___cxa_allocate_exception(4);
      var $17310=$17309;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17310);
      (function() { try { __THREW__ = false; return ___cxa_throw($17309, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1766; break; } else { __label__ = 1763; break; }
    case 1763: // $17311
      var $17312=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17313=$17312.f0;
      HEAP32[(($4137)>>2)]=$17313;
      var $17314=$17312.f1;
      HEAP32[(($4138)>>2)]=$17314;
      var $17315=HEAP32[(($4138)>>2)];
      var $17316=(($17315)|0) < 0;
      if ($17316) { __label__ = 1764; break; } else { __label__ = 1765; break; }
    case 1764: // $17317
      var $17318=HEAP32[(($4137)>>2)];
      ___cxa_call_unexpected($17318);
      throw "Reached an unreachable!"
    case 1765: // $17319
      var $17320=HEAP32[(($4137)>>2)];
      var $17321=HEAP32[(($4137)>>2)];
      var $17322=HEAP32[(($4138)>>2)];
      var $17323=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17321, tempValue);
      var $17324=($17323.f1 = $17322, $17323);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1766: // $17325
      throw "Reached an unreachable!"
    case 1767: // $_ZnwjPKci_exit220
      var $17326=HEAP32[(($result_i219)>>2)];
      var $17327=$4134;
      var $17328=$4135;
      var $17329=$4136;
      var $17330=$result_i219;
      var $17331=$4137;
      var $17332=$4138;
      var $17333=$17326;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5573, 1, 0, 1, 0, 23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1768; break; } else { __label__ = 12231; break; }
    case 1768: // $17334
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5574, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1769; break; } else { __label__ = 12231; break; }
    case 1769: // $17335
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5575, 4, 1, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1770; break; } else { __label__ = 12231; break; }
    case 1770: // $17336
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5576, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1771; break; } else { __label__ = 12231; break; }
    case 1771: // $17337
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5577, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1772; break; } else { __label__ = 12231; break; }
    case 1772: // $17338
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1773; break; } else { __label__ = 12231; break; }
    case 1773: // $17339
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1774; break; } else { __label__ = 12231; break; }
    case 1774: // $17340
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5572, $5573, $5574, $5575, $5576, $5577, $5578, $5579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1775; break; } else { __label__ = 12231; break; }
    case 1775: // $17341
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17333, 62, 2, 1, ((STRING_TABLE.__str411)|0), ((STRING_TABLE.__str412)|0), $5572) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1776; break; } else { __label__ = 12231; break; }
    case 1776: // $17342
      var $17343=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17333);
      var $17344=__ZN11simple_listI16input_type_entryE6appendERS0_($17294, $17343);
      var $17345=$4689;
      var $17346=$4129;
      var $17347=$4130;
      var $17348=$4131;
      var $17349=$result_i221;
      var $17350=$4132;
      var $17351=$4133;
      HEAP32[(($4129)>>2)]=408;
      HEAP32[(($4130)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4131)>>2)]=166;
      var $17352=HEAP32[(($4129)>>2)];
      var $17353=HEAP32[(($4130)>>2)];
      var $17354=HEAP32[(($4131)>>2)];
      var $17355=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17352, $17353, $17354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1777; break; } else { __label__ = 1779; break; };
    case 1777: // $17356
      HEAP32[(($result_i221)>>2)]=$17355;
      var $17357=HEAP32[(($result_i221)>>2)];
      var $17358=(($17357)|0)==0;
      if ($17358) { __label__ = 1778; break; } else { __label__ = 1783; break; }
    case 1778: // $17359
      var $17360=___cxa_allocate_exception(4);
      var $17361=$17360;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17361);
      (function() { try { __THREW__ = false; return ___cxa_throw($17360, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1782; break; } else { __label__ = 1779; break; }
    case 1779: // $17362
      var $17363=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17364=$17363.f0;
      HEAP32[(($4132)>>2)]=$17364;
      var $17365=$17363.f1;
      HEAP32[(($4133)>>2)]=$17365;
      var $17366=HEAP32[(($4133)>>2)];
      var $17367=(($17366)|0) < 0;
      if ($17367) { __label__ = 1780; break; } else { __label__ = 1781; break; }
    case 1780: // $17368
      var $17369=HEAP32[(($4132)>>2)];
      ___cxa_call_unexpected($17369);
      throw "Reached an unreachable!"
    case 1781: // $17370
      var $17371=HEAP32[(($4132)>>2)];
      var $17372=HEAP32[(($4132)>>2)];
      var $17373=HEAP32[(($4133)>>2)];
      var $17374=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17372, tempValue);
      var $17375=($17374.f1 = $17373, $17374);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1782: // $17376
      throw "Reached an unreachable!"
    case 1783: // $_ZnwjPKci_exit222
      var $17377=HEAP32[(($result_i221)>>2)];
      var $17378=$4129;
      var $17379=$4130;
      var $17380=$4131;
      var $17381=$result_i221;
      var $17382=$4132;
      var $17383=$4133;
      var $17384=$17377;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5581, 4, 1, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1784; break; } else { __label__ = 12236; break; }
    case 1784: // $17385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5582, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1785; break; } else { __label__ = 12236; break; }
    case 1785: // $17386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5583, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1786; break; } else { __label__ = 12236; break; }
    case 1786: // $17387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1787; break; } else { __label__ = 12236; break; }
    case 1787: // $17388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1788; break; } else { __label__ = 12236; break; }
    case 1788: // $17389
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1789; break; } else { __label__ = 12236; break; }
    case 1789: // $17390
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1790; break; } else { __label__ = 12236; break; }
    case 1790: // $17391
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5580, $5581, $5582, $5583, $5584, $5585, $5586, $5587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1791; break; } else { __label__ = 12236; break; }
    case 1791: // $17392
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17384, 63, 2, 1, ((STRING_TABLE.__str413)|0), ((STRING_TABLE.__str414)|0), $5580) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1792; break; } else { __label__ = 12236; break; }
    case 1792: // $17393
      var $17394=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17384);
      var $17395=__ZN11simple_listI16input_type_entryE6appendERS0_($17345, $17394);
      var $17396=$4689;
      var $17397=$4124;
      var $17398=$4125;
      var $17399=$4126;
      var $17400=$result_i223;
      var $17401=$4127;
      var $17402=$4128;
      HEAP32[(($4124)>>2)]=408;
      HEAP32[(($4125)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4126)>>2)]=167;
      var $17403=HEAP32[(($4124)>>2)];
      var $17404=HEAP32[(($4125)>>2)];
      var $17405=HEAP32[(($4126)>>2)];
      var $17406=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17403, $17404, $17405) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1793; break; } else { __label__ = 1795; break; };
    case 1793: // $17407
      HEAP32[(($result_i223)>>2)]=$17406;
      var $17408=HEAP32[(($result_i223)>>2)];
      var $17409=(($17408)|0)==0;
      if ($17409) { __label__ = 1794; break; } else { __label__ = 1799; break; }
    case 1794: // $17410
      var $17411=___cxa_allocate_exception(4);
      var $17412=$17411;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17412);
      (function() { try { __THREW__ = false; return ___cxa_throw($17411, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1798; break; } else { __label__ = 1795; break; }
    case 1795: // $17413
      var $17414=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17415=$17414.f0;
      HEAP32[(($4127)>>2)]=$17415;
      var $17416=$17414.f1;
      HEAP32[(($4128)>>2)]=$17416;
      var $17417=HEAP32[(($4128)>>2)];
      var $17418=(($17417)|0) < 0;
      if ($17418) { __label__ = 1796; break; } else { __label__ = 1797; break; }
    case 1796: // $17419
      var $17420=HEAP32[(($4127)>>2)];
      ___cxa_call_unexpected($17420);
      throw "Reached an unreachable!"
    case 1797: // $17421
      var $17422=HEAP32[(($4127)>>2)];
      var $17423=HEAP32[(($4127)>>2)];
      var $17424=HEAP32[(($4128)>>2)];
      var $17425=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17423, tempValue);
      var $17426=($17425.f1 = $17424, $17425);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1798: // $17427
      throw "Reached an unreachable!"
    case 1799: // $_ZnwjPKci_exit224
      var $17428=HEAP32[(($result_i223)>>2)];
      var $17429=$4124;
      var $17430=$4125;
      var $17431=$4126;
      var $17432=$result_i223;
      var $17433=$4127;
      var $17434=$4128;
      var $17435=$17428;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5589, 4, 1, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1800; break; } else { __label__ = 12241; break; }
    case 1800: // $17436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5590, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1801; break; } else { __label__ = 12241; break; }
    case 1801: // $17437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5591, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1802; break; } else { __label__ = 12241; break; }
    case 1802: // $17438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1803; break; } else { __label__ = 12241; break; }
    case 1803: // $17439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1804; break; } else { __label__ = 12241; break; }
    case 1804: // $17440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1805; break; } else { __label__ = 12241; break; }
    case 1805: // $17441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1806; break; } else { __label__ = 12241; break; }
    case 1806: // $17442
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5588, $5589, $5590, $5591, $5592, $5593, $5594, $5595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1807; break; } else { __label__ = 12241; break; }
    case 1807: // $17443
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17435, 64, 2, 1, ((STRING_TABLE.__str415409)|0), ((STRING_TABLE.__str416)|0), $5588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1808; break; } else { __label__ = 12241; break; }
    case 1808: // $17444
      var $17445=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17435);
      var $17446=__ZN11simple_listI16input_type_entryE6appendERS0_($17396, $17445);
      var $17447=$4689;
      var $17448=$4119;
      var $17449=$4120;
      var $17450=$4121;
      var $17451=$result_i225;
      var $17452=$4122;
      var $17453=$4123;
      HEAP32[(($4119)>>2)]=408;
      HEAP32[(($4120)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4121)>>2)]=168;
      var $17454=HEAP32[(($4119)>>2)];
      var $17455=HEAP32[(($4120)>>2)];
      var $17456=HEAP32[(($4121)>>2)];
      var $17457=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17454, $17455, $17456) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1809; break; } else { __label__ = 1811; break; };
    case 1809: // $17458
      HEAP32[(($result_i225)>>2)]=$17457;
      var $17459=HEAP32[(($result_i225)>>2)];
      var $17460=(($17459)|0)==0;
      if ($17460) { __label__ = 1810; break; } else { __label__ = 1815; break; }
    case 1810: // $17461
      var $17462=___cxa_allocate_exception(4);
      var $17463=$17462;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17463);
      (function() { try { __THREW__ = false; return ___cxa_throw($17462, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1814; break; } else { __label__ = 1811; break; }
    case 1811: // $17464
      var $17465=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17466=$17465.f0;
      HEAP32[(($4122)>>2)]=$17466;
      var $17467=$17465.f1;
      HEAP32[(($4123)>>2)]=$17467;
      var $17468=HEAP32[(($4123)>>2)];
      var $17469=(($17468)|0) < 0;
      if ($17469) { __label__ = 1812; break; } else { __label__ = 1813; break; }
    case 1812: // $17470
      var $17471=HEAP32[(($4122)>>2)];
      ___cxa_call_unexpected($17471);
      throw "Reached an unreachable!"
    case 1813: // $17472
      var $17473=HEAP32[(($4122)>>2)];
      var $17474=HEAP32[(($4122)>>2)];
      var $17475=HEAP32[(($4123)>>2)];
      var $17476=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17474, tempValue);
      var $17477=($17476.f1 = $17475, $17476);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1814: // $17478
      throw "Reached an unreachable!"
    case 1815: // $_ZnwjPKci_exit226
      var $17479=HEAP32[(($result_i225)>>2)];
      var $17480=$4119;
      var $17481=$4120;
      var $17482=$4121;
      var $17483=$result_i225;
      var $17484=$4122;
      var $17485=$4123;
      var $17486=$17479;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5597, 4, 1, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1816; break; } else { __label__ = 12246; break; }
    case 1816: // $17487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5598, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1817; break; } else { __label__ = 12246; break; }
    case 1817: // $17488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5599, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1818; break; } else { __label__ = 12246; break; }
    case 1818: // $17489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5600, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1819; break; } else { __label__ = 12246; break; }
    case 1819: // $17490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5601, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1820; break; } else { __label__ = 12246; break; }
    case 1820: // $17491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1821; break; } else { __label__ = 12246; break; }
    case 1821: // $17492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1822; break; } else { __label__ = 12246; break; }
    case 1822: // $17493
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5596, $5597, $5598, $5599, $5600, $5601, $5602, $5603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1823; break; } else { __label__ = 12246; break; }
    case 1823: // $17494
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17486, 65, 2, 1, ((STRING_TABLE.__str417)|0), ((STRING_TABLE.__str418)|0), $5596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1824; break; } else { __label__ = 12246; break; }
    case 1824: // $17495
      var $17496=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17486);
      var $17497=__ZN11simple_listI16input_type_entryE6appendERS0_($17447, $17496);
      var $17498=$4689;
      var $17499=$4114;
      var $17500=$4115;
      var $17501=$4116;
      var $17502=$result_i227;
      var $17503=$4117;
      var $17504=$4118;
      HEAP32[(($4114)>>2)]=408;
      HEAP32[(($4115)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4116)>>2)]=169;
      var $17505=HEAP32[(($4114)>>2)];
      var $17506=HEAP32[(($4115)>>2)];
      var $17507=HEAP32[(($4116)>>2)];
      var $17508=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17505, $17506, $17507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1825; break; } else { __label__ = 1827; break; };
    case 1825: // $17509
      HEAP32[(($result_i227)>>2)]=$17508;
      var $17510=HEAP32[(($result_i227)>>2)];
      var $17511=(($17510)|0)==0;
      if ($17511) { __label__ = 1826; break; } else { __label__ = 1831; break; }
    case 1826: // $17512
      var $17513=___cxa_allocate_exception(4);
      var $17514=$17513;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17514);
      (function() { try { __THREW__ = false; return ___cxa_throw($17513, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1830; break; } else { __label__ = 1827; break; }
    case 1827: // $17515
      var $17516=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17517=$17516.f0;
      HEAP32[(($4117)>>2)]=$17517;
      var $17518=$17516.f1;
      HEAP32[(($4118)>>2)]=$17518;
      var $17519=HEAP32[(($4118)>>2)];
      var $17520=(($17519)|0) < 0;
      if ($17520) { __label__ = 1828; break; } else { __label__ = 1829; break; }
    case 1828: // $17521
      var $17522=HEAP32[(($4117)>>2)];
      ___cxa_call_unexpected($17522);
      throw "Reached an unreachable!"
    case 1829: // $17523
      var $17524=HEAP32[(($4117)>>2)];
      var $17525=HEAP32[(($4117)>>2)];
      var $17526=HEAP32[(($4118)>>2)];
      var $17527=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17525, tempValue);
      var $17528=($17527.f1 = $17526, $17527);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1830: // $17529
      throw "Reached an unreachable!"
    case 1831: // $_ZnwjPKci_exit228
      var $17530=HEAP32[(($result_i227)>>2)];
      var $17531=$4114;
      var $17532=$4115;
      var $17533=$4116;
      var $17534=$result_i227;
      var $17535=$4117;
      var $17536=$4118;
      var $17537=$17530;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5605, 4, 1, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1832; break; } else { __label__ = 12251; break; }
    case 1832: // $17538
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5606, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1833; break; } else { __label__ = 12251; break; }
    case 1833: // $17539
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5607, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1834; break; } else { __label__ = 12251; break; }
    case 1834: // $17540
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1835; break; } else { __label__ = 12251; break; }
    case 1835: // $17541
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1836; break; } else { __label__ = 12251; break; }
    case 1836: // $17542
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1837; break; } else { __label__ = 12251; break; }
    case 1837: // $17543
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1838; break; } else { __label__ = 12251; break; }
    case 1838: // $17544
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5604, $5605, $5606, $5607, $5608, $5609, $5610, $5611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1839; break; } else { __label__ = 12251; break; }
    case 1839: // $17545
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17537, 66, 2, 1, ((STRING_TABLE.__str419)|0), ((STRING_TABLE.__str420)|0), $5604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1840; break; } else { __label__ = 12251; break; }
    case 1840: // $17546
      var $17547=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17537);
      var $17548=__ZN11simple_listI16input_type_entryE6appendERS0_($17498, $17547);
      var $17549=$4689;
      var $17550=$4109;
      var $17551=$4110;
      var $17552=$4111;
      var $17553=$result_i229;
      var $17554=$4112;
      var $17555=$4113;
      HEAP32[(($4109)>>2)]=408;
      HEAP32[(($4110)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4111)>>2)]=170;
      var $17556=HEAP32[(($4109)>>2)];
      var $17557=HEAP32[(($4110)>>2)];
      var $17558=HEAP32[(($4111)>>2)];
      var $17559=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17556, $17557, $17558) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1841; break; } else { __label__ = 1843; break; };
    case 1841: // $17560
      HEAP32[(($result_i229)>>2)]=$17559;
      var $17561=HEAP32[(($result_i229)>>2)];
      var $17562=(($17561)|0)==0;
      if ($17562) { __label__ = 1842; break; } else { __label__ = 1847; break; }
    case 1842: // $17563
      var $17564=___cxa_allocate_exception(4);
      var $17565=$17564;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17565);
      (function() { try { __THREW__ = false; return ___cxa_throw($17564, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1846; break; } else { __label__ = 1843; break; }
    case 1843: // $17566
      var $17567=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17568=$17567.f0;
      HEAP32[(($4112)>>2)]=$17568;
      var $17569=$17567.f1;
      HEAP32[(($4113)>>2)]=$17569;
      var $17570=HEAP32[(($4113)>>2)];
      var $17571=(($17570)|0) < 0;
      if ($17571) { __label__ = 1844; break; } else { __label__ = 1845; break; }
    case 1844: // $17572
      var $17573=HEAP32[(($4112)>>2)];
      ___cxa_call_unexpected($17573);
      throw "Reached an unreachable!"
    case 1845: // $17574
      var $17575=HEAP32[(($4112)>>2)];
      var $17576=HEAP32[(($4112)>>2)];
      var $17577=HEAP32[(($4113)>>2)];
      var $17578=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17576, tempValue);
      var $17579=($17578.f1 = $17577, $17578);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1846: // $17580
      throw "Reached an unreachable!"
    case 1847: // $_ZnwjPKci_exit230
      var $17581=HEAP32[(($result_i229)>>2)];
      var $17582=$4109;
      var $17583=$4110;
      var $17584=$4111;
      var $17585=$result_i229;
      var $17586=$4112;
      var $17587=$4113;
      var $17588=$17581;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5613, 4, 1, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1848; break; } else { __label__ = 12256; break; }
    case 1848: // $17589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5614, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1849; break; } else { __label__ = 12256; break; }
    case 1849: // $17590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5615, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1850; break; } else { __label__ = 12256; break; }
    case 1850: // $17591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1851; break; } else { __label__ = 12256; break; }
    case 1851: // $17592
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1852; break; } else { __label__ = 12256; break; }
    case 1852: // $17593
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1853; break; } else { __label__ = 12256; break; }
    case 1853: // $17594
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1854; break; } else { __label__ = 12256; break; }
    case 1854: // $17595
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5612, $5613, $5614, $5615, $5616, $5617, $5618, $5619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1855; break; } else { __label__ = 12256; break; }
    case 1855: // $17596
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17588, 67, 2, 1, ((STRING_TABLE.__str421)|0), ((STRING_TABLE.__str422)|0), $5612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1856; break; } else { __label__ = 12256; break; }
    case 1856: // $17597
      var $17598=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17588);
      var $17599=__ZN11simple_listI16input_type_entryE6appendERS0_($17549, $17598);
      var $17600=$4689;
      var $17601=$4104;
      var $17602=$4105;
      var $17603=$4106;
      var $17604=$result_i231;
      var $17605=$4107;
      var $17606=$4108;
      HEAP32[(($4104)>>2)]=408;
      HEAP32[(($4105)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4106)>>2)]=171;
      var $17607=HEAP32[(($4104)>>2)];
      var $17608=HEAP32[(($4105)>>2)];
      var $17609=HEAP32[(($4106)>>2)];
      var $17610=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17607, $17608, $17609) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1857; break; } else { __label__ = 1859; break; };
    case 1857: // $17611
      HEAP32[(($result_i231)>>2)]=$17610;
      var $17612=HEAP32[(($result_i231)>>2)];
      var $17613=(($17612)|0)==0;
      if ($17613) { __label__ = 1858; break; } else { __label__ = 1863; break; }
    case 1858: // $17614
      var $17615=___cxa_allocate_exception(4);
      var $17616=$17615;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17616);
      (function() { try { __THREW__ = false; return ___cxa_throw($17615, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1862; break; } else { __label__ = 1859; break; }
    case 1859: // $17617
      var $17618=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17619=$17618.f0;
      HEAP32[(($4107)>>2)]=$17619;
      var $17620=$17618.f1;
      HEAP32[(($4108)>>2)]=$17620;
      var $17621=HEAP32[(($4108)>>2)];
      var $17622=(($17621)|0) < 0;
      if ($17622) { __label__ = 1860; break; } else { __label__ = 1861; break; }
    case 1860: // $17623
      var $17624=HEAP32[(($4107)>>2)];
      ___cxa_call_unexpected($17624);
      throw "Reached an unreachable!"
    case 1861: // $17625
      var $17626=HEAP32[(($4107)>>2)];
      var $17627=HEAP32[(($4107)>>2)];
      var $17628=HEAP32[(($4108)>>2)];
      var $17629=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17627, tempValue);
      var $17630=($17629.f1 = $17628, $17629);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1862: // $17631
      throw "Reached an unreachable!"
    case 1863: // $_ZnwjPKci_exit232
      var $17632=HEAP32[(($result_i231)>>2)];
      var $17633=$4104;
      var $17634=$4105;
      var $17635=$4106;
      var $17636=$result_i231;
      var $17637=$4107;
      var $17638=$4108;
      var $17639=$17632;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5621, 4, 1, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1864; break; } else { __label__ = 12261; break; }
    case 1864: // $17640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5622, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1865; break; } else { __label__ = 12261; break; }
    case 1865: // $17641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5623, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1866; break; } else { __label__ = 12261; break; }
    case 1866: // $17642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5624, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1867; break; } else { __label__ = 12261; break; }
    case 1867: // $17643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5625, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1868; break; } else { __label__ = 12261; break; }
    case 1868: // $17644
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1869; break; } else { __label__ = 12261; break; }
    case 1869: // $17645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1870; break; } else { __label__ = 12261; break; }
    case 1870: // $17646
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5620, $5621, $5622, $5623, $5624, $5625, $5626, $5627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1871; break; } else { __label__ = 12261; break; }
    case 1871: // $17647
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17639, 68, 2, 1, ((STRING_TABLE.__str423)|0), ((STRING_TABLE.__str424)|0), $5620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1872; break; } else { __label__ = 12261; break; }
    case 1872: // $17648
      var $17649=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17639);
      var $17650=__ZN11simple_listI16input_type_entryE6appendERS0_($17600, $17649);
      var $17651=$4689;
      var $17652=$4099;
      var $17653=$4100;
      var $17654=$4101;
      var $17655=$result_i233;
      var $17656=$4102;
      var $17657=$4103;
      HEAP32[(($4099)>>2)]=408;
      HEAP32[(($4100)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4101)>>2)]=172;
      var $17658=HEAP32[(($4099)>>2)];
      var $17659=HEAP32[(($4100)>>2)];
      var $17660=HEAP32[(($4101)>>2)];
      var $17661=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17658, $17659, $17660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1873; break; } else { __label__ = 1875; break; };
    case 1873: // $17662
      HEAP32[(($result_i233)>>2)]=$17661;
      var $17663=HEAP32[(($result_i233)>>2)];
      var $17664=(($17663)|0)==0;
      if ($17664) { __label__ = 1874; break; } else { __label__ = 1879; break; }
    case 1874: // $17665
      var $17666=___cxa_allocate_exception(4);
      var $17667=$17666;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17667);
      (function() { try { __THREW__ = false; return ___cxa_throw($17666, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1878; break; } else { __label__ = 1875; break; }
    case 1875: // $17668
      var $17669=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17670=$17669.f0;
      HEAP32[(($4102)>>2)]=$17670;
      var $17671=$17669.f1;
      HEAP32[(($4103)>>2)]=$17671;
      var $17672=HEAP32[(($4103)>>2)];
      var $17673=(($17672)|0) < 0;
      if ($17673) { __label__ = 1876; break; } else { __label__ = 1877; break; }
    case 1876: // $17674
      var $17675=HEAP32[(($4102)>>2)];
      ___cxa_call_unexpected($17675);
      throw "Reached an unreachable!"
    case 1877: // $17676
      var $17677=HEAP32[(($4102)>>2)];
      var $17678=HEAP32[(($4102)>>2)];
      var $17679=HEAP32[(($4103)>>2)];
      var $17680=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17678, tempValue);
      var $17681=($17680.f1 = $17679, $17680);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1878: // $17682
      throw "Reached an unreachable!"
    case 1879: // $_ZnwjPKci_exit234
      var $17683=HEAP32[(($result_i233)>>2)];
      var $17684=$4099;
      var $17685=$4100;
      var $17686=$4101;
      var $17687=$result_i233;
      var $17688=$4102;
      var $17689=$4103;
      var $17690=$17683;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5629, 4, 1, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1880; break; } else { __label__ = 12266; break; }
    case 1880: // $17691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5630, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1881; break; } else { __label__ = 12266; break; }
    case 1881: // $17692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5631, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1882; break; } else { __label__ = 12266; break; }
    case 1882: // $17693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1883; break; } else { __label__ = 12266; break; }
    case 1883: // $17694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1884; break; } else { __label__ = 12266; break; }
    case 1884: // $17695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1885; break; } else { __label__ = 12266; break; }
    case 1885: // $17696
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1886; break; } else { __label__ = 12266; break; }
    case 1886: // $17697
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5628, $5629, $5630, $5631, $5632, $5633, $5634, $5635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1887; break; } else { __label__ = 12266; break; }
    case 1887: // $17698
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17690, 69, 2, 1, ((STRING_TABLE.__str425)|0), ((STRING_TABLE.__str426)|0), $5628) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1888; break; } else { __label__ = 12266; break; }
    case 1888: // $17699
      var $17700=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17690);
      var $17701=__ZN11simple_listI16input_type_entryE6appendERS0_($17651, $17700);
      var $17702=$4689;
      var $17703=$4094;
      var $17704=$4095;
      var $17705=$4096;
      var $17706=$result_i235;
      var $17707=$4097;
      var $17708=$4098;
      HEAP32[(($4094)>>2)]=408;
      HEAP32[(($4095)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4096)>>2)]=173;
      var $17709=HEAP32[(($4094)>>2)];
      var $17710=HEAP32[(($4095)>>2)];
      var $17711=HEAP32[(($4096)>>2)];
      var $17712=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17709, $17710, $17711) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1889; break; } else { __label__ = 1891; break; };
    case 1889: // $17713
      HEAP32[(($result_i235)>>2)]=$17712;
      var $17714=HEAP32[(($result_i235)>>2)];
      var $17715=(($17714)|0)==0;
      if ($17715) { __label__ = 1890; break; } else { __label__ = 1895; break; }
    case 1890: // $17716
      var $17717=___cxa_allocate_exception(4);
      var $17718=$17717;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17718);
      (function() { try { __THREW__ = false; return ___cxa_throw($17717, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1894; break; } else { __label__ = 1891; break; }
    case 1891: // $17719
      var $17720=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17721=$17720.f0;
      HEAP32[(($4097)>>2)]=$17721;
      var $17722=$17720.f1;
      HEAP32[(($4098)>>2)]=$17722;
      var $17723=HEAP32[(($4098)>>2)];
      var $17724=(($17723)|0) < 0;
      if ($17724) { __label__ = 1892; break; } else { __label__ = 1893; break; }
    case 1892: // $17725
      var $17726=HEAP32[(($4097)>>2)];
      ___cxa_call_unexpected($17726);
      throw "Reached an unreachable!"
    case 1893: // $17727
      var $17728=HEAP32[(($4097)>>2)];
      var $17729=HEAP32[(($4097)>>2)];
      var $17730=HEAP32[(($4098)>>2)];
      var $17731=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17729, tempValue);
      var $17732=($17731.f1 = $17730, $17731);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1894: // $17733
      throw "Reached an unreachable!"
    case 1895: // $_ZnwjPKci_exit236
      var $17734=HEAP32[(($result_i235)>>2)];
      var $17735=$4094;
      var $17736=$4095;
      var $17737=$4096;
      var $17738=$result_i235;
      var $17739=$4097;
      var $17740=$4098;
      var $17741=$17734;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5637, 4, 1, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1896; break; } else { __label__ = 12271; break; }
    case 1896: // $17742
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5638, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1897; break; } else { __label__ = 12271; break; }
    case 1897: // $17743
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5639, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1898; break; } else { __label__ = 12271; break; }
    case 1898: // $17744
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1899; break; } else { __label__ = 12271; break; }
    case 1899: // $17745
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1900; break; } else { __label__ = 12271; break; }
    case 1900: // $17746
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1901; break; } else { __label__ = 12271; break; }
    case 1901: // $17747
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1902; break; } else { __label__ = 12271; break; }
    case 1902: // $17748
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5636, $5637, $5638, $5639, $5640, $5641, $5642, $5643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1903; break; } else { __label__ = 12271; break; }
    case 1903: // $17749
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17741, 70, 2, 1, ((STRING_TABLE.__str427)|0), ((STRING_TABLE.__str428)|0), $5636) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1904; break; } else { __label__ = 12271; break; }
    case 1904: // $17750
      var $17751=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17741);
      var $17752=__ZN11simple_listI16input_type_entryE6appendERS0_($17702, $17751);
      var $17753=$4689;
      var $17754=$4089;
      var $17755=$4090;
      var $17756=$4091;
      var $17757=$result_i237;
      var $17758=$4092;
      var $17759=$4093;
      HEAP32[(($4089)>>2)]=408;
      HEAP32[(($4090)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4091)>>2)]=174;
      var $17760=HEAP32[(($4089)>>2)];
      var $17761=HEAP32[(($4090)>>2)];
      var $17762=HEAP32[(($4091)>>2)];
      var $17763=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17760, $17761, $17762) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1905; break; } else { __label__ = 1907; break; };
    case 1905: // $17764
      HEAP32[(($result_i237)>>2)]=$17763;
      var $17765=HEAP32[(($result_i237)>>2)];
      var $17766=(($17765)|0)==0;
      if ($17766) { __label__ = 1906; break; } else { __label__ = 1911; break; }
    case 1906: // $17767
      var $17768=___cxa_allocate_exception(4);
      var $17769=$17768;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17769);
      (function() { try { __THREW__ = false; return ___cxa_throw($17768, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1910; break; } else { __label__ = 1907; break; }
    case 1907: // $17770
      var $17771=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17772=$17771.f0;
      HEAP32[(($4092)>>2)]=$17772;
      var $17773=$17771.f1;
      HEAP32[(($4093)>>2)]=$17773;
      var $17774=HEAP32[(($4093)>>2)];
      var $17775=(($17774)|0) < 0;
      if ($17775) { __label__ = 1908; break; } else { __label__ = 1909; break; }
    case 1908: // $17776
      var $17777=HEAP32[(($4092)>>2)];
      ___cxa_call_unexpected($17777);
      throw "Reached an unreachable!"
    case 1909: // $17778
      var $17779=HEAP32[(($4092)>>2)];
      var $17780=HEAP32[(($4092)>>2)];
      var $17781=HEAP32[(($4093)>>2)];
      var $17782=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17780, tempValue);
      var $17783=($17782.f1 = $17781, $17782);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1910: // $17784
      throw "Reached an unreachable!"
    case 1911: // $_ZnwjPKci_exit238
      var $17785=HEAP32[(($result_i237)>>2)];
      var $17786=$4089;
      var $17787=$4090;
      var $17788=$4091;
      var $17789=$result_i237;
      var $17790=$4092;
      var $17791=$4093;
      var $17792=$17785;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5645, 4, 1, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1912; break; } else { __label__ = 12276; break; }
    case 1912: // $17793
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5646, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1913; break; } else { __label__ = 12276; break; }
    case 1913: // $17794
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5647, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1914; break; } else { __label__ = 12276; break; }
    case 1914: // $17795
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5648, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1915; break; } else { __label__ = 12276; break; }
    case 1915: // $17796
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5649, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1916; break; } else { __label__ = 12276; break; }
    case 1916: // $17797
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1917; break; } else { __label__ = 12276; break; }
    case 1917: // $17798
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1918; break; } else { __label__ = 12276; break; }
    case 1918: // $17799
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5644, $5645, $5646, $5647, $5648, $5649, $5650, $5651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1919; break; } else { __label__ = 12276; break; }
    case 1919: // $17800
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17792, 71, 2, 1, ((STRING_TABLE.__str429)|0), ((STRING_TABLE.__str430)|0), $5644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1920; break; } else { __label__ = 12276; break; }
    case 1920: // $17801
      var $17802=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17792);
      var $17803=__ZN11simple_listI16input_type_entryE6appendERS0_($17753, $17802);
      var $17804=$4689;
      var $17805=$4084;
      var $17806=$4085;
      var $17807=$4086;
      var $17808=$result_i239;
      var $17809=$4087;
      var $17810=$4088;
      HEAP32[(($4084)>>2)]=408;
      HEAP32[(($4085)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4086)>>2)]=175;
      var $17811=HEAP32[(($4084)>>2)];
      var $17812=HEAP32[(($4085)>>2)];
      var $17813=HEAP32[(($4086)>>2)];
      var $17814=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17811, $17812, $17813) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1921; break; } else { __label__ = 1923; break; };
    case 1921: // $17815
      HEAP32[(($result_i239)>>2)]=$17814;
      var $17816=HEAP32[(($result_i239)>>2)];
      var $17817=(($17816)|0)==0;
      if ($17817) { __label__ = 1922; break; } else { __label__ = 1927; break; }
    case 1922: // $17818
      var $17819=___cxa_allocate_exception(4);
      var $17820=$17819;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17820);
      (function() { try { __THREW__ = false; return ___cxa_throw($17819, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1926; break; } else { __label__ = 1923; break; }
    case 1923: // $17821
      var $17822=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17823=$17822.f0;
      HEAP32[(($4087)>>2)]=$17823;
      var $17824=$17822.f1;
      HEAP32[(($4088)>>2)]=$17824;
      var $17825=HEAP32[(($4088)>>2)];
      var $17826=(($17825)|0) < 0;
      if ($17826) { __label__ = 1924; break; } else { __label__ = 1925; break; }
    case 1924: // $17827
      var $17828=HEAP32[(($4087)>>2)];
      ___cxa_call_unexpected($17828);
      throw "Reached an unreachable!"
    case 1925: // $17829
      var $17830=HEAP32[(($4087)>>2)];
      var $17831=HEAP32[(($4087)>>2)];
      var $17832=HEAP32[(($4088)>>2)];
      var $17833=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17831, tempValue);
      var $17834=($17833.f1 = $17832, $17833);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1926: // $17835
      throw "Reached an unreachable!"
    case 1927: // $_ZnwjPKci_exit240
      var $17836=HEAP32[(($result_i239)>>2)];
      var $17837=$4084;
      var $17838=$4085;
      var $17839=$4086;
      var $17840=$result_i239;
      var $17841=$4087;
      var $17842=$4088;
      var $17843=$17836;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5653, 4, 1, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1928; break; } else { __label__ = 12281; break; }
    case 1928: // $17844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5654, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1929; break; } else { __label__ = 12281; break; }
    case 1929: // $17845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5655, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1930; break; } else { __label__ = 12281; break; }
    case 1930: // $17846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1931; break; } else { __label__ = 12281; break; }
    case 1931: // $17847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1932; break; } else { __label__ = 12281; break; }
    case 1932: // $17848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1933; break; } else { __label__ = 12281; break; }
    case 1933: // $17849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1934; break; } else { __label__ = 12281; break; }
    case 1934: // $17850
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5652, $5653, $5654, $5655, $5656, $5657, $5658, $5659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1935; break; } else { __label__ = 12281; break; }
    case 1935: // $17851
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17843, 72, 2, 1, ((STRING_TABLE.__str431)|0), ((STRING_TABLE.__str432)|0), $5652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1936; break; } else { __label__ = 12281; break; }
    case 1936: // $17852
      var $17853=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17843);
      var $17854=__ZN11simple_listI16input_type_entryE6appendERS0_($17804, $17853);
      var $17855=$4689;
      var $17856=$4079;
      var $17857=$4080;
      var $17858=$4081;
      var $17859=$result_i241;
      var $17860=$4082;
      var $17861=$4083;
      HEAP32[(($4079)>>2)]=408;
      HEAP32[(($4080)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4081)>>2)]=176;
      var $17862=HEAP32[(($4079)>>2)];
      var $17863=HEAP32[(($4080)>>2)];
      var $17864=HEAP32[(($4081)>>2)];
      var $17865=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17862, $17863, $17864) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1937; break; } else { __label__ = 1939; break; };
    case 1937: // $17866
      HEAP32[(($result_i241)>>2)]=$17865;
      var $17867=HEAP32[(($result_i241)>>2)];
      var $17868=(($17867)|0)==0;
      if ($17868) { __label__ = 1938; break; } else { __label__ = 1943; break; }
    case 1938: // $17869
      var $17870=___cxa_allocate_exception(4);
      var $17871=$17870;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17871);
      (function() { try { __THREW__ = false; return ___cxa_throw($17870, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1942; break; } else { __label__ = 1939; break; }
    case 1939: // $17872
      var $17873=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17874=$17873.f0;
      HEAP32[(($4082)>>2)]=$17874;
      var $17875=$17873.f1;
      HEAP32[(($4083)>>2)]=$17875;
      var $17876=HEAP32[(($4083)>>2)];
      var $17877=(($17876)|0) < 0;
      if ($17877) { __label__ = 1940; break; } else { __label__ = 1941; break; }
    case 1940: // $17878
      var $17879=HEAP32[(($4082)>>2)];
      ___cxa_call_unexpected($17879);
      throw "Reached an unreachable!"
    case 1941: // $17880
      var $17881=HEAP32[(($4082)>>2)];
      var $17882=HEAP32[(($4082)>>2)];
      var $17883=HEAP32[(($4083)>>2)];
      var $17884=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17882, tempValue);
      var $17885=($17884.f1 = $17883, $17884);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1942: // $17886
      throw "Reached an unreachable!"
    case 1943: // $_ZnwjPKci_exit242
      var $17887=HEAP32[(($result_i241)>>2)];
      var $17888=$4079;
      var $17889=$4080;
      var $17890=$4081;
      var $17891=$result_i241;
      var $17892=$4082;
      var $17893=$4083;
      var $17894=$17887;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5661, 4, 1, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1944; break; } else { __label__ = 12286; break; }
    case 1944: // $17895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5662, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1945; break; } else { __label__ = 12286; break; }
    case 1945: // $17896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5663, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1946; break; } else { __label__ = 12286; break; }
    case 1946: // $17897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1947; break; } else { __label__ = 12286; break; }
    case 1947: // $17898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1948; break; } else { __label__ = 12286; break; }
    case 1948: // $17899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1949; break; } else { __label__ = 12286; break; }
    case 1949: // $17900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1950; break; } else { __label__ = 12286; break; }
    case 1950: // $17901
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5660, $5661, $5662, $5663, $5664, $5665, $5666, $5667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1951; break; } else { __label__ = 12286; break; }
    case 1951: // $17902
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17894, 73, 2, 1, ((STRING_TABLE.__str433)|0), ((STRING_TABLE.__str434)|0), $5660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1952; break; } else { __label__ = 12286; break; }
    case 1952: // $17903
      var $17904=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17894);
      var $17905=__ZN11simple_listI16input_type_entryE6appendERS0_($17855, $17904);
      var $17906=$4689;
      var $17907=$4074;
      var $17908=$4075;
      var $17909=$4076;
      var $17910=$result_i243;
      var $17911=$4077;
      var $17912=$4078;
      HEAP32[(($4074)>>2)]=408;
      HEAP32[(($4075)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4076)>>2)]=177;
      var $17913=HEAP32[(($4074)>>2)];
      var $17914=HEAP32[(($4075)>>2)];
      var $17915=HEAP32[(($4076)>>2)];
      var $17916=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17913, $17914, $17915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1953; break; } else { __label__ = 1955; break; };
    case 1953: // $17917
      HEAP32[(($result_i243)>>2)]=$17916;
      var $17918=HEAP32[(($result_i243)>>2)];
      var $17919=(($17918)|0)==0;
      if ($17919) { __label__ = 1954; break; } else { __label__ = 1959; break; }
    case 1954: // $17920
      var $17921=___cxa_allocate_exception(4);
      var $17922=$17921;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17922);
      (function() { try { __THREW__ = false; return ___cxa_throw($17921, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1958; break; } else { __label__ = 1955; break; }
    case 1955: // $17923
      var $17924=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17925=$17924.f0;
      HEAP32[(($4077)>>2)]=$17925;
      var $17926=$17924.f1;
      HEAP32[(($4078)>>2)]=$17926;
      var $17927=HEAP32[(($4078)>>2)];
      var $17928=(($17927)|0) < 0;
      if ($17928) { __label__ = 1956; break; } else { __label__ = 1957; break; }
    case 1956: // $17929
      var $17930=HEAP32[(($4077)>>2)];
      ___cxa_call_unexpected($17930);
      throw "Reached an unreachable!"
    case 1957: // $17931
      var $17932=HEAP32[(($4077)>>2)];
      var $17933=HEAP32[(($4077)>>2)];
      var $17934=HEAP32[(($4078)>>2)];
      var $17935=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17933, tempValue);
      var $17936=($17935.f1 = $17934, $17935);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1958: // $17937
      throw "Reached an unreachable!"
    case 1959: // $_ZnwjPKci_exit244
      var $17938=HEAP32[(($result_i243)>>2)];
      var $17939=$4074;
      var $17940=$4075;
      var $17941=$4076;
      var $17942=$result_i243;
      var $17943=$4077;
      var $17944=$4078;
      var $17945=$17938;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5669, 4, 1, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1960; break; } else { __label__ = 12291; break; }
    case 1960: // $17946
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5670, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1961; break; } else { __label__ = 12291; break; }
    case 1961: // $17947
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5671, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1962; break; } else { __label__ = 12291; break; }
    case 1962: // $17948
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5672, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1963; break; } else { __label__ = 12291; break; }
    case 1963: // $17949
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5673, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1964; break; } else { __label__ = 12291; break; }
    case 1964: // $17950
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1965; break; } else { __label__ = 12291; break; }
    case 1965: // $17951
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1966; break; } else { __label__ = 12291; break; }
    case 1966: // $17952
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5668, $5669, $5670, $5671, $5672, $5673, $5674, $5675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1967; break; } else { __label__ = 12291; break; }
    case 1967: // $17953
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17945, 74, 2, 1, ((STRING_TABLE.__str435)|0), ((STRING_TABLE.__str436)|0), $5668) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1968; break; } else { __label__ = 12291; break; }
    case 1968: // $17954
      var $17955=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17945);
      var $17956=__ZN11simple_listI16input_type_entryE6appendERS0_($17906, $17955);
      var $17957=$4689;
      var $17958=$4069;
      var $17959=$4070;
      var $17960=$4071;
      var $17961=$result_i245;
      var $17962=$4072;
      var $17963=$4073;
      HEAP32[(($4069)>>2)]=408;
      HEAP32[(($4070)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4071)>>2)]=178;
      var $17964=HEAP32[(($4069)>>2)];
      var $17965=HEAP32[(($4070)>>2)];
      var $17966=HEAP32[(($4071)>>2)];
      var $17967=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17964, $17965, $17966) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1969; break; } else { __label__ = 1971; break; };
    case 1969: // $17968
      HEAP32[(($result_i245)>>2)]=$17967;
      var $17969=HEAP32[(($result_i245)>>2)];
      var $17970=(($17969)|0)==0;
      if ($17970) { __label__ = 1970; break; } else { __label__ = 1975; break; }
    case 1970: // $17971
      var $17972=___cxa_allocate_exception(4);
      var $17973=$17972;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($17973);
      (function() { try { __THREW__ = false; return ___cxa_throw($17972, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1974; break; } else { __label__ = 1971; break; }
    case 1971: // $17974
      var $17975=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17976=$17975.f0;
      HEAP32[(($4072)>>2)]=$17976;
      var $17977=$17975.f1;
      HEAP32[(($4073)>>2)]=$17977;
      var $17978=HEAP32[(($4073)>>2)];
      var $17979=(($17978)|0) < 0;
      if ($17979) { __label__ = 1972; break; } else { __label__ = 1973; break; }
    case 1972: // $17980
      var $17981=HEAP32[(($4072)>>2)];
      ___cxa_call_unexpected($17981);
      throw "Reached an unreachable!"
    case 1973: // $17982
      var $17983=HEAP32[(($4072)>>2)];
      var $17984=HEAP32[(($4072)>>2)];
      var $17985=HEAP32[(($4073)>>2)];
      var $17986=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17984, tempValue);
      var $17987=($17986.f1 = $17985, $17986);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1974: // $17988
      throw "Reached an unreachable!"
    case 1975: // $_ZnwjPKci_exit246
      var $17989=HEAP32[(($result_i245)>>2)];
      var $17990=$4069;
      var $17991=$4070;
      var $17992=$4071;
      var $17993=$result_i245;
      var $17994=$4072;
      var $17995=$4073;
      var $17996=$17989;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5677, 1, 0, 1, 0, 29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1976; break; } else { __label__ = 12296; break; }
    case 1976: // $17997
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5678, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1977; break; } else { __label__ = 12296; break; }
    case 1977: // $17998
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5679, 4, 1, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1978; break; } else { __label__ = 12296; break; }
    case 1978: // $17999
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1979; break; } else { __label__ = 12296; break; }
    case 1979: // $18000
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1980; break; } else { __label__ = 12296; break; }
    case 1980: // $18001
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1981; break; } else { __label__ = 12296; break; }
    case 1981: // $18002
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1982; break; } else { __label__ = 12296; break; }
    case 1982: // $18003
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5676, $5677, $5678, $5679, $5680, $5681, $5682, $5683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1983; break; } else { __label__ = 12296; break; }
    case 1983: // $18004
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($17996, 43, 2, 1, ((STRING_TABLE.__str437)|0), ((STRING_TABLE.__str438)|0), $5676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1984; break; } else { __label__ = 12296; break; }
    case 1984: // $18005
      var $18006=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $17996);
      var $18007=__ZN11simple_listI16input_type_entryE6appendERS0_($17957, $18006);
      var $18008=$4689;
      var $18009=$4064;
      var $18010=$4065;
      var $18011=$4066;
      var $18012=$result_i247;
      var $18013=$4067;
      var $18014=$4068;
      HEAP32[(($4064)>>2)]=408;
      HEAP32[(($4065)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4066)>>2)]=179;
      var $18015=HEAP32[(($4064)>>2)];
      var $18016=HEAP32[(($4065)>>2)];
      var $18017=HEAP32[(($4066)>>2)];
      var $18018=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18015, $18016, $18017) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1985; break; } else { __label__ = 1987; break; };
    case 1985: // $18019
      HEAP32[(($result_i247)>>2)]=$18018;
      var $18020=HEAP32[(($result_i247)>>2)];
      var $18021=(($18020)|0)==0;
      if ($18021) { __label__ = 1986; break; } else { __label__ = 1991; break; }
    case 1986: // $18022
      var $18023=___cxa_allocate_exception(4);
      var $18024=$18023;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18024);
      (function() { try { __THREW__ = false; return ___cxa_throw($18023, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1990; break; } else { __label__ = 1987; break; }
    case 1987: // $18025
      var $18026=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18027=$18026.f0;
      HEAP32[(($4067)>>2)]=$18027;
      var $18028=$18026.f1;
      HEAP32[(($4068)>>2)]=$18028;
      var $18029=HEAP32[(($4068)>>2)];
      var $18030=(($18029)|0) < 0;
      if ($18030) { __label__ = 1988; break; } else { __label__ = 1989; break; }
    case 1988: // $18031
      var $18032=HEAP32[(($4067)>>2)];
      ___cxa_call_unexpected($18032);
      throw "Reached an unreachable!"
    case 1989: // $18033
      var $18034=HEAP32[(($4067)>>2)];
      var $18035=HEAP32[(($4067)>>2)];
      var $18036=HEAP32[(($4068)>>2)];
      var $18037=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18035, tempValue);
      var $18038=($18037.f1 = $18036, $18037);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 1990: // $18039
      throw "Reached an unreachable!"
    case 1991: // $_ZnwjPKci_exit248
      var $18040=HEAP32[(($result_i247)>>2)];
      var $18041=$4064;
      var $18042=$4065;
      var $18043=$4066;
      var $18044=$result_i247;
      var $18045=$4067;
      var $18046=$4068;
      var $18047=$18040;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5685, 1, 0, 1, 0, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1992; break; } else { __label__ = 12301; break; }
    case 1992: // $18048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5686, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1993; break; } else { __label__ = 12301; break; }
    case 1993: // $18049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5687, 4, 1, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1994; break; } else { __label__ = 12301; break; }
    case 1994: // $18050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5688, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1995; break; } else { __label__ = 12301; break; }
    case 1995: // $18051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5689, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1996; break; } else { __label__ = 12301; break; }
    case 1996: // $18052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5690, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1997; break; } else { __label__ = 12301; break; }
    case 1997: // $18053
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5691, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1998; break; } else { __label__ = 12301; break; }
    case 1998: // $18054
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5684, $5685, $5686, $5687, $5688, $5689, $5690, $5691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1999; break; } else { __label__ = 12301; break; }
    case 1999: // $18055
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18047, 44, 2, 1, ((STRING_TABLE.__str439)|0), ((STRING_TABLE.__str440)|0), $5684) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2000; break; } else { __label__ = 12301; break; }
    case 2000: // $18056
      var $18057=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18047);
      var $18058=__ZN11simple_listI16input_type_entryE6appendERS0_($18008, $18057);
      var $18059=$4689;
      var $18060=$4059;
      var $18061=$4060;
      var $18062=$4061;
      var $18063=$result_i249;
      var $18064=$4062;
      var $18065=$4063;
      HEAP32[(($4059)>>2)]=408;
      HEAP32[(($4060)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4061)>>2)]=180;
      var $18066=HEAP32[(($4059)>>2)];
      var $18067=HEAP32[(($4060)>>2)];
      var $18068=HEAP32[(($4061)>>2)];
      var $18069=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18066, $18067, $18068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2001; break; } else { __label__ = 2003; break; };
    case 2001: // $18070
      HEAP32[(($result_i249)>>2)]=$18069;
      var $18071=HEAP32[(($result_i249)>>2)];
      var $18072=(($18071)|0)==0;
      if ($18072) { __label__ = 2002; break; } else { __label__ = 2007; break; }
    case 2002: // $18073
      var $18074=___cxa_allocate_exception(4);
      var $18075=$18074;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18075);
      (function() { try { __THREW__ = false; return ___cxa_throw($18074, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2006; break; } else { __label__ = 2003; break; }
    case 2003: // $18076
      var $18077=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18078=$18077.f0;
      HEAP32[(($4062)>>2)]=$18078;
      var $18079=$18077.f1;
      HEAP32[(($4063)>>2)]=$18079;
      var $18080=HEAP32[(($4063)>>2)];
      var $18081=(($18080)|0) < 0;
      if ($18081) { __label__ = 2004; break; } else { __label__ = 2005; break; }
    case 2004: // $18082
      var $18083=HEAP32[(($4062)>>2)];
      ___cxa_call_unexpected($18083);
      throw "Reached an unreachable!"
    case 2005: // $18084
      var $18085=HEAP32[(($4062)>>2)];
      var $18086=HEAP32[(($4062)>>2)];
      var $18087=HEAP32[(($4063)>>2)];
      var $18088=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18086, tempValue);
      var $18089=($18088.f1 = $18087, $18088);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2006: // $18090
      throw "Reached an unreachable!"
    case 2007: // $_ZnwjPKci_exit250
      var $18091=HEAP32[(($result_i249)>>2)];
      var $18092=$4059;
      var $18093=$4060;
      var $18094=$4061;
      var $18095=$result_i249;
      var $18096=$4062;
      var $18097=$4063;
      var $18098=$18091;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5693, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2008; break; } else { __label__ = 12306; break; }
    case 2008: // $18099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5694, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2009; break; } else { __label__ = 12306; break; }
    case 2009: // $18100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5695, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2010; break; } else { __label__ = 12306; break; }
    case 2010: // $18101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5696, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2011; break; } else { __label__ = 12306; break; }
    case 2011: // $18102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5697, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2012; break; } else { __label__ = 12306; break; }
    case 2012: // $18103
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2013; break; } else { __label__ = 12306; break; }
    case 2013: // $18104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2014; break; } else { __label__ = 12306; break; }
    case 2014: // $18105
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5692, $5693, $5694, $5695, $5696, $5697, $5698, $5699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2015; break; } else { __label__ = 12306; break; }
    case 2015: // $18106
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18098, 75, 2, 1, ((STRING_TABLE.__str441)|0), ((STRING_TABLE.__str442)|0), $5692) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2016; break; } else { __label__ = 12306; break; }
    case 2016: // $18107
      var $18108=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18098);
      var $18109=__ZN11simple_listI16input_type_entryE6appendERS0_($18059, $18108);
      var $18110=$4689;
      var $18111=$4054;
      var $18112=$4055;
      var $18113=$4056;
      var $18114=$result_i251;
      var $18115=$4057;
      var $18116=$4058;
      HEAP32[(($4054)>>2)]=408;
      HEAP32[(($4055)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4056)>>2)]=181;
      var $18117=HEAP32[(($4054)>>2)];
      var $18118=HEAP32[(($4055)>>2)];
      var $18119=HEAP32[(($4056)>>2)];
      var $18120=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18117, $18118, $18119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2017; break; } else { __label__ = 2019; break; };
    case 2017: // $18121
      HEAP32[(($result_i251)>>2)]=$18120;
      var $18122=HEAP32[(($result_i251)>>2)];
      var $18123=(($18122)|0)==0;
      if ($18123) { __label__ = 2018; break; } else { __label__ = 2023; break; }
    case 2018: // $18124
      var $18125=___cxa_allocate_exception(4);
      var $18126=$18125;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18126);
      (function() { try { __THREW__ = false; return ___cxa_throw($18125, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2022; break; } else { __label__ = 2019; break; }
    case 2019: // $18127
      var $18128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18129=$18128.f0;
      HEAP32[(($4057)>>2)]=$18129;
      var $18130=$18128.f1;
      HEAP32[(($4058)>>2)]=$18130;
      var $18131=HEAP32[(($4058)>>2)];
      var $18132=(($18131)|0) < 0;
      if ($18132) { __label__ = 2020; break; } else { __label__ = 2021; break; }
    case 2020: // $18133
      var $18134=HEAP32[(($4057)>>2)];
      ___cxa_call_unexpected($18134);
      throw "Reached an unreachable!"
    case 2021: // $18135
      var $18136=HEAP32[(($4057)>>2)];
      var $18137=HEAP32[(($4057)>>2)];
      var $18138=HEAP32[(($4058)>>2)];
      var $18139=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18137, tempValue);
      var $18140=($18139.f1 = $18138, $18139);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2022: // $18141
      throw "Reached an unreachable!"
    case 2023: // $_ZnwjPKci_exit252
      var $18142=HEAP32[(($result_i251)>>2)];
      var $18143=$4054;
      var $18144=$4055;
      var $18145=$4056;
      var $18146=$result_i251;
      var $18147=$4057;
      var $18148=$4058;
      var $18149=$18142;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5701, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2024; break; } else { __label__ = 12311; break; }
    case 2024: // $18150
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5702, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2025; break; } else { __label__ = 12311; break; }
    case 2025: // $18151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5703, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2026; break; } else { __label__ = 12311; break; }
    case 2026: // $18152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2027; break; } else { __label__ = 12311; break; }
    case 2027: // $18153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2028; break; } else { __label__ = 12311; break; }
    case 2028: // $18154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2029; break; } else { __label__ = 12311; break; }
    case 2029: // $18155
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2030; break; } else { __label__ = 12311; break; }
    case 2030: // $18156
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5700, $5701, $5702, $5703, $5704, $5705, $5706, $5707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2031; break; } else { __label__ = 12311; break; }
    case 2031: // $18157
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18149, 76, 2, 1, ((STRING_TABLE.__str443)|0), ((STRING_TABLE.__str444)|0), $5700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2032; break; } else { __label__ = 12311; break; }
    case 2032: // $18158
      var $18159=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18149);
      var $18160=__ZN11simple_listI16input_type_entryE6appendERS0_($18110, $18159);
      var $18161=$4689;
      var $18162=$4049;
      var $18163=$4050;
      var $18164=$4051;
      var $18165=$result_i253;
      var $18166=$4052;
      var $18167=$4053;
      HEAP32[(($4049)>>2)]=408;
      HEAP32[(($4050)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4051)>>2)]=182;
      var $18168=HEAP32[(($4049)>>2)];
      var $18169=HEAP32[(($4050)>>2)];
      var $18170=HEAP32[(($4051)>>2)];
      var $18171=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18168, $18169, $18170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2033; break; } else { __label__ = 2035; break; };
    case 2033: // $18172
      HEAP32[(($result_i253)>>2)]=$18171;
      var $18173=HEAP32[(($result_i253)>>2)];
      var $18174=(($18173)|0)==0;
      if ($18174) { __label__ = 2034; break; } else { __label__ = 2039; break; }
    case 2034: // $18175
      var $18176=___cxa_allocate_exception(4);
      var $18177=$18176;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18177);
      (function() { try { __THREW__ = false; return ___cxa_throw($18176, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2038; break; } else { __label__ = 2035; break; }
    case 2035: // $18178
      var $18179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18180=$18179.f0;
      HEAP32[(($4052)>>2)]=$18180;
      var $18181=$18179.f1;
      HEAP32[(($4053)>>2)]=$18181;
      var $18182=HEAP32[(($4053)>>2)];
      var $18183=(($18182)|0) < 0;
      if ($18183) { __label__ = 2036; break; } else { __label__ = 2037; break; }
    case 2036: // $18184
      var $18185=HEAP32[(($4052)>>2)];
      ___cxa_call_unexpected($18185);
      throw "Reached an unreachable!"
    case 2037: // $18186
      var $18187=HEAP32[(($4052)>>2)];
      var $18188=HEAP32[(($4052)>>2)];
      var $18189=HEAP32[(($4053)>>2)];
      var $18190=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18188, tempValue);
      var $18191=($18190.f1 = $18189, $18190);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2038: // $18192
      throw "Reached an unreachable!"
    case 2039: // $_ZnwjPKci_exit254
      var $18193=HEAP32[(($result_i253)>>2)];
      var $18194=$4049;
      var $18195=$4050;
      var $18196=$4051;
      var $18197=$result_i253;
      var $18198=$4052;
      var $18199=$4053;
      var $18200=$18193;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5709, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2040; break; } else { __label__ = 12316; break; }
    case 2040: // $18201
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5710, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2041; break; } else { __label__ = 12316; break; }
    case 2041: // $18202
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5711, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2042; break; } else { __label__ = 12316; break; }
    case 2042: // $18203
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2043; break; } else { __label__ = 12316; break; }
    case 2043: // $18204
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2044; break; } else { __label__ = 12316; break; }
    case 2044: // $18205
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2045; break; } else { __label__ = 12316; break; }
    case 2045: // $18206
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2046; break; } else { __label__ = 12316; break; }
    case 2046: // $18207
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5708, $5709, $5710, $5711, $5712, $5713, $5714, $5715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2047; break; } else { __label__ = 12316; break; }
    case 2047: // $18208
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18200, 77, 2, 1, ((STRING_TABLE.__str445)|0), ((STRING_TABLE.__str446)|0), $5708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2048; break; } else { __label__ = 12316; break; }
    case 2048: // $18209
      var $18210=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18200);
      var $18211=__ZN11simple_listI16input_type_entryE6appendERS0_($18161, $18210);
      var $18212=$4689;
      var $18213=$4044;
      var $18214=$4045;
      var $18215=$4046;
      var $18216=$result_i255;
      var $18217=$4047;
      var $18218=$4048;
      HEAP32[(($4044)>>2)]=408;
      HEAP32[(($4045)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4046)>>2)]=183;
      var $18219=HEAP32[(($4044)>>2)];
      var $18220=HEAP32[(($4045)>>2)];
      var $18221=HEAP32[(($4046)>>2)];
      var $18222=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18219, $18220, $18221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2049; break; } else { __label__ = 2051; break; };
    case 2049: // $18223
      HEAP32[(($result_i255)>>2)]=$18222;
      var $18224=HEAP32[(($result_i255)>>2)];
      var $18225=(($18224)|0)==0;
      if ($18225) { __label__ = 2050; break; } else { __label__ = 2055; break; }
    case 2050: // $18226
      var $18227=___cxa_allocate_exception(4);
      var $18228=$18227;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18228);
      (function() { try { __THREW__ = false; return ___cxa_throw($18227, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2054; break; } else { __label__ = 2051; break; }
    case 2051: // $18229
      var $18230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18231=$18230.f0;
      HEAP32[(($4047)>>2)]=$18231;
      var $18232=$18230.f1;
      HEAP32[(($4048)>>2)]=$18232;
      var $18233=HEAP32[(($4048)>>2)];
      var $18234=(($18233)|0) < 0;
      if ($18234) { __label__ = 2052; break; } else { __label__ = 2053; break; }
    case 2052: // $18235
      var $18236=HEAP32[(($4047)>>2)];
      ___cxa_call_unexpected($18236);
      throw "Reached an unreachable!"
    case 2053: // $18237
      var $18238=HEAP32[(($4047)>>2)];
      var $18239=HEAP32[(($4047)>>2)];
      var $18240=HEAP32[(($4048)>>2)];
      var $18241=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18239, tempValue);
      var $18242=($18241.f1 = $18240, $18241);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2054: // $18243
      throw "Reached an unreachable!"
    case 2055: // $_ZnwjPKci_exit256
      var $18244=HEAP32[(($result_i255)>>2)];
      var $18245=$4044;
      var $18246=$4045;
      var $18247=$4046;
      var $18248=$result_i255;
      var $18249=$4047;
      var $18250=$4048;
      var $18251=$18244;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5717, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2056; break; } else { __label__ = 12321; break; }
    case 2056: // $18252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5718, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2057; break; } else { __label__ = 12321; break; }
    case 2057: // $18253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5719, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2058; break; } else { __label__ = 12321; break; }
    case 2058: // $18254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5720, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2059; break; } else { __label__ = 12321; break; }
    case 2059: // $18255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5721, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2060; break; } else { __label__ = 12321; break; }
    case 2060: // $18256
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2061; break; } else { __label__ = 12321; break; }
    case 2061: // $18257
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2062; break; } else { __label__ = 12321; break; }
    case 2062: // $18258
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5716, $5717, $5718, $5719, $5720, $5721, $5722, $5723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2063; break; } else { __label__ = 12321; break; }
    case 2063: // $18259
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18251, 78, 2, 1, ((STRING_TABLE.__str447)|0), ((STRING_TABLE.__str448)|0), $5716) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2064; break; } else { __label__ = 12321; break; }
    case 2064: // $18260
      var $18261=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18251);
      var $18262=__ZN11simple_listI16input_type_entryE6appendERS0_($18212, $18261);
      var $18263=$4689;
      var $18264=$4039;
      var $18265=$4040;
      var $18266=$4041;
      var $18267=$result_i257;
      var $18268=$4042;
      var $18269=$4043;
      HEAP32[(($4039)>>2)]=408;
      HEAP32[(($4040)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4041)>>2)]=184;
      var $18270=HEAP32[(($4039)>>2)];
      var $18271=HEAP32[(($4040)>>2)];
      var $18272=HEAP32[(($4041)>>2)];
      var $18273=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18270, $18271, $18272) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2065; break; } else { __label__ = 2067; break; };
    case 2065: // $18274
      HEAP32[(($result_i257)>>2)]=$18273;
      var $18275=HEAP32[(($result_i257)>>2)];
      var $18276=(($18275)|0)==0;
      if ($18276) { __label__ = 2066; break; } else { __label__ = 2071; break; }
    case 2066: // $18277
      var $18278=___cxa_allocate_exception(4);
      var $18279=$18278;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18279);
      (function() { try { __THREW__ = false; return ___cxa_throw($18278, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2070; break; } else { __label__ = 2067; break; }
    case 2067: // $18280
      var $18281=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18282=$18281.f0;
      HEAP32[(($4042)>>2)]=$18282;
      var $18283=$18281.f1;
      HEAP32[(($4043)>>2)]=$18283;
      var $18284=HEAP32[(($4043)>>2)];
      var $18285=(($18284)|0) < 0;
      if ($18285) { __label__ = 2068; break; } else { __label__ = 2069; break; }
    case 2068: // $18286
      var $18287=HEAP32[(($4042)>>2)];
      ___cxa_call_unexpected($18287);
      throw "Reached an unreachable!"
    case 2069: // $18288
      var $18289=HEAP32[(($4042)>>2)];
      var $18290=HEAP32[(($4042)>>2)];
      var $18291=HEAP32[(($4043)>>2)];
      var $18292=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18290, tempValue);
      var $18293=($18292.f1 = $18291, $18292);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2070: // $18294
      throw "Reached an unreachable!"
    case 2071: // $_ZnwjPKci_exit258
      var $18295=HEAP32[(($result_i257)>>2)];
      var $18296=$4039;
      var $18297=$4040;
      var $18298=$4041;
      var $18299=$result_i257;
      var $18300=$4042;
      var $18301=$4043;
      var $18302=$18295;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5725, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2072; break; } else { __label__ = 12326; break; }
    case 2072: // $18303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5726, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2073; break; } else { __label__ = 12326; break; }
    case 2073: // $18304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5727, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2074; break; } else { __label__ = 12326; break; }
    case 2074: // $18305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2075; break; } else { __label__ = 12326; break; }
    case 2075: // $18306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2076; break; } else { __label__ = 12326; break; }
    case 2076: // $18307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2077; break; } else { __label__ = 12326; break; }
    case 2077: // $18308
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2078; break; } else { __label__ = 12326; break; }
    case 2078: // $18309
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5724, $5725, $5726, $5727, $5728, $5729, $5730, $5731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2079; break; } else { __label__ = 12326; break; }
    case 2079: // $18310
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18302, 79, 2, 1, ((STRING_TABLE.__str449)|0), ((STRING_TABLE.__str450)|0), $5724) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2080; break; } else { __label__ = 12326; break; }
    case 2080: // $18311
      var $18312=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18302);
      var $18313=__ZN11simple_listI16input_type_entryE6appendERS0_($18263, $18312);
      var $18314=$4689;
      var $18315=$4034;
      var $18316=$4035;
      var $18317=$4036;
      var $18318=$result_i259;
      var $18319=$4037;
      var $18320=$4038;
      HEAP32[(($4034)>>2)]=408;
      HEAP32[(($4035)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4036)>>2)]=185;
      var $18321=HEAP32[(($4034)>>2)];
      var $18322=HEAP32[(($4035)>>2)];
      var $18323=HEAP32[(($4036)>>2)];
      var $18324=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18321, $18322, $18323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2081; break; } else { __label__ = 2083; break; };
    case 2081: // $18325
      HEAP32[(($result_i259)>>2)]=$18324;
      var $18326=HEAP32[(($result_i259)>>2)];
      var $18327=(($18326)|0)==0;
      if ($18327) { __label__ = 2082; break; } else { __label__ = 2087; break; }
    case 2082: // $18328
      var $18329=___cxa_allocate_exception(4);
      var $18330=$18329;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18330);
      (function() { try { __THREW__ = false; return ___cxa_throw($18329, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2086; break; } else { __label__ = 2083; break; }
    case 2083: // $18331
      var $18332=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18333=$18332.f0;
      HEAP32[(($4037)>>2)]=$18333;
      var $18334=$18332.f1;
      HEAP32[(($4038)>>2)]=$18334;
      var $18335=HEAP32[(($4038)>>2)];
      var $18336=(($18335)|0) < 0;
      if ($18336) { __label__ = 2084; break; } else { __label__ = 2085; break; }
    case 2084: // $18337
      var $18338=HEAP32[(($4037)>>2)];
      ___cxa_call_unexpected($18338);
      throw "Reached an unreachable!"
    case 2085: // $18339
      var $18340=HEAP32[(($4037)>>2)];
      var $18341=HEAP32[(($4037)>>2)];
      var $18342=HEAP32[(($4038)>>2)];
      var $18343=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18341, tempValue);
      var $18344=($18343.f1 = $18342, $18343);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2086: // $18345
      throw "Reached an unreachable!"
    case 2087: // $_ZnwjPKci_exit260
      var $18346=HEAP32[(($result_i259)>>2)];
      var $18347=$4034;
      var $18348=$4035;
      var $18349=$4036;
      var $18350=$result_i259;
      var $18351=$4037;
      var $18352=$4038;
      var $18353=$18346;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5733, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2088; break; } else { __label__ = 12331; break; }
    case 2088: // $18354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5734, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2089; break; } else { __label__ = 12331; break; }
    case 2089: // $18355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5735, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2090; break; } else { __label__ = 12331; break; }
    case 2090: // $18356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2091; break; } else { __label__ = 12331; break; }
    case 2091: // $18357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2092; break; } else { __label__ = 12331; break; }
    case 2092: // $18358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2093; break; } else { __label__ = 12331; break; }
    case 2093: // $18359
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2094; break; } else { __label__ = 12331; break; }
    case 2094: // $18360
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5732, $5733, $5734, $5735, $5736, $5737, $5738, $5739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2095; break; } else { __label__ = 12331; break; }
    case 2095: // $18361
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18353, 80, 2, 1, ((STRING_TABLE.__str451)|0), ((STRING_TABLE.__str452)|0), $5732) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2096; break; } else { __label__ = 12331; break; }
    case 2096: // $18362
      var $18363=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18353);
      var $18364=__ZN11simple_listI16input_type_entryE6appendERS0_($18314, $18363);
      var $18365=$4689;
      var $18366=$4029;
      var $18367=$4030;
      var $18368=$4031;
      var $18369=$result_i261;
      var $18370=$4032;
      var $18371=$4033;
      HEAP32[(($4029)>>2)]=408;
      HEAP32[(($4030)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4031)>>2)]=186;
      var $18372=HEAP32[(($4029)>>2)];
      var $18373=HEAP32[(($4030)>>2)];
      var $18374=HEAP32[(($4031)>>2)];
      var $18375=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18372, $18373, $18374) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2097; break; } else { __label__ = 2099; break; };
    case 2097: // $18376
      HEAP32[(($result_i261)>>2)]=$18375;
      var $18377=HEAP32[(($result_i261)>>2)];
      var $18378=(($18377)|0)==0;
      if ($18378) { __label__ = 2098; break; } else { __label__ = 2103; break; }
    case 2098: // $18379
      var $18380=___cxa_allocate_exception(4);
      var $18381=$18380;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18381);
      (function() { try { __THREW__ = false; return ___cxa_throw($18380, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2102; break; } else { __label__ = 2099; break; }
    case 2099: // $18382
      var $18383=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18384=$18383.f0;
      HEAP32[(($4032)>>2)]=$18384;
      var $18385=$18383.f1;
      HEAP32[(($4033)>>2)]=$18385;
      var $18386=HEAP32[(($4033)>>2)];
      var $18387=(($18386)|0) < 0;
      if ($18387) { __label__ = 2100; break; } else { __label__ = 2101; break; }
    case 2100: // $18388
      var $18389=HEAP32[(($4032)>>2)];
      ___cxa_call_unexpected($18389);
      throw "Reached an unreachable!"
    case 2101: // $18390
      var $18391=HEAP32[(($4032)>>2)];
      var $18392=HEAP32[(($4032)>>2)];
      var $18393=HEAP32[(($4033)>>2)];
      var $18394=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18392, tempValue);
      var $18395=($18394.f1 = $18393, $18394);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2102: // $18396
      throw "Reached an unreachable!"
    case 2103: // $_ZnwjPKci_exit262
      var $18397=HEAP32[(($result_i261)>>2)];
      var $18398=$4029;
      var $18399=$4030;
      var $18400=$4031;
      var $18401=$result_i261;
      var $18402=$4032;
      var $18403=$4033;
      var $18404=$18397;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5741, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2104; break; } else { __label__ = 12336; break; }
    case 2104: // $18405
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5742, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2105; break; } else { __label__ = 12336; break; }
    case 2105: // $18406
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5743, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2106; break; } else { __label__ = 12336; break; }
    case 2106: // $18407
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5744, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2107; break; } else { __label__ = 12336; break; }
    case 2107: // $18408
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5745, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2108; break; } else { __label__ = 12336; break; }
    case 2108: // $18409
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2109; break; } else { __label__ = 12336; break; }
    case 2109: // $18410
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2110; break; } else { __label__ = 12336; break; }
    case 2110: // $18411
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5740, $5741, $5742, $5743, $5744, $5745, $5746, $5747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2111; break; } else { __label__ = 12336; break; }
    case 2111: // $18412
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18404, 81, 2, 1, ((STRING_TABLE.__str453)|0), ((STRING_TABLE.__str454)|0), $5740) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2112; break; } else { __label__ = 12336; break; }
    case 2112: // $18413
      var $18414=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18404);
      var $18415=__ZN11simple_listI16input_type_entryE6appendERS0_($18365, $18414);
      var $18416=$4689;
      var $18417=$4024;
      var $18418=$4025;
      var $18419=$4026;
      var $18420=$result_i263;
      var $18421=$4027;
      var $18422=$4028;
      HEAP32[(($4024)>>2)]=408;
      HEAP32[(($4025)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4026)>>2)]=187;
      var $18423=HEAP32[(($4024)>>2)];
      var $18424=HEAP32[(($4025)>>2)];
      var $18425=HEAP32[(($4026)>>2)];
      var $18426=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18423, $18424, $18425) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2113; break; } else { __label__ = 2115; break; };
    case 2113: // $18427
      HEAP32[(($result_i263)>>2)]=$18426;
      var $18428=HEAP32[(($result_i263)>>2)];
      var $18429=(($18428)|0)==0;
      if ($18429) { __label__ = 2114; break; } else { __label__ = 2119; break; }
    case 2114: // $18430
      var $18431=___cxa_allocate_exception(4);
      var $18432=$18431;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18432);
      (function() { try { __THREW__ = false; return ___cxa_throw($18431, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2118; break; } else { __label__ = 2115; break; }
    case 2115: // $18433
      var $18434=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18435=$18434.f0;
      HEAP32[(($4027)>>2)]=$18435;
      var $18436=$18434.f1;
      HEAP32[(($4028)>>2)]=$18436;
      var $18437=HEAP32[(($4028)>>2)];
      var $18438=(($18437)|0) < 0;
      if ($18438) { __label__ = 2116; break; } else { __label__ = 2117; break; }
    case 2116: // $18439
      var $18440=HEAP32[(($4027)>>2)];
      ___cxa_call_unexpected($18440);
      throw "Reached an unreachable!"
    case 2117: // $18441
      var $18442=HEAP32[(($4027)>>2)];
      var $18443=HEAP32[(($4027)>>2)];
      var $18444=HEAP32[(($4028)>>2)];
      var $18445=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18443, tempValue);
      var $18446=($18445.f1 = $18444, $18445);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2118: // $18447
      throw "Reached an unreachable!"
    case 2119: // $_ZnwjPKci_exit264
      var $18448=HEAP32[(($result_i263)>>2)];
      var $18449=$4024;
      var $18450=$4025;
      var $18451=$4026;
      var $18452=$result_i263;
      var $18453=$4027;
      var $18454=$4028;
      var $18455=$18448;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5749, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2120; break; } else { __label__ = 12341; break; }
    case 2120: // $18456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5750, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2121; break; } else { __label__ = 12341; break; }
    case 2121: // $18457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5751, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2122; break; } else { __label__ = 12341; break; }
    case 2122: // $18458
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2123; break; } else { __label__ = 12341; break; }
    case 2123: // $18459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2124; break; } else { __label__ = 12341; break; }
    case 2124: // $18460
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2125; break; } else { __label__ = 12341; break; }
    case 2125: // $18461
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2126; break; } else { __label__ = 12341; break; }
    case 2126: // $18462
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5748, $5749, $5750, $5751, $5752, $5753, $5754, $5755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2127; break; } else { __label__ = 12341; break; }
    case 2127: // $18463
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18455, 82, 2, 1, ((STRING_TABLE.__str455)|0), ((STRING_TABLE.__str456)|0), $5748) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2128; break; } else { __label__ = 12341; break; }
    case 2128: // $18464
      var $18465=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18455);
      var $18466=__ZN11simple_listI16input_type_entryE6appendERS0_($18416, $18465);
      var $18467=$4689;
      var $18468=$4019;
      var $18469=$4020;
      var $18470=$4021;
      var $18471=$result_i265;
      var $18472=$4022;
      var $18473=$4023;
      HEAP32[(($4019)>>2)]=408;
      HEAP32[(($4020)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4021)>>2)]=188;
      var $18474=HEAP32[(($4019)>>2)];
      var $18475=HEAP32[(($4020)>>2)];
      var $18476=HEAP32[(($4021)>>2)];
      var $18477=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18474, $18475, $18476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2129; break; } else { __label__ = 2131; break; };
    case 2129: // $18478
      HEAP32[(($result_i265)>>2)]=$18477;
      var $18479=HEAP32[(($result_i265)>>2)];
      var $18480=(($18479)|0)==0;
      if ($18480) { __label__ = 2130; break; } else { __label__ = 2135; break; }
    case 2130: // $18481
      var $18482=___cxa_allocate_exception(4);
      var $18483=$18482;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18483);
      (function() { try { __THREW__ = false; return ___cxa_throw($18482, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2134; break; } else { __label__ = 2131; break; }
    case 2131: // $18484
      var $18485=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18486=$18485.f0;
      HEAP32[(($4022)>>2)]=$18486;
      var $18487=$18485.f1;
      HEAP32[(($4023)>>2)]=$18487;
      var $18488=HEAP32[(($4023)>>2)];
      var $18489=(($18488)|0) < 0;
      if ($18489) { __label__ = 2132; break; } else { __label__ = 2133; break; }
    case 2132: // $18490
      var $18491=HEAP32[(($4022)>>2)];
      ___cxa_call_unexpected($18491);
      throw "Reached an unreachable!"
    case 2133: // $18492
      var $18493=HEAP32[(($4022)>>2)];
      var $18494=HEAP32[(($4022)>>2)];
      var $18495=HEAP32[(($4023)>>2)];
      var $18496=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18494, tempValue);
      var $18497=($18496.f1 = $18495, $18496);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2134: // $18498
      throw "Reached an unreachable!"
    case 2135: // $_ZnwjPKci_exit266
      var $18499=HEAP32[(($result_i265)>>2)];
      var $18500=$4019;
      var $18501=$4020;
      var $18502=$4021;
      var $18503=$result_i265;
      var $18504=$4022;
      var $18505=$4023;
      var $18506=$18499;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5757, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2136; break; } else { __label__ = 12346; break; }
    case 2136: // $18507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5758, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2137; break; } else { __label__ = 12346; break; }
    case 2137: // $18508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5759, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2138; break; } else { __label__ = 12346; break; }
    case 2138: // $18509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2139; break; } else { __label__ = 12346; break; }
    case 2139: // $18510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2140; break; } else { __label__ = 12346; break; }
    case 2140: // $18511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2141; break; } else { __label__ = 12346; break; }
    case 2141: // $18512
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2142; break; } else { __label__ = 12346; break; }
    case 2142: // $18513
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5756, $5757, $5758, $5759, $5760, $5761, $5762, $5763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2143; break; } else { __label__ = 12346; break; }
    case 2143: // $18514
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18506, 83, 2, 1, ((STRING_TABLE.__str457)|0), ((STRING_TABLE.__str458)|0), $5756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2144; break; } else { __label__ = 12346; break; }
    case 2144: // $18515
      var $18516=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18506);
      var $18517=__ZN11simple_listI16input_type_entryE6appendERS0_($18467, $18516);
      var $18518=$4689;
      var $18519=$4014;
      var $18520=$4015;
      var $18521=$4016;
      var $18522=$result_i267;
      var $18523=$4017;
      var $18524=$4018;
      HEAP32[(($4014)>>2)]=408;
      HEAP32[(($4015)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4016)>>2)]=189;
      var $18525=HEAP32[(($4014)>>2)];
      var $18526=HEAP32[(($4015)>>2)];
      var $18527=HEAP32[(($4016)>>2)];
      var $18528=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18525, $18526, $18527) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2145; break; } else { __label__ = 2147; break; };
    case 2145: // $18529
      HEAP32[(($result_i267)>>2)]=$18528;
      var $18530=HEAP32[(($result_i267)>>2)];
      var $18531=(($18530)|0)==0;
      if ($18531) { __label__ = 2146; break; } else { __label__ = 2151; break; }
    case 2146: // $18532
      var $18533=___cxa_allocate_exception(4);
      var $18534=$18533;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18534);
      (function() { try { __THREW__ = false; return ___cxa_throw($18533, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2150; break; } else { __label__ = 2147; break; }
    case 2147: // $18535
      var $18536=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18537=$18536.f0;
      HEAP32[(($4017)>>2)]=$18537;
      var $18538=$18536.f1;
      HEAP32[(($4018)>>2)]=$18538;
      var $18539=HEAP32[(($4018)>>2)];
      var $18540=(($18539)|0) < 0;
      if ($18540) { __label__ = 2148; break; } else { __label__ = 2149; break; }
    case 2148: // $18541
      var $18542=HEAP32[(($4017)>>2)];
      ___cxa_call_unexpected($18542);
      throw "Reached an unreachable!"
    case 2149: // $18543
      var $18544=HEAP32[(($4017)>>2)];
      var $18545=HEAP32[(($4017)>>2)];
      var $18546=HEAP32[(($4018)>>2)];
      var $18547=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18545, tempValue);
      var $18548=($18547.f1 = $18546, $18547);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2150: // $18549
      throw "Reached an unreachable!"
    case 2151: // $_ZnwjPKci_exit268
      var $18550=HEAP32[(($result_i267)>>2)];
      var $18551=$4014;
      var $18552=$4015;
      var $18553=$4016;
      var $18554=$result_i267;
      var $18555=$4017;
      var $18556=$4018;
      var $18557=$18550;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5765, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2152; break; } else { __label__ = 12351; break; }
    case 2152: // $18558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5766, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2153; break; } else { __label__ = 12351; break; }
    case 2153: // $18559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5767, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2154; break; } else { __label__ = 12351; break; }
    case 2154: // $18560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5768, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2155; break; } else { __label__ = 12351; break; }
    case 2155: // $18561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5769, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2156; break; } else { __label__ = 12351; break; }
    case 2156: // $18562
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2157; break; } else { __label__ = 12351; break; }
    case 2157: // $18563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2158; break; } else { __label__ = 12351; break; }
    case 2158: // $18564
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5764, $5765, $5766, $5767, $5768, $5769, $5770, $5771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2159; break; } else { __label__ = 12351; break; }
    case 2159: // $18565
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18557, 84, 2, 1, ((STRING_TABLE.__str459)|0), ((STRING_TABLE.__str460)|0), $5764) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2160; break; } else { __label__ = 12351; break; }
    case 2160: // $18566
      var $18567=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18557);
      var $18568=__ZN11simple_listI16input_type_entryE6appendERS0_($18518, $18567);
      var $18569=$4689;
      var $18570=$4009;
      var $18571=$4010;
      var $18572=$4011;
      var $18573=$result_i269;
      var $18574=$4012;
      var $18575=$4013;
      HEAP32[(($4009)>>2)]=408;
      HEAP32[(($4010)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4011)>>2)]=190;
      var $18576=HEAP32[(($4009)>>2)];
      var $18577=HEAP32[(($4010)>>2)];
      var $18578=HEAP32[(($4011)>>2)];
      var $18579=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18576, $18577, $18578) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2161; break; } else { __label__ = 2163; break; };
    case 2161: // $18580
      HEAP32[(($result_i269)>>2)]=$18579;
      var $18581=HEAP32[(($result_i269)>>2)];
      var $18582=(($18581)|0)==0;
      if ($18582) { __label__ = 2162; break; } else { __label__ = 2167; break; }
    case 2162: // $18583
      var $18584=___cxa_allocate_exception(4);
      var $18585=$18584;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18585);
      (function() { try { __THREW__ = false; return ___cxa_throw($18584, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2166; break; } else { __label__ = 2163; break; }
    case 2163: // $18586
      var $18587=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18588=$18587.f0;
      HEAP32[(($4012)>>2)]=$18588;
      var $18589=$18587.f1;
      HEAP32[(($4013)>>2)]=$18589;
      var $18590=HEAP32[(($4013)>>2)];
      var $18591=(($18590)|0) < 0;
      if ($18591) { __label__ = 2164; break; } else { __label__ = 2165; break; }
    case 2164: // $18592
      var $18593=HEAP32[(($4012)>>2)];
      ___cxa_call_unexpected($18593);
      throw "Reached an unreachable!"
    case 2165: // $18594
      var $18595=HEAP32[(($4012)>>2)];
      var $18596=HEAP32[(($4012)>>2)];
      var $18597=HEAP32[(($4013)>>2)];
      var $18598=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18596, tempValue);
      var $18599=($18598.f1 = $18597, $18598);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2166: // $18600
      throw "Reached an unreachable!"
    case 2167: // $_ZnwjPKci_exit270
      var $18601=HEAP32[(($result_i269)>>2)];
      var $18602=$4009;
      var $18603=$4010;
      var $18604=$4011;
      var $18605=$result_i269;
      var $18606=$4012;
      var $18607=$4013;
      var $18608=$18601;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5773, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2168; break; } else { __label__ = 12356; break; }
    case 2168: // $18609
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5774, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2169; break; } else { __label__ = 12356; break; }
    case 2169: // $18610
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5775, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2170; break; } else { __label__ = 12356; break; }
    case 2170: // $18611
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2171; break; } else { __label__ = 12356; break; }
    case 2171: // $18612
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2172; break; } else { __label__ = 12356; break; }
    case 2172: // $18613
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2173; break; } else { __label__ = 12356; break; }
    case 2173: // $18614
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2174; break; } else { __label__ = 12356; break; }
    case 2174: // $18615
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5772, $5773, $5774, $5775, $5776, $5777, $5778, $5779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2175; break; } else { __label__ = 12356; break; }
    case 2175: // $18616
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18608, 85, 2, 1, ((STRING_TABLE.__str461)|0), ((STRING_TABLE.__str462)|0), $5772) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2176; break; } else { __label__ = 12356; break; }
    case 2176: // $18617
      var $18618=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18608);
      var $18619=__ZN11simple_listI16input_type_entryE6appendERS0_($18569, $18618);
      var $18620=$4689;
      var $18621=$4004;
      var $18622=$4005;
      var $18623=$4006;
      var $18624=$result_i271;
      var $18625=$4007;
      var $18626=$4008;
      HEAP32[(($4004)>>2)]=408;
      HEAP32[(($4005)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4006)>>2)]=191;
      var $18627=HEAP32[(($4004)>>2)];
      var $18628=HEAP32[(($4005)>>2)];
      var $18629=HEAP32[(($4006)>>2)];
      var $18630=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18627, $18628, $18629) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2177; break; } else { __label__ = 2179; break; };
    case 2177: // $18631
      HEAP32[(($result_i271)>>2)]=$18630;
      var $18632=HEAP32[(($result_i271)>>2)];
      var $18633=(($18632)|0)==0;
      if ($18633) { __label__ = 2178; break; } else { __label__ = 2183; break; }
    case 2178: // $18634
      var $18635=___cxa_allocate_exception(4);
      var $18636=$18635;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18636);
      (function() { try { __THREW__ = false; return ___cxa_throw($18635, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2182; break; } else { __label__ = 2179; break; }
    case 2179: // $18637
      var $18638=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18639=$18638.f0;
      HEAP32[(($4007)>>2)]=$18639;
      var $18640=$18638.f1;
      HEAP32[(($4008)>>2)]=$18640;
      var $18641=HEAP32[(($4008)>>2)];
      var $18642=(($18641)|0) < 0;
      if ($18642) { __label__ = 2180; break; } else { __label__ = 2181; break; }
    case 2180: // $18643
      var $18644=HEAP32[(($4007)>>2)];
      ___cxa_call_unexpected($18644);
      throw "Reached an unreachable!"
    case 2181: // $18645
      var $18646=HEAP32[(($4007)>>2)];
      var $18647=HEAP32[(($4007)>>2)];
      var $18648=HEAP32[(($4008)>>2)];
      var $18649=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18647, tempValue);
      var $18650=($18649.f1 = $18648, $18649);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2182: // $18651
      throw "Reached an unreachable!"
    case 2183: // $_ZnwjPKci_exit272
      var $18652=HEAP32[(($result_i271)>>2)];
      var $18653=$4004;
      var $18654=$4005;
      var $18655=$4006;
      var $18656=$result_i271;
      var $18657=$4007;
      var $18658=$4008;
      var $18659=$18652;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5781, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2184; break; } else { __label__ = 12361; break; }
    case 2184: // $18660
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5782, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2185; break; } else { __label__ = 12361; break; }
    case 2185: // $18661
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5783, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2186; break; } else { __label__ = 12361; break; }
    case 2186: // $18662
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2187; break; } else { __label__ = 12361; break; }
    case 2187: // $18663
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2188; break; } else { __label__ = 12361; break; }
    case 2188: // $18664
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2189; break; } else { __label__ = 12361; break; }
    case 2189: // $18665
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2190; break; } else { __label__ = 12361; break; }
    case 2190: // $18666
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5780, $5781, $5782, $5783, $5784, $5785, $5786, $5787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2191; break; } else { __label__ = 12361; break; }
    case 2191: // $18667
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18659, 86, 2, 1, ((STRING_TABLE.__str463)|0), ((STRING_TABLE.__str464)|0), $5780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2192; break; } else { __label__ = 12361; break; }
    case 2192: // $18668
      var $18669=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18659);
      var $18670=__ZN11simple_listI16input_type_entryE6appendERS0_($18620, $18669);
      var $18671=$4689;
      var $18672=$3999;
      var $18673=$4000;
      var $18674=$4001;
      var $18675=$result_i273;
      var $18676=$4002;
      var $18677=$4003;
      HEAP32[(($3999)>>2)]=408;
      HEAP32[(($4000)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($4001)>>2)]=192;
      var $18678=HEAP32[(($3999)>>2)];
      var $18679=HEAP32[(($4000)>>2)];
      var $18680=HEAP32[(($4001)>>2)];
      var $18681=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18678, $18679, $18680) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2193; break; } else { __label__ = 2195; break; };
    case 2193: // $18682
      HEAP32[(($result_i273)>>2)]=$18681;
      var $18683=HEAP32[(($result_i273)>>2)];
      var $18684=(($18683)|0)==0;
      if ($18684) { __label__ = 2194; break; } else { __label__ = 2199; break; }
    case 2194: // $18685
      var $18686=___cxa_allocate_exception(4);
      var $18687=$18686;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18687);
      (function() { try { __THREW__ = false; return ___cxa_throw($18686, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2198; break; } else { __label__ = 2195; break; }
    case 2195: // $18688
      var $18689=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18690=$18689.f0;
      HEAP32[(($4002)>>2)]=$18690;
      var $18691=$18689.f1;
      HEAP32[(($4003)>>2)]=$18691;
      var $18692=HEAP32[(($4003)>>2)];
      var $18693=(($18692)|0) < 0;
      if ($18693) { __label__ = 2196; break; } else { __label__ = 2197; break; }
    case 2196: // $18694
      var $18695=HEAP32[(($4002)>>2)];
      ___cxa_call_unexpected($18695);
      throw "Reached an unreachable!"
    case 2197: // $18696
      var $18697=HEAP32[(($4002)>>2)];
      var $18698=HEAP32[(($4002)>>2)];
      var $18699=HEAP32[(($4003)>>2)];
      var $18700=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18698, tempValue);
      var $18701=($18700.f1 = $18699, $18700);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2198: // $18702
      throw "Reached an unreachable!"
    case 2199: // $_ZnwjPKci_exit274
      var $18703=HEAP32[(($result_i273)>>2)];
      var $18704=$3999;
      var $18705=$4000;
      var $18706=$4001;
      var $18707=$result_i273;
      var $18708=$4002;
      var $18709=$4003;
      var $18710=$18703;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5789, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2200; break; } else { __label__ = 12366; break; }
    case 2200: // $18711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5790, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2201; break; } else { __label__ = 12366; break; }
    case 2201: // $18712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5791, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2202; break; } else { __label__ = 12366; break; }
    case 2202: // $18713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5792, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2203; break; } else { __label__ = 12366; break; }
    case 2203: // $18714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5793, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2204; break; } else { __label__ = 12366; break; }
    case 2204: // $18715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5794, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2205; break; } else { __label__ = 12366; break; }
    case 2205: // $18716
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5795, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2206; break; } else { __label__ = 12366; break; }
    case 2206: // $18717
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5788, $5789, $5790, $5791, $5792, $5793, $5794, $5795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2207; break; } else { __label__ = 12366; break; }
    case 2207: // $18718
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18710, 87, 2, 1, ((STRING_TABLE.__str465)|0), ((STRING_TABLE.__str466)|0), $5788) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2208; break; } else { __label__ = 12366; break; }
    case 2208: // $18719
      var $18720=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18710);
      var $18721=__ZN11simple_listI16input_type_entryE6appendERS0_($18671, $18720);
      var $18722=$4689;
      var $18723=$3994;
      var $18724=$3995;
      var $18725=$3996;
      var $18726=$result_i275;
      var $18727=$3997;
      var $18728=$3998;
      HEAP32[(($3994)>>2)]=408;
      HEAP32[(($3995)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3996)>>2)]=193;
      var $18729=HEAP32[(($3994)>>2)];
      var $18730=HEAP32[(($3995)>>2)];
      var $18731=HEAP32[(($3996)>>2)];
      var $18732=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18729, $18730, $18731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2209; break; } else { __label__ = 2211; break; };
    case 2209: // $18733
      HEAP32[(($result_i275)>>2)]=$18732;
      var $18734=HEAP32[(($result_i275)>>2)];
      var $18735=(($18734)|0)==0;
      if ($18735) { __label__ = 2210; break; } else { __label__ = 2215; break; }
    case 2210: // $18736
      var $18737=___cxa_allocate_exception(4);
      var $18738=$18737;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18738);
      (function() { try { __THREW__ = false; return ___cxa_throw($18737, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2214; break; } else { __label__ = 2211; break; }
    case 2211: // $18739
      var $18740=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18741=$18740.f0;
      HEAP32[(($3997)>>2)]=$18741;
      var $18742=$18740.f1;
      HEAP32[(($3998)>>2)]=$18742;
      var $18743=HEAP32[(($3998)>>2)];
      var $18744=(($18743)|0) < 0;
      if ($18744) { __label__ = 2212; break; } else { __label__ = 2213; break; }
    case 2212: // $18745
      var $18746=HEAP32[(($3997)>>2)];
      ___cxa_call_unexpected($18746);
      throw "Reached an unreachable!"
    case 2213: // $18747
      var $18748=HEAP32[(($3997)>>2)];
      var $18749=HEAP32[(($3997)>>2)];
      var $18750=HEAP32[(($3998)>>2)];
      var $18751=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18749, tempValue);
      var $18752=($18751.f1 = $18750, $18751);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2214: // $18753
      throw "Reached an unreachable!"
    case 2215: // $_ZnwjPKci_exit276
      var $18754=HEAP32[(($result_i275)>>2)];
      var $18755=$3994;
      var $18756=$3995;
      var $18757=$3996;
      var $18758=$result_i275;
      var $18759=$3997;
      var $18760=$3998;
      var $18761=$18754;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5797, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2216; break; } else { __label__ = 12371; break; }
    case 2216: // $18762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5798, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2217; break; } else { __label__ = 12371; break; }
    case 2217: // $18763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5799, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2218; break; } else { __label__ = 12371; break; }
    case 2218: // $18764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5800, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2219; break; } else { __label__ = 12371; break; }
    case 2219: // $18765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5801, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2220; break; } else { __label__ = 12371; break; }
    case 2220: // $18766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5802, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2221; break; } else { __label__ = 12371; break; }
    case 2221: // $18767
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5803, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2222; break; } else { __label__ = 12371; break; }
    case 2222: // $18768
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5796, $5797, $5798, $5799, $5800, $5801, $5802, $5803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2223; break; } else { __label__ = 12371; break; }
    case 2223: // $18769
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18761, 88, 2, 1, ((STRING_TABLE.__str467)|0), ((STRING_TABLE.__str468)|0), $5796) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2224; break; } else { __label__ = 12371; break; }
    case 2224: // $18770
      var $18771=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18761);
      var $18772=__ZN11simple_listI16input_type_entryE6appendERS0_($18722, $18771);
      var $18773=$4689;
      var $18774=$3989;
      var $18775=$3990;
      var $18776=$3991;
      var $18777=$result_i277;
      var $18778=$3992;
      var $18779=$3993;
      HEAP32[(($3989)>>2)]=408;
      HEAP32[(($3990)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3991)>>2)]=194;
      var $18780=HEAP32[(($3989)>>2)];
      var $18781=HEAP32[(($3990)>>2)];
      var $18782=HEAP32[(($3991)>>2)];
      var $18783=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18780, $18781, $18782) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2225; break; } else { __label__ = 2227; break; };
    case 2225: // $18784
      HEAP32[(($result_i277)>>2)]=$18783;
      var $18785=HEAP32[(($result_i277)>>2)];
      var $18786=(($18785)|0)==0;
      if ($18786) { __label__ = 2226; break; } else { __label__ = 2231; break; }
    case 2226: // $18787
      var $18788=___cxa_allocate_exception(4);
      var $18789=$18788;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18789);
      (function() { try { __THREW__ = false; return ___cxa_throw($18788, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2230; break; } else { __label__ = 2227; break; }
    case 2227: // $18790
      var $18791=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18792=$18791.f0;
      HEAP32[(($3992)>>2)]=$18792;
      var $18793=$18791.f1;
      HEAP32[(($3993)>>2)]=$18793;
      var $18794=HEAP32[(($3993)>>2)];
      var $18795=(($18794)|0) < 0;
      if ($18795) { __label__ = 2228; break; } else { __label__ = 2229; break; }
    case 2228: // $18796
      var $18797=HEAP32[(($3992)>>2)];
      ___cxa_call_unexpected($18797);
      throw "Reached an unreachable!"
    case 2229: // $18798
      var $18799=HEAP32[(($3992)>>2)];
      var $18800=HEAP32[(($3992)>>2)];
      var $18801=HEAP32[(($3993)>>2)];
      var $18802=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18800, tempValue);
      var $18803=($18802.f1 = $18801, $18802);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2230: // $18804
      throw "Reached an unreachable!"
    case 2231: // $_ZnwjPKci_exit278
      var $18805=HEAP32[(($result_i277)>>2)];
      var $18806=$3989;
      var $18807=$3990;
      var $18808=$3991;
      var $18809=$result_i277;
      var $18810=$3992;
      var $18811=$3993;
      var $18812=$18805;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5805, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2232; break; } else { __label__ = 12376; break; }
    case 2232: // $18813
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5806, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2233; break; } else { __label__ = 12376; break; }
    case 2233: // $18814
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5807, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2234; break; } else { __label__ = 12376; break; }
    case 2234: // $18815
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5808, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2235; break; } else { __label__ = 12376; break; }
    case 2235: // $18816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5809, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2236; break; } else { __label__ = 12376; break; }
    case 2236: // $18817
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2237; break; } else { __label__ = 12376; break; }
    case 2237: // $18818
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2238; break; } else { __label__ = 12376; break; }
    case 2238: // $18819
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5804, $5805, $5806, $5807, $5808, $5809, $5810, $5811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2239; break; } else { __label__ = 12376; break; }
    case 2239: // $18820
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18812, 89, 2, 1, ((STRING_TABLE.__str469)|0), ((STRING_TABLE.__str470)|0), $5804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2240; break; } else { __label__ = 12376; break; }
    case 2240: // $18821
      var $18822=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18812);
      var $18823=__ZN11simple_listI16input_type_entryE6appendERS0_($18773, $18822);
      var $18824=$4689;
      var $18825=$3984;
      var $18826=$3985;
      var $18827=$3986;
      var $18828=$result_i279;
      var $18829=$3987;
      var $18830=$3988;
      HEAP32[(($3984)>>2)]=408;
      HEAP32[(($3985)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3986)>>2)]=195;
      var $18831=HEAP32[(($3984)>>2)];
      var $18832=HEAP32[(($3985)>>2)];
      var $18833=HEAP32[(($3986)>>2)];
      var $18834=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18831, $18832, $18833) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2241; break; } else { __label__ = 2243; break; };
    case 2241: // $18835
      HEAP32[(($result_i279)>>2)]=$18834;
      var $18836=HEAP32[(($result_i279)>>2)];
      var $18837=(($18836)|0)==0;
      if ($18837) { __label__ = 2242; break; } else { __label__ = 2247; break; }
    case 2242: // $18838
      var $18839=___cxa_allocate_exception(4);
      var $18840=$18839;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18840);
      (function() { try { __THREW__ = false; return ___cxa_throw($18839, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2246; break; } else { __label__ = 2243; break; }
    case 2243: // $18841
      var $18842=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18843=$18842.f0;
      HEAP32[(($3987)>>2)]=$18843;
      var $18844=$18842.f1;
      HEAP32[(($3988)>>2)]=$18844;
      var $18845=HEAP32[(($3988)>>2)];
      var $18846=(($18845)|0) < 0;
      if ($18846) { __label__ = 2244; break; } else { __label__ = 2245; break; }
    case 2244: // $18847
      var $18848=HEAP32[(($3987)>>2)];
      ___cxa_call_unexpected($18848);
      throw "Reached an unreachable!"
    case 2245: // $18849
      var $18850=HEAP32[(($3987)>>2)];
      var $18851=HEAP32[(($3987)>>2)];
      var $18852=HEAP32[(($3988)>>2)];
      var $18853=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18851, tempValue);
      var $18854=($18853.f1 = $18852, $18853);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2246: // $18855
      throw "Reached an unreachable!"
    case 2247: // $_ZnwjPKci_exit280
      var $18856=HEAP32[(($result_i279)>>2)];
      var $18857=$3984;
      var $18858=$3985;
      var $18859=$3986;
      var $18860=$result_i279;
      var $18861=$3987;
      var $18862=$3988;
      var $18863=$18856;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5813, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2248; break; } else { __label__ = 12381; break; }
    case 2248: // $18864
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5814, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2249; break; } else { __label__ = 12381; break; }
    case 2249: // $18865
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5815, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2250; break; } else { __label__ = 12381; break; }
    case 2250: // $18866
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2251; break; } else { __label__ = 12381; break; }
    case 2251: // $18867
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2252; break; } else { __label__ = 12381; break; }
    case 2252: // $18868
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2253; break; } else { __label__ = 12381; break; }
    case 2253: // $18869
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2254; break; } else { __label__ = 12381; break; }
    case 2254: // $18870
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5812, $5813, $5814, $5815, $5816, $5817, $5818, $5819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2255; break; } else { __label__ = 12381; break; }
    case 2255: // $18871
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18863, 90, 2, 1, ((STRING_TABLE.__str471)|0), ((STRING_TABLE.__str472)|0), $5812) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2256; break; } else { __label__ = 12381; break; }
    case 2256: // $18872
      var $18873=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18863);
      var $18874=__ZN11simple_listI16input_type_entryE6appendERS0_($18824, $18873);
      var $18875=$4689;
      var $18876=$3979;
      var $18877=$3980;
      var $18878=$3981;
      var $18879=$result_i281;
      var $18880=$3982;
      var $18881=$3983;
      HEAP32[(($3979)>>2)]=408;
      HEAP32[(($3980)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3981)>>2)]=196;
      var $18882=HEAP32[(($3979)>>2)];
      var $18883=HEAP32[(($3980)>>2)];
      var $18884=HEAP32[(($3981)>>2)];
      var $18885=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18882, $18883, $18884) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2257; break; } else { __label__ = 2259; break; };
    case 2257: // $18886
      HEAP32[(($result_i281)>>2)]=$18885;
      var $18887=HEAP32[(($result_i281)>>2)];
      var $18888=(($18887)|0)==0;
      if ($18888) { __label__ = 2258; break; } else { __label__ = 2263; break; }
    case 2258: // $18889
      var $18890=___cxa_allocate_exception(4);
      var $18891=$18890;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18891);
      (function() { try { __THREW__ = false; return ___cxa_throw($18890, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2262; break; } else { __label__ = 2259; break; }
    case 2259: // $18892
      var $18893=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18894=$18893.f0;
      HEAP32[(($3982)>>2)]=$18894;
      var $18895=$18893.f1;
      HEAP32[(($3983)>>2)]=$18895;
      var $18896=HEAP32[(($3983)>>2)];
      var $18897=(($18896)|0) < 0;
      if ($18897) { __label__ = 2260; break; } else { __label__ = 2261; break; }
    case 2260: // $18898
      var $18899=HEAP32[(($3982)>>2)];
      ___cxa_call_unexpected($18899);
      throw "Reached an unreachable!"
    case 2261: // $18900
      var $18901=HEAP32[(($3982)>>2)];
      var $18902=HEAP32[(($3982)>>2)];
      var $18903=HEAP32[(($3983)>>2)];
      var $18904=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18902, tempValue);
      var $18905=($18904.f1 = $18903, $18904);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2262: // $18906
      throw "Reached an unreachable!"
    case 2263: // $_ZnwjPKci_exit282
      var $18907=HEAP32[(($result_i281)>>2)];
      var $18908=$3979;
      var $18909=$3980;
      var $18910=$3981;
      var $18911=$result_i281;
      var $18912=$3982;
      var $18913=$3983;
      var $18914=$18907;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5821, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2264; break; } else { __label__ = 12386; break; }
    case 2264: // $18915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5822, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2265; break; } else { __label__ = 12386; break; }
    case 2265: // $18916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5823, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2266; break; } else { __label__ = 12386; break; }
    case 2266: // $18917
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2267; break; } else { __label__ = 12386; break; }
    case 2267: // $18918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2268; break; } else { __label__ = 12386; break; }
    case 2268: // $18919
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2269; break; } else { __label__ = 12386; break; }
    case 2269: // $18920
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2270; break; } else { __label__ = 12386; break; }
    case 2270: // $18921
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5820, $5821, $5822, $5823, $5824, $5825, $5826, $5827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2271; break; } else { __label__ = 12386; break; }
    case 2271: // $18922
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18914, 91, 2, 1, ((STRING_TABLE.__str473410)|0), ((STRING_TABLE.__str474)|0), $5820) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2272; break; } else { __label__ = 12386; break; }
    case 2272: // $18923
      var $18924=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18914);
      var $18925=__ZN11simple_listI16input_type_entryE6appendERS0_($18875, $18924);
      var $18926=$4689;
      var $18927=$3974;
      var $18928=$3975;
      var $18929=$3976;
      var $18930=$result_i283;
      var $18931=$3977;
      var $18932=$3978;
      HEAP32[(($3974)>>2)]=408;
      HEAP32[(($3975)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3976)>>2)]=197;
      var $18933=HEAP32[(($3974)>>2)];
      var $18934=HEAP32[(($3975)>>2)];
      var $18935=HEAP32[(($3976)>>2)];
      var $18936=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18933, $18934, $18935) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2273; break; } else { __label__ = 2275; break; };
    case 2273: // $18937
      HEAP32[(($result_i283)>>2)]=$18936;
      var $18938=HEAP32[(($result_i283)>>2)];
      var $18939=(($18938)|0)==0;
      if ($18939) { __label__ = 2274; break; } else { __label__ = 2279; break; }
    case 2274: // $18940
      var $18941=___cxa_allocate_exception(4);
      var $18942=$18941;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18942);
      (function() { try { __THREW__ = false; return ___cxa_throw($18941, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2278; break; } else { __label__ = 2275; break; }
    case 2275: // $18943
      var $18944=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18945=$18944.f0;
      HEAP32[(($3977)>>2)]=$18945;
      var $18946=$18944.f1;
      HEAP32[(($3978)>>2)]=$18946;
      var $18947=HEAP32[(($3978)>>2)];
      var $18948=(($18947)|0) < 0;
      if ($18948) { __label__ = 2276; break; } else { __label__ = 2277; break; }
    case 2276: // $18949
      var $18950=HEAP32[(($3977)>>2)];
      ___cxa_call_unexpected($18950);
      throw "Reached an unreachable!"
    case 2277: // $18951
      var $18952=HEAP32[(($3977)>>2)];
      var $18953=HEAP32[(($3977)>>2)];
      var $18954=HEAP32[(($3978)>>2)];
      var $18955=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18953, tempValue);
      var $18956=($18955.f1 = $18954, $18955);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2278: // $18957
      throw "Reached an unreachable!"
    case 2279: // $_ZnwjPKci_exit284
      var $18958=HEAP32[(($result_i283)>>2)];
      var $18959=$3974;
      var $18960=$3975;
      var $18961=$3976;
      var $18962=$result_i283;
      var $18963=$3977;
      var $18964=$3978;
      var $18965=$18958;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5829, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2280; break; } else { __label__ = 12391; break; }
    case 2280: // $18966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5830, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2281; break; } else { __label__ = 12391; break; }
    case 2281: // $18967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5831, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2282; break; } else { __label__ = 12391; break; }
    case 2282: // $18968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2283; break; } else { __label__ = 12391; break; }
    case 2283: // $18969
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2284; break; } else { __label__ = 12391; break; }
    case 2284: // $18970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2285; break; } else { __label__ = 12391; break; }
    case 2285: // $18971
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2286; break; } else { __label__ = 12391; break; }
    case 2286: // $18972
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5828, $5829, $5830, $5831, $5832, $5833, $5834, $5835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2287; break; } else { __label__ = 12391; break; }
    case 2287: // $18973
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($18965, 92, 2, 1, ((STRING_TABLE.__str475)|0), ((STRING_TABLE.__str476)|0), $5828) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2288; break; } else { __label__ = 12391; break; }
    case 2288: // $18974
      var $18975=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $18965);
      var $18976=__ZN11simple_listI16input_type_entryE6appendERS0_($18926, $18975);
      var $18977=$4689;
      var $18978=$3969;
      var $18979=$3970;
      var $18980=$3971;
      var $18981=$result_i285;
      var $18982=$3972;
      var $18983=$3973;
      HEAP32[(($3969)>>2)]=408;
      HEAP32[(($3970)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3971)>>2)]=198;
      var $18984=HEAP32[(($3969)>>2)];
      var $18985=HEAP32[(($3970)>>2)];
      var $18986=HEAP32[(($3971)>>2)];
      var $18987=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18984, $18985, $18986) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2289; break; } else { __label__ = 2291; break; };
    case 2289: // $18988
      HEAP32[(($result_i285)>>2)]=$18987;
      var $18989=HEAP32[(($result_i285)>>2)];
      var $18990=(($18989)|0)==0;
      if ($18990) { __label__ = 2290; break; } else { __label__ = 2295; break; }
    case 2290: // $18991
      var $18992=___cxa_allocate_exception(4);
      var $18993=$18992;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($18993);
      (function() { try { __THREW__ = false; return ___cxa_throw($18992, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2294; break; } else { __label__ = 2291; break; }
    case 2291: // $18994
      var $18995=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18996=$18995.f0;
      HEAP32[(($3972)>>2)]=$18996;
      var $18997=$18995.f1;
      HEAP32[(($3973)>>2)]=$18997;
      var $18998=HEAP32[(($3973)>>2)];
      var $18999=(($18998)|0) < 0;
      if ($18999) { __label__ = 2292; break; } else { __label__ = 2293; break; }
    case 2292: // $19000
      var $19001=HEAP32[(($3972)>>2)];
      ___cxa_call_unexpected($19001);
      throw "Reached an unreachable!"
    case 2293: // $19002
      var $19003=HEAP32[(($3972)>>2)];
      var $19004=HEAP32[(($3972)>>2)];
      var $19005=HEAP32[(($3973)>>2)];
      var $19006=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19004, tempValue);
      var $19007=($19006.f1 = $19005, $19006);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2294: // $19008
      throw "Reached an unreachable!"
    case 2295: // $_ZnwjPKci_exit286
      var $19009=HEAP32[(($result_i285)>>2)];
      var $19010=$3969;
      var $19011=$3970;
      var $19012=$3971;
      var $19013=$result_i285;
      var $19014=$3972;
      var $19015=$3973;
      var $19016=$19009;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5837, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2296; break; } else { __label__ = 12396; break; }
    case 2296: // $19017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5838, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2297; break; } else { __label__ = 12396; break; }
    case 2297: // $19018
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5839, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2298; break; } else { __label__ = 12396; break; }
    case 2298: // $19019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2299; break; } else { __label__ = 12396; break; }
    case 2299: // $19020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2300; break; } else { __label__ = 12396; break; }
    case 2300: // $19021
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2301; break; } else { __label__ = 12396; break; }
    case 2301: // $19022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2302; break; } else { __label__ = 12396; break; }
    case 2302: // $19023
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5836, $5837, $5838, $5839, $5840, $5841, $5842, $5843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2303; break; } else { __label__ = 12396; break; }
    case 2303: // $19024
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19016, 93, 2, 1, ((STRING_TABLE.__str477)|0), ((STRING_TABLE.__str478)|0), $5836) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2304; break; } else { __label__ = 12396; break; }
    case 2304: // $19025
      var $19026=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19016);
      var $19027=__ZN11simple_listI16input_type_entryE6appendERS0_($18977, $19026);
      var $19028=$4689;
      var $19029=$3964;
      var $19030=$3965;
      var $19031=$3966;
      var $19032=$result_i287;
      var $19033=$3967;
      var $19034=$3968;
      HEAP32[(($3964)>>2)]=408;
      HEAP32[(($3965)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3966)>>2)]=199;
      var $19035=HEAP32[(($3964)>>2)];
      var $19036=HEAP32[(($3965)>>2)];
      var $19037=HEAP32[(($3966)>>2)];
      var $19038=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19035, $19036, $19037) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2305; break; } else { __label__ = 2307; break; };
    case 2305: // $19039
      HEAP32[(($result_i287)>>2)]=$19038;
      var $19040=HEAP32[(($result_i287)>>2)];
      var $19041=(($19040)|0)==0;
      if ($19041) { __label__ = 2306; break; } else { __label__ = 2311; break; }
    case 2306: // $19042
      var $19043=___cxa_allocate_exception(4);
      var $19044=$19043;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19044);
      (function() { try { __THREW__ = false; return ___cxa_throw($19043, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2310; break; } else { __label__ = 2307; break; }
    case 2307: // $19045
      var $19046=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19047=$19046.f0;
      HEAP32[(($3967)>>2)]=$19047;
      var $19048=$19046.f1;
      HEAP32[(($3968)>>2)]=$19048;
      var $19049=HEAP32[(($3968)>>2)];
      var $19050=(($19049)|0) < 0;
      if ($19050) { __label__ = 2308; break; } else { __label__ = 2309; break; }
    case 2308: // $19051
      var $19052=HEAP32[(($3967)>>2)];
      ___cxa_call_unexpected($19052);
      throw "Reached an unreachable!"
    case 2309: // $19053
      var $19054=HEAP32[(($3967)>>2)];
      var $19055=HEAP32[(($3967)>>2)];
      var $19056=HEAP32[(($3968)>>2)];
      var $19057=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19055, tempValue);
      var $19058=($19057.f1 = $19056, $19057);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2310: // $19059
      throw "Reached an unreachable!"
    case 2311: // $_ZnwjPKci_exit288
      var $19060=HEAP32[(($result_i287)>>2)];
      var $19061=$3964;
      var $19062=$3965;
      var $19063=$3966;
      var $19064=$result_i287;
      var $19065=$3967;
      var $19066=$3968;
      var $19067=$19060;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5845, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2312; break; } else { __label__ = 12401; break; }
    case 2312: // $19068
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5846, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2313; break; } else { __label__ = 12401; break; }
    case 2313: // $19069
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5847, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2314; break; } else { __label__ = 12401; break; }
    case 2314: // $19070
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2315; break; } else { __label__ = 12401; break; }
    case 2315: // $19071
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2316; break; } else { __label__ = 12401; break; }
    case 2316: // $19072
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2317; break; } else { __label__ = 12401; break; }
    case 2317: // $19073
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2318; break; } else { __label__ = 12401; break; }
    case 2318: // $19074
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5844, $5845, $5846, $5847, $5848, $5849, $5850, $5851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2319; break; } else { __label__ = 12401; break; }
    case 2319: // $19075
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19067, 94, 2, 1, ((STRING_TABLE.__str479)|0), ((STRING_TABLE.__str480)|0), $5844) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2320; break; } else { __label__ = 12401; break; }
    case 2320: // $19076
      var $19077=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19067);
      var $19078=__ZN11simple_listI16input_type_entryE6appendERS0_($19028, $19077);
      var $19079=$4689;
      var $19080=$3959;
      var $19081=$3960;
      var $19082=$3961;
      var $19083=$result_i289;
      var $19084=$3962;
      var $19085=$3963;
      HEAP32[(($3959)>>2)]=408;
      HEAP32[(($3960)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3961)>>2)]=200;
      var $19086=HEAP32[(($3959)>>2)];
      var $19087=HEAP32[(($3960)>>2)];
      var $19088=HEAP32[(($3961)>>2)];
      var $19089=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19086, $19087, $19088) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2321; break; } else { __label__ = 2323; break; };
    case 2321: // $19090
      HEAP32[(($result_i289)>>2)]=$19089;
      var $19091=HEAP32[(($result_i289)>>2)];
      var $19092=(($19091)|0)==0;
      if ($19092) { __label__ = 2322; break; } else { __label__ = 2327; break; }
    case 2322: // $19093
      var $19094=___cxa_allocate_exception(4);
      var $19095=$19094;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19095);
      (function() { try { __THREW__ = false; return ___cxa_throw($19094, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2326; break; } else { __label__ = 2323; break; }
    case 2323: // $19096
      var $19097=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19098=$19097.f0;
      HEAP32[(($3962)>>2)]=$19098;
      var $19099=$19097.f1;
      HEAP32[(($3963)>>2)]=$19099;
      var $19100=HEAP32[(($3963)>>2)];
      var $19101=(($19100)|0) < 0;
      if ($19101) { __label__ = 2324; break; } else { __label__ = 2325; break; }
    case 2324: // $19102
      var $19103=HEAP32[(($3962)>>2)];
      ___cxa_call_unexpected($19103);
      throw "Reached an unreachable!"
    case 2325: // $19104
      var $19105=HEAP32[(($3962)>>2)];
      var $19106=HEAP32[(($3962)>>2)];
      var $19107=HEAP32[(($3963)>>2)];
      var $19108=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19106, tempValue);
      var $19109=($19108.f1 = $19107, $19108);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2326: // $19110
      throw "Reached an unreachable!"
    case 2327: // $_ZnwjPKci_exit290
      var $19111=HEAP32[(($result_i289)>>2)];
      var $19112=$3959;
      var $19113=$3960;
      var $19114=$3961;
      var $19115=$result_i289;
      var $19116=$3962;
      var $19117=$3963;
      var $19118=$19111;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5853, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2328; break; } else { __label__ = 12406; break; }
    case 2328: // $19119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5854, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2329; break; } else { __label__ = 12406; break; }
    case 2329: // $19120
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5855, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2330; break; } else { __label__ = 12406; break; }
    case 2330: // $19121
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2331; break; } else { __label__ = 12406; break; }
    case 2331: // $19122
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2332; break; } else { __label__ = 12406; break; }
    case 2332: // $19123
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2333; break; } else { __label__ = 12406; break; }
    case 2333: // $19124
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2334; break; } else { __label__ = 12406; break; }
    case 2334: // $19125
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5852, $5853, $5854, $5855, $5856, $5857, $5858, $5859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2335; break; } else { __label__ = 12406; break; }
    case 2335: // $19126
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19118, 95, 2, 1, ((STRING_TABLE.__str481)|0), ((STRING_TABLE.__str482)|0), $5852) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2336; break; } else { __label__ = 12406; break; }
    case 2336: // $19127
      var $19128=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19118);
      var $19129=__ZN11simple_listI16input_type_entryE6appendERS0_($19079, $19128);
      var $19130=$4689;
      var $19131=$3954;
      var $19132=$3955;
      var $19133=$3956;
      var $19134=$result_i291;
      var $19135=$3957;
      var $19136=$3958;
      HEAP32[(($3954)>>2)]=408;
      HEAP32[(($3955)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3956)>>2)]=201;
      var $19137=HEAP32[(($3954)>>2)];
      var $19138=HEAP32[(($3955)>>2)];
      var $19139=HEAP32[(($3956)>>2)];
      var $19140=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19137, $19138, $19139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2337; break; } else { __label__ = 2339; break; };
    case 2337: // $19141
      HEAP32[(($result_i291)>>2)]=$19140;
      var $19142=HEAP32[(($result_i291)>>2)];
      var $19143=(($19142)|0)==0;
      if ($19143) { __label__ = 2338; break; } else { __label__ = 2343; break; }
    case 2338: // $19144
      var $19145=___cxa_allocate_exception(4);
      var $19146=$19145;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19146);
      (function() { try { __THREW__ = false; return ___cxa_throw($19145, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2342; break; } else { __label__ = 2339; break; }
    case 2339: // $19147
      var $19148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19149=$19148.f0;
      HEAP32[(($3957)>>2)]=$19149;
      var $19150=$19148.f1;
      HEAP32[(($3958)>>2)]=$19150;
      var $19151=HEAP32[(($3958)>>2)];
      var $19152=(($19151)|0) < 0;
      if ($19152) { __label__ = 2340; break; } else { __label__ = 2341; break; }
    case 2340: // $19153
      var $19154=HEAP32[(($3957)>>2)];
      ___cxa_call_unexpected($19154);
      throw "Reached an unreachable!"
    case 2341: // $19155
      var $19156=HEAP32[(($3957)>>2)];
      var $19157=HEAP32[(($3957)>>2)];
      var $19158=HEAP32[(($3958)>>2)];
      var $19159=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19157, tempValue);
      var $19160=($19159.f1 = $19158, $19159);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2342: // $19161
      throw "Reached an unreachable!"
    case 2343: // $_ZnwjPKci_exit292
      var $19162=HEAP32[(($result_i291)>>2)];
      var $19163=$3954;
      var $19164=$3955;
      var $19165=$3956;
      var $19166=$result_i291;
      var $19167=$3957;
      var $19168=$3958;
      var $19169=$19162;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5861, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2344; break; } else { __label__ = 12411; break; }
    case 2344: // $19170
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5862, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2345; break; } else { __label__ = 12411; break; }
    case 2345: // $19171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5863, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2346; break; } else { __label__ = 12411; break; }
    case 2346: // $19172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2347; break; } else { __label__ = 12411; break; }
    case 2347: // $19173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2348; break; } else { __label__ = 12411; break; }
    case 2348: // $19174
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2349; break; } else { __label__ = 12411; break; }
    case 2349: // $19175
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2350; break; } else { __label__ = 12411; break; }
    case 2350: // $19176
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5860, $5861, $5862, $5863, $5864, $5865, $5866, $5867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2351; break; } else { __label__ = 12411; break; }
    case 2351: // $19177
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19169, 96, 2, 1, ((STRING_TABLE.__str483)|0), ((STRING_TABLE.__str484)|0), $5860) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2352; break; } else { __label__ = 12411; break; }
    case 2352: // $19178
      var $19179=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19169);
      var $19180=__ZN11simple_listI16input_type_entryE6appendERS0_($19130, $19179);
      var $19181=$4689;
      var $19182=$3949;
      var $19183=$3950;
      var $19184=$3951;
      var $19185=$result_i293;
      var $19186=$3952;
      var $19187=$3953;
      HEAP32[(($3949)>>2)]=408;
      HEAP32[(($3950)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3951)>>2)]=202;
      var $19188=HEAP32[(($3949)>>2)];
      var $19189=HEAP32[(($3950)>>2)];
      var $19190=HEAP32[(($3951)>>2)];
      var $19191=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19188, $19189, $19190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2353; break; } else { __label__ = 2355; break; };
    case 2353: // $19192
      HEAP32[(($result_i293)>>2)]=$19191;
      var $19193=HEAP32[(($result_i293)>>2)];
      var $19194=(($19193)|0)==0;
      if ($19194) { __label__ = 2354; break; } else { __label__ = 2359; break; }
    case 2354: // $19195
      var $19196=___cxa_allocate_exception(4);
      var $19197=$19196;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19197);
      (function() { try { __THREW__ = false; return ___cxa_throw($19196, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2358; break; } else { __label__ = 2355; break; }
    case 2355: // $19198
      var $19199=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19200=$19199.f0;
      HEAP32[(($3952)>>2)]=$19200;
      var $19201=$19199.f1;
      HEAP32[(($3953)>>2)]=$19201;
      var $19202=HEAP32[(($3953)>>2)];
      var $19203=(($19202)|0) < 0;
      if ($19203) { __label__ = 2356; break; } else { __label__ = 2357; break; }
    case 2356: // $19204
      var $19205=HEAP32[(($3952)>>2)];
      ___cxa_call_unexpected($19205);
      throw "Reached an unreachable!"
    case 2357: // $19206
      var $19207=HEAP32[(($3952)>>2)];
      var $19208=HEAP32[(($3952)>>2)];
      var $19209=HEAP32[(($3953)>>2)];
      var $19210=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19208, tempValue);
      var $19211=($19210.f1 = $19209, $19210);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2358: // $19212
      throw "Reached an unreachable!"
    case 2359: // $_ZnwjPKci_exit294
      var $19213=HEAP32[(($result_i293)>>2)];
      var $19214=$3949;
      var $19215=$3950;
      var $19216=$3951;
      var $19217=$result_i293;
      var $19218=$3952;
      var $19219=$3953;
      var $19220=$19213;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5869, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2360; break; } else { __label__ = 12416; break; }
    case 2360: // $19221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5870, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2361; break; } else { __label__ = 12416; break; }
    case 2361: // $19222
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5871, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2362; break; } else { __label__ = 12416; break; }
    case 2362: // $19223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2363; break; } else { __label__ = 12416; break; }
    case 2363: // $19224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2364; break; } else { __label__ = 12416; break; }
    case 2364: // $19225
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2365; break; } else { __label__ = 12416; break; }
    case 2365: // $19226
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2366; break; } else { __label__ = 12416; break; }
    case 2366: // $19227
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5868, $5869, $5870, $5871, $5872, $5873, $5874, $5875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2367; break; } else { __label__ = 12416; break; }
    case 2367: // $19228
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19220, 97, 2, 1, ((STRING_TABLE.__str485)|0), ((STRING_TABLE.__str486)|0), $5868) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2368; break; } else { __label__ = 12416; break; }
    case 2368: // $19229
      var $19230=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19220);
      var $19231=__ZN11simple_listI16input_type_entryE6appendERS0_($19181, $19230);
      var $19232=$4689;
      var $19233=$3944;
      var $19234=$3945;
      var $19235=$3946;
      var $19236=$result_i295;
      var $19237=$3947;
      var $19238=$3948;
      HEAP32[(($3944)>>2)]=408;
      HEAP32[(($3945)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3946)>>2)]=203;
      var $19239=HEAP32[(($3944)>>2)];
      var $19240=HEAP32[(($3945)>>2)];
      var $19241=HEAP32[(($3946)>>2)];
      var $19242=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19239, $19240, $19241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2369; break; } else { __label__ = 2371; break; };
    case 2369: // $19243
      HEAP32[(($result_i295)>>2)]=$19242;
      var $19244=HEAP32[(($result_i295)>>2)];
      var $19245=(($19244)|0)==0;
      if ($19245) { __label__ = 2370; break; } else { __label__ = 2375; break; }
    case 2370: // $19246
      var $19247=___cxa_allocate_exception(4);
      var $19248=$19247;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19248);
      (function() { try { __THREW__ = false; return ___cxa_throw($19247, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2374; break; } else { __label__ = 2371; break; }
    case 2371: // $19249
      var $19250=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19251=$19250.f0;
      HEAP32[(($3947)>>2)]=$19251;
      var $19252=$19250.f1;
      HEAP32[(($3948)>>2)]=$19252;
      var $19253=HEAP32[(($3948)>>2)];
      var $19254=(($19253)|0) < 0;
      if ($19254) { __label__ = 2372; break; } else { __label__ = 2373; break; }
    case 2372: // $19255
      var $19256=HEAP32[(($3947)>>2)];
      ___cxa_call_unexpected($19256);
      throw "Reached an unreachable!"
    case 2373: // $19257
      var $19258=HEAP32[(($3947)>>2)];
      var $19259=HEAP32[(($3947)>>2)];
      var $19260=HEAP32[(($3948)>>2)];
      var $19261=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19259, tempValue);
      var $19262=($19261.f1 = $19260, $19261);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2374: // $19263
      throw "Reached an unreachable!"
    case 2375: // $_ZnwjPKci_exit296
      var $19264=HEAP32[(($result_i295)>>2)];
      var $19265=$3944;
      var $19266=$3945;
      var $19267=$3946;
      var $19268=$result_i295;
      var $19269=$3947;
      var $19270=$3948;
      var $19271=$19264;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5877, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2376; break; } else { __label__ = 12421; break; }
    case 2376: // $19272
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5878, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2377; break; } else { __label__ = 12421; break; }
    case 2377: // $19273
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5879, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2378; break; } else { __label__ = 12421; break; }
    case 2378: // $19274
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2379; break; } else { __label__ = 12421; break; }
    case 2379: // $19275
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2380; break; } else { __label__ = 12421; break; }
    case 2380: // $19276
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2381; break; } else { __label__ = 12421; break; }
    case 2381: // $19277
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2382; break; } else { __label__ = 12421; break; }
    case 2382: // $19278
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5876, $5877, $5878, $5879, $5880, $5881, $5882, $5883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2383; break; } else { __label__ = 12421; break; }
    case 2383: // $19279
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19271, 98, 2, 1, ((STRING_TABLE.__str487)|0), ((STRING_TABLE.__str488)|0), $5876) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2384; break; } else { __label__ = 12421; break; }
    case 2384: // $19280
      var $19281=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19271);
      var $19282=__ZN11simple_listI16input_type_entryE6appendERS0_($19232, $19281);
      var $19283=$4689;
      var $19284=$3939;
      var $19285=$3940;
      var $19286=$3941;
      var $19287=$result_i297;
      var $19288=$3942;
      var $19289=$3943;
      HEAP32[(($3939)>>2)]=408;
      HEAP32[(($3940)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3941)>>2)]=204;
      var $19290=HEAP32[(($3939)>>2)];
      var $19291=HEAP32[(($3940)>>2)];
      var $19292=HEAP32[(($3941)>>2)];
      var $19293=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19290, $19291, $19292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2385; break; } else { __label__ = 2387; break; };
    case 2385: // $19294
      HEAP32[(($result_i297)>>2)]=$19293;
      var $19295=HEAP32[(($result_i297)>>2)];
      var $19296=(($19295)|0)==0;
      if ($19296) { __label__ = 2386; break; } else { __label__ = 2391; break; }
    case 2386: // $19297
      var $19298=___cxa_allocate_exception(4);
      var $19299=$19298;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19299);
      (function() { try { __THREW__ = false; return ___cxa_throw($19298, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2390; break; } else { __label__ = 2387; break; }
    case 2387: // $19300
      var $19301=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19302=$19301.f0;
      HEAP32[(($3942)>>2)]=$19302;
      var $19303=$19301.f1;
      HEAP32[(($3943)>>2)]=$19303;
      var $19304=HEAP32[(($3943)>>2)];
      var $19305=(($19304)|0) < 0;
      if ($19305) { __label__ = 2388; break; } else { __label__ = 2389; break; }
    case 2388: // $19306
      var $19307=HEAP32[(($3942)>>2)];
      ___cxa_call_unexpected($19307);
      throw "Reached an unreachable!"
    case 2389: // $19308
      var $19309=HEAP32[(($3942)>>2)];
      var $19310=HEAP32[(($3942)>>2)];
      var $19311=HEAP32[(($3943)>>2)];
      var $19312=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19310, tempValue);
      var $19313=($19312.f1 = $19311, $19312);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2390: // $19314
      throw "Reached an unreachable!"
    case 2391: // $_ZnwjPKci_exit298
      var $19315=HEAP32[(($result_i297)>>2)];
      var $19316=$3939;
      var $19317=$3940;
      var $19318=$3941;
      var $19319=$result_i297;
      var $19320=$3942;
      var $19321=$3943;
      var $19322=$19315;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5885, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2392; break; } else { __label__ = 12426; break; }
    case 2392: // $19323
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5886, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2393; break; } else { __label__ = 12426; break; }
    case 2393: // $19324
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5887, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2394; break; } else { __label__ = 12426; break; }
    case 2394: // $19325
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2395; break; } else { __label__ = 12426; break; }
    case 2395: // $19326
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2396; break; } else { __label__ = 12426; break; }
    case 2396: // $19327
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2397; break; } else { __label__ = 12426; break; }
    case 2397: // $19328
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2398; break; } else { __label__ = 12426; break; }
    case 2398: // $19329
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5884, $5885, $5886, $5887, $5888, $5889, $5890, $5891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2399; break; } else { __label__ = 12426; break; }
    case 2399: // $19330
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19322, 99, 2, 1, ((STRING_TABLE.__str489)|0), ((STRING_TABLE.__str490)|0), $5884) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2400; break; } else { __label__ = 12426; break; }
    case 2400: // $19331
      var $19332=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19322);
      var $19333=__ZN11simple_listI16input_type_entryE6appendERS0_($19283, $19332);
      var $19334=$4689;
      var $19335=$3934;
      var $19336=$3935;
      var $19337=$3936;
      var $19338=$result_i299;
      var $19339=$3937;
      var $19340=$3938;
      HEAP32[(($3934)>>2)]=408;
      HEAP32[(($3935)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3936)>>2)]=205;
      var $19341=HEAP32[(($3934)>>2)];
      var $19342=HEAP32[(($3935)>>2)];
      var $19343=HEAP32[(($3936)>>2)];
      var $19344=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19341, $19342, $19343) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2401; break; } else { __label__ = 2403; break; };
    case 2401: // $19345
      HEAP32[(($result_i299)>>2)]=$19344;
      var $19346=HEAP32[(($result_i299)>>2)];
      var $19347=(($19346)|0)==0;
      if ($19347) { __label__ = 2402; break; } else { __label__ = 2407; break; }
    case 2402: // $19348
      var $19349=___cxa_allocate_exception(4);
      var $19350=$19349;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19350);
      (function() { try { __THREW__ = false; return ___cxa_throw($19349, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2406; break; } else { __label__ = 2403; break; }
    case 2403: // $19351
      var $19352=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19353=$19352.f0;
      HEAP32[(($3937)>>2)]=$19353;
      var $19354=$19352.f1;
      HEAP32[(($3938)>>2)]=$19354;
      var $19355=HEAP32[(($3938)>>2)];
      var $19356=(($19355)|0) < 0;
      if ($19356) { __label__ = 2404; break; } else { __label__ = 2405; break; }
    case 2404: // $19357
      var $19358=HEAP32[(($3937)>>2)];
      ___cxa_call_unexpected($19358);
      throw "Reached an unreachable!"
    case 2405: // $19359
      var $19360=HEAP32[(($3937)>>2)];
      var $19361=HEAP32[(($3937)>>2)];
      var $19362=HEAP32[(($3938)>>2)];
      var $19363=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19361, tempValue);
      var $19364=($19363.f1 = $19362, $19363);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2406: // $19365
      throw "Reached an unreachable!"
    case 2407: // $_ZnwjPKci_exit300
      var $19366=HEAP32[(($result_i299)>>2)];
      var $19367=$3934;
      var $19368=$3935;
      var $19369=$3936;
      var $19370=$result_i299;
      var $19371=$3937;
      var $19372=$3938;
      var $19373=$19366;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5893, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2408; break; } else { __label__ = 12431; break; }
    case 2408: // $19374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5894, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2409; break; } else { __label__ = 12431; break; }
    case 2409: // $19375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5895, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2410; break; } else { __label__ = 12431; break; }
    case 2410: // $19376
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2411; break; } else { __label__ = 12431; break; }
    case 2411: // $19377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2412; break; } else { __label__ = 12431; break; }
    case 2412: // $19378
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2413; break; } else { __label__ = 12431; break; }
    case 2413: // $19379
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2414; break; } else { __label__ = 12431; break; }
    case 2414: // $19380
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5892, $5893, $5894, $5895, $5896, $5897, $5898, $5899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2415; break; } else { __label__ = 12431; break; }
    case 2415: // $19381
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19373, 100, 2, 1, ((STRING_TABLE.__str491)|0), ((STRING_TABLE.__str492)|0), $5892) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2416; break; } else { __label__ = 12431; break; }
    case 2416: // $19382
      var $19383=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19373);
      var $19384=__ZN11simple_listI16input_type_entryE6appendERS0_($19334, $19383);
      var $19385=$4689;
      var $19386=$3929;
      var $19387=$3930;
      var $19388=$3931;
      var $19389=$result_i301;
      var $19390=$3932;
      var $19391=$3933;
      HEAP32[(($3929)>>2)]=408;
      HEAP32[(($3930)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3931)>>2)]=206;
      var $19392=HEAP32[(($3929)>>2)];
      var $19393=HEAP32[(($3930)>>2)];
      var $19394=HEAP32[(($3931)>>2)];
      var $19395=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19392, $19393, $19394) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2417; break; } else { __label__ = 2419; break; };
    case 2417: // $19396
      HEAP32[(($result_i301)>>2)]=$19395;
      var $19397=HEAP32[(($result_i301)>>2)];
      var $19398=(($19397)|0)==0;
      if ($19398) { __label__ = 2418; break; } else { __label__ = 2423; break; }
    case 2418: // $19399
      var $19400=___cxa_allocate_exception(4);
      var $19401=$19400;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19401);
      (function() { try { __THREW__ = false; return ___cxa_throw($19400, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2422; break; } else { __label__ = 2419; break; }
    case 2419: // $19402
      var $19403=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19404=$19403.f0;
      HEAP32[(($3932)>>2)]=$19404;
      var $19405=$19403.f1;
      HEAP32[(($3933)>>2)]=$19405;
      var $19406=HEAP32[(($3933)>>2)];
      var $19407=(($19406)|0) < 0;
      if ($19407) { __label__ = 2420; break; } else { __label__ = 2421; break; }
    case 2420: // $19408
      var $19409=HEAP32[(($3932)>>2)];
      ___cxa_call_unexpected($19409);
      throw "Reached an unreachable!"
    case 2421: // $19410
      var $19411=HEAP32[(($3932)>>2)];
      var $19412=HEAP32[(($3932)>>2)];
      var $19413=HEAP32[(($3933)>>2)];
      var $19414=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19412, tempValue);
      var $19415=($19414.f1 = $19413, $19414);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2422: // $19416
      throw "Reached an unreachable!"
    case 2423: // $_ZnwjPKci_exit302
      var $19417=HEAP32[(($result_i301)>>2)];
      var $19418=$3929;
      var $19419=$3930;
      var $19420=$3931;
      var $19421=$result_i301;
      var $19422=$3932;
      var $19423=$3933;
      var $19424=$19417;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5901, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2424; break; } else { __label__ = 12436; break; }
    case 2424: // $19425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5902, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2425; break; } else { __label__ = 12436; break; }
    case 2425: // $19426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5903, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2426; break; } else { __label__ = 12436; break; }
    case 2426: // $19427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2427; break; } else { __label__ = 12436; break; }
    case 2427: // $19428
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2428; break; } else { __label__ = 12436; break; }
    case 2428: // $19429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2429; break; } else { __label__ = 12436; break; }
    case 2429: // $19430
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2430; break; } else { __label__ = 12436; break; }
    case 2430: // $19431
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5900, $5901, $5902, $5903, $5904, $5905, $5906, $5907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2431; break; } else { __label__ = 12436; break; }
    case 2431: // $19432
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19424, 101, 2, 1, ((STRING_TABLE.__str493)|0), ((STRING_TABLE.__str494)|0), $5900) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2432; break; } else { __label__ = 12436; break; }
    case 2432: // $19433
      var $19434=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19424);
      var $19435=__ZN11simple_listI16input_type_entryE6appendERS0_($19385, $19434);
      var $19436=$4689;
      var $19437=$3924;
      var $19438=$3925;
      var $19439=$3926;
      var $19440=$result_i303;
      var $19441=$3927;
      var $19442=$3928;
      HEAP32[(($3924)>>2)]=408;
      HEAP32[(($3925)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3926)>>2)]=207;
      var $19443=HEAP32[(($3924)>>2)];
      var $19444=HEAP32[(($3925)>>2)];
      var $19445=HEAP32[(($3926)>>2)];
      var $19446=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19443, $19444, $19445) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2433; break; } else { __label__ = 2435; break; };
    case 2433: // $19447
      HEAP32[(($result_i303)>>2)]=$19446;
      var $19448=HEAP32[(($result_i303)>>2)];
      var $19449=(($19448)|0)==0;
      if ($19449) { __label__ = 2434; break; } else { __label__ = 2439; break; }
    case 2434: // $19450
      var $19451=___cxa_allocate_exception(4);
      var $19452=$19451;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19452);
      (function() { try { __THREW__ = false; return ___cxa_throw($19451, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2438; break; } else { __label__ = 2435; break; }
    case 2435: // $19453
      var $19454=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19455=$19454.f0;
      HEAP32[(($3927)>>2)]=$19455;
      var $19456=$19454.f1;
      HEAP32[(($3928)>>2)]=$19456;
      var $19457=HEAP32[(($3928)>>2)];
      var $19458=(($19457)|0) < 0;
      if ($19458) { __label__ = 2436; break; } else { __label__ = 2437; break; }
    case 2436: // $19459
      var $19460=HEAP32[(($3927)>>2)];
      ___cxa_call_unexpected($19460);
      throw "Reached an unreachable!"
    case 2437: // $19461
      var $19462=HEAP32[(($3927)>>2)];
      var $19463=HEAP32[(($3927)>>2)];
      var $19464=HEAP32[(($3928)>>2)];
      var $19465=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19463, tempValue);
      var $19466=($19465.f1 = $19464, $19465);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2438: // $19467
      throw "Reached an unreachable!"
    case 2439: // $_ZnwjPKci_exit304
      var $19468=HEAP32[(($result_i303)>>2)];
      var $19469=$3924;
      var $19470=$3925;
      var $19471=$3926;
      var $19472=$result_i303;
      var $19473=$3927;
      var $19474=$3928;
      var $19475=$19468;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5909, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2440; break; } else { __label__ = 12441; break; }
    case 2440: // $19476
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5910, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2441; break; } else { __label__ = 12441; break; }
    case 2441: // $19477
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5911, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2442; break; } else { __label__ = 12441; break; }
    case 2442: // $19478
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2443; break; } else { __label__ = 12441; break; }
    case 2443: // $19479
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2444; break; } else { __label__ = 12441; break; }
    case 2444: // $19480
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2445; break; } else { __label__ = 12441; break; }
    case 2445: // $19481
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2446; break; } else { __label__ = 12441; break; }
    case 2446: // $19482
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5908, $5909, $5910, $5911, $5912, $5913, $5914, $5915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2447; break; } else { __label__ = 12441; break; }
    case 2447: // $19483
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19475, 102, 2, 1, ((STRING_TABLE.__str495)|0), ((STRING_TABLE.__str496)|0), $5908) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2448; break; } else { __label__ = 12441; break; }
    case 2448: // $19484
      var $19485=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19475);
      var $19486=__ZN11simple_listI16input_type_entryE6appendERS0_($19436, $19485);
      var $19487=$4689;
      var $19488=$3919;
      var $19489=$3920;
      var $19490=$3921;
      var $19491=$result_i305;
      var $19492=$3922;
      var $19493=$3923;
      HEAP32[(($3919)>>2)]=408;
      HEAP32[(($3920)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3921)>>2)]=208;
      var $19494=HEAP32[(($3919)>>2)];
      var $19495=HEAP32[(($3920)>>2)];
      var $19496=HEAP32[(($3921)>>2)];
      var $19497=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19494, $19495, $19496) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2449; break; } else { __label__ = 2451; break; };
    case 2449: // $19498
      HEAP32[(($result_i305)>>2)]=$19497;
      var $19499=HEAP32[(($result_i305)>>2)];
      var $19500=(($19499)|0)==0;
      if ($19500) { __label__ = 2450; break; } else { __label__ = 2455; break; }
    case 2450: // $19501
      var $19502=___cxa_allocate_exception(4);
      var $19503=$19502;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19503);
      (function() { try { __THREW__ = false; return ___cxa_throw($19502, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2454; break; } else { __label__ = 2451; break; }
    case 2451: // $19504
      var $19505=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19506=$19505.f0;
      HEAP32[(($3922)>>2)]=$19506;
      var $19507=$19505.f1;
      HEAP32[(($3923)>>2)]=$19507;
      var $19508=HEAP32[(($3923)>>2)];
      var $19509=(($19508)|0) < 0;
      if ($19509) { __label__ = 2452; break; } else { __label__ = 2453; break; }
    case 2452: // $19510
      var $19511=HEAP32[(($3922)>>2)];
      ___cxa_call_unexpected($19511);
      throw "Reached an unreachable!"
    case 2453: // $19512
      var $19513=HEAP32[(($3922)>>2)];
      var $19514=HEAP32[(($3922)>>2)];
      var $19515=HEAP32[(($3923)>>2)];
      var $19516=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19514, tempValue);
      var $19517=($19516.f1 = $19515, $19516);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2454: // $19518
      throw "Reached an unreachable!"
    case 2455: // $_ZnwjPKci_exit306
      var $19519=HEAP32[(($result_i305)>>2)];
      var $19520=$3919;
      var $19521=$3920;
      var $19522=$3921;
      var $19523=$result_i305;
      var $19524=$3922;
      var $19525=$3923;
      var $19526=$19519;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5917, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2456; break; } else { __label__ = 12446; break; }
    case 2456: // $19527
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5918, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2457; break; } else { __label__ = 12446; break; }
    case 2457: // $19528
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5919, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2458; break; } else { __label__ = 12446; break; }
    case 2458: // $19529
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2459; break; } else { __label__ = 12446; break; }
    case 2459: // $19530
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2460; break; } else { __label__ = 12446; break; }
    case 2460: // $19531
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2461; break; } else { __label__ = 12446; break; }
    case 2461: // $19532
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2462; break; } else { __label__ = 12446; break; }
    case 2462: // $19533
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5916, $5917, $5918, $5919, $5920, $5921, $5922, $5923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2463; break; } else { __label__ = 12446; break; }
    case 2463: // $19534
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19526, 103, 2, 1, ((STRING_TABLE.__str497)|0), ((STRING_TABLE.__str498)|0), $5916) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2464; break; } else { __label__ = 12446; break; }
    case 2464: // $19535
      var $19536=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19526);
      var $19537=__ZN11simple_listI16input_type_entryE6appendERS0_($19487, $19536);
      var $19538=$4689;
      var $19539=$3914;
      var $19540=$3915;
      var $19541=$3916;
      var $19542=$result_i307;
      var $19543=$3917;
      var $19544=$3918;
      HEAP32[(($3914)>>2)]=408;
      HEAP32[(($3915)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3916)>>2)]=209;
      var $19545=HEAP32[(($3914)>>2)];
      var $19546=HEAP32[(($3915)>>2)];
      var $19547=HEAP32[(($3916)>>2)];
      var $19548=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19545, $19546, $19547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2465; break; } else { __label__ = 2467; break; };
    case 2465: // $19549
      HEAP32[(($result_i307)>>2)]=$19548;
      var $19550=HEAP32[(($result_i307)>>2)];
      var $19551=(($19550)|0)==0;
      if ($19551) { __label__ = 2466; break; } else { __label__ = 2471; break; }
    case 2466: // $19552
      var $19553=___cxa_allocate_exception(4);
      var $19554=$19553;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19554);
      (function() { try { __THREW__ = false; return ___cxa_throw($19553, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2470; break; } else { __label__ = 2467; break; }
    case 2467: // $19555
      var $19556=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19557=$19556.f0;
      HEAP32[(($3917)>>2)]=$19557;
      var $19558=$19556.f1;
      HEAP32[(($3918)>>2)]=$19558;
      var $19559=HEAP32[(($3918)>>2)];
      var $19560=(($19559)|0) < 0;
      if ($19560) { __label__ = 2468; break; } else { __label__ = 2469; break; }
    case 2468: // $19561
      var $19562=HEAP32[(($3917)>>2)];
      ___cxa_call_unexpected($19562);
      throw "Reached an unreachable!"
    case 2469: // $19563
      var $19564=HEAP32[(($3917)>>2)];
      var $19565=HEAP32[(($3917)>>2)];
      var $19566=HEAP32[(($3918)>>2)];
      var $19567=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19565, tempValue);
      var $19568=($19567.f1 = $19566, $19567);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2470: // $19569
      throw "Reached an unreachable!"
    case 2471: // $_ZnwjPKci_exit308
      var $19570=HEAP32[(($result_i307)>>2)];
      var $19571=$3914;
      var $19572=$3915;
      var $19573=$3916;
      var $19574=$result_i307;
      var $19575=$3917;
      var $19576=$3918;
      var $19577=$19570;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5925, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2472; break; } else { __label__ = 12451; break; }
    case 2472: // $19578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5926, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2473; break; } else { __label__ = 12451; break; }
    case 2473: // $19579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5927, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2474; break; } else { __label__ = 12451; break; }
    case 2474: // $19580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2475; break; } else { __label__ = 12451; break; }
    case 2475: // $19581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2476; break; } else { __label__ = 12451; break; }
    case 2476: // $19582
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2477; break; } else { __label__ = 12451; break; }
    case 2477: // $19583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2478; break; } else { __label__ = 12451; break; }
    case 2478: // $19584
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5924, $5925, $5926, $5927, $5928, $5929, $5930, $5931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2479; break; } else { __label__ = 12451; break; }
    case 2479: // $19585
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19577, 104, 2, 1, ((STRING_TABLE.__str499)|0), ((STRING_TABLE.__str500)|0), $5924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2480; break; } else { __label__ = 12451; break; }
    case 2480: // $19586
      var $19587=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19577);
      var $19588=__ZN11simple_listI16input_type_entryE6appendERS0_($19538, $19587);
      var $19589=$4689;
      var $19590=$3909;
      var $19591=$3910;
      var $19592=$3911;
      var $19593=$result_i309;
      var $19594=$3912;
      var $19595=$3913;
      HEAP32[(($3909)>>2)]=408;
      HEAP32[(($3910)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3911)>>2)]=210;
      var $19596=HEAP32[(($3909)>>2)];
      var $19597=HEAP32[(($3910)>>2)];
      var $19598=HEAP32[(($3911)>>2)];
      var $19599=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19596, $19597, $19598) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2481; break; } else { __label__ = 2483; break; };
    case 2481: // $19600
      HEAP32[(($result_i309)>>2)]=$19599;
      var $19601=HEAP32[(($result_i309)>>2)];
      var $19602=(($19601)|0)==0;
      if ($19602) { __label__ = 2482; break; } else { __label__ = 2487; break; }
    case 2482: // $19603
      var $19604=___cxa_allocate_exception(4);
      var $19605=$19604;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19605);
      (function() { try { __THREW__ = false; return ___cxa_throw($19604, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2486; break; } else { __label__ = 2483; break; }
    case 2483: // $19606
      var $19607=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19608=$19607.f0;
      HEAP32[(($3912)>>2)]=$19608;
      var $19609=$19607.f1;
      HEAP32[(($3913)>>2)]=$19609;
      var $19610=HEAP32[(($3913)>>2)];
      var $19611=(($19610)|0) < 0;
      if ($19611) { __label__ = 2484; break; } else { __label__ = 2485; break; }
    case 2484: // $19612
      var $19613=HEAP32[(($3912)>>2)];
      ___cxa_call_unexpected($19613);
      throw "Reached an unreachable!"
    case 2485: // $19614
      var $19615=HEAP32[(($3912)>>2)];
      var $19616=HEAP32[(($3912)>>2)];
      var $19617=HEAP32[(($3913)>>2)];
      var $19618=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19616, tempValue);
      var $19619=($19618.f1 = $19617, $19618);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2486: // $19620
      throw "Reached an unreachable!"
    case 2487: // $_ZnwjPKci_exit310
      var $19621=HEAP32[(($result_i309)>>2)];
      var $19622=$3909;
      var $19623=$3910;
      var $19624=$3911;
      var $19625=$result_i309;
      var $19626=$3912;
      var $19627=$3913;
      var $19628=$19621;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5933, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2488; break; } else { __label__ = 12456; break; }
    case 2488: // $19629
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5934, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2489; break; } else { __label__ = 12456; break; }
    case 2489: // $19630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5935, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2490; break; } else { __label__ = 12456; break; }
    case 2490: // $19631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2491; break; } else { __label__ = 12456; break; }
    case 2491: // $19632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2492; break; } else { __label__ = 12456; break; }
    case 2492: // $19633
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2493; break; } else { __label__ = 12456; break; }
    case 2493: // $19634
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2494; break; } else { __label__ = 12456; break; }
    case 2494: // $19635
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5932, $5933, $5934, $5935, $5936, $5937, $5938, $5939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2495; break; } else { __label__ = 12456; break; }
    case 2495: // $19636
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19628, 105, 2, 1, ((STRING_TABLE.__str501)|0), ((STRING_TABLE.__str502)|0), $5932) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2496; break; } else { __label__ = 12456; break; }
    case 2496: // $19637
      var $19638=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19628);
      var $19639=__ZN11simple_listI16input_type_entryE6appendERS0_($19589, $19638);
      var $19640=$4689;
      var $19641=$3904;
      var $19642=$3905;
      var $19643=$3906;
      var $19644=$result_i311;
      var $19645=$3907;
      var $19646=$3908;
      HEAP32[(($3904)>>2)]=408;
      HEAP32[(($3905)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3906)>>2)]=211;
      var $19647=HEAP32[(($3904)>>2)];
      var $19648=HEAP32[(($3905)>>2)];
      var $19649=HEAP32[(($3906)>>2)];
      var $19650=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19647, $19648, $19649) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2497; break; } else { __label__ = 2499; break; };
    case 2497: // $19651
      HEAP32[(($result_i311)>>2)]=$19650;
      var $19652=HEAP32[(($result_i311)>>2)];
      var $19653=(($19652)|0)==0;
      if ($19653) { __label__ = 2498; break; } else { __label__ = 2503; break; }
    case 2498: // $19654
      var $19655=___cxa_allocate_exception(4);
      var $19656=$19655;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19656);
      (function() { try { __THREW__ = false; return ___cxa_throw($19655, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2502; break; } else { __label__ = 2499; break; }
    case 2499: // $19657
      var $19658=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19659=$19658.f0;
      HEAP32[(($3907)>>2)]=$19659;
      var $19660=$19658.f1;
      HEAP32[(($3908)>>2)]=$19660;
      var $19661=HEAP32[(($3908)>>2)];
      var $19662=(($19661)|0) < 0;
      if ($19662) { __label__ = 2500; break; } else { __label__ = 2501; break; }
    case 2500: // $19663
      var $19664=HEAP32[(($3907)>>2)];
      ___cxa_call_unexpected($19664);
      throw "Reached an unreachable!"
    case 2501: // $19665
      var $19666=HEAP32[(($3907)>>2)];
      var $19667=HEAP32[(($3907)>>2)];
      var $19668=HEAP32[(($3908)>>2)];
      var $19669=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19667, tempValue);
      var $19670=($19669.f1 = $19668, $19669);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2502: // $19671
      throw "Reached an unreachable!"
    case 2503: // $_ZnwjPKci_exit312
      var $19672=HEAP32[(($result_i311)>>2)];
      var $19673=$3904;
      var $19674=$3905;
      var $19675=$3906;
      var $19676=$result_i311;
      var $19677=$3907;
      var $19678=$3908;
      var $19679=$19672;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5941, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2504; break; } else { __label__ = 12461; break; }
    case 2504: // $19680
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5942, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2505; break; } else { __label__ = 12461; break; }
    case 2505: // $19681
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5943, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2506; break; } else { __label__ = 12461; break; }
    case 2506: // $19682
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2507; break; } else { __label__ = 12461; break; }
    case 2507: // $19683
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2508; break; } else { __label__ = 12461; break; }
    case 2508: // $19684
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2509; break; } else { __label__ = 12461; break; }
    case 2509: // $19685
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2510; break; } else { __label__ = 12461; break; }
    case 2510: // $19686
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5940, $5941, $5942, $5943, $5944, $5945, $5946, $5947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2511; break; } else { __label__ = 12461; break; }
    case 2511: // $19687
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19679, 106, 2, 1, ((STRING_TABLE.__str503)|0), ((STRING_TABLE.__str504)|0), $5940) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2512; break; } else { __label__ = 12461; break; }
    case 2512: // $19688
      var $19689=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19679);
      var $19690=__ZN11simple_listI16input_type_entryE6appendERS0_($19640, $19689);
      var $19691=$4689;
      var $19692=$3899;
      var $19693=$3900;
      var $19694=$3901;
      var $19695=$result_i313;
      var $19696=$3902;
      var $19697=$3903;
      HEAP32[(($3899)>>2)]=408;
      HEAP32[(($3900)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3901)>>2)]=212;
      var $19698=HEAP32[(($3899)>>2)];
      var $19699=HEAP32[(($3900)>>2)];
      var $19700=HEAP32[(($3901)>>2)];
      var $19701=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19698, $19699, $19700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2513; break; } else { __label__ = 2515; break; };
    case 2513: // $19702
      HEAP32[(($result_i313)>>2)]=$19701;
      var $19703=HEAP32[(($result_i313)>>2)];
      var $19704=(($19703)|0)==0;
      if ($19704) { __label__ = 2514; break; } else { __label__ = 2519; break; }
    case 2514: // $19705
      var $19706=___cxa_allocate_exception(4);
      var $19707=$19706;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19707);
      (function() { try { __THREW__ = false; return ___cxa_throw($19706, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2518; break; } else { __label__ = 2515; break; }
    case 2515: // $19708
      var $19709=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19710=$19709.f0;
      HEAP32[(($3902)>>2)]=$19710;
      var $19711=$19709.f1;
      HEAP32[(($3903)>>2)]=$19711;
      var $19712=HEAP32[(($3903)>>2)];
      var $19713=(($19712)|0) < 0;
      if ($19713) { __label__ = 2516; break; } else { __label__ = 2517; break; }
    case 2516: // $19714
      var $19715=HEAP32[(($3902)>>2)];
      ___cxa_call_unexpected($19715);
      throw "Reached an unreachable!"
    case 2517: // $19716
      var $19717=HEAP32[(($3902)>>2)];
      var $19718=HEAP32[(($3902)>>2)];
      var $19719=HEAP32[(($3903)>>2)];
      var $19720=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19718, tempValue);
      var $19721=($19720.f1 = $19719, $19720);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2518: // $19722
      throw "Reached an unreachable!"
    case 2519: // $_ZnwjPKci_exit314
      var $19723=HEAP32[(($result_i313)>>2)];
      var $19724=$3899;
      var $19725=$3900;
      var $19726=$3901;
      var $19727=$result_i313;
      var $19728=$3902;
      var $19729=$3903;
      var $19730=$19723;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5949, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2520; break; } else { __label__ = 12466; break; }
    case 2520: // $19731
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5950, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2521; break; } else { __label__ = 12466; break; }
    case 2521: // $19732
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5951, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2522; break; } else { __label__ = 12466; break; }
    case 2522: // $19733
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2523; break; } else { __label__ = 12466; break; }
    case 2523: // $19734
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2524; break; } else { __label__ = 12466; break; }
    case 2524: // $19735
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2525; break; } else { __label__ = 12466; break; }
    case 2525: // $19736
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2526; break; } else { __label__ = 12466; break; }
    case 2526: // $19737
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5948, $5949, $5950, $5951, $5952, $5953, $5954, $5955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2527; break; } else { __label__ = 12466; break; }
    case 2527: // $19738
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19730, 107, 2, 1, ((STRING_TABLE.__str505)|0), ((STRING_TABLE.__str506)|0), $5948) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2528; break; } else { __label__ = 12466; break; }
    case 2528: // $19739
      var $19740=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19730);
      var $19741=__ZN11simple_listI16input_type_entryE6appendERS0_($19691, $19740);
      var $19742=$4689;
      var $19743=$3894;
      var $19744=$3895;
      var $19745=$3896;
      var $19746=$result_i315;
      var $19747=$3897;
      var $19748=$3898;
      HEAP32[(($3894)>>2)]=408;
      HEAP32[(($3895)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3896)>>2)]=213;
      var $19749=HEAP32[(($3894)>>2)];
      var $19750=HEAP32[(($3895)>>2)];
      var $19751=HEAP32[(($3896)>>2)];
      var $19752=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19749, $19750, $19751) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2529; break; } else { __label__ = 2531; break; };
    case 2529: // $19753
      HEAP32[(($result_i315)>>2)]=$19752;
      var $19754=HEAP32[(($result_i315)>>2)];
      var $19755=(($19754)|0)==0;
      if ($19755) { __label__ = 2530; break; } else { __label__ = 2535; break; }
    case 2530: // $19756
      var $19757=___cxa_allocate_exception(4);
      var $19758=$19757;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19758);
      (function() { try { __THREW__ = false; return ___cxa_throw($19757, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2534; break; } else { __label__ = 2531; break; }
    case 2531: // $19759
      var $19760=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19761=$19760.f0;
      HEAP32[(($3897)>>2)]=$19761;
      var $19762=$19760.f1;
      HEAP32[(($3898)>>2)]=$19762;
      var $19763=HEAP32[(($3898)>>2)];
      var $19764=(($19763)|0) < 0;
      if ($19764) { __label__ = 2532; break; } else { __label__ = 2533; break; }
    case 2532: // $19765
      var $19766=HEAP32[(($3897)>>2)];
      ___cxa_call_unexpected($19766);
      throw "Reached an unreachable!"
    case 2533: // $19767
      var $19768=HEAP32[(($3897)>>2)];
      var $19769=HEAP32[(($3897)>>2)];
      var $19770=HEAP32[(($3898)>>2)];
      var $19771=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19769, tempValue);
      var $19772=($19771.f1 = $19770, $19771);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2534: // $19773
      throw "Reached an unreachable!"
    case 2535: // $_ZnwjPKci_exit316
      var $19774=HEAP32[(($result_i315)>>2)];
      var $19775=$3894;
      var $19776=$3895;
      var $19777=$3896;
      var $19778=$result_i315;
      var $19779=$3897;
      var $19780=$3898;
      var $19781=$19774;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5957, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2536; break; } else { __label__ = 12471; break; }
    case 2536: // $19782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2537; break; } else { __label__ = 12471; break; }
    case 2537: // $19783
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2538; break; } else { __label__ = 12471; break; }
    case 2538: // $19784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2539; break; } else { __label__ = 12471; break; }
    case 2539: // $19785
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2540; break; } else { __label__ = 12471; break; }
    case 2540: // $19786
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2541; break; } else { __label__ = 12471; break; }
    case 2541: // $19787
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2542; break; } else { __label__ = 12471; break; }
    case 2542: // $19788
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5956, $5957, $5958, $5959, $5960, $5961, $5962, $5963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2543; break; } else { __label__ = 12471; break; }
    case 2543: // $19789
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19781, 108, 2, 1, ((STRING_TABLE.__str507)|0), ((STRING_TABLE.__str508)|0), $5956) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2544; break; } else { __label__ = 12471; break; }
    case 2544: // $19790
      var $19791=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19781);
      var $19792=__ZN11simple_listI16input_type_entryE6appendERS0_($19742, $19791);
      var $19793=$4689;
      var $19794=$3889;
      var $19795=$3890;
      var $19796=$3891;
      var $19797=$result_i317;
      var $19798=$3892;
      var $19799=$3893;
      HEAP32[(($3889)>>2)]=408;
      HEAP32[(($3890)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3891)>>2)]=214;
      var $19800=HEAP32[(($3889)>>2)];
      var $19801=HEAP32[(($3890)>>2)];
      var $19802=HEAP32[(($3891)>>2)];
      var $19803=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19800, $19801, $19802) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2545; break; } else { __label__ = 2547; break; };
    case 2545: // $19804
      HEAP32[(($result_i317)>>2)]=$19803;
      var $19805=HEAP32[(($result_i317)>>2)];
      var $19806=(($19805)|0)==0;
      if ($19806) { __label__ = 2546; break; } else { __label__ = 2551; break; }
    case 2546: // $19807
      var $19808=___cxa_allocate_exception(4);
      var $19809=$19808;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19809);
      (function() { try { __THREW__ = false; return ___cxa_throw($19808, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2550; break; } else { __label__ = 2547; break; }
    case 2547: // $19810
      var $19811=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19812=$19811.f0;
      HEAP32[(($3892)>>2)]=$19812;
      var $19813=$19811.f1;
      HEAP32[(($3893)>>2)]=$19813;
      var $19814=HEAP32[(($3893)>>2)];
      var $19815=(($19814)|0) < 0;
      if ($19815) { __label__ = 2548; break; } else { __label__ = 2549; break; }
    case 2548: // $19816
      var $19817=HEAP32[(($3892)>>2)];
      ___cxa_call_unexpected($19817);
      throw "Reached an unreachable!"
    case 2549: // $19818
      var $19819=HEAP32[(($3892)>>2)];
      var $19820=HEAP32[(($3892)>>2)];
      var $19821=HEAP32[(($3893)>>2)];
      var $19822=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19820, tempValue);
      var $19823=($19822.f1 = $19821, $19822);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2550: // $19824
      throw "Reached an unreachable!"
    case 2551: // $_ZnwjPKci_exit318
      var $19825=HEAP32[(($result_i317)>>2)];
      var $19826=$3889;
      var $19827=$3890;
      var $19828=$3891;
      var $19829=$result_i317;
      var $19830=$3892;
      var $19831=$3893;
      var $19832=$19825;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5965, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2552; break; } else { __label__ = 12476; break; }
    case 2552: // $19833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5966, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2553; break; } else { __label__ = 12476; break; }
    case 2553: // $19834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5967, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2554; break; } else { __label__ = 12476; break; }
    case 2554: // $19835
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2555; break; } else { __label__ = 12476; break; }
    case 2555: // $19836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2556; break; } else { __label__ = 12476; break; }
    case 2556: // $19837
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2557; break; } else { __label__ = 12476; break; }
    case 2557: // $19838
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2558; break; } else { __label__ = 12476; break; }
    case 2558: // $19839
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5964, $5965, $5966, $5967, $5968, $5969, $5970, $5971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2559; break; } else { __label__ = 12476; break; }
    case 2559: // $19840
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19832, 109, 2, 1, ((STRING_TABLE.__str509)|0), ((STRING_TABLE.__str510)|0), $5964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2560; break; } else { __label__ = 12476; break; }
    case 2560: // $19841
      var $19842=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19832);
      var $19843=__ZN11simple_listI16input_type_entryE6appendERS0_($19793, $19842);
      var $19844=$4689;
      var $19845=$3884;
      var $19846=$3885;
      var $19847=$3886;
      var $19848=$result_i319;
      var $19849=$3887;
      var $19850=$3888;
      HEAP32[(($3884)>>2)]=408;
      HEAP32[(($3885)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3886)>>2)]=215;
      var $19851=HEAP32[(($3884)>>2)];
      var $19852=HEAP32[(($3885)>>2)];
      var $19853=HEAP32[(($3886)>>2)];
      var $19854=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19851, $19852, $19853) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2561; break; } else { __label__ = 2563; break; };
    case 2561: // $19855
      HEAP32[(($result_i319)>>2)]=$19854;
      var $19856=HEAP32[(($result_i319)>>2)];
      var $19857=(($19856)|0)==0;
      if ($19857) { __label__ = 2562; break; } else { __label__ = 2567; break; }
    case 2562: // $19858
      var $19859=___cxa_allocate_exception(4);
      var $19860=$19859;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19860);
      (function() { try { __THREW__ = false; return ___cxa_throw($19859, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2566; break; } else { __label__ = 2563; break; }
    case 2563: // $19861
      var $19862=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19863=$19862.f0;
      HEAP32[(($3887)>>2)]=$19863;
      var $19864=$19862.f1;
      HEAP32[(($3888)>>2)]=$19864;
      var $19865=HEAP32[(($3888)>>2)];
      var $19866=(($19865)|0) < 0;
      if ($19866) { __label__ = 2564; break; } else { __label__ = 2565; break; }
    case 2564: // $19867
      var $19868=HEAP32[(($3887)>>2)];
      ___cxa_call_unexpected($19868);
      throw "Reached an unreachable!"
    case 2565: // $19869
      var $19870=HEAP32[(($3887)>>2)];
      var $19871=HEAP32[(($3887)>>2)];
      var $19872=HEAP32[(($3888)>>2)];
      var $19873=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19871, tempValue);
      var $19874=($19873.f1 = $19872, $19873);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2566: // $19875
      throw "Reached an unreachable!"
    case 2567: // $_ZnwjPKci_exit320
      var $19876=HEAP32[(($result_i319)>>2)];
      var $19877=$3884;
      var $19878=$3885;
      var $19879=$3886;
      var $19880=$result_i319;
      var $19881=$3887;
      var $19882=$3888;
      var $19883=$19876;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5973, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2568; break; } else { __label__ = 12481; break; }
    case 2568: // $19884
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5974, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2569; break; } else { __label__ = 12481; break; }
    case 2569: // $19885
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5975, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2570; break; } else { __label__ = 12481; break; }
    case 2570: // $19886
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2571; break; } else { __label__ = 12481; break; }
    case 2571: // $19887
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2572; break; } else { __label__ = 12481; break; }
    case 2572: // $19888
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2573; break; } else { __label__ = 12481; break; }
    case 2573: // $19889
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2574; break; } else { __label__ = 12481; break; }
    case 2574: // $19890
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5972, $5973, $5974, $5975, $5976, $5977, $5978, $5979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2575; break; } else { __label__ = 12481; break; }
    case 2575: // $19891
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19883, 110, 2, 1, ((STRING_TABLE.__str511)|0), ((STRING_TABLE.__str512)|0), $5972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2576; break; } else { __label__ = 12481; break; }
    case 2576: // $19892
      var $19893=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19883);
      var $19894=__ZN11simple_listI16input_type_entryE6appendERS0_($19844, $19893);
      var $19895=$4689;
      var $19896=$3879;
      var $19897=$3880;
      var $19898=$3881;
      var $19899=$result_i321;
      var $19900=$3882;
      var $19901=$3883;
      HEAP32[(($3879)>>2)]=408;
      HEAP32[(($3880)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3881)>>2)]=216;
      var $19902=HEAP32[(($3879)>>2)];
      var $19903=HEAP32[(($3880)>>2)];
      var $19904=HEAP32[(($3881)>>2)];
      var $19905=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19902, $19903, $19904) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2577; break; } else { __label__ = 2579; break; };
    case 2577: // $19906
      HEAP32[(($result_i321)>>2)]=$19905;
      var $19907=HEAP32[(($result_i321)>>2)];
      var $19908=(($19907)|0)==0;
      if ($19908) { __label__ = 2578; break; } else { __label__ = 2583; break; }
    case 2578: // $19909
      var $19910=___cxa_allocate_exception(4);
      var $19911=$19910;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19911);
      (function() { try { __THREW__ = false; return ___cxa_throw($19910, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2582; break; } else { __label__ = 2579; break; }
    case 2579: // $19912
      var $19913=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19914=$19913.f0;
      HEAP32[(($3882)>>2)]=$19914;
      var $19915=$19913.f1;
      HEAP32[(($3883)>>2)]=$19915;
      var $19916=HEAP32[(($3883)>>2)];
      var $19917=(($19916)|0) < 0;
      if ($19917) { __label__ = 2580; break; } else { __label__ = 2581; break; }
    case 2580: // $19918
      var $19919=HEAP32[(($3882)>>2)];
      ___cxa_call_unexpected($19919);
      throw "Reached an unreachable!"
    case 2581: // $19920
      var $19921=HEAP32[(($3882)>>2)];
      var $19922=HEAP32[(($3882)>>2)];
      var $19923=HEAP32[(($3883)>>2)];
      var $19924=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19922, tempValue);
      var $19925=($19924.f1 = $19923, $19924);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2582: // $19926
      throw "Reached an unreachable!"
    case 2583: // $_ZnwjPKci_exit322
      var $19927=HEAP32[(($result_i321)>>2)];
      var $19928=$3879;
      var $19929=$3880;
      var $19930=$3881;
      var $19931=$result_i321;
      var $19932=$3882;
      var $19933=$3883;
      var $19934=$19927;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5981, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2584; break; } else { __label__ = 12486; break; }
    case 2584: // $19935
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2585; break; } else { __label__ = 12486; break; }
    case 2585: // $19936
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2586; break; } else { __label__ = 12486; break; }
    case 2586: // $19937
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2587; break; } else { __label__ = 12486; break; }
    case 2587: // $19938
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2588; break; } else { __label__ = 12486; break; }
    case 2588: // $19939
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2589; break; } else { __label__ = 12486; break; }
    case 2589: // $19940
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2590; break; } else { __label__ = 12486; break; }
    case 2590: // $19941
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5980, $5981, $5982, $5983, $5984, $5985, $5986, $5987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2591; break; } else { __label__ = 12486; break; }
    case 2591: // $19942
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19934, 111, 2, 1, ((STRING_TABLE.__str513)|0), ((STRING_TABLE.__str514)|0), $5980) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2592; break; } else { __label__ = 12486; break; }
    case 2592: // $19943
      var $19944=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19934);
      var $19945=__ZN11simple_listI16input_type_entryE6appendERS0_($19895, $19944);
      var $19946=$4689;
      var $19947=$3874;
      var $19948=$3875;
      var $19949=$3876;
      var $19950=$result_i323;
      var $19951=$3877;
      var $19952=$3878;
      HEAP32[(($3874)>>2)]=408;
      HEAP32[(($3875)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3876)>>2)]=217;
      var $19953=HEAP32[(($3874)>>2)];
      var $19954=HEAP32[(($3875)>>2)];
      var $19955=HEAP32[(($3876)>>2)];
      var $19956=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19953, $19954, $19955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2593; break; } else { __label__ = 2595; break; };
    case 2593: // $19957
      HEAP32[(($result_i323)>>2)]=$19956;
      var $19958=HEAP32[(($result_i323)>>2)];
      var $19959=(($19958)|0)==0;
      if ($19959) { __label__ = 2594; break; } else { __label__ = 2599; break; }
    case 2594: // $19960
      var $19961=___cxa_allocate_exception(4);
      var $19962=$19961;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($19962);
      (function() { try { __THREW__ = false; return ___cxa_throw($19961, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2598; break; } else { __label__ = 2595; break; }
    case 2595: // $19963
      var $19964=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19965=$19964.f0;
      HEAP32[(($3877)>>2)]=$19965;
      var $19966=$19964.f1;
      HEAP32[(($3878)>>2)]=$19966;
      var $19967=HEAP32[(($3878)>>2)];
      var $19968=(($19967)|0) < 0;
      if ($19968) { __label__ = 2596; break; } else { __label__ = 2597; break; }
    case 2596: // $19969
      var $19970=HEAP32[(($3877)>>2)];
      ___cxa_call_unexpected($19970);
      throw "Reached an unreachable!"
    case 2597: // $19971
      var $19972=HEAP32[(($3877)>>2)];
      var $19973=HEAP32[(($3877)>>2)];
      var $19974=HEAP32[(($3878)>>2)];
      var $19975=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19973, tempValue);
      var $19976=($19975.f1 = $19974, $19975);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2598: // $19977
      throw "Reached an unreachable!"
    case 2599: // $_ZnwjPKci_exit324
      var $19978=HEAP32[(($result_i323)>>2)];
      var $19979=$3874;
      var $19980=$3875;
      var $19981=$3876;
      var $19982=$result_i323;
      var $19983=$3877;
      var $19984=$3878;
      var $19985=$19978;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5989, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2600; break; } else { __label__ = 12491; break; }
    case 2600: // $19986
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5990, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2601; break; } else { __label__ = 12491; break; }
    case 2601: // $19987
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5991, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2602; break; } else { __label__ = 12491; break; }
    case 2602: // $19988
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2603; break; } else { __label__ = 12491; break; }
    case 2603: // $19989
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2604; break; } else { __label__ = 12491; break; }
    case 2604: // $19990
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2605; break; } else { __label__ = 12491; break; }
    case 2605: // $19991
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2606; break; } else { __label__ = 12491; break; }
    case 2606: // $19992
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5988, $5989, $5990, $5991, $5992, $5993, $5994, $5995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2607; break; } else { __label__ = 12491; break; }
    case 2607: // $19993
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($19985, 112, 2, 1, ((STRING_TABLE.__str515)|0), ((STRING_TABLE.__str516411)|0), $5988) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2608; break; } else { __label__ = 12491; break; }
    case 2608: // $19994
      var $19995=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $19985);
      var $19996=__ZN11simple_listI16input_type_entryE6appendERS0_($19946, $19995);
      var $19997=$4689;
      var $19998=$3869;
      var $19999=$3870;
      var $20000=$3871;
      var $20001=$result_i325;
      var $20002=$3872;
      var $20003=$3873;
      HEAP32[(($3869)>>2)]=408;
      HEAP32[(($3870)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3871)>>2)]=218;
      var $20004=HEAP32[(($3869)>>2)];
      var $20005=HEAP32[(($3870)>>2)];
      var $20006=HEAP32[(($3871)>>2)];
      var $20007=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20004, $20005, $20006) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2609; break; } else { __label__ = 2611; break; };
    case 2609: // $20008
      HEAP32[(($result_i325)>>2)]=$20007;
      var $20009=HEAP32[(($result_i325)>>2)];
      var $20010=(($20009)|0)==0;
      if ($20010) { __label__ = 2610; break; } else { __label__ = 2615; break; }
    case 2610: // $20011
      var $20012=___cxa_allocate_exception(4);
      var $20013=$20012;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20013);
      (function() { try { __THREW__ = false; return ___cxa_throw($20012, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2614; break; } else { __label__ = 2611; break; }
    case 2611: // $20014
      var $20015=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20016=$20015.f0;
      HEAP32[(($3872)>>2)]=$20016;
      var $20017=$20015.f1;
      HEAP32[(($3873)>>2)]=$20017;
      var $20018=HEAP32[(($3873)>>2)];
      var $20019=(($20018)|0) < 0;
      if ($20019) { __label__ = 2612; break; } else { __label__ = 2613; break; }
    case 2612: // $20020
      var $20021=HEAP32[(($3872)>>2)];
      ___cxa_call_unexpected($20021);
      throw "Reached an unreachable!"
    case 2613: // $20022
      var $20023=HEAP32[(($3872)>>2)];
      var $20024=HEAP32[(($3872)>>2)];
      var $20025=HEAP32[(($3873)>>2)];
      var $20026=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20024, tempValue);
      var $20027=($20026.f1 = $20025, $20026);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2614: // $20028
      throw "Reached an unreachable!"
    case 2615: // $_ZnwjPKci_exit326
      var $20029=HEAP32[(($result_i325)>>2)];
      var $20030=$3869;
      var $20031=$3870;
      var $20032=$3871;
      var $20033=$result_i325;
      var $20034=$3872;
      var $20035=$3873;
      var $20036=$20029;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5997, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2616; break; } else { __label__ = 12496; break; }
    case 2616: // $20037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5998, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2617; break; } else { __label__ = 12496; break; }
    case 2617: // $20038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5999, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2618; break; } else { __label__ = 12496; break; }
    case 2618: // $20039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2619; break; } else { __label__ = 12496; break; }
    case 2619: // $20040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2620; break; } else { __label__ = 12496; break; }
    case 2620: // $20041
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2621; break; } else { __label__ = 12496; break; }
    case 2621: // $20042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2622; break; } else { __label__ = 12496; break; }
    case 2622: // $20043
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($5996, $5997, $5998, $5999, $6000, $6001, $6002, $6003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2623; break; } else { __label__ = 12496; break; }
    case 2623: // $20044
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20036, 113, 2, 1, ((STRING_TABLE.__str517)|0), ((STRING_TABLE.__str518)|0), $5996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2624; break; } else { __label__ = 12496; break; }
    case 2624: // $20045
      var $20046=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20036);
      var $20047=__ZN11simple_listI16input_type_entryE6appendERS0_($19997, $20046);
      var $20048=$4689;
      var $20049=$3864;
      var $20050=$3865;
      var $20051=$3866;
      var $20052=$result_i327;
      var $20053=$3867;
      var $20054=$3868;
      HEAP32[(($3864)>>2)]=408;
      HEAP32[(($3865)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3866)>>2)]=220;
      var $20055=HEAP32[(($3864)>>2)];
      var $20056=HEAP32[(($3865)>>2)];
      var $20057=HEAP32[(($3866)>>2)];
      var $20058=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20055, $20056, $20057) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2625; break; } else { __label__ = 2627; break; };
    case 2625: // $20059
      HEAP32[(($result_i327)>>2)]=$20058;
      var $20060=HEAP32[(($result_i327)>>2)];
      var $20061=(($20060)|0)==0;
      if ($20061) { __label__ = 2626; break; } else { __label__ = 2631; break; }
    case 2626: // $20062
      var $20063=___cxa_allocate_exception(4);
      var $20064=$20063;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20064);
      (function() { try { __THREW__ = false; return ___cxa_throw($20063, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2630; break; } else { __label__ = 2627; break; }
    case 2627: // $20065
      var $20066=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20067=$20066.f0;
      HEAP32[(($3867)>>2)]=$20067;
      var $20068=$20066.f1;
      HEAP32[(($3868)>>2)]=$20068;
      var $20069=HEAP32[(($3868)>>2)];
      var $20070=(($20069)|0) < 0;
      if ($20070) { __label__ = 2628; break; } else { __label__ = 2629; break; }
    case 2628: // $20071
      var $20072=HEAP32[(($3867)>>2)];
      ___cxa_call_unexpected($20072);
      throw "Reached an unreachable!"
    case 2629: // $20073
      var $20074=HEAP32[(($3867)>>2)];
      var $20075=HEAP32[(($3867)>>2)];
      var $20076=HEAP32[(($3868)>>2)];
      var $20077=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20075, tempValue);
      var $20078=($20077.f1 = $20076, $20077);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2630: // $20079
      throw "Reached an unreachable!"
    case 2631: // $_ZnwjPKci_exit328
      var $20080=HEAP32[(($result_i327)>>2)];
      var $20081=$3864;
      var $20082=$3865;
      var $20083=$3866;
      var $20084=$result_i327;
      var $20085=$3867;
      var $20086=$3868;
      var $20087=$20080;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6005, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2632; break; } else { __label__ = 12501; break; }
    case 2632: // $20088
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6006, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2633; break; } else { __label__ = 12501; break; }
    case 2633: // $20089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6007, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2634; break; } else { __label__ = 12501; break; }
    case 2634: // $20090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2635; break; } else { __label__ = 12501; break; }
    case 2635: // $20091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2636; break; } else { __label__ = 12501; break; }
    case 2636: // $20092
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2637; break; } else { __label__ = 12501; break; }
    case 2637: // $20093
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2638; break; } else { __label__ = 12501; break; }
    case 2638: // $20094
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6004, $6005, $6006, $6007, $6008, $6009, $6010, $6011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2639; break; } else { __label__ = 12501; break; }
    case 2639: // $20095
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20087, 47, 3, 2, ((STRING_TABLE.__str519)|0), ((STRING_TABLE.__str520)|0), $6004) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2640; break; } else { __label__ = 12501; break; }
    case 2640: // $20096
      var $20097=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20087);
      var $20098=__ZN11simple_listI16input_type_entryE6appendERS0_($20048, $20097);
      var $20099=$4689;
      var $20100=$3859;
      var $20101=$3860;
      var $20102=$3861;
      var $20103=$result_i329;
      var $20104=$3862;
      var $20105=$3863;
      HEAP32[(($3859)>>2)]=408;
      HEAP32[(($3860)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3861)>>2)]=221;
      var $20106=HEAP32[(($3859)>>2)];
      var $20107=HEAP32[(($3860)>>2)];
      var $20108=HEAP32[(($3861)>>2)];
      var $20109=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20106, $20107, $20108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2641; break; } else { __label__ = 2643; break; };
    case 2641: // $20110
      HEAP32[(($result_i329)>>2)]=$20109;
      var $20111=HEAP32[(($result_i329)>>2)];
      var $20112=(($20111)|0)==0;
      if ($20112) { __label__ = 2642; break; } else { __label__ = 2647; break; }
    case 2642: // $20113
      var $20114=___cxa_allocate_exception(4);
      var $20115=$20114;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20115);
      (function() { try { __THREW__ = false; return ___cxa_throw($20114, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2646; break; } else { __label__ = 2643; break; }
    case 2643: // $20116
      var $20117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20118=$20117.f0;
      HEAP32[(($3862)>>2)]=$20118;
      var $20119=$20117.f1;
      HEAP32[(($3863)>>2)]=$20119;
      var $20120=HEAP32[(($3863)>>2)];
      var $20121=(($20120)|0) < 0;
      if ($20121) { __label__ = 2644; break; } else { __label__ = 2645; break; }
    case 2644: // $20122
      var $20123=HEAP32[(($3862)>>2)];
      ___cxa_call_unexpected($20123);
      throw "Reached an unreachable!"
    case 2645: // $20124
      var $20125=HEAP32[(($3862)>>2)];
      var $20126=HEAP32[(($3862)>>2)];
      var $20127=HEAP32[(($3863)>>2)];
      var $20128=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20126, tempValue);
      var $20129=($20128.f1 = $20127, $20128);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2646: // $20130
      throw "Reached an unreachable!"
    case 2647: // $_ZnwjPKci_exit330
      var $20131=HEAP32[(($result_i329)>>2)];
      var $20132=$3859;
      var $20133=$3860;
      var $20134=$3861;
      var $20135=$result_i329;
      var $20136=$3862;
      var $20137=$3863;
      var $20138=$20131;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6013, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2648; break; } else { __label__ = 12506; break; }
    case 2648: // $20139
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6014, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2649; break; } else { __label__ = 12506; break; }
    case 2649: // $20140
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6015, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2650; break; } else { __label__ = 12506; break; }
    case 2650: // $20141
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2651; break; } else { __label__ = 12506; break; }
    case 2651: // $20142
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2652; break; } else { __label__ = 12506; break; }
    case 2652: // $20143
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2653; break; } else { __label__ = 12506; break; }
    case 2653: // $20144
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2654; break; } else { __label__ = 12506; break; }
    case 2654: // $20145
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6012, $6013, $6014, $6015, $6016, $6017, $6018, $6019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2655; break; } else { __label__ = 12506; break; }
    case 2655: // $20146
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20138, 48, 3, 2, ((STRING_TABLE.__str521)|0), ((STRING_TABLE.__str522)|0), $6012) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2656; break; } else { __label__ = 12506; break; }
    case 2656: // $20147
      var $20148=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20138);
      var $20149=__ZN11simple_listI16input_type_entryE6appendERS0_($20099, $20148);
      var $20150=$4689;
      var $20151=$3854;
      var $20152=$3855;
      var $20153=$3856;
      var $20154=$result_i331;
      var $20155=$3857;
      var $20156=$3858;
      HEAP32[(($3854)>>2)]=408;
      HEAP32[(($3855)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3856)>>2)]=222;
      var $20157=HEAP32[(($3854)>>2)];
      var $20158=HEAP32[(($3855)>>2)];
      var $20159=HEAP32[(($3856)>>2)];
      var $20160=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20157, $20158, $20159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2657; break; } else { __label__ = 2659; break; };
    case 2657: // $20161
      HEAP32[(($result_i331)>>2)]=$20160;
      var $20162=HEAP32[(($result_i331)>>2)];
      var $20163=(($20162)|0)==0;
      if ($20163) { __label__ = 2658; break; } else { __label__ = 2663; break; }
    case 2658: // $20164
      var $20165=___cxa_allocate_exception(4);
      var $20166=$20165;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20166);
      (function() { try { __THREW__ = false; return ___cxa_throw($20165, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2662; break; } else { __label__ = 2659; break; }
    case 2659: // $20167
      var $20168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20169=$20168.f0;
      HEAP32[(($3857)>>2)]=$20169;
      var $20170=$20168.f1;
      HEAP32[(($3858)>>2)]=$20170;
      var $20171=HEAP32[(($3858)>>2)];
      var $20172=(($20171)|0) < 0;
      if ($20172) { __label__ = 2660; break; } else { __label__ = 2661; break; }
    case 2660: // $20173
      var $20174=HEAP32[(($3857)>>2)];
      ___cxa_call_unexpected($20174);
      throw "Reached an unreachable!"
    case 2661: // $20175
      var $20176=HEAP32[(($3857)>>2)];
      var $20177=HEAP32[(($3857)>>2)];
      var $20178=HEAP32[(($3858)>>2)];
      var $20179=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20177, tempValue);
      var $20180=($20179.f1 = $20178, $20179);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2662: // $20181
      throw "Reached an unreachable!"
    case 2663: // $_ZnwjPKci_exit332
      var $20182=HEAP32[(($result_i331)>>2)];
      var $20183=$3854;
      var $20184=$3855;
      var $20185=$3856;
      var $20186=$result_i331;
      var $20187=$3857;
      var $20188=$3858;
      var $20189=$20182;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6021, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2664; break; } else { __label__ = 12511; break; }
    case 2664: // $20190
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6022, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2665; break; } else { __label__ = 12511; break; }
    case 2665: // $20191
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6023, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2666; break; } else { __label__ = 12511; break; }
    case 2666: // $20192
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2667; break; } else { __label__ = 12511; break; }
    case 2667: // $20193
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2668; break; } else { __label__ = 12511; break; }
    case 2668: // $20194
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2669; break; } else { __label__ = 12511; break; }
    case 2669: // $20195
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2670; break; } else { __label__ = 12511; break; }
    case 2670: // $20196
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6020, $6021, $6022, $6023, $6024, $6025, $6026, $6027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2671; break; } else { __label__ = 12511; break; }
    case 2671: // $20197
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20189, 49, 3, 2, ((STRING_TABLE.__str523)|0), ((STRING_TABLE.__str524)|0), $6020) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2672; break; } else { __label__ = 12511; break; }
    case 2672: // $20198
      var $20199=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20189);
      var $20200=__ZN11simple_listI16input_type_entryE6appendERS0_($20150, $20199);
      var $20201=$4689;
      var $20202=$3849;
      var $20203=$3850;
      var $20204=$3851;
      var $20205=$result_i333;
      var $20206=$3852;
      var $20207=$3853;
      HEAP32[(($3849)>>2)]=408;
      HEAP32[(($3850)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3851)>>2)]=223;
      var $20208=HEAP32[(($3849)>>2)];
      var $20209=HEAP32[(($3850)>>2)];
      var $20210=HEAP32[(($3851)>>2)];
      var $20211=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20208, $20209, $20210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2673; break; } else { __label__ = 2675; break; };
    case 2673: // $20212
      HEAP32[(($result_i333)>>2)]=$20211;
      var $20213=HEAP32[(($result_i333)>>2)];
      var $20214=(($20213)|0)==0;
      if ($20214) { __label__ = 2674; break; } else { __label__ = 2679; break; }
    case 2674: // $20215
      var $20216=___cxa_allocate_exception(4);
      var $20217=$20216;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20217);
      (function() { try { __THREW__ = false; return ___cxa_throw($20216, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2678; break; } else { __label__ = 2675; break; }
    case 2675: // $20218
      var $20219=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20220=$20219.f0;
      HEAP32[(($3852)>>2)]=$20220;
      var $20221=$20219.f1;
      HEAP32[(($3853)>>2)]=$20221;
      var $20222=HEAP32[(($3853)>>2)];
      var $20223=(($20222)|0) < 0;
      if ($20223) { __label__ = 2676; break; } else { __label__ = 2677; break; }
    case 2676: // $20224
      var $20225=HEAP32[(($3852)>>2)];
      ___cxa_call_unexpected($20225);
      throw "Reached an unreachable!"
    case 2677: // $20226
      var $20227=HEAP32[(($3852)>>2)];
      var $20228=HEAP32[(($3852)>>2)];
      var $20229=HEAP32[(($3853)>>2)];
      var $20230=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20228, tempValue);
      var $20231=($20230.f1 = $20229, $20230);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2678: // $20232
      throw "Reached an unreachable!"
    case 2679: // $_ZnwjPKci_exit334
      var $20233=HEAP32[(($result_i333)>>2)];
      var $20234=$3849;
      var $20235=$3850;
      var $20236=$3851;
      var $20237=$result_i333;
      var $20238=$3852;
      var $20239=$3853;
      var $20240=$20233;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6029, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2680; break; } else { __label__ = 12516; break; }
    case 2680: // $20241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6030, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2681; break; } else { __label__ = 12516; break; }
    case 2681: // $20242
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6031, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2682; break; } else { __label__ = 12516; break; }
    case 2682: // $20243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2683; break; } else { __label__ = 12516; break; }
    case 2683: // $20244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2684; break; } else { __label__ = 12516; break; }
    case 2684: // $20245
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2685; break; } else { __label__ = 12516; break; }
    case 2685: // $20246
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2686; break; } else { __label__ = 12516; break; }
    case 2686: // $20247
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6028, $6029, $6030, $6031, $6032, $6033, $6034, $6035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2687; break; } else { __label__ = 12516; break; }
    case 2687: // $20248
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20240, 50, 3, 2, ((STRING_TABLE.__str525)|0), ((STRING_TABLE.__str526)|0), $6028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2688; break; } else { __label__ = 12516; break; }
    case 2688: // $20249
      var $20250=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20240);
      var $20251=__ZN11simple_listI16input_type_entryE6appendERS0_($20201, $20250);
      var $20252=$4689;
      var $20253=$3844;
      var $20254=$3845;
      var $20255=$3846;
      var $20256=$result_i335;
      var $20257=$3847;
      var $20258=$3848;
      HEAP32[(($3844)>>2)]=408;
      HEAP32[(($3845)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3846)>>2)]=224;
      var $20259=HEAP32[(($3844)>>2)];
      var $20260=HEAP32[(($3845)>>2)];
      var $20261=HEAP32[(($3846)>>2)];
      var $20262=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20259, $20260, $20261) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2689; break; } else { __label__ = 2691; break; };
    case 2689: // $20263
      HEAP32[(($result_i335)>>2)]=$20262;
      var $20264=HEAP32[(($result_i335)>>2)];
      var $20265=(($20264)|0)==0;
      if ($20265) { __label__ = 2690; break; } else { __label__ = 2695; break; }
    case 2690: // $20266
      var $20267=___cxa_allocate_exception(4);
      var $20268=$20267;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20268);
      (function() { try { __THREW__ = false; return ___cxa_throw($20267, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2694; break; } else { __label__ = 2691; break; }
    case 2691: // $20269
      var $20270=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20271=$20270.f0;
      HEAP32[(($3847)>>2)]=$20271;
      var $20272=$20270.f1;
      HEAP32[(($3848)>>2)]=$20272;
      var $20273=HEAP32[(($3848)>>2)];
      var $20274=(($20273)|0) < 0;
      if ($20274) { __label__ = 2692; break; } else { __label__ = 2693; break; }
    case 2692: // $20275
      var $20276=HEAP32[(($3847)>>2)];
      ___cxa_call_unexpected($20276);
      throw "Reached an unreachable!"
    case 2693: // $20277
      var $20278=HEAP32[(($3847)>>2)];
      var $20279=HEAP32[(($3847)>>2)];
      var $20280=HEAP32[(($3848)>>2)];
      var $20281=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20279, tempValue);
      var $20282=($20281.f1 = $20280, $20281);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2694: // $20283
      throw "Reached an unreachable!"
    case 2695: // $_ZnwjPKci_exit336
      var $20284=HEAP32[(($result_i335)>>2)];
      var $20285=$3844;
      var $20286=$3845;
      var $20287=$3846;
      var $20288=$result_i335;
      var $20289=$3847;
      var $20290=$3848;
      var $20291=$20284;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6037, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2696; break; } else { __label__ = 12521; break; }
    case 2696: // $20292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6038, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2697; break; } else { __label__ = 12521; break; }
    case 2697: // $20293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6039, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2698; break; } else { __label__ = 12521; break; }
    case 2698: // $20294
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2699; break; } else { __label__ = 12521; break; }
    case 2699: // $20295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2700; break; } else { __label__ = 12521; break; }
    case 2700: // $20296
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2701; break; } else { __label__ = 12521; break; }
    case 2701: // $20297
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2702; break; } else { __label__ = 12521; break; }
    case 2702: // $20298
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6036, $6037, $6038, $6039, $6040, $6041, $6042, $6043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2703; break; } else { __label__ = 12521; break; }
    case 2703: // $20299
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20291, 51, 3, 2, ((STRING_TABLE.__str527)|0), ((STRING_TABLE.__str528)|0), $6036) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2704; break; } else { __label__ = 12521; break; }
    case 2704: // $20300
      var $20301=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20291);
      var $20302=__ZN11simple_listI16input_type_entryE6appendERS0_($20252, $20301);
      var $20303=$4689;
      var $20304=$3839;
      var $20305=$3840;
      var $20306=$3841;
      var $20307=$result_i337;
      var $20308=$3842;
      var $20309=$3843;
      HEAP32[(($3839)>>2)]=408;
      HEAP32[(($3840)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3841)>>2)]=225;
      var $20310=HEAP32[(($3839)>>2)];
      var $20311=HEAP32[(($3840)>>2)];
      var $20312=HEAP32[(($3841)>>2)];
      var $20313=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20310, $20311, $20312) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2705; break; } else { __label__ = 2707; break; };
    case 2705: // $20314
      HEAP32[(($result_i337)>>2)]=$20313;
      var $20315=HEAP32[(($result_i337)>>2)];
      var $20316=(($20315)|0)==0;
      if ($20316) { __label__ = 2706; break; } else { __label__ = 2711; break; }
    case 2706: // $20317
      var $20318=___cxa_allocate_exception(4);
      var $20319=$20318;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20319);
      (function() { try { __THREW__ = false; return ___cxa_throw($20318, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2710; break; } else { __label__ = 2707; break; }
    case 2707: // $20320
      var $20321=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20322=$20321.f0;
      HEAP32[(($3842)>>2)]=$20322;
      var $20323=$20321.f1;
      HEAP32[(($3843)>>2)]=$20323;
      var $20324=HEAP32[(($3843)>>2)];
      var $20325=(($20324)|0) < 0;
      if ($20325) { __label__ = 2708; break; } else { __label__ = 2709; break; }
    case 2708: // $20326
      var $20327=HEAP32[(($3842)>>2)];
      ___cxa_call_unexpected($20327);
      throw "Reached an unreachable!"
    case 2709: // $20328
      var $20329=HEAP32[(($3842)>>2)];
      var $20330=HEAP32[(($3842)>>2)];
      var $20331=HEAP32[(($3843)>>2)];
      var $20332=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20330, tempValue);
      var $20333=($20332.f1 = $20331, $20332);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2710: // $20334
      throw "Reached an unreachable!"
    case 2711: // $_ZnwjPKci_exit338
      var $20335=HEAP32[(($result_i337)>>2)];
      var $20336=$3839;
      var $20337=$3840;
      var $20338=$3841;
      var $20339=$result_i337;
      var $20340=$3842;
      var $20341=$3843;
      var $20342=$20335;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6045, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2712; break; } else { __label__ = 12526; break; }
    case 2712: // $20343
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6046, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2713; break; } else { __label__ = 12526; break; }
    case 2713: // $20344
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6047, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2714; break; } else { __label__ = 12526; break; }
    case 2714: // $20345
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2715; break; } else { __label__ = 12526; break; }
    case 2715: // $20346
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2716; break; } else { __label__ = 12526; break; }
    case 2716: // $20347
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2717; break; } else { __label__ = 12526; break; }
    case 2717: // $20348
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2718; break; } else { __label__ = 12526; break; }
    case 2718: // $20349
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6044, $6045, $6046, $6047, $6048, $6049, $6050, $6051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2719; break; } else { __label__ = 12526; break; }
    case 2719: // $20350
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20342, 52, 3, 2, ((STRING_TABLE.__str529)|0), ((STRING_TABLE.__str530)|0), $6044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2720; break; } else { __label__ = 12526; break; }
    case 2720: // $20351
      var $20352=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20342);
      var $20353=__ZN11simple_listI16input_type_entryE6appendERS0_($20303, $20352);
      var $20354=$4689;
      var $20355=$3834;
      var $20356=$3835;
      var $20357=$3836;
      var $20358=$result_i339;
      var $20359=$3837;
      var $20360=$3838;
      HEAP32[(($3834)>>2)]=408;
      HEAP32[(($3835)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3836)>>2)]=226;
      var $20361=HEAP32[(($3834)>>2)];
      var $20362=HEAP32[(($3835)>>2)];
      var $20363=HEAP32[(($3836)>>2)];
      var $20364=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20361, $20362, $20363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2721; break; } else { __label__ = 2723; break; };
    case 2721: // $20365
      HEAP32[(($result_i339)>>2)]=$20364;
      var $20366=HEAP32[(($result_i339)>>2)];
      var $20367=(($20366)|0)==0;
      if ($20367) { __label__ = 2722; break; } else { __label__ = 2727; break; }
    case 2722: // $20368
      var $20369=___cxa_allocate_exception(4);
      var $20370=$20369;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20370);
      (function() { try { __THREW__ = false; return ___cxa_throw($20369, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2726; break; } else { __label__ = 2723; break; }
    case 2723: // $20371
      var $20372=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20373=$20372.f0;
      HEAP32[(($3837)>>2)]=$20373;
      var $20374=$20372.f1;
      HEAP32[(($3838)>>2)]=$20374;
      var $20375=HEAP32[(($3838)>>2)];
      var $20376=(($20375)|0) < 0;
      if ($20376) { __label__ = 2724; break; } else { __label__ = 2725; break; }
    case 2724: // $20377
      var $20378=HEAP32[(($3837)>>2)];
      ___cxa_call_unexpected($20378);
      throw "Reached an unreachable!"
    case 2725: // $20379
      var $20380=HEAP32[(($3837)>>2)];
      var $20381=HEAP32[(($3837)>>2)];
      var $20382=HEAP32[(($3838)>>2)];
      var $20383=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20381, tempValue);
      var $20384=($20383.f1 = $20382, $20383);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2726: // $20385
      throw "Reached an unreachable!"
    case 2727: // $_ZnwjPKci_exit340
      var $20386=HEAP32[(($result_i339)>>2)];
      var $20387=$3834;
      var $20388=$3835;
      var $20389=$3836;
      var $20390=$result_i339;
      var $20391=$3837;
      var $20392=$3838;
      var $20393=$20386;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6053, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2728; break; } else { __label__ = 12531; break; }
    case 2728: // $20394
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6054, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2729; break; } else { __label__ = 12531; break; }
    case 2729: // $20395
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6055, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2730; break; } else { __label__ = 12531; break; }
    case 2730: // $20396
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2731; break; } else { __label__ = 12531; break; }
    case 2731: // $20397
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2732; break; } else { __label__ = 12531; break; }
    case 2732: // $20398
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2733; break; } else { __label__ = 12531; break; }
    case 2733: // $20399
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2734; break; } else { __label__ = 12531; break; }
    case 2734: // $20400
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6052, $6053, $6054, $6055, $6056, $6057, $6058, $6059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2735; break; } else { __label__ = 12531; break; }
    case 2735: // $20401
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20393, 53, 3, 2, ((STRING_TABLE.__str531)|0), ((STRING_TABLE.__str532)|0), $6052) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2736; break; } else { __label__ = 12531; break; }
    case 2736: // $20402
      var $20403=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20393);
      var $20404=__ZN11simple_listI16input_type_entryE6appendERS0_($20354, $20403);
      var $20405=$4689;
      var $20406=$3829;
      var $20407=$3830;
      var $20408=$3831;
      var $20409=$result_i341;
      var $20410=$3832;
      var $20411=$3833;
      HEAP32[(($3829)>>2)]=408;
      HEAP32[(($3830)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3831)>>2)]=227;
      var $20412=HEAP32[(($3829)>>2)];
      var $20413=HEAP32[(($3830)>>2)];
      var $20414=HEAP32[(($3831)>>2)];
      var $20415=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20412, $20413, $20414) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2737; break; } else { __label__ = 2739; break; };
    case 2737: // $20416
      HEAP32[(($result_i341)>>2)]=$20415;
      var $20417=HEAP32[(($result_i341)>>2)];
      var $20418=(($20417)|0)==0;
      if ($20418) { __label__ = 2738; break; } else { __label__ = 2743; break; }
    case 2738: // $20419
      var $20420=___cxa_allocate_exception(4);
      var $20421=$20420;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20421);
      (function() { try { __THREW__ = false; return ___cxa_throw($20420, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2742; break; } else { __label__ = 2739; break; }
    case 2739: // $20422
      var $20423=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20424=$20423.f0;
      HEAP32[(($3832)>>2)]=$20424;
      var $20425=$20423.f1;
      HEAP32[(($3833)>>2)]=$20425;
      var $20426=HEAP32[(($3833)>>2)];
      var $20427=(($20426)|0) < 0;
      if ($20427) { __label__ = 2740; break; } else { __label__ = 2741; break; }
    case 2740: // $20428
      var $20429=HEAP32[(($3832)>>2)];
      ___cxa_call_unexpected($20429);
      throw "Reached an unreachable!"
    case 2741: // $20430
      var $20431=HEAP32[(($3832)>>2)];
      var $20432=HEAP32[(($3832)>>2)];
      var $20433=HEAP32[(($3833)>>2)];
      var $20434=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20432, tempValue);
      var $20435=($20434.f1 = $20433, $20434);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2742: // $20436
      throw "Reached an unreachable!"
    case 2743: // $_ZnwjPKci_exit342
      var $20437=HEAP32[(($result_i341)>>2)];
      var $20438=$3829;
      var $20439=$3830;
      var $20440=$3831;
      var $20441=$result_i341;
      var $20442=$3832;
      var $20443=$3833;
      var $20444=$20437;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6061, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2744; break; } else { __label__ = 12536; break; }
    case 2744: // $20445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6062, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2745; break; } else { __label__ = 12536; break; }
    case 2745: // $20446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6063, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2746; break; } else { __label__ = 12536; break; }
    case 2746: // $20447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2747; break; } else { __label__ = 12536; break; }
    case 2747: // $20448
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2748; break; } else { __label__ = 12536; break; }
    case 2748: // $20449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2749; break; } else { __label__ = 12536; break; }
    case 2749: // $20450
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2750; break; } else { __label__ = 12536; break; }
    case 2750: // $20451
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6060, $6061, $6062, $6063, $6064, $6065, $6066, $6067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2751; break; } else { __label__ = 12536; break; }
    case 2751: // $20452
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20444, 54, 3, 2, ((STRING_TABLE.__str533)|0), ((STRING_TABLE.__str534)|0), $6060) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2752; break; } else { __label__ = 12536; break; }
    case 2752: // $20453
      var $20454=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20444);
      var $20455=__ZN11simple_listI16input_type_entryE6appendERS0_($20405, $20454);
      var $20456=$4689;
      var $20457=$3824;
      var $20458=$3825;
      var $20459=$3826;
      var $20460=$result_i343;
      var $20461=$3827;
      var $20462=$3828;
      HEAP32[(($3824)>>2)]=408;
      HEAP32[(($3825)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3826)>>2)]=228;
      var $20463=HEAP32[(($3824)>>2)];
      var $20464=HEAP32[(($3825)>>2)];
      var $20465=HEAP32[(($3826)>>2)];
      var $20466=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20463, $20464, $20465) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2753; break; } else { __label__ = 2755; break; };
    case 2753: // $20467
      HEAP32[(($result_i343)>>2)]=$20466;
      var $20468=HEAP32[(($result_i343)>>2)];
      var $20469=(($20468)|0)==0;
      if ($20469) { __label__ = 2754; break; } else { __label__ = 2759; break; }
    case 2754: // $20470
      var $20471=___cxa_allocate_exception(4);
      var $20472=$20471;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20472);
      (function() { try { __THREW__ = false; return ___cxa_throw($20471, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2758; break; } else { __label__ = 2755; break; }
    case 2755: // $20473
      var $20474=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20475=$20474.f0;
      HEAP32[(($3827)>>2)]=$20475;
      var $20476=$20474.f1;
      HEAP32[(($3828)>>2)]=$20476;
      var $20477=HEAP32[(($3828)>>2)];
      var $20478=(($20477)|0) < 0;
      if ($20478) { __label__ = 2756; break; } else { __label__ = 2757; break; }
    case 2756: // $20479
      var $20480=HEAP32[(($3827)>>2)];
      ___cxa_call_unexpected($20480);
      throw "Reached an unreachable!"
    case 2757: // $20481
      var $20482=HEAP32[(($3827)>>2)];
      var $20483=HEAP32[(($3827)>>2)];
      var $20484=HEAP32[(($3828)>>2)];
      var $20485=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20483, tempValue);
      var $20486=($20485.f1 = $20484, $20485);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2758: // $20487
      throw "Reached an unreachable!"
    case 2759: // $_ZnwjPKci_exit344
      var $20488=HEAP32[(($result_i343)>>2)];
      var $20489=$3824;
      var $20490=$3825;
      var $20491=$3826;
      var $20492=$result_i343;
      var $20493=$3827;
      var $20494=$3828;
      var $20495=$20488;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6069, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2760; break; } else { __label__ = 12541; break; }
    case 2760: // $20496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6070, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2761; break; } else { __label__ = 12541; break; }
    case 2761: // $20497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6071, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2762; break; } else { __label__ = 12541; break; }
    case 2762: // $20498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2763; break; } else { __label__ = 12541; break; }
    case 2763: // $20499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2764; break; } else { __label__ = 12541; break; }
    case 2764: // $20500
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2765; break; } else { __label__ = 12541; break; }
    case 2765: // $20501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2766; break; } else { __label__ = 12541; break; }
    case 2766: // $20502
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6068, $6069, $6070, $6071, $6072, $6073, $6074, $6075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2767; break; } else { __label__ = 12541; break; }
    case 2767: // $20503
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20495, 55, 3, 2, ((STRING_TABLE.__str535)|0), ((STRING_TABLE.__str536)|0), $6068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2768; break; } else { __label__ = 12541; break; }
    case 2768: // $20504
      var $20505=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20495);
      var $20506=__ZN11simple_listI16input_type_entryE6appendERS0_($20456, $20505);
      var $20507=$4689;
      var $20508=$3819;
      var $20509=$3820;
      var $20510=$3821;
      var $20511=$result_i345;
      var $20512=$3822;
      var $20513=$3823;
      HEAP32[(($3819)>>2)]=408;
      HEAP32[(($3820)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3821)>>2)]=229;
      var $20514=HEAP32[(($3819)>>2)];
      var $20515=HEAP32[(($3820)>>2)];
      var $20516=HEAP32[(($3821)>>2)];
      var $20517=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20514, $20515, $20516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2769; break; } else { __label__ = 2771; break; };
    case 2769: // $20518
      HEAP32[(($result_i345)>>2)]=$20517;
      var $20519=HEAP32[(($result_i345)>>2)];
      var $20520=(($20519)|0)==0;
      if ($20520) { __label__ = 2770; break; } else { __label__ = 2775; break; }
    case 2770: // $20521
      var $20522=___cxa_allocate_exception(4);
      var $20523=$20522;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20523);
      (function() { try { __THREW__ = false; return ___cxa_throw($20522, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2774; break; } else { __label__ = 2771; break; }
    case 2771: // $20524
      var $20525=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20526=$20525.f0;
      HEAP32[(($3822)>>2)]=$20526;
      var $20527=$20525.f1;
      HEAP32[(($3823)>>2)]=$20527;
      var $20528=HEAP32[(($3823)>>2)];
      var $20529=(($20528)|0) < 0;
      if ($20529) { __label__ = 2772; break; } else { __label__ = 2773; break; }
    case 2772: // $20530
      var $20531=HEAP32[(($3822)>>2)];
      ___cxa_call_unexpected($20531);
      throw "Reached an unreachable!"
    case 2773: // $20532
      var $20533=HEAP32[(($3822)>>2)];
      var $20534=HEAP32[(($3822)>>2)];
      var $20535=HEAP32[(($3823)>>2)];
      var $20536=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20534, tempValue);
      var $20537=($20536.f1 = $20535, $20536);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2774: // $20538
      throw "Reached an unreachable!"
    case 2775: // $_ZnwjPKci_exit346
      var $20539=HEAP32[(($result_i345)>>2)];
      var $20540=$3819;
      var $20541=$3820;
      var $20542=$3821;
      var $20543=$result_i345;
      var $20544=$3822;
      var $20545=$3823;
      var $20546=$20539;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6077, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2776; break; } else { __label__ = 12546; break; }
    case 2776: // $20547
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6078, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2777; break; } else { __label__ = 12546; break; }
    case 2777: // $20548
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6079, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2778; break; } else { __label__ = 12546; break; }
    case 2778: // $20549
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2779; break; } else { __label__ = 12546; break; }
    case 2779: // $20550
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2780; break; } else { __label__ = 12546; break; }
    case 2780: // $20551
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2781; break; } else { __label__ = 12546; break; }
    case 2781: // $20552
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2782; break; } else { __label__ = 12546; break; }
    case 2782: // $20553
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6076, $6077, $6078, $6079, $6080, $6081, $6082, $6083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2783; break; } else { __label__ = 12546; break; }
    case 2783: // $20554
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20546, 56, 3, 2, ((STRING_TABLE.__str537)|0), ((STRING_TABLE.__str538)|0), $6076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2784; break; } else { __label__ = 12546; break; }
    case 2784: // $20555
      var $20556=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20546);
      var $20557=__ZN11simple_listI16input_type_entryE6appendERS0_($20507, $20556);
      var $20558=$4689;
      var $20559=$3814;
      var $20560=$3815;
      var $20561=$3816;
      var $20562=$result_i347;
      var $20563=$3817;
      var $20564=$3818;
      HEAP32[(($3814)>>2)]=408;
      HEAP32[(($3815)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3816)>>2)]=230;
      var $20565=HEAP32[(($3814)>>2)];
      var $20566=HEAP32[(($3815)>>2)];
      var $20567=HEAP32[(($3816)>>2)];
      var $20568=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20565, $20566, $20567) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2785; break; } else { __label__ = 2787; break; };
    case 2785: // $20569
      HEAP32[(($result_i347)>>2)]=$20568;
      var $20570=HEAP32[(($result_i347)>>2)];
      var $20571=(($20570)|0)==0;
      if ($20571) { __label__ = 2786; break; } else { __label__ = 2791; break; }
    case 2786: // $20572
      var $20573=___cxa_allocate_exception(4);
      var $20574=$20573;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20574);
      (function() { try { __THREW__ = false; return ___cxa_throw($20573, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2790; break; } else { __label__ = 2787; break; }
    case 2787: // $20575
      var $20576=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20577=$20576.f0;
      HEAP32[(($3817)>>2)]=$20577;
      var $20578=$20576.f1;
      HEAP32[(($3818)>>2)]=$20578;
      var $20579=HEAP32[(($3818)>>2)];
      var $20580=(($20579)|0) < 0;
      if ($20580) { __label__ = 2788; break; } else { __label__ = 2789; break; }
    case 2788: // $20581
      var $20582=HEAP32[(($3817)>>2)];
      ___cxa_call_unexpected($20582);
      throw "Reached an unreachable!"
    case 2789: // $20583
      var $20584=HEAP32[(($3817)>>2)];
      var $20585=HEAP32[(($3817)>>2)];
      var $20586=HEAP32[(($3818)>>2)];
      var $20587=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20585, tempValue);
      var $20588=($20587.f1 = $20586, $20587);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2790: // $20589
      throw "Reached an unreachable!"
    case 2791: // $_ZnwjPKci_exit348
      var $20590=HEAP32[(($result_i347)>>2)];
      var $20591=$3814;
      var $20592=$3815;
      var $20593=$3816;
      var $20594=$result_i347;
      var $20595=$3817;
      var $20596=$3818;
      var $20597=$20590;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6085, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2792; break; } else { __label__ = 12551; break; }
    case 2792: // $20598
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6086, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2793; break; } else { __label__ = 12551; break; }
    case 2793: // $20599
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6087, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2794; break; } else { __label__ = 12551; break; }
    case 2794: // $20600
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2795; break; } else { __label__ = 12551; break; }
    case 2795: // $20601
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2796; break; } else { __label__ = 12551; break; }
    case 2796: // $20602
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2797; break; } else { __label__ = 12551; break; }
    case 2797: // $20603
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2798; break; } else { __label__ = 12551; break; }
    case 2798: // $20604
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6084, $6085, $6086, $6087, $6088, $6089, $6090, $6091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2799; break; } else { __label__ = 12551; break; }
    case 2799: // $20605
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20597, 57, 3, 2, ((STRING_TABLE.__str539)|0), ((STRING_TABLE.__str540)|0), $6084) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2800; break; } else { __label__ = 12551; break; }
    case 2800: // $20606
      var $20607=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20597);
      var $20608=__ZN11simple_listI16input_type_entryE6appendERS0_($20558, $20607);
      var $20609=$4689;
      var $20610=$3809;
      var $20611=$3810;
      var $20612=$3811;
      var $20613=$result_i349;
      var $20614=$3812;
      var $20615=$3813;
      HEAP32[(($3809)>>2)]=408;
      HEAP32[(($3810)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3811)>>2)]=231;
      var $20616=HEAP32[(($3809)>>2)];
      var $20617=HEAP32[(($3810)>>2)];
      var $20618=HEAP32[(($3811)>>2)];
      var $20619=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20616, $20617, $20618) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2801; break; } else { __label__ = 2803; break; };
    case 2801: // $20620
      HEAP32[(($result_i349)>>2)]=$20619;
      var $20621=HEAP32[(($result_i349)>>2)];
      var $20622=(($20621)|0)==0;
      if ($20622) { __label__ = 2802; break; } else { __label__ = 2807; break; }
    case 2802: // $20623
      var $20624=___cxa_allocate_exception(4);
      var $20625=$20624;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20625);
      (function() { try { __THREW__ = false; return ___cxa_throw($20624, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2806; break; } else { __label__ = 2803; break; }
    case 2803: // $20626
      var $20627=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20628=$20627.f0;
      HEAP32[(($3812)>>2)]=$20628;
      var $20629=$20627.f1;
      HEAP32[(($3813)>>2)]=$20629;
      var $20630=HEAP32[(($3813)>>2)];
      var $20631=(($20630)|0) < 0;
      if ($20631) { __label__ = 2804; break; } else { __label__ = 2805; break; }
    case 2804: // $20632
      var $20633=HEAP32[(($3812)>>2)];
      ___cxa_call_unexpected($20633);
      throw "Reached an unreachable!"
    case 2805: // $20634
      var $20635=HEAP32[(($3812)>>2)];
      var $20636=HEAP32[(($3812)>>2)];
      var $20637=HEAP32[(($3813)>>2)];
      var $20638=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20636, tempValue);
      var $20639=($20638.f1 = $20637, $20638);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2806: // $20640
      throw "Reached an unreachable!"
    case 2807: // $_ZnwjPKci_exit350
      var $20641=HEAP32[(($result_i349)>>2)];
      var $20642=$3809;
      var $20643=$3810;
      var $20644=$3811;
      var $20645=$result_i349;
      var $20646=$3812;
      var $20647=$3813;
      var $20648=$20641;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6093, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2808; break; } else { __label__ = 12556; break; }
    case 2808: // $20649
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6094, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2809; break; } else { __label__ = 12556; break; }
    case 2809: // $20650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6095, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2810; break; } else { __label__ = 12556; break; }
    case 2810: // $20651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2811; break; } else { __label__ = 12556; break; }
    case 2811: // $20652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2812; break; } else { __label__ = 12556; break; }
    case 2812: // $20653
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2813; break; } else { __label__ = 12556; break; }
    case 2813: // $20654
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2814; break; } else { __label__ = 12556; break; }
    case 2814: // $20655
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6092, $6093, $6094, $6095, $6096, $6097, $6098, $6099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2815; break; } else { __label__ = 12556; break; }
    case 2815: // $20656
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20648, 58, 3, 2, ((STRING_TABLE.__str541)|0), ((STRING_TABLE.__str542)|0), $6092) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2816; break; } else { __label__ = 12556; break; }
    case 2816: // $20657
      var $20658=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20648);
      var $20659=__ZN11simple_listI16input_type_entryE6appendERS0_($20609, $20658);
      var $20660=$4689;
      var $20661=$3804;
      var $20662=$3805;
      var $20663=$3806;
      var $20664=$result_i351;
      var $20665=$3807;
      var $20666=$3808;
      HEAP32[(($3804)>>2)]=408;
      HEAP32[(($3805)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3806)>>2)]=232;
      var $20667=HEAP32[(($3804)>>2)];
      var $20668=HEAP32[(($3805)>>2)];
      var $20669=HEAP32[(($3806)>>2)];
      var $20670=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20667, $20668, $20669) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2817; break; } else { __label__ = 2819; break; };
    case 2817: // $20671
      HEAP32[(($result_i351)>>2)]=$20670;
      var $20672=HEAP32[(($result_i351)>>2)];
      var $20673=(($20672)|0)==0;
      if ($20673) { __label__ = 2818; break; } else { __label__ = 2823; break; }
    case 2818: // $20674
      var $20675=___cxa_allocate_exception(4);
      var $20676=$20675;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20676);
      (function() { try { __THREW__ = false; return ___cxa_throw($20675, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2822; break; } else { __label__ = 2819; break; }
    case 2819: // $20677
      var $20678=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20679=$20678.f0;
      HEAP32[(($3807)>>2)]=$20679;
      var $20680=$20678.f1;
      HEAP32[(($3808)>>2)]=$20680;
      var $20681=HEAP32[(($3808)>>2)];
      var $20682=(($20681)|0) < 0;
      if ($20682) { __label__ = 2820; break; } else { __label__ = 2821; break; }
    case 2820: // $20683
      var $20684=HEAP32[(($3807)>>2)];
      ___cxa_call_unexpected($20684);
      throw "Reached an unreachable!"
    case 2821: // $20685
      var $20686=HEAP32[(($3807)>>2)];
      var $20687=HEAP32[(($3807)>>2)];
      var $20688=HEAP32[(($3808)>>2)];
      var $20689=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20687, tempValue);
      var $20690=($20689.f1 = $20688, $20689);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2822: // $20691
      throw "Reached an unreachable!"
    case 2823: // $_ZnwjPKci_exit352
      var $20692=HEAP32[(($result_i351)>>2)];
      var $20693=$3804;
      var $20694=$3805;
      var $20695=$3806;
      var $20696=$result_i351;
      var $20697=$3807;
      var $20698=$3808;
      var $20699=$20692;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6101, 1, 0, 1, 0, 100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2824; break; } else { __label__ = 12561; break; }
    case 2824: // $20700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6102, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2825; break; } else { __label__ = 12561; break; }
    case 2825: // $20701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6103, 4, 2, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2826; break; } else { __label__ = 12561; break; }
    case 2826: // $20702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6104, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2827; break; } else { __label__ = 12561; break; }
    case 2827: // $20703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6105, 3, 2, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2828; break; } else { __label__ = 12561; break; }
    case 2828: // $20704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2829; break; } else { __label__ = 12561; break; }
    case 2829: // $20705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2830; break; } else { __label__ = 12561; break; }
    case 2830: // $20706
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6100, $6101, $6102, $6103, $6104, $6105, $6106, $6107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2831; break; } else { __label__ = 12561; break; }
    case 2831: // $20707
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20699, 59, 3, 2, ((STRING_TABLE.__str543)|0), ((STRING_TABLE.__str544)|0), $6100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2832; break; } else { __label__ = 12561; break; }
    case 2832: // $20708
      var $20709=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20699);
      var $20710=__ZN11simple_listI16input_type_entryE6appendERS0_($20660, $20709);
      var $20711=$4689;
      var $20712=$3799;
      var $20713=$3800;
      var $20714=$3801;
      var $20715=$result_i353;
      var $20716=$3802;
      var $20717=$3803;
      HEAP32[(($3799)>>2)]=408;
      HEAP32[(($3800)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3801)>>2)]=233;
      var $20718=HEAP32[(($3799)>>2)];
      var $20719=HEAP32[(($3800)>>2)];
      var $20720=HEAP32[(($3801)>>2)];
      var $20721=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20718, $20719, $20720) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2833; break; } else { __label__ = 2835; break; };
    case 2833: // $20722
      HEAP32[(($result_i353)>>2)]=$20721;
      var $20723=HEAP32[(($result_i353)>>2)];
      var $20724=(($20723)|0)==0;
      if ($20724) { __label__ = 2834; break; } else { __label__ = 2839; break; }
    case 2834: // $20725
      var $20726=___cxa_allocate_exception(4);
      var $20727=$20726;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20727);
      (function() { try { __THREW__ = false; return ___cxa_throw($20726, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2838; break; } else { __label__ = 2835; break; }
    case 2835: // $20728
      var $20729=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20730=$20729.f0;
      HEAP32[(($3802)>>2)]=$20730;
      var $20731=$20729.f1;
      HEAP32[(($3803)>>2)]=$20731;
      var $20732=HEAP32[(($3803)>>2)];
      var $20733=(($20732)|0) < 0;
      if ($20733) { __label__ = 2836; break; } else { __label__ = 2837; break; }
    case 2836: // $20734
      var $20735=HEAP32[(($3802)>>2)];
      ___cxa_call_unexpected($20735);
      throw "Reached an unreachable!"
    case 2837: // $20736
      var $20737=HEAP32[(($3802)>>2)];
      var $20738=HEAP32[(($3802)>>2)];
      var $20739=HEAP32[(($3803)>>2)];
      var $20740=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20738, tempValue);
      var $20741=($20740.f1 = $20739, $20740);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2838: // $20742
      throw "Reached an unreachable!"
    case 2839: // $_ZnwjPKci_exit354
      var $20743=HEAP32[(($result_i353)>>2)];
      var $20744=$3799;
      var $20745=$3800;
      var $20746=$3801;
      var $20747=$result_i353;
      var $20748=$3802;
      var $20749=$3803;
      var $20750=$20743;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6109, 1, 0, 1, 0, 98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2840; break; } else { __label__ = 12566; break; }
    case 2840: // $20751
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6110, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2841; break; } else { __label__ = 12566; break; }
    case 2841: // $20752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6111, 4, 2, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2842; break; } else { __label__ = 12566; break; }
    case 2842: // $20753
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6112, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2843; break; } else { __label__ = 12566; break; }
    case 2843: // $20754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6113, 3, 2, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2844; break; } else { __label__ = 12566; break; }
    case 2844: // $20755
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2845; break; } else { __label__ = 12566; break; }
    case 2845: // $20756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2846; break; } else { __label__ = 12566; break; }
    case 2846: // $20757
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6108, $6109, $6110, $6111, $6112, $6113, $6114, $6115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2847; break; } else { __label__ = 12566; break; }
    case 2847: // $20758
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20750, 60, 3, 2, ((STRING_TABLE.__str545)|0), ((STRING_TABLE.__str546)|0), $6108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2848; break; } else { __label__ = 12566; break; }
    case 2848: // $20759
      var $20760=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20750);
      var $20761=__ZN11simple_listI16input_type_entryE6appendERS0_($20711, $20760);
      var $20762=$4689;
      var $20763=$3794;
      var $20764=$3795;
      var $20765=$3796;
      var $20766=$result_i355;
      var $20767=$3797;
      var $20768=$3798;
      HEAP32[(($3794)>>2)]=408;
      HEAP32[(($3795)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3796)>>2)]=234;
      var $20769=HEAP32[(($3794)>>2)];
      var $20770=HEAP32[(($3795)>>2)];
      var $20771=HEAP32[(($3796)>>2)];
      var $20772=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20769, $20770, $20771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2849; break; } else { __label__ = 2851; break; };
    case 2849: // $20773
      HEAP32[(($result_i355)>>2)]=$20772;
      var $20774=HEAP32[(($result_i355)>>2)];
      var $20775=(($20774)|0)==0;
      if ($20775) { __label__ = 2850; break; } else { __label__ = 2855; break; }
    case 2850: // $20776
      var $20777=___cxa_allocate_exception(4);
      var $20778=$20777;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20778);
      (function() { try { __THREW__ = false; return ___cxa_throw($20777, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2854; break; } else { __label__ = 2851; break; }
    case 2851: // $20779
      var $20780=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20781=$20780.f0;
      HEAP32[(($3797)>>2)]=$20781;
      var $20782=$20780.f1;
      HEAP32[(($3798)>>2)]=$20782;
      var $20783=HEAP32[(($3798)>>2)];
      var $20784=(($20783)|0) < 0;
      if ($20784) { __label__ = 2852; break; } else { __label__ = 2853; break; }
    case 2852: // $20785
      var $20786=HEAP32[(($3797)>>2)];
      ___cxa_call_unexpected($20786);
      throw "Reached an unreachable!"
    case 2853: // $20787
      var $20788=HEAP32[(($3797)>>2)];
      var $20789=HEAP32[(($3797)>>2)];
      var $20790=HEAP32[(($3798)>>2)];
      var $20791=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20789, tempValue);
      var $20792=($20791.f1 = $20790, $20791);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2854: // $20793
      throw "Reached an unreachable!"
    case 2855: // $_ZnwjPKci_exit356
      var $20794=HEAP32[(($result_i355)>>2)];
      var $20795=$3794;
      var $20796=$3795;
      var $20797=$3796;
      var $20798=$result_i355;
      var $20799=$3797;
      var $20800=$3798;
      var $20801=$20794;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6117, 1, 0, 1, 0, 60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2856; break; } else { __label__ = 12571; break; }
    case 2856: // $20802
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6118, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2857; break; } else { __label__ = 12571; break; }
    case 2857: // $20803
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6119, 4, 2, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2858; break; } else { __label__ = 12571; break; }
    case 2858: // $20804
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2859; break; } else { __label__ = 12571; break; }
    case 2859: // $20805
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2860; break; } else { __label__ = 12571; break; }
    case 2860: // $20806
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2861; break; } else { __label__ = 12571; break; }
    case 2861: // $20807
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2862; break; } else { __label__ = 12571; break; }
    case 2862: // $20808
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6116, $6117, $6118, $6119, $6120, $6121, $6122, $6123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2863; break; } else { __label__ = 12571; break; }
    case 2863: // $20809
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20801, 61, 3, 2, ((STRING_TABLE.__str547)|0), ((STRING_TABLE.__str548)|0), $6116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2864; break; } else { __label__ = 12571; break; }
    case 2864: // $20810
      var $20811=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20801);
      var $20812=__ZN11simple_listI16input_type_entryE6appendERS0_($20762, $20811);
      var $20813=$4689;
      var $20814=$3789;
      var $20815=$3790;
      var $20816=$3791;
      var $20817=$result_i357;
      var $20818=$3792;
      var $20819=$3793;
      HEAP32[(($3789)>>2)]=408;
      HEAP32[(($3790)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3791)>>2)]=235;
      var $20820=HEAP32[(($3789)>>2)];
      var $20821=HEAP32[(($3790)>>2)];
      var $20822=HEAP32[(($3791)>>2)];
      var $20823=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20820, $20821, $20822) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2865; break; } else { __label__ = 2867; break; };
    case 2865: // $20824
      HEAP32[(($result_i357)>>2)]=$20823;
      var $20825=HEAP32[(($result_i357)>>2)];
      var $20826=(($20825)|0)==0;
      if ($20826) { __label__ = 2866; break; } else { __label__ = 2871; break; }
    case 2866: // $20827
      var $20828=___cxa_allocate_exception(4);
      var $20829=$20828;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20829);
      (function() { try { __THREW__ = false; return ___cxa_throw($20828, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2870; break; } else { __label__ = 2867; break; }
    case 2867: // $20830
      var $20831=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20832=$20831.f0;
      HEAP32[(($3792)>>2)]=$20832;
      var $20833=$20831.f1;
      HEAP32[(($3793)>>2)]=$20833;
      var $20834=HEAP32[(($3793)>>2)];
      var $20835=(($20834)|0) < 0;
      if ($20835) { __label__ = 2868; break; } else { __label__ = 2869; break; }
    case 2868: // $20836
      var $20837=HEAP32[(($3792)>>2)];
      ___cxa_call_unexpected($20837);
      throw "Reached an unreachable!"
    case 2869: // $20838
      var $20839=HEAP32[(($3792)>>2)];
      var $20840=HEAP32[(($3792)>>2)];
      var $20841=HEAP32[(($3793)>>2)];
      var $20842=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20840, tempValue);
      var $20843=($20842.f1 = $20841, $20842);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2870: // $20844
      throw "Reached an unreachable!"
    case 2871: // $_ZnwjPKci_exit358
      var $20845=HEAP32[(($result_i357)>>2)];
      var $20846=$3789;
      var $20847=$3790;
      var $20848=$3791;
      var $20849=$result_i357;
      var $20850=$3792;
      var $20851=$3793;
      var $20852=$20845;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6125, 4, 2, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2872; break; } else { __label__ = 12576; break; }
    case 2872: // $20853
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6126, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2873; break; } else { __label__ = 12576; break; }
    case 2873: // $20854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6127, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2874; break; } else { __label__ = 12576; break; }
    case 2874: // $20855
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2875; break; } else { __label__ = 12576; break; }
    case 2875: // $20856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2876; break; } else { __label__ = 12576; break; }
    case 2876: // $20857
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2877; break; } else { __label__ = 12576; break; }
    case 2877: // $20858
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2878; break; } else { __label__ = 12576; break; }
    case 2878: // $20859
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6124, $6125, $6126, $6127, $6128, $6129, $6130, $6131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2879; break; } else { __label__ = 12576; break; }
    case 2879: // $20860
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20852, 62, 3, 2, ((STRING_TABLE.__str549)|0), ((STRING_TABLE.__str550)|0), $6124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2880; break; } else { __label__ = 12576; break; }
    case 2880: // $20861
      var $20862=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20852);
      var $20863=__ZN11simple_listI16input_type_entryE6appendERS0_($20813, $20862);
      var $20864=$4689;
      var $20865=$3784;
      var $20866=$3785;
      var $20867=$3786;
      var $20868=$result_i359;
      var $20869=$3787;
      var $20870=$3788;
      HEAP32[(($3784)>>2)]=408;
      HEAP32[(($3785)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3786)>>2)]=236;
      var $20871=HEAP32[(($3784)>>2)];
      var $20872=HEAP32[(($3785)>>2)];
      var $20873=HEAP32[(($3786)>>2)];
      var $20874=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20871, $20872, $20873) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2881; break; } else { __label__ = 2883; break; };
    case 2881: // $20875
      HEAP32[(($result_i359)>>2)]=$20874;
      var $20876=HEAP32[(($result_i359)>>2)];
      var $20877=(($20876)|0)==0;
      if ($20877) { __label__ = 2882; break; } else { __label__ = 2887; break; }
    case 2882: // $20878
      var $20879=___cxa_allocate_exception(4);
      var $20880=$20879;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20880);
      (function() { try { __THREW__ = false; return ___cxa_throw($20879, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2886; break; } else { __label__ = 2883; break; }
    case 2883: // $20881
      var $20882=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20883=$20882.f0;
      HEAP32[(($3787)>>2)]=$20883;
      var $20884=$20882.f1;
      HEAP32[(($3788)>>2)]=$20884;
      var $20885=HEAP32[(($3788)>>2)];
      var $20886=(($20885)|0) < 0;
      if ($20886) { __label__ = 2884; break; } else { __label__ = 2885; break; }
    case 2884: // $20887
      var $20888=HEAP32[(($3787)>>2)];
      ___cxa_call_unexpected($20888);
      throw "Reached an unreachable!"
    case 2885: // $20889
      var $20890=HEAP32[(($3787)>>2)];
      var $20891=HEAP32[(($3787)>>2)];
      var $20892=HEAP32[(($3788)>>2)];
      var $20893=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20891, tempValue);
      var $20894=($20893.f1 = $20892, $20893);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2886: // $20895
      throw "Reached an unreachable!"
    case 2887: // $_ZnwjPKci_exit360
      var $20896=HEAP32[(($result_i359)>>2)];
      var $20897=$3784;
      var $20898=$3785;
      var $20899=$3786;
      var $20900=$result_i359;
      var $20901=$3787;
      var $20902=$3788;
      var $20903=$20896;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6133, 4, 2, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2888; break; } else { __label__ = 12581; break; }
    case 2888: // $20904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6134, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2889; break; } else { __label__ = 12581; break; }
    case 2889: // $20905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6135, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2890; break; } else { __label__ = 12581; break; }
    case 2890: // $20906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2891; break; } else { __label__ = 12581; break; }
    case 2891: // $20907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2892; break; } else { __label__ = 12581; break; }
    case 2892: // $20908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2893; break; } else { __label__ = 12581; break; }
    case 2893: // $20909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2894; break; } else { __label__ = 12581; break; }
    case 2894: // $20910
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6132, $6133, $6134, $6135, $6136, $6137, $6138, $6139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2895; break; } else { __label__ = 12581; break; }
    case 2895: // $20911
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20903, 63, 3, 2, ((STRING_TABLE.__str551)|0), ((STRING_TABLE.__str552)|0), $6132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2896; break; } else { __label__ = 12581; break; }
    case 2896: // $20912
      var $20913=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20903);
      var $20914=__ZN11simple_listI16input_type_entryE6appendERS0_($20864, $20913);
      var $20915=$4689;
      var $20916=$3779;
      var $20917=$3780;
      var $20918=$3781;
      var $20919=$result_i361;
      var $20920=$3782;
      var $20921=$3783;
      HEAP32[(($3779)>>2)]=408;
      HEAP32[(($3780)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3781)>>2)]=237;
      var $20922=HEAP32[(($3779)>>2)];
      var $20923=HEAP32[(($3780)>>2)];
      var $20924=HEAP32[(($3781)>>2)];
      var $20925=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20922, $20923, $20924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2897; break; } else { __label__ = 2899; break; };
    case 2897: // $20926
      HEAP32[(($result_i361)>>2)]=$20925;
      var $20927=HEAP32[(($result_i361)>>2)];
      var $20928=(($20927)|0)==0;
      if ($20928) { __label__ = 2898; break; } else { __label__ = 2903; break; }
    case 2898: // $20929
      var $20930=___cxa_allocate_exception(4);
      var $20931=$20930;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20931);
      (function() { try { __THREW__ = false; return ___cxa_throw($20930, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2902; break; } else { __label__ = 2899; break; }
    case 2899: // $20932
      var $20933=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20934=$20933.f0;
      HEAP32[(($3782)>>2)]=$20934;
      var $20935=$20933.f1;
      HEAP32[(($3783)>>2)]=$20935;
      var $20936=HEAP32[(($3783)>>2)];
      var $20937=(($20936)|0) < 0;
      if ($20937) { __label__ = 2900; break; } else { __label__ = 2901; break; }
    case 2900: // $20938
      var $20939=HEAP32[(($3782)>>2)];
      ___cxa_call_unexpected($20939);
      throw "Reached an unreachable!"
    case 2901: // $20940
      var $20941=HEAP32[(($3782)>>2)];
      var $20942=HEAP32[(($3782)>>2)];
      var $20943=HEAP32[(($3783)>>2)];
      var $20944=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20942, tempValue);
      var $20945=($20944.f1 = $20943, $20944);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2902: // $20946
      throw "Reached an unreachable!"
    case 2903: // $_ZnwjPKci_exit362
      var $20947=HEAP32[(($result_i361)>>2)];
      var $20948=$3779;
      var $20949=$3780;
      var $20950=$3781;
      var $20951=$result_i361;
      var $20952=$3782;
      var $20953=$3783;
      var $20954=$20947;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6141, 4, 2, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2904; break; } else { __label__ = 12586; break; }
    case 2904: // $20955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6142, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2905; break; } else { __label__ = 12586; break; }
    case 2905: // $20956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6143, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2906; break; } else { __label__ = 12586; break; }
    case 2906: // $20957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2907; break; } else { __label__ = 12586; break; }
    case 2907: // $20958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2908; break; } else { __label__ = 12586; break; }
    case 2908: // $20959
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2909; break; } else { __label__ = 12586; break; }
    case 2909: // $20960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2910; break; } else { __label__ = 12586; break; }
    case 2910: // $20961
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6140, $6141, $6142, $6143, $6144, $6145, $6146, $6147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2911; break; } else { __label__ = 12586; break; }
    case 2911: // $20962
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($20954, 64, 3, 2, ((STRING_TABLE.__str553)|0), ((STRING_TABLE.__str554)|0), $6140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2912; break; } else { __label__ = 12586; break; }
    case 2912: // $20963
      var $20964=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $20954);
      var $20965=__ZN11simple_listI16input_type_entryE6appendERS0_($20915, $20964);
      var $20966=$4689;
      var $20967=$3774;
      var $20968=$3775;
      var $20969=$3776;
      var $20970=$result_i363;
      var $20971=$3777;
      var $20972=$3778;
      HEAP32[(($3774)>>2)]=408;
      HEAP32[(($3775)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3776)>>2)]=238;
      var $20973=HEAP32[(($3774)>>2)];
      var $20974=HEAP32[(($3775)>>2)];
      var $20975=HEAP32[(($3776)>>2)];
      var $20976=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($20973, $20974, $20975) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2913; break; } else { __label__ = 2915; break; };
    case 2913: // $20977
      HEAP32[(($result_i363)>>2)]=$20976;
      var $20978=HEAP32[(($result_i363)>>2)];
      var $20979=(($20978)|0)==0;
      if ($20979) { __label__ = 2914; break; } else { __label__ = 2919; break; }
    case 2914: // $20980
      var $20981=___cxa_allocate_exception(4);
      var $20982=$20981;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($20982);
      (function() { try { __THREW__ = false; return ___cxa_throw($20981, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2918; break; } else { __label__ = 2915; break; }
    case 2915: // $20983
      var $20984=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20985=$20984.f0;
      HEAP32[(($3777)>>2)]=$20985;
      var $20986=$20984.f1;
      HEAP32[(($3778)>>2)]=$20986;
      var $20987=HEAP32[(($3778)>>2)];
      var $20988=(($20987)|0) < 0;
      if ($20988) { __label__ = 2916; break; } else { __label__ = 2917; break; }
    case 2916: // $20989
      var $20990=HEAP32[(($3777)>>2)];
      ___cxa_call_unexpected($20990);
      throw "Reached an unreachable!"
    case 2917: // $20991
      var $20992=HEAP32[(($3777)>>2)];
      var $20993=HEAP32[(($3777)>>2)];
      var $20994=HEAP32[(($3778)>>2)];
      var $20995=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20993, tempValue);
      var $20996=($20995.f1 = $20994, $20995);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2918: // $20997
      throw "Reached an unreachable!"
    case 2919: // $_ZnwjPKci_exit364
      var $20998=HEAP32[(($result_i363)>>2)];
      var $20999=$3774;
      var $21000=$3775;
      var $21001=$3776;
      var $21002=$result_i363;
      var $21003=$3777;
      var $21004=$3778;
      var $21005=$20998;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6149, 4, 2, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2920; break; } else { __label__ = 12591; break; }
    case 2920: // $21006
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2921; break; } else { __label__ = 12591; break; }
    case 2921: // $21007
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2922; break; } else { __label__ = 12591; break; }
    case 2922: // $21008
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2923; break; } else { __label__ = 12591; break; }
    case 2923: // $21009
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2924; break; } else { __label__ = 12591; break; }
    case 2924: // $21010
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2925; break; } else { __label__ = 12591; break; }
    case 2925: // $21011
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2926; break; } else { __label__ = 12591; break; }
    case 2926: // $21012
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6148, $6149, $6150, $6151, $6152, $6153, $6154, $6155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2927; break; } else { __label__ = 12591; break; }
    case 2927: // $21013
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21005, 65, 3, 2, ((STRING_TABLE.__str555)|0), ((STRING_TABLE.__str556)|0), $6148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2928; break; } else { __label__ = 12591; break; }
    case 2928: // $21014
      var $21015=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21005);
      var $21016=__ZN11simple_listI16input_type_entryE6appendERS0_($20966, $21015);
      var $21017=$4689;
      var $21018=$3769;
      var $21019=$3770;
      var $21020=$3771;
      var $21021=$result_i365;
      var $21022=$3772;
      var $21023=$3773;
      HEAP32[(($3769)>>2)]=408;
      HEAP32[(($3770)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3771)>>2)]=239;
      var $21024=HEAP32[(($3769)>>2)];
      var $21025=HEAP32[(($3770)>>2)];
      var $21026=HEAP32[(($3771)>>2)];
      var $21027=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21024, $21025, $21026) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2929; break; } else { __label__ = 2931; break; };
    case 2929: // $21028
      HEAP32[(($result_i365)>>2)]=$21027;
      var $21029=HEAP32[(($result_i365)>>2)];
      var $21030=(($21029)|0)==0;
      if ($21030) { __label__ = 2930; break; } else { __label__ = 2935; break; }
    case 2930: // $21031
      var $21032=___cxa_allocate_exception(4);
      var $21033=$21032;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21033);
      (function() { try { __THREW__ = false; return ___cxa_throw($21032, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2934; break; } else { __label__ = 2931; break; }
    case 2931: // $21034
      var $21035=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21036=$21035.f0;
      HEAP32[(($3772)>>2)]=$21036;
      var $21037=$21035.f1;
      HEAP32[(($3773)>>2)]=$21037;
      var $21038=HEAP32[(($3773)>>2)];
      var $21039=(($21038)|0) < 0;
      if ($21039) { __label__ = 2932; break; } else { __label__ = 2933; break; }
    case 2932: // $21040
      var $21041=HEAP32[(($3772)>>2)];
      ___cxa_call_unexpected($21041);
      throw "Reached an unreachable!"
    case 2933: // $21042
      var $21043=HEAP32[(($3772)>>2)];
      var $21044=HEAP32[(($3772)>>2)];
      var $21045=HEAP32[(($3773)>>2)];
      var $21046=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21044, tempValue);
      var $21047=($21046.f1 = $21045, $21046);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2934: // $21048
      throw "Reached an unreachable!"
    case 2935: // $_ZnwjPKci_exit366
      var $21049=HEAP32[(($result_i365)>>2)];
      var $21050=$3769;
      var $21051=$3770;
      var $21052=$3771;
      var $21053=$result_i365;
      var $21054=$3772;
      var $21055=$3773;
      var $21056=$21049;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6157, 4, 2, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2936; break; } else { __label__ = 12596; break; }
    case 2936: // $21057
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6158, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2937; break; } else { __label__ = 12596; break; }
    case 2937: // $21058
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6159, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2938; break; } else { __label__ = 12596; break; }
    case 2938: // $21059
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2939; break; } else { __label__ = 12596; break; }
    case 2939: // $21060
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2940; break; } else { __label__ = 12596; break; }
    case 2940: // $21061
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2941; break; } else { __label__ = 12596; break; }
    case 2941: // $21062
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2942; break; } else { __label__ = 12596; break; }
    case 2942: // $21063
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6156, $6157, $6158, $6159, $6160, $6161, $6162, $6163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2943; break; } else { __label__ = 12596; break; }
    case 2943: // $21064
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21056, 66, 3, 2, ((STRING_TABLE.__str557)|0), ((STRING_TABLE.__str558)|0), $6156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2944; break; } else { __label__ = 12596; break; }
    case 2944: // $21065
      var $21066=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21056);
      var $21067=__ZN11simple_listI16input_type_entryE6appendERS0_($21017, $21066);
      var $21068=$4689;
      var $21069=$3764;
      var $21070=$3765;
      var $21071=$3766;
      var $21072=$result_i367;
      var $21073=$3767;
      var $21074=$3768;
      HEAP32[(($3764)>>2)]=408;
      HEAP32[(($3765)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3766)>>2)]=240;
      var $21075=HEAP32[(($3764)>>2)];
      var $21076=HEAP32[(($3765)>>2)];
      var $21077=HEAP32[(($3766)>>2)];
      var $21078=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21075, $21076, $21077) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2945; break; } else { __label__ = 2947; break; };
    case 2945: // $21079
      HEAP32[(($result_i367)>>2)]=$21078;
      var $21080=HEAP32[(($result_i367)>>2)];
      var $21081=(($21080)|0)==0;
      if ($21081) { __label__ = 2946; break; } else { __label__ = 2951; break; }
    case 2946: // $21082
      var $21083=___cxa_allocate_exception(4);
      var $21084=$21083;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21084);
      (function() { try { __THREW__ = false; return ___cxa_throw($21083, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2950; break; } else { __label__ = 2947; break; }
    case 2947: // $21085
      var $21086=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21087=$21086.f0;
      HEAP32[(($3767)>>2)]=$21087;
      var $21088=$21086.f1;
      HEAP32[(($3768)>>2)]=$21088;
      var $21089=HEAP32[(($3768)>>2)];
      var $21090=(($21089)|0) < 0;
      if ($21090) { __label__ = 2948; break; } else { __label__ = 2949; break; }
    case 2948: // $21091
      var $21092=HEAP32[(($3767)>>2)];
      ___cxa_call_unexpected($21092);
      throw "Reached an unreachable!"
    case 2949: // $21093
      var $21094=HEAP32[(($3767)>>2)];
      var $21095=HEAP32[(($3767)>>2)];
      var $21096=HEAP32[(($3768)>>2)];
      var $21097=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21095, tempValue);
      var $21098=($21097.f1 = $21096, $21097);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2950: // $21099
      throw "Reached an unreachable!"
    case 2951: // $_ZnwjPKci_exit368
      var $21100=HEAP32[(($result_i367)>>2)];
      var $21101=$3764;
      var $21102=$3765;
      var $21103=$3766;
      var $21104=$result_i367;
      var $21105=$3767;
      var $21106=$3768;
      var $21107=$21100;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6165, 4, 2, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2952; break; } else { __label__ = 12601; break; }
    case 2952: // $21108
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6166, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2953; break; } else { __label__ = 12601; break; }
    case 2953: // $21109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6167, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2954; break; } else { __label__ = 12601; break; }
    case 2954: // $21110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2955; break; } else { __label__ = 12601; break; }
    case 2955: // $21111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2956; break; } else { __label__ = 12601; break; }
    case 2956: // $21112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2957; break; } else { __label__ = 12601; break; }
    case 2957: // $21113
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2958; break; } else { __label__ = 12601; break; }
    case 2958: // $21114
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6164, $6165, $6166, $6167, $6168, $6169, $6170, $6171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2959; break; } else { __label__ = 12601; break; }
    case 2959: // $21115
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21107, 67, 3, 2, ((STRING_TABLE.__str559)|0), ((STRING_TABLE.__str560)|0), $6164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2960; break; } else { __label__ = 12601; break; }
    case 2960: // $21116
      var $21117=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21107);
      var $21118=__ZN11simple_listI16input_type_entryE6appendERS0_($21068, $21117);
      var $21119=$4689;
      var $21120=$3759;
      var $21121=$3760;
      var $21122=$3761;
      var $21123=$result_i369;
      var $21124=$3762;
      var $21125=$3763;
      HEAP32[(($3759)>>2)]=408;
      HEAP32[(($3760)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3761)>>2)]=241;
      var $21126=HEAP32[(($3759)>>2)];
      var $21127=HEAP32[(($3760)>>2)];
      var $21128=HEAP32[(($3761)>>2)];
      var $21129=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21126, $21127, $21128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2961; break; } else { __label__ = 2963; break; };
    case 2961: // $21130
      HEAP32[(($result_i369)>>2)]=$21129;
      var $21131=HEAP32[(($result_i369)>>2)];
      var $21132=(($21131)|0)==0;
      if ($21132) { __label__ = 2962; break; } else { __label__ = 2967; break; }
    case 2962: // $21133
      var $21134=___cxa_allocate_exception(4);
      var $21135=$21134;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21135);
      (function() { try { __THREW__ = false; return ___cxa_throw($21134, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2966; break; } else { __label__ = 2963; break; }
    case 2963: // $21136
      var $21137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21138=$21137.f0;
      HEAP32[(($3762)>>2)]=$21138;
      var $21139=$21137.f1;
      HEAP32[(($3763)>>2)]=$21139;
      var $21140=HEAP32[(($3763)>>2)];
      var $21141=(($21140)|0) < 0;
      if ($21141) { __label__ = 2964; break; } else { __label__ = 2965; break; }
    case 2964: // $21142
      var $21143=HEAP32[(($3762)>>2)];
      ___cxa_call_unexpected($21143);
      throw "Reached an unreachable!"
    case 2965: // $21144
      var $21145=HEAP32[(($3762)>>2)];
      var $21146=HEAP32[(($3762)>>2)];
      var $21147=HEAP32[(($3763)>>2)];
      var $21148=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21146, tempValue);
      var $21149=($21148.f1 = $21147, $21148);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2966: // $21150
      throw "Reached an unreachable!"
    case 2967: // $_ZnwjPKci_exit370
      var $21151=HEAP32[(($result_i369)>>2)];
      var $21152=$3759;
      var $21153=$3760;
      var $21154=$3761;
      var $21155=$result_i369;
      var $21156=$3762;
      var $21157=$3763;
      var $21158=$21151;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6173, 4, 2, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2968; break; } else { __label__ = 12606; break; }
    case 2968: // $21159
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2969; break; } else { __label__ = 12606; break; }
    case 2969: // $21160
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2970; break; } else { __label__ = 12606; break; }
    case 2970: // $21161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2971; break; } else { __label__ = 12606; break; }
    case 2971: // $21162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2972; break; } else { __label__ = 12606; break; }
    case 2972: // $21163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2973; break; } else { __label__ = 12606; break; }
    case 2973: // $21164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2974; break; } else { __label__ = 12606; break; }
    case 2974: // $21165
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6172, $6173, $6174, $6175, $6176, $6177, $6178, $6179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2975; break; } else { __label__ = 12606; break; }
    case 2975: // $21166
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21158, 68, 3, 2, ((STRING_TABLE.__str561)|0), ((STRING_TABLE.__str562)|0), $6172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2976; break; } else { __label__ = 12606; break; }
    case 2976: // $21167
      var $21168=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21158);
      var $21169=__ZN11simple_listI16input_type_entryE6appendERS0_($21119, $21168);
      var $21170=$4689;
      var $21171=$3754;
      var $21172=$3755;
      var $21173=$3756;
      var $21174=$result_i371;
      var $21175=$3757;
      var $21176=$3758;
      HEAP32[(($3754)>>2)]=408;
      HEAP32[(($3755)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3756)>>2)]=242;
      var $21177=HEAP32[(($3754)>>2)];
      var $21178=HEAP32[(($3755)>>2)];
      var $21179=HEAP32[(($3756)>>2)];
      var $21180=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21177, $21178, $21179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2977; break; } else { __label__ = 2979; break; };
    case 2977: // $21181
      HEAP32[(($result_i371)>>2)]=$21180;
      var $21182=HEAP32[(($result_i371)>>2)];
      var $21183=(($21182)|0)==0;
      if ($21183) { __label__ = 2978; break; } else { __label__ = 2983; break; }
    case 2978: // $21184
      var $21185=___cxa_allocate_exception(4);
      var $21186=$21185;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21186);
      (function() { try { __THREW__ = false; return ___cxa_throw($21185, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2982; break; } else { __label__ = 2979; break; }
    case 2979: // $21187
      var $21188=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21189=$21188.f0;
      HEAP32[(($3757)>>2)]=$21189;
      var $21190=$21188.f1;
      HEAP32[(($3758)>>2)]=$21190;
      var $21191=HEAP32[(($3758)>>2)];
      var $21192=(($21191)|0) < 0;
      if ($21192) { __label__ = 2980; break; } else { __label__ = 2981; break; }
    case 2980: // $21193
      var $21194=HEAP32[(($3757)>>2)];
      ___cxa_call_unexpected($21194);
      throw "Reached an unreachable!"
    case 2981: // $21195
      var $21196=HEAP32[(($3757)>>2)];
      var $21197=HEAP32[(($3757)>>2)];
      var $21198=HEAP32[(($3758)>>2)];
      var $21199=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21197, tempValue);
      var $21200=($21199.f1 = $21198, $21199);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2982: // $21201
      throw "Reached an unreachable!"
    case 2983: // $_ZnwjPKci_exit372
      var $21202=HEAP32[(($result_i371)>>2)];
      var $21203=$3754;
      var $21204=$3755;
      var $21205=$3756;
      var $21206=$result_i371;
      var $21207=$3757;
      var $21208=$3758;
      var $21209=$21202;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6181, 4, 2, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2984; break; } else { __label__ = 12611; break; }
    case 2984: // $21210
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6182, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2985; break; } else { __label__ = 12611; break; }
    case 2985: // $21211
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6183, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2986; break; } else { __label__ = 12611; break; }
    case 2986: // $21212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2987; break; } else { __label__ = 12611; break; }
    case 2987: // $21213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2988; break; } else { __label__ = 12611; break; }
    case 2988: // $21214
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2989; break; } else { __label__ = 12611; break; }
    case 2989: // $21215
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2990; break; } else { __label__ = 12611; break; }
    case 2990: // $21216
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6180, $6181, $6182, $6183, $6184, $6185, $6186, $6187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2991; break; } else { __label__ = 12611; break; }
    case 2991: // $21217
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21209, 69, 3, 2, ((STRING_TABLE.__str563)|0), ((STRING_TABLE.__str564)|0), $6180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2992; break; } else { __label__ = 12611; break; }
    case 2992: // $21218
      var $21219=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21209);
      var $21220=__ZN11simple_listI16input_type_entryE6appendERS0_($21170, $21219);
      var $21221=$4689;
      var $21222=$3749;
      var $21223=$3750;
      var $21224=$3751;
      var $21225=$result_i373;
      var $21226=$3752;
      var $21227=$3753;
      HEAP32[(($3749)>>2)]=408;
      HEAP32[(($3750)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3751)>>2)]=243;
      var $21228=HEAP32[(($3749)>>2)];
      var $21229=HEAP32[(($3750)>>2)];
      var $21230=HEAP32[(($3751)>>2)];
      var $21231=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21228, $21229, $21230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2993; break; } else { __label__ = 2995; break; };
    case 2993: // $21232
      HEAP32[(($result_i373)>>2)]=$21231;
      var $21233=HEAP32[(($result_i373)>>2)];
      var $21234=(($21233)|0)==0;
      if ($21234) { __label__ = 2994; break; } else { __label__ = 2999; break; }
    case 2994: // $21235
      var $21236=___cxa_allocate_exception(4);
      var $21237=$21236;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21237);
      (function() { try { __THREW__ = false; return ___cxa_throw($21236, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2998; break; } else { __label__ = 2995; break; }
    case 2995: // $21238
      var $21239=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21240=$21239.f0;
      HEAP32[(($3752)>>2)]=$21240;
      var $21241=$21239.f1;
      HEAP32[(($3753)>>2)]=$21241;
      var $21242=HEAP32[(($3753)>>2)];
      var $21243=(($21242)|0) < 0;
      if ($21243) { __label__ = 2996; break; } else { __label__ = 2997; break; }
    case 2996: // $21244
      var $21245=HEAP32[(($3752)>>2)];
      ___cxa_call_unexpected($21245);
      throw "Reached an unreachable!"
    case 2997: // $21246
      var $21247=HEAP32[(($3752)>>2)];
      var $21248=HEAP32[(($3752)>>2)];
      var $21249=HEAP32[(($3753)>>2)];
      var $21250=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21248, tempValue);
      var $21251=($21250.f1 = $21249, $21250);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 2998: // $21252
      throw "Reached an unreachable!"
    case 2999: // $_ZnwjPKci_exit374
      var $21253=HEAP32[(($result_i373)>>2)];
      var $21254=$3749;
      var $21255=$3750;
      var $21256=$3751;
      var $21257=$result_i373;
      var $21258=$3752;
      var $21259=$3753;
      var $21260=$21253;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6189, 4, 2, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3000; break; } else { __label__ = 12616; break; }
    case 3000: // $21261
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6190, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3001; break; } else { __label__ = 12616; break; }
    case 3001: // $21262
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6191, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3002; break; } else { __label__ = 12616; break; }
    case 3002: // $21263
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3003; break; } else { __label__ = 12616; break; }
    case 3003: // $21264
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3004; break; } else { __label__ = 12616; break; }
    case 3004: // $21265
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3005; break; } else { __label__ = 12616; break; }
    case 3005: // $21266
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3006; break; } else { __label__ = 12616; break; }
    case 3006: // $21267
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6188, $6189, $6190, $6191, $6192, $6193, $6194, $6195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3007; break; } else { __label__ = 12616; break; }
    case 3007: // $21268
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21260, 70, 3, 2, ((STRING_TABLE.__str565)|0), ((STRING_TABLE.__str566)|0), $6188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3008; break; } else { __label__ = 12616; break; }
    case 3008: // $21269
      var $21270=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21260);
      var $21271=__ZN11simple_listI16input_type_entryE6appendERS0_($21221, $21270);
      var $21272=$4689;
      var $21273=$3744;
      var $21274=$3745;
      var $21275=$3746;
      var $21276=$result_i375;
      var $21277=$3747;
      var $21278=$3748;
      HEAP32[(($3744)>>2)]=408;
      HEAP32[(($3745)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3746)>>2)]=244;
      var $21279=HEAP32[(($3744)>>2)];
      var $21280=HEAP32[(($3745)>>2)];
      var $21281=HEAP32[(($3746)>>2)];
      var $21282=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21279, $21280, $21281) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3009; break; } else { __label__ = 3011; break; };
    case 3009: // $21283
      HEAP32[(($result_i375)>>2)]=$21282;
      var $21284=HEAP32[(($result_i375)>>2)];
      var $21285=(($21284)|0)==0;
      if ($21285) { __label__ = 3010; break; } else { __label__ = 3015; break; }
    case 3010: // $21286
      var $21287=___cxa_allocate_exception(4);
      var $21288=$21287;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21288);
      (function() { try { __THREW__ = false; return ___cxa_throw($21287, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3014; break; } else { __label__ = 3011; break; }
    case 3011: // $21289
      var $21290=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21291=$21290.f0;
      HEAP32[(($3747)>>2)]=$21291;
      var $21292=$21290.f1;
      HEAP32[(($3748)>>2)]=$21292;
      var $21293=HEAP32[(($3748)>>2)];
      var $21294=(($21293)|0) < 0;
      if ($21294) { __label__ = 3012; break; } else { __label__ = 3013; break; }
    case 3012: // $21295
      var $21296=HEAP32[(($3747)>>2)];
      ___cxa_call_unexpected($21296);
      throw "Reached an unreachable!"
    case 3013: // $21297
      var $21298=HEAP32[(($3747)>>2)];
      var $21299=HEAP32[(($3747)>>2)];
      var $21300=HEAP32[(($3748)>>2)];
      var $21301=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21299, tempValue);
      var $21302=($21301.f1 = $21300, $21301);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3014: // $21303
      throw "Reached an unreachable!"
    case 3015: // $_ZnwjPKci_exit376
      var $21304=HEAP32[(($result_i375)>>2)];
      var $21305=$3744;
      var $21306=$3745;
      var $21307=$3746;
      var $21308=$result_i375;
      var $21309=$3747;
      var $21310=$3748;
      var $21311=$21304;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6197, 4, 2, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3016; break; } else { __label__ = 12621; break; }
    case 3016: // $21312
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3017; break; } else { __label__ = 12621; break; }
    case 3017: // $21313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3018; break; } else { __label__ = 12621; break; }
    case 3018: // $21314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3019; break; } else { __label__ = 12621; break; }
    case 3019: // $21315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3020; break; } else { __label__ = 12621; break; }
    case 3020: // $21316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3021; break; } else { __label__ = 12621; break; }
    case 3021: // $21317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3022; break; } else { __label__ = 12621; break; }
    case 3022: // $21318
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6196, $6197, $6198, $6199, $6200, $6201, $6202, $6203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3023; break; } else { __label__ = 12621; break; }
    case 3023: // $21319
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21311, 71, 3, 2, ((STRING_TABLE.__str567)|0), ((STRING_TABLE.__str568)|0), $6196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3024; break; } else { __label__ = 12621; break; }
    case 3024: // $21320
      var $21321=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21311);
      var $21322=__ZN11simple_listI16input_type_entryE6appendERS0_($21272, $21321);
      var $21323=$4689;
      var $21324=$3739;
      var $21325=$3740;
      var $21326=$3741;
      var $21327=$result_i377;
      var $21328=$3742;
      var $21329=$3743;
      HEAP32[(($3739)>>2)]=408;
      HEAP32[(($3740)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3741)>>2)]=245;
      var $21330=HEAP32[(($3739)>>2)];
      var $21331=HEAP32[(($3740)>>2)];
      var $21332=HEAP32[(($3741)>>2)];
      var $21333=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21330, $21331, $21332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3025; break; } else { __label__ = 3027; break; };
    case 3025: // $21334
      HEAP32[(($result_i377)>>2)]=$21333;
      var $21335=HEAP32[(($result_i377)>>2)];
      var $21336=(($21335)|0)==0;
      if ($21336) { __label__ = 3026; break; } else { __label__ = 3031; break; }
    case 3026: // $21337
      var $21338=___cxa_allocate_exception(4);
      var $21339=$21338;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21339);
      (function() { try { __THREW__ = false; return ___cxa_throw($21338, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3030; break; } else { __label__ = 3027; break; }
    case 3027: // $21340
      var $21341=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21342=$21341.f0;
      HEAP32[(($3742)>>2)]=$21342;
      var $21343=$21341.f1;
      HEAP32[(($3743)>>2)]=$21343;
      var $21344=HEAP32[(($3743)>>2)];
      var $21345=(($21344)|0) < 0;
      if ($21345) { __label__ = 3028; break; } else { __label__ = 3029; break; }
    case 3028: // $21346
      var $21347=HEAP32[(($3742)>>2)];
      ___cxa_call_unexpected($21347);
      throw "Reached an unreachable!"
    case 3029: // $21348
      var $21349=HEAP32[(($3742)>>2)];
      var $21350=HEAP32[(($3742)>>2)];
      var $21351=HEAP32[(($3743)>>2)];
      var $21352=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21350, tempValue);
      var $21353=($21352.f1 = $21351, $21352);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3030: // $21354
      throw "Reached an unreachable!"
    case 3031: // $_ZnwjPKci_exit378
      var $21355=HEAP32[(($result_i377)>>2)];
      var $21356=$3739;
      var $21357=$3740;
      var $21358=$3741;
      var $21359=$result_i377;
      var $21360=$3742;
      var $21361=$3743;
      var $21362=$21355;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6205, 4, 2, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3032; break; } else { __label__ = 12626; break; }
    case 3032: // $21363
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6206, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3033; break; } else { __label__ = 12626; break; }
    case 3033: // $21364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6207, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3034; break; } else { __label__ = 12626; break; }
    case 3034: // $21365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3035; break; } else { __label__ = 12626; break; }
    case 3035: // $21366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3036; break; } else { __label__ = 12626; break; }
    case 3036: // $21367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3037; break; } else { __label__ = 12626; break; }
    case 3037: // $21368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3038; break; } else { __label__ = 12626; break; }
    case 3038: // $21369
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6204, $6205, $6206, $6207, $6208, $6209, $6210, $6211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3039; break; } else { __label__ = 12626; break; }
    case 3039: // $21370
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21362, 72, 3, 2, ((STRING_TABLE.__str569)|0), ((STRING_TABLE.__str570)|0), $6204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3040; break; } else { __label__ = 12626; break; }
    case 3040: // $21371
      var $21372=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21362);
      var $21373=__ZN11simple_listI16input_type_entryE6appendERS0_($21323, $21372);
      var $21374=$4689;
      var $21375=$3734;
      var $21376=$3735;
      var $21377=$3736;
      var $21378=$result_i379;
      var $21379=$3737;
      var $21380=$3738;
      HEAP32[(($3734)>>2)]=408;
      HEAP32[(($3735)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3736)>>2)]=246;
      var $21381=HEAP32[(($3734)>>2)];
      var $21382=HEAP32[(($3735)>>2)];
      var $21383=HEAP32[(($3736)>>2)];
      var $21384=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21381, $21382, $21383) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3041; break; } else { __label__ = 3043; break; };
    case 3041: // $21385
      HEAP32[(($result_i379)>>2)]=$21384;
      var $21386=HEAP32[(($result_i379)>>2)];
      var $21387=(($21386)|0)==0;
      if ($21387) { __label__ = 3042; break; } else { __label__ = 3047; break; }
    case 3042: // $21388
      var $21389=___cxa_allocate_exception(4);
      var $21390=$21389;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21390);
      (function() { try { __THREW__ = false; return ___cxa_throw($21389, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3046; break; } else { __label__ = 3043; break; }
    case 3043: // $21391
      var $21392=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21393=$21392.f0;
      HEAP32[(($3737)>>2)]=$21393;
      var $21394=$21392.f1;
      HEAP32[(($3738)>>2)]=$21394;
      var $21395=HEAP32[(($3738)>>2)];
      var $21396=(($21395)|0) < 0;
      if ($21396) { __label__ = 3044; break; } else { __label__ = 3045; break; }
    case 3044: // $21397
      var $21398=HEAP32[(($3737)>>2)];
      ___cxa_call_unexpected($21398);
      throw "Reached an unreachable!"
    case 3045: // $21399
      var $21400=HEAP32[(($3737)>>2)];
      var $21401=HEAP32[(($3737)>>2)];
      var $21402=HEAP32[(($3738)>>2)];
      var $21403=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21401, tempValue);
      var $21404=($21403.f1 = $21402, $21403);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3046: // $21405
      throw "Reached an unreachable!"
    case 3047: // $_ZnwjPKci_exit380
      var $21406=HEAP32[(($result_i379)>>2)];
      var $21407=$3734;
      var $21408=$3735;
      var $21409=$3736;
      var $21410=$result_i379;
      var $21411=$3737;
      var $21412=$3738;
      var $21413=$21406;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6213, 4, 2, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3048; break; } else { __label__ = 12631; break; }
    case 3048: // $21414
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3049; break; } else { __label__ = 12631; break; }
    case 3049: // $21415
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3050; break; } else { __label__ = 12631; break; }
    case 3050: // $21416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3051; break; } else { __label__ = 12631; break; }
    case 3051: // $21417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3052; break; } else { __label__ = 12631; break; }
    case 3052: // $21418
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3053; break; } else { __label__ = 12631; break; }
    case 3053: // $21419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3054; break; } else { __label__ = 12631; break; }
    case 3054: // $21420
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6212, $6213, $6214, $6215, $6216, $6217, $6218, $6219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3055; break; } else { __label__ = 12631; break; }
    case 3055: // $21421
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21413, 73, 3, 2, ((STRING_TABLE.__str571)|0), ((STRING_TABLE.__str572)|0), $6212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3056; break; } else { __label__ = 12631; break; }
    case 3056: // $21422
      var $21423=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21413);
      var $21424=__ZN11simple_listI16input_type_entryE6appendERS0_($21374, $21423);
      var $21425=$4689;
      var $21426=$3729;
      var $21427=$3730;
      var $21428=$3731;
      var $21429=$result_i381;
      var $21430=$3732;
      var $21431=$3733;
      HEAP32[(($3729)>>2)]=408;
      HEAP32[(($3730)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3731)>>2)]=247;
      var $21432=HEAP32[(($3729)>>2)];
      var $21433=HEAP32[(($3730)>>2)];
      var $21434=HEAP32[(($3731)>>2)];
      var $21435=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21432, $21433, $21434) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3057; break; } else { __label__ = 3059; break; };
    case 3057: // $21436
      HEAP32[(($result_i381)>>2)]=$21435;
      var $21437=HEAP32[(($result_i381)>>2)];
      var $21438=(($21437)|0)==0;
      if ($21438) { __label__ = 3058; break; } else { __label__ = 3063; break; }
    case 3058: // $21439
      var $21440=___cxa_allocate_exception(4);
      var $21441=$21440;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21441);
      (function() { try { __THREW__ = false; return ___cxa_throw($21440, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3062; break; } else { __label__ = 3059; break; }
    case 3059: // $21442
      var $21443=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21444=$21443.f0;
      HEAP32[(($3732)>>2)]=$21444;
      var $21445=$21443.f1;
      HEAP32[(($3733)>>2)]=$21445;
      var $21446=HEAP32[(($3733)>>2)];
      var $21447=(($21446)|0) < 0;
      if ($21447) { __label__ = 3060; break; } else { __label__ = 3061; break; }
    case 3060: // $21448
      var $21449=HEAP32[(($3732)>>2)];
      ___cxa_call_unexpected($21449);
      throw "Reached an unreachable!"
    case 3061: // $21450
      var $21451=HEAP32[(($3732)>>2)];
      var $21452=HEAP32[(($3732)>>2)];
      var $21453=HEAP32[(($3733)>>2)];
      var $21454=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21452, tempValue);
      var $21455=($21454.f1 = $21453, $21454);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3062: // $21456
      throw "Reached an unreachable!"
    case 3063: // $_ZnwjPKci_exit382
      var $21457=HEAP32[(($result_i381)>>2)];
      var $21458=$3729;
      var $21459=$3730;
      var $21460=$3731;
      var $21461=$result_i381;
      var $21462=$3732;
      var $21463=$3733;
      var $21464=$21457;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6221, 4, 2, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3064; break; } else { __label__ = 12636; break; }
    case 3064: // $21465
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6222, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3065; break; } else { __label__ = 12636; break; }
    case 3065: // $21466
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3066; break; } else { __label__ = 12636; break; }
    case 3066: // $21467
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3067; break; } else { __label__ = 12636; break; }
    case 3067: // $21468
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3068; break; } else { __label__ = 12636; break; }
    case 3068: // $21469
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3069; break; } else { __label__ = 12636; break; }
    case 3069: // $21470
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3070; break; } else { __label__ = 12636; break; }
    case 3070: // $21471
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6220, $6221, $6222, $6223, $6224, $6225, $6226, $6227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3071; break; } else { __label__ = 12636; break; }
    case 3071: // $21472
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21464, 74, 3, 2, ((STRING_TABLE.__str573)|0), ((STRING_TABLE.__str574412)|0), $6220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3072; break; } else { __label__ = 12636; break; }
    case 3072: // $21473
      var $21474=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21464);
      var $21475=__ZN11simple_listI16input_type_entryE6appendERS0_($21425, $21474);
      var $21476=$4689;
      var $21477=$3724;
      var $21478=$3725;
      var $21479=$3726;
      var $21480=$result_i383;
      var $21481=$3727;
      var $21482=$3728;
      HEAP32[(($3724)>>2)]=408;
      HEAP32[(($3725)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3726)>>2)]=248;
      var $21483=HEAP32[(($3724)>>2)];
      var $21484=HEAP32[(($3725)>>2)];
      var $21485=HEAP32[(($3726)>>2)];
      var $21486=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21483, $21484, $21485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3073; break; } else { __label__ = 3075; break; };
    case 3073: // $21487
      HEAP32[(($result_i383)>>2)]=$21486;
      var $21488=HEAP32[(($result_i383)>>2)];
      var $21489=(($21488)|0)==0;
      if ($21489) { __label__ = 3074; break; } else { __label__ = 3079; break; }
    case 3074: // $21490
      var $21491=___cxa_allocate_exception(4);
      var $21492=$21491;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21492);
      (function() { try { __THREW__ = false; return ___cxa_throw($21491, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3078; break; } else { __label__ = 3075; break; }
    case 3075: // $21493
      var $21494=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21495=$21494.f0;
      HEAP32[(($3727)>>2)]=$21495;
      var $21496=$21494.f1;
      HEAP32[(($3728)>>2)]=$21496;
      var $21497=HEAP32[(($3728)>>2)];
      var $21498=(($21497)|0) < 0;
      if ($21498) { __label__ = 3076; break; } else { __label__ = 3077; break; }
    case 3076: // $21499
      var $21500=HEAP32[(($3727)>>2)];
      ___cxa_call_unexpected($21500);
      throw "Reached an unreachable!"
    case 3077: // $21501
      var $21502=HEAP32[(($3727)>>2)];
      var $21503=HEAP32[(($3727)>>2)];
      var $21504=HEAP32[(($3728)>>2)];
      var $21505=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21503, tempValue);
      var $21506=($21505.f1 = $21504, $21505);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3078: // $21507
      throw "Reached an unreachable!"
    case 3079: // $_ZnwjPKci_exit384
      var $21508=HEAP32[(($result_i383)>>2)];
      var $21509=$3724;
      var $21510=$3725;
      var $21511=$3726;
      var $21512=$result_i383;
      var $21513=$3727;
      var $21514=$3728;
      var $21515=$21508;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6229, 1, 0, 1, 0, 30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3080; break; } else { __label__ = 12641; break; }
    case 3080: // $21516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6230, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3081; break; } else { __label__ = 12641; break; }
    case 3081: // $21517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6231, 4, 2, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3082; break; } else { __label__ = 12641; break; }
    case 3082: // $21518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3083; break; } else { __label__ = 12641; break; }
    case 3083: // $21519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3084; break; } else { __label__ = 12641; break; }
    case 3084: // $21520
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3085; break; } else { __label__ = 12641; break; }
    case 3085: // $21521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3086; break; } else { __label__ = 12641; break; }
    case 3086: // $21522
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6228, $6229, $6230, $6231, $6232, $6233, $6234, $6235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3087; break; } else { __label__ = 12641; break; }
    case 3087: // $21523
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21515, 43, 3, 2, ((STRING_TABLE.__str575)|0), ((STRING_TABLE.__str576)|0), $6228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3088; break; } else { __label__ = 12641; break; }
    case 3088: // $21524
      var $21525=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21515);
      var $21526=__ZN11simple_listI16input_type_entryE6appendERS0_($21476, $21525);
      var $21527=$4689;
      var $21528=$3719;
      var $21529=$3720;
      var $21530=$3721;
      var $21531=$result_i385;
      var $21532=$3722;
      var $21533=$3723;
      HEAP32[(($3719)>>2)]=408;
      HEAP32[(($3720)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3721)>>2)]=249;
      var $21534=HEAP32[(($3719)>>2)];
      var $21535=HEAP32[(($3720)>>2)];
      var $21536=HEAP32[(($3721)>>2)];
      var $21537=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21534, $21535, $21536) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3089; break; } else { __label__ = 3091; break; };
    case 3089: // $21538
      HEAP32[(($result_i385)>>2)]=$21537;
      var $21539=HEAP32[(($result_i385)>>2)];
      var $21540=(($21539)|0)==0;
      if ($21540) { __label__ = 3090; break; } else { __label__ = 3095; break; }
    case 3090: // $21541
      var $21542=___cxa_allocate_exception(4);
      var $21543=$21542;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21543);
      (function() { try { __THREW__ = false; return ___cxa_throw($21542, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3094; break; } else { __label__ = 3091; break; }
    case 3091: // $21544
      var $21545=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21546=$21545.f0;
      HEAP32[(($3722)>>2)]=$21546;
      var $21547=$21545.f1;
      HEAP32[(($3723)>>2)]=$21547;
      var $21548=HEAP32[(($3723)>>2)];
      var $21549=(($21548)|0) < 0;
      if ($21549) { __label__ = 3092; break; } else { __label__ = 3093; break; }
    case 3092: // $21550
      var $21551=HEAP32[(($3722)>>2)];
      ___cxa_call_unexpected($21551);
      throw "Reached an unreachable!"
    case 3093: // $21552
      var $21553=HEAP32[(($3722)>>2)];
      var $21554=HEAP32[(($3722)>>2)];
      var $21555=HEAP32[(($3723)>>2)];
      var $21556=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21554, tempValue);
      var $21557=($21556.f1 = $21555, $21556);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3094: // $21558
      throw "Reached an unreachable!"
    case 3095: // $_ZnwjPKci_exit386
      var $21559=HEAP32[(($result_i385)>>2)];
      var $21560=$3719;
      var $21561=$3720;
      var $21562=$3721;
      var $21563=$result_i385;
      var $21564=$3722;
      var $21565=$3723;
      var $21566=$21559;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6237, 1, 0, 1, 0, 34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3096; break; } else { __label__ = 12646; break; }
    case 3096: // $21567
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6238, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3097; break; } else { __label__ = 12646; break; }
    case 3097: // $21568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6239, 4, 2, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3098; break; } else { __label__ = 12646; break; }
    case 3098: // $21569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3099; break; } else { __label__ = 12646; break; }
    case 3099: // $21570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3100; break; } else { __label__ = 12646; break; }
    case 3100: // $21571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3101; break; } else { __label__ = 12646; break; }
    case 3101: // $21572
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3102; break; } else { __label__ = 12646; break; }
    case 3102: // $21573
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6236, $6237, $6238, $6239, $6240, $6241, $6242, $6243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3103; break; } else { __label__ = 12646; break; }
    case 3103: // $21574
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21566, 44, 3, 2, ((STRING_TABLE.__str577)|0), ((STRING_TABLE.__str578)|0), $6236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3104; break; } else { __label__ = 12646; break; }
    case 3104: // $21575
      var $21576=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21566);
      var $21577=__ZN11simple_listI16input_type_entryE6appendERS0_($21527, $21576);
      var $21578=$4689;
      var $21579=$3714;
      var $21580=$3715;
      var $21581=$3716;
      var $21582=$result_i387;
      var $21583=$3717;
      var $21584=$3718;
      HEAP32[(($3714)>>2)]=408;
      HEAP32[(($3715)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3716)>>2)]=251;
      var $21585=HEAP32[(($3714)>>2)];
      var $21586=HEAP32[(($3715)>>2)];
      var $21587=HEAP32[(($3716)>>2)];
      var $21588=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21585, $21586, $21587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3105; break; } else { __label__ = 3107; break; };
    case 3105: // $21589
      HEAP32[(($result_i387)>>2)]=$21588;
      var $21590=HEAP32[(($result_i387)>>2)];
      var $21591=(($21590)|0)==0;
      if ($21591) { __label__ = 3106; break; } else { __label__ = 3111; break; }
    case 3106: // $21592
      var $21593=___cxa_allocate_exception(4);
      var $21594=$21593;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21594);
      (function() { try { __THREW__ = false; return ___cxa_throw($21593, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3110; break; } else { __label__ = 3107; break; }
    case 3107: // $21595
      var $21596=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21597=$21596.f0;
      HEAP32[(($3717)>>2)]=$21597;
      var $21598=$21596.f1;
      HEAP32[(($3718)>>2)]=$21598;
      var $21599=HEAP32[(($3718)>>2)];
      var $21600=(($21599)|0) < 0;
      if ($21600) { __label__ = 3108; break; } else { __label__ = 3109; break; }
    case 3108: // $21601
      var $21602=HEAP32[(($3717)>>2)];
      ___cxa_call_unexpected($21602);
      throw "Reached an unreachable!"
    case 3109: // $21603
      var $21604=HEAP32[(($3717)>>2)];
      var $21605=HEAP32[(($3717)>>2)];
      var $21606=HEAP32[(($3718)>>2)];
      var $21607=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21605, tempValue);
      var $21608=($21607.f1 = $21606, $21607);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3110: // $21609
      throw "Reached an unreachable!"
    case 3111: // $_ZnwjPKci_exit388
      var $21610=HEAP32[(($result_i387)>>2)];
      var $21611=$3714;
      var $21612=$3715;
      var $21613=$3716;
      var $21614=$result_i387;
      var $21615=$3717;
      var $21616=$3718;
      var $21617=$21610;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6245, 1, 0, 1, 0, 87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3112; break; } else { __label__ = 12651; break; }
    case 3112: // $21618
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6246, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3113; break; } else { __label__ = 12651; break; }
    case 3113: // $21619
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6247, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3114; break; } else { __label__ = 12651; break; }
    case 3114: // $21620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3115; break; } else { __label__ = 12651; break; }
    case 3115: // $21621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3116; break; } else { __label__ = 12651; break; }
    case 3116: // $21622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3117; break; } else { __label__ = 12651; break; }
    case 3117: // $21623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3118; break; } else { __label__ = 12651; break; }
    case 3118: // $21624
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6244, $6245, $6246, $6247, $6248, $6249, $6250, $6251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3119; break; } else { __label__ = 12651; break; }
    case 3119: // $21625
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21617, 47, 4, 3, ((STRING_TABLE.__str579)|0), ((STRING_TABLE.__str580)|0), $6244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3120; break; } else { __label__ = 12651; break; }
    case 3120: // $21626
      var $21627=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21617);
      var $21628=__ZN11simple_listI16input_type_entryE6appendERS0_($21578, $21627);
      var $21629=$4689;
      var $21630=$3709;
      var $21631=$3710;
      var $21632=$3711;
      var $21633=$result_i389;
      var $21634=$3712;
      var $21635=$3713;
      HEAP32[(($3709)>>2)]=408;
      HEAP32[(($3710)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3711)>>2)]=252;
      var $21636=HEAP32[(($3709)>>2)];
      var $21637=HEAP32[(($3710)>>2)];
      var $21638=HEAP32[(($3711)>>2)];
      var $21639=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21636, $21637, $21638) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3121; break; } else { __label__ = 3123; break; };
    case 3121: // $21640
      HEAP32[(($result_i389)>>2)]=$21639;
      var $21641=HEAP32[(($result_i389)>>2)];
      var $21642=(($21641)|0)==0;
      if ($21642) { __label__ = 3122; break; } else { __label__ = 3127; break; }
    case 3122: // $21643
      var $21644=___cxa_allocate_exception(4);
      var $21645=$21644;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21645);
      (function() { try { __THREW__ = false; return ___cxa_throw($21644, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3126; break; } else { __label__ = 3123; break; }
    case 3123: // $21646
      var $21647=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21648=$21647.f0;
      HEAP32[(($3712)>>2)]=$21648;
      var $21649=$21647.f1;
      HEAP32[(($3713)>>2)]=$21649;
      var $21650=HEAP32[(($3713)>>2)];
      var $21651=(($21650)|0) < 0;
      if ($21651) { __label__ = 3124; break; } else { __label__ = 3125; break; }
    case 3124: // $21652
      var $21653=HEAP32[(($3712)>>2)];
      ___cxa_call_unexpected($21653);
      throw "Reached an unreachable!"
    case 3125: // $21654
      var $21655=HEAP32[(($3712)>>2)];
      var $21656=HEAP32[(($3712)>>2)];
      var $21657=HEAP32[(($3713)>>2)];
      var $21658=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21656, tempValue);
      var $21659=($21658.f1 = $21657, $21658);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3126: // $21660
      throw "Reached an unreachable!"
    case 3127: // $_ZnwjPKci_exit390
      var $21661=HEAP32[(($result_i389)>>2)];
      var $21662=$3709;
      var $21663=$3710;
      var $21664=$3711;
      var $21665=$result_i389;
      var $21666=$3712;
      var $21667=$3713;
      var $21668=$21661;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6253, 1, 0, 1, 0, 81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3128; break; } else { __label__ = 12656; break; }
    case 3128: // $21669
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6254, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3129; break; } else { __label__ = 12656; break; }
    case 3129: // $21670
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6255, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3130; break; } else { __label__ = 12656; break; }
    case 3130: // $21671
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3131; break; } else { __label__ = 12656; break; }
    case 3131: // $21672
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3132; break; } else { __label__ = 12656; break; }
    case 3132: // $21673
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3133; break; } else { __label__ = 12656; break; }
    case 3133: // $21674
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3134; break; } else { __label__ = 12656; break; }
    case 3134: // $21675
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6252, $6253, $6254, $6255, $6256, $6257, $6258, $6259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3135; break; } else { __label__ = 12656; break; }
    case 3135: // $21676
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21668, 48, 4, 3, ((STRING_TABLE.__str581)|0), ((STRING_TABLE.__str582)|0), $6252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3136; break; } else { __label__ = 12656; break; }
    case 3136: // $21677
      var $21678=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21668);
      var $21679=__ZN11simple_listI16input_type_entryE6appendERS0_($21629, $21678);
      var $21680=$4689;
      var $21681=$3704;
      var $21682=$3705;
      var $21683=$3706;
      var $21684=$result_i391;
      var $21685=$3707;
      var $21686=$3708;
      HEAP32[(($3704)>>2)]=408;
      HEAP32[(($3705)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3706)>>2)]=253;
      var $21687=HEAP32[(($3704)>>2)];
      var $21688=HEAP32[(($3705)>>2)];
      var $21689=HEAP32[(($3706)>>2)];
      var $21690=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21687, $21688, $21689) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3137; break; } else { __label__ = 3139; break; };
    case 3137: // $21691
      HEAP32[(($result_i391)>>2)]=$21690;
      var $21692=HEAP32[(($result_i391)>>2)];
      var $21693=(($21692)|0)==0;
      if ($21693) { __label__ = 3138; break; } else { __label__ = 3143; break; }
    case 3138: // $21694
      var $21695=___cxa_allocate_exception(4);
      var $21696=$21695;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21696);
      (function() { try { __THREW__ = false; return ___cxa_throw($21695, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3142; break; } else { __label__ = 3139; break; }
    case 3139: // $21697
      var $21698=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21699=$21698.f0;
      HEAP32[(($3707)>>2)]=$21699;
      var $21700=$21698.f1;
      HEAP32[(($3708)>>2)]=$21700;
      var $21701=HEAP32[(($3708)>>2)];
      var $21702=(($21701)|0) < 0;
      if ($21702) { __label__ = 3140; break; } else { __label__ = 3141; break; }
    case 3140: // $21703
      var $21704=HEAP32[(($3707)>>2)];
      ___cxa_call_unexpected($21704);
      throw "Reached an unreachable!"
    case 3141: // $21705
      var $21706=HEAP32[(($3707)>>2)];
      var $21707=HEAP32[(($3707)>>2)];
      var $21708=HEAP32[(($3708)>>2)];
      var $21709=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21707, tempValue);
      var $21710=($21709.f1 = $21708, $21709);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3142: // $21711
      throw "Reached an unreachable!"
    case 3143: // $_ZnwjPKci_exit392
      var $21712=HEAP32[(($result_i391)>>2)];
      var $21713=$3704;
      var $21714=$3705;
      var $21715=$3706;
      var $21716=$result_i391;
      var $21717=$3707;
      var $21718=$3708;
      var $21719=$21712;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6261, 1, 0, 1, 0, 83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3144; break; } else { __label__ = 12661; break; }
    case 3144: // $21720
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6262, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3145; break; } else { __label__ = 12661; break; }
    case 3145: // $21721
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6263, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3146; break; } else { __label__ = 12661; break; }
    case 3146: // $21722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3147; break; } else { __label__ = 12661; break; }
    case 3147: // $21723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3148; break; } else { __label__ = 12661; break; }
    case 3148: // $21724
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3149; break; } else { __label__ = 12661; break; }
    case 3149: // $21725
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3150; break; } else { __label__ = 12661; break; }
    case 3150: // $21726
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6260, $6261, $6262, $6263, $6264, $6265, $6266, $6267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3151; break; } else { __label__ = 12661; break; }
    case 3151: // $21727
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21719, 49, 4, 3, ((STRING_TABLE.__str583)|0), ((STRING_TABLE.__str584)|0), $6260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3152; break; } else { __label__ = 12661; break; }
    case 3152: // $21728
      var $21729=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21719);
      var $21730=__ZN11simple_listI16input_type_entryE6appendERS0_($21680, $21729);
      var $21731=$4689;
      var $21732=$3699;
      var $21733=$3700;
      var $21734=$3701;
      var $21735=$result_i393;
      var $21736=$3702;
      var $21737=$3703;
      HEAP32[(($3699)>>2)]=408;
      HEAP32[(($3700)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3701)>>2)]=254;
      var $21738=HEAP32[(($3699)>>2)];
      var $21739=HEAP32[(($3700)>>2)];
      var $21740=HEAP32[(($3701)>>2)];
      var $21741=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21738, $21739, $21740) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3153; break; } else { __label__ = 3155; break; };
    case 3153: // $21742
      HEAP32[(($result_i393)>>2)]=$21741;
      var $21743=HEAP32[(($result_i393)>>2)];
      var $21744=(($21743)|0)==0;
      if ($21744) { __label__ = 3154; break; } else { __label__ = 3159; break; }
    case 3154: // $21745
      var $21746=___cxa_allocate_exception(4);
      var $21747=$21746;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21747);
      (function() { try { __THREW__ = false; return ___cxa_throw($21746, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3158; break; } else { __label__ = 3155; break; }
    case 3155: // $21748
      var $21749=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21750=$21749.f0;
      HEAP32[(($3702)>>2)]=$21750;
      var $21751=$21749.f1;
      HEAP32[(($3703)>>2)]=$21751;
      var $21752=HEAP32[(($3703)>>2)];
      var $21753=(($21752)|0) < 0;
      if ($21753) { __label__ = 3156; break; } else { __label__ = 3157; break; }
    case 3156: // $21754
      var $21755=HEAP32[(($3702)>>2)];
      ___cxa_call_unexpected($21755);
      throw "Reached an unreachable!"
    case 3157: // $21756
      var $21757=HEAP32[(($3702)>>2)];
      var $21758=HEAP32[(($3702)>>2)];
      var $21759=HEAP32[(($3703)>>2)];
      var $21760=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21758, tempValue);
      var $21761=($21760.f1 = $21759, $21760);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3158: // $21762
      throw "Reached an unreachable!"
    case 3159: // $_ZnwjPKci_exit394
      var $21763=HEAP32[(($result_i393)>>2)];
      var $21764=$3699;
      var $21765=$3700;
      var $21766=$3701;
      var $21767=$result_i393;
      var $21768=$3702;
      var $21769=$3703;
      var $21770=$21763;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6269, 1, 0, 1, 0, 85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3160; break; } else { __label__ = 12666; break; }
    case 3160: // $21771
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6270, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3161; break; } else { __label__ = 12666; break; }
    case 3161: // $21772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6271, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3162; break; } else { __label__ = 12666; break; }
    case 3162: // $21773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3163; break; } else { __label__ = 12666; break; }
    case 3163: // $21774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3164; break; } else { __label__ = 12666; break; }
    case 3164: // $21775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3165; break; } else { __label__ = 12666; break; }
    case 3165: // $21776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3166; break; } else { __label__ = 12666; break; }
    case 3166: // $21777
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6268, $6269, $6270, $6271, $6272, $6273, $6274, $6275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3167; break; } else { __label__ = 12666; break; }
    case 3167: // $21778
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21770, 50, 4, 3, ((STRING_TABLE.__str585)|0), ((STRING_TABLE.__str586)|0), $6268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3168; break; } else { __label__ = 12666; break; }
    case 3168: // $21779
      var $21780=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21770);
      var $21781=__ZN11simple_listI16input_type_entryE6appendERS0_($21731, $21780);
      var $21782=$4689;
      var $21783=$3694;
      var $21784=$3695;
      var $21785=$3696;
      var $21786=$result_i395;
      var $21787=$3697;
      var $21788=$3698;
      HEAP32[(($3694)>>2)]=408;
      HEAP32[(($3695)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3696)>>2)]=255;
      var $21789=HEAP32[(($3694)>>2)];
      var $21790=HEAP32[(($3695)>>2)];
      var $21791=HEAP32[(($3696)>>2)];
      var $21792=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21789, $21790, $21791) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3169; break; } else { __label__ = 3171; break; };
    case 3169: // $21793
      HEAP32[(($result_i395)>>2)]=$21792;
      var $21794=HEAP32[(($result_i395)>>2)];
      var $21795=(($21794)|0)==0;
      if ($21795) { __label__ = 3170; break; } else { __label__ = 3175; break; }
    case 3170: // $21796
      var $21797=___cxa_allocate_exception(4);
      var $21798=$21797;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21798);
      (function() { try { __THREW__ = false; return ___cxa_throw($21797, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3174; break; } else { __label__ = 3171; break; }
    case 3171: // $21799
      var $21800=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21801=$21800.f0;
      HEAP32[(($3697)>>2)]=$21801;
      var $21802=$21800.f1;
      HEAP32[(($3698)>>2)]=$21802;
      var $21803=HEAP32[(($3698)>>2)];
      var $21804=(($21803)|0) < 0;
      if ($21804) { __label__ = 3172; break; } else { __label__ = 3173; break; }
    case 3172: // $21805
      var $21806=HEAP32[(($3697)>>2)];
      ___cxa_call_unexpected($21806);
      throw "Reached an unreachable!"
    case 3173: // $21807
      var $21808=HEAP32[(($3697)>>2)];
      var $21809=HEAP32[(($3697)>>2)];
      var $21810=HEAP32[(($3698)>>2)];
      var $21811=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21809, tempValue);
      var $21812=($21811.f1 = $21810, $21811);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3174: // $21813
      throw "Reached an unreachable!"
    case 3175: // $_ZnwjPKci_exit396
      var $21814=HEAP32[(($result_i395)>>2)];
      var $21815=$3694;
      var $21816=$3695;
      var $21817=$3696;
      var $21818=$result_i395;
      var $21819=$3697;
      var $21820=$3698;
      var $21821=$21814;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6277, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3176; break; } else { __label__ = 12671; break; }
    case 3176: // $21822
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6278, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3177; break; } else { __label__ = 12671; break; }
    case 3177: // $21823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6279, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3178; break; } else { __label__ = 12671; break; }
    case 3178: // $21824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6280, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3179; break; } else { __label__ = 12671; break; }
    case 3179: // $21825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6281, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3180; break; } else { __label__ = 12671; break; }
    case 3180: // $21826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3181; break; } else { __label__ = 12671; break; }
    case 3181: // $21827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3182; break; } else { __label__ = 12671; break; }
    case 3182: // $21828
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6276, $6277, $6278, $6279, $6280, $6281, $6282, $6283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3183; break; } else { __label__ = 12671; break; }
    case 3183: // $21829
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21821, 51, 4, 3, ((STRING_TABLE.__str587)|0), ((STRING_TABLE.__str588)|0), $6276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3184; break; } else { __label__ = 12671; break; }
    case 3184: // $21830
      var $21831=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21821);
      var $21832=__ZN11simple_listI16input_type_entryE6appendERS0_($21782, $21831);
      var $21833=$4689;
      var $21834=$3689;
      var $21835=$3690;
      var $21836=$3691;
      var $21837=$result_i397;
      var $21838=$3692;
      var $21839=$3693;
      HEAP32[(($3689)>>2)]=408;
      HEAP32[(($3690)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3691)>>2)]=256;
      var $21840=HEAP32[(($3689)>>2)];
      var $21841=HEAP32[(($3690)>>2)];
      var $21842=HEAP32[(($3691)>>2)];
      var $21843=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21840, $21841, $21842) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3185; break; } else { __label__ = 3187; break; };
    case 3185: // $21844
      HEAP32[(($result_i397)>>2)]=$21843;
      var $21845=HEAP32[(($result_i397)>>2)];
      var $21846=(($21845)|0)==0;
      if ($21846) { __label__ = 3186; break; } else { __label__ = 3191; break; }
    case 3186: // $21847
      var $21848=___cxa_allocate_exception(4);
      var $21849=$21848;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21849);
      (function() { try { __THREW__ = false; return ___cxa_throw($21848, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3190; break; } else { __label__ = 3187; break; }
    case 3187: // $21850
      var $21851=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21852=$21851.f0;
      HEAP32[(($3692)>>2)]=$21852;
      var $21853=$21851.f1;
      HEAP32[(($3693)>>2)]=$21853;
      var $21854=HEAP32[(($3693)>>2)];
      var $21855=(($21854)|0) < 0;
      if ($21855) { __label__ = 3188; break; } else { __label__ = 3189; break; }
    case 3188: // $21856
      var $21857=HEAP32[(($3692)>>2)];
      ___cxa_call_unexpected($21857);
      throw "Reached an unreachable!"
    case 3189: // $21858
      var $21859=HEAP32[(($3692)>>2)];
      var $21860=HEAP32[(($3692)>>2)];
      var $21861=HEAP32[(($3693)>>2)];
      var $21862=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21860, tempValue);
      var $21863=($21862.f1 = $21861, $21862);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3190: // $21864
      throw "Reached an unreachable!"
    case 3191: // $_ZnwjPKci_exit398
      var $21865=HEAP32[(($result_i397)>>2)];
      var $21866=$3689;
      var $21867=$3690;
      var $21868=$3691;
      var $21869=$result_i397;
      var $21870=$3692;
      var $21871=$3693;
      var $21872=$21865;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6285, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3192; break; } else { __label__ = 12676; break; }
    case 3192: // $21873
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6286, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3193; break; } else { __label__ = 12676; break; }
    case 3193: // $21874
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6287, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3194; break; } else { __label__ = 12676; break; }
    case 3194: // $21875
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3195; break; } else { __label__ = 12676; break; }
    case 3195: // $21876
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3196; break; } else { __label__ = 12676; break; }
    case 3196: // $21877
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3197; break; } else { __label__ = 12676; break; }
    case 3197: // $21878
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3198; break; } else { __label__ = 12676; break; }
    case 3198: // $21879
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6284, $6285, $6286, $6287, $6288, $6289, $6290, $6291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3199; break; } else { __label__ = 12676; break; }
    case 3199: // $21880
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21872, 52, 4, 3, ((STRING_TABLE.__str589)|0), ((STRING_TABLE.__str590)|0), $6284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3200; break; } else { __label__ = 12676; break; }
    case 3200: // $21881
      var $21882=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21872);
      var $21883=__ZN11simple_listI16input_type_entryE6appendERS0_($21833, $21882);
      var $21884=$4689;
      var $21885=$3684;
      var $21886=$3685;
      var $21887=$3686;
      var $21888=$result_i399;
      var $21889=$3687;
      var $21890=$3688;
      HEAP32[(($3684)>>2)]=408;
      HEAP32[(($3685)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3686)>>2)]=257;
      var $21891=HEAP32[(($3684)>>2)];
      var $21892=HEAP32[(($3685)>>2)];
      var $21893=HEAP32[(($3686)>>2)];
      var $21894=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21891, $21892, $21893) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3201; break; } else { __label__ = 3203; break; };
    case 3201: // $21895
      HEAP32[(($result_i399)>>2)]=$21894;
      var $21896=HEAP32[(($result_i399)>>2)];
      var $21897=(($21896)|0)==0;
      if ($21897) { __label__ = 3202; break; } else { __label__ = 3207; break; }
    case 3202: // $21898
      var $21899=___cxa_allocate_exception(4);
      var $21900=$21899;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21900);
      (function() { try { __THREW__ = false; return ___cxa_throw($21899, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3206; break; } else { __label__ = 3203; break; }
    case 3203: // $21901
      var $21902=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21903=$21902.f0;
      HEAP32[(($3687)>>2)]=$21903;
      var $21904=$21902.f1;
      HEAP32[(($3688)>>2)]=$21904;
      var $21905=HEAP32[(($3688)>>2)];
      var $21906=(($21905)|0) < 0;
      if ($21906) { __label__ = 3204; break; } else { __label__ = 3205; break; }
    case 3204: // $21907
      var $21908=HEAP32[(($3687)>>2)];
      ___cxa_call_unexpected($21908);
      throw "Reached an unreachable!"
    case 3205: // $21909
      var $21910=HEAP32[(($3687)>>2)];
      var $21911=HEAP32[(($3687)>>2)];
      var $21912=HEAP32[(($3688)>>2)];
      var $21913=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21911, tempValue);
      var $21914=($21913.f1 = $21912, $21913);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3206: // $21915
      throw "Reached an unreachable!"
    case 3207: // $_ZnwjPKci_exit400
      var $21916=HEAP32[(($result_i399)>>2)];
      var $21917=$3684;
      var $21918=$3685;
      var $21919=$3686;
      var $21920=$result_i399;
      var $21921=$3687;
      var $21922=$3688;
      var $21923=$21916;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6293, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3208; break; } else { __label__ = 12681; break; }
    case 3208: // $21924
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6294, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3209; break; } else { __label__ = 12681; break; }
    case 3209: // $21925
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6295, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3210; break; } else { __label__ = 12681; break; }
    case 3210: // $21926
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3211; break; } else { __label__ = 12681; break; }
    case 3211: // $21927
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3212; break; } else { __label__ = 12681; break; }
    case 3212: // $21928
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3213; break; } else { __label__ = 12681; break; }
    case 3213: // $21929
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3214; break; } else { __label__ = 12681; break; }
    case 3214: // $21930
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6292, $6293, $6294, $6295, $6296, $6297, $6298, $6299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3215; break; } else { __label__ = 12681; break; }
    case 3215: // $21931
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21923, 53, 4, 3, ((STRING_TABLE.__str591)|0), ((STRING_TABLE.__str592)|0), $6292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3216; break; } else { __label__ = 12681; break; }
    case 3216: // $21932
      var $21933=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21923);
      var $21934=__ZN11simple_listI16input_type_entryE6appendERS0_($21884, $21933);
      var $21935=$4689;
      var $21936=$3679;
      var $21937=$3680;
      var $21938=$3681;
      var $21939=$result_i401;
      var $21940=$3682;
      var $21941=$3683;
      HEAP32[(($3679)>>2)]=408;
      HEAP32[(($3680)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3681)>>2)]=258;
      var $21942=HEAP32[(($3679)>>2)];
      var $21943=HEAP32[(($3680)>>2)];
      var $21944=HEAP32[(($3681)>>2)];
      var $21945=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21942, $21943, $21944) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3217; break; } else { __label__ = 3219; break; };
    case 3217: // $21946
      HEAP32[(($result_i401)>>2)]=$21945;
      var $21947=HEAP32[(($result_i401)>>2)];
      var $21948=(($21947)|0)==0;
      if ($21948) { __label__ = 3218; break; } else { __label__ = 3223; break; }
    case 3218: // $21949
      var $21950=___cxa_allocate_exception(4);
      var $21951=$21950;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($21951);
      (function() { try { __THREW__ = false; return ___cxa_throw($21950, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3222; break; } else { __label__ = 3219; break; }
    case 3219: // $21952
      var $21953=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21954=$21953.f0;
      HEAP32[(($3682)>>2)]=$21954;
      var $21955=$21953.f1;
      HEAP32[(($3683)>>2)]=$21955;
      var $21956=HEAP32[(($3683)>>2)];
      var $21957=(($21956)|0) < 0;
      if ($21957) { __label__ = 3220; break; } else { __label__ = 3221; break; }
    case 3220: // $21958
      var $21959=HEAP32[(($3682)>>2)];
      ___cxa_call_unexpected($21959);
      throw "Reached an unreachable!"
    case 3221: // $21960
      var $21961=HEAP32[(($3682)>>2)];
      var $21962=HEAP32[(($3682)>>2)];
      var $21963=HEAP32[(($3683)>>2)];
      var $21964=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21962, tempValue);
      var $21965=($21964.f1 = $21963, $21964);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3222: // $21966
      throw "Reached an unreachable!"
    case 3223: // $_ZnwjPKci_exit402
      var $21967=HEAP32[(($result_i401)>>2)];
      var $21968=$3679;
      var $21969=$3680;
      var $21970=$3681;
      var $21971=$result_i401;
      var $21972=$3682;
      var $21973=$3683;
      var $21974=$21967;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6301, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3224; break; } else { __label__ = 12686; break; }
    case 3224: // $21975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6302, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3225; break; } else { __label__ = 12686; break; }
    case 3225: // $21976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6303, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3226; break; } else { __label__ = 12686; break; }
    case 3226: // $21977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3227; break; } else { __label__ = 12686; break; }
    case 3227: // $21978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3228; break; } else { __label__ = 12686; break; }
    case 3228: // $21979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3229; break; } else { __label__ = 12686; break; }
    case 3229: // $21980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3230; break; } else { __label__ = 12686; break; }
    case 3230: // $21981
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6300, $6301, $6302, $6303, $6304, $6305, $6306, $6307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3231; break; } else { __label__ = 12686; break; }
    case 3231: // $21982
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($21974, 54, 4, 3, ((STRING_TABLE.__str593)|0), ((STRING_TABLE.__str594)|0), $6300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3232; break; } else { __label__ = 12686; break; }
    case 3232: // $21983
      var $21984=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $21974);
      var $21985=__ZN11simple_listI16input_type_entryE6appendERS0_($21935, $21984);
      var $21986=$4689;
      var $21987=$3674;
      var $21988=$3675;
      var $21989=$3676;
      var $21990=$result_i403;
      var $21991=$3677;
      var $21992=$3678;
      HEAP32[(($3674)>>2)]=408;
      HEAP32[(($3675)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3676)>>2)]=259;
      var $21993=HEAP32[(($3674)>>2)];
      var $21994=HEAP32[(($3675)>>2)];
      var $21995=HEAP32[(($3676)>>2)];
      var $21996=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21993, $21994, $21995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3233; break; } else { __label__ = 3235; break; };
    case 3233: // $21997
      HEAP32[(($result_i403)>>2)]=$21996;
      var $21998=HEAP32[(($result_i403)>>2)];
      var $21999=(($21998)|0)==0;
      if ($21999) { __label__ = 3234; break; } else { __label__ = 3239; break; }
    case 3234: // $22000
      var $22001=___cxa_allocate_exception(4);
      var $22002=$22001;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22002);
      (function() { try { __THREW__ = false; return ___cxa_throw($22001, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3238; break; } else { __label__ = 3235; break; }
    case 3235: // $22003
      var $22004=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22005=$22004.f0;
      HEAP32[(($3677)>>2)]=$22005;
      var $22006=$22004.f1;
      HEAP32[(($3678)>>2)]=$22006;
      var $22007=HEAP32[(($3678)>>2)];
      var $22008=(($22007)|0) < 0;
      if ($22008) { __label__ = 3236; break; } else { __label__ = 3237; break; }
    case 3236: // $22009
      var $22010=HEAP32[(($3677)>>2)];
      ___cxa_call_unexpected($22010);
      throw "Reached an unreachable!"
    case 3237: // $22011
      var $22012=HEAP32[(($3677)>>2)];
      var $22013=HEAP32[(($3677)>>2)];
      var $22014=HEAP32[(($3678)>>2)];
      var $22015=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22013, tempValue);
      var $22016=($22015.f1 = $22014, $22015);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3238: // $22017
      throw "Reached an unreachable!"
    case 3239: // $_ZnwjPKci_exit404
      var $22018=HEAP32[(($result_i403)>>2)];
      var $22019=$3674;
      var $22020=$3675;
      var $22021=$3676;
      var $22022=$result_i403;
      var $22023=$3677;
      var $22024=$3678;
      var $22025=$22018;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6309, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3240; break; } else { __label__ = 12691; break; }
    case 3240: // $22026
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6310, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3241; break; } else { __label__ = 12691; break; }
    case 3241: // $22027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6311, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3242; break; } else { __label__ = 12691; break; }
    case 3242: // $22028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3243; break; } else { __label__ = 12691; break; }
    case 3243: // $22029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3244; break; } else { __label__ = 12691; break; }
    case 3244: // $22030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3245; break; } else { __label__ = 12691; break; }
    case 3245: // $22031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3246; break; } else { __label__ = 12691; break; }
    case 3246: // $22032
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6308, $6309, $6310, $6311, $6312, $6313, $6314, $6315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3247; break; } else { __label__ = 12691; break; }
    case 3247: // $22033
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22025, 55, 4, 3, ((STRING_TABLE.__str595)|0), ((STRING_TABLE.__str596)|0), $6308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3248; break; } else { __label__ = 12691; break; }
    case 3248: // $22034
      var $22035=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22025);
      var $22036=__ZN11simple_listI16input_type_entryE6appendERS0_($21986, $22035);
      var $22037=$4689;
      var $22038=$3669;
      var $22039=$3670;
      var $22040=$3671;
      var $22041=$result_i405;
      var $22042=$3672;
      var $22043=$3673;
      HEAP32[(($3669)>>2)]=408;
      HEAP32[(($3670)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3671)>>2)]=260;
      var $22044=HEAP32[(($3669)>>2)];
      var $22045=HEAP32[(($3670)>>2)];
      var $22046=HEAP32[(($3671)>>2)];
      var $22047=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22044, $22045, $22046) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3249; break; } else { __label__ = 3251; break; };
    case 3249: // $22048
      HEAP32[(($result_i405)>>2)]=$22047;
      var $22049=HEAP32[(($result_i405)>>2)];
      var $22050=(($22049)|0)==0;
      if ($22050) { __label__ = 3250; break; } else { __label__ = 3255; break; }
    case 3250: // $22051
      var $22052=___cxa_allocate_exception(4);
      var $22053=$22052;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22053);
      (function() { try { __THREW__ = false; return ___cxa_throw($22052, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3254; break; } else { __label__ = 3251; break; }
    case 3251: // $22054
      var $22055=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22056=$22055.f0;
      HEAP32[(($3672)>>2)]=$22056;
      var $22057=$22055.f1;
      HEAP32[(($3673)>>2)]=$22057;
      var $22058=HEAP32[(($3673)>>2)];
      var $22059=(($22058)|0) < 0;
      if ($22059) { __label__ = 3252; break; } else { __label__ = 3253; break; }
    case 3252: // $22060
      var $22061=HEAP32[(($3672)>>2)];
      ___cxa_call_unexpected($22061);
      throw "Reached an unreachable!"
    case 3253: // $22062
      var $22063=HEAP32[(($3672)>>2)];
      var $22064=HEAP32[(($3672)>>2)];
      var $22065=HEAP32[(($3673)>>2)];
      var $22066=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22064, tempValue);
      var $22067=($22066.f1 = $22065, $22066);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3254: // $22068
      throw "Reached an unreachable!"
    case 3255: // $_ZnwjPKci_exit406
      var $22069=HEAP32[(($result_i405)>>2)];
      var $22070=$3669;
      var $22071=$3670;
      var $22072=$3671;
      var $22073=$result_i405;
      var $22074=$3672;
      var $22075=$3673;
      var $22076=$22069;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6317, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3256; break; } else { __label__ = 12696; break; }
    case 3256: // $22077
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6318, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3257; break; } else { __label__ = 12696; break; }
    case 3257: // $22078
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6319, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3258; break; } else { __label__ = 12696; break; }
    case 3258: // $22079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3259; break; } else { __label__ = 12696; break; }
    case 3259: // $22080
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3260; break; } else { __label__ = 12696; break; }
    case 3260: // $22081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3261; break; } else { __label__ = 12696; break; }
    case 3261: // $22082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3262; break; } else { __label__ = 12696; break; }
    case 3262: // $22083
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6316, $6317, $6318, $6319, $6320, $6321, $6322, $6323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3263; break; } else { __label__ = 12696; break; }
    case 3263: // $22084
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22076, 56, 4, 3, ((STRING_TABLE.__str597)|0), ((STRING_TABLE.__str598)|0), $6316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3264; break; } else { __label__ = 12696; break; }
    case 3264: // $22085
      var $22086=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22076);
      var $22087=__ZN11simple_listI16input_type_entryE6appendERS0_($22037, $22086);
      var $22088=$4689;
      var $22089=$3664;
      var $22090=$3665;
      var $22091=$3666;
      var $22092=$result_i407;
      var $22093=$3667;
      var $22094=$3668;
      HEAP32[(($3664)>>2)]=408;
      HEAP32[(($3665)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3666)>>2)]=261;
      var $22095=HEAP32[(($3664)>>2)];
      var $22096=HEAP32[(($3665)>>2)];
      var $22097=HEAP32[(($3666)>>2)];
      var $22098=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22095, $22096, $22097) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3265; break; } else { __label__ = 3267; break; };
    case 3265: // $22099
      HEAP32[(($result_i407)>>2)]=$22098;
      var $22100=HEAP32[(($result_i407)>>2)];
      var $22101=(($22100)|0)==0;
      if ($22101) { __label__ = 3266; break; } else { __label__ = 3271; break; }
    case 3266: // $22102
      var $22103=___cxa_allocate_exception(4);
      var $22104=$22103;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22104);
      (function() { try { __THREW__ = false; return ___cxa_throw($22103, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3270; break; } else { __label__ = 3267; break; }
    case 3267: // $22105
      var $22106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22107=$22106.f0;
      HEAP32[(($3667)>>2)]=$22107;
      var $22108=$22106.f1;
      HEAP32[(($3668)>>2)]=$22108;
      var $22109=HEAP32[(($3668)>>2)];
      var $22110=(($22109)|0) < 0;
      if ($22110) { __label__ = 3268; break; } else { __label__ = 3269; break; }
    case 3268: // $22111
      var $22112=HEAP32[(($3667)>>2)];
      ___cxa_call_unexpected($22112);
      throw "Reached an unreachable!"
    case 3269: // $22113
      var $22114=HEAP32[(($3667)>>2)];
      var $22115=HEAP32[(($3667)>>2)];
      var $22116=HEAP32[(($3668)>>2)];
      var $22117=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22115, tempValue);
      var $22118=($22117.f1 = $22116, $22117);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3270: // $22119
      throw "Reached an unreachable!"
    case 3271: // $_ZnwjPKci_exit408
      var $22120=HEAP32[(($result_i407)>>2)];
      var $22121=$3664;
      var $22122=$3665;
      var $22123=$3666;
      var $22124=$result_i407;
      var $22125=$3667;
      var $22126=$3668;
      var $22127=$22120;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6325, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3272; break; } else { __label__ = 12701; break; }
    case 3272: // $22128
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6326, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3273; break; } else { __label__ = 12701; break; }
    case 3273: // $22129
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6327, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3274; break; } else { __label__ = 12701; break; }
    case 3274: // $22130
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3275; break; } else { __label__ = 12701; break; }
    case 3275: // $22131
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3276; break; } else { __label__ = 12701; break; }
    case 3276: // $22132
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3277; break; } else { __label__ = 12701; break; }
    case 3277: // $22133
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3278; break; } else { __label__ = 12701; break; }
    case 3278: // $22134
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6324, $6325, $6326, $6327, $6328, $6329, $6330, $6331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3279; break; } else { __label__ = 12701; break; }
    case 3279: // $22135
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22127, 57, 4, 3, ((STRING_TABLE.__str599)|0), ((STRING_TABLE.__str600)|0), $6324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3280; break; } else { __label__ = 12701; break; }
    case 3280: // $22136
      var $22137=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22127);
      var $22138=__ZN11simple_listI16input_type_entryE6appendERS0_($22088, $22137);
      var $22139=$4689;
      var $22140=$3659;
      var $22141=$3660;
      var $22142=$3661;
      var $22143=$result_i409;
      var $22144=$3662;
      var $22145=$3663;
      HEAP32[(($3659)>>2)]=408;
      HEAP32[(($3660)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3661)>>2)]=262;
      var $22146=HEAP32[(($3659)>>2)];
      var $22147=HEAP32[(($3660)>>2)];
      var $22148=HEAP32[(($3661)>>2)];
      var $22149=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22146, $22147, $22148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3281; break; } else { __label__ = 3283; break; };
    case 3281: // $22150
      HEAP32[(($result_i409)>>2)]=$22149;
      var $22151=HEAP32[(($result_i409)>>2)];
      var $22152=(($22151)|0)==0;
      if ($22152) { __label__ = 3282; break; } else { __label__ = 3287; break; }
    case 3282: // $22153
      var $22154=___cxa_allocate_exception(4);
      var $22155=$22154;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22155);
      (function() { try { __THREW__ = false; return ___cxa_throw($22154, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3286; break; } else { __label__ = 3283; break; }
    case 3283: // $22156
      var $22157=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22158=$22157.f0;
      HEAP32[(($3662)>>2)]=$22158;
      var $22159=$22157.f1;
      HEAP32[(($3663)>>2)]=$22159;
      var $22160=HEAP32[(($3663)>>2)];
      var $22161=(($22160)|0) < 0;
      if ($22161) { __label__ = 3284; break; } else { __label__ = 3285; break; }
    case 3284: // $22162
      var $22163=HEAP32[(($3662)>>2)];
      ___cxa_call_unexpected($22163);
      throw "Reached an unreachable!"
    case 3285: // $22164
      var $22165=HEAP32[(($3662)>>2)];
      var $22166=HEAP32[(($3662)>>2)];
      var $22167=HEAP32[(($3663)>>2)];
      var $22168=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22166, tempValue);
      var $22169=($22168.f1 = $22167, $22168);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3286: // $22170
      throw "Reached an unreachable!"
    case 3287: // $_ZnwjPKci_exit410
      var $22171=HEAP32[(($result_i409)>>2)];
      var $22172=$3659;
      var $22173=$3660;
      var $22174=$3661;
      var $22175=$result_i409;
      var $22176=$3662;
      var $22177=$3663;
      var $22178=$22171;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6333, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3288; break; } else { __label__ = 12706; break; }
    case 3288: // $22179
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6334, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3289; break; } else { __label__ = 12706; break; }
    case 3289: // $22180
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6335, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3290; break; } else { __label__ = 12706; break; }
    case 3290: // $22181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3291; break; } else { __label__ = 12706; break; }
    case 3291: // $22182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3292; break; } else { __label__ = 12706; break; }
    case 3292: // $22183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3293; break; } else { __label__ = 12706; break; }
    case 3293: // $22184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3294; break; } else { __label__ = 12706; break; }
    case 3294: // $22185
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6332, $6333, $6334, $6335, $6336, $6337, $6338, $6339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3295; break; } else { __label__ = 12706; break; }
    case 3295: // $22186
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22178, 58, 4, 3, ((STRING_TABLE.__str601)|0), ((STRING_TABLE.__str602)|0), $6332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3296; break; } else { __label__ = 12706; break; }
    case 3296: // $22187
      var $22188=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22178);
      var $22189=__ZN11simple_listI16input_type_entryE6appendERS0_($22139, $22188);
      var $22190=$4689;
      var $22191=$3654;
      var $22192=$3655;
      var $22193=$3656;
      var $22194=$result_i411;
      var $22195=$3657;
      var $22196=$3658;
      HEAP32[(($3654)>>2)]=408;
      HEAP32[(($3655)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3656)>>2)]=263;
      var $22197=HEAP32[(($3654)>>2)];
      var $22198=HEAP32[(($3655)>>2)];
      var $22199=HEAP32[(($3656)>>2)];
      var $22200=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22197, $22198, $22199) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3297; break; } else { __label__ = 3299; break; };
    case 3297: // $22201
      HEAP32[(($result_i411)>>2)]=$22200;
      var $22202=HEAP32[(($result_i411)>>2)];
      var $22203=(($22202)|0)==0;
      if ($22203) { __label__ = 3298; break; } else { __label__ = 3303; break; }
    case 3298: // $22204
      var $22205=___cxa_allocate_exception(4);
      var $22206=$22205;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22206);
      (function() { try { __THREW__ = false; return ___cxa_throw($22205, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3302; break; } else { __label__ = 3299; break; }
    case 3299: // $22207
      var $22208=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22209=$22208.f0;
      HEAP32[(($3657)>>2)]=$22209;
      var $22210=$22208.f1;
      HEAP32[(($3658)>>2)]=$22210;
      var $22211=HEAP32[(($3658)>>2)];
      var $22212=(($22211)|0) < 0;
      if ($22212) { __label__ = 3300; break; } else { __label__ = 3301; break; }
    case 3300: // $22213
      var $22214=HEAP32[(($3657)>>2)];
      ___cxa_call_unexpected($22214);
      throw "Reached an unreachable!"
    case 3301: // $22215
      var $22216=HEAP32[(($3657)>>2)];
      var $22217=HEAP32[(($3657)>>2)];
      var $22218=HEAP32[(($3658)>>2)];
      var $22219=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22217, tempValue);
      var $22220=($22219.f1 = $22218, $22219);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3302: // $22221
      throw "Reached an unreachable!"
    case 3303: // $_ZnwjPKci_exit412
      var $22222=HEAP32[(($result_i411)>>2)];
      var $22223=$3654;
      var $22224=$3655;
      var $22225=$3656;
      var $22226=$result_i411;
      var $22227=$3657;
      var $22228=$3658;
      var $22229=$22222;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6341, 1, 0, 1, 0, 79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3304; break; } else { __label__ = 12711; break; }
    case 3304: // $22230
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6342, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3305; break; } else { __label__ = 12711; break; }
    case 3305: // $22231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6343, 4, 3, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3306; break; } else { __label__ = 12711; break; }
    case 3306: // $22232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3307; break; } else { __label__ = 12711; break; }
    case 3307: // $22233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3308; break; } else { __label__ = 12711; break; }
    case 3308: // $22234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3309; break; } else { __label__ = 12711; break; }
    case 3309: // $22235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3310; break; } else { __label__ = 12711; break; }
    case 3310: // $22236
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6340, $6341, $6342, $6343, $6344, $6345, $6346, $6347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3311; break; } else { __label__ = 12711; break; }
    case 3311: // $22237
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22229, 59, 4, 3, ((STRING_TABLE.__str603)|0), ((STRING_TABLE.__str604)|0), $6340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3312; break; } else { __label__ = 12711; break; }
    case 3312: // $22238
      var $22239=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22229);
      var $22240=__ZN11simple_listI16input_type_entryE6appendERS0_($22190, $22239);
      var $22241=$4689;
      var $22242=$3649;
      var $22243=$3650;
      var $22244=$3651;
      var $22245=$result_i413;
      var $22246=$3652;
      var $22247=$3653;
      HEAP32[(($3649)>>2)]=408;
      HEAP32[(($3650)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3651)>>2)]=264;
      var $22248=HEAP32[(($3649)>>2)];
      var $22249=HEAP32[(($3650)>>2)];
      var $22250=HEAP32[(($3651)>>2)];
      var $22251=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22248, $22249, $22250) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3313; break; } else { __label__ = 3315; break; };
    case 3313: // $22252
      HEAP32[(($result_i413)>>2)]=$22251;
      var $22253=HEAP32[(($result_i413)>>2)];
      var $22254=(($22253)|0)==0;
      if ($22254) { __label__ = 3314; break; } else { __label__ = 3319; break; }
    case 3314: // $22255
      var $22256=___cxa_allocate_exception(4);
      var $22257=$22256;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22257);
      (function() { try { __THREW__ = false; return ___cxa_throw($22256, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3318; break; } else { __label__ = 3315; break; }
    case 3315: // $22258
      var $22259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22260=$22259.f0;
      HEAP32[(($3652)>>2)]=$22260;
      var $22261=$22259.f1;
      HEAP32[(($3653)>>2)]=$22261;
      var $22262=HEAP32[(($3653)>>2)];
      var $22263=(($22262)|0) < 0;
      if ($22263) { __label__ = 3316; break; } else { __label__ = 3317; break; }
    case 3316: // $22264
      var $22265=HEAP32[(($3652)>>2)];
      ___cxa_call_unexpected($22265);
      throw "Reached an unreachable!"
    case 3317: // $22266
      var $22267=HEAP32[(($3652)>>2)];
      var $22268=HEAP32[(($3652)>>2)];
      var $22269=HEAP32[(($3653)>>2)];
      var $22270=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22268, tempValue);
      var $22271=($22270.f1 = $22269, $22270);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3318: // $22272
      throw "Reached an unreachable!"
    case 3319: // $_ZnwjPKci_exit414
      var $22273=HEAP32[(($result_i413)>>2)];
      var $22274=$3649;
      var $22275=$3650;
      var $22276=$3651;
      var $22277=$result_i413;
      var $22278=$3652;
      var $22279=$3653;
      var $22280=$22273;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6349, 1, 0, 1, 0, 93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3320; break; } else { __label__ = 12716; break; }
    case 3320: // $22281
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6350, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3321; break; } else { __label__ = 12716; break; }
    case 3321: // $22282
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6351, 4, 3, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3322; break; } else { __label__ = 12716; break; }
    case 3322: // $22283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3323; break; } else { __label__ = 12716; break; }
    case 3323: // $22284
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3324; break; } else { __label__ = 12716; break; }
    case 3324: // $22285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3325; break; } else { __label__ = 12716; break; }
    case 3325: // $22286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3326; break; } else { __label__ = 12716; break; }
    case 3326: // $22287
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6348, $6349, $6350, $6351, $6352, $6353, $6354, $6355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3327; break; } else { __label__ = 12716; break; }
    case 3327: // $22288
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22280, 60, 4, 3, ((STRING_TABLE.__str605)|0), ((STRING_TABLE.__str606)|0), $6348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3328; break; } else { __label__ = 12716; break; }
    case 3328: // $22289
      var $22290=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22280);
      var $22291=__ZN11simple_listI16input_type_entryE6appendERS0_($22241, $22290);
      var $22292=$4689;
      var $22293=$3644;
      var $22294=$3645;
      var $22295=$3646;
      var $22296=$result_i415;
      var $22297=$3647;
      var $22298=$3648;
      HEAP32[(($3644)>>2)]=408;
      HEAP32[(($3645)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3646)>>2)]=265;
      var $22299=HEAP32[(($3644)>>2)];
      var $22300=HEAP32[(($3645)>>2)];
      var $22301=HEAP32[(($3646)>>2)];
      var $22302=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22299, $22300, $22301) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3329; break; } else { __label__ = 3331; break; };
    case 3329: // $22303
      HEAP32[(($result_i415)>>2)]=$22302;
      var $22304=HEAP32[(($result_i415)>>2)];
      var $22305=(($22304)|0)==0;
      if ($22305) { __label__ = 3330; break; } else { __label__ = 3335; break; }
    case 3330: // $22306
      var $22307=___cxa_allocate_exception(4);
      var $22308=$22307;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22308);
      (function() { try { __THREW__ = false; return ___cxa_throw($22307, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3334; break; } else { __label__ = 3331; break; }
    case 3331: // $22309
      var $22310=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22311=$22310.f0;
      HEAP32[(($3647)>>2)]=$22311;
      var $22312=$22310.f1;
      HEAP32[(($3648)>>2)]=$22312;
      var $22313=HEAP32[(($3648)>>2)];
      var $22314=(($22313)|0) < 0;
      if ($22314) { __label__ = 3332; break; } else { __label__ = 3333; break; }
    case 3332: // $22315
      var $22316=HEAP32[(($3647)>>2)];
      ___cxa_call_unexpected($22316);
      throw "Reached an unreachable!"
    case 3333: // $22317
      var $22318=HEAP32[(($3647)>>2)];
      var $22319=HEAP32[(($3647)>>2)];
      var $22320=HEAP32[(($3648)>>2)];
      var $22321=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22319, tempValue);
      var $22322=($22321.f1 = $22320, $22321);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3334: // $22323
      throw "Reached an unreachable!"
    case 3335: // $_ZnwjPKci_exit416
      var $22324=HEAP32[(($result_i415)>>2)];
      var $22325=$3644;
      var $22326=$3645;
      var $22327=$3646;
      var $22328=$result_i415;
      var $22329=$3647;
      var $22330=$3648;
      var $22331=$22324;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6357, 1, 0, 1, 0, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3336; break; } else { __label__ = 12721; break; }
    case 3336: // $22332
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6358, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3337; break; } else { __label__ = 12721; break; }
    case 3337: // $22333
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6359, 4, 3, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3338; break; } else { __label__ = 12721; break; }
    case 3338: // $22334
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3339; break; } else { __label__ = 12721; break; }
    case 3339: // $22335
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3340; break; } else { __label__ = 12721; break; }
    case 3340: // $22336
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3341; break; } else { __label__ = 12721; break; }
    case 3341: // $22337
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3342; break; } else { __label__ = 12721; break; }
    case 3342: // $22338
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6356, $6357, $6358, $6359, $6360, $6361, $6362, $6363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3343; break; } else { __label__ = 12721; break; }
    case 3343: // $22339
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22331, 61, 4, 3, ((STRING_TABLE.__str607)|0), ((STRING_TABLE.__str608)|0), $6356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3344; break; } else { __label__ = 12721; break; }
    case 3344: // $22340
      var $22341=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22331);
      var $22342=__ZN11simple_listI16input_type_entryE6appendERS0_($22292, $22341);
      var $22343=$4689;
      var $22344=$3639;
      var $22345=$3640;
      var $22346=$3641;
      var $22347=$result_i417;
      var $22348=$3642;
      var $22349=$3643;
      HEAP32[(($3639)>>2)]=408;
      HEAP32[(($3640)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3641)>>2)]=266;
      var $22350=HEAP32[(($3639)>>2)];
      var $22351=HEAP32[(($3640)>>2)];
      var $22352=HEAP32[(($3641)>>2)];
      var $22353=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22350, $22351, $22352) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3345; break; } else { __label__ = 3347; break; };
    case 3345: // $22354
      HEAP32[(($result_i417)>>2)]=$22353;
      var $22355=HEAP32[(($result_i417)>>2)];
      var $22356=(($22355)|0)==0;
      if ($22356) { __label__ = 3346; break; } else { __label__ = 3351; break; }
    case 3346: // $22357
      var $22358=___cxa_allocate_exception(4);
      var $22359=$22358;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22359);
      (function() { try { __THREW__ = false; return ___cxa_throw($22358, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3350; break; } else { __label__ = 3347; break; }
    case 3347: // $22360
      var $22361=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22362=$22361.f0;
      HEAP32[(($3642)>>2)]=$22362;
      var $22363=$22361.f1;
      HEAP32[(($3643)>>2)]=$22363;
      var $22364=HEAP32[(($3643)>>2)];
      var $22365=(($22364)|0) < 0;
      if ($22365) { __label__ = 3348; break; } else { __label__ = 3349; break; }
    case 3348: // $22366
      var $22367=HEAP32[(($3642)>>2)];
      ___cxa_call_unexpected($22367);
      throw "Reached an unreachable!"
    case 3349: // $22368
      var $22369=HEAP32[(($3642)>>2)];
      var $22370=HEAP32[(($3642)>>2)];
      var $22371=HEAP32[(($3643)>>2)];
      var $22372=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22370, tempValue);
      var $22373=($22372.f1 = $22371, $22372);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3350: // $22374
      throw "Reached an unreachable!"
    case 3351: // $_ZnwjPKci_exit418
      var $22375=HEAP32[(($result_i417)>>2)];
      var $22376=$3639;
      var $22377=$3640;
      var $22378=$3641;
      var $22379=$result_i417;
      var $22380=$3642;
      var $22381=$3643;
      var $22382=$22375;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6365, 4, 3, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3352; break; } else { __label__ = 12726; break; }
    case 3352: // $22383
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6366, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3353; break; } else { __label__ = 12726; break; }
    case 3353: // $22384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6367, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3354; break; } else { __label__ = 12726; break; }
    case 3354: // $22385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3355; break; } else { __label__ = 12726; break; }
    case 3355: // $22386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3356; break; } else { __label__ = 12726; break; }
    case 3356: // $22387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3357; break; } else { __label__ = 12726; break; }
    case 3357: // $22388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3358; break; } else { __label__ = 12726; break; }
    case 3358: // $22389
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6364, $6365, $6366, $6367, $6368, $6369, $6370, $6371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3359; break; } else { __label__ = 12726; break; }
    case 3359: // $22390
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22382, 62, 4, 3, ((STRING_TABLE.__str609)|0), ((STRING_TABLE.__str610)|0), $6364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3360; break; } else { __label__ = 12726; break; }
    case 3360: // $22391
      var $22392=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22382);
      var $22393=__ZN11simple_listI16input_type_entryE6appendERS0_($22343, $22392);
      var $22394=$4689;
      var $22395=$3634;
      var $22396=$3635;
      var $22397=$3636;
      var $22398=$result_i419;
      var $22399=$3637;
      var $22400=$3638;
      HEAP32[(($3634)>>2)]=408;
      HEAP32[(($3635)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3636)>>2)]=267;
      var $22401=HEAP32[(($3634)>>2)];
      var $22402=HEAP32[(($3635)>>2)];
      var $22403=HEAP32[(($3636)>>2)];
      var $22404=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22401, $22402, $22403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3361; break; } else { __label__ = 3363; break; };
    case 3361: // $22405
      HEAP32[(($result_i419)>>2)]=$22404;
      var $22406=HEAP32[(($result_i419)>>2)];
      var $22407=(($22406)|0)==0;
      if ($22407) { __label__ = 3362; break; } else { __label__ = 3367; break; }
    case 3362: // $22408
      var $22409=___cxa_allocate_exception(4);
      var $22410=$22409;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22410);
      (function() { try { __THREW__ = false; return ___cxa_throw($22409, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3366; break; } else { __label__ = 3363; break; }
    case 3363: // $22411
      var $22412=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22413=$22412.f0;
      HEAP32[(($3637)>>2)]=$22413;
      var $22414=$22412.f1;
      HEAP32[(($3638)>>2)]=$22414;
      var $22415=HEAP32[(($3638)>>2)];
      var $22416=(($22415)|0) < 0;
      if ($22416) { __label__ = 3364; break; } else { __label__ = 3365; break; }
    case 3364: // $22417
      var $22418=HEAP32[(($3637)>>2)];
      ___cxa_call_unexpected($22418);
      throw "Reached an unreachable!"
    case 3365: // $22419
      var $22420=HEAP32[(($3637)>>2)];
      var $22421=HEAP32[(($3637)>>2)];
      var $22422=HEAP32[(($3638)>>2)];
      var $22423=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22421, tempValue);
      var $22424=($22423.f1 = $22422, $22423);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3366: // $22425
      throw "Reached an unreachable!"
    case 3367: // $_ZnwjPKci_exit420
      var $22426=HEAP32[(($result_i419)>>2)];
      var $22427=$3634;
      var $22428=$3635;
      var $22429=$3636;
      var $22430=$result_i419;
      var $22431=$3637;
      var $22432=$3638;
      var $22433=$22426;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6373, 4, 3, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3368; break; } else { __label__ = 12731; break; }
    case 3368: // $22434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6374, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3369; break; } else { __label__ = 12731; break; }
    case 3369: // $22435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6375, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3370; break; } else { __label__ = 12731; break; }
    case 3370: // $22436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3371; break; } else { __label__ = 12731; break; }
    case 3371: // $22437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3372; break; } else { __label__ = 12731; break; }
    case 3372: // $22438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3373; break; } else { __label__ = 12731; break; }
    case 3373: // $22439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3374; break; } else { __label__ = 12731; break; }
    case 3374: // $22440
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6372, $6373, $6374, $6375, $6376, $6377, $6378, $6379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3375; break; } else { __label__ = 12731; break; }
    case 3375: // $22441
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22433, 63, 4, 3, ((STRING_TABLE.__str611)|0), ((STRING_TABLE.__str612)|0), $6372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3376; break; } else { __label__ = 12731; break; }
    case 3376: // $22442
      var $22443=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22433);
      var $22444=__ZN11simple_listI16input_type_entryE6appendERS0_($22394, $22443);
      var $22445=$4689;
      var $22446=$3629;
      var $22447=$3630;
      var $22448=$3631;
      var $22449=$result_i421;
      var $22450=$3632;
      var $22451=$3633;
      HEAP32[(($3629)>>2)]=408;
      HEAP32[(($3630)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3631)>>2)]=268;
      var $22452=HEAP32[(($3629)>>2)];
      var $22453=HEAP32[(($3630)>>2)];
      var $22454=HEAP32[(($3631)>>2)];
      var $22455=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22452, $22453, $22454) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3377; break; } else { __label__ = 3379; break; };
    case 3377: // $22456
      HEAP32[(($result_i421)>>2)]=$22455;
      var $22457=HEAP32[(($result_i421)>>2)];
      var $22458=(($22457)|0)==0;
      if ($22458) { __label__ = 3378; break; } else { __label__ = 3383; break; }
    case 3378: // $22459
      var $22460=___cxa_allocate_exception(4);
      var $22461=$22460;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22461);
      (function() { try { __THREW__ = false; return ___cxa_throw($22460, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3382; break; } else { __label__ = 3379; break; }
    case 3379: // $22462
      var $22463=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22464=$22463.f0;
      HEAP32[(($3632)>>2)]=$22464;
      var $22465=$22463.f1;
      HEAP32[(($3633)>>2)]=$22465;
      var $22466=HEAP32[(($3633)>>2)];
      var $22467=(($22466)|0) < 0;
      if ($22467) { __label__ = 3380; break; } else { __label__ = 3381; break; }
    case 3380: // $22468
      var $22469=HEAP32[(($3632)>>2)];
      ___cxa_call_unexpected($22469);
      throw "Reached an unreachable!"
    case 3381: // $22470
      var $22471=HEAP32[(($3632)>>2)];
      var $22472=HEAP32[(($3632)>>2)];
      var $22473=HEAP32[(($3633)>>2)];
      var $22474=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22472, tempValue);
      var $22475=($22474.f1 = $22473, $22474);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3382: // $22476
      throw "Reached an unreachable!"
    case 3383: // $_ZnwjPKci_exit422
      var $22477=HEAP32[(($result_i421)>>2)];
      var $22478=$3629;
      var $22479=$3630;
      var $22480=$3631;
      var $22481=$result_i421;
      var $22482=$3632;
      var $22483=$3633;
      var $22484=$22477;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6381, 4, 3, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3384; break; } else { __label__ = 12736; break; }
    case 3384: // $22485
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3385; break; } else { __label__ = 12736; break; }
    case 3385: // $22486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3386; break; } else { __label__ = 12736; break; }
    case 3386: // $22487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3387; break; } else { __label__ = 12736; break; }
    case 3387: // $22488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3388; break; } else { __label__ = 12736; break; }
    case 3388: // $22489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3389; break; } else { __label__ = 12736; break; }
    case 3389: // $22490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3390; break; } else { __label__ = 12736; break; }
    case 3390: // $22491
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6380, $6381, $6382, $6383, $6384, $6385, $6386, $6387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3391; break; } else { __label__ = 12736; break; }
    case 3391: // $22492
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22484, 64, 4, 3, ((STRING_TABLE.__str613)|0), ((STRING_TABLE.__str614)|0), $6380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3392; break; } else { __label__ = 12736; break; }
    case 3392: // $22493
      var $22494=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22484);
      var $22495=__ZN11simple_listI16input_type_entryE6appendERS0_($22445, $22494);
      var $22496=$4689;
      var $22497=$3624;
      var $22498=$3625;
      var $22499=$3626;
      var $22500=$result_i423;
      var $22501=$3627;
      var $22502=$3628;
      HEAP32[(($3624)>>2)]=408;
      HEAP32[(($3625)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3626)>>2)]=269;
      var $22503=HEAP32[(($3624)>>2)];
      var $22504=HEAP32[(($3625)>>2)];
      var $22505=HEAP32[(($3626)>>2)];
      var $22506=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22503, $22504, $22505) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3393; break; } else { __label__ = 3395; break; };
    case 3393: // $22507
      HEAP32[(($result_i423)>>2)]=$22506;
      var $22508=HEAP32[(($result_i423)>>2)];
      var $22509=(($22508)|0)==0;
      if ($22509) { __label__ = 3394; break; } else { __label__ = 3399; break; }
    case 3394: // $22510
      var $22511=___cxa_allocate_exception(4);
      var $22512=$22511;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22512);
      (function() { try { __THREW__ = false; return ___cxa_throw($22511, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3398; break; } else { __label__ = 3395; break; }
    case 3395: // $22513
      var $22514=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22515=$22514.f0;
      HEAP32[(($3627)>>2)]=$22515;
      var $22516=$22514.f1;
      HEAP32[(($3628)>>2)]=$22516;
      var $22517=HEAP32[(($3628)>>2)];
      var $22518=(($22517)|0) < 0;
      if ($22518) { __label__ = 3396; break; } else { __label__ = 3397; break; }
    case 3396: // $22519
      var $22520=HEAP32[(($3627)>>2)];
      ___cxa_call_unexpected($22520);
      throw "Reached an unreachable!"
    case 3397: // $22521
      var $22522=HEAP32[(($3627)>>2)];
      var $22523=HEAP32[(($3627)>>2)];
      var $22524=HEAP32[(($3628)>>2)];
      var $22525=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22523, tempValue);
      var $22526=($22525.f1 = $22524, $22525);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3398: // $22527
      throw "Reached an unreachable!"
    case 3399: // $_ZnwjPKci_exit424
      var $22528=HEAP32[(($result_i423)>>2)];
      var $22529=$3624;
      var $22530=$3625;
      var $22531=$3626;
      var $22532=$result_i423;
      var $22533=$3627;
      var $22534=$3628;
      var $22535=$22528;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6389, 4, 3, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3400; break; } else { __label__ = 12741; break; }
    case 3400: // $22536
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6390, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3401; break; } else { __label__ = 12741; break; }
    case 3401: // $22537
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6391, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3402; break; } else { __label__ = 12741; break; }
    case 3402: // $22538
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3403; break; } else { __label__ = 12741; break; }
    case 3403: // $22539
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3404; break; } else { __label__ = 12741; break; }
    case 3404: // $22540
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3405; break; } else { __label__ = 12741; break; }
    case 3405: // $22541
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3406; break; } else { __label__ = 12741; break; }
    case 3406: // $22542
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6388, $6389, $6390, $6391, $6392, $6393, $6394, $6395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3407; break; } else { __label__ = 12741; break; }
    case 3407: // $22543
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22535, 65, 4, 3, ((STRING_TABLE.__str615)|0), ((STRING_TABLE.__str616)|0), $6388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3408; break; } else { __label__ = 12741; break; }
    case 3408: // $22544
      var $22545=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22535);
      var $22546=__ZN11simple_listI16input_type_entryE6appendERS0_($22496, $22545);
      var $22547=$4689;
      var $22548=$3619;
      var $22549=$3620;
      var $22550=$3621;
      var $22551=$result_i425;
      var $22552=$3622;
      var $22553=$3623;
      HEAP32[(($3619)>>2)]=408;
      HEAP32[(($3620)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3621)>>2)]=270;
      var $22554=HEAP32[(($3619)>>2)];
      var $22555=HEAP32[(($3620)>>2)];
      var $22556=HEAP32[(($3621)>>2)];
      var $22557=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22554, $22555, $22556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3409; break; } else { __label__ = 3411; break; };
    case 3409: // $22558
      HEAP32[(($result_i425)>>2)]=$22557;
      var $22559=HEAP32[(($result_i425)>>2)];
      var $22560=(($22559)|0)==0;
      if ($22560) { __label__ = 3410; break; } else { __label__ = 3415; break; }
    case 3410: // $22561
      var $22562=___cxa_allocate_exception(4);
      var $22563=$22562;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22563);
      (function() { try { __THREW__ = false; return ___cxa_throw($22562, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3414; break; } else { __label__ = 3411; break; }
    case 3411: // $22564
      var $22565=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22566=$22565.f0;
      HEAP32[(($3622)>>2)]=$22566;
      var $22567=$22565.f1;
      HEAP32[(($3623)>>2)]=$22567;
      var $22568=HEAP32[(($3623)>>2)];
      var $22569=(($22568)|0) < 0;
      if ($22569) { __label__ = 3412; break; } else { __label__ = 3413; break; }
    case 3412: // $22570
      var $22571=HEAP32[(($3622)>>2)];
      ___cxa_call_unexpected($22571);
      throw "Reached an unreachable!"
    case 3413: // $22572
      var $22573=HEAP32[(($3622)>>2)];
      var $22574=HEAP32[(($3622)>>2)];
      var $22575=HEAP32[(($3623)>>2)];
      var $22576=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22574, tempValue);
      var $22577=($22576.f1 = $22575, $22576);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3414: // $22578
      throw "Reached an unreachable!"
    case 3415: // $_ZnwjPKci_exit426
      var $22579=HEAP32[(($result_i425)>>2)];
      var $22580=$3619;
      var $22581=$3620;
      var $22582=$3621;
      var $22583=$result_i425;
      var $22584=$3622;
      var $22585=$3623;
      var $22586=$22579;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6397, 4, 3, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3416; break; } else { __label__ = 12746; break; }
    case 3416: // $22587
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6398, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3417; break; } else { __label__ = 12746; break; }
    case 3417: // $22588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6399, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3418; break; } else { __label__ = 12746; break; }
    case 3418: // $22589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3419; break; } else { __label__ = 12746; break; }
    case 3419: // $22590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3420; break; } else { __label__ = 12746; break; }
    case 3420: // $22591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3421; break; } else { __label__ = 12746; break; }
    case 3421: // $22592
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3422; break; } else { __label__ = 12746; break; }
    case 3422: // $22593
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6396, $6397, $6398, $6399, $6400, $6401, $6402, $6403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3423; break; } else { __label__ = 12746; break; }
    case 3423: // $22594
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22586, 66, 4, 3, ((STRING_TABLE.__str617413)|0), ((STRING_TABLE.__str618)|0), $6396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3424; break; } else { __label__ = 12746; break; }
    case 3424: // $22595
      var $22596=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22586);
      var $22597=__ZN11simple_listI16input_type_entryE6appendERS0_($22547, $22596);
      var $22598=$4689;
      var $22599=$3614;
      var $22600=$3615;
      var $22601=$3616;
      var $22602=$result_i427;
      var $22603=$3617;
      var $22604=$3618;
      HEAP32[(($3614)>>2)]=408;
      HEAP32[(($3615)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3616)>>2)]=271;
      var $22605=HEAP32[(($3614)>>2)];
      var $22606=HEAP32[(($3615)>>2)];
      var $22607=HEAP32[(($3616)>>2)];
      var $22608=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22605, $22606, $22607) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3425; break; } else { __label__ = 3427; break; };
    case 3425: // $22609
      HEAP32[(($result_i427)>>2)]=$22608;
      var $22610=HEAP32[(($result_i427)>>2)];
      var $22611=(($22610)|0)==0;
      if ($22611) { __label__ = 3426; break; } else { __label__ = 3431; break; }
    case 3426: // $22612
      var $22613=___cxa_allocate_exception(4);
      var $22614=$22613;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22614);
      (function() { try { __THREW__ = false; return ___cxa_throw($22613, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3430; break; } else { __label__ = 3427; break; }
    case 3427: // $22615
      var $22616=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22617=$22616.f0;
      HEAP32[(($3617)>>2)]=$22617;
      var $22618=$22616.f1;
      HEAP32[(($3618)>>2)]=$22618;
      var $22619=HEAP32[(($3618)>>2)];
      var $22620=(($22619)|0) < 0;
      if ($22620) { __label__ = 3428; break; } else { __label__ = 3429; break; }
    case 3428: // $22621
      var $22622=HEAP32[(($3617)>>2)];
      ___cxa_call_unexpected($22622);
      throw "Reached an unreachable!"
    case 3429: // $22623
      var $22624=HEAP32[(($3617)>>2)];
      var $22625=HEAP32[(($3617)>>2)];
      var $22626=HEAP32[(($3618)>>2)];
      var $22627=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22625, tempValue);
      var $22628=($22627.f1 = $22626, $22627);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3430: // $22629
      throw "Reached an unreachable!"
    case 3431: // $_ZnwjPKci_exit428
      var $22630=HEAP32[(($result_i427)>>2)];
      var $22631=$3614;
      var $22632=$3615;
      var $22633=$3616;
      var $22634=$result_i427;
      var $22635=$3617;
      var $22636=$3618;
      var $22637=$22630;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6405, 4, 3, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3432; break; } else { __label__ = 12751; break; }
    case 3432: // $22638
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6406, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3433; break; } else { __label__ = 12751; break; }
    case 3433: // $22639
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6407, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3434; break; } else { __label__ = 12751; break; }
    case 3434: // $22640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6408, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3435; break; } else { __label__ = 12751; break; }
    case 3435: // $22641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6409, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3436; break; } else { __label__ = 12751; break; }
    case 3436: // $22642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3437; break; } else { __label__ = 12751; break; }
    case 3437: // $22643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3438; break; } else { __label__ = 12751; break; }
    case 3438: // $22644
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6404, $6405, $6406, $6407, $6408, $6409, $6410, $6411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3439; break; } else { __label__ = 12751; break; }
    case 3439: // $22645
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22637, 67, 4, 3, ((STRING_TABLE.__str619)|0), ((STRING_TABLE.__str620)|0), $6404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3440; break; } else { __label__ = 12751; break; }
    case 3440: // $22646
      var $22647=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22637);
      var $22648=__ZN11simple_listI16input_type_entryE6appendERS0_($22598, $22647);
      var $22649=$4689;
      var $22650=$3609;
      var $22651=$3610;
      var $22652=$3611;
      var $22653=$result_i429;
      var $22654=$3612;
      var $22655=$3613;
      HEAP32[(($3609)>>2)]=408;
      HEAP32[(($3610)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3611)>>2)]=272;
      var $22656=HEAP32[(($3609)>>2)];
      var $22657=HEAP32[(($3610)>>2)];
      var $22658=HEAP32[(($3611)>>2)];
      var $22659=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22656, $22657, $22658) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3441; break; } else { __label__ = 3443; break; };
    case 3441: // $22660
      HEAP32[(($result_i429)>>2)]=$22659;
      var $22661=HEAP32[(($result_i429)>>2)];
      var $22662=(($22661)|0)==0;
      if ($22662) { __label__ = 3442; break; } else { __label__ = 3447; break; }
    case 3442: // $22663
      var $22664=___cxa_allocate_exception(4);
      var $22665=$22664;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22665);
      (function() { try { __THREW__ = false; return ___cxa_throw($22664, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3446; break; } else { __label__ = 3443; break; }
    case 3443: // $22666
      var $22667=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22668=$22667.f0;
      HEAP32[(($3612)>>2)]=$22668;
      var $22669=$22667.f1;
      HEAP32[(($3613)>>2)]=$22669;
      var $22670=HEAP32[(($3613)>>2)];
      var $22671=(($22670)|0) < 0;
      if ($22671) { __label__ = 3444; break; } else { __label__ = 3445; break; }
    case 3444: // $22672
      var $22673=HEAP32[(($3612)>>2)];
      ___cxa_call_unexpected($22673);
      throw "Reached an unreachable!"
    case 3445: // $22674
      var $22675=HEAP32[(($3612)>>2)];
      var $22676=HEAP32[(($3612)>>2)];
      var $22677=HEAP32[(($3613)>>2)];
      var $22678=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22676, tempValue);
      var $22679=($22678.f1 = $22677, $22678);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3446: // $22680
      throw "Reached an unreachable!"
    case 3447: // $_ZnwjPKci_exit430
      var $22681=HEAP32[(($result_i429)>>2)];
      var $22682=$3609;
      var $22683=$3610;
      var $22684=$3611;
      var $22685=$result_i429;
      var $22686=$3612;
      var $22687=$3613;
      var $22688=$22681;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6413, 4, 3, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3448; break; } else { __label__ = 12756; break; }
    case 3448: // $22689
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6414, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3449; break; } else { __label__ = 12756; break; }
    case 3449: // $22690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6415, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3450; break; } else { __label__ = 12756; break; }
    case 3450: // $22691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3451; break; } else { __label__ = 12756; break; }
    case 3451: // $22692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3452; break; } else { __label__ = 12756; break; }
    case 3452: // $22693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3453; break; } else { __label__ = 12756; break; }
    case 3453: // $22694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3454; break; } else { __label__ = 12756; break; }
    case 3454: // $22695
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6412, $6413, $6414, $6415, $6416, $6417, $6418, $6419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3455; break; } else { __label__ = 12756; break; }
    case 3455: // $22696
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22688, 68, 4, 3, ((STRING_TABLE.__str621)|0), ((STRING_TABLE.__str622)|0), $6412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3456; break; } else { __label__ = 12756; break; }
    case 3456: // $22697
      var $22698=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22688);
      var $22699=__ZN11simple_listI16input_type_entryE6appendERS0_($22649, $22698);
      var $22700=$4689;
      var $22701=$3604;
      var $22702=$3605;
      var $22703=$3606;
      var $22704=$result_i431;
      var $22705=$3607;
      var $22706=$3608;
      HEAP32[(($3604)>>2)]=408;
      HEAP32[(($3605)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3606)>>2)]=273;
      var $22707=HEAP32[(($3604)>>2)];
      var $22708=HEAP32[(($3605)>>2)];
      var $22709=HEAP32[(($3606)>>2)];
      var $22710=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22707, $22708, $22709) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3457; break; } else { __label__ = 3459; break; };
    case 3457: // $22711
      HEAP32[(($result_i431)>>2)]=$22710;
      var $22712=HEAP32[(($result_i431)>>2)];
      var $22713=(($22712)|0)==0;
      if ($22713) { __label__ = 3458; break; } else { __label__ = 3463; break; }
    case 3458: // $22714
      var $22715=___cxa_allocate_exception(4);
      var $22716=$22715;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22716);
      (function() { try { __THREW__ = false; return ___cxa_throw($22715, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3462; break; } else { __label__ = 3459; break; }
    case 3459: // $22717
      var $22718=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22719=$22718.f0;
      HEAP32[(($3607)>>2)]=$22719;
      var $22720=$22718.f1;
      HEAP32[(($3608)>>2)]=$22720;
      var $22721=HEAP32[(($3608)>>2)];
      var $22722=(($22721)|0) < 0;
      if ($22722) { __label__ = 3460; break; } else { __label__ = 3461; break; }
    case 3460: // $22723
      var $22724=HEAP32[(($3607)>>2)];
      ___cxa_call_unexpected($22724);
      throw "Reached an unreachable!"
    case 3461: // $22725
      var $22726=HEAP32[(($3607)>>2)];
      var $22727=HEAP32[(($3607)>>2)];
      var $22728=HEAP32[(($3608)>>2)];
      var $22729=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22727, tempValue);
      var $22730=($22729.f1 = $22728, $22729);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3462: // $22731
      throw "Reached an unreachable!"
    case 3463: // $_ZnwjPKci_exit432
      var $22732=HEAP32[(($result_i431)>>2)];
      var $22733=$3604;
      var $22734=$3605;
      var $22735=$3606;
      var $22736=$result_i431;
      var $22737=$3607;
      var $22738=$3608;
      var $22739=$22732;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6421, 4, 3, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3464; break; } else { __label__ = 12761; break; }
    case 3464: // $22740
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6422, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3465; break; } else { __label__ = 12761; break; }
    case 3465: // $22741
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6423, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3466; break; } else { __label__ = 12761; break; }
    case 3466: // $22742
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3467; break; } else { __label__ = 12761; break; }
    case 3467: // $22743
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3468; break; } else { __label__ = 12761; break; }
    case 3468: // $22744
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3469; break; } else { __label__ = 12761; break; }
    case 3469: // $22745
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3470; break; } else { __label__ = 12761; break; }
    case 3470: // $22746
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6420, $6421, $6422, $6423, $6424, $6425, $6426, $6427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3471; break; } else { __label__ = 12761; break; }
    case 3471: // $22747
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22739, 69, 4, 3, ((STRING_TABLE.__str623)|0), ((STRING_TABLE.__str624)|0), $6420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3472; break; } else { __label__ = 12761; break; }
    case 3472: // $22748
      var $22749=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22739);
      var $22750=__ZN11simple_listI16input_type_entryE6appendERS0_($22700, $22749);
      var $22751=$4689;
      var $22752=$3599;
      var $22753=$3600;
      var $22754=$3601;
      var $22755=$result_i433;
      var $22756=$3602;
      var $22757=$3603;
      HEAP32[(($3599)>>2)]=408;
      HEAP32[(($3600)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3601)>>2)]=274;
      var $22758=HEAP32[(($3599)>>2)];
      var $22759=HEAP32[(($3600)>>2)];
      var $22760=HEAP32[(($3601)>>2)];
      var $22761=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22758, $22759, $22760) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3473; break; } else { __label__ = 3475; break; };
    case 3473: // $22762
      HEAP32[(($result_i433)>>2)]=$22761;
      var $22763=HEAP32[(($result_i433)>>2)];
      var $22764=(($22763)|0)==0;
      if ($22764) { __label__ = 3474; break; } else { __label__ = 3479; break; }
    case 3474: // $22765
      var $22766=___cxa_allocate_exception(4);
      var $22767=$22766;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22767);
      (function() { try { __THREW__ = false; return ___cxa_throw($22766, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3478; break; } else { __label__ = 3475; break; }
    case 3475: // $22768
      var $22769=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22770=$22769.f0;
      HEAP32[(($3602)>>2)]=$22770;
      var $22771=$22769.f1;
      HEAP32[(($3603)>>2)]=$22771;
      var $22772=HEAP32[(($3603)>>2)];
      var $22773=(($22772)|0) < 0;
      if ($22773) { __label__ = 3476; break; } else { __label__ = 3477; break; }
    case 3476: // $22774
      var $22775=HEAP32[(($3602)>>2)];
      ___cxa_call_unexpected($22775);
      throw "Reached an unreachable!"
    case 3477: // $22776
      var $22777=HEAP32[(($3602)>>2)];
      var $22778=HEAP32[(($3602)>>2)];
      var $22779=HEAP32[(($3603)>>2)];
      var $22780=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22778, tempValue);
      var $22781=($22780.f1 = $22779, $22780);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3478: // $22782
      throw "Reached an unreachable!"
    case 3479: // $_ZnwjPKci_exit434
      var $22783=HEAP32[(($result_i433)>>2)];
      var $22784=$3599;
      var $22785=$3600;
      var $22786=$3601;
      var $22787=$result_i433;
      var $22788=$3602;
      var $22789=$3603;
      var $22790=$22783;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6429, 4, 3, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3480; break; } else { __label__ = 12766; break; }
    case 3480: // $22791
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6430, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3481; break; } else { __label__ = 12766; break; }
    case 3481: // $22792
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6431, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3482; break; } else { __label__ = 12766; break; }
    case 3482: // $22793
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6432, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3483; break; } else { __label__ = 12766; break; }
    case 3483: // $22794
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6433, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3484; break; } else { __label__ = 12766; break; }
    case 3484: // $22795
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3485; break; } else { __label__ = 12766; break; }
    case 3485: // $22796
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3486; break; } else { __label__ = 12766; break; }
    case 3486: // $22797
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6428, $6429, $6430, $6431, $6432, $6433, $6434, $6435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3487; break; } else { __label__ = 12766; break; }
    case 3487: // $22798
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22790, 70, 4, 3, ((STRING_TABLE.__str625)|0), ((STRING_TABLE.__str626)|0), $6428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3488; break; } else { __label__ = 12766; break; }
    case 3488: // $22799
      var $22800=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22790);
      var $22801=__ZN11simple_listI16input_type_entryE6appendERS0_($22751, $22800);
      var $22802=$4689;
      var $22803=$3594;
      var $22804=$3595;
      var $22805=$3596;
      var $22806=$result_i435;
      var $22807=$3597;
      var $22808=$3598;
      HEAP32[(($3594)>>2)]=408;
      HEAP32[(($3595)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3596)>>2)]=275;
      var $22809=HEAP32[(($3594)>>2)];
      var $22810=HEAP32[(($3595)>>2)];
      var $22811=HEAP32[(($3596)>>2)];
      var $22812=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22809, $22810, $22811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3489; break; } else { __label__ = 3491; break; };
    case 3489: // $22813
      HEAP32[(($result_i435)>>2)]=$22812;
      var $22814=HEAP32[(($result_i435)>>2)];
      var $22815=(($22814)|0)==0;
      if ($22815) { __label__ = 3490; break; } else { __label__ = 3495; break; }
    case 3490: // $22816
      var $22817=___cxa_allocate_exception(4);
      var $22818=$22817;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22818);
      (function() { try { __THREW__ = false; return ___cxa_throw($22817, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3494; break; } else { __label__ = 3491; break; }
    case 3491: // $22819
      var $22820=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22821=$22820.f0;
      HEAP32[(($3597)>>2)]=$22821;
      var $22822=$22820.f1;
      HEAP32[(($3598)>>2)]=$22822;
      var $22823=HEAP32[(($3598)>>2)];
      var $22824=(($22823)|0) < 0;
      if ($22824) { __label__ = 3492; break; } else { __label__ = 3493; break; }
    case 3492: // $22825
      var $22826=HEAP32[(($3597)>>2)];
      ___cxa_call_unexpected($22826);
      throw "Reached an unreachable!"
    case 3493: // $22827
      var $22828=HEAP32[(($3597)>>2)];
      var $22829=HEAP32[(($3597)>>2)];
      var $22830=HEAP32[(($3598)>>2)];
      var $22831=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22829, tempValue);
      var $22832=($22831.f1 = $22830, $22831);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3494: // $22833
      throw "Reached an unreachable!"
    case 3495: // $_ZnwjPKci_exit436
      var $22834=HEAP32[(($result_i435)>>2)];
      var $22835=$3594;
      var $22836=$3595;
      var $22837=$3596;
      var $22838=$result_i435;
      var $22839=$3597;
      var $22840=$3598;
      var $22841=$22834;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6437, 4, 3, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3496; break; } else { __label__ = 12771; break; }
    case 3496: // $22842
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6438, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3497; break; } else { __label__ = 12771; break; }
    case 3497: // $22843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6439, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3498; break; } else { __label__ = 12771; break; }
    case 3498: // $22844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3499; break; } else { __label__ = 12771; break; }
    case 3499: // $22845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3500; break; } else { __label__ = 12771; break; }
    case 3500: // $22846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3501; break; } else { __label__ = 12771; break; }
    case 3501: // $22847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3502; break; } else { __label__ = 12771; break; }
    case 3502: // $22848
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6436, $6437, $6438, $6439, $6440, $6441, $6442, $6443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3503; break; } else { __label__ = 12771; break; }
    case 3503: // $22849
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22841, 71, 4, 3, ((STRING_TABLE.__str627)|0), ((STRING_TABLE.__str628)|0), $6436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3504; break; } else { __label__ = 12771; break; }
    case 3504: // $22850
      var $22851=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22841);
      var $22852=__ZN11simple_listI16input_type_entryE6appendERS0_($22802, $22851);
      var $22853=$4689;
      var $22854=$3589;
      var $22855=$3590;
      var $22856=$3591;
      var $22857=$result_i437;
      var $22858=$3592;
      var $22859=$3593;
      HEAP32[(($3589)>>2)]=408;
      HEAP32[(($3590)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3591)>>2)]=276;
      var $22860=HEAP32[(($3589)>>2)];
      var $22861=HEAP32[(($3590)>>2)];
      var $22862=HEAP32[(($3591)>>2)];
      var $22863=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22860, $22861, $22862) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3505; break; } else { __label__ = 3507; break; };
    case 3505: // $22864
      HEAP32[(($result_i437)>>2)]=$22863;
      var $22865=HEAP32[(($result_i437)>>2)];
      var $22866=(($22865)|0)==0;
      if ($22866) { __label__ = 3506; break; } else { __label__ = 3511; break; }
    case 3506: // $22867
      var $22868=___cxa_allocate_exception(4);
      var $22869=$22868;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22869);
      (function() { try { __THREW__ = false; return ___cxa_throw($22868, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3510; break; } else { __label__ = 3507; break; }
    case 3507: // $22870
      var $22871=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22872=$22871.f0;
      HEAP32[(($3592)>>2)]=$22872;
      var $22873=$22871.f1;
      HEAP32[(($3593)>>2)]=$22873;
      var $22874=HEAP32[(($3593)>>2)];
      var $22875=(($22874)|0) < 0;
      if ($22875) { __label__ = 3508; break; } else { __label__ = 3509; break; }
    case 3508: // $22876
      var $22877=HEAP32[(($3592)>>2)];
      ___cxa_call_unexpected($22877);
      throw "Reached an unreachable!"
    case 3509: // $22878
      var $22879=HEAP32[(($3592)>>2)];
      var $22880=HEAP32[(($3592)>>2)];
      var $22881=HEAP32[(($3593)>>2)];
      var $22882=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22880, tempValue);
      var $22883=($22882.f1 = $22881, $22882);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3510: // $22884
      throw "Reached an unreachable!"
    case 3511: // $_ZnwjPKci_exit438
      var $22885=HEAP32[(($result_i437)>>2)];
      var $22886=$3589;
      var $22887=$3590;
      var $22888=$3591;
      var $22889=$result_i437;
      var $22890=$3592;
      var $22891=$3593;
      var $22892=$22885;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6445, 4, 3, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3512; break; } else { __label__ = 12776; break; }
    case 3512: // $22893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6446, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3513; break; } else { __label__ = 12776; break; }
    case 3513: // $22894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6447, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3514; break; } else { __label__ = 12776; break; }
    case 3514: // $22895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3515; break; } else { __label__ = 12776; break; }
    case 3515: // $22896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3516; break; } else { __label__ = 12776; break; }
    case 3516: // $22897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3517; break; } else { __label__ = 12776; break; }
    case 3517: // $22898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3518; break; } else { __label__ = 12776; break; }
    case 3518: // $22899
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6444, $6445, $6446, $6447, $6448, $6449, $6450, $6451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3519; break; } else { __label__ = 12776; break; }
    case 3519: // $22900
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22892, 72, 4, 3, ((STRING_TABLE.__str629)|0), ((STRING_TABLE.__str630)|0), $6444) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3520; break; } else { __label__ = 12776; break; }
    case 3520: // $22901
      var $22902=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22892);
      var $22903=__ZN11simple_listI16input_type_entryE6appendERS0_($22853, $22902);
      var $22904=$4689;
      var $22905=$3584;
      var $22906=$3585;
      var $22907=$3586;
      var $22908=$result_i439;
      var $22909=$3587;
      var $22910=$3588;
      HEAP32[(($3584)>>2)]=408;
      HEAP32[(($3585)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3586)>>2)]=277;
      var $22911=HEAP32[(($3584)>>2)];
      var $22912=HEAP32[(($3585)>>2)];
      var $22913=HEAP32[(($3586)>>2)];
      var $22914=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22911, $22912, $22913) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3521; break; } else { __label__ = 3523; break; };
    case 3521: // $22915
      HEAP32[(($result_i439)>>2)]=$22914;
      var $22916=HEAP32[(($result_i439)>>2)];
      var $22917=(($22916)|0)==0;
      if ($22917) { __label__ = 3522; break; } else { __label__ = 3527; break; }
    case 3522: // $22918
      var $22919=___cxa_allocate_exception(4);
      var $22920=$22919;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22920);
      (function() { try { __THREW__ = false; return ___cxa_throw($22919, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3526; break; } else { __label__ = 3523; break; }
    case 3523: // $22921
      var $22922=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22923=$22922.f0;
      HEAP32[(($3587)>>2)]=$22923;
      var $22924=$22922.f1;
      HEAP32[(($3588)>>2)]=$22924;
      var $22925=HEAP32[(($3588)>>2)];
      var $22926=(($22925)|0) < 0;
      if ($22926) { __label__ = 3524; break; } else { __label__ = 3525; break; }
    case 3524: // $22927
      var $22928=HEAP32[(($3587)>>2)];
      ___cxa_call_unexpected($22928);
      throw "Reached an unreachable!"
    case 3525: // $22929
      var $22930=HEAP32[(($3587)>>2)];
      var $22931=HEAP32[(($3587)>>2)];
      var $22932=HEAP32[(($3588)>>2)];
      var $22933=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22931, tempValue);
      var $22934=($22933.f1 = $22932, $22933);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3526: // $22935
      throw "Reached an unreachable!"
    case 3527: // $_ZnwjPKci_exit440
      var $22936=HEAP32[(($result_i439)>>2)];
      var $22937=$3584;
      var $22938=$3585;
      var $22939=$3586;
      var $22940=$result_i439;
      var $22941=$3587;
      var $22942=$3588;
      var $22943=$22936;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6453, 4, 3, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3528; break; } else { __label__ = 12781; break; }
    case 3528: // $22944
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6454, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3529; break; } else { __label__ = 12781; break; }
    case 3529: // $22945
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6455, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3530; break; } else { __label__ = 12781; break; }
    case 3530: // $22946
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6456, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3531; break; } else { __label__ = 12781; break; }
    case 3531: // $22947
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6457, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3532; break; } else { __label__ = 12781; break; }
    case 3532: // $22948
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3533; break; } else { __label__ = 12781; break; }
    case 3533: // $22949
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3534; break; } else { __label__ = 12781; break; }
    case 3534: // $22950
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6452, $6453, $6454, $6455, $6456, $6457, $6458, $6459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3535; break; } else { __label__ = 12781; break; }
    case 3535: // $22951
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22943, 73, 4, 3, ((STRING_TABLE.__str631)|0), ((STRING_TABLE.__str632)|0), $6452) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3536; break; } else { __label__ = 12781; break; }
    case 3536: // $22952
      var $22953=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22943);
      var $22954=__ZN11simple_listI16input_type_entryE6appendERS0_($22904, $22953);
      var $22955=$4689;
      var $22956=$3579;
      var $22957=$3580;
      var $22958=$3581;
      var $22959=$result_i441;
      var $22960=$3582;
      var $22961=$3583;
      HEAP32[(($3579)>>2)]=408;
      HEAP32[(($3580)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3581)>>2)]=278;
      var $22962=HEAP32[(($3579)>>2)];
      var $22963=HEAP32[(($3580)>>2)];
      var $22964=HEAP32[(($3581)>>2)];
      var $22965=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22962, $22963, $22964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3537; break; } else { __label__ = 3539; break; };
    case 3537: // $22966
      HEAP32[(($result_i441)>>2)]=$22965;
      var $22967=HEAP32[(($result_i441)>>2)];
      var $22968=(($22967)|0)==0;
      if ($22968) { __label__ = 3538; break; } else { __label__ = 3543; break; }
    case 3538: // $22969
      var $22970=___cxa_allocate_exception(4);
      var $22971=$22970;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($22971);
      (function() { try { __THREW__ = false; return ___cxa_throw($22970, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3542; break; } else { __label__ = 3539; break; }
    case 3539: // $22972
      var $22973=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22974=$22973.f0;
      HEAP32[(($3582)>>2)]=$22974;
      var $22975=$22973.f1;
      HEAP32[(($3583)>>2)]=$22975;
      var $22976=HEAP32[(($3583)>>2)];
      var $22977=(($22976)|0) < 0;
      if ($22977) { __label__ = 3540; break; } else { __label__ = 3541; break; }
    case 3540: // $22978
      var $22979=HEAP32[(($3582)>>2)];
      ___cxa_call_unexpected($22979);
      throw "Reached an unreachable!"
    case 3541: // $22980
      var $22981=HEAP32[(($3582)>>2)];
      var $22982=HEAP32[(($3582)>>2)];
      var $22983=HEAP32[(($3583)>>2)];
      var $22984=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22982, tempValue);
      var $22985=($22984.f1 = $22983, $22984);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3542: // $22986
      throw "Reached an unreachable!"
    case 3543: // $_ZnwjPKci_exit442
      var $22987=HEAP32[(($result_i441)>>2)];
      var $22988=$3579;
      var $22989=$3580;
      var $22990=$3581;
      var $22991=$result_i441;
      var $22992=$3582;
      var $22993=$3583;
      var $22994=$22987;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6461, 4, 3, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3544; break; } else { __label__ = 12786; break; }
    case 3544: // $22995
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6462, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3545; break; } else { __label__ = 12786; break; }
    case 3545: // $22996
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6463, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3546; break; } else { __label__ = 12786; break; }
    case 3546: // $22997
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3547; break; } else { __label__ = 12786; break; }
    case 3547: // $22998
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3548; break; } else { __label__ = 12786; break; }
    case 3548: // $22999
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3549; break; } else { __label__ = 12786; break; }
    case 3549: // $23000
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3550; break; } else { __label__ = 12786; break; }
    case 3550: // $23001
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6460, $6461, $6462, $6463, $6464, $6465, $6466, $6467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3551; break; } else { __label__ = 12786; break; }
    case 3551: // $23002
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($22994, 74, 4, 3, ((STRING_TABLE.__str633)|0), ((STRING_TABLE.__str634)|0), $6460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3552; break; } else { __label__ = 12786; break; }
    case 3552: // $23003
      var $23004=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $22994);
      var $23005=__ZN11simple_listI16input_type_entryE6appendERS0_($22955, $23004);
      var $23006=$4689;
      var $23007=$3574;
      var $23008=$3575;
      var $23009=$3576;
      var $23010=$result_i443;
      var $23011=$3577;
      var $23012=$3578;
      HEAP32[(($3574)>>2)]=408;
      HEAP32[(($3575)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3576)>>2)]=279;
      var $23013=HEAP32[(($3574)>>2)];
      var $23014=HEAP32[(($3575)>>2)];
      var $23015=HEAP32[(($3576)>>2)];
      var $23016=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23013, $23014, $23015) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3553; break; } else { __label__ = 3555; break; };
    case 3553: // $23017
      HEAP32[(($result_i443)>>2)]=$23016;
      var $23018=HEAP32[(($result_i443)>>2)];
      var $23019=(($23018)|0)==0;
      if ($23019) { __label__ = 3554; break; } else { __label__ = 3559; break; }
    case 3554: // $23020
      var $23021=___cxa_allocate_exception(4);
      var $23022=$23021;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23022);
      (function() { try { __THREW__ = false; return ___cxa_throw($23021, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3558; break; } else { __label__ = 3555; break; }
    case 3555: // $23023
      var $23024=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23025=$23024.f0;
      HEAP32[(($3577)>>2)]=$23025;
      var $23026=$23024.f1;
      HEAP32[(($3578)>>2)]=$23026;
      var $23027=HEAP32[(($3578)>>2)];
      var $23028=(($23027)|0) < 0;
      if ($23028) { __label__ = 3556; break; } else { __label__ = 3557; break; }
    case 3556: // $23029
      var $23030=HEAP32[(($3577)>>2)];
      ___cxa_call_unexpected($23030);
      throw "Reached an unreachable!"
    case 3557: // $23031
      var $23032=HEAP32[(($3577)>>2)];
      var $23033=HEAP32[(($3577)>>2)];
      var $23034=HEAP32[(($3578)>>2)];
      var $23035=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23033, tempValue);
      var $23036=($23035.f1 = $23034, $23035);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3558: // $23037
      throw "Reached an unreachable!"
    case 3559: // $_ZnwjPKci_exit444
      var $23038=HEAP32[(($result_i443)>>2)];
      var $23039=$3574;
      var $23040=$3575;
      var $23041=$3576;
      var $23042=$result_i443;
      var $23043=$3577;
      var $23044=$3578;
      var $23045=$23038;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6469, 1, 0, 1, 0, 31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3560; break; } else { __label__ = 12791; break; }
    case 3560: // $23046
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6470, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3561; break; } else { __label__ = 12791; break; }
    case 3561: // $23047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6471, 4, 3, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3562; break; } else { __label__ = 12791; break; }
    case 3562: // $23048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3563; break; } else { __label__ = 12791; break; }
    case 3563: // $23049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3564; break; } else { __label__ = 12791; break; }
    case 3564: // $23050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3565; break; } else { __label__ = 12791; break; }
    case 3565: // $23051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3566; break; } else { __label__ = 12791; break; }
    case 3566: // $23052
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6468, $6469, $6470, $6471, $6472, $6473, $6474, $6475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3567; break; } else { __label__ = 12791; break; }
    case 3567: // $23053
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23045, 43, 4, 3, ((STRING_TABLE.__str635)|0), ((STRING_TABLE.__str636)|0), $6468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3568; break; } else { __label__ = 12791; break; }
    case 3568: // $23054
      var $23055=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23045);
      var $23056=__ZN11simple_listI16input_type_entryE6appendERS0_($23006, $23055);
      var $23057=$4689;
      var $23058=$3569;
      var $23059=$3570;
      var $23060=$3571;
      var $23061=$result_i445;
      var $23062=$3572;
      var $23063=$3573;
      HEAP32[(($3569)>>2)]=408;
      HEAP32[(($3570)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3571)>>2)]=280;
      var $23064=HEAP32[(($3569)>>2)];
      var $23065=HEAP32[(($3570)>>2)];
      var $23066=HEAP32[(($3571)>>2)];
      var $23067=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23064, $23065, $23066) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3569; break; } else { __label__ = 3571; break; };
    case 3569: // $23068
      HEAP32[(($result_i445)>>2)]=$23067;
      var $23069=HEAP32[(($result_i445)>>2)];
      var $23070=(($23069)|0)==0;
      if ($23070) { __label__ = 3570; break; } else { __label__ = 3575; break; }
    case 3570: // $23071
      var $23072=___cxa_allocate_exception(4);
      var $23073=$23072;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23073);
      (function() { try { __THREW__ = false; return ___cxa_throw($23072, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3574; break; } else { __label__ = 3571; break; }
    case 3571: // $23074
      var $23075=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23076=$23075.f0;
      HEAP32[(($3572)>>2)]=$23076;
      var $23077=$23075.f1;
      HEAP32[(($3573)>>2)]=$23077;
      var $23078=HEAP32[(($3573)>>2)];
      var $23079=(($23078)|0) < 0;
      if ($23079) { __label__ = 3572; break; } else { __label__ = 3573; break; }
    case 3572: // $23080
      var $23081=HEAP32[(($3572)>>2)];
      ___cxa_call_unexpected($23081);
      throw "Reached an unreachable!"
    case 3573: // $23082
      var $23083=HEAP32[(($3572)>>2)];
      var $23084=HEAP32[(($3572)>>2)];
      var $23085=HEAP32[(($3573)>>2)];
      var $23086=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23084, tempValue);
      var $23087=($23086.f1 = $23085, $23086);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3574: // $23088
      throw "Reached an unreachable!"
    case 3575: // $_ZnwjPKci_exit446
      var $23089=HEAP32[(($result_i445)>>2)];
      var $23090=$3569;
      var $23091=$3570;
      var $23092=$3571;
      var $23093=$result_i445;
      var $23094=$3572;
      var $23095=$3573;
      var $23096=$23089;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6477, 1, 0, 1, 0, 35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3576; break; } else { __label__ = 12796; break; }
    case 3576: // $23097
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6478, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3577; break; } else { __label__ = 12796; break; }
    case 3577: // $23098
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6479, 4, 3, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3578; break; } else { __label__ = 12796; break; }
    case 3578: // $23099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6480, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3579; break; } else { __label__ = 12796; break; }
    case 3579: // $23100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6481, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3580; break; } else { __label__ = 12796; break; }
    case 3580: // $23101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3581; break; } else { __label__ = 12796; break; }
    case 3581: // $23102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3582; break; } else { __label__ = 12796; break; }
    case 3582: // $23103
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6476, $6477, $6478, $6479, $6480, $6481, $6482, $6483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3583; break; } else { __label__ = 12796; break; }
    case 3583: // $23104
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23096, 44, 4, 3, ((STRING_TABLE.__str637)|0), ((STRING_TABLE.__str638)|0), $6476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3584; break; } else { __label__ = 12796; break; }
    case 3584: // $23105
      var $23106=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23096);
      var $23107=__ZN11simple_listI16input_type_entryE6appendERS0_($23057, $23106);
      var $23108=$4689;
      var $23109=$3564;
      var $23110=$3565;
      var $23111=$3566;
      var $23112=$result_i447;
      var $23113=$3567;
      var $23114=$3568;
      HEAP32[(($3564)>>2)]=408;
      HEAP32[(($3565)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3566)>>2)]=282;
      var $23115=HEAP32[(($3564)>>2)];
      var $23116=HEAP32[(($3565)>>2)];
      var $23117=HEAP32[(($3566)>>2)];
      var $23118=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23115, $23116, $23117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3585; break; } else { __label__ = 3587; break; };
    case 3585: // $23119
      HEAP32[(($result_i447)>>2)]=$23118;
      var $23120=HEAP32[(($result_i447)>>2)];
      var $23121=(($23120)|0)==0;
      if ($23121) { __label__ = 3586; break; } else { __label__ = 3591; break; }
    case 3586: // $23122
      var $23123=___cxa_allocate_exception(4);
      var $23124=$23123;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23124);
      (function() { try { __THREW__ = false; return ___cxa_throw($23123, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3590; break; } else { __label__ = 3587; break; }
    case 3587: // $23125
      var $23126=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23127=$23126.f0;
      HEAP32[(($3567)>>2)]=$23127;
      var $23128=$23126.f1;
      HEAP32[(($3568)>>2)]=$23128;
      var $23129=HEAP32[(($3568)>>2)];
      var $23130=(($23129)|0) < 0;
      if ($23130) { __label__ = 3588; break; } else { __label__ = 3589; break; }
    case 3588: // $23131
      var $23132=HEAP32[(($3567)>>2)];
      ___cxa_call_unexpected($23132);
      throw "Reached an unreachable!"
    case 3589: // $23133
      var $23134=HEAP32[(($3567)>>2)];
      var $23135=HEAP32[(($3567)>>2)];
      var $23136=HEAP32[(($3568)>>2)];
      var $23137=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23135, tempValue);
      var $23138=($23137.f1 = $23136, $23137);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3590: // $23139
      throw "Reached an unreachable!"
    case 3591: // $_ZnwjPKci_exit448
      var $23140=HEAP32[(($result_i447)>>2)];
      var $23141=$3564;
      var $23142=$3565;
      var $23143=$3566;
      var $23144=$result_i447;
      var $23145=$3567;
      var $23146=$3568;
      var $23147=$23140;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6485, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3592; break; } else { __label__ = 12801; break; }
    case 3592: // $23148
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6486, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3593; break; } else { __label__ = 12801; break; }
    case 3593: // $23149
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6487, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3594; break; } else { __label__ = 12801; break; }
    case 3594: // $23150
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3595; break; } else { __label__ = 12801; break; }
    case 3595: // $23151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3596; break; } else { __label__ = 12801; break; }
    case 3596: // $23152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3597; break; } else { __label__ = 12801; break; }
    case 3597: // $23153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3598; break; } else { __label__ = 12801; break; }
    case 3598: // $23154
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6484, $6485, $6486, $6487, $6488, $6489, $6490, $6491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3599; break; } else { __label__ = 12801; break; }
    case 3599: // $23155
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23147, 47, 5, 4, ((STRING_TABLE.__str639)|0), ((STRING_TABLE.__str640)|0), $6484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3600; break; } else { __label__ = 12801; break; }
    case 3600: // $23156
      var $23157=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23147);
      var $23158=__ZN11simple_listI16input_type_entryE6appendERS0_($23108, $23157);
      var $23159=$4689;
      var $23160=$3559;
      var $23161=$3560;
      var $23162=$3561;
      var $23163=$result_i449;
      var $23164=$3562;
      var $23165=$3563;
      HEAP32[(($3559)>>2)]=408;
      HEAP32[(($3560)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3561)>>2)]=283;
      var $23166=HEAP32[(($3559)>>2)];
      var $23167=HEAP32[(($3560)>>2)];
      var $23168=HEAP32[(($3561)>>2)];
      var $23169=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23166, $23167, $23168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3601; break; } else { __label__ = 3603; break; };
    case 3601: // $23170
      HEAP32[(($result_i449)>>2)]=$23169;
      var $23171=HEAP32[(($result_i449)>>2)];
      var $23172=(($23171)|0)==0;
      if ($23172) { __label__ = 3602; break; } else { __label__ = 3607; break; }
    case 3602: // $23173
      var $23174=___cxa_allocate_exception(4);
      var $23175=$23174;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23175);
      (function() { try { __THREW__ = false; return ___cxa_throw($23174, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3606; break; } else { __label__ = 3603; break; }
    case 3603: // $23176
      var $23177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23178=$23177.f0;
      HEAP32[(($3562)>>2)]=$23178;
      var $23179=$23177.f1;
      HEAP32[(($3563)>>2)]=$23179;
      var $23180=HEAP32[(($3563)>>2)];
      var $23181=(($23180)|0) < 0;
      if ($23181) { __label__ = 3604; break; } else { __label__ = 3605; break; }
    case 3604: // $23182
      var $23183=HEAP32[(($3562)>>2)];
      ___cxa_call_unexpected($23183);
      throw "Reached an unreachable!"
    case 3605: // $23184
      var $23185=HEAP32[(($3562)>>2)];
      var $23186=HEAP32[(($3562)>>2)];
      var $23187=HEAP32[(($3563)>>2)];
      var $23188=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23186, tempValue);
      var $23189=($23188.f1 = $23187, $23188);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3606: // $23190
      throw "Reached an unreachable!"
    case 3607: // $_ZnwjPKci_exit450
      var $23191=HEAP32[(($result_i449)>>2)];
      var $23192=$3559;
      var $23193=$3560;
      var $23194=$3561;
      var $23195=$result_i449;
      var $23196=$3562;
      var $23197=$3563;
      var $23198=$23191;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6493, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3608; break; } else { __label__ = 12806; break; }
    case 3608: // $23199
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6494, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3609; break; } else { __label__ = 12806; break; }
    case 3609: // $23200
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6495, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3610; break; } else { __label__ = 12806; break; }
    case 3610: // $23201
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3611; break; } else { __label__ = 12806; break; }
    case 3611: // $23202
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3612; break; } else { __label__ = 12806; break; }
    case 3612: // $23203
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3613; break; } else { __label__ = 12806; break; }
    case 3613: // $23204
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3614; break; } else { __label__ = 12806; break; }
    case 3614: // $23205
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6492, $6493, $6494, $6495, $6496, $6497, $6498, $6499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3615; break; } else { __label__ = 12806; break; }
    case 3615: // $23206
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23198, 48, 5, 4, ((STRING_TABLE.__str641)|0), ((STRING_TABLE.__str642)|0), $6492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3616; break; } else { __label__ = 12806; break; }
    case 3616: // $23207
      var $23208=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23198);
      var $23209=__ZN11simple_listI16input_type_entryE6appendERS0_($23159, $23208);
      var $23210=$4689;
      var $23211=$3554;
      var $23212=$3555;
      var $23213=$3556;
      var $23214=$result_i451;
      var $23215=$3557;
      var $23216=$3558;
      HEAP32[(($3554)>>2)]=408;
      HEAP32[(($3555)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3556)>>2)]=284;
      var $23217=HEAP32[(($3554)>>2)];
      var $23218=HEAP32[(($3555)>>2)];
      var $23219=HEAP32[(($3556)>>2)];
      var $23220=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23217, $23218, $23219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3617; break; } else { __label__ = 3619; break; };
    case 3617: // $23221
      HEAP32[(($result_i451)>>2)]=$23220;
      var $23222=HEAP32[(($result_i451)>>2)];
      var $23223=(($23222)|0)==0;
      if ($23223) { __label__ = 3618; break; } else { __label__ = 3623; break; }
    case 3618: // $23224
      var $23225=___cxa_allocate_exception(4);
      var $23226=$23225;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23226);
      (function() { try { __THREW__ = false; return ___cxa_throw($23225, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3622; break; } else { __label__ = 3619; break; }
    case 3619: // $23227
      var $23228=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23229=$23228.f0;
      HEAP32[(($3557)>>2)]=$23229;
      var $23230=$23228.f1;
      HEAP32[(($3558)>>2)]=$23230;
      var $23231=HEAP32[(($3558)>>2)];
      var $23232=(($23231)|0) < 0;
      if ($23232) { __label__ = 3620; break; } else { __label__ = 3621; break; }
    case 3620: // $23233
      var $23234=HEAP32[(($3557)>>2)];
      ___cxa_call_unexpected($23234);
      throw "Reached an unreachable!"
    case 3621: // $23235
      var $23236=HEAP32[(($3557)>>2)];
      var $23237=HEAP32[(($3557)>>2)];
      var $23238=HEAP32[(($3558)>>2)];
      var $23239=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23237, tempValue);
      var $23240=($23239.f1 = $23238, $23239);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3622: // $23241
      throw "Reached an unreachable!"
    case 3623: // $_ZnwjPKci_exit452
      var $23242=HEAP32[(($result_i451)>>2)];
      var $23243=$3554;
      var $23244=$3555;
      var $23245=$3556;
      var $23246=$result_i451;
      var $23247=$3557;
      var $23248=$3558;
      var $23249=$23242;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6501, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3624; break; } else { __label__ = 12811; break; }
    case 3624: // $23250
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6502, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3625; break; } else { __label__ = 12811; break; }
    case 3625: // $23251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6503, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3626; break; } else { __label__ = 12811; break; }
    case 3626: // $23252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6504, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3627; break; } else { __label__ = 12811; break; }
    case 3627: // $23253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6505, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3628; break; } else { __label__ = 12811; break; }
    case 3628: // $23254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3629; break; } else { __label__ = 12811; break; }
    case 3629: // $23255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3630; break; } else { __label__ = 12811; break; }
    case 3630: // $23256
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6500, $6501, $6502, $6503, $6504, $6505, $6506, $6507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3631; break; } else { __label__ = 12811; break; }
    case 3631: // $23257
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23249, 49, 5, 4, ((STRING_TABLE.__str643)|0), ((STRING_TABLE.__str644)|0), $6500) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3632; break; } else { __label__ = 12811; break; }
    case 3632: // $23258
      var $23259=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23249);
      var $23260=__ZN11simple_listI16input_type_entryE6appendERS0_($23210, $23259);
      var $23261=$4689;
      var $23262=$3549;
      var $23263=$3550;
      var $23264=$3551;
      var $23265=$result_i453;
      var $23266=$3552;
      var $23267=$3553;
      HEAP32[(($3549)>>2)]=408;
      HEAP32[(($3550)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3551)>>2)]=285;
      var $23268=HEAP32[(($3549)>>2)];
      var $23269=HEAP32[(($3550)>>2)];
      var $23270=HEAP32[(($3551)>>2)];
      var $23271=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23268, $23269, $23270) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3633; break; } else { __label__ = 3635; break; };
    case 3633: // $23272
      HEAP32[(($result_i453)>>2)]=$23271;
      var $23273=HEAP32[(($result_i453)>>2)];
      var $23274=(($23273)|0)==0;
      if ($23274) { __label__ = 3634; break; } else { __label__ = 3639; break; }
    case 3634: // $23275
      var $23276=___cxa_allocate_exception(4);
      var $23277=$23276;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23277);
      (function() { try { __THREW__ = false; return ___cxa_throw($23276, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3638; break; } else { __label__ = 3635; break; }
    case 3635: // $23278
      var $23279=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23280=$23279.f0;
      HEAP32[(($3552)>>2)]=$23280;
      var $23281=$23279.f1;
      HEAP32[(($3553)>>2)]=$23281;
      var $23282=HEAP32[(($3553)>>2)];
      var $23283=(($23282)|0) < 0;
      if ($23283) { __label__ = 3636; break; } else { __label__ = 3637; break; }
    case 3636: // $23284
      var $23285=HEAP32[(($3552)>>2)];
      ___cxa_call_unexpected($23285);
      throw "Reached an unreachable!"
    case 3637: // $23286
      var $23287=HEAP32[(($3552)>>2)];
      var $23288=HEAP32[(($3552)>>2)];
      var $23289=HEAP32[(($3553)>>2)];
      var $23290=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23288, tempValue);
      var $23291=($23290.f1 = $23289, $23290);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3638: // $23292
      throw "Reached an unreachable!"
    case 3639: // $_ZnwjPKci_exit454
      var $23293=HEAP32[(($result_i453)>>2)];
      var $23294=$3549;
      var $23295=$3550;
      var $23296=$3551;
      var $23297=$result_i453;
      var $23298=$3552;
      var $23299=$3553;
      var $23300=$23293;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6509, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3640; break; } else { __label__ = 12816; break; }
    case 3640: // $23301
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6510, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3641; break; } else { __label__ = 12816; break; }
    case 3641: // $23302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6511, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3642; break; } else { __label__ = 12816; break; }
    case 3642: // $23303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3643; break; } else { __label__ = 12816; break; }
    case 3643: // $23304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3644; break; } else { __label__ = 12816; break; }
    case 3644: // $23305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3645; break; } else { __label__ = 12816; break; }
    case 3645: // $23306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3646; break; } else { __label__ = 12816; break; }
    case 3646: // $23307
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6508, $6509, $6510, $6511, $6512, $6513, $6514, $6515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3647; break; } else { __label__ = 12816; break; }
    case 3647: // $23308
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23300, 50, 5, 4, ((STRING_TABLE.__str645)|0), ((STRING_TABLE.__str646)|0), $6508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3648; break; } else { __label__ = 12816; break; }
    case 3648: // $23309
      var $23310=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23300);
      var $23311=__ZN11simple_listI16input_type_entryE6appendERS0_($23261, $23310);
      var $23312=$4689;
      var $23313=$3544;
      var $23314=$3545;
      var $23315=$3546;
      var $23316=$result_i455;
      var $23317=$3547;
      var $23318=$3548;
      HEAP32[(($3544)>>2)]=408;
      HEAP32[(($3545)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3546)>>2)]=286;
      var $23319=HEAP32[(($3544)>>2)];
      var $23320=HEAP32[(($3545)>>2)];
      var $23321=HEAP32[(($3546)>>2)];
      var $23322=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23319, $23320, $23321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3649; break; } else { __label__ = 3651; break; };
    case 3649: // $23323
      HEAP32[(($result_i455)>>2)]=$23322;
      var $23324=HEAP32[(($result_i455)>>2)];
      var $23325=(($23324)|0)==0;
      if ($23325) { __label__ = 3650; break; } else { __label__ = 3655; break; }
    case 3650: // $23326
      var $23327=___cxa_allocate_exception(4);
      var $23328=$23327;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23328);
      (function() { try { __THREW__ = false; return ___cxa_throw($23327, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3654; break; } else { __label__ = 3651; break; }
    case 3651: // $23329
      var $23330=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23331=$23330.f0;
      HEAP32[(($3547)>>2)]=$23331;
      var $23332=$23330.f1;
      HEAP32[(($3548)>>2)]=$23332;
      var $23333=HEAP32[(($3548)>>2)];
      var $23334=(($23333)|0) < 0;
      if ($23334) { __label__ = 3652; break; } else { __label__ = 3653; break; }
    case 3652: // $23335
      var $23336=HEAP32[(($3547)>>2)];
      ___cxa_call_unexpected($23336);
      throw "Reached an unreachable!"
    case 3653: // $23337
      var $23338=HEAP32[(($3547)>>2)];
      var $23339=HEAP32[(($3547)>>2)];
      var $23340=HEAP32[(($3548)>>2)];
      var $23341=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23339, tempValue);
      var $23342=($23341.f1 = $23340, $23341);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3654: // $23343
      throw "Reached an unreachable!"
    case 3655: // $_ZnwjPKci_exit456
      var $23344=HEAP32[(($result_i455)>>2)];
      var $23345=$3544;
      var $23346=$3545;
      var $23347=$3546;
      var $23348=$result_i455;
      var $23349=$3547;
      var $23350=$3548;
      var $23351=$23344;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6517, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3656; break; } else { __label__ = 12821; break; }
    case 3656: // $23352
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6518, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3657; break; } else { __label__ = 12821; break; }
    case 3657: // $23353
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6519, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3658; break; } else { __label__ = 12821; break; }
    case 3658: // $23354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3659; break; } else { __label__ = 12821; break; }
    case 3659: // $23355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3660; break; } else { __label__ = 12821; break; }
    case 3660: // $23356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3661; break; } else { __label__ = 12821; break; }
    case 3661: // $23357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3662; break; } else { __label__ = 12821; break; }
    case 3662: // $23358
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6516, $6517, $6518, $6519, $6520, $6521, $6522, $6523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3663; break; } else { __label__ = 12821; break; }
    case 3663: // $23359
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23351, 51, 5, 4, ((STRING_TABLE.__str647)|0), ((STRING_TABLE.__str648)|0), $6516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3664; break; } else { __label__ = 12821; break; }
    case 3664: // $23360
      var $23361=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23351);
      var $23362=__ZN11simple_listI16input_type_entryE6appendERS0_($23312, $23361);
      var $23363=$4689;
      var $23364=$3539;
      var $23365=$3540;
      var $23366=$3541;
      var $23367=$result_i457;
      var $23368=$3542;
      var $23369=$3543;
      HEAP32[(($3539)>>2)]=408;
      HEAP32[(($3540)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3541)>>2)]=287;
      var $23370=HEAP32[(($3539)>>2)];
      var $23371=HEAP32[(($3540)>>2)];
      var $23372=HEAP32[(($3541)>>2)];
      var $23373=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23370, $23371, $23372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3665; break; } else { __label__ = 3667; break; };
    case 3665: // $23374
      HEAP32[(($result_i457)>>2)]=$23373;
      var $23375=HEAP32[(($result_i457)>>2)];
      var $23376=(($23375)|0)==0;
      if ($23376) { __label__ = 3666; break; } else { __label__ = 3671; break; }
    case 3666: // $23377
      var $23378=___cxa_allocate_exception(4);
      var $23379=$23378;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23379);
      (function() { try { __THREW__ = false; return ___cxa_throw($23378, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3670; break; } else { __label__ = 3667; break; }
    case 3667: // $23380
      var $23381=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23382=$23381.f0;
      HEAP32[(($3542)>>2)]=$23382;
      var $23383=$23381.f1;
      HEAP32[(($3543)>>2)]=$23383;
      var $23384=HEAP32[(($3543)>>2)];
      var $23385=(($23384)|0) < 0;
      if ($23385) { __label__ = 3668; break; } else { __label__ = 3669; break; }
    case 3668: // $23386
      var $23387=HEAP32[(($3542)>>2)];
      ___cxa_call_unexpected($23387);
      throw "Reached an unreachable!"
    case 3669: // $23388
      var $23389=HEAP32[(($3542)>>2)];
      var $23390=HEAP32[(($3542)>>2)];
      var $23391=HEAP32[(($3543)>>2)];
      var $23392=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23390, tempValue);
      var $23393=($23392.f1 = $23391, $23392);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3670: // $23394
      throw "Reached an unreachable!"
    case 3671: // $_ZnwjPKci_exit458
      var $23395=HEAP32[(($result_i457)>>2)];
      var $23396=$3539;
      var $23397=$3540;
      var $23398=$3541;
      var $23399=$result_i457;
      var $23400=$3542;
      var $23401=$3543;
      var $23402=$23395;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6525, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3672; break; } else { __label__ = 12826; break; }
    case 3672: // $23403
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6526, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3673; break; } else { __label__ = 12826; break; }
    case 3673: // $23404
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6527, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3674; break; } else { __label__ = 12826; break; }
    case 3674: // $23405
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6528, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3675; break; } else { __label__ = 12826; break; }
    case 3675: // $23406
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6529, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3676; break; } else { __label__ = 12826; break; }
    case 3676: // $23407
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3677; break; } else { __label__ = 12826; break; }
    case 3677: // $23408
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3678; break; } else { __label__ = 12826; break; }
    case 3678: // $23409
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6524, $6525, $6526, $6527, $6528, $6529, $6530, $6531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3679; break; } else { __label__ = 12826; break; }
    case 3679: // $23410
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23402, 52, 5, 4, ((STRING_TABLE.__str649)|0), ((STRING_TABLE.__str650)|0), $6524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3680; break; } else { __label__ = 12826; break; }
    case 3680: // $23411
      var $23412=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23402);
      var $23413=__ZN11simple_listI16input_type_entryE6appendERS0_($23363, $23412);
      var $23414=$4689;
      var $23415=$3534;
      var $23416=$3535;
      var $23417=$3536;
      var $23418=$result_i459;
      var $23419=$3537;
      var $23420=$3538;
      HEAP32[(($3534)>>2)]=408;
      HEAP32[(($3535)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3536)>>2)]=288;
      var $23421=HEAP32[(($3534)>>2)];
      var $23422=HEAP32[(($3535)>>2)];
      var $23423=HEAP32[(($3536)>>2)];
      var $23424=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23421, $23422, $23423) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3681; break; } else { __label__ = 3683; break; };
    case 3681: // $23425
      HEAP32[(($result_i459)>>2)]=$23424;
      var $23426=HEAP32[(($result_i459)>>2)];
      var $23427=(($23426)|0)==0;
      if ($23427) { __label__ = 3682; break; } else { __label__ = 3687; break; }
    case 3682: // $23428
      var $23429=___cxa_allocate_exception(4);
      var $23430=$23429;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23430);
      (function() { try { __THREW__ = false; return ___cxa_throw($23429, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3686; break; } else { __label__ = 3683; break; }
    case 3683: // $23431
      var $23432=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23433=$23432.f0;
      HEAP32[(($3537)>>2)]=$23433;
      var $23434=$23432.f1;
      HEAP32[(($3538)>>2)]=$23434;
      var $23435=HEAP32[(($3538)>>2)];
      var $23436=(($23435)|0) < 0;
      if ($23436) { __label__ = 3684; break; } else { __label__ = 3685; break; }
    case 3684: // $23437
      var $23438=HEAP32[(($3537)>>2)];
      ___cxa_call_unexpected($23438);
      throw "Reached an unreachable!"
    case 3685: // $23439
      var $23440=HEAP32[(($3537)>>2)];
      var $23441=HEAP32[(($3537)>>2)];
      var $23442=HEAP32[(($3538)>>2)];
      var $23443=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23441, tempValue);
      var $23444=($23443.f1 = $23442, $23443);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3686: // $23445
      throw "Reached an unreachable!"
    case 3687: // $_ZnwjPKci_exit460
      var $23446=HEAP32[(($result_i459)>>2)];
      var $23447=$3534;
      var $23448=$3535;
      var $23449=$3536;
      var $23450=$result_i459;
      var $23451=$3537;
      var $23452=$3538;
      var $23453=$23446;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6533, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3688; break; } else { __label__ = 12831; break; }
    case 3688: // $23454
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6534, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3689; break; } else { __label__ = 12831; break; }
    case 3689: // $23455
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6535, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3690; break; } else { __label__ = 12831; break; }
    case 3690: // $23456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3691; break; } else { __label__ = 12831; break; }
    case 3691: // $23457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3692; break; } else { __label__ = 12831; break; }
    case 3692: // $23458
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3693; break; } else { __label__ = 12831; break; }
    case 3693: // $23459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3694; break; } else { __label__ = 12831; break; }
    case 3694: // $23460
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6532, $6533, $6534, $6535, $6536, $6537, $6538, $6539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3695; break; } else { __label__ = 12831; break; }
    case 3695: // $23461
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23453, 53, 5, 4, ((STRING_TABLE.__str651)|0), ((STRING_TABLE.__str652)|0), $6532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3696; break; } else { __label__ = 12831; break; }
    case 3696: // $23462
      var $23463=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23453);
      var $23464=__ZN11simple_listI16input_type_entryE6appendERS0_($23414, $23463);
      var $23465=$4689;
      var $23466=$3529;
      var $23467=$3530;
      var $23468=$3531;
      var $23469=$result_i461;
      var $23470=$3532;
      var $23471=$3533;
      HEAP32[(($3529)>>2)]=408;
      HEAP32[(($3530)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3531)>>2)]=289;
      var $23472=HEAP32[(($3529)>>2)];
      var $23473=HEAP32[(($3530)>>2)];
      var $23474=HEAP32[(($3531)>>2)];
      var $23475=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23472, $23473, $23474) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3697; break; } else { __label__ = 3699; break; };
    case 3697: // $23476
      HEAP32[(($result_i461)>>2)]=$23475;
      var $23477=HEAP32[(($result_i461)>>2)];
      var $23478=(($23477)|0)==0;
      if ($23478) { __label__ = 3698; break; } else { __label__ = 3703; break; }
    case 3698: // $23479
      var $23480=___cxa_allocate_exception(4);
      var $23481=$23480;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23481);
      (function() { try { __THREW__ = false; return ___cxa_throw($23480, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3702; break; } else { __label__ = 3699; break; }
    case 3699: // $23482
      var $23483=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23484=$23483.f0;
      HEAP32[(($3532)>>2)]=$23484;
      var $23485=$23483.f1;
      HEAP32[(($3533)>>2)]=$23485;
      var $23486=HEAP32[(($3533)>>2)];
      var $23487=(($23486)|0) < 0;
      if ($23487) { __label__ = 3700; break; } else { __label__ = 3701; break; }
    case 3700: // $23488
      var $23489=HEAP32[(($3532)>>2)];
      ___cxa_call_unexpected($23489);
      throw "Reached an unreachable!"
    case 3701: // $23490
      var $23491=HEAP32[(($3532)>>2)];
      var $23492=HEAP32[(($3532)>>2)];
      var $23493=HEAP32[(($3533)>>2)];
      var $23494=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23492, tempValue);
      var $23495=($23494.f1 = $23493, $23494);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3702: // $23496
      throw "Reached an unreachable!"
    case 3703: // $_ZnwjPKci_exit462
      var $23497=HEAP32[(($result_i461)>>2)];
      var $23498=$3529;
      var $23499=$3530;
      var $23500=$3531;
      var $23501=$result_i461;
      var $23502=$3532;
      var $23503=$3533;
      var $23504=$23497;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6541, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3704; break; } else { __label__ = 12836; break; }
    case 3704: // $23505
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6542, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3705; break; } else { __label__ = 12836; break; }
    case 3705: // $23506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6543, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3706; break; } else { __label__ = 12836; break; }
    case 3706: // $23507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3707; break; } else { __label__ = 12836; break; }
    case 3707: // $23508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3708; break; } else { __label__ = 12836; break; }
    case 3708: // $23509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3709; break; } else { __label__ = 12836; break; }
    case 3709: // $23510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3710; break; } else { __label__ = 12836; break; }
    case 3710: // $23511
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6540, $6541, $6542, $6543, $6544, $6545, $6546, $6547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3711; break; } else { __label__ = 12836; break; }
    case 3711: // $23512
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23504, 54, 5, 4, ((STRING_TABLE.__str653)|0), ((STRING_TABLE.__str654)|0), $6540) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3712; break; } else { __label__ = 12836; break; }
    case 3712: // $23513
      var $23514=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23504);
      var $23515=__ZN11simple_listI16input_type_entryE6appendERS0_($23465, $23514);
      var $23516=$4689;
      var $23517=$3524;
      var $23518=$3525;
      var $23519=$3526;
      var $23520=$result_i463;
      var $23521=$3527;
      var $23522=$3528;
      HEAP32[(($3524)>>2)]=408;
      HEAP32[(($3525)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3526)>>2)]=290;
      var $23523=HEAP32[(($3524)>>2)];
      var $23524=HEAP32[(($3525)>>2)];
      var $23525=HEAP32[(($3526)>>2)];
      var $23526=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23523, $23524, $23525) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3713; break; } else { __label__ = 3715; break; };
    case 3713: // $23527
      HEAP32[(($result_i463)>>2)]=$23526;
      var $23528=HEAP32[(($result_i463)>>2)];
      var $23529=(($23528)|0)==0;
      if ($23529) { __label__ = 3714; break; } else { __label__ = 3719; break; }
    case 3714: // $23530
      var $23531=___cxa_allocate_exception(4);
      var $23532=$23531;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23532);
      (function() { try { __THREW__ = false; return ___cxa_throw($23531, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3718; break; } else { __label__ = 3715; break; }
    case 3715: // $23533
      var $23534=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23535=$23534.f0;
      HEAP32[(($3527)>>2)]=$23535;
      var $23536=$23534.f1;
      HEAP32[(($3528)>>2)]=$23536;
      var $23537=HEAP32[(($3528)>>2)];
      var $23538=(($23537)|0) < 0;
      if ($23538) { __label__ = 3716; break; } else { __label__ = 3717; break; }
    case 3716: // $23539
      var $23540=HEAP32[(($3527)>>2)];
      ___cxa_call_unexpected($23540);
      throw "Reached an unreachable!"
    case 3717: // $23541
      var $23542=HEAP32[(($3527)>>2)];
      var $23543=HEAP32[(($3527)>>2)];
      var $23544=HEAP32[(($3528)>>2)];
      var $23545=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23543, tempValue);
      var $23546=($23545.f1 = $23544, $23545);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3718: // $23547
      throw "Reached an unreachable!"
    case 3719: // $_ZnwjPKci_exit464
      var $23548=HEAP32[(($result_i463)>>2)];
      var $23549=$3524;
      var $23550=$3525;
      var $23551=$3526;
      var $23552=$result_i463;
      var $23553=$3527;
      var $23554=$3528;
      var $23555=$23548;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6549, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3720; break; } else { __label__ = 12841; break; }
    case 3720: // $23556
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6550, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3721; break; } else { __label__ = 12841; break; }
    case 3721: // $23557
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6551, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3722; break; } else { __label__ = 12841; break; }
    case 3722: // $23558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6552, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3723; break; } else { __label__ = 12841; break; }
    case 3723: // $23559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6553, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3724; break; } else { __label__ = 12841; break; }
    case 3724: // $23560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6554, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3725; break; } else { __label__ = 12841; break; }
    case 3725: // $23561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6555, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3726; break; } else { __label__ = 12841; break; }
    case 3726: // $23562
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6548, $6549, $6550, $6551, $6552, $6553, $6554, $6555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3727; break; } else { __label__ = 12841; break; }
    case 3727: // $23563
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23555, 55, 5, 4, ((STRING_TABLE.__str655)|0), ((STRING_TABLE.__str656)|0), $6548) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3728; break; } else { __label__ = 12841; break; }
    case 3728: // $23564
      var $23565=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23555);
      var $23566=__ZN11simple_listI16input_type_entryE6appendERS0_($23516, $23565);
      var $23567=$4689;
      var $23568=$3519;
      var $23569=$3520;
      var $23570=$3521;
      var $23571=$result_i465;
      var $23572=$3522;
      var $23573=$3523;
      HEAP32[(($3519)>>2)]=408;
      HEAP32[(($3520)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3521)>>2)]=291;
      var $23574=HEAP32[(($3519)>>2)];
      var $23575=HEAP32[(($3520)>>2)];
      var $23576=HEAP32[(($3521)>>2)];
      var $23577=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23574, $23575, $23576) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3729; break; } else { __label__ = 3731; break; };
    case 3729: // $23578
      HEAP32[(($result_i465)>>2)]=$23577;
      var $23579=HEAP32[(($result_i465)>>2)];
      var $23580=(($23579)|0)==0;
      if ($23580) { __label__ = 3730; break; } else { __label__ = 3735; break; }
    case 3730: // $23581
      var $23582=___cxa_allocate_exception(4);
      var $23583=$23582;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23583);
      (function() { try { __THREW__ = false; return ___cxa_throw($23582, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3734; break; } else { __label__ = 3731; break; }
    case 3731: // $23584
      var $23585=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23586=$23585.f0;
      HEAP32[(($3522)>>2)]=$23586;
      var $23587=$23585.f1;
      HEAP32[(($3523)>>2)]=$23587;
      var $23588=HEAP32[(($3523)>>2)];
      var $23589=(($23588)|0) < 0;
      if ($23589) { __label__ = 3732; break; } else { __label__ = 3733; break; }
    case 3732: // $23590
      var $23591=HEAP32[(($3522)>>2)];
      ___cxa_call_unexpected($23591);
      throw "Reached an unreachable!"
    case 3733: // $23592
      var $23593=HEAP32[(($3522)>>2)];
      var $23594=HEAP32[(($3522)>>2)];
      var $23595=HEAP32[(($3523)>>2)];
      var $23596=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23594, tempValue);
      var $23597=($23596.f1 = $23595, $23596);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3734: // $23598
      throw "Reached an unreachable!"
    case 3735: // $_ZnwjPKci_exit466
      var $23599=HEAP32[(($result_i465)>>2)];
      var $23600=$3519;
      var $23601=$3520;
      var $23602=$3521;
      var $23603=$result_i465;
      var $23604=$3522;
      var $23605=$3523;
      var $23606=$23599;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6557, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3736; break; } else { __label__ = 12846; break; }
    case 3736: // $23607
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6558, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3737; break; } else { __label__ = 12846; break; }
    case 3737: // $23608
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6559, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3738; break; } else { __label__ = 12846; break; }
    case 3738: // $23609
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6560, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3739; break; } else { __label__ = 12846; break; }
    case 3739: // $23610
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6561, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3740; break; } else { __label__ = 12846; break; }
    case 3740: // $23611
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6562, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3741; break; } else { __label__ = 12846; break; }
    case 3741: // $23612
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6563, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3742; break; } else { __label__ = 12846; break; }
    case 3742: // $23613
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6556, $6557, $6558, $6559, $6560, $6561, $6562, $6563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3743; break; } else { __label__ = 12846; break; }
    case 3743: // $23614
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23606, 56, 5, 4, ((STRING_TABLE.__str657)|0), ((STRING_TABLE.__str658)|0), $6556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3744; break; } else { __label__ = 12846; break; }
    case 3744: // $23615
      var $23616=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23606);
      var $23617=__ZN11simple_listI16input_type_entryE6appendERS0_($23567, $23616);
      var $23618=$4689;
      var $23619=$3514;
      var $23620=$3515;
      var $23621=$3516;
      var $23622=$result_i467;
      var $23623=$3517;
      var $23624=$3518;
      HEAP32[(($3514)>>2)]=408;
      HEAP32[(($3515)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3516)>>2)]=292;
      var $23625=HEAP32[(($3514)>>2)];
      var $23626=HEAP32[(($3515)>>2)];
      var $23627=HEAP32[(($3516)>>2)];
      var $23628=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23625, $23626, $23627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3745; break; } else { __label__ = 3747; break; };
    case 3745: // $23629
      HEAP32[(($result_i467)>>2)]=$23628;
      var $23630=HEAP32[(($result_i467)>>2)];
      var $23631=(($23630)|0)==0;
      if ($23631) { __label__ = 3746; break; } else { __label__ = 3751; break; }
    case 3746: // $23632
      var $23633=___cxa_allocate_exception(4);
      var $23634=$23633;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23634);
      (function() { try { __THREW__ = false; return ___cxa_throw($23633, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3750; break; } else { __label__ = 3747; break; }
    case 3747: // $23635
      var $23636=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23637=$23636.f0;
      HEAP32[(($3517)>>2)]=$23637;
      var $23638=$23636.f1;
      HEAP32[(($3518)>>2)]=$23638;
      var $23639=HEAP32[(($3518)>>2)];
      var $23640=(($23639)|0) < 0;
      if ($23640) { __label__ = 3748; break; } else { __label__ = 3749; break; }
    case 3748: // $23641
      var $23642=HEAP32[(($3517)>>2)];
      ___cxa_call_unexpected($23642);
      throw "Reached an unreachable!"
    case 3749: // $23643
      var $23644=HEAP32[(($3517)>>2)];
      var $23645=HEAP32[(($3517)>>2)];
      var $23646=HEAP32[(($3518)>>2)];
      var $23647=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23645, tempValue);
      var $23648=($23647.f1 = $23646, $23647);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3750: // $23649
      throw "Reached an unreachable!"
    case 3751: // $_ZnwjPKci_exit468
      var $23650=HEAP32[(($result_i467)>>2)];
      var $23651=$3514;
      var $23652=$3515;
      var $23653=$3516;
      var $23654=$result_i467;
      var $23655=$3517;
      var $23656=$3518;
      var $23657=$23650;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6565, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3752; break; } else { __label__ = 12851; break; }
    case 3752: // $23658
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6566, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3753; break; } else { __label__ = 12851; break; }
    case 3753: // $23659
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6567, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3754; break; } else { __label__ = 12851; break; }
    case 3754: // $23660
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6568, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3755; break; } else { __label__ = 12851; break; }
    case 3755: // $23661
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6569, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3756; break; } else { __label__ = 12851; break; }
    case 3756: // $23662
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3757; break; } else { __label__ = 12851; break; }
    case 3757: // $23663
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3758; break; } else { __label__ = 12851; break; }
    case 3758: // $23664
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6564, $6565, $6566, $6567, $6568, $6569, $6570, $6571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3759; break; } else { __label__ = 12851; break; }
    case 3759: // $23665
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23657, 57, 5, 4, ((STRING_TABLE.__str659)|0), ((STRING_TABLE.__str660)|0), $6564) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3760; break; } else { __label__ = 12851; break; }
    case 3760: // $23666
      var $23667=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23657);
      var $23668=__ZN11simple_listI16input_type_entryE6appendERS0_($23618, $23667);
      var $23669=$4689;
      var $23670=$3509;
      var $23671=$3510;
      var $23672=$3511;
      var $23673=$result_i469;
      var $23674=$3512;
      var $23675=$3513;
      HEAP32[(($3509)>>2)]=408;
      HEAP32[(($3510)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3511)>>2)]=293;
      var $23676=HEAP32[(($3509)>>2)];
      var $23677=HEAP32[(($3510)>>2)];
      var $23678=HEAP32[(($3511)>>2)];
      var $23679=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23676, $23677, $23678) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3761; break; } else { __label__ = 3763; break; };
    case 3761: // $23680
      HEAP32[(($result_i469)>>2)]=$23679;
      var $23681=HEAP32[(($result_i469)>>2)];
      var $23682=(($23681)|0)==0;
      if ($23682) { __label__ = 3762; break; } else { __label__ = 3767; break; }
    case 3762: // $23683
      var $23684=___cxa_allocate_exception(4);
      var $23685=$23684;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23685);
      (function() { try { __THREW__ = false; return ___cxa_throw($23684, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3766; break; } else { __label__ = 3763; break; }
    case 3763: // $23686
      var $23687=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23688=$23687.f0;
      HEAP32[(($3512)>>2)]=$23688;
      var $23689=$23687.f1;
      HEAP32[(($3513)>>2)]=$23689;
      var $23690=HEAP32[(($3513)>>2)];
      var $23691=(($23690)|0) < 0;
      if ($23691) { __label__ = 3764; break; } else { __label__ = 3765; break; }
    case 3764: // $23692
      var $23693=HEAP32[(($3512)>>2)];
      ___cxa_call_unexpected($23693);
      throw "Reached an unreachable!"
    case 3765: // $23694
      var $23695=HEAP32[(($3512)>>2)];
      var $23696=HEAP32[(($3512)>>2)];
      var $23697=HEAP32[(($3513)>>2)];
      var $23698=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23696, tempValue);
      var $23699=($23698.f1 = $23697, $23698);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3766: // $23700
      throw "Reached an unreachable!"
    case 3767: // $_ZnwjPKci_exit470
      var $23701=HEAP32[(($result_i469)>>2)];
      var $23702=$3509;
      var $23703=$3510;
      var $23704=$3511;
      var $23705=$result_i469;
      var $23706=$3512;
      var $23707=$3513;
      var $23708=$23701;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6573, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3768; break; } else { __label__ = 12856; break; }
    case 3768: // $23709
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6574, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3769; break; } else { __label__ = 12856; break; }
    case 3769: // $23710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6575, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3770; break; } else { __label__ = 12856; break; }
    case 3770: // $23711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6576, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3771; break; } else { __label__ = 12856; break; }
    case 3771: // $23712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6577, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3772; break; } else { __label__ = 12856; break; }
    case 3772: // $23713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3773; break; } else { __label__ = 12856; break; }
    case 3773: // $23714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3774; break; } else { __label__ = 12856; break; }
    case 3774: // $23715
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6572, $6573, $6574, $6575, $6576, $6577, $6578, $6579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3775; break; } else { __label__ = 12856; break; }
    case 3775: // $23716
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23708, 58, 5, 4, ((STRING_TABLE.__str661)|0), ((STRING_TABLE.__str662)|0), $6572) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3776; break; } else { __label__ = 12856; break; }
    case 3776: // $23717
      var $23718=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23708);
      var $23719=__ZN11simple_listI16input_type_entryE6appendERS0_($23669, $23718);
      var $23720=$4689;
      var $23721=$3504;
      var $23722=$3505;
      var $23723=$3506;
      var $23724=$result_i471;
      var $23725=$3507;
      var $23726=$3508;
      HEAP32[(($3504)>>2)]=408;
      HEAP32[(($3505)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3506)>>2)]=294;
      var $23727=HEAP32[(($3504)>>2)];
      var $23728=HEAP32[(($3505)>>2)];
      var $23729=HEAP32[(($3506)>>2)];
      var $23730=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23727, $23728, $23729) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3777; break; } else { __label__ = 3779; break; };
    case 3777: // $23731
      HEAP32[(($result_i471)>>2)]=$23730;
      var $23732=HEAP32[(($result_i471)>>2)];
      var $23733=(($23732)|0)==0;
      if ($23733) { __label__ = 3778; break; } else { __label__ = 3783; break; }
    case 3778: // $23734
      var $23735=___cxa_allocate_exception(4);
      var $23736=$23735;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23736);
      (function() { try { __THREW__ = false; return ___cxa_throw($23735, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3782; break; } else { __label__ = 3779; break; }
    case 3779: // $23737
      var $23738=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23739=$23738.f0;
      HEAP32[(($3507)>>2)]=$23739;
      var $23740=$23738.f1;
      HEAP32[(($3508)>>2)]=$23740;
      var $23741=HEAP32[(($3508)>>2)];
      var $23742=(($23741)|0) < 0;
      if ($23742) { __label__ = 3780; break; } else { __label__ = 3781; break; }
    case 3780: // $23743
      var $23744=HEAP32[(($3507)>>2)];
      ___cxa_call_unexpected($23744);
      throw "Reached an unreachable!"
    case 3781: // $23745
      var $23746=HEAP32[(($3507)>>2)];
      var $23747=HEAP32[(($3507)>>2)];
      var $23748=HEAP32[(($3508)>>2)];
      var $23749=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23747, tempValue);
      var $23750=($23749.f1 = $23748, $23749);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3782: // $23751
      throw "Reached an unreachable!"
    case 3783: // $_ZnwjPKci_exit472
      var $23752=HEAP32[(($result_i471)>>2)];
      var $23753=$3504;
      var $23754=$3505;
      var $23755=$3506;
      var $23756=$result_i471;
      var $23757=$3507;
      var $23758=$3508;
      var $23759=$23752;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6581, 4, 4, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3784; break; } else { __label__ = 12861; break; }
    case 3784: // $23760
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6582, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3785; break; } else { __label__ = 12861; break; }
    case 3785: // $23761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6583, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3786; break; } else { __label__ = 12861; break; }
    case 3786: // $23762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3787; break; } else { __label__ = 12861; break; }
    case 3787: // $23763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3788; break; } else { __label__ = 12861; break; }
    case 3788: // $23764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3789; break; } else { __label__ = 12861; break; }
    case 3789: // $23765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3790; break; } else { __label__ = 12861; break; }
    case 3790: // $23766
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6580, $6581, $6582, $6583, $6584, $6585, $6586, $6587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3791; break; } else { __label__ = 12861; break; }
    case 3791: // $23767
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23759, 59, 5, 4, ((STRING_TABLE.__str663)|0), ((STRING_TABLE.__str664)|0), $6580) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3792; break; } else { __label__ = 12861; break; }
    case 3792: // $23768
      var $23769=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23759);
      var $23770=__ZN11simple_listI16input_type_entryE6appendERS0_($23720, $23769);
      var $23771=$4689;
      var $23772=$3499;
      var $23773=$3500;
      var $23774=$3501;
      var $23775=$result_i473;
      var $23776=$3502;
      var $23777=$3503;
      HEAP32[(($3499)>>2)]=408;
      HEAP32[(($3500)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3501)>>2)]=295;
      var $23778=HEAP32[(($3499)>>2)];
      var $23779=HEAP32[(($3500)>>2)];
      var $23780=HEAP32[(($3501)>>2)];
      var $23781=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23778, $23779, $23780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3793; break; } else { __label__ = 3795; break; };
    case 3793: // $23782
      HEAP32[(($result_i473)>>2)]=$23781;
      var $23783=HEAP32[(($result_i473)>>2)];
      var $23784=(($23783)|0)==0;
      if ($23784) { __label__ = 3794; break; } else { __label__ = 3799; break; }
    case 3794: // $23785
      var $23786=___cxa_allocate_exception(4);
      var $23787=$23786;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23787);
      (function() { try { __THREW__ = false; return ___cxa_throw($23786, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3798; break; } else { __label__ = 3795; break; }
    case 3795: // $23788
      var $23789=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23790=$23789.f0;
      HEAP32[(($3502)>>2)]=$23790;
      var $23791=$23789.f1;
      HEAP32[(($3503)>>2)]=$23791;
      var $23792=HEAP32[(($3503)>>2)];
      var $23793=(($23792)|0) < 0;
      if ($23793) { __label__ = 3796; break; } else { __label__ = 3797; break; }
    case 3796: // $23794
      var $23795=HEAP32[(($3502)>>2)];
      ___cxa_call_unexpected($23795);
      throw "Reached an unreachable!"
    case 3797: // $23796
      var $23797=HEAP32[(($3502)>>2)];
      var $23798=HEAP32[(($3502)>>2)];
      var $23799=HEAP32[(($3503)>>2)];
      var $23800=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23798, tempValue);
      var $23801=($23800.f1 = $23799, $23800);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3798: // $23802
      throw "Reached an unreachable!"
    case 3799: // $_ZnwjPKci_exit474
      var $23803=HEAP32[(($result_i473)>>2)];
      var $23804=$3499;
      var $23805=$3500;
      var $23806=$3501;
      var $23807=$result_i473;
      var $23808=$3502;
      var $23809=$3503;
      var $23810=$23803;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6589, 4, 4, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3800; break; } else { __label__ = 12866; break; }
    case 3800: // $23811
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6590, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3801; break; } else { __label__ = 12866; break; }
    case 3801: // $23812
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6591, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3802; break; } else { __label__ = 12866; break; }
    case 3802: // $23813
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3803; break; } else { __label__ = 12866; break; }
    case 3803: // $23814
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3804; break; } else { __label__ = 12866; break; }
    case 3804: // $23815
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3805; break; } else { __label__ = 12866; break; }
    case 3805: // $23816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3806; break; } else { __label__ = 12866; break; }
    case 3806: // $23817
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6588, $6589, $6590, $6591, $6592, $6593, $6594, $6595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3807; break; } else { __label__ = 12866; break; }
    case 3807: // $23818
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23810, 60, 5, 4, ((STRING_TABLE.__str665)|0), ((STRING_TABLE.__str666)|0), $6588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3808; break; } else { __label__ = 12866; break; }
    case 3808: // $23819
      var $23820=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23810);
      var $23821=__ZN11simple_listI16input_type_entryE6appendERS0_($23771, $23820);
      var $23822=$4689;
      var $23823=$3494;
      var $23824=$3495;
      var $23825=$3496;
      var $23826=$result_i475;
      var $23827=$3497;
      var $23828=$3498;
      HEAP32[(($3494)>>2)]=408;
      HEAP32[(($3495)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3496)>>2)]=296;
      var $23829=HEAP32[(($3494)>>2)];
      var $23830=HEAP32[(($3495)>>2)];
      var $23831=HEAP32[(($3496)>>2)];
      var $23832=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23829, $23830, $23831) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3809; break; } else { __label__ = 3811; break; };
    case 3809: // $23833
      HEAP32[(($result_i475)>>2)]=$23832;
      var $23834=HEAP32[(($result_i475)>>2)];
      var $23835=(($23834)|0)==0;
      if ($23835) { __label__ = 3810; break; } else { __label__ = 3815; break; }
    case 3810: // $23836
      var $23837=___cxa_allocate_exception(4);
      var $23838=$23837;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23838);
      (function() { try { __THREW__ = false; return ___cxa_throw($23837, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3814; break; } else { __label__ = 3811; break; }
    case 3811: // $23839
      var $23840=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23841=$23840.f0;
      HEAP32[(($3497)>>2)]=$23841;
      var $23842=$23840.f1;
      HEAP32[(($3498)>>2)]=$23842;
      var $23843=HEAP32[(($3498)>>2)];
      var $23844=(($23843)|0) < 0;
      if ($23844) { __label__ = 3812; break; } else { __label__ = 3813; break; }
    case 3812: // $23845
      var $23846=HEAP32[(($3497)>>2)];
      ___cxa_call_unexpected($23846);
      throw "Reached an unreachable!"
    case 3813: // $23847
      var $23848=HEAP32[(($3497)>>2)];
      var $23849=HEAP32[(($3497)>>2)];
      var $23850=HEAP32[(($3498)>>2)];
      var $23851=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23849, tempValue);
      var $23852=($23851.f1 = $23850, $23851);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3814: // $23853
      throw "Reached an unreachable!"
    case 3815: // $_ZnwjPKci_exit476
      var $23854=HEAP32[(($result_i475)>>2)];
      var $23855=$3494;
      var $23856=$3495;
      var $23857=$3496;
      var $23858=$result_i475;
      var $23859=$3497;
      var $23860=$3498;
      var $23861=$23854;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6597, 4, 4, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3816; break; } else { __label__ = 12871; break; }
    case 3816: // $23862
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6598, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3817; break; } else { __label__ = 12871; break; }
    case 3817: // $23863
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6599, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3818; break; } else { __label__ = 12871; break; }
    case 3818: // $23864
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6600, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3819; break; } else { __label__ = 12871; break; }
    case 3819: // $23865
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6601, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3820; break; } else { __label__ = 12871; break; }
    case 3820: // $23866
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3821; break; } else { __label__ = 12871; break; }
    case 3821: // $23867
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3822; break; } else { __label__ = 12871; break; }
    case 3822: // $23868
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6596, $6597, $6598, $6599, $6600, $6601, $6602, $6603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3823; break; } else { __label__ = 12871; break; }
    case 3823: // $23869
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23861, 61, 5, 4, ((STRING_TABLE.__str667)|0), ((STRING_TABLE.__str668)|0), $6596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3824; break; } else { __label__ = 12871; break; }
    case 3824: // $23870
      var $23871=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23861);
      var $23872=__ZN11simple_listI16input_type_entryE6appendERS0_($23822, $23871);
      var $23873=$4689;
      var $23874=$3489;
      var $23875=$3490;
      var $23876=$3491;
      var $23877=$result_i477;
      var $23878=$3492;
      var $23879=$3493;
      HEAP32[(($3489)>>2)]=408;
      HEAP32[(($3490)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3491)>>2)]=297;
      var $23880=HEAP32[(($3489)>>2)];
      var $23881=HEAP32[(($3490)>>2)];
      var $23882=HEAP32[(($3491)>>2)];
      var $23883=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23880, $23881, $23882) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3825; break; } else { __label__ = 3827; break; };
    case 3825: // $23884
      HEAP32[(($result_i477)>>2)]=$23883;
      var $23885=HEAP32[(($result_i477)>>2)];
      var $23886=(($23885)|0)==0;
      if ($23886) { __label__ = 3826; break; } else { __label__ = 3831; break; }
    case 3826: // $23887
      var $23888=___cxa_allocate_exception(4);
      var $23889=$23888;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23889);
      (function() { try { __THREW__ = false; return ___cxa_throw($23888, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3830; break; } else { __label__ = 3827; break; }
    case 3827: // $23890
      var $23891=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23892=$23891.f0;
      HEAP32[(($3492)>>2)]=$23892;
      var $23893=$23891.f1;
      HEAP32[(($3493)>>2)]=$23893;
      var $23894=HEAP32[(($3493)>>2)];
      var $23895=(($23894)|0) < 0;
      if ($23895) { __label__ = 3828; break; } else { __label__ = 3829; break; }
    case 3828: // $23896
      var $23897=HEAP32[(($3492)>>2)];
      ___cxa_call_unexpected($23897);
      throw "Reached an unreachable!"
    case 3829: // $23898
      var $23899=HEAP32[(($3492)>>2)];
      var $23900=HEAP32[(($3492)>>2)];
      var $23901=HEAP32[(($3493)>>2)];
      var $23902=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23900, tempValue);
      var $23903=($23902.f1 = $23901, $23902);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3830: // $23904
      throw "Reached an unreachable!"
    case 3831: // $_ZnwjPKci_exit478
      var $23905=HEAP32[(($result_i477)>>2)];
      var $23906=$3489;
      var $23907=$3490;
      var $23908=$3491;
      var $23909=$result_i477;
      var $23910=$3492;
      var $23911=$3493;
      var $23912=$23905;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6605, 4, 4, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3832; break; } else { __label__ = 12876; break; }
    case 3832: // $23913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6606, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3833; break; } else { __label__ = 12876; break; }
    case 3833: // $23914
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6607, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3834; break; } else { __label__ = 12876; break; }
    case 3834: // $23915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3835; break; } else { __label__ = 12876; break; }
    case 3835: // $23916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3836; break; } else { __label__ = 12876; break; }
    case 3836: // $23917
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3837; break; } else { __label__ = 12876; break; }
    case 3837: // $23918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3838; break; } else { __label__ = 12876; break; }
    case 3838: // $23919
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6604, $6605, $6606, $6607, $6608, $6609, $6610, $6611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3839; break; } else { __label__ = 12876; break; }
    case 3839: // $23920
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23912, 62, 5, 4, ((STRING_TABLE.__str669)|0), ((STRING_TABLE.__str670)|0), $6604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3840; break; } else { __label__ = 12876; break; }
    case 3840: // $23921
      var $23922=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23912);
      var $23923=__ZN11simple_listI16input_type_entryE6appendERS0_($23873, $23922);
      var $23924=$4689;
      var $23925=$3484;
      var $23926=$3485;
      var $23927=$3486;
      var $23928=$result_i479;
      var $23929=$3487;
      var $23930=$3488;
      HEAP32[(($3484)>>2)]=408;
      HEAP32[(($3485)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3486)>>2)]=298;
      var $23931=HEAP32[(($3484)>>2)];
      var $23932=HEAP32[(($3485)>>2)];
      var $23933=HEAP32[(($3486)>>2)];
      var $23934=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23931, $23932, $23933) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3841; break; } else { __label__ = 3843; break; };
    case 3841: // $23935
      HEAP32[(($result_i479)>>2)]=$23934;
      var $23936=HEAP32[(($result_i479)>>2)];
      var $23937=(($23936)|0)==0;
      if ($23937) { __label__ = 3842; break; } else { __label__ = 3847; break; }
    case 3842: // $23938
      var $23939=___cxa_allocate_exception(4);
      var $23940=$23939;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23940);
      (function() { try { __THREW__ = false; return ___cxa_throw($23939, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3846; break; } else { __label__ = 3843; break; }
    case 3843: // $23941
      var $23942=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23943=$23942.f0;
      HEAP32[(($3487)>>2)]=$23943;
      var $23944=$23942.f1;
      HEAP32[(($3488)>>2)]=$23944;
      var $23945=HEAP32[(($3488)>>2)];
      var $23946=(($23945)|0) < 0;
      if ($23946) { __label__ = 3844; break; } else { __label__ = 3845; break; }
    case 3844: // $23947
      var $23948=HEAP32[(($3487)>>2)];
      ___cxa_call_unexpected($23948);
      throw "Reached an unreachable!"
    case 3845: // $23949
      var $23950=HEAP32[(($3487)>>2)];
      var $23951=HEAP32[(($3487)>>2)];
      var $23952=HEAP32[(($3488)>>2)];
      var $23953=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23951, tempValue);
      var $23954=($23953.f1 = $23952, $23953);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3846: // $23955
      throw "Reached an unreachable!"
    case 3847: // $_ZnwjPKci_exit480
      var $23956=HEAP32[(($result_i479)>>2)];
      var $23957=$3484;
      var $23958=$3485;
      var $23959=$3486;
      var $23960=$result_i479;
      var $23961=$3487;
      var $23962=$3488;
      var $23963=$23956;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6613, 4, 4, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3848; break; } else { __label__ = 12881; break; }
    case 3848: // $23964
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6614, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3849; break; } else { __label__ = 12881; break; }
    case 3849: // $23965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6615, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3850; break; } else { __label__ = 12881; break; }
    case 3850: // $23966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3851; break; } else { __label__ = 12881; break; }
    case 3851: // $23967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3852; break; } else { __label__ = 12881; break; }
    case 3852: // $23968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3853; break; } else { __label__ = 12881; break; }
    case 3853: // $23969
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3854; break; } else { __label__ = 12881; break; }
    case 3854: // $23970
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6612, $6613, $6614, $6615, $6616, $6617, $6618, $6619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3855; break; } else { __label__ = 12881; break; }
    case 3855: // $23971
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($23963, 63, 5, 4, ((STRING_TABLE.__str671)|0), ((STRING_TABLE.__str672)|0), $6612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3856; break; } else { __label__ = 12881; break; }
    case 3856: // $23972
      var $23973=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $23963);
      var $23974=__ZN11simple_listI16input_type_entryE6appendERS0_($23924, $23973);
      var $23975=$4689;
      var $23976=$3479;
      var $23977=$3480;
      var $23978=$3481;
      var $23979=$result_i481;
      var $23980=$3482;
      var $23981=$3483;
      HEAP32[(($3479)>>2)]=408;
      HEAP32[(($3480)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3481)>>2)]=299;
      var $23982=HEAP32[(($3479)>>2)];
      var $23983=HEAP32[(($3480)>>2)];
      var $23984=HEAP32[(($3481)>>2)];
      var $23985=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23982, $23983, $23984) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3857; break; } else { __label__ = 3859; break; };
    case 3857: // $23986
      HEAP32[(($result_i481)>>2)]=$23985;
      var $23987=HEAP32[(($result_i481)>>2)];
      var $23988=(($23987)|0)==0;
      if ($23988) { __label__ = 3858; break; } else { __label__ = 3863; break; }
    case 3858: // $23989
      var $23990=___cxa_allocate_exception(4);
      var $23991=$23990;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23991);
      (function() { try { __THREW__ = false; return ___cxa_throw($23990, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3862; break; } else { __label__ = 3859; break; }
    case 3859: // $23992
      var $23993=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23994=$23993.f0;
      HEAP32[(($3482)>>2)]=$23994;
      var $23995=$23993.f1;
      HEAP32[(($3483)>>2)]=$23995;
      var $23996=HEAP32[(($3483)>>2)];
      var $23997=(($23996)|0) < 0;
      if ($23997) { __label__ = 3860; break; } else { __label__ = 3861; break; }
    case 3860: // $23998
      var $23999=HEAP32[(($3482)>>2)];
      ___cxa_call_unexpected($23999);
      throw "Reached an unreachable!"
    case 3861: // $24000
      var $24001=HEAP32[(($3482)>>2)];
      var $24002=HEAP32[(($3482)>>2)];
      var $24003=HEAP32[(($3483)>>2)];
      var $24004=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24002, tempValue);
      var $24005=($24004.f1 = $24003, $24004);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3862: // $24006
      throw "Reached an unreachable!"
    case 3863: // $_ZnwjPKci_exit482
      var $24007=HEAP32[(($result_i481)>>2)];
      var $24008=$3479;
      var $24009=$3480;
      var $24010=$3481;
      var $24011=$result_i481;
      var $24012=$3482;
      var $24013=$3483;
      var $24014=$24007;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6621, 4, 4, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3864; break; } else { __label__ = 12886; break; }
    case 3864: // $24015
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6622, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3865; break; } else { __label__ = 12886; break; }
    case 3865: // $24016
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6623, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3866; break; } else { __label__ = 12886; break; }
    case 3866: // $24017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6624, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3867; break; } else { __label__ = 12886; break; }
    case 3867: // $24018
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6625, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3868; break; } else { __label__ = 12886; break; }
    case 3868: // $24019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3869; break; } else { __label__ = 12886; break; }
    case 3869: // $24020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3870; break; } else { __label__ = 12886; break; }
    case 3870: // $24021
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6620, $6621, $6622, $6623, $6624, $6625, $6626, $6627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3871; break; } else { __label__ = 12886; break; }
    case 3871: // $24022
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24014, 64, 5, 4, ((STRING_TABLE.__str673)|0), ((STRING_TABLE.__str674)|0), $6620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3872; break; } else { __label__ = 12886; break; }
    case 3872: // $24023
      var $24024=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24014);
      var $24025=__ZN11simple_listI16input_type_entryE6appendERS0_($23975, $24024);
      var $24026=$4689;
      var $24027=$3474;
      var $24028=$3475;
      var $24029=$3476;
      var $24030=$result_i483;
      var $24031=$3477;
      var $24032=$3478;
      HEAP32[(($3474)>>2)]=408;
      HEAP32[(($3475)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3476)>>2)]=300;
      var $24033=HEAP32[(($3474)>>2)];
      var $24034=HEAP32[(($3475)>>2)];
      var $24035=HEAP32[(($3476)>>2)];
      var $24036=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24033, $24034, $24035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3873; break; } else { __label__ = 3875; break; };
    case 3873: // $24037
      HEAP32[(($result_i483)>>2)]=$24036;
      var $24038=HEAP32[(($result_i483)>>2)];
      var $24039=(($24038)|0)==0;
      if ($24039) { __label__ = 3874; break; } else { __label__ = 3879; break; }
    case 3874: // $24040
      var $24041=___cxa_allocate_exception(4);
      var $24042=$24041;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24042);
      (function() { try { __THREW__ = false; return ___cxa_throw($24041, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3878; break; } else { __label__ = 3875; break; }
    case 3875: // $24043
      var $24044=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24045=$24044.f0;
      HEAP32[(($3477)>>2)]=$24045;
      var $24046=$24044.f1;
      HEAP32[(($3478)>>2)]=$24046;
      var $24047=HEAP32[(($3478)>>2)];
      var $24048=(($24047)|0) < 0;
      if ($24048) { __label__ = 3876; break; } else { __label__ = 3877; break; }
    case 3876: // $24049
      var $24050=HEAP32[(($3477)>>2)];
      ___cxa_call_unexpected($24050);
      throw "Reached an unreachable!"
    case 3877: // $24051
      var $24052=HEAP32[(($3477)>>2)];
      var $24053=HEAP32[(($3477)>>2)];
      var $24054=HEAP32[(($3478)>>2)];
      var $24055=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24053, tempValue);
      var $24056=($24055.f1 = $24054, $24055);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3878: // $24057
      throw "Reached an unreachable!"
    case 3879: // $_ZnwjPKci_exit484
      var $24058=HEAP32[(($result_i483)>>2)];
      var $24059=$3474;
      var $24060=$3475;
      var $24061=$3476;
      var $24062=$result_i483;
      var $24063=$3477;
      var $24064=$3478;
      var $24065=$24058;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6629, 4, 4, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3880; break; } else { __label__ = 12891; break; }
    case 3880: // $24066
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6630, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3881; break; } else { __label__ = 12891; break; }
    case 3881: // $24067
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6631, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3882; break; } else { __label__ = 12891; break; }
    case 3882: // $24068
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3883; break; } else { __label__ = 12891; break; }
    case 3883: // $24069
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3884; break; } else { __label__ = 12891; break; }
    case 3884: // $24070
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3885; break; } else { __label__ = 12891; break; }
    case 3885: // $24071
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3886; break; } else { __label__ = 12891; break; }
    case 3886: // $24072
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6628, $6629, $6630, $6631, $6632, $6633, $6634, $6635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3887; break; } else { __label__ = 12891; break; }
    case 3887: // $24073
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24065, 65, 5, 4, ((STRING_TABLE.__str675414)|0), ((STRING_TABLE.__str676)|0), $6628) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3888; break; } else { __label__ = 12891; break; }
    case 3888: // $24074
      var $24075=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24065);
      var $24076=__ZN11simple_listI16input_type_entryE6appendERS0_($24026, $24075);
      var $24077=$4689;
      var $24078=$3469;
      var $24079=$3470;
      var $24080=$3471;
      var $24081=$result_i485;
      var $24082=$3472;
      var $24083=$3473;
      HEAP32[(($3469)>>2)]=408;
      HEAP32[(($3470)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3471)>>2)]=301;
      var $24084=HEAP32[(($3469)>>2)];
      var $24085=HEAP32[(($3470)>>2)];
      var $24086=HEAP32[(($3471)>>2)];
      var $24087=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24084, $24085, $24086) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3889; break; } else { __label__ = 3891; break; };
    case 3889: // $24088
      HEAP32[(($result_i485)>>2)]=$24087;
      var $24089=HEAP32[(($result_i485)>>2)];
      var $24090=(($24089)|0)==0;
      if ($24090) { __label__ = 3890; break; } else { __label__ = 3895; break; }
    case 3890: // $24091
      var $24092=___cxa_allocate_exception(4);
      var $24093=$24092;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24093);
      (function() { try { __THREW__ = false; return ___cxa_throw($24092, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3894; break; } else { __label__ = 3891; break; }
    case 3891: // $24094
      var $24095=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24096=$24095.f0;
      HEAP32[(($3472)>>2)]=$24096;
      var $24097=$24095.f1;
      HEAP32[(($3473)>>2)]=$24097;
      var $24098=HEAP32[(($3473)>>2)];
      var $24099=(($24098)|0) < 0;
      if ($24099) { __label__ = 3892; break; } else { __label__ = 3893; break; }
    case 3892: // $24100
      var $24101=HEAP32[(($3472)>>2)];
      ___cxa_call_unexpected($24101);
      throw "Reached an unreachable!"
    case 3893: // $24102
      var $24103=HEAP32[(($3472)>>2)];
      var $24104=HEAP32[(($3472)>>2)];
      var $24105=HEAP32[(($3473)>>2)];
      var $24106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24104, tempValue);
      var $24107=($24106.f1 = $24105, $24106);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3894: // $24108
      throw "Reached an unreachable!"
    case 3895: // $_ZnwjPKci_exit486
      var $24109=HEAP32[(($result_i485)>>2)];
      var $24110=$3469;
      var $24111=$3470;
      var $24112=$3471;
      var $24113=$result_i485;
      var $24114=$3472;
      var $24115=$3473;
      var $24116=$24109;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6637, 4, 4, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3896; break; } else { __label__ = 12896; break; }
    case 3896: // $24117
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6638, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3897; break; } else { __label__ = 12896; break; }
    case 3897: // $24118
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6639, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3898; break; } else { __label__ = 12896; break; }
    case 3898: // $24119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3899; break; } else { __label__ = 12896; break; }
    case 3899: // $24120
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3900; break; } else { __label__ = 12896; break; }
    case 3900: // $24121
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3901; break; } else { __label__ = 12896; break; }
    case 3901: // $24122
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3902; break; } else { __label__ = 12896; break; }
    case 3902: // $24123
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6636, $6637, $6638, $6639, $6640, $6641, $6642, $6643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3903; break; } else { __label__ = 12896; break; }
    case 3903: // $24124
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24116, 66, 5, 4, ((STRING_TABLE.__str677)|0), ((STRING_TABLE.__str678)|0), $6636) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3904; break; } else { __label__ = 12896; break; }
    case 3904: // $24125
      var $24126=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24116);
      var $24127=__ZN11simple_listI16input_type_entryE6appendERS0_($24077, $24126);
      var $24128=$4689;
      var $24129=$3464;
      var $24130=$3465;
      var $24131=$3466;
      var $24132=$result_i487;
      var $24133=$3467;
      var $24134=$3468;
      HEAP32[(($3464)>>2)]=408;
      HEAP32[(($3465)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3466)>>2)]=302;
      var $24135=HEAP32[(($3464)>>2)];
      var $24136=HEAP32[(($3465)>>2)];
      var $24137=HEAP32[(($3466)>>2)];
      var $24138=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24135, $24136, $24137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3905; break; } else { __label__ = 3907; break; };
    case 3905: // $24139
      HEAP32[(($result_i487)>>2)]=$24138;
      var $24140=HEAP32[(($result_i487)>>2)];
      var $24141=(($24140)|0)==0;
      if ($24141) { __label__ = 3906; break; } else { __label__ = 3911; break; }
    case 3906: // $24142
      var $24143=___cxa_allocate_exception(4);
      var $24144=$24143;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24144);
      (function() { try { __THREW__ = false; return ___cxa_throw($24143, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3910; break; } else { __label__ = 3907; break; }
    case 3907: // $24145
      var $24146=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24147=$24146.f0;
      HEAP32[(($3467)>>2)]=$24147;
      var $24148=$24146.f1;
      HEAP32[(($3468)>>2)]=$24148;
      var $24149=HEAP32[(($3468)>>2)];
      var $24150=(($24149)|0) < 0;
      if ($24150) { __label__ = 3908; break; } else { __label__ = 3909; break; }
    case 3908: // $24151
      var $24152=HEAP32[(($3467)>>2)];
      ___cxa_call_unexpected($24152);
      throw "Reached an unreachable!"
    case 3909: // $24153
      var $24154=HEAP32[(($3467)>>2)];
      var $24155=HEAP32[(($3467)>>2)];
      var $24156=HEAP32[(($3468)>>2)];
      var $24157=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24155, tempValue);
      var $24158=($24157.f1 = $24156, $24157);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3910: // $24159
      throw "Reached an unreachable!"
    case 3911: // $_ZnwjPKci_exit488
      var $24160=HEAP32[(($result_i487)>>2)];
      var $24161=$3464;
      var $24162=$3465;
      var $24163=$3466;
      var $24164=$result_i487;
      var $24165=$3467;
      var $24166=$3468;
      var $24167=$24160;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6645, 4, 4, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3912; break; } else { __label__ = 12901; break; }
    case 3912: // $24168
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6646, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3913; break; } else { __label__ = 12901; break; }
    case 3913: // $24169
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6647, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3914; break; } else { __label__ = 12901; break; }
    case 3914: // $24170
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6648, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3915; break; } else { __label__ = 12901; break; }
    case 3915: // $24171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6649, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3916; break; } else { __label__ = 12901; break; }
    case 3916: // $24172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3917; break; } else { __label__ = 12901; break; }
    case 3917: // $24173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3918; break; } else { __label__ = 12901; break; }
    case 3918: // $24174
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6644, $6645, $6646, $6647, $6648, $6649, $6650, $6651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3919; break; } else { __label__ = 12901; break; }
    case 3919: // $24175
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24167, 67, 5, 4, ((STRING_TABLE.__str679)|0), ((STRING_TABLE.__str680)|0), $6644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3920; break; } else { __label__ = 12901; break; }
    case 3920: // $24176
      var $24177=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24167);
      var $24178=__ZN11simple_listI16input_type_entryE6appendERS0_($24128, $24177);
      var $24179=$4689;
      var $24180=$3459;
      var $24181=$3460;
      var $24182=$3461;
      var $24183=$result_i489;
      var $24184=$3462;
      var $24185=$3463;
      HEAP32[(($3459)>>2)]=408;
      HEAP32[(($3460)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3461)>>2)]=303;
      var $24186=HEAP32[(($3459)>>2)];
      var $24187=HEAP32[(($3460)>>2)];
      var $24188=HEAP32[(($3461)>>2)];
      var $24189=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24186, $24187, $24188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3921; break; } else { __label__ = 3923; break; };
    case 3921: // $24190
      HEAP32[(($result_i489)>>2)]=$24189;
      var $24191=HEAP32[(($result_i489)>>2)];
      var $24192=(($24191)|0)==0;
      if ($24192) { __label__ = 3922; break; } else { __label__ = 3927; break; }
    case 3922: // $24193
      var $24194=___cxa_allocate_exception(4);
      var $24195=$24194;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24195);
      (function() { try { __THREW__ = false; return ___cxa_throw($24194, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3926; break; } else { __label__ = 3923; break; }
    case 3923: // $24196
      var $24197=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24198=$24197.f0;
      HEAP32[(($3462)>>2)]=$24198;
      var $24199=$24197.f1;
      HEAP32[(($3463)>>2)]=$24199;
      var $24200=HEAP32[(($3463)>>2)];
      var $24201=(($24200)|0) < 0;
      if ($24201) { __label__ = 3924; break; } else { __label__ = 3925; break; }
    case 3924: // $24202
      var $24203=HEAP32[(($3462)>>2)];
      ___cxa_call_unexpected($24203);
      throw "Reached an unreachable!"
    case 3925: // $24204
      var $24205=HEAP32[(($3462)>>2)];
      var $24206=HEAP32[(($3462)>>2)];
      var $24207=HEAP32[(($3463)>>2)];
      var $24208=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24206, tempValue);
      var $24209=($24208.f1 = $24207, $24208);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3926: // $24210
      throw "Reached an unreachable!"
    case 3927: // $_ZnwjPKci_exit490
      var $24211=HEAP32[(($result_i489)>>2)];
      var $24212=$3459;
      var $24213=$3460;
      var $24214=$3461;
      var $24215=$result_i489;
      var $24216=$3462;
      var $24217=$3463;
      var $24218=$24211;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6653, 4, 4, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3928; break; } else { __label__ = 12906; break; }
    case 3928: // $24219
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6654, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3929; break; } else { __label__ = 12906; break; }
    case 3929: // $24220
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6655, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3930; break; } else { __label__ = 12906; break; }
    case 3930: // $24221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3931; break; } else { __label__ = 12906; break; }
    case 3931: // $24222
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3932; break; } else { __label__ = 12906; break; }
    case 3932: // $24223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3933; break; } else { __label__ = 12906; break; }
    case 3933: // $24224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3934; break; } else { __label__ = 12906; break; }
    case 3934: // $24225
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6652, $6653, $6654, $6655, $6656, $6657, $6658, $6659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3935; break; } else { __label__ = 12906; break; }
    case 3935: // $24226
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24218, 68, 5, 4, ((STRING_TABLE.__str681)|0), ((STRING_TABLE.__str682)|0), $6652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3936; break; } else { __label__ = 12906; break; }
    case 3936: // $24227
      var $24228=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24218);
      var $24229=__ZN11simple_listI16input_type_entryE6appendERS0_($24179, $24228);
      var $24230=$4689;
      var $24231=$3454;
      var $24232=$3455;
      var $24233=$3456;
      var $24234=$result_i491;
      var $24235=$3457;
      var $24236=$3458;
      HEAP32[(($3454)>>2)]=408;
      HEAP32[(($3455)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3456)>>2)]=304;
      var $24237=HEAP32[(($3454)>>2)];
      var $24238=HEAP32[(($3455)>>2)];
      var $24239=HEAP32[(($3456)>>2)];
      var $24240=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24237, $24238, $24239) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3937; break; } else { __label__ = 3939; break; };
    case 3937: // $24241
      HEAP32[(($result_i491)>>2)]=$24240;
      var $24242=HEAP32[(($result_i491)>>2)];
      var $24243=(($24242)|0)==0;
      if ($24243) { __label__ = 3938; break; } else { __label__ = 3943; break; }
    case 3938: // $24244
      var $24245=___cxa_allocate_exception(4);
      var $24246=$24245;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24246);
      (function() { try { __THREW__ = false; return ___cxa_throw($24245, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3942; break; } else { __label__ = 3939; break; }
    case 3939: // $24247
      var $24248=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24249=$24248.f0;
      HEAP32[(($3457)>>2)]=$24249;
      var $24250=$24248.f1;
      HEAP32[(($3458)>>2)]=$24250;
      var $24251=HEAP32[(($3458)>>2)];
      var $24252=(($24251)|0) < 0;
      if ($24252) { __label__ = 3940; break; } else { __label__ = 3941; break; }
    case 3940: // $24253
      var $24254=HEAP32[(($3457)>>2)];
      ___cxa_call_unexpected($24254);
      throw "Reached an unreachable!"
    case 3941: // $24255
      var $24256=HEAP32[(($3457)>>2)];
      var $24257=HEAP32[(($3457)>>2)];
      var $24258=HEAP32[(($3458)>>2)];
      var $24259=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24257, tempValue);
      var $24260=($24259.f1 = $24258, $24259);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3942: // $24261
      throw "Reached an unreachable!"
    case 3943: // $_ZnwjPKci_exit492
      var $24262=HEAP32[(($result_i491)>>2)];
      var $24263=$3454;
      var $24264=$3455;
      var $24265=$3456;
      var $24266=$result_i491;
      var $24267=$3457;
      var $24268=$3458;
      var $24269=$24262;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6661, 4, 4, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3944; break; } else { __label__ = 12911; break; }
    case 3944: // $24270
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6662, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3945; break; } else { __label__ = 12911; break; }
    case 3945: // $24271
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6663, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3946; break; } else { __label__ = 12911; break; }
    case 3946: // $24272
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3947; break; } else { __label__ = 12911; break; }
    case 3947: // $24273
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3948; break; } else { __label__ = 12911; break; }
    case 3948: // $24274
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3949; break; } else { __label__ = 12911; break; }
    case 3949: // $24275
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3950; break; } else { __label__ = 12911; break; }
    case 3950: // $24276
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6660, $6661, $6662, $6663, $6664, $6665, $6666, $6667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3951; break; } else { __label__ = 12911; break; }
    case 3951: // $24277
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24269, 69, 5, 4, ((STRING_TABLE.__str683)|0), ((STRING_TABLE.__str684)|0), $6660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3952; break; } else { __label__ = 12911; break; }
    case 3952: // $24278
      var $24279=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24269);
      var $24280=__ZN11simple_listI16input_type_entryE6appendERS0_($24230, $24279);
      var $24281=$4689;
      var $24282=$3449;
      var $24283=$3450;
      var $24284=$3451;
      var $24285=$result_i493;
      var $24286=$3452;
      var $24287=$3453;
      HEAP32[(($3449)>>2)]=408;
      HEAP32[(($3450)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3451)>>2)]=305;
      var $24288=HEAP32[(($3449)>>2)];
      var $24289=HEAP32[(($3450)>>2)];
      var $24290=HEAP32[(($3451)>>2)];
      var $24291=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24288, $24289, $24290) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3953; break; } else { __label__ = 3955; break; };
    case 3953: // $24292
      HEAP32[(($result_i493)>>2)]=$24291;
      var $24293=HEAP32[(($result_i493)>>2)];
      var $24294=(($24293)|0)==0;
      if ($24294) { __label__ = 3954; break; } else { __label__ = 3959; break; }
    case 3954: // $24295
      var $24296=___cxa_allocate_exception(4);
      var $24297=$24296;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24297);
      (function() { try { __THREW__ = false; return ___cxa_throw($24296, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3958; break; } else { __label__ = 3955; break; }
    case 3955: // $24298
      var $24299=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24300=$24299.f0;
      HEAP32[(($3452)>>2)]=$24300;
      var $24301=$24299.f1;
      HEAP32[(($3453)>>2)]=$24301;
      var $24302=HEAP32[(($3453)>>2)];
      var $24303=(($24302)|0) < 0;
      if ($24303) { __label__ = 3956; break; } else { __label__ = 3957; break; }
    case 3956: // $24304
      var $24305=HEAP32[(($3452)>>2)];
      ___cxa_call_unexpected($24305);
      throw "Reached an unreachable!"
    case 3957: // $24306
      var $24307=HEAP32[(($3452)>>2)];
      var $24308=HEAP32[(($3452)>>2)];
      var $24309=HEAP32[(($3453)>>2)];
      var $24310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24308, tempValue);
      var $24311=($24310.f1 = $24309, $24310);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3958: // $24312
      throw "Reached an unreachable!"
    case 3959: // $_ZnwjPKci_exit494
      var $24313=HEAP32[(($result_i493)>>2)];
      var $24314=$3449;
      var $24315=$3450;
      var $24316=$3451;
      var $24317=$result_i493;
      var $24318=$3452;
      var $24319=$3453;
      var $24320=$24313;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6669, 4, 4, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3960; break; } else { __label__ = 12916; break; }
    case 3960: // $24321
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6670, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3961; break; } else { __label__ = 12916; break; }
    case 3961: // $24322
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6671, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3962; break; } else { __label__ = 12916; break; }
    case 3962: // $24323
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6672, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3963; break; } else { __label__ = 12916; break; }
    case 3963: // $24324
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6673, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3964; break; } else { __label__ = 12916; break; }
    case 3964: // $24325
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3965; break; } else { __label__ = 12916; break; }
    case 3965: // $24326
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3966; break; } else { __label__ = 12916; break; }
    case 3966: // $24327
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6668, $6669, $6670, $6671, $6672, $6673, $6674, $6675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3967; break; } else { __label__ = 12916; break; }
    case 3967: // $24328
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24320, 70, 5, 4, ((STRING_TABLE.__str685)|0), ((STRING_TABLE.__str686)|0), $6668) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3968; break; } else { __label__ = 12916; break; }
    case 3968: // $24329
      var $24330=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24320);
      var $24331=__ZN11simple_listI16input_type_entryE6appendERS0_($24281, $24330);
      var $24332=$4689;
      var $24333=$3444;
      var $24334=$3445;
      var $24335=$3446;
      var $24336=$result_i495;
      var $24337=$3447;
      var $24338=$3448;
      HEAP32[(($3444)>>2)]=408;
      HEAP32[(($3445)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3446)>>2)]=306;
      var $24339=HEAP32[(($3444)>>2)];
      var $24340=HEAP32[(($3445)>>2)];
      var $24341=HEAP32[(($3446)>>2)];
      var $24342=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24339, $24340, $24341) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3969; break; } else { __label__ = 3971; break; };
    case 3969: // $24343
      HEAP32[(($result_i495)>>2)]=$24342;
      var $24344=HEAP32[(($result_i495)>>2)];
      var $24345=(($24344)|0)==0;
      if ($24345) { __label__ = 3970; break; } else { __label__ = 3975; break; }
    case 3970: // $24346
      var $24347=___cxa_allocate_exception(4);
      var $24348=$24347;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24348);
      (function() { try { __THREW__ = false; return ___cxa_throw($24347, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3974; break; } else { __label__ = 3971; break; }
    case 3971: // $24349
      var $24350=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24351=$24350.f0;
      HEAP32[(($3447)>>2)]=$24351;
      var $24352=$24350.f1;
      HEAP32[(($3448)>>2)]=$24352;
      var $24353=HEAP32[(($3448)>>2)];
      var $24354=(($24353)|0) < 0;
      if ($24354) { __label__ = 3972; break; } else { __label__ = 3973; break; }
    case 3972: // $24355
      var $24356=HEAP32[(($3447)>>2)];
      ___cxa_call_unexpected($24356);
      throw "Reached an unreachable!"
    case 3973: // $24357
      var $24358=HEAP32[(($3447)>>2)];
      var $24359=HEAP32[(($3447)>>2)];
      var $24360=HEAP32[(($3448)>>2)];
      var $24361=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24359, tempValue);
      var $24362=($24361.f1 = $24360, $24361);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3974: // $24363
      throw "Reached an unreachable!"
    case 3975: // $_ZnwjPKci_exit496
      var $24364=HEAP32[(($result_i495)>>2)];
      var $24365=$3444;
      var $24366=$3445;
      var $24367=$3446;
      var $24368=$result_i495;
      var $24369=$3447;
      var $24370=$3448;
      var $24371=$24364;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6677, 4, 4, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3976; break; } else { __label__ = 12921; break; }
    case 3976: // $24372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6678, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3977; break; } else { __label__ = 12921; break; }
    case 3977: // $24373
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6679, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3978; break; } else { __label__ = 12921; break; }
    case 3978: // $24374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3979; break; } else { __label__ = 12921; break; }
    case 3979: // $24375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3980; break; } else { __label__ = 12921; break; }
    case 3980: // $24376
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3981; break; } else { __label__ = 12921; break; }
    case 3981: // $24377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3982; break; } else { __label__ = 12921; break; }
    case 3982: // $24378
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6676, $6677, $6678, $6679, $6680, $6681, $6682, $6683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3983; break; } else { __label__ = 12921; break; }
    case 3983: // $24379
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24371, 71, 5, 4, ((STRING_TABLE.__str687)|0), ((STRING_TABLE.__str688)|0), $6676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3984; break; } else { __label__ = 12921; break; }
    case 3984: // $24380
      var $24381=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24371);
      var $24382=__ZN11simple_listI16input_type_entryE6appendERS0_($24332, $24381);
      var $24383=$4689;
      var $24384=$3439;
      var $24385=$3440;
      var $24386=$3441;
      var $24387=$result_i497;
      var $24388=$3442;
      var $24389=$3443;
      HEAP32[(($3439)>>2)]=408;
      HEAP32[(($3440)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3441)>>2)]=307;
      var $24390=HEAP32[(($3439)>>2)];
      var $24391=HEAP32[(($3440)>>2)];
      var $24392=HEAP32[(($3441)>>2)];
      var $24393=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24390, $24391, $24392) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3985; break; } else { __label__ = 3987; break; };
    case 3985: // $24394
      HEAP32[(($result_i497)>>2)]=$24393;
      var $24395=HEAP32[(($result_i497)>>2)];
      var $24396=(($24395)|0)==0;
      if ($24396) { __label__ = 3986; break; } else { __label__ = 3991; break; }
    case 3986: // $24397
      var $24398=___cxa_allocate_exception(4);
      var $24399=$24398;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24399);
      (function() { try { __THREW__ = false; return ___cxa_throw($24398, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3990; break; } else { __label__ = 3987; break; }
    case 3987: // $24400
      var $24401=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24402=$24401.f0;
      HEAP32[(($3442)>>2)]=$24402;
      var $24403=$24401.f1;
      HEAP32[(($3443)>>2)]=$24403;
      var $24404=HEAP32[(($3443)>>2)];
      var $24405=(($24404)|0) < 0;
      if ($24405) { __label__ = 3988; break; } else { __label__ = 3989; break; }
    case 3988: // $24406
      var $24407=HEAP32[(($3442)>>2)];
      ___cxa_call_unexpected($24407);
      throw "Reached an unreachable!"
    case 3989: // $24408
      var $24409=HEAP32[(($3442)>>2)];
      var $24410=HEAP32[(($3442)>>2)];
      var $24411=HEAP32[(($3443)>>2)];
      var $24412=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24410, tempValue);
      var $24413=($24412.f1 = $24411, $24412);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3990: // $24414
      throw "Reached an unreachable!"
    case 3991: // $_ZnwjPKci_exit498
      var $24415=HEAP32[(($result_i497)>>2)];
      var $24416=$3439;
      var $24417=$3440;
      var $24418=$3441;
      var $24419=$result_i497;
      var $24420=$3442;
      var $24421=$3443;
      var $24422=$24415;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6685, 4, 4, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3992; break; } else { __label__ = 12926; break; }
    case 3992: // $24423
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6686, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3993; break; } else { __label__ = 12926; break; }
    case 3993: // $24424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6687, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3994; break; } else { __label__ = 12926; break; }
    case 3994: // $24425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6688, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3995; break; } else { __label__ = 12926; break; }
    case 3995: // $24426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6689, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3996; break; } else { __label__ = 12926; break; }
    case 3996: // $24427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6690, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3997; break; } else { __label__ = 12926; break; }
    case 3997: // $24428
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6691, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3998; break; } else { __label__ = 12926; break; }
    case 3998: // $24429
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6684, $6685, $6686, $6687, $6688, $6689, $6690, $6691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3999; break; } else { __label__ = 12926; break; }
    case 3999: // $24430
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24422, 72, 5, 4, ((STRING_TABLE.__str689)|0), ((STRING_TABLE.__str690)|0), $6684) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4000; break; } else { __label__ = 12926; break; }
    case 4000: // $24431
      var $24432=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24422);
      var $24433=__ZN11simple_listI16input_type_entryE6appendERS0_($24383, $24432);
      var $24434=$4689;
      var $24435=$3434;
      var $24436=$3435;
      var $24437=$3436;
      var $24438=$result_i499;
      var $24439=$3437;
      var $24440=$3438;
      HEAP32[(($3434)>>2)]=408;
      HEAP32[(($3435)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3436)>>2)]=308;
      var $24441=HEAP32[(($3434)>>2)];
      var $24442=HEAP32[(($3435)>>2)];
      var $24443=HEAP32[(($3436)>>2)];
      var $24444=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24441, $24442, $24443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4001; break; } else { __label__ = 4003; break; };
    case 4001: // $24445
      HEAP32[(($result_i499)>>2)]=$24444;
      var $24446=HEAP32[(($result_i499)>>2)];
      var $24447=(($24446)|0)==0;
      if ($24447) { __label__ = 4002; break; } else { __label__ = 4007; break; }
    case 4002: // $24448
      var $24449=___cxa_allocate_exception(4);
      var $24450=$24449;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24450);
      (function() { try { __THREW__ = false; return ___cxa_throw($24449, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4006; break; } else { __label__ = 4003; break; }
    case 4003: // $24451
      var $24452=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24453=$24452.f0;
      HEAP32[(($3437)>>2)]=$24453;
      var $24454=$24452.f1;
      HEAP32[(($3438)>>2)]=$24454;
      var $24455=HEAP32[(($3438)>>2)];
      var $24456=(($24455)|0) < 0;
      if ($24456) { __label__ = 4004; break; } else { __label__ = 4005; break; }
    case 4004: // $24457
      var $24458=HEAP32[(($3437)>>2)];
      ___cxa_call_unexpected($24458);
      throw "Reached an unreachable!"
    case 4005: // $24459
      var $24460=HEAP32[(($3437)>>2)];
      var $24461=HEAP32[(($3437)>>2)];
      var $24462=HEAP32[(($3438)>>2)];
      var $24463=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24461, tempValue);
      var $24464=($24463.f1 = $24462, $24463);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4006: // $24465
      throw "Reached an unreachable!"
    case 4007: // $_ZnwjPKci_exit500
      var $24466=HEAP32[(($result_i499)>>2)];
      var $24467=$3434;
      var $24468=$3435;
      var $24469=$3436;
      var $24470=$result_i499;
      var $24471=$3437;
      var $24472=$3438;
      var $24473=$24466;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6693, 4, 4, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4008; break; } else { __label__ = 12931; break; }
    case 4008: // $24474
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6694, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4009; break; } else { __label__ = 12931; break; }
    case 4009: // $24475
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6695, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4010; break; } else { __label__ = 12931; break; }
    case 4010: // $24476
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6696, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4011; break; } else { __label__ = 12931; break; }
    case 4011: // $24477
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6697, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4012; break; } else { __label__ = 12931; break; }
    case 4012: // $24478
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4013; break; } else { __label__ = 12931; break; }
    case 4013: // $24479
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4014; break; } else { __label__ = 12931; break; }
    case 4014: // $24480
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6692, $6693, $6694, $6695, $6696, $6697, $6698, $6699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4015; break; } else { __label__ = 12931; break; }
    case 4015: // $24481
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24473, 73, 5, 4, ((STRING_TABLE.__str691)|0), ((STRING_TABLE.__str692)|0), $6692) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4016; break; } else { __label__ = 12931; break; }
    case 4016: // $24482
      var $24483=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24473);
      var $24484=__ZN11simple_listI16input_type_entryE6appendERS0_($24434, $24483);
      var $24485=$4689;
      var $24486=$3429;
      var $24487=$3430;
      var $24488=$3431;
      var $24489=$result_i501;
      var $24490=$3432;
      var $24491=$3433;
      HEAP32[(($3429)>>2)]=408;
      HEAP32[(($3430)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3431)>>2)]=309;
      var $24492=HEAP32[(($3429)>>2)];
      var $24493=HEAP32[(($3430)>>2)];
      var $24494=HEAP32[(($3431)>>2)];
      var $24495=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24492, $24493, $24494) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4017; break; } else { __label__ = 4019; break; };
    case 4017: // $24496
      HEAP32[(($result_i501)>>2)]=$24495;
      var $24497=HEAP32[(($result_i501)>>2)];
      var $24498=(($24497)|0)==0;
      if ($24498) { __label__ = 4018; break; } else { __label__ = 4023; break; }
    case 4018: // $24499
      var $24500=___cxa_allocate_exception(4);
      var $24501=$24500;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24501);
      (function() { try { __THREW__ = false; return ___cxa_throw($24500, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4022; break; } else { __label__ = 4019; break; }
    case 4019: // $24502
      var $24503=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24504=$24503.f0;
      HEAP32[(($3432)>>2)]=$24504;
      var $24505=$24503.f1;
      HEAP32[(($3433)>>2)]=$24505;
      var $24506=HEAP32[(($3433)>>2)];
      var $24507=(($24506)|0) < 0;
      if ($24507) { __label__ = 4020; break; } else { __label__ = 4021; break; }
    case 4020: // $24508
      var $24509=HEAP32[(($3432)>>2)];
      ___cxa_call_unexpected($24509);
      throw "Reached an unreachable!"
    case 4021: // $24510
      var $24511=HEAP32[(($3432)>>2)];
      var $24512=HEAP32[(($3432)>>2)];
      var $24513=HEAP32[(($3433)>>2)];
      var $24514=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24512, tempValue);
      var $24515=($24514.f1 = $24513, $24514);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4022: // $24516
      throw "Reached an unreachable!"
    case 4023: // $_ZnwjPKci_exit502
      var $24517=HEAP32[(($result_i501)>>2)];
      var $24518=$3429;
      var $24519=$3430;
      var $24520=$3431;
      var $24521=$result_i501;
      var $24522=$3432;
      var $24523=$3433;
      var $24524=$24517;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6701, 4, 4, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4024; break; } else { __label__ = 12936; break; }
    case 4024: // $24525
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6702, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4025; break; } else { __label__ = 12936; break; }
    case 4025: // $24526
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6703, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4026; break; } else { __label__ = 12936; break; }
    case 4026: // $24527
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4027; break; } else { __label__ = 12936; break; }
    case 4027: // $24528
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4028; break; } else { __label__ = 12936; break; }
    case 4028: // $24529
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4029; break; } else { __label__ = 12936; break; }
    case 4029: // $24530
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4030; break; } else { __label__ = 12936; break; }
    case 4030: // $24531
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6700, $6701, $6702, $6703, $6704, $6705, $6706, $6707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4031; break; } else { __label__ = 12936; break; }
    case 4031: // $24532
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24524, 74, 5, 4, ((STRING_TABLE.__str693)|0), ((STRING_TABLE.__str694)|0), $6700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4032; break; } else { __label__ = 12936; break; }
    case 4032: // $24533
      var $24534=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24524);
      var $24535=__ZN11simple_listI16input_type_entryE6appendERS0_($24485, $24534);
      var $24536=$4689;
      var $24537=$3424;
      var $24538=$3425;
      var $24539=$3426;
      var $24540=$result_i503;
      var $24541=$3427;
      var $24542=$3428;
      HEAP32[(($3424)>>2)]=408;
      HEAP32[(($3425)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3426)>>2)]=310;
      var $24543=HEAP32[(($3424)>>2)];
      var $24544=HEAP32[(($3425)>>2)];
      var $24545=HEAP32[(($3426)>>2)];
      var $24546=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24543, $24544, $24545) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4033; break; } else { __label__ = 4035; break; };
    case 4033: // $24547
      HEAP32[(($result_i503)>>2)]=$24546;
      var $24548=HEAP32[(($result_i503)>>2)];
      var $24549=(($24548)|0)==0;
      if ($24549) { __label__ = 4034; break; } else { __label__ = 4039; break; }
    case 4034: // $24550
      var $24551=___cxa_allocate_exception(4);
      var $24552=$24551;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24552);
      (function() { try { __THREW__ = false; return ___cxa_throw($24551, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4038; break; } else { __label__ = 4035; break; }
    case 4035: // $24553
      var $24554=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24555=$24554.f0;
      HEAP32[(($3427)>>2)]=$24555;
      var $24556=$24554.f1;
      HEAP32[(($3428)>>2)]=$24556;
      var $24557=HEAP32[(($3428)>>2)];
      var $24558=(($24557)|0) < 0;
      if ($24558) { __label__ = 4036; break; } else { __label__ = 4037; break; }
    case 4036: // $24559
      var $24560=HEAP32[(($3427)>>2)];
      ___cxa_call_unexpected($24560);
      throw "Reached an unreachable!"
    case 4037: // $24561
      var $24562=HEAP32[(($3427)>>2)];
      var $24563=HEAP32[(($3427)>>2)];
      var $24564=HEAP32[(($3428)>>2)];
      var $24565=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24563, tempValue);
      var $24566=($24565.f1 = $24564, $24565);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4038: // $24567
      throw "Reached an unreachable!"
    case 4039: // $_ZnwjPKci_exit504
      var $24568=HEAP32[(($result_i503)>>2)];
      var $24569=$3424;
      var $24570=$3425;
      var $24571=$3426;
      var $24572=$result_i503;
      var $24573=$3427;
      var $24574=$3428;
      var $24575=$24568;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6709, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4040; break; } else { __label__ = 12941; break; }
    case 4040: // $24576
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6710, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4041; break; } else { __label__ = 12941; break; }
    case 4041: // $24577
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6711, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4042; break; } else { __label__ = 12941; break; }
    case 4042: // $24578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4043; break; } else { __label__ = 12941; break; }
    case 4043: // $24579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4044; break; } else { __label__ = 12941; break; }
    case 4044: // $24580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4045; break; } else { __label__ = 12941; break; }
    case 4045: // $24581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4046; break; } else { __label__ = 12941; break; }
    case 4046: // $24582
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6708, $6709, $6710, $6711, $6712, $6713, $6714, $6715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4047; break; } else { __label__ = 12941; break; }
    case 4047: // $24583
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24575, 43, 5, 4, ((STRING_TABLE.__str695)|0), ((STRING_TABLE.__str696)|0), $6708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4048; break; } else { __label__ = 12941; break; }
    case 4048: // $24584
      var $24585=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24575);
      var $24586=__ZN11simple_listI16input_type_entryE6appendERS0_($24536, $24585);
      var $24587=$4689;
      var $24588=$3419;
      var $24589=$3420;
      var $24590=$3421;
      var $24591=$result_i505;
      var $24592=$3422;
      var $24593=$3423;
      HEAP32[(($3419)>>2)]=408;
      HEAP32[(($3420)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3421)>>2)]=311;
      var $24594=HEAP32[(($3419)>>2)];
      var $24595=HEAP32[(($3420)>>2)];
      var $24596=HEAP32[(($3421)>>2)];
      var $24597=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24594, $24595, $24596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4049; break; } else { __label__ = 4051; break; };
    case 4049: // $24598
      HEAP32[(($result_i505)>>2)]=$24597;
      var $24599=HEAP32[(($result_i505)>>2)];
      var $24600=(($24599)|0)==0;
      if ($24600) { __label__ = 4050; break; } else { __label__ = 4055; break; }
    case 4050: // $24601
      var $24602=___cxa_allocate_exception(4);
      var $24603=$24602;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24603);
      (function() { try { __THREW__ = false; return ___cxa_throw($24602, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4054; break; } else { __label__ = 4051; break; }
    case 4051: // $24604
      var $24605=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24606=$24605.f0;
      HEAP32[(($3422)>>2)]=$24606;
      var $24607=$24605.f1;
      HEAP32[(($3423)>>2)]=$24607;
      var $24608=HEAP32[(($3423)>>2)];
      var $24609=(($24608)|0) < 0;
      if ($24609) { __label__ = 4052; break; } else { __label__ = 4053; break; }
    case 4052: // $24610
      var $24611=HEAP32[(($3422)>>2)];
      ___cxa_call_unexpected($24611);
      throw "Reached an unreachable!"
    case 4053: // $24612
      var $24613=HEAP32[(($3422)>>2)];
      var $24614=HEAP32[(($3422)>>2)];
      var $24615=HEAP32[(($3423)>>2)];
      var $24616=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24614, tempValue);
      var $24617=($24616.f1 = $24615, $24616);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4054: // $24618
      throw "Reached an unreachable!"
    case 4055: // $_ZnwjPKci_exit506
      var $24619=HEAP32[(($result_i505)>>2)];
      var $24620=$3419;
      var $24621=$3420;
      var $24622=$3421;
      var $24623=$result_i505;
      var $24624=$3422;
      var $24625=$3423;
      var $24626=$24619;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6717, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4056; break; } else { __label__ = 12946; break; }
    case 4056: // $24627
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6718, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4057; break; } else { __label__ = 12946; break; }
    case 4057: // $24628
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6719, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4058; break; } else { __label__ = 12946; break; }
    case 4058: // $24629
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6720, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4059; break; } else { __label__ = 12946; break; }
    case 4059: // $24630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6721, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4060; break; } else { __label__ = 12946; break; }
    case 4060: // $24631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4061; break; } else { __label__ = 12946; break; }
    case 4061: // $24632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4062; break; } else { __label__ = 12946; break; }
    case 4062: // $24633
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6716, $6717, $6718, $6719, $6720, $6721, $6722, $6723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4063; break; } else { __label__ = 12946; break; }
    case 4063: // $24634
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24626, 44, 5, 4, ((STRING_TABLE.__str697)|0), ((STRING_TABLE.__str698)|0), $6716) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4064; break; } else { __label__ = 12946; break; }
    case 4064: // $24635
      var $24636=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24626);
      var $24637=__ZN11simple_listI16input_type_entryE6appendERS0_($24587, $24636);
      var $24638=$4689;
      var $24639=$3414;
      var $24640=$3415;
      var $24641=$3416;
      var $24642=$result_i507;
      var $24643=$3417;
      var $24644=$3418;
      HEAP32[(($3414)>>2)]=408;
      HEAP32[(($3415)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3416)>>2)]=313;
      var $24645=HEAP32[(($3414)>>2)];
      var $24646=HEAP32[(($3415)>>2)];
      var $24647=HEAP32[(($3416)>>2)];
      var $24648=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24645, $24646, $24647) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4065; break; } else { __label__ = 4067; break; };
    case 4065: // $24649
      HEAP32[(($result_i507)>>2)]=$24648;
      var $24650=HEAP32[(($result_i507)>>2)];
      var $24651=(($24650)|0)==0;
      if ($24651) { __label__ = 4066; break; } else { __label__ = 4071; break; }
    case 4066: // $24652
      var $24653=___cxa_allocate_exception(4);
      var $24654=$24653;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24654);
      (function() { try { __THREW__ = false; return ___cxa_throw($24653, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4070; break; } else { __label__ = 4067; break; }
    case 4067: // $24655
      var $24656=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24657=$24656.f0;
      HEAP32[(($3417)>>2)]=$24657;
      var $24658=$24656.f1;
      HEAP32[(($3418)>>2)]=$24658;
      var $24659=HEAP32[(($3418)>>2)];
      var $24660=(($24659)|0) < 0;
      if ($24660) { __label__ = 4068; break; } else { __label__ = 4069; break; }
    case 4068: // $24661
      var $24662=HEAP32[(($3417)>>2)];
      ___cxa_call_unexpected($24662);
      throw "Reached an unreachable!"
    case 4069: // $24663
      var $24664=HEAP32[(($3417)>>2)];
      var $24665=HEAP32[(($3417)>>2)];
      var $24666=HEAP32[(($3418)>>2)];
      var $24667=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24665, tempValue);
      var $24668=($24667.f1 = $24666, $24667);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4070: // $24669
      throw "Reached an unreachable!"
    case 4071: // $_ZnwjPKci_exit508
      var $24670=HEAP32[(($result_i507)>>2)];
      var $24671=$3414;
      var $24672=$3415;
      var $24673=$3416;
      var $24674=$result_i507;
      var $24675=$3417;
      var $24676=$3418;
      var $24677=$24670;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6725, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4072; break; } else { __label__ = 12951; break; }
    case 4072: // $24678
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6726, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4073; break; } else { __label__ = 12951; break; }
    case 4073: // $24679
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6727, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4074; break; } else { __label__ = 12951; break; }
    case 4074: // $24680
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4075; break; } else { __label__ = 12951; break; }
    case 4075: // $24681
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4076; break; } else { __label__ = 12951; break; }
    case 4076: // $24682
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4077; break; } else { __label__ = 12951; break; }
    case 4077: // $24683
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4078; break; } else { __label__ = 12951; break; }
    case 4078: // $24684
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6724, $6725, $6726, $6727, $6728, $6729, $6730, $6731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4079; break; } else { __label__ = 12951; break; }
    case 4079: // $24685
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24677, 47, 6, 5, ((STRING_TABLE.__str699)|0), ((STRING_TABLE.__str700)|0), $6724) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4080; break; } else { __label__ = 12951; break; }
    case 4080: // $24686
      var $24687=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24677);
      var $24688=__ZN11simple_listI16input_type_entryE6appendERS0_($24638, $24687);
      var $24689=$4689;
      var $24690=$3409;
      var $24691=$3410;
      var $24692=$3411;
      var $24693=$result_i509;
      var $24694=$3412;
      var $24695=$3413;
      HEAP32[(($3409)>>2)]=408;
      HEAP32[(($3410)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3411)>>2)]=314;
      var $24696=HEAP32[(($3409)>>2)];
      var $24697=HEAP32[(($3410)>>2)];
      var $24698=HEAP32[(($3411)>>2)];
      var $24699=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24696, $24697, $24698) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4081; break; } else { __label__ = 4083; break; };
    case 4081: // $24700
      HEAP32[(($result_i509)>>2)]=$24699;
      var $24701=HEAP32[(($result_i509)>>2)];
      var $24702=(($24701)|0)==0;
      if ($24702) { __label__ = 4082; break; } else { __label__ = 4087; break; }
    case 4082: // $24703
      var $24704=___cxa_allocate_exception(4);
      var $24705=$24704;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24705);
      (function() { try { __THREW__ = false; return ___cxa_throw($24704, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4086; break; } else { __label__ = 4083; break; }
    case 4083: // $24706
      var $24707=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24708=$24707.f0;
      HEAP32[(($3412)>>2)]=$24708;
      var $24709=$24707.f1;
      HEAP32[(($3413)>>2)]=$24709;
      var $24710=HEAP32[(($3413)>>2)];
      var $24711=(($24710)|0) < 0;
      if ($24711) { __label__ = 4084; break; } else { __label__ = 4085; break; }
    case 4084: // $24712
      var $24713=HEAP32[(($3412)>>2)];
      ___cxa_call_unexpected($24713);
      throw "Reached an unreachable!"
    case 4085: // $24714
      var $24715=HEAP32[(($3412)>>2)];
      var $24716=HEAP32[(($3412)>>2)];
      var $24717=HEAP32[(($3413)>>2)];
      var $24718=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24716, tempValue);
      var $24719=($24718.f1 = $24717, $24718);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4086: // $24720
      throw "Reached an unreachable!"
    case 4087: // $_ZnwjPKci_exit510
      var $24721=HEAP32[(($result_i509)>>2)];
      var $24722=$3409;
      var $24723=$3410;
      var $24724=$3411;
      var $24725=$result_i509;
      var $24726=$3412;
      var $24727=$3413;
      var $24728=$24721;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6733, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4088; break; } else { __label__ = 12956; break; }
    case 4088: // $24729
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6734, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4089; break; } else { __label__ = 12956; break; }
    case 4089: // $24730
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6735, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4090; break; } else { __label__ = 12956; break; }
    case 4090: // $24731
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4091; break; } else { __label__ = 12956; break; }
    case 4091: // $24732
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4092; break; } else { __label__ = 12956; break; }
    case 4092: // $24733
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4093; break; } else { __label__ = 12956; break; }
    case 4093: // $24734
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4094; break; } else { __label__ = 12956; break; }
    case 4094: // $24735
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6732, $6733, $6734, $6735, $6736, $6737, $6738, $6739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4095; break; } else { __label__ = 12956; break; }
    case 4095: // $24736
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24728, 48, 6, 5, ((STRING_TABLE.__str701)|0), ((STRING_TABLE.__str702)|0), $6732) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4096; break; } else { __label__ = 12956; break; }
    case 4096: // $24737
      var $24738=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24728);
      var $24739=__ZN11simple_listI16input_type_entryE6appendERS0_($24689, $24738);
      var $24740=$4689;
      var $24741=$3404;
      var $24742=$3405;
      var $24743=$3406;
      var $24744=$result_i511;
      var $24745=$3407;
      var $24746=$3408;
      HEAP32[(($3404)>>2)]=408;
      HEAP32[(($3405)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3406)>>2)]=315;
      var $24747=HEAP32[(($3404)>>2)];
      var $24748=HEAP32[(($3405)>>2)];
      var $24749=HEAP32[(($3406)>>2)];
      var $24750=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24747, $24748, $24749) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4097; break; } else { __label__ = 4099; break; };
    case 4097: // $24751
      HEAP32[(($result_i511)>>2)]=$24750;
      var $24752=HEAP32[(($result_i511)>>2)];
      var $24753=(($24752)|0)==0;
      if ($24753) { __label__ = 4098; break; } else { __label__ = 4103; break; }
    case 4098: // $24754
      var $24755=___cxa_allocate_exception(4);
      var $24756=$24755;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24756);
      (function() { try { __THREW__ = false; return ___cxa_throw($24755, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4102; break; } else { __label__ = 4099; break; }
    case 4099: // $24757
      var $24758=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24759=$24758.f0;
      HEAP32[(($3407)>>2)]=$24759;
      var $24760=$24758.f1;
      HEAP32[(($3408)>>2)]=$24760;
      var $24761=HEAP32[(($3408)>>2)];
      var $24762=(($24761)|0) < 0;
      if ($24762) { __label__ = 4100; break; } else { __label__ = 4101; break; }
    case 4100: // $24763
      var $24764=HEAP32[(($3407)>>2)];
      ___cxa_call_unexpected($24764);
      throw "Reached an unreachable!"
    case 4101: // $24765
      var $24766=HEAP32[(($3407)>>2)];
      var $24767=HEAP32[(($3407)>>2)];
      var $24768=HEAP32[(($3408)>>2)];
      var $24769=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24767, tempValue);
      var $24770=($24769.f1 = $24768, $24769);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4102: // $24771
      throw "Reached an unreachable!"
    case 4103: // $_ZnwjPKci_exit512
      var $24772=HEAP32[(($result_i511)>>2)];
      var $24773=$3404;
      var $24774=$3405;
      var $24775=$3406;
      var $24776=$result_i511;
      var $24777=$3407;
      var $24778=$3408;
      var $24779=$24772;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6741, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4104; break; } else { __label__ = 12961; break; }
    case 4104: // $24780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6742, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4105; break; } else { __label__ = 12961; break; }
    case 4105: // $24781
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6743, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4106; break; } else { __label__ = 12961; break; }
    case 4106: // $24782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6744, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4107; break; } else { __label__ = 12961; break; }
    case 4107: // $24783
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6745, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4108; break; } else { __label__ = 12961; break; }
    case 4108: // $24784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4109; break; } else { __label__ = 12961; break; }
    case 4109: // $24785
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4110; break; } else { __label__ = 12961; break; }
    case 4110: // $24786
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6740, $6741, $6742, $6743, $6744, $6745, $6746, $6747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4111; break; } else { __label__ = 12961; break; }
    case 4111: // $24787
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24779, 49, 6, 5, ((STRING_TABLE.__str703)|0), ((STRING_TABLE.__str704)|0), $6740) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4112; break; } else { __label__ = 12961; break; }
    case 4112: // $24788
      var $24789=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24779);
      var $24790=__ZN11simple_listI16input_type_entryE6appendERS0_($24740, $24789);
      var $24791=$4689;
      var $24792=$3399;
      var $24793=$3400;
      var $24794=$3401;
      var $24795=$result_i513;
      var $24796=$3402;
      var $24797=$3403;
      HEAP32[(($3399)>>2)]=408;
      HEAP32[(($3400)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3401)>>2)]=316;
      var $24798=HEAP32[(($3399)>>2)];
      var $24799=HEAP32[(($3400)>>2)];
      var $24800=HEAP32[(($3401)>>2)];
      var $24801=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24798, $24799, $24800) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4113; break; } else { __label__ = 4115; break; };
    case 4113: // $24802
      HEAP32[(($result_i513)>>2)]=$24801;
      var $24803=HEAP32[(($result_i513)>>2)];
      var $24804=(($24803)|0)==0;
      if ($24804) { __label__ = 4114; break; } else { __label__ = 4119; break; }
    case 4114: // $24805
      var $24806=___cxa_allocate_exception(4);
      var $24807=$24806;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24807);
      (function() { try { __THREW__ = false; return ___cxa_throw($24806, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4118; break; } else { __label__ = 4115; break; }
    case 4115: // $24808
      var $24809=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24810=$24809.f0;
      HEAP32[(($3402)>>2)]=$24810;
      var $24811=$24809.f1;
      HEAP32[(($3403)>>2)]=$24811;
      var $24812=HEAP32[(($3403)>>2)];
      var $24813=(($24812)|0) < 0;
      if ($24813) { __label__ = 4116; break; } else { __label__ = 4117; break; }
    case 4116: // $24814
      var $24815=HEAP32[(($3402)>>2)];
      ___cxa_call_unexpected($24815);
      throw "Reached an unreachable!"
    case 4117: // $24816
      var $24817=HEAP32[(($3402)>>2)];
      var $24818=HEAP32[(($3402)>>2)];
      var $24819=HEAP32[(($3403)>>2)];
      var $24820=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24818, tempValue);
      var $24821=($24820.f1 = $24819, $24820);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4118: // $24822
      throw "Reached an unreachable!"
    case 4119: // $_ZnwjPKci_exit514
      var $24823=HEAP32[(($result_i513)>>2)];
      var $24824=$3399;
      var $24825=$3400;
      var $24826=$3401;
      var $24827=$result_i513;
      var $24828=$3402;
      var $24829=$3403;
      var $24830=$24823;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6749, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4120; break; } else { __label__ = 12966; break; }
    case 4120: // $24831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6750, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4121; break; } else { __label__ = 12966; break; }
    case 4121: // $24832
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6751, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4122; break; } else { __label__ = 12966; break; }
    case 4122: // $24833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4123; break; } else { __label__ = 12966; break; }
    case 4123: // $24834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4124; break; } else { __label__ = 12966; break; }
    case 4124: // $24835
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4125; break; } else { __label__ = 12966; break; }
    case 4125: // $24836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4126; break; } else { __label__ = 12966; break; }
    case 4126: // $24837
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6748, $6749, $6750, $6751, $6752, $6753, $6754, $6755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4127; break; } else { __label__ = 12966; break; }
    case 4127: // $24838
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24830, 50, 6, 5, ((STRING_TABLE.__str705)|0), ((STRING_TABLE.__str706)|0), $6748) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4128; break; } else { __label__ = 12966; break; }
    case 4128: // $24839
      var $24840=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24830);
      var $24841=__ZN11simple_listI16input_type_entryE6appendERS0_($24791, $24840);
      var $24842=$4689;
      var $24843=$3394;
      var $24844=$3395;
      var $24845=$3396;
      var $24846=$result_i515;
      var $24847=$3397;
      var $24848=$3398;
      HEAP32[(($3394)>>2)]=408;
      HEAP32[(($3395)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3396)>>2)]=317;
      var $24849=HEAP32[(($3394)>>2)];
      var $24850=HEAP32[(($3395)>>2)];
      var $24851=HEAP32[(($3396)>>2)];
      var $24852=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24849, $24850, $24851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4129; break; } else { __label__ = 4131; break; };
    case 4129: // $24853
      HEAP32[(($result_i515)>>2)]=$24852;
      var $24854=HEAP32[(($result_i515)>>2)];
      var $24855=(($24854)|0)==0;
      if ($24855) { __label__ = 4130; break; } else { __label__ = 4135; break; }
    case 4130: // $24856
      var $24857=___cxa_allocate_exception(4);
      var $24858=$24857;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24858);
      (function() { try { __THREW__ = false; return ___cxa_throw($24857, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4134; break; } else { __label__ = 4131; break; }
    case 4131: // $24859
      var $24860=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24861=$24860.f0;
      HEAP32[(($3397)>>2)]=$24861;
      var $24862=$24860.f1;
      HEAP32[(($3398)>>2)]=$24862;
      var $24863=HEAP32[(($3398)>>2)];
      var $24864=(($24863)|0) < 0;
      if ($24864) { __label__ = 4132; break; } else { __label__ = 4133; break; }
    case 4132: // $24865
      var $24866=HEAP32[(($3397)>>2)];
      ___cxa_call_unexpected($24866);
      throw "Reached an unreachable!"
    case 4133: // $24867
      var $24868=HEAP32[(($3397)>>2)];
      var $24869=HEAP32[(($3397)>>2)];
      var $24870=HEAP32[(($3398)>>2)];
      var $24871=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24869, tempValue);
      var $24872=($24871.f1 = $24870, $24871);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4134: // $24873
      throw "Reached an unreachable!"
    case 4135: // $_ZnwjPKci_exit516
      var $24874=HEAP32[(($result_i515)>>2)];
      var $24875=$3394;
      var $24876=$3395;
      var $24877=$3396;
      var $24878=$result_i515;
      var $24879=$3397;
      var $24880=$3398;
      var $24881=$24874;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6757, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4136; break; } else { __label__ = 12971; break; }
    case 4136: // $24882
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6758, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4137; break; } else { __label__ = 12971; break; }
    case 4137: // $24883
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6759, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4138; break; } else { __label__ = 12971; break; }
    case 4138: // $24884
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4139; break; } else { __label__ = 12971; break; }
    case 4139: // $24885
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4140; break; } else { __label__ = 12971; break; }
    case 4140: // $24886
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4141; break; } else { __label__ = 12971; break; }
    case 4141: // $24887
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4142; break; } else { __label__ = 12971; break; }
    case 4142: // $24888
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6756, $6757, $6758, $6759, $6760, $6761, $6762, $6763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4143; break; } else { __label__ = 12971; break; }
    case 4143: // $24889
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24881, 51, 6, 5, ((STRING_TABLE.__str707)|0), ((STRING_TABLE.__str708)|0), $6756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4144; break; } else { __label__ = 12971; break; }
    case 4144: // $24890
      var $24891=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24881);
      var $24892=__ZN11simple_listI16input_type_entryE6appendERS0_($24842, $24891);
      var $24893=$4689;
      var $24894=$3389;
      var $24895=$3390;
      var $24896=$3391;
      var $24897=$result_i517;
      var $24898=$3392;
      var $24899=$3393;
      HEAP32[(($3389)>>2)]=408;
      HEAP32[(($3390)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3391)>>2)]=318;
      var $24900=HEAP32[(($3389)>>2)];
      var $24901=HEAP32[(($3390)>>2)];
      var $24902=HEAP32[(($3391)>>2)];
      var $24903=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24900, $24901, $24902) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4145; break; } else { __label__ = 4147; break; };
    case 4145: // $24904
      HEAP32[(($result_i517)>>2)]=$24903;
      var $24905=HEAP32[(($result_i517)>>2)];
      var $24906=(($24905)|0)==0;
      if ($24906) { __label__ = 4146; break; } else { __label__ = 4151; break; }
    case 4146: // $24907
      var $24908=___cxa_allocate_exception(4);
      var $24909=$24908;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24909);
      (function() { try { __THREW__ = false; return ___cxa_throw($24908, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4150; break; } else { __label__ = 4147; break; }
    case 4147: // $24910
      var $24911=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24912=$24911.f0;
      HEAP32[(($3392)>>2)]=$24912;
      var $24913=$24911.f1;
      HEAP32[(($3393)>>2)]=$24913;
      var $24914=HEAP32[(($3393)>>2)];
      var $24915=(($24914)|0) < 0;
      if ($24915) { __label__ = 4148; break; } else { __label__ = 4149; break; }
    case 4148: // $24916
      var $24917=HEAP32[(($3392)>>2)];
      ___cxa_call_unexpected($24917);
      throw "Reached an unreachable!"
    case 4149: // $24918
      var $24919=HEAP32[(($3392)>>2)];
      var $24920=HEAP32[(($3392)>>2)];
      var $24921=HEAP32[(($3393)>>2)];
      var $24922=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24920, tempValue);
      var $24923=($24922.f1 = $24921, $24922);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4150: // $24924
      throw "Reached an unreachable!"
    case 4151: // $_ZnwjPKci_exit518
      var $24925=HEAP32[(($result_i517)>>2)];
      var $24926=$3389;
      var $24927=$3390;
      var $24928=$3391;
      var $24929=$result_i517;
      var $24930=$3392;
      var $24931=$3393;
      var $24932=$24925;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6765, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4152; break; } else { __label__ = 12976; break; }
    case 4152: // $24933
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6766, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4153; break; } else { __label__ = 12976; break; }
    case 4153: // $24934
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6767, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4154; break; } else { __label__ = 12976; break; }
    case 4154: // $24935
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6768, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4155; break; } else { __label__ = 12976; break; }
    case 4155: // $24936
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6769, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4156; break; } else { __label__ = 12976; break; }
    case 4156: // $24937
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4157; break; } else { __label__ = 12976; break; }
    case 4157: // $24938
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4158; break; } else { __label__ = 12976; break; }
    case 4158: // $24939
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6764, $6765, $6766, $6767, $6768, $6769, $6770, $6771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4159; break; } else { __label__ = 12976; break; }
    case 4159: // $24940
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24932, 52, 6, 5, ((STRING_TABLE.__str709)|0), ((STRING_TABLE.__str710)|0), $6764) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4160; break; } else { __label__ = 12976; break; }
    case 4160: // $24941
      var $24942=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24932);
      var $24943=__ZN11simple_listI16input_type_entryE6appendERS0_($24893, $24942);
      var $24944=$4689;
      var $24945=$3384;
      var $24946=$3385;
      var $24947=$3386;
      var $24948=$result_i519;
      var $24949=$3387;
      var $24950=$3388;
      HEAP32[(($3384)>>2)]=408;
      HEAP32[(($3385)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3386)>>2)]=319;
      var $24951=HEAP32[(($3384)>>2)];
      var $24952=HEAP32[(($3385)>>2)];
      var $24953=HEAP32[(($3386)>>2)];
      var $24954=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24951, $24952, $24953) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4161; break; } else { __label__ = 4163; break; };
    case 4161: // $24955
      HEAP32[(($result_i519)>>2)]=$24954;
      var $24956=HEAP32[(($result_i519)>>2)];
      var $24957=(($24956)|0)==0;
      if ($24957) { __label__ = 4162; break; } else { __label__ = 4167; break; }
    case 4162: // $24958
      var $24959=___cxa_allocate_exception(4);
      var $24960=$24959;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24960);
      (function() { try { __THREW__ = false; return ___cxa_throw($24959, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4166; break; } else { __label__ = 4163; break; }
    case 4163: // $24961
      var $24962=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24963=$24962.f0;
      HEAP32[(($3387)>>2)]=$24963;
      var $24964=$24962.f1;
      HEAP32[(($3388)>>2)]=$24964;
      var $24965=HEAP32[(($3388)>>2)];
      var $24966=(($24965)|0) < 0;
      if ($24966) { __label__ = 4164; break; } else { __label__ = 4165; break; }
    case 4164: // $24967
      var $24968=HEAP32[(($3387)>>2)];
      ___cxa_call_unexpected($24968);
      throw "Reached an unreachable!"
    case 4165: // $24969
      var $24970=HEAP32[(($3387)>>2)];
      var $24971=HEAP32[(($3387)>>2)];
      var $24972=HEAP32[(($3388)>>2)];
      var $24973=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24971, tempValue);
      var $24974=($24973.f1 = $24972, $24973);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4166: // $24975
      throw "Reached an unreachable!"
    case 4167: // $_ZnwjPKci_exit520
      var $24976=HEAP32[(($result_i519)>>2)];
      var $24977=$3384;
      var $24978=$3385;
      var $24979=$3386;
      var $24980=$result_i519;
      var $24981=$3387;
      var $24982=$3388;
      var $24983=$24976;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6773, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4168; break; } else { __label__ = 12981; break; }
    case 4168: // $24984
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6774, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4169; break; } else { __label__ = 12981; break; }
    case 4169: // $24985
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6775, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4170; break; } else { __label__ = 12981; break; }
    case 4170: // $24986
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4171; break; } else { __label__ = 12981; break; }
    case 4171: // $24987
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4172; break; } else { __label__ = 12981; break; }
    case 4172: // $24988
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4173; break; } else { __label__ = 12981; break; }
    case 4173: // $24989
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4174; break; } else { __label__ = 12981; break; }
    case 4174: // $24990
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6772, $6773, $6774, $6775, $6776, $6777, $6778, $6779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4175; break; } else { __label__ = 12981; break; }
    case 4175: // $24991
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($24983, 53, 6, 5, ((STRING_TABLE.__str711)|0), ((STRING_TABLE.__str712)|0), $6772) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4176; break; } else { __label__ = 12981; break; }
    case 4176: // $24992
      var $24993=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $24983);
      var $24994=__ZN11simple_listI16input_type_entryE6appendERS0_($24944, $24993);
      var $24995=$4689;
      var $24996=$3379;
      var $24997=$3380;
      var $24998=$3381;
      var $24999=$result_i521;
      var $25000=$3382;
      var $25001=$3383;
      HEAP32[(($3379)>>2)]=408;
      HEAP32[(($3380)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3381)>>2)]=320;
      var $25002=HEAP32[(($3379)>>2)];
      var $25003=HEAP32[(($3380)>>2)];
      var $25004=HEAP32[(($3381)>>2)];
      var $25005=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25002, $25003, $25004) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4177; break; } else { __label__ = 4179; break; };
    case 4177: // $25006
      HEAP32[(($result_i521)>>2)]=$25005;
      var $25007=HEAP32[(($result_i521)>>2)];
      var $25008=(($25007)|0)==0;
      if ($25008) { __label__ = 4178; break; } else { __label__ = 4183; break; }
    case 4178: // $25009
      var $25010=___cxa_allocate_exception(4);
      var $25011=$25010;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25011);
      (function() { try { __THREW__ = false; return ___cxa_throw($25010, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4182; break; } else { __label__ = 4179; break; }
    case 4179: // $25012
      var $25013=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25014=$25013.f0;
      HEAP32[(($3382)>>2)]=$25014;
      var $25015=$25013.f1;
      HEAP32[(($3383)>>2)]=$25015;
      var $25016=HEAP32[(($3383)>>2)];
      var $25017=(($25016)|0) < 0;
      if ($25017) { __label__ = 4180; break; } else { __label__ = 4181; break; }
    case 4180: // $25018
      var $25019=HEAP32[(($3382)>>2)];
      ___cxa_call_unexpected($25019);
      throw "Reached an unreachable!"
    case 4181: // $25020
      var $25021=HEAP32[(($3382)>>2)];
      var $25022=HEAP32[(($3382)>>2)];
      var $25023=HEAP32[(($3383)>>2)];
      var $25024=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25022, tempValue);
      var $25025=($25024.f1 = $25023, $25024);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4182: // $25026
      throw "Reached an unreachable!"
    case 4183: // $_ZnwjPKci_exit522
      var $25027=HEAP32[(($result_i521)>>2)];
      var $25028=$3379;
      var $25029=$3380;
      var $25030=$3381;
      var $25031=$result_i521;
      var $25032=$3382;
      var $25033=$3383;
      var $25034=$25027;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6781, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4184; break; } else { __label__ = 12986; break; }
    case 4184: // $25035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6782, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4185; break; } else { __label__ = 12986; break; }
    case 4185: // $25036
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6783, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4186; break; } else { __label__ = 12986; break; }
    case 4186: // $25037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4187; break; } else { __label__ = 12986; break; }
    case 4187: // $25038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4188; break; } else { __label__ = 12986; break; }
    case 4188: // $25039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4189; break; } else { __label__ = 12986; break; }
    case 4189: // $25040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4190; break; } else { __label__ = 12986; break; }
    case 4190: // $25041
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6780, $6781, $6782, $6783, $6784, $6785, $6786, $6787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4191; break; } else { __label__ = 12986; break; }
    case 4191: // $25042
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25034, 54, 6, 5, ((STRING_TABLE.__str713)|0), ((STRING_TABLE.__str714)|0), $6780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4192; break; } else { __label__ = 12986; break; }
    case 4192: // $25043
      var $25044=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25034);
      var $25045=__ZN11simple_listI16input_type_entryE6appendERS0_($24995, $25044);
      var $25046=$4689;
      var $25047=$3374;
      var $25048=$3375;
      var $25049=$3376;
      var $25050=$result_i523;
      var $25051=$3377;
      var $25052=$3378;
      HEAP32[(($3374)>>2)]=408;
      HEAP32[(($3375)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3376)>>2)]=321;
      var $25053=HEAP32[(($3374)>>2)];
      var $25054=HEAP32[(($3375)>>2)];
      var $25055=HEAP32[(($3376)>>2)];
      var $25056=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25053, $25054, $25055) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4193; break; } else { __label__ = 4195; break; };
    case 4193: // $25057
      HEAP32[(($result_i523)>>2)]=$25056;
      var $25058=HEAP32[(($result_i523)>>2)];
      var $25059=(($25058)|0)==0;
      if ($25059) { __label__ = 4194; break; } else { __label__ = 4199; break; }
    case 4194: // $25060
      var $25061=___cxa_allocate_exception(4);
      var $25062=$25061;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25062);
      (function() { try { __THREW__ = false; return ___cxa_throw($25061, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4198; break; } else { __label__ = 4195; break; }
    case 4195: // $25063
      var $25064=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25065=$25064.f0;
      HEAP32[(($3377)>>2)]=$25065;
      var $25066=$25064.f1;
      HEAP32[(($3378)>>2)]=$25066;
      var $25067=HEAP32[(($3378)>>2)];
      var $25068=(($25067)|0) < 0;
      if ($25068) { __label__ = 4196; break; } else { __label__ = 4197; break; }
    case 4196: // $25069
      var $25070=HEAP32[(($3377)>>2)];
      ___cxa_call_unexpected($25070);
      throw "Reached an unreachable!"
    case 4197: // $25071
      var $25072=HEAP32[(($3377)>>2)];
      var $25073=HEAP32[(($3377)>>2)];
      var $25074=HEAP32[(($3378)>>2)];
      var $25075=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25073, tempValue);
      var $25076=($25075.f1 = $25074, $25075);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4198: // $25077
      throw "Reached an unreachable!"
    case 4199: // $_ZnwjPKci_exit524
      var $25078=HEAP32[(($result_i523)>>2)];
      var $25079=$3374;
      var $25080=$3375;
      var $25081=$3376;
      var $25082=$result_i523;
      var $25083=$3377;
      var $25084=$3378;
      var $25085=$25078;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6789, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4200; break; } else { __label__ = 12991; break; }
    case 4200: // $25086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6790, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4201; break; } else { __label__ = 12991; break; }
    case 4201: // $25087
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6791, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4202; break; } else { __label__ = 12991; break; }
    case 4202: // $25088
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6792, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4203; break; } else { __label__ = 12991; break; }
    case 4203: // $25089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6793, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4204; break; } else { __label__ = 12991; break; }
    case 4204: // $25090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6794, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4205; break; } else { __label__ = 12991; break; }
    case 4205: // $25091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6795, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4206; break; } else { __label__ = 12991; break; }
    case 4206: // $25092
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6788, $6789, $6790, $6791, $6792, $6793, $6794, $6795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4207; break; } else { __label__ = 12991; break; }
    case 4207: // $25093
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25085, 55, 6, 5, ((STRING_TABLE.__str715)|0), ((STRING_TABLE.__str716)|0), $6788) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4208; break; } else { __label__ = 12991; break; }
    case 4208: // $25094
      var $25095=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25085);
      var $25096=__ZN11simple_listI16input_type_entryE6appendERS0_($25046, $25095);
      var $25097=$4689;
      var $25098=$3369;
      var $25099=$3370;
      var $25100=$3371;
      var $25101=$result_i525;
      var $25102=$3372;
      var $25103=$3373;
      HEAP32[(($3369)>>2)]=408;
      HEAP32[(($3370)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3371)>>2)]=322;
      var $25104=HEAP32[(($3369)>>2)];
      var $25105=HEAP32[(($3370)>>2)];
      var $25106=HEAP32[(($3371)>>2)];
      var $25107=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25104, $25105, $25106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4209; break; } else { __label__ = 4211; break; };
    case 4209: // $25108
      HEAP32[(($result_i525)>>2)]=$25107;
      var $25109=HEAP32[(($result_i525)>>2)];
      var $25110=(($25109)|0)==0;
      if ($25110) { __label__ = 4210; break; } else { __label__ = 4215; break; }
    case 4210: // $25111
      var $25112=___cxa_allocate_exception(4);
      var $25113=$25112;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25113);
      (function() { try { __THREW__ = false; return ___cxa_throw($25112, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4214; break; } else { __label__ = 4211; break; }
    case 4211: // $25114
      var $25115=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25116=$25115.f0;
      HEAP32[(($3372)>>2)]=$25116;
      var $25117=$25115.f1;
      HEAP32[(($3373)>>2)]=$25117;
      var $25118=HEAP32[(($3373)>>2)];
      var $25119=(($25118)|0) < 0;
      if ($25119) { __label__ = 4212; break; } else { __label__ = 4213; break; }
    case 4212: // $25120
      var $25121=HEAP32[(($3372)>>2)];
      ___cxa_call_unexpected($25121);
      throw "Reached an unreachable!"
    case 4213: // $25122
      var $25123=HEAP32[(($3372)>>2)];
      var $25124=HEAP32[(($3372)>>2)];
      var $25125=HEAP32[(($3373)>>2)];
      var $25126=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25124, tempValue);
      var $25127=($25126.f1 = $25125, $25126);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4214: // $25128
      throw "Reached an unreachable!"
    case 4215: // $_ZnwjPKci_exit526
      var $25129=HEAP32[(($result_i525)>>2)];
      var $25130=$3369;
      var $25131=$3370;
      var $25132=$3371;
      var $25133=$result_i525;
      var $25134=$3372;
      var $25135=$3373;
      var $25136=$25129;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6797, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4216; break; } else { __label__ = 12996; break; }
    case 4216: // $25137
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6798, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4217; break; } else { __label__ = 12996; break; }
    case 4217: // $25138
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6799, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4218; break; } else { __label__ = 12996; break; }
    case 4218: // $25139
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6800, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4219; break; } else { __label__ = 12996; break; }
    case 4219: // $25140
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6801, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4220; break; } else { __label__ = 12996; break; }
    case 4220: // $25141
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6802, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4221; break; } else { __label__ = 12996; break; }
    case 4221: // $25142
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6803, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4222; break; } else { __label__ = 12996; break; }
    case 4222: // $25143
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6796, $6797, $6798, $6799, $6800, $6801, $6802, $6803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4223; break; } else { __label__ = 12996; break; }
    case 4223: // $25144
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25136, 56, 6, 5, ((STRING_TABLE.__str717)|0), ((STRING_TABLE.__str718415)|0), $6796) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4224; break; } else { __label__ = 12996; break; }
    case 4224: // $25145
      var $25146=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25136);
      var $25147=__ZN11simple_listI16input_type_entryE6appendERS0_($25097, $25146);
      var $25148=$4689;
      var $25149=$3364;
      var $25150=$3365;
      var $25151=$3366;
      var $25152=$result_i527;
      var $25153=$3367;
      var $25154=$3368;
      HEAP32[(($3364)>>2)]=408;
      HEAP32[(($3365)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3366)>>2)]=323;
      var $25155=HEAP32[(($3364)>>2)];
      var $25156=HEAP32[(($3365)>>2)];
      var $25157=HEAP32[(($3366)>>2)];
      var $25158=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25155, $25156, $25157) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4225; break; } else { __label__ = 4227; break; };
    case 4225: // $25159
      HEAP32[(($result_i527)>>2)]=$25158;
      var $25160=HEAP32[(($result_i527)>>2)];
      var $25161=(($25160)|0)==0;
      if ($25161) { __label__ = 4226; break; } else { __label__ = 4231; break; }
    case 4226: // $25162
      var $25163=___cxa_allocate_exception(4);
      var $25164=$25163;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25164);
      (function() { try { __THREW__ = false; return ___cxa_throw($25163, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4230; break; } else { __label__ = 4227; break; }
    case 4227: // $25165
      var $25166=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25167=$25166.f0;
      HEAP32[(($3367)>>2)]=$25167;
      var $25168=$25166.f1;
      HEAP32[(($3368)>>2)]=$25168;
      var $25169=HEAP32[(($3368)>>2)];
      var $25170=(($25169)|0) < 0;
      if ($25170) { __label__ = 4228; break; } else { __label__ = 4229; break; }
    case 4228: // $25171
      var $25172=HEAP32[(($3367)>>2)];
      ___cxa_call_unexpected($25172);
      throw "Reached an unreachable!"
    case 4229: // $25173
      var $25174=HEAP32[(($3367)>>2)];
      var $25175=HEAP32[(($3367)>>2)];
      var $25176=HEAP32[(($3368)>>2)];
      var $25177=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25175, tempValue);
      var $25178=($25177.f1 = $25176, $25177);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4230: // $25179
      throw "Reached an unreachable!"
    case 4231: // $_ZnwjPKci_exit528
      var $25180=HEAP32[(($result_i527)>>2)];
      var $25181=$3364;
      var $25182=$3365;
      var $25183=$3366;
      var $25184=$result_i527;
      var $25185=$3367;
      var $25186=$3368;
      var $25187=$25180;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6805, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4232; break; } else { __label__ = 13001; break; }
    case 4232: // $25188
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6806, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4233; break; } else { __label__ = 13001; break; }
    case 4233: // $25189
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6807, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4234; break; } else { __label__ = 13001; break; }
    case 4234: // $25190
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6808, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4235; break; } else { __label__ = 13001; break; }
    case 4235: // $25191
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6809, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4236; break; } else { __label__ = 13001; break; }
    case 4236: // $25192
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4237; break; } else { __label__ = 13001; break; }
    case 4237: // $25193
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4238; break; } else { __label__ = 13001; break; }
    case 4238: // $25194
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6804, $6805, $6806, $6807, $6808, $6809, $6810, $6811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4239; break; } else { __label__ = 13001; break; }
    case 4239: // $25195
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25187, 57, 6, 5, ((STRING_TABLE.__str719)|0), ((STRING_TABLE.__str720)|0), $6804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4240; break; } else { __label__ = 13001; break; }
    case 4240: // $25196
      var $25197=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25187);
      var $25198=__ZN11simple_listI16input_type_entryE6appendERS0_($25148, $25197);
      var $25199=$4689;
      var $25200=$3359;
      var $25201=$3360;
      var $25202=$3361;
      var $25203=$result_i529;
      var $25204=$3362;
      var $25205=$3363;
      HEAP32[(($3359)>>2)]=408;
      HEAP32[(($3360)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3361)>>2)]=324;
      var $25206=HEAP32[(($3359)>>2)];
      var $25207=HEAP32[(($3360)>>2)];
      var $25208=HEAP32[(($3361)>>2)];
      var $25209=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25206, $25207, $25208) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4241; break; } else { __label__ = 4243; break; };
    case 4241: // $25210
      HEAP32[(($result_i529)>>2)]=$25209;
      var $25211=HEAP32[(($result_i529)>>2)];
      var $25212=(($25211)|0)==0;
      if ($25212) { __label__ = 4242; break; } else { __label__ = 4247; break; }
    case 4242: // $25213
      var $25214=___cxa_allocate_exception(4);
      var $25215=$25214;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25215);
      (function() { try { __THREW__ = false; return ___cxa_throw($25214, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4246; break; } else { __label__ = 4243; break; }
    case 4243: // $25216
      var $25217=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25218=$25217.f0;
      HEAP32[(($3362)>>2)]=$25218;
      var $25219=$25217.f1;
      HEAP32[(($3363)>>2)]=$25219;
      var $25220=HEAP32[(($3363)>>2)];
      var $25221=(($25220)|0) < 0;
      if ($25221) { __label__ = 4244; break; } else { __label__ = 4245; break; }
    case 4244: // $25222
      var $25223=HEAP32[(($3362)>>2)];
      ___cxa_call_unexpected($25223);
      throw "Reached an unreachable!"
    case 4245: // $25224
      var $25225=HEAP32[(($3362)>>2)];
      var $25226=HEAP32[(($3362)>>2)];
      var $25227=HEAP32[(($3363)>>2)];
      var $25228=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25226, tempValue);
      var $25229=($25228.f1 = $25227, $25228);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4246: // $25230
      throw "Reached an unreachable!"
    case 4247: // $_ZnwjPKci_exit530
      var $25231=HEAP32[(($result_i529)>>2)];
      var $25232=$3359;
      var $25233=$3360;
      var $25234=$3361;
      var $25235=$result_i529;
      var $25236=$3362;
      var $25237=$3363;
      var $25238=$25231;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6813, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4248; break; } else { __label__ = 13006; break; }
    case 4248: // $25239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6814, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4249; break; } else { __label__ = 13006; break; }
    case 4249: // $25240
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6815, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4250; break; } else { __label__ = 13006; break; }
    case 4250: // $25241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4251; break; } else { __label__ = 13006; break; }
    case 4251: // $25242
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4252; break; } else { __label__ = 13006; break; }
    case 4252: // $25243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4253; break; } else { __label__ = 13006; break; }
    case 4253: // $25244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4254; break; } else { __label__ = 13006; break; }
    case 4254: // $25245
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6812, $6813, $6814, $6815, $6816, $6817, $6818, $6819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4255; break; } else { __label__ = 13006; break; }
    case 4255: // $25246
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25238, 58, 6, 5, ((STRING_TABLE.__str721)|0), ((STRING_TABLE.__str722)|0), $6812) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4256; break; } else { __label__ = 13006; break; }
    case 4256: // $25247
      var $25248=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25238);
      var $25249=__ZN11simple_listI16input_type_entryE6appendERS0_($25199, $25248);
      var $25250=$4689;
      var $25251=$3354;
      var $25252=$3355;
      var $25253=$3356;
      var $25254=$result_i531;
      var $25255=$3357;
      var $25256=$3358;
      HEAP32[(($3354)>>2)]=408;
      HEAP32[(($3355)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3356)>>2)]=325;
      var $25257=HEAP32[(($3354)>>2)];
      var $25258=HEAP32[(($3355)>>2)];
      var $25259=HEAP32[(($3356)>>2)];
      var $25260=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25257, $25258, $25259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4257; break; } else { __label__ = 4259; break; };
    case 4257: // $25261
      HEAP32[(($result_i531)>>2)]=$25260;
      var $25262=HEAP32[(($result_i531)>>2)];
      var $25263=(($25262)|0)==0;
      if ($25263) { __label__ = 4258; break; } else { __label__ = 4263; break; }
    case 4258: // $25264
      var $25265=___cxa_allocate_exception(4);
      var $25266=$25265;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25266);
      (function() { try { __THREW__ = false; return ___cxa_throw($25265, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4262; break; } else { __label__ = 4259; break; }
    case 4259: // $25267
      var $25268=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25269=$25268.f0;
      HEAP32[(($3357)>>2)]=$25269;
      var $25270=$25268.f1;
      HEAP32[(($3358)>>2)]=$25270;
      var $25271=HEAP32[(($3358)>>2)];
      var $25272=(($25271)|0) < 0;
      if ($25272) { __label__ = 4260; break; } else { __label__ = 4261; break; }
    case 4260: // $25273
      var $25274=HEAP32[(($3357)>>2)];
      ___cxa_call_unexpected($25274);
      throw "Reached an unreachable!"
    case 4261: // $25275
      var $25276=HEAP32[(($3357)>>2)];
      var $25277=HEAP32[(($3357)>>2)];
      var $25278=HEAP32[(($3358)>>2)];
      var $25279=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25277, tempValue);
      var $25280=($25279.f1 = $25278, $25279);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4262: // $25281
      throw "Reached an unreachable!"
    case 4263: // $_ZnwjPKci_exit532
      var $25282=HEAP32[(($result_i531)>>2)];
      var $25283=$3354;
      var $25284=$3355;
      var $25285=$3356;
      var $25286=$result_i531;
      var $25287=$3357;
      var $25288=$3358;
      var $25289=$25282;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6821, 4, 5, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4264; break; } else { __label__ = 13011; break; }
    case 4264: // $25290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6822, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4265; break; } else { __label__ = 13011; break; }
    case 4265: // $25291
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6823, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4266; break; } else { __label__ = 13011; break; }
    case 4266: // $25292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4267; break; } else { __label__ = 13011; break; }
    case 4267: // $25293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4268; break; } else { __label__ = 13011; break; }
    case 4268: // $25294
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4269; break; } else { __label__ = 13011; break; }
    case 4269: // $25295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4270; break; } else { __label__ = 13011; break; }
    case 4270: // $25296
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6820, $6821, $6822, $6823, $6824, $6825, $6826, $6827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4271; break; } else { __label__ = 13011; break; }
    case 4271: // $25297
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25289, 59, 6, 5, ((STRING_TABLE.__str723)|0), ((STRING_TABLE.__str724)|0), $6820) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4272; break; } else { __label__ = 13011; break; }
    case 4272: // $25298
      var $25299=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25289);
      var $25300=__ZN11simple_listI16input_type_entryE6appendERS0_($25250, $25299);
      var $25301=$4689;
      var $25302=$3349;
      var $25303=$3350;
      var $25304=$3351;
      var $25305=$result_i533;
      var $25306=$3352;
      var $25307=$3353;
      HEAP32[(($3349)>>2)]=408;
      HEAP32[(($3350)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3351)>>2)]=326;
      var $25308=HEAP32[(($3349)>>2)];
      var $25309=HEAP32[(($3350)>>2)];
      var $25310=HEAP32[(($3351)>>2)];
      var $25311=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25308, $25309, $25310) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4273; break; } else { __label__ = 4275; break; };
    case 4273: // $25312
      HEAP32[(($result_i533)>>2)]=$25311;
      var $25313=HEAP32[(($result_i533)>>2)];
      var $25314=(($25313)|0)==0;
      if ($25314) { __label__ = 4274; break; } else { __label__ = 4279; break; }
    case 4274: // $25315
      var $25316=___cxa_allocate_exception(4);
      var $25317=$25316;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25317);
      (function() { try { __THREW__ = false; return ___cxa_throw($25316, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4278; break; } else { __label__ = 4275; break; }
    case 4275: // $25318
      var $25319=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25320=$25319.f0;
      HEAP32[(($3352)>>2)]=$25320;
      var $25321=$25319.f1;
      HEAP32[(($3353)>>2)]=$25321;
      var $25322=HEAP32[(($3353)>>2)];
      var $25323=(($25322)|0) < 0;
      if ($25323) { __label__ = 4276; break; } else { __label__ = 4277; break; }
    case 4276: // $25324
      var $25325=HEAP32[(($3352)>>2)];
      ___cxa_call_unexpected($25325);
      throw "Reached an unreachable!"
    case 4277: // $25326
      var $25327=HEAP32[(($3352)>>2)];
      var $25328=HEAP32[(($3352)>>2)];
      var $25329=HEAP32[(($3353)>>2)];
      var $25330=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25328, tempValue);
      var $25331=($25330.f1 = $25329, $25330);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4278: // $25332
      throw "Reached an unreachable!"
    case 4279: // $_ZnwjPKci_exit534
      var $25333=HEAP32[(($result_i533)>>2)];
      var $25334=$3349;
      var $25335=$3350;
      var $25336=$3351;
      var $25337=$result_i533;
      var $25338=$3352;
      var $25339=$3353;
      var $25340=$25333;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6829, 4, 5, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4280; break; } else { __label__ = 13016; break; }
    case 4280: // $25341
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6830, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4281; break; } else { __label__ = 13016; break; }
    case 4281: // $25342
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6831, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4282; break; } else { __label__ = 13016; break; }
    case 4282: // $25343
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4283; break; } else { __label__ = 13016; break; }
    case 4283: // $25344
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4284; break; } else { __label__ = 13016; break; }
    case 4284: // $25345
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4285; break; } else { __label__ = 13016; break; }
    case 4285: // $25346
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4286; break; } else { __label__ = 13016; break; }
    case 4286: // $25347
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6828, $6829, $6830, $6831, $6832, $6833, $6834, $6835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4287; break; } else { __label__ = 13016; break; }
    case 4287: // $25348
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25340, 60, 6, 5, ((STRING_TABLE.__str725)|0), ((STRING_TABLE.__str726)|0), $6828) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4288; break; } else { __label__ = 13016; break; }
    case 4288: // $25349
      var $25350=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25340);
      var $25351=__ZN11simple_listI16input_type_entryE6appendERS0_($25301, $25350);
      var $25352=$4689;
      var $25353=$3344;
      var $25354=$3345;
      var $25355=$3346;
      var $25356=$result_i535;
      var $25357=$3347;
      var $25358=$3348;
      HEAP32[(($3344)>>2)]=408;
      HEAP32[(($3345)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3346)>>2)]=327;
      var $25359=HEAP32[(($3344)>>2)];
      var $25360=HEAP32[(($3345)>>2)];
      var $25361=HEAP32[(($3346)>>2)];
      var $25362=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25359, $25360, $25361) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4289; break; } else { __label__ = 4291; break; };
    case 4289: // $25363
      HEAP32[(($result_i535)>>2)]=$25362;
      var $25364=HEAP32[(($result_i535)>>2)];
      var $25365=(($25364)|0)==0;
      if ($25365) { __label__ = 4290; break; } else { __label__ = 4295; break; }
    case 4290: // $25366
      var $25367=___cxa_allocate_exception(4);
      var $25368=$25367;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25368);
      (function() { try { __THREW__ = false; return ___cxa_throw($25367, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4294; break; } else { __label__ = 4291; break; }
    case 4291: // $25369
      var $25370=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25371=$25370.f0;
      HEAP32[(($3347)>>2)]=$25371;
      var $25372=$25370.f1;
      HEAP32[(($3348)>>2)]=$25372;
      var $25373=HEAP32[(($3348)>>2)];
      var $25374=(($25373)|0) < 0;
      if ($25374) { __label__ = 4292; break; } else { __label__ = 4293; break; }
    case 4292: // $25375
      var $25376=HEAP32[(($3347)>>2)];
      ___cxa_call_unexpected($25376);
      throw "Reached an unreachable!"
    case 4293: // $25377
      var $25378=HEAP32[(($3347)>>2)];
      var $25379=HEAP32[(($3347)>>2)];
      var $25380=HEAP32[(($3348)>>2)];
      var $25381=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25379, tempValue);
      var $25382=($25381.f1 = $25380, $25381);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4294: // $25383
      throw "Reached an unreachable!"
    case 4295: // $_ZnwjPKci_exit536
      var $25384=HEAP32[(($result_i535)>>2)];
      var $25385=$3344;
      var $25386=$3345;
      var $25387=$3346;
      var $25388=$result_i535;
      var $25389=$3347;
      var $25390=$3348;
      var $25391=$25384;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6837, 4, 5, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4296; break; } else { __label__ = 13021; break; }
    case 4296: // $25392
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6838, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4297; break; } else { __label__ = 13021; break; }
    case 4297: // $25393
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6839, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4298; break; } else { __label__ = 13021; break; }
    case 4298: // $25394
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4299; break; } else { __label__ = 13021; break; }
    case 4299: // $25395
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4300; break; } else { __label__ = 13021; break; }
    case 4300: // $25396
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4301; break; } else { __label__ = 13021; break; }
    case 4301: // $25397
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4302; break; } else { __label__ = 13021; break; }
    case 4302: // $25398
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6836, $6837, $6838, $6839, $6840, $6841, $6842, $6843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4303; break; } else { __label__ = 13021; break; }
    case 4303: // $25399
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25391, 61, 6, 5, ((STRING_TABLE.__str727)|0), ((STRING_TABLE.__str728)|0), $6836) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4304; break; } else { __label__ = 13021; break; }
    case 4304: // $25400
      var $25401=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25391);
      var $25402=__ZN11simple_listI16input_type_entryE6appendERS0_($25352, $25401);
      var $25403=$4689;
      var $25404=$3339;
      var $25405=$3340;
      var $25406=$3341;
      var $25407=$result_i537;
      var $25408=$3342;
      var $25409=$3343;
      HEAP32[(($3339)>>2)]=408;
      HEAP32[(($3340)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3341)>>2)]=328;
      var $25410=HEAP32[(($3339)>>2)];
      var $25411=HEAP32[(($3340)>>2)];
      var $25412=HEAP32[(($3341)>>2)];
      var $25413=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25410, $25411, $25412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4305; break; } else { __label__ = 4307; break; };
    case 4305: // $25414
      HEAP32[(($result_i537)>>2)]=$25413;
      var $25415=HEAP32[(($result_i537)>>2)];
      var $25416=(($25415)|0)==0;
      if ($25416) { __label__ = 4306; break; } else { __label__ = 4311; break; }
    case 4306: // $25417
      var $25418=___cxa_allocate_exception(4);
      var $25419=$25418;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25419);
      (function() { try { __THREW__ = false; return ___cxa_throw($25418, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4310; break; } else { __label__ = 4307; break; }
    case 4307: // $25420
      var $25421=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25422=$25421.f0;
      HEAP32[(($3342)>>2)]=$25422;
      var $25423=$25421.f1;
      HEAP32[(($3343)>>2)]=$25423;
      var $25424=HEAP32[(($3343)>>2)];
      var $25425=(($25424)|0) < 0;
      if ($25425) { __label__ = 4308; break; } else { __label__ = 4309; break; }
    case 4308: // $25426
      var $25427=HEAP32[(($3342)>>2)];
      ___cxa_call_unexpected($25427);
      throw "Reached an unreachable!"
    case 4309: // $25428
      var $25429=HEAP32[(($3342)>>2)];
      var $25430=HEAP32[(($3342)>>2)];
      var $25431=HEAP32[(($3343)>>2)];
      var $25432=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25430, tempValue);
      var $25433=($25432.f1 = $25431, $25432);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4310: // $25434
      throw "Reached an unreachable!"
    case 4311: // $_ZnwjPKci_exit538
      var $25435=HEAP32[(($result_i537)>>2)];
      var $25436=$3339;
      var $25437=$3340;
      var $25438=$3341;
      var $25439=$result_i537;
      var $25440=$3342;
      var $25441=$3343;
      var $25442=$25435;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6845, 4, 5, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4312; break; } else { __label__ = 13026; break; }
    case 4312: // $25443
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6846, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4313; break; } else { __label__ = 13026; break; }
    case 4313: // $25444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6847, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4314; break; } else { __label__ = 13026; break; }
    case 4314: // $25445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4315; break; } else { __label__ = 13026; break; }
    case 4315: // $25446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4316; break; } else { __label__ = 13026; break; }
    case 4316: // $25447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4317; break; } else { __label__ = 13026; break; }
    case 4317: // $25448
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4318; break; } else { __label__ = 13026; break; }
    case 4318: // $25449
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6844, $6845, $6846, $6847, $6848, $6849, $6850, $6851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4319; break; } else { __label__ = 13026; break; }
    case 4319: // $25450
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25442, 62, 6, 5, ((STRING_TABLE.__str729)|0), ((STRING_TABLE.__str730)|0), $6844) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4320; break; } else { __label__ = 13026; break; }
    case 4320: // $25451
      var $25452=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25442);
      var $25453=__ZN11simple_listI16input_type_entryE6appendERS0_($25403, $25452);
      var $25454=$4689;
      var $25455=$3334;
      var $25456=$3335;
      var $25457=$3336;
      var $25458=$result_i539;
      var $25459=$3337;
      var $25460=$3338;
      HEAP32[(($3334)>>2)]=408;
      HEAP32[(($3335)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3336)>>2)]=329;
      var $25461=HEAP32[(($3334)>>2)];
      var $25462=HEAP32[(($3335)>>2)];
      var $25463=HEAP32[(($3336)>>2)];
      var $25464=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25461, $25462, $25463) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4321; break; } else { __label__ = 4323; break; };
    case 4321: // $25465
      HEAP32[(($result_i539)>>2)]=$25464;
      var $25466=HEAP32[(($result_i539)>>2)];
      var $25467=(($25466)|0)==0;
      if ($25467) { __label__ = 4322; break; } else { __label__ = 4327; break; }
    case 4322: // $25468
      var $25469=___cxa_allocate_exception(4);
      var $25470=$25469;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25470);
      (function() { try { __THREW__ = false; return ___cxa_throw($25469, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4326; break; } else { __label__ = 4323; break; }
    case 4323: // $25471
      var $25472=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25473=$25472.f0;
      HEAP32[(($3337)>>2)]=$25473;
      var $25474=$25472.f1;
      HEAP32[(($3338)>>2)]=$25474;
      var $25475=HEAP32[(($3338)>>2)];
      var $25476=(($25475)|0) < 0;
      if ($25476) { __label__ = 4324; break; } else { __label__ = 4325; break; }
    case 4324: // $25477
      var $25478=HEAP32[(($3337)>>2)];
      ___cxa_call_unexpected($25478);
      throw "Reached an unreachable!"
    case 4325: // $25479
      var $25480=HEAP32[(($3337)>>2)];
      var $25481=HEAP32[(($3337)>>2)];
      var $25482=HEAP32[(($3338)>>2)];
      var $25483=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25481, tempValue);
      var $25484=($25483.f1 = $25482, $25483);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4326: // $25485
      throw "Reached an unreachable!"
    case 4327: // $_ZnwjPKci_exit540
      var $25486=HEAP32[(($result_i539)>>2)];
      var $25487=$3334;
      var $25488=$3335;
      var $25489=$3336;
      var $25490=$result_i539;
      var $25491=$3337;
      var $25492=$3338;
      var $25493=$25486;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6853, 4, 5, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4328; break; } else { __label__ = 13031; break; }
    case 4328: // $25494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6854, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4329; break; } else { __label__ = 13031; break; }
    case 4329: // $25495
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6855, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4330; break; } else { __label__ = 13031; break; }
    case 4330: // $25496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4331; break; } else { __label__ = 13031; break; }
    case 4331: // $25497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4332; break; } else { __label__ = 13031; break; }
    case 4332: // $25498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4333; break; } else { __label__ = 13031; break; }
    case 4333: // $25499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4334; break; } else { __label__ = 13031; break; }
    case 4334: // $25500
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6852, $6853, $6854, $6855, $6856, $6857, $6858, $6859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4335; break; } else { __label__ = 13031; break; }
    case 4335: // $25501
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25493, 63, 6, 5, ((STRING_TABLE.__str731)|0), ((STRING_TABLE.__str732)|0), $6852) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4336; break; } else { __label__ = 13031; break; }
    case 4336: // $25502
      var $25503=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25493);
      var $25504=__ZN11simple_listI16input_type_entryE6appendERS0_($25454, $25503);
      var $25505=$4689;
      var $25506=$3329;
      var $25507=$3330;
      var $25508=$3331;
      var $25509=$result_i541;
      var $25510=$3332;
      var $25511=$3333;
      HEAP32[(($3329)>>2)]=408;
      HEAP32[(($3330)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3331)>>2)]=330;
      var $25512=HEAP32[(($3329)>>2)];
      var $25513=HEAP32[(($3330)>>2)];
      var $25514=HEAP32[(($3331)>>2)];
      var $25515=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25512, $25513, $25514) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4337; break; } else { __label__ = 4339; break; };
    case 4337: // $25516
      HEAP32[(($result_i541)>>2)]=$25515;
      var $25517=HEAP32[(($result_i541)>>2)];
      var $25518=(($25517)|0)==0;
      if ($25518) { __label__ = 4338; break; } else { __label__ = 4343; break; }
    case 4338: // $25519
      var $25520=___cxa_allocate_exception(4);
      var $25521=$25520;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25521);
      (function() { try { __THREW__ = false; return ___cxa_throw($25520, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4342; break; } else { __label__ = 4339; break; }
    case 4339: // $25522
      var $25523=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25524=$25523.f0;
      HEAP32[(($3332)>>2)]=$25524;
      var $25525=$25523.f1;
      HEAP32[(($3333)>>2)]=$25525;
      var $25526=HEAP32[(($3333)>>2)];
      var $25527=(($25526)|0) < 0;
      if ($25527) { __label__ = 4340; break; } else { __label__ = 4341; break; }
    case 4340: // $25528
      var $25529=HEAP32[(($3332)>>2)];
      ___cxa_call_unexpected($25529);
      throw "Reached an unreachable!"
    case 4341: // $25530
      var $25531=HEAP32[(($3332)>>2)];
      var $25532=HEAP32[(($3332)>>2)];
      var $25533=HEAP32[(($3333)>>2)];
      var $25534=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25532, tempValue);
      var $25535=($25534.f1 = $25533, $25534);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4342: // $25536
      throw "Reached an unreachable!"
    case 4343: // $_ZnwjPKci_exit542
      var $25537=HEAP32[(($result_i541)>>2)];
      var $25538=$3329;
      var $25539=$3330;
      var $25540=$3331;
      var $25541=$result_i541;
      var $25542=$3332;
      var $25543=$3333;
      var $25544=$25537;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6861, 4, 5, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4344; break; } else { __label__ = 13036; break; }
    case 4344: // $25545
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6862, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4345; break; } else { __label__ = 13036; break; }
    case 4345: // $25546
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6863, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4346; break; } else { __label__ = 13036; break; }
    case 4346: // $25547
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4347; break; } else { __label__ = 13036; break; }
    case 4347: // $25548
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4348; break; } else { __label__ = 13036; break; }
    case 4348: // $25549
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4349; break; } else { __label__ = 13036; break; }
    case 4349: // $25550
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4350; break; } else { __label__ = 13036; break; }
    case 4350: // $25551
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6860, $6861, $6862, $6863, $6864, $6865, $6866, $6867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4351; break; } else { __label__ = 13036; break; }
    case 4351: // $25552
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25544, 64, 6, 5, ((STRING_TABLE.__str733)|0), ((STRING_TABLE.__str734)|0), $6860) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4352; break; } else { __label__ = 13036; break; }
    case 4352: // $25553
      var $25554=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25544);
      var $25555=__ZN11simple_listI16input_type_entryE6appendERS0_($25505, $25554);
      var $25556=$4689;
      var $25557=$3324;
      var $25558=$3325;
      var $25559=$3326;
      var $25560=$result_i543;
      var $25561=$3327;
      var $25562=$3328;
      HEAP32[(($3324)>>2)]=408;
      HEAP32[(($3325)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3326)>>2)]=331;
      var $25563=HEAP32[(($3324)>>2)];
      var $25564=HEAP32[(($3325)>>2)];
      var $25565=HEAP32[(($3326)>>2)];
      var $25566=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25563, $25564, $25565) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4353; break; } else { __label__ = 4355; break; };
    case 4353: // $25567
      HEAP32[(($result_i543)>>2)]=$25566;
      var $25568=HEAP32[(($result_i543)>>2)];
      var $25569=(($25568)|0)==0;
      if ($25569) { __label__ = 4354; break; } else { __label__ = 4359; break; }
    case 4354: // $25570
      var $25571=___cxa_allocate_exception(4);
      var $25572=$25571;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25572);
      (function() { try { __THREW__ = false; return ___cxa_throw($25571, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4358; break; } else { __label__ = 4355; break; }
    case 4355: // $25573
      var $25574=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25575=$25574.f0;
      HEAP32[(($3327)>>2)]=$25575;
      var $25576=$25574.f1;
      HEAP32[(($3328)>>2)]=$25576;
      var $25577=HEAP32[(($3328)>>2)];
      var $25578=(($25577)|0) < 0;
      if ($25578) { __label__ = 4356; break; } else { __label__ = 4357; break; }
    case 4356: // $25579
      var $25580=HEAP32[(($3327)>>2)];
      ___cxa_call_unexpected($25580);
      throw "Reached an unreachable!"
    case 4357: // $25581
      var $25582=HEAP32[(($3327)>>2)];
      var $25583=HEAP32[(($3327)>>2)];
      var $25584=HEAP32[(($3328)>>2)];
      var $25585=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25583, tempValue);
      var $25586=($25585.f1 = $25584, $25585);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4358: // $25587
      throw "Reached an unreachable!"
    case 4359: // $_ZnwjPKci_exit544
      var $25588=HEAP32[(($result_i543)>>2)];
      var $25589=$3324;
      var $25590=$3325;
      var $25591=$3326;
      var $25592=$result_i543;
      var $25593=$3327;
      var $25594=$3328;
      var $25595=$25588;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6869, 4, 5, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4360; break; } else { __label__ = 13041; break; }
    case 4360: // $25596
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6870, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4361; break; } else { __label__ = 13041; break; }
    case 4361: // $25597
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6871, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4362; break; } else { __label__ = 13041; break; }
    case 4362: // $25598
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4363; break; } else { __label__ = 13041; break; }
    case 4363: // $25599
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4364; break; } else { __label__ = 13041; break; }
    case 4364: // $25600
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4365; break; } else { __label__ = 13041; break; }
    case 4365: // $25601
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4366; break; } else { __label__ = 13041; break; }
    case 4366: // $25602
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6868, $6869, $6870, $6871, $6872, $6873, $6874, $6875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4367; break; } else { __label__ = 13041; break; }
    case 4367: // $25603
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25595, 65, 6, 5, ((STRING_TABLE.__str735)|0), ((STRING_TABLE.__str736)|0), $6868) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4368; break; } else { __label__ = 13041; break; }
    case 4368: // $25604
      var $25605=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25595);
      var $25606=__ZN11simple_listI16input_type_entryE6appendERS0_($25556, $25605);
      var $25607=$4689;
      var $25608=$3319;
      var $25609=$3320;
      var $25610=$3321;
      var $25611=$result_i545;
      var $25612=$3322;
      var $25613=$3323;
      HEAP32[(($3319)>>2)]=408;
      HEAP32[(($3320)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3321)>>2)]=332;
      var $25614=HEAP32[(($3319)>>2)];
      var $25615=HEAP32[(($3320)>>2)];
      var $25616=HEAP32[(($3321)>>2)];
      var $25617=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25614, $25615, $25616) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4369; break; } else { __label__ = 4371; break; };
    case 4369: // $25618
      HEAP32[(($result_i545)>>2)]=$25617;
      var $25619=HEAP32[(($result_i545)>>2)];
      var $25620=(($25619)|0)==0;
      if ($25620) { __label__ = 4370; break; } else { __label__ = 4375; break; }
    case 4370: // $25621
      var $25622=___cxa_allocate_exception(4);
      var $25623=$25622;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25623);
      (function() { try { __THREW__ = false; return ___cxa_throw($25622, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4374; break; } else { __label__ = 4371; break; }
    case 4371: // $25624
      var $25625=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25626=$25625.f0;
      HEAP32[(($3322)>>2)]=$25626;
      var $25627=$25625.f1;
      HEAP32[(($3323)>>2)]=$25627;
      var $25628=HEAP32[(($3323)>>2)];
      var $25629=(($25628)|0) < 0;
      if ($25629) { __label__ = 4372; break; } else { __label__ = 4373; break; }
    case 4372: // $25630
      var $25631=HEAP32[(($3322)>>2)];
      ___cxa_call_unexpected($25631);
      throw "Reached an unreachable!"
    case 4373: // $25632
      var $25633=HEAP32[(($3322)>>2)];
      var $25634=HEAP32[(($3322)>>2)];
      var $25635=HEAP32[(($3323)>>2)];
      var $25636=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25634, tempValue);
      var $25637=($25636.f1 = $25635, $25636);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4374: // $25638
      throw "Reached an unreachable!"
    case 4375: // $_ZnwjPKci_exit546
      var $25639=HEAP32[(($result_i545)>>2)];
      var $25640=$3319;
      var $25641=$3320;
      var $25642=$3321;
      var $25643=$result_i545;
      var $25644=$3322;
      var $25645=$3323;
      var $25646=$25639;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6877, 4, 5, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4376; break; } else { __label__ = 13046; break; }
    case 4376: // $25647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6878, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4377; break; } else { __label__ = 13046; break; }
    case 4377: // $25648
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6879, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4378; break; } else { __label__ = 13046; break; }
    case 4378: // $25649
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4379; break; } else { __label__ = 13046; break; }
    case 4379: // $25650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4380; break; } else { __label__ = 13046; break; }
    case 4380: // $25651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4381; break; } else { __label__ = 13046; break; }
    case 4381: // $25652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4382; break; } else { __label__ = 13046; break; }
    case 4382: // $25653
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6876, $6877, $6878, $6879, $6880, $6881, $6882, $6883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4383; break; } else { __label__ = 13046; break; }
    case 4383: // $25654
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25646, 66, 6, 5, ((STRING_TABLE.__str737)|0), ((STRING_TABLE.__str738)|0), $6876) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4384; break; } else { __label__ = 13046; break; }
    case 4384: // $25655
      var $25656=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25646);
      var $25657=__ZN11simple_listI16input_type_entryE6appendERS0_($25607, $25656);
      var $25658=$4689;
      var $25659=$3314;
      var $25660=$3315;
      var $25661=$3316;
      var $25662=$result_i547;
      var $25663=$3317;
      var $25664=$3318;
      HEAP32[(($3314)>>2)]=408;
      HEAP32[(($3315)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3316)>>2)]=333;
      var $25665=HEAP32[(($3314)>>2)];
      var $25666=HEAP32[(($3315)>>2)];
      var $25667=HEAP32[(($3316)>>2)];
      var $25668=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25665, $25666, $25667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4385; break; } else { __label__ = 4387; break; };
    case 4385: // $25669
      HEAP32[(($result_i547)>>2)]=$25668;
      var $25670=HEAP32[(($result_i547)>>2)];
      var $25671=(($25670)|0)==0;
      if ($25671) { __label__ = 4386; break; } else { __label__ = 4391; break; }
    case 4386: // $25672
      var $25673=___cxa_allocate_exception(4);
      var $25674=$25673;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25674);
      (function() { try { __THREW__ = false; return ___cxa_throw($25673, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4390; break; } else { __label__ = 4387; break; }
    case 4387: // $25675
      var $25676=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25677=$25676.f0;
      HEAP32[(($3317)>>2)]=$25677;
      var $25678=$25676.f1;
      HEAP32[(($3318)>>2)]=$25678;
      var $25679=HEAP32[(($3318)>>2)];
      var $25680=(($25679)|0) < 0;
      if ($25680) { __label__ = 4388; break; } else { __label__ = 4389; break; }
    case 4388: // $25681
      var $25682=HEAP32[(($3317)>>2)];
      ___cxa_call_unexpected($25682);
      throw "Reached an unreachable!"
    case 4389: // $25683
      var $25684=HEAP32[(($3317)>>2)];
      var $25685=HEAP32[(($3317)>>2)];
      var $25686=HEAP32[(($3318)>>2)];
      var $25687=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25685, tempValue);
      var $25688=($25687.f1 = $25686, $25687);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4390: // $25689
      throw "Reached an unreachable!"
    case 4391: // $_ZnwjPKci_exit548
      var $25690=HEAP32[(($result_i547)>>2)];
      var $25691=$3314;
      var $25692=$3315;
      var $25693=$3316;
      var $25694=$result_i547;
      var $25695=$3317;
      var $25696=$3318;
      var $25697=$25690;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6885, 4, 5, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4392; break; } else { __label__ = 13051; break; }
    case 4392: // $25698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6886, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4393; break; } else { __label__ = 13051; break; }
    case 4393: // $25699
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6887, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4394; break; } else { __label__ = 13051; break; }
    case 4394: // $25700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4395; break; } else { __label__ = 13051; break; }
    case 4395: // $25701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4396; break; } else { __label__ = 13051; break; }
    case 4396: // $25702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4397; break; } else { __label__ = 13051; break; }
    case 4397: // $25703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4398; break; } else { __label__ = 13051; break; }
    case 4398: // $25704
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6884, $6885, $6886, $6887, $6888, $6889, $6890, $6891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4399; break; } else { __label__ = 13051; break; }
    case 4399: // $25705
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25697, 67, 6, 5, ((STRING_TABLE.__str739)|0), ((STRING_TABLE.__str740)|0), $6884) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4400; break; } else { __label__ = 13051; break; }
    case 4400: // $25706
      var $25707=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25697);
      var $25708=__ZN11simple_listI16input_type_entryE6appendERS0_($25658, $25707);
      var $25709=$4689;
      var $25710=$3309;
      var $25711=$3310;
      var $25712=$3311;
      var $25713=$result_i549;
      var $25714=$3312;
      var $25715=$3313;
      HEAP32[(($3309)>>2)]=408;
      HEAP32[(($3310)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3311)>>2)]=334;
      var $25716=HEAP32[(($3309)>>2)];
      var $25717=HEAP32[(($3310)>>2)];
      var $25718=HEAP32[(($3311)>>2)];
      var $25719=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25716, $25717, $25718) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4401; break; } else { __label__ = 4403; break; };
    case 4401: // $25720
      HEAP32[(($result_i549)>>2)]=$25719;
      var $25721=HEAP32[(($result_i549)>>2)];
      var $25722=(($25721)|0)==0;
      if ($25722) { __label__ = 4402; break; } else { __label__ = 4407; break; }
    case 4402: // $25723
      var $25724=___cxa_allocate_exception(4);
      var $25725=$25724;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25725);
      (function() { try { __THREW__ = false; return ___cxa_throw($25724, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4406; break; } else { __label__ = 4403; break; }
    case 4403: // $25726
      var $25727=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25728=$25727.f0;
      HEAP32[(($3312)>>2)]=$25728;
      var $25729=$25727.f1;
      HEAP32[(($3313)>>2)]=$25729;
      var $25730=HEAP32[(($3313)>>2)];
      var $25731=(($25730)|0) < 0;
      if ($25731) { __label__ = 4404; break; } else { __label__ = 4405; break; }
    case 4404: // $25732
      var $25733=HEAP32[(($3312)>>2)];
      ___cxa_call_unexpected($25733);
      throw "Reached an unreachable!"
    case 4405: // $25734
      var $25735=HEAP32[(($3312)>>2)];
      var $25736=HEAP32[(($3312)>>2)];
      var $25737=HEAP32[(($3313)>>2)];
      var $25738=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25736, tempValue);
      var $25739=($25738.f1 = $25737, $25738);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4406: // $25740
      throw "Reached an unreachable!"
    case 4407: // $_ZnwjPKci_exit550
      var $25741=HEAP32[(($result_i549)>>2)];
      var $25742=$3309;
      var $25743=$3310;
      var $25744=$3311;
      var $25745=$result_i549;
      var $25746=$3312;
      var $25747=$3313;
      var $25748=$25741;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6893, 4, 5, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4408; break; } else { __label__ = 13056; break; }
    case 4408: // $25749
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6894, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4409; break; } else { __label__ = 13056; break; }
    case 4409: // $25750
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6895, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4410; break; } else { __label__ = 13056; break; }
    case 4410: // $25751
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4411; break; } else { __label__ = 13056; break; }
    case 4411: // $25752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4412; break; } else { __label__ = 13056; break; }
    case 4412: // $25753
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4413; break; } else { __label__ = 13056; break; }
    case 4413: // $25754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4414; break; } else { __label__ = 13056; break; }
    case 4414: // $25755
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6892, $6893, $6894, $6895, $6896, $6897, $6898, $6899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4415; break; } else { __label__ = 13056; break; }
    case 4415: // $25756
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25748, 68, 6, 5, ((STRING_TABLE.__str741)|0), ((STRING_TABLE.__str742)|0), $6892) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4416; break; } else { __label__ = 13056; break; }
    case 4416: // $25757
      var $25758=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25748);
      var $25759=__ZN11simple_listI16input_type_entryE6appendERS0_($25709, $25758);
      var $25760=$4689;
      var $25761=$3304;
      var $25762=$3305;
      var $25763=$3306;
      var $25764=$result_i551;
      var $25765=$3307;
      var $25766=$3308;
      HEAP32[(($3304)>>2)]=408;
      HEAP32[(($3305)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3306)>>2)]=335;
      var $25767=HEAP32[(($3304)>>2)];
      var $25768=HEAP32[(($3305)>>2)];
      var $25769=HEAP32[(($3306)>>2)];
      var $25770=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25767, $25768, $25769) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4417; break; } else { __label__ = 4419; break; };
    case 4417: // $25771
      HEAP32[(($result_i551)>>2)]=$25770;
      var $25772=HEAP32[(($result_i551)>>2)];
      var $25773=(($25772)|0)==0;
      if ($25773) { __label__ = 4418; break; } else { __label__ = 4423; break; }
    case 4418: // $25774
      var $25775=___cxa_allocate_exception(4);
      var $25776=$25775;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25776);
      (function() { try { __THREW__ = false; return ___cxa_throw($25775, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4422; break; } else { __label__ = 4419; break; }
    case 4419: // $25777
      var $25778=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25779=$25778.f0;
      HEAP32[(($3307)>>2)]=$25779;
      var $25780=$25778.f1;
      HEAP32[(($3308)>>2)]=$25780;
      var $25781=HEAP32[(($3308)>>2)];
      var $25782=(($25781)|0) < 0;
      if ($25782) { __label__ = 4420; break; } else { __label__ = 4421; break; }
    case 4420: // $25783
      var $25784=HEAP32[(($3307)>>2)];
      ___cxa_call_unexpected($25784);
      throw "Reached an unreachable!"
    case 4421: // $25785
      var $25786=HEAP32[(($3307)>>2)];
      var $25787=HEAP32[(($3307)>>2)];
      var $25788=HEAP32[(($3308)>>2)];
      var $25789=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25787, tempValue);
      var $25790=($25789.f1 = $25788, $25789);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4422: // $25791
      throw "Reached an unreachable!"
    case 4423: // $_ZnwjPKci_exit552
      var $25792=HEAP32[(($result_i551)>>2)];
      var $25793=$3304;
      var $25794=$3305;
      var $25795=$3306;
      var $25796=$result_i551;
      var $25797=$3307;
      var $25798=$3308;
      var $25799=$25792;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6901, 4, 5, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4424; break; } else { __label__ = 13061; break; }
    case 4424: // $25800
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6902, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4425; break; } else { __label__ = 13061; break; }
    case 4425: // $25801
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6903, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4426; break; } else { __label__ = 13061; break; }
    case 4426: // $25802
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4427; break; } else { __label__ = 13061; break; }
    case 4427: // $25803
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4428; break; } else { __label__ = 13061; break; }
    case 4428: // $25804
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4429; break; } else { __label__ = 13061; break; }
    case 4429: // $25805
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4430; break; } else { __label__ = 13061; break; }
    case 4430: // $25806
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6900, $6901, $6902, $6903, $6904, $6905, $6906, $6907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4431; break; } else { __label__ = 13061; break; }
    case 4431: // $25807
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25799, 69, 6, 5, ((STRING_TABLE.__str743)|0), ((STRING_TABLE.__str744)|0), $6900) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4432; break; } else { __label__ = 13061; break; }
    case 4432: // $25808
      var $25809=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25799);
      var $25810=__ZN11simple_listI16input_type_entryE6appendERS0_($25760, $25809);
      var $25811=$4689;
      var $25812=$3299;
      var $25813=$3300;
      var $25814=$3301;
      var $25815=$result_i553;
      var $25816=$3302;
      var $25817=$3303;
      HEAP32[(($3299)>>2)]=408;
      HEAP32[(($3300)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3301)>>2)]=336;
      var $25818=HEAP32[(($3299)>>2)];
      var $25819=HEAP32[(($3300)>>2)];
      var $25820=HEAP32[(($3301)>>2)];
      var $25821=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25818, $25819, $25820) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4433; break; } else { __label__ = 4435; break; };
    case 4433: // $25822
      HEAP32[(($result_i553)>>2)]=$25821;
      var $25823=HEAP32[(($result_i553)>>2)];
      var $25824=(($25823)|0)==0;
      if ($25824) { __label__ = 4434; break; } else { __label__ = 4439; break; }
    case 4434: // $25825
      var $25826=___cxa_allocate_exception(4);
      var $25827=$25826;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25827);
      (function() { try { __THREW__ = false; return ___cxa_throw($25826, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4438; break; } else { __label__ = 4435; break; }
    case 4435: // $25828
      var $25829=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25830=$25829.f0;
      HEAP32[(($3302)>>2)]=$25830;
      var $25831=$25829.f1;
      HEAP32[(($3303)>>2)]=$25831;
      var $25832=HEAP32[(($3303)>>2)];
      var $25833=(($25832)|0) < 0;
      if ($25833) { __label__ = 4436; break; } else { __label__ = 4437; break; }
    case 4436: // $25834
      var $25835=HEAP32[(($3302)>>2)];
      ___cxa_call_unexpected($25835);
      throw "Reached an unreachable!"
    case 4437: // $25836
      var $25837=HEAP32[(($3302)>>2)];
      var $25838=HEAP32[(($3302)>>2)];
      var $25839=HEAP32[(($3303)>>2)];
      var $25840=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25838, tempValue);
      var $25841=($25840.f1 = $25839, $25840);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4438: // $25842
      throw "Reached an unreachable!"
    case 4439: // $_ZnwjPKci_exit554
      var $25843=HEAP32[(($result_i553)>>2)];
      var $25844=$3299;
      var $25845=$3300;
      var $25846=$3301;
      var $25847=$result_i553;
      var $25848=$3302;
      var $25849=$3303;
      var $25850=$25843;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6909, 4, 5, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4440; break; } else { __label__ = 13066; break; }
    case 4440: // $25851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6910, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4441; break; } else { __label__ = 13066; break; }
    case 4441: // $25852
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6911, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4442; break; } else { __label__ = 13066; break; }
    case 4442: // $25853
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4443; break; } else { __label__ = 13066; break; }
    case 4443: // $25854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4444; break; } else { __label__ = 13066; break; }
    case 4444: // $25855
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4445; break; } else { __label__ = 13066; break; }
    case 4445: // $25856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4446; break; } else { __label__ = 13066; break; }
    case 4446: // $25857
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6908, $6909, $6910, $6911, $6912, $6913, $6914, $6915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4447; break; } else { __label__ = 13066; break; }
    case 4447: // $25858
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25850, 70, 6, 5, ((STRING_TABLE.__str745)|0), ((STRING_TABLE.__str746)|0), $6908) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4448; break; } else { __label__ = 13066; break; }
    case 4448: // $25859
      var $25860=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25850);
      var $25861=__ZN11simple_listI16input_type_entryE6appendERS0_($25811, $25860);
      var $25862=$4689;
      var $25863=$3294;
      var $25864=$3295;
      var $25865=$3296;
      var $25866=$result_i555;
      var $25867=$3297;
      var $25868=$3298;
      HEAP32[(($3294)>>2)]=408;
      HEAP32[(($3295)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3296)>>2)]=337;
      var $25869=HEAP32[(($3294)>>2)];
      var $25870=HEAP32[(($3295)>>2)];
      var $25871=HEAP32[(($3296)>>2)];
      var $25872=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25869, $25870, $25871) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4449; break; } else { __label__ = 4451; break; };
    case 4449: // $25873
      HEAP32[(($result_i555)>>2)]=$25872;
      var $25874=HEAP32[(($result_i555)>>2)];
      var $25875=(($25874)|0)==0;
      if ($25875) { __label__ = 4450; break; } else { __label__ = 4455; break; }
    case 4450: // $25876
      var $25877=___cxa_allocate_exception(4);
      var $25878=$25877;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25878);
      (function() { try { __THREW__ = false; return ___cxa_throw($25877, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4454; break; } else { __label__ = 4451; break; }
    case 4451: // $25879
      var $25880=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25881=$25880.f0;
      HEAP32[(($3297)>>2)]=$25881;
      var $25882=$25880.f1;
      HEAP32[(($3298)>>2)]=$25882;
      var $25883=HEAP32[(($3298)>>2)];
      var $25884=(($25883)|0) < 0;
      if ($25884) { __label__ = 4452; break; } else { __label__ = 4453; break; }
    case 4452: // $25885
      var $25886=HEAP32[(($3297)>>2)];
      ___cxa_call_unexpected($25886);
      throw "Reached an unreachable!"
    case 4453: // $25887
      var $25888=HEAP32[(($3297)>>2)];
      var $25889=HEAP32[(($3297)>>2)];
      var $25890=HEAP32[(($3298)>>2)];
      var $25891=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25889, tempValue);
      var $25892=($25891.f1 = $25890, $25891);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4454: // $25893
      throw "Reached an unreachable!"
    case 4455: // $_ZnwjPKci_exit556
      var $25894=HEAP32[(($result_i555)>>2)];
      var $25895=$3294;
      var $25896=$3295;
      var $25897=$3296;
      var $25898=$result_i555;
      var $25899=$3297;
      var $25900=$3298;
      var $25901=$25894;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6917, 4, 5, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4456; break; } else { __label__ = 13071; break; }
    case 4456: // $25902
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6918, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4457; break; } else { __label__ = 13071; break; }
    case 4457: // $25903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6919, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4458; break; } else { __label__ = 13071; break; }
    case 4458: // $25904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4459; break; } else { __label__ = 13071; break; }
    case 4459: // $25905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4460; break; } else { __label__ = 13071; break; }
    case 4460: // $25906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4461; break; } else { __label__ = 13071; break; }
    case 4461: // $25907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4462; break; } else { __label__ = 13071; break; }
    case 4462: // $25908
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6916, $6917, $6918, $6919, $6920, $6921, $6922, $6923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4463; break; } else { __label__ = 13071; break; }
    case 4463: // $25909
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25901, 71, 6, 5, ((STRING_TABLE.__str747)|0), ((STRING_TABLE.__str748)|0), $6916) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4464; break; } else { __label__ = 13071; break; }
    case 4464: // $25910
      var $25911=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25901);
      var $25912=__ZN11simple_listI16input_type_entryE6appendERS0_($25862, $25911);
      var $25913=$4689;
      var $25914=$3289;
      var $25915=$3290;
      var $25916=$3291;
      var $25917=$result_i557;
      var $25918=$3292;
      var $25919=$3293;
      HEAP32[(($3289)>>2)]=408;
      HEAP32[(($3290)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3291)>>2)]=338;
      var $25920=HEAP32[(($3289)>>2)];
      var $25921=HEAP32[(($3290)>>2)];
      var $25922=HEAP32[(($3291)>>2)];
      var $25923=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25920, $25921, $25922) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4465; break; } else { __label__ = 4467; break; };
    case 4465: // $25924
      HEAP32[(($result_i557)>>2)]=$25923;
      var $25925=HEAP32[(($result_i557)>>2)];
      var $25926=(($25925)|0)==0;
      if ($25926) { __label__ = 4466; break; } else { __label__ = 4471; break; }
    case 4466: // $25927
      var $25928=___cxa_allocate_exception(4);
      var $25929=$25928;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25929);
      (function() { try { __THREW__ = false; return ___cxa_throw($25928, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4470; break; } else { __label__ = 4467; break; }
    case 4467: // $25930
      var $25931=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25932=$25931.f0;
      HEAP32[(($3292)>>2)]=$25932;
      var $25933=$25931.f1;
      HEAP32[(($3293)>>2)]=$25933;
      var $25934=HEAP32[(($3293)>>2)];
      var $25935=(($25934)|0) < 0;
      if ($25935) { __label__ = 4468; break; } else { __label__ = 4469; break; }
    case 4468: // $25936
      var $25937=HEAP32[(($3292)>>2)];
      ___cxa_call_unexpected($25937);
      throw "Reached an unreachable!"
    case 4469: // $25938
      var $25939=HEAP32[(($3292)>>2)];
      var $25940=HEAP32[(($3292)>>2)];
      var $25941=HEAP32[(($3293)>>2)];
      var $25942=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25940, tempValue);
      var $25943=($25942.f1 = $25941, $25942);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4470: // $25944
      throw "Reached an unreachable!"
    case 4471: // $_ZnwjPKci_exit558
      var $25945=HEAP32[(($result_i557)>>2)];
      var $25946=$3289;
      var $25947=$3290;
      var $25948=$3291;
      var $25949=$result_i557;
      var $25950=$3292;
      var $25951=$3293;
      var $25952=$25945;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6925, 4, 5, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4472; break; } else { __label__ = 13076; break; }
    case 4472: // $25953
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6926, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4473; break; } else { __label__ = 13076; break; }
    case 4473: // $25954
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6927, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4474; break; } else { __label__ = 13076; break; }
    case 4474: // $25955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4475; break; } else { __label__ = 13076; break; }
    case 4475: // $25956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4476; break; } else { __label__ = 13076; break; }
    case 4476: // $25957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4477; break; } else { __label__ = 13076; break; }
    case 4477: // $25958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4478; break; } else { __label__ = 13076; break; }
    case 4478: // $25959
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6924, $6925, $6926, $6927, $6928, $6929, $6930, $6931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4479; break; } else { __label__ = 13076; break; }
    case 4479: // $25960
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($25952, 72, 6, 5, ((STRING_TABLE.__str749)|0), ((STRING_TABLE.__str750)|0), $6924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4480; break; } else { __label__ = 13076; break; }
    case 4480: // $25961
      var $25962=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $25952);
      var $25963=__ZN11simple_listI16input_type_entryE6appendERS0_($25913, $25962);
      var $25964=$4689;
      var $25965=$3284;
      var $25966=$3285;
      var $25967=$3286;
      var $25968=$result_i559;
      var $25969=$3287;
      var $25970=$3288;
      HEAP32[(($3284)>>2)]=408;
      HEAP32[(($3285)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3286)>>2)]=339;
      var $25971=HEAP32[(($3284)>>2)];
      var $25972=HEAP32[(($3285)>>2)];
      var $25973=HEAP32[(($3286)>>2)];
      var $25974=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($25971, $25972, $25973) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4481; break; } else { __label__ = 4483; break; };
    case 4481: // $25975
      HEAP32[(($result_i559)>>2)]=$25974;
      var $25976=HEAP32[(($result_i559)>>2)];
      var $25977=(($25976)|0)==0;
      if ($25977) { __label__ = 4482; break; } else { __label__ = 4487; break; }
    case 4482: // $25978
      var $25979=___cxa_allocate_exception(4);
      var $25980=$25979;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25980);
      (function() { try { __THREW__ = false; return ___cxa_throw($25979, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4486; break; } else { __label__ = 4483; break; }
    case 4483: // $25981
      var $25982=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25983=$25982.f0;
      HEAP32[(($3287)>>2)]=$25983;
      var $25984=$25982.f1;
      HEAP32[(($3288)>>2)]=$25984;
      var $25985=HEAP32[(($3288)>>2)];
      var $25986=(($25985)|0) < 0;
      if ($25986) { __label__ = 4484; break; } else { __label__ = 4485; break; }
    case 4484: // $25987
      var $25988=HEAP32[(($3287)>>2)];
      ___cxa_call_unexpected($25988);
      throw "Reached an unreachable!"
    case 4485: // $25989
      var $25990=HEAP32[(($3287)>>2)];
      var $25991=HEAP32[(($3287)>>2)];
      var $25992=HEAP32[(($3288)>>2)];
      var $25993=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25991, tempValue);
      var $25994=($25993.f1 = $25992, $25993);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4486: // $25995
      throw "Reached an unreachable!"
    case 4487: // $_ZnwjPKci_exit560
      var $25996=HEAP32[(($result_i559)>>2)];
      var $25997=$3284;
      var $25998=$3285;
      var $25999=$3286;
      var $26000=$result_i559;
      var $26001=$3287;
      var $26002=$3288;
      var $26003=$25996;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6933, 4, 5, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4488; break; } else { __label__ = 13081; break; }
    case 4488: // $26004
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6934, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4489; break; } else { __label__ = 13081; break; }
    case 4489: // $26005
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6935, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4490; break; } else { __label__ = 13081; break; }
    case 4490: // $26006
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4491; break; } else { __label__ = 13081; break; }
    case 4491: // $26007
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4492; break; } else { __label__ = 13081; break; }
    case 4492: // $26008
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4493; break; } else { __label__ = 13081; break; }
    case 4493: // $26009
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4494; break; } else { __label__ = 13081; break; }
    case 4494: // $26010
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6932, $6933, $6934, $6935, $6936, $6937, $6938, $6939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4495; break; } else { __label__ = 13081; break; }
    case 4495: // $26011
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26003, 73, 6, 5, ((STRING_TABLE.__str751)|0), ((STRING_TABLE.__str752)|0), $6932) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4496; break; } else { __label__ = 13081; break; }
    case 4496: // $26012
      var $26013=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26003);
      var $26014=__ZN11simple_listI16input_type_entryE6appendERS0_($25964, $26013);
      var $26015=$4689;
      var $26016=$3279;
      var $26017=$3280;
      var $26018=$3281;
      var $26019=$result_i561;
      var $26020=$3282;
      var $26021=$3283;
      HEAP32[(($3279)>>2)]=408;
      HEAP32[(($3280)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3281)>>2)]=340;
      var $26022=HEAP32[(($3279)>>2)];
      var $26023=HEAP32[(($3280)>>2)];
      var $26024=HEAP32[(($3281)>>2)];
      var $26025=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26022, $26023, $26024) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4497; break; } else { __label__ = 4499; break; };
    case 4497: // $26026
      HEAP32[(($result_i561)>>2)]=$26025;
      var $26027=HEAP32[(($result_i561)>>2)];
      var $26028=(($26027)|0)==0;
      if ($26028) { __label__ = 4498; break; } else { __label__ = 4503; break; }
    case 4498: // $26029
      var $26030=___cxa_allocate_exception(4);
      var $26031=$26030;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26031);
      (function() { try { __THREW__ = false; return ___cxa_throw($26030, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4502; break; } else { __label__ = 4499; break; }
    case 4499: // $26032
      var $26033=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26034=$26033.f0;
      HEAP32[(($3282)>>2)]=$26034;
      var $26035=$26033.f1;
      HEAP32[(($3283)>>2)]=$26035;
      var $26036=HEAP32[(($3283)>>2)];
      var $26037=(($26036)|0) < 0;
      if ($26037) { __label__ = 4500; break; } else { __label__ = 4501; break; }
    case 4500: // $26038
      var $26039=HEAP32[(($3282)>>2)];
      ___cxa_call_unexpected($26039);
      throw "Reached an unreachable!"
    case 4501: // $26040
      var $26041=HEAP32[(($3282)>>2)];
      var $26042=HEAP32[(($3282)>>2)];
      var $26043=HEAP32[(($3283)>>2)];
      var $26044=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26042, tempValue);
      var $26045=($26044.f1 = $26043, $26044);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4502: // $26046
      throw "Reached an unreachable!"
    case 4503: // $_ZnwjPKci_exit562
      var $26047=HEAP32[(($result_i561)>>2)];
      var $26048=$3279;
      var $26049=$3280;
      var $26050=$3281;
      var $26051=$result_i561;
      var $26052=$3282;
      var $26053=$3283;
      var $26054=$26047;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6941, 4, 5, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4504; break; } else { __label__ = 13086; break; }
    case 4504: // $26055
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6942, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4505; break; } else { __label__ = 13086; break; }
    case 4505: // $26056
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6943, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4506; break; } else { __label__ = 13086; break; }
    case 4506: // $26057
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4507; break; } else { __label__ = 13086; break; }
    case 4507: // $26058
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4508; break; } else { __label__ = 13086; break; }
    case 4508: // $26059
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4509; break; } else { __label__ = 13086; break; }
    case 4509: // $26060
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4510; break; } else { __label__ = 13086; break; }
    case 4510: // $26061
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6940, $6941, $6942, $6943, $6944, $6945, $6946, $6947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4511; break; } else { __label__ = 13086; break; }
    case 4511: // $26062
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26054, 74, 6, 5, ((STRING_TABLE.__str753)|0), ((STRING_TABLE.__str754)|0), $6940) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4512; break; } else { __label__ = 13086; break; }
    case 4512: // $26063
      var $26064=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26054);
      var $26065=__ZN11simple_listI16input_type_entryE6appendERS0_($26015, $26064);
      var $26066=$4689;
      var $26067=$3274;
      var $26068=$3275;
      var $26069=$3276;
      var $26070=$result_i563;
      var $26071=$3277;
      var $26072=$3278;
      HEAP32[(($3274)>>2)]=408;
      HEAP32[(($3275)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3276)>>2)]=341;
      var $26073=HEAP32[(($3274)>>2)];
      var $26074=HEAP32[(($3275)>>2)];
      var $26075=HEAP32[(($3276)>>2)];
      var $26076=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26073, $26074, $26075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4513; break; } else { __label__ = 4515; break; };
    case 4513: // $26077
      HEAP32[(($result_i563)>>2)]=$26076;
      var $26078=HEAP32[(($result_i563)>>2)];
      var $26079=(($26078)|0)==0;
      if ($26079) { __label__ = 4514; break; } else { __label__ = 4519; break; }
    case 4514: // $26080
      var $26081=___cxa_allocate_exception(4);
      var $26082=$26081;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26082);
      (function() { try { __THREW__ = false; return ___cxa_throw($26081, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4518; break; } else { __label__ = 4515; break; }
    case 4515: // $26083
      var $26084=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26085=$26084.f0;
      HEAP32[(($3277)>>2)]=$26085;
      var $26086=$26084.f1;
      HEAP32[(($3278)>>2)]=$26086;
      var $26087=HEAP32[(($3278)>>2)];
      var $26088=(($26087)|0) < 0;
      if ($26088) { __label__ = 4516; break; } else { __label__ = 4517; break; }
    case 4516: // $26089
      var $26090=HEAP32[(($3277)>>2)];
      ___cxa_call_unexpected($26090);
      throw "Reached an unreachable!"
    case 4517: // $26091
      var $26092=HEAP32[(($3277)>>2)];
      var $26093=HEAP32[(($3277)>>2)];
      var $26094=HEAP32[(($3278)>>2)];
      var $26095=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26093, tempValue);
      var $26096=($26095.f1 = $26094, $26095);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4518: // $26097
      throw "Reached an unreachable!"
    case 4519: // $_ZnwjPKci_exit564
      var $26098=HEAP32[(($result_i563)>>2)];
      var $26099=$3274;
      var $26100=$3275;
      var $26101=$3276;
      var $26102=$result_i563;
      var $26103=$3277;
      var $26104=$3278;
      var $26105=$26098;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6949, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4520; break; } else { __label__ = 13091; break; }
    case 4520: // $26106
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6950, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4521; break; } else { __label__ = 13091; break; }
    case 4521: // $26107
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6951, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4522; break; } else { __label__ = 13091; break; }
    case 4522: // $26108
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4523; break; } else { __label__ = 13091; break; }
    case 4523: // $26109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4524; break; } else { __label__ = 13091; break; }
    case 4524: // $26110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4525; break; } else { __label__ = 13091; break; }
    case 4525: // $26111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4526; break; } else { __label__ = 13091; break; }
    case 4526: // $26112
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6948, $6949, $6950, $6951, $6952, $6953, $6954, $6955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4527; break; } else { __label__ = 13091; break; }
    case 4527: // $26113
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26105, 43, 6, 5, ((STRING_TABLE.__str755)|0), ((STRING_TABLE.__str756)|0), $6948) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4528; break; } else { __label__ = 13091; break; }
    case 4528: // $26114
      var $26115=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26105);
      var $26116=__ZN11simple_listI16input_type_entryE6appendERS0_($26066, $26115);
      var $26117=$4689;
      var $26118=$3269;
      var $26119=$3270;
      var $26120=$3271;
      var $26121=$result_i565;
      var $26122=$3272;
      var $26123=$3273;
      HEAP32[(($3269)>>2)]=408;
      HEAP32[(($3270)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3271)>>2)]=342;
      var $26124=HEAP32[(($3269)>>2)];
      var $26125=HEAP32[(($3270)>>2)];
      var $26126=HEAP32[(($3271)>>2)];
      var $26127=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26124, $26125, $26126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4529; break; } else { __label__ = 4531; break; };
    case 4529: // $26128
      HEAP32[(($result_i565)>>2)]=$26127;
      var $26129=HEAP32[(($result_i565)>>2)];
      var $26130=(($26129)|0)==0;
      if ($26130) { __label__ = 4530; break; } else { __label__ = 4535; break; }
    case 4530: // $26131
      var $26132=___cxa_allocate_exception(4);
      var $26133=$26132;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26133);
      (function() { try { __THREW__ = false; return ___cxa_throw($26132, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4534; break; } else { __label__ = 4531; break; }
    case 4531: // $26134
      var $26135=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26136=$26135.f0;
      HEAP32[(($3272)>>2)]=$26136;
      var $26137=$26135.f1;
      HEAP32[(($3273)>>2)]=$26137;
      var $26138=HEAP32[(($3273)>>2)];
      var $26139=(($26138)|0) < 0;
      if ($26139) { __label__ = 4532; break; } else { __label__ = 4533; break; }
    case 4532: // $26140
      var $26141=HEAP32[(($3272)>>2)];
      ___cxa_call_unexpected($26141);
      throw "Reached an unreachable!"
    case 4533: // $26142
      var $26143=HEAP32[(($3272)>>2)];
      var $26144=HEAP32[(($3272)>>2)];
      var $26145=HEAP32[(($3273)>>2)];
      var $26146=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26144, tempValue);
      var $26147=($26146.f1 = $26145, $26146);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4534: // $26148
      throw "Reached an unreachable!"
    case 4535: // $_ZnwjPKci_exit566
      var $26149=HEAP32[(($result_i565)>>2)];
      var $26150=$3269;
      var $26151=$3270;
      var $26152=$3271;
      var $26153=$result_i565;
      var $26154=$3272;
      var $26155=$3273;
      var $26156=$26149;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6957, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4536; break; } else { __label__ = 13096; break; }
    case 4536: // $26157
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4537; break; } else { __label__ = 13096; break; }
    case 4537: // $26158
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4538; break; } else { __label__ = 13096; break; }
    case 4538: // $26159
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4539; break; } else { __label__ = 13096; break; }
    case 4539: // $26160
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4540; break; } else { __label__ = 13096; break; }
    case 4540: // $26161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4541; break; } else { __label__ = 13096; break; }
    case 4541: // $26162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4542; break; } else { __label__ = 13096; break; }
    case 4542: // $26163
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6956, $6957, $6958, $6959, $6960, $6961, $6962, $6963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4543; break; } else { __label__ = 13096; break; }
    case 4543: // $26164
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26156, 44, 6, 5, ((STRING_TABLE.__str757)|0), ((STRING_TABLE.__str758)|0), $6956) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4544; break; } else { __label__ = 13096; break; }
    case 4544: // $26165
      var $26166=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26156);
      var $26167=__ZN11simple_listI16input_type_entryE6appendERS0_($26117, $26166);
      var $26168=$4689;
      var $26169=$3264;
      var $26170=$3265;
      var $26171=$3266;
      var $26172=$result_i567;
      var $26173=$3267;
      var $26174=$3268;
      HEAP32[(($3264)>>2)]=408;
      HEAP32[(($3265)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3266)>>2)]=344;
      var $26175=HEAP32[(($3264)>>2)];
      var $26176=HEAP32[(($3265)>>2)];
      var $26177=HEAP32[(($3266)>>2)];
      var $26178=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26175, $26176, $26177) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4545; break; } else { __label__ = 4547; break; };
    case 4545: // $26179
      HEAP32[(($result_i567)>>2)]=$26178;
      var $26180=HEAP32[(($result_i567)>>2)];
      var $26181=(($26180)|0)==0;
      if ($26181) { __label__ = 4546; break; } else { __label__ = 4551; break; }
    case 4546: // $26182
      var $26183=___cxa_allocate_exception(4);
      var $26184=$26183;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26184);
      (function() { try { __THREW__ = false; return ___cxa_throw($26183, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4550; break; } else { __label__ = 4547; break; }
    case 4547: // $26185
      var $26186=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26187=$26186.f0;
      HEAP32[(($3267)>>2)]=$26187;
      var $26188=$26186.f1;
      HEAP32[(($3268)>>2)]=$26188;
      var $26189=HEAP32[(($3268)>>2)];
      var $26190=(($26189)|0) < 0;
      if ($26190) { __label__ = 4548; break; } else { __label__ = 4549; break; }
    case 4548: // $26191
      var $26192=HEAP32[(($3267)>>2)];
      ___cxa_call_unexpected($26192);
      throw "Reached an unreachable!"
    case 4549: // $26193
      var $26194=HEAP32[(($3267)>>2)];
      var $26195=HEAP32[(($3267)>>2)];
      var $26196=HEAP32[(($3268)>>2)];
      var $26197=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26195, tempValue);
      var $26198=($26197.f1 = $26196, $26197);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4550: // $26199
      throw "Reached an unreachable!"
    case 4551: // $_ZnwjPKci_exit568
      var $26200=HEAP32[(($result_i567)>>2)];
      var $26201=$3264;
      var $26202=$3265;
      var $26203=$3266;
      var $26204=$result_i567;
      var $26205=$3267;
      var $26206=$3268;
      var $26207=$26200;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6965, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4552; break; } else { __label__ = 13101; break; }
    case 4552: // $26208
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6966, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4553; break; } else { __label__ = 13101; break; }
    case 4553: // $26209
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6967, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4554; break; } else { __label__ = 13101; break; }
    case 4554: // $26210
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4555; break; } else { __label__ = 13101; break; }
    case 4555: // $26211
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4556; break; } else { __label__ = 13101; break; }
    case 4556: // $26212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4557; break; } else { __label__ = 13101; break; }
    case 4557: // $26213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4558; break; } else { __label__ = 13101; break; }
    case 4558: // $26214
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6964, $6965, $6966, $6967, $6968, $6969, $6970, $6971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4559; break; } else { __label__ = 13101; break; }
    case 4559: // $26215
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26207, 47, 7, 6, ((STRING_TABLE.__str759)|0), ((STRING_TABLE.__str760)|0), $6964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4560; break; } else { __label__ = 13101; break; }
    case 4560: // $26216
      var $26217=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26207);
      var $26218=__ZN11simple_listI16input_type_entryE6appendERS0_($26168, $26217);
      var $26219=$4689;
      var $26220=$3259;
      var $26221=$3260;
      var $26222=$3261;
      var $26223=$result_i569;
      var $26224=$3262;
      var $26225=$3263;
      HEAP32[(($3259)>>2)]=408;
      HEAP32[(($3260)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3261)>>2)]=345;
      var $26226=HEAP32[(($3259)>>2)];
      var $26227=HEAP32[(($3260)>>2)];
      var $26228=HEAP32[(($3261)>>2)];
      var $26229=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26226, $26227, $26228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4561; break; } else { __label__ = 4563; break; };
    case 4561: // $26230
      HEAP32[(($result_i569)>>2)]=$26229;
      var $26231=HEAP32[(($result_i569)>>2)];
      var $26232=(($26231)|0)==0;
      if ($26232) { __label__ = 4562; break; } else { __label__ = 4567; break; }
    case 4562: // $26233
      var $26234=___cxa_allocate_exception(4);
      var $26235=$26234;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26235);
      (function() { try { __THREW__ = false; return ___cxa_throw($26234, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4566; break; } else { __label__ = 4563; break; }
    case 4563: // $26236
      var $26237=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26238=$26237.f0;
      HEAP32[(($3262)>>2)]=$26238;
      var $26239=$26237.f1;
      HEAP32[(($3263)>>2)]=$26239;
      var $26240=HEAP32[(($3263)>>2)];
      var $26241=(($26240)|0) < 0;
      if ($26241) { __label__ = 4564; break; } else { __label__ = 4565; break; }
    case 4564: // $26242
      var $26243=HEAP32[(($3262)>>2)];
      ___cxa_call_unexpected($26243);
      throw "Reached an unreachable!"
    case 4565: // $26244
      var $26245=HEAP32[(($3262)>>2)];
      var $26246=HEAP32[(($3262)>>2)];
      var $26247=HEAP32[(($3263)>>2)];
      var $26248=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26246, tempValue);
      var $26249=($26248.f1 = $26247, $26248);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4566: // $26250
      throw "Reached an unreachable!"
    case 4567: // $_ZnwjPKci_exit570
      var $26251=HEAP32[(($result_i569)>>2)];
      var $26252=$3259;
      var $26253=$3260;
      var $26254=$3261;
      var $26255=$result_i569;
      var $26256=$3262;
      var $26257=$3263;
      var $26258=$26251;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6973, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4568; break; } else { __label__ = 13106; break; }
    case 4568: // $26259
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6974, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4569; break; } else { __label__ = 13106; break; }
    case 4569: // $26260
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6975, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4570; break; } else { __label__ = 13106; break; }
    case 4570: // $26261
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4571; break; } else { __label__ = 13106; break; }
    case 4571: // $26262
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4572; break; } else { __label__ = 13106; break; }
    case 4572: // $26263
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4573; break; } else { __label__ = 13106; break; }
    case 4573: // $26264
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4574; break; } else { __label__ = 13106; break; }
    case 4574: // $26265
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6972, $6973, $6974, $6975, $6976, $6977, $6978, $6979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4575; break; } else { __label__ = 13106; break; }
    case 4575: // $26266
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26258, 48, 7, 6, ((STRING_TABLE.__str761)|0), ((STRING_TABLE.__str762)|0), $6972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4576; break; } else { __label__ = 13106; break; }
    case 4576: // $26267
      var $26268=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26258);
      var $26269=__ZN11simple_listI16input_type_entryE6appendERS0_($26219, $26268);
      var $26270=$4689;
      var $26271=$3254;
      var $26272=$3255;
      var $26273=$3256;
      var $26274=$result_i571;
      var $26275=$3257;
      var $26276=$3258;
      HEAP32[(($3254)>>2)]=408;
      HEAP32[(($3255)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3256)>>2)]=346;
      var $26277=HEAP32[(($3254)>>2)];
      var $26278=HEAP32[(($3255)>>2)];
      var $26279=HEAP32[(($3256)>>2)];
      var $26280=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26277, $26278, $26279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4577; break; } else { __label__ = 4579; break; };
    case 4577: // $26281
      HEAP32[(($result_i571)>>2)]=$26280;
      var $26282=HEAP32[(($result_i571)>>2)];
      var $26283=(($26282)|0)==0;
      if ($26283) { __label__ = 4578; break; } else { __label__ = 4583; break; }
    case 4578: // $26284
      var $26285=___cxa_allocate_exception(4);
      var $26286=$26285;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26286);
      (function() { try { __THREW__ = false; return ___cxa_throw($26285, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4582; break; } else { __label__ = 4579; break; }
    case 4579: // $26287
      var $26288=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26289=$26288.f0;
      HEAP32[(($3257)>>2)]=$26289;
      var $26290=$26288.f1;
      HEAP32[(($3258)>>2)]=$26290;
      var $26291=HEAP32[(($3258)>>2)];
      var $26292=(($26291)|0) < 0;
      if ($26292) { __label__ = 4580; break; } else { __label__ = 4581; break; }
    case 4580: // $26293
      var $26294=HEAP32[(($3257)>>2)];
      ___cxa_call_unexpected($26294);
      throw "Reached an unreachable!"
    case 4581: // $26295
      var $26296=HEAP32[(($3257)>>2)];
      var $26297=HEAP32[(($3257)>>2)];
      var $26298=HEAP32[(($3258)>>2)];
      var $26299=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26297, tempValue);
      var $26300=($26299.f1 = $26298, $26299);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4582: // $26301
      throw "Reached an unreachable!"
    case 4583: // $_ZnwjPKci_exit572
      var $26302=HEAP32[(($result_i571)>>2)];
      var $26303=$3254;
      var $26304=$3255;
      var $26305=$3256;
      var $26306=$result_i571;
      var $26307=$3257;
      var $26308=$3258;
      var $26309=$26302;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6981, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4584; break; } else { __label__ = 13111; break; }
    case 4584: // $26310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4585; break; } else { __label__ = 13111; break; }
    case 4585: // $26311
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4586; break; } else { __label__ = 13111; break; }
    case 4586: // $26312
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4587; break; } else { __label__ = 13111; break; }
    case 4587: // $26313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4588; break; } else { __label__ = 13111; break; }
    case 4588: // $26314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4589; break; } else { __label__ = 13111; break; }
    case 4589: // $26315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4590; break; } else { __label__ = 13111; break; }
    case 4590: // $26316
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6980, $6981, $6982, $6983, $6984, $6985, $6986, $6987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4591; break; } else { __label__ = 13111; break; }
    case 4591: // $26317
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26309, 49, 7, 6, ((STRING_TABLE.__str763)|0), ((STRING_TABLE.__str764)|0), $6980) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4592; break; } else { __label__ = 13111; break; }
    case 4592: // $26318
      var $26319=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26309);
      var $26320=__ZN11simple_listI16input_type_entryE6appendERS0_($26270, $26319);
      var $26321=$4689;
      var $26322=$3249;
      var $26323=$3250;
      var $26324=$3251;
      var $26325=$result_i573;
      var $26326=$3252;
      var $26327=$3253;
      HEAP32[(($3249)>>2)]=408;
      HEAP32[(($3250)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3251)>>2)]=347;
      var $26328=HEAP32[(($3249)>>2)];
      var $26329=HEAP32[(($3250)>>2)];
      var $26330=HEAP32[(($3251)>>2)];
      var $26331=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26328, $26329, $26330) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4593; break; } else { __label__ = 4595; break; };
    case 4593: // $26332
      HEAP32[(($result_i573)>>2)]=$26331;
      var $26333=HEAP32[(($result_i573)>>2)];
      var $26334=(($26333)|0)==0;
      if ($26334) { __label__ = 4594; break; } else { __label__ = 4599; break; }
    case 4594: // $26335
      var $26336=___cxa_allocate_exception(4);
      var $26337=$26336;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26337);
      (function() { try { __THREW__ = false; return ___cxa_throw($26336, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4598; break; } else { __label__ = 4595; break; }
    case 4595: // $26338
      var $26339=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26340=$26339.f0;
      HEAP32[(($3252)>>2)]=$26340;
      var $26341=$26339.f1;
      HEAP32[(($3253)>>2)]=$26341;
      var $26342=HEAP32[(($3253)>>2)];
      var $26343=(($26342)|0) < 0;
      if ($26343) { __label__ = 4596; break; } else { __label__ = 4597; break; }
    case 4596: // $26344
      var $26345=HEAP32[(($3252)>>2)];
      ___cxa_call_unexpected($26345);
      throw "Reached an unreachable!"
    case 4597: // $26346
      var $26347=HEAP32[(($3252)>>2)];
      var $26348=HEAP32[(($3252)>>2)];
      var $26349=HEAP32[(($3253)>>2)];
      var $26350=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26348, tempValue);
      var $26351=($26350.f1 = $26349, $26350);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4598: // $26352
      throw "Reached an unreachable!"
    case 4599: // $_ZnwjPKci_exit574
      var $26353=HEAP32[(($result_i573)>>2)];
      var $26354=$3249;
      var $26355=$3250;
      var $26356=$3251;
      var $26357=$result_i573;
      var $26358=$3252;
      var $26359=$3253;
      var $26360=$26353;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6989, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4600; break; } else { __label__ = 13116; break; }
    case 4600: // $26361
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6990, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4601; break; } else { __label__ = 13116; break; }
    case 4601: // $26362
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6991, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4602; break; } else { __label__ = 13116; break; }
    case 4602: // $26363
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4603; break; } else { __label__ = 13116; break; }
    case 4603: // $26364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4604; break; } else { __label__ = 13116; break; }
    case 4604: // $26365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4605; break; } else { __label__ = 13116; break; }
    case 4605: // $26366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4606; break; } else { __label__ = 13116; break; }
    case 4606: // $26367
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6988, $6989, $6990, $6991, $6992, $6993, $6994, $6995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4607; break; } else { __label__ = 13116; break; }
    case 4607: // $26368
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26360, 50, 7, 6, ((STRING_TABLE.__str765)|0), ((STRING_TABLE.__str766)|0), $6988) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4608; break; } else { __label__ = 13116; break; }
    case 4608: // $26369
      var $26370=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26360);
      var $26371=__ZN11simple_listI16input_type_entryE6appendERS0_($26321, $26370);
      var $26372=$4689;
      var $26373=$3244;
      var $26374=$3245;
      var $26375=$3246;
      var $26376=$result_i575;
      var $26377=$3247;
      var $26378=$3248;
      HEAP32[(($3244)>>2)]=408;
      HEAP32[(($3245)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3246)>>2)]=348;
      var $26379=HEAP32[(($3244)>>2)];
      var $26380=HEAP32[(($3245)>>2)];
      var $26381=HEAP32[(($3246)>>2)];
      var $26382=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26379, $26380, $26381) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4609; break; } else { __label__ = 4611; break; };
    case 4609: // $26383
      HEAP32[(($result_i575)>>2)]=$26382;
      var $26384=HEAP32[(($result_i575)>>2)];
      var $26385=(($26384)|0)==0;
      if ($26385) { __label__ = 4610; break; } else { __label__ = 4615; break; }
    case 4610: // $26386
      var $26387=___cxa_allocate_exception(4);
      var $26388=$26387;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26388);
      (function() { try { __THREW__ = false; return ___cxa_throw($26387, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4614; break; } else { __label__ = 4611; break; }
    case 4611: // $26389
      var $26390=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26391=$26390.f0;
      HEAP32[(($3247)>>2)]=$26391;
      var $26392=$26390.f1;
      HEAP32[(($3248)>>2)]=$26392;
      var $26393=HEAP32[(($3248)>>2)];
      var $26394=(($26393)|0) < 0;
      if ($26394) { __label__ = 4612; break; } else { __label__ = 4613; break; }
    case 4612: // $26395
      var $26396=HEAP32[(($3247)>>2)];
      ___cxa_call_unexpected($26396);
      throw "Reached an unreachable!"
    case 4613: // $26397
      var $26398=HEAP32[(($3247)>>2)];
      var $26399=HEAP32[(($3247)>>2)];
      var $26400=HEAP32[(($3248)>>2)];
      var $26401=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26399, tempValue);
      var $26402=($26401.f1 = $26400, $26401);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4614: // $26403
      throw "Reached an unreachable!"
    case 4615: // $_ZnwjPKci_exit576
      var $26404=HEAP32[(($result_i575)>>2)];
      var $26405=$3244;
      var $26406=$3245;
      var $26407=$3246;
      var $26408=$result_i575;
      var $26409=$3247;
      var $26410=$3248;
      var $26411=$26404;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6997, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4616; break; } else { __label__ = 13121; break; }
    case 4616: // $26412
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6998, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4617; break; } else { __label__ = 13121; break; }
    case 4617: // $26413
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6999, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4618; break; } else { __label__ = 13121; break; }
    case 4618: // $26414
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4619; break; } else { __label__ = 13121; break; }
    case 4619: // $26415
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4620; break; } else { __label__ = 13121; break; }
    case 4620: // $26416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4621; break; } else { __label__ = 13121; break; }
    case 4621: // $26417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4622; break; } else { __label__ = 13121; break; }
    case 4622: // $26418
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($6996, $6997, $6998, $6999, $7000, $7001, $7002, $7003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4623; break; } else { __label__ = 13121; break; }
    case 4623: // $26419
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26411, 51, 7, 6, ((STRING_TABLE.__str767)|0), ((STRING_TABLE.__str768)|0), $6996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4624; break; } else { __label__ = 13121; break; }
    case 4624: // $26420
      var $26421=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26411);
      var $26422=__ZN11simple_listI16input_type_entryE6appendERS0_($26372, $26421);
      var $26423=$4689;
      var $26424=$3239;
      var $26425=$3240;
      var $26426=$3241;
      var $26427=$result_i577;
      var $26428=$3242;
      var $26429=$3243;
      HEAP32[(($3239)>>2)]=408;
      HEAP32[(($3240)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3241)>>2)]=349;
      var $26430=HEAP32[(($3239)>>2)];
      var $26431=HEAP32[(($3240)>>2)];
      var $26432=HEAP32[(($3241)>>2)];
      var $26433=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26430, $26431, $26432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4625; break; } else { __label__ = 4627; break; };
    case 4625: // $26434
      HEAP32[(($result_i577)>>2)]=$26433;
      var $26435=HEAP32[(($result_i577)>>2)];
      var $26436=(($26435)|0)==0;
      if ($26436) { __label__ = 4626; break; } else { __label__ = 4631; break; }
    case 4626: // $26437
      var $26438=___cxa_allocate_exception(4);
      var $26439=$26438;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26439);
      (function() { try { __THREW__ = false; return ___cxa_throw($26438, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4630; break; } else { __label__ = 4627; break; }
    case 4627: // $26440
      var $26441=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26442=$26441.f0;
      HEAP32[(($3242)>>2)]=$26442;
      var $26443=$26441.f1;
      HEAP32[(($3243)>>2)]=$26443;
      var $26444=HEAP32[(($3243)>>2)];
      var $26445=(($26444)|0) < 0;
      if ($26445) { __label__ = 4628; break; } else { __label__ = 4629; break; }
    case 4628: // $26446
      var $26447=HEAP32[(($3242)>>2)];
      ___cxa_call_unexpected($26447);
      throw "Reached an unreachable!"
    case 4629: // $26448
      var $26449=HEAP32[(($3242)>>2)];
      var $26450=HEAP32[(($3242)>>2)];
      var $26451=HEAP32[(($3243)>>2)];
      var $26452=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26450, tempValue);
      var $26453=($26452.f1 = $26451, $26452);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4630: // $26454
      throw "Reached an unreachable!"
    case 4631: // $_ZnwjPKci_exit578
      var $26455=HEAP32[(($result_i577)>>2)];
      var $26456=$3239;
      var $26457=$3240;
      var $26458=$3241;
      var $26459=$result_i577;
      var $26460=$3242;
      var $26461=$3243;
      var $26462=$26455;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7005, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4632; break; } else { __label__ = 13126; break; }
    case 4632: // $26463
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7006, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4633; break; } else { __label__ = 13126; break; }
    case 4633: // $26464
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7007, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4634; break; } else { __label__ = 13126; break; }
    case 4634: // $26465
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4635; break; } else { __label__ = 13126; break; }
    case 4635: // $26466
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4636; break; } else { __label__ = 13126; break; }
    case 4636: // $26467
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4637; break; } else { __label__ = 13126; break; }
    case 4637: // $26468
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4638; break; } else { __label__ = 13126; break; }
    case 4638: // $26469
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7004, $7005, $7006, $7007, $7008, $7009, $7010, $7011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4639; break; } else { __label__ = 13126; break; }
    case 4639: // $26470
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26462, 52, 7, 6, ((STRING_TABLE.__str769)|0), ((STRING_TABLE.__str770)|0), $7004) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4640; break; } else { __label__ = 13126; break; }
    case 4640: // $26471
      var $26472=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26462);
      var $26473=__ZN11simple_listI16input_type_entryE6appendERS0_($26423, $26472);
      var $26474=$4689;
      var $26475=$3234;
      var $26476=$3235;
      var $26477=$3236;
      var $26478=$result_i579;
      var $26479=$3237;
      var $26480=$3238;
      HEAP32[(($3234)>>2)]=408;
      HEAP32[(($3235)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3236)>>2)]=350;
      var $26481=HEAP32[(($3234)>>2)];
      var $26482=HEAP32[(($3235)>>2)];
      var $26483=HEAP32[(($3236)>>2)];
      var $26484=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26481, $26482, $26483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4641; break; } else { __label__ = 4643; break; };
    case 4641: // $26485
      HEAP32[(($result_i579)>>2)]=$26484;
      var $26486=HEAP32[(($result_i579)>>2)];
      var $26487=(($26486)|0)==0;
      if ($26487) { __label__ = 4642; break; } else { __label__ = 4647; break; }
    case 4642: // $26488
      var $26489=___cxa_allocate_exception(4);
      var $26490=$26489;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26490);
      (function() { try { __THREW__ = false; return ___cxa_throw($26489, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4646; break; } else { __label__ = 4643; break; }
    case 4643: // $26491
      var $26492=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26493=$26492.f0;
      HEAP32[(($3237)>>2)]=$26493;
      var $26494=$26492.f1;
      HEAP32[(($3238)>>2)]=$26494;
      var $26495=HEAP32[(($3238)>>2)];
      var $26496=(($26495)|0) < 0;
      if ($26496) { __label__ = 4644; break; } else { __label__ = 4645; break; }
    case 4644: // $26497
      var $26498=HEAP32[(($3237)>>2)];
      ___cxa_call_unexpected($26498);
      throw "Reached an unreachable!"
    case 4645: // $26499
      var $26500=HEAP32[(($3237)>>2)];
      var $26501=HEAP32[(($3237)>>2)];
      var $26502=HEAP32[(($3238)>>2)];
      var $26503=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26501, tempValue);
      var $26504=($26503.f1 = $26502, $26503);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4646: // $26505
      throw "Reached an unreachable!"
    case 4647: // $_ZnwjPKci_exit580
      var $26506=HEAP32[(($result_i579)>>2)];
      var $26507=$3234;
      var $26508=$3235;
      var $26509=$3236;
      var $26510=$result_i579;
      var $26511=$3237;
      var $26512=$3238;
      var $26513=$26506;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7013, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4648; break; } else { __label__ = 13131; break; }
    case 4648: // $26514
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7014, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4649; break; } else { __label__ = 13131; break; }
    case 4649: // $26515
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7015, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4650; break; } else { __label__ = 13131; break; }
    case 4650: // $26516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4651; break; } else { __label__ = 13131; break; }
    case 4651: // $26517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4652; break; } else { __label__ = 13131; break; }
    case 4652: // $26518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4653; break; } else { __label__ = 13131; break; }
    case 4653: // $26519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4654; break; } else { __label__ = 13131; break; }
    case 4654: // $26520
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7012, $7013, $7014, $7015, $7016, $7017, $7018, $7019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4655; break; } else { __label__ = 13131; break; }
    case 4655: // $26521
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26513, 53, 7, 6, ((STRING_TABLE.__str771)|0), ((STRING_TABLE.__str772)|0), $7012) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4656; break; } else { __label__ = 13131; break; }
    case 4656: // $26522
      var $26523=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26513);
      var $26524=__ZN11simple_listI16input_type_entryE6appendERS0_($26474, $26523);
      var $26525=$4689;
      var $26526=$3229;
      var $26527=$3230;
      var $26528=$3231;
      var $26529=$result_i581;
      var $26530=$3232;
      var $26531=$3233;
      HEAP32[(($3229)>>2)]=408;
      HEAP32[(($3230)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3231)>>2)]=351;
      var $26532=HEAP32[(($3229)>>2)];
      var $26533=HEAP32[(($3230)>>2)];
      var $26534=HEAP32[(($3231)>>2)];
      var $26535=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26532, $26533, $26534) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4657; break; } else { __label__ = 4659; break; };
    case 4657: // $26536
      HEAP32[(($result_i581)>>2)]=$26535;
      var $26537=HEAP32[(($result_i581)>>2)];
      var $26538=(($26537)|0)==0;
      if ($26538) { __label__ = 4658; break; } else { __label__ = 4663; break; }
    case 4658: // $26539
      var $26540=___cxa_allocate_exception(4);
      var $26541=$26540;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26541);
      (function() { try { __THREW__ = false; return ___cxa_throw($26540, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4662; break; } else { __label__ = 4659; break; }
    case 4659: // $26542
      var $26543=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26544=$26543.f0;
      HEAP32[(($3232)>>2)]=$26544;
      var $26545=$26543.f1;
      HEAP32[(($3233)>>2)]=$26545;
      var $26546=HEAP32[(($3233)>>2)];
      var $26547=(($26546)|0) < 0;
      if ($26547) { __label__ = 4660; break; } else { __label__ = 4661; break; }
    case 4660: // $26548
      var $26549=HEAP32[(($3232)>>2)];
      ___cxa_call_unexpected($26549);
      throw "Reached an unreachable!"
    case 4661: // $26550
      var $26551=HEAP32[(($3232)>>2)];
      var $26552=HEAP32[(($3232)>>2)];
      var $26553=HEAP32[(($3233)>>2)];
      var $26554=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26552, tempValue);
      var $26555=($26554.f1 = $26553, $26554);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4662: // $26556
      throw "Reached an unreachable!"
    case 4663: // $_ZnwjPKci_exit582
      var $26557=HEAP32[(($result_i581)>>2)];
      var $26558=$3229;
      var $26559=$3230;
      var $26560=$3231;
      var $26561=$result_i581;
      var $26562=$3232;
      var $26563=$3233;
      var $26564=$26557;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7021, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4664; break; } else { __label__ = 13136; break; }
    case 4664: // $26565
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7022, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4665; break; } else { __label__ = 13136; break; }
    case 4665: // $26566
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7023, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4666; break; } else { __label__ = 13136; break; }
    case 4666: // $26567
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4667; break; } else { __label__ = 13136; break; }
    case 4667: // $26568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4668; break; } else { __label__ = 13136; break; }
    case 4668: // $26569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4669; break; } else { __label__ = 13136; break; }
    case 4669: // $26570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4670; break; } else { __label__ = 13136; break; }
    case 4670: // $26571
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7020, $7021, $7022, $7023, $7024, $7025, $7026, $7027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4671; break; } else { __label__ = 13136; break; }
    case 4671: // $26572
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26564, 54, 7, 6, ((STRING_TABLE.__str773)|0), ((STRING_TABLE.__str774)|0), $7020) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4672; break; } else { __label__ = 13136; break; }
    case 4672: // $26573
      var $26574=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26564);
      var $26575=__ZN11simple_listI16input_type_entryE6appendERS0_($26525, $26574);
      var $26576=$4689;
      var $26577=$3224;
      var $26578=$3225;
      var $26579=$3226;
      var $26580=$result_i583;
      var $26581=$3227;
      var $26582=$3228;
      HEAP32[(($3224)>>2)]=408;
      HEAP32[(($3225)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3226)>>2)]=352;
      var $26583=HEAP32[(($3224)>>2)];
      var $26584=HEAP32[(($3225)>>2)];
      var $26585=HEAP32[(($3226)>>2)];
      var $26586=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26583, $26584, $26585) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4673; break; } else { __label__ = 4675; break; };
    case 4673: // $26587
      HEAP32[(($result_i583)>>2)]=$26586;
      var $26588=HEAP32[(($result_i583)>>2)];
      var $26589=(($26588)|0)==0;
      if ($26589) { __label__ = 4674; break; } else { __label__ = 4679; break; }
    case 4674: // $26590
      var $26591=___cxa_allocate_exception(4);
      var $26592=$26591;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26592);
      (function() { try { __THREW__ = false; return ___cxa_throw($26591, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4678; break; } else { __label__ = 4675; break; }
    case 4675: // $26593
      var $26594=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26595=$26594.f0;
      HEAP32[(($3227)>>2)]=$26595;
      var $26596=$26594.f1;
      HEAP32[(($3228)>>2)]=$26596;
      var $26597=HEAP32[(($3228)>>2)];
      var $26598=(($26597)|0) < 0;
      if ($26598) { __label__ = 4676; break; } else { __label__ = 4677; break; }
    case 4676: // $26599
      var $26600=HEAP32[(($3227)>>2)];
      ___cxa_call_unexpected($26600);
      throw "Reached an unreachable!"
    case 4677: // $26601
      var $26602=HEAP32[(($3227)>>2)];
      var $26603=HEAP32[(($3227)>>2)];
      var $26604=HEAP32[(($3228)>>2)];
      var $26605=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26603, tempValue);
      var $26606=($26605.f1 = $26604, $26605);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4678: // $26607
      throw "Reached an unreachable!"
    case 4679: // $_ZnwjPKci_exit584
      var $26608=HEAP32[(($result_i583)>>2)];
      var $26609=$3224;
      var $26610=$3225;
      var $26611=$3226;
      var $26612=$result_i583;
      var $26613=$3227;
      var $26614=$3228;
      var $26615=$26608;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7029, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4680; break; } else { __label__ = 13141; break; }
    case 4680: // $26616
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7030, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4681; break; } else { __label__ = 13141; break; }
    case 4681: // $26617
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7031, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4682; break; } else { __label__ = 13141; break; }
    case 4682: // $26618
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4683; break; } else { __label__ = 13141; break; }
    case 4683: // $26619
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4684; break; } else { __label__ = 13141; break; }
    case 4684: // $26620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4685; break; } else { __label__ = 13141; break; }
    case 4685: // $26621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4686; break; } else { __label__ = 13141; break; }
    case 4686: // $26622
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7028, $7029, $7030, $7031, $7032, $7033, $7034, $7035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4687; break; } else { __label__ = 13141; break; }
    case 4687: // $26623
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26615, 55, 7, 6, ((STRING_TABLE.__str775)|0), ((STRING_TABLE.__str776416)|0), $7028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4688; break; } else { __label__ = 13141; break; }
    case 4688: // $26624
      var $26625=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26615);
      var $26626=__ZN11simple_listI16input_type_entryE6appendERS0_($26576, $26625);
      var $26627=$4689;
      var $26628=$3219;
      var $26629=$3220;
      var $26630=$3221;
      var $26631=$result_i585;
      var $26632=$3222;
      var $26633=$3223;
      HEAP32[(($3219)>>2)]=408;
      HEAP32[(($3220)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3221)>>2)]=353;
      var $26634=HEAP32[(($3219)>>2)];
      var $26635=HEAP32[(($3220)>>2)];
      var $26636=HEAP32[(($3221)>>2)];
      var $26637=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26634, $26635, $26636) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4689; break; } else { __label__ = 4691; break; };
    case 4689: // $26638
      HEAP32[(($result_i585)>>2)]=$26637;
      var $26639=HEAP32[(($result_i585)>>2)];
      var $26640=(($26639)|0)==0;
      if ($26640) { __label__ = 4690; break; } else { __label__ = 4695; break; }
    case 4690: // $26641
      var $26642=___cxa_allocate_exception(4);
      var $26643=$26642;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26643);
      (function() { try { __THREW__ = false; return ___cxa_throw($26642, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4694; break; } else { __label__ = 4691; break; }
    case 4691: // $26644
      var $26645=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26646=$26645.f0;
      HEAP32[(($3222)>>2)]=$26646;
      var $26647=$26645.f1;
      HEAP32[(($3223)>>2)]=$26647;
      var $26648=HEAP32[(($3223)>>2)];
      var $26649=(($26648)|0) < 0;
      if ($26649) { __label__ = 4692; break; } else { __label__ = 4693; break; }
    case 4692: // $26650
      var $26651=HEAP32[(($3222)>>2)];
      ___cxa_call_unexpected($26651);
      throw "Reached an unreachable!"
    case 4693: // $26652
      var $26653=HEAP32[(($3222)>>2)];
      var $26654=HEAP32[(($3222)>>2)];
      var $26655=HEAP32[(($3223)>>2)];
      var $26656=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26654, tempValue);
      var $26657=($26656.f1 = $26655, $26656);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4694: // $26658
      throw "Reached an unreachable!"
    case 4695: // $_ZnwjPKci_exit586
      var $26659=HEAP32[(($result_i585)>>2)];
      var $26660=$3219;
      var $26661=$3220;
      var $26662=$3221;
      var $26663=$result_i585;
      var $26664=$3222;
      var $26665=$3223;
      var $26666=$26659;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7037, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4696; break; } else { __label__ = 13146; break; }
    case 4696: // $26667
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7038, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4697; break; } else { __label__ = 13146; break; }
    case 4697: // $26668
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7039, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4698; break; } else { __label__ = 13146; break; }
    case 4698: // $26669
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4699; break; } else { __label__ = 13146; break; }
    case 4699: // $26670
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4700; break; } else { __label__ = 13146; break; }
    case 4700: // $26671
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4701; break; } else { __label__ = 13146; break; }
    case 4701: // $26672
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4702; break; } else { __label__ = 13146; break; }
    case 4702: // $26673
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7036, $7037, $7038, $7039, $7040, $7041, $7042, $7043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4703; break; } else { __label__ = 13146; break; }
    case 4703: // $26674
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26666, 56, 7, 6, ((STRING_TABLE.__str777)|0), ((STRING_TABLE.__str778)|0), $7036) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4704; break; } else { __label__ = 13146; break; }
    case 4704: // $26675
      var $26676=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26666);
      var $26677=__ZN11simple_listI16input_type_entryE6appendERS0_($26627, $26676);
      var $26678=$4689;
      var $26679=$3214;
      var $26680=$3215;
      var $26681=$3216;
      var $26682=$result_i587;
      var $26683=$3217;
      var $26684=$3218;
      HEAP32[(($3214)>>2)]=408;
      HEAP32[(($3215)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3216)>>2)]=354;
      var $26685=HEAP32[(($3214)>>2)];
      var $26686=HEAP32[(($3215)>>2)];
      var $26687=HEAP32[(($3216)>>2)];
      var $26688=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26685, $26686, $26687) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4705; break; } else { __label__ = 4707; break; };
    case 4705: // $26689
      HEAP32[(($result_i587)>>2)]=$26688;
      var $26690=HEAP32[(($result_i587)>>2)];
      var $26691=(($26690)|0)==0;
      if ($26691) { __label__ = 4706; break; } else { __label__ = 4711; break; }
    case 4706: // $26692
      var $26693=___cxa_allocate_exception(4);
      var $26694=$26693;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26694);
      (function() { try { __THREW__ = false; return ___cxa_throw($26693, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4710; break; } else { __label__ = 4707; break; }
    case 4707: // $26695
      var $26696=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26697=$26696.f0;
      HEAP32[(($3217)>>2)]=$26697;
      var $26698=$26696.f1;
      HEAP32[(($3218)>>2)]=$26698;
      var $26699=HEAP32[(($3218)>>2)];
      var $26700=(($26699)|0) < 0;
      if ($26700) { __label__ = 4708; break; } else { __label__ = 4709; break; }
    case 4708: // $26701
      var $26702=HEAP32[(($3217)>>2)];
      ___cxa_call_unexpected($26702);
      throw "Reached an unreachable!"
    case 4709: // $26703
      var $26704=HEAP32[(($3217)>>2)];
      var $26705=HEAP32[(($3217)>>2)];
      var $26706=HEAP32[(($3218)>>2)];
      var $26707=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26705, tempValue);
      var $26708=($26707.f1 = $26706, $26707);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4710: // $26709
      throw "Reached an unreachable!"
    case 4711: // $_ZnwjPKci_exit588
      var $26710=HEAP32[(($result_i587)>>2)];
      var $26711=$3214;
      var $26712=$3215;
      var $26713=$3216;
      var $26714=$result_i587;
      var $26715=$3217;
      var $26716=$3218;
      var $26717=$26710;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7045, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4712; break; } else { __label__ = 13151; break; }
    case 4712: // $26718
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7046, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4713; break; } else { __label__ = 13151; break; }
    case 4713: // $26719
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7047, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4714; break; } else { __label__ = 13151; break; }
    case 4714: // $26720
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4715; break; } else { __label__ = 13151; break; }
    case 4715: // $26721
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4716; break; } else { __label__ = 13151; break; }
    case 4716: // $26722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4717; break; } else { __label__ = 13151; break; }
    case 4717: // $26723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4718; break; } else { __label__ = 13151; break; }
    case 4718: // $26724
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7044, $7045, $7046, $7047, $7048, $7049, $7050, $7051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4719; break; } else { __label__ = 13151; break; }
    case 4719: // $26725
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26717, 57, 7, 6, ((STRING_TABLE.__str779)|0), ((STRING_TABLE.__str780)|0), $7044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4720; break; } else { __label__ = 13151; break; }
    case 4720: // $26726
      var $26727=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26717);
      var $26728=__ZN11simple_listI16input_type_entryE6appendERS0_($26678, $26727);
      var $26729=$4689;
      var $26730=$3209;
      var $26731=$3210;
      var $26732=$3211;
      var $26733=$result_i589;
      var $26734=$3212;
      var $26735=$3213;
      HEAP32[(($3209)>>2)]=408;
      HEAP32[(($3210)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3211)>>2)]=355;
      var $26736=HEAP32[(($3209)>>2)];
      var $26737=HEAP32[(($3210)>>2)];
      var $26738=HEAP32[(($3211)>>2)];
      var $26739=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26736, $26737, $26738) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4721; break; } else { __label__ = 4723; break; };
    case 4721: // $26740
      HEAP32[(($result_i589)>>2)]=$26739;
      var $26741=HEAP32[(($result_i589)>>2)];
      var $26742=(($26741)|0)==0;
      if ($26742) { __label__ = 4722; break; } else { __label__ = 4727; break; }
    case 4722: // $26743
      var $26744=___cxa_allocate_exception(4);
      var $26745=$26744;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26745);
      (function() { try { __THREW__ = false; return ___cxa_throw($26744, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4726; break; } else { __label__ = 4723; break; }
    case 4723: // $26746
      var $26747=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26748=$26747.f0;
      HEAP32[(($3212)>>2)]=$26748;
      var $26749=$26747.f1;
      HEAP32[(($3213)>>2)]=$26749;
      var $26750=HEAP32[(($3213)>>2)];
      var $26751=(($26750)|0) < 0;
      if ($26751) { __label__ = 4724; break; } else { __label__ = 4725; break; }
    case 4724: // $26752
      var $26753=HEAP32[(($3212)>>2)];
      ___cxa_call_unexpected($26753);
      throw "Reached an unreachable!"
    case 4725: // $26754
      var $26755=HEAP32[(($3212)>>2)];
      var $26756=HEAP32[(($3212)>>2)];
      var $26757=HEAP32[(($3213)>>2)];
      var $26758=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26756, tempValue);
      var $26759=($26758.f1 = $26757, $26758);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4726: // $26760
      throw "Reached an unreachable!"
    case 4727: // $_ZnwjPKci_exit590
      var $26761=HEAP32[(($result_i589)>>2)];
      var $26762=$3209;
      var $26763=$3210;
      var $26764=$3211;
      var $26765=$result_i589;
      var $26766=$3212;
      var $26767=$3213;
      var $26768=$26761;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7053, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4728; break; } else { __label__ = 13156; break; }
    case 4728: // $26769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7054, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4729; break; } else { __label__ = 13156; break; }
    case 4729: // $26770
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7055, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4730; break; } else { __label__ = 13156; break; }
    case 4730: // $26771
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4731; break; } else { __label__ = 13156; break; }
    case 4731: // $26772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4732; break; } else { __label__ = 13156; break; }
    case 4732: // $26773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4733; break; } else { __label__ = 13156; break; }
    case 4733: // $26774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4734; break; } else { __label__ = 13156; break; }
    case 4734: // $26775
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7052, $7053, $7054, $7055, $7056, $7057, $7058, $7059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4735; break; } else { __label__ = 13156; break; }
    case 4735: // $26776
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26768, 58, 7, 6, ((STRING_TABLE.__str781)|0), ((STRING_TABLE.__str782)|0), $7052) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4736; break; } else { __label__ = 13156; break; }
    case 4736: // $26777
      var $26778=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26768);
      var $26779=__ZN11simple_listI16input_type_entryE6appendERS0_($26729, $26778);
      var $26780=$4689;
      var $26781=$3204;
      var $26782=$3205;
      var $26783=$3206;
      var $26784=$result_i591;
      var $26785=$3207;
      var $26786=$3208;
      HEAP32[(($3204)>>2)]=408;
      HEAP32[(($3205)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3206)>>2)]=356;
      var $26787=HEAP32[(($3204)>>2)];
      var $26788=HEAP32[(($3205)>>2)];
      var $26789=HEAP32[(($3206)>>2)];
      var $26790=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26787, $26788, $26789) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4737; break; } else { __label__ = 4739; break; };
    case 4737: // $26791
      HEAP32[(($result_i591)>>2)]=$26790;
      var $26792=HEAP32[(($result_i591)>>2)];
      var $26793=(($26792)|0)==0;
      if ($26793) { __label__ = 4738; break; } else { __label__ = 4743; break; }
    case 4738: // $26794
      var $26795=___cxa_allocate_exception(4);
      var $26796=$26795;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26796);
      (function() { try { __THREW__ = false; return ___cxa_throw($26795, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4742; break; } else { __label__ = 4739; break; }
    case 4739: // $26797
      var $26798=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26799=$26798.f0;
      HEAP32[(($3207)>>2)]=$26799;
      var $26800=$26798.f1;
      HEAP32[(($3208)>>2)]=$26800;
      var $26801=HEAP32[(($3208)>>2)];
      var $26802=(($26801)|0) < 0;
      if ($26802) { __label__ = 4740; break; } else { __label__ = 4741; break; }
    case 4740: // $26803
      var $26804=HEAP32[(($3207)>>2)];
      ___cxa_call_unexpected($26804);
      throw "Reached an unreachable!"
    case 4741: // $26805
      var $26806=HEAP32[(($3207)>>2)];
      var $26807=HEAP32[(($3207)>>2)];
      var $26808=HEAP32[(($3208)>>2)];
      var $26809=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26807, tempValue);
      var $26810=($26809.f1 = $26808, $26809);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4742: // $26811
      throw "Reached an unreachable!"
    case 4743: // $_ZnwjPKci_exit592
      var $26812=HEAP32[(($result_i591)>>2)];
      var $26813=$3204;
      var $26814=$3205;
      var $26815=$3206;
      var $26816=$result_i591;
      var $26817=$3207;
      var $26818=$3208;
      var $26819=$26812;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7061, 4, 6, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4744; break; } else { __label__ = 13161; break; }
    case 4744: // $26820
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7062, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4745; break; } else { __label__ = 13161; break; }
    case 4745: // $26821
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7063, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4746; break; } else { __label__ = 13161; break; }
    case 4746: // $26822
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4747; break; } else { __label__ = 13161; break; }
    case 4747: // $26823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4748; break; } else { __label__ = 13161; break; }
    case 4748: // $26824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4749; break; } else { __label__ = 13161; break; }
    case 4749: // $26825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4750; break; } else { __label__ = 13161; break; }
    case 4750: // $26826
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7060, $7061, $7062, $7063, $7064, $7065, $7066, $7067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4751; break; } else { __label__ = 13161; break; }
    case 4751: // $26827
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26819, 59, 7, 6, ((STRING_TABLE.__str783)|0), ((STRING_TABLE.__str784)|0), $7060) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4752; break; } else { __label__ = 13161; break; }
    case 4752: // $26828
      var $26829=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26819);
      var $26830=__ZN11simple_listI16input_type_entryE6appendERS0_($26780, $26829);
      var $26831=$4689;
      var $26832=$3199;
      var $26833=$3200;
      var $26834=$3201;
      var $26835=$result_i593;
      var $26836=$3202;
      var $26837=$3203;
      HEAP32[(($3199)>>2)]=408;
      HEAP32[(($3200)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3201)>>2)]=357;
      var $26838=HEAP32[(($3199)>>2)];
      var $26839=HEAP32[(($3200)>>2)];
      var $26840=HEAP32[(($3201)>>2)];
      var $26841=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26838, $26839, $26840) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4753; break; } else { __label__ = 4755; break; };
    case 4753: // $26842
      HEAP32[(($result_i593)>>2)]=$26841;
      var $26843=HEAP32[(($result_i593)>>2)];
      var $26844=(($26843)|0)==0;
      if ($26844) { __label__ = 4754; break; } else { __label__ = 4759; break; }
    case 4754: // $26845
      var $26846=___cxa_allocate_exception(4);
      var $26847=$26846;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26847);
      (function() { try { __THREW__ = false; return ___cxa_throw($26846, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4758; break; } else { __label__ = 4755; break; }
    case 4755: // $26848
      var $26849=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26850=$26849.f0;
      HEAP32[(($3202)>>2)]=$26850;
      var $26851=$26849.f1;
      HEAP32[(($3203)>>2)]=$26851;
      var $26852=HEAP32[(($3203)>>2)];
      var $26853=(($26852)|0) < 0;
      if ($26853) { __label__ = 4756; break; } else { __label__ = 4757; break; }
    case 4756: // $26854
      var $26855=HEAP32[(($3202)>>2)];
      ___cxa_call_unexpected($26855);
      throw "Reached an unreachable!"
    case 4757: // $26856
      var $26857=HEAP32[(($3202)>>2)];
      var $26858=HEAP32[(($3202)>>2)];
      var $26859=HEAP32[(($3203)>>2)];
      var $26860=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26858, tempValue);
      var $26861=($26860.f1 = $26859, $26860);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4758: // $26862
      throw "Reached an unreachable!"
    case 4759: // $_ZnwjPKci_exit594
      var $26863=HEAP32[(($result_i593)>>2)];
      var $26864=$3199;
      var $26865=$3200;
      var $26866=$3201;
      var $26867=$result_i593;
      var $26868=$3202;
      var $26869=$3203;
      var $26870=$26863;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7069, 4, 6, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4760; break; } else { __label__ = 13166; break; }
    case 4760: // $26871
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7070, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4761; break; } else { __label__ = 13166; break; }
    case 4761: // $26872
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7071, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4762; break; } else { __label__ = 13166; break; }
    case 4762: // $26873
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4763; break; } else { __label__ = 13166; break; }
    case 4763: // $26874
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4764; break; } else { __label__ = 13166; break; }
    case 4764: // $26875
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4765; break; } else { __label__ = 13166; break; }
    case 4765: // $26876
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4766; break; } else { __label__ = 13166; break; }
    case 4766: // $26877
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7068, $7069, $7070, $7071, $7072, $7073, $7074, $7075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4767; break; } else { __label__ = 13166; break; }
    case 4767: // $26878
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26870, 60, 7, 6, ((STRING_TABLE.__str785)|0), ((STRING_TABLE.__str786)|0), $7068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4768; break; } else { __label__ = 13166; break; }
    case 4768: // $26879
      var $26880=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26870);
      var $26881=__ZN11simple_listI16input_type_entryE6appendERS0_($26831, $26880);
      var $26882=$4689;
      var $26883=$3194;
      var $26884=$3195;
      var $26885=$3196;
      var $26886=$result_i595;
      var $26887=$3197;
      var $26888=$3198;
      HEAP32[(($3194)>>2)]=408;
      HEAP32[(($3195)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3196)>>2)]=358;
      var $26889=HEAP32[(($3194)>>2)];
      var $26890=HEAP32[(($3195)>>2)];
      var $26891=HEAP32[(($3196)>>2)];
      var $26892=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26889, $26890, $26891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4769; break; } else { __label__ = 4771; break; };
    case 4769: // $26893
      HEAP32[(($result_i595)>>2)]=$26892;
      var $26894=HEAP32[(($result_i595)>>2)];
      var $26895=(($26894)|0)==0;
      if ($26895) { __label__ = 4770; break; } else { __label__ = 4775; break; }
    case 4770: // $26896
      var $26897=___cxa_allocate_exception(4);
      var $26898=$26897;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26898);
      (function() { try { __THREW__ = false; return ___cxa_throw($26897, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4774; break; } else { __label__ = 4771; break; }
    case 4771: // $26899
      var $26900=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26901=$26900.f0;
      HEAP32[(($3197)>>2)]=$26901;
      var $26902=$26900.f1;
      HEAP32[(($3198)>>2)]=$26902;
      var $26903=HEAP32[(($3198)>>2)];
      var $26904=(($26903)|0) < 0;
      if ($26904) { __label__ = 4772; break; } else { __label__ = 4773; break; }
    case 4772: // $26905
      var $26906=HEAP32[(($3197)>>2)];
      ___cxa_call_unexpected($26906);
      throw "Reached an unreachable!"
    case 4773: // $26907
      var $26908=HEAP32[(($3197)>>2)];
      var $26909=HEAP32[(($3197)>>2)];
      var $26910=HEAP32[(($3198)>>2)];
      var $26911=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26909, tempValue);
      var $26912=($26911.f1 = $26910, $26911);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4774: // $26913
      throw "Reached an unreachable!"
    case 4775: // $_ZnwjPKci_exit596
      var $26914=HEAP32[(($result_i595)>>2)];
      var $26915=$3194;
      var $26916=$3195;
      var $26917=$3196;
      var $26918=$result_i595;
      var $26919=$3197;
      var $26920=$3198;
      var $26921=$26914;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7077, 4, 6, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4776; break; } else { __label__ = 13171; break; }
    case 4776: // $26922
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7078, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4777; break; } else { __label__ = 13171; break; }
    case 4777: // $26923
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7079, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4778; break; } else { __label__ = 13171; break; }
    case 4778: // $26924
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4779; break; } else { __label__ = 13171; break; }
    case 4779: // $26925
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4780; break; } else { __label__ = 13171; break; }
    case 4780: // $26926
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4781; break; } else { __label__ = 13171; break; }
    case 4781: // $26927
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4782; break; } else { __label__ = 13171; break; }
    case 4782: // $26928
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7076, $7077, $7078, $7079, $7080, $7081, $7082, $7083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4783; break; } else { __label__ = 13171; break; }
    case 4783: // $26929
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26921, 61, 7, 6, ((STRING_TABLE.__str787)|0), ((STRING_TABLE.__str788)|0), $7076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4784; break; } else { __label__ = 13171; break; }
    case 4784: // $26930
      var $26931=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26921);
      var $26932=__ZN11simple_listI16input_type_entryE6appendERS0_($26882, $26931);
      var $26933=$4689;
      var $26934=$3189;
      var $26935=$3190;
      var $26936=$3191;
      var $26937=$result_i597;
      var $26938=$3192;
      var $26939=$3193;
      HEAP32[(($3189)>>2)]=408;
      HEAP32[(($3190)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3191)>>2)]=359;
      var $26940=HEAP32[(($3189)>>2)];
      var $26941=HEAP32[(($3190)>>2)];
      var $26942=HEAP32[(($3191)>>2)];
      var $26943=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26940, $26941, $26942) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4785; break; } else { __label__ = 4787; break; };
    case 4785: // $26944
      HEAP32[(($result_i597)>>2)]=$26943;
      var $26945=HEAP32[(($result_i597)>>2)];
      var $26946=(($26945)|0)==0;
      if ($26946) { __label__ = 4786; break; } else { __label__ = 4791; break; }
    case 4786: // $26947
      var $26948=___cxa_allocate_exception(4);
      var $26949=$26948;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26949);
      (function() { try { __THREW__ = false; return ___cxa_throw($26948, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4790; break; } else { __label__ = 4787; break; }
    case 4787: // $26950
      var $26951=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26952=$26951.f0;
      HEAP32[(($3192)>>2)]=$26952;
      var $26953=$26951.f1;
      HEAP32[(($3193)>>2)]=$26953;
      var $26954=HEAP32[(($3193)>>2)];
      var $26955=(($26954)|0) < 0;
      if ($26955) { __label__ = 4788; break; } else { __label__ = 4789; break; }
    case 4788: // $26956
      var $26957=HEAP32[(($3192)>>2)];
      ___cxa_call_unexpected($26957);
      throw "Reached an unreachable!"
    case 4789: // $26958
      var $26959=HEAP32[(($3192)>>2)];
      var $26960=HEAP32[(($3192)>>2)];
      var $26961=HEAP32[(($3193)>>2)];
      var $26962=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26960, tempValue);
      var $26963=($26962.f1 = $26961, $26962);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4790: // $26964
      throw "Reached an unreachable!"
    case 4791: // $_ZnwjPKci_exit598
      var $26965=HEAP32[(($result_i597)>>2)];
      var $26966=$3189;
      var $26967=$3190;
      var $26968=$3191;
      var $26969=$result_i597;
      var $26970=$3192;
      var $26971=$3193;
      var $26972=$26965;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7085, 4, 6, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4792; break; } else { __label__ = 13176; break; }
    case 4792: // $26973
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7086, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4793; break; } else { __label__ = 13176; break; }
    case 4793: // $26974
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7087, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4794; break; } else { __label__ = 13176; break; }
    case 4794: // $26975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4795; break; } else { __label__ = 13176; break; }
    case 4795: // $26976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4796; break; } else { __label__ = 13176; break; }
    case 4796: // $26977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4797; break; } else { __label__ = 13176; break; }
    case 4797: // $26978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4798; break; } else { __label__ = 13176; break; }
    case 4798: // $26979
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7084, $7085, $7086, $7087, $7088, $7089, $7090, $7091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4799; break; } else { __label__ = 13176; break; }
    case 4799: // $26980
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($26972, 62, 7, 6, ((STRING_TABLE.__str789)|0), ((STRING_TABLE.__str790)|0), $7084) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4800; break; } else { __label__ = 13176; break; }
    case 4800: // $26981
      var $26982=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $26972);
      var $26983=__ZN11simple_listI16input_type_entryE6appendERS0_($26933, $26982);
      var $26984=$4689;
      var $26985=$3184;
      var $26986=$3185;
      var $26987=$3186;
      var $26988=$result_i599;
      var $26989=$3187;
      var $26990=$3188;
      HEAP32[(($3184)>>2)]=408;
      HEAP32[(($3185)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3186)>>2)]=360;
      var $26991=HEAP32[(($3184)>>2)];
      var $26992=HEAP32[(($3185)>>2)];
      var $26993=HEAP32[(($3186)>>2)];
      var $26994=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26991, $26992, $26993) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4801; break; } else { __label__ = 4803; break; };
    case 4801: // $26995
      HEAP32[(($result_i599)>>2)]=$26994;
      var $26996=HEAP32[(($result_i599)>>2)];
      var $26997=(($26996)|0)==0;
      if ($26997) { __label__ = 4802; break; } else { __label__ = 4807; break; }
    case 4802: // $26998
      var $26999=___cxa_allocate_exception(4);
      var $27000=$26999;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27000);
      (function() { try { __THREW__ = false; return ___cxa_throw($26999, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4806; break; } else { __label__ = 4803; break; }
    case 4803: // $27001
      var $27002=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27003=$27002.f0;
      HEAP32[(($3187)>>2)]=$27003;
      var $27004=$27002.f1;
      HEAP32[(($3188)>>2)]=$27004;
      var $27005=HEAP32[(($3188)>>2)];
      var $27006=(($27005)|0) < 0;
      if ($27006) { __label__ = 4804; break; } else { __label__ = 4805; break; }
    case 4804: // $27007
      var $27008=HEAP32[(($3187)>>2)];
      ___cxa_call_unexpected($27008);
      throw "Reached an unreachable!"
    case 4805: // $27009
      var $27010=HEAP32[(($3187)>>2)];
      var $27011=HEAP32[(($3187)>>2)];
      var $27012=HEAP32[(($3188)>>2)];
      var $27013=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27011, tempValue);
      var $27014=($27013.f1 = $27012, $27013);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4806: // $27015
      throw "Reached an unreachable!"
    case 4807: // $_ZnwjPKci_exit600
      var $27016=HEAP32[(($result_i599)>>2)];
      var $27017=$3184;
      var $27018=$3185;
      var $27019=$3186;
      var $27020=$result_i599;
      var $27021=$3187;
      var $27022=$3188;
      var $27023=$27016;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7093, 4, 6, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4808; break; } else { __label__ = 13181; break; }
    case 4808: // $27024
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7094, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4809; break; } else { __label__ = 13181; break; }
    case 4809: // $27025
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7095, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4810; break; } else { __label__ = 13181; break; }
    case 4810: // $27026
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4811; break; } else { __label__ = 13181; break; }
    case 4811: // $27027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4812; break; } else { __label__ = 13181; break; }
    case 4812: // $27028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4813; break; } else { __label__ = 13181; break; }
    case 4813: // $27029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4814; break; } else { __label__ = 13181; break; }
    case 4814: // $27030
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7092, $7093, $7094, $7095, $7096, $7097, $7098, $7099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4815; break; } else { __label__ = 13181; break; }
    case 4815: // $27031
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27023, 63, 7, 6, ((STRING_TABLE.__str791)|0), ((STRING_TABLE.__str792)|0), $7092) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4816; break; } else { __label__ = 13181; break; }
    case 4816: // $27032
      var $27033=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27023);
      var $27034=__ZN11simple_listI16input_type_entryE6appendERS0_($26984, $27033);
      var $27035=$4689;
      var $27036=$3179;
      var $27037=$3180;
      var $27038=$3181;
      var $27039=$result_i601;
      var $27040=$3182;
      var $27041=$3183;
      HEAP32[(($3179)>>2)]=408;
      HEAP32[(($3180)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3181)>>2)]=361;
      var $27042=HEAP32[(($3179)>>2)];
      var $27043=HEAP32[(($3180)>>2)];
      var $27044=HEAP32[(($3181)>>2)];
      var $27045=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27042, $27043, $27044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4817; break; } else { __label__ = 4819; break; };
    case 4817: // $27046
      HEAP32[(($result_i601)>>2)]=$27045;
      var $27047=HEAP32[(($result_i601)>>2)];
      var $27048=(($27047)|0)==0;
      if ($27048) { __label__ = 4818; break; } else { __label__ = 4823; break; }
    case 4818: // $27049
      var $27050=___cxa_allocate_exception(4);
      var $27051=$27050;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27051);
      (function() { try { __THREW__ = false; return ___cxa_throw($27050, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4822; break; } else { __label__ = 4819; break; }
    case 4819: // $27052
      var $27053=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27054=$27053.f0;
      HEAP32[(($3182)>>2)]=$27054;
      var $27055=$27053.f1;
      HEAP32[(($3183)>>2)]=$27055;
      var $27056=HEAP32[(($3183)>>2)];
      var $27057=(($27056)|0) < 0;
      if ($27057) { __label__ = 4820; break; } else { __label__ = 4821; break; }
    case 4820: // $27058
      var $27059=HEAP32[(($3182)>>2)];
      ___cxa_call_unexpected($27059);
      throw "Reached an unreachable!"
    case 4821: // $27060
      var $27061=HEAP32[(($3182)>>2)];
      var $27062=HEAP32[(($3182)>>2)];
      var $27063=HEAP32[(($3183)>>2)];
      var $27064=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27062, tempValue);
      var $27065=($27064.f1 = $27063, $27064);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4822: // $27066
      throw "Reached an unreachable!"
    case 4823: // $_ZnwjPKci_exit602
      var $27067=HEAP32[(($result_i601)>>2)];
      var $27068=$3179;
      var $27069=$3180;
      var $27070=$3181;
      var $27071=$result_i601;
      var $27072=$3182;
      var $27073=$3183;
      var $27074=$27067;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7101, 4, 6, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4824; break; } else { __label__ = 13186; break; }
    case 4824: // $27075
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7102, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4825; break; } else { __label__ = 13186; break; }
    case 4825: // $27076
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7103, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4826; break; } else { __label__ = 13186; break; }
    case 4826: // $27077
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7104, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4827; break; } else { __label__ = 13186; break; }
    case 4827: // $27078
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7105, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4828; break; } else { __label__ = 13186; break; }
    case 4828: // $27079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4829; break; } else { __label__ = 13186; break; }
    case 4829: // $27080
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4830; break; } else { __label__ = 13186; break; }
    case 4830: // $27081
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7100, $7101, $7102, $7103, $7104, $7105, $7106, $7107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4831; break; } else { __label__ = 13186; break; }
    case 4831: // $27082
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27074, 64, 7, 6, ((STRING_TABLE.__str793)|0), ((STRING_TABLE.__str794)|0), $7100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4832; break; } else { __label__ = 13186; break; }
    case 4832: // $27083
      var $27084=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27074);
      var $27085=__ZN11simple_listI16input_type_entryE6appendERS0_($27035, $27084);
      var $27086=$4689;
      var $27087=$3174;
      var $27088=$3175;
      var $27089=$3176;
      var $27090=$result_i603;
      var $27091=$3177;
      var $27092=$3178;
      HEAP32[(($3174)>>2)]=408;
      HEAP32[(($3175)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3176)>>2)]=362;
      var $27093=HEAP32[(($3174)>>2)];
      var $27094=HEAP32[(($3175)>>2)];
      var $27095=HEAP32[(($3176)>>2)];
      var $27096=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27093, $27094, $27095) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4833; break; } else { __label__ = 4835; break; };
    case 4833: // $27097
      HEAP32[(($result_i603)>>2)]=$27096;
      var $27098=HEAP32[(($result_i603)>>2)];
      var $27099=(($27098)|0)==0;
      if ($27099) { __label__ = 4834; break; } else { __label__ = 4839; break; }
    case 4834: // $27100
      var $27101=___cxa_allocate_exception(4);
      var $27102=$27101;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27102);
      (function() { try { __THREW__ = false; return ___cxa_throw($27101, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4838; break; } else { __label__ = 4835; break; }
    case 4835: // $27103
      var $27104=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27105=$27104.f0;
      HEAP32[(($3177)>>2)]=$27105;
      var $27106=$27104.f1;
      HEAP32[(($3178)>>2)]=$27106;
      var $27107=HEAP32[(($3178)>>2)];
      var $27108=(($27107)|0) < 0;
      if ($27108) { __label__ = 4836; break; } else { __label__ = 4837; break; }
    case 4836: // $27109
      var $27110=HEAP32[(($3177)>>2)];
      ___cxa_call_unexpected($27110);
      throw "Reached an unreachable!"
    case 4837: // $27111
      var $27112=HEAP32[(($3177)>>2)];
      var $27113=HEAP32[(($3177)>>2)];
      var $27114=HEAP32[(($3178)>>2)];
      var $27115=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27113, tempValue);
      var $27116=($27115.f1 = $27114, $27115);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4838: // $27117
      throw "Reached an unreachable!"
    case 4839: // $_ZnwjPKci_exit604
      var $27118=HEAP32[(($result_i603)>>2)];
      var $27119=$3174;
      var $27120=$3175;
      var $27121=$3176;
      var $27122=$result_i603;
      var $27123=$3177;
      var $27124=$3178;
      var $27125=$27118;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7109, 4, 6, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4840; break; } else { __label__ = 13191; break; }
    case 4840: // $27126
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7110, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4841; break; } else { __label__ = 13191; break; }
    case 4841: // $27127
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7111, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4842; break; } else { __label__ = 13191; break; }
    case 4842: // $27128
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7112, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4843; break; } else { __label__ = 13191; break; }
    case 4843: // $27129
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7113, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4844; break; } else { __label__ = 13191; break; }
    case 4844: // $27130
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4845; break; } else { __label__ = 13191; break; }
    case 4845: // $27131
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4846; break; } else { __label__ = 13191; break; }
    case 4846: // $27132
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7108, $7109, $7110, $7111, $7112, $7113, $7114, $7115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4847; break; } else { __label__ = 13191; break; }
    case 4847: // $27133
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27125, 65, 7, 6, ((STRING_TABLE.__str795)|0), ((STRING_TABLE.__str796)|0), $7108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4848; break; } else { __label__ = 13191; break; }
    case 4848: // $27134
      var $27135=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27125);
      var $27136=__ZN11simple_listI16input_type_entryE6appendERS0_($27086, $27135);
      var $27137=$4689;
      var $27138=$3169;
      var $27139=$3170;
      var $27140=$3171;
      var $27141=$result_i605;
      var $27142=$3172;
      var $27143=$3173;
      HEAP32[(($3169)>>2)]=408;
      HEAP32[(($3170)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3171)>>2)]=363;
      var $27144=HEAP32[(($3169)>>2)];
      var $27145=HEAP32[(($3170)>>2)];
      var $27146=HEAP32[(($3171)>>2)];
      var $27147=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27144, $27145, $27146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4849; break; } else { __label__ = 4851; break; };
    case 4849: // $27148
      HEAP32[(($result_i605)>>2)]=$27147;
      var $27149=HEAP32[(($result_i605)>>2)];
      var $27150=(($27149)|0)==0;
      if ($27150) { __label__ = 4850; break; } else { __label__ = 4855; break; }
    case 4850: // $27151
      var $27152=___cxa_allocate_exception(4);
      var $27153=$27152;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27153);
      (function() { try { __THREW__ = false; return ___cxa_throw($27152, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4854; break; } else { __label__ = 4851; break; }
    case 4851: // $27154
      var $27155=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27156=$27155.f0;
      HEAP32[(($3172)>>2)]=$27156;
      var $27157=$27155.f1;
      HEAP32[(($3173)>>2)]=$27157;
      var $27158=HEAP32[(($3173)>>2)];
      var $27159=(($27158)|0) < 0;
      if ($27159) { __label__ = 4852; break; } else { __label__ = 4853; break; }
    case 4852: // $27160
      var $27161=HEAP32[(($3172)>>2)];
      ___cxa_call_unexpected($27161);
      throw "Reached an unreachable!"
    case 4853: // $27162
      var $27163=HEAP32[(($3172)>>2)];
      var $27164=HEAP32[(($3172)>>2)];
      var $27165=HEAP32[(($3173)>>2)];
      var $27166=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27164, tempValue);
      var $27167=($27166.f1 = $27165, $27166);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4854: // $27168
      throw "Reached an unreachable!"
    case 4855: // $_ZnwjPKci_exit606
      var $27169=HEAP32[(($result_i605)>>2)];
      var $27170=$3169;
      var $27171=$3170;
      var $27172=$3171;
      var $27173=$result_i605;
      var $27174=$3172;
      var $27175=$3173;
      var $27176=$27169;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7117, 4, 6, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4856; break; } else { __label__ = 13196; break; }
    case 4856: // $27177
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7118, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4857; break; } else { __label__ = 13196; break; }
    case 4857: // $27178
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7119, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4858; break; } else { __label__ = 13196; break; }
    case 4858: // $27179
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4859; break; } else { __label__ = 13196; break; }
    case 4859: // $27180
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4860; break; } else { __label__ = 13196; break; }
    case 4860: // $27181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4861; break; } else { __label__ = 13196; break; }
    case 4861: // $27182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4862; break; } else { __label__ = 13196; break; }
    case 4862: // $27183
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7116, $7117, $7118, $7119, $7120, $7121, $7122, $7123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4863; break; } else { __label__ = 13196; break; }
    case 4863: // $27184
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27176, 66, 7, 6, ((STRING_TABLE.__str797)|0), ((STRING_TABLE.__str798)|0), $7116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4864; break; } else { __label__ = 13196; break; }
    case 4864: // $27185
      var $27186=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27176);
      var $27187=__ZN11simple_listI16input_type_entryE6appendERS0_($27137, $27186);
      var $27188=$4689;
      var $27189=$3164;
      var $27190=$3165;
      var $27191=$3166;
      var $27192=$result_i607;
      var $27193=$3167;
      var $27194=$3168;
      HEAP32[(($3164)>>2)]=408;
      HEAP32[(($3165)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3166)>>2)]=364;
      var $27195=HEAP32[(($3164)>>2)];
      var $27196=HEAP32[(($3165)>>2)];
      var $27197=HEAP32[(($3166)>>2)];
      var $27198=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27195, $27196, $27197) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4865; break; } else { __label__ = 4867; break; };
    case 4865: // $27199
      HEAP32[(($result_i607)>>2)]=$27198;
      var $27200=HEAP32[(($result_i607)>>2)];
      var $27201=(($27200)|0)==0;
      if ($27201) { __label__ = 4866; break; } else { __label__ = 4871; break; }
    case 4866: // $27202
      var $27203=___cxa_allocate_exception(4);
      var $27204=$27203;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27204);
      (function() { try { __THREW__ = false; return ___cxa_throw($27203, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4870; break; } else { __label__ = 4867; break; }
    case 4867: // $27205
      var $27206=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27207=$27206.f0;
      HEAP32[(($3167)>>2)]=$27207;
      var $27208=$27206.f1;
      HEAP32[(($3168)>>2)]=$27208;
      var $27209=HEAP32[(($3168)>>2)];
      var $27210=(($27209)|0) < 0;
      if ($27210) { __label__ = 4868; break; } else { __label__ = 4869; break; }
    case 4868: // $27211
      var $27212=HEAP32[(($3167)>>2)];
      ___cxa_call_unexpected($27212);
      throw "Reached an unreachable!"
    case 4869: // $27213
      var $27214=HEAP32[(($3167)>>2)];
      var $27215=HEAP32[(($3167)>>2)];
      var $27216=HEAP32[(($3168)>>2)];
      var $27217=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27215, tempValue);
      var $27218=($27217.f1 = $27216, $27217);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4870: // $27219
      throw "Reached an unreachable!"
    case 4871: // $_ZnwjPKci_exit608
      var $27220=HEAP32[(($result_i607)>>2)];
      var $27221=$3164;
      var $27222=$3165;
      var $27223=$3166;
      var $27224=$result_i607;
      var $27225=$3167;
      var $27226=$3168;
      var $27227=$27220;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7125, 4, 6, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4872; break; } else { __label__ = 13201; break; }
    case 4872: // $27228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7126, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4873; break; } else { __label__ = 13201; break; }
    case 4873: // $27229
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7127, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4874; break; } else { __label__ = 13201; break; }
    case 4874: // $27230
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4875; break; } else { __label__ = 13201; break; }
    case 4875: // $27231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4876; break; } else { __label__ = 13201; break; }
    case 4876: // $27232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4877; break; } else { __label__ = 13201; break; }
    case 4877: // $27233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4878; break; } else { __label__ = 13201; break; }
    case 4878: // $27234
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7124, $7125, $7126, $7127, $7128, $7129, $7130, $7131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4879; break; } else { __label__ = 13201; break; }
    case 4879: // $27235
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27227, 67, 7, 6, ((STRING_TABLE.__str799)|0), ((STRING_TABLE.__str800)|0), $7124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4880; break; } else { __label__ = 13201; break; }
    case 4880: // $27236
      var $27237=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27227);
      var $27238=__ZN11simple_listI16input_type_entryE6appendERS0_($27188, $27237);
      var $27239=$4689;
      var $27240=$3159;
      var $27241=$3160;
      var $27242=$3161;
      var $27243=$result_i609;
      var $27244=$3162;
      var $27245=$3163;
      HEAP32[(($3159)>>2)]=408;
      HEAP32[(($3160)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3161)>>2)]=365;
      var $27246=HEAP32[(($3159)>>2)];
      var $27247=HEAP32[(($3160)>>2)];
      var $27248=HEAP32[(($3161)>>2)];
      var $27249=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27246, $27247, $27248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4881; break; } else { __label__ = 4883; break; };
    case 4881: // $27250
      HEAP32[(($result_i609)>>2)]=$27249;
      var $27251=HEAP32[(($result_i609)>>2)];
      var $27252=(($27251)|0)==0;
      if ($27252) { __label__ = 4882; break; } else { __label__ = 4887; break; }
    case 4882: // $27253
      var $27254=___cxa_allocate_exception(4);
      var $27255=$27254;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27255);
      (function() { try { __THREW__ = false; return ___cxa_throw($27254, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4886; break; } else { __label__ = 4883; break; }
    case 4883: // $27256
      var $27257=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27258=$27257.f0;
      HEAP32[(($3162)>>2)]=$27258;
      var $27259=$27257.f1;
      HEAP32[(($3163)>>2)]=$27259;
      var $27260=HEAP32[(($3163)>>2)];
      var $27261=(($27260)|0) < 0;
      if ($27261) { __label__ = 4884; break; } else { __label__ = 4885; break; }
    case 4884: // $27262
      var $27263=HEAP32[(($3162)>>2)];
      ___cxa_call_unexpected($27263);
      throw "Reached an unreachable!"
    case 4885: // $27264
      var $27265=HEAP32[(($3162)>>2)];
      var $27266=HEAP32[(($3162)>>2)];
      var $27267=HEAP32[(($3163)>>2)];
      var $27268=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27266, tempValue);
      var $27269=($27268.f1 = $27267, $27268);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4886: // $27270
      throw "Reached an unreachable!"
    case 4887: // $_ZnwjPKci_exit610
      var $27271=HEAP32[(($result_i609)>>2)];
      var $27272=$3159;
      var $27273=$3160;
      var $27274=$3161;
      var $27275=$result_i609;
      var $27276=$3162;
      var $27277=$3163;
      var $27278=$27271;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7133, 4, 6, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4888; break; } else { __label__ = 13206; break; }
    case 4888: // $27279
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7134, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4889; break; } else { __label__ = 13206; break; }
    case 4889: // $27280
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7135, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4890; break; } else { __label__ = 13206; break; }
    case 4890: // $27281
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4891; break; } else { __label__ = 13206; break; }
    case 4891: // $27282
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4892; break; } else { __label__ = 13206; break; }
    case 4892: // $27283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4893; break; } else { __label__ = 13206; break; }
    case 4893: // $27284
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4894; break; } else { __label__ = 13206; break; }
    case 4894: // $27285
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7132, $7133, $7134, $7135, $7136, $7137, $7138, $7139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4895; break; } else { __label__ = 13206; break; }
    case 4895: // $27286
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27278, 68, 7, 6, ((STRING_TABLE.__str801)|0), ((STRING_TABLE.__str802)|0), $7132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4896; break; } else { __label__ = 13206; break; }
    case 4896: // $27287
      var $27288=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27278);
      var $27289=__ZN11simple_listI16input_type_entryE6appendERS0_($27239, $27288);
      var $27290=$4689;
      var $27291=$3154;
      var $27292=$3155;
      var $27293=$3156;
      var $27294=$result_i611;
      var $27295=$3157;
      var $27296=$3158;
      HEAP32[(($3154)>>2)]=408;
      HEAP32[(($3155)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3156)>>2)]=366;
      var $27297=HEAP32[(($3154)>>2)];
      var $27298=HEAP32[(($3155)>>2)];
      var $27299=HEAP32[(($3156)>>2)];
      var $27300=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27297, $27298, $27299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4897; break; } else { __label__ = 4899; break; };
    case 4897: // $27301
      HEAP32[(($result_i611)>>2)]=$27300;
      var $27302=HEAP32[(($result_i611)>>2)];
      var $27303=(($27302)|0)==0;
      if ($27303) { __label__ = 4898; break; } else { __label__ = 4903; break; }
    case 4898: // $27304
      var $27305=___cxa_allocate_exception(4);
      var $27306=$27305;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27306);
      (function() { try { __THREW__ = false; return ___cxa_throw($27305, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4902; break; } else { __label__ = 4899; break; }
    case 4899: // $27307
      var $27308=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27309=$27308.f0;
      HEAP32[(($3157)>>2)]=$27309;
      var $27310=$27308.f1;
      HEAP32[(($3158)>>2)]=$27310;
      var $27311=HEAP32[(($3158)>>2)];
      var $27312=(($27311)|0) < 0;
      if ($27312) { __label__ = 4900; break; } else { __label__ = 4901; break; }
    case 4900: // $27313
      var $27314=HEAP32[(($3157)>>2)];
      ___cxa_call_unexpected($27314);
      throw "Reached an unreachable!"
    case 4901: // $27315
      var $27316=HEAP32[(($3157)>>2)];
      var $27317=HEAP32[(($3157)>>2)];
      var $27318=HEAP32[(($3158)>>2)];
      var $27319=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27317, tempValue);
      var $27320=($27319.f1 = $27318, $27319);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4902: // $27321
      throw "Reached an unreachable!"
    case 4903: // $_ZnwjPKci_exit612
      var $27322=HEAP32[(($result_i611)>>2)];
      var $27323=$3154;
      var $27324=$3155;
      var $27325=$3156;
      var $27326=$result_i611;
      var $27327=$3157;
      var $27328=$3158;
      var $27329=$27322;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7141, 4, 6, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4904; break; } else { __label__ = 13211; break; }
    case 4904: // $27330
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7142, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4905; break; } else { __label__ = 13211; break; }
    case 4905: // $27331
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7143, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4906; break; } else { __label__ = 13211; break; }
    case 4906: // $27332
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4907; break; } else { __label__ = 13211; break; }
    case 4907: // $27333
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4908; break; } else { __label__ = 13211; break; }
    case 4908: // $27334
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4909; break; } else { __label__ = 13211; break; }
    case 4909: // $27335
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4910; break; } else { __label__ = 13211; break; }
    case 4910: // $27336
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7140, $7141, $7142, $7143, $7144, $7145, $7146, $7147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4911; break; } else { __label__ = 13211; break; }
    case 4911: // $27337
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27329, 69, 7, 6, ((STRING_TABLE.__str803)|0), ((STRING_TABLE.__str804)|0), $7140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4912; break; } else { __label__ = 13211; break; }
    case 4912: // $27338
      var $27339=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27329);
      var $27340=__ZN11simple_listI16input_type_entryE6appendERS0_($27290, $27339);
      var $27341=$4689;
      var $27342=$3149;
      var $27343=$3150;
      var $27344=$3151;
      var $27345=$result_i613;
      var $27346=$3152;
      var $27347=$3153;
      HEAP32[(($3149)>>2)]=408;
      HEAP32[(($3150)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3151)>>2)]=367;
      var $27348=HEAP32[(($3149)>>2)];
      var $27349=HEAP32[(($3150)>>2)];
      var $27350=HEAP32[(($3151)>>2)];
      var $27351=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27348, $27349, $27350) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4913; break; } else { __label__ = 4915; break; };
    case 4913: // $27352
      HEAP32[(($result_i613)>>2)]=$27351;
      var $27353=HEAP32[(($result_i613)>>2)];
      var $27354=(($27353)|0)==0;
      if ($27354) { __label__ = 4914; break; } else { __label__ = 4919; break; }
    case 4914: // $27355
      var $27356=___cxa_allocate_exception(4);
      var $27357=$27356;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27357);
      (function() { try { __THREW__ = false; return ___cxa_throw($27356, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4918; break; } else { __label__ = 4915; break; }
    case 4915: // $27358
      var $27359=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27360=$27359.f0;
      HEAP32[(($3152)>>2)]=$27360;
      var $27361=$27359.f1;
      HEAP32[(($3153)>>2)]=$27361;
      var $27362=HEAP32[(($3153)>>2)];
      var $27363=(($27362)|0) < 0;
      if ($27363) { __label__ = 4916; break; } else { __label__ = 4917; break; }
    case 4916: // $27364
      var $27365=HEAP32[(($3152)>>2)];
      ___cxa_call_unexpected($27365);
      throw "Reached an unreachable!"
    case 4917: // $27366
      var $27367=HEAP32[(($3152)>>2)];
      var $27368=HEAP32[(($3152)>>2)];
      var $27369=HEAP32[(($3153)>>2)];
      var $27370=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27368, tempValue);
      var $27371=($27370.f1 = $27369, $27370);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4918: // $27372
      throw "Reached an unreachable!"
    case 4919: // $_ZnwjPKci_exit614
      var $27373=HEAP32[(($result_i613)>>2)];
      var $27374=$3149;
      var $27375=$3150;
      var $27376=$3151;
      var $27377=$result_i613;
      var $27378=$3152;
      var $27379=$3153;
      var $27380=$27373;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7149, 4, 6, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4920; break; } else { __label__ = 13216; break; }
    case 4920: // $27381
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4921; break; } else { __label__ = 13216; break; }
    case 4921: // $27382
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4922; break; } else { __label__ = 13216; break; }
    case 4922: // $27383
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4923; break; } else { __label__ = 13216; break; }
    case 4923: // $27384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4924; break; } else { __label__ = 13216; break; }
    case 4924: // $27385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4925; break; } else { __label__ = 13216; break; }
    case 4925: // $27386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4926; break; } else { __label__ = 13216; break; }
    case 4926: // $27387
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7148, $7149, $7150, $7151, $7152, $7153, $7154, $7155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4927; break; } else { __label__ = 13216; break; }
    case 4927: // $27388
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27380, 70, 7, 6, ((STRING_TABLE.__str805)|0), ((STRING_TABLE.__str806)|0), $7148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4928; break; } else { __label__ = 13216; break; }
    case 4928: // $27389
      var $27390=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27380);
      var $27391=__ZN11simple_listI16input_type_entryE6appendERS0_($27341, $27390);
      var $27392=$4689;
      var $27393=$3144;
      var $27394=$3145;
      var $27395=$3146;
      var $27396=$result_i615;
      var $27397=$3147;
      var $27398=$3148;
      HEAP32[(($3144)>>2)]=408;
      HEAP32[(($3145)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3146)>>2)]=368;
      var $27399=HEAP32[(($3144)>>2)];
      var $27400=HEAP32[(($3145)>>2)];
      var $27401=HEAP32[(($3146)>>2)];
      var $27402=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27399, $27400, $27401) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4929; break; } else { __label__ = 4931; break; };
    case 4929: // $27403
      HEAP32[(($result_i615)>>2)]=$27402;
      var $27404=HEAP32[(($result_i615)>>2)];
      var $27405=(($27404)|0)==0;
      if ($27405) { __label__ = 4930; break; } else { __label__ = 4935; break; }
    case 4930: // $27406
      var $27407=___cxa_allocate_exception(4);
      var $27408=$27407;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27408);
      (function() { try { __THREW__ = false; return ___cxa_throw($27407, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4934; break; } else { __label__ = 4931; break; }
    case 4931: // $27409
      var $27410=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27411=$27410.f0;
      HEAP32[(($3147)>>2)]=$27411;
      var $27412=$27410.f1;
      HEAP32[(($3148)>>2)]=$27412;
      var $27413=HEAP32[(($3148)>>2)];
      var $27414=(($27413)|0) < 0;
      if ($27414) { __label__ = 4932; break; } else { __label__ = 4933; break; }
    case 4932: // $27415
      var $27416=HEAP32[(($3147)>>2)];
      ___cxa_call_unexpected($27416);
      throw "Reached an unreachable!"
    case 4933: // $27417
      var $27418=HEAP32[(($3147)>>2)];
      var $27419=HEAP32[(($3147)>>2)];
      var $27420=HEAP32[(($3148)>>2)];
      var $27421=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27419, tempValue);
      var $27422=($27421.f1 = $27420, $27421);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4934: // $27423
      throw "Reached an unreachable!"
    case 4935: // $_ZnwjPKci_exit616
      var $27424=HEAP32[(($result_i615)>>2)];
      var $27425=$3144;
      var $27426=$3145;
      var $27427=$3146;
      var $27428=$result_i615;
      var $27429=$3147;
      var $27430=$3148;
      var $27431=$27424;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7157, 4, 6, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4936; break; } else { __label__ = 13221; break; }
    case 4936: // $27432
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7158, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4937; break; } else { __label__ = 13221; break; }
    case 4937: // $27433
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7159, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4938; break; } else { __label__ = 13221; break; }
    case 4938: // $27434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4939; break; } else { __label__ = 13221; break; }
    case 4939: // $27435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4940; break; } else { __label__ = 13221; break; }
    case 4940: // $27436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4941; break; } else { __label__ = 13221; break; }
    case 4941: // $27437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4942; break; } else { __label__ = 13221; break; }
    case 4942: // $27438
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7156, $7157, $7158, $7159, $7160, $7161, $7162, $7163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4943; break; } else { __label__ = 13221; break; }
    case 4943: // $27439
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27431, 71, 7, 6, ((STRING_TABLE.__str807)|0), ((STRING_TABLE.__str808)|0), $7156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4944; break; } else { __label__ = 13221; break; }
    case 4944: // $27440
      var $27441=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27431);
      var $27442=__ZN11simple_listI16input_type_entryE6appendERS0_($27392, $27441);
      var $27443=$4689;
      var $27444=$3139;
      var $27445=$3140;
      var $27446=$3141;
      var $27447=$result_i617;
      var $27448=$3142;
      var $27449=$3143;
      HEAP32[(($3139)>>2)]=408;
      HEAP32[(($3140)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3141)>>2)]=369;
      var $27450=HEAP32[(($3139)>>2)];
      var $27451=HEAP32[(($3140)>>2)];
      var $27452=HEAP32[(($3141)>>2)];
      var $27453=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27450, $27451, $27452) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4945; break; } else { __label__ = 4947; break; };
    case 4945: // $27454
      HEAP32[(($result_i617)>>2)]=$27453;
      var $27455=HEAP32[(($result_i617)>>2)];
      var $27456=(($27455)|0)==0;
      if ($27456) { __label__ = 4946; break; } else { __label__ = 4951; break; }
    case 4946: // $27457
      var $27458=___cxa_allocate_exception(4);
      var $27459=$27458;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27459);
      (function() { try { __THREW__ = false; return ___cxa_throw($27458, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4950; break; } else { __label__ = 4947; break; }
    case 4947: // $27460
      var $27461=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27462=$27461.f0;
      HEAP32[(($3142)>>2)]=$27462;
      var $27463=$27461.f1;
      HEAP32[(($3143)>>2)]=$27463;
      var $27464=HEAP32[(($3143)>>2)];
      var $27465=(($27464)|0) < 0;
      if ($27465) { __label__ = 4948; break; } else { __label__ = 4949; break; }
    case 4948: // $27466
      var $27467=HEAP32[(($3142)>>2)];
      ___cxa_call_unexpected($27467);
      throw "Reached an unreachable!"
    case 4949: // $27468
      var $27469=HEAP32[(($3142)>>2)];
      var $27470=HEAP32[(($3142)>>2)];
      var $27471=HEAP32[(($3143)>>2)];
      var $27472=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27470, tempValue);
      var $27473=($27472.f1 = $27471, $27472);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4950: // $27474
      throw "Reached an unreachable!"
    case 4951: // $_ZnwjPKci_exit618
      var $27475=HEAP32[(($result_i617)>>2)];
      var $27476=$3139;
      var $27477=$3140;
      var $27478=$3141;
      var $27479=$result_i617;
      var $27480=$3142;
      var $27481=$3143;
      var $27482=$27475;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7165, 4, 6, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4952; break; } else { __label__ = 13226; break; }
    case 4952: // $27483
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7166, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4953; break; } else { __label__ = 13226; break; }
    case 4953: // $27484
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7167, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4954; break; } else { __label__ = 13226; break; }
    case 4954: // $27485
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4955; break; } else { __label__ = 13226; break; }
    case 4955: // $27486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4956; break; } else { __label__ = 13226; break; }
    case 4956: // $27487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4957; break; } else { __label__ = 13226; break; }
    case 4957: // $27488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4958; break; } else { __label__ = 13226; break; }
    case 4958: // $27489
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7164, $7165, $7166, $7167, $7168, $7169, $7170, $7171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4959; break; } else { __label__ = 13226; break; }
    case 4959: // $27490
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27482, 72, 7, 6, ((STRING_TABLE.__str809)|0), ((STRING_TABLE.__str810)|0), $7164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4960; break; } else { __label__ = 13226; break; }
    case 4960: // $27491
      var $27492=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27482);
      var $27493=__ZN11simple_listI16input_type_entryE6appendERS0_($27443, $27492);
      var $27494=$4689;
      var $27495=$3134;
      var $27496=$3135;
      var $27497=$3136;
      var $27498=$result_i619;
      var $27499=$3137;
      var $27500=$3138;
      HEAP32[(($3134)>>2)]=408;
      HEAP32[(($3135)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3136)>>2)]=370;
      var $27501=HEAP32[(($3134)>>2)];
      var $27502=HEAP32[(($3135)>>2)];
      var $27503=HEAP32[(($3136)>>2)];
      var $27504=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27501, $27502, $27503) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4961; break; } else { __label__ = 4963; break; };
    case 4961: // $27505
      HEAP32[(($result_i619)>>2)]=$27504;
      var $27506=HEAP32[(($result_i619)>>2)];
      var $27507=(($27506)|0)==0;
      if ($27507) { __label__ = 4962; break; } else { __label__ = 4967; break; }
    case 4962: // $27508
      var $27509=___cxa_allocate_exception(4);
      var $27510=$27509;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27510);
      (function() { try { __THREW__ = false; return ___cxa_throw($27509, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4966; break; } else { __label__ = 4963; break; }
    case 4963: // $27511
      var $27512=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27513=$27512.f0;
      HEAP32[(($3137)>>2)]=$27513;
      var $27514=$27512.f1;
      HEAP32[(($3138)>>2)]=$27514;
      var $27515=HEAP32[(($3138)>>2)];
      var $27516=(($27515)|0) < 0;
      if ($27516) { __label__ = 4964; break; } else { __label__ = 4965; break; }
    case 4964: // $27517
      var $27518=HEAP32[(($3137)>>2)];
      ___cxa_call_unexpected($27518);
      throw "Reached an unreachable!"
    case 4965: // $27519
      var $27520=HEAP32[(($3137)>>2)];
      var $27521=HEAP32[(($3137)>>2)];
      var $27522=HEAP32[(($3138)>>2)];
      var $27523=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27521, tempValue);
      var $27524=($27523.f1 = $27522, $27523);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4966: // $27525
      throw "Reached an unreachable!"
    case 4967: // $_ZnwjPKci_exit620
      var $27526=HEAP32[(($result_i619)>>2)];
      var $27527=$3134;
      var $27528=$3135;
      var $27529=$3136;
      var $27530=$result_i619;
      var $27531=$3137;
      var $27532=$3138;
      var $27533=$27526;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7173, 4, 6, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4968; break; } else { __label__ = 13231; break; }
    case 4968: // $27534
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4969; break; } else { __label__ = 13231; break; }
    case 4969: // $27535
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4970; break; } else { __label__ = 13231; break; }
    case 4970: // $27536
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4971; break; } else { __label__ = 13231; break; }
    case 4971: // $27537
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4972; break; } else { __label__ = 13231; break; }
    case 4972: // $27538
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4973; break; } else { __label__ = 13231; break; }
    case 4973: // $27539
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4974; break; } else { __label__ = 13231; break; }
    case 4974: // $27540
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7172, $7173, $7174, $7175, $7176, $7177, $7178, $7179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4975; break; } else { __label__ = 13231; break; }
    case 4975: // $27541
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27533, 73, 7, 6, ((STRING_TABLE.__str811)|0), ((STRING_TABLE.__str812)|0), $7172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4976; break; } else { __label__ = 13231; break; }
    case 4976: // $27542
      var $27543=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27533);
      var $27544=__ZN11simple_listI16input_type_entryE6appendERS0_($27494, $27543);
      var $27545=$4689;
      var $27546=$3129;
      var $27547=$3130;
      var $27548=$3131;
      var $27549=$result_i621;
      var $27550=$3132;
      var $27551=$3133;
      HEAP32[(($3129)>>2)]=408;
      HEAP32[(($3130)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3131)>>2)]=371;
      var $27552=HEAP32[(($3129)>>2)];
      var $27553=HEAP32[(($3130)>>2)];
      var $27554=HEAP32[(($3131)>>2)];
      var $27555=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27552, $27553, $27554) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4977; break; } else { __label__ = 4979; break; };
    case 4977: // $27556
      HEAP32[(($result_i621)>>2)]=$27555;
      var $27557=HEAP32[(($result_i621)>>2)];
      var $27558=(($27557)|0)==0;
      if ($27558) { __label__ = 4978; break; } else { __label__ = 4983; break; }
    case 4978: // $27559
      var $27560=___cxa_allocate_exception(4);
      var $27561=$27560;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27561);
      (function() { try { __THREW__ = false; return ___cxa_throw($27560, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4982; break; } else { __label__ = 4979; break; }
    case 4979: // $27562
      var $27563=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27564=$27563.f0;
      HEAP32[(($3132)>>2)]=$27564;
      var $27565=$27563.f1;
      HEAP32[(($3133)>>2)]=$27565;
      var $27566=HEAP32[(($3133)>>2)];
      var $27567=(($27566)|0) < 0;
      if ($27567) { __label__ = 4980; break; } else { __label__ = 4981; break; }
    case 4980: // $27568
      var $27569=HEAP32[(($3132)>>2)];
      ___cxa_call_unexpected($27569);
      throw "Reached an unreachable!"
    case 4981: // $27570
      var $27571=HEAP32[(($3132)>>2)];
      var $27572=HEAP32[(($3132)>>2)];
      var $27573=HEAP32[(($3133)>>2)];
      var $27574=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27572, tempValue);
      var $27575=($27574.f1 = $27573, $27574);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4982: // $27576
      throw "Reached an unreachable!"
    case 4983: // $_ZnwjPKci_exit622
      var $27577=HEAP32[(($result_i621)>>2)];
      var $27578=$3129;
      var $27579=$3130;
      var $27580=$3131;
      var $27581=$result_i621;
      var $27582=$3132;
      var $27583=$3133;
      var $27584=$27577;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7181, 4, 6, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4984; break; } else { __label__ = 13236; break; }
    case 4984: // $27585
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7182, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4985; break; } else { __label__ = 13236; break; }
    case 4985: // $27586
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7183, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4986; break; } else { __label__ = 13236; break; }
    case 4986: // $27587
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4987; break; } else { __label__ = 13236; break; }
    case 4987: // $27588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4988; break; } else { __label__ = 13236; break; }
    case 4988: // $27589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4989; break; } else { __label__ = 13236; break; }
    case 4989: // $27590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4990; break; } else { __label__ = 13236; break; }
    case 4990: // $27591
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7180, $7181, $7182, $7183, $7184, $7185, $7186, $7187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4991; break; } else { __label__ = 13236; break; }
    case 4991: // $27592
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27584, 74, 7, 6, ((STRING_TABLE.__str813)|0), ((STRING_TABLE.__str814)|0), $7180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4992; break; } else { __label__ = 13236; break; }
    case 4992: // $27593
      var $27594=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27584);
      var $27595=__ZN11simple_listI16input_type_entryE6appendERS0_($27545, $27594);
      var $27596=$4689;
      var $27597=$3124;
      var $27598=$3125;
      var $27599=$3126;
      var $27600=$result_i623;
      var $27601=$3127;
      var $27602=$3128;
      HEAP32[(($3124)>>2)]=408;
      HEAP32[(($3125)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3126)>>2)]=372;
      var $27603=HEAP32[(($3124)>>2)];
      var $27604=HEAP32[(($3125)>>2)];
      var $27605=HEAP32[(($3126)>>2)];
      var $27606=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27603, $27604, $27605) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4993; break; } else { __label__ = 4995; break; };
    case 4993: // $27607
      HEAP32[(($result_i623)>>2)]=$27606;
      var $27608=HEAP32[(($result_i623)>>2)];
      var $27609=(($27608)|0)==0;
      if ($27609) { __label__ = 4994; break; } else { __label__ = 4999; break; }
    case 4994: // $27610
      var $27611=___cxa_allocate_exception(4);
      var $27612=$27611;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27612);
      (function() { try { __THREW__ = false; return ___cxa_throw($27611, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4998; break; } else { __label__ = 4995; break; }
    case 4995: // $27613
      var $27614=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27615=$27614.f0;
      HEAP32[(($3127)>>2)]=$27615;
      var $27616=$27614.f1;
      HEAP32[(($3128)>>2)]=$27616;
      var $27617=HEAP32[(($3128)>>2)];
      var $27618=(($27617)|0) < 0;
      if ($27618) { __label__ = 4996; break; } else { __label__ = 4997; break; }
    case 4996: // $27619
      var $27620=HEAP32[(($3127)>>2)];
      ___cxa_call_unexpected($27620);
      throw "Reached an unreachable!"
    case 4997: // $27621
      var $27622=HEAP32[(($3127)>>2)];
      var $27623=HEAP32[(($3127)>>2)];
      var $27624=HEAP32[(($3128)>>2)];
      var $27625=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27623, tempValue);
      var $27626=($27625.f1 = $27624, $27625);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4998: // $27627
      throw "Reached an unreachable!"
    case 4999: // $_ZnwjPKci_exit624
      var $27628=HEAP32[(($result_i623)>>2)];
      var $27629=$3124;
      var $27630=$3125;
      var $27631=$3126;
      var $27632=$result_i623;
      var $27633=$3127;
      var $27634=$3128;
      var $27635=$27628;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7189, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5000; break; } else { __label__ = 13241; break; }
    case 5000: // $27636
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7190, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5001; break; } else { __label__ = 13241; break; }
    case 5001: // $27637
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7191, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5002; break; } else { __label__ = 13241; break; }
    case 5002: // $27638
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5003; break; } else { __label__ = 13241; break; }
    case 5003: // $27639
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5004; break; } else { __label__ = 13241; break; }
    case 5004: // $27640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5005; break; } else { __label__ = 13241; break; }
    case 5005: // $27641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5006; break; } else { __label__ = 13241; break; }
    case 5006: // $27642
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7188, $7189, $7190, $7191, $7192, $7193, $7194, $7195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5007; break; } else { __label__ = 13241; break; }
    case 5007: // $27643
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27635, 43, 7, 6, ((STRING_TABLE.__str815)|0), ((STRING_TABLE.__str816)|0), $7188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5008; break; } else { __label__ = 13241; break; }
    case 5008: // $27644
      var $27645=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27635);
      var $27646=__ZN11simple_listI16input_type_entryE6appendERS0_($27596, $27645);
      var $27647=$4689;
      var $27648=$3119;
      var $27649=$3120;
      var $27650=$3121;
      var $27651=$result_i625;
      var $27652=$3122;
      var $27653=$3123;
      HEAP32[(($3119)>>2)]=408;
      HEAP32[(($3120)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3121)>>2)]=373;
      var $27654=HEAP32[(($3119)>>2)];
      var $27655=HEAP32[(($3120)>>2)];
      var $27656=HEAP32[(($3121)>>2)];
      var $27657=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27654, $27655, $27656) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5009; break; } else { __label__ = 5011; break; };
    case 5009: // $27658
      HEAP32[(($result_i625)>>2)]=$27657;
      var $27659=HEAP32[(($result_i625)>>2)];
      var $27660=(($27659)|0)==0;
      if ($27660) { __label__ = 5010; break; } else { __label__ = 5015; break; }
    case 5010: // $27661
      var $27662=___cxa_allocate_exception(4);
      var $27663=$27662;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27663);
      (function() { try { __THREW__ = false; return ___cxa_throw($27662, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5014; break; } else { __label__ = 5011; break; }
    case 5011: // $27664
      var $27665=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27666=$27665.f0;
      HEAP32[(($3122)>>2)]=$27666;
      var $27667=$27665.f1;
      HEAP32[(($3123)>>2)]=$27667;
      var $27668=HEAP32[(($3123)>>2)];
      var $27669=(($27668)|0) < 0;
      if ($27669) { __label__ = 5012; break; } else { __label__ = 5013; break; }
    case 5012: // $27670
      var $27671=HEAP32[(($3122)>>2)];
      ___cxa_call_unexpected($27671);
      throw "Reached an unreachable!"
    case 5013: // $27672
      var $27673=HEAP32[(($3122)>>2)];
      var $27674=HEAP32[(($3122)>>2)];
      var $27675=HEAP32[(($3123)>>2)];
      var $27676=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27674, tempValue);
      var $27677=($27676.f1 = $27675, $27676);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5014: // $27678
      throw "Reached an unreachable!"
    case 5015: // $_ZnwjPKci_exit626
      var $27679=HEAP32[(($result_i625)>>2)];
      var $27680=$3119;
      var $27681=$3120;
      var $27682=$3121;
      var $27683=$result_i625;
      var $27684=$3122;
      var $27685=$3123;
      var $27686=$27679;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7197, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5016; break; } else { __label__ = 13246; break; }
    case 5016: // $27687
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5017; break; } else { __label__ = 13246; break; }
    case 5017: // $27688
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5018; break; } else { __label__ = 13246; break; }
    case 5018: // $27689
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5019; break; } else { __label__ = 13246; break; }
    case 5019: // $27690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5020; break; } else { __label__ = 13246; break; }
    case 5020: // $27691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5021; break; } else { __label__ = 13246; break; }
    case 5021: // $27692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5022; break; } else { __label__ = 13246; break; }
    case 5022: // $27693
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7196, $7197, $7198, $7199, $7200, $7201, $7202, $7203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5023; break; } else { __label__ = 13246; break; }
    case 5023: // $27694
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27686, 44, 7, 6, ((STRING_TABLE.__str817)|0), ((STRING_TABLE.__str818)|0), $7196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5024; break; } else { __label__ = 13246; break; }
    case 5024: // $27695
      var $27696=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27686);
      var $27697=__ZN11simple_listI16input_type_entryE6appendERS0_($27647, $27696);
      var $27698=$4689;
      var $27699=$3114;
      var $27700=$3115;
      var $27701=$3116;
      var $27702=$result_i627;
      var $27703=$3117;
      var $27704=$3118;
      HEAP32[(($3114)>>2)]=408;
      HEAP32[(($3115)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3116)>>2)]=375;
      var $27705=HEAP32[(($3114)>>2)];
      var $27706=HEAP32[(($3115)>>2)];
      var $27707=HEAP32[(($3116)>>2)];
      var $27708=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27705, $27706, $27707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5025; break; } else { __label__ = 5027; break; };
    case 5025: // $27709
      HEAP32[(($result_i627)>>2)]=$27708;
      var $27710=HEAP32[(($result_i627)>>2)];
      var $27711=(($27710)|0)==0;
      if ($27711) { __label__ = 5026; break; } else { __label__ = 5031; break; }
    case 5026: // $27712
      var $27713=___cxa_allocate_exception(4);
      var $27714=$27713;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27714);
      (function() { try { __THREW__ = false; return ___cxa_throw($27713, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5030; break; } else { __label__ = 5027; break; }
    case 5027: // $27715
      var $27716=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27717=$27716.f0;
      HEAP32[(($3117)>>2)]=$27717;
      var $27718=$27716.f1;
      HEAP32[(($3118)>>2)]=$27718;
      var $27719=HEAP32[(($3118)>>2)];
      var $27720=(($27719)|0) < 0;
      if ($27720) { __label__ = 5028; break; } else { __label__ = 5029; break; }
    case 5028: // $27721
      var $27722=HEAP32[(($3117)>>2)];
      ___cxa_call_unexpected($27722);
      throw "Reached an unreachable!"
    case 5029: // $27723
      var $27724=HEAP32[(($3117)>>2)];
      var $27725=HEAP32[(($3117)>>2)];
      var $27726=HEAP32[(($3118)>>2)];
      var $27727=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27725, tempValue);
      var $27728=($27727.f1 = $27726, $27727);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5030: // $27729
      throw "Reached an unreachable!"
    case 5031: // $_ZnwjPKci_exit628
      var $27730=HEAP32[(($result_i627)>>2)];
      var $27731=$3114;
      var $27732=$3115;
      var $27733=$3116;
      var $27734=$result_i627;
      var $27735=$3117;
      var $27736=$3118;
      var $27737=$27730;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7205, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5032; break; } else { __label__ = 13251; break; }
    case 5032: // $27738
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7206, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5033; break; } else { __label__ = 13251; break; }
    case 5033: // $27739
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7207, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5034; break; } else { __label__ = 13251; break; }
    case 5034: // $27740
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5035; break; } else { __label__ = 13251; break; }
    case 5035: // $27741
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5036; break; } else { __label__ = 13251; break; }
    case 5036: // $27742
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5037; break; } else { __label__ = 13251; break; }
    case 5037: // $27743
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5038; break; } else { __label__ = 13251; break; }
    case 5038: // $27744
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7204, $7205, $7206, $7207, $7208, $7209, $7210, $7211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5039; break; } else { __label__ = 13251; break; }
    case 5039: // $27745
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27737, 47, 8, 7, ((STRING_TABLE.__str819417)|0), ((STRING_TABLE.__str820)|0), $7204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5040; break; } else { __label__ = 13251; break; }
    case 5040: // $27746
      var $27747=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27737);
      var $27748=__ZN11simple_listI16input_type_entryE6appendERS0_($27698, $27747);
      var $27749=$4689;
      var $27750=$3109;
      var $27751=$3110;
      var $27752=$3111;
      var $27753=$result_i629;
      var $27754=$3112;
      var $27755=$3113;
      HEAP32[(($3109)>>2)]=408;
      HEAP32[(($3110)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3111)>>2)]=376;
      var $27756=HEAP32[(($3109)>>2)];
      var $27757=HEAP32[(($3110)>>2)];
      var $27758=HEAP32[(($3111)>>2)];
      var $27759=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27756, $27757, $27758) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5041; break; } else { __label__ = 5043; break; };
    case 5041: // $27760
      HEAP32[(($result_i629)>>2)]=$27759;
      var $27761=HEAP32[(($result_i629)>>2)];
      var $27762=(($27761)|0)==0;
      if ($27762) { __label__ = 5042; break; } else { __label__ = 5047; break; }
    case 5042: // $27763
      var $27764=___cxa_allocate_exception(4);
      var $27765=$27764;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27765);
      (function() { try { __THREW__ = false; return ___cxa_throw($27764, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5046; break; } else { __label__ = 5043; break; }
    case 5043: // $27766
      var $27767=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27768=$27767.f0;
      HEAP32[(($3112)>>2)]=$27768;
      var $27769=$27767.f1;
      HEAP32[(($3113)>>2)]=$27769;
      var $27770=HEAP32[(($3113)>>2)];
      var $27771=(($27770)|0) < 0;
      if ($27771) { __label__ = 5044; break; } else { __label__ = 5045; break; }
    case 5044: // $27772
      var $27773=HEAP32[(($3112)>>2)];
      ___cxa_call_unexpected($27773);
      throw "Reached an unreachable!"
    case 5045: // $27774
      var $27775=HEAP32[(($3112)>>2)];
      var $27776=HEAP32[(($3112)>>2)];
      var $27777=HEAP32[(($3113)>>2)];
      var $27778=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27776, tempValue);
      var $27779=($27778.f1 = $27777, $27778);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5046: // $27780
      throw "Reached an unreachable!"
    case 5047: // $_ZnwjPKci_exit630
      var $27781=HEAP32[(($result_i629)>>2)];
      var $27782=$3109;
      var $27783=$3110;
      var $27784=$3111;
      var $27785=$result_i629;
      var $27786=$3112;
      var $27787=$3113;
      var $27788=$27781;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7213, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5048; break; } else { __label__ = 13256; break; }
    case 5048: // $27789
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5049; break; } else { __label__ = 13256; break; }
    case 5049: // $27790
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5050; break; } else { __label__ = 13256; break; }
    case 5050: // $27791
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5051; break; } else { __label__ = 13256; break; }
    case 5051: // $27792
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5052; break; } else { __label__ = 13256; break; }
    case 5052: // $27793
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5053; break; } else { __label__ = 13256; break; }
    case 5053: // $27794
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5054; break; } else { __label__ = 13256; break; }
    case 5054: // $27795
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7212, $7213, $7214, $7215, $7216, $7217, $7218, $7219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5055; break; } else { __label__ = 13256; break; }
    case 5055: // $27796
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27788, 48, 8, 7, ((STRING_TABLE.__str821)|0), ((STRING_TABLE.__str822)|0), $7212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5056; break; } else { __label__ = 13256; break; }
    case 5056: // $27797
      var $27798=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27788);
      var $27799=__ZN11simple_listI16input_type_entryE6appendERS0_($27749, $27798);
      var $27800=$4689;
      var $27801=$3104;
      var $27802=$3105;
      var $27803=$3106;
      var $27804=$result_i631;
      var $27805=$3107;
      var $27806=$3108;
      HEAP32[(($3104)>>2)]=408;
      HEAP32[(($3105)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3106)>>2)]=377;
      var $27807=HEAP32[(($3104)>>2)];
      var $27808=HEAP32[(($3105)>>2)];
      var $27809=HEAP32[(($3106)>>2)];
      var $27810=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27807, $27808, $27809) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5057; break; } else { __label__ = 5059; break; };
    case 5057: // $27811
      HEAP32[(($result_i631)>>2)]=$27810;
      var $27812=HEAP32[(($result_i631)>>2)];
      var $27813=(($27812)|0)==0;
      if ($27813) { __label__ = 5058; break; } else { __label__ = 5063; break; }
    case 5058: // $27814
      var $27815=___cxa_allocate_exception(4);
      var $27816=$27815;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27816);
      (function() { try { __THREW__ = false; return ___cxa_throw($27815, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5062; break; } else { __label__ = 5059; break; }
    case 5059: // $27817
      var $27818=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27819=$27818.f0;
      HEAP32[(($3107)>>2)]=$27819;
      var $27820=$27818.f1;
      HEAP32[(($3108)>>2)]=$27820;
      var $27821=HEAP32[(($3108)>>2)];
      var $27822=(($27821)|0) < 0;
      if ($27822) { __label__ = 5060; break; } else { __label__ = 5061; break; }
    case 5060: // $27823
      var $27824=HEAP32[(($3107)>>2)];
      ___cxa_call_unexpected($27824);
      throw "Reached an unreachable!"
    case 5061: // $27825
      var $27826=HEAP32[(($3107)>>2)];
      var $27827=HEAP32[(($3107)>>2)];
      var $27828=HEAP32[(($3108)>>2)];
      var $27829=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27827, tempValue);
      var $27830=($27829.f1 = $27828, $27829);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5062: // $27831
      throw "Reached an unreachable!"
    case 5063: // $_ZnwjPKci_exit632
      var $27832=HEAP32[(($result_i631)>>2)];
      var $27833=$3104;
      var $27834=$3105;
      var $27835=$3106;
      var $27836=$result_i631;
      var $27837=$3107;
      var $27838=$3108;
      var $27839=$27832;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7221, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5064; break; } else { __label__ = 13261; break; }
    case 5064: // $27840
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7222, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5065; break; } else { __label__ = 13261; break; }
    case 5065: // $27841
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5066; break; } else { __label__ = 13261; break; }
    case 5066: // $27842
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5067; break; } else { __label__ = 13261; break; }
    case 5067: // $27843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5068; break; } else { __label__ = 13261; break; }
    case 5068: // $27844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5069; break; } else { __label__ = 13261; break; }
    case 5069: // $27845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5070; break; } else { __label__ = 13261; break; }
    case 5070: // $27846
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7220, $7221, $7222, $7223, $7224, $7225, $7226, $7227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5071; break; } else { __label__ = 13261; break; }
    case 5071: // $27847
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27839, 49, 8, 7, ((STRING_TABLE.__str823)|0), ((STRING_TABLE.__str824)|0), $7220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5072; break; } else { __label__ = 13261; break; }
    case 5072: // $27848
      var $27849=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27839);
      var $27850=__ZN11simple_listI16input_type_entryE6appendERS0_($27800, $27849);
      var $27851=$4689;
      var $27852=$3099;
      var $27853=$3100;
      var $27854=$3101;
      var $27855=$result_i633;
      var $27856=$3102;
      var $27857=$3103;
      HEAP32[(($3099)>>2)]=408;
      HEAP32[(($3100)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3101)>>2)]=378;
      var $27858=HEAP32[(($3099)>>2)];
      var $27859=HEAP32[(($3100)>>2)];
      var $27860=HEAP32[(($3101)>>2)];
      var $27861=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27858, $27859, $27860) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5073; break; } else { __label__ = 5075; break; };
    case 5073: // $27862
      HEAP32[(($result_i633)>>2)]=$27861;
      var $27863=HEAP32[(($result_i633)>>2)];
      var $27864=(($27863)|0)==0;
      if ($27864) { __label__ = 5074; break; } else { __label__ = 5079; break; }
    case 5074: // $27865
      var $27866=___cxa_allocate_exception(4);
      var $27867=$27866;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27867);
      (function() { try { __THREW__ = false; return ___cxa_throw($27866, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5078; break; } else { __label__ = 5075; break; }
    case 5075: // $27868
      var $27869=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27870=$27869.f0;
      HEAP32[(($3102)>>2)]=$27870;
      var $27871=$27869.f1;
      HEAP32[(($3103)>>2)]=$27871;
      var $27872=HEAP32[(($3103)>>2)];
      var $27873=(($27872)|0) < 0;
      if ($27873) { __label__ = 5076; break; } else { __label__ = 5077; break; }
    case 5076: // $27874
      var $27875=HEAP32[(($3102)>>2)];
      ___cxa_call_unexpected($27875);
      throw "Reached an unreachable!"
    case 5077: // $27876
      var $27877=HEAP32[(($3102)>>2)];
      var $27878=HEAP32[(($3102)>>2)];
      var $27879=HEAP32[(($3103)>>2)];
      var $27880=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27878, tempValue);
      var $27881=($27880.f1 = $27879, $27880);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5078: // $27882
      throw "Reached an unreachable!"
    case 5079: // $_ZnwjPKci_exit634
      var $27883=HEAP32[(($result_i633)>>2)];
      var $27884=$3099;
      var $27885=$3100;
      var $27886=$3101;
      var $27887=$result_i633;
      var $27888=$3102;
      var $27889=$3103;
      var $27890=$27883;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7229, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5080; break; } else { __label__ = 13266; break; }
    case 5080: // $27891
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7230, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5081; break; } else { __label__ = 13266; break; }
    case 5081: // $27892
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7231, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5082; break; } else { __label__ = 13266; break; }
    case 5082: // $27893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5083; break; } else { __label__ = 13266; break; }
    case 5083: // $27894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5084; break; } else { __label__ = 13266; break; }
    case 5084: // $27895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5085; break; } else { __label__ = 13266; break; }
    case 5085: // $27896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5086; break; } else { __label__ = 13266; break; }
    case 5086: // $27897
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7228, $7229, $7230, $7231, $7232, $7233, $7234, $7235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5087; break; } else { __label__ = 13266; break; }
    case 5087: // $27898
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27890, 50, 8, 7, ((STRING_TABLE.__str825)|0), ((STRING_TABLE.__str826)|0), $7228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5088; break; } else { __label__ = 13266; break; }
    case 5088: // $27899
      var $27900=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27890);
      var $27901=__ZN11simple_listI16input_type_entryE6appendERS0_($27851, $27900);
      var $27902=$4689;
      var $27903=$3094;
      var $27904=$3095;
      var $27905=$3096;
      var $27906=$result_i635;
      var $27907=$3097;
      var $27908=$3098;
      HEAP32[(($3094)>>2)]=408;
      HEAP32[(($3095)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3096)>>2)]=379;
      var $27909=HEAP32[(($3094)>>2)];
      var $27910=HEAP32[(($3095)>>2)];
      var $27911=HEAP32[(($3096)>>2)];
      var $27912=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27909, $27910, $27911) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5089; break; } else { __label__ = 5091; break; };
    case 5089: // $27913
      HEAP32[(($result_i635)>>2)]=$27912;
      var $27914=HEAP32[(($result_i635)>>2)];
      var $27915=(($27914)|0)==0;
      if ($27915) { __label__ = 5090; break; } else { __label__ = 5095; break; }
    case 5090: // $27916
      var $27917=___cxa_allocate_exception(4);
      var $27918=$27917;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27918);
      (function() { try { __THREW__ = false; return ___cxa_throw($27917, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5094; break; } else { __label__ = 5091; break; }
    case 5091: // $27919
      var $27920=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27921=$27920.f0;
      HEAP32[(($3097)>>2)]=$27921;
      var $27922=$27920.f1;
      HEAP32[(($3098)>>2)]=$27922;
      var $27923=HEAP32[(($3098)>>2)];
      var $27924=(($27923)|0) < 0;
      if ($27924) { __label__ = 5092; break; } else { __label__ = 5093; break; }
    case 5092: // $27925
      var $27926=HEAP32[(($3097)>>2)];
      ___cxa_call_unexpected($27926);
      throw "Reached an unreachable!"
    case 5093: // $27927
      var $27928=HEAP32[(($3097)>>2)];
      var $27929=HEAP32[(($3097)>>2)];
      var $27930=HEAP32[(($3098)>>2)];
      var $27931=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27929, tempValue);
      var $27932=($27931.f1 = $27930, $27931);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5094: // $27933
      throw "Reached an unreachable!"
    case 5095: // $_ZnwjPKci_exit636
      var $27934=HEAP32[(($result_i635)>>2)];
      var $27935=$3094;
      var $27936=$3095;
      var $27937=$3096;
      var $27938=$result_i635;
      var $27939=$3097;
      var $27940=$3098;
      var $27941=$27934;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7237, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5096; break; } else { __label__ = 13271; break; }
    case 5096: // $27942
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7238, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5097; break; } else { __label__ = 13271; break; }
    case 5097: // $27943
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7239, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5098; break; } else { __label__ = 13271; break; }
    case 5098: // $27944
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5099; break; } else { __label__ = 13271; break; }
    case 5099: // $27945
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5100; break; } else { __label__ = 13271; break; }
    case 5100: // $27946
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5101; break; } else { __label__ = 13271; break; }
    case 5101: // $27947
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5102; break; } else { __label__ = 13271; break; }
    case 5102: // $27948
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7236, $7237, $7238, $7239, $7240, $7241, $7242, $7243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5103; break; } else { __label__ = 13271; break; }
    case 5103: // $27949
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27941, 51, 8, 7, ((STRING_TABLE.__str827)|0), ((STRING_TABLE.__str828)|0), $7236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5104; break; } else { __label__ = 13271; break; }
    case 5104: // $27950
      var $27951=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27941);
      var $27952=__ZN11simple_listI16input_type_entryE6appendERS0_($27902, $27951);
      var $27953=$4689;
      var $27954=$3089;
      var $27955=$3090;
      var $27956=$3091;
      var $27957=$result_i637;
      var $27958=$3092;
      var $27959=$3093;
      HEAP32[(($3089)>>2)]=408;
      HEAP32[(($3090)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3091)>>2)]=380;
      var $27960=HEAP32[(($3089)>>2)];
      var $27961=HEAP32[(($3090)>>2)];
      var $27962=HEAP32[(($3091)>>2)];
      var $27963=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27960, $27961, $27962) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5105; break; } else { __label__ = 5107; break; };
    case 5105: // $27964
      HEAP32[(($result_i637)>>2)]=$27963;
      var $27965=HEAP32[(($result_i637)>>2)];
      var $27966=(($27965)|0)==0;
      if ($27966) { __label__ = 5106; break; } else { __label__ = 5111; break; }
    case 5106: // $27967
      var $27968=___cxa_allocate_exception(4);
      var $27969=$27968;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27969);
      (function() { try { __THREW__ = false; return ___cxa_throw($27968, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5110; break; } else { __label__ = 5107; break; }
    case 5107: // $27970
      var $27971=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27972=$27971.f0;
      HEAP32[(($3092)>>2)]=$27972;
      var $27973=$27971.f1;
      HEAP32[(($3093)>>2)]=$27973;
      var $27974=HEAP32[(($3093)>>2)];
      var $27975=(($27974)|0) < 0;
      if ($27975) { __label__ = 5108; break; } else { __label__ = 5109; break; }
    case 5108: // $27976
      var $27977=HEAP32[(($3092)>>2)];
      ___cxa_call_unexpected($27977);
      throw "Reached an unreachable!"
    case 5109: // $27978
      var $27979=HEAP32[(($3092)>>2)];
      var $27980=HEAP32[(($3092)>>2)];
      var $27981=HEAP32[(($3093)>>2)];
      var $27982=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27980, tempValue);
      var $27983=($27982.f1 = $27981, $27982);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5110: // $27984
      throw "Reached an unreachable!"
    case 5111: // $_ZnwjPKci_exit638
      var $27985=HEAP32[(($result_i637)>>2)];
      var $27986=$3089;
      var $27987=$3090;
      var $27988=$3091;
      var $27989=$result_i637;
      var $27990=$3092;
      var $27991=$3093;
      var $27992=$27985;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7245, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5112; break; } else { __label__ = 13276; break; }
    case 5112: // $27993
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7246, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5113; break; } else { __label__ = 13276; break; }
    case 5113: // $27994
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7247, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5114; break; } else { __label__ = 13276; break; }
    case 5114: // $27995
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5115; break; } else { __label__ = 13276; break; }
    case 5115: // $27996
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5116; break; } else { __label__ = 13276; break; }
    case 5116: // $27997
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5117; break; } else { __label__ = 13276; break; }
    case 5117: // $27998
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5118; break; } else { __label__ = 13276; break; }
    case 5118: // $27999
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7244, $7245, $7246, $7247, $7248, $7249, $7250, $7251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5119; break; } else { __label__ = 13276; break; }
    case 5119: // $28000
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($27992, 52, 8, 7, ((STRING_TABLE.__str829)|0), ((STRING_TABLE.__str830)|0), $7244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5120; break; } else { __label__ = 13276; break; }
    case 5120: // $28001
      var $28002=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $27992);
      var $28003=__ZN11simple_listI16input_type_entryE6appendERS0_($27953, $28002);
      var $28004=$4689;
      var $28005=$3084;
      var $28006=$3085;
      var $28007=$3086;
      var $28008=$result_i639;
      var $28009=$3087;
      var $28010=$3088;
      HEAP32[(($3084)>>2)]=408;
      HEAP32[(($3085)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3086)>>2)]=381;
      var $28011=HEAP32[(($3084)>>2)];
      var $28012=HEAP32[(($3085)>>2)];
      var $28013=HEAP32[(($3086)>>2)];
      var $28014=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28011, $28012, $28013) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5121; break; } else { __label__ = 5123; break; };
    case 5121: // $28015
      HEAP32[(($result_i639)>>2)]=$28014;
      var $28016=HEAP32[(($result_i639)>>2)];
      var $28017=(($28016)|0)==0;
      if ($28017) { __label__ = 5122; break; } else { __label__ = 5127; break; }
    case 5122: // $28018
      var $28019=___cxa_allocate_exception(4);
      var $28020=$28019;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28020);
      (function() { try { __THREW__ = false; return ___cxa_throw($28019, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5126; break; } else { __label__ = 5123; break; }
    case 5123: // $28021
      var $28022=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28023=$28022.f0;
      HEAP32[(($3087)>>2)]=$28023;
      var $28024=$28022.f1;
      HEAP32[(($3088)>>2)]=$28024;
      var $28025=HEAP32[(($3088)>>2)];
      var $28026=(($28025)|0) < 0;
      if ($28026) { __label__ = 5124; break; } else { __label__ = 5125; break; }
    case 5124: // $28027
      var $28028=HEAP32[(($3087)>>2)];
      ___cxa_call_unexpected($28028);
      throw "Reached an unreachable!"
    case 5125: // $28029
      var $28030=HEAP32[(($3087)>>2)];
      var $28031=HEAP32[(($3087)>>2)];
      var $28032=HEAP32[(($3088)>>2)];
      var $28033=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28031, tempValue);
      var $28034=($28033.f1 = $28032, $28033);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5126: // $28035
      throw "Reached an unreachable!"
    case 5127: // $_ZnwjPKci_exit640
      var $28036=HEAP32[(($result_i639)>>2)];
      var $28037=$3084;
      var $28038=$3085;
      var $28039=$3086;
      var $28040=$result_i639;
      var $28041=$3087;
      var $28042=$3088;
      var $28043=$28036;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7253, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5128; break; } else { __label__ = 13281; break; }
    case 5128: // $28044
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7254, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5129; break; } else { __label__ = 13281; break; }
    case 5129: // $28045
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7255, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5130; break; } else { __label__ = 13281; break; }
    case 5130: // $28046
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5131; break; } else { __label__ = 13281; break; }
    case 5131: // $28047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5132; break; } else { __label__ = 13281; break; }
    case 5132: // $28048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5133; break; } else { __label__ = 13281; break; }
    case 5133: // $28049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5134; break; } else { __label__ = 13281; break; }
    case 5134: // $28050
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7252, $7253, $7254, $7255, $7256, $7257, $7258, $7259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5135; break; } else { __label__ = 13281; break; }
    case 5135: // $28051
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28043, 53, 8, 7, ((STRING_TABLE.__str831)|0), ((STRING_TABLE.__str832)|0), $7252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5136; break; } else { __label__ = 13281; break; }
    case 5136: // $28052
      var $28053=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28043);
      var $28054=__ZN11simple_listI16input_type_entryE6appendERS0_($28004, $28053);
      var $28055=$4689;
      var $28056=$3079;
      var $28057=$3080;
      var $28058=$3081;
      var $28059=$result_i641;
      var $28060=$3082;
      var $28061=$3083;
      HEAP32[(($3079)>>2)]=408;
      HEAP32[(($3080)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3081)>>2)]=382;
      var $28062=HEAP32[(($3079)>>2)];
      var $28063=HEAP32[(($3080)>>2)];
      var $28064=HEAP32[(($3081)>>2)];
      var $28065=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28062, $28063, $28064) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5137; break; } else { __label__ = 5139; break; };
    case 5137: // $28066
      HEAP32[(($result_i641)>>2)]=$28065;
      var $28067=HEAP32[(($result_i641)>>2)];
      var $28068=(($28067)|0)==0;
      if ($28068) { __label__ = 5138; break; } else { __label__ = 5143; break; }
    case 5138: // $28069
      var $28070=___cxa_allocate_exception(4);
      var $28071=$28070;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28071);
      (function() { try { __THREW__ = false; return ___cxa_throw($28070, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5142; break; } else { __label__ = 5139; break; }
    case 5139: // $28072
      var $28073=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28074=$28073.f0;
      HEAP32[(($3082)>>2)]=$28074;
      var $28075=$28073.f1;
      HEAP32[(($3083)>>2)]=$28075;
      var $28076=HEAP32[(($3083)>>2)];
      var $28077=(($28076)|0) < 0;
      if ($28077) { __label__ = 5140; break; } else { __label__ = 5141; break; }
    case 5140: // $28078
      var $28079=HEAP32[(($3082)>>2)];
      ___cxa_call_unexpected($28079);
      throw "Reached an unreachable!"
    case 5141: // $28080
      var $28081=HEAP32[(($3082)>>2)];
      var $28082=HEAP32[(($3082)>>2)];
      var $28083=HEAP32[(($3083)>>2)];
      var $28084=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28082, tempValue);
      var $28085=($28084.f1 = $28083, $28084);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5142: // $28086
      throw "Reached an unreachable!"
    case 5143: // $_ZnwjPKci_exit642
      var $28087=HEAP32[(($result_i641)>>2)];
      var $28088=$3079;
      var $28089=$3080;
      var $28090=$3081;
      var $28091=$result_i641;
      var $28092=$3082;
      var $28093=$3083;
      var $28094=$28087;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7261, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5144; break; } else { __label__ = 13286; break; }
    case 5144: // $28095
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7262, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5145; break; } else { __label__ = 13286; break; }
    case 5145: // $28096
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7263, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5146; break; } else { __label__ = 13286; break; }
    case 5146: // $28097
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5147; break; } else { __label__ = 13286; break; }
    case 5147: // $28098
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5148; break; } else { __label__ = 13286; break; }
    case 5148: // $28099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5149; break; } else { __label__ = 13286; break; }
    case 5149: // $28100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5150; break; } else { __label__ = 13286; break; }
    case 5150: // $28101
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7260, $7261, $7262, $7263, $7264, $7265, $7266, $7267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5151; break; } else { __label__ = 13286; break; }
    case 5151: // $28102
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28094, 54, 8, 7, ((STRING_TABLE.__str833)|0), ((STRING_TABLE.__str834)|0), $7260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5152; break; } else { __label__ = 13286; break; }
    case 5152: // $28103
      var $28104=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28094);
      var $28105=__ZN11simple_listI16input_type_entryE6appendERS0_($28055, $28104);
      var $28106=$4689;
      var $28107=$3074;
      var $28108=$3075;
      var $28109=$3076;
      var $28110=$result_i643;
      var $28111=$3077;
      var $28112=$3078;
      HEAP32[(($3074)>>2)]=408;
      HEAP32[(($3075)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3076)>>2)]=383;
      var $28113=HEAP32[(($3074)>>2)];
      var $28114=HEAP32[(($3075)>>2)];
      var $28115=HEAP32[(($3076)>>2)];
      var $28116=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28113, $28114, $28115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5153; break; } else { __label__ = 5155; break; };
    case 5153: // $28117
      HEAP32[(($result_i643)>>2)]=$28116;
      var $28118=HEAP32[(($result_i643)>>2)];
      var $28119=(($28118)|0)==0;
      if ($28119) { __label__ = 5154; break; } else { __label__ = 5159; break; }
    case 5154: // $28120
      var $28121=___cxa_allocate_exception(4);
      var $28122=$28121;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28122);
      (function() { try { __THREW__ = false; return ___cxa_throw($28121, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5158; break; } else { __label__ = 5155; break; }
    case 5155: // $28123
      var $28124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28125=$28124.f0;
      HEAP32[(($3077)>>2)]=$28125;
      var $28126=$28124.f1;
      HEAP32[(($3078)>>2)]=$28126;
      var $28127=HEAP32[(($3078)>>2)];
      var $28128=(($28127)|0) < 0;
      if ($28128) { __label__ = 5156; break; } else { __label__ = 5157; break; }
    case 5156: // $28129
      var $28130=HEAP32[(($3077)>>2)];
      ___cxa_call_unexpected($28130);
      throw "Reached an unreachable!"
    case 5157: // $28131
      var $28132=HEAP32[(($3077)>>2)];
      var $28133=HEAP32[(($3077)>>2)];
      var $28134=HEAP32[(($3078)>>2)];
      var $28135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28133, tempValue);
      var $28136=($28135.f1 = $28134, $28135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5158: // $28137
      throw "Reached an unreachable!"
    case 5159: // $_ZnwjPKci_exit644
      var $28138=HEAP32[(($result_i643)>>2)];
      var $28139=$3074;
      var $28140=$3075;
      var $28141=$3076;
      var $28142=$result_i643;
      var $28143=$3077;
      var $28144=$3078;
      var $28145=$28138;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7269, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5160; break; } else { __label__ = 13291; break; }
    case 5160: // $28146
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7270, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5161; break; } else { __label__ = 13291; break; }
    case 5161: // $28147
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7271, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5162; break; } else { __label__ = 13291; break; }
    case 5162: // $28148
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5163; break; } else { __label__ = 13291; break; }
    case 5163: // $28149
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5164; break; } else { __label__ = 13291; break; }
    case 5164: // $28150
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5165; break; } else { __label__ = 13291; break; }
    case 5165: // $28151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5166; break; } else { __label__ = 13291; break; }
    case 5166: // $28152
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7268, $7269, $7270, $7271, $7272, $7273, $7274, $7275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5167; break; } else { __label__ = 13291; break; }
    case 5167: // $28153
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28145, 55, 8, 7, ((STRING_TABLE.__str835)|0), ((STRING_TABLE.__str836)|0), $7268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5168; break; } else { __label__ = 13291; break; }
    case 5168: // $28154
      var $28155=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28145);
      var $28156=__ZN11simple_listI16input_type_entryE6appendERS0_($28106, $28155);
      var $28157=$4689;
      var $28158=$3069;
      var $28159=$3070;
      var $28160=$3071;
      var $28161=$result_i645;
      var $28162=$3072;
      var $28163=$3073;
      HEAP32[(($3069)>>2)]=408;
      HEAP32[(($3070)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3071)>>2)]=384;
      var $28164=HEAP32[(($3069)>>2)];
      var $28165=HEAP32[(($3070)>>2)];
      var $28166=HEAP32[(($3071)>>2)];
      var $28167=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28164, $28165, $28166) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5169; break; } else { __label__ = 5171; break; };
    case 5169: // $28168
      HEAP32[(($result_i645)>>2)]=$28167;
      var $28169=HEAP32[(($result_i645)>>2)];
      var $28170=(($28169)|0)==0;
      if ($28170) { __label__ = 5170; break; } else { __label__ = 5175; break; }
    case 5170: // $28171
      var $28172=___cxa_allocate_exception(4);
      var $28173=$28172;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28173);
      (function() { try { __THREW__ = false; return ___cxa_throw($28172, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5174; break; } else { __label__ = 5171; break; }
    case 5171: // $28174
      var $28175=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28176=$28175.f0;
      HEAP32[(($3072)>>2)]=$28176;
      var $28177=$28175.f1;
      HEAP32[(($3073)>>2)]=$28177;
      var $28178=HEAP32[(($3073)>>2)];
      var $28179=(($28178)|0) < 0;
      if ($28179) { __label__ = 5172; break; } else { __label__ = 5173; break; }
    case 5172: // $28180
      var $28181=HEAP32[(($3072)>>2)];
      ___cxa_call_unexpected($28181);
      throw "Reached an unreachable!"
    case 5173: // $28182
      var $28183=HEAP32[(($3072)>>2)];
      var $28184=HEAP32[(($3072)>>2)];
      var $28185=HEAP32[(($3073)>>2)];
      var $28186=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28184, tempValue);
      var $28187=($28186.f1 = $28185, $28186);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5174: // $28188
      throw "Reached an unreachable!"
    case 5175: // $_ZnwjPKci_exit646
      var $28189=HEAP32[(($result_i645)>>2)];
      var $28190=$3069;
      var $28191=$3070;
      var $28192=$3071;
      var $28193=$result_i645;
      var $28194=$3072;
      var $28195=$3073;
      var $28196=$28189;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7277, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5176; break; } else { __label__ = 13296; break; }
    case 5176: // $28197
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7278, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5177; break; } else { __label__ = 13296; break; }
    case 5177: // $28198
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7279, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5178; break; } else { __label__ = 13296; break; }
    case 5178: // $28199
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7280, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5179; break; } else { __label__ = 13296; break; }
    case 5179: // $28200
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7281, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5180; break; } else { __label__ = 13296; break; }
    case 5180: // $28201
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5181; break; } else { __label__ = 13296; break; }
    case 5181: // $28202
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5182; break; } else { __label__ = 13296; break; }
    case 5182: // $28203
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7276, $7277, $7278, $7279, $7280, $7281, $7282, $7283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5183; break; } else { __label__ = 13296; break; }
    case 5183: // $28204
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28196, 56, 8, 7, ((STRING_TABLE.__str837)|0), ((STRING_TABLE.__str838)|0), $7276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5184; break; } else { __label__ = 13296; break; }
    case 5184: // $28205
      var $28206=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28196);
      var $28207=__ZN11simple_listI16input_type_entryE6appendERS0_($28157, $28206);
      var $28208=$4689;
      var $28209=$3064;
      var $28210=$3065;
      var $28211=$3066;
      var $28212=$result_i647;
      var $28213=$3067;
      var $28214=$3068;
      HEAP32[(($3064)>>2)]=408;
      HEAP32[(($3065)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3066)>>2)]=385;
      var $28215=HEAP32[(($3064)>>2)];
      var $28216=HEAP32[(($3065)>>2)];
      var $28217=HEAP32[(($3066)>>2)];
      var $28218=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28215, $28216, $28217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5185; break; } else { __label__ = 5187; break; };
    case 5185: // $28219
      HEAP32[(($result_i647)>>2)]=$28218;
      var $28220=HEAP32[(($result_i647)>>2)];
      var $28221=(($28220)|0)==0;
      if ($28221) { __label__ = 5186; break; } else { __label__ = 5191; break; }
    case 5186: // $28222
      var $28223=___cxa_allocate_exception(4);
      var $28224=$28223;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28224);
      (function() { try { __THREW__ = false; return ___cxa_throw($28223, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5190; break; } else { __label__ = 5187; break; }
    case 5187: // $28225
      var $28226=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28227=$28226.f0;
      HEAP32[(($3067)>>2)]=$28227;
      var $28228=$28226.f1;
      HEAP32[(($3068)>>2)]=$28228;
      var $28229=HEAP32[(($3068)>>2)];
      var $28230=(($28229)|0) < 0;
      if ($28230) { __label__ = 5188; break; } else { __label__ = 5189; break; }
    case 5188: // $28231
      var $28232=HEAP32[(($3067)>>2)];
      ___cxa_call_unexpected($28232);
      throw "Reached an unreachable!"
    case 5189: // $28233
      var $28234=HEAP32[(($3067)>>2)];
      var $28235=HEAP32[(($3067)>>2)];
      var $28236=HEAP32[(($3068)>>2)];
      var $28237=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28235, tempValue);
      var $28238=($28237.f1 = $28236, $28237);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5190: // $28239
      throw "Reached an unreachable!"
    case 5191: // $_ZnwjPKci_exit648
      var $28240=HEAP32[(($result_i647)>>2)];
      var $28241=$3064;
      var $28242=$3065;
      var $28243=$3066;
      var $28244=$result_i647;
      var $28245=$3067;
      var $28246=$3068;
      var $28247=$28240;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7285, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5192; break; } else { __label__ = 13301; break; }
    case 5192: // $28248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7286, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5193; break; } else { __label__ = 13301; break; }
    case 5193: // $28249
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7287, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5194; break; } else { __label__ = 13301; break; }
    case 5194: // $28250
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5195; break; } else { __label__ = 13301; break; }
    case 5195: // $28251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5196; break; } else { __label__ = 13301; break; }
    case 5196: // $28252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5197; break; } else { __label__ = 13301; break; }
    case 5197: // $28253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5198; break; } else { __label__ = 13301; break; }
    case 5198: // $28254
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7284, $7285, $7286, $7287, $7288, $7289, $7290, $7291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5199; break; } else { __label__ = 13301; break; }
    case 5199: // $28255
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28247, 57, 8, 7, ((STRING_TABLE.__str839)|0), ((STRING_TABLE.__str840)|0), $7284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5200; break; } else { __label__ = 13301; break; }
    case 5200: // $28256
      var $28257=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28247);
      var $28258=__ZN11simple_listI16input_type_entryE6appendERS0_($28208, $28257);
      var $28259=$4689;
      var $28260=$3059;
      var $28261=$3060;
      var $28262=$3061;
      var $28263=$result_i649;
      var $28264=$3062;
      var $28265=$3063;
      HEAP32[(($3059)>>2)]=408;
      HEAP32[(($3060)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3061)>>2)]=386;
      var $28266=HEAP32[(($3059)>>2)];
      var $28267=HEAP32[(($3060)>>2)];
      var $28268=HEAP32[(($3061)>>2)];
      var $28269=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28266, $28267, $28268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5201; break; } else { __label__ = 5203; break; };
    case 5201: // $28270
      HEAP32[(($result_i649)>>2)]=$28269;
      var $28271=HEAP32[(($result_i649)>>2)];
      var $28272=(($28271)|0)==0;
      if ($28272) { __label__ = 5202; break; } else { __label__ = 5207; break; }
    case 5202: // $28273
      var $28274=___cxa_allocate_exception(4);
      var $28275=$28274;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28275);
      (function() { try { __THREW__ = false; return ___cxa_throw($28274, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5206; break; } else { __label__ = 5203; break; }
    case 5203: // $28276
      var $28277=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28278=$28277.f0;
      HEAP32[(($3062)>>2)]=$28278;
      var $28279=$28277.f1;
      HEAP32[(($3063)>>2)]=$28279;
      var $28280=HEAP32[(($3063)>>2)];
      var $28281=(($28280)|0) < 0;
      if ($28281) { __label__ = 5204; break; } else { __label__ = 5205; break; }
    case 5204: // $28282
      var $28283=HEAP32[(($3062)>>2)];
      ___cxa_call_unexpected($28283);
      throw "Reached an unreachable!"
    case 5205: // $28284
      var $28285=HEAP32[(($3062)>>2)];
      var $28286=HEAP32[(($3062)>>2)];
      var $28287=HEAP32[(($3063)>>2)];
      var $28288=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28286, tempValue);
      var $28289=($28288.f1 = $28287, $28288);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5206: // $28290
      throw "Reached an unreachable!"
    case 5207: // $_ZnwjPKci_exit650
      var $28291=HEAP32[(($result_i649)>>2)];
      var $28292=$3059;
      var $28293=$3060;
      var $28294=$3061;
      var $28295=$result_i649;
      var $28296=$3062;
      var $28297=$3063;
      var $28298=$28291;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7293, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5208; break; } else { __label__ = 13306; break; }
    case 5208: // $28299
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7294, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5209; break; } else { __label__ = 13306; break; }
    case 5209: // $28300
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7295, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5210; break; } else { __label__ = 13306; break; }
    case 5210: // $28301
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5211; break; } else { __label__ = 13306; break; }
    case 5211: // $28302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5212; break; } else { __label__ = 13306; break; }
    case 5212: // $28303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5213; break; } else { __label__ = 13306; break; }
    case 5213: // $28304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5214; break; } else { __label__ = 13306; break; }
    case 5214: // $28305
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7292, $7293, $7294, $7295, $7296, $7297, $7298, $7299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5215; break; } else { __label__ = 13306; break; }
    case 5215: // $28306
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28298, 58, 8, 7, ((STRING_TABLE.__str841)|0), ((STRING_TABLE.__str842)|0), $7292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5216; break; } else { __label__ = 13306; break; }
    case 5216: // $28307
      var $28308=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28298);
      var $28309=__ZN11simple_listI16input_type_entryE6appendERS0_($28259, $28308);
      var $28310=$4689;
      var $28311=$3054;
      var $28312=$3055;
      var $28313=$3056;
      var $28314=$result_i651;
      var $28315=$3057;
      var $28316=$3058;
      HEAP32[(($3054)>>2)]=408;
      HEAP32[(($3055)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3056)>>2)]=387;
      var $28317=HEAP32[(($3054)>>2)];
      var $28318=HEAP32[(($3055)>>2)];
      var $28319=HEAP32[(($3056)>>2)];
      var $28320=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28317, $28318, $28319) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5217; break; } else { __label__ = 5219; break; };
    case 5217: // $28321
      HEAP32[(($result_i651)>>2)]=$28320;
      var $28322=HEAP32[(($result_i651)>>2)];
      var $28323=(($28322)|0)==0;
      if ($28323) { __label__ = 5218; break; } else { __label__ = 5223; break; }
    case 5218: // $28324
      var $28325=___cxa_allocate_exception(4);
      var $28326=$28325;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28326);
      (function() { try { __THREW__ = false; return ___cxa_throw($28325, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5222; break; } else { __label__ = 5219; break; }
    case 5219: // $28327
      var $28328=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28329=$28328.f0;
      HEAP32[(($3057)>>2)]=$28329;
      var $28330=$28328.f1;
      HEAP32[(($3058)>>2)]=$28330;
      var $28331=HEAP32[(($3058)>>2)];
      var $28332=(($28331)|0) < 0;
      if ($28332) { __label__ = 5220; break; } else { __label__ = 5221; break; }
    case 5220: // $28333
      var $28334=HEAP32[(($3057)>>2)];
      ___cxa_call_unexpected($28334);
      throw "Reached an unreachable!"
    case 5221: // $28335
      var $28336=HEAP32[(($3057)>>2)];
      var $28337=HEAP32[(($3057)>>2)];
      var $28338=HEAP32[(($3058)>>2)];
      var $28339=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28337, tempValue);
      var $28340=($28339.f1 = $28338, $28339);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5222: // $28341
      throw "Reached an unreachable!"
    case 5223: // $_ZnwjPKci_exit652
      var $28342=HEAP32[(($result_i651)>>2)];
      var $28343=$3054;
      var $28344=$3055;
      var $28345=$3056;
      var $28346=$result_i651;
      var $28347=$3057;
      var $28348=$3058;
      var $28349=$28342;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7301, 4, 7, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5224; break; } else { __label__ = 13311; break; }
    case 5224: // $28350
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7302, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5225; break; } else { __label__ = 13311; break; }
    case 5225: // $28351
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7303, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5226; break; } else { __label__ = 13311; break; }
    case 5226: // $28352
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5227; break; } else { __label__ = 13311; break; }
    case 5227: // $28353
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5228; break; } else { __label__ = 13311; break; }
    case 5228: // $28354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5229; break; } else { __label__ = 13311; break; }
    case 5229: // $28355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5230; break; } else { __label__ = 13311; break; }
    case 5230: // $28356
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7300, $7301, $7302, $7303, $7304, $7305, $7306, $7307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5231; break; } else { __label__ = 13311; break; }
    case 5231: // $28357
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28349, 59, 8, 7, ((STRING_TABLE.__str843)|0), ((STRING_TABLE.__str844)|0), $7300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5232; break; } else { __label__ = 13311; break; }
    case 5232: // $28358
      var $28359=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28349);
      var $28360=__ZN11simple_listI16input_type_entryE6appendERS0_($28310, $28359);
      var $28361=$4689;
      var $28362=$3049;
      var $28363=$3050;
      var $28364=$3051;
      var $28365=$result_i653;
      var $28366=$3052;
      var $28367=$3053;
      HEAP32[(($3049)>>2)]=408;
      HEAP32[(($3050)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3051)>>2)]=388;
      var $28368=HEAP32[(($3049)>>2)];
      var $28369=HEAP32[(($3050)>>2)];
      var $28370=HEAP32[(($3051)>>2)];
      var $28371=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28368, $28369, $28370) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5233; break; } else { __label__ = 5235; break; };
    case 5233: // $28372
      HEAP32[(($result_i653)>>2)]=$28371;
      var $28373=HEAP32[(($result_i653)>>2)];
      var $28374=(($28373)|0)==0;
      if ($28374) { __label__ = 5234; break; } else { __label__ = 5239; break; }
    case 5234: // $28375
      var $28376=___cxa_allocate_exception(4);
      var $28377=$28376;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28377);
      (function() { try { __THREW__ = false; return ___cxa_throw($28376, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5238; break; } else { __label__ = 5235; break; }
    case 5235: // $28378
      var $28379=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28380=$28379.f0;
      HEAP32[(($3052)>>2)]=$28380;
      var $28381=$28379.f1;
      HEAP32[(($3053)>>2)]=$28381;
      var $28382=HEAP32[(($3053)>>2)];
      var $28383=(($28382)|0) < 0;
      if ($28383) { __label__ = 5236; break; } else { __label__ = 5237; break; }
    case 5236: // $28384
      var $28385=HEAP32[(($3052)>>2)];
      ___cxa_call_unexpected($28385);
      throw "Reached an unreachable!"
    case 5237: // $28386
      var $28387=HEAP32[(($3052)>>2)];
      var $28388=HEAP32[(($3052)>>2)];
      var $28389=HEAP32[(($3053)>>2)];
      var $28390=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28388, tempValue);
      var $28391=($28390.f1 = $28389, $28390);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5238: // $28392
      throw "Reached an unreachable!"
    case 5239: // $_ZnwjPKci_exit654
      var $28393=HEAP32[(($result_i653)>>2)];
      var $28394=$3049;
      var $28395=$3050;
      var $28396=$3051;
      var $28397=$result_i653;
      var $28398=$3052;
      var $28399=$3053;
      var $28400=$28393;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7309, 4, 7, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5240; break; } else { __label__ = 13316; break; }
    case 5240: // $28401
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7310, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5241; break; } else { __label__ = 13316; break; }
    case 5241: // $28402
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7311, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5242; break; } else { __label__ = 13316; break; }
    case 5242: // $28403
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5243; break; } else { __label__ = 13316; break; }
    case 5243: // $28404
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5244; break; } else { __label__ = 13316; break; }
    case 5244: // $28405
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5245; break; } else { __label__ = 13316; break; }
    case 5245: // $28406
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5246; break; } else { __label__ = 13316; break; }
    case 5246: // $28407
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7308, $7309, $7310, $7311, $7312, $7313, $7314, $7315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5247; break; } else { __label__ = 13316; break; }
    case 5247: // $28408
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28400, 60, 8, 7, ((STRING_TABLE.__str845)|0), ((STRING_TABLE.__str846)|0), $7308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5248; break; } else { __label__ = 13316; break; }
    case 5248: // $28409
      var $28410=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28400);
      var $28411=__ZN11simple_listI16input_type_entryE6appendERS0_($28361, $28410);
      var $28412=$4689;
      var $28413=$3044;
      var $28414=$3045;
      var $28415=$3046;
      var $28416=$result_i655;
      var $28417=$3047;
      var $28418=$3048;
      HEAP32[(($3044)>>2)]=408;
      HEAP32[(($3045)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3046)>>2)]=389;
      var $28419=HEAP32[(($3044)>>2)];
      var $28420=HEAP32[(($3045)>>2)];
      var $28421=HEAP32[(($3046)>>2)];
      var $28422=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28419, $28420, $28421) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5249; break; } else { __label__ = 5251; break; };
    case 5249: // $28423
      HEAP32[(($result_i655)>>2)]=$28422;
      var $28424=HEAP32[(($result_i655)>>2)];
      var $28425=(($28424)|0)==0;
      if ($28425) { __label__ = 5250; break; } else { __label__ = 5255; break; }
    case 5250: // $28426
      var $28427=___cxa_allocate_exception(4);
      var $28428=$28427;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28428);
      (function() { try { __THREW__ = false; return ___cxa_throw($28427, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5254; break; } else { __label__ = 5251; break; }
    case 5251: // $28429
      var $28430=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28431=$28430.f0;
      HEAP32[(($3047)>>2)]=$28431;
      var $28432=$28430.f1;
      HEAP32[(($3048)>>2)]=$28432;
      var $28433=HEAP32[(($3048)>>2)];
      var $28434=(($28433)|0) < 0;
      if ($28434) { __label__ = 5252; break; } else { __label__ = 5253; break; }
    case 5252: // $28435
      var $28436=HEAP32[(($3047)>>2)];
      ___cxa_call_unexpected($28436);
      throw "Reached an unreachable!"
    case 5253: // $28437
      var $28438=HEAP32[(($3047)>>2)];
      var $28439=HEAP32[(($3047)>>2)];
      var $28440=HEAP32[(($3048)>>2)];
      var $28441=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28439, tempValue);
      var $28442=($28441.f1 = $28440, $28441);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5254: // $28443
      throw "Reached an unreachable!"
    case 5255: // $_ZnwjPKci_exit656
      var $28444=HEAP32[(($result_i655)>>2)];
      var $28445=$3044;
      var $28446=$3045;
      var $28447=$3046;
      var $28448=$result_i655;
      var $28449=$3047;
      var $28450=$3048;
      var $28451=$28444;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7317, 4, 7, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5256; break; } else { __label__ = 13321; break; }
    case 5256: // $28452
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7318, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5257; break; } else { __label__ = 13321; break; }
    case 5257: // $28453
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7319, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5258; break; } else { __label__ = 13321; break; }
    case 5258: // $28454
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5259; break; } else { __label__ = 13321; break; }
    case 5259: // $28455
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5260; break; } else { __label__ = 13321; break; }
    case 5260: // $28456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5261; break; } else { __label__ = 13321; break; }
    case 5261: // $28457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5262; break; } else { __label__ = 13321; break; }
    case 5262: // $28458
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7316, $7317, $7318, $7319, $7320, $7321, $7322, $7323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5263; break; } else { __label__ = 13321; break; }
    case 5263: // $28459
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28451, 61, 8, 7, ((STRING_TABLE.__str847)|0), ((STRING_TABLE.__str848)|0), $7316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5264; break; } else { __label__ = 13321; break; }
    case 5264: // $28460
      var $28461=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28451);
      var $28462=__ZN11simple_listI16input_type_entryE6appendERS0_($28412, $28461);
      var $28463=$4689;
      var $28464=$3039;
      var $28465=$3040;
      var $28466=$3041;
      var $28467=$result_i657;
      var $28468=$3042;
      var $28469=$3043;
      HEAP32[(($3039)>>2)]=408;
      HEAP32[(($3040)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3041)>>2)]=390;
      var $28470=HEAP32[(($3039)>>2)];
      var $28471=HEAP32[(($3040)>>2)];
      var $28472=HEAP32[(($3041)>>2)];
      var $28473=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28470, $28471, $28472) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5265; break; } else { __label__ = 5267; break; };
    case 5265: // $28474
      HEAP32[(($result_i657)>>2)]=$28473;
      var $28475=HEAP32[(($result_i657)>>2)];
      var $28476=(($28475)|0)==0;
      if ($28476) { __label__ = 5266; break; } else { __label__ = 5271; break; }
    case 5266: // $28477
      var $28478=___cxa_allocate_exception(4);
      var $28479=$28478;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28479);
      (function() { try { __THREW__ = false; return ___cxa_throw($28478, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5270; break; } else { __label__ = 5267; break; }
    case 5267: // $28480
      var $28481=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28482=$28481.f0;
      HEAP32[(($3042)>>2)]=$28482;
      var $28483=$28481.f1;
      HEAP32[(($3043)>>2)]=$28483;
      var $28484=HEAP32[(($3043)>>2)];
      var $28485=(($28484)|0) < 0;
      if ($28485) { __label__ = 5268; break; } else { __label__ = 5269; break; }
    case 5268: // $28486
      var $28487=HEAP32[(($3042)>>2)];
      ___cxa_call_unexpected($28487);
      throw "Reached an unreachable!"
    case 5269: // $28488
      var $28489=HEAP32[(($3042)>>2)];
      var $28490=HEAP32[(($3042)>>2)];
      var $28491=HEAP32[(($3043)>>2)];
      var $28492=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28490, tempValue);
      var $28493=($28492.f1 = $28491, $28492);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5270: // $28494
      throw "Reached an unreachable!"
    case 5271: // $_ZnwjPKci_exit658
      var $28495=HEAP32[(($result_i657)>>2)];
      var $28496=$3039;
      var $28497=$3040;
      var $28498=$3041;
      var $28499=$result_i657;
      var $28500=$3042;
      var $28501=$3043;
      var $28502=$28495;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7325, 4, 7, 1, 0, 121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5272; break; } else { __label__ = 13326; break; }
    case 5272: // $28503
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7326, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5273; break; } else { __label__ = 13326; break; }
    case 5273: // $28504
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7327, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5274; break; } else { __label__ = 13326; break; }
    case 5274: // $28505
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5275; break; } else { __label__ = 13326; break; }
    case 5275: // $28506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5276; break; } else { __label__ = 13326; break; }
    case 5276: // $28507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5277; break; } else { __label__ = 13326; break; }
    case 5277: // $28508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5278; break; } else { __label__ = 13326; break; }
    case 5278: // $28509
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7324, $7325, $7326, $7327, $7328, $7329, $7330, $7331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5279; break; } else { __label__ = 13326; break; }
    case 5279: // $28510
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28502, 62, 8, 7, ((STRING_TABLE.__str849)|0), ((STRING_TABLE.__str850)|0), $7324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5280; break; } else { __label__ = 13326; break; }
    case 5280: // $28511
      var $28512=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28502);
      var $28513=__ZN11simple_listI16input_type_entryE6appendERS0_($28463, $28512);
      var $28514=$4689;
      var $28515=$3034;
      var $28516=$3035;
      var $28517=$3036;
      var $28518=$result_i659;
      var $28519=$3037;
      var $28520=$3038;
      HEAP32[(($3034)>>2)]=408;
      HEAP32[(($3035)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3036)>>2)]=391;
      var $28521=HEAP32[(($3034)>>2)];
      var $28522=HEAP32[(($3035)>>2)];
      var $28523=HEAP32[(($3036)>>2)];
      var $28524=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28521, $28522, $28523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5281; break; } else { __label__ = 5283; break; };
    case 5281: // $28525
      HEAP32[(($result_i659)>>2)]=$28524;
      var $28526=HEAP32[(($result_i659)>>2)];
      var $28527=(($28526)|0)==0;
      if ($28527) { __label__ = 5282; break; } else { __label__ = 5287; break; }
    case 5282: // $28528
      var $28529=___cxa_allocate_exception(4);
      var $28530=$28529;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28530);
      (function() { try { __THREW__ = false; return ___cxa_throw($28529, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5286; break; } else { __label__ = 5283; break; }
    case 5283: // $28531
      var $28532=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28533=$28532.f0;
      HEAP32[(($3037)>>2)]=$28533;
      var $28534=$28532.f1;
      HEAP32[(($3038)>>2)]=$28534;
      var $28535=HEAP32[(($3038)>>2)];
      var $28536=(($28535)|0) < 0;
      if ($28536) { __label__ = 5284; break; } else { __label__ = 5285; break; }
    case 5284: // $28537
      var $28538=HEAP32[(($3037)>>2)];
      ___cxa_call_unexpected($28538);
      throw "Reached an unreachable!"
    case 5285: // $28539
      var $28540=HEAP32[(($3037)>>2)];
      var $28541=HEAP32[(($3037)>>2)];
      var $28542=HEAP32[(($3038)>>2)];
      var $28543=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28541, tempValue);
      var $28544=($28543.f1 = $28542, $28543);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5286: // $28545
      throw "Reached an unreachable!"
    case 5287: // $_ZnwjPKci_exit660
      var $28546=HEAP32[(($result_i659)>>2)];
      var $28547=$3034;
      var $28548=$3035;
      var $28549=$3036;
      var $28550=$result_i659;
      var $28551=$3037;
      var $28552=$3038;
      var $28553=$28546;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7333, 4, 7, 1, 0, 122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5288; break; } else { __label__ = 13331; break; }
    case 5288: // $28554
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7334, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5289; break; } else { __label__ = 13331; break; }
    case 5289: // $28555
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7335, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5290; break; } else { __label__ = 13331; break; }
    case 5290: // $28556
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5291; break; } else { __label__ = 13331; break; }
    case 5291: // $28557
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5292; break; } else { __label__ = 13331; break; }
    case 5292: // $28558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5293; break; } else { __label__ = 13331; break; }
    case 5293: // $28559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5294; break; } else { __label__ = 13331; break; }
    case 5294: // $28560
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7332, $7333, $7334, $7335, $7336, $7337, $7338, $7339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5295; break; } else { __label__ = 13331; break; }
    case 5295: // $28561
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28553, 63, 8, 7, ((STRING_TABLE.__str851)|0), ((STRING_TABLE.__str852)|0), $7332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5296; break; } else { __label__ = 13331; break; }
    case 5296: // $28562
      var $28563=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28553);
      var $28564=__ZN11simple_listI16input_type_entryE6appendERS0_($28514, $28563);
      var $28565=$4689;
      var $28566=$3029;
      var $28567=$3030;
      var $28568=$3031;
      var $28569=$result_i661;
      var $28570=$3032;
      var $28571=$3033;
      HEAP32[(($3029)>>2)]=408;
      HEAP32[(($3030)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3031)>>2)]=392;
      var $28572=HEAP32[(($3029)>>2)];
      var $28573=HEAP32[(($3030)>>2)];
      var $28574=HEAP32[(($3031)>>2)];
      var $28575=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28572, $28573, $28574) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5297; break; } else { __label__ = 5299; break; };
    case 5297: // $28576
      HEAP32[(($result_i661)>>2)]=$28575;
      var $28577=HEAP32[(($result_i661)>>2)];
      var $28578=(($28577)|0)==0;
      if ($28578) { __label__ = 5298; break; } else { __label__ = 5303; break; }
    case 5298: // $28579
      var $28580=___cxa_allocate_exception(4);
      var $28581=$28580;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28581);
      (function() { try { __THREW__ = false; return ___cxa_throw($28580, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5302; break; } else { __label__ = 5299; break; }
    case 5299: // $28582
      var $28583=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28584=$28583.f0;
      HEAP32[(($3032)>>2)]=$28584;
      var $28585=$28583.f1;
      HEAP32[(($3033)>>2)]=$28585;
      var $28586=HEAP32[(($3033)>>2)];
      var $28587=(($28586)|0) < 0;
      if ($28587) { __label__ = 5300; break; } else { __label__ = 5301; break; }
    case 5300: // $28588
      var $28589=HEAP32[(($3032)>>2)];
      ___cxa_call_unexpected($28589);
      throw "Reached an unreachable!"
    case 5301: // $28590
      var $28591=HEAP32[(($3032)>>2)];
      var $28592=HEAP32[(($3032)>>2)];
      var $28593=HEAP32[(($3033)>>2)];
      var $28594=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28592, tempValue);
      var $28595=($28594.f1 = $28593, $28594);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5302: // $28596
      throw "Reached an unreachable!"
    case 5303: // $_ZnwjPKci_exit662
      var $28597=HEAP32[(($result_i661)>>2)];
      var $28598=$3029;
      var $28599=$3030;
      var $28600=$3031;
      var $28601=$result_i661;
      var $28602=$3032;
      var $28603=$3033;
      var $28604=$28597;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7341, 4, 7, 1, 0, 123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5304; break; } else { __label__ = 13336; break; }
    case 5304: // $28605
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7342, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5305; break; } else { __label__ = 13336; break; }
    case 5305: // $28606
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7343, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5306; break; } else { __label__ = 13336; break; }
    case 5306: // $28607
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5307; break; } else { __label__ = 13336; break; }
    case 5307: // $28608
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5308; break; } else { __label__ = 13336; break; }
    case 5308: // $28609
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5309; break; } else { __label__ = 13336; break; }
    case 5309: // $28610
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5310; break; } else { __label__ = 13336; break; }
    case 5310: // $28611
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7340, $7341, $7342, $7343, $7344, $7345, $7346, $7347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5311; break; } else { __label__ = 13336; break; }
    case 5311: // $28612
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28604, 64, 8, 7, ((STRING_TABLE.__str853)|0), ((STRING_TABLE.__str854)|0), $7340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5312; break; } else { __label__ = 13336; break; }
    case 5312: // $28613
      var $28614=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28604);
      var $28615=__ZN11simple_listI16input_type_entryE6appendERS0_($28565, $28614);
      var $28616=$4689;
      var $28617=$3024;
      var $28618=$3025;
      var $28619=$3026;
      var $28620=$result_i663;
      var $28621=$3027;
      var $28622=$3028;
      HEAP32[(($3024)>>2)]=408;
      HEAP32[(($3025)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3026)>>2)]=393;
      var $28623=HEAP32[(($3024)>>2)];
      var $28624=HEAP32[(($3025)>>2)];
      var $28625=HEAP32[(($3026)>>2)];
      var $28626=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28623, $28624, $28625) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5313; break; } else { __label__ = 5315; break; };
    case 5313: // $28627
      HEAP32[(($result_i663)>>2)]=$28626;
      var $28628=HEAP32[(($result_i663)>>2)];
      var $28629=(($28628)|0)==0;
      if ($28629) { __label__ = 5314; break; } else { __label__ = 5319; break; }
    case 5314: // $28630
      var $28631=___cxa_allocate_exception(4);
      var $28632=$28631;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28632);
      (function() { try { __THREW__ = false; return ___cxa_throw($28631, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5318; break; } else { __label__ = 5315; break; }
    case 5315: // $28633
      var $28634=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28635=$28634.f0;
      HEAP32[(($3027)>>2)]=$28635;
      var $28636=$28634.f1;
      HEAP32[(($3028)>>2)]=$28636;
      var $28637=HEAP32[(($3028)>>2)];
      var $28638=(($28637)|0) < 0;
      if ($28638) { __label__ = 5316; break; } else { __label__ = 5317; break; }
    case 5316: // $28639
      var $28640=HEAP32[(($3027)>>2)];
      ___cxa_call_unexpected($28640);
      throw "Reached an unreachable!"
    case 5317: // $28641
      var $28642=HEAP32[(($3027)>>2)];
      var $28643=HEAP32[(($3027)>>2)];
      var $28644=HEAP32[(($3028)>>2)];
      var $28645=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28643, tempValue);
      var $28646=($28645.f1 = $28644, $28645);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5318: // $28647
      throw "Reached an unreachable!"
    case 5319: // $_ZnwjPKci_exit664
      var $28648=HEAP32[(($result_i663)>>2)];
      var $28649=$3024;
      var $28650=$3025;
      var $28651=$3026;
      var $28652=$result_i663;
      var $28653=$3027;
      var $28654=$3028;
      var $28655=$28648;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7349, 4, 7, 1, 0, 124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5320; break; } else { __label__ = 13341; break; }
    case 5320: // $28656
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7350, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5321; break; } else { __label__ = 13341; break; }
    case 5321: // $28657
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7351, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5322; break; } else { __label__ = 13341; break; }
    case 5322: // $28658
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5323; break; } else { __label__ = 13341; break; }
    case 5323: // $28659
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5324; break; } else { __label__ = 13341; break; }
    case 5324: // $28660
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5325; break; } else { __label__ = 13341; break; }
    case 5325: // $28661
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5326; break; } else { __label__ = 13341; break; }
    case 5326: // $28662
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7348, $7349, $7350, $7351, $7352, $7353, $7354, $7355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5327; break; } else { __label__ = 13341; break; }
    case 5327: // $28663
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28655, 65, 8, 7, ((STRING_TABLE.__str855)|0), ((STRING_TABLE.__str856)|0), $7348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5328; break; } else { __label__ = 13341; break; }
    case 5328: // $28664
      var $28665=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28655);
      var $28666=__ZN11simple_listI16input_type_entryE6appendERS0_($28616, $28665);
      var $28667=$4689;
      var $28668=$3019;
      var $28669=$3020;
      var $28670=$3021;
      var $28671=$result_i665;
      var $28672=$3022;
      var $28673=$3023;
      HEAP32[(($3019)>>2)]=408;
      HEAP32[(($3020)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3021)>>2)]=394;
      var $28674=HEAP32[(($3019)>>2)];
      var $28675=HEAP32[(($3020)>>2)];
      var $28676=HEAP32[(($3021)>>2)];
      var $28677=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28674, $28675, $28676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5329; break; } else { __label__ = 5331; break; };
    case 5329: // $28678
      HEAP32[(($result_i665)>>2)]=$28677;
      var $28679=HEAP32[(($result_i665)>>2)];
      var $28680=(($28679)|0)==0;
      if ($28680) { __label__ = 5330; break; } else { __label__ = 5335; break; }
    case 5330: // $28681
      var $28682=___cxa_allocate_exception(4);
      var $28683=$28682;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28683);
      (function() { try { __THREW__ = false; return ___cxa_throw($28682, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5334; break; } else { __label__ = 5331; break; }
    case 5331: // $28684
      var $28685=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28686=$28685.f0;
      HEAP32[(($3022)>>2)]=$28686;
      var $28687=$28685.f1;
      HEAP32[(($3023)>>2)]=$28687;
      var $28688=HEAP32[(($3023)>>2)];
      var $28689=(($28688)|0) < 0;
      if ($28689) { __label__ = 5332; break; } else { __label__ = 5333; break; }
    case 5332: // $28690
      var $28691=HEAP32[(($3022)>>2)];
      ___cxa_call_unexpected($28691);
      throw "Reached an unreachable!"
    case 5333: // $28692
      var $28693=HEAP32[(($3022)>>2)];
      var $28694=HEAP32[(($3022)>>2)];
      var $28695=HEAP32[(($3023)>>2)];
      var $28696=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28694, tempValue);
      var $28697=($28696.f1 = $28695, $28696);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5334: // $28698
      throw "Reached an unreachable!"
    case 5335: // $_ZnwjPKci_exit666
      var $28699=HEAP32[(($result_i665)>>2)];
      var $28700=$3019;
      var $28701=$3020;
      var $28702=$3021;
      var $28703=$result_i665;
      var $28704=$3022;
      var $28705=$3023;
      var $28706=$28699;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7357, 4, 7, 1, 0, 125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5336; break; } else { __label__ = 13346; break; }
    case 5336: // $28707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7358, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5337; break; } else { __label__ = 13346; break; }
    case 5337: // $28708
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7359, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5338; break; } else { __label__ = 13346; break; }
    case 5338: // $28709
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5339; break; } else { __label__ = 13346; break; }
    case 5339: // $28710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5340; break; } else { __label__ = 13346; break; }
    case 5340: // $28711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5341; break; } else { __label__ = 13346; break; }
    case 5341: // $28712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5342; break; } else { __label__ = 13346; break; }
    case 5342: // $28713
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7356, $7357, $7358, $7359, $7360, $7361, $7362, $7363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5343; break; } else { __label__ = 13346; break; }
    case 5343: // $28714
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28706, 66, 8, 7, ((STRING_TABLE.__str857)|0), ((STRING_TABLE.__str858)|0), $7356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5344; break; } else { __label__ = 13346; break; }
    case 5344: // $28715
      var $28716=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28706);
      var $28717=__ZN11simple_listI16input_type_entryE6appendERS0_($28667, $28716);
      var $28718=$4689;
      var $28719=$3014;
      var $28720=$3015;
      var $28721=$3016;
      var $28722=$result_i667;
      var $28723=$3017;
      var $28724=$3018;
      HEAP32[(($3014)>>2)]=408;
      HEAP32[(($3015)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3016)>>2)]=395;
      var $28725=HEAP32[(($3014)>>2)];
      var $28726=HEAP32[(($3015)>>2)];
      var $28727=HEAP32[(($3016)>>2)];
      var $28728=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28725, $28726, $28727) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5345; break; } else { __label__ = 5347; break; };
    case 5345: // $28729
      HEAP32[(($result_i667)>>2)]=$28728;
      var $28730=HEAP32[(($result_i667)>>2)];
      var $28731=(($28730)|0)==0;
      if ($28731) { __label__ = 5346; break; } else { __label__ = 5351; break; }
    case 5346: // $28732
      var $28733=___cxa_allocate_exception(4);
      var $28734=$28733;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28734);
      (function() { try { __THREW__ = false; return ___cxa_throw($28733, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5350; break; } else { __label__ = 5347; break; }
    case 5347: // $28735
      var $28736=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28737=$28736.f0;
      HEAP32[(($3017)>>2)]=$28737;
      var $28738=$28736.f1;
      HEAP32[(($3018)>>2)]=$28738;
      var $28739=HEAP32[(($3018)>>2)];
      var $28740=(($28739)|0) < 0;
      if ($28740) { __label__ = 5348; break; } else { __label__ = 5349; break; }
    case 5348: // $28741
      var $28742=HEAP32[(($3017)>>2)];
      ___cxa_call_unexpected($28742);
      throw "Reached an unreachable!"
    case 5349: // $28743
      var $28744=HEAP32[(($3017)>>2)];
      var $28745=HEAP32[(($3017)>>2)];
      var $28746=HEAP32[(($3018)>>2)];
      var $28747=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28745, tempValue);
      var $28748=($28747.f1 = $28746, $28747);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5350: // $28749
      throw "Reached an unreachable!"
    case 5351: // $_ZnwjPKci_exit668
      var $28750=HEAP32[(($result_i667)>>2)];
      var $28751=$3014;
      var $28752=$3015;
      var $28753=$3016;
      var $28754=$result_i667;
      var $28755=$3017;
      var $28756=$3018;
      var $28757=$28750;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7365, 4, 7, 1, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5352; break; } else { __label__ = 13351; break; }
    case 5352: // $28758
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7366, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5353; break; } else { __label__ = 13351; break; }
    case 5353: // $28759
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7367, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5354; break; } else { __label__ = 13351; break; }
    case 5354: // $28760
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5355; break; } else { __label__ = 13351; break; }
    case 5355: // $28761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5356; break; } else { __label__ = 13351; break; }
    case 5356: // $28762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5357; break; } else { __label__ = 13351; break; }
    case 5357: // $28763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5358; break; } else { __label__ = 13351; break; }
    case 5358: // $28764
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7364, $7365, $7366, $7367, $7368, $7369, $7370, $7371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5359; break; } else { __label__ = 13351; break; }
    case 5359: // $28765
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28757, 67, 8, 7, ((STRING_TABLE.__str859)|0), ((STRING_TABLE.__str860)|0), $7364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5360; break; } else { __label__ = 13351; break; }
    case 5360: // $28766
      var $28767=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28757);
      var $28768=__ZN11simple_listI16input_type_entryE6appendERS0_($28718, $28767);
      var $28769=$4689;
      var $28770=$3009;
      var $28771=$3010;
      var $28772=$3011;
      var $28773=$result_i669;
      var $28774=$3012;
      var $28775=$3013;
      HEAP32[(($3009)>>2)]=408;
      HEAP32[(($3010)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3011)>>2)]=396;
      var $28776=HEAP32[(($3009)>>2)];
      var $28777=HEAP32[(($3010)>>2)];
      var $28778=HEAP32[(($3011)>>2)];
      var $28779=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28776, $28777, $28778) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5361; break; } else { __label__ = 5363; break; };
    case 5361: // $28780
      HEAP32[(($result_i669)>>2)]=$28779;
      var $28781=HEAP32[(($result_i669)>>2)];
      var $28782=(($28781)|0)==0;
      if ($28782) { __label__ = 5362; break; } else { __label__ = 5367; break; }
    case 5362: // $28783
      var $28784=___cxa_allocate_exception(4);
      var $28785=$28784;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28785);
      (function() { try { __THREW__ = false; return ___cxa_throw($28784, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5366; break; } else { __label__ = 5363; break; }
    case 5363: // $28786
      var $28787=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28788=$28787.f0;
      HEAP32[(($3012)>>2)]=$28788;
      var $28789=$28787.f1;
      HEAP32[(($3013)>>2)]=$28789;
      var $28790=HEAP32[(($3013)>>2)];
      var $28791=(($28790)|0) < 0;
      if ($28791) { __label__ = 5364; break; } else { __label__ = 5365; break; }
    case 5364: // $28792
      var $28793=HEAP32[(($3012)>>2)];
      ___cxa_call_unexpected($28793);
      throw "Reached an unreachable!"
    case 5365: // $28794
      var $28795=HEAP32[(($3012)>>2)];
      var $28796=HEAP32[(($3012)>>2)];
      var $28797=HEAP32[(($3013)>>2)];
      var $28798=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28796, tempValue);
      var $28799=($28798.f1 = $28797, $28798);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5366: // $28800
      throw "Reached an unreachable!"
    case 5367: // $_ZnwjPKci_exit670
      var $28801=HEAP32[(($result_i669)>>2)];
      var $28802=$3009;
      var $28803=$3010;
      var $28804=$3011;
      var $28805=$result_i669;
      var $28806=$3012;
      var $28807=$3013;
      var $28808=$28801;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7373, 4, 7, 1, 0, 127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5368; break; } else { __label__ = 13356; break; }
    case 5368: // $28809
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7374, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5369; break; } else { __label__ = 13356; break; }
    case 5369: // $28810
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7375, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5370; break; } else { __label__ = 13356; break; }
    case 5370: // $28811
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5371; break; } else { __label__ = 13356; break; }
    case 5371: // $28812
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5372; break; } else { __label__ = 13356; break; }
    case 5372: // $28813
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5373; break; } else { __label__ = 13356; break; }
    case 5373: // $28814
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5374; break; } else { __label__ = 13356; break; }
    case 5374: // $28815
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7372, $7373, $7374, $7375, $7376, $7377, $7378, $7379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5375; break; } else { __label__ = 13356; break; }
    case 5375: // $28816
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28808, 68, 8, 7, ((STRING_TABLE.__str861)|0), ((STRING_TABLE.__str862)|0), $7372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5376; break; } else { __label__ = 13356; break; }
    case 5376: // $28817
      var $28818=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28808);
      var $28819=__ZN11simple_listI16input_type_entryE6appendERS0_($28769, $28818);
      var $28820=$4689;
      var $28821=$3004;
      var $28822=$3005;
      var $28823=$3006;
      var $28824=$result_i671;
      var $28825=$3007;
      var $28826=$3008;
      HEAP32[(($3004)>>2)]=408;
      HEAP32[(($3005)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3006)>>2)]=397;
      var $28827=HEAP32[(($3004)>>2)];
      var $28828=HEAP32[(($3005)>>2)];
      var $28829=HEAP32[(($3006)>>2)];
      var $28830=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28827, $28828, $28829) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5377; break; } else { __label__ = 5379; break; };
    case 5377: // $28831
      HEAP32[(($result_i671)>>2)]=$28830;
      var $28832=HEAP32[(($result_i671)>>2)];
      var $28833=(($28832)|0)==0;
      if ($28833) { __label__ = 5378; break; } else { __label__ = 5383; break; }
    case 5378: // $28834
      var $28835=___cxa_allocate_exception(4);
      var $28836=$28835;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28836);
      (function() { try { __THREW__ = false; return ___cxa_throw($28835, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5382; break; } else { __label__ = 5379; break; }
    case 5379: // $28837
      var $28838=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28839=$28838.f0;
      HEAP32[(($3007)>>2)]=$28839;
      var $28840=$28838.f1;
      HEAP32[(($3008)>>2)]=$28840;
      var $28841=HEAP32[(($3008)>>2)];
      var $28842=(($28841)|0) < 0;
      if ($28842) { __label__ = 5380; break; } else { __label__ = 5381; break; }
    case 5380: // $28843
      var $28844=HEAP32[(($3007)>>2)];
      ___cxa_call_unexpected($28844);
      throw "Reached an unreachable!"
    case 5381: // $28845
      var $28846=HEAP32[(($3007)>>2)];
      var $28847=HEAP32[(($3007)>>2)];
      var $28848=HEAP32[(($3008)>>2)];
      var $28849=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28847, tempValue);
      var $28850=($28849.f1 = $28848, $28849);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5382: // $28851
      throw "Reached an unreachable!"
    case 5383: // $_ZnwjPKci_exit672
      var $28852=HEAP32[(($result_i671)>>2)];
      var $28853=$3004;
      var $28854=$3005;
      var $28855=$3006;
      var $28856=$result_i671;
      var $28857=$3007;
      var $28858=$3008;
      var $28859=$28852;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7381, 4, 7, 1, 0, 128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5384; break; } else { __label__ = 13361; break; }
    case 5384: // $28860
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5385; break; } else { __label__ = 13361; break; }
    case 5385: // $28861
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5386; break; } else { __label__ = 13361; break; }
    case 5386: // $28862
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5387; break; } else { __label__ = 13361; break; }
    case 5387: // $28863
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5388; break; } else { __label__ = 13361; break; }
    case 5388: // $28864
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5389; break; } else { __label__ = 13361; break; }
    case 5389: // $28865
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5390; break; } else { __label__ = 13361; break; }
    case 5390: // $28866
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7380, $7381, $7382, $7383, $7384, $7385, $7386, $7387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5391; break; } else { __label__ = 13361; break; }
    case 5391: // $28867
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28859, 69, 8, 7, ((STRING_TABLE.__str863)|0), ((STRING_TABLE.__str864)|0), $7380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5392; break; } else { __label__ = 13361; break; }
    case 5392: // $28868
      var $28869=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28859);
      var $28870=__ZN11simple_listI16input_type_entryE6appendERS0_($28820, $28869);
      var $28871=$4689;
      var $28872=$2999;
      var $28873=$3000;
      var $28874=$3001;
      var $28875=$result_i673;
      var $28876=$3002;
      var $28877=$3003;
      HEAP32[(($2999)>>2)]=408;
      HEAP32[(($3000)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3001)>>2)]=398;
      var $28878=HEAP32[(($2999)>>2)];
      var $28879=HEAP32[(($3000)>>2)];
      var $28880=HEAP32[(($3001)>>2)];
      var $28881=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28878, $28879, $28880) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5393; break; } else { __label__ = 5395; break; };
    case 5393: // $28882
      HEAP32[(($result_i673)>>2)]=$28881;
      var $28883=HEAP32[(($result_i673)>>2)];
      var $28884=(($28883)|0)==0;
      if ($28884) { __label__ = 5394; break; } else { __label__ = 5399; break; }
    case 5394: // $28885
      var $28886=___cxa_allocate_exception(4);
      var $28887=$28886;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28887);
      (function() { try { __THREW__ = false; return ___cxa_throw($28886, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5398; break; } else { __label__ = 5395; break; }
    case 5395: // $28888
      var $28889=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28890=$28889.f0;
      HEAP32[(($3002)>>2)]=$28890;
      var $28891=$28889.f1;
      HEAP32[(($3003)>>2)]=$28891;
      var $28892=HEAP32[(($3003)>>2)];
      var $28893=(($28892)|0) < 0;
      if ($28893) { __label__ = 5396; break; } else { __label__ = 5397; break; }
    case 5396: // $28894
      var $28895=HEAP32[(($3002)>>2)];
      ___cxa_call_unexpected($28895);
      throw "Reached an unreachable!"
    case 5397: // $28896
      var $28897=HEAP32[(($3002)>>2)];
      var $28898=HEAP32[(($3002)>>2)];
      var $28899=HEAP32[(($3003)>>2)];
      var $28900=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28898, tempValue);
      var $28901=($28900.f1 = $28899, $28900);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5398: // $28902
      throw "Reached an unreachable!"
    case 5399: // $_ZnwjPKci_exit674
      var $28903=HEAP32[(($result_i673)>>2)];
      var $28904=$2999;
      var $28905=$3000;
      var $28906=$3001;
      var $28907=$result_i673;
      var $28908=$3002;
      var $28909=$3003;
      var $28910=$28903;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7389, 4, 7, 1, 0, 129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5400; break; } else { __label__ = 13366; break; }
    case 5400: // $28911
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7390, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5401; break; } else { __label__ = 13366; break; }
    case 5401: // $28912
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7391, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5402; break; } else { __label__ = 13366; break; }
    case 5402: // $28913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5403; break; } else { __label__ = 13366; break; }
    case 5403: // $28914
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5404; break; } else { __label__ = 13366; break; }
    case 5404: // $28915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5405; break; } else { __label__ = 13366; break; }
    case 5405: // $28916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5406; break; } else { __label__ = 13366; break; }
    case 5406: // $28917
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7388, $7389, $7390, $7391, $7392, $7393, $7394, $7395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5407; break; } else { __label__ = 13366; break; }
    case 5407: // $28918
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28910, 70, 8, 7, ((STRING_TABLE.__str865)|0), ((STRING_TABLE.__str866)|0), $7388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5408; break; } else { __label__ = 13366; break; }
    case 5408: // $28919
      var $28920=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28910);
      var $28921=__ZN11simple_listI16input_type_entryE6appendERS0_($28871, $28920);
      var $28922=$4689;
      var $28923=$2994;
      var $28924=$2995;
      var $28925=$2996;
      var $28926=$result_i675;
      var $28927=$2997;
      var $28928=$2998;
      HEAP32[(($2994)>>2)]=408;
      HEAP32[(($2995)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2996)>>2)]=399;
      var $28929=HEAP32[(($2994)>>2)];
      var $28930=HEAP32[(($2995)>>2)];
      var $28931=HEAP32[(($2996)>>2)];
      var $28932=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28929, $28930, $28931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5409; break; } else { __label__ = 5411; break; };
    case 5409: // $28933
      HEAP32[(($result_i675)>>2)]=$28932;
      var $28934=HEAP32[(($result_i675)>>2)];
      var $28935=(($28934)|0)==0;
      if ($28935) { __label__ = 5410; break; } else { __label__ = 5415; break; }
    case 5410: // $28936
      var $28937=___cxa_allocate_exception(4);
      var $28938=$28937;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28938);
      (function() { try { __THREW__ = false; return ___cxa_throw($28937, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5414; break; } else { __label__ = 5411; break; }
    case 5411: // $28939
      var $28940=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28941=$28940.f0;
      HEAP32[(($2997)>>2)]=$28941;
      var $28942=$28940.f1;
      HEAP32[(($2998)>>2)]=$28942;
      var $28943=HEAP32[(($2998)>>2)];
      var $28944=(($28943)|0) < 0;
      if ($28944) { __label__ = 5412; break; } else { __label__ = 5413; break; }
    case 5412: // $28945
      var $28946=HEAP32[(($2997)>>2)];
      ___cxa_call_unexpected($28946);
      throw "Reached an unreachable!"
    case 5413: // $28947
      var $28948=HEAP32[(($2997)>>2)];
      var $28949=HEAP32[(($2997)>>2)];
      var $28950=HEAP32[(($2998)>>2)];
      var $28951=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28949, tempValue);
      var $28952=($28951.f1 = $28950, $28951);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5414: // $28953
      throw "Reached an unreachable!"
    case 5415: // $_ZnwjPKci_exit676
      var $28954=HEAP32[(($result_i675)>>2)];
      var $28955=$2994;
      var $28956=$2995;
      var $28957=$2996;
      var $28958=$result_i675;
      var $28959=$2997;
      var $28960=$2998;
      var $28961=$28954;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7397, 4, 7, 1, 0, 130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5416; break; } else { __label__ = 13371; break; }
    case 5416: // $28962
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7398, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5417; break; } else { __label__ = 13371; break; }
    case 5417: // $28963
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7399, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5418; break; } else { __label__ = 13371; break; }
    case 5418: // $28964
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5419; break; } else { __label__ = 13371; break; }
    case 5419: // $28965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5420; break; } else { __label__ = 13371; break; }
    case 5420: // $28966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5421; break; } else { __label__ = 13371; break; }
    case 5421: // $28967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5422; break; } else { __label__ = 13371; break; }
    case 5422: // $28968
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7396, $7397, $7398, $7399, $7400, $7401, $7402, $7403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5423; break; } else { __label__ = 13371; break; }
    case 5423: // $28969
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($28961, 71, 8, 7, ((STRING_TABLE.__str867)|0), ((STRING_TABLE.__str868)|0), $7396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5424; break; } else { __label__ = 13371; break; }
    case 5424: // $28970
      var $28971=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $28961);
      var $28972=__ZN11simple_listI16input_type_entryE6appendERS0_($28922, $28971);
      var $28973=$4689;
      var $28974=$2989;
      var $28975=$2990;
      var $28976=$2991;
      var $28977=$result_i677;
      var $28978=$2992;
      var $28979=$2993;
      HEAP32[(($2989)>>2)]=408;
      HEAP32[(($2990)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2991)>>2)]=400;
      var $28980=HEAP32[(($2989)>>2)];
      var $28981=HEAP32[(($2990)>>2)];
      var $28982=HEAP32[(($2991)>>2)];
      var $28983=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28980, $28981, $28982) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5425; break; } else { __label__ = 5427; break; };
    case 5425: // $28984
      HEAP32[(($result_i677)>>2)]=$28983;
      var $28985=HEAP32[(($result_i677)>>2)];
      var $28986=(($28985)|0)==0;
      if ($28986) { __label__ = 5426; break; } else { __label__ = 5431; break; }
    case 5426: // $28987
      var $28988=___cxa_allocate_exception(4);
      var $28989=$28988;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28989);
      (function() { try { __THREW__ = false; return ___cxa_throw($28988, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5430; break; } else { __label__ = 5427; break; }
    case 5427: // $28990
      var $28991=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28992=$28991.f0;
      HEAP32[(($2992)>>2)]=$28992;
      var $28993=$28991.f1;
      HEAP32[(($2993)>>2)]=$28993;
      var $28994=HEAP32[(($2993)>>2)];
      var $28995=(($28994)|0) < 0;
      if ($28995) { __label__ = 5428; break; } else { __label__ = 5429; break; }
    case 5428: // $28996
      var $28997=HEAP32[(($2992)>>2)];
      ___cxa_call_unexpected($28997);
      throw "Reached an unreachable!"
    case 5429: // $28998
      var $28999=HEAP32[(($2992)>>2)];
      var $29000=HEAP32[(($2992)>>2)];
      var $29001=HEAP32[(($2993)>>2)];
      var $29002=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29000, tempValue);
      var $29003=($29002.f1 = $29001, $29002);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5430: // $29004
      throw "Reached an unreachable!"
    case 5431: // $_ZnwjPKci_exit678
      var $29005=HEAP32[(($result_i677)>>2)];
      var $29006=$2989;
      var $29007=$2990;
      var $29008=$2991;
      var $29009=$result_i677;
      var $29010=$2992;
      var $29011=$2993;
      var $29012=$29005;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7405, 4, 7, 1, 0, 131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5432; break; } else { __label__ = 13376; break; }
    case 5432: // $29013
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7406, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5433; break; } else { __label__ = 13376; break; }
    case 5433: // $29014
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7407, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5434; break; } else { __label__ = 13376; break; }
    case 5434: // $29015
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7408, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5435; break; } else { __label__ = 13376; break; }
    case 5435: // $29016
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7409, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5436; break; } else { __label__ = 13376; break; }
    case 5436: // $29017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5437; break; } else { __label__ = 13376; break; }
    case 5437: // $29018
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5438; break; } else { __label__ = 13376; break; }
    case 5438: // $29019
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7404, $7405, $7406, $7407, $7408, $7409, $7410, $7411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5439; break; } else { __label__ = 13376; break; }
    case 5439: // $29020
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29012, 72, 8, 7, ((STRING_TABLE.__str869)|0), ((STRING_TABLE.__str870)|0), $7404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5440; break; } else { __label__ = 13376; break; }
    case 5440: // $29021
      var $29022=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29012);
      var $29023=__ZN11simple_listI16input_type_entryE6appendERS0_($28973, $29022);
      var $29024=$4689;
      var $29025=$2984;
      var $29026=$2985;
      var $29027=$2986;
      var $29028=$result_i679;
      var $29029=$2987;
      var $29030=$2988;
      HEAP32[(($2984)>>2)]=408;
      HEAP32[(($2985)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2986)>>2)]=401;
      var $29031=HEAP32[(($2984)>>2)];
      var $29032=HEAP32[(($2985)>>2)];
      var $29033=HEAP32[(($2986)>>2)];
      var $29034=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29031, $29032, $29033) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5441; break; } else { __label__ = 5443; break; };
    case 5441: // $29035
      HEAP32[(($result_i679)>>2)]=$29034;
      var $29036=HEAP32[(($result_i679)>>2)];
      var $29037=(($29036)|0)==0;
      if ($29037) { __label__ = 5442; break; } else { __label__ = 5447; break; }
    case 5442: // $29038
      var $29039=___cxa_allocate_exception(4);
      var $29040=$29039;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29040);
      (function() { try { __THREW__ = false; return ___cxa_throw($29039, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5446; break; } else { __label__ = 5443; break; }
    case 5443: // $29041
      var $29042=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29043=$29042.f0;
      HEAP32[(($2987)>>2)]=$29043;
      var $29044=$29042.f1;
      HEAP32[(($2988)>>2)]=$29044;
      var $29045=HEAP32[(($2988)>>2)];
      var $29046=(($29045)|0) < 0;
      if ($29046) { __label__ = 5444; break; } else { __label__ = 5445; break; }
    case 5444: // $29047
      var $29048=HEAP32[(($2987)>>2)];
      ___cxa_call_unexpected($29048);
      throw "Reached an unreachable!"
    case 5445: // $29049
      var $29050=HEAP32[(($2987)>>2)];
      var $29051=HEAP32[(($2987)>>2)];
      var $29052=HEAP32[(($2988)>>2)];
      var $29053=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29051, tempValue);
      var $29054=($29053.f1 = $29052, $29053);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5446: // $29055
      throw "Reached an unreachable!"
    case 5447: // $_ZnwjPKci_exit680
      var $29056=HEAP32[(($result_i679)>>2)];
      var $29057=$2984;
      var $29058=$2985;
      var $29059=$2986;
      var $29060=$result_i679;
      var $29061=$2987;
      var $29062=$2988;
      var $29063=$29056;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7413, 4, 7, 1, 0, 132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5448; break; } else { __label__ = 13381; break; }
    case 5448: // $29064
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7414, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5449; break; } else { __label__ = 13381; break; }
    case 5449: // $29065
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7415, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5450; break; } else { __label__ = 13381; break; }
    case 5450: // $29066
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5451; break; } else { __label__ = 13381; break; }
    case 5451: // $29067
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5452; break; } else { __label__ = 13381; break; }
    case 5452: // $29068
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5453; break; } else { __label__ = 13381; break; }
    case 5453: // $29069
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5454; break; } else { __label__ = 13381; break; }
    case 5454: // $29070
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7412, $7413, $7414, $7415, $7416, $7417, $7418, $7419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5455; break; } else { __label__ = 13381; break; }
    case 5455: // $29071
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29063, 73, 8, 7, ((STRING_TABLE.__str871)|0), ((STRING_TABLE.__str872)|0), $7412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5456; break; } else { __label__ = 13381; break; }
    case 5456: // $29072
      var $29073=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29063);
      var $29074=__ZN11simple_listI16input_type_entryE6appendERS0_($29024, $29073);
      var $29075=$4689;
      var $29076=$2979;
      var $29077=$2980;
      var $29078=$2981;
      var $29079=$result_i681;
      var $29080=$2982;
      var $29081=$2983;
      HEAP32[(($2979)>>2)]=408;
      HEAP32[(($2980)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2981)>>2)]=402;
      var $29082=HEAP32[(($2979)>>2)];
      var $29083=HEAP32[(($2980)>>2)];
      var $29084=HEAP32[(($2981)>>2)];
      var $29085=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29082, $29083, $29084) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5457; break; } else { __label__ = 5459; break; };
    case 5457: // $29086
      HEAP32[(($result_i681)>>2)]=$29085;
      var $29087=HEAP32[(($result_i681)>>2)];
      var $29088=(($29087)|0)==0;
      if ($29088) { __label__ = 5458; break; } else { __label__ = 5463; break; }
    case 5458: // $29089
      var $29090=___cxa_allocate_exception(4);
      var $29091=$29090;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29091);
      (function() { try { __THREW__ = false; return ___cxa_throw($29090, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5462; break; } else { __label__ = 5459; break; }
    case 5459: // $29092
      var $29093=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29094=$29093.f0;
      HEAP32[(($2982)>>2)]=$29094;
      var $29095=$29093.f1;
      HEAP32[(($2983)>>2)]=$29095;
      var $29096=HEAP32[(($2983)>>2)];
      var $29097=(($29096)|0) < 0;
      if ($29097) { __label__ = 5460; break; } else { __label__ = 5461; break; }
    case 5460: // $29098
      var $29099=HEAP32[(($2982)>>2)];
      ___cxa_call_unexpected($29099);
      throw "Reached an unreachable!"
    case 5461: // $29100
      var $29101=HEAP32[(($2982)>>2)];
      var $29102=HEAP32[(($2982)>>2)];
      var $29103=HEAP32[(($2983)>>2)];
      var $29104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29102, tempValue);
      var $29105=($29104.f1 = $29103, $29104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5462: // $29106
      throw "Reached an unreachable!"
    case 5463: // $_ZnwjPKci_exit682
      var $29107=HEAP32[(($result_i681)>>2)];
      var $29108=$2979;
      var $29109=$2980;
      var $29110=$2981;
      var $29111=$result_i681;
      var $29112=$2982;
      var $29113=$2983;
      var $29114=$29107;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7421, 4, 7, 1, 0, 133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5464; break; } else { __label__ = 13386; break; }
    case 5464: // $29115
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7422, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5465; break; } else { __label__ = 13386; break; }
    case 5465: // $29116
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7423, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5466; break; } else { __label__ = 13386; break; }
    case 5466: // $29117
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5467; break; } else { __label__ = 13386; break; }
    case 5467: // $29118
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5468; break; } else { __label__ = 13386; break; }
    case 5468: // $29119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5469; break; } else { __label__ = 13386; break; }
    case 5469: // $29120
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5470; break; } else { __label__ = 13386; break; }
    case 5470: // $29121
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7420, $7421, $7422, $7423, $7424, $7425, $7426, $7427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5471; break; } else { __label__ = 13386; break; }
    case 5471: // $29122
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29114, 74, 8, 7, ((STRING_TABLE.__str873)|0), ((STRING_TABLE.__str874)|0), $7420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5472; break; } else { __label__ = 13386; break; }
    case 5472: // $29123
      var $29124=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29114);
      var $29125=__ZN11simple_listI16input_type_entryE6appendERS0_($29075, $29124);
      var $29126=$4689;
      var $29127=$2974;
      var $29128=$2975;
      var $29129=$2976;
      var $29130=$result_i683;
      var $29131=$2977;
      var $29132=$2978;
      HEAP32[(($2974)>>2)]=408;
      HEAP32[(($2975)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2976)>>2)]=403;
      var $29133=HEAP32[(($2974)>>2)];
      var $29134=HEAP32[(($2975)>>2)];
      var $29135=HEAP32[(($2976)>>2)];
      var $29136=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29133, $29134, $29135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5473; break; } else { __label__ = 5475; break; };
    case 5473: // $29137
      HEAP32[(($result_i683)>>2)]=$29136;
      var $29138=HEAP32[(($result_i683)>>2)];
      var $29139=(($29138)|0)==0;
      if ($29139) { __label__ = 5474; break; } else { __label__ = 5479; break; }
    case 5474: // $29140
      var $29141=___cxa_allocate_exception(4);
      var $29142=$29141;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29142);
      (function() { try { __THREW__ = false; return ___cxa_throw($29141, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5478; break; } else { __label__ = 5475; break; }
    case 5475: // $29143
      var $29144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29145=$29144.f0;
      HEAP32[(($2977)>>2)]=$29145;
      var $29146=$29144.f1;
      HEAP32[(($2978)>>2)]=$29146;
      var $29147=HEAP32[(($2978)>>2)];
      var $29148=(($29147)|0) < 0;
      if ($29148) { __label__ = 5476; break; } else { __label__ = 5477; break; }
    case 5476: // $29149
      var $29150=HEAP32[(($2977)>>2)];
      ___cxa_call_unexpected($29150);
      throw "Reached an unreachable!"
    case 5477: // $29151
      var $29152=HEAP32[(($2977)>>2)];
      var $29153=HEAP32[(($2977)>>2)];
      var $29154=HEAP32[(($2978)>>2)];
      var $29155=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29153, tempValue);
      var $29156=($29155.f1 = $29154, $29155);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5478: // $29157
      throw "Reached an unreachable!"
    case 5479: // $_ZnwjPKci_exit684
      var $29158=HEAP32[(($result_i683)>>2)];
      var $29159=$2974;
      var $29160=$2975;
      var $29161=$2976;
      var $29162=$result_i683;
      var $29163=$2977;
      var $29164=$2978;
      var $29165=$29158;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7429, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5480; break; } else { __label__ = 13391; break; }
    case 5480: // $29166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7430, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5481; break; } else { __label__ = 13391; break; }
    case 5481: // $29167
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7431, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5482; break; } else { __label__ = 13391; break; }
    case 5482: // $29168
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7432, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5483; break; } else { __label__ = 13391; break; }
    case 5483: // $29169
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7433, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5484; break; } else { __label__ = 13391; break; }
    case 5484: // $29170
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5485; break; } else { __label__ = 13391; break; }
    case 5485: // $29171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5486; break; } else { __label__ = 13391; break; }
    case 5486: // $29172
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7428, $7429, $7430, $7431, $7432, $7433, $7434, $7435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5487; break; } else { __label__ = 13391; break; }
    case 5487: // $29173
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29165, 43, 8, 7, ((STRING_TABLE.__str875)|0), ((STRING_TABLE.__str876)|0), $7428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5488; break; } else { __label__ = 13391; break; }
    case 5488: // $29174
      var $29175=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29165);
      var $29176=__ZN11simple_listI16input_type_entryE6appendERS0_($29126, $29175);
      var $29177=$4689;
      var $29178=$2969;
      var $29179=$2970;
      var $29180=$2971;
      var $29181=$result_i685;
      var $29182=$2972;
      var $29183=$2973;
      HEAP32[(($2969)>>2)]=408;
      HEAP32[(($2970)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2971)>>2)]=404;
      var $29184=HEAP32[(($2969)>>2)];
      var $29185=HEAP32[(($2970)>>2)];
      var $29186=HEAP32[(($2971)>>2)];
      var $29187=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29184, $29185, $29186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5489; break; } else { __label__ = 5491; break; };
    case 5489: // $29188
      HEAP32[(($result_i685)>>2)]=$29187;
      var $29189=HEAP32[(($result_i685)>>2)];
      var $29190=(($29189)|0)==0;
      if ($29190) { __label__ = 5490; break; } else { __label__ = 5495; break; }
    case 5490: // $29191
      var $29192=___cxa_allocate_exception(4);
      var $29193=$29192;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29193);
      (function() { try { __THREW__ = false; return ___cxa_throw($29192, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5494; break; } else { __label__ = 5491; break; }
    case 5491: // $29194
      var $29195=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29196=$29195.f0;
      HEAP32[(($2972)>>2)]=$29196;
      var $29197=$29195.f1;
      HEAP32[(($2973)>>2)]=$29197;
      var $29198=HEAP32[(($2973)>>2)];
      var $29199=(($29198)|0) < 0;
      if ($29199) { __label__ = 5492; break; } else { __label__ = 5493; break; }
    case 5492: // $29200
      var $29201=HEAP32[(($2972)>>2)];
      ___cxa_call_unexpected($29201);
      throw "Reached an unreachable!"
    case 5493: // $29202
      var $29203=HEAP32[(($2972)>>2)];
      var $29204=HEAP32[(($2972)>>2)];
      var $29205=HEAP32[(($2973)>>2)];
      var $29206=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29204, tempValue);
      var $29207=($29206.f1 = $29205, $29206);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5494: // $29208
      throw "Reached an unreachable!"
    case 5495: // $_ZnwjPKci_exit686
      var $29209=HEAP32[(($result_i685)>>2)];
      var $29210=$2969;
      var $29211=$2970;
      var $29212=$2971;
      var $29213=$result_i685;
      var $29214=$2972;
      var $29215=$2973;
      var $29216=$29209;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7437, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5496; break; } else { __label__ = 13396; break; }
    case 5496: // $29217
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7438, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5497; break; } else { __label__ = 13396; break; }
    case 5497: // $29218
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7439, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5498; break; } else { __label__ = 13396; break; }
    case 5498: // $29219
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5499; break; } else { __label__ = 13396; break; }
    case 5499: // $29220
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5500; break; } else { __label__ = 13396; break; }
    case 5500: // $29221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5501; break; } else { __label__ = 13396; break; }
    case 5501: // $29222
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5502; break; } else { __label__ = 13396; break; }
    case 5502: // $29223
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7436, $7437, $7438, $7439, $7440, $7441, $7442, $7443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5503; break; } else { __label__ = 13396; break; }
    case 5503: // $29224
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29216, 44, 8, 7, ((STRING_TABLE.__str877418)|0), ((STRING_TABLE.__str878)|0), $7436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5504; break; } else { __label__ = 13396; break; }
    case 5504: // $29225
      var $29226=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29216);
      var $29227=__ZN11simple_listI16input_type_entryE6appendERS0_($29177, $29226);
      var $29228=$4689;
      var $29229=$2964;
      var $29230=$2965;
      var $29231=$2966;
      var $29232=$result_i687;
      var $29233=$2967;
      var $29234=$2968;
      HEAP32[(($2964)>>2)]=408;
      HEAP32[(($2965)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2966)>>2)]=406;
      var $29235=HEAP32[(($2964)>>2)];
      var $29236=HEAP32[(($2965)>>2)];
      var $29237=HEAP32[(($2966)>>2)];
      var $29238=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29235, $29236, $29237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5505; break; } else { __label__ = 5507; break; };
    case 5505: // $29239
      HEAP32[(($result_i687)>>2)]=$29238;
      var $29240=HEAP32[(($result_i687)>>2)];
      var $29241=(($29240)|0)==0;
      if ($29241) { __label__ = 5506; break; } else { __label__ = 5511; break; }
    case 5506: // $29242
      var $29243=___cxa_allocate_exception(4);
      var $29244=$29243;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29244);
      (function() { try { __THREW__ = false; return ___cxa_throw($29243, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5510; break; } else { __label__ = 5507; break; }
    case 5507: // $29245
      var $29246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29247=$29246.f0;
      HEAP32[(($2967)>>2)]=$29247;
      var $29248=$29246.f1;
      HEAP32[(($2968)>>2)]=$29248;
      var $29249=HEAP32[(($2968)>>2)];
      var $29250=(($29249)|0) < 0;
      if ($29250) { __label__ = 5508; break; } else { __label__ = 5509; break; }
    case 5508: // $29251
      var $29252=HEAP32[(($2967)>>2)];
      ___cxa_call_unexpected($29252);
      throw "Reached an unreachable!"
    case 5509: // $29253
      var $29254=HEAP32[(($2967)>>2)];
      var $29255=HEAP32[(($2967)>>2)];
      var $29256=HEAP32[(($2968)>>2)];
      var $29257=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29255, tempValue);
      var $29258=($29257.f1 = $29256, $29257);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5510: // $29259
      throw "Reached an unreachable!"
    case 5511: // $_ZnwjPKci_exit688
      var $29260=HEAP32[(($result_i687)>>2)];
      var $29261=$2964;
      var $29262=$2965;
      var $29263=$2966;
      var $29264=$result_i687;
      var $29265=$2967;
      var $29266=$2968;
      var $29267=$29260;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7445, 1, 0, 1, 0, 28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5512; break; } else { __label__ = 13401; break; }
    case 5512: // $29268
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7446, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5513; break; } else { __label__ = 13401; break; }
    case 5513: // $29269
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7447, 4, 0, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5514; break; } else { __label__ = 13401; break; }
    case 5514: // $29270
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5515; break; } else { __label__ = 13401; break; }
    case 5515: // $29271
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5516; break; } else { __label__ = 13401; break; }
    case 5516: // $29272
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5517; break; } else { __label__ = 13401; break; }
    case 5517: // $29273
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5518; break; } else { __label__ = 13401; break; }
    case 5518: // $29274
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7444, $7445, $7446, $7447, $7448, $7449, $7450, $7451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5519; break; } else { __label__ = 13401; break; }
    case 5519: // $29275
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29267, 9, 9, 0, ((STRING_TABLE.__str879)|0), ((STRING_TABLE.__str880)|0), $7444) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5520; break; } else { __label__ = 13401; break; }
    case 5520: // $29276
      var $29277=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29267);
      var $29278=__ZN11simple_listI16input_type_entryE6appendERS0_($29228, $29277);
      var $29279=$4689;
      var $29280=$2959;
      var $29281=$2960;
      var $29282=$2961;
      var $29283=$result_i689;
      var $29284=$2962;
      var $29285=$2963;
      HEAP32[(($2959)>>2)]=408;
      HEAP32[(($2960)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2961)>>2)]=407;
      var $29286=HEAP32[(($2959)>>2)];
      var $29287=HEAP32[(($2960)>>2)];
      var $29288=HEAP32[(($2961)>>2)];
      var $29289=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29286, $29287, $29288) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5521; break; } else { __label__ = 5523; break; };
    case 5521: // $29290
      HEAP32[(($result_i689)>>2)]=$29289;
      var $29291=HEAP32[(($result_i689)>>2)];
      var $29292=(($29291)|0)==0;
      if ($29292) { __label__ = 5522; break; } else { __label__ = 5527; break; }
    case 5522: // $29293
      var $29294=___cxa_allocate_exception(4);
      var $29295=$29294;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29295);
      (function() { try { __THREW__ = false; return ___cxa_throw($29294, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5526; break; } else { __label__ = 5523; break; }
    case 5523: // $29296
      var $29297=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29298=$29297.f0;
      HEAP32[(($2962)>>2)]=$29298;
      var $29299=$29297.f1;
      HEAP32[(($2963)>>2)]=$29299;
      var $29300=HEAP32[(($2963)>>2)];
      var $29301=(($29300)|0) < 0;
      if ($29301) { __label__ = 5524; break; } else { __label__ = 5525; break; }
    case 5524: // $29302
      var $29303=HEAP32[(($2962)>>2)];
      ___cxa_call_unexpected($29303);
      throw "Reached an unreachable!"
    case 5525: // $29304
      var $29305=HEAP32[(($2962)>>2)];
      var $29306=HEAP32[(($2962)>>2)];
      var $29307=HEAP32[(($2963)>>2)];
      var $29308=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29306, tempValue);
      var $29309=($29308.f1 = $29307, $29308);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5526: // $29310
      throw "Reached an unreachable!"
    case 5527: // $_ZnwjPKci_exit690
      var $29311=HEAP32[(($result_i689)>>2)];
      var $29312=$2959;
      var $29313=$2960;
      var $29314=$2961;
      var $29315=$result_i689;
      var $29316=$2962;
      var $29317=$2963;
      var $29318=$29311;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7453, 1, 0, 1, 0, 29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5528; break; } else { __label__ = 13406; break; }
    case 5528: // $29319
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7454, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5529; break; } else { __label__ = 13406; break; }
    case 5529: // $29320
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7455, 4, 1, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5530; break; } else { __label__ = 13406; break; }
    case 5530: // $29321
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7456, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5531; break; } else { __label__ = 13406; break; }
    case 5531: // $29322
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7457, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5532; break; } else { __label__ = 13406; break; }
    case 5532: // $29323
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5533; break; } else { __label__ = 13406; break; }
    case 5533: // $29324
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5534; break; } else { __label__ = 13406; break; }
    case 5534: // $29325
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7452, $7453, $7454, $7455, $7456, $7457, $7458, $7459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5535; break; } else { __label__ = 13406; break; }
    case 5535: // $29326
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29318, 10, 9, 0, ((STRING_TABLE.__str881)|0), ((STRING_TABLE.__str882)|0), $7452) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5536; break; } else { __label__ = 13406; break; }
    case 5536: // $29327
      var $29328=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29318);
      var $29329=__ZN11simple_listI16input_type_entryE6appendERS0_($29279, $29328);
      var $29330=$4689;
      var $29331=$2954;
      var $29332=$2955;
      var $29333=$2956;
      var $29334=$result_i691;
      var $29335=$2957;
      var $29336=$2958;
      HEAP32[(($2954)>>2)]=408;
      HEAP32[(($2955)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2956)>>2)]=408;
      var $29337=HEAP32[(($2954)>>2)];
      var $29338=HEAP32[(($2955)>>2)];
      var $29339=HEAP32[(($2956)>>2)];
      var $29340=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29337, $29338, $29339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5537; break; } else { __label__ = 5539; break; };
    case 5537: // $29341
      HEAP32[(($result_i691)>>2)]=$29340;
      var $29342=HEAP32[(($result_i691)>>2)];
      var $29343=(($29342)|0)==0;
      if ($29343) { __label__ = 5538; break; } else { __label__ = 5543; break; }
    case 5538: // $29344
      var $29345=___cxa_allocate_exception(4);
      var $29346=$29345;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29346);
      (function() { try { __THREW__ = false; return ___cxa_throw($29345, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5542; break; } else { __label__ = 5539; break; }
    case 5539: // $29347
      var $29348=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29349=$29348.f0;
      HEAP32[(($2957)>>2)]=$29349;
      var $29350=$29348.f1;
      HEAP32[(($2958)>>2)]=$29350;
      var $29351=HEAP32[(($2958)>>2)];
      var $29352=(($29351)|0) < 0;
      if ($29352) { __label__ = 5540; break; } else { __label__ = 5541; break; }
    case 5540: // $29353
      var $29354=HEAP32[(($2957)>>2)];
      ___cxa_call_unexpected($29354);
      throw "Reached an unreachable!"
    case 5541: // $29355
      var $29356=HEAP32[(($2957)>>2)];
      var $29357=HEAP32[(($2957)>>2)];
      var $29358=HEAP32[(($2958)>>2)];
      var $29359=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29357, tempValue);
      var $29360=($29359.f1 = $29358, $29359);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5542: // $29361
      throw "Reached an unreachable!"
    case 5543: // $_ZnwjPKci_exit692
      var $29362=HEAP32[(($result_i691)>>2)];
      var $29363=$2954;
      var $29364=$2955;
      var $29365=$2956;
      var $29366=$result_i691;
      var $29367=$2957;
      var $29368=$2958;
      var $29369=$29362;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7461, 1, 0, 1, 0, 30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5544; break; } else { __label__ = 13411; break; }
    case 5544: // $29370
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7462, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5545; break; } else { __label__ = 13411; break; }
    case 5545: // $29371
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7463, 4, 2, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5546; break; } else { __label__ = 13411; break; }
    case 5546: // $29372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5547; break; } else { __label__ = 13411; break; }
    case 5547: // $29373
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5548; break; } else { __label__ = 13411; break; }
    case 5548: // $29374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5549; break; } else { __label__ = 13411; break; }
    case 5549: // $29375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5550; break; } else { __label__ = 13411; break; }
    case 5550: // $29376
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7460, $7461, $7462, $7463, $7464, $7465, $7466, $7467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5551; break; } else { __label__ = 13411; break; }
    case 5551: // $29377
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29369, 11, 9, 0, ((STRING_TABLE.__str883)|0), ((STRING_TABLE.__str884)|0), $7460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5552; break; } else { __label__ = 13411; break; }
    case 5552: // $29378
      var $29379=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29369);
      var $29380=__ZN11simple_listI16input_type_entryE6appendERS0_($29330, $29379);
      var $29381=$4689;
      var $29382=$2949;
      var $29383=$2950;
      var $29384=$2951;
      var $29385=$result_i693;
      var $29386=$2952;
      var $29387=$2953;
      HEAP32[(($2949)>>2)]=408;
      HEAP32[(($2950)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2951)>>2)]=409;
      var $29388=HEAP32[(($2949)>>2)];
      var $29389=HEAP32[(($2950)>>2)];
      var $29390=HEAP32[(($2951)>>2)];
      var $29391=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29388, $29389, $29390) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5553; break; } else { __label__ = 5555; break; };
    case 5553: // $29392
      HEAP32[(($result_i693)>>2)]=$29391;
      var $29393=HEAP32[(($result_i693)>>2)];
      var $29394=(($29393)|0)==0;
      if ($29394) { __label__ = 5554; break; } else { __label__ = 5559; break; }
    case 5554: // $29395
      var $29396=___cxa_allocate_exception(4);
      var $29397=$29396;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29397);
      (function() { try { __THREW__ = false; return ___cxa_throw($29396, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5558; break; } else { __label__ = 5555; break; }
    case 5555: // $29398
      var $29399=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29400=$29399.f0;
      HEAP32[(($2952)>>2)]=$29400;
      var $29401=$29399.f1;
      HEAP32[(($2953)>>2)]=$29401;
      var $29402=HEAP32[(($2953)>>2)];
      var $29403=(($29402)|0) < 0;
      if ($29403) { __label__ = 5556; break; } else { __label__ = 5557; break; }
    case 5556: // $29404
      var $29405=HEAP32[(($2952)>>2)];
      ___cxa_call_unexpected($29405);
      throw "Reached an unreachable!"
    case 5557: // $29406
      var $29407=HEAP32[(($2952)>>2)];
      var $29408=HEAP32[(($2952)>>2)];
      var $29409=HEAP32[(($2953)>>2)];
      var $29410=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29408, tempValue);
      var $29411=($29410.f1 = $29409, $29410);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5558: // $29412
      throw "Reached an unreachable!"
    case 5559: // $_ZnwjPKci_exit694
      var $29413=HEAP32[(($result_i693)>>2)];
      var $29414=$2949;
      var $29415=$2950;
      var $29416=$2951;
      var $29417=$result_i693;
      var $29418=$2952;
      var $29419=$2953;
      var $29420=$29413;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7469, 1, 0, 1, 0, 31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5560; break; } else { __label__ = 13416; break; }
    case 5560: // $29421
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7470, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5561; break; } else { __label__ = 13416; break; }
    case 5561: // $29422
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7471, 4, 3, 1, 0, 134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5562; break; } else { __label__ = 13416; break; }
    case 5562: // $29423
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5563; break; } else { __label__ = 13416; break; }
    case 5563: // $29424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5564; break; } else { __label__ = 13416; break; }
    case 5564: // $29425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5565; break; } else { __label__ = 13416; break; }
    case 5565: // $29426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5566; break; } else { __label__ = 13416; break; }
    case 5566: // $29427
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7468, $7469, $7470, $7471, $7472, $7473, $7474, $7475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5567; break; } else { __label__ = 13416; break; }
    case 5567: // $29428
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29420, 12, 9, 0, ((STRING_TABLE.__str885)|0), ((STRING_TABLE.__str886)|0), $7468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5568; break; } else { __label__ = 13416; break; }
    case 5568: // $29429
      var $29430=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29420);
      var $29431=__ZN11simple_listI16input_type_entryE6appendERS0_($29381, $29430);
      var $29432=$4689;
      var $29433=$2944;
      var $29434=$2945;
      var $29435=$2946;
      var $29436=$result_i695;
      var $29437=$2947;
      var $29438=$2948;
      HEAP32[(($2944)>>2)]=408;
      HEAP32[(($2945)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2946)>>2)]=410;
      var $29439=HEAP32[(($2944)>>2)];
      var $29440=HEAP32[(($2945)>>2)];
      var $29441=HEAP32[(($2946)>>2)];
      var $29442=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29439, $29440, $29441) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5569; break; } else { __label__ = 5571; break; };
    case 5569: // $29443
      HEAP32[(($result_i695)>>2)]=$29442;
      var $29444=HEAP32[(($result_i695)>>2)];
      var $29445=(($29444)|0)==0;
      if ($29445) { __label__ = 5570; break; } else { __label__ = 5575; break; }
    case 5570: // $29446
      var $29447=___cxa_allocate_exception(4);
      var $29448=$29447;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29448);
      (function() { try { __THREW__ = false; return ___cxa_throw($29447, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5574; break; } else { __label__ = 5571; break; }
    case 5571: // $29449
      var $29450=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29451=$29450.f0;
      HEAP32[(($2947)>>2)]=$29451;
      var $29452=$29450.f1;
      HEAP32[(($2948)>>2)]=$29452;
      var $29453=HEAP32[(($2948)>>2)];
      var $29454=(($29453)|0) < 0;
      if ($29454) { __label__ = 5572; break; } else { __label__ = 5573; break; }
    case 5572: // $29455
      var $29456=HEAP32[(($2947)>>2)];
      ___cxa_call_unexpected($29456);
      throw "Reached an unreachable!"
    case 5573: // $29457
      var $29458=HEAP32[(($2947)>>2)];
      var $29459=HEAP32[(($2947)>>2)];
      var $29460=HEAP32[(($2948)>>2)];
      var $29461=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29459, tempValue);
      var $29462=($29461.f1 = $29460, $29461);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5574: // $29463
      throw "Reached an unreachable!"
    case 5575: // $_ZnwjPKci_exit696
      var $29464=HEAP32[(($result_i695)>>2)];
      var $29465=$2944;
      var $29466=$2945;
      var $29467=$2946;
      var $29468=$result_i695;
      var $29469=$2947;
      var $29470=$2948;
      var $29471=$29464;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7477, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5576; break; } else { __label__ = 13421; break; }
    case 5576: // $29472
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7478, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5577; break; } else { __label__ = 13421; break; }
    case 5577: // $29473
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7479, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5578; break; } else { __label__ = 13421; break; }
    case 5578: // $29474
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7480, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5579; break; } else { __label__ = 13421; break; }
    case 5579: // $29475
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7481, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5580; break; } else { __label__ = 13421; break; }
    case 5580: // $29476
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5581; break; } else { __label__ = 13421; break; }
    case 5581: // $29477
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5582; break; } else { __label__ = 13421; break; }
    case 5582: // $29478
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7476, $7477, $7478, $7479, $7480, $7481, $7482, $7483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5583; break; } else { __label__ = 13421; break; }
    case 5583: // $29479
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29471, 13, 9, 0, ((STRING_TABLE.__str887)|0), ((STRING_TABLE.__str888)|0), $7476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5584; break; } else { __label__ = 13421; break; }
    case 5584: // $29480
      var $29481=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29471);
      var $29482=__ZN11simple_listI16input_type_entryE6appendERS0_($29432, $29481);
      var $29483=$4689;
      var $29484=$2939;
      var $29485=$2940;
      var $29486=$2941;
      var $29487=$result_i697;
      var $29488=$2942;
      var $29489=$2943;
      HEAP32[(($2939)>>2)]=408;
      HEAP32[(($2940)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2941)>>2)]=411;
      var $29490=HEAP32[(($2939)>>2)];
      var $29491=HEAP32[(($2940)>>2)];
      var $29492=HEAP32[(($2941)>>2)];
      var $29493=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29490, $29491, $29492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5585; break; } else { __label__ = 5587; break; };
    case 5585: // $29494
      HEAP32[(($result_i697)>>2)]=$29493;
      var $29495=HEAP32[(($result_i697)>>2)];
      var $29496=(($29495)|0)==0;
      if ($29496) { __label__ = 5586; break; } else { __label__ = 5591; break; }
    case 5586: // $29497
      var $29498=___cxa_allocate_exception(4);
      var $29499=$29498;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29499);
      (function() { try { __THREW__ = false; return ___cxa_throw($29498, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5590; break; } else { __label__ = 5587; break; }
    case 5587: // $29500
      var $29501=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29502=$29501.f0;
      HEAP32[(($2942)>>2)]=$29502;
      var $29503=$29501.f1;
      HEAP32[(($2943)>>2)]=$29503;
      var $29504=HEAP32[(($2943)>>2)];
      var $29505=(($29504)|0) < 0;
      if ($29505) { __label__ = 5588; break; } else { __label__ = 5589; break; }
    case 5588: // $29506
      var $29507=HEAP32[(($2942)>>2)];
      ___cxa_call_unexpected($29507);
      throw "Reached an unreachable!"
    case 5589: // $29508
      var $29509=HEAP32[(($2942)>>2)];
      var $29510=HEAP32[(($2942)>>2)];
      var $29511=HEAP32[(($2943)>>2)];
      var $29512=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29510, tempValue);
      var $29513=($29512.f1 = $29511, $29512);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5590: // $29514
      throw "Reached an unreachable!"
    case 5591: // $_ZnwjPKci_exit698
      var $29515=HEAP32[(($result_i697)>>2)];
      var $29516=$2939;
      var $29517=$2940;
      var $29518=$2941;
      var $29519=$result_i697;
      var $29520=$2942;
      var $29521=$2943;
      var $29522=$29515;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7485, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5592; break; } else { __label__ = 13426; break; }
    case 5592: // $29523
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7486, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5593; break; } else { __label__ = 13426; break; }
    case 5593: // $29524
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7487, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5594; break; } else { __label__ = 13426; break; }
    case 5594: // $29525
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5595; break; } else { __label__ = 13426; break; }
    case 5595: // $29526
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5596; break; } else { __label__ = 13426; break; }
    case 5596: // $29527
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5597; break; } else { __label__ = 13426; break; }
    case 5597: // $29528
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5598; break; } else { __label__ = 13426; break; }
    case 5598: // $29529
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7484, $7485, $7486, $7487, $7488, $7489, $7490, $7491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5599; break; } else { __label__ = 13426; break; }
    case 5599: // $29530
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29522, 14, 9, 0, ((STRING_TABLE.__str889)|0), ((STRING_TABLE.__str890)|0), $7484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5600; break; } else { __label__ = 13426; break; }
    case 5600: // $29531
      var $29532=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29522);
      var $29533=__ZN11simple_listI16input_type_entryE6appendERS0_($29483, $29532);
      var $29534=$4689;
      var $29535=$2934;
      var $29536=$2935;
      var $29537=$2936;
      var $29538=$result_i699;
      var $29539=$2937;
      var $29540=$2938;
      HEAP32[(($2934)>>2)]=408;
      HEAP32[(($2935)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2936)>>2)]=412;
      var $29541=HEAP32[(($2934)>>2)];
      var $29542=HEAP32[(($2935)>>2)];
      var $29543=HEAP32[(($2936)>>2)];
      var $29544=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29541, $29542, $29543) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5601; break; } else { __label__ = 5603; break; };
    case 5601: // $29545
      HEAP32[(($result_i699)>>2)]=$29544;
      var $29546=HEAP32[(($result_i699)>>2)];
      var $29547=(($29546)|0)==0;
      if ($29547) { __label__ = 5602; break; } else { __label__ = 5607; break; }
    case 5602: // $29548
      var $29549=___cxa_allocate_exception(4);
      var $29550=$29549;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29550);
      (function() { try { __THREW__ = false; return ___cxa_throw($29549, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5606; break; } else { __label__ = 5603; break; }
    case 5603: // $29551
      var $29552=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29553=$29552.f0;
      HEAP32[(($2937)>>2)]=$29553;
      var $29554=$29552.f1;
      HEAP32[(($2938)>>2)]=$29554;
      var $29555=HEAP32[(($2938)>>2)];
      var $29556=(($29555)|0) < 0;
      if ($29556) { __label__ = 5604; break; } else { __label__ = 5605; break; }
    case 5604: // $29557
      var $29558=HEAP32[(($2937)>>2)];
      ___cxa_call_unexpected($29558);
      throw "Reached an unreachable!"
    case 5605: // $29559
      var $29560=HEAP32[(($2937)>>2)];
      var $29561=HEAP32[(($2937)>>2)];
      var $29562=HEAP32[(($2938)>>2)];
      var $29563=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29561, tempValue);
      var $29564=($29563.f1 = $29562, $29563);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5606: // $29565
      throw "Reached an unreachable!"
    case 5607: // $_ZnwjPKci_exit700
      var $29566=HEAP32[(($result_i699)>>2)];
      var $29567=$2934;
      var $29568=$2935;
      var $29569=$2936;
      var $29570=$result_i699;
      var $29571=$2937;
      var $29572=$2938;
      var $29573=$29566;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7493, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5608; break; } else { __label__ = 13431; break; }
    case 5608: // $29574
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7494, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5609; break; } else { __label__ = 13431; break; }
    case 5609: // $29575
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7495, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5610; break; } else { __label__ = 13431; break; }
    case 5610: // $29576
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5611; break; } else { __label__ = 13431; break; }
    case 5611: // $29577
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5612; break; } else { __label__ = 13431; break; }
    case 5612: // $29578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5613; break; } else { __label__ = 13431; break; }
    case 5613: // $29579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5614; break; } else { __label__ = 13431; break; }
    case 5614: // $29580
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7492, $7493, $7494, $7495, $7496, $7497, $7498, $7499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5615; break; } else { __label__ = 13431; break; }
    case 5615: // $29581
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29573, 15, 9, 0, ((STRING_TABLE.__str891)|0), ((STRING_TABLE.__str892)|0), $7492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5616; break; } else { __label__ = 13431; break; }
    case 5616: // $29582
      var $29583=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29573);
      var $29584=__ZN11simple_listI16input_type_entryE6appendERS0_($29534, $29583);
      var $29585=$4689;
      var $29586=$2929;
      var $29587=$2930;
      var $29588=$2931;
      var $29589=$result_i701;
      var $29590=$2932;
      var $29591=$2933;
      HEAP32[(($2929)>>2)]=408;
      HEAP32[(($2930)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2931)>>2)]=413;
      var $29592=HEAP32[(($2929)>>2)];
      var $29593=HEAP32[(($2930)>>2)];
      var $29594=HEAP32[(($2931)>>2)];
      var $29595=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29592, $29593, $29594) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5617; break; } else { __label__ = 5619; break; };
    case 5617: // $29596
      HEAP32[(($result_i701)>>2)]=$29595;
      var $29597=HEAP32[(($result_i701)>>2)];
      var $29598=(($29597)|0)==0;
      if ($29598) { __label__ = 5618; break; } else { __label__ = 5623; break; }
    case 5618: // $29599
      var $29600=___cxa_allocate_exception(4);
      var $29601=$29600;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29601);
      (function() { try { __THREW__ = false; return ___cxa_throw($29600, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5622; break; } else { __label__ = 5619; break; }
    case 5619: // $29602
      var $29603=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29604=$29603.f0;
      HEAP32[(($2932)>>2)]=$29604;
      var $29605=$29603.f1;
      HEAP32[(($2933)>>2)]=$29605;
      var $29606=HEAP32[(($2933)>>2)];
      var $29607=(($29606)|0) < 0;
      if ($29607) { __label__ = 5620; break; } else { __label__ = 5621; break; }
    case 5620: // $29608
      var $29609=HEAP32[(($2932)>>2)];
      ___cxa_call_unexpected($29609);
      throw "Reached an unreachable!"
    case 5621: // $29610
      var $29611=HEAP32[(($2932)>>2)];
      var $29612=HEAP32[(($2932)>>2)];
      var $29613=HEAP32[(($2933)>>2)];
      var $29614=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29612, tempValue);
      var $29615=($29614.f1 = $29613, $29614);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5622: // $29616
      throw "Reached an unreachable!"
    case 5623: // $_ZnwjPKci_exit702
      var $29617=HEAP32[(($result_i701)>>2)];
      var $29618=$2929;
      var $29619=$2930;
      var $29620=$2931;
      var $29621=$result_i701;
      var $29622=$2932;
      var $29623=$2933;
      var $29624=$29617;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7501, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5624; break; } else { __label__ = 13436; break; }
    case 5624: // $29625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7502, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5625; break; } else { __label__ = 13436; break; }
    case 5625: // $29626
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7503, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5626; break; } else { __label__ = 13436; break; }
    case 5626: // $29627
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7504, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5627; break; } else { __label__ = 13436; break; }
    case 5627: // $29628
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7505, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5628; break; } else { __label__ = 13436; break; }
    case 5628: // $29629
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5629; break; } else { __label__ = 13436; break; }
    case 5629: // $29630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5630; break; } else { __label__ = 13436; break; }
    case 5630: // $29631
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7500, $7501, $7502, $7503, $7504, $7505, $7506, $7507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5631; break; } else { __label__ = 13436; break; }
    case 5631: // $29632
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29624, 16, 9, 0, ((STRING_TABLE.__str893)|0), ((STRING_TABLE.__str894)|0), $7500) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5632; break; } else { __label__ = 13436; break; }
    case 5632: // $29633
      var $29634=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29624);
      var $29635=__ZN11simple_listI16input_type_entryE6appendERS0_($29585, $29634);
      var $29636=$4689;
      var $29637=$2924;
      var $29638=$2925;
      var $29639=$2926;
      var $29640=$result_i703;
      var $29641=$2927;
      var $29642=$2928;
      HEAP32[(($2924)>>2)]=408;
      HEAP32[(($2925)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2926)>>2)]=415;
      var $29643=HEAP32[(($2924)>>2)];
      var $29644=HEAP32[(($2925)>>2)];
      var $29645=HEAP32[(($2926)>>2)];
      var $29646=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29643, $29644, $29645) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5633; break; } else { __label__ = 5635; break; };
    case 5633: // $29647
      HEAP32[(($result_i703)>>2)]=$29646;
      var $29648=HEAP32[(($result_i703)>>2)];
      var $29649=(($29648)|0)==0;
      if ($29649) { __label__ = 5634; break; } else { __label__ = 5639; break; }
    case 5634: // $29650
      var $29651=___cxa_allocate_exception(4);
      var $29652=$29651;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29652);
      (function() { try { __THREW__ = false; return ___cxa_throw($29651, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5638; break; } else { __label__ = 5635; break; }
    case 5635: // $29653
      var $29654=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29655=$29654.f0;
      HEAP32[(($2927)>>2)]=$29655;
      var $29656=$29654.f1;
      HEAP32[(($2928)>>2)]=$29656;
      var $29657=HEAP32[(($2928)>>2)];
      var $29658=(($29657)|0) < 0;
      if ($29658) { __label__ = 5636; break; } else { __label__ = 5637; break; }
    case 5636: // $29659
      var $29660=HEAP32[(($2927)>>2)];
      ___cxa_call_unexpected($29660);
      throw "Reached an unreachable!"
    case 5637: // $29661
      var $29662=HEAP32[(($2927)>>2)];
      var $29663=HEAP32[(($2927)>>2)];
      var $29664=HEAP32[(($2928)>>2)];
      var $29665=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29663, tempValue);
      var $29666=($29665.f1 = $29664, $29665);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5638: // $29667
      throw "Reached an unreachable!"
    case 5639: // $_ZnwjPKci_exit704
      var $29668=HEAP32[(($result_i703)>>2)];
      var $29669=$2924;
      var $29670=$2925;
      var $29671=$2926;
      var $29672=$result_i703;
      var $29673=$2927;
      var $29674=$2928;
      var $29675=$29668;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7509, 1, 0, 1, 0, 32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5640; break; } else { __label__ = 13441; break; }
    case 5640: // $29676
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7510, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5641; break; } else { __label__ = 13441; break; }
    case 5641: // $29677
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7511, 4, 0, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5642; break; } else { __label__ = 13441; break; }
    case 5642: // $29678
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5643; break; } else { __label__ = 13441; break; }
    case 5643: // $29679
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5644; break; } else { __label__ = 13441; break; }
    case 5644: // $29680
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5645; break; } else { __label__ = 13441; break; }
    case 5645: // $29681
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5646; break; } else { __label__ = 13441; break; }
    case 5646: // $29682
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7508, $7509, $7510, $7511, $7512, $7513, $7514, $7515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5647; break; } else { __label__ = 13441; break; }
    case 5647: // $29683
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29675, 17, 9, 0, ((STRING_TABLE.__str895)|0), ((STRING_TABLE.__str896)|0), $7508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5648; break; } else { __label__ = 13441; break; }
    case 5648: // $29684
      var $29685=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29675);
      var $29686=__ZN11simple_listI16input_type_entryE6appendERS0_($29636, $29685);
      var $29687=$4689;
      var $29688=$2919;
      var $29689=$2920;
      var $29690=$2921;
      var $29691=$result_i705;
      var $29692=$2922;
      var $29693=$2923;
      HEAP32[(($2919)>>2)]=408;
      HEAP32[(($2920)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2921)>>2)]=416;
      var $29694=HEAP32[(($2919)>>2)];
      var $29695=HEAP32[(($2920)>>2)];
      var $29696=HEAP32[(($2921)>>2)];
      var $29697=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29694, $29695, $29696) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5649; break; } else { __label__ = 5651; break; };
    case 5649: // $29698
      HEAP32[(($result_i705)>>2)]=$29697;
      var $29699=HEAP32[(($result_i705)>>2)];
      var $29700=(($29699)|0)==0;
      if ($29700) { __label__ = 5650; break; } else { __label__ = 5655; break; }
    case 5650: // $29701
      var $29702=___cxa_allocate_exception(4);
      var $29703=$29702;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29703);
      (function() { try { __THREW__ = false; return ___cxa_throw($29702, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5654; break; } else { __label__ = 5651; break; }
    case 5651: // $29704
      var $29705=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29706=$29705.f0;
      HEAP32[(($2922)>>2)]=$29706;
      var $29707=$29705.f1;
      HEAP32[(($2923)>>2)]=$29707;
      var $29708=HEAP32[(($2923)>>2)];
      var $29709=(($29708)|0) < 0;
      if ($29709) { __label__ = 5652; break; } else { __label__ = 5653; break; }
    case 5652: // $29710
      var $29711=HEAP32[(($2922)>>2)];
      ___cxa_call_unexpected($29711);
      throw "Reached an unreachable!"
    case 5653: // $29712
      var $29713=HEAP32[(($2922)>>2)];
      var $29714=HEAP32[(($2922)>>2)];
      var $29715=HEAP32[(($2923)>>2)];
      var $29716=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29714, tempValue);
      var $29717=($29716.f1 = $29715, $29716);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5654: // $29718
      throw "Reached an unreachable!"
    case 5655: // $_ZnwjPKci_exit706
      var $29719=HEAP32[(($result_i705)>>2)];
      var $29720=$2919;
      var $29721=$2920;
      var $29722=$2921;
      var $29723=$result_i705;
      var $29724=$2922;
      var $29725=$2923;
      var $29726=$29719;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7517, 1, 0, 1, 0, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5656; break; } else { __label__ = 13446; break; }
    case 5656: // $29727
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7518, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5657; break; } else { __label__ = 13446; break; }
    case 5657: // $29728
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7519, 4, 1, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5658; break; } else { __label__ = 13446; break; }
    case 5658: // $29729
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5659; break; } else { __label__ = 13446; break; }
    case 5659: // $29730
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5660; break; } else { __label__ = 13446; break; }
    case 5660: // $29731
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5661; break; } else { __label__ = 13446; break; }
    case 5661: // $29732
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5662; break; } else { __label__ = 13446; break; }
    case 5662: // $29733
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7516, $7517, $7518, $7519, $7520, $7521, $7522, $7523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5663; break; } else { __label__ = 13446; break; }
    case 5663: // $29734
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29726, 18, 9, 0, ((STRING_TABLE.__str897)|0), ((STRING_TABLE.__str898)|0), $7516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5664; break; } else { __label__ = 13446; break; }
    case 5664: // $29735
      var $29736=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29726);
      var $29737=__ZN11simple_listI16input_type_entryE6appendERS0_($29687, $29736);
      var $29738=$4689;
      var $29739=$2914;
      var $29740=$2915;
      var $29741=$2916;
      var $29742=$result_i707;
      var $29743=$2917;
      var $29744=$2918;
      HEAP32[(($2914)>>2)]=408;
      HEAP32[(($2915)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2916)>>2)]=417;
      var $29745=HEAP32[(($2914)>>2)];
      var $29746=HEAP32[(($2915)>>2)];
      var $29747=HEAP32[(($2916)>>2)];
      var $29748=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29745, $29746, $29747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5665; break; } else { __label__ = 5667; break; };
    case 5665: // $29749
      HEAP32[(($result_i707)>>2)]=$29748;
      var $29750=HEAP32[(($result_i707)>>2)];
      var $29751=(($29750)|0)==0;
      if ($29751) { __label__ = 5666; break; } else { __label__ = 5671; break; }
    case 5666: // $29752
      var $29753=___cxa_allocate_exception(4);
      var $29754=$29753;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29754);
      (function() { try { __THREW__ = false; return ___cxa_throw($29753, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5670; break; } else { __label__ = 5667; break; }
    case 5667: // $29755
      var $29756=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29757=$29756.f0;
      HEAP32[(($2917)>>2)]=$29757;
      var $29758=$29756.f1;
      HEAP32[(($2918)>>2)]=$29758;
      var $29759=HEAP32[(($2918)>>2)];
      var $29760=(($29759)|0) < 0;
      if ($29760) { __label__ = 5668; break; } else { __label__ = 5669; break; }
    case 5668: // $29761
      var $29762=HEAP32[(($2917)>>2)];
      ___cxa_call_unexpected($29762);
      throw "Reached an unreachable!"
    case 5669: // $29763
      var $29764=HEAP32[(($2917)>>2)];
      var $29765=HEAP32[(($2917)>>2)];
      var $29766=HEAP32[(($2918)>>2)];
      var $29767=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29765, tempValue);
      var $29768=($29767.f1 = $29766, $29767);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5670: // $29769
      throw "Reached an unreachable!"
    case 5671: // $_ZnwjPKci_exit708
      var $29770=HEAP32[(($result_i707)>>2)];
      var $29771=$2914;
      var $29772=$2915;
      var $29773=$2916;
      var $29774=$result_i707;
      var $29775=$2917;
      var $29776=$2918;
      var $29777=$29770;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7525, 1, 0, 1, 0, 34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5672; break; } else { __label__ = 13451; break; }
    case 5672: // $29778
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7526, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5673; break; } else { __label__ = 13451; break; }
    case 5673: // $29779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7527, 4, 2, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5674; break; } else { __label__ = 13451; break; }
    case 5674: // $29780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7528, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5675; break; } else { __label__ = 13451; break; }
    case 5675: // $29781
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7529, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5676; break; } else { __label__ = 13451; break; }
    case 5676: // $29782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5677; break; } else { __label__ = 13451; break; }
    case 5677: // $29783
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5678; break; } else { __label__ = 13451; break; }
    case 5678: // $29784
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7524, $7525, $7526, $7527, $7528, $7529, $7530, $7531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5679; break; } else { __label__ = 13451; break; }
    case 5679: // $29785
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29777, 19, 9, 0, ((STRING_TABLE.__str899)|0), ((STRING_TABLE.__str900)|0), $7524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5680; break; } else { __label__ = 13451; break; }
    case 5680: // $29786
      var $29787=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29777);
      var $29788=__ZN11simple_listI16input_type_entryE6appendERS0_($29738, $29787);
      var $29789=$4689;
      var $29790=$2909;
      var $29791=$2910;
      var $29792=$2911;
      var $29793=$result_i709;
      var $29794=$2912;
      var $29795=$2913;
      HEAP32[(($2909)>>2)]=408;
      HEAP32[(($2910)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2911)>>2)]=418;
      var $29796=HEAP32[(($2909)>>2)];
      var $29797=HEAP32[(($2910)>>2)];
      var $29798=HEAP32[(($2911)>>2)];
      var $29799=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29796, $29797, $29798) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5681; break; } else { __label__ = 5683; break; };
    case 5681: // $29800
      HEAP32[(($result_i709)>>2)]=$29799;
      var $29801=HEAP32[(($result_i709)>>2)];
      var $29802=(($29801)|0)==0;
      if ($29802) { __label__ = 5682; break; } else { __label__ = 5687; break; }
    case 5682: // $29803
      var $29804=___cxa_allocate_exception(4);
      var $29805=$29804;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29805);
      (function() { try { __THREW__ = false; return ___cxa_throw($29804, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5686; break; } else { __label__ = 5683; break; }
    case 5683: // $29806
      var $29807=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29808=$29807.f0;
      HEAP32[(($2912)>>2)]=$29808;
      var $29809=$29807.f1;
      HEAP32[(($2913)>>2)]=$29809;
      var $29810=HEAP32[(($2913)>>2)];
      var $29811=(($29810)|0) < 0;
      if ($29811) { __label__ = 5684; break; } else { __label__ = 5685; break; }
    case 5684: // $29812
      var $29813=HEAP32[(($2912)>>2)];
      ___cxa_call_unexpected($29813);
      throw "Reached an unreachable!"
    case 5685: // $29814
      var $29815=HEAP32[(($2912)>>2)];
      var $29816=HEAP32[(($2912)>>2)];
      var $29817=HEAP32[(($2913)>>2)];
      var $29818=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29816, tempValue);
      var $29819=($29818.f1 = $29817, $29818);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5686: // $29820
      throw "Reached an unreachable!"
    case 5687: // $_ZnwjPKci_exit710
      var $29821=HEAP32[(($result_i709)>>2)];
      var $29822=$2909;
      var $29823=$2910;
      var $29824=$2911;
      var $29825=$result_i709;
      var $29826=$2912;
      var $29827=$2913;
      var $29828=$29821;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7533, 1, 0, 1, 0, 35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5688; break; } else { __label__ = 13456; break; }
    case 5688: // $29829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7534, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5689; break; } else { __label__ = 13456; break; }
    case 5689: // $29830
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7535, 4, 3, 1, 0, 135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5690; break; } else { __label__ = 13456; break; }
    case 5690: // $29831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5691; break; } else { __label__ = 13456; break; }
    case 5691: // $29832
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5692; break; } else { __label__ = 13456; break; }
    case 5692: // $29833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5693; break; } else { __label__ = 13456; break; }
    case 5693: // $29834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5694; break; } else { __label__ = 13456; break; }
    case 5694: // $29835
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7532, $7533, $7534, $7535, $7536, $7537, $7538, $7539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5695; break; } else { __label__ = 13456; break; }
    case 5695: // $29836
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29828, 20, 9, 0, ((STRING_TABLE.__str901)|0), ((STRING_TABLE.__str902)|0), $7532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5696; break; } else { __label__ = 13456; break; }
    case 5696: // $29837
      var $29838=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29828);
      var $29839=__ZN11simple_listI16input_type_entryE6appendERS0_($29789, $29838);
      var $29840=$4689;
      var $29841=$2904;
      var $29842=$2905;
      var $29843=$2906;
      var $29844=$result_i711;
      var $29845=$2907;
      var $29846=$2908;
      HEAP32[(($2904)>>2)]=408;
      HEAP32[(($2905)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2906)>>2)]=419;
      var $29847=HEAP32[(($2904)>>2)];
      var $29848=HEAP32[(($2905)>>2)];
      var $29849=HEAP32[(($2906)>>2)];
      var $29850=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29847, $29848, $29849) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5697; break; } else { __label__ = 5699; break; };
    case 5697: // $29851
      HEAP32[(($result_i711)>>2)]=$29850;
      var $29852=HEAP32[(($result_i711)>>2)];
      var $29853=(($29852)|0)==0;
      if ($29853) { __label__ = 5698; break; } else { __label__ = 5703; break; }
    case 5698: // $29854
      var $29855=___cxa_allocate_exception(4);
      var $29856=$29855;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29856);
      (function() { try { __THREW__ = false; return ___cxa_throw($29855, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5702; break; } else { __label__ = 5699; break; }
    case 5699: // $29857
      var $29858=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29859=$29858.f0;
      HEAP32[(($2907)>>2)]=$29859;
      var $29860=$29858.f1;
      HEAP32[(($2908)>>2)]=$29860;
      var $29861=HEAP32[(($2908)>>2)];
      var $29862=(($29861)|0) < 0;
      if ($29862) { __label__ = 5700; break; } else { __label__ = 5701; break; }
    case 5700: // $29863
      var $29864=HEAP32[(($2907)>>2)];
      ___cxa_call_unexpected($29864);
      throw "Reached an unreachable!"
    case 5701: // $29865
      var $29866=HEAP32[(($2907)>>2)];
      var $29867=HEAP32[(($2907)>>2)];
      var $29868=HEAP32[(($2908)>>2)];
      var $29869=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29867, tempValue);
      var $29870=($29869.f1 = $29868, $29869);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5702: // $29871
      throw "Reached an unreachable!"
    case 5703: // $_ZnwjPKci_exit712
      var $29872=HEAP32[(($result_i711)>>2)];
      var $29873=$2904;
      var $29874=$2905;
      var $29875=$2906;
      var $29876=$result_i711;
      var $29877=$2907;
      var $29878=$2908;
      var $29879=$29872;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7541, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5704; break; } else { __label__ = 13461; break; }
    case 5704: // $29880
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7542, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5705; break; } else { __label__ = 13461; break; }
    case 5705: // $29881
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7543, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5706; break; } else { __label__ = 13461; break; }
    case 5706: // $29882
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5707; break; } else { __label__ = 13461; break; }
    case 5707: // $29883
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5708; break; } else { __label__ = 13461; break; }
    case 5708: // $29884
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5709; break; } else { __label__ = 13461; break; }
    case 5709: // $29885
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5710; break; } else { __label__ = 13461; break; }
    case 5710: // $29886
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7540, $7541, $7542, $7543, $7544, $7545, $7546, $7547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5711; break; } else { __label__ = 13461; break; }
    case 5711: // $29887
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29879, 21, 9, 0, ((STRING_TABLE.__str903)|0), ((STRING_TABLE.__str904)|0), $7540) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5712; break; } else { __label__ = 13461; break; }
    case 5712: // $29888
      var $29889=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29879);
      var $29890=__ZN11simple_listI16input_type_entryE6appendERS0_($29840, $29889);
      var $29891=$4689;
      var $29892=$2899;
      var $29893=$2900;
      var $29894=$2901;
      var $29895=$result_i713;
      var $29896=$2902;
      var $29897=$2903;
      HEAP32[(($2899)>>2)]=408;
      HEAP32[(($2900)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2901)>>2)]=420;
      var $29898=HEAP32[(($2899)>>2)];
      var $29899=HEAP32[(($2900)>>2)];
      var $29900=HEAP32[(($2901)>>2)];
      var $29901=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29898, $29899, $29900) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5713; break; } else { __label__ = 5715; break; };
    case 5713: // $29902
      HEAP32[(($result_i713)>>2)]=$29901;
      var $29903=HEAP32[(($result_i713)>>2)];
      var $29904=(($29903)|0)==0;
      if ($29904) { __label__ = 5714; break; } else { __label__ = 5719; break; }
    case 5714: // $29905
      var $29906=___cxa_allocate_exception(4);
      var $29907=$29906;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29907);
      (function() { try { __THREW__ = false; return ___cxa_throw($29906, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5718; break; } else { __label__ = 5715; break; }
    case 5715: // $29908
      var $29909=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29910=$29909.f0;
      HEAP32[(($2902)>>2)]=$29910;
      var $29911=$29909.f1;
      HEAP32[(($2903)>>2)]=$29911;
      var $29912=HEAP32[(($2903)>>2)];
      var $29913=(($29912)|0) < 0;
      if ($29913) { __label__ = 5716; break; } else { __label__ = 5717; break; }
    case 5716: // $29914
      var $29915=HEAP32[(($2902)>>2)];
      ___cxa_call_unexpected($29915);
      throw "Reached an unreachable!"
    case 5717: // $29916
      var $29917=HEAP32[(($2902)>>2)];
      var $29918=HEAP32[(($2902)>>2)];
      var $29919=HEAP32[(($2903)>>2)];
      var $29920=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29918, tempValue);
      var $29921=($29920.f1 = $29919, $29920);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5718: // $29922
      throw "Reached an unreachable!"
    case 5719: // $_ZnwjPKci_exit714
      var $29923=HEAP32[(($result_i713)>>2)];
      var $29924=$2899;
      var $29925=$2900;
      var $29926=$2901;
      var $29927=$result_i713;
      var $29928=$2902;
      var $29929=$2903;
      var $29930=$29923;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7549, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5720; break; } else { __label__ = 13466; break; }
    case 5720: // $29931
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7550, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5721; break; } else { __label__ = 13466; break; }
    case 5721: // $29932
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7551, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5722; break; } else { __label__ = 13466; break; }
    case 5722: // $29933
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7552, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5723; break; } else { __label__ = 13466; break; }
    case 5723: // $29934
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7553, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5724; break; } else { __label__ = 13466; break; }
    case 5724: // $29935
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7554, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5725; break; } else { __label__ = 13466; break; }
    case 5725: // $29936
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7555, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5726; break; } else { __label__ = 13466; break; }
    case 5726: // $29937
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7548, $7549, $7550, $7551, $7552, $7553, $7554, $7555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5727; break; } else { __label__ = 13466; break; }
    case 5727: // $29938
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29930, 22, 9, 0, ((STRING_TABLE.__str905)|0), ((STRING_TABLE.__str906)|0), $7548) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5728; break; } else { __label__ = 13466; break; }
    case 5728: // $29939
      var $29940=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29930);
      var $29941=__ZN11simple_listI16input_type_entryE6appendERS0_($29891, $29940);
      var $29942=$4689;
      var $29943=$2894;
      var $29944=$2895;
      var $29945=$2896;
      var $29946=$result_i715;
      var $29947=$2897;
      var $29948=$2898;
      HEAP32[(($2894)>>2)]=408;
      HEAP32[(($2895)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2896)>>2)]=421;
      var $29949=HEAP32[(($2894)>>2)];
      var $29950=HEAP32[(($2895)>>2)];
      var $29951=HEAP32[(($2896)>>2)];
      var $29952=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29949, $29950, $29951) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5729; break; } else { __label__ = 5731; break; };
    case 5729: // $29953
      HEAP32[(($result_i715)>>2)]=$29952;
      var $29954=HEAP32[(($result_i715)>>2)];
      var $29955=(($29954)|0)==0;
      if ($29955) { __label__ = 5730; break; } else { __label__ = 5735; break; }
    case 5730: // $29956
      var $29957=___cxa_allocate_exception(4);
      var $29958=$29957;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29958);
      (function() { try { __THREW__ = false; return ___cxa_throw($29957, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5734; break; } else { __label__ = 5731; break; }
    case 5731: // $29959
      var $29960=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29961=$29960.f0;
      HEAP32[(($2897)>>2)]=$29961;
      var $29962=$29960.f1;
      HEAP32[(($2898)>>2)]=$29962;
      var $29963=HEAP32[(($2898)>>2)];
      var $29964=(($29963)|0) < 0;
      if ($29964) { __label__ = 5732; break; } else { __label__ = 5733; break; }
    case 5732: // $29965
      var $29966=HEAP32[(($2897)>>2)];
      ___cxa_call_unexpected($29966);
      throw "Reached an unreachable!"
    case 5733: // $29967
      var $29968=HEAP32[(($2897)>>2)];
      var $29969=HEAP32[(($2897)>>2)];
      var $29970=HEAP32[(($2898)>>2)];
      var $29971=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29969, tempValue);
      var $29972=($29971.f1 = $29970, $29971);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5734: // $29973
      throw "Reached an unreachable!"
    case 5735: // $_ZnwjPKci_exit716
      var $29974=HEAP32[(($result_i715)>>2)];
      var $29975=$2894;
      var $29976=$2895;
      var $29977=$2896;
      var $29978=$result_i715;
      var $29979=$2897;
      var $29980=$2898;
      var $29981=$29974;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7557, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5736; break; } else { __label__ = 13471; break; }
    case 5736: // $29982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7558, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5737; break; } else { __label__ = 13471; break; }
    case 5737: // $29983
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7559, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5738; break; } else { __label__ = 13471; break; }
    case 5738: // $29984
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7560, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5739; break; } else { __label__ = 13471; break; }
    case 5739: // $29985
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7561, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5740; break; } else { __label__ = 13471; break; }
    case 5740: // $29986
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7562, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5741; break; } else { __label__ = 13471; break; }
    case 5741: // $29987
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7563, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5742; break; } else { __label__ = 13471; break; }
    case 5742: // $29988
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7556, $7557, $7558, $7559, $7560, $7561, $7562, $7563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5743; break; } else { __label__ = 13471; break; }
    case 5743: // $29989
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($29981, 23, 9, 0, ((STRING_TABLE.__str907)|0), ((STRING_TABLE.__str908)|0), $7556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5744; break; } else { __label__ = 13471; break; }
    case 5744: // $29990
      var $29991=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $29981);
      var $29992=__ZN11simple_listI16input_type_entryE6appendERS0_($29942, $29991);
      var $29993=$4689;
      var $29994=$2889;
      var $29995=$2890;
      var $29996=$2891;
      var $29997=$result_i717;
      var $29998=$2892;
      var $29999=$2893;
      HEAP32[(($2889)>>2)]=408;
      HEAP32[(($2890)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2891)>>2)]=422;
      var $30000=HEAP32[(($2889)>>2)];
      var $30001=HEAP32[(($2890)>>2)];
      var $30002=HEAP32[(($2891)>>2)];
      var $30003=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30000, $30001, $30002) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5745; break; } else { __label__ = 5747; break; };
    case 5745: // $30004
      HEAP32[(($result_i717)>>2)]=$30003;
      var $30005=HEAP32[(($result_i717)>>2)];
      var $30006=(($30005)|0)==0;
      if ($30006) { __label__ = 5746; break; } else { __label__ = 5751; break; }
    case 5746: // $30007
      var $30008=___cxa_allocate_exception(4);
      var $30009=$30008;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30009);
      (function() { try { __THREW__ = false; return ___cxa_throw($30008, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5750; break; } else { __label__ = 5747; break; }
    case 5747: // $30010
      var $30011=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30012=$30011.f0;
      HEAP32[(($2892)>>2)]=$30012;
      var $30013=$30011.f1;
      HEAP32[(($2893)>>2)]=$30013;
      var $30014=HEAP32[(($2893)>>2)];
      var $30015=(($30014)|0) < 0;
      if ($30015) { __label__ = 5748; break; } else { __label__ = 5749; break; }
    case 5748: // $30016
      var $30017=HEAP32[(($2892)>>2)];
      ___cxa_call_unexpected($30017);
      throw "Reached an unreachable!"
    case 5749: // $30018
      var $30019=HEAP32[(($2892)>>2)];
      var $30020=HEAP32[(($2892)>>2)];
      var $30021=HEAP32[(($2893)>>2)];
      var $30022=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30020, tempValue);
      var $30023=($30022.f1 = $30021, $30022);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5750: // $30024
      throw "Reached an unreachable!"
    case 5751: // $_ZnwjPKci_exit718
      var $30025=HEAP32[(($result_i717)>>2)];
      var $30026=$2889;
      var $30027=$2890;
      var $30028=$2891;
      var $30029=$result_i717;
      var $30030=$2892;
      var $30031=$2893;
      var $30032=$30025;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7565, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5752; break; } else { __label__ = 13476; break; }
    case 5752: // $30033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7566, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5753; break; } else { __label__ = 13476; break; }
    case 5753: // $30034
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7567, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5754; break; } else { __label__ = 13476; break; }
    case 5754: // $30035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7568, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5755; break; } else { __label__ = 13476; break; }
    case 5755: // $30036
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7569, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5756; break; } else { __label__ = 13476; break; }
    case 5756: // $30037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5757; break; } else { __label__ = 13476; break; }
    case 5757: // $30038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5758; break; } else { __label__ = 13476; break; }
    case 5758: // $30039
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7564, $7565, $7566, $7567, $7568, $7569, $7570, $7571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5759; break; } else { __label__ = 13476; break; }
    case 5759: // $30040
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30032, 24, 9, 0, ((STRING_TABLE.__str909)|0), ((STRING_TABLE.__str910)|0), $7564) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5760; break; } else { __label__ = 13476; break; }
    case 5760: // $30041
      var $30042=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30032);
      var $30043=__ZN11simple_listI16input_type_entryE6appendERS0_($29993, $30042);
      var $30044=$4689;
      var $30045=$2884;
      var $30046=$2885;
      var $30047=$2886;
      var $30048=$result_i719;
      var $30049=$2887;
      var $30050=$2888;
      HEAP32[(($2884)>>2)]=408;
      HEAP32[(($2885)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2886)>>2)]=423;
      var $30051=HEAP32[(($2884)>>2)];
      var $30052=HEAP32[(($2885)>>2)];
      var $30053=HEAP32[(($2886)>>2)];
      var $30054=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30051, $30052, $30053) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5761; break; } else { __label__ = 5763; break; };
    case 5761: // $30055
      HEAP32[(($result_i719)>>2)]=$30054;
      var $30056=HEAP32[(($result_i719)>>2)];
      var $30057=(($30056)|0)==0;
      if ($30057) { __label__ = 5762; break; } else { __label__ = 5767; break; }
    case 5762: // $30058
      var $30059=___cxa_allocate_exception(4);
      var $30060=$30059;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30060);
      (function() { try { __THREW__ = false; return ___cxa_throw($30059, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5766; break; } else { __label__ = 5763; break; }
    case 5763: // $30061
      var $30062=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30063=$30062.f0;
      HEAP32[(($2887)>>2)]=$30063;
      var $30064=$30062.f1;
      HEAP32[(($2888)>>2)]=$30064;
      var $30065=HEAP32[(($2888)>>2)];
      var $30066=(($30065)|0) < 0;
      if ($30066) { __label__ = 5764; break; } else { __label__ = 5765; break; }
    case 5764: // $30067
      var $30068=HEAP32[(($2887)>>2)];
      ___cxa_call_unexpected($30068);
      throw "Reached an unreachable!"
    case 5765: // $30069
      var $30070=HEAP32[(($2887)>>2)];
      var $30071=HEAP32[(($2887)>>2)];
      var $30072=HEAP32[(($2888)>>2)];
      var $30073=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30071, tempValue);
      var $30074=($30073.f1 = $30072, $30073);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5766: // $30075
      throw "Reached an unreachable!"
    case 5767: // $_ZnwjPKci_exit720
      var $30076=HEAP32[(($result_i719)>>2)];
      var $30077=$2884;
      var $30078=$2885;
      var $30079=$2886;
      var $30080=$result_i719;
      var $30081=$2887;
      var $30082=$2888;
      var $30083=$30076;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7573, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5768; break; } else { __label__ = 13481; break; }
    case 5768: // $30084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7574, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5769; break; } else { __label__ = 13481; break; }
    case 5769: // $30085
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7575, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5770; break; } else { __label__ = 13481; break; }
    case 5770: // $30086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7576, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5771; break; } else { __label__ = 13481; break; }
    case 5771: // $30087
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7577, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5772; break; } else { __label__ = 13481; break; }
    case 5772: // $30088
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5773; break; } else { __label__ = 13481; break; }
    case 5773: // $30089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5774; break; } else { __label__ = 13481; break; }
    case 5774: // $30090
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7572, $7573, $7574, $7575, $7576, $7577, $7578, $7579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5775; break; } else { __label__ = 13481; break; }
    case 5775: // $30091
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30083, 25, 9, 0, ((STRING_TABLE.__str911)|0), ((STRING_TABLE.__str912)|0), $7572) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5776; break; } else { __label__ = 13481; break; }
    case 5776: // $30092
      var $30093=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30083);
      var $30094=__ZN11simple_listI16input_type_entryE6appendERS0_($30044, $30093);
      var $30095=$4689;
      var $30096=$2879;
      var $30097=$2880;
      var $30098=$2881;
      var $30099=$result_i721;
      var $30100=$2882;
      var $30101=$2883;
      HEAP32[(($2879)>>2)]=408;
      HEAP32[(($2880)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2881)>>2)]=424;
      var $30102=HEAP32[(($2879)>>2)];
      var $30103=HEAP32[(($2880)>>2)];
      var $30104=HEAP32[(($2881)>>2)];
      var $30105=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30102, $30103, $30104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5777; break; } else { __label__ = 5779; break; };
    case 5777: // $30106
      HEAP32[(($result_i721)>>2)]=$30105;
      var $30107=HEAP32[(($result_i721)>>2)];
      var $30108=(($30107)|0)==0;
      if ($30108) { __label__ = 5778; break; } else { __label__ = 5783; break; }
    case 5778: // $30109
      var $30110=___cxa_allocate_exception(4);
      var $30111=$30110;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30111);
      (function() { try { __THREW__ = false; return ___cxa_throw($30110, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5782; break; } else { __label__ = 5779; break; }
    case 5779: // $30112
      var $30113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30114=$30113.f0;
      HEAP32[(($2882)>>2)]=$30114;
      var $30115=$30113.f1;
      HEAP32[(($2883)>>2)]=$30115;
      var $30116=HEAP32[(($2883)>>2)];
      var $30117=(($30116)|0) < 0;
      if ($30117) { __label__ = 5780; break; } else { __label__ = 5781; break; }
    case 5780: // $30118
      var $30119=HEAP32[(($2882)>>2)];
      ___cxa_call_unexpected($30119);
      throw "Reached an unreachable!"
    case 5781: // $30120
      var $30121=HEAP32[(($2882)>>2)];
      var $30122=HEAP32[(($2882)>>2)];
      var $30123=HEAP32[(($2883)>>2)];
      var $30124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30122, tempValue);
      var $30125=($30124.f1 = $30123, $30124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5782: // $30126
      throw "Reached an unreachable!"
    case 5783: // $_ZnwjPKci_exit722
      var $30127=HEAP32[(($result_i721)>>2)];
      var $30128=$2879;
      var $30129=$2880;
      var $30130=$2881;
      var $30131=$result_i721;
      var $30132=$2882;
      var $30133=$2883;
      var $30134=$30127;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7581, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5784; break; } else { __label__ = 13486; break; }
    case 5784: // $30135
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7582, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5785; break; } else { __label__ = 13486; break; }
    case 5785: // $30136
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7583, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5786; break; } else { __label__ = 13486; break; }
    case 5786: // $30137
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5787; break; } else { __label__ = 13486; break; }
    case 5787: // $30138
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5788; break; } else { __label__ = 13486; break; }
    case 5788: // $30139
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5789; break; } else { __label__ = 13486; break; }
    case 5789: // $30140
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5790; break; } else { __label__ = 13486; break; }
    case 5790: // $30141
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7580, $7581, $7582, $7583, $7584, $7585, $7586, $7587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5791; break; } else { __label__ = 13486; break; }
    case 5791: // $30142
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30134, 26, 9, 0, ((STRING_TABLE.__str913)|0), ((STRING_TABLE.__str914)|0), $7580) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5792; break; } else { __label__ = 13486; break; }
    case 5792: // $30143
      var $30144=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30134);
      var $30145=__ZN11simple_listI16input_type_entryE6appendERS0_($30095, $30144);
      var $30146=$4689;
      var $30147=$2874;
      var $30148=$2875;
      var $30149=$2876;
      var $30150=$result_i723;
      var $30151=$2877;
      var $30152=$2878;
      HEAP32[(($2874)>>2)]=408;
      HEAP32[(($2875)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2876)>>2)]=425;
      var $30153=HEAP32[(($2874)>>2)];
      var $30154=HEAP32[(($2875)>>2)];
      var $30155=HEAP32[(($2876)>>2)];
      var $30156=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30153, $30154, $30155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5793; break; } else { __label__ = 5795; break; };
    case 5793: // $30157
      HEAP32[(($result_i723)>>2)]=$30156;
      var $30158=HEAP32[(($result_i723)>>2)];
      var $30159=(($30158)|0)==0;
      if ($30159) { __label__ = 5794; break; } else { __label__ = 5799; break; }
    case 5794: // $30160
      var $30161=___cxa_allocate_exception(4);
      var $30162=$30161;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30162);
      (function() { try { __THREW__ = false; return ___cxa_throw($30161, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5798; break; } else { __label__ = 5795; break; }
    case 5795: // $30163
      var $30164=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30165=$30164.f0;
      HEAP32[(($2877)>>2)]=$30165;
      var $30166=$30164.f1;
      HEAP32[(($2878)>>2)]=$30166;
      var $30167=HEAP32[(($2878)>>2)];
      var $30168=(($30167)|0) < 0;
      if ($30168) { __label__ = 5796; break; } else { __label__ = 5797; break; }
    case 5796: // $30169
      var $30170=HEAP32[(($2877)>>2)];
      ___cxa_call_unexpected($30170);
      throw "Reached an unreachable!"
    case 5797: // $30171
      var $30172=HEAP32[(($2877)>>2)];
      var $30173=HEAP32[(($2877)>>2)];
      var $30174=HEAP32[(($2878)>>2)];
      var $30175=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30173, tempValue);
      var $30176=($30175.f1 = $30174, $30175);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5798: // $30177
      throw "Reached an unreachable!"
    case 5799: // $_ZnwjPKci_exit724
      var $30178=HEAP32[(($result_i723)>>2)];
      var $30179=$2874;
      var $30180=$2875;
      var $30181=$2876;
      var $30182=$result_i723;
      var $30183=$2877;
      var $30184=$2878;
      var $30185=$30178;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7589, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5800; break; } else { __label__ = 13491; break; }
    case 5800: // $30186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7590, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5801; break; } else { __label__ = 13491; break; }
    case 5801: // $30187
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7591, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5802; break; } else { __label__ = 13491; break; }
    case 5802: // $30188
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5803; break; } else { __label__ = 13491; break; }
    case 5803: // $30189
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5804; break; } else { __label__ = 13491; break; }
    case 5804: // $30190
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5805; break; } else { __label__ = 13491; break; }
    case 5805: // $30191
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5806; break; } else { __label__ = 13491; break; }
    case 5806: // $30192
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7588, $7589, $7590, $7591, $7592, $7593, $7594, $7595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5807; break; } else { __label__ = 13491; break; }
    case 5807: // $30193
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30185, 27, 9, 0, ((STRING_TABLE.__str915)|0), ((STRING_TABLE.__str916)|0), $7588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5808; break; } else { __label__ = 13491; break; }
    case 5808: // $30194
      var $30195=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30185);
      var $30196=__ZN11simple_listI16input_type_entryE6appendERS0_($30146, $30195);
      var $30197=$4689;
      var $30198=$2869;
      var $30199=$2870;
      var $30200=$2871;
      var $30201=$result_i725;
      var $30202=$2872;
      var $30203=$2873;
      HEAP32[(($2869)>>2)]=408;
      HEAP32[(($2870)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2871)>>2)]=426;
      var $30204=HEAP32[(($2869)>>2)];
      var $30205=HEAP32[(($2870)>>2)];
      var $30206=HEAP32[(($2871)>>2)];
      var $30207=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30204, $30205, $30206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5809; break; } else { __label__ = 5811; break; };
    case 5809: // $30208
      HEAP32[(($result_i725)>>2)]=$30207;
      var $30209=HEAP32[(($result_i725)>>2)];
      var $30210=(($30209)|0)==0;
      if ($30210) { __label__ = 5810; break; } else { __label__ = 5815; break; }
    case 5810: // $30211
      var $30212=___cxa_allocate_exception(4);
      var $30213=$30212;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30213);
      (function() { try { __THREW__ = false; return ___cxa_throw($30212, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5814; break; } else { __label__ = 5811; break; }
    case 5811: // $30214
      var $30215=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30216=$30215.f0;
      HEAP32[(($2872)>>2)]=$30216;
      var $30217=$30215.f1;
      HEAP32[(($2873)>>2)]=$30217;
      var $30218=HEAP32[(($2873)>>2)];
      var $30219=(($30218)|0) < 0;
      if ($30219) { __label__ = 5812; break; } else { __label__ = 5813; break; }
    case 5812: // $30220
      var $30221=HEAP32[(($2872)>>2)];
      ___cxa_call_unexpected($30221);
      throw "Reached an unreachable!"
    case 5813: // $30222
      var $30223=HEAP32[(($2872)>>2)];
      var $30224=HEAP32[(($2872)>>2)];
      var $30225=HEAP32[(($2873)>>2)];
      var $30226=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30224, tempValue);
      var $30227=($30226.f1 = $30225, $30226);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5814: // $30228
      throw "Reached an unreachable!"
    case 5815: // $_ZnwjPKci_exit726
      var $30229=HEAP32[(($result_i725)>>2)];
      var $30230=$2869;
      var $30231=$2870;
      var $30232=$2871;
      var $30233=$result_i725;
      var $30234=$2872;
      var $30235=$2873;
      var $30236=$30229;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7597, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5816; break; } else { __label__ = 13496; break; }
    case 5816: // $30237
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7598, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5817; break; } else { __label__ = 13496; break; }
    case 5817: // $30238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7599, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5818; break; } else { __label__ = 13496; break; }
    case 5818: // $30239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7600, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5819; break; } else { __label__ = 13496; break; }
    case 5819: // $30240
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7601, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5820; break; } else { __label__ = 13496; break; }
    case 5820: // $30241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5821; break; } else { __label__ = 13496; break; }
    case 5821: // $30242
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5822; break; } else { __label__ = 13496; break; }
    case 5822: // $30243
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7596, $7597, $7598, $7599, $7600, $7601, $7602, $7603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5823; break; } else { __label__ = 13496; break; }
    case 5823: // $30244
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30236, 28, 9, 0, ((STRING_TABLE.__str917)|0), ((STRING_TABLE.__str918)|0), $7596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5824; break; } else { __label__ = 13496; break; }
    case 5824: // $30245
      var $30246=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30236);
      var $30247=__ZN11simple_listI16input_type_entryE6appendERS0_($30197, $30246);
      var $30248=$4689;
      var $30249=$2864;
      var $30250=$2865;
      var $30251=$2866;
      var $30252=$result_i727;
      var $30253=$2867;
      var $30254=$2868;
      HEAP32[(($2864)>>2)]=408;
      HEAP32[(($2865)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2866)>>2)]=427;
      var $30255=HEAP32[(($2864)>>2)];
      var $30256=HEAP32[(($2865)>>2)];
      var $30257=HEAP32[(($2866)>>2)];
      var $30258=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30255, $30256, $30257) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5825; break; } else { __label__ = 5827; break; };
    case 5825: // $30259
      HEAP32[(($result_i727)>>2)]=$30258;
      var $30260=HEAP32[(($result_i727)>>2)];
      var $30261=(($30260)|0)==0;
      if ($30261) { __label__ = 5826; break; } else { __label__ = 5831; break; }
    case 5826: // $30262
      var $30263=___cxa_allocate_exception(4);
      var $30264=$30263;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30264);
      (function() { try { __THREW__ = false; return ___cxa_throw($30263, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5830; break; } else { __label__ = 5827; break; }
    case 5827: // $30265
      var $30266=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30267=$30266.f0;
      HEAP32[(($2867)>>2)]=$30267;
      var $30268=$30266.f1;
      HEAP32[(($2868)>>2)]=$30268;
      var $30269=HEAP32[(($2868)>>2)];
      var $30270=(($30269)|0) < 0;
      if ($30270) { __label__ = 5828; break; } else { __label__ = 5829; break; }
    case 5828: // $30271
      var $30272=HEAP32[(($2867)>>2)];
      ___cxa_call_unexpected($30272);
      throw "Reached an unreachable!"
    case 5829: // $30273
      var $30274=HEAP32[(($2867)>>2)];
      var $30275=HEAP32[(($2867)>>2)];
      var $30276=HEAP32[(($2868)>>2)];
      var $30277=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30275, tempValue);
      var $30278=($30277.f1 = $30276, $30277);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5830: // $30279
      throw "Reached an unreachable!"
    case 5831: // $_ZnwjPKci_exit728
      var $30280=HEAP32[(($result_i727)>>2)];
      var $30281=$2864;
      var $30282=$2865;
      var $30283=$2866;
      var $30284=$result_i727;
      var $30285=$2867;
      var $30286=$2868;
      var $30287=$30280;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7605, 1, 0, 1, 0, 56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5832; break; } else { __label__ = 13501; break; }
    case 5832: // $30288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7606, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5833; break; } else { __label__ = 13501; break; }
    case 5833: // $30289
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7607, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5834; break; } else { __label__ = 13501; break; }
    case 5834: // $30290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5835; break; } else { __label__ = 13501; break; }
    case 5835: // $30291
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5836; break; } else { __label__ = 13501; break; }
    case 5836: // $30292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5837; break; } else { __label__ = 13501; break; }
    case 5837: // $30293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5838; break; } else { __label__ = 13501; break; }
    case 5838: // $30294
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7604, $7605, $7606, $7607, $7608, $7609, $7610, $7611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5839; break; } else { __label__ = 13501; break; }
    case 5839: // $30295
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30287, 29, 9, 0, ((STRING_TABLE.__str919)|0), ((STRING_TABLE.__str920419)|0), $7604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5840; break; } else { __label__ = 13501; break; }
    case 5840: // $30296
      var $30297=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30287);
      var $30298=__ZN11simple_listI16input_type_entryE6appendERS0_($30248, $30297);
      var $30299=$4689;
      var $30300=$2859;
      var $30301=$2860;
      var $30302=$2861;
      var $30303=$result_i729;
      var $30304=$2862;
      var $30305=$2863;
      HEAP32[(($2859)>>2)]=408;
      HEAP32[(($2860)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2861)>>2)]=429;
      var $30306=HEAP32[(($2859)>>2)];
      var $30307=HEAP32[(($2860)>>2)];
      var $30308=HEAP32[(($2861)>>2)];
      var $30309=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30306, $30307, $30308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5841; break; } else { __label__ = 5843; break; };
    case 5841: // $30310
      HEAP32[(($result_i729)>>2)]=$30309;
      var $30311=HEAP32[(($result_i729)>>2)];
      var $30312=(($30311)|0)==0;
      if ($30312) { __label__ = 5842; break; } else { __label__ = 5847; break; }
    case 5842: // $30313
      var $30314=___cxa_allocate_exception(4);
      var $30315=$30314;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30315);
      (function() { try { __THREW__ = false; return ___cxa_throw($30314, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5846; break; } else { __label__ = 5843; break; }
    case 5843: // $30316
      var $30317=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30318=$30317.f0;
      HEAP32[(($2862)>>2)]=$30318;
      var $30319=$30317.f1;
      HEAP32[(($2863)>>2)]=$30319;
      var $30320=HEAP32[(($2863)>>2)];
      var $30321=(($30320)|0) < 0;
      if ($30321) { __label__ = 5844; break; } else { __label__ = 5845; break; }
    case 5844: // $30322
      var $30323=HEAP32[(($2862)>>2)];
      ___cxa_call_unexpected($30323);
      throw "Reached an unreachable!"
    case 5845: // $30324
      var $30325=HEAP32[(($2862)>>2)];
      var $30326=HEAP32[(($2862)>>2)];
      var $30327=HEAP32[(($2863)>>2)];
      var $30328=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30326, tempValue);
      var $30329=($30328.f1 = $30327, $30328);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5846: // $30330
      throw "Reached an unreachable!"
    case 5847: // $_ZnwjPKci_exit730
      var $30331=HEAP32[(($result_i729)>>2)];
      var $30332=$2859;
      var $30333=$2860;
      var $30334=$2861;
      var $30335=$result_i729;
      var $30336=$2862;
      var $30337=$2863;
      var $30338=$30331;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7613, 1, 0, 1, 0, 36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5848; break; } else { __label__ = 13506; break; }
    case 5848: // $30339
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7614, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5849; break; } else { __label__ = 13506; break; }
    case 5849: // $30340
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7615, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5850; break; } else { __label__ = 13506; break; }
    case 5850: // $30341
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5851; break; } else { __label__ = 13506; break; }
    case 5851: // $30342
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5852; break; } else { __label__ = 13506; break; }
    case 5852: // $30343
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5853; break; } else { __label__ = 13506; break; }
    case 5853: // $30344
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5854; break; } else { __label__ = 13506; break; }
    case 5854: // $30345
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7612, $7613, $7614, $7615, $7616, $7617, $7618, $7619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5855; break; } else { __label__ = 13506; break; }
    case 5855: // $30346
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30338, 30, 9, 0, ((STRING_TABLE.__str921)|0), ((STRING_TABLE.__str922)|0), $7612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5856; break; } else { __label__ = 13506; break; }
    case 5856: // $30347
      var $30348=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30338);
      var $30349=__ZN11simple_listI16input_type_entryE6appendERS0_($30299, $30348);
      var $30350=$4689;
      var $30351=$2854;
      var $30352=$2855;
      var $30353=$2856;
      var $30354=$result_i731;
      var $30355=$2857;
      var $30356=$2858;
      HEAP32[(($2854)>>2)]=408;
      HEAP32[(($2855)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2856)>>2)]=430;
      var $30357=HEAP32[(($2854)>>2)];
      var $30358=HEAP32[(($2855)>>2)];
      var $30359=HEAP32[(($2856)>>2)];
      var $30360=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30357, $30358, $30359) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5857; break; } else { __label__ = 5859; break; };
    case 5857: // $30361
      HEAP32[(($result_i731)>>2)]=$30360;
      var $30362=HEAP32[(($result_i731)>>2)];
      var $30363=(($30362)|0)==0;
      if ($30363) { __label__ = 5858; break; } else { __label__ = 5863; break; }
    case 5858: // $30364
      var $30365=___cxa_allocate_exception(4);
      var $30366=$30365;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30366);
      (function() { try { __THREW__ = false; return ___cxa_throw($30365, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5862; break; } else { __label__ = 5859; break; }
    case 5859: // $30367
      var $30368=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30369=$30368.f0;
      HEAP32[(($2857)>>2)]=$30369;
      var $30370=$30368.f1;
      HEAP32[(($2858)>>2)]=$30370;
      var $30371=HEAP32[(($2858)>>2)];
      var $30372=(($30371)|0) < 0;
      if ($30372) { __label__ = 5860; break; } else { __label__ = 5861; break; }
    case 5860: // $30373
      var $30374=HEAP32[(($2857)>>2)];
      ___cxa_call_unexpected($30374);
      throw "Reached an unreachable!"
    case 5861: // $30375
      var $30376=HEAP32[(($2857)>>2)];
      var $30377=HEAP32[(($2857)>>2)];
      var $30378=HEAP32[(($2858)>>2)];
      var $30379=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30377, tempValue);
      var $30380=($30379.f1 = $30378, $30379);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5862: // $30381
      throw "Reached an unreachable!"
    case 5863: // $_ZnwjPKci_exit732
      var $30382=HEAP32[(($result_i731)>>2)];
      var $30383=$2854;
      var $30384=$2855;
      var $30385=$2856;
      var $30386=$result_i731;
      var $30387=$2857;
      var $30388=$2858;
      var $30389=$30382;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7621, 1, 0, 1, 0, 27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5864; break; } else { __label__ = 13511; break; }
    case 5864: // $30390
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7622, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5865; break; } else { __label__ = 13511; break; }
    case 5865: // $30391
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7623, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5866; break; } else { __label__ = 13511; break; }
    case 5866: // $30392
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7624, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5867; break; } else { __label__ = 13511; break; }
    case 5867: // $30393
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7625, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5868; break; } else { __label__ = 13511; break; }
    case 5868: // $30394
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5869; break; } else { __label__ = 13511; break; }
    case 5869: // $30395
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5870; break; } else { __label__ = 13511; break; }
    case 5870: // $30396
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7620, $7621, $7622, $7623, $7624, $7625, $7626, $7627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5871; break; } else { __label__ = 13511; break; }
    case 5871: // $30397
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30389, 31, 9, 0, ((STRING_TABLE.__str923)|0), ((STRING_TABLE.__str924)|0), $7620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5872; break; } else { __label__ = 13511; break; }
    case 5872: // $30398
      var $30399=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30389);
      var $30400=__ZN11simple_listI16input_type_entryE6appendERS0_($30350, $30399);
      var $30401=$4689;
      var $30402=$2849;
      var $30403=$2850;
      var $30404=$2851;
      var $30405=$result_i733;
      var $30406=$2852;
      var $30407=$2853;
      HEAP32[(($2849)>>2)]=408;
      HEAP32[(($2850)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2851)>>2)]=431;
      var $30408=HEAP32[(($2849)>>2)];
      var $30409=HEAP32[(($2850)>>2)];
      var $30410=HEAP32[(($2851)>>2)];
      var $30411=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30408, $30409, $30410) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5873; break; } else { __label__ = 5875; break; };
    case 5873: // $30412
      HEAP32[(($result_i733)>>2)]=$30411;
      var $30413=HEAP32[(($result_i733)>>2)];
      var $30414=(($30413)|0)==0;
      if ($30414) { __label__ = 5874; break; } else { __label__ = 5879; break; }
    case 5874: // $30415
      var $30416=___cxa_allocate_exception(4);
      var $30417=$30416;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30417);
      (function() { try { __THREW__ = false; return ___cxa_throw($30416, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5878; break; } else { __label__ = 5875; break; }
    case 5875: // $30418
      var $30419=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30420=$30419.f0;
      HEAP32[(($2852)>>2)]=$30420;
      var $30421=$30419.f1;
      HEAP32[(($2853)>>2)]=$30421;
      var $30422=HEAP32[(($2853)>>2)];
      var $30423=(($30422)|0) < 0;
      if ($30423) { __label__ = 5876; break; } else { __label__ = 5877; break; }
    case 5876: // $30424
      var $30425=HEAP32[(($2852)>>2)];
      ___cxa_call_unexpected($30425);
      throw "Reached an unreachable!"
    case 5877: // $30426
      var $30427=HEAP32[(($2852)>>2)];
      var $30428=HEAP32[(($2852)>>2)];
      var $30429=HEAP32[(($2853)>>2)];
      var $30430=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30428, tempValue);
      var $30431=($30430.f1 = $30429, $30430);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5878: // $30432
      throw "Reached an unreachable!"
    case 5879: // $_ZnwjPKci_exit734
      var $30433=HEAP32[(($result_i733)>>2)];
      var $30434=$2849;
      var $30435=$2850;
      var $30436=$2851;
      var $30437=$result_i733;
      var $30438=$2852;
      var $30439=$2853;
      var $30440=$30433;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7629, 1, 0, 1, 0, 54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5880; break; } else { __label__ = 13516; break; }
    case 5880: // $30441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7630, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5881; break; } else { __label__ = 13516; break; }
    case 5881: // $30442
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7631, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5882; break; } else { __label__ = 13516; break; }
    case 5882: // $30443
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5883; break; } else { __label__ = 13516; break; }
    case 5883: // $30444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5884; break; } else { __label__ = 13516; break; }
    case 5884: // $30445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5885; break; } else { __label__ = 13516; break; }
    case 5885: // $30446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5886; break; } else { __label__ = 13516; break; }
    case 5886: // $30447
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7628, $7629, $7630, $7631, $7632, $7633, $7634, $7635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5887; break; } else { __label__ = 13516; break; }
    case 5887: // $30448
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30440, 32, 9, 0, ((STRING_TABLE.__str925)|0), ((STRING_TABLE.__str926)|0), $7628) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5888; break; } else { __label__ = 13516; break; }
    case 5888: // $30449
      var $30450=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30440);
      var $30451=__ZN11simple_listI16input_type_entryE6appendERS0_($30401, $30450);
      var $30452=$4689;
      var $30453=$2844;
      var $30454=$2845;
      var $30455=$2846;
      var $30456=$result_i735;
      var $30457=$2847;
      var $30458=$2848;
      HEAP32[(($2844)>>2)]=408;
      HEAP32[(($2845)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2846)>>2)]=432;
      var $30459=HEAP32[(($2844)>>2)];
      var $30460=HEAP32[(($2845)>>2)];
      var $30461=HEAP32[(($2846)>>2)];
      var $30462=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30459, $30460, $30461) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5889; break; } else { __label__ = 5891; break; };
    case 5889: // $30463
      HEAP32[(($result_i735)>>2)]=$30462;
      var $30464=HEAP32[(($result_i735)>>2)];
      var $30465=(($30464)|0)==0;
      if ($30465) { __label__ = 5890; break; } else { __label__ = 5895; break; }
    case 5890: // $30466
      var $30467=___cxa_allocate_exception(4);
      var $30468=$30467;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30468);
      (function() { try { __THREW__ = false; return ___cxa_throw($30467, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5894; break; } else { __label__ = 5891; break; }
    case 5891: // $30469
      var $30470=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30471=$30470.f0;
      HEAP32[(($2847)>>2)]=$30471;
      var $30472=$30470.f1;
      HEAP32[(($2848)>>2)]=$30472;
      var $30473=HEAP32[(($2848)>>2)];
      var $30474=(($30473)|0) < 0;
      if ($30474) { __label__ = 5892; break; } else { __label__ = 5893; break; }
    case 5892: // $30475
      var $30476=HEAP32[(($2847)>>2)];
      ___cxa_call_unexpected($30476);
      throw "Reached an unreachable!"
    case 5893: // $30477
      var $30478=HEAP32[(($2847)>>2)];
      var $30479=HEAP32[(($2847)>>2)];
      var $30480=HEAP32[(($2848)>>2)];
      var $30481=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30479, tempValue);
      var $30482=($30481.f1 = $30480, $30481);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5894: // $30483
      throw "Reached an unreachable!"
    case 5895: // $_ZnwjPKci_exit736
      var $30484=HEAP32[(($result_i735)>>2)];
      var $30485=$2844;
      var $30486=$2845;
      var $30487=$2846;
      var $30488=$result_i735;
      var $30489=$2847;
      var $30490=$2848;
      var $30491=$30484;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7637, 1, 0, 1, 0, 55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5896; break; } else { __label__ = 13521; break; }
    case 5896: // $30492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7638, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5897; break; } else { __label__ = 13521; break; }
    case 5897: // $30493
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7639, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5898; break; } else { __label__ = 13521; break; }
    case 5898: // $30494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5899; break; } else { __label__ = 13521; break; }
    case 5899: // $30495
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5900; break; } else { __label__ = 13521; break; }
    case 5900: // $30496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5901; break; } else { __label__ = 13521; break; }
    case 5901: // $30497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5902; break; } else { __label__ = 13521; break; }
    case 5902: // $30498
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7636, $7637, $7638, $7639, $7640, $7641, $7642, $7643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5903; break; } else { __label__ = 13521; break; }
    case 5903: // $30499
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30491, 33, 9, 0, ((STRING_TABLE.__str927)|0), ((STRING_TABLE.__str928)|0), $7636) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5904; break; } else { __label__ = 13521; break; }
    case 5904: // $30500
      var $30501=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30491);
      var $30502=__ZN11simple_listI16input_type_entryE6appendERS0_($30452, $30501);
      var $30503=$4689;
      var $30504=$2839;
      var $30505=$2840;
      var $30506=$2841;
      var $30507=$result_i737;
      var $30508=$2842;
      var $30509=$2843;
      HEAP32[(($2839)>>2)]=408;
      HEAP32[(($2840)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2841)>>2)]=434;
      var $30510=HEAP32[(($2839)>>2)];
      var $30511=HEAP32[(($2840)>>2)];
      var $30512=HEAP32[(($2841)>>2)];
      var $30513=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30510, $30511, $30512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5905; break; } else { __label__ = 5907; break; };
    case 5905: // $30514
      HEAP32[(($result_i737)>>2)]=$30513;
      var $30515=HEAP32[(($result_i737)>>2)];
      var $30516=(($30515)|0)==0;
      if ($30516) { __label__ = 5906; break; } else { __label__ = 5911; break; }
    case 5906: // $30517
      var $30518=___cxa_allocate_exception(4);
      var $30519=$30518;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30519);
      (function() { try { __THREW__ = false; return ___cxa_throw($30518, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5910; break; } else { __label__ = 5907; break; }
    case 5907: // $30520
      var $30521=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30522=$30521.f0;
      HEAP32[(($2842)>>2)]=$30522;
      var $30523=$30521.f1;
      HEAP32[(($2843)>>2)]=$30523;
      var $30524=HEAP32[(($2843)>>2)];
      var $30525=(($30524)|0) < 0;
      if ($30525) { __label__ = 5908; break; } else { __label__ = 5909; break; }
    case 5908: // $30526
      var $30527=HEAP32[(($2842)>>2)];
      ___cxa_call_unexpected($30527);
      throw "Reached an unreachable!"
    case 5909: // $30528
      var $30529=HEAP32[(($2842)>>2)];
      var $30530=HEAP32[(($2842)>>2)];
      var $30531=HEAP32[(($2843)>>2)];
      var $30532=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30530, tempValue);
      var $30533=($30532.f1 = $30531, $30532);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5910: // $30534
      throw "Reached an unreachable!"
    case 5911: // $_ZnwjPKci_exit738
      var $30535=HEAP32[(($result_i737)>>2)];
      var $30536=$2839;
      var $30537=$2840;
      var $30538=$2841;
      var $30539=$result_i737;
      var $30540=$2842;
      var $30541=$2843;
      var $30542=$30535;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7645, 1, 0, 1, 0, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5912; break; } else { __label__ = 13526; break; }
    case 5912: // $30543
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7646, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5913; break; } else { __label__ = 13526; break; }
    case 5913: // $30544
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7647, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5914; break; } else { __label__ = 13526; break; }
    case 5914: // $30545
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7648, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5915; break; } else { __label__ = 13526; break; }
    case 5915: // $30546
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7649, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5916; break; } else { __label__ = 13526; break; }
    case 5916: // $30547
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5917; break; } else { __label__ = 13526; break; }
    case 5917: // $30548
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5918; break; } else { __label__ = 13526; break; }
    case 5918: // $30549
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7644, $7645, $7646, $7647, $7648, $7649, $7650, $7651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5919; break; } else { __label__ = 13526; break; }
    case 5919: // $30550
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30542, 34, 9, 0, ((STRING_TABLE.__str929)|0), ((STRING_TABLE.__str930)|0), $7644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5920; break; } else { __label__ = 13526; break; }
    case 5920: // $30551
      var $30552=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30542);
      var $30553=__ZN11simple_listI16input_type_entryE6appendERS0_($30503, $30552);
      var $30554=$4689;
      var $30555=$2834;
      var $30556=$2835;
      var $30557=$2836;
      var $30558=$result_i739;
      var $30559=$2837;
      var $30560=$2838;
      HEAP32[(($2834)>>2)]=408;
      HEAP32[(($2835)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2836)>>2)]=435;
      var $30561=HEAP32[(($2834)>>2)];
      var $30562=HEAP32[(($2835)>>2)];
      var $30563=HEAP32[(($2836)>>2)];
      var $30564=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30561, $30562, $30563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5921; break; } else { __label__ = 5923; break; };
    case 5921: // $30565
      HEAP32[(($result_i739)>>2)]=$30564;
      var $30566=HEAP32[(($result_i739)>>2)];
      var $30567=(($30566)|0)==0;
      if ($30567) { __label__ = 5922; break; } else { __label__ = 5927; break; }
    case 5922: // $30568
      var $30569=___cxa_allocate_exception(4);
      var $30570=$30569;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30570);
      (function() { try { __THREW__ = false; return ___cxa_throw($30569, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5926; break; } else { __label__ = 5923; break; }
    case 5923: // $30571
      var $30572=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30573=$30572.f0;
      HEAP32[(($2837)>>2)]=$30573;
      var $30574=$30572.f1;
      HEAP32[(($2838)>>2)]=$30574;
      var $30575=HEAP32[(($2838)>>2)];
      var $30576=(($30575)|0) < 0;
      if ($30576) { __label__ = 5924; break; } else { __label__ = 5925; break; }
    case 5924: // $30577
      var $30578=HEAP32[(($2837)>>2)];
      ___cxa_call_unexpected($30578);
      throw "Reached an unreachable!"
    case 5925: // $30579
      var $30580=HEAP32[(($2837)>>2)];
      var $30581=HEAP32[(($2837)>>2)];
      var $30582=HEAP32[(($2838)>>2)];
      var $30583=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30581, tempValue);
      var $30584=($30583.f1 = $30582, $30583);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5926: // $30585
      throw "Reached an unreachable!"
    case 5927: // $_ZnwjPKci_exit740
      var $30586=HEAP32[(($result_i739)>>2)];
      var $30587=$2834;
      var $30588=$2835;
      var $30589=$2836;
      var $30590=$result_i739;
      var $30591=$2837;
      var $30592=$2838;
      var $30593=$30586;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7653, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5928; break; } else { __label__ = 13531; break; }
    case 5928: // $30594
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7654, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5929; break; } else { __label__ = 13531; break; }
    case 5929: // $30595
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7655, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5930; break; } else { __label__ = 13531; break; }
    case 5930: // $30596
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5931; break; } else { __label__ = 13531; break; }
    case 5931: // $30597
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5932; break; } else { __label__ = 13531; break; }
    case 5932: // $30598
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5933; break; } else { __label__ = 13531; break; }
    case 5933: // $30599
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5934; break; } else { __label__ = 13531; break; }
    case 5934: // $30600
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7652, $7653, $7654, $7655, $7656, $7657, $7658, $7659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5935; break; } else { __label__ = 13531; break; }
    case 5935: // $30601
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30593, 35, 9, 0, ((STRING_TABLE.__str931)|0), ((STRING_TABLE.__str932)|0), $7652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5936; break; } else { __label__ = 13531; break; }
    case 5936: // $30602
      var $30603=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30593);
      var $30604=__ZN11simple_listI16input_type_entryE6appendERS0_($30554, $30603);
      var $30605=$4689;
      var $30606=$2829;
      var $30607=$2830;
      var $30608=$2831;
      var $30609=$result_i741;
      var $30610=$2832;
      var $30611=$2833;
      HEAP32[(($2829)>>2)]=408;
      HEAP32[(($2830)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2831)>>2)]=436;
      var $30612=HEAP32[(($2829)>>2)];
      var $30613=HEAP32[(($2830)>>2)];
      var $30614=HEAP32[(($2831)>>2)];
      var $30615=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30612, $30613, $30614) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5937; break; } else { __label__ = 5939; break; };
    case 5937: // $30616
      HEAP32[(($result_i741)>>2)]=$30615;
      var $30617=HEAP32[(($result_i741)>>2)];
      var $30618=(($30617)|0)==0;
      if ($30618) { __label__ = 5938; break; } else { __label__ = 5943; break; }
    case 5938: // $30619
      var $30620=___cxa_allocate_exception(4);
      var $30621=$30620;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30621);
      (function() { try { __THREW__ = false; return ___cxa_throw($30620, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5942; break; } else { __label__ = 5939; break; }
    case 5939: // $30622
      var $30623=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30624=$30623.f0;
      HEAP32[(($2832)>>2)]=$30624;
      var $30625=$30623.f1;
      HEAP32[(($2833)>>2)]=$30625;
      var $30626=HEAP32[(($2833)>>2)];
      var $30627=(($30626)|0) < 0;
      if ($30627) { __label__ = 5940; break; } else { __label__ = 5941; break; }
    case 5940: // $30628
      var $30629=HEAP32[(($2832)>>2)];
      ___cxa_call_unexpected($30629);
      throw "Reached an unreachable!"
    case 5941: // $30630
      var $30631=HEAP32[(($2832)>>2)];
      var $30632=HEAP32[(($2832)>>2)];
      var $30633=HEAP32[(($2833)>>2)];
      var $30634=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30632, tempValue);
      var $30635=($30634.f1 = $30633, $30634);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5942: // $30636
      throw "Reached an unreachable!"
    case 5943: // $_ZnwjPKci_exit742
      var $30637=HEAP32[(($result_i741)>>2)];
      var $30638=$2829;
      var $30639=$2830;
      var $30640=$2831;
      var $30641=$result_i741;
      var $30642=$2832;
      var $30643=$2833;
      var $30644=$30637;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7661, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5944; break; } else { __label__ = 13536; break; }
    case 5944: // $30645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7662, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5945; break; } else { __label__ = 13536; break; }
    case 5945: // $30646
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7663, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5946; break; } else { __label__ = 13536; break; }
    case 5946: // $30647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5947; break; } else { __label__ = 13536; break; }
    case 5947: // $30648
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5948; break; } else { __label__ = 13536; break; }
    case 5948: // $30649
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5949; break; } else { __label__ = 13536; break; }
    case 5949: // $30650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5950; break; } else { __label__ = 13536; break; }
    case 5950: // $30651
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7660, $7661, $7662, $7663, $7664, $7665, $7666, $7667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5951; break; } else { __label__ = 13536; break; }
    case 5951: // $30652
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30644, 36, 9, 0, ((STRING_TABLE.__str933)|0), ((STRING_TABLE.__str934)|0), $7660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5952; break; } else { __label__ = 13536; break; }
    case 5952: // $30653
      var $30654=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30644);
      var $30655=__ZN11simple_listI16input_type_entryE6appendERS0_($30605, $30654);
      var $30656=$4689;
      var $30657=$2824;
      var $30658=$2825;
      var $30659=$2826;
      var $30660=$result_i743;
      var $30661=$2827;
      var $30662=$2828;
      HEAP32[(($2824)>>2)]=408;
      HEAP32[(($2825)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2826)>>2)]=437;
      var $30663=HEAP32[(($2824)>>2)];
      var $30664=HEAP32[(($2825)>>2)];
      var $30665=HEAP32[(($2826)>>2)];
      var $30666=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30663, $30664, $30665) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5953; break; } else { __label__ = 5955; break; };
    case 5953: // $30667
      HEAP32[(($result_i743)>>2)]=$30666;
      var $30668=HEAP32[(($result_i743)>>2)];
      var $30669=(($30668)|0)==0;
      if ($30669) { __label__ = 5954; break; } else { __label__ = 5959; break; }
    case 5954: // $30670
      var $30671=___cxa_allocate_exception(4);
      var $30672=$30671;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30672);
      (function() { try { __THREW__ = false; return ___cxa_throw($30671, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5958; break; } else { __label__ = 5955; break; }
    case 5955: // $30673
      var $30674=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30675=$30674.f0;
      HEAP32[(($2827)>>2)]=$30675;
      var $30676=$30674.f1;
      HEAP32[(($2828)>>2)]=$30676;
      var $30677=HEAP32[(($2828)>>2)];
      var $30678=(($30677)|0) < 0;
      if ($30678) { __label__ = 5956; break; } else { __label__ = 5957; break; }
    case 5956: // $30679
      var $30680=HEAP32[(($2827)>>2)];
      ___cxa_call_unexpected($30680);
      throw "Reached an unreachable!"
    case 5957: // $30681
      var $30682=HEAP32[(($2827)>>2)];
      var $30683=HEAP32[(($2827)>>2)];
      var $30684=HEAP32[(($2828)>>2)];
      var $30685=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30683, tempValue);
      var $30686=($30685.f1 = $30684, $30685);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5958: // $30687
      throw "Reached an unreachable!"
    case 5959: // $_ZnwjPKci_exit744
      var $30688=HEAP32[(($result_i743)>>2)];
      var $30689=$2824;
      var $30690=$2825;
      var $30691=$2826;
      var $30692=$result_i743;
      var $30693=$2827;
      var $30694=$2828;
      var $30695=$30688;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7669, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5960; break; } else { __label__ = 13541; break; }
    case 5960: // $30696
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7670, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5961; break; } else { __label__ = 13541; break; }
    case 5961: // $30697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7671, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5962; break; } else { __label__ = 13541; break; }
    case 5962: // $30698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7672, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5963; break; } else { __label__ = 13541; break; }
    case 5963: // $30699
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7673, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5964; break; } else { __label__ = 13541; break; }
    case 5964: // $30700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5965; break; } else { __label__ = 13541; break; }
    case 5965: // $30701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5966; break; } else { __label__ = 13541; break; }
    case 5966: // $30702
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7668, $7669, $7670, $7671, $7672, $7673, $7674, $7675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5967; break; } else { __label__ = 13541; break; }
    case 5967: // $30703
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30695, 37, 9, 0, ((STRING_TABLE.__str935)|0), ((STRING_TABLE.__str936)|0), $7668) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5968; break; } else { __label__ = 13541; break; }
    case 5968: // $30704
      var $30705=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30695);
      var $30706=__ZN11simple_listI16input_type_entryE6appendERS0_($30656, $30705);
      var $30707=$4689;
      var $30708=$2819;
      var $30709=$2820;
      var $30710=$2821;
      var $30711=$result_i745;
      var $30712=$2822;
      var $30713=$2823;
      HEAP32[(($2819)>>2)]=408;
      HEAP32[(($2820)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2821)>>2)]=439;
      var $30714=HEAP32[(($2819)>>2)];
      var $30715=HEAP32[(($2820)>>2)];
      var $30716=HEAP32[(($2821)>>2)];
      var $30717=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30714, $30715, $30716) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5969; break; } else { __label__ = 5971; break; };
    case 5969: // $30718
      HEAP32[(($result_i745)>>2)]=$30717;
      var $30719=HEAP32[(($result_i745)>>2)];
      var $30720=(($30719)|0)==0;
      if ($30720) { __label__ = 5970; break; } else { __label__ = 5975; break; }
    case 5970: // $30721
      var $30722=___cxa_allocate_exception(4);
      var $30723=$30722;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30723);
      (function() { try { __THREW__ = false; return ___cxa_throw($30722, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5974; break; } else { __label__ = 5971; break; }
    case 5971: // $30724
      var $30725=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30726=$30725.f0;
      HEAP32[(($2822)>>2)]=$30726;
      var $30727=$30725.f1;
      HEAP32[(($2823)>>2)]=$30727;
      var $30728=HEAP32[(($2823)>>2)];
      var $30729=(($30728)|0) < 0;
      if ($30729) { __label__ = 5972; break; } else { __label__ = 5973; break; }
    case 5972: // $30730
      var $30731=HEAP32[(($2822)>>2)];
      ___cxa_call_unexpected($30731);
      throw "Reached an unreachable!"
    case 5973: // $30732
      var $30733=HEAP32[(($2822)>>2)];
      var $30734=HEAP32[(($2822)>>2)];
      var $30735=HEAP32[(($2823)>>2)];
      var $30736=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30734, tempValue);
      var $30737=($30736.f1 = $30735, $30736);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5974: // $30738
      throw "Reached an unreachable!"
    case 5975: // $_ZnwjPKci_exit746
      var $30739=HEAP32[(($result_i745)>>2)];
      var $30740=$2819;
      var $30741=$2820;
      var $30742=$2821;
      var $30743=$result_i745;
      var $30744=$2822;
      var $30745=$2823;
      var $30746=$30739;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7677, 1, 0, 1, 0, 38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5976; break; } else { __label__ = 13546; break; }
    case 5976: // $30747
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7678, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5977; break; } else { __label__ = 13546; break; }
    case 5977: // $30748
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7679, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5978; break; } else { __label__ = 13546; break; }
    case 5978: // $30749
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5979; break; } else { __label__ = 13546; break; }
    case 5979: // $30750
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5980; break; } else { __label__ = 13546; break; }
    case 5980: // $30751
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5981; break; } else { __label__ = 13546; break; }
    case 5981: // $30752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5982; break; } else { __label__ = 13546; break; }
    case 5982: // $30753
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7676, $7677, $7678, $7679, $7680, $7681, $7682, $7683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5983; break; } else { __label__ = 13546; break; }
    case 5983: // $30754
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30746, 38, 9, 0, ((STRING_TABLE.__str937)|0), ((STRING_TABLE.__str355)|0), $7676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5984; break; } else { __label__ = 13546; break; }
    case 5984: // $30755
      var $30756=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30746);
      var $30757=__ZN11simple_listI16input_type_entryE6appendERS0_($30707, $30756);
      var $30758=$4689;
      var $30759=$2814;
      var $30760=$2815;
      var $30761=$2816;
      var $30762=$result_i747;
      var $30763=$2817;
      var $30764=$2818;
      HEAP32[(($2814)>>2)]=408;
      HEAP32[(($2815)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2816)>>2)]=440;
      var $30765=HEAP32[(($2814)>>2)];
      var $30766=HEAP32[(($2815)>>2)];
      var $30767=HEAP32[(($2816)>>2)];
      var $30768=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30765, $30766, $30767) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5985; break; } else { __label__ = 5987; break; };
    case 5985: // $30769
      HEAP32[(($result_i747)>>2)]=$30768;
      var $30770=HEAP32[(($result_i747)>>2)];
      var $30771=(($30770)|0)==0;
      if ($30771) { __label__ = 5986; break; } else { __label__ = 5991; break; }
    case 5986: // $30772
      var $30773=___cxa_allocate_exception(4);
      var $30774=$30773;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30774);
      (function() { try { __THREW__ = false; return ___cxa_throw($30773, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5990; break; } else { __label__ = 5987; break; }
    case 5987: // $30775
      var $30776=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30777=$30776.f0;
      HEAP32[(($2817)>>2)]=$30777;
      var $30778=$30776.f1;
      HEAP32[(($2818)>>2)]=$30778;
      var $30779=HEAP32[(($2818)>>2)];
      var $30780=(($30779)|0) < 0;
      if ($30780) { __label__ = 5988; break; } else { __label__ = 5989; break; }
    case 5988: // $30781
      var $30782=HEAP32[(($2817)>>2)];
      ___cxa_call_unexpected($30782);
      throw "Reached an unreachable!"
    case 5989: // $30783
      var $30784=HEAP32[(($2817)>>2)];
      var $30785=HEAP32[(($2817)>>2)];
      var $30786=HEAP32[(($2818)>>2)];
      var $30787=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30785, tempValue);
      var $30788=($30787.f1 = $30786, $30787);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5990: // $30789
      throw "Reached an unreachable!"
    case 5991: // $_ZnwjPKci_exit748
      var $30790=HEAP32[(($result_i747)>>2)];
      var $30791=$2814;
      var $30792=$2815;
      var $30793=$2816;
      var $30794=$result_i747;
      var $30795=$2817;
      var $30796=$2818;
      var $30797=$30790;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7685, 1, 0, 1, 0, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5992; break; } else { __label__ = 13551; break; }
    case 5992: // $30798
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7686, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5993; break; } else { __label__ = 13551; break; }
    case 5993: // $30799
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7687, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5994; break; } else { __label__ = 13551; break; }
    case 5994: // $30800
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7688, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5995; break; } else { __label__ = 13551; break; }
    case 5995: // $30801
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7689, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5996; break; } else { __label__ = 13551; break; }
    case 5996: // $30802
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7690, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5997; break; } else { __label__ = 13551; break; }
    case 5997: // $30803
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7691, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5998; break; } else { __label__ = 13551; break; }
    case 5998: // $30804
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7684, $7685, $7686, $7687, $7688, $7689, $7690, $7691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5999; break; } else { __label__ = 13551; break; }
    case 5999: // $30805
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30797, 39, 9, 0, ((STRING_TABLE.__str938)|0), ((STRING_TABLE.__str939)|0), $7684) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6000; break; } else { __label__ = 13551; break; }
    case 6000: // $30806
      var $30807=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30797);
      var $30808=__ZN11simple_listI16input_type_entryE6appendERS0_($30758, $30807);
      var $30809=$4689;
      var $30810=$2809;
      var $30811=$2810;
      var $30812=$2811;
      var $30813=$result_i749;
      var $30814=$2812;
      var $30815=$2813;
      HEAP32[(($2809)>>2)]=408;
      HEAP32[(($2810)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2811)>>2)]=441;
      var $30816=HEAP32[(($2809)>>2)];
      var $30817=HEAP32[(($2810)>>2)];
      var $30818=HEAP32[(($2811)>>2)];
      var $30819=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30816, $30817, $30818) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6001; break; } else { __label__ = 6003; break; };
    case 6001: // $30820
      HEAP32[(($result_i749)>>2)]=$30819;
      var $30821=HEAP32[(($result_i749)>>2)];
      var $30822=(($30821)|0)==0;
      if ($30822) { __label__ = 6002; break; } else { __label__ = 6007; break; }
    case 6002: // $30823
      var $30824=___cxa_allocate_exception(4);
      var $30825=$30824;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30825);
      (function() { try { __THREW__ = false; return ___cxa_throw($30824, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6006; break; } else { __label__ = 6003; break; }
    case 6003: // $30826
      var $30827=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30828=$30827.f0;
      HEAP32[(($2812)>>2)]=$30828;
      var $30829=$30827.f1;
      HEAP32[(($2813)>>2)]=$30829;
      var $30830=HEAP32[(($2813)>>2)];
      var $30831=(($30830)|0) < 0;
      if ($30831) { __label__ = 6004; break; } else { __label__ = 6005; break; }
    case 6004: // $30832
      var $30833=HEAP32[(($2812)>>2)];
      ___cxa_call_unexpected($30833);
      throw "Reached an unreachable!"
    case 6005: // $30834
      var $30835=HEAP32[(($2812)>>2)];
      var $30836=HEAP32[(($2812)>>2)];
      var $30837=HEAP32[(($2813)>>2)];
      var $30838=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30836, tempValue);
      var $30839=($30838.f1 = $30837, $30838);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6006: // $30840
      throw "Reached an unreachable!"
    case 6007: // $_ZnwjPKci_exit750
      var $30841=HEAP32[(($result_i749)>>2)];
      var $30842=$2809;
      var $30843=$2810;
      var $30844=$2811;
      var $30845=$result_i749;
      var $30846=$2812;
      var $30847=$2813;
      var $30848=$30841;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7693, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6008; break; } else { __label__ = 13556; break; }
    case 6008: // $30849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7694, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6009; break; } else { __label__ = 13556; break; }
    case 6009: // $30850
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7695, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6010; break; } else { __label__ = 13556; break; }
    case 6010: // $30851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7696, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6011; break; } else { __label__ = 13556; break; }
    case 6011: // $30852
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7697, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6012; break; } else { __label__ = 13556; break; }
    case 6012: // $30853
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6013; break; } else { __label__ = 13556; break; }
    case 6013: // $30854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6014; break; } else { __label__ = 13556; break; }
    case 6014: // $30855
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7692, $7693, $7694, $7695, $7696, $7697, $7698, $7699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6015; break; } else { __label__ = 13556; break; }
    case 6015: // $30856
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30848, 40, 9, 0, ((STRING_TABLE.__str940)|0), ((STRING_TABLE.__str941)|0), $7692) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6016; break; } else { __label__ = 13556; break; }
    case 6016: // $30857
      var $30858=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30848);
      var $30859=__ZN11simple_listI16input_type_entryE6appendERS0_($30809, $30858);
      var $30860=$4689;
      var $30861=$2804;
      var $30862=$2805;
      var $30863=$2806;
      var $30864=$result_i751;
      var $30865=$2807;
      var $30866=$2808;
      HEAP32[(($2804)>>2)]=408;
      HEAP32[(($2805)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2806)>>2)]=442;
      var $30867=HEAP32[(($2804)>>2)];
      var $30868=HEAP32[(($2805)>>2)];
      var $30869=HEAP32[(($2806)>>2)];
      var $30870=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30867, $30868, $30869) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6017; break; } else { __label__ = 6019; break; };
    case 6017: // $30871
      HEAP32[(($result_i751)>>2)]=$30870;
      var $30872=HEAP32[(($result_i751)>>2)];
      var $30873=(($30872)|0)==0;
      if ($30873) { __label__ = 6018; break; } else { __label__ = 6023; break; }
    case 6018: // $30874
      var $30875=___cxa_allocate_exception(4);
      var $30876=$30875;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30876);
      (function() { try { __THREW__ = false; return ___cxa_throw($30875, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6022; break; } else { __label__ = 6019; break; }
    case 6019: // $30877
      var $30878=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30879=$30878.f0;
      HEAP32[(($2807)>>2)]=$30879;
      var $30880=$30878.f1;
      HEAP32[(($2808)>>2)]=$30880;
      var $30881=HEAP32[(($2808)>>2)];
      var $30882=(($30881)|0) < 0;
      if ($30882) { __label__ = 6020; break; } else { __label__ = 6021; break; }
    case 6020: // $30883
      var $30884=HEAP32[(($2807)>>2)];
      ___cxa_call_unexpected($30884);
      throw "Reached an unreachable!"
    case 6021: // $30885
      var $30886=HEAP32[(($2807)>>2)];
      var $30887=HEAP32[(($2807)>>2)];
      var $30888=HEAP32[(($2808)>>2)];
      var $30889=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30887, tempValue);
      var $30890=($30889.f1 = $30888, $30889);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6022: // $30891
      throw "Reached an unreachable!"
    case 6023: // $_ZnwjPKci_exit752
      var $30892=HEAP32[(($result_i751)>>2)];
      var $30893=$2804;
      var $30894=$2805;
      var $30895=$2806;
      var $30896=$result_i751;
      var $30897=$2807;
      var $30898=$2808;
      var $30899=$30892;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7701, 1, 0, 1, 0, 54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6024; break; } else { __label__ = 13561; break; }
    case 6024: // $30900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7702, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6025; break; } else { __label__ = 13561; break; }
    case 6025: // $30901
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7703, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6026; break; } else { __label__ = 13561; break; }
    case 6026: // $30902
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6027; break; } else { __label__ = 13561; break; }
    case 6027: // $30903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6028; break; } else { __label__ = 13561; break; }
    case 6028: // $30904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6029; break; } else { __label__ = 13561; break; }
    case 6029: // $30905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6030; break; } else { __label__ = 13561; break; }
    case 6030: // $30906
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7700, $7701, $7702, $7703, $7704, $7705, $7706, $7707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6031; break; } else { __label__ = 13561; break; }
    case 6031: // $30907
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30899, 42, 9, 0, ((STRING_TABLE.__str942)|0), ((STRING_TABLE.__str943)|0), $7700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6032; break; } else { __label__ = 13561; break; }
    case 6032: // $30908
      var $30909=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30899);
      var $30910=__ZN11simple_listI16input_type_entryE6appendERS0_($30860, $30909);
      var $30911=$4689;
      var $30912=$2799;
      var $30913=$2800;
      var $30914=$2801;
      var $30915=$result_i753;
      var $30916=$2802;
      var $30917=$2803;
      HEAP32[(($2799)>>2)]=408;
      HEAP32[(($2800)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2801)>>2)]=443;
      var $30918=HEAP32[(($2799)>>2)];
      var $30919=HEAP32[(($2800)>>2)];
      var $30920=HEAP32[(($2801)>>2)];
      var $30921=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30918, $30919, $30920) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6033; break; } else { __label__ = 6035; break; };
    case 6033: // $30922
      HEAP32[(($result_i753)>>2)]=$30921;
      var $30923=HEAP32[(($result_i753)>>2)];
      var $30924=(($30923)|0)==0;
      if ($30924) { __label__ = 6034; break; } else { __label__ = 6039; break; }
    case 6034: // $30925
      var $30926=___cxa_allocate_exception(4);
      var $30927=$30926;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30927);
      (function() { try { __THREW__ = false; return ___cxa_throw($30926, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6038; break; } else { __label__ = 6035; break; }
    case 6035: // $30928
      var $30929=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30930=$30929.f0;
      HEAP32[(($2802)>>2)]=$30930;
      var $30931=$30929.f1;
      HEAP32[(($2803)>>2)]=$30931;
      var $30932=HEAP32[(($2803)>>2)];
      var $30933=(($30932)|0) < 0;
      if ($30933) { __label__ = 6036; break; } else { __label__ = 6037; break; }
    case 6036: // $30934
      var $30935=HEAP32[(($2802)>>2)];
      ___cxa_call_unexpected($30935);
      throw "Reached an unreachable!"
    case 6037: // $30936
      var $30937=HEAP32[(($2802)>>2)];
      var $30938=HEAP32[(($2802)>>2)];
      var $30939=HEAP32[(($2803)>>2)];
      var $30940=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30938, tempValue);
      var $30941=($30940.f1 = $30939, $30940);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6038: // $30942
      throw "Reached an unreachable!"
    case 6039: // $_ZnwjPKci_exit754
      var $30943=HEAP32[(($result_i753)>>2)];
      var $30944=$2799;
      var $30945=$2800;
      var $30946=$2801;
      var $30947=$result_i753;
      var $30948=$2802;
      var $30949=$2803;
      var $30950=$30943;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7709, 1, 0, 1, 0, 55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6040; break; } else { __label__ = 13566; break; }
    case 6040: // $30951
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7710, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6041; break; } else { __label__ = 13566; break; }
    case 6041: // $30952
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7711, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6042; break; } else { __label__ = 13566; break; }
    case 6042: // $30953
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6043; break; } else { __label__ = 13566; break; }
    case 6043: // $30954
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6044; break; } else { __label__ = 13566; break; }
    case 6044: // $30955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6045; break; } else { __label__ = 13566; break; }
    case 6045: // $30956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6046; break; } else { __label__ = 13566; break; }
    case 6046: // $30957
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7708, $7709, $7710, $7711, $7712, $7713, $7714, $7715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6047; break; } else { __label__ = 13566; break; }
    case 6047: // $30958
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($30950, 41, 9, 0, ((STRING_TABLE.__str944)|0), ((STRING_TABLE.__str945)|0), $7708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6048; break; } else { __label__ = 13566; break; }
    case 6048: // $30959
      var $30960=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $30950);
      var $30961=__ZN11simple_listI16input_type_entryE6appendERS0_($30911, $30960);
      var $30962=$4689;
      var $30963=$2794;
      var $30964=$2795;
      var $30965=$2796;
      var $30966=$result_i755;
      var $30967=$2797;
      var $30968=$2798;
      HEAP32[(($2794)>>2)]=408;
      HEAP32[(($2795)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2796)>>2)]=445;
      var $30969=HEAP32[(($2794)>>2)];
      var $30970=HEAP32[(($2795)>>2)];
      var $30971=HEAP32[(($2796)>>2)];
      var $30972=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30969, $30970, $30971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6049; break; } else { __label__ = 6051; break; };
    case 6049: // $30973
      HEAP32[(($result_i755)>>2)]=$30972;
      var $30974=HEAP32[(($result_i755)>>2)];
      var $30975=(($30974)|0)==0;
      if ($30975) { __label__ = 6050; break; } else { __label__ = 6055; break; }
    case 6050: // $30976
      var $30977=___cxa_allocate_exception(4);
      var $30978=$30977;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30978);
      (function() { try { __THREW__ = false; return ___cxa_throw($30977, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6054; break; } else { __label__ = 6051; break; }
    case 6051: // $30979
      var $30980=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30981=$30980.f0;
      HEAP32[(($2797)>>2)]=$30981;
      var $30982=$30980.f1;
      HEAP32[(($2798)>>2)]=$30982;
      var $30983=HEAP32[(($2798)>>2)];
      var $30984=(($30983)|0) < 0;
      if ($30984) { __label__ = 6052; break; } else { __label__ = 6053; break; }
    case 6052: // $30985
      var $30986=HEAP32[(($2797)>>2)];
      ___cxa_call_unexpected($30986);
      throw "Reached an unreachable!"
    case 6053: // $30987
      var $30988=HEAP32[(($2797)>>2)];
      var $30989=HEAP32[(($2797)>>2)];
      var $30990=HEAP32[(($2798)>>2)];
      var $30991=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30989, tempValue);
      var $30992=($30991.f1 = $30990, $30991);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6054: // $30993
      throw "Reached an unreachable!"
    case 6055: // $_ZnwjPKci_exit756
      var $30994=HEAP32[(($result_i755)>>2)];
      var $30995=$2794;
      var $30996=$2795;
      var $30997=$2796;
      var $30998=$result_i755;
      var $30999=$2797;
      var $31000=$2798;
      var $31001=$30994;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7717, 4, 0, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6056; break; } else { __label__ = 13571; break; }
    case 6056: // $31002
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7718, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6057; break; } else { __label__ = 13571; break; }
    case 6057: // $31003
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7719, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6058; break; } else { __label__ = 13571; break; }
    case 6058: // $31004
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7720, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6059; break; } else { __label__ = 13571; break; }
    case 6059: // $31005
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7721, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6060; break; } else { __label__ = 13571; break; }
    case 6060: // $31006
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6061; break; } else { __label__ = 13571; break; }
    case 6061: // $31007
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6062; break; } else { __label__ = 13571; break; }
    case 6062: // $31008
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7716, $7717, $7718, $7719, $7720, $7721, $7722, $7723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6063; break; } else { __label__ = 13571; break; }
    case 6063: // $31009
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7725, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6064; break; } else { __label__ = 13571; break; }
    case 6064: // $31010
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7726, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6065; break; } else { __label__ = 13571; break; }
    case 6065: // $31011
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7727, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6066; break; } else { __label__ = 13571; break; }
    case 6066: // $31012
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6067; break; } else { __label__ = 13571; break; }
    case 6067: // $31013
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6068; break; } else { __label__ = 13571; break; }
    case 6068: // $31014
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6069; break; } else { __label__ = 13571; break; }
    case 6069: // $31015
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6070; break; } else { __label__ = 13571; break; }
    case 6070: // $31016
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7724, $7725, $7726, $7727, $7728, $7729, $7730, $7731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6071; break; } else { __label__ = 13571; break; }
    case 6071: // $31017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7733, 1, 0, 1, 0, 99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6072; break; } else { __label__ = 13571; break; }
    case 6072: // $31018
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7734, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6073; break; } else { __label__ = 13571; break; }
    case 6073: // $31019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7735, 4, 0, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6074; break; } else { __label__ = 13571; break; }
    case 6074: // $31020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6075; break; } else { __label__ = 13571; break; }
    case 6075: // $31021
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6076; break; } else { __label__ = 13571; break; }
    case 6076: // $31022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6077; break; } else { __label__ = 13571; break; }
    case 6077: // $31023
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6078; break; } else { __label__ = 13571; break; }
    case 6078: // $31024
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7732, $7733, $7734, $7735, $7736, $7737, $7738, $7739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6079; break; } else { __label__ = 13571; break; }
    case 6079: // $31025
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31001, 147, 1, 0, ((STRING_TABLE.__str946)|0), ((STRING_TABLE.__str947)|0), $7716, $7724, $7732) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6080; break; } else { __label__ = 13571; break; }
    case 6080: // $31026
      var $31027=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31001);
      var $31028=__ZN11simple_listI16input_type_entryE6appendERS0_($30962, $31027);
      var $31029=$4689;
      var $31030=$2789;
      var $31031=$2790;
      var $31032=$2791;
      var $31033=$result_i757;
      var $31034=$2792;
      var $31035=$2793;
      HEAP32[(($2789)>>2)]=408;
      HEAP32[(($2790)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2791)>>2)]=446;
      var $31036=HEAP32[(($2789)>>2)];
      var $31037=HEAP32[(($2790)>>2)];
      var $31038=HEAP32[(($2791)>>2)];
      var $31039=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31036, $31037, $31038) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6081; break; } else { __label__ = 6083; break; };
    case 6081: // $31040
      HEAP32[(($result_i757)>>2)]=$31039;
      var $31041=HEAP32[(($result_i757)>>2)];
      var $31042=(($31041)|0)==0;
      if ($31042) { __label__ = 6082; break; } else { __label__ = 6087; break; }
    case 6082: // $31043
      var $31044=___cxa_allocate_exception(4);
      var $31045=$31044;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31045);
      (function() { try { __THREW__ = false; return ___cxa_throw($31044, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6086; break; } else { __label__ = 6083; break; }
    case 6083: // $31046
      var $31047=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31048=$31047.f0;
      HEAP32[(($2792)>>2)]=$31048;
      var $31049=$31047.f1;
      HEAP32[(($2793)>>2)]=$31049;
      var $31050=HEAP32[(($2793)>>2)];
      var $31051=(($31050)|0) < 0;
      if ($31051) { __label__ = 6084; break; } else { __label__ = 6085; break; }
    case 6084: // $31052
      var $31053=HEAP32[(($2792)>>2)];
      ___cxa_call_unexpected($31053);
      throw "Reached an unreachable!"
    case 6085: // $31054
      var $31055=HEAP32[(($2792)>>2)];
      var $31056=HEAP32[(($2792)>>2)];
      var $31057=HEAP32[(($2793)>>2)];
      var $31058=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31056, tempValue);
      var $31059=($31058.f1 = $31057, $31058);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6086: // $31060
      throw "Reached an unreachable!"
    case 6087: // $_ZnwjPKci_exit758
      var $31061=HEAP32[(($result_i757)>>2)];
      var $31062=$2789;
      var $31063=$2790;
      var $31064=$2791;
      var $31065=$result_i757;
      var $31066=$2792;
      var $31067=$2793;
      var $31068=$31061;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7741, 4, 1, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6088; break; } else { __label__ = 13576; break; }
    case 6088: // $31069
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7742, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6089; break; } else { __label__ = 13576; break; }
    case 6089: // $31070
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7743, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6090; break; } else { __label__ = 13576; break; }
    case 6090: // $31071
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7744, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6091; break; } else { __label__ = 13576; break; }
    case 6091: // $31072
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7745, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6092; break; } else { __label__ = 13576; break; }
    case 6092: // $31073
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6093; break; } else { __label__ = 13576; break; }
    case 6093: // $31074
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6094; break; } else { __label__ = 13576; break; }
    case 6094: // $31075
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7740, $7741, $7742, $7743, $7744, $7745, $7746, $7747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6095; break; } else { __label__ = 13576; break; }
    case 6095: // $31076
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7749, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6096; break; } else { __label__ = 13576; break; }
    case 6096: // $31077
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7750, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6097; break; } else { __label__ = 13576; break; }
    case 6097: // $31078
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7751, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6098; break; } else { __label__ = 13576; break; }
    case 6098: // $31079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6099; break; } else { __label__ = 13576; break; }
    case 6099: // $31080
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6100; break; } else { __label__ = 13576; break; }
    case 6100: // $31081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6101; break; } else { __label__ = 13576; break; }
    case 6101: // $31082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6102; break; } else { __label__ = 13576; break; }
    case 6102: // $31083
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7748, $7749, $7750, $7751, $7752, $7753, $7754, $7755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6103; break; } else { __label__ = 13576; break; }
    case 6103: // $31084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7757, 1, 0, 1, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6104; break; } else { __label__ = 13576; break; }
    case 6104: // $31085
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7758, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6105; break; } else { __label__ = 13576; break; }
    case 6105: // $31086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7759, 4, 1, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6106; break; } else { __label__ = 13576; break; }
    case 6106: // $31087
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6107; break; } else { __label__ = 13576; break; }
    case 6107: // $31088
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6108; break; } else { __label__ = 13576; break; }
    case 6108: // $31089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6109; break; } else { __label__ = 13576; break; }
    case 6109: // $31090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6110; break; } else { __label__ = 13576; break; }
    case 6110: // $31091
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7756, $7757, $7758, $7759, $7760, $7761, $7762, $7763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6111; break; } else { __label__ = 13576; break; }
    case 6111: // $31092
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31068, 147, 2, 1, ((STRING_TABLE.__str948)|0), ((STRING_TABLE.__str949)|0), $7740, $7748, $7756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6112; break; } else { __label__ = 13576; break; }
    case 6112: // $31093
      var $31094=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31068);
      var $31095=__ZN11simple_listI16input_type_entryE6appendERS0_($31029, $31094);
      var $31096=$4689;
      var $31097=$2784;
      var $31098=$2785;
      var $31099=$2786;
      var $31100=$result_i759;
      var $31101=$2787;
      var $31102=$2788;
      HEAP32[(($2784)>>2)]=408;
      HEAP32[(($2785)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2786)>>2)]=447;
      var $31103=HEAP32[(($2784)>>2)];
      var $31104=HEAP32[(($2785)>>2)];
      var $31105=HEAP32[(($2786)>>2)];
      var $31106=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31103, $31104, $31105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6113; break; } else { __label__ = 6115; break; };
    case 6113: // $31107
      HEAP32[(($result_i759)>>2)]=$31106;
      var $31108=HEAP32[(($result_i759)>>2)];
      var $31109=(($31108)|0)==0;
      if ($31109) { __label__ = 6114; break; } else { __label__ = 6119; break; }
    case 6114: // $31110
      var $31111=___cxa_allocate_exception(4);
      var $31112=$31111;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31112);
      (function() { try { __THREW__ = false; return ___cxa_throw($31111, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6118; break; } else { __label__ = 6115; break; }
    case 6115: // $31113
      var $31114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31115=$31114.f0;
      HEAP32[(($2787)>>2)]=$31115;
      var $31116=$31114.f1;
      HEAP32[(($2788)>>2)]=$31116;
      var $31117=HEAP32[(($2788)>>2)];
      var $31118=(($31117)|0) < 0;
      if ($31118) { __label__ = 6116; break; } else { __label__ = 6117; break; }
    case 6116: // $31119
      var $31120=HEAP32[(($2787)>>2)];
      ___cxa_call_unexpected($31120);
      throw "Reached an unreachable!"
    case 6117: // $31121
      var $31122=HEAP32[(($2787)>>2)];
      var $31123=HEAP32[(($2787)>>2)];
      var $31124=HEAP32[(($2788)>>2)];
      var $31125=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31123, tempValue);
      var $31126=($31125.f1 = $31124, $31125);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6118: // $31127
      throw "Reached an unreachable!"
    case 6119: // $_ZnwjPKci_exit760
      var $31128=HEAP32[(($result_i759)>>2)];
      var $31129=$2784;
      var $31130=$2785;
      var $31131=$2786;
      var $31132=$result_i759;
      var $31133=$2787;
      var $31134=$2788;
      var $31135=$31128;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7765, 4, 2, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6120; break; } else { __label__ = 13581; break; }
    case 6120: // $31136
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7766, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6121; break; } else { __label__ = 13581; break; }
    case 6121: // $31137
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7767, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6122; break; } else { __label__ = 13581; break; }
    case 6122: // $31138
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7768, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6123; break; } else { __label__ = 13581; break; }
    case 6123: // $31139
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7769, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6124; break; } else { __label__ = 13581; break; }
    case 6124: // $31140
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6125; break; } else { __label__ = 13581; break; }
    case 6125: // $31141
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6126; break; } else { __label__ = 13581; break; }
    case 6126: // $31142
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7764, $7765, $7766, $7767, $7768, $7769, $7770, $7771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6127; break; } else { __label__ = 13581; break; }
    case 6127: // $31143
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7773, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6128; break; } else { __label__ = 13581; break; }
    case 6128: // $31144
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7774, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6129; break; } else { __label__ = 13581; break; }
    case 6129: // $31145
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7775, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6130; break; } else { __label__ = 13581; break; }
    case 6130: // $31146
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6131; break; } else { __label__ = 13581; break; }
    case 6131: // $31147
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6132; break; } else { __label__ = 13581; break; }
    case 6132: // $31148
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6133; break; } else { __label__ = 13581; break; }
    case 6133: // $31149
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6134; break; } else { __label__ = 13581; break; }
    case 6134: // $31150
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7772, $7773, $7774, $7775, $7776, $7777, $7778, $7779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6135; break; } else { __label__ = 13581; break; }
    case 6135: // $31151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7781, 1, 0, 1, 0, 100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6136; break; } else { __label__ = 13581; break; }
    case 6136: // $31152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7782, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6137; break; } else { __label__ = 13581; break; }
    case 6137: // $31153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7783, 4, 2, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6138; break; } else { __label__ = 13581; break; }
    case 6138: // $31154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6139; break; } else { __label__ = 13581; break; }
    case 6139: // $31155
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6140; break; } else { __label__ = 13581; break; }
    case 6140: // $31156
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6141; break; } else { __label__ = 13581; break; }
    case 6141: // $31157
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6142; break; } else { __label__ = 13581; break; }
    case 6142: // $31158
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7780, $7781, $7782, $7783, $7784, $7785, $7786, $7787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6143; break; } else { __label__ = 13581; break; }
    case 6143: // $31159
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31135, 147, 3, 2, ((STRING_TABLE.__str950)|0), ((STRING_TABLE.__str951)|0), $7764, $7772, $7780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6144; break; } else { __label__ = 13581; break; }
    case 6144: // $31160
      var $31161=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31135);
      var $31162=__ZN11simple_listI16input_type_entryE6appendERS0_($31096, $31161);
      var $31163=$4689;
      var $31164=$2779;
      var $31165=$2780;
      var $31166=$2781;
      var $31167=$result_i761;
      var $31168=$2782;
      var $31169=$2783;
      HEAP32[(($2779)>>2)]=408;
      HEAP32[(($2780)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2781)>>2)]=448;
      var $31170=HEAP32[(($2779)>>2)];
      var $31171=HEAP32[(($2780)>>2)];
      var $31172=HEAP32[(($2781)>>2)];
      var $31173=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31170, $31171, $31172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6145; break; } else { __label__ = 6147; break; };
    case 6145: // $31174
      HEAP32[(($result_i761)>>2)]=$31173;
      var $31175=HEAP32[(($result_i761)>>2)];
      var $31176=(($31175)|0)==0;
      if ($31176) { __label__ = 6146; break; } else { __label__ = 6151; break; }
    case 6146: // $31177
      var $31178=___cxa_allocate_exception(4);
      var $31179=$31178;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31179);
      (function() { try { __THREW__ = false; return ___cxa_throw($31178, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6150; break; } else { __label__ = 6147; break; }
    case 6147: // $31180
      var $31181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31182=$31181.f0;
      HEAP32[(($2782)>>2)]=$31182;
      var $31183=$31181.f1;
      HEAP32[(($2783)>>2)]=$31183;
      var $31184=HEAP32[(($2783)>>2)];
      var $31185=(($31184)|0) < 0;
      if ($31185) { __label__ = 6148; break; } else { __label__ = 6149; break; }
    case 6148: // $31186
      var $31187=HEAP32[(($2782)>>2)];
      ___cxa_call_unexpected($31187);
      throw "Reached an unreachable!"
    case 6149: // $31188
      var $31189=HEAP32[(($2782)>>2)];
      var $31190=HEAP32[(($2782)>>2)];
      var $31191=HEAP32[(($2783)>>2)];
      var $31192=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31190, tempValue);
      var $31193=($31192.f1 = $31191, $31192);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6150: // $31194
      throw "Reached an unreachable!"
    case 6151: // $_ZnwjPKci_exit762
      var $31195=HEAP32[(($result_i761)>>2)];
      var $31196=$2779;
      var $31197=$2780;
      var $31198=$2781;
      var $31199=$result_i761;
      var $31200=$2782;
      var $31201=$2783;
      var $31202=$31195;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7789, 4, 3, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6152; break; } else { __label__ = 13586; break; }
    case 6152: // $31203
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7790, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6153; break; } else { __label__ = 13586; break; }
    case 6153: // $31204
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7791, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6154; break; } else { __label__ = 13586; break; }
    case 6154: // $31205
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7792, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6155; break; } else { __label__ = 13586; break; }
    case 6155: // $31206
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7793, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6156; break; } else { __label__ = 13586; break; }
    case 6156: // $31207
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7794, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6157; break; } else { __label__ = 13586; break; }
    case 6157: // $31208
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7795, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6158; break; } else { __label__ = 13586; break; }
    case 6158: // $31209
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7788, $7789, $7790, $7791, $7792, $7793, $7794, $7795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6159; break; } else { __label__ = 13586; break; }
    case 6159: // $31210
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7797, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6160; break; } else { __label__ = 13586; break; }
    case 6160: // $31211
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7798, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6161; break; } else { __label__ = 13586; break; }
    case 6161: // $31212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7799, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6162; break; } else { __label__ = 13586; break; }
    case 6162: // $31213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7800, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6163; break; } else { __label__ = 13586; break; }
    case 6163: // $31214
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7801, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6164; break; } else { __label__ = 13586; break; }
    case 6164: // $31215
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7802, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6165; break; } else { __label__ = 13586; break; }
    case 6165: // $31216
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7803, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6166; break; } else { __label__ = 13586; break; }
    case 6166: // $31217
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7796, $7797, $7798, $7799, $7800, $7801, $7802, $7803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6167; break; } else { __label__ = 13586; break; }
    case 6167: // $31218
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7805, 1, 0, 1, 0, 79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6168; break; } else { __label__ = 13586; break; }
    case 6168: // $31219
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7806, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6169; break; } else { __label__ = 13586; break; }
    case 6169: // $31220
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7807, 4, 3, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6170; break; } else { __label__ = 13586; break; }
    case 6170: // $31221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7808, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6171; break; } else { __label__ = 13586; break; }
    case 6171: // $31222
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7809, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6172; break; } else { __label__ = 13586; break; }
    case 6172: // $31223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6173; break; } else { __label__ = 13586; break; }
    case 6173: // $31224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6174; break; } else { __label__ = 13586; break; }
    case 6174: // $31225
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7804, $7805, $7806, $7807, $7808, $7809, $7810, $7811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6175; break; } else { __label__ = 13586; break; }
    case 6175: // $31226
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31202, 147, 4, 3, ((STRING_TABLE.__str952)|0), ((STRING_TABLE.__str953)|0), $7788, $7796, $7804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6176; break; } else { __label__ = 13586; break; }
    case 6176: // $31227
      var $31228=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31202);
      var $31229=__ZN11simple_listI16input_type_entryE6appendERS0_($31163, $31228);
      var $31230=$4689;
      var $31231=$2774;
      var $31232=$2775;
      var $31233=$2776;
      var $31234=$result_i763;
      var $31235=$2777;
      var $31236=$2778;
      HEAP32[(($2774)>>2)]=408;
      HEAP32[(($2775)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2776)>>2)]=449;
      var $31237=HEAP32[(($2774)>>2)];
      var $31238=HEAP32[(($2775)>>2)];
      var $31239=HEAP32[(($2776)>>2)];
      var $31240=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31237, $31238, $31239) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6177; break; } else { __label__ = 6179; break; };
    case 6177: // $31241
      HEAP32[(($result_i763)>>2)]=$31240;
      var $31242=HEAP32[(($result_i763)>>2)];
      var $31243=(($31242)|0)==0;
      if ($31243) { __label__ = 6178; break; } else { __label__ = 6183; break; }
    case 6178: // $31244
      var $31245=___cxa_allocate_exception(4);
      var $31246=$31245;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31246);
      (function() { try { __THREW__ = false; return ___cxa_throw($31245, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6182; break; } else { __label__ = 6179; break; }
    case 6179: // $31247
      var $31248=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31249=$31248.f0;
      HEAP32[(($2777)>>2)]=$31249;
      var $31250=$31248.f1;
      HEAP32[(($2778)>>2)]=$31250;
      var $31251=HEAP32[(($2778)>>2)];
      var $31252=(($31251)|0) < 0;
      if ($31252) { __label__ = 6180; break; } else { __label__ = 6181; break; }
    case 6180: // $31253
      var $31254=HEAP32[(($2777)>>2)];
      ___cxa_call_unexpected($31254);
      throw "Reached an unreachable!"
    case 6181: // $31255
      var $31256=HEAP32[(($2777)>>2)];
      var $31257=HEAP32[(($2777)>>2)];
      var $31258=HEAP32[(($2778)>>2)];
      var $31259=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31257, tempValue);
      var $31260=($31259.f1 = $31258, $31259);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6182: // $31261
      throw "Reached an unreachable!"
    case 6183: // $_ZnwjPKci_exit764
      var $31262=HEAP32[(($result_i763)>>2)];
      var $31263=$2774;
      var $31264=$2775;
      var $31265=$2776;
      var $31266=$result_i763;
      var $31267=$2777;
      var $31268=$2778;
      var $31269=$31262;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7813, 4, 4, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6184; break; } else { __label__ = 13591; break; }
    case 6184: // $31270
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7814, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6185; break; } else { __label__ = 13591; break; }
    case 6185: // $31271
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7815, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6186; break; } else { __label__ = 13591; break; }
    case 6186: // $31272
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6187; break; } else { __label__ = 13591; break; }
    case 6187: // $31273
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6188; break; } else { __label__ = 13591; break; }
    case 6188: // $31274
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6189; break; } else { __label__ = 13591; break; }
    case 6189: // $31275
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6190; break; } else { __label__ = 13591; break; }
    case 6190: // $31276
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7812, $7813, $7814, $7815, $7816, $7817, $7818, $7819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6191; break; } else { __label__ = 13591; break; }
    case 6191: // $31277
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7821, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6192; break; } else { __label__ = 13591; break; }
    case 6192: // $31278
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7822, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6193; break; } else { __label__ = 13591; break; }
    case 6193: // $31279
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7823, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6194; break; } else { __label__ = 13591; break; }
    case 6194: // $31280
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6195; break; } else { __label__ = 13591; break; }
    case 6195: // $31281
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6196; break; } else { __label__ = 13591; break; }
    case 6196: // $31282
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6197; break; } else { __label__ = 13591; break; }
    case 6197: // $31283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6198; break; } else { __label__ = 13591; break; }
    case 6198: // $31284
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7820, $7821, $7822, $7823, $7824, $7825, $7826, $7827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6199; break; } else { __label__ = 13591; break; }
    case 6199: // $31285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7829, 4, 4, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6200; break; } else { __label__ = 13591; break; }
    case 6200: // $31286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7830, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6201; break; } else { __label__ = 13591; break; }
    case 6201: // $31287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7831, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6202; break; } else { __label__ = 13591; break; }
    case 6202: // $31288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6203; break; } else { __label__ = 13591; break; }
    case 6203: // $31289
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6204; break; } else { __label__ = 13591; break; }
    case 6204: // $31290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6205; break; } else { __label__ = 13591; break; }
    case 6205: // $31291
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6206; break; } else { __label__ = 13591; break; }
    case 6206: // $31292
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7828, $7829, $7830, $7831, $7832, $7833, $7834, $7835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6207; break; } else { __label__ = 13591; break; }
    case 6207: // $31293
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31269, 147, 5, 4, ((STRING_TABLE.__str954)|0), ((STRING_TABLE.__str955)|0), $7812, $7820, $7828) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6208; break; } else { __label__ = 13591; break; }
    case 6208: // $31294
      var $31295=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31269);
      var $31296=__ZN11simple_listI16input_type_entryE6appendERS0_($31230, $31295);
      var $31297=$4689;
      var $31298=$2769;
      var $31299=$2770;
      var $31300=$2771;
      var $31301=$result_i765;
      var $31302=$2772;
      var $31303=$2773;
      HEAP32[(($2769)>>2)]=408;
      HEAP32[(($2770)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2771)>>2)]=450;
      var $31304=HEAP32[(($2769)>>2)];
      var $31305=HEAP32[(($2770)>>2)];
      var $31306=HEAP32[(($2771)>>2)];
      var $31307=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31304, $31305, $31306) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6209; break; } else { __label__ = 6211; break; };
    case 6209: // $31308
      HEAP32[(($result_i765)>>2)]=$31307;
      var $31309=HEAP32[(($result_i765)>>2)];
      var $31310=(($31309)|0)==0;
      if ($31310) { __label__ = 6210; break; } else { __label__ = 6215; break; }
    case 6210: // $31311
      var $31312=___cxa_allocate_exception(4);
      var $31313=$31312;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31313);
      (function() { try { __THREW__ = false; return ___cxa_throw($31312, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6214; break; } else { __label__ = 6211; break; }
    case 6211: // $31314
      var $31315=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31316=$31315.f0;
      HEAP32[(($2772)>>2)]=$31316;
      var $31317=$31315.f1;
      HEAP32[(($2773)>>2)]=$31317;
      var $31318=HEAP32[(($2773)>>2)];
      var $31319=(($31318)|0) < 0;
      if ($31319) { __label__ = 6212; break; } else { __label__ = 6213; break; }
    case 6212: // $31320
      var $31321=HEAP32[(($2772)>>2)];
      ___cxa_call_unexpected($31321);
      throw "Reached an unreachable!"
    case 6213: // $31322
      var $31323=HEAP32[(($2772)>>2)];
      var $31324=HEAP32[(($2772)>>2)];
      var $31325=HEAP32[(($2773)>>2)];
      var $31326=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31324, tempValue);
      var $31327=($31326.f1 = $31325, $31326);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6214: // $31328
      throw "Reached an unreachable!"
    case 6215: // $_ZnwjPKci_exit766
      var $31329=HEAP32[(($result_i765)>>2)];
      var $31330=$2769;
      var $31331=$2770;
      var $31332=$2771;
      var $31333=$result_i765;
      var $31334=$2772;
      var $31335=$2773;
      var $31336=$31329;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7837, 4, 5, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6216; break; } else { __label__ = 13596; break; }
    case 6216: // $31337
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7838, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6217; break; } else { __label__ = 13596; break; }
    case 6217: // $31338
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7839, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6218; break; } else { __label__ = 13596; break; }
    case 6218: // $31339
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6219; break; } else { __label__ = 13596; break; }
    case 6219: // $31340
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6220; break; } else { __label__ = 13596; break; }
    case 6220: // $31341
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6221; break; } else { __label__ = 13596; break; }
    case 6221: // $31342
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6222; break; } else { __label__ = 13596; break; }
    case 6222: // $31343
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7836, $7837, $7838, $7839, $7840, $7841, $7842, $7843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6223; break; } else { __label__ = 13596; break; }
    case 6223: // $31344
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7845, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6224; break; } else { __label__ = 13596; break; }
    case 6224: // $31345
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7846, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6225; break; } else { __label__ = 13596; break; }
    case 6225: // $31346
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7847, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6226; break; } else { __label__ = 13596; break; }
    case 6226: // $31347
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6227; break; } else { __label__ = 13596; break; }
    case 6227: // $31348
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6228; break; } else { __label__ = 13596; break; }
    case 6228: // $31349
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6229; break; } else { __label__ = 13596; break; }
    case 6229: // $31350
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6230; break; } else { __label__ = 13596; break; }
    case 6230: // $31351
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7844, $7845, $7846, $7847, $7848, $7849, $7850, $7851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6231; break; } else { __label__ = 13596; break; }
    case 6231: // $31352
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7853, 4, 5, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6232; break; } else { __label__ = 13596; break; }
    case 6232: // $31353
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7854, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6233; break; } else { __label__ = 13596; break; }
    case 6233: // $31354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7855, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6234; break; } else { __label__ = 13596; break; }
    case 6234: // $31355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6235; break; } else { __label__ = 13596; break; }
    case 6235: // $31356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6236; break; } else { __label__ = 13596; break; }
    case 6236: // $31357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6237; break; } else { __label__ = 13596; break; }
    case 6237: // $31358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6238; break; } else { __label__ = 13596; break; }
    case 6238: // $31359
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7852, $7853, $7854, $7855, $7856, $7857, $7858, $7859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6239; break; } else { __label__ = 13596; break; }
    case 6239: // $31360
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31336, 147, 6, 5, ((STRING_TABLE.__str956)|0), ((STRING_TABLE.__str957)|0), $7836, $7844, $7852) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6240; break; } else { __label__ = 13596; break; }
    case 6240: // $31361
      var $31362=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31336);
      var $31363=__ZN11simple_listI16input_type_entryE6appendERS0_($31297, $31362);
      var $31364=$4689;
      var $31365=$2764;
      var $31366=$2765;
      var $31367=$2766;
      var $31368=$result_i767;
      var $31369=$2767;
      var $31370=$2768;
      HEAP32[(($2764)>>2)]=408;
      HEAP32[(($2765)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2766)>>2)]=451;
      var $31371=HEAP32[(($2764)>>2)];
      var $31372=HEAP32[(($2765)>>2)];
      var $31373=HEAP32[(($2766)>>2)];
      var $31374=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31371, $31372, $31373) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6241; break; } else { __label__ = 6243; break; };
    case 6241: // $31375
      HEAP32[(($result_i767)>>2)]=$31374;
      var $31376=HEAP32[(($result_i767)>>2)];
      var $31377=(($31376)|0)==0;
      if ($31377) { __label__ = 6242; break; } else { __label__ = 6247; break; }
    case 6242: // $31378
      var $31379=___cxa_allocate_exception(4);
      var $31380=$31379;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31380);
      (function() { try { __THREW__ = false; return ___cxa_throw($31379, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6246; break; } else { __label__ = 6243; break; }
    case 6243: // $31381
      var $31382=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31383=$31382.f0;
      HEAP32[(($2767)>>2)]=$31383;
      var $31384=$31382.f1;
      HEAP32[(($2768)>>2)]=$31384;
      var $31385=HEAP32[(($2768)>>2)];
      var $31386=(($31385)|0) < 0;
      if ($31386) { __label__ = 6244; break; } else { __label__ = 6245; break; }
    case 6244: // $31387
      var $31388=HEAP32[(($2767)>>2)];
      ___cxa_call_unexpected($31388);
      throw "Reached an unreachable!"
    case 6245: // $31389
      var $31390=HEAP32[(($2767)>>2)];
      var $31391=HEAP32[(($2767)>>2)];
      var $31392=HEAP32[(($2768)>>2)];
      var $31393=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31391, tempValue);
      var $31394=($31393.f1 = $31392, $31393);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6246: // $31395
      throw "Reached an unreachable!"
    case 6247: // $_ZnwjPKci_exit768
      var $31396=HEAP32[(($result_i767)>>2)];
      var $31397=$2764;
      var $31398=$2765;
      var $31399=$2766;
      var $31400=$result_i767;
      var $31401=$2767;
      var $31402=$2768;
      var $31403=$31396;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7861, 4, 6, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6248; break; } else { __label__ = 13601; break; }
    case 6248: // $31404
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7862, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6249; break; } else { __label__ = 13601; break; }
    case 6249: // $31405
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7863, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6250; break; } else { __label__ = 13601; break; }
    case 6250: // $31406
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6251; break; } else { __label__ = 13601; break; }
    case 6251: // $31407
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6252; break; } else { __label__ = 13601; break; }
    case 6252: // $31408
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6253; break; } else { __label__ = 13601; break; }
    case 6253: // $31409
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6254; break; } else { __label__ = 13601; break; }
    case 6254: // $31410
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7860, $7861, $7862, $7863, $7864, $7865, $7866, $7867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6255; break; } else { __label__ = 13601; break; }
    case 6255: // $31411
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7869, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6256; break; } else { __label__ = 13601; break; }
    case 6256: // $31412
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7870, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6257; break; } else { __label__ = 13601; break; }
    case 6257: // $31413
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7871, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6258; break; } else { __label__ = 13601; break; }
    case 6258: // $31414
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6259; break; } else { __label__ = 13601; break; }
    case 6259: // $31415
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6260; break; } else { __label__ = 13601; break; }
    case 6260: // $31416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6261; break; } else { __label__ = 13601; break; }
    case 6261: // $31417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6262; break; } else { __label__ = 13601; break; }
    case 6262: // $31418
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7868, $7869, $7870, $7871, $7872, $7873, $7874, $7875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6263; break; } else { __label__ = 13601; break; }
    case 6263: // $31419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7877, 4, 6, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6264; break; } else { __label__ = 13601; break; }
    case 6264: // $31420
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7878, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6265; break; } else { __label__ = 13601; break; }
    case 6265: // $31421
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7879, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6266; break; } else { __label__ = 13601; break; }
    case 6266: // $31422
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6267; break; } else { __label__ = 13601; break; }
    case 6267: // $31423
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6268; break; } else { __label__ = 13601; break; }
    case 6268: // $31424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6269; break; } else { __label__ = 13601; break; }
    case 6269: // $31425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6270; break; } else { __label__ = 13601; break; }
    case 6270: // $31426
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7876, $7877, $7878, $7879, $7880, $7881, $7882, $7883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6271; break; } else { __label__ = 13601; break; }
    case 6271: // $31427
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31403, 147, 7, 6, ((STRING_TABLE.__str958)|0), ((STRING_TABLE.__str959)|0), $7860, $7868, $7876) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6272; break; } else { __label__ = 13601; break; }
    case 6272: // $31428
      var $31429=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31403);
      var $31430=__ZN11simple_listI16input_type_entryE6appendERS0_($31364, $31429);
      var $31431=$4689;
      var $31432=$2759;
      var $31433=$2760;
      var $31434=$2761;
      var $31435=$result_i769;
      var $31436=$2762;
      var $31437=$2763;
      HEAP32[(($2759)>>2)]=408;
      HEAP32[(($2760)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2761)>>2)]=452;
      var $31438=HEAP32[(($2759)>>2)];
      var $31439=HEAP32[(($2760)>>2)];
      var $31440=HEAP32[(($2761)>>2)];
      var $31441=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31438, $31439, $31440) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6273; break; } else { __label__ = 6275; break; };
    case 6273: // $31442
      HEAP32[(($result_i769)>>2)]=$31441;
      var $31443=HEAP32[(($result_i769)>>2)];
      var $31444=(($31443)|0)==0;
      if ($31444) { __label__ = 6274; break; } else { __label__ = 6279; break; }
    case 6274: // $31445
      var $31446=___cxa_allocate_exception(4);
      var $31447=$31446;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31447);
      (function() { try { __THREW__ = false; return ___cxa_throw($31446, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6278; break; } else { __label__ = 6275; break; }
    case 6275: // $31448
      var $31449=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31450=$31449.f0;
      HEAP32[(($2762)>>2)]=$31450;
      var $31451=$31449.f1;
      HEAP32[(($2763)>>2)]=$31451;
      var $31452=HEAP32[(($2763)>>2)];
      var $31453=(($31452)|0) < 0;
      if ($31453) { __label__ = 6276; break; } else { __label__ = 6277; break; }
    case 6276: // $31454
      var $31455=HEAP32[(($2762)>>2)];
      ___cxa_call_unexpected($31455);
      throw "Reached an unreachable!"
    case 6277: // $31456
      var $31457=HEAP32[(($2762)>>2)];
      var $31458=HEAP32[(($2762)>>2)];
      var $31459=HEAP32[(($2763)>>2)];
      var $31460=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31458, tempValue);
      var $31461=($31460.f1 = $31459, $31460);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6278: // $31462
      throw "Reached an unreachable!"
    case 6279: // $_ZnwjPKci_exit770
      var $31463=HEAP32[(($result_i769)>>2)];
      var $31464=$2759;
      var $31465=$2760;
      var $31466=$2761;
      var $31467=$result_i769;
      var $31468=$2762;
      var $31469=$2763;
      var $31470=$31463;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7885, 4, 7, 2, 2, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6280; break; } else { __label__ = 13606; break; }
    case 6280: // $31471
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7886, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6281; break; } else { __label__ = 13606; break; }
    case 6281: // $31472
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7887, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6282; break; } else { __label__ = 13606; break; }
    case 6282: // $31473
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6283; break; } else { __label__ = 13606; break; }
    case 6283: // $31474
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6284; break; } else { __label__ = 13606; break; }
    case 6284: // $31475
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6285; break; } else { __label__ = 13606; break; }
    case 6285: // $31476
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6286; break; } else { __label__ = 13606; break; }
    case 6286: // $31477
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7884, $7885, $7886, $7887, $7888, $7889, $7890, $7891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6287; break; } else { __label__ = 13606; break; }
    case 6287: // $31478
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7893, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6288; break; } else { __label__ = 13606; break; }
    case 6288: // $31479
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7894, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6289; break; } else { __label__ = 13606; break; }
    case 6289: // $31480
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7895, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6290; break; } else { __label__ = 13606; break; }
    case 6290: // $31481
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6291; break; } else { __label__ = 13606; break; }
    case 6291: // $31482
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6292; break; } else { __label__ = 13606; break; }
    case 6292: // $31483
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6293; break; } else { __label__ = 13606; break; }
    case 6293: // $31484
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6294; break; } else { __label__ = 13606; break; }
    case 6294: // $31485
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7892, $7893, $7894, $7895, $7896, $7897, $7898, $7899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6295; break; } else { __label__ = 13606; break; }
    case 6295: // $31486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7901, 4, 7, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6296; break; } else { __label__ = 13606; break; }
    case 6296: // $31487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7902, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6297; break; } else { __label__ = 13606; break; }
    case 6297: // $31488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7903, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6298; break; } else { __label__ = 13606; break; }
    case 6298: // $31489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6299; break; } else { __label__ = 13606; break; }
    case 6299: // $31490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6300; break; } else { __label__ = 13606; break; }
    case 6300: // $31491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6301; break; } else { __label__ = 13606; break; }
    case 6301: // $31492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6302; break; } else { __label__ = 13606; break; }
    case 6302: // $31493
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7900, $7901, $7902, $7903, $7904, $7905, $7906, $7907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6303; break; } else { __label__ = 13606; break; }
    case 6303: // $31494
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31470, 147, 8, 7, ((STRING_TABLE.__str960)|0), ((STRING_TABLE.__str961)|0), $7884, $7892, $7900) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6304; break; } else { __label__ = 13606; break; }
    case 6304: // $31495
      var $31496=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31470);
      var $31497=__ZN11simple_listI16input_type_entryE6appendERS0_($31431, $31496);
      var $31498=$4689;
      var $31499=$2754;
      var $31500=$2755;
      var $31501=$2756;
      var $31502=$result_i771;
      var $31503=$2757;
      var $31504=$2758;
      HEAP32[(($2754)>>2)]=408;
      HEAP32[(($2755)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2756)>>2)]=454;
      var $31505=HEAP32[(($2754)>>2)];
      var $31506=HEAP32[(($2755)>>2)];
      var $31507=HEAP32[(($2756)>>2)];
      var $31508=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31505, $31506, $31507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6305; break; } else { __label__ = 6307; break; };
    case 6305: // $31509
      HEAP32[(($result_i771)>>2)]=$31508;
      var $31510=HEAP32[(($result_i771)>>2)];
      var $31511=(($31510)|0)==0;
      if ($31511) { __label__ = 6306; break; } else { __label__ = 6311; break; }
    case 6306: // $31512
      var $31513=___cxa_allocate_exception(4);
      var $31514=$31513;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31514);
      (function() { try { __THREW__ = false; return ___cxa_throw($31513, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6310; break; } else { __label__ = 6307; break; }
    case 6307: // $31515
      var $31516=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31517=$31516.f0;
      HEAP32[(($2757)>>2)]=$31517;
      var $31518=$31516.f1;
      HEAP32[(($2758)>>2)]=$31518;
      var $31519=HEAP32[(($2758)>>2)];
      var $31520=(($31519)|0) < 0;
      if ($31520) { __label__ = 6308; break; } else { __label__ = 6309; break; }
    case 6308: // $31521
      var $31522=HEAP32[(($2757)>>2)];
      ___cxa_call_unexpected($31522);
      throw "Reached an unreachable!"
    case 6309: // $31523
      var $31524=HEAP32[(($2757)>>2)];
      var $31525=HEAP32[(($2757)>>2)];
      var $31526=HEAP32[(($2758)>>2)];
      var $31527=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31525, tempValue);
      var $31528=($31527.f1 = $31526, $31527);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6310: // $31529
      throw "Reached an unreachable!"
    case 6311: // $_ZnwjPKci_exit772
      var $31530=HEAP32[(($result_i771)>>2)];
      var $31531=$2754;
      var $31532=$2755;
      var $31533=$2756;
      var $31534=$result_i771;
      var $31535=$2757;
      var $31536=$2758;
      var $31537=$31530;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7909, 4, 0, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6312; break; } else { __label__ = 13611; break; }
    case 6312: // $31538
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7910, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6313; break; } else { __label__ = 13611; break; }
    case 6313: // $31539
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7911, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6314; break; } else { __label__ = 13611; break; }
    case 6314: // $31540
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6315; break; } else { __label__ = 13611; break; }
    case 6315: // $31541
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6316; break; } else { __label__ = 13611; break; }
    case 6316: // $31542
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6317; break; } else { __label__ = 13611; break; }
    case 6317: // $31543
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6318; break; } else { __label__ = 13611; break; }
    case 6318: // $31544
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7908, $7909, $7910, $7911, $7912, $7913, $7914, $7915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6319; break; } else { __label__ = 13611; break; }
    case 6319: // $31545
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7917, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6320; break; } else { __label__ = 13611; break; }
    case 6320: // $31546
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7918, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6321; break; } else { __label__ = 13611; break; }
    case 6321: // $31547
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7919, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6322; break; } else { __label__ = 13611; break; }
    case 6322: // $31548
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6323; break; } else { __label__ = 13611; break; }
    case 6323: // $31549
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6324; break; } else { __label__ = 13611; break; }
    case 6324: // $31550
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6325; break; } else { __label__ = 13611; break; }
    case 6325: // $31551
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6326; break; } else { __label__ = 13611; break; }
    case 6326: // $31552
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7916, $7917, $7918, $7919, $7920, $7921, $7922, $7923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6327; break; } else { __label__ = 13611; break; }
    case 6327: // $31553
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7925, 1, 0, 1, 0, 101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6328; break; } else { __label__ = 13611; break; }
    case 6328: // $31554
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7926, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6329; break; } else { __label__ = 13611; break; }
    case 6329: // $31555
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7927, 4, 0, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6330; break; } else { __label__ = 13611; break; }
    case 6330: // $31556
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6331; break; } else { __label__ = 13611; break; }
    case 6331: // $31557
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6332; break; } else { __label__ = 13611; break; }
    case 6332: // $31558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6333; break; } else { __label__ = 13611; break; }
    case 6333: // $31559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6334; break; } else { __label__ = 13611; break; }
    case 6334: // $31560
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7924, $7925, $7926, $7927, $7928, $7929, $7930, $7931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6335; break; } else { __label__ = 13611; break; }
    case 6335: // $31561
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31537, 148, 1, 0, ((STRING_TABLE.__str962)|0), ((STRING_TABLE.__str963)|0), $7908, $7916, $7924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6336; break; } else { __label__ = 13611; break; }
    case 6336: // $31562
      var $31563=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31537);
      var $31564=__ZN11simple_listI16input_type_entryE6appendERS0_($31498, $31563);
      var $31565=$4689;
      var $31566=$2749;
      var $31567=$2750;
      var $31568=$2751;
      var $31569=$result_i773;
      var $31570=$2752;
      var $31571=$2753;
      HEAP32[(($2749)>>2)]=408;
      HEAP32[(($2750)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2751)>>2)]=455;
      var $31572=HEAP32[(($2749)>>2)];
      var $31573=HEAP32[(($2750)>>2)];
      var $31574=HEAP32[(($2751)>>2)];
      var $31575=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31572, $31573, $31574) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6337; break; } else { __label__ = 6339; break; };
    case 6337: // $31576
      HEAP32[(($result_i773)>>2)]=$31575;
      var $31577=HEAP32[(($result_i773)>>2)];
      var $31578=(($31577)|0)==0;
      if ($31578) { __label__ = 6338; break; } else { __label__ = 6343; break; }
    case 6338: // $31579
      var $31580=___cxa_allocate_exception(4);
      var $31581=$31580;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31581);
      (function() { try { __THREW__ = false; return ___cxa_throw($31580, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6342; break; } else { __label__ = 6339; break; }
    case 6339: // $31582
      var $31583=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31584=$31583.f0;
      HEAP32[(($2752)>>2)]=$31584;
      var $31585=$31583.f1;
      HEAP32[(($2753)>>2)]=$31585;
      var $31586=HEAP32[(($2753)>>2)];
      var $31587=(($31586)|0) < 0;
      if ($31587) { __label__ = 6340; break; } else { __label__ = 6341; break; }
    case 6340: // $31588
      var $31589=HEAP32[(($2752)>>2)];
      ___cxa_call_unexpected($31589);
      throw "Reached an unreachable!"
    case 6341: // $31590
      var $31591=HEAP32[(($2752)>>2)];
      var $31592=HEAP32[(($2752)>>2)];
      var $31593=HEAP32[(($2753)>>2)];
      var $31594=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31592, tempValue);
      var $31595=($31594.f1 = $31593, $31594);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6342: // $31596
      throw "Reached an unreachable!"
    case 6343: // $_ZnwjPKci_exit774
      var $31597=HEAP32[(($result_i773)>>2)];
      var $31598=$2749;
      var $31599=$2750;
      var $31600=$2751;
      var $31601=$result_i773;
      var $31602=$2752;
      var $31603=$2753;
      var $31604=$31597;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7933, 4, 1, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6344; break; } else { __label__ = 13616; break; }
    case 6344: // $31605
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7934, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6345; break; } else { __label__ = 13616; break; }
    case 6345: // $31606
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7935, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6346; break; } else { __label__ = 13616; break; }
    case 6346: // $31607
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6347; break; } else { __label__ = 13616; break; }
    case 6347: // $31608
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6348; break; } else { __label__ = 13616; break; }
    case 6348: // $31609
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6349; break; } else { __label__ = 13616; break; }
    case 6349: // $31610
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6350; break; } else { __label__ = 13616; break; }
    case 6350: // $31611
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7932, $7933, $7934, $7935, $7936, $7937, $7938, $7939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6351; break; } else { __label__ = 13616; break; }
    case 6351: // $31612
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7941, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6352; break; } else { __label__ = 13616; break; }
    case 6352: // $31613
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7942, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6353; break; } else { __label__ = 13616; break; }
    case 6353: // $31614
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7943, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6354; break; } else { __label__ = 13616; break; }
    case 6354: // $31615
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6355; break; } else { __label__ = 13616; break; }
    case 6355: // $31616
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6356; break; } else { __label__ = 13616; break; }
    case 6356: // $31617
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6357; break; } else { __label__ = 13616; break; }
    case 6357: // $31618
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6358; break; } else { __label__ = 13616; break; }
    case 6358: // $31619
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7940, $7941, $7942, $7943, $7944, $7945, $7946, $7947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6359; break; } else { __label__ = 13616; break; }
    case 6359: // $31620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7949, 1, 0, 1, 0, 19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6360; break; } else { __label__ = 13616; break; }
    case 6360: // $31621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7950, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6361; break; } else { __label__ = 13616; break; }
    case 6361: // $31622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7951, 4, 1, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6362; break; } else { __label__ = 13616; break; }
    case 6362: // $31623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6363; break; } else { __label__ = 13616; break; }
    case 6363: // $31624
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6364; break; } else { __label__ = 13616; break; }
    case 6364: // $31625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6365; break; } else { __label__ = 13616; break; }
    case 6365: // $31626
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6366; break; } else { __label__ = 13616; break; }
    case 6366: // $31627
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7948, $7949, $7950, $7951, $7952, $7953, $7954, $7955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6367; break; } else { __label__ = 13616; break; }
    case 6367: // $31628
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31604, 148, 2, 1, ((STRING_TABLE.__str964)|0), ((STRING_TABLE.__str965)|0), $7932, $7940, $7948) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6368; break; } else { __label__ = 13616; break; }
    case 6368: // $31629
      var $31630=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31604);
      var $31631=__ZN11simple_listI16input_type_entryE6appendERS0_($31565, $31630);
      var $31632=$4689;
      var $31633=$2744;
      var $31634=$2745;
      var $31635=$2746;
      var $31636=$result_i775;
      var $31637=$2747;
      var $31638=$2748;
      HEAP32[(($2744)>>2)]=408;
      HEAP32[(($2745)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2746)>>2)]=456;
      var $31639=HEAP32[(($2744)>>2)];
      var $31640=HEAP32[(($2745)>>2)];
      var $31641=HEAP32[(($2746)>>2)];
      var $31642=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31639, $31640, $31641) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6369; break; } else { __label__ = 6371; break; };
    case 6369: // $31643
      HEAP32[(($result_i775)>>2)]=$31642;
      var $31644=HEAP32[(($result_i775)>>2)];
      var $31645=(($31644)|0)==0;
      if ($31645) { __label__ = 6370; break; } else { __label__ = 6375; break; }
    case 6370: // $31646
      var $31647=___cxa_allocate_exception(4);
      var $31648=$31647;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31648);
      (function() { try { __THREW__ = false; return ___cxa_throw($31647, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6374; break; } else { __label__ = 6371; break; }
    case 6371: // $31649
      var $31650=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31651=$31650.f0;
      HEAP32[(($2747)>>2)]=$31651;
      var $31652=$31650.f1;
      HEAP32[(($2748)>>2)]=$31652;
      var $31653=HEAP32[(($2748)>>2)];
      var $31654=(($31653)|0) < 0;
      if ($31654) { __label__ = 6372; break; } else { __label__ = 6373; break; }
    case 6372: // $31655
      var $31656=HEAP32[(($2747)>>2)];
      ___cxa_call_unexpected($31656);
      throw "Reached an unreachable!"
    case 6373: // $31657
      var $31658=HEAP32[(($2747)>>2)];
      var $31659=HEAP32[(($2747)>>2)];
      var $31660=HEAP32[(($2748)>>2)];
      var $31661=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31659, tempValue);
      var $31662=($31661.f1 = $31660, $31661);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6374: // $31663
      throw "Reached an unreachable!"
    case 6375: // $_ZnwjPKci_exit776
      var $31664=HEAP32[(($result_i775)>>2)];
      var $31665=$2744;
      var $31666=$2745;
      var $31667=$2746;
      var $31668=$result_i775;
      var $31669=$2747;
      var $31670=$2748;
      var $31671=$31664;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7957, 4, 2, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6376; break; } else { __label__ = 13621; break; }
    case 6376: // $31672
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6377; break; } else { __label__ = 13621; break; }
    case 6377: // $31673
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6378; break; } else { __label__ = 13621; break; }
    case 6378: // $31674
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6379; break; } else { __label__ = 13621; break; }
    case 6379: // $31675
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6380; break; } else { __label__ = 13621; break; }
    case 6380: // $31676
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6381; break; } else { __label__ = 13621; break; }
    case 6381: // $31677
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6382; break; } else { __label__ = 13621; break; }
    case 6382: // $31678
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7956, $7957, $7958, $7959, $7960, $7961, $7962, $7963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6383; break; } else { __label__ = 13621; break; }
    case 6383: // $31679
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7965, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6384; break; } else { __label__ = 13621; break; }
    case 6384: // $31680
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7966, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6385; break; } else { __label__ = 13621; break; }
    case 6385: // $31681
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7967, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6386; break; } else { __label__ = 13621; break; }
    case 6386: // $31682
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6387; break; } else { __label__ = 13621; break; }
    case 6387: // $31683
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6388; break; } else { __label__ = 13621; break; }
    case 6388: // $31684
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6389; break; } else { __label__ = 13621; break; }
    case 6389: // $31685
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6390; break; } else { __label__ = 13621; break; }
    case 6390: // $31686
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7964, $7965, $7966, $7967, $7968, $7969, $7970, $7971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6391; break; } else { __label__ = 13621; break; }
    case 6391: // $31687
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7973, 1, 0, 1, 0, 98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6392; break; } else { __label__ = 13621; break; }
    case 6392: // $31688
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7974, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6393; break; } else { __label__ = 13621; break; }
    case 6393: // $31689
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7975, 4, 2, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6394; break; } else { __label__ = 13621; break; }
    case 6394: // $31690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6395; break; } else { __label__ = 13621; break; }
    case 6395: // $31691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6396; break; } else { __label__ = 13621; break; }
    case 6396: // $31692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6397; break; } else { __label__ = 13621; break; }
    case 6397: // $31693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6398; break; } else { __label__ = 13621; break; }
    case 6398: // $31694
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7972, $7973, $7974, $7975, $7976, $7977, $7978, $7979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6399; break; } else { __label__ = 13621; break; }
    case 6399: // $31695
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31671, 148, 3, 2, ((STRING_TABLE.__str966)|0), ((STRING_TABLE.__str967)|0), $7956, $7964, $7972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6400; break; } else { __label__ = 13621; break; }
    case 6400: // $31696
      var $31697=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31671);
      var $31698=__ZN11simple_listI16input_type_entryE6appendERS0_($31632, $31697);
      var $31699=$4689;
      var $31700=$2739;
      var $31701=$2740;
      var $31702=$2741;
      var $31703=$result_i777;
      var $31704=$2742;
      var $31705=$2743;
      HEAP32[(($2739)>>2)]=408;
      HEAP32[(($2740)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2741)>>2)]=457;
      var $31706=HEAP32[(($2739)>>2)];
      var $31707=HEAP32[(($2740)>>2)];
      var $31708=HEAP32[(($2741)>>2)];
      var $31709=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31706, $31707, $31708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6401; break; } else { __label__ = 6403; break; };
    case 6401: // $31710
      HEAP32[(($result_i777)>>2)]=$31709;
      var $31711=HEAP32[(($result_i777)>>2)];
      var $31712=(($31711)|0)==0;
      if ($31712) { __label__ = 6402; break; } else { __label__ = 6407; break; }
    case 6402: // $31713
      var $31714=___cxa_allocate_exception(4);
      var $31715=$31714;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31715);
      (function() { try { __THREW__ = false; return ___cxa_throw($31714, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6406; break; } else { __label__ = 6403; break; }
    case 6403: // $31716
      var $31717=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31718=$31717.f0;
      HEAP32[(($2742)>>2)]=$31718;
      var $31719=$31717.f1;
      HEAP32[(($2743)>>2)]=$31719;
      var $31720=HEAP32[(($2743)>>2)];
      var $31721=(($31720)|0) < 0;
      if ($31721) { __label__ = 6404; break; } else { __label__ = 6405; break; }
    case 6404: // $31722
      var $31723=HEAP32[(($2742)>>2)];
      ___cxa_call_unexpected($31723);
      throw "Reached an unreachable!"
    case 6405: // $31724
      var $31725=HEAP32[(($2742)>>2)];
      var $31726=HEAP32[(($2742)>>2)];
      var $31727=HEAP32[(($2743)>>2)];
      var $31728=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31726, tempValue);
      var $31729=($31728.f1 = $31727, $31728);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6406: // $31730
      throw "Reached an unreachable!"
    case 6407: // $_ZnwjPKci_exit778
      var $31731=HEAP32[(($result_i777)>>2)];
      var $31732=$2739;
      var $31733=$2740;
      var $31734=$2741;
      var $31735=$result_i777;
      var $31736=$2742;
      var $31737=$2743;
      var $31738=$31731;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7981, 4, 3, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6408; break; } else { __label__ = 13626; break; }
    case 6408: // $31739
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6409; break; } else { __label__ = 13626; break; }
    case 6409: // $31740
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6410; break; } else { __label__ = 13626; break; }
    case 6410: // $31741
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6411; break; } else { __label__ = 13626; break; }
    case 6411: // $31742
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6412; break; } else { __label__ = 13626; break; }
    case 6412: // $31743
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6413; break; } else { __label__ = 13626; break; }
    case 6413: // $31744
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6414; break; } else { __label__ = 13626; break; }
    case 6414: // $31745
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7980, $7981, $7982, $7983, $7984, $7985, $7986, $7987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6415; break; } else { __label__ = 13626; break; }
    case 6415: // $31746
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7989, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6416; break; } else { __label__ = 13626; break; }
    case 6416: // $31747
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7990, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6417; break; } else { __label__ = 13626; break; }
    case 6417: // $31748
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7991, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6418; break; } else { __label__ = 13626; break; }
    case 6418: // $31749
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6419; break; } else { __label__ = 13626; break; }
    case 6419: // $31750
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6420; break; } else { __label__ = 13626; break; }
    case 6420: // $31751
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6421; break; } else { __label__ = 13626; break; }
    case 6421: // $31752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6422; break; } else { __label__ = 13626; break; }
    case 6422: // $31753
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7988, $7989, $7990, $7991, $7992, $7993, $7994, $7995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6423; break; } else { __label__ = 13626; break; }
    case 6423: // $31754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7997, 1, 0, 1, 0, 93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6424; break; } else { __label__ = 13626; break; }
    case 6424: // $31755
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($7998, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6425; break; } else { __label__ = 13626; break; }
    case 6425: // $31756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7999, 4, 3, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6426; break; } else { __label__ = 13626; break; }
    case 6426: // $31757
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6427; break; } else { __label__ = 13626; break; }
    case 6427: // $31758
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6428; break; } else { __label__ = 13626; break; }
    case 6428: // $31759
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6429; break; } else { __label__ = 13626; break; }
    case 6429: // $31760
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6430; break; } else { __label__ = 13626; break; }
    case 6430: // $31761
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($7996, $7997, $7998, $7999, $8000, $8001, $8002, $8003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6431; break; } else { __label__ = 13626; break; }
    case 6431: // $31762
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31738, 148, 4, 3, ((STRING_TABLE.__str968)|0), ((STRING_TABLE.__str969)|0), $7980, $7988, $7996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6432; break; } else { __label__ = 13626; break; }
    case 6432: // $31763
      var $31764=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31738);
      var $31765=__ZN11simple_listI16input_type_entryE6appendERS0_($31699, $31764);
      var $31766=$4689;
      var $31767=$2734;
      var $31768=$2735;
      var $31769=$2736;
      var $31770=$result_i779;
      var $31771=$2737;
      var $31772=$2738;
      HEAP32[(($2734)>>2)]=408;
      HEAP32[(($2735)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2736)>>2)]=458;
      var $31773=HEAP32[(($2734)>>2)];
      var $31774=HEAP32[(($2735)>>2)];
      var $31775=HEAP32[(($2736)>>2)];
      var $31776=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31773, $31774, $31775) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6433; break; } else { __label__ = 6435; break; };
    case 6433: // $31777
      HEAP32[(($result_i779)>>2)]=$31776;
      var $31778=HEAP32[(($result_i779)>>2)];
      var $31779=(($31778)|0)==0;
      if ($31779) { __label__ = 6434; break; } else { __label__ = 6439; break; }
    case 6434: // $31780
      var $31781=___cxa_allocate_exception(4);
      var $31782=$31781;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31782);
      (function() { try { __THREW__ = false; return ___cxa_throw($31781, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6438; break; } else { __label__ = 6435; break; }
    case 6435: // $31783
      var $31784=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31785=$31784.f0;
      HEAP32[(($2737)>>2)]=$31785;
      var $31786=$31784.f1;
      HEAP32[(($2738)>>2)]=$31786;
      var $31787=HEAP32[(($2738)>>2)];
      var $31788=(($31787)|0) < 0;
      if ($31788) { __label__ = 6436; break; } else { __label__ = 6437; break; }
    case 6436: // $31789
      var $31790=HEAP32[(($2737)>>2)];
      ___cxa_call_unexpected($31790);
      throw "Reached an unreachable!"
    case 6437: // $31791
      var $31792=HEAP32[(($2737)>>2)];
      var $31793=HEAP32[(($2737)>>2)];
      var $31794=HEAP32[(($2738)>>2)];
      var $31795=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31793, tempValue);
      var $31796=($31795.f1 = $31794, $31795);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6438: // $31797
      throw "Reached an unreachable!"
    case 6439: // $_ZnwjPKci_exit780
      var $31798=HEAP32[(($result_i779)>>2)];
      var $31799=$2734;
      var $31800=$2735;
      var $31801=$2736;
      var $31802=$result_i779;
      var $31803=$2737;
      var $31804=$2738;
      var $31805=$31798;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8005, 4, 4, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6440; break; } else { __label__ = 13631; break; }
    case 6440: // $31806
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8006, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6441; break; } else { __label__ = 13631; break; }
    case 6441: // $31807
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8007, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6442; break; } else { __label__ = 13631; break; }
    case 6442: // $31808
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6443; break; } else { __label__ = 13631; break; }
    case 6443: // $31809
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6444; break; } else { __label__ = 13631; break; }
    case 6444: // $31810
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6445; break; } else { __label__ = 13631; break; }
    case 6445: // $31811
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6446; break; } else { __label__ = 13631; break; }
    case 6446: // $31812
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8004, $8005, $8006, $8007, $8008, $8009, $8010, $8011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6447; break; } else { __label__ = 13631; break; }
    case 6447: // $31813
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8013, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6448; break; } else { __label__ = 13631; break; }
    case 6448: // $31814
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8014, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6449; break; } else { __label__ = 13631; break; }
    case 6449: // $31815
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8015, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6450; break; } else { __label__ = 13631; break; }
    case 6450: // $31816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6451; break; } else { __label__ = 13631; break; }
    case 6451: // $31817
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6452; break; } else { __label__ = 13631; break; }
    case 6452: // $31818
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6453; break; } else { __label__ = 13631; break; }
    case 6453: // $31819
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6454; break; } else { __label__ = 13631; break; }
    case 6454: // $31820
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8012, $8013, $8014, $8015, $8016, $8017, $8018, $8019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6455; break; } else { __label__ = 13631; break; }
    case 6455: // $31821
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8021, 4, 4, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6456; break; } else { __label__ = 13631; break; }
    case 6456: // $31822
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8022, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6457; break; } else { __label__ = 13631; break; }
    case 6457: // $31823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8023, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6458; break; } else { __label__ = 13631; break; }
    case 6458: // $31824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6459; break; } else { __label__ = 13631; break; }
    case 6459: // $31825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6460; break; } else { __label__ = 13631; break; }
    case 6460: // $31826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6461; break; } else { __label__ = 13631; break; }
    case 6461: // $31827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6462; break; } else { __label__ = 13631; break; }
    case 6462: // $31828
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8020, $8021, $8022, $8023, $8024, $8025, $8026, $8027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6463; break; } else { __label__ = 13631; break; }
    case 6463: // $31829
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31805, 148, 5, 4, ((STRING_TABLE.__str970)|0), ((STRING_TABLE.__str971)|0), $8004, $8012, $8020) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6464; break; } else { __label__ = 13631; break; }
    case 6464: // $31830
      var $31831=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31805);
      var $31832=__ZN11simple_listI16input_type_entryE6appendERS0_($31766, $31831);
      var $31833=$4689;
      var $31834=$2729;
      var $31835=$2730;
      var $31836=$2731;
      var $31837=$result_i781;
      var $31838=$2732;
      var $31839=$2733;
      HEAP32[(($2729)>>2)]=408;
      HEAP32[(($2730)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2731)>>2)]=459;
      var $31840=HEAP32[(($2729)>>2)];
      var $31841=HEAP32[(($2730)>>2)];
      var $31842=HEAP32[(($2731)>>2)];
      var $31843=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31840, $31841, $31842) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6465; break; } else { __label__ = 6467; break; };
    case 6465: // $31844
      HEAP32[(($result_i781)>>2)]=$31843;
      var $31845=HEAP32[(($result_i781)>>2)];
      var $31846=(($31845)|0)==0;
      if ($31846) { __label__ = 6466; break; } else { __label__ = 6471; break; }
    case 6466: // $31847
      var $31848=___cxa_allocate_exception(4);
      var $31849=$31848;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31849);
      (function() { try { __THREW__ = false; return ___cxa_throw($31848, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6470; break; } else { __label__ = 6467; break; }
    case 6467: // $31850
      var $31851=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31852=$31851.f0;
      HEAP32[(($2732)>>2)]=$31852;
      var $31853=$31851.f1;
      HEAP32[(($2733)>>2)]=$31853;
      var $31854=HEAP32[(($2733)>>2)];
      var $31855=(($31854)|0) < 0;
      if ($31855) { __label__ = 6468; break; } else { __label__ = 6469; break; }
    case 6468: // $31856
      var $31857=HEAP32[(($2732)>>2)];
      ___cxa_call_unexpected($31857);
      throw "Reached an unreachable!"
    case 6469: // $31858
      var $31859=HEAP32[(($2732)>>2)];
      var $31860=HEAP32[(($2732)>>2)];
      var $31861=HEAP32[(($2733)>>2)];
      var $31862=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31860, tempValue);
      var $31863=($31862.f1 = $31861, $31862);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6470: // $31864
      throw "Reached an unreachable!"
    case 6471: // $_ZnwjPKci_exit782
      var $31865=HEAP32[(($result_i781)>>2)];
      var $31866=$2729;
      var $31867=$2730;
      var $31868=$2731;
      var $31869=$result_i781;
      var $31870=$2732;
      var $31871=$2733;
      var $31872=$31865;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8029, 4, 5, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6472; break; } else { __label__ = 13636; break; }
    case 6472: // $31873
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8030, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6473; break; } else { __label__ = 13636; break; }
    case 6473: // $31874
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8031, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6474; break; } else { __label__ = 13636; break; }
    case 6474: // $31875
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6475; break; } else { __label__ = 13636; break; }
    case 6475: // $31876
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6476; break; } else { __label__ = 13636; break; }
    case 6476: // $31877
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6477; break; } else { __label__ = 13636; break; }
    case 6477: // $31878
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6478; break; } else { __label__ = 13636; break; }
    case 6478: // $31879
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8028, $8029, $8030, $8031, $8032, $8033, $8034, $8035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6479; break; } else { __label__ = 13636; break; }
    case 6479: // $31880
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8037, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6480; break; } else { __label__ = 13636; break; }
    case 6480: // $31881
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8038, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6481; break; } else { __label__ = 13636; break; }
    case 6481: // $31882
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8039, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6482; break; } else { __label__ = 13636; break; }
    case 6482: // $31883
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6483; break; } else { __label__ = 13636; break; }
    case 6483: // $31884
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6484; break; } else { __label__ = 13636; break; }
    case 6484: // $31885
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6485; break; } else { __label__ = 13636; break; }
    case 6485: // $31886
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6486; break; } else { __label__ = 13636; break; }
    case 6486: // $31887
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8036, $8037, $8038, $8039, $8040, $8041, $8042, $8043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6487; break; } else { __label__ = 13636; break; }
    case 6487: // $31888
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8045, 4, 5, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6488; break; } else { __label__ = 13636; break; }
    case 6488: // $31889
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8046, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6489; break; } else { __label__ = 13636; break; }
    case 6489: // $31890
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8047, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6490; break; } else { __label__ = 13636; break; }
    case 6490: // $31891
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6491; break; } else { __label__ = 13636; break; }
    case 6491: // $31892
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6492; break; } else { __label__ = 13636; break; }
    case 6492: // $31893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6493; break; } else { __label__ = 13636; break; }
    case 6493: // $31894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6494; break; } else { __label__ = 13636; break; }
    case 6494: // $31895
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8044, $8045, $8046, $8047, $8048, $8049, $8050, $8051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6495; break; } else { __label__ = 13636; break; }
    case 6495: // $31896
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31872, 148, 6, 5, ((STRING_TABLE.__str972)|0), ((STRING_TABLE.__str973)|0), $8028, $8036, $8044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6496; break; } else { __label__ = 13636; break; }
    case 6496: // $31897
      var $31898=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31872);
      var $31899=__ZN11simple_listI16input_type_entryE6appendERS0_($31833, $31898);
      var $31900=$4689;
      var $31901=$2724;
      var $31902=$2725;
      var $31903=$2726;
      var $31904=$result_i783;
      var $31905=$2727;
      var $31906=$2728;
      HEAP32[(($2724)>>2)]=408;
      HEAP32[(($2725)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2726)>>2)]=460;
      var $31907=HEAP32[(($2724)>>2)];
      var $31908=HEAP32[(($2725)>>2)];
      var $31909=HEAP32[(($2726)>>2)];
      var $31910=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31907, $31908, $31909) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6497; break; } else { __label__ = 6499; break; };
    case 6497: // $31911
      HEAP32[(($result_i783)>>2)]=$31910;
      var $31912=HEAP32[(($result_i783)>>2)];
      var $31913=(($31912)|0)==0;
      if ($31913) { __label__ = 6498; break; } else { __label__ = 6503; break; }
    case 6498: // $31914
      var $31915=___cxa_allocate_exception(4);
      var $31916=$31915;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31916);
      (function() { try { __THREW__ = false; return ___cxa_throw($31915, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6502; break; } else { __label__ = 6499; break; }
    case 6499: // $31917
      var $31918=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31919=$31918.f0;
      HEAP32[(($2727)>>2)]=$31919;
      var $31920=$31918.f1;
      HEAP32[(($2728)>>2)]=$31920;
      var $31921=HEAP32[(($2728)>>2)];
      var $31922=(($31921)|0) < 0;
      if ($31922) { __label__ = 6500; break; } else { __label__ = 6501; break; }
    case 6500: // $31923
      var $31924=HEAP32[(($2727)>>2)];
      ___cxa_call_unexpected($31924);
      throw "Reached an unreachable!"
    case 6501: // $31925
      var $31926=HEAP32[(($2727)>>2)];
      var $31927=HEAP32[(($2727)>>2)];
      var $31928=HEAP32[(($2728)>>2)];
      var $31929=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31927, tempValue);
      var $31930=($31929.f1 = $31928, $31929);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6502: // $31931
      throw "Reached an unreachable!"
    case 6503: // $_ZnwjPKci_exit784
      var $31932=HEAP32[(($result_i783)>>2)];
      var $31933=$2724;
      var $31934=$2725;
      var $31935=$2726;
      var $31936=$result_i783;
      var $31937=$2727;
      var $31938=$2728;
      var $31939=$31932;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8053, 4, 6, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6504; break; } else { __label__ = 13641; break; }
    case 6504: // $31940
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8054, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6505; break; } else { __label__ = 13641; break; }
    case 6505: // $31941
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8055, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6506; break; } else { __label__ = 13641; break; }
    case 6506: // $31942
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6507; break; } else { __label__ = 13641; break; }
    case 6507: // $31943
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6508; break; } else { __label__ = 13641; break; }
    case 6508: // $31944
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6509; break; } else { __label__ = 13641; break; }
    case 6509: // $31945
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6510; break; } else { __label__ = 13641; break; }
    case 6510: // $31946
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8052, $8053, $8054, $8055, $8056, $8057, $8058, $8059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6511; break; } else { __label__ = 13641; break; }
    case 6511: // $31947
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8061, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6512; break; } else { __label__ = 13641; break; }
    case 6512: // $31948
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8062, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6513; break; } else { __label__ = 13641; break; }
    case 6513: // $31949
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8063, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6514; break; } else { __label__ = 13641; break; }
    case 6514: // $31950
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6515; break; } else { __label__ = 13641; break; }
    case 6515: // $31951
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6516; break; } else { __label__ = 13641; break; }
    case 6516: // $31952
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6517; break; } else { __label__ = 13641; break; }
    case 6517: // $31953
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6518; break; } else { __label__ = 13641; break; }
    case 6518: // $31954
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8060, $8061, $8062, $8063, $8064, $8065, $8066, $8067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6519; break; } else { __label__ = 13641; break; }
    case 6519: // $31955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8069, 4, 6, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6520; break; } else { __label__ = 13641; break; }
    case 6520: // $31956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8070, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6521; break; } else { __label__ = 13641; break; }
    case 6521: // $31957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8071, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6522; break; } else { __label__ = 13641; break; }
    case 6522: // $31958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6523; break; } else { __label__ = 13641; break; }
    case 6523: // $31959
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6524; break; } else { __label__ = 13641; break; }
    case 6524: // $31960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6525; break; } else { __label__ = 13641; break; }
    case 6525: // $31961
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6526; break; } else { __label__ = 13641; break; }
    case 6526: // $31962
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8068, $8069, $8070, $8071, $8072, $8073, $8074, $8075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6527; break; } else { __label__ = 13641; break; }
    case 6527: // $31963
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($31939, 148, 7, 6, ((STRING_TABLE.__str974)|0), ((STRING_TABLE.__str975)|0), $8052, $8060, $8068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6528; break; } else { __label__ = 13641; break; }
    case 6528: // $31964
      var $31965=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $31939);
      var $31966=__ZN11simple_listI16input_type_entryE6appendERS0_($31900, $31965);
      var $31967=$4689;
      var $31968=$2719;
      var $31969=$2720;
      var $31970=$2721;
      var $31971=$result_i785;
      var $31972=$2722;
      var $31973=$2723;
      HEAP32[(($2719)>>2)]=408;
      HEAP32[(($2720)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2721)>>2)]=461;
      var $31974=HEAP32[(($2719)>>2)];
      var $31975=HEAP32[(($2720)>>2)];
      var $31976=HEAP32[(($2721)>>2)];
      var $31977=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31974, $31975, $31976) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6529; break; } else { __label__ = 6531; break; };
    case 6529: // $31978
      HEAP32[(($result_i785)>>2)]=$31977;
      var $31979=HEAP32[(($result_i785)>>2)];
      var $31980=(($31979)|0)==0;
      if ($31980) { __label__ = 6530; break; } else { __label__ = 6535; break; }
    case 6530: // $31981
      var $31982=___cxa_allocate_exception(4);
      var $31983=$31982;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31983);
      (function() { try { __THREW__ = false; return ___cxa_throw($31982, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6534; break; } else { __label__ = 6531; break; }
    case 6531: // $31984
      var $31985=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31986=$31985.f0;
      HEAP32[(($2722)>>2)]=$31986;
      var $31987=$31985.f1;
      HEAP32[(($2723)>>2)]=$31987;
      var $31988=HEAP32[(($2723)>>2)];
      var $31989=(($31988)|0) < 0;
      if ($31989) { __label__ = 6532; break; } else { __label__ = 6533; break; }
    case 6532: // $31990
      var $31991=HEAP32[(($2722)>>2)];
      ___cxa_call_unexpected($31991);
      throw "Reached an unreachable!"
    case 6533: // $31992
      var $31993=HEAP32[(($2722)>>2)];
      var $31994=HEAP32[(($2722)>>2)];
      var $31995=HEAP32[(($2723)>>2)];
      var $31996=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31994, tempValue);
      var $31997=($31996.f1 = $31995, $31996);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6534: // $31998
      throw "Reached an unreachable!"
    case 6535: // $_ZnwjPKci_exit786
      var $31999=HEAP32[(($result_i785)>>2)];
      var $32000=$2719;
      var $32001=$2720;
      var $32002=$2721;
      var $32003=$result_i785;
      var $32004=$2722;
      var $32005=$2723;
      var $32006=$31999;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8077, 4, 7, 2, 1, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6536; break; } else { __label__ = 13646; break; }
    case 6536: // $32007
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8078, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6537; break; } else { __label__ = 13646; break; }
    case 6537: // $32008
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8079, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6538; break; } else { __label__ = 13646; break; }
    case 6538: // $32009
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6539; break; } else { __label__ = 13646; break; }
    case 6539: // $32010
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6540; break; } else { __label__ = 13646; break; }
    case 6540: // $32011
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6541; break; } else { __label__ = 13646; break; }
    case 6541: // $32012
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6542; break; } else { __label__ = 13646; break; }
    case 6542: // $32013
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8076, $8077, $8078, $8079, $8080, $8081, $8082, $8083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6543; break; } else { __label__ = 13646; break; }
    case 6543: // $32014
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8085, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6544; break; } else { __label__ = 13646; break; }
    case 6544: // $32015
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8086, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6545; break; } else { __label__ = 13646; break; }
    case 6545: // $32016
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8087, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6546; break; } else { __label__ = 13646; break; }
    case 6546: // $32017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6547; break; } else { __label__ = 13646; break; }
    case 6547: // $32018
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6548; break; } else { __label__ = 13646; break; }
    case 6548: // $32019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6549; break; } else { __label__ = 13646; break; }
    case 6549: // $32020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6550; break; } else { __label__ = 13646; break; }
    case 6550: // $32021
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8084, $8085, $8086, $8087, $8088, $8089, $8090, $8091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6551; break; } else { __label__ = 13646; break; }
    case 6551: // $32022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8093, 4, 7, 1, 0, 119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6552; break; } else { __label__ = 13646; break; }
    case 6552: // $32023
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8094, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6553; break; } else { __label__ = 13646; break; }
    case 6553: // $32024
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8095, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6554; break; } else { __label__ = 13646; break; }
    case 6554: // $32025
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6555; break; } else { __label__ = 13646; break; }
    case 6555: // $32026
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6556; break; } else { __label__ = 13646; break; }
    case 6556: // $32027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6557; break; } else { __label__ = 13646; break; }
    case 6557: // $32028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6558; break; } else { __label__ = 13646; break; }
    case 6558: // $32029
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8092, $8093, $8094, $8095, $8096, $8097, $8098, $8099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6559; break; } else { __label__ = 13646; break; }
    case 6559: // $32030
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32006, 148, 8, 7, ((STRING_TABLE.__str976)|0), ((STRING_TABLE.__str977)|0), $8076, $8084, $8092) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6560; break; } else { __label__ = 13646; break; }
    case 6560: // $32031
      var $32032=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32006);
      var $32033=__ZN11simple_listI16input_type_entryE6appendERS0_($31967, $32032);
      var $32034=$4689;
      var $32035=$2714;
      var $32036=$2715;
      var $32037=$2716;
      var $32038=$result_i787;
      var $32039=$2717;
      var $32040=$2718;
      HEAP32[(($2714)>>2)]=408;
      HEAP32[(($2715)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2716)>>2)]=463;
      var $32041=HEAP32[(($2714)>>2)];
      var $32042=HEAP32[(($2715)>>2)];
      var $32043=HEAP32[(($2716)>>2)];
      var $32044=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32041, $32042, $32043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6561; break; } else { __label__ = 6563; break; };
    case 6561: // $32045
      HEAP32[(($result_i787)>>2)]=$32044;
      var $32046=HEAP32[(($result_i787)>>2)];
      var $32047=(($32046)|0)==0;
      if ($32047) { __label__ = 6562; break; } else { __label__ = 6567; break; }
    case 6562: // $32048
      var $32049=___cxa_allocate_exception(4);
      var $32050=$32049;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32050);
      (function() { try { __THREW__ = false; return ___cxa_throw($32049, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6566; break; } else { __label__ = 6563; break; }
    case 6563: // $32051
      var $32052=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32053=$32052.f0;
      HEAP32[(($2717)>>2)]=$32053;
      var $32054=$32052.f1;
      HEAP32[(($2718)>>2)]=$32054;
      var $32055=HEAP32[(($2718)>>2)];
      var $32056=(($32055)|0) < 0;
      if ($32056) { __label__ = 6564; break; } else { __label__ = 6565; break; }
    case 6564: // $32057
      var $32058=HEAP32[(($2717)>>2)];
      ___cxa_call_unexpected($32058);
      throw "Reached an unreachable!"
    case 6565: // $32059
      var $32060=HEAP32[(($2717)>>2)];
      var $32061=HEAP32[(($2717)>>2)];
      var $32062=HEAP32[(($2718)>>2)];
      var $32063=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32061, tempValue);
      var $32064=($32063.f1 = $32062, $32063);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6566: // $32065
      throw "Reached an unreachable!"
    case 6567: // $_ZnwjPKci_exit788
      var $32066=HEAP32[(($result_i787)>>2)];
      var $32067=$2714;
      var $32068=$2715;
      var $32069=$2716;
      var $32070=$result_i787;
      var $32071=$2717;
      var $32072=$2718;
      var $32073=$32066;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8101, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6568; break; } else { __label__ = 13651; break; }
    case 6568: // $32074
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8102, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6569; break; } else { __label__ = 13651; break; }
    case 6569: // $32075
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8103, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6570; break; } else { __label__ = 13651; break; }
    case 6570: // $32076
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8104, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6571; break; } else { __label__ = 13651; break; }
    case 6571: // $32077
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8105, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6572; break; } else { __label__ = 13651; break; }
    case 6572: // $32078
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6573; break; } else { __label__ = 13651; break; }
    case 6573: // $32079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6574; break; } else { __label__ = 13651; break; }
    case 6574: // $32080
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8100, $8101, $8102, $8103, $8104, $8105, $8106, $8107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6575; break; } else { __label__ = 13651; break; }
    case 6575: // $32081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8109, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6576; break; } else { __label__ = 13651; break; }
    case 6576: // $32082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8110, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6577; break; } else { __label__ = 13651; break; }
    case 6577: // $32083
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8111, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6578; break; } else { __label__ = 13651; break; }
    case 6578: // $32084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8112, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6579; break; } else { __label__ = 13651; break; }
    case 6579: // $32085
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8113, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6580; break; } else { __label__ = 13651; break; }
    case 6580: // $32086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6581; break; } else { __label__ = 13651; break; }
    case 6581: // $32087
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6582; break; } else { __label__ = 13651; break; }
    case 6582: // $32088
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8108, $8109, $8110, $8111, $8112, $8113, $8114, $8115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6583; break; } else { __label__ = 13651; break; }
    case 6583: // $32089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8117, 1, 0, 1, 0, 68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6584; break; } else { __label__ = 13651; break; }
    case 6584: // $32090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8118, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6585; break; } else { __label__ = 13651; break; }
    case 6585: // $32091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8119, 4, 0, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6586; break; } else { __label__ = 13651; break; }
    case 6586: // $32092
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6587; break; } else { __label__ = 13651; break; }
    case 6587: // $32093
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6588; break; } else { __label__ = 13651; break; }
    case 6588: // $32094
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6589; break; } else { __label__ = 13651; break; }
    case 6589: // $32095
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6590; break; } else { __label__ = 13651; break; }
    case 6590: // $32096
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8116, $8117, $8118, $8119, $8120, $8121, $8122, $8123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6591; break; } else { __label__ = 13651; break; }
    case 6591: // $32097
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32073, 149, 1, 0, ((STRING_TABLE.__str978420)|0), ((STRING_TABLE.__str979)|0), $8100, $8108, $8116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6592; break; } else { __label__ = 13651; break; }
    case 6592: // $32098
      var $32099=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32073);
      var $32100=__ZN11simple_listI16input_type_entryE6appendERS0_($32034, $32099);
      var $32101=$4689;
      var $32102=$2709;
      var $32103=$2710;
      var $32104=$2711;
      var $32105=$result_i789;
      var $32106=$2712;
      var $32107=$2713;
      HEAP32[(($2709)>>2)]=408;
      HEAP32[(($2710)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2711)>>2)]=464;
      var $32108=HEAP32[(($2709)>>2)];
      var $32109=HEAP32[(($2710)>>2)];
      var $32110=HEAP32[(($2711)>>2)];
      var $32111=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32108, $32109, $32110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6593; break; } else { __label__ = 6595; break; };
    case 6593: // $32112
      HEAP32[(($result_i789)>>2)]=$32111;
      var $32113=HEAP32[(($result_i789)>>2)];
      var $32114=(($32113)|0)==0;
      if ($32114) { __label__ = 6594; break; } else { __label__ = 6599; break; }
    case 6594: // $32115
      var $32116=___cxa_allocate_exception(4);
      var $32117=$32116;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32117);
      (function() { try { __THREW__ = false; return ___cxa_throw($32116, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6598; break; } else { __label__ = 6595; break; }
    case 6595: // $32118
      var $32119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32120=$32119.f0;
      HEAP32[(($2712)>>2)]=$32120;
      var $32121=$32119.f1;
      HEAP32[(($2713)>>2)]=$32121;
      var $32122=HEAP32[(($2713)>>2)];
      var $32123=(($32122)|0) < 0;
      if ($32123) { __label__ = 6596; break; } else { __label__ = 6597; break; }
    case 6596: // $32124
      var $32125=HEAP32[(($2712)>>2)];
      ___cxa_call_unexpected($32125);
      throw "Reached an unreachable!"
    case 6597: // $32126
      var $32127=HEAP32[(($2712)>>2)];
      var $32128=HEAP32[(($2712)>>2)];
      var $32129=HEAP32[(($2713)>>2)];
      var $32130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32128, tempValue);
      var $32131=($32130.f1 = $32129, $32130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6598: // $32132
      throw "Reached an unreachable!"
    case 6599: // $_ZnwjPKci_exit790
      var $32133=HEAP32[(($result_i789)>>2)];
      var $32134=$2709;
      var $32135=$2710;
      var $32136=$2711;
      var $32137=$result_i789;
      var $32138=$2712;
      var $32139=$2713;
      var $32140=$32133;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8125, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6600; break; } else { __label__ = 13656; break; }
    case 6600: // $32141
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8126, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6601; break; } else { __label__ = 13656; break; }
    case 6601: // $32142
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8127, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6602; break; } else { __label__ = 13656; break; }
    case 6602: // $32143
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6603; break; } else { __label__ = 13656; break; }
    case 6603: // $32144
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6604; break; } else { __label__ = 13656; break; }
    case 6604: // $32145
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6605; break; } else { __label__ = 13656; break; }
    case 6605: // $32146
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6606; break; } else { __label__ = 13656; break; }
    case 6606: // $32147
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8124, $8125, $8126, $8127, $8128, $8129, $8130, $8131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6607; break; } else { __label__ = 13656; break; }
    case 6607: // $32148
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8133, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6608; break; } else { __label__ = 13656; break; }
    case 6608: // $32149
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8134, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6609; break; } else { __label__ = 13656; break; }
    case 6609: // $32150
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8135, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6610; break; } else { __label__ = 13656; break; }
    case 6610: // $32151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6611; break; } else { __label__ = 13656; break; }
    case 6611: // $32152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6612; break; } else { __label__ = 13656; break; }
    case 6612: // $32153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6613; break; } else { __label__ = 13656; break; }
    case 6613: // $32154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6614; break; } else { __label__ = 13656; break; }
    case 6614: // $32155
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8132, $8133, $8134, $8135, $8136, $8137, $8138, $8139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6615; break; } else { __label__ = 13656; break; }
    case 6615: // $32156
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8141, 1, 0, 1, 0, 17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6616; break; } else { __label__ = 13656; break; }
    case 6616: // $32157
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8142, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6617; break; } else { __label__ = 13656; break; }
    case 6617: // $32158
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8143, 4, 1, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6618; break; } else { __label__ = 13656; break; }
    case 6618: // $32159
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6619; break; } else { __label__ = 13656; break; }
    case 6619: // $32160
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6620; break; } else { __label__ = 13656; break; }
    case 6620: // $32161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6621; break; } else { __label__ = 13656; break; }
    case 6621: // $32162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6622; break; } else { __label__ = 13656; break; }
    case 6622: // $32163
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8140, $8141, $8142, $8143, $8144, $8145, $8146, $8147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6623; break; } else { __label__ = 13656; break; }
    case 6623: // $32164
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32140, 149, 2, 1, ((STRING_TABLE.__str980)|0), ((STRING_TABLE.__str981)|0), $8124, $8132, $8140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6624; break; } else { __label__ = 13656; break; }
    case 6624: // $32165
      var $32166=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32140);
      var $32167=__ZN11simple_listI16input_type_entryE6appendERS0_($32101, $32166);
      var $32168=$4689;
      var $32169=$2704;
      var $32170=$2705;
      var $32171=$2706;
      var $32172=$result_i791;
      var $32173=$2707;
      var $32174=$2708;
      HEAP32[(($2704)>>2)]=408;
      HEAP32[(($2705)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2706)>>2)]=465;
      var $32175=HEAP32[(($2704)>>2)];
      var $32176=HEAP32[(($2705)>>2)];
      var $32177=HEAP32[(($2706)>>2)];
      var $32178=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32175, $32176, $32177) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6625; break; } else { __label__ = 6627; break; };
    case 6625: // $32179
      HEAP32[(($result_i791)>>2)]=$32178;
      var $32180=HEAP32[(($result_i791)>>2)];
      var $32181=(($32180)|0)==0;
      if ($32181) { __label__ = 6626; break; } else { __label__ = 6631; break; }
    case 6626: // $32182
      var $32183=___cxa_allocate_exception(4);
      var $32184=$32183;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32184);
      (function() { try { __THREW__ = false; return ___cxa_throw($32183, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6630; break; } else { __label__ = 6627; break; }
    case 6627: // $32185
      var $32186=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32187=$32186.f0;
      HEAP32[(($2707)>>2)]=$32187;
      var $32188=$32186.f1;
      HEAP32[(($2708)>>2)]=$32188;
      var $32189=HEAP32[(($2708)>>2)];
      var $32190=(($32189)|0) < 0;
      if ($32190) { __label__ = 6628; break; } else { __label__ = 6629; break; }
    case 6628: // $32191
      var $32192=HEAP32[(($2707)>>2)];
      ___cxa_call_unexpected($32192);
      throw "Reached an unreachable!"
    case 6629: // $32193
      var $32194=HEAP32[(($2707)>>2)];
      var $32195=HEAP32[(($2707)>>2)];
      var $32196=HEAP32[(($2708)>>2)];
      var $32197=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32195, tempValue);
      var $32198=($32197.f1 = $32196, $32197);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6630: // $32199
      throw "Reached an unreachable!"
    case 6631: // $_ZnwjPKci_exit792
      var $32200=HEAP32[(($result_i791)>>2)];
      var $32201=$2704;
      var $32202=$2705;
      var $32203=$2706;
      var $32204=$result_i791;
      var $32205=$2707;
      var $32206=$2708;
      var $32207=$32200;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8149, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6632; break; } else { __label__ = 13661; break; }
    case 6632: // $32208
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6633; break; } else { __label__ = 13661; break; }
    case 6633: // $32209
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6634; break; } else { __label__ = 13661; break; }
    case 6634: // $32210
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6635; break; } else { __label__ = 13661; break; }
    case 6635: // $32211
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6636; break; } else { __label__ = 13661; break; }
    case 6636: // $32212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6637; break; } else { __label__ = 13661; break; }
    case 6637: // $32213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6638; break; } else { __label__ = 13661; break; }
    case 6638: // $32214
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8148, $8149, $8150, $8151, $8152, $8153, $8154, $8155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6639; break; } else { __label__ = 13661; break; }
    case 6639: // $32215
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8157, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6640; break; } else { __label__ = 13661; break; }
    case 6640: // $32216
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8158, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6641; break; } else { __label__ = 13661; break; }
    case 6641: // $32217
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8159, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6642; break; } else { __label__ = 13661; break; }
    case 6642: // $32218
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6643; break; } else { __label__ = 13661; break; }
    case 6643: // $32219
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6644; break; } else { __label__ = 13661; break; }
    case 6644: // $32220
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6645; break; } else { __label__ = 13661; break; }
    case 6645: // $32221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6646; break; } else { __label__ = 13661; break; }
    case 6646: // $32222
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8156, $8157, $8158, $8159, $8160, $8161, $8162, $8163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6647; break; } else { __label__ = 13661; break; }
    case 6647: // $32223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8165, 1, 0, 1, 0, 60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6648; break; } else { __label__ = 13661; break; }
    case 6648: // $32224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8166, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6649; break; } else { __label__ = 13661; break; }
    case 6649: // $32225
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8167, 4, 2, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6650; break; } else { __label__ = 13661; break; }
    case 6650: // $32226
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6651; break; } else { __label__ = 13661; break; }
    case 6651: // $32227
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6652; break; } else { __label__ = 13661; break; }
    case 6652: // $32228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6653; break; } else { __label__ = 13661; break; }
    case 6653: // $32229
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6654; break; } else { __label__ = 13661; break; }
    case 6654: // $32230
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8164, $8165, $8166, $8167, $8168, $8169, $8170, $8171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6655; break; } else { __label__ = 13661; break; }
    case 6655: // $32231
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32207, 149, 3, 2, ((STRING_TABLE.__str982)|0), ((STRING_TABLE.__str983)|0), $8148, $8156, $8164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6656; break; } else { __label__ = 13661; break; }
    case 6656: // $32232
      var $32233=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32207);
      var $32234=__ZN11simple_listI16input_type_entryE6appendERS0_($32168, $32233);
      var $32235=$4689;
      var $32236=$2699;
      var $32237=$2700;
      var $32238=$2701;
      var $32239=$result_i793;
      var $32240=$2702;
      var $32241=$2703;
      HEAP32[(($2699)>>2)]=408;
      HEAP32[(($2700)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2701)>>2)]=466;
      var $32242=HEAP32[(($2699)>>2)];
      var $32243=HEAP32[(($2700)>>2)];
      var $32244=HEAP32[(($2701)>>2)];
      var $32245=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32242, $32243, $32244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6657; break; } else { __label__ = 6659; break; };
    case 6657: // $32246
      HEAP32[(($result_i793)>>2)]=$32245;
      var $32247=HEAP32[(($result_i793)>>2)];
      var $32248=(($32247)|0)==0;
      if ($32248) { __label__ = 6658; break; } else { __label__ = 6663; break; }
    case 6658: // $32249
      var $32250=___cxa_allocate_exception(4);
      var $32251=$32250;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32251);
      (function() { try { __THREW__ = false; return ___cxa_throw($32250, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6662; break; } else { __label__ = 6659; break; }
    case 6659: // $32252
      var $32253=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32254=$32253.f0;
      HEAP32[(($2702)>>2)]=$32254;
      var $32255=$32253.f1;
      HEAP32[(($2703)>>2)]=$32255;
      var $32256=HEAP32[(($2703)>>2)];
      var $32257=(($32256)|0) < 0;
      if ($32257) { __label__ = 6660; break; } else { __label__ = 6661; break; }
    case 6660: // $32258
      var $32259=HEAP32[(($2702)>>2)];
      ___cxa_call_unexpected($32259);
      throw "Reached an unreachable!"
    case 6661: // $32260
      var $32261=HEAP32[(($2702)>>2)];
      var $32262=HEAP32[(($2702)>>2)];
      var $32263=HEAP32[(($2703)>>2)];
      var $32264=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32262, tempValue);
      var $32265=($32264.f1 = $32263, $32264);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6662: // $32266
      throw "Reached an unreachable!"
    case 6663: // $_ZnwjPKci_exit794
      var $32267=HEAP32[(($result_i793)>>2)];
      var $32268=$2699;
      var $32269=$2700;
      var $32270=$2701;
      var $32271=$result_i793;
      var $32272=$2702;
      var $32273=$2703;
      var $32274=$32267;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8173, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6664; break; } else { __label__ = 13666; break; }
    case 6664: // $32275
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6665; break; } else { __label__ = 13666; break; }
    case 6665: // $32276
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6666; break; } else { __label__ = 13666; break; }
    case 6666: // $32277
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6667; break; } else { __label__ = 13666; break; }
    case 6667: // $32278
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6668; break; } else { __label__ = 13666; break; }
    case 6668: // $32279
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6669; break; } else { __label__ = 13666; break; }
    case 6669: // $32280
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6670; break; } else { __label__ = 13666; break; }
    case 6670: // $32281
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8172, $8173, $8174, $8175, $8176, $8177, $8178, $8179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6671; break; } else { __label__ = 13666; break; }
    case 6671: // $32282
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8181, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6672; break; } else { __label__ = 13666; break; }
    case 6672: // $32283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8182, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6673; break; } else { __label__ = 13666; break; }
    case 6673: // $32284
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8183, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6674; break; } else { __label__ = 13666; break; }
    case 6674: // $32285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6675; break; } else { __label__ = 13666; break; }
    case 6675: // $32286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6676; break; } else { __label__ = 13666; break; }
    case 6676: // $32287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6677; break; } else { __label__ = 13666; break; }
    case 6677: // $32288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6678; break; } else { __label__ = 13666; break; }
    case 6678: // $32289
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8180, $8181, $8182, $8183, $8184, $8185, $8186, $8187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6679; break; } else { __label__ = 13666; break; }
    case 6679: // $32290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8189, 1, 0, 1, 0, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6680; break; } else { __label__ = 13666; break; }
    case 6680: // $32291
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8190, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6681; break; } else { __label__ = 13666; break; }
    case 6681: // $32292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8191, 4, 3, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6682; break; } else { __label__ = 13666; break; }
    case 6682: // $32293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6683; break; } else { __label__ = 13666; break; }
    case 6683: // $32294
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6684; break; } else { __label__ = 13666; break; }
    case 6684: // $32295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6685; break; } else { __label__ = 13666; break; }
    case 6685: // $32296
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6686; break; } else { __label__ = 13666; break; }
    case 6686: // $32297
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8188, $8189, $8190, $8191, $8192, $8193, $8194, $8195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6687; break; } else { __label__ = 13666; break; }
    case 6687: // $32298
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32274, 149, 4, 3, ((STRING_TABLE.__str984)|0), ((STRING_TABLE.__str985)|0), $8172, $8180, $8188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6688; break; } else { __label__ = 13666; break; }
    case 6688: // $32299
      var $32300=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32274);
      var $32301=__ZN11simple_listI16input_type_entryE6appendERS0_($32235, $32300);
      var $32302=$4689;
      var $32303=$2694;
      var $32304=$2695;
      var $32305=$2696;
      var $32306=$result_i795;
      var $32307=$2697;
      var $32308=$2698;
      HEAP32[(($2694)>>2)]=408;
      HEAP32[(($2695)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2696)>>2)]=467;
      var $32309=HEAP32[(($2694)>>2)];
      var $32310=HEAP32[(($2695)>>2)];
      var $32311=HEAP32[(($2696)>>2)];
      var $32312=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32309, $32310, $32311) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6689; break; } else { __label__ = 6691; break; };
    case 6689: // $32313
      HEAP32[(($result_i795)>>2)]=$32312;
      var $32314=HEAP32[(($result_i795)>>2)];
      var $32315=(($32314)|0)==0;
      if ($32315) { __label__ = 6690; break; } else { __label__ = 6695; break; }
    case 6690: // $32316
      var $32317=___cxa_allocate_exception(4);
      var $32318=$32317;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32318);
      (function() { try { __THREW__ = false; return ___cxa_throw($32317, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6694; break; } else { __label__ = 6691; break; }
    case 6691: // $32319
      var $32320=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32321=$32320.f0;
      HEAP32[(($2697)>>2)]=$32321;
      var $32322=$32320.f1;
      HEAP32[(($2698)>>2)]=$32322;
      var $32323=HEAP32[(($2698)>>2)];
      var $32324=(($32323)|0) < 0;
      if ($32324) { __label__ = 6692; break; } else { __label__ = 6693; break; }
    case 6692: // $32325
      var $32326=HEAP32[(($2697)>>2)];
      ___cxa_call_unexpected($32326);
      throw "Reached an unreachable!"
    case 6693: // $32327
      var $32328=HEAP32[(($2697)>>2)];
      var $32329=HEAP32[(($2697)>>2)];
      var $32330=HEAP32[(($2698)>>2)];
      var $32331=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32329, tempValue);
      var $32332=($32331.f1 = $32330, $32331);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6694: // $32333
      throw "Reached an unreachable!"
    case 6695: // $_ZnwjPKci_exit796
      var $32334=HEAP32[(($result_i795)>>2)];
      var $32335=$2694;
      var $32336=$2695;
      var $32337=$2696;
      var $32338=$result_i795;
      var $32339=$2697;
      var $32340=$2698;
      var $32341=$32334;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8197, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6696; break; } else { __label__ = 13671; break; }
    case 6696: // $32342
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6697; break; } else { __label__ = 13671; break; }
    case 6697: // $32343
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6698; break; } else { __label__ = 13671; break; }
    case 6698: // $32344
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6699; break; } else { __label__ = 13671; break; }
    case 6699: // $32345
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6700; break; } else { __label__ = 13671; break; }
    case 6700: // $32346
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6701; break; } else { __label__ = 13671; break; }
    case 6701: // $32347
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6702; break; } else { __label__ = 13671; break; }
    case 6702: // $32348
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8196, $8197, $8198, $8199, $8200, $8201, $8202, $8203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6703; break; } else { __label__ = 13671; break; }
    case 6703: // $32349
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8205, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6704; break; } else { __label__ = 13671; break; }
    case 6704: // $32350
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8206, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6705; break; } else { __label__ = 13671; break; }
    case 6705: // $32351
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8207, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6706; break; } else { __label__ = 13671; break; }
    case 6706: // $32352
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6707; break; } else { __label__ = 13671; break; }
    case 6707: // $32353
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6708; break; } else { __label__ = 13671; break; }
    case 6708: // $32354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6709; break; } else { __label__ = 13671; break; }
    case 6709: // $32355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6710; break; } else { __label__ = 13671; break; }
    case 6710: // $32356
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8204, $8205, $8206, $8207, $8208, $8209, $8210, $8211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6711; break; } else { __label__ = 13671; break; }
    case 6711: // $32357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8213, 4, 4, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6712; break; } else { __label__ = 13671; break; }
    case 6712: // $32358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6713; break; } else { __label__ = 13671; break; }
    case 6713: // $32359
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6714; break; } else { __label__ = 13671; break; }
    case 6714: // $32360
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6715; break; } else { __label__ = 13671; break; }
    case 6715: // $32361
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6716; break; } else { __label__ = 13671; break; }
    case 6716: // $32362
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6717; break; } else { __label__ = 13671; break; }
    case 6717: // $32363
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6718; break; } else { __label__ = 13671; break; }
    case 6718: // $32364
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8212, $8213, $8214, $8215, $8216, $8217, $8218, $8219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6719; break; } else { __label__ = 13671; break; }
    case 6719: // $32365
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32341, 149, 5, 4, ((STRING_TABLE.__str986)|0), ((STRING_TABLE.__str987)|0), $8196, $8204, $8212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6720; break; } else { __label__ = 13671; break; }
    case 6720: // $32366
      var $32367=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32341);
      var $32368=__ZN11simple_listI16input_type_entryE6appendERS0_($32302, $32367);
      var $32369=$4689;
      var $32370=$2689;
      var $32371=$2690;
      var $32372=$2691;
      var $32373=$result_i797;
      var $32374=$2692;
      var $32375=$2693;
      HEAP32[(($2689)>>2)]=408;
      HEAP32[(($2690)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2691)>>2)]=468;
      var $32376=HEAP32[(($2689)>>2)];
      var $32377=HEAP32[(($2690)>>2)];
      var $32378=HEAP32[(($2691)>>2)];
      var $32379=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32376, $32377, $32378) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6721; break; } else { __label__ = 6723; break; };
    case 6721: // $32380
      HEAP32[(($result_i797)>>2)]=$32379;
      var $32381=HEAP32[(($result_i797)>>2)];
      var $32382=(($32381)|0)==0;
      if ($32382) { __label__ = 6722; break; } else { __label__ = 6727; break; }
    case 6722: // $32383
      var $32384=___cxa_allocate_exception(4);
      var $32385=$32384;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32385);
      (function() { try { __THREW__ = false; return ___cxa_throw($32384, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6726; break; } else { __label__ = 6723; break; }
    case 6723: // $32386
      var $32387=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32388=$32387.f0;
      HEAP32[(($2692)>>2)]=$32388;
      var $32389=$32387.f1;
      HEAP32[(($2693)>>2)]=$32389;
      var $32390=HEAP32[(($2693)>>2)];
      var $32391=(($32390)|0) < 0;
      if ($32391) { __label__ = 6724; break; } else { __label__ = 6725; break; }
    case 6724: // $32392
      var $32393=HEAP32[(($2692)>>2)];
      ___cxa_call_unexpected($32393);
      throw "Reached an unreachable!"
    case 6725: // $32394
      var $32395=HEAP32[(($2692)>>2)];
      var $32396=HEAP32[(($2692)>>2)];
      var $32397=HEAP32[(($2693)>>2)];
      var $32398=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32396, tempValue);
      var $32399=($32398.f1 = $32397, $32398);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6726: // $32400
      throw "Reached an unreachable!"
    case 6727: // $_ZnwjPKci_exit798
      var $32401=HEAP32[(($result_i797)>>2)];
      var $32402=$2689;
      var $32403=$2690;
      var $32404=$2691;
      var $32405=$result_i797;
      var $32406=$2692;
      var $32407=$2693;
      var $32408=$32401;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8221, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6728; break; } else { __label__ = 13676; break; }
    case 6728: // $32409
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8222, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6729; break; } else { __label__ = 13676; break; }
    case 6729: // $32410
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6730; break; } else { __label__ = 13676; break; }
    case 6730: // $32411
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6731; break; } else { __label__ = 13676; break; }
    case 6731: // $32412
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6732; break; } else { __label__ = 13676; break; }
    case 6732: // $32413
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6733; break; } else { __label__ = 13676; break; }
    case 6733: // $32414
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6734; break; } else { __label__ = 13676; break; }
    case 6734: // $32415
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8220, $8221, $8222, $8223, $8224, $8225, $8226, $8227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6735; break; } else { __label__ = 13676; break; }
    case 6735: // $32416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8229, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6736; break; } else { __label__ = 13676; break; }
    case 6736: // $32417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8230, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6737; break; } else { __label__ = 13676; break; }
    case 6737: // $32418
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8231, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6738; break; } else { __label__ = 13676; break; }
    case 6738: // $32419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6739; break; } else { __label__ = 13676; break; }
    case 6739: // $32420
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6740; break; } else { __label__ = 13676; break; }
    case 6740: // $32421
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6741; break; } else { __label__ = 13676; break; }
    case 6741: // $32422
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6742; break; } else { __label__ = 13676; break; }
    case 6742: // $32423
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8228, $8229, $8230, $8231, $8232, $8233, $8234, $8235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6743; break; } else { __label__ = 13676; break; }
    case 6743: // $32424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8237, 4, 5, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6744; break; } else { __label__ = 13676; break; }
    case 6744: // $32425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8238, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6745; break; } else { __label__ = 13676; break; }
    case 6745: // $32426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8239, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6746; break; } else { __label__ = 13676; break; }
    case 6746: // $32427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6747; break; } else { __label__ = 13676; break; }
    case 6747: // $32428
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6748; break; } else { __label__ = 13676; break; }
    case 6748: // $32429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6749; break; } else { __label__ = 13676; break; }
    case 6749: // $32430
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6750; break; } else { __label__ = 13676; break; }
    case 6750: // $32431
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8236, $8237, $8238, $8239, $8240, $8241, $8242, $8243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6751; break; } else { __label__ = 13676; break; }
    case 6751: // $32432
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32408, 149, 6, 5, ((STRING_TABLE.__str988)|0), ((STRING_TABLE.__str989)|0), $8220, $8228, $8236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6752; break; } else { __label__ = 13676; break; }
    case 6752: // $32433
      var $32434=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32408);
      var $32435=__ZN11simple_listI16input_type_entryE6appendERS0_($32369, $32434);
      var $32436=$4689;
      var $32437=$2684;
      var $32438=$2685;
      var $32439=$2686;
      var $32440=$result_i799;
      var $32441=$2687;
      var $32442=$2688;
      HEAP32[(($2684)>>2)]=408;
      HEAP32[(($2685)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2686)>>2)]=469;
      var $32443=HEAP32[(($2684)>>2)];
      var $32444=HEAP32[(($2685)>>2)];
      var $32445=HEAP32[(($2686)>>2)];
      var $32446=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32443, $32444, $32445) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6753; break; } else { __label__ = 6755; break; };
    case 6753: // $32447
      HEAP32[(($result_i799)>>2)]=$32446;
      var $32448=HEAP32[(($result_i799)>>2)];
      var $32449=(($32448)|0)==0;
      if ($32449) { __label__ = 6754; break; } else { __label__ = 6759; break; }
    case 6754: // $32450
      var $32451=___cxa_allocate_exception(4);
      var $32452=$32451;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32452);
      (function() { try { __THREW__ = false; return ___cxa_throw($32451, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6758; break; } else { __label__ = 6755; break; }
    case 6755: // $32453
      var $32454=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32455=$32454.f0;
      HEAP32[(($2687)>>2)]=$32455;
      var $32456=$32454.f1;
      HEAP32[(($2688)>>2)]=$32456;
      var $32457=HEAP32[(($2688)>>2)];
      var $32458=(($32457)|0) < 0;
      if ($32458) { __label__ = 6756; break; } else { __label__ = 6757; break; }
    case 6756: // $32459
      var $32460=HEAP32[(($2687)>>2)];
      ___cxa_call_unexpected($32460);
      throw "Reached an unreachable!"
    case 6757: // $32461
      var $32462=HEAP32[(($2687)>>2)];
      var $32463=HEAP32[(($2687)>>2)];
      var $32464=HEAP32[(($2688)>>2)];
      var $32465=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32463, tempValue);
      var $32466=($32465.f1 = $32464, $32465);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6758: // $32467
      throw "Reached an unreachable!"
    case 6759: // $_ZnwjPKci_exit800
      var $32468=HEAP32[(($result_i799)>>2)];
      var $32469=$2684;
      var $32470=$2685;
      var $32471=$2686;
      var $32472=$result_i799;
      var $32473=$2687;
      var $32474=$2688;
      var $32475=$32468;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8245, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6760; break; } else { __label__ = 13681; break; }
    case 6760: // $32476
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8246, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6761; break; } else { __label__ = 13681; break; }
    case 6761: // $32477
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8247, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6762; break; } else { __label__ = 13681; break; }
    case 6762: // $32478
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6763; break; } else { __label__ = 13681; break; }
    case 6763: // $32479
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6764; break; } else { __label__ = 13681; break; }
    case 6764: // $32480
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6765; break; } else { __label__ = 13681; break; }
    case 6765: // $32481
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6766; break; } else { __label__ = 13681; break; }
    case 6766: // $32482
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8244, $8245, $8246, $8247, $8248, $8249, $8250, $8251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6767; break; } else { __label__ = 13681; break; }
    case 6767: // $32483
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8253, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6768; break; } else { __label__ = 13681; break; }
    case 6768: // $32484
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8254, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6769; break; } else { __label__ = 13681; break; }
    case 6769: // $32485
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8255, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6770; break; } else { __label__ = 13681; break; }
    case 6770: // $32486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6771; break; } else { __label__ = 13681; break; }
    case 6771: // $32487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6772; break; } else { __label__ = 13681; break; }
    case 6772: // $32488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6773; break; } else { __label__ = 13681; break; }
    case 6773: // $32489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6774; break; } else { __label__ = 13681; break; }
    case 6774: // $32490
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8252, $8253, $8254, $8255, $8256, $8257, $8258, $8259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6775; break; } else { __label__ = 13681; break; }
    case 6775: // $32491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8261, 4, 6, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6776; break; } else { __label__ = 13681; break; }
    case 6776: // $32492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8262, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6777; break; } else { __label__ = 13681; break; }
    case 6777: // $32493
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8263, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6778; break; } else { __label__ = 13681; break; }
    case 6778: // $32494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6779; break; } else { __label__ = 13681; break; }
    case 6779: // $32495
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6780; break; } else { __label__ = 13681; break; }
    case 6780: // $32496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6781; break; } else { __label__ = 13681; break; }
    case 6781: // $32497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6782; break; } else { __label__ = 13681; break; }
    case 6782: // $32498
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8260, $8261, $8262, $8263, $8264, $8265, $8266, $8267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6783; break; } else { __label__ = 13681; break; }
    case 6783: // $32499
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32475, 149, 7, 6, ((STRING_TABLE.__str990)|0), ((STRING_TABLE.__str991)|0), $8244, $8252, $8260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6784; break; } else { __label__ = 13681; break; }
    case 6784: // $32500
      var $32501=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32475);
      var $32502=__ZN11simple_listI16input_type_entryE6appendERS0_($32436, $32501);
      var $32503=$4689;
      var $32504=$2679;
      var $32505=$2680;
      var $32506=$2681;
      var $32507=$result_i801;
      var $32508=$2682;
      var $32509=$2683;
      HEAP32[(($2679)>>2)]=408;
      HEAP32[(($2680)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2681)>>2)]=470;
      var $32510=HEAP32[(($2679)>>2)];
      var $32511=HEAP32[(($2680)>>2)];
      var $32512=HEAP32[(($2681)>>2)];
      var $32513=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32510, $32511, $32512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6785; break; } else { __label__ = 6787; break; };
    case 6785: // $32514
      HEAP32[(($result_i801)>>2)]=$32513;
      var $32515=HEAP32[(($result_i801)>>2)];
      var $32516=(($32515)|0)==0;
      if ($32516) { __label__ = 6786; break; } else { __label__ = 6791; break; }
    case 6786: // $32517
      var $32518=___cxa_allocate_exception(4);
      var $32519=$32518;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32519);
      (function() { try { __THREW__ = false; return ___cxa_throw($32518, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6790; break; } else { __label__ = 6787; break; }
    case 6787: // $32520
      var $32521=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32522=$32521.f0;
      HEAP32[(($2682)>>2)]=$32522;
      var $32523=$32521.f1;
      HEAP32[(($2683)>>2)]=$32523;
      var $32524=HEAP32[(($2683)>>2)];
      var $32525=(($32524)|0) < 0;
      if ($32525) { __label__ = 6788; break; } else { __label__ = 6789; break; }
    case 6788: // $32526
      var $32527=HEAP32[(($2682)>>2)];
      ___cxa_call_unexpected($32527);
      throw "Reached an unreachable!"
    case 6789: // $32528
      var $32529=HEAP32[(($2682)>>2)];
      var $32530=HEAP32[(($2682)>>2)];
      var $32531=HEAP32[(($2683)>>2)];
      var $32532=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32530, tempValue);
      var $32533=($32532.f1 = $32531, $32532);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6790: // $32534
      throw "Reached an unreachable!"
    case 6791: // $_ZnwjPKci_exit802
      var $32535=HEAP32[(($result_i801)>>2)];
      var $32536=$2679;
      var $32537=$2680;
      var $32538=$2681;
      var $32539=$result_i801;
      var $32540=$2682;
      var $32541=$2683;
      var $32542=$32535;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8269, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6792; break; } else { __label__ = 13686; break; }
    case 6792: // $32543
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8270, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6793; break; } else { __label__ = 13686; break; }
    case 6793: // $32544
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8271, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6794; break; } else { __label__ = 13686; break; }
    case 6794: // $32545
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6795; break; } else { __label__ = 13686; break; }
    case 6795: // $32546
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6796; break; } else { __label__ = 13686; break; }
    case 6796: // $32547
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6797; break; } else { __label__ = 13686; break; }
    case 6797: // $32548
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6798; break; } else { __label__ = 13686; break; }
    case 6798: // $32549
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8268, $8269, $8270, $8271, $8272, $8273, $8274, $8275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6799; break; } else { __label__ = 13686; break; }
    case 6799: // $32550
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8277, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6800; break; } else { __label__ = 13686; break; }
    case 6800: // $32551
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8278, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6801; break; } else { __label__ = 13686; break; }
    case 6801: // $32552
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8279, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6802; break; } else { __label__ = 13686; break; }
    case 6802: // $32553
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8280, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6803; break; } else { __label__ = 13686; break; }
    case 6803: // $32554
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8281, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6804; break; } else { __label__ = 13686; break; }
    case 6804: // $32555
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6805; break; } else { __label__ = 13686; break; }
    case 6805: // $32556
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6806; break; } else { __label__ = 13686; break; }
    case 6806: // $32557
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8276, $8277, $8278, $8279, $8280, $8281, $8282, $8283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6807; break; } else { __label__ = 13686; break; }
    case 6807: // $32558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8285, 4, 7, 1, 0, 120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6808; break; } else { __label__ = 13686; break; }
    case 6808: // $32559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8286, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6809; break; } else { __label__ = 13686; break; }
    case 6809: // $32560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8287, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6810; break; } else { __label__ = 13686; break; }
    case 6810: // $32561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6811; break; } else { __label__ = 13686; break; }
    case 6811: // $32562
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6812; break; } else { __label__ = 13686; break; }
    case 6812: // $32563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6813; break; } else { __label__ = 13686; break; }
    case 6813: // $32564
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6814; break; } else { __label__ = 13686; break; }
    case 6814: // $32565
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8284, $8285, $8286, $8287, $8288, $8289, $8290, $8291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6815; break; } else { __label__ = 13686; break; }
    case 6815: // $32566
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32542, 149, 8, 7, ((STRING_TABLE.__str992)|0), ((STRING_TABLE.__str993)|0), $8268, $8276, $8284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6816; break; } else { __label__ = 13686; break; }
    case 6816: // $32567
      var $32568=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32542);
      var $32569=__ZN11simple_listI16input_type_entryE6appendERS0_($32503, $32568);
      var $32570=$4689;
      var $32571=$2674;
      var $32572=$2675;
      var $32573=$2676;
      var $32574=$result_i803;
      var $32575=$2677;
      var $32576=$2678;
      HEAP32[(($2674)>>2)]=408;
      HEAP32[(($2675)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2676)>>2)]=472;
      var $32577=HEAP32[(($2674)>>2)];
      var $32578=HEAP32[(($2675)>>2)];
      var $32579=HEAP32[(($2676)>>2)];
      var $32580=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32577, $32578, $32579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6817; break; } else { __label__ = 6819; break; };
    case 6817: // $32581
      HEAP32[(($result_i803)>>2)]=$32580;
      var $32582=HEAP32[(($result_i803)>>2)];
      var $32583=(($32582)|0)==0;
      if ($32583) { __label__ = 6818; break; } else { __label__ = 6823; break; }
    case 6818: // $32584
      var $32585=___cxa_allocate_exception(4);
      var $32586=$32585;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32586);
      (function() { try { __THREW__ = false; return ___cxa_throw($32585, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6822; break; } else { __label__ = 6819; break; }
    case 6819: // $32587
      var $32588=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32589=$32588.f0;
      HEAP32[(($2677)>>2)]=$32589;
      var $32590=$32588.f1;
      HEAP32[(($2678)>>2)]=$32590;
      var $32591=HEAP32[(($2678)>>2)];
      var $32592=(($32591)|0) < 0;
      if ($32592) { __label__ = 6820; break; } else { __label__ = 6821; break; }
    case 6820: // $32593
      var $32594=HEAP32[(($2677)>>2)];
      ___cxa_call_unexpected($32594);
      throw "Reached an unreachable!"
    case 6821: // $32595
      var $32596=HEAP32[(($2677)>>2)];
      var $32597=HEAP32[(($2677)>>2)];
      var $32598=HEAP32[(($2678)>>2)];
      var $32599=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32597, tempValue);
      var $32600=($32599.f1 = $32598, $32599);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6822: // $32601
      throw "Reached an unreachable!"
    case 6823: // $_ZnwjPKci_exit804
      var $32602=HEAP32[(($result_i803)>>2)];
      var $32603=$2674;
      var $32604=$2675;
      var $32605=$2676;
      var $32606=$result_i803;
      var $32607=$2677;
      var $32608=$2678;
      var $32609=$32602;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8293, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6824; break; } else { __label__ = 13691; break; }
    case 6824: // $32610
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8294, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6825; break; } else { __label__ = 13691; break; }
    case 6825: // $32611
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8295, 4, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6826; break; } else { __label__ = 13691; break; }
    case 6826: // $32612
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6827; break; } else { __label__ = 13691; break; }
    case 6827: // $32613
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6828; break; } else { __label__ = 13691; break; }
    case 6828: // $32614
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6829; break; } else { __label__ = 13691; break; }
    case 6829: // $32615
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6830; break; } else { __label__ = 13691; break; }
    case 6830: // $32616
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8292, $8293, $8294, $8295, $8296, $8297, $8298, $8299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6831; break; } else { __label__ = 13691; break; }
    case 6831: // $32617
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8301, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6832; break; } else { __label__ = 13691; break; }
    case 6832: // $32618
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8302, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6833; break; } else { __label__ = 13691; break; }
    case 6833: // $32619
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8303, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6834; break; } else { __label__ = 13691; break; }
    case 6834: // $32620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6835; break; } else { __label__ = 13691; break; }
    case 6835: // $32621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6836; break; } else { __label__ = 13691; break; }
    case 6836: // $32622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6837; break; } else { __label__ = 13691; break; }
    case 6837: // $32623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6838; break; } else { __label__ = 13691; break; }
    case 6838: // $32624
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8300, $8301, $8302, $8303, $8304, $8305, $8306, $8307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6839; break; } else { __label__ = 13691; break; }
    case 6839: // $32625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8309, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6840; break; } else { __label__ = 13691; break; }
    case 6840: // $32626
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8310, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6841; break; } else { __label__ = 13691; break; }
    case 6841: // $32627
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8311, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6842; break; } else { __label__ = 13691; break; }
    case 6842: // $32628
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6843; break; } else { __label__ = 13691; break; }
    case 6843: // $32629
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6844; break; } else { __label__ = 13691; break; }
    case 6844: // $32630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6845; break; } else { __label__ = 13691; break; }
    case 6845: // $32631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6846; break; } else { __label__ = 13691; break; }
    case 6846: // $32632
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8308, $8309, $8310, $8311, $8312, $8313, $8314, $8315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6847; break; } else { __label__ = 13691; break; }
    case 6847: // $32633
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32609, 140, 1, 0, ((STRING_TABLE.__str994)|0), ((STRING_TABLE.__str995)|0), $8292, $8300, $8308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6848; break; } else { __label__ = 13691; break; }
    case 6848: // $32634
      var $32635=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32609);
      var $32636=__ZN11simple_listI16input_type_entryE6appendERS0_($32570, $32635);
      var $32637=$4689;
      var $32638=$2669;
      var $32639=$2670;
      var $32640=$2671;
      var $32641=$result_i805;
      var $32642=$2672;
      var $32643=$2673;
      HEAP32[(($2669)>>2)]=408;
      HEAP32[(($2670)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2671)>>2)]=473;
      var $32644=HEAP32[(($2669)>>2)];
      var $32645=HEAP32[(($2670)>>2)];
      var $32646=HEAP32[(($2671)>>2)];
      var $32647=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32644, $32645, $32646) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6849; break; } else { __label__ = 6851; break; };
    case 6849: // $32648
      HEAP32[(($result_i805)>>2)]=$32647;
      var $32649=HEAP32[(($result_i805)>>2)];
      var $32650=(($32649)|0)==0;
      if ($32650) { __label__ = 6850; break; } else { __label__ = 6855; break; }
    case 6850: // $32651
      var $32652=___cxa_allocate_exception(4);
      var $32653=$32652;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32653);
      (function() { try { __THREW__ = false; return ___cxa_throw($32652, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6854; break; } else { __label__ = 6851; break; }
    case 6851: // $32654
      var $32655=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32656=$32655.f0;
      HEAP32[(($2672)>>2)]=$32656;
      var $32657=$32655.f1;
      HEAP32[(($2673)>>2)]=$32657;
      var $32658=HEAP32[(($2673)>>2)];
      var $32659=(($32658)|0) < 0;
      if ($32659) { __label__ = 6852; break; } else { __label__ = 6853; break; }
    case 6852: // $32660
      var $32661=HEAP32[(($2672)>>2)];
      ___cxa_call_unexpected($32661);
      throw "Reached an unreachable!"
    case 6853: // $32662
      var $32663=HEAP32[(($2672)>>2)];
      var $32664=HEAP32[(($2672)>>2)];
      var $32665=HEAP32[(($2673)>>2)];
      var $32666=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32664, tempValue);
      var $32667=($32666.f1 = $32665, $32666);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6854: // $32668
      throw "Reached an unreachable!"
    case 6855: // $_ZnwjPKci_exit806
      var $32669=HEAP32[(($result_i805)>>2)];
      var $32670=$2669;
      var $32671=$2670;
      var $32672=$2671;
      var $32673=$result_i805;
      var $32674=$2672;
      var $32675=$2673;
      var $32676=$32669;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8317, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6856; break; } else { __label__ = 13696; break; }
    case 6856: // $32677
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8318, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6857; break; } else { __label__ = 13696; break; }
    case 6857: // $32678
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8319, 4, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6858; break; } else { __label__ = 13696; break; }
    case 6858: // $32679
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6859; break; } else { __label__ = 13696; break; }
    case 6859: // $32680
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6860; break; } else { __label__ = 13696; break; }
    case 6860: // $32681
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6861; break; } else { __label__ = 13696; break; }
    case 6861: // $32682
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6862; break; } else { __label__ = 13696; break; }
    case 6862: // $32683
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8316, $8317, $8318, $8319, $8320, $8321, $8322, $8323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6863; break; } else { __label__ = 13696; break; }
    case 6863: // $32684
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8325, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6864; break; } else { __label__ = 13696; break; }
    case 6864: // $32685
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8326, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6865; break; } else { __label__ = 13696; break; }
    case 6865: // $32686
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8327, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6866; break; } else { __label__ = 13696; break; }
    case 6866: // $32687
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6867; break; } else { __label__ = 13696; break; }
    case 6867: // $32688
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6868; break; } else { __label__ = 13696; break; }
    case 6868: // $32689
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6869; break; } else { __label__ = 13696; break; }
    case 6869: // $32690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6870; break; } else { __label__ = 13696; break; }
    case 6870: // $32691
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8324, $8325, $8326, $8327, $8328, $8329, $8330, $8331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6871; break; } else { __label__ = 13696; break; }
    case 6871: // $32692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8333, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6872; break; } else { __label__ = 13696; break; }
    case 6872: // $32693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8334, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6873; break; } else { __label__ = 13696; break; }
    case 6873: // $32694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8335, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6874; break; } else { __label__ = 13696; break; }
    case 6874: // $32695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6875; break; } else { __label__ = 13696; break; }
    case 6875: // $32696
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6876; break; } else { __label__ = 13696; break; }
    case 6876: // $32697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6877; break; } else { __label__ = 13696; break; }
    case 6877: // $32698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6878; break; } else { __label__ = 13696; break; }
    case 6878: // $32699
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8332, $8333, $8334, $8335, $8336, $8337, $8338, $8339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6879; break; } else { __label__ = 13696; break; }
    case 6879: // $32700
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32676, 140, 2, 1, ((STRING_TABLE.__str996)|0), ((STRING_TABLE.__str997)|0), $8316, $8324, $8332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6880; break; } else { __label__ = 13696; break; }
    case 6880: // $32701
      var $32702=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32676);
      var $32703=__ZN11simple_listI16input_type_entryE6appendERS0_($32637, $32702);
      var $32704=$4689;
      var $32705=$2664;
      var $32706=$2665;
      var $32707=$2666;
      var $32708=$result_i807;
      var $32709=$2667;
      var $32710=$2668;
      HEAP32[(($2664)>>2)]=408;
      HEAP32[(($2665)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2666)>>2)]=474;
      var $32711=HEAP32[(($2664)>>2)];
      var $32712=HEAP32[(($2665)>>2)];
      var $32713=HEAP32[(($2666)>>2)];
      var $32714=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32711, $32712, $32713) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6881; break; } else { __label__ = 6883; break; };
    case 6881: // $32715
      HEAP32[(($result_i807)>>2)]=$32714;
      var $32716=HEAP32[(($result_i807)>>2)];
      var $32717=(($32716)|0)==0;
      if ($32717) { __label__ = 6882; break; } else { __label__ = 6887; break; }
    case 6882: // $32718
      var $32719=___cxa_allocate_exception(4);
      var $32720=$32719;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32720);
      (function() { try { __THREW__ = false; return ___cxa_throw($32719, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6886; break; } else { __label__ = 6883; break; }
    case 6883: // $32721
      var $32722=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32723=$32722.f0;
      HEAP32[(($2667)>>2)]=$32723;
      var $32724=$32722.f1;
      HEAP32[(($2668)>>2)]=$32724;
      var $32725=HEAP32[(($2668)>>2)];
      var $32726=(($32725)|0) < 0;
      if ($32726) { __label__ = 6884; break; } else { __label__ = 6885; break; }
    case 6884: // $32727
      var $32728=HEAP32[(($2667)>>2)];
      ___cxa_call_unexpected($32728);
      throw "Reached an unreachable!"
    case 6885: // $32729
      var $32730=HEAP32[(($2667)>>2)];
      var $32731=HEAP32[(($2667)>>2)];
      var $32732=HEAP32[(($2668)>>2)];
      var $32733=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32731, tempValue);
      var $32734=($32733.f1 = $32732, $32733);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6886: // $32735
      throw "Reached an unreachable!"
    case 6887: // $_ZnwjPKci_exit808
      var $32736=HEAP32[(($result_i807)>>2)];
      var $32737=$2664;
      var $32738=$2665;
      var $32739=$2666;
      var $32740=$result_i807;
      var $32741=$2667;
      var $32742=$2668;
      var $32743=$32736;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8341, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6888; break; } else { __label__ = 13701; break; }
    case 6888: // $32744
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8342, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6889; break; } else { __label__ = 13701; break; }
    case 6889: // $32745
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8343, 4, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6890; break; } else { __label__ = 13701; break; }
    case 6890: // $32746
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6891; break; } else { __label__ = 13701; break; }
    case 6891: // $32747
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6892; break; } else { __label__ = 13701; break; }
    case 6892: // $32748
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6893; break; } else { __label__ = 13701; break; }
    case 6893: // $32749
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6894; break; } else { __label__ = 13701; break; }
    case 6894: // $32750
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8340, $8341, $8342, $8343, $8344, $8345, $8346, $8347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6895; break; } else { __label__ = 13701; break; }
    case 6895: // $32751
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8349, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6896; break; } else { __label__ = 13701; break; }
    case 6896: // $32752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8350, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6897; break; } else { __label__ = 13701; break; }
    case 6897: // $32753
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8351, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6898; break; } else { __label__ = 13701; break; }
    case 6898: // $32754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6899; break; } else { __label__ = 13701; break; }
    case 6899: // $32755
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6900; break; } else { __label__ = 13701; break; }
    case 6900: // $32756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6901; break; } else { __label__ = 13701; break; }
    case 6901: // $32757
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6902; break; } else { __label__ = 13701; break; }
    case 6902: // $32758
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8348, $8349, $8350, $8351, $8352, $8353, $8354, $8355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6903; break; } else { __label__ = 13701; break; }
    case 6903: // $32759
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8357, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6904; break; } else { __label__ = 13701; break; }
    case 6904: // $32760
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8358, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6905; break; } else { __label__ = 13701; break; }
    case 6905: // $32761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8359, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6906; break; } else { __label__ = 13701; break; }
    case 6906: // $32762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6907; break; } else { __label__ = 13701; break; }
    case 6907: // $32763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6908; break; } else { __label__ = 13701; break; }
    case 6908: // $32764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6909; break; } else { __label__ = 13701; break; }
    case 6909: // $32765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6910; break; } else { __label__ = 13701; break; }
    case 6910: // $32766
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8356, $8357, $8358, $8359, $8360, $8361, $8362, $8363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6911; break; } else { __label__ = 13701; break; }
    case 6911: // $32767
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32743, 140, 3, 2, ((STRING_TABLE.__str998)|0), ((STRING_TABLE.__str999)|0), $8340, $8348, $8356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6912; break; } else { __label__ = 13701; break; }
    case 6912: // $32768
      var $32769=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32743);
      var $32770=__ZN11simple_listI16input_type_entryE6appendERS0_($32704, $32769);
      var $32771=$4689;
      var $32772=$2659;
      var $32773=$2660;
      var $32774=$2661;
      var $32775=$result_i809;
      var $32776=$2662;
      var $32777=$2663;
      HEAP32[(($2659)>>2)]=408;
      HEAP32[(($2660)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2661)>>2)]=475;
      var $32778=HEAP32[(($2659)>>2)];
      var $32779=HEAP32[(($2660)>>2)];
      var $32780=HEAP32[(($2661)>>2)];
      var $32781=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32778, $32779, $32780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6913; break; } else { __label__ = 6915; break; };
    case 6913: // $32782
      HEAP32[(($result_i809)>>2)]=$32781;
      var $32783=HEAP32[(($result_i809)>>2)];
      var $32784=(($32783)|0)==0;
      if ($32784) { __label__ = 6914; break; } else { __label__ = 6919; break; }
    case 6914: // $32785
      var $32786=___cxa_allocate_exception(4);
      var $32787=$32786;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32787);
      (function() { try { __THREW__ = false; return ___cxa_throw($32786, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6918; break; } else { __label__ = 6915; break; }
    case 6915: // $32788
      var $32789=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32790=$32789.f0;
      HEAP32[(($2662)>>2)]=$32790;
      var $32791=$32789.f1;
      HEAP32[(($2663)>>2)]=$32791;
      var $32792=HEAP32[(($2663)>>2)];
      var $32793=(($32792)|0) < 0;
      if ($32793) { __label__ = 6916; break; } else { __label__ = 6917; break; }
    case 6916: // $32794
      var $32795=HEAP32[(($2662)>>2)];
      ___cxa_call_unexpected($32795);
      throw "Reached an unreachable!"
    case 6917: // $32796
      var $32797=HEAP32[(($2662)>>2)];
      var $32798=HEAP32[(($2662)>>2)];
      var $32799=HEAP32[(($2663)>>2)];
      var $32800=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32798, tempValue);
      var $32801=($32800.f1 = $32799, $32800);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6918: // $32802
      throw "Reached an unreachable!"
    case 6919: // $_ZnwjPKci_exit810
      var $32803=HEAP32[(($result_i809)>>2)];
      var $32804=$2659;
      var $32805=$2660;
      var $32806=$2661;
      var $32807=$result_i809;
      var $32808=$2662;
      var $32809=$2663;
      var $32810=$32803;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8365, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6920; break; } else { __label__ = 13706; break; }
    case 6920: // $32811
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8366, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6921; break; } else { __label__ = 13706; break; }
    case 6921: // $32812
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8367, 4, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6922; break; } else { __label__ = 13706; break; }
    case 6922: // $32813
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6923; break; } else { __label__ = 13706; break; }
    case 6923: // $32814
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6924; break; } else { __label__ = 13706; break; }
    case 6924: // $32815
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6925; break; } else { __label__ = 13706; break; }
    case 6925: // $32816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6926; break; } else { __label__ = 13706; break; }
    case 6926: // $32817
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8364, $8365, $8366, $8367, $8368, $8369, $8370, $8371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6927; break; } else { __label__ = 13706; break; }
    case 6927: // $32818
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8373, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6928; break; } else { __label__ = 13706; break; }
    case 6928: // $32819
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8374, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6929; break; } else { __label__ = 13706; break; }
    case 6929: // $32820
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8375, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6930; break; } else { __label__ = 13706; break; }
    case 6930: // $32821
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6931; break; } else { __label__ = 13706; break; }
    case 6931: // $32822
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6932; break; } else { __label__ = 13706; break; }
    case 6932: // $32823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6933; break; } else { __label__ = 13706; break; }
    case 6933: // $32824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6934; break; } else { __label__ = 13706; break; }
    case 6934: // $32825
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8372, $8373, $8374, $8375, $8376, $8377, $8378, $8379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6935; break; } else { __label__ = 13706; break; }
    case 6935: // $32826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8381, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6936; break; } else { __label__ = 13706; break; }
    case 6936: // $32827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6937; break; } else { __label__ = 13706; break; }
    case 6937: // $32828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6938; break; } else { __label__ = 13706; break; }
    case 6938: // $32829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6939; break; } else { __label__ = 13706; break; }
    case 6939: // $32830
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6940; break; } else { __label__ = 13706; break; }
    case 6940: // $32831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6941; break; } else { __label__ = 13706; break; }
    case 6941: // $32832
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6942; break; } else { __label__ = 13706; break; }
    case 6942: // $32833
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8380, $8381, $8382, $8383, $8384, $8385, $8386, $8387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6943; break; } else { __label__ = 13706; break; }
    case 6943: // $32834
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32810, 140, 4, 3, ((STRING_TABLE.__str1000)|0), ((STRING_TABLE.__str1001)|0), $8364, $8372, $8380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6944; break; } else { __label__ = 13706; break; }
    case 6944: // $32835
      var $32836=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32810);
      var $32837=__ZN11simple_listI16input_type_entryE6appendERS0_($32771, $32836);
      var $32838=$4689;
      var $32839=$2654;
      var $32840=$2655;
      var $32841=$2656;
      var $32842=$result_i811;
      var $32843=$2657;
      var $32844=$2658;
      HEAP32[(($2654)>>2)]=408;
      HEAP32[(($2655)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2656)>>2)]=476;
      var $32845=HEAP32[(($2654)>>2)];
      var $32846=HEAP32[(($2655)>>2)];
      var $32847=HEAP32[(($2656)>>2)];
      var $32848=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32845, $32846, $32847) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6945; break; } else { __label__ = 6947; break; };
    case 6945: // $32849
      HEAP32[(($result_i811)>>2)]=$32848;
      var $32850=HEAP32[(($result_i811)>>2)];
      var $32851=(($32850)|0)==0;
      if ($32851) { __label__ = 6946; break; } else { __label__ = 6951; break; }
    case 6946: // $32852
      var $32853=___cxa_allocate_exception(4);
      var $32854=$32853;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32854);
      (function() { try { __THREW__ = false; return ___cxa_throw($32853, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6950; break; } else { __label__ = 6947; break; }
    case 6947: // $32855
      var $32856=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32857=$32856.f0;
      HEAP32[(($2657)>>2)]=$32857;
      var $32858=$32856.f1;
      HEAP32[(($2658)>>2)]=$32858;
      var $32859=HEAP32[(($2658)>>2)];
      var $32860=(($32859)|0) < 0;
      if ($32860) { __label__ = 6948; break; } else { __label__ = 6949; break; }
    case 6948: // $32861
      var $32862=HEAP32[(($2657)>>2)];
      ___cxa_call_unexpected($32862);
      throw "Reached an unreachable!"
    case 6949: // $32863
      var $32864=HEAP32[(($2657)>>2)];
      var $32865=HEAP32[(($2657)>>2)];
      var $32866=HEAP32[(($2658)>>2)];
      var $32867=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32865, tempValue);
      var $32868=($32867.f1 = $32866, $32867);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6950: // $32869
      throw "Reached an unreachable!"
    case 6951: // $_ZnwjPKci_exit812
      var $32870=HEAP32[(($result_i811)>>2)];
      var $32871=$2654;
      var $32872=$2655;
      var $32873=$2656;
      var $32874=$result_i811;
      var $32875=$2657;
      var $32876=$2658;
      var $32877=$32870;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8389, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6952; break; } else { __label__ = 13711; break; }
    case 6952: // $32878
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8390, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6953; break; } else { __label__ = 13711; break; }
    case 6953: // $32879
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8391, 4, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6954; break; } else { __label__ = 13711; break; }
    case 6954: // $32880
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6955; break; } else { __label__ = 13711; break; }
    case 6955: // $32881
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6956; break; } else { __label__ = 13711; break; }
    case 6956: // $32882
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6957; break; } else { __label__ = 13711; break; }
    case 6957: // $32883
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6958; break; } else { __label__ = 13711; break; }
    case 6958: // $32884
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8388, $8389, $8390, $8391, $8392, $8393, $8394, $8395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6959; break; } else { __label__ = 13711; break; }
    case 6959: // $32885
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8397, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6960; break; } else { __label__ = 13711; break; }
    case 6960: // $32886
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8398, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6961; break; } else { __label__ = 13711; break; }
    case 6961: // $32887
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8399, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6962; break; } else { __label__ = 13711; break; }
    case 6962: // $32888
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6963; break; } else { __label__ = 13711; break; }
    case 6963: // $32889
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6964; break; } else { __label__ = 13711; break; }
    case 6964: // $32890
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6965; break; } else { __label__ = 13711; break; }
    case 6965: // $32891
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6966; break; } else { __label__ = 13711; break; }
    case 6966: // $32892
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8396, $8397, $8398, $8399, $8400, $8401, $8402, $8403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6967; break; } else { __label__ = 13711; break; }
    case 6967: // $32893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8405, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6968; break; } else { __label__ = 13711; break; }
    case 6968: // $32894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8406, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6969; break; } else { __label__ = 13711; break; }
    case 6969: // $32895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8407, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6970; break; } else { __label__ = 13711; break; }
    case 6970: // $32896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8408, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6971; break; } else { __label__ = 13711; break; }
    case 6971: // $32897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8409, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6972; break; } else { __label__ = 13711; break; }
    case 6972: // $32898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6973; break; } else { __label__ = 13711; break; }
    case 6973: // $32899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6974; break; } else { __label__ = 13711; break; }
    case 6974: // $32900
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8404, $8405, $8406, $8407, $8408, $8409, $8410, $8411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6975; break; } else { __label__ = 13711; break; }
    case 6975: // $32901
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32877, 140, 5, 4, ((STRING_TABLE.__str1002)|0), ((STRING_TABLE.__str1003)|0), $8388, $8396, $8404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6976; break; } else { __label__ = 13711; break; }
    case 6976: // $32902
      var $32903=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32877);
      var $32904=__ZN11simple_listI16input_type_entryE6appendERS0_($32838, $32903);
      var $32905=$4689;
      var $32906=$2649;
      var $32907=$2650;
      var $32908=$2651;
      var $32909=$result_i813;
      var $32910=$2652;
      var $32911=$2653;
      HEAP32[(($2649)>>2)]=408;
      HEAP32[(($2650)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2651)>>2)]=477;
      var $32912=HEAP32[(($2649)>>2)];
      var $32913=HEAP32[(($2650)>>2)];
      var $32914=HEAP32[(($2651)>>2)];
      var $32915=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32912, $32913, $32914) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6977; break; } else { __label__ = 6979; break; };
    case 6977: // $32916
      HEAP32[(($result_i813)>>2)]=$32915;
      var $32917=HEAP32[(($result_i813)>>2)];
      var $32918=(($32917)|0)==0;
      if ($32918) { __label__ = 6978; break; } else { __label__ = 6983; break; }
    case 6978: // $32919
      var $32920=___cxa_allocate_exception(4);
      var $32921=$32920;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32921);
      (function() { try { __THREW__ = false; return ___cxa_throw($32920, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6982; break; } else { __label__ = 6979; break; }
    case 6979: // $32922
      var $32923=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32924=$32923.f0;
      HEAP32[(($2652)>>2)]=$32924;
      var $32925=$32923.f1;
      HEAP32[(($2653)>>2)]=$32925;
      var $32926=HEAP32[(($2653)>>2)];
      var $32927=(($32926)|0) < 0;
      if ($32927) { __label__ = 6980; break; } else { __label__ = 6981; break; }
    case 6980: // $32928
      var $32929=HEAP32[(($2652)>>2)];
      ___cxa_call_unexpected($32929);
      throw "Reached an unreachable!"
    case 6981: // $32930
      var $32931=HEAP32[(($2652)>>2)];
      var $32932=HEAP32[(($2652)>>2)];
      var $32933=HEAP32[(($2653)>>2)];
      var $32934=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32932, tempValue);
      var $32935=($32934.f1 = $32933, $32934);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6982: // $32936
      throw "Reached an unreachable!"
    case 6983: // $_ZnwjPKci_exit814
      var $32937=HEAP32[(($result_i813)>>2)];
      var $32938=$2649;
      var $32939=$2650;
      var $32940=$2651;
      var $32941=$result_i813;
      var $32942=$2652;
      var $32943=$2653;
      var $32944=$32937;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8413, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6984; break; } else { __label__ = 13716; break; }
    case 6984: // $32945
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8414, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6985; break; } else { __label__ = 13716; break; }
    case 6985: // $32946
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8415, 4, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6986; break; } else { __label__ = 13716; break; }
    case 6986: // $32947
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6987; break; } else { __label__ = 13716; break; }
    case 6987: // $32948
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6988; break; } else { __label__ = 13716; break; }
    case 6988: // $32949
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6989; break; } else { __label__ = 13716; break; }
    case 6989: // $32950
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6990; break; } else { __label__ = 13716; break; }
    case 6990: // $32951
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8412, $8413, $8414, $8415, $8416, $8417, $8418, $8419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6991; break; } else { __label__ = 13716; break; }
    case 6991: // $32952
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8421, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6992; break; } else { __label__ = 13716; break; }
    case 6992: // $32953
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8422, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6993; break; } else { __label__ = 13716; break; }
    case 6993: // $32954
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8423, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6994; break; } else { __label__ = 13716; break; }
    case 6994: // $32955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6995; break; } else { __label__ = 13716; break; }
    case 6995: // $32956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6996; break; } else { __label__ = 13716; break; }
    case 6996: // $32957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6997; break; } else { __label__ = 13716; break; }
    case 6997: // $32958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6998; break; } else { __label__ = 13716; break; }
    case 6998: // $32959
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8420, $8421, $8422, $8423, $8424, $8425, $8426, $8427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6999; break; } else { __label__ = 13716; break; }
    case 6999: // $32960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8429, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7000; break; } else { __label__ = 13716; break; }
    case 7000: // $32961
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8430, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7001; break; } else { __label__ = 13716; break; }
    case 7001: // $32962
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8431, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7002; break; } else { __label__ = 13716; break; }
    case 7002: // $32963
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8432, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7003; break; } else { __label__ = 13716; break; }
    case 7003: // $32964
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8433, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7004; break; } else { __label__ = 13716; break; }
    case 7004: // $32965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7005; break; } else { __label__ = 13716; break; }
    case 7005: // $32966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7006; break; } else { __label__ = 13716; break; }
    case 7006: // $32967
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8428, $8429, $8430, $8431, $8432, $8433, $8434, $8435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7007; break; } else { __label__ = 13716; break; }
    case 7007: // $32968
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($32944, 140, 6, 5, ((STRING_TABLE.__str1004)|0), ((STRING_TABLE.__str1005)|0), $8412, $8420, $8428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7008; break; } else { __label__ = 13716; break; }
    case 7008: // $32969
      var $32970=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $32944);
      var $32971=__ZN11simple_listI16input_type_entryE6appendERS0_($32905, $32970);
      var $32972=$4689;
      var $32973=$2644;
      var $32974=$2645;
      var $32975=$2646;
      var $32976=$result_i815;
      var $32977=$2647;
      var $32978=$2648;
      HEAP32[(($2644)>>2)]=408;
      HEAP32[(($2645)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2646)>>2)]=478;
      var $32979=HEAP32[(($2644)>>2)];
      var $32980=HEAP32[(($2645)>>2)];
      var $32981=HEAP32[(($2646)>>2)];
      var $32982=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32979, $32980, $32981) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7009; break; } else { __label__ = 7011; break; };
    case 7009: // $32983
      HEAP32[(($result_i815)>>2)]=$32982;
      var $32984=HEAP32[(($result_i815)>>2)];
      var $32985=(($32984)|0)==0;
      if ($32985) { __label__ = 7010; break; } else { __label__ = 7015; break; }
    case 7010: // $32986
      var $32987=___cxa_allocate_exception(4);
      var $32988=$32987;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32988);
      (function() { try { __THREW__ = false; return ___cxa_throw($32987, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7014; break; } else { __label__ = 7011; break; }
    case 7011: // $32989
      var $32990=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32991=$32990.f0;
      HEAP32[(($2647)>>2)]=$32991;
      var $32992=$32990.f1;
      HEAP32[(($2648)>>2)]=$32992;
      var $32993=HEAP32[(($2648)>>2)];
      var $32994=(($32993)|0) < 0;
      if ($32994) { __label__ = 7012; break; } else { __label__ = 7013; break; }
    case 7012: // $32995
      var $32996=HEAP32[(($2647)>>2)];
      ___cxa_call_unexpected($32996);
      throw "Reached an unreachable!"
    case 7013: // $32997
      var $32998=HEAP32[(($2647)>>2)];
      var $32999=HEAP32[(($2647)>>2)];
      var $33000=HEAP32[(($2648)>>2)];
      var $33001=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32999, tempValue);
      var $33002=($33001.f1 = $33000, $33001);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7014: // $33003
      throw "Reached an unreachable!"
    case 7015: // $_ZnwjPKci_exit816
      var $33004=HEAP32[(($result_i815)>>2)];
      var $33005=$2644;
      var $33006=$2645;
      var $33007=$2646;
      var $33008=$result_i815;
      var $33009=$2647;
      var $33010=$2648;
      var $33011=$33004;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8437, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7016; break; } else { __label__ = 13721; break; }
    case 7016: // $33012
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8438, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7017; break; } else { __label__ = 13721; break; }
    case 7017: // $33013
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8439, 4, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7018; break; } else { __label__ = 13721; break; }
    case 7018: // $33014
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7019; break; } else { __label__ = 13721; break; }
    case 7019: // $33015
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7020; break; } else { __label__ = 13721; break; }
    case 7020: // $33016
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7021; break; } else { __label__ = 13721; break; }
    case 7021: // $33017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7022; break; } else { __label__ = 13721; break; }
    case 7022: // $33018
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8436, $8437, $8438, $8439, $8440, $8441, $8442, $8443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7023; break; } else { __label__ = 13721; break; }
    case 7023: // $33019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8445, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7024; break; } else { __label__ = 13721; break; }
    case 7024: // $33020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8446, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7025; break; } else { __label__ = 13721; break; }
    case 7025: // $33021
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8447, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7026; break; } else { __label__ = 13721; break; }
    case 7026: // $33022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7027; break; } else { __label__ = 13721; break; }
    case 7027: // $33023
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7028; break; } else { __label__ = 13721; break; }
    case 7028: // $33024
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7029; break; } else { __label__ = 13721; break; }
    case 7029: // $33025
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7030; break; } else { __label__ = 13721; break; }
    case 7030: // $33026
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8444, $8445, $8446, $8447, $8448, $8449, $8450, $8451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7031; break; } else { __label__ = 13721; break; }
    case 7031: // $33027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8453, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7032; break; } else { __label__ = 13721; break; }
    case 7032: // $33028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8454, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7033; break; } else { __label__ = 13721; break; }
    case 7033: // $33029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8455, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7034; break; } else { __label__ = 13721; break; }
    case 7034: // $33030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8456, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7035; break; } else { __label__ = 13721; break; }
    case 7035: // $33031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8457, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7036; break; } else { __label__ = 13721; break; }
    case 7036: // $33032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7037; break; } else { __label__ = 13721; break; }
    case 7037: // $33033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7038; break; } else { __label__ = 13721; break; }
    case 7038: // $33034
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8452, $8453, $8454, $8455, $8456, $8457, $8458, $8459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7039; break; } else { __label__ = 13721; break; }
    case 7039: // $33035
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33011, 140, 7, 6, ((STRING_TABLE.__str1006)|0), ((STRING_TABLE.__str1007)|0), $8436, $8444, $8452) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7040; break; } else { __label__ = 13721; break; }
    case 7040: // $33036
      var $33037=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33011);
      var $33038=__ZN11simple_listI16input_type_entryE6appendERS0_($32972, $33037);
      var $33039=$4689;
      var $33040=$2639;
      var $33041=$2640;
      var $33042=$2641;
      var $33043=$result_i817;
      var $33044=$2642;
      var $33045=$2643;
      HEAP32[(($2639)>>2)]=408;
      HEAP32[(($2640)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2641)>>2)]=479;
      var $33046=HEAP32[(($2639)>>2)];
      var $33047=HEAP32[(($2640)>>2)];
      var $33048=HEAP32[(($2641)>>2)];
      var $33049=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33046, $33047, $33048) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7041; break; } else { __label__ = 7043; break; };
    case 7041: // $33050
      HEAP32[(($result_i817)>>2)]=$33049;
      var $33051=HEAP32[(($result_i817)>>2)];
      var $33052=(($33051)|0)==0;
      if ($33052) { __label__ = 7042; break; } else { __label__ = 7047; break; }
    case 7042: // $33053
      var $33054=___cxa_allocate_exception(4);
      var $33055=$33054;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33055);
      (function() { try { __THREW__ = false; return ___cxa_throw($33054, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7046; break; } else { __label__ = 7043; break; }
    case 7043: // $33056
      var $33057=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33058=$33057.f0;
      HEAP32[(($2642)>>2)]=$33058;
      var $33059=$33057.f1;
      HEAP32[(($2643)>>2)]=$33059;
      var $33060=HEAP32[(($2643)>>2)];
      var $33061=(($33060)|0) < 0;
      if ($33061) { __label__ = 7044; break; } else { __label__ = 7045; break; }
    case 7044: // $33062
      var $33063=HEAP32[(($2642)>>2)];
      ___cxa_call_unexpected($33063);
      throw "Reached an unreachable!"
    case 7045: // $33064
      var $33065=HEAP32[(($2642)>>2)];
      var $33066=HEAP32[(($2642)>>2)];
      var $33067=HEAP32[(($2643)>>2)];
      var $33068=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33066, tempValue);
      var $33069=($33068.f1 = $33067, $33068);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7046: // $33070
      throw "Reached an unreachable!"
    case 7047: // $_ZnwjPKci_exit818
      var $33071=HEAP32[(($result_i817)>>2)];
      var $33072=$2639;
      var $33073=$2640;
      var $33074=$2641;
      var $33075=$result_i817;
      var $33076=$2642;
      var $33077=$2643;
      var $33078=$33071;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8461, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7048; break; } else { __label__ = 13726; break; }
    case 7048: // $33079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8462, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7049; break; } else { __label__ = 13726; break; }
    case 7049: // $33080
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8463, 4, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7050; break; } else { __label__ = 13726; break; }
    case 7050: // $33081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7051; break; } else { __label__ = 13726; break; }
    case 7051: // $33082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7052; break; } else { __label__ = 13726; break; }
    case 7052: // $33083
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7053; break; } else { __label__ = 13726; break; }
    case 7053: // $33084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7054; break; } else { __label__ = 13726; break; }
    case 7054: // $33085
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8460, $8461, $8462, $8463, $8464, $8465, $8466, $8467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7055; break; } else { __label__ = 13726; break; }
    case 7055: // $33086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8469, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7056; break; } else { __label__ = 13726; break; }
    case 7056: // $33087
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8470, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7057; break; } else { __label__ = 13726; break; }
    case 7057: // $33088
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8471, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7058; break; } else { __label__ = 13726; break; }
    case 7058: // $33089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7059; break; } else { __label__ = 13726; break; }
    case 7059: // $33090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7060; break; } else { __label__ = 13726; break; }
    case 7060: // $33091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7061; break; } else { __label__ = 13726; break; }
    case 7061: // $33092
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7062; break; } else { __label__ = 13726; break; }
    case 7062: // $33093
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8468, $8469, $8470, $8471, $8472, $8473, $8474, $8475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7063; break; } else { __label__ = 13726; break; }
    case 7063: // $33094
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8477, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7064; break; } else { __label__ = 13726; break; }
    case 7064: // $33095
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8478, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7065; break; } else { __label__ = 13726; break; }
    case 7065: // $33096
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8479, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7066; break; } else { __label__ = 13726; break; }
    case 7066: // $33097
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8480, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7067; break; } else { __label__ = 13726; break; }
    case 7067: // $33098
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8481, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7068; break; } else { __label__ = 13726; break; }
    case 7068: // $33099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7069; break; } else { __label__ = 13726; break; }
    case 7069: // $33100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7070; break; } else { __label__ = 13726; break; }
    case 7070: // $33101
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8476, $8477, $8478, $8479, $8480, $8481, $8482, $8483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7071; break; } else { __label__ = 13726; break; }
    case 7071: // $33102
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33078, 140, 8, 7, ((STRING_TABLE.__str1008)|0), ((STRING_TABLE.__str1009)|0), $8460, $8468, $8476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7072; break; } else { __label__ = 13726; break; }
    case 7072: // $33103
      var $33104=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33078);
      var $33105=__ZN11simple_listI16input_type_entryE6appendERS0_($33039, $33104);
      var $33106=$4689;
      var $33107=$2634;
      var $33108=$2635;
      var $33109=$2636;
      var $33110=$result_i819;
      var $33111=$2637;
      var $33112=$2638;
      HEAP32[(($2634)>>2)]=408;
      HEAP32[(($2635)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2636)>>2)]=481;
      var $33113=HEAP32[(($2634)>>2)];
      var $33114=HEAP32[(($2635)>>2)];
      var $33115=HEAP32[(($2636)>>2)];
      var $33116=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33113, $33114, $33115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7073; break; } else { __label__ = 7075; break; };
    case 7073: // $33117
      HEAP32[(($result_i819)>>2)]=$33116;
      var $33118=HEAP32[(($result_i819)>>2)];
      var $33119=(($33118)|0)==0;
      if ($33119) { __label__ = 7074; break; } else { __label__ = 7079; break; }
    case 7074: // $33120
      var $33121=___cxa_allocate_exception(4);
      var $33122=$33121;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33122);
      (function() { try { __THREW__ = false; return ___cxa_throw($33121, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7078; break; } else { __label__ = 7075; break; }
    case 7075: // $33123
      var $33124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33125=$33124.f0;
      HEAP32[(($2637)>>2)]=$33125;
      var $33126=$33124.f1;
      HEAP32[(($2638)>>2)]=$33126;
      var $33127=HEAP32[(($2638)>>2)];
      var $33128=(($33127)|0) < 0;
      if ($33128) { __label__ = 7076; break; } else { __label__ = 7077; break; }
    case 7076: // $33129
      var $33130=HEAP32[(($2637)>>2)];
      ___cxa_call_unexpected($33130);
      throw "Reached an unreachable!"
    case 7077: // $33131
      var $33132=HEAP32[(($2637)>>2)];
      var $33133=HEAP32[(($2637)>>2)];
      var $33134=HEAP32[(($2638)>>2)];
      var $33135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33133, tempValue);
      var $33136=($33135.f1 = $33134, $33135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7078: // $33137
      throw "Reached an unreachable!"
    case 7079: // $_ZnwjPKci_exit820
      var $33138=HEAP32[(($result_i819)>>2)];
      var $33139=$2634;
      var $33140=$2635;
      var $33141=$2636;
      var $33142=$result_i819;
      var $33143=$2637;
      var $33144=$2638;
      var $33145=$33138;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8485, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7080; break; } else { __label__ = 13731; break; }
    case 7080: // $33146
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8486, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7081; break; } else { __label__ = 13731; break; }
    case 7081: // $33147
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8487, 4, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7082; break; } else { __label__ = 13731; break; }
    case 7082: // $33148
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7083; break; } else { __label__ = 13731; break; }
    case 7083: // $33149
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7084; break; } else { __label__ = 13731; break; }
    case 7084: // $33150
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7085; break; } else { __label__ = 13731; break; }
    case 7085: // $33151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7086; break; } else { __label__ = 13731; break; }
    case 7086: // $33152
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8484, $8485, $8486, $8487, $8488, $8489, $8490, $8491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7087; break; } else { __label__ = 13731; break; }
    case 7087: // $33153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8493, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7088; break; } else { __label__ = 13731; break; }
    case 7088: // $33154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8494, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7089; break; } else { __label__ = 13731; break; }
    case 7089: // $33155
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8495, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7090; break; } else { __label__ = 13731; break; }
    case 7090: // $33156
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7091; break; } else { __label__ = 13731; break; }
    case 7091: // $33157
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7092; break; } else { __label__ = 13731; break; }
    case 7092: // $33158
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7093; break; } else { __label__ = 13731; break; }
    case 7093: // $33159
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7094; break; } else { __label__ = 13731; break; }
    case 7094: // $33160
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8492, $8493, $8494, $8495, $8496, $8497, $8498, $8499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7095; break; } else { __label__ = 13731; break; }
    case 7095: // $33161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8501, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7096; break; } else { __label__ = 13731; break; }
    case 7096: // $33162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8502, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7097; break; } else { __label__ = 13731; break; }
    case 7097: // $33163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8503, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7098; break; } else { __label__ = 13731; break; }
    case 7098: // $33164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8504, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7099; break; } else { __label__ = 13731; break; }
    case 7099: // $33165
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8505, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7100; break; } else { __label__ = 13731; break; }
    case 7100: // $33166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7101; break; } else { __label__ = 13731; break; }
    case 7101: // $33167
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7102; break; } else { __label__ = 13731; break; }
    case 7102: // $33168
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8500, $8501, $8502, $8503, $8504, $8505, $8506, $8507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7103; break; } else { __label__ = 13731; break; }
    case 7103: // $33169
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33145, 141, 1, 0, ((STRING_TABLE.__str1010)|0), ((STRING_TABLE.__str1011)|0), $8484, $8492, $8500) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7104; break; } else { __label__ = 13731; break; }
    case 7104: // $33170
      var $33171=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33145);
      var $33172=__ZN11simple_listI16input_type_entryE6appendERS0_($33106, $33171);
      var $33173=$4689;
      var $33174=$2629;
      var $33175=$2630;
      var $33176=$2631;
      var $33177=$result_i821;
      var $33178=$2632;
      var $33179=$2633;
      HEAP32[(($2629)>>2)]=408;
      HEAP32[(($2630)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2631)>>2)]=482;
      var $33180=HEAP32[(($2629)>>2)];
      var $33181=HEAP32[(($2630)>>2)];
      var $33182=HEAP32[(($2631)>>2)];
      var $33183=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33180, $33181, $33182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7105; break; } else { __label__ = 7107; break; };
    case 7105: // $33184
      HEAP32[(($result_i821)>>2)]=$33183;
      var $33185=HEAP32[(($result_i821)>>2)];
      var $33186=(($33185)|0)==0;
      if ($33186) { __label__ = 7106; break; } else { __label__ = 7111; break; }
    case 7106: // $33187
      var $33188=___cxa_allocate_exception(4);
      var $33189=$33188;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33189);
      (function() { try { __THREW__ = false; return ___cxa_throw($33188, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7110; break; } else { __label__ = 7107; break; }
    case 7107: // $33190
      var $33191=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33192=$33191.f0;
      HEAP32[(($2632)>>2)]=$33192;
      var $33193=$33191.f1;
      HEAP32[(($2633)>>2)]=$33193;
      var $33194=HEAP32[(($2633)>>2)];
      var $33195=(($33194)|0) < 0;
      if ($33195) { __label__ = 7108; break; } else { __label__ = 7109; break; }
    case 7108: // $33196
      var $33197=HEAP32[(($2632)>>2)];
      ___cxa_call_unexpected($33197);
      throw "Reached an unreachable!"
    case 7109: // $33198
      var $33199=HEAP32[(($2632)>>2)];
      var $33200=HEAP32[(($2632)>>2)];
      var $33201=HEAP32[(($2633)>>2)];
      var $33202=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33200, tempValue);
      var $33203=($33202.f1 = $33201, $33202);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7110: // $33204
      throw "Reached an unreachable!"
    case 7111: // $_ZnwjPKci_exit822
      var $33205=HEAP32[(($result_i821)>>2)];
      var $33206=$2629;
      var $33207=$2630;
      var $33208=$2631;
      var $33209=$result_i821;
      var $33210=$2632;
      var $33211=$2633;
      var $33212=$33205;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8509, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7112; break; } else { __label__ = 13736; break; }
    case 7112: // $33213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8510, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7113; break; } else { __label__ = 13736; break; }
    case 7113: // $33214
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8511, 4, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7114; break; } else { __label__ = 13736; break; }
    case 7114: // $33215
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7115; break; } else { __label__ = 13736; break; }
    case 7115: // $33216
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7116; break; } else { __label__ = 13736; break; }
    case 7116: // $33217
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7117; break; } else { __label__ = 13736; break; }
    case 7117: // $33218
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7118; break; } else { __label__ = 13736; break; }
    case 7118: // $33219
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8508, $8509, $8510, $8511, $8512, $8513, $8514, $8515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7119; break; } else { __label__ = 13736; break; }
    case 7119: // $33220
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8517, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7120; break; } else { __label__ = 13736; break; }
    case 7120: // $33221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8518, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7121; break; } else { __label__ = 13736; break; }
    case 7121: // $33222
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8519, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7122; break; } else { __label__ = 13736; break; }
    case 7122: // $33223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7123; break; } else { __label__ = 13736; break; }
    case 7123: // $33224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7124; break; } else { __label__ = 13736; break; }
    case 7124: // $33225
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7125; break; } else { __label__ = 13736; break; }
    case 7125: // $33226
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7126; break; } else { __label__ = 13736; break; }
    case 7126: // $33227
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8516, $8517, $8518, $8519, $8520, $8521, $8522, $8523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7127; break; } else { __label__ = 13736; break; }
    case 7127: // $33228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8525, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7128; break; } else { __label__ = 13736; break; }
    case 7128: // $33229
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8526, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7129; break; } else { __label__ = 13736; break; }
    case 7129: // $33230
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8527, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7130; break; } else { __label__ = 13736; break; }
    case 7130: // $33231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8528, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7131; break; } else { __label__ = 13736; break; }
    case 7131: // $33232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8529, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7132; break; } else { __label__ = 13736; break; }
    case 7132: // $33233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7133; break; } else { __label__ = 13736; break; }
    case 7133: // $33234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7134; break; } else { __label__ = 13736; break; }
    case 7134: // $33235
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8524, $8525, $8526, $8527, $8528, $8529, $8530, $8531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7135; break; } else { __label__ = 13736; break; }
    case 7135: // $33236
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33212, 141, 2, 1, ((STRING_TABLE.__str1012)|0), ((STRING_TABLE.__str1013)|0), $8508, $8516, $8524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7136; break; } else { __label__ = 13736; break; }
    case 7136: // $33237
      var $33238=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33212);
      var $33239=__ZN11simple_listI16input_type_entryE6appendERS0_($33173, $33238);
      var $33240=$4689;
      var $33241=$2624;
      var $33242=$2625;
      var $33243=$2626;
      var $33244=$result_i823;
      var $33245=$2627;
      var $33246=$2628;
      HEAP32[(($2624)>>2)]=408;
      HEAP32[(($2625)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2626)>>2)]=483;
      var $33247=HEAP32[(($2624)>>2)];
      var $33248=HEAP32[(($2625)>>2)];
      var $33249=HEAP32[(($2626)>>2)];
      var $33250=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33247, $33248, $33249) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7137; break; } else { __label__ = 7139; break; };
    case 7137: // $33251
      HEAP32[(($result_i823)>>2)]=$33250;
      var $33252=HEAP32[(($result_i823)>>2)];
      var $33253=(($33252)|0)==0;
      if ($33253) { __label__ = 7138; break; } else { __label__ = 7143; break; }
    case 7138: // $33254
      var $33255=___cxa_allocate_exception(4);
      var $33256=$33255;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33256);
      (function() { try { __THREW__ = false; return ___cxa_throw($33255, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7142; break; } else { __label__ = 7139; break; }
    case 7139: // $33257
      var $33258=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33259=$33258.f0;
      HEAP32[(($2627)>>2)]=$33259;
      var $33260=$33258.f1;
      HEAP32[(($2628)>>2)]=$33260;
      var $33261=HEAP32[(($2628)>>2)];
      var $33262=(($33261)|0) < 0;
      if ($33262) { __label__ = 7140; break; } else { __label__ = 7141; break; }
    case 7140: // $33263
      var $33264=HEAP32[(($2627)>>2)];
      ___cxa_call_unexpected($33264);
      throw "Reached an unreachable!"
    case 7141: // $33265
      var $33266=HEAP32[(($2627)>>2)];
      var $33267=HEAP32[(($2627)>>2)];
      var $33268=HEAP32[(($2628)>>2)];
      var $33269=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33267, tempValue);
      var $33270=($33269.f1 = $33268, $33269);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7142: // $33271
      throw "Reached an unreachable!"
    case 7143: // $_ZnwjPKci_exit824
      var $33272=HEAP32[(($result_i823)>>2)];
      var $33273=$2624;
      var $33274=$2625;
      var $33275=$2626;
      var $33276=$result_i823;
      var $33277=$2627;
      var $33278=$2628;
      var $33279=$33272;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8533, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7144; break; } else { __label__ = 13741; break; }
    case 7144: // $33280
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8534, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7145; break; } else { __label__ = 13741; break; }
    case 7145: // $33281
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8535, 4, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7146; break; } else { __label__ = 13741; break; }
    case 7146: // $33282
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7147; break; } else { __label__ = 13741; break; }
    case 7147: // $33283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7148; break; } else { __label__ = 13741; break; }
    case 7148: // $33284
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7149; break; } else { __label__ = 13741; break; }
    case 7149: // $33285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7150; break; } else { __label__ = 13741; break; }
    case 7150: // $33286
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8532, $8533, $8534, $8535, $8536, $8537, $8538, $8539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7151; break; } else { __label__ = 13741; break; }
    case 7151: // $33287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8541, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7152; break; } else { __label__ = 13741; break; }
    case 7152: // $33288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8542, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7153; break; } else { __label__ = 13741; break; }
    case 7153: // $33289
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8543, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7154; break; } else { __label__ = 13741; break; }
    case 7154: // $33290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7155; break; } else { __label__ = 13741; break; }
    case 7155: // $33291
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7156; break; } else { __label__ = 13741; break; }
    case 7156: // $33292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7157; break; } else { __label__ = 13741; break; }
    case 7157: // $33293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7158; break; } else { __label__ = 13741; break; }
    case 7158: // $33294
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8540, $8541, $8542, $8543, $8544, $8545, $8546, $8547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7159; break; } else { __label__ = 13741; break; }
    case 7159: // $33295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8549, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7160; break; } else { __label__ = 13741; break; }
    case 7160: // $33296
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8550, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7161; break; } else { __label__ = 13741; break; }
    case 7161: // $33297
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8551, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7162; break; } else { __label__ = 13741; break; }
    case 7162: // $33298
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8552, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7163; break; } else { __label__ = 13741; break; }
    case 7163: // $33299
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8553, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7164; break; } else { __label__ = 13741; break; }
    case 7164: // $33300
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8554, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7165; break; } else { __label__ = 13741; break; }
    case 7165: // $33301
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8555, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7166; break; } else { __label__ = 13741; break; }
    case 7166: // $33302
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8548, $8549, $8550, $8551, $8552, $8553, $8554, $8555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7167; break; } else { __label__ = 13741; break; }
    case 7167: // $33303
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33279, 141, 3, 2, ((STRING_TABLE.__str1014)|0), ((STRING_TABLE.__str1015)|0), $8532, $8540, $8548) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7168; break; } else { __label__ = 13741; break; }
    case 7168: // $33304
      var $33305=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33279);
      var $33306=__ZN11simple_listI16input_type_entryE6appendERS0_($33240, $33305);
      var $33307=$4689;
      var $33308=$2619;
      var $33309=$2620;
      var $33310=$2621;
      var $33311=$result_i825;
      var $33312=$2622;
      var $33313=$2623;
      HEAP32[(($2619)>>2)]=408;
      HEAP32[(($2620)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2621)>>2)]=484;
      var $33314=HEAP32[(($2619)>>2)];
      var $33315=HEAP32[(($2620)>>2)];
      var $33316=HEAP32[(($2621)>>2)];
      var $33317=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33314, $33315, $33316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7169; break; } else { __label__ = 7171; break; };
    case 7169: // $33318
      HEAP32[(($result_i825)>>2)]=$33317;
      var $33319=HEAP32[(($result_i825)>>2)];
      var $33320=(($33319)|0)==0;
      if ($33320) { __label__ = 7170; break; } else { __label__ = 7175; break; }
    case 7170: // $33321
      var $33322=___cxa_allocate_exception(4);
      var $33323=$33322;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33323);
      (function() { try { __THREW__ = false; return ___cxa_throw($33322, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7174; break; } else { __label__ = 7171; break; }
    case 7171: // $33324
      var $33325=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33326=$33325.f0;
      HEAP32[(($2622)>>2)]=$33326;
      var $33327=$33325.f1;
      HEAP32[(($2623)>>2)]=$33327;
      var $33328=HEAP32[(($2623)>>2)];
      var $33329=(($33328)|0) < 0;
      if ($33329) { __label__ = 7172; break; } else { __label__ = 7173; break; }
    case 7172: // $33330
      var $33331=HEAP32[(($2622)>>2)];
      ___cxa_call_unexpected($33331);
      throw "Reached an unreachable!"
    case 7173: // $33332
      var $33333=HEAP32[(($2622)>>2)];
      var $33334=HEAP32[(($2622)>>2)];
      var $33335=HEAP32[(($2623)>>2)];
      var $33336=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33334, tempValue);
      var $33337=($33336.f1 = $33335, $33336);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7174: // $33338
      throw "Reached an unreachable!"
    case 7175: // $_ZnwjPKci_exit826
      var $33339=HEAP32[(($result_i825)>>2)];
      var $33340=$2619;
      var $33341=$2620;
      var $33342=$2621;
      var $33343=$result_i825;
      var $33344=$2622;
      var $33345=$2623;
      var $33346=$33339;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8557, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7176; break; } else { __label__ = 13746; break; }
    case 7176: // $33347
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8558, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7177; break; } else { __label__ = 13746; break; }
    case 7177: // $33348
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8559, 4, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7178; break; } else { __label__ = 13746; break; }
    case 7178: // $33349
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8560, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7179; break; } else { __label__ = 13746; break; }
    case 7179: // $33350
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8561, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7180; break; } else { __label__ = 13746; break; }
    case 7180: // $33351
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8562, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7181; break; } else { __label__ = 13746; break; }
    case 7181: // $33352
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8563, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7182; break; } else { __label__ = 13746; break; }
    case 7182: // $33353
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8556, $8557, $8558, $8559, $8560, $8561, $8562, $8563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7183; break; } else { __label__ = 13746; break; }
    case 7183: // $33354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8565, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7184; break; } else { __label__ = 13746; break; }
    case 7184: // $33355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8566, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7185; break; } else { __label__ = 13746; break; }
    case 7185: // $33356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8567, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7186; break; } else { __label__ = 13746; break; }
    case 7186: // $33357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8568, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7187; break; } else { __label__ = 13746; break; }
    case 7187: // $33358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8569, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7188; break; } else { __label__ = 13746; break; }
    case 7188: // $33359
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7189; break; } else { __label__ = 13746; break; }
    case 7189: // $33360
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7190; break; } else { __label__ = 13746; break; }
    case 7190: // $33361
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8564, $8565, $8566, $8567, $8568, $8569, $8570, $8571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7191; break; } else { __label__ = 13746; break; }
    case 7191: // $33362
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8573, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7192; break; } else { __label__ = 13746; break; }
    case 7192: // $33363
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8574, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7193; break; } else { __label__ = 13746; break; }
    case 7193: // $33364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8575, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7194; break; } else { __label__ = 13746; break; }
    case 7194: // $33365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8576, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7195; break; } else { __label__ = 13746; break; }
    case 7195: // $33366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8577, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7196; break; } else { __label__ = 13746; break; }
    case 7196: // $33367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7197; break; } else { __label__ = 13746; break; }
    case 7197: // $33368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7198; break; } else { __label__ = 13746; break; }
    case 7198: // $33369
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8572, $8573, $8574, $8575, $8576, $8577, $8578, $8579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7199; break; } else { __label__ = 13746; break; }
    case 7199: // $33370
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33346, 141, 4, 3, ((STRING_TABLE.__str1016)|0), ((STRING_TABLE.__str1017)|0), $8556, $8564, $8572) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7200; break; } else { __label__ = 13746; break; }
    case 7200: // $33371
      var $33372=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33346);
      var $33373=__ZN11simple_listI16input_type_entryE6appendERS0_($33307, $33372);
      var $33374=$4689;
      var $33375=$2614;
      var $33376=$2615;
      var $33377=$2616;
      var $33378=$result_i827;
      var $33379=$2617;
      var $33380=$2618;
      HEAP32[(($2614)>>2)]=408;
      HEAP32[(($2615)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2616)>>2)]=485;
      var $33381=HEAP32[(($2614)>>2)];
      var $33382=HEAP32[(($2615)>>2)];
      var $33383=HEAP32[(($2616)>>2)];
      var $33384=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33381, $33382, $33383) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7201; break; } else { __label__ = 7203; break; };
    case 7201: // $33385
      HEAP32[(($result_i827)>>2)]=$33384;
      var $33386=HEAP32[(($result_i827)>>2)];
      var $33387=(($33386)|0)==0;
      if ($33387) { __label__ = 7202; break; } else { __label__ = 7207; break; }
    case 7202: // $33388
      var $33389=___cxa_allocate_exception(4);
      var $33390=$33389;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33390);
      (function() { try { __THREW__ = false; return ___cxa_throw($33389, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7206; break; } else { __label__ = 7203; break; }
    case 7203: // $33391
      var $33392=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33393=$33392.f0;
      HEAP32[(($2617)>>2)]=$33393;
      var $33394=$33392.f1;
      HEAP32[(($2618)>>2)]=$33394;
      var $33395=HEAP32[(($2618)>>2)];
      var $33396=(($33395)|0) < 0;
      if ($33396) { __label__ = 7204; break; } else { __label__ = 7205; break; }
    case 7204: // $33397
      var $33398=HEAP32[(($2617)>>2)];
      ___cxa_call_unexpected($33398);
      throw "Reached an unreachable!"
    case 7205: // $33399
      var $33400=HEAP32[(($2617)>>2)];
      var $33401=HEAP32[(($2617)>>2)];
      var $33402=HEAP32[(($2618)>>2)];
      var $33403=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33401, tempValue);
      var $33404=($33403.f1 = $33402, $33403);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7206: // $33405
      throw "Reached an unreachable!"
    case 7207: // $_ZnwjPKci_exit828
      var $33406=HEAP32[(($result_i827)>>2)];
      var $33407=$2614;
      var $33408=$2615;
      var $33409=$2616;
      var $33410=$result_i827;
      var $33411=$2617;
      var $33412=$2618;
      var $33413=$33406;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8581, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7208; break; } else { __label__ = 13751; break; }
    case 7208: // $33414
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8582, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7209; break; } else { __label__ = 13751; break; }
    case 7209: // $33415
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8583, 4, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7210; break; } else { __label__ = 13751; break; }
    case 7210: // $33416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7211; break; } else { __label__ = 13751; break; }
    case 7211: // $33417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7212; break; } else { __label__ = 13751; break; }
    case 7212: // $33418
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7213; break; } else { __label__ = 13751; break; }
    case 7213: // $33419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7214; break; } else { __label__ = 13751; break; }
    case 7214: // $33420
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8580, $8581, $8582, $8583, $8584, $8585, $8586, $8587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7215; break; } else { __label__ = 13751; break; }
    case 7215: // $33421
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8589, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7216; break; } else { __label__ = 13751; break; }
    case 7216: // $33422
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8590, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7217; break; } else { __label__ = 13751; break; }
    case 7217: // $33423
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8591, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7218; break; } else { __label__ = 13751; break; }
    case 7218: // $33424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7219; break; } else { __label__ = 13751; break; }
    case 7219: // $33425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7220; break; } else { __label__ = 13751; break; }
    case 7220: // $33426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7221; break; } else { __label__ = 13751; break; }
    case 7221: // $33427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7222; break; } else { __label__ = 13751; break; }
    case 7222: // $33428
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8588, $8589, $8590, $8591, $8592, $8593, $8594, $8595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7223; break; } else { __label__ = 13751; break; }
    case 7223: // $33429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8597, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7224; break; } else { __label__ = 13751; break; }
    case 7224: // $33430
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8598, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7225; break; } else { __label__ = 13751; break; }
    case 7225: // $33431
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8599, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7226; break; } else { __label__ = 13751; break; }
    case 7226: // $33432
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8600, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7227; break; } else { __label__ = 13751; break; }
    case 7227: // $33433
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8601, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7228; break; } else { __label__ = 13751; break; }
    case 7228: // $33434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7229; break; } else { __label__ = 13751; break; }
    case 7229: // $33435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7230; break; } else { __label__ = 13751; break; }
    case 7230: // $33436
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8596, $8597, $8598, $8599, $8600, $8601, $8602, $8603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7231; break; } else { __label__ = 13751; break; }
    case 7231: // $33437
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33413, 141, 5, 4, ((STRING_TABLE.__str1018)|0), ((STRING_TABLE.__str1019)|0), $8580, $8588, $8596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7232; break; } else { __label__ = 13751; break; }
    case 7232: // $33438
      var $33439=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33413);
      var $33440=__ZN11simple_listI16input_type_entryE6appendERS0_($33374, $33439);
      var $33441=$4689;
      var $33442=$2609;
      var $33443=$2610;
      var $33444=$2611;
      var $33445=$result_i829;
      var $33446=$2612;
      var $33447=$2613;
      HEAP32[(($2609)>>2)]=408;
      HEAP32[(($2610)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2611)>>2)]=486;
      var $33448=HEAP32[(($2609)>>2)];
      var $33449=HEAP32[(($2610)>>2)];
      var $33450=HEAP32[(($2611)>>2)];
      var $33451=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33448, $33449, $33450) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7233; break; } else { __label__ = 7235; break; };
    case 7233: // $33452
      HEAP32[(($result_i829)>>2)]=$33451;
      var $33453=HEAP32[(($result_i829)>>2)];
      var $33454=(($33453)|0)==0;
      if ($33454) { __label__ = 7234; break; } else { __label__ = 7239; break; }
    case 7234: // $33455
      var $33456=___cxa_allocate_exception(4);
      var $33457=$33456;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33457);
      (function() { try { __THREW__ = false; return ___cxa_throw($33456, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7238; break; } else { __label__ = 7235; break; }
    case 7235: // $33458
      var $33459=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33460=$33459.f0;
      HEAP32[(($2612)>>2)]=$33460;
      var $33461=$33459.f1;
      HEAP32[(($2613)>>2)]=$33461;
      var $33462=HEAP32[(($2613)>>2)];
      var $33463=(($33462)|0) < 0;
      if ($33463) { __label__ = 7236; break; } else { __label__ = 7237; break; }
    case 7236: // $33464
      var $33465=HEAP32[(($2612)>>2)];
      ___cxa_call_unexpected($33465);
      throw "Reached an unreachable!"
    case 7237: // $33466
      var $33467=HEAP32[(($2612)>>2)];
      var $33468=HEAP32[(($2612)>>2)];
      var $33469=HEAP32[(($2613)>>2)];
      var $33470=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33468, tempValue);
      var $33471=($33470.f1 = $33469, $33470);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7238: // $33472
      throw "Reached an unreachable!"
    case 7239: // $_ZnwjPKci_exit830
      var $33473=HEAP32[(($result_i829)>>2)];
      var $33474=$2609;
      var $33475=$2610;
      var $33476=$2611;
      var $33477=$result_i829;
      var $33478=$2612;
      var $33479=$2613;
      var $33480=$33473;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8605, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7240; break; } else { __label__ = 13756; break; }
    case 7240: // $33481
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8606, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7241; break; } else { __label__ = 13756; break; }
    case 7241: // $33482
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8607, 4, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7242; break; } else { __label__ = 13756; break; }
    case 7242: // $33483
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7243; break; } else { __label__ = 13756; break; }
    case 7243: // $33484
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7244; break; } else { __label__ = 13756; break; }
    case 7244: // $33485
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7245; break; } else { __label__ = 13756; break; }
    case 7245: // $33486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7246; break; } else { __label__ = 13756; break; }
    case 7246: // $33487
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8604, $8605, $8606, $8607, $8608, $8609, $8610, $8611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7247; break; } else { __label__ = 13756; break; }
    case 7247: // $33488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8613, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7248; break; } else { __label__ = 13756; break; }
    case 7248: // $33489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8614, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7249; break; } else { __label__ = 13756; break; }
    case 7249: // $33490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8615, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7250; break; } else { __label__ = 13756; break; }
    case 7250: // $33491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7251; break; } else { __label__ = 13756; break; }
    case 7251: // $33492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7252; break; } else { __label__ = 13756; break; }
    case 7252: // $33493
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7253; break; } else { __label__ = 13756; break; }
    case 7253: // $33494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7254; break; } else { __label__ = 13756; break; }
    case 7254: // $33495
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8612, $8613, $8614, $8615, $8616, $8617, $8618, $8619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7255; break; } else { __label__ = 13756; break; }
    case 7255: // $33496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8621, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7256; break; } else { __label__ = 13756; break; }
    case 7256: // $33497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8622, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7257; break; } else { __label__ = 13756; break; }
    case 7257: // $33498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8623, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7258; break; } else { __label__ = 13756; break; }
    case 7258: // $33499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8624, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7259; break; } else { __label__ = 13756; break; }
    case 7259: // $33500
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8625, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7260; break; } else { __label__ = 13756; break; }
    case 7260: // $33501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7261; break; } else { __label__ = 13756; break; }
    case 7261: // $33502
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7262; break; } else { __label__ = 13756; break; }
    case 7262: // $33503
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8620, $8621, $8622, $8623, $8624, $8625, $8626, $8627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7263; break; } else { __label__ = 13756; break; }
    case 7263: // $33504
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33480, 141, 6, 5, ((STRING_TABLE.__str1020)|0), ((STRING_TABLE.__str1021421)|0), $8604, $8612, $8620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7264; break; } else { __label__ = 13756; break; }
    case 7264: // $33505
      var $33506=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33480);
      var $33507=__ZN11simple_listI16input_type_entryE6appendERS0_($33441, $33506);
      var $33508=$4689;
      var $33509=$2604;
      var $33510=$2605;
      var $33511=$2606;
      var $33512=$result_i831;
      var $33513=$2607;
      var $33514=$2608;
      HEAP32[(($2604)>>2)]=408;
      HEAP32[(($2605)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2606)>>2)]=487;
      var $33515=HEAP32[(($2604)>>2)];
      var $33516=HEAP32[(($2605)>>2)];
      var $33517=HEAP32[(($2606)>>2)];
      var $33518=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33515, $33516, $33517) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7265; break; } else { __label__ = 7267; break; };
    case 7265: // $33519
      HEAP32[(($result_i831)>>2)]=$33518;
      var $33520=HEAP32[(($result_i831)>>2)];
      var $33521=(($33520)|0)==0;
      if ($33521) { __label__ = 7266; break; } else { __label__ = 7271; break; }
    case 7266: // $33522
      var $33523=___cxa_allocate_exception(4);
      var $33524=$33523;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33524);
      (function() { try { __THREW__ = false; return ___cxa_throw($33523, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7270; break; } else { __label__ = 7267; break; }
    case 7267: // $33525
      var $33526=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33527=$33526.f0;
      HEAP32[(($2607)>>2)]=$33527;
      var $33528=$33526.f1;
      HEAP32[(($2608)>>2)]=$33528;
      var $33529=HEAP32[(($2608)>>2)];
      var $33530=(($33529)|0) < 0;
      if ($33530) { __label__ = 7268; break; } else { __label__ = 7269; break; }
    case 7268: // $33531
      var $33532=HEAP32[(($2607)>>2)];
      ___cxa_call_unexpected($33532);
      throw "Reached an unreachable!"
    case 7269: // $33533
      var $33534=HEAP32[(($2607)>>2)];
      var $33535=HEAP32[(($2607)>>2)];
      var $33536=HEAP32[(($2608)>>2)];
      var $33537=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33535, tempValue);
      var $33538=($33537.f1 = $33536, $33537);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7270: // $33539
      throw "Reached an unreachable!"
    case 7271: // $_ZnwjPKci_exit832
      var $33540=HEAP32[(($result_i831)>>2)];
      var $33541=$2604;
      var $33542=$2605;
      var $33543=$2606;
      var $33544=$result_i831;
      var $33545=$2607;
      var $33546=$2608;
      var $33547=$33540;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8629, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7272; break; } else { __label__ = 13761; break; }
    case 7272: // $33548
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8630, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7273; break; } else { __label__ = 13761; break; }
    case 7273: // $33549
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8631, 4, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7274; break; } else { __label__ = 13761; break; }
    case 7274: // $33550
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7275; break; } else { __label__ = 13761; break; }
    case 7275: // $33551
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7276; break; } else { __label__ = 13761; break; }
    case 7276: // $33552
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7277; break; } else { __label__ = 13761; break; }
    case 7277: // $33553
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7278; break; } else { __label__ = 13761; break; }
    case 7278: // $33554
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8628, $8629, $8630, $8631, $8632, $8633, $8634, $8635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7279; break; } else { __label__ = 13761; break; }
    case 7279: // $33555
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8637, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7280; break; } else { __label__ = 13761; break; }
    case 7280: // $33556
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8638, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7281; break; } else { __label__ = 13761; break; }
    case 7281: // $33557
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8639, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7282; break; } else { __label__ = 13761; break; }
    case 7282: // $33558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7283; break; } else { __label__ = 13761; break; }
    case 7283: // $33559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7284; break; } else { __label__ = 13761; break; }
    case 7284: // $33560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7285; break; } else { __label__ = 13761; break; }
    case 7285: // $33561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7286; break; } else { __label__ = 13761; break; }
    case 7286: // $33562
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8636, $8637, $8638, $8639, $8640, $8641, $8642, $8643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7287; break; } else { __label__ = 13761; break; }
    case 7287: // $33563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8645, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7288; break; } else { __label__ = 13761; break; }
    case 7288: // $33564
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8646, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7289; break; } else { __label__ = 13761; break; }
    case 7289: // $33565
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8647, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7290; break; } else { __label__ = 13761; break; }
    case 7290: // $33566
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8648, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7291; break; } else { __label__ = 13761; break; }
    case 7291: // $33567
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8649, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7292; break; } else { __label__ = 13761; break; }
    case 7292: // $33568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7293; break; } else { __label__ = 13761; break; }
    case 7293: // $33569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7294; break; } else { __label__ = 13761; break; }
    case 7294: // $33570
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8644, $8645, $8646, $8647, $8648, $8649, $8650, $8651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7295; break; } else { __label__ = 13761; break; }
    case 7295: // $33571
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33547, 141, 7, 6, ((STRING_TABLE.__str1022)|0), ((STRING_TABLE.__str1023)|0), $8628, $8636, $8644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7296; break; } else { __label__ = 13761; break; }
    case 7296: // $33572
      var $33573=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33547);
      var $33574=__ZN11simple_listI16input_type_entryE6appendERS0_($33508, $33573);
      var $33575=$4689;
      var $33576=$2599;
      var $33577=$2600;
      var $33578=$2601;
      var $33579=$result_i833;
      var $33580=$2602;
      var $33581=$2603;
      HEAP32[(($2599)>>2)]=408;
      HEAP32[(($2600)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2601)>>2)]=488;
      var $33582=HEAP32[(($2599)>>2)];
      var $33583=HEAP32[(($2600)>>2)];
      var $33584=HEAP32[(($2601)>>2)];
      var $33585=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33582, $33583, $33584) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7297; break; } else { __label__ = 7299; break; };
    case 7297: // $33586
      HEAP32[(($result_i833)>>2)]=$33585;
      var $33587=HEAP32[(($result_i833)>>2)];
      var $33588=(($33587)|0)==0;
      if ($33588) { __label__ = 7298; break; } else { __label__ = 7303; break; }
    case 7298: // $33589
      var $33590=___cxa_allocate_exception(4);
      var $33591=$33590;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33591);
      (function() { try { __THREW__ = false; return ___cxa_throw($33590, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7302; break; } else { __label__ = 7299; break; }
    case 7299: // $33592
      var $33593=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33594=$33593.f0;
      HEAP32[(($2602)>>2)]=$33594;
      var $33595=$33593.f1;
      HEAP32[(($2603)>>2)]=$33595;
      var $33596=HEAP32[(($2603)>>2)];
      var $33597=(($33596)|0) < 0;
      if ($33597) { __label__ = 7300; break; } else { __label__ = 7301; break; }
    case 7300: // $33598
      var $33599=HEAP32[(($2602)>>2)];
      ___cxa_call_unexpected($33599);
      throw "Reached an unreachable!"
    case 7301: // $33600
      var $33601=HEAP32[(($2602)>>2)];
      var $33602=HEAP32[(($2602)>>2)];
      var $33603=HEAP32[(($2603)>>2)];
      var $33604=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33602, tempValue);
      var $33605=($33604.f1 = $33603, $33604);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7302: // $33606
      throw "Reached an unreachable!"
    case 7303: // $_ZnwjPKci_exit834
      var $33607=HEAP32[(($result_i833)>>2)];
      var $33608=$2599;
      var $33609=$2600;
      var $33610=$2601;
      var $33611=$result_i833;
      var $33612=$2602;
      var $33613=$2603;
      var $33614=$33607;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8653, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7304; break; } else { __label__ = 13766; break; }
    case 7304: // $33615
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8654, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7305; break; } else { __label__ = 13766; break; }
    case 7305: // $33616
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8655, 4, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7306; break; } else { __label__ = 13766; break; }
    case 7306: // $33617
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7307; break; } else { __label__ = 13766; break; }
    case 7307: // $33618
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7308; break; } else { __label__ = 13766; break; }
    case 7308: // $33619
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7309; break; } else { __label__ = 13766; break; }
    case 7309: // $33620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7310; break; } else { __label__ = 13766; break; }
    case 7310: // $33621
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8652, $8653, $8654, $8655, $8656, $8657, $8658, $8659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7311; break; } else { __label__ = 13766; break; }
    case 7311: // $33622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8661, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7312; break; } else { __label__ = 13766; break; }
    case 7312: // $33623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8662, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7313; break; } else { __label__ = 13766; break; }
    case 7313: // $33624
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8663, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7314; break; } else { __label__ = 13766; break; }
    case 7314: // $33625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7315; break; } else { __label__ = 13766; break; }
    case 7315: // $33626
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7316; break; } else { __label__ = 13766; break; }
    case 7316: // $33627
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7317; break; } else { __label__ = 13766; break; }
    case 7317: // $33628
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7318; break; } else { __label__ = 13766; break; }
    case 7318: // $33629
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8660, $8661, $8662, $8663, $8664, $8665, $8666, $8667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7319; break; } else { __label__ = 13766; break; }
    case 7319: // $33630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8669, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7320; break; } else { __label__ = 13766; break; }
    case 7320: // $33631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8670, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7321; break; } else { __label__ = 13766; break; }
    case 7321: // $33632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8671, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7322; break; } else { __label__ = 13766; break; }
    case 7322: // $33633
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8672, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7323; break; } else { __label__ = 13766; break; }
    case 7323: // $33634
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8673, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7324; break; } else { __label__ = 13766; break; }
    case 7324: // $33635
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7325; break; } else { __label__ = 13766; break; }
    case 7325: // $33636
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7326; break; } else { __label__ = 13766; break; }
    case 7326: // $33637
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8668, $8669, $8670, $8671, $8672, $8673, $8674, $8675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7327; break; } else { __label__ = 13766; break; }
    case 7327: // $33638
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33614, 141, 8, 7, ((STRING_TABLE.__str1024)|0), ((STRING_TABLE.__str1025)|0), $8652, $8660, $8668) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7328; break; } else { __label__ = 13766; break; }
    case 7328: // $33639
      var $33640=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33614);
      var $33641=__ZN11simple_listI16input_type_entryE6appendERS0_($33575, $33640);
      var $33642=$4689;
      var $33643=$2594;
      var $33644=$2595;
      var $33645=$2596;
      var $33646=$result_i835;
      var $33647=$2597;
      var $33648=$2598;
      HEAP32[(($2594)>>2)]=408;
      HEAP32[(($2595)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2596)>>2)]=490;
      var $33649=HEAP32[(($2594)>>2)];
      var $33650=HEAP32[(($2595)>>2)];
      var $33651=HEAP32[(($2596)>>2)];
      var $33652=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33649, $33650, $33651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7329; break; } else { __label__ = 7331; break; };
    case 7329: // $33653
      HEAP32[(($result_i835)>>2)]=$33652;
      var $33654=HEAP32[(($result_i835)>>2)];
      var $33655=(($33654)|0)==0;
      if ($33655) { __label__ = 7330; break; } else { __label__ = 7335; break; }
    case 7330: // $33656
      var $33657=___cxa_allocate_exception(4);
      var $33658=$33657;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33658);
      (function() { try { __THREW__ = false; return ___cxa_throw($33657, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7334; break; } else { __label__ = 7331; break; }
    case 7331: // $33659
      var $33660=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33661=$33660.f0;
      HEAP32[(($2597)>>2)]=$33661;
      var $33662=$33660.f1;
      HEAP32[(($2598)>>2)]=$33662;
      var $33663=HEAP32[(($2598)>>2)];
      var $33664=(($33663)|0) < 0;
      if ($33664) { __label__ = 7332; break; } else { __label__ = 7333; break; }
    case 7332: // $33665
      var $33666=HEAP32[(($2597)>>2)];
      ___cxa_call_unexpected($33666);
      throw "Reached an unreachable!"
    case 7333: // $33667
      var $33668=HEAP32[(($2597)>>2)];
      var $33669=HEAP32[(($2597)>>2)];
      var $33670=HEAP32[(($2598)>>2)];
      var $33671=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33669, tempValue);
      var $33672=($33671.f1 = $33670, $33671);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7334: // $33673
      throw "Reached an unreachable!"
    case 7335: // $_ZnwjPKci_exit836
      var $33674=HEAP32[(($result_i835)>>2)];
      var $33675=$2594;
      var $33676=$2595;
      var $33677=$2596;
      var $33678=$result_i835;
      var $33679=$2597;
      var $33680=$2598;
      var $33681=$33674;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8677, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7336; break; } else { __label__ = 13771; break; }
    case 7336: // $33682
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8678, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7337; break; } else { __label__ = 13771; break; }
    case 7337: // $33683
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8679, 4, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7338; break; } else { __label__ = 13771; break; }
    case 7338: // $33684
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7339; break; } else { __label__ = 13771; break; }
    case 7339: // $33685
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7340; break; } else { __label__ = 13771; break; }
    case 7340: // $33686
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7341; break; } else { __label__ = 13771; break; }
    case 7341: // $33687
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7342; break; } else { __label__ = 13771; break; }
    case 7342: // $33688
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8676, $8677, $8678, $8679, $8680, $8681, $8682, $8683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7343; break; } else { __label__ = 13771; break; }
    case 7343: // $33689
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8685, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7344; break; } else { __label__ = 13771; break; }
    case 7344: // $33690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8686, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7345; break; } else { __label__ = 13771; break; }
    case 7345: // $33691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8687, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7346; break; } else { __label__ = 13771; break; }
    case 7346: // $33692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8688, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7347; break; } else { __label__ = 13771; break; }
    case 7347: // $33693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8689, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7348; break; } else { __label__ = 13771; break; }
    case 7348: // $33694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8690, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7349; break; } else { __label__ = 13771; break; }
    case 7349: // $33695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8691, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7350; break; } else { __label__ = 13771; break; }
    case 7350: // $33696
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8684, $8685, $8686, $8687, $8688, $8689, $8690, $8691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7351; break; } else { __label__ = 13771; break; }
    case 7351: // $33697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8693, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7352; break; } else { __label__ = 13771; break; }
    case 7352: // $33698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8694, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7353; break; } else { __label__ = 13771; break; }
    case 7353: // $33699
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8695, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7354; break; } else { __label__ = 13771; break; }
    case 7354: // $33700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8696, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7355; break; } else { __label__ = 13771; break; }
    case 7355: // $33701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8697, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7356; break; } else { __label__ = 13771; break; }
    case 7356: // $33702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7357; break; } else { __label__ = 13771; break; }
    case 7357: // $33703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7358; break; } else { __label__ = 13771; break; }
    case 7358: // $33704
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8692, $8693, $8694, $8695, $8696, $8697, $8698, $8699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7359; break; } else { __label__ = 13771; break; }
    case 7359: // $33705
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33681, 150, 1, 0, ((STRING_TABLE.__str1026)|0), ((STRING_TABLE.__str1027)|0), $8676, $8684, $8692) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7360; break; } else { __label__ = 13771; break; }
    case 7360: // $33706
      var $33707=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33681);
      var $33708=__ZN11simple_listI16input_type_entryE6appendERS0_($33642, $33707);
      var $33709=$4689;
      var $33710=$2589;
      var $33711=$2590;
      var $33712=$2591;
      var $33713=$result_i837;
      var $33714=$2592;
      var $33715=$2593;
      HEAP32[(($2589)>>2)]=408;
      HEAP32[(($2590)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2591)>>2)]=491;
      var $33716=HEAP32[(($2589)>>2)];
      var $33717=HEAP32[(($2590)>>2)];
      var $33718=HEAP32[(($2591)>>2)];
      var $33719=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33716, $33717, $33718) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7361; break; } else { __label__ = 7363; break; };
    case 7361: // $33720
      HEAP32[(($result_i837)>>2)]=$33719;
      var $33721=HEAP32[(($result_i837)>>2)];
      var $33722=(($33721)|0)==0;
      if ($33722) { __label__ = 7362; break; } else { __label__ = 7367; break; }
    case 7362: // $33723
      var $33724=___cxa_allocate_exception(4);
      var $33725=$33724;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33725);
      (function() { try { __THREW__ = false; return ___cxa_throw($33724, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7366; break; } else { __label__ = 7363; break; }
    case 7363: // $33726
      var $33727=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33728=$33727.f0;
      HEAP32[(($2592)>>2)]=$33728;
      var $33729=$33727.f1;
      HEAP32[(($2593)>>2)]=$33729;
      var $33730=HEAP32[(($2593)>>2)];
      var $33731=(($33730)|0) < 0;
      if ($33731) { __label__ = 7364; break; } else { __label__ = 7365; break; }
    case 7364: // $33732
      var $33733=HEAP32[(($2592)>>2)];
      ___cxa_call_unexpected($33733);
      throw "Reached an unreachable!"
    case 7365: // $33734
      var $33735=HEAP32[(($2592)>>2)];
      var $33736=HEAP32[(($2592)>>2)];
      var $33737=HEAP32[(($2593)>>2)];
      var $33738=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33736, tempValue);
      var $33739=($33738.f1 = $33737, $33738);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7366: // $33740
      throw "Reached an unreachable!"
    case 7367: // $_ZnwjPKci_exit838
      var $33741=HEAP32[(($result_i837)>>2)];
      var $33742=$2589;
      var $33743=$2590;
      var $33744=$2591;
      var $33745=$result_i837;
      var $33746=$2592;
      var $33747=$2593;
      var $33748=$33741;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8701, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7368; break; } else { __label__ = 13776; break; }
    case 7368: // $33749
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8702, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7369; break; } else { __label__ = 13776; break; }
    case 7369: // $33750
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8703, 4, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7370; break; } else { __label__ = 13776; break; }
    case 7370: // $33751
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7371; break; } else { __label__ = 13776; break; }
    case 7371: // $33752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7372; break; } else { __label__ = 13776; break; }
    case 7372: // $33753
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7373; break; } else { __label__ = 13776; break; }
    case 7373: // $33754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7374; break; } else { __label__ = 13776; break; }
    case 7374: // $33755
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8700, $8701, $8702, $8703, $8704, $8705, $8706, $8707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7375; break; } else { __label__ = 13776; break; }
    case 7375: // $33756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8709, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7376; break; } else { __label__ = 13776; break; }
    case 7376: // $33757
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8710, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7377; break; } else { __label__ = 13776; break; }
    case 7377: // $33758
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8711, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7378; break; } else { __label__ = 13776; break; }
    case 7378: // $33759
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7379; break; } else { __label__ = 13776; break; }
    case 7379: // $33760
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7380; break; } else { __label__ = 13776; break; }
    case 7380: // $33761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7381; break; } else { __label__ = 13776; break; }
    case 7381: // $33762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7382; break; } else { __label__ = 13776; break; }
    case 7382: // $33763
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8708, $8709, $8710, $8711, $8712, $8713, $8714, $8715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7383; break; } else { __label__ = 13776; break; }
    case 7383: // $33764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8717, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7384; break; } else { __label__ = 13776; break; }
    case 7384: // $33765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8718, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7385; break; } else { __label__ = 13776; break; }
    case 7385: // $33766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8719, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7386; break; } else { __label__ = 13776; break; }
    case 7386: // $33767
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8720, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7387; break; } else { __label__ = 13776; break; }
    case 7387: // $33768
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8721, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7388; break; } else { __label__ = 13776; break; }
    case 7388: // $33769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7389; break; } else { __label__ = 13776; break; }
    case 7389: // $33770
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7390; break; } else { __label__ = 13776; break; }
    case 7390: // $33771
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8716, $8717, $8718, $8719, $8720, $8721, $8722, $8723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7391; break; } else { __label__ = 13776; break; }
    case 7391: // $33772
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33748, 150, 2, 1, ((STRING_TABLE.__str1028)|0), ((STRING_TABLE.__str1029)|0), $8700, $8708, $8716) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7392; break; } else { __label__ = 13776; break; }
    case 7392: // $33773
      var $33774=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33748);
      var $33775=__ZN11simple_listI16input_type_entryE6appendERS0_($33709, $33774);
      var $33776=$4689;
      var $33777=$2584;
      var $33778=$2585;
      var $33779=$2586;
      var $33780=$result_i839;
      var $33781=$2587;
      var $33782=$2588;
      HEAP32[(($2584)>>2)]=408;
      HEAP32[(($2585)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2586)>>2)]=492;
      var $33783=HEAP32[(($2584)>>2)];
      var $33784=HEAP32[(($2585)>>2)];
      var $33785=HEAP32[(($2586)>>2)];
      var $33786=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33783, $33784, $33785) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7393; break; } else { __label__ = 7395; break; };
    case 7393: // $33787
      HEAP32[(($result_i839)>>2)]=$33786;
      var $33788=HEAP32[(($result_i839)>>2)];
      var $33789=(($33788)|0)==0;
      if ($33789) { __label__ = 7394; break; } else { __label__ = 7399; break; }
    case 7394: // $33790
      var $33791=___cxa_allocate_exception(4);
      var $33792=$33791;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33792);
      (function() { try { __THREW__ = false; return ___cxa_throw($33791, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7398; break; } else { __label__ = 7395; break; }
    case 7395: // $33793
      var $33794=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33795=$33794.f0;
      HEAP32[(($2587)>>2)]=$33795;
      var $33796=$33794.f1;
      HEAP32[(($2588)>>2)]=$33796;
      var $33797=HEAP32[(($2588)>>2)];
      var $33798=(($33797)|0) < 0;
      if ($33798) { __label__ = 7396; break; } else { __label__ = 7397; break; }
    case 7396: // $33799
      var $33800=HEAP32[(($2587)>>2)];
      ___cxa_call_unexpected($33800);
      throw "Reached an unreachable!"
    case 7397: // $33801
      var $33802=HEAP32[(($2587)>>2)];
      var $33803=HEAP32[(($2587)>>2)];
      var $33804=HEAP32[(($2588)>>2)];
      var $33805=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33803, tempValue);
      var $33806=($33805.f1 = $33804, $33805);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7398: // $33807
      throw "Reached an unreachable!"
    case 7399: // $_ZnwjPKci_exit840
      var $33808=HEAP32[(($result_i839)>>2)];
      var $33809=$2584;
      var $33810=$2585;
      var $33811=$2586;
      var $33812=$result_i839;
      var $33813=$2587;
      var $33814=$2588;
      var $33815=$33808;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8725, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7400; break; } else { __label__ = 13781; break; }
    case 7400: // $33816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8726, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7401; break; } else { __label__ = 13781; break; }
    case 7401: // $33817
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8727, 4, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7402; break; } else { __label__ = 13781; break; }
    case 7402: // $33818
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7403; break; } else { __label__ = 13781; break; }
    case 7403: // $33819
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7404; break; } else { __label__ = 13781; break; }
    case 7404: // $33820
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7405; break; } else { __label__ = 13781; break; }
    case 7405: // $33821
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7406; break; } else { __label__ = 13781; break; }
    case 7406: // $33822
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8724, $8725, $8726, $8727, $8728, $8729, $8730, $8731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7407; break; } else { __label__ = 13781; break; }
    case 7407: // $33823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8733, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7408; break; } else { __label__ = 13781; break; }
    case 7408: // $33824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8734, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7409; break; } else { __label__ = 13781; break; }
    case 7409: // $33825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8735, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7410; break; } else { __label__ = 13781; break; }
    case 7410: // $33826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7411; break; } else { __label__ = 13781; break; }
    case 7411: // $33827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7412; break; } else { __label__ = 13781; break; }
    case 7412: // $33828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7413; break; } else { __label__ = 13781; break; }
    case 7413: // $33829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7414; break; } else { __label__ = 13781; break; }
    case 7414: // $33830
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8732, $8733, $8734, $8735, $8736, $8737, $8738, $8739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7415; break; } else { __label__ = 13781; break; }
    case 7415: // $33831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8741, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7416; break; } else { __label__ = 13781; break; }
    case 7416: // $33832
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8742, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7417; break; } else { __label__ = 13781; break; }
    case 7417: // $33833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8743, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7418; break; } else { __label__ = 13781; break; }
    case 7418: // $33834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8744, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7419; break; } else { __label__ = 13781; break; }
    case 7419: // $33835
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8745, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7420; break; } else { __label__ = 13781; break; }
    case 7420: // $33836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7421; break; } else { __label__ = 13781; break; }
    case 7421: // $33837
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7422; break; } else { __label__ = 13781; break; }
    case 7422: // $33838
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8740, $8741, $8742, $8743, $8744, $8745, $8746, $8747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7423; break; } else { __label__ = 13781; break; }
    case 7423: // $33839
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33815, 150, 3, 2, ((STRING_TABLE.__str1030)|0), ((STRING_TABLE.__str1031)|0), $8724, $8732, $8740) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7424; break; } else { __label__ = 13781; break; }
    case 7424: // $33840
      var $33841=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33815);
      var $33842=__ZN11simple_listI16input_type_entryE6appendERS0_($33776, $33841);
      var $33843=$4689;
      var $33844=$2579;
      var $33845=$2580;
      var $33846=$2581;
      var $33847=$result_i841;
      var $33848=$2582;
      var $33849=$2583;
      HEAP32[(($2579)>>2)]=408;
      HEAP32[(($2580)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2581)>>2)]=493;
      var $33850=HEAP32[(($2579)>>2)];
      var $33851=HEAP32[(($2580)>>2)];
      var $33852=HEAP32[(($2581)>>2)];
      var $33853=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33850, $33851, $33852) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7425; break; } else { __label__ = 7427; break; };
    case 7425: // $33854
      HEAP32[(($result_i841)>>2)]=$33853;
      var $33855=HEAP32[(($result_i841)>>2)];
      var $33856=(($33855)|0)==0;
      if ($33856) { __label__ = 7426; break; } else { __label__ = 7431; break; }
    case 7426: // $33857
      var $33858=___cxa_allocate_exception(4);
      var $33859=$33858;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33859);
      (function() { try { __THREW__ = false; return ___cxa_throw($33858, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7430; break; } else { __label__ = 7427; break; }
    case 7427: // $33860
      var $33861=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33862=$33861.f0;
      HEAP32[(($2582)>>2)]=$33862;
      var $33863=$33861.f1;
      HEAP32[(($2583)>>2)]=$33863;
      var $33864=HEAP32[(($2583)>>2)];
      var $33865=(($33864)|0) < 0;
      if ($33865) { __label__ = 7428; break; } else { __label__ = 7429; break; }
    case 7428: // $33866
      var $33867=HEAP32[(($2582)>>2)];
      ___cxa_call_unexpected($33867);
      throw "Reached an unreachable!"
    case 7429: // $33868
      var $33869=HEAP32[(($2582)>>2)];
      var $33870=HEAP32[(($2582)>>2)];
      var $33871=HEAP32[(($2583)>>2)];
      var $33872=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33870, tempValue);
      var $33873=($33872.f1 = $33871, $33872);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7430: // $33874
      throw "Reached an unreachable!"
    case 7431: // $_ZnwjPKci_exit842
      var $33875=HEAP32[(($result_i841)>>2)];
      var $33876=$2579;
      var $33877=$2580;
      var $33878=$2581;
      var $33879=$result_i841;
      var $33880=$2582;
      var $33881=$2583;
      var $33882=$33875;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8749, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7432; break; } else { __label__ = 13786; break; }
    case 7432: // $33883
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8750, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7433; break; } else { __label__ = 13786; break; }
    case 7433: // $33884
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8751, 4, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7434; break; } else { __label__ = 13786; break; }
    case 7434: // $33885
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7435; break; } else { __label__ = 13786; break; }
    case 7435: // $33886
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7436; break; } else { __label__ = 13786; break; }
    case 7436: // $33887
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7437; break; } else { __label__ = 13786; break; }
    case 7437: // $33888
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7438; break; } else { __label__ = 13786; break; }
    case 7438: // $33889
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8748, $8749, $8750, $8751, $8752, $8753, $8754, $8755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7439; break; } else { __label__ = 13786; break; }
    case 7439: // $33890
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8757, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7440; break; } else { __label__ = 13786; break; }
    case 7440: // $33891
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8758, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7441; break; } else { __label__ = 13786; break; }
    case 7441: // $33892
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8759, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7442; break; } else { __label__ = 13786; break; }
    case 7442: // $33893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7443; break; } else { __label__ = 13786; break; }
    case 7443: // $33894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7444; break; } else { __label__ = 13786; break; }
    case 7444: // $33895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7445; break; } else { __label__ = 13786; break; }
    case 7445: // $33896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7446; break; } else { __label__ = 13786; break; }
    case 7446: // $33897
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8756, $8757, $8758, $8759, $8760, $8761, $8762, $8763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7447; break; } else { __label__ = 13786; break; }
    case 7447: // $33898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8765, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7448; break; } else { __label__ = 13786; break; }
    case 7448: // $33899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8766, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7449; break; } else { __label__ = 13786; break; }
    case 7449: // $33900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8767, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7450; break; } else { __label__ = 13786; break; }
    case 7450: // $33901
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8768, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7451; break; } else { __label__ = 13786; break; }
    case 7451: // $33902
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8769, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7452; break; } else { __label__ = 13786; break; }
    case 7452: // $33903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7453; break; } else { __label__ = 13786; break; }
    case 7453: // $33904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7454; break; } else { __label__ = 13786; break; }
    case 7454: // $33905
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8764, $8765, $8766, $8767, $8768, $8769, $8770, $8771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7455; break; } else { __label__ = 13786; break; }
    case 7455: // $33906
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33882, 150, 4, 3, ((STRING_TABLE.__str1032)|0), ((STRING_TABLE.__str1033)|0), $8748, $8756, $8764) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7456; break; } else { __label__ = 13786; break; }
    case 7456: // $33907
      var $33908=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33882);
      var $33909=__ZN11simple_listI16input_type_entryE6appendERS0_($33843, $33908);
      var $33910=$4689;
      var $33911=$2574;
      var $33912=$2575;
      var $33913=$2576;
      var $33914=$result_i843;
      var $33915=$2577;
      var $33916=$2578;
      HEAP32[(($2574)>>2)]=408;
      HEAP32[(($2575)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2576)>>2)]=494;
      var $33917=HEAP32[(($2574)>>2)];
      var $33918=HEAP32[(($2575)>>2)];
      var $33919=HEAP32[(($2576)>>2)];
      var $33920=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33917, $33918, $33919) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7457; break; } else { __label__ = 7459; break; };
    case 7457: // $33921
      HEAP32[(($result_i843)>>2)]=$33920;
      var $33922=HEAP32[(($result_i843)>>2)];
      var $33923=(($33922)|0)==0;
      if ($33923) { __label__ = 7458; break; } else { __label__ = 7463; break; }
    case 7458: // $33924
      var $33925=___cxa_allocate_exception(4);
      var $33926=$33925;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33926);
      (function() { try { __THREW__ = false; return ___cxa_throw($33925, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7462; break; } else { __label__ = 7459; break; }
    case 7459: // $33927
      var $33928=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33929=$33928.f0;
      HEAP32[(($2577)>>2)]=$33929;
      var $33930=$33928.f1;
      HEAP32[(($2578)>>2)]=$33930;
      var $33931=HEAP32[(($2578)>>2)];
      var $33932=(($33931)|0) < 0;
      if ($33932) { __label__ = 7460; break; } else { __label__ = 7461; break; }
    case 7460: // $33933
      var $33934=HEAP32[(($2577)>>2)];
      ___cxa_call_unexpected($33934);
      throw "Reached an unreachable!"
    case 7461: // $33935
      var $33936=HEAP32[(($2577)>>2)];
      var $33937=HEAP32[(($2577)>>2)];
      var $33938=HEAP32[(($2578)>>2)];
      var $33939=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33937, tempValue);
      var $33940=($33939.f1 = $33938, $33939);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7462: // $33941
      throw "Reached an unreachable!"
    case 7463: // $_ZnwjPKci_exit844
      var $33942=HEAP32[(($result_i843)>>2)];
      var $33943=$2574;
      var $33944=$2575;
      var $33945=$2576;
      var $33946=$result_i843;
      var $33947=$2577;
      var $33948=$2578;
      var $33949=$33942;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8773, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7464; break; } else { __label__ = 13791; break; }
    case 7464: // $33950
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8774, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7465; break; } else { __label__ = 13791; break; }
    case 7465: // $33951
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8775, 4, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7466; break; } else { __label__ = 13791; break; }
    case 7466: // $33952
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7467; break; } else { __label__ = 13791; break; }
    case 7467: // $33953
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7468; break; } else { __label__ = 13791; break; }
    case 7468: // $33954
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7469; break; } else { __label__ = 13791; break; }
    case 7469: // $33955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7470; break; } else { __label__ = 13791; break; }
    case 7470: // $33956
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8772, $8773, $8774, $8775, $8776, $8777, $8778, $8779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7471; break; } else { __label__ = 13791; break; }
    case 7471: // $33957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8781, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7472; break; } else { __label__ = 13791; break; }
    case 7472: // $33958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8782, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7473; break; } else { __label__ = 13791; break; }
    case 7473: // $33959
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8783, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7474; break; } else { __label__ = 13791; break; }
    case 7474: // $33960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7475; break; } else { __label__ = 13791; break; }
    case 7475: // $33961
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7476; break; } else { __label__ = 13791; break; }
    case 7476: // $33962
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7477; break; } else { __label__ = 13791; break; }
    case 7477: // $33963
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7478; break; } else { __label__ = 13791; break; }
    case 7478: // $33964
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8780, $8781, $8782, $8783, $8784, $8785, $8786, $8787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7479; break; } else { __label__ = 13791; break; }
    case 7479: // $33965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8789, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7480; break; } else { __label__ = 13791; break; }
    case 7480: // $33966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8790, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7481; break; } else { __label__ = 13791; break; }
    case 7481: // $33967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8791, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7482; break; } else { __label__ = 13791; break; }
    case 7482: // $33968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8792, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7483; break; } else { __label__ = 13791; break; }
    case 7483: // $33969
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8793, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7484; break; } else { __label__ = 13791; break; }
    case 7484: // $33970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8794, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7485; break; } else { __label__ = 13791; break; }
    case 7485: // $33971
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8795, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7486; break; } else { __label__ = 13791; break; }
    case 7486: // $33972
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8788, $8789, $8790, $8791, $8792, $8793, $8794, $8795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7487; break; } else { __label__ = 13791; break; }
    case 7487: // $33973
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($33949, 150, 5, 4, ((STRING_TABLE.__str1034)|0), ((STRING_TABLE.__str1035)|0), $8772, $8780, $8788) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7488; break; } else { __label__ = 13791; break; }
    case 7488: // $33974
      var $33975=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $33949);
      var $33976=__ZN11simple_listI16input_type_entryE6appendERS0_($33910, $33975);
      var $33977=$4689;
      var $33978=$2569;
      var $33979=$2570;
      var $33980=$2571;
      var $33981=$result_i845;
      var $33982=$2572;
      var $33983=$2573;
      HEAP32[(($2569)>>2)]=408;
      HEAP32[(($2570)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2571)>>2)]=495;
      var $33984=HEAP32[(($2569)>>2)];
      var $33985=HEAP32[(($2570)>>2)];
      var $33986=HEAP32[(($2571)>>2)];
      var $33987=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33984, $33985, $33986) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7489; break; } else { __label__ = 7491; break; };
    case 7489: // $33988
      HEAP32[(($result_i845)>>2)]=$33987;
      var $33989=HEAP32[(($result_i845)>>2)];
      var $33990=(($33989)|0)==0;
      if ($33990) { __label__ = 7490; break; } else { __label__ = 7495; break; }
    case 7490: // $33991
      var $33992=___cxa_allocate_exception(4);
      var $33993=$33992;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33993);
      (function() { try { __THREW__ = false; return ___cxa_throw($33992, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7494; break; } else { __label__ = 7491; break; }
    case 7491: // $33994
      var $33995=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33996=$33995.f0;
      HEAP32[(($2572)>>2)]=$33996;
      var $33997=$33995.f1;
      HEAP32[(($2573)>>2)]=$33997;
      var $33998=HEAP32[(($2573)>>2)];
      var $33999=(($33998)|0) < 0;
      if ($33999) { __label__ = 7492; break; } else { __label__ = 7493; break; }
    case 7492: // $34000
      var $34001=HEAP32[(($2572)>>2)];
      ___cxa_call_unexpected($34001);
      throw "Reached an unreachable!"
    case 7493: // $34002
      var $34003=HEAP32[(($2572)>>2)];
      var $34004=HEAP32[(($2572)>>2)];
      var $34005=HEAP32[(($2573)>>2)];
      var $34006=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34004, tempValue);
      var $34007=($34006.f1 = $34005, $34006);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7494: // $34008
      throw "Reached an unreachable!"
    case 7495: // $_ZnwjPKci_exit846
      var $34009=HEAP32[(($result_i845)>>2)];
      var $34010=$2569;
      var $34011=$2570;
      var $34012=$2571;
      var $34013=$result_i845;
      var $34014=$2572;
      var $34015=$2573;
      var $34016=$34009;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8797, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7496; break; } else { __label__ = 13796; break; }
    case 7496: // $34017
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8798, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7497; break; } else { __label__ = 13796; break; }
    case 7497: // $34018
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8799, 4, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7498; break; } else { __label__ = 13796; break; }
    case 7498: // $34019
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8800, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7499; break; } else { __label__ = 13796; break; }
    case 7499: // $34020
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8801, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7500; break; } else { __label__ = 13796; break; }
    case 7500: // $34021
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8802, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7501; break; } else { __label__ = 13796; break; }
    case 7501: // $34022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8803, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7502; break; } else { __label__ = 13796; break; }
    case 7502: // $34023
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8796, $8797, $8798, $8799, $8800, $8801, $8802, $8803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7503; break; } else { __label__ = 13796; break; }
    case 7503: // $34024
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8805, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7504; break; } else { __label__ = 13796; break; }
    case 7504: // $34025
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8806, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7505; break; } else { __label__ = 13796; break; }
    case 7505: // $34026
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8807, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7506; break; } else { __label__ = 13796; break; }
    case 7506: // $34027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8808, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7507; break; } else { __label__ = 13796; break; }
    case 7507: // $34028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8809, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7508; break; } else { __label__ = 13796; break; }
    case 7508: // $34029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7509; break; } else { __label__ = 13796; break; }
    case 7509: // $34030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7510; break; } else { __label__ = 13796; break; }
    case 7510: // $34031
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8804, $8805, $8806, $8807, $8808, $8809, $8810, $8811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7511; break; } else { __label__ = 13796; break; }
    case 7511: // $34032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8813, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7512; break; } else { __label__ = 13796; break; }
    case 7512: // $34033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8814, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7513; break; } else { __label__ = 13796; break; }
    case 7513: // $34034
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8815, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7514; break; } else { __label__ = 13796; break; }
    case 7514: // $34035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7515; break; } else { __label__ = 13796; break; }
    case 7515: // $34036
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7516; break; } else { __label__ = 13796; break; }
    case 7516: // $34037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7517; break; } else { __label__ = 13796; break; }
    case 7517: // $34038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7518; break; } else { __label__ = 13796; break; }
    case 7518: // $34039
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8812, $8813, $8814, $8815, $8816, $8817, $8818, $8819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7519; break; } else { __label__ = 13796; break; }
    case 7519: // $34040
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34016, 150, 6, 5, ((STRING_TABLE.__str1036)|0), ((STRING_TABLE.__str1037)|0), $8796, $8804, $8812) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7520; break; } else { __label__ = 13796; break; }
    case 7520: // $34041
      var $34042=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34016);
      var $34043=__ZN11simple_listI16input_type_entryE6appendERS0_($33977, $34042);
      var $34044=$4689;
      var $34045=$2564;
      var $34046=$2565;
      var $34047=$2566;
      var $34048=$result_i847;
      var $34049=$2567;
      var $34050=$2568;
      HEAP32[(($2564)>>2)]=408;
      HEAP32[(($2565)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2566)>>2)]=496;
      var $34051=HEAP32[(($2564)>>2)];
      var $34052=HEAP32[(($2565)>>2)];
      var $34053=HEAP32[(($2566)>>2)];
      var $34054=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34051, $34052, $34053) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7521; break; } else { __label__ = 7523; break; };
    case 7521: // $34055
      HEAP32[(($result_i847)>>2)]=$34054;
      var $34056=HEAP32[(($result_i847)>>2)];
      var $34057=(($34056)|0)==0;
      if ($34057) { __label__ = 7522; break; } else { __label__ = 7527; break; }
    case 7522: // $34058
      var $34059=___cxa_allocate_exception(4);
      var $34060=$34059;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34060);
      (function() { try { __THREW__ = false; return ___cxa_throw($34059, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7526; break; } else { __label__ = 7523; break; }
    case 7523: // $34061
      var $34062=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34063=$34062.f0;
      HEAP32[(($2567)>>2)]=$34063;
      var $34064=$34062.f1;
      HEAP32[(($2568)>>2)]=$34064;
      var $34065=HEAP32[(($2568)>>2)];
      var $34066=(($34065)|0) < 0;
      if ($34066) { __label__ = 7524; break; } else { __label__ = 7525; break; }
    case 7524: // $34067
      var $34068=HEAP32[(($2567)>>2)];
      ___cxa_call_unexpected($34068);
      throw "Reached an unreachable!"
    case 7525: // $34069
      var $34070=HEAP32[(($2567)>>2)];
      var $34071=HEAP32[(($2567)>>2)];
      var $34072=HEAP32[(($2568)>>2)];
      var $34073=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34071, tempValue);
      var $34074=($34073.f1 = $34072, $34073);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7526: // $34075
      throw "Reached an unreachable!"
    case 7527: // $_ZnwjPKci_exit848
      var $34076=HEAP32[(($result_i847)>>2)];
      var $34077=$2564;
      var $34078=$2565;
      var $34079=$2566;
      var $34080=$result_i847;
      var $34081=$2567;
      var $34082=$2568;
      var $34083=$34076;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8821, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7528; break; } else { __label__ = 13801; break; }
    case 7528: // $34084
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8822, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7529; break; } else { __label__ = 13801; break; }
    case 7529: // $34085
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8823, 4, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7530; break; } else { __label__ = 13801; break; }
    case 7530: // $34086
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7531; break; } else { __label__ = 13801; break; }
    case 7531: // $34087
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7532; break; } else { __label__ = 13801; break; }
    case 7532: // $34088
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7533; break; } else { __label__ = 13801; break; }
    case 7533: // $34089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7534; break; } else { __label__ = 13801; break; }
    case 7534: // $34090
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8820, $8821, $8822, $8823, $8824, $8825, $8826, $8827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7535; break; } else { __label__ = 13801; break; }
    case 7535: // $34091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8829, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7536; break; } else { __label__ = 13801; break; }
    case 7536: // $34092
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8830, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7537; break; } else { __label__ = 13801; break; }
    case 7537: // $34093
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8831, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7538; break; } else { __label__ = 13801; break; }
    case 7538: // $34094
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7539; break; } else { __label__ = 13801; break; }
    case 7539: // $34095
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7540; break; } else { __label__ = 13801; break; }
    case 7540: // $34096
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7541; break; } else { __label__ = 13801; break; }
    case 7541: // $34097
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7542; break; } else { __label__ = 13801; break; }
    case 7542: // $34098
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8828, $8829, $8830, $8831, $8832, $8833, $8834, $8835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7543; break; } else { __label__ = 13801; break; }
    case 7543: // $34099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8837, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7544; break; } else { __label__ = 13801; break; }
    case 7544: // $34100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8838, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7545; break; } else { __label__ = 13801; break; }
    case 7545: // $34101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8839, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7546; break; } else { __label__ = 13801; break; }
    case 7546: // $34102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7547; break; } else { __label__ = 13801; break; }
    case 7547: // $34103
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7548; break; } else { __label__ = 13801; break; }
    case 7548: // $34104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7549; break; } else { __label__ = 13801; break; }
    case 7549: // $34105
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7550; break; } else { __label__ = 13801; break; }
    case 7550: // $34106
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8836, $8837, $8838, $8839, $8840, $8841, $8842, $8843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7551; break; } else { __label__ = 13801; break; }
    case 7551: // $34107
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34083, 150, 7, 6, ((STRING_TABLE.__str1038)|0), ((STRING_TABLE.__str1039)|0), $8820, $8828, $8836) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7552; break; } else { __label__ = 13801; break; }
    case 7552: // $34108
      var $34109=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34083);
      var $34110=__ZN11simple_listI16input_type_entryE6appendERS0_($34044, $34109);
      var $34111=$4689;
      var $34112=$2559;
      var $34113=$2560;
      var $34114=$2561;
      var $34115=$result_i849;
      var $34116=$2562;
      var $34117=$2563;
      HEAP32[(($2559)>>2)]=408;
      HEAP32[(($2560)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2561)>>2)]=497;
      var $34118=HEAP32[(($2559)>>2)];
      var $34119=HEAP32[(($2560)>>2)];
      var $34120=HEAP32[(($2561)>>2)];
      var $34121=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34118, $34119, $34120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7553; break; } else { __label__ = 7555; break; };
    case 7553: // $34122
      HEAP32[(($result_i849)>>2)]=$34121;
      var $34123=HEAP32[(($result_i849)>>2)];
      var $34124=(($34123)|0)==0;
      if ($34124) { __label__ = 7554; break; } else { __label__ = 7559; break; }
    case 7554: // $34125
      var $34126=___cxa_allocate_exception(4);
      var $34127=$34126;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34127);
      (function() { try { __THREW__ = false; return ___cxa_throw($34126, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7558; break; } else { __label__ = 7555; break; }
    case 7555: // $34128
      var $34129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34130=$34129.f0;
      HEAP32[(($2562)>>2)]=$34130;
      var $34131=$34129.f1;
      HEAP32[(($2563)>>2)]=$34131;
      var $34132=HEAP32[(($2563)>>2)];
      var $34133=(($34132)|0) < 0;
      if ($34133) { __label__ = 7556; break; } else { __label__ = 7557; break; }
    case 7556: // $34134
      var $34135=HEAP32[(($2562)>>2)];
      ___cxa_call_unexpected($34135);
      throw "Reached an unreachable!"
    case 7557: // $34136
      var $34137=HEAP32[(($2562)>>2)];
      var $34138=HEAP32[(($2562)>>2)];
      var $34139=HEAP32[(($2563)>>2)];
      var $34140=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34138, tempValue);
      var $34141=($34140.f1 = $34139, $34140);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7558: // $34142
      throw "Reached an unreachable!"
    case 7559: // $_ZnwjPKci_exit850
      var $34143=HEAP32[(($result_i849)>>2)];
      var $34144=$2559;
      var $34145=$2560;
      var $34146=$2561;
      var $34147=$result_i849;
      var $34148=$2562;
      var $34149=$2563;
      var $34150=$34143;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8845, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7560; break; } else { __label__ = 13806; break; }
    case 7560: // $34151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8846, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7561; break; } else { __label__ = 13806; break; }
    case 7561: // $34152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8847, 4, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7562; break; } else { __label__ = 13806; break; }
    case 7562: // $34153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7563; break; } else { __label__ = 13806; break; }
    case 7563: // $34154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7564; break; } else { __label__ = 13806; break; }
    case 7564: // $34155
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7565; break; } else { __label__ = 13806; break; }
    case 7565: // $34156
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7566; break; } else { __label__ = 13806; break; }
    case 7566: // $34157
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8844, $8845, $8846, $8847, $8848, $8849, $8850, $8851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7567; break; } else { __label__ = 13806; break; }
    case 7567: // $34158
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8853, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7568; break; } else { __label__ = 13806; break; }
    case 7568: // $34159
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8854, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7569; break; } else { __label__ = 13806; break; }
    case 7569: // $34160
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8855, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7570; break; } else { __label__ = 13806; break; }
    case 7570: // $34161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7571; break; } else { __label__ = 13806; break; }
    case 7571: // $34162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7572; break; } else { __label__ = 13806; break; }
    case 7572: // $34163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7573; break; } else { __label__ = 13806; break; }
    case 7573: // $34164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7574; break; } else { __label__ = 13806; break; }
    case 7574: // $34165
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8852, $8853, $8854, $8855, $8856, $8857, $8858, $8859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7575; break; } else { __label__ = 13806; break; }
    case 7575: // $34166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8861, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7576; break; } else { __label__ = 13806; break; }
    case 7576: // $34167
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8862, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7577; break; } else { __label__ = 13806; break; }
    case 7577: // $34168
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8863, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7578; break; } else { __label__ = 13806; break; }
    case 7578: // $34169
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7579; break; } else { __label__ = 13806; break; }
    case 7579: // $34170
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7580; break; } else { __label__ = 13806; break; }
    case 7580: // $34171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7581; break; } else { __label__ = 13806; break; }
    case 7581: // $34172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7582; break; } else { __label__ = 13806; break; }
    case 7582: // $34173
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8860, $8861, $8862, $8863, $8864, $8865, $8866, $8867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7583; break; } else { __label__ = 13806; break; }
    case 7583: // $34174
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34150, 150, 8, 7, ((STRING_TABLE.__str1040)|0), ((STRING_TABLE.__str1041)|0), $8844, $8852, $8860) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7584; break; } else { __label__ = 13806; break; }
    case 7584: // $34175
      var $34176=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34150);
      var $34177=__ZN11simple_listI16input_type_entryE6appendERS0_($34111, $34176);
      var $34178=$4689;
      var $34179=$2554;
      var $34180=$2555;
      var $34181=$2556;
      var $34182=$result_i851;
      var $34183=$2557;
      var $34184=$2558;
      HEAP32[(($2554)>>2)]=408;
      HEAP32[(($2555)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2556)>>2)]=499;
      var $34185=HEAP32[(($2554)>>2)];
      var $34186=HEAP32[(($2555)>>2)];
      var $34187=HEAP32[(($2556)>>2)];
      var $34188=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34185, $34186, $34187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7585; break; } else { __label__ = 7587; break; };
    case 7585: // $34189
      HEAP32[(($result_i851)>>2)]=$34188;
      var $34190=HEAP32[(($result_i851)>>2)];
      var $34191=(($34190)|0)==0;
      if ($34191) { __label__ = 7586; break; } else { __label__ = 7591; break; }
    case 7586: // $34192
      var $34193=___cxa_allocate_exception(4);
      var $34194=$34193;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34194);
      (function() { try { __THREW__ = false; return ___cxa_throw($34193, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7590; break; } else { __label__ = 7587; break; }
    case 7587: // $34195
      var $34196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34197=$34196.f0;
      HEAP32[(($2557)>>2)]=$34197;
      var $34198=$34196.f1;
      HEAP32[(($2558)>>2)]=$34198;
      var $34199=HEAP32[(($2558)>>2)];
      var $34200=(($34199)|0) < 0;
      if ($34200) { __label__ = 7588; break; } else { __label__ = 7589; break; }
    case 7588: // $34201
      var $34202=HEAP32[(($2557)>>2)];
      ___cxa_call_unexpected($34202);
      throw "Reached an unreachable!"
    case 7589: // $34203
      var $34204=HEAP32[(($2557)>>2)];
      var $34205=HEAP32[(($2557)>>2)];
      var $34206=HEAP32[(($2558)>>2)];
      var $34207=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34205, tempValue);
      var $34208=($34207.f1 = $34206, $34207);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7590: // $34209
      throw "Reached an unreachable!"
    case 7591: // $_ZnwjPKci_exit852
      var $34210=HEAP32[(($result_i851)>>2)];
      var $34211=$2554;
      var $34212=$2555;
      var $34213=$2556;
      var $34214=$result_i851;
      var $34215=$2557;
      var $34216=$2558;
      var $34217=$34210;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8869, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7592; break; } else { __label__ = 13811; break; }
    case 7592: // $34218
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8870, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7593; break; } else { __label__ = 13811; break; }
    case 7593: // $34219
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8871, 4, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7594; break; } else { __label__ = 13811; break; }
    case 7594: // $34220
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7595; break; } else { __label__ = 13811; break; }
    case 7595: // $34221
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7596; break; } else { __label__ = 13811; break; }
    case 7596: // $34222
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7597; break; } else { __label__ = 13811; break; }
    case 7597: // $34223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7598; break; } else { __label__ = 13811; break; }
    case 7598: // $34224
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8868, $8869, $8870, $8871, $8872, $8873, $8874, $8875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7599; break; } else { __label__ = 13811; break; }
    case 7599: // $34225
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8877, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7600; break; } else { __label__ = 13811; break; }
    case 7600: // $34226
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8878, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7601; break; } else { __label__ = 13811; break; }
    case 7601: // $34227
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8879, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7602; break; } else { __label__ = 13811; break; }
    case 7602: // $34228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7603; break; } else { __label__ = 13811; break; }
    case 7603: // $34229
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7604; break; } else { __label__ = 13811; break; }
    case 7604: // $34230
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7605; break; } else { __label__ = 13811; break; }
    case 7605: // $34231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7606; break; } else { __label__ = 13811; break; }
    case 7606: // $34232
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8876, $8877, $8878, $8879, $8880, $8881, $8882, $8883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7607; break; } else { __label__ = 13811; break; }
    case 7607: // $34233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8885, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7608; break; } else { __label__ = 13811; break; }
    case 7608: // $34234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8886, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7609; break; } else { __label__ = 13811; break; }
    case 7609: // $34235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8887, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7610; break; } else { __label__ = 13811; break; }
    case 7610: // $34236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7611; break; } else { __label__ = 13811; break; }
    case 7611: // $34237
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7612; break; } else { __label__ = 13811; break; }
    case 7612: // $34238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7613; break; } else { __label__ = 13811; break; }
    case 7613: // $34239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7614; break; } else { __label__ = 13811; break; }
    case 7614: // $34240
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8884, $8885, $8886, $8887, $8888, $8889, $8890, $8891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7615; break; } else { __label__ = 13811; break; }
    case 7615: // $34241
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34217, 151, 1, 0, ((STRING_TABLE.__str1042)|0), ((STRING_TABLE.__str1043)|0), $8868, $8876, $8884) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7616; break; } else { __label__ = 13811; break; }
    case 7616: // $34242
      var $34243=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34217);
      var $34244=__ZN11simple_listI16input_type_entryE6appendERS0_($34178, $34243);
      var $34245=$4689;
      var $34246=$2549;
      var $34247=$2550;
      var $34248=$2551;
      var $34249=$result_i853;
      var $34250=$2552;
      var $34251=$2553;
      HEAP32[(($2549)>>2)]=408;
      HEAP32[(($2550)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2551)>>2)]=500;
      var $34252=HEAP32[(($2549)>>2)];
      var $34253=HEAP32[(($2550)>>2)];
      var $34254=HEAP32[(($2551)>>2)];
      var $34255=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34252, $34253, $34254) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7617; break; } else { __label__ = 7619; break; };
    case 7617: // $34256
      HEAP32[(($result_i853)>>2)]=$34255;
      var $34257=HEAP32[(($result_i853)>>2)];
      var $34258=(($34257)|0)==0;
      if ($34258) { __label__ = 7618; break; } else { __label__ = 7623; break; }
    case 7618: // $34259
      var $34260=___cxa_allocate_exception(4);
      var $34261=$34260;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34261);
      (function() { try { __THREW__ = false; return ___cxa_throw($34260, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7622; break; } else { __label__ = 7619; break; }
    case 7619: // $34262
      var $34263=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34264=$34263.f0;
      HEAP32[(($2552)>>2)]=$34264;
      var $34265=$34263.f1;
      HEAP32[(($2553)>>2)]=$34265;
      var $34266=HEAP32[(($2553)>>2)];
      var $34267=(($34266)|0) < 0;
      if ($34267) { __label__ = 7620; break; } else { __label__ = 7621; break; }
    case 7620: // $34268
      var $34269=HEAP32[(($2552)>>2)];
      ___cxa_call_unexpected($34269);
      throw "Reached an unreachable!"
    case 7621: // $34270
      var $34271=HEAP32[(($2552)>>2)];
      var $34272=HEAP32[(($2552)>>2)];
      var $34273=HEAP32[(($2553)>>2)];
      var $34274=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34272, tempValue);
      var $34275=($34274.f1 = $34273, $34274);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7622: // $34276
      throw "Reached an unreachable!"
    case 7623: // $_ZnwjPKci_exit854
      var $34277=HEAP32[(($result_i853)>>2)];
      var $34278=$2549;
      var $34279=$2550;
      var $34280=$2551;
      var $34281=$result_i853;
      var $34282=$2552;
      var $34283=$2553;
      var $34284=$34277;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8893, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7624; break; } else { __label__ = 13816; break; }
    case 7624: // $34285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8894, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7625; break; } else { __label__ = 13816; break; }
    case 7625: // $34286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8895, 4, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7626; break; } else { __label__ = 13816; break; }
    case 7626: // $34287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7627; break; } else { __label__ = 13816; break; }
    case 7627: // $34288
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7628; break; } else { __label__ = 13816; break; }
    case 7628: // $34289
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7629; break; } else { __label__ = 13816; break; }
    case 7629: // $34290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7630; break; } else { __label__ = 13816; break; }
    case 7630: // $34291
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8892, $8893, $8894, $8895, $8896, $8897, $8898, $8899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7631; break; } else { __label__ = 13816; break; }
    case 7631: // $34292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8901, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7632; break; } else { __label__ = 13816; break; }
    case 7632: // $34293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8902, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7633; break; } else { __label__ = 13816; break; }
    case 7633: // $34294
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8903, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7634; break; } else { __label__ = 13816; break; }
    case 7634: // $34295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7635; break; } else { __label__ = 13816; break; }
    case 7635: // $34296
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7636; break; } else { __label__ = 13816; break; }
    case 7636: // $34297
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7637; break; } else { __label__ = 13816; break; }
    case 7637: // $34298
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7638; break; } else { __label__ = 13816; break; }
    case 7638: // $34299
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8900, $8901, $8902, $8903, $8904, $8905, $8906, $8907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7639; break; } else { __label__ = 13816; break; }
    case 7639: // $34300
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8909, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7640; break; } else { __label__ = 13816; break; }
    case 7640: // $34301
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8910, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7641; break; } else { __label__ = 13816; break; }
    case 7641: // $34302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8911, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7642; break; } else { __label__ = 13816; break; }
    case 7642: // $34303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7643; break; } else { __label__ = 13816; break; }
    case 7643: // $34304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7644; break; } else { __label__ = 13816; break; }
    case 7644: // $34305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7645; break; } else { __label__ = 13816; break; }
    case 7645: // $34306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7646; break; } else { __label__ = 13816; break; }
    case 7646: // $34307
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8908, $8909, $8910, $8911, $8912, $8913, $8914, $8915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7647; break; } else { __label__ = 13816; break; }
    case 7647: // $34308
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34284, 151, 2, 1, ((STRING_TABLE.__str1044)|0), ((STRING_TABLE.__str1045)|0), $8892, $8900, $8908) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7648; break; } else { __label__ = 13816; break; }
    case 7648: // $34309
      var $34310=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34284);
      var $34311=__ZN11simple_listI16input_type_entryE6appendERS0_($34245, $34310);
      var $34312=$4689;
      var $34313=$2544;
      var $34314=$2545;
      var $34315=$2546;
      var $34316=$result_i855;
      var $34317=$2547;
      var $34318=$2548;
      HEAP32[(($2544)>>2)]=408;
      HEAP32[(($2545)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2546)>>2)]=501;
      var $34319=HEAP32[(($2544)>>2)];
      var $34320=HEAP32[(($2545)>>2)];
      var $34321=HEAP32[(($2546)>>2)];
      var $34322=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34319, $34320, $34321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7649; break; } else { __label__ = 7651; break; };
    case 7649: // $34323
      HEAP32[(($result_i855)>>2)]=$34322;
      var $34324=HEAP32[(($result_i855)>>2)];
      var $34325=(($34324)|0)==0;
      if ($34325) { __label__ = 7650; break; } else { __label__ = 7655; break; }
    case 7650: // $34326
      var $34327=___cxa_allocate_exception(4);
      var $34328=$34327;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34328);
      (function() { try { __THREW__ = false; return ___cxa_throw($34327, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7654; break; } else { __label__ = 7651; break; }
    case 7651: // $34329
      var $34330=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34331=$34330.f0;
      HEAP32[(($2547)>>2)]=$34331;
      var $34332=$34330.f1;
      HEAP32[(($2548)>>2)]=$34332;
      var $34333=HEAP32[(($2548)>>2)];
      var $34334=(($34333)|0) < 0;
      if ($34334) { __label__ = 7652; break; } else { __label__ = 7653; break; }
    case 7652: // $34335
      var $34336=HEAP32[(($2547)>>2)];
      ___cxa_call_unexpected($34336);
      throw "Reached an unreachable!"
    case 7653: // $34337
      var $34338=HEAP32[(($2547)>>2)];
      var $34339=HEAP32[(($2547)>>2)];
      var $34340=HEAP32[(($2548)>>2)];
      var $34341=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34339, tempValue);
      var $34342=($34341.f1 = $34340, $34341);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7654: // $34343
      throw "Reached an unreachable!"
    case 7655: // $_ZnwjPKci_exit856
      var $34344=HEAP32[(($result_i855)>>2)];
      var $34345=$2544;
      var $34346=$2545;
      var $34347=$2546;
      var $34348=$result_i855;
      var $34349=$2547;
      var $34350=$2548;
      var $34351=$34344;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8917, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7656; break; } else { __label__ = 13821; break; }
    case 7656: // $34352
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8918, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7657; break; } else { __label__ = 13821; break; }
    case 7657: // $34353
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8919, 4, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7658; break; } else { __label__ = 13821; break; }
    case 7658: // $34354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7659; break; } else { __label__ = 13821; break; }
    case 7659: // $34355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7660; break; } else { __label__ = 13821; break; }
    case 7660: // $34356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7661; break; } else { __label__ = 13821; break; }
    case 7661: // $34357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7662; break; } else { __label__ = 13821; break; }
    case 7662: // $34358
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8916, $8917, $8918, $8919, $8920, $8921, $8922, $8923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7663; break; } else { __label__ = 13821; break; }
    case 7663: // $34359
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8925, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7664; break; } else { __label__ = 13821; break; }
    case 7664: // $34360
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8926, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7665; break; } else { __label__ = 13821; break; }
    case 7665: // $34361
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8927, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7666; break; } else { __label__ = 13821; break; }
    case 7666: // $34362
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7667; break; } else { __label__ = 13821; break; }
    case 7667: // $34363
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7668; break; } else { __label__ = 13821; break; }
    case 7668: // $34364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7669; break; } else { __label__ = 13821; break; }
    case 7669: // $34365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7670; break; } else { __label__ = 13821; break; }
    case 7670: // $34366
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8924, $8925, $8926, $8927, $8928, $8929, $8930, $8931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7671; break; } else { __label__ = 13821; break; }
    case 7671: // $34367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8933, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7672; break; } else { __label__ = 13821; break; }
    case 7672: // $34368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8934, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7673; break; } else { __label__ = 13821; break; }
    case 7673: // $34369
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8935, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7674; break; } else { __label__ = 13821; break; }
    case 7674: // $34370
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7675; break; } else { __label__ = 13821; break; }
    case 7675: // $34371
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7676; break; } else { __label__ = 13821; break; }
    case 7676: // $34372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7677; break; } else { __label__ = 13821; break; }
    case 7677: // $34373
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7678; break; } else { __label__ = 13821; break; }
    case 7678: // $34374
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8932, $8933, $8934, $8935, $8936, $8937, $8938, $8939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7679; break; } else { __label__ = 13821; break; }
    case 7679: // $34375
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34351, 151, 3, 2, ((STRING_TABLE.__str1046)|0), ((STRING_TABLE.__str1047)|0), $8916, $8924, $8932) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7680; break; } else { __label__ = 13821; break; }
    case 7680: // $34376
      var $34377=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34351);
      var $34378=__ZN11simple_listI16input_type_entryE6appendERS0_($34312, $34377);
      var $34379=$4689;
      var $34380=$2539;
      var $34381=$2540;
      var $34382=$2541;
      var $34383=$result_i857;
      var $34384=$2542;
      var $34385=$2543;
      HEAP32[(($2539)>>2)]=408;
      HEAP32[(($2540)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2541)>>2)]=502;
      var $34386=HEAP32[(($2539)>>2)];
      var $34387=HEAP32[(($2540)>>2)];
      var $34388=HEAP32[(($2541)>>2)];
      var $34389=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34386, $34387, $34388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7681; break; } else { __label__ = 7683; break; };
    case 7681: // $34390
      HEAP32[(($result_i857)>>2)]=$34389;
      var $34391=HEAP32[(($result_i857)>>2)];
      var $34392=(($34391)|0)==0;
      if ($34392) { __label__ = 7682; break; } else { __label__ = 7687; break; }
    case 7682: // $34393
      var $34394=___cxa_allocate_exception(4);
      var $34395=$34394;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34395);
      (function() { try { __THREW__ = false; return ___cxa_throw($34394, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7686; break; } else { __label__ = 7683; break; }
    case 7683: // $34396
      var $34397=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34398=$34397.f0;
      HEAP32[(($2542)>>2)]=$34398;
      var $34399=$34397.f1;
      HEAP32[(($2543)>>2)]=$34399;
      var $34400=HEAP32[(($2543)>>2)];
      var $34401=(($34400)|0) < 0;
      if ($34401) { __label__ = 7684; break; } else { __label__ = 7685; break; }
    case 7684: // $34402
      var $34403=HEAP32[(($2542)>>2)];
      ___cxa_call_unexpected($34403);
      throw "Reached an unreachable!"
    case 7685: // $34404
      var $34405=HEAP32[(($2542)>>2)];
      var $34406=HEAP32[(($2542)>>2)];
      var $34407=HEAP32[(($2543)>>2)];
      var $34408=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34406, tempValue);
      var $34409=($34408.f1 = $34407, $34408);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7686: // $34410
      throw "Reached an unreachable!"
    case 7687: // $_ZnwjPKci_exit858
      var $34411=HEAP32[(($result_i857)>>2)];
      var $34412=$2539;
      var $34413=$2540;
      var $34414=$2541;
      var $34415=$result_i857;
      var $34416=$2542;
      var $34417=$2543;
      var $34418=$34411;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8941, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7688; break; } else { __label__ = 13826; break; }
    case 7688: // $34419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8942, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7689; break; } else { __label__ = 13826; break; }
    case 7689: // $34420
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8943, 4, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7690; break; } else { __label__ = 13826; break; }
    case 7690: // $34421
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7691; break; } else { __label__ = 13826; break; }
    case 7691: // $34422
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7692; break; } else { __label__ = 13826; break; }
    case 7692: // $34423
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7693; break; } else { __label__ = 13826; break; }
    case 7693: // $34424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7694; break; } else { __label__ = 13826; break; }
    case 7694: // $34425
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8940, $8941, $8942, $8943, $8944, $8945, $8946, $8947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7695; break; } else { __label__ = 13826; break; }
    case 7695: // $34426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8949, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7696; break; } else { __label__ = 13826; break; }
    case 7696: // $34427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8950, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7697; break; } else { __label__ = 13826; break; }
    case 7697: // $34428
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8951, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7698; break; } else { __label__ = 13826; break; }
    case 7698: // $34429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7699; break; } else { __label__ = 13826; break; }
    case 7699: // $34430
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7700; break; } else { __label__ = 13826; break; }
    case 7700: // $34431
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7701; break; } else { __label__ = 13826; break; }
    case 7701: // $34432
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7702; break; } else { __label__ = 13826; break; }
    case 7702: // $34433
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8948, $8949, $8950, $8951, $8952, $8953, $8954, $8955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7703; break; } else { __label__ = 13826; break; }
    case 7703: // $34434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8957, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7704; break; } else { __label__ = 13826; break; }
    case 7704: // $34435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7705; break; } else { __label__ = 13826; break; }
    case 7705: // $34436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7706; break; } else { __label__ = 13826; break; }
    case 7706: // $34437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7707; break; } else { __label__ = 13826; break; }
    case 7707: // $34438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7708; break; } else { __label__ = 13826; break; }
    case 7708: // $34439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7709; break; } else { __label__ = 13826; break; }
    case 7709: // $34440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7710; break; } else { __label__ = 13826; break; }
    case 7710: // $34441
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8956, $8957, $8958, $8959, $8960, $8961, $8962, $8963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7711; break; } else { __label__ = 13826; break; }
    case 7711: // $34442
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34418, 151, 4, 3, ((STRING_TABLE.__str1048)|0), ((STRING_TABLE.__str1049)|0), $8940, $8948, $8956) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7712; break; } else { __label__ = 13826; break; }
    case 7712: // $34443
      var $34444=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34418);
      var $34445=__ZN11simple_listI16input_type_entryE6appendERS0_($34379, $34444);
      var $34446=$4689;
      var $34447=$2534;
      var $34448=$2535;
      var $34449=$2536;
      var $34450=$result_i859;
      var $34451=$2537;
      var $34452=$2538;
      HEAP32[(($2534)>>2)]=408;
      HEAP32[(($2535)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2536)>>2)]=503;
      var $34453=HEAP32[(($2534)>>2)];
      var $34454=HEAP32[(($2535)>>2)];
      var $34455=HEAP32[(($2536)>>2)];
      var $34456=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34453, $34454, $34455) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7713; break; } else { __label__ = 7715; break; };
    case 7713: // $34457
      HEAP32[(($result_i859)>>2)]=$34456;
      var $34458=HEAP32[(($result_i859)>>2)];
      var $34459=(($34458)|0)==0;
      if ($34459) { __label__ = 7714; break; } else { __label__ = 7719; break; }
    case 7714: // $34460
      var $34461=___cxa_allocate_exception(4);
      var $34462=$34461;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34462);
      (function() { try { __THREW__ = false; return ___cxa_throw($34461, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7718; break; } else { __label__ = 7715; break; }
    case 7715: // $34463
      var $34464=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34465=$34464.f0;
      HEAP32[(($2537)>>2)]=$34465;
      var $34466=$34464.f1;
      HEAP32[(($2538)>>2)]=$34466;
      var $34467=HEAP32[(($2538)>>2)];
      var $34468=(($34467)|0) < 0;
      if ($34468) { __label__ = 7716; break; } else { __label__ = 7717; break; }
    case 7716: // $34469
      var $34470=HEAP32[(($2537)>>2)];
      ___cxa_call_unexpected($34470);
      throw "Reached an unreachable!"
    case 7717: // $34471
      var $34472=HEAP32[(($2537)>>2)];
      var $34473=HEAP32[(($2537)>>2)];
      var $34474=HEAP32[(($2538)>>2)];
      var $34475=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34473, tempValue);
      var $34476=($34475.f1 = $34474, $34475);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7718: // $34477
      throw "Reached an unreachable!"
    case 7719: // $_ZnwjPKci_exit860
      var $34478=HEAP32[(($result_i859)>>2)];
      var $34479=$2534;
      var $34480=$2535;
      var $34481=$2536;
      var $34482=$result_i859;
      var $34483=$2537;
      var $34484=$2538;
      var $34485=$34478;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8965, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7720; break; } else { __label__ = 13831; break; }
    case 7720: // $34486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8966, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7721; break; } else { __label__ = 13831; break; }
    case 7721: // $34487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8967, 4, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7722; break; } else { __label__ = 13831; break; }
    case 7722: // $34488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7723; break; } else { __label__ = 13831; break; }
    case 7723: // $34489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7724; break; } else { __label__ = 13831; break; }
    case 7724: // $34490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7725; break; } else { __label__ = 13831; break; }
    case 7725: // $34491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7726; break; } else { __label__ = 13831; break; }
    case 7726: // $34492
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8964, $8965, $8966, $8967, $8968, $8969, $8970, $8971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7727; break; } else { __label__ = 13831; break; }
    case 7727: // $34493
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8973, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7728; break; } else { __label__ = 13831; break; }
    case 7728: // $34494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8974, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7729; break; } else { __label__ = 13831; break; }
    case 7729: // $34495
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8975, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7730; break; } else { __label__ = 13831; break; }
    case 7730: // $34496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7731; break; } else { __label__ = 13831; break; }
    case 7731: // $34497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7732; break; } else { __label__ = 13831; break; }
    case 7732: // $34498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7733; break; } else { __label__ = 13831; break; }
    case 7733: // $34499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7734; break; } else { __label__ = 13831; break; }
    case 7734: // $34500
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8972, $8973, $8974, $8975, $8976, $8977, $8978, $8979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7735; break; } else { __label__ = 13831; break; }
    case 7735: // $34501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8981, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7736; break; } else { __label__ = 13831; break; }
    case 7736: // $34502
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7737; break; } else { __label__ = 13831; break; }
    case 7737: // $34503
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7738; break; } else { __label__ = 13831; break; }
    case 7738: // $34504
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7739; break; } else { __label__ = 13831; break; }
    case 7739: // $34505
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7740; break; } else { __label__ = 13831; break; }
    case 7740: // $34506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7741; break; } else { __label__ = 13831; break; }
    case 7741: // $34507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7742; break; } else { __label__ = 13831; break; }
    case 7742: // $34508
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8980, $8981, $8982, $8983, $8984, $8985, $8986, $8987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7743; break; } else { __label__ = 13831; break; }
    case 7743: // $34509
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34485, 151, 5, 4, ((STRING_TABLE.__str1050)|0), ((STRING_TABLE.__str1051)|0), $8964, $8972, $8980) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7744; break; } else { __label__ = 13831; break; }
    case 7744: // $34510
      var $34511=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34485);
      var $34512=__ZN11simple_listI16input_type_entryE6appendERS0_($34446, $34511);
      var $34513=$4689;
      var $34514=$2529;
      var $34515=$2530;
      var $34516=$2531;
      var $34517=$result_i861;
      var $34518=$2532;
      var $34519=$2533;
      HEAP32[(($2529)>>2)]=408;
      HEAP32[(($2530)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2531)>>2)]=504;
      var $34520=HEAP32[(($2529)>>2)];
      var $34521=HEAP32[(($2530)>>2)];
      var $34522=HEAP32[(($2531)>>2)];
      var $34523=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34520, $34521, $34522) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7745; break; } else { __label__ = 7747; break; };
    case 7745: // $34524
      HEAP32[(($result_i861)>>2)]=$34523;
      var $34525=HEAP32[(($result_i861)>>2)];
      var $34526=(($34525)|0)==0;
      if ($34526) { __label__ = 7746; break; } else { __label__ = 7751; break; }
    case 7746: // $34527
      var $34528=___cxa_allocate_exception(4);
      var $34529=$34528;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34529);
      (function() { try { __THREW__ = false; return ___cxa_throw($34528, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7750; break; } else { __label__ = 7747; break; }
    case 7747: // $34530
      var $34531=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34532=$34531.f0;
      HEAP32[(($2532)>>2)]=$34532;
      var $34533=$34531.f1;
      HEAP32[(($2533)>>2)]=$34533;
      var $34534=HEAP32[(($2533)>>2)];
      var $34535=(($34534)|0) < 0;
      if ($34535) { __label__ = 7748; break; } else { __label__ = 7749; break; }
    case 7748: // $34536
      var $34537=HEAP32[(($2532)>>2)];
      ___cxa_call_unexpected($34537);
      throw "Reached an unreachable!"
    case 7749: // $34538
      var $34539=HEAP32[(($2532)>>2)];
      var $34540=HEAP32[(($2532)>>2)];
      var $34541=HEAP32[(($2533)>>2)];
      var $34542=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34540, tempValue);
      var $34543=($34542.f1 = $34541, $34542);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7750: // $34544
      throw "Reached an unreachable!"
    case 7751: // $_ZnwjPKci_exit862
      var $34545=HEAP32[(($result_i861)>>2)];
      var $34546=$2529;
      var $34547=$2530;
      var $34548=$2531;
      var $34549=$result_i861;
      var $34550=$2532;
      var $34551=$2533;
      var $34552=$34545;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8989, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7752; break; } else { __label__ = 13836; break; }
    case 7752: // $34553
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8990, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7753; break; } else { __label__ = 13836; break; }
    case 7753: // $34554
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8991, 4, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7754; break; } else { __label__ = 13836; break; }
    case 7754: // $34555
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7755; break; } else { __label__ = 13836; break; }
    case 7755: // $34556
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7756; break; } else { __label__ = 13836; break; }
    case 7756: // $34557
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7757; break; } else { __label__ = 13836; break; }
    case 7757: // $34558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7758; break; } else { __label__ = 13836; break; }
    case 7758: // $34559
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8988, $8989, $8990, $8991, $8992, $8993, $8994, $8995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7759; break; } else { __label__ = 13836; break; }
    case 7759: // $34560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8997, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7760; break; } else { __label__ = 13836; break; }
    case 7760: // $34561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8998, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7761; break; } else { __label__ = 13836; break; }
    case 7761: // $34562
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8999, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7762; break; } else { __label__ = 13836; break; }
    case 7762: // $34563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7763; break; } else { __label__ = 13836; break; }
    case 7763: // $34564
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7764; break; } else { __label__ = 13836; break; }
    case 7764: // $34565
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7765; break; } else { __label__ = 13836; break; }
    case 7765: // $34566
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7766; break; } else { __label__ = 13836; break; }
    case 7766: // $34567
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($8996, $8997, $8998, $8999, $9000, $9001, $9002, $9003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7767; break; } else { __label__ = 13836; break; }
    case 7767: // $34568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9005, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7768; break; } else { __label__ = 13836; break; }
    case 7768: // $34569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9006, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7769; break; } else { __label__ = 13836; break; }
    case 7769: // $34570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9007, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7770; break; } else { __label__ = 13836; break; }
    case 7770: // $34571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7771; break; } else { __label__ = 13836; break; }
    case 7771: // $34572
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7772; break; } else { __label__ = 13836; break; }
    case 7772: // $34573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7773; break; } else { __label__ = 13836; break; }
    case 7773: // $34574
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7774; break; } else { __label__ = 13836; break; }
    case 7774: // $34575
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9004, $9005, $9006, $9007, $9008, $9009, $9010, $9011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7775; break; } else { __label__ = 13836; break; }
    case 7775: // $34576
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34552, 151, 6, 5, ((STRING_TABLE.__str1052)|0), ((STRING_TABLE.__str1053)|0), $8988, $8996, $9004) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7776; break; } else { __label__ = 13836; break; }
    case 7776: // $34577
      var $34578=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34552);
      var $34579=__ZN11simple_listI16input_type_entryE6appendERS0_($34513, $34578);
      var $34580=$4689;
      var $34581=$2524;
      var $34582=$2525;
      var $34583=$2526;
      var $34584=$result_i863;
      var $34585=$2527;
      var $34586=$2528;
      HEAP32[(($2524)>>2)]=408;
      HEAP32[(($2525)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2526)>>2)]=505;
      var $34587=HEAP32[(($2524)>>2)];
      var $34588=HEAP32[(($2525)>>2)];
      var $34589=HEAP32[(($2526)>>2)];
      var $34590=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34587, $34588, $34589) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7777; break; } else { __label__ = 7779; break; };
    case 7777: // $34591
      HEAP32[(($result_i863)>>2)]=$34590;
      var $34592=HEAP32[(($result_i863)>>2)];
      var $34593=(($34592)|0)==0;
      if ($34593) { __label__ = 7778; break; } else { __label__ = 7783; break; }
    case 7778: // $34594
      var $34595=___cxa_allocate_exception(4);
      var $34596=$34595;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34596);
      (function() { try { __THREW__ = false; return ___cxa_throw($34595, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7782; break; } else { __label__ = 7779; break; }
    case 7779: // $34597
      var $34598=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34599=$34598.f0;
      HEAP32[(($2527)>>2)]=$34599;
      var $34600=$34598.f1;
      HEAP32[(($2528)>>2)]=$34600;
      var $34601=HEAP32[(($2528)>>2)];
      var $34602=(($34601)|0) < 0;
      if ($34602) { __label__ = 7780; break; } else { __label__ = 7781; break; }
    case 7780: // $34603
      var $34604=HEAP32[(($2527)>>2)];
      ___cxa_call_unexpected($34604);
      throw "Reached an unreachable!"
    case 7781: // $34605
      var $34606=HEAP32[(($2527)>>2)];
      var $34607=HEAP32[(($2527)>>2)];
      var $34608=HEAP32[(($2528)>>2)];
      var $34609=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34607, tempValue);
      var $34610=($34609.f1 = $34608, $34609);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7782: // $34611
      throw "Reached an unreachable!"
    case 7783: // $_ZnwjPKci_exit864
      var $34612=HEAP32[(($result_i863)>>2)];
      var $34613=$2524;
      var $34614=$2525;
      var $34615=$2526;
      var $34616=$result_i863;
      var $34617=$2527;
      var $34618=$2528;
      var $34619=$34612;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9013, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7784; break; } else { __label__ = 13841; break; }
    case 7784: // $34620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9014, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7785; break; } else { __label__ = 13841; break; }
    case 7785: // $34621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9015, 4, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7786; break; } else { __label__ = 13841; break; }
    case 7786: // $34622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7787; break; } else { __label__ = 13841; break; }
    case 7787: // $34623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7788; break; } else { __label__ = 13841; break; }
    case 7788: // $34624
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7789; break; } else { __label__ = 13841; break; }
    case 7789: // $34625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7790; break; } else { __label__ = 13841; break; }
    case 7790: // $34626
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9012, $9013, $9014, $9015, $9016, $9017, $9018, $9019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7791; break; } else { __label__ = 13841; break; }
    case 7791: // $34627
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9021, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7792; break; } else { __label__ = 13841; break; }
    case 7792: // $34628
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9022, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7793; break; } else { __label__ = 13841; break; }
    case 7793: // $34629
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9023, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7794; break; } else { __label__ = 13841; break; }
    case 7794: // $34630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7795; break; } else { __label__ = 13841; break; }
    case 7795: // $34631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7796; break; } else { __label__ = 13841; break; }
    case 7796: // $34632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7797; break; } else { __label__ = 13841; break; }
    case 7797: // $34633
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7798; break; } else { __label__ = 13841; break; }
    case 7798: // $34634
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9020, $9021, $9022, $9023, $9024, $9025, $9026, $9027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7799; break; } else { __label__ = 13841; break; }
    case 7799: // $34635
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9029, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7800; break; } else { __label__ = 13841; break; }
    case 7800: // $34636
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9030, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7801; break; } else { __label__ = 13841; break; }
    case 7801: // $34637
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9031, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7802; break; } else { __label__ = 13841; break; }
    case 7802: // $34638
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7803; break; } else { __label__ = 13841; break; }
    case 7803: // $34639
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7804; break; } else { __label__ = 13841; break; }
    case 7804: // $34640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7805; break; } else { __label__ = 13841; break; }
    case 7805: // $34641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7806; break; } else { __label__ = 13841; break; }
    case 7806: // $34642
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9028, $9029, $9030, $9031, $9032, $9033, $9034, $9035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7807; break; } else { __label__ = 13841; break; }
    case 7807: // $34643
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34619, 151, 7, 6, ((STRING_TABLE.__str1054)|0), ((STRING_TABLE.__str1055)|0), $9012, $9020, $9028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7808; break; } else { __label__ = 13841; break; }
    case 7808: // $34644
      var $34645=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34619);
      var $34646=__ZN11simple_listI16input_type_entryE6appendERS0_($34580, $34645);
      var $34647=$4689;
      var $34648=$2519;
      var $34649=$2520;
      var $34650=$2521;
      var $34651=$result_i865;
      var $34652=$2522;
      var $34653=$2523;
      HEAP32[(($2519)>>2)]=408;
      HEAP32[(($2520)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2521)>>2)]=506;
      var $34654=HEAP32[(($2519)>>2)];
      var $34655=HEAP32[(($2520)>>2)];
      var $34656=HEAP32[(($2521)>>2)];
      var $34657=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34654, $34655, $34656) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7809; break; } else { __label__ = 7811; break; };
    case 7809: // $34658
      HEAP32[(($result_i865)>>2)]=$34657;
      var $34659=HEAP32[(($result_i865)>>2)];
      var $34660=(($34659)|0)==0;
      if ($34660) { __label__ = 7810; break; } else { __label__ = 7815; break; }
    case 7810: // $34661
      var $34662=___cxa_allocate_exception(4);
      var $34663=$34662;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34663);
      (function() { try { __THREW__ = false; return ___cxa_throw($34662, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7814; break; } else { __label__ = 7811; break; }
    case 7811: // $34664
      var $34665=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34666=$34665.f0;
      HEAP32[(($2522)>>2)]=$34666;
      var $34667=$34665.f1;
      HEAP32[(($2523)>>2)]=$34667;
      var $34668=HEAP32[(($2523)>>2)];
      var $34669=(($34668)|0) < 0;
      if ($34669) { __label__ = 7812; break; } else { __label__ = 7813; break; }
    case 7812: // $34670
      var $34671=HEAP32[(($2522)>>2)];
      ___cxa_call_unexpected($34671);
      throw "Reached an unreachable!"
    case 7813: // $34672
      var $34673=HEAP32[(($2522)>>2)];
      var $34674=HEAP32[(($2522)>>2)];
      var $34675=HEAP32[(($2523)>>2)];
      var $34676=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34674, tempValue);
      var $34677=($34676.f1 = $34675, $34676);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7814: // $34678
      throw "Reached an unreachable!"
    case 7815: // $_ZnwjPKci_exit866
      var $34679=HEAP32[(($result_i865)>>2)];
      var $34680=$2519;
      var $34681=$2520;
      var $34682=$2521;
      var $34683=$result_i865;
      var $34684=$2522;
      var $34685=$2523;
      var $34686=$34679;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9037, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7816; break; } else { __label__ = 13846; break; }
    case 7816: // $34687
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9038, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7817; break; } else { __label__ = 13846; break; }
    case 7817: // $34688
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9039, 4, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7818; break; } else { __label__ = 13846; break; }
    case 7818: // $34689
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7819; break; } else { __label__ = 13846; break; }
    case 7819: // $34690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7820; break; } else { __label__ = 13846; break; }
    case 7820: // $34691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7821; break; } else { __label__ = 13846; break; }
    case 7821: // $34692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7822; break; } else { __label__ = 13846; break; }
    case 7822: // $34693
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9036, $9037, $9038, $9039, $9040, $9041, $9042, $9043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7823; break; } else { __label__ = 13846; break; }
    case 7823: // $34694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9045, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7824; break; } else { __label__ = 13846; break; }
    case 7824: // $34695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9046, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7825; break; } else { __label__ = 13846; break; }
    case 7825: // $34696
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9047, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7826; break; } else { __label__ = 13846; break; }
    case 7826: // $34697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7827; break; } else { __label__ = 13846; break; }
    case 7827: // $34698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7828; break; } else { __label__ = 13846; break; }
    case 7828: // $34699
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7829; break; } else { __label__ = 13846; break; }
    case 7829: // $34700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7830; break; } else { __label__ = 13846; break; }
    case 7830: // $34701
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9044, $9045, $9046, $9047, $9048, $9049, $9050, $9051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7831; break; } else { __label__ = 13846; break; }
    case 7831: // $34702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9053, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7832; break; } else { __label__ = 13846; break; }
    case 7832: // $34703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9054, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7833; break; } else { __label__ = 13846; break; }
    case 7833: // $34704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9055, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7834; break; } else { __label__ = 13846; break; }
    case 7834: // $34705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7835; break; } else { __label__ = 13846; break; }
    case 7835: // $34706
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7836; break; } else { __label__ = 13846; break; }
    case 7836: // $34707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7837; break; } else { __label__ = 13846; break; }
    case 7837: // $34708
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7838; break; } else { __label__ = 13846; break; }
    case 7838: // $34709
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9052, $9053, $9054, $9055, $9056, $9057, $9058, $9059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7839; break; } else { __label__ = 13846; break; }
    case 7839: // $34710
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34686, 151, 8, 7, ((STRING_TABLE.__str1056)|0), ((STRING_TABLE.__str1057)|0), $9036, $9044, $9052) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7840; break; } else { __label__ = 13846; break; }
    case 7840: // $34711
      var $34712=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34686);
      var $34713=__ZN11simple_listI16input_type_entryE6appendERS0_($34647, $34712);
      var $34714=$4689;
      var $34715=$2514;
      var $34716=$2515;
      var $34717=$2516;
      var $34718=$result_i867;
      var $34719=$2517;
      var $34720=$2518;
      HEAP32[(($2514)>>2)]=408;
      HEAP32[(($2515)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2516)>>2)]=508;
      var $34721=HEAP32[(($2514)>>2)];
      var $34722=HEAP32[(($2515)>>2)];
      var $34723=HEAP32[(($2516)>>2)];
      var $34724=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34721, $34722, $34723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7841; break; } else { __label__ = 7843; break; };
    case 7841: // $34725
      HEAP32[(($result_i867)>>2)]=$34724;
      var $34726=HEAP32[(($result_i867)>>2)];
      var $34727=(($34726)|0)==0;
      if ($34727) { __label__ = 7842; break; } else { __label__ = 7847; break; }
    case 7842: // $34728
      var $34729=___cxa_allocate_exception(4);
      var $34730=$34729;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34730);
      (function() { try { __THREW__ = false; return ___cxa_throw($34729, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7846; break; } else { __label__ = 7843; break; }
    case 7843: // $34731
      var $34732=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34733=$34732.f0;
      HEAP32[(($2517)>>2)]=$34733;
      var $34734=$34732.f1;
      HEAP32[(($2518)>>2)]=$34734;
      var $34735=HEAP32[(($2518)>>2)];
      var $34736=(($34735)|0) < 0;
      if ($34736) { __label__ = 7844; break; } else { __label__ = 7845; break; }
    case 7844: // $34737
      var $34738=HEAP32[(($2517)>>2)];
      ___cxa_call_unexpected($34738);
      throw "Reached an unreachable!"
    case 7845: // $34739
      var $34740=HEAP32[(($2517)>>2)];
      var $34741=HEAP32[(($2517)>>2)];
      var $34742=HEAP32[(($2518)>>2)];
      var $34743=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34741, tempValue);
      var $34744=($34743.f1 = $34742, $34743);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7846: // $34745
      throw "Reached an unreachable!"
    case 7847: // $_ZnwjPKci_exit868
      var $34746=HEAP32[(($result_i867)>>2)];
      var $34747=$2514;
      var $34748=$2515;
      var $34749=$2516;
      var $34750=$result_i867;
      var $34751=$2517;
      var $34752=$2518;
      var $34753=$34746;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9061, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7848; break; } else { __label__ = 13851; break; }
    case 7848: // $34754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9062, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7849; break; } else { __label__ = 13851; break; }
    case 7849: // $34755
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9063, 4, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7850; break; } else { __label__ = 13851; break; }
    case 7850: // $34756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7851; break; } else { __label__ = 13851; break; }
    case 7851: // $34757
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7852; break; } else { __label__ = 13851; break; }
    case 7852: // $34758
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7853; break; } else { __label__ = 13851; break; }
    case 7853: // $34759
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7854; break; } else { __label__ = 13851; break; }
    case 7854: // $34760
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9060, $9061, $9062, $9063, $9064, $9065, $9066, $9067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7855; break; } else { __label__ = 13851; break; }
    case 7855: // $34761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9069, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7856; break; } else { __label__ = 13851; break; }
    case 7856: // $34762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9070, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7857; break; } else { __label__ = 13851; break; }
    case 7857: // $34763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9071, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7858; break; } else { __label__ = 13851; break; }
    case 7858: // $34764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7859; break; } else { __label__ = 13851; break; }
    case 7859: // $34765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7860; break; } else { __label__ = 13851; break; }
    case 7860: // $34766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7861; break; } else { __label__ = 13851; break; }
    case 7861: // $34767
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7862; break; } else { __label__ = 13851; break; }
    case 7862: // $34768
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9068, $9069, $9070, $9071, $9072, $9073, $9074, $9075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7863; break; } else { __label__ = 13851; break; }
    case 7863: // $34769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9077, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7864; break; } else { __label__ = 13851; break; }
    case 7864: // $34770
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9078, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7865; break; } else { __label__ = 13851; break; }
    case 7865: // $34771
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9079, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7866; break; } else { __label__ = 13851; break; }
    case 7866: // $34772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7867; break; } else { __label__ = 13851; break; }
    case 7867: // $34773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7868; break; } else { __label__ = 13851; break; }
    case 7868: // $34774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7869; break; } else { __label__ = 13851; break; }
    case 7869: // $34775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7870; break; } else { __label__ = 13851; break; }
    case 7870: // $34776
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9076, $9077, $9078, $9079, $9080, $9081, $9082, $9083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7871; break; } else { __label__ = 13851; break; }
    case 7871: // $34777
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34753, 152, 1, 0, ((STRING_TABLE.__str1058)|0), ((STRING_TABLE.__str1059)|0), $9060, $9068, $9076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7872; break; } else { __label__ = 13851; break; }
    case 7872: // $34778
      var $34779=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34753);
      var $34780=__ZN11simple_listI16input_type_entryE6appendERS0_($34714, $34779);
      var $34781=$4689;
      var $34782=$2509;
      var $34783=$2510;
      var $34784=$2511;
      var $34785=$result_i869;
      var $34786=$2512;
      var $34787=$2513;
      HEAP32[(($2509)>>2)]=408;
      HEAP32[(($2510)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2511)>>2)]=509;
      var $34788=HEAP32[(($2509)>>2)];
      var $34789=HEAP32[(($2510)>>2)];
      var $34790=HEAP32[(($2511)>>2)];
      var $34791=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34788, $34789, $34790) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7873; break; } else { __label__ = 7875; break; };
    case 7873: // $34792
      HEAP32[(($result_i869)>>2)]=$34791;
      var $34793=HEAP32[(($result_i869)>>2)];
      var $34794=(($34793)|0)==0;
      if ($34794) { __label__ = 7874; break; } else { __label__ = 7879; break; }
    case 7874: // $34795
      var $34796=___cxa_allocate_exception(4);
      var $34797=$34796;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34797);
      (function() { try { __THREW__ = false; return ___cxa_throw($34796, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7878; break; } else { __label__ = 7875; break; }
    case 7875: // $34798
      var $34799=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34800=$34799.f0;
      HEAP32[(($2512)>>2)]=$34800;
      var $34801=$34799.f1;
      HEAP32[(($2513)>>2)]=$34801;
      var $34802=HEAP32[(($2513)>>2)];
      var $34803=(($34802)|0) < 0;
      if ($34803) { __label__ = 7876; break; } else { __label__ = 7877; break; }
    case 7876: // $34804
      var $34805=HEAP32[(($2512)>>2)];
      ___cxa_call_unexpected($34805);
      throw "Reached an unreachable!"
    case 7877: // $34806
      var $34807=HEAP32[(($2512)>>2)];
      var $34808=HEAP32[(($2512)>>2)];
      var $34809=HEAP32[(($2513)>>2)];
      var $34810=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34808, tempValue);
      var $34811=($34810.f1 = $34809, $34810);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7878: // $34812
      throw "Reached an unreachable!"
    case 7879: // $_ZnwjPKci_exit870
      var $34813=HEAP32[(($result_i869)>>2)];
      var $34814=$2509;
      var $34815=$2510;
      var $34816=$2511;
      var $34817=$result_i869;
      var $34818=$2512;
      var $34819=$2513;
      var $34820=$34813;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9085, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7880; break; } else { __label__ = 13856; break; }
    case 7880: // $34821
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9086, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7881; break; } else { __label__ = 13856; break; }
    case 7881: // $34822
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9087, 4, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7882; break; } else { __label__ = 13856; break; }
    case 7882: // $34823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7883; break; } else { __label__ = 13856; break; }
    case 7883: // $34824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7884; break; } else { __label__ = 13856; break; }
    case 7884: // $34825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7885; break; } else { __label__ = 13856; break; }
    case 7885: // $34826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7886; break; } else { __label__ = 13856; break; }
    case 7886: // $34827
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9084, $9085, $9086, $9087, $9088, $9089, $9090, $9091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7887; break; } else { __label__ = 13856; break; }
    case 7887: // $34828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9093, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7888; break; } else { __label__ = 13856; break; }
    case 7888: // $34829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9094, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7889; break; } else { __label__ = 13856; break; }
    case 7889: // $34830
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9095, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7890; break; } else { __label__ = 13856; break; }
    case 7890: // $34831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7891; break; } else { __label__ = 13856; break; }
    case 7891: // $34832
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7892; break; } else { __label__ = 13856; break; }
    case 7892: // $34833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7893; break; } else { __label__ = 13856; break; }
    case 7893: // $34834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7894; break; } else { __label__ = 13856; break; }
    case 7894: // $34835
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9092, $9093, $9094, $9095, $9096, $9097, $9098, $9099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7895; break; } else { __label__ = 13856; break; }
    case 7895: // $34836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9101, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7896; break; } else { __label__ = 13856; break; }
    case 7896: // $34837
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9102, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7897; break; } else { __label__ = 13856; break; }
    case 7897: // $34838
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9103, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7898; break; } else { __label__ = 13856; break; }
    case 7898: // $34839
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9104, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7899; break; } else { __label__ = 13856; break; }
    case 7899: // $34840
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9105, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7900; break; } else { __label__ = 13856; break; }
    case 7900: // $34841
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7901; break; } else { __label__ = 13856; break; }
    case 7901: // $34842
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7902; break; } else { __label__ = 13856; break; }
    case 7902: // $34843
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9100, $9101, $9102, $9103, $9104, $9105, $9106, $9107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7903; break; } else { __label__ = 13856; break; }
    case 7903: // $34844
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34820, 152, 2, 1, ((STRING_TABLE.__str1060)|0), ((STRING_TABLE.__str1061)|0), $9084, $9092, $9100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7904; break; } else { __label__ = 13856; break; }
    case 7904: // $34845
      var $34846=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34820);
      var $34847=__ZN11simple_listI16input_type_entryE6appendERS0_($34781, $34846);
      var $34848=$4689;
      var $34849=$2504;
      var $34850=$2505;
      var $34851=$2506;
      var $34852=$result_i871;
      var $34853=$2507;
      var $34854=$2508;
      HEAP32[(($2504)>>2)]=408;
      HEAP32[(($2505)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2506)>>2)]=510;
      var $34855=HEAP32[(($2504)>>2)];
      var $34856=HEAP32[(($2505)>>2)];
      var $34857=HEAP32[(($2506)>>2)];
      var $34858=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34855, $34856, $34857) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7905; break; } else { __label__ = 7907; break; };
    case 7905: // $34859
      HEAP32[(($result_i871)>>2)]=$34858;
      var $34860=HEAP32[(($result_i871)>>2)];
      var $34861=(($34860)|0)==0;
      if ($34861) { __label__ = 7906; break; } else { __label__ = 7911; break; }
    case 7906: // $34862
      var $34863=___cxa_allocate_exception(4);
      var $34864=$34863;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34864);
      (function() { try { __THREW__ = false; return ___cxa_throw($34863, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7910; break; } else { __label__ = 7907; break; }
    case 7907: // $34865
      var $34866=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34867=$34866.f0;
      HEAP32[(($2507)>>2)]=$34867;
      var $34868=$34866.f1;
      HEAP32[(($2508)>>2)]=$34868;
      var $34869=HEAP32[(($2508)>>2)];
      var $34870=(($34869)|0) < 0;
      if ($34870) { __label__ = 7908; break; } else { __label__ = 7909; break; }
    case 7908: // $34871
      var $34872=HEAP32[(($2507)>>2)];
      ___cxa_call_unexpected($34872);
      throw "Reached an unreachable!"
    case 7909: // $34873
      var $34874=HEAP32[(($2507)>>2)];
      var $34875=HEAP32[(($2507)>>2)];
      var $34876=HEAP32[(($2508)>>2)];
      var $34877=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34875, tempValue);
      var $34878=($34877.f1 = $34876, $34877);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7910: // $34879
      throw "Reached an unreachable!"
    case 7911: // $_ZnwjPKci_exit872
      var $34880=HEAP32[(($result_i871)>>2)];
      var $34881=$2504;
      var $34882=$2505;
      var $34883=$2506;
      var $34884=$result_i871;
      var $34885=$2507;
      var $34886=$2508;
      var $34887=$34880;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9109, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7912; break; } else { __label__ = 13861; break; }
    case 7912: // $34888
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9110, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7913; break; } else { __label__ = 13861; break; }
    case 7913: // $34889
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9111, 4, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7914; break; } else { __label__ = 13861; break; }
    case 7914: // $34890
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9112, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7915; break; } else { __label__ = 13861; break; }
    case 7915: // $34891
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9113, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7916; break; } else { __label__ = 13861; break; }
    case 7916: // $34892
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7917; break; } else { __label__ = 13861; break; }
    case 7917: // $34893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7918; break; } else { __label__ = 13861; break; }
    case 7918: // $34894
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9108, $9109, $9110, $9111, $9112, $9113, $9114, $9115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7919; break; } else { __label__ = 13861; break; }
    case 7919: // $34895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9117, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7920; break; } else { __label__ = 13861; break; }
    case 7920: // $34896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9118, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7921; break; } else { __label__ = 13861; break; }
    case 7921: // $34897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9119, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7922; break; } else { __label__ = 13861; break; }
    case 7922: // $34898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7923; break; } else { __label__ = 13861; break; }
    case 7923: // $34899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7924; break; } else { __label__ = 13861; break; }
    case 7924: // $34900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7925; break; } else { __label__ = 13861; break; }
    case 7925: // $34901
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7926; break; } else { __label__ = 13861; break; }
    case 7926: // $34902
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9116, $9117, $9118, $9119, $9120, $9121, $9122, $9123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7927; break; } else { __label__ = 13861; break; }
    case 7927: // $34903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9125, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7928; break; } else { __label__ = 13861; break; }
    case 7928: // $34904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9126, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7929; break; } else { __label__ = 13861; break; }
    case 7929: // $34905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9127, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7930; break; } else { __label__ = 13861; break; }
    case 7930: // $34906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7931; break; } else { __label__ = 13861; break; }
    case 7931: // $34907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7932; break; } else { __label__ = 13861; break; }
    case 7932: // $34908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7933; break; } else { __label__ = 13861; break; }
    case 7933: // $34909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7934; break; } else { __label__ = 13861; break; }
    case 7934: // $34910
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9124, $9125, $9126, $9127, $9128, $9129, $9130, $9131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7935; break; } else { __label__ = 13861; break; }
    case 7935: // $34911
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34887, 152, 3, 2, ((STRING_TABLE.__str1062)|0), ((STRING_TABLE.__str1063)|0), $9108, $9116, $9124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7936; break; } else { __label__ = 13861; break; }
    case 7936: // $34912
      var $34913=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34887);
      var $34914=__ZN11simple_listI16input_type_entryE6appendERS0_($34848, $34913);
      var $34915=$4689;
      var $34916=$2499;
      var $34917=$2500;
      var $34918=$2501;
      var $34919=$result_i873;
      var $34920=$2502;
      var $34921=$2503;
      HEAP32[(($2499)>>2)]=408;
      HEAP32[(($2500)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2501)>>2)]=511;
      var $34922=HEAP32[(($2499)>>2)];
      var $34923=HEAP32[(($2500)>>2)];
      var $34924=HEAP32[(($2501)>>2)];
      var $34925=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34922, $34923, $34924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7937; break; } else { __label__ = 7939; break; };
    case 7937: // $34926
      HEAP32[(($result_i873)>>2)]=$34925;
      var $34927=HEAP32[(($result_i873)>>2)];
      var $34928=(($34927)|0)==0;
      if ($34928) { __label__ = 7938; break; } else { __label__ = 7943; break; }
    case 7938: // $34929
      var $34930=___cxa_allocate_exception(4);
      var $34931=$34930;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34931);
      (function() { try { __THREW__ = false; return ___cxa_throw($34930, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7942; break; } else { __label__ = 7939; break; }
    case 7939: // $34932
      var $34933=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34934=$34933.f0;
      HEAP32[(($2502)>>2)]=$34934;
      var $34935=$34933.f1;
      HEAP32[(($2503)>>2)]=$34935;
      var $34936=HEAP32[(($2503)>>2)];
      var $34937=(($34936)|0) < 0;
      if ($34937) { __label__ = 7940; break; } else { __label__ = 7941; break; }
    case 7940: // $34938
      var $34939=HEAP32[(($2502)>>2)];
      ___cxa_call_unexpected($34939);
      throw "Reached an unreachable!"
    case 7941: // $34940
      var $34941=HEAP32[(($2502)>>2)];
      var $34942=HEAP32[(($2502)>>2)];
      var $34943=HEAP32[(($2503)>>2)];
      var $34944=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34942, tempValue);
      var $34945=($34944.f1 = $34943, $34944);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7942: // $34946
      throw "Reached an unreachable!"
    case 7943: // $_ZnwjPKci_exit874
      var $34947=HEAP32[(($result_i873)>>2)];
      var $34948=$2499;
      var $34949=$2500;
      var $34950=$2501;
      var $34951=$result_i873;
      var $34952=$2502;
      var $34953=$2503;
      var $34954=$34947;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9133, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7944; break; } else { __label__ = 13866; break; }
    case 7944: // $34955
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9134, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7945; break; } else { __label__ = 13866; break; }
    case 7945: // $34956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9135, 4, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7946; break; } else { __label__ = 13866; break; }
    case 7946: // $34957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7947; break; } else { __label__ = 13866; break; }
    case 7947: // $34958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7948; break; } else { __label__ = 13866; break; }
    case 7948: // $34959
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7949; break; } else { __label__ = 13866; break; }
    case 7949: // $34960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7950; break; } else { __label__ = 13866; break; }
    case 7950: // $34961
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9132, $9133, $9134, $9135, $9136, $9137, $9138, $9139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7951; break; } else { __label__ = 13866; break; }
    case 7951: // $34962
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9141, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7952; break; } else { __label__ = 13866; break; }
    case 7952: // $34963
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9142, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7953; break; } else { __label__ = 13866; break; }
    case 7953: // $34964
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9143, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7954; break; } else { __label__ = 13866; break; }
    case 7954: // $34965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7955; break; } else { __label__ = 13866; break; }
    case 7955: // $34966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7956; break; } else { __label__ = 13866; break; }
    case 7956: // $34967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7957; break; } else { __label__ = 13866; break; }
    case 7957: // $34968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7958; break; } else { __label__ = 13866; break; }
    case 7958: // $34969
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9140, $9141, $9142, $9143, $9144, $9145, $9146, $9147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7959; break; } else { __label__ = 13866; break; }
    case 7959: // $34970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9149, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7960; break; } else { __label__ = 13866; break; }
    case 7960: // $34971
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7961; break; } else { __label__ = 13866; break; }
    case 7961: // $34972
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7962; break; } else { __label__ = 13866; break; }
    case 7962: // $34973
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7963; break; } else { __label__ = 13866; break; }
    case 7963: // $34974
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7964; break; } else { __label__ = 13866; break; }
    case 7964: // $34975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7965; break; } else { __label__ = 13866; break; }
    case 7965: // $34976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7966; break; } else { __label__ = 13866; break; }
    case 7966: // $34977
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9148, $9149, $9150, $9151, $9152, $9153, $9154, $9155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7967; break; } else { __label__ = 13866; break; }
    case 7967: // $34978
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($34954, 152, 4, 3, ((STRING_TABLE.__str1064)|0), ((STRING_TABLE.__str1065)|0), $9132, $9140, $9148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7968; break; } else { __label__ = 13866; break; }
    case 7968: // $34979
      var $34980=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $34954);
      var $34981=__ZN11simple_listI16input_type_entryE6appendERS0_($34915, $34980);
      var $34982=$4689;
      var $34983=$2494;
      var $34984=$2495;
      var $34985=$2496;
      var $34986=$result_i875;
      var $34987=$2497;
      var $34988=$2498;
      HEAP32[(($2494)>>2)]=408;
      HEAP32[(($2495)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2496)>>2)]=512;
      var $34989=HEAP32[(($2494)>>2)];
      var $34990=HEAP32[(($2495)>>2)];
      var $34991=HEAP32[(($2496)>>2)];
      var $34992=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34989, $34990, $34991) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7969; break; } else { __label__ = 7971; break; };
    case 7969: // $34993
      HEAP32[(($result_i875)>>2)]=$34992;
      var $34994=HEAP32[(($result_i875)>>2)];
      var $34995=(($34994)|0)==0;
      if ($34995) { __label__ = 7970; break; } else { __label__ = 7975; break; }
    case 7970: // $34996
      var $34997=___cxa_allocate_exception(4);
      var $34998=$34997;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($34998);
      (function() { try { __THREW__ = false; return ___cxa_throw($34997, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7974; break; } else { __label__ = 7971; break; }
    case 7971: // $34999
      var $35000=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35001=$35000.f0;
      HEAP32[(($2497)>>2)]=$35001;
      var $35002=$35000.f1;
      HEAP32[(($2498)>>2)]=$35002;
      var $35003=HEAP32[(($2498)>>2)];
      var $35004=(($35003)|0) < 0;
      if ($35004) { __label__ = 7972; break; } else { __label__ = 7973; break; }
    case 7972: // $35005
      var $35006=HEAP32[(($2497)>>2)];
      ___cxa_call_unexpected($35006);
      throw "Reached an unreachable!"
    case 7973: // $35007
      var $35008=HEAP32[(($2497)>>2)];
      var $35009=HEAP32[(($2497)>>2)];
      var $35010=HEAP32[(($2498)>>2)];
      var $35011=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35009, tempValue);
      var $35012=($35011.f1 = $35010, $35011);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7974: // $35013
      throw "Reached an unreachable!"
    case 7975: // $_ZnwjPKci_exit876
      var $35014=HEAP32[(($result_i875)>>2)];
      var $35015=$2494;
      var $35016=$2495;
      var $35017=$2496;
      var $35018=$result_i875;
      var $35019=$2497;
      var $35020=$2498;
      var $35021=$35014;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9157, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7976; break; } else { __label__ = 13871; break; }
    case 7976: // $35022
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9158, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7977; break; } else { __label__ = 13871; break; }
    case 7977: // $35023
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9159, 4, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7978; break; } else { __label__ = 13871; break; }
    case 7978: // $35024
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7979; break; } else { __label__ = 13871; break; }
    case 7979: // $35025
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7980; break; } else { __label__ = 13871; break; }
    case 7980: // $35026
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7981; break; } else { __label__ = 13871; break; }
    case 7981: // $35027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7982; break; } else { __label__ = 13871; break; }
    case 7982: // $35028
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9156, $9157, $9158, $9159, $9160, $9161, $9162, $9163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7983; break; } else { __label__ = 13871; break; }
    case 7983: // $35029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9165, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7984; break; } else { __label__ = 13871; break; }
    case 7984: // $35030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9166, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7985; break; } else { __label__ = 13871; break; }
    case 7985: // $35031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9167, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7986; break; } else { __label__ = 13871; break; }
    case 7986: // $35032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7987; break; } else { __label__ = 13871; break; }
    case 7987: // $35033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7988; break; } else { __label__ = 13871; break; }
    case 7988: // $35034
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7989; break; } else { __label__ = 13871; break; }
    case 7989: // $35035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7990; break; } else { __label__ = 13871; break; }
    case 7990: // $35036
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9164, $9165, $9166, $9167, $9168, $9169, $9170, $9171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7991; break; } else { __label__ = 13871; break; }
    case 7991: // $35037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9173, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7992; break; } else { __label__ = 13871; break; }
    case 7992: // $35038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7993; break; } else { __label__ = 13871; break; }
    case 7993: // $35039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7994; break; } else { __label__ = 13871; break; }
    case 7994: // $35040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7995; break; } else { __label__ = 13871; break; }
    case 7995: // $35041
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7996; break; } else { __label__ = 13871; break; }
    case 7996: // $35042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7997; break; } else { __label__ = 13871; break; }
    case 7997: // $35043
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7998; break; } else { __label__ = 13871; break; }
    case 7998: // $35044
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9172, $9173, $9174, $9175, $9176, $9177, $9178, $9179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7999; break; } else { __label__ = 13871; break; }
    case 7999: // $35045
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35021, 152, 5, 4, ((STRING_TABLE.__str1066)|0), ((STRING_TABLE.__str1067)|0), $9156, $9164, $9172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8000; break; } else { __label__ = 13871; break; }
    case 8000: // $35046
      var $35047=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35021);
      var $35048=__ZN11simple_listI16input_type_entryE6appendERS0_($34982, $35047);
      var $35049=$4689;
      var $35050=$2489;
      var $35051=$2490;
      var $35052=$2491;
      var $35053=$result_i877;
      var $35054=$2492;
      var $35055=$2493;
      HEAP32[(($2489)>>2)]=408;
      HEAP32[(($2490)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2491)>>2)]=513;
      var $35056=HEAP32[(($2489)>>2)];
      var $35057=HEAP32[(($2490)>>2)];
      var $35058=HEAP32[(($2491)>>2)];
      var $35059=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35056, $35057, $35058) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8001; break; } else { __label__ = 8003; break; };
    case 8001: // $35060
      HEAP32[(($result_i877)>>2)]=$35059;
      var $35061=HEAP32[(($result_i877)>>2)];
      var $35062=(($35061)|0)==0;
      if ($35062) { __label__ = 8002; break; } else { __label__ = 8007; break; }
    case 8002: // $35063
      var $35064=___cxa_allocate_exception(4);
      var $35065=$35064;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35065);
      (function() { try { __THREW__ = false; return ___cxa_throw($35064, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8006; break; } else { __label__ = 8003; break; }
    case 8003: // $35066
      var $35067=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35068=$35067.f0;
      HEAP32[(($2492)>>2)]=$35068;
      var $35069=$35067.f1;
      HEAP32[(($2493)>>2)]=$35069;
      var $35070=HEAP32[(($2493)>>2)];
      var $35071=(($35070)|0) < 0;
      if ($35071) { __label__ = 8004; break; } else { __label__ = 8005; break; }
    case 8004: // $35072
      var $35073=HEAP32[(($2492)>>2)];
      ___cxa_call_unexpected($35073);
      throw "Reached an unreachable!"
    case 8005: // $35074
      var $35075=HEAP32[(($2492)>>2)];
      var $35076=HEAP32[(($2492)>>2)];
      var $35077=HEAP32[(($2493)>>2)];
      var $35078=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35076, tempValue);
      var $35079=($35078.f1 = $35077, $35078);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8006: // $35080
      throw "Reached an unreachable!"
    case 8007: // $_ZnwjPKci_exit878
      var $35081=HEAP32[(($result_i877)>>2)];
      var $35082=$2489;
      var $35083=$2490;
      var $35084=$2491;
      var $35085=$result_i877;
      var $35086=$2492;
      var $35087=$2493;
      var $35088=$35081;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9181, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8008; break; } else { __label__ = 13876; break; }
    case 8008: // $35089
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9182, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8009; break; } else { __label__ = 13876; break; }
    case 8009: // $35090
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9183, 4, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8010; break; } else { __label__ = 13876; break; }
    case 8010: // $35091
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8011; break; } else { __label__ = 13876; break; }
    case 8011: // $35092
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8012; break; } else { __label__ = 13876; break; }
    case 8012: // $35093
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8013; break; } else { __label__ = 13876; break; }
    case 8013: // $35094
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8014; break; } else { __label__ = 13876; break; }
    case 8014: // $35095
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9180, $9181, $9182, $9183, $9184, $9185, $9186, $9187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8015; break; } else { __label__ = 13876; break; }
    case 8015: // $35096
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9189, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8016; break; } else { __label__ = 13876; break; }
    case 8016: // $35097
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9190, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8017; break; } else { __label__ = 13876; break; }
    case 8017: // $35098
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9191, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8018; break; } else { __label__ = 13876; break; }
    case 8018: // $35099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8019; break; } else { __label__ = 13876; break; }
    case 8019: // $35100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8020; break; } else { __label__ = 13876; break; }
    case 8020: // $35101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8021; break; } else { __label__ = 13876; break; }
    case 8021: // $35102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8022; break; } else { __label__ = 13876; break; }
    case 8022: // $35103
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9188, $9189, $9190, $9191, $9192, $9193, $9194, $9195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8023; break; } else { __label__ = 13876; break; }
    case 8023: // $35104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9197, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8024; break; } else { __label__ = 13876; break; }
    case 8024: // $35105
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8025; break; } else { __label__ = 13876; break; }
    case 8025: // $35106
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8026; break; } else { __label__ = 13876; break; }
    case 8026: // $35107
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8027; break; } else { __label__ = 13876; break; }
    case 8027: // $35108
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8028; break; } else { __label__ = 13876; break; }
    case 8028: // $35109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8029; break; } else { __label__ = 13876; break; }
    case 8029: // $35110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8030; break; } else { __label__ = 13876; break; }
    case 8030: // $35111
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9196, $9197, $9198, $9199, $9200, $9201, $9202, $9203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8031; break; } else { __label__ = 13876; break; }
    case 8031: // $35112
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35088, 152, 6, 5, ((STRING_TABLE.__str1068)|0), ((STRING_TABLE.__str1069)|0), $9180, $9188, $9196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8032; break; } else { __label__ = 13876; break; }
    case 8032: // $35113
      var $35114=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35088);
      var $35115=__ZN11simple_listI16input_type_entryE6appendERS0_($35049, $35114);
      var $35116=$4689;
      var $35117=$2484;
      var $35118=$2485;
      var $35119=$2486;
      var $35120=$result_i879;
      var $35121=$2487;
      var $35122=$2488;
      HEAP32[(($2484)>>2)]=408;
      HEAP32[(($2485)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2486)>>2)]=514;
      var $35123=HEAP32[(($2484)>>2)];
      var $35124=HEAP32[(($2485)>>2)];
      var $35125=HEAP32[(($2486)>>2)];
      var $35126=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35123, $35124, $35125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8033; break; } else { __label__ = 8035; break; };
    case 8033: // $35127
      HEAP32[(($result_i879)>>2)]=$35126;
      var $35128=HEAP32[(($result_i879)>>2)];
      var $35129=(($35128)|0)==0;
      if ($35129) { __label__ = 8034; break; } else { __label__ = 8039; break; }
    case 8034: // $35130
      var $35131=___cxa_allocate_exception(4);
      var $35132=$35131;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35132);
      (function() { try { __THREW__ = false; return ___cxa_throw($35131, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8038; break; } else { __label__ = 8035; break; }
    case 8035: // $35133
      var $35134=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35135=$35134.f0;
      HEAP32[(($2487)>>2)]=$35135;
      var $35136=$35134.f1;
      HEAP32[(($2488)>>2)]=$35136;
      var $35137=HEAP32[(($2488)>>2)];
      var $35138=(($35137)|0) < 0;
      if ($35138) { __label__ = 8036; break; } else { __label__ = 8037; break; }
    case 8036: // $35139
      var $35140=HEAP32[(($2487)>>2)];
      ___cxa_call_unexpected($35140);
      throw "Reached an unreachable!"
    case 8037: // $35141
      var $35142=HEAP32[(($2487)>>2)];
      var $35143=HEAP32[(($2487)>>2)];
      var $35144=HEAP32[(($2488)>>2)];
      var $35145=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35143, tempValue);
      var $35146=($35145.f1 = $35144, $35145);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8038: // $35147
      throw "Reached an unreachable!"
    case 8039: // $_ZnwjPKci_exit880
      var $35148=HEAP32[(($result_i879)>>2)];
      var $35149=$2484;
      var $35150=$2485;
      var $35151=$2486;
      var $35152=$result_i879;
      var $35153=$2487;
      var $35154=$2488;
      var $35155=$35148;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9205, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8040; break; } else { __label__ = 13881; break; }
    case 8040: // $35156
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9206, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8041; break; } else { __label__ = 13881; break; }
    case 8041: // $35157
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9207, 4, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8042; break; } else { __label__ = 13881; break; }
    case 8042: // $35158
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8043; break; } else { __label__ = 13881; break; }
    case 8043: // $35159
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8044; break; } else { __label__ = 13881; break; }
    case 8044: // $35160
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8045; break; } else { __label__ = 13881; break; }
    case 8045: // $35161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8046; break; } else { __label__ = 13881; break; }
    case 8046: // $35162
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9204, $9205, $9206, $9207, $9208, $9209, $9210, $9211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8047; break; } else { __label__ = 13881; break; }
    case 8047: // $35163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9213, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8048; break; } else { __label__ = 13881; break; }
    case 8048: // $35164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8049; break; } else { __label__ = 13881; break; }
    case 8049: // $35165
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8050; break; } else { __label__ = 13881; break; }
    case 8050: // $35166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8051; break; } else { __label__ = 13881; break; }
    case 8051: // $35167
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8052; break; } else { __label__ = 13881; break; }
    case 8052: // $35168
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8053; break; } else { __label__ = 13881; break; }
    case 8053: // $35169
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8054; break; } else { __label__ = 13881; break; }
    case 8054: // $35170
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9212, $9213, $9214, $9215, $9216, $9217, $9218, $9219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8055; break; } else { __label__ = 13881; break; }
    case 8055: // $35171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9221, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8056; break; } else { __label__ = 13881; break; }
    case 8056: // $35172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9222, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8057; break; } else { __label__ = 13881; break; }
    case 8057: // $35173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8058; break; } else { __label__ = 13881; break; }
    case 8058: // $35174
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8059; break; } else { __label__ = 13881; break; }
    case 8059: // $35175
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8060; break; } else { __label__ = 13881; break; }
    case 8060: // $35176
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8061; break; } else { __label__ = 13881; break; }
    case 8061: // $35177
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8062; break; } else { __label__ = 13881; break; }
    case 8062: // $35178
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9220, $9221, $9222, $9223, $9224, $9225, $9226, $9227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8063; break; } else { __label__ = 13881; break; }
    case 8063: // $35179
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35155, 152, 7, 6, ((STRING_TABLE.__str1070)|0), ((STRING_TABLE.__str1071)|0), $9204, $9212, $9220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8064; break; } else { __label__ = 13881; break; }
    case 8064: // $35180
      var $35181=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35155);
      var $35182=__ZN11simple_listI16input_type_entryE6appendERS0_($35116, $35181);
      var $35183=$4689;
      var $35184=$2479;
      var $35185=$2480;
      var $35186=$2481;
      var $35187=$result_i881;
      var $35188=$2482;
      var $35189=$2483;
      HEAP32[(($2479)>>2)]=408;
      HEAP32[(($2480)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2481)>>2)]=515;
      var $35190=HEAP32[(($2479)>>2)];
      var $35191=HEAP32[(($2480)>>2)];
      var $35192=HEAP32[(($2481)>>2)];
      var $35193=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35190, $35191, $35192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8065; break; } else { __label__ = 8067; break; };
    case 8065: // $35194
      HEAP32[(($result_i881)>>2)]=$35193;
      var $35195=HEAP32[(($result_i881)>>2)];
      var $35196=(($35195)|0)==0;
      if ($35196) { __label__ = 8066; break; } else { __label__ = 8071; break; }
    case 8066: // $35197
      var $35198=___cxa_allocate_exception(4);
      var $35199=$35198;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35199);
      (function() { try { __THREW__ = false; return ___cxa_throw($35198, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8070; break; } else { __label__ = 8067; break; }
    case 8067: // $35200
      var $35201=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35202=$35201.f0;
      HEAP32[(($2482)>>2)]=$35202;
      var $35203=$35201.f1;
      HEAP32[(($2483)>>2)]=$35203;
      var $35204=HEAP32[(($2483)>>2)];
      var $35205=(($35204)|0) < 0;
      if ($35205) { __label__ = 8068; break; } else { __label__ = 8069; break; }
    case 8068: // $35206
      var $35207=HEAP32[(($2482)>>2)];
      ___cxa_call_unexpected($35207);
      throw "Reached an unreachable!"
    case 8069: // $35208
      var $35209=HEAP32[(($2482)>>2)];
      var $35210=HEAP32[(($2482)>>2)];
      var $35211=HEAP32[(($2483)>>2)];
      var $35212=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35210, tempValue);
      var $35213=($35212.f1 = $35211, $35212);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8070: // $35214
      throw "Reached an unreachable!"
    case 8071: // $_ZnwjPKci_exit882
      var $35215=HEAP32[(($result_i881)>>2)];
      var $35216=$2479;
      var $35217=$2480;
      var $35218=$2481;
      var $35219=$result_i881;
      var $35220=$2482;
      var $35221=$2483;
      var $35222=$35215;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9229, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8072; break; } else { __label__ = 13886; break; }
    case 8072: // $35223
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9230, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8073; break; } else { __label__ = 13886; break; }
    case 8073: // $35224
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9231, 4, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8074; break; } else { __label__ = 13886; break; }
    case 8074: // $35225
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8075; break; } else { __label__ = 13886; break; }
    case 8075: // $35226
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8076; break; } else { __label__ = 13886; break; }
    case 8076: // $35227
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8077; break; } else { __label__ = 13886; break; }
    case 8077: // $35228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8078; break; } else { __label__ = 13886; break; }
    case 8078: // $35229
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9228, $9229, $9230, $9231, $9232, $9233, $9234, $9235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8079; break; } else { __label__ = 13886; break; }
    case 8079: // $35230
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9237, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8080; break; } else { __label__ = 13886; break; }
    case 8080: // $35231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9238, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8081; break; } else { __label__ = 13886; break; }
    case 8081: // $35232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9239, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8082; break; } else { __label__ = 13886; break; }
    case 8082: // $35233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8083; break; } else { __label__ = 13886; break; }
    case 8083: // $35234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8084; break; } else { __label__ = 13886; break; }
    case 8084: // $35235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8085; break; } else { __label__ = 13886; break; }
    case 8085: // $35236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8086; break; } else { __label__ = 13886; break; }
    case 8086: // $35237
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9236, $9237, $9238, $9239, $9240, $9241, $9242, $9243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8087; break; } else { __label__ = 13886; break; }
    case 8087: // $35238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9245, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8088; break; } else { __label__ = 13886; break; }
    case 8088: // $35239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9246, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8089; break; } else { __label__ = 13886; break; }
    case 8089: // $35240
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9247, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8090; break; } else { __label__ = 13886; break; }
    case 8090: // $35241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8091; break; } else { __label__ = 13886; break; }
    case 8091: // $35242
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8092; break; } else { __label__ = 13886; break; }
    case 8092: // $35243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8093; break; } else { __label__ = 13886; break; }
    case 8093: // $35244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8094; break; } else { __label__ = 13886; break; }
    case 8094: // $35245
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9244, $9245, $9246, $9247, $9248, $9249, $9250, $9251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8095; break; } else { __label__ = 13886; break; }
    case 8095: // $35246
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35222, 152, 8, 7, ((STRING_TABLE.__str1072)|0), ((STRING_TABLE.__str1073)|0), $9228, $9236, $9244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8096; break; } else { __label__ = 13886; break; }
    case 8096: // $35247
      var $35248=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35222);
      var $35249=__ZN11simple_listI16input_type_entryE6appendERS0_($35183, $35248);
      var $35250=$4689;
      var $35251=$2474;
      var $35252=$2475;
      var $35253=$2476;
      var $35254=$result_i883;
      var $35255=$2477;
      var $35256=$2478;
      HEAP32[(($2474)>>2)]=408;
      HEAP32[(($2475)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2476)>>2)]=517;
      var $35257=HEAP32[(($2474)>>2)];
      var $35258=HEAP32[(($2475)>>2)];
      var $35259=HEAP32[(($2476)>>2)];
      var $35260=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35257, $35258, $35259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8097; break; } else { __label__ = 8099; break; };
    case 8097: // $35261
      HEAP32[(($result_i883)>>2)]=$35260;
      var $35262=HEAP32[(($result_i883)>>2)];
      var $35263=(($35262)|0)==0;
      if ($35263) { __label__ = 8098; break; } else { __label__ = 8103; break; }
    case 8098: // $35264
      var $35265=___cxa_allocate_exception(4);
      var $35266=$35265;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35266);
      (function() { try { __THREW__ = false; return ___cxa_throw($35265, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8102; break; } else { __label__ = 8099; break; }
    case 8099: // $35267
      var $35268=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35269=$35268.f0;
      HEAP32[(($2477)>>2)]=$35269;
      var $35270=$35268.f1;
      HEAP32[(($2478)>>2)]=$35270;
      var $35271=HEAP32[(($2478)>>2)];
      var $35272=(($35271)|0) < 0;
      if ($35272) { __label__ = 8100; break; } else { __label__ = 8101; break; }
    case 8100: // $35273
      var $35274=HEAP32[(($2477)>>2)];
      ___cxa_call_unexpected($35274);
      throw "Reached an unreachable!"
    case 8101: // $35275
      var $35276=HEAP32[(($2477)>>2)];
      var $35277=HEAP32[(($2477)>>2)];
      var $35278=HEAP32[(($2478)>>2)];
      var $35279=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35277, tempValue);
      var $35280=($35279.f1 = $35278, $35279);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8102: // $35281
      throw "Reached an unreachable!"
    case 8103: // $_ZnwjPKci_exit884
      var $35282=HEAP32[(($result_i883)>>2)];
      var $35283=$2474;
      var $35284=$2475;
      var $35285=$2476;
      var $35286=$result_i883;
      var $35287=$2477;
      var $35288=$2478;
      var $35289=$35282;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9253, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8104; break; } else { __label__ = 13891; break; }
    case 8104: // $35290
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9254, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8105; break; } else { __label__ = 13891; break; }
    case 8105: // $35291
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9255, 4, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8106; break; } else { __label__ = 13891; break; }
    case 8106: // $35292
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8107; break; } else { __label__ = 13891; break; }
    case 8107: // $35293
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8108; break; } else { __label__ = 13891; break; }
    case 8108: // $35294
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8109; break; } else { __label__ = 13891; break; }
    case 8109: // $35295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8110; break; } else { __label__ = 13891; break; }
    case 8110: // $35296
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9252, $9253, $9254, $9255, $9256, $9257, $9258, $9259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8111; break; } else { __label__ = 13891; break; }
    case 8111: // $35297
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9261, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8112; break; } else { __label__ = 13891; break; }
    case 8112: // $35298
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9262, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8113; break; } else { __label__ = 13891; break; }
    case 8113: // $35299
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9263, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8114; break; } else { __label__ = 13891; break; }
    case 8114: // $35300
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8115; break; } else { __label__ = 13891; break; }
    case 8115: // $35301
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8116; break; } else { __label__ = 13891; break; }
    case 8116: // $35302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8117; break; } else { __label__ = 13891; break; }
    case 8117: // $35303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8118; break; } else { __label__ = 13891; break; }
    case 8118: // $35304
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9260, $9261, $9262, $9263, $9264, $9265, $9266, $9267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8119; break; } else { __label__ = 13891; break; }
    case 8119: // $35305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9269, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8120; break; } else { __label__ = 13891; break; }
    case 8120: // $35306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9270, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8121; break; } else { __label__ = 13891; break; }
    case 8121: // $35307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9271, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8122; break; } else { __label__ = 13891; break; }
    case 8122: // $35308
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8123; break; } else { __label__ = 13891; break; }
    case 8123: // $35309
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8124; break; } else { __label__ = 13891; break; }
    case 8124: // $35310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8125; break; } else { __label__ = 13891; break; }
    case 8125: // $35311
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8126; break; } else { __label__ = 13891; break; }
    case 8126: // $35312
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9268, $9269, $9270, $9271, $9272, $9273, $9274, $9275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8127; break; } else { __label__ = 13891; break; }
    case 8127: // $35313
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35289, 153, 1, 0, ((STRING_TABLE.__str1074)|0), ((STRING_TABLE.__str1075)|0), $9252, $9260, $9268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8128; break; } else { __label__ = 13891; break; }
    case 8128: // $35314
      var $35315=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35289);
      var $35316=__ZN11simple_listI16input_type_entryE6appendERS0_($35250, $35315);
      var $35317=$4689;
      var $35318=$2469;
      var $35319=$2470;
      var $35320=$2471;
      var $35321=$result_i885;
      var $35322=$2472;
      var $35323=$2473;
      HEAP32[(($2469)>>2)]=408;
      HEAP32[(($2470)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2471)>>2)]=518;
      var $35324=HEAP32[(($2469)>>2)];
      var $35325=HEAP32[(($2470)>>2)];
      var $35326=HEAP32[(($2471)>>2)];
      var $35327=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35324, $35325, $35326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8129; break; } else { __label__ = 8131; break; };
    case 8129: // $35328
      HEAP32[(($result_i885)>>2)]=$35327;
      var $35329=HEAP32[(($result_i885)>>2)];
      var $35330=(($35329)|0)==0;
      if ($35330) { __label__ = 8130; break; } else { __label__ = 8135; break; }
    case 8130: // $35331
      var $35332=___cxa_allocate_exception(4);
      var $35333=$35332;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35333);
      (function() { try { __THREW__ = false; return ___cxa_throw($35332, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8134; break; } else { __label__ = 8131; break; }
    case 8131: // $35334
      var $35335=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35336=$35335.f0;
      HEAP32[(($2472)>>2)]=$35336;
      var $35337=$35335.f1;
      HEAP32[(($2473)>>2)]=$35337;
      var $35338=HEAP32[(($2473)>>2)];
      var $35339=(($35338)|0) < 0;
      if ($35339) { __label__ = 8132; break; } else { __label__ = 8133; break; }
    case 8132: // $35340
      var $35341=HEAP32[(($2472)>>2)];
      ___cxa_call_unexpected($35341);
      throw "Reached an unreachable!"
    case 8133: // $35342
      var $35343=HEAP32[(($2472)>>2)];
      var $35344=HEAP32[(($2472)>>2)];
      var $35345=HEAP32[(($2473)>>2)];
      var $35346=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35344, tempValue);
      var $35347=($35346.f1 = $35345, $35346);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8134: // $35348
      throw "Reached an unreachable!"
    case 8135: // $_ZnwjPKci_exit886
      var $35349=HEAP32[(($result_i885)>>2)];
      var $35350=$2469;
      var $35351=$2470;
      var $35352=$2471;
      var $35353=$result_i885;
      var $35354=$2472;
      var $35355=$2473;
      var $35356=$35349;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9277, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8136; break; } else { __label__ = 13896; break; }
    case 8136: // $35357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9278, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8137; break; } else { __label__ = 13896; break; }
    case 8137: // $35358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9279, 4, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8138; break; } else { __label__ = 13896; break; }
    case 8138: // $35359
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9280, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8139; break; } else { __label__ = 13896; break; }
    case 8139: // $35360
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9281, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8140; break; } else { __label__ = 13896; break; }
    case 8140: // $35361
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8141; break; } else { __label__ = 13896; break; }
    case 8141: // $35362
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8142; break; } else { __label__ = 13896; break; }
    case 8142: // $35363
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9276, $9277, $9278, $9279, $9280, $9281, $9282, $9283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8143; break; } else { __label__ = 13896; break; }
    case 8143: // $35364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9285, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8144; break; } else { __label__ = 13896; break; }
    case 8144: // $35365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9286, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8145; break; } else { __label__ = 13896; break; }
    case 8145: // $35366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9287, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8146; break; } else { __label__ = 13896; break; }
    case 8146: // $35367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8147; break; } else { __label__ = 13896; break; }
    case 8147: // $35368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8148; break; } else { __label__ = 13896; break; }
    case 8148: // $35369
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8149; break; } else { __label__ = 13896; break; }
    case 8149: // $35370
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8150; break; } else { __label__ = 13896; break; }
    case 8150: // $35371
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9284, $9285, $9286, $9287, $9288, $9289, $9290, $9291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8151; break; } else { __label__ = 13896; break; }
    case 8151: // $35372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9293, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8152; break; } else { __label__ = 13896; break; }
    case 8152: // $35373
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9294, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8153; break; } else { __label__ = 13896; break; }
    case 8153: // $35374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9295, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8154; break; } else { __label__ = 13896; break; }
    case 8154: // $35375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8155; break; } else { __label__ = 13896; break; }
    case 8155: // $35376
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8156; break; } else { __label__ = 13896; break; }
    case 8156: // $35377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8157; break; } else { __label__ = 13896; break; }
    case 8157: // $35378
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8158; break; } else { __label__ = 13896; break; }
    case 8158: // $35379
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9292, $9293, $9294, $9295, $9296, $9297, $9298, $9299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8159; break; } else { __label__ = 13896; break; }
    case 8159: // $35380
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35356, 153, 2, 1, ((STRING_TABLE.__str1076)|0), ((STRING_TABLE.__str1077)|0), $9276, $9284, $9292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8160; break; } else { __label__ = 13896; break; }
    case 8160: // $35381
      var $35382=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35356);
      var $35383=__ZN11simple_listI16input_type_entryE6appendERS0_($35317, $35382);
      var $35384=$4689;
      var $35385=$2464;
      var $35386=$2465;
      var $35387=$2466;
      var $35388=$result_i887;
      var $35389=$2467;
      var $35390=$2468;
      HEAP32[(($2464)>>2)]=408;
      HEAP32[(($2465)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2466)>>2)]=519;
      var $35391=HEAP32[(($2464)>>2)];
      var $35392=HEAP32[(($2465)>>2)];
      var $35393=HEAP32[(($2466)>>2)];
      var $35394=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35391, $35392, $35393) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8161; break; } else { __label__ = 8163; break; };
    case 8161: // $35395
      HEAP32[(($result_i887)>>2)]=$35394;
      var $35396=HEAP32[(($result_i887)>>2)];
      var $35397=(($35396)|0)==0;
      if ($35397) { __label__ = 8162; break; } else { __label__ = 8167; break; }
    case 8162: // $35398
      var $35399=___cxa_allocate_exception(4);
      var $35400=$35399;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35400);
      (function() { try { __THREW__ = false; return ___cxa_throw($35399, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8166; break; } else { __label__ = 8163; break; }
    case 8163: // $35401
      var $35402=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35403=$35402.f0;
      HEAP32[(($2467)>>2)]=$35403;
      var $35404=$35402.f1;
      HEAP32[(($2468)>>2)]=$35404;
      var $35405=HEAP32[(($2468)>>2)];
      var $35406=(($35405)|0) < 0;
      if ($35406) { __label__ = 8164; break; } else { __label__ = 8165; break; }
    case 8164: // $35407
      var $35408=HEAP32[(($2467)>>2)];
      ___cxa_call_unexpected($35408);
      throw "Reached an unreachable!"
    case 8165: // $35409
      var $35410=HEAP32[(($2467)>>2)];
      var $35411=HEAP32[(($2467)>>2)];
      var $35412=HEAP32[(($2468)>>2)];
      var $35413=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35411, tempValue);
      var $35414=($35413.f1 = $35412, $35413);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8166: // $35415
      throw "Reached an unreachable!"
    case 8167: // $_ZnwjPKci_exit888
      var $35416=HEAP32[(($result_i887)>>2)];
      var $35417=$2464;
      var $35418=$2465;
      var $35419=$2466;
      var $35420=$result_i887;
      var $35421=$2467;
      var $35422=$2468;
      var $35423=$35416;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9301, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8168; break; } else { __label__ = 13901; break; }
    case 8168: // $35424
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9302, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8169; break; } else { __label__ = 13901; break; }
    case 8169: // $35425
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9303, 4, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8170; break; } else { __label__ = 13901; break; }
    case 8170: // $35426
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8171; break; } else { __label__ = 13901; break; }
    case 8171: // $35427
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8172; break; } else { __label__ = 13901; break; }
    case 8172: // $35428
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8173; break; } else { __label__ = 13901; break; }
    case 8173: // $35429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8174; break; } else { __label__ = 13901; break; }
    case 8174: // $35430
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9300, $9301, $9302, $9303, $9304, $9305, $9306, $9307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8175; break; } else { __label__ = 13901; break; }
    case 8175: // $35431
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9309, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8176; break; } else { __label__ = 13901; break; }
    case 8176: // $35432
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9310, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8177; break; } else { __label__ = 13901; break; }
    case 8177: // $35433
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9311, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8178; break; } else { __label__ = 13901; break; }
    case 8178: // $35434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8179; break; } else { __label__ = 13901; break; }
    case 8179: // $35435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8180; break; } else { __label__ = 13901; break; }
    case 8180: // $35436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8181; break; } else { __label__ = 13901; break; }
    case 8181: // $35437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8182; break; } else { __label__ = 13901; break; }
    case 8182: // $35438
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9308, $9309, $9310, $9311, $9312, $9313, $9314, $9315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8183; break; } else { __label__ = 13901; break; }
    case 8183: // $35439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9317, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8184; break; } else { __label__ = 13901; break; }
    case 8184: // $35440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9318, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8185; break; } else { __label__ = 13901; break; }
    case 8185: // $35441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9319, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8186; break; } else { __label__ = 13901; break; }
    case 8186: // $35442
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8187; break; } else { __label__ = 13901; break; }
    case 8187: // $35443
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8188; break; } else { __label__ = 13901; break; }
    case 8188: // $35444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8189; break; } else { __label__ = 13901; break; }
    case 8189: // $35445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8190; break; } else { __label__ = 13901; break; }
    case 8190: // $35446
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9316, $9317, $9318, $9319, $9320, $9321, $9322, $9323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8191; break; } else { __label__ = 13901; break; }
    case 8191: // $35447
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35423, 153, 3, 2, ((STRING_TABLE.__str1078)|0), ((STRING_TABLE.__str1079422)|0), $9300, $9308, $9316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8192; break; } else { __label__ = 13901; break; }
    case 8192: // $35448
      var $35449=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35423);
      var $35450=__ZN11simple_listI16input_type_entryE6appendERS0_($35384, $35449);
      var $35451=$4689;
      var $35452=$2459;
      var $35453=$2460;
      var $35454=$2461;
      var $35455=$result_i889;
      var $35456=$2462;
      var $35457=$2463;
      HEAP32[(($2459)>>2)]=408;
      HEAP32[(($2460)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2461)>>2)]=520;
      var $35458=HEAP32[(($2459)>>2)];
      var $35459=HEAP32[(($2460)>>2)];
      var $35460=HEAP32[(($2461)>>2)];
      var $35461=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35458, $35459, $35460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8193; break; } else { __label__ = 8195; break; };
    case 8193: // $35462
      HEAP32[(($result_i889)>>2)]=$35461;
      var $35463=HEAP32[(($result_i889)>>2)];
      var $35464=(($35463)|0)==0;
      if ($35464) { __label__ = 8194; break; } else { __label__ = 8199; break; }
    case 8194: // $35465
      var $35466=___cxa_allocate_exception(4);
      var $35467=$35466;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35467);
      (function() { try { __THREW__ = false; return ___cxa_throw($35466, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8198; break; } else { __label__ = 8195; break; }
    case 8195: // $35468
      var $35469=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35470=$35469.f0;
      HEAP32[(($2462)>>2)]=$35470;
      var $35471=$35469.f1;
      HEAP32[(($2463)>>2)]=$35471;
      var $35472=HEAP32[(($2463)>>2)];
      var $35473=(($35472)|0) < 0;
      if ($35473) { __label__ = 8196; break; } else { __label__ = 8197; break; }
    case 8196: // $35474
      var $35475=HEAP32[(($2462)>>2)];
      ___cxa_call_unexpected($35475);
      throw "Reached an unreachable!"
    case 8197: // $35476
      var $35477=HEAP32[(($2462)>>2)];
      var $35478=HEAP32[(($2462)>>2)];
      var $35479=HEAP32[(($2463)>>2)];
      var $35480=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35478, tempValue);
      var $35481=($35480.f1 = $35479, $35480);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8198: // $35482
      throw "Reached an unreachable!"
    case 8199: // $_ZnwjPKci_exit890
      var $35483=HEAP32[(($result_i889)>>2)];
      var $35484=$2459;
      var $35485=$2460;
      var $35486=$2461;
      var $35487=$result_i889;
      var $35488=$2462;
      var $35489=$2463;
      var $35490=$35483;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9325, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8200; break; } else { __label__ = 13906; break; }
    case 8200: // $35491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9326, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8201; break; } else { __label__ = 13906; break; }
    case 8201: // $35492
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9327, 4, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8202; break; } else { __label__ = 13906; break; }
    case 8202: // $35493
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8203; break; } else { __label__ = 13906; break; }
    case 8203: // $35494
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8204; break; } else { __label__ = 13906; break; }
    case 8204: // $35495
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8205; break; } else { __label__ = 13906; break; }
    case 8205: // $35496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8206; break; } else { __label__ = 13906; break; }
    case 8206: // $35497
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9324, $9325, $9326, $9327, $9328, $9329, $9330, $9331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8207; break; } else { __label__ = 13906; break; }
    case 8207: // $35498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9333, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8208; break; } else { __label__ = 13906; break; }
    case 8208: // $35499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9334, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8209; break; } else { __label__ = 13906; break; }
    case 8209: // $35500
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9335, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8210; break; } else { __label__ = 13906; break; }
    case 8210: // $35501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8211; break; } else { __label__ = 13906; break; }
    case 8211: // $35502
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8212; break; } else { __label__ = 13906; break; }
    case 8212: // $35503
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8213; break; } else { __label__ = 13906; break; }
    case 8213: // $35504
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8214; break; } else { __label__ = 13906; break; }
    case 8214: // $35505
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9332, $9333, $9334, $9335, $9336, $9337, $9338, $9339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8215; break; } else { __label__ = 13906; break; }
    case 8215: // $35506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9341, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8216; break; } else { __label__ = 13906; break; }
    case 8216: // $35507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9342, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8217; break; } else { __label__ = 13906; break; }
    case 8217: // $35508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9343, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8218; break; } else { __label__ = 13906; break; }
    case 8218: // $35509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8219; break; } else { __label__ = 13906; break; }
    case 8219: // $35510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8220; break; } else { __label__ = 13906; break; }
    case 8220: // $35511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8221; break; } else { __label__ = 13906; break; }
    case 8221: // $35512
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8222; break; } else { __label__ = 13906; break; }
    case 8222: // $35513
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9340, $9341, $9342, $9343, $9344, $9345, $9346, $9347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8223; break; } else { __label__ = 13906; break; }
    case 8223: // $35514
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35490, 153, 4, 3, ((STRING_TABLE.__str1080)|0), ((STRING_TABLE.__str1081)|0), $9324, $9332, $9340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8224; break; } else { __label__ = 13906; break; }
    case 8224: // $35515
      var $35516=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35490);
      var $35517=__ZN11simple_listI16input_type_entryE6appendERS0_($35451, $35516);
      var $35518=$4689;
      var $35519=$2454;
      var $35520=$2455;
      var $35521=$2456;
      var $35522=$result_i891;
      var $35523=$2457;
      var $35524=$2458;
      HEAP32[(($2454)>>2)]=408;
      HEAP32[(($2455)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2456)>>2)]=521;
      var $35525=HEAP32[(($2454)>>2)];
      var $35526=HEAP32[(($2455)>>2)];
      var $35527=HEAP32[(($2456)>>2)];
      var $35528=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35525, $35526, $35527) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8225; break; } else { __label__ = 8227; break; };
    case 8225: // $35529
      HEAP32[(($result_i891)>>2)]=$35528;
      var $35530=HEAP32[(($result_i891)>>2)];
      var $35531=(($35530)|0)==0;
      if ($35531) { __label__ = 8226; break; } else { __label__ = 8231; break; }
    case 8226: // $35532
      var $35533=___cxa_allocate_exception(4);
      var $35534=$35533;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35534);
      (function() { try { __THREW__ = false; return ___cxa_throw($35533, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8230; break; } else { __label__ = 8227; break; }
    case 8227: // $35535
      var $35536=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35537=$35536.f0;
      HEAP32[(($2457)>>2)]=$35537;
      var $35538=$35536.f1;
      HEAP32[(($2458)>>2)]=$35538;
      var $35539=HEAP32[(($2458)>>2)];
      var $35540=(($35539)|0) < 0;
      if ($35540) { __label__ = 8228; break; } else { __label__ = 8229; break; }
    case 8228: // $35541
      var $35542=HEAP32[(($2457)>>2)];
      ___cxa_call_unexpected($35542);
      throw "Reached an unreachable!"
    case 8229: // $35543
      var $35544=HEAP32[(($2457)>>2)];
      var $35545=HEAP32[(($2457)>>2)];
      var $35546=HEAP32[(($2458)>>2)];
      var $35547=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35545, tempValue);
      var $35548=($35547.f1 = $35546, $35547);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8230: // $35549
      throw "Reached an unreachable!"
    case 8231: // $_ZnwjPKci_exit892
      var $35550=HEAP32[(($result_i891)>>2)];
      var $35551=$2454;
      var $35552=$2455;
      var $35553=$2456;
      var $35554=$result_i891;
      var $35555=$2457;
      var $35556=$2458;
      var $35557=$35550;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9349, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8232; break; } else { __label__ = 13911; break; }
    case 8232: // $35558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9350, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8233; break; } else { __label__ = 13911; break; }
    case 8233: // $35559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9351, 4, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8234; break; } else { __label__ = 13911; break; }
    case 8234: // $35560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8235; break; } else { __label__ = 13911; break; }
    case 8235: // $35561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8236; break; } else { __label__ = 13911; break; }
    case 8236: // $35562
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8237; break; } else { __label__ = 13911; break; }
    case 8237: // $35563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8238; break; } else { __label__ = 13911; break; }
    case 8238: // $35564
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9348, $9349, $9350, $9351, $9352, $9353, $9354, $9355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8239; break; } else { __label__ = 13911; break; }
    case 8239: // $35565
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9357, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8240; break; } else { __label__ = 13911; break; }
    case 8240: // $35566
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9358, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8241; break; } else { __label__ = 13911; break; }
    case 8241: // $35567
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9359, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8242; break; } else { __label__ = 13911; break; }
    case 8242: // $35568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8243; break; } else { __label__ = 13911; break; }
    case 8243: // $35569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8244; break; } else { __label__ = 13911; break; }
    case 8244: // $35570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8245; break; } else { __label__ = 13911; break; }
    case 8245: // $35571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8246; break; } else { __label__ = 13911; break; }
    case 8246: // $35572
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9356, $9357, $9358, $9359, $9360, $9361, $9362, $9363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8247; break; } else { __label__ = 13911; break; }
    case 8247: // $35573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9365, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8248; break; } else { __label__ = 13911; break; }
    case 8248: // $35574
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9366, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8249; break; } else { __label__ = 13911; break; }
    case 8249: // $35575
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9367, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8250; break; } else { __label__ = 13911; break; }
    case 8250: // $35576
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8251; break; } else { __label__ = 13911; break; }
    case 8251: // $35577
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8252; break; } else { __label__ = 13911; break; }
    case 8252: // $35578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8253; break; } else { __label__ = 13911; break; }
    case 8253: // $35579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8254; break; } else { __label__ = 13911; break; }
    case 8254: // $35580
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9364, $9365, $9366, $9367, $9368, $9369, $9370, $9371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8255; break; } else { __label__ = 13911; break; }
    case 8255: // $35581
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35557, 153, 5, 4, ((STRING_TABLE.__str1082)|0), ((STRING_TABLE.__str1083)|0), $9348, $9356, $9364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8256; break; } else { __label__ = 13911; break; }
    case 8256: // $35582
      var $35583=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35557);
      var $35584=__ZN11simple_listI16input_type_entryE6appendERS0_($35518, $35583);
      var $35585=$4689;
      var $35586=$2449;
      var $35587=$2450;
      var $35588=$2451;
      var $35589=$result_i893;
      var $35590=$2452;
      var $35591=$2453;
      HEAP32[(($2449)>>2)]=408;
      HEAP32[(($2450)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2451)>>2)]=522;
      var $35592=HEAP32[(($2449)>>2)];
      var $35593=HEAP32[(($2450)>>2)];
      var $35594=HEAP32[(($2451)>>2)];
      var $35595=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35592, $35593, $35594) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8257; break; } else { __label__ = 8259; break; };
    case 8257: // $35596
      HEAP32[(($result_i893)>>2)]=$35595;
      var $35597=HEAP32[(($result_i893)>>2)];
      var $35598=(($35597)|0)==0;
      if ($35598) { __label__ = 8258; break; } else { __label__ = 8263; break; }
    case 8258: // $35599
      var $35600=___cxa_allocate_exception(4);
      var $35601=$35600;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35601);
      (function() { try { __THREW__ = false; return ___cxa_throw($35600, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8262; break; } else { __label__ = 8259; break; }
    case 8259: // $35602
      var $35603=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35604=$35603.f0;
      HEAP32[(($2452)>>2)]=$35604;
      var $35605=$35603.f1;
      HEAP32[(($2453)>>2)]=$35605;
      var $35606=HEAP32[(($2453)>>2)];
      var $35607=(($35606)|0) < 0;
      if ($35607) { __label__ = 8260; break; } else { __label__ = 8261; break; }
    case 8260: // $35608
      var $35609=HEAP32[(($2452)>>2)];
      ___cxa_call_unexpected($35609);
      throw "Reached an unreachable!"
    case 8261: // $35610
      var $35611=HEAP32[(($2452)>>2)];
      var $35612=HEAP32[(($2452)>>2)];
      var $35613=HEAP32[(($2453)>>2)];
      var $35614=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35612, tempValue);
      var $35615=($35614.f1 = $35613, $35614);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8262: // $35616
      throw "Reached an unreachable!"
    case 8263: // $_ZnwjPKci_exit894
      var $35617=HEAP32[(($result_i893)>>2)];
      var $35618=$2449;
      var $35619=$2450;
      var $35620=$2451;
      var $35621=$result_i893;
      var $35622=$2452;
      var $35623=$2453;
      var $35624=$35617;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9373, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8264; break; } else { __label__ = 13916; break; }
    case 8264: // $35625
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9374, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8265; break; } else { __label__ = 13916; break; }
    case 8265: // $35626
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9375, 4, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8266; break; } else { __label__ = 13916; break; }
    case 8266: // $35627
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8267; break; } else { __label__ = 13916; break; }
    case 8267: // $35628
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8268; break; } else { __label__ = 13916; break; }
    case 8268: // $35629
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8269; break; } else { __label__ = 13916; break; }
    case 8269: // $35630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8270; break; } else { __label__ = 13916; break; }
    case 8270: // $35631
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9372, $9373, $9374, $9375, $9376, $9377, $9378, $9379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8271; break; } else { __label__ = 13916; break; }
    case 8271: // $35632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9381, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8272; break; } else { __label__ = 13916; break; }
    case 8272: // $35633
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8273; break; } else { __label__ = 13916; break; }
    case 8273: // $35634
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8274; break; } else { __label__ = 13916; break; }
    case 8274: // $35635
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8275; break; } else { __label__ = 13916; break; }
    case 8275: // $35636
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8276; break; } else { __label__ = 13916; break; }
    case 8276: // $35637
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8277; break; } else { __label__ = 13916; break; }
    case 8277: // $35638
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8278; break; } else { __label__ = 13916; break; }
    case 8278: // $35639
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9380, $9381, $9382, $9383, $9384, $9385, $9386, $9387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8279; break; } else { __label__ = 13916; break; }
    case 8279: // $35640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9389, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8280; break; } else { __label__ = 13916; break; }
    case 8280: // $35641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9390, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8281; break; } else { __label__ = 13916; break; }
    case 8281: // $35642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9391, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8282; break; } else { __label__ = 13916; break; }
    case 8282: // $35643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8283; break; } else { __label__ = 13916; break; }
    case 8283: // $35644
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8284; break; } else { __label__ = 13916; break; }
    case 8284: // $35645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8285; break; } else { __label__ = 13916; break; }
    case 8285: // $35646
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8286; break; } else { __label__ = 13916; break; }
    case 8286: // $35647
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9388, $9389, $9390, $9391, $9392, $9393, $9394, $9395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8287; break; } else { __label__ = 13916; break; }
    case 8287: // $35648
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35624, 153, 6, 5, ((STRING_TABLE.__str1084)|0), ((STRING_TABLE.__str1085)|0), $9372, $9380, $9388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8288; break; } else { __label__ = 13916; break; }
    case 8288: // $35649
      var $35650=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35624);
      var $35651=__ZN11simple_listI16input_type_entryE6appendERS0_($35585, $35650);
      var $35652=$4689;
      var $35653=$2444;
      var $35654=$2445;
      var $35655=$2446;
      var $35656=$result_i895;
      var $35657=$2447;
      var $35658=$2448;
      HEAP32[(($2444)>>2)]=408;
      HEAP32[(($2445)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2446)>>2)]=523;
      var $35659=HEAP32[(($2444)>>2)];
      var $35660=HEAP32[(($2445)>>2)];
      var $35661=HEAP32[(($2446)>>2)];
      var $35662=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35659, $35660, $35661) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8289; break; } else { __label__ = 8291; break; };
    case 8289: // $35663
      HEAP32[(($result_i895)>>2)]=$35662;
      var $35664=HEAP32[(($result_i895)>>2)];
      var $35665=(($35664)|0)==0;
      if ($35665) { __label__ = 8290; break; } else { __label__ = 8295; break; }
    case 8290: // $35666
      var $35667=___cxa_allocate_exception(4);
      var $35668=$35667;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35668);
      (function() { try { __THREW__ = false; return ___cxa_throw($35667, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8294; break; } else { __label__ = 8291; break; }
    case 8291: // $35669
      var $35670=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35671=$35670.f0;
      HEAP32[(($2447)>>2)]=$35671;
      var $35672=$35670.f1;
      HEAP32[(($2448)>>2)]=$35672;
      var $35673=HEAP32[(($2448)>>2)];
      var $35674=(($35673)|0) < 0;
      if ($35674) { __label__ = 8292; break; } else { __label__ = 8293; break; }
    case 8292: // $35675
      var $35676=HEAP32[(($2447)>>2)];
      ___cxa_call_unexpected($35676);
      throw "Reached an unreachable!"
    case 8293: // $35677
      var $35678=HEAP32[(($2447)>>2)];
      var $35679=HEAP32[(($2447)>>2)];
      var $35680=HEAP32[(($2448)>>2)];
      var $35681=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35679, tempValue);
      var $35682=($35681.f1 = $35680, $35681);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8294: // $35683
      throw "Reached an unreachable!"
    case 8295: // $_ZnwjPKci_exit896
      var $35684=HEAP32[(($result_i895)>>2)];
      var $35685=$2444;
      var $35686=$2445;
      var $35687=$2446;
      var $35688=$result_i895;
      var $35689=$2447;
      var $35690=$2448;
      var $35691=$35684;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9397, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8296; break; } else { __label__ = 13921; break; }
    case 8296: // $35692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9398, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8297; break; } else { __label__ = 13921; break; }
    case 8297: // $35693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9399, 4, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8298; break; } else { __label__ = 13921; break; }
    case 8298: // $35694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8299; break; } else { __label__ = 13921; break; }
    case 8299: // $35695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8300; break; } else { __label__ = 13921; break; }
    case 8300: // $35696
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8301; break; } else { __label__ = 13921; break; }
    case 8301: // $35697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8302; break; } else { __label__ = 13921; break; }
    case 8302: // $35698
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9396, $9397, $9398, $9399, $9400, $9401, $9402, $9403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8303; break; } else { __label__ = 13921; break; }
    case 8303: // $35699
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9405, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8304; break; } else { __label__ = 13921; break; }
    case 8304: // $35700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9406, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8305; break; } else { __label__ = 13921; break; }
    case 8305: // $35701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9407, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8306; break; } else { __label__ = 13921; break; }
    case 8306: // $35702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9408, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8307; break; } else { __label__ = 13921; break; }
    case 8307: // $35703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9409, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8308; break; } else { __label__ = 13921; break; }
    case 8308: // $35704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8309; break; } else { __label__ = 13921; break; }
    case 8309: // $35705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8310; break; } else { __label__ = 13921; break; }
    case 8310: // $35706
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9404, $9405, $9406, $9407, $9408, $9409, $9410, $9411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8311; break; } else { __label__ = 13921; break; }
    case 8311: // $35707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9413, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8312; break; } else { __label__ = 13921; break; }
    case 8312: // $35708
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9414, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8313; break; } else { __label__ = 13921; break; }
    case 8313: // $35709
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9415, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8314; break; } else { __label__ = 13921; break; }
    case 8314: // $35710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8315; break; } else { __label__ = 13921; break; }
    case 8315: // $35711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8316; break; } else { __label__ = 13921; break; }
    case 8316: // $35712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8317; break; } else { __label__ = 13921; break; }
    case 8317: // $35713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8318; break; } else { __label__ = 13921; break; }
    case 8318: // $35714
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9412, $9413, $9414, $9415, $9416, $9417, $9418, $9419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8319; break; } else { __label__ = 13921; break; }
    case 8319: // $35715
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35691, 153, 7, 6, ((STRING_TABLE.__str1086)|0), ((STRING_TABLE.__str1087)|0), $9396, $9404, $9412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8320; break; } else { __label__ = 13921; break; }
    case 8320: // $35716
      var $35717=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35691);
      var $35718=__ZN11simple_listI16input_type_entryE6appendERS0_($35652, $35717);
      var $35719=$4689;
      var $35720=$2439;
      var $35721=$2440;
      var $35722=$2441;
      var $35723=$result_i897;
      var $35724=$2442;
      var $35725=$2443;
      HEAP32[(($2439)>>2)]=408;
      HEAP32[(($2440)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2441)>>2)]=524;
      var $35726=HEAP32[(($2439)>>2)];
      var $35727=HEAP32[(($2440)>>2)];
      var $35728=HEAP32[(($2441)>>2)];
      var $35729=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35726, $35727, $35728) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8321; break; } else { __label__ = 8323; break; };
    case 8321: // $35730
      HEAP32[(($result_i897)>>2)]=$35729;
      var $35731=HEAP32[(($result_i897)>>2)];
      var $35732=(($35731)|0)==0;
      if ($35732) { __label__ = 8322; break; } else { __label__ = 8327; break; }
    case 8322: // $35733
      var $35734=___cxa_allocate_exception(4);
      var $35735=$35734;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35735);
      (function() { try { __THREW__ = false; return ___cxa_throw($35734, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8326; break; } else { __label__ = 8323; break; }
    case 8323: // $35736
      var $35737=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35738=$35737.f0;
      HEAP32[(($2442)>>2)]=$35738;
      var $35739=$35737.f1;
      HEAP32[(($2443)>>2)]=$35739;
      var $35740=HEAP32[(($2443)>>2)];
      var $35741=(($35740)|0) < 0;
      if ($35741) { __label__ = 8324; break; } else { __label__ = 8325; break; }
    case 8324: // $35742
      var $35743=HEAP32[(($2442)>>2)];
      ___cxa_call_unexpected($35743);
      throw "Reached an unreachable!"
    case 8325: // $35744
      var $35745=HEAP32[(($2442)>>2)];
      var $35746=HEAP32[(($2442)>>2)];
      var $35747=HEAP32[(($2443)>>2)];
      var $35748=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35746, tempValue);
      var $35749=($35748.f1 = $35747, $35748);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8326: // $35750
      throw "Reached an unreachable!"
    case 8327: // $_ZnwjPKci_exit898
      var $35751=HEAP32[(($result_i897)>>2)];
      var $35752=$2439;
      var $35753=$2440;
      var $35754=$2441;
      var $35755=$result_i897;
      var $35756=$2442;
      var $35757=$2443;
      var $35758=$35751;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9421, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8328; break; } else { __label__ = 13926; break; }
    case 8328: // $35759
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9422, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8329; break; } else { __label__ = 13926; break; }
    case 8329: // $35760
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9423, 4, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8330; break; } else { __label__ = 13926; break; }
    case 8330: // $35761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8331; break; } else { __label__ = 13926; break; }
    case 8331: // $35762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8332; break; } else { __label__ = 13926; break; }
    case 8332: // $35763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8333; break; } else { __label__ = 13926; break; }
    case 8333: // $35764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8334; break; } else { __label__ = 13926; break; }
    case 8334: // $35765
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9420, $9421, $9422, $9423, $9424, $9425, $9426, $9427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8335; break; } else { __label__ = 13926; break; }
    case 8335: // $35766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9429, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8336; break; } else { __label__ = 13926; break; }
    case 8336: // $35767
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9430, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8337; break; } else { __label__ = 13926; break; }
    case 8337: // $35768
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9431, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8338; break; } else { __label__ = 13926; break; }
    case 8338: // $35769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9432, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8339; break; } else { __label__ = 13926; break; }
    case 8339: // $35770
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9433, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8340; break; } else { __label__ = 13926; break; }
    case 8340: // $35771
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8341; break; } else { __label__ = 13926; break; }
    case 8341: // $35772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8342; break; } else { __label__ = 13926; break; }
    case 8342: // $35773
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9428, $9429, $9430, $9431, $9432, $9433, $9434, $9435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8343; break; } else { __label__ = 13926; break; }
    case 8343: // $35774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9437, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8344; break; } else { __label__ = 13926; break; }
    case 8344: // $35775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9438, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8345; break; } else { __label__ = 13926; break; }
    case 8345: // $35776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9439, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8346; break; } else { __label__ = 13926; break; }
    case 8346: // $35777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8347; break; } else { __label__ = 13926; break; }
    case 8347: // $35778
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8348; break; } else { __label__ = 13926; break; }
    case 8348: // $35779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8349; break; } else { __label__ = 13926; break; }
    case 8349: // $35780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8350; break; } else { __label__ = 13926; break; }
    case 8350: // $35781
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9436, $9437, $9438, $9439, $9440, $9441, $9442, $9443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8351; break; } else { __label__ = 13926; break; }
    case 8351: // $35782
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35758, 153, 8, 7, ((STRING_TABLE.__str1088)|0), ((STRING_TABLE.__str1089)|0), $9420, $9428, $9436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8352; break; } else { __label__ = 13926; break; }
    case 8352: // $35783
      var $35784=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35758);
      var $35785=__ZN11simple_listI16input_type_entryE6appendERS0_($35719, $35784);
      var $35786=$4689;
      var $35787=$2434;
      var $35788=$2435;
      var $35789=$2436;
      var $35790=$result_i899;
      var $35791=$2437;
      var $35792=$2438;
      HEAP32[(($2434)>>2)]=408;
      HEAP32[(($2435)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2436)>>2)]=526;
      var $35793=HEAP32[(($2434)>>2)];
      var $35794=HEAP32[(($2435)>>2)];
      var $35795=HEAP32[(($2436)>>2)];
      var $35796=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35793, $35794, $35795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8353; break; } else { __label__ = 8355; break; };
    case 8353: // $35797
      HEAP32[(($result_i899)>>2)]=$35796;
      var $35798=HEAP32[(($result_i899)>>2)];
      var $35799=(($35798)|0)==0;
      if ($35799) { __label__ = 8354; break; } else { __label__ = 8359; break; }
    case 8354: // $35800
      var $35801=___cxa_allocate_exception(4);
      var $35802=$35801;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35802);
      (function() { try { __THREW__ = false; return ___cxa_throw($35801, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8358; break; } else { __label__ = 8355; break; }
    case 8355: // $35803
      var $35804=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35805=$35804.f0;
      HEAP32[(($2437)>>2)]=$35805;
      var $35806=$35804.f1;
      HEAP32[(($2438)>>2)]=$35806;
      var $35807=HEAP32[(($2438)>>2)];
      var $35808=(($35807)|0) < 0;
      if ($35808) { __label__ = 8356; break; } else { __label__ = 8357; break; }
    case 8356: // $35809
      var $35810=HEAP32[(($2437)>>2)];
      ___cxa_call_unexpected($35810);
      throw "Reached an unreachable!"
    case 8357: // $35811
      var $35812=HEAP32[(($2437)>>2)];
      var $35813=HEAP32[(($2437)>>2)];
      var $35814=HEAP32[(($2438)>>2)];
      var $35815=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35813, tempValue);
      var $35816=($35815.f1 = $35814, $35815);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8358: // $35817
      throw "Reached an unreachable!"
    case 8359: // $_ZnwjPKci_exit900
      var $35818=HEAP32[(($result_i899)>>2)];
      var $35819=$2434;
      var $35820=$2435;
      var $35821=$2436;
      var $35822=$result_i899;
      var $35823=$2437;
      var $35824=$2438;
      var $35825=$35818;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9445, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8360; break; } else { __label__ = 13931; break; }
    case 8360: // $35826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9446, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8361; break; } else { __label__ = 13931; break; }
    case 8361: // $35827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9447, 4, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8362; break; } else { __label__ = 13931; break; }
    case 8362: // $35828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8363; break; } else { __label__ = 13931; break; }
    case 8363: // $35829
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8364; break; } else { __label__ = 13931; break; }
    case 8364: // $35830
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8365; break; } else { __label__ = 13931; break; }
    case 8365: // $35831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8366; break; } else { __label__ = 13931; break; }
    case 8366: // $35832
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9444, $9445, $9446, $9447, $9448, $9449, $9450, $9451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8367; break; } else { __label__ = 13931; break; }
    case 8367: // $35833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9453, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8368; break; } else { __label__ = 13931; break; }
    case 8368: // $35834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9454, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8369; break; } else { __label__ = 13931; break; }
    case 8369: // $35835
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9455, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8370; break; } else { __label__ = 13931; break; }
    case 8370: // $35836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9456, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8371; break; } else { __label__ = 13931; break; }
    case 8371: // $35837
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9457, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8372; break; } else { __label__ = 13931; break; }
    case 8372: // $35838
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8373; break; } else { __label__ = 13931; break; }
    case 8373: // $35839
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8374; break; } else { __label__ = 13931; break; }
    case 8374: // $35840
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9452, $9453, $9454, $9455, $9456, $9457, $9458, $9459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8375; break; } else { __label__ = 13931; break; }
    case 8375: // $35841
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9461, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8376; break; } else { __label__ = 13931; break; }
    case 8376: // $35842
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9462, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8377; break; } else { __label__ = 13931; break; }
    case 8377: // $35843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9463, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8378; break; } else { __label__ = 13931; break; }
    case 8378: // $35844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8379; break; } else { __label__ = 13931; break; }
    case 8379: // $35845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8380; break; } else { __label__ = 13931; break; }
    case 8380: // $35846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8381; break; } else { __label__ = 13931; break; }
    case 8381: // $35847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8382; break; } else { __label__ = 13931; break; }
    case 8382: // $35848
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9460, $9461, $9462, $9463, $9464, $9465, $9466, $9467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8383; break; } else { __label__ = 13931; break; }
    case 8383: // $35849
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35825, 154, 1, 0, ((STRING_TABLE.__str1090)|0), ((STRING_TABLE.__str1091)|0), $9444, $9452, $9460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8384; break; } else { __label__ = 13931; break; }
    case 8384: // $35850
      var $35851=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35825);
      var $35852=__ZN11simple_listI16input_type_entryE6appendERS0_($35786, $35851);
      var $35853=$4689;
      var $35854=$2429;
      var $35855=$2430;
      var $35856=$2431;
      var $35857=$result_i901;
      var $35858=$2432;
      var $35859=$2433;
      HEAP32[(($2429)>>2)]=408;
      HEAP32[(($2430)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2431)>>2)]=527;
      var $35860=HEAP32[(($2429)>>2)];
      var $35861=HEAP32[(($2430)>>2)];
      var $35862=HEAP32[(($2431)>>2)];
      var $35863=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35860, $35861, $35862) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8385; break; } else { __label__ = 8387; break; };
    case 8385: // $35864
      HEAP32[(($result_i901)>>2)]=$35863;
      var $35865=HEAP32[(($result_i901)>>2)];
      var $35866=(($35865)|0)==0;
      if ($35866) { __label__ = 8386; break; } else { __label__ = 8391; break; }
    case 8386: // $35867
      var $35868=___cxa_allocate_exception(4);
      var $35869=$35868;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35869);
      (function() { try { __THREW__ = false; return ___cxa_throw($35868, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8390; break; } else { __label__ = 8387; break; }
    case 8387: // $35870
      var $35871=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35872=$35871.f0;
      HEAP32[(($2432)>>2)]=$35872;
      var $35873=$35871.f1;
      HEAP32[(($2433)>>2)]=$35873;
      var $35874=HEAP32[(($2433)>>2)];
      var $35875=(($35874)|0) < 0;
      if ($35875) { __label__ = 8388; break; } else { __label__ = 8389; break; }
    case 8388: // $35876
      var $35877=HEAP32[(($2432)>>2)];
      ___cxa_call_unexpected($35877);
      throw "Reached an unreachable!"
    case 8389: // $35878
      var $35879=HEAP32[(($2432)>>2)];
      var $35880=HEAP32[(($2432)>>2)];
      var $35881=HEAP32[(($2433)>>2)];
      var $35882=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35880, tempValue);
      var $35883=($35882.f1 = $35881, $35882);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8390: // $35884
      throw "Reached an unreachable!"
    case 8391: // $_ZnwjPKci_exit902
      var $35885=HEAP32[(($result_i901)>>2)];
      var $35886=$2429;
      var $35887=$2430;
      var $35888=$2431;
      var $35889=$result_i901;
      var $35890=$2432;
      var $35891=$2433;
      var $35892=$35885;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9469, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8392; break; } else { __label__ = 13936; break; }
    case 8392: // $35893
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9470, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8393; break; } else { __label__ = 13936; break; }
    case 8393: // $35894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9471, 4, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8394; break; } else { __label__ = 13936; break; }
    case 8394: // $35895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8395; break; } else { __label__ = 13936; break; }
    case 8395: // $35896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8396; break; } else { __label__ = 13936; break; }
    case 8396: // $35897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8397; break; } else { __label__ = 13936; break; }
    case 8397: // $35898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8398; break; } else { __label__ = 13936; break; }
    case 8398: // $35899
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9468, $9469, $9470, $9471, $9472, $9473, $9474, $9475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8399; break; } else { __label__ = 13936; break; }
    case 8399: // $35900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9477, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8400; break; } else { __label__ = 13936; break; }
    case 8400: // $35901
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9478, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8401; break; } else { __label__ = 13936; break; }
    case 8401: // $35902
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9479, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8402; break; } else { __label__ = 13936; break; }
    case 8402: // $35903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9480, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8403; break; } else { __label__ = 13936; break; }
    case 8403: // $35904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9481, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8404; break; } else { __label__ = 13936; break; }
    case 8404: // $35905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8405; break; } else { __label__ = 13936; break; }
    case 8405: // $35906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8406; break; } else { __label__ = 13936; break; }
    case 8406: // $35907
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9476, $9477, $9478, $9479, $9480, $9481, $9482, $9483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8407; break; } else { __label__ = 13936; break; }
    case 8407: // $35908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9485, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8408; break; } else { __label__ = 13936; break; }
    case 8408: // $35909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9486, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8409; break; } else { __label__ = 13936; break; }
    case 8409: // $35910
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9487, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8410; break; } else { __label__ = 13936; break; }
    case 8410: // $35911
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8411; break; } else { __label__ = 13936; break; }
    case 8411: // $35912
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8412; break; } else { __label__ = 13936; break; }
    case 8412: // $35913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8413; break; } else { __label__ = 13936; break; }
    case 8413: // $35914
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8414; break; } else { __label__ = 13936; break; }
    case 8414: // $35915
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9484, $9485, $9486, $9487, $9488, $9489, $9490, $9491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8415; break; } else { __label__ = 13936; break; }
    case 8415: // $35916
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35892, 154, 2, 1, ((STRING_TABLE.__str1092)|0), ((STRING_TABLE.__str1093)|0), $9468, $9476, $9484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8416; break; } else { __label__ = 13936; break; }
    case 8416: // $35917
      var $35918=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35892);
      var $35919=__ZN11simple_listI16input_type_entryE6appendERS0_($35853, $35918);
      var $35920=$4689;
      var $35921=$2424;
      var $35922=$2425;
      var $35923=$2426;
      var $35924=$result_i903;
      var $35925=$2427;
      var $35926=$2428;
      HEAP32[(($2424)>>2)]=408;
      HEAP32[(($2425)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2426)>>2)]=528;
      var $35927=HEAP32[(($2424)>>2)];
      var $35928=HEAP32[(($2425)>>2)];
      var $35929=HEAP32[(($2426)>>2)];
      var $35930=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35927, $35928, $35929) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8417; break; } else { __label__ = 8419; break; };
    case 8417: // $35931
      HEAP32[(($result_i903)>>2)]=$35930;
      var $35932=HEAP32[(($result_i903)>>2)];
      var $35933=(($35932)|0)==0;
      if ($35933) { __label__ = 8418; break; } else { __label__ = 8423; break; }
    case 8418: // $35934
      var $35935=___cxa_allocate_exception(4);
      var $35936=$35935;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35936);
      (function() { try { __THREW__ = false; return ___cxa_throw($35935, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8422; break; } else { __label__ = 8419; break; }
    case 8419: // $35937
      var $35938=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35939=$35938.f0;
      HEAP32[(($2427)>>2)]=$35939;
      var $35940=$35938.f1;
      HEAP32[(($2428)>>2)]=$35940;
      var $35941=HEAP32[(($2428)>>2)];
      var $35942=(($35941)|0) < 0;
      if ($35942) { __label__ = 8420; break; } else { __label__ = 8421; break; }
    case 8420: // $35943
      var $35944=HEAP32[(($2427)>>2)];
      ___cxa_call_unexpected($35944);
      throw "Reached an unreachable!"
    case 8421: // $35945
      var $35946=HEAP32[(($2427)>>2)];
      var $35947=HEAP32[(($2427)>>2)];
      var $35948=HEAP32[(($2428)>>2)];
      var $35949=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35947, tempValue);
      var $35950=($35949.f1 = $35948, $35949);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8422: // $35951
      throw "Reached an unreachable!"
    case 8423: // $_ZnwjPKci_exit904
      var $35952=HEAP32[(($result_i903)>>2)];
      var $35953=$2424;
      var $35954=$2425;
      var $35955=$2426;
      var $35956=$result_i903;
      var $35957=$2427;
      var $35958=$2428;
      var $35959=$35952;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9493, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8424; break; } else { __label__ = 13941; break; }
    case 8424: // $35960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9494, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8425; break; } else { __label__ = 13941; break; }
    case 8425: // $35961
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9495, 4, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8426; break; } else { __label__ = 13941; break; }
    case 8426: // $35962
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8427; break; } else { __label__ = 13941; break; }
    case 8427: // $35963
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8428; break; } else { __label__ = 13941; break; }
    case 8428: // $35964
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8429; break; } else { __label__ = 13941; break; }
    case 8429: // $35965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8430; break; } else { __label__ = 13941; break; }
    case 8430: // $35966
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9492, $9493, $9494, $9495, $9496, $9497, $9498, $9499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8431; break; } else { __label__ = 13941; break; }
    case 8431: // $35967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9501, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8432; break; } else { __label__ = 13941; break; }
    case 8432: // $35968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9502, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8433; break; } else { __label__ = 13941; break; }
    case 8433: // $35969
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9503, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8434; break; } else { __label__ = 13941; break; }
    case 8434: // $35970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9504, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8435; break; } else { __label__ = 13941; break; }
    case 8435: // $35971
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9505, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8436; break; } else { __label__ = 13941; break; }
    case 8436: // $35972
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8437; break; } else { __label__ = 13941; break; }
    case 8437: // $35973
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8438; break; } else { __label__ = 13941; break; }
    case 8438: // $35974
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9500, $9501, $9502, $9503, $9504, $9505, $9506, $9507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8439; break; } else { __label__ = 13941; break; }
    case 8439: // $35975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9509, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8440; break; } else { __label__ = 13941; break; }
    case 8440: // $35976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9510, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8441; break; } else { __label__ = 13941; break; }
    case 8441: // $35977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9511, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8442; break; } else { __label__ = 13941; break; }
    case 8442: // $35978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8443; break; } else { __label__ = 13941; break; }
    case 8443: // $35979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8444; break; } else { __label__ = 13941; break; }
    case 8444: // $35980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8445; break; } else { __label__ = 13941; break; }
    case 8445: // $35981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8446; break; } else { __label__ = 13941; break; }
    case 8446: // $35982
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9508, $9509, $9510, $9511, $9512, $9513, $9514, $9515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8447; break; } else { __label__ = 13941; break; }
    case 8447: // $35983
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($35959, 154, 3, 2, ((STRING_TABLE.__str1094)|0), ((STRING_TABLE.__str1095)|0), $9492, $9500, $9508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8448; break; } else { __label__ = 13941; break; }
    case 8448: // $35984
      var $35985=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $35959);
      var $35986=__ZN11simple_listI16input_type_entryE6appendERS0_($35920, $35985);
      var $35987=$4689;
      var $35988=$2419;
      var $35989=$2420;
      var $35990=$2421;
      var $35991=$result_i905;
      var $35992=$2422;
      var $35993=$2423;
      HEAP32[(($2419)>>2)]=408;
      HEAP32[(($2420)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2421)>>2)]=529;
      var $35994=HEAP32[(($2419)>>2)];
      var $35995=HEAP32[(($2420)>>2)];
      var $35996=HEAP32[(($2421)>>2)];
      var $35997=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($35994, $35995, $35996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8449; break; } else { __label__ = 8451; break; };
    case 8449: // $35998
      HEAP32[(($result_i905)>>2)]=$35997;
      var $35999=HEAP32[(($result_i905)>>2)];
      var $36000=(($35999)|0)==0;
      if ($36000) { __label__ = 8450; break; } else { __label__ = 8455; break; }
    case 8450: // $36001
      var $36002=___cxa_allocate_exception(4);
      var $36003=$36002;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36003);
      (function() { try { __THREW__ = false; return ___cxa_throw($36002, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8454; break; } else { __label__ = 8451; break; }
    case 8451: // $36004
      var $36005=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36006=$36005.f0;
      HEAP32[(($2422)>>2)]=$36006;
      var $36007=$36005.f1;
      HEAP32[(($2423)>>2)]=$36007;
      var $36008=HEAP32[(($2423)>>2)];
      var $36009=(($36008)|0) < 0;
      if ($36009) { __label__ = 8452; break; } else { __label__ = 8453; break; }
    case 8452: // $36010
      var $36011=HEAP32[(($2422)>>2)];
      ___cxa_call_unexpected($36011);
      throw "Reached an unreachable!"
    case 8453: // $36012
      var $36013=HEAP32[(($2422)>>2)];
      var $36014=HEAP32[(($2422)>>2)];
      var $36015=HEAP32[(($2423)>>2)];
      var $36016=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36014, tempValue);
      var $36017=($36016.f1 = $36015, $36016);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8454: // $36018
      throw "Reached an unreachable!"
    case 8455: // $_ZnwjPKci_exit906
      var $36019=HEAP32[(($result_i905)>>2)];
      var $36020=$2419;
      var $36021=$2420;
      var $36022=$2421;
      var $36023=$result_i905;
      var $36024=$2422;
      var $36025=$2423;
      var $36026=$36019;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9517, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8456; break; } else { __label__ = 13946; break; }
    case 8456: // $36027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9518, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8457; break; } else { __label__ = 13946; break; }
    case 8457: // $36028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9519, 4, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8458; break; } else { __label__ = 13946; break; }
    case 8458: // $36029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8459; break; } else { __label__ = 13946; break; }
    case 8459: // $36030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8460; break; } else { __label__ = 13946; break; }
    case 8460: // $36031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8461; break; } else { __label__ = 13946; break; }
    case 8461: // $36032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8462; break; } else { __label__ = 13946; break; }
    case 8462: // $36033
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9516, $9517, $9518, $9519, $9520, $9521, $9522, $9523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8463; break; } else { __label__ = 13946; break; }
    case 8463: // $36034
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9525, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8464; break; } else { __label__ = 13946; break; }
    case 8464: // $36035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9526, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8465; break; } else { __label__ = 13946; break; }
    case 8465: // $36036
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9527, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8466; break; } else { __label__ = 13946; break; }
    case 8466: // $36037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9528, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8467; break; } else { __label__ = 13946; break; }
    case 8467: // $36038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9529, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8468; break; } else { __label__ = 13946; break; }
    case 8468: // $36039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8469; break; } else { __label__ = 13946; break; }
    case 8469: // $36040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8470; break; } else { __label__ = 13946; break; }
    case 8470: // $36041
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9524, $9525, $9526, $9527, $9528, $9529, $9530, $9531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8471; break; } else { __label__ = 13946; break; }
    case 8471: // $36042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9533, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8472; break; } else { __label__ = 13946; break; }
    case 8472: // $36043
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9534, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8473; break; } else { __label__ = 13946; break; }
    case 8473: // $36044
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9535, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8474; break; } else { __label__ = 13946; break; }
    case 8474: // $36045
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8475; break; } else { __label__ = 13946; break; }
    case 8475: // $36046
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8476; break; } else { __label__ = 13946; break; }
    case 8476: // $36047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8477; break; } else { __label__ = 13946; break; }
    case 8477: // $36048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8478; break; } else { __label__ = 13946; break; }
    case 8478: // $36049
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9532, $9533, $9534, $9535, $9536, $9537, $9538, $9539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8479; break; } else { __label__ = 13946; break; }
    case 8479: // $36050
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36026, 154, 4, 3, ((STRING_TABLE.__str1096)|0), ((STRING_TABLE.__str1097)|0), $9516, $9524, $9532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8480; break; } else { __label__ = 13946; break; }
    case 8480: // $36051
      var $36052=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36026);
      var $36053=__ZN11simple_listI16input_type_entryE6appendERS0_($35987, $36052);
      var $36054=$4689;
      var $36055=$2414;
      var $36056=$2415;
      var $36057=$2416;
      var $36058=$result_i907;
      var $36059=$2417;
      var $36060=$2418;
      HEAP32[(($2414)>>2)]=408;
      HEAP32[(($2415)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2416)>>2)]=530;
      var $36061=HEAP32[(($2414)>>2)];
      var $36062=HEAP32[(($2415)>>2)];
      var $36063=HEAP32[(($2416)>>2)];
      var $36064=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36061, $36062, $36063) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8481; break; } else { __label__ = 8483; break; };
    case 8481: // $36065
      HEAP32[(($result_i907)>>2)]=$36064;
      var $36066=HEAP32[(($result_i907)>>2)];
      var $36067=(($36066)|0)==0;
      if ($36067) { __label__ = 8482; break; } else { __label__ = 8487; break; }
    case 8482: // $36068
      var $36069=___cxa_allocate_exception(4);
      var $36070=$36069;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36070);
      (function() { try { __THREW__ = false; return ___cxa_throw($36069, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8486; break; } else { __label__ = 8483; break; }
    case 8483: // $36071
      var $36072=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36073=$36072.f0;
      HEAP32[(($2417)>>2)]=$36073;
      var $36074=$36072.f1;
      HEAP32[(($2418)>>2)]=$36074;
      var $36075=HEAP32[(($2418)>>2)];
      var $36076=(($36075)|0) < 0;
      if ($36076) { __label__ = 8484; break; } else { __label__ = 8485; break; }
    case 8484: // $36077
      var $36078=HEAP32[(($2417)>>2)];
      ___cxa_call_unexpected($36078);
      throw "Reached an unreachable!"
    case 8485: // $36079
      var $36080=HEAP32[(($2417)>>2)];
      var $36081=HEAP32[(($2417)>>2)];
      var $36082=HEAP32[(($2418)>>2)];
      var $36083=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36081, tempValue);
      var $36084=($36083.f1 = $36082, $36083);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8486: // $36085
      throw "Reached an unreachable!"
    case 8487: // $_ZnwjPKci_exit908
      var $36086=HEAP32[(($result_i907)>>2)];
      var $36087=$2414;
      var $36088=$2415;
      var $36089=$2416;
      var $36090=$result_i907;
      var $36091=$2417;
      var $36092=$2418;
      var $36093=$36086;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9541, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8488; break; } else { __label__ = 13951; break; }
    case 8488: // $36094
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9542, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8489; break; } else { __label__ = 13951; break; }
    case 8489: // $36095
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9543, 4, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8490; break; } else { __label__ = 13951; break; }
    case 8490: // $36096
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8491; break; } else { __label__ = 13951; break; }
    case 8491: // $36097
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8492; break; } else { __label__ = 13951; break; }
    case 8492: // $36098
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8493; break; } else { __label__ = 13951; break; }
    case 8493: // $36099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8494; break; } else { __label__ = 13951; break; }
    case 8494: // $36100
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9540, $9541, $9542, $9543, $9544, $9545, $9546, $9547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8495; break; } else { __label__ = 13951; break; }
    case 8495: // $36101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9549, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8496; break; } else { __label__ = 13951; break; }
    case 8496: // $36102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9550, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8497; break; } else { __label__ = 13951; break; }
    case 8497: // $36103
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9551, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8498; break; } else { __label__ = 13951; break; }
    case 8498: // $36104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9552, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8499; break; } else { __label__ = 13951; break; }
    case 8499: // $36105
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9553, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8500; break; } else { __label__ = 13951; break; }
    case 8500: // $36106
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9554, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8501; break; } else { __label__ = 13951; break; }
    case 8501: // $36107
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9555, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8502; break; } else { __label__ = 13951; break; }
    case 8502: // $36108
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9548, $9549, $9550, $9551, $9552, $9553, $9554, $9555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8503; break; } else { __label__ = 13951; break; }
    case 8503: // $36109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9557, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8504; break; } else { __label__ = 13951; break; }
    case 8504: // $36110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9558, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8505; break; } else { __label__ = 13951; break; }
    case 8505: // $36111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9559, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8506; break; } else { __label__ = 13951; break; }
    case 8506: // $36112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9560, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8507; break; } else { __label__ = 13951; break; }
    case 8507: // $36113
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9561, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8508; break; } else { __label__ = 13951; break; }
    case 8508: // $36114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9562, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8509; break; } else { __label__ = 13951; break; }
    case 8509: // $36115
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9563, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8510; break; } else { __label__ = 13951; break; }
    case 8510: // $36116
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9556, $9557, $9558, $9559, $9560, $9561, $9562, $9563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8511; break; } else { __label__ = 13951; break; }
    case 8511: // $36117
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36093, 154, 5, 4, ((STRING_TABLE.__str1098)|0), ((STRING_TABLE.__str1099)|0), $9540, $9548, $9556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8512; break; } else { __label__ = 13951; break; }
    case 8512: // $36118
      var $36119=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36093);
      var $36120=__ZN11simple_listI16input_type_entryE6appendERS0_($36054, $36119);
      var $36121=$4689;
      var $36122=$2409;
      var $36123=$2410;
      var $36124=$2411;
      var $36125=$result_i909;
      var $36126=$2412;
      var $36127=$2413;
      HEAP32[(($2409)>>2)]=408;
      HEAP32[(($2410)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2411)>>2)]=531;
      var $36128=HEAP32[(($2409)>>2)];
      var $36129=HEAP32[(($2410)>>2)];
      var $36130=HEAP32[(($2411)>>2)];
      var $36131=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36128, $36129, $36130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8513; break; } else { __label__ = 8515; break; };
    case 8513: // $36132
      HEAP32[(($result_i909)>>2)]=$36131;
      var $36133=HEAP32[(($result_i909)>>2)];
      var $36134=(($36133)|0)==0;
      if ($36134) { __label__ = 8514; break; } else { __label__ = 8519; break; }
    case 8514: // $36135
      var $36136=___cxa_allocate_exception(4);
      var $36137=$36136;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36137);
      (function() { try { __THREW__ = false; return ___cxa_throw($36136, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8518; break; } else { __label__ = 8515; break; }
    case 8515: // $36138
      var $36139=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36140=$36139.f0;
      HEAP32[(($2412)>>2)]=$36140;
      var $36141=$36139.f1;
      HEAP32[(($2413)>>2)]=$36141;
      var $36142=HEAP32[(($2413)>>2)];
      var $36143=(($36142)|0) < 0;
      if ($36143) { __label__ = 8516; break; } else { __label__ = 8517; break; }
    case 8516: // $36144
      var $36145=HEAP32[(($2412)>>2)];
      ___cxa_call_unexpected($36145);
      throw "Reached an unreachable!"
    case 8517: // $36146
      var $36147=HEAP32[(($2412)>>2)];
      var $36148=HEAP32[(($2412)>>2)];
      var $36149=HEAP32[(($2413)>>2)];
      var $36150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36148, tempValue);
      var $36151=($36150.f1 = $36149, $36150);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8518: // $36152
      throw "Reached an unreachable!"
    case 8519: // $_ZnwjPKci_exit910
      var $36153=HEAP32[(($result_i909)>>2)];
      var $36154=$2409;
      var $36155=$2410;
      var $36156=$2411;
      var $36157=$result_i909;
      var $36158=$2412;
      var $36159=$2413;
      var $36160=$36153;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9565, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8520; break; } else { __label__ = 13956; break; }
    case 8520: // $36161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9566, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8521; break; } else { __label__ = 13956; break; }
    case 8521: // $36162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9567, 4, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8522; break; } else { __label__ = 13956; break; }
    case 8522: // $36163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9568, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8523; break; } else { __label__ = 13956; break; }
    case 8523: // $36164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9569, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8524; break; } else { __label__ = 13956; break; }
    case 8524: // $36165
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8525; break; } else { __label__ = 13956; break; }
    case 8525: // $36166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8526; break; } else { __label__ = 13956; break; }
    case 8526: // $36167
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9564, $9565, $9566, $9567, $9568, $9569, $9570, $9571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8527; break; } else { __label__ = 13956; break; }
    case 8527: // $36168
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9573, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8528; break; } else { __label__ = 13956; break; }
    case 8528: // $36169
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9574, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8529; break; } else { __label__ = 13956; break; }
    case 8529: // $36170
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9575, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8530; break; } else { __label__ = 13956; break; }
    case 8530: // $36171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9576, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8531; break; } else { __label__ = 13956; break; }
    case 8531: // $36172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9577, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8532; break; } else { __label__ = 13956; break; }
    case 8532: // $36173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8533; break; } else { __label__ = 13956; break; }
    case 8533: // $36174
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8534; break; } else { __label__ = 13956; break; }
    case 8534: // $36175
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9572, $9573, $9574, $9575, $9576, $9577, $9578, $9579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8535; break; } else { __label__ = 13956; break; }
    case 8535: // $36176
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9581, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8536; break; } else { __label__ = 13956; break; }
    case 8536: // $36177
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9582, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8537; break; } else { __label__ = 13956; break; }
    case 8537: // $36178
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9583, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8538; break; } else { __label__ = 13956; break; }
    case 8538: // $36179
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8539; break; } else { __label__ = 13956; break; }
    case 8539: // $36180
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8540; break; } else { __label__ = 13956; break; }
    case 8540: // $36181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8541; break; } else { __label__ = 13956; break; }
    case 8541: // $36182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8542; break; } else { __label__ = 13956; break; }
    case 8542: // $36183
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9580, $9581, $9582, $9583, $9584, $9585, $9586, $9587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8543; break; } else { __label__ = 13956; break; }
    case 8543: // $36184
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36160, 154, 6, 5, ((STRING_TABLE.__str1100)|0), ((STRING_TABLE.__str1101)|0), $9564, $9572, $9580) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8544; break; } else { __label__ = 13956; break; }
    case 8544: // $36185
      var $36186=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36160);
      var $36187=__ZN11simple_listI16input_type_entryE6appendERS0_($36121, $36186);
      var $36188=$4689;
      var $36189=$2404;
      var $36190=$2405;
      var $36191=$2406;
      var $36192=$result_i911;
      var $36193=$2407;
      var $36194=$2408;
      HEAP32[(($2404)>>2)]=408;
      HEAP32[(($2405)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2406)>>2)]=532;
      var $36195=HEAP32[(($2404)>>2)];
      var $36196=HEAP32[(($2405)>>2)];
      var $36197=HEAP32[(($2406)>>2)];
      var $36198=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36195, $36196, $36197) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8545; break; } else { __label__ = 8547; break; };
    case 8545: // $36199
      HEAP32[(($result_i911)>>2)]=$36198;
      var $36200=HEAP32[(($result_i911)>>2)];
      var $36201=(($36200)|0)==0;
      if ($36201) { __label__ = 8546; break; } else { __label__ = 8551; break; }
    case 8546: // $36202
      var $36203=___cxa_allocate_exception(4);
      var $36204=$36203;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36204);
      (function() { try { __THREW__ = false; return ___cxa_throw($36203, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8550; break; } else { __label__ = 8547; break; }
    case 8547: // $36205
      var $36206=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36207=$36206.f0;
      HEAP32[(($2407)>>2)]=$36207;
      var $36208=$36206.f1;
      HEAP32[(($2408)>>2)]=$36208;
      var $36209=HEAP32[(($2408)>>2)];
      var $36210=(($36209)|0) < 0;
      if ($36210) { __label__ = 8548; break; } else { __label__ = 8549; break; }
    case 8548: // $36211
      var $36212=HEAP32[(($2407)>>2)];
      ___cxa_call_unexpected($36212);
      throw "Reached an unreachable!"
    case 8549: // $36213
      var $36214=HEAP32[(($2407)>>2)];
      var $36215=HEAP32[(($2407)>>2)];
      var $36216=HEAP32[(($2408)>>2)];
      var $36217=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36215, tempValue);
      var $36218=($36217.f1 = $36216, $36217);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8550: // $36219
      throw "Reached an unreachable!"
    case 8551: // $_ZnwjPKci_exit912
      var $36220=HEAP32[(($result_i911)>>2)];
      var $36221=$2404;
      var $36222=$2405;
      var $36223=$2406;
      var $36224=$result_i911;
      var $36225=$2407;
      var $36226=$2408;
      var $36227=$36220;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9589, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8552; break; } else { __label__ = 13961; break; }
    case 8552: // $36228
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9590, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8553; break; } else { __label__ = 13961; break; }
    case 8553: // $36229
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9591, 4, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8554; break; } else { __label__ = 13961; break; }
    case 8554: // $36230
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8555; break; } else { __label__ = 13961; break; }
    case 8555: // $36231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8556; break; } else { __label__ = 13961; break; }
    case 8556: // $36232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8557; break; } else { __label__ = 13961; break; }
    case 8557: // $36233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8558; break; } else { __label__ = 13961; break; }
    case 8558: // $36234
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9588, $9589, $9590, $9591, $9592, $9593, $9594, $9595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8559; break; } else { __label__ = 13961; break; }
    case 8559: // $36235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9597, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8560; break; } else { __label__ = 13961; break; }
    case 8560: // $36236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9598, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8561; break; } else { __label__ = 13961; break; }
    case 8561: // $36237
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9599, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8562; break; } else { __label__ = 13961; break; }
    case 8562: // $36238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9600, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8563; break; } else { __label__ = 13961; break; }
    case 8563: // $36239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9601, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8564; break; } else { __label__ = 13961; break; }
    case 8564: // $36240
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8565; break; } else { __label__ = 13961; break; }
    case 8565: // $36241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8566; break; } else { __label__ = 13961; break; }
    case 8566: // $36242
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9596, $9597, $9598, $9599, $9600, $9601, $9602, $9603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8567; break; } else { __label__ = 13961; break; }
    case 8567: // $36243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9605, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8568; break; } else { __label__ = 13961; break; }
    case 8568: // $36244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9606, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8569; break; } else { __label__ = 13961; break; }
    case 8569: // $36245
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9607, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8570; break; } else { __label__ = 13961; break; }
    case 8570: // $36246
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8571; break; } else { __label__ = 13961; break; }
    case 8571: // $36247
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8572; break; } else { __label__ = 13961; break; }
    case 8572: // $36248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8573; break; } else { __label__ = 13961; break; }
    case 8573: // $36249
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8574; break; } else { __label__ = 13961; break; }
    case 8574: // $36250
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9604, $9605, $9606, $9607, $9608, $9609, $9610, $9611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8575; break; } else { __label__ = 13961; break; }
    case 8575: // $36251
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36227, 154, 7, 6, ((STRING_TABLE.__str1102)|0), ((STRING_TABLE.__str1103)|0), $9588, $9596, $9604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8576; break; } else { __label__ = 13961; break; }
    case 8576: // $36252
      var $36253=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36227);
      var $36254=__ZN11simple_listI16input_type_entryE6appendERS0_($36188, $36253);
      var $36255=$4689;
      var $36256=$2399;
      var $36257=$2400;
      var $36258=$2401;
      var $36259=$result_i913;
      var $36260=$2402;
      var $36261=$2403;
      HEAP32[(($2399)>>2)]=408;
      HEAP32[(($2400)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2401)>>2)]=533;
      var $36262=HEAP32[(($2399)>>2)];
      var $36263=HEAP32[(($2400)>>2)];
      var $36264=HEAP32[(($2401)>>2)];
      var $36265=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36262, $36263, $36264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8577; break; } else { __label__ = 8579; break; };
    case 8577: // $36266
      HEAP32[(($result_i913)>>2)]=$36265;
      var $36267=HEAP32[(($result_i913)>>2)];
      var $36268=(($36267)|0)==0;
      if ($36268) { __label__ = 8578; break; } else { __label__ = 8583; break; }
    case 8578: // $36269
      var $36270=___cxa_allocate_exception(4);
      var $36271=$36270;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36271);
      (function() { try { __THREW__ = false; return ___cxa_throw($36270, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8582; break; } else { __label__ = 8579; break; }
    case 8579: // $36272
      var $36273=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36274=$36273.f0;
      HEAP32[(($2402)>>2)]=$36274;
      var $36275=$36273.f1;
      HEAP32[(($2403)>>2)]=$36275;
      var $36276=HEAP32[(($2403)>>2)];
      var $36277=(($36276)|0) < 0;
      if ($36277) { __label__ = 8580; break; } else { __label__ = 8581; break; }
    case 8580: // $36278
      var $36279=HEAP32[(($2402)>>2)];
      ___cxa_call_unexpected($36279);
      throw "Reached an unreachable!"
    case 8581: // $36280
      var $36281=HEAP32[(($2402)>>2)];
      var $36282=HEAP32[(($2402)>>2)];
      var $36283=HEAP32[(($2403)>>2)];
      var $36284=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36282, tempValue);
      var $36285=($36284.f1 = $36283, $36284);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8582: // $36286
      throw "Reached an unreachable!"
    case 8583: // $_ZnwjPKci_exit914
      var $36287=HEAP32[(($result_i913)>>2)];
      var $36288=$2399;
      var $36289=$2400;
      var $36290=$2401;
      var $36291=$result_i913;
      var $36292=$2402;
      var $36293=$2403;
      var $36294=$36287;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9613, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8584; break; } else { __label__ = 13966; break; }
    case 8584: // $36295
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9614, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8585; break; } else { __label__ = 13966; break; }
    case 8585: // $36296
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9615, 4, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8586; break; } else { __label__ = 13966; break; }
    case 8586: // $36297
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8587; break; } else { __label__ = 13966; break; }
    case 8587: // $36298
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8588; break; } else { __label__ = 13966; break; }
    case 8588: // $36299
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8589; break; } else { __label__ = 13966; break; }
    case 8589: // $36300
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8590; break; } else { __label__ = 13966; break; }
    case 8590: // $36301
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9612, $9613, $9614, $9615, $9616, $9617, $9618, $9619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8591; break; } else { __label__ = 13966; break; }
    case 8591: // $36302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9621, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8592; break; } else { __label__ = 13966; break; }
    case 8592: // $36303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9622, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8593; break; } else { __label__ = 13966; break; }
    case 8593: // $36304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9623, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8594; break; } else { __label__ = 13966; break; }
    case 8594: // $36305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9624, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8595; break; } else { __label__ = 13966; break; }
    case 8595: // $36306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9625, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8596; break; } else { __label__ = 13966; break; }
    case 8596: // $36307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8597; break; } else { __label__ = 13966; break; }
    case 8597: // $36308
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8598; break; } else { __label__ = 13966; break; }
    case 8598: // $36309
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9620, $9621, $9622, $9623, $9624, $9625, $9626, $9627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8599; break; } else { __label__ = 13966; break; }
    case 8599: // $36310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9629, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8600; break; } else { __label__ = 13966; break; }
    case 8600: // $36311
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9630, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8601; break; } else { __label__ = 13966; break; }
    case 8601: // $36312
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9631, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8602; break; } else { __label__ = 13966; break; }
    case 8602: // $36313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8603; break; } else { __label__ = 13966; break; }
    case 8603: // $36314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8604; break; } else { __label__ = 13966; break; }
    case 8604: // $36315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8605; break; } else { __label__ = 13966; break; }
    case 8605: // $36316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8606; break; } else { __label__ = 13966; break; }
    case 8606: // $36317
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9628, $9629, $9630, $9631, $9632, $9633, $9634, $9635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8607; break; } else { __label__ = 13966; break; }
    case 8607: // $36318
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36294, 154, 8, 7, ((STRING_TABLE.__str1104)|0), ((STRING_TABLE.__str1105)|0), $9612, $9620, $9628) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8608; break; } else { __label__ = 13966; break; }
    case 8608: // $36319
      var $36320=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36294);
      var $36321=__ZN11simple_listI16input_type_entryE6appendERS0_($36255, $36320);
      var $36322=$4689;
      var $36323=$2394;
      var $36324=$2395;
      var $36325=$2396;
      var $36326=$result_i915;
      var $36327=$2397;
      var $36328=$2398;
      HEAP32[(($2394)>>2)]=408;
      HEAP32[(($2395)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2396)>>2)]=535;
      var $36329=HEAP32[(($2394)>>2)];
      var $36330=HEAP32[(($2395)>>2)];
      var $36331=HEAP32[(($2396)>>2)];
      var $36332=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36329, $36330, $36331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8609; break; } else { __label__ = 8611; break; };
    case 8609: // $36333
      HEAP32[(($result_i915)>>2)]=$36332;
      var $36334=HEAP32[(($result_i915)>>2)];
      var $36335=(($36334)|0)==0;
      if ($36335) { __label__ = 8610; break; } else { __label__ = 8615; break; }
    case 8610: // $36336
      var $36337=___cxa_allocate_exception(4);
      var $36338=$36337;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36338);
      (function() { try { __THREW__ = false; return ___cxa_throw($36337, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8614; break; } else { __label__ = 8611; break; }
    case 8611: // $36339
      var $36340=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36341=$36340.f0;
      HEAP32[(($2397)>>2)]=$36341;
      var $36342=$36340.f1;
      HEAP32[(($2398)>>2)]=$36342;
      var $36343=HEAP32[(($2398)>>2)];
      var $36344=(($36343)|0) < 0;
      if ($36344) { __label__ = 8612; break; } else { __label__ = 8613; break; }
    case 8612: // $36345
      var $36346=HEAP32[(($2397)>>2)];
      ___cxa_call_unexpected($36346);
      throw "Reached an unreachable!"
    case 8613: // $36347
      var $36348=HEAP32[(($2397)>>2)];
      var $36349=HEAP32[(($2397)>>2)];
      var $36350=HEAP32[(($2398)>>2)];
      var $36351=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36349, tempValue);
      var $36352=($36351.f1 = $36350, $36351);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8614: // $36353
      throw "Reached an unreachable!"
    case 8615: // $_ZnwjPKci_exit916
      var $36354=HEAP32[(($result_i915)>>2)];
      var $36355=$2394;
      var $36356=$2395;
      var $36357=$2396;
      var $36358=$result_i915;
      var $36359=$2397;
      var $36360=$2398;
      var $36361=$36354;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9637, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8616; break; } else { __label__ = 13971; break; }
    case 8616: // $36362
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9638, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8617; break; } else { __label__ = 13971; break; }
    case 8617: // $36363
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9639, 4, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8618; break; } else { __label__ = 13971; break; }
    case 8618: // $36364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8619; break; } else { __label__ = 13971; break; }
    case 8619: // $36365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8620; break; } else { __label__ = 13971; break; }
    case 8620: // $36366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8621; break; } else { __label__ = 13971; break; }
    case 8621: // $36367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8622; break; } else { __label__ = 13971; break; }
    case 8622: // $36368
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9636, $9637, $9638, $9639, $9640, $9641, $9642, $9643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8623; break; } else { __label__ = 13971; break; }
    case 8623: // $36369
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9645, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8624; break; } else { __label__ = 13971; break; }
    case 8624: // $36370
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9646, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8625; break; } else { __label__ = 13971; break; }
    case 8625: // $36371
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9647, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8626; break; } else { __label__ = 13971; break; }
    case 8626: // $36372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9648, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8627; break; } else { __label__ = 13971; break; }
    case 8627: // $36373
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9649, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8628; break; } else { __label__ = 13971; break; }
    case 8628: // $36374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8629; break; } else { __label__ = 13971; break; }
    case 8629: // $36375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8630; break; } else { __label__ = 13971; break; }
    case 8630: // $36376
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9644, $9645, $9646, $9647, $9648, $9649, $9650, $9651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8631; break; } else { __label__ = 13971; break; }
    case 8631: // $36377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9653, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8632; break; } else { __label__ = 13971; break; }
    case 8632: // $36378
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9654, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8633; break; } else { __label__ = 13971; break; }
    case 8633: // $36379
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9655, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8634; break; } else { __label__ = 13971; break; }
    case 8634: // $36380
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8635; break; } else { __label__ = 13971; break; }
    case 8635: // $36381
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8636; break; } else { __label__ = 13971; break; }
    case 8636: // $36382
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8637; break; } else { __label__ = 13971; break; }
    case 8637: // $36383
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8638; break; } else { __label__ = 13971; break; }
    case 8638: // $36384
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9652, $9653, $9654, $9655, $9656, $9657, $9658, $9659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8639; break; } else { __label__ = 13971; break; }
    case 8639: // $36385
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36361, 155, 1, 0, ((STRING_TABLE.__str1106)|0), ((STRING_TABLE.__str1107)|0), $9636, $9644, $9652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8640; break; } else { __label__ = 13971; break; }
    case 8640: // $36386
      var $36387=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36361);
      var $36388=__ZN11simple_listI16input_type_entryE6appendERS0_($36322, $36387);
      var $36389=$4689;
      var $36390=$2389;
      var $36391=$2390;
      var $36392=$2391;
      var $36393=$result_i917;
      var $36394=$2392;
      var $36395=$2393;
      HEAP32[(($2389)>>2)]=408;
      HEAP32[(($2390)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2391)>>2)]=536;
      var $36396=HEAP32[(($2389)>>2)];
      var $36397=HEAP32[(($2390)>>2)];
      var $36398=HEAP32[(($2391)>>2)];
      var $36399=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36396, $36397, $36398) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8641; break; } else { __label__ = 8643; break; };
    case 8641: // $36400
      HEAP32[(($result_i917)>>2)]=$36399;
      var $36401=HEAP32[(($result_i917)>>2)];
      var $36402=(($36401)|0)==0;
      if ($36402) { __label__ = 8642; break; } else { __label__ = 8647; break; }
    case 8642: // $36403
      var $36404=___cxa_allocate_exception(4);
      var $36405=$36404;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36405);
      (function() { try { __THREW__ = false; return ___cxa_throw($36404, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8646; break; } else { __label__ = 8643; break; }
    case 8643: // $36406
      var $36407=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36408=$36407.f0;
      HEAP32[(($2392)>>2)]=$36408;
      var $36409=$36407.f1;
      HEAP32[(($2393)>>2)]=$36409;
      var $36410=HEAP32[(($2393)>>2)];
      var $36411=(($36410)|0) < 0;
      if ($36411) { __label__ = 8644; break; } else { __label__ = 8645; break; }
    case 8644: // $36412
      var $36413=HEAP32[(($2392)>>2)];
      ___cxa_call_unexpected($36413);
      throw "Reached an unreachable!"
    case 8645: // $36414
      var $36415=HEAP32[(($2392)>>2)];
      var $36416=HEAP32[(($2392)>>2)];
      var $36417=HEAP32[(($2393)>>2)];
      var $36418=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36416, tempValue);
      var $36419=($36418.f1 = $36417, $36418);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8646: // $36420
      throw "Reached an unreachable!"
    case 8647: // $_ZnwjPKci_exit918
      var $36421=HEAP32[(($result_i917)>>2)];
      var $36422=$2389;
      var $36423=$2390;
      var $36424=$2391;
      var $36425=$result_i917;
      var $36426=$2392;
      var $36427=$2393;
      var $36428=$36421;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9661, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8648; break; } else { __label__ = 13976; break; }
    case 8648: // $36429
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9662, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8649; break; } else { __label__ = 13976; break; }
    case 8649: // $36430
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9663, 4, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8650; break; } else { __label__ = 13976; break; }
    case 8650: // $36431
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8651; break; } else { __label__ = 13976; break; }
    case 8651: // $36432
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8652; break; } else { __label__ = 13976; break; }
    case 8652: // $36433
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8653; break; } else { __label__ = 13976; break; }
    case 8653: // $36434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8654; break; } else { __label__ = 13976; break; }
    case 8654: // $36435
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9660, $9661, $9662, $9663, $9664, $9665, $9666, $9667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8655; break; } else { __label__ = 13976; break; }
    case 8655: // $36436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9669, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8656; break; } else { __label__ = 13976; break; }
    case 8656: // $36437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9670, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8657; break; } else { __label__ = 13976; break; }
    case 8657: // $36438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9671, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8658; break; } else { __label__ = 13976; break; }
    case 8658: // $36439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9672, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8659; break; } else { __label__ = 13976; break; }
    case 8659: // $36440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9673, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8660; break; } else { __label__ = 13976; break; }
    case 8660: // $36441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8661; break; } else { __label__ = 13976; break; }
    case 8661: // $36442
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8662; break; } else { __label__ = 13976; break; }
    case 8662: // $36443
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9668, $9669, $9670, $9671, $9672, $9673, $9674, $9675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8663; break; } else { __label__ = 13976; break; }
    case 8663: // $36444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9677, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8664; break; } else { __label__ = 13976; break; }
    case 8664: // $36445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9678, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8665; break; } else { __label__ = 13976; break; }
    case 8665: // $36446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9679, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8666; break; } else { __label__ = 13976; break; }
    case 8666: // $36447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8667; break; } else { __label__ = 13976; break; }
    case 8667: // $36448
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8668; break; } else { __label__ = 13976; break; }
    case 8668: // $36449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8669; break; } else { __label__ = 13976; break; }
    case 8669: // $36450
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8670; break; } else { __label__ = 13976; break; }
    case 8670: // $36451
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9676, $9677, $9678, $9679, $9680, $9681, $9682, $9683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8671; break; } else { __label__ = 13976; break; }
    case 8671: // $36452
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36428, 155, 2, 1, ((STRING_TABLE.__str1108)|0), ((STRING_TABLE.__str1109)|0), $9660, $9668, $9676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8672; break; } else { __label__ = 13976; break; }
    case 8672: // $36453
      var $36454=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36428);
      var $36455=__ZN11simple_listI16input_type_entryE6appendERS0_($36389, $36454);
      var $36456=$4689;
      var $36457=$2384;
      var $36458=$2385;
      var $36459=$2386;
      var $36460=$result_i919;
      var $36461=$2387;
      var $36462=$2388;
      HEAP32[(($2384)>>2)]=408;
      HEAP32[(($2385)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2386)>>2)]=537;
      var $36463=HEAP32[(($2384)>>2)];
      var $36464=HEAP32[(($2385)>>2)];
      var $36465=HEAP32[(($2386)>>2)];
      var $36466=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36463, $36464, $36465) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8673; break; } else { __label__ = 8675; break; };
    case 8673: // $36467
      HEAP32[(($result_i919)>>2)]=$36466;
      var $36468=HEAP32[(($result_i919)>>2)];
      var $36469=(($36468)|0)==0;
      if ($36469) { __label__ = 8674; break; } else { __label__ = 8679; break; }
    case 8674: // $36470
      var $36471=___cxa_allocate_exception(4);
      var $36472=$36471;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36472);
      (function() { try { __THREW__ = false; return ___cxa_throw($36471, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8678; break; } else { __label__ = 8675; break; }
    case 8675: // $36473
      var $36474=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36475=$36474.f0;
      HEAP32[(($2387)>>2)]=$36475;
      var $36476=$36474.f1;
      HEAP32[(($2388)>>2)]=$36476;
      var $36477=HEAP32[(($2388)>>2)];
      var $36478=(($36477)|0) < 0;
      if ($36478) { __label__ = 8676; break; } else { __label__ = 8677; break; }
    case 8676: // $36479
      var $36480=HEAP32[(($2387)>>2)];
      ___cxa_call_unexpected($36480);
      throw "Reached an unreachable!"
    case 8677: // $36481
      var $36482=HEAP32[(($2387)>>2)];
      var $36483=HEAP32[(($2387)>>2)];
      var $36484=HEAP32[(($2388)>>2)];
      var $36485=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36483, tempValue);
      var $36486=($36485.f1 = $36484, $36485);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8678: // $36487
      throw "Reached an unreachable!"
    case 8679: // $_ZnwjPKci_exit920
      var $36488=HEAP32[(($result_i919)>>2)];
      var $36489=$2384;
      var $36490=$2385;
      var $36491=$2386;
      var $36492=$result_i919;
      var $36493=$2387;
      var $36494=$2388;
      var $36495=$36488;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9685, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8680; break; } else { __label__ = 13981; break; }
    case 8680: // $36496
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9686, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8681; break; } else { __label__ = 13981; break; }
    case 8681: // $36497
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9687, 4, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8682; break; } else { __label__ = 13981; break; }
    case 8682: // $36498
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9688, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8683; break; } else { __label__ = 13981; break; }
    case 8683: // $36499
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9689, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8684; break; } else { __label__ = 13981; break; }
    case 8684: // $36500
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9690, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8685; break; } else { __label__ = 13981; break; }
    case 8685: // $36501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9691, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8686; break; } else { __label__ = 13981; break; }
    case 8686: // $36502
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9684, $9685, $9686, $9687, $9688, $9689, $9690, $9691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8687; break; } else { __label__ = 13981; break; }
    case 8687: // $36503
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9693, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8688; break; } else { __label__ = 13981; break; }
    case 8688: // $36504
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9694, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8689; break; } else { __label__ = 13981; break; }
    case 8689: // $36505
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9695, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8690; break; } else { __label__ = 13981; break; }
    case 8690: // $36506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9696, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8691; break; } else { __label__ = 13981; break; }
    case 8691: // $36507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9697, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8692; break; } else { __label__ = 13981; break; }
    case 8692: // $36508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8693; break; } else { __label__ = 13981; break; }
    case 8693: // $36509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8694; break; } else { __label__ = 13981; break; }
    case 8694: // $36510
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9692, $9693, $9694, $9695, $9696, $9697, $9698, $9699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8695; break; } else { __label__ = 13981; break; }
    case 8695: // $36511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9701, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8696; break; } else { __label__ = 13981; break; }
    case 8696: // $36512
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9702, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8697; break; } else { __label__ = 13981; break; }
    case 8697: // $36513
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9703, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8698; break; } else { __label__ = 13981; break; }
    case 8698: // $36514
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8699; break; } else { __label__ = 13981; break; }
    case 8699: // $36515
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8700; break; } else { __label__ = 13981; break; }
    case 8700: // $36516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8701; break; } else { __label__ = 13981; break; }
    case 8701: // $36517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8702; break; } else { __label__ = 13981; break; }
    case 8702: // $36518
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9700, $9701, $9702, $9703, $9704, $9705, $9706, $9707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8703; break; } else { __label__ = 13981; break; }
    case 8703: // $36519
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36495, 155, 3, 2, ((STRING_TABLE.__str1110)|0), ((STRING_TABLE.__str1111)|0), $9684, $9692, $9700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8704; break; } else { __label__ = 13981; break; }
    case 8704: // $36520
      var $36521=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36495);
      var $36522=__ZN11simple_listI16input_type_entryE6appendERS0_($36456, $36521);
      var $36523=$4689;
      var $36524=$2379;
      var $36525=$2380;
      var $36526=$2381;
      var $36527=$result_i921;
      var $36528=$2382;
      var $36529=$2383;
      HEAP32[(($2379)>>2)]=408;
      HEAP32[(($2380)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2381)>>2)]=538;
      var $36530=HEAP32[(($2379)>>2)];
      var $36531=HEAP32[(($2380)>>2)];
      var $36532=HEAP32[(($2381)>>2)];
      var $36533=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36530, $36531, $36532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8705; break; } else { __label__ = 8707; break; };
    case 8705: // $36534
      HEAP32[(($result_i921)>>2)]=$36533;
      var $36535=HEAP32[(($result_i921)>>2)];
      var $36536=(($36535)|0)==0;
      if ($36536) { __label__ = 8706; break; } else { __label__ = 8711; break; }
    case 8706: // $36537
      var $36538=___cxa_allocate_exception(4);
      var $36539=$36538;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36539);
      (function() { try { __THREW__ = false; return ___cxa_throw($36538, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8710; break; } else { __label__ = 8707; break; }
    case 8707: // $36540
      var $36541=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36542=$36541.f0;
      HEAP32[(($2382)>>2)]=$36542;
      var $36543=$36541.f1;
      HEAP32[(($2383)>>2)]=$36543;
      var $36544=HEAP32[(($2383)>>2)];
      var $36545=(($36544)|0) < 0;
      if ($36545) { __label__ = 8708; break; } else { __label__ = 8709; break; }
    case 8708: // $36546
      var $36547=HEAP32[(($2382)>>2)];
      ___cxa_call_unexpected($36547);
      throw "Reached an unreachable!"
    case 8709: // $36548
      var $36549=HEAP32[(($2382)>>2)];
      var $36550=HEAP32[(($2382)>>2)];
      var $36551=HEAP32[(($2383)>>2)];
      var $36552=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36550, tempValue);
      var $36553=($36552.f1 = $36551, $36552);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8710: // $36554
      throw "Reached an unreachable!"
    case 8711: // $_ZnwjPKci_exit922
      var $36555=HEAP32[(($result_i921)>>2)];
      var $36556=$2379;
      var $36557=$2380;
      var $36558=$2381;
      var $36559=$result_i921;
      var $36560=$2382;
      var $36561=$2383;
      var $36562=$36555;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9709, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8712; break; } else { __label__ = 13986; break; }
    case 8712: // $36563
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9710, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8713; break; } else { __label__ = 13986; break; }
    case 8713: // $36564
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9711, 4, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8714; break; } else { __label__ = 13986; break; }
    case 8714: // $36565
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8715; break; } else { __label__ = 13986; break; }
    case 8715: // $36566
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8716; break; } else { __label__ = 13986; break; }
    case 8716: // $36567
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8717; break; } else { __label__ = 13986; break; }
    case 8717: // $36568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8718; break; } else { __label__ = 13986; break; }
    case 8718: // $36569
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9708, $9709, $9710, $9711, $9712, $9713, $9714, $9715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8719; break; } else { __label__ = 13986; break; }
    case 8719: // $36570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9717, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8720; break; } else { __label__ = 13986; break; }
    case 8720: // $36571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9718, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8721; break; } else { __label__ = 13986; break; }
    case 8721: // $36572
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9719, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8722; break; } else { __label__ = 13986; break; }
    case 8722: // $36573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9720, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8723; break; } else { __label__ = 13986; break; }
    case 8723: // $36574
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9721, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8724; break; } else { __label__ = 13986; break; }
    case 8724: // $36575
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8725; break; } else { __label__ = 13986; break; }
    case 8725: // $36576
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8726; break; } else { __label__ = 13986; break; }
    case 8726: // $36577
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9716, $9717, $9718, $9719, $9720, $9721, $9722, $9723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8727; break; } else { __label__ = 13986; break; }
    case 8727: // $36578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9725, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8728; break; } else { __label__ = 13986; break; }
    case 8728: // $36579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9726, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8729; break; } else { __label__ = 13986; break; }
    case 8729: // $36580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9727, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8730; break; } else { __label__ = 13986; break; }
    case 8730: // $36581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8731; break; } else { __label__ = 13986; break; }
    case 8731: // $36582
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8732; break; } else { __label__ = 13986; break; }
    case 8732: // $36583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8733; break; } else { __label__ = 13986; break; }
    case 8733: // $36584
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8734; break; } else { __label__ = 13986; break; }
    case 8734: // $36585
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9724, $9725, $9726, $9727, $9728, $9729, $9730, $9731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8735; break; } else { __label__ = 13986; break; }
    case 8735: // $36586
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36562, 155, 4, 3, ((STRING_TABLE.__str1112)|0), ((STRING_TABLE.__str1113)|0), $9708, $9716, $9724) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8736; break; } else { __label__ = 13986; break; }
    case 8736: // $36587
      var $36588=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36562);
      var $36589=__ZN11simple_listI16input_type_entryE6appendERS0_($36523, $36588);
      var $36590=$4689;
      var $36591=$2374;
      var $36592=$2375;
      var $36593=$2376;
      var $36594=$result_i923;
      var $36595=$2377;
      var $36596=$2378;
      HEAP32[(($2374)>>2)]=408;
      HEAP32[(($2375)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2376)>>2)]=539;
      var $36597=HEAP32[(($2374)>>2)];
      var $36598=HEAP32[(($2375)>>2)];
      var $36599=HEAP32[(($2376)>>2)];
      var $36600=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36597, $36598, $36599) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8737; break; } else { __label__ = 8739; break; };
    case 8737: // $36601
      HEAP32[(($result_i923)>>2)]=$36600;
      var $36602=HEAP32[(($result_i923)>>2)];
      var $36603=(($36602)|0)==0;
      if ($36603) { __label__ = 8738; break; } else { __label__ = 8743; break; }
    case 8738: // $36604
      var $36605=___cxa_allocate_exception(4);
      var $36606=$36605;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36606);
      (function() { try { __THREW__ = false; return ___cxa_throw($36605, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8742; break; } else { __label__ = 8739; break; }
    case 8739: // $36607
      var $36608=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36609=$36608.f0;
      HEAP32[(($2377)>>2)]=$36609;
      var $36610=$36608.f1;
      HEAP32[(($2378)>>2)]=$36610;
      var $36611=HEAP32[(($2378)>>2)];
      var $36612=(($36611)|0) < 0;
      if ($36612) { __label__ = 8740; break; } else { __label__ = 8741; break; }
    case 8740: // $36613
      var $36614=HEAP32[(($2377)>>2)];
      ___cxa_call_unexpected($36614);
      throw "Reached an unreachable!"
    case 8741: // $36615
      var $36616=HEAP32[(($2377)>>2)];
      var $36617=HEAP32[(($2377)>>2)];
      var $36618=HEAP32[(($2378)>>2)];
      var $36619=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36617, tempValue);
      var $36620=($36619.f1 = $36618, $36619);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8742: // $36621
      throw "Reached an unreachable!"
    case 8743: // $_ZnwjPKci_exit924
      var $36622=HEAP32[(($result_i923)>>2)];
      var $36623=$2374;
      var $36624=$2375;
      var $36625=$2376;
      var $36626=$result_i923;
      var $36627=$2377;
      var $36628=$2378;
      var $36629=$36622;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9733, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8744; break; } else { __label__ = 13991; break; }
    case 8744: // $36630
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9734, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8745; break; } else { __label__ = 13991; break; }
    case 8745: // $36631
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9735, 4, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8746; break; } else { __label__ = 13991; break; }
    case 8746: // $36632
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8747; break; } else { __label__ = 13991; break; }
    case 8747: // $36633
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8748; break; } else { __label__ = 13991; break; }
    case 8748: // $36634
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8749; break; } else { __label__ = 13991; break; }
    case 8749: // $36635
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8750; break; } else { __label__ = 13991; break; }
    case 8750: // $36636
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9732, $9733, $9734, $9735, $9736, $9737, $9738, $9739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8751; break; } else { __label__ = 13991; break; }
    case 8751: // $36637
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9741, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8752; break; } else { __label__ = 13991; break; }
    case 8752: // $36638
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9742, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8753; break; } else { __label__ = 13991; break; }
    case 8753: // $36639
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9743, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8754; break; } else { __label__ = 13991; break; }
    case 8754: // $36640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9744, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8755; break; } else { __label__ = 13991; break; }
    case 8755: // $36641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9745, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8756; break; } else { __label__ = 13991; break; }
    case 8756: // $36642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8757; break; } else { __label__ = 13991; break; }
    case 8757: // $36643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8758; break; } else { __label__ = 13991; break; }
    case 8758: // $36644
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9740, $9741, $9742, $9743, $9744, $9745, $9746, $9747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8759; break; } else { __label__ = 13991; break; }
    case 8759: // $36645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9749, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8760; break; } else { __label__ = 13991; break; }
    case 8760: // $36646
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9750, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8761; break; } else { __label__ = 13991; break; }
    case 8761: // $36647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9751, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8762; break; } else { __label__ = 13991; break; }
    case 8762: // $36648
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8763; break; } else { __label__ = 13991; break; }
    case 8763: // $36649
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8764; break; } else { __label__ = 13991; break; }
    case 8764: // $36650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8765; break; } else { __label__ = 13991; break; }
    case 8765: // $36651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8766; break; } else { __label__ = 13991; break; }
    case 8766: // $36652
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9748, $9749, $9750, $9751, $9752, $9753, $9754, $9755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8767; break; } else { __label__ = 13991; break; }
    case 8767: // $36653
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36629, 155, 5, 4, ((STRING_TABLE.__str1114)|0), ((STRING_TABLE.__str1115)|0), $9732, $9740, $9748) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8768; break; } else { __label__ = 13991; break; }
    case 8768: // $36654
      var $36655=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36629);
      var $36656=__ZN11simple_listI16input_type_entryE6appendERS0_($36590, $36655);
      var $36657=$4689;
      var $36658=$2369;
      var $36659=$2370;
      var $36660=$2371;
      var $36661=$result_i925;
      var $36662=$2372;
      var $36663=$2373;
      HEAP32[(($2369)>>2)]=408;
      HEAP32[(($2370)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2371)>>2)]=540;
      var $36664=HEAP32[(($2369)>>2)];
      var $36665=HEAP32[(($2370)>>2)];
      var $36666=HEAP32[(($2371)>>2)];
      var $36667=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36664, $36665, $36666) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8769; break; } else { __label__ = 8771; break; };
    case 8769: // $36668
      HEAP32[(($result_i925)>>2)]=$36667;
      var $36669=HEAP32[(($result_i925)>>2)];
      var $36670=(($36669)|0)==0;
      if ($36670) { __label__ = 8770; break; } else { __label__ = 8775; break; }
    case 8770: // $36671
      var $36672=___cxa_allocate_exception(4);
      var $36673=$36672;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36673);
      (function() { try { __THREW__ = false; return ___cxa_throw($36672, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8774; break; } else { __label__ = 8771; break; }
    case 8771: // $36674
      var $36675=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36676=$36675.f0;
      HEAP32[(($2372)>>2)]=$36676;
      var $36677=$36675.f1;
      HEAP32[(($2373)>>2)]=$36677;
      var $36678=HEAP32[(($2373)>>2)];
      var $36679=(($36678)|0) < 0;
      if ($36679) { __label__ = 8772; break; } else { __label__ = 8773; break; }
    case 8772: // $36680
      var $36681=HEAP32[(($2372)>>2)];
      ___cxa_call_unexpected($36681);
      throw "Reached an unreachable!"
    case 8773: // $36682
      var $36683=HEAP32[(($2372)>>2)];
      var $36684=HEAP32[(($2372)>>2)];
      var $36685=HEAP32[(($2373)>>2)];
      var $36686=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36684, tempValue);
      var $36687=($36686.f1 = $36685, $36686);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8774: // $36688
      throw "Reached an unreachable!"
    case 8775: // $_ZnwjPKci_exit926
      var $36689=HEAP32[(($result_i925)>>2)];
      var $36690=$2369;
      var $36691=$2370;
      var $36692=$2371;
      var $36693=$result_i925;
      var $36694=$2372;
      var $36695=$2373;
      var $36696=$36689;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9757, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8776; break; } else { __label__ = 13996; break; }
    case 8776: // $36697
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9758, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8777; break; } else { __label__ = 13996; break; }
    case 8777: // $36698
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9759, 4, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8778; break; } else { __label__ = 13996; break; }
    case 8778: // $36699
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8779; break; } else { __label__ = 13996; break; }
    case 8779: // $36700
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8780; break; } else { __label__ = 13996; break; }
    case 8780: // $36701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8781; break; } else { __label__ = 13996; break; }
    case 8781: // $36702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8782; break; } else { __label__ = 13996; break; }
    case 8782: // $36703
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9756, $9757, $9758, $9759, $9760, $9761, $9762, $9763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8783; break; } else { __label__ = 13996; break; }
    case 8783: // $36704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9765, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8784; break; } else { __label__ = 13996; break; }
    case 8784: // $36705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9766, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8785; break; } else { __label__ = 13996; break; }
    case 8785: // $36706
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9767, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8786; break; } else { __label__ = 13996; break; }
    case 8786: // $36707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9768, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8787; break; } else { __label__ = 13996; break; }
    case 8787: // $36708
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9769, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8788; break; } else { __label__ = 13996; break; }
    case 8788: // $36709
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8789; break; } else { __label__ = 13996; break; }
    case 8789: // $36710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8790; break; } else { __label__ = 13996; break; }
    case 8790: // $36711
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9764, $9765, $9766, $9767, $9768, $9769, $9770, $9771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8791; break; } else { __label__ = 13996; break; }
    case 8791: // $36712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9773, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8792; break; } else { __label__ = 13996; break; }
    case 8792: // $36713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9774, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8793; break; } else { __label__ = 13996; break; }
    case 8793: // $36714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9775, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8794; break; } else { __label__ = 13996; break; }
    case 8794: // $36715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8795; break; } else { __label__ = 13996; break; }
    case 8795: // $36716
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8796; break; } else { __label__ = 13996; break; }
    case 8796: // $36717
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8797; break; } else { __label__ = 13996; break; }
    case 8797: // $36718
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8798; break; } else { __label__ = 13996; break; }
    case 8798: // $36719
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9772, $9773, $9774, $9775, $9776, $9777, $9778, $9779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8799; break; } else { __label__ = 13996; break; }
    case 8799: // $36720
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36696, 155, 6, 5, ((STRING_TABLE.__str1116)|0), ((STRING_TABLE.__str1117)|0), $9756, $9764, $9772) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8800; break; } else { __label__ = 13996; break; }
    case 8800: // $36721
      var $36722=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36696);
      var $36723=__ZN11simple_listI16input_type_entryE6appendERS0_($36657, $36722);
      var $36724=$4689;
      var $36725=$2364;
      var $36726=$2365;
      var $36727=$2366;
      var $36728=$result_i927;
      var $36729=$2367;
      var $36730=$2368;
      HEAP32[(($2364)>>2)]=408;
      HEAP32[(($2365)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2366)>>2)]=541;
      var $36731=HEAP32[(($2364)>>2)];
      var $36732=HEAP32[(($2365)>>2)];
      var $36733=HEAP32[(($2366)>>2)];
      var $36734=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36731, $36732, $36733) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8801; break; } else { __label__ = 8803; break; };
    case 8801: // $36735
      HEAP32[(($result_i927)>>2)]=$36734;
      var $36736=HEAP32[(($result_i927)>>2)];
      var $36737=(($36736)|0)==0;
      if ($36737) { __label__ = 8802; break; } else { __label__ = 8807; break; }
    case 8802: // $36738
      var $36739=___cxa_allocate_exception(4);
      var $36740=$36739;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36740);
      (function() { try { __THREW__ = false; return ___cxa_throw($36739, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8806; break; } else { __label__ = 8803; break; }
    case 8803: // $36741
      var $36742=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36743=$36742.f0;
      HEAP32[(($2367)>>2)]=$36743;
      var $36744=$36742.f1;
      HEAP32[(($2368)>>2)]=$36744;
      var $36745=HEAP32[(($2368)>>2)];
      var $36746=(($36745)|0) < 0;
      if ($36746) { __label__ = 8804; break; } else { __label__ = 8805; break; }
    case 8804: // $36747
      var $36748=HEAP32[(($2367)>>2)];
      ___cxa_call_unexpected($36748);
      throw "Reached an unreachable!"
    case 8805: // $36749
      var $36750=HEAP32[(($2367)>>2)];
      var $36751=HEAP32[(($2367)>>2)];
      var $36752=HEAP32[(($2368)>>2)];
      var $36753=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36751, tempValue);
      var $36754=($36753.f1 = $36752, $36753);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8806: // $36755
      throw "Reached an unreachable!"
    case 8807: // $_ZnwjPKci_exit928
      var $36756=HEAP32[(($result_i927)>>2)];
      var $36757=$2364;
      var $36758=$2365;
      var $36759=$2366;
      var $36760=$result_i927;
      var $36761=$2367;
      var $36762=$2368;
      var $36763=$36756;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9781, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8808; break; } else { __label__ = 14001; break; }
    case 8808: // $36764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9782, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8809; break; } else { __label__ = 14001; break; }
    case 8809: // $36765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9783, 4, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8810; break; } else { __label__ = 14001; break; }
    case 8810: // $36766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8811; break; } else { __label__ = 14001; break; }
    case 8811: // $36767
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8812; break; } else { __label__ = 14001; break; }
    case 8812: // $36768
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8813; break; } else { __label__ = 14001; break; }
    case 8813: // $36769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8814; break; } else { __label__ = 14001; break; }
    case 8814: // $36770
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9780, $9781, $9782, $9783, $9784, $9785, $9786, $9787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8815; break; } else { __label__ = 14001; break; }
    case 8815: // $36771
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9789, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8816; break; } else { __label__ = 14001; break; }
    case 8816: // $36772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9790, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8817; break; } else { __label__ = 14001; break; }
    case 8817: // $36773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9791, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8818; break; } else { __label__ = 14001; break; }
    case 8818: // $36774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9792, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8819; break; } else { __label__ = 14001; break; }
    case 8819: // $36775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9793, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8820; break; } else { __label__ = 14001; break; }
    case 8820: // $36776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9794, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8821; break; } else { __label__ = 14001; break; }
    case 8821: // $36777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9795, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8822; break; } else { __label__ = 14001; break; }
    case 8822: // $36778
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9788, $9789, $9790, $9791, $9792, $9793, $9794, $9795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8823; break; } else { __label__ = 14001; break; }
    case 8823: // $36779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9797, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8824; break; } else { __label__ = 14001; break; }
    case 8824: // $36780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9798, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8825; break; } else { __label__ = 14001; break; }
    case 8825: // $36781
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9799, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8826; break; } else { __label__ = 14001; break; }
    case 8826: // $36782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9800, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8827; break; } else { __label__ = 14001; break; }
    case 8827: // $36783
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9801, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8828; break; } else { __label__ = 14001; break; }
    case 8828: // $36784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9802, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8829; break; } else { __label__ = 14001; break; }
    case 8829: // $36785
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9803, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8830; break; } else { __label__ = 14001; break; }
    case 8830: // $36786
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9796, $9797, $9798, $9799, $9800, $9801, $9802, $9803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8831; break; } else { __label__ = 14001; break; }
    case 8831: // $36787
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36763, 155, 7, 6, ((STRING_TABLE.__str1118)|0), ((STRING_TABLE.__str1119)|0), $9780, $9788, $9796) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8832; break; } else { __label__ = 14001; break; }
    case 8832: // $36788
      var $36789=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36763);
      var $36790=__ZN11simple_listI16input_type_entryE6appendERS0_($36724, $36789);
      var $36791=$4689;
      var $36792=$2359;
      var $36793=$2360;
      var $36794=$2361;
      var $36795=$result_i929;
      var $36796=$2362;
      var $36797=$2363;
      HEAP32[(($2359)>>2)]=408;
      HEAP32[(($2360)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2361)>>2)]=542;
      var $36798=HEAP32[(($2359)>>2)];
      var $36799=HEAP32[(($2360)>>2)];
      var $36800=HEAP32[(($2361)>>2)];
      var $36801=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36798, $36799, $36800) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8833; break; } else { __label__ = 8835; break; };
    case 8833: // $36802
      HEAP32[(($result_i929)>>2)]=$36801;
      var $36803=HEAP32[(($result_i929)>>2)];
      var $36804=(($36803)|0)==0;
      if ($36804) { __label__ = 8834; break; } else { __label__ = 8839; break; }
    case 8834: // $36805
      var $36806=___cxa_allocate_exception(4);
      var $36807=$36806;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36807);
      (function() { try { __THREW__ = false; return ___cxa_throw($36806, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8838; break; } else { __label__ = 8835; break; }
    case 8835: // $36808
      var $36809=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36810=$36809.f0;
      HEAP32[(($2362)>>2)]=$36810;
      var $36811=$36809.f1;
      HEAP32[(($2363)>>2)]=$36811;
      var $36812=HEAP32[(($2363)>>2)];
      var $36813=(($36812)|0) < 0;
      if ($36813) { __label__ = 8836; break; } else { __label__ = 8837; break; }
    case 8836: // $36814
      var $36815=HEAP32[(($2362)>>2)];
      ___cxa_call_unexpected($36815);
      throw "Reached an unreachable!"
    case 8837: // $36816
      var $36817=HEAP32[(($2362)>>2)];
      var $36818=HEAP32[(($2362)>>2)];
      var $36819=HEAP32[(($2363)>>2)];
      var $36820=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36818, tempValue);
      var $36821=($36820.f1 = $36819, $36820);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8838: // $36822
      throw "Reached an unreachable!"
    case 8839: // $_ZnwjPKci_exit930
      var $36823=HEAP32[(($result_i929)>>2)];
      var $36824=$2359;
      var $36825=$2360;
      var $36826=$2361;
      var $36827=$result_i929;
      var $36828=$2362;
      var $36829=$2363;
      var $36830=$36823;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9805, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8840; break; } else { __label__ = 14006; break; }
    case 8840: // $36831
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9806, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8841; break; } else { __label__ = 14006; break; }
    case 8841: // $36832
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9807, 4, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8842; break; } else { __label__ = 14006; break; }
    case 8842: // $36833
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9808, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8843; break; } else { __label__ = 14006; break; }
    case 8843: // $36834
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9809, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8844; break; } else { __label__ = 14006; break; }
    case 8844: // $36835
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8845; break; } else { __label__ = 14006; break; }
    case 8845: // $36836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8846; break; } else { __label__ = 14006; break; }
    case 8846: // $36837
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9804, $9805, $9806, $9807, $9808, $9809, $9810, $9811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8847; break; } else { __label__ = 14006; break; }
    case 8847: // $36838
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9813, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8848; break; } else { __label__ = 14006; break; }
    case 8848: // $36839
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9814, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8849; break; } else { __label__ = 14006; break; }
    case 8849: // $36840
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9815, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8850; break; } else { __label__ = 14006; break; }
    case 8850: // $36841
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8851; break; } else { __label__ = 14006; break; }
    case 8851: // $36842
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8852; break; } else { __label__ = 14006; break; }
    case 8852: // $36843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8853; break; } else { __label__ = 14006; break; }
    case 8853: // $36844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8854; break; } else { __label__ = 14006; break; }
    case 8854: // $36845
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9812, $9813, $9814, $9815, $9816, $9817, $9818, $9819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8855; break; } else { __label__ = 14006; break; }
    case 8855: // $36846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9821, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8856; break; } else { __label__ = 14006; break; }
    case 8856: // $36847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9822, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8857; break; } else { __label__ = 14006; break; }
    case 8857: // $36848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9823, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8858; break; } else { __label__ = 14006; break; }
    case 8858: // $36849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8859; break; } else { __label__ = 14006; break; }
    case 8859: // $36850
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8860; break; } else { __label__ = 14006; break; }
    case 8860: // $36851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8861; break; } else { __label__ = 14006; break; }
    case 8861: // $36852
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8862; break; } else { __label__ = 14006; break; }
    case 8862: // $36853
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9820, $9821, $9822, $9823, $9824, $9825, $9826, $9827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8863; break; } else { __label__ = 14006; break; }
    case 8863: // $36854
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36830, 155, 8, 7, ((STRING_TABLE.__str1120)|0), ((STRING_TABLE.__str1121)|0), $9804, $9812, $9820) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8864; break; } else { __label__ = 14006; break; }
    case 8864: // $36855
      var $36856=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36830);
      var $36857=__ZN11simple_listI16input_type_entryE6appendERS0_($36791, $36856);
      var $36858=$4689;
      var $36859=$2354;
      var $36860=$2355;
      var $36861=$2356;
      var $36862=$result_i931;
      var $36863=$2357;
      var $36864=$2358;
      HEAP32[(($2354)>>2)]=408;
      HEAP32[(($2355)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2356)>>2)]=544;
      var $36865=HEAP32[(($2354)>>2)];
      var $36866=HEAP32[(($2355)>>2)];
      var $36867=HEAP32[(($2356)>>2)];
      var $36868=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36865, $36866, $36867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8865; break; } else { __label__ = 8867; break; };
    case 8865: // $36869
      HEAP32[(($result_i931)>>2)]=$36868;
      var $36870=HEAP32[(($result_i931)>>2)];
      var $36871=(($36870)|0)==0;
      if ($36871) { __label__ = 8866; break; } else { __label__ = 8871; break; }
    case 8866: // $36872
      var $36873=___cxa_allocate_exception(4);
      var $36874=$36873;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36874);
      (function() { try { __THREW__ = false; return ___cxa_throw($36873, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8870; break; } else { __label__ = 8867; break; }
    case 8867: // $36875
      var $36876=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36877=$36876.f0;
      HEAP32[(($2357)>>2)]=$36877;
      var $36878=$36876.f1;
      HEAP32[(($2358)>>2)]=$36878;
      var $36879=HEAP32[(($2358)>>2)];
      var $36880=(($36879)|0) < 0;
      if ($36880) { __label__ = 8868; break; } else { __label__ = 8869; break; }
    case 8868: // $36881
      var $36882=HEAP32[(($2357)>>2)];
      ___cxa_call_unexpected($36882);
      throw "Reached an unreachable!"
    case 8869: // $36883
      var $36884=HEAP32[(($2357)>>2)];
      var $36885=HEAP32[(($2357)>>2)];
      var $36886=HEAP32[(($2358)>>2)];
      var $36887=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36885, tempValue);
      var $36888=($36887.f1 = $36886, $36887);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8870: // $36889
      throw "Reached an unreachable!"
    case 8871: // $_ZnwjPKci_exit932
      var $36890=HEAP32[(($result_i931)>>2)];
      var $36891=$2354;
      var $36892=$2355;
      var $36893=$2356;
      var $36894=$result_i931;
      var $36895=$2357;
      var $36896=$2358;
      var $36897=$36890;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9829, 4, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8872; break; } else { __label__ = 14011; break; }
    case 8872: // $36898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9830, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8873; break; } else { __label__ = 14011; break; }
    case 8873: // $36899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9831, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8874; break; } else { __label__ = 14011; break; }
    case 8874: // $36900
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8875; break; } else { __label__ = 14011; break; }
    case 8875: // $36901
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8876; break; } else { __label__ = 14011; break; }
    case 8876: // $36902
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8877; break; } else { __label__ = 14011; break; }
    case 8877: // $36903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8878; break; } else { __label__ = 14011; break; }
    case 8878: // $36904
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9828, $9829, $9830, $9831, $9832, $9833, $9834, $9835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8879; break; } else { __label__ = 14011; break; }
    case 8879: // $36905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9837, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8880; break; } else { __label__ = 14011; break; }
    case 8880: // $36906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9838, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8881; break; } else { __label__ = 14011; break; }
    case 8881: // $36907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9839, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8882; break; } else { __label__ = 14011; break; }
    case 8882: // $36908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8883; break; } else { __label__ = 14011; break; }
    case 8883: // $36909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8884; break; } else { __label__ = 14011; break; }
    case 8884: // $36910
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8885; break; } else { __label__ = 14011; break; }
    case 8885: // $36911
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8886; break; } else { __label__ = 14011; break; }
    case 8886: // $36912
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9836, $9837, $9838, $9839, $9840, $9841, $9842, $9843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8887; break; } else { __label__ = 14011; break; }
    case 8887: // $36913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9845, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8888; break; } else { __label__ = 14011; break; }
    case 8888: // $36914
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9846, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8889; break; } else { __label__ = 14011; break; }
    case 8889: // $36915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9847, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8890; break; } else { __label__ = 14011; break; }
    case 8890: // $36916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8891; break; } else { __label__ = 14011; break; }
    case 8891: // $36917
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8892; break; } else { __label__ = 14011; break; }
    case 8892: // $36918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8893; break; } else { __label__ = 14011; break; }
    case 8893: // $36919
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8894; break; } else { __label__ = 14011; break; }
    case 8894: // $36920
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9844, $9845, $9846, $9847, $9848, $9849, $9850, $9851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8895; break; } else { __label__ = 14011; break; }
    case 8895: // $36921
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36897, 142, 1, 0, ((STRING_TABLE.__str1122423)|0), ((STRING_TABLE.__str1123)|0), $9828, $9836, $9844) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8896; break; } else { __label__ = 14011; break; }
    case 8896: // $36922
      var $36923=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36897);
      var $36924=__ZN11simple_listI16input_type_entryE6appendERS0_($36858, $36923);
      var $36925=$4689;
      var $36926=$2349;
      var $36927=$2350;
      var $36928=$2351;
      var $36929=$result_i933;
      var $36930=$2352;
      var $36931=$2353;
      HEAP32[(($2349)>>2)]=408;
      HEAP32[(($2350)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2351)>>2)]=545;
      var $36932=HEAP32[(($2349)>>2)];
      var $36933=HEAP32[(($2350)>>2)];
      var $36934=HEAP32[(($2351)>>2)];
      var $36935=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36932, $36933, $36934) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8897; break; } else { __label__ = 8899; break; };
    case 8897: // $36936
      HEAP32[(($result_i933)>>2)]=$36935;
      var $36937=HEAP32[(($result_i933)>>2)];
      var $36938=(($36937)|0)==0;
      if ($36938) { __label__ = 8898; break; } else { __label__ = 8903; break; }
    case 8898: // $36939
      var $36940=___cxa_allocate_exception(4);
      var $36941=$36940;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36941);
      (function() { try { __THREW__ = false; return ___cxa_throw($36940, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8902; break; } else { __label__ = 8899; break; }
    case 8899: // $36942
      var $36943=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36944=$36943.f0;
      HEAP32[(($2352)>>2)]=$36944;
      var $36945=$36943.f1;
      HEAP32[(($2353)>>2)]=$36945;
      var $36946=HEAP32[(($2353)>>2)];
      var $36947=(($36946)|0) < 0;
      if ($36947) { __label__ = 8900; break; } else { __label__ = 8901; break; }
    case 8900: // $36948
      var $36949=HEAP32[(($2352)>>2)];
      ___cxa_call_unexpected($36949);
      throw "Reached an unreachable!"
    case 8901: // $36950
      var $36951=HEAP32[(($2352)>>2)];
      var $36952=HEAP32[(($2352)>>2)];
      var $36953=HEAP32[(($2353)>>2)];
      var $36954=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36952, tempValue);
      var $36955=($36954.f1 = $36953, $36954);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8902: // $36956
      throw "Reached an unreachable!"
    case 8903: // $_ZnwjPKci_exit934
      var $36957=HEAP32[(($result_i933)>>2)];
      var $36958=$2349;
      var $36959=$2350;
      var $36960=$2351;
      var $36961=$result_i933;
      var $36962=$2352;
      var $36963=$2353;
      var $36964=$36957;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9853, 4, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8904; break; } else { __label__ = 14016; break; }
    case 8904: // $36965
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9854, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8905; break; } else { __label__ = 14016; break; }
    case 8905: // $36966
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9855, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8906; break; } else { __label__ = 14016; break; }
    case 8906: // $36967
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8907; break; } else { __label__ = 14016; break; }
    case 8907: // $36968
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8908; break; } else { __label__ = 14016; break; }
    case 8908: // $36969
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8909; break; } else { __label__ = 14016; break; }
    case 8909: // $36970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8910; break; } else { __label__ = 14016; break; }
    case 8910: // $36971
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9852, $9853, $9854, $9855, $9856, $9857, $9858, $9859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8911; break; } else { __label__ = 14016; break; }
    case 8911: // $36972
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9861, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8912; break; } else { __label__ = 14016; break; }
    case 8912: // $36973
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9862, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8913; break; } else { __label__ = 14016; break; }
    case 8913: // $36974
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9863, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8914; break; } else { __label__ = 14016; break; }
    case 8914: // $36975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8915; break; } else { __label__ = 14016; break; }
    case 8915: // $36976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8916; break; } else { __label__ = 14016; break; }
    case 8916: // $36977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8917; break; } else { __label__ = 14016; break; }
    case 8917: // $36978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8918; break; } else { __label__ = 14016; break; }
    case 8918: // $36979
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9860, $9861, $9862, $9863, $9864, $9865, $9866, $9867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8919; break; } else { __label__ = 14016; break; }
    case 8919: // $36980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9869, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8920; break; } else { __label__ = 14016; break; }
    case 8920: // $36981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9870, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8921; break; } else { __label__ = 14016; break; }
    case 8921: // $36982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9871, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8922; break; } else { __label__ = 14016; break; }
    case 8922: // $36983
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8923; break; } else { __label__ = 14016; break; }
    case 8923: // $36984
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8924; break; } else { __label__ = 14016; break; }
    case 8924: // $36985
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8925; break; } else { __label__ = 14016; break; }
    case 8925: // $36986
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8926; break; } else { __label__ = 14016; break; }
    case 8926: // $36987
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9868, $9869, $9870, $9871, $9872, $9873, $9874, $9875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8927; break; } else { __label__ = 14016; break; }
    case 8927: // $36988
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($36964, 142, 2, 1, ((STRING_TABLE.__str1124)|0), ((STRING_TABLE.__str1125)|0), $9852, $9860, $9868) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8928; break; } else { __label__ = 14016; break; }
    case 8928: // $36989
      var $36990=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $36964);
      var $36991=__ZN11simple_listI16input_type_entryE6appendERS0_($36925, $36990);
      var $36992=$4689;
      var $36993=$2344;
      var $36994=$2345;
      var $36995=$2346;
      var $36996=$result_i935;
      var $36997=$2347;
      var $36998=$2348;
      HEAP32[(($2344)>>2)]=408;
      HEAP32[(($2345)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2346)>>2)]=546;
      var $36999=HEAP32[(($2344)>>2)];
      var $37000=HEAP32[(($2345)>>2)];
      var $37001=HEAP32[(($2346)>>2)];
      var $37002=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36999, $37000, $37001) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8929; break; } else { __label__ = 8931; break; };
    case 8929: // $37003
      HEAP32[(($result_i935)>>2)]=$37002;
      var $37004=HEAP32[(($result_i935)>>2)];
      var $37005=(($37004)|0)==0;
      if ($37005) { __label__ = 8930; break; } else { __label__ = 8935; break; }
    case 8930: // $37006
      var $37007=___cxa_allocate_exception(4);
      var $37008=$37007;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37008);
      (function() { try { __THREW__ = false; return ___cxa_throw($37007, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8934; break; } else { __label__ = 8931; break; }
    case 8931: // $37009
      var $37010=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37011=$37010.f0;
      HEAP32[(($2347)>>2)]=$37011;
      var $37012=$37010.f1;
      HEAP32[(($2348)>>2)]=$37012;
      var $37013=HEAP32[(($2348)>>2)];
      var $37014=(($37013)|0) < 0;
      if ($37014) { __label__ = 8932; break; } else { __label__ = 8933; break; }
    case 8932: // $37015
      var $37016=HEAP32[(($2347)>>2)];
      ___cxa_call_unexpected($37016);
      throw "Reached an unreachable!"
    case 8933: // $37017
      var $37018=HEAP32[(($2347)>>2)];
      var $37019=HEAP32[(($2347)>>2)];
      var $37020=HEAP32[(($2348)>>2)];
      var $37021=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37019, tempValue);
      var $37022=($37021.f1 = $37020, $37021);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8934: // $37023
      throw "Reached an unreachable!"
    case 8935: // $_ZnwjPKci_exit936
      var $37024=HEAP32[(($result_i935)>>2)];
      var $37025=$2344;
      var $37026=$2345;
      var $37027=$2346;
      var $37028=$result_i935;
      var $37029=$2347;
      var $37030=$2348;
      var $37031=$37024;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9877, 4, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8936; break; } else { __label__ = 14021; break; }
    case 8936: // $37032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9878, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8937; break; } else { __label__ = 14021; break; }
    case 8937: // $37033
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9879, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8938; break; } else { __label__ = 14021; break; }
    case 8938: // $37034
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8939; break; } else { __label__ = 14021; break; }
    case 8939: // $37035
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8940; break; } else { __label__ = 14021; break; }
    case 8940: // $37036
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8941; break; } else { __label__ = 14021; break; }
    case 8941: // $37037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8942; break; } else { __label__ = 14021; break; }
    case 8942: // $37038
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9876, $9877, $9878, $9879, $9880, $9881, $9882, $9883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8943; break; } else { __label__ = 14021; break; }
    case 8943: // $37039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9885, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8944; break; } else { __label__ = 14021; break; }
    case 8944: // $37040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9886, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8945; break; } else { __label__ = 14021; break; }
    case 8945: // $37041
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9887, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8946; break; } else { __label__ = 14021; break; }
    case 8946: // $37042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8947; break; } else { __label__ = 14021; break; }
    case 8947: // $37043
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8948; break; } else { __label__ = 14021; break; }
    case 8948: // $37044
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8949; break; } else { __label__ = 14021; break; }
    case 8949: // $37045
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8950; break; } else { __label__ = 14021; break; }
    case 8950: // $37046
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9884, $9885, $9886, $9887, $9888, $9889, $9890, $9891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8951; break; } else { __label__ = 14021; break; }
    case 8951: // $37047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9893, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8952; break; } else { __label__ = 14021; break; }
    case 8952: // $37048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9894, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8953; break; } else { __label__ = 14021; break; }
    case 8953: // $37049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9895, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8954; break; } else { __label__ = 14021; break; }
    case 8954: // $37050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8955; break; } else { __label__ = 14021; break; }
    case 8955: // $37051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8956; break; } else { __label__ = 14021; break; }
    case 8956: // $37052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8957; break; } else { __label__ = 14021; break; }
    case 8957: // $37053
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8958; break; } else { __label__ = 14021; break; }
    case 8958: // $37054
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9892, $9893, $9894, $9895, $9896, $9897, $9898, $9899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8959; break; } else { __label__ = 14021; break; }
    case 8959: // $37055
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37031, 142, 3, 2, ((STRING_TABLE.__str1126)|0), ((STRING_TABLE.__str1127)|0), $9876, $9884, $9892) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8960; break; } else { __label__ = 14021; break; }
    case 8960: // $37056
      var $37057=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37031);
      var $37058=__ZN11simple_listI16input_type_entryE6appendERS0_($36992, $37057);
      var $37059=$4689;
      var $37060=$2339;
      var $37061=$2340;
      var $37062=$2341;
      var $37063=$result_i937;
      var $37064=$2342;
      var $37065=$2343;
      HEAP32[(($2339)>>2)]=408;
      HEAP32[(($2340)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2341)>>2)]=547;
      var $37066=HEAP32[(($2339)>>2)];
      var $37067=HEAP32[(($2340)>>2)];
      var $37068=HEAP32[(($2341)>>2)];
      var $37069=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37066, $37067, $37068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8961; break; } else { __label__ = 8963; break; };
    case 8961: // $37070
      HEAP32[(($result_i937)>>2)]=$37069;
      var $37071=HEAP32[(($result_i937)>>2)];
      var $37072=(($37071)|0)==0;
      if ($37072) { __label__ = 8962; break; } else { __label__ = 8967; break; }
    case 8962: // $37073
      var $37074=___cxa_allocate_exception(4);
      var $37075=$37074;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37075);
      (function() { try { __THREW__ = false; return ___cxa_throw($37074, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8966; break; } else { __label__ = 8963; break; }
    case 8963: // $37076
      var $37077=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37078=$37077.f0;
      HEAP32[(($2342)>>2)]=$37078;
      var $37079=$37077.f1;
      HEAP32[(($2343)>>2)]=$37079;
      var $37080=HEAP32[(($2343)>>2)];
      var $37081=(($37080)|0) < 0;
      if ($37081) { __label__ = 8964; break; } else { __label__ = 8965; break; }
    case 8964: // $37082
      var $37083=HEAP32[(($2342)>>2)];
      ___cxa_call_unexpected($37083);
      throw "Reached an unreachable!"
    case 8965: // $37084
      var $37085=HEAP32[(($2342)>>2)];
      var $37086=HEAP32[(($2342)>>2)];
      var $37087=HEAP32[(($2343)>>2)];
      var $37088=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37086, tempValue);
      var $37089=($37088.f1 = $37087, $37088);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8966: // $37090
      throw "Reached an unreachable!"
    case 8967: // $_ZnwjPKci_exit938
      var $37091=HEAP32[(($result_i937)>>2)];
      var $37092=$2339;
      var $37093=$2340;
      var $37094=$2341;
      var $37095=$result_i937;
      var $37096=$2342;
      var $37097=$2343;
      var $37098=$37091;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9901, 4, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8968; break; } else { __label__ = 14026; break; }
    case 8968: // $37099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9902, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8969; break; } else { __label__ = 14026; break; }
    case 8969: // $37100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9903, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8970; break; } else { __label__ = 14026; break; }
    case 8970: // $37101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8971; break; } else { __label__ = 14026; break; }
    case 8971: // $37102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8972; break; } else { __label__ = 14026; break; }
    case 8972: // $37103
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8973; break; } else { __label__ = 14026; break; }
    case 8973: // $37104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8974; break; } else { __label__ = 14026; break; }
    case 8974: // $37105
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9900, $9901, $9902, $9903, $9904, $9905, $9906, $9907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8975; break; } else { __label__ = 14026; break; }
    case 8975: // $37106
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9909, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8976; break; } else { __label__ = 14026; break; }
    case 8976: // $37107
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9910, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8977; break; } else { __label__ = 14026; break; }
    case 8977: // $37108
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9911, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8978; break; } else { __label__ = 14026; break; }
    case 8978: // $37109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8979; break; } else { __label__ = 14026; break; }
    case 8979: // $37110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8980; break; } else { __label__ = 14026; break; }
    case 8980: // $37111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8981; break; } else { __label__ = 14026; break; }
    case 8981: // $37112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8982; break; } else { __label__ = 14026; break; }
    case 8982: // $37113
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9908, $9909, $9910, $9911, $9912, $9913, $9914, $9915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8983; break; } else { __label__ = 14026; break; }
    case 8983: // $37114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9917, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8984; break; } else { __label__ = 14026; break; }
    case 8984: // $37115
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9918, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8985; break; } else { __label__ = 14026; break; }
    case 8985: // $37116
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9919, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8986; break; } else { __label__ = 14026; break; }
    case 8986: // $37117
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8987; break; } else { __label__ = 14026; break; }
    case 8987: // $37118
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8988; break; } else { __label__ = 14026; break; }
    case 8988: // $37119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8989; break; } else { __label__ = 14026; break; }
    case 8989: // $37120
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8990; break; } else { __label__ = 14026; break; }
    case 8990: // $37121
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9916, $9917, $9918, $9919, $9920, $9921, $9922, $9923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8991; break; } else { __label__ = 14026; break; }
    case 8991: // $37122
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37098, 142, 4, 3, ((STRING_TABLE.__str1128)|0), ((STRING_TABLE.__str1129)|0), $9900, $9908, $9916) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8992; break; } else { __label__ = 14026; break; }
    case 8992: // $37123
      var $37124=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37098);
      var $37125=__ZN11simple_listI16input_type_entryE6appendERS0_($37059, $37124);
      var $37126=$4689;
      var $37127=$2334;
      var $37128=$2335;
      var $37129=$2336;
      var $37130=$result_i939;
      var $37131=$2337;
      var $37132=$2338;
      HEAP32[(($2334)>>2)]=408;
      HEAP32[(($2335)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2336)>>2)]=548;
      var $37133=HEAP32[(($2334)>>2)];
      var $37134=HEAP32[(($2335)>>2)];
      var $37135=HEAP32[(($2336)>>2)];
      var $37136=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37133, $37134, $37135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8993; break; } else { __label__ = 8995; break; };
    case 8993: // $37137
      HEAP32[(($result_i939)>>2)]=$37136;
      var $37138=HEAP32[(($result_i939)>>2)];
      var $37139=(($37138)|0)==0;
      if ($37139) { __label__ = 8994; break; } else { __label__ = 8999; break; }
    case 8994: // $37140
      var $37141=___cxa_allocate_exception(4);
      var $37142=$37141;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37142);
      (function() { try { __THREW__ = false; return ___cxa_throw($37141, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8998; break; } else { __label__ = 8995; break; }
    case 8995: // $37143
      var $37144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37145=$37144.f0;
      HEAP32[(($2337)>>2)]=$37145;
      var $37146=$37144.f1;
      HEAP32[(($2338)>>2)]=$37146;
      var $37147=HEAP32[(($2338)>>2)];
      var $37148=(($37147)|0) < 0;
      if ($37148) { __label__ = 8996; break; } else { __label__ = 8997; break; }
    case 8996: // $37149
      var $37150=HEAP32[(($2337)>>2)];
      ___cxa_call_unexpected($37150);
      throw "Reached an unreachable!"
    case 8997: // $37151
      var $37152=HEAP32[(($2337)>>2)];
      var $37153=HEAP32[(($2337)>>2)];
      var $37154=HEAP32[(($2338)>>2)];
      var $37155=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37153, tempValue);
      var $37156=($37155.f1 = $37154, $37155);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8998: // $37157
      throw "Reached an unreachable!"
    case 8999: // $_ZnwjPKci_exit940
      var $37158=HEAP32[(($result_i939)>>2)];
      var $37159=$2334;
      var $37160=$2335;
      var $37161=$2336;
      var $37162=$result_i939;
      var $37163=$2337;
      var $37164=$2338;
      var $37165=$37158;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9925, 4, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9000; break; } else { __label__ = 14031; break; }
    case 9000: // $37166
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9926, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9001; break; } else { __label__ = 14031; break; }
    case 9001: // $37167
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9927, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9002; break; } else { __label__ = 14031; break; }
    case 9002: // $37168
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9003; break; } else { __label__ = 14031; break; }
    case 9003: // $37169
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9004; break; } else { __label__ = 14031; break; }
    case 9004: // $37170
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9005; break; } else { __label__ = 14031; break; }
    case 9005: // $37171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9006; break; } else { __label__ = 14031; break; }
    case 9006: // $37172
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9924, $9925, $9926, $9927, $9928, $9929, $9930, $9931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9007; break; } else { __label__ = 14031; break; }
    case 9007: // $37173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9933, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9008; break; } else { __label__ = 14031; break; }
    case 9008: // $37174
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9934, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9009; break; } else { __label__ = 14031; break; }
    case 9009: // $37175
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9935, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9010; break; } else { __label__ = 14031; break; }
    case 9010: // $37176
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9011; break; } else { __label__ = 14031; break; }
    case 9011: // $37177
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9012; break; } else { __label__ = 14031; break; }
    case 9012: // $37178
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9013; break; } else { __label__ = 14031; break; }
    case 9013: // $37179
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9014; break; } else { __label__ = 14031; break; }
    case 9014: // $37180
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9932, $9933, $9934, $9935, $9936, $9937, $9938, $9939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9015; break; } else { __label__ = 14031; break; }
    case 9015: // $37181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9941, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9016; break; } else { __label__ = 14031; break; }
    case 9016: // $37182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9942, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9017; break; } else { __label__ = 14031; break; }
    case 9017: // $37183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9943, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9018; break; } else { __label__ = 14031; break; }
    case 9018: // $37184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9019; break; } else { __label__ = 14031; break; }
    case 9019: // $37185
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9020; break; } else { __label__ = 14031; break; }
    case 9020: // $37186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9021; break; } else { __label__ = 14031; break; }
    case 9021: // $37187
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9022; break; } else { __label__ = 14031; break; }
    case 9022: // $37188
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9940, $9941, $9942, $9943, $9944, $9945, $9946, $9947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9023; break; } else { __label__ = 14031; break; }
    case 9023: // $37189
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37165, 142, 5, 4, ((STRING_TABLE.__str1130)|0), ((STRING_TABLE.__str1131)|0), $9924, $9932, $9940) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9024; break; } else { __label__ = 14031; break; }
    case 9024: // $37190
      var $37191=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37165);
      var $37192=__ZN11simple_listI16input_type_entryE6appendERS0_($37126, $37191);
      var $37193=$4689;
      var $37194=$2329;
      var $37195=$2330;
      var $37196=$2331;
      var $37197=$result_i941;
      var $37198=$2332;
      var $37199=$2333;
      HEAP32[(($2329)>>2)]=408;
      HEAP32[(($2330)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2331)>>2)]=549;
      var $37200=HEAP32[(($2329)>>2)];
      var $37201=HEAP32[(($2330)>>2)];
      var $37202=HEAP32[(($2331)>>2)];
      var $37203=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37200, $37201, $37202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9025; break; } else { __label__ = 9027; break; };
    case 9025: // $37204
      HEAP32[(($result_i941)>>2)]=$37203;
      var $37205=HEAP32[(($result_i941)>>2)];
      var $37206=(($37205)|0)==0;
      if ($37206) { __label__ = 9026; break; } else { __label__ = 9031; break; }
    case 9026: // $37207
      var $37208=___cxa_allocate_exception(4);
      var $37209=$37208;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37209);
      (function() { try { __THREW__ = false; return ___cxa_throw($37208, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9030; break; } else { __label__ = 9027; break; }
    case 9027: // $37210
      var $37211=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37212=$37211.f0;
      HEAP32[(($2332)>>2)]=$37212;
      var $37213=$37211.f1;
      HEAP32[(($2333)>>2)]=$37213;
      var $37214=HEAP32[(($2333)>>2)];
      var $37215=(($37214)|0) < 0;
      if ($37215) { __label__ = 9028; break; } else { __label__ = 9029; break; }
    case 9028: // $37216
      var $37217=HEAP32[(($2332)>>2)];
      ___cxa_call_unexpected($37217);
      throw "Reached an unreachable!"
    case 9029: // $37218
      var $37219=HEAP32[(($2332)>>2)];
      var $37220=HEAP32[(($2332)>>2)];
      var $37221=HEAP32[(($2333)>>2)];
      var $37222=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37220, tempValue);
      var $37223=($37222.f1 = $37221, $37222);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9030: // $37224
      throw "Reached an unreachable!"
    case 9031: // $_ZnwjPKci_exit942
      var $37225=HEAP32[(($result_i941)>>2)];
      var $37226=$2329;
      var $37227=$2330;
      var $37228=$2331;
      var $37229=$result_i941;
      var $37230=$2332;
      var $37231=$2333;
      var $37232=$37225;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9949, 4, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9032; break; } else { __label__ = 14036; break; }
    case 9032: // $37233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9950, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9033; break; } else { __label__ = 14036; break; }
    case 9033: // $37234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9951, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9034; break; } else { __label__ = 14036; break; }
    case 9034: // $37235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9035; break; } else { __label__ = 14036; break; }
    case 9035: // $37236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9036; break; } else { __label__ = 14036; break; }
    case 9036: // $37237
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9037; break; } else { __label__ = 14036; break; }
    case 9037: // $37238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9038; break; } else { __label__ = 14036; break; }
    case 9038: // $37239
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9948, $9949, $9950, $9951, $9952, $9953, $9954, $9955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9039; break; } else { __label__ = 14036; break; }
    case 9039: // $37240
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9957, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9040; break; } else { __label__ = 14036; break; }
    case 9040: // $37241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9041; break; } else { __label__ = 14036; break; }
    case 9041: // $37242
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9042; break; } else { __label__ = 14036; break; }
    case 9042: // $37243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9043; break; } else { __label__ = 14036; break; }
    case 9043: // $37244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9044; break; } else { __label__ = 14036; break; }
    case 9044: // $37245
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9045; break; } else { __label__ = 14036; break; }
    case 9045: // $37246
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9046; break; } else { __label__ = 14036; break; }
    case 9046: // $37247
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9956, $9957, $9958, $9959, $9960, $9961, $9962, $9963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9047; break; } else { __label__ = 14036; break; }
    case 9047: // $37248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9965, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9048; break; } else { __label__ = 14036; break; }
    case 9048: // $37249
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9966, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9049; break; } else { __label__ = 14036; break; }
    case 9049: // $37250
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9967, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9050; break; } else { __label__ = 14036; break; }
    case 9050: // $37251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9051; break; } else { __label__ = 14036; break; }
    case 9051: // $37252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9052; break; } else { __label__ = 14036; break; }
    case 9052: // $37253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9053; break; } else { __label__ = 14036; break; }
    case 9053: // $37254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9054; break; } else { __label__ = 14036; break; }
    case 9054: // $37255
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9964, $9965, $9966, $9967, $9968, $9969, $9970, $9971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9055; break; } else { __label__ = 14036; break; }
    case 9055: // $37256
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37232, 142, 6, 5, ((STRING_TABLE.__str1132)|0), ((STRING_TABLE.__str1133)|0), $9948, $9956, $9964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9056; break; } else { __label__ = 14036; break; }
    case 9056: // $37257
      var $37258=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37232);
      var $37259=__ZN11simple_listI16input_type_entryE6appendERS0_($37193, $37258);
      var $37260=$4689;
      var $37261=$2324;
      var $37262=$2325;
      var $37263=$2326;
      var $37264=$result_i943;
      var $37265=$2327;
      var $37266=$2328;
      HEAP32[(($2324)>>2)]=408;
      HEAP32[(($2325)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2326)>>2)]=550;
      var $37267=HEAP32[(($2324)>>2)];
      var $37268=HEAP32[(($2325)>>2)];
      var $37269=HEAP32[(($2326)>>2)];
      var $37270=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37267, $37268, $37269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9057; break; } else { __label__ = 9059; break; };
    case 9057: // $37271
      HEAP32[(($result_i943)>>2)]=$37270;
      var $37272=HEAP32[(($result_i943)>>2)];
      var $37273=(($37272)|0)==0;
      if ($37273) { __label__ = 9058; break; } else { __label__ = 9063; break; }
    case 9058: // $37274
      var $37275=___cxa_allocate_exception(4);
      var $37276=$37275;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37276);
      (function() { try { __THREW__ = false; return ___cxa_throw($37275, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9062; break; } else { __label__ = 9059; break; }
    case 9059: // $37277
      var $37278=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37279=$37278.f0;
      HEAP32[(($2327)>>2)]=$37279;
      var $37280=$37278.f1;
      HEAP32[(($2328)>>2)]=$37280;
      var $37281=HEAP32[(($2328)>>2)];
      var $37282=(($37281)|0) < 0;
      if ($37282) { __label__ = 9060; break; } else { __label__ = 9061; break; }
    case 9060: // $37283
      var $37284=HEAP32[(($2327)>>2)];
      ___cxa_call_unexpected($37284);
      throw "Reached an unreachable!"
    case 9061: // $37285
      var $37286=HEAP32[(($2327)>>2)];
      var $37287=HEAP32[(($2327)>>2)];
      var $37288=HEAP32[(($2328)>>2)];
      var $37289=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37287, tempValue);
      var $37290=($37289.f1 = $37288, $37289);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9062: // $37291
      throw "Reached an unreachable!"
    case 9063: // $_ZnwjPKci_exit944
      var $37292=HEAP32[(($result_i943)>>2)];
      var $37293=$2324;
      var $37294=$2325;
      var $37295=$2326;
      var $37296=$result_i943;
      var $37297=$2327;
      var $37298=$2328;
      var $37299=$37292;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9973, 4, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9064; break; } else { __label__ = 14041; break; }
    case 9064: // $37300
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9974, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9065; break; } else { __label__ = 14041; break; }
    case 9065: // $37301
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9975, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9066; break; } else { __label__ = 14041; break; }
    case 9066: // $37302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9067; break; } else { __label__ = 14041; break; }
    case 9067: // $37303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9068; break; } else { __label__ = 14041; break; }
    case 9068: // $37304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9069; break; } else { __label__ = 14041; break; }
    case 9069: // $37305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9070; break; } else { __label__ = 14041; break; }
    case 9070: // $37306
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9972, $9973, $9974, $9975, $9976, $9977, $9978, $9979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9071; break; } else { __label__ = 14041; break; }
    case 9071: // $37307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9981, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9072; break; } else { __label__ = 14041; break; }
    case 9072: // $37308
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9073; break; } else { __label__ = 14041; break; }
    case 9073: // $37309
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9074; break; } else { __label__ = 14041; break; }
    case 9074: // $37310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9075; break; } else { __label__ = 14041; break; }
    case 9075: // $37311
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9076; break; } else { __label__ = 14041; break; }
    case 9076: // $37312
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9077; break; } else { __label__ = 14041; break; }
    case 9077: // $37313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9078; break; } else { __label__ = 14041; break; }
    case 9078: // $37314
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9980, $9981, $9982, $9983, $9984, $9985, $9986, $9987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9079; break; } else { __label__ = 14041; break; }
    case 9079: // $37315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9989, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9080; break; } else { __label__ = 14041; break; }
    case 9080: // $37316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9990, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9081; break; } else { __label__ = 14041; break; }
    case 9081: // $37317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9991, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9082; break; } else { __label__ = 14041; break; }
    case 9082: // $37318
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9083; break; } else { __label__ = 14041; break; }
    case 9083: // $37319
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9084; break; } else { __label__ = 14041; break; }
    case 9084: // $37320
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9085; break; } else { __label__ = 14041; break; }
    case 9085: // $37321
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9086; break; } else { __label__ = 14041; break; }
    case 9086: // $37322
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9988, $9989, $9990, $9991, $9992, $9993, $9994, $9995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9087; break; } else { __label__ = 14041; break; }
    case 9087: // $37323
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37299, 142, 7, 6, ((STRING_TABLE.__str1134)|0), ((STRING_TABLE.__str1135)|0), $9972, $9980, $9988) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9088; break; } else { __label__ = 14041; break; }
    case 9088: // $37324
      var $37325=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37299);
      var $37326=__ZN11simple_listI16input_type_entryE6appendERS0_($37260, $37325);
      var $37327=$4689;
      var $37328=$2319;
      var $37329=$2320;
      var $37330=$2321;
      var $37331=$result_i945;
      var $37332=$2322;
      var $37333=$2323;
      HEAP32[(($2319)>>2)]=408;
      HEAP32[(($2320)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2321)>>2)]=551;
      var $37334=HEAP32[(($2319)>>2)];
      var $37335=HEAP32[(($2320)>>2)];
      var $37336=HEAP32[(($2321)>>2)];
      var $37337=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37334, $37335, $37336) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9089; break; } else { __label__ = 9091; break; };
    case 9089: // $37338
      HEAP32[(($result_i945)>>2)]=$37337;
      var $37339=HEAP32[(($result_i945)>>2)];
      var $37340=(($37339)|0)==0;
      if ($37340) { __label__ = 9090; break; } else { __label__ = 9095; break; }
    case 9090: // $37341
      var $37342=___cxa_allocate_exception(4);
      var $37343=$37342;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37343);
      (function() { try { __THREW__ = false; return ___cxa_throw($37342, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9094; break; } else { __label__ = 9091; break; }
    case 9091: // $37344
      var $37345=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37346=$37345.f0;
      HEAP32[(($2322)>>2)]=$37346;
      var $37347=$37345.f1;
      HEAP32[(($2323)>>2)]=$37347;
      var $37348=HEAP32[(($2323)>>2)];
      var $37349=(($37348)|0) < 0;
      if ($37349) { __label__ = 9092; break; } else { __label__ = 9093; break; }
    case 9092: // $37350
      var $37351=HEAP32[(($2322)>>2)];
      ___cxa_call_unexpected($37351);
      throw "Reached an unreachable!"
    case 9093: // $37352
      var $37353=HEAP32[(($2322)>>2)];
      var $37354=HEAP32[(($2322)>>2)];
      var $37355=HEAP32[(($2323)>>2)];
      var $37356=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37354, tempValue);
      var $37357=($37356.f1 = $37355, $37356);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9094: // $37358
      throw "Reached an unreachable!"
    case 9095: // $_ZnwjPKci_exit946
      var $37359=HEAP32[(($result_i945)>>2)];
      var $37360=$2319;
      var $37361=$2320;
      var $37362=$2321;
      var $37363=$result_i945;
      var $37364=$2322;
      var $37365=$2323;
      var $37366=$37359;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9997, 4, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9096; break; } else { __label__ = 14046; break; }
    case 9096: // $37367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($9998, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9097; break; } else { __label__ = 14046; break; }
    case 9097: // $37368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9999, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9098; break; } else { __label__ = 14046; break; }
    case 9098: // $37369
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9099; break; } else { __label__ = 14046; break; }
    case 9099: // $37370
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9100; break; } else { __label__ = 14046; break; }
    case 9100: // $37371
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9101; break; } else { __label__ = 14046; break; }
    case 9101: // $37372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9102; break; } else { __label__ = 14046; break; }
    case 9102: // $37373
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($9996, $9997, $9998, $9999, $10000, $10001, $10002, $10003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9103; break; } else { __label__ = 14046; break; }
    case 9103: // $37374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10005, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9104; break; } else { __label__ = 14046; break; }
    case 9104: // $37375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10006, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9105; break; } else { __label__ = 14046; break; }
    case 9105: // $37376
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10007, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9106; break; } else { __label__ = 14046; break; }
    case 9106: // $37377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9107; break; } else { __label__ = 14046; break; }
    case 9107: // $37378
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9108; break; } else { __label__ = 14046; break; }
    case 9108: // $37379
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9109; break; } else { __label__ = 14046; break; }
    case 9109: // $37380
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9110; break; } else { __label__ = 14046; break; }
    case 9110: // $37381
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10004, $10005, $10006, $10007, $10008, $10009, $10010, $10011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9111; break; } else { __label__ = 14046; break; }
    case 9111: // $37382
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10013, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9112; break; } else { __label__ = 14046; break; }
    case 9112: // $37383
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10014, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9113; break; } else { __label__ = 14046; break; }
    case 9113: // $37384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10015, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9114; break; } else { __label__ = 14046; break; }
    case 9114: // $37385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9115; break; } else { __label__ = 14046; break; }
    case 9115: // $37386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9116; break; } else { __label__ = 14046; break; }
    case 9116: // $37387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9117; break; } else { __label__ = 14046; break; }
    case 9117: // $37388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9118; break; } else { __label__ = 14046; break; }
    case 9118: // $37389
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10012, $10013, $10014, $10015, $10016, $10017, $10018, $10019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9119; break; } else { __label__ = 14046; break; }
    case 9119: // $37390
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37366, 142, 8, 7, ((STRING_TABLE.__str1136)|0), ((STRING_TABLE.__str1137)|0), $9996, $10004, $10012) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9120; break; } else { __label__ = 14046; break; }
    case 9120: // $37391
      var $37392=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37366);
      var $37393=__ZN11simple_listI16input_type_entryE6appendERS0_($37327, $37392);
      var $37394=$4689;
      var $37395=$2314;
      var $37396=$2315;
      var $37397=$2316;
      var $37398=$result_i947;
      var $37399=$2317;
      var $37400=$2318;
      HEAP32[(($2314)>>2)]=408;
      HEAP32[(($2315)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2316)>>2)]=553;
      var $37401=HEAP32[(($2314)>>2)];
      var $37402=HEAP32[(($2315)>>2)];
      var $37403=HEAP32[(($2316)>>2)];
      var $37404=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37401, $37402, $37403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9121; break; } else { __label__ = 9123; break; };
    case 9121: // $37405
      HEAP32[(($result_i947)>>2)]=$37404;
      var $37406=HEAP32[(($result_i947)>>2)];
      var $37407=(($37406)|0)==0;
      if ($37407) { __label__ = 9122; break; } else { __label__ = 9127; break; }
    case 9122: // $37408
      var $37409=___cxa_allocate_exception(4);
      var $37410=$37409;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37410);
      (function() { try { __THREW__ = false; return ___cxa_throw($37409, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9126; break; } else { __label__ = 9123; break; }
    case 9123: // $37411
      var $37412=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37413=$37412.f0;
      HEAP32[(($2317)>>2)]=$37413;
      var $37414=$37412.f1;
      HEAP32[(($2318)>>2)]=$37414;
      var $37415=HEAP32[(($2318)>>2)];
      var $37416=(($37415)|0) < 0;
      if ($37416) { __label__ = 9124; break; } else { __label__ = 9125; break; }
    case 9124: // $37417
      var $37418=HEAP32[(($2317)>>2)];
      ___cxa_call_unexpected($37418);
      throw "Reached an unreachable!"
    case 9125: // $37419
      var $37420=HEAP32[(($2317)>>2)];
      var $37421=HEAP32[(($2317)>>2)];
      var $37422=HEAP32[(($2318)>>2)];
      var $37423=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37421, tempValue);
      var $37424=($37423.f1 = $37422, $37423);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9126: // $37425
      throw "Reached an unreachable!"
    case 9127: // $_ZnwjPKci_exit948
      var $37426=HEAP32[(($result_i947)>>2)];
      var $37427=$2314;
      var $37428=$2315;
      var $37429=$2316;
      var $37430=$result_i947;
      var $37431=$2317;
      var $37432=$2318;
      var $37433=$37426;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10021, 4, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9128; break; } else { __label__ = 14051; break; }
    case 9128: // $37434
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10022, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9129; break; } else { __label__ = 14051; break; }
    case 9129: // $37435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10023, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9130; break; } else { __label__ = 14051; break; }
    case 9130: // $37436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9131; break; } else { __label__ = 14051; break; }
    case 9131: // $37437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9132; break; } else { __label__ = 14051; break; }
    case 9132: // $37438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9133; break; } else { __label__ = 14051; break; }
    case 9133: // $37439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9134; break; } else { __label__ = 14051; break; }
    case 9134: // $37440
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10020, $10021, $10022, $10023, $10024, $10025, $10026, $10027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9135; break; } else { __label__ = 14051; break; }
    case 9135: // $37441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10029, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9136; break; } else { __label__ = 14051; break; }
    case 9136: // $37442
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10030, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9137; break; } else { __label__ = 14051; break; }
    case 9137: // $37443
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10031, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9138; break; } else { __label__ = 14051; break; }
    case 9138: // $37444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9139; break; } else { __label__ = 14051; break; }
    case 9139: // $37445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9140; break; } else { __label__ = 14051; break; }
    case 9140: // $37446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9141; break; } else { __label__ = 14051; break; }
    case 9141: // $37447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9142; break; } else { __label__ = 14051; break; }
    case 9142: // $37448
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10028, $10029, $10030, $10031, $10032, $10033, $10034, $10035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9143; break; } else { __label__ = 14051; break; }
    case 9143: // $37449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10037, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9144; break; } else { __label__ = 14051; break; }
    case 9144: // $37450
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10038, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9145; break; } else { __label__ = 14051; break; }
    case 9145: // $37451
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10039, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9146; break; } else { __label__ = 14051; break; }
    case 9146: // $37452
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9147; break; } else { __label__ = 14051; break; }
    case 9147: // $37453
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9148; break; } else { __label__ = 14051; break; }
    case 9148: // $37454
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9149; break; } else { __label__ = 14051; break; }
    case 9149: // $37455
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9150; break; } else { __label__ = 14051; break; }
    case 9150: // $37456
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10036, $10037, $10038, $10039, $10040, $10041, $10042, $10043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9151; break; } else { __label__ = 14051; break; }
    case 9151: // $37457
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37433, 143, 1, 0, ((STRING_TABLE.__str1138)|0), ((STRING_TABLE.__str1139)|0), $10020, $10028, $10036) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9152; break; } else { __label__ = 14051; break; }
    case 9152: // $37458
      var $37459=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37433);
      var $37460=__ZN11simple_listI16input_type_entryE6appendERS0_($37394, $37459);
      var $37461=$4689;
      var $37462=$2309;
      var $37463=$2310;
      var $37464=$2311;
      var $37465=$result_i949;
      var $37466=$2312;
      var $37467=$2313;
      HEAP32[(($2309)>>2)]=408;
      HEAP32[(($2310)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2311)>>2)]=554;
      var $37468=HEAP32[(($2309)>>2)];
      var $37469=HEAP32[(($2310)>>2)];
      var $37470=HEAP32[(($2311)>>2)];
      var $37471=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37468, $37469, $37470) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9153; break; } else { __label__ = 9155; break; };
    case 9153: // $37472
      HEAP32[(($result_i949)>>2)]=$37471;
      var $37473=HEAP32[(($result_i949)>>2)];
      var $37474=(($37473)|0)==0;
      if ($37474) { __label__ = 9154; break; } else { __label__ = 9159; break; }
    case 9154: // $37475
      var $37476=___cxa_allocate_exception(4);
      var $37477=$37476;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37477);
      (function() { try { __THREW__ = false; return ___cxa_throw($37476, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9158; break; } else { __label__ = 9155; break; }
    case 9155: // $37478
      var $37479=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37480=$37479.f0;
      HEAP32[(($2312)>>2)]=$37480;
      var $37481=$37479.f1;
      HEAP32[(($2313)>>2)]=$37481;
      var $37482=HEAP32[(($2313)>>2)];
      var $37483=(($37482)|0) < 0;
      if ($37483) { __label__ = 9156; break; } else { __label__ = 9157; break; }
    case 9156: // $37484
      var $37485=HEAP32[(($2312)>>2)];
      ___cxa_call_unexpected($37485);
      throw "Reached an unreachable!"
    case 9157: // $37486
      var $37487=HEAP32[(($2312)>>2)];
      var $37488=HEAP32[(($2312)>>2)];
      var $37489=HEAP32[(($2313)>>2)];
      var $37490=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37488, tempValue);
      var $37491=($37490.f1 = $37489, $37490);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9158: // $37492
      throw "Reached an unreachable!"
    case 9159: // $_ZnwjPKci_exit950
      var $37493=HEAP32[(($result_i949)>>2)];
      var $37494=$2309;
      var $37495=$2310;
      var $37496=$2311;
      var $37497=$result_i949;
      var $37498=$2312;
      var $37499=$2313;
      var $37500=$37493;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10045, 4, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9160; break; } else { __label__ = 14056; break; }
    case 9160: // $37501
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10046, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9161; break; } else { __label__ = 14056; break; }
    case 9161: // $37502
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10047, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9162; break; } else { __label__ = 14056; break; }
    case 9162: // $37503
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9163; break; } else { __label__ = 14056; break; }
    case 9163: // $37504
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9164; break; } else { __label__ = 14056; break; }
    case 9164: // $37505
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9165; break; } else { __label__ = 14056; break; }
    case 9165: // $37506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9166; break; } else { __label__ = 14056; break; }
    case 9166: // $37507
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10044, $10045, $10046, $10047, $10048, $10049, $10050, $10051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9167; break; } else { __label__ = 14056; break; }
    case 9167: // $37508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10053, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9168; break; } else { __label__ = 14056; break; }
    case 9168: // $37509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10054, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9169; break; } else { __label__ = 14056; break; }
    case 9169: // $37510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10055, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9170; break; } else { __label__ = 14056; break; }
    case 9170: // $37511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9171; break; } else { __label__ = 14056; break; }
    case 9171: // $37512
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9172; break; } else { __label__ = 14056; break; }
    case 9172: // $37513
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9173; break; } else { __label__ = 14056; break; }
    case 9173: // $37514
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9174; break; } else { __label__ = 14056; break; }
    case 9174: // $37515
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10052, $10053, $10054, $10055, $10056, $10057, $10058, $10059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9175; break; } else { __label__ = 14056; break; }
    case 9175: // $37516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10061, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9176; break; } else { __label__ = 14056; break; }
    case 9176: // $37517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10062, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9177; break; } else { __label__ = 14056; break; }
    case 9177: // $37518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10063, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9178; break; } else { __label__ = 14056; break; }
    case 9178: // $37519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9179; break; } else { __label__ = 14056; break; }
    case 9179: // $37520
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9180; break; } else { __label__ = 14056; break; }
    case 9180: // $37521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9181; break; } else { __label__ = 14056; break; }
    case 9181: // $37522
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9182; break; } else { __label__ = 14056; break; }
    case 9182: // $37523
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10060, $10061, $10062, $10063, $10064, $10065, $10066, $10067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9183; break; } else { __label__ = 14056; break; }
    case 9183: // $37524
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37500, 143, 2, 1, ((STRING_TABLE.__str1140)|0), ((STRING_TABLE.__str1141)|0), $10044, $10052, $10060) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9184; break; } else { __label__ = 14056; break; }
    case 9184: // $37525
      var $37526=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37500);
      var $37527=__ZN11simple_listI16input_type_entryE6appendERS0_($37461, $37526);
      var $37528=$4689;
      var $37529=$2304;
      var $37530=$2305;
      var $37531=$2306;
      var $37532=$result_i951;
      var $37533=$2307;
      var $37534=$2308;
      HEAP32[(($2304)>>2)]=408;
      HEAP32[(($2305)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2306)>>2)]=555;
      var $37535=HEAP32[(($2304)>>2)];
      var $37536=HEAP32[(($2305)>>2)];
      var $37537=HEAP32[(($2306)>>2)];
      var $37538=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37535, $37536, $37537) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9185; break; } else { __label__ = 9187; break; };
    case 9185: // $37539
      HEAP32[(($result_i951)>>2)]=$37538;
      var $37540=HEAP32[(($result_i951)>>2)];
      var $37541=(($37540)|0)==0;
      if ($37541) { __label__ = 9186; break; } else { __label__ = 9191; break; }
    case 9186: // $37542
      var $37543=___cxa_allocate_exception(4);
      var $37544=$37543;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37544);
      (function() { try { __THREW__ = false; return ___cxa_throw($37543, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9190; break; } else { __label__ = 9187; break; }
    case 9187: // $37545
      var $37546=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37547=$37546.f0;
      HEAP32[(($2307)>>2)]=$37547;
      var $37548=$37546.f1;
      HEAP32[(($2308)>>2)]=$37548;
      var $37549=HEAP32[(($2308)>>2)];
      var $37550=(($37549)|0) < 0;
      if ($37550) { __label__ = 9188; break; } else { __label__ = 9189; break; }
    case 9188: // $37551
      var $37552=HEAP32[(($2307)>>2)];
      ___cxa_call_unexpected($37552);
      throw "Reached an unreachable!"
    case 9189: // $37553
      var $37554=HEAP32[(($2307)>>2)];
      var $37555=HEAP32[(($2307)>>2)];
      var $37556=HEAP32[(($2308)>>2)];
      var $37557=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37555, tempValue);
      var $37558=($37557.f1 = $37556, $37557);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9190: // $37559
      throw "Reached an unreachable!"
    case 9191: // $_ZnwjPKci_exit952
      var $37560=HEAP32[(($result_i951)>>2)];
      var $37561=$2304;
      var $37562=$2305;
      var $37563=$2306;
      var $37564=$result_i951;
      var $37565=$2307;
      var $37566=$2308;
      var $37567=$37560;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10069, 4, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9192; break; } else { __label__ = 14061; break; }
    case 9192: // $37568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10070, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9193; break; } else { __label__ = 14061; break; }
    case 9193: // $37569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10071, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9194; break; } else { __label__ = 14061; break; }
    case 9194: // $37570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9195; break; } else { __label__ = 14061; break; }
    case 9195: // $37571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9196; break; } else { __label__ = 14061; break; }
    case 9196: // $37572
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9197; break; } else { __label__ = 14061; break; }
    case 9197: // $37573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9198; break; } else { __label__ = 14061; break; }
    case 9198: // $37574
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10068, $10069, $10070, $10071, $10072, $10073, $10074, $10075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9199; break; } else { __label__ = 14061; break; }
    case 9199: // $37575
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10077, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9200; break; } else { __label__ = 14061; break; }
    case 9200: // $37576
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10078, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9201; break; } else { __label__ = 14061; break; }
    case 9201: // $37577
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10079, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9202; break; } else { __label__ = 14061; break; }
    case 9202: // $37578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9203; break; } else { __label__ = 14061; break; }
    case 9203: // $37579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9204; break; } else { __label__ = 14061; break; }
    case 9204: // $37580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9205; break; } else { __label__ = 14061; break; }
    case 9205: // $37581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9206; break; } else { __label__ = 14061; break; }
    case 9206: // $37582
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10076, $10077, $10078, $10079, $10080, $10081, $10082, $10083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9207; break; } else { __label__ = 14061; break; }
    case 9207: // $37583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10085, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9208; break; } else { __label__ = 14061; break; }
    case 9208: // $37584
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10086, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9209; break; } else { __label__ = 14061; break; }
    case 9209: // $37585
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10087, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9210; break; } else { __label__ = 14061; break; }
    case 9210: // $37586
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9211; break; } else { __label__ = 14061; break; }
    case 9211: // $37587
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9212; break; } else { __label__ = 14061; break; }
    case 9212: // $37588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9213; break; } else { __label__ = 14061; break; }
    case 9213: // $37589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9214; break; } else { __label__ = 14061; break; }
    case 9214: // $37590
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10084, $10085, $10086, $10087, $10088, $10089, $10090, $10091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9215; break; } else { __label__ = 14061; break; }
    case 9215: // $37591
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37567, 143, 3, 2, ((STRING_TABLE.__str1142)|0), ((STRING_TABLE.__str1143)|0), $10068, $10076, $10084) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9216; break; } else { __label__ = 14061; break; }
    case 9216: // $37592
      var $37593=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37567);
      var $37594=__ZN11simple_listI16input_type_entryE6appendERS0_($37528, $37593);
      var $37595=$4689;
      var $37596=$2299;
      var $37597=$2300;
      var $37598=$2301;
      var $37599=$result_i953;
      var $37600=$2302;
      var $37601=$2303;
      HEAP32[(($2299)>>2)]=408;
      HEAP32[(($2300)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2301)>>2)]=556;
      var $37602=HEAP32[(($2299)>>2)];
      var $37603=HEAP32[(($2300)>>2)];
      var $37604=HEAP32[(($2301)>>2)];
      var $37605=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37602, $37603, $37604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9217; break; } else { __label__ = 9219; break; };
    case 9217: // $37606
      HEAP32[(($result_i953)>>2)]=$37605;
      var $37607=HEAP32[(($result_i953)>>2)];
      var $37608=(($37607)|0)==0;
      if ($37608) { __label__ = 9218; break; } else { __label__ = 9223; break; }
    case 9218: // $37609
      var $37610=___cxa_allocate_exception(4);
      var $37611=$37610;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37611);
      (function() { try { __THREW__ = false; return ___cxa_throw($37610, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9222; break; } else { __label__ = 9219; break; }
    case 9219: // $37612
      var $37613=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37614=$37613.f0;
      HEAP32[(($2302)>>2)]=$37614;
      var $37615=$37613.f1;
      HEAP32[(($2303)>>2)]=$37615;
      var $37616=HEAP32[(($2303)>>2)];
      var $37617=(($37616)|0) < 0;
      if ($37617) { __label__ = 9220; break; } else { __label__ = 9221; break; }
    case 9220: // $37618
      var $37619=HEAP32[(($2302)>>2)];
      ___cxa_call_unexpected($37619);
      throw "Reached an unreachable!"
    case 9221: // $37620
      var $37621=HEAP32[(($2302)>>2)];
      var $37622=HEAP32[(($2302)>>2)];
      var $37623=HEAP32[(($2303)>>2)];
      var $37624=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37622, tempValue);
      var $37625=($37624.f1 = $37623, $37624);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9222: // $37626
      throw "Reached an unreachable!"
    case 9223: // $_ZnwjPKci_exit954
      var $37627=HEAP32[(($result_i953)>>2)];
      var $37628=$2299;
      var $37629=$2300;
      var $37630=$2301;
      var $37631=$result_i953;
      var $37632=$2302;
      var $37633=$2303;
      var $37634=$37627;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10093, 4, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9224; break; } else { __label__ = 14066; break; }
    case 9224: // $37635
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10094, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9225; break; } else { __label__ = 14066; break; }
    case 9225: // $37636
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10095, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9226; break; } else { __label__ = 14066; break; }
    case 9226: // $37637
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9227; break; } else { __label__ = 14066; break; }
    case 9227: // $37638
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9228; break; } else { __label__ = 14066; break; }
    case 9228: // $37639
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9229; break; } else { __label__ = 14066; break; }
    case 9229: // $37640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9230; break; } else { __label__ = 14066; break; }
    case 9230: // $37641
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10092, $10093, $10094, $10095, $10096, $10097, $10098, $10099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9231; break; } else { __label__ = 14066; break; }
    case 9231: // $37642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10101, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9232; break; } else { __label__ = 14066; break; }
    case 9232: // $37643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10102, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9233; break; } else { __label__ = 14066; break; }
    case 9233: // $37644
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10103, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9234; break; } else { __label__ = 14066; break; }
    case 9234: // $37645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10104, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9235; break; } else { __label__ = 14066; break; }
    case 9235: // $37646
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10105, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9236; break; } else { __label__ = 14066; break; }
    case 9236: // $37647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9237; break; } else { __label__ = 14066; break; }
    case 9237: // $37648
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9238; break; } else { __label__ = 14066; break; }
    case 9238: // $37649
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10100, $10101, $10102, $10103, $10104, $10105, $10106, $10107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9239; break; } else { __label__ = 14066; break; }
    case 9239: // $37650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10109, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9240; break; } else { __label__ = 14066; break; }
    case 9240: // $37651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10110, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9241; break; } else { __label__ = 14066; break; }
    case 9241: // $37652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10111, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9242; break; } else { __label__ = 14066; break; }
    case 9242: // $37653
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10112, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9243; break; } else { __label__ = 14066; break; }
    case 9243: // $37654
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10113, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9244; break; } else { __label__ = 14066; break; }
    case 9244: // $37655
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9245; break; } else { __label__ = 14066; break; }
    case 9245: // $37656
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9246; break; } else { __label__ = 14066; break; }
    case 9246: // $37657
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10108, $10109, $10110, $10111, $10112, $10113, $10114, $10115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9247; break; } else { __label__ = 14066; break; }
    case 9247: // $37658
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37634, 143, 4, 3, ((STRING_TABLE.__str1144)|0), ((STRING_TABLE.__str1145)|0), $10092, $10100, $10108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9248; break; } else { __label__ = 14066; break; }
    case 9248: // $37659
      var $37660=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37634);
      var $37661=__ZN11simple_listI16input_type_entryE6appendERS0_($37595, $37660);
      var $37662=$4689;
      var $37663=$2294;
      var $37664=$2295;
      var $37665=$2296;
      var $37666=$result_i955;
      var $37667=$2297;
      var $37668=$2298;
      HEAP32[(($2294)>>2)]=408;
      HEAP32[(($2295)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2296)>>2)]=557;
      var $37669=HEAP32[(($2294)>>2)];
      var $37670=HEAP32[(($2295)>>2)];
      var $37671=HEAP32[(($2296)>>2)];
      var $37672=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37669, $37670, $37671) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9249; break; } else { __label__ = 9251; break; };
    case 9249: // $37673
      HEAP32[(($result_i955)>>2)]=$37672;
      var $37674=HEAP32[(($result_i955)>>2)];
      var $37675=(($37674)|0)==0;
      if ($37675) { __label__ = 9250; break; } else { __label__ = 9255; break; }
    case 9250: // $37676
      var $37677=___cxa_allocate_exception(4);
      var $37678=$37677;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37678);
      (function() { try { __THREW__ = false; return ___cxa_throw($37677, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9254; break; } else { __label__ = 9251; break; }
    case 9251: // $37679
      var $37680=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37681=$37680.f0;
      HEAP32[(($2297)>>2)]=$37681;
      var $37682=$37680.f1;
      HEAP32[(($2298)>>2)]=$37682;
      var $37683=HEAP32[(($2298)>>2)];
      var $37684=(($37683)|0) < 0;
      if ($37684) { __label__ = 9252; break; } else { __label__ = 9253; break; }
    case 9252: // $37685
      var $37686=HEAP32[(($2297)>>2)];
      ___cxa_call_unexpected($37686);
      throw "Reached an unreachable!"
    case 9253: // $37687
      var $37688=HEAP32[(($2297)>>2)];
      var $37689=HEAP32[(($2297)>>2)];
      var $37690=HEAP32[(($2298)>>2)];
      var $37691=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37689, tempValue);
      var $37692=($37691.f1 = $37690, $37691);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9254: // $37693
      throw "Reached an unreachable!"
    case 9255: // $_ZnwjPKci_exit956
      var $37694=HEAP32[(($result_i955)>>2)];
      var $37695=$2294;
      var $37696=$2295;
      var $37697=$2296;
      var $37698=$result_i955;
      var $37699=$2297;
      var $37700=$2298;
      var $37701=$37694;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10117, 4, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9256; break; } else { __label__ = 14071; break; }
    case 9256: // $37702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10118, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9257; break; } else { __label__ = 14071; break; }
    case 9257: // $37703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10119, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9258; break; } else { __label__ = 14071; break; }
    case 9258: // $37704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9259; break; } else { __label__ = 14071; break; }
    case 9259: // $37705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9260; break; } else { __label__ = 14071; break; }
    case 9260: // $37706
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9261; break; } else { __label__ = 14071; break; }
    case 9261: // $37707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9262; break; } else { __label__ = 14071; break; }
    case 9262: // $37708
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10116, $10117, $10118, $10119, $10120, $10121, $10122, $10123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9263; break; } else { __label__ = 14071; break; }
    case 9263: // $37709
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10125, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9264; break; } else { __label__ = 14071; break; }
    case 9264: // $37710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10126, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9265; break; } else { __label__ = 14071; break; }
    case 9265: // $37711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10127, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9266; break; } else { __label__ = 14071; break; }
    case 9266: // $37712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9267; break; } else { __label__ = 14071; break; }
    case 9267: // $37713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9268; break; } else { __label__ = 14071; break; }
    case 9268: // $37714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9269; break; } else { __label__ = 14071; break; }
    case 9269: // $37715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9270; break; } else { __label__ = 14071; break; }
    case 9270: // $37716
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10124, $10125, $10126, $10127, $10128, $10129, $10130, $10131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9271; break; } else { __label__ = 14071; break; }
    case 9271: // $37717
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10133, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9272; break; } else { __label__ = 14071; break; }
    case 9272: // $37718
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10134, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9273; break; } else { __label__ = 14071; break; }
    case 9273: // $37719
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10135, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9274; break; } else { __label__ = 14071; break; }
    case 9274: // $37720
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9275; break; } else { __label__ = 14071; break; }
    case 9275: // $37721
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9276; break; } else { __label__ = 14071; break; }
    case 9276: // $37722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9277; break; } else { __label__ = 14071; break; }
    case 9277: // $37723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9278; break; } else { __label__ = 14071; break; }
    case 9278: // $37724
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10132, $10133, $10134, $10135, $10136, $10137, $10138, $10139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9279; break; } else { __label__ = 14071; break; }
    case 9279: // $37725
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37701, 143, 5, 4, ((STRING_TABLE.__str1146)|0), ((STRING_TABLE.__str1147)|0), $10116, $10124, $10132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9280; break; } else { __label__ = 14071; break; }
    case 9280: // $37726
      var $37727=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37701);
      var $37728=__ZN11simple_listI16input_type_entryE6appendERS0_($37662, $37727);
      var $37729=$4689;
      var $37730=$2289;
      var $37731=$2290;
      var $37732=$2291;
      var $37733=$result_i957;
      var $37734=$2292;
      var $37735=$2293;
      HEAP32[(($2289)>>2)]=408;
      HEAP32[(($2290)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2291)>>2)]=558;
      var $37736=HEAP32[(($2289)>>2)];
      var $37737=HEAP32[(($2290)>>2)];
      var $37738=HEAP32[(($2291)>>2)];
      var $37739=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37736, $37737, $37738) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9281; break; } else { __label__ = 9283; break; };
    case 9281: // $37740
      HEAP32[(($result_i957)>>2)]=$37739;
      var $37741=HEAP32[(($result_i957)>>2)];
      var $37742=(($37741)|0)==0;
      if ($37742) { __label__ = 9282; break; } else { __label__ = 9287; break; }
    case 9282: // $37743
      var $37744=___cxa_allocate_exception(4);
      var $37745=$37744;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37745);
      (function() { try { __THREW__ = false; return ___cxa_throw($37744, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9286; break; } else { __label__ = 9283; break; }
    case 9283: // $37746
      var $37747=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37748=$37747.f0;
      HEAP32[(($2292)>>2)]=$37748;
      var $37749=$37747.f1;
      HEAP32[(($2293)>>2)]=$37749;
      var $37750=HEAP32[(($2293)>>2)];
      var $37751=(($37750)|0) < 0;
      if ($37751) { __label__ = 9284; break; } else { __label__ = 9285; break; }
    case 9284: // $37752
      var $37753=HEAP32[(($2292)>>2)];
      ___cxa_call_unexpected($37753);
      throw "Reached an unreachable!"
    case 9285: // $37754
      var $37755=HEAP32[(($2292)>>2)];
      var $37756=HEAP32[(($2292)>>2)];
      var $37757=HEAP32[(($2293)>>2)];
      var $37758=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37756, tempValue);
      var $37759=($37758.f1 = $37757, $37758);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9286: // $37760
      throw "Reached an unreachable!"
    case 9287: // $_ZnwjPKci_exit958
      var $37761=HEAP32[(($result_i957)>>2)];
      var $37762=$2289;
      var $37763=$2290;
      var $37764=$2291;
      var $37765=$result_i957;
      var $37766=$2292;
      var $37767=$2293;
      var $37768=$37761;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10141, 4, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9288; break; } else { __label__ = 14076; break; }
    case 9288: // $37769
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10142, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9289; break; } else { __label__ = 14076; break; }
    case 9289: // $37770
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10143, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9290; break; } else { __label__ = 14076; break; }
    case 9290: // $37771
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9291; break; } else { __label__ = 14076; break; }
    case 9291: // $37772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9292; break; } else { __label__ = 14076; break; }
    case 9292: // $37773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9293; break; } else { __label__ = 14076; break; }
    case 9293: // $37774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9294; break; } else { __label__ = 14076; break; }
    case 9294: // $37775
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10140, $10141, $10142, $10143, $10144, $10145, $10146, $10147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9295; break; } else { __label__ = 14076; break; }
    case 9295: // $37776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10149, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9296; break; } else { __label__ = 14076; break; }
    case 9296: // $37777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9297; break; } else { __label__ = 14076; break; }
    case 9297: // $37778
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9298; break; } else { __label__ = 14076; break; }
    case 9298: // $37779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9299; break; } else { __label__ = 14076; break; }
    case 9299: // $37780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9300; break; } else { __label__ = 14076; break; }
    case 9300: // $37781
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9301; break; } else { __label__ = 14076; break; }
    case 9301: // $37782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9302; break; } else { __label__ = 14076; break; }
    case 9302: // $37783
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10148, $10149, $10150, $10151, $10152, $10153, $10154, $10155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9303; break; } else { __label__ = 14076; break; }
    case 9303: // $37784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10157, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9304; break; } else { __label__ = 14076; break; }
    case 9304: // $37785
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10158, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9305; break; } else { __label__ = 14076; break; }
    case 9305: // $37786
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10159, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9306; break; } else { __label__ = 14076; break; }
    case 9306: // $37787
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9307; break; } else { __label__ = 14076; break; }
    case 9307: // $37788
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9308; break; } else { __label__ = 14076; break; }
    case 9308: // $37789
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9309; break; } else { __label__ = 14076; break; }
    case 9309: // $37790
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9310; break; } else { __label__ = 14076; break; }
    case 9310: // $37791
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10156, $10157, $10158, $10159, $10160, $10161, $10162, $10163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9311; break; } else { __label__ = 14076; break; }
    case 9311: // $37792
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37768, 143, 6, 5, ((STRING_TABLE.__str1148424)|0), ((STRING_TABLE.__str1149)|0), $10140, $10148, $10156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9312; break; } else { __label__ = 14076; break; }
    case 9312: // $37793
      var $37794=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37768);
      var $37795=__ZN11simple_listI16input_type_entryE6appendERS0_($37729, $37794);
      var $37796=$4689;
      var $37797=$2284;
      var $37798=$2285;
      var $37799=$2286;
      var $37800=$result_i959;
      var $37801=$2287;
      var $37802=$2288;
      HEAP32[(($2284)>>2)]=408;
      HEAP32[(($2285)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2286)>>2)]=559;
      var $37803=HEAP32[(($2284)>>2)];
      var $37804=HEAP32[(($2285)>>2)];
      var $37805=HEAP32[(($2286)>>2)];
      var $37806=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37803, $37804, $37805) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9313; break; } else { __label__ = 9315; break; };
    case 9313: // $37807
      HEAP32[(($result_i959)>>2)]=$37806;
      var $37808=HEAP32[(($result_i959)>>2)];
      var $37809=(($37808)|0)==0;
      if ($37809) { __label__ = 9314; break; } else { __label__ = 9319; break; }
    case 9314: // $37810
      var $37811=___cxa_allocate_exception(4);
      var $37812=$37811;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37812);
      (function() { try { __THREW__ = false; return ___cxa_throw($37811, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9318; break; } else { __label__ = 9315; break; }
    case 9315: // $37813
      var $37814=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37815=$37814.f0;
      HEAP32[(($2287)>>2)]=$37815;
      var $37816=$37814.f1;
      HEAP32[(($2288)>>2)]=$37816;
      var $37817=HEAP32[(($2288)>>2)];
      var $37818=(($37817)|0) < 0;
      if ($37818) { __label__ = 9316; break; } else { __label__ = 9317; break; }
    case 9316: // $37819
      var $37820=HEAP32[(($2287)>>2)];
      ___cxa_call_unexpected($37820);
      throw "Reached an unreachable!"
    case 9317: // $37821
      var $37822=HEAP32[(($2287)>>2)];
      var $37823=HEAP32[(($2287)>>2)];
      var $37824=HEAP32[(($2288)>>2)];
      var $37825=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37823, tempValue);
      var $37826=($37825.f1 = $37824, $37825);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9318: // $37827
      throw "Reached an unreachable!"
    case 9319: // $_ZnwjPKci_exit960
      var $37828=HEAP32[(($result_i959)>>2)];
      var $37829=$2284;
      var $37830=$2285;
      var $37831=$2286;
      var $37832=$result_i959;
      var $37833=$2287;
      var $37834=$2288;
      var $37835=$37828;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10165, 4, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9320; break; } else { __label__ = 14081; break; }
    case 9320: // $37836
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10166, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9321; break; } else { __label__ = 14081; break; }
    case 9321: // $37837
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10167, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9322; break; } else { __label__ = 14081; break; }
    case 9322: // $37838
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9323; break; } else { __label__ = 14081; break; }
    case 9323: // $37839
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9324; break; } else { __label__ = 14081; break; }
    case 9324: // $37840
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9325; break; } else { __label__ = 14081; break; }
    case 9325: // $37841
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9326; break; } else { __label__ = 14081; break; }
    case 9326: // $37842
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10164, $10165, $10166, $10167, $10168, $10169, $10170, $10171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9327; break; } else { __label__ = 14081; break; }
    case 9327: // $37843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10173, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9328; break; } else { __label__ = 14081; break; }
    case 9328: // $37844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9329; break; } else { __label__ = 14081; break; }
    case 9329: // $37845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9330; break; } else { __label__ = 14081; break; }
    case 9330: // $37846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9331; break; } else { __label__ = 14081; break; }
    case 9331: // $37847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9332; break; } else { __label__ = 14081; break; }
    case 9332: // $37848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9333; break; } else { __label__ = 14081; break; }
    case 9333: // $37849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9334; break; } else { __label__ = 14081; break; }
    case 9334: // $37850
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10172, $10173, $10174, $10175, $10176, $10177, $10178, $10179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9335; break; } else { __label__ = 14081; break; }
    case 9335: // $37851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10181, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9336; break; } else { __label__ = 14081; break; }
    case 9336: // $37852
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10182, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9337; break; } else { __label__ = 14081; break; }
    case 9337: // $37853
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10183, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9338; break; } else { __label__ = 14081; break; }
    case 9338: // $37854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9339; break; } else { __label__ = 14081; break; }
    case 9339: // $37855
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9340; break; } else { __label__ = 14081; break; }
    case 9340: // $37856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9341; break; } else { __label__ = 14081; break; }
    case 9341: // $37857
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9342; break; } else { __label__ = 14081; break; }
    case 9342: // $37858
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10180, $10181, $10182, $10183, $10184, $10185, $10186, $10187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9343; break; } else { __label__ = 14081; break; }
    case 9343: // $37859
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37835, 143, 7, 6, ((STRING_TABLE.__str1150)|0), ((STRING_TABLE.__str1151)|0), $10164, $10172, $10180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9344; break; } else { __label__ = 14081; break; }
    case 9344: // $37860
      var $37861=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37835);
      var $37862=__ZN11simple_listI16input_type_entryE6appendERS0_($37796, $37861);
      var $37863=$4689;
      var $37864=$2279;
      var $37865=$2280;
      var $37866=$2281;
      var $37867=$result_i961;
      var $37868=$2282;
      var $37869=$2283;
      HEAP32[(($2279)>>2)]=408;
      HEAP32[(($2280)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2281)>>2)]=560;
      var $37870=HEAP32[(($2279)>>2)];
      var $37871=HEAP32[(($2280)>>2)];
      var $37872=HEAP32[(($2281)>>2)];
      var $37873=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37870, $37871, $37872) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9345; break; } else { __label__ = 9347; break; };
    case 9345: // $37874
      HEAP32[(($result_i961)>>2)]=$37873;
      var $37875=HEAP32[(($result_i961)>>2)];
      var $37876=(($37875)|0)==0;
      if ($37876) { __label__ = 9346; break; } else { __label__ = 9351; break; }
    case 9346: // $37877
      var $37878=___cxa_allocate_exception(4);
      var $37879=$37878;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37879);
      (function() { try { __THREW__ = false; return ___cxa_throw($37878, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9350; break; } else { __label__ = 9347; break; }
    case 9347: // $37880
      var $37881=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37882=$37881.f0;
      HEAP32[(($2282)>>2)]=$37882;
      var $37883=$37881.f1;
      HEAP32[(($2283)>>2)]=$37883;
      var $37884=HEAP32[(($2283)>>2)];
      var $37885=(($37884)|0) < 0;
      if ($37885) { __label__ = 9348; break; } else { __label__ = 9349; break; }
    case 9348: // $37886
      var $37887=HEAP32[(($2282)>>2)];
      ___cxa_call_unexpected($37887);
      throw "Reached an unreachable!"
    case 9349: // $37888
      var $37889=HEAP32[(($2282)>>2)];
      var $37890=HEAP32[(($2282)>>2)];
      var $37891=HEAP32[(($2283)>>2)];
      var $37892=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37890, tempValue);
      var $37893=($37892.f1 = $37891, $37892);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9350: // $37894
      throw "Reached an unreachable!"
    case 9351: // $_ZnwjPKci_exit962
      var $37895=HEAP32[(($result_i961)>>2)];
      var $37896=$2279;
      var $37897=$2280;
      var $37898=$2281;
      var $37899=$result_i961;
      var $37900=$2282;
      var $37901=$2283;
      var $37902=$37895;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10189, 4, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9352; break; } else { __label__ = 14086; break; }
    case 9352: // $37903
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10190, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9353; break; } else { __label__ = 14086; break; }
    case 9353: // $37904
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10191, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9354; break; } else { __label__ = 14086; break; }
    case 9354: // $37905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9355; break; } else { __label__ = 14086; break; }
    case 9355: // $37906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9356; break; } else { __label__ = 14086; break; }
    case 9356: // $37907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9357; break; } else { __label__ = 14086; break; }
    case 9357: // $37908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9358; break; } else { __label__ = 14086; break; }
    case 9358: // $37909
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10188, $10189, $10190, $10191, $10192, $10193, $10194, $10195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9359; break; } else { __label__ = 14086; break; }
    case 9359: // $37910
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10197, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9360; break; } else { __label__ = 14086; break; }
    case 9360: // $37911
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9361; break; } else { __label__ = 14086; break; }
    case 9361: // $37912
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9362; break; } else { __label__ = 14086; break; }
    case 9362: // $37913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9363; break; } else { __label__ = 14086; break; }
    case 9363: // $37914
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9364; break; } else { __label__ = 14086; break; }
    case 9364: // $37915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9365; break; } else { __label__ = 14086; break; }
    case 9365: // $37916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9366; break; } else { __label__ = 14086; break; }
    case 9366: // $37917
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10196, $10197, $10198, $10199, $10200, $10201, $10202, $10203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9367; break; } else { __label__ = 14086; break; }
    case 9367: // $37918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10205, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9368; break; } else { __label__ = 14086; break; }
    case 9368: // $37919
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10206, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9369; break; } else { __label__ = 14086; break; }
    case 9369: // $37920
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10207, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9370; break; } else { __label__ = 14086; break; }
    case 9370: // $37921
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9371; break; } else { __label__ = 14086; break; }
    case 9371: // $37922
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9372; break; } else { __label__ = 14086; break; }
    case 9372: // $37923
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9373; break; } else { __label__ = 14086; break; }
    case 9373: // $37924
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9374; break; } else { __label__ = 14086; break; }
    case 9374: // $37925
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10204, $10205, $10206, $10207, $10208, $10209, $10210, $10211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9375; break; } else { __label__ = 14086; break; }
    case 9375: // $37926
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37902, 143, 8, 7, ((STRING_TABLE.__str1152)|0), ((STRING_TABLE.__str1153)|0), $10188, $10196, $10204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9376; break; } else { __label__ = 14086; break; }
    case 9376: // $37927
      var $37928=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37902);
      var $37929=__ZN11simple_listI16input_type_entryE6appendERS0_($37863, $37928);
      var $37930=$4689;
      var $37931=$2274;
      var $37932=$2275;
      var $37933=$2276;
      var $37934=$result_i963;
      var $37935=$2277;
      var $37936=$2278;
      HEAP32[(($2274)>>2)]=408;
      HEAP32[(($2275)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2276)>>2)]=562;
      var $37937=HEAP32[(($2274)>>2)];
      var $37938=HEAP32[(($2275)>>2)];
      var $37939=HEAP32[(($2276)>>2)];
      var $37940=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($37937, $37938, $37939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9377; break; } else { __label__ = 9379; break; };
    case 9377: // $37941
      HEAP32[(($result_i963)>>2)]=$37940;
      var $37942=HEAP32[(($result_i963)>>2)];
      var $37943=(($37942)|0)==0;
      if ($37943) { __label__ = 9378; break; } else { __label__ = 9383; break; }
    case 9378: // $37944
      var $37945=___cxa_allocate_exception(4);
      var $37946=$37945;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37946);
      (function() { try { __THREW__ = false; return ___cxa_throw($37945, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9382; break; } else { __label__ = 9379; break; }
    case 9379: // $37947
      var $37948=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37949=$37948.f0;
      HEAP32[(($2277)>>2)]=$37949;
      var $37950=$37948.f1;
      HEAP32[(($2278)>>2)]=$37950;
      var $37951=HEAP32[(($2278)>>2)];
      var $37952=(($37951)|0) < 0;
      if ($37952) { __label__ = 9380; break; } else { __label__ = 9381; break; }
    case 9380: // $37953
      var $37954=HEAP32[(($2277)>>2)];
      ___cxa_call_unexpected($37954);
      throw "Reached an unreachable!"
    case 9381: // $37955
      var $37956=HEAP32[(($2277)>>2)];
      var $37957=HEAP32[(($2277)>>2)];
      var $37958=HEAP32[(($2278)>>2)];
      var $37959=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37957, tempValue);
      var $37960=($37959.f1 = $37958, $37959);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9382: // $37961
      throw "Reached an unreachable!"
    case 9383: // $_ZnwjPKci_exit964
      var $37962=HEAP32[(($result_i963)>>2)];
      var $37963=$2274;
      var $37964=$2275;
      var $37965=$2276;
      var $37966=$result_i963;
      var $37967=$2277;
      var $37968=$2278;
      var $37969=$37962;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10213, 4, 0, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9384; break; } else { __label__ = 14091; break; }
    case 9384: // $37970
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9385; break; } else { __label__ = 14091; break; }
    case 9385: // $37971
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9386; break; } else { __label__ = 14091; break; }
    case 9386: // $37972
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9387; break; } else { __label__ = 14091; break; }
    case 9387: // $37973
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9388; break; } else { __label__ = 14091; break; }
    case 9388: // $37974
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9389; break; } else { __label__ = 14091; break; }
    case 9389: // $37975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9390; break; } else { __label__ = 14091; break; }
    case 9390: // $37976
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10212, $10213, $10214, $10215, $10216, $10217, $10218, $10219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9391; break; } else { __label__ = 14091; break; }
    case 9391: // $37977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10221, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9392; break; } else { __label__ = 14091; break; }
    case 9392: // $37978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10222, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9393; break; } else { __label__ = 14091; break; }
    case 9393: // $37979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9394; break; } else { __label__ = 14091; break; }
    case 9394: // $37980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9395; break; } else { __label__ = 14091; break; }
    case 9395: // $37981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9396; break; } else { __label__ = 14091; break; }
    case 9396: // $37982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9397; break; } else { __label__ = 14091; break; }
    case 9397: // $37983
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9398; break; } else { __label__ = 14091; break; }
    case 9398: // $37984
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10220, $10221, $10222, $10223, $10224, $10225, $10226, $10227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9399; break; } else { __label__ = 14091; break; }
    case 9399: // $37985
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10229, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9400; break; } else { __label__ = 14091; break; }
    case 9400: // $37986
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10230, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9401; break; } else { __label__ = 14091; break; }
    case 9401: // $37987
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10231, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9402; break; } else { __label__ = 14091; break; }
    case 9402: // $37988
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9403; break; } else { __label__ = 14091; break; }
    case 9403: // $37989
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9404; break; } else { __label__ = 14091; break; }
    case 9404: // $37990
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9405; break; } else { __label__ = 14091; break; }
    case 9405: // $37991
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9406; break; } else { __label__ = 14091; break; }
    case 9406: // $37992
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10228, $10229, $10230, $10231, $10232, $10233, $10234, $10235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9407; break; } else { __label__ = 14091; break; }
    case 9407: // $37993
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($37969, 144, 1, 0, ((STRING_TABLE.__str1154)|0), ((STRING_TABLE.__str1155)|0), $10212, $10220, $10228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9408; break; } else { __label__ = 14091; break; }
    case 9408: // $37994
      var $37995=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $37969);
      var $37996=__ZN11simple_listI16input_type_entryE6appendERS0_($37930, $37995);
      var $37997=$4689;
      var $37998=$2269;
      var $37999=$2270;
      var $38000=$2271;
      var $38001=$result_i965;
      var $38002=$2272;
      var $38003=$2273;
      HEAP32[(($2269)>>2)]=408;
      HEAP32[(($2270)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2271)>>2)]=563;
      var $38004=HEAP32[(($2269)>>2)];
      var $38005=HEAP32[(($2270)>>2)];
      var $38006=HEAP32[(($2271)>>2)];
      var $38007=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38004, $38005, $38006) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9409; break; } else { __label__ = 9411; break; };
    case 9409: // $38008
      HEAP32[(($result_i965)>>2)]=$38007;
      var $38009=HEAP32[(($result_i965)>>2)];
      var $38010=(($38009)|0)==0;
      if ($38010) { __label__ = 9410; break; } else { __label__ = 9415; break; }
    case 9410: // $38011
      var $38012=___cxa_allocate_exception(4);
      var $38013=$38012;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38013);
      (function() { try { __THREW__ = false; return ___cxa_throw($38012, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9414; break; } else { __label__ = 9411; break; }
    case 9411: // $38014
      var $38015=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38016=$38015.f0;
      HEAP32[(($2272)>>2)]=$38016;
      var $38017=$38015.f1;
      HEAP32[(($2273)>>2)]=$38017;
      var $38018=HEAP32[(($2273)>>2)];
      var $38019=(($38018)|0) < 0;
      if ($38019) { __label__ = 9412; break; } else { __label__ = 9413; break; }
    case 9412: // $38020
      var $38021=HEAP32[(($2272)>>2)];
      ___cxa_call_unexpected($38021);
      throw "Reached an unreachable!"
    case 9413: // $38022
      var $38023=HEAP32[(($2272)>>2)];
      var $38024=HEAP32[(($2272)>>2)];
      var $38025=HEAP32[(($2273)>>2)];
      var $38026=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38024, tempValue);
      var $38027=($38026.f1 = $38025, $38026);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9414: // $38028
      throw "Reached an unreachable!"
    case 9415: // $_ZnwjPKci_exit966
      var $38029=HEAP32[(($result_i965)>>2)];
      var $38030=$2269;
      var $38031=$2270;
      var $38032=$2271;
      var $38033=$result_i965;
      var $38034=$2272;
      var $38035=$2273;
      var $38036=$38029;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10237, 4, 1, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9416; break; } else { __label__ = 14096; break; }
    case 9416: // $38037
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10238, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9417; break; } else { __label__ = 14096; break; }
    case 9417: // $38038
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10239, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9418; break; } else { __label__ = 14096; break; }
    case 9418: // $38039
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9419; break; } else { __label__ = 14096; break; }
    case 9419: // $38040
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9420; break; } else { __label__ = 14096; break; }
    case 9420: // $38041
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9421; break; } else { __label__ = 14096; break; }
    case 9421: // $38042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9422; break; } else { __label__ = 14096; break; }
    case 9422: // $38043
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10236, $10237, $10238, $10239, $10240, $10241, $10242, $10243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9423; break; } else { __label__ = 14096; break; }
    case 9423: // $38044
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10245, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9424; break; } else { __label__ = 14096; break; }
    case 9424: // $38045
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10246, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9425; break; } else { __label__ = 14096; break; }
    case 9425: // $38046
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10247, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9426; break; } else { __label__ = 14096; break; }
    case 9426: // $38047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9427; break; } else { __label__ = 14096; break; }
    case 9427: // $38048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9428; break; } else { __label__ = 14096; break; }
    case 9428: // $38049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9429; break; } else { __label__ = 14096; break; }
    case 9429: // $38050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9430; break; } else { __label__ = 14096; break; }
    case 9430: // $38051
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10244, $10245, $10246, $10247, $10248, $10249, $10250, $10251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9431; break; } else { __label__ = 14096; break; }
    case 9431: // $38052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10253, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9432; break; } else { __label__ = 14096; break; }
    case 9432: // $38053
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10254, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9433; break; } else { __label__ = 14096; break; }
    case 9433: // $38054
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10255, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9434; break; } else { __label__ = 14096; break; }
    case 9434: // $38055
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9435; break; } else { __label__ = 14096; break; }
    case 9435: // $38056
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9436; break; } else { __label__ = 14096; break; }
    case 9436: // $38057
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9437; break; } else { __label__ = 14096; break; }
    case 9437: // $38058
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9438; break; } else { __label__ = 14096; break; }
    case 9438: // $38059
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10252, $10253, $10254, $10255, $10256, $10257, $10258, $10259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9439; break; } else { __label__ = 14096; break; }
    case 9439: // $38060
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38036, 144, 2, 1, ((STRING_TABLE.__str1156)|0), ((STRING_TABLE.__str1157)|0), $10236, $10244, $10252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9440; break; } else { __label__ = 14096; break; }
    case 9440: // $38061
      var $38062=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38036);
      var $38063=__ZN11simple_listI16input_type_entryE6appendERS0_($37997, $38062);
      var $38064=$4689;
      var $38065=$2264;
      var $38066=$2265;
      var $38067=$2266;
      var $38068=$result_i967;
      var $38069=$2267;
      var $38070=$2268;
      HEAP32[(($2264)>>2)]=408;
      HEAP32[(($2265)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2266)>>2)]=564;
      var $38071=HEAP32[(($2264)>>2)];
      var $38072=HEAP32[(($2265)>>2)];
      var $38073=HEAP32[(($2266)>>2)];
      var $38074=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38071, $38072, $38073) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9441; break; } else { __label__ = 9443; break; };
    case 9441: // $38075
      HEAP32[(($result_i967)>>2)]=$38074;
      var $38076=HEAP32[(($result_i967)>>2)];
      var $38077=(($38076)|0)==0;
      if ($38077) { __label__ = 9442; break; } else { __label__ = 9447; break; }
    case 9442: // $38078
      var $38079=___cxa_allocate_exception(4);
      var $38080=$38079;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38080);
      (function() { try { __THREW__ = false; return ___cxa_throw($38079, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9446; break; } else { __label__ = 9443; break; }
    case 9443: // $38081
      var $38082=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38083=$38082.f0;
      HEAP32[(($2267)>>2)]=$38083;
      var $38084=$38082.f1;
      HEAP32[(($2268)>>2)]=$38084;
      var $38085=HEAP32[(($2268)>>2)];
      var $38086=(($38085)|0) < 0;
      if ($38086) { __label__ = 9444; break; } else { __label__ = 9445; break; }
    case 9444: // $38087
      var $38088=HEAP32[(($2267)>>2)];
      ___cxa_call_unexpected($38088);
      throw "Reached an unreachable!"
    case 9445: // $38089
      var $38090=HEAP32[(($2267)>>2)];
      var $38091=HEAP32[(($2267)>>2)];
      var $38092=HEAP32[(($2268)>>2)];
      var $38093=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38091, tempValue);
      var $38094=($38093.f1 = $38092, $38093);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9446: // $38095
      throw "Reached an unreachable!"
    case 9447: // $_ZnwjPKci_exit968
      var $38096=HEAP32[(($result_i967)>>2)];
      var $38097=$2264;
      var $38098=$2265;
      var $38099=$2266;
      var $38100=$result_i967;
      var $38101=$2267;
      var $38102=$2268;
      var $38103=$38096;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10261, 4, 2, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9448; break; } else { __label__ = 14101; break; }
    case 9448: // $38104
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10262, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9449; break; } else { __label__ = 14101; break; }
    case 9449: // $38105
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10263, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9450; break; } else { __label__ = 14101; break; }
    case 9450: // $38106
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9451; break; } else { __label__ = 14101; break; }
    case 9451: // $38107
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9452; break; } else { __label__ = 14101; break; }
    case 9452: // $38108
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9453; break; } else { __label__ = 14101; break; }
    case 9453: // $38109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9454; break; } else { __label__ = 14101; break; }
    case 9454: // $38110
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10260, $10261, $10262, $10263, $10264, $10265, $10266, $10267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9455; break; } else { __label__ = 14101; break; }
    case 9455: // $38111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10269, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9456; break; } else { __label__ = 14101; break; }
    case 9456: // $38112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10270, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9457; break; } else { __label__ = 14101; break; }
    case 9457: // $38113
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10271, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9458; break; } else { __label__ = 14101; break; }
    case 9458: // $38114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9459; break; } else { __label__ = 14101; break; }
    case 9459: // $38115
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9460; break; } else { __label__ = 14101; break; }
    case 9460: // $38116
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9461; break; } else { __label__ = 14101; break; }
    case 9461: // $38117
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9462; break; } else { __label__ = 14101; break; }
    case 9462: // $38118
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10268, $10269, $10270, $10271, $10272, $10273, $10274, $10275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9463; break; } else { __label__ = 14101; break; }
    case 9463: // $38119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10277, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9464; break; } else { __label__ = 14101; break; }
    case 9464: // $38120
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10278, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9465; break; } else { __label__ = 14101; break; }
    case 9465: // $38121
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10279, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9466; break; } else { __label__ = 14101; break; }
    case 9466: // $38122
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10280, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9467; break; } else { __label__ = 14101; break; }
    case 9467: // $38123
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10281, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9468; break; } else { __label__ = 14101; break; }
    case 9468: // $38124
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9469; break; } else { __label__ = 14101; break; }
    case 9469: // $38125
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9470; break; } else { __label__ = 14101; break; }
    case 9470: // $38126
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10276, $10277, $10278, $10279, $10280, $10281, $10282, $10283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9471; break; } else { __label__ = 14101; break; }
    case 9471: // $38127
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38103, 144, 3, 2, ((STRING_TABLE.__str1158)|0), ((STRING_TABLE.__str1159425)|0), $10260, $10268, $10276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9472; break; } else { __label__ = 14101; break; }
    case 9472: // $38128
      var $38129=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38103);
      var $38130=__ZN11simple_listI16input_type_entryE6appendERS0_($38064, $38129);
      var $38131=$4689;
      var $38132=$2259;
      var $38133=$2260;
      var $38134=$2261;
      var $38135=$result_i969;
      var $38136=$2262;
      var $38137=$2263;
      HEAP32[(($2259)>>2)]=408;
      HEAP32[(($2260)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2261)>>2)]=565;
      var $38138=HEAP32[(($2259)>>2)];
      var $38139=HEAP32[(($2260)>>2)];
      var $38140=HEAP32[(($2261)>>2)];
      var $38141=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38138, $38139, $38140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9473; break; } else { __label__ = 9475; break; };
    case 9473: // $38142
      HEAP32[(($result_i969)>>2)]=$38141;
      var $38143=HEAP32[(($result_i969)>>2)];
      var $38144=(($38143)|0)==0;
      if ($38144) { __label__ = 9474; break; } else { __label__ = 9479; break; }
    case 9474: // $38145
      var $38146=___cxa_allocate_exception(4);
      var $38147=$38146;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38147);
      (function() { try { __THREW__ = false; return ___cxa_throw($38146, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9478; break; } else { __label__ = 9475; break; }
    case 9475: // $38148
      var $38149=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38150=$38149.f0;
      HEAP32[(($2262)>>2)]=$38150;
      var $38151=$38149.f1;
      HEAP32[(($2263)>>2)]=$38151;
      var $38152=HEAP32[(($2263)>>2)];
      var $38153=(($38152)|0) < 0;
      if ($38153) { __label__ = 9476; break; } else { __label__ = 9477; break; }
    case 9476: // $38154
      var $38155=HEAP32[(($2262)>>2)];
      ___cxa_call_unexpected($38155);
      throw "Reached an unreachable!"
    case 9477: // $38156
      var $38157=HEAP32[(($2262)>>2)];
      var $38158=HEAP32[(($2262)>>2)];
      var $38159=HEAP32[(($2263)>>2)];
      var $38160=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38158, tempValue);
      var $38161=($38160.f1 = $38159, $38160);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9478: // $38162
      throw "Reached an unreachable!"
    case 9479: // $_ZnwjPKci_exit970
      var $38163=HEAP32[(($result_i969)>>2)];
      var $38164=$2259;
      var $38165=$2260;
      var $38166=$2261;
      var $38167=$result_i969;
      var $38168=$2262;
      var $38169=$2263;
      var $38170=$38163;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10285, 4, 3, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9480; break; } else { __label__ = 14106; break; }
    case 9480: // $38171
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10286, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9481; break; } else { __label__ = 14106; break; }
    case 9481: // $38172
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10287, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9482; break; } else { __label__ = 14106; break; }
    case 9482: // $38173
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9483; break; } else { __label__ = 14106; break; }
    case 9483: // $38174
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9484; break; } else { __label__ = 14106; break; }
    case 9484: // $38175
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9485; break; } else { __label__ = 14106; break; }
    case 9485: // $38176
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9486; break; } else { __label__ = 14106; break; }
    case 9486: // $38177
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10284, $10285, $10286, $10287, $10288, $10289, $10290, $10291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9487; break; } else { __label__ = 14106; break; }
    case 9487: // $38178
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10293, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9488; break; } else { __label__ = 14106; break; }
    case 9488: // $38179
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10294, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9489; break; } else { __label__ = 14106; break; }
    case 9489: // $38180
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10295, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9490; break; } else { __label__ = 14106; break; }
    case 9490: // $38181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9491; break; } else { __label__ = 14106; break; }
    case 9491: // $38182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9492; break; } else { __label__ = 14106; break; }
    case 9492: // $38183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9493; break; } else { __label__ = 14106; break; }
    case 9493: // $38184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9494; break; } else { __label__ = 14106; break; }
    case 9494: // $38185
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10292, $10293, $10294, $10295, $10296, $10297, $10298, $10299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9495; break; } else { __label__ = 14106; break; }
    case 9495: // $38186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10301, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9496; break; } else { __label__ = 14106; break; }
    case 9496: // $38187
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10302, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9497; break; } else { __label__ = 14106; break; }
    case 9497: // $38188
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10303, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9498; break; } else { __label__ = 14106; break; }
    case 9498: // $38189
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9499; break; } else { __label__ = 14106; break; }
    case 9499: // $38190
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9500; break; } else { __label__ = 14106; break; }
    case 9500: // $38191
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9501; break; } else { __label__ = 14106; break; }
    case 9501: // $38192
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9502; break; } else { __label__ = 14106; break; }
    case 9502: // $38193
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10300, $10301, $10302, $10303, $10304, $10305, $10306, $10307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9503; break; } else { __label__ = 14106; break; }
    case 9503: // $38194
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38170, 144, 4, 3, ((STRING_TABLE.__str1160)|0), ((STRING_TABLE.__str1161)|0), $10284, $10292, $10300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9504; break; } else { __label__ = 14106; break; }
    case 9504: // $38195
      var $38196=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38170);
      var $38197=__ZN11simple_listI16input_type_entryE6appendERS0_($38131, $38196);
      var $38198=$4689;
      var $38199=$2254;
      var $38200=$2255;
      var $38201=$2256;
      var $38202=$result_i971;
      var $38203=$2257;
      var $38204=$2258;
      HEAP32[(($2254)>>2)]=408;
      HEAP32[(($2255)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2256)>>2)]=566;
      var $38205=HEAP32[(($2254)>>2)];
      var $38206=HEAP32[(($2255)>>2)];
      var $38207=HEAP32[(($2256)>>2)];
      var $38208=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38205, $38206, $38207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9505; break; } else { __label__ = 9507; break; };
    case 9505: // $38209
      HEAP32[(($result_i971)>>2)]=$38208;
      var $38210=HEAP32[(($result_i971)>>2)];
      var $38211=(($38210)|0)==0;
      if ($38211) { __label__ = 9506; break; } else { __label__ = 9511; break; }
    case 9506: // $38212
      var $38213=___cxa_allocate_exception(4);
      var $38214=$38213;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38214);
      (function() { try { __THREW__ = false; return ___cxa_throw($38213, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9510; break; } else { __label__ = 9507; break; }
    case 9507: // $38215
      var $38216=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38217=$38216.f0;
      HEAP32[(($2257)>>2)]=$38217;
      var $38218=$38216.f1;
      HEAP32[(($2258)>>2)]=$38218;
      var $38219=HEAP32[(($2258)>>2)];
      var $38220=(($38219)|0) < 0;
      if ($38220) { __label__ = 9508; break; } else { __label__ = 9509; break; }
    case 9508: // $38221
      var $38222=HEAP32[(($2257)>>2)];
      ___cxa_call_unexpected($38222);
      throw "Reached an unreachable!"
    case 9509: // $38223
      var $38224=HEAP32[(($2257)>>2)];
      var $38225=HEAP32[(($2257)>>2)];
      var $38226=HEAP32[(($2258)>>2)];
      var $38227=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38225, tempValue);
      var $38228=($38227.f1 = $38226, $38227);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9510: // $38229
      throw "Reached an unreachable!"
    case 9511: // $_ZnwjPKci_exit972
      var $38230=HEAP32[(($result_i971)>>2)];
      var $38231=$2254;
      var $38232=$2255;
      var $38233=$2256;
      var $38234=$result_i971;
      var $38235=$2257;
      var $38236=$2258;
      var $38237=$38230;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10309, 4, 4, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9512; break; } else { __label__ = 14111; break; }
    case 9512: // $38238
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10310, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9513; break; } else { __label__ = 14111; break; }
    case 9513: // $38239
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10311, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9514; break; } else { __label__ = 14111; break; }
    case 9514: // $38240
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9515; break; } else { __label__ = 14111; break; }
    case 9515: // $38241
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9516; break; } else { __label__ = 14111; break; }
    case 9516: // $38242
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9517; break; } else { __label__ = 14111; break; }
    case 9517: // $38243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9518; break; } else { __label__ = 14111; break; }
    case 9518: // $38244
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10308, $10309, $10310, $10311, $10312, $10313, $10314, $10315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9519; break; } else { __label__ = 14111; break; }
    case 9519: // $38245
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10317, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9520; break; } else { __label__ = 14111; break; }
    case 9520: // $38246
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10318, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9521; break; } else { __label__ = 14111; break; }
    case 9521: // $38247
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10319, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9522; break; } else { __label__ = 14111; break; }
    case 9522: // $38248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9523; break; } else { __label__ = 14111; break; }
    case 9523: // $38249
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9524; break; } else { __label__ = 14111; break; }
    case 9524: // $38250
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9525; break; } else { __label__ = 14111; break; }
    case 9525: // $38251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9526; break; } else { __label__ = 14111; break; }
    case 9526: // $38252
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10316, $10317, $10318, $10319, $10320, $10321, $10322, $10323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9527; break; } else { __label__ = 14111; break; }
    case 9527: // $38253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10325, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9528; break; } else { __label__ = 14111; break; }
    case 9528: // $38254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10326, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9529; break; } else { __label__ = 14111; break; }
    case 9529: // $38255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10327, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9530; break; } else { __label__ = 14111; break; }
    case 9530: // $38256
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9531; break; } else { __label__ = 14111; break; }
    case 9531: // $38257
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9532; break; } else { __label__ = 14111; break; }
    case 9532: // $38258
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9533; break; } else { __label__ = 14111; break; }
    case 9533: // $38259
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9534; break; } else { __label__ = 14111; break; }
    case 9534: // $38260
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10324, $10325, $10326, $10327, $10328, $10329, $10330, $10331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9535; break; } else { __label__ = 14111; break; }
    case 9535: // $38261
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38237, 144, 5, 4, ((STRING_TABLE.__str1162)|0), ((STRING_TABLE.__str1163)|0), $10308, $10316, $10324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9536; break; } else { __label__ = 14111; break; }
    case 9536: // $38262
      var $38263=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38237);
      var $38264=__ZN11simple_listI16input_type_entryE6appendERS0_($38198, $38263);
      var $38265=$4689;
      var $38266=$2249;
      var $38267=$2250;
      var $38268=$2251;
      var $38269=$result_i973;
      var $38270=$2252;
      var $38271=$2253;
      HEAP32[(($2249)>>2)]=408;
      HEAP32[(($2250)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2251)>>2)]=567;
      var $38272=HEAP32[(($2249)>>2)];
      var $38273=HEAP32[(($2250)>>2)];
      var $38274=HEAP32[(($2251)>>2)];
      var $38275=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38272, $38273, $38274) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9537; break; } else { __label__ = 9539; break; };
    case 9537: // $38276
      HEAP32[(($result_i973)>>2)]=$38275;
      var $38277=HEAP32[(($result_i973)>>2)];
      var $38278=(($38277)|0)==0;
      if ($38278) { __label__ = 9538; break; } else { __label__ = 9543; break; }
    case 9538: // $38279
      var $38280=___cxa_allocate_exception(4);
      var $38281=$38280;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38281);
      (function() { try { __THREW__ = false; return ___cxa_throw($38280, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9542; break; } else { __label__ = 9539; break; }
    case 9539: // $38282
      var $38283=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38284=$38283.f0;
      HEAP32[(($2252)>>2)]=$38284;
      var $38285=$38283.f1;
      HEAP32[(($2253)>>2)]=$38285;
      var $38286=HEAP32[(($2253)>>2)];
      var $38287=(($38286)|0) < 0;
      if ($38287) { __label__ = 9540; break; } else { __label__ = 9541; break; }
    case 9540: // $38288
      var $38289=HEAP32[(($2252)>>2)];
      ___cxa_call_unexpected($38289);
      throw "Reached an unreachable!"
    case 9541: // $38290
      var $38291=HEAP32[(($2252)>>2)];
      var $38292=HEAP32[(($2252)>>2)];
      var $38293=HEAP32[(($2253)>>2)];
      var $38294=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38292, tempValue);
      var $38295=($38294.f1 = $38293, $38294);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9542: // $38296
      throw "Reached an unreachable!"
    case 9543: // $_ZnwjPKci_exit974
      var $38297=HEAP32[(($result_i973)>>2)];
      var $38298=$2249;
      var $38299=$2250;
      var $38300=$2251;
      var $38301=$result_i973;
      var $38302=$2252;
      var $38303=$2253;
      var $38304=$38297;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10333, 4, 5, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9544; break; } else { __label__ = 14116; break; }
    case 9544: // $38305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10334, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9545; break; } else { __label__ = 14116; break; }
    case 9545: // $38306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10335, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9546; break; } else { __label__ = 14116; break; }
    case 9546: // $38307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9547; break; } else { __label__ = 14116; break; }
    case 9547: // $38308
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9548; break; } else { __label__ = 14116; break; }
    case 9548: // $38309
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9549; break; } else { __label__ = 14116; break; }
    case 9549: // $38310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9550; break; } else { __label__ = 14116; break; }
    case 9550: // $38311
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10332, $10333, $10334, $10335, $10336, $10337, $10338, $10339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9551; break; } else { __label__ = 14116; break; }
    case 9551: // $38312
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10341, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9552; break; } else { __label__ = 14116; break; }
    case 9552: // $38313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10342, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9553; break; } else { __label__ = 14116; break; }
    case 9553: // $38314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10343, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9554; break; } else { __label__ = 14116; break; }
    case 9554: // $38315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9555; break; } else { __label__ = 14116; break; }
    case 9555: // $38316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9556; break; } else { __label__ = 14116; break; }
    case 9556: // $38317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9557; break; } else { __label__ = 14116; break; }
    case 9557: // $38318
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9558; break; } else { __label__ = 14116; break; }
    case 9558: // $38319
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10340, $10341, $10342, $10343, $10344, $10345, $10346, $10347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9559; break; } else { __label__ = 14116; break; }
    case 9559: // $38320
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10349, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9560; break; } else { __label__ = 14116; break; }
    case 9560: // $38321
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10350, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9561; break; } else { __label__ = 14116; break; }
    case 9561: // $38322
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10351, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9562; break; } else { __label__ = 14116; break; }
    case 9562: // $38323
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9563; break; } else { __label__ = 14116; break; }
    case 9563: // $38324
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9564; break; } else { __label__ = 14116; break; }
    case 9564: // $38325
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9565; break; } else { __label__ = 14116; break; }
    case 9565: // $38326
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9566; break; } else { __label__ = 14116; break; }
    case 9566: // $38327
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10348, $10349, $10350, $10351, $10352, $10353, $10354, $10355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9567; break; } else { __label__ = 14116; break; }
    case 9567: // $38328
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38304, 144, 6, 5, ((STRING_TABLE.__str1164)|0), ((STRING_TABLE.__str1165)|0), $10332, $10340, $10348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9568; break; } else { __label__ = 14116; break; }
    case 9568: // $38329
      var $38330=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38304);
      var $38331=__ZN11simple_listI16input_type_entryE6appendERS0_($38265, $38330);
      var $38332=$4689;
      var $38333=$2244;
      var $38334=$2245;
      var $38335=$2246;
      var $38336=$result_i975;
      var $38337=$2247;
      var $38338=$2248;
      HEAP32[(($2244)>>2)]=408;
      HEAP32[(($2245)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2246)>>2)]=568;
      var $38339=HEAP32[(($2244)>>2)];
      var $38340=HEAP32[(($2245)>>2)];
      var $38341=HEAP32[(($2246)>>2)];
      var $38342=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38339, $38340, $38341) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9569; break; } else { __label__ = 9571; break; };
    case 9569: // $38343
      HEAP32[(($result_i975)>>2)]=$38342;
      var $38344=HEAP32[(($result_i975)>>2)];
      var $38345=(($38344)|0)==0;
      if ($38345) { __label__ = 9570; break; } else { __label__ = 9575; break; }
    case 9570: // $38346
      var $38347=___cxa_allocate_exception(4);
      var $38348=$38347;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38348);
      (function() { try { __THREW__ = false; return ___cxa_throw($38347, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9574; break; } else { __label__ = 9571; break; }
    case 9571: // $38349
      var $38350=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38351=$38350.f0;
      HEAP32[(($2247)>>2)]=$38351;
      var $38352=$38350.f1;
      HEAP32[(($2248)>>2)]=$38352;
      var $38353=HEAP32[(($2248)>>2)];
      var $38354=(($38353)|0) < 0;
      if ($38354) { __label__ = 9572; break; } else { __label__ = 9573; break; }
    case 9572: // $38355
      var $38356=HEAP32[(($2247)>>2)];
      ___cxa_call_unexpected($38356);
      throw "Reached an unreachable!"
    case 9573: // $38357
      var $38358=HEAP32[(($2247)>>2)];
      var $38359=HEAP32[(($2247)>>2)];
      var $38360=HEAP32[(($2248)>>2)];
      var $38361=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38359, tempValue);
      var $38362=($38361.f1 = $38360, $38361);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9574: // $38363
      throw "Reached an unreachable!"
    case 9575: // $_ZnwjPKci_exit976
      var $38364=HEAP32[(($result_i975)>>2)];
      var $38365=$2244;
      var $38366=$2245;
      var $38367=$2246;
      var $38368=$result_i975;
      var $38369=$2247;
      var $38370=$2248;
      var $38371=$38364;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10357, 4, 6, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9576; break; } else { __label__ = 14121; break; }
    case 9576: // $38372
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10358, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9577; break; } else { __label__ = 14121; break; }
    case 9577: // $38373
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10359, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9578; break; } else { __label__ = 14121; break; }
    case 9578: // $38374
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9579; break; } else { __label__ = 14121; break; }
    case 9579: // $38375
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9580; break; } else { __label__ = 14121; break; }
    case 9580: // $38376
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9581; break; } else { __label__ = 14121; break; }
    case 9581: // $38377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9582; break; } else { __label__ = 14121; break; }
    case 9582: // $38378
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10356, $10357, $10358, $10359, $10360, $10361, $10362, $10363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9583; break; } else { __label__ = 14121; break; }
    case 9583: // $38379
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10365, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9584; break; } else { __label__ = 14121; break; }
    case 9584: // $38380
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10366, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9585; break; } else { __label__ = 14121; break; }
    case 9585: // $38381
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10367, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9586; break; } else { __label__ = 14121; break; }
    case 9586: // $38382
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9587; break; } else { __label__ = 14121; break; }
    case 9587: // $38383
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9588; break; } else { __label__ = 14121; break; }
    case 9588: // $38384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9589; break; } else { __label__ = 14121; break; }
    case 9589: // $38385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9590; break; } else { __label__ = 14121; break; }
    case 9590: // $38386
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10364, $10365, $10366, $10367, $10368, $10369, $10370, $10371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9591; break; } else { __label__ = 14121; break; }
    case 9591: // $38387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10373, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9592; break; } else { __label__ = 14121; break; }
    case 9592: // $38388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10374, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9593; break; } else { __label__ = 14121; break; }
    case 9593: // $38389
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10375, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9594; break; } else { __label__ = 14121; break; }
    case 9594: // $38390
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9595; break; } else { __label__ = 14121; break; }
    case 9595: // $38391
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9596; break; } else { __label__ = 14121; break; }
    case 9596: // $38392
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9597; break; } else { __label__ = 14121; break; }
    case 9597: // $38393
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9598; break; } else { __label__ = 14121; break; }
    case 9598: // $38394
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10372, $10373, $10374, $10375, $10376, $10377, $10378, $10379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9599; break; } else { __label__ = 14121; break; }
    case 9599: // $38395
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38371, 144, 7, 6, ((STRING_TABLE.__str1166)|0), ((STRING_TABLE.__str1167)|0), $10356, $10364, $10372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9600; break; } else { __label__ = 14121; break; }
    case 9600: // $38396
      var $38397=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38371);
      var $38398=__ZN11simple_listI16input_type_entryE6appendERS0_($38332, $38397);
      var $38399=$4689;
      var $38400=$2239;
      var $38401=$2240;
      var $38402=$2241;
      var $38403=$result_i977;
      var $38404=$2242;
      var $38405=$2243;
      HEAP32[(($2239)>>2)]=408;
      HEAP32[(($2240)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2241)>>2)]=569;
      var $38406=HEAP32[(($2239)>>2)];
      var $38407=HEAP32[(($2240)>>2)];
      var $38408=HEAP32[(($2241)>>2)];
      var $38409=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38406, $38407, $38408) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9601; break; } else { __label__ = 9603; break; };
    case 9601: // $38410
      HEAP32[(($result_i977)>>2)]=$38409;
      var $38411=HEAP32[(($result_i977)>>2)];
      var $38412=(($38411)|0)==0;
      if ($38412) { __label__ = 9602; break; } else { __label__ = 9607; break; }
    case 9602: // $38413
      var $38414=___cxa_allocate_exception(4);
      var $38415=$38414;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38415);
      (function() { try { __THREW__ = false; return ___cxa_throw($38414, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9606; break; } else { __label__ = 9603; break; }
    case 9603: // $38416
      var $38417=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38418=$38417.f0;
      HEAP32[(($2242)>>2)]=$38418;
      var $38419=$38417.f1;
      HEAP32[(($2243)>>2)]=$38419;
      var $38420=HEAP32[(($2243)>>2)];
      var $38421=(($38420)|0) < 0;
      if ($38421) { __label__ = 9604; break; } else { __label__ = 9605; break; }
    case 9604: // $38422
      var $38423=HEAP32[(($2242)>>2)];
      ___cxa_call_unexpected($38423);
      throw "Reached an unreachable!"
    case 9605: // $38424
      var $38425=HEAP32[(($2242)>>2)];
      var $38426=HEAP32[(($2242)>>2)];
      var $38427=HEAP32[(($2243)>>2)];
      var $38428=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38426, tempValue);
      var $38429=($38428.f1 = $38427, $38428);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9606: // $38430
      throw "Reached an unreachable!"
    case 9607: // $_ZnwjPKci_exit978
      var $38431=HEAP32[(($result_i977)>>2)];
      var $38432=$2239;
      var $38433=$2240;
      var $38434=$2241;
      var $38435=$result_i977;
      var $38436=$2242;
      var $38437=$2243;
      var $38438=$38431;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10381, 4, 7, 2, 0, 112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9608; break; } else { __label__ = 14126; break; }
    case 9608: // $38439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9609; break; } else { __label__ = 14126; break; }
    case 9609: // $38440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9610; break; } else { __label__ = 14126; break; }
    case 9610: // $38441
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9611; break; } else { __label__ = 14126; break; }
    case 9611: // $38442
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9612; break; } else { __label__ = 14126; break; }
    case 9612: // $38443
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9613; break; } else { __label__ = 14126; break; }
    case 9613: // $38444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9614; break; } else { __label__ = 14126; break; }
    case 9614: // $38445
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10380, $10381, $10382, $10383, $10384, $10385, $10386, $10387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9615; break; } else { __label__ = 14126; break; }
    case 9615: // $38446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10389, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9616; break; } else { __label__ = 14126; break; }
    case 9616: // $38447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10390, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9617; break; } else { __label__ = 14126; break; }
    case 9617: // $38448
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10391, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9618; break; } else { __label__ = 14126; break; }
    case 9618: // $38449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9619; break; } else { __label__ = 14126; break; }
    case 9619: // $38450
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9620; break; } else { __label__ = 14126; break; }
    case 9620: // $38451
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9621; break; } else { __label__ = 14126; break; }
    case 9621: // $38452
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9622; break; } else { __label__ = 14126; break; }
    case 9622: // $38453
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10388, $10389, $10390, $10391, $10392, $10393, $10394, $10395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9623; break; } else { __label__ = 14126; break; }
    case 9623: // $38454
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10397, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9624; break; } else { __label__ = 14126; break; }
    case 9624: // $38455
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10398, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9625; break; } else { __label__ = 14126; break; }
    case 9625: // $38456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10399, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9626; break; } else { __label__ = 14126; break; }
    case 9626: // $38457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9627; break; } else { __label__ = 14126; break; }
    case 9627: // $38458
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9628; break; } else { __label__ = 14126; break; }
    case 9628: // $38459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9629; break; } else { __label__ = 14126; break; }
    case 9629: // $38460
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9630; break; } else { __label__ = 14126; break; }
    case 9630: // $38461
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10396, $10397, $10398, $10399, $10400, $10401, $10402, $10403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9631; break; } else { __label__ = 14126; break; }
    case 9631: // $38462
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38438, 144, 8, 7, ((STRING_TABLE.__str1168)|0), ((STRING_TABLE.__str1169)|0), $10380, $10388, $10396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9632; break; } else { __label__ = 14126; break; }
    case 9632: // $38463
      var $38464=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38438);
      var $38465=__ZN11simple_listI16input_type_entryE6appendERS0_($38399, $38464);
      var $38466=$4689;
      var $38467=$2234;
      var $38468=$2235;
      var $38469=$2236;
      var $38470=$result_i979;
      var $38471=$2237;
      var $38472=$2238;
      HEAP32[(($2234)>>2)]=408;
      HEAP32[(($2235)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2236)>>2)]=571;
      var $38473=HEAP32[(($2234)>>2)];
      var $38474=HEAP32[(($2235)>>2)];
      var $38475=HEAP32[(($2236)>>2)];
      var $38476=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38473, $38474, $38475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9633; break; } else { __label__ = 9635; break; };
    case 9633: // $38477
      HEAP32[(($result_i979)>>2)]=$38476;
      var $38478=HEAP32[(($result_i979)>>2)];
      var $38479=(($38478)|0)==0;
      if ($38479) { __label__ = 9634; break; } else { __label__ = 9639; break; }
    case 9634: // $38480
      var $38481=___cxa_allocate_exception(4);
      var $38482=$38481;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38482);
      (function() { try { __THREW__ = false; return ___cxa_throw($38481, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9638; break; } else { __label__ = 9635; break; }
    case 9635: // $38483
      var $38484=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38485=$38484.f0;
      HEAP32[(($2237)>>2)]=$38485;
      var $38486=$38484.f1;
      HEAP32[(($2238)>>2)]=$38486;
      var $38487=HEAP32[(($2238)>>2)];
      var $38488=(($38487)|0) < 0;
      if ($38488) { __label__ = 9636; break; } else { __label__ = 9637; break; }
    case 9636: // $38489
      var $38490=HEAP32[(($2237)>>2)];
      ___cxa_call_unexpected($38490);
      throw "Reached an unreachable!"
    case 9637: // $38491
      var $38492=HEAP32[(($2237)>>2)];
      var $38493=HEAP32[(($2237)>>2)];
      var $38494=HEAP32[(($2238)>>2)];
      var $38495=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38493, tempValue);
      var $38496=($38495.f1 = $38494, $38495);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9638: // $38497
      throw "Reached an unreachable!"
    case 9639: // $_ZnwjPKci_exit980
      var $38498=HEAP32[(($result_i979)>>2)];
      var $38499=$2234;
      var $38500=$2235;
      var $38501=$2236;
      var $38502=$result_i979;
      var $38503=$2237;
      var $38504=$2238;
      var $38505=$38498;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10405, 3, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9640; break; } else { __label__ = 14131; break; }
    case 9640: // $38506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10406, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9641; break; } else { __label__ = 14131; break; }
    case 9641: // $38507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10407, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9642; break; } else { __label__ = 14131; break; }
    case 9642: // $38508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10408, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9643; break; } else { __label__ = 14131; break; }
    case 9643: // $38509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10409, 4, 0, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9644; break; } else { __label__ = 14131; break; }
    case 9644: // $38510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9645; break; } else { __label__ = 14131; break; }
    case 9645: // $38511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9646; break; } else { __label__ = 14131; break; }
    case 9646: // $38512
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10404, $10405, $10406, $10407, $10408, $10409, $10410, $10411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9647; break; } else { __label__ = 14131; break; }
    case 9647: // $38513
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10413, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9648; break; } else { __label__ = 14131; break; }
    case 9648: // $38514
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10414, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9649; break; } else { __label__ = 14131; break; }
    case 9649: // $38515
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10415, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9650; break; } else { __label__ = 14131; break; }
    case 9650: // $38516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9651; break; } else { __label__ = 14131; break; }
    case 9651: // $38517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9652; break; } else { __label__ = 14131; break; }
    case 9652: // $38518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9653; break; } else { __label__ = 14131; break; }
    case 9653: // $38519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9654; break; } else { __label__ = 14131; break; }
    case 9654: // $38520
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10412, $10413, $10414, $10415, $10416, $10417, $10418, $10419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9655; break; } else { __label__ = 14131; break; }
    case 9655: // $38521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10421, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9656; break; } else { __label__ = 14131; break; }
    case 9656: // $38522
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10422, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9657; break; } else { __label__ = 14131; break; }
    case 9657: // $38523
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10423, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9658; break; } else { __label__ = 14131; break; }
    case 9658: // $38524
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9659; break; } else { __label__ = 14131; break; }
    case 9659: // $38525
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9660; break; } else { __label__ = 14131; break; }
    case 9660: // $38526
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9661; break; } else { __label__ = 14131; break; }
    case 9661: // $38527
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9662; break; } else { __label__ = 14131; break; }
    case 9662: // $38528
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10420, $10421, $10422, $10423, $10424, $10425, $10426, $10427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9663; break; } else { __label__ = 14131; break; }
    case 9663: // $38529
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38505, 145, 1, 0, ((STRING_TABLE.__str1170)|0), ((STRING_TABLE.__str1171)|0), $10404, $10412, $10420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9664; break; } else { __label__ = 14131; break; }
    case 9664: // $38530
      var $38531=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38505);
      var $38532=__ZN11simple_listI16input_type_entryE6appendERS0_($38466, $38531);
      var $38533=$4689;
      var $38534=$2229;
      var $38535=$2230;
      var $38536=$2231;
      var $38537=$result_i981;
      var $38538=$2232;
      var $38539=$2233;
      HEAP32[(($2229)>>2)]=408;
      HEAP32[(($2230)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2231)>>2)]=572;
      var $38540=HEAP32[(($2229)>>2)];
      var $38541=HEAP32[(($2230)>>2)];
      var $38542=HEAP32[(($2231)>>2)];
      var $38543=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38540, $38541, $38542) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9665; break; } else { __label__ = 9667; break; };
    case 9665: // $38544
      HEAP32[(($result_i981)>>2)]=$38543;
      var $38545=HEAP32[(($result_i981)>>2)];
      var $38546=(($38545)|0)==0;
      if ($38546) { __label__ = 9666; break; } else { __label__ = 9671; break; }
    case 9666: // $38547
      var $38548=___cxa_allocate_exception(4);
      var $38549=$38548;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38549);
      (function() { try { __THREW__ = false; return ___cxa_throw($38548, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9670; break; } else { __label__ = 9667; break; }
    case 9667: // $38550
      var $38551=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38552=$38551.f0;
      HEAP32[(($2232)>>2)]=$38552;
      var $38553=$38551.f1;
      HEAP32[(($2233)>>2)]=$38553;
      var $38554=HEAP32[(($2233)>>2)];
      var $38555=(($38554)|0) < 0;
      if ($38555) { __label__ = 9668; break; } else { __label__ = 9669; break; }
    case 9668: // $38556
      var $38557=HEAP32[(($2232)>>2)];
      ___cxa_call_unexpected($38557);
      throw "Reached an unreachable!"
    case 9669: // $38558
      var $38559=HEAP32[(($2232)>>2)];
      var $38560=HEAP32[(($2232)>>2)];
      var $38561=HEAP32[(($2233)>>2)];
      var $38562=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38560, tempValue);
      var $38563=($38562.f1 = $38561, $38562);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9670: // $38564
      throw "Reached an unreachable!"
    case 9671: // $_ZnwjPKci_exit982
      var $38565=HEAP32[(($result_i981)>>2)];
      var $38566=$2229;
      var $38567=$2230;
      var $38568=$2231;
      var $38569=$result_i981;
      var $38570=$2232;
      var $38571=$2233;
      var $38572=$38565;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10429, 3, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9672; break; } else { __label__ = 14136; break; }
    case 9672: // $38573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10430, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9673; break; } else { __label__ = 14136; break; }
    case 9673: // $38574
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10431, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9674; break; } else { __label__ = 14136; break; }
    case 9674: // $38575
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10432, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9675; break; } else { __label__ = 14136; break; }
    case 9675: // $38576
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10433, 4, 1, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9676; break; } else { __label__ = 14136; break; }
    case 9676: // $38577
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9677; break; } else { __label__ = 14136; break; }
    case 9677: // $38578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9678; break; } else { __label__ = 14136; break; }
    case 9678: // $38579
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10428, $10429, $10430, $10431, $10432, $10433, $10434, $10435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9679; break; } else { __label__ = 14136; break; }
    case 9679: // $38580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10437, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9680; break; } else { __label__ = 14136; break; }
    case 9680: // $38581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10438, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9681; break; } else { __label__ = 14136; break; }
    case 9681: // $38582
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10439, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9682; break; } else { __label__ = 14136; break; }
    case 9682: // $38583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9683; break; } else { __label__ = 14136; break; }
    case 9683: // $38584
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9684; break; } else { __label__ = 14136; break; }
    case 9684: // $38585
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9685; break; } else { __label__ = 14136; break; }
    case 9685: // $38586
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9686; break; } else { __label__ = 14136; break; }
    case 9686: // $38587
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10436, $10437, $10438, $10439, $10440, $10441, $10442, $10443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9687; break; } else { __label__ = 14136; break; }
    case 9687: // $38588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10445, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9688; break; } else { __label__ = 14136; break; }
    case 9688: // $38589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10446, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9689; break; } else { __label__ = 14136; break; }
    case 9689: // $38590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10447, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9690; break; } else { __label__ = 14136; break; }
    case 9690: // $38591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9691; break; } else { __label__ = 14136; break; }
    case 9691: // $38592
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9692; break; } else { __label__ = 14136; break; }
    case 9692: // $38593
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9693; break; } else { __label__ = 14136; break; }
    case 9693: // $38594
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9694; break; } else { __label__ = 14136; break; }
    case 9694: // $38595
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10444, $10445, $10446, $10447, $10448, $10449, $10450, $10451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9695; break; } else { __label__ = 14136; break; }
    case 9695: // $38596
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38572, 145, 2, 1, ((STRING_TABLE.__str1172)|0), ((STRING_TABLE.__str1173)|0), $10428, $10436, $10444) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9696; break; } else { __label__ = 14136; break; }
    case 9696: // $38597
      var $38598=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38572);
      var $38599=__ZN11simple_listI16input_type_entryE6appendERS0_($38533, $38598);
      var $38600=$4689;
      var $38601=$2224;
      var $38602=$2225;
      var $38603=$2226;
      var $38604=$result_i983;
      var $38605=$2227;
      var $38606=$2228;
      HEAP32[(($2224)>>2)]=408;
      HEAP32[(($2225)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2226)>>2)]=573;
      var $38607=HEAP32[(($2224)>>2)];
      var $38608=HEAP32[(($2225)>>2)];
      var $38609=HEAP32[(($2226)>>2)];
      var $38610=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38607, $38608, $38609) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9697; break; } else { __label__ = 9699; break; };
    case 9697: // $38611
      HEAP32[(($result_i983)>>2)]=$38610;
      var $38612=HEAP32[(($result_i983)>>2)];
      var $38613=(($38612)|0)==0;
      if ($38613) { __label__ = 9698; break; } else { __label__ = 9703; break; }
    case 9698: // $38614
      var $38615=___cxa_allocate_exception(4);
      var $38616=$38615;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38616);
      (function() { try { __THREW__ = false; return ___cxa_throw($38615, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9702; break; } else { __label__ = 9699; break; }
    case 9699: // $38617
      var $38618=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38619=$38618.f0;
      HEAP32[(($2227)>>2)]=$38619;
      var $38620=$38618.f1;
      HEAP32[(($2228)>>2)]=$38620;
      var $38621=HEAP32[(($2228)>>2)];
      var $38622=(($38621)|0) < 0;
      if ($38622) { __label__ = 9700; break; } else { __label__ = 9701; break; }
    case 9700: // $38623
      var $38624=HEAP32[(($2227)>>2)];
      ___cxa_call_unexpected($38624);
      throw "Reached an unreachable!"
    case 9701: // $38625
      var $38626=HEAP32[(($2227)>>2)];
      var $38627=HEAP32[(($2227)>>2)];
      var $38628=HEAP32[(($2228)>>2)];
      var $38629=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38627, tempValue);
      var $38630=($38629.f1 = $38628, $38629);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9702: // $38631
      throw "Reached an unreachable!"
    case 9703: // $_ZnwjPKci_exit984
      var $38632=HEAP32[(($result_i983)>>2)];
      var $38633=$2224;
      var $38634=$2225;
      var $38635=$2226;
      var $38636=$result_i983;
      var $38637=$2227;
      var $38638=$2228;
      var $38639=$38632;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10453, 3, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9704; break; } else { __label__ = 14141; break; }
    case 9704: // $38640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10454, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9705; break; } else { __label__ = 14141; break; }
    case 9705: // $38641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10455, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9706; break; } else { __label__ = 14141; break; }
    case 9706: // $38642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10456, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9707; break; } else { __label__ = 14141; break; }
    case 9707: // $38643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10457, 4, 2, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9708; break; } else { __label__ = 14141; break; }
    case 9708: // $38644
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9709; break; } else { __label__ = 14141; break; }
    case 9709: // $38645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9710; break; } else { __label__ = 14141; break; }
    case 9710: // $38646
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10452, $10453, $10454, $10455, $10456, $10457, $10458, $10459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9711; break; } else { __label__ = 14141; break; }
    case 9711: // $38647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10461, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9712; break; } else { __label__ = 14141; break; }
    case 9712: // $38648
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10462, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9713; break; } else { __label__ = 14141; break; }
    case 9713: // $38649
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10463, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9714; break; } else { __label__ = 14141; break; }
    case 9714: // $38650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9715; break; } else { __label__ = 14141; break; }
    case 9715: // $38651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9716; break; } else { __label__ = 14141; break; }
    case 9716: // $38652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9717; break; } else { __label__ = 14141; break; }
    case 9717: // $38653
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9718; break; } else { __label__ = 14141; break; }
    case 9718: // $38654
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10460, $10461, $10462, $10463, $10464, $10465, $10466, $10467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9719; break; } else { __label__ = 14141; break; }
    case 9719: // $38655
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10469, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9720; break; } else { __label__ = 14141; break; }
    case 9720: // $38656
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10470, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9721; break; } else { __label__ = 14141; break; }
    case 9721: // $38657
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10471, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9722; break; } else { __label__ = 14141; break; }
    case 9722: // $38658
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9723; break; } else { __label__ = 14141; break; }
    case 9723: // $38659
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9724; break; } else { __label__ = 14141; break; }
    case 9724: // $38660
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9725; break; } else { __label__ = 14141; break; }
    case 9725: // $38661
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9726; break; } else { __label__ = 14141; break; }
    case 9726: // $38662
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10468, $10469, $10470, $10471, $10472, $10473, $10474, $10475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9727; break; } else { __label__ = 14141; break; }
    case 9727: // $38663
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38639, 145, 3, 2, ((STRING_TABLE.__str1174)|0), ((STRING_TABLE.__str1175)|0), $10452, $10460, $10468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9728; break; } else { __label__ = 14141; break; }
    case 9728: // $38664
      var $38665=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38639);
      var $38666=__ZN11simple_listI16input_type_entryE6appendERS0_($38600, $38665);
      var $38667=$4689;
      var $38668=$2219;
      var $38669=$2220;
      var $38670=$2221;
      var $38671=$result_i985;
      var $38672=$2222;
      var $38673=$2223;
      HEAP32[(($2219)>>2)]=408;
      HEAP32[(($2220)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2221)>>2)]=574;
      var $38674=HEAP32[(($2219)>>2)];
      var $38675=HEAP32[(($2220)>>2)];
      var $38676=HEAP32[(($2221)>>2)];
      var $38677=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38674, $38675, $38676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9729; break; } else { __label__ = 9731; break; };
    case 9729: // $38678
      HEAP32[(($result_i985)>>2)]=$38677;
      var $38679=HEAP32[(($result_i985)>>2)];
      var $38680=(($38679)|0)==0;
      if ($38680) { __label__ = 9730; break; } else { __label__ = 9735; break; }
    case 9730: // $38681
      var $38682=___cxa_allocate_exception(4);
      var $38683=$38682;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38683);
      (function() { try { __THREW__ = false; return ___cxa_throw($38682, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9734; break; } else { __label__ = 9731; break; }
    case 9731: // $38684
      var $38685=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38686=$38685.f0;
      HEAP32[(($2222)>>2)]=$38686;
      var $38687=$38685.f1;
      HEAP32[(($2223)>>2)]=$38687;
      var $38688=HEAP32[(($2223)>>2)];
      var $38689=(($38688)|0) < 0;
      if ($38689) { __label__ = 9732; break; } else { __label__ = 9733; break; }
    case 9732: // $38690
      var $38691=HEAP32[(($2222)>>2)];
      ___cxa_call_unexpected($38691);
      throw "Reached an unreachable!"
    case 9733: // $38692
      var $38693=HEAP32[(($2222)>>2)];
      var $38694=HEAP32[(($2222)>>2)];
      var $38695=HEAP32[(($2223)>>2)];
      var $38696=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38694, tempValue);
      var $38697=($38696.f1 = $38695, $38696);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9734: // $38698
      throw "Reached an unreachable!"
    case 9735: // $_ZnwjPKci_exit986
      var $38699=HEAP32[(($result_i985)>>2)];
      var $38700=$2219;
      var $38701=$2220;
      var $38702=$2221;
      var $38703=$result_i985;
      var $38704=$2222;
      var $38705=$2223;
      var $38706=$38699;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10477, 3, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9736; break; } else { __label__ = 14146; break; }
    case 9736: // $38707
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10478, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9737; break; } else { __label__ = 14146; break; }
    case 9737: // $38708
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10479, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9738; break; } else { __label__ = 14146; break; }
    case 9738: // $38709
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10480, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9739; break; } else { __label__ = 14146; break; }
    case 9739: // $38710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10481, 4, 3, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9740; break; } else { __label__ = 14146; break; }
    case 9740: // $38711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9741; break; } else { __label__ = 14146; break; }
    case 9741: // $38712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9742; break; } else { __label__ = 14146; break; }
    case 9742: // $38713
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10476, $10477, $10478, $10479, $10480, $10481, $10482, $10483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9743; break; } else { __label__ = 14146; break; }
    case 9743: // $38714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10485, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9744; break; } else { __label__ = 14146; break; }
    case 9744: // $38715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10486, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9745; break; } else { __label__ = 14146; break; }
    case 9745: // $38716
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10487, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9746; break; } else { __label__ = 14146; break; }
    case 9746: // $38717
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9747; break; } else { __label__ = 14146; break; }
    case 9747: // $38718
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9748; break; } else { __label__ = 14146; break; }
    case 9748: // $38719
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9749; break; } else { __label__ = 14146; break; }
    case 9749: // $38720
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9750; break; } else { __label__ = 14146; break; }
    case 9750: // $38721
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10484, $10485, $10486, $10487, $10488, $10489, $10490, $10491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9751; break; } else { __label__ = 14146; break; }
    case 9751: // $38722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10493, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9752; break; } else { __label__ = 14146; break; }
    case 9752: // $38723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10494, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9753; break; } else { __label__ = 14146; break; }
    case 9753: // $38724
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10495, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9754; break; } else { __label__ = 14146; break; }
    case 9754: // $38725
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9755; break; } else { __label__ = 14146; break; }
    case 9755: // $38726
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9756; break; } else { __label__ = 14146; break; }
    case 9756: // $38727
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9757; break; } else { __label__ = 14146; break; }
    case 9757: // $38728
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9758; break; } else { __label__ = 14146; break; }
    case 9758: // $38729
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10492, $10493, $10494, $10495, $10496, $10497, $10498, $10499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9759; break; } else { __label__ = 14146; break; }
    case 9759: // $38730
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38706, 145, 4, 3, ((STRING_TABLE.__str1176)|0), ((STRING_TABLE.__str1177)|0), $10476, $10484, $10492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9760; break; } else { __label__ = 14146; break; }
    case 9760: // $38731
      var $38732=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38706);
      var $38733=__ZN11simple_listI16input_type_entryE6appendERS0_($38667, $38732);
      var $38734=$4689;
      var $38735=$2214;
      var $38736=$2215;
      var $38737=$2216;
      var $38738=$result_i987;
      var $38739=$2217;
      var $38740=$2218;
      HEAP32[(($2214)>>2)]=408;
      HEAP32[(($2215)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2216)>>2)]=575;
      var $38741=HEAP32[(($2214)>>2)];
      var $38742=HEAP32[(($2215)>>2)];
      var $38743=HEAP32[(($2216)>>2)];
      var $38744=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38741, $38742, $38743) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9761; break; } else { __label__ = 9763; break; };
    case 9761: // $38745
      HEAP32[(($result_i987)>>2)]=$38744;
      var $38746=HEAP32[(($result_i987)>>2)];
      var $38747=(($38746)|0)==0;
      if ($38747) { __label__ = 9762; break; } else { __label__ = 9767; break; }
    case 9762: // $38748
      var $38749=___cxa_allocate_exception(4);
      var $38750=$38749;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38750);
      (function() { try { __THREW__ = false; return ___cxa_throw($38749, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9766; break; } else { __label__ = 9763; break; }
    case 9763: // $38751
      var $38752=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38753=$38752.f0;
      HEAP32[(($2217)>>2)]=$38753;
      var $38754=$38752.f1;
      HEAP32[(($2218)>>2)]=$38754;
      var $38755=HEAP32[(($2218)>>2)];
      var $38756=(($38755)|0) < 0;
      if ($38756) { __label__ = 9764; break; } else { __label__ = 9765; break; }
    case 9764: // $38757
      var $38758=HEAP32[(($2217)>>2)];
      ___cxa_call_unexpected($38758);
      throw "Reached an unreachable!"
    case 9765: // $38759
      var $38760=HEAP32[(($2217)>>2)];
      var $38761=HEAP32[(($2217)>>2)];
      var $38762=HEAP32[(($2218)>>2)];
      var $38763=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38761, tempValue);
      var $38764=($38763.f1 = $38762, $38763);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9766: // $38765
      throw "Reached an unreachable!"
    case 9767: // $_ZnwjPKci_exit988
      var $38766=HEAP32[(($result_i987)>>2)];
      var $38767=$2214;
      var $38768=$2215;
      var $38769=$2216;
      var $38770=$result_i987;
      var $38771=$2217;
      var $38772=$2218;
      var $38773=$38766;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10501, 3, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9768; break; } else { __label__ = 14151; break; }
    case 9768: // $38774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10502, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9769; break; } else { __label__ = 14151; break; }
    case 9769: // $38775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10503, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9770; break; } else { __label__ = 14151; break; }
    case 9770: // $38776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10504, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9771; break; } else { __label__ = 14151; break; }
    case 9771: // $38777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10505, 4, 4, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9772; break; } else { __label__ = 14151; break; }
    case 9772: // $38778
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9773; break; } else { __label__ = 14151; break; }
    case 9773: // $38779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9774; break; } else { __label__ = 14151; break; }
    case 9774: // $38780
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10500, $10501, $10502, $10503, $10504, $10505, $10506, $10507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9775; break; } else { __label__ = 14151; break; }
    case 9775: // $38781
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10509, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9776; break; } else { __label__ = 14151; break; }
    case 9776: // $38782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10510, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9777; break; } else { __label__ = 14151; break; }
    case 9777: // $38783
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10511, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9778; break; } else { __label__ = 14151; break; }
    case 9778: // $38784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9779; break; } else { __label__ = 14151; break; }
    case 9779: // $38785
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9780; break; } else { __label__ = 14151; break; }
    case 9780: // $38786
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9781; break; } else { __label__ = 14151; break; }
    case 9781: // $38787
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9782; break; } else { __label__ = 14151; break; }
    case 9782: // $38788
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10508, $10509, $10510, $10511, $10512, $10513, $10514, $10515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9783; break; } else { __label__ = 14151; break; }
    case 9783: // $38789
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10517, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9784; break; } else { __label__ = 14151; break; }
    case 9784: // $38790
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10518, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9785; break; } else { __label__ = 14151; break; }
    case 9785: // $38791
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10519, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9786; break; } else { __label__ = 14151; break; }
    case 9786: // $38792
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9787; break; } else { __label__ = 14151; break; }
    case 9787: // $38793
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9788; break; } else { __label__ = 14151; break; }
    case 9788: // $38794
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9789; break; } else { __label__ = 14151; break; }
    case 9789: // $38795
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9790; break; } else { __label__ = 14151; break; }
    case 9790: // $38796
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10516, $10517, $10518, $10519, $10520, $10521, $10522, $10523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9791; break; } else { __label__ = 14151; break; }
    case 9791: // $38797
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38773, 145, 5, 4, ((STRING_TABLE.__str1178)|0), ((STRING_TABLE.__str1179)|0), $10500, $10508, $10516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9792; break; } else { __label__ = 14151; break; }
    case 9792: // $38798
      var $38799=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38773);
      var $38800=__ZN11simple_listI16input_type_entryE6appendERS0_($38734, $38799);
      var $38801=$4689;
      var $38802=$2209;
      var $38803=$2210;
      var $38804=$2211;
      var $38805=$result_i989;
      var $38806=$2212;
      var $38807=$2213;
      HEAP32[(($2209)>>2)]=408;
      HEAP32[(($2210)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2211)>>2)]=576;
      var $38808=HEAP32[(($2209)>>2)];
      var $38809=HEAP32[(($2210)>>2)];
      var $38810=HEAP32[(($2211)>>2)];
      var $38811=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38808, $38809, $38810) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9793; break; } else { __label__ = 9795; break; };
    case 9793: // $38812
      HEAP32[(($result_i989)>>2)]=$38811;
      var $38813=HEAP32[(($result_i989)>>2)];
      var $38814=(($38813)|0)==0;
      if ($38814) { __label__ = 9794; break; } else { __label__ = 9799; break; }
    case 9794: // $38815
      var $38816=___cxa_allocate_exception(4);
      var $38817=$38816;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38817);
      (function() { try { __THREW__ = false; return ___cxa_throw($38816, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9798; break; } else { __label__ = 9795; break; }
    case 9795: // $38818
      var $38819=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38820=$38819.f0;
      HEAP32[(($2212)>>2)]=$38820;
      var $38821=$38819.f1;
      HEAP32[(($2213)>>2)]=$38821;
      var $38822=HEAP32[(($2213)>>2)];
      var $38823=(($38822)|0) < 0;
      if ($38823) { __label__ = 9796; break; } else { __label__ = 9797; break; }
    case 9796: // $38824
      var $38825=HEAP32[(($2212)>>2)];
      ___cxa_call_unexpected($38825);
      throw "Reached an unreachable!"
    case 9797: // $38826
      var $38827=HEAP32[(($2212)>>2)];
      var $38828=HEAP32[(($2212)>>2)];
      var $38829=HEAP32[(($2213)>>2)];
      var $38830=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38828, tempValue);
      var $38831=($38830.f1 = $38829, $38830);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9798: // $38832
      throw "Reached an unreachable!"
    case 9799: // $_ZnwjPKci_exit990
      var $38833=HEAP32[(($result_i989)>>2)];
      var $38834=$2209;
      var $38835=$2210;
      var $38836=$2211;
      var $38837=$result_i989;
      var $38838=$2212;
      var $38839=$2213;
      var $38840=$38833;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10525, 3, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9800; break; } else { __label__ = 14156; break; }
    case 9800: // $38841
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10526, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9801; break; } else { __label__ = 14156; break; }
    case 9801: // $38842
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10527, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9802; break; } else { __label__ = 14156; break; }
    case 9802: // $38843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10528, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9803; break; } else { __label__ = 14156; break; }
    case 9803: // $38844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10529, 4, 5, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9804; break; } else { __label__ = 14156; break; }
    case 9804: // $38845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9805; break; } else { __label__ = 14156; break; }
    case 9805: // $38846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9806; break; } else { __label__ = 14156; break; }
    case 9806: // $38847
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10524, $10525, $10526, $10527, $10528, $10529, $10530, $10531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9807; break; } else { __label__ = 14156; break; }
    case 9807: // $38848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10533, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9808; break; } else { __label__ = 14156; break; }
    case 9808: // $38849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10534, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9809; break; } else { __label__ = 14156; break; }
    case 9809: // $38850
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10535, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9810; break; } else { __label__ = 14156; break; }
    case 9810: // $38851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9811; break; } else { __label__ = 14156; break; }
    case 9811: // $38852
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9812; break; } else { __label__ = 14156; break; }
    case 9812: // $38853
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9813; break; } else { __label__ = 14156; break; }
    case 9813: // $38854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9814; break; } else { __label__ = 14156; break; }
    case 9814: // $38855
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10532, $10533, $10534, $10535, $10536, $10537, $10538, $10539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9815; break; } else { __label__ = 14156; break; }
    case 9815: // $38856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10541, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9816; break; } else { __label__ = 14156; break; }
    case 9816: // $38857
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10542, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9817; break; } else { __label__ = 14156; break; }
    case 9817: // $38858
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10543, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9818; break; } else { __label__ = 14156; break; }
    case 9818: // $38859
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9819; break; } else { __label__ = 14156; break; }
    case 9819: // $38860
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9820; break; } else { __label__ = 14156; break; }
    case 9820: // $38861
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9821; break; } else { __label__ = 14156; break; }
    case 9821: // $38862
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9822; break; } else { __label__ = 14156; break; }
    case 9822: // $38863
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10540, $10541, $10542, $10543, $10544, $10545, $10546, $10547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9823; break; } else { __label__ = 14156; break; }
    case 9823: // $38864
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38840, 145, 6, 5, ((STRING_TABLE.__str1180426)|0), ((STRING_TABLE.__str1181)|0), $10524, $10532, $10540) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9824; break; } else { __label__ = 14156; break; }
    case 9824: // $38865
      var $38866=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38840);
      var $38867=__ZN11simple_listI16input_type_entryE6appendERS0_($38801, $38866);
      var $38868=$4689;
      var $38869=$2204;
      var $38870=$2205;
      var $38871=$2206;
      var $38872=$result_i991;
      var $38873=$2207;
      var $38874=$2208;
      HEAP32[(($2204)>>2)]=408;
      HEAP32[(($2205)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2206)>>2)]=577;
      var $38875=HEAP32[(($2204)>>2)];
      var $38876=HEAP32[(($2205)>>2)];
      var $38877=HEAP32[(($2206)>>2)];
      var $38878=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38875, $38876, $38877) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9825; break; } else { __label__ = 9827; break; };
    case 9825: // $38879
      HEAP32[(($result_i991)>>2)]=$38878;
      var $38880=HEAP32[(($result_i991)>>2)];
      var $38881=(($38880)|0)==0;
      if ($38881) { __label__ = 9826; break; } else { __label__ = 9831; break; }
    case 9826: // $38882
      var $38883=___cxa_allocate_exception(4);
      var $38884=$38883;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38884);
      (function() { try { __THREW__ = false; return ___cxa_throw($38883, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9830; break; } else { __label__ = 9827; break; }
    case 9827: // $38885
      var $38886=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38887=$38886.f0;
      HEAP32[(($2207)>>2)]=$38887;
      var $38888=$38886.f1;
      HEAP32[(($2208)>>2)]=$38888;
      var $38889=HEAP32[(($2208)>>2)];
      var $38890=(($38889)|0) < 0;
      if ($38890) { __label__ = 9828; break; } else { __label__ = 9829; break; }
    case 9828: // $38891
      var $38892=HEAP32[(($2207)>>2)];
      ___cxa_call_unexpected($38892);
      throw "Reached an unreachable!"
    case 9829: // $38893
      var $38894=HEAP32[(($2207)>>2)];
      var $38895=HEAP32[(($2207)>>2)];
      var $38896=HEAP32[(($2208)>>2)];
      var $38897=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38895, tempValue);
      var $38898=($38897.f1 = $38896, $38897);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9830: // $38899
      throw "Reached an unreachable!"
    case 9831: // $_ZnwjPKci_exit992
      var $38900=HEAP32[(($result_i991)>>2)];
      var $38901=$2204;
      var $38902=$2205;
      var $38903=$2206;
      var $38904=$result_i991;
      var $38905=$2207;
      var $38906=$2208;
      var $38907=$38900;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10549, 3, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9832; break; } else { __label__ = 14161; break; }
    case 9832: // $38908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10550, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9833; break; } else { __label__ = 14161; break; }
    case 9833: // $38909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10551, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9834; break; } else { __label__ = 14161; break; }
    case 9834: // $38910
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10552, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9835; break; } else { __label__ = 14161; break; }
    case 9835: // $38911
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10553, 4, 6, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9836; break; } else { __label__ = 14161; break; }
    case 9836: // $38912
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10554, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9837; break; } else { __label__ = 14161; break; }
    case 9837: // $38913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10555, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9838; break; } else { __label__ = 14161; break; }
    case 9838: // $38914
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10548, $10549, $10550, $10551, $10552, $10553, $10554, $10555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9839; break; } else { __label__ = 14161; break; }
    case 9839: // $38915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10557, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9840; break; } else { __label__ = 14161; break; }
    case 9840: // $38916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10558, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9841; break; } else { __label__ = 14161; break; }
    case 9841: // $38917
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10559, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9842; break; } else { __label__ = 14161; break; }
    case 9842: // $38918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10560, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9843; break; } else { __label__ = 14161; break; }
    case 9843: // $38919
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10561, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9844; break; } else { __label__ = 14161; break; }
    case 9844: // $38920
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10562, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9845; break; } else { __label__ = 14161; break; }
    case 9845: // $38921
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10563, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9846; break; } else { __label__ = 14161; break; }
    case 9846: // $38922
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10556, $10557, $10558, $10559, $10560, $10561, $10562, $10563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9847; break; } else { __label__ = 14161; break; }
    case 9847: // $38923
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10565, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9848; break; } else { __label__ = 14161; break; }
    case 9848: // $38924
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10566, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9849; break; } else { __label__ = 14161; break; }
    case 9849: // $38925
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10567, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9850; break; } else { __label__ = 14161; break; }
    case 9850: // $38926
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10568, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9851; break; } else { __label__ = 14161; break; }
    case 9851: // $38927
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10569, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9852; break; } else { __label__ = 14161; break; }
    case 9852: // $38928
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9853; break; } else { __label__ = 14161; break; }
    case 9853: // $38929
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9854; break; } else { __label__ = 14161; break; }
    case 9854: // $38930
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10564, $10565, $10566, $10567, $10568, $10569, $10570, $10571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9855; break; } else { __label__ = 14161; break; }
    case 9855: // $38931
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38907, 145, 7, 6, ((STRING_TABLE.__str1182)|0), ((STRING_TABLE.__str1183)|0), $10548, $10556, $10564) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9856; break; } else { __label__ = 14161; break; }
    case 9856: // $38932
      var $38933=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38907);
      var $38934=__ZN11simple_listI16input_type_entryE6appendERS0_($38868, $38933);
      var $38935=$4689;
      var $38936=$2199;
      var $38937=$2200;
      var $38938=$2201;
      var $38939=$result_i993;
      var $38940=$2202;
      var $38941=$2203;
      HEAP32[(($2199)>>2)]=408;
      HEAP32[(($2200)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2201)>>2)]=578;
      var $38942=HEAP32[(($2199)>>2)];
      var $38943=HEAP32[(($2200)>>2)];
      var $38944=HEAP32[(($2201)>>2)];
      var $38945=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38942, $38943, $38944) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9857; break; } else { __label__ = 9859; break; };
    case 9857: // $38946
      HEAP32[(($result_i993)>>2)]=$38945;
      var $38947=HEAP32[(($result_i993)>>2)];
      var $38948=(($38947)|0)==0;
      if ($38948) { __label__ = 9858; break; } else { __label__ = 9863; break; }
    case 9858: // $38949
      var $38950=___cxa_allocate_exception(4);
      var $38951=$38950;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38951);
      (function() { try { __THREW__ = false; return ___cxa_throw($38950, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9862; break; } else { __label__ = 9859; break; }
    case 9859: // $38952
      var $38953=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38954=$38953.f0;
      HEAP32[(($2202)>>2)]=$38954;
      var $38955=$38953.f1;
      HEAP32[(($2203)>>2)]=$38955;
      var $38956=HEAP32[(($2203)>>2)];
      var $38957=(($38956)|0) < 0;
      if ($38957) { __label__ = 9860; break; } else { __label__ = 9861; break; }
    case 9860: // $38958
      var $38959=HEAP32[(($2202)>>2)];
      ___cxa_call_unexpected($38959);
      throw "Reached an unreachable!"
    case 9861: // $38960
      var $38961=HEAP32[(($2202)>>2)];
      var $38962=HEAP32[(($2202)>>2)];
      var $38963=HEAP32[(($2203)>>2)];
      var $38964=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38962, tempValue);
      var $38965=($38964.f1 = $38963, $38964);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9862: // $38966
      throw "Reached an unreachable!"
    case 9863: // $_ZnwjPKci_exit994
      var $38967=HEAP32[(($result_i993)>>2)];
      var $38968=$2199;
      var $38969=$2200;
      var $38970=$2201;
      var $38971=$result_i993;
      var $38972=$2202;
      var $38973=$2203;
      var $38974=$38967;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10573, 3, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9864; break; } else { __label__ = 14166; break; }
    case 9864: // $38975
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10574, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9865; break; } else { __label__ = 14166; break; }
    case 9865: // $38976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10575, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9866; break; } else { __label__ = 14166; break; }
    case 9866: // $38977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10576, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9867; break; } else { __label__ = 14166; break; }
    case 9867: // $38978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10577, 4, 7, 2, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9868; break; } else { __label__ = 14166; break; }
    case 9868: // $38979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9869; break; } else { __label__ = 14166; break; }
    case 9869: // $38980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9870; break; } else { __label__ = 14166; break; }
    case 9870: // $38981
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10572, $10573, $10574, $10575, $10576, $10577, $10578, $10579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9871; break; } else { __label__ = 14166; break; }
    case 9871: // $38982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10581, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9872; break; } else { __label__ = 14166; break; }
    case 9872: // $38983
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10582, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9873; break; } else { __label__ = 14166; break; }
    case 9873: // $38984
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10583, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9874; break; } else { __label__ = 14166; break; }
    case 9874: // $38985
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9875; break; } else { __label__ = 14166; break; }
    case 9875: // $38986
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9876; break; } else { __label__ = 14166; break; }
    case 9876: // $38987
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9877; break; } else { __label__ = 14166; break; }
    case 9877: // $38988
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9878; break; } else { __label__ = 14166; break; }
    case 9878: // $38989
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10580, $10581, $10582, $10583, $10584, $10585, $10586, $10587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9879; break; } else { __label__ = 14166; break; }
    case 9879: // $38990
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10589, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9880; break; } else { __label__ = 14166; break; }
    case 9880: // $38991
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10590, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9881; break; } else { __label__ = 14166; break; }
    case 9881: // $38992
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10591, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9882; break; } else { __label__ = 14166; break; }
    case 9882: // $38993
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9883; break; } else { __label__ = 14166; break; }
    case 9883: // $38994
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9884; break; } else { __label__ = 14166; break; }
    case 9884: // $38995
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9885; break; } else { __label__ = 14166; break; }
    case 9885: // $38996
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9886; break; } else { __label__ = 14166; break; }
    case 9886: // $38997
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10588, $10589, $10590, $10591, $10592, $10593, $10594, $10595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9887; break; } else { __label__ = 14166; break; }
    case 9887: // $38998
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($38974, 145, 8, 7, ((STRING_TABLE.__str1184)|0), ((STRING_TABLE.__str1185)|0), $10572, $10580, $10588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9888; break; } else { __label__ = 14166; break; }
    case 9888: // $38999
      var $39000=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $38974);
      var $39001=__ZN11simple_listI16input_type_entryE6appendERS0_($38935, $39000);
      var $39002=$4689;
      var $39003=$2194;
      var $39004=$2195;
      var $39005=$2196;
      var $39006=$result_i995;
      var $39007=$2197;
      var $39008=$2198;
      HEAP32[(($2194)>>2)]=408;
      HEAP32[(($2195)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2196)>>2)]=580;
      var $39009=HEAP32[(($2194)>>2)];
      var $39010=HEAP32[(($2195)>>2)];
      var $39011=HEAP32[(($2196)>>2)];
      var $39012=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39009, $39010, $39011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9889; break; } else { __label__ = 9891; break; };
    case 9889: // $39013
      HEAP32[(($result_i995)>>2)]=$39012;
      var $39014=HEAP32[(($result_i995)>>2)];
      var $39015=(($39014)|0)==0;
      if ($39015) { __label__ = 9890; break; } else { __label__ = 9895; break; }
    case 9890: // $39016
      var $39017=___cxa_allocate_exception(4);
      var $39018=$39017;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39018);
      (function() { try { __THREW__ = false; return ___cxa_throw($39017, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9894; break; } else { __label__ = 9891; break; }
    case 9891: // $39019
      var $39020=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39021=$39020.f0;
      HEAP32[(($2197)>>2)]=$39021;
      var $39022=$39020.f1;
      HEAP32[(($2198)>>2)]=$39022;
      var $39023=HEAP32[(($2198)>>2)];
      var $39024=(($39023)|0) < 0;
      if ($39024) { __label__ = 9892; break; } else { __label__ = 9893; break; }
    case 9892: // $39025
      var $39026=HEAP32[(($2197)>>2)];
      ___cxa_call_unexpected($39026);
      throw "Reached an unreachable!"
    case 9893: // $39027
      var $39028=HEAP32[(($2197)>>2)];
      var $39029=HEAP32[(($2197)>>2)];
      var $39030=HEAP32[(($2198)>>2)];
      var $39031=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39029, tempValue);
      var $39032=($39031.f1 = $39030, $39031);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9894: // $39033
      throw "Reached an unreachable!"
    case 9895: // $_ZnwjPKci_exit996
      var $39034=HEAP32[(($result_i995)>>2)];
      var $39035=$2194;
      var $39036=$2195;
      var $39037=$2196;
      var $39038=$result_i995;
      var $39039=$2197;
      var $39040=$2198;
      var $39041=$39034;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10597, 3, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9896; break; } else { __label__ = 14171; break; }
    case 9896: // $39042
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10598, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9897; break; } else { __label__ = 14171; break; }
    case 9897: // $39043
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10599, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9898; break; } else { __label__ = 14171; break; }
    case 9898: // $39044
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10600, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9899; break; } else { __label__ = 14171; break; }
    case 9899: // $39045
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10601, 4, 0, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9900; break; } else { __label__ = 14171; break; }
    case 9900: // $39046
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9901; break; } else { __label__ = 14171; break; }
    case 9901: // $39047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9902; break; } else { __label__ = 14171; break; }
    case 9902: // $39048
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10596, $10597, $10598, $10599, $10600, $10601, $10602, $10603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9903; break; } else { __label__ = 14171; break; }
    case 9903: // $39049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10605, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9904; break; } else { __label__ = 14171; break; }
    case 9904: // $39050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10606, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9905; break; } else { __label__ = 14171; break; }
    case 9905: // $39051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10607, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9906; break; } else { __label__ = 14171; break; }
    case 9906: // $39052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9907; break; } else { __label__ = 14171; break; }
    case 9907: // $39053
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9908; break; } else { __label__ = 14171; break; }
    case 9908: // $39054
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9909; break; } else { __label__ = 14171; break; }
    case 9909: // $39055
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9910; break; } else { __label__ = 14171; break; }
    case 9910: // $39056
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10604, $10605, $10606, $10607, $10608, $10609, $10610, $10611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9911; break; } else { __label__ = 14171; break; }
    case 9911: // $39057
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10613, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9912; break; } else { __label__ = 14171; break; }
    case 9912: // $39058
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10614, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9913; break; } else { __label__ = 14171; break; }
    case 9913: // $39059
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10615, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9914; break; } else { __label__ = 14171; break; }
    case 9914: // $39060
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9915; break; } else { __label__ = 14171; break; }
    case 9915: // $39061
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9916; break; } else { __label__ = 14171; break; }
    case 9916: // $39062
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9917; break; } else { __label__ = 14171; break; }
    case 9917: // $39063
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9918; break; } else { __label__ = 14171; break; }
    case 9918: // $39064
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10612, $10613, $10614, $10615, $10616, $10617, $10618, $10619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9919; break; } else { __label__ = 14171; break; }
    case 9919: // $39065
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39041, 146, 1, 0, ((STRING_TABLE.__str1186)|0), ((STRING_TABLE.__str1187)|0), $10596, $10604, $10612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9920; break; } else { __label__ = 14171; break; }
    case 9920: // $39066
      var $39067=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39041);
      var $39068=__ZN11simple_listI16input_type_entryE6appendERS0_($39002, $39067);
      var $39069=$4689;
      var $39070=$2189;
      var $39071=$2190;
      var $39072=$2191;
      var $39073=$result_i997;
      var $39074=$2192;
      var $39075=$2193;
      HEAP32[(($2189)>>2)]=408;
      HEAP32[(($2190)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2191)>>2)]=581;
      var $39076=HEAP32[(($2189)>>2)];
      var $39077=HEAP32[(($2190)>>2)];
      var $39078=HEAP32[(($2191)>>2)];
      var $39079=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39076, $39077, $39078) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9921; break; } else { __label__ = 9923; break; };
    case 9921: // $39080
      HEAP32[(($result_i997)>>2)]=$39079;
      var $39081=HEAP32[(($result_i997)>>2)];
      var $39082=(($39081)|0)==0;
      if ($39082) { __label__ = 9922; break; } else { __label__ = 9927; break; }
    case 9922: // $39083
      var $39084=___cxa_allocate_exception(4);
      var $39085=$39084;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39085);
      (function() { try { __THREW__ = false; return ___cxa_throw($39084, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9926; break; } else { __label__ = 9923; break; }
    case 9923: // $39086
      var $39087=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39088=$39087.f0;
      HEAP32[(($2192)>>2)]=$39088;
      var $39089=$39087.f1;
      HEAP32[(($2193)>>2)]=$39089;
      var $39090=HEAP32[(($2193)>>2)];
      var $39091=(($39090)|0) < 0;
      if ($39091) { __label__ = 9924; break; } else { __label__ = 9925; break; }
    case 9924: // $39092
      var $39093=HEAP32[(($2192)>>2)];
      ___cxa_call_unexpected($39093);
      throw "Reached an unreachable!"
    case 9925: // $39094
      var $39095=HEAP32[(($2192)>>2)];
      var $39096=HEAP32[(($2192)>>2)];
      var $39097=HEAP32[(($2193)>>2)];
      var $39098=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39096, tempValue);
      var $39099=($39098.f1 = $39097, $39098);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9926: // $39100
      throw "Reached an unreachable!"
    case 9927: // $_ZnwjPKci_exit998
      var $39101=HEAP32[(($result_i997)>>2)];
      var $39102=$2189;
      var $39103=$2190;
      var $39104=$2191;
      var $39105=$result_i997;
      var $39106=$2192;
      var $39107=$2193;
      var $39108=$39101;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10621, 3, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9928; break; } else { __label__ = 14176; break; }
    case 9928: // $39109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10622, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9929; break; } else { __label__ = 14176; break; }
    case 9929: // $39110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10623, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9930; break; } else { __label__ = 14176; break; }
    case 9930: // $39111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10624, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9931; break; } else { __label__ = 14176; break; }
    case 9931: // $39112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10625, 4, 1, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9932; break; } else { __label__ = 14176; break; }
    case 9932: // $39113
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9933; break; } else { __label__ = 14176; break; }
    case 9933: // $39114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9934; break; } else { __label__ = 14176; break; }
    case 9934: // $39115
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10620, $10621, $10622, $10623, $10624, $10625, $10626, $10627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9935; break; } else { __label__ = 14176; break; }
    case 9935: // $39116
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10629, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9936; break; } else { __label__ = 14176; break; }
    case 9936: // $39117
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10630, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9937; break; } else { __label__ = 14176; break; }
    case 9937: // $39118
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10631, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9938; break; } else { __label__ = 14176; break; }
    case 9938: // $39119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9939; break; } else { __label__ = 14176; break; }
    case 9939: // $39120
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9940; break; } else { __label__ = 14176; break; }
    case 9940: // $39121
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9941; break; } else { __label__ = 14176; break; }
    case 9941: // $39122
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9942; break; } else { __label__ = 14176; break; }
    case 9942: // $39123
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10628, $10629, $10630, $10631, $10632, $10633, $10634, $10635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9943; break; } else { __label__ = 14176; break; }
    case 9943: // $39124
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10637, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9944; break; } else { __label__ = 14176; break; }
    case 9944: // $39125
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10638, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9945; break; } else { __label__ = 14176; break; }
    case 9945: // $39126
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10639, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9946; break; } else { __label__ = 14176; break; }
    case 9946: // $39127
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9947; break; } else { __label__ = 14176; break; }
    case 9947: // $39128
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9948; break; } else { __label__ = 14176; break; }
    case 9948: // $39129
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9949; break; } else { __label__ = 14176; break; }
    case 9949: // $39130
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9950; break; } else { __label__ = 14176; break; }
    case 9950: // $39131
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10636, $10637, $10638, $10639, $10640, $10641, $10642, $10643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9951; break; } else { __label__ = 14176; break; }
    case 9951: // $39132
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39108, 146, 2, 1, ((STRING_TABLE.__str1188)|0), ((STRING_TABLE.__str1189)|0), $10620, $10628, $10636) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9952; break; } else { __label__ = 14176; break; }
    case 9952: // $39133
      var $39134=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39108);
      var $39135=__ZN11simple_listI16input_type_entryE6appendERS0_($39069, $39134);
      var $39136=$4689;
      var $39137=$2184;
      var $39138=$2185;
      var $39139=$2186;
      var $39140=$result_i999;
      var $39141=$2187;
      var $39142=$2188;
      HEAP32[(($2184)>>2)]=408;
      HEAP32[(($2185)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2186)>>2)]=582;
      var $39143=HEAP32[(($2184)>>2)];
      var $39144=HEAP32[(($2185)>>2)];
      var $39145=HEAP32[(($2186)>>2)];
      var $39146=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39143, $39144, $39145) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9953; break; } else { __label__ = 9955; break; };
    case 9953: // $39147
      HEAP32[(($result_i999)>>2)]=$39146;
      var $39148=HEAP32[(($result_i999)>>2)];
      var $39149=(($39148)|0)==0;
      if ($39149) { __label__ = 9954; break; } else { __label__ = 9959; break; }
    case 9954: // $39150
      var $39151=___cxa_allocate_exception(4);
      var $39152=$39151;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39152);
      (function() { try { __THREW__ = false; return ___cxa_throw($39151, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9958; break; } else { __label__ = 9955; break; }
    case 9955: // $39153
      var $39154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39155=$39154.f0;
      HEAP32[(($2187)>>2)]=$39155;
      var $39156=$39154.f1;
      HEAP32[(($2188)>>2)]=$39156;
      var $39157=HEAP32[(($2188)>>2)];
      var $39158=(($39157)|0) < 0;
      if ($39158) { __label__ = 9956; break; } else { __label__ = 9957; break; }
    case 9956: // $39159
      var $39160=HEAP32[(($2187)>>2)];
      ___cxa_call_unexpected($39160);
      throw "Reached an unreachable!"
    case 9957: // $39161
      var $39162=HEAP32[(($2187)>>2)];
      var $39163=HEAP32[(($2187)>>2)];
      var $39164=HEAP32[(($2188)>>2)];
      var $39165=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39163, tempValue);
      var $39166=($39165.f1 = $39164, $39165);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9958: // $39167
      throw "Reached an unreachable!"
    case 9959: // $_ZnwjPKci_exit1000
      var $39168=HEAP32[(($result_i999)>>2)];
      var $39169=$2184;
      var $39170=$2185;
      var $39171=$2186;
      var $39172=$result_i999;
      var $39173=$2187;
      var $39174=$2188;
      var $39175=$39168;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10645, 3, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9960; break; } else { __label__ = 14181; break; }
    case 9960: // $39176
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10646, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9961; break; } else { __label__ = 14181; break; }
    case 9961: // $39177
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10647, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9962; break; } else { __label__ = 14181; break; }
    case 9962: // $39178
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10648, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9963; break; } else { __label__ = 14181; break; }
    case 9963: // $39179
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10649, 4, 2, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9964; break; } else { __label__ = 14181; break; }
    case 9964: // $39180
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9965; break; } else { __label__ = 14181; break; }
    case 9965: // $39181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9966; break; } else { __label__ = 14181; break; }
    case 9966: // $39182
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10644, $10645, $10646, $10647, $10648, $10649, $10650, $10651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9967; break; } else { __label__ = 14181; break; }
    case 9967: // $39183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10653, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9968; break; } else { __label__ = 14181; break; }
    case 9968: // $39184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10654, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9969; break; } else { __label__ = 14181; break; }
    case 9969: // $39185
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10655, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9970; break; } else { __label__ = 14181; break; }
    case 9970: // $39186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9971; break; } else { __label__ = 14181; break; }
    case 9971: // $39187
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9972; break; } else { __label__ = 14181; break; }
    case 9972: // $39188
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9973; break; } else { __label__ = 14181; break; }
    case 9973: // $39189
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9974; break; } else { __label__ = 14181; break; }
    case 9974: // $39190
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10652, $10653, $10654, $10655, $10656, $10657, $10658, $10659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9975; break; } else { __label__ = 14181; break; }
    case 9975: // $39191
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10661, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9976; break; } else { __label__ = 14181; break; }
    case 9976: // $39192
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10662, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9977; break; } else { __label__ = 14181; break; }
    case 9977: // $39193
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10663, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9978; break; } else { __label__ = 14181; break; }
    case 9978: // $39194
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9979; break; } else { __label__ = 14181; break; }
    case 9979: // $39195
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9980; break; } else { __label__ = 14181; break; }
    case 9980: // $39196
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9981; break; } else { __label__ = 14181; break; }
    case 9981: // $39197
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9982; break; } else { __label__ = 14181; break; }
    case 9982: // $39198
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10660, $10661, $10662, $10663, $10664, $10665, $10666, $10667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9983; break; } else { __label__ = 14181; break; }
    case 9983: // $39199
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39175, 146, 3, 2, ((STRING_TABLE.__str1190)|0), ((STRING_TABLE.__str1191)|0), $10644, $10652, $10660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9984; break; } else { __label__ = 14181; break; }
    case 9984: // $39200
      var $39201=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39175);
      var $39202=__ZN11simple_listI16input_type_entryE6appendERS0_($39136, $39201);
      var $39203=$4689;
      var $39204=$2179;
      var $39205=$2180;
      var $39206=$2181;
      var $39207=$result_i1001;
      var $39208=$2182;
      var $39209=$2183;
      HEAP32[(($2179)>>2)]=408;
      HEAP32[(($2180)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2181)>>2)]=583;
      var $39210=HEAP32[(($2179)>>2)];
      var $39211=HEAP32[(($2180)>>2)];
      var $39212=HEAP32[(($2181)>>2)];
      var $39213=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39210, $39211, $39212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9985; break; } else { __label__ = 9987; break; };
    case 9985: // $39214
      HEAP32[(($result_i1001)>>2)]=$39213;
      var $39215=HEAP32[(($result_i1001)>>2)];
      var $39216=(($39215)|0)==0;
      if ($39216) { __label__ = 9986; break; } else { __label__ = 9991; break; }
    case 9986: // $39217
      var $39218=___cxa_allocate_exception(4);
      var $39219=$39218;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39219);
      (function() { try { __THREW__ = false; return ___cxa_throw($39218, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9990; break; } else { __label__ = 9987; break; }
    case 9987: // $39220
      var $39221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39222=$39221.f0;
      HEAP32[(($2182)>>2)]=$39222;
      var $39223=$39221.f1;
      HEAP32[(($2183)>>2)]=$39223;
      var $39224=HEAP32[(($2183)>>2)];
      var $39225=(($39224)|0) < 0;
      if ($39225) { __label__ = 9988; break; } else { __label__ = 9989; break; }
    case 9988: // $39226
      var $39227=HEAP32[(($2182)>>2)];
      ___cxa_call_unexpected($39227);
      throw "Reached an unreachable!"
    case 9989: // $39228
      var $39229=HEAP32[(($2182)>>2)];
      var $39230=HEAP32[(($2182)>>2)];
      var $39231=HEAP32[(($2183)>>2)];
      var $39232=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39230, tempValue);
      var $39233=($39232.f1 = $39231, $39232);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9990: // $39234
      throw "Reached an unreachable!"
    case 9991: // $_ZnwjPKci_exit1002
      var $39235=HEAP32[(($result_i1001)>>2)];
      var $39236=$2179;
      var $39237=$2180;
      var $39238=$2181;
      var $39239=$result_i1001;
      var $39240=$2182;
      var $39241=$2183;
      var $39242=$39235;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10669, 3, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9992; break; } else { __label__ = 14186; break; }
    case 9992: // $39243
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10670, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9993; break; } else { __label__ = 14186; break; }
    case 9993: // $39244
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10671, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9994; break; } else { __label__ = 14186; break; }
    case 9994: // $39245
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10672, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9995; break; } else { __label__ = 14186; break; }
    case 9995: // $39246
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10673, 4, 3, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9996; break; } else { __label__ = 14186; break; }
    case 9996: // $39247
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9997; break; } else { __label__ = 14186; break; }
    case 9997: // $39248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9998; break; } else { __label__ = 14186; break; }
    case 9998: // $39249
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10668, $10669, $10670, $10671, $10672, $10673, $10674, $10675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9999; break; } else { __label__ = 14186; break; }
    case 9999: // $39250
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10677, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10000; break; } else { __label__ = 14186; break; }
    case 10000: // $39251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10678, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10001; break; } else { __label__ = 14186; break; }
    case 10001: // $39252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10679, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10002; break; } else { __label__ = 14186; break; }
    case 10002: // $39253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10003; break; } else { __label__ = 14186; break; }
    case 10003: // $39254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10004; break; } else { __label__ = 14186; break; }
    case 10004: // $39255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10005; break; } else { __label__ = 14186; break; }
    case 10005: // $39256
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10006; break; } else { __label__ = 14186; break; }
    case 10006: // $39257
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10676, $10677, $10678, $10679, $10680, $10681, $10682, $10683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10007; break; } else { __label__ = 14186; break; }
    case 10007: // $39258
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10685, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10008; break; } else { __label__ = 14186; break; }
    case 10008: // $39259
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10686, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10009; break; } else { __label__ = 14186; break; }
    case 10009: // $39260
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10687, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10010; break; } else { __label__ = 14186; break; }
    case 10010: // $39261
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10688, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10011; break; } else { __label__ = 14186; break; }
    case 10011: // $39262
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10689, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10012; break; } else { __label__ = 14186; break; }
    case 10012: // $39263
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10690, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10013; break; } else { __label__ = 14186; break; }
    case 10013: // $39264
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10691, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10014; break; } else { __label__ = 14186; break; }
    case 10014: // $39265
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10684, $10685, $10686, $10687, $10688, $10689, $10690, $10691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10015; break; } else { __label__ = 14186; break; }
    case 10015: // $39266
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39242, 146, 4, 3, ((STRING_TABLE.__str1192)|0), ((STRING_TABLE.__str1193)|0), $10668, $10676, $10684) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10016; break; } else { __label__ = 14186; break; }
    case 10016: // $39267
      var $39268=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39242);
      var $39269=__ZN11simple_listI16input_type_entryE6appendERS0_($39203, $39268);
      var $39270=$4689;
      var $39271=$2174;
      var $39272=$2175;
      var $39273=$2176;
      var $39274=$result_i1003;
      var $39275=$2177;
      var $39276=$2178;
      HEAP32[(($2174)>>2)]=408;
      HEAP32[(($2175)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2176)>>2)]=584;
      var $39277=HEAP32[(($2174)>>2)];
      var $39278=HEAP32[(($2175)>>2)];
      var $39279=HEAP32[(($2176)>>2)];
      var $39280=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39277, $39278, $39279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10017; break; } else { __label__ = 10019; break; };
    case 10017: // $39281
      HEAP32[(($result_i1003)>>2)]=$39280;
      var $39282=HEAP32[(($result_i1003)>>2)];
      var $39283=(($39282)|0)==0;
      if ($39283) { __label__ = 10018; break; } else { __label__ = 10023; break; }
    case 10018: // $39284
      var $39285=___cxa_allocate_exception(4);
      var $39286=$39285;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39286);
      (function() { try { __THREW__ = false; return ___cxa_throw($39285, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10022; break; } else { __label__ = 10019; break; }
    case 10019: // $39287
      var $39288=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39289=$39288.f0;
      HEAP32[(($2177)>>2)]=$39289;
      var $39290=$39288.f1;
      HEAP32[(($2178)>>2)]=$39290;
      var $39291=HEAP32[(($2178)>>2)];
      var $39292=(($39291)|0) < 0;
      if ($39292) { __label__ = 10020; break; } else { __label__ = 10021; break; }
    case 10020: // $39293
      var $39294=HEAP32[(($2177)>>2)];
      ___cxa_call_unexpected($39294);
      throw "Reached an unreachable!"
    case 10021: // $39295
      var $39296=HEAP32[(($2177)>>2)];
      var $39297=HEAP32[(($2177)>>2)];
      var $39298=HEAP32[(($2178)>>2)];
      var $39299=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39297, tempValue);
      var $39300=($39299.f1 = $39298, $39299);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10022: // $39301
      throw "Reached an unreachable!"
    case 10023: // $_ZnwjPKci_exit1004
      var $39302=HEAP32[(($result_i1003)>>2)];
      var $39303=$2174;
      var $39304=$2175;
      var $39305=$2176;
      var $39306=$result_i1003;
      var $39307=$2177;
      var $39308=$2178;
      var $39309=$39302;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10693, 3, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10024; break; } else { __label__ = 14191; break; }
    case 10024: // $39310
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10694, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10025; break; } else { __label__ = 14191; break; }
    case 10025: // $39311
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10695, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10026; break; } else { __label__ = 14191; break; }
    case 10026: // $39312
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10696, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10027; break; } else { __label__ = 14191; break; }
    case 10027: // $39313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10697, 4, 4, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10028; break; } else { __label__ = 14191; break; }
    case 10028: // $39314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10698, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10029; break; } else { __label__ = 14191; break; }
    case 10029: // $39315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10699, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10030; break; } else { __label__ = 14191; break; }
    case 10030: // $39316
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10692, $10693, $10694, $10695, $10696, $10697, $10698, $10699) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10031; break; } else { __label__ = 14191; break; }
    case 10031: // $39317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10701, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10032; break; } else { __label__ = 14191; break; }
    case 10032: // $39318
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10702, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10033; break; } else { __label__ = 14191; break; }
    case 10033: // $39319
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10703, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10034; break; } else { __label__ = 14191; break; }
    case 10034: // $39320
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10704, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10035; break; } else { __label__ = 14191; break; }
    case 10035: // $39321
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10705, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10036; break; } else { __label__ = 14191; break; }
    case 10036: // $39322
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10706, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10037; break; } else { __label__ = 14191; break; }
    case 10037: // $39323
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10707, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10038; break; } else { __label__ = 14191; break; }
    case 10038: // $39324
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10700, $10701, $10702, $10703, $10704, $10705, $10706, $10707) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10039; break; } else { __label__ = 14191; break; }
    case 10039: // $39325
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10709, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10040; break; } else { __label__ = 14191; break; }
    case 10040: // $39326
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10710, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10041; break; } else { __label__ = 14191; break; }
    case 10041: // $39327
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10711, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10042; break; } else { __label__ = 14191; break; }
    case 10042: // $39328
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10712, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10043; break; } else { __label__ = 14191; break; }
    case 10043: // $39329
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10713, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10044; break; } else { __label__ = 14191; break; }
    case 10044: // $39330
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10714, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10045; break; } else { __label__ = 14191; break; }
    case 10045: // $39331
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10715, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10046; break; } else { __label__ = 14191; break; }
    case 10046: // $39332
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10708, $10709, $10710, $10711, $10712, $10713, $10714, $10715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10047; break; } else { __label__ = 14191; break; }
    case 10047: // $39333
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39309, 146, 5, 4, ((STRING_TABLE.__str1194)|0), ((STRING_TABLE.__str1195)|0), $10692, $10700, $10708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10048; break; } else { __label__ = 14191; break; }
    case 10048: // $39334
      var $39335=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39309);
      var $39336=__ZN11simple_listI16input_type_entryE6appendERS0_($39270, $39335);
      var $39337=$4689;
      var $39338=$2169;
      var $39339=$2170;
      var $39340=$2171;
      var $39341=$result_i1005;
      var $39342=$2172;
      var $39343=$2173;
      HEAP32[(($2169)>>2)]=408;
      HEAP32[(($2170)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2171)>>2)]=585;
      var $39344=HEAP32[(($2169)>>2)];
      var $39345=HEAP32[(($2170)>>2)];
      var $39346=HEAP32[(($2171)>>2)];
      var $39347=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39344, $39345, $39346) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10049; break; } else { __label__ = 10051; break; };
    case 10049: // $39348
      HEAP32[(($result_i1005)>>2)]=$39347;
      var $39349=HEAP32[(($result_i1005)>>2)];
      var $39350=(($39349)|0)==0;
      if ($39350) { __label__ = 10050; break; } else { __label__ = 10055; break; }
    case 10050: // $39351
      var $39352=___cxa_allocate_exception(4);
      var $39353=$39352;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39353);
      (function() { try { __THREW__ = false; return ___cxa_throw($39352, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10054; break; } else { __label__ = 10051; break; }
    case 10051: // $39354
      var $39355=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39356=$39355.f0;
      HEAP32[(($2172)>>2)]=$39356;
      var $39357=$39355.f1;
      HEAP32[(($2173)>>2)]=$39357;
      var $39358=HEAP32[(($2173)>>2)];
      var $39359=(($39358)|0) < 0;
      if ($39359) { __label__ = 10052; break; } else { __label__ = 10053; break; }
    case 10052: // $39360
      var $39361=HEAP32[(($2172)>>2)];
      ___cxa_call_unexpected($39361);
      throw "Reached an unreachable!"
    case 10053: // $39362
      var $39363=HEAP32[(($2172)>>2)];
      var $39364=HEAP32[(($2172)>>2)];
      var $39365=HEAP32[(($2173)>>2)];
      var $39366=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39364, tempValue);
      var $39367=($39366.f1 = $39365, $39366);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10054: // $39368
      throw "Reached an unreachable!"
    case 10055: // $_ZnwjPKci_exit1006
      var $39369=HEAP32[(($result_i1005)>>2)];
      var $39370=$2169;
      var $39371=$2170;
      var $39372=$2171;
      var $39373=$result_i1005;
      var $39374=$2172;
      var $39375=$2173;
      var $39376=$39369;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10717, 3, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10056; break; } else { __label__ = 14196; break; }
    case 10056: // $39377
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10718, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10057; break; } else { __label__ = 14196; break; }
    case 10057: // $39378
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10719, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10058; break; } else { __label__ = 14196; break; }
    case 10058: // $39379
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10720, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10059; break; } else { __label__ = 14196; break; }
    case 10059: // $39380
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10721, 4, 5, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10060; break; } else { __label__ = 14196; break; }
    case 10060: // $39381
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10722, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10061; break; } else { __label__ = 14196; break; }
    case 10061: // $39382
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10723, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10062; break; } else { __label__ = 14196; break; }
    case 10062: // $39383
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10716, $10717, $10718, $10719, $10720, $10721, $10722, $10723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10063; break; } else { __label__ = 14196; break; }
    case 10063: // $39384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10725, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10064; break; } else { __label__ = 14196; break; }
    case 10064: // $39385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10726, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10065; break; } else { __label__ = 14196; break; }
    case 10065: // $39386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10727, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10066; break; } else { __label__ = 14196; break; }
    case 10066: // $39387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10728, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10067; break; } else { __label__ = 14196; break; }
    case 10067: // $39388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10729, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10068; break; } else { __label__ = 14196; break; }
    case 10068: // $39389
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10730, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10069; break; } else { __label__ = 14196; break; }
    case 10069: // $39390
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10731, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10070; break; } else { __label__ = 14196; break; }
    case 10070: // $39391
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10724, $10725, $10726, $10727, $10728, $10729, $10730, $10731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10071; break; } else { __label__ = 14196; break; }
    case 10071: // $39392
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10733, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10072; break; } else { __label__ = 14196; break; }
    case 10072: // $39393
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10734, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10073; break; } else { __label__ = 14196; break; }
    case 10073: // $39394
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10735, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10074; break; } else { __label__ = 14196; break; }
    case 10074: // $39395
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10736, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10075; break; } else { __label__ = 14196; break; }
    case 10075: // $39396
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10737, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10076; break; } else { __label__ = 14196; break; }
    case 10076: // $39397
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10738, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10077; break; } else { __label__ = 14196; break; }
    case 10077: // $39398
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10739, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10078; break; } else { __label__ = 14196; break; }
    case 10078: // $39399
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10732, $10733, $10734, $10735, $10736, $10737, $10738, $10739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10079; break; } else { __label__ = 14196; break; }
    case 10079: // $39400
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39376, 146, 6, 5, ((STRING_TABLE.__str1196)|0), ((STRING_TABLE.__str1197)|0), $10716, $10724, $10732) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10080; break; } else { __label__ = 14196; break; }
    case 10080: // $39401
      var $39402=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39376);
      var $39403=__ZN11simple_listI16input_type_entryE6appendERS0_($39337, $39402);
      var $39404=$4689;
      var $39405=$2164;
      var $39406=$2165;
      var $39407=$2166;
      var $39408=$result_i1007;
      var $39409=$2167;
      var $39410=$2168;
      HEAP32[(($2164)>>2)]=408;
      HEAP32[(($2165)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2166)>>2)]=586;
      var $39411=HEAP32[(($2164)>>2)];
      var $39412=HEAP32[(($2165)>>2)];
      var $39413=HEAP32[(($2166)>>2)];
      var $39414=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39411, $39412, $39413) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10081; break; } else { __label__ = 10083; break; };
    case 10081: // $39415
      HEAP32[(($result_i1007)>>2)]=$39414;
      var $39416=HEAP32[(($result_i1007)>>2)];
      var $39417=(($39416)|0)==0;
      if ($39417) { __label__ = 10082; break; } else { __label__ = 10087; break; }
    case 10082: // $39418
      var $39419=___cxa_allocate_exception(4);
      var $39420=$39419;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39420);
      (function() { try { __THREW__ = false; return ___cxa_throw($39419, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10086; break; } else { __label__ = 10083; break; }
    case 10083: // $39421
      var $39422=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39423=$39422.f0;
      HEAP32[(($2167)>>2)]=$39423;
      var $39424=$39422.f1;
      HEAP32[(($2168)>>2)]=$39424;
      var $39425=HEAP32[(($2168)>>2)];
      var $39426=(($39425)|0) < 0;
      if ($39426) { __label__ = 10084; break; } else { __label__ = 10085; break; }
    case 10084: // $39427
      var $39428=HEAP32[(($2167)>>2)];
      ___cxa_call_unexpected($39428);
      throw "Reached an unreachable!"
    case 10085: // $39429
      var $39430=HEAP32[(($2167)>>2)];
      var $39431=HEAP32[(($2167)>>2)];
      var $39432=HEAP32[(($2168)>>2)];
      var $39433=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39431, tempValue);
      var $39434=($39433.f1 = $39432, $39433);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10086: // $39435
      throw "Reached an unreachable!"
    case 10087: // $_ZnwjPKci_exit1008
      var $39436=HEAP32[(($result_i1007)>>2)];
      var $39437=$2164;
      var $39438=$2165;
      var $39439=$2166;
      var $39440=$result_i1007;
      var $39441=$2167;
      var $39442=$2168;
      var $39443=$39436;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10741, 3, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10088; break; } else { __label__ = 14201; break; }
    case 10088: // $39444
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10742, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10089; break; } else { __label__ = 14201; break; }
    case 10089: // $39445
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10743, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10090; break; } else { __label__ = 14201; break; }
    case 10090: // $39446
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10744, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10091; break; } else { __label__ = 14201; break; }
    case 10091: // $39447
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10745, 4, 6, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10092; break; } else { __label__ = 14201; break; }
    case 10092: // $39448
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10746, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10093; break; } else { __label__ = 14201; break; }
    case 10093: // $39449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10747, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10094; break; } else { __label__ = 14201; break; }
    case 10094: // $39450
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10740, $10741, $10742, $10743, $10744, $10745, $10746, $10747) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10095; break; } else { __label__ = 14201; break; }
    case 10095: // $39451
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10749, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10096; break; } else { __label__ = 14201; break; }
    case 10096: // $39452
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10750, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10097; break; } else { __label__ = 14201; break; }
    case 10097: // $39453
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10751, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10098; break; } else { __label__ = 14201; break; }
    case 10098: // $39454
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10752, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10099; break; } else { __label__ = 14201; break; }
    case 10099: // $39455
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10753, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10100; break; } else { __label__ = 14201; break; }
    case 10100: // $39456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10754, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10101; break; } else { __label__ = 14201; break; }
    case 10101: // $39457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10755, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10102; break; } else { __label__ = 14201; break; }
    case 10102: // $39458
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10748, $10749, $10750, $10751, $10752, $10753, $10754, $10755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10103; break; } else { __label__ = 14201; break; }
    case 10103: // $39459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10757, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10104; break; } else { __label__ = 14201; break; }
    case 10104: // $39460
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10758, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10105; break; } else { __label__ = 14201; break; }
    case 10105: // $39461
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10759, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10106; break; } else { __label__ = 14201; break; }
    case 10106: // $39462
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10760, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10107; break; } else { __label__ = 14201; break; }
    case 10107: // $39463
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10761, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10108; break; } else { __label__ = 14201; break; }
    case 10108: // $39464
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10762, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10109; break; } else { __label__ = 14201; break; }
    case 10109: // $39465
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10763, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10110; break; } else { __label__ = 14201; break; }
    case 10110: // $39466
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10756, $10757, $10758, $10759, $10760, $10761, $10762, $10763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10111; break; } else { __label__ = 14201; break; }
    case 10111: // $39467
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39443, 146, 7, 6, ((STRING_TABLE.__str1198)|0), ((STRING_TABLE.__str1199)|0), $10740, $10748, $10756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10112; break; } else { __label__ = 14201; break; }
    case 10112: // $39468
      var $39469=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39443);
      var $39470=__ZN11simple_listI16input_type_entryE6appendERS0_($39404, $39469);
      var $39471=$4689;
      var $39472=$2159;
      var $39473=$2160;
      var $39474=$2161;
      var $39475=$result_i1009;
      var $39476=$2162;
      var $39477=$2163;
      HEAP32[(($2159)>>2)]=408;
      HEAP32[(($2160)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2161)>>2)]=587;
      var $39478=HEAP32[(($2159)>>2)];
      var $39479=HEAP32[(($2160)>>2)];
      var $39480=HEAP32[(($2161)>>2)];
      var $39481=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39478, $39479, $39480) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10113; break; } else { __label__ = 10115; break; };
    case 10113: // $39482
      HEAP32[(($result_i1009)>>2)]=$39481;
      var $39483=HEAP32[(($result_i1009)>>2)];
      var $39484=(($39483)|0)==0;
      if ($39484) { __label__ = 10114; break; } else { __label__ = 10119; break; }
    case 10114: // $39485
      var $39486=___cxa_allocate_exception(4);
      var $39487=$39486;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39487);
      (function() { try { __THREW__ = false; return ___cxa_throw($39486, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10118; break; } else { __label__ = 10115; break; }
    case 10115: // $39488
      var $39489=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39490=$39489.f0;
      HEAP32[(($2162)>>2)]=$39490;
      var $39491=$39489.f1;
      HEAP32[(($2163)>>2)]=$39491;
      var $39492=HEAP32[(($2163)>>2)];
      var $39493=(($39492)|0) < 0;
      if ($39493) { __label__ = 10116; break; } else { __label__ = 10117; break; }
    case 10116: // $39494
      var $39495=HEAP32[(($2162)>>2)];
      ___cxa_call_unexpected($39495);
      throw "Reached an unreachable!"
    case 10117: // $39496
      var $39497=HEAP32[(($2162)>>2)];
      var $39498=HEAP32[(($2162)>>2)];
      var $39499=HEAP32[(($2163)>>2)];
      var $39500=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39498, tempValue);
      var $39501=($39500.f1 = $39499, $39500);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10118: // $39502
      throw "Reached an unreachable!"
    case 10119: // $_ZnwjPKci_exit1010
      var $39503=HEAP32[(($result_i1009)>>2)];
      var $39504=$2159;
      var $39505=$2160;
      var $39506=$2161;
      var $39507=$result_i1009;
      var $39508=$2162;
      var $39509=$2163;
      var $39510=$39503;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10765, 3, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10120; break; } else { __label__ = 14206; break; }
    case 10120: // $39511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10766, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10121; break; } else { __label__ = 14206; break; }
    case 10121: // $39512
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10767, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10122; break; } else { __label__ = 14206; break; }
    case 10122: // $39513
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10768, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10123; break; } else { __label__ = 14206; break; }
    case 10123: // $39514
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10769, 4, 7, 2, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10124; break; } else { __label__ = 14206; break; }
    case 10124: // $39515
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10770, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10125; break; } else { __label__ = 14206; break; }
    case 10125: // $39516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10771, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10126; break; } else { __label__ = 14206; break; }
    case 10126: // $39517
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10764, $10765, $10766, $10767, $10768, $10769, $10770, $10771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10127; break; } else { __label__ = 14206; break; }
    case 10127: // $39518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10773, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10128; break; } else { __label__ = 14206; break; }
    case 10128: // $39519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10774, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10129; break; } else { __label__ = 14206; break; }
    case 10129: // $39520
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10775, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10130; break; } else { __label__ = 14206; break; }
    case 10130: // $39521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10776, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10131; break; } else { __label__ = 14206; break; }
    case 10131: // $39522
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10777, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10132; break; } else { __label__ = 14206; break; }
    case 10132: // $39523
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10778, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10133; break; } else { __label__ = 14206; break; }
    case 10133: // $39524
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10779, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10134; break; } else { __label__ = 14206; break; }
    case 10134: // $39525
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10772, $10773, $10774, $10775, $10776, $10777, $10778, $10779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10135; break; } else { __label__ = 14206; break; }
    case 10135: // $39526
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10781, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10136; break; } else { __label__ = 14206; break; }
    case 10136: // $39527
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10782, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10137; break; } else { __label__ = 14206; break; }
    case 10137: // $39528
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10783, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10138; break; } else { __label__ = 14206; break; }
    case 10138: // $39529
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10784, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10139; break; } else { __label__ = 14206; break; }
    case 10139: // $39530
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10785, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10140; break; } else { __label__ = 14206; break; }
    case 10140: // $39531
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10786, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10141; break; } else { __label__ = 14206; break; }
    case 10141: // $39532
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10787, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10142; break; } else { __label__ = 14206; break; }
    case 10142: // $39533
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10780, $10781, $10782, $10783, $10784, $10785, $10786, $10787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10143; break; } else { __label__ = 14206; break; }
    case 10143: // $39534
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39510, 146, 8, 7, ((STRING_TABLE.__str1200)|0), ((STRING_TABLE.__str1201)|0), $10764, $10772, $10780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10144; break; } else { __label__ = 14206; break; }
    case 10144: // $39535
      var $39536=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39510);
      var $39537=__ZN11simple_listI16input_type_entryE6appendERS0_($39471, $39536);
      var $39538=$4689;
      var $39539=$2154;
      var $39540=$2155;
      var $39541=$2156;
      var $39542=$result_i1011;
      var $39543=$2157;
      var $39544=$2158;
      HEAP32[(($2154)>>2)]=408;
      HEAP32[(($2155)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2156)>>2)]=589;
      var $39545=HEAP32[(($2154)>>2)];
      var $39546=HEAP32[(($2155)>>2)];
      var $39547=HEAP32[(($2156)>>2)];
      var $39548=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39545, $39546, $39547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10145; break; } else { __label__ = 10147; break; };
    case 10145: // $39549
      HEAP32[(($result_i1011)>>2)]=$39548;
      var $39550=HEAP32[(($result_i1011)>>2)];
      var $39551=(($39550)|0)==0;
      if ($39551) { __label__ = 10146; break; } else { __label__ = 10151; break; }
    case 10146: // $39552
      var $39553=___cxa_allocate_exception(4);
      var $39554=$39553;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39554);
      (function() { try { __THREW__ = false; return ___cxa_throw($39553, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10150; break; } else { __label__ = 10147; break; }
    case 10147: // $39555
      var $39556=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39557=$39556.f0;
      HEAP32[(($2157)>>2)]=$39557;
      var $39558=$39556.f1;
      HEAP32[(($2158)>>2)]=$39558;
      var $39559=HEAP32[(($2158)>>2)];
      var $39560=(($39559)|0) < 0;
      if ($39560) { __label__ = 10148; break; } else { __label__ = 10149; break; }
    case 10148: // $39561
      var $39562=HEAP32[(($2157)>>2)];
      ___cxa_call_unexpected($39562);
      throw "Reached an unreachable!"
    case 10149: // $39563
      var $39564=HEAP32[(($2157)>>2)];
      var $39565=HEAP32[(($2157)>>2)];
      var $39566=HEAP32[(($2158)>>2)];
      var $39567=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39565, tempValue);
      var $39568=($39567.f1 = $39566, $39567);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10150: // $39569
      throw "Reached an unreachable!"
    case 10151: // $_ZnwjPKci_exit1012
      var $39570=HEAP32[(($result_i1011)>>2)];
      var $39571=$2154;
      var $39572=$2155;
      var $39573=$2156;
      var $39574=$result_i1011;
      var $39575=$2157;
      var $39576=$2158;
      var $39577=$39570;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10789, 2, 0, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10152; break; } else { __label__ = 14211; break; }
    case 10152: // $39578
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10790, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10153; break; } else { __label__ = 14211; break; }
    case 10153: // $39579
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10791, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10154; break; } else { __label__ = 14211; break; }
    case 10154: // $39580
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10792, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10155; break; } else { __label__ = 14211; break; }
    case 10155: // $39581
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10793, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10156; break; } else { __label__ = 14211; break; }
    case 10156: // $39582
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10794, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10157; break; } else { __label__ = 14211; break; }
    case 10157: // $39583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10795, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10158; break; } else { __label__ = 14211; break; }
    case 10158: // $39584
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10788, $10789, $10790, $10791, $10792, $10793, $10794, $10795) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10159; break; } else { __label__ = 14211; break; }
    case 10159: // $39585
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10797, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10160; break; } else { __label__ = 14211; break; }
    case 10160: // $39586
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10798, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10161; break; } else { __label__ = 14211; break; }
    case 10161: // $39587
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10799, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10162; break; } else { __label__ = 14211; break; }
    case 10162: // $39588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10800, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10163; break; } else { __label__ = 14211; break; }
    case 10163: // $39589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10801, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10164; break; } else { __label__ = 14211; break; }
    case 10164: // $39590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10802, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10165; break; } else { __label__ = 14211; break; }
    case 10165: // $39591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10803, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10166; break; } else { __label__ = 14211; break; }
    case 10166: // $39592
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10796, $10797, $10798, $10799, $10800, $10801, $10802, $10803) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10167; break; } else { __label__ = 14211; break; }
    case 10167: // $39593
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10805, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10168; break; } else { __label__ = 14211; break; }
    case 10168: // $39594
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10806, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10169; break; } else { __label__ = 14211; break; }
    case 10169: // $39595
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10807, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10170; break; } else { __label__ = 14211; break; }
    case 10170: // $39596
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10808, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10171; break; } else { __label__ = 14211; break; }
    case 10171: // $39597
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10809, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10172; break; } else { __label__ = 14211; break; }
    case 10172: // $39598
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10810, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10173; break; } else { __label__ = 14211; break; }
    case 10173: // $39599
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10811, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10174; break; } else { __label__ = 14211; break; }
    case 10174: // $39600
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10804, $10805, $10806, $10807, $10808, $10809, $10810, $10811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10175; break; } else { __label__ = 14211; break; }
    case 10175: // $39601
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39577, 156, 1, 0, ((STRING_TABLE.__str1202)|0), ((STRING_TABLE.__str1203)|0), $10788, $10796, $10804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10176; break; } else { __label__ = 14211; break; }
    case 10176: // $39602
      var $39603=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39577);
      var $39604=__ZN11simple_listI16input_type_entryE6appendERS0_($39538, $39603);
      var $39605=$4689;
      var $39606=$2149;
      var $39607=$2150;
      var $39608=$2151;
      var $39609=$result_i1013;
      var $39610=$2152;
      var $39611=$2153;
      HEAP32[(($2149)>>2)]=408;
      HEAP32[(($2150)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2151)>>2)]=590;
      var $39612=HEAP32[(($2149)>>2)];
      var $39613=HEAP32[(($2150)>>2)];
      var $39614=HEAP32[(($2151)>>2)];
      var $39615=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39612, $39613, $39614) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10177; break; } else { __label__ = 10179; break; };
    case 10177: // $39616
      HEAP32[(($result_i1013)>>2)]=$39615;
      var $39617=HEAP32[(($result_i1013)>>2)];
      var $39618=(($39617)|0)==0;
      if ($39618) { __label__ = 10178; break; } else { __label__ = 10183; break; }
    case 10178: // $39619
      var $39620=___cxa_allocate_exception(4);
      var $39621=$39620;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39621);
      (function() { try { __THREW__ = false; return ___cxa_throw($39620, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10182; break; } else { __label__ = 10179; break; }
    case 10179: // $39622
      var $39623=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39624=$39623.f0;
      HEAP32[(($2152)>>2)]=$39624;
      var $39625=$39623.f1;
      HEAP32[(($2153)>>2)]=$39625;
      var $39626=HEAP32[(($2153)>>2)];
      var $39627=(($39626)|0) < 0;
      if ($39627) { __label__ = 10180; break; } else { __label__ = 10181; break; }
    case 10180: // $39628
      var $39629=HEAP32[(($2152)>>2)];
      ___cxa_call_unexpected($39629);
      throw "Reached an unreachable!"
    case 10181: // $39630
      var $39631=HEAP32[(($2152)>>2)];
      var $39632=HEAP32[(($2152)>>2)];
      var $39633=HEAP32[(($2153)>>2)];
      var $39634=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39632, tempValue);
      var $39635=($39634.f1 = $39633, $39634);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10182: // $39636
      throw "Reached an unreachable!"
    case 10183: // $_ZnwjPKci_exit1014
      var $39637=HEAP32[(($result_i1013)>>2)];
      var $39638=$2149;
      var $39639=$2150;
      var $39640=$2151;
      var $39641=$result_i1013;
      var $39642=$2152;
      var $39643=$2153;
      var $39644=$39637;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10813, 2, 1, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10184; break; } else { __label__ = 14216; break; }
    case 10184: // $39645
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10814, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10185; break; } else { __label__ = 14216; break; }
    case 10185: // $39646
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10815, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10186; break; } else { __label__ = 14216; break; }
    case 10186: // $39647
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10816, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10187; break; } else { __label__ = 14216; break; }
    case 10187: // $39648
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10817, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10188; break; } else { __label__ = 14216; break; }
    case 10188: // $39649
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10818, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10189; break; } else { __label__ = 14216; break; }
    case 10189: // $39650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10819, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10190; break; } else { __label__ = 14216; break; }
    case 10190: // $39651
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10812, $10813, $10814, $10815, $10816, $10817, $10818, $10819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10191; break; } else { __label__ = 14216; break; }
    case 10191: // $39652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10821, 1, 0, 1, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10192; break; } else { __label__ = 14216; break; }
    case 10192: // $39653
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10822, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10193; break; } else { __label__ = 14216; break; }
    case 10193: // $39654
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10823, 4, 1, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10194; break; } else { __label__ = 14216; break; }
    case 10194: // $39655
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10824, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10195; break; } else { __label__ = 14216; break; }
    case 10195: // $39656
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10825, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10196; break; } else { __label__ = 14216; break; }
    case 10196: // $39657
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10826, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10197; break; } else { __label__ = 14216; break; }
    case 10197: // $39658
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10827, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10198; break; } else { __label__ = 14216; break; }
    case 10198: // $39659
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10820, $10821, $10822, $10823, $10824, $10825, $10826, $10827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10199; break; } else { __label__ = 14216; break; }
    case 10199: // $39660
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10829, 1, 0, 1, 0, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10200; break; } else { __label__ = 14216; break; }
    case 10200: // $39661
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10830, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10201; break; } else { __label__ = 14216; break; }
    case 10201: // $39662
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10831, 4, 1, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10202; break; } else { __label__ = 14216; break; }
    case 10202: // $39663
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10832, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10203; break; } else { __label__ = 14216; break; }
    case 10203: // $39664
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10833, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10204; break; } else { __label__ = 14216; break; }
    case 10204: // $39665
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10834, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10205; break; } else { __label__ = 14216; break; }
    case 10205: // $39666
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10835, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10206; break; } else { __label__ = 14216; break; }
    case 10206: // $39667
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10828, $10829, $10830, $10831, $10832, $10833, $10834, $10835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10207; break; } else { __label__ = 14216; break; }
    case 10207: // $39668
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39644, 156, 2, 1, ((STRING_TABLE.__str1204)|0), ((STRING_TABLE.__str1205)|0), $10812, $10820, $10828) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10208; break; } else { __label__ = 14216; break; }
    case 10208: // $39669
      var $39670=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39644);
      var $39671=__ZN11simple_listI16input_type_entryE6appendERS0_($39605, $39670);
      var $39672=$4689;
      var $39673=$2144;
      var $39674=$2145;
      var $39675=$2146;
      var $39676=$result_i1015;
      var $39677=$2147;
      var $39678=$2148;
      HEAP32[(($2144)>>2)]=408;
      HEAP32[(($2145)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2146)>>2)]=591;
      var $39679=HEAP32[(($2144)>>2)];
      var $39680=HEAP32[(($2145)>>2)];
      var $39681=HEAP32[(($2146)>>2)];
      var $39682=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39679, $39680, $39681) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10209; break; } else { __label__ = 10211; break; };
    case 10209: // $39683
      HEAP32[(($result_i1015)>>2)]=$39682;
      var $39684=HEAP32[(($result_i1015)>>2)];
      var $39685=(($39684)|0)==0;
      if ($39685) { __label__ = 10210; break; } else { __label__ = 10215; break; }
    case 10210: // $39686
      var $39687=___cxa_allocate_exception(4);
      var $39688=$39687;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39688);
      (function() { try { __THREW__ = false; return ___cxa_throw($39687, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10214; break; } else { __label__ = 10211; break; }
    case 10211: // $39689
      var $39690=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39691=$39690.f0;
      HEAP32[(($2147)>>2)]=$39691;
      var $39692=$39690.f1;
      HEAP32[(($2148)>>2)]=$39692;
      var $39693=HEAP32[(($2148)>>2)];
      var $39694=(($39693)|0) < 0;
      if ($39694) { __label__ = 10212; break; } else { __label__ = 10213; break; }
    case 10212: // $39695
      var $39696=HEAP32[(($2147)>>2)];
      ___cxa_call_unexpected($39696);
      throw "Reached an unreachable!"
    case 10213: // $39697
      var $39698=HEAP32[(($2147)>>2)];
      var $39699=HEAP32[(($2147)>>2)];
      var $39700=HEAP32[(($2148)>>2)];
      var $39701=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39699, tempValue);
      var $39702=($39701.f1 = $39700, $39701);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10214: // $39703
      throw "Reached an unreachable!"
    case 10215: // $_ZnwjPKci_exit1016
      var $39704=HEAP32[(($result_i1015)>>2)];
      var $39705=$2144;
      var $39706=$2145;
      var $39707=$2146;
      var $39708=$result_i1015;
      var $39709=$2147;
      var $39710=$2148;
      var $39711=$39704;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10837, 2, 2, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10216; break; } else { __label__ = 14221; break; }
    case 10216: // $39712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10838, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10217; break; } else { __label__ = 14221; break; }
    case 10217: // $39713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10839, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10218; break; } else { __label__ = 14221; break; }
    case 10218: // $39714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10840, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10219; break; } else { __label__ = 14221; break; }
    case 10219: // $39715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10841, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10220; break; } else { __label__ = 14221; break; }
    case 10220: // $39716
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10842, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10221; break; } else { __label__ = 14221; break; }
    case 10221: // $39717
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10843, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10222; break; } else { __label__ = 14221; break; }
    case 10222: // $39718
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10836, $10837, $10838, $10839, $10840, $10841, $10842, $10843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10223; break; } else { __label__ = 14221; break; }
    case 10223: // $39719
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10845, 1, 0, 1, 0, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10224; break; } else { __label__ = 14221; break; }
    case 10224: // $39720
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10846, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10225; break; } else { __label__ = 14221; break; }
    case 10225: // $39721
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10847, 4, 2, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10226; break; } else { __label__ = 14221; break; }
    case 10226: // $39722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10848, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10227; break; } else { __label__ = 14221; break; }
    case 10227: // $39723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10849, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10228; break; } else { __label__ = 14221; break; }
    case 10228: // $39724
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10850, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10229; break; } else { __label__ = 14221; break; }
    case 10229: // $39725
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10851, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10230; break; } else { __label__ = 14221; break; }
    case 10230: // $39726
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10844, $10845, $10846, $10847, $10848, $10849, $10850, $10851) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10231; break; } else { __label__ = 14221; break; }
    case 10231: // $39727
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10853, 1, 0, 1, 0, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10232; break; } else { __label__ = 14221; break; }
    case 10232: // $39728
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10854, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10233; break; } else { __label__ = 14221; break; }
    case 10233: // $39729
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10855, 4, 2, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10234; break; } else { __label__ = 14221; break; }
    case 10234: // $39730
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10856, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10235; break; } else { __label__ = 14221; break; }
    case 10235: // $39731
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10857, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10236; break; } else { __label__ = 14221; break; }
    case 10236: // $39732
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10858, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10237; break; } else { __label__ = 14221; break; }
    case 10237: // $39733
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10859, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10238; break; } else { __label__ = 14221; break; }
    case 10238: // $39734
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10852, $10853, $10854, $10855, $10856, $10857, $10858, $10859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10239; break; } else { __label__ = 14221; break; }
    case 10239: // $39735
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39711, 156, 3, 2, ((STRING_TABLE.__str1206)|0), ((STRING_TABLE.__str1207)|0), $10836, $10844, $10852) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10240; break; } else { __label__ = 14221; break; }
    case 10240: // $39736
      var $39737=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39711);
      var $39738=__ZN11simple_listI16input_type_entryE6appendERS0_($39672, $39737);
      var $39739=$4689;
      var $39740=$2139;
      var $39741=$2140;
      var $39742=$2141;
      var $39743=$result_i1017;
      var $39744=$2142;
      var $39745=$2143;
      HEAP32[(($2139)>>2)]=408;
      HEAP32[(($2140)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2141)>>2)]=592;
      var $39746=HEAP32[(($2139)>>2)];
      var $39747=HEAP32[(($2140)>>2)];
      var $39748=HEAP32[(($2141)>>2)];
      var $39749=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39746, $39747, $39748) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10241; break; } else { __label__ = 10243; break; };
    case 10241: // $39750
      HEAP32[(($result_i1017)>>2)]=$39749;
      var $39751=HEAP32[(($result_i1017)>>2)];
      var $39752=(($39751)|0)==0;
      if ($39752) { __label__ = 10242; break; } else { __label__ = 10247; break; }
    case 10242: // $39753
      var $39754=___cxa_allocate_exception(4);
      var $39755=$39754;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39755);
      (function() { try { __THREW__ = false; return ___cxa_throw($39754, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10246; break; } else { __label__ = 10243; break; }
    case 10243: // $39756
      var $39757=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39758=$39757.f0;
      HEAP32[(($2142)>>2)]=$39758;
      var $39759=$39757.f1;
      HEAP32[(($2143)>>2)]=$39759;
      var $39760=HEAP32[(($2143)>>2)];
      var $39761=(($39760)|0) < 0;
      if ($39761) { __label__ = 10244; break; } else { __label__ = 10245; break; }
    case 10244: // $39762
      var $39763=HEAP32[(($2142)>>2)];
      ___cxa_call_unexpected($39763);
      throw "Reached an unreachable!"
    case 10245: // $39764
      var $39765=HEAP32[(($2142)>>2)];
      var $39766=HEAP32[(($2142)>>2)];
      var $39767=HEAP32[(($2143)>>2)];
      var $39768=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39766, tempValue);
      var $39769=($39768.f1 = $39767, $39768);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10246: // $39770
      throw "Reached an unreachable!"
    case 10247: // $_ZnwjPKci_exit1018
      var $39771=HEAP32[(($result_i1017)>>2)];
      var $39772=$2139;
      var $39773=$2140;
      var $39774=$2141;
      var $39775=$result_i1017;
      var $39776=$2142;
      var $39777=$2143;
      var $39778=$39771;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10861, 2, 3, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10248; break; } else { __label__ = 14226; break; }
    case 10248: // $39779
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10862, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10249; break; } else { __label__ = 14226; break; }
    case 10249: // $39780
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10863, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10250; break; } else { __label__ = 14226; break; }
    case 10250: // $39781
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10864, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10251; break; } else { __label__ = 14226; break; }
    case 10251: // $39782
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10865, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10252; break; } else { __label__ = 14226; break; }
    case 10252: // $39783
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10866, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10253; break; } else { __label__ = 14226; break; }
    case 10253: // $39784
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10867, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10254; break; } else { __label__ = 14226; break; }
    case 10254: // $39785
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10860, $10861, $10862, $10863, $10864, $10865, $10866, $10867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10255; break; } else { __label__ = 14226; break; }
    case 10255: // $39786
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10869, 4, 3, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10256; break; } else { __label__ = 14226; break; }
    case 10256: // $39787
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10870, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10257; break; } else { __label__ = 14226; break; }
    case 10257: // $39788
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10871, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10258; break; } else { __label__ = 14226; break; }
    case 10258: // $39789
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10872, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10259; break; } else { __label__ = 14226; break; }
    case 10259: // $39790
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10873, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10260; break; } else { __label__ = 14226; break; }
    case 10260: // $39791
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10874, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10261; break; } else { __label__ = 14226; break; }
    case 10261: // $39792
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10875, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10262; break; } else { __label__ = 14226; break; }
    case 10262: // $39793
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10868, $10869, $10870, $10871, $10872, $10873, $10874, $10875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10263; break; } else { __label__ = 14226; break; }
    case 10263: // $39794
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10877, 4, 3, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10264; break; } else { __label__ = 14226; break; }
    case 10264: // $39795
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10878, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10265; break; } else { __label__ = 14226; break; }
    case 10265: // $39796
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10879, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10266; break; } else { __label__ = 14226; break; }
    case 10266: // $39797
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10880, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10267; break; } else { __label__ = 14226; break; }
    case 10267: // $39798
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10881, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10268; break; } else { __label__ = 14226; break; }
    case 10268: // $39799
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10882, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10269; break; } else { __label__ = 14226; break; }
    case 10269: // $39800
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10883, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10270; break; } else { __label__ = 14226; break; }
    case 10270: // $39801
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10876, $10877, $10878, $10879, $10880, $10881, $10882, $10883) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10271; break; } else { __label__ = 14226; break; }
    case 10271: // $39802
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39778, 156, 4, 3, ((STRING_TABLE.__str1208)|0), ((STRING_TABLE.__str1209)|0), $10860, $10868, $10876) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10272; break; } else { __label__ = 14226; break; }
    case 10272: // $39803
      var $39804=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39778);
      var $39805=__ZN11simple_listI16input_type_entryE6appendERS0_($39739, $39804);
      var $39806=$4689;
      var $39807=$2134;
      var $39808=$2135;
      var $39809=$2136;
      var $39810=$result_i1019;
      var $39811=$2137;
      var $39812=$2138;
      HEAP32[(($2134)>>2)]=408;
      HEAP32[(($2135)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2136)>>2)]=593;
      var $39813=HEAP32[(($2134)>>2)];
      var $39814=HEAP32[(($2135)>>2)];
      var $39815=HEAP32[(($2136)>>2)];
      var $39816=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39813, $39814, $39815) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10273; break; } else { __label__ = 10275; break; };
    case 10273: // $39817
      HEAP32[(($result_i1019)>>2)]=$39816;
      var $39818=HEAP32[(($result_i1019)>>2)];
      var $39819=(($39818)|0)==0;
      if ($39819) { __label__ = 10274; break; } else { __label__ = 10279; break; }
    case 10274: // $39820
      var $39821=___cxa_allocate_exception(4);
      var $39822=$39821;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39822);
      (function() { try { __THREW__ = false; return ___cxa_throw($39821, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10278; break; } else { __label__ = 10275; break; }
    case 10275: // $39823
      var $39824=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39825=$39824.f0;
      HEAP32[(($2137)>>2)]=$39825;
      var $39826=$39824.f1;
      HEAP32[(($2138)>>2)]=$39826;
      var $39827=HEAP32[(($2138)>>2)];
      var $39828=(($39827)|0) < 0;
      if ($39828) { __label__ = 10276; break; } else { __label__ = 10277; break; }
    case 10276: // $39829
      var $39830=HEAP32[(($2137)>>2)];
      ___cxa_call_unexpected($39830);
      throw "Reached an unreachable!"
    case 10277: // $39831
      var $39832=HEAP32[(($2137)>>2)];
      var $39833=HEAP32[(($2137)>>2)];
      var $39834=HEAP32[(($2138)>>2)];
      var $39835=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39833, tempValue);
      var $39836=($39835.f1 = $39834, $39835);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10278: // $39837
      throw "Reached an unreachable!"
    case 10279: // $_ZnwjPKci_exit1020
      var $39838=HEAP32[(($result_i1019)>>2)];
      var $39839=$2134;
      var $39840=$2135;
      var $39841=$2136;
      var $39842=$result_i1019;
      var $39843=$2137;
      var $39844=$2138;
      var $39845=$39838;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10885, 2, 4, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10280; break; } else { __label__ = 14231; break; }
    case 10280: // $39846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10886, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10281; break; } else { __label__ = 14231; break; }
    case 10281: // $39847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10887, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10282; break; } else { __label__ = 14231; break; }
    case 10282: // $39848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10888, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10283; break; } else { __label__ = 14231; break; }
    case 10283: // $39849
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10889, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10284; break; } else { __label__ = 14231; break; }
    case 10284: // $39850
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10890, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10285; break; } else { __label__ = 14231; break; }
    case 10285: // $39851
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10891, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10286; break; } else { __label__ = 14231; break; }
    case 10286: // $39852
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10884, $10885, $10886, $10887, $10888, $10889, $10890, $10891) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10287; break; } else { __label__ = 14231; break; }
    case 10287: // $39853
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10893, 4, 4, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10288; break; } else { __label__ = 14231; break; }
    case 10288: // $39854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10894, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10289; break; } else { __label__ = 14231; break; }
    case 10289: // $39855
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10895, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10290; break; } else { __label__ = 14231; break; }
    case 10290: // $39856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10896, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10291; break; } else { __label__ = 14231; break; }
    case 10291: // $39857
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10897, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10292; break; } else { __label__ = 14231; break; }
    case 10292: // $39858
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10898, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10293; break; } else { __label__ = 14231; break; }
    case 10293: // $39859
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10899, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10294; break; } else { __label__ = 14231; break; }
    case 10294: // $39860
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10892, $10893, $10894, $10895, $10896, $10897, $10898, $10899) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10295; break; } else { __label__ = 14231; break; }
    case 10295: // $39861
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10901, 4, 4, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10296; break; } else { __label__ = 14231; break; }
    case 10296: // $39862
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10902, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10297; break; } else { __label__ = 14231; break; }
    case 10297: // $39863
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10903, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10298; break; } else { __label__ = 14231; break; }
    case 10298: // $39864
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10904, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10299; break; } else { __label__ = 14231; break; }
    case 10299: // $39865
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10905, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10300; break; } else { __label__ = 14231; break; }
    case 10300: // $39866
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10906, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10301; break; } else { __label__ = 14231; break; }
    case 10301: // $39867
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10907, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10302; break; } else { __label__ = 14231; break; }
    case 10302: // $39868
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10900, $10901, $10902, $10903, $10904, $10905, $10906, $10907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10303; break; } else { __label__ = 14231; break; }
    case 10303: // $39869
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39845, 156, 5, 4, ((STRING_TABLE.__str1210)|0), ((STRING_TABLE.__str1211)|0), $10884, $10892, $10900) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10304; break; } else { __label__ = 14231; break; }
    case 10304: // $39870
      var $39871=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39845);
      var $39872=__ZN11simple_listI16input_type_entryE6appendERS0_($39806, $39871);
      var $39873=$4689;
      var $39874=$2129;
      var $39875=$2130;
      var $39876=$2131;
      var $39877=$result_i1021;
      var $39878=$2132;
      var $39879=$2133;
      HEAP32[(($2129)>>2)]=408;
      HEAP32[(($2130)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2131)>>2)]=594;
      var $39880=HEAP32[(($2129)>>2)];
      var $39881=HEAP32[(($2130)>>2)];
      var $39882=HEAP32[(($2131)>>2)];
      var $39883=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39880, $39881, $39882) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10305; break; } else { __label__ = 10307; break; };
    case 10305: // $39884
      HEAP32[(($result_i1021)>>2)]=$39883;
      var $39885=HEAP32[(($result_i1021)>>2)];
      var $39886=(($39885)|0)==0;
      if ($39886) { __label__ = 10306; break; } else { __label__ = 10311; break; }
    case 10306: // $39887
      var $39888=___cxa_allocate_exception(4);
      var $39889=$39888;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39889);
      (function() { try { __THREW__ = false; return ___cxa_throw($39888, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10310; break; } else { __label__ = 10307; break; }
    case 10307: // $39890
      var $39891=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39892=$39891.f0;
      HEAP32[(($2132)>>2)]=$39892;
      var $39893=$39891.f1;
      HEAP32[(($2133)>>2)]=$39893;
      var $39894=HEAP32[(($2133)>>2)];
      var $39895=(($39894)|0) < 0;
      if ($39895) { __label__ = 10308; break; } else { __label__ = 10309; break; }
    case 10308: // $39896
      var $39897=HEAP32[(($2132)>>2)];
      ___cxa_call_unexpected($39897);
      throw "Reached an unreachable!"
    case 10309: // $39898
      var $39899=HEAP32[(($2132)>>2)];
      var $39900=HEAP32[(($2132)>>2)];
      var $39901=HEAP32[(($2133)>>2)];
      var $39902=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39900, tempValue);
      var $39903=($39902.f1 = $39901, $39902);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10310: // $39904
      throw "Reached an unreachable!"
    case 10311: // $_ZnwjPKci_exit1022
      var $39905=HEAP32[(($result_i1021)>>2)];
      var $39906=$2129;
      var $39907=$2130;
      var $39908=$2131;
      var $39909=$result_i1021;
      var $39910=$2132;
      var $39911=$2133;
      var $39912=$39905;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10909, 2, 5, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10312; break; } else { __label__ = 14236; break; }
    case 10312: // $39913
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10910, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10313; break; } else { __label__ = 14236; break; }
    case 10313: // $39914
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10911, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10314; break; } else { __label__ = 14236; break; }
    case 10314: // $39915
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10912, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10315; break; } else { __label__ = 14236; break; }
    case 10315: // $39916
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10913, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10316; break; } else { __label__ = 14236; break; }
    case 10316: // $39917
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10914, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10317; break; } else { __label__ = 14236; break; }
    case 10317: // $39918
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10915, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10318; break; } else { __label__ = 14236; break; }
    case 10318: // $39919
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10908, $10909, $10910, $10911, $10912, $10913, $10914, $10915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10319; break; } else { __label__ = 14236; break; }
    case 10319: // $39920
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10917, 4, 5, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10320; break; } else { __label__ = 14236; break; }
    case 10320: // $39921
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10918, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10321; break; } else { __label__ = 14236; break; }
    case 10321: // $39922
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10919, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10322; break; } else { __label__ = 14236; break; }
    case 10322: // $39923
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10920, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10323; break; } else { __label__ = 14236; break; }
    case 10323: // $39924
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10921, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10324; break; } else { __label__ = 14236; break; }
    case 10324: // $39925
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10922, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10325; break; } else { __label__ = 14236; break; }
    case 10325: // $39926
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10923, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10326; break; } else { __label__ = 14236; break; }
    case 10326: // $39927
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10916, $10917, $10918, $10919, $10920, $10921, $10922, $10923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10327; break; } else { __label__ = 14236; break; }
    case 10327: // $39928
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10925, 4, 5, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10328; break; } else { __label__ = 14236; break; }
    case 10328: // $39929
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10926, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10329; break; } else { __label__ = 14236; break; }
    case 10329: // $39930
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10927, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10330; break; } else { __label__ = 14236; break; }
    case 10330: // $39931
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10928, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10331; break; } else { __label__ = 14236; break; }
    case 10331: // $39932
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10929, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10332; break; } else { __label__ = 14236; break; }
    case 10332: // $39933
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10930, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10333; break; } else { __label__ = 14236; break; }
    case 10333: // $39934
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10931, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10334; break; } else { __label__ = 14236; break; }
    case 10334: // $39935
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10924, $10925, $10926, $10927, $10928, $10929, $10930, $10931) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10335; break; } else { __label__ = 14236; break; }
    case 10335: // $39936
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39912, 156, 6, 5, ((STRING_TABLE.__str1212)|0), ((STRING_TABLE.__str1213)|0), $10908, $10916, $10924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10336; break; } else { __label__ = 14236; break; }
    case 10336: // $39937
      var $39938=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39912);
      var $39939=__ZN11simple_listI16input_type_entryE6appendERS0_($39873, $39938);
      var $39940=$4689;
      var $39941=$2124;
      var $39942=$2125;
      var $39943=$2126;
      var $39944=$result_i1023;
      var $39945=$2127;
      var $39946=$2128;
      HEAP32[(($2124)>>2)]=408;
      HEAP32[(($2125)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2126)>>2)]=595;
      var $39947=HEAP32[(($2124)>>2)];
      var $39948=HEAP32[(($2125)>>2)];
      var $39949=HEAP32[(($2126)>>2)];
      var $39950=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($39947, $39948, $39949) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10337; break; } else { __label__ = 10339; break; };
    case 10337: // $39951
      HEAP32[(($result_i1023)>>2)]=$39950;
      var $39952=HEAP32[(($result_i1023)>>2)];
      var $39953=(($39952)|0)==0;
      if ($39953) { __label__ = 10338; break; } else { __label__ = 10343; break; }
    case 10338: // $39954
      var $39955=___cxa_allocate_exception(4);
      var $39956=$39955;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39956);
      (function() { try { __THREW__ = false; return ___cxa_throw($39955, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10342; break; } else { __label__ = 10339; break; }
    case 10339: // $39957
      var $39958=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39959=$39958.f0;
      HEAP32[(($2127)>>2)]=$39959;
      var $39960=$39958.f1;
      HEAP32[(($2128)>>2)]=$39960;
      var $39961=HEAP32[(($2128)>>2)];
      var $39962=(($39961)|0) < 0;
      if ($39962) { __label__ = 10340; break; } else { __label__ = 10341; break; }
    case 10340: // $39963
      var $39964=HEAP32[(($2127)>>2)];
      ___cxa_call_unexpected($39964);
      throw "Reached an unreachable!"
    case 10341: // $39965
      var $39966=HEAP32[(($2127)>>2)];
      var $39967=HEAP32[(($2127)>>2)];
      var $39968=HEAP32[(($2128)>>2)];
      var $39969=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39967, tempValue);
      var $39970=($39969.f1 = $39968, $39969);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10342: // $39971
      throw "Reached an unreachable!"
    case 10343: // $_ZnwjPKci_exit1024
      var $39972=HEAP32[(($result_i1023)>>2)];
      var $39973=$2124;
      var $39974=$2125;
      var $39975=$2126;
      var $39976=$result_i1023;
      var $39977=$2127;
      var $39978=$2128;
      var $39979=$39972;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10933, 2, 6, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10344; break; } else { __label__ = 14241; break; }
    case 10344: // $39980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10934, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10345; break; } else { __label__ = 14241; break; }
    case 10345: // $39981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10935, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10346; break; } else { __label__ = 14241; break; }
    case 10346: // $39982
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10936, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10347; break; } else { __label__ = 14241; break; }
    case 10347: // $39983
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10937, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10348; break; } else { __label__ = 14241; break; }
    case 10348: // $39984
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10938, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10349; break; } else { __label__ = 14241; break; }
    case 10349: // $39985
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10939, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10350; break; } else { __label__ = 14241; break; }
    case 10350: // $39986
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10932, $10933, $10934, $10935, $10936, $10937, $10938, $10939) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10351; break; } else { __label__ = 14241; break; }
    case 10351: // $39987
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10941, 4, 6, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10352; break; } else { __label__ = 14241; break; }
    case 10352: // $39988
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10942, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10353; break; } else { __label__ = 14241; break; }
    case 10353: // $39989
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10943, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10354; break; } else { __label__ = 14241; break; }
    case 10354: // $39990
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10944, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10355; break; } else { __label__ = 14241; break; }
    case 10355: // $39991
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10945, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10356; break; } else { __label__ = 14241; break; }
    case 10356: // $39992
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10946, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10357; break; } else { __label__ = 14241; break; }
    case 10357: // $39993
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10947, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10358; break; } else { __label__ = 14241; break; }
    case 10358: // $39994
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10940, $10941, $10942, $10943, $10944, $10945, $10946, $10947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10359; break; } else { __label__ = 14241; break; }
    case 10359: // $39995
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10949, 4, 6, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10360; break; } else { __label__ = 14241; break; }
    case 10360: // $39996
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10950, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10361; break; } else { __label__ = 14241; break; }
    case 10361: // $39997
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10951, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10362; break; } else { __label__ = 14241; break; }
    case 10362: // $39998
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10952, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10363; break; } else { __label__ = 14241; break; }
    case 10363: // $39999
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10953, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10364; break; } else { __label__ = 14241; break; }
    case 10364: // $40000
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10954, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10365; break; } else { __label__ = 14241; break; }
    case 10365: // $40001
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10955, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10366; break; } else { __label__ = 14241; break; }
    case 10366: // $40002
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10948, $10949, $10950, $10951, $10952, $10953, $10954, $10955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10367; break; } else { __label__ = 14241; break; }
    case 10367: // $40003
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($39979, 156, 7, 6, ((STRING_TABLE.__str1214)|0), ((STRING_TABLE.__str1215)|0), $10932, $10940, $10948) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10368; break; } else { __label__ = 14241; break; }
    case 10368: // $40004
      var $40005=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $39979);
      var $40006=__ZN11simple_listI16input_type_entryE6appendERS0_($39940, $40005);
      var $40007=$4689;
      var $40008=$2119;
      var $40009=$2120;
      var $40010=$2121;
      var $40011=$result_i1025;
      var $40012=$2122;
      var $40013=$2123;
      HEAP32[(($2119)>>2)]=408;
      HEAP32[(($2120)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2121)>>2)]=596;
      var $40014=HEAP32[(($2119)>>2)];
      var $40015=HEAP32[(($2120)>>2)];
      var $40016=HEAP32[(($2121)>>2)];
      var $40017=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40014, $40015, $40016) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10369; break; } else { __label__ = 10371; break; };
    case 10369: // $40018
      HEAP32[(($result_i1025)>>2)]=$40017;
      var $40019=HEAP32[(($result_i1025)>>2)];
      var $40020=(($40019)|0)==0;
      if ($40020) { __label__ = 10370; break; } else { __label__ = 10375; break; }
    case 10370: // $40021
      var $40022=___cxa_allocate_exception(4);
      var $40023=$40022;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40023);
      (function() { try { __THREW__ = false; return ___cxa_throw($40022, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10374; break; } else { __label__ = 10371; break; }
    case 10371: // $40024
      var $40025=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40026=$40025.f0;
      HEAP32[(($2122)>>2)]=$40026;
      var $40027=$40025.f1;
      HEAP32[(($2123)>>2)]=$40027;
      var $40028=HEAP32[(($2123)>>2)];
      var $40029=(($40028)|0) < 0;
      if ($40029) { __label__ = 10372; break; } else { __label__ = 10373; break; }
    case 10372: // $40030
      var $40031=HEAP32[(($2122)>>2)];
      ___cxa_call_unexpected($40031);
      throw "Reached an unreachable!"
    case 10373: // $40032
      var $40033=HEAP32[(($2122)>>2)];
      var $40034=HEAP32[(($2122)>>2)];
      var $40035=HEAP32[(($2123)>>2)];
      var $40036=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40034, tempValue);
      var $40037=($40036.f1 = $40035, $40036);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10374: // $40038
      throw "Reached an unreachable!"
    case 10375: // $_ZnwjPKci_exit1026
      var $40039=HEAP32[(($result_i1025)>>2)];
      var $40040=$2119;
      var $40041=$2120;
      var $40042=$2121;
      var $40043=$result_i1025;
      var $40044=$2122;
      var $40045=$2123;
      var $40046=$40039;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10957, 2, 7, 3, 0, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10376; break; } else { __label__ = 14246; break; }
    case 10376: // $40047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10958, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10377; break; } else { __label__ = 14246; break; }
    case 10377: // $40048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10959, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10378; break; } else { __label__ = 14246; break; }
    case 10378: // $40049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10960, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10379; break; } else { __label__ = 14246; break; }
    case 10379: // $40050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10961, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10380; break; } else { __label__ = 14246; break; }
    case 10380: // $40051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10962, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10381; break; } else { __label__ = 14246; break; }
    case 10381: // $40052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10963, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10382; break; } else { __label__ = 14246; break; }
    case 10382: // $40053
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10956, $10957, $10958, $10959, $10960, $10961, $10962, $10963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10383; break; } else { __label__ = 14246; break; }
    case 10383: // $40054
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10965, 4, 7, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10384; break; } else { __label__ = 14246; break; }
    case 10384: // $40055
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10966, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10385; break; } else { __label__ = 14246; break; }
    case 10385: // $40056
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10967, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10386; break; } else { __label__ = 14246; break; }
    case 10386: // $40057
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10968, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10387; break; } else { __label__ = 14246; break; }
    case 10387: // $40058
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10969, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10388; break; } else { __label__ = 14246; break; }
    case 10388: // $40059
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10970, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10389; break; } else { __label__ = 14246; break; }
    case 10389: // $40060
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10971, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10390; break; } else { __label__ = 14246; break; }
    case 10390: // $40061
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10964, $10965, $10966, $10967, $10968, $10969, $10970, $10971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10391; break; } else { __label__ = 14246; break; }
    case 10391: // $40062
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10973, 4, 7, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10392; break; } else { __label__ = 14246; break; }
    case 10392: // $40063
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10974, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10393; break; } else { __label__ = 14246; break; }
    case 10393: // $40064
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10975, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10394; break; } else { __label__ = 14246; break; }
    case 10394: // $40065
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10976, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10395; break; } else { __label__ = 14246; break; }
    case 10395: // $40066
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10977, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10396; break; } else { __label__ = 14246; break; }
    case 10396: // $40067
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10978, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10397; break; } else { __label__ = 14246; break; }
    case 10397: // $40068
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10979, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10398; break; } else { __label__ = 14246; break; }
    case 10398: // $40069
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10972, $10973, $10974, $10975, $10976, $10977, $10978, $10979) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10399; break; } else { __label__ = 14246; break; }
    case 10399: // $40070
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40046, 156, 8, 7, ((STRING_TABLE.__str1216)|0), ((STRING_TABLE.__str1217)|0), $10956, $10964, $10972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10400; break; } else { __label__ = 14246; break; }
    case 10400: // $40071
      var $40072=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40046);
      var $40073=__ZN11simple_listI16input_type_entryE6appendERS0_($40007, $40072);
      var $40074=$4689;
      var $40075=$2114;
      var $40076=$2115;
      var $40077=$2116;
      var $40078=$result_i1027;
      var $40079=$2117;
      var $40080=$2118;
      HEAP32[(($2114)>>2)]=408;
      HEAP32[(($2115)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2116)>>2)]=598;
      var $40081=HEAP32[(($2114)>>2)];
      var $40082=HEAP32[(($2115)>>2)];
      var $40083=HEAP32[(($2116)>>2)];
      var $40084=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40081, $40082, $40083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10401; break; } else { __label__ = 10403; break; };
    case 10401: // $40085
      HEAP32[(($result_i1027)>>2)]=$40084;
      var $40086=HEAP32[(($result_i1027)>>2)];
      var $40087=(($40086)|0)==0;
      if ($40087) { __label__ = 10402; break; } else { __label__ = 10407; break; }
    case 10402: // $40088
      var $40089=___cxa_allocate_exception(4);
      var $40090=$40089;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40090);
      (function() { try { __THREW__ = false; return ___cxa_throw($40089, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10406; break; } else { __label__ = 10403; break; }
    case 10403: // $40091
      var $40092=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40093=$40092.f0;
      HEAP32[(($2117)>>2)]=$40093;
      var $40094=$40092.f1;
      HEAP32[(($2118)>>2)]=$40094;
      var $40095=HEAP32[(($2118)>>2)];
      var $40096=(($40095)|0) < 0;
      if ($40096) { __label__ = 10404; break; } else { __label__ = 10405; break; }
    case 10404: // $40097
      var $40098=HEAP32[(($2117)>>2)];
      ___cxa_call_unexpected($40098);
      throw "Reached an unreachable!"
    case 10405: // $40099
      var $40100=HEAP32[(($2117)>>2)];
      var $40101=HEAP32[(($2117)>>2)];
      var $40102=HEAP32[(($2118)>>2)];
      var $40103=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40101, tempValue);
      var $40104=($40103.f1 = $40102, $40103);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10406: // $40105
      throw "Reached an unreachable!"
    case 10407: // $_ZnwjPKci_exit1028
      var $40106=HEAP32[(($result_i1027)>>2)];
      var $40107=$2114;
      var $40108=$2115;
      var $40109=$2116;
      var $40110=$result_i1027;
      var $40111=$2117;
      var $40112=$2118;
      var $40113=$40106;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10981, 2, 0, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10408; break; } else { __label__ = 14251; break; }
    case 10408: // $40114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10982, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10409; break; } else { __label__ = 14251; break; }
    case 10409: // $40115
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10983, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10410; break; } else { __label__ = 14251; break; }
    case 10410: // $40116
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10984, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10411; break; } else { __label__ = 14251; break; }
    case 10411: // $40117
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10985, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10412; break; } else { __label__ = 14251; break; }
    case 10412: // $40118
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10986, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10413; break; } else { __label__ = 14251; break; }
    case 10413: // $40119
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10987, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10414; break; } else { __label__ = 14251; break; }
    case 10414: // $40120
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10980, $10981, $10982, $10983, $10984, $10985, $10986, $10987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10415; break; } else { __label__ = 14251; break; }
    case 10415: // $40121
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10989, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10416; break; } else { __label__ = 14251; break; }
    case 10416: // $40122
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10990, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10417; break; } else { __label__ = 14251; break; }
    case 10417: // $40123
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10991, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10418; break; } else { __label__ = 14251; break; }
    case 10418: // $40124
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10992, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10419; break; } else { __label__ = 14251; break; }
    case 10419: // $40125
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10993, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10420; break; } else { __label__ = 14251; break; }
    case 10420: // $40126
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10994, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10421; break; } else { __label__ = 14251; break; }
    case 10421: // $40127
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10995, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10422; break; } else { __label__ = 14251; break; }
    case 10422: // $40128
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10988, $10989, $10990, $10991, $10992, $10993, $10994, $10995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10423; break; } else { __label__ = 14251; break; }
    case 10423: // $40129
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10997, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10424; break; } else { __label__ = 14251; break; }
    case 10424: // $40130
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10998, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10425; break; } else { __label__ = 14251; break; }
    case 10425: // $40131
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10999, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10426; break; } else { __label__ = 14251; break; }
    case 10426: // $40132
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11000, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10427; break; } else { __label__ = 14251; break; }
    case 10427: // $40133
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11001, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10428; break; } else { __label__ = 14251; break; }
    case 10428: // $40134
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11002, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10429; break; } else { __label__ = 14251; break; }
    case 10429: // $40135
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11003, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10430; break; } else { __label__ = 14251; break; }
    case 10430: // $40136
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($10996, $10997, $10998, $10999, $11000, $11001, $11002, $11003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10431; break; } else { __label__ = 14251; break; }
    case 10431: // $40137
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40113, 157, 1, 0, ((STRING_TABLE.__str1218)|0), ((STRING_TABLE.__str1219)|0), $10980, $10988, $10996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10432; break; } else { __label__ = 14251; break; }
    case 10432: // $40138
      var $40139=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40113);
      var $40140=__ZN11simple_listI16input_type_entryE6appendERS0_($40074, $40139);
      var $40141=$4689;
      var $40142=$2109;
      var $40143=$2110;
      var $40144=$2111;
      var $40145=$result_i1029;
      var $40146=$2112;
      var $40147=$2113;
      HEAP32[(($2109)>>2)]=408;
      HEAP32[(($2110)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2111)>>2)]=599;
      var $40148=HEAP32[(($2109)>>2)];
      var $40149=HEAP32[(($2110)>>2)];
      var $40150=HEAP32[(($2111)>>2)];
      var $40151=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40148, $40149, $40150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10433; break; } else { __label__ = 10435; break; };
    case 10433: // $40152
      HEAP32[(($result_i1029)>>2)]=$40151;
      var $40153=HEAP32[(($result_i1029)>>2)];
      var $40154=(($40153)|0)==0;
      if ($40154) { __label__ = 10434; break; } else { __label__ = 10439; break; }
    case 10434: // $40155
      var $40156=___cxa_allocate_exception(4);
      var $40157=$40156;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40157);
      (function() { try { __THREW__ = false; return ___cxa_throw($40156, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10438; break; } else { __label__ = 10435; break; }
    case 10435: // $40158
      var $40159=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40160=$40159.f0;
      HEAP32[(($2112)>>2)]=$40160;
      var $40161=$40159.f1;
      HEAP32[(($2113)>>2)]=$40161;
      var $40162=HEAP32[(($2113)>>2)];
      var $40163=(($40162)|0) < 0;
      if ($40163) { __label__ = 10436; break; } else { __label__ = 10437; break; }
    case 10436: // $40164
      var $40165=HEAP32[(($2112)>>2)];
      ___cxa_call_unexpected($40165);
      throw "Reached an unreachable!"
    case 10437: // $40166
      var $40167=HEAP32[(($2112)>>2)];
      var $40168=HEAP32[(($2112)>>2)];
      var $40169=HEAP32[(($2113)>>2)];
      var $40170=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40168, tempValue);
      var $40171=($40170.f1 = $40169, $40170);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10438: // $40172
      throw "Reached an unreachable!"
    case 10439: // $_ZnwjPKci_exit1030
      var $40173=HEAP32[(($result_i1029)>>2)];
      var $40174=$2109;
      var $40175=$2110;
      var $40176=$2111;
      var $40177=$result_i1029;
      var $40178=$2112;
      var $40179=$2113;
      var $40180=$40173;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11005, 2, 1, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10440; break; } else { __label__ = 14256; break; }
    case 10440: // $40181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11006, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10441; break; } else { __label__ = 14256; break; }
    case 10441: // $40182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11007, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10442; break; } else { __label__ = 14256; break; }
    case 10442: // $40183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11008, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10443; break; } else { __label__ = 14256; break; }
    case 10443: // $40184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11009, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10444; break; } else { __label__ = 14256; break; }
    case 10444: // $40185
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11010, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10445; break; } else { __label__ = 14256; break; }
    case 10445: // $40186
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11011, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10446; break; } else { __label__ = 14256; break; }
    case 10446: // $40187
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11004, $11005, $11006, $11007, $11008, $11009, $11010, $11011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10447; break; } else { __label__ = 14256; break; }
    case 10447: // $40188
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11013, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10448; break; } else { __label__ = 14256; break; }
    case 10448: // $40189
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11014, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10449; break; } else { __label__ = 14256; break; }
    case 10449: // $40190
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11015, 4, 1, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10450; break; } else { __label__ = 14256; break; }
    case 10450: // $40191
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11016, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10451; break; } else { __label__ = 14256; break; }
    case 10451: // $40192
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11017, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10452; break; } else { __label__ = 14256; break; }
    case 10452: // $40193
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11018, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10453; break; } else { __label__ = 14256; break; }
    case 10453: // $40194
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11019, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10454; break; } else { __label__ = 14256; break; }
    case 10454: // $40195
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11012, $11013, $11014, $11015, $11016, $11017, $11018, $11019) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10455; break; } else { __label__ = 14256; break; }
    case 10455: // $40196
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11021, 1, 0, 1, 0, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10456; break; } else { __label__ = 14256; break; }
    case 10456: // $40197
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11022, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10457; break; } else { __label__ = 14256; break; }
    case 10457: // $40198
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11023, 4, 1, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10458; break; } else { __label__ = 14256; break; }
    case 10458: // $40199
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11024, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10459; break; } else { __label__ = 14256; break; }
    case 10459: // $40200
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11025, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10460; break; } else { __label__ = 14256; break; }
    case 10460: // $40201
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11026, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10461; break; } else { __label__ = 14256; break; }
    case 10461: // $40202
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11027, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10462; break; } else { __label__ = 14256; break; }
    case 10462: // $40203
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11020, $11021, $11022, $11023, $11024, $11025, $11026, $11027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10463; break; } else { __label__ = 14256; break; }
    case 10463: // $40204
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40180, 157, 2, 1, ((STRING_TABLE.__str1220)|0), ((STRING_TABLE.__str1221)|0), $11004, $11012, $11020) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10464; break; } else { __label__ = 14256; break; }
    case 10464: // $40205
      var $40206=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40180);
      var $40207=__ZN11simple_listI16input_type_entryE6appendERS0_($40141, $40206);
      var $40208=$4689;
      var $40209=$2104;
      var $40210=$2105;
      var $40211=$2106;
      var $40212=$result_i1031;
      var $40213=$2107;
      var $40214=$2108;
      HEAP32[(($2104)>>2)]=408;
      HEAP32[(($2105)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2106)>>2)]=600;
      var $40215=HEAP32[(($2104)>>2)];
      var $40216=HEAP32[(($2105)>>2)];
      var $40217=HEAP32[(($2106)>>2)];
      var $40218=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40215, $40216, $40217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10465; break; } else { __label__ = 10467; break; };
    case 10465: // $40219
      HEAP32[(($result_i1031)>>2)]=$40218;
      var $40220=HEAP32[(($result_i1031)>>2)];
      var $40221=(($40220)|0)==0;
      if ($40221) { __label__ = 10466; break; } else { __label__ = 10471; break; }
    case 10466: // $40222
      var $40223=___cxa_allocate_exception(4);
      var $40224=$40223;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40224);
      (function() { try { __THREW__ = false; return ___cxa_throw($40223, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10470; break; } else { __label__ = 10467; break; }
    case 10467: // $40225
      var $40226=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40227=$40226.f0;
      HEAP32[(($2107)>>2)]=$40227;
      var $40228=$40226.f1;
      HEAP32[(($2108)>>2)]=$40228;
      var $40229=HEAP32[(($2108)>>2)];
      var $40230=(($40229)|0) < 0;
      if ($40230) { __label__ = 10468; break; } else { __label__ = 10469; break; }
    case 10468: // $40231
      var $40232=HEAP32[(($2107)>>2)];
      ___cxa_call_unexpected($40232);
      throw "Reached an unreachable!"
    case 10469: // $40233
      var $40234=HEAP32[(($2107)>>2)];
      var $40235=HEAP32[(($2107)>>2)];
      var $40236=HEAP32[(($2108)>>2)];
      var $40237=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40235, tempValue);
      var $40238=($40237.f1 = $40236, $40237);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10470: // $40239
      throw "Reached an unreachable!"
    case 10471: // $_ZnwjPKci_exit1032
      var $40240=HEAP32[(($result_i1031)>>2)];
      var $40241=$2104;
      var $40242=$2105;
      var $40243=$2106;
      var $40244=$result_i1031;
      var $40245=$2107;
      var $40246=$2108;
      var $40247=$40240;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11029, 2, 2, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10472; break; } else { __label__ = 14261; break; }
    case 10472: // $40248
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11030, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10473; break; } else { __label__ = 14261; break; }
    case 10473: // $40249
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11031, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10474; break; } else { __label__ = 14261; break; }
    case 10474: // $40250
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11032, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10475; break; } else { __label__ = 14261; break; }
    case 10475: // $40251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11033, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10476; break; } else { __label__ = 14261; break; }
    case 10476: // $40252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11034, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10477; break; } else { __label__ = 14261; break; }
    case 10477: // $40253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11035, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10478; break; } else { __label__ = 14261; break; }
    case 10478: // $40254
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11028, $11029, $11030, $11031, $11032, $11033, $11034, $11035) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10479; break; } else { __label__ = 14261; break; }
    case 10479: // $40255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11037, 1, 0, 1, 0, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10480; break; } else { __label__ = 14261; break; }
    case 10480: // $40256
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11038, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10481; break; } else { __label__ = 14261; break; }
    case 10481: // $40257
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11039, 4, 2, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10482; break; } else { __label__ = 14261; break; }
    case 10482: // $40258
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11040, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10483; break; } else { __label__ = 14261; break; }
    case 10483: // $40259
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11041, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10484; break; } else { __label__ = 14261; break; }
    case 10484: // $40260
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11042, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10485; break; } else { __label__ = 14261; break; }
    case 10485: // $40261
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11043, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10486; break; } else { __label__ = 14261; break; }
    case 10486: // $40262
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11036, $11037, $11038, $11039, $11040, $11041, $11042, $11043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10487; break; } else { __label__ = 14261; break; }
    case 10487: // $40263
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11045, 1, 0, 1, 0, 11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10488; break; } else { __label__ = 14261; break; }
    case 10488: // $40264
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11046, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10489; break; } else { __label__ = 14261; break; }
    case 10489: // $40265
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11047, 4, 2, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10490; break; } else { __label__ = 14261; break; }
    case 10490: // $40266
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11048, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10491; break; } else { __label__ = 14261; break; }
    case 10491: // $40267
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11049, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10492; break; } else { __label__ = 14261; break; }
    case 10492: // $40268
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11050, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10493; break; } else { __label__ = 14261; break; }
    case 10493: // $40269
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11051, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10494; break; } else { __label__ = 14261; break; }
    case 10494: // $40270
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11044, $11045, $11046, $11047, $11048, $11049, $11050, $11051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10495; break; } else { __label__ = 14261; break; }
    case 10495: // $40271
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40247, 157, 3, 2, ((STRING_TABLE.__str1222)|0), ((STRING_TABLE.__str1223)|0), $11028, $11036, $11044) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10496; break; } else { __label__ = 14261; break; }
    case 10496: // $40272
      var $40273=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40247);
      var $40274=__ZN11simple_listI16input_type_entryE6appendERS0_($40208, $40273);
      var $40275=$4689;
      var $40276=$2099;
      var $40277=$2100;
      var $40278=$2101;
      var $40279=$result_i1033;
      var $40280=$2102;
      var $40281=$2103;
      HEAP32[(($2099)>>2)]=408;
      HEAP32[(($2100)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2101)>>2)]=601;
      var $40282=HEAP32[(($2099)>>2)];
      var $40283=HEAP32[(($2100)>>2)];
      var $40284=HEAP32[(($2101)>>2)];
      var $40285=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40282, $40283, $40284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10497; break; } else { __label__ = 10499; break; };
    case 10497: // $40286
      HEAP32[(($result_i1033)>>2)]=$40285;
      var $40287=HEAP32[(($result_i1033)>>2)];
      var $40288=(($40287)|0)==0;
      if ($40288) { __label__ = 10498; break; } else { __label__ = 10503; break; }
    case 10498: // $40289
      var $40290=___cxa_allocate_exception(4);
      var $40291=$40290;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40291);
      (function() { try { __THREW__ = false; return ___cxa_throw($40290, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10502; break; } else { __label__ = 10499; break; }
    case 10499: // $40292
      var $40293=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40294=$40293.f0;
      HEAP32[(($2102)>>2)]=$40294;
      var $40295=$40293.f1;
      HEAP32[(($2103)>>2)]=$40295;
      var $40296=HEAP32[(($2103)>>2)];
      var $40297=(($40296)|0) < 0;
      if ($40297) { __label__ = 10500; break; } else { __label__ = 10501; break; }
    case 10500: // $40298
      var $40299=HEAP32[(($2102)>>2)];
      ___cxa_call_unexpected($40299);
      throw "Reached an unreachable!"
    case 10501: // $40300
      var $40301=HEAP32[(($2102)>>2)];
      var $40302=HEAP32[(($2102)>>2)];
      var $40303=HEAP32[(($2103)>>2)];
      var $40304=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40302, tempValue);
      var $40305=($40304.f1 = $40303, $40304);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10502: // $40306
      throw "Reached an unreachable!"
    case 10503: // $_ZnwjPKci_exit1034
      var $40307=HEAP32[(($result_i1033)>>2)];
      var $40308=$2099;
      var $40309=$2100;
      var $40310=$2101;
      var $40311=$result_i1033;
      var $40312=$2102;
      var $40313=$2103;
      var $40314=$40307;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11053, 2, 3, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10504; break; } else { __label__ = 14266; break; }
    case 10504: // $40315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11054, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10505; break; } else { __label__ = 14266; break; }
    case 10505: // $40316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11055, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10506; break; } else { __label__ = 14266; break; }
    case 10506: // $40317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11056, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10507; break; } else { __label__ = 14266; break; }
    case 10507: // $40318
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11057, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10508; break; } else { __label__ = 14266; break; }
    case 10508: // $40319
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11058, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10509; break; } else { __label__ = 14266; break; }
    case 10509: // $40320
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11059, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10510; break; } else { __label__ = 14266; break; }
    case 10510: // $40321
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11052, $11053, $11054, $11055, $11056, $11057, $11058, $11059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10511; break; } else { __label__ = 14266; break; }
    case 10511: // $40322
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11061, 4, 3, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10512; break; } else { __label__ = 14266; break; }
    case 10512: // $40323
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11062, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10513; break; } else { __label__ = 14266; break; }
    case 10513: // $40324
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11063, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10514; break; } else { __label__ = 14266; break; }
    case 10514: // $40325
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11064, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10515; break; } else { __label__ = 14266; break; }
    case 10515: // $40326
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11065, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10516; break; } else { __label__ = 14266; break; }
    case 10516: // $40327
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11066, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10517; break; } else { __label__ = 14266; break; }
    case 10517: // $40328
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11067, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10518; break; } else { __label__ = 14266; break; }
    case 10518: // $40329
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11060, $11061, $11062, $11063, $11064, $11065, $11066, $11067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10519; break; } else { __label__ = 14266; break; }
    case 10519: // $40330
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11069, 4, 3, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10520; break; } else { __label__ = 14266; break; }
    case 10520: // $40331
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11070, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10521; break; } else { __label__ = 14266; break; }
    case 10521: // $40332
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11071, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10522; break; } else { __label__ = 14266; break; }
    case 10522: // $40333
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11072, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10523; break; } else { __label__ = 14266; break; }
    case 10523: // $40334
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11073, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10524; break; } else { __label__ = 14266; break; }
    case 10524: // $40335
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11074, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10525; break; } else { __label__ = 14266; break; }
    case 10525: // $40336
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11075, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10526; break; } else { __label__ = 14266; break; }
    case 10526: // $40337
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11068, $11069, $11070, $11071, $11072, $11073, $11074, $11075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10527; break; } else { __label__ = 14266; break; }
    case 10527: // $40338
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40314, 157, 4, 3, ((STRING_TABLE.__str1224)|0), ((STRING_TABLE.__str1225)|0), $11052, $11060, $11068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10528; break; } else { __label__ = 14266; break; }
    case 10528: // $40339
      var $40340=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40314);
      var $40341=__ZN11simple_listI16input_type_entryE6appendERS0_($40275, $40340);
      var $40342=$4689;
      var $40343=$2094;
      var $40344=$2095;
      var $40345=$2096;
      var $40346=$result_i1035;
      var $40347=$2097;
      var $40348=$2098;
      HEAP32[(($2094)>>2)]=408;
      HEAP32[(($2095)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2096)>>2)]=602;
      var $40349=HEAP32[(($2094)>>2)];
      var $40350=HEAP32[(($2095)>>2)];
      var $40351=HEAP32[(($2096)>>2)];
      var $40352=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40349, $40350, $40351) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10529; break; } else { __label__ = 10531; break; };
    case 10529: // $40353
      HEAP32[(($result_i1035)>>2)]=$40352;
      var $40354=HEAP32[(($result_i1035)>>2)];
      var $40355=(($40354)|0)==0;
      if ($40355) { __label__ = 10530; break; } else { __label__ = 10535; break; }
    case 10530: // $40356
      var $40357=___cxa_allocate_exception(4);
      var $40358=$40357;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40358);
      (function() { try { __THREW__ = false; return ___cxa_throw($40357, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10534; break; } else { __label__ = 10531; break; }
    case 10531: // $40359
      var $40360=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40361=$40360.f0;
      HEAP32[(($2097)>>2)]=$40361;
      var $40362=$40360.f1;
      HEAP32[(($2098)>>2)]=$40362;
      var $40363=HEAP32[(($2098)>>2)];
      var $40364=(($40363)|0) < 0;
      if ($40364) { __label__ = 10532; break; } else { __label__ = 10533; break; }
    case 10532: // $40365
      var $40366=HEAP32[(($2097)>>2)];
      ___cxa_call_unexpected($40366);
      throw "Reached an unreachable!"
    case 10533: // $40367
      var $40368=HEAP32[(($2097)>>2)];
      var $40369=HEAP32[(($2097)>>2)];
      var $40370=HEAP32[(($2098)>>2)];
      var $40371=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40369, tempValue);
      var $40372=($40371.f1 = $40370, $40371);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10534: // $40373
      throw "Reached an unreachable!"
    case 10535: // $_ZnwjPKci_exit1036
      var $40374=HEAP32[(($result_i1035)>>2)];
      var $40375=$2094;
      var $40376=$2095;
      var $40377=$2096;
      var $40378=$result_i1035;
      var $40379=$2097;
      var $40380=$2098;
      var $40381=$40374;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11077, 2, 4, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10536; break; } else { __label__ = 14271; break; }
    case 10536: // $40382
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11078, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10537; break; } else { __label__ = 14271; break; }
    case 10537: // $40383
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11079, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10538; break; } else { __label__ = 14271; break; }
    case 10538: // $40384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11080, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10539; break; } else { __label__ = 14271; break; }
    case 10539: // $40385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11081, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10540; break; } else { __label__ = 14271; break; }
    case 10540: // $40386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11082, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10541; break; } else { __label__ = 14271; break; }
    case 10541: // $40387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11083, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10542; break; } else { __label__ = 14271; break; }
    case 10542: // $40388
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11076, $11077, $11078, $11079, $11080, $11081, $11082, $11083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10543; break; } else { __label__ = 14271; break; }
    case 10543: // $40389
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11085, 4, 4, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10544; break; } else { __label__ = 14271; break; }
    case 10544: // $40390
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11086, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10545; break; } else { __label__ = 14271; break; }
    case 10545: // $40391
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11087, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10546; break; } else { __label__ = 14271; break; }
    case 10546: // $40392
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11088, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10547; break; } else { __label__ = 14271; break; }
    case 10547: // $40393
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11089, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10548; break; } else { __label__ = 14271; break; }
    case 10548: // $40394
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11090, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10549; break; } else { __label__ = 14271; break; }
    case 10549: // $40395
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11091, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10550; break; } else { __label__ = 14271; break; }
    case 10550: // $40396
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11084, $11085, $11086, $11087, $11088, $11089, $11090, $11091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10551; break; } else { __label__ = 14271; break; }
    case 10551: // $40397
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11093, 4, 4, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10552; break; } else { __label__ = 14271; break; }
    case 10552: // $40398
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11094, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10553; break; } else { __label__ = 14271; break; }
    case 10553: // $40399
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11095, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10554; break; } else { __label__ = 14271; break; }
    case 10554: // $40400
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11096, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10555; break; } else { __label__ = 14271; break; }
    case 10555: // $40401
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11097, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10556; break; } else { __label__ = 14271; break; }
    case 10556: // $40402
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11098, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10557; break; } else { __label__ = 14271; break; }
    case 10557: // $40403
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11099, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10558; break; } else { __label__ = 14271; break; }
    case 10558: // $40404
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11092, $11093, $11094, $11095, $11096, $11097, $11098, $11099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10559; break; } else { __label__ = 14271; break; }
    case 10559: // $40405
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40381, 157, 5, 4, ((STRING_TABLE.__str1226)|0), ((STRING_TABLE.__str1227)|0), $11076, $11084, $11092) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10560; break; } else { __label__ = 14271; break; }
    case 10560: // $40406
      var $40407=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40381);
      var $40408=__ZN11simple_listI16input_type_entryE6appendERS0_($40342, $40407);
      var $40409=$4689;
      var $40410=$2089;
      var $40411=$2090;
      var $40412=$2091;
      var $40413=$result_i1037;
      var $40414=$2092;
      var $40415=$2093;
      HEAP32[(($2089)>>2)]=408;
      HEAP32[(($2090)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2091)>>2)]=603;
      var $40416=HEAP32[(($2089)>>2)];
      var $40417=HEAP32[(($2090)>>2)];
      var $40418=HEAP32[(($2091)>>2)];
      var $40419=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40416, $40417, $40418) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10561; break; } else { __label__ = 10563; break; };
    case 10561: // $40420
      HEAP32[(($result_i1037)>>2)]=$40419;
      var $40421=HEAP32[(($result_i1037)>>2)];
      var $40422=(($40421)|0)==0;
      if ($40422) { __label__ = 10562; break; } else { __label__ = 10567; break; }
    case 10562: // $40423
      var $40424=___cxa_allocate_exception(4);
      var $40425=$40424;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40425);
      (function() { try { __THREW__ = false; return ___cxa_throw($40424, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10566; break; } else { __label__ = 10563; break; }
    case 10563: // $40426
      var $40427=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40428=$40427.f0;
      HEAP32[(($2092)>>2)]=$40428;
      var $40429=$40427.f1;
      HEAP32[(($2093)>>2)]=$40429;
      var $40430=HEAP32[(($2093)>>2)];
      var $40431=(($40430)|0) < 0;
      if ($40431) { __label__ = 10564; break; } else { __label__ = 10565; break; }
    case 10564: // $40432
      var $40433=HEAP32[(($2092)>>2)];
      ___cxa_call_unexpected($40433);
      throw "Reached an unreachable!"
    case 10565: // $40434
      var $40435=HEAP32[(($2092)>>2)];
      var $40436=HEAP32[(($2092)>>2)];
      var $40437=HEAP32[(($2093)>>2)];
      var $40438=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40436, tempValue);
      var $40439=($40438.f1 = $40437, $40438);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10566: // $40440
      throw "Reached an unreachable!"
    case 10567: // $_ZnwjPKci_exit1038
      var $40441=HEAP32[(($result_i1037)>>2)];
      var $40442=$2089;
      var $40443=$2090;
      var $40444=$2091;
      var $40445=$result_i1037;
      var $40446=$2092;
      var $40447=$2093;
      var $40448=$40441;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11101, 2, 5, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10568; break; } else { __label__ = 14276; break; }
    case 10568: // $40449
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11102, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10569; break; } else { __label__ = 14276; break; }
    case 10569: // $40450
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11103, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10570; break; } else { __label__ = 14276; break; }
    case 10570: // $40451
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11104, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10571; break; } else { __label__ = 14276; break; }
    case 10571: // $40452
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11105, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10572; break; } else { __label__ = 14276; break; }
    case 10572: // $40453
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11106, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10573; break; } else { __label__ = 14276; break; }
    case 10573: // $40454
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11107, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10574; break; } else { __label__ = 14276; break; }
    case 10574: // $40455
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11100, $11101, $11102, $11103, $11104, $11105, $11106, $11107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10575; break; } else { __label__ = 14276; break; }
    case 10575: // $40456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11109, 4, 5, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10576; break; } else { __label__ = 14276; break; }
    case 10576: // $40457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11110, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10577; break; } else { __label__ = 14276; break; }
    case 10577: // $40458
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11111, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10578; break; } else { __label__ = 14276; break; }
    case 10578: // $40459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11112, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10579; break; } else { __label__ = 14276; break; }
    case 10579: // $40460
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11113, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10580; break; } else { __label__ = 14276; break; }
    case 10580: // $40461
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11114, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10581; break; } else { __label__ = 14276; break; }
    case 10581: // $40462
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11115, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10582; break; } else { __label__ = 14276; break; }
    case 10582: // $40463
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11108, $11109, $11110, $11111, $11112, $11113, $11114, $11115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10583; break; } else { __label__ = 14276; break; }
    case 10583: // $40464
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11117, 4, 5, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10584; break; } else { __label__ = 14276; break; }
    case 10584: // $40465
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11118, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10585; break; } else { __label__ = 14276; break; }
    case 10585: // $40466
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11119, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10586; break; } else { __label__ = 14276; break; }
    case 10586: // $40467
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11120, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10587; break; } else { __label__ = 14276; break; }
    case 10587: // $40468
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11121, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10588; break; } else { __label__ = 14276; break; }
    case 10588: // $40469
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11122, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10589; break; } else { __label__ = 14276; break; }
    case 10589: // $40470
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11123, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10590; break; } else { __label__ = 14276; break; }
    case 10590: // $40471
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11116, $11117, $11118, $11119, $11120, $11121, $11122, $11123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10591; break; } else { __label__ = 14276; break; }
    case 10591: // $40472
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40448, 157, 6, 5, ((STRING_TABLE.__str1228)|0), ((STRING_TABLE.__str1229)|0), $11100, $11108, $11116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10592; break; } else { __label__ = 14276; break; }
    case 10592: // $40473
      var $40474=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40448);
      var $40475=__ZN11simple_listI16input_type_entryE6appendERS0_($40409, $40474);
      var $40476=$4689;
      var $40477=$2084;
      var $40478=$2085;
      var $40479=$2086;
      var $40480=$result_i1039;
      var $40481=$2087;
      var $40482=$2088;
      HEAP32[(($2084)>>2)]=408;
      HEAP32[(($2085)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2086)>>2)]=604;
      var $40483=HEAP32[(($2084)>>2)];
      var $40484=HEAP32[(($2085)>>2)];
      var $40485=HEAP32[(($2086)>>2)];
      var $40486=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40483, $40484, $40485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10593; break; } else { __label__ = 10595; break; };
    case 10593: // $40487
      HEAP32[(($result_i1039)>>2)]=$40486;
      var $40488=HEAP32[(($result_i1039)>>2)];
      var $40489=(($40488)|0)==0;
      if ($40489) { __label__ = 10594; break; } else { __label__ = 10599; break; }
    case 10594: // $40490
      var $40491=___cxa_allocate_exception(4);
      var $40492=$40491;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40492);
      (function() { try { __THREW__ = false; return ___cxa_throw($40491, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10598; break; } else { __label__ = 10595; break; }
    case 10595: // $40493
      var $40494=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40495=$40494.f0;
      HEAP32[(($2087)>>2)]=$40495;
      var $40496=$40494.f1;
      HEAP32[(($2088)>>2)]=$40496;
      var $40497=HEAP32[(($2088)>>2)];
      var $40498=(($40497)|0) < 0;
      if ($40498) { __label__ = 10596; break; } else { __label__ = 10597; break; }
    case 10596: // $40499
      var $40500=HEAP32[(($2087)>>2)];
      ___cxa_call_unexpected($40500);
      throw "Reached an unreachable!"
    case 10597: // $40501
      var $40502=HEAP32[(($2087)>>2)];
      var $40503=HEAP32[(($2087)>>2)];
      var $40504=HEAP32[(($2088)>>2)];
      var $40505=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40503, tempValue);
      var $40506=($40505.f1 = $40504, $40505);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10598: // $40507
      throw "Reached an unreachable!"
    case 10599: // $_ZnwjPKci_exit1040
      var $40508=HEAP32[(($result_i1039)>>2)];
      var $40509=$2084;
      var $40510=$2085;
      var $40511=$2086;
      var $40512=$result_i1039;
      var $40513=$2087;
      var $40514=$2088;
      var $40515=$40508;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11125, 2, 6, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10600; break; } else { __label__ = 14281; break; }
    case 10600: // $40516
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11126, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10601; break; } else { __label__ = 14281; break; }
    case 10601: // $40517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11127, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10602; break; } else { __label__ = 14281; break; }
    case 10602: // $40518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11128, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10603; break; } else { __label__ = 14281; break; }
    case 10603: // $40519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11129, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10604; break; } else { __label__ = 14281; break; }
    case 10604: // $40520
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11130, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10605; break; } else { __label__ = 14281; break; }
    case 10605: // $40521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11131, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10606; break; } else { __label__ = 14281; break; }
    case 10606: // $40522
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11124, $11125, $11126, $11127, $11128, $11129, $11130, $11131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10607; break; } else { __label__ = 14281; break; }
    case 10607: // $40523
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11133, 4, 6, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10608; break; } else { __label__ = 14281; break; }
    case 10608: // $40524
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11134, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10609; break; } else { __label__ = 14281; break; }
    case 10609: // $40525
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11135, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10610; break; } else { __label__ = 14281; break; }
    case 10610: // $40526
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11136, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10611; break; } else { __label__ = 14281; break; }
    case 10611: // $40527
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11137, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10612; break; } else { __label__ = 14281; break; }
    case 10612: // $40528
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11138, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10613; break; } else { __label__ = 14281; break; }
    case 10613: // $40529
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11139, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10614; break; } else { __label__ = 14281; break; }
    case 10614: // $40530
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11132, $11133, $11134, $11135, $11136, $11137, $11138, $11139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10615; break; } else { __label__ = 14281; break; }
    case 10615: // $40531
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11141, 4, 6, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10616; break; } else { __label__ = 14281; break; }
    case 10616: // $40532
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11142, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10617; break; } else { __label__ = 14281; break; }
    case 10617: // $40533
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11143, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10618; break; } else { __label__ = 14281; break; }
    case 10618: // $40534
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11144, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10619; break; } else { __label__ = 14281; break; }
    case 10619: // $40535
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11145, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10620; break; } else { __label__ = 14281; break; }
    case 10620: // $40536
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11146, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10621; break; } else { __label__ = 14281; break; }
    case 10621: // $40537
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11147, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10622; break; } else { __label__ = 14281; break; }
    case 10622: // $40538
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11140, $11141, $11142, $11143, $11144, $11145, $11146, $11147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10623; break; } else { __label__ = 14281; break; }
    case 10623: // $40539
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40515, 157, 7, 6, ((STRING_TABLE.__str1230)|0), ((STRING_TABLE.__str1231)|0), $11124, $11132, $11140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10624; break; } else { __label__ = 14281; break; }
    case 10624: // $40540
      var $40541=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40515);
      var $40542=__ZN11simple_listI16input_type_entryE6appendERS0_($40476, $40541);
      var $40543=$4689;
      var $40544=$2079;
      var $40545=$2080;
      var $40546=$2081;
      var $40547=$result_i1041;
      var $40548=$2082;
      var $40549=$2083;
      HEAP32[(($2079)>>2)]=408;
      HEAP32[(($2080)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2081)>>2)]=605;
      var $40550=HEAP32[(($2079)>>2)];
      var $40551=HEAP32[(($2080)>>2)];
      var $40552=HEAP32[(($2081)>>2)];
      var $40553=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40550, $40551, $40552) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10625; break; } else { __label__ = 10627; break; };
    case 10625: // $40554
      HEAP32[(($result_i1041)>>2)]=$40553;
      var $40555=HEAP32[(($result_i1041)>>2)];
      var $40556=(($40555)|0)==0;
      if ($40556) { __label__ = 10626; break; } else { __label__ = 10631; break; }
    case 10626: // $40557
      var $40558=___cxa_allocate_exception(4);
      var $40559=$40558;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40559);
      (function() { try { __THREW__ = false; return ___cxa_throw($40558, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10630; break; } else { __label__ = 10627; break; }
    case 10627: // $40560
      var $40561=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40562=$40561.f0;
      HEAP32[(($2082)>>2)]=$40562;
      var $40563=$40561.f1;
      HEAP32[(($2083)>>2)]=$40563;
      var $40564=HEAP32[(($2083)>>2)];
      var $40565=(($40564)|0) < 0;
      if ($40565) { __label__ = 10628; break; } else { __label__ = 10629; break; }
    case 10628: // $40566
      var $40567=HEAP32[(($2082)>>2)];
      ___cxa_call_unexpected($40567);
      throw "Reached an unreachable!"
    case 10629: // $40568
      var $40569=HEAP32[(($2082)>>2)];
      var $40570=HEAP32[(($2082)>>2)];
      var $40571=HEAP32[(($2083)>>2)];
      var $40572=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40570, tempValue);
      var $40573=($40572.f1 = $40571, $40572);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10630: // $40574
      throw "Reached an unreachable!"
    case 10631: // $_ZnwjPKci_exit1042
      var $40575=HEAP32[(($result_i1041)>>2)];
      var $40576=$2079;
      var $40577=$2080;
      var $40578=$2081;
      var $40579=$result_i1041;
      var $40580=$2082;
      var $40581=$2083;
      var $40582=$40575;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11149, 2, 7, 3, 0, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10632; break; } else { __label__ = 14286; break; }
    case 10632: // $40583
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11150, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10633; break; } else { __label__ = 14286; break; }
    case 10633: // $40584
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11151, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10634; break; } else { __label__ = 14286; break; }
    case 10634: // $40585
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11152, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10635; break; } else { __label__ = 14286; break; }
    case 10635: // $40586
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11153, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10636; break; } else { __label__ = 14286; break; }
    case 10636: // $40587
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11154, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10637; break; } else { __label__ = 14286; break; }
    case 10637: // $40588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11155, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10638; break; } else { __label__ = 14286; break; }
    case 10638: // $40589
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11148, $11149, $11150, $11151, $11152, $11153, $11154, $11155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10639; break; } else { __label__ = 14286; break; }
    case 10639: // $40590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11157, 4, 7, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10640; break; } else { __label__ = 14286; break; }
    case 10640: // $40591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11158, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10641; break; } else { __label__ = 14286; break; }
    case 10641: // $40592
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11159, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10642; break; } else { __label__ = 14286; break; }
    case 10642: // $40593
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11160, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10643; break; } else { __label__ = 14286; break; }
    case 10643: // $40594
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11161, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10644; break; } else { __label__ = 14286; break; }
    case 10644: // $40595
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11162, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10645; break; } else { __label__ = 14286; break; }
    case 10645: // $40596
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11163, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10646; break; } else { __label__ = 14286; break; }
    case 10646: // $40597
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11156, $11157, $11158, $11159, $11160, $11161, $11162, $11163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10647; break; } else { __label__ = 14286; break; }
    case 10647: // $40598
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11165, 4, 7, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10648; break; } else { __label__ = 14286; break; }
    case 10648: // $40599
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11166, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10649; break; } else { __label__ = 14286; break; }
    case 10649: // $40600
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11167, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10650; break; } else { __label__ = 14286; break; }
    case 10650: // $40601
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11168, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10651; break; } else { __label__ = 14286; break; }
    case 10651: // $40602
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11169, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10652; break; } else { __label__ = 14286; break; }
    case 10652: // $40603
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11170, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10653; break; } else { __label__ = 14286; break; }
    case 10653: // $40604
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11171, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10654; break; } else { __label__ = 14286; break; }
    case 10654: // $40605
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11164, $11165, $11166, $11167, $11168, $11169, $11170, $11171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10655; break; } else { __label__ = 14286; break; }
    case 10655: // $40606
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_]($40582, 157, 8, 7, ((STRING_TABLE.__str1232)|0), ((STRING_TABLE.__str1233)|0), $11148, $11156, $11164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10656; break; } else { __label__ = 14286; break; }
    case 10656: // $40607
      var $40608=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40582);
      var $40609=__ZN11simple_listI16input_type_entryE6appendERS0_($40543, $40608);
      var $40610=$4689;
      var $40611=$2074;
      var $40612=$2075;
      var $40613=$2076;
      var $40614=$result_i1043;
      var $40615=$2077;
      var $40616=$2078;
      HEAP32[(($2074)>>2)]=408;
      HEAP32[(($2075)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2076)>>2)]=607;
      var $40617=HEAP32[(($2074)>>2)];
      var $40618=HEAP32[(($2075)>>2)];
      var $40619=HEAP32[(($2076)>>2)];
      var $40620=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40617, $40618, $40619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10657; break; } else { __label__ = 10659; break; };
    case 10657: // $40621
      HEAP32[(($result_i1043)>>2)]=$40620;
      var $40622=HEAP32[(($result_i1043)>>2)];
      var $40623=(($40622)|0)==0;
      if ($40623) { __label__ = 10658; break; } else { __label__ = 10663; break; }
    case 10658: // $40624
      var $40625=___cxa_allocate_exception(4);
      var $40626=$40625;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40626);
      (function() { try { __THREW__ = false; return ___cxa_throw($40625, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10662; break; } else { __label__ = 10659; break; }
    case 10659: // $40627
      var $40628=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40629=$40628.f0;
      HEAP32[(($2077)>>2)]=$40629;
      var $40630=$40628.f1;
      HEAP32[(($2078)>>2)]=$40630;
      var $40631=HEAP32[(($2078)>>2)];
      var $40632=(($40631)|0) < 0;
      if ($40632) { __label__ = 10660; break; } else { __label__ = 10661; break; }
    case 10660: // $40633
      var $40634=HEAP32[(($2077)>>2)];
      ___cxa_call_unexpected($40634);
      throw "Reached an unreachable!"
    case 10661: // $40635
      var $40636=HEAP32[(($2077)>>2)];
      var $40637=HEAP32[(($2077)>>2)];
      var $40638=HEAP32[(($2078)>>2)];
      var $40639=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40637, tempValue);
      var $40640=($40639.f1 = $40638, $40639);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10662: // $40641
      throw "Reached an unreachable!"
    case 10663: // $_ZnwjPKci_exit1044
      var $40642=HEAP32[(($result_i1043)>>2)];
      var $40643=$2074;
      var $40644=$2075;
      var $40645=$2076;
      var $40646=$result_i1043;
      var $40647=$2077;
      var $40648=$2078;
      var $40649=$40642;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11173, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10664; break; } else { __label__ = 14291; break; }
    case 10664: // $40650
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11174, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10665; break; } else { __label__ = 14291; break; }
    case 10665: // $40651
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11175, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10666; break; } else { __label__ = 14291; break; }
    case 10666: // $40652
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11176, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10667; break; } else { __label__ = 14291; break; }
    case 10667: // $40653
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11177, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10668; break; } else { __label__ = 14291; break; }
    case 10668: // $40654
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11178, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10669; break; } else { __label__ = 14291; break; }
    case 10669: // $40655
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11179, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10670; break; } else { __label__ = 14291; break; }
    case 10670: // $40656
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11172, $11173, $11174, $11175, $11176, $11177, $11178, $11179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10671; break; } else { __label__ = 14291; break; }
    case 10671: // $40657
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40649, 45, 9, 0, ((STRING_TABLE.__str1234427)|0), ((STRING_TABLE.__str1235)|0), $11172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10672; break; } else { __label__ = 14291; break; }
    case 10672: // $40658
      var $40659=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40649);
      var $40660=__ZN11simple_listI16input_type_entryE6appendERS0_($40610, $40659);
      var $40661=$4689;
      var $40662=$2069;
      var $40663=$2070;
      var $40664=$2071;
      var $40665=$result_i1045;
      var $40666=$2072;
      var $40667=$2073;
      HEAP32[(($2069)>>2)]=408;
      HEAP32[(($2070)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2071)>>2)]=608;
      var $40668=HEAP32[(($2069)>>2)];
      var $40669=HEAP32[(($2070)>>2)];
      var $40670=HEAP32[(($2071)>>2)];
      var $40671=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40668, $40669, $40670) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10673; break; } else { __label__ = 10675; break; };
    case 10673: // $40672
      HEAP32[(($result_i1045)>>2)]=$40671;
      var $40673=HEAP32[(($result_i1045)>>2)];
      var $40674=(($40673)|0)==0;
      if ($40674) { __label__ = 10674; break; } else { __label__ = 10679; break; }
    case 10674: // $40675
      var $40676=___cxa_allocate_exception(4);
      var $40677=$40676;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40677);
      (function() { try { __THREW__ = false; return ___cxa_throw($40676, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10678; break; } else { __label__ = 10675; break; }
    case 10675: // $40678
      var $40679=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40680=$40679.f0;
      HEAP32[(($2072)>>2)]=$40680;
      var $40681=$40679.f1;
      HEAP32[(($2073)>>2)]=$40681;
      var $40682=HEAP32[(($2073)>>2)];
      var $40683=(($40682)|0) < 0;
      if ($40683) { __label__ = 10676; break; } else { __label__ = 10677; break; }
    case 10676: // $40684
      var $40685=HEAP32[(($2072)>>2)];
      ___cxa_call_unexpected($40685);
      throw "Reached an unreachable!"
    case 10677: // $40686
      var $40687=HEAP32[(($2072)>>2)];
      var $40688=HEAP32[(($2072)>>2)];
      var $40689=HEAP32[(($2073)>>2)];
      var $40690=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40688, tempValue);
      var $40691=($40690.f1 = $40689, $40690);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10678: // $40692
      throw "Reached an unreachable!"
    case 10679: // $_ZnwjPKci_exit1046
      var $40693=HEAP32[(($result_i1045)>>2)];
      var $40694=$2069;
      var $40695=$2070;
      var $40696=$2071;
      var $40697=$result_i1045;
      var $40698=$2072;
      var $40699=$2073;
      var $40700=$40693;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11181, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10680; break; } else { __label__ = 14296; break; }
    case 10680: // $40701
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11182, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10681; break; } else { __label__ = 14296; break; }
    case 10681: // $40702
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11183, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10682; break; } else { __label__ = 14296; break; }
    case 10682: // $40703
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11184, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10683; break; } else { __label__ = 14296; break; }
    case 10683: // $40704
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11185, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10684; break; } else { __label__ = 14296; break; }
    case 10684: // $40705
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11186, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10685; break; } else { __label__ = 14296; break; }
    case 10685: // $40706
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11187, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10686; break; } else { __label__ = 14296; break; }
    case 10686: // $40707
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11180, $11181, $11182, $11183, $11184, $11185, $11186, $11187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10687; break; } else { __label__ = 14296; break; }
    case 10687: // $40708
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40700, 46, 9, 0, ((STRING_TABLE.__str1236)|0), ((STRING_TABLE.__str1237)|0), $11180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10688; break; } else { __label__ = 14296; break; }
    case 10688: // $40709
      var $40710=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40700);
      var $40711=__ZN11simple_listI16input_type_entryE6appendERS0_($40661, $40710);
      var $40712=$4689;
      var $40713=$2064;
      var $40714=$2065;
      var $40715=$2066;
      var $40716=$result_i1047;
      var $40717=$2067;
      var $40718=$2068;
      HEAP32[(($2064)>>2)]=408;
      HEAP32[(($2065)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2066)>>2)]=610;
      var $40719=HEAP32[(($2064)>>2)];
      var $40720=HEAP32[(($2065)>>2)];
      var $40721=HEAP32[(($2066)>>2)];
      var $40722=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40719, $40720, $40721) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10689; break; } else { __label__ = 10691; break; };
    case 10689: // $40723
      HEAP32[(($result_i1047)>>2)]=$40722;
      var $40724=HEAP32[(($result_i1047)>>2)];
      var $40725=(($40724)|0)==0;
      if ($40725) { __label__ = 10690; break; } else { __label__ = 10695; break; }
    case 10690: // $40726
      var $40727=___cxa_allocate_exception(4);
      var $40728=$40727;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40728);
      (function() { try { __THREW__ = false; return ___cxa_throw($40727, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10694; break; } else { __label__ = 10691; break; }
    case 10691: // $40729
      var $40730=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40731=$40730.f0;
      HEAP32[(($2067)>>2)]=$40731;
      var $40732=$40730.f1;
      HEAP32[(($2068)>>2)]=$40732;
      var $40733=HEAP32[(($2068)>>2)];
      var $40734=(($40733)|0) < 0;
      if ($40734) { __label__ = 10692; break; } else { __label__ = 10693; break; }
    case 10692: // $40735
      var $40736=HEAP32[(($2067)>>2)];
      ___cxa_call_unexpected($40736);
      throw "Reached an unreachable!"
    case 10693: // $40737
      var $40738=HEAP32[(($2067)>>2)];
      var $40739=HEAP32[(($2067)>>2)];
      var $40740=HEAP32[(($2068)>>2)];
      var $40741=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40739, tempValue);
      var $40742=($40741.f1 = $40740, $40741);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10694: // $40743
      throw "Reached an unreachable!"
    case 10695: // $_ZnwjPKci_exit1048
      var $40744=HEAP32[(($result_i1047)>>2)];
      var $40745=$2064;
      var $40746=$2065;
      var $40747=$2066;
      var $40748=$result_i1047;
      var $40749=$2067;
      var $40750=$2068;
      var $40751=$40744;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11189, 1, 0, 1, 0, 53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10696; break; } else { __label__ = 14301; break; }
    case 10696: // $40752
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11190, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10697; break; } else { __label__ = 14301; break; }
    case 10697: // $40753
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11191, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10698; break; } else { __label__ = 14301; break; }
    case 10698: // $40754
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11192, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10699; break; } else { __label__ = 14301; break; }
    case 10699: // $40755
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11193, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10700; break; } else { __label__ = 14301; break; }
    case 10700: // $40756
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11194, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10701; break; } else { __label__ = 14301; break; }
    case 10701: // $40757
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11195, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10702; break; } else { __label__ = 14301; break; }
    case 10702: // $40758
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11188, $11189, $11190, $11191, $11192, $11193, $11194, $11195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10703; break; } else { __label__ = 14301; break; }
    case 10703: // $40759
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40751, 160, 0, 0, ((STRING_TABLE.__str1238)|0), ((STRING_TABLE.__str1239)|0), $11188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10704; break; } else { __label__ = 14301; break; }
    case 10704: // $40760
      var $40761=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40751);
      var $40762=__ZN11simple_listI16input_type_entryE6appendERS0_($40712, $40761);
      var $40763=$4689;
      var $40764=$2059;
      var $40765=$2060;
      var $40766=$2061;
      var $40767=$result_i1049;
      var $40768=$2062;
      var $40769=$2063;
      HEAP32[(($2059)>>2)]=408;
      HEAP32[(($2060)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2061)>>2)]=611;
      var $40770=HEAP32[(($2059)>>2)];
      var $40771=HEAP32[(($2060)>>2)];
      var $40772=HEAP32[(($2061)>>2)];
      var $40773=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40770, $40771, $40772) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10705; break; } else { __label__ = 10707; break; };
    case 10705: // $40774
      HEAP32[(($result_i1049)>>2)]=$40773;
      var $40775=HEAP32[(($result_i1049)>>2)];
      var $40776=(($40775)|0)==0;
      if ($40776) { __label__ = 10706; break; } else { __label__ = 10711; break; }
    case 10706: // $40777
      var $40778=___cxa_allocate_exception(4);
      var $40779=$40778;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40779);
      (function() { try { __THREW__ = false; return ___cxa_throw($40778, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10710; break; } else { __label__ = 10707; break; }
    case 10707: // $40780
      var $40781=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40782=$40781.f0;
      HEAP32[(($2062)>>2)]=$40782;
      var $40783=$40781.f1;
      HEAP32[(($2063)>>2)]=$40783;
      var $40784=HEAP32[(($2063)>>2)];
      var $40785=(($40784)|0) < 0;
      if ($40785) { __label__ = 10708; break; } else { __label__ = 10709; break; }
    case 10708: // $40786
      var $40787=HEAP32[(($2062)>>2)];
      ___cxa_call_unexpected($40787);
      throw "Reached an unreachable!"
    case 10709: // $40788
      var $40789=HEAP32[(($2062)>>2)];
      var $40790=HEAP32[(($2062)>>2)];
      var $40791=HEAP32[(($2063)>>2)];
      var $40792=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40790, tempValue);
      var $40793=($40792.f1 = $40791, $40792);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10710: // $40794
      throw "Reached an unreachable!"
    case 10711: // $_ZnwjPKci_exit1050
      var $40795=HEAP32[(($result_i1049)>>2)];
      var $40796=$2059;
      var $40797=$2060;
      var $40798=$2061;
      var $40799=$result_i1049;
      var $40800=$2062;
      var $40801=$2063;
      var $40802=$40795;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11197, 1, 0, 1, 0, 53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10712; break; } else { __label__ = 14306; break; }
    case 10712: // $40803
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11198, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10713; break; } else { __label__ = 14306; break; }
    case 10713: // $40804
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11199, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10714; break; } else { __label__ = 14306; break; }
    case 10714: // $40805
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11200, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10715; break; } else { __label__ = 14306; break; }
    case 10715: // $40806
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11201, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10716; break; } else { __label__ = 14306; break; }
    case 10716: // $40807
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11202, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10717; break; } else { __label__ = 14306; break; }
    case 10717: // $40808
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11203, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10718; break; } else { __label__ = 14306; break; }
    case 10718: // $40809
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11196, $11197, $11198, $11199, $11200, $11201, $11202, $11203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10719; break; } else { __label__ = 14306; break; }
    case 10719: // $40810
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40802, 161, 0, 0, ((STRING_TABLE.__str1240)|0), ((STRING_TABLE.__str1241)|0), $11196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10720; break; } else { __label__ = 14306; break; }
    case 10720: // $40811
      var $40812=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40802);
      var $40813=__ZN11simple_listI16input_type_entryE6appendERS0_($40763, $40812);
      var $40814=$4689;
      var $40815=$2054;
      var $40816=$2055;
      var $40817=$2056;
      var $40818=$result_i1051;
      var $40819=$2057;
      var $40820=$2058;
      HEAP32[(($2054)>>2)]=408;
      HEAP32[(($2055)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2056)>>2)]=612;
      var $40821=HEAP32[(($2054)>>2)];
      var $40822=HEAP32[(($2055)>>2)];
      var $40823=HEAP32[(($2056)>>2)];
      var $40824=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40821, $40822, $40823) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10721; break; } else { __label__ = 10723; break; };
    case 10721: // $40825
      HEAP32[(($result_i1051)>>2)]=$40824;
      var $40826=HEAP32[(($result_i1051)>>2)];
      var $40827=(($40826)|0)==0;
      if ($40827) { __label__ = 10722; break; } else { __label__ = 10727; break; }
    case 10722: // $40828
      var $40829=___cxa_allocate_exception(4);
      var $40830=$40829;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40830);
      (function() { try { __THREW__ = false; return ___cxa_throw($40829, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10726; break; } else { __label__ = 10723; break; }
    case 10723: // $40831
      var $40832=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40833=$40832.f0;
      HEAP32[(($2057)>>2)]=$40833;
      var $40834=$40832.f1;
      HEAP32[(($2058)>>2)]=$40834;
      var $40835=HEAP32[(($2058)>>2)];
      var $40836=(($40835)|0) < 0;
      if ($40836) { __label__ = 10724; break; } else { __label__ = 10725; break; }
    case 10724: // $40837
      var $40838=HEAP32[(($2057)>>2)];
      ___cxa_call_unexpected($40838);
      throw "Reached an unreachable!"
    case 10725: // $40839
      var $40840=HEAP32[(($2057)>>2)];
      var $40841=HEAP32[(($2057)>>2)];
      var $40842=HEAP32[(($2058)>>2)];
      var $40843=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40841, tempValue);
      var $40844=($40843.f1 = $40842, $40843);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10726: // $40845
      throw "Reached an unreachable!"
    case 10727: // $_ZnwjPKci_exit1052
      var $40846=HEAP32[(($result_i1051)>>2)];
      var $40847=$2054;
      var $40848=$2055;
      var $40849=$2056;
      var $40850=$result_i1051;
      var $40851=$2057;
      var $40852=$2058;
      var $40853=$40846;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11205, 1, 0, 1, 0, 57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10728; break; } else { __label__ = 14311; break; }
    case 10728: // $40854
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11206, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10729; break; } else { __label__ = 14311; break; }
    case 10729: // $40855
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11207, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10730; break; } else { __label__ = 14311; break; }
    case 10730: // $40856
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11208, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10731; break; } else { __label__ = 14311; break; }
    case 10731: // $40857
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11209, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10732; break; } else { __label__ = 14311; break; }
    case 10732: // $40858
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11210, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10733; break; } else { __label__ = 14311; break; }
    case 10733: // $40859
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11211, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10734; break; } else { __label__ = 14311; break; }
    case 10734: // $40860
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11204, $11205, $11206, $11207, $11208, $11209, $11210, $11211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10735; break; } else { __label__ = 14311; break; }
    case 10735: // $40861
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40853, 159, 0, 0, ((STRING_TABLE.__str1242)|0), ((STRING_TABLE.__str1243)|0), $11204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10736; break; } else { __label__ = 14311; break; }
    case 10736: // $40862
      var $40863=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40853);
      var $40864=__ZN11simple_listI16input_type_entryE6appendERS0_($40814, $40863);
      var $40865=$4689;
      var $40866=$2049;
      var $40867=$2050;
      var $40868=$2051;
      var $40869=$result_i1053;
      var $40870=$2052;
      var $40871=$2053;
      HEAP32[(($2049)>>2)]=408;
      HEAP32[(($2050)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2051)>>2)]=613;
      var $40872=HEAP32[(($2049)>>2)];
      var $40873=HEAP32[(($2050)>>2)];
      var $40874=HEAP32[(($2051)>>2)];
      var $40875=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40872, $40873, $40874) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10737; break; } else { __label__ = 10739; break; };
    case 10737: // $40876
      HEAP32[(($result_i1053)>>2)]=$40875;
      var $40877=HEAP32[(($result_i1053)>>2)];
      var $40878=(($40877)|0)==0;
      if ($40878) { __label__ = 10738; break; } else { __label__ = 10743; break; }
    case 10738: // $40879
      var $40880=___cxa_allocate_exception(4);
      var $40881=$40880;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40881);
      (function() { try { __THREW__ = false; return ___cxa_throw($40880, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10742; break; } else { __label__ = 10739; break; }
    case 10739: // $40882
      var $40883=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40884=$40883.f0;
      HEAP32[(($2052)>>2)]=$40884;
      var $40885=$40883.f1;
      HEAP32[(($2053)>>2)]=$40885;
      var $40886=HEAP32[(($2053)>>2)];
      var $40887=(($40886)|0) < 0;
      if ($40887) { __label__ = 10740; break; } else { __label__ = 10741; break; }
    case 10740: // $40888
      var $40889=HEAP32[(($2052)>>2)];
      ___cxa_call_unexpected($40889);
      throw "Reached an unreachable!"
    case 10741: // $40890
      var $40891=HEAP32[(($2052)>>2)];
      var $40892=HEAP32[(($2052)>>2)];
      var $40893=HEAP32[(($2053)>>2)];
      var $40894=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40892, tempValue);
      var $40895=($40894.f1 = $40893, $40894);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10742: // $40896
      throw "Reached an unreachable!"
    case 10743: // $_ZnwjPKci_exit1054
      var $40897=HEAP32[(($result_i1053)>>2)];
      var $40898=$2049;
      var $40899=$2050;
      var $40900=$2051;
      var $40901=$result_i1053;
      var $40902=$2052;
      var $40903=$2053;
      var $40904=$40897;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11213, 1, 0, 1, 0, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10744; break; } else { __label__ = 14316; break; }
    case 10744: // $40905
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11214, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10745; break; } else { __label__ = 14316; break; }
    case 10745: // $40906
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11215, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10746; break; } else { __label__ = 14316; break; }
    case 10746: // $40907
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11216, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10747; break; } else { __label__ = 14316; break; }
    case 10747: // $40908
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11217, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10748; break; } else { __label__ = 14316; break; }
    case 10748: // $40909
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11218, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10749; break; } else { __label__ = 14316; break; }
    case 10749: // $40910
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11219, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10750; break; } else { __label__ = 14316; break; }
    case 10750: // $40911
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11212, $11213, $11214, $11215, $11216, $11217, $11218, $11219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10751; break; } else { __label__ = 14316; break; }
    case 10751: // $40912
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40904, 162, 0, 0, ((STRING_TABLE.__str1244)|0), ((STRING_TABLE.__str177)|0), $11212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10752; break; } else { __label__ = 14316; break; }
    case 10752: // $40913
      var $40914=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40904);
      var $40915=__ZN11simple_listI16input_type_entryE6appendERS0_($40865, $40914);
      var $40916=$4689;
      var $40917=$2044;
      var $40918=$2045;
      var $40919=$2046;
      var $40920=$result_i1055;
      var $40921=$2047;
      var $40922=$2048;
      HEAP32[(($2044)>>2)]=408;
      HEAP32[(($2045)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2046)>>2)]=614;
      var $40923=HEAP32[(($2044)>>2)];
      var $40924=HEAP32[(($2045)>>2)];
      var $40925=HEAP32[(($2046)>>2)];
      var $40926=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40923, $40924, $40925) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10753; break; } else { __label__ = 10755; break; };
    case 10753: // $40927
      HEAP32[(($result_i1055)>>2)]=$40926;
      var $40928=HEAP32[(($result_i1055)>>2)];
      var $40929=(($40928)|0)==0;
      if ($40929) { __label__ = 10754; break; } else { __label__ = 10759; break; }
    case 10754: // $40930
      var $40931=___cxa_allocate_exception(4);
      var $40932=$40931;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40932);
      (function() { try { __THREW__ = false; return ___cxa_throw($40931, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10758; break; } else { __label__ = 10755; break; }
    case 10755: // $40933
      var $40934=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40935=$40934.f0;
      HEAP32[(($2047)>>2)]=$40935;
      var $40936=$40934.f1;
      HEAP32[(($2048)>>2)]=$40936;
      var $40937=HEAP32[(($2048)>>2)];
      var $40938=(($40937)|0) < 0;
      if ($40938) { __label__ = 10756; break; } else { __label__ = 10757; break; }
    case 10756: // $40939
      var $40940=HEAP32[(($2047)>>2)];
      ___cxa_call_unexpected($40940);
      throw "Reached an unreachable!"
    case 10757: // $40941
      var $40942=HEAP32[(($2047)>>2)];
      var $40943=HEAP32[(($2047)>>2)];
      var $40944=HEAP32[(($2048)>>2)];
      var $40945=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40943, tempValue);
      var $40946=($40945.f1 = $40944, $40945);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10758: // $40947
      throw "Reached an unreachable!"
    case 10759: // $_ZnwjPKci_exit1056
      var $40948=HEAP32[(($result_i1055)>>2)];
      var $40949=$2044;
      var $40950=$2045;
      var $40951=$2046;
      var $40952=$result_i1055;
      var $40953=$2047;
      var $40954=$2048;
      var $40955=$40948;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11221, 1, 0, 1, 0, 39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10760; break; } else { __label__ = 14321; break; }
    case 10760: // $40956
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11222, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10761; break; } else { __label__ = 14321; break; }
    case 10761: // $40957
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11223, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10762; break; } else { __label__ = 14321; break; }
    case 10762: // $40958
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11224, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10763; break; } else { __label__ = 14321; break; }
    case 10763: // $40959
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11225, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10764; break; } else { __label__ = 14321; break; }
    case 10764: // $40960
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11226, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10765; break; } else { __label__ = 14321; break; }
    case 10765: // $40961
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11227, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10766; break; } else { __label__ = 14321; break; }
    case 10766: // $40962
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11220, $11221, $11222, $11223, $11224, $11225, $11226, $11227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10767; break; } else { __label__ = 14321; break; }
    case 10767: // $40963
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($40955, 163, 0, 0, ((STRING_TABLE.__str1245)|0), ((STRING_TABLE.__str1246)|0), $11220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10768; break; } else { __label__ = 14321; break; }
    case 10768: // $40964
      var $40965=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $40955);
      var $40966=__ZN11simple_listI16input_type_entryE6appendERS0_($40916, $40965);
      var $40967=$4689;
      var $40968=$2039;
      var $40969=$2040;
      var $40970=$2041;
      var $40971=$result_i1057;
      var $40972=$2042;
      var $40973=$2043;
      HEAP32[(($2039)>>2)]=408;
      HEAP32[(($2040)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2041)>>2)]=615;
      var $40974=HEAP32[(($2039)>>2)];
      var $40975=HEAP32[(($2040)>>2)];
      var $40976=HEAP32[(($2041)>>2)];
      var $40977=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40974, $40975, $40976) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10769; break; } else { __label__ = 10771; break; };
    case 10769: // $40978
      HEAP32[(($result_i1057)>>2)]=$40977;
      var $40979=HEAP32[(($result_i1057)>>2)];
      var $40980=(($40979)|0)==0;
      if ($40980) { __label__ = 10770; break; } else { __label__ = 10775; break; }
    case 10770: // $40981
      var $40982=___cxa_allocate_exception(4);
      var $40983=$40982;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40983);
      (function() { try { __THREW__ = false; return ___cxa_throw($40982, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10774; break; } else { __label__ = 10771; break; }
    case 10771: // $40984
      var $40985=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40986=$40985.f0;
      HEAP32[(($2042)>>2)]=$40986;
      var $40987=$40985.f1;
      HEAP32[(($2043)>>2)]=$40987;
      var $40988=HEAP32[(($2043)>>2)];
      var $40989=(($40988)|0) < 0;
      if ($40989) { __label__ = 10772; break; } else { __label__ = 10773; break; }
    case 10772: // $40990
      var $40991=HEAP32[(($2042)>>2)];
      ___cxa_call_unexpected($40991);
      throw "Reached an unreachable!"
    case 10773: // $40992
      var $40993=HEAP32[(($2042)>>2)];
      var $40994=HEAP32[(($2042)>>2)];
      var $40995=HEAP32[(($2043)>>2)];
      var $40996=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40994, tempValue);
      var $40997=($40996.f1 = $40995, $40996);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10774: // $40998
      throw "Reached an unreachable!"
    case 10775: // $_ZnwjPKci_exit1058
      var $40999=HEAP32[(($result_i1057)>>2)];
      var $41000=$2039;
      var $41001=$2040;
      var $41002=$2041;
      var $41003=$result_i1057;
      var $41004=$2042;
      var $41005=$2043;
      var $41006=$40999;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11229, 1, 0, 1, 0, 39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10776; break; } else { __label__ = 14326; break; }
    case 10776: // $41007
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11230, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10777; break; } else { __label__ = 14326; break; }
    case 10777: // $41008
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11231, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10778; break; } else { __label__ = 14326; break; }
    case 10778: // $41009
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11232, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10779; break; } else { __label__ = 14326; break; }
    case 10779: // $41010
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11233, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10780; break; } else { __label__ = 14326; break; }
    case 10780: // $41011
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11234, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10781; break; } else { __label__ = 14326; break; }
    case 10781: // $41012
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11235, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10782; break; } else { __label__ = 14326; break; }
    case 10782: // $41013
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11228, $11229, $11230, $11231, $11232, $11233, $11234, $11235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10783; break; } else { __label__ = 14326; break; }
    case 10783: // $41014
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41006, 164, 0, 0, ((STRING_TABLE.__str1247)|0), ((STRING_TABLE.__str1248)|0), $11228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10784; break; } else { __label__ = 14326; break; }
    case 10784: // $41015
      var $41016=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41006);
      var $41017=__ZN11simple_listI16input_type_entryE6appendERS0_($40967, $41016);
      var $41018=$4689;
      var $41019=$2034;
      var $41020=$2035;
      var $41021=$2036;
      var $41022=$result_i1059;
      var $41023=$2037;
      var $41024=$2038;
      HEAP32[(($2034)>>2)]=408;
      HEAP32[(($2035)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2036)>>2)]=616;
      var $41025=HEAP32[(($2034)>>2)];
      var $41026=HEAP32[(($2035)>>2)];
      var $41027=HEAP32[(($2036)>>2)];
      var $41028=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41025, $41026, $41027) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10785; break; } else { __label__ = 10787; break; };
    case 10785: // $41029
      HEAP32[(($result_i1059)>>2)]=$41028;
      var $41030=HEAP32[(($result_i1059)>>2)];
      var $41031=(($41030)|0)==0;
      if ($41031) { __label__ = 10786; break; } else { __label__ = 10791; break; }
    case 10786: // $41032
      var $41033=___cxa_allocate_exception(4);
      var $41034=$41033;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41034);
      (function() { try { __THREW__ = false; return ___cxa_throw($41033, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10790; break; } else { __label__ = 10787; break; }
    case 10787: // $41035
      var $41036=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41037=$41036.f0;
      HEAP32[(($2037)>>2)]=$41037;
      var $41038=$41036.f1;
      HEAP32[(($2038)>>2)]=$41038;
      var $41039=HEAP32[(($2038)>>2)];
      var $41040=(($41039)|0) < 0;
      if ($41040) { __label__ = 10788; break; } else { __label__ = 10789; break; }
    case 10788: // $41041
      var $41042=HEAP32[(($2037)>>2)];
      ___cxa_call_unexpected($41042);
      throw "Reached an unreachable!"
    case 10789: // $41043
      var $41044=HEAP32[(($2037)>>2)];
      var $41045=HEAP32[(($2037)>>2)];
      var $41046=HEAP32[(($2038)>>2)];
      var $41047=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41045, tempValue);
      var $41048=($41047.f1 = $41046, $41047);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10790: // $41049
      throw "Reached an unreachable!"
    case 10791: // $_ZnwjPKci_exit1060
      var $41050=HEAP32[(($result_i1059)>>2)];
      var $41051=$2034;
      var $41052=$2035;
      var $41053=$2036;
      var $41054=$result_i1059;
      var $41055=$2037;
      var $41056=$2038;
      var $41057=$41050;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11237, 1, 0, 1, 0, 40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10792; break; } else { __label__ = 14331; break; }
    case 10792: // $41058
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11238, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10793; break; } else { __label__ = 14331; break; }
    case 10793: // $41059
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11239, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10794; break; } else { __label__ = 14331; break; }
    case 10794: // $41060
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11240, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10795; break; } else { __label__ = 14331; break; }
    case 10795: // $41061
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11241, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10796; break; } else { __label__ = 14331; break; }
    case 10796: // $41062
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11242, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10797; break; } else { __label__ = 14331; break; }
    case 10797: // $41063
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11243, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10798; break; } else { __label__ = 14331; break; }
    case 10798: // $41064
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11236, $11237, $11238, $11239, $11240, $11241, $11242, $11243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10799; break; } else { __label__ = 14331; break; }
    case 10799: // $41065
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41057, 165, 0, 0, ((STRING_TABLE.__str1249)|0), ((STRING_TABLE.__str1250)|0), $11236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10800; break; } else { __label__ = 14331; break; }
    case 10800: // $41066
      var $41067=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41057);
      var $41068=__ZN11simple_listI16input_type_entryE6appendERS0_($41018, $41067);
      var $41069=$4689;
      var $41070=$2029;
      var $41071=$2030;
      var $41072=$2031;
      var $41073=$result_i1061;
      var $41074=$2032;
      var $41075=$2033;
      HEAP32[(($2029)>>2)]=408;
      HEAP32[(($2030)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2031)>>2)]=617;
      var $41076=HEAP32[(($2029)>>2)];
      var $41077=HEAP32[(($2030)>>2)];
      var $41078=HEAP32[(($2031)>>2)];
      var $41079=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41076, $41077, $41078) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10801; break; } else { __label__ = 10803; break; };
    case 10801: // $41080
      HEAP32[(($result_i1061)>>2)]=$41079;
      var $41081=HEAP32[(($result_i1061)>>2)];
      var $41082=(($41081)|0)==0;
      if ($41082) { __label__ = 10802; break; } else { __label__ = 10807; break; }
    case 10802: // $41083
      var $41084=___cxa_allocate_exception(4);
      var $41085=$41084;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41085);
      (function() { try { __THREW__ = false; return ___cxa_throw($41084, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10806; break; } else { __label__ = 10803; break; }
    case 10803: // $41086
      var $41087=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41088=$41087.f0;
      HEAP32[(($2032)>>2)]=$41088;
      var $41089=$41087.f1;
      HEAP32[(($2033)>>2)]=$41089;
      var $41090=HEAP32[(($2033)>>2)];
      var $41091=(($41090)|0) < 0;
      if ($41091) { __label__ = 10804; break; } else { __label__ = 10805; break; }
    case 10804: // $41092
      var $41093=HEAP32[(($2032)>>2)];
      ___cxa_call_unexpected($41093);
      throw "Reached an unreachable!"
    case 10805: // $41094
      var $41095=HEAP32[(($2032)>>2)];
      var $41096=HEAP32[(($2032)>>2)];
      var $41097=HEAP32[(($2033)>>2)];
      var $41098=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41096, tempValue);
      var $41099=($41098.f1 = $41097, $41098);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10806: // $41100
      throw "Reached an unreachable!"
    case 10807: // $_ZnwjPKci_exit1062
      var $41101=HEAP32[(($result_i1061)>>2)];
      var $41102=$2029;
      var $41103=$2030;
      var $41104=$2031;
      var $41105=$result_i1061;
      var $41106=$2032;
      var $41107=$2033;
      var $41108=$41101;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11245, 1, 0, 1, 0, 44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10808; break; } else { __label__ = 14336; break; }
    case 10808: // $41109
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11246, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10809; break; } else { __label__ = 14336; break; }
    case 10809: // $41110
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11247, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10810; break; } else { __label__ = 14336; break; }
    case 10810: // $41111
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11248, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10811; break; } else { __label__ = 14336; break; }
    case 10811: // $41112
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11249, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10812; break; } else { __label__ = 14336; break; }
    case 10812: // $41113
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11250, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10813; break; } else { __label__ = 14336; break; }
    case 10813: // $41114
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11251, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10814; break; } else { __label__ = 14336; break; }
    case 10814: // $41115
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11244, $11245, $11246, $11247, $11248, $11249, $11250, $11251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10815; break; } else { __label__ = 14336; break; }
    case 10815: // $41116
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41108, 166, 0, 0, ((STRING_TABLE.__str1251)|0), ((STRING_TABLE.__str1252)|0), $11244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10816; break; } else { __label__ = 14336; break; }
    case 10816: // $41117
      var $41118=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41108);
      var $41119=__ZN11simple_listI16input_type_entryE6appendERS0_($41069, $41118);
      var $41120=$4689;
      var $41121=$2024;
      var $41122=$2025;
      var $41123=$2026;
      var $41124=$result_i1063;
      var $41125=$2027;
      var $41126=$2028;
      HEAP32[(($2024)>>2)]=408;
      HEAP32[(($2025)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2026)>>2)]=618;
      var $41127=HEAP32[(($2024)>>2)];
      var $41128=HEAP32[(($2025)>>2)];
      var $41129=HEAP32[(($2026)>>2)];
      var $41130=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41127, $41128, $41129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10817; break; } else { __label__ = 10819; break; };
    case 10817: // $41131
      HEAP32[(($result_i1063)>>2)]=$41130;
      var $41132=HEAP32[(($result_i1063)>>2)];
      var $41133=(($41132)|0)==0;
      if ($41133) { __label__ = 10818; break; } else { __label__ = 10823; break; }
    case 10818: // $41134
      var $41135=___cxa_allocate_exception(4);
      var $41136=$41135;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41136);
      (function() { try { __THREW__ = false; return ___cxa_throw($41135, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10822; break; } else { __label__ = 10819; break; }
    case 10819: // $41137
      var $41138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41139=$41138.f0;
      HEAP32[(($2027)>>2)]=$41139;
      var $41140=$41138.f1;
      HEAP32[(($2028)>>2)]=$41140;
      var $41141=HEAP32[(($2028)>>2)];
      var $41142=(($41141)|0) < 0;
      if ($41142) { __label__ = 10820; break; } else { __label__ = 10821; break; }
    case 10820: // $41143
      var $41144=HEAP32[(($2027)>>2)];
      ___cxa_call_unexpected($41144);
      throw "Reached an unreachable!"
    case 10821: // $41145
      var $41146=HEAP32[(($2027)>>2)];
      var $41147=HEAP32[(($2027)>>2)];
      var $41148=HEAP32[(($2028)>>2)];
      var $41149=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41147, tempValue);
      var $41150=($41149.f1 = $41148, $41149);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10822: // $41151
      throw "Reached an unreachable!"
    case 10823: // $_ZnwjPKci_exit1064
      var $41152=HEAP32[(($result_i1063)>>2)];
      var $41153=$2024;
      var $41154=$2025;
      var $41155=$2026;
      var $41156=$result_i1063;
      var $41157=$2027;
      var $41158=$2028;
      var $41159=$41152;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11253, 1, 0, 1, 0, 45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10824; break; } else { __label__ = 14341; break; }
    case 10824: // $41160
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11254, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10825; break; } else { __label__ = 14341; break; }
    case 10825: // $41161
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11255, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10826; break; } else { __label__ = 14341; break; }
    case 10826: // $41162
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11256, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10827; break; } else { __label__ = 14341; break; }
    case 10827: // $41163
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11257, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10828; break; } else { __label__ = 14341; break; }
    case 10828: // $41164
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11258, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10829; break; } else { __label__ = 14341; break; }
    case 10829: // $41165
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11259, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10830; break; } else { __label__ = 14341; break; }
    case 10830: // $41166
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11252, $11253, $11254, $11255, $11256, $11257, $11258, $11259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10831; break; } else { __label__ = 14341; break; }
    case 10831: // $41167
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41159, 167, 0, 0, ((STRING_TABLE.__str1253)|0), ((STRING_TABLE.__str1254)|0), $11252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10832; break; } else { __label__ = 14341; break; }
    case 10832: // $41168
      var $41169=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41159);
      var $41170=__ZN11simple_listI16input_type_entryE6appendERS0_($41120, $41169);
      var $41171=$4689;
      var $41172=$2019;
      var $41173=$2020;
      var $41174=$2021;
      var $41175=$result_i1065;
      var $41176=$2022;
      var $41177=$2023;
      HEAP32[(($2019)>>2)]=408;
      HEAP32[(($2020)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2021)>>2)]=619;
      var $41178=HEAP32[(($2019)>>2)];
      var $41179=HEAP32[(($2020)>>2)];
      var $41180=HEAP32[(($2021)>>2)];
      var $41181=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41178, $41179, $41180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10833; break; } else { __label__ = 10835; break; };
    case 10833: // $41182
      HEAP32[(($result_i1065)>>2)]=$41181;
      var $41183=HEAP32[(($result_i1065)>>2)];
      var $41184=(($41183)|0)==0;
      if ($41184) { __label__ = 10834; break; } else { __label__ = 10839; break; }
    case 10834: // $41185
      var $41186=___cxa_allocate_exception(4);
      var $41187=$41186;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41187);
      (function() { try { __THREW__ = false; return ___cxa_throw($41186, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10838; break; } else { __label__ = 10835; break; }
    case 10835: // $41188
      var $41189=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41190=$41189.f0;
      HEAP32[(($2022)>>2)]=$41190;
      var $41191=$41189.f1;
      HEAP32[(($2023)>>2)]=$41191;
      var $41192=HEAP32[(($2023)>>2)];
      var $41193=(($41192)|0) < 0;
      if ($41193) { __label__ = 10836; break; } else { __label__ = 10837; break; }
    case 10836: // $41194
      var $41195=HEAP32[(($2022)>>2)];
      ___cxa_call_unexpected($41195);
      throw "Reached an unreachable!"
    case 10837: // $41196
      var $41197=HEAP32[(($2022)>>2)];
      var $41198=HEAP32[(($2022)>>2)];
      var $41199=HEAP32[(($2023)>>2)];
      var $41200=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41198, tempValue);
      var $41201=($41200.f1 = $41199, $41200);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10838: // $41202
      throw "Reached an unreachable!"
    case 10839: // $_ZnwjPKci_exit1066
      var $41203=HEAP32[(($result_i1065)>>2)];
      var $41204=$2019;
      var $41205=$2020;
      var $41206=$2021;
      var $41207=$result_i1065;
      var $41208=$2022;
      var $41209=$2023;
      var $41210=$41203;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11261, 1, 0, 1, 0, 46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10840; break; } else { __label__ = 14346; break; }
    case 10840: // $41211
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11262, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10841; break; } else { __label__ = 14346; break; }
    case 10841: // $41212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11263, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10842; break; } else { __label__ = 14346; break; }
    case 10842: // $41213
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11264, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10843; break; } else { __label__ = 14346; break; }
    case 10843: // $41214
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11265, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10844; break; } else { __label__ = 14346; break; }
    case 10844: // $41215
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11266, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10845; break; } else { __label__ = 14346; break; }
    case 10845: // $41216
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11267, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10846; break; } else { __label__ = 14346; break; }
    case 10846: // $41217
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11260, $11261, $11262, $11263, $11264, $11265, $11266, $11267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10847; break; } else { __label__ = 14346; break; }
    case 10847: // $41218
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41210, 168, 0, 0, ((STRING_TABLE.__str1255)|0), ((STRING_TABLE.__str1256)|0), $11260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10848; break; } else { __label__ = 14346; break; }
    case 10848: // $41219
      var $41220=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41210);
      var $41221=__ZN11simple_listI16input_type_entryE6appendERS0_($41171, $41220);
      var $41222=$4689;
      var $41223=$2014;
      var $41224=$2015;
      var $41225=$2016;
      var $41226=$result_i1067;
      var $41227=$2017;
      var $41228=$2018;
      HEAP32[(($2014)>>2)]=408;
      HEAP32[(($2015)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2016)>>2)]=620;
      var $41229=HEAP32[(($2014)>>2)];
      var $41230=HEAP32[(($2015)>>2)];
      var $41231=HEAP32[(($2016)>>2)];
      var $41232=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41229, $41230, $41231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10849; break; } else { __label__ = 10851; break; };
    case 10849: // $41233
      HEAP32[(($result_i1067)>>2)]=$41232;
      var $41234=HEAP32[(($result_i1067)>>2)];
      var $41235=(($41234)|0)==0;
      if ($41235) { __label__ = 10850; break; } else { __label__ = 10855; break; }
    case 10850: // $41236
      var $41237=___cxa_allocate_exception(4);
      var $41238=$41237;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41238);
      (function() { try { __THREW__ = false; return ___cxa_throw($41237, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10854; break; } else { __label__ = 10851; break; }
    case 10851: // $41239
      var $41240=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41241=$41240.f0;
      HEAP32[(($2017)>>2)]=$41241;
      var $41242=$41240.f1;
      HEAP32[(($2018)>>2)]=$41242;
      var $41243=HEAP32[(($2018)>>2)];
      var $41244=(($41243)|0) < 0;
      if ($41244) { __label__ = 10852; break; } else { __label__ = 10853; break; }
    case 10852: // $41245
      var $41246=HEAP32[(($2017)>>2)];
      ___cxa_call_unexpected($41246);
      throw "Reached an unreachable!"
    case 10853: // $41247
      var $41248=HEAP32[(($2017)>>2)];
      var $41249=HEAP32[(($2017)>>2)];
      var $41250=HEAP32[(($2018)>>2)];
      var $41251=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41249, tempValue);
      var $41252=($41251.f1 = $41250, $41251);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10854: // $41253
      throw "Reached an unreachable!"
    case 10855: // $_ZnwjPKci_exit1068
      var $41254=HEAP32[(($result_i1067)>>2)];
      var $41255=$2014;
      var $41256=$2015;
      var $41257=$2016;
      var $41258=$result_i1067;
      var $41259=$2017;
      var $41260=$2018;
      var $41261=$41254;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11269, 1, 0, 1, 0, 69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10856; break; } else { __label__ = 14351; break; }
    case 10856: // $41262
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11270, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10857; break; } else { __label__ = 14351; break; }
    case 10857: // $41263
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11271, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10858; break; } else { __label__ = 14351; break; }
    case 10858: // $41264
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11272, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10859; break; } else { __label__ = 14351; break; }
    case 10859: // $41265
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11273, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10860; break; } else { __label__ = 14351; break; }
    case 10860: // $41266
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11274, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10861; break; } else { __label__ = 14351; break; }
    case 10861: // $41267
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11275, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10862; break; } else { __label__ = 14351; break; }
    case 10862: // $41268
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11268, $11269, $11270, $11271, $11272, $11273, $11274, $11275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10863; break; } else { __label__ = 14351; break; }
    case 10863: // $41269
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41261, 169, 0, 0, ((STRING_TABLE.__str1257)|0), ((STRING_TABLE.__str1258)|0), $11268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10864; break; } else { __label__ = 14351; break; }
    case 10864: // $41270
      var $41271=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41261);
      var $41272=__ZN11simple_listI16input_type_entryE6appendERS0_($41222, $41271);
      var $41273=$4689;
      var $41274=$2009;
      var $41275=$2010;
      var $41276=$2011;
      var $41277=$result_i1069;
      var $41278=$2012;
      var $41279=$2013;
      HEAP32[(($2009)>>2)]=408;
      HEAP32[(($2010)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2011)>>2)]=621;
      var $41280=HEAP32[(($2009)>>2)];
      var $41281=HEAP32[(($2010)>>2)];
      var $41282=HEAP32[(($2011)>>2)];
      var $41283=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41280, $41281, $41282) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10865; break; } else { __label__ = 10867; break; };
    case 10865: // $41284
      HEAP32[(($result_i1069)>>2)]=$41283;
      var $41285=HEAP32[(($result_i1069)>>2)];
      var $41286=(($41285)|0)==0;
      if ($41286) { __label__ = 10866; break; } else { __label__ = 10871; break; }
    case 10866: // $41287
      var $41288=___cxa_allocate_exception(4);
      var $41289=$41288;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41289);
      (function() { try { __THREW__ = false; return ___cxa_throw($41288, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10870; break; } else { __label__ = 10867; break; }
    case 10867: // $41290
      var $41291=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41292=$41291.f0;
      HEAP32[(($2012)>>2)]=$41292;
      var $41293=$41291.f1;
      HEAP32[(($2013)>>2)]=$41293;
      var $41294=HEAP32[(($2013)>>2)];
      var $41295=(($41294)|0) < 0;
      if ($41295) { __label__ = 10868; break; } else { __label__ = 10869; break; }
    case 10868: // $41296
      var $41297=HEAP32[(($2012)>>2)];
      ___cxa_call_unexpected($41297);
      throw "Reached an unreachable!"
    case 10869: // $41298
      var $41299=HEAP32[(($2012)>>2)];
      var $41300=HEAP32[(($2012)>>2)];
      var $41301=HEAP32[(($2013)>>2)];
      var $41302=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41300, tempValue);
      var $41303=($41302.f1 = $41301, $41302);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10870: // $41304
      throw "Reached an unreachable!"
    case 10871: // $_ZnwjPKci_exit1070
      var $41305=HEAP32[(($result_i1069)>>2)];
      var $41306=$2009;
      var $41307=$2010;
      var $41308=$2011;
      var $41309=$result_i1069;
      var $41310=$2012;
      var $41311=$2013;
      var $41312=$41305;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11277, 1, 0, 1, 0, 47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10872; break; } else { __label__ = 14356; break; }
    case 10872: // $41313
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11278, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10873; break; } else { __label__ = 14356; break; }
    case 10873: // $41314
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11279, 1, 0, 1, 0, 99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10874; break; } else { __label__ = 14356; break; }
    case 10874: // $41315
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11280, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10875; break; } else { __label__ = 14356; break; }
    case 10875: // $41316
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11281, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10876; break; } else { __label__ = 14356; break; }
    case 10876: // $41317
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11282, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10877; break; } else { __label__ = 14356; break; }
    case 10877: // $41318
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11283, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10878; break; } else { __label__ = 14356; break; }
    case 10878: // $41319
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11276, $11277, $11278, $11279, $11280, $11281, $11282, $11283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10879; break; } else { __label__ = 14356; break; }
    case 10879: // $41320
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41312, 170, 0, 0, ((STRING_TABLE.__str1259)|0), ((STRING_TABLE.__str1260)|0), $11276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10880; break; } else { __label__ = 14356; break; }
    case 10880: // $41321
      var $41322=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41312);
      var $41323=__ZN11simple_listI16input_type_entryE6appendERS0_($41273, $41322);
      var $41324=$4689;
      var $41325=$2004;
      var $41326=$2005;
      var $41327=$2006;
      var $41328=$result_i1071;
      var $41329=$2007;
      var $41330=$2008;
      HEAP32[(($2004)>>2)]=408;
      HEAP32[(($2005)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2006)>>2)]=622;
      var $41331=HEAP32[(($2004)>>2)];
      var $41332=HEAP32[(($2005)>>2)];
      var $41333=HEAP32[(($2006)>>2)];
      var $41334=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41331, $41332, $41333) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10881; break; } else { __label__ = 10883; break; };
    case 10881: // $41335
      HEAP32[(($result_i1071)>>2)]=$41334;
      var $41336=HEAP32[(($result_i1071)>>2)];
      var $41337=(($41336)|0)==0;
      if ($41337) { __label__ = 10882; break; } else { __label__ = 10887; break; }
    case 10882: // $41338
      var $41339=___cxa_allocate_exception(4);
      var $41340=$41339;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41340);
      (function() { try { __THREW__ = false; return ___cxa_throw($41339, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10886; break; } else { __label__ = 10883; break; }
    case 10883: // $41341
      var $41342=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41343=$41342.f0;
      HEAP32[(($2007)>>2)]=$41343;
      var $41344=$41342.f1;
      HEAP32[(($2008)>>2)]=$41344;
      var $41345=HEAP32[(($2008)>>2)];
      var $41346=(($41345)|0) < 0;
      if ($41346) { __label__ = 10884; break; } else { __label__ = 10885; break; }
    case 10884: // $41347
      var $41348=HEAP32[(($2007)>>2)];
      ___cxa_call_unexpected($41348);
      throw "Reached an unreachable!"
    case 10885: // $41349
      var $41350=HEAP32[(($2007)>>2)];
      var $41351=HEAP32[(($2007)>>2)];
      var $41352=HEAP32[(($2008)>>2)];
      var $41353=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41351, tempValue);
      var $41354=($41353.f1 = $41352, $41353);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10886: // $41355
      throw "Reached an unreachable!"
    case 10887: // $_ZnwjPKci_exit1072
      var $41356=HEAP32[(($result_i1071)>>2)];
      var $41357=$2004;
      var $41358=$2005;
      var $41359=$2006;
      var $41360=$result_i1071;
      var $41361=$2007;
      var $41362=$2008;
      var $41363=$41356;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11285, 1, 0, 1, 0, 48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10888; break; } else { __label__ = 14361; break; }
    case 10888: // $41364
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11286, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10889; break; } else { __label__ = 14361; break; }
    case 10889: // $41365
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11287, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10890; break; } else { __label__ = 14361; break; }
    case 10890: // $41366
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11288, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10891; break; } else { __label__ = 14361; break; }
    case 10891: // $41367
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11289, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10892; break; } else { __label__ = 14361; break; }
    case 10892: // $41368
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11290, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10893; break; } else { __label__ = 14361; break; }
    case 10893: // $41369
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11291, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10894; break; } else { __label__ = 14361; break; }
    case 10894: // $41370
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11284, $11285, $11286, $11287, $11288, $11289, $11290, $11291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10895; break; } else { __label__ = 14361; break; }
    case 10895: // $41371
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41363, 171, 0, 0, ((STRING_TABLE.__str1261)|0), ((STRING_TABLE.__str1262)|0), $11284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10896; break; } else { __label__ = 14361; break; }
    case 10896: // $41372
      var $41373=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41363);
      var $41374=__ZN11simple_listI16input_type_entryE6appendERS0_($41324, $41373);
      var $41375=$4689;
      var $41376=$1999;
      var $41377=$2000;
      var $41378=$2001;
      var $41379=$result_i1073;
      var $41380=$2002;
      var $41381=$2003;
      HEAP32[(($1999)>>2)]=408;
      HEAP32[(($2000)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($2001)>>2)]=623;
      var $41382=HEAP32[(($1999)>>2)];
      var $41383=HEAP32[(($2000)>>2)];
      var $41384=HEAP32[(($2001)>>2)];
      var $41385=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41382, $41383, $41384) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10897; break; } else { __label__ = 10899; break; };
    case 10897: // $41386
      HEAP32[(($result_i1073)>>2)]=$41385;
      var $41387=HEAP32[(($result_i1073)>>2)];
      var $41388=(($41387)|0)==0;
      if ($41388) { __label__ = 10898; break; } else { __label__ = 10903; break; }
    case 10898: // $41389
      var $41390=___cxa_allocate_exception(4);
      var $41391=$41390;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41391);
      (function() { try { __THREW__ = false; return ___cxa_throw($41390, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10902; break; } else { __label__ = 10899; break; }
    case 10899: // $41392
      var $41393=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41394=$41393.f0;
      HEAP32[(($2002)>>2)]=$41394;
      var $41395=$41393.f1;
      HEAP32[(($2003)>>2)]=$41395;
      var $41396=HEAP32[(($2003)>>2)];
      var $41397=(($41396)|0) < 0;
      if ($41397) { __label__ = 10900; break; } else { __label__ = 10901; break; }
    case 10900: // $41398
      var $41399=HEAP32[(($2002)>>2)];
      ___cxa_call_unexpected($41399);
      throw "Reached an unreachable!"
    case 10901: // $41400
      var $41401=HEAP32[(($2002)>>2)];
      var $41402=HEAP32[(($2002)>>2)];
      var $41403=HEAP32[(($2003)>>2)];
      var $41404=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41402, tempValue);
      var $41405=($41404.f1 = $41403, $41404);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10902: // $41406
      throw "Reached an unreachable!"
    case 10903: // $_ZnwjPKci_exit1074
      var $41407=HEAP32[(($result_i1073)>>2)];
      var $41408=$1999;
      var $41409=$2000;
      var $41410=$2001;
      var $41411=$result_i1073;
      var $41412=$2002;
      var $41413=$2003;
      var $41414=$41407;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11293, 1, 0, 1, 0, 48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10904; break; } else { __label__ = 14366; break; }
    case 10904: // $41415
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11294, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10905; break; } else { __label__ = 14366; break; }
    case 10905: // $41416
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11295, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10906; break; } else { __label__ = 14366; break; }
    case 10906: // $41417
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11296, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10907; break; } else { __label__ = 14366; break; }
    case 10907: // $41418
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11297, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10908; break; } else { __label__ = 14366; break; }
    case 10908: // $41419
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11298, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10909; break; } else { __label__ = 14366; break; }
    case 10909: // $41420
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11299, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10910; break; } else { __label__ = 14366; break; }
    case 10910: // $41421
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11292, $11293, $11294, $11295, $11296, $11297, $11298, $11299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10911; break; } else { __label__ = 14366; break; }
    case 10911: // $41422
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41414, 172, 0, 0, ((STRING_TABLE.__str1263)|0), ((STRING_TABLE.__str1264)|0), $11292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10912; break; } else { __label__ = 14366; break; }
    case 10912: // $41423
      var $41424=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41414);
      var $41425=__ZN11simple_listI16input_type_entryE6appendERS0_($41375, $41424);
      var $41426=$4689;
      var $41427=$1994;
      var $41428=$1995;
      var $41429=$1996;
      var $41430=$result_i1075;
      var $41431=$1997;
      var $41432=$1998;
      HEAP32[(($1994)>>2)]=408;
      HEAP32[(($1995)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1996)>>2)]=624;
      var $41433=HEAP32[(($1994)>>2)];
      var $41434=HEAP32[(($1995)>>2)];
      var $41435=HEAP32[(($1996)>>2)];
      var $41436=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41433, $41434, $41435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10913; break; } else { __label__ = 10915; break; };
    case 10913: // $41437
      HEAP32[(($result_i1075)>>2)]=$41436;
      var $41438=HEAP32[(($result_i1075)>>2)];
      var $41439=(($41438)|0)==0;
      if ($41439) { __label__ = 10914; break; } else { __label__ = 10919; break; }
    case 10914: // $41440
      var $41441=___cxa_allocate_exception(4);
      var $41442=$41441;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41442);
      (function() { try { __THREW__ = false; return ___cxa_throw($41441, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10918; break; } else { __label__ = 10915; break; }
    case 10915: // $41443
      var $41444=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41445=$41444.f0;
      HEAP32[(($1997)>>2)]=$41445;
      var $41446=$41444.f1;
      HEAP32[(($1998)>>2)]=$41446;
      var $41447=HEAP32[(($1998)>>2)];
      var $41448=(($41447)|0) < 0;
      if ($41448) { __label__ = 10916; break; } else { __label__ = 10917; break; }
    case 10916: // $41449
      var $41450=HEAP32[(($1997)>>2)];
      ___cxa_call_unexpected($41450);
      throw "Reached an unreachable!"
    case 10917: // $41451
      var $41452=HEAP32[(($1997)>>2)];
      var $41453=HEAP32[(($1997)>>2)];
      var $41454=HEAP32[(($1998)>>2)];
      var $41455=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41453, tempValue);
      var $41456=($41455.f1 = $41454, $41455);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10918: // $41457
      throw "Reached an unreachable!"
    case 10919: // $_ZnwjPKci_exit1076
      var $41458=HEAP32[(($result_i1075)>>2)];
      var $41459=$1994;
      var $41460=$1995;
      var $41461=$1996;
      var $41462=$result_i1075;
      var $41463=$1997;
      var $41464=$1998;
      var $41465=$41458;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11301, 1, 0, 1, 0, 42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10920; break; } else { __label__ = 14371; break; }
    case 10920: // $41466
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11302, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10921; break; } else { __label__ = 14371; break; }
    case 10921: // $41467
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11303, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10922; break; } else { __label__ = 14371; break; }
    case 10922: // $41468
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11304, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10923; break; } else { __label__ = 14371; break; }
    case 10923: // $41469
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11305, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10924; break; } else { __label__ = 14371; break; }
    case 10924: // $41470
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11306, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10925; break; } else { __label__ = 14371; break; }
    case 10925: // $41471
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11307, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10926; break; } else { __label__ = 14371; break; }
    case 10926: // $41472
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11300, $11301, $11302, $11303, $11304, $11305, $11306, $11307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10927; break; } else { __label__ = 14371; break; }
    case 10927: // $41473
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41465, 173, 0, 0, ((STRING_TABLE.__str1265)|0), ((STRING_TABLE.__str1266)|0), $11300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10928; break; } else { __label__ = 14371; break; }
    case 10928: // $41474
      var $41475=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41465);
      var $41476=__ZN11simple_listI16input_type_entryE6appendERS0_($41426, $41475);
      var $41477=$4689;
      var $41478=$1989;
      var $41479=$1990;
      var $41480=$1991;
      var $41481=$result_i1077;
      var $41482=$1992;
      var $41483=$1993;
      HEAP32[(($1989)>>2)]=408;
      HEAP32[(($1990)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1991)>>2)]=625;
      var $41484=HEAP32[(($1989)>>2)];
      var $41485=HEAP32[(($1990)>>2)];
      var $41486=HEAP32[(($1991)>>2)];
      var $41487=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41484, $41485, $41486) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10929; break; } else { __label__ = 10931; break; };
    case 10929: // $41488
      HEAP32[(($result_i1077)>>2)]=$41487;
      var $41489=HEAP32[(($result_i1077)>>2)];
      var $41490=(($41489)|0)==0;
      if ($41490) { __label__ = 10930; break; } else { __label__ = 10935; break; }
    case 10930: // $41491
      var $41492=___cxa_allocate_exception(4);
      var $41493=$41492;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41493);
      (function() { try { __THREW__ = false; return ___cxa_throw($41492, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10934; break; } else { __label__ = 10931; break; }
    case 10931: // $41494
      var $41495=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41496=$41495.f0;
      HEAP32[(($1992)>>2)]=$41496;
      var $41497=$41495.f1;
      HEAP32[(($1993)>>2)]=$41497;
      var $41498=HEAP32[(($1993)>>2)];
      var $41499=(($41498)|0) < 0;
      if ($41499) { __label__ = 10932; break; } else { __label__ = 10933; break; }
    case 10932: // $41500
      var $41501=HEAP32[(($1992)>>2)];
      ___cxa_call_unexpected($41501);
      throw "Reached an unreachable!"
    case 10933: // $41502
      var $41503=HEAP32[(($1992)>>2)];
      var $41504=HEAP32[(($1992)>>2)];
      var $41505=HEAP32[(($1993)>>2)];
      var $41506=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41504, tempValue);
      var $41507=($41506.f1 = $41505, $41506);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10934: // $41508
      throw "Reached an unreachable!"
    case 10935: // $_ZnwjPKci_exit1078
      var $41509=HEAP32[(($result_i1077)>>2)];
      var $41510=$1989;
      var $41511=$1990;
      var $41512=$1991;
      var $41513=$result_i1077;
      var $41514=$1992;
      var $41515=$1993;
      var $41516=$41509;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11309, 1, 0, 1, 0, 77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10936; break; } else { __label__ = 14376; break; }
    case 10936: // $41517
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11310, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10937; break; } else { __label__ = 14376; break; }
    case 10937: // $41518
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11311, 4, 0, 1, 5, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10938; break; } else { __label__ = 14376; break; }
    case 10938: // $41519
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11312, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10939; break; } else { __label__ = 14376; break; }
    case 10939: // $41520
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11313, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10940; break; } else { __label__ = 14376; break; }
    case 10940: // $41521
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11314, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10941; break; } else { __label__ = 14376; break; }
    case 10941: // $41522
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11315, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10942; break; } else { __label__ = 14376; break; }
    case 10942: // $41523
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11308, $11309, $11310, $11311, $11312, $11313, $11314, $11315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10943; break; } else { __label__ = 14376; break; }
    case 10943: // $41524
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41516, 174, 0, 0, ((STRING_TABLE.__str1267)|0), ((STRING_TABLE.__str1268)|0), $11308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10944; break; } else { __label__ = 14376; break; }
    case 10944: // $41525
      var $41526=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41516);
      var $41527=__ZN11simple_listI16input_type_entryE6appendERS0_($41477, $41526);
      var $41528=$4689;
      var $41529=$1984;
      var $41530=$1985;
      var $41531=$1986;
      var $41532=$result_i1079;
      var $41533=$1987;
      var $41534=$1988;
      HEAP32[(($1984)>>2)]=408;
      HEAP32[(($1985)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1986)>>2)]=626;
      var $41535=HEAP32[(($1984)>>2)];
      var $41536=HEAP32[(($1985)>>2)];
      var $41537=HEAP32[(($1986)>>2)];
      var $41538=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41535, $41536, $41537) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10945; break; } else { __label__ = 10947; break; };
    case 10945: // $41539
      HEAP32[(($result_i1079)>>2)]=$41538;
      var $41540=HEAP32[(($result_i1079)>>2)];
      var $41541=(($41540)|0)==0;
      if ($41541) { __label__ = 10946; break; } else { __label__ = 10951; break; }
    case 10946: // $41542
      var $41543=___cxa_allocate_exception(4);
      var $41544=$41543;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41544);
      (function() { try { __THREW__ = false; return ___cxa_throw($41543, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10950; break; } else { __label__ = 10947; break; }
    case 10947: // $41545
      var $41546=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41547=$41546.f0;
      HEAP32[(($1987)>>2)]=$41547;
      var $41548=$41546.f1;
      HEAP32[(($1988)>>2)]=$41548;
      var $41549=HEAP32[(($1988)>>2)];
      var $41550=(($41549)|0) < 0;
      if ($41550) { __label__ = 10948; break; } else { __label__ = 10949; break; }
    case 10948: // $41551
      var $41552=HEAP32[(($1987)>>2)];
      ___cxa_call_unexpected($41552);
      throw "Reached an unreachable!"
    case 10949: // $41553
      var $41554=HEAP32[(($1987)>>2)];
      var $41555=HEAP32[(($1987)>>2)];
      var $41556=HEAP32[(($1988)>>2)];
      var $41557=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41555, tempValue);
      var $41558=($41557.f1 = $41556, $41557);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10950: // $41559
      throw "Reached an unreachable!"
    case 10951: // $_ZnwjPKci_exit1080
      var $41560=HEAP32[(($result_i1079)>>2)];
      var $41561=$1984;
      var $41562=$1985;
      var $41563=$1986;
      var $41564=$result_i1079;
      var $41565=$1987;
      var $41566=$1988;
      var $41567=$41560;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11317, 1, 0, 1, 0, 78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10952; break; } else { __label__ = 14381; break; }
    case 10952: // $41568
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11318, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10953; break; } else { __label__ = 14381; break; }
    case 10953: // $41569
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11319, 4, 0, 1, 6, 111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10954; break; } else { __label__ = 14381; break; }
    case 10954: // $41570
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11320, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10955; break; } else { __label__ = 14381; break; }
    case 10955: // $41571
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11321, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10956; break; } else { __label__ = 14381; break; }
    case 10956: // $41572
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11322, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10957; break; } else { __label__ = 14381; break; }
    case 10957: // $41573
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11323, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10958; break; } else { __label__ = 14381; break; }
    case 10958: // $41574
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11316, $11317, $11318, $11319, $11320, $11321, $11322, $11323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10959; break; } else { __label__ = 14381; break; }
    case 10959: // $41575
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41567, 175, 0, 0, ((STRING_TABLE.__str1269)|0), ((STRING_TABLE.__str1270)|0), $11316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10960; break; } else { __label__ = 14381; break; }
    case 10960: // $41576
      var $41577=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41567);
      var $41578=__ZN11simple_listI16input_type_entryE6appendERS0_($41528, $41577);
      var $41579=$4689;
      var $41580=$1979;
      var $41581=$1980;
      var $41582=$1981;
      var $41583=$result_i1081;
      var $41584=$1982;
      var $41585=$1983;
      HEAP32[(($1979)>>2)]=408;
      HEAP32[(($1980)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1981)>>2)]=627;
      var $41586=HEAP32[(($1979)>>2)];
      var $41587=HEAP32[(($1980)>>2)];
      var $41588=HEAP32[(($1981)>>2)];
      var $41589=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41586, $41587, $41588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10961; break; } else { __label__ = 10963; break; };
    case 10961: // $41590
      HEAP32[(($result_i1081)>>2)]=$41589;
      var $41591=HEAP32[(($result_i1081)>>2)];
      var $41592=(($41591)|0)==0;
      if ($41592) { __label__ = 10962; break; } else { __label__ = 10967; break; }
    case 10962: // $41593
      var $41594=___cxa_allocate_exception(4);
      var $41595=$41594;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41595);
      (function() { try { __THREW__ = false; return ___cxa_throw($41594, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10966; break; } else { __label__ = 10963; break; }
    case 10963: // $41596
      var $41597=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41598=$41597.f0;
      HEAP32[(($1982)>>2)]=$41598;
      var $41599=$41597.f1;
      HEAP32[(($1983)>>2)]=$41599;
      var $41600=HEAP32[(($1983)>>2)];
      var $41601=(($41600)|0) < 0;
      if ($41601) { __label__ = 10964; break; } else { __label__ = 10965; break; }
    case 10964: // $41602
      var $41603=HEAP32[(($1982)>>2)];
      ___cxa_call_unexpected($41603);
      throw "Reached an unreachable!"
    case 10965: // $41604
      var $41605=HEAP32[(($1982)>>2)];
      var $41606=HEAP32[(($1982)>>2)];
      var $41607=HEAP32[(($1983)>>2)];
      var $41608=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41606, tempValue);
      var $41609=($41608.f1 = $41607, $41608);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10966: // $41610
      throw "Reached an unreachable!"
    case 10967: // $_ZnwjPKci_exit1082
      var $41611=HEAP32[(($result_i1081)>>2)];
      var $41612=$1979;
      var $41613=$1980;
      var $41614=$1981;
      var $41615=$result_i1081;
      var $41616=$1982;
      var $41617=$1983;
      var $41618=$41611;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11325, 1, 0, 1, 0, 75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10968; break; } else { __label__ = 14386; break; }
    case 10968: // $41619
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11326, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10969; break; } else { __label__ = 14386; break; }
    case 10969: // $41620
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11327, 4, 0, 1, 3, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10970; break; } else { __label__ = 14386; break; }
    case 10970: // $41621
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11328, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10971; break; } else { __label__ = 14386; break; }
    case 10971: // $41622
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11329, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10972; break; } else { __label__ = 14386; break; }
    case 10972: // $41623
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11330, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10973; break; } else { __label__ = 14386; break; }
    case 10973: // $41624
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11331, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10974; break; } else { __label__ = 14386; break; }
    case 10974: // $41625
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11324, $11325, $11326, $11327, $11328, $11329, $11330, $11331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10975; break; } else { __label__ = 14386; break; }
    case 10975: // $41626
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41618, 176, 0, 0, ((STRING_TABLE.__str1271)|0), ((STRING_TABLE.__str1272)|0), $11324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10976; break; } else { __label__ = 14386; break; }
    case 10976: // $41627
      var $41628=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41618);
      var $41629=__ZN11simple_listI16input_type_entryE6appendERS0_($41579, $41628);
      var $41630=$4689;
      var $41631=$1974;
      var $41632=$1975;
      var $41633=$1976;
      var $41634=$result_i1083;
      var $41635=$1977;
      var $41636=$1978;
      HEAP32[(($1974)>>2)]=408;
      HEAP32[(($1975)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1976)>>2)]=628;
      var $41637=HEAP32[(($1974)>>2)];
      var $41638=HEAP32[(($1975)>>2)];
      var $41639=HEAP32[(($1976)>>2)];
      var $41640=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41637, $41638, $41639) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10977; break; } else { __label__ = 10979; break; };
    case 10977: // $41641
      HEAP32[(($result_i1083)>>2)]=$41640;
      var $41642=HEAP32[(($result_i1083)>>2)];
      var $41643=(($41642)|0)==0;
      if ($41643) { __label__ = 10978; break; } else { __label__ = 10983; break; }
    case 10978: // $41644
      var $41645=___cxa_allocate_exception(4);
      var $41646=$41645;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41646);
      (function() { try { __THREW__ = false; return ___cxa_throw($41645, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10982; break; } else { __label__ = 10979; break; }
    case 10979: // $41647
      var $41648=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41649=$41648.f0;
      HEAP32[(($1977)>>2)]=$41649;
      var $41650=$41648.f1;
      HEAP32[(($1978)>>2)]=$41650;
      var $41651=HEAP32[(($1978)>>2)];
      var $41652=(($41651)|0) < 0;
      if ($41652) { __label__ = 10980; break; } else { __label__ = 10981; break; }
    case 10980: // $41653
      var $41654=HEAP32[(($1977)>>2)];
      ___cxa_call_unexpected($41654);
      throw "Reached an unreachable!"
    case 10981: // $41655
      var $41656=HEAP32[(($1977)>>2)];
      var $41657=HEAP32[(($1977)>>2)];
      var $41658=HEAP32[(($1978)>>2)];
      var $41659=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41657, tempValue);
      var $41660=($41659.f1 = $41658, $41659);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10982: // $41661
      throw "Reached an unreachable!"
    case 10983: // $_ZnwjPKci_exit1084
      var $41662=HEAP32[(($result_i1083)>>2)];
      var $41663=$1974;
      var $41664=$1975;
      var $41665=$1976;
      var $41666=$result_i1083;
      var $41667=$1977;
      var $41668=$1978;
      var $41669=$41662;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11333, 1, 0, 1, 0, 76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10984; break; } else { __label__ = 14391; break; }
    case 10984: // $41670
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11334, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10985; break; } else { __label__ = 14391; break; }
    case 10985: // $41671
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11335, 4, 0, 1, 4, 110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10986; break; } else { __label__ = 14391; break; }
    case 10986: // $41672
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11336, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10987; break; } else { __label__ = 14391; break; }
    case 10987: // $41673
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11337, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10988; break; } else { __label__ = 14391; break; }
    case 10988: // $41674
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11338, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10989; break; } else { __label__ = 14391; break; }
    case 10989: // $41675
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11339, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10990; break; } else { __label__ = 14391; break; }
    case 10990: // $41676
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11332, $11333, $11334, $11335, $11336, $11337, $11338, $11339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10991; break; } else { __label__ = 14391; break; }
    case 10991: // $41677
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41669, 177, 0, 0, ((STRING_TABLE.__str1273)|0), ((STRING_TABLE.__str1274)|0), $11332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10992; break; } else { __label__ = 14391; break; }
    case 10992: // $41678
      var $41679=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41669);
      var $41680=__ZN11simple_listI16input_type_entryE6appendERS0_($41630, $41679);
      var $41681=$4689;
      var $41682=$1969;
      var $41683=$1970;
      var $41684=$1971;
      var $41685=$result_i1085;
      var $41686=$1972;
      var $41687=$1973;
      HEAP32[(($1969)>>2)]=408;
      HEAP32[(($1970)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1971)>>2)]=629;
      var $41688=HEAP32[(($1969)>>2)];
      var $41689=HEAP32[(($1970)>>2)];
      var $41690=HEAP32[(($1971)>>2)];
      var $41691=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41688, $41689, $41690) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10993; break; } else { __label__ = 10995; break; };
    case 10993: // $41692
      HEAP32[(($result_i1085)>>2)]=$41691;
      var $41693=HEAP32[(($result_i1085)>>2)];
      var $41694=(($41693)|0)==0;
      if ($41694) { __label__ = 10994; break; } else { __label__ = 10999; break; }
    case 10994: // $41695
      var $41696=___cxa_allocate_exception(4);
      var $41697=$41696;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41697);
      (function() { try { __THREW__ = false; return ___cxa_throw($41696, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10998; break; } else { __label__ = 10995; break; }
    case 10995: // $41698
      var $41699=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41700=$41699.f0;
      HEAP32[(($1972)>>2)]=$41700;
      var $41701=$41699.f1;
      HEAP32[(($1973)>>2)]=$41701;
      var $41702=HEAP32[(($1973)>>2)];
      var $41703=(($41702)|0) < 0;
      if ($41703) { __label__ = 10996; break; } else { __label__ = 10997; break; }
    case 10996: // $41704
      var $41705=HEAP32[(($1972)>>2)];
      ___cxa_call_unexpected($41705);
      throw "Reached an unreachable!"
    case 10997: // $41706
      var $41707=HEAP32[(($1972)>>2)];
      var $41708=HEAP32[(($1972)>>2)];
      var $41709=HEAP32[(($1973)>>2)];
      var $41710=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41708, tempValue);
      var $41711=($41710.f1 = $41709, $41710);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10998: // $41712
      throw "Reached an unreachable!"
    case 10999: // $_ZnwjPKci_exit1086
      var $41713=HEAP32[(($result_i1085)>>2)];
      var $41714=$1969;
      var $41715=$1970;
      var $41716=$1971;
      var $41717=$result_i1085;
      var $41718=$1972;
      var $41719=$1973;
      var $41720=$41713;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11341, 1, 0, 1, 0, 71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11000; break; } else { __label__ = 14396; break; }
    case 11000: // $41721
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11342, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11001; break; } else { __label__ = 14396; break; }
    case 11001: // $41722
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11343, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11002; break; } else { __label__ = 14396; break; }
    case 11002: // $41723
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11344, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11003; break; } else { __label__ = 14396; break; }
    case 11003: // $41724
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11345, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11004; break; } else { __label__ = 14396; break; }
    case 11004: // $41725
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11346, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11005; break; } else { __label__ = 14396; break; }
    case 11005: // $41726
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11347, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11006; break; } else { __label__ = 14396; break; }
    case 11006: // $41727
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11340, $11341, $11342, $11343, $11344, $11345, $11346, $11347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11007; break; } else { __label__ = 14396; break; }
    case 11007: // $41728
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41720, 178, 0, 0, ((STRING_TABLE.__str1275)|0), ((STRING_TABLE.__str1276)|0), $11340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11008; break; } else { __label__ = 14396; break; }
    case 11008: // $41729
      var $41730=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41720);
      var $41731=__ZN11simple_listI16input_type_entryE6appendERS0_($41681, $41730);
      var $41732=$4689;
      var $41733=$1964;
      var $41734=$1965;
      var $41735=$1966;
      var $41736=$result_i1087;
      var $41737=$1967;
      var $41738=$1968;
      HEAP32[(($1964)>>2)]=408;
      HEAP32[(($1965)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1966)>>2)]=630;
      var $41739=HEAP32[(($1964)>>2)];
      var $41740=HEAP32[(($1965)>>2)];
      var $41741=HEAP32[(($1966)>>2)];
      var $41742=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41739, $41740, $41741) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11009; break; } else { __label__ = 11011; break; };
    case 11009: // $41743
      HEAP32[(($result_i1087)>>2)]=$41742;
      var $41744=HEAP32[(($result_i1087)>>2)];
      var $41745=(($41744)|0)==0;
      if ($41745) { __label__ = 11010; break; } else { __label__ = 11015; break; }
    case 11010: // $41746
      var $41747=___cxa_allocate_exception(4);
      var $41748=$41747;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41748);
      (function() { try { __THREW__ = false; return ___cxa_throw($41747, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11014; break; } else { __label__ = 11011; break; }
    case 11011: // $41749
      var $41750=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41751=$41750.f0;
      HEAP32[(($1967)>>2)]=$41751;
      var $41752=$41750.f1;
      HEAP32[(($1968)>>2)]=$41752;
      var $41753=HEAP32[(($1968)>>2)];
      var $41754=(($41753)|0) < 0;
      if ($41754) { __label__ = 11012; break; } else { __label__ = 11013; break; }
    case 11012: // $41755
      var $41756=HEAP32[(($1967)>>2)];
      ___cxa_call_unexpected($41756);
      throw "Reached an unreachable!"
    case 11013: // $41757
      var $41758=HEAP32[(($1967)>>2)];
      var $41759=HEAP32[(($1967)>>2)];
      var $41760=HEAP32[(($1968)>>2)];
      var $41761=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41759, tempValue);
      var $41762=($41761.f1 = $41760, $41761);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11014: // $41763
      throw "Reached an unreachable!"
    case 11015: // $_ZnwjPKci_exit1088
      var $41764=HEAP32[(($result_i1087)>>2)];
      var $41765=$1964;
      var $41766=$1965;
      var $41767=$1966;
      var $41768=$result_i1087;
      var $41769=$1967;
      var $41770=$1968;
      var $41771=$41764;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11349, 1, 0, 1, 0, 72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11016; break; } else { __label__ = 14401; break; }
    case 11016: // $41772
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11350, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11017; break; } else { __label__ = 14401; break; }
    case 11017: // $41773
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11351, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11018; break; } else { __label__ = 14401; break; }
    case 11018: // $41774
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11352, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11019; break; } else { __label__ = 14401; break; }
    case 11019: // $41775
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11353, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11020; break; } else { __label__ = 14401; break; }
    case 11020: // $41776
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11354, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11021; break; } else { __label__ = 14401; break; }
    case 11021: // $41777
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11355, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11022; break; } else { __label__ = 14401; break; }
    case 11022: // $41778
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11348, $11349, $11350, $11351, $11352, $11353, $11354, $11355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11023; break; } else { __label__ = 14401; break; }
    case 11023: // $41779
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41771, 179, 0, 0, ((STRING_TABLE.__str1277)|0), ((STRING_TABLE.__str1278)|0), $11348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11024; break; } else { __label__ = 14401; break; }
    case 11024: // $41780
      var $41781=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41771);
      var $41782=__ZN11simple_listI16input_type_entryE6appendERS0_($41732, $41781);
      var $41783=$4689;
      var $41784=$1959;
      var $41785=$1960;
      var $41786=$1961;
      var $41787=$result_i1089;
      var $41788=$1962;
      var $41789=$1963;
      HEAP32[(($1959)>>2)]=408;
      HEAP32[(($1960)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1961)>>2)]=631;
      var $41790=HEAP32[(($1959)>>2)];
      var $41791=HEAP32[(($1960)>>2)];
      var $41792=HEAP32[(($1961)>>2)];
      var $41793=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41790, $41791, $41792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11025; break; } else { __label__ = 11027; break; };
    case 11025: // $41794
      HEAP32[(($result_i1089)>>2)]=$41793;
      var $41795=HEAP32[(($result_i1089)>>2)];
      var $41796=(($41795)|0)==0;
      if ($41796) { __label__ = 11026; break; } else { __label__ = 11031; break; }
    case 11026: // $41797
      var $41798=___cxa_allocate_exception(4);
      var $41799=$41798;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41799);
      (function() { try { __THREW__ = false; return ___cxa_throw($41798, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11030; break; } else { __label__ = 11027; break; }
    case 11027: // $41800
      var $41801=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41802=$41801.f0;
      HEAP32[(($1962)>>2)]=$41802;
      var $41803=$41801.f1;
      HEAP32[(($1963)>>2)]=$41803;
      var $41804=HEAP32[(($1963)>>2)];
      var $41805=(($41804)|0) < 0;
      if ($41805) { __label__ = 11028; break; } else { __label__ = 11029; break; }
    case 11028: // $41806
      var $41807=HEAP32[(($1962)>>2)];
      ___cxa_call_unexpected($41807);
      throw "Reached an unreachable!"
    case 11029: // $41808
      var $41809=HEAP32[(($1962)>>2)];
      var $41810=HEAP32[(($1962)>>2)];
      var $41811=HEAP32[(($1963)>>2)];
      var $41812=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41810, tempValue);
      var $41813=($41812.f1 = $41811, $41812);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11030: // $41814
      throw "Reached an unreachable!"
    case 11031: // $_ZnwjPKci_exit1090
      var $41815=HEAP32[(($result_i1089)>>2)];
      var $41816=$1959;
      var $41817=$1960;
      var $41818=$1961;
      var $41819=$result_i1089;
      var $41820=$1962;
      var $41821=$1963;
      var $41822=$41815;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11357, 1, 0, 1, 0, 73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11032; break; } else { __label__ = 14406; break; }
    case 11032: // $41823
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11358, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11033; break; } else { __label__ = 14406; break; }
    case 11033: // $41824
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11359, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11034; break; } else { __label__ = 14406; break; }
    case 11034: // $41825
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11360, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11035; break; } else { __label__ = 14406; break; }
    case 11035: // $41826
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11361, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11036; break; } else { __label__ = 14406; break; }
    case 11036: // $41827
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11362, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11037; break; } else { __label__ = 14406; break; }
    case 11037: // $41828
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11363, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11038; break; } else { __label__ = 14406; break; }
    case 11038: // $41829
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11356, $11357, $11358, $11359, $11360, $11361, $11362, $11363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11039; break; } else { __label__ = 14406; break; }
    case 11039: // $41830
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41822, 180, 0, 0, ((STRING_TABLE.__str1279)|0), ((STRING_TABLE.__str1280)|0), $11356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11040; break; } else { __label__ = 14406; break; }
    case 11040: // $41831
      var $41832=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41822);
      var $41833=__ZN11simple_listI16input_type_entryE6appendERS0_($41783, $41832);
      var $41834=$4689;
      var $41835=$1954;
      var $41836=$1955;
      var $41837=$1956;
      var $41838=$result_i1091;
      var $41839=$1957;
      var $41840=$1958;
      HEAP32[(($1954)>>2)]=408;
      HEAP32[(($1955)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1956)>>2)]=632;
      var $41841=HEAP32[(($1954)>>2)];
      var $41842=HEAP32[(($1955)>>2)];
      var $41843=HEAP32[(($1956)>>2)];
      var $41844=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41841, $41842, $41843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11041; break; } else { __label__ = 11043; break; };
    case 11041: // $41845
      HEAP32[(($result_i1091)>>2)]=$41844;
      var $41846=HEAP32[(($result_i1091)>>2)];
      var $41847=(($41846)|0)==0;
      if ($41847) { __label__ = 11042; break; } else { __label__ = 11047; break; }
    case 11042: // $41848
      var $41849=___cxa_allocate_exception(4);
      var $41850=$41849;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41850);
      (function() { try { __THREW__ = false; return ___cxa_throw($41849, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11046; break; } else { __label__ = 11043; break; }
    case 11043: // $41851
      var $41852=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41853=$41852.f0;
      HEAP32[(($1957)>>2)]=$41853;
      var $41854=$41852.f1;
      HEAP32[(($1958)>>2)]=$41854;
      var $41855=HEAP32[(($1958)>>2)];
      var $41856=(($41855)|0) < 0;
      if ($41856) { __label__ = 11044; break; } else { __label__ = 11045; break; }
    case 11044: // $41857
      var $41858=HEAP32[(($1957)>>2)];
      ___cxa_call_unexpected($41858);
      throw "Reached an unreachable!"
    case 11045: // $41859
      var $41860=HEAP32[(($1957)>>2)];
      var $41861=HEAP32[(($1957)>>2)];
      var $41862=HEAP32[(($1958)>>2)];
      var $41863=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41861, tempValue);
      var $41864=($41863.f1 = $41862, $41863);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11046: // $41865
      throw "Reached an unreachable!"
    case 11047: // $_ZnwjPKci_exit1092
      var $41866=HEAP32[(($result_i1091)>>2)];
      var $41867=$1954;
      var $41868=$1955;
      var $41869=$1956;
      var $41870=$result_i1091;
      var $41871=$1957;
      var $41872=$1958;
      var $41873=$41866;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11365, 1, 0, 1, 0, 74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11048; break; } else { __label__ = 14411; break; }
    case 11048: // $41874
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11366, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11049; break; } else { __label__ = 14411; break; }
    case 11049: // $41875
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11367, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11050; break; } else { __label__ = 14411; break; }
    case 11050: // $41876
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11368, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11051; break; } else { __label__ = 14411; break; }
    case 11051: // $41877
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11369, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11052; break; } else { __label__ = 14411; break; }
    case 11052: // $41878
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11370, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11053; break; } else { __label__ = 14411; break; }
    case 11053: // $41879
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11371, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11054; break; } else { __label__ = 14411; break; }
    case 11054: // $41880
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11364, $11365, $11366, $11367, $11368, $11369, $11370, $11371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11055; break; } else { __label__ = 14411; break; }
    case 11055: // $41881
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41873, 181, 0, 0, ((STRING_TABLE.__str1281428)|0), ((STRING_TABLE.__str1282)|0), $11364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11056; break; } else { __label__ = 14411; break; }
    case 11056: // $41882
      var $41883=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41873);
      var $41884=__ZN11simple_listI16input_type_entryE6appendERS0_($41834, $41883);
      var $41885=$4689;
      var $41886=$1949;
      var $41887=$1950;
      var $41888=$1951;
      var $41889=$result_i1093;
      var $41890=$1952;
      var $41891=$1953;
      HEAP32[(($1949)>>2)]=408;
      HEAP32[(($1950)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1951)>>2)]=633;
      var $41892=HEAP32[(($1949)>>2)];
      var $41893=HEAP32[(($1950)>>2)];
      var $41894=HEAP32[(($1951)>>2)];
      var $41895=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41892, $41893, $41894) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11057; break; } else { __label__ = 11059; break; };
    case 11057: // $41896
      HEAP32[(($result_i1093)>>2)]=$41895;
      var $41897=HEAP32[(($result_i1093)>>2)];
      var $41898=(($41897)|0)==0;
      if ($41898) { __label__ = 11058; break; } else { __label__ = 11063; break; }
    case 11058: // $41899
      var $41900=___cxa_allocate_exception(4);
      var $41901=$41900;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41901);
      (function() { try { __THREW__ = false; return ___cxa_throw($41900, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11062; break; } else { __label__ = 11059; break; }
    case 11059: // $41902
      var $41903=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41904=$41903.f0;
      HEAP32[(($1952)>>2)]=$41904;
      var $41905=$41903.f1;
      HEAP32[(($1953)>>2)]=$41905;
      var $41906=HEAP32[(($1953)>>2)];
      var $41907=(($41906)|0) < 0;
      if ($41907) { __label__ = 11060; break; } else { __label__ = 11061; break; }
    case 11060: // $41908
      var $41909=HEAP32[(($1952)>>2)];
      ___cxa_call_unexpected($41909);
      throw "Reached an unreachable!"
    case 11061: // $41910
      var $41911=HEAP32[(($1952)>>2)];
      var $41912=HEAP32[(($1952)>>2)];
      var $41913=HEAP32[(($1953)>>2)];
      var $41914=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41912, tempValue);
      var $41915=($41914.f1 = $41913, $41914);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11062: // $41916
      throw "Reached an unreachable!"
    case 11063: // $_ZnwjPKci_exit1094
      var $41917=HEAP32[(($result_i1093)>>2)];
      var $41918=$1949;
      var $41919=$1950;
      var $41920=$1951;
      var $41921=$result_i1093;
      var $41922=$1952;
      var $41923=$1953;
      var $41924=$41917;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11373, 1, 0, 1, 0, 60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11064; break; } else { __label__ = 14416; break; }
    case 11064: // $41925
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11374, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11065; break; } else { __label__ = 14416; break; }
    case 11065: // $41926
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11375, 4, 0, 1, 0, 118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11066; break; } else { __label__ = 14416; break; }
    case 11066: // $41927
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11376, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11067; break; } else { __label__ = 14416; break; }
    case 11067: // $41928
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11377, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11068; break; } else { __label__ = 14416; break; }
    case 11068: // $41929
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11378, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11069; break; } else { __label__ = 14416; break; }
    case 11069: // $41930
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11379, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11070; break; } else { __label__ = 14416; break; }
    case 11070: // $41931
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11372, $11373, $11374, $11375, $11376, $11377, $11378, $11379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11071; break; } else { __label__ = 14416; break; }
    case 11071: // $41932
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41924, 182, 0, 0, ((STRING_TABLE.__str1283)|0), ((STRING_TABLE.__str1284)|0), $11372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11072; break; } else { __label__ = 14416; break; }
    case 11072: // $41933
      var $41934=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41924);
      var $41935=__ZN11simple_listI16input_type_entryE6appendERS0_($41885, $41934);
      var $41936=$4689;
      var $41937=$1944;
      var $41938=$1945;
      var $41939=$1946;
      var $41940=$result_i1095;
      var $41941=$1947;
      var $41942=$1948;
      HEAP32[(($1944)>>2)]=408;
      HEAP32[(($1945)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1946)>>2)]=634;
      var $41943=HEAP32[(($1944)>>2)];
      var $41944=HEAP32[(($1945)>>2)];
      var $41945=HEAP32[(($1946)>>2)];
      var $41946=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41943, $41944, $41945) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11073; break; } else { __label__ = 11075; break; };
    case 11073: // $41947
      HEAP32[(($result_i1095)>>2)]=$41946;
      var $41948=HEAP32[(($result_i1095)>>2)];
      var $41949=(($41948)|0)==0;
      if ($41949) { __label__ = 11074; break; } else { __label__ = 11079; break; }
    case 11074: // $41950
      var $41951=___cxa_allocate_exception(4);
      var $41952=$41951;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41952);
      (function() { try { __THREW__ = false; return ___cxa_throw($41951, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11078; break; } else { __label__ = 11075; break; }
    case 11075: // $41953
      var $41954=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41955=$41954.f0;
      HEAP32[(($1947)>>2)]=$41955;
      var $41956=$41954.f1;
      HEAP32[(($1948)>>2)]=$41956;
      var $41957=HEAP32[(($1948)>>2)];
      var $41958=(($41957)|0) < 0;
      if ($41958) { __label__ = 11076; break; } else { __label__ = 11077; break; }
    case 11076: // $41959
      var $41960=HEAP32[(($1947)>>2)];
      ___cxa_call_unexpected($41960);
      throw "Reached an unreachable!"
    case 11077: // $41961
      var $41962=HEAP32[(($1947)>>2)];
      var $41963=HEAP32[(($1947)>>2)];
      var $41964=HEAP32[(($1948)>>2)];
      var $41965=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41963, tempValue);
      var $41966=($41965.f1 = $41964, $41965);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11078: // $41967
      throw "Reached an unreachable!"
    case 11079: // $_ZnwjPKci_exit1096
      var $41968=HEAP32[(($result_i1095)>>2)];
      var $41969=$1944;
      var $41970=$1945;
      var $41971=$1946;
      var $41972=$result_i1095;
      var $41973=$1947;
      var $41974=$1948;
      var $41975=$41968;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11381, 1, 0, 1, 0, 52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11080; break; } else { __label__ = 14421; break; }
    case 11080: // $41976
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11382, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11081; break; } else { __label__ = 14421; break; }
    case 11081: // $41977
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11383, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11082; break; } else { __label__ = 14421; break; }
    case 11082: // $41978
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11384, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11083; break; } else { __label__ = 14421; break; }
    case 11083: // $41979
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11385, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11084; break; } else { __label__ = 14421; break; }
    case 11084: // $41980
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11386, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11085; break; } else { __label__ = 14421; break; }
    case 11085: // $41981
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11387, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11086; break; } else { __label__ = 14421; break; }
    case 11086: // $41982
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11380, $11381, $11382, $11383, $11384, $11385, $11386, $11387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11087; break; } else { __label__ = 14421; break; }
    case 11087: // $41983
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($41975, 183, 0, 0, ((STRING_TABLE.__str1285)|0), ((STRING_TABLE.__str1286)|0), $11380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11088; break; } else { __label__ = 14421; break; }
    case 11088: // $41984
      var $41985=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $41975);
      var $41986=__ZN11simple_listI16input_type_entryE6appendERS0_($41936, $41985);
      var $41987=$4689;
      var $41988=$1939;
      var $41989=$1940;
      var $41990=$1941;
      var $41991=$result_i1097;
      var $41992=$1942;
      var $41993=$1943;
      HEAP32[(($1939)>>2)]=408;
      HEAP32[(($1940)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1941)>>2)]=635;
      var $41994=HEAP32[(($1939)>>2)];
      var $41995=HEAP32[(($1940)>>2)];
      var $41996=HEAP32[(($1941)>>2)];
      var $41997=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41994, $41995, $41996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11089; break; } else { __label__ = 11091; break; };
    case 11089: // $41998
      HEAP32[(($result_i1097)>>2)]=$41997;
      var $41999=HEAP32[(($result_i1097)>>2)];
      var $42000=(($41999)|0)==0;
      if ($42000) { __label__ = 11090; break; } else { __label__ = 11095; break; }
    case 11090: // $42001
      var $42002=___cxa_allocate_exception(4);
      var $42003=$42002;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42003);
      (function() { try { __THREW__ = false; return ___cxa_throw($42002, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11094; break; } else { __label__ = 11091; break; }
    case 11091: // $42004
      var $42005=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42006=$42005.f0;
      HEAP32[(($1942)>>2)]=$42006;
      var $42007=$42005.f1;
      HEAP32[(($1943)>>2)]=$42007;
      var $42008=HEAP32[(($1943)>>2)];
      var $42009=(($42008)|0) < 0;
      if ($42009) { __label__ = 11092; break; } else { __label__ = 11093; break; }
    case 11092: // $42010
      var $42011=HEAP32[(($1942)>>2)];
      ___cxa_call_unexpected($42011);
      throw "Reached an unreachable!"
    case 11093: // $42012
      var $42013=HEAP32[(($1942)>>2)];
      var $42014=HEAP32[(($1942)>>2)];
      var $42015=HEAP32[(($1943)>>2)];
      var $42016=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42014, tempValue);
      var $42017=($42016.f1 = $42015, $42016);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11094: // $42018
      throw "Reached an unreachable!"
    case 11095: // $_ZnwjPKci_exit1098
      var $42019=HEAP32[(($result_i1097)>>2)];
      var $42020=$1939;
      var $42021=$1940;
      var $42022=$1941;
      var $42023=$result_i1097;
      var $42024=$1942;
      var $42025=$1943;
      var $42026=$42019;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11389, 1, 0, 1, 0, 68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11096; break; } else { __label__ = 14426; break; }
    case 11096: // $42027
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11390, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11097; break; } else { __label__ = 14426; break; }
    case 11097: // $42028
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11391, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11098; break; } else { __label__ = 14426; break; }
    case 11098: // $42029
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11392, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11099; break; } else { __label__ = 14426; break; }
    case 11099: // $42030
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11393, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11100; break; } else { __label__ = 14426; break; }
    case 11100: // $42031
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11394, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11101; break; } else { __label__ = 14426; break; }
    case 11101: // $42032
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11395, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11102; break; } else { __label__ = 14426; break; }
    case 11102: // $42033
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11388, $11389, $11390, $11391, $11392, $11393, $11394, $11395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11103; break; } else { __label__ = 14426; break; }
    case 11103: // $42034
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42026, 184, 0, 0, ((STRING_TABLE.__str1287)|0), ((STRING_TABLE.__str1288)|0), $11388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11104; break; } else { __label__ = 14426; break; }
    case 11104: // $42035
      var $42036=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42026);
      var $42037=__ZN11simple_listI16input_type_entryE6appendERS0_($41987, $42036);
      var $42038=$4689;
      var $42039=$1934;
      var $42040=$1935;
      var $42041=$1936;
      var $42042=$result_i1099;
      var $42043=$1937;
      var $42044=$1938;
      HEAP32[(($1934)>>2)]=408;
      HEAP32[(($1935)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1936)>>2)]=636;
      var $42045=HEAP32[(($1934)>>2)];
      var $42046=HEAP32[(($1935)>>2)];
      var $42047=HEAP32[(($1936)>>2)];
      var $42048=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42045, $42046, $42047) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11105; break; } else { __label__ = 11107; break; };
    case 11105: // $42049
      HEAP32[(($result_i1099)>>2)]=$42048;
      var $42050=HEAP32[(($result_i1099)>>2)];
      var $42051=(($42050)|0)==0;
      if ($42051) { __label__ = 11106; break; } else { __label__ = 11111; break; }
    case 11106: // $42052
      var $42053=___cxa_allocate_exception(4);
      var $42054=$42053;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42054);
      (function() { try { __THREW__ = false; return ___cxa_throw($42053, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11110; break; } else { __label__ = 11107; break; }
    case 11107: // $42055
      var $42056=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42057=$42056.f0;
      HEAP32[(($1937)>>2)]=$42057;
      var $42058=$42056.f1;
      HEAP32[(($1938)>>2)]=$42058;
      var $42059=HEAP32[(($1938)>>2)];
      var $42060=(($42059)|0) < 0;
      if ($42060) { __label__ = 11108; break; } else { __label__ = 11109; break; }
    case 11108: // $42061
      var $42062=HEAP32[(($1937)>>2)];
      ___cxa_call_unexpected($42062);
      throw "Reached an unreachable!"
    case 11109: // $42063
      var $42064=HEAP32[(($1937)>>2)];
      var $42065=HEAP32[(($1937)>>2)];
      var $42066=HEAP32[(($1938)>>2)];
      var $42067=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42065, tempValue);
      var $42068=($42067.f1 = $42066, $42067);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11110: // $42069
      throw "Reached an unreachable!"
    case 11111: // $_ZnwjPKci_exit1100
      var $42070=HEAP32[(($result_i1099)>>2)];
      var $42071=$1934;
      var $42072=$1935;
      var $42073=$1936;
      var $42074=$result_i1099;
      var $42075=$1937;
      var $42076=$1938;
      var $42077=$42070;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11397, 1, 0, 1, 0, 70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11112; break; } else { __label__ = 14431; break; }
    case 11112: // $42078
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11398, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11113; break; } else { __label__ = 14431; break; }
    case 11113: // $42079
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11399, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11114; break; } else { __label__ = 14431; break; }
    case 11114: // $42080
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11400, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11115; break; } else { __label__ = 14431; break; }
    case 11115: // $42081
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11401, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11116; break; } else { __label__ = 14431; break; }
    case 11116: // $42082
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11402, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11117; break; } else { __label__ = 14431; break; }
    case 11117: // $42083
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11403, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11118; break; } else { __label__ = 14431; break; }
    case 11118: // $42084
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11396, $11397, $11398, $11399, $11400, $11401, $11402, $11403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11119; break; } else { __label__ = 14431; break; }
    case 11119: // $42085
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42077, 185, 0, 0, ((STRING_TABLE.__str1289)|0), ((STRING_TABLE.__str1290)|0), $11396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11120; break; } else { __label__ = 14431; break; }
    case 11120: // $42086
      var $42087=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42077);
      var $42088=__ZN11simple_listI16input_type_entryE6appendERS0_($42038, $42087);
      var $42089=$4689;
      var $42090=$1929;
      var $42091=$1930;
      var $42092=$1931;
      var $42093=$result_i1101;
      var $42094=$1932;
      var $42095=$1933;
      HEAP32[(($1929)>>2)]=408;
      HEAP32[(($1930)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1931)>>2)]=637;
      var $42096=HEAP32[(($1929)>>2)];
      var $42097=HEAP32[(($1930)>>2)];
      var $42098=HEAP32[(($1931)>>2)];
      var $42099=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42096, $42097, $42098) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11121; break; } else { __label__ = 11123; break; };
    case 11121: // $42100
      HEAP32[(($result_i1101)>>2)]=$42099;
      var $42101=HEAP32[(($result_i1101)>>2)];
      var $42102=(($42101)|0)==0;
      if ($42102) { __label__ = 11122; break; } else { __label__ = 11127; break; }
    case 11122: // $42103
      var $42104=___cxa_allocate_exception(4);
      var $42105=$42104;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42105);
      (function() { try { __THREW__ = false; return ___cxa_throw($42104, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11126; break; } else { __label__ = 11123; break; }
    case 11123: // $42106
      var $42107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42108=$42107.f0;
      HEAP32[(($1932)>>2)]=$42108;
      var $42109=$42107.f1;
      HEAP32[(($1933)>>2)]=$42109;
      var $42110=HEAP32[(($1933)>>2)];
      var $42111=(($42110)|0) < 0;
      if ($42111) { __label__ = 11124; break; } else { __label__ = 11125; break; }
    case 11124: // $42112
      var $42113=HEAP32[(($1932)>>2)];
      ___cxa_call_unexpected($42113);
      throw "Reached an unreachable!"
    case 11125: // $42114
      var $42115=HEAP32[(($1932)>>2)];
      var $42116=HEAP32[(($1932)>>2)];
      var $42117=HEAP32[(($1933)>>2)];
      var $42118=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42116, tempValue);
      var $42119=($42118.f1 = $42117, $42118);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11126: // $42120
      throw "Reached an unreachable!"
    case 11127: // $_ZnwjPKci_exit1102
      var $42121=HEAP32[(($result_i1101)>>2)];
      var $42122=$1929;
      var $42123=$1930;
      var $42124=$1931;
      var $42125=$result_i1101;
      var $42126=$1932;
      var $42127=$1933;
      var $42128=$42121;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11405, 1, 0, 1, 0, 55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11128; break; } else { __label__ = 14436; break; }
    case 11128: // $42129
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11406, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11129; break; } else { __label__ = 14436; break; }
    case 11129: // $42130
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11407, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11130; break; } else { __label__ = 14436; break; }
    case 11130: // $42131
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11408, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11131; break; } else { __label__ = 14436; break; }
    case 11131: // $42132
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11409, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11132; break; } else { __label__ = 14436; break; }
    case 11132: // $42133
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11410, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11133; break; } else { __label__ = 14436; break; }
    case 11133: // $42134
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11411, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11134; break; } else { __label__ = 14436; break; }
    case 11134: // $42135
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11404, $11405, $11406, $11407, $11408, $11409, $11410, $11411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11135; break; } else { __label__ = 14436; break; }
    case 11135: // $42136
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42128, 186, 0, 0, ((STRING_TABLE.__str1291)|0), ((STRING_TABLE.__str1292)|0), $11404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11136; break; } else { __label__ = 14436; break; }
    case 11136: // $42137
      var $42138=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42128);
      var $42139=__ZN11simple_listI16input_type_entryE6appendERS0_($42089, $42138);
      var $42140=$4689;
      var $42141=$1924;
      var $42142=$1925;
      var $42143=$1926;
      var $42144=$result_i1103;
      var $42145=$1927;
      var $42146=$1928;
      HEAP32[(($1924)>>2)]=408;
      HEAP32[(($1925)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1926)>>2)]=638;
      var $42147=HEAP32[(($1924)>>2)];
      var $42148=HEAP32[(($1925)>>2)];
      var $42149=HEAP32[(($1926)>>2)];
      var $42150=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42147, $42148, $42149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11137; break; } else { __label__ = 11139; break; };
    case 11137: // $42151
      HEAP32[(($result_i1103)>>2)]=$42150;
      var $42152=HEAP32[(($result_i1103)>>2)];
      var $42153=(($42152)|0)==0;
      if ($42153) { __label__ = 11138; break; } else { __label__ = 11143; break; }
    case 11138: // $42154
      var $42155=___cxa_allocate_exception(4);
      var $42156=$42155;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42156);
      (function() { try { __THREW__ = false; return ___cxa_throw($42155, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11142; break; } else { __label__ = 11139; break; }
    case 11139: // $42157
      var $42158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42159=$42158.f0;
      HEAP32[(($1927)>>2)]=$42159;
      var $42160=$42158.f1;
      HEAP32[(($1928)>>2)]=$42160;
      var $42161=HEAP32[(($1928)>>2)];
      var $42162=(($42161)|0) < 0;
      if ($42162) { __label__ = 11140; break; } else { __label__ = 11141; break; }
    case 11140: // $42163
      var $42164=HEAP32[(($1927)>>2)];
      ___cxa_call_unexpected($42164);
      throw "Reached an unreachable!"
    case 11141: // $42165
      var $42166=HEAP32[(($1927)>>2)];
      var $42167=HEAP32[(($1927)>>2)];
      var $42168=HEAP32[(($1928)>>2)];
      var $42169=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42167, tempValue);
      var $42170=($42169.f1 = $42168, $42169);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11142: // $42171
      throw "Reached an unreachable!"
    case 11143: // $_ZnwjPKci_exit1104
      var $42172=HEAP32[(($result_i1103)>>2)];
      var $42173=$1924;
      var $42174=$1925;
      var $42175=$1926;
      var $42176=$result_i1103;
      var $42177=$1927;
      var $42178=$1928;
      var $42179=$42172;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11413, 1, 0, 1, 0, 54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11144; break; } else { __label__ = 14441; break; }
    case 11144: // $42180
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11414, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11145; break; } else { __label__ = 14441; break; }
    case 11145: // $42181
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11415, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11146; break; } else { __label__ = 14441; break; }
    case 11146: // $42182
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11416, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11147; break; } else { __label__ = 14441; break; }
    case 11147: // $42183
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11417, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11148; break; } else { __label__ = 14441; break; }
    case 11148: // $42184
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11418, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11149; break; } else { __label__ = 14441; break; }
    case 11149: // $42185
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11419, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11150; break; } else { __label__ = 14441; break; }
    case 11150: // $42186
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11412, $11413, $11414, $11415, $11416, $11417, $11418, $11419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11151; break; } else { __label__ = 14441; break; }
    case 11151: // $42187
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42179, 187, 0, 0, ((STRING_TABLE.__str1293)|0), ((STRING_TABLE.__str1294)|0), $11412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11152; break; } else { __label__ = 14441; break; }
    case 11152: // $42188
      var $42189=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42179);
      var $42190=__ZN11simple_listI16input_type_entryE6appendERS0_($42140, $42189);
      var $42191=$4689;
      var $42192=$1919;
      var $42193=$1920;
      var $42194=$1921;
      var $42195=$result_i1105;
      var $42196=$1922;
      var $42197=$1923;
      HEAP32[(($1919)>>2)]=408;
      HEAP32[(($1920)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1921)>>2)]=639;
      var $42198=HEAP32[(($1919)>>2)];
      var $42199=HEAP32[(($1920)>>2)];
      var $42200=HEAP32[(($1921)>>2)];
      var $42201=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42198, $42199, $42200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11153; break; } else { __label__ = 11155; break; };
    case 11153: // $42202
      HEAP32[(($result_i1105)>>2)]=$42201;
      var $42203=HEAP32[(($result_i1105)>>2)];
      var $42204=(($42203)|0)==0;
      if ($42204) { __label__ = 11154; break; } else { __label__ = 11159; break; }
    case 11154: // $42205
      var $42206=___cxa_allocate_exception(4);
      var $42207=$42206;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42207);
      (function() { try { __THREW__ = false; return ___cxa_throw($42206, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11158; break; } else { __label__ = 11155; break; }
    case 11155: // $42208
      var $42209=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42210=$42209.f0;
      HEAP32[(($1922)>>2)]=$42210;
      var $42211=$42209.f1;
      HEAP32[(($1923)>>2)]=$42211;
      var $42212=HEAP32[(($1923)>>2)];
      var $42213=(($42212)|0) < 0;
      if ($42213) { __label__ = 11156; break; } else { __label__ = 11157; break; }
    case 11156: // $42214
      var $42215=HEAP32[(($1922)>>2)];
      ___cxa_call_unexpected($42215);
      throw "Reached an unreachable!"
    case 11157: // $42216
      var $42217=HEAP32[(($1922)>>2)];
      var $42218=HEAP32[(($1922)>>2)];
      var $42219=HEAP32[(($1923)>>2)];
      var $42220=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42218, tempValue);
      var $42221=($42220.f1 = $42219, $42220);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11158: // $42222
      throw "Reached an unreachable!"
    case 11159: // $_ZnwjPKci_exit1106
      var $42223=HEAP32[(($result_i1105)>>2)];
      var $42224=$1919;
      var $42225=$1920;
      var $42226=$1921;
      var $42227=$result_i1105;
      var $42228=$1922;
      var $42229=$1923;
      var $42230=$42223;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11421, 1, 0, 1, 0, 58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11160; break; } else { __label__ = 14446; break; }
    case 11160: // $42231
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11422, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11161; break; } else { __label__ = 14446; break; }
    case 11161: // $42232
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11423, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11162; break; } else { __label__ = 14446; break; }
    case 11162: // $42233
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11424, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11163; break; } else { __label__ = 14446; break; }
    case 11163: // $42234
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11425, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11164; break; } else { __label__ = 14446; break; }
    case 11164: // $42235
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11426, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11165; break; } else { __label__ = 14446; break; }
    case 11165: // $42236
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11427, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11166; break; } else { __label__ = 14446; break; }
    case 11166: // $42237
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11420, $11421, $11422, $11423, $11424, $11425, $11426, $11427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11167; break; } else { __label__ = 14446; break; }
    case 11167: // $42238
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42230, 188, 0, 0, ((STRING_TABLE.__str1295)|0), ((STRING_TABLE.__str1296)|0), $11420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11168; break; } else { __label__ = 14446; break; }
    case 11168: // $42239
      var $42240=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42230);
      var $42241=__ZN11simple_listI16input_type_entryE6appendERS0_($42191, $42240);
      var $42242=$4689;
      var $42243=$1914;
      var $42244=$1915;
      var $42245=$1916;
      var $42246=$result_i1107;
      var $42247=$1917;
      var $42248=$1918;
      HEAP32[(($1914)>>2)]=408;
      HEAP32[(($1915)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1916)>>2)]=640;
      var $42249=HEAP32[(($1914)>>2)];
      var $42250=HEAP32[(($1915)>>2)];
      var $42251=HEAP32[(($1916)>>2)];
      var $42252=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42249, $42250, $42251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11169; break; } else { __label__ = 11171; break; };
    case 11169: // $42253
      HEAP32[(($result_i1107)>>2)]=$42252;
      var $42254=HEAP32[(($result_i1107)>>2)];
      var $42255=(($42254)|0)==0;
      if ($42255) { __label__ = 11170; break; } else { __label__ = 11175; break; }
    case 11170: // $42256
      var $42257=___cxa_allocate_exception(4);
      var $42258=$42257;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42258);
      (function() { try { __THREW__ = false; return ___cxa_throw($42257, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11174; break; } else { __label__ = 11171; break; }
    case 11171: // $42259
      var $42260=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42261=$42260.f0;
      HEAP32[(($1917)>>2)]=$42261;
      var $42262=$42260.f1;
      HEAP32[(($1918)>>2)]=$42262;
      var $42263=HEAP32[(($1918)>>2)];
      var $42264=(($42263)|0) < 0;
      if ($42264) { __label__ = 11172; break; } else { __label__ = 11173; break; }
    case 11172: // $42265
      var $42266=HEAP32[(($1917)>>2)];
      ___cxa_call_unexpected($42266);
      throw "Reached an unreachable!"
    case 11173: // $42267
      var $42268=HEAP32[(($1917)>>2)];
      var $42269=HEAP32[(($1917)>>2)];
      var $42270=HEAP32[(($1918)>>2)];
      var $42271=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42269, tempValue);
      var $42272=($42271.f1 = $42270, $42271);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11174: // $42273
      throw "Reached an unreachable!"
    case 11175: // $_ZnwjPKci_exit1108
      var $42274=HEAP32[(($result_i1107)>>2)];
      var $42275=$1914;
      var $42276=$1915;
      var $42277=$1916;
      var $42278=$result_i1107;
      var $42279=$1917;
      var $42280=$1918;
      var $42281=$42274;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11429, 1, 0, 1, 0, 59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11176; break; } else { __label__ = 14451; break; }
    case 11176: // $42282
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11430, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11177; break; } else { __label__ = 14451; break; }
    case 11177: // $42283
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11431, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11178; break; } else { __label__ = 14451; break; }
    case 11178: // $42284
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11432, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11179; break; } else { __label__ = 14451; break; }
    case 11179: // $42285
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11433, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11180; break; } else { __label__ = 14451; break; }
    case 11180: // $42286
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11434, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11181; break; } else { __label__ = 14451; break; }
    case 11181: // $42287
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11435, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11182; break; } else { __label__ = 14451; break; }
    case 11182: // $42288
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11428, $11429, $11430, $11431, $11432, $11433, $11434, $11435) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11183; break; } else { __label__ = 14451; break; }
    case 11183: // $42289
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42281, 189, 0, 0, ((STRING_TABLE.__str1297)|0), ((STRING_TABLE.__str1298)|0), $11428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11184; break; } else { __label__ = 14451; break; }
    case 11184: // $42290
      var $42291=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42281);
      var $42292=__ZN11simple_listI16input_type_entryE6appendERS0_($42242, $42291);
      var $42293=$4689;
      var $42294=$1909;
      var $42295=$1910;
      var $42296=$1911;
      var $42297=$result_i1109;
      var $42298=$1912;
      var $42299=$1913;
      HEAP32[(($1909)>>2)]=408;
      HEAP32[(($1910)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1911)>>2)]=641;
      var $42300=HEAP32[(($1909)>>2)];
      var $42301=HEAP32[(($1910)>>2)];
      var $42302=HEAP32[(($1911)>>2)];
      var $42303=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42300, $42301, $42302) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11185; break; } else { __label__ = 11187; break; };
    case 11185: // $42304
      HEAP32[(($result_i1109)>>2)]=$42303;
      var $42305=HEAP32[(($result_i1109)>>2)];
      var $42306=(($42305)|0)==0;
      if ($42306) { __label__ = 11186; break; } else { __label__ = 11191; break; }
    case 11186: // $42307
      var $42308=___cxa_allocate_exception(4);
      var $42309=$42308;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42309);
      (function() { try { __THREW__ = false; return ___cxa_throw($42308, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11190; break; } else { __label__ = 11187; break; }
    case 11187: // $42310
      var $42311=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42312=$42311.f0;
      HEAP32[(($1912)>>2)]=$42312;
      var $42313=$42311.f1;
      HEAP32[(($1913)>>2)]=$42313;
      var $42314=HEAP32[(($1913)>>2)];
      var $42315=(($42314)|0) < 0;
      if ($42315) { __label__ = 11188; break; } else { __label__ = 11189; break; }
    case 11188: // $42316
      var $42317=HEAP32[(($1912)>>2)];
      ___cxa_call_unexpected($42317);
      throw "Reached an unreachable!"
    case 11189: // $42318
      var $42319=HEAP32[(($1912)>>2)];
      var $42320=HEAP32[(($1912)>>2)];
      var $42321=HEAP32[(($1913)>>2)];
      var $42322=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42320, tempValue);
      var $42323=($42322.f1 = $42321, $42322);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11190: // $42324
      throw "Reached an unreachable!"
    case 11191: // $_ZnwjPKci_exit1110
      var $42325=HEAP32[(($result_i1109)>>2)];
      var $42326=$1909;
      var $42327=$1910;
      var $42328=$1911;
      var $42329=$result_i1109;
      var $42330=$1912;
      var $42331=$1913;
      var $42332=$42325;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11437, 1, 0, 1, 0, 18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11192; break; } else { __label__ = 14456; break; }
    case 11192: // $42333
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11438, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11193; break; } else { __label__ = 14456; break; }
    case 11193: // $42334
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11439, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11194; break; } else { __label__ = 14456; break; }
    case 11194: // $42335
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11440, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11195; break; } else { __label__ = 14456; break; }
    case 11195: // $42336
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11441, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11196; break; } else { __label__ = 14456; break; }
    case 11196: // $42337
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11442, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11197; break; } else { __label__ = 14456; break; }
    case 11197: // $42338
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11443, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11198; break; } else { __label__ = 14456; break; }
    case 11198: // $42339
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11436, $11437, $11438, $11439, $11440, $11441, $11442, $11443) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11199; break; } else { __label__ = 14456; break; }
    case 11199: // $42340
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42332, 190, 0, 0, ((STRING_TABLE.__str1299)|0), ((STRING_TABLE.__str1300)|0), $11436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11200; break; } else { __label__ = 14456; break; }
    case 11200: // $42341
      var $42342=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42332);
      var $42343=__ZN11simple_listI16input_type_entryE6appendERS0_($42293, $42342);
      var $42344=$4689;
      var $42345=$1904;
      var $42346=$1905;
      var $42347=$1906;
      var $42348=$result_i1111;
      var $42349=$1907;
      var $42350=$1908;
      HEAP32[(($1904)>>2)]=408;
      HEAP32[(($1905)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1906)>>2)]=642;
      var $42351=HEAP32[(($1904)>>2)];
      var $42352=HEAP32[(($1905)>>2)];
      var $42353=HEAP32[(($1906)>>2)];
      var $42354=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42351, $42352, $42353) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11201; break; } else { __label__ = 11203; break; };
    case 11201: // $42355
      HEAP32[(($result_i1111)>>2)]=$42354;
      var $42356=HEAP32[(($result_i1111)>>2)];
      var $42357=(($42356)|0)==0;
      if ($42357) { __label__ = 11202; break; } else { __label__ = 11207; break; }
    case 11202: // $42358
      var $42359=___cxa_allocate_exception(4);
      var $42360=$42359;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42360);
      (function() { try { __THREW__ = false; return ___cxa_throw($42359, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11206; break; } else { __label__ = 11203; break; }
    case 11203: // $42361
      var $42362=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42363=$42362.f0;
      HEAP32[(($1907)>>2)]=$42363;
      var $42364=$42362.f1;
      HEAP32[(($1908)>>2)]=$42364;
      var $42365=HEAP32[(($1908)>>2)];
      var $42366=(($42365)|0) < 0;
      if ($42366) { __label__ = 11204; break; } else { __label__ = 11205; break; }
    case 11204: // $42367
      var $42368=HEAP32[(($1907)>>2)];
      ___cxa_call_unexpected($42368);
      throw "Reached an unreachable!"
    case 11205: // $42369
      var $42370=HEAP32[(($1907)>>2)];
      var $42371=HEAP32[(($1907)>>2)];
      var $42372=HEAP32[(($1908)>>2)];
      var $42373=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42371, tempValue);
      var $42374=($42373.f1 = $42372, $42373);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11206: // $42375
      throw "Reached an unreachable!"
    case 11207: // $_ZnwjPKci_exit1112
      var $42376=HEAP32[(($result_i1111)>>2)];
      var $42377=$1904;
      var $42378=$1905;
      var $42379=$1906;
      var $42380=$result_i1111;
      var $42381=$1907;
      var $42382=$1908;
      var $42383=$42376;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11445, 1, 0, 1, 0, 47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11208; break; } else { __label__ = 14461; break; }
    case 11208: // $42384
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11446, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11209; break; } else { __label__ = 14461; break; }
    case 11209: // $42385
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11447, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11210; break; } else { __label__ = 14461; break; }
    case 11210: // $42386
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11448, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11211; break; } else { __label__ = 14461; break; }
    case 11211: // $42387
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11449, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11212; break; } else { __label__ = 14461; break; }
    case 11212: // $42388
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11450, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11213; break; } else { __label__ = 14461; break; }
    case 11213: // $42389
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11451, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11214; break; } else { __label__ = 14461; break; }
    case 11214: // $42390
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11444, $11445, $11446, $11447, $11448, $11449, $11450, $11451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11215; break; } else { __label__ = 14461; break; }
    case 11215: // $42391
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42383, 191, 0, 0, ((STRING_TABLE.__str1301)|0), ((STRING_TABLE.__str1302)|0), $11444) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11216; break; } else { __label__ = 14461; break; }
    case 11216: // $42392
      var $42393=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42383);
      var $42394=__ZN11simple_listI16input_type_entryE6appendERS0_($42344, $42393);
      var $42395=$4689;
      var $42396=$1899;
      var $42397=$1900;
      var $42398=$1901;
      var $42399=$result_i1113;
      var $42400=$1902;
      var $42401=$1903;
      HEAP32[(($1899)>>2)]=408;
      HEAP32[(($1900)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1901)>>2)]=643;
      var $42402=HEAP32[(($1899)>>2)];
      var $42403=HEAP32[(($1900)>>2)];
      var $42404=HEAP32[(($1901)>>2)];
      var $42405=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42402, $42403, $42404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11217; break; } else { __label__ = 11219; break; };
    case 11217: // $42406
      HEAP32[(($result_i1113)>>2)]=$42405;
      var $42407=HEAP32[(($result_i1113)>>2)];
      var $42408=(($42407)|0)==0;
      if ($42408) { __label__ = 11218; break; } else { __label__ = 11223; break; }
    case 11218: // $42409
      var $42410=___cxa_allocate_exception(4);
      var $42411=$42410;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42411);
      (function() { try { __THREW__ = false; return ___cxa_throw($42410, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11222; break; } else { __label__ = 11219; break; }
    case 11219: // $42412
      var $42413=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42414=$42413.f0;
      HEAP32[(($1902)>>2)]=$42414;
      var $42415=$42413.f1;
      HEAP32[(($1903)>>2)]=$42415;
      var $42416=HEAP32[(($1903)>>2)];
      var $42417=(($42416)|0) < 0;
      if ($42417) { __label__ = 11220; break; } else { __label__ = 11221; break; }
    case 11220: // $42418
      var $42419=HEAP32[(($1902)>>2)];
      ___cxa_call_unexpected($42419);
      throw "Reached an unreachable!"
    case 11221: // $42420
      var $42421=HEAP32[(($1902)>>2)];
      var $42422=HEAP32[(($1902)>>2)];
      var $42423=HEAP32[(($1903)>>2)];
      var $42424=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42422, tempValue);
      var $42425=($42424.f1 = $42423, $42424);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11222: // $42426
      throw "Reached an unreachable!"
    case 11223: // $_ZnwjPKci_exit1114
      var $42427=HEAP32[(($result_i1113)>>2)];
      var $42428=$1899;
      var $42429=$1900;
      var $42430=$1901;
      var $42431=$result_i1113;
      var $42432=$1902;
      var $42433=$1903;
      var $42434=$42427;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11453, 1, 0, 1, 0, 103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11224; break; } else { __label__ = 14466; break; }
    case 11224: // $42435
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11454, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11225; break; } else { __label__ = 14466; break; }
    case 11225: // $42436
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11455, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11226; break; } else { __label__ = 14466; break; }
    case 11226: // $42437
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11456, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11227; break; } else { __label__ = 14466; break; }
    case 11227: // $42438
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11457, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11228; break; } else { __label__ = 14466; break; }
    case 11228: // $42439
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11458, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11229; break; } else { __label__ = 14466; break; }
    case 11229: // $42440
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11459, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11230; break; } else { __label__ = 14466; break; }
    case 11230: // $42441
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11452, $11453, $11454, $11455, $11456, $11457, $11458, $11459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11231; break; } else { __label__ = 14466; break; }
    case 11231: // $42442
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42434, 192, 0, 0, ((STRING_TABLE.__str1303)|0), ((STRING_TABLE.__str1304)|0), $11452) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11232; break; } else { __label__ = 14466; break; }
    case 11232: // $42443
      var $42444=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42434);
      var $42445=__ZN11simple_listI16input_type_entryE6appendERS0_($42395, $42444);
      var $42446=$4689;
      var $42447=$1894;
      var $42448=$1895;
      var $42449=$1896;
      var $42450=$result_i1115;
      var $42451=$1897;
      var $42452=$1898;
      HEAP32[(($1894)>>2)]=408;
      HEAP32[(($1895)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1896)>>2)]=644;
      var $42453=HEAP32[(($1894)>>2)];
      var $42454=HEAP32[(($1895)>>2)];
      var $42455=HEAP32[(($1896)>>2)];
      var $42456=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42453, $42454, $42455) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11233; break; } else { __label__ = 11235; break; };
    case 11233: // $42457
      HEAP32[(($result_i1115)>>2)]=$42456;
      var $42458=HEAP32[(($result_i1115)>>2)];
      var $42459=(($42458)|0)==0;
      if ($42459) { __label__ = 11234; break; } else { __label__ = 11239; break; }
    case 11234: // $42460
      var $42461=___cxa_allocate_exception(4);
      var $42462=$42461;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42462);
      (function() { try { __THREW__ = false; return ___cxa_throw($42461, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11238; break; } else { __label__ = 11235; break; }
    case 11235: // $42463
      var $42464=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42465=$42464.f0;
      HEAP32[(($1897)>>2)]=$42465;
      var $42466=$42464.f1;
      HEAP32[(($1898)>>2)]=$42466;
      var $42467=HEAP32[(($1898)>>2)];
      var $42468=(($42467)|0) < 0;
      if ($42468) { __label__ = 11236; break; } else { __label__ = 11237; break; }
    case 11236: // $42469
      var $42470=HEAP32[(($1897)>>2)];
      ___cxa_call_unexpected($42470);
      throw "Reached an unreachable!"
    case 11237: // $42471
      var $42472=HEAP32[(($1897)>>2)];
      var $42473=HEAP32[(($1897)>>2)];
      var $42474=HEAP32[(($1898)>>2)];
      var $42475=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42473, tempValue);
      var $42476=($42475.f1 = $42474, $42475);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11238: // $42477
      throw "Reached an unreachable!"
    case 11239: // $_ZnwjPKci_exit1116
      var $42478=HEAP32[(($result_i1115)>>2)];
      var $42479=$1894;
      var $42480=$1895;
      var $42481=$1896;
      var $42482=$result_i1115;
      var $42483=$1897;
      var $42484=$1898;
      var $42485=$42478;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11461, 1, 0, 1, 0, 103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11240; break; } else { __label__ = 14471; break; }
    case 11240: // $42486
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11462, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11241; break; } else { __label__ = 14471; break; }
    case 11241: // $42487
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11463, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11242; break; } else { __label__ = 14471; break; }
    case 11242: // $42488
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11464, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11243; break; } else { __label__ = 14471; break; }
    case 11243: // $42489
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11465, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11244; break; } else { __label__ = 14471; break; }
    case 11244: // $42490
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11466, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11245; break; } else { __label__ = 14471; break; }
    case 11245: // $42491
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11467, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11246; break; } else { __label__ = 14471; break; }
    case 11246: // $42492
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11460, $11461, $11462, $11463, $11464, $11465, $11466, $11467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11247; break; } else { __label__ = 14471; break; }
    case 11247: // $42493
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42485, 194, 0, 0, ((STRING_TABLE.__str1305)|0), ((STRING_TABLE.__str1306)|0), $11460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11248; break; } else { __label__ = 14471; break; }
    case 11248: // $42494
      var $42495=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42485);
      var $42496=__ZN11simple_listI16input_type_entryE6appendERS0_($42446, $42495);
      var $42497=$4689;
      var $42498=$1889;
      var $42499=$1890;
      var $42500=$1891;
      var $42501=$result_i1117;
      var $42502=$1892;
      var $42503=$1893;
      HEAP32[(($1889)>>2)]=408;
      HEAP32[(($1890)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1891)>>2)]=645;
      var $42504=HEAP32[(($1889)>>2)];
      var $42505=HEAP32[(($1890)>>2)];
      var $42506=HEAP32[(($1891)>>2)];
      var $42507=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42504, $42505, $42506) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11249; break; } else { __label__ = 11251; break; };
    case 11249: // $42508
      HEAP32[(($result_i1117)>>2)]=$42507;
      var $42509=HEAP32[(($result_i1117)>>2)];
      var $42510=(($42509)|0)==0;
      if ($42510) { __label__ = 11250; break; } else { __label__ = 11255; break; }
    case 11250: // $42511
      var $42512=___cxa_allocate_exception(4);
      var $42513=$42512;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42513);
      (function() { try { __THREW__ = false; return ___cxa_throw($42512, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11254; break; } else { __label__ = 11251; break; }
    case 11251: // $42514
      var $42515=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42516=$42515.f0;
      HEAP32[(($1892)>>2)]=$42516;
      var $42517=$42515.f1;
      HEAP32[(($1893)>>2)]=$42517;
      var $42518=HEAP32[(($1893)>>2)];
      var $42519=(($42518)|0) < 0;
      if ($42519) { __label__ = 11252; break; } else { __label__ = 11253; break; }
    case 11252: // $42520
      var $42521=HEAP32[(($1892)>>2)];
      ___cxa_call_unexpected($42521);
      throw "Reached an unreachable!"
    case 11253: // $42522
      var $42523=HEAP32[(($1892)>>2)];
      var $42524=HEAP32[(($1892)>>2)];
      var $42525=HEAP32[(($1893)>>2)];
      var $42526=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42524, tempValue);
      var $42527=($42526.f1 = $42525, $42526);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11254: // $42528
      throw "Reached an unreachable!"
    case 11255: // $_ZnwjPKci_exit1118
      var $42529=HEAP32[(($result_i1117)>>2)];
      var $42530=$1889;
      var $42531=$1890;
      var $42532=$1891;
      var $42533=$result_i1117;
      var $42534=$1892;
      var $42535=$1893;
      var $42536=$42529;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11469, 1, 0, 1, 0, 41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11256; break; } else { __label__ = 14476; break; }
    case 11256: // $42537
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11470, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11257; break; } else { __label__ = 14476; break; }
    case 11257: // $42538
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11471, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11258; break; } else { __label__ = 14476; break; }
    case 11258: // $42539
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11472, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11259; break; } else { __label__ = 14476; break; }
    case 11259: // $42540
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11473, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11260; break; } else { __label__ = 14476; break; }
    case 11260: // $42541
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11474, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11261; break; } else { __label__ = 14476; break; }
    case 11261: // $42542
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11475, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11262; break; } else { __label__ = 14476; break; }
    case 11262: // $42543
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11468, $11469, $11470, $11471, $11472, $11473, $11474, $11475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11263; break; } else { __label__ = 14476; break; }
    case 11263: // $42544
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42536, 193, 0, 0, ((STRING_TABLE.__str1307)|0), ((STRING_TABLE.__str1308429)|0), $11468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11264; break; } else { __label__ = 14476; break; }
    case 11264: // $42545
      var $42546=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42536);
      var $42547=__ZN11simple_listI16input_type_entryE6appendERS0_($42497, $42546);
      var $42548=$4689;
      var $42549=$1884;
      var $42550=$1885;
      var $42551=$1886;
      var $42552=$result_i1119;
      var $42553=$1887;
      var $42554=$1888;
      HEAP32[(($1884)>>2)]=408;
      HEAP32[(($1885)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1886)>>2)]=646;
      var $42555=HEAP32[(($1884)>>2)];
      var $42556=HEAP32[(($1885)>>2)];
      var $42557=HEAP32[(($1886)>>2)];
      var $42558=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42555, $42556, $42557) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11265; break; } else { __label__ = 11267; break; };
    case 11265: // $42559
      HEAP32[(($result_i1119)>>2)]=$42558;
      var $42560=HEAP32[(($result_i1119)>>2)];
      var $42561=(($42560)|0)==0;
      if ($42561) { __label__ = 11266; break; } else { __label__ = 11271; break; }
    case 11266: // $42562
      var $42563=___cxa_allocate_exception(4);
      var $42564=$42563;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42564);
      (function() { try { __THREW__ = false; return ___cxa_throw($42563, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11270; break; } else { __label__ = 11267; break; }
    case 11267: // $42565
      var $42566=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42567=$42566.f0;
      HEAP32[(($1887)>>2)]=$42567;
      var $42568=$42566.f1;
      HEAP32[(($1888)>>2)]=$42568;
      var $42569=HEAP32[(($1888)>>2)];
      var $42570=(($42569)|0) < 0;
      if ($42570) { __label__ = 11268; break; } else { __label__ = 11269; break; }
    case 11268: // $42571
      var $42572=HEAP32[(($1887)>>2)];
      ___cxa_call_unexpected($42572);
      throw "Reached an unreachable!"
    case 11269: // $42573
      var $42574=HEAP32[(($1887)>>2)];
      var $42575=HEAP32[(($1887)>>2)];
      var $42576=HEAP32[(($1888)>>2)];
      var $42577=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42575, tempValue);
      var $42578=($42577.f1 = $42576, $42577);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11270: // $42579
      throw "Reached an unreachable!"
    case 11271: // $_ZnwjPKci_exit1120
      var $42580=HEAP32[(($result_i1119)>>2)];
      var $42581=$1884;
      var $42582=$1885;
      var $42583=$1886;
      var $42584=$result_i1119;
      var $42585=$1887;
      var $42586=$1888;
      var $42587=$42580;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11477, 1, 0, 1, 0, 43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11272; break; } else { __label__ = 14481; break; }
    case 11272: // $42588
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11478, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11273; break; } else { __label__ = 14481; break; }
    case 11273: // $42589
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11479, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11274; break; } else { __label__ = 14481; break; }
    case 11274: // $42590
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11480, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11275; break; } else { __label__ = 14481; break; }
    case 11275: // $42591
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11481, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11276; break; } else { __label__ = 14481; break; }
    case 11276: // $42592
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11482, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11277; break; } else { __label__ = 14481; break; }
    case 11277: // $42593
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11483, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11278; break; } else { __label__ = 14481; break; }
    case 11278: // $42594
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11476, $11477, $11478, $11479, $11480, $11481, $11482, $11483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11279; break; } else { __label__ = 14481; break; }
    case 11279: // $42595
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42587, 195, 0, 0, ((STRING_TABLE.__str1309)|0), ((STRING_TABLE.__str1310)|0), $11476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11280; break; } else { __label__ = 14481; break; }
    case 11280: // $42596
      var $42597=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42587);
      var $42598=__ZN11simple_listI16input_type_entryE6appendERS0_($42548, $42597);
      var $42599=$4689;
      var $42600=$1879;
      var $42601=$1880;
      var $42602=$1881;
      var $42603=$result_i1121;
      var $42604=$1882;
      var $42605=$1883;
      HEAP32[(($1879)>>2)]=408;
      HEAP32[(($1880)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1881)>>2)]=647;
      var $42606=HEAP32[(($1879)>>2)];
      var $42607=HEAP32[(($1880)>>2)];
      var $42608=HEAP32[(($1881)>>2)];
      var $42609=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42606, $42607, $42608) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11281; break; } else { __label__ = 11283; break; };
    case 11281: // $42610
      HEAP32[(($result_i1121)>>2)]=$42609;
      var $42611=HEAP32[(($result_i1121)>>2)];
      var $42612=(($42611)|0)==0;
      if ($42612) { __label__ = 11282; break; } else { __label__ = 11287; break; }
    case 11282: // $42613
      var $42614=___cxa_allocate_exception(4);
      var $42615=$42614;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42615);
      (function() { try { __THREW__ = false; return ___cxa_throw($42614, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11286; break; } else { __label__ = 11283; break; }
    case 11283: // $42616
      var $42617=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42618=$42617.f0;
      HEAP32[(($1882)>>2)]=$42618;
      var $42619=$42617.f1;
      HEAP32[(($1883)>>2)]=$42619;
      var $42620=HEAP32[(($1883)>>2)];
      var $42621=(($42620)|0) < 0;
      if ($42621) { __label__ = 11284; break; } else { __label__ = 11285; break; }
    case 11284: // $42622
      var $42623=HEAP32[(($1882)>>2)];
      ___cxa_call_unexpected($42623);
      throw "Reached an unreachable!"
    case 11285: // $42624
      var $42625=HEAP32[(($1882)>>2)];
      var $42626=HEAP32[(($1882)>>2)];
      var $42627=HEAP32[(($1883)>>2)];
      var $42628=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42626, tempValue);
      var $42629=($42628.f1 = $42627, $42628);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11286: // $42630
      throw "Reached an unreachable!"
    case 11287: // $_ZnwjPKci_exit1122
      var $42631=HEAP32[(($result_i1121)>>2)];
      var $42632=$1879;
      var $42633=$1880;
      var $42634=$1881;
      var $42635=$result_i1121;
      var $42636=$1882;
      var $42637=$1883;
      var $42638=$42631;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11485, 1, 0, 1, 0, 43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11288; break; } else { __label__ = 14486; break; }
    case 11288: // $42639
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11486, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11289; break; } else { __label__ = 14486; break; }
    case 11289: // $42640
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11487, 1, 0, 1, 0, 97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11290; break; } else { __label__ = 14486; break; }
    case 11290: // $42641
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11488, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11291; break; } else { __label__ = 14486; break; }
    case 11291: // $42642
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11489, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11292; break; } else { __label__ = 14486; break; }
    case 11292: // $42643
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11490, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11293; break; } else { __label__ = 14486; break; }
    case 11293: // $42644
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11491, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11294; break; } else { __label__ = 14486; break; }
    case 11294: // $42645
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11484, $11485, $11486, $11487, $11488, $11489, $11490, $11491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11295; break; } else { __label__ = 14486; break; }
    case 11295: // $42646
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42638, 196, 0, 0, ((STRING_TABLE.__str1311)|0), ((STRING_TABLE.__str1312)|0), $11484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11296; break; } else { __label__ = 14486; break; }
    case 11296: // $42647
      var $42648=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42638);
      var $42649=__ZN11simple_listI16input_type_entryE6appendERS0_($42599, $42648);
      var $42650=$4689;
      var $42651=$1874;
      var $42652=$1875;
      var $42653=$1876;
      var $42654=$result_i1123;
      var $42655=$1877;
      var $42656=$1878;
      HEAP32[(($1874)>>2)]=408;
      HEAP32[(($1875)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1876)>>2)]=649;
      var $42657=HEAP32[(($1874)>>2)];
      var $42658=HEAP32[(($1875)>>2)];
      var $42659=HEAP32[(($1876)>>2)];
      var $42660=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42657, $42658, $42659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11297; break; } else { __label__ = 11299; break; };
    case 11297: // $42661
      HEAP32[(($result_i1123)>>2)]=$42660;
      var $42662=HEAP32[(($result_i1123)>>2)];
      var $42663=(($42662)|0)==0;
      if ($42663) { __label__ = 11298; break; } else { __label__ = 11303; break; }
    case 11298: // $42664
      var $42665=___cxa_allocate_exception(4);
      var $42666=$42665;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42666);
      (function() { try { __THREW__ = false; return ___cxa_throw($42665, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11302; break; } else { __label__ = 11299; break; }
    case 11299: // $42667
      var $42668=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42669=$42668.f0;
      HEAP32[(($1877)>>2)]=$42669;
      var $42670=$42668.f1;
      HEAP32[(($1878)>>2)]=$42670;
      var $42671=HEAP32[(($1878)>>2)];
      var $42672=(($42671)|0) < 0;
      if ($42672) { __label__ = 11300; break; } else { __label__ = 11301; break; }
    case 11300: // $42673
      var $42674=HEAP32[(($1877)>>2)];
      ___cxa_call_unexpected($42674);
      throw "Reached an unreachable!"
    case 11301: // $42675
      var $42676=HEAP32[(($1877)>>2)];
      var $42677=HEAP32[(($1877)>>2)];
      var $42678=HEAP32[(($1878)>>2)];
      var $42679=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42677, tempValue);
      var $42680=($42679.f1 = $42678, $42679);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11302: // $42681
      throw "Reached an unreachable!"
    case 11303: // $_ZnwjPKci_exit1124
      var $42682=HEAP32[(($result_i1123)>>2)];
      var $42683=$1874;
      var $42684=$1875;
      var $42685=$1876;
      var $42686=$result_i1123;
      var $42687=$1877;
      var $42688=$1878;
      var $42689=$42682;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11493, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11304; break; } else { __label__ = 14491; break; }
    case 11304: // $42690
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11494, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11305; break; } else { __label__ = 14491; break; }
    case 11305: // $42691
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11495, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11306; break; } else { __label__ = 14491; break; }
    case 11306: // $42692
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11496, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11307; break; } else { __label__ = 14491; break; }
    case 11307: // $42693
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11497, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11308; break; } else { __label__ = 14491; break; }
    case 11308: // $42694
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11498, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11309; break; } else { __label__ = 14491; break; }
    case 11309: // $42695
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11499, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11310; break; } else { __label__ = 14491; break; }
    case 11310: // $42696
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11492, $11493, $11494, $11495, $11496, $11497, $11498, $11499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11311; break; } else { __label__ = 14491; break; }
    case 11311: // $42697
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42689, 197, 0, 0, ((STRING_TABLE.__str1313)|0), 0, $11492) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11312; break; } else { __label__ = 14491; break; }
    case 11312: // $42698
      var $42699=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42689);
      var $42700=__ZN11simple_listI16input_type_entryE6appendERS0_($42650, $42699);
      var $42701=$4689;
      var $42702=$1869;
      var $42703=$1870;
      var $42704=$1871;
      var $42705=$result_i1125;
      var $42706=$1872;
      var $42707=$1873;
      HEAP32[(($1869)>>2)]=408;
      HEAP32[(($1870)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1871)>>2)]=650;
      var $42708=HEAP32[(($1869)>>2)];
      var $42709=HEAP32[(($1870)>>2)];
      var $42710=HEAP32[(($1871)>>2)];
      var $42711=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42708, $42709, $42710) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11313; break; } else { __label__ = 11315; break; };
    case 11313: // $42712
      HEAP32[(($result_i1125)>>2)]=$42711;
      var $42713=HEAP32[(($result_i1125)>>2)];
      var $42714=(($42713)|0)==0;
      if ($42714) { __label__ = 11314; break; } else { __label__ = 11319; break; }
    case 11314: // $42715
      var $42716=___cxa_allocate_exception(4);
      var $42717=$42716;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42717);
      (function() { try { __THREW__ = false; return ___cxa_throw($42716, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11318; break; } else { __label__ = 11315; break; }
    case 11315: // $42718
      var $42719=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42720=$42719.f0;
      HEAP32[(($1872)>>2)]=$42720;
      var $42721=$42719.f1;
      HEAP32[(($1873)>>2)]=$42721;
      var $42722=HEAP32[(($1873)>>2)];
      var $42723=(($42722)|0) < 0;
      if ($42723) { __label__ = 11316; break; } else { __label__ = 11317; break; }
    case 11316: // $42724
      var $42725=HEAP32[(($1872)>>2)];
      ___cxa_call_unexpected($42725);
      throw "Reached an unreachable!"
    case 11317: // $42726
      var $42727=HEAP32[(($1872)>>2)];
      var $42728=HEAP32[(($1872)>>2)];
      var $42729=HEAP32[(($1873)>>2)];
      var $42730=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42728, tempValue);
      var $42731=($42730.f1 = $42729, $42730);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11318: // $42732
      throw "Reached an unreachable!"
    case 11319: // $_ZnwjPKci_exit1126
      var $42733=HEAP32[(($result_i1125)>>2)];
      var $42734=$1869;
      var $42735=$1870;
      var $42736=$1871;
      var $42737=$result_i1125;
      var $42738=$1872;
      var $42739=$1873;
      var $42740=$42733;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11501, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11320; break; } else { __label__ = 14496; break; }
    case 11320: // $42741
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11502, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11321; break; } else { __label__ = 14496; break; }
    case 11321: // $42742
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11503, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11322; break; } else { __label__ = 14496; break; }
    case 11322: // $42743
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11504, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11323; break; } else { __label__ = 14496; break; }
    case 11323: // $42744
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11505, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11324; break; } else { __label__ = 14496; break; }
    case 11324: // $42745
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11506, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11325; break; } else { __label__ = 14496; break; }
    case 11325: // $42746
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11507, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11326; break; } else { __label__ = 14496; break; }
    case 11326: // $42747
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11500, $11501, $11502, $11503, $11504, $11505, $11506, $11507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11327; break; } else { __label__ = 14496; break; }
    case 11327: // $42748
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42740, 198, 0, 0, ((STRING_TABLE.__str1314)|0), 0, $11500) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11328; break; } else { __label__ = 14496; break; }
    case 11328: // $42749
      var $42750=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42740);
      var $42751=__ZN11simple_listI16input_type_entryE6appendERS0_($42701, $42750);
      var $42752=$4689;
      var $42753=$1864;
      var $42754=$1865;
      var $42755=$1866;
      var $42756=$result_i1127;
      var $42757=$1867;
      var $42758=$1868;
      HEAP32[(($1864)>>2)]=408;
      HEAP32[(($1865)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1866)>>2)]=651;
      var $42759=HEAP32[(($1864)>>2)];
      var $42760=HEAP32[(($1865)>>2)];
      var $42761=HEAP32[(($1866)>>2)];
      var $42762=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42759, $42760, $42761) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11329; break; } else { __label__ = 11331; break; };
    case 11329: // $42763
      HEAP32[(($result_i1127)>>2)]=$42762;
      var $42764=HEAP32[(($result_i1127)>>2)];
      var $42765=(($42764)|0)==0;
      if ($42765) { __label__ = 11330; break; } else { __label__ = 11335; break; }
    case 11330: // $42766
      var $42767=___cxa_allocate_exception(4);
      var $42768=$42767;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42768);
      (function() { try { __THREW__ = false; return ___cxa_throw($42767, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11334; break; } else { __label__ = 11331; break; }
    case 11331: // $42769
      var $42770=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42771=$42770.f0;
      HEAP32[(($1867)>>2)]=$42771;
      var $42772=$42770.f1;
      HEAP32[(($1868)>>2)]=$42772;
      var $42773=HEAP32[(($1868)>>2)];
      var $42774=(($42773)|0) < 0;
      if ($42774) { __label__ = 11332; break; } else { __label__ = 11333; break; }
    case 11332: // $42775
      var $42776=HEAP32[(($1867)>>2)];
      ___cxa_call_unexpected($42776);
      throw "Reached an unreachable!"
    case 11333: // $42777
      var $42778=HEAP32[(($1867)>>2)];
      var $42779=HEAP32[(($1867)>>2)];
      var $42780=HEAP32[(($1868)>>2)];
      var $42781=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42779, tempValue);
      var $42782=($42781.f1 = $42780, $42781);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11334: // $42783
      throw "Reached an unreachable!"
    case 11335: // $_ZnwjPKci_exit1128
      var $42784=HEAP32[(($result_i1127)>>2)];
      var $42785=$1864;
      var $42786=$1865;
      var $42787=$1866;
      var $42788=$result_i1127;
      var $42789=$1867;
      var $42790=$1868;
      var $42791=$42784;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11509, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11336; break; } else { __label__ = 14501; break; }
    case 11336: // $42792
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11510, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11337; break; } else { __label__ = 14501; break; }
    case 11337: // $42793
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11511, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11338; break; } else { __label__ = 14501; break; }
    case 11338: // $42794
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11512, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11339; break; } else { __label__ = 14501; break; }
    case 11339: // $42795
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11513, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11340; break; } else { __label__ = 14501; break; }
    case 11340: // $42796
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11514, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11341; break; } else { __label__ = 14501; break; }
    case 11341: // $42797
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11515, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11342; break; } else { __label__ = 14501; break; }
    case 11342: // $42798
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11508, $11509, $11510, $11511, $11512, $11513, $11514, $11515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11343; break; } else { __label__ = 14501; break; }
    case 11343: // $42799
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42791, 199, 0, 0, ((STRING_TABLE.__str1315)|0), 0, $11508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11344; break; } else { __label__ = 14501; break; }
    case 11344: // $42800
      var $42801=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42791);
      var $42802=__ZN11simple_listI16input_type_entryE6appendERS0_($42752, $42801);
      var $42803=$4689;
      var $42804=$1859;
      var $42805=$1860;
      var $42806=$1861;
      var $42807=$result_i1129;
      var $42808=$1862;
      var $42809=$1863;
      HEAP32[(($1859)>>2)]=408;
      HEAP32[(($1860)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1861)>>2)]=652;
      var $42810=HEAP32[(($1859)>>2)];
      var $42811=HEAP32[(($1860)>>2)];
      var $42812=HEAP32[(($1861)>>2)];
      var $42813=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42810, $42811, $42812) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11345; break; } else { __label__ = 11347; break; };
    case 11345: // $42814
      HEAP32[(($result_i1129)>>2)]=$42813;
      var $42815=HEAP32[(($result_i1129)>>2)];
      var $42816=(($42815)|0)==0;
      if ($42816) { __label__ = 11346; break; } else { __label__ = 11351; break; }
    case 11346: // $42817
      var $42818=___cxa_allocate_exception(4);
      var $42819=$42818;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42819);
      (function() { try { __THREW__ = false; return ___cxa_throw($42818, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11350; break; } else { __label__ = 11347; break; }
    case 11347: // $42820
      var $42821=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42822=$42821.f0;
      HEAP32[(($1862)>>2)]=$42822;
      var $42823=$42821.f1;
      HEAP32[(($1863)>>2)]=$42823;
      var $42824=HEAP32[(($1863)>>2)];
      var $42825=(($42824)|0) < 0;
      if ($42825) { __label__ = 11348; break; } else { __label__ = 11349; break; }
    case 11348: // $42826
      var $42827=HEAP32[(($1862)>>2)];
      ___cxa_call_unexpected($42827);
      throw "Reached an unreachable!"
    case 11349: // $42828
      var $42829=HEAP32[(($1862)>>2)];
      var $42830=HEAP32[(($1862)>>2)];
      var $42831=HEAP32[(($1863)>>2)];
      var $42832=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42830, tempValue);
      var $42833=($42832.f1 = $42831, $42832);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11350: // $42834
      throw "Reached an unreachable!"
    case 11351: // $_ZnwjPKci_exit1130
      var $42835=HEAP32[(($result_i1129)>>2)];
      var $42836=$1859;
      var $42837=$1860;
      var $42838=$1861;
      var $42839=$result_i1129;
      var $42840=$1862;
      var $42841=$1863;
      var $42842=$42835;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11517, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11352; break; } else { __label__ = 14506; break; }
    case 11352: // $42843
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11518, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11353; break; } else { __label__ = 14506; break; }
    case 11353: // $42844
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11519, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11354; break; } else { __label__ = 14506; break; }
    case 11354: // $42845
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11520, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11355; break; } else { __label__ = 14506; break; }
    case 11355: // $42846
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11521, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11356; break; } else { __label__ = 14506; break; }
    case 11356: // $42847
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11522, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11357; break; } else { __label__ = 14506; break; }
    case 11357: // $42848
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11523, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11358; break; } else { __label__ = 14506; break; }
    case 11358: // $42849
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11516, $11517, $11518, $11519, $11520, $11521, $11522, $11523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11359; break; } else { __label__ = 14506; break; }
    case 11359: // $42850
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42842, 200, 0, 0, ((STRING_TABLE.__str1316)|0), 0, $11516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11360; break; } else { __label__ = 14506; break; }
    case 11360: // $42851
      var $42852=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42842);
      var $42853=__ZN11simple_listI16input_type_entryE6appendERS0_($42803, $42852);
      var $42854=$4689;
      var $42855=$1854;
      var $42856=$1855;
      var $42857=$1856;
      var $42858=$result_i1131;
      var $42859=$1857;
      var $42860=$1858;
      HEAP32[(($1854)>>2)]=408;
      HEAP32[(($1855)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1856)>>2)]=653;
      var $42861=HEAP32[(($1854)>>2)];
      var $42862=HEAP32[(($1855)>>2)];
      var $42863=HEAP32[(($1856)>>2)];
      var $42864=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42861, $42862, $42863) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11361; break; } else { __label__ = 11363; break; };
    case 11361: // $42865
      HEAP32[(($result_i1131)>>2)]=$42864;
      var $42866=HEAP32[(($result_i1131)>>2)];
      var $42867=(($42866)|0)==0;
      if ($42867) { __label__ = 11362; break; } else { __label__ = 11367; break; }
    case 11362: // $42868
      var $42869=___cxa_allocate_exception(4);
      var $42870=$42869;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42870);
      (function() { try { __THREW__ = false; return ___cxa_throw($42869, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11366; break; } else { __label__ = 11363; break; }
    case 11363: // $42871
      var $42872=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42873=$42872.f0;
      HEAP32[(($1857)>>2)]=$42873;
      var $42874=$42872.f1;
      HEAP32[(($1858)>>2)]=$42874;
      var $42875=HEAP32[(($1858)>>2)];
      var $42876=(($42875)|0) < 0;
      if ($42876) { __label__ = 11364; break; } else { __label__ = 11365; break; }
    case 11364: // $42877
      var $42878=HEAP32[(($1857)>>2)];
      ___cxa_call_unexpected($42878);
      throw "Reached an unreachable!"
    case 11365: // $42879
      var $42880=HEAP32[(($1857)>>2)];
      var $42881=HEAP32[(($1857)>>2)];
      var $42882=HEAP32[(($1858)>>2)];
      var $42883=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42881, tempValue);
      var $42884=($42883.f1 = $42882, $42883);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11366: // $42885
      throw "Reached an unreachable!"
    case 11367: // $_ZnwjPKci_exit1132
      var $42886=HEAP32[(($result_i1131)>>2)];
      var $42887=$1854;
      var $42888=$1855;
      var $42889=$1856;
      var $42890=$result_i1131;
      var $42891=$1857;
      var $42892=$1858;
      var $42893=$42886;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11525, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11368; break; } else { __label__ = 14511; break; }
    case 11368: // $42894
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11526, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11369; break; } else { __label__ = 14511; break; }
    case 11369: // $42895
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11527, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11370; break; } else { __label__ = 14511; break; }
    case 11370: // $42896
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11528, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11371; break; } else { __label__ = 14511; break; }
    case 11371: // $42897
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11529, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11372; break; } else { __label__ = 14511; break; }
    case 11372: // $42898
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11530, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11373; break; } else { __label__ = 14511; break; }
    case 11373: // $42899
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11531, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11374; break; } else { __label__ = 14511; break; }
    case 11374: // $42900
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11524, $11525, $11526, $11527, $11528, $11529, $11530, $11531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11375; break; } else { __label__ = 14511; break; }
    case 11375: // $42901
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42893, 201, 0, 0, ((STRING_TABLE.__str1317)|0), 0, $11524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11376; break; } else { __label__ = 14511; break; }
    case 11376: // $42902
      var $42903=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42893);
      var $42904=__ZN11simple_listI16input_type_entryE6appendERS0_($42854, $42903);
      var $42905=$4689;
      var $42906=$1849;
      var $42907=$1850;
      var $42908=$1851;
      var $42909=$result_i1133;
      var $42910=$1852;
      var $42911=$1853;
      HEAP32[(($1849)>>2)]=408;
      HEAP32[(($1850)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1851)>>2)]=654;
      var $42912=HEAP32[(($1849)>>2)];
      var $42913=HEAP32[(($1850)>>2)];
      var $42914=HEAP32[(($1851)>>2)];
      var $42915=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42912, $42913, $42914) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11377; break; } else { __label__ = 11379; break; };
    case 11377: // $42916
      HEAP32[(($result_i1133)>>2)]=$42915;
      var $42917=HEAP32[(($result_i1133)>>2)];
      var $42918=(($42917)|0)==0;
      if ($42918) { __label__ = 11378; break; } else { __label__ = 11383; break; }
    case 11378: // $42919
      var $42920=___cxa_allocate_exception(4);
      var $42921=$42920;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42921);
      (function() { try { __THREW__ = false; return ___cxa_throw($42920, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11382; break; } else { __label__ = 11379; break; }
    case 11379: // $42922
      var $42923=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42924=$42923.f0;
      HEAP32[(($1852)>>2)]=$42924;
      var $42925=$42923.f1;
      HEAP32[(($1853)>>2)]=$42925;
      var $42926=HEAP32[(($1853)>>2)];
      var $42927=(($42926)|0) < 0;
      if ($42927) { __label__ = 11380; break; } else { __label__ = 11381; break; }
    case 11380: // $42928
      var $42929=HEAP32[(($1852)>>2)];
      ___cxa_call_unexpected($42929);
      throw "Reached an unreachable!"
    case 11381: // $42930
      var $42931=HEAP32[(($1852)>>2)];
      var $42932=HEAP32[(($1852)>>2)];
      var $42933=HEAP32[(($1853)>>2)];
      var $42934=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42932, tempValue);
      var $42935=($42934.f1 = $42933, $42934);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11382: // $42936
      throw "Reached an unreachable!"
    case 11383: // $_ZnwjPKci_exit1134
      var $42937=HEAP32[(($result_i1133)>>2)];
      var $42938=$1849;
      var $42939=$1850;
      var $42940=$1851;
      var $42941=$result_i1133;
      var $42942=$1852;
      var $42943=$1853;
      var $42944=$42937;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11533, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11384; break; } else { __label__ = 14516; break; }
    case 11384: // $42945
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11534, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11385; break; } else { __label__ = 14516; break; }
    case 11385: // $42946
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11535, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11386; break; } else { __label__ = 14516; break; }
    case 11386: // $42947
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11536, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11387; break; } else { __label__ = 14516; break; }
    case 11387: // $42948
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11537, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11388; break; } else { __label__ = 14516; break; }
    case 11388: // $42949
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11538, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11389; break; } else { __label__ = 14516; break; }
    case 11389: // $42950
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11539, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11390; break; } else { __label__ = 14516; break; }
    case 11390: // $42951
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11532, $11533, $11534, $11535, $11536, $11537, $11538, $11539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11391; break; } else { __label__ = 14516; break; }
    case 11391: // $42952
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42944, 202, 0, 0, ((STRING_TABLE.__str1318)|0), 0, $11532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11392; break; } else { __label__ = 14516; break; }
    case 11392: // $42953
      var $42954=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42944);
      var $42955=__ZN11simple_listI16input_type_entryE6appendERS0_($42905, $42954);
      var $42956=$4689;
      var $42957=$1844;
      var $42958=$1845;
      var $42959=$1846;
      var $42960=$result_i1135;
      var $42961=$1847;
      var $42962=$1848;
      HEAP32[(($1844)>>2)]=408;
      HEAP32[(($1845)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1846)>>2)]=655;
      var $42963=HEAP32[(($1844)>>2)];
      var $42964=HEAP32[(($1845)>>2)];
      var $42965=HEAP32[(($1846)>>2)];
      var $42966=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($42963, $42964, $42965) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11393; break; } else { __label__ = 11395; break; };
    case 11393: // $42967
      HEAP32[(($result_i1135)>>2)]=$42966;
      var $42968=HEAP32[(($result_i1135)>>2)];
      var $42969=(($42968)|0)==0;
      if ($42969) { __label__ = 11394; break; } else { __label__ = 11399; break; }
    case 11394: // $42970
      var $42971=___cxa_allocate_exception(4);
      var $42972=$42971;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42972);
      (function() { try { __THREW__ = false; return ___cxa_throw($42971, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11398; break; } else { __label__ = 11395; break; }
    case 11395: // $42973
      var $42974=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42975=$42974.f0;
      HEAP32[(($1847)>>2)]=$42975;
      var $42976=$42974.f1;
      HEAP32[(($1848)>>2)]=$42976;
      var $42977=HEAP32[(($1848)>>2)];
      var $42978=(($42977)|0) < 0;
      if ($42978) { __label__ = 11396; break; } else { __label__ = 11397; break; }
    case 11396: // $42979
      var $42980=HEAP32[(($1847)>>2)];
      ___cxa_call_unexpected($42980);
      throw "Reached an unreachable!"
    case 11397: // $42981
      var $42982=HEAP32[(($1847)>>2)];
      var $42983=HEAP32[(($1847)>>2)];
      var $42984=HEAP32[(($1848)>>2)];
      var $42985=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42983, tempValue);
      var $42986=($42985.f1 = $42984, $42985);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11398: // $42987
      throw "Reached an unreachable!"
    case 11399: // $_ZnwjPKci_exit1136
      var $42988=HEAP32[(($result_i1135)>>2)];
      var $42989=$1844;
      var $42990=$1845;
      var $42991=$1846;
      var $42992=$result_i1135;
      var $42993=$1847;
      var $42994=$1848;
      var $42995=$42988;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11541, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11400; break; } else { __label__ = 14521; break; }
    case 11400: // $42996
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11542, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11401; break; } else { __label__ = 14521; break; }
    case 11401: // $42997
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11543, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11402; break; } else { __label__ = 14521; break; }
    case 11402: // $42998
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11544, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11403; break; } else { __label__ = 14521; break; }
    case 11403: // $42999
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11545, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11404; break; } else { __label__ = 14521; break; }
    case 11404: // $43000
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11546, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11405; break; } else { __label__ = 14521; break; }
    case 11405: // $43001
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11547, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11406; break; } else { __label__ = 14521; break; }
    case 11406: // $43002
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11540, $11541, $11542, $11543, $11544, $11545, $11546, $11547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11407; break; } else { __label__ = 14521; break; }
    case 11407: // $43003
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($42995, 203, 0, 0, ((STRING_TABLE.__str1319)|0), 0, $11540) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11408; break; } else { __label__ = 14521; break; }
    case 11408: // $43004
      var $43005=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $42995);
      var $43006=__ZN11simple_listI16input_type_entryE6appendERS0_($42956, $43005);
      var $43007=$4689;
      var $43008=$1839;
      var $43009=$1840;
      var $43010=$1841;
      var $43011=$result_i1137;
      var $43012=$1842;
      var $43013=$1843;
      HEAP32[(($1839)>>2)]=408;
      HEAP32[(($1840)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1841)>>2)]=656;
      var $43014=HEAP32[(($1839)>>2)];
      var $43015=HEAP32[(($1840)>>2)];
      var $43016=HEAP32[(($1841)>>2)];
      var $43017=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43014, $43015, $43016) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11409; break; } else { __label__ = 11411; break; };
    case 11409: // $43018
      HEAP32[(($result_i1137)>>2)]=$43017;
      var $43019=HEAP32[(($result_i1137)>>2)];
      var $43020=(($43019)|0)==0;
      if ($43020) { __label__ = 11410; break; } else { __label__ = 11415; break; }
    case 11410: // $43021
      var $43022=___cxa_allocate_exception(4);
      var $43023=$43022;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43023);
      (function() { try { __THREW__ = false; return ___cxa_throw($43022, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11414; break; } else { __label__ = 11411; break; }
    case 11411: // $43024
      var $43025=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43026=$43025.f0;
      HEAP32[(($1842)>>2)]=$43026;
      var $43027=$43025.f1;
      HEAP32[(($1843)>>2)]=$43027;
      var $43028=HEAP32[(($1843)>>2)];
      var $43029=(($43028)|0) < 0;
      if ($43029) { __label__ = 11412; break; } else { __label__ = 11413; break; }
    case 11412: // $43030
      var $43031=HEAP32[(($1842)>>2)];
      ___cxa_call_unexpected($43031);
      throw "Reached an unreachable!"
    case 11413: // $43032
      var $43033=HEAP32[(($1842)>>2)];
      var $43034=HEAP32[(($1842)>>2)];
      var $43035=HEAP32[(($1843)>>2)];
      var $43036=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43034, tempValue);
      var $43037=($43036.f1 = $43035, $43036);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11414: // $43038
      throw "Reached an unreachable!"
    case 11415: // $_ZnwjPKci_exit1138
      var $43039=HEAP32[(($result_i1137)>>2)];
      var $43040=$1839;
      var $43041=$1840;
      var $43042=$1841;
      var $43043=$result_i1137;
      var $43044=$1842;
      var $43045=$1843;
      var $43046=$43039;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11549, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11416; break; } else { __label__ = 14526; break; }
    case 11416: // $43047
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11550, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11417; break; } else { __label__ = 14526; break; }
    case 11417: // $43048
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11551, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11418; break; } else { __label__ = 14526; break; }
    case 11418: // $43049
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11552, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11419; break; } else { __label__ = 14526; break; }
    case 11419: // $43050
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11553, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11420; break; } else { __label__ = 14526; break; }
    case 11420: // $43051
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11554, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11421; break; } else { __label__ = 14526; break; }
    case 11421: // $43052
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11555, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11422; break; } else { __label__ = 14526; break; }
    case 11422: // $43053
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11548, $11549, $11550, $11551, $11552, $11553, $11554, $11555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11423; break; } else { __label__ = 14526; break; }
    case 11423: // $43054
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43046, 204, 0, 0, ((STRING_TABLE.__str1320)|0), 0, $11548) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11424; break; } else { __label__ = 14526; break; }
    case 11424: // $43055
      var $43056=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43046);
      var $43057=__ZN11simple_listI16input_type_entryE6appendERS0_($43007, $43056);
      var $43058=$4689;
      var $43059=$1834;
      var $43060=$1835;
      var $43061=$1836;
      var $43062=$result_i1139;
      var $43063=$1837;
      var $43064=$1838;
      HEAP32[(($1834)>>2)]=408;
      HEAP32[(($1835)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1836)>>2)]=657;
      var $43065=HEAP32[(($1834)>>2)];
      var $43066=HEAP32[(($1835)>>2)];
      var $43067=HEAP32[(($1836)>>2)];
      var $43068=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43065, $43066, $43067) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11425; break; } else { __label__ = 11427; break; };
    case 11425: // $43069
      HEAP32[(($result_i1139)>>2)]=$43068;
      var $43070=HEAP32[(($result_i1139)>>2)];
      var $43071=(($43070)|0)==0;
      if ($43071) { __label__ = 11426; break; } else { __label__ = 11431; break; }
    case 11426: // $43072
      var $43073=___cxa_allocate_exception(4);
      var $43074=$43073;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43074);
      (function() { try { __THREW__ = false; return ___cxa_throw($43073, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11430; break; } else { __label__ = 11427; break; }
    case 11427: // $43075
      var $43076=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43077=$43076.f0;
      HEAP32[(($1837)>>2)]=$43077;
      var $43078=$43076.f1;
      HEAP32[(($1838)>>2)]=$43078;
      var $43079=HEAP32[(($1838)>>2)];
      var $43080=(($43079)|0) < 0;
      if ($43080) { __label__ = 11428; break; } else { __label__ = 11429; break; }
    case 11428: // $43081
      var $43082=HEAP32[(($1837)>>2)];
      ___cxa_call_unexpected($43082);
      throw "Reached an unreachable!"
    case 11429: // $43083
      var $43084=HEAP32[(($1837)>>2)];
      var $43085=HEAP32[(($1837)>>2)];
      var $43086=HEAP32[(($1838)>>2)];
      var $43087=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43085, tempValue);
      var $43088=($43087.f1 = $43086, $43087);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11430: // $43089
      throw "Reached an unreachable!"
    case 11431: // $_ZnwjPKci_exit1140
      var $43090=HEAP32[(($result_i1139)>>2)];
      var $43091=$1834;
      var $43092=$1835;
      var $43093=$1836;
      var $43094=$result_i1139;
      var $43095=$1837;
      var $43096=$1838;
      var $43097=$43090;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11557, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11432; break; } else { __label__ = 14531; break; }
    case 11432: // $43098
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11558, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11433; break; } else { __label__ = 14531; break; }
    case 11433: // $43099
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11559, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11434; break; } else { __label__ = 14531; break; }
    case 11434: // $43100
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11560, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11435; break; } else { __label__ = 14531; break; }
    case 11435: // $43101
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11561, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11436; break; } else { __label__ = 14531; break; }
    case 11436: // $43102
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11562, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11437; break; } else { __label__ = 14531; break; }
    case 11437: // $43103
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11563, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11438; break; } else { __label__ = 14531; break; }
    case 11438: // $43104
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11556, $11557, $11558, $11559, $11560, $11561, $11562, $11563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11439; break; } else { __label__ = 14531; break; }
    case 11439: // $43105
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43097, 205, 0, 0, ((STRING_TABLE.__str1321)|0), 0, $11556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11440; break; } else { __label__ = 14531; break; }
    case 11440: // $43106
      var $43107=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43097);
      var $43108=__ZN11simple_listI16input_type_entryE6appendERS0_($43058, $43107);
      var $43109=$4689;
      var $43110=$1829;
      var $43111=$1830;
      var $43112=$1831;
      var $43113=$result_i1141;
      var $43114=$1832;
      var $43115=$1833;
      HEAP32[(($1829)>>2)]=408;
      HEAP32[(($1830)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1831)>>2)]=658;
      var $43116=HEAP32[(($1829)>>2)];
      var $43117=HEAP32[(($1830)>>2)];
      var $43118=HEAP32[(($1831)>>2)];
      var $43119=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43116, $43117, $43118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11441; break; } else { __label__ = 11443; break; };
    case 11441: // $43120
      HEAP32[(($result_i1141)>>2)]=$43119;
      var $43121=HEAP32[(($result_i1141)>>2)];
      var $43122=(($43121)|0)==0;
      if ($43122) { __label__ = 11442; break; } else { __label__ = 11447; break; }
    case 11442: // $43123
      var $43124=___cxa_allocate_exception(4);
      var $43125=$43124;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43125);
      (function() { try { __THREW__ = false; return ___cxa_throw($43124, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11446; break; } else { __label__ = 11443; break; }
    case 11443: // $43126
      var $43127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43128=$43127.f0;
      HEAP32[(($1832)>>2)]=$43128;
      var $43129=$43127.f1;
      HEAP32[(($1833)>>2)]=$43129;
      var $43130=HEAP32[(($1833)>>2)];
      var $43131=(($43130)|0) < 0;
      if ($43131) { __label__ = 11444; break; } else { __label__ = 11445; break; }
    case 11444: // $43132
      var $43133=HEAP32[(($1832)>>2)];
      ___cxa_call_unexpected($43133);
      throw "Reached an unreachable!"
    case 11445: // $43134
      var $43135=HEAP32[(($1832)>>2)];
      var $43136=HEAP32[(($1832)>>2)];
      var $43137=HEAP32[(($1833)>>2)];
      var $43138=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43136, tempValue);
      var $43139=($43138.f1 = $43137, $43138);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11446: // $43140
      throw "Reached an unreachable!"
    case 11447: // $_ZnwjPKci_exit1142
      var $43141=HEAP32[(($result_i1141)>>2)];
      var $43142=$1829;
      var $43143=$1830;
      var $43144=$1831;
      var $43145=$result_i1141;
      var $43146=$1832;
      var $43147=$1833;
      var $43148=$43141;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11565, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11448; break; } else { __label__ = 14536; break; }
    case 11448: // $43149
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11566, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11449; break; } else { __label__ = 14536; break; }
    case 11449: // $43150
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11567, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11450; break; } else { __label__ = 14536; break; }
    case 11450: // $43151
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11568, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11451; break; } else { __label__ = 14536; break; }
    case 11451: // $43152
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11569, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11452; break; } else { __label__ = 14536; break; }
    case 11452: // $43153
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11570, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11453; break; } else { __label__ = 14536; break; }
    case 11453: // $43154
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11571, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11454; break; } else { __label__ = 14536; break; }
    case 11454: // $43155
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11564, $11565, $11566, $11567, $11568, $11569, $11570, $11571) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11455; break; } else { __label__ = 14536; break; }
    case 11455: // $43156
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43148, 206, 0, 0, ((STRING_TABLE.__str1322430)|0), 0, $11564) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11456; break; } else { __label__ = 14536; break; }
    case 11456: // $43157
      var $43158=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43148);
      var $43159=__ZN11simple_listI16input_type_entryE6appendERS0_($43109, $43158);
      var $43160=$4689;
      var $43161=$1824;
      var $43162=$1825;
      var $43163=$1826;
      var $43164=$result_i1143;
      var $43165=$1827;
      var $43166=$1828;
      HEAP32[(($1824)>>2)]=408;
      HEAP32[(($1825)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1826)>>2)]=659;
      var $43167=HEAP32[(($1824)>>2)];
      var $43168=HEAP32[(($1825)>>2)];
      var $43169=HEAP32[(($1826)>>2)];
      var $43170=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43167, $43168, $43169) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11457; break; } else { __label__ = 11459; break; };
    case 11457: // $43171
      HEAP32[(($result_i1143)>>2)]=$43170;
      var $43172=HEAP32[(($result_i1143)>>2)];
      var $43173=(($43172)|0)==0;
      if ($43173) { __label__ = 11458; break; } else { __label__ = 11463; break; }
    case 11458: // $43174
      var $43175=___cxa_allocate_exception(4);
      var $43176=$43175;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43176);
      (function() { try { __THREW__ = false; return ___cxa_throw($43175, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11462; break; } else { __label__ = 11459; break; }
    case 11459: // $43177
      var $43178=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43179=$43178.f0;
      HEAP32[(($1827)>>2)]=$43179;
      var $43180=$43178.f1;
      HEAP32[(($1828)>>2)]=$43180;
      var $43181=HEAP32[(($1828)>>2)];
      var $43182=(($43181)|0) < 0;
      if ($43182) { __label__ = 11460; break; } else { __label__ = 11461; break; }
    case 11460: // $43183
      var $43184=HEAP32[(($1827)>>2)];
      ___cxa_call_unexpected($43184);
      throw "Reached an unreachable!"
    case 11461: // $43185
      var $43186=HEAP32[(($1827)>>2)];
      var $43187=HEAP32[(($1827)>>2)];
      var $43188=HEAP32[(($1828)>>2)];
      var $43189=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43187, tempValue);
      var $43190=($43189.f1 = $43188, $43189);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11462: // $43191
      throw "Reached an unreachable!"
    case 11463: // $_ZnwjPKci_exit1144
      var $43192=HEAP32[(($result_i1143)>>2)];
      var $43193=$1824;
      var $43194=$1825;
      var $43195=$1826;
      var $43196=$result_i1143;
      var $43197=$1827;
      var $43198=$1828;
      var $43199=$43192;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11573, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11464; break; } else { __label__ = 14541; break; }
    case 11464: // $43200
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11574, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11465; break; } else { __label__ = 14541; break; }
    case 11465: // $43201
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11575, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11466; break; } else { __label__ = 14541; break; }
    case 11466: // $43202
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11576, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11467; break; } else { __label__ = 14541; break; }
    case 11467: // $43203
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11577, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11468; break; } else { __label__ = 14541; break; }
    case 11468: // $43204
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11578, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11469; break; } else { __label__ = 14541; break; }
    case 11469: // $43205
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11579, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11470; break; } else { __label__ = 14541; break; }
    case 11470: // $43206
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11572, $11573, $11574, $11575, $11576, $11577, $11578, $11579) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11471; break; } else { __label__ = 14541; break; }
    case 11471: // $43207
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43199, 207, 0, 0, ((STRING_TABLE.__str1323)|0), 0, $11572) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11472; break; } else { __label__ = 14541; break; }
    case 11472: // $43208
      var $43209=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43199);
      var $43210=__ZN11simple_listI16input_type_entryE6appendERS0_($43160, $43209);
      var $43211=$4689;
      var $43212=$1819;
      var $43213=$1820;
      var $43214=$1821;
      var $43215=$result_i1145;
      var $43216=$1822;
      var $43217=$1823;
      HEAP32[(($1819)>>2)]=408;
      HEAP32[(($1820)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1821)>>2)]=660;
      var $43218=HEAP32[(($1819)>>2)];
      var $43219=HEAP32[(($1820)>>2)];
      var $43220=HEAP32[(($1821)>>2)];
      var $43221=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43218, $43219, $43220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11473; break; } else { __label__ = 11475; break; };
    case 11473: // $43222
      HEAP32[(($result_i1145)>>2)]=$43221;
      var $43223=HEAP32[(($result_i1145)>>2)];
      var $43224=(($43223)|0)==0;
      if ($43224) { __label__ = 11474; break; } else { __label__ = 11479; break; }
    case 11474: // $43225
      var $43226=___cxa_allocate_exception(4);
      var $43227=$43226;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43227);
      (function() { try { __THREW__ = false; return ___cxa_throw($43226, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11478; break; } else { __label__ = 11475; break; }
    case 11475: // $43228
      var $43229=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43230=$43229.f0;
      HEAP32[(($1822)>>2)]=$43230;
      var $43231=$43229.f1;
      HEAP32[(($1823)>>2)]=$43231;
      var $43232=HEAP32[(($1823)>>2)];
      var $43233=(($43232)|0) < 0;
      if ($43233) { __label__ = 11476; break; } else { __label__ = 11477; break; }
    case 11476: // $43234
      var $43235=HEAP32[(($1822)>>2)];
      ___cxa_call_unexpected($43235);
      throw "Reached an unreachable!"
    case 11477: // $43236
      var $43237=HEAP32[(($1822)>>2)];
      var $43238=HEAP32[(($1822)>>2)];
      var $43239=HEAP32[(($1823)>>2)];
      var $43240=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43238, tempValue);
      var $43241=($43240.f1 = $43239, $43240);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11478: // $43242
      throw "Reached an unreachable!"
    case 11479: // $_ZnwjPKci_exit1146
      var $43243=HEAP32[(($result_i1145)>>2)];
      var $43244=$1819;
      var $43245=$1820;
      var $43246=$1821;
      var $43247=$result_i1145;
      var $43248=$1822;
      var $43249=$1823;
      var $43250=$43243;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11581, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11480; break; } else { __label__ = 14546; break; }
    case 11480: // $43251
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11582, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11481; break; } else { __label__ = 14546; break; }
    case 11481: // $43252
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11583, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11482; break; } else { __label__ = 14546; break; }
    case 11482: // $43253
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11584, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11483; break; } else { __label__ = 14546; break; }
    case 11483: // $43254
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11585, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11484; break; } else { __label__ = 14546; break; }
    case 11484: // $43255
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11586, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11485; break; } else { __label__ = 14546; break; }
    case 11485: // $43256
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11587, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11486; break; } else { __label__ = 14546; break; }
    case 11486: // $43257
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11580, $11581, $11582, $11583, $11584, $11585, $11586, $11587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11487; break; } else { __label__ = 14546; break; }
    case 11487: // $43258
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43250, 208, 0, 0, ((STRING_TABLE.__str1324)|0), 0, $11580) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11488; break; } else { __label__ = 14546; break; }
    case 11488: // $43259
      var $43260=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43250);
      var $43261=__ZN11simple_listI16input_type_entryE6appendERS0_($43211, $43260);
      var $43262=$4689;
      var $43263=$1814;
      var $43264=$1815;
      var $43265=$1816;
      var $43266=$result_i1147;
      var $43267=$1817;
      var $43268=$1818;
      HEAP32[(($1814)>>2)]=408;
      HEAP32[(($1815)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1816)>>2)]=661;
      var $43269=HEAP32[(($1814)>>2)];
      var $43270=HEAP32[(($1815)>>2)];
      var $43271=HEAP32[(($1816)>>2)];
      var $43272=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43269, $43270, $43271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11489; break; } else { __label__ = 11491; break; };
    case 11489: // $43273
      HEAP32[(($result_i1147)>>2)]=$43272;
      var $43274=HEAP32[(($result_i1147)>>2)];
      var $43275=(($43274)|0)==0;
      if ($43275) { __label__ = 11490; break; } else { __label__ = 11495; break; }
    case 11490: // $43276
      var $43277=___cxa_allocate_exception(4);
      var $43278=$43277;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43278);
      (function() { try { __THREW__ = false; return ___cxa_throw($43277, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11494; break; } else { __label__ = 11491; break; }
    case 11491: // $43279
      var $43280=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43281=$43280.f0;
      HEAP32[(($1817)>>2)]=$43281;
      var $43282=$43280.f1;
      HEAP32[(($1818)>>2)]=$43282;
      var $43283=HEAP32[(($1818)>>2)];
      var $43284=(($43283)|0) < 0;
      if ($43284) { __label__ = 11492; break; } else { __label__ = 11493; break; }
    case 11492: // $43285
      var $43286=HEAP32[(($1817)>>2)];
      ___cxa_call_unexpected($43286);
      throw "Reached an unreachable!"
    case 11493: // $43287
      var $43288=HEAP32[(($1817)>>2)];
      var $43289=HEAP32[(($1817)>>2)];
      var $43290=HEAP32[(($1818)>>2)];
      var $43291=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43289, tempValue);
      var $43292=($43291.f1 = $43290, $43291);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11494: // $43293
      throw "Reached an unreachable!"
    case 11495: // $_ZnwjPKci_exit1148
      var $43294=HEAP32[(($result_i1147)>>2)];
      var $43295=$1814;
      var $43296=$1815;
      var $43297=$1816;
      var $43298=$result_i1147;
      var $43299=$1817;
      var $43300=$1818;
      var $43301=$43294;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11589, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11496; break; } else { __label__ = 14551; break; }
    case 11496: // $43302
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11590, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11497; break; } else { __label__ = 14551; break; }
    case 11497: // $43303
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11591, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11498; break; } else { __label__ = 14551; break; }
    case 11498: // $43304
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11592, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11499; break; } else { __label__ = 14551; break; }
    case 11499: // $43305
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11593, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11500; break; } else { __label__ = 14551; break; }
    case 11500: // $43306
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11594, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11501; break; } else { __label__ = 14551; break; }
    case 11501: // $43307
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11595, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11502; break; } else { __label__ = 14551; break; }
    case 11502: // $43308
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11588, $11589, $11590, $11591, $11592, $11593, $11594, $11595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11503; break; } else { __label__ = 14551; break; }
    case 11503: // $43309
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43301, 209, 0, 0, ((STRING_TABLE.__str1325)|0), 0, $11588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11504; break; } else { __label__ = 14551; break; }
    case 11504: // $43310
      var $43311=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43301);
      var $43312=__ZN11simple_listI16input_type_entryE6appendERS0_($43262, $43311);
      var $43313=$4689;
      var $43314=$1809;
      var $43315=$1810;
      var $43316=$1811;
      var $43317=$result_i1149;
      var $43318=$1812;
      var $43319=$1813;
      HEAP32[(($1809)>>2)]=408;
      HEAP32[(($1810)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1811)>>2)]=662;
      var $43320=HEAP32[(($1809)>>2)];
      var $43321=HEAP32[(($1810)>>2)];
      var $43322=HEAP32[(($1811)>>2)];
      var $43323=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43320, $43321, $43322) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11505; break; } else { __label__ = 11507; break; };
    case 11505: // $43324
      HEAP32[(($result_i1149)>>2)]=$43323;
      var $43325=HEAP32[(($result_i1149)>>2)];
      var $43326=(($43325)|0)==0;
      if ($43326) { __label__ = 11506; break; } else { __label__ = 11511; break; }
    case 11506: // $43327
      var $43328=___cxa_allocate_exception(4);
      var $43329=$43328;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43329);
      (function() { try { __THREW__ = false; return ___cxa_throw($43328, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11510; break; } else { __label__ = 11507; break; }
    case 11507: // $43330
      var $43331=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43332=$43331.f0;
      HEAP32[(($1812)>>2)]=$43332;
      var $43333=$43331.f1;
      HEAP32[(($1813)>>2)]=$43333;
      var $43334=HEAP32[(($1813)>>2)];
      var $43335=(($43334)|0) < 0;
      if ($43335) { __label__ = 11508; break; } else { __label__ = 11509; break; }
    case 11508: // $43336
      var $43337=HEAP32[(($1812)>>2)];
      ___cxa_call_unexpected($43337);
      throw "Reached an unreachable!"
    case 11509: // $43338
      var $43339=HEAP32[(($1812)>>2)];
      var $43340=HEAP32[(($1812)>>2)];
      var $43341=HEAP32[(($1813)>>2)];
      var $43342=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43340, tempValue);
      var $43343=($43342.f1 = $43341, $43342);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11510: // $43344
      throw "Reached an unreachable!"
    case 11511: // $_ZnwjPKci_exit1150
      var $43345=HEAP32[(($result_i1149)>>2)];
      var $43346=$1809;
      var $43347=$1810;
      var $43348=$1811;
      var $43349=$result_i1149;
      var $43350=$1812;
      var $43351=$1813;
      var $43352=$43345;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11597, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11512; break; } else { __label__ = 14556; break; }
    case 11512: // $43353
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11598, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11513; break; } else { __label__ = 14556; break; }
    case 11513: // $43354
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11599, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11514; break; } else { __label__ = 14556; break; }
    case 11514: // $43355
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11600, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11515; break; } else { __label__ = 14556; break; }
    case 11515: // $43356
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11601, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11516; break; } else { __label__ = 14556; break; }
    case 11516: // $43357
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11602, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11517; break; } else { __label__ = 14556; break; }
    case 11517: // $43358
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11603, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11518; break; } else { __label__ = 14556; break; }
    case 11518: // $43359
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11596, $11597, $11598, $11599, $11600, $11601, $11602, $11603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11519; break; } else { __label__ = 14556; break; }
    case 11519: // $43360
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43352, 210, 0, 0, ((STRING_TABLE.__str1326)|0), 0, $11596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11520; break; } else { __label__ = 14556; break; }
    case 11520: // $43361
      var $43362=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43352);
      var $43363=__ZN11simple_listI16input_type_entryE6appendERS0_($43313, $43362);
      var $43364=$4689;
      var $43365=$1804;
      var $43366=$1805;
      var $43367=$1806;
      var $43368=$result_i1151;
      var $43369=$1807;
      var $43370=$1808;
      HEAP32[(($1804)>>2)]=408;
      HEAP32[(($1805)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1806)>>2)]=663;
      var $43371=HEAP32[(($1804)>>2)];
      var $43372=HEAP32[(($1805)>>2)];
      var $43373=HEAP32[(($1806)>>2)];
      var $43374=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43371, $43372, $43373) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11521; break; } else { __label__ = 11523; break; };
    case 11521: // $43375
      HEAP32[(($result_i1151)>>2)]=$43374;
      var $43376=HEAP32[(($result_i1151)>>2)];
      var $43377=(($43376)|0)==0;
      if ($43377) { __label__ = 11522; break; } else { __label__ = 11527; break; }
    case 11522: // $43378
      var $43379=___cxa_allocate_exception(4);
      var $43380=$43379;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43380);
      (function() { try { __THREW__ = false; return ___cxa_throw($43379, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11526; break; } else { __label__ = 11523; break; }
    case 11523: // $43381
      var $43382=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43383=$43382.f0;
      HEAP32[(($1807)>>2)]=$43383;
      var $43384=$43382.f1;
      HEAP32[(($1808)>>2)]=$43384;
      var $43385=HEAP32[(($1808)>>2)];
      var $43386=(($43385)|0) < 0;
      if ($43386) { __label__ = 11524; break; } else { __label__ = 11525; break; }
    case 11524: // $43387
      var $43388=HEAP32[(($1807)>>2)];
      ___cxa_call_unexpected($43388);
      throw "Reached an unreachable!"
    case 11525: // $43389
      var $43390=HEAP32[(($1807)>>2)];
      var $43391=HEAP32[(($1807)>>2)];
      var $43392=HEAP32[(($1808)>>2)];
      var $43393=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43391, tempValue);
      var $43394=($43393.f1 = $43392, $43393);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11526: // $43395
      throw "Reached an unreachable!"
    case 11527: // $_ZnwjPKci_exit1152
      var $43396=HEAP32[(($result_i1151)>>2)];
      var $43397=$1804;
      var $43398=$1805;
      var $43399=$1806;
      var $43400=$result_i1151;
      var $43401=$1807;
      var $43402=$1808;
      var $43403=$43396;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11605, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11528; break; } else { __label__ = 14561; break; }
    case 11528: // $43404
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11606, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11529; break; } else { __label__ = 14561; break; }
    case 11529: // $43405
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11607, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11530; break; } else { __label__ = 14561; break; }
    case 11530: // $43406
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11608, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11531; break; } else { __label__ = 14561; break; }
    case 11531: // $43407
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11609, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11532; break; } else { __label__ = 14561; break; }
    case 11532: // $43408
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11610, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11533; break; } else { __label__ = 14561; break; }
    case 11533: // $43409
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11611, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11534; break; } else { __label__ = 14561; break; }
    case 11534: // $43410
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11604, $11605, $11606, $11607, $11608, $11609, $11610, $11611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11535; break; } else { __label__ = 14561; break; }
    case 11535: // $43411
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43403, 211, 0, 0, ((STRING_TABLE.__str1327)|0), 0, $11604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11536; break; } else { __label__ = 14561; break; }
    case 11536: // $43412
      var $43413=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43403);
      var $43414=__ZN11simple_listI16input_type_entryE6appendERS0_($43364, $43413);
      var $43415=$4689;
      var $43416=$1799;
      var $43417=$1800;
      var $43418=$1801;
      var $43419=$result_i1153;
      var $43420=$1802;
      var $43421=$1803;
      HEAP32[(($1799)>>2)]=408;
      HEAP32[(($1800)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1801)>>2)]=664;
      var $43422=HEAP32[(($1799)>>2)];
      var $43423=HEAP32[(($1800)>>2)];
      var $43424=HEAP32[(($1801)>>2)];
      var $43425=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43422, $43423, $43424) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11537; break; } else { __label__ = 11539; break; };
    case 11537: // $43426
      HEAP32[(($result_i1153)>>2)]=$43425;
      var $43427=HEAP32[(($result_i1153)>>2)];
      var $43428=(($43427)|0)==0;
      if ($43428) { __label__ = 11538; break; } else { __label__ = 11543; break; }
    case 11538: // $43429
      var $43430=___cxa_allocate_exception(4);
      var $43431=$43430;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43431);
      (function() { try { __THREW__ = false; return ___cxa_throw($43430, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11542; break; } else { __label__ = 11539; break; }
    case 11539: // $43432
      var $43433=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43434=$43433.f0;
      HEAP32[(($1802)>>2)]=$43434;
      var $43435=$43433.f1;
      HEAP32[(($1803)>>2)]=$43435;
      var $43436=HEAP32[(($1803)>>2)];
      var $43437=(($43436)|0) < 0;
      if ($43437) { __label__ = 11540; break; } else { __label__ = 11541; break; }
    case 11540: // $43438
      var $43439=HEAP32[(($1802)>>2)];
      ___cxa_call_unexpected($43439);
      throw "Reached an unreachable!"
    case 11541: // $43440
      var $43441=HEAP32[(($1802)>>2)];
      var $43442=HEAP32[(($1802)>>2)];
      var $43443=HEAP32[(($1803)>>2)];
      var $43444=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43442, tempValue);
      var $43445=($43444.f1 = $43443, $43444);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11542: // $43446
      throw "Reached an unreachable!"
    case 11543: // $_ZnwjPKci_exit1154
      var $43447=HEAP32[(($result_i1153)>>2)];
      var $43448=$1799;
      var $43449=$1800;
      var $43450=$1801;
      var $43451=$result_i1153;
      var $43452=$1802;
      var $43453=$1803;
      var $43454=$43447;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11613, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11544; break; } else { __label__ = 14566; break; }
    case 11544: // $43455
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11614, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11545; break; } else { __label__ = 14566; break; }
    case 11545: // $43456
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11615, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11546; break; } else { __label__ = 14566; break; }
    case 11546: // $43457
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11616, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11547; break; } else { __label__ = 14566; break; }
    case 11547: // $43458
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11617, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11548; break; } else { __label__ = 14566; break; }
    case 11548: // $43459
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11618, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11549; break; } else { __label__ = 14566; break; }
    case 11549: // $43460
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11619, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11550; break; } else { __label__ = 14566; break; }
    case 11550: // $43461
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11612, $11613, $11614, $11615, $11616, $11617, $11618, $11619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11551; break; } else { __label__ = 14566; break; }
    case 11551: // $43462
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43454, 212, 0, 0, ((STRING_TABLE.__str1328)|0), 0, $11612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11552; break; } else { __label__ = 14566; break; }
    case 11552: // $43463
      var $43464=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43454);
      var $43465=__ZN11simple_listI16input_type_entryE6appendERS0_($43415, $43464);
      var $43466=$4689;
      var $43467=$1794;
      var $43468=$1795;
      var $43469=$1796;
      var $43470=$result_i1155;
      var $43471=$1797;
      var $43472=$1798;
      HEAP32[(($1794)>>2)]=408;
      HEAP32[(($1795)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1796)>>2)]=665;
      var $43473=HEAP32[(($1794)>>2)];
      var $43474=HEAP32[(($1795)>>2)];
      var $43475=HEAP32[(($1796)>>2)];
      var $43476=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43473, $43474, $43475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11553; break; } else { __label__ = 11555; break; };
    case 11553: // $43477
      HEAP32[(($result_i1155)>>2)]=$43476;
      var $43478=HEAP32[(($result_i1155)>>2)];
      var $43479=(($43478)|0)==0;
      if ($43479) { __label__ = 11554; break; } else { __label__ = 11559; break; }
    case 11554: // $43480
      var $43481=___cxa_allocate_exception(4);
      var $43482=$43481;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43482);
      (function() { try { __THREW__ = false; return ___cxa_throw($43481, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11558; break; } else { __label__ = 11555; break; }
    case 11555: // $43483
      var $43484=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43485=$43484.f0;
      HEAP32[(($1797)>>2)]=$43485;
      var $43486=$43484.f1;
      HEAP32[(($1798)>>2)]=$43486;
      var $43487=HEAP32[(($1798)>>2)];
      var $43488=(($43487)|0) < 0;
      if ($43488) { __label__ = 11556; break; } else { __label__ = 11557; break; }
    case 11556: // $43489
      var $43490=HEAP32[(($1797)>>2)];
      ___cxa_call_unexpected($43490);
      throw "Reached an unreachable!"
    case 11557: // $43491
      var $43492=HEAP32[(($1797)>>2)];
      var $43493=HEAP32[(($1797)>>2)];
      var $43494=HEAP32[(($1798)>>2)];
      var $43495=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43493, tempValue);
      var $43496=($43495.f1 = $43494, $43495);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11558: // $43497
      throw "Reached an unreachable!"
    case 11559: // $_ZnwjPKci_exit1156
      var $43498=HEAP32[(($result_i1155)>>2)];
      var $43499=$1794;
      var $43500=$1795;
      var $43501=$1796;
      var $43502=$result_i1155;
      var $43503=$1797;
      var $43504=$1798;
      var $43505=$43498;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11621, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11560; break; } else { __label__ = 14571; break; }
    case 11560: // $43506
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11622, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11561; break; } else { __label__ = 14571; break; }
    case 11561: // $43507
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11623, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11562; break; } else { __label__ = 14571; break; }
    case 11562: // $43508
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11624, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11563; break; } else { __label__ = 14571; break; }
    case 11563: // $43509
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11625, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11564; break; } else { __label__ = 14571; break; }
    case 11564: // $43510
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11626, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11565; break; } else { __label__ = 14571; break; }
    case 11565: // $43511
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11627, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11566; break; } else { __label__ = 14571; break; }
    case 11566: // $43512
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11620, $11621, $11622, $11623, $11624, $11625, $11626, $11627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11567; break; } else { __label__ = 14571; break; }
    case 11567: // $43513
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43505, 3, 11, 0, ((STRING_TABLE.__str1329)|0), 0, $11620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11568; break; } else { __label__ = 14571; break; }
    case 11568: // $43514
      var $43515=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43505);
      var $43516=__ZN11simple_listI16input_type_entryE6appendERS0_($43466, $43515);
      var $43517=$4689;
      var $43518=$1789;
      var $43519=$1790;
      var $43520=$1791;
      var $43521=$result_i1157;
      var $43522=$1792;
      var $43523=$1793;
      HEAP32[(($1789)>>2)]=408;
      HEAP32[(($1790)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1791)>>2)]=666;
      var $43524=HEAP32[(($1789)>>2)];
      var $43525=HEAP32[(($1790)>>2)];
      var $43526=HEAP32[(($1791)>>2)];
      var $43527=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43524, $43525, $43526) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11569; break; } else { __label__ = 11571; break; };
    case 11569: // $43528
      HEAP32[(($result_i1157)>>2)]=$43527;
      var $43529=HEAP32[(($result_i1157)>>2)];
      var $43530=(($43529)|0)==0;
      if ($43530) { __label__ = 11570; break; } else { __label__ = 11575; break; }
    case 11570: // $43531
      var $43532=___cxa_allocate_exception(4);
      var $43533=$43532;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43533);
      (function() { try { __THREW__ = false; return ___cxa_throw($43532, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11574; break; } else { __label__ = 11571; break; }
    case 11571: // $43534
      var $43535=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43536=$43535.f0;
      HEAP32[(($1792)>>2)]=$43536;
      var $43537=$43535.f1;
      HEAP32[(($1793)>>2)]=$43537;
      var $43538=HEAP32[(($1793)>>2)];
      var $43539=(($43538)|0) < 0;
      if ($43539) { __label__ = 11572; break; } else { __label__ = 11573; break; }
    case 11572: // $43540
      var $43541=HEAP32[(($1792)>>2)];
      ___cxa_call_unexpected($43541);
      throw "Reached an unreachable!"
    case 11573: // $43542
      var $43543=HEAP32[(($1792)>>2)];
      var $43544=HEAP32[(($1792)>>2)];
      var $43545=HEAP32[(($1793)>>2)];
      var $43546=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43544, tempValue);
      var $43547=($43546.f1 = $43545, $43546);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11574: // $43548
      throw "Reached an unreachable!"
    case 11575: // $_ZnwjPKci_exit1158
      var $43549=HEAP32[(($result_i1157)>>2)];
      var $43550=$1789;
      var $43551=$1790;
      var $43552=$1791;
      var $43553=$result_i1157;
      var $43554=$1792;
      var $43555=$1793;
      var $43556=$43549;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11629, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11576; break; } else { __label__ = 14576; break; }
    case 11576: // $43557
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11630, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11577; break; } else { __label__ = 14576; break; }
    case 11577: // $43558
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11631, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11578; break; } else { __label__ = 14576; break; }
    case 11578: // $43559
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11632, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11579; break; } else { __label__ = 14576; break; }
    case 11579: // $43560
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11633, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11580; break; } else { __label__ = 14576; break; }
    case 11580: // $43561
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11634, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11581; break; } else { __label__ = 14576; break; }
    case 11581: // $43562
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11635, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11582; break; } else { __label__ = 14576; break; }
    case 11582: // $43563
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11628, $11629, $11630, $11631, $11632, $11633, $11634, $11635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11583; break; } else { __label__ = 14576; break; }
    case 11583: // $43564
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43556, 1, 11, 0, ((STRING_TABLE.__str1330)|0), 0, $11628) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11584; break; } else { __label__ = 14576; break; }
    case 11584: // $43565
      var $43566=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43556);
      var $43567=__ZN11simple_listI16input_type_entryE6appendERS0_($43517, $43566);
      var $43568=$4689;
      var $43569=$1784;
      var $43570=$1785;
      var $43571=$1786;
      var $43572=$result_i1159;
      var $43573=$1787;
      var $43574=$1788;
      HEAP32[(($1784)>>2)]=408;
      HEAP32[(($1785)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1786)>>2)]=667;
      var $43575=HEAP32[(($1784)>>2)];
      var $43576=HEAP32[(($1785)>>2)];
      var $43577=HEAP32[(($1786)>>2)];
      var $43578=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43575, $43576, $43577) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11585; break; } else { __label__ = 11587; break; };
    case 11585: // $43579
      HEAP32[(($result_i1159)>>2)]=$43578;
      var $43580=HEAP32[(($result_i1159)>>2)];
      var $43581=(($43580)|0)==0;
      if ($43581) { __label__ = 11586; break; } else { __label__ = 11591; break; }
    case 11586: // $43582
      var $43583=___cxa_allocate_exception(4);
      var $43584=$43583;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43584);
      (function() { try { __THREW__ = false; return ___cxa_throw($43583, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11590; break; } else { __label__ = 11587; break; }
    case 11587: // $43585
      var $43586=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43587=$43586.f0;
      HEAP32[(($1787)>>2)]=$43587;
      var $43588=$43586.f1;
      HEAP32[(($1788)>>2)]=$43588;
      var $43589=HEAP32[(($1788)>>2)];
      var $43590=(($43589)|0) < 0;
      if ($43590) { __label__ = 11588; break; } else { __label__ = 11589; break; }
    case 11588: // $43591
      var $43592=HEAP32[(($1787)>>2)];
      ___cxa_call_unexpected($43592);
      throw "Reached an unreachable!"
    case 11589: // $43593
      var $43594=HEAP32[(($1787)>>2)];
      var $43595=HEAP32[(($1787)>>2)];
      var $43596=HEAP32[(($1788)>>2)];
      var $43597=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43595, tempValue);
      var $43598=($43597.f1 = $43596, $43597);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11590: // $43599
      throw "Reached an unreachable!"
    case 11591: // $_ZnwjPKci_exit1160
      var $43600=HEAP32[(($result_i1159)>>2)];
      var $43601=$1784;
      var $43602=$1785;
      var $43603=$1786;
      var $43604=$result_i1159;
      var $43605=$1787;
      var $43606=$1788;
      var $43607=$43600;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11637, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11592; break; } else { __label__ = 14581; break; }
    case 11592: // $43608
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11638, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11593; break; } else { __label__ = 14581; break; }
    case 11593: // $43609
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11639, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11594; break; } else { __label__ = 14581; break; }
    case 11594: // $43610
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11640, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11595; break; } else { __label__ = 14581; break; }
    case 11595: // $43611
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11641, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11596; break; } else { __label__ = 14581; break; }
    case 11596: // $43612
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11642, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11597; break; } else { __label__ = 14581; break; }
    case 11597: // $43613
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11643, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11598; break; } else { __label__ = 14581; break; }
    case 11598: // $43614
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11636, $11637, $11638, $11639, $11640, $11641, $11642, $11643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11599; break; } else { __label__ = 14581; break; }
    case 11599: // $43615
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43607, 214, 11, 0, ((STRING_TABLE.__str1331)|0), 0, $11636) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11600; break; } else { __label__ = 14581; break; }
    case 11600: // $43616
      var $43617=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43607);
      var $43618=__ZN11simple_listI16input_type_entryE6appendERS0_($43568, $43617);
      var $43619=$4689;
      var $43620=$1779;
      var $43621=$1780;
      var $43622=$1781;
      var $43623=$result_i1161;
      var $43624=$1782;
      var $43625=$1783;
      HEAP32[(($1779)>>2)]=408;
      HEAP32[(($1780)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1781)>>2)]=668;
      var $43626=HEAP32[(($1779)>>2)];
      var $43627=HEAP32[(($1780)>>2)];
      var $43628=HEAP32[(($1781)>>2)];
      var $43629=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43626, $43627, $43628) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11601; break; } else { __label__ = 11603; break; };
    case 11601: // $43630
      HEAP32[(($result_i1161)>>2)]=$43629;
      var $43631=HEAP32[(($result_i1161)>>2)];
      var $43632=(($43631)|0)==0;
      if ($43632) { __label__ = 11602; break; } else { __label__ = 11607; break; }
    case 11602: // $43633
      var $43634=___cxa_allocate_exception(4);
      var $43635=$43634;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43635);
      (function() { try { __THREW__ = false; return ___cxa_throw($43634, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11606; break; } else { __label__ = 11603; break; }
    case 11603: // $43636
      var $43637=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43638=$43637.f0;
      HEAP32[(($1782)>>2)]=$43638;
      var $43639=$43637.f1;
      HEAP32[(($1783)>>2)]=$43639;
      var $43640=HEAP32[(($1783)>>2)];
      var $43641=(($43640)|0) < 0;
      if ($43641) { __label__ = 11604; break; } else { __label__ = 11605; break; }
    case 11604: // $43642
      var $43643=HEAP32[(($1782)>>2)];
      ___cxa_call_unexpected($43643);
      throw "Reached an unreachable!"
    case 11605: // $43644
      var $43645=HEAP32[(($1782)>>2)];
      var $43646=HEAP32[(($1782)>>2)];
      var $43647=HEAP32[(($1783)>>2)];
      var $43648=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43646, tempValue);
      var $43649=($43648.f1 = $43647, $43648);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11606: // $43650
      throw "Reached an unreachable!"
    case 11607: // $_ZnwjPKci_exit1162
      var $43651=HEAP32[(($result_i1161)>>2)];
      var $43652=$1779;
      var $43653=$1780;
      var $43654=$1781;
      var $43655=$result_i1161;
      var $43656=$1782;
      var $43657=$1783;
      var $43658=$43651;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11645, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11608; break; } else { __label__ = 14586; break; }
    case 11608: // $43659
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11646, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11609; break; } else { __label__ = 14586; break; }
    case 11609: // $43660
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11647, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11610; break; } else { __label__ = 14586; break; }
    case 11610: // $43661
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11648, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11611; break; } else { __label__ = 14586; break; }
    case 11611: // $43662
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11649, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11612; break; } else { __label__ = 14586; break; }
    case 11612: // $43663
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11650, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11613; break; } else { __label__ = 14586; break; }
    case 11613: // $43664
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11651, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11614; break; } else { __label__ = 14586; break; }
    case 11614: // $43665
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11644, $11645, $11646, $11647, $11648, $11649, $11650, $11651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11615; break; } else { __label__ = 14586; break; }
    case 11615: // $43666
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43658, 213, 11, 0, ((STRING_TABLE.__str1332)|0), 0, $11644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11616; break; } else { __label__ = 14586; break; }
    case 11616: // $43667
      var $43668=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43658);
      var $43669=__ZN11simple_listI16input_type_entryE6appendERS0_($43619, $43668);
      var $43670=$4689;
      var $43671=$1774;
      var $43672=$1775;
      var $43673=$1776;
      var $43674=$result_i1163;
      var $43675=$1777;
      var $43676=$1778;
      HEAP32[(($1774)>>2)]=408;
      HEAP32[(($1775)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1776)>>2)]=669;
      var $43677=HEAP32[(($1774)>>2)];
      var $43678=HEAP32[(($1775)>>2)];
      var $43679=HEAP32[(($1776)>>2)];
      var $43680=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43677, $43678, $43679) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11617; break; } else { __label__ = 11619; break; };
    case 11617: // $43681
      HEAP32[(($result_i1163)>>2)]=$43680;
      var $43682=HEAP32[(($result_i1163)>>2)];
      var $43683=(($43682)|0)==0;
      if ($43683) { __label__ = 11618; break; } else { __label__ = 11623; break; }
    case 11618: // $43684
      var $43685=___cxa_allocate_exception(4);
      var $43686=$43685;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43686);
      (function() { try { __THREW__ = false; return ___cxa_throw($43685, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11622; break; } else { __label__ = 11619; break; }
    case 11619: // $43687
      var $43688=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43689=$43688.f0;
      HEAP32[(($1777)>>2)]=$43689;
      var $43690=$43688.f1;
      HEAP32[(($1778)>>2)]=$43690;
      var $43691=HEAP32[(($1778)>>2)];
      var $43692=(($43691)|0) < 0;
      if ($43692) { __label__ = 11620; break; } else { __label__ = 11621; break; }
    case 11620: // $43693
      var $43694=HEAP32[(($1777)>>2)];
      ___cxa_call_unexpected($43694);
      throw "Reached an unreachable!"
    case 11621: // $43695
      var $43696=HEAP32[(($1777)>>2)];
      var $43697=HEAP32[(($1777)>>2)];
      var $43698=HEAP32[(($1778)>>2)];
      var $43699=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43697, tempValue);
      var $43700=($43699.f1 = $43698, $43699);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11622: // $43701
      throw "Reached an unreachable!"
    case 11623: // $_ZnwjPKci_exit1164
      var $43702=HEAP32[(($result_i1163)>>2)];
      var $43703=$1774;
      var $43704=$1775;
      var $43705=$1776;
      var $43706=$result_i1163;
      var $43707=$1777;
      var $43708=$1778;
      var $43709=$43702;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11653, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11624; break; } else { __label__ = 14591; break; }
    case 11624: // $43710
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11654, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11625; break; } else { __label__ = 14591; break; }
    case 11625: // $43711
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11655, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11626; break; } else { __label__ = 14591; break; }
    case 11626: // $43712
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11656, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11627; break; } else { __label__ = 14591; break; }
    case 11627: // $43713
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11657, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11628; break; } else { __label__ = 14591; break; }
    case 11628: // $43714
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11658, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11629; break; } else { __label__ = 14591; break; }
    case 11629: // $43715
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11659, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11630; break; } else { __label__ = 14591; break; }
    case 11630: // $43716
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11652, $11653, $11654, $11655, $11656, $11657, $11658, $11659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11631; break; } else { __label__ = 14591; break; }
    case 11631: // $43717
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43709, 158, 11, 0, ((STRING_TABLE.__str1333)|0), 0, $11652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11632; break; } else { __label__ = 14591; break; }
    case 11632: // $43718
      var $43719=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43709);
      var $43720=__ZN11simple_listI16input_type_entryE6appendERS0_($43670, $43719);
      var $43721=$4689;
      var $43722=$1769;
      var $43723=$1770;
      var $43724=$1771;
      var $43725=$result_i1165;
      var $43726=$1772;
      var $43727=$1773;
      HEAP32[(($1769)>>2)]=408;
      HEAP32[(($1770)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1771)>>2)]=670;
      var $43728=HEAP32[(($1769)>>2)];
      var $43729=HEAP32[(($1770)>>2)];
      var $43730=HEAP32[(($1771)>>2)];
      var $43731=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43728, $43729, $43730) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11633; break; } else { __label__ = 11635; break; };
    case 11633: // $43732
      HEAP32[(($result_i1165)>>2)]=$43731;
      var $43733=HEAP32[(($result_i1165)>>2)];
      var $43734=(($43733)|0)==0;
      if ($43734) { __label__ = 11634; break; } else { __label__ = 11639; break; }
    case 11634: // $43735
      var $43736=___cxa_allocate_exception(4);
      var $43737=$43736;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43737);
      (function() { try { __THREW__ = false; return ___cxa_throw($43736, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11638; break; } else { __label__ = 11635; break; }
    case 11635: // $43738
      var $43739=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43740=$43739.f0;
      HEAP32[(($1772)>>2)]=$43740;
      var $43741=$43739.f1;
      HEAP32[(($1773)>>2)]=$43741;
      var $43742=HEAP32[(($1773)>>2)];
      var $43743=(($43742)|0) < 0;
      if ($43743) { __label__ = 11636; break; } else { __label__ = 11637; break; }
    case 11636: // $43744
      var $43745=HEAP32[(($1772)>>2)];
      ___cxa_call_unexpected($43745);
      throw "Reached an unreachable!"
    case 11637: // $43746
      var $43747=HEAP32[(($1772)>>2)];
      var $43748=HEAP32[(($1772)>>2)];
      var $43749=HEAP32[(($1773)>>2)];
      var $43750=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43748, tempValue);
      var $43751=($43750.f1 = $43749, $43750);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11638: // $43752
      throw "Reached an unreachable!"
    case 11639: // $_ZnwjPKci_exit1166
      var $43753=HEAP32[(($result_i1165)>>2)];
      var $43754=$1769;
      var $43755=$1770;
      var $43756=$1771;
      var $43757=$result_i1165;
      var $43758=$1772;
      var $43759=$1773;
      var $43760=$43753;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11661, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11640; break; } else { __label__ = 14596; break; }
    case 11640: // $43761
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11662, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11641; break; } else { __label__ = 14596; break; }
    case 11641: // $43762
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11663, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11642; break; } else { __label__ = 14596; break; }
    case 11642: // $43763
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11664, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11643; break; } else { __label__ = 14596; break; }
    case 11643: // $43764
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11665, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11644; break; } else { __label__ = 14596; break; }
    case 11644: // $43765
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11666, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11645; break; } else { __label__ = 14596; break; }
    case 11645: // $43766
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11667, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11646; break; } else { __label__ = 14596; break; }
    case 11646: // $43767
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11660, $11661, $11662, $11663, $11664, $11665, $11666, $11667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11647; break; } else { __label__ = 14596; break; }
    case 11647: // $43768
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43760, 5, 11, 0, ((STRING_TABLE.__str1334)|0), 0, $11660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11648; break; } else { __label__ = 14596; break; }
    case 11648: // $43769
      var $43770=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43760);
      var $43771=__ZN11simple_listI16input_type_entryE6appendERS0_($43721, $43770);
      var $43772=$4689;
      var $43773=$1764;
      var $43774=$1765;
      var $43775=$1766;
      var $43776=$result_i1167;
      var $43777=$1767;
      var $43778=$1768;
      HEAP32[(($1764)>>2)]=408;
      HEAP32[(($1765)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1766)>>2)]=671;
      var $43779=HEAP32[(($1764)>>2)];
      var $43780=HEAP32[(($1765)>>2)];
      var $43781=HEAP32[(($1766)>>2)];
      var $43782=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43779, $43780, $43781) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11649; break; } else { __label__ = 11651; break; };
    case 11649: // $43783
      HEAP32[(($result_i1167)>>2)]=$43782;
      var $43784=HEAP32[(($result_i1167)>>2)];
      var $43785=(($43784)|0)==0;
      if ($43785) { __label__ = 11650; break; } else { __label__ = 11655; break; }
    case 11650: // $43786
      var $43787=___cxa_allocate_exception(4);
      var $43788=$43787;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43788);
      (function() { try { __THREW__ = false; return ___cxa_throw($43787, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11654; break; } else { __label__ = 11651; break; }
    case 11651: // $43789
      var $43790=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43791=$43790.f0;
      HEAP32[(($1767)>>2)]=$43791;
      var $43792=$43790.f1;
      HEAP32[(($1768)>>2)]=$43792;
      var $43793=HEAP32[(($1768)>>2)];
      var $43794=(($43793)|0) < 0;
      if ($43794) { __label__ = 11652; break; } else { __label__ = 11653; break; }
    case 11652: // $43795
      var $43796=HEAP32[(($1767)>>2)];
      ___cxa_call_unexpected($43796);
      throw "Reached an unreachable!"
    case 11653: // $43797
      var $43798=HEAP32[(($1767)>>2)];
      var $43799=HEAP32[(($1767)>>2)];
      var $43800=HEAP32[(($1768)>>2)];
      var $43801=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43799, tempValue);
      var $43802=($43801.f1 = $43800, $43801);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11654: // $43803
      throw "Reached an unreachable!"
    case 11655: // $_ZnwjPKci_exit1168
      var $43804=HEAP32[(($result_i1167)>>2)];
      var $43805=$1764;
      var $43806=$1765;
      var $43807=$1766;
      var $43808=$result_i1167;
      var $43809=$1767;
      var $43810=$1768;
      var $43811=$43804;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11669, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11656; break; } else { __label__ = 14601; break; }
    case 11656: // $43812
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11670, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11657; break; } else { __label__ = 14601; break; }
    case 11657: // $43813
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11671, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11658; break; } else { __label__ = 14601; break; }
    case 11658: // $43814
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11672, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11659; break; } else { __label__ = 14601; break; }
    case 11659: // $43815
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11673, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11660; break; } else { __label__ = 14601; break; }
    case 11660: // $43816
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11674, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11661; break; } else { __label__ = 14601; break; }
    case 11661: // $43817
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11675, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11662; break; } else { __label__ = 14601; break; }
    case 11662: // $43818
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11668, $11669, $11670, $11671, $11672, $11673, $11674, $11675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11663; break; } else { __label__ = 14601; break; }
    case 11663: // $43819
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43811, 7, 11, 0, ((STRING_TABLE.__str1335)|0), 0, $11668) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11664; break; } else { __label__ = 14601; break; }
    case 11664: // $43820
      var $43821=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43811);
      var $43822=__ZN11simple_listI16input_type_entryE6appendERS0_($43772, $43821);
      var $43823=$4689;
      var $43824=$1759;
      var $43825=$1760;
      var $43826=$1761;
      var $43827=$result_i1169;
      var $43828=$1762;
      var $43829=$1763;
      HEAP32[(($1759)>>2)]=408;
      HEAP32[(($1760)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1761)>>2)]=672;
      var $43830=HEAP32[(($1759)>>2)];
      var $43831=HEAP32[(($1760)>>2)];
      var $43832=HEAP32[(($1761)>>2)];
      var $43833=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43830, $43831, $43832) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11665; break; } else { __label__ = 11667; break; };
    case 11665: // $43834
      HEAP32[(($result_i1169)>>2)]=$43833;
      var $43835=HEAP32[(($result_i1169)>>2)];
      var $43836=(($43835)|0)==0;
      if ($43836) { __label__ = 11666; break; } else { __label__ = 11671; break; }
    case 11666: // $43837
      var $43838=___cxa_allocate_exception(4);
      var $43839=$43838;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43839);
      (function() { try { __THREW__ = false; return ___cxa_throw($43838, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11670; break; } else { __label__ = 11667; break; }
    case 11667: // $43840
      var $43841=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43842=$43841.f0;
      HEAP32[(($1762)>>2)]=$43842;
      var $43843=$43841.f1;
      HEAP32[(($1763)>>2)]=$43843;
      var $43844=HEAP32[(($1763)>>2)];
      var $43845=(($43844)|0) < 0;
      if ($43845) { __label__ = 11668; break; } else { __label__ = 11669; break; }
    case 11668: // $43846
      var $43847=HEAP32[(($1762)>>2)];
      ___cxa_call_unexpected($43847);
      throw "Reached an unreachable!"
    case 11669: // $43848
      var $43849=HEAP32[(($1762)>>2)];
      var $43850=HEAP32[(($1762)>>2)];
      var $43851=HEAP32[(($1763)>>2)];
      var $43852=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43850, tempValue);
      var $43853=($43852.f1 = $43851, $43852);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11670: // $43854
      throw "Reached an unreachable!"
    case 11671: // $_ZnwjPKci_exit1170
      var $43855=HEAP32[(($result_i1169)>>2)];
      var $43856=$1759;
      var $43857=$1760;
      var $43858=$1761;
      var $43859=$result_i1169;
      var $43860=$1762;
      var $43861=$1763;
      var $43862=$43855;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11677, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11672; break; } else { __label__ = 14606; break; }
    case 11672: // $43863
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11678, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11673; break; } else { __label__ = 14606; break; }
    case 11673: // $43864
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11679, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11674; break; } else { __label__ = 14606; break; }
    case 11674: // $43865
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11680, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11675; break; } else { __label__ = 14606; break; }
    case 11675: // $43866
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11681, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11676; break; } else { __label__ = 14606; break; }
    case 11676: // $43867
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11682, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11677; break; } else { __label__ = 14606; break; }
    case 11677: // $43868
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($11683, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11678; break; } else { __label__ = 14606; break; }
    case 11678: // $43869
      (function() { try { __THREW__ = false; return __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($11676, $11677, $11678, $11679, $11680, $11681, $11682, $11683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11679; break; } else { __label__ = 14606; break; }
    case 11679: // $43870
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq]($43862, 8, 11, 0, ((STRING_TABLE.__str1336)|0), 0, $11676) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11680; break; } else { __label__ = 14606; break; }
    case 11680: // $43871
      var $43872=__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_(_global_resource_pool, $43862);
      var $43873=__ZN11simple_listI16input_type_entryE6appendERS0_($43823, $43872);
      STACKTOP = __stackBase__;
      return;
    case 11681: // $43874
      var $43875=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43876=$43875.f0;
      $4692=$43876;
      var $43877=$43875.f1;
      $4693=$43877;
      var $43878=$1756;
      var $43879=$1757;
      var $43880=$1758;
      HEAP32[(($1756)>>2)]=$11716;
      HEAP32[(($1757)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1758)>>2)]=54;
      var $43881=HEAP32[(($1756)>>2)];
      var $43882=(($43881)|0)!=0;
      if ($43882) { __label__ = 11682; break; } else { __label__ = 11684; break; }
    case 11682: // $43883
      var $43884=HEAP32[(($1756)>>2)];
      var $43885=HEAP32[(($1757)>>2)];
      var $43886=HEAP32[(($1758)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43884, $43885, $43886) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11683; break; } else { __label__ = 14612; break; }
    case 11683: // $_noexc
      __label__ = 11684; break;
    case 11684: // $_ZdlPvPKci_exit
      var $43887=$1756;
      var $43888=$1757;
      var $43889=$1758;
      __label__ = 11685; break;
    case 11685: // $43890
      __label__ = 14611; break;
    case 11686: // $43891
      var $43892=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43893=$43892.f0;
      $4692=$43893;
      var $43894=$43892.f1;
      $4693=$43894;
      var $43895=$1753;
      var $43896=$1754;
      var $43897=$1755;
      HEAP32[(($1753)>>2)]=$11767;
      HEAP32[(($1754)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1755)>>2)]=55;
      var $43898=HEAP32[(($1753)>>2)];
      var $43899=(($43898)|0)!=0;
      if ($43899) { __label__ = 11687; break; } else { __label__ = 11689; break; }
    case 11687: // $43900
      var $43901=HEAP32[(($1753)>>2)];
      var $43902=HEAP32[(($1754)>>2)];
      var $43903=HEAP32[(($1755)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43901, $43902, $43903) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11688; break; } else { __label__ = 14612; break; }
    case 11688: // $_noexc1171
      __label__ = 11689; break;
    case 11689: // $_ZdlPvPKci_exit1172
      var $43904=$1753;
      var $43905=$1754;
      var $43906=$1755;
      __label__ = 11690; break;
    case 11690: // $43907
      __label__ = 14611; break;
    case 11691: // $43908
      var $43909=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43910=$43909.f0;
      $4692=$43910;
      var $43911=$43909.f1;
      $4693=$43911;
      var $43912=$1750;
      var $43913=$1751;
      var $43914=$1752;
      HEAP32[(($1750)>>2)]=$11818;
      HEAP32[(($1751)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1752)>>2)]=56;
      var $43915=HEAP32[(($1750)>>2)];
      var $43916=(($43915)|0)!=0;
      if ($43916) { __label__ = 11692; break; } else { __label__ = 11694; break; }
    case 11692: // $43917
      var $43918=HEAP32[(($1750)>>2)];
      var $43919=HEAP32[(($1751)>>2)];
      var $43920=HEAP32[(($1752)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43918, $43919, $43920) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11693; break; } else { __label__ = 14612; break; }
    case 11693: // $_noexc1173
      __label__ = 11694; break;
    case 11694: // $_ZdlPvPKci_exit1174
      var $43921=$1750;
      var $43922=$1751;
      var $43923=$1752;
      __label__ = 11695; break;
    case 11695: // $43924
      __label__ = 14611; break;
    case 11696: // $43925
      var $43926=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43927=$43926.f0;
      $4692=$43927;
      var $43928=$43926.f1;
      $4693=$43928;
      var $43929=$1747;
      var $43930=$1748;
      var $43931=$1749;
      HEAP32[(($1747)>>2)]=$11869;
      HEAP32[(($1748)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1749)>>2)]=57;
      var $43932=HEAP32[(($1747)>>2)];
      var $43933=(($43932)|0)!=0;
      if ($43933) { __label__ = 11697; break; } else { __label__ = 11699; break; }
    case 11697: // $43934
      var $43935=HEAP32[(($1747)>>2)];
      var $43936=HEAP32[(($1748)>>2)];
      var $43937=HEAP32[(($1749)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43935, $43936, $43937) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11698; break; } else { __label__ = 14612; break; }
    case 11698: // $_noexc1175
      __label__ = 11699; break;
    case 11699: // $_ZdlPvPKci_exit1176
      var $43938=$1747;
      var $43939=$1748;
      var $43940=$1749;
      __label__ = 11700; break;
    case 11700: // $43941
      __label__ = 14611; break;
    case 11701: // $43942
      var $43943=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43944=$43943.f0;
      $4692=$43944;
      var $43945=$43943.f1;
      $4693=$43945;
      var $43946=$1744;
      var $43947=$1745;
      var $43948=$1746;
      HEAP32[(($1744)>>2)]=$11920;
      HEAP32[(($1745)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1746)>>2)]=58;
      var $43949=HEAP32[(($1744)>>2)];
      var $43950=(($43949)|0)!=0;
      if ($43950) { __label__ = 11702; break; } else { __label__ = 11704; break; }
    case 11702: // $43951
      var $43952=HEAP32[(($1744)>>2)];
      var $43953=HEAP32[(($1745)>>2)];
      var $43954=HEAP32[(($1746)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43952, $43953, $43954) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11703; break; } else { __label__ = 14612; break; }
    case 11703: // $_noexc1177
      __label__ = 11704; break;
    case 11704: // $_ZdlPvPKci_exit1178
      var $43955=$1744;
      var $43956=$1745;
      var $43957=$1746;
      __label__ = 11705; break;
    case 11705: // $43958
      __label__ = 14611; break;
    case 11706: // $43959
      var $43960=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43961=$43960.f0;
      $4692=$43961;
      var $43962=$43960.f1;
      $4693=$43962;
      var $43963=$1741;
      var $43964=$1742;
      var $43965=$1743;
      HEAP32[(($1741)>>2)]=$11971;
      HEAP32[(($1742)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1743)>>2)]=59;
      var $43966=HEAP32[(($1741)>>2)];
      var $43967=(($43966)|0)!=0;
      if ($43967) { __label__ = 11707; break; } else { __label__ = 11709; break; }
    case 11707: // $43968
      var $43969=HEAP32[(($1741)>>2)];
      var $43970=HEAP32[(($1742)>>2)];
      var $43971=HEAP32[(($1743)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43969, $43970, $43971) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11708; break; } else { __label__ = 14612; break; }
    case 11708: // $_noexc1179
      __label__ = 11709; break;
    case 11709: // $_ZdlPvPKci_exit1180
      var $43972=$1741;
      var $43973=$1742;
      var $43974=$1743;
      __label__ = 11710; break;
    case 11710: // $43975
      __label__ = 14611; break;
    case 11711: // $43976
      var $43977=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43978=$43977.f0;
      $4692=$43978;
      var $43979=$43977.f1;
      $4693=$43979;
      var $43980=$1738;
      var $43981=$1739;
      var $43982=$1740;
      HEAP32[(($1738)>>2)]=$12022;
      HEAP32[(($1739)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1740)>>2)]=60;
      var $43983=HEAP32[(($1738)>>2)];
      var $43984=(($43983)|0)!=0;
      if ($43984) { __label__ = 11712; break; } else { __label__ = 11714; break; }
    case 11712: // $43985
      var $43986=HEAP32[(($1738)>>2)];
      var $43987=HEAP32[(($1739)>>2)];
      var $43988=HEAP32[(($1740)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($43986, $43987, $43988) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11713; break; } else { __label__ = 14612; break; }
    case 11713: // $_noexc1181
      __label__ = 11714; break;
    case 11714: // $_ZdlPvPKci_exit1182
      var $43989=$1738;
      var $43990=$1739;
      var $43991=$1740;
      __label__ = 11715; break;
    case 11715: // $43992
      __label__ = 14611; break;
    case 11716: // $43993
      var $43994=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43995=$43994.f0;
      $4692=$43995;
      var $43996=$43994.f1;
      $4693=$43996;
      var $43997=$1735;
      var $43998=$1736;
      var $43999=$1737;
      HEAP32[(($1735)>>2)]=$12073;
      HEAP32[(($1736)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1737)>>2)]=61;
      var $44000=HEAP32[(($1735)>>2)];
      var $44001=(($44000)|0)!=0;
      if ($44001) { __label__ = 11717; break; } else { __label__ = 11719; break; }
    case 11717: // $44002
      var $44003=HEAP32[(($1735)>>2)];
      var $44004=HEAP32[(($1736)>>2)];
      var $44005=HEAP32[(($1737)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44003, $44004, $44005) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11718; break; } else { __label__ = 14612; break; }
    case 11718: // $_noexc1183
      __label__ = 11719; break;
    case 11719: // $_ZdlPvPKci_exit1184
      var $44006=$1735;
      var $44007=$1736;
      var $44008=$1737;
      __label__ = 11720; break;
    case 11720: // $44009
      __label__ = 14611; break;
    case 11721: // $44010
      var $44011=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44012=$44011.f0;
      $4692=$44012;
      var $44013=$44011.f1;
      $4693=$44013;
      var $44014=$1732;
      var $44015=$1733;
      var $44016=$1734;
      HEAP32[(($1732)>>2)]=$12124;
      HEAP32[(($1733)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1734)>>2)]=62;
      var $44017=HEAP32[(($1732)>>2)];
      var $44018=(($44017)|0)!=0;
      if ($44018) { __label__ = 11722; break; } else { __label__ = 11724; break; }
    case 11722: // $44019
      var $44020=HEAP32[(($1732)>>2)];
      var $44021=HEAP32[(($1733)>>2)];
      var $44022=HEAP32[(($1734)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44020, $44021, $44022) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11723; break; } else { __label__ = 14612; break; }
    case 11723: // $_noexc1185
      __label__ = 11724; break;
    case 11724: // $_ZdlPvPKci_exit1186
      var $44023=$1732;
      var $44024=$1733;
      var $44025=$1734;
      __label__ = 11725; break;
    case 11725: // $44026
      __label__ = 14611; break;
    case 11726: // $44027
      var $44028=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44029=$44028.f0;
      $4692=$44029;
      var $44030=$44028.f1;
      $4693=$44030;
      var $44031=$1729;
      var $44032=$1730;
      var $44033=$1731;
      HEAP32[(($1729)>>2)]=$12175;
      HEAP32[(($1730)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1731)>>2)]=63;
      var $44034=HEAP32[(($1729)>>2)];
      var $44035=(($44034)|0)!=0;
      if ($44035) { __label__ = 11727; break; } else { __label__ = 11729; break; }
    case 11727: // $44036
      var $44037=HEAP32[(($1729)>>2)];
      var $44038=HEAP32[(($1730)>>2)];
      var $44039=HEAP32[(($1731)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44037, $44038, $44039) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11728; break; } else { __label__ = 14612; break; }
    case 11728: // $_noexc1187
      __label__ = 11729; break;
    case 11729: // $_ZdlPvPKci_exit1188
      var $44040=$1729;
      var $44041=$1730;
      var $44042=$1731;
      __label__ = 11730; break;
    case 11730: // $44043
      __label__ = 14611; break;
    case 11731: // $44044
      var $44045=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44046=$44045.f0;
      $4692=$44046;
      var $44047=$44045.f1;
      $4693=$44047;
      var $44048=$1726;
      var $44049=$1727;
      var $44050=$1728;
      HEAP32[(($1726)>>2)]=$12226;
      HEAP32[(($1727)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1728)>>2)]=64;
      var $44051=HEAP32[(($1726)>>2)];
      var $44052=(($44051)|0)!=0;
      if ($44052) { __label__ = 11732; break; } else { __label__ = 11734; break; }
    case 11732: // $44053
      var $44054=HEAP32[(($1726)>>2)];
      var $44055=HEAP32[(($1727)>>2)];
      var $44056=HEAP32[(($1728)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44054, $44055, $44056) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11733; break; } else { __label__ = 14612; break; }
    case 11733: // $_noexc1189
      __label__ = 11734; break;
    case 11734: // $_ZdlPvPKci_exit1190
      var $44057=$1726;
      var $44058=$1727;
      var $44059=$1728;
      __label__ = 11735; break;
    case 11735: // $44060
      __label__ = 14611; break;
    case 11736: // $44061
      var $44062=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44063=$44062.f0;
      $4692=$44063;
      var $44064=$44062.f1;
      $4693=$44064;
      var $44065=$1723;
      var $44066=$1724;
      var $44067=$1725;
      HEAP32[(($1723)>>2)]=$12277;
      HEAP32[(($1724)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1725)>>2)]=65;
      var $44068=HEAP32[(($1723)>>2)];
      var $44069=(($44068)|0)!=0;
      if ($44069) { __label__ = 11737; break; } else { __label__ = 11739; break; }
    case 11737: // $44070
      var $44071=HEAP32[(($1723)>>2)];
      var $44072=HEAP32[(($1724)>>2)];
      var $44073=HEAP32[(($1725)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44071, $44072, $44073) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11738; break; } else { __label__ = 14612; break; }
    case 11738: // $_noexc1191
      __label__ = 11739; break;
    case 11739: // $_ZdlPvPKci_exit1192
      var $44074=$1723;
      var $44075=$1724;
      var $44076=$1725;
      __label__ = 11740; break;
    case 11740: // $44077
      __label__ = 14611; break;
    case 11741: // $44078
      var $44079=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44080=$44079.f0;
      $4692=$44080;
      var $44081=$44079.f1;
      $4693=$44081;
      var $44082=$1720;
      var $44083=$1721;
      var $44084=$1722;
      HEAP32[(($1720)>>2)]=$12328;
      HEAP32[(($1721)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1722)>>2)]=66;
      var $44085=HEAP32[(($1720)>>2)];
      var $44086=(($44085)|0)!=0;
      if ($44086) { __label__ = 11742; break; } else { __label__ = 11744; break; }
    case 11742: // $44087
      var $44088=HEAP32[(($1720)>>2)];
      var $44089=HEAP32[(($1721)>>2)];
      var $44090=HEAP32[(($1722)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44088, $44089, $44090) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11743; break; } else { __label__ = 14612; break; }
    case 11743: // $_noexc1193
      __label__ = 11744; break;
    case 11744: // $_ZdlPvPKci_exit1194
      var $44091=$1720;
      var $44092=$1721;
      var $44093=$1722;
      __label__ = 11745; break;
    case 11745: // $44094
      __label__ = 14611; break;
    case 11746: // $44095
      var $44096=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44097=$44096.f0;
      $4692=$44097;
      var $44098=$44096.f1;
      $4693=$44098;
      var $44099=$1717;
      var $44100=$1718;
      var $44101=$1719;
      HEAP32[(($1717)>>2)]=$12379;
      HEAP32[(($1718)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1719)>>2)]=67;
      var $44102=HEAP32[(($1717)>>2)];
      var $44103=(($44102)|0)!=0;
      if ($44103) { __label__ = 11747; break; } else { __label__ = 11749; break; }
    case 11747: // $44104
      var $44105=HEAP32[(($1717)>>2)];
      var $44106=HEAP32[(($1718)>>2)];
      var $44107=HEAP32[(($1719)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44105, $44106, $44107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11748; break; } else { __label__ = 14612; break; }
    case 11748: // $_noexc1195
      __label__ = 11749; break;
    case 11749: // $_ZdlPvPKci_exit1196
      var $44108=$1717;
      var $44109=$1718;
      var $44110=$1719;
      __label__ = 11750; break;
    case 11750: // $44111
      __label__ = 14611; break;
    case 11751: // $44112
      var $44113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44114=$44113.f0;
      $4692=$44114;
      var $44115=$44113.f1;
      $4693=$44115;
      var $44116=$1714;
      var $44117=$1715;
      var $44118=$1716;
      HEAP32[(($1714)>>2)]=$12430;
      HEAP32[(($1715)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1716)>>2)]=68;
      var $44119=HEAP32[(($1714)>>2)];
      var $44120=(($44119)|0)!=0;
      if ($44120) { __label__ = 11752; break; } else { __label__ = 11754; break; }
    case 11752: // $44121
      var $44122=HEAP32[(($1714)>>2)];
      var $44123=HEAP32[(($1715)>>2)];
      var $44124=HEAP32[(($1716)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44122, $44123, $44124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11753; break; } else { __label__ = 14612; break; }
    case 11753: // $_noexc1197
      __label__ = 11754; break;
    case 11754: // $_ZdlPvPKci_exit1198
      var $44125=$1714;
      var $44126=$1715;
      var $44127=$1716;
      __label__ = 11755; break;
    case 11755: // $44128
      __label__ = 14611; break;
    case 11756: // $44129
      var $44130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44131=$44130.f0;
      $4692=$44131;
      var $44132=$44130.f1;
      $4693=$44132;
      var $44133=$1711;
      var $44134=$1712;
      var $44135=$1713;
      HEAP32[(($1711)>>2)]=$12481;
      HEAP32[(($1712)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1713)>>2)]=69;
      var $44136=HEAP32[(($1711)>>2)];
      var $44137=(($44136)|0)!=0;
      if ($44137) { __label__ = 11757; break; } else { __label__ = 11759; break; }
    case 11757: // $44138
      var $44139=HEAP32[(($1711)>>2)];
      var $44140=HEAP32[(($1712)>>2)];
      var $44141=HEAP32[(($1713)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44139, $44140, $44141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11758; break; } else { __label__ = 14612; break; }
    case 11758: // $_noexc1199
      __label__ = 11759; break;
    case 11759: // $_ZdlPvPKci_exit1200
      var $44142=$1711;
      var $44143=$1712;
      var $44144=$1713;
      __label__ = 11760; break;
    case 11760: // $44145
      __label__ = 14611; break;
    case 11761: // $44146
      var $44147=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44148=$44147.f0;
      $4692=$44148;
      var $44149=$44147.f1;
      $4693=$44149;
      var $44150=$1708;
      var $44151=$1709;
      var $44152=$1710;
      HEAP32[(($1708)>>2)]=$12532;
      HEAP32[(($1709)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1710)>>2)]=70;
      var $44153=HEAP32[(($1708)>>2)];
      var $44154=(($44153)|0)!=0;
      if ($44154) { __label__ = 11762; break; } else { __label__ = 11764; break; }
    case 11762: // $44155
      var $44156=HEAP32[(($1708)>>2)];
      var $44157=HEAP32[(($1709)>>2)];
      var $44158=HEAP32[(($1710)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44156, $44157, $44158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11763; break; } else { __label__ = 14612; break; }
    case 11763: // $_noexc1201
      __label__ = 11764; break;
    case 11764: // $_ZdlPvPKci_exit1202
      var $44159=$1708;
      var $44160=$1709;
      var $44161=$1710;
      __label__ = 11765; break;
    case 11765: // $44162
      __label__ = 14611; break;
    case 11766: // $44163
      var $44164=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44165=$44164.f0;
      $4692=$44165;
      var $44166=$44164.f1;
      $4693=$44166;
      var $44167=$1705;
      var $44168=$1706;
      var $44169=$1707;
      HEAP32[(($1705)>>2)]=$12583;
      HEAP32[(($1706)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1707)>>2)]=71;
      var $44170=HEAP32[(($1705)>>2)];
      var $44171=(($44170)|0)!=0;
      if ($44171) { __label__ = 11767; break; } else { __label__ = 11769; break; }
    case 11767: // $44172
      var $44173=HEAP32[(($1705)>>2)];
      var $44174=HEAP32[(($1706)>>2)];
      var $44175=HEAP32[(($1707)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44173, $44174, $44175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11768; break; } else { __label__ = 14612; break; }
    case 11768: // $_noexc1203
      __label__ = 11769; break;
    case 11769: // $_ZdlPvPKci_exit1204
      var $44176=$1705;
      var $44177=$1706;
      var $44178=$1707;
      __label__ = 11770; break;
    case 11770: // $44179
      __label__ = 14611; break;
    case 11771: // $44180
      var $44181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44182=$44181.f0;
      $4692=$44182;
      var $44183=$44181.f1;
      $4693=$44183;
      var $44184=$1702;
      var $44185=$1703;
      var $44186=$1704;
      HEAP32[(($1702)>>2)]=$12634;
      HEAP32[(($1703)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1704)>>2)]=72;
      var $44187=HEAP32[(($1702)>>2)];
      var $44188=(($44187)|0)!=0;
      if ($44188) { __label__ = 11772; break; } else { __label__ = 11774; break; }
    case 11772: // $44189
      var $44190=HEAP32[(($1702)>>2)];
      var $44191=HEAP32[(($1703)>>2)];
      var $44192=HEAP32[(($1704)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44190, $44191, $44192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11773; break; } else { __label__ = 14612; break; }
    case 11773: // $_noexc1205
      __label__ = 11774; break;
    case 11774: // $_ZdlPvPKci_exit1206
      var $44193=$1702;
      var $44194=$1703;
      var $44195=$1704;
      __label__ = 11775; break;
    case 11775: // $44196
      __label__ = 14611; break;
    case 11776: // $44197
      var $44198=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44199=$44198.f0;
      $4692=$44199;
      var $44200=$44198.f1;
      $4693=$44200;
      var $44201=$1699;
      var $44202=$1700;
      var $44203=$1701;
      HEAP32[(($1699)>>2)]=$12685;
      HEAP32[(($1700)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1701)>>2)]=73;
      var $44204=HEAP32[(($1699)>>2)];
      var $44205=(($44204)|0)!=0;
      if ($44205) { __label__ = 11777; break; } else { __label__ = 11779; break; }
    case 11777: // $44206
      var $44207=HEAP32[(($1699)>>2)];
      var $44208=HEAP32[(($1700)>>2)];
      var $44209=HEAP32[(($1701)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44207, $44208, $44209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11778; break; } else { __label__ = 14612; break; }
    case 11778: // $_noexc1207
      __label__ = 11779; break;
    case 11779: // $_ZdlPvPKci_exit1208
      var $44210=$1699;
      var $44211=$1700;
      var $44212=$1701;
      __label__ = 11780; break;
    case 11780: // $44213
      __label__ = 14611; break;
    case 11781: // $44214
      var $44215=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44216=$44215.f0;
      $4692=$44216;
      var $44217=$44215.f1;
      $4693=$44217;
      var $44218=$1696;
      var $44219=$1697;
      var $44220=$1698;
      HEAP32[(($1696)>>2)]=$12736;
      HEAP32[(($1697)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1698)>>2)]=74;
      var $44221=HEAP32[(($1696)>>2)];
      var $44222=(($44221)|0)!=0;
      if ($44222) { __label__ = 11782; break; } else { __label__ = 11784; break; }
    case 11782: // $44223
      var $44224=HEAP32[(($1696)>>2)];
      var $44225=HEAP32[(($1697)>>2)];
      var $44226=HEAP32[(($1698)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44224, $44225, $44226) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11783; break; } else { __label__ = 14612; break; }
    case 11783: // $_noexc1209
      __label__ = 11784; break;
    case 11784: // $_ZdlPvPKci_exit1210
      var $44227=$1696;
      var $44228=$1697;
      var $44229=$1698;
      __label__ = 11785; break;
    case 11785: // $44230
      __label__ = 14611; break;
    case 11786: // $44231
      var $44232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44233=$44232.f0;
      $4692=$44233;
      var $44234=$44232.f1;
      $4693=$44234;
      var $44235=$1693;
      var $44236=$1694;
      var $44237=$1695;
      HEAP32[(($1693)>>2)]=$12787;
      HEAP32[(($1694)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1695)>>2)]=75;
      var $44238=HEAP32[(($1693)>>2)];
      var $44239=(($44238)|0)!=0;
      if ($44239) { __label__ = 11787; break; } else { __label__ = 11789; break; }
    case 11787: // $44240
      var $44241=HEAP32[(($1693)>>2)];
      var $44242=HEAP32[(($1694)>>2)];
      var $44243=HEAP32[(($1695)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44241, $44242, $44243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11788; break; } else { __label__ = 14612; break; }
    case 11788: // $_noexc1211
      __label__ = 11789; break;
    case 11789: // $_ZdlPvPKci_exit1212
      var $44244=$1693;
      var $44245=$1694;
      var $44246=$1695;
      __label__ = 11790; break;
    case 11790: // $44247
      __label__ = 14611; break;
    case 11791: // $44248
      var $44249=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44250=$44249.f0;
      $4692=$44250;
      var $44251=$44249.f1;
      $4693=$44251;
      var $44252=$1690;
      var $44253=$1691;
      var $44254=$1692;
      HEAP32[(($1690)>>2)]=$12838;
      HEAP32[(($1691)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1692)>>2)]=76;
      var $44255=HEAP32[(($1690)>>2)];
      var $44256=(($44255)|0)!=0;
      if ($44256) { __label__ = 11792; break; } else { __label__ = 11794; break; }
    case 11792: // $44257
      var $44258=HEAP32[(($1690)>>2)];
      var $44259=HEAP32[(($1691)>>2)];
      var $44260=HEAP32[(($1692)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44258, $44259, $44260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11793; break; } else { __label__ = 14612; break; }
    case 11793: // $_noexc1213
      __label__ = 11794; break;
    case 11794: // $_ZdlPvPKci_exit1214
      var $44261=$1690;
      var $44262=$1691;
      var $44263=$1692;
      __label__ = 11795; break;
    case 11795: // $44264
      __label__ = 14611; break;
    case 11796: // $44265
      var $44266=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44267=$44266.f0;
      $4692=$44267;
      var $44268=$44266.f1;
      $4693=$44268;
      var $44269=$1687;
      var $44270=$1688;
      var $44271=$1689;
      HEAP32[(($1687)>>2)]=$12889;
      HEAP32[(($1688)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1689)>>2)]=77;
      var $44272=HEAP32[(($1687)>>2)];
      var $44273=(($44272)|0)!=0;
      if ($44273) { __label__ = 11797; break; } else { __label__ = 11799; break; }
    case 11797: // $44274
      var $44275=HEAP32[(($1687)>>2)];
      var $44276=HEAP32[(($1688)>>2)];
      var $44277=HEAP32[(($1689)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44275, $44276, $44277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11798; break; } else { __label__ = 14612; break; }
    case 11798: // $_noexc1215
      __label__ = 11799; break;
    case 11799: // $_ZdlPvPKci_exit1216
      var $44278=$1687;
      var $44279=$1688;
      var $44280=$1689;
      __label__ = 11800; break;
    case 11800: // $44281
      __label__ = 14611; break;
    case 11801: // $44282
      var $44283=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44284=$44283.f0;
      $4692=$44284;
      var $44285=$44283.f1;
      $4693=$44285;
      var $44286=$1684;
      var $44287=$1685;
      var $44288=$1686;
      HEAP32[(($1684)>>2)]=$12940;
      HEAP32[(($1685)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1686)>>2)]=78;
      var $44289=HEAP32[(($1684)>>2)];
      var $44290=(($44289)|0)!=0;
      if ($44290) { __label__ = 11802; break; } else { __label__ = 11804; break; }
    case 11802: // $44291
      var $44292=HEAP32[(($1684)>>2)];
      var $44293=HEAP32[(($1685)>>2)];
      var $44294=HEAP32[(($1686)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44292, $44293, $44294) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11803; break; } else { __label__ = 14612; break; }
    case 11803: // $_noexc1217
      __label__ = 11804; break;
    case 11804: // $_ZdlPvPKci_exit1218
      var $44295=$1684;
      var $44296=$1685;
      var $44297=$1686;
      __label__ = 11805; break;
    case 11805: // $44298
      __label__ = 14611; break;
    case 11806: // $44299
      var $44300=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44301=$44300.f0;
      $4692=$44301;
      var $44302=$44300.f1;
      $4693=$44302;
      var $44303=$1681;
      var $44304=$1682;
      var $44305=$1683;
      HEAP32[(($1681)>>2)]=$12991;
      HEAP32[(($1682)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1683)>>2)]=79;
      var $44306=HEAP32[(($1681)>>2)];
      var $44307=(($44306)|0)!=0;
      if ($44307) { __label__ = 11807; break; } else { __label__ = 11809; break; }
    case 11807: // $44308
      var $44309=HEAP32[(($1681)>>2)];
      var $44310=HEAP32[(($1682)>>2)];
      var $44311=HEAP32[(($1683)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44309, $44310, $44311) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11808; break; } else { __label__ = 14612; break; }
    case 11808: // $_noexc1219
      __label__ = 11809; break;
    case 11809: // $_ZdlPvPKci_exit1220
      var $44312=$1681;
      var $44313=$1682;
      var $44314=$1683;
      __label__ = 11810; break;
    case 11810: // $44315
      __label__ = 14611; break;
    case 11811: // $44316
      var $44317=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44318=$44317.f0;
      $4692=$44318;
      var $44319=$44317.f1;
      $4693=$44319;
      var $44320=$1678;
      var $44321=$1679;
      var $44322=$1680;
      HEAP32[(($1678)>>2)]=$13042;
      HEAP32[(($1679)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1680)>>2)]=80;
      var $44323=HEAP32[(($1678)>>2)];
      var $44324=(($44323)|0)!=0;
      if ($44324) { __label__ = 11812; break; } else { __label__ = 11814; break; }
    case 11812: // $44325
      var $44326=HEAP32[(($1678)>>2)];
      var $44327=HEAP32[(($1679)>>2)];
      var $44328=HEAP32[(($1680)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44326, $44327, $44328) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11813; break; } else { __label__ = 14612; break; }
    case 11813: // $_noexc1221
      __label__ = 11814; break;
    case 11814: // $_ZdlPvPKci_exit1222
      var $44329=$1678;
      var $44330=$1679;
      var $44331=$1680;
      __label__ = 11815; break;
    case 11815: // $44332
      __label__ = 14611; break;
    case 11816: // $44333
      var $44334=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44335=$44334.f0;
      $4692=$44335;
      var $44336=$44334.f1;
      $4693=$44336;
      var $44337=$1675;
      var $44338=$1676;
      var $44339=$1677;
      HEAP32[(($1675)>>2)]=$13093;
      HEAP32[(($1676)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1677)>>2)]=81;
      var $44340=HEAP32[(($1675)>>2)];
      var $44341=(($44340)|0)!=0;
      if ($44341) { __label__ = 11817; break; } else { __label__ = 11819; break; }
    case 11817: // $44342
      var $44343=HEAP32[(($1675)>>2)];
      var $44344=HEAP32[(($1676)>>2)];
      var $44345=HEAP32[(($1677)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44343, $44344, $44345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11818; break; } else { __label__ = 14612; break; }
    case 11818: // $_noexc1223
      __label__ = 11819; break;
    case 11819: // $_ZdlPvPKci_exit1224
      var $44346=$1675;
      var $44347=$1676;
      var $44348=$1677;
      __label__ = 11820; break;
    case 11820: // $44349
      __label__ = 14611; break;
    case 11821: // $44350
      var $44351=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44352=$44351.f0;
      $4692=$44352;
      var $44353=$44351.f1;
      $4693=$44353;
      var $44354=$1672;
      var $44355=$1673;
      var $44356=$1674;
      HEAP32[(($1672)>>2)]=$13144;
      HEAP32[(($1673)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1674)>>2)]=82;
      var $44357=HEAP32[(($1672)>>2)];
      var $44358=(($44357)|0)!=0;
      if ($44358) { __label__ = 11822; break; } else { __label__ = 11824; break; }
    case 11822: // $44359
      var $44360=HEAP32[(($1672)>>2)];
      var $44361=HEAP32[(($1673)>>2)];
      var $44362=HEAP32[(($1674)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44360, $44361, $44362) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11823; break; } else { __label__ = 14612; break; }
    case 11823: // $_noexc1225
      __label__ = 11824; break;
    case 11824: // $_ZdlPvPKci_exit1226
      var $44363=$1672;
      var $44364=$1673;
      var $44365=$1674;
      __label__ = 11825; break;
    case 11825: // $44366
      __label__ = 14611; break;
    case 11826: // $44367
      var $44368=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44369=$44368.f0;
      $4692=$44369;
      var $44370=$44368.f1;
      $4693=$44370;
      var $44371=$1669;
      var $44372=$1670;
      var $44373=$1671;
      HEAP32[(($1669)>>2)]=$13195;
      HEAP32[(($1670)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1671)>>2)]=83;
      var $44374=HEAP32[(($1669)>>2)];
      var $44375=(($44374)|0)!=0;
      if ($44375) { __label__ = 11827; break; } else { __label__ = 11829; break; }
    case 11827: // $44376
      var $44377=HEAP32[(($1669)>>2)];
      var $44378=HEAP32[(($1670)>>2)];
      var $44379=HEAP32[(($1671)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44377, $44378, $44379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11828; break; } else { __label__ = 14612; break; }
    case 11828: // $_noexc1227
      __label__ = 11829; break;
    case 11829: // $_ZdlPvPKci_exit1228
      var $44380=$1669;
      var $44381=$1670;
      var $44382=$1671;
      __label__ = 11830; break;
    case 11830: // $44383
      __label__ = 14611; break;
    case 11831: // $44384
      var $44385=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44386=$44385.f0;
      $4692=$44386;
      var $44387=$44385.f1;
      $4693=$44387;
      var $44388=$1666;
      var $44389=$1667;
      var $44390=$1668;
      HEAP32[(($1666)>>2)]=$13246;
      HEAP32[(($1667)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1668)>>2)]=84;
      var $44391=HEAP32[(($1666)>>2)];
      var $44392=(($44391)|0)!=0;
      if ($44392) { __label__ = 11832; break; } else { __label__ = 11834; break; }
    case 11832: // $44393
      var $44394=HEAP32[(($1666)>>2)];
      var $44395=HEAP32[(($1667)>>2)];
      var $44396=HEAP32[(($1668)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44394, $44395, $44396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11833; break; } else { __label__ = 14612; break; }
    case 11833: // $_noexc1229
      __label__ = 11834; break;
    case 11834: // $_ZdlPvPKci_exit1230
      var $44397=$1666;
      var $44398=$1667;
      var $44399=$1668;
      __label__ = 11835; break;
    case 11835: // $44400
      __label__ = 14611; break;
    case 11836: // $44401
      var $44402=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44403=$44402.f0;
      $4692=$44403;
      var $44404=$44402.f1;
      $4693=$44404;
      var $44405=$1663;
      var $44406=$1664;
      var $44407=$1665;
      HEAP32[(($1663)>>2)]=$13297;
      HEAP32[(($1664)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1665)>>2)]=85;
      var $44408=HEAP32[(($1663)>>2)];
      var $44409=(($44408)|0)!=0;
      if ($44409) { __label__ = 11837; break; } else { __label__ = 11839; break; }
    case 11837: // $44410
      var $44411=HEAP32[(($1663)>>2)];
      var $44412=HEAP32[(($1664)>>2)];
      var $44413=HEAP32[(($1665)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44411, $44412, $44413) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11838; break; } else { __label__ = 14612; break; }
    case 11838: // $_noexc1231
      __label__ = 11839; break;
    case 11839: // $_ZdlPvPKci_exit1232
      var $44414=$1663;
      var $44415=$1664;
      var $44416=$1665;
      __label__ = 11840; break;
    case 11840: // $44417
      __label__ = 14611; break;
    case 11841: // $44418
      var $44419=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44420=$44419.f0;
      $4692=$44420;
      var $44421=$44419.f1;
      $4693=$44421;
      var $44422=$1660;
      var $44423=$1661;
      var $44424=$1662;
      HEAP32[(($1660)>>2)]=$13348;
      HEAP32[(($1661)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1662)>>2)]=86;
      var $44425=HEAP32[(($1660)>>2)];
      var $44426=(($44425)|0)!=0;
      if ($44426) { __label__ = 11842; break; } else { __label__ = 11844; break; }
    case 11842: // $44427
      var $44428=HEAP32[(($1660)>>2)];
      var $44429=HEAP32[(($1661)>>2)];
      var $44430=HEAP32[(($1662)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44428, $44429, $44430) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11843; break; } else { __label__ = 14612; break; }
    case 11843: // $_noexc1233
      __label__ = 11844; break;
    case 11844: // $_ZdlPvPKci_exit1234
      var $44431=$1660;
      var $44432=$1661;
      var $44433=$1662;
      __label__ = 11845; break;
    case 11845: // $44434
      __label__ = 14611; break;
    case 11846: // $44435
      var $44436=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44437=$44436.f0;
      $4692=$44437;
      var $44438=$44436.f1;
      $4693=$44438;
      var $44439=$1657;
      var $44440=$1658;
      var $44441=$1659;
      HEAP32[(($1657)>>2)]=$13399;
      HEAP32[(($1658)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1659)>>2)]=87;
      var $44442=HEAP32[(($1657)>>2)];
      var $44443=(($44442)|0)!=0;
      if ($44443) { __label__ = 11847; break; } else { __label__ = 11849; break; }
    case 11847: // $44444
      var $44445=HEAP32[(($1657)>>2)];
      var $44446=HEAP32[(($1658)>>2)];
      var $44447=HEAP32[(($1659)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44445, $44446, $44447) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11848; break; } else { __label__ = 14612; break; }
    case 11848: // $_noexc1235
      __label__ = 11849; break;
    case 11849: // $_ZdlPvPKci_exit1236
      var $44448=$1657;
      var $44449=$1658;
      var $44450=$1659;
      __label__ = 11850; break;
    case 11850: // $44451
      __label__ = 14611; break;
    case 11851: // $44452
      var $44453=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44454=$44453.f0;
      $4692=$44454;
      var $44455=$44453.f1;
      $4693=$44455;
      var $44456=$1654;
      var $44457=$1655;
      var $44458=$1656;
      HEAP32[(($1654)>>2)]=$13450;
      HEAP32[(($1655)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1656)>>2)]=88;
      var $44459=HEAP32[(($1654)>>2)];
      var $44460=(($44459)|0)!=0;
      if ($44460) { __label__ = 11852; break; } else { __label__ = 11854; break; }
    case 11852: // $44461
      var $44462=HEAP32[(($1654)>>2)];
      var $44463=HEAP32[(($1655)>>2)];
      var $44464=HEAP32[(($1656)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44462, $44463, $44464) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11853; break; } else { __label__ = 14612; break; }
    case 11853: // $_noexc1237
      __label__ = 11854; break;
    case 11854: // $_ZdlPvPKci_exit1238
      var $44465=$1654;
      var $44466=$1655;
      var $44467=$1656;
      __label__ = 11855; break;
    case 11855: // $44468
      __label__ = 14611; break;
    case 11856: // $44469
      var $44470=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44471=$44470.f0;
      $4692=$44471;
      var $44472=$44470.f1;
      $4693=$44472;
      var $44473=$1651;
      var $44474=$1652;
      var $44475=$1653;
      HEAP32[(($1651)>>2)]=$13501;
      HEAP32[(($1652)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1653)>>2)]=89;
      var $44476=HEAP32[(($1651)>>2)];
      var $44477=(($44476)|0)!=0;
      if ($44477) { __label__ = 11857; break; } else { __label__ = 11859; break; }
    case 11857: // $44478
      var $44479=HEAP32[(($1651)>>2)];
      var $44480=HEAP32[(($1652)>>2)];
      var $44481=HEAP32[(($1653)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44479, $44480, $44481) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11858; break; } else { __label__ = 14612; break; }
    case 11858: // $_noexc1239
      __label__ = 11859; break;
    case 11859: // $_ZdlPvPKci_exit1240
      var $44482=$1651;
      var $44483=$1652;
      var $44484=$1653;
      __label__ = 11860; break;
    case 11860: // $44485
      __label__ = 14611; break;
    case 11861: // $44486
      var $44487=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44488=$44487.f0;
      $4692=$44488;
      var $44489=$44487.f1;
      $4693=$44489;
      var $44490=$1648;
      var $44491=$1649;
      var $44492=$1650;
      HEAP32[(($1648)>>2)]=$13552;
      HEAP32[(($1649)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1650)>>2)]=90;
      var $44493=HEAP32[(($1648)>>2)];
      var $44494=(($44493)|0)!=0;
      if ($44494) { __label__ = 11862; break; } else { __label__ = 11864; break; }
    case 11862: // $44495
      var $44496=HEAP32[(($1648)>>2)];
      var $44497=HEAP32[(($1649)>>2)];
      var $44498=HEAP32[(($1650)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44496, $44497, $44498) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11863; break; } else { __label__ = 14612; break; }
    case 11863: // $_noexc1241
      __label__ = 11864; break;
    case 11864: // $_ZdlPvPKci_exit1242
      var $44499=$1648;
      var $44500=$1649;
      var $44501=$1650;
      __label__ = 11865; break;
    case 11865: // $44502
      __label__ = 14611; break;
    case 11866: // $44503
      var $44504=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44505=$44504.f0;
      $4692=$44505;
      var $44506=$44504.f1;
      $4693=$44506;
      var $44507=$1645;
      var $44508=$1646;
      var $44509=$1647;
      HEAP32[(($1645)>>2)]=$13603;
      HEAP32[(($1646)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1647)>>2)]=91;
      var $44510=HEAP32[(($1645)>>2)];
      var $44511=(($44510)|0)!=0;
      if ($44511) { __label__ = 11867; break; } else { __label__ = 11869; break; }
    case 11867: // $44512
      var $44513=HEAP32[(($1645)>>2)];
      var $44514=HEAP32[(($1646)>>2)];
      var $44515=HEAP32[(($1647)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44513, $44514, $44515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11868; break; } else { __label__ = 14612; break; }
    case 11868: // $_noexc1243
      __label__ = 11869; break;
    case 11869: // $_ZdlPvPKci_exit1244
      var $44516=$1645;
      var $44517=$1646;
      var $44518=$1647;
      __label__ = 11870; break;
    case 11870: // $44519
      __label__ = 14611; break;
    case 11871: // $44520
      var $44521=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44522=$44521.f0;
      $4692=$44522;
      var $44523=$44521.f1;
      $4693=$44523;
      var $44524=$1642;
      var $44525=$1643;
      var $44526=$1644;
      HEAP32[(($1642)>>2)]=$13654;
      HEAP32[(($1643)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1644)>>2)]=92;
      var $44527=HEAP32[(($1642)>>2)];
      var $44528=(($44527)|0)!=0;
      if ($44528) { __label__ = 11872; break; } else { __label__ = 11874; break; }
    case 11872: // $44529
      var $44530=HEAP32[(($1642)>>2)];
      var $44531=HEAP32[(($1643)>>2)];
      var $44532=HEAP32[(($1644)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44530, $44531, $44532) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11873; break; } else { __label__ = 14612; break; }
    case 11873: // $_noexc1245
      __label__ = 11874; break;
    case 11874: // $_ZdlPvPKci_exit1246
      var $44533=$1642;
      var $44534=$1643;
      var $44535=$1644;
      __label__ = 11875; break;
    case 11875: // $44536
      __label__ = 14611; break;
    case 11876: // $44537
      var $44538=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44539=$44538.f0;
      $4692=$44539;
      var $44540=$44538.f1;
      $4693=$44540;
      var $44541=$1639;
      var $44542=$1640;
      var $44543=$1641;
      HEAP32[(($1639)>>2)]=$13705;
      HEAP32[(($1640)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1641)>>2)]=93;
      var $44544=HEAP32[(($1639)>>2)];
      var $44545=(($44544)|0)!=0;
      if ($44545) { __label__ = 11877; break; } else { __label__ = 11879; break; }
    case 11877: // $44546
      var $44547=HEAP32[(($1639)>>2)];
      var $44548=HEAP32[(($1640)>>2)];
      var $44549=HEAP32[(($1641)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44547, $44548, $44549) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11878; break; } else { __label__ = 14612; break; }
    case 11878: // $_noexc1247
      __label__ = 11879; break;
    case 11879: // $_ZdlPvPKci_exit1248
      var $44550=$1639;
      var $44551=$1640;
      var $44552=$1641;
      __label__ = 11880; break;
    case 11880: // $44553
      __label__ = 14611; break;
    case 11881: // $44554
      var $44555=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44556=$44555.f0;
      $4692=$44556;
      var $44557=$44555.f1;
      $4693=$44557;
      var $44558=$1636;
      var $44559=$1637;
      var $44560=$1638;
      HEAP32[(($1636)>>2)]=$13756;
      HEAP32[(($1637)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1638)>>2)]=94;
      var $44561=HEAP32[(($1636)>>2)];
      var $44562=(($44561)|0)!=0;
      if ($44562) { __label__ = 11882; break; } else { __label__ = 11884; break; }
    case 11882: // $44563
      var $44564=HEAP32[(($1636)>>2)];
      var $44565=HEAP32[(($1637)>>2)];
      var $44566=HEAP32[(($1638)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44564, $44565, $44566) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11883; break; } else { __label__ = 14612; break; }
    case 11883: // $_noexc1249
      __label__ = 11884; break;
    case 11884: // $_ZdlPvPKci_exit1250
      var $44567=$1636;
      var $44568=$1637;
      var $44569=$1638;
      __label__ = 11885; break;
    case 11885: // $44570
      __label__ = 14611; break;
    case 11886: // $44571
      var $44572=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44573=$44572.f0;
      $4692=$44573;
      var $44574=$44572.f1;
      $4693=$44574;
      var $44575=$1633;
      var $44576=$1634;
      var $44577=$1635;
      HEAP32[(($1633)>>2)]=$13807;
      HEAP32[(($1634)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1635)>>2)]=95;
      var $44578=HEAP32[(($1633)>>2)];
      var $44579=(($44578)|0)!=0;
      if ($44579) { __label__ = 11887; break; } else { __label__ = 11889; break; }
    case 11887: // $44580
      var $44581=HEAP32[(($1633)>>2)];
      var $44582=HEAP32[(($1634)>>2)];
      var $44583=HEAP32[(($1635)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44581, $44582, $44583) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11888; break; } else { __label__ = 14612; break; }
    case 11888: // $_noexc1251
      __label__ = 11889; break;
    case 11889: // $_ZdlPvPKci_exit1252
      var $44584=$1633;
      var $44585=$1634;
      var $44586=$1635;
      __label__ = 11890; break;
    case 11890: // $44587
      __label__ = 14611; break;
    case 11891: // $44588
      var $44589=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44590=$44589.f0;
      $4692=$44590;
      var $44591=$44589.f1;
      $4693=$44591;
      var $44592=$1630;
      var $44593=$1631;
      var $44594=$1632;
      HEAP32[(($1630)>>2)]=$13858;
      HEAP32[(($1631)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1632)>>2)]=96;
      var $44595=HEAP32[(($1630)>>2)];
      var $44596=(($44595)|0)!=0;
      if ($44596) { __label__ = 11892; break; } else { __label__ = 11894; break; }
    case 11892: // $44597
      var $44598=HEAP32[(($1630)>>2)];
      var $44599=HEAP32[(($1631)>>2)];
      var $44600=HEAP32[(($1632)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44598, $44599, $44600) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11893; break; } else { __label__ = 14612; break; }
    case 11893: // $_noexc1253
      __label__ = 11894; break;
    case 11894: // $_ZdlPvPKci_exit1254
      var $44601=$1630;
      var $44602=$1631;
      var $44603=$1632;
      __label__ = 11895; break;
    case 11895: // $44604
      __label__ = 14611; break;
    case 11896: // $44605
      var $44606=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44607=$44606.f0;
      $4692=$44607;
      var $44608=$44606.f1;
      $4693=$44608;
      var $44609=$1627;
      var $44610=$1628;
      var $44611=$1629;
      HEAP32[(($1627)>>2)]=$13909;
      HEAP32[(($1628)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1629)>>2)]=97;
      var $44612=HEAP32[(($1627)>>2)];
      var $44613=(($44612)|0)!=0;
      if ($44613) { __label__ = 11897; break; } else { __label__ = 11899; break; }
    case 11897: // $44614
      var $44615=HEAP32[(($1627)>>2)];
      var $44616=HEAP32[(($1628)>>2)];
      var $44617=HEAP32[(($1629)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44615, $44616, $44617) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11898; break; } else { __label__ = 14612; break; }
    case 11898: // $_noexc1255
      __label__ = 11899; break;
    case 11899: // $_ZdlPvPKci_exit1256
      var $44618=$1627;
      var $44619=$1628;
      var $44620=$1629;
      __label__ = 11900; break;
    case 11900: // $44621
      __label__ = 14611; break;
    case 11901: // $44622
      var $44623=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44624=$44623.f0;
      $4692=$44624;
      var $44625=$44623.f1;
      $4693=$44625;
      var $44626=$1624;
      var $44627=$1625;
      var $44628=$1626;
      HEAP32[(($1624)>>2)]=$13960;
      HEAP32[(($1625)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1626)>>2)]=98;
      var $44629=HEAP32[(($1624)>>2)];
      var $44630=(($44629)|0)!=0;
      if ($44630) { __label__ = 11902; break; } else { __label__ = 11904; break; }
    case 11902: // $44631
      var $44632=HEAP32[(($1624)>>2)];
      var $44633=HEAP32[(($1625)>>2)];
      var $44634=HEAP32[(($1626)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44632, $44633, $44634) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11903; break; } else { __label__ = 14612; break; }
    case 11903: // $_noexc1257
      __label__ = 11904; break;
    case 11904: // $_ZdlPvPKci_exit1258
      var $44635=$1624;
      var $44636=$1625;
      var $44637=$1626;
      __label__ = 11905; break;
    case 11905: // $44638
      __label__ = 14611; break;
    case 11906: // $44639
      var $44640=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44641=$44640.f0;
      $4692=$44641;
      var $44642=$44640.f1;
      $4693=$44642;
      var $44643=$1621;
      var $44644=$1622;
      var $44645=$1623;
      HEAP32[(($1621)>>2)]=$14011;
      HEAP32[(($1622)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1623)>>2)]=99;
      var $44646=HEAP32[(($1621)>>2)];
      var $44647=(($44646)|0)!=0;
      if ($44647) { __label__ = 11907; break; } else { __label__ = 11909; break; }
    case 11907: // $44648
      var $44649=HEAP32[(($1621)>>2)];
      var $44650=HEAP32[(($1622)>>2)];
      var $44651=HEAP32[(($1623)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44649, $44650, $44651) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11908; break; } else { __label__ = 14612; break; }
    case 11908: // $_noexc1259
      __label__ = 11909; break;
    case 11909: // $_ZdlPvPKci_exit1260
      var $44652=$1621;
      var $44653=$1622;
      var $44654=$1623;
      __label__ = 11910; break;
    case 11910: // $44655
      __label__ = 14611; break;
    case 11911: // $44656
      var $44657=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44658=$44657.f0;
      $4692=$44658;
      var $44659=$44657.f1;
      $4693=$44659;
      var $44660=$1618;
      var $44661=$1619;
      var $44662=$1620;
      HEAP32[(($1618)>>2)]=$14062;
      HEAP32[(($1619)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1620)>>2)]=100;
      var $44663=HEAP32[(($1618)>>2)];
      var $44664=(($44663)|0)!=0;
      if ($44664) { __label__ = 11912; break; } else { __label__ = 11914; break; }
    case 11912: // $44665
      var $44666=HEAP32[(($1618)>>2)];
      var $44667=HEAP32[(($1619)>>2)];
      var $44668=HEAP32[(($1620)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44666, $44667, $44668) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11913; break; } else { __label__ = 14612; break; }
    case 11913: // $_noexc1261
      __label__ = 11914; break;
    case 11914: // $_ZdlPvPKci_exit1262
      var $44669=$1618;
      var $44670=$1619;
      var $44671=$1620;
      __label__ = 11915; break;
    case 11915: // $44672
      __label__ = 14611; break;
    case 11916: // $44673
      var $44674=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44675=$44674.f0;
      $4692=$44675;
      var $44676=$44674.f1;
      $4693=$44676;
      var $44677=$1615;
      var $44678=$1616;
      var $44679=$1617;
      HEAP32[(($1615)>>2)]=$14113;
      HEAP32[(($1616)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1617)>>2)]=101;
      var $44680=HEAP32[(($1615)>>2)];
      var $44681=(($44680)|0)!=0;
      if ($44681) { __label__ = 11917; break; } else { __label__ = 11919; break; }
    case 11917: // $44682
      var $44683=HEAP32[(($1615)>>2)];
      var $44684=HEAP32[(($1616)>>2)];
      var $44685=HEAP32[(($1617)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44683, $44684, $44685) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11918; break; } else { __label__ = 14612; break; }
    case 11918: // $_noexc1263
      __label__ = 11919; break;
    case 11919: // $_ZdlPvPKci_exit1264
      var $44686=$1615;
      var $44687=$1616;
      var $44688=$1617;
      __label__ = 11920; break;
    case 11920: // $44689
      __label__ = 14611; break;
    case 11921: // $44690
      var $44691=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44692=$44691.f0;
      $4692=$44692;
      var $44693=$44691.f1;
      $4693=$44693;
      var $44694=$1612;
      var $44695=$1613;
      var $44696=$1614;
      HEAP32[(($1612)>>2)]=$14164;
      HEAP32[(($1613)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1614)>>2)]=102;
      var $44697=HEAP32[(($1612)>>2)];
      var $44698=(($44697)|0)!=0;
      if ($44698) { __label__ = 11922; break; } else { __label__ = 11924; break; }
    case 11922: // $44699
      var $44700=HEAP32[(($1612)>>2)];
      var $44701=HEAP32[(($1613)>>2)];
      var $44702=HEAP32[(($1614)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44700, $44701, $44702) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11923; break; } else { __label__ = 14612; break; }
    case 11923: // $_noexc1265
      __label__ = 11924; break;
    case 11924: // $_ZdlPvPKci_exit1266
      var $44703=$1612;
      var $44704=$1613;
      var $44705=$1614;
      __label__ = 11925; break;
    case 11925: // $44706
      __label__ = 14611; break;
    case 11926: // $44707
      var $44708=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44709=$44708.f0;
      $4692=$44709;
      var $44710=$44708.f1;
      $4693=$44710;
      var $44711=$1609;
      var $44712=$1610;
      var $44713=$1611;
      HEAP32[(($1609)>>2)]=$14215;
      HEAP32[(($1610)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1611)>>2)]=103;
      var $44714=HEAP32[(($1609)>>2)];
      var $44715=(($44714)|0)!=0;
      if ($44715) { __label__ = 11927; break; } else { __label__ = 11929; break; }
    case 11927: // $44716
      var $44717=HEAP32[(($1609)>>2)];
      var $44718=HEAP32[(($1610)>>2)];
      var $44719=HEAP32[(($1611)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44717, $44718, $44719) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11928; break; } else { __label__ = 14612; break; }
    case 11928: // $_noexc1267
      __label__ = 11929; break;
    case 11929: // $_ZdlPvPKci_exit1268
      var $44720=$1609;
      var $44721=$1610;
      var $44722=$1611;
      __label__ = 11930; break;
    case 11930: // $44723
      __label__ = 14611; break;
    case 11931: // $44724
      var $44725=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44726=$44725.f0;
      $4692=$44726;
      var $44727=$44725.f1;
      $4693=$44727;
      var $44728=$1606;
      var $44729=$1607;
      var $44730=$1608;
      HEAP32[(($1606)>>2)]=$14266;
      HEAP32[(($1607)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1608)>>2)]=104;
      var $44731=HEAP32[(($1606)>>2)];
      var $44732=(($44731)|0)!=0;
      if ($44732) { __label__ = 11932; break; } else { __label__ = 11934; break; }
    case 11932: // $44733
      var $44734=HEAP32[(($1606)>>2)];
      var $44735=HEAP32[(($1607)>>2)];
      var $44736=HEAP32[(($1608)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44734, $44735, $44736) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11933; break; } else { __label__ = 14612; break; }
    case 11933: // $_noexc1269
      __label__ = 11934; break;
    case 11934: // $_ZdlPvPKci_exit1270
      var $44737=$1606;
      var $44738=$1607;
      var $44739=$1608;
      __label__ = 11935; break;
    case 11935: // $44740
      __label__ = 14611; break;
    case 11936: // $44741
      var $44742=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44743=$44742.f0;
      $4692=$44743;
      var $44744=$44742.f1;
      $4693=$44744;
      var $44745=$1603;
      var $44746=$1604;
      var $44747=$1605;
      HEAP32[(($1603)>>2)]=$14317;
      HEAP32[(($1604)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1605)>>2)]=105;
      var $44748=HEAP32[(($1603)>>2)];
      var $44749=(($44748)|0)!=0;
      if ($44749) { __label__ = 11937; break; } else { __label__ = 11939; break; }
    case 11937: // $44750
      var $44751=HEAP32[(($1603)>>2)];
      var $44752=HEAP32[(($1604)>>2)];
      var $44753=HEAP32[(($1605)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44751, $44752, $44753) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11938; break; } else { __label__ = 14612; break; }
    case 11938: // $_noexc1271
      __label__ = 11939; break;
    case 11939: // $_ZdlPvPKci_exit1272
      var $44754=$1603;
      var $44755=$1604;
      var $44756=$1605;
      __label__ = 11940; break;
    case 11940: // $44757
      __label__ = 14611; break;
    case 11941: // $44758
      var $44759=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44760=$44759.f0;
      $4692=$44760;
      var $44761=$44759.f1;
      $4693=$44761;
      var $44762=$1600;
      var $44763=$1601;
      var $44764=$1602;
      HEAP32[(($1600)>>2)]=$14368;
      HEAP32[(($1601)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1602)>>2)]=106;
      var $44765=HEAP32[(($1600)>>2)];
      var $44766=(($44765)|0)!=0;
      if ($44766) { __label__ = 11942; break; } else { __label__ = 11944; break; }
    case 11942: // $44767
      var $44768=HEAP32[(($1600)>>2)];
      var $44769=HEAP32[(($1601)>>2)];
      var $44770=HEAP32[(($1602)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44768, $44769, $44770) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11943; break; } else { __label__ = 14612; break; }
    case 11943: // $_noexc1273
      __label__ = 11944; break;
    case 11944: // $_ZdlPvPKci_exit1274
      var $44771=$1600;
      var $44772=$1601;
      var $44773=$1602;
      __label__ = 11945; break;
    case 11945: // $44774
      __label__ = 14611; break;
    case 11946: // $44775
      var $44776=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44777=$44776.f0;
      $4692=$44777;
      var $44778=$44776.f1;
      $4693=$44778;
      var $44779=$1597;
      var $44780=$1598;
      var $44781=$1599;
      HEAP32[(($1597)>>2)]=$14419;
      HEAP32[(($1598)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1599)>>2)]=107;
      var $44782=HEAP32[(($1597)>>2)];
      var $44783=(($44782)|0)!=0;
      if ($44783) { __label__ = 11947; break; } else { __label__ = 11949; break; }
    case 11947: // $44784
      var $44785=HEAP32[(($1597)>>2)];
      var $44786=HEAP32[(($1598)>>2)];
      var $44787=HEAP32[(($1599)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44785, $44786, $44787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11948; break; } else { __label__ = 14612; break; }
    case 11948: // $_noexc1275
      __label__ = 11949; break;
    case 11949: // $_ZdlPvPKci_exit1276
      var $44788=$1597;
      var $44789=$1598;
      var $44790=$1599;
      __label__ = 11950; break;
    case 11950: // $44791
      __label__ = 14611; break;
    case 11951: // $44792
      var $44793=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44794=$44793.f0;
      $4692=$44794;
      var $44795=$44793.f1;
      $4693=$44795;
      var $44796=$1594;
      var $44797=$1595;
      var $44798=$1596;
      HEAP32[(($1594)>>2)]=$14470;
      HEAP32[(($1595)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1596)>>2)]=108;
      var $44799=HEAP32[(($1594)>>2)];
      var $44800=(($44799)|0)!=0;
      if ($44800) { __label__ = 11952; break; } else { __label__ = 11954; break; }
    case 11952: // $44801
      var $44802=HEAP32[(($1594)>>2)];
      var $44803=HEAP32[(($1595)>>2)];
      var $44804=HEAP32[(($1596)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44802, $44803, $44804) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11953; break; } else { __label__ = 14612; break; }
    case 11953: // $_noexc1277
      __label__ = 11954; break;
    case 11954: // $_ZdlPvPKci_exit1278
      var $44805=$1594;
      var $44806=$1595;
      var $44807=$1596;
      __label__ = 11955; break;
    case 11955: // $44808
      __label__ = 14611; break;
    case 11956: // $44809
      var $44810=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44811=$44810.f0;
      $4692=$44811;
      var $44812=$44810.f1;
      $4693=$44812;
      var $44813=$1591;
      var $44814=$1592;
      var $44815=$1593;
      HEAP32[(($1591)>>2)]=$14521;
      HEAP32[(($1592)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1593)>>2)]=109;
      var $44816=HEAP32[(($1591)>>2)];
      var $44817=(($44816)|0)!=0;
      if ($44817) { __label__ = 11957; break; } else { __label__ = 11959; break; }
    case 11957: // $44818
      var $44819=HEAP32[(($1591)>>2)];
      var $44820=HEAP32[(($1592)>>2)];
      var $44821=HEAP32[(($1593)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44819, $44820, $44821) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11958; break; } else { __label__ = 14612; break; }
    case 11958: // $_noexc1279
      __label__ = 11959; break;
    case 11959: // $_ZdlPvPKci_exit1280
      var $44822=$1591;
      var $44823=$1592;
      var $44824=$1593;
      __label__ = 11960; break;
    case 11960: // $44825
      __label__ = 14611; break;
    case 11961: // $44826
      var $44827=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44828=$44827.f0;
      $4692=$44828;
      var $44829=$44827.f1;
      $4693=$44829;
      var $44830=$1588;
      var $44831=$1589;
      var $44832=$1590;
      HEAP32[(($1588)>>2)]=$14572;
      HEAP32[(($1589)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1590)>>2)]=110;
      var $44833=HEAP32[(($1588)>>2)];
      var $44834=(($44833)|0)!=0;
      if ($44834) { __label__ = 11962; break; } else { __label__ = 11964; break; }
    case 11962: // $44835
      var $44836=HEAP32[(($1588)>>2)];
      var $44837=HEAP32[(($1589)>>2)];
      var $44838=HEAP32[(($1590)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44836, $44837, $44838) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11963; break; } else { __label__ = 14612; break; }
    case 11963: // $_noexc1281
      __label__ = 11964; break;
    case 11964: // $_ZdlPvPKci_exit1282
      var $44839=$1588;
      var $44840=$1589;
      var $44841=$1590;
      __label__ = 11965; break;
    case 11965: // $44842
      __label__ = 14611; break;
    case 11966: // $44843
      var $44844=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44845=$44844.f0;
      $4692=$44845;
      var $44846=$44844.f1;
      $4693=$44846;
      var $44847=$1585;
      var $44848=$1586;
      var $44849=$1587;
      HEAP32[(($1585)>>2)]=$14623;
      HEAP32[(($1586)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1587)>>2)]=111;
      var $44850=HEAP32[(($1585)>>2)];
      var $44851=(($44850)|0)!=0;
      if ($44851) { __label__ = 11967; break; } else { __label__ = 11969; break; }
    case 11967: // $44852
      var $44853=HEAP32[(($1585)>>2)];
      var $44854=HEAP32[(($1586)>>2)];
      var $44855=HEAP32[(($1587)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44853, $44854, $44855) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11968; break; } else { __label__ = 14612; break; }
    case 11968: // $_noexc1283
      __label__ = 11969; break;
    case 11969: // $_ZdlPvPKci_exit1284
      var $44856=$1585;
      var $44857=$1586;
      var $44858=$1587;
      __label__ = 11970; break;
    case 11970: // $44859
      __label__ = 14611; break;
    case 11971: // $44860
      var $44861=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44862=$44861.f0;
      $4692=$44862;
      var $44863=$44861.f1;
      $4693=$44863;
      var $44864=$1582;
      var $44865=$1583;
      var $44866=$1584;
      HEAP32[(($1582)>>2)]=$14674;
      HEAP32[(($1583)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1584)>>2)]=112;
      var $44867=HEAP32[(($1582)>>2)];
      var $44868=(($44867)|0)!=0;
      if ($44868) { __label__ = 11972; break; } else { __label__ = 11974; break; }
    case 11972: // $44869
      var $44870=HEAP32[(($1582)>>2)];
      var $44871=HEAP32[(($1583)>>2)];
      var $44872=HEAP32[(($1584)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44870, $44871, $44872) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11973; break; } else { __label__ = 14612; break; }
    case 11973: // $_noexc1285
      __label__ = 11974; break;
    case 11974: // $_ZdlPvPKci_exit1286
      var $44873=$1582;
      var $44874=$1583;
      var $44875=$1584;
      __label__ = 11975; break;
    case 11975: // $44876
      __label__ = 14611; break;
    case 11976: // $44877
      var $44878=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44879=$44878.f0;
      $4692=$44879;
      var $44880=$44878.f1;
      $4693=$44880;
      var $44881=$1579;
      var $44882=$1580;
      var $44883=$1581;
      HEAP32[(($1579)>>2)]=$14725;
      HEAP32[(($1580)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1581)>>2)]=113;
      var $44884=HEAP32[(($1579)>>2)];
      var $44885=(($44884)|0)!=0;
      if ($44885) { __label__ = 11977; break; } else { __label__ = 11979; break; }
    case 11977: // $44886
      var $44887=HEAP32[(($1579)>>2)];
      var $44888=HEAP32[(($1580)>>2)];
      var $44889=HEAP32[(($1581)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44887, $44888, $44889) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11978; break; } else { __label__ = 14612; break; }
    case 11978: // $_noexc1287
      __label__ = 11979; break;
    case 11979: // $_ZdlPvPKci_exit1288
      var $44890=$1579;
      var $44891=$1580;
      var $44892=$1581;
      __label__ = 11980; break;
    case 11980: // $44893
      __label__ = 14611; break;
    case 11981: // $44894
      var $44895=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44896=$44895.f0;
      $4692=$44896;
      var $44897=$44895.f1;
      $4693=$44897;
      var $44898=$1576;
      var $44899=$1577;
      var $44900=$1578;
      HEAP32[(($1576)>>2)]=$14776;
      HEAP32[(($1577)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1578)>>2)]=114;
      var $44901=HEAP32[(($1576)>>2)];
      var $44902=(($44901)|0)!=0;
      if ($44902) { __label__ = 11982; break; } else { __label__ = 11984; break; }
    case 11982: // $44903
      var $44904=HEAP32[(($1576)>>2)];
      var $44905=HEAP32[(($1577)>>2)];
      var $44906=HEAP32[(($1578)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44904, $44905, $44906) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11983; break; } else { __label__ = 14612; break; }
    case 11983: // $_noexc1289
      __label__ = 11984; break;
    case 11984: // $_ZdlPvPKci_exit1290
      var $44907=$1576;
      var $44908=$1577;
      var $44909=$1578;
      __label__ = 11985; break;
    case 11985: // $44910
      __label__ = 14611; break;
    case 11986: // $44911
      var $44912=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44913=$44912.f0;
      $4692=$44913;
      var $44914=$44912.f1;
      $4693=$44914;
      var $44915=$1573;
      var $44916=$1574;
      var $44917=$1575;
      HEAP32[(($1573)>>2)]=$14827;
      HEAP32[(($1574)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1575)>>2)]=115;
      var $44918=HEAP32[(($1573)>>2)];
      var $44919=(($44918)|0)!=0;
      if ($44919) { __label__ = 11987; break; } else { __label__ = 11989; break; }
    case 11987: // $44920
      var $44921=HEAP32[(($1573)>>2)];
      var $44922=HEAP32[(($1574)>>2)];
      var $44923=HEAP32[(($1575)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44921, $44922, $44923) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11988; break; } else { __label__ = 14612; break; }
    case 11988: // $_noexc1291
      __label__ = 11989; break;
    case 11989: // $_ZdlPvPKci_exit1292
      var $44924=$1573;
      var $44925=$1574;
      var $44926=$1575;
      __label__ = 11990; break;
    case 11990: // $44927
      __label__ = 14611; break;
    case 11991: // $44928
      var $44929=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44930=$44929.f0;
      $4692=$44930;
      var $44931=$44929.f1;
      $4693=$44931;
      var $44932=$1570;
      var $44933=$1571;
      var $44934=$1572;
      HEAP32[(($1570)>>2)]=$14878;
      HEAP32[(($1571)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1572)>>2)]=116;
      var $44935=HEAP32[(($1570)>>2)];
      var $44936=(($44935)|0)!=0;
      if ($44936) { __label__ = 11992; break; } else { __label__ = 11994; break; }
    case 11992: // $44937
      var $44938=HEAP32[(($1570)>>2)];
      var $44939=HEAP32[(($1571)>>2)];
      var $44940=HEAP32[(($1572)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44938, $44939, $44940) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11993; break; } else { __label__ = 14612; break; }
    case 11993: // $_noexc1293
      __label__ = 11994; break;
    case 11994: // $_ZdlPvPKci_exit1294
      var $44941=$1570;
      var $44942=$1571;
      var $44943=$1572;
      __label__ = 11995; break;
    case 11995: // $44944
      __label__ = 14611; break;
    case 11996: // $44945
      var $44946=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44947=$44946.f0;
      $4692=$44947;
      var $44948=$44946.f1;
      $4693=$44948;
      var $44949=$1567;
      var $44950=$1568;
      var $44951=$1569;
      HEAP32[(($1567)>>2)]=$14929;
      HEAP32[(($1568)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1569)>>2)]=117;
      var $44952=HEAP32[(($1567)>>2)];
      var $44953=(($44952)|0)!=0;
      if ($44953) { __label__ = 11997; break; } else { __label__ = 11999; break; }
    case 11997: // $44954
      var $44955=HEAP32[(($1567)>>2)];
      var $44956=HEAP32[(($1568)>>2)];
      var $44957=HEAP32[(($1569)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44955, $44956, $44957) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11998; break; } else { __label__ = 14612; break; }
    case 11998: // $_noexc1295
      __label__ = 11999; break;
    case 11999: // $_ZdlPvPKci_exit1296
      var $44958=$1567;
      var $44959=$1568;
      var $44960=$1569;
      __label__ = 12000; break;
    case 12000: // $44961
      __label__ = 14611; break;
    case 12001: // $44962
      var $44963=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44964=$44963.f0;
      $4692=$44964;
      var $44965=$44963.f1;
      $4693=$44965;
      var $44966=$1564;
      var $44967=$1565;
      var $44968=$1566;
      HEAP32[(($1564)>>2)]=$14980;
      HEAP32[(($1565)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1566)>>2)]=118;
      var $44969=HEAP32[(($1564)>>2)];
      var $44970=(($44969)|0)!=0;
      if ($44970) { __label__ = 12002; break; } else { __label__ = 12004; break; }
    case 12002: // $44971
      var $44972=HEAP32[(($1564)>>2)];
      var $44973=HEAP32[(($1565)>>2)];
      var $44974=HEAP32[(($1566)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44972, $44973, $44974) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12003; break; } else { __label__ = 14612; break; }
    case 12003: // $_noexc1297
      __label__ = 12004; break;
    case 12004: // $_ZdlPvPKci_exit1298
      var $44975=$1564;
      var $44976=$1565;
      var $44977=$1566;
      __label__ = 12005; break;
    case 12005: // $44978
      __label__ = 14611; break;
    case 12006: // $44979
      var $44980=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44981=$44980.f0;
      $4692=$44981;
      var $44982=$44980.f1;
      $4693=$44982;
      var $44983=$1561;
      var $44984=$1562;
      var $44985=$1563;
      HEAP32[(($1561)>>2)]=$15031;
      HEAP32[(($1562)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1563)>>2)]=119;
      var $44986=HEAP32[(($1561)>>2)];
      var $44987=(($44986)|0)!=0;
      if ($44987) { __label__ = 12007; break; } else { __label__ = 12009; break; }
    case 12007: // $44988
      var $44989=HEAP32[(($1561)>>2)];
      var $44990=HEAP32[(($1562)>>2)];
      var $44991=HEAP32[(($1563)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($44989, $44990, $44991) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12008; break; } else { __label__ = 14612; break; }
    case 12008: // $_noexc1299
      __label__ = 12009; break;
    case 12009: // $_ZdlPvPKci_exit1300
      var $44992=$1561;
      var $44993=$1562;
      var $44994=$1563;
      __label__ = 12010; break;
    case 12010: // $44995
      __label__ = 14611; break;
    case 12011: // $44996
      var $44997=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44998=$44997.f0;
      $4692=$44998;
      var $44999=$44997.f1;
      $4693=$44999;
      var $45000=$1558;
      var $45001=$1559;
      var $45002=$1560;
      HEAP32[(($1558)>>2)]=$15082;
      HEAP32[(($1559)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1560)>>2)]=120;
      var $45003=HEAP32[(($1558)>>2)];
      var $45004=(($45003)|0)!=0;
      if ($45004) { __label__ = 12012; break; } else { __label__ = 12014; break; }
    case 12012: // $45005
      var $45006=HEAP32[(($1558)>>2)];
      var $45007=HEAP32[(($1559)>>2)];
      var $45008=HEAP32[(($1560)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45006, $45007, $45008) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12013; break; } else { __label__ = 14612; break; }
    case 12013: // $_noexc1301
      __label__ = 12014; break;
    case 12014: // $_ZdlPvPKci_exit1302
      var $45009=$1558;
      var $45010=$1559;
      var $45011=$1560;
      __label__ = 12015; break;
    case 12015: // $45012
      __label__ = 14611; break;
    case 12016: // $45013
      var $45014=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45015=$45014.f0;
      $4692=$45015;
      var $45016=$45014.f1;
      $4693=$45016;
      var $45017=$1555;
      var $45018=$1556;
      var $45019=$1557;
      HEAP32[(($1555)>>2)]=$15133;
      HEAP32[(($1556)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1557)>>2)]=121;
      var $45020=HEAP32[(($1555)>>2)];
      var $45021=(($45020)|0)!=0;
      if ($45021) { __label__ = 12017; break; } else { __label__ = 12019; break; }
    case 12017: // $45022
      var $45023=HEAP32[(($1555)>>2)];
      var $45024=HEAP32[(($1556)>>2)];
      var $45025=HEAP32[(($1557)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45023, $45024, $45025) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12018; break; } else { __label__ = 14612; break; }
    case 12018: // $_noexc1303
      __label__ = 12019; break;
    case 12019: // $_ZdlPvPKci_exit1304
      var $45026=$1555;
      var $45027=$1556;
      var $45028=$1557;
      __label__ = 12020; break;
    case 12020: // $45029
      __label__ = 14611; break;
    case 12021: // $45030
      var $45031=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45032=$45031.f0;
      $4692=$45032;
      var $45033=$45031.f1;
      $4693=$45033;
      var $45034=$1552;
      var $45035=$1553;
      var $45036=$1554;
      HEAP32[(($1552)>>2)]=$15184;
      HEAP32[(($1553)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1554)>>2)]=122;
      var $45037=HEAP32[(($1552)>>2)];
      var $45038=(($45037)|0)!=0;
      if ($45038) { __label__ = 12022; break; } else { __label__ = 12024; break; }
    case 12022: // $45039
      var $45040=HEAP32[(($1552)>>2)];
      var $45041=HEAP32[(($1553)>>2)];
      var $45042=HEAP32[(($1554)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45040, $45041, $45042) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12023; break; } else { __label__ = 14612; break; }
    case 12023: // $_noexc1305
      __label__ = 12024; break;
    case 12024: // $_ZdlPvPKci_exit1306
      var $45043=$1552;
      var $45044=$1553;
      var $45045=$1554;
      __label__ = 12025; break;
    case 12025: // $45046
      __label__ = 14611; break;
    case 12026: // $45047
      var $45048=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45049=$45048.f0;
      $4692=$45049;
      var $45050=$45048.f1;
      $4693=$45050;
      var $45051=$1549;
      var $45052=$1550;
      var $45053=$1551;
      HEAP32[(($1549)>>2)]=$15235;
      HEAP32[(($1550)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1551)>>2)]=123;
      var $45054=HEAP32[(($1549)>>2)];
      var $45055=(($45054)|0)!=0;
      if ($45055) { __label__ = 12027; break; } else { __label__ = 12029; break; }
    case 12027: // $45056
      var $45057=HEAP32[(($1549)>>2)];
      var $45058=HEAP32[(($1550)>>2)];
      var $45059=HEAP32[(($1551)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45057, $45058, $45059) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12028; break; } else { __label__ = 14612; break; }
    case 12028: // $_noexc1307
      __label__ = 12029; break;
    case 12029: // $_ZdlPvPKci_exit1308
      var $45060=$1549;
      var $45061=$1550;
      var $45062=$1551;
      __label__ = 12030; break;
    case 12030: // $45063
      __label__ = 14611; break;
    case 12031: // $45064
      var $45065=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45066=$45065.f0;
      $4692=$45066;
      var $45067=$45065.f1;
      $4693=$45067;
      var $45068=$1546;
      var $45069=$1547;
      var $45070=$1548;
      HEAP32[(($1546)>>2)]=$15286;
      HEAP32[(($1547)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1548)>>2)]=124;
      var $45071=HEAP32[(($1546)>>2)];
      var $45072=(($45071)|0)!=0;
      if ($45072) { __label__ = 12032; break; } else { __label__ = 12034; break; }
    case 12032: // $45073
      var $45074=HEAP32[(($1546)>>2)];
      var $45075=HEAP32[(($1547)>>2)];
      var $45076=HEAP32[(($1548)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45074, $45075, $45076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12033; break; } else { __label__ = 14612; break; }
    case 12033: // $_noexc1309
      __label__ = 12034; break;
    case 12034: // $_ZdlPvPKci_exit1310
      var $45077=$1546;
      var $45078=$1547;
      var $45079=$1548;
      __label__ = 12035; break;
    case 12035: // $45080
      __label__ = 14611; break;
    case 12036: // $45081
      var $45082=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45083=$45082.f0;
      $4692=$45083;
      var $45084=$45082.f1;
      $4693=$45084;
      var $45085=$1543;
      var $45086=$1544;
      var $45087=$1545;
      HEAP32[(($1543)>>2)]=$15337;
      HEAP32[(($1544)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1545)>>2)]=125;
      var $45088=HEAP32[(($1543)>>2)];
      var $45089=(($45088)|0)!=0;
      if ($45089) { __label__ = 12037; break; } else { __label__ = 12039; break; }
    case 12037: // $45090
      var $45091=HEAP32[(($1543)>>2)];
      var $45092=HEAP32[(($1544)>>2)];
      var $45093=HEAP32[(($1545)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45091, $45092, $45093) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12038; break; } else { __label__ = 14612; break; }
    case 12038: // $_noexc1311
      __label__ = 12039; break;
    case 12039: // $_ZdlPvPKci_exit1312
      var $45094=$1543;
      var $45095=$1544;
      var $45096=$1545;
      __label__ = 12040; break;
    case 12040: // $45097
      __label__ = 14611; break;
    case 12041: // $45098
      var $45099=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45100=$45099.f0;
      $4692=$45100;
      var $45101=$45099.f1;
      $4693=$45101;
      var $45102=$1540;
      var $45103=$1541;
      var $45104=$1542;
      HEAP32[(($1540)>>2)]=$15388;
      HEAP32[(($1541)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1542)>>2)]=126;
      var $45105=HEAP32[(($1540)>>2)];
      var $45106=(($45105)|0)!=0;
      if ($45106) { __label__ = 12042; break; } else { __label__ = 12044; break; }
    case 12042: // $45107
      var $45108=HEAP32[(($1540)>>2)];
      var $45109=HEAP32[(($1541)>>2)];
      var $45110=HEAP32[(($1542)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45108, $45109, $45110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12043; break; } else { __label__ = 14612; break; }
    case 12043: // $_noexc1313
      __label__ = 12044; break;
    case 12044: // $_ZdlPvPKci_exit1314
      var $45111=$1540;
      var $45112=$1541;
      var $45113=$1542;
      __label__ = 12045; break;
    case 12045: // $45114
      __label__ = 14611; break;
    case 12046: // $45115
      var $45116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45117=$45116.f0;
      $4692=$45117;
      var $45118=$45116.f1;
      $4693=$45118;
      var $45119=$1537;
      var $45120=$1538;
      var $45121=$1539;
      HEAP32[(($1537)>>2)]=$15439;
      HEAP32[(($1538)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1539)>>2)]=127;
      var $45122=HEAP32[(($1537)>>2)];
      var $45123=(($45122)|0)!=0;
      if ($45123) { __label__ = 12047; break; } else { __label__ = 12049; break; }
    case 12047: // $45124
      var $45125=HEAP32[(($1537)>>2)];
      var $45126=HEAP32[(($1538)>>2)];
      var $45127=HEAP32[(($1539)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45125, $45126, $45127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12048; break; } else { __label__ = 14612; break; }
    case 12048: // $_noexc1315
      __label__ = 12049; break;
    case 12049: // $_ZdlPvPKci_exit1316
      var $45128=$1537;
      var $45129=$1538;
      var $45130=$1539;
      __label__ = 12050; break;
    case 12050: // $45131
      __label__ = 14611; break;
    case 12051: // $45132
      var $45133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45134=$45133.f0;
      $4692=$45134;
      var $45135=$45133.f1;
      $4693=$45135;
      var $45136=$1534;
      var $45137=$1535;
      var $45138=$1536;
      HEAP32[(($1534)>>2)]=$15490;
      HEAP32[(($1535)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1536)>>2)]=128;
      var $45139=HEAP32[(($1534)>>2)];
      var $45140=(($45139)|0)!=0;
      if ($45140) { __label__ = 12052; break; } else { __label__ = 12054; break; }
    case 12052: // $45141
      var $45142=HEAP32[(($1534)>>2)];
      var $45143=HEAP32[(($1535)>>2)];
      var $45144=HEAP32[(($1536)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45142, $45143, $45144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12053; break; } else { __label__ = 14612; break; }
    case 12053: // $_noexc1317
      __label__ = 12054; break;
    case 12054: // $_ZdlPvPKci_exit1318
      var $45145=$1534;
      var $45146=$1535;
      var $45147=$1536;
      __label__ = 12055; break;
    case 12055: // $45148
      __label__ = 14611; break;
    case 12056: // $45149
      var $45150=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45151=$45150.f0;
      $4692=$45151;
      var $45152=$45150.f1;
      $4693=$45152;
      var $45153=$1531;
      var $45154=$1532;
      var $45155=$1533;
      HEAP32[(($1531)>>2)]=$15541;
      HEAP32[(($1532)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1533)>>2)]=129;
      var $45156=HEAP32[(($1531)>>2)];
      var $45157=(($45156)|0)!=0;
      if ($45157) { __label__ = 12057; break; } else { __label__ = 12059; break; }
    case 12057: // $45158
      var $45159=HEAP32[(($1531)>>2)];
      var $45160=HEAP32[(($1532)>>2)];
      var $45161=HEAP32[(($1533)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45159, $45160, $45161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12058; break; } else { __label__ = 14612; break; }
    case 12058: // $_noexc1319
      __label__ = 12059; break;
    case 12059: // $_ZdlPvPKci_exit1320
      var $45162=$1531;
      var $45163=$1532;
      var $45164=$1533;
      __label__ = 12060; break;
    case 12060: // $45165
      __label__ = 14611; break;
    case 12061: // $45166
      var $45167=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45168=$45167.f0;
      $4692=$45168;
      var $45169=$45167.f1;
      $4693=$45169;
      var $45170=$1528;
      var $45171=$1529;
      var $45172=$1530;
      HEAP32[(($1528)>>2)]=$15592;
      HEAP32[(($1529)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1530)>>2)]=130;
      var $45173=HEAP32[(($1528)>>2)];
      var $45174=(($45173)|0)!=0;
      if ($45174) { __label__ = 12062; break; } else { __label__ = 12064; break; }
    case 12062: // $45175
      var $45176=HEAP32[(($1528)>>2)];
      var $45177=HEAP32[(($1529)>>2)];
      var $45178=HEAP32[(($1530)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45176, $45177, $45178) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12063; break; } else { __label__ = 14612; break; }
    case 12063: // $_noexc1321
      __label__ = 12064; break;
    case 12064: // $_ZdlPvPKci_exit1322
      var $45179=$1528;
      var $45180=$1529;
      var $45181=$1530;
      __label__ = 12065; break;
    case 12065: // $45182
      __label__ = 14611; break;
    case 12066: // $45183
      var $45184=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45185=$45184.f0;
      $4692=$45185;
      var $45186=$45184.f1;
      $4693=$45186;
      var $45187=$1525;
      var $45188=$1526;
      var $45189=$1527;
      HEAP32[(($1525)>>2)]=$15643;
      HEAP32[(($1526)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1527)>>2)]=131;
      var $45190=HEAP32[(($1525)>>2)];
      var $45191=(($45190)|0)!=0;
      if ($45191) { __label__ = 12067; break; } else { __label__ = 12069; break; }
    case 12067: // $45192
      var $45193=HEAP32[(($1525)>>2)];
      var $45194=HEAP32[(($1526)>>2)];
      var $45195=HEAP32[(($1527)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45193, $45194, $45195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12068; break; } else { __label__ = 14612; break; }
    case 12068: // $_noexc1323
      __label__ = 12069; break;
    case 12069: // $_ZdlPvPKci_exit1324
      var $45196=$1525;
      var $45197=$1526;
      var $45198=$1527;
      __label__ = 12070; break;
    case 12070: // $45199
      __label__ = 14611; break;
    case 12071: // $45200
      var $45201=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45202=$45201.f0;
      $4692=$45202;
      var $45203=$45201.f1;
      $4693=$45203;
      var $45204=$1522;
      var $45205=$1523;
      var $45206=$1524;
      HEAP32[(($1522)>>2)]=$15694;
      HEAP32[(($1523)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1524)>>2)]=132;
      var $45207=HEAP32[(($1522)>>2)];
      var $45208=(($45207)|0)!=0;
      if ($45208) { __label__ = 12072; break; } else { __label__ = 12074; break; }
    case 12072: // $45209
      var $45210=HEAP32[(($1522)>>2)];
      var $45211=HEAP32[(($1523)>>2)];
      var $45212=HEAP32[(($1524)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45210, $45211, $45212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12073; break; } else { __label__ = 14612; break; }
    case 12073: // $_noexc1325
      __label__ = 12074; break;
    case 12074: // $_ZdlPvPKci_exit1326
      var $45213=$1522;
      var $45214=$1523;
      var $45215=$1524;
      __label__ = 12075; break;
    case 12075: // $45216
      __label__ = 14611; break;
    case 12076: // $45217
      var $45218=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45219=$45218.f0;
      $4692=$45219;
      var $45220=$45218.f1;
      $4693=$45220;
      var $45221=$1519;
      var $45222=$1520;
      var $45223=$1521;
      HEAP32[(($1519)>>2)]=$15745;
      HEAP32[(($1520)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1521)>>2)]=133;
      var $45224=HEAP32[(($1519)>>2)];
      var $45225=(($45224)|0)!=0;
      if ($45225) { __label__ = 12077; break; } else { __label__ = 12079; break; }
    case 12077: // $45226
      var $45227=HEAP32[(($1519)>>2)];
      var $45228=HEAP32[(($1520)>>2)];
      var $45229=HEAP32[(($1521)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45227, $45228, $45229) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12078; break; } else { __label__ = 14612; break; }
    case 12078: // $_noexc1327
      __label__ = 12079; break;
    case 12079: // $_ZdlPvPKci_exit1328
      var $45230=$1519;
      var $45231=$1520;
      var $45232=$1521;
      __label__ = 12080; break;
    case 12080: // $45233
      __label__ = 14611; break;
    case 12081: // $45234
      var $45235=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45236=$45235.f0;
      $4692=$45236;
      var $45237=$45235.f1;
      $4693=$45237;
      var $45238=$1516;
      var $45239=$1517;
      var $45240=$1518;
      HEAP32[(($1516)>>2)]=$15796;
      HEAP32[(($1517)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1518)>>2)]=134;
      var $45241=HEAP32[(($1516)>>2)];
      var $45242=(($45241)|0)!=0;
      if ($45242) { __label__ = 12082; break; } else { __label__ = 12084; break; }
    case 12082: // $45243
      var $45244=HEAP32[(($1516)>>2)];
      var $45245=HEAP32[(($1517)>>2)];
      var $45246=HEAP32[(($1518)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45244, $45245, $45246) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12083; break; } else { __label__ = 14612; break; }
    case 12083: // $_noexc1329
      __label__ = 12084; break;
    case 12084: // $_ZdlPvPKci_exit1330
      var $45247=$1516;
      var $45248=$1517;
      var $45249=$1518;
      __label__ = 12085; break;
    case 12085: // $45250
      __label__ = 14611; break;
    case 12086: // $45251
      var $45252=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45253=$45252.f0;
      $4692=$45253;
      var $45254=$45252.f1;
      $4693=$45254;
      var $45255=$1513;
      var $45256=$1514;
      var $45257=$1515;
      HEAP32[(($1513)>>2)]=$15847;
      HEAP32[(($1514)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1515)>>2)]=135;
      var $45258=HEAP32[(($1513)>>2)];
      var $45259=(($45258)|0)!=0;
      if ($45259) { __label__ = 12087; break; } else { __label__ = 12089; break; }
    case 12087: // $45260
      var $45261=HEAP32[(($1513)>>2)];
      var $45262=HEAP32[(($1514)>>2)];
      var $45263=HEAP32[(($1515)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45261, $45262, $45263) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12088; break; } else { __label__ = 14612; break; }
    case 12088: // $_noexc1331
      __label__ = 12089; break;
    case 12089: // $_ZdlPvPKci_exit1332
      var $45264=$1513;
      var $45265=$1514;
      var $45266=$1515;
      __label__ = 12090; break;
    case 12090: // $45267
      __label__ = 14611; break;
    case 12091: // $45268
      var $45269=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45270=$45269.f0;
      $4692=$45270;
      var $45271=$45269.f1;
      $4693=$45271;
      var $45272=$1510;
      var $45273=$1511;
      var $45274=$1512;
      HEAP32[(($1510)>>2)]=$15898;
      HEAP32[(($1511)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1512)>>2)]=136;
      var $45275=HEAP32[(($1510)>>2)];
      var $45276=(($45275)|0)!=0;
      if ($45276) { __label__ = 12092; break; } else { __label__ = 12094; break; }
    case 12092: // $45277
      var $45278=HEAP32[(($1510)>>2)];
      var $45279=HEAP32[(($1511)>>2)];
      var $45280=HEAP32[(($1512)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45278, $45279, $45280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12093; break; } else { __label__ = 14612; break; }
    case 12093: // $_noexc1333
      __label__ = 12094; break;
    case 12094: // $_ZdlPvPKci_exit1334
      var $45281=$1510;
      var $45282=$1511;
      var $45283=$1512;
      __label__ = 12095; break;
    case 12095: // $45284
      __label__ = 14611; break;
    case 12096: // $45285
      var $45286=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45287=$45286.f0;
      $4692=$45287;
      var $45288=$45286.f1;
      $4693=$45288;
      var $45289=$1507;
      var $45290=$1508;
      var $45291=$1509;
      HEAP32[(($1507)>>2)]=$15949;
      HEAP32[(($1508)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1509)>>2)]=137;
      var $45292=HEAP32[(($1507)>>2)];
      var $45293=(($45292)|0)!=0;
      if ($45293) { __label__ = 12097; break; } else { __label__ = 12099; break; }
    case 12097: // $45294
      var $45295=HEAP32[(($1507)>>2)];
      var $45296=HEAP32[(($1508)>>2)];
      var $45297=HEAP32[(($1509)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45295, $45296, $45297) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12098; break; } else { __label__ = 14612; break; }
    case 12098: // $_noexc1335
      __label__ = 12099; break;
    case 12099: // $_ZdlPvPKci_exit1336
      var $45298=$1507;
      var $45299=$1508;
      var $45300=$1509;
      __label__ = 12100; break;
    case 12100: // $45301
      __label__ = 14611; break;
    case 12101: // $45302
      var $45303=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45304=$45303.f0;
      $4692=$45304;
      var $45305=$45303.f1;
      $4693=$45305;
      var $45306=$1504;
      var $45307=$1505;
      var $45308=$1506;
      HEAP32[(($1504)>>2)]=$16000;
      HEAP32[(($1505)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1506)>>2)]=138;
      var $45309=HEAP32[(($1504)>>2)];
      var $45310=(($45309)|0)!=0;
      if ($45310) { __label__ = 12102; break; } else { __label__ = 12104; break; }
    case 12102: // $45311
      var $45312=HEAP32[(($1504)>>2)];
      var $45313=HEAP32[(($1505)>>2)];
      var $45314=HEAP32[(($1506)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45312, $45313, $45314) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12103; break; } else { __label__ = 14612; break; }
    case 12103: // $_noexc1337
      __label__ = 12104; break;
    case 12104: // $_ZdlPvPKci_exit1338
      var $45315=$1504;
      var $45316=$1505;
      var $45317=$1506;
      __label__ = 12105; break;
    case 12105: // $45318
      __label__ = 14611; break;
    case 12106: // $45319
      var $45320=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45321=$45320.f0;
      $4692=$45321;
      var $45322=$45320.f1;
      $4693=$45322;
      var $45323=$1501;
      var $45324=$1502;
      var $45325=$1503;
      HEAP32[(($1501)>>2)]=$16051;
      HEAP32[(($1502)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1503)>>2)]=139;
      var $45326=HEAP32[(($1501)>>2)];
      var $45327=(($45326)|0)!=0;
      if ($45327) { __label__ = 12107; break; } else { __label__ = 12109; break; }
    case 12107: // $45328
      var $45329=HEAP32[(($1501)>>2)];
      var $45330=HEAP32[(($1502)>>2)];
      var $45331=HEAP32[(($1503)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45329, $45330, $45331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12108; break; } else { __label__ = 14612; break; }
    case 12108: // $_noexc1339
      __label__ = 12109; break;
    case 12109: // $_ZdlPvPKci_exit1340
      var $45332=$1501;
      var $45333=$1502;
      var $45334=$1503;
      __label__ = 12110; break;
    case 12110: // $45335
      __label__ = 14611; break;
    case 12111: // $45336
      var $45337=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45338=$45337.f0;
      $4692=$45338;
      var $45339=$45337.f1;
      $4693=$45339;
      var $45340=$1498;
      var $45341=$1499;
      var $45342=$1500;
      HEAP32[(($1498)>>2)]=$16102;
      HEAP32[(($1499)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1500)>>2)]=140;
      var $45343=HEAP32[(($1498)>>2)];
      var $45344=(($45343)|0)!=0;
      if ($45344) { __label__ = 12112; break; } else { __label__ = 12114; break; }
    case 12112: // $45345
      var $45346=HEAP32[(($1498)>>2)];
      var $45347=HEAP32[(($1499)>>2)];
      var $45348=HEAP32[(($1500)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45346, $45347, $45348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12113; break; } else { __label__ = 14612; break; }
    case 12113: // $_noexc1341
      __label__ = 12114; break;
    case 12114: // $_ZdlPvPKci_exit1342
      var $45349=$1498;
      var $45350=$1499;
      var $45351=$1500;
      __label__ = 12115; break;
    case 12115: // $45352
      __label__ = 14611; break;
    case 12116: // $45353
      var $45354=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45355=$45354.f0;
      $4692=$45355;
      var $45356=$45354.f1;
      $4693=$45356;
      var $45357=$1495;
      var $45358=$1496;
      var $45359=$1497;
      HEAP32[(($1495)>>2)]=$16153;
      HEAP32[(($1496)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1497)>>2)]=141;
      var $45360=HEAP32[(($1495)>>2)];
      var $45361=(($45360)|0)!=0;
      if ($45361) { __label__ = 12117; break; } else { __label__ = 12119; break; }
    case 12117: // $45362
      var $45363=HEAP32[(($1495)>>2)];
      var $45364=HEAP32[(($1496)>>2)];
      var $45365=HEAP32[(($1497)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45363, $45364, $45365) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12118; break; } else { __label__ = 14612; break; }
    case 12118: // $_noexc1343
      __label__ = 12119; break;
    case 12119: // $_ZdlPvPKci_exit1344
      var $45366=$1495;
      var $45367=$1496;
      var $45368=$1497;
      __label__ = 12120; break;
    case 12120: // $45369
      __label__ = 14611; break;
    case 12121: // $45370
      var $45371=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45372=$45371.f0;
      $4692=$45372;
      var $45373=$45371.f1;
      $4693=$45373;
      var $45374=$1492;
      var $45375=$1493;
      var $45376=$1494;
      HEAP32[(($1492)>>2)]=$16204;
      HEAP32[(($1493)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1494)>>2)]=142;
      var $45377=HEAP32[(($1492)>>2)];
      var $45378=(($45377)|0)!=0;
      if ($45378) { __label__ = 12122; break; } else { __label__ = 12124; break; }
    case 12122: // $45379
      var $45380=HEAP32[(($1492)>>2)];
      var $45381=HEAP32[(($1493)>>2)];
      var $45382=HEAP32[(($1494)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45380, $45381, $45382) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12123; break; } else { __label__ = 14612; break; }
    case 12123: // $_noexc1345
      __label__ = 12124; break;
    case 12124: // $_ZdlPvPKci_exit1346
      var $45383=$1492;
      var $45384=$1493;
      var $45385=$1494;
      __label__ = 12125; break;
    case 12125: // $45386
      __label__ = 14611; break;
    case 12126: // $45387
      var $45388=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45389=$45388.f0;
      $4692=$45389;
      var $45390=$45388.f1;
      $4693=$45390;
      var $45391=$1489;
      var $45392=$1490;
      var $45393=$1491;
      HEAP32[(($1489)>>2)]=$16255;
      HEAP32[(($1490)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1491)>>2)]=143;
      var $45394=HEAP32[(($1489)>>2)];
      var $45395=(($45394)|0)!=0;
      if ($45395) { __label__ = 12127; break; } else { __label__ = 12129; break; }
    case 12127: // $45396
      var $45397=HEAP32[(($1489)>>2)];
      var $45398=HEAP32[(($1490)>>2)];
      var $45399=HEAP32[(($1491)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45397, $45398, $45399) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12128; break; } else { __label__ = 14612; break; }
    case 12128: // $_noexc1347
      __label__ = 12129; break;
    case 12129: // $_ZdlPvPKci_exit1348
      var $45400=$1489;
      var $45401=$1490;
      var $45402=$1491;
      __label__ = 12130; break;
    case 12130: // $45403
      __label__ = 14611; break;
    case 12131: // $45404
      var $45405=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45406=$45405.f0;
      $4692=$45406;
      var $45407=$45405.f1;
      $4693=$45407;
      var $45408=$1486;
      var $45409=$1487;
      var $45410=$1488;
      HEAP32[(($1486)>>2)]=$16306;
      HEAP32[(($1487)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1488)>>2)]=144;
      var $45411=HEAP32[(($1486)>>2)];
      var $45412=(($45411)|0)!=0;
      if ($45412) { __label__ = 12132; break; } else { __label__ = 12134; break; }
    case 12132: // $45413
      var $45414=HEAP32[(($1486)>>2)];
      var $45415=HEAP32[(($1487)>>2)];
      var $45416=HEAP32[(($1488)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45414, $45415, $45416) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12133; break; } else { __label__ = 14612; break; }
    case 12133: // $_noexc1349
      __label__ = 12134; break;
    case 12134: // $_ZdlPvPKci_exit1350
      var $45417=$1486;
      var $45418=$1487;
      var $45419=$1488;
      __label__ = 12135; break;
    case 12135: // $45420
      __label__ = 14611; break;
    case 12136: // $45421
      var $45422=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45423=$45422.f0;
      $4692=$45423;
      var $45424=$45422.f1;
      $4693=$45424;
      var $45425=$1483;
      var $45426=$1484;
      var $45427=$1485;
      HEAP32[(($1483)>>2)]=$16357;
      HEAP32[(($1484)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1485)>>2)]=145;
      var $45428=HEAP32[(($1483)>>2)];
      var $45429=(($45428)|0)!=0;
      if ($45429) { __label__ = 12137; break; } else { __label__ = 12139; break; }
    case 12137: // $45430
      var $45431=HEAP32[(($1483)>>2)];
      var $45432=HEAP32[(($1484)>>2)];
      var $45433=HEAP32[(($1485)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45431, $45432, $45433) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12138; break; } else { __label__ = 14612; break; }
    case 12138: // $_noexc1351
      __label__ = 12139; break;
    case 12139: // $_ZdlPvPKci_exit1352
      var $45434=$1483;
      var $45435=$1484;
      var $45436=$1485;
      __label__ = 12140; break;
    case 12140: // $45437
      __label__ = 14611; break;
    case 12141: // $45438
      var $45439=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45440=$45439.f0;
      $4692=$45440;
      var $45441=$45439.f1;
      $4693=$45441;
      var $45442=$1480;
      var $45443=$1481;
      var $45444=$1482;
      HEAP32[(($1480)>>2)]=$16408;
      HEAP32[(($1481)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1482)>>2)]=146;
      var $45445=HEAP32[(($1480)>>2)];
      var $45446=(($45445)|0)!=0;
      if ($45446) { __label__ = 12142; break; } else { __label__ = 12144; break; }
    case 12142: // $45447
      var $45448=HEAP32[(($1480)>>2)];
      var $45449=HEAP32[(($1481)>>2)];
      var $45450=HEAP32[(($1482)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45448, $45449, $45450) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12143; break; } else { __label__ = 14612; break; }
    case 12143: // $_noexc1353
      __label__ = 12144; break;
    case 12144: // $_ZdlPvPKci_exit1354
      var $45451=$1480;
      var $45452=$1481;
      var $45453=$1482;
      __label__ = 12145; break;
    case 12145: // $45454
      __label__ = 14611; break;
    case 12146: // $45455
      var $45456=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45457=$45456.f0;
      $4692=$45457;
      var $45458=$45456.f1;
      $4693=$45458;
      var $45459=$1477;
      var $45460=$1478;
      var $45461=$1479;
      HEAP32[(($1477)>>2)]=$16459;
      HEAP32[(($1478)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1479)>>2)]=147;
      var $45462=HEAP32[(($1477)>>2)];
      var $45463=(($45462)|0)!=0;
      if ($45463) { __label__ = 12147; break; } else { __label__ = 12149; break; }
    case 12147: // $45464
      var $45465=HEAP32[(($1477)>>2)];
      var $45466=HEAP32[(($1478)>>2)];
      var $45467=HEAP32[(($1479)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45465, $45466, $45467) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12148; break; } else { __label__ = 14612; break; }
    case 12148: // $_noexc1355
      __label__ = 12149; break;
    case 12149: // $_ZdlPvPKci_exit1356
      var $45468=$1477;
      var $45469=$1478;
      var $45470=$1479;
      __label__ = 12150; break;
    case 12150: // $45471
      __label__ = 14611; break;
    case 12151: // $45472
      var $45473=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45474=$45473.f0;
      $4692=$45474;
      var $45475=$45473.f1;
      $4693=$45475;
      var $45476=$1474;
      var $45477=$1475;
      var $45478=$1476;
      HEAP32[(($1474)>>2)]=$16510;
      HEAP32[(($1475)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1476)>>2)]=148;
      var $45479=HEAP32[(($1474)>>2)];
      var $45480=(($45479)|0)!=0;
      if ($45480) { __label__ = 12152; break; } else { __label__ = 12154; break; }
    case 12152: // $45481
      var $45482=HEAP32[(($1474)>>2)];
      var $45483=HEAP32[(($1475)>>2)];
      var $45484=HEAP32[(($1476)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45482, $45483, $45484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12153; break; } else { __label__ = 14612; break; }
    case 12153: // $_noexc1357
      __label__ = 12154; break;
    case 12154: // $_ZdlPvPKci_exit1358
      var $45485=$1474;
      var $45486=$1475;
      var $45487=$1476;
      __label__ = 12155; break;
    case 12155: // $45488
      __label__ = 14611; break;
    case 12156: // $45489
      var $45490=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45491=$45490.f0;
      $4692=$45491;
      var $45492=$45490.f1;
      $4693=$45492;
      var $45493=$1471;
      var $45494=$1472;
      var $45495=$1473;
      HEAP32[(($1471)>>2)]=$16561;
      HEAP32[(($1472)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1473)>>2)]=150;
      var $45496=HEAP32[(($1471)>>2)];
      var $45497=(($45496)|0)!=0;
      if ($45497) { __label__ = 12157; break; } else { __label__ = 12159; break; }
    case 12157: // $45498
      var $45499=HEAP32[(($1471)>>2)];
      var $45500=HEAP32[(($1472)>>2)];
      var $45501=HEAP32[(($1473)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45499, $45500, $45501) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12158; break; } else { __label__ = 14612; break; }
    case 12158: // $_noexc1359
      __label__ = 12159; break;
    case 12159: // $_ZdlPvPKci_exit1360
      var $45502=$1471;
      var $45503=$1472;
      var $45504=$1473;
      __label__ = 12160; break;
    case 12160: // $45505
      __label__ = 14611; break;
    case 12161: // $45506
      var $45507=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45508=$45507.f0;
      $4692=$45508;
      var $45509=$45507.f1;
      $4693=$45509;
      var $45510=$1468;
      var $45511=$1469;
      var $45512=$1470;
      HEAP32[(($1468)>>2)]=$16612;
      HEAP32[(($1469)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1470)>>2)]=151;
      var $45513=HEAP32[(($1468)>>2)];
      var $45514=(($45513)|0)!=0;
      if ($45514) { __label__ = 12162; break; } else { __label__ = 12164; break; }
    case 12162: // $45515
      var $45516=HEAP32[(($1468)>>2)];
      var $45517=HEAP32[(($1469)>>2)];
      var $45518=HEAP32[(($1470)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45516, $45517, $45518) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12163; break; } else { __label__ = 14612; break; }
    case 12163: // $_noexc1361
      __label__ = 12164; break;
    case 12164: // $_ZdlPvPKci_exit1362
      var $45519=$1468;
      var $45520=$1469;
      var $45521=$1470;
      __label__ = 12165; break;
    case 12165: // $45522
      __label__ = 14611; break;
    case 12166: // $45523
      var $45524=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45525=$45524.f0;
      $4692=$45525;
      var $45526=$45524.f1;
      $4693=$45526;
      var $45527=$1465;
      var $45528=$1466;
      var $45529=$1467;
      HEAP32[(($1465)>>2)]=$16663;
      HEAP32[(($1466)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1467)>>2)]=152;
      var $45530=HEAP32[(($1465)>>2)];
      var $45531=(($45530)|0)!=0;
      if ($45531) { __label__ = 12167; break; } else { __label__ = 12169; break; }
    case 12167: // $45532
      var $45533=HEAP32[(($1465)>>2)];
      var $45534=HEAP32[(($1466)>>2)];
      var $45535=HEAP32[(($1467)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45533, $45534, $45535) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12168; break; } else { __label__ = 14612; break; }
    case 12168: // $_noexc1363
      __label__ = 12169; break;
    case 12169: // $_ZdlPvPKci_exit1364
      var $45536=$1465;
      var $45537=$1466;
      var $45538=$1467;
      __label__ = 12170; break;
    case 12170: // $45539
      __label__ = 14611; break;
    case 12171: // $45540
      var $45541=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45542=$45541.f0;
      $4692=$45542;
      var $45543=$45541.f1;
      $4693=$45543;
      var $45544=$1462;
      var $45545=$1463;
      var $45546=$1464;
      HEAP32[(($1462)>>2)]=$16714;
      HEAP32[(($1463)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1464)>>2)]=153;
      var $45547=HEAP32[(($1462)>>2)];
      var $45548=(($45547)|0)!=0;
      if ($45548) { __label__ = 12172; break; } else { __label__ = 12174; break; }
    case 12172: // $45549
      var $45550=HEAP32[(($1462)>>2)];
      var $45551=HEAP32[(($1463)>>2)];
      var $45552=HEAP32[(($1464)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45550, $45551, $45552) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12173; break; } else { __label__ = 14612; break; }
    case 12173: // $_noexc1365
      __label__ = 12174; break;
    case 12174: // $_ZdlPvPKci_exit1366
      var $45553=$1462;
      var $45554=$1463;
      var $45555=$1464;
      __label__ = 12175; break;
    case 12175: // $45556
      __label__ = 14611; break;
    case 12176: // $45557
      var $45558=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45559=$45558.f0;
      $4692=$45559;
      var $45560=$45558.f1;
      $4693=$45560;
      var $45561=$1459;
      var $45562=$1460;
      var $45563=$1461;
      HEAP32[(($1459)>>2)]=$16765;
      HEAP32[(($1460)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1461)>>2)]=154;
      var $45564=HEAP32[(($1459)>>2)];
      var $45565=(($45564)|0)!=0;
      if ($45565) { __label__ = 12177; break; } else { __label__ = 12179; break; }
    case 12177: // $45566
      var $45567=HEAP32[(($1459)>>2)];
      var $45568=HEAP32[(($1460)>>2)];
      var $45569=HEAP32[(($1461)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45567, $45568, $45569) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12178; break; } else { __label__ = 14612; break; }
    case 12178: // $_noexc1367
      __label__ = 12179; break;
    case 12179: // $_ZdlPvPKci_exit1368
      var $45570=$1459;
      var $45571=$1460;
      var $45572=$1461;
      __label__ = 12180; break;
    case 12180: // $45573
      __label__ = 14611; break;
    case 12181: // $45574
      var $45575=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45576=$45575.f0;
      $4692=$45576;
      var $45577=$45575.f1;
      $4693=$45577;
      var $45578=$1456;
      var $45579=$1457;
      var $45580=$1458;
      HEAP32[(($1456)>>2)]=$16816;
      HEAP32[(($1457)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1458)>>2)]=155;
      var $45581=HEAP32[(($1456)>>2)];
      var $45582=(($45581)|0)!=0;
      if ($45582) { __label__ = 12182; break; } else { __label__ = 12184; break; }
    case 12182: // $45583
      var $45584=HEAP32[(($1456)>>2)];
      var $45585=HEAP32[(($1457)>>2)];
      var $45586=HEAP32[(($1458)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45584, $45585, $45586) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12183; break; } else { __label__ = 14612; break; }
    case 12183: // $_noexc1369
      __label__ = 12184; break;
    case 12184: // $_ZdlPvPKci_exit1370
      var $45587=$1456;
      var $45588=$1457;
      var $45589=$1458;
      __label__ = 12185; break;
    case 12185: // $45590
      __label__ = 14611; break;
    case 12186: // $45591
      var $45592=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45593=$45592.f0;
      $4692=$45593;
      var $45594=$45592.f1;
      $4693=$45594;
      var $45595=$1453;
      var $45596=$1454;
      var $45597=$1455;
      HEAP32[(($1453)>>2)]=$16867;
      HEAP32[(($1454)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1455)>>2)]=156;
      var $45598=HEAP32[(($1453)>>2)];
      var $45599=(($45598)|0)!=0;
      if ($45599) { __label__ = 12187; break; } else { __label__ = 12189; break; }
    case 12187: // $45600
      var $45601=HEAP32[(($1453)>>2)];
      var $45602=HEAP32[(($1454)>>2)];
      var $45603=HEAP32[(($1455)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45601, $45602, $45603) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12188; break; } else { __label__ = 14612; break; }
    case 12188: // $_noexc1371
      __label__ = 12189; break;
    case 12189: // $_ZdlPvPKci_exit1372
      var $45604=$1453;
      var $45605=$1454;
      var $45606=$1455;
      __label__ = 12190; break;
    case 12190: // $45607
      __label__ = 14611; break;
    case 12191: // $45608
      var $45609=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45610=$45609.f0;
      $4692=$45610;
      var $45611=$45609.f1;
      $4693=$45611;
      var $45612=$1450;
      var $45613=$1451;
      var $45614=$1452;
      HEAP32[(($1450)>>2)]=$16918;
      HEAP32[(($1451)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1452)>>2)]=157;
      var $45615=HEAP32[(($1450)>>2)];
      var $45616=(($45615)|0)!=0;
      if ($45616) { __label__ = 12192; break; } else { __label__ = 12194; break; }
    case 12192: // $45617
      var $45618=HEAP32[(($1450)>>2)];
      var $45619=HEAP32[(($1451)>>2)];
      var $45620=HEAP32[(($1452)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45618, $45619, $45620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12193; break; } else { __label__ = 14612; break; }
    case 12193: // $_noexc1373
      __label__ = 12194; break;
    case 12194: // $_ZdlPvPKci_exit1374
      var $45621=$1450;
      var $45622=$1451;
      var $45623=$1452;
      __label__ = 12195; break;
    case 12195: // $45624
      __label__ = 14611; break;
    case 12196: // $45625
      var $45626=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45627=$45626.f0;
      $4692=$45627;
      var $45628=$45626.f1;
      $4693=$45628;
      var $45629=$1447;
      var $45630=$1448;
      var $45631=$1449;
      HEAP32[(($1447)>>2)]=$16969;
      HEAP32[(($1448)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1449)>>2)]=158;
      var $45632=HEAP32[(($1447)>>2)];
      var $45633=(($45632)|0)!=0;
      if ($45633) { __label__ = 12197; break; } else { __label__ = 12199; break; }
    case 12197: // $45634
      var $45635=HEAP32[(($1447)>>2)];
      var $45636=HEAP32[(($1448)>>2)];
      var $45637=HEAP32[(($1449)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45635, $45636, $45637) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12198; break; } else { __label__ = 14612; break; }
    case 12198: // $_noexc1375
      __label__ = 12199; break;
    case 12199: // $_ZdlPvPKci_exit1376
      var $45638=$1447;
      var $45639=$1448;
      var $45640=$1449;
      __label__ = 12200; break;
    case 12200: // $45641
      __label__ = 14611; break;
    case 12201: // $45642
      var $45643=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45644=$45643.f0;
      $4692=$45644;
      var $45645=$45643.f1;
      $4693=$45645;
      var $45646=$1444;
      var $45647=$1445;
      var $45648=$1446;
      HEAP32[(($1444)>>2)]=$17020;
      HEAP32[(($1445)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1446)>>2)]=159;
      var $45649=HEAP32[(($1444)>>2)];
      var $45650=(($45649)|0)!=0;
      if ($45650) { __label__ = 12202; break; } else { __label__ = 12204; break; }
    case 12202: // $45651
      var $45652=HEAP32[(($1444)>>2)];
      var $45653=HEAP32[(($1445)>>2)];
      var $45654=HEAP32[(($1446)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45652, $45653, $45654) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12203; break; } else { __label__ = 14612; break; }
    case 12203: // $_noexc1377
      __label__ = 12204; break;
    case 12204: // $_ZdlPvPKci_exit1378
      var $45655=$1444;
      var $45656=$1445;
      var $45657=$1446;
      __label__ = 12205; break;
    case 12205: // $45658
      __label__ = 14611; break;
    case 12206: // $45659
      var $45660=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45661=$45660.f0;
      $4692=$45661;
      var $45662=$45660.f1;
      $4693=$45662;
      var $45663=$1441;
      var $45664=$1442;
      var $45665=$1443;
      HEAP32[(($1441)>>2)]=$17071;
      HEAP32[(($1442)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1443)>>2)]=160;
      var $45666=HEAP32[(($1441)>>2)];
      var $45667=(($45666)|0)!=0;
      if ($45667) { __label__ = 12207; break; } else { __label__ = 12209; break; }
    case 12207: // $45668
      var $45669=HEAP32[(($1441)>>2)];
      var $45670=HEAP32[(($1442)>>2)];
      var $45671=HEAP32[(($1443)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45669, $45670, $45671) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12208; break; } else { __label__ = 14612; break; }
    case 12208: // $_noexc1379
      __label__ = 12209; break;
    case 12209: // $_ZdlPvPKci_exit1380
      var $45672=$1441;
      var $45673=$1442;
      var $45674=$1443;
      __label__ = 12210; break;
    case 12210: // $45675
      __label__ = 14611; break;
    case 12211: // $45676
      var $45677=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45678=$45677.f0;
      $4692=$45678;
      var $45679=$45677.f1;
      $4693=$45679;
      var $45680=$1438;
      var $45681=$1439;
      var $45682=$1440;
      HEAP32[(($1438)>>2)]=$17122;
      HEAP32[(($1439)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1440)>>2)]=161;
      var $45683=HEAP32[(($1438)>>2)];
      var $45684=(($45683)|0)!=0;
      if ($45684) { __label__ = 12212; break; } else { __label__ = 12214; break; }
    case 12212: // $45685
      var $45686=HEAP32[(($1438)>>2)];
      var $45687=HEAP32[(($1439)>>2)];
      var $45688=HEAP32[(($1440)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45686, $45687, $45688) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12213; break; } else { __label__ = 14612; break; }
    case 12213: // $_noexc1381
      __label__ = 12214; break;
    case 12214: // $_ZdlPvPKci_exit1382
      var $45689=$1438;
      var $45690=$1439;
      var $45691=$1440;
      __label__ = 12215; break;
    case 12215: // $45692
      __label__ = 14611; break;
    case 12216: // $45693
      var $45694=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45695=$45694.f0;
      $4692=$45695;
      var $45696=$45694.f1;
      $4693=$45696;
      var $45697=$1435;
      var $45698=$1436;
      var $45699=$1437;
      HEAP32[(($1435)>>2)]=$17173;
      HEAP32[(($1436)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1437)>>2)]=162;
      var $45700=HEAP32[(($1435)>>2)];
      var $45701=(($45700)|0)!=0;
      if ($45701) { __label__ = 12217; break; } else { __label__ = 12219; break; }
    case 12217: // $45702
      var $45703=HEAP32[(($1435)>>2)];
      var $45704=HEAP32[(($1436)>>2)];
      var $45705=HEAP32[(($1437)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45703, $45704, $45705) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12218; break; } else { __label__ = 14612; break; }
    case 12218: // $_noexc1383
      __label__ = 12219; break;
    case 12219: // $_ZdlPvPKci_exit1384
      var $45706=$1435;
      var $45707=$1436;
      var $45708=$1437;
      __label__ = 12220; break;
    case 12220: // $45709
      __label__ = 14611; break;
    case 12221: // $45710
      var $45711=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45712=$45711.f0;
      $4692=$45712;
      var $45713=$45711.f1;
      $4693=$45713;
      var $45714=$1432;
      var $45715=$1433;
      var $45716=$1434;
      HEAP32[(($1432)>>2)]=$17224;
      HEAP32[(($1433)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1434)>>2)]=163;
      var $45717=HEAP32[(($1432)>>2)];
      var $45718=(($45717)|0)!=0;
      if ($45718) { __label__ = 12222; break; } else { __label__ = 12224; break; }
    case 12222: // $45719
      var $45720=HEAP32[(($1432)>>2)];
      var $45721=HEAP32[(($1433)>>2)];
      var $45722=HEAP32[(($1434)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45720, $45721, $45722) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12223; break; } else { __label__ = 14612; break; }
    case 12223: // $_noexc1385
      __label__ = 12224; break;
    case 12224: // $_ZdlPvPKci_exit1386
      var $45723=$1432;
      var $45724=$1433;
      var $45725=$1434;
      __label__ = 12225; break;
    case 12225: // $45726
      __label__ = 14611; break;
    case 12226: // $45727
      var $45728=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45729=$45728.f0;
      $4692=$45729;
      var $45730=$45728.f1;
      $4693=$45730;
      var $45731=$1429;
      var $45732=$1430;
      var $45733=$1431;
      HEAP32[(($1429)>>2)]=$17275;
      HEAP32[(($1430)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1431)>>2)]=164;
      var $45734=HEAP32[(($1429)>>2)];
      var $45735=(($45734)|0)!=0;
      if ($45735) { __label__ = 12227; break; } else { __label__ = 12229; break; }
    case 12227: // $45736
      var $45737=HEAP32[(($1429)>>2)];
      var $45738=HEAP32[(($1430)>>2)];
      var $45739=HEAP32[(($1431)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45737, $45738, $45739) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12228; break; } else { __label__ = 14612; break; }
    case 12228: // $_noexc1387
      __label__ = 12229; break;
    case 12229: // $_ZdlPvPKci_exit1388
      var $45740=$1429;
      var $45741=$1430;
      var $45742=$1431;
      __label__ = 12230; break;
    case 12230: // $45743
      __label__ = 14611; break;
    case 12231: // $45744
      var $45745=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45746=$45745.f0;
      $4692=$45746;
      var $45747=$45745.f1;
      $4693=$45747;
      var $45748=$1426;
      var $45749=$1427;
      var $45750=$1428;
      HEAP32[(($1426)>>2)]=$17326;
      HEAP32[(($1427)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1428)>>2)]=165;
      var $45751=HEAP32[(($1426)>>2)];
      var $45752=(($45751)|0)!=0;
      if ($45752) { __label__ = 12232; break; } else { __label__ = 12234; break; }
    case 12232: // $45753
      var $45754=HEAP32[(($1426)>>2)];
      var $45755=HEAP32[(($1427)>>2)];
      var $45756=HEAP32[(($1428)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45754, $45755, $45756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12233; break; } else { __label__ = 14612; break; }
    case 12233: // $_noexc1389
      __label__ = 12234; break;
    case 12234: // $_ZdlPvPKci_exit1390
      var $45757=$1426;
      var $45758=$1427;
      var $45759=$1428;
      __label__ = 12235; break;
    case 12235: // $45760
      __label__ = 14611; break;
    case 12236: // $45761
      var $45762=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45763=$45762.f0;
      $4692=$45763;
      var $45764=$45762.f1;
      $4693=$45764;
      var $45765=$1423;
      var $45766=$1424;
      var $45767=$1425;
      HEAP32[(($1423)>>2)]=$17377;
      HEAP32[(($1424)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1425)>>2)]=166;
      var $45768=HEAP32[(($1423)>>2)];
      var $45769=(($45768)|0)!=0;
      if ($45769) { __label__ = 12237; break; } else { __label__ = 12239; break; }
    case 12237: // $45770
      var $45771=HEAP32[(($1423)>>2)];
      var $45772=HEAP32[(($1424)>>2)];
      var $45773=HEAP32[(($1425)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45771, $45772, $45773) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12238; break; } else { __label__ = 14612; break; }
    case 12238: // $_noexc1391
      __label__ = 12239; break;
    case 12239: // $_ZdlPvPKci_exit1392
      var $45774=$1423;
      var $45775=$1424;
      var $45776=$1425;
      __label__ = 12240; break;
    case 12240: // $45777
      __label__ = 14611; break;
    case 12241: // $45778
      var $45779=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45780=$45779.f0;
      $4692=$45780;
      var $45781=$45779.f1;
      $4693=$45781;
      var $45782=$1420;
      var $45783=$1421;
      var $45784=$1422;
      HEAP32[(($1420)>>2)]=$17428;
      HEAP32[(($1421)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1422)>>2)]=167;
      var $45785=HEAP32[(($1420)>>2)];
      var $45786=(($45785)|0)!=0;
      if ($45786) { __label__ = 12242; break; } else { __label__ = 12244; break; }
    case 12242: // $45787
      var $45788=HEAP32[(($1420)>>2)];
      var $45789=HEAP32[(($1421)>>2)];
      var $45790=HEAP32[(($1422)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45788, $45789, $45790) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12243; break; } else { __label__ = 14612; break; }
    case 12243: // $_noexc1393
      __label__ = 12244; break;
    case 12244: // $_ZdlPvPKci_exit1394
      var $45791=$1420;
      var $45792=$1421;
      var $45793=$1422;
      __label__ = 12245; break;
    case 12245: // $45794
      __label__ = 14611; break;
    case 12246: // $45795
      var $45796=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45797=$45796.f0;
      $4692=$45797;
      var $45798=$45796.f1;
      $4693=$45798;
      var $45799=$1417;
      var $45800=$1418;
      var $45801=$1419;
      HEAP32[(($1417)>>2)]=$17479;
      HEAP32[(($1418)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1419)>>2)]=168;
      var $45802=HEAP32[(($1417)>>2)];
      var $45803=(($45802)|0)!=0;
      if ($45803) { __label__ = 12247; break; } else { __label__ = 12249; break; }
    case 12247: // $45804
      var $45805=HEAP32[(($1417)>>2)];
      var $45806=HEAP32[(($1418)>>2)];
      var $45807=HEAP32[(($1419)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45805, $45806, $45807) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12248; break; } else { __label__ = 14612; break; }
    case 12248: // $_noexc1395
      __label__ = 12249; break;
    case 12249: // $_ZdlPvPKci_exit1396
      var $45808=$1417;
      var $45809=$1418;
      var $45810=$1419;
      __label__ = 12250; break;
    case 12250: // $45811
      __label__ = 14611; break;
    case 12251: // $45812
      var $45813=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45814=$45813.f0;
      $4692=$45814;
      var $45815=$45813.f1;
      $4693=$45815;
      var $45816=$1414;
      var $45817=$1415;
      var $45818=$1416;
      HEAP32[(($1414)>>2)]=$17530;
      HEAP32[(($1415)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1416)>>2)]=169;
      var $45819=HEAP32[(($1414)>>2)];
      var $45820=(($45819)|0)!=0;
      if ($45820) { __label__ = 12252; break; } else { __label__ = 12254; break; }
    case 12252: // $45821
      var $45822=HEAP32[(($1414)>>2)];
      var $45823=HEAP32[(($1415)>>2)];
      var $45824=HEAP32[(($1416)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45822, $45823, $45824) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12253; break; } else { __label__ = 14612; break; }
    case 12253: // $_noexc1397
      __label__ = 12254; break;
    case 12254: // $_ZdlPvPKci_exit1398
      var $45825=$1414;
      var $45826=$1415;
      var $45827=$1416;
      __label__ = 12255; break;
    case 12255: // $45828
      __label__ = 14611; break;
    case 12256: // $45829
      var $45830=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45831=$45830.f0;
      $4692=$45831;
      var $45832=$45830.f1;
      $4693=$45832;
      var $45833=$1411;
      var $45834=$1412;
      var $45835=$1413;
      HEAP32[(($1411)>>2)]=$17581;
      HEAP32[(($1412)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1413)>>2)]=170;
      var $45836=HEAP32[(($1411)>>2)];
      var $45837=(($45836)|0)!=0;
      if ($45837) { __label__ = 12257; break; } else { __label__ = 12259; break; }
    case 12257: // $45838
      var $45839=HEAP32[(($1411)>>2)];
      var $45840=HEAP32[(($1412)>>2)];
      var $45841=HEAP32[(($1413)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45839, $45840, $45841) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12258; break; } else { __label__ = 14612; break; }
    case 12258: // $_noexc1399
      __label__ = 12259; break;
    case 12259: // $_ZdlPvPKci_exit1400
      var $45842=$1411;
      var $45843=$1412;
      var $45844=$1413;
      __label__ = 12260; break;
    case 12260: // $45845
      __label__ = 14611; break;
    case 12261: // $45846
      var $45847=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45848=$45847.f0;
      $4692=$45848;
      var $45849=$45847.f1;
      $4693=$45849;
      var $45850=$1408;
      var $45851=$1409;
      var $45852=$1410;
      HEAP32[(($1408)>>2)]=$17632;
      HEAP32[(($1409)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1410)>>2)]=171;
      var $45853=HEAP32[(($1408)>>2)];
      var $45854=(($45853)|0)!=0;
      if ($45854) { __label__ = 12262; break; } else { __label__ = 12264; break; }
    case 12262: // $45855
      var $45856=HEAP32[(($1408)>>2)];
      var $45857=HEAP32[(($1409)>>2)];
      var $45858=HEAP32[(($1410)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45856, $45857, $45858) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12263; break; } else { __label__ = 14612; break; }
    case 12263: // $_noexc1401
      __label__ = 12264; break;
    case 12264: // $_ZdlPvPKci_exit1402
      var $45859=$1408;
      var $45860=$1409;
      var $45861=$1410;
      __label__ = 12265; break;
    case 12265: // $45862
      __label__ = 14611; break;
    case 12266: // $45863
      var $45864=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45865=$45864.f0;
      $4692=$45865;
      var $45866=$45864.f1;
      $4693=$45866;
      var $45867=$1405;
      var $45868=$1406;
      var $45869=$1407;
      HEAP32[(($1405)>>2)]=$17683;
      HEAP32[(($1406)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1407)>>2)]=172;
      var $45870=HEAP32[(($1405)>>2)];
      var $45871=(($45870)|0)!=0;
      if ($45871) { __label__ = 12267; break; } else { __label__ = 12269; break; }
    case 12267: // $45872
      var $45873=HEAP32[(($1405)>>2)];
      var $45874=HEAP32[(($1406)>>2)];
      var $45875=HEAP32[(($1407)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45873, $45874, $45875) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12268; break; } else { __label__ = 14612; break; }
    case 12268: // $_noexc1403
      __label__ = 12269; break;
    case 12269: // $_ZdlPvPKci_exit1404
      var $45876=$1405;
      var $45877=$1406;
      var $45878=$1407;
      __label__ = 12270; break;
    case 12270: // $45879
      __label__ = 14611; break;
    case 12271: // $45880
      var $45881=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45882=$45881.f0;
      $4692=$45882;
      var $45883=$45881.f1;
      $4693=$45883;
      var $45884=$1402;
      var $45885=$1403;
      var $45886=$1404;
      HEAP32[(($1402)>>2)]=$17734;
      HEAP32[(($1403)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1404)>>2)]=173;
      var $45887=HEAP32[(($1402)>>2)];
      var $45888=(($45887)|0)!=0;
      if ($45888) { __label__ = 12272; break; } else { __label__ = 12274; break; }
    case 12272: // $45889
      var $45890=HEAP32[(($1402)>>2)];
      var $45891=HEAP32[(($1403)>>2)];
      var $45892=HEAP32[(($1404)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45890, $45891, $45892) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12273; break; } else { __label__ = 14612; break; }
    case 12273: // $_noexc1405
      __label__ = 12274; break;
    case 12274: // $_ZdlPvPKci_exit1406
      var $45893=$1402;
      var $45894=$1403;
      var $45895=$1404;
      __label__ = 12275; break;
    case 12275: // $45896
      __label__ = 14611; break;
    case 12276: // $45897
      var $45898=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45899=$45898.f0;
      $4692=$45899;
      var $45900=$45898.f1;
      $4693=$45900;
      var $45901=$1399;
      var $45902=$1400;
      var $45903=$1401;
      HEAP32[(($1399)>>2)]=$17785;
      HEAP32[(($1400)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1401)>>2)]=174;
      var $45904=HEAP32[(($1399)>>2)];
      var $45905=(($45904)|0)!=0;
      if ($45905) { __label__ = 12277; break; } else { __label__ = 12279; break; }
    case 12277: // $45906
      var $45907=HEAP32[(($1399)>>2)];
      var $45908=HEAP32[(($1400)>>2)];
      var $45909=HEAP32[(($1401)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45907, $45908, $45909) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12278; break; } else { __label__ = 14612; break; }
    case 12278: // $_noexc1407
      __label__ = 12279; break;
    case 12279: // $_ZdlPvPKci_exit1408
      var $45910=$1399;
      var $45911=$1400;
      var $45912=$1401;
      __label__ = 12280; break;
    case 12280: // $45913
      __label__ = 14611; break;
    case 12281: // $45914
      var $45915=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45916=$45915.f0;
      $4692=$45916;
      var $45917=$45915.f1;
      $4693=$45917;
      var $45918=$1396;
      var $45919=$1397;
      var $45920=$1398;
      HEAP32[(($1396)>>2)]=$17836;
      HEAP32[(($1397)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1398)>>2)]=175;
      var $45921=HEAP32[(($1396)>>2)];
      var $45922=(($45921)|0)!=0;
      if ($45922) { __label__ = 12282; break; } else { __label__ = 12284; break; }
    case 12282: // $45923
      var $45924=HEAP32[(($1396)>>2)];
      var $45925=HEAP32[(($1397)>>2)];
      var $45926=HEAP32[(($1398)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45924, $45925, $45926) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12283; break; } else { __label__ = 14612; break; }
    case 12283: // $_noexc1409
      __label__ = 12284; break;
    case 12284: // $_ZdlPvPKci_exit1410
      var $45927=$1396;
      var $45928=$1397;
      var $45929=$1398;
      __label__ = 12285; break;
    case 12285: // $45930
      __label__ = 14611; break;
    case 12286: // $45931
      var $45932=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45933=$45932.f0;
      $4692=$45933;
      var $45934=$45932.f1;
      $4693=$45934;
      var $45935=$1393;
      var $45936=$1394;
      var $45937=$1395;
      HEAP32[(($1393)>>2)]=$17887;
      HEAP32[(($1394)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1395)>>2)]=176;
      var $45938=HEAP32[(($1393)>>2)];
      var $45939=(($45938)|0)!=0;
      if ($45939) { __label__ = 12287; break; } else { __label__ = 12289; break; }
    case 12287: // $45940
      var $45941=HEAP32[(($1393)>>2)];
      var $45942=HEAP32[(($1394)>>2)];
      var $45943=HEAP32[(($1395)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45941, $45942, $45943) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12288; break; } else { __label__ = 14612; break; }
    case 12288: // $_noexc1411
      __label__ = 12289; break;
    case 12289: // $_ZdlPvPKci_exit1412
      var $45944=$1393;
      var $45945=$1394;
      var $45946=$1395;
      __label__ = 12290; break;
    case 12290: // $45947
      __label__ = 14611; break;
    case 12291: // $45948
      var $45949=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45950=$45949.f0;
      $4692=$45950;
      var $45951=$45949.f1;
      $4693=$45951;
      var $45952=$1390;
      var $45953=$1391;
      var $45954=$1392;
      HEAP32[(($1390)>>2)]=$17938;
      HEAP32[(($1391)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1392)>>2)]=177;
      var $45955=HEAP32[(($1390)>>2)];
      var $45956=(($45955)|0)!=0;
      if ($45956) { __label__ = 12292; break; } else { __label__ = 12294; break; }
    case 12292: // $45957
      var $45958=HEAP32[(($1390)>>2)];
      var $45959=HEAP32[(($1391)>>2)];
      var $45960=HEAP32[(($1392)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45958, $45959, $45960) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12293; break; } else { __label__ = 14612; break; }
    case 12293: // $_noexc1413
      __label__ = 12294; break;
    case 12294: // $_ZdlPvPKci_exit1414
      var $45961=$1390;
      var $45962=$1391;
      var $45963=$1392;
      __label__ = 12295; break;
    case 12295: // $45964
      __label__ = 14611; break;
    case 12296: // $45965
      var $45966=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45967=$45966.f0;
      $4692=$45967;
      var $45968=$45966.f1;
      $4693=$45968;
      var $45969=$1387;
      var $45970=$1388;
      var $45971=$1389;
      HEAP32[(($1387)>>2)]=$17989;
      HEAP32[(($1388)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1389)>>2)]=178;
      var $45972=HEAP32[(($1387)>>2)];
      var $45973=(($45972)|0)!=0;
      if ($45973) { __label__ = 12297; break; } else { __label__ = 12299; break; }
    case 12297: // $45974
      var $45975=HEAP32[(($1387)>>2)];
      var $45976=HEAP32[(($1388)>>2)];
      var $45977=HEAP32[(($1389)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45975, $45976, $45977) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12298; break; } else { __label__ = 14612; break; }
    case 12298: // $_noexc1415
      __label__ = 12299; break;
    case 12299: // $_ZdlPvPKci_exit1416
      var $45978=$1387;
      var $45979=$1388;
      var $45980=$1389;
      __label__ = 12300; break;
    case 12300: // $45981
      __label__ = 14611; break;
    case 12301: // $45982
      var $45983=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45984=$45983.f0;
      $4692=$45984;
      var $45985=$45983.f1;
      $4693=$45985;
      var $45986=$1384;
      var $45987=$1385;
      var $45988=$1386;
      HEAP32[(($1384)>>2)]=$18040;
      HEAP32[(($1385)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1386)>>2)]=179;
      var $45989=HEAP32[(($1384)>>2)];
      var $45990=(($45989)|0)!=0;
      if ($45990) { __label__ = 12302; break; } else { __label__ = 12304; break; }
    case 12302: // $45991
      var $45992=HEAP32[(($1384)>>2)];
      var $45993=HEAP32[(($1385)>>2)];
      var $45994=HEAP32[(($1386)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($45992, $45993, $45994) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12303; break; } else { __label__ = 14612; break; }
    case 12303: // $_noexc1417
      __label__ = 12304; break;
    case 12304: // $_ZdlPvPKci_exit1418
      var $45995=$1384;
      var $45996=$1385;
      var $45997=$1386;
      __label__ = 12305; break;
    case 12305: // $45998
      __label__ = 14611; break;
    case 12306: // $45999
      var $46000=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46001=$46000.f0;
      $4692=$46001;
      var $46002=$46000.f1;
      $4693=$46002;
      var $46003=$1381;
      var $46004=$1382;
      var $46005=$1383;
      HEAP32[(($1381)>>2)]=$18091;
      HEAP32[(($1382)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1383)>>2)]=180;
      var $46006=HEAP32[(($1381)>>2)];
      var $46007=(($46006)|0)!=0;
      if ($46007) { __label__ = 12307; break; } else { __label__ = 12309; break; }
    case 12307: // $46008
      var $46009=HEAP32[(($1381)>>2)];
      var $46010=HEAP32[(($1382)>>2)];
      var $46011=HEAP32[(($1383)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46009, $46010, $46011) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12308; break; } else { __label__ = 14612; break; }
    case 12308: // $_noexc1419
      __label__ = 12309; break;
    case 12309: // $_ZdlPvPKci_exit1420
      var $46012=$1381;
      var $46013=$1382;
      var $46014=$1383;
      __label__ = 12310; break;
    case 12310: // $46015
      __label__ = 14611; break;
    case 12311: // $46016
      var $46017=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46018=$46017.f0;
      $4692=$46018;
      var $46019=$46017.f1;
      $4693=$46019;
      var $46020=$1378;
      var $46021=$1379;
      var $46022=$1380;
      HEAP32[(($1378)>>2)]=$18142;
      HEAP32[(($1379)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1380)>>2)]=181;
      var $46023=HEAP32[(($1378)>>2)];
      var $46024=(($46023)|0)!=0;
      if ($46024) { __label__ = 12312; break; } else { __label__ = 12314; break; }
    case 12312: // $46025
      var $46026=HEAP32[(($1378)>>2)];
      var $46027=HEAP32[(($1379)>>2)];
      var $46028=HEAP32[(($1380)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46026, $46027, $46028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12313; break; } else { __label__ = 14612; break; }
    case 12313: // $_noexc1421
      __label__ = 12314; break;
    case 12314: // $_ZdlPvPKci_exit1422
      var $46029=$1378;
      var $46030=$1379;
      var $46031=$1380;
      __label__ = 12315; break;
    case 12315: // $46032
      __label__ = 14611; break;
    case 12316: // $46033
      var $46034=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46035=$46034.f0;
      $4692=$46035;
      var $46036=$46034.f1;
      $4693=$46036;
      var $46037=$1375;
      var $46038=$1376;
      var $46039=$1377;
      HEAP32[(($1375)>>2)]=$18193;
      HEAP32[(($1376)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1377)>>2)]=182;
      var $46040=HEAP32[(($1375)>>2)];
      var $46041=(($46040)|0)!=0;
      if ($46041) { __label__ = 12317; break; } else { __label__ = 12319; break; }
    case 12317: // $46042
      var $46043=HEAP32[(($1375)>>2)];
      var $46044=HEAP32[(($1376)>>2)];
      var $46045=HEAP32[(($1377)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46043, $46044, $46045) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12318; break; } else { __label__ = 14612; break; }
    case 12318: // $_noexc1423
      __label__ = 12319; break;
    case 12319: // $_ZdlPvPKci_exit1424
      var $46046=$1375;
      var $46047=$1376;
      var $46048=$1377;
      __label__ = 12320; break;
    case 12320: // $46049
      __label__ = 14611; break;
    case 12321: // $46050
      var $46051=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46052=$46051.f0;
      $4692=$46052;
      var $46053=$46051.f1;
      $4693=$46053;
      var $46054=$1372;
      var $46055=$1373;
      var $46056=$1374;
      HEAP32[(($1372)>>2)]=$18244;
      HEAP32[(($1373)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1374)>>2)]=183;
      var $46057=HEAP32[(($1372)>>2)];
      var $46058=(($46057)|0)!=0;
      if ($46058) { __label__ = 12322; break; } else { __label__ = 12324; break; }
    case 12322: // $46059
      var $46060=HEAP32[(($1372)>>2)];
      var $46061=HEAP32[(($1373)>>2)];
      var $46062=HEAP32[(($1374)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46060, $46061, $46062) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12323; break; } else { __label__ = 14612; break; }
    case 12323: // $_noexc1425
      __label__ = 12324; break;
    case 12324: // $_ZdlPvPKci_exit1426
      var $46063=$1372;
      var $46064=$1373;
      var $46065=$1374;
      __label__ = 12325; break;
    case 12325: // $46066
      __label__ = 14611; break;
    case 12326: // $46067
      var $46068=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46069=$46068.f0;
      $4692=$46069;
      var $46070=$46068.f1;
      $4693=$46070;
      var $46071=$1369;
      var $46072=$1370;
      var $46073=$1371;
      HEAP32[(($1369)>>2)]=$18295;
      HEAP32[(($1370)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1371)>>2)]=184;
      var $46074=HEAP32[(($1369)>>2)];
      var $46075=(($46074)|0)!=0;
      if ($46075) { __label__ = 12327; break; } else { __label__ = 12329; break; }
    case 12327: // $46076
      var $46077=HEAP32[(($1369)>>2)];
      var $46078=HEAP32[(($1370)>>2)];
      var $46079=HEAP32[(($1371)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46077, $46078, $46079) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12328; break; } else { __label__ = 14612; break; }
    case 12328: // $_noexc1427
      __label__ = 12329; break;
    case 12329: // $_ZdlPvPKci_exit1428
      var $46080=$1369;
      var $46081=$1370;
      var $46082=$1371;
      __label__ = 12330; break;
    case 12330: // $46083
      __label__ = 14611; break;
    case 12331: // $46084
      var $46085=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46086=$46085.f0;
      $4692=$46086;
      var $46087=$46085.f1;
      $4693=$46087;
      var $46088=$1366;
      var $46089=$1367;
      var $46090=$1368;
      HEAP32[(($1366)>>2)]=$18346;
      HEAP32[(($1367)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1368)>>2)]=185;
      var $46091=HEAP32[(($1366)>>2)];
      var $46092=(($46091)|0)!=0;
      if ($46092) { __label__ = 12332; break; } else { __label__ = 12334; break; }
    case 12332: // $46093
      var $46094=HEAP32[(($1366)>>2)];
      var $46095=HEAP32[(($1367)>>2)];
      var $46096=HEAP32[(($1368)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46094, $46095, $46096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12333; break; } else { __label__ = 14612; break; }
    case 12333: // $_noexc1429
      __label__ = 12334; break;
    case 12334: // $_ZdlPvPKci_exit1430
      var $46097=$1366;
      var $46098=$1367;
      var $46099=$1368;
      __label__ = 12335; break;
    case 12335: // $46100
      __label__ = 14611; break;
    case 12336: // $46101
      var $46102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46103=$46102.f0;
      $4692=$46103;
      var $46104=$46102.f1;
      $4693=$46104;
      var $46105=$1363;
      var $46106=$1364;
      var $46107=$1365;
      HEAP32[(($1363)>>2)]=$18397;
      HEAP32[(($1364)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1365)>>2)]=186;
      var $46108=HEAP32[(($1363)>>2)];
      var $46109=(($46108)|0)!=0;
      if ($46109) { __label__ = 12337; break; } else { __label__ = 12339; break; }
    case 12337: // $46110
      var $46111=HEAP32[(($1363)>>2)];
      var $46112=HEAP32[(($1364)>>2)];
      var $46113=HEAP32[(($1365)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46111, $46112, $46113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12338; break; } else { __label__ = 14612; break; }
    case 12338: // $_noexc1431
      __label__ = 12339; break;
    case 12339: // $_ZdlPvPKci_exit1432
      var $46114=$1363;
      var $46115=$1364;
      var $46116=$1365;
      __label__ = 12340; break;
    case 12340: // $46117
      __label__ = 14611; break;
    case 12341: // $46118
      var $46119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46120=$46119.f0;
      $4692=$46120;
      var $46121=$46119.f1;
      $4693=$46121;
      var $46122=$1360;
      var $46123=$1361;
      var $46124=$1362;
      HEAP32[(($1360)>>2)]=$18448;
      HEAP32[(($1361)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1362)>>2)]=187;
      var $46125=HEAP32[(($1360)>>2)];
      var $46126=(($46125)|0)!=0;
      if ($46126) { __label__ = 12342; break; } else { __label__ = 12344; break; }
    case 12342: // $46127
      var $46128=HEAP32[(($1360)>>2)];
      var $46129=HEAP32[(($1361)>>2)];
      var $46130=HEAP32[(($1362)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46128, $46129, $46130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12343; break; } else { __label__ = 14612; break; }
    case 12343: // $_noexc1433
      __label__ = 12344; break;
    case 12344: // $_ZdlPvPKci_exit1434
      var $46131=$1360;
      var $46132=$1361;
      var $46133=$1362;
      __label__ = 12345; break;
    case 12345: // $46134
      __label__ = 14611; break;
    case 12346: // $46135
      var $46136=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46137=$46136.f0;
      $4692=$46137;
      var $46138=$46136.f1;
      $4693=$46138;
      var $46139=$1357;
      var $46140=$1358;
      var $46141=$1359;
      HEAP32[(($1357)>>2)]=$18499;
      HEAP32[(($1358)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1359)>>2)]=188;
      var $46142=HEAP32[(($1357)>>2)];
      var $46143=(($46142)|0)!=0;
      if ($46143) { __label__ = 12347; break; } else { __label__ = 12349; break; }
    case 12347: // $46144
      var $46145=HEAP32[(($1357)>>2)];
      var $46146=HEAP32[(($1358)>>2)];
      var $46147=HEAP32[(($1359)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46145, $46146, $46147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12348; break; } else { __label__ = 14612; break; }
    case 12348: // $_noexc1435
      __label__ = 12349; break;
    case 12349: // $_ZdlPvPKci_exit1436
      var $46148=$1357;
      var $46149=$1358;
      var $46150=$1359;
      __label__ = 12350; break;
    case 12350: // $46151
      __label__ = 14611; break;
    case 12351: // $46152
      var $46153=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46154=$46153.f0;
      $4692=$46154;
      var $46155=$46153.f1;
      $4693=$46155;
      var $46156=$1354;
      var $46157=$1355;
      var $46158=$1356;
      HEAP32[(($1354)>>2)]=$18550;
      HEAP32[(($1355)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1356)>>2)]=189;
      var $46159=HEAP32[(($1354)>>2)];
      var $46160=(($46159)|0)!=0;
      if ($46160) { __label__ = 12352; break; } else { __label__ = 12354; break; }
    case 12352: // $46161
      var $46162=HEAP32[(($1354)>>2)];
      var $46163=HEAP32[(($1355)>>2)];
      var $46164=HEAP32[(($1356)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46162, $46163, $46164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12353; break; } else { __label__ = 14612; break; }
    case 12353: // $_noexc1437
      __label__ = 12354; break;
    case 12354: // $_ZdlPvPKci_exit1438
      var $46165=$1354;
      var $46166=$1355;
      var $46167=$1356;
      __label__ = 12355; break;
    case 12355: // $46168
      __label__ = 14611; break;
    case 12356: // $46169
      var $46170=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46171=$46170.f0;
      $4692=$46171;
      var $46172=$46170.f1;
      $4693=$46172;
      var $46173=$1351;
      var $46174=$1352;
      var $46175=$1353;
      HEAP32[(($1351)>>2)]=$18601;
      HEAP32[(($1352)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1353)>>2)]=190;
      var $46176=HEAP32[(($1351)>>2)];
      var $46177=(($46176)|0)!=0;
      if ($46177) { __label__ = 12357; break; } else { __label__ = 12359; break; }
    case 12357: // $46178
      var $46179=HEAP32[(($1351)>>2)];
      var $46180=HEAP32[(($1352)>>2)];
      var $46181=HEAP32[(($1353)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46179, $46180, $46181) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12358; break; } else { __label__ = 14612; break; }
    case 12358: // $_noexc1439
      __label__ = 12359; break;
    case 12359: // $_ZdlPvPKci_exit1440
      var $46182=$1351;
      var $46183=$1352;
      var $46184=$1353;
      __label__ = 12360; break;
    case 12360: // $46185
      __label__ = 14611; break;
    case 12361: // $46186
      var $46187=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46188=$46187.f0;
      $4692=$46188;
      var $46189=$46187.f1;
      $4693=$46189;
      var $46190=$1348;
      var $46191=$1349;
      var $46192=$1350;
      HEAP32[(($1348)>>2)]=$18652;
      HEAP32[(($1349)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1350)>>2)]=191;
      var $46193=HEAP32[(($1348)>>2)];
      var $46194=(($46193)|0)!=0;
      if ($46194) { __label__ = 12362; break; } else { __label__ = 12364; break; }
    case 12362: // $46195
      var $46196=HEAP32[(($1348)>>2)];
      var $46197=HEAP32[(($1349)>>2)];
      var $46198=HEAP32[(($1350)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46196, $46197, $46198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12363; break; } else { __label__ = 14612; break; }
    case 12363: // $_noexc1441
      __label__ = 12364; break;
    case 12364: // $_ZdlPvPKci_exit1442
      var $46199=$1348;
      var $46200=$1349;
      var $46201=$1350;
      __label__ = 12365; break;
    case 12365: // $46202
      __label__ = 14611; break;
    case 12366: // $46203
      var $46204=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46205=$46204.f0;
      $4692=$46205;
      var $46206=$46204.f1;
      $4693=$46206;
      var $46207=$1345;
      var $46208=$1346;
      var $46209=$1347;
      HEAP32[(($1345)>>2)]=$18703;
      HEAP32[(($1346)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1347)>>2)]=192;
      var $46210=HEAP32[(($1345)>>2)];
      var $46211=(($46210)|0)!=0;
      if ($46211) { __label__ = 12367; break; } else { __label__ = 12369; break; }
    case 12367: // $46212
      var $46213=HEAP32[(($1345)>>2)];
      var $46214=HEAP32[(($1346)>>2)];
      var $46215=HEAP32[(($1347)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46213, $46214, $46215) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12368; break; } else { __label__ = 14612; break; }
    case 12368: // $_noexc1443
      __label__ = 12369; break;
    case 12369: // $_ZdlPvPKci_exit1444
      var $46216=$1345;
      var $46217=$1346;
      var $46218=$1347;
      __label__ = 12370; break;
    case 12370: // $46219
      __label__ = 14611; break;
    case 12371: // $46220
      var $46221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46222=$46221.f0;
      $4692=$46222;
      var $46223=$46221.f1;
      $4693=$46223;
      var $46224=$1342;
      var $46225=$1343;
      var $46226=$1344;
      HEAP32[(($1342)>>2)]=$18754;
      HEAP32[(($1343)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1344)>>2)]=193;
      var $46227=HEAP32[(($1342)>>2)];
      var $46228=(($46227)|0)!=0;
      if ($46228) { __label__ = 12372; break; } else { __label__ = 12374; break; }
    case 12372: // $46229
      var $46230=HEAP32[(($1342)>>2)];
      var $46231=HEAP32[(($1343)>>2)];
      var $46232=HEAP32[(($1344)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46230, $46231, $46232) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12373; break; } else { __label__ = 14612; break; }
    case 12373: // $_noexc1445
      __label__ = 12374; break;
    case 12374: // $_ZdlPvPKci_exit1446
      var $46233=$1342;
      var $46234=$1343;
      var $46235=$1344;
      __label__ = 12375; break;
    case 12375: // $46236
      __label__ = 14611; break;
    case 12376: // $46237
      var $46238=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46239=$46238.f0;
      $4692=$46239;
      var $46240=$46238.f1;
      $4693=$46240;
      var $46241=$1339;
      var $46242=$1340;
      var $46243=$1341;
      HEAP32[(($1339)>>2)]=$18805;
      HEAP32[(($1340)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1341)>>2)]=194;
      var $46244=HEAP32[(($1339)>>2)];
      var $46245=(($46244)|0)!=0;
      if ($46245) { __label__ = 12377; break; } else { __label__ = 12379; break; }
    case 12377: // $46246
      var $46247=HEAP32[(($1339)>>2)];
      var $46248=HEAP32[(($1340)>>2)];
      var $46249=HEAP32[(($1341)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46247, $46248, $46249) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12378; break; } else { __label__ = 14612; break; }
    case 12378: // $_noexc1447
      __label__ = 12379; break;
    case 12379: // $_ZdlPvPKci_exit1448
      var $46250=$1339;
      var $46251=$1340;
      var $46252=$1341;
      __label__ = 12380; break;
    case 12380: // $46253
      __label__ = 14611; break;
    case 12381: // $46254
      var $46255=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46256=$46255.f0;
      $4692=$46256;
      var $46257=$46255.f1;
      $4693=$46257;
      var $46258=$1336;
      var $46259=$1337;
      var $46260=$1338;
      HEAP32[(($1336)>>2)]=$18856;
      HEAP32[(($1337)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1338)>>2)]=195;
      var $46261=HEAP32[(($1336)>>2)];
      var $46262=(($46261)|0)!=0;
      if ($46262) { __label__ = 12382; break; } else { __label__ = 12384; break; }
    case 12382: // $46263
      var $46264=HEAP32[(($1336)>>2)];
      var $46265=HEAP32[(($1337)>>2)];
      var $46266=HEAP32[(($1338)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46264, $46265, $46266) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12383; break; } else { __label__ = 14612; break; }
    case 12383: // $_noexc1449
      __label__ = 12384; break;
    case 12384: // $_ZdlPvPKci_exit1450
      var $46267=$1336;
      var $46268=$1337;
      var $46269=$1338;
      __label__ = 12385; break;
    case 12385: // $46270
      __label__ = 14611; break;
    case 12386: // $46271
      var $46272=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46273=$46272.f0;
      $4692=$46273;
      var $46274=$46272.f1;
      $4693=$46274;
      var $46275=$1333;
      var $46276=$1334;
      var $46277=$1335;
      HEAP32[(($1333)>>2)]=$18907;
      HEAP32[(($1334)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1335)>>2)]=196;
      var $46278=HEAP32[(($1333)>>2)];
      var $46279=(($46278)|0)!=0;
      if ($46279) { __label__ = 12387; break; } else { __label__ = 12389; break; }
    case 12387: // $46280
      var $46281=HEAP32[(($1333)>>2)];
      var $46282=HEAP32[(($1334)>>2)];
      var $46283=HEAP32[(($1335)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46281, $46282, $46283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12388; break; } else { __label__ = 14612; break; }
    case 12388: // $_noexc1451
      __label__ = 12389; break;
    case 12389: // $_ZdlPvPKci_exit1452
      var $46284=$1333;
      var $46285=$1334;
      var $46286=$1335;
      __label__ = 12390; break;
    case 12390: // $46287
      __label__ = 14611; break;
    case 12391: // $46288
      var $46289=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46290=$46289.f0;
      $4692=$46290;
      var $46291=$46289.f1;
      $4693=$46291;
      var $46292=$1330;
      var $46293=$1331;
      var $46294=$1332;
      HEAP32[(($1330)>>2)]=$18958;
      HEAP32[(($1331)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1332)>>2)]=197;
      var $46295=HEAP32[(($1330)>>2)];
      var $46296=(($46295)|0)!=0;
      if ($46296) { __label__ = 12392; break; } else { __label__ = 12394; break; }
    case 12392: // $46297
      var $46298=HEAP32[(($1330)>>2)];
      var $46299=HEAP32[(($1331)>>2)];
      var $46300=HEAP32[(($1332)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46298, $46299, $46300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12393; break; } else { __label__ = 14612; break; }
    case 12393: // $_noexc1453
      __label__ = 12394; break;
    case 12394: // $_ZdlPvPKci_exit1454
      var $46301=$1330;
      var $46302=$1331;
      var $46303=$1332;
      __label__ = 12395; break;
    case 12395: // $46304
      __label__ = 14611; break;
    case 12396: // $46305
      var $46306=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46307=$46306.f0;
      $4692=$46307;
      var $46308=$46306.f1;
      $4693=$46308;
      var $46309=$1327;
      var $46310=$1328;
      var $46311=$1329;
      HEAP32[(($1327)>>2)]=$19009;
      HEAP32[(($1328)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1329)>>2)]=198;
      var $46312=HEAP32[(($1327)>>2)];
      var $46313=(($46312)|0)!=0;
      if ($46313) { __label__ = 12397; break; } else { __label__ = 12399; break; }
    case 12397: // $46314
      var $46315=HEAP32[(($1327)>>2)];
      var $46316=HEAP32[(($1328)>>2)];
      var $46317=HEAP32[(($1329)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46315, $46316, $46317) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12398; break; } else { __label__ = 14612; break; }
    case 12398: // $_noexc1455
      __label__ = 12399; break;
    case 12399: // $_ZdlPvPKci_exit1456
      var $46318=$1327;
      var $46319=$1328;
      var $46320=$1329;
      __label__ = 12400; break;
    case 12400: // $46321
      __label__ = 14611; break;
    case 12401: // $46322
      var $46323=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46324=$46323.f0;
      $4692=$46324;
      var $46325=$46323.f1;
      $4693=$46325;
      var $46326=$1324;
      var $46327=$1325;
      var $46328=$1326;
      HEAP32[(($1324)>>2)]=$19060;
      HEAP32[(($1325)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1326)>>2)]=199;
      var $46329=HEAP32[(($1324)>>2)];
      var $46330=(($46329)|0)!=0;
      if ($46330) { __label__ = 12402; break; } else { __label__ = 12404; break; }
    case 12402: // $46331
      var $46332=HEAP32[(($1324)>>2)];
      var $46333=HEAP32[(($1325)>>2)];
      var $46334=HEAP32[(($1326)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46332, $46333, $46334) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12403; break; } else { __label__ = 14612; break; }
    case 12403: // $_noexc1457
      __label__ = 12404; break;
    case 12404: // $_ZdlPvPKci_exit1458
      var $46335=$1324;
      var $46336=$1325;
      var $46337=$1326;
      __label__ = 12405; break;
    case 12405: // $46338
      __label__ = 14611; break;
    case 12406: // $46339
      var $46340=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46341=$46340.f0;
      $4692=$46341;
      var $46342=$46340.f1;
      $4693=$46342;
      var $46343=$1321;
      var $46344=$1322;
      var $46345=$1323;
      HEAP32[(($1321)>>2)]=$19111;
      HEAP32[(($1322)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1323)>>2)]=200;
      var $46346=HEAP32[(($1321)>>2)];
      var $46347=(($46346)|0)!=0;
      if ($46347) { __label__ = 12407; break; } else { __label__ = 12409; break; }
    case 12407: // $46348
      var $46349=HEAP32[(($1321)>>2)];
      var $46350=HEAP32[(($1322)>>2)];
      var $46351=HEAP32[(($1323)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46349, $46350, $46351) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12408; break; } else { __label__ = 14612; break; }
    case 12408: // $_noexc1459
      __label__ = 12409; break;
    case 12409: // $_ZdlPvPKci_exit1460
      var $46352=$1321;
      var $46353=$1322;
      var $46354=$1323;
      __label__ = 12410; break;
    case 12410: // $46355
      __label__ = 14611; break;
    case 12411: // $46356
      var $46357=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46358=$46357.f0;
      $4692=$46358;
      var $46359=$46357.f1;
      $4693=$46359;
      var $46360=$1318;
      var $46361=$1319;
      var $46362=$1320;
      HEAP32[(($1318)>>2)]=$19162;
      HEAP32[(($1319)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1320)>>2)]=201;
      var $46363=HEAP32[(($1318)>>2)];
      var $46364=(($46363)|0)!=0;
      if ($46364) { __label__ = 12412; break; } else { __label__ = 12414; break; }
    case 12412: // $46365
      var $46366=HEAP32[(($1318)>>2)];
      var $46367=HEAP32[(($1319)>>2)];
      var $46368=HEAP32[(($1320)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46366, $46367, $46368) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12413; break; } else { __label__ = 14612; break; }
    case 12413: // $_noexc1461
      __label__ = 12414; break;
    case 12414: // $_ZdlPvPKci_exit1462
      var $46369=$1318;
      var $46370=$1319;
      var $46371=$1320;
      __label__ = 12415; break;
    case 12415: // $46372
      __label__ = 14611; break;
    case 12416: // $46373
      var $46374=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46375=$46374.f0;
      $4692=$46375;
      var $46376=$46374.f1;
      $4693=$46376;
      var $46377=$1315;
      var $46378=$1316;
      var $46379=$1317;
      HEAP32[(($1315)>>2)]=$19213;
      HEAP32[(($1316)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1317)>>2)]=202;
      var $46380=HEAP32[(($1315)>>2)];
      var $46381=(($46380)|0)!=0;
      if ($46381) { __label__ = 12417; break; } else { __label__ = 12419; break; }
    case 12417: // $46382
      var $46383=HEAP32[(($1315)>>2)];
      var $46384=HEAP32[(($1316)>>2)];
      var $46385=HEAP32[(($1317)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46383, $46384, $46385) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12418; break; } else { __label__ = 14612; break; }
    case 12418: // $_noexc1463
      __label__ = 12419; break;
    case 12419: // $_ZdlPvPKci_exit1464
      var $46386=$1315;
      var $46387=$1316;
      var $46388=$1317;
      __label__ = 12420; break;
    case 12420: // $46389
      __label__ = 14611; break;
    case 12421: // $46390
      var $46391=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46392=$46391.f0;
      $4692=$46392;
      var $46393=$46391.f1;
      $4693=$46393;
      var $46394=$1312;
      var $46395=$1313;
      var $46396=$1314;
      HEAP32[(($1312)>>2)]=$19264;
      HEAP32[(($1313)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1314)>>2)]=203;
      var $46397=HEAP32[(($1312)>>2)];
      var $46398=(($46397)|0)!=0;
      if ($46398) { __label__ = 12422; break; } else { __label__ = 12424; break; }
    case 12422: // $46399
      var $46400=HEAP32[(($1312)>>2)];
      var $46401=HEAP32[(($1313)>>2)];
      var $46402=HEAP32[(($1314)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46400, $46401, $46402) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12423; break; } else { __label__ = 14612; break; }
    case 12423: // $_noexc1465
      __label__ = 12424; break;
    case 12424: // $_ZdlPvPKci_exit1466
      var $46403=$1312;
      var $46404=$1313;
      var $46405=$1314;
      __label__ = 12425; break;
    case 12425: // $46406
      __label__ = 14611; break;
    case 12426: // $46407
      var $46408=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46409=$46408.f0;
      $4692=$46409;
      var $46410=$46408.f1;
      $4693=$46410;
      var $46411=$1309;
      var $46412=$1310;
      var $46413=$1311;
      HEAP32[(($1309)>>2)]=$19315;
      HEAP32[(($1310)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1311)>>2)]=204;
      var $46414=HEAP32[(($1309)>>2)];
      var $46415=(($46414)|0)!=0;
      if ($46415) { __label__ = 12427; break; } else { __label__ = 12429; break; }
    case 12427: // $46416
      var $46417=HEAP32[(($1309)>>2)];
      var $46418=HEAP32[(($1310)>>2)];
      var $46419=HEAP32[(($1311)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46417, $46418, $46419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12428; break; } else { __label__ = 14612; break; }
    case 12428: // $_noexc1467
      __label__ = 12429; break;
    case 12429: // $_ZdlPvPKci_exit1468
      var $46420=$1309;
      var $46421=$1310;
      var $46422=$1311;
      __label__ = 12430; break;
    case 12430: // $46423
      __label__ = 14611; break;
    case 12431: // $46424
      var $46425=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46426=$46425.f0;
      $4692=$46426;
      var $46427=$46425.f1;
      $4693=$46427;
      var $46428=$1306;
      var $46429=$1307;
      var $46430=$1308;
      HEAP32[(($1306)>>2)]=$19366;
      HEAP32[(($1307)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1308)>>2)]=205;
      var $46431=HEAP32[(($1306)>>2)];
      var $46432=(($46431)|0)!=0;
      if ($46432) { __label__ = 12432; break; } else { __label__ = 12434; break; }
    case 12432: // $46433
      var $46434=HEAP32[(($1306)>>2)];
      var $46435=HEAP32[(($1307)>>2)];
      var $46436=HEAP32[(($1308)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46434, $46435, $46436) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12433; break; } else { __label__ = 14612; break; }
    case 12433: // $_noexc1469
      __label__ = 12434; break;
    case 12434: // $_ZdlPvPKci_exit1470
      var $46437=$1306;
      var $46438=$1307;
      var $46439=$1308;
      __label__ = 12435; break;
    case 12435: // $46440
      __label__ = 14611; break;
    case 12436: // $46441
      var $46442=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46443=$46442.f0;
      $4692=$46443;
      var $46444=$46442.f1;
      $4693=$46444;
      var $46445=$1303;
      var $46446=$1304;
      var $46447=$1305;
      HEAP32[(($1303)>>2)]=$19417;
      HEAP32[(($1304)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1305)>>2)]=206;
      var $46448=HEAP32[(($1303)>>2)];
      var $46449=(($46448)|0)!=0;
      if ($46449) { __label__ = 12437; break; } else { __label__ = 12439; break; }
    case 12437: // $46450
      var $46451=HEAP32[(($1303)>>2)];
      var $46452=HEAP32[(($1304)>>2)];
      var $46453=HEAP32[(($1305)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46451, $46452, $46453) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12438; break; } else { __label__ = 14612; break; }
    case 12438: // $_noexc1471
      __label__ = 12439; break;
    case 12439: // $_ZdlPvPKci_exit1472
      var $46454=$1303;
      var $46455=$1304;
      var $46456=$1305;
      __label__ = 12440; break;
    case 12440: // $46457
      __label__ = 14611; break;
    case 12441: // $46458
      var $46459=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46460=$46459.f0;
      $4692=$46460;
      var $46461=$46459.f1;
      $4693=$46461;
      var $46462=$1300;
      var $46463=$1301;
      var $46464=$1302;
      HEAP32[(($1300)>>2)]=$19468;
      HEAP32[(($1301)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1302)>>2)]=207;
      var $46465=HEAP32[(($1300)>>2)];
      var $46466=(($46465)|0)!=0;
      if ($46466) { __label__ = 12442; break; } else { __label__ = 12444; break; }
    case 12442: // $46467
      var $46468=HEAP32[(($1300)>>2)];
      var $46469=HEAP32[(($1301)>>2)];
      var $46470=HEAP32[(($1302)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46468, $46469, $46470) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12443; break; } else { __label__ = 14612; break; }
    case 12443: // $_noexc1473
      __label__ = 12444; break;
    case 12444: // $_ZdlPvPKci_exit1474
      var $46471=$1300;
      var $46472=$1301;
      var $46473=$1302;
      __label__ = 12445; break;
    case 12445: // $46474
      __label__ = 14611; break;
    case 12446: // $46475
      var $46476=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46477=$46476.f0;
      $4692=$46477;
      var $46478=$46476.f1;
      $4693=$46478;
      var $46479=$1297;
      var $46480=$1298;
      var $46481=$1299;
      HEAP32[(($1297)>>2)]=$19519;
      HEAP32[(($1298)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1299)>>2)]=208;
      var $46482=HEAP32[(($1297)>>2)];
      var $46483=(($46482)|0)!=0;
      if ($46483) { __label__ = 12447; break; } else { __label__ = 12449; break; }
    case 12447: // $46484
      var $46485=HEAP32[(($1297)>>2)];
      var $46486=HEAP32[(($1298)>>2)];
      var $46487=HEAP32[(($1299)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46485, $46486, $46487) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12448; break; } else { __label__ = 14612; break; }
    case 12448: // $_noexc1475
      __label__ = 12449; break;
    case 12449: // $_ZdlPvPKci_exit1476
      var $46488=$1297;
      var $46489=$1298;
      var $46490=$1299;
      __label__ = 12450; break;
    case 12450: // $46491
      __label__ = 14611; break;
    case 12451: // $46492
      var $46493=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46494=$46493.f0;
      $4692=$46494;
      var $46495=$46493.f1;
      $4693=$46495;
      var $46496=$1294;
      var $46497=$1295;
      var $46498=$1296;
      HEAP32[(($1294)>>2)]=$19570;
      HEAP32[(($1295)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1296)>>2)]=209;
      var $46499=HEAP32[(($1294)>>2)];
      var $46500=(($46499)|0)!=0;
      if ($46500) { __label__ = 12452; break; } else { __label__ = 12454; break; }
    case 12452: // $46501
      var $46502=HEAP32[(($1294)>>2)];
      var $46503=HEAP32[(($1295)>>2)];
      var $46504=HEAP32[(($1296)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46502, $46503, $46504) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12453; break; } else { __label__ = 14612; break; }
    case 12453: // $_noexc1477
      __label__ = 12454; break;
    case 12454: // $_ZdlPvPKci_exit1478
      var $46505=$1294;
      var $46506=$1295;
      var $46507=$1296;
      __label__ = 12455; break;
    case 12455: // $46508
      __label__ = 14611; break;
    case 12456: // $46509
      var $46510=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46511=$46510.f0;
      $4692=$46511;
      var $46512=$46510.f1;
      $4693=$46512;
      var $46513=$1291;
      var $46514=$1292;
      var $46515=$1293;
      HEAP32[(($1291)>>2)]=$19621;
      HEAP32[(($1292)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1293)>>2)]=210;
      var $46516=HEAP32[(($1291)>>2)];
      var $46517=(($46516)|0)!=0;
      if ($46517) { __label__ = 12457; break; } else { __label__ = 12459; break; }
    case 12457: // $46518
      var $46519=HEAP32[(($1291)>>2)];
      var $46520=HEAP32[(($1292)>>2)];
      var $46521=HEAP32[(($1293)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46519, $46520, $46521) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12458; break; } else { __label__ = 14612; break; }
    case 12458: // $_noexc1479
      __label__ = 12459; break;
    case 12459: // $_ZdlPvPKci_exit1480
      var $46522=$1291;
      var $46523=$1292;
      var $46524=$1293;
      __label__ = 12460; break;
    case 12460: // $46525
      __label__ = 14611; break;
    case 12461: // $46526
      var $46527=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46528=$46527.f0;
      $4692=$46528;
      var $46529=$46527.f1;
      $4693=$46529;
      var $46530=$1288;
      var $46531=$1289;
      var $46532=$1290;
      HEAP32[(($1288)>>2)]=$19672;
      HEAP32[(($1289)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1290)>>2)]=211;
      var $46533=HEAP32[(($1288)>>2)];
      var $46534=(($46533)|0)!=0;
      if ($46534) { __label__ = 12462; break; } else { __label__ = 12464; break; }
    case 12462: // $46535
      var $46536=HEAP32[(($1288)>>2)];
      var $46537=HEAP32[(($1289)>>2)];
      var $46538=HEAP32[(($1290)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46536, $46537, $46538) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12463; break; } else { __label__ = 14612; break; }
    case 12463: // $_noexc1481
      __label__ = 12464; break;
    case 12464: // $_ZdlPvPKci_exit1482
      var $46539=$1288;
      var $46540=$1289;
      var $46541=$1290;
      __label__ = 12465; break;
    case 12465: // $46542
      __label__ = 14611; break;
    case 12466: // $46543
      var $46544=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46545=$46544.f0;
      $4692=$46545;
      var $46546=$46544.f1;
      $4693=$46546;
      var $46547=$1285;
      var $46548=$1286;
      var $46549=$1287;
      HEAP32[(($1285)>>2)]=$19723;
      HEAP32[(($1286)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1287)>>2)]=212;
      var $46550=HEAP32[(($1285)>>2)];
      var $46551=(($46550)|0)!=0;
      if ($46551) { __label__ = 12467; break; } else { __label__ = 12469; break; }
    case 12467: // $46552
      var $46553=HEAP32[(($1285)>>2)];
      var $46554=HEAP32[(($1286)>>2)];
      var $46555=HEAP32[(($1287)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46553, $46554, $46555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12468; break; } else { __label__ = 14612; break; }
    case 12468: // $_noexc1483
      __label__ = 12469; break;
    case 12469: // $_ZdlPvPKci_exit1484
      var $46556=$1285;
      var $46557=$1286;
      var $46558=$1287;
      __label__ = 12470; break;
    case 12470: // $46559
      __label__ = 14611; break;
    case 12471: // $46560
      var $46561=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46562=$46561.f0;
      $4692=$46562;
      var $46563=$46561.f1;
      $4693=$46563;
      var $46564=$1282;
      var $46565=$1283;
      var $46566=$1284;
      HEAP32[(($1282)>>2)]=$19774;
      HEAP32[(($1283)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1284)>>2)]=213;
      var $46567=HEAP32[(($1282)>>2)];
      var $46568=(($46567)|0)!=0;
      if ($46568) { __label__ = 12472; break; } else { __label__ = 12474; break; }
    case 12472: // $46569
      var $46570=HEAP32[(($1282)>>2)];
      var $46571=HEAP32[(($1283)>>2)];
      var $46572=HEAP32[(($1284)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46570, $46571, $46572) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12473; break; } else { __label__ = 14612; break; }
    case 12473: // $_noexc1485
      __label__ = 12474; break;
    case 12474: // $_ZdlPvPKci_exit1486
      var $46573=$1282;
      var $46574=$1283;
      var $46575=$1284;
      __label__ = 12475; break;
    case 12475: // $46576
      __label__ = 14611; break;
    case 12476: // $46577
      var $46578=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46579=$46578.f0;
      $4692=$46579;
      var $46580=$46578.f1;
      $4693=$46580;
      var $46581=$1279;
      var $46582=$1280;
      var $46583=$1281;
      HEAP32[(($1279)>>2)]=$19825;
      HEAP32[(($1280)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1281)>>2)]=214;
      var $46584=HEAP32[(($1279)>>2)];
      var $46585=(($46584)|0)!=0;
      if ($46585) { __label__ = 12477; break; } else { __label__ = 12479; break; }
    case 12477: // $46586
      var $46587=HEAP32[(($1279)>>2)];
      var $46588=HEAP32[(($1280)>>2)];
      var $46589=HEAP32[(($1281)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46587, $46588, $46589) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12478; break; } else { __label__ = 14612; break; }
    case 12478: // $_noexc1487
      __label__ = 12479; break;
    case 12479: // $_ZdlPvPKci_exit1488
      var $46590=$1279;
      var $46591=$1280;
      var $46592=$1281;
      __label__ = 12480; break;
    case 12480: // $46593
      __label__ = 14611; break;
    case 12481: // $46594
      var $46595=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46596=$46595.f0;
      $4692=$46596;
      var $46597=$46595.f1;
      $4693=$46597;
      var $46598=$1276;
      var $46599=$1277;
      var $46600=$1278;
      HEAP32[(($1276)>>2)]=$19876;
      HEAP32[(($1277)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1278)>>2)]=215;
      var $46601=HEAP32[(($1276)>>2)];
      var $46602=(($46601)|0)!=0;
      if ($46602) { __label__ = 12482; break; } else { __label__ = 12484; break; }
    case 12482: // $46603
      var $46604=HEAP32[(($1276)>>2)];
      var $46605=HEAP32[(($1277)>>2)];
      var $46606=HEAP32[(($1278)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46604, $46605, $46606) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12483; break; } else { __label__ = 14612; break; }
    case 12483: // $_noexc1489
      __label__ = 12484; break;
    case 12484: // $_ZdlPvPKci_exit1490
      var $46607=$1276;
      var $46608=$1277;
      var $46609=$1278;
      __label__ = 12485; break;
    case 12485: // $46610
      __label__ = 14611; break;
    case 12486: // $46611
      var $46612=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46613=$46612.f0;
      $4692=$46613;
      var $46614=$46612.f1;
      $4693=$46614;
      var $46615=$1273;
      var $46616=$1274;
      var $46617=$1275;
      HEAP32[(($1273)>>2)]=$19927;
      HEAP32[(($1274)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1275)>>2)]=216;
      var $46618=HEAP32[(($1273)>>2)];
      var $46619=(($46618)|0)!=0;
      if ($46619) { __label__ = 12487; break; } else { __label__ = 12489; break; }
    case 12487: // $46620
      var $46621=HEAP32[(($1273)>>2)];
      var $46622=HEAP32[(($1274)>>2)];
      var $46623=HEAP32[(($1275)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46621, $46622, $46623) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12488; break; } else { __label__ = 14612; break; }
    case 12488: // $_noexc1491
      __label__ = 12489; break;
    case 12489: // $_ZdlPvPKci_exit1492
      var $46624=$1273;
      var $46625=$1274;
      var $46626=$1275;
      __label__ = 12490; break;
    case 12490: // $46627
      __label__ = 14611; break;
    case 12491: // $46628
      var $46629=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46630=$46629.f0;
      $4692=$46630;
      var $46631=$46629.f1;
      $4693=$46631;
      var $46632=$1270;
      var $46633=$1271;
      var $46634=$1272;
      HEAP32[(($1270)>>2)]=$19978;
      HEAP32[(($1271)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1272)>>2)]=217;
      var $46635=HEAP32[(($1270)>>2)];
      var $46636=(($46635)|0)!=0;
      if ($46636) { __label__ = 12492; break; } else { __label__ = 12494; break; }
    case 12492: // $46637
      var $46638=HEAP32[(($1270)>>2)];
      var $46639=HEAP32[(($1271)>>2)];
      var $46640=HEAP32[(($1272)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46638, $46639, $46640) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12493; break; } else { __label__ = 14612; break; }
    case 12493: // $_noexc1493
      __label__ = 12494; break;
    case 12494: // $_ZdlPvPKci_exit1494
      var $46641=$1270;
      var $46642=$1271;
      var $46643=$1272;
      __label__ = 12495; break;
    case 12495: // $46644
      __label__ = 14611; break;
    case 12496: // $46645
      var $46646=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46647=$46646.f0;
      $4692=$46647;
      var $46648=$46646.f1;
      $4693=$46648;
      var $46649=$1267;
      var $46650=$1268;
      var $46651=$1269;
      HEAP32[(($1267)>>2)]=$20029;
      HEAP32[(($1268)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1269)>>2)]=218;
      var $46652=HEAP32[(($1267)>>2)];
      var $46653=(($46652)|0)!=0;
      if ($46653) { __label__ = 12497; break; } else { __label__ = 12499; break; }
    case 12497: // $46654
      var $46655=HEAP32[(($1267)>>2)];
      var $46656=HEAP32[(($1268)>>2)];
      var $46657=HEAP32[(($1269)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46655, $46656, $46657) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12498; break; } else { __label__ = 14612; break; }
    case 12498: // $_noexc1495
      __label__ = 12499; break;
    case 12499: // $_ZdlPvPKci_exit1496
      var $46658=$1267;
      var $46659=$1268;
      var $46660=$1269;
      __label__ = 12500; break;
    case 12500: // $46661
      __label__ = 14611; break;
    case 12501: // $46662
      var $46663=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46664=$46663.f0;
      $4692=$46664;
      var $46665=$46663.f1;
      $4693=$46665;
      var $46666=$1264;
      var $46667=$1265;
      var $46668=$1266;
      HEAP32[(($1264)>>2)]=$20080;
      HEAP32[(($1265)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1266)>>2)]=220;
      var $46669=HEAP32[(($1264)>>2)];
      var $46670=(($46669)|0)!=0;
      if ($46670) { __label__ = 12502; break; } else { __label__ = 12504; break; }
    case 12502: // $46671
      var $46672=HEAP32[(($1264)>>2)];
      var $46673=HEAP32[(($1265)>>2)];
      var $46674=HEAP32[(($1266)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46672, $46673, $46674) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12503; break; } else { __label__ = 14612; break; }
    case 12503: // $_noexc1497
      __label__ = 12504; break;
    case 12504: // $_ZdlPvPKci_exit1498
      var $46675=$1264;
      var $46676=$1265;
      var $46677=$1266;
      __label__ = 12505; break;
    case 12505: // $46678
      __label__ = 14611; break;
    case 12506: // $46679
      var $46680=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46681=$46680.f0;
      $4692=$46681;
      var $46682=$46680.f1;
      $4693=$46682;
      var $46683=$1261;
      var $46684=$1262;
      var $46685=$1263;
      HEAP32[(($1261)>>2)]=$20131;
      HEAP32[(($1262)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1263)>>2)]=221;
      var $46686=HEAP32[(($1261)>>2)];
      var $46687=(($46686)|0)!=0;
      if ($46687) { __label__ = 12507; break; } else { __label__ = 12509; break; }
    case 12507: // $46688
      var $46689=HEAP32[(($1261)>>2)];
      var $46690=HEAP32[(($1262)>>2)];
      var $46691=HEAP32[(($1263)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46689, $46690, $46691) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12508; break; } else { __label__ = 14612; break; }
    case 12508: // $_noexc1499
      __label__ = 12509; break;
    case 12509: // $_ZdlPvPKci_exit1500
      var $46692=$1261;
      var $46693=$1262;
      var $46694=$1263;
      __label__ = 12510; break;
    case 12510: // $46695
      __label__ = 14611; break;
    case 12511: // $46696
      var $46697=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46698=$46697.f0;
      $4692=$46698;
      var $46699=$46697.f1;
      $4693=$46699;
      var $46700=$1258;
      var $46701=$1259;
      var $46702=$1260;
      HEAP32[(($1258)>>2)]=$20182;
      HEAP32[(($1259)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1260)>>2)]=222;
      var $46703=HEAP32[(($1258)>>2)];
      var $46704=(($46703)|0)!=0;
      if ($46704) { __label__ = 12512; break; } else { __label__ = 12514; break; }
    case 12512: // $46705
      var $46706=HEAP32[(($1258)>>2)];
      var $46707=HEAP32[(($1259)>>2)];
      var $46708=HEAP32[(($1260)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46706, $46707, $46708) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12513; break; } else { __label__ = 14612; break; }
    case 12513: // $_noexc1501
      __label__ = 12514; break;
    case 12514: // $_ZdlPvPKci_exit1502
      var $46709=$1258;
      var $46710=$1259;
      var $46711=$1260;
      __label__ = 12515; break;
    case 12515: // $46712
      __label__ = 14611; break;
    case 12516: // $46713
      var $46714=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46715=$46714.f0;
      $4692=$46715;
      var $46716=$46714.f1;
      $4693=$46716;
      var $46717=$1255;
      var $46718=$1256;
      var $46719=$1257;
      HEAP32[(($1255)>>2)]=$20233;
      HEAP32[(($1256)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1257)>>2)]=223;
      var $46720=HEAP32[(($1255)>>2)];
      var $46721=(($46720)|0)!=0;
      if ($46721) { __label__ = 12517; break; } else { __label__ = 12519; break; }
    case 12517: // $46722
      var $46723=HEAP32[(($1255)>>2)];
      var $46724=HEAP32[(($1256)>>2)];
      var $46725=HEAP32[(($1257)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46723, $46724, $46725) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12518; break; } else { __label__ = 14612; break; }
    case 12518: // $_noexc1503
      __label__ = 12519; break;
    case 12519: // $_ZdlPvPKci_exit1504
      var $46726=$1255;
      var $46727=$1256;
      var $46728=$1257;
      __label__ = 12520; break;
    case 12520: // $46729
      __label__ = 14611; break;
    case 12521: // $46730
      var $46731=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46732=$46731.f0;
      $4692=$46732;
      var $46733=$46731.f1;
      $4693=$46733;
      var $46734=$1252;
      var $46735=$1253;
      var $46736=$1254;
      HEAP32[(($1252)>>2)]=$20284;
      HEAP32[(($1253)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1254)>>2)]=224;
      var $46737=HEAP32[(($1252)>>2)];
      var $46738=(($46737)|0)!=0;
      if ($46738) { __label__ = 12522; break; } else { __label__ = 12524; break; }
    case 12522: // $46739
      var $46740=HEAP32[(($1252)>>2)];
      var $46741=HEAP32[(($1253)>>2)];
      var $46742=HEAP32[(($1254)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46740, $46741, $46742) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12523; break; } else { __label__ = 14612; break; }
    case 12523: // $_noexc1505
      __label__ = 12524; break;
    case 12524: // $_ZdlPvPKci_exit1506
      var $46743=$1252;
      var $46744=$1253;
      var $46745=$1254;
      __label__ = 12525; break;
    case 12525: // $46746
      __label__ = 14611; break;
    case 12526: // $46747
      var $46748=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46749=$46748.f0;
      $4692=$46749;
      var $46750=$46748.f1;
      $4693=$46750;
      var $46751=$1249;
      var $46752=$1250;
      var $46753=$1251;
      HEAP32[(($1249)>>2)]=$20335;
      HEAP32[(($1250)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1251)>>2)]=225;
      var $46754=HEAP32[(($1249)>>2)];
      var $46755=(($46754)|0)!=0;
      if ($46755) { __label__ = 12527; break; } else { __label__ = 12529; break; }
    case 12527: // $46756
      var $46757=HEAP32[(($1249)>>2)];
      var $46758=HEAP32[(($1250)>>2)];
      var $46759=HEAP32[(($1251)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46757, $46758, $46759) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12528; break; } else { __label__ = 14612; break; }
    case 12528: // $_noexc1507
      __label__ = 12529; break;
    case 12529: // $_ZdlPvPKci_exit1508
      var $46760=$1249;
      var $46761=$1250;
      var $46762=$1251;
      __label__ = 12530; break;
    case 12530: // $46763
      __label__ = 14611; break;
    case 12531: // $46764
      var $46765=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46766=$46765.f0;
      $4692=$46766;
      var $46767=$46765.f1;
      $4693=$46767;
      var $46768=$1246;
      var $46769=$1247;
      var $46770=$1248;
      HEAP32[(($1246)>>2)]=$20386;
      HEAP32[(($1247)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1248)>>2)]=226;
      var $46771=HEAP32[(($1246)>>2)];
      var $46772=(($46771)|0)!=0;
      if ($46772) { __label__ = 12532; break; } else { __label__ = 12534; break; }
    case 12532: // $46773
      var $46774=HEAP32[(($1246)>>2)];
      var $46775=HEAP32[(($1247)>>2)];
      var $46776=HEAP32[(($1248)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46774, $46775, $46776) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12533; break; } else { __label__ = 14612; break; }
    case 12533: // $_noexc1509
      __label__ = 12534; break;
    case 12534: // $_ZdlPvPKci_exit1510
      var $46777=$1246;
      var $46778=$1247;
      var $46779=$1248;
      __label__ = 12535; break;
    case 12535: // $46780
      __label__ = 14611; break;
    case 12536: // $46781
      var $46782=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46783=$46782.f0;
      $4692=$46783;
      var $46784=$46782.f1;
      $4693=$46784;
      var $46785=$1243;
      var $46786=$1244;
      var $46787=$1245;
      HEAP32[(($1243)>>2)]=$20437;
      HEAP32[(($1244)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1245)>>2)]=227;
      var $46788=HEAP32[(($1243)>>2)];
      var $46789=(($46788)|0)!=0;
      if ($46789) { __label__ = 12537; break; } else { __label__ = 12539; break; }
    case 12537: // $46790
      var $46791=HEAP32[(($1243)>>2)];
      var $46792=HEAP32[(($1244)>>2)];
      var $46793=HEAP32[(($1245)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46791, $46792, $46793) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12538; break; } else { __label__ = 14612; break; }
    case 12538: // $_noexc1511
      __label__ = 12539; break;
    case 12539: // $_ZdlPvPKci_exit1512
      var $46794=$1243;
      var $46795=$1244;
      var $46796=$1245;
      __label__ = 12540; break;
    case 12540: // $46797
      __label__ = 14611; break;
    case 12541: // $46798
      var $46799=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46800=$46799.f0;
      $4692=$46800;
      var $46801=$46799.f1;
      $4693=$46801;
      var $46802=$1240;
      var $46803=$1241;
      var $46804=$1242;
      HEAP32[(($1240)>>2)]=$20488;
      HEAP32[(($1241)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1242)>>2)]=228;
      var $46805=HEAP32[(($1240)>>2)];
      var $46806=(($46805)|0)!=0;
      if ($46806) { __label__ = 12542; break; } else { __label__ = 12544; break; }
    case 12542: // $46807
      var $46808=HEAP32[(($1240)>>2)];
      var $46809=HEAP32[(($1241)>>2)];
      var $46810=HEAP32[(($1242)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46808, $46809, $46810) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12543; break; } else { __label__ = 14612; break; }
    case 12543: // $_noexc1513
      __label__ = 12544; break;
    case 12544: // $_ZdlPvPKci_exit1514
      var $46811=$1240;
      var $46812=$1241;
      var $46813=$1242;
      __label__ = 12545; break;
    case 12545: // $46814
      __label__ = 14611; break;
    case 12546: // $46815
      var $46816=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46817=$46816.f0;
      $4692=$46817;
      var $46818=$46816.f1;
      $4693=$46818;
      var $46819=$1237;
      var $46820=$1238;
      var $46821=$1239;
      HEAP32[(($1237)>>2)]=$20539;
      HEAP32[(($1238)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1239)>>2)]=229;
      var $46822=HEAP32[(($1237)>>2)];
      var $46823=(($46822)|0)!=0;
      if ($46823) { __label__ = 12547; break; } else { __label__ = 12549; break; }
    case 12547: // $46824
      var $46825=HEAP32[(($1237)>>2)];
      var $46826=HEAP32[(($1238)>>2)];
      var $46827=HEAP32[(($1239)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46825, $46826, $46827) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12548; break; } else { __label__ = 14612; break; }
    case 12548: // $_noexc1515
      __label__ = 12549; break;
    case 12549: // $_ZdlPvPKci_exit1516
      var $46828=$1237;
      var $46829=$1238;
      var $46830=$1239;
      __label__ = 12550; break;
    case 12550: // $46831
      __label__ = 14611; break;
    case 12551: // $46832
      var $46833=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46834=$46833.f0;
      $4692=$46834;
      var $46835=$46833.f1;
      $4693=$46835;
      var $46836=$1234;
      var $46837=$1235;
      var $46838=$1236;
      HEAP32[(($1234)>>2)]=$20590;
      HEAP32[(($1235)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1236)>>2)]=230;
      var $46839=HEAP32[(($1234)>>2)];
      var $46840=(($46839)|0)!=0;
      if ($46840) { __label__ = 12552; break; } else { __label__ = 12554; break; }
    case 12552: // $46841
      var $46842=HEAP32[(($1234)>>2)];
      var $46843=HEAP32[(($1235)>>2)];
      var $46844=HEAP32[(($1236)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46842, $46843, $46844) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12553; break; } else { __label__ = 14612; break; }
    case 12553: // $_noexc1517
      __label__ = 12554; break;
    case 12554: // $_ZdlPvPKci_exit1518
      var $46845=$1234;
      var $46846=$1235;
      var $46847=$1236;
      __label__ = 12555; break;
    case 12555: // $46848
      __label__ = 14611; break;
    case 12556: // $46849
      var $46850=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46851=$46850.f0;
      $4692=$46851;
      var $46852=$46850.f1;
      $4693=$46852;
      var $46853=$1231;
      var $46854=$1232;
      var $46855=$1233;
      HEAP32[(($1231)>>2)]=$20641;
      HEAP32[(($1232)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1233)>>2)]=231;
      var $46856=HEAP32[(($1231)>>2)];
      var $46857=(($46856)|0)!=0;
      if ($46857) { __label__ = 12557; break; } else { __label__ = 12559; break; }
    case 12557: // $46858
      var $46859=HEAP32[(($1231)>>2)];
      var $46860=HEAP32[(($1232)>>2)];
      var $46861=HEAP32[(($1233)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46859, $46860, $46861) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12558; break; } else { __label__ = 14612; break; }
    case 12558: // $_noexc1519
      __label__ = 12559; break;
    case 12559: // $_ZdlPvPKci_exit1520
      var $46862=$1231;
      var $46863=$1232;
      var $46864=$1233;
      __label__ = 12560; break;
    case 12560: // $46865
      __label__ = 14611; break;
    case 12561: // $46866
      var $46867=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46868=$46867.f0;
      $4692=$46868;
      var $46869=$46867.f1;
      $4693=$46869;
      var $46870=$1228;
      var $46871=$1229;
      var $46872=$1230;
      HEAP32[(($1228)>>2)]=$20692;
      HEAP32[(($1229)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1230)>>2)]=232;
      var $46873=HEAP32[(($1228)>>2)];
      var $46874=(($46873)|0)!=0;
      if ($46874) { __label__ = 12562; break; } else { __label__ = 12564; break; }
    case 12562: // $46875
      var $46876=HEAP32[(($1228)>>2)];
      var $46877=HEAP32[(($1229)>>2)];
      var $46878=HEAP32[(($1230)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46876, $46877, $46878) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12563; break; } else { __label__ = 14612; break; }
    case 12563: // $_noexc1521
      __label__ = 12564; break;
    case 12564: // $_ZdlPvPKci_exit1522
      var $46879=$1228;
      var $46880=$1229;
      var $46881=$1230;
      __label__ = 12565; break;
    case 12565: // $46882
      __label__ = 14611; break;
    case 12566: // $46883
      var $46884=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46885=$46884.f0;
      $4692=$46885;
      var $46886=$46884.f1;
      $4693=$46886;
      var $46887=$1225;
      var $46888=$1226;
      var $46889=$1227;
      HEAP32[(($1225)>>2)]=$20743;
      HEAP32[(($1226)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1227)>>2)]=233;
      var $46890=HEAP32[(($1225)>>2)];
      var $46891=(($46890)|0)!=0;
      if ($46891) { __label__ = 12567; break; } else { __label__ = 12569; break; }
    case 12567: // $46892
      var $46893=HEAP32[(($1225)>>2)];
      var $46894=HEAP32[(($1226)>>2)];
      var $46895=HEAP32[(($1227)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46893, $46894, $46895) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12568; break; } else { __label__ = 14612; break; }
    case 12568: // $_noexc1523
      __label__ = 12569; break;
    case 12569: // $_ZdlPvPKci_exit1524
      var $46896=$1225;
      var $46897=$1226;
      var $46898=$1227;
      __label__ = 12570; break;
    case 12570: // $46899
      __label__ = 14611; break;
    case 12571: // $46900
      var $46901=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46902=$46901.f0;
      $4692=$46902;
      var $46903=$46901.f1;
      $4693=$46903;
      var $46904=$1222;
      var $46905=$1223;
      var $46906=$1224;
      HEAP32[(($1222)>>2)]=$20794;
      HEAP32[(($1223)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1224)>>2)]=234;
      var $46907=HEAP32[(($1222)>>2)];
      var $46908=(($46907)|0)!=0;
      if ($46908) { __label__ = 12572; break; } else { __label__ = 12574; break; }
    case 12572: // $46909
      var $46910=HEAP32[(($1222)>>2)];
      var $46911=HEAP32[(($1223)>>2)];
      var $46912=HEAP32[(($1224)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46910, $46911, $46912) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12573; break; } else { __label__ = 14612; break; }
    case 12573: // $_noexc1525
      __label__ = 12574; break;
    case 12574: // $_ZdlPvPKci_exit1526
      var $46913=$1222;
      var $46914=$1223;
      var $46915=$1224;
      __label__ = 12575; break;
    case 12575: // $46916
      __label__ = 14611; break;
    case 12576: // $46917
      var $46918=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46919=$46918.f0;
      $4692=$46919;
      var $46920=$46918.f1;
      $4693=$46920;
      var $46921=$1219;
      var $46922=$1220;
      var $46923=$1221;
      HEAP32[(($1219)>>2)]=$20845;
      HEAP32[(($1220)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1221)>>2)]=235;
      var $46924=HEAP32[(($1219)>>2)];
      var $46925=(($46924)|0)!=0;
      if ($46925) { __label__ = 12577; break; } else { __label__ = 12579; break; }
    case 12577: // $46926
      var $46927=HEAP32[(($1219)>>2)];
      var $46928=HEAP32[(($1220)>>2)];
      var $46929=HEAP32[(($1221)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46927, $46928, $46929) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12578; break; } else { __label__ = 14612; break; }
    case 12578: // $_noexc1527
      __label__ = 12579; break;
    case 12579: // $_ZdlPvPKci_exit1528
      var $46930=$1219;
      var $46931=$1220;
      var $46932=$1221;
      __label__ = 12580; break;
    case 12580: // $46933
      __label__ = 14611; break;
    case 12581: // $46934
      var $46935=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46936=$46935.f0;
      $4692=$46936;
      var $46937=$46935.f1;
      $4693=$46937;
      var $46938=$1216;
      var $46939=$1217;
      var $46940=$1218;
      HEAP32[(($1216)>>2)]=$20896;
      HEAP32[(($1217)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1218)>>2)]=236;
      var $46941=HEAP32[(($1216)>>2)];
      var $46942=(($46941)|0)!=0;
      if ($46942) { __label__ = 12582; break; } else { __label__ = 12584; break; }
    case 12582: // $46943
      var $46944=HEAP32[(($1216)>>2)];
      var $46945=HEAP32[(($1217)>>2)];
      var $46946=HEAP32[(($1218)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46944, $46945, $46946) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12583; break; } else { __label__ = 14612; break; }
    case 12583: // $_noexc1529
      __label__ = 12584; break;
    case 12584: // $_ZdlPvPKci_exit1530
      var $46947=$1216;
      var $46948=$1217;
      var $46949=$1218;
      __label__ = 12585; break;
    case 12585: // $46950
      __label__ = 14611; break;
    case 12586: // $46951
      var $46952=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46953=$46952.f0;
      $4692=$46953;
      var $46954=$46952.f1;
      $4693=$46954;
      var $46955=$1213;
      var $46956=$1214;
      var $46957=$1215;
      HEAP32[(($1213)>>2)]=$20947;
      HEAP32[(($1214)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1215)>>2)]=237;
      var $46958=HEAP32[(($1213)>>2)];
      var $46959=(($46958)|0)!=0;
      if ($46959) { __label__ = 12587; break; } else { __label__ = 12589; break; }
    case 12587: // $46960
      var $46961=HEAP32[(($1213)>>2)];
      var $46962=HEAP32[(($1214)>>2)];
      var $46963=HEAP32[(($1215)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46961, $46962, $46963) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12588; break; } else { __label__ = 14612; break; }
    case 12588: // $_noexc1531
      __label__ = 12589; break;
    case 12589: // $_ZdlPvPKci_exit1532
      var $46964=$1213;
      var $46965=$1214;
      var $46966=$1215;
      __label__ = 12590; break;
    case 12590: // $46967
      __label__ = 14611; break;
    case 12591: // $46968
      var $46969=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46970=$46969.f0;
      $4692=$46970;
      var $46971=$46969.f1;
      $4693=$46971;
      var $46972=$1210;
      var $46973=$1211;
      var $46974=$1212;
      HEAP32[(($1210)>>2)]=$20998;
      HEAP32[(($1211)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1212)>>2)]=238;
      var $46975=HEAP32[(($1210)>>2)];
      var $46976=(($46975)|0)!=0;
      if ($46976) { __label__ = 12592; break; } else { __label__ = 12594; break; }
    case 12592: // $46977
      var $46978=HEAP32[(($1210)>>2)];
      var $46979=HEAP32[(($1211)>>2)];
      var $46980=HEAP32[(($1212)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46978, $46979, $46980) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12593; break; } else { __label__ = 14612; break; }
    case 12593: // $_noexc1533
      __label__ = 12594; break;
    case 12594: // $_ZdlPvPKci_exit1534
      var $46981=$1210;
      var $46982=$1211;
      var $46983=$1212;
      __label__ = 12595; break;
    case 12595: // $46984
      __label__ = 14611; break;
    case 12596: // $46985
      var $46986=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46987=$46986.f0;
      $4692=$46987;
      var $46988=$46986.f1;
      $4693=$46988;
      var $46989=$1207;
      var $46990=$1208;
      var $46991=$1209;
      HEAP32[(($1207)>>2)]=$21049;
      HEAP32[(($1208)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1209)>>2)]=239;
      var $46992=HEAP32[(($1207)>>2)];
      var $46993=(($46992)|0)!=0;
      if ($46993) { __label__ = 12597; break; } else { __label__ = 12599; break; }
    case 12597: // $46994
      var $46995=HEAP32[(($1207)>>2)];
      var $46996=HEAP32[(($1208)>>2)];
      var $46997=HEAP32[(($1209)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($46995, $46996, $46997) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12598; break; } else { __label__ = 14612; break; }
    case 12598: // $_noexc1535
      __label__ = 12599; break;
    case 12599: // $_ZdlPvPKci_exit1536
      var $46998=$1207;
      var $46999=$1208;
      var $47000=$1209;
      __label__ = 12600; break;
    case 12600: // $47001
      __label__ = 14611; break;
    case 12601: // $47002
      var $47003=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47004=$47003.f0;
      $4692=$47004;
      var $47005=$47003.f1;
      $4693=$47005;
      var $47006=$1204;
      var $47007=$1205;
      var $47008=$1206;
      HEAP32[(($1204)>>2)]=$21100;
      HEAP32[(($1205)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1206)>>2)]=240;
      var $47009=HEAP32[(($1204)>>2)];
      var $47010=(($47009)|0)!=0;
      if ($47010) { __label__ = 12602; break; } else { __label__ = 12604; break; }
    case 12602: // $47011
      var $47012=HEAP32[(($1204)>>2)];
      var $47013=HEAP32[(($1205)>>2)];
      var $47014=HEAP32[(($1206)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47012, $47013, $47014) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12603; break; } else { __label__ = 14612; break; }
    case 12603: // $_noexc1537
      __label__ = 12604; break;
    case 12604: // $_ZdlPvPKci_exit1538
      var $47015=$1204;
      var $47016=$1205;
      var $47017=$1206;
      __label__ = 12605; break;
    case 12605: // $47018
      __label__ = 14611; break;
    case 12606: // $47019
      var $47020=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47021=$47020.f0;
      $4692=$47021;
      var $47022=$47020.f1;
      $4693=$47022;
      var $47023=$1201;
      var $47024=$1202;
      var $47025=$1203;
      HEAP32[(($1201)>>2)]=$21151;
      HEAP32[(($1202)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1203)>>2)]=241;
      var $47026=HEAP32[(($1201)>>2)];
      var $47027=(($47026)|0)!=0;
      if ($47027) { __label__ = 12607; break; } else { __label__ = 12609; break; }
    case 12607: // $47028
      var $47029=HEAP32[(($1201)>>2)];
      var $47030=HEAP32[(($1202)>>2)];
      var $47031=HEAP32[(($1203)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47029, $47030, $47031) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12608; break; } else { __label__ = 14612; break; }
    case 12608: // $_noexc1539
      __label__ = 12609; break;
    case 12609: // $_ZdlPvPKci_exit1540
      var $47032=$1201;
      var $47033=$1202;
      var $47034=$1203;
      __label__ = 12610; break;
    case 12610: // $47035
      __label__ = 14611; break;
    case 12611: // $47036
      var $47037=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47038=$47037.f0;
      $4692=$47038;
      var $47039=$47037.f1;
      $4693=$47039;
      var $47040=$1198;
      var $47041=$1199;
      var $47042=$1200;
      HEAP32[(($1198)>>2)]=$21202;
      HEAP32[(($1199)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1200)>>2)]=242;
      var $47043=HEAP32[(($1198)>>2)];
      var $47044=(($47043)|0)!=0;
      if ($47044) { __label__ = 12612; break; } else { __label__ = 12614; break; }
    case 12612: // $47045
      var $47046=HEAP32[(($1198)>>2)];
      var $47047=HEAP32[(($1199)>>2)];
      var $47048=HEAP32[(($1200)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47046, $47047, $47048) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12613; break; } else { __label__ = 14612; break; }
    case 12613: // $_noexc1541
      __label__ = 12614; break;
    case 12614: // $_ZdlPvPKci_exit1542
      var $47049=$1198;
      var $47050=$1199;
      var $47051=$1200;
      __label__ = 12615; break;
    case 12615: // $47052
      __label__ = 14611; break;
    case 12616: // $47053
      var $47054=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47055=$47054.f0;
      $4692=$47055;
      var $47056=$47054.f1;
      $4693=$47056;
      var $47057=$1195;
      var $47058=$1196;
      var $47059=$1197;
      HEAP32[(($1195)>>2)]=$21253;
      HEAP32[(($1196)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1197)>>2)]=243;
      var $47060=HEAP32[(($1195)>>2)];
      var $47061=(($47060)|0)!=0;
      if ($47061) { __label__ = 12617; break; } else { __label__ = 12619; break; }
    case 12617: // $47062
      var $47063=HEAP32[(($1195)>>2)];
      var $47064=HEAP32[(($1196)>>2)];
      var $47065=HEAP32[(($1197)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47063, $47064, $47065) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12618; break; } else { __label__ = 14612; break; }
    case 12618: // $_noexc1543
      __label__ = 12619; break;
    case 12619: // $_ZdlPvPKci_exit1544
      var $47066=$1195;
      var $47067=$1196;
      var $47068=$1197;
      __label__ = 12620; break;
    case 12620: // $47069
      __label__ = 14611; break;
    case 12621: // $47070
      var $47071=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47072=$47071.f0;
      $4692=$47072;
      var $47073=$47071.f1;
      $4693=$47073;
      var $47074=$1192;
      var $47075=$1193;
      var $47076=$1194;
      HEAP32[(($1192)>>2)]=$21304;
      HEAP32[(($1193)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1194)>>2)]=244;
      var $47077=HEAP32[(($1192)>>2)];
      var $47078=(($47077)|0)!=0;
      if ($47078) { __label__ = 12622; break; } else { __label__ = 12624; break; }
    case 12622: // $47079
      var $47080=HEAP32[(($1192)>>2)];
      var $47081=HEAP32[(($1193)>>2)];
      var $47082=HEAP32[(($1194)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47080, $47081, $47082) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12623; break; } else { __label__ = 14612; break; }
    case 12623: // $_noexc1545
      __label__ = 12624; break;
    case 12624: // $_ZdlPvPKci_exit1546
      var $47083=$1192;
      var $47084=$1193;
      var $47085=$1194;
      __label__ = 12625; break;
    case 12625: // $47086
      __label__ = 14611; break;
    case 12626: // $47087
      var $47088=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47089=$47088.f0;
      $4692=$47089;
      var $47090=$47088.f1;
      $4693=$47090;
      var $47091=$1189;
      var $47092=$1190;
      var $47093=$1191;
      HEAP32[(($1189)>>2)]=$21355;
      HEAP32[(($1190)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1191)>>2)]=245;
      var $47094=HEAP32[(($1189)>>2)];
      var $47095=(($47094)|0)!=0;
      if ($47095) { __label__ = 12627; break; } else { __label__ = 12629; break; }
    case 12627: // $47096
      var $47097=HEAP32[(($1189)>>2)];
      var $47098=HEAP32[(($1190)>>2)];
      var $47099=HEAP32[(($1191)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47097, $47098, $47099) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12628; break; } else { __label__ = 14612; break; }
    case 12628: // $_noexc1547
      __label__ = 12629; break;
    case 12629: // $_ZdlPvPKci_exit1548
      var $47100=$1189;
      var $47101=$1190;
      var $47102=$1191;
      __label__ = 12630; break;
    case 12630: // $47103
      __label__ = 14611; break;
    case 12631: // $47104
      var $47105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47106=$47105.f0;
      $4692=$47106;
      var $47107=$47105.f1;
      $4693=$47107;
      var $47108=$1186;
      var $47109=$1187;
      var $47110=$1188;
      HEAP32[(($1186)>>2)]=$21406;
      HEAP32[(($1187)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1188)>>2)]=246;
      var $47111=HEAP32[(($1186)>>2)];
      var $47112=(($47111)|0)!=0;
      if ($47112) { __label__ = 12632; break; } else { __label__ = 12634; break; }
    case 12632: // $47113
      var $47114=HEAP32[(($1186)>>2)];
      var $47115=HEAP32[(($1187)>>2)];
      var $47116=HEAP32[(($1188)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47114, $47115, $47116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12633; break; } else { __label__ = 14612; break; }
    case 12633: // $_noexc1549
      __label__ = 12634; break;
    case 12634: // $_ZdlPvPKci_exit1550
      var $47117=$1186;
      var $47118=$1187;
      var $47119=$1188;
      __label__ = 12635; break;
    case 12635: // $47120
      __label__ = 14611; break;
    case 12636: // $47121
      var $47122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47123=$47122.f0;
      $4692=$47123;
      var $47124=$47122.f1;
      $4693=$47124;
      var $47125=$1183;
      var $47126=$1184;
      var $47127=$1185;
      HEAP32[(($1183)>>2)]=$21457;
      HEAP32[(($1184)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1185)>>2)]=247;
      var $47128=HEAP32[(($1183)>>2)];
      var $47129=(($47128)|0)!=0;
      if ($47129) { __label__ = 12637; break; } else { __label__ = 12639; break; }
    case 12637: // $47130
      var $47131=HEAP32[(($1183)>>2)];
      var $47132=HEAP32[(($1184)>>2)];
      var $47133=HEAP32[(($1185)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47131, $47132, $47133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12638; break; } else { __label__ = 14612; break; }
    case 12638: // $_noexc1551
      __label__ = 12639; break;
    case 12639: // $_ZdlPvPKci_exit1552
      var $47134=$1183;
      var $47135=$1184;
      var $47136=$1185;
      __label__ = 12640; break;
    case 12640: // $47137
      __label__ = 14611; break;
    case 12641: // $47138
      var $47139=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47140=$47139.f0;
      $4692=$47140;
      var $47141=$47139.f1;
      $4693=$47141;
      var $47142=$1180;
      var $47143=$1181;
      var $47144=$1182;
      HEAP32[(($1180)>>2)]=$21508;
      HEAP32[(($1181)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1182)>>2)]=248;
      var $47145=HEAP32[(($1180)>>2)];
      var $47146=(($47145)|0)!=0;
      if ($47146) { __label__ = 12642; break; } else { __label__ = 12644; break; }
    case 12642: // $47147
      var $47148=HEAP32[(($1180)>>2)];
      var $47149=HEAP32[(($1181)>>2)];
      var $47150=HEAP32[(($1182)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47148, $47149, $47150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12643; break; } else { __label__ = 14612; break; }
    case 12643: // $_noexc1553
      __label__ = 12644; break;
    case 12644: // $_ZdlPvPKci_exit1554
      var $47151=$1180;
      var $47152=$1181;
      var $47153=$1182;
      __label__ = 12645; break;
    case 12645: // $47154
      __label__ = 14611; break;
    case 12646: // $47155
      var $47156=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47157=$47156.f0;
      $4692=$47157;
      var $47158=$47156.f1;
      $4693=$47158;
      var $47159=$1177;
      var $47160=$1178;
      var $47161=$1179;
      HEAP32[(($1177)>>2)]=$21559;
      HEAP32[(($1178)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1179)>>2)]=249;
      var $47162=HEAP32[(($1177)>>2)];
      var $47163=(($47162)|0)!=0;
      if ($47163) { __label__ = 12647; break; } else { __label__ = 12649; break; }
    case 12647: // $47164
      var $47165=HEAP32[(($1177)>>2)];
      var $47166=HEAP32[(($1178)>>2)];
      var $47167=HEAP32[(($1179)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47165, $47166, $47167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12648; break; } else { __label__ = 14612; break; }
    case 12648: // $_noexc1555
      __label__ = 12649; break;
    case 12649: // $_ZdlPvPKci_exit1556
      var $47168=$1177;
      var $47169=$1178;
      var $47170=$1179;
      __label__ = 12650; break;
    case 12650: // $47171
      __label__ = 14611; break;
    case 12651: // $47172
      var $47173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47174=$47173.f0;
      $4692=$47174;
      var $47175=$47173.f1;
      $4693=$47175;
      var $47176=$1174;
      var $47177=$1175;
      var $47178=$1176;
      HEAP32[(($1174)>>2)]=$21610;
      HEAP32[(($1175)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1176)>>2)]=251;
      var $47179=HEAP32[(($1174)>>2)];
      var $47180=(($47179)|0)!=0;
      if ($47180) { __label__ = 12652; break; } else { __label__ = 12654; break; }
    case 12652: // $47181
      var $47182=HEAP32[(($1174)>>2)];
      var $47183=HEAP32[(($1175)>>2)];
      var $47184=HEAP32[(($1176)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47182, $47183, $47184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12653; break; } else { __label__ = 14612; break; }
    case 12653: // $_noexc1557
      __label__ = 12654; break;
    case 12654: // $_ZdlPvPKci_exit1558
      var $47185=$1174;
      var $47186=$1175;
      var $47187=$1176;
      __label__ = 12655; break;
    case 12655: // $47188
      __label__ = 14611; break;
    case 12656: // $47189
      var $47190=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47191=$47190.f0;
      $4692=$47191;
      var $47192=$47190.f1;
      $4693=$47192;
      var $47193=$1171;
      var $47194=$1172;
      var $47195=$1173;
      HEAP32[(($1171)>>2)]=$21661;
      HEAP32[(($1172)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1173)>>2)]=252;
      var $47196=HEAP32[(($1171)>>2)];
      var $47197=(($47196)|0)!=0;
      if ($47197) { __label__ = 12657; break; } else { __label__ = 12659; break; }
    case 12657: // $47198
      var $47199=HEAP32[(($1171)>>2)];
      var $47200=HEAP32[(($1172)>>2)];
      var $47201=HEAP32[(($1173)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47199, $47200, $47201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12658; break; } else { __label__ = 14612; break; }
    case 12658: // $_noexc1559
      __label__ = 12659; break;
    case 12659: // $_ZdlPvPKci_exit1560
      var $47202=$1171;
      var $47203=$1172;
      var $47204=$1173;
      __label__ = 12660; break;
    case 12660: // $47205
      __label__ = 14611; break;
    case 12661: // $47206
      var $47207=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47208=$47207.f0;
      $4692=$47208;
      var $47209=$47207.f1;
      $4693=$47209;
      var $47210=$1168;
      var $47211=$1169;
      var $47212=$1170;
      HEAP32[(($1168)>>2)]=$21712;
      HEAP32[(($1169)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1170)>>2)]=253;
      var $47213=HEAP32[(($1168)>>2)];
      var $47214=(($47213)|0)!=0;
      if ($47214) { __label__ = 12662; break; } else { __label__ = 12664; break; }
    case 12662: // $47215
      var $47216=HEAP32[(($1168)>>2)];
      var $47217=HEAP32[(($1169)>>2)];
      var $47218=HEAP32[(($1170)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47216, $47217, $47218) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12663; break; } else { __label__ = 14612; break; }
    case 12663: // $_noexc1561
      __label__ = 12664; break;
    case 12664: // $_ZdlPvPKci_exit1562
      var $47219=$1168;
      var $47220=$1169;
      var $47221=$1170;
      __label__ = 12665; break;
    case 12665: // $47222
      __label__ = 14611; break;
    case 12666: // $47223
      var $47224=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47225=$47224.f0;
      $4692=$47225;
      var $47226=$47224.f1;
      $4693=$47226;
      var $47227=$1165;
      var $47228=$1166;
      var $47229=$1167;
      HEAP32[(($1165)>>2)]=$21763;
      HEAP32[(($1166)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1167)>>2)]=254;
      var $47230=HEAP32[(($1165)>>2)];
      var $47231=(($47230)|0)!=0;
      if ($47231) { __label__ = 12667; break; } else { __label__ = 12669; break; }
    case 12667: // $47232
      var $47233=HEAP32[(($1165)>>2)];
      var $47234=HEAP32[(($1166)>>2)];
      var $47235=HEAP32[(($1167)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47233, $47234, $47235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12668; break; } else { __label__ = 14612; break; }
    case 12668: // $_noexc1563
      __label__ = 12669; break;
    case 12669: // $_ZdlPvPKci_exit1564
      var $47236=$1165;
      var $47237=$1166;
      var $47238=$1167;
      __label__ = 12670; break;
    case 12670: // $47239
      __label__ = 14611; break;
    case 12671: // $47240
      var $47241=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47242=$47241.f0;
      $4692=$47242;
      var $47243=$47241.f1;
      $4693=$47243;
      var $47244=$1162;
      var $47245=$1163;
      var $47246=$1164;
      HEAP32[(($1162)>>2)]=$21814;
      HEAP32[(($1163)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1164)>>2)]=255;
      var $47247=HEAP32[(($1162)>>2)];
      var $47248=(($47247)|0)!=0;
      if ($47248) { __label__ = 12672; break; } else { __label__ = 12674; break; }
    case 12672: // $47249
      var $47250=HEAP32[(($1162)>>2)];
      var $47251=HEAP32[(($1163)>>2)];
      var $47252=HEAP32[(($1164)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47250, $47251, $47252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12673; break; } else { __label__ = 14612; break; }
    case 12673: // $_noexc1565
      __label__ = 12674; break;
    case 12674: // $_ZdlPvPKci_exit1566
      var $47253=$1162;
      var $47254=$1163;
      var $47255=$1164;
      __label__ = 12675; break;
    case 12675: // $47256
      __label__ = 14611; break;
    case 12676: // $47257
      var $47258=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47259=$47258.f0;
      $4692=$47259;
      var $47260=$47258.f1;
      $4693=$47260;
      var $47261=$1159;
      var $47262=$1160;
      var $47263=$1161;
      HEAP32[(($1159)>>2)]=$21865;
      HEAP32[(($1160)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1161)>>2)]=256;
      var $47264=HEAP32[(($1159)>>2)];
      var $47265=(($47264)|0)!=0;
      if ($47265) { __label__ = 12677; break; } else { __label__ = 12679; break; }
    case 12677: // $47266
      var $47267=HEAP32[(($1159)>>2)];
      var $47268=HEAP32[(($1160)>>2)];
      var $47269=HEAP32[(($1161)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47267, $47268, $47269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12678; break; } else { __label__ = 14612; break; }
    case 12678: // $_noexc1567
      __label__ = 12679; break;
    case 12679: // $_ZdlPvPKci_exit1568
      var $47270=$1159;
      var $47271=$1160;
      var $47272=$1161;
      __label__ = 12680; break;
    case 12680: // $47273
      __label__ = 14611; break;
    case 12681: // $47274
      var $47275=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47276=$47275.f0;
      $4692=$47276;
      var $47277=$47275.f1;
      $4693=$47277;
      var $47278=$1156;
      var $47279=$1157;
      var $47280=$1158;
      HEAP32[(($1156)>>2)]=$21916;
      HEAP32[(($1157)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1158)>>2)]=257;
      var $47281=HEAP32[(($1156)>>2)];
      var $47282=(($47281)|0)!=0;
      if ($47282) { __label__ = 12682; break; } else { __label__ = 12684; break; }
    case 12682: // $47283
      var $47284=HEAP32[(($1156)>>2)];
      var $47285=HEAP32[(($1157)>>2)];
      var $47286=HEAP32[(($1158)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47284, $47285, $47286) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12683; break; } else { __label__ = 14612; break; }
    case 12683: // $_noexc1569
      __label__ = 12684; break;
    case 12684: // $_ZdlPvPKci_exit1570
      var $47287=$1156;
      var $47288=$1157;
      var $47289=$1158;
      __label__ = 12685; break;
    case 12685: // $47290
      __label__ = 14611; break;
    case 12686: // $47291
      var $47292=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47293=$47292.f0;
      $4692=$47293;
      var $47294=$47292.f1;
      $4693=$47294;
      var $47295=$1153;
      var $47296=$1154;
      var $47297=$1155;
      HEAP32[(($1153)>>2)]=$21967;
      HEAP32[(($1154)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1155)>>2)]=258;
      var $47298=HEAP32[(($1153)>>2)];
      var $47299=(($47298)|0)!=0;
      if ($47299) { __label__ = 12687; break; } else { __label__ = 12689; break; }
    case 12687: // $47300
      var $47301=HEAP32[(($1153)>>2)];
      var $47302=HEAP32[(($1154)>>2)];
      var $47303=HEAP32[(($1155)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47301, $47302, $47303) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12688; break; } else { __label__ = 14612; break; }
    case 12688: // $_noexc1571
      __label__ = 12689; break;
    case 12689: // $_ZdlPvPKci_exit1572
      var $47304=$1153;
      var $47305=$1154;
      var $47306=$1155;
      __label__ = 12690; break;
    case 12690: // $47307
      __label__ = 14611; break;
    case 12691: // $47308
      var $47309=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47310=$47309.f0;
      $4692=$47310;
      var $47311=$47309.f1;
      $4693=$47311;
      var $47312=$1150;
      var $47313=$1151;
      var $47314=$1152;
      HEAP32[(($1150)>>2)]=$22018;
      HEAP32[(($1151)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1152)>>2)]=259;
      var $47315=HEAP32[(($1150)>>2)];
      var $47316=(($47315)|0)!=0;
      if ($47316) { __label__ = 12692; break; } else { __label__ = 12694; break; }
    case 12692: // $47317
      var $47318=HEAP32[(($1150)>>2)];
      var $47319=HEAP32[(($1151)>>2)];
      var $47320=HEAP32[(($1152)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47318, $47319, $47320) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12693; break; } else { __label__ = 14612; break; }
    case 12693: // $_noexc1573
      __label__ = 12694; break;
    case 12694: // $_ZdlPvPKci_exit1574
      var $47321=$1150;
      var $47322=$1151;
      var $47323=$1152;
      __label__ = 12695; break;
    case 12695: // $47324
      __label__ = 14611; break;
    case 12696: // $47325
      var $47326=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47327=$47326.f0;
      $4692=$47327;
      var $47328=$47326.f1;
      $4693=$47328;
      var $47329=$1147;
      var $47330=$1148;
      var $47331=$1149;
      HEAP32[(($1147)>>2)]=$22069;
      HEAP32[(($1148)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1149)>>2)]=260;
      var $47332=HEAP32[(($1147)>>2)];
      var $47333=(($47332)|0)!=0;
      if ($47333) { __label__ = 12697; break; } else { __label__ = 12699; break; }
    case 12697: // $47334
      var $47335=HEAP32[(($1147)>>2)];
      var $47336=HEAP32[(($1148)>>2)];
      var $47337=HEAP32[(($1149)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47335, $47336, $47337) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12698; break; } else { __label__ = 14612; break; }
    case 12698: // $_noexc1575
      __label__ = 12699; break;
    case 12699: // $_ZdlPvPKci_exit1576
      var $47338=$1147;
      var $47339=$1148;
      var $47340=$1149;
      __label__ = 12700; break;
    case 12700: // $47341
      __label__ = 14611; break;
    case 12701: // $47342
      var $47343=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47344=$47343.f0;
      $4692=$47344;
      var $47345=$47343.f1;
      $4693=$47345;
      var $47346=$1144;
      var $47347=$1145;
      var $47348=$1146;
      HEAP32[(($1144)>>2)]=$22120;
      HEAP32[(($1145)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1146)>>2)]=261;
      var $47349=HEAP32[(($1144)>>2)];
      var $47350=(($47349)|0)!=0;
      if ($47350) { __label__ = 12702; break; } else { __label__ = 12704; break; }
    case 12702: // $47351
      var $47352=HEAP32[(($1144)>>2)];
      var $47353=HEAP32[(($1145)>>2)];
      var $47354=HEAP32[(($1146)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47352, $47353, $47354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12703; break; } else { __label__ = 14612; break; }
    case 12703: // $_noexc1577
      __label__ = 12704; break;
    case 12704: // $_ZdlPvPKci_exit1578
      var $47355=$1144;
      var $47356=$1145;
      var $47357=$1146;
      __label__ = 12705; break;
    case 12705: // $47358
      __label__ = 14611; break;
    case 12706: // $47359
      var $47360=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47361=$47360.f0;
      $4692=$47361;
      var $47362=$47360.f1;
      $4693=$47362;
      var $47363=$1141;
      var $47364=$1142;
      var $47365=$1143;
      HEAP32[(($1141)>>2)]=$22171;
      HEAP32[(($1142)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1143)>>2)]=262;
      var $47366=HEAP32[(($1141)>>2)];
      var $47367=(($47366)|0)!=0;
      if ($47367) { __label__ = 12707; break; } else { __label__ = 12709; break; }
    case 12707: // $47368
      var $47369=HEAP32[(($1141)>>2)];
      var $47370=HEAP32[(($1142)>>2)];
      var $47371=HEAP32[(($1143)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47369, $47370, $47371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12708; break; } else { __label__ = 14612; break; }
    case 12708: // $_noexc1579
      __label__ = 12709; break;
    case 12709: // $_ZdlPvPKci_exit1580
      var $47372=$1141;
      var $47373=$1142;
      var $47374=$1143;
      __label__ = 12710; break;
    case 12710: // $47375
      __label__ = 14611; break;
    case 12711: // $47376
      var $47377=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47378=$47377.f0;
      $4692=$47378;
      var $47379=$47377.f1;
      $4693=$47379;
      var $47380=$1138;
      var $47381=$1139;
      var $47382=$1140;
      HEAP32[(($1138)>>2)]=$22222;
      HEAP32[(($1139)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1140)>>2)]=263;
      var $47383=HEAP32[(($1138)>>2)];
      var $47384=(($47383)|0)!=0;
      if ($47384) { __label__ = 12712; break; } else { __label__ = 12714; break; }
    case 12712: // $47385
      var $47386=HEAP32[(($1138)>>2)];
      var $47387=HEAP32[(($1139)>>2)];
      var $47388=HEAP32[(($1140)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47386, $47387, $47388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12713; break; } else { __label__ = 14612; break; }
    case 12713: // $_noexc1581
      __label__ = 12714; break;
    case 12714: // $_ZdlPvPKci_exit1582
      var $47389=$1138;
      var $47390=$1139;
      var $47391=$1140;
      __label__ = 12715; break;
    case 12715: // $47392
      __label__ = 14611; break;
    case 12716: // $47393
      var $47394=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47395=$47394.f0;
      $4692=$47395;
      var $47396=$47394.f1;
      $4693=$47396;
      var $47397=$1135;
      var $47398=$1136;
      var $47399=$1137;
      HEAP32[(($1135)>>2)]=$22273;
      HEAP32[(($1136)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1137)>>2)]=264;
      var $47400=HEAP32[(($1135)>>2)];
      var $47401=(($47400)|0)!=0;
      if ($47401) { __label__ = 12717; break; } else { __label__ = 12719; break; }
    case 12717: // $47402
      var $47403=HEAP32[(($1135)>>2)];
      var $47404=HEAP32[(($1136)>>2)];
      var $47405=HEAP32[(($1137)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47403, $47404, $47405) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12718; break; } else { __label__ = 14612; break; }
    case 12718: // $_noexc1583
      __label__ = 12719; break;
    case 12719: // $_ZdlPvPKci_exit1584
      var $47406=$1135;
      var $47407=$1136;
      var $47408=$1137;
      __label__ = 12720; break;
    case 12720: // $47409
      __label__ = 14611; break;
    case 12721: // $47410
      var $47411=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47412=$47411.f0;
      $4692=$47412;
      var $47413=$47411.f1;
      $4693=$47413;
      var $47414=$1132;
      var $47415=$1133;
      var $47416=$1134;
      HEAP32[(($1132)>>2)]=$22324;
      HEAP32[(($1133)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1134)>>2)]=265;
      var $47417=HEAP32[(($1132)>>2)];
      var $47418=(($47417)|0)!=0;
      if ($47418) { __label__ = 12722; break; } else { __label__ = 12724; break; }
    case 12722: // $47419
      var $47420=HEAP32[(($1132)>>2)];
      var $47421=HEAP32[(($1133)>>2)];
      var $47422=HEAP32[(($1134)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47420, $47421, $47422) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12723; break; } else { __label__ = 14612; break; }
    case 12723: // $_noexc1585
      __label__ = 12724; break;
    case 12724: // $_ZdlPvPKci_exit1586
      var $47423=$1132;
      var $47424=$1133;
      var $47425=$1134;
      __label__ = 12725; break;
    case 12725: // $47426
      __label__ = 14611; break;
    case 12726: // $47427
      var $47428=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47429=$47428.f0;
      $4692=$47429;
      var $47430=$47428.f1;
      $4693=$47430;
      var $47431=$1129;
      var $47432=$1130;
      var $47433=$1131;
      HEAP32[(($1129)>>2)]=$22375;
      HEAP32[(($1130)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1131)>>2)]=266;
      var $47434=HEAP32[(($1129)>>2)];
      var $47435=(($47434)|0)!=0;
      if ($47435) { __label__ = 12727; break; } else { __label__ = 12729; break; }
    case 12727: // $47436
      var $47437=HEAP32[(($1129)>>2)];
      var $47438=HEAP32[(($1130)>>2)];
      var $47439=HEAP32[(($1131)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47437, $47438, $47439) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12728; break; } else { __label__ = 14612; break; }
    case 12728: // $_noexc1587
      __label__ = 12729; break;
    case 12729: // $_ZdlPvPKci_exit1588
      var $47440=$1129;
      var $47441=$1130;
      var $47442=$1131;
      __label__ = 12730; break;
    case 12730: // $47443
      __label__ = 14611; break;
    case 12731: // $47444
      var $47445=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47446=$47445.f0;
      $4692=$47446;
      var $47447=$47445.f1;
      $4693=$47447;
      var $47448=$1126;
      var $47449=$1127;
      var $47450=$1128;
      HEAP32[(($1126)>>2)]=$22426;
      HEAP32[(($1127)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1128)>>2)]=267;
      var $47451=HEAP32[(($1126)>>2)];
      var $47452=(($47451)|0)!=0;
      if ($47452) { __label__ = 12732; break; } else { __label__ = 12734; break; }
    case 12732: // $47453
      var $47454=HEAP32[(($1126)>>2)];
      var $47455=HEAP32[(($1127)>>2)];
      var $47456=HEAP32[(($1128)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47454, $47455, $47456) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12733; break; } else { __label__ = 14612; break; }
    case 12733: // $_noexc1589
      __label__ = 12734; break;
    case 12734: // $_ZdlPvPKci_exit1590
      var $47457=$1126;
      var $47458=$1127;
      var $47459=$1128;
      __label__ = 12735; break;
    case 12735: // $47460
      __label__ = 14611; break;
    case 12736: // $47461
      var $47462=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47463=$47462.f0;
      $4692=$47463;
      var $47464=$47462.f1;
      $4693=$47464;
      var $47465=$1123;
      var $47466=$1124;
      var $47467=$1125;
      HEAP32[(($1123)>>2)]=$22477;
      HEAP32[(($1124)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1125)>>2)]=268;
      var $47468=HEAP32[(($1123)>>2)];
      var $47469=(($47468)|0)!=0;
      if ($47469) { __label__ = 12737; break; } else { __label__ = 12739; break; }
    case 12737: // $47470
      var $47471=HEAP32[(($1123)>>2)];
      var $47472=HEAP32[(($1124)>>2)];
      var $47473=HEAP32[(($1125)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47471, $47472, $47473) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12738; break; } else { __label__ = 14612; break; }
    case 12738: // $_noexc1591
      __label__ = 12739; break;
    case 12739: // $_ZdlPvPKci_exit1592
      var $47474=$1123;
      var $47475=$1124;
      var $47476=$1125;
      __label__ = 12740; break;
    case 12740: // $47477
      __label__ = 14611; break;
    case 12741: // $47478
      var $47479=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47480=$47479.f0;
      $4692=$47480;
      var $47481=$47479.f1;
      $4693=$47481;
      var $47482=$1120;
      var $47483=$1121;
      var $47484=$1122;
      HEAP32[(($1120)>>2)]=$22528;
      HEAP32[(($1121)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1122)>>2)]=269;
      var $47485=HEAP32[(($1120)>>2)];
      var $47486=(($47485)|0)!=0;
      if ($47486) { __label__ = 12742; break; } else { __label__ = 12744; break; }
    case 12742: // $47487
      var $47488=HEAP32[(($1120)>>2)];
      var $47489=HEAP32[(($1121)>>2)];
      var $47490=HEAP32[(($1122)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47488, $47489, $47490) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12743; break; } else { __label__ = 14612; break; }
    case 12743: // $_noexc1593
      __label__ = 12744; break;
    case 12744: // $_ZdlPvPKci_exit1594
      var $47491=$1120;
      var $47492=$1121;
      var $47493=$1122;
      __label__ = 12745; break;
    case 12745: // $47494
      __label__ = 14611; break;
    case 12746: // $47495
      var $47496=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47497=$47496.f0;
      $4692=$47497;
      var $47498=$47496.f1;
      $4693=$47498;
      var $47499=$1117;
      var $47500=$1118;
      var $47501=$1119;
      HEAP32[(($1117)>>2)]=$22579;
      HEAP32[(($1118)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1119)>>2)]=270;
      var $47502=HEAP32[(($1117)>>2)];
      var $47503=(($47502)|0)!=0;
      if ($47503) { __label__ = 12747; break; } else { __label__ = 12749; break; }
    case 12747: // $47504
      var $47505=HEAP32[(($1117)>>2)];
      var $47506=HEAP32[(($1118)>>2)];
      var $47507=HEAP32[(($1119)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47505, $47506, $47507) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12748; break; } else { __label__ = 14612; break; }
    case 12748: // $_noexc1595
      __label__ = 12749; break;
    case 12749: // $_ZdlPvPKci_exit1596
      var $47508=$1117;
      var $47509=$1118;
      var $47510=$1119;
      __label__ = 12750; break;
    case 12750: // $47511
      __label__ = 14611; break;
    case 12751: // $47512
      var $47513=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47514=$47513.f0;
      $4692=$47514;
      var $47515=$47513.f1;
      $4693=$47515;
      var $47516=$1114;
      var $47517=$1115;
      var $47518=$1116;
      HEAP32[(($1114)>>2)]=$22630;
      HEAP32[(($1115)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1116)>>2)]=271;
      var $47519=HEAP32[(($1114)>>2)];
      var $47520=(($47519)|0)!=0;
      if ($47520) { __label__ = 12752; break; } else { __label__ = 12754; break; }
    case 12752: // $47521
      var $47522=HEAP32[(($1114)>>2)];
      var $47523=HEAP32[(($1115)>>2)];
      var $47524=HEAP32[(($1116)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47522, $47523, $47524) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12753; break; } else { __label__ = 14612; break; }
    case 12753: // $_noexc1597
      __label__ = 12754; break;
    case 12754: // $_ZdlPvPKci_exit1598
      var $47525=$1114;
      var $47526=$1115;
      var $47527=$1116;
      __label__ = 12755; break;
    case 12755: // $47528
      __label__ = 14611; break;
    case 12756: // $47529
      var $47530=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47531=$47530.f0;
      $4692=$47531;
      var $47532=$47530.f1;
      $4693=$47532;
      var $47533=$1111;
      var $47534=$1112;
      var $47535=$1113;
      HEAP32[(($1111)>>2)]=$22681;
      HEAP32[(($1112)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1113)>>2)]=272;
      var $47536=HEAP32[(($1111)>>2)];
      var $47537=(($47536)|0)!=0;
      if ($47537) { __label__ = 12757; break; } else { __label__ = 12759; break; }
    case 12757: // $47538
      var $47539=HEAP32[(($1111)>>2)];
      var $47540=HEAP32[(($1112)>>2)];
      var $47541=HEAP32[(($1113)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47539, $47540, $47541) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12758; break; } else { __label__ = 14612; break; }
    case 12758: // $_noexc1599
      __label__ = 12759; break;
    case 12759: // $_ZdlPvPKci_exit1600
      var $47542=$1111;
      var $47543=$1112;
      var $47544=$1113;
      __label__ = 12760; break;
    case 12760: // $47545
      __label__ = 14611; break;
    case 12761: // $47546
      var $47547=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47548=$47547.f0;
      $4692=$47548;
      var $47549=$47547.f1;
      $4693=$47549;
      var $47550=$1108;
      var $47551=$1109;
      var $47552=$1110;
      HEAP32[(($1108)>>2)]=$22732;
      HEAP32[(($1109)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1110)>>2)]=273;
      var $47553=HEAP32[(($1108)>>2)];
      var $47554=(($47553)|0)!=0;
      if ($47554) { __label__ = 12762; break; } else { __label__ = 12764; break; }
    case 12762: // $47555
      var $47556=HEAP32[(($1108)>>2)];
      var $47557=HEAP32[(($1109)>>2)];
      var $47558=HEAP32[(($1110)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47556, $47557, $47558) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12763; break; } else { __label__ = 14612; break; }
    case 12763: // $_noexc1601
      __label__ = 12764; break;
    case 12764: // $_ZdlPvPKci_exit1602
      var $47559=$1108;
      var $47560=$1109;
      var $47561=$1110;
      __label__ = 12765; break;
    case 12765: // $47562
      __label__ = 14611; break;
    case 12766: // $47563
      var $47564=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47565=$47564.f0;
      $4692=$47565;
      var $47566=$47564.f1;
      $4693=$47566;
      var $47567=$1105;
      var $47568=$1106;
      var $47569=$1107;
      HEAP32[(($1105)>>2)]=$22783;
      HEAP32[(($1106)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1107)>>2)]=274;
      var $47570=HEAP32[(($1105)>>2)];
      var $47571=(($47570)|0)!=0;
      if ($47571) { __label__ = 12767; break; } else { __label__ = 12769; break; }
    case 12767: // $47572
      var $47573=HEAP32[(($1105)>>2)];
      var $47574=HEAP32[(($1106)>>2)];
      var $47575=HEAP32[(($1107)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47573, $47574, $47575) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12768; break; } else { __label__ = 14612; break; }
    case 12768: // $_noexc1603
      __label__ = 12769; break;
    case 12769: // $_ZdlPvPKci_exit1604
      var $47576=$1105;
      var $47577=$1106;
      var $47578=$1107;
      __label__ = 12770; break;
    case 12770: // $47579
      __label__ = 14611; break;
    case 12771: // $47580
      var $47581=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47582=$47581.f0;
      $4692=$47582;
      var $47583=$47581.f1;
      $4693=$47583;
      var $47584=$1102;
      var $47585=$1103;
      var $47586=$1104;
      HEAP32[(($1102)>>2)]=$22834;
      HEAP32[(($1103)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1104)>>2)]=275;
      var $47587=HEAP32[(($1102)>>2)];
      var $47588=(($47587)|0)!=0;
      if ($47588) { __label__ = 12772; break; } else { __label__ = 12774; break; }
    case 12772: // $47589
      var $47590=HEAP32[(($1102)>>2)];
      var $47591=HEAP32[(($1103)>>2)];
      var $47592=HEAP32[(($1104)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47590, $47591, $47592) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12773; break; } else { __label__ = 14612; break; }
    case 12773: // $_noexc1605
      __label__ = 12774; break;
    case 12774: // $_ZdlPvPKci_exit1606
      var $47593=$1102;
      var $47594=$1103;
      var $47595=$1104;
      __label__ = 12775; break;
    case 12775: // $47596
      __label__ = 14611; break;
    case 12776: // $47597
      var $47598=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47599=$47598.f0;
      $4692=$47599;
      var $47600=$47598.f1;
      $4693=$47600;
      var $47601=$1099;
      var $47602=$1100;
      var $47603=$1101;
      HEAP32[(($1099)>>2)]=$22885;
      HEAP32[(($1100)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1101)>>2)]=276;
      var $47604=HEAP32[(($1099)>>2)];
      var $47605=(($47604)|0)!=0;
      if ($47605) { __label__ = 12777; break; } else { __label__ = 12779; break; }
    case 12777: // $47606
      var $47607=HEAP32[(($1099)>>2)];
      var $47608=HEAP32[(($1100)>>2)];
      var $47609=HEAP32[(($1101)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47607, $47608, $47609) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12778; break; } else { __label__ = 14612; break; }
    case 12778: // $_noexc1607
      __label__ = 12779; break;
    case 12779: // $_ZdlPvPKci_exit1608
      var $47610=$1099;
      var $47611=$1100;
      var $47612=$1101;
      __label__ = 12780; break;
    case 12780: // $47613
      __label__ = 14611; break;
    case 12781: // $47614
      var $47615=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47616=$47615.f0;
      $4692=$47616;
      var $47617=$47615.f1;
      $4693=$47617;
      var $47618=$1096;
      var $47619=$1097;
      var $47620=$1098;
      HEAP32[(($1096)>>2)]=$22936;
      HEAP32[(($1097)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1098)>>2)]=277;
      var $47621=HEAP32[(($1096)>>2)];
      var $47622=(($47621)|0)!=0;
      if ($47622) { __label__ = 12782; break; } else { __label__ = 12784; break; }
    case 12782: // $47623
      var $47624=HEAP32[(($1096)>>2)];
      var $47625=HEAP32[(($1097)>>2)];
      var $47626=HEAP32[(($1098)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47624, $47625, $47626) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12783; break; } else { __label__ = 14612; break; }
    case 12783: // $_noexc1609
      __label__ = 12784; break;
    case 12784: // $_ZdlPvPKci_exit1610
      var $47627=$1096;
      var $47628=$1097;
      var $47629=$1098;
      __label__ = 12785; break;
    case 12785: // $47630
      __label__ = 14611; break;
    case 12786: // $47631
      var $47632=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47633=$47632.f0;
      $4692=$47633;
      var $47634=$47632.f1;
      $4693=$47634;
      var $47635=$1093;
      var $47636=$1094;
      var $47637=$1095;
      HEAP32[(($1093)>>2)]=$22987;
      HEAP32[(($1094)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1095)>>2)]=278;
      var $47638=HEAP32[(($1093)>>2)];
      var $47639=(($47638)|0)!=0;
      if ($47639) { __label__ = 12787; break; } else { __label__ = 12789; break; }
    case 12787: // $47640
      var $47641=HEAP32[(($1093)>>2)];
      var $47642=HEAP32[(($1094)>>2)];
      var $47643=HEAP32[(($1095)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47641, $47642, $47643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12788; break; } else { __label__ = 14612; break; }
    case 12788: // $_noexc1611
      __label__ = 12789; break;
    case 12789: // $_ZdlPvPKci_exit1612
      var $47644=$1093;
      var $47645=$1094;
      var $47646=$1095;
      __label__ = 12790; break;
    case 12790: // $47647
      __label__ = 14611; break;
    case 12791: // $47648
      var $47649=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47650=$47649.f0;
      $4692=$47650;
      var $47651=$47649.f1;
      $4693=$47651;
      var $47652=$1090;
      var $47653=$1091;
      var $47654=$1092;
      HEAP32[(($1090)>>2)]=$23038;
      HEAP32[(($1091)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1092)>>2)]=279;
      var $47655=HEAP32[(($1090)>>2)];
      var $47656=(($47655)|0)!=0;
      if ($47656) { __label__ = 12792; break; } else { __label__ = 12794; break; }
    case 12792: // $47657
      var $47658=HEAP32[(($1090)>>2)];
      var $47659=HEAP32[(($1091)>>2)];
      var $47660=HEAP32[(($1092)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47658, $47659, $47660) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12793; break; } else { __label__ = 14612; break; }
    case 12793: // $_noexc1613
      __label__ = 12794; break;
    case 12794: // $_ZdlPvPKci_exit1614
      var $47661=$1090;
      var $47662=$1091;
      var $47663=$1092;
      __label__ = 12795; break;
    case 12795: // $47664
      __label__ = 14611; break;
    case 12796: // $47665
      var $47666=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47667=$47666.f0;
      $4692=$47667;
      var $47668=$47666.f1;
      $4693=$47668;
      var $47669=$1087;
      var $47670=$1088;
      var $47671=$1089;
      HEAP32[(($1087)>>2)]=$23089;
      HEAP32[(($1088)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1089)>>2)]=280;
      var $47672=HEAP32[(($1087)>>2)];
      var $47673=(($47672)|0)!=0;
      if ($47673) { __label__ = 12797; break; } else { __label__ = 12799; break; }
    case 12797: // $47674
      var $47675=HEAP32[(($1087)>>2)];
      var $47676=HEAP32[(($1088)>>2)];
      var $47677=HEAP32[(($1089)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47675, $47676, $47677) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12798; break; } else { __label__ = 14612; break; }
    case 12798: // $_noexc1615
      __label__ = 12799; break;
    case 12799: // $_ZdlPvPKci_exit1616
      var $47678=$1087;
      var $47679=$1088;
      var $47680=$1089;
      __label__ = 12800; break;
    case 12800: // $47681
      __label__ = 14611; break;
    case 12801: // $47682
      var $47683=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47684=$47683.f0;
      $4692=$47684;
      var $47685=$47683.f1;
      $4693=$47685;
      var $47686=$1084;
      var $47687=$1085;
      var $47688=$1086;
      HEAP32[(($1084)>>2)]=$23140;
      HEAP32[(($1085)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1086)>>2)]=282;
      var $47689=HEAP32[(($1084)>>2)];
      var $47690=(($47689)|0)!=0;
      if ($47690) { __label__ = 12802; break; } else { __label__ = 12804; break; }
    case 12802: // $47691
      var $47692=HEAP32[(($1084)>>2)];
      var $47693=HEAP32[(($1085)>>2)];
      var $47694=HEAP32[(($1086)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47692, $47693, $47694) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12803; break; } else { __label__ = 14612; break; }
    case 12803: // $_noexc1617
      __label__ = 12804; break;
    case 12804: // $_ZdlPvPKci_exit1618
      var $47695=$1084;
      var $47696=$1085;
      var $47697=$1086;
      __label__ = 12805; break;
    case 12805: // $47698
      __label__ = 14611; break;
    case 12806: // $47699
      var $47700=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47701=$47700.f0;
      $4692=$47701;
      var $47702=$47700.f1;
      $4693=$47702;
      var $47703=$1081;
      var $47704=$1082;
      var $47705=$1083;
      HEAP32[(($1081)>>2)]=$23191;
      HEAP32[(($1082)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1083)>>2)]=283;
      var $47706=HEAP32[(($1081)>>2)];
      var $47707=(($47706)|0)!=0;
      if ($47707) { __label__ = 12807; break; } else { __label__ = 12809; break; }
    case 12807: // $47708
      var $47709=HEAP32[(($1081)>>2)];
      var $47710=HEAP32[(($1082)>>2)];
      var $47711=HEAP32[(($1083)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47709, $47710, $47711) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12808; break; } else { __label__ = 14612; break; }
    case 12808: // $_noexc1619
      __label__ = 12809; break;
    case 12809: // $_ZdlPvPKci_exit1620
      var $47712=$1081;
      var $47713=$1082;
      var $47714=$1083;
      __label__ = 12810; break;
    case 12810: // $47715
      __label__ = 14611; break;
    case 12811: // $47716
      var $47717=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47718=$47717.f0;
      $4692=$47718;
      var $47719=$47717.f1;
      $4693=$47719;
      var $47720=$1078;
      var $47721=$1079;
      var $47722=$1080;
      HEAP32[(($1078)>>2)]=$23242;
      HEAP32[(($1079)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1080)>>2)]=284;
      var $47723=HEAP32[(($1078)>>2)];
      var $47724=(($47723)|0)!=0;
      if ($47724) { __label__ = 12812; break; } else { __label__ = 12814; break; }
    case 12812: // $47725
      var $47726=HEAP32[(($1078)>>2)];
      var $47727=HEAP32[(($1079)>>2)];
      var $47728=HEAP32[(($1080)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47726, $47727, $47728) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12813; break; } else { __label__ = 14612; break; }
    case 12813: // $_noexc1621
      __label__ = 12814; break;
    case 12814: // $_ZdlPvPKci_exit1622
      var $47729=$1078;
      var $47730=$1079;
      var $47731=$1080;
      __label__ = 12815; break;
    case 12815: // $47732
      __label__ = 14611; break;
    case 12816: // $47733
      var $47734=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47735=$47734.f0;
      $4692=$47735;
      var $47736=$47734.f1;
      $4693=$47736;
      var $47737=$1075;
      var $47738=$1076;
      var $47739=$1077;
      HEAP32[(($1075)>>2)]=$23293;
      HEAP32[(($1076)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1077)>>2)]=285;
      var $47740=HEAP32[(($1075)>>2)];
      var $47741=(($47740)|0)!=0;
      if ($47741) { __label__ = 12817; break; } else { __label__ = 12819; break; }
    case 12817: // $47742
      var $47743=HEAP32[(($1075)>>2)];
      var $47744=HEAP32[(($1076)>>2)];
      var $47745=HEAP32[(($1077)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47743, $47744, $47745) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12818; break; } else { __label__ = 14612; break; }
    case 12818: // $_noexc1623
      __label__ = 12819; break;
    case 12819: // $_ZdlPvPKci_exit1624
      var $47746=$1075;
      var $47747=$1076;
      var $47748=$1077;
      __label__ = 12820; break;
    case 12820: // $47749
      __label__ = 14611; break;
    case 12821: // $47750
      var $47751=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47752=$47751.f0;
      $4692=$47752;
      var $47753=$47751.f1;
      $4693=$47753;
      var $47754=$1072;
      var $47755=$1073;
      var $47756=$1074;
      HEAP32[(($1072)>>2)]=$23344;
      HEAP32[(($1073)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1074)>>2)]=286;
      var $47757=HEAP32[(($1072)>>2)];
      var $47758=(($47757)|0)!=0;
      if ($47758) { __label__ = 12822; break; } else { __label__ = 12824; break; }
    case 12822: // $47759
      var $47760=HEAP32[(($1072)>>2)];
      var $47761=HEAP32[(($1073)>>2)];
      var $47762=HEAP32[(($1074)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47760, $47761, $47762) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12823; break; } else { __label__ = 14612; break; }
    case 12823: // $_noexc1625
      __label__ = 12824; break;
    case 12824: // $_ZdlPvPKci_exit1626
      var $47763=$1072;
      var $47764=$1073;
      var $47765=$1074;
      __label__ = 12825; break;
    case 12825: // $47766
      __label__ = 14611; break;
    case 12826: // $47767
      var $47768=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47769=$47768.f0;
      $4692=$47769;
      var $47770=$47768.f1;
      $4693=$47770;
      var $47771=$1069;
      var $47772=$1070;
      var $47773=$1071;
      HEAP32[(($1069)>>2)]=$23395;
      HEAP32[(($1070)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1071)>>2)]=287;
      var $47774=HEAP32[(($1069)>>2)];
      var $47775=(($47774)|0)!=0;
      if ($47775) { __label__ = 12827; break; } else { __label__ = 12829; break; }
    case 12827: // $47776
      var $47777=HEAP32[(($1069)>>2)];
      var $47778=HEAP32[(($1070)>>2)];
      var $47779=HEAP32[(($1071)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47777, $47778, $47779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12828; break; } else { __label__ = 14612; break; }
    case 12828: // $_noexc1627
      __label__ = 12829; break;
    case 12829: // $_ZdlPvPKci_exit1628
      var $47780=$1069;
      var $47781=$1070;
      var $47782=$1071;
      __label__ = 12830; break;
    case 12830: // $47783
      __label__ = 14611; break;
    case 12831: // $47784
      var $47785=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47786=$47785.f0;
      $4692=$47786;
      var $47787=$47785.f1;
      $4693=$47787;
      var $47788=$1066;
      var $47789=$1067;
      var $47790=$1068;
      HEAP32[(($1066)>>2)]=$23446;
      HEAP32[(($1067)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1068)>>2)]=288;
      var $47791=HEAP32[(($1066)>>2)];
      var $47792=(($47791)|0)!=0;
      if ($47792) { __label__ = 12832; break; } else { __label__ = 12834; break; }
    case 12832: // $47793
      var $47794=HEAP32[(($1066)>>2)];
      var $47795=HEAP32[(($1067)>>2)];
      var $47796=HEAP32[(($1068)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47794, $47795, $47796) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12833; break; } else { __label__ = 14612; break; }
    case 12833: // $_noexc1629
      __label__ = 12834; break;
    case 12834: // $_ZdlPvPKci_exit1630
      var $47797=$1066;
      var $47798=$1067;
      var $47799=$1068;
      __label__ = 12835; break;
    case 12835: // $47800
      __label__ = 14611; break;
    case 12836: // $47801
      var $47802=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47803=$47802.f0;
      $4692=$47803;
      var $47804=$47802.f1;
      $4693=$47804;
      var $47805=$1063;
      var $47806=$1064;
      var $47807=$1065;
      HEAP32[(($1063)>>2)]=$23497;
      HEAP32[(($1064)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1065)>>2)]=289;
      var $47808=HEAP32[(($1063)>>2)];
      var $47809=(($47808)|0)!=0;
      if ($47809) { __label__ = 12837; break; } else { __label__ = 12839; break; }
    case 12837: // $47810
      var $47811=HEAP32[(($1063)>>2)];
      var $47812=HEAP32[(($1064)>>2)];
      var $47813=HEAP32[(($1065)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47811, $47812, $47813) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12838; break; } else { __label__ = 14612; break; }
    case 12838: // $_noexc1631
      __label__ = 12839; break;
    case 12839: // $_ZdlPvPKci_exit1632
      var $47814=$1063;
      var $47815=$1064;
      var $47816=$1065;
      __label__ = 12840; break;
    case 12840: // $47817
      __label__ = 14611; break;
    case 12841: // $47818
      var $47819=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47820=$47819.f0;
      $4692=$47820;
      var $47821=$47819.f1;
      $4693=$47821;
      var $47822=$1060;
      var $47823=$1061;
      var $47824=$1062;
      HEAP32[(($1060)>>2)]=$23548;
      HEAP32[(($1061)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1062)>>2)]=290;
      var $47825=HEAP32[(($1060)>>2)];
      var $47826=(($47825)|0)!=0;
      if ($47826) { __label__ = 12842; break; } else { __label__ = 12844; break; }
    case 12842: // $47827
      var $47828=HEAP32[(($1060)>>2)];
      var $47829=HEAP32[(($1061)>>2)];
      var $47830=HEAP32[(($1062)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47828, $47829, $47830) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12843; break; } else { __label__ = 14612; break; }
    case 12843: // $_noexc1633
      __label__ = 12844; break;
    case 12844: // $_ZdlPvPKci_exit1634
      var $47831=$1060;
      var $47832=$1061;
      var $47833=$1062;
      __label__ = 12845; break;
    case 12845: // $47834
      __label__ = 14611; break;
    case 12846: // $47835
      var $47836=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47837=$47836.f0;
      $4692=$47837;
      var $47838=$47836.f1;
      $4693=$47838;
      var $47839=$1057;
      var $47840=$1058;
      var $47841=$1059;
      HEAP32[(($1057)>>2)]=$23599;
      HEAP32[(($1058)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1059)>>2)]=291;
      var $47842=HEAP32[(($1057)>>2)];
      var $47843=(($47842)|0)!=0;
      if ($47843) { __label__ = 12847; break; } else { __label__ = 12849; break; }
    case 12847: // $47844
      var $47845=HEAP32[(($1057)>>2)];
      var $47846=HEAP32[(($1058)>>2)];
      var $47847=HEAP32[(($1059)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47845, $47846, $47847) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12848; break; } else { __label__ = 14612; break; }
    case 12848: // $_noexc1635
      __label__ = 12849; break;
    case 12849: // $_ZdlPvPKci_exit1636
      var $47848=$1057;
      var $47849=$1058;
      var $47850=$1059;
      __label__ = 12850; break;
    case 12850: // $47851
      __label__ = 14611; break;
    case 12851: // $47852
      var $47853=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47854=$47853.f0;
      $4692=$47854;
      var $47855=$47853.f1;
      $4693=$47855;
      var $47856=$1054;
      var $47857=$1055;
      var $47858=$1056;
      HEAP32[(($1054)>>2)]=$23650;
      HEAP32[(($1055)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1056)>>2)]=292;
      var $47859=HEAP32[(($1054)>>2)];
      var $47860=(($47859)|0)!=0;
      if ($47860) { __label__ = 12852; break; } else { __label__ = 12854; break; }
    case 12852: // $47861
      var $47862=HEAP32[(($1054)>>2)];
      var $47863=HEAP32[(($1055)>>2)];
      var $47864=HEAP32[(($1056)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47862, $47863, $47864) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12853; break; } else { __label__ = 14612; break; }
    case 12853: // $_noexc1637
      __label__ = 12854; break;
    case 12854: // $_ZdlPvPKci_exit1638
      var $47865=$1054;
      var $47866=$1055;
      var $47867=$1056;
      __label__ = 12855; break;
    case 12855: // $47868
      __label__ = 14611; break;
    case 12856: // $47869
      var $47870=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47871=$47870.f0;
      $4692=$47871;
      var $47872=$47870.f1;
      $4693=$47872;
      var $47873=$1051;
      var $47874=$1052;
      var $47875=$1053;
      HEAP32[(($1051)>>2)]=$23701;
      HEAP32[(($1052)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1053)>>2)]=293;
      var $47876=HEAP32[(($1051)>>2)];
      var $47877=(($47876)|0)!=0;
      if ($47877) { __label__ = 12857; break; } else { __label__ = 12859; break; }
    case 12857: // $47878
      var $47879=HEAP32[(($1051)>>2)];
      var $47880=HEAP32[(($1052)>>2)];
      var $47881=HEAP32[(($1053)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47879, $47880, $47881) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12858; break; } else { __label__ = 14612; break; }
    case 12858: // $_noexc1639
      __label__ = 12859; break;
    case 12859: // $_ZdlPvPKci_exit1640
      var $47882=$1051;
      var $47883=$1052;
      var $47884=$1053;
      __label__ = 12860; break;
    case 12860: // $47885
      __label__ = 14611; break;
    case 12861: // $47886
      var $47887=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47888=$47887.f0;
      $4692=$47888;
      var $47889=$47887.f1;
      $4693=$47889;
      var $47890=$1048;
      var $47891=$1049;
      var $47892=$1050;
      HEAP32[(($1048)>>2)]=$23752;
      HEAP32[(($1049)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1050)>>2)]=294;
      var $47893=HEAP32[(($1048)>>2)];
      var $47894=(($47893)|0)!=0;
      if ($47894) { __label__ = 12862; break; } else { __label__ = 12864; break; }
    case 12862: // $47895
      var $47896=HEAP32[(($1048)>>2)];
      var $47897=HEAP32[(($1049)>>2)];
      var $47898=HEAP32[(($1050)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47896, $47897, $47898) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12863; break; } else { __label__ = 14612; break; }
    case 12863: // $_noexc1641
      __label__ = 12864; break;
    case 12864: // $_ZdlPvPKci_exit1642
      var $47899=$1048;
      var $47900=$1049;
      var $47901=$1050;
      __label__ = 12865; break;
    case 12865: // $47902
      __label__ = 14611; break;
    case 12866: // $47903
      var $47904=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47905=$47904.f0;
      $4692=$47905;
      var $47906=$47904.f1;
      $4693=$47906;
      var $47907=$1045;
      var $47908=$1046;
      var $47909=$1047;
      HEAP32[(($1045)>>2)]=$23803;
      HEAP32[(($1046)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1047)>>2)]=295;
      var $47910=HEAP32[(($1045)>>2)];
      var $47911=(($47910)|0)!=0;
      if ($47911) { __label__ = 12867; break; } else { __label__ = 12869; break; }
    case 12867: // $47912
      var $47913=HEAP32[(($1045)>>2)];
      var $47914=HEAP32[(($1046)>>2)];
      var $47915=HEAP32[(($1047)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47913, $47914, $47915) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12868; break; } else { __label__ = 14612; break; }
    case 12868: // $_noexc1643
      __label__ = 12869; break;
    case 12869: // $_ZdlPvPKci_exit1644
      var $47916=$1045;
      var $47917=$1046;
      var $47918=$1047;
      __label__ = 12870; break;
    case 12870: // $47919
      __label__ = 14611; break;
    case 12871: // $47920
      var $47921=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47922=$47921.f0;
      $4692=$47922;
      var $47923=$47921.f1;
      $4693=$47923;
      var $47924=$1042;
      var $47925=$1043;
      var $47926=$1044;
      HEAP32[(($1042)>>2)]=$23854;
      HEAP32[(($1043)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1044)>>2)]=296;
      var $47927=HEAP32[(($1042)>>2)];
      var $47928=(($47927)|0)!=0;
      if ($47928) { __label__ = 12872; break; } else { __label__ = 12874; break; }
    case 12872: // $47929
      var $47930=HEAP32[(($1042)>>2)];
      var $47931=HEAP32[(($1043)>>2)];
      var $47932=HEAP32[(($1044)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47930, $47931, $47932) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12873; break; } else { __label__ = 14612; break; }
    case 12873: // $_noexc1645
      __label__ = 12874; break;
    case 12874: // $_ZdlPvPKci_exit1646
      var $47933=$1042;
      var $47934=$1043;
      var $47935=$1044;
      __label__ = 12875; break;
    case 12875: // $47936
      __label__ = 14611; break;
    case 12876: // $47937
      var $47938=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47939=$47938.f0;
      $4692=$47939;
      var $47940=$47938.f1;
      $4693=$47940;
      var $47941=$1039;
      var $47942=$1040;
      var $47943=$1041;
      HEAP32[(($1039)>>2)]=$23905;
      HEAP32[(($1040)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1041)>>2)]=297;
      var $47944=HEAP32[(($1039)>>2)];
      var $47945=(($47944)|0)!=0;
      if ($47945) { __label__ = 12877; break; } else { __label__ = 12879; break; }
    case 12877: // $47946
      var $47947=HEAP32[(($1039)>>2)];
      var $47948=HEAP32[(($1040)>>2)];
      var $47949=HEAP32[(($1041)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47947, $47948, $47949) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12878; break; } else { __label__ = 14612; break; }
    case 12878: // $_noexc1647
      __label__ = 12879; break;
    case 12879: // $_ZdlPvPKci_exit1648
      var $47950=$1039;
      var $47951=$1040;
      var $47952=$1041;
      __label__ = 12880; break;
    case 12880: // $47953
      __label__ = 14611; break;
    case 12881: // $47954
      var $47955=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47956=$47955.f0;
      $4692=$47956;
      var $47957=$47955.f1;
      $4693=$47957;
      var $47958=$1036;
      var $47959=$1037;
      var $47960=$1038;
      HEAP32[(($1036)>>2)]=$23956;
      HEAP32[(($1037)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1038)>>2)]=298;
      var $47961=HEAP32[(($1036)>>2)];
      var $47962=(($47961)|0)!=0;
      if ($47962) { __label__ = 12882; break; } else { __label__ = 12884; break; }
    case 12882: // $47963
      var $47964=HEAP32[(($1036)>>2)];
      var $47965=HEAP32[(($1037)>>2)];
      var $47966=HEAP32[(($1038)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47964, $47965, $47966) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12883; break; } else { __label__ = 14612; break; }
    case 12883: // $_noexc1649
      __label__ = 12884; break;
    case 12884: // $_ZdlPvPKci_exit1650
      var $47967=$1036;
      var $47968=$1037;
      var $47969=$1038;
      __label__ = 12885; break;
    case 12885: // $47970
      __label__ = 14611; break;
    case 12886: // $47971
      var $47972=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47973=$47972.f0;
      $4692=$47973;
      var $47974=$47972.f1;
      $4693=$47974;
      var $47975=$1033;
      var $47976=$1034;
      var $47977=$1035;
      HEAP32[(($1033)>>2)]=$24007;
      HEAP32[(($1034)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1035)>>2)]=299;
      var $47978=HEAP32[(($1033)>>2)];
      var $47979=(($47978)|0)!=0;
      if ($47979) { __label__ = 12887; break; } else { __label__ = 12889; break; }
    case 12887: // $47980
      var $47981=HEAP32[(($1033)>>2)];
      var $47982=HEAP32[(($1034)>>2)];
      var $47983=HEAP32[(($1035)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47981, $47982, $47983) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12888; break; } else { __label__ = 14612; break; }
    case 12888: // $_noexc1651
      __label__ = 12889; break;
    case 12889: // $_ZdlPvPKci_exit1652
      var $47984=$1033;
      var $47985=$1034;
      var $47986=$1035;
      __label__ = 12890; break;
    case 12890: // $47987
      __label__ = 14611; break;
    case 12891: // $47988
      var $47989=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47990=$47989.f0;
      $4692=$47990;
      var $47991=$47989.f1;
      $4693=$47991;
      var $47992=$1030;
      var $47993=$1031;
      var $47994=$1032;
      HEAP32[(($1030)>>2)]=$24058;
      HEAP32[(($1031)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1032)>>2)]=300;
      var $47995=HEAP32[(($1030)>>2)];
      var $47996=(($47995)|0)!=0;
      if ($47996) { __label__ = 12892; break; } else { __label__ = 12894; break; }
    case 12892: // $47997
      var $47998=HEAP32[(($1030)>>2)];
      var $47999=HEAP32[(($1031)>>2)];
      var $48000=HEAP32[(($1032)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47998, $47999, $48000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12893; break; } else { __label__ = 14612; break; }
    case 12893: // $_noexc1653
      __label__ = 12894; break;
    case 12894: // $_ZdlPvPKci_exit1654
      var $48001=$1030;
      var $48002=$1031;
      var $48003=$1032;
      __label__ = 12895; break;
    case 12895: // $48004
      __label__ = 14611; break;
    case 12896: // $48005
      var $48006=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48007=$48006.f0;
      $4692=$48007;
      var $48008=$48006.f1;
      $4693=$48008;
      var $48009=$1027;
      var $48010=$1028;
      var $48011=$1029;
      HEAP32[(($1027)>>2)]=$24109;
      HEAP32[(($1028)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1029)>>2)]=301;
      var $48012=HEAP32[(($1027)>>2)];
      var $48013=(($48012)|0)!=0;
      if ($48013) { __label__ = 12897; break; } else { __label__ = 12899; break; }
    case 12897: // $48014
      var $48015=HEAP32[(($1027)>>2)];
      var $48016=HEAP32[(($1028)>>2)];
      var $48017=HEAP32[(($1029)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48015, $48016, $48017) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12898; break; } else { __label__ = 14612; break; }
    case 12898: // $_noexc1655
      __label__ = 12899; break;
    case 12899: // $_ZdlPvPKci_exit1656
      var $48018=$1027;
      var $48019=$1028;
      var $48020=$1029;
      __label__ = 12900; break;
    case 12900: // $48021
      __label__ = 14611; break;
    case 12901: // $48022
      var $48023=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48024=$48023.f0;
      $4692=$48024;
      var $48025=$48023.f1;
      $4693=$48025;
      var $48026=$1024;
      var $48027=$1025;
      var $48028=$1026;
      HEAP32[(($1024)>>2)]=$24160;
      HEAP32[(($1025)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1026)>>2)]=302;
      var $48029=HEAP32[(($1024)>>2)];
      var $48030=(($48029)|0)!=0;
      if ($48030) { __label__ = 12902; break; } else { __label__ = 12904; break; }
    case 12902: // $48031
      var $48032=HEAP32[(($1024)>>2)];
      var $48033=HEAP32[(($1025)>>2)];
      var $48034=HEAP32[(($1026)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48032, $48033, $48034) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12903; break; } else { __label__ = 14612; break; }
    case 12903: // $_noexc1657
      __label__ = 12904; break;
    case 12904: // $_ZdlPvPKci_exit1658
      var $48035=$1024;
      var $48036=$1025;
      var $48037=$1026;
      __label__ = 12905; break;
    case 12905: // $48038
      __label__ = 14611; break;
    case 12906: // $48039
      var $48040=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48041=$48040.f0;
      $4692=$48041;
      var $48042=$48040.f1;
      $4693=$48042;
      var $48043=$1021;
      var $48044=$1022;
      var $48045=$1023;
      HEAP32[(($1021)>>2)]=$24211;
      HEAP32[(($1022)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1023)>>2)]=303;
      var $48046=HEAP32[(($1021)>>2)];
      var $48047=(($48046)|0)!=0;
      if ($48047) { __label__ = 12907; break; } else { __label__ = 12909; break; }
    case 12907: // $48048
      var $48049=HEAP32[(($1021)>>2)];
      var $48050=HEAP32[(($1022)>>2)];
      var $48051=HEAP32[(($1023)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48049, $48050, $48051) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12908; break; } else { __label__ = 14612; break; }
    case 12908: // $_noexc1659
      __label__ = 12909; break;
    case 12909: // $_ZdlPvPKci_exit1660
      var $48052=$1021;
      var $48053=$1022;
      var $48054=$1023;
      __label__ = 12910; break;
    case 12910: // $48055
      __label__ = 14611; break;
    case 12911: // $48056
      var $48057=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48058=$48057.f0;
      $4692=$48058;
      var $48059=$48057.f1;
      $4693=$48059;
      var $48060=$1018;
      var $48061=$1019;
      var $48062=$1020;
      HEAP32[(($1018)>>2)]=$24262;
      HEAP32[(($1019)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1020)>>2)]=304;
      var $48063=HEAP32[(($1018)>>2)];
      var $48064=(($48063)|0)!=0;
      if ($48064) { __label__ = 12912; break; } else { __label__ = 12914; break; }
    case 12912: // $48065
      var $48066=HEAP32[(($1018)>>2)];
      var $48067=HEAP32[(($1019)>>2)];
      var $48068=HEAP32[(($1020)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48066, $48067, $48068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12913; break; } else { __label__ = 14612; break; }
    case 12913: // $_noexc1661
      __label__ = 12914; break;
    case 12914: // $_ZdlPvPKci_exit1662
      var $48069=$1018;
      var $48070=$1019;
      var $48071=$1020;
      __label__ = 12915; break;
    case 12915: // $48072
      __label__ = 14611; break;
    case 12916: // $48073
      var $48074=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48075=$48074.f0;
      $4692=$48075;
      var $48076=$48074.f1;
      $4693=$48076;
      var $48077=$1015;
      var $48078=$1016;
      var $48079=$1017;
      HEAP32[(($1015)>>2)]=$24313;
      HEAP32[(($1016)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1017)>>2)]=305;
      var $48080=HEAP32[(($1015)>>2)];
      var $48081=(($48080)|0)!=0;
      if ($48081) { __label__ = 12917; break; } else { __label__ = 12919; break; }
    case 12917: // $48082
      var $48083=HEAP32[(($1015)>>2)];
      var $48084=HEAP32[(($1016)>>2)];
      var $48085=HEAP32[(($1017)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48083, $48084, $48085) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12918; break; } else { __label__ = 14612; break; }
    case 12918: // $_noexc1663
      __label__ = 12919; break;
    case 12919: // $_ZdlPvPKci_exit1664
      var $48086=$1015;
      var $48087=$1016;
      var $48088=$1017;
      __label__ = 12920; break;
    case 12920: // $48089
      __label__ = 14611; break;
    case 12921: // $48090
      var $48091=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48092=$48091.f0;
      $4692=$48092;
      var $48093=$48091.f1;
      $4693=$48093;
      var $48094=$1012;
      var $48095=$1013;
      var $48096=$1014;
      HEAP32[(($1012)>>2)]=$24364;
      HEAP32[(($1013)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1014)>>2)]=306;
      var $48097=HEAP32[(($1012)>>2)];
      var $48098=(($48097)|0)!=0;
      if ($48098) { __label__ = 12922; break; } else { __label__ = 12924; break; }
    case 12922: // $48099
      var $48100=HEAP32[(($1012)>>2)];
      var $48101=HEAP32[(($1013)>>2)];
      var $48102=HEAP32[(($1014)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48100, $48101, $48102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12923; break; } else { __label__ = 14612; break; }
    case 12923: // $_noexc1665
      __label__ = 12924; break;
    case 12924: // $_ZdlPvPKci_exit1666
      var $48103=$1012;
      var $48104=$1013;
      var $48105=$1014;
      __label__ = 12925; break;
    case 12925: // $48106
      __label__ = 14611; break;
    case 12926: // $48107
      var $48108=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48109=$48108.f0;
      $4692=$48109;
      var $48110=$48108.f1;
      $4693=$48110;
      var $48111=$1009;
      var $48112=$1010;
      var $48113=$1011;
      HEAP32[(($1009)>>2)]=$24415;
      HEAP32[(($1010)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1011)>>2)]=307;
      var $48114=HEAP32[(($1009)>>2)];
      var $48115=(($48114)|0)!=0;
      if ($48115) { __label__ = 12927; break; } else { __label__ = 12929; break; }
    case 12927: // $48116
      var $48117=HEAP32[(($1009)>>2)];
      var $48118=HEAP32[(($1010)>>2)];
      var $48119=HEAP32[(($1011)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48117, $48118, $48119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12928; break; } else { __label__ = 14612; break; }
    case 12928: // $_noexc1667
      __label__ = 12929; break;
    case 12929: // $_ZdlPvPKci_exit1668
      var $48120=$1009;
      var $48121=$1010;
      var $48122=$1011;
      __label__ = 12930; break;
    case 12930: // $48123
      __label__ = 14611; break;
    case 12931: // $48124
      var $48125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48126=$48125.f0;
      $4692=$48126;
      var $48127=$48125.f1;
      $4693=$48127;
      var $48128=$1006;
      var $48129=$1007;
      var $48130=$1008;
      HEAP32[(($1006)>>2)]=$24466;
      HEAP32[(($1007)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1008)>>2)]=308;
      var $48131=HEAP32[(($1006)>>2)];
      var $48132=(($48131)|0)!=0;
      if ($48132) { __label__ = 12932; break; } else { __label__ = 12934; break; }
    case 12932: // $48133
      var $48134=HEAP32[(($1006)>>2)];
      var $48135=HEAP32[(($1007)>>2)];
      var $48136=HEAP32[(($1008)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48134, $48135, $48136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12933; break; } else { __label__ = 14612; break; }
    case 12933: // $_noexc1669
      __label__ = 12934; break;
    case 12934: // $_ZdlPvPKci_exit1670
      var $48137=$1006;
      var $48138=$1007;
      var $48139=$1008;
      __label__ = 12935; break;
    case 12935: // $48140
      __label__ = 14611; break;
    case 12936: // $48141
      var $48142=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48143=$48142.f0;
      $4692=$48143;
      var $48144=$48142.f1;
      $4693=$48144;
      var $48145=$1003;
      var $48146=$1004;
      var $48147=$1005;
      HEAP32[(($1003)>>2)]=$24517;
      HEAP32[(($1004)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1005)>>2)]=309;
      var $48148=HEAP32[(($1003)>>2)];
      var $48149=(($48148)|0)!=0;
      if ($48149) { __label__ = 12937; break; } else { __label__ = 12939; break; }
    case 12937: // $48150
      var $48151=HEAP32[(($1003)>>2)];
      var $48152=HEAP32[(($1004)>>2)];
      var $48153=HEAP32[(($1005)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48151, $48152, $48153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12938; break; } else { __label__ = 14612; break; }
    case 12938: // $_noexc1671
      __label__ = 12939; break;
    case 12939: // $_ZdlPvPKci_exit1672
      var $48154=$1003;
      var $48155=$1004;
      var $48156=$1005;
      __label__ = 12940; break;
    case 12940: // $48157
      __label__ = 14611; break;
    case 12941: // $48158
      var $48159=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48160=$48159.f0;
      $4692=$48160;
      var $48161=$48159.f1;
      $4693=$48161;
      var $48162=$1000;
      var $48163=$1001;
      var $48164=$1002;
      HEAP32[(($1000)>>2)]=$24568;
      HEAP32[(($1001)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($1002)>>2)]=310;
      var $48165=HEAP32[(($1000)>>2)];
      var $48166=(($48165)|0)!=0;
      if ($48166) { __label__ = 12942; break; } else { __label__ = 12944; break; }
    case 12942: // $48167
      var $48168=HEAP32[(($1000)>>2)];
      var $48169=HEAP32[(($1001)>>2)];
      var $48170=HEAP32[(($1002)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48168, $48169, $48170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12943; break; } else { __label__ = 14612; break; }
    case 12943: // $_noexc1673
      __label__ = 12944; break;
    case 12944: // $_ZdlPvPKci_exit1674
      var $48171=$1000;
      var $48172=$1001;
      var $48173=$1002;
      __label__ = 12945; break;
    case 12945: // $48174
      __label__ = 14611; break;
    case 12946: // $48175
      var $48176=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48177=$48176.f0;
      $4692=$48177;
      var $48178=$48176.f1;
      $4693=$48178;
      var $48179=$997;
      var $48180=$998;
      var $48181=$999;
      HEAP32[(($997)>>2)]=$24619;
      HEAP32[(($998)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($999)>>2)]=311;
      var $48182=HEAP32[(($997)>>2)];
      var $48183=(($48182)|0)!=0;
      if ($48183) { __label__ = 12947; break; } else { __label__ = 12949; break; }
    case 12947: // $48184
      var $48185=HEAP32[(($997)>>2)];
      var $48186=HEAP32[(($998)>>2)];
      var $48187=HEAP32[(($999)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48185, $48186, $48187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12948; break; } else { __label__ = 14612; break; }
    case 12948: // $_noexc1675
      __label__ = 12949; break;
    case 12949: // $_ZdlPvPKci_exit1676
      var $48188=$997;
      var $48189=$998;
      var $48190=$999;
      __label__ = 12950; break;
    case 12950: // $48191
      __label__ = 14611; break;
    case 12951: // $48192
      var $48193=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48194=$48193.f0;
      $4692=$48194;
      var $48195=$48193.f1;
      $4693=$48195;
      var $48196=$994;
      var $48197=$995;
      var $48198=$996;
      HEAP32[(($994)>>2)]=$24670;
      HEAP32[(($995)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($996)>>2)]=313;
      var $48199=HEAP32[(($994)>>2)];
      var $48200=(($48199)|0)!=0;
      if ($48200) { __label__ = 12952; break; } else { __label__ = 12954; break; }
    case 12952: // $48201
      var $48202=HEAP32[(($994)>>2)];
      var $48203=HEAP32[(($995)>>2)];
      var $48204=HEAP32[(($996)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48202, $48203, $48204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12953; break; } else { __label__ = 14612; break; }
    case 12953: // $_noexc1677
      __label__ = 12954; break;
    case 12954: // $_ZdlPvPKci_exit1678
      var $48205=$994;
      var $48206=$995;
      var $48207=$996;
      __label__ = 12955; break;
    case 12955: // $48208
      __label__ = 14611; break;
    case 12956: // $48209
      var $48210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48211=$48210.f0;
      $4692=$48211;
      var $48212=$48210.f1;
      $4693=$48212;
      var $48213=$991;
      var $48214=$992;
      var $48215=$993;
      HEAP32[(($991)>>2)]=$24721;
      HEAP32[(($992)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($993)>>2)]=314;
      var $48216=HEAP32[(($991)>>2)];
      var $48217=(($48216)|0)!=0;
      if ($48217) { __label__ = 12957; break; } else { __label__ = 12959; break; }
    case 12957: // $48218
      var $48219=HEAP32[(($991)>>2)];
      var $48220=HEAP32[(($992)>>2)];
      var $48221=HEAP32[(($993)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48219, $48220, $48221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12958; break; } else { __label__ = 14612; break; }
    case 12958: // $_noexc1679
      __label__ = 12959; break;
    case 12959: // $_ZdlPvPKci_exit1680
      var $48222=$991;
      var $48223=$992;
      var $48224=$993;
      __label__ = 12960; break;
    case 12960: // $48225
      __label__ = 14611; break;
    case 12961: // $48226
      var $48227=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48228=$48227.f0;
      $4692=$48228;
      var $48229=$48227.f1;
      $4693=$48229;
      var $48230=$988;
      var $48231=$989;
      var $48232=$990;
      HEAP32[(($988)>>2)]=$24772;
      HEAP32[(($989)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($990)>>2)]=315;
      var $48233=HEAP32[(($988)>>2)];
      var $48234=(($48233)|0)!=0;
      if ($48234) { __label__ = 12962; break; } else { __label__ = 12964; break; }
    case 12962: // $48235
      var $48236=HEAP32[(($988)>>2)];
      var $48237=HEAP32[(($989)>>2)];
      var $48238=HEAP32[(($990)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48236, $48237, $48238) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12963; break; } else { __label__ = 14612; break; }
    case 12963: // $_noexc1681
      __label__ = 12964; break;
    case 12964: // $_ZdlPvPKci_exit1682
      var $48239=$988;
      var $48240=$989;
      var $48241=$990;
      __label__ = 12965; break;
    case 12965: // $48242
      __label__ = 14611; break;
    case 12966: // $48243
      var $48244=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48245=$48244.f0;
      $4692=$48245;
      var $48246=$48244.f1;
      $4693=$48246;
      var $48247=$985;
      var $48248=$986;
      var $48249=$987;
      HEAP32[(($985)>>2)]=$24823;
      HEAP32[(($986)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($987)>>2)]=316;
      var $48250=HEAP32[(($985)>>2)];
      var $48251=(($48250)|0)!=0;
      if ($48251) { __label__ = 12967; break; } else { __label__ = 12969; break; }
    case 12967: // $48252
      var $48253=HEAP32[(($985)>>2)];
      var $48254=HEAP32[(($986)>>2)];
      var $48255=HEAP32[(($987)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48253, $48254, $48255) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12968; break; } else { __label__ = 14612; break; }
    case 12968: // $_noexc1683
      __label__ = 12969; break;
    case 12969: // $_ZdlPvPKci_exit1684
      var $48256=$985;
      var $48257=$986;
      var $48258=$987;
      __label__ = 12970; break;
    case 12970: // $48259
      __label__ = 14611; break;
    case 12971: // $48260
      var $48261=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48262=$48261.f0;
      $4692=$48262;
      var $48263=$48261.f1;
      $4693=$48263;
      var $48264=$982;
      var $48265=$983;
      var $48266=$984;
      HEAP32[(($982)>>2)]=$24874;
      HEAP32[(($983)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($984)>>2)]=317;
      var $48267=HEAP32[(($982)>>2)];
      var $48268=(($48267)|0)!=0;
      if ($48268) { __label__ = 12972; break; } else { __label__ = 12974; break; }
    case 12972: // $48269
      var $48270=HEAP32[(($982)>>2)];
      var $48271=HEAP32[(($983)>>2)];
      var $48272=HEAP32[(($984)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48270, $48271, $48272) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12973; break; } else { __label__ = 14612; break; }
    case 12973: // $_noexc1685
      __label__ = 12974; break;
    case 12974: // $_ZdlPvPKci_exit1686
      var $48273=$982;
      var $48274=$983;
      var $48275=$984;
      __label__ = 12975; break;
    case 12975: // $48276
      __label__ = 14611; break;
    case 12976: // $48277
      var $48278=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48279=$48278.f0;
      $4692=$48279;
      var $48280=$48278.f1;
      $4693=$48280;
      var $48281=$979;
      var $48282=$980;
      var $48283=$981;
      HEAP32[(($979)>>2)]=$24925;
      HEAP32[(($980)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($981)>>2)]=318;
      var $48284=HEAP32[(($979)>>2)];
      var $48285=(($48284)|0)!=0;
      if ($48285) { __label__ = 12977; break; } else { __label__ = 12979; break; }
    case 12977: // $48286
      var $48287=HEAP32[(($979)>>2)];
      var $48288=HEAP32[(($980)>>2)];
      var $48289=HEAP32[(($981)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48287, $48288, $48289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12978; break; } else { __label__ = 14612; break; }
    case 12978: // $_noexc1687
      __label__ = 12979; break;
    case 12979: // $_ZdlPvPKci_exit1688
      var $48290=$979;
      var $48291=$980;
      var $48292=$981;
      __label__ = 12980; break;
    case 12980: // $48293
      __label__ = 14611; break;
    case 12981: // $48294
      var $48295=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48296=$48295.f0;
      $4692=$48296;
      var $48297=$48295.f1;
      $4693=$48297;
      var $48298=$976;
      var $48299=$977;
      var $48300=$978;
      HEAP32[(($976)>>2)]=$24976;
      HEAP32[(($977)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($978)>>2)]=319;
      var $48301=HEAP32[(($976)>>2)];
      var $48302=(($48301)|0)!=0;
      if ($48302) { __label__ = 12982; break; } else { __label__ = 12984; break; }
    case 12982: // $48303
      var $48304=HEAP32[(($976)>>2)];
      var $48305=HEAP32[(($977)>>2)];
      var $48306=HEAP32[(($978)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48304, $48305, $48306) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12983; break; } else { __label__ = 14612; break; }
    case 12983: // $_noexc1689
      __label__ = 12984; break;
    case 12984: // $_ZdlPvPKci_exit1690
      var $48307=$976;
      var $48308=$977;
      var $48309=$978;
      __label__ = 12985; break;
    case 12985: // $48310
      __label__ = 14611; break;
    case 12986: // $48311
      var $48312=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48313=$48312.f0;
      $4692=$48313;
      var $48314=$48312.f1;
      $4693=$48314;
      var $48315=$973;
      var $48316=$974;
      var $48317=$975;
      HEAP32[(($973)>>2)]=$25027;
      HEAP32[(($974)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($975)>>2)]=320;
      var $48318=HEAP32[(($973)>>2)];
      var $48319=(($48318)|0)!=0;
      if ($48319) { __label__ = 12987; break; } else { __label__ = 12989; break; }
    case 12987: // $48320
      var $48321=HEAP32[(($973)>>2)];
      var $48322=HEAP32[(($974)>>2)];
      var $48323=HEAP32[(($975)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48321, $48322, $48323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12988; break; } else { __label__ = 14612; break; }
    case 12988: // $_noexc1691
      __label__ = 12989; break;
    case 12989: // $_ZdlPvPKci_exit1692
      var $48324=$973;
      var $48325=$974;
      var $48326=$975;
      __label__ = 12990; break;
    case 12990: // $48327
      __label__ = 14611; break;
    case 12991: // $48328
      var $48329=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48330=$48329.f0;
      $4692=$48330;
      var $48331=$48329.f1;
      $4693=$48331;
      var $48332=$970;
      var $48333=$971;
      var $48334=$972;
      HEAP32[(($970)>>2)]=$25078;
      HEAP32[(($971)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($972)>>2)]=321;
      var $48335=HEAP32[(($970)>>2)];
      var $48336=(($48335)|0)!=0;
      if ($48336) { __label__ = 12992; break; } else { __label__ = 12994; break; }
    case 12992: // $48337
      var $48338=HEAP32[(($970)>>2)];
      var $48339=HEAP32[(($971)>>2)];
      var $48340=HEAP32[(($972)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48338, $48339, $48340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12993; break; } else { __label__ = 14612; break; }
    case 12993: // $_noexc1693
      __label__ = 12994; break;
    case 12994: // $_ZdlPvPKci_exit1694
      var $48341=$970;
      var $48342=$971;
      var $48343=$972;
      __label__ = 12995; break;
    case 12995: // $48344
      __label__ = 14611; break;
    case 12996: // $48345
      var $48346=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48347=$48346.f0;
      $4692=$48347;
      var $48348=$48346.f1;
      $4693=$48348;
      var $48349=$967;
      var $48350=$968;
      var $48351=$969;
      HEAP32[(($967)>>2)]=$25129;
      HEAP32[(($968)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($969)>>2)]=322;
      var $48352=HEAP32[(($967)>>2)];
      var $48353=(($48352)|0)!=0;
      if ($48353) { __label__ = 12997; break; } else { __label__ = 12999; break; }
    case 12997: // $48354
      var $48355=HEAP32[(($967)>>2)];
      var $48356=HEAP32[(($968)>>2)];
      var $48357=HEAP32[(($969)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48355, $48356, $48357) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12998; break; } else { __label__ = 14612; break; }
    case 12998: // $_noexc1695
      __label__ = 12999; break;
    case 12999: // $_ZdlPvPKci_exit1696
      var $48358=$967;
      var $48359=$968;
      var $48360=$969;
      __label__ = 13000; break;
    case 13000: // $48361
      __label__ = 14611; break;
    case 13001: // $48362
      var $48363=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48364=$48363.f0;
      $4692=$48364;
      var $48365=$48363.f1;
      $4693=$48365;
      var $48366=$964;
      var $48367=$965;
      var $48368=$966;
      HEAP32[(($964)>>2)]=$25180;
      HEAP32[(($965)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($966)>>2)]=323;
      var $48369=HEAP32[(($964)>>2)];
      var $48370=(($48369)|0)!=0;
      if ($48370) { __label__ = 13002; break; } else { __label__ = 13004; break; }
    case 13002: // $48371
      var $48372=HEAP32[(($964)>>2)];
      var $48373=HEAP32[(($965)>>2)];
      var $48374=HEAP32[(($966)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48372, $48373, $48374) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13003; break; } else { __label__ = 14612; break; }
    case 13003: // $_noexc1697
      __label__ = 13004; break;
    case 13004: // $_ZdlPvPKci_exit1698
      var $48375=$964;
      var $48376=$965;
      var $48377=$966;
      __label__ = 13005; break;
    case 13005: // $48378
      __label__ = 14611; break;
    case 13006: // $48379
      var $48380=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48381=$48380.f0;
      $4692=$48381;
      var $48382=$48380.f1;
      $4693=$48382;
      var $48383=$961;
      var $48384=$962;
      var $48385=$963;
      HEAP32[(($961)>>2)]=$25231;
      HEAP32[(($962)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($963)>>2)]=324;
      var $48386=HEAP32[(($961)>>2)];
      var $48387=(($48386)|0)!=0;
      if ($48387) { __label__ = 13007; break; } else { __label__ = 13009; break; }
    case 13007: // $48388
      var $48389=HEAP32[(($961)>>2)];
      var $48390=HEAP32[(($962)>>2)];
      var $48391=HEAP32[(($963)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48389, $48390, $48391) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13008; break; } else { __label__ = 14612; break; }
    case 13008: // $_noexc1699
      __label__ = 13009; break;
    case 13009: // $_ZdlPvPKci_exit1700
      var $48392=$961;
      var $48393=$962;
      var $48394=$963;
      __label__ = 13010; break;
    case 13010: // $48395
      __label__ = 14611; break;
    case 13011: // $48396
      var $48397=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48398=$48397.f0;
      $4692=$48398;
      var $48399=$48397.f1;
      $4693=$48399;
      var $48400=$958;
      var $48401=$959;
      var $48402=$960;
      HEAP32[(($958)>>2)]=$25282;
      HEAP32[(($959)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($960)>>2)]=325;
      var $48403=HEAP32[(($958)>>2)];
      var $48404=(($48403)|0)!=0;
      if ($48404) { __label__ = 13012; break; } else { __label__ = 13014; break; }
    case 13012: // $48405
      var $48406=HEAP32[(($958)>>2)];
      var $48407=HEAP32[(($959)>>2)];
      var $48408=HEAP32[(($960)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48406, $48407, $48408) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13013; break; } else { __label__ = 14612; break; }
    case 13013: // $_noexc1701
      __label__ = 13014; break;
    case 13014: // $_ZdlPvPKci_exit1702
      var $48409=$958;
      var $48410=$959;
      var $48411=$960;
      __label__ = 13015; break;
    case 13015: // $48412
      __label__ = 14611; break;
    case 13016: // $48413
      var $48414=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48415=$48414.f0;
      $4692=$48415;
      var $48416=$48414.f1;
      $4693=$48416;
      var $48417=$955;
      var $48418=$956;
      var $48419=$957;
      HEAP32[(($955)>>2)]=$25333;
      HEAP32[(($956)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($957)>>2)]=326;
      var $48420=HEAP32[(($955)>>2)];
      var $48421=(($48420)|0)!=0;
      if ($48421) { __label__ = 13017; break; } else { __label__ = 13019; break; }
    case 13017: // $48422
      var $48423=HEAP32[(($955)>>2)];
      var $48424=HEAP32[(($956)>>2)];
      var $48425=HEAP32[(($957)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48423, $48424, $48425) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13018; break; } else { __label__ = 14612; break; }
    case 13018: // $_noexc1703
      __label__ = 13019; break;
    case 13019: // $_ZdlPvPKci_exit1704
      var $48426=$955;
      var $48427=$956;
      var $48428=$957;
      __label__ = 13020; break;
    case 13020: // $48429
      __label__ = 14611; break;
    case 13021: // $48430
      var $48431=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48432=$48431.f0;
      $4692=$48432;
      var $48433=$48431.f1;
      $4693=$48433;
      var $48434=$952;
      var $48435=$953;
      var $48436=$954;
      HEAP32[(($952)>>2)]=$25384;
      HEAP32[(($953)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($954)>>2)]=327;
      var $48437=HEAP32[(($952)>>2)];
      var $48438=(($48437)|0)!=0;
      if ($48438) { __label__ = 13022; break; } else { __label__ = 13024; break; }
    case 13022: // $48439
      var $48440=HEAP32[(($952)>>2)];
      var $48441=HEAP32[(($953)>>2)];
      var $48442=HEAP32[(($954)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48440, $48441, $48442) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13023; break; } else { __label__ = 14612; break; }
    case 13023: // $_noexc1705
      __label__ = 13024; break;
    case 13024: // $_ZdlPvPKci_exit1706
      var $48443=$952;
      var $48444=$953;
      var $48445=$954;
      __label__ = 13025; break;
    case 13025: // $48446
      __label__ = 14611; break;
    case 13026: // $48447
      var $48448=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48449=$48448.f0;
      $4692=$48449;
      var $48450=$48448.f1;
      $4693=$48450;
      var $48451=$949;
      var $48452=$950;
      var $48453=$951;
      HEAP32[(($949)>>2)]=$25435;
      HEAP32[(($950)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($951)>>2)]=328;
      var $48454=HEAP32[(($949)>>2)];
      var $48455=(($48454)|0)!=0;
      if ($48455) { __label__ = 13027; break; } else { __label__ = 13029; break; }
    case 13027: // $48456
      var $48457=HEAP32[(($949)>>2)];
      var $48458=HEAP32[(($950)>>2)];
      var $48459=HEAP32[(($951)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48457, $48458, $48459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13028; break; } else { __label__ = 14612; break; }
    case 13028: // $_noexc1707
      __label__ = 13029; break;
    case 13029: // $_ZdlPvPKci_exit1708
      var $48460=$949;
      var $48461=$950;
      var $48462=$951;
      __label__ = 13030; break;
    case 13030: // $48463
      __label__ = 14611; break;
    case 13031: // $48464
      var $48465=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48466=$48465.f0;
      $4692=$48466;
      var $48467=$48465.f1;
      $4693=$48467;
      var $48468=$946;
      var $48469=$947;
      var $48470=$948;
      HEAP32[(($946)>>2)]=$25486;
      HEAP32[(($947)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($948)>>2)]=329;
      var $48471=HEAP32[(($946)>>2)];
      var $48472=(($48471)|0)!=0;
      if ($48472) { __label__ = 13032; break; } else { __label__ = 13034; break; }
    case 13032: // $48473
      var $48474=HEAP32[(($946)>>2)];
      var $48475=HEAP32[(($947)>>2)];
      var $48476=HEAP32[(($948)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48474, $48475, $48476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13033; break; } else { __label__ = 14612; break; }
    case 13033: // $_noexc1709
      __label__ = 13034; break;
    case 13034: // $_ZdlPvPKci_exit1710
      var $48477=$946;
      var $48478=$947;
      var $48479=$948;
      __label__ = 13035; break;
    case 13035: // $48480
      __label__ = 14611; break;
    case 13036: // $48481
      var $48482=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48483=$48482.f0;
      $4692=$48483;
      var $48484=$48482.f1;
      $4693=$48484;
      var $48485=$943;
      var $48486=$944;
      var $48487=$945;
      HEAP32[(($943)>>2)]=$25537;
      HEAP32[(($944)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($945)>>2)]=330;
      var $48488=HEAP32[(($943)>>2)];
      var $48489=(($48488)|0)!=0;
      if ($48489) { __label__ = 13037; break; } else { __label__ = 13039; break; }
    case 13037: // $48490
      var $48491=HEAP32[(($943)>>2)];
      var $48492=HEAP32[(($944)>>2)];
      var $48493=HEAP32[(($945)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48491, $48492, $48493) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13038; break; } else { __label__ = 14612; break; }
    case 13038: // $_noexc1711
      __label__ = 13039; break;
    case 13039: // $_ZdlPvPKci_exit1712
      var $48494=$943;
      var $48495=$944;
      var $48496=$945;
      __label__ = 13040; break;
    case 13040: // $48497
      __label__ = 14611; break;
    case 13041: // $48498
      var $48499=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48500=$48499.f0;
      $4692=$48500;
      var $48501=$48499.f1;
      $4693=$48501;
      var $48502=$940;
      var $48503=$941;
      var $48504=$942;
      HEAP32[(($940)>>2)]=$25588;
      HEAP32[(($941)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($942)>>2)]=331;
      var $48505=HEAP32[(($940)>>2)];
      var $48506=(($48505)|0)!=0;
      if ($48506) { __label__ = 13042; break; } else { __label__ = 13044; break; }
    case 13042: // $48507
      var $48508=HEAP32[(($940)>>2)];
      var $48509=HEAP32[(($941)>>2)];
      var $48510=HEAP32[(($942)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48508, $48509, $48510) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13043; break; } else { __label__ = 14612; break; }
    case 13043: // $_noexc1713
      __label__ = 13044; break;
    case 13044: // $_ZdlPvPKci_exit1714
      var $48511=$940;
      var $48512=$941;
      var $48513=$942;
      __label__ = 13045; break;
    case 13045: // $48514
      __label__ = 14611; break;
    case 13046: // $48515
      var $48516=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48517=$48516.f0;
      $4692=$48517;
      var $48518=$48516.f1;
      $4693=$48518;
      var $48519=$937;
      var $48520=$938;
      var $48521=$939;
      HEAP32[(($937)>>2)]=$25639;
      HEAP32[(($938)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($939)>>2)]=332;
      var $48522=HEAP32[(($937)>>2)];
      var $48523=(($48522)|0)!=0;
      if ($48523) { __label__ = 13047; break; } else { __label__ = 13049; break; }
    case 13047: // $48524
      var $48525=HEAP32[(($937)>>2)];
      var $48526=HEAP32[(($938)>>2)];
      var $48527=HEAP32[(($939)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48525, $48526, $48527) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13048; break; } else { __label__ = 14612; break; }
    case 13048: // $_noexc1715
      __label__ = 13049; break;
    case 13049: // $_ZdlPvPKci_exit1716
      var $48528=$937;
      var $48529=$938;
      var $48530=$939;
      __label__ = 13050; break;
    case 13050: // $48531
      __label__ = 14611; break;
    case 13051: // $48532
      var $48533=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48534=$48533.f0;
      $4692=$48534;
      var $48535=$48533.f1;
      $4693=$48535;
      var $48536=$934;
      var $48537=$935;
      var $48538=$936;
      HEAP32[(($934)>>2)]=$25690;
      HEAP32[(($935)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($936)>>2)]=333;
      var $48539=HEAP32[(($934)>>2)];
      var $48540=(($48539)|0)!=0;
      if ($48540) { __label__ = 13052; break; } else { __label__ = 13054; break; }
    case 13052: // $48541
      var $48542=HEAP32[(($934)>>2)];
      var $48543=HEAP32[(($935)>>2)];
      var $48544=HEAP32[(($936)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48542, $48543, $48544) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13053; break; } else { __label__ = 14612; break; }
    case 13053: // $_noexc1717
      __label__ = 13054; break;
    case 13054: // $_ZdlPvPKci_exit1718
      var $48545=$934;
      var $48546=$935;
      var $48547=$936;
      __label__ = 13055; break;
    case 13055: // $48548
      __label__ = 14611; break;
    case 13056: // $48549
      var $48550=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48551=$48550.f0;
      $4692=$48551;
      var $48552=$48550.f1;
      $4693=$48552;
      var $48553=$931;
      var $48554=$932;
      var $48555=$933;
      HEAP32[(($931)>>2)]=$25741;
      HEAP32[(($932)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($933)>>2)]=334;
      var $48556=HEAP32[(($931)>>2)];
      var $48557=(($48556)|0)!=0;
      if ($48557) { __label__ = 13057; break; } else { __label__ = 13059; break; }
    case 13057: // $48558
      var $48559=HEAP32[(($931)>>2)];
      var $48560=HEAP32[(($932)>>2)];
      var $48561=HEAP32[(($933)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48559, $48560, $48561) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13058; break; } else { __label__ = 14612; break; }
    case 13058: // $_noexc1719
      __label__ = 13059; break;
    case 13059: // $_ZdlPvPKci_exit1720
      var $48562=$931;
      var $48563=$932;
      var $48564=$933;
      __label__ = 13060; break;
    case 13060: // $48565
      __label__ = 14611; break;
    case 13061: // $48566
      var $48567=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48568=$48567.f0;
      $4692=$48568;
      var $48569=$48567.f1;
      $4693=$48569;
      var $48570=$928;
      var $48571=$929;
      var $48572=$930;
      HEAP32[(($928)>>2)]=$25792;
      HEAP32[(($929)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($930)>>2)]=335;
      var $48573=HEAP32[(($928)>>2)];
      var $48574=(($48573)|0)!=0;
      if ($48574) { __label__ = 13062; break; } else { __label__ = 13064; break; }
    case 13062: // $48575
      var $48576=HEAP32[(($928)>>2)];
      var $48577=HEAP32[(($929)>>2)];
      var $48578=HEAP32[(($930)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48576, $48577, $48578) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13063; break; } else { __label__ = 14612; break; }
    case 13063: // $_noexc1721
      __label__ = 13064; break;
    case 13064: // $_ZdlPvPKci_exit1722
      var $48579=$928;
      var $48580=$929;
      var $48581=$930;
      __label__ = 13065; break;
    case 13065: // $48582
      __label__ = 14611; break;
    case 13066: // $48583
      var $48584=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48585=$48584.f0;
      $4692=$48585;
      var $48586=$48584.f1;
      $4693=$48586;
      var $48587=$925;
      var $48588=$926;
      var $48589=$927;
      HEAP32[(($925)>>2)]=$25843;
      HEAP32[(($926)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($927)>>2)]=336;
      var $48590=HEAP32[(($925)>>2)];
      var $48591=(($48590)|0)!=0;
      if ($48591) { __label__ = 13067; break; } else { __label__ = 13069; break; }
    case 13067: // $48592
      var $48593=HEAP32[(($925)>>2)];
      var $48594=HEAP32[(($926)>>2)];
      var $48595=HEAP32[(($927)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48593, $48594, $48595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13068; break; } else { __label__ = 14612; break; }
    case 13068: // $_noexc1723
      __label__ = 13069; break;
    case 13069: // $_ZdlPvPKci_exit1724
      var $48596=$925;
      var $48597=$926;
      var $48598=$927;
      __label__ = 13070; break;
    case 13070: // $48599
      __label__ = 14611; break;
    case 13071: // $48600
      var $48601=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48602=$48601.f0;
      $4692=$48602;
      var $48603=$48601.f1;
      $4693=$48603;
      var $48604=$922;
      var $48605=$923;
      var $48606=$924;
      HEAP32[(($922)>>2)]=$25894;
      HEAP32[(($923)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($924)>>2)]=337;
      var $48607=HEAP32[(($922)>>2)];
      var $48608=(($48607)|0)!=0;
      if ($48608) { __label__ = 13072; break; } else { __label__ = 13074; break; }
    case 13072: // $48609
      var $48610=HEAP32[(($922)>>2)];
      var $48611=HEAP32[(($923)>>2)];
      var $48612=HEAP32[(($924)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48610, $48611, $48612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13073; break; } else { __label__ = 14612; break; }
    case 13073: // $_noexc1725
      __label__ = 13074; break;
    case 13074: // $_ZdlPvPKci_exit1726
      var $48613=$922;
      var $48614=$923;
      var $48615=$924;
      __label__ = 13075; break;
    case 13075: // $48616
      __label__ = 14611; break;
    case 13076: // $48617
      var $48618=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48619=$48618.f0;
      $4692=$48619;
      var $48620=$48618.f1;
      $4693=$48620;
      var $48621=$919;
      var $48622=$920;
      var $48623=$921;
      HEAP32[(($919)>>2)]=$25945;
      HEAP32[(($920)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($921)>>2)]=338;
      var $48624=HEAP32[(($919)>>2)];
      var $48625=(($48624)|0)!=0;
      if ($48625) { __label__ = 13077; break; } else { __label__ = 13079; break; }
    case 13077: // $48626
      var $48627=HEAP32[(($919)>>2)];
      var $48628=HEAP32[(($920)>>2)];
      var $48629=HEAP32[(($921)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48627, $48628, $48629) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13078; break; } else { __label__ = 14612; break; }
    case 13078: // $_noexc1727
      __label__ = 13079; break;
    case 13079: // $_ZdlPvPKci_exit1728
      var $48630=$919;
      var $48631=$920;
      var $48632=$921;
      __label__ = 13080; break;
    case 13080: // $48633
      __label__ = 14611; break;
    case 13081: // $48634
      var $48635=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48636=$48635.f0;
      $4692=$48636;
      var $48637=$48635.f1;
      $4693=$48637;
      var $48638=$916;
      var $48639=$917;
      var $48640=$918;
      HEAP32[(($916)>>2)]=$25996;
      HEAP32[(($917)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($918)>>2)]=339;
      var $48641=HEAP32[(($916)>>2)];
      var $48642=(($48641)|0)!=0;
      if ($48642) { __label__ = 13082; break; } else { __label__ = 13084; break; }
    case 13082: // $48643
      var $48644=HEAP32[(($916)>>2)];
      var $48645=HEAP32[(($917)>>2)];
      var $48646=HEAP32[(($918)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48644, $48645, $48646) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13083; break; } else { __label__ = 14612; break; }
    case 13083: // $_noexc1729
      __label__ = 13084; break;
    case 13084: // $_ZdlPvPKci_exit1730
      var $48647=$916;
      var $48648=$917;
      var $48649=$918;
      __label__ = 13085; break;
    case 13085: // $48650
      __label__ = 14611; break;
    case 13086: // $48651
      var $48652=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48653=$48652.f0;
      $4692=$48653;
      var $48654=$48652.f1;
      $4693=$48654;
      var $48655=$913;
      var $48656=$914;
      var $48657=$915;
      HEAP32[(($913)>>2)]=$26047;
      HEAP32[(($914)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($915)>>2)]=340;
      var $48658=HEAP32[(($913)>>2)];
      var $48659=(($48658)|0)!=0;
      if ($48659) { __label__ = 13087; break; } else { __label__ = 13089; break; }
    case 13087: // $48660
      var $48661=HEAP32[(($913)>>2)];
      var $48662=HEAP32[(($914)>>2)];
      var $48663=HEAP32[(($915)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48661, $48662, $48663) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13088; break; } else { __label__ = 14612; break; }
    case 13088: // $_noexc1731
      __label__ = 13089; break;
    case 13089: // $_ZdlPvPKci_exit1732
      var $48664=$913;
      var $48665=$914;
      var $48666=$915;
      __label__ = 13090; break;
    case 13090: // $48667
      __label__ = 14611; break;
    case 13091: // $48668
      var $48669=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48670=$48669.f0;
      $4692=$48670;
      var $48671=$48669.f1;
      $4693=$48671;
      var $48672=$910;
      var $48673=$911;
      var $48674=$912;
      HEAP32[(($910)>>2)]=$26098;
      HEAP32[(($911)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($912)>>2)]=341;
      var $48675=HEAP32[(($910)>>2)];
      var $48676=(($48675)|0)!=0;
      if ($48676) { __label__ = 13092; break; } else { __label__ = 13094; break; }
    case 13092: // $48677
      var $48678=HEAP32[(($910)>>2)];
      var $48679=HEAP32[(($911)>>2)];
      var $48680=HEAP32[(($912)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48678, $48679, $48680) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13093; break; } else { __label__ = 14612; break; }
    case 13093: // $_noexc1733
      __label__ = 13094; break;
    case 13094: // $_ZdlPvPKci_exit1734
      var $48681=$910;
      var $48682=$911;
      var $48683=$912;
      __label__ = 13095; break;
    case 13095: // $48684
      __label__ = 14611; break;
    case 13096: // $48685
      var $48686=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48687=$48686.f0;
      $4692=$48687;
      var $48688=$48686.f1;
      $4693=$48688;
      var $48689=$907;
      var $48690=$908;
      var $48691=$909;
      HEAP32[(($907)>>2)]=$26149;
      HEAP32[(($908)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($909)>>2)]=342;
      var $48692=HEAP32[(($907)>>2)];
      var $48693=(($48692)|0)!=0;
      if ($48693) { __label__ = 13097; break; } else { __label__ = 13099; break; }
    case 13097: // $48694
      var $48695=HEAP32[(($907)>>2)];
      var $48696=HEAP32[(($908)>>2)];
      var $48697=HEAP32[(($909)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48695, $48696, $48697) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13098; break; } else { __label__ = 14612; break; }
    case 13098: // $_noexc1735
      __label__ = 13099; break;
    case 13099: // $_ZdlPvPKci_exit1736
      var $48698=$907;
      var $48699=$908;
      var $48700=$909;
      __label__ = 13100; break;
    case 13100: // $48701
      __label__ = 14611; break;
    case 13101: // $48702
      var $48703=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48704=$48703.f0;
      $4692=$48704;
      var $48705=$48703.f1;
      $4693=$48705;
      var $48706=$904;
      var $48707=$905;
      var $48708=$906;
      HEAP32[(($904)>>2)]=$26200;
      HEAP32[(($905)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($906)>>2)]=344;
      var $48709=HEAP32[(($904)>>2)];
      var $48710=(($48709)|0)!=0;
      if ($48710) { __label__ = 13102; break; } else { __label__ = 13104; break; }
    case 13102: // $48711
      var $48712=HEAP32[(($904)>>2)];
      var $48713=HEAP32[(($905)>>2)];
      var $48714=HEAP32[(($906)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48712, $48713, $48714) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13103; break; } else { __label__ = 14612; break; }
    case 13103: // $_noexc1737
      __label__ = 13104; break;
    case 13104: // $_ZdlPvPKci_exit1738
      var $48715=$904;
      var $48716=$905;
      var $48717=$906;
      __label__ = 13105; break;
    case 13105: // $48718
      __label__ = 14611; break;
    case 13106: // $48719
      var $48720=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48721=$48720.f0;
      $4692=$48721;
      var $48722=$48720.f1;
      $4693=$48722;
      var $48723=$901;
      var $48724=$902;
      var $48725=$903;
      HEAP32[(($901)>>2)]=$26251;
      HEAP32[(($902)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($903)>>2)]=345;
      var $48726=HEAP32[(($901)>>2)];
      var $48727=(($48726)|0)!=0;
      if ($48727) { __label__ = 13107; break; } else { __label__ = 13109; break; }
    case 13107: // $48728
      var $48729=HEAP32[(($901)>>2)];
      var $48730=HEAP32[(($902)>>2)];
      var $48731=HEAP32[(($903)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48729, $48730, $48731) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13108; break; } else { __label__ = 14612; break; }
    case 13108: // $_noexc1739
      __label__ = 13109; break;
    case 13109: // $_ZdlPvPKci_exit1740
      var $48732=$901;
      var $48733=$902;
      var $48734=$903;
      __label__ = 13110; break;
    case 13110: // $48735
      __label__ = 14611; break;
    case 13111: // $48736
      var $48737=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48738=$48737.f0;
      $4692=$48738;
      var $48739=$48737.f1;
      $4693=$48739;
      var $48740=$898;
      var $48741=$899;
      var $48742=$900;
      HEAP32[(($898)>>2)]=$26302;
      HEAP32[(($899)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($900)>>2)]=346;
      var $48743=HEAP32[(($898)>>2)];
      var $48744=(($48743)|0)!=0;
      if ($48744) { __label__ = 13112; break; } else { __label__ = 13114; break; }
    case 13112: // $48745
      var $48746=HEAP32[(($898)>>2)];
      var $48747=HEAP32[(($899)>>2)];
      var $48748=HEAP32[(($900)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48746, $48747, $48748) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13113; break; } else { __label__ = 14612; break; }
    case 13113: // $_noexc1741
      __label__ = 13114; break;
    case 13114: // $_ZdlPvPKci_exit1742
      var $48749=$898;
      var $48750=$899;
      var $48751=$900;
      __label__ = 13115; break;
    case 13115: // $48752
      __label__ = 14611; break;
    case 13116: // $48753
      var $48754=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48755=$48754.f0;
      $4692=$48755;
      var $48756=$48754.f1;
      $4693=$48756;
      var $48757=$895;
      var $48758=$896;
      var $48759=$897;
      HEAP32[(($895)>>2)]=$26353;
      HEAP32[(($896)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($897)>>2)]=347;
      var $48760=HEAP32[(($895)>>2)];
      var $48761=(($48760)|0)!=0;
      if ($48761) { __label__ = 13117; break; } else { __label__ = 13119; break; }
    case 13117: // $48762
      var $48763=HEAP32[(($895)>>2)];
      var $48764=HEAP32[(($896)>>2)];
      var $48765=HEAP32[(($897)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48763, $48764, $48765) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13118; break; } else { __label__ = 14612; break; }
    case 13118: // $_noexc1743
      __label__ = 13119; break;
    case 13119: // $_ZdlPvPKci_exit1744
      var $48766=$895;
      var $48767=$896;
      var $48768=$897;
      __label__ = 13120; break;
    case 13120: // $48769
      __label__ = 14611; break;
    case 13121: // $48770
      var $48771=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48772=$48771.f0;
      $4692=$48772;
      var $48773=$48771.f1;
      $4693=$48773;
      var $48774=$892;
      var $48775=$893;
      var $48776=$894;
      HEAP32[(($892)>>2)]=$26404;
      HEAP32[(($893)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($894)>>2)]=348;
      var $48777=HEAP32[(($892)>>2)];
      var $48778=(($48777)|0)!=0;
      if ($48778) { __label__ = 13122; break; } else { __label__ = 13124; break; }
    case 13122: // $48779
      var $48780=HEAP32[(($892)>>2)];
      var $48781=HEAP32[(($893)>>2)];
      var $48782=HEAP32[(($894)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48780, $48781, $48782) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13123; break; } else { __label__ = 14612; break; }
    case 13123: // $_noexc1745
      __label__ = 13124; break;
    case 13124: // $_ZdlPvPKci_exit1746
      var $48783=$892;
      var $48784=$893;
      var $48785=$894;
      __label__ = 13125; break;
    case 13125: // $48786
      __label__ = 14611; break;
    case 13126: // $48787
      var $48788=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48789=$48788.f0;
      $4692=$48789;
      var $48790=$48788.f1;
      $4693=$48790;
      var $48791=$889;
      var $48792=$890;
      var $48793=$891;
      HEAP32[(($889)>>2)]=$26455;
      HEAP32[(($890)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($891)>>2)]=349;
      var $48794=HEAP32[(($889)>>2)];
      var $48795=(($48794)|0)!=0;
      if ($48795) { __label__ = 13127; break; } else { __label__ = 13129; break; }
    case 13127: // $48796
      var $48797=HEAP32[(($889)>>2)];
      var $48798=HEAP32[(($890)>>2)];
      var $48799=HEAP32[(($891)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48797, $48798, $48799) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13128; break; } else { __label__ = 14612; break; }
    case 13128: // $_noexc1747
      __label__ = 13129; break;
    case 13129: // $_ZdlPvPKci_exit1748
      var $48800=$889;
      var $48801=$890;
      var $48802=$891;
      __label__ = 13130; break;
    case 13130: // $48803
      __label__ = 14611; break;
    case 13131: // $48804
      var $48805=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48806=$48805.f0;
      $4692=$48806;
      var $48807=$48805.f1;
      $4693=$48807;
      var $48808=$886;
      var $48809=$887;
      var $48810=$888;
      HEAP32[(($886)>>2)]=$26506;
      HEAP32[(($887)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($888)>>2)]=350;
      var $48811=HEAP32[(($886)>>2)];
      var $48812=(($48811)|0)!=0;
      if ($48812) { __label__ = 13132; break; } else { __label__ = 13134; break; }
    case 13132: // $48813
      var $48814=HEAP32[(($886)>>2)];
      var $48815=HEAP32[(($887)>>2)];
      var $48816=HEAP32[(($888)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48814, $48815, $48816) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13133; break; } else { __label__ = 14612; break; }
    case 13133: // $_noexc1749
      __label__ = 13134; break;
    case 13134: // $_ZdlPvPKci_exit1750
      var $48817=$886;
      var $48818=$887;
      var $48819=$888;
      __label__ = 13135; break;
    case 13135: // $48820
      __label__ = 14611; break;
    case 13136: // $48821
      var $48822=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48823=$48822.f0;
      $4692=$48823;
      var $48824=$48822.f1;
      $4693=$48824;
      var $48825=$883;
      var $48826=$884;
      var $48827=$885;
      HEAP32[(($883)>>2)]=$26557;
      HEAP32[(($884)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($885)>>2)]=351;
      var $48828=HEAP32[(($883)>>2)];
      var $48829=(($48828)|0)!=0;
      if ($48829) { __label__ = 13137; break; } else { __label__ = 13139; break; }
    case 13137: // $48830
      var $48831=HEAP32[(($883)>>2)];
      var $48832=HEAP32[(($884)>>2)];
      var $48833=HEAP32[(($885)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48831, $48832, $48833) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13138; break; } else { __label__ = 14612; break; }
    case 13138: // $_noexc1751
      __label__ = 13139; break;
    case 13139: // $_ZdlPvPKci_exit1752
      var $48834=$883;
      var $48835=$884;
      var $48836=$885;
      __label__ = 13140; break;
    case 13140: // $48837
      __label__ = 14611; break;
    case 13141: // $48838
      var $48839=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48840=$48839.f0;
      $4692=$48840;
      var $48841=$48839.f1;
      $4693=$48841;
      var $48842=$880;
      var $48843=$881;
      var $48844=$882;
      HEAP32[(($880)>>2)]=$26608;
      HEAP32[(($881)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($882)>>2)]=352;
      var $48845=HEAP32[(($880)>>2)];
      var $48846=(($48845)|0)!=0;
      if ($48846) { __label__ = 13142; break; } else { __label__ = 13144; break; }
    case 13142: // $48847
      var $48848=HEAP32[(($880)>>2)];
      var $48849=HEAP32[(($881)>>2)];
      var $48850=HEAP32[(($882)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48848, $48849, $48850) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13143; break; } else { __label__ = 14612; break; }
    case 13143: // $_noexc1753
      __label__ = 13144; break;
    case 13144: // $_ZdlPvPKci_exit1754
      var $48851=$880;
      var $48852=$881;
      var $48853=$882;
      __label__ = 13145; break;
    case 13145: // $48854
      __label__ = 14611; break;
    case 13146: // $48855
      var $48856=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48857=$48856.f0;
      $4692=$48857;
      var $48858=$48856.f1;
      $4693=$48858;
      var $48859=$877;
      var $48860=$878;
      var $48861=$879;
      HEAP32[(($877)>>2)]=$26659;
      HEAP32[(($878)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($879)>>2)]=353;
      var $48862=HEAP32[(($877)>>2)];
      var $48863=(($48862)|0)!=0;
      if ($48863) { __label__ = 13147; break; } else { __label__ = 13149; break; }
    case 13147: // $48864
      var $48865=HEAP32[(($877)>>2)];
      var $48866=HEAP32[(($878)>>2)];
      var $48867=HEAP32[(($879)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48865, $48866, $48867) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13148; break; } else { __label__ = 14612; break; }
    case 13148: // $_noexc1755
      __label__ = 13149; break;
    case 13149: // $_ZdlPvPKci_exit1756
      var $48868=$877;
      var $48869=$878;
      var $48870=$879;
      __label__ = 13150; break;
    case 13150: // $48871
      __label__ = 14611; break;
    case 13151: // $48872
      var $48873=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48874=$48873.f0;
      $4692=$48874;
      var $48875=$48873.f1;
      $4693=$48875;
      var $48876=$874;
      var $48877=$875;
      var $48878=$876;
      HEAP32[(($874)>>2)]=$26710;
      HEAP32[(($875)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($876)>>2)]=354;
      var $48879=HEAP32[(($874)>>2)];
      var $48880=(($48879)|0)!=0;
      if ($48880) { __label__ = 13152; break; } else { __label__ = 13154; break; }
    case 13152: // $48881
      var $48882=HEAP32[(($874)>>2)];
      var $48883=HEAP32[(($875)>>2)];
      var $48884=HEAP32[(($876)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48882, $48883, $48884) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13153; break; } else { __label__ = 14612; break; }
    case 13153: // $_noexc1757
      __label__ = 13154; break;
    case 13154: // $_ZdlPvPKci_exit1758
      var $48885=$874;
      var $48886=$875;
      var $48887=$876;
      __label__ = 13155; break;
    case 13155: // $48888
      __label__ = 14611; break;
    case 13156: // $48889
      var $48890=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48891=$48890.f0;
      $4692=$48891;
      var $48892=$48890.f1;
      $4693=$48892;
      var $48893=$871;
      var $48894=$872;
      var $48895=$873;
      HEAP32[(($871)>>2)]=$26761;
      HEAP32[(($872)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($873)>>2)]=355;
      var $48896=HEAP32[(($871)>>2)];
      var $48897=(($48896)|0)!=0;
      if ($48897) { __label__ = 13157; break; } else { __label__ = 13159; break; }
    case 13157: // $48898
      var $48899=HEAP32[(($871)>>2)];
      var $48900=HEAP32[(($872)>>2)];
      var $48901=HEAP32[(($873)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48899, $48900, $48901) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13158; break; } else { __label__ = 14612; break; }
    case 13158: // $_noexc1759
      __label__ = 13159; break;
    case 13159: // $_ZdlPvPKci_exit1760
      var $48902=$871;
      var $48903=$872;
      var $48904=$873;
      __label__ = 13160; break;
    case 13160: // $48905
      __label__ = 14611; break;
    case 13161: // $48906
      var $48907=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48908=$48907.f0;
      $4692=$48908;
      var $48909=$48907.f1;
      $4693=$48909;
      var $48910=$868;
      var $48911=$869;
      var $48912=$870;
      HEAP32[(($868)>>2)]=$26812;
      HEAP32[(($869)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($870)>>2)]=356;
      var $48913=HEAP32[(($868)>>2)];
      var $48914=(($48913)|0)!=0;
      if ($48914) { __label__ = 13162; break; } else { __label__ = 13164; break; }
    case 13162: // $48915
      var $48916=HEAP32[(($868)>>2)];
      var $48917=HEAP32[(($869)>>2)];
      var $48918=HEAP32[(($870)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48916, $48917, $48918) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13163; break; } else { __label__ = 14612; break; }
    case 13163: // $_noexc1761
      __label__ = 13164; break;
    case 13164: // $_ZdlPvPKci_exit1762
      var $48919=$868;
      var $48920=$869;
      var $48921=$870;
      __label__ = 13165; break;
    case 13165: // $48922
      __label__ = 14611; break;
    case 13166: // $48923
      var $48924=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48925=$48924.f0;
      $4692=$48925;
      var $48926=$48924.f1;
      $4693=$48926;
      var $48927=$865;
      var $48928=$866;
      var $48929=$867;
      HEAP32[(($865)>>2)]=$26863;
      HEAP32[(($866)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($867)>>2)]=357;
      var $48930=HEAP32[(($865)>>2)];
      var $48931=(($48930)|0)!=0;
      if ($48931) { __label__ = 13167; break; } else { __label__ = 13169; break; }
    case 13167: // $48932
      var $48933=HEAP32[(($865)>>2)];
      var $48934=HEAP32[(($866)>>2)];
      var $48935=HEAP32[(($867)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48933, $48934, $48935) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13168; break; } else { __label__ = 14612; break; }
    case 13168: // $_noexc1763
      __label__ = 13169; break;
    case 13169: // $_ZdlPvPKci_exit1764
      var $48936=$865;
      var $48937=$866;
      var $48938=$867;
      __label__ = 13170; break;
    case 13170: // $48939
      __label__ = 14611; break;
    case 13171: // $48940
      var $48941=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48942=$48941.f0;
      $4692=$48942;
      var $48943=$48941.f1;
      $4693=$48943;
      var $48944=$862;
      var $48945=$863;
      var $48946=$864;
      HEAP32[(($862)>>2)]=$26914;
      HEAP32[(($863)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($864)>>2)]=358;
      var $48947=HEAP32[(($862)>>2)];
      var $48948=(($48947)|0)!=0;
      if ($48948) { __label__ = 13172; break; } else { __label__ = 13174; break; }
    case 13172: // $48949
      var $48950=HEAP32[(($862)>>2)];
      var $48951=HEAP32[(($863)>>2)];
      var $48952=HEAP32[(($864)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48950, $48951, $48952) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13173; break; } else { __label__ = 14612; break; }
    case 13173: // $_noexc1765
      __label__ = 13174; break;
    case 13174: // $_ZdlPvPKci_exit1766
      var $48953=$862;
      var $48954=$863;
      var $48955=$864;
      __label__ = 13175; break;
    case 13175: // $48956
      __label__ = 14611; break;
    case 13176: // $48957
      var $48958=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48959=$48958.f0;
      $4692=$48959;
      var $48960=$48958.f1;
      $4693=$48960;
      var $48961=$859;
      var $48962=$860;
      var $48963=$861;
      HEAP32[(($859)>>2)]=$26965;
      HEAP32[(($860)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($861)>>2)]=359;
      var $48964=HEAP32[(($859)>>2)];
      var $48965=(($48964)|0)!=0;
      if ($48965) { __label__ = 13177; break; } else { __label__ = 13179; break; }
    case 13177: // $48966
      var $48967=HEAP32[(($859)>>2)];
      var $48968=HEAP32[(($860)>>2)];
      var $48969=HEAP32[(($861)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48967, $48968, $48969) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13178; break; } else { __label__ = 14612; break; }
    case 13178: // $_noexc1767
      __label__ = 13179; break;
    case 13179: // $_ZdlPvPKci_exit1768
      var $48970=$859;
      var $48971=$860;
      var $48972=$861;
      __label__ = 13180; break;
    case 13180: // $48973
      __label__ = 14611; break;
    case 13181: // $48974
      var $48975=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48976=$48975.f0;
      $4692=$48976;
      var $48977=$48975.f1;
      $4693=$48977;
      var $48978=$856;
      var $48979=$857;
      var $48980=$858;
      HEAP32[(($856)>>2)]=$27016;
      HEAP32[(($857)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($858)>>2)]=360;
      var $48981=HEAP32[(($856)>>2)];
      var $48982=(($48981)|0)!=0;
      if ($48982) { __label__ = 13182; break; } else { __label__ = 13184; break; }
    case 13182: // $48983
      var $48984=HEAP32[(($856)>>2)];
      var $48985=HEAP32[(($857)>>2)];
      var $48986=HEAP32[(($858)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($48984, $48985, $48986) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13183; break; } else { __label__ = 14612; break; }
    case 13183: // $_noexc1769
      __label__ = 13184; break;
    case 13184: // $_ZdlPvPKci_exit1770
      var $48987=$856;
      var $48988=$857;
      var $48989=$858;
      __label__ = 13185; break;
    case 13185: // $48990
      __label__ = 14611; break;
    case 13186: // $48991
      var $48992=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48993=$48992.f0;
      $4692=$48993;
      var $48994=$48992.f1;
      $4693=$48994;
      var $48995=$853;
      var $48996=$854;
      var $48997=$855;
      HEAP32[(($853)>>2)]=$27067;
      HEAP32[(($854)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($855)>>2)]=361;
      var $48998=HEAP32[(($853)>>2)];
      var $48999=(($48998)|0)!=0;
      if ($48999) { __label__ = 13187; break; } else { __label__ = 13189; break; }
    case 13187: // $49000
      var $49001=HEAP32[(($853)>>2)];
      var $49002=HEAP32[(($854)>>2)];
      var $49003=HEAP32[(($855)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49001, $49002, $49003) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13188; break; } else { __label__ = 14612; break; }
    case 13188: // $_noexc1771
      __label__ = 13189; break;
    case 13189: // $_ZdlPvPKci_exit1772
      var $49004=$853;
      var $49005=$854;
      var $49006=$855;
      __label__ = 13190; break;
    case 13190: // $49007
      __label__ = 14611; break;
    case 13191: // $49008
      var $49009=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49010=$49009.f0;
      $4692=$49010;
      var $49011=$49009.f1;
      $4693=$49011;
      var $49012=$850;
      var $49013=$851;
      var $49014=$852;
      HEAP32[(($850)>>2)]=$27118;
      HEAP32[(($851)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($852)>>2)]=362;
      var $49015=HEAP32[(($850)>>2)];
      var $49016=(($49015)|0)!=0;
      if ($49016) { __label__ = 13192; break; } else { __label__ = 13194; break; }
    case 13192: // $49017
      var $49018=HEAP32[(($850)>>2)];
      var $49019=HEAP32[(($851)>>2)];
      var $49020=HEAP32[(($852)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49018, $49019, $49020) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13193; break; } else { __label__ = 14612; break; }
    case 13193: // $_noexc1773
      __label__ = 13194; break;
    case 13194: // $_ZdlPvPKci_exit1774
      var $49021=$850;
      var $49022=$851;
      var $49023=$852;
      __label__ = 13195; break;
    case 13195: // $49024
      __label__ = 14611; break;
    case 13196: // $49025
      var $49026=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49027=$49026.f0;
      $4692=$49027;
      var $49028=$49026.f1;
      $4693=$49028;
      var $49029=$847;
      var $49030=$848;
      var $49031=$849;
      HEAP32[(($847)>>2)]=$27169;
      HEAP32[(($848)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($849)>>2)]=363;
      var $49032=HEAP32[(($847)>>2)];
      var $49033=(($49032)|0)!=0;
      if ($49033) { __label__ = 13197; break; } else { __label__ = 13199; break; }
    case 13197: // $49034
      var $49035=HEAP32[(($847)>>2)];
      var $49036=HEAP32[(($848)>>2)];
      var $49037=HEAP32[(($849)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49035, $49036, $49037) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13198; break; } else { __label__ = 14612; break; }
    case 13198: // $_noexc1775
      __label__ = 13199; break;
    case 13199: // $_ZdlPvPKci_exit1776
      var $49038=$847;
      var $49039=$848;
      var $49040=$849;
      __label__ = 13200; break;
    case 13200: // $49041
      __label__ = 14611; break;
    case 13201: // $49042
      var $49043=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49044=$49043.f0;
      $4692=$49044;
      var $49045=$49043.f1;
      $4693=$49045;
      var $49046=$844;
      var $49047=$845;
      var $49048=$846;
      HEAP32[(($844)>>2)]=$27220;
      HEAP32[(($845)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($846)>>2)]=364;
      var $49049=HEAP32[(($844)>>2)];
      var $49050=(($49049)|0)!=0;
      if ($49050) { __label__ = 13202; break; } else { __label__ = 13204; break; }
    case 13202: // $49051
      var $49052=HEAP32[(($844)>>2)];
      var $49053=HEAP32[(($845)>>2)];
      var $49054=HEAP32[(($846)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49052, $49053, $49054) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13203; break; } else { __label__ = 14612; break; }
    case 13203: // $_noexc1777
      __label__ = 13204; break;
    case 13204: // $_ZdlPvPKci_exit1778
      var $49055=$844;
      var $49056=$845;
      var $49057=$846;
      __label__ = 13205; break;
    case 13205: // $49058
      __label__ = 14611; break;
    case 13206: // $49059
      var $49060=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49061=$49060.f0;
      $4692=$49061;
      var $49062=$49060.f1;
      $4693=$49062;
      var $49063=$841;
      var $49064=$842;
      var $49065=$843;
      HEAP32[(($841)>>2)]=$27271;
      HEAP32[(($842)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($843)>>2)]=365;
      var $49066=HEAP32[(($841)>>2)];
      var $49067=(($49066)|0)!=0;
      if ($49067) { __label__ = 13207; break; } else { __label__ = 13209; break; }
    case 13207: // $49068
      var $49069=HEAP32[(($841)>>2)];
      var $49070=HEAP32[(($842)>>2)];
      var $49071=HEAP32[(($843)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49069, $49070, $49071) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13208; break; } else { __label__ = 14612; break; }
    case 13208: // $_noexc1779
      __label__ = 13209; break;
    case 13209: // $_ZdlPvPKci_exit1780
      var $49072=$841;
      var $49073=$842;
      var $49074=$843;
      __label__ = 13210; break;
    case 13210: // $49075
      __label__ = 14611; break;
    case 13211: // $49076
      var $49077=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49078=$49077.f0;
      $4692=$49078;
      var $49079=$49077.f1;
      $4693=$49079;
      var $49080=$838;
      var $49081=$839;
      var $49082=$840;
      HEAP32[(($838)>>2)]=$27322;
      HEAP32[(($839)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($840)>>2)]=366;
      var $49083=HEAP32[(($838)>>2)];
      var $49084=(($49083)|0)!=0;
      if ($49084) { __label__ = 13212; break; } else { __label__ = 13214; break; }
    case 13212: // $49085
      var $49086=HEAP32[(($838)>>2)];
      var $49087=HEAP32[(($839)>>2)];
      var $49088=HEAP32[(($840)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49086, $49087, $49088) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13213; break; } else { __label__ = 14612; break; }
    case 13213: // $_noexc1781
      __label__ = 13214; break;
    case 13214: // $_ZdlPvPKci_exit1782
      var $49089=$838;
      var $49090=$839;
      var $49091=$840;
      __label__ = 13215; break;
    case 13215: // $49092
      __label__ = 14611; break;
    case 13216: // $49093
      var $49094=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49095=$49094.f0;
      $4692=$49095;
      var $49096=$49094.f1;
      $4693=$49096;
      var $49097=$835;
      var $49098=$836;
      var $49099=$837;
      HEAP32[(($835)>>2)]=$27373;
      HEAP32[(($836)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($837)>>2)]=367;
      var $49100=HEAP32[(($835)>>2)];
      var $49101=(($49100)|0)!=0;
      if ($49101) { __label__ = 13217; break; } else { __label__ = 13219; break; }
    case 13217: // $49102
      var $49103=HEAP32[(($835)>>2)];
      var $49104=HEAP32[(($836)>>2)];
      var $49105=HEAP32[(($837)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49103, $49104, $49105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13218; break; } else { __label__ = 14612; break; }
    case 13218: // $_noexc1783
      __label__ = 13219; break;
    case 13219: // $_ZdlPvPKci_exit1784
      var $49106=$835;
      var $49107=$836;
      var $49108=$837;
      __label__ = 13220; break;
    case 13220: // $49109
      __label__ = 14611; break;
    case 13221: // $49110
      var $49111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49112=$49111.f0;
      $4692=$49112;
      var $49113=$49111.f1;
      $4693=$49113;
      var $49114=$832;
      var $49115=$833;
      var $49116=$834;
      HEAP32[(($832)>>2)]=$27424;
      HEAP32[(($833)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($834)>>2)]=368;
      var $49117=HEAP32[(($832)>>2)];
      var $49118=(($49117)|0)!=0;
      if ($49118) { __label__ = 13222; break; } else { __label__ = 13224; break; }
    case 13222: // $49119
      var $49120=HEAP32[(($832)>>2)];
      var $49121=HEAP32[(($833)>>2)];
      var $49122=HEAP32[(($834)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49120, $49121, $49122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13223; break; } else { __label__ = 14612; break; }
    case 13223: // $_noexc1785
      __label__ = 13224; break;
    case 13224: // $_ZdlPvPKci_exit1786
      var $49123=$832;
      var $49124=$833;
      var $49125=$834;
      __label__ = 13225; break;
    case 13225: // $49126
      __label__ = 14611; break;
    case 13226: // $49127
      var $49128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49129=$49128.f0;
      $4692=$49129;
      var $49130=$49128.f1;
      $4693=$49130;
      var $49131=$829;
      var $49132=$830;
      var $49133=$831;
      HEAP32[(($829)>>2)]=$27475;
      HEAP32[(($830)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($831)>>2)]=369;
      var $49134=HEAP32[(($829)>>2)];
      var $49135=(($49134)|0)!=0;
      if ($49135) { __label__ = 13227; break; } else { __label__ = 13229; break; }
    case 13227: // $49136
      var $49137=HEAP32[(($829)>>2)];
      var $49138=HEAP32[(($830)>>2)];
      var $49139=HEAP32[(($831)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49137, $49138, $49139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13228; break; } else { __label__ = 14612; break; }
    case 13228: // $_noexc1787
      __label__ = 13229; break;
    case 13229: // $_ZdlPvPKci_exit1788
      var $49140=$829;
      var $49141=$830;
      var $49142=$831;
      __label__ = 13230; break;
    case 13230: // $49143
      __label__ = 14611; break;
    case 13231: // $49144
      var $49145=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49146=$49145.f0;
      $4692=$49146;
      var $49147=$49145.f1;
      $4693=$49147;
      var $49148=$826;
      var $49149=$827;
      var $49150=$828;
      HEAP32[(($826)>>2)]=$27526;
      HEAP32[(($827)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($828)>>2)]=370;
      var $49151=HEAP32[(($826)>>2)];
      var $49152=(($49151)|0)!=0;
      if ($49152) { __label__ = 13232; break; } else { __label__ = 13234; break; }
    case 13232: // $49153
      var $49154=HEAP32[(($826)>>2)];
      var $49155=HEAP32[(($827)>>2)];
      var $49156=HEAP32[(($828)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49154, $49155, $49156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13233; break; } else { __label__ = 14612; break; }
    case 13233: // $_noexc1789
      __label__ = 13234; break;
    case 13234: // $_ZdlPvPKci_exit1790
      var $49157=$826;
      var $49158=$827;
      var $49159=$828;
      __label__ = 13235; break;
    case 13235: // $49160
      __label__ = 14611; break;
    case 13236: // $49161
      var $49162=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49163=$49162.f0;
      $4692=$49163;
      var $49164=$49162.f1;
      $4693=$49164;
      var $49165=$823;
      var $49166=$824;
      var $49167=$825;
      HEAP32[(($823)>>2)]=$27577;
      HEAP32[(($824)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($825)>>2)]=371;
      var $49168=HEAP32[(($823)>>2)];
      var $49169=(($49168)|0)!=0;
      if ($49169) { __label__ = 13237; break; } else { __label__ = 13239; break; }
    case 13237: // $49170
      var $49171=HEAP32[(($823)>>2)];
      var $49172=HEAP32[(($824)>>2)];
      var $49173=HEAP32[(($825)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49171, $49172, $49173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13238; break; } else { __label__ = 14612; break; }
    case 13238: // $_noexc1791
      __label__ = 13239; break;
    case 13239: // $_ZdlPvPKci_exit1792
      var $49174=$823;
      var $49175=$824;
      var $49176=$825;
      __label__ = 13240; break;
    case 13240: // $49177
      __label__ = 14611; break;
    case 13241: // $49178
      var $49179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49180=$49179.f0;
      $4692=$49180;
      var $49181=$49179.f1;
      $4693=$49181;
      var $49182=$820;
      var $49183=$821;
      var $49184=$822;
      HEAP32[(($820)>>2)]=$27628;
      HEAP32[(($821)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($822)>>2)]=372;
      var $49185=HEAP32[(($820)>>2)];
      var $49186=(($49185)|0)!=0;
      if ($49186) { __label__ = 13242; break; } else { __label__ = 13244; break; }
    case 13242: // $49187
      var $49188=HEAP32[(($820)>>2)];
      var $49189=HEAP32[(($821)>>2)];
      var $49190=HEAP32[(($822)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49188, $49189, $49190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13243; break; } else { __label__ = 14612; break; }
    case 13243: // $_noexc1793
      __label__ = 13244; break;
    case 13244: // $_ZdlPvPKci_exit1794
      var $49191=$820;
      var $49192=$821;
      var $49193=$822;
      __label__ = 13245; break;
    case 13245: // $49194
      __label__ = 14611; break;
    case 13246: // $49195
      var $49196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49197=$49196.f0;
      $4692=$49197;
      var $49198=$49196.f1;
      $4693=$49198;
      var $49199=$817;
      var $49200=$818;
      var $49201=$819;
      HEAP32[(($817)>>2)]=$27679;
      HEAP32[(($818)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($819)>>2)]=373;
      var $49202=HEAP32[(($817)>>2)];
      var $49203=(($49202)|0)!=0;
      if ($49203) { __label__ = 13247; break; } else { __label__ = 13249; break; }
    case 13247: // $49204
      var $49205=HEAP32[(($817)>>2)];
      var $49206=HEAP32[(($818)>>2)];
      var $49207=HEAP32[(($819)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49205, $49206, $49207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13248; break; } else { __label__ = 14612; break; }
    case 13248: // $_noexc1795
      __label__ = 13249; break;
    case 13249: // $_ZdlPvPKci_exit1796
      var $49208=$817;
      var $49209=$818;
      var $49210=$819;
      __label__ = 13250; break;
    case 13250: // $49211
      __label__ = 14611; break;
    case 13251: // $49212
      var $49213=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49214=$49213.f0;
      $4692=$49214;
      var $49215=$49213.f1;
      $4693=$49215;
      var $49216=$814;
      var $49217=$815;
      var $49218=$816;
      HEAP32[(($814)>>2)]=$27730;
      HEAP32[(($815)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($816)>>2)]=375;
      var $49219=HEAP32[(($814)>>2)];
      var $49220=(($49219)|0)!=0;
      if ($49220) { __label__ = 13252; break; } else { __label__ = 13254; break; }
    case 13252: // $49221
      var $49222=HEAP32[(($814)>>2)];
      var $49223=HEAP32[(($815)>>2)];
      var $49224=HEAP32[(($816)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49222, $49223, $49224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13253; break; } else { __label__ = 14612; break; }
    case 13253: // $_noexc1797
      __label__ = 13254; break;
    case 13254: // $_ZdlPvPKci_exit1798
      var $49225=$814;
      var $49226=$815;
      var $49227=$816;
      __label__ = 13255; break;
    case 13255: // $49228
      __label__ = 14611; break;
    case 13256: // $49229
      var $49230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49231=$49230.f0;
      $4692=$49231;
      var $49232=$49230.f1;
      $4693=$49232;
      var $49233=$811;
      var $49234=$812;
      var $49235=$813;
      HEAP32[(($811)>>2)]=$27781;
      HEAP32[(($812)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($813)>>2)]=376;
      var $49236=HEAP32[(($811)>>2)];
      var $49237=(($49236)|0)!=0;
      if ($49237) { __label__ = 13257; break; } else { __label__ = 13259; break; }
    case 13257: // $49238
      var $49239=HEAP32[(($811)>>2)];
      var $49240=HEAP32[(($812)>>2)];
      var $49241=HEAP32[(($813)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49239, $49240, $49241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13258; break; } else { __label__ = 14612; break; }
    case 13258: // $_noexc1799
      __label__ = 13259; break;
    case 13259: // $_ZdlPvPKci_exit1800
      var $49242=$811;
      var $49243=$812;
      var $49244=$813;
      __label__ = 13260; break;
    case 13260: // $49245
      __label__ = 14611; break;
    case 13261: // $49246
      var $49247=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49248=$49247.f0;
      $4692=$49248;
      var $49249=$49247.f1;
      $4693=$49249;
      var $49250=$808;
      var $49251=$809;
      var $49252=$810;
      HEAP32[(($808)>>2)]=$27832;
      HEAP32[(($809)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($810)>>2)]=377;
      var $49253=HEAP32[(($808)>>2)];
      var $49254=(($49253)|0)!=0;
      if ($49254) { __label__ = 13262; break; } else { __label__ = 13264; break; }
    case 13262: // $49255
      var $49256=HEAP32[(($808)>>2)];
      var $49257=HEAP32[(($809)>>2)];
      var $49258=HEAP32[(($810)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49256, $49257, $49258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13263; break; } else { __label__ = 14612; break; }
    case 13263: // $_noexc1801
      __label__ = 13264; break;
    case 13264: // $_ZdlPvPKci_exit1802
      var $49259=$808;
      var $49260=$809;
      var $49261=$810;
      __label__ = 13265; break;
    case 13265: // $49262
      __label__ = 14611; break;
    case 13266: // $49263
      var $49264=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49265=$49264.f0;
      $4692=$49265;
      var $49266=$49264.f1;
      $4693=$49266;
      var $49267=$805;
      var $49268=$806;
      var $49269=$807;
      HEAP32[(($805)>>2)]=$27883;
      HEAP32[(($806)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($807)>>2)]=378;
      var $49270=HEAP32[(($805)>>2)];
      var $49271=(($49270)|0)!=0;
      if ($49271) { __label__ = 13267; break; } else { __label__ = 13269; break; }
    case 13267: // $49272
      var $49273=HEAP32[(($805)>>2)];
      var $49274=HEAP32[(($806)>>2)];
      var $49275=HEAP32[(($807)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49273, $49274, $49275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13268; break; } else { __label__ = 14612; break; }
    case 13268: // $_noexc1803
      __label__ = 13269; break;
    case 13269: // $_ZdlPvPKci_exit1804
      var $49276=$805;
      var $49277=$806;
      var $49278=$807;
      __label__ = 13270; break;
    case 13270: // $49279
      __label__ = 14611; break;
    case 13271: // $49280
      var $49281=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49282=$49281.f0;
      $4692=$49282;
      var $49283=$49281.f1;
      $4693=$49283;
      var $49284=$802;
      var $49285=$803;
      var $49286=$804;
      HEAP32[(($802)>>2)]=$27934;
      HEAP32[(($803)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($804)>>2)]=379;
      var $49287=HEAP32[(($802)>>2)];
      var $49288=(($49287)|0)!=0;
      if ($49288) { __label__ = 13272; break; } else { __label__ = 13274; break; }
    case 13272: // $49289
      var $49290=HEAP32[(($802)>>2)];
      var $49291=HEAP32[(($803)>>2)];
      var $49292=HEAP32[(($804)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49290, $49291, $49292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13273; break; } else { __label__ = 14612; break; }
    case 13273: // $_noexc1805
      __label__ = 13274; break;
    case 13274: // $_ZdlPvPKci_exit1806
      var $49293=$802;
      var $49294=$803;
      var $49295=$804;
      __label__ = 13275; break;
    case 13275: // $49296
      __label__ = 14611; break;
    case 13276: // $49297
      var $49298=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49299=$49298.f0;
      $4692=$49299;
      var $49300=$49298.f1;
      $4693=$49300;
      var $49301=$799;
      var $49302=$800;
      var $49303=$801;
      HEAP32[(($799)>>2)]=$27985;
      HEAP32[(($800)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($801)>>2)]=380;
      var $49304=HEAP32[(($799)>>2)];
      var $49305=(($49304)|0)!=0;
      if ($49305) { __label__ = 13277; break; } else { __label__ = 13279; break; }
    case 13277: // $49306
      var $49307=HEAP32[(($799)>>2)];
      var $49308=HEAP32[(($800)>>2)];
      var $49309=HEAP32[(($801)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49307, $49308, $49309) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13278; break; } else { __label__ = 14612; break; }
    case 13278: // $_noexc1807
      __label__ = 13279; break;
    case 13279: // $_ZdlPvPKci_exit1808
      var $49310=$799;
      var $49311=$800;
      var $49312=$801;
      __label__ = 13280; break;
    case 13280: // $49313
      __label__ = 14611; break;
    case 13281: // $49314
      var $49315=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49316=$49315.f0;
      $4692=$49316;
      var $49317=$49315.f1;
      $4693=$49317;
      var $49318=$796;
      var $49319=$797;
      var $49320=$798;
      HEAP32[(($796)>>2)]=$28036;
      HEAP32[(($797)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($798)>>2)]=381;
      var $49321=HEAP32[(($796)>>2)];
      var $49322=(($49321)|0)!=0;
      if ($49322) { __label__ = 13282; break; } else { __label__ = 13284; break; }
    case 13282: // $49323
      var $49324=HEAP32[(($796)>>2)];
      var $49325=HEAP32[(($797)>>2)];
      var $49326=HEAP32[(($798)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49324, $49325, $49326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13283; break; } else { __label__ = 14612; break; }
    case 13283: // $_noexc1809
      __label__ = 13284; break;
    case 13284: // $_ZdlPvPKci_exit1810
      var $49327=$796;
      var $49328=$797;
      var $49329=$798;
      __label__ = 13285; break;
    case 13285: // $49330
      __label__ = 14611; break;
    case 13286: // $49331
      var $49332=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49333=$49332.f0;
      $4692=$49333;
      var $49334=$49332.f1;
      $4693=$49334;
      var $49335=$793;
      var $49336=$794;
      var $49337=$795;
      HEAP32[(($793)>>2)]=$28087;
      HEAP32[(($794)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($795)>>2)]=382;
      var $49338=HEAP32[(($793)>>2)];
      var $49339=(($49338)|0)!=0;
      if ($49339) { __label__ = 13287; break; } else { __label__ = 13289; break; }
    case 13287: // $49340
      var $49341=HEAP32[(($793)>>2)];
      var $49342=HEAP32[(($794)>>2)];
      var $49343=HEAP32[(($795)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49341, $49342, $49343) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13288; break; } else { __label__ = 14612; break; }
    case 13288: // $_noexc1811
      __label__ = 13289; break;
    case 13289: // $_ZdlPvPKci_exit1812
      var $49344=$793;
      var $49345=$794;
      var $49346=$795;
      __label__ = 13290; break;
    case 13290: // $49347
      __label__ = 14611; break;
    case 13291: // $49348
      var $49349=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49350=$49349.f0;
      $4692=$49350;
      var $49351=$49349.f1;
      $4693=$49351;
      var $49352=$790;
      var $49353=$791;
      var $49354=$792;
      HEAP32[(($790)>>2)]=$28138;
      HEAP32[(($791)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($792)>>2)]=383;
      var $49355=HEAP32[(($790)>>2)];
      var $49356=(($49355)|0)!=0;
      if ($49356) { __label__ = 13292; break; } else { __label__ = 13294; break; }
    case 13292: // $49357
      var $49358=HEAP32[(($790)>>2)];
      var $49359=HEAP32[(($791)>>2)];
      var $49360=HEAP32[(($792)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49358, $49359, $49360) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13293; break; } else { __label__ = 14612; break; }
    case 13293: // $_noexc1813
      __label__ = 13294; break;
    case 13294: // $_ZdlPvPKci_exit1814
      var $49361=$790;
      var $49362=$791;
      var $49363=$792;
      __label__ = 13295; break;
    case 13295: // $49364
      __label__ = 14611; break;
    case 13296: // $49365
      var $49366=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49367=$49366.f0;
      $4692=$49367;
      var $49368=$49366.f1;
      $4693=$49368;
      var $49369=$787;
      var $49370=$788;
      var $49371=$789;
      HEAP32[(($787)>>2)]=$28189;
      HEAP32[(($788)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($789)>>2)]=384;
      var $49372=HEAP32[(($787)>>2)];
      var $49373=(($49372)|0)!=0;
      if ($49373) { __label__ = 13297; break; } else { __label__ = 13299; break; }
    case 13297: // $49374
      var $49375=HEAP32[(($787)>>2)];
      var $49376=HEAP32[(($788)>>2)];
      var $49377=HEAP32[(($789)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49375, $49376, $49377) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13298; break; } else { __label__ = 14612; break; }
    case 13298: // $_noexc1815
      __label__ = 13299; break;
    case 13299: // $_ZdlPvPKci_exit1816
      var $49378=$787;
      var $49379=$788;
      var $49380=$789;
      __label__ = 13300; break;
    case 13300: // $49381
      __label__ = 14611; break;
    case 13301: // $49382
      var $49383=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49384=$49383.f0;
      $4692=$49384;
      var $49385=$49383.f1;
      $4693=$49385;
      var $49386=$784;
      var $49387=$785;
      var $49388=$786;
      HEAP32[(($784)>>2)]=$28240;
      HEAP32[(($785)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($786)>>2)]=385;
      var $49389=HEAP32[(($784)>>2)];
      var $49390=(($49389)|0)!=0;
      if ($49390) { __label__ = 13302; break; } else { __label__ = 13304; break; }
    case 13302: // $49391
      var $49392=HEAP32[(($784)>>2)];
      var $49393=HEAP32[(($785)>>2)];
      var $49394=HEAP32[(($786)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49392, $49393, $49394) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13303; break; } else { __label__ = 14612; break; }
    case 13303: // $_noexc1817
      __label__ = 13304; break;
    case 13304: // $_ZdlPvPKci_exit1818
      var $49395=$784;
      var $49396=$785;
      var $49397=$786;
      __label__ = 13305; break;
    case 13305: // $49398
      __label__ = 14611; break;
    case 13306: // $49399
      var $49400=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49401=$49400.f0;
      $4692=$49401;
      var $49402=$49400.f1;
      $4693=$49402;
      var $49403=$781;
      var $49404=$782;
      var $49405=$783;
      HEAP32[(($781)>>2)]=$28291;
      HEAP32[(($782)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($783)>>2)]=386;
      var $49406=HEAP32[(($781)>>2)];
      var $49407=(($49406)|0)!=0;
      if ($49407) { __label__ = 13307; break; } else { __label__ = 13309; break; }
    case 13307: // $49408
      var $49409=HEAP32[(($781)>>2)];
      var $49410=HEAP32[(($782)>>2)];
      var $49411=HEAP32[(($783)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49409, $49410, $49411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13308; break; } else { __label__ = 14612; break; }
    case 13308: // $_noexc1819
      __label__ = 13309; break;
    case 13309: // $_ZdlPvPKci_exit1820
      var $49412=$781;
      var $49413=$782;
      var $49414=$783;
      __label__ = 13310; break;
    case 13310: // $49415
      __label__ = 14611; break;
    case 13311: // $49416
      var $49417=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49418=$49417.f0;
      $4692=$49418;
      var $49419=$49417.f1;
      $4693=$49419;
      var $49420=$778;
      var $49421=$779;
      var $49422=$780;
      HEAP32[(($778)>>2)]=$28342;
      HEAP32[(($779)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($780)>>2)]=387;
      var $49423=HEAP32[(($778)>>2)];
      var $49424=(($49423)|0)!=0;
      if ($49424) { __label__ = 13312; break; } else { __label__ = 13314; break; }
    case 13312: // $49425
      var $49426=HEAP32[(($778)>>2)];
      var $49427=HEAP32[(($779)>>2)];
      var $49428=HEAP32[(($780)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49426, $49427, $49428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13313; break; } else { __label__ = 14612; break; }
    case 13313: // $_noexc1821
      __label__ = 13314; break;
    case 13314: // $_ZdlPvPKci_exit1822
      var $49429=$778;
      var $49430=$779;
      var $49431=$780;
      __label__ = 13315; break;
    case 13315: // $49432
      __label__ = 14611; break;
    case 13316: // $49433
      var $49434=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49435=$49434.f0;
      $4692=$49435;
      var $49436=$49434.f1;
      $4693=$49436;
      var $49437=$775;
      var $49438=$776;
      var $49439=$777;
      HEAP32[(($775)>>2)]=$28393;
      HEAP32[(($776)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($777)>>2)]=388;
      var $49440=HEAP32[(($775)>>2)];
      var $49441=(($49440)|0)!=0;
      if ($49441) { __label__ = 13317; break; } else { __label__ = 13319; break; }
    case 13317: // $49442
      var $49443=HEAP32[(($775)>>2)];
      var $49444=HEAP32[(($776)>>2)];
      var $49445=HEAP32[(($777)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49443, $49444, $49445) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13318; break; } else { __label__ = 14612; break; }
    case 13318: // $_noexc1823
      __label__ = 13319; break;
    case 13319: // $_ZdlPvPKci_exit1824
      var $49446=$775;
      var $49447=$776;
      var $49448=$777;
      __label__ = 13320; break;
    case 13320: // $49449
      __label__ = 14611; break;
    case 13321: // $49450
      var $49451=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49452=$49451.f0;
      $4692=$49452;
      var $49453=$49451.f1;
      $4693=$49453;
      var $49454=$772;
      var $49455=$773;
      var $49456=$774;
      HEAP32[(($772)>>2)]=$28444;
      HEAP32[(($773)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($774)>>2)]=389;
      var $49457=HEAP32[(($772)>>2)];
      var $49458=(($49457)|0)!=0;
      if ($49458) { __label__ = 13322; break; } else { __label__ = 13324; break; }
    case 13322: // $49459
      var $49460=HEAP32[(($772)>>2)];
      var $49461=HEAP32[(($773)>>2)];
      var $49462=HEAP32[(($774)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49460, $49461, $49462) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13323; break; } else { __label__ = 14612; break; }
    case 13323: // $_noexc1825
      __label__ = 13324; break;
    case 13324: // $_ZdlPvPKci_exit1826
      var $49463=$772;
      var $49464=$773;
      var $49465=$774;
      __label__ = 13325; break;
    case 13325: // $49466
      __label__ = 14611; break;
    case 13326: // $49467
      var $49468=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49469=$49468.f0;
      $4692=$49469;
      var $49470=$49468.f1;
      $4693=$49470;
      var $49471=$769;
      var $49472=$770;
      var $49473=$771;
      HEAP32[(($769)>>2)]=$28495;
      HEAP32[(($770)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($771)>>2)]=390;
      var $49474=HEAP32[(($769)>>2)];
      var $49475=(($49474)|0)!=0;
      if ($49475) { __label__ = 13327; break; } else { __label__ = 13329; break; }
    case 13327: // $49476
      var $49477=HEAP32[(($769)>>2)];
      var $49478=HEAP32[(($770)>>2)];
      var $49479=HEAP32[(($771)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49477, $49478, $49479) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13328; break; } else { __label__ = 14612; break; }
    case 13328: // $_noexc1827
      __label__ = 13329; break;
    case 13329: // $_ZdlPvPKci_exit1828
      var $49480=$769;
      var $49481=$770;
      var $49482=$771;
      __label__ = 13330; break;
    case 13330: // $49483
      __label__ = 14611; break;
    case 13331: // $49484
      var $49485=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49486=$49485.f0;
      $4692=$49486;
      var $49487=$49485.f1;
      $4693=$49487;
      var $49488=$766;
      var $49489=$767;
      var $49490=$768;
      HEAP32[(($766)>>2)]=$28546;
      HEAP32[(($767)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($768)>>2)]=391;
      var $49491=HEAP32[(($766)>>2)];
      var $49492=(($49491)|0)!=0;
      if ($49492) { __label__ = 13332; break; } else { __label__ = 13334; break; }
    case 13332: // $49493
      var $49494=HEAP32[(($766)>>2)];
      var $49495=HEAP32[(($767)>>2)];
      var $49496=HEAP32[(($768)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49494, $49495, $49496) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13333; break; } else { __label__ = 14612; break; }
    case 13333: // $_noexc1829
      __label__ = 13334; break;
    case 13334: // $_ZdlPvPKci_exit1830
      var $49497=$766;
      var $49498=$767;
      var $49499=$768;
      __label__ = 13335; break;
    case 13335: // $49500
      __label__ = 14611; break;
    case 13336: // $49501
      var $49502=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49503=$49502.f0;
      $4692=$49503;
      var $49504=$49502.f1;
      $4693=$49504;
      var $49505=$763;
      var $49506=$764;
      var $49507=$765;
      HEAP32[(($763)>>2)]=$28597;
      HEAP32[(($764)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($765)>>2)]=392;
      var $49508=HEAP32[(($763)>>2)];
      var $49509=(($49508)|0)!=0;
      if ($49509) { __label__ = 13337; break; } else { __label__ = 13339; break; }
    case 13337: // $49510
      var $49511=HEAP32[(($763)>>2)];
      var $49512=HEAP32[(($764)>>2)];
      var $49513=HEAP32[(($765)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49511, $49512, $49513) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13338; break; } else { __label__ = 14612; break; }
    case 13338: // $_noexc1831
      __label__ = 13339; break;
    case 13339: // $_ZdlPvPKci_exit1832
      var $49514=$763;
      var $49515=$764;
      var $49516=$765;
      __label__ = 13340; break;
    case 13340: // $49517
      __label__ = 14611; break;
    case 13341: // $49518
      var $49519=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49520=$49519.f0;
      $4692=$49520;
      var $49521=$49519.f1;
      $4693=$49521;
      var $49522=$760;
      var $49523=$761;
      var $49524=$762;
      HEAP32[(($760)>>2)]=$28648;
      HEAP32[(($761)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($762)>>2)]=393;
      var $49525=HEAP32[(($760)>>2)];
      var $49526=(($49525)|0)!=0;
      if ($49526) { __label__ = 13342; break; } else { __label__ = 13344; break; }
    case 13342: // $49527
      var $49528=HEAP32[(($760)>>2)];
      var $49529=HEAP32[(($761)>>2)];
      var $49530=HEAP32[(($762)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49528, $49529, $49530) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13343; break; } else { __label__ = 14612; break; }
    case 13343: // $_noexc1833
      __label__ = 13344; break;
    case 13344: // $_ZdlPvPKci_exit1834
      var $49531=$760;
      var $49532=$761;
      var $49533=$762;
      __label__ = 13345; break;
    case 13345: // $49534
      __label__ = 14611; break;
    case 13346: // $49535
      var $49536=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49537=$49536.f0;
      $4692=$49537;
      var $49538=$49536.f1;
      $4693=$49538;
      var $49539=$757;
      var $49540=$758;
      var $49541=$759;
      HEAP32[(($757)>>2)]=$28699;
      HEAP32[(($758)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($759)>>2)]=394;
      var $49542=HEAP32[(($757)>>2)];
      var $49543=(($49542)|0)!=0;
      if ($49543) { __label__ = 13347; break; } else { __label__ = 13349; break; }
    case 13347: // $49544
      var $49545=HEAP32[(($757)>>2)];
      var $49546=HEAP32[(($758)>>2)];
      var $49547=HEAP32[(($759)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49545, $49546, $49547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13348; break; } else { __label__ = 14612; break; }
    case 13348: // $_noexc1835
      __label__ = 13349; break;
    case 13349: // $_ZdlPvPKci_exit1836
      var $49548=$757;
      var $49549=$758;
      var $49550=$759;
      __label__ = 13350; break;
    case 13350: // $49551
      __label__ = 14611; break;
    case 13351: // $49552
      var $49553=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49554=$49553.f0;
      $4692=$49554;
      var $49555=$49553.f1;
      $4693=$49555;
      var $49556=$754;
      var $49557=$755;
      var $49558=$756;
      HEAP32[(($754)>>2)]=$28750;
      HEAP32[(($755)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($756)>>2)]=395;
      var $49559=HEAP32[(($754)>>2)];
      var $49560=(($49559)|0)!=0;
      if ($49560) { __label__ = 13352; break; } else { __label__ = 13354; break; }
    case 13352: // $49561
      var $49562=HEAP32[(($754)>>2)];
      var $49563=HEAP32[(($755)>>2)];
      var $49564=HEAP32[(($756)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49562, $49563, $49564) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13353; break; } else { __label__ = 14612; break; }
    case 13353: // $_noexc1837
      __label__ = 13354; break;
    case 13354: // $_ZdlPvPKci_exit1838
      var $49565=$754;
      var $49566=$755;
      var $49567=$756;
      __label__ = 13355; break;
    case 13355: // $49568
      __label__ = 14611; break;
    case 13356: // $49569
      var $49570=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49571=$49570.f0;
      $4692=$49571;
      var $49572=$49570.f1;
      $4693=$49572;
      var $49573=$751;
      var $49574=$752;
      var $49575=$753;
      HEAP32[(($751)>>2)]=$28801;
      HEAP32[(($752)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($753)>>2)]=396;
      var $49576=HEAP32[(($751)>>2)];
      var $49577=(($49576)|0)!=0;
      if ($49577) { __label__ = 13357; break; } else { __label__ = 13359; break; }
    case 13357: // $49578
      var $49579=HEAP32[(($751)>>2)];
      var $49580=HEAP32[(($752)>>2)];
      var $49581=HEAP32[(($753)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49579, $49580, $49581) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13358; break; } else { __label__ = 14612; break; }
    case 13358: // $_noexc1839
      __label__ = 13359; break;
    case 13359: // $_ZdlPvPKci_exit1840
      var $49582=$751;
      var $49583=$752;
      var $49584=$753;
      __label__ = 13360; break;
    case 13360: // $49585
      __label__ = 14611; break;
    case 13361: // $49586
      var $49587=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49588=$49587.f0;
      $4692=$49588;
      var $49589=$49587.f1;
      $4693=$49589;
      var $49590=$748;
      var $49591=$749;
      var $49592=$750;
      HEAP32[(($748)>>2)]=$28852;
      HEAP32[(($749)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($750)>>2)]=397;
      var $49593=HEAP32[(($748)>>2)];
      var $49594=(($49593)|0)!=0;
      if ($49594) { __label__ = 13362; break; } else { __label__ = 13364; break; }
    case 13362: // $49595
      var $49596=HEAP32[(($748)>>2)];
      var $49597=HEAP32[(($749)>>2)];
      var $49598=HEAP32[(($750)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49596, $49597, $49598) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13363; break; } else { __label__ = 14612; break; }
    case 13363: // $_noexc1841
      __label__ = 13364; break;
    case 13364: // $_ZdlPvPKci_exit1842
      var $49599=$748;
      var $49600=$749;
      var $49601=$750;
      __label__ = 13365; break;
    case 13365: // $49602
      __label__ = 14611; break;
    case 13366: // $49603
      var $49604=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49605=$49604.f0;
      $4692=$49605;
      var $49606=$49604.f1;
      $4693=$49606;
      var $49607=$745;
      var $49608=$746;
      var $49609=$747;
      HEAP32[(($745)>>2)]=$28903;
      HEAP32[(($746)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($747)>>2)]=398;
      var $49610=HEAP32[(($745)>>2)];
      var $49611=(($49610)|0)!=0;
      if ($49611) { __label__ = 13367; break; } else { __label__ = 13369; break; }
    case 13367: // $49612
      var $49613=HEAP32[(($745)>>2)];
      var $49614=HEAP32[(($746)>>2)];
      var $49615=HEAP32[(($747)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49613, $49614, $49615) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13368; break; } else { __label__ = 14612; break; }
    case 13368: // $_noexc1843
      __label__ = 13369; break;
    case 13369: // $_ZdlPvPKci_exit1844
      var $49616=$745;
      var $49617=$746;
      var $49618=$747;
      __label__ = 13370; break;
    case 13370: // $49619
      __label__ = 14611; break;
    case 13371: // $49620
      var $49621=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49622=$49621.f0;
      $4692=$49622;
      var $49623=$49621.f1;
      $4693=$49623;
      var $49624=$742;
      var $49625=$743;
      var $49626=$744;
      HEAP32[(($742)>>2)]=$28954;
      HEAP32[(($743)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($744)>>2)]=399;
      var $49627=HEAP32[(($742)>>2)];
      var $49628=(($49627)|0)!=0;
      if ($49628) { __label__ = 13372; break; } else { __label__ = 13374; break; }
    case 13372: // $49629
      var $49630=HEAP32[(($742)>>2)];
      var $49631=HEAP32[(($743)>>2)];
      var $49632=HEAP32[(($744)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49630, $49631, $49632) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13373; break; } else { __label__ = 14612; break; }
    case 13373: // $_noexc1845
      __label__ = 13374; break;
    case 13374: // $_ZdlPvPKci_exit1846
      var $49633=$742;
      var $49634=$743;
      var $49635=$744;
      __label__ = 13375; break;
    case 13375: // $49636
      __label__ = 14611; break;
    case 13376: // $49637
      var $49638=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49639=$49638.f0;
      $4692=$49639;
      var $49640=$49638.f1;
      $4693=$49640;
      var $49641=$739;
      var $49642=$740;
      var $49643=$741;
      HEAP32[(($739)>>2)]=$29005;
      HEAP32[(($740)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($741)>>2)]=400;
      var $49644=HEAP32[(($739)>>2)];
      var $49645=(($49644)|0)!=0;
      if ($49645) { __label__ = 13377; break; } else { __label__ = 13379; break; }
    case 13377: // $49646
      var $49647=HEAP32[(($739)>>2)];
      var $49648=HEAP32[(($740)>>2)];
      var $49649=HEAP32[(($741)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49647, $49648, $49649) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13378; break; } else { __label__ = 14612; break; }
    case 13378: // $_noexc1847
      __label__ = 13379; break;
    case 13379: // $_ZdlPvPKci_exit1848
      var $49650=$739;
      var $49651=$740;
      var $49652=$741;
      __label__ = 13380; break;
    case 13380: // $49653
      __label__ = 14611; break;
    case 13381: // $49654
      var $49655=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49656=$49655.f0;
      $4692=$49656;
      var $49657=$49655.f1;
      $4693=$49657;
      var $49658=$736;
      var $49659=$737;
      var $49660=$738;
      HEAP32[(($736)>>2)]=$29056;
      HEAP32[(($737)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($738)>>2)]=401;
      var $49661=HEAP32[(($736)>>2)];
      var $49662=(($49661)|0)!=0;
      if ($49662) { __label__ = 13382; break; } else { __label__ = 13384; break; }
    case 13382: // $49663
      var $49664=HEAP32[(($736)>>2)];
      var $49665=HEAP32[(($737)>>2)];
      var $49666=HEAP32[(($738)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49664, $49665, $49666) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13383; break; } else { __label__ = 14612; break; }
    case 13383: // $_noexc1849
      __label__ = 13384; break;
    case 13384: // $_ZdlPvPKci_exit1850
      var $49667=$736;
      var $49668=$737;
      var $49669=$738;
      __label__ = 13385; break;
    case 13385: // $49670
      __label__ = 14611; break;
    case 13386: // $49671
      var $49672=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49673=$49672.f0;
      $4692=$49673;
      var $49674=$49672.f1;
      $4693=$49674;
      var $49675=$733;
      var $49676=$734;
      var $49677=$735;
      HEAP32[(($733)>>2)]=$29107;
      HEAP32[(($734)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($735)>>2)]=402;
      var $49678=HEAP32[(($733)>>2)];
      var $49679=(($49678)|0)!=0;
      if ($49679) { __label__ = 13387; break; } else { __label__ = 13389; break; }
    case 13387: // $49680
      var $49681=HEAP32[(($733)>>2)];
      var $49682=HEAP32[(($734)>>2)];
      var $49683=HEAP32[(($735)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49681, $49682, $49683) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13388; break; } else { __label__ = 14612; break; }
    case 13388: // $_noexc1851
      __label__ = 13389; break;
    case 13389: // $_ZdlPvPKci_exit1852
      var $49684=$733;
      var $49685=$734;
      var $49686=$735;
      __label__ = 13390; break;
    case 13390: // $49687
      __label__ = 14611; break;
    case 13391: // $49688
      var $49689=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49690=$49689.f0;
      $4692=$49690;
      var $49691=$49689.f1;
      $4693=$49691;
      var $49692=$730;
      var $49693=$731;
      var $49694=$732;
      HEAP32[(($730)>>2)]=$29158;
      HEAP32[(($731)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($732)>>2)]=403;
      var $49695=HEAP32[(($730)>>2)];
      var $49696=(($49695)|0)!=0;
      if ($49696) { __label__ = 13392; break; } else { __label__ = 13394; break; }
    case 13392: // $49697
      var $49698=HEAP32[(($730)>>2)];
      var $49699=HEAP32[(($731)>>2)];
      var $49700=HEAP32[(($732)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49698, $49699, $49700) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13393; break; } else { __label__ = 14612; break; }
    case 13393: // $_noexc1853
      __label__ = 13394; break;
    case 13394: // $_ZdlPvPKci_exit1854
      var $49701=$730;
      var $49702=$731;
      var $49703=$732;
      __label__ = 13395; break;
    case 13395: // $49704
      __label__ = 14611; break;
    case 13396: // $49705
      var $49706=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49707=$49706.f0;
      $4692=$49707;
      var $49708=$49706.f1;
      $4693=$49708;
      var $49709=$727;
      var $49710=$728;
      var $49711=$729;
      HEAP32[(($727)>>2)]=$29209;
      HEAP32[(($728)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($729)>>2)]=404;
      var $49712=HEAP32[(($727)>>2)];
      var $49713=(($49712)|0)!=0;
      if ($49713) { __label__ = 13397; break; } else { __label__ = 13399; break; }
    case 13397: // $49714
      var $49715=HEAP32[(($727)>>2)];
      var $49716=HEAP32[(($728)>>2)];
      var $49717=HEAP32[(($729)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49715, $49716, $49717) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13398; break; } else { __label__ = 14612; break; }
    case 13398: // $_noexc1855
      __label__ = 13399; break;
    case 13399: // $_ZdlPvPKci_exit1856
      var $49718=$727;
      var $49719=$728;
      var $49720=$729;
      __label__ = 13400; break;
    case 13400: // $49721
      __label__ = 14611; break;
    case 13401: // $49722
      var $49723=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49724=$49723.f0;
      $4692=$49724;
      var $49725=$49723.f1;
      $4693=$49725;
      var $49726=$724;
      var $49727=$725;
      var $49728=$726;
      HEAP32[(($724)>>2)]=$29260;
      HEAP32[(($725)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($726)>>2)]=406;
      var $49729=HEAP32[(($724)>>2)];
      var $49730=(($49729)|0)!=0;
      if ($49730) { __label__ = 13402; break; } else { __label__ = 13404; break; }
    case 13402: // $49731
      var $49732=HEAP32[(($724)>>2)];
      var $49733=HEAP32[(($725)>>2)];
      var $49734=HEAP32[(($726)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49732, $49733, $49734) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13403; break; } else { __label__ = 14612; break; }
    case 13403: // $_noexc1857
      __label__ = 13404; break;
    case 13404: // $_ZdlPvPKci_exit1858
      var $49735=$724;
      var $49736=$725;
      var $49737=$726;
      __label__ = 13405; break;
    case 13405: // $49738
      __label__ = 14611; break;
    case 13406: // $49739
      var $49740=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49741=$49740.f0;
      $4692=$49741;
      var $49742=$49740.f1;
      $4693=$49742;
      var $49743=$721;
      var $49744=$722;
      var $49745=$723;
      HEAP32[(($721)>>2)]=$29311;
      HEAP32[(($722)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($723)>>2)]=407;
      var $49746=HEAP32[(($721)>>2)];
      var $49747=(($49746)|0)!=0;
      if ($49747) { __label__ = 13407; break; } else { __label__ = 13409; break; }
    case 13407: // $49748
      var $49749=HEAP32[(($721)>>2)];
      var $49750=HEAP32[(($722)>>2)];
      var $49751=HEAP32[(($723)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49749, $49750, $49751) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13408; break; } else { __label__ = 14612; break; }
    case 13408: // $_noexc1859
      __label__ = 13409; break;
    case 13409: // $_ZdlPvPKci_exit1860
      var $49752=$721;
      var $49753=$722;
      var $49754=$723;
      __label__ = 13410; break;
    case 13410: // $49755
      __label__ = 14611; break;
    case 13411: // $49756
      var $49757=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49758=$49757.f0;
      $4692=$49758;
      var $49759=$49757.f1;
      $4693=$49759;
      var $49760=$718;
      var $49761=$719;
      var $49762=$720;
      HEAP32[(($718)>>2)]=$29362;
      HEAP32[(($719)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($720)>>2)]=408;
      var $49763=HEAP32[(($718)>>2)];
      var $49764=(($49763)|0)!=0;
      if ($49764) { __label__ = 13412; break; } else { __label__ = 13414; break; }
    case 13412: // $49765
      var $49766=HEAP32[(($718)>>2)];
      var $49767=HEAP32[(($719)>>2)];
      var $49768=HEAP32[(($720)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49766, $49767, $49768) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13413; break; } else { __label__ = 14612; break; }
    case 13413: // $_noexc1861
      __label__ = 13414; break;
    case 13414: // $_ZdlPvPKci_exit1862
      var $49769=$718;
      var $49770=$719;
      var $49771=$720;
      __label__ = 13415; break;
    case 13415: // $49772
      __label__ = 14611; break;
    case 13416: // $49773
      var $49774=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49775=$49774.f0;
      $4692=$49775;
      var $49776=$49774.f1;
      $4693=$49776;
      var $49777=$715;
      var $49778=$716;
      var $49779=$717;
      HEAP32[(($715)>>2)]=$29413;
      HEAP32[(($716)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($717)>>2)]=409;
      var $49780=HEAP32[(($715)>>2)];
      var $49781=(($49780)|0)!=0;
      if ($49781) { __label__ = 13417; break; } else { __label__ = 13419; break; }
    case 13417: // $49782
      var $49783=HEAP32[(($715)>>2)];
      var $49784=HEAP32[(($716)>>2)];
      var $49785=HEAP32[(($717)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49783, $49784, $49785) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13418; break; } else { __label__ = 14612; break; }
    case 13418: // $_noexc1863
      __label__ = 13419; break;
    case 13419: // $_ZdlPvPKci_exit1864
      var $49786=$715;
      var $49787=$716;
      var $49788=$717;
      __label__ = 13420; break;
    case 13420: // $49789
      __label__ = 14611; break;
    case 13421: // $49790
      var $49791=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49792=$49791.f0;
      $4692=$49792;
      var $49793=$49791.f1;
      $4693=$49793;
      var $49794=$712;
      var $49795=$713;
      var $49796=$714;
      HEAP32[(($712)>>2)]=$29464;
      HEAP32[(($713)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($714)>>2)]=410;
      var $49797=HEAP32[(($712)>>2)];
      var $49798=(($49797)|0)!=0;
      if ($49798) { __label__ = 13422; break; } else { __label__ = 13424; break; }
    case 13422: // $49799
      var $49800=HEAP32[(($712)>>2)];
      var $49801=HEAP32[(($713)>>2)];
      var $49802=HEAP32[(($714)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49800, $49801, $49802) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13423; break; } else { __label__ = 14612; break; }
    case 13423: // $_noexc1865
      __label__ = 13424; break;
    case 13424: // $_ZdlPvPKci_exit1866
      var $49803=$712;
      var $49804=$713;
      var $49805=$714;
      __label__ = 13425; break;
    case 13425: // $49806
      __label__ = 14611; break;
    case 13426: // $49807
      var $49808=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49809=$49808.f0;
      $4692=$49809;
      var $49810=$49808.f1;
      $4693=$49810;
      var $49811=$709;
      var $49812=$710;
      var $49813=$711;
      HEAP32[(($709)>>2)]=$29515;
      HEAP32[(($710)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($711)>>2)]=411;
      var $49814=HEAP32[(($709)>>2)];
      var $49815=(($49814)|0)!=0;
      if ($49815) { __label__ = 13427; break; } else { __label__ = 13429; break; }
    case 13427: // $49816
      var $49817=HEAP32[(($709)>>2)];
      var $49818=HEAP32[(($710)>>2)];
      var $49819=HEAP32[(($711)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49817, $49818, $49819) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13428; break; } else { __label__ = 14612; break; }
    case 13428: // $_noexc1867
      __label__ = 13429; break;
    case 13429: // $_ZdlPvPKci_exit1868
      var $49820=$709;
      var $49821=$710;
      var $49822=$711;
      __label__ = 13430; break;
    case 13430: // $49823
      __label__ = 14611; break;
    case 13431: // $49824
      var $49825=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49826=$49825.f0;
      $4692=$49826;
      var $49827=$49825.f1;
      $4693=$49827;
      var $49828=$706;
      var $49829=$707;
      var $49830=$708;
      HEAP32[(($706)>>2)]=$29566;
      HEAP32[(($707)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($708)>>2)]=412;
      var $49831=HEAP32[(($706)>>2)];
      var $49832=(($49831)|0)!=0;
      if ($49832) { __label__ = 13432; break; } else { __label__ = 13434; break; }
    case 13432: // $49833
      var $49834=HEAP32[(($706)>>2)];
      var $49835=HEAP32[(($707)>>2)];
      var $49836=HEAP32[(($708)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49834, $49835, $49836) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13433; break; } else { __label__ = 14612; break; }
    case 13433: // $_noexc1869
      __label__ = 13434; break;
    case 13434: // $_ZdlPvPKci_exit1870
      var $49837=$706;
      var $49838=$707;
      var $49839=$708;
      __label__ = 13435; break;
    case 13435: // $49840
      __label__ = 14611; break;
    case 13436: // $49841
      var $49842=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49843=$49842.f0;
      $4692=$49843;
      var $49844=$49842.f1;
      $4693=$49844;
      var $49845=$703;
      var $49846=$704;
      var $49847=$705;
      HEAP32[(($703)>>2)]=$29617;
      HEAP32[(($704)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($705)>>2)]=413;
      var $49848=HEAP32[(($703)>>2)];
      var $49849=(($49848)|0)!=0;
      if ($49849) { __label__ = 13437; break; } else { __label__ = 13439; break; }
    case 13437: // $49850
      var $49851=HEAP32[(($703)>>2)];
      var $49852=HEAP32[(($704)>>2)];
      var $49853=HEAP32[(($705)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49851, $49852, $49853) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13438; break; } else { __label__ = 14612; break; }
    case 13438: // $_noexc1871
      __label__ = 13439; break;
    case 13439: // $_ZdlPvPKci_exit1872
      var $49854=$703;
      var $49855=$704;
      var $49856=$705;
      __label__ = 13440; break;
    case 13440: // $49857
      __label__ = 14611; break;
    case 13441: // $49858
      var $49859=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49860=$49859.f0;
      $4692=$49860;
      var $49861=$49859.f1;
      $4693=$49861;
      var $49862=$700;
      var $49863=$701;
      var $49864=$702;
      HEAP32[(($700)>>2)]=$29668;
      HEAP32[(($701)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($702)>>2)]=415;
      var $49865=HEAP32[(($700)>>2)];
      var $49866=(($49865)|0)!=0;
      if ($49866) { __label__ = 13442; break; } else { __label__ = 13444; break; }
    case 13442: // $49867
      var $49868=HEAP32[(($700)>>2)];
      var $49869=HEAP32[(($701)>>2)];
      var $49870=HEAP32[(($702)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49868, $49869, $49870) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13443; break; } else { __label__ = 14612; break; }
    case 13443: // $_noexc1873
      __label__ = 13444; break;
    case 13444: // $_ZdlPvPKci_exit1874
      var $49871=$700;
      var $49872=$701;
      var $49873=$702;
      __label__ = 13445; break;
    case 13445: // $49874
      __label__ = 14611; break;
    case 13446: // $49875
      var $49876=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49877=$49876.f0;
      $4692=$49877;
      var $49878=$49876.f1;
      $4693=$49878;
      var $49879=$697;
      var $49880=$698;
      var $49881=$699;
      HEAP32[(($697)>>2)]=$29719;
      HEAP32[(($698)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($699)>>2)]=416;
      var $49882=HEAP32[(($697)>>2)];
      var $49883=(($49882)|0)!=0;
      if ($49883) { __label__ = 13447; break; } else { __label__ = 13449; break; }
    case 13447: // $49884
      var $49885=HEAP32[(($697)>>2)];
      var $49886=HEAP32[(($698)>>2)];
      var $49887=HEAP32[(($699)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49885, $49886, $49887) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13448; break; } else { __label__ = 14612; break; }
    case 13448: // $_noexc1875
      __label__ = 13449; break;
    case 13449: // $_ZdlPvPKci_exit1876
      var $49888=$697;
      var $49889=$698;
      var $49890=$699;
      __label__ = 13450; break;
    case 13450: // $49891
      __label__ = 14611; break;
    case 13451: // $49892
      var $49893=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49894=$49893.f0;
      $4692=$49894;
      var $49895=$49893.f1;
      $4693=$49895;
      var $49896=$694;
      var $49897=$695;
      var $49898=$696;
      HEAP32[(($694)>>2)]=$29770;
      HEAP32[(($695)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($696)>>2)]=417;
      var $49899=HEAP32[(($694)>>2)];
      var $49900=(($49899)|0)!=0;
      if ($49900) { __label__ = 13452; break; } else { __label__ = 13454; break; }
    case 13452: // $49901
      var $49902=HEAP32[(($694)>>2)];
      var $49903=HEAP32[(($695)>>2)];
      var $49904=HEAP32[(($696)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49902, $49903, $49904) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13453; break; } else { __label__ = 14612; break; }
    case 13453: // $_noexc1877
      __label__ = 13454; break;
    case 13454: // $_ZdlPvPKci_exit1878
      var $49905=$694;
      var $49906=$695;
      var $49907=$696;
      __label__ = 13455; break;
    case 13455: // $49908
      __label__ = 14611; break;
    case 13456: // $49909
      var $49910=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49911=$49910.f0;
      $4692=$49911;
      var $49912=$49910.f1;
      $4693=$49912;
      var $49913=$691;
      var $49914=$692;
      var $49915=$693;
      HEAP32[(($691)>>2)]=$29821;
      HEAP32[(($692)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($693)>>2)]=418;
      var $49916=HEAP32[(($691)>>2)];
      var $49917=(($49916)|0)!=0;
      if ($49917) { __label__ = 13457; break; } else { __label__ = 13459; break; }
    case 13457: // $49918
      var $49919=HEAP32[(($691)>>2)];
      var $49920=HEAP32[(($692)>>2)];
      var $49921=HEAP32[(($693)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49919, $49920, $49921) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13458; break; } else { __label__ = 14612; break; }
    case 13458: // $_noexc1879
      __label__ = 13459; break;
    case 13459: // $_ZdlPvPKci_exit1880
      var $49922=$691;
      var $49923=$692;
      var $49924=$693;
      __label__ = 13460; break;
    case 13460: // $49925
      __label__ = 14611; break;
    case 13461: // $49926
      var $49927=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49928=$49927.f0;
      $4692=$49928;
      var $49929=$49927.f1;
      $4693=$49929;
      var $49930=$688;
      var $49931=$689;
      var $49932=$690;
      HEAP32[(($688)>>2)]=$29872;
      HEAP32[(($689)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($690)>>2)]=419;
      var $49933=HEAP32[(($688)>>2)];
      var $49934=(($49933)|0)!=0;
      if ($49934) { __label__ = 13462; break; } else { __label__ = 13464; break; }
    case 13462: // $49935
      var $49936=HEAP32[(($688)>>2)];
      var $49937=HEAP32[(($689)>>2)];
      var $49938=HEAP32[(($690)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49936, $49937, $49938) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13463; break; } else { __label__ = 14612; break; }
    case 13463: // $_noexc1881
      __label__ = 13464; break;
    case 13464: // $_ZdlPvPKci_exit1882
      var $49939=$688;
      var $49940=$689;
      var $49941=$690;
      __label__ = 13465; break;
    case 13465: // $49942
      __label__ = 14611; break;
    case 13466: // $49943
      var $49944=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49945=$49944.f0;
      $4692=$49945;
      var $49946=$49944.f1;
      $4693=$49946;
      var $49947=$685;
      var $49948=$686;
      var $49949=$687;
      HEAP32[(($685)>>2)]=$29923;
      HEAP32[(($686)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($687)>>2)]=420;
      var $49950=HEAP32[(($685)>>2)];
      var $49951=(($49950)|0)!=0;
      if ($49951) { __label__ = 13467; break; } else { __label__ = 13469; break; }
    case 13467: // $49952
      var $49953=HEAP32[(($685)>>2)];
      var $49954=HEAP32[(($686)>>2)];
      var $49955=HEAP32[(($687)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49953, $49954, $49955) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13468; break; } else { __label__ = 14612; break; }
    case 13468: // $_noexc1883
      __label__ = 13469; break;
    case 13469: // $_ZdlPvPKci_exit1884
      var $49956=$685;
      var $49957=$686;
      var $49958=$687;
      __label__ = 13470; break;
    case 13470: // $49959
      __label__ = 14611; break;
    case 13471: // $49960
      var $49961=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49962=$49961.f0;
      $4692=$49962;
      var $49963=$49961.f1;
      $4693=$49963;
      var $49964=$682;
      var $49965=$683;
      var $49966=$684;
      HEAP32[(($682)>>2)]=$29974;
      HEAP32[(($683)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($684)>>2)]=421;
      var $49967=HEAP32[(($682)>>2)];
      var $49968=(($49967)|0)!=0;
      if ($49968) { __label__ = 13472; break; } else { __label__ = 13474; break; }
    case 13472: // $49969
      var $49970=HEAP32[(($682)>>2)];
      var $49971=HEAP32[(($683)>>2)];
      var $49972=HEAP32[(($684)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49970, $49971, $49972) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13473; break; } else { __label__ = 14612; break; }
    case 13473: // $_noexc1885
      __label__ = 13474; break;
    case 13474: // $_ZdlPvPKci_exit1886
      var $49973=$682;
      var $49974=$683;
      var $49975=$684;
      __label__ = 13475; break;
    case 13475: // $49976
      __label__ = 14611; break;
    case 13476: // $49977
      var $49978=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49979=$49978.f0;
      $4692=$49979;
      var $49980=$49978.f1;
      $4693=$49980;
      var $49981=$679;
      var $49982=$680;
      var $49983=$681;
      HEAP32[(($679)>>2)]=$30025;
      HEAP32[(($680)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($681)>>2)]=422;
      var $49984=HEAP32[(($679)>>2)];
      var $49985=(($49984)|0)!=0;
      if ($49985) { __label__ = 13477; break; } else { __label__ = 13479; break; }
    case 13477: // $49986
      var $49987=HEAP32[(($679)>>2)];
      var $49988=HEAP32[(($680)>>2)];
      var $49989=HEAP32[(($681)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($49987, $49988, $49989) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13478; break; } else { __label__ = 14612; break; }
    case 13478: // $_noexc1887
      __label__ = 13479; break;
    case 13479: // $_ZdlPvPKci_exit1888
      var $49990=$679;
      var $49991=$680;
      var $49992=$681;
      __label__ = 13480; break;
    case 13480: // $49993
      __label__ = 14611; break;
    case 13481: // $49994
      var $49995=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49996=$49995.f0;
      $4692=$49996;
      var $49997=$49995.f1;
      $4693=$49997;
      var $49998=$676;
      var $49999=$677;
      var $50000=$678;
      HEAP32[(($676)>>2)]=$30076;
      HEAP32[(($677)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($678)>>2)]=423;
      var $50001=HEAP32[(($676)>>2)];
      var $50002=(($50001)|0)!=0;
      if ($50002) { __label__ = 13482; break; } else { __label__ = 13484; break; }
    case 13482: // $50003
      var $50004=HEAP32[(($676)>>2)];
      var $50005=HEAP32[(($677)>>2)];
      var $50006=HEAP32[(($678)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50004, $50005, $50006) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13483; break; } else { __label__ = 14612; break; }
    case 13483: // $_noexc1889
      __label__ = 13484; break;
    case 13484: // $_ZdlPvPKci_exit1890
      var $50007=$676;
      var $50008=$677;
      var $50009=$678;
      __label__ = 13485; break;
    case 13485: // $50010
      __label__ = 14611; break;
    case 13486: // $50011
      var $50012=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50013=$50012.f0;
      $4692=$50013;
      var $50014=$50012.f1;
      $4693=$50014;
      var $50015=$673;
      var $50016=$674;
      var $50017=$675;
      HEAP32[(($673)>>2)]=$30127;
      HEAP32[(($674)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($675)>>2)]=424;
      var $50018=HEAP32[(($673)>>2)];
      var $50019=(($50018)|0)!=0;
      if ($50019) { __label__ = 13487; break; } else { __label__ = 13489; break; }
    case 13487: // $50020
      var $50021=HEAP32[(($673)>>2)];
      var $50022=HEAP32[(($674)>>2)];
      var $50023=HEAP32[(($675)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50021, $50022, $50023) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13488; break; } else { __label__ = 14612; break; }
    case 13488: // $_noexc1891
      __label__ = 13489; break;
    case 13489: // $_ZdlPvPKci_exit1892
      var $50024=$673;
      var $50025=$674;
      var $50026=$675;
      __label__ = 13490; break;
    case 13490: // $50027
      __label__ = 14611; break;
    case 13491: // $50028
      var $50029=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50030=$50029.f0;
      $4692=$50030;
      var $50031=$50029.f1;
      $4693=$50031;
      var $50032=$670;
      var $50033=$671;
      var $50034=$672;
      HEAP32[(($670)>>2)]=$30178;
      HEAP32[(($671)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($672)>>2)]=425;
      var $50035=HEAP32[(($670)>>2)];
      var $50036=(($50035)|0)!=0;
      if ($50036) { __label__ = 13492; break; } else { __label__ = 13494; break; }
    case 13492: // $50037
      var $50038=HEAP32[(($670)>>2)];
      var $50039=HEAP32[(($671)>>2)];
      var $50040=HEAP32[(($672)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50038, $50039, $50040) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13493; break; } else { __label__ = 14612; break; }
    case 13493: // $_noexc1893
      __label__ = 13494; break;
    case 13494: // $_ZdlPvPKci_exit1894
      var $50041=$670;
      var $50042=$671;
      var $50043=$672;
      __label__ = 13495; break;
    case 13495: // $50044
      __label__ = 14611; break;
    case 13496: // $50045
      var $50046=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50047=$50046.f0;
      $4692=$50047;
      var $50048=$50046.f1;
      $4693=$50048;
      var $50049=$667;
      var $50050=$668;
      var $50051=$669;
      HEAP32[(($667)>>2)]=$30229;
      HEAP32[(($668)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($669)>>2)]=426;
      var $50052=HEAP32[(($667)>>2)];
      var $50053=(($50052)|0)!=0;
      if ($50053) { __label__ = 13497; break; } else { __label__ = 13499; break; }
    case 13497: // $50054
      var $50055=HEAP32[(($667)>>2)];
      var $50056=HEAP32[(($668)>>2)];
      var $50057=HEAP32[(($669)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50055, $50056, $50057) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13498; break; } else { __label__ = 14612; break; }
    case 13498: // $_noexc1895
      __label__ = 13499; break;
    case 13499: // $_ZdlPvPKci_exit1896
      var $50058=$667;
      var $50059=$668;
      var $50060=$669;
      __label__ = 13500; break;
    case 13500: // $50061
      __label__ = 14611; break;
    case 13501: // $50062
      var $50063=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50064=$50063.f0;
      $4692=$50064;
      var $50065=$50063.f1;
      $4693=$50065;
      var $50066=$664;
      var $50067=$665;
      var $50068=$666;
      HEAP32[(($664)>>2)]=$30280;
      HEAP32[(($665)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($666)>>2)]=427;
      var $50069=HEAP32[(($664)>>2)];
      var $50070=(($50069)|0)!=0;
      if ($50070) { __label__ = 13502; break; } else { __label__ = 13504; break; }
    case 13502: // $50071
      var $50072=HEAP32[(($664)>>2)];
      var $50073=HEAP32[(($665)>>2)];
      var $50074=HEAP32[(($666)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50072, $50073, $50074) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13503; break; } else { __label__ = 14612; break; }
    case 13503: // $_noexc1897
      __label__ = 13504; break;
    case 13504: // $_ZdlPvPKci_exit1898
      var $50075=$664;
      var $50076=$665;
      var $50077=$666;
      __label__ = 13505; break;
    case 13505: // $50078
      __label__ = 14611; break;
    case 13506: // $50079
      var $50080=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50081=$50080.f0;
      $4692=$50081;
      var $50082=$50080.f1;
      $4693=$50082;
      var $50083=$661;
      var $50084=$662;
      var $50085=$663;
      HEAP32[(($661)>>2)]=$30331;
      HEAP32[(($662)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($663)>>2)]=429;
      var $50086=HEAP32[(($661)>>2)];
      var $50087=(($50086)|0)!=0;
      if ($50087) { __label__ = 13507; break; } else { __label__ = 13509; break; }
    case 13507: // $50088
      var $50089=HEAP32[(($661)>>2)];
      var $50090=HEAP32[(($662)>>2)];
      var $50091=HEAP32[(($663)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50089, $50090, $50091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13508; break; } else { __label__ = 14612; break; }
    case 13508: // $_noexc1899
      __label__ = 13509; break;
    case 13509: // $_ZdlPvPKci_exit1900
      var $50092=$661;
      var $50093=$662;
      var $50094=$663;
      __label__ = 13510; break;
    case 13510: // $50095
      __label__ = 14611; break;
    case 13511: // $50096
      var $50097=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50098=$50097.f0;
      $4692=$50098;
      var $50099=$50097.f1;
      $4693=$50099;
      var $50100=$658;
      var $50101=$659;
      var $50102=$660;
      HEAP32[(($658)>>2)]=$30382;
      HEAP32[(($659)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($660)>>2)]=430;
      var $50103=HEAP32[(($658)>>2)];
      var $50104=(($50103)|0)!=0;
      if ($50104) { __label__ = 13512; break; } else { __label__ = 13514; break; }
    case 13512: // $50105
      var $50106=HEAP32[(($658)>>2)];
      var $50107=HEAP32[(($659)>>2)];
      var $50108=HEAP32[(($660)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50106, $50107, $50108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13513; break; } else { __label__ = 14612; break; }
    case 13513: // $_noexc1901
      __label__ = 13514; break;
    case 13514: // $_ZdlPvPKci_exit1902
      var $50109=$658;
      var $50110=$659;
      var $50111=$660;
      __label__ = 13515; break;
    case 13515: // $50112
      __label__ = 14611; break;
    case 13516: // $50113
      var $50114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50115=$50114.f0;
      $4692=$50115;
      var $50116=$50114.f1;
      $4693=$50116;
      var $50117=$655;
      var $50118=$656;
      var $50119=$657;
      HEAP32[(($655)>>2)]=$30433;
      HEAP32[(($656)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($657)>>2)]=431;
      var $50120=HEAP32[(($655)>>2)];
      var $50121=(($50120)|0)!=0;
      if ($50121) { __label__ = 13517; break; } else { __label__ = 13519; break; }
    case 13517: // $50122
      var $50123=HEAP32[(($655)>>2)];
      var $50124=HEAP32[(($656)>>2)];
      var $50125=HEAP32[(($657)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50123, $50124, $50125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13518; break; } else { __label__ = 14612; break; }
    case 13518: // $_noexc1903
      __label__ = 13519; break;
    case 13519: // $_ZdlPvPKci_exit1904
      var $50126=$655;
      var $50127=$656;
      var $50128=$657;
      __label__ = 13520; break;
    case 13520: // $50129
      __label__ = 14611; break;
    case 13521: // $50130
      var $50131=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50132=$50131.f0;
      $4692=$50132;
      var $50133=$50131.f1;
      $4693=$50133;
      var $50134=$652;
      var $50135=$653;
      var $50136=$654;
      HEAP32[(($652)>>2)]=$30484;
      HEAP32[(($653)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($654)>>2)]=432;
      var $50137=HEAP32[(($652)>>2)];
      var $50138=(($50137)|0)!=0;
      if ($50138) { __label__ = 13522; break; } else { __label__ = 13524; break; }
    case 13522: // $50139
      var $50140=HEAP32[(($652)>>2)];
      var $50141=HEAP32[(($653)>>2)];
      var $50142=HEAP32[(($654)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50140, $50141, $50142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13523; break; } else { __label__ = 14612; break; }
    case 13523: // $_noexc1905
      __label__ = 13524; break;
    case 13524: // $_ZdlPvPKci_exit1906
      var $50143=$652;
      var $50144=$653;
      var $50145=$654;
      __label__ = 13525; break;
    case 13525: // $50146
      __label__ = 14611; break;
    case 13526: // $50147
      var $50148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50149=$50148.f0;
      $4692=$50149;
      var $50150=$50148.f1;
      $4693=$50150;
      var $50151=$649;
      var $50152=$650;
      var $50153=$651;
      HEAP32[(($649)>>2)]=$30535;
      HEAP32[(($650)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($651)>>2)]=434;
      var $50154=HEAP32[(($649)>>2)];
      var $50155=(($50154)|0)!=0;
      if ($50155) { __label__ = 13527; break; } else { __label__ = 13529; break; }
    case 13527: // $50156
      var $50157=HEAP32[(($649)>>2)];
      var $50158=HEAP32[(($650)>>2)];
      var $50159=HEAP32[(($651)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50157, $50158, $50159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13528; break; } else { __label__ = 14612; break; }
    case 13528: // $_noexc1907
      __label__ = 13529; break;
    case 13529: // $_ZdlPvPKci_exit1908
      var $50160=$649;
      var $50161=$650;
      var $50162=$651;
      __label__ = 13530; break;
    case 13530: // $50163
      __label__ = 14611; break;
    case 13531: // $50164
      var $50165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50166=$50165.f0;
      $4692=$50166;
      var $50167=$50165.f1;
      $4693=$50167;
      var $50168=$646;
      var $50169=$647;
      var $50170=$648;
      HEAP32[(($646)>>2)]=$30586;
      HEAP32[(($647)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($648)>>2)]=435;
      var $50171=HEAP32[(($646)>>2)];
      var $50172=(($50171)|0)!=0;
      if ($50172) { __label__ = 13532; break; } else { __label__ = 13534; break; }
    case 13532: // $50173
      var $50174=HEAP32[(($646)>>2)];
      var $50175=HEAP32[(($647)>>2)];
      var $50176=HEAP32[(($648)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50174, $50175, $50176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13533; break; } else { __label__ = 14612; break; }
    case 13533: // $_noexc1909
      __label__ = 13534; break;
    case 13534: // $_ZdlPvPKci_exit1910
      var $50177=$646;
      var $50178=$647;
      var $50179=$648;
      __label__ = 13535; break;
    case 13535: // $50180
      __label__ = 14611; break;
    case 13536: // $50181
      var $50182=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50183=$50182.f0;
      $4692=$50183;
      var $50184=$50182.f1;
      $4693=$50184;
      var $50185=$643;
      var $50186=$644;
      var $50187=$645;
      HEAP32[(($643)>>2)]=$30637;
      HEAP32[(($644)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($645)>>2)]=436;
      var $50188=HEAP32[(($643)>>2)];
      var $50189=(($50188)|0)!=0;
      if ($50189) { __label__ = 13537; break; } else { __label__ = 13539; break; }
    case 13537: // $50190
      var $50191=HEAP32[(($643)>>2)];
      var $50192=HEAP32[(($644)>>2)];
      var $50193=HEAP32[(($645)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50191, $50192, $50193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13538; break; } else { __label__ = 14612; break; }
    case 13538: // $_noexc1911
      __label__ = 13539; break;
    case 13539: // $_ZdlPvPKci_exit1912
      var $50194=$643;
      var $50195=$644;
      var $50196=$645;
      __label__ = 13540; break;
    case 13540: // $50197
      __label__ = 14611; break;
    case 13541: // $50198
      var $50199=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50200=$50199.f0;
      $4692=$50200;
      var $50201=$50199.f1;
      $4693=$50201;
      var $50202=$640;
      var $50203=$641;
      var $50204=$642;
      HEAP32[(($640)>>2)]=$30688;
      HEAP32[(($641)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($642)>>2)]=437;
      var $50205=HEAP32[(($640)>>2)];
      var $50206=(($50205)|0)!=0;
      if ($50206) { __label__ = 13542; break; } else { __label__ = 13544; break; }
    case 13542: // $50207
      var $50208=HEAP32[(($640)>>2)];
      var $50209=HEAP32[(($641)>>2)];
      var $50210=HEAP32[(($642)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50208, $50209, $50210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13543; break; } else { __label__ = 14612; break; }
    case 13543: // $_noexc1913
      __label__ = 13544; break;
    case 13544: // $_ZdlPvPKci_exit1914
      var $50211=$640;
      var $50212=$641;
      var $50213=$642;
      __label__ = 13545; break;
    case 13545: // $50214
      __label__ = 14611; break;
    case 13546: // $50215
      var $50216=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50217=$50216.f0;
      $4692=$50217;
      var $50218=$50216.f1;
      $4693=$50218;
      var $50219=$637;
      var $50220=$638;
      var $50221=$639;
      HEAP32[(($637)>>2)]=$30739;
      HEAP32[(($638)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($639)>>2)]=439;
      var $50222=HEAP32[(($637)>>2)];
      var $50223=(($50222)|0)!=0;
      if ($50223) { __label__ = 13547; break; } else { __label__ = 13549; break; }
    case 13547: // $50224
      var $50225=HEAP32[(($637)>>2)];
      var $50226=HEAP32[(($638)>>2)];
      var $50227=HEAP32[(($639)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50225, $50226, $50227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13548; break; } else { __label__ = 14612; break; }
    case 13548: // $_noexc1915
      __label__ = 13549; break;
    case 13549: // $_ZdlPvPKci_exit1916
      var $50228=$637;
      var $50229=$638;
      var $50230=$639;
      __label__ = 13550; break;
    case 13550: // $50231
      __label__ = 14611; break;
    case 13551: // $50232
      var $50233=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50234=$50233.f0;
      $4692=$50234;
      var $50235=$50233.f1;
      $4693=$50235;
      var $50236=$634;
      var $50237=$635;
      var $50238=$636;
      HEAP32[(($634)>>2)]=$30790;
      HEAP32[(($635)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($636)>>2)]=440;
      var $50239=HEAP32[(($634)>>2)];
      var $50240=(($50239)|0)!=0;
      if ($50240) { __label__ = 13552; break; } else { __label__ = 13554; break; }
    case 13552: // $50241
      var $50242=HEAP32[(($634)>>2)];
      var $50243=HEAP32[(($635)>>2)];
      var $50244=HEAP32[(($636)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50242, $50243, $50244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13553; break; } else { __label__ = 14612; break; }
    case 13553: // $_noexc1917
      __label__ = 13554; break;
    case 13554: // $_ZdlPvPKci_exit1918
      var $50245=$634;
      var $50246=$635;
      var $50247=$636;
      __label__ = 13555; break;
    case 13555: // $50248
      __label__ = 14611; break;
    case 13556: // $50249
      var $50250=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50251=$50250.f0;
      $4692=$50251;
      var $50252=$50250.f1;
      $4693=$50252;
      var $50253=$631;
      var $50254=$632;
      var $50255=$633;
      HEAP32[(($631)>>2)]=$30841;
      HEAP32[(($632)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($633)>>2)]=441;
      var $50256=HEAP32[(($631)>>2)];
      var $50257=(($50256)|0)!=0;
      if ($50257) { __label__ = 13557; break; } else { __label__ = 13559; break; }
    case 13557: // $50258
      var $50259=HEAP32[(($631)>>2)];
      var $50260=HEAP32[(($632)>>2)];
      var $50261=HEAP32[(($633)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50259, $50260, $50261) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13558; break; } else { __label__ = 14612; break; }
    case 13558: // $_noexc1919
      __label__ = 13559; break;
    case 13559: // $_ZdlPvPKci_exit1920
      var $50262=$631;
      var $50263=$632;
      var $50264=$633;
      __label__ = 13560; break;
    case 13560: // $50265
      __label__ = 14611; break;
    case 13561: // $50266
      var $50267=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50268=$50267.f0;
      $4692=$50268;
      var $50269=$50267.f1;
      $4693=$50269;
      var $50270=$628;
      var $50271=$629;
      var $50272=$630;
      HEAP32[(($628)>>2)]=$30892;
      HEAP32[(($629)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($630)>>2)]=442;
      var $50273=HEAP32[(($628)>>2)];
      var $50274=(($50273)|0)!=0;
      if ($50274) { __label__ = 13562; break; } else { __label__ = 13564; break; }
    case 13562: // $50275
      var $50276=HEAP32[(($628)>>2)];
      var $50277=HEAP32[(($629)>>2)];
      var $50278=HEAP32[(($630)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50276, $50277, $50278) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13563; break; } else { __label__ = 14612; break; }
    case 13563: // $_noexc1921
      __label__ = 13564; break;
    case 13564: // $_ZdlPvPKci_exit1922
      var $50279=$628;
      var $50280=$629;
      var $50281=$630;
      __label__ = 13565; break;
    case 13565: // $50282
      __label__ = 14611; break;
    case 13566: // $50283
      var $50284=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50285=$50284.f0;
      $4692=$50285;
      var $50286=$50284.f1;
      $4693=$50286;
      var $50287=$625;
      var $50288=$626;
      var $50289=$627;
      HEAP32[(($625)>>2)]=$30943;
      HEAP32[(($626)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($627)>>2)]=443;
      var $50290=HEAP32[(($625)>>2)];
      var $50291=(($50290)|0)!=0;
      if ($50291) { __label__ = 13567; break; } else { __label__ = 13569; break; }
    case 13567: // $50292
      var $50293=HEAP32[(($625)>>2)];
      var $50294=HEAP32[(($626)>>2)];
      var $50295=HEAP32[(($627)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50293, $50294, $50295) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13568; break; } else { __label__ = 14612; break; }
    case 13568: // $_noexc1923
      __label__ = 13569; break;
    case 13569: // $_ZdlPvPKci_exit1924
      var $50296=$625;
      var $50297=$626;
      var $50298=$627;
      __label__ = 13570; break;
    case 13570: // $50299
      __label__ = 14611; break;
    case 13571: // $50300
      var $50301=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50302=$50301.f0;
      $4692=$50302;
      var $50303=$50301.f1;
      $4693=$50303;
      var $50304=$622;
      var $50305=$623;
      var $50306=$624;
      HEAP32[(($622)>>2)]=$30994;
      HEAP32[(($623)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($624)>>2)]=445;
      var $50307=HEAP32[(($622)>>2)];
      var $50308=(($50307)|0)!=0;
      if ($50308) { __label__ = 13572; break; } else { __label__ = 13574; break; }
    case 13572: // $50309
      var $50310=HEAP32[(($622)>>2)];
      var $50311=HEAP32[(($623)>>2)];
      var $50312=HEAP32[(($624)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50310, $50311, $50312) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13573; break; } else { __label__ = 14612; break; }
    case 13573: // $_noexc1925
      __label__ = 13574; break;
    case 13574: // $_ZdlPvPKci_exit1926
      var $50313=$622;
      var $50314=$623;
      var $50315=$624;
      __label__ = 13575; break;
    case 13575: // $50316
      __label__ = 14611; break;
    case 13576: // $50317
      var $50318=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50319=$50318.f0;
      $4692=$50319;
      var $50320=$50318.f1;
      $4693=$50320;
      var $50321=$619;
      var $50322=$620;
      var $50323=$621;
      HEAP32[(($619)>>2)]=$31061;
      HEAP32[(($620)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($621)>>2)]=446;
      var $50324=HEAP32[(($619)>>2)];
      var $50325=(($50324)|0)!=0;
      if ($50325) { __label__ = 13577; break; } else { __label__ = 13579; break; }
    case 13577: // $50326
      var $50327=HEAP32[(($619)>>2)];
      var $50328=HEAP32[(($620)>>2)];
      var $50329=HEAP32[(($621)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50327, $50328, $50329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13578; break; } else { __label__ = 14612; break; }
    case 13578: // $_noexc1927
      __label__ = 13579; break;
    case 13579: // $_ZdlPvPKci_exit1928
      var $50330=$619;
      var $50331=$620;
      var $50332=$621;
      __label__ = 13580; break;
    case 13580: // $50333
      __label__ = 14611; break;
    case 13581: // $50334
      var $50335=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50336=$50335.f0;
      $4692=$50336;
      var $50337=$50335.f1;
      $4693=$50337;
      var $50338=$616;
      var $50339=$617;
      var $50340=$618;
      HEAP32[(($616)>>2)]=$31128;
      HEAP32[(($617)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($618)>>2)]=447;
      var $50341=HEAP32[(($616)>>2)];
      var $50342=(($50341)|0)!=0;
      if ($50342) { __label__ = 13582; break; } else { __label__ = 13584; break; }
    case 13582: // $50343
      var $50344=HEAP32[(($616)>>2)];
      var $50345=HEAP32[(($617)>>2)];
      var $50346=HEAP32[(($618)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50344, $50345, $50346) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13583; break; } else { __label__ = 14612; break; }
    case 13583: // $_noexc1929
      __label__ = 13584; break;
    case 13584: // $_ZdlPvPKci_exit1930
      var $50347=$616;
      var $50348=$617;
      var $50349=$618;
      __label__ = 13585; break;
    case 13585: // $50350
      __label__ = 14611; break;
    case 13586: // $50351
      var $50352=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50353=$50352.f0;
      $4692=$50353;
      var $50354=$50352.f1;
      $4693=$50354;
      var $50355=$613;
      var $50356=$614;
      var $50357=$615;
      HEAP32[(($613)>>2)]=$31195;
      HEAP32[(($614)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($615)>>2)]=448;
      var $50358=HEAP32[(($613)>>2)];
      var $50359=(($50358)|0)!=0;
      if ($50359) { __label__ = 13587; break; } else { __label__ = 13589; break; }
    case 13587: // $50360
      var $50361=HEAP32[(($613)>>2)];
      var $50362=HEAP32[(($614)>>2)];
      var $50363=HEAP32[(($615)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50361, $50362, $50363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13588; break; } else { __label__ = 14612; break; }
    case 13588: // $_noexc1931
      __label__ = 13589; break;
    case 13589: // $_ZdlPvPKci_exit1932
      var $50364=$613;
      var $50365=$614;
      var $50366=$615;
      __label__ = 13590; break;
    case 13590: // $50367
      __label__ = 14611; break;
    case 13591: // $50368
      var $50369=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50370=$50369.f0;
      $4692=$50370;
      var $50371=$50369.f1;
      $4693=$50371;
      var $50372=$610;
      var $50373=$611;
      var $50374=$612;
      HEAP32[(($610)>>2)]=$31262;
      HEAP32[(($611)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($612)>>2)]=449;
      var $50375=HEAP32[(($610)>>2)];
      var $50376=(($50375)|0)!=0;
      if ($50376) { __label__ = 13592; break; } else { __label__ = 13594; break; }
    case 13592: // $50377
      var $50378=HEAP32[(($610)>>2)];
      var $50379=HEAP32[(($611)>>2)];
      var $50380=HEAP32[(($612)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50378, $50379, $50380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13593; break; } else { __label__ = 14612; break; }
    case 13593: // $_noexc1933
      __label__ = 13594; break;
    case 13594: // $_ZdlPvPKci_exit1934
      var $50381=$610;
      var $50382=$611;
      var $50383=$612;
      __label__ = 13595; break;
    case 13595: // $50384
      __label__ = 14611; break;
    case 13596: // $50385
      var $50386=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50387=$50386.f0;
      $4692=$50387;
      var $50388=$50386.f1;
      $4693=$50388;
      var $50389=$607;
      var $50390=$608;
      var $50391=$609;
      HEAP32[(($607)>>2)]=$31329;
      HEAP32[(($608)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($609)>>2)]=450;
      var $50392=HEAP32[(($607)>>2)];
      var $50393=(($50392)|0)!=0;
      if ($50393) { __label__ = 13597; break; } else { __label__ = 13599; break; }
    case 13597: // $50394
      var $50395=HEAP32[(($607)>>2)];
      var $50396=HEAP32[(($608)>>2)];
      var $50397=HEAP32[(($609)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50395, $50396, $50397) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13598; break; } else { __label__ = 14612; break; }
    case 13598: // $_noexc1935
      __label__ = 13599; break;
    case 13599: // $_ZdlPvPKci_exit1936
      var $50398=$607;
      var $50399=$608;
      var $50400=$609;
      __label__ = 13600; break;
    case 13600: // $50401
      __label__ = 14611; break;
    case 13601: // $50402
      var $50403=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50404=$50403.f0;
      $4692=$50404;
      var $50405=$50403.f1;
      $4693=$50405;
      var $50406=$604;
      var $50407=$605;
      var $50408=$606;
      HEAP32[(($604)>>2)]=$31396;
      HEAP32[(($605)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($606)>>2)]=451;
      var $50409=HEAP32[(($604)>>2)];
      var $50410=(($50409)|0)!=0;
      if ($50410) { __label__ = 13602; break; } else { __label__ = 13604; break; }
    case 13602: // $50411
      var $50412=HEAP32[(($604)>>2)];
      var $50413=HEAP32[(($605)>>2)];
      var $50414=HEAP32[(($606)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50412, $50413, $50414) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13603; break; } else { __label__ = 14612; break; }
    case 13603: // $_noexc1937
      __label__ = 13604; break;
    case 13604: // $_ZdlPvPKci_exit1938
      var $50415=$604;
      var $50416=$605;
      var $50417=$606;
      __label__ = 13605; break;
    case 13605: // $50418
      __label__ = 14611; break;
    case 13606: // $50419
      var $50420=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50421=$50420.f0;
      $4692=$50421;
      var $50422=$50420.f1;
      $4693=$50422;
      var $50423=$601;
      var $50424=$602;
      var $50425=$603;
      HEAP32[(($601)>>2)]=$31463;
      HEAP32[(($602)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($603)>>2)]=452;
      var $50426=HEAP32[(($601)>>2)];
      var $50427=(($50426)|0)!=0;
      if ($50427) { __label__ = 13607; break; } else { __label__ = 13609; break; }
    case 13607: // $50428
      var $50429=HEAP32[(($601)>>2)];
      var $50430=HEAP32[(($602)>>2)];
      var $50431=HEAP32[(($603)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50429, $50430, $50431) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13608; break; } else { __label__ = 14612; break; }
    case 13608: // $_noexc1939
      __label__ = 13609; break;
    case 13609: // $_ZdlPvPKci_exit1940
      var $50432=$601;
      var $50433=$602;
      var $50434=$603;
      __label__ = 13610; break;
    case 13610: // $50435
      __label__ = 14611; break;
    case 13611: // $50436
      var $50437=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50438=$50437.f0;
      $4692=$50438;
      var $50439=$50437.f1;
      $4693=$50439;
      var $50440=$598;
      var $50441=$599;
      var $50442=$600;
      HEAP32[(($598)>>2)]=$31530;
      HEAP32[(($599)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($600)>>2)]=454;
      var $50443=HEAP32[(($598)>>2)];
      var $50444=(($50443)|0)!=0;
      if ($50444) { __label__ = 13612; break; } else { __label__ = 13614; break; }
    case 13612: // $50445
      var $50446=HEAP32[(($598)>>2)];
      var $50447=HEAP32[(($599)>>2)];
      var $50448=HEAP32[(($600)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50446, $50447, $50448) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13613; break; } else { __label__ = 14612; break; }
    case 13613: // $_noexc1941
      __label__ = 13614; break;
    case 13614: // $_ZdlPvPKci_exit1942
      var $50449=$598;
      var $50450=$599;
      var $50451=$600;
      __label__ = 13615; break;
    case 13615: // $50452
      __label__ = 14611; break;
    case 13616: // $50453
      var $50454=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50455=$50454.f0;
      $4692=$50455;
      var $50456=$50454.f1;
      $4693=$50456;
      var $50457=$595;
      var $50458=$596;
      var $50459=$597;
      HEAP32[(($595)>>2)]=$31597;
      HEAP32[(($596)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($597)>>2)]=455;
      var $50460=HEAP32[(($595)>>2)];
      var $50461=(($50460)|0)!=0;
      if ($50461) { __label__ = 13617; break; } else { __label__ = 13619; break; }
    case 13617: // $50462
      var $50463=HEAP32[(($595)>>2)];
      var $50464=HEAP32[(($596)>>2)];
      var $50465=HEAP32[(($597)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50463, $50464, $50465) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13618; break; } else { __label__ = 14612; break; }
    case 13618: // $_noexc1943
      __label__ = 13619; break;
    case 13619: // $_ZdlPvPKci_exit1944
      var $50466=$595;
      var $50467=$596;
      var $50468=$597;
      __label__ = 13620; break;
    case 13620: // $50469
      __label__ = 14611; break;
    case 13621: // $50470
      var $50471=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50472=$50471.f0;
      $4692=$50472;
      var $50473=$50471.f1;
      $4693=$50473;
      var $50474=$592;
      var $50475=$593;
      var $50476=$594;
      HEAP32[(($592)>>2)]=$31664;
      HEAP32[(($593)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($594)>>2)]=456;
      var $50477=HEAP32[(($592)>>2)];
      var $50478=(($50477)|0)!=0;
      if ($50478) { __label__ = 13622; break; } else { __label__ = 13624; break; }
    case 13622: // $50479
      var $50480=HEAP32[(($592)>>2)];
      var $50481=HEAP32[(($593)>>2)];
      var $50482=HEAP32[(($594)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50480, $50481, $50482) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13623; break; } else { __label__ = 14612; break; }
    case 13623: // $_noexc1945
      __label__ = 13624; break;
    case 13624: // $_ZdlPvPKci_exit1946
      var $50483=$592;
      var $50484=$593;
      var $50485=$594;
      __label__ = 13625; break;
    case 13625: // $50486
      __label__ = 14611; break;
    case 13626: // $50487
      var $50488=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50489=$50488.f0;
      $4692=$50489;
      var $50490=$50488.f1;
      $4693=$50490;
      var $50491=$589;
      var $50492=$590;
      var $50493=$591;
      HEAP32[(($589)>>2)]=$31731;
      HEAP32[(($590)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($591)>>2)]=457;
      var $50494=HEAP32[(($589)>>2)];
      var $50495=(($50494)|0)!=0;
      if ($50495) { __label__ = 13627; break; } else { __label__ = 13629; break; }
    case 13627: // $50496
      var $50497=HEAP32[(($589)>>2)];
      var $50498=HEAP32[(($590)>>2)];
      var $50499=HEAP32[(($591)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50497, $50498, $50499) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13628; break; } else { __label__ = 14612; break; }
    case 13628: // $_noexc1947
      __label__ = 13629; break;
    case 13629: // $_ZdlPvPKci_exit1948
      var $50500=$589;
      var $50501=$590;
      var $50502=$591;
      __label__ = 13630; break;
    case 13630: // $50503
      __label__ = 14611; break;
    case 13631: // $50504
      var $50505=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50506=$50505.f0;
      $4692=$50506;
      var $50507=$50505.f1;
      $4693=$50507;
      var $50508=$586;
      var $50509=$587;
      var $50510=$588;
      HEAP32[(($586)>>2)]=$31798;
      HEAP32[(($587)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($588)>>2)]=458;
      var $50511=HEAP32[(($586)>>2)];
      var $50512=(($50511)|0)!=0;
      if ($50512) { __label__ = 13632; break; } else { __label__ = 13634; break; }
    case 13632: // $50513
      var $50514=HEAP32[(($586)>>2)];
      var $50515=HEAP32[(($587)>>2)];
      var $50516=HEAP32[(($588)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50514, $50515, $50516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13633; break; } else { __label__ = 14612; break; }
    case 13633: // $_noexc1949
      __label__ = 13634; break;
    case 13634: // $_ZdlPvPKci_exit1950
      var $50517=$586;
      var $50518=$587;
      var $50519=$588;
      __label__ = 13635; break;
    case 13635: // $50520
      __label__ = 14611; break;
    case 13636: // $50521
      var $50522=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50523=$50522.f0;
      $4692=$50523;
      var $50524=$50522.f1;
      $4693=$50524;
      var $50525=$583;
      var $50526=$584;
      var $50527=$585;
      HEAP32[(($583)>>2)]=$31865;
      HEAP32[(($584)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($585)>>2)]=459;
      var $50528=HEAP32[(($583)>>2)];
      var $50529=(($50528)|0)!=0;
      if ($50529) { __label__ = 13637; break; } else { __label__ = 13639; break; }
    case 13637: // $50530
      var $50531=HEAP32[(($583)>>2)];
      var $50532=HEAP32[(($584)>>2)];
      var $50533=HEAP32[(($585)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50531, $50532, $50533) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13638; break; } else { __label__ = 14612; break; }
    case 13638: // $_noexc1951
      __label__ = 13639; break;
    case 13639: // $_ZdlPvPKci_exit1952
      var $50534=$583;
      var $50535=$584;
      var $50536=$585;
      __label__ = 13640; break;
    case 13640: // $50537
      __label__ = 14611; break;
    case 13641: // $50538
      var $50539=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50540=$50539.f0;
      $4692=$50540;
      var $50541=$50539.f1;
      $4693=$50541;
      var $50542=$580;
      var $50543=$581;
      var $50544=$582;
      HEAP32[(($580)>>2)]=$31932;
      HEAP32[(($581)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($582)>>2)]=460;
      var $50545=HEAP32[(($580)>>2)];
      var $50546=(($50545)|0)!=0;
      if ($50546) { __label__ = 13642; break; } else { __label__ = 13644; break; }
    case 13642: // $50547
      var $50548=HEAP32[(($580)>>2)];
      var $50549=HEAP32[(($581)>>2)];
      var $50550=HEAP32[(($582)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50548, $50549, $50550) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13643; break; } else { __label__ = 14612; break; }
    case 13643: // $_noexc1953
      __label__ = 13644; break;
    case 13644: // $_ZdlPvPKci_exit1954
      var $50551=$580;
      var $50552=$581;
      var $50553=$582;
      __label__ = 13645; break;
    case 13645: // $50554
      __label__ = 14611; break;
    case 13646: // $50555
      var $50556=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50557=$50556.f0;
      $4692=$50557;
      var $50558=$50556.f1;
      $4693=$50558;
      var $50559=$577;
      var $50560=$578;
      var $50561=$579;
      HEAP32[(($577)>>2)]=$31999;
      HEAP32[(($578)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($579)>>2)]=461;
      var $50562=HEAP32[(($577)>>2)];
      var $50563=(($50562)|0)!=0;
      if ($50563) { __label__ = 13647; break; } else { __label__ = 13649; break; }
    case 13647: // $50564
      var $50565=HEAP32[(($577)>>2)];
      var $50566=HEAP32[(($578)>>2)];
      var $50567=HEAP32[(($579)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50565, $50566, $50567) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13648; break; } else { __label__ = 14612; break; }
    case 13648: // $_noexc1955
      __label__ = 13649; break;
    case 13649: // $_ZdlPvPKci_exit1956
      var $50568=$577;
      var $50569=$578;
      var $50570=$579;
      __label__ = 13650; break;
    case 13650: // $50571
      __label__ = 14611; break;
    case 13651: // $50572
      var $50573=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50574=$50573.f0;
      $4692=$50574;
      var $50575=$50573.f1;
      $4693=$50575;
      var $50576=$574;
      var $50577=$575;
      var $50578=$576;
      HEAP32[(($574)>>2)]=$32066;
      HEAP32[(($575)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($576)>>2)]=463;
      var $50579=HEAP32[(($574)>>2)];
      var $50580=(($50579)|0)!=0;
      if ($50580) { __label__ = 13652; break; } else { __label__ = 13654; break; }
    case 13652: // $50581
      var $50582=HEAP32[(($574)>>2)];
      var $50583=HEAP32[(($575)>>2)];
      var $50584=HEAP32[(($576)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50582, $50583, $50584) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13653; break; } else { __label__ = 14612; break; }
    case 13653: // $_noexc1957
      __label__ = 13654; break;
    case 13654: // $_ZdlPvPKci_exit1958
      var $50585=$574;
      var $50586=$575;
      var $50587=$576;
      __label__ = 13655; break;
    case 13655: // $50588
      __label__ = 14611; break;
    case 13656: // $50589
      var $50590=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50591=$50590.f0;
      $4692=$50591;
      var $50592=$50590.f1;
      $4693=$50592;
      var $50593=$571;
      var $50594=$572;
      var $50595=$573;
      HEAP32[(($571)>>2)]=$32133;
      HEAP32[(($572)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($573)>>2)]=464;
      var $50596=HEAP32[(($571)>>2)];
      var $50597=(($50596)|0)!=0;
      if ($50597) { __label__ = 13657; break; } else { __label__ = 13659; break; }
    case 13657: // $50598
      var $50599=HEAP32[(($571)>>2)];
      var $50600=HEAP32[(($572)>>2)];
      var $50601=HEAP32[(($573)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50599, $50600, $50601) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13658; break; } else { __label__ = 14612; break; }
    case 13658: // $_noexc1959
      __label__ = 13659; break;
    case 13659: // $_ZdlPvPKci_exit1960
      var $50602=$571;
      var $50603=$572;
      var $50604=$573;
      __label__ = 13660; break;
    case 13660: // $50605
      __label__ = 14611; break;
    case 13661: // $50606
      var $50607=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50608=$50607.f0;
      $4692=$50608;
      var $50609=$50607.f1;
      $4693=$50609;
      var $50610=$568;
      var $50611=$569;
      var $50612=$570;
      HEAP32[(($568)>>2)]=$32200;
      HEAP32[(($569)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($570)>>2)]=465;
      var $50613=HEAP32[(($568)>>2)];
      var $50614=(($50613)|0)!=0;
      if ($50614) { __label__ = 13662; break; } else { __label__ = 13664; break; }
    case 13662: // $50615
      var $50616=HEAP32[(($568)>>2)];
      var $50617=HEAP32[(($569)>>2)];
      var $50618=HEAP32[(($570)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50616, $50617, $50618) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13663; break; } else { __label__ = 14612; break; }
    case 13663: // $_noexc1961
      __label__ = 13664; break;
    case 13664: // $_ZdlPvPKci_exit1962
      var $50619=$568;
      var $50620=$569;
      var $50621=$570;
      __label__ = 13665; break;
    case 13665: // $50622
      __label__ = 14611; break;
    case 13666: // $50623
      var $50624=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50625=$50624.f0;
      $4692=$50625;
      var $50626=$50624.f1;
      $4693=$50626;
      var $50627=$565;
      var $50628=$566;
      var $50629=$567;
      HEAP32[(($565)>>2)]=$32267;
      HEAP32[(($566)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($567)>>2)]=466;
      var $50630=HEAP32[(($565)>>2)];
      var $50631=(($50630)|0)!=0;
      if ($50631) { __label__ = 13667; break; } else { __label__ = 13669; break; }
    case 13667: // $50632
      var $50633=HEAP32[(($565)>>2)];
      var $50634=HEAP32[(($566)>>2)];
      var $50635=HEAP32[(($567)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50633, $50634, $50635) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13668; break; } else { __label__ = 14612; break; }
    case 13668: // $_noexc1963
      __label__ = 13669; break;
    case 13669: // $_ZdlPvPKci_exit1964
      var $50636=$565;
      var $50637=$566;
      var $50638=$567;
      __label__ = 13670; break;
    case 13670: // $50639
      __label__ = 14611; break;
    case 13671: // $50640
      var $50641=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50642=$50641.f0;
      $4692=$50642;
      var $50643=$50641.f1;
      $4693=$50643;
      var $50644=$562;
      var $50645=$563;
      var $50646=$564;
      HEAP32[(($562)>>2)]=$32334;
      HEAP32[(($563)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($564)>>2)]=467;
      var $50647=HEAP32[(($562)>>2)];
      var $50648=(($50647)|0)!=0;
      if ($50648) { __label__ = 13672; break; } else { __label__ = 13674; break; }
    case 13672: // $50649
      var $50650=HEAP32[(($562)>>2)];
      var $50651=HEAP32[(($563)>>2)];
      var $50652=HEAP32[(($564)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50650, $50651, $50652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13673; break; } else { __label__ = 14612; break; }
    case 13673: // $_noexc1965
      __label__ = 13674; break;
    case 13674: // $_ZdlPvPKci_exit1966
      var $50653=$562;
      var $50654=$563;
      var $50655=$564;
      __label__ = 13675; break;
    case 13675: // $50656
      __label__ = 14611; break;
    case 13676: // $50657
      var $50658=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50659=$50658.f0;
      $4692=$50659;
      var $50660=$50658.f1;
      $4693=$50660;
      var $50661=$559;
      var $50662=$560;
      var $50663=$561;
      HEAP32[(($559)>>2)]=$32401;
      HEAP32[(($560)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($561)>>2)]=468;
      var $50664=HEAP32[(($559)>>2)];
      var $50665=(($50664)|0)!=0;
      if ($50665) { __label__ = 13677; break; } else { __label__ = 13679; break; }
    case 13677: // $50666
      var $50667=HEAP32[(($559)>>2)];
      var $50668=HEAP32[(($560)>>2)];
      var $50669=HEAP32[(($561)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50667, $50668, $50669) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13678; break; } else { __label__ = 14612; break; }
    case 13678: // $_noexc1967
      __label__ = 13679; break;
    case 13679: // $_ZdlPvPKci_exit1968
      var $50670=$559;
      var $50671=$560;
      var $50672=$561;
      __label__ = 13680; break;
    case 13680: // $50673
      __label__ = 14611; break;
    case 13681: // $50674
      var $50675=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50676=$50675.f0;
      $4692=$50676;
      var $50677=$50675.f1;
      $4693=$50677;
      var $50678=$556;
      var $50679=$557;
      var $50680=$558;
      HEAP32[(($556)>>2)]=$32468;
      HEAP32[(($557)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($558)>>2)]=469;
      var $50681=HEAP32[(($556)>>2)];
      var $50682=(($50681)|0)!=0;
      if ($50682) { __label__ = 13682; break; } else { __label__ = 13684; break; }
    case 13682: // $50683
      var $50684=HEAP32[(($556)>>2)];
      var $50685=HEAP32[(($557)>>2)];
      var $50686=HEAP32[(($558)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50684, $50685, $50686) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13683; break; } else { __label__ = 14612; break; }
    case 13683: // $_noexc1969
      __label__ = 13684; break;
    case 13684: // $_ZdlPvPKci_exit1970
      var $50687=$556;
      var $50688=$557;
      var $50689=$558;
      __label__ = 13685; break;
    case 13685: // $50690
      __label__ = 14611; break;
    case 13686: // $50691
      var $50692=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50693=$50692.f0;
      $4692=$50693;
      var $50694=$50692.f1;
      $4693=$50694;
      var $50695=$553;
      var $50696=$554;
      var $50697=$555;
      HEAP32[(($553)>>2)]=$32535;
      HEAP32[(($554)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($555)>>2)]=470;
      var $50698=HEAP32[(($553)>>2)];
      var $50699=(($50698)|0)!=0;
      if ($50699) { __label__ = 13687; break; } else { __label__ = 13689; break; }
    case 13687: // $50700
      var $50701=HEAP32[(($553)>>2)];
      var $50702=HEAP32[(($554)>>2)];
      var $50703=HEAP32[(($555)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50701, $50702, $50703) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13688; break; } else { __label__ = 14612; break; }
    case 13688: // $_noexc1971
      __label__ = 13689; break;
    case 13689: // $_ZdlPvPKci_exit1972
      var $50704=$553;
      var $50705=$554;
      var $50706=$555;
      __label__ = 13690; break;
    case 13690: // $50707
      __label__ = 14611; break;
    case 13691: // $50708
      var $50709=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50710=$50709.f0;
      $4692=$50710;
      var $50711=$50709.f1;
      $4693=$50711;
      var $50712=$550;
      var $50713=$551;
      var $50714=$552;
      HEAP32[(($550)>>2)]=$32602;
      HEAP32[(($551)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($552)>>2)]=472;
      var $50715=HEAP32[(($550)>>2)];
      var $50716=(($50715)|0)!=0;
      if ($50716) { __label__ = 13692; break; } else { __label__ = 13694; break; }
    case 13692: // $50717
      var $50718=HEAP32[(($550)>>2)];
      var $50719=HEAP32[(($551)>>2)];
      var $50720=HEAP32[(($552)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50718, $50719, $50720) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13693; break; } else { __label__ = 14612; break; }
    case 13693: // $_noexc1973
      __label__ = 13694; break;
    case 13694: // $_ZdlPvPKci_exit1974
      var $50721=$550;
      var $50722=$551;
      var $50723=$552;
      __label__ = 13695; break;
    case 13695: // $50724
      __label__ = 14611; break;
    case 13696: // $50725
      var $50726=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50727=$50726.f0;
      $4692=$50727;
      var $50728=$50726.f1;
      $4693=$50728;
      var $50729=$547;
      var $50730=$548;
      var $50731=$549;
      HEAP32[(($547)>>2)]=$32669;
      HEAP32[(($548)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($549)>>2)]=473;
      var $50732=HEAP32[(($547)>>2)];
      var $50733=(($50732)|0)!=0;
      if ($50733) { __label__ = 13697; break; } else { __label__ = 13699; break; }
    case 13697: // $50734
      var $50735=HEAP32[(($547)>>2)];
      var $50736=HEAP32[(($548)>>2)];
      var $50737=HEAP32[(($549)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50735, $50736, $50737) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13698; break; } else { __label__ = 14612; break; }
    case 13698: // $_noexc1975
      __label__ = 13699; break;
    case 13699: // $_ZdlPvPKci_exit1976
      var $50738=$547;
      var $50739=$548;
      var $50740=$549;
      __label__ = 13700; break;
    case 13700: // $50741
      __label__ = 14611; break;
    case 13701: // $50742
      var $50743=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50744=$50743.f0;
      $4692=$50744;
      var $50745=$50743.f1;
      $4693=$50745;
      var $50746=$544;
      var $50747=$545;
      var $50748=$546;
      HEAP32[(($544)>>2)]=$32736;
      HEAP32[(($545)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($546)>>2)]=474;
      var $50749=HEAP32[(($544)>>2)];
      var $50750=(($50749)|0)!=0;
      if ($50750) { __label__ = 13702; break; } else { __label__ = 13704; break; }
    case 13702: // $50751
      var $50752=HEAP32[(($544)>>2)];
      var $50753=HEAP32[(($545)>>2)];
      var $50754=HEAP32[(($546)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50752, $50753, $50754) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13703; break; } else { __label__ = 14612; break; }
    case 13703: // $_noexc1977
      __label__ = 13704; break;
    case 13704: // $_ZdlPvPKci_exit1978
      var $50755=$544;
      var $50756=$545;
      var $50757=$546;
      __label__ = 13705; break;
    case 13705: // $50758
      __label__ = 14611; break;
    case 13706: // $50759
      var $50760=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50761=$50760.f0;
      $4692=$50761;
      var $50762=$50760.f1;
      $4693=$50762;
      var $50763=$541;
      var $50764=$542;
      var $50765=$543;
      HEAP32[(($541)>>2)]=$32803;
      HEAP32[(($542)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($543)>>2)]=475;
      var $50766=HEAP32[(($541)>>2)];
      var $50767=(($50766)|0)!=0;
      if ($50767) { __label__ = 13707; break; } else { __label__ = 13709; break; }
    case 13707: // $50768
      var $50769=HEAP32[(($541)>>2)];
      var $50770=HEAP32[(($542)>>2)];
      var $50771=HEAP32[(($543)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50769, $50770, $50771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13708; break; } else { __label__ = 14612; break; }
    case 13708: // $_noexc1979
      __label__ = 13709; break;
    case 13709: // $_ZdlPvPKci_exit1980
      var $50772=$541;
      var $50773=$542;
      var $50774=$543;
      __label__ = 13710; break;
    case 13710: // $50775
      __label__ = 14611; break;
    case 13711: // $50776
      var $50777=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50778=$50777.f0;
      $4692=$50778;
      var $50779=$50777.f1;
      $4693=$50779;
      var $50780=$538;
      var $50781=$539;
      var $50782=$540;
      HEAP32[(($538)>>2)]=$32870;
      HEAP32[(($539)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($540)>>2)]=476;
      var $50783=HEAP32[(($538)>>2)];
      var $50784=(($50783)|0)!=0;
      if ($50784) { __label__ = 13712; break; } else { __label__ = 13714; break; }
    case 13712: // $50785
      var $50786=HEAP32[(($538)>>2)];
      var $50787=HEAP32[(($539)>>2)];
      var $50788=HEAP32[(($540)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50786, $50787, $50788) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13713; break; } else { __label__ = 14612; break; }
    case 13713: // $_noexc1981
      __label__ = 13714; break;
    case 13714: // $_ZdlPvPKci_exit1982
      var $50789=$538;
      var $50790=$539;
      var $50791=$540;
      __label__ = 13715; break;
    case 13715: // $50792
      __label__ = 14611; break;
    case 13716: // $50793
      var $50794=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50795=$50794.f0;
      $4692=$50795;
      var $50796=$50794.f1;
      $4693=$50796;
      var $50797=$535;
      var $50798=$536;
      var $50799=$537;
      HEAP32[(($535)>>2)]=$32937;
      HEAP32[(($536)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($537)>>2)]=477;
      var $50800=HEAP32[(($535)>>2)];
      var $50801=(($50800)|0)!=0;
      if ($50801) { __label__ = 13717; break; } else { __label__ = 13719; break; }
    case 13717: // $50802
      var $50803=HEAP32[(($535)>>2)];
      var $50804=HEAP32[(($536)>>2)];
      var $50805=HEAP32[(($537)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50803, $50804, $50805) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13718; break; } else { __label__ = 14612; break; }
    case 13718: // $_noexc1983
      __label__ = 13719; break;
    case 13719: // $_ZdlPvPKci_exit1984
      var $50806=$535;
      var $50807=$536;
      var $50808=$537;
      __label__ = 13720; break;
    case 13720: // $50809
      __label__ = 14611; break;
    case 13721: // $50810
      var $50811=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50812=$50811.f0;
      $4692=$50812;
      var $50813=$50811.f1;
      $4693=$50813;
      var $50814=$532;
      var $50815=$533;
      var $50816=$534;
      HEAP32[(($532)>>2)]=$33004;
      HEAP32[(($533)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($534)>>2)]=478;
      var $50817=HEAP32[(($532)>>2)];
      var $50818=(($50817)|0)!=0;
      if ($50818) { __label__ = 13722; break; } else { __label__ = 13724; break; }
    case 13722: // $50819
      var $50820=HEAP32[(($532)>>2)];
      var $50821=HEAP32[(($533)>>2)];
      var $50822=HEAP32[(($534)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50820, $50821, $50822) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13723; break; } else { __label__ = 14612; break; }
    case 13723: // $_noexc1985
      __label__ = 13724; break;
    case 13724: // $_ZdlPvPKci_exit1986
      var $50823=$532;
      var $50824=$533;
      var $50825=$534;
      __label__ = 13725; break;
    case 13725: // $50826
      __label__ = 14611; break;
    case 13726: // $50827
      var $50828=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50829=$50828.f0;
      $4692=$50829;
      var $50830=$50828.f1;
      $4693=$50830;
      var $50831=$529;
      var $50832=$530;
      var $50833=$531;
      HEAP32[(($529)>>2)]=$33071;
      HEAP32[(($530)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($531)>>2)]=479;
      var $50834=HEAP32[(($529)>>2)];
      var $50835=(($50834)|0)!=0;
      if ($50835) { __label__ = 13727; break; } else { __label__ = 13729; break; }
    case 13727: // $50836
      var $50837=HEAP32[(($529)>>2)];
      var $50838=HEAP32[(($530)>>2)];
      var $50839=HEAP32[(($531)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50837, $50838, $50839) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13728; break; } else { __label__ = 14612; break; }
    case 13728: // $_noexc1987
      __label__ = 13729; break;
    case 13729: // $_ZdlPvPKci_exit1988
      var $50840=$529;
      var $50841=$530;
      var $50842=$531;
      __label__ = 13730; break;
    case 13730: // $50843
      __label__ = 14611; break;
    case 13731: // $50844
      var $50845=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50846=$50845.f0;
      $4692=$50846;
      var $50847=$50845.f1;
      $4693=$50847;
      var $50848=$526;
      var $50849=$527;
      var $50850=$528;
      HEAP32[(($526)>>2)]=$33138;
      HEAP32[(($527)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($528)>>2)]=481;
      var $50851=HEAP32[(($526)>>2)];
      var $50852=(($50851)|0)!=0;
      if ($50852) { __label__ = 13732; break; } else { __label__ = 13734; break; }
    case 13732: // $50853
      var $50854=HEAP32[(($526)>>2)];
      var $50855=HEAP32[(($527)>>2)];
      var $50856=HEAP32[(($528)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50854, $50855, $50856) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13733; break; } else { __label__ = 14612; break; }
    case 13733: // $_noexc1989
      __label__ = 13734; break;
    case 13734: // $_ZdlPvPKci_exit1990
      var $50857=$526;
      var $50858=$527;
      var $50859=$528;
      __label__ = 13735; break;
    case 13735: // $50860
      __label__ = 14611; break;
    case 13736: // $50861
      var $50862=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50863=$50862.f0;
      $4692=$50863;
      var $50864=$50862.f1;
      $4693=$50864;
      var $50865=$523;
      var $50866=$524;
      var $50867=$525;
      HEAP32[(($523)>>2)]=$33205;
      HEAP32[(($524)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($525)>>2)]=482;
      var $50868=HEAP32[(($523)>>2)];
      var $50869=(($50868)|0)!=0;
      if ($50869) { __label__ = 13737; break; } else { __label__ = 13739; break; }
    case 13737: // $50870
      var $50871=HEAP32[(($523)>>2)];
      var $50872=HEAP32[(($524)>>2)];
      var $50873=HEAP32[(($525)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50871, $50872, $50873) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13738; break; } else { __label__ = 14612; break; }
    case 13738: // $_noexc1991
      __label__ = 13739; break;
    case 13739: // $_ZdlPvPKci_exit1992
      var $50874=$523;
      var $50875=$524;
      var $50876=$525;
      __label__ = 13740; break;
    case 13740: // $50877
      __label__ = 14611; break;
    case 13741: // $50878
      var $50879=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50880=$50879.f0;
      $4692=$50880;
      var $50881=$50879.f1;
      $4693=$50881;
      var $50882=$520;
      var $50883=$521;
      var $50884=$522;
      HEAP32[(($520)>>2)]=$33272;
      HEAP32[(($521)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($522)>>2)]=483;
      var $50885=HEAP32[(($520)>>2)];
      var $50886=(($50885)|0)!=0;
      if ($50886) { __label__ = 13742; break; } else { __label__ = 13744; break; }
    case 13742: // $50887
      var $50888=HEAP32[(($520)>>2)];
      var $50889=HEAP32[(($521)>>2)];
      var $50890=HEAP32[(($522)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50888, $50889, $50890) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13743; break; } else { __label__ = 14612; break; }
    case 13743: // $_noexc1993
      __label__ = 13744; break;
    case 13744: // $_ZdlPvPKci_exit1994
      var $50891=$520;
      var $50892=$521;
      var $50893=$522;
      __label__ = 13745; break;
    case 13745: // $50894
      __label__ = 14611; break;
    case 13746: // $50895
      var $50896=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50897=$50896.f0;
      $4692=$50897;
      var $50898=$50896.f1;
      $4693=$50898;
      var $50899=$517;
      var $50900=$518;
      var $50901=$519;
      HEAP32[(($517)>>2)]=$33339;
      HEAP32[(($518)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($519)>>2)]=484;
      var $50902=HEAP32[(($517)>>2)];
      var $50903=(($50902)|0)!=0;
      if ($50903) { __label__ = 13747; break; } else { __label__ = 13749; break; }
    case 13747: // $50904
      var $50905=HEAP32[(($517)>>2)];
      var $50906=HEAP32[(($518)>>2)];
      var $50907=HEAP32[(($519)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50905, $50906, $50907) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13748; break; } else { __label__ = 14612; break; }
    case 13748: // $_noexc1995
      __label__ = 13749; break;
    case 13749: // $_ZdlPvPKci_exit1996
      var $50908=$517;
      var $50909=$518;
      var $50910=$519;
      __label__ = 13750; break;
    case 13750: // $50911
      __label__ = 14611; break;
    case 13751: // $50912
      var $50913=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50914=$50913.f0;
      $4692=$50914;
      var $50915=$50913.f1;
      $4693=$50915;
      var $50916=$514;
      var $50917=$515;
      var $50918=$516;
      HEAP32[(($514)>>2)]=$33406;
      HEAP32[(($515)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($516)>>2)]=485;
      var $50919=HEAP32[(($514)>>2)];
      var $50920=(($50919)|0)!=0;
      if ($50920) { __label__ = 13752; break; } else { __label__ = 13754; break; }
    case 13752: // $50921
      var $50922=HEAP32[(($514)>>2)];
      var $50923=HEAP32[(($515)>>2)];
      var $50924=HEAP32[(($516)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50922, $50923, $50924) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13753; break; } else { __label__ = 14612; break; }
    case 13753: // $_noexc1997
      __label__ = 13754; break;
    case 13754: // $_ZdlPvPKci_exit1998
      var $50925=$514;
      var $50926=$515;
      var $50927=$516;
      __label__ = 13755; break;
    case 13755: // $50928
      __label__ = 14611; break;
    case 13756: // $50929
      var $50930=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50931=$50930.f0;
      $4692=$50931;
      var $50932=$50930.f1;
      $4693=$50932;
      var $50933=$511;
      var $50934=$512;
      var $50935=$513;
      HEAP32[(($511)>>2)]=$33473;
      HEAP32[(($512)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($513)>>2)]=486;
      var $50936=HEAP32[(($511)>>2)];
      var $50937=(($50936)|0)!=0;
      if ($50937) { __label__ = 13757; break; } else { __label__ = 13759; break; }
    case 13757: // $50938
      var $50939=HEAP32[(($511)>>2)];
      var $50940=HEAP32[(($512)>>2)];
      var $50941=HEAP32[(($513)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50939, $50940, $50941) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13758; break; } else { __label__ = 14612; break; }
    case 13758: // $_noexc1999
      __label__ = 13759; break;
    case 13759: // $_ZdlPvPKci_exit2000
      var $50942=$511;
      var $50943=$512;
      var $50944=$513;
      __label__ = 13760; break;
    case 13760: // $50945
      __label__ = 14611; break;
    case 13761: // $50946
      var $50947=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50948=$50947.f0;
      $4692=$50948;
      var $50949=$50947.f1;
      $4693=$50949;
      var $50950=$508;
      var $50951=$509;
      var $50952=$510;
      HEAP32[(($508)>>2)]=$33540;
      HEAP32[(($509)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($510)>>2)]=487;
      var $50953=HEAP32[(($508)>>2)];
      var $50954=(($50953)|0)!=0;
      if ($50954) { __label__ = 13762; break; } else { __label__ = 13764; break; }
    case 13762: // $50955
      var $50956=HEAP32[(($508)>>2)];
      var $50957=HEAP32[(($509)>>2)];
      var $50958=HEAP32[(($510)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50956, $50957, $50958) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13763; break; } else { __label__ = 14612; break; }
    case 13763: // $_noexc2001
      __label__ = 13764; break;
    case 13764: // $_ZdlPvPKci_exit2002
      var $50959=$508;
      var $50960=$509;
      var $50961=$510;
      __label__ = 13765; break;
    case 13765: // $50962
      __label__ = 14611; break;
    case 13766: // $50963
      var $50964=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50965=$50964.f0;
      $4692=$50965;
      var $50966=$50964.f1;
      $4693=$50966;
      var $50967=$505;
      var $50968=$506;
      var $50969=$507;
      HEAP32[(($505)>>2)]=$33607;
      HEAP32[(($506)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($507)>>2)]=488;
      var $50970=HEAP32[(($505)>>2)];
      var $50971=(($50970)|0)!=0;
      if ($50971) { __label__ = 13767; break; } else { __label__ = 13769; break; }
    case 13767: // $50972
      var $50973=HEAP32[(($505)>>2)];
      var $50974=HEAP32[(($506)>>2)];
      var $50975=HEAP32[(($507)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50973, $50974, $50975) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13768; break; } else { __label__ = 14612; break; }
    case 13768: // $_noexc2003
      __label__ = 13769; break;
    case 13769: // $_ZdlPvPKci_exit2004
      var $50976=$505;
      var $50977=$506;
      var $50978=$507;
      __label__ = 13770; break;
    case 13770: // $50979
      __label__ = 14611; break;
    case 13771: // $50980
      var $50981=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50982=$50981.f0;
      $4692=$50982;
      var $50983=$50981.f1;
      $4693=$50983;
      var $50984=$502;
      var $50985=$503;
      var $50986=$504;
      HEAP32[(($502)>>2)]=$33674;
      HEAP32[(($503)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($504)>>2)]=490;
      var $50987=HEAP32[(($502)>>2)];
      var $50988=(($50987)|0)!=0;
      if ($50988) { __label__ = 13772; break; } else { __label__ = 13774; break; }
    case 13772: // $50989
      var $50990=HEAP32[(($502)>>2)];
      var $50991=HEAP32[(($503)>>2)];
      var $50992=HEAP32[(($504)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($50990, $50991, $50992) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13773; break; } else { __label__ = 14612; break; }
    case 13773: // $_noexc2005
      __label__ = 13774; break;
    case 13774: // $_ZdlPvPKci_exit2006
      var $50993=$502;
      var $50994=$503;
      var $50995=$504;
      __label__ = 13775; break;
    case 13775: // $50996
      __label__ = 14611; break;
    case 13776: // $50997
      var $50998=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50999=$50998.f0;
      $4692=$50999;
      var $51000=$50998.f1;
      $4693=$51000;
      var $51001=$499;
      var $51002=$500;
      var $51003=$501;
      HEAP32[(($499)>>2)]=$33741;
      HEAP32[(($500)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($501)>>2)]=491;
      var $51004=HEAP32[(($499)>>2)];
      var $51005=(($51004)|0)!=0;
      if ($51005) { __label__ = 13777; break; } else { __label__ = 13779; break; }
    case 13777: // $51006
      var $51007=HEAP32[(($499)>>2)];
      var $51008=HEAP32[(($500)>>2)];
      var $51009=HEAP32[(($501)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51007, $51008, $51009) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13778; break; } else { __label__ = 14612; break; }
    case 13778: // $_noexc2007
      __label__ = 13779; break;
    case 13779: // $_ZdlPvPKci_exit2008
      var $51010=$499;
      var $51011=$500;
      var $51012=$501;
      __label__ = 13780; break;
    case 13780: // $51013
      __label__ = 14611; break;
    case 13781: // $51014
      var $51015=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51016=$51015.f0;
      $4692=$51016;
      var $51017=$51015.f1;
      $4693=$51017;
      var $51018=$496;
      var $51019=$497;
      var $51020=$498;
      HEAP32[(($496)>>2)]=$33808;
      HEAP32[(($497)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($498)>>2)]=492;
      var $51021=HEAP32[(($496)>>2)];
      var $51022=(($51021)|0)!=0;
      if ($51022) { __label__ = 13782; break; } else { __label__ = 13784; break; }
    case 13782: // $51023
      var $51024=HEAP32[(($496)>>2)];
      var $51025=HEAP32[(($497)>>2)];
      var $51026=HEAP32[(($498)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51024, $51025, $51026) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13783; break; } else { __label__ = 14612; break; }
    case 13783: // $_noexc2009
      __label__ = 13784; break;
    case 13784: // $_ZdlPvPKci_exit2010
      var $51027=$496;
      var $51028=$497;
      var $51029=$498;
      __label__ = 13785; break;
    case 13785: // $51030
      __label__ = 14611; break;
    case 13786: // $51031
      var $51032=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51033=$51032.f0;
      $4692=$51033;
      var $51034=$51032.f1;
      $4693=$51034;
      var $51035=$493;
      var $51036=$494;
      var $51037=$495;
      HEAP32[(($493)>>2)]=$33875;
      HEAP32[(($494)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($495)>>2)]=493;
      var $51038=HEAP32[(($493)>>2)];
      var $51039=(($51038)|0)!=0;
      if ($51039) { __label__ = 13787; break; } else { __label__ = 13789; break; }
    case 13787: // $51040
      var $51041=HEAP32[(($493)>>2)];
      var $51042=HEAP32[(($494)>>2)];
      var $51043=HEAP32[(($495)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51041, $51042, $51043) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13788; break; } else { __label__ = 14612; break; }
    case 13788: // $_noexc2011
      __label__ = 13789; break;
    case 13789: // $_ZdlPvPKci_exit2012
      var $51044=$493;
      var $51045=$494;
      var $51046=$495;
      __label__ = 13790; break;
    case 13790: // $51047
      __label__ = 14611; break;
    case 13791: // $51048
      var $51049=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51050=$51049.f0;
      $4692=$51050;
      var $51051=$51049.f1;
      $4693=$51051;
      var $51052=$490;
      var $51053=$491;
      var $51054=$492;
      HEAP32[(($490)>>2)]=$33942;
      HEAP32[(($491)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($492)>>2)]=494;
      var $51055=HEAP32[(($490)>>2)];
      var $51056=(($51055)|0)!=0;
      if ($51056) { __label__ = 13792; break; } else { __label__ = 13794; break; }
    case 13792: // $51057
      var $51058=HEAP32[(($490)>>2)];
      var $51059=HEAP32[(($491)>>2)];
      var $51060=HEAP32[(($492)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51058, $51059, $51060) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13793; break; } else { __label__ = 14612; break; }
    case 13793: // $_noexc2013
      __label__ = 13794; break;
    case 13794: // $_ZdlPvPKci_exit2014
      var $51061=$490;
      var $51062=$491;
      var $51063=$492;
      __label__ = 13795; break;
    case 13795: // $51064
      __label__ = 14611; break;
    case 13796: // $51065
      var $51066=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51067=$51066.f0;
      $4692=$51067;
      var $51068=$51066.f1;
      $4693=$51068;
      var $51069=$487;
      var $51070=$488;
      var $51071=$489;
      HEAP32[(($487)>>2)]=$34009;
      HEAP32[(($488)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($489)>>2)]=495;
      var $51072=HEAP32[(($487)>>2)];
      var $51073=(($51072)|0)!=0;
      if ($51073) { __label__ = 13797; break; } else { __label__ = 13799; break; }
    case 13797: // $51074
      var $51075=HEAP32[(($487)>>2)];
      var $51076=HEAP32[(($488)>>2)];
      var $51077=HEAP32[(($489)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51075, $51076, $51077) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13798; break; } else { __label__ = 14612; break; }
    case 13798: // $_noexc2015
      __label__ = 13799; break;
    case 13799: // $_ZdlPvPKci_exit2016
      var $51078=$487;
      var $51079=$488;
      var $51080=$489;
      __label__ = 13800; break;
    case 13800: // $51081
      __label__ = 14611; break;
    case 13801: // $51082
      var $51083=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51084=$51083.f0;
      $4692=$51084;
      var $51085=$51083.f1;
      $4693=$51085;
      var $51086=$484;
      var $51087=$485;
      var $51088=$486;
      HEAP32[(($484)>>2)]=$34076;
      HEAP32[(($485)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($486)>>2)]=496;
      var $51089=HEAP32[(($484)>>2)];
      var $51090=(($51089)|0)!=0;
      if ($51090) { __label__ = 13802; break; } else { __label__ = 13804; break; }
    case 13802: // $51091
      var $51092=HEAP32[(($484)>>2)];
      var $51093=HEAP32[(($485)>>2)];
      var $51094=HEAP32[(($486)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51092, $51093, $51094) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13803; break; } else { __label__ = 14612; break; }
    case 13803: // $_noexc2017
      __label__ = 13804; break;
    case 13804: // $_ZdlPvPKci_exit2018
      var $51095=$484;
      var $51096=$485;
      var $51097=$486;
      __label__ = 13805; break;
    case 13805: // $51098
      __label__ = 14611; break;
    case 13806: // $51099
      var $51100=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51101=$51100.f0;
      $4692=$51101;
      var $51102=$51100.f1;
      $4693=$51102;
      var $51103=$481;
      var $51104=$482;
      var $51105=$483;
      HEAP32[(($481)>>2)]=$34143;
      HEAP32[(($482)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($483)>>2)]=497;
      var $51106=HEAP32[(($481)>>2)];
      var $51107=(($51106)|0)!=0;
      if ($51107) { __label__ = 13807; break; } else { __label__ = 13809; break; }
    case 13807: // $51108
      var $51109=HEAP32[(($481)>>2)];
      var $51110=HEAP32[(($482)>>2)];
      var $51111=HEAP32[(($483)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51109, $51110, $51111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13808; break; } else { __label__ = 14612; break; }
    case 13808: // $_noexc2019
      __label__ = 13809; break;
    case 13809: // $_ZdlPvPKci_exit2020
      var $51112=$481;
      var $51113=$482;
      var $51114=$483;
      __label__ = 13810; break;
    case 13810: // $51115
      __label__ = 14611; break;
    case 13811: // $51116
      var $51117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51118=$51117.f0;
      $4692=$51118;
      var $51119=$51117.f1;
      $4693=$51119;
      var $51120=$478;
      var $51121=$479;
      var $51122=$480;
      HEAP32[(($478)>>2)]=$34210;
      HEAP32[(($479)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($480)>>2)]=499;
      var $51123=HEAP32[(($478)>>2)];
      var $51124=(($51123)|0)!=0;
      if ($51124) { __label__ = 13812; break; } else { __label__ = 13814; break; }
    case 13812: // $51125
      var $51126=HEAP32[(($478)>>2)];
      var $51127=HEAP32[(($479)>>2)];
      var $51128=HEAP32[(($480)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51126, $51127, $51128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13813; break; } else { __label__ = 14612; break; }
    case 13813: // $_noexc2021
      __label__ = 13814; break;
    case 13814: // $_ZdlPvPKci_exit2022
      var $51129=$478;
      var $51130=$479;
      var $51131=$480;
      __label__ = 13815; break;
    case 13815: // $51132
      __label__ = 14611; break;
    case 13816: // $51133
      var $51134=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51135=$51134.f0;
      $4692=$51135;
      var $51136=$51134.f1;
      $4693=$51136;
      var $51137=$475;
      var $51138=$476;
      var $51139=$477;
      HEAP32[(($475)>>2)]=$34277;
      HEAP32[(($476)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($477)>>2)]=500;
      var $51140=HEAP32[(($475)>>2)];
      var $51141=(($51140)|0)!=0;
      if ($51141) { __label__ = 13817; break; } else { __label__ = 13819; break; }
    case 13817: // $51142
      var $51143=HEAP32[(($475)>>2)];
      var $51144=HEAP32[(($476)>>2)];
      var $51145=HEAP32[(($477)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51143, $51144, $51145) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13818; break; } else { __label__ = 14612; break; }
    case 13818: // $_noexc2023
      __label__ = 13819; break;
    case 13819: // $_ZdlPvPKci_exit2024
      var $51146=$475;
      var $51147=$476;
      var $51148=$477;
      __label__ = 13820; break;
    case 13820: // $51149
      __label__ = 14611; break;
    case 13821: // $51150
      var $51151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51152=$51151.f0;
      $4692=$51152;
      var $51153=$51151.f1;
      $4693=$51153;
      var $51154=$472;
      var $51155=$473;
      var $51156=$474;
      HEAP32[(($472)>>2)]=$34344;
      HEAP32[(($473)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($474)>>2)]=501;
      var $51157=HEAP32[(($472)>>2)];
      var $51158=(($51157)|0)!=0;
      if ($51158) { __label__ = 13822; break; } else { __label__ = 13824; break; }
    case 13822: // $51159
      var $51160=HEAP32[(($472)>>2)];
      var $51161=HEAP32[(($473)>>2)];
      var $51162=HEAP32[(($474)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51160, $51161, $51162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13823; break; } else { __label__ = 14612; break; }
    case 13823: // $_noexc2025
      __label__ = 13824; break;
    case 13824: // $_ZdlPvPKci_exit2026
      var $51163=$472;
      var $51164=$473;
      var $51165=$474;
      __label__ = 13825; break;
    case 13825: // $51166
      __label__ = 14611; break;
    case 13826: // $51167
      var $51168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51169=$51168.f0;
      $4692=$51169;
      var $51170=$51168.f1;
      $4693=$51170;
      var $51171=$469;
      var $51172=$470;
      var $51173=$471;
      HEAP32[(($469)>>2)]=$34411;
      HEAP32[(($470)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($471)>>2)]=502;
      var $51174=HEAP32[(($469)>>2)];
      var $51175=(($51174)|0)!=0;
      if ($51175) { __label__ = 13827; break; } else { __label__ = 13829; break; }
    case 13827: // $51176
      var $51177=HEAP32[(($469)>>2)];
      var $51178=HEAP32[(($470)>>2)];
      var $51179=HEAP32[(($471)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51177, $51178, $51179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13828; break; } else { __label__ = 14612; break; }
    case 13828: // $_noexc2027
      __label__ = 13829; break;
    case 13829: // $_ZdlPvPKci_exit2028
      var $51180=$469;
      var $51181=$470;
      var $51182=$471;
      __label__ = 13830; break;
    case 13830: // $51183
      __label__ = 14611; break;
    case 13831: // $51184
      var $51185=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51186=$51185.f0;
      $4692=$51186;
      var $51187=$51185.f1;
      $4693=$51187;
      var $51188=$466;
      var $51189=$467;
      var $51190=$468;
      HEAP32[(($466)>>2)]=$34478;
      HEAP32[(($467)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($468)>>2)]=503;
      var $51191=HEAP32[(($466)>>2)];
      var $51192=(($51191)|0)!=0;
      if ($51192) { __label__ = 13832; break; } else { __label__ = 13834; break; }
    case 13832: // $51193
      var $51194=HEAP32[(($466)>>2)];
      var $51195=HEAP32[(($467)>>2)];
      var $51196=HEAP32[(($468)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51194, $51195, $51196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13833; break; } else { __label__ = 14612; break; }
    case 13833: // $_noexc2029
      __label__ = 13834; break;
    case 13834: // $_ZdlPvPKci_exit2030
      var $51197=$466;
      var $51198=$467;
      var $51199=$468;
      __label__ = 13835; break;
    case 13835: // $51200
      __label__ = 14611; break;
    case 13836: // $51201
      var $51202=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51203=$51202.f0;
      $4692=$51203;
      var $51204=$51202.f1;
      $4693=$51204;
      var $51205=$463;
      var $51206=$464;
      var $51207=$465;
      HEAP32[(($463)>>2)]=$34545;
      HEAP32[(($464)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($465)>>2)]=504;
      var $51208=HEAP32[(($463)>>2)];
      var $51209=(($51208)|0)!=0;
      if ($51209) { __label__ = 13837; break; } else { __label__ = 13839; break; }
    case 13837: // $51210
      var $51211=HEAP32[(($463)>>2)];
      var $51212=HEAP32[(($464)>>2)];
      var $51213=HEAP32[(($465)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51211, $51212, $51213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13838; break; } else { __label__ = 14612; break; }
    case 13838: // $_noexc2031
      __label__ = 13839; break;
    case 13839: // $_ZdlPvPKci_exit2032
      var $51214=$463;
      var $51215=$464;
      var $51216=$465;
      __label__ = 13840; break;
    case 13840: // $51217
      __label__ = 14611; break;
    case 13841: // $51218
      var $51219=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51220=$51219.f0;
      $4692=$51220;
      var $51221=$51219.f1;
      $4693=$51221;
      var $51222=$460;
      var $51223=$461;
      var $51224=$462;
      HEAP32[(($460)>>2)]=$34612;
      HEAP32[(($461)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($462)>>2)]=505;
      var $51225=HEAP32[(($460)>>2)];
      var $51226=(($51225)|0)!=0;
      if ($51226) { __label__ = 13842; break; } else { __label__ = 13844; break; }
    case 13842: // $51227
      var $51228=HEAP32[(($460)>>2)];
      var $51229=HEAP32[(($461)>>2)];
      var $51230=HEAP32[(($462)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51228, $51229, $51230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13843; break; } else { __label__ = 14612; break; }
    case 13843: // $_noexc2033
      __label__ = 13844; break;
    case 13844: // $_ZdlPvPKci_exit2034
      var $51231=$460;
      var $51232=$461;
      var $51233=$462;
      __label__ = 13845; break;
    case 13845: // $51234
      __label__ = 14611; break;
    case 13846: // $51235
      var $51236=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51237=$51236.f0;
      $4692=$51237;
      var $51238=$51236.f1;
      $4693=$51238;
      var $51239=$457;
      var $51240=$458;
      var $51241=$459;
      HEAP32[(($457)>>2)]=$34679;
      HEAP32[(($458)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($459)>>2)]=506;
      var $51242=HEAP32[(($457)>>2)];
      var $51243=(($51242)|0)!=0;
      if ($51243) { __label__ = 13847; break; } else { __label__ = 13849; break; }
    case 13847: // $51244
      var $51245=HEAP32[(($457)>>2)];
      var $51246=HEAP32[(($458)>>2)];
      var $51247=HEAP32[(($459)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51245, $51246, $51247) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13848; break; } else { __label__ = 14612; break; }
    case 13848: // $_noexc2035
      __label__ = 13849; break;
    case 13849: // $_ZdlPvPKci_exit2036
      var $51248=$457;
      var $51249=$458;
      var $51250=$459;
      __label__ = 13850; break;
    case 13850: // $51251
      __label__ = 14611; break;
    case 13851: // $51252
      var $51253=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51254=$51253.f0;
      $4692=$51254;
      var $51255=$51253.f1;
      $4693=$51255;
      var $51256=$454;
      var $51257=$455;
      var $51258=$456;
      HEAP32[(($454)>>2)]=$34746;
      HEAP32[(($455)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($456)>>2)]=508;
      var $51259=HEAP32[(($454)>>2)];
      var $51260=(($51259)|0)!=0;
      if ($51260) { __label__ = 13852; break; } else { __label__ = 13854; break; }
    case 13852: // $51261
      var $51262=HEAP32[(($454)>>2)];
      var $51263=HEAP32[(($455)>>2)];
      var $51264=HEAP32[(($456)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51262, $51263, $51264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13853; break; } else { __label__ = 14612; break; }
    case 13853: // $_noexc2037
      __label__ = 13854; break;
    case 13854: // $_ZdlPvPKci_exit2038
      var $51265=$454;
      var $51266=$455;
      var $51267=$456;
      __label__ = 13855; break;
    case 13855: // $51268
      __label__ = 14611; break;
    case 13856: // $51269
      var $51270=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51271=$51270.f0;
      $4692=$51271;
      var $51272=$51270.f1;
      $4693=$51272;
      var $51273=$451;
      var $51274=$452;
      var $51275=$453;
      HEAP32[(($451)>>2)]=$34813;
      HEAP32[(($452)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($453)>>2)]=509;
      var $51276=HEAP32[(($451)>>2)];
      var $51277=(($51276)|0)!=0;
      if ($51277) { __label__ = 13857; break; } else { __label__ = 13859; break; }
    case 13857: // $51278
      var $51279=HEAP32[(($451)>>2)];
      var $51280=HEAP32[(($452)>>2)];
      var $51281=HEAP32[(($453)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51279, $51280, $51281) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13858; break; } else { __label__ = 14612; break; }
    case 13858: // $_noexc2039
      __label__ = 13859; break;
    case 13859: // $_ZdlPvPKci_exit2040
      var $51282=$451;
      var $51283=$452;
      var $51284=$453;
      __label__ = 13860; break;
    case 13860: // $51285
      __label__ = 14611; break;
    case 13861: // $51286
      var $51287=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51288=$51287.f0;
      $4692=$51288;
      var $51289=$51287.f1;
      $4693=$51289;
      var $51290=$448;
      var $51291=$449;
      var $51292=$450;
      HEAP32[(($448)>>2)]=$34880;
      HEAP32[(($449)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($450)>>2)]=510;
      var $51293=HEAP32[(($448)>>2)];
      var $51294=(($51293)|0)!=0;
      if ($51294) { __label__ = 13862; break; } else { __label__ = 13864; break; }
    case 13862: // $51295
      var $51296=HEAP32[(($448)>>2)];
      var $51297=HEAP32[(($449)>>2)];
      var $51298=HEAP32[(($450)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51296, $51297, $51298) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13863; break; } else { __label__ = 14612; break; }
    case 13863: // $_noexc2041
      __label__ = 13864; break;
    case 13864: // $_ZdlPvPKci_exit2042
      var $51299=$448;
      var $51300=$449;
      var $51301=$450;
      __label__ = 13865; break;
    case 13865: // $51302
      __label__ = 14611; break;
    case 13866: // $51303
      var $51304=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51305=$51304.f0;
      $4692=$51305;
      var $51306=$51304.f1;
      $4693=$51306;
      var $51307=$445;
      var $51308=$446;
      var $51309=$447;
      HEAP32[(($445)>>2)]=$34947;
      HEAP32[(($446)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($447)>>2)]=511;
      var $51310=HEAP32[(($445)>>2)];
      var $51311=(($51310)|0)!=0;
      if ($51311) { __label__ = 13867; break; } else { __label__ = 13869; break; }
    case 13867: // $51312
      var $51313=HEAP32[(($445)>>2)];
      var $51314=HEAP32[(($446)>>2)];
      var $51315=HEAP32[(($447)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51313, $51314, $51315) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13868; break; } else { __label__ = 14612; break; }
    case 13868: // $_noexc2043
      __label__ = 13869; break;
    case 13869: // $_ZdlPvPKci_exit2044
      var $51316=$445;
      var $51317=$446;
      var $51318=$447;
      __label__ = 13870; break;
    case 13870: // $51319
      __label__ = 14611; break;
    case 13871: // $51320
      var $51321=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51322=$51321.f0;
      $4692=$51322;
      var $51323=$51321.f1;
      $4693=$51323;
      var $51324=$442;
      var $51325=$443;
      var $51326=$444;
      HEAP32[(($442)>>2)]=$35014;
      HEAP32[(($443)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($444)>>2)]=512;
      var $51327=HEAP32[(($442)>>2)];
      var $51328=(($51327)|0)!=0;
      if ($51328) { __label__ = 13872; break; } else { __label__ = 13874; break; }
    case 13872: // $51329
      var $51330=HEAP32[(($442)>>2)];
      var $51331=HEAP32[(($443)>>2)];
      var $51332=HEAP32[(($444)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51330, $51331, $51332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13873; break; } else { __label__ = 14612; break; }
    case 13873: // $_noexc2045
      __label__ = 13874; break;
    case 13874: // $_ZdlPvPKci_exit2046
      var $51333=$442;
      var $51334=$443;
      var $51335=$444;
      __label__ = 13875; break;
    case 13875: // $51336
      __label__ = 14611; break;
    case 13876: // $51337
      var $51338=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51339=$51338.f0;
      $4692=$51339;
      var $51340=$51338.f1;
      $4693=$51340;
      var $51341=$439;
      var $51342=$440;
      var $51343=$441;
      HEAP32[(($439)>>2)]=$35081;
      HEAP32[(($440)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($441)>>2)]=513;
      var $51344=HEAP32[(($439)>>2)];
      var $51345=(($51344)|0)!=0;
      if ($51345) { __label__ = 13877; break; } else { __label__ = 13879; break; }
    case 13877: // $51346
      var $51347=HEAP32[(($439)>>2)];
      var $51348=HEAP32[(($440)>>2)];
      var $51349=HEAP32[(($441)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51347, $51348, $51349) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13878; break; } else { __label__ = 14612; break; }
    case 13878: // $_noexc2047
      __label__ = 13879; break;
    case 13879: // $_ZdlPvPKci_exit2048
      var $51350=$439;
      var $51351=$440;
      var $51352=$441;
      __label__ = 13880; break;
    case 13880: // $51353
      __label__ = 14611; break;
    case 13881: // $51354
      var $51355=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51356=$51355.f0;
      $4692=$51356;
      var $51357=$51355.f1;
      $4693=$51357;
      var $51358=$436;
      var $51359=$437;
      var $51360=$438;
      HEAP32[(($436)>>2)]=$35148;
      HEAP32[(($437)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($438)>>2)]=514;
      var $51361=HEAP32[(($436)>>2)];
      var $51362=(($51361)|0)!=0;
      if ($51362) { __label__ = 13882; break; } else { __label__ = 13884; break; }
    case 13882: // $51363
      var $51364=HEAP32[(($436)>>2)];
      var $51365=HEAP32[(($437)>>2)];
      var $51366=HEAP32[(($438)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51364, $51365, $51366) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13883; break; } else { __label__ = 14612; break; }
    case 13883: // $_noexc2049
      __label__ = 13884; break;
    case 13884: // $_ZdlPvPKci_exit2050
      var $51367=$436;
      var $51368=$437;
      var $51369=$438;
      __label__ = 13885; break;
    case 13885: // $51370
      __label__ = 14611; break;
    case 13886: // $51371
      var $51372=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51373=$51372.f0;
      $4692=$51373;
      var $51374=$51372.f1;
      $4693=$51374;
      var $51375=$433;
      var $51376=$434;
      var $51377=$435;
      HEAP32[(($433)>>2)]=$35215;
      HEAP32[(($434)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($435)>>2)]=515;
      var $51378=HEAP32[(($433)>>2)];
      var $51379=(($51378)|0)!=0;
      if ($51379) { __label__ = 13887; break; } else { __label__ = 13889; break; }
    case 13887: // $51380
      var $51381=HEAP32[(($433)>>2)];
      var $51382=HEAP32[(($434)>>2)];
      var $51383=HEAP32[(($435)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51381, $51382, $51383) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13888; break; } else { __label__ = 14612; break; }
    case 13888: // $_noexc2051
      __label__ = 13889; break;
    case 13889: // $_ZdlPvPKci_exit2052
      var $51384=$433;
      var $51385=$434;
      var $51386=$435;
      __label__ = 13890; break;
    case 13890: // $51387
      __label__ = 14611; break;
    case 13891: // $51388
      var $51389=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51390=$51389.f0;
      $4692=$51390;
      var $51391=$51389.f1;
      $4693=$51391;
      var $51392=$430;
      var $51393=$431;
      var $51394=$432;
      HEAP32[(($430)>>2)]=$35282;
      HEAP32[(($431)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($432)>>2)]=517;
      var $51395=HEAP32[(($430)>>2)];
      var $51396=(($51395)|0)!=0;
      if ($51396) { __label__ = 13892; break; } else { __label__ = 13894; break; }
    case 13892: // $51397
      var $51398=HEAP32[(($430)>>2)];
      var $51399=HEAP32[(($431)>>2)];
      var $51400=HEAP32[(($432)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51398, $51399, $51400) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13893; break; } else { __label__ = 14612; break; }
    case 13893: // $_noexc2053
      __label__ = 13894; break;
    case 13894: // $_ZdlPvPKci_exit2054
      var $51401=$430;
      var $51402=$431;
      var $51403=$432;
      __label__ = 13895; break;
    case 13895: // $51404
      __label__ = 14611; break;
    case 13896: // $51405
      var $51406=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51407=$51406.f0;
      $4692=$51407;
      var $51408=$51406.f1;
      $4693=$51408;
      var $51409=$427;
      var $51410=$428;
      var $51411=$429;
      HEAP32[(($427)>>2)]=$35349;
      HEAP32[(($428)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($429)>>2)]=518;
      var $51412=HEAP32[(($427)>>2)];
      var $51413=(($51412)|0)!=0;
      if ($51413) { __label__ = 13897; break; } else { __label__ = 13899; break; }
    case 13897: // $51414
      var $51415=HEAP32[(($427)>>2)];
      var $51416=HEAP32[(($428)>>2)];
      var $51417=HEAP32[(($429)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51415, $51416, $51417) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13898; break; } else { __label__ = 14612; break; }
    case 13898: // $_noexc2055
      __label__ = 13899; break;
    case 13899: // $_ZdlPvPKci_exit2056
      var $51418=$427;
      var $51419=$428;
      var $51420=$429;
      __label__ = 13900; break;
    case 13900: // $51421
      __label__ = 14611; break;
    case 13901: // $51422
      var $51423=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51424=$51423.f0;
      $4692=$51424;
      var $51425=$51423.f1;
      $4693=$51425;
      var $51426=$424;
      var $51427=$425;
      var $51428=$426;
      HEAP32[(($424)>>2)]=$35416;
      HEAP32[(($425)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($426)>>2)]=519;
      var $51429=HEAP32[(($424)>>2)];
      var $51430=(($51429)|0)!=0;
      if ($51430) { __label__ = 13902; break; } else { __label__ = 13904; break; }
    case 13902: // $51431
      var $51432=HEAP32[(($424)>>2)];
      var $51433=HEAP32[(($425)>>2)];
      var $51434=HEAP32[(($426)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51432, $51433, $51434) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13903; break; } else { __label__ = 14612; break; }
    case 13903: // $_noexc2057
      __label__ = 13904; break;
    case 13904: // $_ZdlPvPKci_exit2058
      var $51435=$424;
      var $51436=$425;
      var $51437=$426;
      __label__ = 13905; break;
    case 13905: // $51438
      __label__ = 14611; break;
    case 13906: // $51439
      var $51440=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51441=$51440.f0;
      $4692=$51441;
      var $51442=$51440.f1;
      $4693=$51442;
      var $51443=$421;
      var $51444=$422;
      var $51445=$423;
      HEAP32[(($421)>>2)]=$35483;
      HEAP32[(($422)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($423)>>2)]=520;
      var $51446=HEAP32[(($421)>>2)];
      var $51447=(($51446)|0)!=0;
      if ($51447) { __label__ = 13907; break; } else { __label__ = 13909; break; }
    case 13907: // $51448
      var $51449=HEAP32[(($421)>>2)];
      var $51450=HEAP32[(($422)>>2)];
      var $51451=HEAP32[(($423)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51449, $51450, $51451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13908; break; } else { __label__ = 14612; break; }
    case 13908: // $_noexc2059
      __label__ = 13909; break;
    case 13909: // $_ZdlPvPKci_exit2060
      var $51452=$421;
      var $51453=$422;
      var $51454=$423;
      __label__ = 13910; break;
    case 13910: // $51455
      __label__ = 14611; break;
    case 13911: // $51456
      var $51457=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51458=$51457.f0;
      $4692=$51458;
      var $51459=$51457.f1;
      $4693=$51459;
      var $51460=$418;
      var $51461=$419;
      var $51462=$420;
      HEAP32[(($418)>>2)]=$35550;
      HEAP32[(($419)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($420)>>2)]=521;
      var $51463=HEAP32[(($418)>>2)];
      var $51464=(($51463)|0)!=0;
      if ($51464) { __label__ = 13912; break; } else { __label__ = 13914; break; }
    case 13912: // $51465
      var $51466=HEAP32[(($418)>>2)];
      var $51467=HEAP32[(($419)>>2)];
      var $51468=HEAP32[(($420)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51466, $51467, $51468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13913; break; } else { __label__ = 14612; break; }
    case 13913: // $_noexc2061
      __label__ = 13914; break;
    case 13914: // $_ZdlPvPKci_exit2062
      var $51469=$418;
      var $51470=$419;
      var $51471=$420;
      __label__ = 13915; break;
    case 13915: // $51472
      __label__ = 14611; break;
    case 13916: // $51473
      var $51474=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51475=$51474.f0;
      $4692=$51475;
      var $51476=$51474.f1;
      $4693=$51476;
      var $51477=$415;
      var $51478=$416;
      var $51479=$417;
      HEAP32[(($415)>>2)]=$35617;
      HEAP32[(($416)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($417)>>2)]=522;
      var $51480=HEAP32[(($415)>>2)];
      var $51481=(($51480)|0)!=0;
      if ($51481) { __label__ = 13917; break; } else { __label__ = 13919; break; }
    case 13917: // $51482
      var $51483=HEAP32[(($415)>>2)];
      var $51484=HEAP32[(($416)>>2)];
      var $51485=HEAP32[(($417)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51483, $51484, $51485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13918; break; } else { __label__ = 14612; break; }
    case 13918: // $_noexc2063
      __label__ = 13919; break;
    case 13919: // $_ZdlPvPKci_exit2064
      var $51486=$415;
      var $51487=$416;
      var $51488=$417;
      __label__ = 13920; break;
    case 13920: // $51489
      __label__ = 14611; break;
    case 13921: // $51490
      var $51491=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51492=$51491.f0;
      $4692=$51492;
      var $51493=$51491.f1;
      $4693=$51493;
      var $51494=$412;
      var $51495=$413;
      var $51496=$414;
      HEAP32[(($412)>>2)]=$35684;
      HEAP32[(($413)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($414)>>2)]=523;
      var $51497=HEAP32[(($412)>>2)];
      var $51498=(($51497)|0)!=0;
      if ($51498) { __label__ = 13922; break; } else { __label__ = 13924; break; }
    case 13922: // $51499
      var $51500=HEAP32[(($412)>>2)];
      var $51501=HEAP32[(($413)>>2)];
      var $51502=HEAP32[(($414)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51500, $51501, $51502) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13923; break; } else { __label__ = 14612; break; }
    case 13923: // $_noexc2065
      __label__ = 13924; break;
    case 13924: // $_ZdlPvPKci_exit2066
      var $51503=$412;
      var $51504=$413;
      var $51505=$414;
      __label__ = 13925; break;
    case 13925: // $51506
      __label__ = 14611; break;
    case 13926: // $51507
      var $51508=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51509=$51508.f0;
      $4692=$51509;
      var $51510=$51508.f1;
      $4693=$51510;
      var $51511=$409;
      var $51512=$410;
      var $51513=$411;
      HEAP32[(($409)>>2)]=$35751;
      HEAP32[(($410)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($411)>>2)]=524;
      var $51514=HEAP32[(($409)>>2)];
      var $51515=(($51514)|0)!=0;
      if ($51515) { __label__ = 13927; break; } else { __label__ = 13929; break; }
    case 13927: // $51516
      var $51517=HEAP32[(($409)>>2)];
      var $51518=HEAP32[(($410)>>2)];
      var $51519=HEAP32[(($411)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51517, $51518, $51519) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13928; break; } else { __label__ = 14612; break; }
    case 13928: // $_noexc2067
      __label__ = 13929; break;
    case 13929: // $_ZdlPvPKci_exit2068
      var $51520=$409;
      var $51521=$410;
      var $51522=$411;
      __label__ = 13930; break;
    case 13930: // $51523
      __label__ = 14611; break;
    case 13931: // $51524
      var $51525=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51526=$51525.f0;
      $4692=$51526;
      var $51527=$51525.f1;
      $4693=$51527;
      var $51528=$406;
      var $51529=$407;
      var $51530=$408;
      HEAP32[(($406)>>2)]=$35818;
      HEAP32[(($407)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($408)>>2)]=526;
      var $51531=HEAP32[(($406)>>2)];
      var $51532=(($51531)|0)!=0;
      if ($51532) { __label__ = 13932; break; } else { __label__ = 13934; break; }
    case 13932: // $51533
      var $51534=HEAP32[(($406)>>2)];
      var $51535=HEAP32[(($407)>>2)];
      var $51536=HEAP32[(($408)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51534, $51535, $51536) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13933; break; } else { __label__ = 14612; break; }
    case 13933: // $_noexc2069
      __label__ = 13934; break;
    case 13934: // $_ZdlPvPKci_exit2070
      var $51537=$406;
      var $51538=$407;
      var $51539=$408;
      __label__ = 13935; break;
    case 13935: // $51540
      __label__ = 14611; break;
    case 13936: // $51541
      var $51542=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51543=$51542.f0;
      $4692=$51543;
      var $51544=$51542.f1;
      $4693=$51544;
      var $51545=$403;
      var $51546=$404;
      var $51547=$405;
      HEAP32[(($403)>>2)]=$35885;
      HEAP32[(($404)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($405)>>2)]=527;
      var $51548=HEAP32[(($403)>>2)];
      var $51549=(($51548)|0)!=0;
      if ($51549) { __label__ = 13937; break; } else { __label__ = 13939; break; }
    case 13937: // $51550
      var $51551=HEAP32[(($403)>>2)];
      var $51552=HEAP32[(($404)>>2)];
      var $51553=HEAP32[(($405)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51551, $51552, $51553) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13938; break; } else { __label__ = 14612; break; }
    case 13938: // $_noexc2071
      __label__ = 13939; break;
    case 13939: // $_ZdlPvPKci_exit2072
      var $51554=$403;
      var $51555=$404;
      var $51556=$405;
      __label__ = 13940; break;
    case 13940: // $51557
      __label__ = 14611; break;
    case 13941: // $51558
      var $51559=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51560=$51559.f0;
      $4692=$51560;
      var $51561=$51559.f1;
      $4693=$51561;
      var $51562=$400;
      var $51563=$401;
      var $51564=$402;
      HEAP32[(($400)>>2)]=$35952;
      HEAP32[(($401)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($402)>>2)]=528;
      var $51565=HEAP32[(($400)>>2)];
      var $51566=(($51565)|0)!=0;
      if ($51566) { __label__ = 13942; break; } else { __label__ = 13944; break; }
    case 13942: // $51567
      var $51568=HEAP32[(($400)>>2)];
      var $51569=HEAP32[(($401)>>2)];
      var $51570=HEAP32[(($402)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51568, $51569, $51570) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13943; break; } else { __label__ = 14612; break; }
    case 13943: // $_noexc2073
      __label__ = 13944; break;
    case 13944: // $_ZdlPvPKci_exit2074
      var $51571=$400;
      var $51572=$401;
      var $51573=$402;
      __label__ = 13945; break;
    case 13945: // $51574
      __label__ = 14611; break;
    case 13946: // $51575
      var $51576=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51577=$51576.f0;
      $4692=$51577;
      var $51578=$51576.f1;
      $4693=$51578;
      var $51579=$397;
      var $51580=$398;
      var $51581=$399;
      HEAP32[(($397)>>2)]=$36019;
      HEAP32[(($398)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($399)>>2)]=529;
      var $51582=HEAP32[(($397)>>2)];
      var $51583=(($51582)|0)!=0;
      if ($51583) { __label__ = 13947; break; } else { __label__ = 13949; break; }
    case 13947: // $51584
      var $51585=HEAP32[(($397)>>2)];
      var $51586=HEAP32[(($398)>>2)];
      var $51587=HEAP32[(($399)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51585, $51586, $51587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13948; break; } else { __label__ = 14612; break; }
    case 13948: // $_noexc2075
      __label__ = 13949; break;
    case 13949: // $_ZdlPvPKci_exit2076
      var $51588=$397;
      var $51589=$398;
      var $51590=$399;
      __label__ = 13950; break;
    case 13950: // $51591
      __label__ = 14611; break;
    case 13951: // $51592
      var $51593=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51594=$51593.f0;
      $4692=$51594;
      var $51595=$51593.f1;
      $4693=$51595;
      var $51596=$394;
      var $51597=$395;
      var $51598=$396;
      HEAP32[(($394)>>2)]=$36086;
      HEAP32[(($395)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($396)>>2)]=530;
      var $51599=HEAP32[(($394)>>2)];
      var $51600=(($51599)|0)!=0;
      if ($51600) { __label__ = 13952; break; } else { __label__ = 13954; break; }
    case 13952: // $51601
      var $51602=HEAP32[(($394)>>2)];
      var $51603=HEAP32[(($395)>>2)];
      var $51604=HEAP32[(($396)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51602, $51603, $51604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13953; break; } else { __label__ = 14612; break; }
    case 13953: // $_noexc2077
      __label__ = 13954; break;
    case 13954: // $_ZdlPvPKci_exit2078
      var $51605=$394;
      var $51606=$395;
      var $51607=$396;
      __label__ = 13955; break;
    case 13955: // $51608
      __label__ = 14611; break;
    case 13956: // $51609
      var $51610=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51611=$51610.f0;
      $4692=$51611;
      var $51612=$51610.f1;
      $4693=$51612;
      var $51613=$391;
      var $51614=$392;
      var $51615=$393;
      HEAP32[(($391)>>2)]=$36153;
      HEAP32[(($392)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($393)>>2)]=531;
      var $51616=HEAP32[(($391)>>2)];
      var $51617=(($51616)|0)!=0;
      if ($51617) { __label__ = 13957; break; } else { __label__ = 13959; break; }
    case 13957: // $51618
      var $51619=HEAP32[(($391)>>2)];
      var $51620=HEAP32[(($392)>>2)];
      var $51621=HEAP32[(($393)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51619, $51620, $51621) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13958; break; } else { __label__ = 14612; break; }
    case 13958: // $_noexc2079
      __label__ = 13959; break;
    case 13959: // $_ZdlPvPKci_exit2080
      var $51622=$391;
      var $51623=$392;
      var $51624=$393;
      __label__ = 13960; break;
    case 13960: // $51625
      __label__ = 14611; break;
    case 13961: // $51626
      var $51627=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51628=$51627.f0;
      $4692=$51628;
      var $51629=$51627.f1;
      $4693=$51629;
      var $51630=$388;
      var $51631=$389;
      var $51632=$390;
      HEAP32[(($388)>>2)]=$36220;
      HEAP32[(($389)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($390)>>2)]=532;
      var $51633=HEAP32[(($388)>>2)];
      var $51634=(($51633)|0)!=0;
      if ($51634) { __label__ = 13962; break; } else { __label__ = 13964; break; }
    case 13962: // $51635
      var $51636=HEAP32[(($388)>>2)];
      var $51637=HEAP32[(($389)>>2)];
      var $51638=HEAP32[(($390)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51636, $51637, $51638) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13963; break; } else { __label__ = 14612; break; }
    case 13963: // $_noexc2081
      __label__ = 13964; break;
    case 13964: // $_ZdlPvPKci_exit2082
      var $51639=$388;
      var $51640=$389;
      var $51641=$390;
      __label__ = 13965; break;
    case 13965: // $51642
      __label__ = 14611; break;
    case 13966: // $51643
      var $51644=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51645=$51644.f0;
      $4692=$51645;
      var $51646=$51644.f1;
      $4693=$51646;
      var $51647=$385;
      var $51648=$386;
      var $51649=$387;
      HEAP32[(($385)>>2)]=$36287;
      HEAP32[(($386)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($387)>>2)]=533;
      var $51650=HEAP32[(($385)>>2)];
      var $51651=(($51650)|0)!=0;
      if ($51651) { __label__ = 13967; break; } else { __label__ = 13969; break; }
    case 13967: // $51652
      var $51653=HEAP32[(($385)>>2)];
      var $51654=HEAP32[(($386)>>2)];
      var $51655=HEAP32[(($387)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51653, $51654, $51655) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13968; break; } else { __label__ = 14612; break; }
    case 13968: // $_noexc2083
      __label__ = 13969; break;
    case 13969: // $_ZdlPvPKci_exit2084
      var $51656=$385;
      var $51657=$386;
      var $51658=$387;
      __label__ = 13970; break;
    case 13970: // $51659
      __label__ = 14611; break;
    case 13971: // $51660
      var $51661=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51662=$51661.f0;
      $4692=$51662;
      var $51663=$51661.f1;
      $4693=$51663;
      var $51664=$382;
      var $51665=$383;
      var $51666=$384;
      HEAP32[(($382)>>2)]=$36354;
      HEAP32[(($383)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($384)>>2)]=535;
      var $51667=HEAP32[(($382)>>2)];
      var $51668=(($51667)|0)!=0;
      if ($51668) { __label__ = 13972; break; } else { __label__ = 13974; break; }
    case 13972: // $51669
      var $51670=HEAP32[(($382)>>2)];
      var $51671=HEAP32[(($383)>>2)];
      var $51672=HEAP32[(($384)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51670, $51671, $51672) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13973; break; } else { __label__ = 14612; break; }
    case 13973: // $_noexc2085
      __label__ = 13974; break;
    case 13974: // $_ZdlPvPKci_exit2086
      var $51673=$382;
      var $51674=$383;
      var $51675=$384;
      __label__ = 13975; break;
    case 13975: // $51676
      __label__ = 14611; break;
    case 13976: // $51677
      var $51678=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51679=$51678.f0;
      $4692=$51679;
      var $51680=$51678.f1;
      $4693=$51680;
      var $51681=$379;
      var $51682=$380;
      var $51683=$381;
      HEAP32[(($379)>>2)]=$36421;
      HEAP32[(($380)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($381)>>2)]=536;
      var $51684=HEAP32[(($379)>>2)];
      var $51685=(($51684)|0)!=0;
      if ($51685) { __label__ = 13977; break; } else { __label__ = 13979; break; }
    case 13977: // $51686
      var $51687=HEAP32[(($379)>>2)];
      var $51688=HEAP32[(($380)>>2)];
      var $51689=HEAP32[(($381)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51687, $51688, $51689) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13978; break; } else { __label__ = 14612; break; }
    case 13978: // $_noexc2087
      __label__ = 13979; break;
    case 13979: // $_ZdlPvPKci_exit2088
      var $51690=$379;
      var $51691=$380;
      var $51692=$381;
      __label__ = 13980; break;
    case 13980: // $51693
      __label__ = 14611; break;
    case 13981: // $51694
      var $51695=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51696=$51695.f0;
      $4692=$51696;
      var $51697=$51695.f1;
      $4693=$51697;
      var $51698=$376;
      var $51699=$377;
      var $51700=$378;
      HEAP32[(($376)>>2)]=$36488;
      HEAP32[(($377)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($378)>>2)]=537;
      var $51701=HEAP32[(($376)>>2)];
      var $51702=(($51701)|0)!=0;
      if ($51702) { __label__ = 13982; break; } else { __label__ = 13984; break; }
    case 13982: // $51703
      var $51704=HEAP32[(($376)>>2)];
      var $51705=HEAP32[(($377)>>2)];
      var $51706=HEAP32[(($378)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51704, $51705, $51706) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13983; break; } else { __label__ = 14612; break; }
    case 13983: // $_noexc2089
      __label__ = 13984; break;
    case 13984: // $_ZdlPvPKci_exit2090
      var $51707=$376;
      var $51708=$377;
      var $51709=$378;
      __label__ = 13985; break;
    case 13985: // $51710
      __label__ = 14611; break;
    case 13986: // $51711
      var $51712=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51713=$51712.f0;
      $4692=$51713;
      var $51714=$51712.f1;
      $4693=$51714;
      var $51715=$373;
      var $51716=$374;
      var $51717=$375;
      HEAP32[(($373)>>2)]=$36555;
      HEAP32[(($374)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($375)>>2)]=538;
      var $51718=HEAP32[(($373)>>2)];
      var $51719=(($51718)|0)!=0;
      if ($51719) { __label__ = 13987; break; } else { __label__ = 13989; break; }
    case 13987: // $51720
      var $51721=HEAP32[(($373)>>2)];
      var $51722=HEAP32[(($374)>>2)];
      var $51723=HEAP32[(($375)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51721, $51722, $51723) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13988; break; } else { __label__ = 14612; break; }
    case 13988: // $_noexc2091
      __label__ = 13989; break;
    case 13989: // $_ZdlPvPKci_exit2092
      var $51724=$373;
      var $51725=$374;
      var $51726=$375;
      __label__ = 13990; break;
    case 13990: // $51727
      __label__ = 14611; break;
    case 13991: // $51728
      var $51729=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51730=$51729.f0;
      $4692=$51730;
      var $51731=$51729.f1;
      $4693=$51731;
      var $51732=$370;
      var $51733=$371;
      var $51734=$372;
      HEAP32[(($370)>>2)]=$36622;
      HEAP32[(($371)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($372)>>2)]=539;
      var $51735=HEAP32[(($370)>>2)];
      var $51736=(($51735)|0)!=0;
      if ($51736) { __label__ = 13992; break; } else { __label__ = 13994; break; }
    case 13992: // $51737
      var $51738=HEAP32[(($370)>>2)];
      var $51739=HEAP32[(($371)>>2)];
      var $51740=HEAP32[(($372)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51738, $51739, $51740) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13993; break; } else { __label__ = 14612; break; }
    case 13993: // $_noexc2093
      __label__ = 13994; break;
    case 13994: // $_ZdlPvPKci_exit2094
      var $51741=$370;
      var $51742=$371;
      var $51743=$372;
      __label__ = 13995; break;
    case 13995: // $51744
      __label__ = 14611; break;
    case 13996: // $51745
      var $51746=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51747=$51746.f0;
      $4692=$51747;
      var $51748=$51746.f1;
      $4693=$51748;
      var $51749=$367;
      var $51750=$368;
      var $51751=$369;
      HEAP32[(($367)>>2)]=$36689;
      HEAP32[(($368)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($369)>>2)]=540;
      var $51752=HEAP32[(($367)>>2)];
      var $51753=(($51752)|0)!=0;
      if ($51753) { __label__ = 13997; break; } else { __label__ = 13999; break; }
    case 13997: // $51754
      var $51755=HEAP32[(($367)>>2)];
      var $51756=HEAP32[(($368)>>2)];
      var $51757=HEAP32[(($369)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51755, $51756, $51757) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13998; break; } else { __label__ = 14612; break; }
    case 13998: // $_noexc2095
      __label__ = 13999; break;
    case 13999: // $_ZdlPvPKci_exit2096
      var $51758=$367;
      var $51759=$368;
      var $51760=$369;
      __label__ = 14000; break;
    case 14000: // $51761
      __label__ = 14611; break;
    case 14001: // $51762
      var $51763=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51764=$51763.f0;
      $4692=$51764;
      var $51765=$51763.f1;
      $4693=$51765;
      var $51766=$364;
      var $51767=$365;
      var $51768=$366;
      HEAP32[(($364)>>2)]=$36756;
      HEAP32[(($365)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($366)>>2)]=541;
      var $51769=HEAP32[(($364)>>2)];
      var $51770=(($51769)|0)!=0;
      if ($51770) { __label__ = 14002; break; } else { __label__ = 14004; break; }
    case 14002: // $51771
      var $51772=HEAP32[(($364)>>2)];
      var $51773=HEAP32[(($365)>>2)];
      var $51774=HEAP32[(($366)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51772, $51773, $51774) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14003; break; } else { __label__ = 14612; break; }
    case 14003: // $_noexc2097
      __label__ = 14004; break;
    case 14004: // $_ZdlPvPKci_exit2098
      var $51775=$364;
      var $51776=$365;
      var $51777=$366;
      __label__ = 14005; break;
    case 14005: // $51778
      __label__ = 14611; break;
    case 14006: // $51779
      var $51780=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51781=$51780.f0;
      $4692=$51781;
      var $51782=$51780.f1;
      $4693=$51782;
      var $51783=$361;
      var $51784=$362;
      var $51785=$363;
      HEAP32[(($361)>>2)]=$36823;
      HEAP32[(($362)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($363)>>2)]=542;
      var $51786=HEAP32[(($361)>>2)];
      var $51787=(($51786)|0)!=0;
      if ($51787) { __label__ = 14007; break; } else { __label__ = 14009; break; }
    case 14007: // $51788
      var $51789=HEAP32[(($361)>>2)];
      var $51790=HEAP32[(($362)>>2)];
      var $51791=HEAP32[(($363)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51789, $51790, $51791) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14008; break; } else { __label__ = 14612; break; }
    case 14008: // $_noexc2099
      __label__ = 14009; break;
    case 14009: // $_ZdlPvPKci_exit2100
      var $51792=$361;
      var $51793=$362;
      var $51794=$363;
      __label__ = 14010; break;
    case 14010: // $51795
      __label__ = 14611; break;
    case 14011: // $51796
      var $51797=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51798=$51797.f0;
      $4692=$51798;
      var $51799=$51797.f1;
      $4693=$51799;
      var $51800=$358;
      var $51801=$359;
      var $51802=$360;
      HEAP32[(($358)>>2)]=$36890;
      HEAP32[(($359)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($360)>>2)]=544;
      var $51803=HEAP32[(($358)>>2)];
      var $51804=(($51803)|0)!=0;
      if ($51804) { __label__ = 14012; break; } else { __label__ = 14014; break; }
    case 14012: // $51805
      var $51806=HEAP32[(($358)>>2)];
      var $51807=HEAP32[(($359)>>2)];
      var $51808=HEAP32[(($360)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51806, $51807, $51808) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14013; break; } else { __label__ = 14612; break; }
    case 14013: // $_noexc2101
      __label__ = 14014; break;
    case 14014: // $_ZdlPvPKci_exit2102
      var $51809=$358;
      var $51810=$359;
      var $51811=$360;
      __label__ = 14015; break;
    case 14015: // $51812
      __label__ = 14611; break;
    case 14016: // $51813
      var $51814=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51815=$51814.f0;
      $4692=$51815;
      var $51816=$51814.f1;
      $4693=$51816;
      var $51817=$355;
      var $51818=$356;
      var $51819=$357;
      HEAP32[(($355)>>2)]=$36957;
      HEAP32[(($356)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($357)>>2)]=545;
      var $51820=HEAP32[(($355)>>2)];
      var $51821=(($51820)|0)!=0;
      if ($51821) { __label__ = 14017; break; } else { __label__ = 14019; break; }
    case 14017: // $51822
      var $51823=HEAP32[(($355)>>2)];
      var $51824=HEAP32[(($356)>>2)];
      var $51825=HEAP32[(($357)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51823, $51824, $51825) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14018; break; } else { __label__ = 14612; break; }
    case 14018: // $_noexc2103
      __label__ = 14019; break;
    case 14019: // $_ZdlPvPKci_exit2104
      var $51826=$355;
      var $51827=$356;
      var $51828=$357;
      __label__ = 14020; break;
    case 14020: // $51829
      __label__ = 14611; break;
    case 14021: // $51830
      var $51831=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51832=$51831.f0;
      $4692=$51832;
      var $51833=$51831.f1;
      $4693=$51833;
      var $51834=$352;
      var $51835=$353;
      var $51836=$354;
      HEAP32[(($352)>>2)]=$37024;
      HEAP32[(($353)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($354)>>2)]=546;
      var $51837=HEAP32[(($352)>>2)];
      var $51838=(($51837)|0)!=0;
      if ($51838) { __label__ = 14022; break; } else { __label__ = 14024; break; }
    case 14022: // $51839
      var $51840=HEAP32[(($352)>>2)];
      var $51841=HEAP32[(($353)>>2)];
      var $51842=HEAP32[(($354)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51840, $51841, $51842) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14023; break; } else { __label__ = 14612; break; }
    case 14023: // $_noexc2105
      __label__ = 14024; break;
    case 14024: // $_ZdlPvPKci_exit2106
      var $51843=$352;
      var $51844=$353;
      var $51845=$354;
      __label__ = 14025; break;
    case 14025: // $51846
      __label__ = 14611; break;
    case 14026: // $51847
      var $51848=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51849=$51848.f0;
      $4692=$51849;
      var $51850=$51848.f1;
      $4693=$51850;
      var $51851=$349;
      var $51852=$350;
      var $51853=$351;
      HEAP32[(($349)>>2)]=$37091;
      HEAP32[(($350)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($351)>>2)]=547;
      var $51854=HEAP32[(($349)>>2)];
      var $51855=(($51854)|0)!=0;
      if ($51855) { __label__ = 14027; break; } else { __label__ = 14029; break; }
    case 14027: // $51856
      var $51857=HEAP32[(($349)>>2)];
      var $51858=HEAP32[(($350)>>2)];
      var $51859=HEAP32[(($351)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51857, $51858, $51859) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14028; break; } else { __label__ = 14612; break; }
    case 14028: // $_noexc2107
      __label__ = 14029; break;
    case 14029: // $_ZdlPvPKci_exit2108
      var $51860=$349;
      var $51861=$350;
      var $51862=$351;
      __label__ = 14030; break;
    case 14030: // $51863
      __label__ = 14611; break;
    case 14031: // $51864
      var $51865=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51866=$51865.f0;
      $4692=$51866;
      var $51867=$51865.f1;
      $4693=$51867;
      var $51868=$346;
      var $51869=$347;
      var $51870=$348;
      HEAP32[(($346)>>2)]=$37158;
      HEAP32[(($347)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($348)>>2)]=548;
      var $51871=HEAP32[(($346)>>2)];
      var $51872=(($51871)|0)!=0;
      if ($51872) { __label__ = 14032; break; } else { __label__ = 14034; break; }
    case 14032: // $51873
      var $51874=HEAP32[(($346)>>2)];
      var $51875=HEAP32[(($347)>>2)];
      var $51876=HEAP32[(($348)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51874, $51875, $51876) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14033; break; } else { __label__ = 14612; break; }
    case 14033: // $_noexc2109
      __label__ = 14034; break;
    case 14034: // $_ZdlPvPKci_exit2110
      var $51877=$346;
      var $51878=$347;
      var $51879=$348;
      __label__ = 14035; break;
    case 14035: // $51880
      __label__ = 14611; break;
    case 14036: // $51881
      var $51882=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51883=$51882.f0;
      $4692=$51883;
      var $51884=$51882.f1;
      $4693=$51884;
      var $51885=$343;
      var $51886=$344;
      var $51887=$345;
      HEAP32[(($343)>>2)]=$37225;
      HEAP32[(($344)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($345)>>2)]=549;
      var $51888=HEAP32[(($343)>>2)];
      var $51889=(($51888)|0)!=0;
      if ($51889) { __label__ = 14037; break; } else { __label__ = 14039; break; }
    case 14037: // $51890
      var $51891=HEAP32[(($343)>>2)];
      var $51892=HEAP32[(($344)>>2)];
      var $51893=HEAP32[(($345)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51891, $51892, $51893) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14038; break; } else { __label__ = 14612; break; }
    case 14038: // $_noexc2111
      __label__ = 14039; break;
    case 14039: // $_ZdlPvPKci_exit2112
      var $51894=$343;
      var $51895=$344;
      var $51896=$345;
      __label__ = 14040; break;
    case 14040: // $51897
      __label__ = 14611; break;
    case 14041: // $51898
      var $51899=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51900=$51899.f0;
      $4692=$51900;
      var $51901=$51899.f1;
      $4693=$51901;
      var $51902=$340;
      var $51903=$341;
      var $51904=$342;
      HEAP32[(($340)>>2)]=$37292;
      HEAP32[(($341)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($342)>>2)]=550;
      var $51905=HEAP32[(($340)>>2)];
      var $51906=(($51905)|0)!=0;
      if ($51906) { __label__ = 14042; break; } else { __label__ = 14044; break; }
    case 14042: // $51907
      var $51908=HEAP32[(($340)>>2)];
      var $51909=HEAP32[(($341)>>2)];
      var $51910=HEAP32[(($342)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51908, $51909, $51910) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14043; break; } else { __label__ = 14612; break; }
    case 14043: // $_noexc2113
      __label__ = 14044; break;
    case 14044: // $_ZdlPvPKci_exit2114
      var $51911=$340;
      var $51912=$341;
      var $51913=$342;
      __label__ = 14045; break;
    case 14045: // $51914
      __label__ = 14611; break;
    case 14046: // $51915
      var $51916=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51917=$51916.f0;
      $4692=$51917;
      var $51918=$51916.f1;
      $4693=$51918;
      var $51919=$337;
      var $51920=$338;
      var $51921=$339;
      HEAP32[(($337)>>2)]=$37359;
      HEAP32[(($338)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($339)>>2)]=551;
      var $51922=HEAP32[(($337)>>2)];
      var $51923=(($51922)|0)!=0;
      if ($51923) { __label__ = 14047; break; } else { __label__ = 14049; break; }
    case 14047: // $51924
      var $51925=HEAP32[(($337)>>2)];
      var $51926=HEAP32[(($338)>>2)];
      var $51927=HEAP32[(($339)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51925, $51926, $51927) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14048; break; } else { __label__ = 14612; break; }
    case 14048: // $_noexc2115
      __label__ = 14049; break;
    case 14049: // $_ZdlPvPKci_exit2116
      var $51928=$337;
      var $51929=$338;
      var $51930=$339;
      __label__ = 14050; break;
    case 14050: // $51931
      __label__ = 14611; break;
    case 14051: // $51932
      var $51933=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51934=$51933.f0;
      $4692=$51934;
      var $51935=$51933.f1;
      $4693=$51935;
      var $51936=$334;
      var $51937=$335;
      var $51938=$336;
      HEAP32[(($334)>>2)]=$37426;
      HEAP32[(($335)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($336)>>2)]=553;
      var $51939=HEAP32[(($334)>>2)];
      var $51940=(($51939)|0)!=0;
      if ($51940) { __label__ = 14052; break; } else { __label__ = 14054; break; }
    case 14052: // $51941
      var $51942=HEAP32[(($334)>>2)];
      var $51943=HEAP32[(($335)>>2)];
      var $51944=HEAP32[(($336)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51942, $51943, $51944) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14053; break; } else { __label__ = 14612; break; }
    case 14053: // $_noexc2117
      __label__ = 14054; break;
    case 14054: // $_ZdlPvPKci_exit2118
      var $51945=$334;
      var $51946=$335;
      var $51947=$336;
      __label__ = 14055; break;
    case 14055: // $51948
      __label__ = 14611; break;
    case 14056: // $51949
      var $51950=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51951=$51950.f0;
      $4692=$51951;
      var $51952=$51950.f1;
      $4693=$51952;
      var $51953=$331;
      var $51954=$332;
      var $51955=$333;
      HEAP32[(($331)>>2)]=$37493;
      HEAP32[(($332)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($333)>>2)]=554;
      var $51956=HEAP32[(($331)>>2)];
      var $51957=(($51956)|0)!=0;
      if ($51957) { __label__ = 14057; break; } else { __label__ = 14059; break; }
    case 14057: // $51958
      var $51959=HEAP32[(($331)>>2)];
      var $51960=HEAP32[(($332)>>2)];
      var $51961=HEAP32[(($333)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51959, $51960, $51961) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14058; break; } else { __label__ = 14612; break; }
    case 14058: // $_noexc2119
      __label__ = 14059; break;
    case 14059: // $_ZdlPvPKci_exit2120
      var $51962=$331;
      var $51963=$332;
      var $51964=$333;
      __label__ = 14060; break;
    case 14060: // $51965
      __label__ = 14611; break;
    case 14061: // $51966
      var $51967=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51968=$51967.f0;
      $4692=$51968;
      var $51969=$51967.f1;
      $4693=$51969;
      var $51970=$328;
      var $51971=$329;
      var $51972=$330;
      HEAP32[(($328)>>2)]=$37560;
      HEAP32[(($329)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($330)>>2)]=555;
      var $51973=HEAP32[(($328)>>2)];
      var $51974=(($51973)|0)!=0;
      if ($51974) { __label__ = 14062; break; } else { __label__ = 14064; break; }
    case 14062: // $51975
      var $51976=HEAP32[(($328)>>2)];
      var $51977=HEAP32[(($329)>>2)];
      var $51978=HEAP32[(($330)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51976, $51977, $51978) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14063; break; } else { __label__ = 14612; break; }
    case 14063: // $_noexc2121
      __label__ = 14064; break;
    case 14064: // $_ZdlPvPKci_exit2122
      var $51979=$328;
      var $51980=$329;
      var $51981=$330;
      __label__ = 14065; break;
    case 14065: // $51982
      __label__ = 14611; break;
    case 14066: // $51983
      var $51984=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51985=$51984.f0;
      $4692=$51985;
      var $51986=$51984.f1;
      $4693=$51986;
      var $51987=$325;
      var $51988=$326;
      var $51989=$327;
      HEAP32[(($325)>>2)]=$37627;
      HEAP32[(($326)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($327)>>2)]=556;
      var $51990=HEAP32[(($325)>>2)];
      var $51991=(($51990)|0)!=0;
      if ($51991) { __label__ = 14067; break; } else { __label__ = 14069; break; }
    case 14067: // $51992
      var $51993=HEAP32[(($325)>>2)];
      var $51994=HEAP32[(($326)>>2)];
      var $51995=HEAP32[(($327)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($51993, $51994, $51995) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14068; break; } else { __label__ = 14612; break; }
    case 14068: // $_noexc2123
      __label__ = 14069; break;
    case 14069: // $_ZdlPvPKci_exit2124
      var $51996=$325;
      var $51997=$326;
      var $51998=$327;
      __label__ = 14070; break;
    case 14070: // $51999
      __label__ = 14611; break;
    case 14071: // $52000
      var $52001=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52002=$52001.f0;
      $4692=$52002;
      var $52003=$52001.f1;
      $4693=$52003;
      var $52004=$322;
      var $52005=$323;
      var $52006=$324;
      HEAP32[(($322)>>2)]=$37694;
      HEAP32[(($323)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($324)>>2)]=557;
      var $52007=HEAP32[(($322)>>2)];
      var $52008=(($52007)|0)!=0;
      if ($52008) { __label__ = 14072; break; } else { __label__ = 14074; break; }
    case 14072: // $52009
      var $52010=HEAP32[(($322)>>2)];
      var $52011=HEAP32[(($323)>>2)];
      var $52012=HEAP32[(($324)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52010, $52011, $52012) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14073; break; } else { __label__ = 14612; break; }
    case 14073: // $_noexc2125
      __label__ = 14074; break;
    case 14074: // $_ZdlPvPKci_exit2126
      var $52013=$322;
      var $52014=$323;
      var $52015=$324;
      __label__ = 14075; break;
    case 14075: // $52016
      __label__ = 14611; break;
    case 14076: // $52017
      var $52018=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52019=$52018.f0;
      $4692=$52019;
      var $52020=$52018.f1;
      $4693=$52020;
      var $52021=$319;
      var $52022=$320;
      var $52023=$321;
      HEAP32[(($319)>>2)]=$37761;
      HEAP32[(($320)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($321)>>2)]=558;
      var $52024=HEAP32[(($319)>>2)];
      var $52025=(($52024)|0)!=0;
      if ($52025) { __label__ = 14077; break; } else { __label__ = 14079; break; }
    case 14077: // $52026
      var $52027=HEAP32[(($319)>>2)];
      var $52028=HEAP32[(($320)>>2)];
      var $52029=HEAP32[(($321)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52027, $52028, $52029) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14078; break; } else { __label__ = 14612; break; }
    case 14078: // $_noexc2127
      __label__ = 14079; break;
    case 14079: // $_ZdlPvPKci_exit2128
      var $52030=$319;
      var $52031=$320;
      var $52032=$321;
      __label__ = 14080; break;
    case 14080: // $52033
      __label__ = 14611; break;
    case 14081: // $52034
      var $52035=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52036=$52035.f0;
      $4692=$52036;
      var $52037=$52035.f1;
      $4693=$52037;
      var $52038=$316;
      var $52039=$317;
      var $52040=$318;
      HEAP32[(($316)>>2)]=$37828;
      HEAP32[(($317)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($318)>>2)]=559;
      var $52041=HEAP32[(($316)>>2)];
      var $52042=(($52041)|0)!=0;
      if ($52042) { __label__ = 14082; break; } else { __label__ = 14084; break; }
    case 14082: // $52043
      var $52044=HEAP32[(($316)>>2)];
      var $52045=HEAP32[(($317)>>2)];
      var $52046=HEAP32[(($318)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52044, $52045, $52046) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14083; break; } else { __label__ = 14612; break; }
    case 14083: // $_noexc2129
      __label__ = 14084; break;
    case 14084: // $_ZdlPvPKci_exit2130
      var $52047=$316;
      var $52048=$317;
      var $52049=$318;
      __label__ = 14085; break;
    case 14085: // $52050
      __label__ = 14611; break;
    case 14086: // $52051
      var $52052=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52053=$52052.f0;
      $4692=$52053;
      var $52054=$52052.f1;
      $4693=$52054;
      var $52055=$313;
      var $52056=$314;
      var $52057=$315;
      HEAP32[(($313)>>2)]=$37895;
      HEAP32[(($314)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($315)>>2)]=560;
      var $52058=HEAP32[(($313)>>2)];
      var $52059=(($52058)|0)!=0;
      if ($52059) { __label__ = 14087; break; } else { __label__ = 14089; break; }
    case 14087: // $52060
      var $52061=HEAP32[(($313)>>2)];
      var $52062=HEAP32[(($314)>>2)];
      var $52063=HEAP32[(($315)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52061, $52062, $52063) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14088; break; } else { __label__ = 14612; break; }
    case 14088: // $_noexc2131
      __label__ = 14089; break;
    case 14089: // $_ZdlPvPKci_exit2132
      var $52064=$313;
      var $52065=$314;
      var $52066=$315;
      __label__ = 14090; break;
    case 14090: // $52067
      __label__ = 14611; break;
    case 14091: // $52068
      var $52069=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52070=$52069.f0;
      $4692=$52070;
      var $52071=$52069.f1;
      $4693=$52071;
      var $52072=$310;
      var $52073=$311;
      var $52074=$312;
      HEAP32[(($310)>>2)]=$37962;
      HEAP32[(($311)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($312)>>2)]=562;
      var $52075=HEAP32[(($310)>>2)];
      var $52076=(($52075)|0)!=0;
      if ($52076) { __label__ = 14092; break; } else { __label__ = 14094; break; }
    case 14092: // $52077
      var $52078=HEAP32[(($310)>>2)];
      var $52079=HEAP32[(($311)>>2)];
      var $52080=HEAP32[(($312)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52078, $52079, $52080) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14093; break; } else { __label__ = 14612; break; }
    case 14093: // $_noexc2133
      __label__ = 14094; break;
    case 14094: // $_ZdlPvPKci_exit2134
      var $52081=$310;
      var $52082=$311;
      var $52083=$312;
      __label__ = 14095; break;
    case 14095: // $52084
      __label__ = 14611; break;
    case 14096: // $52085
      var $52086=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52087=$52086.f0;
      $4692=$52087;
      var $52088=$52086.f1;
      $4693=$52088;
      var $52089=$307;
      var $52090=$308;
      var $52091=$309;
      HEAP32[(($307)>>2)]=$38029;
      HEAP32[(($308)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($309)>>2)]=563;
      var $52092=HEAP32[(($307)>>2)];
      var $52093=(($52092)|0)!=0;
      if ($52093) { __label__ = 14097; break; } else { __label__ = 14099; break; }
    case 14097: // $52094
      var $52095=HEAP32[(($307)>>2)];
      var $52096=HEAP32[(($308)>>2)];
      var $52097=HEAP32[(($309)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52095, $52096, $52097) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14098; break; } else { __label__ = 14612; break; }
    case 14098: // $_noexc2135
      __label__ = 14099; break;
    case 14099: // $_ZdlPvPKci_exit2136
      var $52098=$307;
      var $52099=$308;
      var $52100=$309;
      __label__ = 14100; break;
    case 14100: // $52101
      __label__ = 14611; break;
    case 14101: // $52102
      var $52103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52104=$52103.f0;
      $4692=$52104;
      var $52105=$52103.f1;
      $4693=$52105;
      var $52106=$304;
      var $52107=$305;
      var $52108=$306;
      HEAP32[(($304)>>2)]=$38096;
      HEAP32[(($305)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($306)>>2)]=564;
      var $52109=HEAP32[(($304)>>2)];
      var $52110=(($52109)|0)!=0;
      if ($52110) { __label__ = 14102; break; } else { __label__ = 14104; break; }
    case 14102: // $52111
      var $52112=HEAP32[(($304)>>2)];
      var $52113=HEAP32[(($305)>>2)];
      var $52114=HEAP32[(($306)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52112, $52113, $52114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14103; break; } else { __label__ = 14612; break; }
    case 14103: // $_noexc2137
      __label__ = 14104; break;
    case 14104: // $_ZdlPvPKci_exit2138
      var $52115=$304;
      var $52116=$305;
      var $52117=$306;
      __label__ = 14105; break;
    case 14105: // $52118
      __label__ = 14611; break;
    case 14106: // $52119
      var $52120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52121=$52120.f0;
      $4692=$52121;
      var $52122=$52120.f1;
      $4693=$52122;
      var $52123=$301;
      var $52124=$302;
      var $52125=$303;
      HEAP32[(($301)>>2)]=$38163;
      HEAP32[(($302)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($303)>>2)]=565;
      var $52126=HEAP32[(($301)>>2)];
      var $52127=(($52126)|0)!=0;
      if ($52127) { __label__ = 14107; break; } else { __label__ = 14109; break; }
    case 14107: // $52128
      var $52129=HEAP32[(($301)>>2)];
      var $52130=HEAP32[(($302)>>2)];
      var $52131=HEAP32[(($303)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52129, $52130, $52131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14108; break; } else { __label__ = 14612; break; }
    case 14108: // $_noexc2139
      __label__ = 14109; break;
    case 14109: // $_ZdlPvPKci_exit2140
      var $52132=$301;
      var $52133=$302;
      var $52134=$303;
      __label__ = 14110; break;
    case 14110: // $52135
      __label__ = 14611; break;
    case 14111: // $52136
      var $52137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52138=$52137.f0;
      $4692=$52138;
      var $52139=$52137.f1;
      $4693=$52139;
      var $52140=$298;
      var $52141=$299;
      var $52142=$300;
      HEAP32[(($298)>>2)]=$38230;
      HEAP32[(($299)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($300)>>2)]=566;
      var $52143=HEAP32[(($298)>>2)];
      var $52144=(($52143)|0)!=0;
      if ($52144) { __label__ = 14112; break; } else { __label__ = 14114; break; }
    case 14112: // $52145
      var $52146=HEAP32[(($298)>>2)];
      var $52147=HEAP32[(($299)>>2)];
      var $52148=HEAP32[(($300)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52146, $52147, $52148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14113; break; } else { __label__ = 14612; break; }
    case 14113: // $_noexc2141
      __label__ = 14114; break;
    case 14114: // $_ZdlPvPKci_exit2142
      var $52149=$298;
      var $52150=$299;
      var $52151=$300;
      __label__ = 14115; break;
    case 14115: // $52152
      __label__ = 14611; break;
    case 14116: // $52153
      var $52154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52155=$52154.f0;
      $4692=$52155;
      var $52156=$52154.f1;
      $4693=$52156;
      var $52157=$295;
      var $52158=$296;
      var $52159=$297;
      HEAP32[(($295)>>2)]=$38297;
      HEAP32[(($296)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($297)>>2)]=567;
      var $52160=HEAP32[(($295)>>2)];
      var $52161=(($52160)|0)!=0;
      if ($52161) { __label__ = 14117; break; } else { __label__ = 14119; break; }
    case 14117: // $52162
      var $52163=HEAP32[(($295)>>2)];
      var $52164=HEAP32[(($296)>>2)];
      var $52165=HEAP32[(($297)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52163, $52164, $52165) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14118; break; } else { __label__ = 14612; break; }
    case 14118: // $_noexc2143
      __label__ = 14119; break;
    case 14119: // $_ZdlPvPKci_exit2144
      var $52166=$295;
      var $52167=$296;
      var $52168=$297;
      __label__ = 14120; break;
    case 14120: // $52169
      __label__ = 14611; break;
    case 14121: // $52170
      var $52171=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52172=$52171.f0;
      $4692=$52172;
      var $52173=$52171.f1;
      $4693=$52173;
      var $52174=$292;
      var $52175=$293;
      var $52176=$294;
      HEAP32[(($292)>>2)]=$38364;
      HEAP32[(($293)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($294)>>2)]=568;
      var $52177=HEAP32[(($292)>>2)];
      var $52178=(($52177)|0)!=0;
      if ($52178) { __label__ = 14122; break; } else { __label__ = 14124; break; }
    case 14122: // $52179
      var $52180=HEAP32[(($292)>>2)];
      var $52181=HEAP32[(($293)>>2)];
      var $52182=HEAP32[(($294)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52180, $52181, $52182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14123; break; } else { __label__ = 14612; break; }
    case 14123: // $_noexc2145
      __label__ = 14124; break;
    case 14124: // $_ZdlPvPKci_exit2146
      var $52183=$292;
      var $52184=$293;
      var $52185=$294;
      __label__ = 14125; break;
    case 14125: // $52186
      __label__ = 14611; break;
    case 14126: // $52187
      var $52188=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52189=$52188.f0;
      $4692=$52189;
      var $52190=$52188.f1;
      $4693=$52190;
      var $52191=$289;
      var $52192=$290;
      var $52193=$291;
      HEAP32[(($289)>>2)]=$38431;
      HEAP32[(($290)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($291)>>2)]=569;
      var $52194=HEAP32[(($289)>>2)];
      var $52195=(($52194)|0)!=0;
      if ($52195) { __label__ = 14127; break; } else { __label__ = 14129; break; }
    case 14127: // $52196
      var $52197=HEAP32[(($289)>>2)];
      var $52198=HEAP32[(($290)>>2)];
      var $52199=HEAP32[(($291)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52197, $52198, $52199) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14128; break; } else { __label__ = 14612; break; }
    case 14128: // $_noexc2147
      __label__ = 14129; break;
    case 14129: // $_ZdlPvPKci_exit2148
      var $52200=$289;
      var $52201=$290;
      var $52202=$291;
      __label__ = 14130; break;
    case 14130: // $52203
      __label__ = 14611; break;
    case 14131: // $52204
      var $52205=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52206=$52205.f0;
      $4692=$52206;
      var $52207=$52205.f1;
      $4693=$52207;
      var $52208=$286;
      var $52209=$287;
      var $52210=$288;
      HEAP32[(($286)>>2)]=$38498;
      HEAP32[(($287)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($288)>>2)]=571;
      var $52211=HEAP32[(($286)>>2)];
      var $52212=(($52211)|0)!=0;
      if ($52212) { __label__ = 14132; break; } else { __label__ = 14134; break; }
    case 14132: // $52213
      var $52214=HEAP32[(($286)>>2)];
      var $52215=HEAP32[(($287)>>2)];
      var $52216=HEAP32[(($288)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52214, $52215, $52216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14133; break; } else { __label__ = 14612; break; }
    case 14133: // $_noexc2149
      __label__ = 14134; break;
    case 14134: // $_ZdlPvPKci_exit2150
      var $52217=$286;
      var $52218=$287;
      var $52219=$288;
      __label__ = 14135; break;
    case 14135: // $52220
      __label__ = 14611; break;
    case 14136: // $52221
      var $52222=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52223=$52222.f0;
      $4692=$52223;
      var $52224=$52222.f1;
      $4693=$52224;
      var $52225=$283;
      var $52226=$284;
      var $52227=$285;
      HEAP32[(($283)>>2)]=$38565;
      HEAP32[(($284)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($285)>>2)]=572;
      var $52228=HEAP32[(($283)>>2)];
      var $52229=(($52228)|0)!=0;
      if ($52229) { __label__ = 14137; break; } else { __label__ = 14139; break; }
    case 14137: // $52230
      var $52231=HEAP32[(($283)>>2)];
      var $52232=HEAP32[(($284)>>2)];
      var $52233=HEAP32[(($285)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52231, $52232, $52233) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14138; break; } else { __label__ = 14612; break; }
    case 14138: // $_noexc2151
      __label__ = 14139; break;
    case 14139: // $_ZdlPvPKci_exit2152
      var $52234=$283;
      var $52235=$284;
      var $52236=$285;
      __label__ = 14140; break;
    case 14140: // $52237
      __label__ = 14611; break;
    case 14141: // $52238
      var $52239=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52240=$52239.f0;
      $4692=$52240;
      var $52241=$52239.f1;
      $4693=$52241;
      var $52242=$280;
      var $52243=$281;
      var $52244=$282;
      HEAP32[(($280)>>2)]=$38632;
      HEAP32[(($281)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($282)>>2)]=573;
      var $52245=HEAP32[(($280)>>2)];
      var $52246=(($52245)|0)!=0;
      if ($52246) { __label__ = 14142; break; } else { __label__ = 14144; break; }
    case 14142: // $52247
      var $52248=HEAP32[(($280)>>2)];
      var $52249=HEAP32[(($281)>>2)];
      var $52250=HEAP32[(($282)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52248, $52249, $52250) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14143; break; } else { __label__ = 14612; break; }
    case 14143: // $_noexc2153
      __label__ = 14144; break;
    case 14144: // $_ZdlPvPKci_exit2154
      var $52251=$280;
      var $52252=$281;
      var $52253=$282;
      __label__ = 14145; break;
    case 14145: // $52254
      __label__ = 14611; break;
    case 14146: // $52255
      var $52256=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52257=$52256.f0;
      $4692=$52257;
      var $52258=$52256.f1;
      $4693=$52258;
      var $52259=$277;
      var $52260=$278;
      var $52261=$279;
      HEAP32[(($277)>>2)]=$38699;
      HEAP32[(($278)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($279)>>2)]=574;
      var $52262=HEAP32[(($277)>>2)];
      var $52263=(($52262)|0)!=0;
      if ($52263) { __label__ = 14147; break; } else { __label__ = 14149; break; }
    case 14147: // $52264
      var $52265=HEAP32[(($277)>>2)];
      var $52266=HEAP32[(($278)>>2)];
      var $52267=HEAP32[(($279)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52265, $52266, $52267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14148; break; } else { __label__ = 14612; break; }
    case 14148: // $_noexc2155
      __label__ = 14149; break;
    case 14149: // $_ZdlPvPKci_exit2156
      var $52268=$277;
      var $52269=$278;
      var $52270=$279;
      __label__ = 14150; break;
    case 14150: // $52271
      __label__ = 14611; break;
    case 14151: // $52272
      var $52273=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52274=$52273.f0;
      $4692=$52274;
      var $52275=$52273.f1;
      $4693=$52275;
      var $52276=$274;
      var $52277=$275;
      var $52278=$276;
      HEAP32[(($274)>>2)]=$38766;
      HEAP32[(($275)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($276)>>2)]=575;
      var $52279=HEAP32[(($274)>>2)];
      var $52280=(($52279)|0)!=0;
      if ($52280) { __label__ = 14152; break; } else { __label__ = 14154; break; }
    case 14152: // $52281
      var $52282=HEAP32[(($274)>>2)];
      var $52283=HEAP32[(($275)>>2)];
      var $52284=HEAP32[(($276)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52282, $52283, $52284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14153; break; } else { __label__ = 14612; break; }
    case 14153: // $_noexc2157
      __label__ = 14154; break;
    case 14154: // $_ZdlPvPKci_exit2158
      var $52285=$274;
      var $52286=$275;
      var $52287=$276;
      __label__ = 14155; break;
    case 14155: // $52288
      __label__ = 14611; break;
    case 14156: // $52289
      var $52290=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52291=$52290.f0;
      $4692=$52291;
      var $52292=$52290.f1;
      $4693=$52292;
      var $52293=$271;
      var $52294=$272;
      var $52295=$273;
      HEAP32[(($271)>>2)]=$38833;
      HEAP32[(($272)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($273)>>2)]=576;
      var $52296=HEAP32[(($271)>>2)];
      var $52297=(($52296)|0)!=0;
      if ($52297) { __label__ = 14157; break; } else { __label__ = 14159; break; }
    case 14157: // $52298
      var $52299=HEAP32[(($271)>>2)];
      var $52300=HEAP32[(($272)>>2)];
      var $52301=HEAP32[(($273)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52299, $52300, $52301) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14158; break; } else { __label__ = 14612; break; }
    case 14158: // $_noexc2159
      __label__ = 14159; break;
    case 14159: // $_ZdlPvPKci_exit2160
      var $52302=$271;
      var $52303=$272;
      var $52304=$273;
      __label__ = 14160; break;
    case 14160: // $52305
      __label__ = 14611; break;
    case 14161: // $52306
      var $52307=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52308=$52307.f0;
      $4692=$52308;
      var $52309=$52307.f1;
      $4693=$52309;
      var $52310=$268;
      var $52311=$269;
      var $52312=$270;
      HEAP32[(($268)>>2)]=$38900;
      HEAP32[(($269)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($270)>>2)]=577;
      var $52313=HEAP32[(($268)>>2)];
      var $52314=(($52313)|0)!=0;
      if ($52314) { __label__ = 14162; break; } else { __label__ = 14164; break; }
    case 14162: // $52315
      var $52316=HEAP32[(($268)>>2)];
      var $52317=HEAP32[(($269)>>2)];
      var $52318=HEAP32[(($270)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52316, $52317, $52318) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14163; break; } else { __label__ = 14612; break; }
    case 14163: // $_noexc2161
      __label__ = 14164; break;
    case 14164: // $_ZdlPvPKci_exit2162
      var $52319=$268;
      var $52320=$269;
      var $52321=$270;
      __label__ = 14165; break;
    case 14165: // $52322
      __label__ = 14611; break;
    case 14166: // $52323
      var $52324=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52325=$52324.f0;
      $4692=$52325;
      var $52326=$52324.f1;
      $4693=$52326;
      var $52327=$265;
      var $52328=$266;
      var $52329=$267;
      HEAP32[(($265)>>2)]=$38967;
      HEAP32[(($266)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($267)>>2)]=578;
      var $52330=HEAP32[(($265)>>2)];
      var $52331=(($52330)|0)!=0;
      if ($52331) { __label__ = 14167; break; } else { __label__ = 14169; break; }
    case 14167: // $52332
      var $52333=HEAP32[(($265)>>2)];
      var $52334=HEAP32[(($266)>>2)];
      var $52335=HEAP32[(($267)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52333, $52334, $52335) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14168; break; } else { __label__ = 14612; break; }
    case 14168: // $_noexc2163
      __label__ = 14169; break;
    case 14169: // $_ZdlPvPKci_exit2164
      var $52336=$265;
      var $52337=$266;
      var $52338=$267;
      __label__ = 14170; break;
    case 14170: // $52339
      __label__ = 14611; break;
    case 14171: // $52340
      var $52341=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52342=$52341.f0;
      $4692=$52342;
      var $52343=$52341.f1;
      $4693=$52343;
      var $52344=$262;
      var $52345=$263;
      var $52346=$264;
      HEAP32[(($262)>>2)]=$39034;
      HEAP32[(($263)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($264)>>2)]=580;
      var $52347=HEAP32[(($262)>>2)];
      var $52348=(($52347)|0)!=0;
      if ($52348) { __label__ = 14172; break; } else { __label__ = 14174; break; }
    case 14172: // $52349
      var $52350=HEAP32[(($262)>>2)];
      var $52351=HEAP32[(($263)>>2)];
      var $52352=HEAP32[(($264)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52350, $52351, $52352) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14173; break; } else { __label__ = 14612; break; }
    case 14173: // $_noexc2165
      __label__ = 14174; break;
    case 14174: // $_ZdlPvPKci_exit2166
      var $52353=$262;
      var $52354=$263;
      var $52355=$264;
      __label__ = 14175; break;
    case 14175: // $52356
      __label__ = 14611; break;
    case 14176: // $52357
      var $52358=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52359=$52358.f0;
      $4692=$52359;
      var $52360=$52358.f1;
      $4693=$52360;
      var $52361=$259;
      var $52362=$260;
      var $52363=$261;
      HEAP32[(($259)>>2)]=$39101;
      HEAP32[(($260)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($261)>>2)]=581;
      var $52364=HEAP32[(($259)>>2)];
      var $52365=(($52364)|0)!=0;
      if ($52365) { __label__ = 14177; break; } else { __label__ = 14179; break; }
    case 14177: // $52366
      var $52367=HEAP32[(($259)>>2)];
      var $52368=HEAP32[(($260)>>2)];
      var $52369=HEAP32[(($261)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52367, $52368, $52369) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14178; break; } else { __label__ = 14612; break; }
    case 14178: // $_noexc2167
      __label__ = 14179; break;
    case 14179: // $_ZdlPvPKci_exit2168
      var $52370=$259;
      var $52371=$260;
      var $52372=$261;
      __label__ = 14180; break;
    case 14180: // $52373
      __label__ = 14611; break;
    case 14181: // $52374
      var $52375=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52376=$52375.f0;
      $4692=$52376;
      var $52377=$52375.f1;
      $4693=$52377;
      var $52378=$256;
      var $52379=$257;
      var $52380=$258;
      HEAP32[(($256)>>2)]=$39168;
      HEAP32[(($257)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($258)>>2)]=582;
      var $52381=HEAP32[(($256)>>2)];
      var $52382=(($52381)|0)!=0;
      if ($52382) { __label__ = 14182; break; } else { __label__ = 14184; break; }
    case 14182: // $52383
      var $52384=HEAP32[(($256)>>2)];
      var $52385=HEAP32[(($257)>>2)];
      var $52386=HEAP32[(($258)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52384, $52385, $52386) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14183; break; } else { __label__ = 14612; break; }
    case 14183: // $_noexc2169
      __label__ = 14184; break;
    case 14184: // $_ZdlPvPKci_exit2170
      var $52387=$256;
      var $52388=$257;
      var $52389=$258;
      __label__ = 14185; break;
    case 14185: // $52390
      __label__ = 14611; break;
    case 14186: // $52391
      var $52392=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52393=$52392.f0;
      $4692=$52393;
      var $52394=$52392.f1;
      $4693=$52394;
      var $52395=$253;
      var $52396=$254;
      var $52397=$255;
      HEAP32[(($253)>>2)]=$39235;
      HEAP32[(($254)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($255)>>2)]=583;
      var $52398=HEAP32[(($253)>>2)];
      var $52399=(($52398)|0)!=0;
      if ($52399) { __label__ = 14187; break; } else { __label__ = 14189; break; }
    case 14187: // $52400
      var $52401=HEAP32[(($253)>>2)];
      var $52402=HEAP32[(($254)>>2)];
      var $52403=HEAP32[(($255)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52401, $52402, $52403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14188; break; } else { __label__ = 14612; break; }
    case 14188: // $_noexc2171
      __label__ = 14189; break;
    case 14189: // $_ZdlPvPKci_exit2172
      var $52404=$253;
      var $52405=$254;
      var $52406=$255;
      __label__ = 14190; break;
    case 14190: // $52407
      __label__ = 14611; break;
    case 14191: // $52408
      var $52409=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52410=$52409.f0;
      $4692=$52410;
      var $52411=$52409.f1;
      $4693=$52411;
      var $52412=$250;
      var $52413=$251;
      var $52414=$252;
      HEAP32[(($250)>>2)]=$39302;
      HEAP32[(($251)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($252)>>2)]=584;
      var $52415=HEAP32[(($250)>>2)];
      var $52416=(($52415)|0)!=0;
      if ($52416) { __label__ = 14192; break; } else { __label__ = 14194; break; }
    case 14192: // $52417
      var $52418=HEAP32[(($250)>>2)];
      var $52419=HEAP32[(($251)>>2)];
      var $52420=HEAP32[(($252)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52418, $52419, $52420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14193; break; } else { __label__ = 14612; break; }
    case 14193: // $_noexc2173
      __label__ = 14194; break;
    case 14194: // $_ZdlPvPKci_exit2174
      var $52421=$250;
      var $52422=$251;
      var $52423=$252;
      __label__ = 14195; break;
    case 14195: // $52424
      __label__ = 14611; break;
    case 14196: // $52425
      var $52426=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52427=$52426.f0;
      $4692=$52427;
      var $52428=$52426.f1;
      $4693=$52428;
      var $52429=$247;
      var $52430=$248;
      var $52431=$249;
      HEAP32[(($247)>>2)]=$39369;
      HEAP32[(($248)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($249)>>2)]=585;
      var $52432=HEAP32[(($247)>>2)];
      var $52433=(($52432)|0)!=0;
      if ($52433) { __label__ = 14197; break; } else { __label__ = 14199; break; }
    case 14197: // $52434
      var $52435=HEAP32[(($247)>>2)];
      var $52436=HEAP32[(($248)>>2)];
      var $52437=HEAP32[(($249)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52435, $52436, $52437) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14198; break; } else { __label__ = 14612; break; }
    case 14198: // $_noexc2175
      __label__ = 14199; break;
    case 14199: // $_ZdlPvPKci_exit2176
      var $52438=$247;
      var $52439=$248;
      var $52440=$249;
      __label__ = 14200; break;
    case 14200: // $52441
      __label__ = 14611; break;
    case 14201: // $52442
      var $52443=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52444=$52443.f0;
      $4692=$52444;
      var $52445=$52443.f1;
      $4693=$52445;
      var $52446=$244;
      var $52447=$245;
      var $52448=$246;
      HEAP32[(($244)>>2)]=$39436;
      HEAP32[(($245)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($246)>>2)]=586;
      var $52449=HEAP32[(($244)>>2)];
      var $52450=(($52449)|0)!=0;
      if ($52450) { __label__ = 14202; break; } else { __label__ = 14204; break; }
    case 14202: // $52451
      var $52452=HEAP32[(($244)>>2)];
      var $52453=HEAP32[(($245)>>2)];
      var $52454=HEAP32[(($246)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52452, $52453, $52454) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14203; break; } else { __label__ = 14612; break; }
    case 14203: // $_noexc2177
      __label__ = 14204; break;
    case 14204: // $_ZdlPvPKci_exit2178
      var $52455=$244;
      var $52456=$245;
      var $52457=$246;
      __label__ = 14205; break;
    case 14205: // $52458
      __label__ = 14611; break;
    case 14206: // $52459
      var $52460=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52461=$52460.f0;
      $4692=$52461;
      var $52462=$52460.f1;
      $4693=$52462;
      var $52463=$241;
      var $52464=$242;
      var $52465=$243;
      HEAP32[(($241)>>2)]=$39503;
      HEAP32[(($242)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($243)>>2)]=587;
      var $52466=HEAP32[(($241)>>2)];
      var $52467=(($52466)|0)!=0;
      if ($52467) { __label__ = 14207; break; } else { __label__ = 14209; break; }
    case 14207: // $52468
      var $52469=HEAP32[(($241)>>2)];
      var $52470=HEAP32[(($242)>>2)];
      var $52471=HEAP32[(($243)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52469, $52470, $52471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14208; break; } else { __label__ = 14612; break; }
    case 14208: // $_noexc2179
      __label__ = 14209; break;
    case 14209: // $_ZdlPvPKci_exit2180
      var $52472=$241;
      var $52473=$242;
      var $52474=$243;
      __label__ = 14210; break;
    case 14210: // $52475
      __label__ = 14611; break;
    case 14211: // $52476
      var $52477=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52478=$52477.f0;
      $4692=$52478;
      var $52479=$52477.f1;
      $4693=$52479;
      var $52480=$238;
      var $52481=$239;
      var $52482=$240;
      HEAP32[(($238)>>2)]=$39570;
      HEAP32[(($239)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($240)>>2)]=589;
      var $52483=HEAP32[(($238)>>2)];
      var $52484=(($52483)|0)!=0;
      if ($52484) { __label__ = 14212; break; } else { __label__ = 14214; break; }
    case 14212: // $52485
      var $52486=HEAP32[(($238)>>2)];
      var $52487=HEAP32[(($239)>>2)];
      var $52488=HEAP32[(($240)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52486, $52487, $52488) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14213; break; } else { __label__ = 14612; break; }
    case 14213: // $_noexc2181
      __label__ = 14214; break;
    case 14214: // $_ZdlPvPKci_exit2182
      var $52489=$238;
      var $52490=$239;
      var $52491=$240;
      __label__ = 14215; break;
    case 14215: // $52492
      __label__ = 14611; break;
    case 14216: // $52493
      var $52494=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52495=$52494.f0;
      $4692=$52495;
      var $52496=$52494.f1;
      $4693=$52496;
      var $52497=$235;
      var $52498=$236;
      var $52499=$237;
      HEAP32[(($235)>>2)]=$39637;
      HEAP32[(($236)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($237)>>2)]=590;
      var $52500=HEAP32[(($235)>>2)];
      var $52501=(($52500)|0)!=0;
      if ($52501) { __label__ = 14217; break; } else { __label__ = 14219; break; }
    case 14217: // $52502
      var $52503=HEAP32[(($235)>>2)];
      var $52504=HEAP32[(($236)>>2)];
      var $52505=HEAP32[(($237)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52503, $52504, $52505) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14218; break; } else { __label__ = 14612; break; }
    case 14218: // $_noexc2183
      __label__ = 14219; break;
    case 14219: // $_ZdlPvPKci_exit2184
      var $52506=$235;
      var $52507=$236;
      var $52508=$237;
      __label__ = 14220; break;
    case 14220: // $52509
      __label__ = 14611; break;
    case 14221: // $52510
      var $52511=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52512=$52511.f0;
      $4692=$52512;
      var $52513=$52511.f1;
      $4693=$52513;
      var $52514=$232;
      var $52515=$233;
      var $52516=$234;
      HEAP32[(($232)>>2)]=$39704;
      HEAP32[(($233)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($234)>>2)]=591;
      var $52517=HEAP32[(($232)>>2)];
      var $52518=(($52517)|0)!=0;
      if ($52518) { __label__ = 14222; break; } else { __label__ = 14224; break; }
    case 14222: // $52519
      var $52520=HEAP32[(($232)>>2)];
      var $52521=HEAP32[(($233)>>2)];
      var $52522=HEAP32[(($234)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52520, $52521, $52522) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14223; break; } else { __label__ = 14612; break; }
    case 14223: // $_noexc2185
      __label__ = 14224; break;
    case 14224: // $_ZdlPvPKci_exit2186
      var $52523=$232;
      var $52524=$233;
      var $52525=$234;
      __label__ = 14225; break;
    case 14225: // $52526
      __label__ = 14611; break;
    case 14226: // $52527
      var $52528=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52529=$52528.f0;
      $4692=$52529;
      var $52530=$52528.f1;
      $4693=$52530;
      var $52531=$229;
      var $52532=$230;
      var $52533=$231;
      HEAP32[(($229)>>2)]=$39771;
      HEAP32[(($230)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($231)>>2)]=592;
      var $52534=HEAP32[(($229)>>2)];
      var $52535=(($52534)|0)!=0;
      if ($52535) { __label__ = 14227; break; } else { __label__ = 14229; break; }
    case 14227: // $52536
      var $52537=HEAP32[(($229)>>2)];
      var $52538=HEAP32[(($230)>>2)];
      var $52539=HEAP32[(($231)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52537, $52538, $52539) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14228; break; } else { __label__ = 14612; break; }
    case 14228: // $_noexc2187
      __label__ = 14229; break;
    case 14229: // $_ZdlPvPKci_exit2188
      var $52540=$229;
      var $52541=$230;
      var $52542=$231;
      __label__ = 14230; break;
    case 14230: // $52543
      __label__ = 14611; break;
    case 14231: // $52544
      var $52545=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52546=$52545.f0;
      $4692=$52546;
      var $52547=$52545.f1;
      $4693=$52547;
      var $52548=$226;
      var $52549=$227;
      var $52550=$228;
      HEAP32[(($226)>>2)]=$39838;
      HEAP32[(($227)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($228)>>2)]=593;
      var $52551=HEAP32[(($226)>>2)];
      var $52552=(($52551)|0)!=0;
      if ($52552) { __label__ = 14232; break; } else { __label__ = 14234; break; }
    case 14232: // $52553
      var $52554=HEAP32[(($226)>>2)];
      var $52555=HEAP32[(($227)>>2)];
      var $52556=HEAP32[(($228)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52554, $52555, $52556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14233; break; } else { __label__ = 14612; break; }
    case 14233: // $_noexc2189
      __label__ = 14234; break;
    case 14234: // $_ZdlPvPKci_exit2190
      var $52557=$226;
      var $52558=$227;
      var $52559=$228;
      __label__ = 14235; break;
    case 14235: // $52560
      __label__ = 14611; break;
    case 14236: // $52561
      var $52562=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52563=$52562.f0;
      $4692=$52563;
      var $52564=$52562.f1;
      $4693=$52564;
      var $52565=$223;
      var $52566=$224;
      var $52567=$225;
      HEAP32[(($223)>>2)]=$39905;
      HEAP32[(($224)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($225)>>2)]=594;
      var $52568=HEAP32[(($223)>>2)];
      var $52569=(($52568)|0)!=0;
      if ($52569) { __label__ = 14237; break; } else { __label__ = 14239; break; }
    case 14237: // $52570
      var $52571=HEAP32[(($223)>>2)];
      var $52572=HEAP32[(($224)>>2)];
      var $52573=HEAP32[(($225)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52571, $52572, $52573) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14238; break; } else { __label__ = 14612; break; }
    case 14238: // $_noexc2191
      __label__ = 14239; break;
    case 14239: // $_ZdlPvPKci_exit2192
      var $52574=$223;
      var $52575=$224;
      var $52576=$225;
      __label__ = 14240; break;
    case 14240: // $52577
      __label__ = 14611; break;
    case 14241: // $52578
      var $52579=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52580=$52579.f0;
      $4692=$52580;
      var $52581=$52579.f1;
      $4693=$52581;
      var $52582=$220;
      var $52583=$221;
      var $52584=$222;
      HEAP32[(($220)>>2)]=$39972;
      HEAP32[(($221)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($222)>>2)]=595;
      var $52585=HEAP32[(($220)>>2)];
      var $52586=(($52585)|0)!=0;
      if ($52586) { __label__ = 14242; break; } else { __label__ = 14244; break; }
    case 14242: // $52587
      var $52588=HEAP32[(($220)>>2)];
      var $52589=HEAP32[(($221)>>2)];
      var $52590=HEAP32[(($222)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52588, $52589, $52590) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14243; break; } else { __label__ = 14612; break; }
    case 14243: // $_noexc2193
      __label__ = 14244; break;
    case 14244: // $_ZdlPvPKci_exit2194
      var $52591=$220;
      var $52592=$221;
      var $52593=$222;
      __label__ = 14245; break;
    case 14245: // $52594
      __label__ = 14611; break;
    case 14246: // $52595
      var $52596=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52597=$52596.f0;
      $4692=$52597;
      var $52598=$52596.f1;
      $4693=$52598;
      var $52599=$217;
      var $52600=$218;
      var $52601=$219;
      HEAP32[(($217)>>2)]=$40039;
      HEAP32[(($218)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($219)>>2)]=596;
      var $52602=HEAP32[(($217)>>2)];
      var $52603=(($52602)|0)!=0;
      if ($52603) { __label__ = 14247; break; } else { __label__ = 14249; break; }
    case 14247: // $52604
      var $52605=HEAP32[(($217)>>2)];
      var $52606=HEAP32[(($218)>>2)];
      var $52607=HEAP32[(($219)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52605, $52606, $52607) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14248; break; } else { __label__ = 14612; break; }
    case 14248: // $_noexc2195
      __label__ = 14249; break;
    case 14249: // $_ZdlPvPKci_exit2196
      var $52608=$217;
      var $52609=$218;
      var $52610=$219;
      __label__ = 14250; break;
    case 14250: // $52611
      __label__ = 14611; break;
    case 14251: // $52612
      var $52613=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52614=$52613.f0;
      $4692=$52614;
      var $52615=$52613.f1;
      $4693=$52615;
      var $52616=$214;
      var $52617=$215;
      var $52618=$216;
      HEAP32[(($214)>>2)]=$40106;
      HEAP32[(($215)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($216)>>2)]=598;
      var $52619=HEAP32[(($214)>>2)];
      var $52620=(($52619)|0)!=0;
      if ($52620) { __label__ = 14252; break; } else { __label__ = 14254; break; }
    case 14252: // $52621
      var $52622=HEAP32[(($214)>>2)];
      var $52623=HEAP32[(($215)>>2)];
      var $52624=HEAP32[(($216)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52622, $52623, $52624) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14253; break; } else { __label__ = 14612; break; }
    case 14253: // $_noexc2197
      __label__ = 14254; break;
    case 14254: // $_ZdlPvPKci_exit2198
      var $52625=$214;
      var $52626=$215;
      var $52627=$216;
      __label__ = 14255; break;
    case 14255: // $52628
      __label__ = 14611; break;
    case 14256: // $52629
      var $52630=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52631=$52630.f0;
      $4692=$52631;
      var $52632=$52630.f1;
      $4693=$52632;
      var $52633=$211;
      var $52634=$212;
      var $52635=$213;
      HEAP32[(($211)>>2)]=$40173;
      HEAP32[(($212)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($213)>>2)]=599;
      var $52636=HEAP32[(($211)>>2)];
      var $52637=(($52636)|0)!=0;
      if ($52637) { __label__ = 14257; break; } else { __label__ = 14259; break; }
    case 14257: // $52638
      var $52639=HEAP32[(($211)>>2)];
      var $52640=HEAP32[(($212)>>2)];
      var $52641=HEAP32[(($213)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52639, $52640, $52641) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14258; break; } else { __label__ = 14612; break; }
    case 14258: // $_noexc2199
      __label__ = 14259; break;
    case 14259: // $_ZdlPvPKci_exit2200
      var $52642=$211;
      var $52643=$212;
      var $52644=$213;
      __label__ = 14260; break;
    case 14260: // $52645
      __label__ = 14611; break;
    case 14261: // $52646
      var $52647=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52648=$52647.f0;
      $4692=$52648;
      var $52649=$52647.f1;
      $4693=$52649;
      var $52650=$208;
      var $52651=$209;
      var $52652=$210;
      HEAP32[(($208)>>2)]=$40240;
      HEAP32[(($209)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($210)>>2)]=600;
      var $52653=HEAP32[(($208)>>2)];
      var $52654=(($52653)|0)!=0;
      if ($52654) { __label__ = 14262; break; } else { __label__ = 14264; break; }
    case 14262: // $52655
      var $52656=HEAP32[(($208)>>2)];
      var $52657=HEAP32[(($209)>>2)];
      var $52658=HEAP32[(($210)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52656, $52657, $52658) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14263; break; } else { __label__ = 14612; break; }
    case 14263: // $_noexc2201
      __label__ = 14264; break;
    case 14264: // $_ZdlPvPKci_exit2202
      var $52659=$208;
      var $52660=$209;
      var $52661=$210;
      __label__ = 14265; break;
    case 14265: // $52662
      __label__ = 14611; break;
    case 14266: // $52663
      var $52664=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52665=$52664.f0;
      $4692=$52665;
      var $52666=$52664.f1;
      $4693=$52666;
      var $52667=$205;
      var $52668=$206;
      var $52669=$207;
      HEAP32[(($205)>>2)]=$40307;
      HEAP32[(($206)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($207)>>2)]=601;
      var $52670=HEAP32[(($205)>>2)];
      var $52671=(($52670)|0)!=0;
      if ($52671) { __label__ = 14267; break; } else { __label__ = 14269; break; }
    case 14267: // $52672
      var $52673=HEAP32[(($205)>>2)];
      var $52674=HEAP32[(($206)>>2)];
      var $52675=HEAP32[(($207)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52673, $52674, $52675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14268; break; } else { __label__ = 14612; break; }
    case 14268: // $_noexc2203
      __label__ = 14269; break;
    case 14269: // $_ZdlPvPKci_exit2204
      var $52676=$205;
      var $52677=$206;
      var $52678=$207;
      __label__ = 14270; break;
    case 14270: // $52679
      __label__ = 14611; break;
    case 14271: // $52680
      var $52681=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52682=$52681.f0;
      $4692=$52682;
      var $52683=$52681.f1;
      $4693=$52683;
      var $52684=$202;
      var $52685=$203;
      var $52686=$204;
      HEAP32[(($202)>>2)]=$40374;
      HEAP32[(($203)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($204)>>2)]=602;
      var $52687=HEAP32[(($202)>>2)];
      var $52688=(($52687)|0)!=0;
      if ($52688) { __label__ = 14272; break; } else { __label__ = 14274; break; }
    case 14272: // $52689
      var $52690=HEAP32[(($202)>>2)];
      var $52691=HEAP32[(($203)>>2)];
      var $52692=HEAP32[(($204)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52690, $52691, $52692) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14273; break; } else { __label__ = 14612; break; }
    case 14273: // $_noexc2205
      __label__ = 14274; break;
    case 14274: // $_ZdlPvPKci_exit2206
      var $52693=$202;
      var $52694=$203;
      var $52695=$204;
      __label__ = 14275; break;
    case 14275: // $52696
      __label__ = 14611; break;
    case 14276: // $52697
      var $52698=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52699=$52698.f0;
      $4692=$52699;
      var $52700=$52698.f1;
      $4693=$52700;
      var $52701=$199;
      var $52702=$200;
      var $52703=$201;
      HEAP32[(($199)>>2)]=$40441;
      HEAP32[(($200)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($201)>>2)]=603;
      var $52704=HEAP32[(($199)>>2)];
      var $52705=(($52704)|0)!=0;
      if ($52705) { __label__ = 14277; break; } else { __label__ = 14279; break; }
    case 14277: // $52706
      var $52707=HEAP32[(($199)>>2)];
      var $52708=HEAP32[(($200)>>2)];
      var $52709=HEAP32[(($201)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52707, $52708, $52709) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14278; break; } else { __label__ = 14612; break; }
    case 14278: // $_noexc2207
      __label__ = 14279; break;
    case 14279: // $_ZdlPvPKci_exit2208
      var $52710=$199;
      var $52711=$200;
      var $52712=$201;
      __label__ = 14280; break;
    case 14280: // $52713
      __label__ = 14611; break;
    case 14281: // $52714
      var $52715=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52716=$52715.f0;
      $4692=$52716;
      var $52717=$52715.f1;
      $4693=$52717;
      var $52718=$196;
      var $52719=$197;
      var $52720=$198;
      HEAP32[(($196)>>2)]=$40508;
      HEAP32[(($197)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($198)>>2)]=604;
      var $52721=HEAP32[(($196)>>2)];
      var $52722=(($52721)|0)!=0;
      if ($52722) { __label__ = 14282; break; } else { __label__ = 14284; break; }
    case 14282: // $52723
      var $52724=HEAP32[(($196)>>2)];
      var $52725=HEAP32[(($197)>>2)];
      var $52726=HEAP32[(($198)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52724, $52725, $52726) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14283; break; } else { __label__ = 14612; break; }
    case 14283: // $_noexc2209
      __label__ = 14284; break;
    case 14284: // $_ZdlPvPKci_exit2210
      var $52727=$196;
      var $52728=$197;
      var $52729=$198;
      __label__ = 14285; break;
    case 14285: // $52730
      __label__ = 14611; break;
    case 14286: // $52731
      var $52732=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52733=$52732.f0;
      $4692=$52733;
      var $52734=$52732.f1;
      $4693=$52734;
      var $52735=$193;
      var $52736=$194;
      var $52737=$195;
      HEAP32[(($193)>>2)]=$40575;
      HEAP32[(($194)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($195)>>2)]=605;
      var $52738=HEAP32[(($193)>>2)];
      var $52739=(($52738)|0)!=0;
      if ($52739) { __label__ = 14287; break; } else { __label__ = 14289; break; }
    case 14287: // $52740
      var $52741=HEAP32[(($193)>>2)];
      var $52742=HEAP32[(($194)>>2)];
      var $52743=HEAP32[(($195)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52741, $52742, $52743) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14288; break; } else { __label__ = 14612; break; }
    case 14288: // $_noexc2211
      __label__ = 14289; break;
    case 14289: // $_ZdlPvPKci_exit2212
      var $52744=$193;
      var $52745=$194;
      var $52746=$195;
      __label__ = 14290; break;
    case 14290: // $52747
      __label__ = 14611; break;
    case 14291: // $52748
      var $52749=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52750=$52749.f0;
      $4692=$52750;
      var $52751=$52749.f1;
      $4693=$52751;
      var $52752=$190;
      var $52753=$191;
      var $52754=$192;
      HEAP32[(($190)>>2)]=$40642;
      HEAP32[(($191)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($192)>>2)]=607;
      var $52755=HEAP32[(($190)>>2)];
      var $52756=(($52755)|0)!=0;
      if ($52756) { __label__ = 14292; break; } else { __label__ = 14294; break; }
    case 14292: // $52757
      var $52758=HEAP32[(($190)>>2)];
      var $52759=HEAP32[(($191)>>2)];
      var $52760=HEAP32[(($192)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52758, $52759, $52760) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14293; break; } else { __label__ = 14612; break; }
    case 14293: // $_noexc2213
      __label__ = 14294; break;
    case 14294: // $_ZdlPvPKci_exit2214
      var $52761=$190;
      var $52762=$191;
      var $52763=$192;
      __label__ = 14295; break;
    case 14295: // $52764
      __label__ = 14611; break;
    case 14296: // $52765
      var $52766=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52767=$52766.f0;
      $4692=$52767;
      var $52768=$52766.f1;
      $4693=$52768;
      var $52769=$187;
      var $52770=$188;
      var $52771=$189;
      HEAP32[(($187)>>2)]=$40693;
      HEAP32[(($188)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($189)>>2)]=608;
      var $52772=HEAP32[(($187)>>2)];
      var $52773=(($52772)|0)!=0;
      if ($52773) { __label__ = 14297; break; } else { __label__ = 14299; break; }
    case 14297: // $52774
      var $52775=HEAP32[(($187)>>2)];
      var $52776=HEAP32[(($188)>>2)];
      var $52777=HEAP32[(($189)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52775, $52776, $52777) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14298; break; } else { __label__ = 14612; break; }
    case 14298: // $_noexc2215
      __label__ = 14299; break;
    case 14299: // $_ZdlPvPKci_exit2216
      var $52778=$187;
      var $52779=$188;
      var $52780=$189;
      __label__ = 14300; break;
    case 14300: // $52781
      __label__ = 14611; break;
    case 14301: // $52782
      var $52783=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52784=$52783.f0;
      $4692=$52784;
      var $52785=$52783.f1;
      $4693=$52785;
      var $52786=$184;
      var $52787=$185;
      var $52788=$186;
      HEAP32[(($184)>>2)]=$40744;
      HEAP32[(($185)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($186)>>2)]=610;
      var $52789=HEAP32[(($184)>>2)];
      var $52790=(($52789)|0)!=0;
      if ($52790) { __label__ = 14302; break; } else { __label__ = 14304; break; }
    case 14302: // $52791
      var $52792=HEAP32[(($184)>>2)];
      var $52793=HEAP32[(($185)>>2)];
      var $52794=HEAP32[(($186)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52792, $52793, $52794) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14303; break; } else { __label__ = 14612; break; }
    case 14303: // $_noexc2217
      __label__ = 14304; break;
    case 14304: // $_ZdlPvPKci_exit2218
      var $52795=$184;
      var $52796=$185;
      var $52797=$186;
      __label__ = 14305; break;
    case 14305: // $52798
      __label__ = 14611; break;
    case 14306: // $52799
      var $52800=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52801=$52800.f0;
      $4692=$52801;
      var $52802=$52800.f1;
      $4693=$52802;
      var $52803=$181;
      var $52804=$182;
      var $52805=$183;
      HEAP32[(($181)>>2)]=$40795;
      HEAP32[(($182)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($183)>>2)]=611;
      var $52806=HEAP32[(($181)>>2)];
      var $52807=(($52806)|0)!=0;
      if ($52807) { __label__ = 14307; break; } else { __label__ = 14309; break; }
    case 14307: // $52808
      var $52809=HEAP32[(($181)>>2)];
      var $52810=HEAP32[(($182)>>2)];
      var $52811=HEAP32[(($183)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52809, $52810, $52811) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14308; break; } else { __label__ = 14612; break; }
    case 14308: // $_noexc2219
      __label__ = 14309; break;
    case 14309: // $_ZdlPvPKci_exit2220
      var $52812=$181;
      var $52813=$182;
      var $52814=$183;
      __label__ = 14310; break;
    case 14310: // $52815
      __label__ = 14611; break;
    case 14311: // $52816
      var $52817=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52818=$52817.f0;
      $4692=$52818;
      var $52819=$52817.f1;
      $4693=$52819;
      var $52820=$178;
      var $52821=$179;
      var $52822=$180;
      HEAP32[(($178)>>2)]=$40846;
      HEAP32[(($179)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($180)>>2)]=612;
      var $52823=HEAP32[(($178)>>2)];
      var $52824=(($52823)|0)!=0;
      if ($52824) { __label__ = 14312; break; } else { __label__ = 14314; break; }
    case 14312: // $52825
      var $52826=HEAP32[(($178)>>2)];
      var $52827=HEAP32[(($179)>>2)];
      var $52828=HEAP32[(($180)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52826, $52827, $52828) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14313; break; } else { __label__ = 14612; break; }
    case 14313: // $_noexc2221
      __label__ = 14314; break;
    case 14314: // $_ZdlPvPKci_exit2222
      var $52829=$178;
      var $52830=$179;
      var $52831=$180;
      __label__ = 14315; break;
    case 14315: // $52832
      __label__ = 14611; break;
    case 14316: // $52833
      var $52834=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52835=$52834.f0;
      $4692=$52835;
      var $52836=$52834.f1;
      $4693=$52836;
      var $52837=$175;
      var $52838=$176;
      var $52839=$177;
      HEAP32[(($175)>>2)]=$40897;
      HEAP32[(($176)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($177)>>2)]=613;
      var $52840=HEAP32[(($175)>>2)];
      var $52841=(($52840)|0)!=0;
      if ($52841) { __label__ = 14317; break; } else { __label__ = 14319; break; }
    case 14317: // $52842
      var $52843=HEAP32[(($175)>>2)];
      var $52844=HEAP32[(($176)>>2)];
      var $52845=HEAP32[(($177)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52843, $52844, $52845) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14318; break; } else { __label__ = 14612; break; }
    case 14318: // $_noexc2223
      __label__ = 14319; break;
    case 14319: // $_ZdlPvPKci_exit2224
      var $52846=$175;
      var $52847=$176;
      var $52848=$177;
      __label__ = 14320; break;
    case 14320: // $52849
      __label__ = 14611; break;
    case 14321: // $52850
      var $52851=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52852=$52851.f0;
      $4692=$52852;
      var $52853=$52851.f1;
      $4693=$52853;
      var $52854=$172;
      var $52855=$173;
      var $52856=$174;
      HEAP32[(($172)>>2)]=$40948;
      HEAP32[(($173)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($174)>>2)]=614;
      var $52857=HEAP32[(($172)>>2)];
      var $52858=(($52857)|0)!=0;
      if ($52858) { __label__ = 14322; break; } else { __label__ = 14324; break; }
    case 14322: // $52859
      var $52860=HEAP32[(($172)>>2)];
      var $52861=HEAP32[(($173)>>2)];
      var $52862=HEAP32[(($174)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52860, $52861, $52862) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14323; break; } else { __label__ = 14612; break; }
    case 14323: // $_noexc2225
      __label__ = 14324; break;
    case 14324: // $_ZdlPvPKci_exit2226
      var $52863=$172;
      var $52864=$173;
      var $52865=$174;
      __label__ = 14325; break;
    case 14325: // $52866
      __label__ = 14611; break;
    case 14326: // $52867
      var $52868=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52869=$52868.f0;
      $4692=$52869;
      var $52870=$52868.f1;
      $4693=$52870;
      var $52871=$169;
      var $52872=$170;
      var $52873=$171;
      HEAP32[(($169)>>2)]=$40999;
      HEAP32[(($170)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($171)>>2)]=615;
      var $52874=HEAP32[(($169)>>2)];
      var $52875=(($52874)|0)!=0;
      if ($52875) { __label__ = 14327; break; } else { __label__ = 14329; break; }
    case 14327: // $52876
      var $52877=HEAP32[(($169)>>2)];
      var $52878=HEAP32[(($170)>>2)];
      var $52879=HEAP32[(($171)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52877, $52878, $52879) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14328; break; } else { __label__ = 14612; break; }
    case 14328: // $_noexc2227
      __label__ = 14329; break;
    case 14329: // $_ZdlPvPKci_exit2228
      var $52880=$169;
      var $52881=$170;
      var $52882=$171;
      __label__ = 14330; break;
    case 14330: // $52883
      __label__ = 14611; break;
    case 14331: // $52884
      var $52885=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52886=$52885.f0;
      $4692=$52886;
      var $52887=$52885.f1;
      $4693=$52887;
      var $52888=$166;
      var $52889=$167;
      var $52890=$168;
      HEAP32[(($166)>>2)]=$41050;
      HEAP32[(($167)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($168)>>2)]=616;
      var $52891=HEAP32[(($166)>>2)];
      var $52892=(($52891)|0)!=0;
      if ($52892) { __label__ = 14332; break; } else { __label__ = 14334; break; }
    case 14332: // $52893
      var $52894=HEAP32[(($166)>>2)];
      var $52895=HEAP32[(($167)>>2)];
      var $52896=HEAP32[(($168)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52894, $52895, $52896) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14333; break; } else { __label__ = 14612; break; }
    case 14333: // $_noexc2229
      __label__ = 14334; break;
    case 14334: // $_ZdlPvPKci_exit2230
      var $52897=$166;
      var $52898=$167;
      var $52899=$168;
      __label__ = 14335; break;
    case 14335: // $52900
      __label__ = 14611; break;
    case 14336: // $52901
      var $52902=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52903=$52902.f0;
      $4692=$52903;
      var $52904=$52902.f1;
      $4693=$52904;
      var $52905=$163;
      var $52906=$164;
      var $52907=$165;
      HEAP32[(($163)>>2)]=$41101;
      HEAP32[(($164)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($165)>>2)]=617;
      var $52908=HEAP32[(($163)>>2)];
      var $52909=(($52908)|0)!=0;
      if ($52909) { __label__ = 14337; break; } else { __label__ = 14339; break; }
    case 14337: // $52910
      var $52911=HEAP32[(($163)>>2)];
      var $52912=HEAP32[(($164)>>2)];
      var $52913=HEAP32[(($165)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52911, $52912, $52913) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14338; break; } else { __label__ = 14612; break; }
    case 14338: // $_noexc2231
      __label__ = 14339; break;
    case 14339: // $_ZdlPvPKci_exit2232
      var $52914=$163;
      var $52915=$164;
      var $52916=$165;
      __label__ = 14340; break;
    case 14340: // $52917
      __label__ = 14611; break;
    case 14341: // $52918
      var $52919=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52920=$52919.f0;
      $4692=$52920;
      var $52921=$52919.f1;
      $4693=$52921;
      var $52922=$160;
      var $52923=$161;
      var $52924=$162;
      HEAP32[(($160)>>2)]=$41152;
      HEAP32[(($161)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($162)>>2)]=618;
      var $52925=HEAP32[(($160)>>2)];
      var $52926=(($52925)|0)!=0;
      if ($52926) { __label__ = 14342; break; } else { __label__ = 14344; break; }
    case 14342: // $52927
      var $52928=HEAP32[(($160)>>2)];
      var $52929=HEAP32[(($161)>>2)];
      var $52930=HEAP32[(($162)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52928, $52929, $52930) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14343; break; } else { __label__ = 14612; break; }
    case 14343: // $_noexc2233
      __label__ = 14344; break;
    case 14344: // $_ZdlPvPKci_exit2234
      var $52931=$160;
      var $52932=$161;
      var $52933=$162;
      __label__ = 14345; break;
    case 14345: // $52934
      __label__ = 14611; break;
    case 14346: // $52935
      var $52936=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52937=$52936.f0;
      $4692=$52937;
      var $52938=$52936.f1;
      $4693=$52938;
      var $52939=$157;
      var $52940=$158;
      var $52941=$159;
      HEAP32[(($157)>>2)]=$41203;
      HEAP32[(($158)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($159)>>2)]=619;
      var $52942=HEAP32[(($157)>>2)];
      var $52943=(($52942)|0)!=0;
      if ($52943) { __label__ = 14347; break; } else { __label__ = 14349; break; }
    case 14347: // $52944
      var $52945=HEAP32[(($157)>>2)];
      var $52946=HEAP32[(($158)>>2)];
      var $52947=HEAP32[(($159)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52945, $52946, $52947) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14348; break; } else { __label__ = 14612; break; }
    case 14348: // $_noexc2235
      __label__ = 14349; break;
    case 14349: // $_ZdlPvPKci_exit2236
      var $52948=$157;
      var $52949=$158;
      var $52950=$159;
      __label__ = 14350; break;
    case 14350: // $52951
      __label__ = 14611; break;
    case 14351: // $52952
      var $52953=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52954=$52953.f0;
      $4692=$52954;
      var $52955=$52953.f1;
      $4693=$52955;
      var $52956=$154;
      var $52957=$155;
      var $52958=$156;
      HEAP32[(($154)>>2)]=$41254;
      HEAP32[(($155)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($156)>>2)]=620;
      var $52959=HEAP32[(($154)>>2)];
      var $52960=(($52959)|0)!=0;
      if ($52960) { __label__ = 14352; break; } else { __label__ = 14354; break; }
    case 14352: // $52961
      var $52962=HEAP32[(($154)>>2)];
      var $52963=HEAP32[(($155)>>2)];
      var $52964=HEAP32[(($156)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52962, $52963, $52964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14353; break; } else { __label__ = 14612; break; }
    case 14353: // $_noexc2237
      __label__ = 14354; break;
    case 14354: // $_ZdlPvPKci_exit2238
      var $52965=$154;
      var $52966=$155;
      var $52967=$156;
      __label__ = 14355; break;
    case 14355: // $52968
      __label__ = 14611; break;
    case 14356: // $52969
      var $52970=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52971=$52970.f0;
      $4692=$52971;
      var $52972=$52970.f1;
      $4693=$52972;
      var $52973=$151;
      var $52974=$152;
      var $52975=$153;
      HEAP32[(($151)>>2)]=$41305;
      HEAP32[(($152)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($153)>>2)]=621;
      var $52976=HEAP32[(($151)>>2)];
      var $52977=(($52976)|0)!=0;
      if ($52977) { __label__ = 14357; break; } else { __label__ = 14359; break; }
    case 14357: // $52978
      var $52979=HEAP32[(($151)>>2)];
      var $52980=HEAP32[(($152)>>2)];
      var $52981=HEAP32[(($153)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52979, $52980, $52981) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14358; break; } else { __label__ = 14612; break; }
    case 14358: // $_noexc2239
      __label__ = 14359; break;
    case 14359: // $_ZdlPvPKci_exit2240
      var $52982=$151;
      var $52983=$152;
      var $52984=$153;
      __label__ = 14360; break;
    case 14360: // $52985
      __label__ = 14611; break;
    case 14361: // $52986
      var $52987=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52988=$52987.f0;
      $4692=$52988;
      var $52989=$52987.f1;
      $4693=$52989;
      var $52990=$148;
      var $52991=$149;
      var $52992=$150;
      HEAP32[(($148)>>2)]=$41356;
      HEAP32[(($149)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($150)>>2)]=622;
      var $52993=HEAP32[(($148)>>2)];
      var $52994=(($52993)|0)!=0;
      if ($52994) { __label__ = 14362; break; } else { __label__ = 14364; break; }
    case 14362: // $52995
      var $52996=HEAP32[(($148)>>2)];
      var $52997=HEAP32[(($149)>>2)];
      var $52998=HEAP32[(($150)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($52996, $52997, $52998) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14363; break; } else { __label__ = 14612; break; }
    case 14363: // $_noexc2241
      __label__ = 14364; break;
    case 14364: // $_ZdlPvPKci_exit2242
      var $52999=$148;
      var $53000=$149;
      var $53001=$150;
      __label__ = 14365; break;
    case 14365: // $53002
      __label__ = 14611; break;
    case 14366: // $53003
      var $53004=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53005=$53004.f0;
      $4692=$53005;
      var $53006=$53004.f1;
      $4693=$53006;
      var $53007=$145;
      var $53008=$146;
      var $53009=$147;
      HEAP32[(($145)>>2)]=$41407;
      HEAP32[(($146)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($147)>>2)]=623;
      var $53010=HEAP32[(($145)>>2)];
      var $53011=(($53010)|0)!=0;
      if ($53011) { __label__ = 14367; break; } else { __label__ = 14369; break; }
    case 14367: // $53012
      var $53013=HEAP32[(($145)>>2)];
      var $53014=HEAP32[(($146)>>2)];
      var $53015=HEAP32[(($147)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53013, $53014, $53015) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14368; break; } else { __label__ = 14612; break; }
    case 14368: // $_noexc2243
      __label__ = 14369; break;
    case 14369: // $_ZdlPvPKci_exit2244
      var $53016=$145;
      var $53017=$146;
      var $53018=$147;
      __label__ = 14370; break;
    case 14370: // $53019
      __label__ = 14611; break;
    case 14371: // $53020
      var $53021=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53022=$53021.f0;
      $4692=$53022;
      var $53023=$53021.f1;
      $4693=$53023;
      var $53024=$142;
      var $53025=$143;
      var $53026=$144;
      HEAP32[(($142)>>2)]=$41458;
      HEAP32[(($143)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($144)>>2)]=624;
      var $53027=HEAP32[(($142)>>2)];
      var $53028=(($53027)|0)!=0;
      if ($53028) { __label__ = 14372; break; } else { __label__ = 14374; break; }
    case 14372: // $53029
      var $53030=HEAP32[(($142)>>2)];
      var $53031=HEAP32[(($143)>>2)];
      var $53032=HEAP32[(($144)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53030, $53031, $53032) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14373; break; } else { __label__ = 14612; break; }
    case 14373: // $_noexc2245
      __label__ = 14374; break;
    case 14374: // $_ZdlPvPKci_exit2246
      var $53033=$142;
      var $53034=$143;
      var $53035=$144;
      __label__ = 14375; break;
    case 14375: // $53036
      __label__ = 14611; break;
    case 14376: // $53037
      var $53038=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53039=$53038.f0;
      $4692=$53039;
      var $53040=$53038.f1;
      $4693=$53040;
      var $53041=$139;
      var $53042=$140;
      var $53043=$141;
      HEAP32[(($139)>>2)]=$41509;
      HEAP32[(($140)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($141)>>2)]=625;
      var $53044=HEAP32[(($139)>>2)];
      var $53045=(($53044)|0)!=0;
      if ($53045) { __label__ = 14377; break; } else { __label__ = 14379; break; }
    case 14377: // $53046
      var $53047=HEAP32[(($139)>>2)];
      var $53048=HEAP32[(($140)>>2)];
      var $53049=HEAP32[(($141)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53047, $53048, $53049) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14378; break; } else { __label__ = 14612; break; }
    case 14378: // $_noexc2247
      __label__ = 14379; break;
    case 14379: // $_ZdlPvPKci_exit2248
      var $53050=$139;
      var $53051=$140;
      var $53052=$141;
      __label__ = 14380; break;
    case 14380: // $53053
      __label__ = 14611; break;
    case 14381: // $53054
      var $53055=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53056=$53055.f0;
      $4692=$53056;
      var $53057=$53055.f1;
      $4693=$53057;
      var $53058=$136;
      var $53059=$137;
      var $53060=$138;
      HEAP32[(($136)>>2)]=$41560;
      HEAP32[(($137)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($138)>>2)]=626;
      var $53061=HEAP32[(($136)>>2)];
      var $53062=(($53061)|0)!=0;
      if ($53062) { __label__ = 14382; break; } else { __label__ = 14384; break; }
    case 14382: // $53063
      var $53064=HEAP32[(($136)>>2)];
      var $53065=HEAP32[(($137)>>2)];
      var $53066=HEAP32[(($138)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53064, $53065, $53066) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14383; break; } else { __label__ = 14612; break; }
    case 14383: // $_noexc2249
      __label__ = 14384; break;
    case 14384: // $_ZdlPvPKci_exit2250
      var $53067=$136;
      var $53068=$137;
      var $53069=$138;
      __label__ = 14385; break;
    case 14385: // $53070
      __label__ = 14611; break;
    case 14386: // $53071
      var $53072=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53073=$53072.f0;
      $4692=$53073;
      var $53074=$53072.f1;
      $4693=$53074;
      var $53075=$133;
      var $53076=$134;
      var $53077=$135;
      HEAP32[(($133)>>2)]=$41611;
      HEAP32[(($134)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($135)>>2)]=627;
      var $53078=HEAP32[(($133)>>2)];
      var $53079=(($53078)|0)!=0;
      if ($53079) { __label__ = 14387; break; } else { __label__ = 14389; break; }
    case 14387: // $53080
      var $53081=HEAP32[(($133)>>2)];
      var $53082=HEAP32[(($134)>>2)];
      var $53083=HEAP32[(($135)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53081, $53082, $53083) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14388; break; } else { __label__ = 14612; break; }
    case 14388: // $_noexc2251
      __label__ = 14389; break;
    case 14389: // $_ZdlPvPKci_exit2252
      var $53084=$133;
      var $53085=$134;
      var $53086=$135;
      __label__ = 14390; break;
    case 14390: // $53087
      __label__ = 14611; break;
    case 14391: // $53088
      var $53089=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53090=$53089.f0;
      $4692=$53090;
      var $53091=$53089.f1;
      $4693=$53091;
      var $53092=$130;
      var $53093=$131;
      var $53094=$132;
      HEAP32[(($130)>>2)]=$41662;
      HEAP32[(($131)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($132)>>2)]=628;
      var $53095=HEAP32[(($130)>>2)];
      var $53096=(($53095)|0)!=0;
      if ($53096) { __label__ = 14392; break; } else { __label__ = 14394; break; }
    case 14392: // $53097
      var $53098=HEAP32[(($130)>>2)];
      var $53099=HEAP32[(($131)>>2)];
      var $53100=HEAP32[(($132)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53098, $53099, $53100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14393; break; } else { __label__ = 14612; break; }
    case 14393: // $_noexc2253
      __label__ = 14394; break;
    case 14394: // $_ZdlPvPKci_exit2254
      var $53101=$130;
      var $53102=$131;
      var $53103=$132;
      __label__ = 14395; break;
    case 14395: // $53104
      __label__ = 14611; break;
    case 14396: // $53105
      var $53106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53107=$53106.f0;
      $4692=$53107;
      var $53108=$53106.f1;
      $4693=$53108;
      var $53109=$127;
      var $53110=$128;
      var $53111=$129;
      HEAP32[(($127)>>2)]=$41713;
      HEAP32[(($128)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($129)>>2)]=629;
      var $53112=HEAP32[(($127)>>2)];
      var $53113=(($53112)|0)!=0;
      if ($53113) { __label__ = 14397; break; } else { __label__ = 14399; break; }
    case 14397: // $53114
      var $53115=HEAP32[(($127)>>2)];
      var $53116=HEAP32[(($128)>>2)];
      var $53117=HEAP32[(($129)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53115, $53116, $53117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14398; break; } else { __label__ = 14612; break; }
    case 14398: // $_noexc2255
      __label__ = 14399; break;
    case 14399: // $_ZdlPvPKci_exit2256
      var $53118=$127;
      var $53119=$128;
      var $53120=$129;
      __label__ = 14400; break;
    case 14400: // $53121
      __label__ = 14611; break;
    case 14401: // $53122
      var $53123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53124=$53123.f0;
      $4692=$53124;
      var $53125=$53123.f1;
      $4693=$53125;
      var $53126=$124;
      var $53127=$125;
      var $53128=$126;
      HEAP32[(($124)>>2)]=$41764;
      HEAP32[(($125)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($126)>>2)]=630;
      var $53129=HEAP32[(($124)>>2)];
      var $53130=(($53129)|0)!=0;
      if ($53130) { __label__ = 14402; break; } else { __label__ = 14404; break; }
    case 14402: // $53131
      var $53132=HEAP32[(($124)>>2)];
      var $53133=HEAP32[(($125)>>2)];
      var $53134=HEAP32[(($126)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53132, $53133, $53134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14403; break; } else { __label__ = 14612; break; }
    case 14403: // $_noexc2257
      __label__ = 14404; break;
    case 14404: // $_ZdlPvPKci_exit2258
      var $53135=$124;
      var $53136=$125;
      var $53137=$126;
      __label__ = 14405; break;
    case 14405: // $53138
      __label__ = 14611; break;
    case 14406: // $53139
      var $53140=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53141=$53140.f0;
      $4692=$53141;
      var $53142=$53140.f1;
      $4693=$53142;
      var $53143=$121;
      var $53144=$122;
      var $53145=$123;
      HEAP32[(($121)>>2)]=$41815;
      HEAP32[(($122)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($123)>>2)]=631;
      var $53146=HEAP32[(($121)>>2)];
      var $53147=(($53146)|0)!=0;
      if ($53147) { __label__ = 14407; break; } else { __label__ = 14409; break; }
    case 14407: // $53148
      var $53149=HEAP32[(($121)>>2)];
      var $53150=HEAP32[(($122)>>2)];
      var $53151=HEAP32[(($123)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53149, $53150, $53151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14408; break; } else { __label__ = 14612; break; }
    case 14408: // $_noexc2259
      __label__ = 14409; break;
    case 14409: // $_ZdlPvPKci_exit2260
      var $53152=$121;
      var $53153=$122;
      var $53154=$123;
      __label__ = 14410; break;
    case 14410: // $53155
      __label__ = 14611; break;
    case 14411: // $53156
      var $53157=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53158=$53157.f0;
      $4692=$53158;
      var $53159=$53157.f1;
      $4693=$53159;
      var $53160=$118;
      var $53161=$119;
      var $53162=$120;
      HEAP32[(($118)>>2)]=$41866;
      HEAP32[(($119)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($120)>>2)]=632;
      var $53163=HEAP32[(($118)>>2)];
      var $53164=(($53163)|0)!=0;
      if ($53164) { __label__ = 14412; break; } else { __label__ = 14414; break; }
    case 14412: // $53165
      var $53166=HEAP32[(($118)>>2)];
      var $53167=HEAP32[(($119)>>2)];
      var $53168=HEAP32[(($120)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53166, $53167, $53168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14413; break; } else { __label__ = 14612; break; }
    case 14413: // $_noexc2261
      __label__ = 14414; break;
    case 14414: // $_ZdlPvPKci_exit2262
      var $53169=$118;
      var $53170=$119;
      var $53171=$120;
      __label__ = 14415; break;
    case 14415: // $53172
      __label__ = 14611; break;
    case 14416: // $53173
      var $53174=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53175=$53174.f0;
      $4692=$53175;
      var $53176=$53174.f1;
      $4693=$53176;
      var $53177=$115;
      var $53178=$116;
      var $53179=$117;
      HEAP32[(($115)>>2)]=$41917;
      HEAP32[(($116)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($117)>>2)]=633;
      var $53180=HEAP32[(($115)>>2)];
      var $53181=(($53180)|0)!=0;
      if ($53181) { __label__ = 14417; break; } else { __label__ = 14419; break; }
    case 14417: // $53182
      var $53183=HEAP32[(($115)>>2)];
      var $53184=HEAP32[(($116)>>2)];
      var $53185=HEAP32[(($117)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53183, $53184, $53185) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14418; break; } else { __label__ = 14612; break; }
    case 14418: // $_noexc2263
      __label__ = 14419; break;
    case 14419: // $_ZdlPvPKci_exit2264
      var $53186=$115;
      var $53187=$116;
      var $53188=$117;
      __label__ = 14420; break;
    case 14420: // $53189
      __label__ = 14611; break;
    case 14421: // $53190
      var $53191=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53192=$53191.f0;
      $4692=$53192;
      var $53193=$53191.f1;
      $4693=$53193;
      var $53194=$112;
      var $53195=$113;
      var $53196=$114;
      HEAP32[(($112)>>2)]=$41968;
      HEAP32[(($113)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($114)>>2)]=634;
      var $53197=HEAP32[(($112)>>2)];
      var $53198=(($53197)|0)!=0;
      if ($53198) { __label__ = 14422; break; } else { __label__ = 14424; break; }
    case 14422: // $53199
      var $53200=HEAP32[(($112)>>2)];
      var $53201=HEAP32[(($113)>>2)];
      var $53202=HEAP32[(($114)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53200, $53201, $53202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14423; break; } else { __label__ = 14612; break; }
    case 14423: // $_noexc2265
      __label__ = 14424; break;
    case 14424: // $_ZdlPvPKci_exit2266
      var $53203=$112;
      var $53204=$113;
      var $53205=$114;
      __label__ = 14425; break;
    case 14425: // $53206
      __label__ = 14611; break;
    case 14426: // $53207
      var $53208=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53209=$53208.f0;
      $4692=$53209;
      var $53210=$53208.f1;
      $4693=$53210;
      var $53211=$109;
      var $53212=$110;
      var $53213=$111;
      HEAP32[(($109)>>2)]=$42019;
      HEAP32[(($110)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($111)>>2)]=635;
      var $53214=HEAP32[(($109)>>2)];
      var $53215=(($53214)|0)!=0;
      if ($53215) { __label__ = 14427; break; } else { __label__ = 14429; break; }
    case 14427: // $53216
      var $53217=HEAP32[(($109)>>2)];
      var $53218=HEAP32[(($110)>>2)];
      var $53219=HEAP32[(($111)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53217, $53218, $53219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14428; break; } else { __label__ = 14612; break; }
    case 14428: // $_noexc2267
      __label__ = 14429; break;
    case 14429: // $_ZdlPvPKci_exit2268
      var $53220=$109;
      var $53221=$110;
      var $53222=$111;
      __label__ = 14430; break;
    case 14430: // $53223
      __label__ = 14611; break;
    case 14431: // $53224
      var $53225=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53226=$53225.f0;
      $4692=$53226;
      var $53227=$53225.f1;
      $4693=$53227;
      var $53228=$106;
      var $53229=$107;
      var $53230=$108;
      HEAP32[(($106)>>2)]=$42070;
      HEAP32[(($107)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($108)>>2)]=636;
      var $53231=HEAP32[(($106)>>2)];
      var $53232=(($53231)|0)!=0;
      if ($53232) { __label__ = 14432; break; } else { __label__ = 14434; break; }
    case 14432: // $53233
      var $53234=HEAP32[(($106)>>2)];
      var $53235=HEAP32[(($107)>>2)];
      var $53236=HEAP32[(($108)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53234, $53235, $53236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14433; break; } else { __label__ = 14612; break; }
    case 14433: // $_noexc2269
      __label__ = 14434; break;
    case 14434: // $_ZdlPvPKci_exit2270
      var $53237=$106;
      var $53238=$107;
      var $53239=$108;
      __label__ = 14435; break;
    case 14435: // $53240
      __label__ = 14611; break;
    case 14436: // $53241
      var $53242=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53243=$53242.f0;
      $4692=$53243;
      var $53244=$53242.f1;
      $4693=$53244;
      var $53245=$103;
      var $53246=$104;
      var $53247=$105;
      HEAP32[(($103)>>2)]=$42121;
      HEAP32[(($104)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($105)>>2)]=637;
      var $53248=HEAP32[(($103)>>2)];
      var $53249=(($53248)|0)!=0;
      if ($53249) { __label__ = 14437; break; } else { __label__ = 14439; break; }
    case 14437: // $53250
      var $53251=HEAP32[(($103)>>2)];
      var $53252=HEAP32[(($104)>>2)];
      var $53253=HEAP32[(($105)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53251, $53252, $53253) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14438; break; } else { __label__ = 14612; break; }
    case 14438: // $_noexc2271
      __label__ = 14439; break;
    case 14439: // $_ZdlPvPKci_exit2272
      var $53254=$103;
      var $53255=$104;
      var $53256=$105;
      __label__ = 14440; break;
    case 14440: // $53257
      __label__ = 14611; break;
    case 14441: // $53258
      var $53259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53260=$53259.f0;
      $4692=$53260;
      var $53261=$53259.f1;
      $4693=$53261;
      var $53262=$100;
      var $53263=$101;
      var $53264=$102;
      HEAP32[(($100)>>2)]=$42172;
      HEAP32[(($101)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($102)>>2)]=638;
      var $53265=HEAP32[(($100)>>2)];
      var $53266=(($53265)|0)!=0;
      if ($53266) { __label__ = 14442; break; } else { __label__ = 14444; break; }
    case 14442: // $53267
      var $53268=HEAP32[(($100)>>2)];
      var $53269=HEAP32[(($101)>>2)];
      var $53270=HEAP32[(($102)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53268, $53269, $53270) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14443; break; } else { __label__ = 14612; break; }
    case 14443: // $_noexc2273
      __label__ = 14444; break;
    case 14444: // $_ZdlPvPKci_exit2274
      var $53271=$100;
      var $53272=$101;
      var $53273=$102;
      __label__ = 14445; break;
    case 14445: // $53274
      __label__ = 14611; break;
    case 14446: // $53275
      var $53276=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53277=$53276.f0;
      $4692=$53277;
      var $53278=$53276.f1;
      $4693=$53278;
      var $53279=$97;
      var $53280=$98;
      var $53281=$99;
      HEAP32[(($97)>>2)]=$42223;
      HEAP32[(($98)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($99)>>2)]=639;
      var $53282=HEAP32[(($97)>>2)];
      var $53283=(($53282)|0)!=0;
      if ($53283) { __label__ = 14447; break; } else { __label__ = 14449; break; }
    case 14447: // $53284
      var $53285=HEAP32[(($97)>>2)];
      var $53286=HEAP32[(($98)>>2)];
      var $53287=HEAP32[(($99)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53285, $53286, $53287) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14448; break; } else { __label__ = 14612; break; }
    case 14448: // $_noexc2275
      __label__ = 14449; break;
    case 14449: // $_ZdlPvPKci_exit2276
      var $53288=$97;
      var $53289=$98;
      var $53290=$99;
      __label__ = 14450; break;
    case 14450: // $53291
      __label__ = 14611; break;
    case 14451: // $53292
      var $53293=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53294=$53293.f0;
      $4692=$53294;
      var $53295=$53293.f1;
      $4693=$53295;
      var $53296=$94;
      var $53297=$95;
      var $53298=$96;
      HEAP32[(($94)>>2)]=$42274;
      HEAP32[(($95)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($96)>>2)]=640;
      var $53299=HEAP32[(($94)>>2)];
      var $53300=(($53299)|0)!=0;
      if ($53300) { __label__ = 14452; break; } else { __label__ = 14454; break; }
    case 14452: // $53301
      var $53302=HEAP32[(($94)>>2)];
      var $53303=HEAP32[(($95)>>2)];
      var $53304=HEAP32[(($96)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53302, $53303, $53304) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14453; break; } else { __label__ = 14612; break; }
    case 14453: // $_noexc2277
      __label__ = 14454; break;
    case 14454: // $_ZdlPvPKci_exit2278
      var $53305=$94;
      var $53306=$95;
      var $53307=$96;
      __label__ = 14455; break;
    case 14455: // $53308
      __label__ = 14611; break;
    case 14456: // $53309
      var $53310=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53311=$53310.f0;
      $4692=$53311;
      var $53312=$53310.f1;
      $4693=$53312;
      var $53313=$91;
      var $53314=$92;
      var $53315=$93;
      HEAP32[(($91)>>2)]=$42325;
      HEAP32[(($92)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($93)>>2)]=641;
      var $53316=HEAP32[(($91)>>2)];
      var $53317=(($53316)|0)!=0;
      if ($53317) { __label__ = 14457; break; } else { __label__ = 14459; break; }
    case 14457: // $53318
      var $53319=HEAP32[(($91)>>2)];
      var $53320=HEAP32[(($92)>>2)];
      var $53321=HEAP32[(($93)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53319, $53320, $53321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14458; break; } else { __label__ = 14612; break; }
    case 14458: // $_noexc2279
      __label__ = 14459; break;
    case 14459: // $_ZdlPvPKci_exit2280
      var $53322=$91;
      var $53323=$92;
      var $53324=$93;
      __label__ = 14460; break;
    case 14460: // $53325
      __label__ = 14611; break;
    case 14461: // $53326
      var $53327=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53328=$53327.f0;
      $4692=$53328;
      var $53329=$53327.f1;
      $4693=$53329;
      var $53330=$88;
      var $53331=$89;
      var $53332=$90;
      HEAP32[(($88)>>2)]=$42376;
      HEAP32[(($89)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($90)>>2)]=642;
      var $53333=HEAP32[(($88)>>2)];
      var $53334=(($53333)|0)!=0;
      if ($53334) { __label__ = 14462; break; } else { __label__ = 14464; break; }
    case 14462: // $53335
      var $53336=HEAP32[(($88)>>2)];
      var $53337=HEAP32[(($89)>>2)];
      var $53338=HEAP32[(($90)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53336, $53337, $53338) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14463; break; } else { __label__ = 14612; break; }
    case 14463: // $_noexc2281
      __label__ = 14464; break;
    case 14464: // $_ZdlPvPKci_exit2282
      var $53339=$88;
      var $53340=$89;
      var $53341=$90;
      __label__ = 14465; break;
    case 14465: // $53342
      __label__ = 14611; break;
    case 14466: // $53343
      var $53344=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53345=$53344.f0;
      $4692=$53345;
      var $53346=$53344.f1;
      $4693=$53346;
      var $53347=$85;
      var $53348=$86;
      var $53349=$87;
      HEAP32[(($85)>>2)]=$42427;
      HEAP32[(($86)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($87)>>2)]=643;
      var $53350=HEAP32[(($85)>>2)];
      var $53351=(($53350)|0)!=0;
      if ($53351) { __label__ = 14467; break; } else { __label__ = 14469; break; }
    case 14467: // $53352
      var $53353=HEAP32[(($85)>>2)];
      var $53354=HEAP32[(($86)>>2)];
      var $53355=HEAP32[(($87)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53353, $53354, $53355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14468; break; } else { __label__ = 14612; break; }
    case 14468: // $_noexc2283
      __label__ = 14469; break;
    case 14469: // $_ZdlPvPKci_exit2284
      var $53356=$85;
      var $53357=$86;
      var $53358=$87;
      __label__ = 14470; break;
    case 14470: // $53359
      __label__ = 14611; break;
    case 14471: // $53360
      var $53361=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53362=$53361.f0;
      $4692=$53362;
      var $53363=$53361.f1;
      $4693=$53363;
      var $53364=$82;
      var $53365=$83;
      var $53366=$84;
      HEAP32[(($82)>>2)]=$42478;
      HEAP32[(($83)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($84)>>2)]=644;
      var $53367=HEAP32[(($82)>>2)];
      var $53368=(($53367)|0)!=0;
      if ($53368) { __label__ = 14472; break; } else { __label__ = 14474; break; }
    case 14472: // $53369
      var $53370=HEAP32[(($82)>>2)];
      var $53371=HEAP32[(($83)>>2)];
      var $53372=HEAP32[(($84)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53370, $53371, $53372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14473; break; } else { __label__ = 14612; break; }
    case 14473: // $_noexc2285
      __label__ = 14474; break;
    case 14474: // $_ZdlPvPKci_exit2286
      var $53373=$82;
      var $53374=$83;
      var $53375=$84;
      __label__ = 14475; break;
    case 14475: // $53376
      __label__ = 14611; break;
    case 14476: // $53377
      var $53378=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53379=$53378.f0;
      $4692=$53379;
      var $53380=$53378.f1;
      $4693=$53380;
      var $53381=$79;
      var $53382=$80;
      var $53383=$81;
      HEAP32[(($79)>>2)]=$42529;
      HEAP32[(($80)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($81)>>2)]=645;
      var $53384=HEAP32[(($79)>>2)];
      var $53385=(($53384)|0)!=0;
      if ($53385) { __label__ = 14477; break; } else { __label__ = 14479; break; }
    case 14477: // $53386
      var $53387=HEAP32[(($79)>>2)];
      var $53388=HEAP32[(($80)>>2)];
      var $53389=HEAP32[(($81)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53387, $53388, $53389) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14478; break; } else { __label__ = 14612; break; }
    case 14478: // $_noexc2287
      __label__ = 14479; break;
    case 14479: // $_ZdlPvPKci_exit2288
      var $53390=$79;
      var $53391=$80;
      var $53392=$81;
      __label__ = 14480; break;
    case 14480: // $53393
      __label__ = 14611; break;
    case 14481: // $53394
      var $53395=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53396=$53395.f0;
      $4692=$53396;
      var $53397=$53395.f1;
      $4693=$53397;
      var $53398=$76;
      var $53399=$77;
      var $53400=$78;
      HEAP32[(($76)>>2)]=$42580;
      HEAP32[(($77)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($78)>>2)]=646;
      var $53401=HEAP32[(($76)>>2)];
      var $53402=(($53401)|0)!=0;
      if ($53402) { __label__ = 14482; break; } else { __label__ = 14484; break; }
    case 14482: // $53403
      var $53404=HEAP32[(($76)>>2)];
      var $53405=HEAP32[(($77)>>2)];
      var $53406=HEAP32[(($78)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53404, $53405, $53406) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14483; break; } else { __label__ = 14612; break; }
    case 14483: // $_noexc2289
      __label__ = 14484; break;
    case 14484: // $_ZdlPvPKci_exit2290
      var $53407=$76;
      var $53408=$77;
      var $53409=$78;
      __label__ = 14485; break;
    case 14485: // $53410
      __label__ = 14611; break;
    case 14486: // $53411
      var $53412=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53413=$53412.f0;
      $4692=$53413;
      var $53414=$53412.f1;
      $4693=$53414;
      var $53415=$73;
      var $53416=$74;
      var $53417=$75;
      HEAP32[(($73)>>2)]=$42631;
      HEAP32[(($74)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($75)>>2)]=647;
      var $53418=HEAP32[(($73)>>2)];
      var $53419=(($53418)|0)!=0;
      if ($53419) { __label__ = 14487; break; } else { __label__ = 14489; break; }
    case 14487: // $53420
      var $53421=HEAP32[(($73)>>2)];
      var $53422=HEAP32[(($74)>>2)];
      var $53423=HEAP32[(($75)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53421, $53422, $53423) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14488; break; } else { __label__ = 14612; break; }
    case 14488: // $_noexc2291
      __label__ = 14489; break;
    case 14489: // $_ZdlPvPKci_exit2292
      var $53424=$73;
      var $53425=$74;
      var $53426=$75;
      __label__ = 14490; break;
    case 14490: // $53427
      __label__ = 14611; break;
    case 14491: // $53428
      var $53429=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53430=$53429.f0;
      $4692=$53430;
      var $53431=$53429.f1;
      $4693=$53431;
      var $53432=$70;
      var $53433=$71;
      var $53434=$72;
      HEAP32[(($70)>>2)]=$42682;
      HEAP32[(($71)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($72)>>2)]=649;
      var $53435=HEAP32[(($70)>>2)];
      var $53436=(($53435)|0)!=0;
      if ($53436) { __label__ = 14492; break; } else { __label__ = 14494; break; }
    case 14492: // $53437
      var $53438=HEAP32[(($70)>>2)];
      var $53439=HEAP32[(($71)>>2)];
      var $53440=HEAP32[(($72)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53438, $53439, $53440) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14493; break; } else { __label__ = 14612; break; }
    case 14493: // $_noexc2293
      __label__ = 14494; break;
    case 14494: // $_ZdlPvPKci_exit2294
      var $53441=$70;
      var $53442=$71;
      var $53443=$72;
      __label__ = 14495; break;
    case 14495: // $53444
      __label__ = 14611; break;
    case 14496: // $53445
      var $53446=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53447=$53446.f0;
      $4692=$53447;
      var $53448=$53446.f1;
      $4693=$53448;
      var $53449=$67;
      var $53450=$68;
      var $53451=$69;
      HEAP32[(($67)>>2)]=$42733;
      HEAP32[(($68)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($69)>>2)]=650;
      var $53452=HEAP32[(($67)>>2)];
      var $53453=(($53452)|0)!=0;
      if ($53453) { __label__ = 14497; break; } else { __label__ = 14499; break; }
    case 14497: // $53454
      var $53455=HEAP32[(($67)>>2)];
      var $53456=HEAP32[(($68)>>2)];
      var $53457=HEAP32[(($69)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53455, $53456, $53457) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14498; break; } else { __label__ = 14612; break; }
    case 14498: // $_noexc2295
      __label__ = 14499; break;
    case 14499: // $_ZdlPvPKci_exit2296
      var $53458=$67;
      var $53459=$68;
      var $53460=$69;
      __label__ = 14500; break;
    case 14500: // $53461
      __label__ = 14611; break;
    case 14501: // $53462
      var $53463=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53464=$53463.f0;
      $4692=$53464;
      var $53465=$53463.f1;
      $4693=$53465;
      var $53466=$64;
      var $53467=$65;
      var $53468=$66;
      HEAP32[(($64)>>2)]=$42784;
      HEAP32[(($65)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($66)>>2)]=651;
      var $53469=HEAP32[(($64)>>2)];
      var $53470=(($53469)|0)!=0;
      if ($53470) { __label__ = 14502; break; } else { __label__ = 14504; break; }
    case 14502: // $53471
      var $53472=HEAP32[(($64)>>2)];
      var $53473=HEAP32[(($65)>>2)];
      var $53474=HEAP32[(($66)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53472, $53473, $53474) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14503; break; } else { __label__ = 14612; break; }
    case 14503: // $_noexc2297
      __label__ = 14504; break;
    case 14504: // $_ZdlPvPKci_exit2298
      var $53475=$64;
      var $53476=$65;
      var $53477=$66;
      __label__ = 14505; break;
    case 14505: // $53478
      __label__ = 14611; break;
    case 14506: // $53479
      var $53480=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53481=$53480.f0;
      $4692=$53481;
      var $53482=$53480.f1;
      $4693=$53482;
      var $53483=$61;
      var $53484=$62;
      var $53485=$63;
      HEAP32[(($61)>>2)]=$42835;
      HEAP32[(($62)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($63)>>2)]=652;
      var $53486=HEAP32[(($61)>>2)];
      var $53487=(($53486)|0)!=0;
      if ($53487) { __label__ = 14507; break; } else { __label__ = 14509; break; }
    case 14507: // $53488
      var $53489=HEAP32[(($61)>>2)];
      var $53490=HEAP32[(($62)>>2)];
      var $53491=HEAP32[(($63)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53489, $53490, $53491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14508; break; } else { __label__ = 14612; break; }
    case 14508: // $_noexc2299
      __label__ = 14509; break;
    case 14509: // $_ZdlPvPKci_exit2300
      var $53492=$61;
      var $53493=$62;
      var $53494=$63;
      __label__ = 14510; break;
    case 14510: // $53495
      __label__ = 14611; break;
    case 14511: // $53496
      var $53497=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53498=$53497.f0;
      $4692=$53498;
      var $53499=$53497.f1;
      $4693=$53499;
      var $53500=$58;
      var $53501=$59;
      var $53502=$60;
      HEAP32[(($58)>>2)]=$42886;
      HEAP32[(($59)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($60)>>2)]=653;
      var $53503=HEAP32[(($58)>>2)];
      var $53504=(($53503)|0)!=0;
      if ($53504) { __label__ = 14512; break; } else { __label__ = 14514; break; }
    case 14512: // $53505
      var $53506=HEAP32[(($58)>>2)];
      var $53507=HEAP32[(($59)>>2)];
      var $53508=HEAP32[(($60)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53506, $53507, $53508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14513; break; } else { __label__ = 14612; break; }
    case 14513: // $_noexc2301
      __label__ = 14514; break;
    case 14514: // $_ZdlPvPKci_exit2302
      var $53509=$58;
      var $53510=$59;
      var $53511=$60;
      __label__ = 14515; break;
    case 14515: // $53512
      __label__ = 14611; break;
    case 14516: // $53513
      var $53514=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53515=$53514.f0;
      $4692=$53515;
      var $53516=$53514.f1;
      $4693=$53516;
      var $53517=$55;
      var $53518=$56;
      var $53519=$57;
      HEAP32[(($55)>>2)]=$42937;
      HEAP32[(($56)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($57)>>2)]=654;
      var $53520=HEAP32[(($55)>>2)];
      var $53521=(($53520)|0)!=0;
      if ($53521) { __label__ = 14517; break; } else { __label__ = 14519; break; }
    case 14517: // $53522
      var $53523=HEAP32[(($55)>>2)];
      var $53524=HEAP32[(($56)>>2)];
      var $53525=HEAP32[(($57)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53523, $53524, $53525) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14518; break; } else { __label__ = 14612; break; }
    case 14518: // $_noexc2303
      __label__ = 14519; break;
    case 14519: // $_ZdlPvPKci_exit2304
      var $53526=$55;
      var $53527=$56;
      var $53528=$57;
      __label__ = 14520; break;
    case 14520: // $53529
      __label__ = 14611; break;
    case 14521: // $53530
      var $53531=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53532=$53531.f0;
      $4692=$53532;
      var $53533=$53531.f1;
      $4693=$53533;
      var $53534=$52;
      var $53535=$53;
      var $53536=$54;
      HEAP32[(($52)>>2)]=$42988;
      HEAP32[(($53)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($54)>>2)]=655;
      var $53537=HEAP32[(($52)>>2)];
      var $53538=(($53537)|0)!=0;
      if ($53538) { __label__ = 14522; break; } else { __label__ = 14524; break; }
    case 14522: // $53539
      var $53540=HEAP32[(($52)>>2)];
      var $53541=HEAP32[(($53)>>2)];
      var $53542=HEAP32[(($54)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53540, $53541, $53542) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14523; break; } else { __label__ = 14612; break; }
    case 14523: // $_noexc2305
      __label__ = 14524; break;
    case 14524: // $_ZdlPvPKci_exit2306
      var $53543=$52;
      var $53544=$53;
      var $53545=$54;
      __label__ = 14525; break;
    case 14525: // $53546
      __label__ = 14611; break;
    case 14526: // $53547
      var $53548=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53549=$53548.f0;
      $4692=$53549;
      var $53550=$53548.f1;
      $4693=$53550;
      var $53551=$49;
      var $53552=$50;
      var $53553=$51;
      HEAP32[(($49)>>2)]=$43039;
      HEAP32[(($50)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($51)>>2)]=656;
      var $53554=HEAP32[(($49)>>2)];
      var $53555=(($53554)|0)!=0;
      if ($53555) { __label__ = 14527; break; } else { __label__ = 14529; break; }
    case 14527: // $53556
      var $53557=HEAP32[(($49)>>2)];
      var $53558=HEAP32[(($50)>>2)];
      var $53559=HEAP32[(($51)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53557, $53558, $53559) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14528; break; } else { __label__ = 14612; break; }
    case 14528: // $_noexc2307
      __label__ = 14529; break;
    case 14529: // $_ZdlPvPKci_exit2308
      var $53560=$49;
      var $53561=$50;
      var $53562=$51;
      __label__ = 14530; break;
    case 14530: // $53563
      __label__ = 14611; break;
    case 14531: // $53564
      var $53565=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53566=$53565.f0;
      $4692=$53566;
      var $53567=$53565.f1;
      $4693=$53567;
      var $53568=$46;
      var $53569=$47;
      var $53570=$48;
      HEAP32[(($46)>>2)]=$43090;
      HEAP32[(($47)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($48)>>2)]=657;
      var $53571=HEAP32[(($46)>>2)];
      var $53572=(($53571)|0)!=0;
      if ($53572) { __label__ = 14532; break; } else { __label__ = 14534; break; }
    case 14532: // $53573
      var $53574=HEAP32[(($46)>>2)];
      var $53575=HEAP32[(($47)>>2)];
      var $53576=HEAP32[(($48)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53574, $53575, $53576) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14533; break; } else { __label__ = 14612; break; }
    case 14533: // $_noexc2309
      __label__ = 14534; break;
    case 14534: // $_ZdlPvPKci_exit2310
      var $53577=$46;
      var $53578=$47;
      var $53579=$48;
      __label__ = 14535; break;
    case 14535: // $53580
      __label__ = 14611; break;
    case 14536: // $53581
      var $53582=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53583=$53582.f0;
      $4692=$53583;
      var $53584=$53582.f1;
      $4693=$53584;
      var $53585=$43;
      var $53586=$44;
      var $53587=$45;
      HEAP32[(($43)>>2)]=$43141;
      HEAP32[(($44)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($45)>>2)]=658;
      var $53588=HEAP32[(($43)>>2)];
      var $53589=(($53588)|0)!=0;
      if ($53589) { __label__ = 14537; break; } else { __label__ = 14539; break; }
    case 14537: // $53590
      var $53591=HEAP32[(($43)>>2)];
      var $53592=HEAP32[(($44)>>2)];
      var $53593=HEAP32[(($45)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53591, $53592, $53593) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14538; break; } else { __label__ = 14612; break; }
    case 14538: // $_noexc2311
      __label__ = 14539; break;
    case 14539: // $_ZdlPvPKci_exit2312
      var $53594=$43;
      var $53595=$44;
      var $53596=$45;
      __label__ = 14540; break;
    case 14540: // $53597
      __label__ = 14611; break;
    case 14541: // $53598
      var $53599=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53600=$53599.f0;
      $4692=$53600;
      var $53601=$53599.f1;
      $4693=$53601;
      var $53602=$40;
      var $53603=$41;
      var $53604=$42;
      HEAP32[(($40)>>2)]=$43192;
      HEAP32[(($41)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($42)>>2)]=659;
      var $53605=HEAP32[(($40)>>2)];
      var $53606=(($53605)|0)!=0;
      if ($53606) { __label__ = 14542; break; } else { __label__ = 14544; break; }
    case 14542: // $53607
      var $53608=HEAP32[(($40)>>2)];
      var $53609=HEAP32[(($41)>>2)];
      var $53610=HEAP32[(($42)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53608, $53609, $53610) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14543; break; } else { __label__ = 14612; break; }
    case 14543: // $_noexc2313
      __label__ = 14544; break;
    case 14544: // $_ZdlPvPKci_exit2314
      var $53611=$40;
      var $53612=$41;
      var $53613=$42;
      __label__ = 14545; break;
    case 14545: // $53614
      __label__ = 14611; break;
    case 14546: // $53615
      var $53616=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53617=$53616.f0;
      $4692=$53617;
      var $53618=$53616.f1;
      $4693=$53618;
      var $53619=$37;
      var $53620=$38;
      var $53621=$39;
      HEAP32[(($37)>>2)]=$43243;
      HEAP32[(($38)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($39)>>2)]=660;
      var $53622=HEAP32[(($37)>>2)];
      var $53623=(($53622)|0)!=0;
      if ($53623) { __label__ = 14547; break; } else { __label__ = 14549; break; }
    case 14547: // $53624
      var $53625=HEAP32[(($37)>>2)];
      var $53626=HEAP32[(($38)>>2)];
      var $53627=HEAP32[(($39)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53625, $53626, $53627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14548; break; } else { __label__ = 14612; break; }
    case 14548: // $_noexc2315
      __label__ = 14549; break;
    case 14549: // $_ZdlPvPKci_exit2316
      var $53628=$37;
      var $53629=$38;
      var $53630=$39;
      __label__ = 14550; break;
    case 14550: // $53631
      __label__ = 14611; break;
    case 14551: // $53632
      var $53633=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53634=$53633.f0;
      $4692=$53634;
      var $53635=$53633.f1;
      $4693=$53635;
      var $53636=$34;
      var $53637=$35;
      var $53638=$36;
      HEAP32[(($34)>>2)]=$43294;
      HEAP32[(($35)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($36)>>2)]=661;
      var $53639=HEAP32[(($34)>>2)];
      var $53640=(($53639)|0)!=0;
      if ($53640) { __label__ = 14552; break; } else { __label__ = 14554; break; }
    case 14552: // $53641
      var $53642=HEAP32[(($34)>>2)];
      var $53643=HEAP32[(($35)>>2)];
      var $53644=HEAP32[(($36)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53642, $53643, $53644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14553; break; } else { __label__ = 14612; break; }
    case 14553: // $_noexc2317
      __label__ = 14554; break;
    case 14554: // $_ZdlPvPKci_exit2318
      var $53645=$34;
      var $53646=$35;
      var $53647=$36;
      __label__ = 14555; break;
    case 14555: // $53648
      __label__ = 14611; break;
    case 14556: // $53649
      var $53650=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53651=$53650.f0;
      $4692=$53651;
      var $53652=$53650.f1;
      $4693=$53652;
      var $53653=$31;
      var $53654=$32;
      var $53655=$33;
      HEAP32[(($31)>>2)]=$43345;
      HEAP32[(($32)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($33)>>2)]=662;
      var $53656=HEAP32[(($31)>>2)];
      var $53657=(($53656)|0)!=0;
      if ($53657) { __label__ = 14557; break; } else { __label__ = 14559; break; }
    case 14557: // $53658
      var $53659=HEAP32[(($31)>>2)];
      var $53660=HEAP32[(($32)>>2)];
      var $53661=HEAP32[(($33)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53659, $53660, $53661) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14558; break; } else { __label__ = 14612; break; }
    case 14558: // $_noexc2319
      __label__ = 14559; break;
    case 14559: // $_ZdlPvPKci_exit2320
      var $53662=$31;
      var $53663=$32;
      var $53664=$33;
      __label__ = 14560; break;
    case 14560: // $53665
      __label__ = 14611; break;
    case 14561: // $53666
      var $53667=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53668=$53667.f0;
      $4692=$53668;
      var $53669=$53667.f1;
      $4693=$53669;
      var $53670=$28;
      var $53671=$29;
      var $53672=$30;
      HEAP32[(($28)>>2)]=$43396;
      HEAP32[(($29)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($30)>>2)]=663;
      var $53673=HEAP32[(($28)>>2)];
      var $53674=(($53673)|0)!=0;
      if ($53674) { __label__ = 14562; break; } else { __label__ = 14564; break; }
    case 14562: // $53675
      var $53676=HEAP32[(($28)>>2)];
      var $53677=HEAP32[(($29)>>2)];
      var $53678=HEAP32[(($30)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53676, $53677, $53678) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14563; break; } else { __label__ = 14612; break; }
    case 14563: // $_noexc2321
      __label__ = 14564; break;
    case 14564: // $_ZdlPvPKci_exit2322
      var $53679=$28;
      var $53680=$29;
      var $53681=$30;
      __label__ = 14565; break;
    case 14565: // $53682
      __label__ = 14611; break;
    case 14566: // $53683
      var $53684=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53685=$53684.f0;
      $4692=$53685;
      var $53686=$53684.f1;
      $4693=$53686;
      var $53687=$25;
      var $53688=$26;
      var $53689=$27;
      HEAP32[(($25)>>2)]=$43447;
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($27)>>2)]=664;
      var $53690=HEAP32[(($25)>>2)];
      var $53691=(($53690)|0)!=0;
      if ($53691) { __label__ = 14567; break; } else { __label__ = 14569; break; }
    case 14567: // $53692
      var $53693=HEAP32[(($25)>>2)];
      var $53694=HEAP32[(($26)>>2)];
      var $53695=HEAP32[(($27)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53693, $53694, $53695) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14568; break; } else { __label__ = 14612; break; }
    case 14568: // $_noexc2323
      __label__ = 14569; break;
    case 14569: // $_ZdlPvPKci_exit2324
      var $53696=$25;
      var $53697=$26;
      var $53698=$27;
      __label__ = 14570; break;
    case 14570: // $53699
      __label__ = 14611; break;
    case 14571: // $53700
      var $53701=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53702=$53701.f0;
      $4692=$53702;
      var $53703=$53701.f1;
      $4693=$53703;
      var $53704=$22;
      var $53705=$23;
      var $53706=$24;
      HEAP32[(($22)>>2)]=$43498;
      HEAP32[(($23)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($24)>>2)]=665;
      var $53707=HEAP32[(($22)>>2)];
      var $53708=(($53707)|0)!=0;
      if ($53708) { __label__ = 14572; break; } else { __label__ = 14574; break; }
    case 14572: // $53709
      var $53710=HEAP32[(($22)>>2)];
      var $53711=HEAP32[(($23)>>2)];
      var $53712=HEAP32[(($24)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53710, $53711, $53712) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14573; break; } else { __label__ = 14612; break; }
    case 14573: // $_noexc2325
      __label__ = 14574; break;
    case 14574: // $_ZdlPvPKci_exit2326
      var $53713=$22;
      var $53714=$23;
      var $53715=$24;
      __label__ = 14575; break;
    case 14575: // $53716
      __label__ = 14611; break;
    case 14576: // $53717
      var $53718=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53719=$53718.f0;
      $4692=$53719;
      var $53720=$53718.f1;
      $4693=$53720;
      var $53721=$19;
      var $53722=$20;
      var $53723=$21;
      HEAP32[(($19)>>2)]=$43549;
      HEAP32[(($20)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($21)>>2)]=666;
      var $53724=HEAP32[(($19)>>2)];
      var $53725=(($53724)|0)!=0;
      if ($53725) { __label__ = 14577; break; } else { __label__ = 14579; break; }
    case 14577: // $53726
      var $53727=HEAP32[(($19)>>2)];
      var $53728=HEAP32[(($20)>>2)];
      var $53729=HEAP32[(($21)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53727, $53728, $53729) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14578; break; } else { __label__ = 14612; break; }
    case 14578: // $_noexc2327
      __label__ = 14579; break;
    case 14579: // $_ZdlPvPKci_exit2328
      var $53730=$19;
      var $53731=$20;
      var $53732=$21;
      __label__ = 14580; break;
    case 14580: // $53733
      __label__ = 14611; break;
    case 14581: // $53734
      var $53735=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53736=$53735.f0;
      $4692=$53736;
      var $53737=$53735.f1;
      $4693=$53737;
      var $53738=$16;
      var $53739=$17;
      var $53740=$18;
      HEAP32[(($16)>>2)]=$43600;
      HEAP32[(($17)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($18)>>2)]=667;
      var $53741=HEAP32[(($16)>>2)];
      var $53742=(($53741)|0)!=0;
      if ($53742) { __label__ = 14582; break; } else { __label__ = 14584; break; }
    case 14582: // $53743
      var $53744=HEAP32[(($16)>>2)];
      var $53745=HEAP32[(($17)>>2)];
      var $53746=HEAP32[(($18)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53744, $53745, $53746) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14583; break; } else { __label__ = 14612; break; }
    case 14583: // $_noexc2329
      __label__ = 14584; break;
    case 14584: // $_ZdlPvPKci_exit2330
      var $53747=$16;
      var $53748=$17;
      var $53749=$18;
      __label__ = 14585; break;
    case 14585: // $53750
      __label__ = 14611; break;
    case 14586: // $53751
      var $53752=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53753=$53752.f0;
      $4692=$53753;
      var $53754=$53752.f1;
      $4693=$53754;
      var $53755=$13;
      var $53756=$14;
      var $53757=$15;
      HEAP32[(($13)>>2)]=$43651;
      HEAP32[(($14)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($15)>>2)]=668;
      var $53758=HEAP32[(($13)>>2)];
      var $53759=(($53758)|0)!=0;
      if ($53759) { __label__ = 14587; break; } else { __label__ = 14589; break; }
    case 14587: // $53760
      var $53761=HEAP32[(($13)>>2)];
      var $53762=HEAP32[(($14)>>2)];
      var $53763=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53761, $53762, $53763) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14588; break; } else { __label__ = 14612; break; }
    case 14588: // $_noexc2331
      __label__ = 14589; break;
    case 14589: // $_ZdlPvPKci_exit2332
      var $53764=$13;
      var $53765=$14;
      var $53766=$15;
      __label__ = 14590; break;
    case 14590: // $53767
      __label__ = 14611; break;
    case 14591: // $53768
      var $53769=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53770=$53769.f0;
      $4692=$53770;
      var $53771=$53769.f1;
      $4693=$53771;
      var $53772=$10;
      var $53773=$11;
      var $53774=$12;
      HEAP32[(($10)>>2)]=$43702;
      HEAP32[(($11)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($12)>>2)]=669;
      var $53775=HEAP32[(($10)>>2)];
      var $53776=(($53775)|0)!=0;
      if ($53776) { __label__ = 14592; break; } else { __label__ = 14594; break; }
    case 14592: // $53777
      var $53778=HEAP32[(($10)>>2)];
      var $53779=HEAP32[(($11)>>2)];
      var $53780=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53778, $53779, $53780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14593; break; } else { __label__ = 14612; break; }
    case 14593: // $_noexc2333
      __label__ = 14594; break;
    case 14594: // $_ZdlPvPKci_exit2334
      var $53781=$10;
      var $53782=$11;
      var $53783=$12;
      __label__ = 14595; break;
    case 14595: // $53784
      __label__ = 14611; break;
    case 14596: // $53785
      var $53786=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53787=$53786.f0;
      $4692=$53787;
      var $53788=$53786.f1;
      $4693=$53788;
      var $53789=$7;
      var $53790=$8;
      var $53791=$9;
      HEAP32[(($7)>>2)]=$43753;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($9)>>2)]=670;
      var $53792=HEAP32[(($7)>>2)];
      var $53793=(($53792)|0)!=0;
      if ($53793) { __label__ = 14597; break; } else { __label__ = 14599; break; }
    case 14597: // $53794
      var $53795=HEAP32[(($7)>>2)];
      var $53796=HEAP32[(($8)>>2)];
      var $53797=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53795, $53796, $53797) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14598; break; } else { __label__ = 14612; break; }
    case 14598: // $_noexc2335
      __label__ = 14599; break;
    case 14599: // $_ZdlPvPKci_exit2336
      var $53798=$7;
      var $53799=$8;
      var $53800=$9;
      __label__ = 14600; break;
    case 14600: // $53801
      __label__ = 14611; break;
    case 14601: // $53802
      var $53803=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53804=$53803.f0;
      $4692=$53804;
      var $53805=$53803.f1;
      $4693=$53805;
      var $53806=$4;
      var $53807=$5;
      var $53808=$6;
      HEAP32[(($4)>>2)]=$43804;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($6)>>2)]=671;
      var $53809=HEAP32[(($4)>>2)];
      var $53810=(($53809)|0)!=0;
      if ($53810) { __label__ = 14602; break; } else { __label__ = 14604; break; }
    case 14602: // $53811
      var $53812=HEAP32[(($4)>>2)];
      var $53813=HEAP32[(($5)>>2)];
      var $53814=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53812, $53813, $53814) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14603; break; } else { __label__ = 14612; break; }
    case 14603: // $_noexc2337
      __label__ = 14604; break;
    case 14604: // $_ZdlPvPKci_exit2338
      var $53815=$4;
      var $53816=$5;
      var $53817=$6;
      __label__ = 14605; break;
    case 14605: // $53818
      __label__ = 14611; break;
    case 14606: // $53819
      var $53820=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53821=$53820.f0;
      $4692=$53821;
      var $53822=$53820.f1;
      $4693=$53822;
      var $53823=$1;
      var $53824=$2;
      var $53825=$3;
      HEAP32[(($1)>>2)]=$43855;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str191)|0);
      HEAP32[(($3)>>2)]=672;
      var $53826=HEAP32[(($1)>>2)];
      var $53827=(($53826)|0)!=0;
      if ($53827) { __label__ = 14607; break; } else { __label__ = 14609; break; }
    case 14607: // $53828
      var $53829=HEAP32[(($1)>>2)];
      var $53830=HEAP32[(($2)>>2)];
      var $53831=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($53829, $53830, $53831) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14608; break; } else { __label__ = 14612; break; }
    case 14608: // $_noexc2339
      __label__ = 14609; break;
    case 14609: // $_ZdlPvPKci_exit2340
      var $53832=$1;
      var $53833=$2;
      var $53834=$3;
      __label__ = 14610; break;
    case 14610: // $53835
      __label__ = 14611; break;
    case 14611: // $53836
      var $53837=$4692;
      var $53838=$4692;
      var $53839=$4693;
      var $53840=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53838, tempValue);
      var $53841=($53840.f1 = $53839, $53840);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14612: // $53842
      var $53843=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20construct_core_typesR11simple_listI16input_type_entryE["X"]=1;

function __ZN11simple_listI16input_type_entryE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+404)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+404)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astringcvbEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=(($7 << 24) >> 24);
  var $9=(($8)|0)!=0;
  ;
  return $9;
}


function __ZNK8device_t4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($this, $code0, $code1, $code2, $code3, $code4, $code5, $code6) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN9input_seqC2E10input_codeS0_S0_S0_S0_S0_S0_($2, $code0, $code1, $code2, $code3, $code4, $code5, $code6);
  ;
  return;
}


function __ZN10input_codeC1ERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  __ZN10input_codeC2ERKS_($3, $4);
  ;
  return;
}


function __ZN19_input_port_privateC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19_input_port_privateC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvvEEC2I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZL15input_port_exitR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  __ZL12playback_endR15running_machinePKc($2, 0);
  var $3=$1;
  __ZL10record_endR15running_machinePKc($3, 0);
  ;
  return;
}


function __ZL21frame_update_callbackR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine6pausedEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 3; break;
    case 2: // $5
      var $6=$1;
      __ZL12frame_updateR15running_machine($6);
      __label__ = 3; break;
    case 3: // $7
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15init_port_typesR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $curtype;
      var $seqtype;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      var $5=$portdata;
      var $6=(($5+4)|0);
      __Z20construct_core_typesR11simple_listI16input_type_entryE($6);
      var $7=$1;
      var $8=__ZNK15running_machine3osdEv($7);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+32)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$portdata;
      var $14=(($13+4)|0);
      FUNCTION_TABLE[$12]($8, $14);
      var $15=$portdata;
      var $16=(($15+4)|0);
      var $17=__ZNK11simple_listI16input_type_entryE5firstEv($16);
      $curtype=$17;
      __label__ = 1; break;
    case 1: // $18
      var $19=$curtype;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $21
      $seqtype=0;
      __label__ = 3; break;
    case 3: // $22
      var $23=$seqtype;
      var $24=(($23)>>>0) < 3;
      if ($24) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $25
      var $26=$seqtype;
      var $27=$curtype;
      var $28=(($27+212)|0);
      var $29=(($28+($26<<6))|0);
      var $30=$seqtype;
      var $31=$curtype;
      var $32=(($31+20)|0);
      var $33=(($32+($30<<6))|0);
      var $34=$29;
      var $35=$33;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $35>>2, $$dest = $34>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 5; break;
    case 5: // $36
      var $37=$seqtype;
      var $38=(($37+1)|0);
      $seqtype=$38;
      __label__ = 3; break;
    case 6: // $39
      var $40=$curtype;
      var $41=$curtype;
      var $42=(($41+8)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$curtype;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$portdata;
      var $49=(($48+24)|0);
      var $50=(($49+($47<<5))|0);
      var $51=(($50+($44<<2))|0);
      HEAP32[(($51)>>2)]=$40;
      __label__ = 7; break;
    case 7: // $52
      var $53=$curtype;
      var $54=__ZNK16input_type_entry4nextEv($53);
      $curtype=$54;
      __label__ = 1; break;
    case 8: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15init_port_typesR15running_machine["X"]=1;

function __ZNK15running_machine10devicelistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+668)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK14machine_config10devicelistEv($4);
  ;
  return $5;
}


function __ZNK11tagged_listI8device_tE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listI8device_tE5firstEv($3);
  ;
  return $4;
}


function __Z20input_port_list_initR8device_tR11tagged_listI17input_port_configER7astring($device, $portlist, $errorbuf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $constructor;
      var $port;
      $1=$device;
      $2=$portlist;
      $3=$errorbuf;
      var $4=$1;
      var $5=__ZNK8device_t11input_portsEv($4);
      $constructor=$5;
      var $6=$constructor;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 6; break;
    case 2: // $9
      var $10=$3;
      var $11=__ZN7astring5resetEv($10);
      var $12=$constructor;
      var $13=$1;
      var $14=$2;
      var $15=$3;
      FUNCTION_TABLE[$12]($13, $14, $15);
      var $16=$2;
      var $17=__ZNK11tagged_listI17input_port_configE5firstEv($16);
      $port=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$port;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $21
      var $22=$port;
      var $23=$3;
      __ZN17input_port_config15collapse_fieldsER7astring($22, $23);
      __label__ = 5; break;
    case 5: // $24
      var $25=$port;
      var $26=__ZNK17input_port_config4nextEv($25);
      $port=$26;
      __label__ = 3; break;
    case 6: // $27
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK7astring4cstrEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__Z9astring_cPK7astring($2);
  ;
  return $3;
}


function __ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16input_type_entryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_["X"]=1;

function __Z15input_port_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 204; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $basetime;
      var $12;
      var $13;
      var $14=__stackBase__+44;
      var $15=__stackBase__+68;
      var $device;
      var $errors=__stackBase__+92;
      var $16=__stackBase__+156;
      var $17=__stackBase__+180;
      $11=$machine;
      var $18=$11;
      var $19=__ZN15running_machine7respoolEv($18);
      var $20=$5;
      var $21=$6;
      var $22=$7;
      var $23=$8;
      var $24=$result_i;
      var $25=$9;
      var $26=$10;
      HEAP32[(($5)>>2)]=7492;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($7)>>2)]=899;
      HEAP32[(($8)>>2)]=_zeromem;
      var $27=HEAP32[(($5)>>2)];
      var $28=HEAP32[(($6)>>2)];
      var $29=HEAP32[(($7)>>2)];
      var $30=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27, $28, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $31
      HEAP32[(($result_i)>>2)]=$30;
      var $32=HEAP32[(($result_i)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $34
      var $35=___cxa_allocate_exception(4);
      var $36=$35;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36);
      (function() { try { __THREW__ = false; return ___cxa_throw($35, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      HEAP32[(($9)>>2)]=$39;
      var $40=$38.f1;
      HEAP32[(($10)>>2)]=$40;
      var $41=HEAP32[(($10)>>2)];
      var $42=(($41)|0) < 0;
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      var $44=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($44);
      throw "Reached an unreachable!"
    case 5: // $45
      var $46=HEAP32[(($9)>>2)];
      var $47=HEAP32[(($9)>>2)];
      var $48=HEAP32[(($10)>>2)];
      var $49=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $47, tempValue);
      var $50=($49.f1 = $48, $49);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $51
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $52=HEAP32[(($result_i)>>2)];
      var $53=HEAP32[(($5)>>2)];
      _memset($52, 0, $53, 1);
      var $54=HEAP32[(($result_i)>>2)];
      var $55=$5;
      var $56=$6;
      var $57=$7;
      var $58=$8;
      var $59=$result_i;
      var $60=$9;
      var $61=$10;
      var $62=$54;
      (function() { try { __THREW__ = false; return __ZN19_input_port_privateC1Ev($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $63
      var $64=__ZN13resource_pool10add_objectI19_input_port_privateEEPT_S3_($19, $62);
      var $65=$11;
      var $66=(($65+644)|0);
      HEAP32[(($66)>>2)]=$64;
      var $67=$11;
      var $68=$11;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($14, 112, ((STRING_TABLE.__str1338)|0), $68);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($67, 4, $14);
      var $69=$11;
      var $70=$11;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($15, 114, ((STRING_TABLE.__str1339)|0), $70);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($69, 0, $15);
      var $71=$11;
      __ZL15init_port_typesR15running_machine($71);
      var $72=$11;
      var $73=__ZNK15running_machine10devicelistEv($72);
      var $74=$73;
      var $75=__ZNK11tagged_listI8device_tE5firstEv($74);
      $device=$75;
      __label__ = 9; break;
    case 9: // $76
      var $77=$device;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 10; break; } else { __label__ = 25; break; }
    case 10: // $79
      __ZN7astringC1Ev($errors);
      var $80=$device;
      var $81=$11;
      var $82=(($81+20)|0);
      (function() { try { __THREW__ = false; return __Z20input_port_list_initR8device_tR11tagged_listI17input_port_configER7astring($80, $82, $errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 21; break; }
    case 11: // $83
      var $84=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 21; break; };
    case 12: // $85
      if ($84) { __label__ = 13; break; } else { __label__ = 22; break; }
    case 13: // $86
      var $87=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 21; break; };
    case 14: // $88
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1340)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$87,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $89
      __label__ = 22; break;
    case 16: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $92=$91.f0;
      $12=$92;
      var $93=$91.f1;
      $13=$93;
      var $94=$1;
      var $95=$2;
      var $96=$3;
      var $97=$4;
      HEAP32[(($1)>>2)]=$54;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=899;
      HEAP32[(($4)>>2)]=_zeromem;
      var $98=HEAP32[(($1)>>2)];
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $100
      var $101=HEAP32[(($1)>>2)];
      var $102=HEAP32[(($2)>>2)];
      var $103=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($101, $102, $103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 27; break; }
    case 18: // $_noexc
      __label__ = 19; break;
    case 19: // $_ZdlPvPKciRK9zeromem_t_exit
      var $104=$1;
      var $105=$2;
      var $106=$3;
      var $107=$4;
      __label__ = 20; break;
    case 20: // $108
      __label__ = 26; break;
    case 21: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $12=$111;
      var $112=$110.f1;
      $13=$112;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 22: // $113
      FUNCTION_TABLE[__ZN7astringD1Ev]($errors);
      __label__ = 23; break;
    case 23: // $114
      var $115=$device;
      var $116=__ZNK8device_t4nextEv($115);
      $device=$116;
      __label__ = 9; break;
    case 24: // $117
      __label__ = 26; break;
    case 25: // $118
      var $119=$11;
      __ZL15init_port_stateR15running_machine($119);
      var $120=$11;
      var $121=$11;
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($16, 116, ((STRING_TABLE.__str1342)|0), $121);
      var $122=$11;
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($17, 118, ((STRING_TABLE.__str1343)|0), $122);
      __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($120, ((STRING_TABLE.__str1341)|0), $16, $17);
      var $123=$11;
      var $124=__ZL13playback_initR15running_machine($123);
      $basetime=$124;
      var $125=$11;
      __ZL11record_initR15running_machine($125);
      var $126=$basetime;
      STACKTOP = __stackBase__;
      return $126;
    case 26: // $127
      var $128=$12;
      var $129=$12;
      var $130=$13;
      var $131=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $129, tempValue);
      var $132=($131.f1 = $130, $131);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 27: // $133
      var $134=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15input_port_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI19_input_port_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19_input_port_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI19_input_port_privateEEPT_S3_["X"]=1;

function __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFviP14_xml_data_nodeEEC2I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($5, $6, $7, $8);
  ;
  return;
}


function __ZL15init_port_stateR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 160; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i3=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $result_i1=__stackBase__+56;
      var $14=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $result_i=__stackBase__+84;
      var $20=__stackBase__+88;
      var $21=__stackBase__+92;
      var $22;
      var $joystick_map_default;
      var $portdata;
      var $field;
      var $port;
      var $analogstatetail;
      var $readdevicetail;
      var $writedevicetail;
      var $portstate;
      var $fieldstate;
      var $seqtype;
      var $23;
      var $24;
      var $devicetag=__stackBase__+96;
      var $device;
      var $name;
      $22=$machine;
      var $25=$22;
      var $26=__ZNK15running_machine7optionsEv($25);
      var $27=__ZNK11emu_options12joystick_mapEv($26);
      $joystick_map_default=$27;
      var $28=$22;
      var $29=(($28+644)|0);
      var $30=HEAP32[(($29)>>2)];
      $portdata=$30;
      var $31=$22;
      var $32=(($31+20)|0);
      var $33=__ZNK11tagged_listI17input_port_configE5firstEv($32);
      $port=$33;
      __label__ = 1; break;
    case 1: // $34
      var $35=$port;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 2; break; } else { __label__ = 87; break; }
    case 2: // $37
      var $38=$22;
      var $39=__ZN15running_machine7respoolEv($38);
      var $40=$16;
      var $41=$17;
      var $42=$18;
      var $43=$19;
      var $44=$result_i;
      var $45=$20;
      var $46=$21;
      HEAP32[(($16)>>2)]=28;
      HEAP32[(($17)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($18)>>2)]=1967;
      HEAP32[(($19)>>2)]=_zeromem;
      var $47=HEAP32[(($16)>>2)];
      var $48=HEAP32[(($17)>>2)];
      var $49=HEAP32[(($18)>>2)];
      var $50=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($47, $48, $49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $51
      HEAP32[(($result_i)>>2)]=$50;
      var $52=HEAP32[(($result_i)>>2)];
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $54
      var $55=___cxa_allocate_exception(4);
      var $56=$55;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($56);
      (function() { try { __THREW__ = false; return ___cxa_throw($55, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      HEAP32[(($20)>>2)]=$59;
      var $60=$58.f1;
      HEAP32[(($21)>>2)]=$60;
      var $61=HEAP32[(($21)>>2)];
      var $62=(($61)|0) < 0;
      if ($62) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $63
      var $64=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($64);
      throw "Reached an unreachable!"
    case 7: // $65
      var $66=HEAP32[(($20)>>2)];
      var $67=HEAP32[(($20)>>2)];
      var $68=HEAP32[(($21)>>2)];
      var $69=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $67, tempValue);
      var $70=($69.f1 = $68, $69);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $71
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKciRK9zeromem_t_exit
      var $72=HEAP32[(($result_i)>>2)];
      var $73=HEAP32[(($16)>>2)];
      _memset($72, 0, $73, 1);
      var $74=HEAP32[(($result_i)>>2)];
      var $75=$16;
      var $76=$17;
      var $77=$18;
      var $78=$19;
      var $79=$result_i;
      var $80=$20;
      var $81=$21;
      var $82=$74;
      var $83=__ZN13resource_pool10add_objectI17_input_port_stateEEPT_S3_($39, $82);
      $portstate=$83;
      var $84=$portstate;
      var $85=$port;
      var $86=(($85)|0);
      HEAP32[(($86)>>2)]=$84;
      var $87=$portstate;
      var $88=(($87)|0);
      $analogstatetail=$88;
      var $89=$portstate;
      var $90=(($89+4)|0);
      $readdevicetail=$90;
      var $91=$portstate;
      var $92=(($91+8)|0);
      $writedevicetail=$92;
      var $93=$port;
      var $94=__ZNK17input_port_config11first_fieldEv($93);
      $field=$94;
      __label__ = 10; break;
    case 10: // $95
      var $96=$field;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 11; break; } else { __label__ = 85; break; }
    case 11: // $98
      var $99=$22;
      var $100=__ZN15running_machine7respoolEv($99);
      var $101=$10;
      var $102=$11;
      var $103=$12;
      var $104=$13;
      var $105=$result_i1;
      var $106=$14;
      var $107=$15;
      HEAP32[(($10)>>2)]=212;
      HEAP32[(($11)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($12)>>2)]=1982;
      HEAP32[(($13)>>2)]=_zeromem;
      var $108=HEAP32[(($10)>>2)];
      var $109=HEAP32[(($11)>>2)];
      var $110=HEAP32[(($12)>>2)];
      var $111=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($108, $109, $110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $112
      HEAP32[(($result_i1)>>2)]=$111;
      var $113=HEAP32[(($result_i1)>>2)];
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $115
      var $116=___cxa_allocate_exception(4);
      var $117=$116;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($117);
      (function() { try { __THREW__ = false; return ___cxa_throw($116, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $118
      var $119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $120=$119.f0;
      HEAP32[(($14)>>2)]=$120;
      var $121=$119.f1;
      HEAP32[(($15)>>2)]=$121;
      var $122=HEAP32[(($15)>>2)];
      var $123=(($122)|0) < 0;
      if ($123) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $124
      var $125=HEAP32[(($14)>>2)];
      ___cxa_call_unexpected($125);
      throw "Reached an unreachable!"
    case 16: // $126
      var $127=HEAP32[(($14)>>2)];
      var $128=HEAP32[(($14)>>2)];
      var $129=HEAP32[(($15)>>2)];
      var $130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $128, tempValue);
      var $131=($130.f1 = $129, $130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $132
      throw "Reached an unreachable!"
    case 18: // $_ZnwjPKciRK9zeromem_t_exit2
      var $133=HEAP32[(($result_i1)>>2)];
      var $134=HEAP32[(($10)>>2)];
      _memset($133, 0, $134, 1);
      var $135=HEAPU32[(($result_i1)>>2)];
      var $136=$10;
      var $137=$11;
      var $138=$12;
      var $139=$13;
      var $140=$result_i1;
      var $141=$14;
      var $142=$15;
      var $143=$135;
      (function() { try { __THREW__ = false; return __ZN18_input_field_stateC1Ev($143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $144
      var $145=__ZN13resource_pool10add_objectI18_input_field_stateEEPT_S3_($100, $143);
      $fieldstate=$145;
      var $146=$fieldstate;
      var $147=$field;
      var $148=(($147+400)|0);
      HEAP32[(($148)>>2)]=$146;
      $seqtype=0;
      __label__ = 20; break;
    case 20: // $149
      var $150=$seqtype;
      var $151=(($150)>>>0) < 3;
      if ($151) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $152
      var $153=$seqtype;
      var $154=$fieldstate;
      var $155=(($154+8)|0);
      var $156=(($155+($153<<6))|0);
      var $157=$seqtype;
      var $158=$field;
      var $159=(($158+44)|0);
      var $160=(($159+($157<<6))|0);
      var $161=$156;
      var $162=$160;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $162>>2, $$dest = $161>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 22; break;
    case 22: // $163
      var $164=$seqtype;
      var $165=(($164+1)|0);
      $seqtype=$165;
      __label__ = 20; break;
    case 23: // $166
      var $167=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $168=$167.f0;
      $23=$168;
      var $169=$167.f1;
      $24=$169;
      var $170=$6;
      var $171=$7;
      var $172=$8;
      var $173=$9;
      HEAP32[(($6)>>2)]=$135;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($8)>>2)]=1982;
      HEAP32[(($9)>>2)]=_zeromem;
      var $174=HEAP32[(($6)>>2)];
      var $175=(($174)|0)!=0;
      if ($175) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $176
      var $177=HEAP32[(($6)>>2)];
      var $178=HEAP32[(($7)>>2)];
      var $179=HEAP32[(($8)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($177, $178, $179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 106; break; }
    case 25: // $_noexc
      __label__ = 26; break;
    case 26: // $_ZdlPvPKciRK9zeromem_t_exit
      var $180=$6;
      var $181=$7;
      var $182=$8;
      var $183=$9;
      __label__ = 27; break;
    case 27: // $184
      __label__ = 105; break;
    case 28: // $185
      var $186=$field;
      var $187=(($186+4)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$fieldstate;
      var $190=(($189+200)|0);
      HEAP32[(($190)>>2)]=$188;
      var $191=$field;
      var $192=(($191+24)|0);
      var $193=HEAPU32[(($192)>>2)];
      var $194=(($193)>>>0) >= 140;
      if ($194) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $195
      var $196=$field;
      var $197=(($196+24)|0);
      var $198=HEAPU32[(($197)>>2)];
      var $199=(($198)>>>0) <= 157;
      if ($199) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $200
      var $201=$field;
      var $202=__ZL23init_field_analog_statePK18input_field_config($201);
      var $203=$fieldstate;
      var $204=(($203)|0);
      HEAP32[(($204)>>2)]=$202;
      var $205=$analogstatetail;
      HEAP32[(($205)>>2)]=$202;
      var $206=$analogstatetail;
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207)|0);
      $analogstatetail=$208;
      __label__ = 31; break;
    case 31: // $209
      var $210=$field;
      var $211=(($210+24)|0);
      var $212=HEAPU32[(($211)>>2)];
      var $213=(($212)>>>0) >= 47;
      if ($213) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $214
      var $215=$field;
      var $216=(($215+24)|0);
      var $217=HEAPU32[(($216)>>2)];
      var $218=(($217)>>>0) <= 58;
      if ($218) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $219
      var $220=$field;
      var $221=(($220+24)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($222-47)|0);
      var $224=Math.floor((($223)>>>0)/4);
      var $225=$field;
      var $226=(($225+28)|0);
      var $227=HEAPU8[($226)];
      var $228=(($227)&255);
      var $229=$portdata;
      var $230=(($229+6936)|0);
      var $231=(($230+$228*60)|0);
      var $232=(($231+$224*20)|0);
      var $233=$fieldstate;
      var $234=(($233+4)|0);
      HEAP32[(($234)>>2)]=$232;
      var $235=$field;
      var $236=(($235+24)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=(($237-47)|0);
      var $239=(($238)>>>0)%4;
      var $240=(($239) & 255);
      var $241=$fieldstate;
      var $242=(($241+206)|0);
      HEAP8[($242)]=$240;
      var $243=$field;
      var $244=$fieldstate;
      var $245=(($244+206)|0);
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$fieldstate;
      var $249=(($248+4)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=(($250)|0);
      var $252=(($251+($247<<2))|0);
      HEAP32[(($252)>>2)]=$243;
      var $253=$fieldstate;
      var $254=(($253+4)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($255+16)|0);
      HEAP8[($256)]=1;
      __label__ = 34; break;
    case 34: // $257
      __ZN7astringC1Ev($devicetag);
      var $258=$field;
      var $259=(($258+236)|0);
      var $260=$259;
      var $261=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIjRK18input_field_configPv8_noparamS4_E6isnullEv($260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 41; break; };
    case 35: // $262
      if ($261) { __label__ = 43; break; } else { __label__ = 36; break; }
    case 36: // $263
      var $264=$field;
      var $265=$port;
      var $266=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($265) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 41; break; };
    case 37: // $267
      var $268=$field;
      var $269=(($268+264)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(function() { try { __THREW__ = false; return __Z14get_device_tagRK8device_tPKcR7astring($266, $270, $devicetag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 41; break; };
    case 38: // $272
      var $273=(function() { try { __THREW__ = false; return __ZL22init_field_device_infoPK18input_field_configPKc($264, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 41; break; };
    case 39: // $274
      var $275=$readdevicetail;
      HEAP32[(($275)>>2)]=$273;
      var $276=$field;
      var $277=(($276+236)|0);
      var $278=$277;
      var $279=$readdevicetail;
      var $280=HEAP32[(($279)>>2)];
      var $281=(($280+8)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=$282;
      (function() { try { __THREW__ = false; return __ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_E9late_bindER18delegate_late_bind($278, $283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $284
      var $285=$readdevicetail;
      var $286=HEAP32[(($285)>>2)];
      var $287=(($286)|0);
      $readdevicetail=$287;
      __label__ = 43; break;
    case 41: // $288
      var $289=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $289;__label__ = 42; break;
    case 42: // $_body
      var $eh_lpad_body;
      var $290=$eh_lpad_body.f0;
      $23=$290;
      var $291=$eh_lpad_body.f1;
      $24=$291;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($devicetag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 106; break; }
    case 43: // $292
      var $293=$field;
      var $294=(($293+268)|0);
      var $295=$294;
      var $296=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIvRK18input_field_configPvjjE6isnullEv($295) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 41; break; };
    case 44: // $297
      if ($296) { __label__ = 50; break; } else { __label__ = 45; break; }
    case 45: // $298
      var $299=$field;
      var $300=$port;
      var $301=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 41; break; };
    case 46: // $302
      var $303=$field;
      var $304=(($303+296)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=(function() { try { __THREW__ = false; return __Z14get_device_tagRK8device_tPKcR7astring($301, $305, $devicetag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 41; break; };
    case 47: // $307
      var $308=(function() { try { __THREW__ = false; return __ZL22init_field_device_infoPK18input_field_configPKc($299, $306) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 41; break; };
    case 48: // $309
      var $310=$writedevicetail;
      HEAP32[(($310)>>2)]=$308;
      var $311=$field;
      var $312=(($311+268)|0);
      var $313=$312;
      var $314=$writedevicetail;
      var $315=HEAP32[(($314)>>2)];
      var $316=(($315+8)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=$317;
      (function() { try { __THREW__ = false; return __ZN13delegate_baseIvRK18input_field_configPvjjE9late_bindER18delegate_late_bind($313, $318) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 41; break; }
    case 49: // $319
      var $320=$writedevicetail;
      var $321=HEAP32[(($320)>>2)];
      var $322=(($321)|0);
      $writedevicetail=$322;
      __label__ = 50; break;
    case 50: // $323
      var $324=$field;
      var $325=(($324+348)|0);
      var $326=$325;
      var $327=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_E6isnullEv($326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 41; break; };
    case 51: // $328
      if ($327) { __label__ = 57; break; } else { __label__ = 52; break; }
    case 52: // $329
      var $330=$22;
      var $331=$port;
      var $332=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 41; break; };
    case 53: // $333
      var $334=$field;
      var $335=(($334+372)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=(function() { try { __THREW__ = false; return __Z14get_device_tagRK8device_tPKcR7astring($332, $336, $devicetag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 41; break; };
    case 54: // $338
      var $339=(function() { try { __THREW__ = false; return __ZN15running_machine6deviceEPKc($330, $337) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 41; break; };
    case 55: // $340
      $device=$339;
      var $341=$field;
      var $342=(($341+348)|0);
      var $343=$342;
      var $344=$device;
      var $345=$344;
      (function() { try { __THREW__ = false; return __ZN13delegate_baseIfRK18input_field_configf8_noparamS3_E9late_bindER18delegate_late_bind($343, $345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 41; break; }
    case 56: // $346
      __label__ = 57; break;
    case 57: // $347
      var $348=$field;
      var $349=(($348+24)|0);
      var $350=HEAP32[(($349)>>2)];
      var $351=(($350)|0)==46;
      if ($351) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $352
      var $353=$field;
      var $354=(($353+24)|0);
      var $355=HEAP32[(($354)>>2)];
      var $356=(($355)|0)==45;
      if ($356) { __label__ = 59; break; } else { __label__ = 82; break; }
    case 59: // $357
      var $358=$field;
      var $359=(($358+40)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=(($360)|0)==0;
      if ($361) { __label__ = 60; break; } else { __label__ = 82; break; }
    case 60: // $362
      var $363=$field;
      var $364=(function() { try { __THREW__ = false; return __ZL21get_keyboard_key_namePK18input_field_config($363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 41; break; };
    case 61: // $365
      $name=$364;
      var $366=$name;
      var $367=(($366)|0)!=0;
      if ($367) { __label__ = 62; break; } else { __label__ = 81; break; }
    case 62: // $368
      var $369=$22;
      var $370=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($369) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 41; break; };
    case 63: // $371
      var $372=$name;
      var $373=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($372) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 41; break; };
    case 64: // $374
      var $375=(function() { try { __THREW__ = false; return _strlen($373) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 41; break; };
    case 65: // $376
      var $377=(($375+1)|0);
      var $378=$1;
      var $379=$2;
      var $380=$3;
      var $381=$result_i3;
      var $382=$4;
      var $383=$5;
      HEAP32[(($1)>>2)]=$377;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=2036;
      var $384=HEAP32[(($1)>>2)];
      var $385=HEAP32[(($2)>>2)];
      var $386=HEAP32[(($3)>>2)];
      var $387=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($384, $385, $386) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 68; break; };
    case 66: // $388
      HEAP32[(($result_i3)>>2)]=$387;
      var $389=HEAP32[(($result_i3)>>2)];
      var $390=(($389)|0)==0;
      if ($390) { __label__ = 67; break; } else { __label__ = 73; break; }
    case 67: // $391
      var $392=___cxa_allocate_exception(4);
      var $393=$392;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($393);
      (function() { try { __THREW__ = false; return ___cxa_throw($392, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 68; break; }
    case 68: // $394
      var $395=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $396=$395.f0;
      HEAP32[(($4)>>2)]=$396;
      var $397=$395.f1;
      HEAP32[(($5)>>2)]=$397;
      var $398=HEAP32[(($5)>>2)];
      var $399=(($398)|0) < 0;
      if ($399) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $400
      var $401=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($401) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 41; break; }
    case 70: // $_noexc4
      throw "Reached an unreachable!"
    case 71: // $402
      var $403=HEAP32[(($4)>>2)];
      var $404=HEAP32[(($4)>>2)];
      var $405=HEAP32[(($5)>>2)];
      var $406=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $404, tempValue);
      var $407=($406.f1 = $405, $406);
      var $eh_lpad_body = $407;__label__ = 42; break;
    case 72: // $408
      throw "Reached an unreachable!"
    case 73: // $_ZnajPKci_exit
      var $409=HEAP32[(($result_i3)>>2)];
      var $410=$1;
      var $411=$2;
      var $412=$3;
      var $413=$result_i3;
      var $414=$4;
      var $415=$5;
      __label__ = 74; break;
    case 74: // $416
      var $417=$name;
      var $418=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($417) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 41; break; };
    case 75: // $419
      var $420=(function() { try { __THREW__ = false; return _strlen($418) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 41; break; };
    case 76: // $421
      var $422=(($420+1)|0);
      var $423=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIcEEPT_S2_i($370, $409, $422) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 41; break; };
    case 77: // $424
      var $425=$name;
      var $426=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($425) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 41; break; };
    case 78: // $427
      var $428=(function() { try { __THREW__ = false; return _strcpy($423, $426) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 41; break; };
    case 79: // $429
      var $430=$field;
      var $431=(($430+400)|0);
      var $432=HEAP32[(($431)>>2)];
      var $433=(($432+208)|0);
      HEAP32[(($433)>>2)]=$428;
      var $434=$name;
      (function() { try { __THREW__ = false; return __Z12astring_freeP7astring($434) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 41; break; }
    case 80: // $435
      __label__ = 81; break;
    case 81: // $436
      __label__ = 82; break;
    case 82: // $437
      FUNCTION_TABLE[__ZN7astringD1Ev]($devicetag);
      __label__ = 83; break;
    case 83: // $438
      var $439=$field;
      var $440=__ZNK18input_field_config4nextEv($439);
      $field=$440;
      __label__ = 10; break;
    case 84: // $441
      __label__ = 105; break;
    case 85: // $442
      __label__ = 86; break;
    case 86: // $443
      var $444=$port;
      var $445=__ZNK17input_port_config4nextEv($444);
      $port=$445;
      __label__ = 1; break;
    case 87: // $446
      var $447=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($447, 140, 141, 0, ((STRING_TABLE.__str1438)|0), ((STRING_TABLE.__str1439)|0));
      var $448=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($448, 142, 143, 144, ((STRING_TABLE.__str1440)|0), ((STRING_TABLE.__str1441)|0));
      var $449=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($449, 145, 146, 0, ((STRING_TABLE.__str1442)|0), ((STRING_TABLE.__str1443)|0));
      var $450=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($450, 147, 148, 149, ((STRING_TABLE.__str1444)|0), ((STRING_TABLE.__str1445)|0));
      var $451=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($451, 152, 153, 0, ((STRING_TABLE.__str1446)|0), ((STRING_TABLE.__str1447)|0));
      var $452=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($452, 154, 155, 0, ((STRING_TABLE.__str1448)|0), ((STRING_TABLE.__str1449)|0));
      var $453=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($453, 150, 151, 0, ((STRING_TABLE.__str1450)|0), ((STRING_TABLE.__str1451)|0));
      var $454=$22;
      __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($454, 156, 157, 0, ((STRING_TABLE.__str1452)|0), ((STRING_TABLE.__str1453)|0));
      var $455=$joystick_map_default;
      var $456=(($455)|0);
      var $457=HEAP8[($456)];
      var $458=(($457 << 24) >> 24);
      var $459=(($458)|0)==0;
      if ($459) { __label__ = 89; break; } else { __label__ = 88; break; }
    case 88: // $460
      var $461=$joystick_map_default;
      var $462=_strcmp($461, ((STRING_TABLE.__str1454)|0));
      var $463=(($462)|0)==0;
      if ($463) { __label__ = 89; break; } else { __label__ = 104; break; }
    case 89: // $464
      var $465=$22;
      var $466=(($465+20)|0);
      var $467=__ZNK11tagged_listI17input_port_configE5firstEv($466);
      $port=$467;
      __label__ = 90; break;
    case 90: // $468
      var $469=$port;
      var $470=(($469)|0)!=0;
      if ($470) { __label__ = 91; break; } else { __label__ = 103; break; }
    case 91: // $471
      var $472=$port;
      var $473=__ZNK17input_port_config11first_fieldEv($472);
      $field=$473;
      __label__ = 92; break;
    case 92: // $474
      var $475=$field;
      var $476=(($475)|0)!=0;
      if ($476) { __label__ = 93; break; } else { __label__ = 101; break; }
    case 93: // $477
      var $478=$field;
      var $479=(($478+400)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=(($480+4)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=(($482)|0)!=0;
      if ($483) { __label__ = 94; break; } else { __label__ = 99; break; }
    case 94: // $484
      var $485=$field;
      var $486=(($485+384)|0);
      var $487=HEAPU8[($486)];
      var $488=(($487)&255);
      var $489=(($488)|0)==4;
      if ($489) { __label__ = 95; break; } else { __label__ = 99; break; }
    case 95: // $490
      var $491=$22;
      var $492=__ZNK15running_machine5inputEv($491);
      var $493=$field;
      var $494=(($493+32)|0);
      var $495=HEAP32[(($494)>>2)];
      var $496=$495 & 8;
      var $497=(($496)|0)!=0;
      if ($497) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $498
      var $501 = (STRING_TABLE._joystick_map_4way_diagonal);__label__ = 98; break;
    case 97: // $499
      var $501 = (STRING_TABLE._joystick_map_4way_sticky);__label__ = 98; break;
    case 98: // $500
      var $501;
      var $502=(($501)|0);
      var $503=__ZN13input_manager23set_global_joystick_mapEPKc($492, $502);
      __label__ = 101; break;
    case 99: // $504
      __label__ = 100; break;
    case 100: // $505
      var $506=$field;
      var $507=__ZNK18input_field_config4nextEv($506);
      $field=$507;
      __label__ = 92; break;
    case 101: // $508
      __label__ = 102; break;
    case 102: // $509
      var $510=$port;
      var $511=__ZNK17input_port_config4nextEv($510);
      $port=$511;
      __label__ = 90; break;
    case 103: // $512
      __label__ = 104; break;
    case 104: // $513
      STACKTOP = __stackBase__;
      return;
    case 105: // $514
      var $515=$23;
      var $516=$23;
      var $517=$24;
      var $518=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $516, tempValue);
      var $519=($518.f1 = $517, $518);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 106: // $520
      var $521=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15init_port_stateR15running_machine["X"]=1;

function __ZL20load_config_callbackR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 372; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $portdata;
      var $portnode;
      var $seqtype;
      var $newseq=__stackBase__;
      var $4=__stackBase__+192;
      var $5=__stackBase__+196;
      var $6=__stackBase__+200;
      var $7=__stackBase__+204;
      var $8=__stackBase__+208;
      var $9=__stackBase__+212;
      var $10=__stackBase__+216;
      var $tempseq=__stackBase__+220;
      var $11=__stackBase__+284;
      var $12=__stackBase__+288;
      var $13=__stackBase__+292;
      var $14=__stackBase__+296;
      var $15=__stackBase__+300;
      var $16=__stackBase__+304;
      var $17=__stackBase__+308;
      var $seqnode;
      var $type;
      var $player=__stackBase__+312;
      var $18=__stackBase__+316;
      var $19=__stackBase__+320;
      var $20=__stackBase__+324;
      var $21=__stackBase__+328;
      var $22=__stackBase__+332;
      var $23=__stackBase__+336;
      var $24=__stackBase__+340;
      var $25=__stackBase__+344;
      var $26=__stackBase__+348;
      var $27=__stackBase__+352;
      var $28=__stackBase__+356;
      var $29=__stackBase__+360;
      var $30=__stackBase__+364;
      var $31=__stackBase__+368;
      var $entry;
      var $seqtype1;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $32=$1;
      var $33=(($32+644)|0);
      var $34=HEAP32[(($33)>>2)];
      $portdata=$34;
      var $35=$2;
      var $36=(($35)|0)==4;
      if ($36) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $37
      var $38=$portdata;
      var $39=(($38)|0);
      HEAP8[($39)]=1;
      var $40=$1;
      __ZL12frame_updateR15running_machine($40);
      __label__ = 2; break;
    case 2: // $41
      var $42=$3;
      var $43=(($42)|0)==0;
      if ($43) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $44
      __label__ = 39; break;
    case 4: // $45
      var $46=$2;
      var $47=(($46)|0)==1;
      if ($47) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $48
      var $49=$1;
      var $50=$3;
      __ZL16load_remap_tableR15running_machineP14_xml_data_node($49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$3;
      var $53=(($52+8)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=__Z15xml_get_siblingP14_xml_data_nodePKc($54, ((STRING_TABLE.__str1408)|0));
      $portnode=$55;
      __label__ = 7; break;
    case 7: // $56
      var $57=$portnode;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 8; break; } else { __label__ = 29; break; }
    case 8: // $59
      var $60=(($newseq)|0);
      var $61=(($60+192)|0);
      var $63 = $60;__label__ = 9; break;
    case 9: // $62
      var $63;
      __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($9, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($10, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($63, $4, $5, $6, $7, $8, $9, $10);
      var $64=(($63+64)|0);
      var $65=(($64)|0)==(($61)|0);
      if ($65) { __label__ = 10; break; } else { var $63 = $64;__label__ = 9; break; }
    case 10: // $66
      __ZN10input_codeC1ERKS_($11, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($12, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($13, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($14, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($15, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($16, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($17, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($tempseq, $11, $12, $13, $14, $15, $16, $17);
      var $67=$1;
      var $68=$portnode;
      var $69=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($68, ((STRING_TABLE.__str1410)|0), ((__str1366)|0));
      var $70=__ZL25token_to_input_field_typeR15running_machinePKcPi($67, $69, $player);
      $type=$70;
      $seqtype=0;
      __label__ = 11; break;
    case 11: // $71
      var $72=$seqtype;
      var $73=(($72)>>>0) < 3;
      if ($73) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $74
      var $75=$seqtype;
      var $76=(($newseq+($75<<6))|0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($18, 0, 0, 0, 0, 0);
      __ZN10input_codeC1ERKS_($19, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($20, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($21, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($22, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($23, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($24, __ZN9input_seq8end_codeE);
      __ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_($76, $18, $19, $20, $21, $22, $23, $24);
      __label__ = 13; break;
    case 13: // $77
      var $78=$seqtype;
      var $79=(($78+1)|0);
      $seqtype=$79;
      __label__ = 11; break;
    case 14: // $80
      var $81=$portnode;
      var $82=(($81+8)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=__Z15xml_get_siblingP14_xml_data_nodePKc($83, ((STRING_TABLE.__str1421)|0));
      $seqnode=$84;
      __label__ = 15; break;
    case 15: // $85
      var $86=$seqnode;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $88
      var $89=$seqnode;
      var $90=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($89, ((STRING_TABLE.__str1410)|0), ((__str1366)|0));
      var $91=__ZL17token_to_seq_typePKc($90);
      $seqtype=$91;
      var $92=$seqtype;
      var $93=(($92)|0)!=-1;
      if ($93) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $94
      var $95=$seqnode;
      var $96=(($95+16)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $99
      var $100=$seqnode;
      var $101=(($100+16)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=_strcmp($102, ((STRING_TABLE.__str1420)|0));
      var $104=(($103)|0)==0;
      if ($104) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $105
      var $106=$seqtype;
      var $107=(($newseq+($106<<6))|0);
      __ZN10input_codeC1ERKS_($25, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($26, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($27, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($28, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($29, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($30, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($31, __ZN9input_seq8end_codeE);
      __ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_($107, $25, $26, $27, $28, $29, $30, $31);
      __label__ = 21; break;
    case 20: // $108
      var $109=$1;
      var $110=__ZNK15running_machine5inputEv($109);
      var $111=$seqtype;
      var $112=(($newseq+($111<<6))|0);
      var $113=$seqnode;
      var $114=(($113+16)|0);
      var $115=HEAP32[(($114)>>2)];
      __ZN13input_manager15seq_from_tokensER9input_seqPKc($110, $112, $115);
      __label__ = 21; break;
    case 21: // $116
      __label__ = 22; break;
    case 22: // $117
      __label__ = 23; break;
    case 23: // $118
      var $119=$seqnode;
      var $120=(($119)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=__Z15xml_get_siblingP14_xml_data_nodePKc($121, ((STRING_TABLE.__str1421)|0));
      $seqnode=$122;
      __label__ = 15; break;
    case 24: // $123
      var $124=$2;
      var $125=(($124)|0)!=3;
      if ($125) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $126
      var $127=$1;
      var $128=$portnode;
      var $129=$type;
      var $130=HEAP32[(($player)>>2)];
      var $131=(($newseq)|0);
      var $132=__ZL19load_default_configR15running_machineP14_xml_data_nodeiiPK9input_seq($127, $128, $129, $130, $131);
      __label__ = 27; break;
    case 26: // $133
      var $134=$1;
      var $135=$portnode;
      var $136=$type;
      var $137=HEAP32[(($player)>>2)];
      var $138=(($newseq)|0);
      var $139=__ZL16load_game_configR15running_machineP14_xml_data_nodeiiPK9input_seq($134, $135, $136, $137, $138);
      __label__ = 27; break;
    case 27: // $140
      __label__ = 28; break;
    case 28: // $141
      var $142=$portnode;
      var $143=(($142)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=__Z15xml_get_siblingP14_xml_data_nodePKc($144, ((STRING_TABLE.__str1408)|0));
      $portnode=$145;
      __label__ = 7; break;
    case 29: // $146
      var $147=$2;
      var $148=(($147)|0)==1;
      if ($148) { __label__ = 30; break; } else { __label__ = 39; break; }
    case 30: // $149
      var $150=$portdata;
      var $151=(($150+4)|0);
      var $152=__ZNK11simple_listI16input_type_entryE5firstEv($151);
      $entry=$152;
      __label__ = 31; break;
    case 31: // $153
      var $154=$entry;
      var $155=(($154)|0)!=0;
      if ($155) { __label__ = 32; break; } else { __label__ = 38; break; }
    case 32: // $156
      $seqtype1=0;
      __label__ = 33; break;
    case 33: // $157
      var $158=$seqtype1;
      var $159=(($158)>>>0) < 3;
      if ($159) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $160
      var $161=$seqtype1;
      var $162=$entry;
      var $163=(($162+20)|0);
      var $164=(($163+($161<<6))|0);
      var $165=$seqtype1;
      var $166=$entry;
      var $167=(($166+212)|0);
      var $168=(($167+($165<<6))|0);
      var $169=$164;
      var $170=$168;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $170>>2, $$dest = $169>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 35; break;
    case 35: // $171
      var $172=$seqtype1;
      var $173=(($172+1)|0);
      $seqtype1=$173;
      __label__ = 33; break;
    case 36: // $174
      __label__ = 37; break;
    case 37: // $175
      var $176=$entry;
      var $177=__ZNK16input_type_entry4nextEv($176);
      $entry=$177;
      __label__ = 31; break;
    case 38: // $178
      __label__ = 39; break;
    case 39: // $179
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20load_config_callbackR15running_machineiP14_xml_data_node["X"]=1;

function __ZL20save_config_callbackR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$3;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 5; break;
    case 2: // $7
      var $8=$2;
      var $9=(($8)|0)==2;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      var $11=$1;
      var $12=$3;
      __ZL19save_default_inputsR15running_machineP14_xml_data_node($11, $12);
      __label__ = 5; break;
    case 4: // $13
      var $14=$1;
      var $15=$3;
      __ZL16save_game_inputsR15running_machineP14_xml_data_node($14, $15);
      __label__ = 5; break;
    case 5: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13playback_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $filename;
      var $portdata;
      var $header=__stackBase__+36;
      var $basetime=__stackBase__+100;
      var $11;
      var $12;
      var $filerr;
      $10=$machine;
      var $13=$10;
      var $14=__ZNK15running_machine7optionsEv($13);
      var $15=__ZNK11emu_options8playbackEv($14);
      $filename=$15;
      var $16=$10;
      var $17=(($16+644)|0);
      var $18=HEAP32[(($17)>>2)];
      $portdata=$18;
      var $19=$filename;
      var $20=(($19)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      $9=0;
      __label__ = 32; break;
    case 2: // $25
      var $26=$10;
      var $27=__ZN15running_machine7respoolEv($26);
      var $28=$4;
      var $29=$5;
      var $30=$6;
      var $31=$result_i;
      var $32=$7;
      var $33=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($6)>>2)]=3647;
      var $34=HEAP32[(($4)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34, $35, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $38
      HEAP32[(($result_i)>>2)]=$37;
      var $39=HEAP32[(($result_i)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $41
      var $42=___cxa_allocate_exception(4);
      var $43=$42;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43);
      (function() { try { __THREW__ = false; return ___cxa_throw($42, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      HEAP32[(($7)>>2)]=$46;
      var $47=$45.f1;
      HEAP32[(($8)>>2)]=$47;
      var $48=HEAP32[(($8)>>2)];
      var $49=(($48)|0) < 0;
      if ($49) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $50
      var $51=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($51);
      throw "Reached an unreachable!"
    case 7: // $52
      var $53=HEAP32[(($7)>>2)];
      var $54=HEAP32[(($7)>>2)];
      var $55=HEAP32[(($8)>>2)];
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $58
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $59=HEAP32[(($result_i)>>2)];
      var $60=$4;
      var $61=$5;
      var $62=$6;
      var $63=$result_i;
      var $64=$7;
      var $65=$8;
      var $66=$59;
      var $67=$10;
      var $68=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 16; break; };
    case 10: // $69
      var $70=(function() { try { __THREW__ = false; return __ZNK11emu_options15input_directoryEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $71
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($66, $70, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $72
      var $73=__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_($27, $66);
      var $74=$portdata;
      var $75=(($74+7440)|0);
      HEAP32[(($75)>>2)]=$73;
      var $76=$portdata;
      var $77=(($76+7440)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$filename;
      var $80=__ZN8emu_file4openEPKc($78, $79);
      $filerr=$80;
      __label__ = 13; break;
    case 13: // $81
      var $82=$filerr;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 22; break; } else { __label__ = 14; break; }
    case 14: // $84
      var $85=___cxa_allocate_exception(1032);
      var $86=$85;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($86, ((STRING_TABLE.__str1347)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str1398)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str1337)|0),HEAP32[((tempInt+8)>>2)]=3649,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $87
      ___cxa_throw($85, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 16: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $90=$89.f0;
      $11=$90;
      var $91=$89.f1;
      $12=$91;
      var $92=$1;
      var $93=$2;
      var $94=$3;
      HEAP32[(($1)>>2)]=$59;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=3647;
      var $95=HEAP32[(($1)>>2)];
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $97
      var $98=HEAP32[(($1)>>2)];
      var $99=HEAP32[(($2)>>2)];
      var $100=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($98, $99, $100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 34; break; }
    case 18: // $_noexc
      __label__ = 19; break;
    case 19: // $_ZdlPvPKci_exit
      var $101=$1;
      var $102=$2;
      var $103=$3;
      __label__ = 20; break;
    case 20: // $104
      __label__ = 33; break;
    case 21: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $107=$106.f0;
      $11=$107;
      var $108=$106.f1;
      $12=$108;
      ___cxa_free_exception($85);
      __label__ = 33; break;
    case 22: // $109
      __label__ = 23; break;
    case 23: // $110
      var $111=$portdata;
      var $112=(($111+7440)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($header)|0);
      var $115=__ZN8emu_file4readEPvj($113, $114, 64);
      var $116=(($115)|0)!=64;
      if ($116) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $117
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1399)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 25: // $118
      var $119=(($header)|0);
      var $120=_memcmp($119, ((STRING_TABLE.__str1394)|0), 8);
      var $121=(($120)|0)!=0;
      if ($121) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $122
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1400)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 27: // $123
      var $124=(($header+16)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=(($126)|0)!=3;
      if ($127) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $128
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1401)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 29: // $129
      var $130=$filename;
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1402)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$130,tempInt));
      var $131=(($header+16)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=(($header+17)|0);
      var $135=HEAPU8[($134)];
      var $136=(($135)&255);
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1403)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$133,HEAP32[((tempInt+4)>>2)]=$136,tempInt));
      var $137=(($header+8)|0);
      var $138=HEAPU8[($137)];
      var $139=(($138)&255);
      var $140=(($header+9)|0);
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=$142 << 8;
      var $144=$139 | $143;
      var $145=(($header+10)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$147 << 16;
      var $149=$144 | $148;
      var $150=(($header+11)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$152 << 24;
      var $154=$149 | $153;
      var $155$0=$154;
      var $155$1=(($154|0) < 0 ? -1 : 0);
      var $156=(($header+12)|0);
      var $157=HEAP8[($156)];
      var $158$0=$157;
      var $158$1=0;
      var $159$0=0;
      var $159$1=$158$0;
      var $160$0=$155$0 | $159$0;
      var $160$1=$155$1 | $159$1;
      var $161=(($header+13)|0);
      var $162=HEAP8[($161)];
      var $163$0=$162;
      var $163$1=0;
      var $164$0=(0 << 8) | (0 >>> 24);
      var $164$1=($163$0 << 8) | (0 >>> 24);
      var $165$0=$160$0 | $164$0;
      var $165$1=$160$1 | $164$1;
      var $166=(($header+14)|0);
      var $167=HEAP8[($166)];
      var $168$0=$167;
      var $168$1=0;
      var $169$0=(0 << 16) | (0 >>> 16);
      var $169$1=($168$0 << 16) | (0 >>> 16);
      var $170$0=$165$0 | $169$0;
      var $170$1=$165$1 | $169$1;
      var $171=(($header+15)|0);
      var $172=HEAP8[($171)];
      var $173$0=$172;
      var $173$1=0;
      var $174$0=(0 << 24) | (0 >>> 8);
      var $174$1=($173$0 << 24) | (0 >>> 8);
      var $175$0=$170$0 | $174$0;
      var $175$1=$170$1 | $174$1;
      var $176$0=$175$0;
      var $176=$176$0;
      HEAP32[(($basetime)>>2)]=$176;
      var $177=_ctime($basetime);
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1404)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$177,tempInt));
      var $178=(($header)|0);
      var $179=(($178+32)|0);
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1405)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$179,tempInt));
      var $180=$10;
      var $181=__ZNK15running_machine6systemEv($180);
      var $182=(($181+8)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=(($header)|0);
      var $185=(($184+20)|0);
      var $186=$10;
      var $187=__ZNK15running_machine6systemEv($186);
      var $188=(($187+8)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=_strlen($189);
      var $191=(($190+1)|0);
      var $192=_memcmp($183, $185, $191);
      var $193=(($192)|0)!=0;
      if ($193) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $194
      var $195=(($header)|0);
      var $196=(($195+20)|0);
      var $197=$10;
      var $198=__ZNK15running_machine6systemEv($197);
      var $199=(($198+8)|0);
      var $200=HEAP32[(($199)>>2)];
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1406)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$196,HEAP32[((tempInt+4)>>2)]=$200,tempInt));
      __label__ = 31; break;
    case 31: // $201
      var $202=$portdata;
      var $203=(($202+7440)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=__ZN8emu_file8compressEi($204, 6);
      var $206=HEAP32[(($basetime)>>2)];
      $9=$206;
      __label__ = 32; break;
    case 32: // $207
      var $208=$9;
      STACKTOP = __stackBase__;
      return $208;
    case 33: // $209
      var $210=$11;
      var $211=$11;
      var $212=$12;
      var $213=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $211, tempValue);
      var $214=($213.f1 = $212, $213);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 34: // $215
      var $216=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13playback_initR15running_machine["X"]=1;

function __ZNK17input_port_config4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK18input_field_config4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+404)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z15input_type_nameR15running_machineii($machine, $type, $player) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $portdata;
      var $entry;
      $2=$machine;
      $3=$type;
      $4=$player;
      var $5=$2;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      $portdata=$7;
      var $8=$4;
      var $9=$3;
      var $10=$portdata;
      var $11=(($10+24)|0);
      var $12=(($11+($9<<5))|0);
      var $13=(($12+($8<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      $entry=$14;
      var $15=$entry;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$entry;
      var $19=(($18+16)|0);
      var $20=HEAP32[(($19)>>2)];
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      $1=((STRING_TABLE.__str1345)|0);
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14input_type_seqR15running_machineii15_input_seq_type($machine, $type, $player, $seqtype) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $portdata;
      var $entry;
      $2=$machine;
      $3=$type;
      $4=$player;
      $5=$seqtype;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      var $10=$2;
      var $11=(($10+644)|0);
      var $12=HEAP32[(($11)>>2)];
      $portdata=$12;
      var $13=$4;
      var $14=$3;
      var $15=$portdata;
      var $16=(($15+24)|0);
      var $17=(($16+($14<<5))|0);
      var $18=(($17+($13<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      $entry=$19;
      var $20=$entry;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$5;
      var $24=$entry;
      var $25=(($24+212)|0);
      var $26=(($25+($23<<6))|0);
      $1=$26;
      __label__ = 7; break;
    case 6: // $27
      $1=__ZN9input_seq9empty_seqE;
      __label__ = 7; break;
    case 7: // $28
      var $29=$1;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18input_field_config11settinglistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+416)|0);
  ;
  return $3;
}


function __ZNK11simple_listI20input_setting_configE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK8device_t11input_portsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+16)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZN7astring5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZN7astring3cpyEPKc($2, ((__str1366)|0));
  ;
  return $3;
}


function __ZNK11tagged_listI17input_port_configE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listI17input_port_configE5firstEv($3);
  ;
  return $4;
}


function __ZN17input_port_config15collapse_fieldsER7astring($this, $errorbuf) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $list;
      var $maskbits=__stackBase__;
      var $lastmodcount;
      var $current;
      $1=$this;
      $2=$errorbuf;
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=__ZN11simple_listI18input_field_configE10detach_allEv($4);
      $list=$5;
      HEAP32[(($maskbits)>>2)]=0;
      $lastmodcount=-1;
      __label__ = 1; break;
    case 1: // $6
      var $7=$list;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $9
      var $10=$list;
      var $11=__ZNK18input_field_config8modcountEv($10);
      var $12=$lastmodcount;
      var $13=(($11)|0)!=(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$list;
      var $16=__ZNK18input_field_config8modcountEv($15);
      $lastmodcount=$16;
      HEAP32[(($maskbits)>>2)]=0;
      __label__ = 4; break;
    case 4: // $17
      var $18=$list;
      $current=$18;
      var $19=$list;
      var $20=__ZNK18input_field_config4nextEv($19);
      $list=$20;
      var $21=$current;
      var $22=$2;
      __Z19field_config_insertR18input_field_configRjR7astring($21, $maskbits, $22);
      __label__ = 1; break;
    case 5: // $23
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z27input_field_by_tag_and_maskRK11tagged_listI17input_port_configEPKcj($portlist, $tag, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $port;
      var $field;
      $2=$portlist;
      $3=$tag;
      $4=$mask;
      var $5=$2;
      var $6=$3;
      var $7=__ZNK11tagged_listI17input_port_configE4findEPKc($5, $6);
      $port=$7;
      var $8=$port;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $10
      var $11=$port;
      var $12=__ZNK17input_port_config11first_fieldEv($11);
      $field=$12;
      __label__ = 2; break;
    case 2: // $13
      var $14=$field;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $16
      var $17=$field;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$4;
      var $21=$19 & $20;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$field;
      $1=$24;
      __label__ = 9; break;
    case 5: // $25
      __label__ = 6; break;
    case 6: // $26
      var $27=$field;
      var $28=__ZNK18input_field_config4nextEv($27);
      $field=$28;
      __label__ = 2; break;
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      $1=0;
      __label__ = 9; break;
    case 9: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11tagged_listI17input_port_configE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  var $6=__ZNK8tagmap_tIP17input_port_configE14find_hash_onlyEPKc($4, $5);
  ;
  return $6;
}


function __ZNK17input_port_config11first_fieldEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=__ZNK11simple_listI18input_field_configE5firstEv($3);
  ;
  return $4;
}


function __Z16input_field_namePK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$field;
      var $3=$2;
      var $4=(($3+400)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+400)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+208)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$2;
      var $16=(($15+400)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+208)|0);
      var $19=HEAP32[(($18)>>2)];
      $1=$19;
      __label__ = 6; break;
    case 3: // $20
      var $21=$2;
      var $22=(($21+40)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      var $26=$2;
      var $27=(($26+40)|0);
      var $28=HEAP32[(($27)>>2)];
      $1=$28;
      __label__ = 6; break;
    case 5: // $29
      var $30=$2;
      var $31=__ZNK18input_field_config7machineEv($30);
      var $32=$2;
      var $33=(($32+24)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$2;
      var $36=(($35+28)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=__Z15input_type_nameR15running_machineii($31, $34, $38);
      $1=$39;
      __label__ = 6; break;
    case 6: // $40
      var $41=$1;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18input_field_config7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+408)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK17input_port_config7machineEv($4);
  ;
  return $5;
}


function __Z15input_field_seqPK18input_field_config15_input_seq_type($field, $seqtype) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $portseq;
      $2=$field;
      $3=$seqtype;
      var $4=$2;
      var $5=(($4+32)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 1;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=__ZN9input_seq9empty_seqE;
      __label__ = 8; break;
    case 2: // $10
      var $11=$2;
      var $12=(($11+400)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$3;
      var $17=$2;
      var $18=(($17+44)|0);
      var $19=(($18+($16<<6))|0);
      var $28 = $19;__label__ = 5; break;
    case 4: // $20
      var $21=$3;
      var $22=$2;
      var $23=(($22+400)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+8)|0);
      var $26=(($25+($21<<6))|0);
      var $28 = $26;__label__ = 5; break;
    case 5: // $27
      var $28;
      $portseq=$28;
      var $29=$portseq;
      var $30=__ZNK9input_seq10is_defaultEv($29);
      if ($30) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $31
      var $32=$2;
      var $33=__ZNK18input_field_config7machineEv($32);
      var $34=$2;
      var $35=(($34+24)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$2;
      var $38=(($37+28)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=$3;
      var $42=__Z14input_type_seqR15running_machineii15_input_seq_type($33, $36, $40, $41);
      $1=$42;
      __label__ = 8; break;
    case 7: // $43
      var $44=$portseq;
      $1=$44;
      __label__ = 8; break;
    case 8: // $45
      var $46=$1;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15input_field_seqPK18input_field_config15_input_seq_type["X"]=1;

function __ZNK9input_seq10is_defaultEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=(($3)|0);
  var $5=__ZNK10input_codeeqERKS_($4, __ZN9input_seq12default_codeE);
  ;
  return $5;
}


function __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($field, $settings) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $seqtype;
      $1=$field;
      $2=$settings;
      var $3=$2;
      var $4=$3;
      _memset($4, 0, 212, 1);
      $seqtype=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$seqtype;
      var $7=(($6)>>>0) < 3;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$seqtype;
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=(($11+($9<<6))|0);
      var $13=$seqtype;
      var $14=$1;
      var $15=(($14+400)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+8)|0);
      var $18=(($17+($13<<6))|0);
      var $19=$12;
      var $20=$18;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $20>>2, $$dest = $19>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 3; break;
    case 3: // $21
      var $22=$seqtype;
      var $23=(($22+1)|0);
      $seqtype=$23;
      __label__ = 1; break;
    case 4: // $24
      var $25=$1;
      var $26=__ZNK18input_field_config11settinglistEv($25);
      var $27=__ZNK11simple_listI20input_setting_configE5countEv($26);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $29
      var $30=$1;
      var $31=(($30+24)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==158;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=$1;
      var $36=(($35+400)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+200)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$2;
      var $41=(($40)|0);
      HEAP32[(($41)>>2)]=$39;
      __label__ = 7; break;
    case 7: // $42
      var $43=$1;
      var $44=(($43+400)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $49
      var $50=$1;
      var $51=(($50+400)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+24)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$2;
      var $58=(($57+196)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=$1;
      var $60=(($59+400)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+32)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$2;
      var $67=(($66+200)|0);
      HEAP32[(($67)>>2)]=$65;
      var $68=$1;
      var $69=(($68+400)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+36)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$2;
      var $76=(($75+204)|0);
      HEAP32[(($76)>>2)]=$74;
      var $77=$1;
      var $78=(($77+400)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+28)|0);
      var $83=HEAP8[($82)];
      var $84=$2;
      var $85=(($84+208)|0);
      HEAP8[($85)]=$83;
      __label__ = 9; break;
    case 9: // $86
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings["X"]=1;

function __ZL11record_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 148; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $filename;
      var $portdata;
      var $header=__stackBase__+36;
      var $systime=__stackBase__+100;
      var $10;
      var $11;
      var $filerr;
      $9=$machine;
      var $12=$9;
      var $13=__ZNK15running_machine7optionsEv($12);
      var $14=__ZNK11emu_options6recordEv($13);
      $filename=$14;
      var $15=$9;
      var $16=(($15+644)|0);
      var $17=HEAP32[(($16)>>2)];
      $portdata=$17;
      FUNCTION_TABLE[__ZN11system_timeC1Ev]($systime);
      var $18=$filename;
      var $19=(($18)|0);
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $23
      __label__ = 24; break;
    case 2: // $24
      var $25=$9;
      var $26=__ZN15running_machine7respoolEv($25);
      var $27=$4;
      var $28=$5;
      var $29=$6;
      var $30=$result_i;
      var $31=$7;
      var $32=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($6)>>2)]=3845;
      var $33=HEAP32[(($4)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($33, $34, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $37
      HEAP32[(($result_i)>>2)]=$36;
      var $38=HEAP32[(($result_i)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $40
      var $41=___cxa_allocate_exception(4);
      var $42=$41;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42);
      (function() { try { __THREW__ = false; return ___cxa_throw($41, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      HEAP32[(($7)>>2)]=$45;
      var $46=$44.f1;
      HEAP32[(($8)>>2)]=$46;
      var $47=HEAP32[(($8)>>2)];
      var $48=(($47)|0) < 0;
      if ($48) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $49
      var $50=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($50);
      throw "Reached an unreachable!"
    case 7: // $51
      var $52=HEAP32[(($7)>>2)];
      var $53=HEAP32[(($7)>>2)];
      var $54=HEAP32[(($8)>>2)];
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $57
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $58=HEAP32[(($result_i)>>2)];
      var $59=$4;
      var $60=$5;
      var $61=$6;
      var $62=$result_i;
      var $63=$7;
      var $64=$8;
      var $65=$58;
      var $66=$9;
      var $67=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 16; break; };
    case 10: // $68
      var $69=(function() { try { __THREW__ = false; return __ZNK11emu_options15input_directoryEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $70
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($65, $69, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $71
      var $72=__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_($26, $65);
      var $73=$portdata;
      var $74=(($73+7436)|0);
      HEAP32[(($74)>>2)]=$72;
      var $75=$portdata;
      var $76=(($75+7436)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$filename;
      var $79=__ZN8emu_file4openEPKc($77, $78);
      $filerr=$79;
      __label__ = 13; break;
    case 13: // $80
      var $81=$filerr;
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 22; break; } else { __label__ = 14; break; }
    case 14: // $83
      var $84=___cxa_allocate_exception(1032);
      var $85=$84;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($85, ((STRING_TABLE.__str1347)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str1393)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str1337)|0),HEAP32[((tempInt+8)>>2)]=3847,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $86
      ___cxa_throw($84, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 16: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      $10=$89;
      var $90=$88.f1;
      $11=$90;
      var $91=$1;
      var $92=$2;
      var $93=$3;
      HEAP32[(($1)>>2)]=$58;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=3845;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $96
      var $97=HEAP32[(($1)>>2)];
      var $98=HEAP32[(($2)>>2)];
      var $99=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($97, $98, $99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 26; break; }
    case 18: // $_noexc
      __label__ = 19; break;
    case 19: // $_ZdlPvPKci_exit
      var $100=$1;
      var $101=$2;
      var $102=$3;
      __label__ = 20; break;
    case 20: // $103
      __label__ = 25; break;
    case 21: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $106=$105.f0;
      $10=$106;
      var $107=$105.f1;
      $11=$107;
      ___cxa_free_exception($84);
      __label__ = 25; break;
    case 22: // $108
      __label__ = 23; break;
    case 23: // $109
      var $110=$9;
      __ZN15running_machine13base_datetimeER11system_time($110, $systime);
      var $111=(($header)|0);
      _memset($111, 0, 64, 1);
      var $112=(($header)|0);
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($112)]=HEAP8[(((STRING_TABLE.__str1394)|0))];HEAP8[($112+1)]=HEAP8[(((STRING_TABLE.__str1394)|0)+1)];HEAP8[($112+2)]=HEAP8[(((STRING_TABLE.__str1394)|0)+2)];HEAP8[($112+3)]=HEAP8[(((STRING_TABLE.__str1394)|0)+3)];HEAP8[($112+4)]=HEAP8[(((STRING_TABLE.__str1394)|0)+4)];HEAP8[($112+5)]=HEAP8[(((STRING_TABLE.__str1394)|0)+5)];HEAP8[($112+6)]=HEAP8[(((STRING_TABLE.__str1394)|0)+6)];HEAP8[($112+7)]=HEAP8[(((STRING_TABLE.__str1394)|0)+7)];
      var $113=(($systime)|0);
      var $st$7$0=(($113)|0);
      var $114$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($113+4)|0);
      var $114$1=HEAP32[(($st$7$1)>>2)];
      var $115$0=$114$0;
      var $115$1=$114$1;
      var $116$0=$115$0;
      var $116=$116$0&255;
      var $117=(($header+8)|0);
      HEAP8[($117)]=$116;
      var $118=(($systime)|0);
      var $st$18$0=(($118)|0);
      var $119$0=HEAPU32[(($st$18$0)>>2)];
      var $st$18$1=(($118+4)|0);
      var $119$1=HEAP32[(($st$18$1)>>2)];
      var $120$0=($119$0 >>> 8) | ($119$1 << 24);
      var $120$1=($119$1 >> 8) | (((($119$1|0) < 0 ? -1 : 0)) << 24);
      var $121$0=$120$0;
      var $121=$121$0&255;
      var $122=(($header+9)|0);
      HEAP8[($122)]=$121;
      var $123=(($systime)|0);
      var $st$29$0=(($123)|0);
      var $124$0=HEAPU32[(($st$29$0)>>2)];
      var $st$29$1=(($123+4)|0);
      var $124$1=HEAP32[(($st$29$1)>>2)];
      var $125$0=($124$0 >>> 16) | ($124$1 << 16);
      var $125$1=($124$1 >> 16) | (((($124$1|0) < 0 ? -1 : 0)) << 16);
      var $126$0=$125$0;
      var $126=$126$0&255;
      var $127=(($header+10)|0);
      HEAP8[($127)]=$126;
      var $128=(($systime)|0);
      var $st$40$0=(($128)|0);
      var $129$0=HEAPU32[(($st$40$0)>>2)];
      var $st$40$1=(($128+4)|0);
      var $129$1=HEAP32[(($st$40$1)>>2)];
      var $130$0=($129$0 >>> 24) | ($129$1 << 8);
      var $130$1=($129$1 >> 24) | (((($129$1|0) < 0 ? -1 : 0)) << 8);
      var $131$0=$130$0;
      var $131=$131$0&255;
      var $132=(($header+11)|0);
      HEAP8[($132)]=$131;
      var $133=(($systime)|0);
      var $st$51$0=(($133)|0);
      var $134$0=HEAP32[(($st$51$0)>>2)];
      var $st$51$1=(($133+4)|0);
      var $134$1=HEAP32[(($st$51$1)>>2)];
      var $135$0=$134$1;
      var $135$1=(($134$1|0) < 0 ? -1 : 0);
      var $136$0=$135$0;
      var $136=$136$0&255;
      var $137=(($header+12)|0);
      HEAP8[($137)]=$136;
      var $138=(($systime)|0);
      var $st$62$0=(($138)|0);
      var $139$0=HEAP32[(($st$62$0)>>2)];
      var $st$62$1=(($138+4)|0);
      var $139$1=HEAP32[(($st$62$1)>>2)];
      var $140$0=($139$1 >> 8) | (((($139$1|0) < 0 ? -1 : 0)) << 24);
      var $140$1=(((($139$1|0) < 0 ? -1 : 0)) >> 8) | (((($139$1|0) < 0 ? -1 : 0)) << 24);
      var $141$0=$140$0;
      var $141=$141$0&255;
      var $142=(($header+13)|0);
      HEAP8[($142)]=$141;
      var $143=(($systime)|0);
      var $st$73$0=(($143)|0);
      var $144$0=HEAP32[(($st$73$0)>>2)];
      var $st$73$1=(($143+4)|0);
      var $144$1=HEAP32[(($st$73$1)>>2)];
      var $145$0=($144$1 >> 16) | (((($144$1|0) < 0 ? -1 : 0)) << 16);
      var $145$1=(((($144$1|0) < 0 ? -1 : 0)) >> 16) | (((($144$1|0) < 0 ? -1 : 0)) << 16);
      var $146$0=$145$0;
      var $146=$146$0&255;
      var $147=(($header+14)|0);
      HEAP8[($147)]=$146;
      var $148=(($systime)|0);
      var $st$84$0=(($148)|0);
      var $149$0=HEAP32[(($st$84$0)>>2)];
      var $st$84$1=(($148+4)|0);
      var $149$1=HEAP32[(($st$84$1)>>2)];
      var $150$0=($149$1 >> 24) | (((($149$1|0) < 0 ? -1 : 0)) << 8);
      var $150$1=(((($149$1|0) < 0 ? -1 : 0)) >> 24) | (((($149$1|0) < 0 ? -1 : 0)) << 8);
      var $151$0=$150$0;
      var $151=$151$0&255;
      var $152=(($header+15)|0);
      HEAP8[($152)]=$151;
      var $153=(($header+16)|0);
      HEAP8[($153)]=3;
      var $154=(($header+17)|0);
      HEAP8[($154)]=0;
      var $155=(($header)|0);
      var $156=(($155+20)|0);
      var $157=$9;
      var $158=__ZNK15running_machine6systemEv($157);
      var $159=(($158+8)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=_strcpy($156, $160);
      var $162=(($header)|0);
      var $163=(($162+32)|0);
      var $164=_sprintf($163, ((STRING_TABLE.__str1395)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE._build_version)|0),tempInt));
      var $165=$portdata;
      var $166=(($165+7436)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($header)|0);
      var $169=__ZN8emu_file5writeEPKvj($167, $168, 64);
      var $170=$portdata;
      var $171=(($170+7436)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=__ZN8emu_file8compressEi($172, 6);
      __label__ = 24; break;
    case 24: // $174
      STACKTOP = __stackBase__;
      return;
    case 25: // $175
      var $176=$10;
      var $177=$10;
      var $178=$11;
      var $179=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $177, tempValue);
      var $180=($179.f1 = $178, $179);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $181
      var $182=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11record_initR15running_machine["X"]=1;

function __Z20input_type_is_analogi($type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$type;
      var $2=$1;
      var $3=(($2)|0) >= 140;
      if ($3) { __label__ = 1; break; } else { var $8 = 0;__label__ = 2; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5)|0) <= 157;
      var $8 = $6;__label__ = 2; break;
    case 2: // $7
      var $8;
      var $9=(($8)&1);
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI20input_setting_configE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK18input_field_config4portEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+408)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17input_port_config5ownerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK20input_setting_config4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z16input_type_groupR15running_machineii($machine, $type, $player) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $portdata;
      var $entry;
      $2=$machine;
      $3=$type;
      $4=$player;
      var $5=$2;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      $portdata=$7;
      var $8=$4;
      var $9=$3;
      var $10=$portdata;
      var $11=(($10+24)|0);
      var $12=(($11+($9<<5))|0);
      var $13=(($12+($8<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      $entry=$14;
      var $15=$entry;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$entry;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      $1=11;
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings($field, $settings) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $seqtype;
      var $defseq;
      $1=$field;
      $2=$settings;
      $seqtype=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$seqtype;
      var $5=(($4)>>>0) < 3;
      if ($5) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $6
      var $7=$1;
      var $8=__ZNK18input_field_config7machineEv($7);
      var $9=$1;
      var $10=(($9+24)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$1;
      var $13=(($12+28)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$seqtype;
      var $17=__Z14input_type_seqR15running_machineii15_input_seq_type($8, $11, $15, $16);
      $defseq=$17;
      var $18=$defseq;
      var $19=$seqtype;
      var $20=$2;
      var $21=(($20+4)|0);
      var $22=(($21+($19<<6))|0);
      var $23=__ZNK9input_seqeqERKS_($18, $22);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$seqtype;
      var $26=$1;
      var $27=(($26+400)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+8)|0);
      var $30=(($29+($25<<6))|0);
      __ZN9input_seq11set_defaultEv($30);
      __label__ = 5; break;
    case 4: // $31
      var $32=$seqtype;
      var $33=$1;
      var $34=(($33+400)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+8)|0);
      var $37=(($36+($32<<6))|0);
      var $38=$seqtype;
      var $39=$2;
      var $40=(($39+4)|0);
      var $41=(($40+($38<<6))|0);
      var $42=$37;
      var $43=$41;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $43>>2, $$dest = $42>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 5; break;
    case 5: // $44
      __label__ = 6; break;
    case 6: // $45
      var $46=$seqtype;
      var $47=(($46+1)|0);
      $seqtype=$47;
      __label__ = 1; break;
    case 7: // $48
      var $49=$1;
      var $50=__ZNK18input_field_config11settinglistEv($49);
      var $51=__ZNK11simple_listI20input_setting_configE5countEv($50);
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $53
      var $54=$1;
      var $55=(($54+24)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==158;
      if ($57) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $58
      var $59=$2;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$1;
      var $63=(($62+400)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+200)|0);
      HEAP32[(($65)>>2)]=$61;
      __label__ = 10; break;
    case 10: // $66
      var $67=$1;
      var $68=(($67+400)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $73
      var $74=$2;
      var $75=(($74+196)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$1;
      var $78=(($77+400)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+24)|0);
      HEAP32[(($82)>>2)]=$76;
      var $83=$2;
      var $84=(($83+200)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$1;
      var $87=(($86+400)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+32)|0);
      HEAP32[(($91)>>2)]=$85;
      var $92=$2;
      var $93=(($92+204)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$1;
      var $96=(($95+400)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99+36)|0);
      HEAP32[(($100)>>2)]=$94;
      var $101=$2;
      var $102=(($101+208)|0);
      var $103=HEAP8[($102)];
      var $104=$1;
      var $105=(($104+400)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+28)|0);
      HEAP8[($109)]=$103;
      __label__ = 12; break;
    case 12: // $110
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings["X"]=1;

function __ZNK9input_seqeqERKS_($this, $rhs) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rhs;
  var $3=$1;
  var $4=(($3)|0);
  var $5=(($4)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7)|0);
  var $9=(($8)|0);
  var $10=$9;
  var $11=_memcmp($6, $10, 64);
  var $12=(($11)|0)==0;
  ;
  return $12;
}


function __ZN9input_seq11set_defaultEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+4;
  var $4=__stackBase__+8;
  var $5=__stackBase__+12;
  var $6=__stackBase__+16;
  var $7=__stackBase__+20;
  var $8=__stackBase__+24;
  $1=$this;
  var $9=$1;
  __ZN10input_codeC1ERKS_($2, __ZN9input_seq12default_codeE);
  __ZN10input_codeC1ERKS_($3, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
  __ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_($9, $2, $3, $4, $5, $6, $7, $8);
  STACKTOP = __stackBase__;
  return;
}


function __Z24input_field_setting_namePK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $setting;
      $2=$field;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=$2;
      var $6=__ZNK18input_field_config11settinglistEv($5);
      var $7=__ZNK11simple_listI20input_setting_configE5firstEv($6);
      $setting=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$setting;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $11
      var $12=$2;
      var $13=__ZNK18input_field_config7machineEv($12);
      var $14=$setting;
      var $15=(($14+4)|0);
      var $16=$2;
      var $17=__ZNK18input_field_config4portEv($16);
      var $18=__ZNK17input_port_config5ownerEv($17);
      var $19=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($13, $15, $18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $21
      var $22=$setting;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      var $26=(($25+400)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+200)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($24)|0)==(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $31
      var $32=$setting;
      var $33=(($32+20)|0);
      var $34=HEAP32[(($33)>>2)];
      $1=$34;
      __label__ = 11; break;
    case 7: // $35
      __label__ = 8; break;
    case 8: // $36
      __label__ = 9; break;
    case 9: // $37
      var $38=$setting;
      var $39=__ZNK20input_setting_config4nextEv($38);
      $setting=$39;
      __label__ = 3; break;
    case 10: // $40
      $1=((STRING_TABLE.__str1344)|0);
      __label__ = 11; break;
    case 11: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z32input_field_has_previous_settingPK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $setting;
      $2=$field;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=$2;
      var $6=__ZNK18input_field_config11settinglistEv($5);
      var $7=__ZNK11simple_listI20input_setting_configE5firstEv($6);
      $setting=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$setting;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $11
      var $12=$2;
      var $13=__ZNK18input_field_config7machineEv($12);
      var $14=$setting;
      var $15=(($14+4)|0);
      var $16=$2;
      var $17=__ZNK18input_field_config4portEv($16);
      var $18=__ZNK17input_port_config5ownerEv($17);
      var $19=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($13, $15, $18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=$setting;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      var $26=(($25+400)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+200)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($24)|0)!=(($29)|0);
      var $31=(($30)&1);
      $1=$31;
      __label__ = 9; break;
    case 6: // $32
      __label__ = 7; break;
    case 7: // $33
      var $34=$setting;
      var $35=__ZNK20input_setting_config4nextEv($34);
      $setting=$35;
      __label__ = 3; break;
    case 8: // $36
      $1=0;
      __label__ = 9; break;
    case 9: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z35input_field_select_previous_settingPK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $setting;
      var $prevsetting;
      var $found_match;
      $1=$field;
      $found_match=0;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      $prevsetting=0;
      var $4=$1;
      var $5=__ZNK18input_field_config11settinglistEv($4);
      var $6=__ZNK11simple_listI20input_setting_configE5firstEv($5);
      $setting=$6;
      __label__ = 3; break;
    case 3: // $7
      var $8=$setting;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $10
      var $11=$1;
      var $12=__ZNK18input_field_config7machineEv($11);
      var $13=$setting;
      var $14=(($13+4)|0);
      var $15=$1;
      var $16=__ZNK18input_field_config4portEv($15);
      var $17=__ZNK17input_port_config5ownerEv($16);
      var $18=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($12, $14, $17);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $20
      var $21=$setting;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+400)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+200)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($23)|0)==(($28)|0);
      if ($29) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $30
      $found_match=1;
      var $31=$prevsetting;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      __label__ = 12; break;
    case 8: // $34
      __label__ = 9; break;
    case 9: // $35
      var $36=$setting;
      $prevsetting=$36;
      __label__ = 10; break;
    case 10: // $37
      __label__ = 11; break;
    case 11: // $38
      var $39=$setting;
      var $40=__ZNK20input_setting_config4nextEv($39);
      $setting=$40;
      __label__ = 3; break;
    case 12: // $41
      var $42=$found_match;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 20; break; } else { __label__ = 13; break; }
    case 13: // $44
      var $45=$1;
      var $46=__ZNK18input_field_config11settinglistEv($45);
      var $47=__ZNK11simple_listI20input_setting_configE5firstEv($46);
      $prevsetting=$47;
      __label__ = 14; break;
    case 14: // $48
      var $49=$prevsetting;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $51
      var $52=$1;
      var $53=__ZNK18input_field_config7machineEv($52);
      var $54=$prevsetting;
      var $55=(($54+4)|0);
      var $56=$1;
      var $57=__ZNK18input_field_config4portEv($56);
      var $58=__ZNK17input_port_config5ownerEv($57);
      var $59=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($53, $55, $58);
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $61
      __label__ = 19; break;
    case 17: // $62
      __label__ = 18; break;
    case 18: // $63
      var $64=$prevsetting;
      var $65=__ZNK20input_setting_config4nextEv($64);
      $prevsetting=$65;
      __label__ = 14; break;
    case 19: // $66
      __label__ = 20; break;
    case 20: // $67
      var $68=$prevsetting;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $70
      var $71=$prevsetting;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$1;
      var $75=(($74+400)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76+200)|0);
      HEAP32[(($77)>>2)]=$73;
      __label__ = 22; break;
    case 22: // $78
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z35input_field_select_previous_settingPK18input_field_config["X"]=1;

function __Z28input_field_has_next_settingPK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $setting;
      var $found;
      $2=$field;
      $found=0;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=$2;
      var $6=__ZNK18input_field_config11settinglistEv($5);
      var $7=__ZNK11simple_listI20input_setting_configE5firstEv($6);
      $setting=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$setting;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $11
      var $12=$2;
      var $13=__ZNK18input_field_config7machineEv($12);
      var $14=$setting;
      var $15=(($14+4)|0);
      var $16=$2;
      var $17=__ZNK18input_field_config4portEv($16);
      var $18=__ZNK17input_port_config5ownerEv($17);
      var $19=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($13, $15, $18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $21
      var $22=$found;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $24
      $1=1;
      __label__ = 13; break;
    case 7: // $25
      var $26=$setting;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=(($29+400)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+200)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($28)|0)==(($33)|0);
      if ($34) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $35
      $found=1;
      __label__ = 9; break;
    case 9: // $36
      __label__ = 10; break;
    case 10: // $37
      __label__ = 11; break;
    case 11: // $38
      var $39=$setting;
      var $40=__ZNK20input_setting_config4nextEv($39);
      $setting=$40;
      __label__ = 3; break;
    case 12: // $41
      $1=0;
      __label__ = 13; break;
    case 13: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z28input_field_has_next_settingPK18input_field_config["X"]=1;

function __Z31input_field_select_next_settingPK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $setting;
      var $nextsetting;
      $1=$field;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      $nextsetting=0;
      var $4=$1;
      var $5=__ZNK18input_field_config11settinglistEv($4);
      var $6=__ZNK11simple_listI20input_setting_configE5firstEv($5);
      $setting=$6;
      __label__ = 3; break;
    case 3: // $7
      var $8=$setting;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $10
      var $11=$1;
      var $12=__ZNK18input_field_config7machineEv($11);
      var $13=$setting;
      var $14=(($13+4)|0);
      var $15=$1;
      var $16=__ZNK18input_field_config4portEv($15);
      var $17=__ZNK17input_port_config5ownerEv($16);
      var $18=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($12, $14, $17);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $20
      var $21=$setting;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+400)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+200)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($23)|0)==(($28)|0);
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      __label__ = 10; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      __label__ = 9; break;
    case 9: // $33
      var $34=$setting;
      var $35=__ZNK20input_setting_config4nextEv($34);
      $setting=$35;
      __label__ = 3; break;
    case 10: // $36
      var $37=$setting;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $39
      var $40=$setting;
      var $41=__ZNK20input_setting_config4nextEv($40);
      $nextsetting=$41;
      __label__ = 12; break;
    case 12: // $42
      var $43=$nextsetting;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $45
      var $46=$1;
      var $47=__ZNK18input_field_config7machineEv($46);
      var $48=$nextsetting;
      var $49=(($48+4)|0);
      var $50=$1;
      var $51=__ZNK18input_field_config4portEv($50);
      var $52=__ZNK17input_port_config5ownerEv($51);
      var $53=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($47, $49, $52);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $55
      __label__ = 17; break;
    case 15: // $56
      __label__ = 16; break;
    case 16: // $57
      var $58=$nextsetting;
      var $59=__ZNK20input_setting_config4nextEv($58);
      $nextsetting=$59;
      __label__ = 12; break;
    case 17: // $60
      __label__ = 18; break;
    case 18: // $61
      var $62=$nextsetting;
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $64
      var $65=$1;
      var $66=__ZNK18input_field_config11settinglistEv($65);
      var $67=__ZNK11simple_listI20input_setting_configE5firstEv($66);
      $nextsetting=$67;
      __label__ = 20; break;
    case 20: // $68
      var $69=$nextsetting;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $71
      var $72=$1;
      var $73=__ZNK18input_field_config7machineEv($72);
      var $74=$nextsetting;
      var $75=(($74+4)|0);
      var $76=$1;
      var $77=__ZNK18input_field_config4portEv($76);
      var $78=__ZNK17input_port_config5ownerEv($77);
      var $79=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($73, $75, $78);
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $81
      __label__ = 25; break;
    case 23: // $82
      __label__ = 24; break;
    case 24: // $83
      var $84=$nextsetting;
      var $85=__ZNK20input_setting_config4nextEv($84);
      $nextsetting=$85;
      __label__ = 20; break;
    case 25: // $86
      __label__ = 26; break;
    case 26: // $87
      var $88=$nextsetting;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $90
      var $91=$nextsetting;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$1;
      var $95=(($94+400)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+200)|0);
      HEAP32[(($97)>>2)]=$93;
      __label__ = 28; break;
    case 28: // $98
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z31input_field_select_next_settingPK18input_field_config["X"]=1;

function __Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($machine, $condition, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $condvalue;
      var $conditiontag=__stackBase__;
      var $5;
      var $6;
      var $7;
      $2=$machine;
      $3=$condition;
      $4=$owner;
      var $8=$3;
      var $9=(($8+12)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=1;
      __label__ = 16; break;
    case 2: // $14
      __ZN7astringC1Ev($conditiontag);
      var $15=$4;
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($15, $conditiontag, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $20
      var $21=$2;
      var $22=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($conditiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $23
      var $24=(function() { try { __THREW__ = false; return __Z15input_port_readR15running_machinePKc($21, $22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; };
    case 5: // $25
      $condvalue=$24;
      var $26=$3;
      var $27=(($26+12)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      if ($29 == 1) {
        __label__ = 7; break;
      }
      else if ($29 == 2) {
        __label__ = 8; break;
      }
      else if ($29 == 3) {
        __label__ = 9; break;
      }
      else if ($29 == 4) {
        __label__ = 10; break;
      }
      else if ($29 == 5) {
        __label__ = 11; break;
      }
      else if ($29 == 6) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 6: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $5=$32;
      var $33=$31.f1;
      $6=$33;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($conditiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 7: // $34
      var $35=$condvalue;
      var $36=$3;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$35 & $38;
      var $40=$3;
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($39)|0)==(($42)|0);
      var $44=(($43)&1);
      $1=$44;
      $7=1;
      __label__ = 14; break;
    case 8: // $45
      var $46=$condvalue;
      var $47=$3;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$46 & $49;
      var $51=$3;
      var $52=(($51+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($50)|0)!=(($53)|0);
      var $55=(($54)&1);
      $1=$55;
      $7=1;
      __label__ = 14; break;
    case 9: // $56
      var $57=$condvalue;
      var $58=$3;
      var $59=(($58+4)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$57 & $60;
      var $62=$3;
      var $63=(($62+8)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=(($61)>>>0) > (($64)>>>0);
      var $66=(($65)&1);
      $1=$66;
      $7=1;
      __label__ = 14; break;
    case 10: // $67
      var $68=$condvalue;
      var $69=$3;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$68 & $71;
      var $73=$3;
      var $74=(($73+8)|0);
      var $75=HEAPU32[(($74)>>2)];
      var $76=(($72)>>>0) <= (($75)>>>0);
      var $77=(($76)&1);
      $1=$77;
      $7=1;
      __label__ = 14; break;
    case 11: // $78
      var $79=$condvalue;
      var $80=$3;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$79 & $82;
      var $84=$3;
      var $85=(($84+8)|0);
      var $86=HEAPU32[(($85)>>2)];
      var $87=(($83)>>>0) < (($86)>>>0);
      var $88=(($87)&1);
      $1=$88;
      $7=1;
      __label__ = 14; break;
    case 12: // $89
      var $90=$condvalue;
      var $91=$3;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$90 & $93;
      var $95=$3;
      var $96=(($95+8)|0);
      var $97=HEAPU32[(($96)>>2)];
      var $98=(($94)>>>0) >= (($97)>>>0);
      var $99=(($98)&1);
      $1=$99;
      $7=1;
      __label__ = 14; break;
    case 13: // $100
      $1=1;
      $7=1;
      __label__ = 14; break;
    case 14: // $101
      FUNCTION_TABLE[__ZN7astringD1Ev]($conditiontag);
      __label__ = 16; break;
    case 15: // $102
      __label__ = 17; break;
    case 16: // $103
      var $104=$1;
      STACKTOP = __stackBase__;
      return $104;
    case 17: // $105
      var $106=$5;
      var $107=$5;
      var $108=$6;
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t["X"]=1;

function __Z15input_type_listR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  var $portdata;
  $1=$machine;
  var $2=$1;
  var $3=(($2+644)|0);
  var $4=HEAP32[(($3)>>2)];
  $portdata=$4;
  var $5=$portdata;
  var $6=(($5+4)|0);
  ;
  return $6;
}


function __ZNK8attotime14as_attosecondsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($3+4)|0);
      var $st$1$0=(($8)|0);
      var $9$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($8+4)|0);
      var $9$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($1)|0);
      HEAP32[(($st$5$0)>>2)]=$9$0;
      var $st$5$1=(($1+4)|0);
      HEAP32[(($st$5$1)>>2)]=$9$1;
      __label__ = 7; break;
    case 2: // $10
      var $11=(($3)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)==-1;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=(($3+4)|0);
      var $st$1$0=(($15)|0);
      var $16$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $17$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $17$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($1)|0);
      HEAP32[(($st$8$0)>>2)]=$17$0;
      var $st$8$1=(($1+4)|0);
      HEAP32[(($st$8$1)>>2)]=$17$1;
      __label__ = 7; break;
    case 4: // $18
      var $19=(($3)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0) > 0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$1$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 7; break;
    case 6: // $23
      var $$emscripten$temp$2$0=1486618624;
      var $$emscripten$temp$2$1=-232830644;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$2$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 7; break;
    case 7: // $24
      var $st$0$0=(($1)|0);
      var $25$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $25$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$25$0,$25$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK8attotime14as_attosecondsEv["X"]=1;

function __Z18input_type_set_seqR15running_machineii15_input_seq_typePK9input_seq($machine, $type, $player, $seqtype, $newseq) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $portdata;
      var $entry;
      $1=$machine;
      $2=$type;
      $3=$player;
      $4=$seqtype;
      $5=$newseq;
      var $6=$1;
      var $7=(($6+644)|0);
      var $8=HEAP32[(($7)>>2)];
      $portdata=$8;
      var $9=$3;
      var $10=$2;
      var $11=$portdata;
      var $12=(($11+24)|0);
      var $13=(($12+($10<<5))|0);
      var $14=(($13+($9<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $entry=$15;
      var $16=$entry;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$4;
      var $20=$entry;
      var $21=(($20+212)|0);
      var $22=(($21+($19<<6))|0);
      var $23=$5;
      var $24=$22;
      var $25=$23;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $25>>2, $$dest = $24>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 2; break;
    case 2: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18input_type_pressedR15running_machineii($machine, $type, $player) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$type;
  $3=$player;
  var $4=$1;
  var $5=__ZNK15running_machine5inputEv($4);
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=__Z14input_type_seqR15running_machineii15_input_seq_type($6, $7, $8, 0);
  var $10=__ZN13input_manager11seq_pressedERK9input_seq($5, $9);
  var $11=(($10)&1);
  ;
  return $11;
}


function __ZN15running_machine4portEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  var $6=__ZNK11tagged_listI17input_port_configE4findEPKc($4, $5);
  ;
  return $6;
}


function __ZNK17input_port_config7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK8device_t7machineEv($4);
  ;
  return $5;
}


function __ZNK13delegate_baseIjRK18input_field_configPv8_noparamS4_EclES2_S3_($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  var $10=$3;
  var $11=FUNCTION_TABLE[$6]($8, $9, $10);
  ;
  return $11;
}


function __ZNK13screen_device6vblankEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $3=$1;
  var $4=$3;
  var $5=__ZNK8device_t7machineEv($4);
  __ZNK15running_machine4timeEv($2, $5);
  var $6=(($3+520)|0);
  var $7=__ZltRK8attotimeS1_($2, $6);
  STACKTOP = __stackBase__;
  return $7;
}


function __ZmiRK8attotimeS1_($agg_result, $left, $right) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result=__stackBase__;
      $1=$left;
      $2=$right;
      __ZN8attotimeC1Ev($result);
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0) >= 1000000000;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$agg_result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __label__ = 5; break;
    case 2: // $9
      var $10=$1;
      var $11=(($10+4)|0);
      var $st$2$0=(($11)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $13=$2;
      var $14=(($13+4)|0);
      var $st$8$0=(($14)|0);
      var $15$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$8$1)>>2)];
      var $16$0 = ((($12$0)>>>0)+((($12$1)|0)*4294967296))-((($15$0)>>>0)+((($15$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($12$0)>>>0)+((($12$1)|0)*4294967296))-((($15$0)>>>0)+((($15$1)|0)*4294967296)))/4294967296), 4294967295);
      var $17=(($result+4)|0);
      var $st$14$0=(($17)|0);
      HEAP32[(($st$14$0)>>2)]=$16$0;
      var $st$14$1=(($17+4)|0);
      HEAP32[(($st$14$1)>>2)]=$16$1;
      var $18=$1;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$2;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($20-$23)|0);
      var $25=(($result)|0);
      HEAP32[(($25)>>2)]=$24;
      var $26=(($result+4)|0);
      var $st$28$0=(($26)|0);
      var $27$0=HEAP32[(($st$28$0)>>2)];
      var $st$28$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$28$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $28=($27$1|0) < ($$emscripten$temp$0$1|0) || (($27$1|0) == ($$emscripten$temp$0$1|0) && ($27$0|0) <  ($$emscripten$temp$0$0|0));
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=(($result+4)|0);
      var $st$1$0=(($30)|0);
      var $31$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($30+4)|0);
      var $31$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $32$0 = ((($31$0)>>>0)+((($31$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $32$1 = Math.min(Math.floor((((($31$0)>>>0)+((($31$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($30)|0);
      HEAP32[(($st$8$0)>>2)]=$32$0;
      var $st$8$1=(($30+4)|0);
      HEAP32[(($st$8$1)>>2)]=$32$1;
      var $33=(($result)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34-1)|0);
      HEAP32[(($33)>>2)]=$35;
      __label__ = 4; break;
    case 4: // $36
      var $37=$agg_result;
      var $38=$result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($37)>>2)]=HEAP32[(($38)>>2)];HEAP32[(($37+4)>>2)]=HEAP32[(($38+4)>>2)];HEAP32[(($37+8)>>2)]=HEAP32[(($38+8)>>2)];
      __label__ = 5; break;
    case 5: // $39
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZmiRK8attotimeS1_["X"]=1;

function __ZL21apply_analog_settingsiP19_analog_field_state($value, $analog) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$value;
      $2=$analog;
      var $3=$2;
      var $4=$1;
      var $5=__ZL20apply_analog_min_maxPK19_analog_field_statei($3, $4);
      $1=$5;
      var $6=$1;
      var $7$0=$6;
      var $7$1=(($6|0) < 0 ? -1 : 0);
      var $8=$2;
      var $9=(($8+24)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11$0=$10;
      var $11$1=(($10|0) < 0 ? -1 : 0);
      var $12$0 = ((($7$0)>>>0)+((($7$1)|0)*4294967296))*((($11$0)>>>0)+((($11$1)|0)*4294967296))>>>0; var $12$1 = Math.min(Math.floor((((($7$0)>>>0)+((($7$1)|0)*4294967296))*((($11$0)>>>0)+((($11$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=100;
      var $$emscripten$temp$0$1=0;
      var $13$0 = (tempBigIntR=((($12$0)>>>0)+((($12$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $13$1 = Math.min(Math.floor(((tempBigIntR=((($12$0)>>>0)+((($12$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $14$0=$13$0;
      var $14=$14$0;
      $1=$14;
      var $15=$2;
      var $16=(($15+28)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=(($20+64)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=(($22-$23)|0);
      $1=$24;
      __label__ = 5; break;
    case 2: // $25
      var $26=$2;
      var $27=(($26+111)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24)!=0;
      if ($29) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $30
      var $31=$1;
      var $32=(($31+65536)|0);
      $1=$32;
      __label__ = 4; break;
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$1;
      var $36=(($35)|0) >= 0;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$1;
      var $39$0=$38;
      var $39$1=(($38|0) < 0 ? -1 : 0);
      var $40=$2;
      var $41=(($40+68)|0);
      var $st$5$0=(($41)|0);
      var $42$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$5$1)>>2)];
      var $43$0 = ((($39$0)>>>0)+((($39$1)|0)*4294967296))*((($42$0)>>>0)+((($42$1)|0)*4294967296))>>>0; var $43$1 = Math.min(Math.floor((((($39$0)>>>0)+((($39$1)|0)*4294967296))*((($42$0)>>>0)+((($42$1)|0)*4294967296)))/4294967296), 4294967295);
      var $44$0=($43$0 >>> 24) | ($43$1 << 8);
      var $44$1=($43$1 >> 24) | (((($43$1|0) < 0 ? -1 : 0)) << 8);
      var $45$0=$44$0;
      var $45=$45$0;
      $1=$45;
      __label__ = 8; break;
    case 7: // $46
      var $47=$1;
      var $48$0=$47;
      var $48$1=(($47|0) < 0 ? -1 : 0);
      var $49=$2;
      var $50=(($49+76)|0);
      var $st$5$0=(($50)|0);
      var $51$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($50+4)|0);
      var $51$1=HEAP32[(($st$5$1)>>2)];
      var $52$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))*((($51$0)>>>0)+((($51$1)|0)*4294967296))>>>0; var $52$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))*((($51$0)>>>0)+((($51$1)|0)*4294967296)))/4294967296), 4294967295);
      var $53$0=($52$0 >>> 24) | ($52$1 << 8);
      var $53$1=($52$1 >> 24) | (((($52$1|0) < 0 ? -1 : 0)) << 8);
      var $54$0=$53$0;
      var $54=$54$0;
      $1=$54;
      __label__ = 8; break;
    case 8: // $55
      var $56=$2;
      var $57=(($56+12)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$1;
      var $60=(($59+$58)|0);
      $1=$60;
      var $61=$1;
      ;
      return $61;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21apply_analog_settingsiP19_analog_field_state["X"]=1;

function __ZNK8device_t6subtagER7astringPKc($this, $dest, $_tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$dest;
      $3=$_tag;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($4+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$2;
      var $12=(($4+288)|0);
      var $13=__ZN7astring3cpyERKS_($11, $12);
      var $14=__ZN7astring3catEPKc($13, ((STRING_TABLE.__str85)|0));
      var $15=$3;
      var $16=__ZN7astring3catEPKc($14, $15);
      var $22 = $16;__label__ = 4; break;
    case 3: // $17
      var $18=$2;
      var $19=$3;
      var $20=__ZN7astring3cpyEPKc($18, $19);
      var $22 = $20;__label__ = 4; break;
    case 4: // $21
      var $22;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20input_port_read_safeR15running_machinePKcj($machine, $tag, $defvalue) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $port;
      $1=$machine;
      $2=$tag;
      $3=$defvalue;
      var $4=$1;
      var $5=$2;
      var $6=__ZN15running_machine4portEPKc($4, $5);
      $port=$6;
      var $7=$port;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $15 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$port;
      var $13=__Z22input_port_read_directPK17input_port_config($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z22input_port_read_directPK17input_port_config($port) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $analog;
      var $device_field;
      var $result;
      var $2;
      var $3;
      var $newval;
      var $value;
      var $nsec_since_last=__stackBase__;
      var $4=__stackBase__+8;
      var $5=__stackBase__+20;
      $1=$port;
      var $6=$1;
      var $7=__ZNK17input_port_config7machineEv($6);
      var $8=(($7+644)|0);
      var $9=HEAP32[(($8)>>2)];
      $portdata=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$portdata;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24)!=0;
      if ($14) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $15
      var $16=___cxa_allocate_exception(1032);
      var $17=$16;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($17, ((STRING_TABLE.__str1347)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str1348)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str1337)|0),HEAP32[((tempInt+8)>>2)]=1426,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      ___cxa_throw($16, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $2=$21;
      var $22=$20.f1;
      $3=$22;
      ___cxa_free_exception($16);
      __label__ = 32; break;
    case 5: // $23
      __label__ = 6; break;
    case 6: // $24
      var $25=$1;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+16)|0);
      var $29=HEAP32[(($28)>>2)];
      $result=$29;
      var $30=$1;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      $device_field=$34;
      __label__ = 7; break;
    case 7: // $35
      var $36=$device_field;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $38
      var $39=$1;
      var $40=__ZNK17input_port_config7machineEv($39);
      var $41=$device_field;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+8)|0);
      var $45=$1;
      var $46=__ZNK17input_port_config5ownerEv($45);
      var $47=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($40, $44, $46);
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $49
      var $50=$device_field;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+236)|0);
      var $54=$53;
      var $55=$device_field;
      var $56=(($55+4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$device_field;
      var $59=(($58+4)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+260)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__ZNK13delegate_baseIjRK18input_field_configPv8_noparamS4_EclES2_S3_($54, $57, $62);
      $newval=$63;
      var $64=$newval;
      var $65=$device_field;
      var $66=(($65+16)|0);
      HEAP32[(($66)>>2)]=$64;
      var $67=$result;
      var $68=$device_field;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$72 ^ -1;
      var $74=$67 & $73;
      var $75=$newval;
      var $76=$device_field;
      var $77=(($76+12)|0);
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $80=$75 << $79;
      var $81=$device_field;
      var $82=(($81+4)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$80 & $85;
      var $87=$74 | $86;
      $result=$87;
      __label__ = 10; break;
    case 10: // $88
      __label__ = 11; break;
    case 11: // $89
      var $90=$device_field;
      var $91=(($90)|0);
      var $92=HEAP32[(($91)>>2)];
      $device_field=$92;
      __label__ = 7; break;
    case 12: // $93
      var $94=$1;
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+20)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $100
      var $101=$1;
      var $102=__ZNK17input_port_config7machineEv($101);
      var $103=(($102+560)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=__ZNK13screen_device6vblankEv($104);
      if ($105) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $106
      var $107=$1;
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$result;
      var $113=$112 | $111;
      $result=$113;
      __label__ = 16; break;
    case 15: // $114
      var $115=$1;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117+20)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119 ^ -1;
      var $121=$result;
      var $122=$121 & $120;
      $result=$122;
      __label__ = 16; break;
    case 16: // $123
      __label__ = 17; break;
    case 17: // $124
      var $125=$1;
      var $126=(($125)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+12)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$result;
      var $131=$130 ^ $129;
      $result=$131;
      var $132=$1;
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      $analog=$136;
      __label__ = 18; break;
    case 18: // $137
      var $138=$analog;
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 19; break; } else { __label__ = 31; break; }
    case 19: // $140
      var $141=$1;
      var $142=__ZNK17input_port_config7machineEv($141);
      var $143=$analog;
      var $144=(($143+4)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145+8)|0);
      var $147=$1;
      var $148=__ZNK17input_port_config5ownerEv($147);
      var $149=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($142, $146, $148);
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 20; break; } else { __label__ = 29; break; }
    case 20: // $151
      var $152=$analog;
      var $153=(($152+40)|0);
      var $154=HEAP32[(($153)>>2)];
      $value=$154;
      var $155=$analog;
      var $156=(($155+112)|0);
      var $157=HEAP8[($156)];
      var $158=(($157 << 24) >> 24)!=0;
      if ($158) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $159
      var $160=$analog;
      var $161=(($160+4)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+32)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164 & 32;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 24; break; } else { __label__ = 22; break; }
    case 22: // $167
      var $168=$portdata;
      var $169=(($168+7428)|0);
      var $st$2$0=(($169)|0);
      var $170$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($169+4)|0);
      var $170$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $171=$170$0 != $$emscripten$temp$0$0 || $170$1 != $$emscripten$temp$0$1;
      if ($171) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $172
      var $173=$1;
      var $174=__ZNK17input_port_config7machineEv($173);
      __ZNK15running_machine4timeEv($4, $174);
      var $175=$portdata;
      var $176=(($175+7416)|0);
      __ZmiRK8attotimeS1_($5, $4, $176);
      var $177=__ZNK8attotime14as_attosecondsEv($5);
      var $177$0=$177[0];
      var $177$1=$177[1];
      var $$emscripten$temp$1$0=1000000000;
      var $$emscripten$temp$1$1=0;
      var $178$0 = (tempBigIntR=((($177$0)>>>0)+((($177$1)|0)*4294967296))/((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $178$1 = Math.min(Math.floor(((tempBigIntR=((($177$0)>>>0)+((($177$1)|0)*4294967296))/((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$12$0=(($nsec_since_last)|0);
      HEAP32[(($st$12$0)>>2)]=$178$0;
      var $st$12$1=(($nsec_since_last+4)|0);
      HEAP32[(($st$12$1)>>2)]=$178$1;
      var $179=$analog;
      var $180=(($179+44)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182$0=$181;
      var $182$1=(($181|0) < 0 ? -1 : 0);
      var $183=$analog;
      var $184=(($183+40)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$analog;
      var $187=(($186+44)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($185-$188)|0);
      var $190$0=$189;
      var $190$1=(($189|0) < 0 ? -1 : 0);
      var $st$30$0=(($nsec_since_last)|0);
      var $191$0=HEAP32[(($st$30$0)>>2)];
      var $st$30$1=(($nsec_since_last+4)|0);
      var $191$1=HEAP32[(($st$30$1)>>2)];
      var $192$0 = ((($190$0)>>>0)+((($190$1)|0)*4294967296))*((($191$0)>>>0)+((($191$1)|0)*4294967296))>>>0; var $192$1 = Math.min(Math.floor((((($190$0)>>>0)+((($190$1)|0)*4294967296))*((($191$0)>>>0)+((($191$1)|0)*4294967296)))/4294967296), 4294967295);
      var $193=$portdata;
      var $194=(($193+7428)|0);
      var $st$37$0=(($194)|0);
      var $195$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($194+4)|0);
      var $195$1=HEAP32[(($st$37$1)>>2)];
      var $196$0 = (tempBigIntR=((($192$0)>>>0)+((($192$1)|0)*4294967296))/((($195$0)>>>0)+((($195$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $196$1 = Math.min(Math.floor(((tempBigIntR=((($192$0)>>>0)+((($192$1)|0)*4294967296))/((($195$0)>>>0)+((($195$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $197$0 = ((($182$0)>>>0)+((($182$1)|0)*4294967296))+((($196$0)>>>0)+((($196$1)|0)*4294967296))>>>0; var $197$1 = Math.min(Math.floor((((($182$0)>>>0)+((($182$1)|0)*4294967296))+((($196$0)>>>0)+((($196$1)|0)*4294967296)))/4294967296), 4294967295);
      var $198$0=$197$0;
      var $198=$198$0;
      $value=$198;
      __label__ = 24; break;
    case 24: // $199
      var $200=$value;
      var $201=$analog;
      var $202=__ZL21apply_analog_settingsiP19_analog_field_state($200, $201);
      $value=$202;
      var $203=$analog;
      var $204=(($203+4)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205+380)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207)|0)!=0;
      if ($208) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $209
      var $210=$value;
      var $211=$analog;
      var $212=(($211+4)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213+380)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(($215+($210<<2))|0);
      var $217=HEAP32[(($216)>>2)];
      $value=$217;
      __label__ = 26; break;
    case 26: // $218
      var $219=$analog;
      var $220=(($219+4)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+32)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=$223 & 128;
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $226
      var $227=$value;
      var $228=$227 ^ -1;
      $value=$228;
      __label__ = 28; break;
    case 28: // $229
      var $230=$result;
      var $231=$analog;
      var $232=(($231+4)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($233)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=$235 ^ -1;
      var $237=$230 & $236;
      var $238=$value;
      var $239=$analog;
      var $240=(($239+8)|0);
      var $241=HEAPU8[($240)];
      var $242=(($241)&255);
      var $243=$238 << $242;
      var $244=$analog;
      var $245=(($244+4)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=$243 & $248;
      var $250=$237 | $249;
      $result=$250;
      __label__ = 29; break;
    case 29: // $251
      __label__ = 30; break;
    case 30: // $252
      var $253=$analog;
      var $254=(($253)|0);
      var $255=HEAP32[(($254)>>2)];
      $analog=$255;
      __label__ = 18; break;
    case 31: // $256
      var $257=$result;
      STACKTOP = __stackBase__;
      return $257;
    case 32: // $258
      var $259=$2;
      var $260=$2;
      var $261=$3;
      var $262=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $260, tempValue);
      var $263=($262.f1 = $261, $262);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22input_port_read_directPK17input_port_config["X"]=1;

function __Z15input_port_readR15running_machinePKc($machine, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $port;
      $1=$machine;
      $2=$tag;
      var $3=$1;
      var $4=$2;
      var $5=__ZN15running_machine4portEPKc($3, $4);
      $port=$5;
      var $6=$port;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1346)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$9,tempInt));
      throw "Reached an unreachable!"
    case 2: // $10
      var $11=$port;
      var $12=__Z22input_port_read_directPK17input_port_config($11);
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_E6isnullEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $12 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      var $12 = $10;__label__ = 2; break;
    case 2: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z28input_port_string_from_tokenPKc($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $index;
      $2=$string;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 11; break;
    case 2: // $6
      var $7=$2;
      var $8=$7;
      var $9=(($8)>>>0) >= 116;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      var $11=$2;
      $1=$11;
      __label__ = 11; break;
    case 4: // $12
      $index=0;
      __label__ = 5; break;
    case 5: // $13
      var $14=$index;
      var $15=(($14)>>>0) < 115;
      if ($15) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $16
      var $17=$index;
      var $18=((__ZL26input_port_default_strings+($17<<3))|0);
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$2;
      var $22=$21;
      var $23=(($20)|0)==(($22)|0);
      if ($23) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $24
      var $25=$index;
      var $26=((__ZL26input_port_default_strings+($25<<3))|0);
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      $1=$28;
      __label__ = 11; break;
    case 8: // $29
      __label__ = 9; break;
    case 9: // $30
      var $31=$index;
      var $32=(($31+1)|0);
      $index=$32;
      __label__ = 5; break;
    case 10: // $33
      $1=((STRING_TABLE.__str1349)|0);
      __label__ = 11; break;
    case 11: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t20input_ports_defaultsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+48)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z33input_port_get_crosshair_positionR15running_machineiPfS1_($machine, $player, $x, $y) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $port;
      var $field;
      var $gotx;
      var $goty;
      var $analog;
      var $rawvalue;
      var $value;
      $1=$machine;
      $2=$player;
      $3=$x;
      $4=$y;
      $gotx=0;
      $goty=0;
      var $5=$1;
      var $6=(($5+20)|0);
      var $7=__ZNK11tagged_listI17input_port_configE5firstEv($6);
      $port=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$port;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 28; break; }
    case 2: // $11
      var $12=$port;
      var $13=__ZNK17input_port_config11first_fieldEv($12);
      $field=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$field;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 26; break; }
    case 4: // $17
      var $18=$field;
      var $19=(($18+28)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$2;
      var $23=(($21)|0)==(($22)|0);
      if ($23) { __label__ = 5; break; } else { __label__ = 24; break; }
    case 5: // $24
      var $25=$field;
      var $26=(($25+320)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { __label__ = 24; break; }
    case 6: // $30
      var $31=$1;
      var $32=$field;
      var $33=(($32+8)|0);
      var $34=$port;
      var $35=__ZNK17input_port_config5ownerEv($34);
      var $36=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($31, $33, $35);
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 23; break; }
    case 7: // $38
      var $39=$field;
      var $40=(($39+400)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      $analog=$43;
      var $44=$analog;
      var $45=(($44+40)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$analog;
      var $48=__ZL21apply_analog_settingsiP19_analog_field_state($46, $47);
      var $49=$analog;
      var $50=(($49+4)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0);
      var $53=HEAPU32[(($52)>>2)];
      var $54=$analog;
      var $55=(($54+8)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$53 >>> (($57)>>>0);
      var $59=$48 & $58;
      $rawvalue=$59;
      var $60=$rawvalue;
      var $61=$field;
      var $62=(($61+400)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+16)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($60-$67)|0);
      var $69=(($68)|0);
      var $70=$field;
      var $71=(($70+400)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+20)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$field;
      var $78=(($77+400)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+16)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($76-$83)|0);
      var $85=(($84)|0);
      var $86=$69/$85;
      $value=$86;
      var $87=$field;
      var $88=(($87+324)|0);
      var $89=(tempDoubleI32[0]=HEAP32[(($88)>>2)],tempDoubleI32[1]=HEAP32[(($88+4)>>2)],tempDoubleF64[0]);
      var $90=$89 < 0;
      if ($90) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $91
      var $92=$value;
      var $93=$92;
      var $94=1-$93;
      var $95=(-$94);
      var $96=$field;
      var $97=(($96+324)|0);
      var $98=(tempDoubleI32[0]=HEAP32[(($97)>>2)],tempDoubleI32[1]=HEAP32[(($97+4)>>2)],tempDoubleF64[0]);
      var $99=$95*$98;
      var $100=$99;
      $value=$100;
      __label__ = 10; break;
    case 9: // $101
      var $102=$field;
      var $103=(($102+324)|0);
      var $104=(tempDoubleI32[0]=HEAP32[(($103)>>2)],tempDoubleI32[1]=HEAP32[(($103+4)>>2)],tempDoubleF64[0]);
      var $105=$value;
      var $106=$105;
      var $107=$106*$104;
      var $108=$107;
      $value=$108;
      __label__ = 10; break;
    case 10: // $109
      var $110=$field;
      var $111=(($110+332)|0);
      var $112=(tempDoubleI32[0]=HEAP32[(($111)>>2)],tempDoubleI32[1]=HEAP32[(($111+4)>>2)],tempDoubleF64[0]);
      var $113=$value;
      var $114=$113;
      var $115=$114+$112;
      var $116=$115;
      $value=$116;
      var $117=$field;
      var $118=(($117+348)|0);
      var $119=$118;
      var $120=__ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_E6isnullEv($119);
      if ($120) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $121
      var $122=$field;
      var $123=(($122+348)|0);
      var $124=$123;
      var $125=$field;
      var $126=$value;
      var $127=__ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_EclES2_f($124, $125, $126);
      $value=$127;
      __label__ = 12; break;
    case 12: // $128
      var $129=$field;
      var $130=(($129+320)|0);
      var $131=HEAPU8[($130)];
      var $132=(($131)&255);
      var $133=(($132)|0)==1;
      if ($133) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $134
      var $135=$value;
      var $136=$3;
      HEAPF32[(($136)>>2)]=$135;
      $gotx=1;
      var $137=$field;
      var $138=(($137+340)|0);
      var $139=(tempDoubleI32[0]=HEAP32[(($138)>>2)],tempDoubleI32[1]=HEAP32[(($138+4)>>2)],tempDoubleF64[0]);
      var $140=$139 != 0;
      if ($140) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $141
      var $142=$field;
      var $143=(($142+340)|0);
      var $144=(tempDoubleI32[0]=HEAP32[(($143)>>2)],tempDoubleI32[1]=HEAP32[(($143+4)>>2)],tempDoubleF64[0]);
      var $145=$144;
      var $146=$4;
      HEAPF32[(($146)>>2)]=$145;
      $goty=1;
      __label__ = 15; break;
    case 15: // $147
      __label__ = 19; break;
    case 16: // $148
      var $149=$value;
      var $150=$4;
      HEAPF32[(($150)>>2)]=$149;
      $goty=1;
      var $151=$field;
      var $152=(($151+340)|0);
      var $153=(tempDoubleI32[0]=HEAP32[(($152)>>2)],tempDoubleI32[1]=HEAP32[(($152+4)>>2)],tempDoubleF64[0]);
      var $154=$153 != 0;
      if ($154) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $155
      var $156=$field;
      var $157=(($156+340)|0);
      var $158=(tempDoubleI32[0]=HEAP32[(($157)>>2)],tempDoubleI32[1]=HEAP32[(($157+4)>>2)],tempDoubleF64[0]);
      var $159=$158;
      var $160=$3;
      HEAPF32[(($160)>>2)]=$159;
      $gotx=1;
      __label__ = 18; break;
    case 18: // $161
      __label__ = 19; break;
    case 19: // $162
      var $163=$gotx;
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $165
      var $166=$goty;
      var $167=(($166)|0)!=0;
      if ($167) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $168
      __label__ = 26; break;
    case 22: // $169
      __label__ = 23; break;
    case 23: // $170
      __label__ = 24; break;
    case 24: // $171
      __label__ = 25; break;
    case 25: // $172
      var $173=$field;
      var $174=__ZNK18input_field_config4nextEv($173);
      $field=$174;
      __label__ = 3; break;
    case 26: // $175
      __label__ = 27; break;
    case 27: // $176
      var $177=$port;
      var $178=__ZNK17input_port_config4nextEv($177);
      $port=$178;
      __label__ = 1; break;
    case 28: // $179
      var $180=$gotx;
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 29; break; } else { var $186 = 0;__label__ = 30; break; }
    case 29: // $182
      var $183=$goty;
      var $184=(($183)|0)!=0;
      var $186 = $184;__label__ = 30; break;
    case 30: // $185
      var $186;
      var $187=(($186)&1);
      ;
      return $187;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z33input_port_get_crosshair_positionR15running_machineiPfS1_["X"]=1;

function __ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_EclES2_f($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  var $10=$3;
  var $11=FUNCTION_TABLE[$6]($8, $9, $10);
  ;
  return $11;
}


function __Z26input_port_update_defaultsR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $loopnum;
      var $port;
      var $field;
      $1=$machine;
      $loopnum=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$loopnum;
      var $4=(($3)|0) < 2;
      if ($4) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $5
      var $6=$1;
      var $7=(($6+20)|0);
      var $8=__ZNK11tagged_listI17input_port_configE5firstEv($7);
      $port=$8;
      __label__ = 3; break;
    case 3: // $9
      var $10=$port;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $12
      var $13=$loopnum;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $15
      var $16=$port;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+12)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 6; break;
    case 6: // $20
      var $21=$port;
      var $22=__ZNK17input_port_config11first_fieldEv($21);
      $field=$22;
      __label__ = 7; break;
    case 7: // $23
      var $24=$field;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $26
      var $27=$1;
      var $28=$field;
      var $29=(($28+8)|0);
      var $30=$port;
      var $31=__ZNK17input_port_config5ownerEv($30);
      var $32=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($27, $29, $31);
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      var $35=$port;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+12)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$field;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$42 ^ -1;
      var $44=$39 & $43;
      var $45=$field;
      var $46=(($45+400)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+200)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$field;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$49 & $52;
      var $54=$44 | $53;
      var $55=$port;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+12)|0);
      HEAP32[(($58)>>2)]=$54;
      __label__ = 10; break;
    case 10: // $59
      __label__ = 11; break;
    case 11: // $60
      var $61=$field;
      var $62=__ZNK18input_field_config4nextEv($61);
      $field=$62;
      __label__ = 7; break;
    case 12: // $63
      __label__ = 13; break;
    case 13: // $64
      var $65=$port;
      var $66=__ZNK17input_port_config4nextEv($65);
      $port=$66;
      __label__ = 3; break;
    case 14: // $67
      __label__ = 15; break;
    case 15: // $68
      var $69=$loopnum;
      var $70=(($69+1)|0);
      $loopnum=$70;
      __label__ = 1; break;
    case 16: // $71
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26input_port_update_defaultsR15running_machine["X"]=1;

function __Z23input_port_write_directPK17input_port_configjj($port, $data, $mem_mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device_field;
      var $newval;
      $1=$port;
      $2=$data;
      $3=$mem_mask;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$3;
      var $10=$9 ^ -1;
      var $11=$8 & $10;
      var $12=$2;
      var $13=$3;
      var $14=$12 & $13;
      var $15=$11 | $14;
      var $16=$1;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+24)|0);
      HEAP32[(($19)>>2)]=$15;
      var $20=$1;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      $device_field=$24;
      __label__ = 1; break;
    case 1: // $25
      var $26=$device_field;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $28
      var $29=$device_field;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+24)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)==215;
      if ($34) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $35
      var $36=$1;
      var $37=__ZNK17input_port_config7machineEv($36);
      var $38=$device_field;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+8)|0);
      var $42=$1;
      var $43=__ZNK17input_port_config5ownerEv($42);
      var $44=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($37, $41, $43);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $46
      var $47=$1;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+24)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$device_field;
      var $53=(($52+4)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$51 ^ $56;
      var $58=$device_field;
      var $59=(($58+4)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$57 & $62;
      var $64=$device_field;
      var $65=(($64+12)|0);
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$63 >>> (($67)>>>0);
      $newval=$68;
      var $69=$device_field;
      var $70=(($69+16)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$newval;
      var $73=(($71)|0)!=(($72)|0);
      if ($73) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $74
      var $75=$device_field;
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+268)|0);
      var $79=$78;
      var $80=$device_field;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$device_field;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85+292)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$device_field;
      var $89=(($88+16)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$newval;
      __ZNK13delegate_baseIvRK18input_field_configPvjjEclES2_S3_jj($79, $82, $87, $90, $91);
      var $92=$newval;
      var $93=$device_field;
      var $94=(($93+16)|0);
      HEAP32[(($94)>>2)]=$92;
      __label__ = 6; break;
    case 6: // $95
      __label__ = 7; break;
    case 7: // $96
      __label__ = 8; break;
    case 8: // $97
      var $98=$device_field;
      var $99=(($98)|0);
      var $100=HEAP32[(($99)>>2)];
      $device_field=$100;
      __label__ = 1; break;
    case 9: // $101
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z23input_port_write_directPK17input_port_configjj["X"]=1;

function __ZNK13delegate_baseIvRK18input_field_configPvjjEclES2_S3_jj($this, $p1, $p2, $p3, $p4) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  $5=$p4;
  var $6=$1;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  FUNCTION_TABLE[$8]($10, $11, $12, $13, $14);
  ;
  return;
}


function __ZN11simple_listI18input_field_configEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI18input_field_configEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN7astringC1EPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  __ZN7astringC2EPKc($3, $4);
  ;
  return;
}


function __ZN11simple_listI18input_field_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI18input_field_configED2Ev($2);
  ;
  return;
}


function __Z18port_default_valuePKcjjR8device_t($fulltag, $mask, $defval, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tempstring=__stackBase__;
      var $def;
      var $6;
      var $7;
      var $8;
      $2=$fulltag;
      $3=$mask;
      $4=$defval;
      $5=$owner;
      __ZN7astringC1Ev($tempstring);
      $def=0;
      var $9=$5;
      var $10=(function() { try { __THREW__ = false; return __ZNK8device_t20input_ports_defaultsEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 10; break; };
    case 1: // $11
      $def=$10;
      var $12=$def;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$def;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $20
      var $21=$2;
      var $22=$5;
      var $23=$def;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($22, $tempstring, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; };
    case 5: // $27
      var $28=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; };
    case 6: // $29
      var $30=(function() { try { __THREW__ = false; return _strcmp($21, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $31
      var $32=(($30)|0)==0;
      if ($32) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $33
      var $34=$def;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$3;
      var $38=(($36)|0)==(($37)|0);
      if ($38) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $39
      var $40=$def;
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      $1=$42;
      $8=1;
      __label__ = 14; break;
    case 10: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $6=$45;
      var $46=$44.f1;
      $7=$46;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 11: // $47
      var $48=$def;
      var $49=(($48+12)|0);
      $def=$49;
      __label__ = 3; break;
    case 12: // $50
      __label__ = 13; break;
    case 13: // $51
      var $52=$4;
      $1=$52;
      $8=1;
      __label__ = 14; break;
    case 14: // $53
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $54=$1;
      STACKTOP = __stackBase__;
      return $54;
    case 15: // $55
      __label__ = 16; break;
    case 16: // $56
      var $57=$6;
      var $58=$6;
      var $59=$7;
      var $60=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $58, tempValue);
      var $61=($60.f1 = $59, $60);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18port_default_valuePKcjjR8device_t["X"]=1;

function __ZN17input_port_configC2ER8device_tPKc($this, $owner, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$owner;
      $3=$tag;
      var $6=$1;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=(($6+4)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=(($6+8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($6+12)|0);
      var $11=$2;
      HEAP32[(($10)>>2)]=$11;
      var $12=(($6+16)|0);
      __ZN11simple_listI18input_field_configEC1ER13resource_pool($12, _global_resource_pool);
      var $13=(($6+36)|0);
      var $14=$3;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($13, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=(($6+100)|0);
      HEAP32[(($16)>>2)]=0;
      ;
      return;
    case 2: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      var $21=(($6+16)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI18input_field_configED1Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      __label__ = 4; break;
    case 4: // $23
      var $24=$4;
      var $25=$4;
      var $26=$5;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17input_port_config8modcountEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+100)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI18input_field_configE10detach_allEv($this) {
  ;
  var __label__;

  var $1;
  var $result;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  $result=$4;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$result;
  ;
  return $8;
}


function __ZNK18input_field_config8modcountEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+412)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN17input_port_config9fieldlistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  ;
  return $3;
}


function __ZNK11simple_listI18input_field_configE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN18input_field_config10diploclistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+436)|0);
  ;
  return $3;
}


function __ZL13find_charinfoj($target_char) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $low;
      var $high;
      var $i;
      var $ch;
      $2=$target_char;
      $low=0;
      $high=290;
      __label__ = 1; break;
    case 1: // $3
      var $4=$high;
      var $5=$low;
      var $6=(($4)|0) > (($5)|0);
      if ($6) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $7
      var $8=$high;
      var $9=$low;
      var $10=(($8+$9)|0);
      var $11=(((($10)|0)/2)|0);
      $i=$11;
      var $12=$i;
      var $13=((__ZL8charinfo+$12*12)|0);
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      $ch=$15;
      var $16=$ch;
      var $17=$2;
      var $18=(($16)>>>0) < (($17)>>>0);
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$i;
      var $21=(($20+1)|0);
      $low=$21;
      __label__ = 8; break;
    case 4: // $22
      var $23=$ch;
      var $24=$2;
      var $25=(($23)>>>0) > (($24)>>>0);
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$i;
      $high=$27;
      __label__ = 7; break;
    case 6: // $28
      var $29=$i;
      var $30=((__ZL8charinfo+$29*12)|0);
      $1=$30;
      __label__ = 10; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      __label__ = 1; break;
    case 9: // $33
      $1=0;
      __label__ = 10; break;
    case 10: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFjRK18input_field_configPvEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFjRK18input_field_configPvEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvRK18input_field_configPvjjEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFvRK18input_field_configPvjjEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFfRK18input_field_configfEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFfRK18input_field_configfEEC2Ev($2);
  ;
  return;
}


function __ZN11simple_listI20input_setting_configEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI20input_setting_configEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI23input_field_diplocationEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI23input_field_diplocationEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI23input_field_diplocationED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI23input_field_diplocationED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI20input_setting_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI20input_setting_configED2Ev($2);
  ;
  return;
}


function __ZN20input_setting_configC2ER18input_field_configjPKc($this, $field, $_value, $_name) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$field;
  $3=$_value;
  $4=$_name;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  var $9=(($5+20)|0);
  var $10=$4;
  HEAP32[(($9)>>2)]=$10;
  var $11=(($5+24)|0);
  HEAP16[(($11)>>1)]=0;
  var $12=(($5+28)|0);
  var $13=$2;
  HEAP32[(($12)>>2)]=$13;
  var $14=(($5+32)|0);
  HEAP32[(($14)>>2)]=0;
  var $15=(($5+4)|0);
  var $16=$15;
  for (var $$dest = $16, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
    HEAP8[$$dest] = 0
  };
  ;
  return;
}


function __Z19field_config_insertR18input_field_configRjR7astring($newfield, $disallowedbits, $errorbuf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $lowbit;
      var $nextfield;
      var $field;
      var $field1;
      $1=$newfield;
      $2=$disallowedbits;
      $3=$errorbuf;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=(($5+12)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=HEAP32[(($14)>>2)];
      var $16=$13 & $15;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$3;
      var $20=$1;
      var $21=__ZNK18input_field_config4portEv($20);
      var $22=__ZNK17input_port_config3tagEv($21);
      var $23=$1;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZN7astring9catprintfEPKcz($19, ((STRING_TABLE.__str1350)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,HEAP32[((tempInt+4)>>2)]=$25,tempInt));
      __label__ = 3; break;
    case 3: // $27
      var $28=$1;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$2;
      var $32=HEAP32[(($31)>>2)];
      var $33=$32 | $30;
      HEAP32[(($31)>>2)]=$33;
      __label__ = 4; break;
    case 4: // $34
      var $35=$1;
      var $36=__ZNK18input_field_config4portEv($35);
      var $37=__ZN17input_port_config9fieldlistEv($36);
      var $38=__ZNK11simple_listI18input_field_configE5firstEv($37);
      $field=$38;
      __label__ = 5; break;
    case 5: // $39
      var $40=$field;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $42
      var $43=$field;
      var $44=__ZNK18input_field_config4nextEv($43);
      $nextfield=$44;
      var $45=$field;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$1;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$47 & $50;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $53
      var $54=$1;
      var $55=(($54+8)|0);
      var $56=(($55+12)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $60
      var $61=$field;
      var $62=(($61+8)|0);
      var $63=(($62+12)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $67
      var $68=$field;
      var $69=(($68+8)|0);
      var $70=$1;
      var $71=(($70+8)|0);
      var $72=__ZL15condition_equalPK16_input_conditionS1_($69, $71);
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $74
      var $75=$1;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$77 ^ -1;
      var $79=$field;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81 & $78;
      HEAP32[(($80)>>2)]=$82;
      var $83=$1;
      var $84=__ZNK18input_field_config4portEv($83);
      var $85=__ZN17input_port_config9fieldlistEv($84);
      var $86=$field;
      __ZN11simple_listI18input_field_configE6removeERS0_($85, $86);
      __label__ = 11; break;
    case 11: // $87
      __label__ = 12; break;
    case 12: // $88
      var $89=$nextfield;
      $field=$89;
      __label__ = 5; break;
    case 13: // $90
      var $91=$1;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$1;
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96-1)|0);
      var $98=$93 ^ $97;
      var $99=$1;
      var $100=(($99)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$98 & $101;
      $lowbit=$102;
      var $103=$1;
      var $104=__ZNK18input_field_config4portEv($103);
      var $105=__ZN17input_port_config9fieldlistEv($104);
      var $106=__ZNK11simple_listI18input_field_configE5firstEv($105);
      $field1=$106;
      __label__ = 14; break;
    case 14: // $107
      var $108=$field1;
      var $109=(($108)|0)!=0;
      if ($109) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $110
      var $111=$field1;
      var $112=(($111)|0);
      var $113=HEAPU32[(($112)>>2)];
      var $114=$lowbit;
      var $115=(($113)>>>0) > (($114)>>>0);
      if ($115) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $116
      __label__ = 19; break;
    case 17: // $117
      __label__ = 18; break;
    case 18: // $118
      var $119=$field1;
      var $120=__ZNK18input_field_config4nextEv($119);
      $field1=$120;
      __label__ = 14; break;
    case 19: // $121
      var $122=$1;
      var $123=__ZNK18input_field_config4portEv($122);
      var $124=__ZN17input_port_config9fieldlistEv($123);
      var $125=$1;
      var $126=$field1;
      var $127=__ZN11simple_listI18input_field_configE13insert_beforeERS0_PS0_($124, $125, $126);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19field_config_insertR18input_field_configRjR7astring["X"]=1;

function __ZN7astring9catprintfEPKcz($this, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $ap=__stackBase__;
  var $result;
  $1=$this;
  $2=$format;
  var $3=$1;
  var $4=$ap;
  HEAP32[(($4)>>2)]=arguments[__ZN7astring9catprintfEPKcz.length];
  var $5=$2;
  var $6=HEAP32[(($ap)>>2)];
  var $7=__Z18astring_catvprintfP7astringPKcPc($3, $5, $6);
  $result=$7;
  var $8=$ap;
  ;
  var $9=$result;
  STACKTOP = __stackBase__;
  return $9;
}


function __ZNK17input_port_config3tagEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+36)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZL15condition_equalPK16_input_conditionS1_($cond1, $cond2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$cond1;
      $2=$cond2;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { var $38 = 0;__label__ = 4; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0)==(($16)|0);
      if ($17) { __label__ = 2; break; } else { var $38 = 0;__label__ = 4; break; }
    case 2: // $18
      var $19=$1;
      var $20=(($19+12)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$2;
      var $24=(($23+12)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=(($22)|0)==(($26)|0);
      if ($27) { __label__ = 3; break; } else { var $38 = 0;__label__ = 4; break; }
    case 3: // $28
      var $29=$1;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$2;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=_strcmp($31, $34);
      var $36=(($35)|0)==0;
      var $38 = $36;__label__ = 4; break;
    case 4: // $37
      var $38;
      var $39=(($38)&1);
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI18input_field_configE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI18input_field_configE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI18input_field_configE13insert_beforeERS0_PS0_($this, $object, $insert_before) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $curptr;
      $2=$this;
      $3=$object;
      $4=$insert_before;
      var $5=$2;
      var $6=$4;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=__ZN11simple_listI18input_field_configE6appendERS0_($5, $9);
      $1=$10;
      __label__ = 11; break;
    case 2: // $11
      var $12=(($5+4)|0);
      $curptr=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$curptr;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $17
      var $18=$curptr;
      var $19=HEAP32[(($18)>>2)];
      var $20=$4;
      var $21=(($19)|0)==(($20)|0);
      if ($21) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $22
      var $23=$4;
      var $24=$3;
      var $25=(($24+404)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$3;
      var $27=$curptr;
      HEAP32[(($27)>>2)]=$26;
      var $28=(($5+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$4;
      var $31=(($29)|0)==(($30)|0);
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      var $33=$3;
      var $34=(($5+4)|0);
      HEAP32[(($34)>>2)]=$33;
      __label__ = 7; break;
    case 7: // $35
      var $36=(($5+16)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+1)|0);
      HEAP32[(($36)>>2)]=$38;
      var $39=$3;
      $1=$39;
      __label__ = 11; break;
    case 8: // $40
      __label__ = 9; break;
    case 9: // $41
      var $42=$curptr;
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+404)|0);
      $curptr=$44;
      __label__ = 3; break;
    case 10: // $45
      var $46=$3;
      $1=$46;
      __label__ = 11; break;
    case 11: // $47
      var $48=$1;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI18input_field_configE13insert_beforeERS0_PS0_["X"]=1;

function __ZN11simple_listI23input_field_diplocationE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI23input_field_diplocationE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring3cpyEPKci($this, $src, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z13astring_cpychP7astringPKci($4, $5, $6);
  ;
  return $7;
}


function __ZN7astring3cpyEPKc($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__Z12astring_cpycP7astringPKc($3, $4);
  ;
  return $5;
}


function __Z26input_machine_has_keyboardR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $have_keyboard;
      var $field;
      var $port;
      $1=$machine;
      $have_keyboard=0;
      var $2=$1;
      var $3=(($2+20)|0);
      var $4=__ZNK11tagged_listI17input_port_configE5firstEv($3);
      $port=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$port;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $8
      var $9=$port;
      var $10=__ZNK17input_port_config11first_fieldEv($9);
      $field=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$field;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $14
      var $15=$field;
      var $16=(($15+24)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==46;
      if ($18) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $19
      $have_keyboard=1;
      __label__ = 8; break;
    case 6: // $20
      __label__ = 7; break;
    case 7: // $21
      var $22=$field;
      var $23=__ZNK18input_field_config4nextEv($22);
      $field=$23;
      __label__ = 3; break;
    case 8: // $24
      __label__ = 9; break;
    case 9: // $25
      var $26=$port;
      var $27=__ZNK17input_port_config4nextEv($26);
      $port=$27;
      __label__ = 1; break;
    case 10: // $28
      var $29=$have_keyboard;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z33validate_natural_keyboard_staticsv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $i;
      var $error;
      var $last_char;
      var $ci;
      $error=0;
      $last_char=0;
      $i=0;
      __label__ = 1; break;
    case 1: // $1
      var $2=$i;
      var $3=(($2)>>>0) < 290;
      if ($3) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $4
      var $5=$last_char;
      var $6=$i;
      var $7=((__ZL8charinfo+$6*12)|0);
      var $8=(($7)|0);
      var $9=HEAPU32[(($8)>>2)];
      var $10=(($5)>>>0) >= (($9)>>>0);
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=$i;
      var $13=((__ZL8charinfo+$12*12)|0);
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$last_char;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1356)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,HEAP32[((tempInt+4)>>2)]=$16,tempInt));
      $error=1;
      __label__ = 4; break;
    case 4: // $17
      var $18=$i;
      var $19=((__ZL8charinfo+$18*12)|0);
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      $last_char=$21;
      __label__ = 5; break;
    case 5: // $22
      var $23=$i;
      var $24=(($23+1)|0);
      $i=$24;
      __label__ = 1; break;
    case 6: // $25
      $i=0;
      __label__ = 7; break;
    case 7: // $26
      var $27=$i;
      var $28=(($27)>>>0) < 290;
      if ($28) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $29
      var $30=$i;
      var $31=((__ZL8charinfo+$30*12)|0);
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__ZL13find_charinfoj($33);
      $ci=$34;
      var $35=$ci;
      var $36=$i;
      var $37=((__ZL8charinfo+$36*12)|0);
      var $38=(($35)|0)!=(($37)|0);
      if ($38) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      var $40=$i;
      var $41=((__ZL8charinfo+$40*12)|0);
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1357)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$43,tempInt));
      $error=1;
      __label__ = 10; break;
    case 10: // $44
      __label__ = 11; break;
    case 11: // $45
      var $46=$i;
      var $47=(($46+1)|0);
      $i=$47;
      __label__ = 7; break;
    case 12: // $48
      var $49=$error;
      ;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z33validate_natural_keyboard_staticsv["X"]=1;

function __ZN18input_field_configC2ER17input_port_configijjPKc($this, $port, $_type, $_defvalue, $_maskbits, $_name) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7=__stackBase__;
      var $8=__stackBase__+4;
      var $9=__stackBase__+8;
      var $10=__stackBase__+12;
      var $11=__stackBase__+16;
      var $12=__stackBase__+20;
      var $13=__stackBase__+24;
      var $14;
      var $15;
      var $seqtype;
      $1=$this;
      $2=$port;
      $3=$_type;
      $4=$_defvalue;
      $5=$_maskbits;
      $6=$_name;
      var $16=$1;
      var $17=(($16)|0);
      var $18=$5;
      HEAP32[(($17)>>2)]=$18;
      var $19=(($16+4)|0);
      var $20=$4;
      var $21=$5;
      var $22=$20 & $21;
      HEAP32[(($19)>>2)]=$22;
      var $23=(($16+8)|0);
      var $24=(($16+24)|0);
      var $25=$3;
      HEAP32[(($24)>>2)]=$25;
      var $26=(($16+28)|0);
      HEAP8[($26)]=0;
      var $27=(($16+30)|0);
      HEAP16[(($27)>>1)]=0;
      var $28=(($16+32)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($16+36)|0);
      HEAP8[($29)]=0;
      var $30=(($16+40)|0);
      var $31=$6;
      HEAP32[(($30)>>2)]=$31;
      var $32=(($16+44)|0);
      var $33=(($32)|0);
      var $34=(($33+192)|0);
      var $36 = $33;__label__ = 1; break;
    case 1: // $35
      var $36;
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($9, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($10, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($11, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($12, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($13, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($36, $7, $8, $9, $10, $11, $12, $13);
      var $37=(($36+64)|0);
      var $38=(($37)|0)==(($34)|0);
      if ($38) { __label__ = 2; break; } else { var $36 = $37;__label__ = 1; break; }
    case 2: // $39
      var $40=(($16+236)|0);
      __ZN8delegateIFjRK18input_field_configPvEEC1Ev($40);
      var $41=(($16+260)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=(($16+264)|0);
      HEAP32[(($42)>>2)]=((__ZL11DEVICE_SELF431)|0);
      var $43=(($16+268)|0);
      __ZN8delegateIFvRK18input_field_configPvjjEEC1Ev($43);
      var $44=(($16+292)|0);
      HEAP32[(($44)>>2)]=0;
      var $45=(($16+296)|0);
      HEAP32[(($45)>>2)]=((__ZL11DEVICE_SELF431)|0);
      var $46=(($16+300)|0);
      HEAP32[(($46)>>2)]=0;
      var $47=(($16+304)|0);
      var $48=$5;
      HEAP32[(($47)>>2)]=$48;
      var $49=(($16+308)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($16+312)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=(($16+316)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=(($16+320)|0);
      HEAP8[($52)]=0;
      var $53=(($16+324)|0);
      (tempDoubleF64[0]=0,HEAP32[(($53)>>2)]=tempDoubleI32[0],HEAP32[(($53+4)>>2)]=tempDoubleI32[1]);
      var $54=(($16+332)|0);
      (tempDoubleF64[0]=0,HEAP32[(($54)>>2)]=tempDoubleI32[0],HEAP32[(($54+4)>>2)]=tempDoubleI32[1]);
      var $55=(($16+340)|0);
      (tempDoubleF64[0]=0,HEAP32[(($55)>>2)]=tempDoubleI32[0],HEAP32[(($55+4)>>2)]=tempDoubleI32[1]);
      var $56=(($16+348)|0);
      __ZN8delegateIFfRK18input_field_configfEEC1Ev($56);
      var $57=(($16+372)|0);
      HEAP32[(($57)>>2)]=((__ZL11DEVICE_SELF431)|0);
      var $58=(($16+376)|0);
      HEAP16[(($58)>>1)]=0;
      var $59=(($16+380)|0);
      HEAP32[(($59)>>2)]=0;
      var $60=(($16+384)|0);
      HEAP8[($60)]=0;
      var $61=(($16+400)|0);
      HEAP32[(($61)>>2)]=0;
      var $62=(($16+404)|0);
      HEAP32[(($62)>>2)]=0;
      var $63=(($16+408)|0);
      var $64=$2;
      HEAP32[(($63)>>2)]=$64;
      var $65=(($16+412)|0);
      var $66=$2;
      var $67=__ZNK17input_port_config8modcountEv($66);
      HEAP32[(($65)>>2)]=$67;
      var $68=(($16+416)|0);
      __ZN11simple_listI20input_setting_configEC1ER13resource_pool($68, _global_resource_pool);
      var $69=(($16+436)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI23input_field_diplocationEC1ER13resource_pool($69, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $70
      var $71=(($16+8)|0);
      var $72=$71;
      for (var $$dest = $72, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      $seqtype=0;
      __label__ = 4; break;
    case 4: // $73
      var $74=$seqtype;
      var $75=(($74)>>>0) < 3;
      if ($75) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $76
      var $77=$seqtype;
      var $78=(($16+44)|0);
      var $79=(($78+($77<<6))|0);
      (function() { try { __THREW__ = false; return __ZN9input_seq11set_defaultEv($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $80
      __label__ = 7; break;
    case 7: // $81
      var $82=$seqtype;
      var $83=(($82+1)|0);
      $seqtype=$83;
      __label__ = 4; break;
    case 8: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $86=$85.f0;
      $14=$86;
      var $87=$85.f1;
      $15=$87;
      __label__ = 12; break;
    case 9: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $90=$89.f0;
      $14=$90;
      var $91=$89.f1;
      $15=$91;
      var $92=(($16+436)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI23input_field_diplocationED1Ev($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 10: // $93
      var $94=(($16+388)|0);
      var $95=(($94+8)|0);
      HEAP32[(($95)>>2)]=0;
      var $96=(($16+388)|0);
      var $97=(($96+4)|0);
      HEAP32[(($97)>>2)]=0;
      var $98=(($16+388)|0);
      var $99=(($98)|0);
      HEAP32[(($99)>>2)]=0;
      STACKTOP = __stackBase__;
      return;
    case 11: // $100
      __label__ = 12; break;
    case 12: // $101
      var $102=(($16+416)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI20input_setting_configED1Ev($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $103
      __label__ = 14; break;
    case 14: // $104
      var $105=$14;
      var $106=$14;
      var $107=$15;
      var $108=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $106, tempValue);
      var $109=($108.f1 = $107, $108);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18input_field_configC2ER17input_port_configijjPKc["X"]=1;

function __Z15inputx_can_postR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      var $5=$portdata;
      var $6=(($5+7468)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { var $15 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$portdata;
      var $11=(($10+7456)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      var $15 = $13;__label__ = 2; break;
    case 2: // $14
      var $15;
      var $16=(($15)&1);
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10get_bufferR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$portdata;
      var $8=(($7+7460)|0);
      var $9=HEAP32[(($8)>>2)];
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z11inputx_initR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      var $5=$portdata;
      var $6=(($5+7456)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=$portdata;
      var $8=(($7+7464)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=$portdata;
      var $10=(($9+7468)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=$portdata;
      var $12=(($11+7472)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$portdata;
      var $14=(($13+7476)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=$portdata;
      var $16=(($15+7460)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=$1;
      var $18=(($17+584)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 1;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($23, ((STRING_TABLE.__str1341)|0), 0, 0, 1, 1, 120);
      var $24=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($24, ((STRING_TABLE.__str1358)|0), 0, 0, 0, 1, 122);
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=__Z26input_machine_has_keyboardR15running_machine($26);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$1;
      var $31=$1;
      var $32=(($31+20)|0);
      var $33=__ZNK11tagged_listI17input_port_configE5firstEv($32);
      var $34=__ZL11build_codesR15running_machinePK17input_port_config($30, $33);
      var $35=$portdata;
      var $36=(($35+7456)|0);
      HEAP32[(($36)>>2)]=$34;
      var $37=$1;
      __ZL15setup_keybufferR15running_machine($37);
      __label__ = 4; break;
    case 4: // $38
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11inputx_initR15running_machine["X"]=1;

function __ZL13execute_inputR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $6=$1;
  var $7=$4;
  var $8=(($7)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$4;
  var $11=(($10)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=_strlen($12);
  var $14=$5;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($14)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($14+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($14+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  __ZL23inputx_postn_coded_rateR15running_machinePKcj8attotime($6, $9, $13, $5);
  STACKTOP = __stackBase__;
  return;
}


function __ZL15execute_dumpkbdR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 512; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $codes;
      var $filename;
      var $file;
      var $code;
      var $buffer=__stackBase__;
      var $pos;
      var $i;
      var $j;
      var $left_column_width;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+7456)|0);
      var $9=HEAP32[(($8)>>2)];
      $codes=$9;
      $file=0;
      $left_column_width=24;
      var $10=$3;
      var $11=(($10)|0) > 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$4;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $18 = $15;__label__ = 3; break;
    case 2: // $16
      var $18 = 0;__label__ = 3; break;
    case 3: // $17
      var $18;
      $filename=$18;
      var $19=$filename;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $21
      var $22=$filename;
      var $23=_fopen($22, ((STRING_TABLE.__str111)|0));
      $file=$23;
      var $24=$file;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$1;
      var $28=$filename;
      __Z20debug_console_printfR15running_machinePKcz($27, ((STRING_TABLE.__str1362)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,tempInt));
      __label__ = 29; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=$codes;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 8; break; } else { __label__ = 26; break; }
    case 8: // $33
      var $34=$codes;
      var $35=(($34)|0);
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 9; break; } else { __label__ = 26; break; }
    case 9: // $39
      $i=0;
      __label__ = 10; break;
    case 10: // $40
      var $41=$i;
      var $42=$codes;
      var $43=(($42+$41*12)|0);
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 11; break; } else { __label__ = 25; break; }
    case 11: // $47
      var $48=$i;
      var $49=$codes;
      var $50=(($49+$48*12)|0);
      $code=$50;
      $pos=0;
      var $51=$pos;
      var $52=(($buffer+$51)|0);
      var $53=$pos;
      var $54=((512-$53)|0);
      var $55=$code;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$1;
      var $59=$code;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__ZL17code_point_stringR15running_machinej($58, $61);
      var $63=_snprintf($52, $54, ((STRING_TABLE.__str1363)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$57,HEAP32[((tempInt+4)>>2)]=$62,tempInt));
      var $64=$pos;
      var $65=(($64+$63)|0);
      $pos=$65;
      __label__ = 12; break;
    case 12: // $66
      var $67=$pos;
      var $68=$left_column_width;
      var $69=(($67)>>>0) < (($68)>>>0);
      if ($69) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $70
      var $71=$pos;
      var $72=(($71+1)|0);
      $pos=$72;
      var $73=(($buffer+$71)|0);
      HEAP8[($73)]=32;
      __label__ = 12; break;
    case 14: // $74
      var $75=$pos;
      var $76=(($buffer+$75)|0);
      HEAP8[($76)]=0;
      $j=0;
      __label__ = 15; break;
    case 15: // $77
      var $78=$j;
      var $79=(($78)>>>0) < 2;
      if ($79) { __label__ = 16; break; } else { var $88 = 0;__label__ = 17; break; }
    case 16: // $80
      var $81=$j;
      var $82=$code;
      var $83=(($82+4)|0);
      var $84=(($83+($81<<2))|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)!=0;
      var $88 = $86;__label__ = 17; break;
    case 17: // $87
      var $88;
      if ($88) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $89
      var $90=$pos;
      var $91=(($buffer+$90)|0);
      var $92=$pos;
      var $93=((512-$92)|0);
      var $94=$j;
      var $95=(($94)|0) > 0;
      var $96=$95 ? (((STRING_TABLE.__str1365)|0)) : (((__str1366)|0));
      var $97=$j;
      var $98=$code;
      var $99=(($98+4)|0);
      var $100=(($99+($97<<2))|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101+40)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=_snprintf($91, $93, ((STRING_TABLE.__str1364)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$96,HEAP32[((tempInt+4)>>2)]=$103,tempInt));
      var $105=$pos;
      var $106=(($105+$104)|0);
      $pos=$106;
      __label__ = 19; break;
    case 19: // $107
      var $108=$j;
      var $109=(($108+1)|0);
      $j=$109;
      __label__ = 15; break;
    case 20: // $110
      var $111=$file;
      var $112=(($111)|0)!=0;
      if ($112) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $113
      var $114=$file;
      var $115=(($buffer)|0);
      var $116=_fprintf($114, ((STRING_TABLE.__str1367)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$115,tempInt));
      __label__ = 23; break;
    case 22: // $117
      var $118=$1;
      var $119=(($buffer)|0);
      __Z20debug_console_printfR15running_machinePKcz($118, ((STRING_TABLE.__str1367)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$119,tempInt));
      __label__ = 23; break;
    case 23: // $120
      __label__ = 24; break;
    case 24: // $121
      var $122=$i;
      var $123=(($122+1)|0);
      $i=$123;
      __label__ = 10; break;
    case 25: // $124
      __label__ = 27; break;
    case 26: // $125
      var $126=$1;
      __Z20debug_console_printfR15running_machinePKcz($126, ((STRING_TABLE.__str1368)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 27; break;
    case 27: // $127
      var $128=$file;
      var $129=(($128)|0)!=0;
      if ($129) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $130
      var $131=$file;
      var $132=_fclose($131);
      __label__ = 29; break;
    case 29: // $133
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_dumpkbdR15running_machineiiPPKc["X"]=1;

function __Z12inputx_postcR15running_machinej($machine, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$machine;
  $2=$ch;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  __ZL17inputx_postc_rateR15running_machinej8attotime($4, $5, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZL17inputx_postc_rateR15running_machinej8attotime($machine, $ch, $rate) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $rate; $rate = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($rate)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($rate+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($rate+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+4;
  $1=$machine;
  HEAP32[(($2)>>2)]=$ch;
  var $4=$1;
  var $5=$3;
  var $6=$rate;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];HEAP32[(($5+4)>>2)]=HEAP32[(($6+4)>>2)];HEAP32[(($5+8)>>2)]=HEAP32[(($6+8)>>2)];
  __ZL17inputx_postn_rateR15running_machinePKjj8attotime($4, $2, 1, $3);
  STACKTOP = __stackBase__;
  return;
}


function __Z16inputx_post_utf8R15running_machinePKc($machine, $text) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$machine;
  $2=$text;
  var $4=$1;
  var $5=$2;
  var $6=$2;
  var $7=_strlen($6);
  var $8=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  __ZL22inputx_postn_utf8_rateR15running_machinePKcj8attotime($4, $5, $7, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZL22inputx_postn_utf8_rateR15running_machinePKcj8attotime($machine, $text, $text_len, $rate) {
  var __stackBase__  = STACKTOP; STACKTOP += 1052; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $rate; $rate = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($rate)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($rate+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($rate+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $len;
      var $buf=__stackBase__;
      var $c=__stackBase__+1024;
      var $rc;
      var $4=__stackBase__+1028;
      var $5=__stackBase__+1040;
      $1=$machine;
      $2=$text;
      $3=$text_len;
      $len=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$3;
      var $8=(($7)>>>0) > 0;
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$len;
      var $11=(($10)|0)==256;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$1;
      var $14=(($buf)|0);
      var $15=$len;
      var $16=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      __ZL17inputx_postn_rateR15running_machinePKjj8attotime($13, $14, $15, $4);
      $len=0;
      __label__ = 4; break;
    case 4: // $17
      var $18=$2;
      var $19=$3;
      var $20=__Z15uchar_from_utf8PjPKcj($c, $18, $19);
      $rc=$20;
      var $21=$rc;
      var $22=(($21)|0) < 0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      $rc=1;
      HEAP32[(($c)>>2)]=63;
      __label__ = 6; break;
    case 6: // $24
      var $25=$rc;
      var $26=$2;
      var $27=(($26+$25)|0);
      $2=$27;
      var $28=$rc;
      var $29=$3;
      var $30=(($29-$28)|0);
      $3=$30;
      var $31=HEAP32[(($c)>>2)];
      var $32=$len;
      var $33=(($32+1)|0);
      $len=$33;
      var $34=(($buf+($32<<2))|0);
      HEAP32[(($34)>>2)]=$31;
      __label__ = 1; break;
    case 7: // $35
      var $36=$1;
      var $37=(($buf)|0);
      var $38=$len;
      var $39=$5;
      var $40=$rate;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];HEAP32[(($39+4)>>2)]=HEAP32[(($40+4)>>2)];HEAP32[(($39+8)>>2)]=HEAP32[(($40+8)>>2)];
      __ZL17inputx_postn_rateR15running_machinePKjj8attotime($36, $37, $38, $5);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22inputx_postn_utf8_rateR15running_machinePKcj8attotime["X"]=1;

function __Z21input_category_activeR15running_machinei($machine, $category) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $port;
      var $field;
      var $setting;
      var $settings=__stackBase__;
      $2=$machine;
      $3=$category;
      $field=0;
      __ZN26_input_field_user_settingsC1Ev($settings);
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($6+20)|0);
      var $8=__ZNK11tagged_listI17input_port_configE5firstEv($7);
      $port=$8;
      __label__ = 3; break;
    case 3: // $9
      var $10=$port;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 4: // $12
      var $13=$port;
      var $14=__ZNK17input_port_config11first_fieldEv($13);
      $field=$14;
      __label__ = 5; break;
    case 5: // $15
      var $16=$field;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $18
      var $19=$field;
      var $20=(($19+24)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==8;
      if ($22) { __label__ = 7; break; } else { __label__ = 15; break; }
    case 7: // $23
      var $24=$field;
      __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($24, $settings);
      var $25=$field;
      var $26=__ZNK18input_field_config11settinglistEv($25);
      var $27=__ZNK11simple_listI20input_setting_configE5firstEv($26);
      $setting=$27;
      __label__ = 8; break;
    case 8: // $28
      var $29=$setting;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $31
      var $32=$setting;
      var $33=(($32+24)|0);
      var $34=HEAPU16[(($33)>>1)];
      var $35=(($34)&65535);
      var $36=$3;
      var $37=(($35)|0)==(($36)|0);
      if ($37) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $38
      var $39=(($settings)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$setting;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($40)|0)==(($43)|0);
      if ($44) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $45
      $1=1;
      __label__ = 20; break;
    case 12: // $46
      __label__ = 13; break;
    case 13: // $47
      var $48=$setting;
      var $49=__ZNK20input_setting_config4nextEv($48);
      $setting=$49;
      __label__ = 8; break;
    case 14: // $50
      __label__ = 15; break;
    case 15: // $51
      __label__ = 16; break;
    case 16: // $52
      var $53=$field;
      var $54=__ZNK18input_field_config4nextEv($53);
      $field=$54;
      __label__ = 5; break;
    case 17: // $55
      __label__ = 18; break;
    case 18: // $56
      var $57=$port;
      var $58=__ZNK17input_port_config4nextEv($57);
      $port=$58;
      __label__ = 3; break;
    case 19: // $59
      $1=0;
      __label__ = 20; break;
    case 20: // $60
      var $61=$1;
      STACKTOP = __stackBase__;
      return $61;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21input_category_activeR15running_machinei["X"]=1;

function __ZN26_input_field_user_settingsC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN26_input_field_user_settingsC2Ev($2);
  ;
  return;
}


function __ZL11build_codesR15running_machinePK17input_port_config($machine, $portconfig) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $codes;
      var $ports=__stackBase__+28;
      var $fields=__stackBase__+36;
      var $code_count;
      $7=$machine;
      $8=$portconfig;
      $codes=0;
      var $9=$7;
      var $10=$8;
      var $11=(($ports)|0);
      var $12=(($fields)|0);
      var $13=__ZL9scan_keysR15running_machinePK17input_port_configP12_inputx_codePS3_PPK18input_field_configii($9, $10, 0, $11, $12, 0, 0);
      $code_count=$13;
      var $14=$code_count;
      var $15=(($14)|0) > 0;
      if ($15) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $16
      var $17=$7;
      var $18=__ZN15running_machine7respoolEv($17);
      var $19=$code_count;
      var $20=(($19+1)|0);
      var $21=_llvm_umul_with_overflow_i32($20, 12);
      var $22=$21.f1;
      var $23=$21.f0;
      var $24=$22 ? -1 : $23;
      var $25=$1;
      var $26=$2;
      var $27=$3;
      var $28=$4;
      var $29=$result_i;
      var $30=$5;
      var $31=$6;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=4100;
      HEAP32[(($4)>>2)]=_zeromem;
      var $32=HEAP32[(($1)>>2)];
      var $33=HEAP32[(($2)>>2)];
      var $34=HEAP32[(($3)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($5)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($6)>>2)]=$45;
      var $46=HEAP32[(($6)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $48
      var $49=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($49);
      throw "Reached an unreachable!"
    case 6: // $50
      var $51=HEAP32[(($5)>>2)];
      var $52=HEAP32[(($5)>>2)];
      var $53=HEAP32[(($6)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $56
      throw "Reached an unreachable!"
    case 8: // $_ZnajPKciRK9zeromem_t_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=HEAP32[(($1)>>2)];
      _memset($57, 0, $58, 1);
      var $59=HEAP32[(($result_i)>>2)];
      var $60=$1;
      var $61=$2;
      var $62=$3;
      var $63=$4;
      var $64=$result_i;
      var $65=$5;
      var $66=$6;
      var $67=$59;
      var $68=$code_count;
      var $69=(($68+1)|0);
      var $70=__ZN13resource_pool9add_arrayI12_inputx_codeEEPT_S3_i($18, $67, $69);
      $codes=$70;
      var $71=$7;
      var $72=$8;
      var $73=$codes;
      var $74=(($ports)|0);
      var $75=(($fields)|0);
      var $76=__ZL9scan_keysR15running_machinePK17input_port_configP12_inputx_codePS3_PPK18input_field_configii($71, $72, $73, $74, $75, 0, 0);
      __label__ = 9; break;
    case 9: // $77
      var $78=$codes;
      STACKTOP = __stackBase__;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11build_codesR15running_machinePK17input_port_config["X"]=1;

function __ZL15setup_keybufferR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $portdata;
      var $8=__stackBase__+28;
      $7=$machine;
      var $9=$7;
      var $10=(($9+644)|0);
      var $11=HEAP32[(($10)>>2)];
      $portdata=$11;
      var $12=$7;
      var $13=__ZN15running_machine9schedulerEv($12);
      var $14=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($13, 124, ((STRING_TABLE.__str1391)|0), 0);
      var $15=$portdata;
      var $16=(($15+7464)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$7;
      var $18=__ZN15running_machine7respoolEv($17);
      var $19=$1;
      var $20=$2;
      var $21=$3;
      var $22=$4;
      var $23=$result_i;
      var $24=$5;
      var $25=$6;
      HEAP32[(($1)>>2)]=16396;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=4170;
      HEAP32[(($4)>>2)]=_zeromem;
      var $26=HEAP32[(($1)>>2)];
      var $27=HEAP32[(($2)>>2)];
      var $28=HEAP32[(($3)>>2)];
      var $29=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $30
      HEAP32[(($result_i)>>2)]=$29;
      var $31=HEAP32[(($result_i)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $33
      var $34=___cxa_allocate_exception(4);
      var $35=$34;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35);
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($5)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($6)>>2)]=$39;
      var $40=HEAP32[(($6)>>2)];
      var $41=(($40)|0) < 0;
      if ($41) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $42
      var $43=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($43);
      throw "Reached an unreachable!"
    case 5: // $44
      var $45=HEAP32[(($5)>>2)];
      var $46=HEAP32[(($5)>>2)];
      var $47=HEAP32[(($6)>>2)];
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $50
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $51=HEAP32[(($result_i)>>2)];
      var $52=HEAP32[(($1)>>2)];
      _memset($51, 0, $52, 1);
      var $53=HEAP32[(($result_i)>>2)];
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$4;
      var $58=$result_i;
      var $59=$5;
      var $60=$6;
      var $61=$53;
      var $62=__ZN13resource_pool10add_objectI11_key_bufferEEPT_S3_($18, $61);
      var $63=$portdata;
      var $64=(($63+7460)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=$7;
      var $66=$7;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($8, 126, ((STRING_TABLE.__str1392)|0), $66);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($65, 4, $8);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15setup_keybufferR15running_machine["X"]=1;

function __ZN11simple_listI18input_field_configE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+404)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+404)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc($portlist, $device, $tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $fulltag=__stackBase__+36;
      var $13;
      var $14;
      var $15;
      $10=$portlist;
      $11=$device;
      $12=$tag;
      __ZN7astringC1Ev($fulltag);
      var $16=$11;
      var $17=$12;
      var $18=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($16, $fulltag, $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 16; break; };
    case 1: // $19
      var $20=$10;
      var $21=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 16; break; };
    case 2: // $22
      var $23=$4;
      var $24=$5;
      var $25=$6;
      var $26=$result_i;
      var $27=$7;
      var $28=$8;
      HEAP32[(($4)>>2)]=104;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($6)>>2)]=4839;
      var $29=HEAP32[(($4)>>2)];
      var $30=HEAP32[(($5)>>2)];
      var $31=HEAP32[(($6)>>2)];
      var $32=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29, $30, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $33
      HEAP32[(($result_i)>>2)]=$32;
      var $34=HEAP32[(($result_i)>>2)];
      var $35=(($34)|0)==0;
      if ($35) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $36
      var $37=___cxa_allocate_exception(4);
      var $38=$37;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38);
      (function() { try { __THREW__ = false; return ___cxa_throw($37, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 5; break; }
    case 5: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      HEAP32[(($7)>>2)]=$41;
      var $42=$40.f1;
      HEAP32[(($8)>>2)]=$42;
      var $43=HEAP32[(($8)>>2)];
      var $44=(($43)|0) < 0;
      if ($44) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $45
      var $46=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $_noexc
      throw "Reached an unreachable!"
    case 8: // $47
      var $48=HEAP32[(($7)>>2)];
      var $49=HEAP32[(($7)>>2)];
      var $50=HEAP32[(($8)>>2)];
      var $51=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $49, tempValue);
      var $52=($51.f1 = $50, $51);
      var $eh_lpad_body = $52;__label__ = 17; break;
    case 9: // $53
      throw "Reached an unreachable!"
    case 10: // $_ZnwjPKci_exit
      var $54=HEAP32[(($result_i)>>2)];
      var $55=$4;
      var $56=$5;
      var $57=$6;
      var $58=$result_i;
      var $59=$7;
      var $60=$8;
      __label__ = 11; break;
    case 11: // $61
      var $62=$54;
      var $63=$11;
      var $64=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 18; break; };
    case 12: // $65
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17input_port_configC1ER8device_tPKc]($62, $63, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $66
      var $67=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI17input_port_configEEPT_S3_(_global_resource_pool, $62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configE6appendEPKcRS0_($20, $21, $67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; };
    case 15: // $70
      $9=$69;
      $15=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      var $71=$9;
      STACKTOP = __stackBase__;
      return $71;
    case 16: // $72
      var $73=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $73;__label__ = 17; break;
    case 17: // $_body
      var $eh_lpad_body;
      var $74=$eh_lpad_body.f0;
      $13=$74;
      var $75=$eh_lpad_body.f1;
      $14=$75;
      __label__ = 23; break;
    case 18: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $13=$78;
      var $79=$77.f1;
      $14=$79;
      var $80=$1;
      var $81=$2;
      var $82=$3;
      HEAP32[(($1)>>2)]=$54;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=4839;
      var $83=HEAP32[(($1)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $85
      var $86=HEAP32[(($1)>>2)];
      var $87=HEAP32[(($2)>>2)];
      var $88=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($86, $87, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $_noexc1
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $89=$1;
      var $90=$2;
      var $91=$3;
      __label__ = 22; break;
    case 22: // $92
      __label__ = 23; break;
    case 23: // $93
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $94
      __label__ = 25; break;
    case 25: // $95
      var $96=$13;
      var $97=$13;
      var $98=$14;
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc["X"]=1;

function __ZN11tagged_listI17input_port_configE6appendEPKcRS0_($this, $tag, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$tag;
      $3=$object;
      var $6=$1;
      var $7=(($6+20)|0);
      var $8=$2;
      var $9=$3;
      var $10=__ZN8tagmap_tIP17input_port_configE15add_unique_hashEPKcS1_b($7, $8, $9, 0);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=___cxa_allocate_exception(1032);
      var $14=$13;
      var $15=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($14, ((STRING_TABLE.__str1361)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      ___cxa_throw($13, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      ___cxa_free_exception($13);
      __label__ = 5; break;
    case 4: // $21
      var $22=(($6)|0);
      var $23=$3;
      var $24=__ZN11simple_listI17input_port_configE6appendERS0_($22, $23);
      ;
      return $24;
    case 5: // $25
      var $26=$4;
      var $27=$4;
      var $28=$5;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI17input_port_configEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17input_port_configEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17input_port_configEEPT_S3_["X"]=1;

function __Z20ioconfig_alloc_fieldR17input_port_configijjPKc($port, $type, $defval, $mask, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      $9=$port;
      $10=$type;
      $11=$defval;
      $12=$mask;
      $13=$name;
      var $16=$9;
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $18
      var $19=___cxa_allocate_exception(1032);
      var $20=$19;
      var $21=$12;
      var $22=$11;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($20, ((STRING_TABLE.__str1360)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$22,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      ___cxa_throw($19, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $14=$26;
      var $27=$25.f1;
      $15=$27;
      ___cxa_free_exception($19);
      __label__ = 26; break;
    case 4: // $28
      var $29=$10;
      var $30=(($29)|0)!=3;
      if ($30) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $31
      var $32=$10;
      var $33=(($32)|0)!=1;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=$12;
      var $36=$9;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38 | $35;
      HEAP32[(($37)>>2)]=$39;
      __label__ = 7; break;
    case 7: // $40
      var $41=$10;
      var $42=(($41)|0)==5;
      if ($42) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$10;
      var $45=(($44)|0)==7;
      if ($45) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $46
      var $47=$10;
      var $48=(($47)|0)==8;
      if ($48) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $49
      var $50=$9;
      var $51=__ZNK17input_port_config3tagEv($50);
      var $52=$12;
      var $53=$11;
      var $54=$9;
      var $55=__ZNK17input_port_config5ownerEv($54);
      var $56=__Z18port_default_valuePKcjjR8device_t($51, $52, $53, $55);
      $11=$56;
      __label__ = 11; break;
    case 11: // $57
      var $58=$9;
      var $59=__ZN17input_port_config9fieldlistEv($58);
      var $60=$4;
      var $61=$5;
      var $62=$6;
      var $63=$result_i;
      var $64=$7;
      var $65=$8;
      HEAP32[(($4)>>2)]=456;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($6)>>2)]=4861;
      var $66=HEAP32[(($4)>>2)];
      var $67=HEAP32[(($5)>>2)];
      var $68=HEAP32[(($6)>>2)];
      var $69=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($66, $67, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $70
      HEAP32[(($result_i)>>2)]=$69;
      var $71=HEAP32[(($result_i)>>2)];
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $73
      var $74=___cxa_allocate_exception(4);
      var $75=$74;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($75);
      (function() { try { __THREW__ = false; return ___cxa_throw($74, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      HEAP32[(($7)>>2)]=$78;
      var $79=$77.f1;
      HEAP32[(($8)>>2)]=$79;
      var $80=HEAP32[(($8)>>2)];
      var $81=(($80)|0) < 0;
      if ($81) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $82
      var $83=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($83);
      throw "Reached an unreachable!"
    case 16: // $84
      var $85=HEAP32[(($7)>>2)];
      var $86=HEAP32[(($7)>>2)];
      var $87=HEAP32[(($8)>>2)];
      var $88=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $86, tempValue);
      var $89=($88.f1 = $87, $88);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $90
      throw "Reached an unreachable!"
    case 18: // $_ZnwjPKci_exit
      var $91=HEAP32[(($result_i)>>2)];
      var $92=$4;
      var $93=$5;
      var $94=$6;
      var $95=$result_i;
      var $96=$7;
      var $97=$8;
      var $98=$91;
      var $99=$9;
      var $100=$10;
      var $101=$11;
      var $102=$12;
      var $103=$13;
      var $104=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc($103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; };
    case 19: // $105
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18input_field_configC1ER17input_port_configijjPKc]($98, $99, $100, $101, $102, $104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $106
      var $107=__ZN13resource_pool10add_objectI18input_field_configEEPT_S3_(_global_resource_pool, $98);
      var $108=__ZN11simple_listI18input_field_configE6appendERS0_($59, $107);
      STACKTOP = __stackBase__;
      return $108;
    case 21: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $14=$111;
      var $112=$110.f1;
      $15=$112;
      var $113=$1;
      var $114=$2;
      var $115=$3;
      HEAP32[(($1)>>2)]=$91;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=4861;
      var $116=HEAP32[(($1)>>2)];
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $118
      var $119=HEAP32[(($1)>>2)];
      var $120=HEAP32[(($2)>>2)];
      var $121=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($119, $120, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $_noexc
      __label__ = 24; break;
    case 24: // $_ZdlPvPKci_exit
      var $122=$1;
      var $123=$2;
      var $124=$3;
      __label__ = 25; break;
    case 25: // $125
      __label__ = 26; break;
    case 26: // $126
      var $127=$14;
      var $128=$14;
      var $129=$15;
      var $130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $128, tempValue);
      var $131=($130.f1 = $129, $130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 27: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20ioconfig_alloc_fieldR17input_port_configijjPKc["X"]=1;

function __ZN13resource_pool10add_objectI18input_field_configEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18input_field_configEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18input_field_configEEPT_S3_["X"]=1;

function __ZN18input_field_config11settinglistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+416)|0);
  ;
  return $3;
}


function __ZN11simple_listI20input_setting_configE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+32)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+32)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17ioconfig_add_codeR18input_field_configi10input_code($field, $which, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$field;
  $2=$which;
  var $4=$2;
  var $5=$1;
  var $6=(($5+44)|0);
  var $7=(($6+($4<<6))|0);
  __ZN10input_codeC1ERKS_($3, $code);
  var $8=__ZN9input_seqoRE10input_code($7, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seq($this, $_type, $_group, $_player, $_token, $_name, $standard) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7=__stackBase__;
      var $8=__stackBase__+4;
      var $9=__stackBase__+8;
      var $10=__stackBase__+12;
      var $11=__stackBase__+16;
      var $12=__stackBase__+20;
      var $13=__stackBase__+24;
      var $14=__stackBase__+28;
      var $15=__stackBase__+32;
      var $16=__stackBase__+36;
      var $17=__stackBase__+40;
      var $18=__stackBase__+44;
      var $19=__stackBase__+48;
      var $20=__stackBase__+52;
      $1=$this;
      $2=$_type;
      $3=$_group;
      $4=$_player;
      $5=$_token;
      $6=$_name;
      var $21=$1;
      var $22=(($21)|0);
      var $23=$2;
      HEAP32[(($22)>>2)]=$23;
      var $24=(($21+4)|0);
      var $25=$3;
      HEAP32[(($24)>>2)]=$25;
      var $26=(($21+8)|0);
      var $27=$4;
      var $28=(($27) & 255);
      HEAP8[($26)]=$28;
      var $29=(($21+12)|0);
      var $30=$5;
      HEAP32[(($29)>>2)]=$30;
      var $31=(($21+16)|0);
      var $32=$6;
      HEAP32[(($31)>>2)]=$32;
      var $33=(($21+20)|0);
      var $34=(($33)|0);
      var $35=(($34+192)|0);
      var $37 = $34;__label__ = 1; break;
    case 1: // $36
      var $37;
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($9, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($10, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($11, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($12, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($13, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($37, $7, $8, $9, $10, $11, $12, $13);
      var $38=(($37+64)|0);
      var $39=(($38)|0)==(($35)|0);
      if ($39) { __label__ = 2; break; } else { var $37 = $38;__label__ = 1; break; }
    case 2: // $40
      var $41=(($21+212)|0);
      var $42=(($41)|0);
      var $43=(($42+192)|0);
      var $45 = $42;__label__ = 3; break;
    case 3: // $44
      var $45;
      __ZN10input_codeC1ERKS_($14, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($15, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($16, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($17, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($18, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($19, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($20, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($45, $14, $15, $16, $17, $18, $19, $20);
      var $46=(($45+64)|0);
      var $47=(($46)|0)==(($43)|0);
      if ($47) { __label__ = 4; break; } else { var $45 = $46;__label__ = 3; break; }
    case 4: // $48
      var $49=(($21+404)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($21+20)|0);
      var $51=(($50)|0);
      var $52=(($21+212)|0);
      var $53=(($52)|0);
      var $54=$53;
      var $55=$standard;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $55>>2, $$dest = $54>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $56=$51;
      var $57=$53;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $57>>2, $$dest = $56>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seq["X"]=1;

function __ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seqS3_S3_($this, $_type, $_group, $_player, $_token, $_name, $standard, $decrement, $increment) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7=__stackBase__;
      var $8=__stackBase__+4;
      var $9=__stackBase__+8;
      var $10=__stackBase__+12;
      var $11=__stackBase__+16;
      var $12=__stackBase__+20;
      var $13=__stackBase__+24;
      var $14=__stackBase__+28;
      var $15=__stackBase__+32;
      var $16=__stackBase__+36;
      var $17=__stackBase__+40;
      var $18=__stackBase__+44;
      var $19=__stackBase__+48;
      var $20=__stackBase__+52;
      $1=$this;
      $2=$_type;
      $3=$_group;
      $4=$_player;
      $5=$_token;
      $6=$_name;
      var $21=$1;
      var $22=(($21)|0);
      var $23=$2;
      HEAP32[(($22)>>2)]=$23;
      var $24=(($21+4)|0);
      var $25=$3;
      HEAP32[(($24)>>2)]=$25;
      var $26=(($21+8)|0);
      var $27=$4;
      var $28=(($27) & 255);
      HEAP8[($26)]=$28;
      var $29=(($21+12)|0);
      var $30=$5;
      HEAP32[(($29)>>2)]=$30;
      var $31=(($21+16)|0);
      var $32=$6;
      HEAP32[(($31)>>2)]=$32;
      var $33=(($21+20)|0);
      var $34=(($33)|0);
      var $35=(($34+192)|0);
      var $37 = $34;__label__ = 1; break;
    case 1: // $36
      var $37;
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($9, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($10, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($11, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($12, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($13, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($37, $7, $8, $9, $10, $11, $12, $13);
      var $38=(($37+64)|0);
      var $39=(($38)|0)==(($35)|0);
      if ($39) { __label__ = 2; break; } else { var $37 = $38;__label__ = 1; break; }
    case 2: // $40
      var $41=(($21+212)|0);
      var $42=(($41)|0);
      var $43=(($42+192)|0);
      var $45 = $42;__label__ = 3; break;
    case 3: // $44
      var $45;
      __ZN10input_codeC1ERKS_($14, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($15, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($16, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($17, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($18, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($19, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($20, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($45, $14, $15, $16, $17, $18, $19, $20);
      var $46=(($45+64)|0);
      var $47=(($46)|0)==(($43)|0);
      if ($47) { __label__ = 4; break; } else { var $45 = $46;__label__ = 3; break; }
    case 4: // $48
      var $49=(($21+404)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($21+20)|0);
      var $51=(($50)|0);
      var $52=(($21+212)|0);
      var $53=(($52)|0);
      var $54=$53;
      var $55=$standard;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $55>>2, $$dest = $54>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $56=$51;
      var $57=$53;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $57>>2, $$dest = $56>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $58=(($21+20)|0);
      var $59=(($58+64)|0);
      var $60=(($21+212)|0);
      var $61=(($60+64)|0);
      var $62=$61;
      var $63=$increment;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $63>>2, $$dest = $62>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $64=$59;
      var $65=$61;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $65>>2, $$dest = $64>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $66=(($21+20)|0);
      var $67=(($66+128)|0);
      var $68=(($21+212)|0);
      var $69=(($68+128)|0);
      var $70=$69;
      var $71=$decrement;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $71>>2, $$dest = $70>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $72=$67;
      var $73=$69;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $73>>2, $$dest = $72>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seqS3_S3_["X"]=1;

function __ZN20resource_pool_objectI20input_setting_configEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI20input_setting_configEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI20input_setting_configEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 36);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI20input_setting_configE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI20input_setting_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI20input_setting_configED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI18input_field_configEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18input_field_configEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18input_field_configEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 456);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18input_field_configE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18input_field_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18input_field_configED2Ev($2);
  ;
  return;
}


function __Z22ioconfig_alloc_settingR18input_field_configjPKc($field, $value, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      $9=$field;
      $10=$value;
      $11=$name;
      var $14=$9;
      var $15=__ZN18input_field_config11settinglistEv($14);
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=36;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($6)>>2)]=4881;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$9;
      var $56=$10;
      var $57=$11;
      var $58=(function() { try { __THREW__ = false; return __Z28input_port_string_from_tokenPKc($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $59
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN20input_setting_configC1ER18input_field_configjPKc]($54, $55, $56, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $60
      var $61=__ZN13resource_pool10add_objectI20input_setting_configEEPT_S3_(_global_resource_pool, $54);
      var $62=__ZN11simple_listI20input_setting_configE6appendERS0_($15, $61);
      STACKTOP = __stackBase__;
      return $62;
    case 10: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      $12=$65;
      var $66=$64.f1;
      $13=$66;
      var $67=$1;
      var $68=$2;
      var $69=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=4881;
      var $70=HEAP32[(($1)>>2)];
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $72
      var $73=HEAP32[(($1)>>2)];
      var $74=HEAP32[(($2)>>2)];
      var $75=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($73, $74, $75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $76=$1;
      var $77=$2;
      var $78=$3;
      __label__ = 14; break;
    case 14: // $79
      __label__ = 15; break;
    case 15: // $80
      var $81=$12;
      var $82=$12;
      var $83=$13;
      var $84=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $82, tempValue);
      var $85=($84.f1 = $83, $84);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $86
      var $87=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22ioconfig_alloc_settingR18input_field_configjPKc["X"]=1;

function __ZN13resource_pool10add_objectI20input_setting_configEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI20input_setting_configEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI20input_setting_configEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI20input_setting_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI20input_setting_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI20input_setting_configED0Ev["X"]=1;

function __ZN20resource_pool_objectI20input_setting_configED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI20input_setting_configE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18input_field_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18input_field_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18input_field_configED0Ev["X"]=1;

function __ZN11simple_listI17input_port_configE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+8)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+8)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI23input_field_diplocationE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+68)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+68)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+68)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+68)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI23input_field_diplocationE6detachERS0_["X"]=1;

function __ZN11simple_listI18input_field_configE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+404)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+404)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+404)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+404)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI18input_field_configE6detachERS0_["X"]=1;

function __ZN18input_field_configD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18input_field_configD2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI17input_port_configEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17input_port_configEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17input_port_configEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 104);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17input_port_configE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17input_port_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17input_port_configED2Ev($2);
  ;
  return;
}


function __ZN17input_port_configD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN17input_port_configD2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP17input_port_configE15add_unique_hashEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z22tagmap_add_unique_hashP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN11simple_listI23input_field_diplocationE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI23input_field_diplocationE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI23input_field_diplocationED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI23input_field_diplocationE+8)|0);
  __ZN11simple_listI23input_field_diplocationE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI20input_setting_configED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI20input_setting_configE+8)|0);
  __ZN11simple_listI20input_setting_configE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI20input_setting_configE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI20input_setting_configE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18input_field_configED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI18input_field_configE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN18input_field_configD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18input_field_configED2Ev["X"]=1;

function __ZN18input_field_configD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+436)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI23input_field_diplocationED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+416)|0);
      __ZN11simple_listI20input_setting_configED1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+416)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI20input_setting_configED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI17input_port_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17input_port_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17input_port_configED0Ev["X"]=1;

function __ZN20resource_pool_objectI17input_port_configED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI17input_port_configE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN17input_port_configD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17input_port_configED2Ev["X"]=1;

function __ZN17input_port_configD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+36)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+16)|0);
      __ZN11simple_listI18input_field_configED1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+16)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI18input_field_configED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI23input_field_diplocationED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI23input_field_diplocationED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI23input_field_diplocationED0Ev["X"]=1;

function __ZN11simple_listI20input_setting_configE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+32)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+32)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+32)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+32)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI20input_setting_configE6detachERS0_["X"]=1;

function __ZN11simple_listI23input_field_diplocationEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI23input_field_diplocationE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI20input_setting_configEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI20input_setting_configE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI18input_field_configEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI18input_field_configE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11simple_listI17input_port_configE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI20input_setting_configE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI20input_setting_configE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8delegateIFfRK18input_field_configfEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIfRK18input_field_configf8_noparamS3_EC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIfRK18input_field_configf8_noparamS3_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvRK18input_field_configPvjjEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvRK18input_field_configPvjjEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvRK18input_field_configPvjjEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFjRK18input_field_configPvEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_EC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI18input_field_configED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI18input_field_configE+8)|0);
  __ZN11simple_listI18input_field_configE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI18input_field_configE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI18input_field_configE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFviP14_xml_data_nodeEEC2I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I15running_machineEEN15delegate_traitsIT_viS1_S2_S2_E20static_ref_func_typeEPKcPS7_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I15running_machineEEN15delegate_traitsIT_viS1_S2_S2_E20static_ref_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=128;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI15running_machine, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvvEEC2I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I15running_machineEEN15delegate_traitsIT_vS0_S0_S0_S0_E20static_ref_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I15running_machineEEN15delegate_traitsIT_vS0_S0_S0_S0_E20static_ref_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=130;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI15running_machine, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI19_input_port_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI19_input_port_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI19_input_port_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 7492);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI19_input_port_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI19_input_port_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI19_input_port_privateED2Ev($2);
  ;
  return;
}


function __ZN19_input_port_privateD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19_input_port_privateD2Ev($2);
  ;
  return;
}


function __ZN19_input_port_privateD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  __ZN11simple_listI16input_type_entryED1Ev($3);
  ;
  return;
}


function __ZN11simple_listI16input_type_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI16input_type_entryED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI20input_setting_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI20input_setting_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI20input_setting_configED0Ev["X"]=1;

function __ZN11simple_listI18input_field_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI18input_field_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI18input_field_configED0Ev["X"]=1;

function __ZN20resource_pool_objectI19_input_port_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19_input_port_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI19_input_port_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI19_input_port_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI19_input_port_privateE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN19_input_port_privateD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI19_input_port_privateED2Ev["X"]=1;

function __ZN11simple_listI16input_type_entryE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+404)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+404)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+404)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+404)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI16input_type_entryE6detachERS0_["X"]=1;

function __ZL11tagmap_hashPKc451($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI8device_tE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI16input_type_entryED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI16input_type_entryE+8)|0);
  __ZN11simple_listI16input_type_entryE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI16input_type_entryE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI16input_type_entryE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16input_type_entryE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI16input_type_entryE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectI16input_type_entryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16input_type_entryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16input_type_entryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 408);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16input_type_entryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16input_type_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16input_type_entryED2Ev($2);
  ;
  return;
}


function __ZNK8tagmap_tIP17input_port_configE14find_hash_onlyEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL21tagmap_find_hash_onlyPK7_tagmapPKc450($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZL21tagmap_find_hash_onlyPK7_tagmapPKc450($map, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fullhash;
      var $entry;
      $2=$map;
      $3=$tag;
      var $4=$3;
      var $5=__ZL11tagmap_hashPKc451($4);
      $fullhash=$5;
      var $6=$fullhash;
      var $7=(($6)>>>0)%97;
      var $8=$2;
      var $9=(($8)|0);
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $entry=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$entry;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $15
      var $16=$entry;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$fullhash;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$entry;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      $1=$24;
      __label__ = 7; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$entry;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $entry=$29;
      __label__ = 1; break;
    case 6: // $30
      $1=0;
      __label__ = 7; break;
    case 7: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23inputx_postn_coded_rateR15running_machinePKcj8attotime($machine, $text, $text_len, $rate) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $rate; $rate = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($rate)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($rate+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($rate+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $i;
      var $j;
      var $key_len;
      var $increment;
      var $ch;
      var $4=__stackBase__;
      $1=$machine;
      $2=$text;
      $3=$text_len;
      $i=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$3;
      var $8=(($6)>>>0) < (($7)>>>0);
      if ($8) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $9
      var $10=$i;
      var $11=$2;
      var $12=(($11+$10)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      $ch=$14;
      $increment=1;
      var $15=$ch;
      var $16=(($15)|0)==123;
      if ($16) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $17
      $j=0;
      __label__ = 4; break;
    case 4: // $18
      var $19=$j;
      var $20=(($19)>>>0) < 28;
      if ($20) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $21
      var $22=$j;
      var $23=((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+($22<<3))|0);
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=_strlen($25);
      $key_len=$26;
      var $27=$i;
      var $28=$key_len;
      var $29=(($27+$28)|0);
      var $30=(($29+2)|0);
      var $31=$3;
      var $32=(($30)>>>0) <= (($31)>>>0);
      if ($32) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $33
      var $34=$j;
      var $35=((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+($34<<3))|0);
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$i;
      var $39=(($38+1)|0);
      var $40=$2;
      var $41=(($40+$39)|0);
      var $42=$key_len;
      var $43=_memcmp($37, $41, $42);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 7: // $45
      var $46=$i;
      var $47=$key_len;
      var $48=(($46+$47)|0);
      var $49=(($48+1)|0);
      var $50=$2;
      var $51=(($50+$49)|0);
      var $52=HEAP8[($51)];
      var $53=(($52 << 24) >> 24);
      var $54=(($53)|0)==125;
      if ($54) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $55
      var $56=$j;
      var $57=((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+($56<<3))|0);
      var $58=(($57+4)|0);
      var $59=HEAP32[(($58)>>2)];
      $ch=$59;
      var $60=$key_len;
      var $61=(($60+2)|0);
      $increment=$61;
      __label__ = 9; break;
    case 9: // $62
      __label__ = 10; break;
    case 10: // $63
      __label__ = 11; break;
    case 11: // $64
      var $65=$j;
      var $66=(($65+1)|0);
      $j=$66;
      __label__ = 4; break;
    case 12: // $67
      __label__ = 13; break;
    case 13: // $68
      var $69=$ch;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $71
      var $72=$1;
      var $73=$ch;
      var $74=$4;
      var $75=$rate;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($74)>>2)]=HEAP32[(($75)>>2)];HEAP32[(($74+4)>>2)]=HEAP32[(($75+4)>>2)];HEAP32[(($74+8)>>2)]=HEAP32[(($75+8)>>2)];
      __ZL17inputx_postc_rateR15running_machinej8attotime($72, $73, $4);
      __label__ = 15; break;
    case 15: // $76
      var $77=$increment;
      var $78=$i;
      var $79=(($78+$77)|0);
      $i=$79;
      __label__ = 1; break;
    case 16: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23inputx_postn_coded_rateR15running_machinePKcj8attotime["X"]=1;

function __ZN26_input_field_user_settingsC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      $1=$this;
      var $9=$1;
      var $10=(($9+4)|0);
      var $11=(($10)|0);
      var $12=(($11+192)|0);
      var $14 = $11;__label__ = 1; break;
    case 1: // $13
      var $14;
      __ZN10input_codeC1ERKS_($2, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($3, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($14, $2, $3, $4, $5, $6, $7, $8);
      var $15=(($14+64)|0);
      var $16=(($15)|0)==(($12)|0);
      if ($16) { __label__ = 2; break; } else { var $14 = $15;__label__ = 1; break; }
    case 2: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16input_type_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI16input_type_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI16input_type_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI16input_type_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16input_type_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16input_type_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI16input_type_entryED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI16input_type_entryE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17code_point_stringR15running_machinej($machine, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $code=__stackBase__;
      var $tempstr=__stackBase__+4;
      var $3;
      var $4;
      var $5=__stackBase__+68;
      $1=$machine;
      $2=$ch;
      $result=((__ZZL17code_point_stringR15running_machinejE3buf)|0);
      var $6=$2;
      if ($6 == 0) {
        __label__ = 1; break;
      }
      else if ($6 == 13) {
        __label__ = 2; break;
      }
      else if ($6 == 10) {
        __label__ = 3; break;
      }
      else if ($6 == 9) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $7
      var $8=_strcpy(((__ZZL17code_point_stringR15running_machinejE3buf)|0), ((STRING_TABLE.__str1369)|0));
      __label__ = 21; break;
    case 2: // $9
      var $10=_strcpy(((__ZZL17code_point_stringR15running_machinejE3buf)|0), ((STRING_TABLE.__str1370)|0));
      __label__ = 21; break;
    case 3: // $11
      var $12=_strcpy(((__ZZL17code_point_stringR15running_machinejE3buf)|0), ((STRING_TABLE.__str1371)|0));
      __label__ = 21; break;
    case 4: // $13
      var $14=_strcpy(((__ZZL17code_point_stringR15running_machinejE3buf)|0), ((STRING_TABLE.__str1372)|0));
      __label__ = 21; break;
    case 5: // $15
      var $16=$2;
      var $17=(($16)>>>0) >= 32;
      if ($17) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $18
      var $19=$2;
      var $20=(($19)>>>0) < 128;
      if ($20) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $21
      var $22=$2;
      var $23=(($22) & 255);
      HEAP8[(((__ZZL17code_point_stringR15running_machinejE3buf)|0))]=$23;
      HEAP8[(((__ZZL17code_point_stringR15running_machinejE3buf+1)|0))]=0;
      __label__ = 18; break;
    case 8: // $24
      var $25=$2;
      var $26=(($25)>>>0) >= 1048578;
      if ($26) { __label__ = 9; break; } else { __label__ = 16; break; }
    case 9: // $27
      var $28=$2;
      var $29=(($28-1048578)|0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($code, 1, 0, 1, 0, $29);
      __ZN7astringC1Ev($tempstr);
      var $30=$1;
      var $31=(function() { try { __THREW__ = false; return __ZNK15running_machine5inputEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 14; break; };
    case 10: // $32
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($5, $code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $33
      var $34=(function() { try { __THREW__ = false; return __ZNK13input_manager9code_nameER7astring10input_code($31, $tempstr, $5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $35
      var $36=(function() { try { __THREW__ = false; return _snprintf(((__ZZL17code_point_stringR15running_machinejE3buf)|0), 16, ((STRING_TABLE.__str1373)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $37
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      __label__ = 17; break;
    case 14: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $3=$40;
      var $41=$39.f1;
      $4=$41;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $42
      __label__ = 22; break;
    case 16: // $43
      HEAP8[(((__ZZL17code_point_stringR15running_machinejE3buf)|0))]=0;
      __label__ = 17; break;
    case 17: // $44
      __label__ = 18; break;
    case 18: // $45
      var $46=HEAP8[(((__ZZL17code_point_stringR15running_machinejE3buf)|0))];
      var $47=(($46 << 24) >> 24);
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $49
      var $50=$2;
      var $51=_snprintf(((__ZZL17code_point_stringR15running_machinejE3buf)|0), 16, ((STRING_TABLE.__str1374)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$50,tempInt));
      __label__ = 20; break;
    case 20: // $52
      __label__ = 21; break;
    case 21: // $53
      var $54=$result;
      STACKTOP = __stackBase__;
      return $54;
    case 22: // $55
      var $56=$3;
      var $57=$3;
      var $58=$4;
      var $59=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $57, tempValue);
      var $60=($59.f1 = $58, $59);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17code_point_stringR15running_machinej["X"]=1;

function __ZneRK8attotimeS1_($left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)!=(($8)|0);
      if ($9) { var $19 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11+4)|0);
      var $st$2$0=(($12)|0);
      var $13$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($12+4)|0);
      var $13$1=HEAP32[(($st$2$1)>>2)];
      var $14=$2;
      var $15=(($14+4)|0);
      var $st$8$0=(($15)|0);
      var $16$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$8$1)>>2)];
      var $17=$13$0 != $16$0 || $13$1 != $16$1;
      var $19 = $17;__label__ = 2; break;
    case 2: // $18
      var $19;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9find_codeP12_inputx_codej($codes, $ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $i;
      $2=$codes;
      $3=$ch;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      $i=0;
      __label__ = 3; break;
    case 3: // $6
      var $7=$i;
      var $8=$2;
      var $9=(($8+$7*12)|0);
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $13
      var $14=$i;
      var $15=$2;
      var $16=(($15+$14*12)|0);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$3;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=$i;
      var $23=$2;
      var $24=(($23+$22*12)|0);
      $1=$24;
      __label__ = 9; break;
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$i;
      var $28=(($27+1)|0);
      $i=$28;
      __label__ = 3; break;
    case 8: // $29
      $1=0;
      __label__ = 9; break;
    case 9: // $30
      var $31=$1;
      ;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15clear_keybufferR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  var $portdata;
  $1=$machine;
  var $2=$1;
  var $3=(($2+644)|0);
  var $4=HEAP32[(($3)>>2)];
  $portdata=$4;
  var $5=$portdata;
  var $6=(($5+7460)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=$portdata;
  var $8=(($7+7468)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=$portdata;
  var $10=(($9+7456)|0);
  HEAP32[(($10)>>2)]=0;
  ;
  return;
}


function __ZL17inputx_postn_rateR15running_machinePKjj8attotime($machine, $text, $text_len, $rate) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $rate; $rate = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($rate)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($rate+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($rate+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $portdata;
      var $last_cr;
      var $ch=__stackBase__;
      var $s;
      var $ci;
      var $code;
      $1=$machine;
      $2=$text;
      $3=$text_len;
      var $4=$1;
      var $5=(($4+644)|0);
      var $6=HEAP32[(($5)>>2)];
      $portdata=$6;
      $last_cr=0;
      var $7=$portdata;
      var $8=(($7+7480)|0);
      var $9=$8;
      var $10=$rate;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[(($10+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[(($10+8)>>2)];
      var $11=$1;
      var $12=__Z15inputx_can_postR15running_machine($11);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 24; break; }
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16)>>>0) > 0;
      if ($17) { __label__ = 3; break; } else { var $24 = 0;__label__ = 4; break; }
    case 3: // $18
      var $19=$1;
      var $20=__ZL11buffer_fullR15running_machine($19);
      var $21=(($20)|0)!=0;
      var $22=$21 ^ 1;
      var $24 = $22;__label__ = 4; break;
    case 4: // $23
      var $24;
      if ($24) { __label__ = 5; break; } else { __label__ = 23; break; }
    case 5: // $25
      var $26=$2;
      var $27=(($26+4)|0);
      $2=$27;
      var $28=HEAP32[(($26)>>2)];
      HEAP32[(($ch)>>2)]=$28;
      var $29=$3;
      var $30=(($29-1)|0);
      $3=$30;
      var $31=HEAP32[(($ch)>>2)];
      var $32=(($31)|0)!=10;
      if ($32) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $34=$last_cr;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 21; break; } else { __label__ = 7; break; }
    case 7: // $36
      var $37=HEAP32[(($ch)>>2)];
      var $38=(($37)|0)==10;
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      HEAP32[(($ch)>>2)]=13;
      __label__ = 10; break;
    case 9: // $40
      var $41=HEAP32[(($ch)>>2)];
      var $42=(($41)|0)==13;
      var $43=(($42)&1);
      $last_cr=$43;
      __label__ = 10; break;
    case 10: // $44
      var $45=$1;
      var $46=HEAP32[(($ch)>>2)];
      var $47=__ZL21can_post_key_directlyR15running_machinej($45, $46);
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $49
      var $50=$1;
      var $51=HEAP32[(($ch)>>2)];
      __ZL17internal_post_keyR15running_machinej($50, $51);
      __label__ = 20; break;
    case 12: // $52
      var $53=$1;
      var $54=HEAP32[(($ch)>>2)];
      var $55=__ZL22can_post_key_alternateR15running_machinej($53, $54);
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $57
      var $58=HEAP32[(($ch)>>2)];
      var $59=__ZL13find_charinfoj($58);
      $ci=$59;
      __label__ = 14; break;
    case 14: // $60
      __label__ = 15; break;
    case 15: // $61
      var $62=$ci;
      var $63=(($62+8)|0);
      var $64=HEAP32[(($63)>>2)];
      $s=$64;
      __label__ = 16; break;
    case 16: // $65
      var $66=$s;
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24)!=0;
      if ($68) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $69
      var $70=$s;
      var $71=$s;
      var $72=_strlen($71);
      var $73=__Z15uchar_from_utf8PjPKcj($ch, $70, $72);
      var $74=$s;
      var $75=(($74+$73)|0);
      $s=$75;
      var $76=$1;
      var $77=HEAP32[(($ch)>>2)];
      __ZL17internal_post_keyR15running_machinej($76, $77);
      __label__ = 16; break;
    case 18: // $78
      __label__ = 19; break;
    case 19: // $79
      __label__ = 20; break;
    case 20: // $80
      __label__ = 22; break;
    case 21: // $81
      $last_cr=0;
      __label__ = 22; break;
    case 22: // $82
      __label__ = 2; break;
    case 23: // $83
      __label__ = 24; break;
    case 24: // $84
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17inputx_postn_rateR15running_machinePKjj8attotime["X"]=1;

function __ZL11buffer_fullR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  var $keybuf;
  $1=$machine;
  var $2=$1;
  var $3=__ZL10get_bufferR15running_machine($2);
  $keybuf=$3;
  var $4=$keybuf;
  var $5=(($4+4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+1)|0);
  var $8=(($7)>>>0)%4096;
  var $9=$keybuf;
  var $10=(($9)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($8)|0)==(($11)|0);
  var $13=(($12)&1);
  ;
  return $13;
}


function __ZL21can_post_key_directlyR15running_machinej($machine, $ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $rc;
      var $code;
      $1=$machine;
      $2=$ch;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      $rc=0;
      var $6=$portdata;
      var $7=(($6+7468)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $10
      var $11=$portdata;
      var $12=(($11+7472)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$portdata;
      var $17=(($16+7472)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$1;
      var $20=$2;
      var $21=FUNCTION_TABLE[$18]($19, $20);
      var $24 = $21;__label__ = 4; break;
    case 3: // $22
      var $24 = 1;__label__ = 4; break;
    case 4: // $23
      var $24;
      $rc=$24;
      __label__ = 8; break;
    case 5: // $25
      var $26=$portdata;
      var $27=(($26+7456)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=__ZL9find_codeP12_inputx_codej($28, $29);
      $code=$30;
      var $31=$code;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      var $34=$code;
      var $35=(($34+4)|0);
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      var $39=(($38)&1);
      $rc=$39;
      __label__ = 7; break;
    case 7: // $40
      __label__ = 8; break;
    case 8: // $41
      var $42=$rc;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21can_post_key_directlyR15running_machinej["X"]=1;

function __ZL17internal_post_keyR15running_machinej($machine, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $keybuf;
      var $3=__stackBase__;
      var $4=__stackBase__+12;
      $1=$machine;
      $2=$ch;
      var $5=$1;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      $portdata=$7;
      var $8=$1;
      var $9=__ZL10get_bufferR15running_machine($8);
      $keybuf=$9;
      var $10=$keybuf;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$keybuf;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0)==(($15)|0);
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$portdata;
      var $19=(($18+7464)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$portdata;
      var $22=$2;
      __ZL12choose_delayP19_input_port_privatej($3, $21, $22);
      var $23=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($23)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($23+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($23+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($20, $3, 0, $4);
      var $24=$keybuf;
      var $25=$24;
      var $26=(($25+8)|0);
      var $27=$26;
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & -2;
      HEAP32[(($27)>>2)]=$29;
      __label__ = 2; break;
    case 2: // $30
      var $31=$2;
      var $32=$keybuf;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      HEAP32[(($33)>>2)]=$35;
      var $36=$keybuf;
      var $37=(($36+12)|0);
      var $38=(($37+($34<<2))|0);
      HEAP32[(($38)>>2)]=$31;
      var $39=$keybuf;
      var $40=(($39+4)|0);
      var $41=HEAPU32[(($40)>>2)];
      var $42=(($41)>>>0)%4096;
      HEAP32[(($40)>>2)]=$42;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17internal_post_keyR15running_machinej["X"]=1;

function __ZL22can_post_key_alternateR15running_machinej($machine, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $s;
      var $ci;
      var $uchar=__stackBase__;
      var $rc;
      $2=$machine;
      $3=$ch;
      var $4=$3;
      var $5=__ZL13find_charinfoj($4);
      $ci=$5;
      var $6=$ci;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$ci;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      $s=$14;
      var $15=$s;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $17
      $1=0;
      __label__ = 13; break;
    case 5: // $18
      __label__ = 6; break;
    case 6: // $19
      var $20=$s;
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24)!=0;
      if ($22) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $23
      var $24=$s;
      var $25=$s;
      var $26=_strlen($25);
      var $27=__Z15uchar_from_utf8PjPKcj($uchar, $24, $26);
      $rc=$27;
      var $28=$rc;
      var $29=(($28)|0) <= 0;
      if ($29) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $30
      $1=0;
      __label__ = 13; break;
    case 9: // $31
      var $32=$2;
      var $33=HEAP32[(($uchar)>>2)];
      var $34=__ZL21can_post_key_directlyR15running_machinej($32, $33);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $36
      $1=0;
      __label__ = 13; break;
    case 11: // $37
      var $38=$rc;
      var $39=$s;
      var $40=(($39+$38)|0);
      $s=$40;
      __label__ = 6; break;
    case 12: // $41
      $1=1;
      __label__ = 13; break;
    case 13: // $42
      var $43=$1;
      STACKTOP = __stackBase__;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22can_post_key_alternateR15running_machinej["X"]=1;

function __ZL12choose_delayP19_input_port_privatej($agg_result, $portdata, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $delay=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $5=__stackBase__+36;
      $1=$portdata;
      $2=$ch;
      var $6=$1;
      var $7=(($6+7480)|0);
      var $8=__ZneRK8attotimeS1_($7, __ZN8attotime4zeroE);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+7480)|0);
      var $12=$agg_result;
      var $13=$11;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
      __label__ = 9; break;
    case 2: // $14
      var $15=$delay;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($15+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $16=$1;
      var $17=(($16+7468)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $$emscripten$temp$0$0=10;
      var $$emscripten$temp$0$1=0;
      __ZN8attotime9from_msecEx($3, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $21=$delay;
      var $22=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($21)>>2)]=HEAP32[(($22)>>2)];HEAP32[(($21+4)>>2)]=HEAP32[(($22+4)>>2)];HEAP32[(($21+8)>>2)]=HEAP32[(($22+8)>>2)];
      __label__ = 8; break;
    case 4: // $23
      var $24=$2;
      if ($24 == 13) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 5: // $25
      var $$emscripten$temp$1$0=200;
      var $$emscripten$temp$1$1=0;
      __ZN8attotime9from_msecEx($4, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      var $26=$delay;
      var $27=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[(($27)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[(($27+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[(($27+8)>>2)];
      __label__ = 7; break;
    case 6: // $28
      var $$emscripten$temp$2$0=50;
      var $$emscripten$temp$2$1=0;
      __ZN8attotime9from_msecEx($5, $$emscripten$temp$2$0, $$emscripten$temp$2$1);
      var $29=$delay;
      var $30=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($29)>>2)]=HEAP32[(($30)>>2)];HEAP32[(($29+4)>>2)]=HEAP32[(($30+4)>>2)];HEAP32[(($29+8)>>2)]=HEAP32[(($30+8)>>2)];
      __label__ = 7; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      var $33=$agg_result;
      var $34=$delay;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($33)>>2)]=HEAP32[(($34)>>2)];HEAP32[(($33+4)>>2)]=HEAP32[(($34+4)>>2)];HEAP32[(($33+8)>>2)]=HEAP32[(($34+8)>>2)];
      __label__ = 9; break;
    case 9: // $35
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12choose_delayP19_input_port_privatej["X"]=1;

function __ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($this, $callback, $name, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  $1=$this;
  $2=$callback;
  $3=$name;
  $4=$ptr;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=__ZNK16device_scheduler7machineEv($6);
  __ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_($5, $7, $8, $9);
  var $10=$4;
  var $11=__ZN16device_scheduler11timer_allocE8delegateIFvPviEES1_($6, $5, $10);
  STACKTOP = __stackBase__;
  return $11;
}


function __ZL16inputx_timerprocR15running_machinePvi($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $portdata;
      var $keybuf;
      var $delay=__stackBase__;
      var $4=__stackBase__+12;
      var $5=__stackBase__+24;
      var $6=__stackBase__+36;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $7=$1;
      var $8=(($7+644)|0);
      var $9=HEAP32[(($8)>>2)];
      $portdata=$9;
      __ZN8attotimeC1Ev($delay);
      var $10=$1;
      var $11=__ZL10get_bufferR15running_machine($10);
      $keybuf=$11;
      var $12=$portdata;
      var $13=(($12+7468)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $16
      __label__ = 2; break;
    case 2: // $17
      var $18=$keybuf;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$keybuf;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($20)|0)!=(($23)|0);
      if ($24) { __label__ = 3; break; } else { var $39 = 0;__label__ = 4; break; }
    case 3: // $25
      var $26=$portdata;
      var $27=(($26+7468)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$1;
      var $30=$keybuf;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$keybuf;
      var $34=(($33+12)|0);
      var $35=(($34+($32<<2))|0);
      var $36=FUNCTION_TABLE[$28]($29, $35, 1);
      var $37=(($36)|0)!=0;
      var $39 = $37;__label__ = 4; break;
    case 4: // $38
      var $39;
      if ($39) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $40
      var $41=$keybuf;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+1)|0);
      HEAP32[(($42)>>2)]=$44;
      var $45=$keybuf;
      var $46=(($45)|0);
      var $47=HEAPU32[(($46)>>2)];
      var $48=(($47)>>>0)%4096;
      HEAP32[(($46)>>2)]=$48;
      var $49=$portdata;
      var $50=(($49+7480)|0);
      var $51=__ZneRK8attotimeS1_($50, __ZN8attotime4zeroE);
      if ($51) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $52
      __label__ = 8; break;
    case 7: // $53
      __label__ = 2; break;
    case 8: // $54
      __label__ = 13; break;
    case 9: // $55
      var $56=$keybuf;
      var $57=$56;
      var $58=(($57+8)|0);
      var $59=$58;
      var $60=HEAP32[(($59)>>2)];
      var $61=$60 & 1;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $63
      var $64=$keybuf;
      var $65=$64;
      var $66=(($65+8)|0);
      var $67=$66;
      var $68=HEAP32[(($67)>>2)];
      var $69=$68 & -2;
      HEAP32[(($67)>>2)]=$69;
      var $70=$keybuf;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+1)|0);
      HEAP32[(($71)>>2)]=$73;
      var $74=$keybuf;
      var $75=(($74)|0);
      var $76=HEAPU32[(($75)>>2)];
      var $77=(($76)>>>0)%4096;
      HEAP32[(($75)>>2)]=$77;
      __label__ = 12; break;
    case 11: // $78
      var $79=$keybuf;
      var $80=$79;
      var $81=(($80+8)|0);
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=$83 & -2;
      var $85=$84 | 1;
      HEAP32[(($82)>>2)]=$85;
      __label__ = 12; break;
    case 12: // $86
      __label__ = 13; break;
    case 13: // $87
      var $88=$keybuf;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$keybuf;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($90)|0)!=(($93)|0);
      if ($94) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $95
      var $96=$portdata;
      var $97=$keybuf;
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$keybuf;
      var $101=(($100+12)|0);
      var $102=(($101+($99<<2))|0);
      var $103=HEAP32[(($102)>>2)];
      __ZL12choose_delayP19_input_port_privatej($4, $96, $103);
      var $104=$delay;
      var $105=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($104)>>2)]=HEAP32[(($105)>>2)];HEAP32[(($104+4)>>2)]=HEAP32[(($105+4)>>2)];HEAP32[(($104+8)>>2)]=HEAP32[(($105+8)>>2)];
      var $106=$portdata;
      var $107=(($106+7464)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$5;
      var $110=$delay;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($109)>>2)]=HEAP32[(($110)>>2)];HEAP32[(($109+4)>>2)]=HEAP32[(($110+4)>>2)];HEAP32[(($109+8)>>2)]=HEAP32[(($110+8)>>2)];
      var $111=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($111+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($111+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($108, $5, 0, $6);
      __label__ = 15; break;
    case 15: // $112
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16inputx_timerprocR15running_machinePvi["X"]=1;

function __ZN20resource_pool_objectI11_key_bufferEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11_key_bufferEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11_key_bufferEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 16396);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11_key_bufferE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11_key_bufferED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11_key_bufferED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectI11_key_bufferEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11_key_bufferEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11_key_bufferEEPT_S3_["X"]=1;

function __ZN8attotimeC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$$emscripten$temp$0$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$$emscripten$temp$0$1;
  ;
  return;
}


function __ZL17get_keyboard_codePK18input_field_configi($field, $i) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ch;
      $1=$field;
      $2=$i;
      var $3=$2;
      var $4=$1;
      var $5=(($4+388)|0);
      var $6=(($5+($3<<2))|0);
      var $7=HEAP32[(($6)>>2)];
      $ch=$7;
      var $8=$ch;
      var $9=(($8)>>>0) >= 4294967168;
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$ch;
      var $12=(($11)>>>0) <= 4294967295;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$ch;
      var $15=$14 & 255;
      $ch=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$ch;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15running_machine6systemEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+672)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN8attotimeC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8attotimeC2Ev($2);
  ;
  return;
}


function __ZL9scan_keysR15running_machinePK17input_port_configP12_inputx_codePS3_PPK18input_field_configii($machine, $portconfig, $codes, $ports, $shift_ports, $keys, $shift) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $code_count;
      var $port;
      var $field;
      var $code;
      $1=$machine;
      $2=$portconfig;
      $3=$codes;
      $4=$ports;
      $5=$shift_ports;
      $6=$keys;
      $7=$shift;
      $code_count=0;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$2;
      $port=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$port;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 23; break; }
    case 4: // $14
      var $15=$port;
      var $16=__ZNK17input_port_config11first_fieldEv($15);
      $field=$16;
      __label__ = 5; break;
    case 5: // $17
      var $18=$field;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 6; break; } else { __label__ = 21; break; }
    case 6: // $20
      var $21=$field;
      var $22=(($21+24)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)==46;
      if ($24) { __label__ = 7; break; } else { __label__ = 19; break; }
    case 7: // $25
      var $26=$field;
      var $27=$7;
      var $28=__ZL17get_keyboard_codePK18input_field_configi($26, $27);
      $code=$28;
      var $29=$code;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 8: // $31
      var $32=$code;
      var $33=(($32)>>>0) >= 1048576;
      if ($33) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $34
      var $35=$code;
      var $36=(($35)>>>0) <= 1048577;
      if ($36) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $37
      var $38=$field;
      var $39=$6;
      var $40=$5;
      var $41=(($40+($39<<2))|0);
      HEAP32[(($41)>>2)]=$38;
      var $42=$1;
      var $43=$2;
      var $44=$3;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $46
      var $47=$code_count;
      var $48=$3;
      var $49=(($48+$47*12)|0);
      var $52 = $49;__label__ = 13; break;
    case 12: // $50
      var $52 = 0;__label__ = 13; break;
    case 13: // $51
      var $52;
      var $53=$4;
      var $54=$5;
      var $55=$6;
      var $56=(($55+1)|0);
      var $57=$code;
      var $58=(($57-1048576)|0);
      var $59=(($58+1)|0);
      var $60=__ZL9scan_keysR15running_machinePK17input_port_configP12_inputx_codePS3_PPK18input_field_configii($42, $43, $52, $53, $54, $56, $59);
      var $61=$code_count;
      var $62=(($61+$60)|0);
      $code_count=$62;
      __label__ = 17; break;
    case 14: // $63
      var $64=$3;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $66
      var $67=$code_count;
      var $68=$3;
      var $69=(($68+$67*12)|0);
      var $70=(($69+4)|0);
      var $71=(($70)|0);
      var $72=$71;
      var $73=$5;
      var $74=$73;
      var $75=$6;
      var $76=((($75<<2))|0);
      assert($76 % 1 === 0, 'memcpy given ' + $76 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($72, $74, $76, 1);
      var $77=$code;
      var $78=$code_count;
      var $79=$3;
      var $80=(($79+$78*12)|0);
      var $81=(($80)|0);
      HEAP32[(($81)>>2)]=$77;
      var $82=$field;
      var $83=$6;
      var $84=$code_count;
      var $85=$3;
      var $86=(($85+$84*12)|0);
      var $87=(($86+4)|0);
      var $88=(($87+($83<<2))|0);
      HEAP32[(($88)>>2)]=$82;
      __label__ = 16; break;
    case 16: // $89
      var $90=$code_count;
      var $91=(($90+1)|0);
      $code_count=$91;
      __label__ = 17; break;
    case 17: // $92
      __label__ = 18; break;
    case 18: // $93
      __label__ = 19; break;
    case 19: // $94
      __label__ = 20; break;
    case 20: // $95
      var $96=$field;
      var $97=__ZNK18input_field_config4nextEv($96);
      $field=$97;
      __label__ = 5; break;
    case 21: // $98
      __label__ = 22; break;
    case 22: // $99
      var $100=$port;
      var $101=__ZNK17input_port_config4nextEv($100);
      $port=$101;
      __label__ = 3; break;
    case 23: // $102
      var $103=$code_count;
      ;
      return $103;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9scan_keysR15running_machinePK17input_port_configP12_inputx_codePS3_PPK18input_field_configii["X"]=1;

function __ZN19resource_pool_arrayI12_inputx_codeEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI12_inputx_codeEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI12_inputx_codeEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=(($8*12)|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI12_inputx_codeE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI12_inputx_codeED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI12_inputx_codeED2Ev($2);
  ;
  return;
}


function __ZNK15running_machine7optionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+668)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK14machine_config7optionsEv($4);
  ;
  return $5;
}


function __ZNK11emu_options6recordEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str1397)|0));
  ;
  return $4;
}


function __ZNK11emu_options15input_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str1396)|0));
  ;
  return $4;
}


function __ZN20resource_pool_objectI8emu_fileEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI8emu_fileEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI8emu_fileEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 260);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI8emu_fileE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI8emu_fileED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI8emu_fileED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI11_key_bufferED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11_key_bufferED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11_key_bufferED0Ev["X"]=1;

function __ZN20resource_pool_objectI11_key_bufferED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI11_key_bufferE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool9add_arrayI12_inputx_codeEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI12_inputx_codeEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI12_inputx_codeEEPT_S3_i["X"]=1;

function __ZN19resource_pool_arrayI12_inputx_codeED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI12_inputx_codeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI12_inputx_codeED0Ev["X"]=1;

function __ZN19resource_pool_arrayI12_inputx_codeED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayI12_inputx_codeE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI8emu_fileEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8emu_fileEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_["X"]=1;

function __ZL26save_this_input_field_typei($type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$type;
      var $3=$2;
      if ($3 == 1 || $3 == 2 || $3 == 4 || $3 == 6 || $3 == 3) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $4
      $1=0;
      __label__ = 3; break;
    case 2: // $5
      $1=1;
      __label__ = 3; break;
    case 3: // $6
      var $7=$1;
      ;
      return $7;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK14machine_config7optionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11emu_options8playbackEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str1407)|0));
  ;
  return $4;
}


function __ZL19save_default_inputsR15running_machineP14_xml_data_node($machine, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $entry;
      var $seqtype;
      var $portnode;
      var $seqtype1;
      $1=$machine;
      $2=$parentnode;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+4)|0);
      var $8=__ZNK11simple_listI16input_type_entryE5firstEv($7);
      $entry=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$entry;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 22; break; }
    case 2: // $12
      var $13=$entry;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZL26save_this_input_field_typei($15);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $18
      $seqtype=0;
      __label__ = 4; break;
    case 4: // $19
      var $20=$seqtype;
      var $21=(($20)>>>0) < 3;
      if ($21) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $22
      var $23=$seqtype;
      var $24=$entry;
      var $25=(($24+212)|0);
      var $26=(($25+($23<<6))|0);
      var $27=$seqtype;
      var $28=$entry;
      var $29=(($28+20)|0);
      var $30=(($29+($27<<6))|0);
      var $31=__ZNK9input_seqneERKS_($26, $30);
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      __label__ = 9; break;
    case 7: // $33
      __label__ = 8; break;
    case 8: // $34
      var $35=$seqtype;
      var $36=(($35+1)|0);
      $seqtype=$36;
      __label__ = 4; break;
    case 9: // $37
      var $38=$seqtype;
      var $39=(($38)>>>0) < 3;
      if ($39) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $40
      var $41=$2;
      var $42=__Z13xml_add_childP14_xml_data_nodePKcS2_($41, ((STRING_TABLE.__str1408)|0), 0);
      $portnode=$42;
      var $43=$portnode;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $45
      var $46=$portnode;
      var $47=$1;
      var $48=$entry;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$entry;
      var $52=(($51+8)|0);
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=__ZL25input_field_type_to_tokenR15running_machineii($47, $50, $54);
      var $56=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($46, ((STRING_TABLE.__str1410)|0), $55);
      $seqtype1=0;
      __label__ = 12; break;
    case 12: // $57
      var $58=$seqtype1;
      var $59=(($58)>>>0) < 3;
      if ($59) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $60
      var $61=$seqtype1;
      var $62=$entry;
      var $63=(($62+212)|0);
      var $64=(($63+($61<<6))|0);
      var $65=$seqtype1;
      var $66=$entry;
      var $67=(($66+20)|0);
      var $68=(($67+($65<<6))|0);
      var $69=__ZNK9input_seqneERKS_($64, $68);
      if ($69) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $70
      var $71=$1;
      var $72=$portnode;
      var $73=$seqtype1;
      var $74=$entry;
      var $75=(($74)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$seqtype1;
      var $78=$entry;
      var $79=(($78+212)|0);
      var $80=(($79+($77<<6))|0);
      __ZL13save_sequenceR15running_machineP14_xml_data_nodeiiRK9input_seq($71, $72, $73, $76, $80);
      __label__ = 15; break;
    case 15: // $81
      __label__ = 16; break;
    case 16: // $82
      var $83=$seqtype1;
      var $84=(($83+1)|0);
      $seqtype1=$84;
      __label__ = 12; break;
    case 17: // $85
      __label__ = 18; break;
    case 18: // $86
      __label__ = 19; break;
    case 19: // $87
      __label__ = 20; break;
    case 20: // $88
      __label__ = 21; break;
    case 21: // $89
      var $90=$entry;
      var $91=__ZNK16input_type_entry4nextEv($90);
      $entry=$91;
      __label__ = 1; break;
    case 22: // $92
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19save_default_inputsR15running_machineP14_xml_data_node["X"]=1;

function __ZL16save_game_inputsR15running_machineP14_xml_data_node($machine, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $field;
      var $port;
      var $changed;
      var $seqtype;
      var $portnode;
      var $tempbuffer=__stackBase__;
      $1=$machine;
      $2=$parentnode;
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=__ZNK11tagged_listI17input_port_configE5firstEv($4);
      $port=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$port;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 40; break; }
    case 2: // $9
      var $10=$port;
      var $11=__ZNK17input_port_config11first_fieldEv($10);
      $field=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$field;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 38; break; }
    case 4: // $15
      var $16=$field;
      var $17=(($16+24)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZL26save_this_input_field_typei($18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 36; break; }
    case 5: // $21
      $changed=0;
      $seqtype=0;
      __label__ = 6; break;
    case 6: // $22
      var $23=$seqtype;
      var $24=(($23)>>>0) < 3;
      if ($24) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $25
      var $26=$seqtype;
      var $27=$field;
      var $28=(($27+400)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+8)|0);
      var $31=(($30+($26<<6))|0);
      var $32=$seqtype;
      var $33=$field;
      var $34=(($33+44)|0);
      var $35=(($34+($32<<6))|0);
      var $36=__ZNK9input_seqneERKS_($31, $35);
      var $37=(($36)&1);
      var $38=$changed;
      var $39=(($38) & 1);
      var $40=(($39)&1);
      var $41=$40 | $37;
      var $42=(($41)|0)!=0;
      var $43=(($42)&1);
      $changed=$43;
      __label__ = 8; break;
    case 8: // $44
      var $45=$seqtype;
      var $46=(($45+1)|0);
      $seqtype=$46;
      __label__ = 6; break;
    case 9: // $47
      var $48=$field;
      var $49=(($48+400)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $54
      var $55=$field;
      var $56=(($55+400)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+200)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$field;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$59 & $62;
      var $64=$field;
      var $65=(($64+4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$field;
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$66 & $69;
      var $71=(($63)|0)!=(($70)|0);
      var $72=(($71)&1);
      var $73=$changed;
      var $74=(($73) & 1);
      var $75=(($74)&1);
      var $76=$75 | $72;
      var $77=(($76)|0)!=0;
      var $78=(($77)&1);
      $changed=$78;
      __label__ = 12; break;
    case 11: // $79
      var $80=$field;
      var $81=(($80+400)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+32)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$field;
      var $88=(($87+312)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($86)|0)!=(($89)|0);
      var $91=(($90)&1);
      var $92=$changed;
      var $93=(($92) & 1);
      var $94=(($93)&1);
      var $95=$94 | $91;
      var $96=(($95)|0)!=0;
      var $97=(($96)&1);
      $changed=$97;
      var $98=$field;
      var $99=(($98+400)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+36)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$field;
      var $106=(($105+316)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($104)|0)!=(($107)|0);
      var $109=(($108)&1);
      var $110=$changed;
      var $111=(($110) & 1);
      var $112=(($111)&1);
      var $113=$112 | $109;
      var $114=(($113)|0)!=0;
      var $115=(($114)&1);
      $changed=$115;
      var $116=$field;
      var $117=(($116+400)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+24)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$field;
      var $124=(($123+308)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($122)|0)!=(($125)|0);
      var $127=(($126)&1);
      var $128=$changed;
      var $129=(($128) & 1);
      var $130=(($129)&1);
      var $131=$130 | $127;
      var $132=(($131)|0)!=0;
      var $133=(($132)&1);
      $changed=$133;
      var $134=$field;
      var $135=(($134+400)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138+28)|0);
      var $140=HEAPU8[($139)];
      var $141=(($140)&255);
      var $142=$field;
      var $143=(($142+32)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$144 & 16;
      var $146=(($145)|0)!=0;
      var $147=(($146)&1);
      var $148=(($141)|0)!=(($147)|0);
      var $149=(($148)&1);
      var $150=$changed;
      var $151=(($150) & 1);
      var $152=(($151)&1);
      var $153=$152 | $149;
      var $154=(($153)|0)!=0;
      var $155=(($154)&1);
      $changed=$155;
      __label__ = 12; break;
    case 12: // $156
      var $157=$changed;
      var $158=(($157) & 1);
      if ($158) { __label__ = 13; break; } else { __label__ = 35; break; }
    case 13: // $159
      var $160=$2;
      var $161=__Z13xml_add_childP14_xml_data_nodePKcS2_($160, ((STRING_TABLE.__str1408)|0), 0);
      $portnode=$161;
      var $162=$portnode;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 14; break; } else { __label__ = 34; break; }
    case 14: // $164
      var $165=$portnode;
      var $166=$port;
      var $167=(($tempbuffer)|0);
      var $168=__ZL12get_port_tagPK17input_port_configPc($166, $167);
      var $169=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($165, ((STRING_TABLE.__str1409)|0), $168);
      var $170=$portnode;
      var $171=$1;
      var $172=$field;
      var $173=(($172+24)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$field;
      var $176=(($175+28)|0);
      var $177=HEAPU8[($176)];
      var $178=(($177)&255);
      var $179=__ZL25input_field_type_to_tokenR15running_machineii($171, $174, $178);
      var $180=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($170, ((STRING_TABLE.__str1410)|0), $179);
      var $181=$portnode;
      var $182=$field;
      var $183=(($182)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=__Z21xml_set_attribute_intP14_xml_data_nodePKci($181, ((STRING_TABLE.__str1411)|0), $184);
      var $186=$portnode;
      var $187=$field;
      var $188=(($187+4)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=$field;
      var $191=(($190)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=$189 & $192;
      var $194=__Z21xml_set_attribute_intP14_xml_data_nodePKci($186, ((STRING_TABLE.__str1412)|0), $193);
      $seqtype=0;
      __label__ = 15; break;
    case 15: // $195
      var $196=$seqtype;
      var $197=(($196)>>>0) < 3;
      if ($197) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $198
      var $199=$seqtype;
      var $200=$field;
      var $201=(($200+400)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($202+8)|0);
      var $204=(($203+($199<<6))|0);
      var $205=$seqtype;
      var $206=$field;
      var $207=(($206+44)|0);
      var $208=(($207+($205<<6))|0);
      var $209=__ZNK9input_seqneERKS_($204, $208);
      if ($209) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $210
      var $211=$1;
      var $212=$portnode;
      var $213=$seqtype;
      var $214=$field;
      var $215=(($214+24)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=$seqtype;
      var $218=$field;
      var $219=(($218+400)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220+8)|0);
      var $222=(($221+($217<<6))|0);
      __ZL13save_sequenceR15running_machineP14_xml_data_nodeiiRK9input_seq($211, $212, $213, $216, $222);
      __label__ = 18; break;
    case 18: // $223
      __label__ = 19; break;
    case 19: // $224
      var $225=$seqtype;
      var $226=(($225+1)|0);
      $seqtype=$226;
      __label__ = 15; break;
    case 20: // $227
      var $228=$field;
      var $229=(($228+400)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=(($230)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232)|0)==0;
      if ($233) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $234
      var $235=$field;
      var $236=(($235+400)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=(($237+200)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$field;
      var $241=(($240)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=$239 & $242;
      var $244=$field;
      var $245=(($244+4)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=$field;
      var $248=(($247)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=$246 & $249;
      var $251=(($243)|0)!=(($250)|0);
      if ($251) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $252
      var $253=$portnode;
      var $254=$field;
      var $255=(($254+400)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=(($256+200)|0);
      var $258=HEAP32[(($257)>>2)];
      var $259=$field;
      var $260=(($259)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$258 & $261;
      var $263=__Z21xml_set_attribute_intP14_xml_data_nodePKci($253, ((STRING_TABLE.__str1413)|0), $262);
      __label__ = 23; break;
    case 23: // $264
      __label__ = 33; break;
    case 24: // $265
      var $266=$field;
      var $267=(($266+400)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(($268)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($270+32)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=$field;
      var $274=(($273+312)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=(($272)|0)!=(($275)|0);
      if ($276) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $277
      var $278=$portnode;
      var $279=$field;
      var $280=(($279+400)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($281)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=(($283+32)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=__Z21xml_set_attribute_intP14_xml_data_nodePKci($278, ((STRING_TABLE.__str1414)|0), $285);
      __label__ = 26; break;
    case 26: // $287
      var $288=$field;
      var $289=(($288+400)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292+36)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=$field;
      var $296=(($295+316)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=(($294)|0)!=(($297)|0);
      if ($298) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $299
      var $300=$portnode;
      var $301=$field;
      var $302=(($301+400)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(($303)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=(($305+36)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=__Z21xml_set_attribute_intP14_xml_data_nodePKci($300, ((STRING_TABLE.__str1415)|0), $307);
      __label__ = 28; break;
    case 28: // $309
      var $310=$field;
      var $311=(($310+400)|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=(($312)|0);
      var $314=HEAP32[(($313)>>2)];
      var $315=(($314+24)|0);
      var $316=HEAP32[(($315)>>2)];
      var $317=$field;
      var $318=(($317+308)|0);
      var $319=HEAP32[(($318)>>2)];
      var $320=(($316)|0)!=(($319)|0);
      if ($320) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $321
      var $322=$portnode;
      var $323=$field;
      var $324=(($323+400)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($325)|0);
      var $327=HEAP32[(($326)>>2)];
      var $328=(($327+24)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=__Z21xml_set_attribute_intP14_xml_data_nodePKci($322, ((STRING_TABLE.__str1416)|0), $329);
      __label__ = 30; break;
    case 30: // $331
      var $332=$field;
      var $333=(($332+400)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($334)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=(($336+28)|0);
      var $338=HEAPU8[($337)];
      var $339=(($338)&255);
      var $340=$field;
      var $341=(($340+32)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=$342 & 16;
      var $344=(($343)|0)!=0;
      var $345=(($344)&1);
      var $346=(($339)|0)!=(($345)|0);
      if ($346) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $347
      var $348=$portnode;
      var $349=$field;
      var $350=(($349+400)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=(($351)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($353+28)|0);
      var $355=HEAP8[($354)];
      var $356=(($355 << 24) >> 24)!=0;
      var $357=$356 ? (((STRING_TABLE.__str1418)|0)) : (((STRING_TABLE.__str1419)|0));
      var $358=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($348, ((STRING_TABLE.__str1417)|0), $357);
      __label__ = 32; break;
    case 32: // $359
      __label__ = 33; break;
    case 33: // $360
      __label__ = 34; break;
    case 34: // $361
      __label__ = 35; break;
    case 35: // $362
      __label__ = 36; break;
    case 36: // $363
      __label__ = 37; break;
    case 37: // $364
      var $365=$field;
      var $366=__ZNK18input_field_config4nextEv($365);
      $field=$366;
      __label__ = 3; break;
    case 38: // $367
      __label__ = 39; break;
    case 39: // $368
      var $369=$port;
      var $370=__ZNK17input_port_config4nextEv($369);
      $port=$370;
      __label__ = 1; break;
    case 40: // $371
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16save_game_inputsR15running_machineP14_xml_data_node["X"]=1;

function __ZNK9input_seqneERKS_($this, $rhs) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rhs;
  var $3=$1;
  var $4=(($3)|0);
  var $5=(($4)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7)|0);
  var $9=(($8)|0);
  var $10=$9;
  var $11=_memcmp($6, $10, 64);
  var $12=(($11)|0)!=0;
  ;
  return $12;
}


function __ZL12get_port_tagPK17input_port_configPc($port, $tempbuffer) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$port;
  $2=$tempbuffer;
  var $3=$1;
  var $4=__ZNK17input_port_config3tagEv($3);
  ;
  return $4;
}


function __ZL25input_field_type_to_tokenR15running_machineii($machine, $type, $player) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $portdata;
      var $entry;
      $2=$machine;
      $3=$type;
      $4=$player;
      var $5=$2;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      $portdata=$7;
      var $8=$4;
      var $9=$3;
      var $10=$portdata;
      var $11=(($10+24)|0);
      var $12=(($11+($9<<5))|0);
      var $13=(($12+($8<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      $entry=$14;
      var $15=$entry;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$entry;
      var $19=(($18+12)|0);
      var $20=HEAP32[(($19)>>2)];
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      var $22=$3;
      var $23=$4;
      var $24=_sprintf(((__ZZL25input_field_type_to_tokenR15running_machineiiE7tempbuf)|0), ((STRING_TABLE.__str1425)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,HEAP32[((tempInt+4)>>2)]=$23,tempInt));
      $1=((__ZZL25input_field_type_to_tokenR15running_machineiiE7tempbuf)|0);
      __label__ = 3; break;
    case 3: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI8emu_fileED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8emu_fileED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI8emu_fileED0Ev["X"]=1;

function __ZN20resource_pool_objectI8emu_fileED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI8emu_fileE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI16input_type_entryE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16input_type_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+404)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL12frame_updateR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $mouse_field;
      var $ui_visible;
      var $curtime=__stackBase__;
      var $port;
      var $mouse_target;
      var $mouse_target_x=__stackBase__+12;
      var $mouse_target_y=__stackBase__+16;
      var $mouse_button=__stackBase__+20;
      var $2=__stackBase__+24;
      var $3=__stackBase__+36;
      var $4=__stackBase__+48;
      var $tag=__stackBase__+60;
      var $mask=__stackBase__+64;
      var $x=__stackBase__+68;
      var $y=__stackBase__+72;
      var $field;
      var $device_field;
      var $newvalue;
      var $newval;
      $1=$machine;
      var $5=$1;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      $portdata=$7;
      $mouse_field=0;
      var $8=__Z17ui_is_menu_activev();
      $ui_visible=$8;
      var $9=$1;
      __ZNK15running_machine4timeEv($curtime, $9);
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 270);
      var $10=$1;
      var $11=$2;
      var $12=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];HEAP32[(($11+4)>>2)]=HEAP32[(($12+4)>>2)];HEAP32[(($11+8)>>2)]=HEAP32[(($12+8)>>2)];
      __ZL14playback_frameR15running_machine8attotime($10, $2);
      var $13=$1;
      var $14=$3;
      var $15=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($14)>>2)]=HEAP32[(($15)>>2)];HEAP32[(($14+4)>>2)]=HEAP32[(($15+4)>>2)];HEAP32[(($14+8)>>2)]=HEAP32[(($15+8)>>2)];
      __ZL12record_frameR15running_machine8attotime($13, $3);
      var $16=$portdata;
      var $17=(($16+7416)|0);
      __ZmiRK8attotimeS1_($4, $curtime, $17);
      var $18=__ZNK8attotime14as_attosecondsEv($4);
      var $18$0=$18[0];
      var $18$1=$18[1];
      var $$emscripten$temp$0$0=1000000000;
      var $$emscripten$temp$0$1=0;
      var $19$0 = (tempBigIntR=((($18$0)>>>0)+((($18$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $19$1 = Math.min(Math.floor(((tempBigIntR=((($18$0)>>>0)+((($18$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $20=$portdata;
      var $21=(($20+7428)|0);
      var $st$53$0=(($21)|0);
      HEAP32[(($st$53$0)>>2)]=$19$0;
      var $st$53$1=(($21+4)|0);
      HEAP32[(($st$53$1)>>2)]=$19$1;
      var $22=$portdata;
      var $23=(($22+7416)|0);
      var $24=$23;
      var $25=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];HEAP32[(($24+4)>>2)]=HEAP32[(($25+4)>>2)];HEAP32[(($24+8)>>2)]=HEAP32[(($25+8)>>2)];
      var $26=$1;
      __ZL30frame_update_digital_joysticksR15running_machine($26);
      var $27=$1;
      __Z26input_port_update_defaultsR15running_machine($27);
      var $28=$1;
      var $29=__Z19ui_input_find_mouseR15running_machinePiS1_S1_($28, $mouse_target_x, $mouse_target_y, $mouse_button);
      $mouse_target=$29;
      var $30=HEAP32[(($mouse_button)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $32
      var $33=$mouse_target;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $35
      HEAP32[(($tag)>>2)]=0;
      var $36=$mouse_target;
      var $37=HEAP32[(($mouse_target_x)>>2)];
      var $38=HEAP32[(($mouse_target_y)>>2)];
      var $39=__ZN13render_target15map_point_inputEiiRPKcRjRfS4_($36, $37, $38, $tag, $mask, $x, $y);
      if ($39) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $40
      var $41=$1;
      var $42=(($41+20)|0);
      var $43=HEAP32[(($tag)>>2)];
      var $44=HEAP32[(($mask)>>2)];
      var $45=__Z27input_field_by_tag_and_maskRK11tagged_listI17input_port_configEPKcj($42, $43, $44);
      $mouse_field=$45;
      __label__ = 4; break;
    case 4: // $46
      __label__ = 5; break;
    case 5: // $47
      var $48=$1;
      var $49=(($48+20)|0);
      var $50=__ZNK11tagged_listI17input_port_configE5firstEv($49);
      $port=$50;
      __label__ = 6; break;
    case 6: // $51
      var $52=$port;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 7; break; } else { __label__ = 33; break; }
    case 7: // $54
      var $55=$port;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+16)|0);
      HEAP32[(($58)>>2)]=0;
      var $59=$port;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+20)|0);
      HEAP32[(($62)>>2)]=0;
      var $63=$port;
      var $64=__ZNK17input_port_config11first_fieldEv($63);
      $field=$64;
      __label__ = 8; break;
    case 8: // $65
      var $66=$field;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 9; break; } else { __label__ = 22; break; }
    case 9: // $68
      var $69=$port;
      var $70=__ZNK17input_port_config7machineEv($69);
      var $71=$field;
      var $72=(($71+8)|0);
      var $73=$port;
      var $74=__ZNK17input_port_config5ownerEv($73);
      var $75=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($70, $72, $74);
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 10; break; } else { __label__ = 20; break; }
    case 10: // $77
      var $78=$field;
      var $79=(($78+24)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)==6;
      if ($81) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $82
      var $83=$field;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$port;
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+20)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$90 ^ $85;
      HEAP32[(($89)>>2)]=$91;
      __label__ = 19; break;
    case 12: // $92
      var $93=$field;
      var $94=(($93+400)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $99
      var $100=$1;
      var $101=$field;
      var $102=(($101+400)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      __ZL25frame_update_analog_fieldR15running_machineP19_analog_field_state($100, $105);
      __label__ = 18; break;
    case 14: // $106
      var $107=$ui_visible;
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 15: // $109
      var $110=$field;
      var $111=$field;
      var $112=$mouse_field;
      var $113=(($111)|0)==(($112)|0);
      var $114=(($113)&1);
      var $115=__ZL29frame_get_digital_field_statePK18input_field_configi($110, $114);
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $117
      var $118=$field;
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$port;
      var $122=(($121)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123+16)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$125 | $120;
      HEAP32[(($124)>>2)]=$126;
      __label__ = 17; break;
    case 17: // $127
      __label__ = 18; break;
    case 18: // $128
      __label__ = 19; break;
    case 19: // $129
      __label__ = 20; break;
    case 20: // $130
      __label__ = 21; break;
    case 21: // $131
      var $132=$field;
      var $133=__ZNK18input_field_config4nextEv($132);
      $field=$133;
      __label__ = 8; break;
    case 22: // $134
      var $135=$1;
      var $136=$port;
      var $137=$port;
      var $138=(($137)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139+16)|0);
      __ZL22input_port_update_hookR15running_machinePK17input_port_configPj($135, $136, $140);
      var $141=$port;
      __ZL13playback_portPK17input_port_config($141);
      var $142=$port;
      __ZL11record_portPK17input_port_config($142);
      var $143=$port;
      var $144=__Z22input_port_read_directPK17input_port_config($143);
      $newvalue=$144;
      var $145=$port;
      var $146=(($145)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+8)|0);
      var $149=HEAP32[(($148)>>2)];
      $device_field=$149;
      __label__ = 23; break;
    case 23: // $150
      var $151=$device_field;
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 24; break; } else { __label__ = 31; break; }
    case 24: // $153
      var $154=$device_field;
      var $155=(($154+4)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($156+24)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($158)|0)!=215;
      if ($159) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $160
      var $161=$port;
      var $162=__ZNK17input_port_config7machineEv($161);
      var $163=$device_field;
      var $164=(($163+4)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165+8)|0);
      var $167=$port;
      var $168=__ZNK17input_port_config5ownerEv($167);
      var $169=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($162, $166, $168);
      var $170=(($169)|0)!=0;
      if ($170) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $171
      var $172=$newvalue;
      var $173=$device_field;
      var $174=(($173+4)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=(($175)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$172 & $177;
      var $179=$device_field;
      var $180=(($179+12)|0);
      var $181=HEAPU8[($180)];
      var $182=(($181)&255);
      var $183=$178 >>> (($182)>>>0);
      $newval=$183;
      var $184=$device_field;
      var $185=(($184+16)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$newval;
      var $188=(($186)|0)!=(($187)|0);
      if ($188) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $189
      var $190=$device_field;
      var $191=(($190+4)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+268)|0);
      var $194=$193;
      var $195=$device_field;
      var $196=(($195+4)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=$device_field;
      var $199=(($198+4)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+292)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=$device_field;
      var $204=(($203+16)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=$newval;
      __ZNK13delegate_baseIvRK18input_field_configPvjjEclES2_S3_jj($194, $197, $202, $205, $206);
      var $207=$newval;
      var $208=$device_field;
      var $209=(($208+16)|0);
      HEAP32[(($209)>>2)]=$207;
      __label__ = 28; break;
    case 28: // $210
      __label__ = 29; break;
    case 29: // $211
      __label__ = 30; break;
    case 30: // $212
      var $213=$device_field;
      var $214=(($213)|0);
      var $215=HEAP32[(($214)>>2)];
      $device_field=$215;
      __label__ = 23; break;
    case 31: // $216
      __label__ = 32; break;
    case 32: // $217
      var $218=$port;
      var $219=__ZNK17input_port_config4nextEv($218);
      $port=$219;
      __label__ = 6; break;
    case 33: // $220
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12frame_updateR15running_machine["X"]=1;

function __ZL13save_sequenceR15running_machineP14_xml_data_nodeiiRK9input_seq($machine, $parentnode, $type, $porttype, $seq) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $seqstring=__stackBase__;
      var $seqnode;
      var $6;
      var $7;
      $1=$machine;
      $2=$parentnode;
      $3=$type;
      $4=$porttype;
      $5=$seq;
      __ZN7astringC1Ev($seqstring);
      var $8=$5;
      var $9=(function() { try { __THREW__ = false; return __ZNK9input_seq6lengthEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $10
      var $11=(($9)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $12
      var $13=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($seqstring, ((STRING_TABLE.__str1420)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $14
      __label__ = 8; break;
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $6=$17;
      var $18=$16.f1;
      $7=$18;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($seqstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 5: // $19
      var $20=$1;
      var $21=(function() { try { __THREW__ = false; return __ZNK15running_machine5inputEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 4; break; };
    case 6: // $22
      var $23=$5;
      var $24=(function() { try { __THREW__ = false; return __ZNK13input_manager13seq_to_tokensER7astringRK9input_seq($21, $seqstring, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=$2;
      var $28=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($seqstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; };
    case 9: // $29
      var $30=(function() { try { __THREW__ = false; return __Z13xml_add_childP14_xml_data_nodePKcS2_($27, ((STRING_TABLE.__str1421)|0), $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; };
    case 10: // $31
      $seqnode=$30;
      var $32=$seqnode;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $34
      var $35=$seqnode;
      var $36=$3;
      var $37=((__ZL14seqtypestrings+($36<<2))|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(function() { try { __THREW__ = false; return __Z17xml_set_attributeP14_xml_data_nodePKcS2_($35, ((STRING_TABLE.__str1410)|0), $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 4; break; };
    case 12: // $40
      __label__ = 13; break;
    case 13: // $41
      FUNCTION_TABLE[__ZN7astringD1Ev]($seqstring);
      STACKTOP = __stackBase__;
      return;
    case 14: // $42
      __label__ = 15; break;
    case 15: // $43
      var $44=$6;
      var $45=$6;
      var $46=$7;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13save_sequenceR15running_machineP14_xml_data_nodeiiRK9input_seq["X"]=1;

function __ZL16load_remap_tableR15running_machineP14_xml_data_node($machine, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $result_i2=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $portdata;
      var $oldtable;
      var $newtable;
      var $remapnode;
      var $count;
      var $remapnum;
      var $19;
      var $20;
      var $origcode=__stackBase__+72;
      var $newcode=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $oldcode=__stackBase__+88;
      var $newcode1=__stackBase__+92;
      var $entry;
      var $seqtype;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      $17=$machine;
      $18=$parentnode;
      var $25=$17;
      var $26=(($25+644)|0);
      var $27=HEAP32[(($26)>>2)];
      $portdata=$27;
      $count=0;
      var $28=$18;
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__Z15xml_get_siblingP14_xml_data_nodePKc($30, ((STRING_TABLE.__str1426)|0));
      $remapnode=$31;
      __label__ = 1; break;
    case 1: // $32
      var $33=$remapnode;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $35
      var $36=$count;
      var $37=(($36+1)|0);
      $count=$37;
      __label__ = 3; break;
    case 3: // $38
      var $39=$remapnode;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=__Z15xml_get_siblingP14_xml_data_nodePKc($41, ((STRING_TABLE.__str1426)|0));
      $remapnode=$42;
      __label__ = 1; break;
    case 4: // $43
      var $44=$count;
      var $45=(($44)|0) > 0;
      if ($45) { __label__ = 5; break; } else { __label__ = 57; break; }
    case 5: // $46
      var $47=$count;
      var $48=_llvm_umul_with_overflow_i32($47, 4);
      var $49=$48.f1;
      var $50=$48.f0;
      var $51=$49 ? -1 : $50;
      var $52=$12;
      var $53=$13;
      var $54=$14;
      var $55=$result_i;
      var $56=$15;
      var $57=$16;
      HEAP32[(($12)>>2)]=$51;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($14)>>2)]=3236;
      var $58=HEAP32[(($12)>>2)];
      var $59=HEAP32[(($13)>>2)];
      var $60=HEAP32[(($14)>>2)];
      var $61=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($58, $59, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $62
      HEAP32[(($result_i)>>2)]=$61;
      var $63=HEAP32[(($result_i)>>2)];
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $65
      var $66=___cxa_allocate_exception(4);
      var $67=$66;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($67);
      (function() { try { __THREW__ = false; return ___cxa_throw($66, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      HEAP32[(($15)>>2)]=$70;
      var $71=$69.f1;
      HEAP32[(($16)>>2)]=$71;
      var $72=HEAP32[(($16)>>2)];
      var $73=(($72)|0) < 0;
      if ($73) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $74
      var $75=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($75);
      throw "Reached an unreachable!"
    case 10: // $76
      var $77=HEAP32[(($15)>>2)];
      var $78=HEAP32[(($15)>>2)];
      var $79=HEAP32[(($16)>>2)];
      var $80=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $78, tempValue);
      var $81=($80.f1 = $79, $80);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $82
      throw "Reached an unreachable!"
    case 12: // $_ZnajPKci_exit
      var $83=HEAP32[(($result_i)>>2)];
      var $84=$12;
      var $85=$13;
      var $86=$14;
      var $87=$result_i;
      var $88=$15;
      var $89=$16;
      var $90=$83;
      var $91=(($47)|0)==0;
      if ($91) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $92
      var $93=(($90+($47<<2))|0);
      var $95 = $90;__label__ = 14; break;
    case 14: // $94
      var $95;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($95, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 32; break; }
    case 15: // $96
      var $97=(($95+4)|0);
      var $98=(($97)|0)==(($93)|0);
      if ($98) { __label__ = 16; break; } else { var $95 = $97;__label__ = 14; break; }
    case 16: // $99
      var $100=$count;
      var $101=__ZN13resource_pool9add_arrayI10input_codeEEPT_S3_i(_global_resource_pool, $90, $100);
      $oldtable=$101;
      var $102=$count;
      var $103=_llvm_umul_with_overflow_i32($102, 4);
      var $104=$103.f1;
      var $105=$103.f0;
      var $106=$104 ? -1 : $105;
      var $107=$7;
      var $108=$8;
      var $109=$9;
      var $110=$result_i2;
      var $111=$10;
      var $112=$11;
      HEAP32[(($7)>>2)]=$106;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($9)>>2)]=3237;
      var $113=HEAP32[(($7)>>2)];
      var $114=HEAP32[(($8)>>2)];
      var $115=HEAP32[(($9)>>2)];
      var $116=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($113, $114, $115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $117
      HEAP32[(($result_i2)>>2)]=$116;
      var $118=HEAP32[(($result_i2)>>2)];
      var $119=(($118)|0)==0;
      if ($119) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $120
      var $121=___cxa_allocate_exception(4);
      var $122=$121;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($122);
      (function() { try { __THREW__ = false; return ___cxa_throw($121, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $123
      var $124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $125=$124.f0;
      HEAP32[(($10)>>2)]=$125;
      var $126=$124.f1;
      HEAP32[(($11)>>2)]=$126;
      var $127=HEAP32[(($11)>>2)];
      var $128=(($127)|0) < 0;
      if ($128) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $129
      var $130=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($130);
      throw "Reached an unreachable!"
    case 21: // $131
      var $132=HEAP32[(($10)>>2)];
      var $133=HEAP32[(($10)>>2)];
      var $134=HEAP32[(($11)>>2)];
      var $135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $133, tempValue);
      var $136=($135.f1 = $134, $135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $137
      throw "Reached an unreachable!"
    case 23: // $_ZnajPKci_exit3
      var $138=HEAP32[(($result_i2)>>2)];
      var $139=$7;
      var $140=$8;
      var $141=$9;
      var $142=$result_i2;
      var $143=$10;
      var $144=$11;
      var $145=$138;
      var $146=(($102)|0)==0;
      if ($146) { __label__ = 27; break; } else { __label__ = 24; break; }
    case 24: // $147
      var $148=(($145+($102<<2))|0);
      var $150 = $145;__label__ = 25; break;
    case 25: // $149
      var $150;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($150, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 37; break; }
    case 26: // $151
      var $152=(($150+4)|0);
      var $153=(($152)|0)==(($148)|0);
      if ($153) { __label__ = 27; break; } else { var $150 = $152;__label__ = 25; break; }
    case 27: // $154
      var $155=$count;
      var $156=__ZN13resource_pool9add_arrayI10input_codeEEPT_S3_i(_global_resource_pool, $145, $155);
      $newtable=$156;
      $count=0;
      var $157=$18;
      var $158=(($157+8)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=__Z15xml_get_siblingP14_xml_data_nodePKc($159, ((STRING_TABLE.__str1426)|0));
      $remapnode=$160;
      __label__ = 28; break;
    case 28: // $161
      var $162=$remapnode;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 29; break; } else { __label__ = 44; break; }
    case 29: // $164
      var $165=$17;
      var $166=__ZNK15running_machine5inputEv($165);
      var $167=$remapnode;
      var $168=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($167, ((STRING_TABLE.__str1427)|0), ((__str1366)|0));
      __ZN13input_manager15code_from_tokenEPKc($origcode, $166, $168);
      var $169=$17;
      var $170=__ZNK15running_machine5inputEv($169);
      var $171=$remapnode;
      var $172=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($171, ((STRING_TABLE.__str1428)|0), ((__str1366)|0));
      __ZN13input_manager15code_from_tokenEPKc($newcode, $170, $172);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($21, 0, 0, 0, 0, 0);
      var $173=__ZNK10input_codeneERKS_($origcode, $21);
      if ($173) { __label__ = 30; break; } else { __label__ = 42; break; }
    case 30: // $174
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($22, 0, 0, 0, 0, 0);
      var $175=__ZNK10input_codeneERKS_($newcode, $22);
      if ($175) { __label__ = 31; break; } else { __label__ = 42; break; }
    case 31: // $176
      var $177=$count;
      var $178=$oldtable;
      var $179=(($178+($177<<2))|0);
      var $180=$179;
      var $181=$origcode;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($180)>>2)]=HEAP32[(($181)>>2)];
      var $182=$count;
      var $183=$newtable;
      var $184=(($183+($182<<2))|0);
      var $185=$184;
      var $186=$newcode;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($185)>>2)]=HEAP32[(($186)>>2)];
      var $187=$count;
      var $188=(($187+1)|0);
      $count=$188;
      __label__ = 42; break;
    case 32: // $189
      var $190=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $191=$190.f0;
      $19=$191;
      var $192=$190.f1;
      $20=$192;
      var $193=$4;
      var $194=$5;
      var $195=$6;
      HEAP32[(($4)>>2)]=$83;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($6)>>2)]=3236;
      var $196=HEAP32[(($4)>>2)];
      var $197=(($196)|0)!=0;
      if ($197) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $198
      var $199=HEAP32[(($4)>>2)];
      var $200=HEAP32[(($5)>>2)];
      var $201=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($199, $200, $201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 59; break; }
    case 34: // $_noexc
      __label__ = 35; break;
    case 35: // $_ZdaPvPKci_exit
      var $202=$4;
      var $203=$5;
      var $204=$6;
      __label__ = 36; break;
    case 36: // $205
      __label__ = 58; break;
    case 37: // $206
      var $207=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $208=$207.f0;
      $19=$208;
      var $209=$207.f1;
      $20=$209;
      var $210=$1;
      var $211=$2;
      var $212=$3;
      HEAP32[(($1)>>2)]=$138;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=3237;
      var $213=HEAP32[(($1)>>2)];
      var $214=(($213)|0)!=0;
      if ($214) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $215
      var $216=HEAP32[(($1)>>2)];
      var $217=HEAP32[(($2)>>2)];
      var $218=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($216, $217, $218) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 59; break; }
    case 39: // $_noexc4
      __label__ = 40; break;
    case 40: // $_ZdaPvPKci_exit5
      var $219=$1;
      var $220=$2;
      var $221=$3;
      __label__ = 41; break;
    case 41: // $222
      __label__ = 58; break;
    case 42: // $223
      __label__ = 43; break;
    case 43: // $224
      var $225=$remapnode;
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=__Z15xml_get_siblingP14_xml_data_nodePKc($227, ((STRING_TABLE.__str1426)|0));
      $remapnode=$228;
      __label__ = 28; break;
    case 44: // $229
      $remapnum=0;
      __label__ = 45; break;
    case 45: // $230
      var $231=$remapnum;
      var $232=$count;
      var $233=(($231)|0) < (($232)|0);
      if ($233) { __label__ = 46; break; } else { __label__ = 56; break; }
    case 46: // $234
      var $235=$remapnum;
      var $236=$oldtable;
      var $237=(($236+($235<<2))|0);
      __ZN10input_codeC1ERKS_($oldcode, $237);
      var $238=$remapnum;
      var $239=$newtable;
      var $240=(($239+($238<<2))|0);
      __ZN10input_codeC1ERKS_($newcode1, $240);
      var $241=$portdata;
      var $242=(($241+4)|0);
      var $243=__ZNK11simple_listI16input_type_entryE5firstEv($242);
      $entry=$243;
      __label__ = 47; break;
    case 47: // $244
      var $245=$entry;
      var $246=(($245)|0)!=0;
      if ($246) { __label__ = 48; break; } else { __label__ = 54; break; }
    case 48: // $247
      $seqtype=0;
      __label__ = 49; break;
    case 49: // $248
      var $249=$seqtype;
      var $250=(($249)>>>0) < 3;
      if ($250) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $251
      var $252=$seqtype;
      var $253=$entry;
      var $254=(($253+212)|0);
      var $255=(($254+($252<<6))|0);
      __ZN10input_codeC1ERKS_($23, $oldcode);
      __ZN10input_codeC1ERKS_($24, $newcode1);
      __ZN9input_seq7replaceE10input_codeS0_($255, $23, $24);
      __label__ = 51; break;
    case 51: // $256
      var $257=$seqtype;
      var $258=(($257+1)|0);
      $seqtype=$258;
      __label__ = 49; break;
    case 52: // $259
      __label__ = 53; break;
    case 53: // $260
      var $261=$entry;
      var $262=__ZNK16input_type_entry4nextEv($261);
      $entry=$262;
      __label__ = 47; break;
    case 54: // $263
      __label__ = 55; break;
    case 55: // $264
      var $265=$remapnum;
      var $266=(($265+1)|0);
      $remapnum=$266;
      __label__ = 45; break;
    case 56: // $267
      var $268=$oldtable;
      var $269=$268;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $269);
      var $270=$newtable;
      var $271=$270;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $271);
      __label__ = 57; break;
    case 57: // $272
      STACKTOP = __stackBase__;
      return;
    case 58: // $273
      var $274=$19;
      var $275=$19;
      var $276=$20;
      var $277=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $275, tempValue);
      var $278=($277.f1 = $276, $277);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 59: // $279
      var $280=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16load_remap_tableR15running_machineP14_xml_data_node["X"]=1;

function __ZN20dummy_profiler_state5startE12profile_type($this, $type) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$type;
  var $3=$1;
  ;
  return;
}


function __ZNK10input_codeneERKS_($this, $rhs) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rhs;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($5)|0)!=(($8)|0);
  ;
  return $9;
}


function __ZL25token_to_input_field_typeR15running_machinePKcPi($machine, $string, $player) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $portdata;
      var $ipnum=__stackBase__;
      var $entry;
      $2=$machine;
      $3=$string;
      $4=$player;
      var $5=$2;
      var $6=(($5+644)|0);
      var $7=HEAP32[(($6)>>2)];
      $portdata=$7;
      var $8=$3;
      var $9=$4;
      var $10=_sscanf($8, ((STRING_TABLE.__str1425)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$ipnum,HEAP32[((tempInt+4)>>2)]=$9,tempInt));
      var $11=(($10)|0)==2;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=HEAP32[(($ipnum)>>2)];
      $1=$13;
      __label__ = 10; break;
    case 2: // $14
      var $15=$portdata;
      var $16=(($15+4)|0);
      var $17=__ZNK11simple_listI16input_type_entryE5firstEv($16);
      $entry=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$entry;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $21
      var $22=$entry;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $26
      var $27=$entry;
      var $28=(($27+12)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=_strcmp($29, $30);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $34=$entry;
      var $35=(($34+8)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$4;
      HEAP32[(($38)>>2)]=$37;
      var $39=$entry;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      $1=$41;
      __label__ = 10; break;
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      var $44=$entry;
      var $45=__ZNK16input_type_entry4nextEv($44);
      $entry=$45;
      __label__ = 3; break;
    case 9: // $46
      var $47=$4;
      HEAP32[(($47)>>2)]=0;
      $1=3;
      __label__ = 10; break;
    case 10: // $48
      var $49=$1;
      STACKTOP = __stackBase__;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25token_to_input_field_typeR15running_machinePKcPi["X"]=1;

function __ZL17token_to_seq_typePKc($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $seqindex;
      $2=$string;
      $seqindex=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$seqindex;
      var $5=(($4)>>>0) < 3;
      if ($5) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $6
      var $7=$2;
      var $8=$seqindex;
      var $9=((__ZL14seqtypestrings+($8<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__Z12core_stricmpPKcS0_($7, $10);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$seqindex;
      $1=$14;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$seqindex;
      var $18=(($17+1)|0);
      $seqindex=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=-1;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19load_default_configR15running_machineP14_xml_data_nodeiiPK9input_seq($machine, $portnode, $type, $player, $newseq) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $portdata;
      var $entry;
      var $seqtype;
      var $7=__stackBase__;
      var $8=__stackBase__+4;
      $2=$machine;
      $3=$portnode;
      $4=$type;
      $5=$player;
      $6=$newseq;
      var $9=$2;
      var $10=(($9+644)|0);
      var $11=HEAP32[(($10)>>2)];
      $portdata=$11;
      var $12=$portdata;
      var $13=(($12+4)|0);
      var $14=__ZNK11simple_listI16input_type_entryE5firstEv($13);
      $entry=$14;
      __label__ = 1; break;
    case 1: // $15
      var $16=$entry;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $18
      var $19=$entry;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$4;
      var $23=(($21)|0)==(($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $24
      var $25=$entry;
      var $26=(($25+8)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$5;
      var $30=(($28)|0)==(($29)|0);
      if ($30) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $31
      $seqtype=0;
      __label__ = 5; break;
    case 5: // $32
      var $33=$seqtype;
      var $34=(($33)>>>0) < 3;
      if ($34) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $35
      var $36=$seqtype;
      var $37=$6;
      var $38=(($37+($36<<6))|0);
      __ZNK9input_seqixEi($7, $38, 0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 0, 0, 0, 0, 0);
      var $39=__ZNK10input_codeneERKS_($7, $8);
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      var $41=$seqtype;
      var $42=$entry;
      var $43=(($42+212)|0);
      var $44=(($43+($41<<6))|0);
      var $45=$seqtype;
      var $46=$6;
      var $47=(($46+($45<<6))|0);
      var $48=$44;
      var $49=$47;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $49>>2, $$dest = $48>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 8; break;
    case 8: // $50
      __label__ = 9; break;
    case 9: // $51
      var $52=$seqtype;
      var $53=(($52+1)|0);
      $seqtype=$53;
      __label__ = 5; break;
    case 10: // $54
      $1=1;
      __label__ = 14; break;
    case 11: // $55
      __label__ = 12; break;
    case 12: // $56
      var $57=$entry;
      var $58=__ZNK16input_type_entry4nextEv($57);
      $entry=$58;
      __label__ = 1; break;
    case 13: // $59
      $1=0;
      __label__ = 14; break;
    case 14: // $60
      var $61=$1;
      STACKTOP = __stackBase__;
      return $61;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19load_default_configR15running_machineP14_xml_data_nodeiiPK9input_seq["X"]=1;

function __ZL16load_game_configR15running_machineP14_xml_data_nodeiiPK9input_seq($machine, $portnode, $type, $player, $newseq) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $mask;
      var $defvalue;
      var $field;
      var $port;
      var $tempbuffer=__stackBase__;
      var $tag;
      var $revstring;
      var $seqtype;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      $2=$machine;
      $3=$portnode;
      $4=$type;
      $5=$player;
      $6=$newseq;
      var $9=$3;
      var $10=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($9, ((STRING_TABLE.__str1409)|0), 0);
      $tag=$10;
      var $11=$3;
      var $12=__Z21xml_get_attribute_intP14_xml_data_nodePKci($11, ((STRING_TABLE.__str1411)|0), 0);
      $mask=$12;
      var $13=$3;
      var $14=__Z21xml_get_attribute_intP14_xml_data_nodePKci($13, ((STRING_TABLE.__str1412)|0), 0);
      $defvalue=$14;
      var $15=$2;
      var $16=(($15+20)|0);
      var $17=__ZNK11tagged_listI17input_port_configE5firstEv($16);
      $port=$17;
      __label__ = 1; break;
    case 1: // $18
      var $19=$port;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 27; break; }
    case 2: // $21
      var $22=$tag;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=$port;
      var $26=(($tempbuffer)|0);
      var $27=__ZL12get_port_tagPK17input_port_configPc($25, $26);
      var $28=$tag;
      var $29=_strcmp($27, $28);
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 4; break; } else { __label__ = 25; break; }
    case 4: // $31
      var $32=$port;
      var $33=__ZNK17input_port_config11first_fieldEv($32);
      $field=$33;
      __label__ = 5; break;
    case 5: // $34
      var $35=$field;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 6; break; } else { __label__ = 24; break; }
    case 6: // $37
      var $38=$field;
      var $39=(($38+24)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$4;
      var $42=(($40)|0)==(($41)|0);
      if ($42) { __label__ = 7; break; } else { __label__ = 22; break; }
    case 7: // $43
      var $44=$field;
      var $45=(($44+28)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=$5;
      var $49=(($47)|0)==(($48)|0);
      if ($49) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $50
      var $51=$field;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$mask;
      var $55=(($53)|0)==(($54)|0);
      if ($55) { __label__ = 9; break; } else { __label__ = 22; break; }
    case 9: // $56
      var $57=$field;
      var $58=(($57+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$mask;
      var $61=$59 & $60;
      var $62=$defvalue;
      var $63=$mask;
      var $64=$62 & $63;
      var $65=(($61)|0)==(($64)|0);
      if ($65) { __label__ = 10; break; } else { __label__ = 22; break; }
    case 10: // $66
      $seqtype=0;
      __label__ = 11; break;
    case 11: // $67
      var $68=$seqtype;
      var $69=(($68)>>>0) < 3;
      if ($69) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $70
      var $71=$seqtype;
      var $72=$6;
      var $73=(($72+($71<<6))|0);
      __ZNK9input_seqixEi($7, $73, 0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 0, 0, 0, 0, 0);
      var $74=__ZNK10input_codeneERKS_($7, $8);
      if ($74) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $75
      var $76=$seqtype;
      var $77=$field;
      var $78=(($77+400)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79+8)|0);
      var $81=(($80+($76<<6))|0);
      var $82=$seqtype;
      var $83=$6;
      var $84=(($83+($82<<6))|0);
      var $85=$81;
      var $86=$84;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $86>>2, $$dest = $85>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 14; break;
    case 14: // $87
      __label__ = 15; break;
    case 15: // $88
      var $89=$seqtype;
      var $90=(($89+1)|0);
      $seqtype=$90;
      __label__ = 11; break;
    case 16: // $91
      var $92=$field;
      var $93=(($92+400)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)==0;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      var $99=$3;
      var $100=$field;
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=__Z21xml_get_attribute_intP14_xml_data_nodePKci($99, ((STRING_TABLE.__str1413)|0), $102);
      var $104=$field;
      var $105=(($104+400)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+200)|0);
      HEAP32[(($107)>>2)]=$103;
      __label__ = 21; break;
    case 18: // $108
      var $109=$3;
      var $110=$field;
      var $111=(($110+312)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=__Z21xml_get_attribute_intP14_xml_data_nodePKci($109, ((STRING_TABLE.__str1414)|0), $112);
      var $114=$field;
      var $115=(($114+400)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118+32)|0);
      HEAP32[(($119)>>2)]=$113;
      var $120=$3;
      var $121=$field;
      var $122=(($121+316)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=__Z21xml_get_attribute_intP14_xml_data_nodePKci($120, ((STRING_TABLE.__str1415)|0), $123);
      var $125=$field;
      var $126=(($125+400)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+36)|0);
      HEAP32[(($130)>>2)]=$124;
      var $131=$3;
      var $132=$field;
      var $133=(($132+308)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=__Z21xml_get_attribute_intP14_xml_data_nodePKci($131, ((STRING_TABLE.__str1416)|0), $134);
      var $136=$field;
      var $137=(($136+400)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+24)|0);
      HEAP32[(($141)>>2)]=$135;
      var $142=$3;
      var $143=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($142, ((STRING_TABLE.__str1417)|0), 0);
      $revstring=$143;
      var $144=$revstring;
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $146
      var $147=$revstring;
      var $148=_strcmp($147, ((STRING_TABLE.__str1418)|0));
      var $149=(($148)|0)==0;
      var $150=(($149)&1);
      var $151=$field;
      var $152=(($151+400)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+28)|0);
      HEAP8[($156)]=$150;
      __label__ = 20; break;
    case 20: // $157
      __label__ = 21; break;
    case 21: // $158
      $1=1;
      __label__ = 28; break;
    case 22: // $159
      __label__ = 23; break;
    case 23: // $160
      var $161=$field;
      var $162=__ZNK18input_field_config4nextEv($161);
      $field=$162;
      __label__ = 5; break;
    case 24: // $163
      __label__ = 25; break;
    case 25: // $164
      __label__ = 26; break;
    case 26: // $165
      var $166=$port;
      var $167=__ZNK17input_port_config4nextEv($166);
      $port=$167;
      __label__ = 1; break;
    case 27: // $168
      $1=0;
      __label__ = 28; break;
    case 28: // $169
      var $170=$1;
      STACKTOP = __stackBase__;
      return $170;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16load_game_configR15running_machineP14_xml_data_nodeiiPK9input_seq["X"]=1;

function __ZNK9input_seqixEi($agg_result, $this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0) >= 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)>>>0) < 16;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($3)|0);
      var $12=(($11+($10<<2))|0);
      var $15 = $12;__label__ = 4; break;
    case 3: // $13
      var $15 = __ZN9input_seq8end_codeE;__label__ = 4; break;
    case 4: // $14
      var $15;
      __ZN10input_codeC1ERKS_($agg_result, $15);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayI10input_codeEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI10input_codeEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI10input_codeEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<2))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI10input_codeE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI10input_codeED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI10input_codeED2Ev($2);
  ;
  return;
}


function __ZL14playback_frameR15running_machine8attotime($machine, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $readtime=__stackBase__;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      var $5=$portdata;
      var $6=(($5+7440)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      __ZN8attotimeC1Ev($readtime);
      var $10=$1;
      var $11=__ZL20playback_read_uint32R15running_machine($10);
      var $12=(($readtime)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=$1;
      var $14=__ZL20playback_read_uint64R15running_machine($13);
      var $14$0=$14[0];
      var $14$1=$14[1];
      var $15=(($readtime+4)|0);
      var $st$10$0=(($15)|0);
      HEAP32[(($st$10$0)>>2)]=$14$0;
      var $st$10$1=(($15+4)|0);
      HEAP32[(($st$10$1)>>2)]=$14$1;
      var $16=__ZneRK8attotimeS1_($readtime, $curtime);
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$1;
      __ZL12playback_endR15running_machinePKc($18, ((STRING_TABLE.__str1437)|0));
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      var $21=__ZL20playback_read_uint32R15running_machine($20);
      var $22$0=$21;
      var $22$1=0;
      var $23=$portdata;
      var $24=(($23+7444)|0);
      var $st$6$0=(($24)|0);
      var $25$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$6$1)>>2)];
      var $26$0 = ((($25$0)>>>0)+((($25$1)|0)*4294967296))+((($22$0)>>>0)+((($22$1)|0)*4294967296))>>>0; var $26$1 = Math.min(Math.floor((((($25$0)>>>0)+((($25$1)|0)*4294967296))+((($22$0)>>>0)+((($22$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$11$0=(($24)|0);
      HEAP32[(($st$11$0)>>2)]=$26$0;
      var $st$11$1=(($24+4)|0);
      HEAP32[(($st$11$1)>>2)]=$26$1;
      var $27=$portdata;
      var $28=(($27+7452)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+1)|0);
      HEAP32[(($28)>>2)]=$30;
      __label__ = 4; break;
    case 4: // $31
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14playback_frameR15running_machine8attotime["X"]=1;

function __ZN13resource_pool9add_arrayI10input_codeEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI10input_codeEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI10input_codeEEPT_S3_i["X"]=1;

function __ZN19resource_pool_arrayI10input_codeED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI10input_codeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI10input_codeED0Ev["X"]=1;

function __ZN19resource_pool_arrayI10input_codeED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayI10input_codeE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12record_frameR15running_machine8attotime($machine, $curtime) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      var $5=$portdata;
      var $6=(($5+7436)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($curtime)|0);
      var $12=HEAP32[(($11)>>2)];
      __ZL19record_write_uint32R15running_machinej($10, $12);
      var $13=$1;
      var $14=(($curtime+4)|0);
      var $st$6$0=(($14)|0);
      var $15$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$6$1)>>2)];
      __ZL19record_write_uint64R15running_machiney($13, $15$0, $15$1);
      var $16=$1;
      var $17=$1;
      var $18=__ZNK15running_machine5videoEv($17);
      var $19=__ZNK13video_manager13speed_percentEv($18);
      var $20=$19*1048576;
      var $21=($20 >= 0 ? Math.floor($20) : Math.ceil($20));
      __ZL19record_write_uint32R15running_machinej($16, $21);
      __label__ = 2; break;
    case 2: // $22
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL30frame_update_digital_joysticksR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $player;
      var $joyindex;
      var $joystick;
      $1=$machine;
      var $2=$1;
      var $3=(($2+644)|0);
      var $4=HEAP32[(($3)>>2)];
      $portdata=$4;
      $player=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$player;
      var $7=(($6)|0) < 8;
      if ($7) { __label__ = 2; break; } else { __label__ = 37; break; }
    case 2: // $8
      $joyindex=0;
      __label__ = 3; break;
    case 3: // $9
      var $10=$joyindex;
      var $11=(($10)|0) < 3;
      if ($11) { __label__ = 4; break; } else { __label__ = 35; break; }
    case 4: // $12
      var $13=$joyindex;
      var $14=$player;
      var $15=$portdata;
      var $16=(($15+6936)|0);
      var $17=(($16+$14*60)|0);
      var $18=(($17+$13*20)|0);
      $joystick=$18;
      var $19=$joystick;
      var $20=(($19+16)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 33; break; }
    case 5: // $23
      var $24=$joystick;
      var $25=(($24+17)|0);
      var $26=HEAP8[($25)];
      var $27=$joystick;
      var $28=(($27+19)|0);
      HEAP8[($28)]=$26;
      var $29=$joystick;
      var $30=(($29+17)|0);
      HEAP8[($30)]=0;
      var $31=$joystick;
      var $32=(($31)|0);
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=$1;
      var $38=__ZNK15running_machine5inputEv($37);
      var $39=$joystick;
      var $40=(($39)|0);
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__Z15input_field_seqPK18input_field_config15_input_seq_type($42, 0);
      var $44=__ZN13input_manager11seq_pressedERK9input_seq($38, $43);
      if ($44) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $45
      var $46=$joystick;
      var $47=(($46+17)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 | 1;
      var $51=(($50) & 255);
      HEAP8[($47)]=$51;
      __label__ = 8; break;
    case 8: // $52
      var $53=$joystick;
      var $54=(($53)|0);
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $58
      var $59=$1;
      var $60=__ZNK15running_machine5inputEv($59);
      var $61=$joystick;
      var $62=(($61)|0);
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=__Z15input_field_seqPK18input_field_config15_input_seq_type($64, 0);
      var $66=__ZN13input_manager11seq_pressedERK9input_seq($60, $65);
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$joystick;
      var $69=(($68+17)|0);
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=$71 | 2;
      var $73=(($72) & 255);
      HEAP8[($69)]=$73;
      __label__ = 11; break;
    case 11: // $74
      var $75=$joystick;
      var $76=(($75)|0);
      var $77=(($76+8)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $80
      var $81=$1;
      var $82=__ZNK15running_machine5inputEv($81);
      var $83=$joystick;
      var $84=(($83)|0);
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=__Z15input_field_seqPK18input_field_config15_input_seq_type($86, 0);
      var $88=__ZN13input_manager11seq_pressedERK9input_seq($82, $87);
      if ($88) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $89
      var $90=$joystick;
      var $91=(($90+17)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=$93 | 4;
      var $95=(($94) & 255);
      HEAP8[($91)]=$95;
      __label__ = 14; break;
    case 14: // $96
      var $97=$joystick;
      var $98=(($97)|0);
      var $99=(($98+12)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $102
      var $103=$1;
      var $104=__ZNK15running_machine5inputEv($103);
      var $105=$joystick;
      var $106=(($105)|0);
      var $107=(($106+12)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=__Z15input_field_seqPK18input_field_config15_input_seq_type($108, 0);
      var $110=__ZN13input_manager11seq_pressedERK9input_seq($104, $109);
      if ($110) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $111
      var $112=$joystick;
      var $113=(($112+17)|0);
      var $114=HEAPU8[($113)];
      var $115=(($114)&255);
      var $116=$115 | 8;
      var $117=(($116) & 255);
      HEAP8[($113)]=$117;
      __label__ = 17; break;
    case 17: // $118
      var $119=$joystick;
      var $120=(($119+17)|0);
      var $121=HEAPU8[($120)];
      var $122=(($121)&255);
      var $123=$122 & 3;
      var $124=(($123)|0)==3;
      if ($124) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $125
      var $126=$joystick;
      var $127=(($126+17)|0);
      var $128=HEAPU8[($127)];
      var $129=(($128)&255);
      var $130=$129 & -4;
      var $131=(($130) & 255);
      HEAP8[($127)]=$131;
      __label__ = 19; break;
    case 19: // $132
      var $133=$joystick;
      var $134=(($133+17)|0);
      var $135=HEAPU8[($134)];
      var $136=(($135)&255);
      var $137=$136 & 12;
      var $138=(($137)|0)==12;
      if ($138) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $139
      var $140=$joystick;
      var $141=(($140+17)|0);
      var $142=HEAPU8[($141)];
      var $143=(($142)&255);
      var $144=$143 & -13;
      var $145=(($144) & 255);
      HEAP8[($141)]=$145;
      __label__ = 21; break;
    case 21: // $146
      var $147=$joystick;
      var $148=(($147+17)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$joystick;
      var $152=(($151+19)|0);
      var $153=HEAPU8[($152)];
      var $154=(($153)&255);
      var $155=(($150)|0)!=(($154)|0);
      if ($155) { __label__ = 22; break; } else { __label__ = 32; break; }
    case 22: // $156
      var $157=$joystick;
      var $158=(($157+17)|0);
      var $159=HEAP8[($158)];
      var $160=$joystick;
      var $161=(($160+18)|0);
      HEAP8[($161)]=$159;
      var $162=$joystick;
      var $163=(($162+18)|0);
      var $164=HEAPU8[($163)];
      var $165=(($164)&255);
      var $166=$165 & 3;
      var $167=(($166)|0)!=0;
      if ($167) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $168
      var $169=$joystick;
      var $170=(($169+18)|0);
      var $171=HEAPU8[($170)];
      var $172=(($171)&255);
      var $173=$172 & 12;
      var $174=(($173)|0)!=0;
      if ($174) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $175
      var $176=$joystick;
      var $177=(($176+18)|0);
      var $178=HEAPU8[($177)];
      var $179=(($178)&255);
      var $180=$joystick;
      var $181=(($180+19)|0);
      var $182=HEAPU8[($181)];
      var $183=(($182)&255);
      var $184=$179 & $183;
      var $185=$joystick;
      var $186=(($185+18)|0);
      var $187=HEAPU8[($186)];
      var $188=(($187)&255);
      var $189=$188 ^ $184;
      var $190=(($189) & 255);
      HEAP8[($186)]=$190;
      __label__ = 25; break;
    case 25: // $191
      var $192=$joystick;
      var $193=(($192+18)|0);
      var $194=HEAPU8[($193)];
      var $195=(($194)&255);
      var $196=$195 & 3;
      var $197=(($196)|0)!=0;
      if ($197) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $198
      var $199=$joystick;
      var $200=(($199+18)|0);
      var $201=HEAPU8[($200)];
      var $202=(($201)&255);
      var $203=$202 & 12;
      var $204=(($203)|0)!=0;
      if ($204) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $205
      var $206=$1;
      var $207=__ZN15running_machine4randEv($206);
      var $208=$207 & 1;
      var $209=(($208)|0)!=0;
      if ($209) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $210
      var $211=$joystick;
      var $212=(($211+18)|0);
      var $213=HEAPU8[($212)];
      var $214=(($213)&255);
      var $215=$214 & -13;
      var $216=(($215) & 255);
      HEAP8[($212)]=$216;
      __label__ = 30; break;
    case 29: // $217
      var $218=$joystick;
      var $219=(($218+18)|0);
      var $220=HEAPU8[($219)];
      var $221=(($220)&255);
      var $222=$221 & -4;
      var $223=(($222) & 255);
      HEAP8[($219)]=$223;
      __label__ = 30; break;
    case 30: // $224
      __label__ = 31; break;
    case 31: // $225
      __label__ = 32; break;
    case 32: // $226
      __label__ = 33; break;
    case 33: // $227
      __label__ = 34; break;
    case 34: // $228
      var $229=$joyindex;
      var $230=(($229+1)|0);
      $joyindex=$230;
      __label__ = 3; break;
    case 35: // $231
      __label__ = 36; break;
    case 36: // $232
      var $233=$player;
      var $234=(($233+1)|0);
      $player=$234;
      __label__ = 1; break;
    case 37: // $235
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30frame_update_digital_joysticksR15running_machine["X"]=1;

function __ZL25frame_update_analog_fieldR15running_machineP19_analog_field_state($machine, $analog) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $itemclass=__stackBase__;
      var $keypressed;
      var $keyscale=__stackBase__+4;
      var $rawvalue;
      var $delta;
      var $center;
      $1=$machine;
      $2=$analog;
      $keypressed=0;
      $delta=0;
      var $3=$2;
      var $4=$2;
      var $5=(($4+40)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__ZL20apply_analog_min_maxPK19_analog_field_statei($3, $6);
      var $8=$2;
      var $9=(($8+40)|0);
      HEAP32[(($9)>>2)]=$7;
      var $10=$2;
      var $11=(($10+44)|0);
      HEAP32[(($11)>>2)]=$7;
      var $12=$1;
      var $13=__ZNK15running_machine5inputEv($12);
      var $14=$2;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z15input_field_seqPK18input_field_config15_input_seq_type($16, 0);
      var $18=__ZN13input_manager14seq_axis_valueERK9input_seqR16input_item_class($13, $17, $itemclass);
      $rawvalue=$18;
      var $19=HEAP32[(($itemclass)>>2)];
      var $20=(($19)|0)==2;
      if ($20) { __label__ = 1; break; } else { __label__ = 18; break; }
    case 1: // $21
      var $22=$2;
      var $23=(($22+48)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$rawvalue;
      var $26=(($24)|0)!=(($25)|0);
      if ($26) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $27
      var $28=$rawvalue;
      var $29=$2;
      var $30=(($29+48)|0);
      HEAP32[(($30)>>2)]=$28;
      var $31=$2;
      var $32=(($31+108)|0);
      var $33=HEAP8[($32)];
      var $34=(($33 << 24) >> 24)!=0;
      if ($34) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $35
      var $36=$2;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+32)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 & 32;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      var $44=$rawvalue;
      var $45$0=$44;
      var $45$1=(($44|0) < 0 ? -1 : 0);
      var $$emscripten$temp$0$0=100;
      var $$emscripten$temp$0$1=0;
      var $46$0 = ((($45$0)>>>0)+((($45$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $46$1 = Math.min(Math.floor((((($45$0)>>>0)+((($45$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $47=$2;
      var $48=(($47+24)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50$0=$49;
      var $50$1=(($49|0) < 0 ? -1 : 0);
      var $51$0 = (tempBigIntR=((($46$0)>>>0)+((($46$1)|0)*4294967296))/((($50$0)>>>0)+((($50$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $51$1 = Math.min(Math.floor(((tempBigIntR=((($46$0)>>>0)+((($46$1)|0)*4294967296))/((($50$0)>>>0)+((($50$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $52$0=$51$0;
      var $52=$52$0;
      var $53=$2;
      var $54=(($53+40)|0);
      HEAP32[(($54)>>2)]=$52;
      __label__ = 12; break;
    case 5: // $55
      var $56=$2;
      var $57=(($56+100)|0);
      var $st$2$0=(($57)|0);
      var $58$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($57+4)|0);
      var $58$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $59=$58$0 != $$emscripten$temp$1$0 || $58$1 != $$emscripten$temp$1$1;
      if ($59) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $60
      var $61=$rawvalue;
      var $62=(($61+65536)|0);
      var $63$0=$62;
      var $63$1=(($62|0) < 0 ? -1 : 0);
      var $64=$2;
      var $65=(($64+100)|0);
      var $st$6$0=(($65)|0);
      var $66$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($65+4)|0);
      var $66$1=HEAP32[(($st$6$1)>>2)];
      var $67$0 = ((($63$0)>>>0)+((($63$1)|0)*4294967296))*((($66$0)>>>0)+((($66$1)|0)*4294967296))>>>0; var $67$1 = Math.min(Math.floor((((($63$0)>>>0)+((($63$1)|0)*4294967296))*((($66$0)>>>0)+((($66$1)|0)*4294967296)))/4294967296), 4294967295);
      var $68$0=($67$0 >>> 24) | ($67$1 << 8);
      var $68$1=($67$1 >> 24) | (((($67$1|0) < 0 ? -1 : 0)) << 8);
      var $$emscripten$temp$2$0=512;
      var $$emscripten$temp$2$1=0;
      var $69$0 = ((($68$0)>>>0)+((($68$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $69$1 = Math.min(Math.floor((((($68$0)>>>0)+((($68$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $70=$2;
      var $71=(($70+52)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73$0=$72;
      var $73$1=(($72|0) < 0 ? -1 : 0);
      var $74$0 = ((($69$0)>>>0)+((($69$1)|0)*4294967296))+((($73$0)>>>0)+((($73$1)|0)*4294967296))>>>0; var $74$1 = Math.min(Math.floor((((($69$0)>>>0)+((($69$1)|0)*4294967296))+((($73$0)>>>0)+((($73$1)|0)*4294967296)))/4294967296), 4294967295);
      var $75$0=$74$0;
      var $75=$75$0;
      $rawvalue=$75;
      var $76=$rawvalue;
      var $77=$2;
      var $78=(($77+56)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($76)|0) < (($79)|0);
      if ($80) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $81
      var $82=$rawvalue;
      var $88 = $82;__label__ = 9; break;
    case 8: // $83
      var $84=$2;
      var $85=(($84+56)|0);
      var $86=HEAP32[(($85)>>2)];
      var $88 = $86;__label__ = 9; break;
    case 9: // $87
      var $88;
      $rawvalue=$88;
      var $89=$rawvalue;
      var $90$0=$89;
      var $90$1=(($89|0) < 0 ? -1 : 0);
      var $$emscripten$temp$3$0=100;
      var $$emscripten$temp$3$1=0;
      var $91$0 = ((($90$0)>>>0)+((($90$1)|0)*4294967296))*((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $91$1 = Math.min(Math.floor((((($90$0)>>>0)+((($90$1)|0)*4294967296))*((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $92=$2;
      var $93=(($92+24)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95$0=$94;
      var $95$1=(($94|0) < 0 ? -1 : 0);
      var $96$0 = (tempBigIntR=((($91$0)>>>0)+((($91$1)|0)*4294967296))/((($95$0)>>>0)+((($95$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $96$1 = Math.min(Math.floor(((tempBigIntR=((($91$0)>>>0)+((($91$1)|0)*4294967296))/((($95$0)>>>0)+((($95$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $97$0=$96$0;
      var $97=$97$0;
      var $98=$2;
      var $99=(($98+40)|0);
      HEAP32[(($99)>>2)]=$97;
      __label__ = 11; break;
    case 10: // $100
      var $101=$rawvalue;
      var $102=$2;
      var $103=(($102+40)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104+$101)|0);
      HEAP32[(($103)>>2)]=$105;
      __label__ = 11; break;
    case 11: // $106
      __label__ = 12; break;
    case 12: // $107
      var $108=$2;
      var $109=(($108+113)|0);
      HEAP8[($109)]=0;
      __label__ = 55; break;
    case 13: // $110
      var $111=$2;
      var $112=(($111+108)|0);
      var $113=HEAP8[($112)];
      var $114=(($113 << 24) >> 24)!=0;
      if ($114) { __label__ = 16; break; } else { __label__ = 14; break; }
    case 14: // $115
      var $116=$2;
      var $117=(($116+100)|0);
      var $st$2$0=(($117)|0);
      var $118$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($117+4)|0);
      var $118$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $119=$118$0 == $$emscripten$temp$4$0 && $118$1 == $$emscripten$temp$4$1;
      if ($119) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $120
      var $121=$rawvalue;
      var $122=$2;
      var $123=(($122+40)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124+$121)|0);
      HEAP32[(($123)>>2)]=$125;
      __label__ = 16; break;
    case 16: // $126
      __label__ = 17; break;
    case 17: // $127
      __label__ = 18; break;
    case 18: // $128
      var $129=HEAP32[(($itemclass)>>2)];
      var $130=(($129)|0)==3;
      if ($130) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $131
      var $132=$rawvalue;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $134
      var $135=$rawvalue;
      $delta=$135;
      var $136=$2;
      var $137=(($136+113)|0);
      HEAP8[($137)]=0;
      __label__ = 21; break;
    case 21: // $138
      var $139=$2;
      var $140=(($139+40)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141)|0) >= 0;
      if ($142) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $143
      var $144=$2;
      var $145=(($144+84)|0);
      var $st$2$0=(($145)|0);
      var $146$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($145+4)|0);
      var $146$1=HEAP32[(($st$2$1)>>2)];
      var $152$1 = $146$1;var $152$0 = $146$0;__label__ = 24; break;
    case 23: // $147
      var $148=$2;
      var $149=(($148+92)|0);
      var $st$2$0=(($149)|0);
      var $150$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($149+4)|0);
      var $150$1=HEAP32[(($st$2$1)>>2)];
      var $152$1 = $150$1;var $152$0 = $150$0;__label__ = 24; break;
    case 24: // $151
      var $152$0;
      var $152$1;
      var $st$2$0=(($keyscale)|0);
      HEAP32[(($st$2$0)>>2)]=$152$0;
      var $st$2$1=(($keyscale+4)|0);
      HEAP32[(($st$2$1)>>2)]=$152$1;
      var $153=$1;
      var $154=__ZNK15running_machine5inputEv($153);
      var $155=$2;
      var $156=(($155+4)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=__Z15input_field_seqPK18input_field_config15_input_seq_type($157, 2);
      var $159=__ZN13input_manager11seq_pressedERK9input_seq($154, $158);
      if ($159) { __label__ = 25; break; } else { __label__ = 31; break; }
    case 25: // $160
      $keypressed=1;
      var $161=$2;
      var $162=(($161+32)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $165
      var $166=$2;
      var $167=(($166+32)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169$0=$168;
      var $169$1=(($168|0) < 0 ? -1 : 0);
      var $st$5$0=(($keyscale)|0);
      var $170$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($keyscale+4)|0);
      var $170$1=HEAP32[(($st$5$1)>>2)];
      var $171$0 = ((($169$0)>>>0)+((($169$1)|0)*4294967296))*((($170$0)>>>0)+((($170$1)|0)*4294967296))>>>0; var $171$1 = Math.min(Math.floor((((($169$0)>>>0)+((($169$1)|0)*4294967296))*((($170$0)>>>0)+((($170$1)|0)*4294967296)))/4294967296), 4294967295);
      var $172$0=($171$0 >>> 24) | ($171$1 << 8);
      var $172$1=($171$1 >> 24) | (((($171$1|0) < 0 ? -1 : 0)) << 8);
      var $173=$delta;
      var $174$0=$173;
      var $174$1=(($173|0) < 0 ? -1 : 0);
      var $175$0 = ((($174$0)>>>0)+((($174$1)|0)*4294967296))-((($172$0)>>>0)+((($172$1)|0)*4294967296))>>>0; var $175$1 = Math.min(Math.floor((((($174$0)>>>0)+((($174$1)|0)*4294967296))-((($172$0)>>>0)+((($172$1)|0)*4294967296)))/4294967296), 4294967295);
      var $176$0=$175$0;
      var $176=$176$0;
      $delta=$176;
      __label__ = 30; break;
    case 27: // $177
      var $178=$2;
      var $179=(($178+113)|0);
      var $180=HEAP8[($179)];
      var $181=(($180 << 24) >> 24)!=0;
      if ($181) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $182
      var $st$0$0=(($keyscale)|0);
      var $183$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($keyscale+4)|0);
      var $183$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$5$0=1;
      var $$emscripten$temp$5$1=0;
      var $184$0 = ((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))*((($183$0)>>>0)+((($183$1)|0)*4294967296))>>>0; var $184$1 = Math.min(Math.floor((((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))*((($183$0)>>>0)+((($183$1)|0)*4294967296)))/4294967296), 4294967295);
      var $185$0=($184$0 >>> 24) | ($184$1 << 8);
      var $185$1=($184$1 >> 24) | (((($184$1|0) < 0 ? -1 : 0)) << 8);
      var $186=$delta;
      var $187$0=$186;
      var $187$1=(($186|0) < 0 ? -1 : 0);
      var $188$0 = ((($187$0)>>>0)+((($187$1)|0)*4294967296))-((($185$0)>>>0)+((($185$1)|0)*4294967296))>>>0; var $188$1 = Math.min(Math.floor((((($187$0)>>>0)+((($187$1)|0)*4294967296))-((($185$0)>>>0)+((($185$1)|0)*4294967296)))/4294967296), 4294967295);
      var $189$0=$188$0;
      var $189=$189$0;
      $delta=$189;
      __label__ = 29; break;
    case 29: // $190
      __label__ = 30; break;
    case 30: // $191
      var $192=$2;
      var $193=(($192+113)|0);
      HEAP8[($193)]=1;
      __label__ = 31; break;
    case 31: // $194
      var $195=$1;
      var $196=__ZNK15running_machine5inputEv($195);
      var $197=$2;
      var $198=(($197+4)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=__Z15input_field_seqPK18input_field_config15_input_seq_type($199, 1);
      var $201=__ZN13input_manager11seq_pressedERK9input_seq($196, $200);
      if ($201) { __label__ = 32; break; } else { __label__ = 38; break; }
    case 32: // $202
      $keypressed=1;
      var $203=$2;
      var $204=(($203+32)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $207
      var $208=$2;
      var $209=(($208+32)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211$0=$210;
      var $211$1=(($210|0) < 0 ? -1 : 0);
      var $st$5$0=(($keyscale)|0);
      var $212$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($keyscale+4)|0);
      var $212$1=HEAP32[(($st$5$1)>>2)];
      var $213$0 = ((($211$0)>>>0)+((($211$1)|0)*4294967296))*((($212$0)>>>0)+((($212$1)|0)*4294967296))>>>0; var $213$1 = Math.min(Math.floor((((($211$0)>>>0)+((($211$1)|0)*4294967296))*((($212$0)>>>0)+((($212$1)|0)*4294967296)))/4294967296), 4294967295);
      var $214$0=($213$0 >>> 24) | ($213$1 << 8);
      var $214$1=($213$1 >> 24) | (((($213$1|0) < 0 ? -1 : 0)) << 8);
      var $215=$delta;
      var $216$0=$215;
      var $216$1=(($215|0) < 0 ? -1 : 0);
      var $217$0 = ((($216$0)>>>0)+((($216$1)|0)*4294967296))+((($214$0)>>>0)+((($214$1)|0)*4294967296))>>>0; var $217$1 = Math.min(Math.floor((((($216$0)>>>0)+((($216$1)|0)*4294967296))+((($214$0)>>>0)+((($214$1)|0)*4294967296)))/4294967296), 4294967295);
      var $218$0=$217$0;
      var $218=$218$0;
      $delta=$218;
      __label__ = 37; break;
    case 34: // $219
      var $220=$2;
      var $221=(($220+113)|0);
      var $222=HEAP8[($221)];
      var $223=(($222 << 24) >> 24)!=0;
      if ($223) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $224
      var $st$0$0=(($keyscale)|0);
      var $225$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($keyscale+4)|0);
      var $225$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$6$0=1;
      var $$emscripten$temp$6$1=0;
      var $226$0 = ((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))*((($225$0)>>>0)+((($225$1)|0)*4294967296))>>>0; var $226$1 = Math.min(Math.floor((((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))*((($225$0)>>>0)+((($225$1)|0)*4294967296)))/4294967296), 4294967295);
      var $227$0=($226$0 >>> 24) | ($226$1 << 8);
      var $227$1=($226$1 >> 24) | (((($226$1|0) < 0 ? -1 : 0)) << 8);
      var $228=$delta;
      var $229$0=$228;
      var $229$1=(($228|0) < 0 ? -1 : 0);
      var $230$0 = ((($229$0)>>>0)+((($229$1)|0)*4294967296))+((($227$0)>>>0)+((($227$1)|0)*4294967296))>>>0; var $230$1 = Math.min(Math.floor((((($229$0)>>>0)+((($229$1)|0)*4294967296))+((($227$0)>>>0)+((($227$1)|0)*4294967296)))/4294967296), 4294967295);
      var $231$0=$230$0;
      var $231=$231$0;
      $delta=$231;
      __label__ = 36; break;
    case 36: // $232
      __label__ = 37; break;
    case 37: // $233
      var $234=$2;
      var $235=(($234+113)|0);
      HEAP8[($235)]=1;
      __label__ = 38; break;
    case 38: // $236
      var $237=$2;
      var $238=(($237+4)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(($239+32)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=$241 & 32;
      var $243=(($242)|0)!=0;
      if ($243) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $244
      var $245=$2;
      var $246=(($245+40)|0);
      HEAP32[(($246)>>2)]=0;
      __label__ = 40; break;
    case 40: // $247
      var $248=$delta;
      var $249=$2;
      var $250=(($249+40)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($251+$248)|0);
      HEAP32[(($250)>>2)]=$252;
      var $253=$2;
      var $254=(($253+110)|0);
      var $255=HEAP8[($254)];
      var $256=(($255 << 24) >> 24)!=0;
      if ($256) { __label__ = 41; break; } else { __label__ = 52; break; }
    case 41: // $257
      var $258=$2;
      var $259=(($258+60)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261$0=$260;
      var $261$1=(($260|0) < 0 ? -1 : 0);
      var $$emscripten$temp$7$0=100;
      var $$emscripten$temp$7$1=0;
      var $262$0 = ((($261$0)>>>0)+((($261$1)|0)*4294967296))*((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296))>>>0; var $262$1 = Math.min(Math.floor((((($261$0)>>>0)+((($261$1)|0)*4294967296))*((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296)))/4294967296), 4294967295);
      var $263=$2;
      var $264=(($263+24)|0);
      var $265=HEAP32[(($264)>>2)];
      var $266$0=$265;
      var $266$1=(($265|0) < 0 ? -1 : 0);
      var $267$0 = (tempBigIntR=((($262$0)>>>0)+((($262$1)|0)*4294967296))/((($266$0)>>>0)+((($266$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $267$1 = Math.min(Math.floor(((tempBigIntR=((($262$0)>>>0)+((($262$1)|0)*4294967296))/((($266$0)>>>0)+((($266$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $268$0=$267$0;
      var $268=$268$0;
      $center=$268;
      var $269=$2;
      var $270=(($269+113)|0);
      var $271=HEAP8[($270)];
      var $272=(($271 << 24) >> 24)!=0;
      if ($272) { __label__ = 42; break; } else { __label__ = 51; break; }
    case 42: // $273
      var $274=$keypressed;
      var $275=(($274)|0)!=0;
      if ($275) { __label__ = 51; break; } else { __label__ = 43; break; }
    case 43: // $276
      var $277=$2;
      var $278=(($277+40)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=$center;
      var $281=(($279)|0) >= (($280)|0);
      if ($281) { __label__ = 44; break; } else { __label__ = 47; break; }
    case 44: // $282
      var $283=$2;
      var $284=(($283+36)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286$0=$285;
      var $286$1=(($285|0) < 0 ? -1 : 0);
      var $287=$2;
      var $288=(($287+84)|0);
      var $st$7$0=(($288)|0);
      var $289$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($288+4)|0);
      var $289$1=HEAP32[(($st$7$1)>>2)];
      var $290$0 = ((($286$0)>>>0)+((($286$1)|0)*4294967296))*((($289$0)>>>0)+((($289$1)|0)*4294967296))>>>0; var $290$1 = Math.min(Math.floor((((($286$0)>>>0)+((($286$1)|0)*4294967296))*((($289$0)>>>0)+((($289$1)|0)*4294967296)))/4294967296), 4294967295);
      var $291$0=($290$0 >>> 24) | ($290$1 << 8);
      var $291$1=($290$1 >> 24) | (((($290$1|0) < 0 ? -1 : 0)) << 8);
      var $292=$2;
      var $293=(($292+40)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295$0=$294;
      var $295$1=(($294|0) < 0 ? -1 : 0);
      var $296$0 = ((($295$0)>>>0)+((($295$1)|0)*4294967296))-((($291$0)>>>0)+((($291$1)|0)*4294967296))>>>0; var $296$1 = Math.min(Math.floor((((($295$0)>>>0)+((($295$1)|0)*4294967296))-((($291$0)>>>0)+((($291$1)|0)*4294967296)))/4294967296), 4294967295);
      var $297$0=$296$0;
      var $297=$297$0;
      HEAP32[(($293)>>2)]=$297;
      var $298=$2;
      var $299=(($298+40)|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=$center;
      var $302=(($300)|0) < (($301)|0);
      if ($302) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $303
      var $304=$center;
      var $305=$2;
      var $306=(($305+40)|0);
      HEAP32[(($306)>>2)]=$304;
      var $307=$2;
      var $308=(($307+113)|0);
      HEAP8[($308)]=0;
      __label__ = 46; break;
    case 46: // $309
      __label__ = 50; break;
    case 47: // $310
      var $311=$2;
      var $312=(($311+36)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314$0=$313;
      var $314$1=(($313|0) < 0 ? -1 : 0);
      var $315=$2;
      var $316=(($315+92)|0);
      var $st$7$0=(($316)|0);
      var $317$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($316+4)|0);
      var $317$1=HEAP32[(($st$7$1)>>2)];
      var $318$0 = ((($314$0)>>>0)+((($314$1)|0)*4294967296))*((($317$0)>>>0)+((($317$1)|0)*4294967296))>>>0; var $318$1 = Math.min(Math.floor((((($314$0)>>>0)+((($314$1)|0)*4294967296))*((($317$0)>>>0)+((($317$1)|0)*4294967296)))/4294967296), 4294967295);
      var $319$0=($318$0 >>> 24) | ($318$1 << 8);
      var $319$1=($318$1 >> 24) | (((($318$1|0) < 0 ? -1 : 0)) << 8);
      var $320=$2;
      var $321=(($320+40)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323$0=$322;
      var $323$1=(($322|0) < 0 ? -1 : 0);
      var $324$0 = ((($323$0)>>>0)+((($323$1)|0)*4294967296))+((($319$0)>>>0)+((($319$1)|0)*4294967296))>>>0; var $324$1 = Math.min(Math.floor((((($323$0)>>>0)+((($323$1)|0)*4294967296))+((($319$0)>>>0)+((($319$1)|0)*4294967296)))/4294967296), 4294967295);
      var $325$0=$324$0;
      var $325=$325$0;
      HEAP32[(($321)>>2)]=$325;
      var $326=$2;
      var $327=(($326+40)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=$center;
      var $330=(($328)|0) > (($329)|0);
      if ($330) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $331
      var $332=$center;
      var $333=$2;
      var $334=(($333+40)|0);
      HEAP32[(($334)>>2)]=$332;
      var $335=$2;
      var $336=(($335+113)|0);
      HEAP8[($336)]=0;
      __label__ = 49; break;
    case 49: // $337
      __label__ = 50; break;
    case 50: // $338
      __label__ = 51; break;
    case 51: // $339
      __label__ = 55; break;
    case 52: // $340
      var $341=$keypressed;
      var $342=(($341)|0)!=0;
      if ($342) { __label__ = 54; break; } else { __label__ = 53; break; }
    case 53: // $343
      var $344=$2;
      var $345=(($344+113)|0);
      HEAP8[($345)]=0;
      __label__ = 54; break;
    case 54: // $346
      __label__ = 55; break;
    case 55: // $347
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25frame_update_analog_fieldR15running_machineP19_analog_field_state["X"]=1;

function __ZN20dummy_profiler_state4stopEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZL29frame_get_digital_field_statePK18input_field_configi($field, $mouse_down) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curstate;
      var $changed;
      var $mask;
      $2=$field;
      $3=$mouse_down;
      var $4=$3;
      var $5=(($4)|0)!=0;
      if ($5) { var $14 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=$2;
      var $8=__ZNK18input_field_config7machineEv($7);
      var $9=__ZNK15running_machine5inputEv($8);
      var $10=$2;
      var $11=__Z15input_field_seqPK18input_field_config15_input_seq_type($10, 0);
      var $12=__ZN13input_manager11seq_pressedERK9input_seq($9, $11);
      var $14 = $12;__label__ = 2; break;
    case 2: // $13
      var $14;
      var $15=(($14)&1);
      $curstate=$15;
      $changed=0;
      var $16=$curstate;
      var $17=$2;
      var $18=(($17+400)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+205)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($16)|0)!=(($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$curstate;
      var $26=(($25) & 255);
      var $27=$2;
      var $28=(($27+400)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+205)|0);
      HEAP8[($30)]=$26;
      $changed=1;
      __label__ = 4; break;
    case 4: // $31
      var $32=$2;
      var $33=(($32+24)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)==46;
      if ($35) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $36
      var $37=$2;
      var $38=__ZNK18input_field_config7machineEv($37);
      var $39=__Z27ui_get_use_natural_keyboardR15running_machine($38);
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      $1=0;
      __label__ = 42; break;
    case 7: // $42
      var $43=$changed;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 8: // $45
      var $46=$curstate;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 9; break; } else { __label__ = 18; break; }
    case 9: // $48
      var $49=$2;
      var $50=(($49+36)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $54
      var $55=$2;
      var $56=(($55+400)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+204)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      var $63=$2;
      var $64=(($63+36)|0);
      var $65=HEAP8[($64)];
      var $66=$2;
      var $67=(($66+400)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+204)|0);
      HEAP8[($69)]=$65;
      __label__ = 12; break;
    case 12: // $70
      var $71=$2;
      var $72=(($71+32)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73 & 4;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $76
      var $77=$2;
      var $78=__ZNK18input_field_config11settinglistEv($77);
      var $79=__ZNK11simple_listI20input_setting_configE5countEv($78);
      var $80=(($79)|0)==0;
      if ($80) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $81
      var $82=$2;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=(($85+400)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87+200)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89 ^ $84;
      HEAP32[(($88)>>2)]=$90;
      __label__ = 16; break;
    case 15: // $91
      var $92=$2;
      __Z31input_field_select_next_settingPK18input_field_config($92);
      __label__ = 16; break;
    case 16: // $93
      __label__ = 17; break;
    case 17: // $94
      __label__ = 18; break;
    case 18: // $95
      var $96=$2;
      var $97=(($96+36)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $101
      var $102=$2;
      var $103=(($102+400)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104+204)|0);
      var $106=HEAPU8[($105)];
      var $107=(($106)&255);
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $109
      var $110=$2;
      var $111=(($110+400)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112+204)|0);
      var $114=HEAP8[($113)];
      var $115=(($114-1)&255);
      HEAP8[($113)]=$115;
      $curstate=1;
      __label__ = 22; break;
    case 21: // $116
      $curstate=0;
      __label__ = 22; break;
    case 22: // $117
      __label__ = 23; break;
    case 23: // $118
      var $119=$2;
      var $120=(($119+32)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121 & 4;
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $124
      $curstate=0;
      __label__ = 25; break;
    case 25: // $125
      var $126=$curstate;
      var $127=(($126)|0)!=0;
      if ($127) { __label__ = 26; break; } else { __label__ = 35; break; }
    case 26: // $128
      var $129=$3;
      var $130=(($129)|0)!=0;
      if ($130) { __label__ = 35; break; } else { __label__ = 27; break; }
    case 27: // $131
      var $132=$2;
      var $133=(($132+400)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+4)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 28; break; } else { __label__ = 35; break; }
    case 28: // $138
      var $139=$2;
      var $140=(($139+384)|0);
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=(($142)|0)!=16;
      if ($143) { __label__ = 29; break; } else { __label__ = 35; break; }
    case 29: // $144
      var $145=$2;
      var $146=(($145+384)|0);
      var $147=HEAPU8[($146)];
      var $148=(($147)&255);
      var $149=(($148)|0)==4;
      if ($149) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $150
      var $151=$2;
      var $152=(($151+400)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153+4)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+18)|0);
      var $157=HEAP8[($156)];
      var $167 = $157;__label__ = 32; break;
    case 31: // $158
      var $159=$2;
      var $160=(($159+400)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+4)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+17)|0);
      var $165=HEAP8[($164)];
      var $167 = $165;__label__ = 32; break;
    case 32: // $166
      var $167;
      $mask=$167;
      var $168=$mask;
      var $169=(($168)&255);
      var $170=$2;
      var $171=(($170+400)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172+206)|0);
      var $174=HEAPU8[($173)];
      var $175=(($174)&255);
      var $176=1 << $175;
      var $177=$169 & $176;
      var $178=(($177)|0)!=0;
      if ($178) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $179
      $curstate=0;
      __label__ = 34; break;
    case 34: // $180
      __label__ = 35; break;
    case 35: // $181
      var $182=$curstate;
      var $183=(($182)|0)!=0;
      if ($183) { __label__ = 36; break; } else { __label__ = 41; break; }
    case 36: // $184
      var $185=$2;
      var $186=(($185+24)|0);
      var $187=HEAPU32[(($186)>>2)];
      var $188=(($187)>>>0) >= 17;
      if ($188) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $189
      var $190=$2;
      var $191=(($190+24)|0);
      var $192=HEAPU32[(($191)>>2)];
      var $193=(($192)>>>0) <= 28;
      if ($193) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $194
      var $195=$2;
      var $196=__ZNK18input_field_config7machineEv($195);
      var $197=$2;
      var $198=(($197+24)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=(($199-17)|0);
      var $201=__Z22coin_lockout_get_stateR15running_machinei($196, $200);
      var $202=(($201)|0)!=0;
      if ($202) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $203
      var $204=$2;
      var $205=__ZNK18input_field_config7machineEv($204);
      var $206=__ZNK15running_machine7optionsEv($205);
      var $207=__ZNK11emu_options12coin_lockoutEv($206);
      if ($207) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $208
      var $209=$2;
      var $210=__Z16input_field_namePK18input_field_config($209);
      __Z13ui_popup_timeiPKcz(3, ((STRING_TABLE.__str1435)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$210,tempInt));
      $1=0;
      __label__ = 42; break;
    case 41: // $211
      var $212=$curstate;
      $1=$212;
      __label__ = 42; break;
    case 42: // $213
      var $214=$1;
      ;
      return $214;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29frame_get_digital_field_statePK18input_field_configi["X"]=1;

function __ZL22input_port_update_hookR15running_machinePK17input_port_configPj($machine, $port, $digital) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $portdata;
      var $keybuf;
      var $code;
      var $ch;
      var $i;
      var $value;
      $1=$machine;
      $2=$port;
      $3=$digital;
      var $4=$1;
      var $5=(($4+644)|0);
      var $6=HEAP32[(($5)>>2)];
      $portdata=$6;
      var $7=$1;
      var $8=__Z15inputx_can_postR15running_machine($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $10
      var $11=$1;
      var $12=__ZL10get_bufferR15running_machine($11);
      $keybuf=$12;
      var $13=$keybuf;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $15
      var $16=$keybuf;
      var $17=$16;
      var $18=(($17+8)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=$20 & 1;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $23
      var $24=$keybuf;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$keybuf;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($26)|0)!=(($29)|0);
      if ($30) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $31
      var $32=$keybuf;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$keybuf;
      var $36=(($35+12)|0);
      var $37=(($36+($34<<2))|0);
      var $38=HEAP32[(($37)>>2)];
      $ch=$38;
      var $39=$portdata;
      var $40=(($39+7456)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$ch;
      var $43=__ZL9find_codeP12_inputx_codej($41, $42);
      $code=$43;
      var $44=$code;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $46
      $i=0;
      __label__ = 6; break;
    case 6: // $47
      var $48=$i;
      var $49=(($48)>>>0) < 2;
      if ($49) { __label__ = 7; break; } else { var $58 = 0;__label__ = 8; break; }
    case 7: // $50
      var $51=$i;
      var $52=$code;
      var $53=(($52+4)|0);
      var $54=(($53+($51<<2))|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)!=0;
      var $58 = $56;__label__ = 8; break;
    case 8: // $57
      var $58;
      if ($58) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $59
      var $60=$i;
      var $61=$code;
      var $62=(($61+4)|0);
      var $63=(($62+($60<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=__ZNK18input_field_config4portEv($64);
      var $66=$2;
      var $67=(($65)|0)==(($66)|0);
      if ($67) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $68
      var $69=$i;
      var $70=$code;
      var $71=(($70+4)|0);
      var $72=(($71+($69<<2))|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      $value=$75;
      var $76=$value;
      var $77=$3;
      var $78=HEAP32[(($77)>>2)];
      var $79=$78 | $76;
      HEAP32[(($77)>>2)]=$79;
      __label__ = 11; break;
    case 11: // $80
      __label__ = 12; break;
    case 12: // $81
      var $82=$i;
      var $83=(($82+1)|0);
      $i=$83;
      __label__ = 6; break;
    case 13: // $84
      __label__ = 14; break;
    case 14: // $85
      __label__ = 15; break;
    case 15: // $86
      __label__ = 16; break;
    case 16: // $87
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22input_port_update_hookR15running_machinePK17input_port_configPj["X"]=1;

function __ZL13playback_portPK17input_port_config($port) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $analog;
      $1=$port;
      var $2=$1;
      var $3=__ZNK17input_port_config7machineEv($2);
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7440)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $10
      var $11=$1;
      var $12=__ZNK17input_port_config7machineEv($11);
      var $13=__ZL20playback_read_uint32R15running_machine($12);
      var $14=$1;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+12)|0);
      HEAP32[(($17)>>2)]=$13;
      var $18=$1;
      var $19=__ZNK17input_port_config7machineEv($18);
      var $20=__ZL20playback_read_uint32R15running_machine($19);
      var $21=$1;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+16)|0);
      HEAP32[(($24)>>2)]=$20;
      var $25=$1;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $analog=$29;
      __label__ = 2; break;
    case 2: // $30
      var $31=$analog;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $33
      var $34=$1;
      var $35=__ZNK17input_port_config7machineEv($34);
      var $36=__ZL20playback_read_uint32R15running_machine($35);
      var $37=$analog;
      var $38=(($37+40)|0);
      HEAP32[(($38)>>2)]=$36;
      var $39=$1;
      var $40=__ZNK17input_port_config7machineEv($39);
      var $41=__ZL20playback_read_uint32R15running_machine($40);
      var $42=$analog;
      var $43=(($42+44)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=$1;
      var $45=__ZNK17input_port_config7machineEv($44);
      var $46=__ZL20playback_read_uint32R15running_machine($45);
      var $47=$analog;
      var $48=(($47+24)|0);
      HEAP32[(($48)>>2)]=$46;
      var $49=$1;
      var $50=__ZNK17input_port_config7machineEv($49);
      var $51=__ZL19playback_read_uint8R15running_machine($50);
      var $52=$analog;
      var $53=(($52+28)|0);
      HEAP8[($53)]=$51;
      __label__ = 4; break;
    case 4: // $54
      var $55=$analog;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      $analog=$57;
      __label__ = 2; break;
    case 5: // $58
      __label__ = 6; break;
    case 6: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13playback_portPK17input_port_config["X"]=1;

function __ZL11record_portPK17input_port_config($port) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $portdata;
      var $analog;
      $1=$port;
      var $2=$1;
      var $3=__ZNK17input_port_config7machineEv($2);
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7436)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $10
      var $11=$1;
      var $12=__ZNK17input_port_config7machineEv($11);
      var $13=$1;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+12)|0);
      var $17=HEAP32[(($16)>>2)];
      __ZL19record_write_uint32R15running_machinej($12, $17);
      var $18=$1;
      var $19=__ZNK17input_port_config7machineEv($18);
      var $20=$1;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+16)|0);
      var $24=HEAP32[(($23)>>2)];
      __ZL19record_write_uint32R15running_machinej($19, $24);
      var $25=$1;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $analog=$29;
      __label__ = 2; break;
    case 2: // $30
      var $31=$analog;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $33
      var $34=$1;
      var $35=__ZNK17input_port_config7machineEv($34);
      var $36=$analog;
      var $37=(($36+40)|0);
      var $38=HEAP32[(($37)>>2)];
      __ZL19record_write_uint32R15running_machinej($35, $38);
      var $39=$1;
      var $40=__ZNK17input_port_config7machineEv($39);
      var $41=$analog;
      var $42=(($41+44)|0);
      var $43=HEAP32[(($42)>>2)];
      __ZL19record_write_uint32R15running_machinej($40, $43);
      var $44=$1;
      var $45=__ZNK17input_port_config7machineEv($44);
      var $46=$analog;
      var $47=(($46+24)|0);
      var $48=HEAP32[(($47)>>2)];
      __ZL19record_write_uint32R15running_machinej($45, $48);
      var $49=$1;
      var $50=__ZNK17input_port_config7machineEv($49);
      var $51=$analog;
      var $52=(($51+28)|0);
      var $53=HEAP8[($52)];
      __ZL18record_write_uint8R15running_machineh($50, $53);
      __label__ = 4; break;
    case 4: // $54
      var $55=$analog;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      $analog=$57;
      __label__ = 2; break;
    case 5: // $58
      __label__ = 6; break;
    case 6: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11record_portPK17input_port_config["X"]=1;

function __ZL19record_write_uint32R15running_machinej($machine, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $result=__stackBase__;
      $1=$machine;
      $2=$data;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$2;
      HEAP32[(($result)>>2)]=$6;
      var $7=$portdata;
      var $8=(($7+7436)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      __label__ = 4; break;
    case 2: // $12
      var $13=$portdata;
      var $14=(($13+7436)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$result;
      var $17=__ZN8emu_file5writeEPKvj($15, $16, 4);
      var $18=(($17)|0)!=4;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$1;
      __ZL10record_endR15running_machinePKc($20, ((STRING_TABLE.__str1429)|0));
      __label__ = 4; break;
    case 4: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18record_write_uint8R15running_machineh($machine, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $result=__stackBase__;
      $1=$machine;
      $2=$data;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$2;
      HEAP8[($result)]=$6;
      var $7=$portdata;
      var $8=(($7+7436)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      __label__ = 4; break;
    case 2: // $12
      var $13=$portdata;
      var $14=(($13+7436)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZN8emu_file5writeEPKvj($15, $result, 1);
      var $17=(($16)|0)!=1;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$1;
      __ZL10record_endR15running_machinePKc($19, ((STRING_TABLE.__str1429)|0));
      __label__ = 4; break;
    case 4: // $20
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10record_endR15running_machinePKc($machine, $message) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      $1=$machine;
      $2=$message;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7436)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=$1;
      var $12=__ZN15running_machine7respoolEv($11);
      var $13=$portdata;
      var $14=(($13+7436)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15;
      __ZN13resource_pool6removeEPv($12, $16);
      var $17=$portdata;
      var $18=(($17+7436)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=$2;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$2;
      __Z10popmessagePKcz(((STRING_TABLE.__str1430)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,tempInt));
      __label__ = 3; break;
    case 3: // $23
      __label__ = 4; break;
    case 4: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20playback_read_uint32R15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $result=__stackBase__;
      $2=$machine;
      var $3=$2;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7440)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=0;
      __label__ = 5; break;
    case 2: // $11
      var $12=$portdata;
      var $13=(($12+7440)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$result;
      var $16=__ZN8emu_file4readEPvj($14, $15, 4);
      var $17=(($16)|0)!=4;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      __ZL12playback_endR15running_machinePKc($19, ((STRING_TABLE.__str1431)|0));
      $1=0;
      __label__ = 5; break;
    case 4: // $20
      var $21=HEAP32[(($result)>>2)];
      $1=$21;
      __label__ = 5; break;
    case 5: // $22
      var $23=$1;
      STACKTOP = __stackBase__;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19playback_read_uint8R15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      var $result=__stackBase__;
      $2=$machine;
      var $3=$2;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7440)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=0;
      __label__ = 5; break;
    case 2: // $11
      var $12=$portdata;
      var $13=(($12+7440)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZN8emu_file4readEPvj($14, $result, 1);
      var $16=(($15)|0)!=1;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$2;
      __ZL12playback_endR15running_machinePKc($18, ((STRING_TABLE.__str1431)|0));
      $1=0;
      __label__ = 5; break;
    case 4: // $19
      var $20=HEAP8[($result)];
      $1=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      STACKTOP = __stackBase__;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12playback_endR15running_machinePKc($machine, $message) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $portdata;
      $1=$machine;
      $2=$message;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7440)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=$1;
      var $12=__ZN15running_machine7respoolEv($11);
      var $13=$portdata;
      var $14=(($13+7440)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15;
      __ZN13resource_pool6removeEPv($12, $16);
      var $17=$portdata;
      var $18=(($17+7440)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=$2;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$2;
      __Z10popmessagePKcz(((STRING_TABLE.__str1432)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,tempInt));
      __label__ = 3; break;
    case 3: // $23
      var $24=$portdata;
      var $25=(($24+7452)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27$0=$26;
      var $27$1=0;
      var $28=$portdata;
      var $29=(($28+7444)|0);
      var $st$7$0=(($29)|0);
      var $30$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($29+4)|0);
      var $30$1=HEAP32[(($st$7$1)>>2)];
      var $31$0 = Math.floor(((($30$0)>>>0)+((($30$1)|0)*4294967296))/((($27$0)>>>0)+((($27$1)|0)*4294967296)))>>>0; var $31$1 = Math.min(Math.floor((Math.floor(((($30$0)>>>0)+((($30$1)|0)*4294967296))/((($27$0)>>>0)+((($27$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$12$0=(($29)|0);
      HEAP32[(($st$12$0)>>2)]=$31$0;
      var $st$12$1=(($29+4)|0);
      HEAP32[(($st$12$1)>>2)]=$31$1;
      var $32=$portdata;
      var $33=(($32+7452)|0);
      var $34=HEAP32[(($33)>>2)];
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1433)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,tempInt));
      var $35=$portdata;
      var $36=(($35+7444)|0);
      var $st$22$0=(($36)|0);
      var $37$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($36+4)|0);
      var $37$1=HEAP32[(($st$22$1)>>2)];
      var $$emscripten$temp$0$0=200;
      var $$emscripten$temp$0$1=0;
      var $38$0 = ((($37$0)>>>0)+((($37$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $38$1 = Math.min(Math.floor((((($37$0)>>>0)+((($37$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $39$0 = ((($38$0)>>>0)+((($38$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $39$1 = Math.min(Math.floor((((($38$0)>>>0)+((($38$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $40$0=($39$0 >>> 21) | ($39$1 << 11);
      var $40$1=($39$1 >>> 21) | (0 << 11);
      var $41$0=$40$0;
      var $41=$41$0;
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1434)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$41,tempInt));
      __label__ = 4; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12playback_endR15running_machinePKc["X"]=1;

function __ZNK11emu_options12coin_lockoutEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str1436)|0));
  ;
  return $4;
}


function __ZNK12core_options10bool_valueEPKc($this, $name) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$name;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK12core_options5valueEPKc($3, $4);
  var $6=_atoi($5);
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZL20apply_analog_min_maxPK19_analog_field_statei($analog, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $adjmin;
      var $adjmax;
      var $adj1;
      var $range;
      $1=$analog;
      $2=$value;
      var $3=$1;
      var $4=(($3+52)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6$0=$5;
      var $6$1=(($5|0) < 0 ? -1 : 0);
      var $$emscripten$temp$0$0=100;
      var $$emscripten$temp$0$1=0;
      var $7$0 = ((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $8=$1;
      var $9=(($8+24)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11$0=$10;
      var $11$1=(($10|0) < 0 ? -1 : 0);
      var $12$0 = (tempBigIntR=((($7$0)>>>0)+((($7$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $12$1 = Math.min(Math.floor(((tempBigIntR=((($7$0)>>>0)+((($7$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $13$0=$12$0;
      var $13=$13$0;
      $adjmin=$13;
      var $14=$1;
      var $15=(($14+56)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17$0=$16;
      var $17$1=(($16|0) < 0 ? -1 : 0);
      var $$emscripten$temp$1$0=100;
      var $$emscripten$temp$1$1=0;
      var $18$0 = ((($17$0)>>>0)+((($17$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $18$1 = Math.min(Math.floor((((($17$0)>>>0)+((($17$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $19=$1;
      var $20=(($19+24)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22$0=$21;
      var $22$1=(($21|0) < 0 ? -1 : 0);
      var $23$0 = (tempBigIntR=((($18$0)>>>0)+((($18$1)|0)*4294967296))/((($22$0)>>>0)+((($22$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $23$1 = Math.min(Math.floor(((tempBigIntR=((($18$0)>>>0)+((($18$1)|0)*4294967296))/((($22$0)>>>0)+((($22$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $24$0=$23$0;
      var $24=$24$0;
      $adjmax=$24;
      var $25=$1;
      var $26=(($25+109)|0);
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24)!=0;
      if ($28) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $29
      var $30=$2;
      var $31=$adjmax;
      var $32=(($30)|0) > (($31)|0);
      if ($32) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $33
      var $34=$adjmax;
      $2=$34;
      __label__ = 6; break;
    case 3: // $35
      var $36=$2;
      var $37=$adjmin;
      var $38=(($36)|0) < (($37)|0);
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=$adjmin;
      $2=$40;
      __label__ = 5; break;
    case 5: // $41
      __label__ = 6; break;
    case 6: // $42
      __label__ = 14; break;
    case 7: // $43
      var $44=$1;
      var $45=(($44+24)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47$0=$46;
      var $47$1=(($46|0) < 0 ? -1 : 0);
      var $$emscripten$temp$2$0=51200;
      var $$emscripten$temp$2$1=0;
      var $48$0 = (tempBigIntR=((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))/((($47$0)>>>0)+((($47$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $48$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))/((($47$0)>>>0)+((($47$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $49$0=$48$0;
      var $49=$49$0;
      $adj1=$49;
      var $50=$adjmax;
      var $51=$adjmin;
      var $52=(($50-$51)|0);
      var $53=$adj1;
      var $54=(($52+$53)|0);
      $range=$54;
      var $55=$adj1;
      var $56=$adjmax;
      var $57=(($56+$55)|0);
      $adjmax=$57;
      var $58=$adj1;
      var $59=$adjmin;
      var $60=(($59-$58)|0);
      $adjmin=$60;
      __label__ = 8; break;
    case 8: // $61
      var $62=$2;
      var $63=$adjmax;
      var $64=(($62)|0) >= (($63)|0);
      if ($64) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $65
      var $66=$range;
      var $67=$2;
      var $68=(($67-$66)|0);
      $2=$68;
      __label__ = 8; break;
    case 10: // $69
      __label__ = 11; break;
    case 11: // $70
      var $71=$2;
      var $72=$adjmin;
      var $73=(($71)|0) <= (($72)|0);
      if ($73) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $74
      var $75=$range;
      var $76=$2;
      var $77=(($76+$75)|0);
      $2=$77;
      __label__ = 11; break;
    case 13: // $78
      __label__ = 14; break;
    case 14: // $79
      var $80=$2;
      ;
      return $80;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20apply_analog_min_maxPK19_analog_field_statei["X"]=1;

function __ZNK15running_machine5videoEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+1292)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13video_manager13speed_percentEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  var $4=(tempDoubleI32[0]=HEAP32[(($3)>>2)],tempDoubleI32[1]=HEAP32[(($3+4)>>2)],tempDoubleF64[0]);
  ;
  return $4;
}


function __ZNK15running_machine6pausedEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+1308)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { var $11 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($2+1304)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=3;
      var $11 = $9;__label__ = 2; break;
    case 2: // $10
      var $11;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19record_write_uint64R15running_machiney($machine, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $portdata;
      var $result=__stackBase__+8;
      $1=$machine;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$data$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$data$1;
      var $3=$1;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $st$13$0=(($2)|0);
      var $6$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($2+4)|0);
      var $6$1=HEAP32[(($st$13$1)>>2)];
      var $st$17$0=(($result)|0);
      HEAP32[(($st$17$0)>>2)]=$6$0;
      var $st$17$1=(($result+4)|0);
      HEAP32[(($st$17$1)>>2)]=$6$1;
      var $7=$portdata;
      var $8=(($7+7436)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      __label__ = 4; break;
    case 2: // $12
      var $13=$portdata;
      var $14=(($13+7436)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$result;
      var $17=__ZN8emu_file5writeEPKvj($15, $16, 8);
      var $18=(($17)|0)!=8;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$1;
      __ZL10record_endR15running_machinePKc($20, ((STRING_TABLE.__str1429)|0));
      __label__ = 4; break;
    case 4: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20playback_read_uint64R15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $portdata;
      var $result=__stackBase__+8;
      $2=$machine;
      var $3=$2;
      var $4=(($3+644)|0);
      var $5=HEAP32[(($4)>>2)];
      $portdata=$5;
      var $6=$portdata;
      var $7=(($6+7440)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 5; break;
    case 2: // $11
      var $12=$portdata;
      var $13=(($12+7440)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$result;
      var $16=__ZN8emu_file4readEPvj($14, $15, 8);
      var $17=(($16)|0)!=8;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      __ZL12playback_endR15running_machinePKc($19, ((STRING_TABLE.__str1431)|0));
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 5; break;
    case 4: // $20
      var $st$0$0=(($result)|0);
      var $21$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $21$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$21$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$21$1;
      __label__ = 5; break;
    case 5: // $22
      var $st$0$0=(($1)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$23$0,$23$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20playback_read_uint64R15running_machine["X"]=1;

function __ZN7astringC2EPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$3;
  var $5=__ZN7astring4initEv($3);
  var $6=$2;
  var $7=__ZN7astring3cpyEPKc($5, $6);
  ;
  return;
}


function __ZNK11emu_options12joystick_mapEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str1463)|0));
  ;
  return $4;
}


function __ZN18_input_field_stateC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18_input_field_stateC2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectI17_input_port_stateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17_input_port_stateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17_input_port_stateEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI18_input_field_stateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18_input_field_stateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18_input_field_stateEEPT_S3_["X"]=1;

function __ZNK13delegate_baseIjRK18input_field_configPv8_noparamS4_E6isnullEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $12 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      var $12 = $10;__label__ = 2; break;
    case 2: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13delegate_baseIvRK18input_field_configPvjjE6isnullEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $12 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      var $12 = $10;__label__ = 2; break;
    case 2: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14get_device_tagRK8device_tPKcR7astring($device, $tag, $finaltag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$device;
      $2=$tag;
      $3=$finaltag;
      var $4=$2;
      var $5=_strcmp($4, ((__ZL11DEVICE_SELF431)|0));
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$3;
      var $9=$1;
      var $10=__ZNK8device_t3tagEv($9);
      var $11=__ZN7astring3cpyEPKc($8, $10);
      __label__ = 8; break;
    case 2: // $12
      var $13=$2;
      var $14=_strcmp($13, ((STRING_TABLE.__ZL17DEVICE_SELF_OWNER)|0));
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$3;
      var $20=$1;
      var $21=__ZNK8device_t5ownerEv($20);
      var $22=__ZNK8device_t3tagEv($21);
      var $23=__ZN7astring3cpyEPKc($19, $22);
      __label__ = 7; break;
    case 6: // $24
      var $25=$1;
      var $26=$3;
      var $27=$2;
      var $28=__ZNK8device_t6subtagER7astringPKc($25, $26, $27);
      __label__ = 7; break;
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$3;
      var $32=__ZNK7astringcvPKcEv($31);
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_E9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_E4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN13delegate_baseIvRK18input_field_configPvjjE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIvRK18input_field_configPvjjE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN15running_machine6deviceEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=__ZNK15running_machine10devicelistEv($3);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK11tagged_listI8device_tE4findEPKc($5, $6);
  ;
  return $7;
}


function __ZN13delegate_baseIfRK18input_field_configf8_noparamS3_E9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIfRK18input_field_configf8_noparamS3_E4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZL21get_keyboard_key_namePK18input_field_config($field) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      var $i;
      var $ch;
      $1=$field;
      var $2=__Z13astring_allocv();
      $result=$2;
      $i=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$i;
      var $5=(($4)>>>0) < 3;
      if ($5) { __label__ = 2; break; } else { var $14 = 0;__label__ = 3; break; }
    case 2: // $6
      var $7=$i;
      var $8=$1;
      var $9=(($8+388)|0);
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      if ($14) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $15
      var $16=$1;
      var $17=$i;
      var $18=__ZL17get_keyboard_codePK18input_field_configi($16, $17);
      $ch=$18;
      var $19=$result;
      var $20=$result;
      var $21=__Z9astring_cPK7astring($20);
      var $22=$ch;
      var $23=__ZL15inputx_key_namej($22);
      var $24=__Z14astring_printfP7astringPKcz($19, ((STRING_TABLE.__str1460)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=2,HEAP32[((tempInt+8)>>2)]=$23,tempInt));
      __label__ = 5; break;
    case 5: // $25
      var $26=$i;
      var $27=(($26+1)|0);
      $i=$27;
      __label__ = 1; break;
    case 6: // $28
      var $29=$result;
      var $30=__Z17astring_trimspaceP7astring($29);
      var $31=$result;
      var $32=__Z11astring_lenPK7astring($31);
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$result;
      var $36=__Z12astring_cpycP7astringPKc($35, ((STRING_TABLE.__str1461)|0));
      __label__ = 8; break;
    case 8: // $37
      var $38=$result;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23init_field_analog_statePK18input_field_config($field) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $state;
      var $mask;
      $7=$field;
      var $8=$7;
      var $9=__ZNK18input_field_config7machineEv($8);
      var $10=__ZN15running_machine7respoolEv($9);
      var $11=$1;
      var $12=$2;
      var $13=$3;
      var $14=$4;
      var $15=$result_i;
      var $16=$5;
      var $17=$6;
      HEAP32[(($1)>>2)]=116;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=2161;
      HEAP32[(($4)>>2)]=_zeromem;
      var $18=HEAP32[(($1)>>2)];
      var $19=HEAP32[(($2)>>2)];
      var $20=HEAP32[(($3)>>2)];
      var $21=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18, $19, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $22
      HEAP32[(($result_i)>>2)]=$21;
      var $23=HEAP32[(($result_i)>>2)];
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $25
      var $26=___cxa_allocate_exception(4);
      var $27=$26;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27);
      (function() { try { __THREW__ = false; return ___cxa_throw($26, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      HEAP32[(($5)>>2)]=$30;
      var $31=$29.f1;
      HEAP32[(($6)>>2)]=$31;
      var $32=HEAP32[(($6)>>2)];
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $34
      var $35=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($35);
      throw "Reached an unreachable!"
    case 5: // $36
      var $37=HEAP32[(($5)>>2)];
      var $38=HEAP32[(($5)>>2)];
      var $39=HEAP32[(($6)>>2)];
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $42
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $43=HEAP32[(($result_i)>>2)];
      var $44=HEAP32[(($1)>>2)];
      _memset($43, 0, $44, 1);
      var $45=HEAP32[(($result_i)>>2)];
      var $46=$1;
      var $47=$2;
      var $48=$3;
      var $49=$4;
      var $50=$result_i;
      var $51=$5;
      var $52=$6;
      var $53=$45;
      var $54=__ZN13resource_pool10add_objectI19_analog_field_stateEEPT_S3_($10, $53);
      $state=$54;
      var $55=$7;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      $mask=$57;
      __label__ = 8; break;
    case 8: // $58
      var $59=$mask;
      var $60=$59 & 1;
      var $61=(($60)|0)!=0;
      var $62=$61 ^ 1;
      if ($62) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $63
      var $64=$state;
      var $65=(($64+8)|0);
      var $66=HEAP8[($65)];
      var $67=(($66+1)&255);
      HEAP8[($65)]=$67;
      __label__ = 10; break;
    case 10: // $68
      var $69=$mask;
      var $70=$69 >>> 1;
      $mask=$70;
      __label__ = 8; break;
    case 11: // $71
      var $72=$7;
      var $73=$state;
      var $74=(($73+4)|0);
      HEAP32[(($74)>>2)]=$72;
      var $75=$7;
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$7;
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$77 & $80;
      var $82=$state;
      var $83=(($82+8)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$81 >>> (($85)>>>0);
      var $87=$state;
      var $88=(($87+12)|0);
      HEAP32[(($88)>>2)]=$86;
      var $89=$7;
      var $90=(($89+300)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$7;
      var $93=(($92)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$91 & $94;
      var $96=$state;
      var $97=(($96+8)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$95 >>> (($99)>>>0);
      var $101=$state;
      var $102=(($101+16)|0);
      HEAP32[(($102)>>2)]=$100;
      var $103=$7;
      var $104=(($103+304)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$7;
      var $107=(($106)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$105 & $108;
      var $110=$state;
      var $111=(($110+8)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=$109 >>> (($113)>>>0);
      var $115=$state;
      var $116=(($115+20)|0);
      HEAP32[(($116)>>2)]=$114;
      var $117=$7;
      var $118=(($117+308)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$state;
      var $121=(($120+24)|0);
      HEAP32[(($121)>>2)]=$119;
      var $122=$7;
      var $123=(($122+32)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$124 & 16;
      var $126=(($125)|0)!=0;
      var $127=(($126)&1);
      var $128=$state;
      var $129=(($128+28)|0);
      HEAP8[($129)]=$127;
      var $130=$7;
      var $131=(($130+312)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$state;
      var $134=(($133+32)|0);
      HEAP32[(($134)>>2)]=$132;
      var $135=$7;
      var $136=(($135+316)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$state;
      var $139=(($138+36)|0);
      HEAP32[(($139)>>2)]=$137;
      var $140=$state;
      var $141=(($140+52)|0);
      HEAP32[(($141)>>2)]=-65536;
      var $142=$state;
      var $143=(($142+56)|0);
      HEAP32[(($143)>>2)]=65536;
      var $144=$7;
      var $145=(($144+24)|0);
      var $146=HEAP32[(($145)>>2)];
      if ($146 == 147 || $146 == 148 || $146 == 149) {
        __label__ = 12; break;
      }
      else if ($146 == 142 || $146 == 143 || $146 == 144 || $146 == 140 || $146 == 141) {
        __label__ = 13; break;
      }
      else if ($146 == 145 || $146 == 146) {
        __label__ = 14; break;
      }
      else if ($146 == 152 || $146 == 153 || $146 == 156 || $146 == 157 || $146 == 154 || $146 == 155) {
        __label__ = 15; break;
      }
      else if ($146 == 150 || $146 == 151) {
        __label__ = 16; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 12: // $147
      var $148=$state;
      var $149=(($148+60)|0);
      HEAP32[(($149)>>2)]=-65536;
      var $150=$state;
      var $151=(($150+60)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153$0=$152;
      var $153$1=(($152|0) < 0 ? -1 : 0);
      var $$emscripten$temp$0$0=100;
      var $$emscripten$temp$0$1=0;
      var $154$0 = ((($153$0)>>>0)+((($153$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $154$1 = Math.min(Math.floor((((($153$0)>>>0)+((($153$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $155=$state;
      var $156=(($155+24)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158$0=$157;
      var $158$1=(($157|0) < 0 ? -1 : 0);
      var $159$0 = (tempBigIntR=((($154$0)>>>0)+((($154$1)|0)*4294967296))/((($158$0)>>>0)+((($158$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $159$1 = Math.min(Math.floor(((tempBigIntR=((($154$0)>>>0)+((($154$1)|0)*4294967296))/((($158$0)>>>0)+((($158$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $160$0=$159$0;
      var $160=$160$0;
      var $161=$state;
      var $162=(($161+40)|0);
      HEAP32[(($162)>>2)]=$160;
      var $163=$state;
      var $164=(($163+108)|0);
      HEAP8[($164)]=1;
      var $165=$state;
      var $166=(($165+110)|0);
      HEAP8[($166)]=1;
      var $167=$state;
      var $168=(($167+112)|0);
      HEAP8[($168)]=1;
      __label__ = 18; break;
    case 13: // $169
      var $170=$state;
      var $171=(($170+108)|0);
      HEAP8[($171)]=1;
      var $172=$state;
      var $173=(($172+110)|0);
      HEAP8[($173)]=1;
      var $174=$state;
      var $175=(($174+112)|0);
      HEAP8[($175)]=1;
      __label__ = 18; break;
    case 14: // $176
      var $177=$state;
      var $178=(($177+108)|0);
      HEAP8[($178)]=1;
      var $179=$state;
      var $180=(($179+110)|0);
      HEAP8[($180)]=0;
      var $181=$state;
      var $182=(($181+112)|0);
      HEAP8[($182)]=0;
      __label__ = 18; break;
    case 15: // $183
      var $184=$state;
      var $185=(($184+108)|0);
      HEAP8[($185)]=0;
      var $186=$state;
      var $187=(($186+109)|0);
      HEAP8[($187)]=1;
      var $188=$state;
      var $189=(($188+112)|0);
      HEAP8[($189)]=1;
      __label__ = 18; break;
    case 16: // $190
      var $191=$7;
      var $192=(($191+304)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194$0=$193;
      var $194$1=(($193|0) < 0 ? -1 : 0);
      var $195$0=($194$0 << 24) | (0 >>> 8);
      var $195$1=($194$1 << 24) | ($194$0 >>> 8);
      var $$emscripten$temp$1$0=131072;
      var $$emscripten$temp$1$1=0;
      var $196$0 = (tempBigIntR=((($195$0)>>>0)+((($195$1)|0)*4294967296))/((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $196$1 = Math.min(Math.floor(((tempBigIntR=((($195$0)>>>0)+((($195$1)|0)*4294967296))/((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $197=$state;
      var $198=(($197+100)|0);
      var $st$12$0=(($198)|0);
      HEAP32[(($st$12$0)>>2)]=$196$0;
      var $st$12$1=(($198+4)|0);
      HEAP32[(($st$12$1)>>2)]=$196$1;
      var $199=$state;
      var $200=(($199+16)|0);
      HEAP32[(($200)>>2)]=0;
      var $201=$7;
      var $202=(($201+304)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(($203-1)|0);
      var $205=$state;
      var $206=(($205+20)|0);
      HEAP32[(($206)>>2)]=$204;
      var $207=$7;
      var $208=(($207+32)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$209 & 64;
      var $211=(($210)|0)!=0;
      var $212=(($211)&1);
      var $213=$state;
      var $214=(($213+109)|0);
      HEAP8[($214)]=$212;
      var $215=$state;
      var $216=(($215+109)|0);
      var $217=HEAP8[($216)];
      var $218=(($217 << 24) >> 24)!=0;
      var $219=$218 ^ 1;
      var $220=(($219)&1);
      var $221=$state;
      var $222=(($221+110)|0);
      HEAP8[($222)]=$220;
      __label__ = 18; break;
    case 17: // $223
      __Z10fatalerrorPKcz(((STRING_TABLE.__str1462)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 18: // $224
      var $225=$state;
      var $226=(($225+108)|0);
      var $227=HEAP8[($226)];
      var $228=(($227 << 24) >> 24)!=0;
      if ($228) { __label__ = 19; break; } else { __label__ = 29; break; }
    case 19: // $229
      var $230=$state;
      var $231=(($230+12)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=$state;
      var $234=(($233+16)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($232)|0)==(($235)|0);
      if ($236) { var $246 = 1;__label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $237
      var $238=$state;
      var $239=(($238+12)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$state;
      var $242=(($241+20)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($240)|0)==(($243)|0);
      var $246 = $244;__label__ = 21; break;
    case 21: // $245
      var $246;
      var $247=(($246)&1);
      var $248=$state;
      var $249=(($248+111)|0);
      HEAP8[($249)]=$247;
      var $250=$state;
      var $251=(($250+111)|0);
      var $252=HEAP8[($251)];
      var $253=(($252 << 24) >> 24)!=0;
      if ($253) { __label__ = 25; break; } else { __label__ = 22; break; }
    case 22: // $254
      var $255=$state;
      var $256=(($255+20)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=$state;
      var $259=(($258+12)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=(($257-$260)|0);
      var $262$0=$261;
      var $262$1=(($261|0) < 0 ? -1 : 0);
      var $263$0=($262$0 << 24) | (0 >>> 8);
      var $263$1=($262$1 << 24) | ($262$0 >>> 8);
      var $$emscripten$temp$2$0=65536;
      var $$emscripten$temp$2$1=0;
      var $264$0 = (tempBigIntR=((($263$0)>>>0)+((($263$1)|0)*4294967296))/((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $264$1 = Math.min(Math.floor(((tempBigIntR=((($263$0)>>>0)+((($263$1)|0)*4294967296))/((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $265=$state;
      var $266=(($265+68)|0);
      var $st$16$0=(($266)|0);
      HEAP32[(($st$16$0)>>2)]=$264$0;
      var $st$16$1=(($266+4)|0);
      HEAP32[(($st$16$1)>>2)]=$264$1;
      var $267=$state;
      var $268=(($267+12)|0);
      var $269=HEAP32[(($268)>>2)];
      var $270=$state;
      var $271=(($270+16)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($269-$272)|0);
      var $274$0=$273;
      var $274$1=(($273|0) < 0 ? -1 : 0);
      var $275$0=($274$0 << 24) | (0 >>> 8);
      var $275$1=($274$1 << 24) | ($274$0 >>> 8);
      var $$emscripten$temp$3$0=65536;
      var $$emscripten$temp$3$1=0;
      var $276$0 = (tempBigIntR=((($275$0)>>>0)+((($275$1)|0)*4294967296))/((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $276$1 = Math.min(Math.floor(((tempBigIntR=((($275$0)>>>0)+((($275$1)|0)*4294967296))/((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $277=$state;
      var $278=(($277+76)|0);
      var $st$36$0=(($278)|0);
      HEAP32[(($st$36$0)>>2)]=$276$0;
      var $st$36$1=(($278+4)|0);
      HEAP32[(($st$36$1)>>2)]=$276$1;
      var $279=$state;
      var $280=(($279+16)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=$state;
      var $283=(($282+20)|0);
      var $284=HEAP32[(($283)>>2)];
      var $285=(($281)|0) > (($284)|0);
      if ($285) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $286
      var $287=$state;
      var $288=(($287+76)|0);
      var $st$2$0=(($288)|0);
      var $289$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($288+4)|0);
      var $289$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $290$0 = ((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))-((($289$0)>>>0)+((($289$1)|0)*4294967296))>>>0; var $290$1 = Math.min(Math.floor((((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))-((($289$0)>>>0)+((($289$1)|0)*4294967296)))/4294967296), 4294967295);
      var $291=$state;
      var $292=(($291+76)|0);
      var $st$11$0=(($292)|0);
      HEAP32[(($st$11$0)>>2)]=$290$0;
      var $st$11$1=(($292+4)|0);
      HEAP32[(($st$11$1)>>2)]=$290$1;
      __label__ = 24; break;
    case 24: // $293
      var $294=$state;
      var $295=(($294+64)|0);
      HEAP32[(($295)>>2)]=0;
      __label__ = 28; break;
    case 25: // $296
      var $297=$state;
      var $298=(($297+20)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=$state;
      var $301=(($300+16)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=(($299-$302)|0);
      var $304$0=$303;
      var $304$1=(($303|0) < 0 ? -1 : 0);
      var $305$0=($304$0 << 24) | (0 >>> 8);
      var $305$1=($304$1 << 24) | ($304$0 >>> 8);
      var $$emscripten$temp$5$0=131072;
      var $$emscripten$temp$5$1=0;
      var $306$0 = (tempBigIntR=((($305$0)>>>0)+((($305$1)|0)*4294967296))/((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $306$1 = Math.min(Math.floor(((tempBigIntR=((($305$0)>>>0)+((($305$1)|0)*4294967296))/((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $307=$state;
      var $308=(($307+68)|0);
      var $st$16$0=(($308)|0);
      HEAP32[(($st$16$0)>>2)]=$306$0;
      var $st$16$1=(($308+4)|0);
      HEAP32[(($st$16$1)>>2)]=$306$1;
      var $309=$state;
      var $310=(($309+12)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=$state;
      var $313=(($312+20)|0);
      var $314=HEAP32[(($313)>>2)];
      var $315=(($311)|0)==(($314)|0);
      if ($315) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $316
      var $317=$state;
      var $318=(($317+68)|0);
      var $st$2$0=(($318)|0);
      var $319$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($318+4)|0);
      var $319$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      var $320$0 = ((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))-((($319$0)>>>0)+((($319$1)|0)*4294967296))>>>0; var $320$1 = Math.min(Math.floor((((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))-((($319$0)>>>0)+((($319$1)|0)*4294967296)))/4294967296), 4294967295);
      var $321=$state;
      var $322=(($321+68)|0);
      var $st$11$0=(($322)|0);
      HEAP32[(($st$11$0)>>2)]=$320$0;
      var $st$11$1=(($322+4)|0);
      HEAP32[(($st$11$1)>>2)]=$320$1;
      __label__ = 27; break;
    case 27: // $323
      var $324=$state;
      var $325=(($324+68)|0);
      var $st$2$0=(($325)|0);
      var $326$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($325+4)|0);
      var $326$1=HEAP32[(($st$2$1)>>2)];
      var $327=$state;
      var $328=(($327+76)|0);
      var $st$8$0=(($328)|0);
      HEAP32[(($st$8$0)>>2)]=$326$0;
      var $st$8$1=(($328+4)|0);
      HEAP32[(($st$8$1)>>2)]=$326$1;
      var $329=$state;
      var $330=(($329+56)|0);
      var $331=HEAP32[(($330)>>2)];
      var $332=$state;
      var $333=(($332+64)|0);
      HEAP32[(($333)>>2)]=$331;
      __label__ = 28; break;
    case 28: // $334
      __label__ = 37; break;
    case 29: // $335
      var $336=$state;
      var $337=(($336+16)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=$state;
      var $340=(($339+20)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=(($338)|0) > (($341)|0);
      if ($342) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $343
      var $344=$state;
      var $345=(($344+16)|0);
      var $346=HEAP32[(($345)>>2)];
      var $347=(((-$346))|0);
      var $348=$state;
      var $349=(($348+16)|0);
      HEAP32[(($349)>>2)]=$347;
      __label__ = 31; break;
    case 31: // $350
      var $351=$state;
      var $352=(($351+16)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=$state;
      var $355=(($354+12)|0);
      var $356=HEAP32[(($355)>>2)];
      var $357=(($353-$356)|0);
      var $358=((($357<<9))|0);
      var $359=$state;
      var $360=(($359+52)|0);
      HEAP32[(($360)>>2)]=$358;
      var $361=$state;
      var $362=(($361+20)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=$state;
      var $365=(($364+12)|0);
      var $366=HEAP32[(($365)>>2)];
      var $367=(($363-$366)|0);
      var $368=((($367<<9))|0);
      var $369=$state;
      var $370=(($369+56)|0);
      HEAP32[(($370)>>2)]=$368;
      var $371=$state;
      var $372=(($371+68)|0);
      var $$emscripten$temp$7$0=32768;
      var $$emscripten$temp$7$1=0;
      var $st$26$0=(($372)|0);
      HEAP32[(($st$26$0)>>2)]=$$emscripten$temp$7$0;
      var $st$26$1=(($372+4)|0);
      HEAP32[(($st$26$1)>>2)]=$$emscripten$temp$7$1;
      var $373=$state;
      var $374=(($373+76)|0);
      var $$emscripten$temp$8$0=32768;
      var $$emscripten$temp$8$1=0;
      var $st$34$0=(($374)|0);
      HEAP32[(($st$34$0)>>2)]=$$emscripten$temp$8$0;
      var $st$34$1=(($374+4)|0);
      HEAP32[(($st$34$1)>>2)]=$$emscripten$temp$8$1;
      var $375=$7;
      var $376=(($375+32)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=$377 & 32;
      var $379=(($378)|0)!=0;
      if ($379) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $380
      var $381=$state;
      var $382=(($381+64)|0);
      HEAP32[(($382)>>2)]=0;
      __label__ = 36; break;
    case 33: // $383
      var $384=$state;
      var $385=(($384+56)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=$state;
      var $388=(($387+52)|0);
      var $389=HEAP32[(($388)>>2)];
      var $390=(($386+$389)|0);
      var $391=$state;
      var $392=(($391+64)|0);
      HEAP32[(($392)>>2)]=$390;
      var $393=$state;
      var $394=(($393+100)|0);
      var $st$12$0=(($394)|0);
      var $395$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($394+4)|0);
      var $395$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$9$0=0;
      var $$emscripten$temp$9$1=0;
      var $396=$395$0 == $$emscripten$temp$9$0 && $395$1 == $$emscripten$temp$9$1;
      if ($396) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $397
      var $398=$state;
      var $399=(($398+64)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=(($400+512)|0);
      HEAP32[(($399)>>2)]=$401;
      __label__ = 35; break;
    case 35: // $402
      __label__ = 36; break;
    case 36: // $403
      __label__ = 37; break;
    case 37: // $404
      var $405=$state;
      var $406=(($405+68)|0);
      var $st$2$0=(($406)|0);
      var $407$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($406+4)|0);
      var $407$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$10$0=0;
      var $$emscripten$temp$10$1=65536;
      var $408$0 = (tempBigIntR=((($$emscripten$temp$10$0)>>>0)+((($$emscripten$temp$10$1)|0)*4294967296))/((($407$0)>>>0)+((($407$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $408$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$10$0)>>>0)+((($$emscripten$temp$10$1)|0)*4294967296))/((($407$0)>>>0)+((($407$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $409=$state;
      var $410=(($409+84)|0);
      var $st$11$0=(($410)|0);
      HEAP32[(($st$11$0)>>2)]=$408$0;
      var $st$11$1=(($410+4)|0);
      HEAP32[(($st$11$1)>>2)]=$408$1;
      var $411=$state;
      var $412=(($411+76)|0);
      var $st$17$0=(($412)|0);
      var $413$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($412+4)|0);
      var $413$1=HEAP32[(($st$17$1)>>2)];
      var $$emscripten$temp$11$0=0;
      var $$emscripten$temp$11$1=65536;
      var $414$0 = (tempBigIntR=((($$emscripten$temp$11$0)>>>0)+((($$emscripten$temp$11$1)|0)*4294967296))/((($413$0)>>>0)+((($413$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $414$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$11$0)>>>0)+((($$emscripten$temp$11$1)|0)*4294967296))/((($413$0)>>>0)+((($413$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $415=$state;
      var $416=(($415+92)|0);
      var $st$26$0=(($416)|0);
      HEAP32[(($st$26$0)>>2)]=$414$0;
      var $st$26$1=(($416+4)|0);
      HEAP32[(($st$26$1)>>2)]=$414$1;
      var $417=$state;
      STACKTOP = __stackBase__;
      return $417;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23init_field_analog_statePK18input_field_config["X"]=1;

function __ZL22init_field_device_infoPK18input_field_configPKc($field, $device_name) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $info;
      var $mask;
      $7=$field;
      $8=$device_name;
      var $9=$7;
      var $10=__ZNK18input_field_config7machineEv($9);
      var $11=__ZN15running_machine7respoolEv($10);
      var $12=$1;
      var $13=$2;
      var $14=$3;
      var $15=$4;
      var $16=$result_i;
      var $17=$5;
      var $18=$6;
      HEAP32[(($1)>>2)]=20;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1337)|0);
      HEAP32[(($3)>>2)]=2136;
      HEAP32[(($4)>>2)]=_zeromem;
      var $19=HEAP32[(($1)>>2)];
      var $20=HEAP32[(($2)>>2)];
      var $21=HEAP32[(($3)>>2)];
      var $22=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19, $20, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $23
      HEAP32[(($result_i)>>2)]=$22;
      var $24=HEAP32[(($result_i)>>2)];
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $26
      var $27=___cxa_allocate_exception(4);
      var $28=$27;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28);
      (function() { try { __THREW__ = false; return ___cxa_throw($27, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      HEAP32[(($5)>>2)]=$31;
      var $32=$30.f1;
      HEAP32[(($6)>>2)]=$32;
      var $33=HEAP32[(($6)>>2)];
      var $34=(($33)|0) < 0;
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($36);
      throw "Reached an unreachable!"
    case 5: // $37
      var $38=HEAP32[(($5)>>2)];
      var $39=HEAP32[(($5)>>2)];
      var $40=HEAP32[(($6)>>2)];
      var $41=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39, tempValue);
      var $42=($41.f1 = $40, $41);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $43
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $44=HEAP32[(($result_i)>>2)];
      var $45=HEAP32[(($1)>>2)];
      _memset($44, 0, $45, 1);
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$1;
      var $48=$2;
      var $49=$3;
      var $50=$4;
      var $51=$result_i;
      var $52=$5;
      var $53=$6;
      var $54=$46;
      var $55=__ZN13resource_pool10add_objectI18_device_field_infoEEPT_S3_($11, $54);
      $info=$55;
      var $56=$7;
      var $57=$info;
      var $58=(($57+4)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=$7;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      $mask=$61;
      __label__ = 8; break;
    case 8: // $62
      var $63=$mask;
      var $64=$63 & 1;
      var $65=(($64)|0)!=0;
      var $66=$65 ^ 1;
      if ($66) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $67
      var $68=$info;
      var $69=(($68+12)|0);
      var $70=HEAP8[($69)];
      var $71=(($70+1)&255);
      HEAP8[($69)]=$71;
      __label__ = 10; break;
    case 10: // $72
      var $73=$mask;
      var $74=$73 >>> 1;
      $mask=$74;
      __label__ = 8; break;
    case 11: // $75
      var $76=$8;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $78
      var $79=$7;
      var $80=__ZNK18input_field_config7machineEv($79);
      var $81=$8;
      var $82=__ZN15running_machine6deviceEPKc($80, $81);
      var $88 = $82;__label__ = 14; break;
    case 13: // $83
      var $84=$7;
      var $85=__ZNK18input_field_config4portEv($84);
      var $86=__ZNK17input_port_config5ownerEv($85);
      var $88 = $86;__label__ = 14; break;
    case 14: // $87
      var $88;
      var $89=$info;
      var $90=(($89+8)|0);
      HEAP32[(($90)>>2)]=$88;
      var $91=$7;
      var $92=(($91+4)|0);
      var $93=HEAPU32[(($92)>>2)];
      var $94=$info;
      var $95=(($94+12)|0);
      var $96=HEAPU8[($95)];
      var $97=(($96)&255);
      var $98=$93 >>> (($97)>>>0);
      var $99=$info;
      var $100=(($99+16)|0);
      HEAP32[(($100)>>2)]=$98;
      var $101=$info;
      STACKTOP = __stackBase__;
      return $101;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22init_field_device_infoPK18input_field_configPKc["X"]=1;

function __ZNK11input_class7enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1032)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN11input_class6enableEb($this, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($state)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  var $7=(($4+1032)|0);
  var $8=(($6)&1);
  HEAP8[($7)]=$8;
  ;
  return;
}


function __ZNK8device_t5ownerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL23init_autoselect_devicesR15running_machineiiiPKcS2_($machine, $type1, $type2, $type3, $option, $ananame) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $portlist;
      var $stemp;
      var $autoenable;
      var $autostring;
      var $field;
      var $port;
      $1=$machine;
      $2=$type1;
      $3=$type2;
      $4=$type3;
      $5=$option;
      $6=$ananame;
      var $7=$1;
      var $8=(($7+20)|0);
      $portlist=$8;
      var $9=$1;
      var $10=__ZNK15running_machine7optionsEv($9);
      var $11=$10;
      var $12=$5;
      var $13=__ZNK12core_options5valueEPKc($11, $12);
      $stemp=$13;
      $autoenable=1;
      $autostring=((STRING_TABLE.__str1455)|0);
      var $14=$stemp;
      var $15=(($14)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      __label__ = 34; break;
    case 2: // $20
      var $21=$stemp;
      var $22=_strcmp($21, ((STRING_TABLE.__str1453)|0));
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      $autoenable=2;
      $autostring=((STRING_TABLE.__str1453)|0);
      __label__ = 16; break;
    case 4: // $25
      var $26=$stemp;
      var $27=_strcmp($26, ((STRING_TABLE.__str1456)|0));
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      $autoenable=4;
      $autostring=((STRING_TABLE.__str1456)|0);
      __label__ = 15; break;
    case 6: // $30
      var $31=$stemp;
      var $32=_strcmp($31, ((STRING_TABLE.__str1443)|0));
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      $autoenable=3;
      $autostring=((STRING_TABLE.__str1443)|0);
      __label__ = 14; break;
    case 8: // $35
      var $36=$stemp;
      var $37=_strcmp($36, ((STRING_TABLE.__str1457)|0));
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      __label__ = 34; break;
    case 10: // $40
      var $41=$stemp;
      var $42=_strcmp($41, ((STRING_TABLE.__str1455)|0));
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $44
      var $45=$5;
      var $46=$stemp;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1458)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,HEAP32[((tempInt+4)>>2)]=$46,tempInt));
      __label__ = 12; break;
    case 12: // $47
      __label__ = 13; break;
    case 13: // $48
      __label__ = 14; break;
    case 14: // $49
      __label__ = 15; break;
    case 15: // $50
      __label__ = 16; break;
    case 16: // $51
      var $52=$portlist;
      var $53=__ZNK11tagged_listI17input_port_configE5firstEv($52);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 17; break; } else { __label__ = 34; break; }
    case 17: // $55
      var $56=$1;
      var $57=__ZNK15running_machine5inputEv($56);
      var $58=$autoenable;
      var $59=__ZN13input_manager12device_classE18input_device_class($57, $58);
      var $60=__ZNK11input_class7enabledEv($59);
      if ($60) { __label__ = 34; break; } else { __label__ = 18; break; }
    case 18: // $61
      var $62=$portlist;
      var $63=__ZNK11tagged_listI17input_port_configE5firstEv($62);
      $port=$63;
      __label__ = 19; break;
    case 19: // $64
      var $65=$port;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 20; break; } else { __label__ = 33; break; }
    case 20: // $67
      var $68=$port;
      var $69=__ZNK17input_port_config11first_fieldEv($68);
      $field=$69;
      __label__ = 21; break;
    case 21: // $70
      var $71=$field;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 22; break; } else { __label__ = 31; break; }
    case 22: // $73
      var $74=$2;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $76
      var $77=$field;
      var $78=(($77+24)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$2;
      var $81=(($79)|0)==(($80)|0);
      if ($81) { __label__ = 28; break; } else { __label__ = 24; break; }
    case 24: // $82
      var $83=$3;
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $85
      var $86=$field;
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$3;
      var $90=(($88)|0)==(($89)|0);
      if ($90) { __label__ = 28; break; } else { __label__ = 26; break; }
    case 26: // $91
      var $92=$4;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $94
      var $95=$field;
      var $96=(($95+24)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$4;
      var $99=(($97)|0)==(($98)|0);
      if ($99) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $100
      var $101=$autostring;
      var $102=$6;
      __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str1459)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$101,HEAP32[((tempInt+4)>>2)]=$102,tempInt));
      var $103=$1;
      var $104=__ZNK15running_machine5inputEv($103);
      var $105=$autoenable;
      var $106=__ZN13input_manager12device_classE18input_device_class($104, $105);
      __ZN11input_class6enableEb($106, 1);
      __label__ = 31; break;
    case 29: // $107
      __label__ = 30; break;
    case 30: // $108
      var $109=$field;
      var $110=__ZNK18input_field_config4nextEv($109);
      $field=$110;
      __label__ = 21; break;
    case 31: // $111
      __label__ = 32; break;
    case 32: // $112
      var $113=$port;
      var $114=__ZNK17input_port_config4nextEv($113);
      $port=$114;
      __label__ = 19; break;
    case 33: // $115
      __label__ = 34; break;
    case 34: // $116
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23init_autoselect_devicesR15running_machineiiiPKcS2_["X"]=1;

function __ZN19resource_pool_arrayIcEC1EPci($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIcEC2EPci($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIcEC2EPci($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  var $8=(($7)|0);
  __ZN18resource_pool_itemC2EPvj($5, $6, $8);
  var $9=$4;
  HEAP32[(($9)>>2)]=((__ZTV19resource_pool_arrayIcE+8)|0);
  var $10=(($4+32)|0);
  var $11=$2;
  HEAP32[(($10)>>2)]=$11;
  var $12=(($4+36)|0);
  var $13=$3;
  HEAP32[(($12)>>2)]=$13;
  ;
  return;
}


function __ZN19resource_pool_arrayIcED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIcED2Ev($2);
  ;
  return;
}


function __ZL15inputx_key_namej($ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ci;
      var $result;
      var $pos;
      $1=$ch;
      var $2=$1;
      var $3=__ZL13find_charinfoj($2);
      $ci=$3;
      var $4=$ci;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$ci;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      $result=$12;
      var $13=$ci;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $15
      var $16=$ci;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $20
      var $21=$ci;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      $result=$23;
      __label__ = 11; break;
    case 6: // $24
      var $25=$1;
      var $26=(($25)>>>0) > 127;
      if ($26) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $27
      var $28=$1;
      var $29=_isprint($28);
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $31
      var $32=$1;
      var $33=__Z15utf8_from_ucharPcjj(((__ZZL15inputx_key_namejE3buf)|0), 7, $32);
      $pos=$33;
      var $34=$pos;
      var $35=((__ZZL15inputx_key_namejE3buf+$34)|0);
      HEAP8[($35)]=0;
      $result=((__ZZL15inputx_key_namejE3buf)|0);
      __label__ = 10; break;
    case 9: // $36
      $result=((STRING_TABLE.__str1345)|0);
      __label__ = 10; break;
    case 10: // $37
      __label__ = 11; break;
    case 11: // $38
      var $39=$result;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15inputx_key_namej["X"]=1;

function __ZN13delegate_baseIfRK18input_field_configf8_noparamS3_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11tagged_listI8device_tE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  var $6=__ZNK8tagmap_tIP8device_tE14find_hash_onlyEPKc($4, $5);
  ;
  return $6;
}


function __ZNK8tagmap_tIP8device_tE14find_hash_onlyEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL21tagmap_find_hash_onlyPK7_tagmapPKc450($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZN13delegate_baseIvRK18input_field_configPvjjE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18_device_field_infoEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18_device_field_infoEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18_device_field_infoEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 20);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18_device_field_infoE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18_device_field_infoED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18_device_field_infoED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool9add_arrayIcEEPT_S2_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIcEC1EPci($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIcEEPT_S2_i["X"]=1;

function __ZN19resource_pool_arrayIcED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIcED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIcED0Ev["X"]=1;

function __ZN19resource_pool_arrayIcED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIcE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      var $13=$3;
      HEAP32[(($1)>>2)]=$8;
      var $14=HEAP32[(($1)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $16
      var $17=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      __label__ = 5; break;
    case 4: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      HEAP32[(($2)>>2)]=$21;
      var $22=$20.f1;
      HEAP32[(($3)>>2)]=$22;
      var $23=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($23);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $24=$1;
      var $25=$2;
      var $26=$3;
      __label__ = 6; break;
    case 6: // $27
      var $28=$5;
      __ZN18resource_pool_itemD2Ev($28);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI18_device_field_infoEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18_device_field_infoEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18_device_field_infoEEPT_S3_["X"]=1;

function __ZNK15running_machine3osdEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+676)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectI19_analog_field_stateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI19_analog_field_stateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI19_analog_field_stateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 116);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI19_analog_field_stateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI19_analog_field_stateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI19_analog_field_stateED2Ev($2);
  ;
  return;
}


function __ZN18_input_field_stateC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      $1=$this;
      var $9=$1;
      var $10=(($9+8)|0);
      var $11=(($10)|0);
      var $12=(($11+192)|0);
      var $14 = $11;__label__ = 1; break;
    case 1: // $13
      var $14;
      __ZN10input_codeC1ERKS_($2, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($3, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($14, $2, $3, $4, $5, $6, $7, $8);
      var $15=(($14+64)|0);
      var $16=(($15)|0)==(($12)|0);
      if ($16) { __label__ = 2; break; } else { var $14 = $15;__label__ = 1; break; }
    case 2: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18_input_field_stateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18_input_field_stateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18_input_field_stateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 212);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18_input_field_stateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18_input_field_stateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18_input_field_stateED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI17_input_port_stateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17_input_port_stateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17_input_port_stateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 28);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17_input_port_stateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17_input_port_stateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17_input_port_stateED2Ev($2);
  ;
  return;
}


function __ZN7astring3cpyERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__Z11astring_cpyP7astringPKS_($3, $4);
  ;
  return $5;
}


function __ZN7astring3catEPKc($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__ZN7astring3insEiPKc($3, -1, $4);
  ;
  return $5;
}


function __ZN20resource_pool_objectI18_device_field_infoED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18_device_field_infoED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18_device_field_infoED0Ev["X"]=1;

function __ZN20resource_pool_objectI18_device_field_infoED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI18_device_field_infoE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI19_analog_field_stateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19_analog_field_stateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI19_analog_field_stateEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI19_analog_field_stateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19_analog_field_stateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI19_analog_field_stateED0Ev["X"]=1;

function __ZN20resource_pool_objectI19_analog_field_stateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI19_analog_field_stateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18_input_field_stateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18_input_field_stateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18_input_field_stateED0Ev["X"]=1;

function __ZN20resource_pool_objectI18_input_field_stateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI18_input_field_stateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI17_input_port_stateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17_input_port_stateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17_input_port_stateED0Ev["X"]=1;

function __ZN20resource_pool_objectI17_input_port_stateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI17_input_port_stateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z25mame_null_output_callbackPvPKcPc($param, $format, $argptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$param;
  $2=$format;
  $3=$argptr;
  ;
  return;
}


function __ZltRK8attotimeS1_($left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) < (($8)|0);
      if ($9) { var $29 = 1;__label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0)==(($16)|0);
      if ($17) { __label__ = 2; break; } else { var $27 = 0;__label__ = 3; break; }
    case 2: // $18
      var $19=$1;
      var $20=(($19+4)|0);
      var $st$2$0=(($20)|0);
      var $21$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$2$1)>>2)];
      var $22=$2;
      var $23=(($22+4)|0);
      var $st$8$0=(($23)|0);
      var $24$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($23+4)|0);
      var $24$1=HEAP32[(($st$8$1)>>2)];
      var $25=($21$1|0) < ($24$1|0) || (($21$1|0) == ($24$1|0) && ($21$0|0) <  ($24$0|0));
      var $27 = $25;__label__ = 3; break;
    case 3: // $26
      var $27;
      var $29 = $27;__label__ = 4; break;
    case 4: // $28
      var $29;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10input_codeeqERKS_($this, $rhs) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rhs;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($5)|0)==(($8)|0);
  ;
  return $9;
}


function __ZNK14machine_config10devicelistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  ;
  return $3;
}


function __ZN11simple_listI16input_type_entryEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI16input_type_entryE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN10input_codeC2ERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  ;
  return;
}


function __ZNK15running_machine18new_driver_pendingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1312)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK15running_machine15new_driver_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1312)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __ZNK15running_machine12exit_pendingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1310)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __Z14TMS9928A_resetv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $i;
      $i=0;
      __label__ = 1; break;
    case 1: // $1
      var $2=$i;
      var $3=(($2)|0) < 8;
      if ($3) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $4
      var $5=$i;
      var $6=((((__ZL3tms+1)|0)+$5)|0);
      HEAP8[($6)]=0;
      __label__ = 3; break;
    case 3: // $7
      var $8=$i;
      var $9=(($8+1)|0);
      $i=$9;
      __label__ = 1; break;
    case 4: // $10
      HEAP8[(((__ZL3tms+9)|0))]=0;
      HEAP32[((((__ZL3tms+16)|0))>>2)]=0;
      HEAP32[((((__ZL3tms+20)|0))>>2)]=0;
      HEAP32[((((__ZL3tms+24)|0))>>2)]=0;
      HEAP32[((((__ZL3tms+28)|0))>>2)]=0;
      HEAP32[((((__ZL3tms+32)|0))>>2)]=0;
      HEAP32[((((__ZL3tms+40)|0))>>2)]=0;
      HEAP32[((((__ZL3tms+36)|0))>>2)]=0;
      HEAP8[(((__ZL3tms+11)|0))]=0;
      HEAP8[(((__ZL3tms)|0))]=0;
      HEAP32[((((__ZL3tms+12)|0))>>2)]=0;
      HEAP8[(((__ZL3tms+10)|0))]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring3insEiPKc($this, $insbefore, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$insbefore;
  $3=$src;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z12astring_inscP7astringiPKc($4, $5, $6);
  ;
  return $7;
}


function __ZN11simple_listI16input_type_entryEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI16input_type_entryEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN9input_seqC2E10input_codeS0_S0_S0_S0_S0_S0_($this, $code0, $code1, $code2, $code3, $code4, $code5, $code6) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      $1=$this;
      var $9=$1;
      var $10=(($9)|0);
      var $11=(($10)|0);
      var $12=(($11+64)|0);
      var $14 = $11;__label__ = 1; break;
    case 1: // $13
      var $14;
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($14, 0, 0, 0, 0, 0);
      var $15=(($14+4)|0);
      var $16=(($15)|0)==(($12)|0);
      if ($16) { __label__ = 2; break; } else { var $14 = $15;__label__ = 1; break; }
    case 2: // $17
      __ZN10input_codeC1ERKS_($2, $code0);
      __ZN10input_codeC1ERKS_($3, $code1);
      __ZN10input_codeC1ERKS_($4, $code2);
      __ZN10input_codeC1ERKS_($5, $code3);
      __ZN10input_codeC1ERKS_($6, $code4);
      __ZN10input_codeC1ERKS_($7, $code5);
      __ZN10input_codeC1ERKS_($8, $code6);
      __ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_($9, $2, $3, $4, $5, $6, $7, $8);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options7verboseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str31578)|0));
  ;
  return $4;
}


function __ZNK11emu_options11read_configEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str21577)|0));
  ;
  return $4;
}


function __Z25mame_file_output_callbackPvPKcPc($param, $format, $argptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$param;
  $2=$format;
  $3=$argptr;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  var $8=_vfprintf($5, $6, $7);
  ;
  return;
}


function __Z17mame_printf_errorPKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $argptr=__stackBase__;
      $1=$format;
      var $2=HEAP32[((((__ZL9output_cb)|0))>>2)];
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      HEAP32[((((__ZL9output_cb)|0))>>2)]=132;
      var $5=HEAP32[((__impure_ptr)>>2)];
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      HEAP32[((((__ZL15output_cb_param)|0))>>2)]=$8;
      __label__ = 2; break;
    case 2: // $9
      var $10=$argptr;
      HEAP32[(($10)>>2)]=arguments[__Z17mame_printf_errorPKcz.length];
      var $11=HEAP32[((((__ZL9output_cb)|0))>>2)];
      var $12=HEAP32[((((__ZL15output_cb_param)|0))>>2)];
      var $13=$1;
      var $14=HEAP32[(($argptr)>>2)];
      FUNCTION_TABLE[$11]($12, $13, $14);
      var $15=$argptr;
      ;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19mame_printf_warningPKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $argptr=__stackBase__;
      $1=$format;
      var $2=HEAP32[((((__ZL9output_cb+4)|0))>>2)];
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      HEAP32[((((__ZL9output_cb+4)|0))>>2)]=132;
      var $5=HEAP32[((__impure_ptr)>>2)];
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      HEAP32[((((__ZL15output_cb_param+4)|0))>>2)]=$8;
      __label__ = 2; break;
    case 2: // $9
      var $10=$argptr;
      HEAP32[(($10)>>2)]=arguments[__Z19mame_printf_warningPKcz.length];
      var $11=HEAP32[((((__ZL9output_cb+4)|0))>>2)];
      var $12=HEAP32[((((__ZL15output_cb_param+4)|0))>>2)];
      var $13=$1;
      var $14=HEAP32[(($argptr)>>2)];
      FUNCTION_TABLE[$11]($12, $13, $14);
      var $15=$argptr;
      ;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16mame_printf_infoPKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $argptr=__stackBase__;
      $1=$format;
      var $2=HEAP32[((((__ZL9output_cb+8)|0))>>2)];
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      HEAP32[((((__ZL9output_cb+8)|0))>>2)]=132;
      var $5=HEAP32[((__impure_ptr)>>2)];
      var $6=(($5+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      HEAP32[((((__ZL15output_cb_param+8)|0))>>2)]=$8;
      __label__ = 2; break;
    case 2: // $9
      var $10=$argptr;
      HEAP32[(($10)>>2)]=arguments[__Z16mame_printf_infoPKcz.length];
      var $11=HEAP32[((((__ZL9output_cb+8)|0))>>2)];
      var $12=HEAP32[((((__ZL15output_cb_param+8)|0))>>2)];
      var $13=$1;
      var $14=HEAP32[(($argptr)>>2)];
      FUNCTION_TABLE[$11]($12, $13, $14);
      var $15=$argptr;
      ;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19mame_printf_verbosePKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $argptr=__stackBase__;
      $1=$format;
      var $2=HEAP8[(__ZL13print_verbose)];
      var $3=(($2) & 1);
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      __label__ = 5; break;
    case 2: // $5
      var $6=HEAP32[((((__ZL9output_cb+16)|0))>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $8
      HEAP32[((((__ZL9output_cb+16)|0))>>2)]=132;
      var $9=HEAP32[((__impure_ptr)>>2)];
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11;
      HEAP32[((((__ZL15output_cb_param+16)|0))>>2)]=$12;
      __label__ = 4; break;
    case 4: // $13
      var $14=$argptr;
      HEAP32[(($14)>>2)]=arguments[__Z19mame_printf_verbosePKcz.length];
      var $15=HEAP32[((((__ZL9output_cb+16)|0))>>2)];
      var $16=HEAP32[((((__ZL15output_cb_param+16)|0))>>2)];
      var $17=$1;
      var $18=HEAP32[(($argptr)>>2)];
      FUNCTION_TABLE[$15]($16, $17, $18);
      var $19=$argptr;
      ;
      __label__ = 5; break;
    case 5: // $20
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17mame_printf_debugPKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $argptr=__stackBase__;
      $1=$format;
      var $2=HEAP32[((((__ZL9output_cb+12)|0))>>2)];
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      HEAP32[((((__ZL9output_cb+12)|0))>>2)]=134;
      HEAP32[((((__ZL15output_cb_param+12)|0))>>2)]=0;
      __label__ = 2; break;
    case 2: // $5
      var $6=$argptr;
      HEAP32[(($6)>>2)]=arguments[__Z17mame_printf_debugPKcz.length];
      var $7=HEAP32[((((__ZL9output_cb+12)|0))>>2)];
      var $8=HEAP32[((((__ZL15output_cb_param+12)|0))>>2)];
      var $9=$1;
      var $10=HEAP32[(($argptr)>>2)];
      FUNCTION_TABLE[$7]($8, $9, $10);
      var $11=$argptr;
      ;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring7vprintfEPKcPc($this, $format, $args) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$format;
  $3=$args;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z15astring_vprintfP7astringPKcPc($4, $5, $6);
  ;
  return $7;
}


function __ZNK7astring3lenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__Z11astring_lenPK7astring($2);
  ;
  return $3;
}


function __Z8logerrorPKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $arg=__stackBase__;
      $1=$format;
      var $2=HEAP32[((__ZL14global_machine)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=$arg;
      HEAP32[(($5)>>2)]=arguments[__Z8logerrorPKcz.length];
      var $6=HEAP32[((__ZL14global_machine)>>2)];
      var $7=$1;
      var $8=HEAP32[(($arg)>>2)];
      __ZN15running_machine9vlogerrorEPKcPc($6, $7, $8);
      var $9=$arg;
      ;
      __label__ = 2; break;
    case 2: // $10
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19_input_port_privateC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+4)|0);
      __ZN11simple_listI16input_type_entryEC1ER13resource_pool($5, _global_resource_pool);
      var $6=(($4+6936)|0);
      var $7=(($4+7416)|0);
      (function() { try { __THREW__ = false; return __ZN8attotimeC1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=(($4+7480)|0);
      (function() { try { __THREW__ = false; return __ZN8attotimeC1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16input_type_entryED1Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$2;
      var $19=$2;
      var $20=$3;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z12mame_executeR11emu_optionsR13osd_interface($options, $osd) {
  var __stackBase__  = STACKTOP; STACKTOP += 2212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $firstgame;
      var $firstrun;
      var $exit_pending;
      var $error;
      var $system;
      var $errors=__stackBase__;
      var $3;
      var $4;
      var $config=__stackBase__+64;
      var $machine=__stackBase__+540;
      $1=$options;
      $2=$osd;
      $firstgame=1;
      $firstrun=1;
      var $5=$1;
      var $6=__ZNK11emu_options7verboseEv($5);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      HEAP8[(__ZL13print_verbose)]=1;
      __label__ = 2; break;
    case 2: // $8
      $exit_pending=0;
      $error=0;
      __label__ = 3; break;
    case 3: // $9
      var $10=$error;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 4; break; } else { var $17 = 0;__label__ = 5; break; }
    case 4: // $12
      var $13=$exit_pending;
      var $14=(($13) & 1);
      var $15=$14 ^ 1;
      var $17 = $15;__label__ = 5; break;
    case 5: // $16
      var $17;
      if ($17) { __label__ = 6; break; } else { __label__ = 33; break; }
    case 6: // $18
      var $19=$1;
      var $20=__ZNK11emu_options6systemEv($19);
      $system=$20;
      var $21=$system;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $23
      $system=_driver____empty;
      var $24=$firstgame;
      var $25=(($24) & 1);
      if ($25) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $26
      HEAP8[(__ZL13started_empty)]=1;
      __label__ = 9; break;
    case 9: // $27
      __label__ = 11; break;
    case 10: // $28
      var $29=$1;
      var $30=$system;
      __Z16validate_driversR11emu_optionsPK11game_driver($29, $30);
      __label__ = 11; break;
    case 11: // $31
      $firstgame=0;
      var $32=$1;
      var $33=__ZNK11emu_options11read_configEv($32);
      if ($33) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $34
      var $35=$1;
      var $36=$35;
      __ZN12core_options6revertEi($36, 100);
      __ZN7astringC1Ev($errors);
      var $37=$1;
      (function() { try { __THREW__ = false; return __ZN11emu_options19parse_standard_inisER7astring($37, $errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $38
      FUNCTION_TABLE[__ZN7astringD1Ev]($errors);
      __label__ = 16; break;
    case 14: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $3=$41;
      var $42=$40.f1;
      $4=$42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 35; break; }
    case 15: // $43
      __label__ = 34; break;
    case 16: // $44
      var $45=$system;
      var $46=$1;
      FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($config, $45, $46);
      var $47=$2;
      var $48=HEAP8[(__ZL13started_empty)];
      var $49=(($48) & 1);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15running_machineC1ERK14machine_configR13osd_interfaceb]($machine, $config, $47, $49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $50
      HEAP32[((__ZL14global_machine)>>2)]=$machine;
      var $51=$firstrun;
      var $52=(($51) & 1);
      var $53=(function() { try { __THREW__ = false; return __ZN15running_machine3runEb($machine, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 24; break; };
    case 18: // $54
      $error=$53;
      $firstrun=0;
      var $55=(function() { try { __THREW__ = false; return __ZNK15running_machine18new_driver_pendingEv($machine) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 24; break; };
    case 19: // $56
      if ($55) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 20: // $57
      var $58=$1;
      var $59=(function() { try { __THREW__ = false; return __ZNK15running_machine15new_driver_nameEv($machine) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 24; break; };
    case 21: // $60
      (function() { try { __THREW__ = false; return __ZN11emu_options15set_system_nameEPKc($58, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $61
      $firstrun=1;
      __label__ = 25; break;
    case 23: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $3=$64;
      var $65=$63.f1;
      $4=$65;
      __label__ = 31; break;
    case 24: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      $3=$68;
      var $69=$67.f1;
      $4=$69;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15running_machineD1Ev]($machine) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 25: // $70
      var $71=(function() { try { __THREW__ = false; return __ZNK15running_machine12exit_pendingEv($machine) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 24; break; };
    case 26: // $72
      if ($71) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $73
      $exit_pending=1;
      __label__ = 28; break;
    case 28: // $74
      HEAP32[((__ZL14global_machine)>>2)]=0;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15running_machineD1Ev]($machine) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 23; break; }
    case 29: // $75
      FUNCTION_TABLE[__ZN14machine_configD1Ev]($config);
      __label__ = 3; break;
    case 30: // $76
      __label__ = 31; break;
    case 31: // $77
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $78
      __label__ = 34; break;
    case 33: // $79
      var $80=$error;
      STACKTOP = __stackBase__;
      return $80;
    case 34: // $81
      var $82=$3;
      var $83=$3;
      var $84=$4;
      var $85=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $83, tempValue);
      var $86=($85.f1 = $84, $85);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12mame_executeR11emu_optionsR13osd_interface["X"]=1;

function __Z10popmessagePKcz($format) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $temp=__stackBase__;
      var $arg=__stackBase__+64;
      var $2;
      var $3;
      $1=$format;
      var $4=$1;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __Z13ui_popup_timeiPKcz(0, ((STRING_TABLE.__str1575)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 2: // $7
      __ZN7astringC1Ev($temp);
      var $8=$arg;
      HEAP32[(($8)>>2)]=arguments[__Z10popmessagePKcz.length];
      var $9=$1;
      var $10=HEAP32[(($arg)>>2)];
      var $11=(function() { try { __THREW__ = false; return __ZN7astring7vprintfEPKcPc($temp, $9, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $12
      var $13=$arg;
      ;
      var $14=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($temp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $15
      var $16=(((($14)|0)/40)|0);
      var $17=(($16+2)|0);
      var $18=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($temp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $19
      (function() { try { __THREW__ = false; return __Z13ui_popup_timeiPKcz($17, ((STRING_TABLE.__str11576)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $20
      FUNCTION_TABLE[__ZN7astringD1Ev]($temp);
      __label__ = 9; break;
    case 7: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $2=$23;
      var $24=$22.f1;
      $3=$24;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($temp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $25
      __label__ = 10; break;
    case 9: // $26
      STACKTOP = __stackBase__;
      return;
    case 10: // $27
      var $28=$2;
      var $29=$2;
      var $30=$3;
      var $31=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29, tempValue);
      var $32=($31.f1 = $30, $31);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15TMS9928A_vram_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $b;
  $1=$space;
  $2=$offset;
  var $3=HEAP8[(((__ZL3tms)|0))];
  $b=$3;
  var $4=HEAP32[((((__ZL3tms+12)|0))>>2)];
  var $5=HEAP32[((((__ZL3tms+48)|0))>>2)];
  var $6=(($5+$4)|0);
  var $7=HEAP8[($6)];
  HEAP8[(((__ZL3tms)|0))]=$7;
  var $8=HEAP32[((((__ZL3tms+12)|0))>>2)];
  var $9=(($8+1)|0);
  var $10=HEAP32[((((__ZL3tms+60)|0))>>2)];
  var $11=(($10-1)|0);
  var $12=$9 & $11;
  HEAP32[((((__ZL3tms+12)|0))>>2)]=$12;
  HEAP8[(((__ZL3tms+10)|0))]=0;
  var $13=$b;
  ;
  return $13;
}


function __Z15TMS9928A_vram_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$offset;
  $3=$data;
  var $4=$3;
  var $5=HEAP32[((((__ZL3tms+12)|0))>>2)];
  var $6=HEAP32[((((__ZL3tms+48)|0))>>2)];
  var $7=(($6+$5)|0);
  HEAP8[($7)]=$4;
  var $8=HEAP32[((((__ZL3tms+12)|0))>>2)];
  var $9=(($8+1)|0);
  var $10=HEAP32[((((__ZL3tms+60)|0))>>2)];
  var $11=(($10-1)|0);
  var $12=$9 & $11;
  HEAP32[((((__ZL3tms+12)|0))>>2)]=$12;
  var $13=$3;
  HEAP8[(((__ZL3tms)|0))]=$13;
  HEAP8[(((__ZL3tms+10)|0))]=0;
  ;
  return;
}


function __ZNK13address_space7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL15change_registerR15running_machineih($machine, $reg, $val) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $b;
      $1=$machine;
      $2=$reg;
      $3=$val;
      var $4=$2;
      var $5=((STRING_TABLE.__ZZL15change_registerR15running_machineihE4Mask+$4)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=$3;
      var $9=(($8)&255);
      var $10=$9 & $7;
      var $11=(($10) & 255);
      $3=$11;
      var $12=$3;
      var $13=$2;
      var $14=((((__ZL3tms+1)|0)+$13)|0);
      HEAP8[($14)]=$12;
      var $15=$2;
      var $16=$3;
      var $17=(($16)&255);
      __Z8logerrorPKcz(((STRING_TABLE.__str271616)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,HEAP32[((tempInt+4)>>2)]=$17,tempInt));
      var $18=$2;
      if ($18 == 0) {
        __label__ = 1; break;
      }
      else if ($18 == 1) {
        __label__ = 9; break;
      }
      else if ($18 == 2) {
        __label__ = 20; break;
      }
      else if ($18 == 3) {
        __label__ = 21; break;
      }
      else if ($18 == 4) {
        __label__ = 25; break;
      }
      else if ($18 == 5) {
        __label__ = 29; break;
      }
      else if ($18 == 6) {
        __label__ = 30; break;
      }
      else if ($18 == 7) {
        __label__ = 31; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 1: // $19
      var $20=$3;
      var $21=(($20)&255);
      var $22=$21 & 2;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $24
      var $25=HEAPU8[(((__ZL3tms+4)|0))];
      var $26=(($25)&255);
      var $27=$26 & 128;
      var $28=((($27<<6))|0);
      var $29=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $30=(($29-1)|0);
      var $31=$28 & $30;
      HEAP32[((((__ZL3tms+16)|0))>>2)]=$31;
      var $32=HEAPU8[(((__ZL3tms+4)|0))];
      var $33=(($32)&255);
      var $34=$33 & 127;
      var $35=((($34<<3))|0);
      var $36=$35 | 7;
      HEAP32[((((__ZL3tms+36)|0))>>2)]=$36;
      var $37=HEAPU8[(((__ZL3tms+5)|0))];
      var $38=(($37)&255);
      var $39=$38 & 4;
      var $40=((($39<<11))|0);
      var $41=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $42=(($41-1)|0);
      var $43=$40 & $42;
      HEAP32[((((__ZL3tms+20)|0))>>2)]=$43;
      var $44=HEAPU8[(((__ZL3tms+5)|0))];
      var $45=(($44)&255);
      var $46=$45 & 3;
      var $47=((($46<<8))|0);
      var $48=HEAP32[((((__ZL3tms+36)|0))>>2)];
      var $49=$48 & 255;
      var $50=$47 | $49;
      HEAP32[((((__ZL3tms+40)|0))>>2)]=$50;
      __label__ = 4; break;
    case 3: // $51
      var $52=HEAPU8[(((__ZL3tms+4)|0))];
      var $53=(($52)&255);
      var $54=((($53<<6))|0);
      var $55=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $56=(($55-1)|0);
      var $57=$54 & $56;
      HEAP32[((((__ZL3tms+16)|0))>>2)]=$57;
      var $58=HEAPU8[(((__ZL3tms+5)|0))];
      var $59=(($58)&255);
      var $60=((($59<<11))|0);
      var $61=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $62=(($61-1)|0);
      var $63=$60 & $62;
      HEAP32[((((__ZL3tms+20)|0))>>2)]=$63;
      __label__ = 4; break;
    case 4: // $64
      var $65=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $66=(($65)|0)==3;
      if ($66) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $67
      var $68=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $69=(($68)|0)==4;
      if ($69) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $70
      var $71=HEAPU8[(((__ZL3tms+1)|0))];
      var $72=(($71)&255);
      var $73=$72 & 2;
      var $76 = $73;__label__ = 8; break;
    case 7: // $74
      var $76 = 0;__label__ = 8; break;
    case 8: // $75
      var $76;
      var $77=HEAPU8[(((__ZL3tms+2)|0))];
      var $78=(($77)&255);
      var $79=$78 & 16;
      var $80=$79 >> 4;
      var $81=$76 | $80;
      var $82=HEAPU8[(((__ZL3tms+2)|0))];
      var $83=(($82)&255);
      var $84=$83 & 8;
      var $85=$84 >> 1;
      var $86=$81 | $85;
      var $87=((__ZZL15change_registerR15running_machineihE5modes+($86<<2))|0);
      var $88=HEAP32[(($87)>>2)];
      __Z8logerrorPKcz(((STRING_TABLE.__str281617)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$88,tempInt));
      __label__ = 31; break;
    case 9: // $89
      var $90=$3;
      var $91=(($90)&255);
      var $92=$91 & 32;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 10; break; } else { var $100 = 0;__label__ = 11; break; }
    case 10: // $94
      var $95=HEAPU8[(((__ZL3tms+9)|0))];
      var $96=(($95)&255);
      var $97=$96 & 128;
      var $98=(($97)|0)!=0;
      var $100 = $98;__label__ = 11; break;
    case 11: // $99
      var $100;
      var $101=(($100)&1);
      $b=$101;
      var $102=$b;
      var $103=(($102)&255);
      var $104=HEAPU8[(((__ZL3tms+11)|0))];
      var $105=(($104)&255);
      var $106=(($103)|0)!=(($105)|0);
      if ($106) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $107
      var $108=$b;
      HEAP8[(((__ZL3tms+11)|0))]=$108;
      var $109=HEAP32[((((__ZL3tms+44)|0))>>2)];
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $111
      var $112=HEAP32[((((__ZL3tms+44)|0))>>2)];
      var $113=$1;
      var $114=HEAPU8[(((__ZL3tms+11)|0))];
      var $115=(($114)&255);
      FUNCTION_TABLE[$112]($113, $115);
      __label__ = 14; break;
    case 14: // $116
      __label__ = 15; break;
    case 15: // $117
      var $118=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $119=(($118)|0)==3;
      if ($119) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $120
      var $121=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $122=(($121)|0)==4;
      if ($122) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $123
      var $124=HEAPU8[(((__ZL3tms+1)|0))];
      var $125=(($124)&255);
      var $126=$125 & 2;
      var $129 = $126;__label__ = 19; break;
    case 18: // $127
      var $129 = 0;__label__ = 19; break;
    case 19: // $128
      var $129;
      var $130=HEAPU8[(((__ZL3tms+2)|0))];
      var $131=(($130)&255);
      var $132=$131 & 16;
      var $133=$132 >> 4;
      var $134=$129 | $133;
      var $135=HEAPU8[(((__ZL3tms+2)|0))];
      var $136=(($135)&255);
      var $137=$136 & 8;
      var $138=$137 >> 1;
      var $139=$134 | $138;
      var $140=((__ZZL15change_registerR15running_machineihE5modes+($139<<2))|0);
      var $141=HEAP32[(($140)>>2)];
      __Z8logerrorPKcz(((STRING_TABLE.__str281617)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$141,tempInt));
      __label__ = 31; break;
    case 20: // $142
      var $143=$3;
      var $144=(($143)&255);
      var $145=((($144<<10))|0);
      var $146=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $147=(($146-1)|0);
      var $148=$145 & $147;
      HEAP32[((((__ZL3tms+24)|0))>>2)]=$148;
      __label__ = 31; break;
    case 21: // $149
      var $150=HEAPU8[(((__ZL3tms+1)|0))];
      var $151=(($150)&255);
      var $152=$151 & 2;
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $154
      var $155=$3;
      var $156=(($155)&255);
      var $157=$156 & 128;
      var $158=((($157<<6))|0);
      var $159=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $160=(($159-1)|0);
      var $161=$158 & $160;
      HEAP32[((((__ZL3tms+16)|0))>>2)]=$161;
      var $162=$3;
      var $163=(($162)&255);
      var $164=$163 & 127;
      var $165=((($164<<3))|0);
      var $166=$165 | 7;
      HEAP32[((((__ZL3tms+36)|0))>>2)]=$166;
      __label__ = 24; break;
    case 23: // $167
      var $168=$3;
      var $169=(($168)&255);
      var $170=((($169<<6))|0);
      var $171=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $172=(($171-1)|0);
      var $173=$170 & $172;
      HEAP32[((((__ZL3tms+16)|0))>>2)]=$173;
      __label__ = 24; break;
    case 24: // $174
      var $175=HEAPU8[(((__ZL3tms+5)|0))];
      var $176=(($175)&255);
      var $177=$176 & 3;
      var $178=((($177<<8))|0);
      var $179=HEAP32[((((__ZL3tms+36)|0))>>2)];
      var $180=$179 & 255;
      var $181=$178 | $180;
      HEAP32[((((__ZL3tms+40)|0))>>2)]=$181;
      __label__ = 31; break;
    case 25: // $182
      var $183=HEAPU8[(((__ZL3tms+1)|0))];
      var $184=(($183)&255);
      var $185=$184 & 2;
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $187
      var $188=$3;
      var $189=(($188)&255);
      var $190=$189 & 4;
      var $191=((($190<<11))|0);
      var $192=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $193=(($192-1)|0);
      var $194=$191 & $193;
      HEAP32[((((__ZL3tms+20)|0))>>2)]=$194;
      var $195=$3;
      var $196=(($195)&255);
      var $197=$196 & 3;
      var $198=((($197<<8))|0);
      var $199=$198 | 255;
      HEAP32[((((__ZL3tms+40)|0))>>2)]=$199;
      __label__ = 28; break;
    case 27: // $200
      var $201=$3;
      var $202=(($201)&255);
      var $203=((($202<<11))|0);
      var $204=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $205=(($204-1)|0);
      var $206=$203 & $205;
      HEAP32[((((__ZL3tms+20)|0))>>2)]=$206;
      __label__ = 28; break;
    case 28: // $207
      __label__ = 31; break;
    case 29: // $208
      var $209=$3;
      var $210=(($209)&255);
      var $211=((($210<<7))|0);
      var $212=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $213=(($212-1)|0);
      var $214=$211 & $213;
      HEAP32[((((__ZL3tms+28)|0))>>2)]=$214;
      __label__ = 31; break;
    case 30: // $215
      var $216=$3;
      var $217=(($216)&255);
      var $218=((($217<<11))|0);
      var $219=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $220=(($219-1)|0);
      var $221=$218 & $220;
      HEAP32[((((__ZL3tms+32)|0))>>2)]=$221;
      __label__ = 31; break;
    case 31: // $222
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15change_registerR15running_machineih["X"]=1;

function __Z19TMS9928A_register_rP13address_spacej($space, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $b;
      $1=$space;
      $2=$offset;
      var $3=HEAP8[(((__ZL3tms+9)|0))];
      $b=$3;
      HEAP8[(((__ZL3tms+9)|0))]=31;
      var $4=HEAP8[(((__ZL3tms+11)|0))];
      var $5=(($4 << 24) >> 24)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      HEAP8[(((__ZL3tms+11)|0))]=0;
      var $7=HEAP32[((((__ZL3tms+44)|0))>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=HEAP32[((((__ZL3tms+44)|0))>>2)];
      var $11=$1;
      var $12=__ZNK13address_space7machineEv($11);
      var $13=HEAPU8[(((__ZL3tms+11)|0))];
      var $14=(($13)&255);
      FUNCTION_TABLE[$10]($12, $14);
      __label__ = 3; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      HEAP8[(((__ZL3tms+10)|0))]=0;
      var $17=$b;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19TMS9928A_register_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $reg;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $4=HEAP8[(((__ZL3tms+10)|0))];
      var $5=(($4 << 24) >> 24)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $6
      var $7=$3;
      var $8=(($7)&255);
      var $9=(($8)&65535);
      var $10=$9 << 8;
      var $11=HEAP32[((((__ZL3tms+12)|0))>>2)];
      var $12=$11 & 255;
      var $13=$10 | $12;
      var $14=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $15=(($14-1)|0);
      var $16=$13 & $15;
      HEAP32[((((__ZL3tms+12)|0))>>2)]=$16;
      var $17=$3;
      var $18=(($17)&255);
      var $19=$18 & 128;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$3;
      var $23=(($22)&255);
      var $24=$23 & 7;
      $reg=$24;
      var $25=$1;
      var $26=__ZNK13address_space7machineEv($25);
      var $27=$reg;
      var $28=HEAP32[((((__ZL3tms+12)|0))>>2)];
      var $29=$28 & 255;
      var $30=(($29) & 255);
      __ZL15change_registerR15running_machineih($26, $27, $30);
      __label__ = 6; break;
    case 3: // $31
      var $32=$3;
      var $33=(($32)&255);
      var $34=$33 & 64;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $36
      var $37=$1;
      var $38=__Z15TMS9928A_vram_rP13address_spacej($37, 0);
      __label__ = 5; break;
    case 5: // $39
      __label__ = 6; break;
    case 6: // $40
      HEAP8[(((__ZL3tms+10)|0))]=0;
      __label__ = 8; break;
    case 7: // $41
      var $42=HEAP32[((((__ZL3tms+12)|0))>>2)];
      var $43=$42 & 65280;
      var $44=$3;
      var $45=(($44)&255);
      var $46=$43 | $45;
      var $47=HEAP32[((((__ZL3tms+60)|0))>>2)];
      var $48=(($47-1)|0);
      var $49=$46 & $48;
      HEAP32[((((__ZL3tms+12)|0))>>2)]=$49;
      HEAP8[(((__ZL3tms+10)|0))]=1;
      __label__ = 8; break;
    case 8: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19TMS9928A_register_wP13address_spacejh["X"]=1;

function __Z22screen_update_tms9928aP13screen_deviceP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $BackColour;
      var $oldcolor;
      var $rt=__stackBase__;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=HEAPU8[(((__ZL3tms+8)|0))];
      var $5=(($4)&255);
      var $6=$5 & 15;
      $BackColour=$6;
      var $7=$1;
      var $8=$7;
      var $9=__ZNK8device_t7machineEv($8);
      var $10=__ZL17palette_get_colorR15running_machinej($9, 0);
      $oldcolor=$10;
      var $11=$BackColour;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      $BackColour=1;
      __label__ = 2; break;
    case 2: // $14
      var $15=$1;
      var $16=$15;
      var $17=__ZNK8device_t7machineEv($16);
      var $18=$BackColour;
      var $19=((__ZL16TMS9928A_palette+($18<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20 & 16777215;
      var $22=$oldcolor;
      var $23=$22 & -16777216;
      var $24=$21 | $23;
      __ZL17palette_set_colorR15running_machinejj($17, 0, $24);
      var $25=HEAPU8[(((__ZL3tms+2)|0))];
      var $26=(($25)&255);
      var $27=$26 & 64;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $29
      var $30=$2;
      var $31=$3;
      var $32=$BackColour;
      var $33=$1;
      var $34=$33;
      var $35=__ZNK8device_t7machineEv($34);
      var $36=(($35+568)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+($32<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($30, $31, $39);
      __label__ = 11; break;
    case 4: // $40
      var $41=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $42=(($41)|0)==3;
      if ($42) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $43
      var $44=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $45=(($44)|0)==4;
      if ($45) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $46
      var $47=HEAPU8[(((__ZL3tms+1)|0))];
      var $48=(($47)&255);
      var $49=$48 & 2;
      var $52 = $49;__label__ = 8; break;
    case 7: // $50
      var $52 = 0;__label__ = 8; break;
    case 8: // $51
      var $52;
      var $53=HEAPU8[(((__ZL3tms+2)|0))];
      var $54=(($53)&255);
      var $55=$54 & 16;
      var $56=$55 >> 4;
      var $57=$52 | $56;
      var $58=HEAPU8[(((__ZL3tms+2)|0))];
      var $59=(($58)&255);
      var $60=$59 & 8;
      var $61=$60 >> 1;
      var $62=$57 | $61;
      var $63=((__ZL12ModeHandlers+($62<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$1;
      var $66=$65;
      var $67=HEAP32[((((__ZL3tms+56)|0))>>2)];
      var $68=$3;
      FUNCTION_TABLE[$64]($66, $67, $68);
      var $69=$2;
      var $70=HEAP32[((((__ZL3tms+56)|0))>>2)];
      var $71=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $72=$3;
      __Z10copybitmapP8bitmap_tS0_iiiiPK10_rectangle($69, $70, 0, 0, 15, $71, $72);
      var $73=(($rt)|0);
      HEAP32[(($73)>>2)]=0;
      var $74=(($rt+4)|0);
      HEAP32[(($74)>>2)]=285;
      var $75=(($rt+8)|0);
      HEAP32[(($75)>>2)]=0;
      var $76=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $77=(($76-1)|0);
      var $78=(($rt+12)|0);
      HEAP32[(($78)>>2)]=$77;
      var $79=$2;
      var $80=$BackColour;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($79, $rt, $80);
      var $81=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $82=(($81+192)|0);
      var $83=(($rt+8)|0);
      HEAP32[(($83)>>2)]=$82;
      var $84=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $85=(($84+192)|0);
      var $86=HEAP32[((((__ZL3tms+76)|0))>>2)];
      var $87=(($85+$86)|0);
      var $88=(($87-1)|0);
      var $89=(($rt+12)|0);
      HEAP32[(($89)>>2)]=$88;
      var $90=$2;
      var $91=$BackColour;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($90, $rt, $91);
      var $92=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $93=(($rt+8)|0);
      HEAP32[(($93)>>2)]=$92;
      var $94=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $95=(($94+192)|0);
      var $96=(($95-1)|0);
      var $97=(($rt+12)|0);
      HEAP32[(($97)>>2)]=$96;
      var $98=(($rt)|0);
      HEAP32[(($98)>>2)]=0;
      var $99=(($rt+4)|0);
      HEAP32[(($99)>>2)]=14;
      var $100=$2;
      var $101=$BackColour;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($100, $rt, $101);
      var $102=(($rt)|0);
      HEAP32[(($102)>>2)]=271;
      var $103=(($rt+4)|0);
      HEAP32[(($103)>>2)]=285;
      var $104=$2;
      var $105=$BackColour;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($104, $rt, $105);
      var $106=HEAPU8[(((__ZL3tms+2)|0))];
      var $107=(($106)&255);
      var $108=$107 & 80;
      var $109=(($108)|0)==64;
      if ($109) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $110
      var $111=$1;
      var $112=$111;
      var $113=$2;
      var $114=$3;
      __ZL12draw_spritesP8device_tP8bitmap_tPK10_rectangle($112, $113, $114);
      __label__ = 10; break;
    case 10: // $115
      __label__ = 11; break;
    case 11: // $116
      STACKTOP = __stackBase__;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22screen_update_tms9928aP13screen_deviceP8bitmap_tPK10_rectangle["X"]=1;

function __ZL17palette_get_colorR15running_machinej($machine, $pen) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$pen;
  var $3=$1;
  var $4=(($3+564)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__Z23palette_entry_get_colorP10_palette_tj($5, $6);
  ;
  return $7;
}


function __ZL17palette_set_colorR15running_machinejj($machine, $pen, $rgb) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$pen;
  $3=$rgb;
  var $4=$1;
  var $5=(($4+564)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  var $8=$3;
  __Z23palette_entry_set_colorP10_palette_tjj($6, $7, $8);
  ;
  return;
}


function __ZNK13video_manager15skip_this_frameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+120)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZL12draw_spritesP8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  var __stackBase__  = STACKTOP; STACKTOP += 768; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $attributeptr;
      var $patternptr;
      var $c;
      var $p;
      var $x;
      var $y;
      var $size;
      var $i;
      var $j;
      var $large;
      var $yy;
      var $xx;
      var $limit=__stackBase__;
      var $illegalsprite;
      var $illegalspriteline;
      var $line;
      var $line2;
      var $pens;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      var $8=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $9=HEAP32[((((__ZL3tms+28)|0))>>2)];
      var $10=(($8+$9)|0);
      $attributeptr=$10;
      var $11=HEAPU8[(((__ZL3tms+2)|0))];
      var $12=(($11)&255);
      var $13=$12 & 2;
      var $14=(($13)|0)!=0;
      var $15=$14 ? 16 : 8;
      $size=$15;
      var $16=HEAPU8[(((__ZL3tms+2)|0))];
      var $17=(($16)&255);
      var $18=$17 & 1;
      $large=$18;
      $x=0;
      __label__ = 1; break;
    case 1: // $19
      var $20=$x;
      var $21=(($20)|0) < 192;
      if ($21) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $22
      var $23=$x;
      var $24=(($limit+($23<<2))|0);
      HEAP32[(($24)>>2)]=4;
      __label__ = 3; break;
    case 3: // $25
      var $26=$x;
      var $27=(($26+1)|0);
      $x=$27;
      __label__ = 1; break;
    case 4: // $28
      HEAP8[(((__ZL3tms+9)|0))]=-128;
      $illegalspriteline=255;
      $illegalsprite=0;
      var $29=HEAP32[((((__ZL3tms+52)|0))>>2)];
      _memset($29, 0, 49152, 1);
      $p=0;
      __label__ = 5; break;
    case 5: // $30
      var $31=$p;
      var $32=(($31)|0) < 32;
      if ($32) { __label__ = 6; break; } else { __label__ = 108; break; }
    case 6: // $33
      var $34=$attributeptr;
      var $35=(($34+1)|0);
      $attributeptr=$35;
      var $36=HEAPU8[($34)];
      var $37=(($36)&255);
      $y=$37;
      var $38=$y;
      var $39=(($38)|0)==208;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      __label__ = 108; break;
    case 8: // $41
      var $42=$y;
      var $43=(($42)|0) > 208;
      if ($43) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $44
      var $45=$y;
      var $46=$45 ^ -1;
      var $47=$46 & 255;
      var $48=(((-$47))|0);
      $y=$48;
      __label__ = 11; break;
    case 10: // $49
      var $50=$y;
      var $51=(($50+1)|0);
      $y=$51;
      __label__ = 11; break;
    case 11: // $52
      var $53=$attributeptr;
      var $54=(($53+1)|0);
      $attributeptr=$54;
      var $55=HEAPU8[($53)];
      var $56=(($55)&255);
      $x=$56;
      var $57=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $58=HEAP32[((((__ZL3tms+32)|0))>>2)];
      var $59=(($57+$58)|0);
      var $60=$size;
      var $61=(($60)|0)==16;
      if ($61) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $62
      var $63=$attributeptr;
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$65 & 252;
      var $72 = $66;__label__ = 14; break;
    case 13: // $67
      var $68=$attributeptr;
      var $69=HEAPU8[($68)];
      var $70=(($69)&255);
      var $72 = $70;__label__ = 14; break;
    case 14: // $71
      var $72;
      var $73=((($72<<3))|0);
      var $74=(($59+$73)|0);
      $patternptr=$74;
      var $75=$attributeptr;
      var $76=(($75+1)|0);
      $attributeptr=$76;
      var $77=$attributeptr;
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $80=$79 & 15;
      var $81=(($80) & 255);
      $c=$81;
      var $82=$attributeptr;
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$84 & 128;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $87
      var $88=$x;
      var $89=(($88-32)|0);
      $x=$89;
      __label__ = 16; break;
    case 16: // $90
      var $91=$attributeptr;
      var $92=(($91+1)|0);
      $attributeptr=$92;
      var $93=$large;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 54; break; } else { __label__ = 17; break; }
    case 17: // $95
      var $96=$y;
      $yy=$96;
      __label__ = 18; break;
    case 18: // $97
      var $98=$yy;
      var $99=$y;
      var $100=$size;
      var $101=(($99+$100)|0);
      var $102=(($98)|0) < (($101)|0);
      if ($102) { __label__ = 19; break; } else { __label__ = 53; break; }
    case 19: // $103
      var $104=$yy;
      var $105=(($104)|0) < 0;
      if ($105) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $106
      var $107=$yy;
      var $108=(($107)|0) > 191;
      if ($108) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $109
      __label__ = 52; break;
    case 22: // $110
      var $111=$yy;
      var $112=(($limit+($111<<2))|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 23; break; } else { __label__ = 33; break; }
    case 23: // $115
      var $116=$yy;
      var $117=$illegalspriteline;
      var $118=(($116)|0) < (($117)|0);
      if ($118) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $119
      var $120=$yy;
      $illegalspriteline=$120;
      var $121=$p;
      $illegalsprite=$121;
      __label__ = 30; break;
    case 25: // $122
      var $123=$illegalspriteline;
      var $124=$yy;
      var $125=(($123)|0)==(($124)|0);
      if ($125) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $126
      var $127=$illegalsprite;
      var $128=$p;
      var $129=(($127)|0) > (($128)|0);
      if ($129) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $130
      var $131=$p;
      $illegalsprite=$131;
      __label__ = 28; break;
    case 28: // $132
      __label__ = 29; break;
    case 29: // $133
      __label__ = 30; break;
    case 30: // $134
      var $135=HEAP32[((((__ZL3tms+68)|0))>>2)];
      var $136=(($135)|0)!=0;
      if ($136) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $137
      __label__ = 52; break;
    case 32: // $138
      __label__ = 34; break;
    case 33: // $139
      var $140=$yy;
      var $141=(($limit+($140<<2))|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142-1)|0);
      HEAP32[(($141)>>2)]=$143;
      __label__ = 34; break;
    case 34: // $144
      var $145=$yy;
      var $146=$y;
      var $147=(($145-$146)|0);
      var $148=$patternptr;
      var $149=(($148+$147)|0);
      var $150=HEAPU8[($149)];
      var $151=(($150)&255);
      var $152=((($151<<8))|0);
      var $153=$yy;
      var $154=$y;
      var $155=(($153-$154)|0);
      var $156=(($155+16)|0);
      var $157=$patternptr;
      var $158=(($157+$156)|0);
      var $159=HEAPU8[($158)];
      var $160=(($159)&255);
      var $161=(($152+$160)|0);
      var $162=(($161) & 65535);
      $line=$162;
      var $163=$x;
      $xx=$163;
      __label__ = 35; break;
    case 35: // $164
      var $165=$xx;
      var $166=$x;
      var $167=$size;
      var $168=(($166+$167)|0);
      var $169=(($165)|0) < (($168)|0);
      if ($169) { __label__ = 36; break; } else { __label__ = 51; break; }
    case 36: // $170
      var $171=$line;
      var $172=(($171)&65535);
      var $173=$172 & 32768;
      var $174=(($173)|0)!=0;
      if ($174) { __label__ = 37; break; } else { __label__ = 49; break; }
    case 37: // $175
      var $176=$xx;
      var $177=(($176)|0) >= 0;
      if ($177) { __label__ = 38; break; } else { __label__ = 48; break; }
    case 38: // $178
      var $179=$xx;
      var $180=(($179)|0) < 256;
      if ($180) { __label__ = 39; break; } else { __label__ = 48; break; }
    case 39: // $181
      var $182=$yy;
      var $183=((($182<<8))|0);
      var $184=$xx;
      var $185=(($183+$184)|0);
      var $186=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $187=(($186+$185)|0);
      var $188=HEAP8[($187)];
      var $189=(($188 << 24) >> 24)!=0;
      if ($189) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $190
      var $191=HEAPU8[(((__ZL3tms+9)|0))];
      var $192=(($191)&255);
      var $193=$192 | 32;
      var $194=(($193) & 255);
      HEAP8[(((__ZL3tms+9)|0))]=$194;
      __label__ = 42; break;
    case 41: // $195
      var $196=$yy;
      var $197=((($196<<8))|0);
      var $198=$xx;
      var $199=(($197+$198)|0);
      var $200=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $201=(($200+$199)|0);
      HEAP8[($201)]=1;
      __label__ = 42; break;
    case 42: // $202
      var $203=$c;
      var $204=(($203 << 24) >> 24)!=0;
      if ($204) { __label__ = 43; break; } else { __label__ = 47; break; }
    case 43: // $205
      var $206=$yy;
      var $207=((($206<<8))|0);
      var $208=$xx;
      var $209=(($207+$208)|0);
      var $210=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $211=(($210+$209)|0);
      var $212=HEAPU8[($211)];
      var $213=(($212)&255);
      var $214=$213 & 2;
      var $215=(($214)|0)!=0;
      if ($215) { __label__ = 47; break; } else { __label__ = 44; break; }
    case 44: // $216
      var $217=$yy;
      var $218=((($217<<8))|0);
      var $219=$xx;
      var $220=(($218+$219)|0);
      var $221=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $222=(($221+$220)|0);
      var $223=HEAPU8[($222)];
      var $224=(($223)&255);
      var $225=$224 | 2;
      var $226=(($225) & 255);
      HEAP8[($222)]=$226;
      var $227=$2;
      var $228=(($227)|0)!=0;
      if ($228) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $229
      var $230=$c;
      var $231=(($230)&255);
      var $232=$pens;
      var $233=(($232+($231<<2))|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=(($234) & 65535);
      var $236=$2;
      var $237=$236;
      var $238=(($237+4)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$239;
      var $241=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $242=$yy;
      var $243=(($241+$242)|0);
      var $244=$2;
      var $245=$244;
      var $246=(($245+8)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=(($243*$247)|0);
      var $249=(($240+($248<<1))|0);
      var $250=$xx;
      var $251=(($250+15)|0);
      var $252=(($249+($251<<1))|0);
      HEAP16[(($252)>>1)]=$235;
      __label__ = 46; break;
    case 46: // $253
      __label__ = 47; break;
    case 47: // $254
      __label__ = 48; break;
    case 48: // $255
      __label__ = 49; break;
    case 49: // $256
      var $257=$line;
      var $258=(($257)&65535);
      var $259=((($258<<1))|0);
      var $260=(($259) & 65535);
      $line=$260;
      __label__ = 50; break;
    case 50: // $261
      var $262=$xx;
      var $263=(($262+1)|0);
      $xx=$263;
      __label__ = 35; break;
    case 51: // $264
      __label__ = 52; break;
    case 52: // $265
      var $266=$yy;
      var $267=(($266+1)|0);
      $yy=$267;
      __label__ = 18; break;
    case 53: // $268
      __label__ = 106; break;
    case 54: // $269
      $i=0;
      __label__ = 55; break;
    case 55: // $270
      var $271=$i;
      var $272=$size;
      var $273=(($271)|0) < (($272)|0);
      if ($273) { __label__ = 56; break; } else { __label__ = 105; break; }
    case 56: // $274
      var $275=$y;
      var $276=$i;
      var $277=((($276<<1))|0);
      var $278=(($275+$277)|0);
      $yy=$278;
      var $279=$i;
      var $280=$patternptr;
      var $281=(($280+$279)|0);
      var $282=HEAPU8[($281)];
      var $283=(($282)&255);
      var $284=((($283<<8))|0);
      var $285=$i;
      var $286=(($285+16)|0);
      var $287=$patternptr;
      var $288=(($287+$286)|0);
      var $289=HEAPU8[($288)];
      var $290=(($289)&255);
      var $291=(($284+$290)|0);
      var $292=(($291) & 65535);
      $line2=$292;
      $j=0;
      __label__ = 57; break;
    case 57: // $293
      var $294=$j;
      var $295=(($294)|0) < 2;
      if ($295) { __label__ = 58; break; } else { __label__ = 103; break; }
    case 58: // $296
      var $297=$yy;
      var $298=(($297)|0) >= 0;
      if ($298) { __label__ = 59; break; } else { __label__ = 101; break; }
    case 59: // $299
      var $300=$yy;
      var $301=(($300)|0) <= 191;
      if ($301) { __label__ = 60; break; } else { __label__ = 101; break; }
    case 60: // $302
      var $303=$yy;
      var $304=(($limit+($303<<2))|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=(($305)|0)==0;
      if ($306) { __label__ = 61; break; } else { __label__ = 71; break; }
    case 61: // $307
      var $308=$yy;
      var $309=$illegalspriteline;
      var $310=(($308)|0) < (($309)|0);
      if ($310) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $311
      var $312=$yy;
      $illegalspriteline=$312;
      var $313=$p;
      $illegalsprite=$313;
      __label__ = 68; break;
    case 63: // $314
      var $315=$illegalspriteline;
      var $316=$yy;
      var $317=(($315)|0)==(($316)|0);
      if ($317) { __label__ = 64; break; } else { __label__ = 67; break; }
    case 64: // $318
      var $319=$illegalsprite;
      var $320=$p;
      var $321=(($319)|0) > (($320)|0);
      if ($321) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $322
      var $323=$p;
      $illegalsprite=$323;
      __label__ = 66; break;
    case 66: // $324
      __label__ = 67; break;
    case 67: // $325
      __label__ = 68; break;
    case 68: // $326
      var $327=HEAP32[((((__ZL3tms+68)|0))>>2)];
      var $328=(($327)|0)!=0;
      if ($328) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $329
      __label__ = 102; break;
    case 70: // $330
      __label__ = 72; break;
    case 71: // $331
      var $332=$yy;
      var $333=(($limit+($332<<2))|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($334-1)|0);
      HEAP32[(($333)>>2)]=$335;
      __label__ = 72; break;
    case 72: // $336
      var $337=$line2;
      $line=$337;
      var $338=$x;
      $xx=$338;
      __label__ = 73; break;
    case 73: // $339
      var $340=$xx;
      var $341=$x;
      var $342=$size;
      var $343=((($342<<1))|0);
      var $344=(($341+$343)|0);
      var $345=(($340)|0) < (($344)|0);
      if ($345) { __label__ = 74; break; } else { __label__ = 100; break; }
    case 74: // $346
      var $347=$line;
      var $348=(($347)&65535);
      var $349=$348 & 32768;
      var $350=(($349)|0)!=0;
      if ($350) { __label__ = 75; break; } else { __label__ = 98; break; }
    case 75: // $351
      var $352=$xx;
      var $353=(($352)|0) >= 0;
      if ($353) { __label__ = 76; break; } else { __label__ = 86; break; }
    case 76: // $354
      var $355=$xx;
      var $356=(($355)|0) < 256;
      if ($356) { __label__ = 77; break; } else { __label__ = 86; break; }
    case 77: // $357
      var $358=$yy;
      var $359=((($358<<8))|0);
      var $360=$xx;
      var $361=(($359+$360)|0);
      var $362=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $363=(($362+$361)|0);
      var $364=HEAP8[($363)];
      var $365=(($364 << 24) >> 24)!=0;
      if ($365) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $366
      var $367=HEAPU8[(((__ZL3tms+9)|0))];
      var $368=(($367)&255);
      var $369=$368 | 32;
      var $370=(($369) & 255);
      HEAP8[(((__ZL3tms+9)|0))]=$370;
      __label__ = 80; break;
    case 79: // $371
      var $372=$yy;
      var $373=((($372<<8))|0);
      var $374=$xx;
      var $375=(($373+$374)|0);
      var $376=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $377=(($376+$375)|0);
      HEAP8[($377)]=1;
      __label__ = 80; break;
    case 80: // $378
      var $379=$c;
      var $380=(($379 << 24) >> 24)!=0;
      if ($380) { __label__ = 81; break; } else { __label__ = 85; break; }
    case 81: // $381
      var $382=$yy;
      var $383=((($382<<8))|0);
      var $384=$xx;
      var $385=(($383+$384)|0);
      var $386=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $387=(($386+$385)|0);
      var $388=HEAPU8[($387)];
      var $389=(($388)&255);
      var $390=$389 & 2;
      var $391=(($390)|0)!=0;
      if ($391) { __label__ = 85; break; } else { __label__ = 82; break; }
    case 82: // $392
      var $393=$yy;
      var $394=((($393<<8))|0);
      var $395=$xx;
      var $396=(($394+$395)|0);
      var $397=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $398=(($397+$396)|0);
      var $399=HEAPU8[($398)];
      var $400=(($399)&255);
      var $401=$400 | 2;
      var $402=(($401) & 255);
      HEAP8[($398)]=$402;
      var $403=$2;
      var $404=(($403)|0)!=0;
      if ($404) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $405
      var $406=$c;
      var $407=(($406)&255);
      var $408=$pens;
      var $409=(($408+($407<<2))|0);
      var $410=HEAP32[(($409)>>2)];
      var $411=(($410) & 65535);
      var $412=$2;
      var $413=$412;
      var $414=(($413+4)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=$415;
      var $417=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $418=$yy;
      var $419=(($417+$418)|0);
      var $420=$2;
      var $421=$420;
      var $422=(($421+8)|0);
      var $423=HEAP32[(($422)>>2)];
      var $424=(($419*$423)|0);
      var $425=(($416+($424<<1))|0);
      var $426=$xx;
      var $427=(($426+15)|0);
      var $428=(($425+($427<<1))|0);
      HEAP16[(($428)>>1)]=$411;
      __label__ = 84; break;
    case 84: // $429
      __label__ = 85; break;
    case 85: // $430
      __label__ = 86; break;
    case 86: // $431
      var $432=$xx;
      var $433=(($432+1)|0);
      var $434=(($433)|0) >= 0;
      if ($434) { __label__ = 87; break; } else { __label__ = 97; break; }
    case 87: // $435
      var $436=$xx;
      var $437=(($436+1)|0);
      var $438=(($437)|0) < 256;
      if ($438) { __label__ = 88; break; } else { __label__ = 97; break; }
    case 88: // $439
      var $440=$yy;
      var $441=((($440<<8))|0);
      var $442=$xx;
      var $443=(($441+$442)|0);
      var $444=(($443+1)|0);
      var $445=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $446=(($445+$444)|0);
      var $447=HEAP8[($446)];
      var $448=(($447 << 24) >> 24)!=0;
      if ($448) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $449
      var $450=HEAPU8[(((__ZL3tms+9)|0))];
      var $451=(($450)&255);
      var $452=$451 | 32;
      var $453=(($452) & 255);
      HEAP8[(((__ZL3tms+9)|0))]=$453;
      __label__ = 91; break;
    case 90: // $454
      var $455=$yy;
      var $456=((($455<<8))|0);
      var $457=$xx;
      var $458=(($456+$457)|0);
      var $459=(($458+1)|0);
      var $460=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $461=(($460+$459)|0);
      HEAP8[($461)]=1;
      __label__ = 91; break;
    case 91: // $462
      var $463=$c;
      var $464=(($463 << 24) >> 24)!=0;
      if ($464) { __label__ = 92; break; } else { __label__ = 96; break; }
    case 92: // $465
      var $466=$yy;
      var $467=((($466<<8))|0);
      var $468=$xx;
      var $469=(($467+$468)|0);
      var $470=(($469+1)|0);
      var $471=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $472=(($471+$470)|0);
      var $473=HEAPU8[($472)];
      var $474=(($473)&255);
      var $475=$474 & 2;
      var $476=(($475)|0)!=0;
      if ($476) { __label__ = 96; break; } else { __label__ = 93; break; }
    case 93: // $477
      var $478=$yy;
      var $479=((($478<<8))|0);
      var $480=$xx;
      var $481=(($479+$480)|0);
      var $482=(($481+1)|0);
      var $483=HEAP32[((((__ZL3tms+52)|0))>>2)];
      var $484=(($483+$482)|0);
      var $485=HEAPU8[($484)];
      var $486=(($485)&255);
      var $487=$486 | 2;
      var $488=(($487) & 255);
      HEAP8[($484)]=$488;
      var $489=$2;
      var $490=(($489)|0)!=0;
      if ($490) { __label__ = 94; break; } else { __label__ = 95; break; }
    case 94: // $491
      var $492=$c;
      var $493=(($492)&255);
      var $494=$pens;
      var $495=(($494+($493<<2))|0);
      var $496=HEAP32[(($495)>>2)];
      var $497=(($496) & 65535);
      var $498=$2;
      var $499=$498;
      var $500=(($499+4)|0);
      var $501=HEAP32[(($500)>>2)];
      var $502=$501;
      var $503=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $504=$yy;
      var $505=(($503+$504)|0);
      var $506=$2;
      var $507=$506;
      var $508=(($507+8)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=(($505*$509)|0);
      var $511=(($502+($510<<1))|0);
      var $512=$xx;
      var $513=(($512+15)|0);
      var $514=(($513+1)|0);
      var $515=(($511+($514<<1))|0);
      HEAP16[(($515)>>1)]=$497;
      __label__ = 95; break;
    case 95: // $516
      __label__ = 96; break;
    case 96: // $517
      __label__ = 97; break;
    case 97: // $518
      __label__ = 98; break;
    case 98: // $519
      var $520=$line;
      var $521=(($520)&65535);
      var $522=((($521<<1))|0);
      var $523=(($522) & 65535);
      $line=$523;
      __label__ = 99; break;
    case 99: // $524
      var $525=$xx;
      var $526=(($525+2)|0);
      $xx=$526;
      __label__ = 73; break;
    case 100: // $527
      __label__ = 101; break;
    case 101: // $528
      var $529=$yy;
      var $530=(($529+1)|0);
      $yy=$530;
      __label__ = 102; break;
    case 102: // $531
      var $532=$j;
      var $533=(($532+1)|0);
      $j=$533;
      __label__ = 57; break;
    case 103: // $534
      __label__ = 104; break;
    case 104: // $535
      var $536=$i;
      var $537=(($536+1)|0);
      $i=$537;
      __label__ = 55; break;
    case 105: // $538
      __label__ = 106; break;
    case 106: // $539
      __label__ = 107; break;
    case 107: // $540
      var $541=$p;
      var $542=(($541+1)|0);
      $p=$542;
      __label__ = 5; break;
    case 108: // $543
      var $544=$illegalspriteline;
      var $545=(($544)|0)==255;
      if ($545) { __label__ = 109; break; } else { __label__ = 113; break; }
    case 109: // $546
      var $547=$p;
      var $548=(($547)|0) > 31;
      if ($548) { __label__ = 110; break; } else { __label__ = 111; break; }
    case 110: // $549
      var $553 = 31;__label__ = 112; break;
    case 111: // $550
      var $551=$p;
      var $553 = $551;__label__ = 112; break;
    case 112: // $552
      var $553;
      var $554=HEAPU8[(((__ZL3tms+9)|0))];
      var $555=(($554)&255);
      var $556=$555 | $553;
      var $557=(($556) & 255);
      HEAP8[(((__ZL3tms+9)|0))]=$557;
      __label__ = 114; break;
    case 113: // $558
      var $559=$illegalsprite;
      var $560=(($559+64)|0);
      var $561=HEAPU8[(((__ZL3tms+9)|0))];
      var $562=(($561)&255);
      var $563=$562 | $560;
      var $564=(($563) & 255);
      HEAP8[(((__ZL3tms+9)|0))]=$564;
      __label__ = 114; break;
    case 114: // $565
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12draw_spritesP8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __Z18TMS9928A_interruptR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $b;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine5videoEv($2);
      var $4=__ZNK13video_manager15skip_this_frameEv($3);
      if ($4) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $5
      var $6=HEAPU8[(((__ZL3tms+2)|0))];
      var $7=(($6)&255);
      var $8=$7 & 80;
      var $9=(($8)|0)==64;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$1;
      var $12=(($11+560)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13;
      __ZL12draw_spritesP8device_tP8bitmap_tPK10_rectangle($14, 0, 0);
      __label__ = 3; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=HEAPU8[(((__ZL3tms+9)|0))];
      var $18=(($17)&255);
      var $19=$18 | 128;
      var $20=(($19) & 255);
      HEAP8[(((__ZL3tms+9)|0))]=$20;
      var $21=HEAPU8[(((__ZL3tms+2)|0))];
      var $22=(($21)&255);
      var $23=$22 & 32;
      var $24=(($23)|0)!=0;
      var $25=(($24)&1);
      $b=$25;
      var $26=$b;
      var $27=HEAPU8[(((__ZL3tms+11)|0))];
      var $28=(($27)&255);
      var $29=(($26)|0)!=(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $30
      var $31=$b;
      var $32=(($31) & 255);
      HEAP8[(((__ZL3tms+11)|0))]=$32;
      var $33=HEAP32[((((__ZL3tms+44)|0))>>2)];
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=HEAP32[((((__ZL3tms+44)|0))>>2)];
      var $37=$1;
      var $38=HEAPU8[(((__ZL3tms+11)|0))];
      var $39=(($38)&255);
      FUNCTION_TABLE[$36]($37, $39);
      __label__ = 7; break;
    case 7: // $40
      __label__ = 8; break;
    case 8: // $41
      var $42=$b;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18TMS9928A_interruptR15running_machine["X"]=1;

function __Z18TMS9928A_configurePK18TMS9928a_interface($intf) {
  ;
  var __label__;

  var $1;
  $1=$intf;
  var $2=$1;
  var $3=$2;
  assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[((__ZL5sIntf)>>2)]=HEAP32[(($3)>>2)];HEAP32[((__ZL5sIntf+4)>>2)]=HEAP32[(($3+4)>>2)];HEAP32[((__ZL5sIntf+8)>>2)]=HEAP32[(($3+8)>>2)];HEAP32[((__ZL5sIntf+12)>>2)]=HEAP32[(($3+12)>>2)];HEAP32[((__ZL5sIntf+16)>>2)]=HEAP32[(($3+16)>>2)];
  ;
  return;
}


function __Z20video_start_tms9928aR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      __ZL14TMS9928A_startR15running_machinePK18TMS9928a_interface($4, __ZL5sIntf);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13screen_device5widthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+412)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device6heightEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+416)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device6formatEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+380)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN15running_machine4saveEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1088)|0);
  ;
  return $3;
}


function __ZL21palette_init_tms9928aR15running_machinePKh($machine, $color_prom) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$color_prom;
  var $3=$1;
  __ZL18palette_set_colorsR15running_machinejPKji($3, 0, ((__ZL16TMS9928A_palette)|0), 16);
  ;
  return;
}


function __ZL18palette_set_colorsR15running_machinejPKji($machine, $color_base, $colors, $color_count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      $2=$color_base;
      $3=$colors;
      $4=$color_count;
      __label__ = 1; break;
    case 1: // $5
      var $6=$4;
      var $7=(($6-1)|0);
      $4=$7;
      var $8=(($6)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10+564)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=(($13+1)|0);
      $2=$14;
      var $15=$3;
      var $16=(($15+4)|0);
      $3=$16;
      var $17=HEAP32[(($15)>>2)];
      __Z23palette_entry_set_colorP10_palette_tjj($12, $13, $17);
      __label__ = 1; break;
    case 3: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13screen_device12frame_periodEv($agg_result, $this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=__ZNK8device_t7startedEv($5);
      if ($6) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $7
      var $8=$agg_result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE+8)>>2)];
      __label__ = 4; break;
    case 3: // $9
      var $10=(($2+476)|0);
      var $st$1$0=(($10)|0);
      var $11$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($10+4)|0);
      var $11$1=HEAP32[(($st$1$1)>>2)];
      __ZN8attotimeC1Eix($agg_result, 0, $11$0, $11$1);
      __label__ = 4; break;
    case 4: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 4, 1);
  ;
  return;
}


function __ZL14TMS9928A_startR15running_machinePK18TMS9928a_interface($machine, $intf) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $result_i1=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $result_i=__stackBase__+76;
      var $18=__stackBase__+80;
      var $19=__stackBase__+84;
      var $20;
      var $21;
      var $22;
      var $23;
      var $24=__stackBase__+88;
      $20=$machine;
      $21=$intf;
      __label__ = 1; break;
    case 1: // $25
      var $26=$21;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)==4096;
      if ($29) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $30
      var $31=$21;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)==8192;
      if ($34) { __label__ = 7; break; } else { __label__ = 3; break; }
    case 3: // $35
      var $36=$21;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==16384;
      if ($39) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $40
      var $41=___cxa_allocate_exception(1032);
      var $42=$41;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($42, ((STRING_TABLE.__str11590)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str21591)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str31592)|0),HEAP32[((tempInt+8)>>2)]=181,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      ___cxa_throw($41, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 6: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $22=$46;
      var $47=$45.f1;
      $23=$47;
      ___cxa_free_exception($41);
      __label__ = 56; break;
    case 7: // $48
      __label__ = 8; break;
    case 8: // $49
      var $50=$21;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      HEAP32[((((__ZL3tms+64)|0))>>2)]=$52;
      var $53=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $54=(($53)|0)==2;
      if ($54) { var $59 = 1;__label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $55
      var $56=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $57=(($56)|0)==4;
      var $59 = $57;__label__ = 10; break;
    case 10: // $58
      var $59;
      var $60=$59 ? 51 : 27;
      HEAP32[((((__ZL3tms+72)|0))>>2)]=$60;
      var $61=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $62=(($61)|0)==2;
      if ($62) { var $67 = 1;__label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $63
      var $64=HEAP32[((((__ZL3tms+64)|0))>>2)];
      var $65=(($64)|0)==4;
      var $67 = $65;__label__ = 12; break;
    case 12: // $66
      var $67;
      var $68=$67 ? 51 : 24;
      HEAP32[((((__ZL3tms+76)|0))>>2)]=$68;
      var $69=$21;
      var $70=(($69+16)|0);
      var $71=HEAP32[(($70)>>2)];
      HEAP32[((((__ZL3tms+44)|0))>>2)]=$71;
      var $72=$21;
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0) < 15;
      if ($75) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $76
      var $77=$21;
      var $78=(($77+8)|0);
      var $79=HEAP32[(($78)>>2)];
      var $82 = $79;__label__ = 15; break;
    case 14: // $80
      var $82 = 15;__label__ = 15; break;
    case 15: // $81
      var $82;
      var $83=((15-$82)|0);
      HEAP32[((((__ZL3tms+80)|0))>>2)]=$83;
      var $84=$21;
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0) < 15;
      if ($87) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $88
      var $89=$21;
      var $90=(($89+8)|0);
      var $91=HEAP32[(($90)>>2)];
      var $94 = $91;__label__ = 18; break;
    case 17: // $92
      var $94 = 15;__label__ = 18; break;
    case 18: // $93
      var $94;
      var $95=(($94+270)|0);
      HEAP32[((((__ZL3tms+84)|0))>>2)]=$95;
      var $96=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $97=$21;
      var $98=(($97+12)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $101=(($99)|0) < (($100)|0);
      if ($101) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $102
      var $103=$21;
      var $104=(($103+12)|0);
      var $105=HEAP32[(($104)>>2)];
      var $109 = $105;__label__ = 21; break;
    case 20: // $106
      var $107=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $109 = $107;__label__ = 21; break;
    case 21: // $108
      var $109;
      var $110=(($96-$109)|0);
      HEAP32[((((__ZL3tms+88)|0))>>2)]=$110;
      var $111=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $112=(($111+192)|0);
      var $113=(($112-1)|0);
      var $114=$21;
      var $115=(($114+12)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=HEAP32[((((__ZL3tms+76)|0))>>2)];
      var $118=(($116)|0) < (($117)|0);
      if ($118) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $119
      var $120=$21;
      var $121=(($120+12)|0);
      var $122=HEAP32[(($121)>>2)];
      var $126 = $122;__label__ = 24; break;
    case 23: // $123
      var $124=HEAP32[((((__ZL3tms+76)|0))>>2)];
      var $126 = $124;__label__ = 24; break;
    case 24: // $125
      var $126;
      var $127=(($113+$126)|0);
      HEAP32[((((__ZL3tms+92)|0))>>2)]=$127;
      var $128=$20;
      var $129=(($128+560)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=__ZNK13screen_device5widthEv($130);
      var $132=(($131)|0)==286;
      if ($132) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $133
      var $134=$20;
      var $135=(($134+560)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=__ZNK13screen_device6heightEv($136);
      var $138=(($137)|0)==243;
      if ($138) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $139
      var $140=$20;
      var $141=(($140+560)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=HEAP32[((((__ZL3tms+72)|0))>>2)];
      var $144=(($143+192)|0);
      var $145=HEAP32[((((__ZL3tms+76)|0))>>2)];
      var $146=(($144+$145)|0);
      var $147=$20;
      var $148=(($147+560)|0);
      var $149=HEAP32[(($148)>>2)];
      __ZNK13screen_device12frame_periodEv($24, $149);
      var $150=(($24+4)|0);
      var $st$12$0=(($150)|0);
      var $151$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($150+4)|0);
      var $151$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$0=((__ZL3tms+80)|0);
      __ZN13screen_device9configureEiiRK10_rectanglex($142, 286, $146, $$emscripten$temp$0, $151$0, $151$1);
      __label__ = 27; break;
    case 27: // $152
      var $153=$21;
      var $154=(($153+4)|0);
      var $155=HEAP32[(($154)>>2)];
      HEAP32[((((__ZL3tms+60)|0))>>2)]=$155;
      var $156=$20;
      var $157=__ZN15running_machine7respoolEv($156);
      var $158=$21;
      var $159=(($158+4)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160)|0) < 0;
      var $162=$161 ? -1 : $160;
      var $163=$14;
      var $164=$15;
      var $165=$16;
      var $166=$17;
      var $167=$result_i;
      var $168=$18;
      var $169=$19;
      HEAP32[(($14)>>2)]=$162;
      HEAP32[(($15)>>2)]=((STRING_TABLE.__str31592)|0);
      HEAP32[(($16)>>2)]=203;
      HEAP32[(($17)>>2)]=_zeromem;
      var $170=HEAP32[(($14)>>2)];
      var $171=HEAP32[(($15)>>2)];
      var $172=HEAP32[(($16)>>2)];
      var $173=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($170, $171, $172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; };
    case 28: // $174
      HEAP32[(($result_i)>>2)]=$173;
      var $175=HEAP32[(($result_i)>>2)];
      var $176=(($175)|0)==0;
      if ($176) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $177
      var $178=___cxa_allocate_exception(4);
      var $179=$178;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($179);
      (function() { try { __THREW__ = false; return ___cxa_throw($178, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 30; break; }
    case 30: // $180
      var $181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $182=$181.f0;
      HEAP32[(($18)>>2)]=$182;
      var $183=$181.f1;
      HEAP32[(($19)>>2)]=$183;
      var $184=HEAP32[(($19)>>2)];
      var $185=(($184)|0) < 0;
      if ($185) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $186
      var $187=HEAP32[(($18)>>2)];
      ___cxa_call_unexpected($187);
      throw "Reached an unreachable!"
    case 32: // $188
      var $189=HEAP32[(($18)>>2)];
      var $190=HEAP32[(($18)>>2)];
      var $191=HEAP32[(($19)>>2)];
      var $192=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $190, tempValue);
      var $193=($192.f1 = $191, $192);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $194
      throw "Reached an unreachable!"
    case 34: // $_ZnajPKciRK9zeromem_t_exit
      var $195=HEAP32[(($result_i)>>2)];
      var $196=HEAP32[(($14)>>2)];
      _memset($195, 0, $196, 1);
      var $197=HEAP32[(($result_i)>>2)];
      var $198=$14;
      var $199=$15;
      var $200=$16;
      var $201=$17;
      var $202=$result_i;
      var $203=$18;
      var $204=$19;
      var $205=$21;
      var $206=(($205+4)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=__ZN13resource_pool9add_arrayIhEEPT_S2_i($157, $197, $207);
      HEAP32[((((__ZL3tms+48)|0))>>2)]=$208;
      var $209=$20;
      var $210=__ZN15running_machine7respoolEv($209);
      var $211=$9;
      var $212=$10;
      var $213=$11;
      var $214=$result_i1;
      var $215=$12;
      var $216=$13;
      HEAP32[(($9)>>2)]=49152;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str31592)|0);
      HEAP32[(($11)>>2)]=206;
      var $217=HEAP32[(($9)>>2)];
      var $218=HEAP32[(($10)>>2)];
      var $219=HEAP32[(($11)>>2)];
      var $220=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($217, $218, $219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 37; break; };
    case 35: // $221
      HEAP32[(($result_i1)>>2)]=$220;
      var $222=HEAP32[(($result_i1)>>2)];
      var $223=(($222)|0)==0;
      if ($223) { __label__ = 36; break; } else { __label__ = 41; break; }
    case 36: // $224
      var $225=___cxa_allocate_exception(4);
      var $226=$225;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($226);
      (function() { try { __THREW__ = false; return ___cxa_throw($225, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 37; break; }
    case 37: // $227
      var $228=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $229=$228.f0;
      HEAP32[(($12)>>2)]=$229;
      var $230=$228.f1;
      HEAP32[(($13)>>2)]=$230;
      var $231=HEAP32[(($13)>>2)];
      var $232=(($231)|0) < 0;
      if ($232) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $233
      var $234=HEAP32[(($12)>>2)];
      ___cxa_call_unexpected($234);
      throw "Reached an unreachable!"
    case 39: // $235
      var $236=HEAP32[(($12)>>2)];
      var $237=HEAP32[(($12)>>2)];
      var $238=HEAP32[(($13)>>2)];
      var $239=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $237, tempValue);
      var $240=($239.f1 = $238, $239);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 40: // $241
      throw "Reached an unreachable!"
    case 41: // $_ZnajPKci_exit
      var $242=HEAP32[(($result_i1)>>2)];
      var $243=$9;
      var $244=$10;
      var $245=$11;
      var $246=$result_i1;
      var $247=$12;
      var $248=$13;
      var $249=__ZN13resource_pool9add_arrayIhEEPT_S2_i($210, $242, 49152);
      HEAP32[((((__ZL3tms+52)|0))>>2)]=$249;
      var $250=$20;
      var $251=__ZN15running_machine7respoolEv($250);
      var $252=$4;
      var $253=$5;
      var $254=$6;
      var $255=$result_i2;
      var $256=$7;
      var $257=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str31592)|0);
      HEAP32[(($6)>>2)]=209;
      var $258=HEAP32[(($4)>>2)];
      var $259=HEAP32[(($5)>>2)];
      var $260=HEAP32[(($6)>>2)];
      var $261=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($258, $259, $260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 44; break; };
    case 42: // $262
      HEAP32[(($result_i2)>>2)]=$261;
      var $263=HEAP32[(($result_i2)>>2)];
      var $264=(($263)|0)==0;
      if ($264) { __label__ = 43; break; } else { __label__ = 48; break; }
    case 43: // $265
      var $266=___cxa_allocate_exception(4);
      var $267=$266;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($267);
      (function() { try { __THREW__ = false; return ___cxa_throw($266, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 44; break; }
    case 44: // $268
      var $269=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $270=$269.f0;
      HEAP32[(($7)>>2)]=$270;
      var $271=$269.f1;
      HEAP32[(($8)>>2)]=$271;
      var $272=HEAP32[(($8)>>2)];
      var $273=(($272)|0) < 0;
      if ($273) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $274
      var $275=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($275);
      throw "Reached an unreachable!"
    case 46: // $276
      var $277=HEAP32[(($7)>>2)];
      var $278=HEAP32[(($7)>>2)];
      var $279=HEAP32[(($8)>>2)];
      var $280=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $278, tempValue);
      var $281=($280.f1 = $279, $280);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 47: // $282
      throw "Reached an unreachable!"
    case 48: // $_ZnwjPKci_exit
      var $283=HEAP32[(($result_i2)>>2)];
      var $284=$4;
      var $285=$5;
      var $286=$6;
      var $287=$result_i2;
      var $288=$7;
      var $289=$8;
      var $290=$283;
      var $291=$20;
      var $292=(($291+560)|0);
      var $293=HEAP32[(($292)>>2)];
      var $294=(function() { try { __THREW__ = false; return __ZNK13screen_device6formatEv($293) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 51; break; };
    case 49: // $295
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($290, 256, 192, $294, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $296
      var $297=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($251, $290);
      HEAP32[((((__ZL3tms+56)|0))>>2)]=$297;
      __Z14TMS9928A_resetv();
      HEAP32[((((__ZL3tms+68)|0))>>2)]=1;
      var $298=$20;
      var $299=__ZN15running_machine4saveEv($298);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($299, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+1)|0), ((STRING_TABLE.__str51594)|0));
      var $300=$20;
      var $301=__ZN15running_machine4saveEv($300);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($301, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+2)|0), ((STRING_TABLE.__str61595)|0));
      var $302=$20;
      var $303=__ZN15running_machine4saveEv($302);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($303, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+3)|0), ((STRING_TABLE.__str71596)|0));
      var $304=$20;
      var $305=__ZN15running_machine4saveEv($304);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($305, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+4)|0), ((STRING_TABLE.__str81597)|0));
      var $306=$20;
      var $307=__ZN15running_machine4saveEv($306);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($307, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+5)|0), ((STRING_TABLE.__str91598)|0));
      var $308=$20;
      var $309=__ZN15running_machine4saveEv($308);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($309, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+6)|0), ((STRING_TABLE.__str101599)|0));
      var $310=$20;
      var $311=__ZN15running_machine4saveEv($310);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($311, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+7)|0), ((STRING_TABLE.__str111600)|0));
      var $312=$20;
      var $313=__ZN15running_machine4saveEv($312);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($313, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+8)|0), ((STRING_TABLE.__str121601)|0));
      var $314=$20;
      var $315=__ZN15running_machine4saveEv($314);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($315, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+9)|0), ((STRING_TABLE.__str131602)|0));
      var $316=$20;
      var $317=__ZN15running_machine4saveEv($316);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($317, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms)|0), ((STRING_TABLE.__str141603)|0));
      var $318=$20;
      var $319=__ZN15running_machine4saveEv($318);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($319, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+10)|0), ((STRING_TABLE.__str151604)|0));
      var $320=$20;
      var $321=__ZN15running_machine4saveEv($320);
      __ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_($321, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+12)|0), ((STRING_TABLE.__str161605)|0));
      var $322=$20;
      var $323=__ZN15running_machine4saveEv($322);
      __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($323, ((STRING_TABLE.__str41593)|0), 0, 0, ((__ZL3tms+11)|0), ((STRING_TABLE.__str171606)|0));
      var $324=$20;
      var $325=__ZN15running_machine4saveEv($324);
      var $326=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $327=$21;
      var $328=(($327+4)|0);
      var $329=HEAP32[(($328)>>2)];
      __ZN12save_manager12save_pointerIhEEvPKcS2_iPT_S2_j($325, ((STRING_TABLE.__str41593)|0), 0, 0, $326, ((STRING_TABLE.__str181607)|0), $329);
      STACKTOP = __stackBase__;
      return;
    case 51: // $330
      var $331=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $332=$331.f0;
      $22=$332;
      var $333=$331.f1;
      $23=$333;
      var $334=$1;
      var $335=$2;
      var $336=$3;
      HEAP32[(($1)>>2)]=$283;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str31592)|0);
      HEAP32[(($3)>>2)]=209;
      var $337=HEAP32[(($1)>>2)];
      var $338=(($337)|0)!=0;
      if ($338) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $339
      var $340=HEAP32[(($1)>>2)];
      var $341=HEAP32[(($2)>>2)];
      var $342=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($340, $341, $342) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 57; break; }
    case 53: // $_noexc
      __label__ = 54; break;
    case 54: // $_ZdlPvPKci_exit
      var $343=$1;
      var $344=$2;
      var $345=$3;
      __label__ = 55; break;
    case 55: // $346
      __label__ = 56; break;
    case 56: // $347
      var $348=$22;
      var $349=$22;
      var $350=$23;
      var $351=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $349, tempValue);
      var $352=($351.f1 = $350, $351);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 57: // $353
      var $354=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14TMS9928A_startR15running_machinePK18TMS9928a_interface["X"]=1;

function __Z33construct_machine_config_tms9928aR14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      var $10=$2;
      var $11=(($10+40)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=$2;
      var $13=$3;
      var $14=HEAP32[((_SCREEN)>>2)];
      var $15=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($12, $13, ((STRING_TABLE.__str1589)|0), $14, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; };
    case 4: // $16
      $device=$15;
      var $17=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device15static_set_typeER8device_t16screen_type_enum($17, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $18
      var $19=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device17static_set_formatER8device_t14_bitmap_format($19, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $20
      var $21=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device15static_set_sizeER8device_ttt($21, 286, 243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $22
      var $23=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device18static_set_visareaER8device_tssss($23, 3, 282, 18, 227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $24
      var $25=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device24static_set_screen_updateER8device_tPFjPS_P8bitmap_tPK10_rectangleE($25, 136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $26
      var $27=$2;
      var $28=(($27+48)|0);
      HEAP32[(($28)>>2)]=16;
      var $29=$3;
      (function() { try { __THREW__ = false; return __ZN13driver_device23static_set_palette_initER8device_tPFvR15running_machinePKhE($29, 138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $30
      var $31=$3;
      (function() { try { __THREW__ = false; return __ZN13driver_device19static_set_callbackER8device_tNS_13callback_typeEPFvR15running_machineE($31, 4, 140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $32
      var $33=$3;
      $1=$33;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $34=$1;
      STACKTOP = __stackBase__;
      return $34;
    case 12: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $4=$37;
      var $38=$36.f1;
      $5=$38;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $39
      __label__ = 14; break;
    case 14: // $40
      var $41=$4;
      var $42=$4;
      var $43=$5;
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z33construct_machine_config_tms9928aR14machine_configP8device_t["X"]=1;

function __ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8bitmap_tEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_["X"]=1;

function __ZNK8device_t7startedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+244)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN12save_manager12save_pointerIhEEvPKcS2_iPT_S2_j($this, $module, $tag, $index, $value, $valname, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  $7=$count;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$6;
  var $13=$5;
  var $14=$7;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($8, $9, $10, $11, $12, $13, 1, $14);
  ;
  return;
}


function __ZN20resource_pool_objectI8bitmap_tEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI8bitmap_tEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI8bitmap_tEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 48);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI8bitmap_tE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI8bitmap_tED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI8bitmap_tED2Ev($2);
  ;
  return;
}


function __ZL10draw_mode0P8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $pattern;
      var $x;
      var $y;
      var $yy;
      var $xx;
      var $name;
      var $charcode;
      var $colour;
      var $fg;
      var $bg;
      var $patternptr;
      var $pens;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      $name=0;
      $y=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$y;
      var $10=(($9)|0) < 24;
      if ($10) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $11
      $x=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$x;
      var $14=(($13)|0) < 32;
      if ($14) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $15
      var $16=HEAP32[((((__ZL3tms+24)|0))>>2)];
      var $17=$name;
      var $18=(($16+$17)|0);
      var $19=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $20=(($19+$18)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      $charcode=$22;
      var $23=$name;
      var $24=(($23+1)|0);
      $name=$24;
      var $25=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $26=HEAP32[((((__ZL3tms+20)|0))>>2)];
      var $27=(($25+$26)|0);
      var $28=$charcode;
      var $29=((($28<<3))|0);
      var $30=(($27+$29)|0);
      $patternptr=$30;
      var $31=HEAP32[((((__ZL3tms+16)|0))>>2)];
      var $32=$charcode;
      var $33=(((($32)|0)/8)|0);
      var $34=(($31+$33)|0);
      var $35=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $36=(($35+$34)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      $colour=$38;
      var $39=$colour;
      var $40=(((($39)|0)/16)|0);
      var $41=$pens;
      var $42=(($41+($40<<2))|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43) & 255);
      $fg=$44;
      var $45=$colour;
      var $46=$45 & 15;
      var $47=$pens;
      var $48=(($47+($46<<2))|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49) & 255);
      $bg=$50;
      $yy=0;
      __label__ = 5; break;
    case 5: // $51
      var $52=$yy;
      var $53=(($52)|0) < 8;
      if ($53) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $54
      var $55=$patternptr;
      var $56=(($55+1)|0);
      $patternptr=$56;
      var $57=HEAPU8[($55)];
      var $58=(($57)&255);
      $pattern=$58;
      $xx=0;
      __label__ = 7; break;
    case 7: // $59
      var $60=$xx;
      var $61=(($60)|0) < 8;
      if ($61) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $62
      var $63=$pattern;
      var $64=$63 & 128;
      var $65=(($64)|0)!=0;
      var $66=$fg;
      var $67=$bg;
      var $68=$65 ? $66 : $67;
      var $69=(($68)&255);
      var $70=$2;
      var $71=$70;
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73;
      var $75=$y;
      var $76=((($75<<3))|0);
      var $77=$yy;
      var $78=(($76+$77)|0);
      var $79=$2;
      var $80=$79;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($78*$82)|0);
      var $84=(($74+($83<<1))|0);
      var $85=$x;
      var $86=((($85<<3))|0);
      var $87=$xx;
      var $88=(($86+$87)|0);
      var $89=(($84+($88<<1))|0);
      HEAP16[(($89)>>1)]=$69;
      var $90=$pattern;
      var $91=((($90<<1))|0);
      $pattern=$91;
      __label__ = 9; break;
    case 9: // $92
      var $93=$xx;
      var $94=(($93+1)|0);
      $xx=$94;
      __label__ = 7; break;
    case 10: // $95
      __label__ = 11; break;
    case 11: // $96
      var $97=$yy;
      var $98=(($97+1)|0);
      $yy=$98;
      __label__ = 5; break;
    case 12: // $99
      __label__ = 13; break;
    case 13: // $100
      var $101=$x;
      var $102=(($101+1)|0);
      $x=$102;
      __label__ = 3; break;
    case 14: // $103
      __label__ = 15; break;
    case 15: // $104
      var $105=$y;
      var $106=(($105+1)|0);
      $y=$106;
      __label__ = 1; break;
    case 16: // $107
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10draw_mode0P8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __ZL10draw_mode1P8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $pattern;
      var $x;
      var $y;
      var $yy;
      var $xx;
      var $name;
      var $charcode;
      var $fg;
      var $bg;
      var $patternptr;
      var $rt=__stackBase__;
      var $pens;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      var $8=HEAPU8[(((__ZL3tms+8)|0))];
      var $9=(($8)&255);
      var $10=(((($9)|0)/16)|0);
      var $11=$pens;
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13) & 255);
      $fg=$14;
      var $15=HEAPU8[(((__ZL3tms+8)|0))];
      var $16=(($15)&255);
      var $17=$16 & 15;
      var $18=$pens;
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 255);
      $bg=$21;
      var $22=(($rt+8)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($rt+12)|0);
      HEAP32[(($23)>>2)]=191;
      var $24=(($rt)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($rt+4)|0);
      HEAP32[(($25)>>2)]=7;
      var $26=$2;
      var $27=$bg;
      var $28=(($27)&255);
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($26, $rt, $28);
      var $29=(($rt+8)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($rt+12)|0);
      HEAP32[(($30)>>2)]=191;
      var $31=(($rt)|0);
      HEAP32[(($31)>>2)]=248;
      var $32=(($rt+4)|0);
      HEAP32[(($32)>>2)]=255;
      var $33=$2;
      var $34=$bg;
      var $35=(($34)&255);
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($33, $rt, $35);
      $name=0;
      $y=0;
      __label__ = 1; break;
    case 1: // $36
      var $37=$y;
      var $38=(($37)|0) < 24;
      if ($38) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $39
      $x=0;
      __label__ = 3; break;
    case 3: // $40
      var $41=$x;
      var $42=(($41)|0) < 40;
      if ($42) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $43
      var $44=HEAP32[((((__ZL3tms+24)|0))>>2)];
      var $45=$name;
      var $46=(($44+$45)|0);
      var $47=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $48=(($47+$46)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      $charcode=$50;
      var $51=$name;
      var $52=(($51+1)|0);
      $name=$52;
      var $53=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $54=HEAP32[((((__ZL3tms+20)|0))>>2)];
      var $55=(($53+$54)|0);
      var $56=$charcode;
      var $57=((($56<<3))|0);
      var $58=(($55+$57)|0);
      $patternptr=$58;
      $yy=0;
      __label__ = 5; break;
    case 5: // $59
      var $60=$yy;
      var $61=(($60)|0) < 8;
      if ($61) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $62
      var $63=$patternptr;
      var $64=(($63+1)|0);
      $patternptr=$64;
      var $65=HEAPU8[($63)];
      var $66=(($65)&255);
      $pattern=$66;
      $xx=0;
      __label__ = 7; break;
    case 7: // $67
      var $68=$xx;
      var $69=(($68)|0) < 6;
      if ($69) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $70
      var $71=$pattern;
      var $72=$71 & 128;
      var $73=(($72)|0)!=0;
      var $74=$fg;
      var $75=$bg;
      var $76=$73 ? $74 : $75;
      var $77=(($76)&255);
      var $78=$2;
      var $79=$78;
      var $80=(($79+4)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81;
      var $83=$y;
      var $84=((($83<<3))|0);
      var $85=$yy;
      var $86=(($84+$85)|0);
      var $87=$2;
      var $88=$87;
      var $89=(($88+8)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($86*$90)|0);
      var $92=(($82+($91<<1))|0);
      var $93=$x;
      var $94=(($93*6)|0);
      var $95=(($94+8)|0);
      var $96=$xx;
      var $97=(($95+$96)|0);
      var $98=(($92+($97<<1))|0);
      HEAP16[(($98)>>1)]=$77;
      var $99=$pattern;
      var $100=((($99<<1))|0);
      $pattern=$100;
      __label__ = 9; break;
    case 9: // $101
      var $102=$xx;
      var $103=(($102+1)|0);
      $xx=$103;
      __label__ = 7; break;
    case 10: // $104
      __label__ = 11; break;
    case 11: // $105
      var $106=$yy;
      var $107=(($106+1)|0);
      $yy=$107;
      __label__ = 5; break;
    case 12: // $108
      __label__ = 13; break;
    case 13: // $109
      var $110=$x;
      var $111=(($110+1)|0);
      $x=$111;
      __label__ = 3; break;
    case 14: // $112
      __label__ = 15; break;
    case 15: // $113
      var $114=$y;
      var $115=(($114+1)|0);
      $y=$115;
      __label__ = 1; break;
    case 16: // $116
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10draw_mode1P8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __ZL10draw_mode2P8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $colour;
      var $name;
      var $x;
      var $y;
      var $yy;
      var $pattern;
      var $xx;
      var $charcode;
      var $fg;
      var $bg;
      var $pens;
      var $colourptr;
      var $patternptr;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      $name=0;
      $y=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$y;
      var $10=(($9)|0) < 24;
      if ($10) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $11
      $x=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$x;
      var $14=(($13)|0) < 32;
      if ($14) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $15
      var $16=HEAP32[((((__ZL3tms+24)|0))>>2)];
      var $17=$name;
      var $18=(($16+$17)|0);
      var $19=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $20=(($19+$18)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$y;
      var $24=(((($23)|0)/8)|0);
      var $25=((($24<<8))|0);
      var $26=(($22+$25)|0);
      $charcode=$26;
      var $27=$name;
      var $28=(($27+1)|0);
      $name=$28;
      var $29=$charcode;
      var $30=HEAP32[((((__ZL3tms+36)|0))>>2)];
      var $31=$29 & $30;
      $colour=$31;
      var $32=$charcode;
      var $33=HEAP32[((((__ZL3tms+40)|0))>>2)];
      var $34=$32 & $33;
      $pattern=$34;
      var $35=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $36=HEAP32[((((__ZL3tms+20)|0))>>2)];
      var $37=(($35+$36)|0);
      var $38=$colour;
      var $39=((($38<<3))|0);
      var $40=(($37+$39)|0);
      $patternptr=$40;
      var $41=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $42=HEAP32[((((__ZL3tms+16)|0))>>2)];
      var $43=(($41+$42)|0);
      var $44=$pattern;
      var $45=((($44<<3))|0);
      var $46=(($43+$45)|0);
      $colourptr=$46;
      $yy=0;
      __label__ = 5; break;
    case 5: // $47
      var $48=$yy;
      var $49=(($48)|0) < 8;
      if ($49) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $50
      var $51=$patternptr;
      var $52=(($51+1)|0);
      $patternptr=$52;
      var $53=HEAPU8[($51)];
      var $54=(($53)&255);
      $pattern=$54;
      var $55=$colourptr;
      var $56=(($55+1)|0);
      $colourptr=$56;
      var $57=HEAPU8[($55)];
      var $58=(($57)&255);
      $colour=$58;
      var $59=$colour;
      var $60=(((($59)|0)/16)|0);
      var $61=$pens;
      var $62=(($61+($60<<2))|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63) & 255);
      $fg=$64;
      var $65=$colour;
      var $66=$65 & 15;
      var $67=$pens;
      var $68=(($67+($66<<2))|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69) & 255);
      $bg=$70;
      $xx=0;
      __label__ = 7; break;
    case 7: // $71
      var $72=$xx;
      var $73=(($72)|0) < 8;
      if ($73) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $74
      var $75=$pattern;
      var $76=$75 & 128;
      var $77=(($76)|0)!=0;
      var $78=$fg;
      var $79=$bg;
      var $80=$77 ? $78 : $79;
      var $81=(($80)&255);
      var $82=$2;
      var $83=$82;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$85;
      var $87=$y;
      var $88=((($87<<3))|0);
      var $89=$yy;
      var $90=(($88+$89)|0);
      var $91=$2;
      var $92=$91;
      var $93=(($92+8)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($90*$94)|0);
      var $96=(($86+($95<<1))|0);
      var $97=$x;
      var $98=((($97<<3))|0);
      var $99=$xx;
      var $100=(($98+$99)|0);
      var $101=(($96+($100<<1))|0);
      HEAP16[(($101)>>1)]=$81;
      var $102=$pattern;
      var $103=((($102<<1))|0);
      $pattern=$103;
      __label__ = 9; break;
    case 9: // $104
      var $105=$xx;
      var $106=(($105+1)|0);
      $xx=$106;
      __label__ = 7; break;
    case 10: // $107
      __label__ = 11; break;
    case 11: // $108
      var $109=$yy;
      var $110=(($109+1)|0);
      $yy=$110;
      __label__ = 5; break;
    case 12: // $111
      __label__ = 13; break;
    case 13: // $112
      var $113=$x;
      var $114=(($113+1)|0);
      $x=$114;
      __label__ = 3; break;
    case 14: // $115
      __label__ = 15; break;
    case 15: // $116
      var $117=$y;
      var $118=(($117+1)|0);
      $y=$118;
      __label__ = 1; break;
    case 16: // $119
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10draw_mode2P8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __ZN20resource_pool_objectI8bitmap_tED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8bitmap_tED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI8bitmap_tED0Ev["X"]=1;

function __ZN20resource_pool_objectI8bitmap_tED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI8bitmap_tE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI8bitmap_tED2Ev["X"]=1;

function __ZL11draw_mode12P8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $pattern;
      var $x;
      var $y;
      var $yy;
      var $xx;
      var $name;
      var $charcode;
      var $fg;
      var $bg;
      var $patternptr;
      var $pens;
      var $rt=__stackBase__;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      var $8=HEAPU8[(((__ZL3tms+8)|0))];
      var $9=(($8)&255);
      var $10=(((($9)|0)/16)|0);
      var $11=$pens;
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13) & 255);
      $fg=$14;
      var $15=HEAPU8[(((__ZL3tms+8)|0))];
      var $16=(($15)&255);
      var $17=$16 & 15;
      var $18=$pens;
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 255);
      $bg=$21;
      var $22=(($rt+8)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($rt+12)|0);
      HEAP32[(($23)>>2)]=191;
      var $24=(($rt)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($rt+4)|0);
      HEAP32[(($25)>>2)]=7;
      var $26=$2;
      var $27=$bg;
      var $28=(($27)&255);
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($26, $rt, $28);
      var $29=(($rt+8)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($rt+12)|0);
      HEAP32[(($30)>>2)]=191;
      var $31=(($rt)|0);
      HEAP32[(($31)>>2)]=248;
      var $32=(($rt+4)|0);
      HEAP32[(($32)>>2)]=255;
      var $33=$2;
      var $34=$bg;
      var $35=(($34)&255);
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($33, $rt, $35);
      $name=0;
      $y=0;
      __label__ = 1; break;
    case 1: // $36
      var $37=$y;
      var $38=(($37)|0) < 24;
      if ($38) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $39
      $x=0;
      __label__ = 3; break;
    case 3: // $40
      var $41=$x;
      var $42=(($41)|0) < 40;
      if ($42) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $43
      var $44=HEAP32[((((__ZL3tms+24)|0))>>2)];
      var $45=$name;
      var $46=(($44+$45)|0);
      var $47=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $48=(($47+$46)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$y;
      var $52=(((($51)|0)/8)|0);
      var $53=((($52<<8))|0);
      var $54=(($50+$53)|0);
      var $55=HEAP32[((((__ZL3tms+40)|0))>>2)];
      var $56=$54 & $55;
      $charcode=$56;
      var $57=$name;
      var $58=(($57+1)|0);
      $name=$58;
      var $59=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $60=HEAP32[((((__ZL3tms+20)|0))>>2)];
      var $61=(($59+$60)|0);
      var $62=$charcode;
      var $63=((($62<<3))|0);
      var $64=(($61+$63)|0);
      $patternptr=$64;
      $yy=0;
      __label__ = 5; break;
    case 5: // $65
      var $66=$yy;
      var $67=(($66)|0) < 8;
      if ($67) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $68
      var $69=$patternptr;
      var $70=(($69+1)|0);
      $patternptr=$70;
      var $71=HEAPU8[($69)];
      var $72=(($71)&255);
      $pattern=$72;
      $xx=0;
      __label__ = 7; break;
    case 7: // $73
      var $74=$xx;
      var $75=(($74)|0) < 6;
      if ($75) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $76
      var $77=$pattern;
      var $78=$77 & 128;
      var $79=(($78)|0)!=0;
      var $80=$fg;
      var $81=$bg;
      var $82=$79 ? $80 : $81;
      var $83=(($82)&255);
      var $84=$2;
      var $85=$84;
      var $86=(($85+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$87;
      var $89=$y;
      var $90=((($89<<3))|0);
      var $91=$yy;
      var $92=(($90+$91)|0);
      var $93=$2;
      var $94=$93;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($92*$96)|0);
      var $98=(($88+($97<<1))|0);
      var $99=$x;
      var $100=(($99*6)|0);
      var $101=(($100+8)|0);
      var $102=$xx;
      var $103=(($101+$102)|0);
      var $104=(($98+($103<<1))|0);
      HEAP16[(($104)>>1)]=$83;
      var $105=$pattern;
      var $106=((($105<<1))|0);
      $pattern=$106;
      __label__ = 9; break;
    case 9: // $107
      var $108=$xx;
      var $109=(($108+1)|0);
      $xx=$109;
      __label__ = 7; break;
    case 10: // $110
      __label__ = 11; break;
    case 11: // $111
      var $112=$yy;
      var $113=(($112+1)|0);
      $yy=$113;
      __label__ = 5; break;
    case 12: // $114
      __label__ = 13; break;
    case 13: // $115
      var $116=$x;
      var $117=(($116+1)|0);
      $x=$117;
      __label__ = 3; break;
    case 14: // $118
      __label__ = 15; break;
    case 15: // $119
      var $120=$y;
      var $121=(($120+1)|0);
      $y=$121;
      __label__ = 1; break;
    case 16: // $122
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11draw_mode12P8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __ZL10draw_mode3P8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $x;
      var $y;
      var $yy;
      var $yyy;
      var $name;
      var $charcode;
      var $fg;
      var $bg;
      var $patternptr;
      var $pens;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      $name=0;
      $y=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$y;
      var $10=(($9)|0) < 24;
      if ($10) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $11
      $x=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$x;
      var $14=(($13)|0) < 32;
      if ($14) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $15
      var $16=HEAP32[((((__ZL3tms+24)|0))>>2)];
      var $17=$name;
      var $18=(($16+$17)|0);
      var $19=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $20=(($19+$18)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      $charcode=$22;
      var $23=$name;
      var $24=(($23+1)|0);
      $name=$24;
      var $25=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $26=HEAP32[((((__ZL3tms+20)|0))>>2)];
      var $27=(($25+$26)|0);
      var $28=$charcode;
      var $29=((($28<<3))|0);
      var $30=(($27+$29)|0);
      var $31=$y;
      var $32=$31 & 3;
      var $33=((($32<<1))|0);
      var $34=(($30+$33)|0);
      $patternptr=$34;
      $yy=0;
      __label__ = 5; break;
    case 5: // $35
      var $36=$yy;
      var $37=(($36)|0) < 2;
      if ($37) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $38
      var $39=$patternptr;
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=(((($41)|0)/16)|0);
      var $43=$pens;
      var $44=(($43+($42<<2))|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45) & 255);
      $fg=$46;
      var $47=$patternptr;
      var $48=(($47+1)|0);
      $patternptr=$48;
      var $49=HEAPU8[($47)];
      var $50=(($49)&255);
      var $51=$50 & 15;
      var $52=$pens;
      var $53=(($52+($51<<2))|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54) & 255);
      $bg=$55;
      $yyy=0;
      __label__ = 7; break;
    case 7: // $56
      var $57=$yyy;
      var $58=(($57)|0) < 4;
      if ($58) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $59
      var $60=$fg;
      var $61=(($60)&255);
      var $62=$2;
      var $63=$62;
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65;
      var $67=$y;
      var $68=((($67<<3))|0);
      var $69=$yy;
      var $70=((($69<<2))|0);
      var $71=(($68+$70)|0);
      var $72=$yyy;
      var $73=(($71+$72)|0);
      var $74=$2;
      var $75=$74;
      var $76=(($75+8)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($73*$77)|0);
      var $79=(($66+($78<<1))|0);
      var $80=$x;
      var $81=((($80<<3))|0);
      var $82=(($81)|0);
      var $83=(($79+($82<<1))|0);
      HEAP16[(($83)>>1)]=$61;
      var $84=$fg;
      var $85=(($84)&255);
      var $86=$2;
      var $87=$86;
      var $88=(($87+4)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89;
      var $91=$y;
      var $92=((($91<<3))|0);
      var $93=$yy;
      var $94=((($93<<2))|0);
      var $95=(($92+$94)|0);
      var $96=$yyy;
      var $97=(($95+$96)|0);
      var $98=$2;
      var $99=$98;
      var $100=(($99+8)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($97*$101)|0);
      var $103=(($90+($102<<1))|0);
      var $104=$x;
      var $105=((($104<<3))|0);
      var $106=(($105+1)|0);
      var $107=(($103+($106<<1))|0);
      HEAP16[(($107)>>1)]=$85;
      var $108=$fg;
      var $109=(($108)&255);
      var $110=$2;
      var $111=$110;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113;
      var $115=$y;
      var $116=((($115<<3))|0);
      var $117=$yy;
      var $118=((($117<<2))|0);
      var $119=(($116+$118)|0);
      var $120=$yyy;
      var $121=(($119+$120)|0);
      var $122=$2;
      var $123=$122;
      var $124=(($123+8)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($121*$125)|0);
      var $127=(($114+($126<<1))|0);
      var $128=$x;
      var $129=((($128<<3))|0);
      var $130=(($129+2)|0);
      var $131=(($127+($130<<1))|0);
      HEAP16[(($131)>>1)]=$109;
      var $132=$fg;
      var $133=(($132)&255);
      var $134=$2;
      var $135=$134;
      var $136=(($135+4)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$137;
      var $139=$y;
      var $140=((($139<<3))|0);
      var $141=$yy;
      var $142=((($141<<2))|0);
      var $143=(($140+$142)|0);
      var $144=$yyy;
      var $145=(($143+$144)|0);
      var $146=$2;
      var $147=$146;
      var $148=(($147+8)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($145*$149)|0);
      var $151=(($138+($150<<1))|0);
      var $152=$x;
      var $153=((($152<<3))|0);
      var $154=(($153+3)|0);
      var $155=(($151+($154<<1))|0);
      HEAP16[(($155)>>1)]=$133;
      var $156=$bg;
      var $157=(($156)&255);
      var $158=$2;
      var $159=$158;
      var $160=(($159+4)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$161;
      var $163=$y;
      var $164=((($163<<3))|0);
      var $165=$yy;
      var $166=((($165<<2))|0);
      var $167=(($164+$166)|0);
      var $168=$yyy;
      var $169=(($167+$168)|0);
      var $170=$2;
      var $171=$170;
      var $172=(($171+8)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=(($169*$173)|0);
      var $175=(($162+($174<<1))|0);
      var $176=$x;
      var $177=((($176<<3))|0);
      var $178=(($177+4)|0);
      var $179=(($175+($178<<1))|0);
      HEAP16[(($179)>>1)]=$157;
      var $180=$bg;
      var $181=(($180)&255);
      var $182=$2;
      var $183=$182;
      var $184=(($183+4)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$185;
      var $187=$y;
      var $188=((($187<<3))|0);
      var $189=$yy;
      var $190=((($189<<2))|0);
      var $191=(($188+$190)|0);
      var $192=$yyy;
      var $193=(($191+$192)|0);
      var $194=$2;
      var $195=$194;
      var $196=(($195+8)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($193*$197)|0);
      var $199=(($186+($198<<1))|0);
      var $200=$x;
      var $201=((($200<<3))|0);
      var $202=(($201+5)|0);
      var $203=(($199+($202<<1))|0);
      HEAP16[(($203)>>1)]=$181;
      var $204=$bg;
      var $205=(($204)&255);
      var $206=$2;
      var $207=$206;
      var $208=(($207+4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$209;
      var $211=$y;
      var $212=((($211<<3))|0);
      var $213=$yy;
      var $214=((($213<<2))|0);
      var $215=(($212+$214)|0);
      var $216=$yyy;
      var $217=(($215+$216)|0);
      var $218=$2;
      var $219=$218;
      var $220=(($219+8)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($217*$221)|0);
      var $223=(($210+($222<<1))|0);
      var $224=$x;
      var $225=((($224<<3))|0);
      var $226=(($225+6)|0);
      var $227=(($223+($226<<1))|0);
      HEAP16[(($227)>>1)]=$205;
      var $228=$bg;
      var $229=(($228)&255);
      var $230=$2;
      var $231=$230;
      var $232=(($231+4)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$233;
      var $235=$y;
      var $236=((($235<<3))|0);
      var $237=$yy;
      var $238=((($237<<2))|0);
      var $239=(($236+$238)|0);
      var $240=$yyy;
      var $241=(($239+$240)|0);
      var $242=$2;
      var $243=$242;
      var $244=(($243+8)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=(($241*$245)|0);
      var $247=(($234+($246<<1))|0);
      var $248=$x;
      var $249=((($248<<3))|0);
      var $250=(($249+7)|0);
      var $251=(($247+($250<<1))|0);
      HEAP16[(($251)>>1)]=$229;
      __label__ = 9; break;
    case 9: // $252
      var $253=$yyy;
      var $254=(($253+1)|0);
      $yyy=$254;
      __label__ = 7; break;
    case 10: // $255
      __label__ = 11; break;
    case 11: // $256
      var $257=$yy;
      var $258=(($257+1)|0);
      $yy=$258;
      __label__ = 5; break;
    case 12: // $259
      __label__ = 13; break;
    case 13: // $260
      var $261=$x;
      var $262=(($261+1)|0);
      $x=$262;
      __label__ = 3; break;
    case 14: // $263
      __label__ = 15; break;
    case 15: // $264
      var $265=$y;
      var $266=(($265+1)|0);
      $y=$266;
      __label__ = 1; break;
    case 16: // $267
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10draw_mode3P8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __ZL14draw_modebogusP8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fg;
      var $bg;
      var $x;
      var $y;
      var $n;
      var $xx;
      var $pens;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      var $8=HEAPU8[(((__ZL3tms+8)|0))];
      var $9=(($8)&255);
      var $10=(((($9)|0)/16)|0);
      var $11=$pens;
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13) & 255);
      $fg=$14;
      var $15=HEAPU8[(((__ZL3tms+8)|0))];
      var $16=(($15)&255);
      var $17=$16 & 15;
      var $18=$pens;
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20) & 255);
      $bg=$21;
      $y=0;
      __label__ = 1; break;
    case 1: // $22
      var $23=$y;
      var $24=(($23)|0) < 192;
      if ($24) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $25
      $xx=0;
      $n=8;
      __label__ = 3; break;
    case 3: // $26
      var $27=$n;
      var $28=(($27-1)|0);
      $n=$28;
      var $29=(($27)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$bg;
      var $32=(($31)&255);
      var $33=$2;
      var $34=$33;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36;
      var $38=$y;
      var $39=$2;
      var $40=$39;
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($38*$42)|0);
      var $44=(($37+($43<<1))|0);
      var $45=$xx;
      var $46=(($45+1)|0);
      $xx=$46;
      var $47=(($44+($45<<1))|0);
      HEAP16[(($47)>>1)]=$32;
      __label__ = 3; break;
    case 5: // $48
      $x=0;
      __label__ = 6; break;
    case 6: // $49
      var $50=$x;
      var $51=(($50)|0) < 40;
      if ($51) { __label__ = 7; break; } else { __label__ = 15; break; }
    case 7: // $52
      $n=4;
      __label__ = 8; break;
    case 8: // $53
      var $54=$n;
      var $55=(($54-1)|0);
      $n=$55;
      var $56=(($54)|0)!=0;
      if ($56) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $57
      var $58=$fg;
      var $59=(($58)&255);
      var $60=$2;
      var $61=$60;
      var $62=(($61+4)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$63;
      var $65=$y;
      var $66=$2;
      var $67=$66;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($65*$69)|0);
      var $71=(($64+($70<<1))|0);
      var $72=$xx;
      var $73=(($72+1)|0);
      $xx=$73;
      var $74=(($71+($72<<1))|0);
      HEAP16[(($74)>>1)]=$59;
      __label__ = 8; break;
    case 10: // $75
      $n=2;
      __label__ = 11; break;
    case 11: // $76
      var $77=$n;
      var $78=(($77-1)|0);
      $n=$78;
      var $79=(($77)|0)!=0;
      if ($79) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $80
      var $81=$bg;
      var $82=(($81)&255);
      var $83=$2;
      var $84=$83;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86;
      var $88=$y;
      var $89=$2;
      var $90=$89;
      var $91=(($90+8)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($88*$92)|0);
      var $94=(($87+($93<<1))|0);
      var $95=$xx;
      var $96=(($95+1)|0);
      $xx=$96;
      var $97=(($94+($95<<1))|0);
      HEAP16[(($97)>>1)]=$82;
      __label__ = 11; break;
    case 13: // $98
      __label__ = 14; break;
    case 14: // $99
      var $100=$x;
      var $101=(($100+1)|0);
      $x=$101;
      __label__ = 6; break;
    case 15: // $102
      $n=8;
      __label__ = 16; break;
    case 16: // $103
      var $104=$n;
      var $105=(($104-1)|0);
      $n=$105;
      var $106=(($104)|0)!=0;
      if ($106) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $107
      var $108=$bg;
      var $109=(($108)&255);
      var $110=$2;
      var $111=$110;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113;
      var $115=$y;
      var $116=$2;
      var $117=$116;
      var $118=(($117+8)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($115*$119)|0);
      var $121=(($114+($120<<1))|0);
      var $122=$xx;
      var $123=(($122+1)|0);
      $xx=$123;
      var $124=(($121+($122<<1))|0);
      HEAP16[(($124)>>1)]=$109;
      __label__ = 16; break;
    case 18: // $125
      __label__ = 19; break;
    case 19: // $126
      var $127=$y;
      var $128=(($127+1)|0);
      $y=$128;
      __label__ = 1; break;
    case 20: // $129
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14draw_modebogusP8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __Z8downcastIR12timer_device8device_tET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZleRK8attotimeS1_($left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) < (($8)|0);
      if ($9) { var $29 = 1;__label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0)==(($16)|0);
      if ($17) { __label__ = 2; break; } else { var $27 = 0;__label__ = 3; break; }
    case 2: // $18
      var $19=$1;
      var $20=(($19+4)|0);
      var $st$2$0=(($20)|0);
      var $21$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$2$1)>>2)];
      var $22=$2;
      var $23=(($22+4)|0);
      var $st$8$0=(($23)|0);
      var $24$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($23+4)|0);
      var $24$1=HEAP32[(($st$8$1)>>2)];
      var $25=($21$1|0) <= ($24$1|0) && (($21$1|0) <  ($24$1|0) || ($21$0|0) <= ($24$0|0));
      var $27 = $25;__label__ = 3; break;
    case 3: // $26
      var $27;
      var $29 = $27;__label__ = 4; break;
    case 4: // $28
      var $29;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11draw_mode23P8device_tP8bitmap_tPK10_rectangle($screen, $bitmap, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $x;
      var $y;
      var $yy;
      var $yyy;
      var $name;
      var $charcode;
      var $fg;
      var $bg;
      var $patternptr;
      var $pens;
      $1=$screen;
      $2=$bitmap;
      $3=$cliprect;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+568)|0);
      var $7=HEAP32[(($6)>>2)];
      $pens=$7;
      $name=0;
      $y=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$y;
      var $10=(($9)|0) < 24;
      if ($10) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $11
      $x=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$x;
      var $14=(($13)|0) < 32;
      if ($14) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $15
      var $16=HEAP32[((((__ZL3tms+24)|0))>>2)];
      var $17=$name;
      var $18=(($16+$17)|0);
      var $19=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $20=(($19+$18)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      $charcode=$22;
      var $23=$name;
      var $24=(($23+1)|0);
      $name=$24;
      var $25=HEAP32[((((__ZL3tms+48)|0))>>2)];
      var $26=HEAP32[((((__ZL3tms+20)|0))>>2)];
      var $27=(($25+$26)|0);
      var $28=$charcode;
      var $29=$y;
      var $30=$29 & 3;
      var $31=((($30<<1))|0);
      var $32=(($28+$31)|0);
      var $33=$y;
      var $34=(((($33)|0)/8)|0);
      var $35=((($34<<8))|0);
      var $36=(($32+$35)|0);
      var $37=HEAP32[((((__ZL3tms+40)|0))>>2)];
      var $38=$36 & $37;
      var $39=((($38<<3))|0);
      var $40=(($27+$39)|0);
      $patternptr=$40;
      $yy=0;
      __label__ = 5; break;
    case 5: // $41
      var $42=$yy;
      var $43=(($42)|0) < 2;
      if ($43) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $44
      var $45=$patternptr;
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=(((($47)|0)/16)|0);
      var $49=$pens;
      var $50=(($49+($48<<2))|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51) & 255);
      $fg=$52;
      var $53=$patternptr;
      var $54=(($53+1)|0);
      $patternptr=$54;
      var $55=HEAPU8[($53)];
      var $56=(($55)&255);
      var $57=$56 & 15;
      var $58=$pens;
      var $59=(($58+($57<<2))|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60) & 255);
      $bg=$61;
      $yyy=0;
      __label__ = 7; break;
    case 7: // $62
      var $63=$yyy;
      var $64=(($63)|0) < 4;
      if ($64) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $65
      var $66=$fg;
      var $67=(($66)&255);
      var $68=$2;
      var $69=$68;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71;
      var $73=$y;
      var $74=((($73<<3))|0);
      var $75=$yy;
      var $76=((($75<<2))|0);
      var $77=(($74+$76)|0);
      var $78=$yyy;
      var $79=(($77+$78)|0);
      var $80=$2;
      var $81=$80;
      var $82=(($81+8)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($79*$83)|0);
      var $85=(($72+($84<<1))|0);
      var $86=$x;
      var $87=((($86<<3))|0);
      var $88=(($87)|0);
      var $89=(($85+($88<<1))|0);
      HEAP16[(($89)>>1)]=$67;
      var $90=$fg;
      var $91=(($90)&255);
      var $92=$2;
      var $93=$92;
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$95;
      var $97=$y;
      var $98=((($97<<3))|0);
      var $99=$yy;
      var $100=((($99<<2))|0);
      var $101=(($98+$100)|0);
      var $102=$yyy;
      var $103=(($101+$102)|0);
      var $104=$2;
      var $105=$104;
      var $106=(($105+8)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($103*$107)|0);
      var $109=(($96+($108<<1))|0);
      var $110=$x;
      var $111=((($110<<3))|0);
      var $112=(($111+1)|0);
      var $113=(($109+($112<<1))|0);
      HEAP16[(($113)>>1)]=$91;
      var $114=$fg;
      var $115=(($114)&255);
      var $116=$2;
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119;
      var $121=$y;
      var $122=((($121<<3))|0);
      var $123=$yy;
      var $124=((($123<<2))|0);
      var $125=(($122+$124)|0);
      var $126=$yyy;
      var $127=(($125+$126)|0);
      var $128=$2;
      var $129=$128;
      var $130=(($129+8)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($127*$131)|0);
      var $133=(($120+($132<<1))|0);
      var $134=$x;
      var $135=((($134<<3))|0);
      var $136=(($135+2)|0);
      var $137=(($133+($136<<1))|0);
      HEAP16[(($137)>>1)]=$115;
      var $138=$fg;
      var $139=(($138)&255);
      var $140=$2;
      var $141=$140;
      var $142=(($141+4)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$143;
      var $145=$y;
      var $146=((($145<<3))|0);
      var $147=$yy;
      var $148=((($147<<2))|0);
      var $149=(($146+$148)|0);
      var $150=$yyy;
      var $151=(($149+$150)|0);
      var $152=$2;
      var $153=$152;
      var $154=(($153+8)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($151*$155)|0);
      var $157=(($144+($156<<1))|0);
      var $158=$x;
      var $159=((($158<<3))|0);
      var $160=(($159+3)|0);
      var $161=(($157+($160<<1))|0);
      HEAP16[(($161)>>1)]=$139;
      var $162=$bg;
      var $163=(($162)&255);
      var $164=$2;
      var $165=$164;
      var $166=(($165+4)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$167;
      var $169=$y;
      var $170=((($169<<3))|0);
      var $171=$yy;
      var $172=((($171<<2))|0);
      var $173=(($170+$172)|0);
      var $174=$yyy;
      var $175=(($173+$174)|0);
      var $176=$2;
      var $177=$176;
      var $178=(($177+8)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($175*$179)|0);
      var $181=(($168+($180<<1))|0);
      var $182=$x;
      var $183=((($182<<3))|0);
      var $184=(($183+4)|0);
      var $185=(($181+($184<<1))|0);
      HEAP16[(($185)>>1)]=$163;
      var $186=$bg;
      var $187=(($186)&255);
      var $188=$2;
      var $189=$188;
      var $190=(($189+4)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$191;
      var $193=$y;
      var $194=((($193<<3))|0);
      var $195=$yy;
      var $196=((($195<<2))|0);
      var $197=(($194+$196)|0);
      var $198=$yyy;
      var $199=(($197+$198)|0);
      var $200=$2;
      var $201=$200;
      var $202=(($201+8)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(($199*$203)|0);
      var $205=(($192+($204<<1))|0);
      var $206=$x;
      var $207=((($206<<3))|0);
      var $208=(($207+5)|0);
      var $209=(($205+($208<<1))|0);
      HEAP16[(($209)>>1)]=$187;
      var $210=$bg;
      var $211=(($210)&255);
      var $212=$2;
      var $213=$212;
      var $214=(($213+4)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=$215;
      var $217=$y;
      var $218=((($217<<3))|0);
      var $219=$yy;
      var $220=((($219<<2))|0);
      var $221=(($218+$220)|0);
      var $222=$yyy;
      var $223=(($221+$222)|0);
      var $224=$2;
      var $225=$224;
      var $226=(($225+8)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($223*$227)|0);
      var $229=(($216+($228<<1))|0);
      var $230=$x;
      var $231=((($230<<3))|0);
      var $232=(($231+6)|0);
      var $233=(($229+($232<<1))|0);
      HEAP16[(($233)>>1)]=$211;
      var $234=$bg;
      var $235=(($234)&255);
      var $236=$2;
      var $237=$236;
      var $238=(($237+4)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$239;
      var $241=$y;
      var $242=((($241<<3))|0);
      var $243=$yy;
      var $244=((($243<<2))|0);
      var $245=(($242+$244)|0);
      var $246=$yyy;
      var $247=(($245+$246)|0);
      var $248=$2;
      var $249=$248;
      var $250=(($249+8)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($247*$251)|0);
      var $253=(($240+($252<<1))|0);
      var $254=$x;
      var $255=((($254<<3))|0);
      var $256=(($255+7)|0);
      var $257=(($253+($256<<1))|0);
      HEAP16[(($257)>>1)]=$235;
      __label__ = 9; break;
    case 9: // $258
      var $259=$yyy;
      var $260=(($259+1)|0);
      $yyy=$260;
      __label__ = 7; break;
    case 10: // $261
      __label__ = 11; break;
    case 11: // $262
      var $263=$yy;
      var $264=(($263+1)|0);
      $yy=$264;
      __label__ = 5; break;
    case 12: // $265
      __label__ = 13; break;
    case 13: // $266
      var $267=$x;
      var $268=(($267+1)|0);
      $x=$268;
      __label__ = 3; break;
    case 14: // $269
      __label__ = 15; break;
    case 15: // $270
      var $271=$y;
      var $272=(($271+1)|0);
      $y=$272;
      __label__ = 1; break;
    case 16: // $273
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11draw_mode23P8device_tP8bitmap_tPK10_rectangle["X"]=1;

function __ZN12timer_deviceC2ERK14machine_configPKcP8device_tj($this, $mconfig, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$mconfig;
  $3=$tag;
  $4=$owner;
  $5=$clock;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=HEAP32[((_TIMER)>>2)];
  var $10=$3;
  var $11=$4;
  var $12=$5;
  __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($7, $8, $9, ((STRING_TABLE.__str1634)|0), $10, $11, $12);
  var $13=$6;
  HEAP32[(($13)>>2)]=((__ZTV12timer_device+8)|0);
  var $14=(($6+356)|0);
  HEAP32[(($14)>>2)]=2;
  var $15=(($6+360)|0);
  HEAP32[(($15)>>2)]=0;
  var $16=(($6+364)|0);
  HEAP32[(($16)>>2)]=0;
  var $17=(($6+368)|0);
  var $18=$17;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($18+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($18+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $19=(($6+380)|0);
  var $20=$19;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($20+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($20+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $21=(($6+392)|0);
  HEAP32[(($21)>>2)]=0;
  var $22=(($6+396)|0);
  HEAP32[(($22)>>2)]=0;
  var $23=(($6+400)|0);
  HEAP32[(($23)>>2)]=0;
  var $24=(($6+404)|0);
  HEAP32[(($24)>>2)]=0;
  var $25=(($6+408)|0);
  HEAP32[(($25)>>2)]=0;
  var $26=(($6+412)|0);
  HEAP32[(($26)>>2)]=0;
  var $27=(($6+416)|0);
  HEAP8[($27)]=1;
  ;
  return;
}


function __ZN12timer_device24static_configure_genericER8device_tPFvRS_PviE($device, $callback) {
  ;
  var __label__;

  var $1;
  var $2;
  var $timer;
  $1=$device;
  $2=$callback;
  var $3=$1;
  var $4=__Z8downcastIR12timer_device8device_tET_RT0_($3);
  $timer=$4;
  var $5=$timer;
  var $6=(($5+356)|0);
  HEAP32[(($6)>>2)]=2;
  var $7=$2;
  var $8=$timer;
  var $9=(($8+360)|0);
  HEAP32[(($9)>>2)]=$7;
  ;
  return;
}


function __ZN12timer_device25static_configure_periodicER8device_tPFvRS_PviE8attotime($device, $callback, $period) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $period; $period = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($period)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($period+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($period+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $timer;
  $1=$device;
  $2=$callback;
  var $3=$1;
  var $4=__Z8downcastIR12timer_device8device_tET_RT0_($3);
  $timer=$4;
  var $5=$timer;
  var $6=(($5+356)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=$2;
  var $8=$timer;
  var $9=(($8+360)|0);
  HEAP32[(($9)>>2)]=$7;
  var $10=$timer;
  var $11=(($10+380)|0);
  var $12=$11;
  var $13=$period;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
  STACKTOP = __stackBase__;
  return;
}


function __ZNK12timer_device21device_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      $1=$this;
      $2=$options;
      $3=$driver;
      var $4=$1;
      $error=0;
      var $5=(($4+356)|0);
      var $6=HEAP32[(($5)>>2)];
      if ($6 == 2) {
        __label__ = 1; break;
      }
      else if ($6 == 0) {
        __label__ = 9; break;
      }
      else if ($6 == 1) {
        __label__ = 15; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 1: // $7
      var $8=(($4+396)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=(($4+404)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $15
      var $16=(($4+368)|0);
      var $17=__ZneRK8attotimeS1_($16, __ZN8attotime4zeroE);
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$3;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$3;
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$4;
      var $26=__ZNK8device_t3tagEv($25);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str11635)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$24,HEAP32[((tempInt+8)>>2)]=$26,tempInt));
      __label__ = 5; break;
    case 5: // $27
      var $28=(($4+380)|0);
      var $29=__ZneRK8attotimeS1_($28, __ZN8attotime4zeroE);
      if ($29) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $30
      var $31=(($4+368)|0);
      var $32=__ZneRK8attotimeS1_($31, __ZN8attotime4zeroE);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$3;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$3;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$4;
      var $41=__ZNK8device_t3tagEv($40);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str21636)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,HEAP32[((tempInt+4)>>2)]=$39,HEAP32[((tempInt+8)>>2)]=$41,tempInt));
      __label__ = 8; break;
    case 8: // $42
      __label__ = 26; break;
    case 9: // $43
      var $44=(($4+396)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $47
      var $48=(($4+404)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $51
      var $52=$3;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$3;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$4;
      var $59=__ZNK8device_t3tagEv($58);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str31637)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$54,HEAP32[((tempInt+4)>>2)]=$57,HEAP32[((tempInt+8)>>2)]=$59,tempInt));
      __label__ = 12; break;
    case 12: // $60
      var $61=(($4+380)|0);
      var $62=__ZleRK8attotimeS1_($61, __ZN8attotime4zeroE);
      if ($62) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $63
      var $64=$3;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$3;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$4;
      var $71=__ZNK8device_t3tagEv($70);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str41638)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,HEAP32[((tempInt+4)>>2)]=$69,HEAP32[((tempInt+8)>>2)]=$71,tempInt));
      $error=1;
      __label__ = 14; break;
    case 14: // $72
      __label__ = 26; break;
    case 15: // $73
      var $74=(($4+380)|0);
      var $75=__ZneRK8attotimeS1_($74, __ZN8attotime4zeroE);
      if ($75) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $76
      var $77=(($4+368)|0);
      var $78=__ZneRK8attotimeS1_($77, __ZN8attotime4zeroE);
      if ($78) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $79
      var $80=$3;
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$3;
      var $84=(($83+8)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$4;
      var $87=__ZNK8device_t3tagEv($86);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str51639)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,HEAP32[((tempInt+4)>>2)]=$85,HEAP32[((tempInt+8)>>2)]=$87,tempInt));
      __label__ = 18; break;
    case 18: // $88
      var $89=(($4+392)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $92
      var $93=$3;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$3;
      var $97=(($96+8)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$4;
      var $100=__ZNK8device_t3tagEv($99);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str61640)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$95,HEAP32[((tempInt+4)>>2)]=$98,HEAP32[((tempInt+8)>>2)]=$100,tempInt));
      __label__ = 20; break;
    case 20: // $101
      var $102=(($4+404)|0);
      var $103=HEAPU32[(($102)>>2)];
      var $104=(($103)>>>0) < 0;
      if ($104) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $105
      var $106=$3;
      var $107=(($106)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$3;
      var $110=(($109+8)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$4;
      var $113=__ZNK8device_t3tagEv($112);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str71641)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$108,HEAP32[((tempInt+4)>>2)]=$111,HEAP32[((tempInt+8)>>2)]=$113,tempInt));
      $error=1;
      __label__ = 22; break;
    case 22: // $114
      var $115=(($4+408)|0);
      var $116=HEAPU32[(($115)>>2)];
      var $117=(($116)>>>0) < 0;
      if ($117) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $118
      var $119=$3;
      var $120=(($119)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$3;
      var $123=(($122+8)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$4;
      var $126=__ZNK8device_t3tagEv($125);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str81642)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$121,HEAP32[((tempInt+4)>>2)]=$124,HEAP32[((tempInt+8)>>2)]=$126,tempInt));
      $error=1;
      __label__ = 24; break;
    case 24: // $127
      __label__ = 26; break;
    case 25: // $128
      var $129=$3;
      var $130=(($129)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$3;
      var $133=(($132+8)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$4;
      var $136=__ZNK8device_t3tagEv($135);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str91643)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$131,HEAP32[((tempInt+4)>>2)]=$134,HEAP32[((tempInt+8)>>2)]=$136,tempInt));
      $error=1;
      __label__ = 26; break;
    case 26: // $137
      var $138=$error;
      var $139=(($138) & 1);
      ;
      return $139;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12timer_device21device_validity_checkER11emu_optionsRK11game_driver["X"]=1;

function __ZN12timer_device12device_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+396)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=__ZNK8device_t7machineEv($7);
      var $9=(($2+396)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZN15running_machine6deviceI13screen_deviceEEPT_PKc($8, $10);
      var $12=(($2+400)|0);
      HEAP32[(($12)>>2)]=$11;
      __label__ = 2; break;
    case 2: // $13
      var $14=$2;
      var $15=__ZN8device_t11timer_allocEjPv($14, 0, 0);
      var $16=(($2+412)|0);
      HEAP32[(($16)>>2)]=$15;
      var $17=$2;
      var $18=(($2+416)|0);
      __ZN8device_t9save_itemIbEEvRT_PKci($17, $18, ((STRING_TABLE.__str101644)|0), 0);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine6deviceI13screen_deviceEEPT_PKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$2;
  var $5=__ZN15running_machine6deviceEPKc($3, $4);
  var $6=__Z8downcastIP13screen_device8device_tET_PT0_($5);
  ;
  return $6;
}


function __ZN8device_t9save_itemIbEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIbEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14device_creatorI12timer_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=420;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str121646)|0);
      HEAP32[(($6)>>2)]=111;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12timer_deviceC1ERK14machine_configPKcP8device_tj]($53, $54, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI12timer_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str121646)|0);
      HEAP32[(($3)>>2)]=111;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14device_creatorI12timer_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __Z8downcastIP13screen_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12timer_device12device_timerER9emu_timerjiPv($this, $timer, $id, $param, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $next_vpos;
      var $vpos;
      var $6=__stackBase__;
      var $7=__stackBase__+12;
      $1=$this;
      $2=$timer;
      $3=$id;
      $4=$param;
      $5=$ptr;
      var $8=$1;
      var $9=(($8+356)|0);
      var $10=HEAP32[(($9)>>2)];
      if ($10 == 2 || $10 == 0) {
        __label__ = 1; break;
      }
      else if ($10 == 1) {
        __label__ = 4; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 1: // $11
      var $12=(($8+360)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=(($8+360)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($8+364)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$4;
      FUNCTION_TABLE[$17]($8, $19, $20);
      __label__ = 3; break;
    case 3: // $21
      __label__ = 10; break;
    case 4: // $22
      var $23=(($8+404)|0);
      var $24=HEAP32[(($23)>>2)];
      $next_vpos=$24;
      var $25=(($8+416)|0);
      var $26=HEAP8[($25)];
      var $27=(($26) & 1);
      if ($27) { __label__ = 9; break; } else { __label__ = 5; break; }
    case 5: // $28
      var $29=(($8+400)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZNK13screen_device4vposEv($30);
      $vpos=$31;
      var $32=(($8+360)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($8+364)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$vpos;
      FUNCTION_TABLE[$33]($8, $35, $36);
      var $37=(($8+408)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $40
      var $41=$vpos;
      var $42=(($8+408)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($41+$43)|0);
      var $45=(($8+400)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=__ZNK13screen_device6heightEv($46);
      var $48=(($44)>>>0) < (($47)>>>0);
      if ($48) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $49
      var $50=$vpos;
      var $51=(($8+408)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($50+$52)|0);
      $next_vpos=$53;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      var $56=(($8+416)|0);
      HEAP8[($56)]=0;
      var $57=(($8+412)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($8+400)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$next_vpos;
      __ZNK13screen_device14time_until_posEii($6, $60, $61, 0);
      var $62=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($62)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($62+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($62+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($58, $6, 0, $7);
      __label__ = 10; break;
    case 10: // $63
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12timer_device12device_timerER9emu_timerjiPv["X"]=1;

function __ZN12timer_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12timer_deviceD2Ev($2);
  ;
  return;
}


function __ZN12save_manager9save_itemIbEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $12, 1, 1);
  ;
  return;
}


function __ZN20resource_pool_objectI12timer_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12timer_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12timer_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 420);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12timer_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12timer_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12timer_deviceED2Ev($2);
  ;
  return;
}


function __ZN12timer_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8device_tD2Ev($3);
  ;
  return;
}


function __ZL9get_tokenP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP18legacy_device_base8device_tET_PT0_($6);
      var $8=__ZNK18legacy_device_base5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12timer_device12device_resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $period=__stackBase__;
      var $start_delay=__stackBase__+12;
      var $2=__stackBase__+24;
      var $3=__stackBase__+36;
      var $4=__stackBase__+48;
      var $5=__stackBase__+60;
      $1=$this;
      var $6=$1;
      var $7=(($6+356)|0);
      var $8=HEAP32[(($7)>>2)];
      if ($8 == 2 || $8 == 0) {
        __label__ = 1; break;
      }
      else if ($8 == 1) {
        __label__ = 6; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 1: // $9
      var $10=$period;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($10+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($10+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $11=(($6+380)|0);
      var $12=__ZgtRK8attotimeS1_($11, __ZN8attotime4zeroE);
      if ($12) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $13
      var $14=(($6+380)|0);
      var $15=$period;
      var $16=$14;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[(($16+4)>>2)];HEAP32[(($15+8)>>2)]=HEAP32[(($16+8)>>2)];
      var $17=$start_delay;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($17+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($17+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $18=(($6+368)|0);
      var $19=__ZgtRK8attotimeS1_($18, __ZN8attotime4zeroE);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=(($6+368)|0);
      var $22=$start_delay;
      var $23=$21;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($22)>>2)]=HEAP32[(($23)>>2)];HEAP32[(($22+4)>>2)]=HEAP32[(($23+4)>>2)];HEAP32[(($22+8)>>2)]=HEAP32[(($23+8)>>2)];
      __label__ = 4; break;
    case 4: // $24
      var $25=(($6+412)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$2;
      var $28=$start_delay;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];
      var $29=(($6+392)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=$period;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($31)>>2)]=HEAP32[(($32)>>2)];HEAP32[(($31+4)>>2)]=HEAP32[(($32+4)>>2)];HEAP32[(($31+8)>>2)]=HEAP32[(($32+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($26, $2, $30, $3);
      __label__ = 5; break;
    case 5: // $33
      __label__ = 9; break;
    case 6: // $34
      var $35=(($6+400)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      var $39=$6;
      var $40=__ZNK8device_t3tagEv($39);
      var $41=(($6+396)|0);
      var $42=HEAP32[(($41)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str111645)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,HEAP32[((tempInt+4)>>2)]=$42,tempInt));
      throw "Reached an unreachable!"
    case 8: // $43
      var $44=(($6+416)|0);
      HEAP8[($44)]=1;
      var $45=(($6+412)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $48=(($6+392)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($50)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($50+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($50+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($46, $4, $49, $5);
      __label__ = 9; break;
    case 9: // $51
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12timer_device12device_resetEv["X"]=1;

function __ZN12timer_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN12timer_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12timer_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI12timer_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12timer_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12timer_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI12timer_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12timer_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12timer_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI12timer_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI12timer_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}

// Warning: Casting a function pointer type to another with a different number of arguments. See more info in the source (grep for this text). i32 (%class.device_image_interface*)* ==> void ()*
// Warning: Casting a function pointer type to another with a different number of arguments. See more info in the source (grep for this text). void (%class.device_image_interface*)* ==> void ()*
// Warning: Casting a function pointer type to another with a different number of arguments. See more info in the source (grep for this text). void (%class.device_image_interface*)* ==> void ()*
// Warning: Casting a function pointer type to another with a different number of arguments. See more info in the source (grep for this text). i1 (%class.device_image_interface*, i8*, i8*, %struct.rom_entry*)* ==> void ()*

function __Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18legacy_device_base13inline_configEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+360)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z26device_get_config_cartslotPK8device_tjP10deviceinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$2;
      if ($4 == 0) {
        __label__ = 1; break;
      }
      else if ($4 == 1) {
        __label__ = 2; break;
      }
      else if ($4 == 28673) {
        __label__ = 3; break;
      }
      else if ($4 == 28674) {
        __label__ = 4; break;
      }
      else if ($4 == 28675) {
        __label__ = 5; break;
      }
      else if ($4 == 28676) {
        __label__ = 6; break;
      }
      else if ($4 == 28678) {
        __label__ = 7; break;
      }
      else if ($4 == 28677) {
        __label__ = 8; break;
      }
      else if ($4 == 131072) {
        __label__ = 13; break;
      }
      else if ($4 == 159745) {
        __label__ = 14; break;
      }
      else if ($4 == 159747) {
        __label__ = 15; break;
      }
      else if ($4 == 159751) {
        __label__ = 16; break;
      }
      else if ($4 == 159752) {
        __label__ = 17; break;
      }
      else if ($4 == 159749) {
        __label__ = 18; break;
      }
      else if ($4 == 159750) {
        __label__ = 24; break;
      }
      else if ($4 == 196608) {
        __label__ = 30; break;
      }
      else if ($4 == 196610) {
        __label__ = 31; break;
      }
      else if ($4 == 196612) {
        __label__ = 32; break;
      }
      else if ($4 == 225281) {
        __label__ = 33; break;
      }
      else if ($4 == 225349) {
        __label__ = 39; break;
      }
      else {
      __label__ = 44; break;
      }
      
    case 1: // $5
      var $6=$3;
      var $7=$6;
      var $$emscripten$temp$0$0=8;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($7)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($7+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 44; break;
    case 2: // $8
      var $9=$3;
      var $10=$9;
      var $$emscripten$temp$1$0=160;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($10)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($10+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 44; break;
    case 3: // $11
      var $12=$3;
      var $13=$12;
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $st$4$0=(($13)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$2$0;
      var $st$4$1=(($13+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 44; break;
    case 4: // $14
      var $15=$3;
      var $16=$15;
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $st$4$0=(($16)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$3$0;
      var $st$4$1=(($16+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 44; break;
    case 5: // $17
      var $18=$3;
      var $19=$18;
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $st$4$0=(($19)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$4$0;
      var $st$4$1=(($19+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 44; break;
    case 6: // $20
      var $21=$3;
      var $22=$21;
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $st$4$0=(($22)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$5$0;
      var $st$4$1=(($22+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 44; break;
    case 7: // $23
      var $24=$3;
      var $25=$24;
      var $$emscripten$temp$6$0=1;
      var $$emscripten$temp$6$1=0;
      var $st$4$0=(($25)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$6$0;
      var $st$4$1=(($25+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$6$1;
      __label__ = 44; break;
    case 8: // $26
      var $27=$1;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $29
      var $30=$1;
      var $31=__Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_($30);
      var $32=$31;
      var $33=__ZNK18legacy_device_base13inline_configEv($32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $35
      var $36=$1;
      var $37=__ZL10get_configPK8device_t($36);
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40$0=$39;
      var $40$1=(($39|0) < 0 ? -1 : 0);
      var $41=$3;
      var $42=$41;
      var $st$8$0=(($42)|0);
      HEAP32[(($st$8$0)>>2)]=$40$0;
      var $st$8$1=(($42+4)|0);
      HEAP32[(($st$8$1)>>2)]=$40$1;
      __label__ = 12; break;
    case 11: // $43
      var $44=$3;
      var $45=$44;
      var $$emscripten$temp$7$0=0;
      var $$emscripten$temp$7$1=0;
      var $st$4$0=(($45)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$7$0;
      var $st$4$1=(($45+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$7$1;
      __label__ = 12; break;
    case 12: // $46
      __label__ = 44; break;
    case 13: // $47
      var $48=$3;
      var $49=$48;
      HEAP32[(($49)>>2)]=142;
      __label__ = 44; break;
    case 14: // $50
      var $51=$3;
      var $52=$51;
      HEAP32[(($52)>>2)]=144;
      __label__ = 44; break;
    case 15: // $53
      var $54=$3;
      var $55=$54;
      HEAP32[(($55)>>2)]=146;
      __label__ = 44; break;
    case 16: // $56
      var $57=$3;
      var $58=$57;
      HEAP32[(($58)>>2)]=148;
      __label__ = 44; break;
    case 17: // $59
      var $60=$3;
      var $61=$60;
      HEAP32[(($61)>>2)]=150;
      __label__ = 44; break;
    case 18: // $62
      var $63=$1;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $65
      var $66=$1;
      var $67=__Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_($66);
      var $68=$67;
      var $69=__ZNK18legacy_device_base13inline_configEv($68);
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $71
      var $72=$1;
      var $73=__ZL10get_configPK8device_t($72);
      var $74=(($73+24)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $77
      var $78=$1;
      var $79=__ZL10get_configPK8device_t($78);
      var $80=(($79+24)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81;
      var $83=$3;
      var $84=$83;
      HEAP32[(($84)>>2)]=$82;
      __label__ = 23; break;
    case 22: // $85
      var $86=$3;
      var $87=$86;
      HEAP32[(($87)>>2)]=0;
      __label__ = 23; break;
    case 23: // $88
      __label__ = 44; break;
    case 24: // $89
      var $90=$1;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $92
      var $93=$1;
      var $94=__Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_($93);
      var $95=$94;
      var $96=__ZNK18legacy_device_base13inline_configEv($95);
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $98
      var $99=$1;
      var $100=__ZL10get_configPK8device_t($99);
      var $101=(($100+28)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $104
      var $105=$1;
      var $106=__ZL10get_configPK8device_t($105);
      var $107=(($106+28)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$108;
      var $110=$3;
      var $111=$110;
      HEAP32[(($111)>>2)]=$109;
      __label__ = 29; break;
    case 28: // $112
      var $113=$3;
      var $114=$113;
      HEAP32[(($114)>>2)]=0;
      __label__ = 29; break;
    case 29: // $115
      __label__ = 44; break;
    case 30: // $116
      var $117=$3;
      var $118=$117;
      var $119=HEAP32[(($118)>>2)];
      var $120=_strcpy($119, ((STRING_TABLE.__str1651)|0));
      __label__ = 44; break;
    case 31: // $121
      var $122=$3;
      var $123=$122;
      var $124=HEAP32[(($123)>>2)];
      var $125=_strcpy($124, ((STRING_TABLE.__str1651)|0));
      __label__ = 44; break;
    case 32: // $126
      var $127=$3;
      var $128=$127;
      var $129=HEAP32[(($128)>>2)];
      var $130=_strcpy($129, ((STRING_TABLE.__str11652)|0));
      __label__ = 44; break;
    case 33: // $131
      var $132=$1;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 34: // $134
      var $135=$1;
      var $136=__Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_($135);
      var $137=$136;
      var $138=__ZNK18legacy_device_base13inline_configEv($137);
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $140
      var $141=$1;
      var $142=__ZL10get_configPK8device_t($141);
      var $143=(($142)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $146
      var $147=$3;
      var $148=$147;
      var $149=HEAP32[(($148)>>2)];
      var $150=$1;
      var $151=__ZL10get_configPK8device_t($150);
      var $152=(($151)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=_strcpy($149, $153);
      __label__ = 38; break;
    case 37: // $155
      var $156=$3;
      var $157=$156;
      var $158=HEAP32[(($157)>>2)];
      var $159=_strcpy($158, ((STRING_TABLE.__str21653)|0));
      __label__ = 38; break;
    case 38: // $160
      __label__ = 44; break;
    case 39: // $161
      var $162=$1;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $164
      var $165=$1;
      var $166=__Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_($165);
      var $167=$166;
      var $168=__ZNK18legacy_device_base13inline_configEv($167);
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $170
      var $171=$1;
      var $172=__ZL10get_configPK8device_t($171);
      var $173=(($172+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=(($174)|0)!=0;
      if ($175) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $176
      var $177=$3;
      var $178=$177;
      var $179=HEAP32[(($178)>>2)];
      var $180=$1;
      var $181=__ZL10get_configPK8device_t($180);
      var $182=(($181+4)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=_strcpy($179, $183);
      __label__ = 43; break;
    case 43: // $185
      __label__ = 44; break;
    case 44: // $186
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26device_get_config_cartslotPK8device_tjP10deviceinfo["X"]=1;

function __ZL10get_configPK8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($6);
      var $8=__ZNK18legacy_device_base13inline_configEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21device_start_cartslotP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cart;
      var $config;
      $1=$device;
      var $2=$1;
      var $3=__ZL9get_tokenP8device_t($2);
      $cart=$3;
      var $4=$1;
      var $5=__ZL10get_configPK8device_t($4);
      $config=$5;
      var $6=$config;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$config;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      FUNCTION_TABLE[$13]($14);
      __label__ = 3; break;
    case 2: // $15
      var $16=$1;
      var $17=__ZNK8device_t9subdeviceEPKc($16, ((STRING_TABLE.__str41657)|0));
      var $18=$cart;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20device_load_cartslotR22device_image_interface($image) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $device;
      var $cart;
      var $config;
      $2=$image;
      var $3=$2;
      var $4=$3;
      var $5=__ZN16device_interface6deviceEv($4);
      $device=$5;
      var $6=$device;
      var $7=__ZL9get_tokenP8device_t($6);
      $cart=$7;
      var $8=$device;
      var $9=__ZL10get_configPK8device_t($8);
      $config=$9;
      var $10=$config;
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$config;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=FUNCTION_TABLE[$17]($18);
      $1=$19;
      __label__ = 7; break;
    case 2: // $20
      var $21=$device;
      var $22=__ZNK8device_t7machineEv($21);
      var $23=__ZNK15running_machine7optionsEv($22);
      var $24=$2;
      var $25=__ZN22device_image_interface8filenameEv($24);
      var $26=$device;
      var $27=__ZNK8device_t7machineEv($26);
      var $28=__ZNK15running_machine6systemEv($27);
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$cart;
      var $32=(($31+4)|0);
      var $33=__Z14multicart_openR11emu_optionsPKcS2_21_multicart_load_flagsPP12_multicart_t($23, $25, $30, 1, $32);
      var $34=$cart;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $38
      var $39=$2;
      var $40=__ZL17process_cartridgeP22device_image_interface13_process_mode($39, 1);
      $result=$40;
      var $41=$result;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      var $44=$result;
      $1=$44;
      __label__ = 7; break;
    case 5: // $45
      __label__ = 6; break;
    case 6: // $46
      $1=0;
      __label__ = 7; break;
    case 7: // $47
      var $48=$1;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20device_load_cartslotR22device_image_interface["X"]=1;

function __ZL22device_unload_cartslotR22device_image_interface($image) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      var $cart;
      var $config;
      $1=$image;
      var $2=$1;
      var $3=$2;
      var $4=__ZN16device_interface6deviceEv($3);
      $device=$4;
      var $5=$device;
      var $6=__ZL9get_tokenP8device_t($5);
      $cart=$6;
      var $7=$device;
      var $8=__ZL10get_configPK8device_t($7);
      $config=$8;
      var $9=$config;
      var $10=(($9+20)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$config;
      var $15=(($14+20)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      FUNCTION_TABLE[$16]($17);
      __label__ = 5; break;
    case 2: // $18
      var $19=$cart;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$device;
      var $25=__ZNK8device_t7machineEv($24);
      var $26=__ZNK15running_machine7optionsEv($25);
      var $27=$cart;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      __Z15multicart_closeR11emu_optionsP12_multicart_t($26, $29);
      var $30=$cart;
      var $31=(($30+4)|0);
      HEAP32[(($31)>>2)]=0;
      __label__ = 4; break;
    case 4: // $32
      var $33=$1;
      var $34=__ZL17process_cartridgeP22device_image_interface13_process_mode($33, 0);
      __label__ = 5; break;
    case 5: // $35
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL33device_image_get_devices_cartslotR22device_image_interface($image) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $pcb_type;
      var $device;
      $1=$image;
      var $2=$1;
      var $3=$2;
      var $4=__ZN16device_interface6deviceEv($3);
      $device=$4;
      var $5=$1;
      var $6=__ZL12identify_pcbR22device_image_interface($5);
      $pcb_type=$6;
      var $7=$pcb_type;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$device;
      var $11=$pcb_type;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      __Z32image_add_device_with_subdevicesP8device_tPFS0_RK14machine_configPKcS0_jES5_j($10, $13, ((STRING_TABLE.__str41657)|0), 0);
      __label__ = 2; break;
    case 2: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL29device_softlist_load_cartslotR22device_image_interfacePcS1_P9rom_entry($image, $swlist, $swname, $start_entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$image;
  $2=$swlist;
  $3=$swname;
  $4=$start_entry;
  var $5=$1;
  var $6=$5;
  var $7=__ZN16device_interface6deviceEv($6);
  var $8=$2;
  var $9=$3;
  var $10=$4;
  __Z25load_software_part_regionP8device_tPcS1_P9rom_entry($7, $8, $9, $10);
  ;
  return 1;
}


function __ZN15cartslot_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN24legacy_image_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($8, $9, $10, $11, $12, $13, 154);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV15cartslot_device+8)|0);
  var $15=$7;
  var $16=(($15+368)|0);
  var $17=$16;
  HEAP32[(($17)>>2)]=((__ZTV15cartslot_device+148)|0);
  ;
  return;
}


function __ZNK18legacy_device_base17device_rom_regionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK18legacy_device_base14get_legacy_ptrEj($2, 65536);
  var $4=$3;
  ;
  return $4;
}


function __ZNK18legacy_device_base24device_mconfig_additionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK18legacy_device_base14get_legacy_ptrEj($2, 65537);
  var $4=$3;
  ;
  return $4;
}


function __ZNK18legacy_device_base18device_input_portsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK18legacy_device_base14get_legacy_ptrEj($2, 65538);
  var $4=$3;
  ;
  return $4;
}


function __ZN15cartslot_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15cartslot_deviceD2Ev($2);
  ;
  return;
}


function __ZNK24legacy_image_device_base10image_typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_intEj($3, 28673);
  var $4$0=$4[0];
  var $4$1=$4[1];
  var $5$0=$4$0;
  var $5=$5$0;
  ;
  return $5;
}


function __ZNK24legacy_image_device_base11is_readableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_intEj($3, 28674);
  var $4$0=$4[0];
  var $4$1=$4[1];
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
  ;
  return $5;
}


function __ZNK24legacy_image_device_base12is_writeableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_intEj($3, 28675);
  var $4$0=$4[0];
  var $4$1=$4[1];
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
  ;
  return $5;
}


function __ZNK24legacy_image_device_base12is_creatableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_intEj($3, 28676);
  var $4$0=$4[0];
  var $4$1=$4[1];
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
  ;
  return $5;
}


function __ZNK24legacy_image_device_base14must_be_loadedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_intEj($3, 28677);
  var $4$0=$4[0];
  var $4$1=$4[1];
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
  ;
  return $5;
}


function __ZNK24legacy_image_device_base16is_reset_on_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_intEj($3, 28678);
  var $4$0=$4[0];
  var $4$1=$4[1];
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
  ;
  return $5;
}


function __ZNK24legacy_image_device_base15image_interfaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base17get_legacy_stringEj($3, 225349);
  ;
  return $4;
}


function __ZNK24legacy_image_device_base15file_extensionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base17get_legacy_stringEj($3, 225281);
  ;
  return $4;
}


function __ZNK24legacy_image_device_base19create_option_guideEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_ptrEj($3, 94209);
  var $5=$4;
  ;
  return $5;
}


function __Z21legacy_device_creatorI15cartslot_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=1216;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str31656)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15cartslot_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 152, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI15cartslot_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str31656)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI15cartslot_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN15cartslot_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN15cartslot_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15cartslot_deviceD0Ev["X"]=1;

function __ZNK15running_machine6configEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+668)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZThn368_N15cartslot_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN15cartslot_deviceD1Ev($5);
  ;
  return;
}


function __ZThn368_N15cartslot_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN15cartslot_deviceD0Ev($5);
  ;
  return;
}


function __ZThn368_NK24legacy_image_device_base10image_typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base10image_typeEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base11is_readableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base11is_readableEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base12is_writeableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base12is_writeableEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base12is_creatableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base12is_creatableEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base14must_be_loadedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base14must_be_loadedEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base16is_reset_on_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base16is_reset_on_loadEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base15image_interfaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base15image_interfaceEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base15file_extensionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base15file_extensionsEv($5);
  ;
  return $6;
}


function __ZThn368_NK24legacy_image_device_base19create_option_guideEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base19create_option_guideEv($5);
  ;
  return $6;
}


function __ZN15cartslot_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN24legacy_image_device_baseD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI15cartslot_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI15cartslot_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI15cartslot_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1216);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI15cartslot_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI15cartslot_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI15cartslot_deviceED2Ev($2);
  ;
  return;
}


function __ZN22device_image_interface6existsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+88)|0);
  var $4=__ZN7astringcvbEv($3);
  ;
  return $4;
}


function __ZN22device_image_interface8filenameEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+88)|0);
      var $5=__ZN7astringcvbEv($4);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      $1=0;
      __label__ = 3; break;
    case 2: // $7
      var $8=(($3+88)|0);
      var $9=__ZNK7astringcvPKcEv($8);
      $1=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$1;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17process_cartridgeP22device_image_interface13_process_mode($image, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $source;
      var $romrgn;
      var $roment;
      var $result;
      $2=$image;
      $3=$mode;
      $result=0;
      var $4=$2;
      var $5=$4;
      var $6=__ZN16device_interface6deviceEv($5);
      var $7=__ZNK8device_t7machineEv($6);
      var $8=__ZNK15running_machine6configEv($7);
      var $9=__Z16rom_first_sourceRK14machine_config($8);
      $source=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$source;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $13
      var $14=$source;
      var $15=__Z16rom_first_regionRK8device_t($14);
      $romrgn=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$romrgn;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 17; break; }
    case 4: // $19
      var $20=$romrgn;
      var $21=(($20+20)|0);
      $roment=$21;
      __label__ = 5; break;
    case 5: // $22
      var $23=$roment;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25 & 15;
      var $27=(($26)|0)==1;
      if ($27) { var $35 = 1;__label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $28
      var $29=$roment;
      var $30=(($29+16)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$31 & 15;
      var $33=(($32)|0)==2;
      var $35 = $33;__label__ = 7; break;
    case 7: // $34
      var $35;
      var $36=$35 ^ 1;
      if ($36) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $37
      var $38=$roment;
      var $39=(($38+16)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 & 15;
      var $42=(($41)|0)==7;
      if ($42) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $43
      var $44=$roment;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$2;
      var $48=$47;
      var $49=__ZN16device_interface6deviceEv($48);
      var $50=__ZNK8device_t3tagEv($49);
      var $51=_strcmp($46, $50);
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $53
      var $54=$2;
      var $55=$romrgn;
      var $56=$roment;
      var $57=$3;
      var $58=__ZL14load_cartridgeP22device_image_interfacePK9rom_entryS3_13_process_mode($54, $55, $56, $57);
      var $59=$result;
      var $60=$59 | $58;
      $result=$60;
      var $61=$result;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $63
      var $64=$result;
      $1=$64;
      __label__ = 20; break;
    case 12: // $65
      __label__ = 13; break;
    case 13: // $66
      __label__ = 14; break;
    case 14: // $67
      var $68=$roment;
      var $69=(($68+20)|0);
      $roment=$69;
      __label__ = 5; break;
    case 15: // $70
      __label__ = 16; break;
    case 16: // $71
      var $72=$romrgn;
      var $73=__Z15rom_next_regionPK9rom_entry($72);
      $romrgn=$73;
      __label__ = 3; break;
    case 17: // $74
      __label__ = 18; break;
    case 18: // $75
      var $76=$source;
      var $77=__Z15rom_next_sourceRK8device_t($76);
      $source=$77;
      __label__ = 1; break;
    case 19: // $78
      $1=0;
      __label__ = 20; break;
    case 20: // $79
      var $80=$1;
      ;
      return $80;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17process_cartridgeP22device_image_interface13_process_mode["X"]=1;

function __ZN13resource_pool10add_objectI15cartslot_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI15cartslot_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI15cartslot_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI15cartslot_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI15cartslot_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI15cartslot_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI15cartslot_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI15cartslot_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12identify_pcbR22device_image_interface($image) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $config;
      var $pcb_name=__stackBase__;
      var $pcb_type;
      var $mc=__stackBase__+64;
      var $i;
      var $3;
      var $4;
      var $me;
      var $5;
      $2=$image;
      var $6=$2;
      var $7=$6;
      var $8=__ZN16device_interface6deviceEv($7);
      var $9=__ZL10get_configPK8device_t($8);
      $config=$9;
      __ZN7astringC1Ev($pcb_name);
      $pcb_type=0;
      var $10=$2;
      var $11=(function() { try { __THREW__ = false; return __ZN22device_image_interface6existsEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 17; break; };
    case 1: // $12
      if ($11) { __label__ = 2; break; } else { __label__ = 40; break; }
    case 2: // $13
      var $14=$2;
      var $15=$14;
      var $16=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 17; break; };
    case 3: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 17; break; };
    case 4: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 17; break; };
    case 5: // $21
      var $22=$2;
      var $23=(function() { try { __THREW__ = false; return __ZN22device_image_interface8filenameEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 17; break; };
    case 6: // $24
      var $25=$2;
      var $26=$25;
      var $27=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 17; break; };
    case 7: // $28
      var $29=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 17; break; };
    case 8: // $30
      var $31=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 17; break; };
    case 9: // $32
      var $33=(($31+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z14multicart_openR11emu_optionsPKcS2_21_multicart_load_flagsPP12_multicart_t($20, $23, $34, 0, $mc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; };
    case 10: // $36
      $me=$35;
      var $37=$me;
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $39
      var $40=HEAP32[(($mc)>>2)];
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(function() { try { __THREW__ = false; return __Z12astring_cpycP7astringPKc($pcb_name, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 17; break; };
    case 12: // $44
      var $45=$2;
      var $46=$45;
      var $47=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; };
    case 13: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 17; break; };
    case 14: // $50
      var $51=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $52
      var $53=HEAP32[(($mc)>>2)];
      (function() { try { __THREW__ = false; return __Z15multicart_closeR11emu_optionsP12_multicart_t($51, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $54
      __label__ = 23; break;
    case 17: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $3=$57;
      var $58=$56.f1;
      $4=$58;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($pcb_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 18: // $59
      var $60=$me;
      var $61=(($60)|0)!=1;
      if ($61) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $62
      var $63=$me;
      var $64=(function() { try { __THREW__ = false; return __Z20multicart_error_text21_multicart_open_error($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 17; break; };
    case 20: // $65
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str51658)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$64,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 17; break; }
    case 21: // $66
      throw "Reached an unreachable!"
    case 22: // $67
      __label__ = 23; break;
    case 23: // $68
      $i=0;
      __label__ = 24; break;
    case 24: // $69
      var $70=$i;
      var $71=(($70)>>>0) < 16;
      if ($71) { __label__ = 25; break; } else { var $81 = 0;__label__ = 26; break; }
    case 25: // $72
      var $73=$i;
      var $74=$config;
      var $75=(($74+32)|0);
      var $76=(($75+($73<<3))|0);
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)!=0;
      var $81 = $79;__label__ = 26; break;
    case 26: // $80
      var $81;
      if ($81) { __label__ = 27; break; } else { __label__ = 34; break; }
    case 27: // $82
      var $83=$i;
      var $84=$config;
      var $85=(($84+32)|0);
      var $86=(($85+($83<<3))|0);
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0);
      var $90=HEAP8[($89)];
      var $91=(($90 << 24) >> 24);
      var $92=(($91)|0)==0;
      if ($92) { __label__ = 31; break; } else { __label__ = 28; break; }
    case 28: // $93
      var $94=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($pcb_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 17; break; };
    case 29: // $95
      var $96=$i;
      var $97=$config;
      var $98=(($97+32)|0);
      var $99=(($98+($96<<3))|0);
      var $100=(($99)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(function() { try { __THREW__ = false; return _strcmp($94, $101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 17; break; };
    case 30: // $103
      var $104=(($102)|0)!=0;
      if ($104) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $105
      var $106=$i;
      var $107=$config;
      var $108=(($107+32)|0);
      var $109=(($108+($106<<3))|0);
      $pcb_type=$109;
      __label__ = 34; break;
    case 32: // $110
      __label__ = 33; break;
    case 33: // $111
      var $112=$i;
      var $113=(($112+1)|0);
      $i=$113;
      __label__ = 24; break;
    case 34: // $114
      var $115=HEAP32[(($mc)>>2)];
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $117
      var $118=$pcb_type;
      var $119=(($118)|0)==0;
      if ($119) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $120
      var $121=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($pcb_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 17; break; };
    case 37: // $122
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str61659)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$121,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 17; break; }
    case 38: // $123
      throw "Reached an unreachable!"
    case 39: // $124
      __label__ = 44; break;
    case 40: // $125
      var $126=$config;
      var $127=(($126+32)|0);
      var $128=(($127)|0);
      var $129=(($128)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $132
      var $133=$config;
      var $134=(($133+32)|0);
      var $135=(($134)|0);
      var $138 = $135;__label__ = 43; break;
    case 42: // $136
      var $138 = 0;__label__ = 43; break;
    case 43: // $137
      var $138;
      $pcb_type=$138;
      __label__ = 44; break;
    case 44: // $139
      var $140=$pcb_type;
      $1=$140;
      $5=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($pcb_name);
      var $141=$1;
      STACKTOP = __stackBase__;
      return $141;
    case 45: // $142
      __label__ = 46; break;
    case 46: // $143
      var $144=$3;
      var $145=$3;
      var $146=$4;
      var $147=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $145, tempValue);
      var $148=($147.f1 = $146, $147);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 47: // $149
      var $150=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12identify_pcbR22device_image_interface["X"]=1;

function __Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIP18legacy_device_base8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceERP23device_memory_interface($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  HEAP32[(($6)>>2)]=$5;
  var $7=$2;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0)!=0;
  ;
  return $9;
}


function __ZNK8device_t6memoryEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+12)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18legacy_device_base5tokenEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+364)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14load_cartridgeP22device_image_interfacePK9rom_entryS3_13_process_mode($image, $romrgn, $roment, $mode) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $region;
      var $type;
      var $flags;
      var $offset;
      var $length;
      var $read_length;
      var $pos;
      var $len;
      var $ptr;
      var $clear_val;
      var $datawidth;
      var $littleendian;
      var $i;
      var $j;
      var $cpu;
      var $memory=__stackBase__;
      var $temp=__stackBase__+4;
      $2=$image;
      $3=$romrgn;
      $4=$roment;
      $5=$mode;
      $pos=0;
      var $6=$3;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      $region=$8;
      var $9=$4;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      $offset=$11;
      var $12=$4;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      $length=$14;
      var $15=$4;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      $flags=$17;
      var $18=$2;
      var $19=$18;
      var $20=__ZN16device_interface6deviceEv($19);
      var $21=__ZNK8device_t7machineEv($20);
      var $22=$region;
      var $23=__ZN15running_machine6regionEPKc($21, $22);
      var $24=__ZNK13memory_region4baseEv($23);
      var $25=$offset;
      var $26=(($24+$25)|0);
      $ptr=$26;
      var $27=$5;
      var $28=(($27)|0)==1;
      if ($28) { __label__ = 1; break; } else { __label__ = 35; break; }
    case 1: // $29
      var $30=$2;
      var $31=__ZN22device_image_interface14software_entryEv($30);
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $33
      var $34=$flags;
      var $35=$34 & 33554432;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $37
      var $38=$2;
      var $39=__ZN22device_image_interface6lengthEv($38);
      var $39$0=$39[0];
      var $39$1=$39[1];
      var $40=$length;
      var $41$0=$40;
      var $41$1=0;
      var $42=$39$0 != $41$0 || $39$1 != $41$1;
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      $1=1;
      __label__ = 38; break;
    case 5: // $44
      __label__ = 6; break;
    case 6: // $45
      var $46=$2;
      var $47=$ptr;
      var $48=$length;
      var $49=__ZN22device_image_interface5freadEPvj($46, $47, $48);
      $read_length=$49;
      $pos=$49;
      var $50=$2;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $51=__ZN22device_image_interface5fseekExi($50, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $51$0=$51[0];
      __label__ = 12; break;
    case 7: // $52
      var $53=$flags;
      var $54=$53 & 33554432;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $56
      var $57=$2;
      var $58=__ZN22device_image_interface26get_software_region_lengthEPKc($57, ((STRING_TABLE.__str71660)|0));
      var $59=$length;
      var $60=(($58)|0)!=(($59)|0);
      if ($60) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $61
      $1=1;
      __label__ = 38; break;
    case 10: // $62
      __label__ = 11; break;
    case 11: // $63
      var $64=$2;
      var $65=__ZN22device_image_interface26get_software_region_lengthEPKc($64, ((STRING_TABLE.__str71660)|0));
      $read_length=$65;
      $pos=$65;
      var $66=$ptr;
      var $67=$2;
      var $68=__ZN22device_image_interface19get_software_regionEPKc($67, ((STRING_TABLE.__str71660)|0));
      var $69=$read_length;
      assert($69 % 1 === 0, 'memcpy given ' + $69 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($66, $68, $69, 1);
      __label__ = 12; break;
    case 12: // $70
      var $71=$flags;
      var $72=$71 & 16777216;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $74
      __label__ = 14; break;
    case 14: // $75
      var $76=$pos;
      var $77=$length;
      var $78=(($76)>>>0) < (($77)>>>0);
      if ($78) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $79
      var $80=$read_length;
      var $81=$length;
      var $82=$pos;
      var $83=(($81-$82)|0);
      var $84=(($80)>>>0) < (($83)>>>0);
      if ($84) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $85
      var $86=$read_length;
      var $92 = $86;__label__ = 18; break;
    case 17: // $87
      var $88=$length;
      var $89=$pos;
      var $90=(($88-$89)|0);
      var $92 = $90;__label__ = 18; break;
    case 18: // $91
      var $92;
      $len=$92;
      var $93=$ptr;
      var $94=$pos;
      var $95=(($93+$94)|0);
      var $96=$ptr;
      var $97=$len;
      assert($97 % 1 === 0, 'memcpy given ' + $97 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($95, $96, $97, 1);
      var $98=$len;
      var $99=$pos;
      var $100=(($99+$98)|0);
      $pos=$100;
      __label__ = 14; break;
    case 19: // $101
      __label__ = 20; break;
    case 20: // $102
      var $103=$3;
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      $type=$105;
      var $106=$3;
      var $107=(($106+16)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$108 & 1024;
      var $110=(($109)|0)==0;
      var $111=(($110)&1);
      $littleendian=$111;
      var $112=$3;
      var $113=(($112+16)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$114 & 768;
      var $116=$115 >>> 8;
      var $117=8 << $116;
      var $118=(((($117)|0)/8)|0);
      $datawidth=$118;
      var $119=$2;
      var $120=$119;
      var $121=__ZN16device_interface6deviceEv($120);
      var $122=__ZNK8device_t7machineEv($121);
      var $123=$type;
      var $124=__ZN15running_machine6deviceEPKc($122, $123);
      $cpu=$124;
      var $125=$cpu;
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $127
      var $128=$cpu;
      var $129=__ZN8device_t9interfaceERP23device_memory_interface($128, $memory);
      if ($129) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $130
      var $131=$cpu;
      var $132=__ZNK8device_t6memoryEv($131);
      var $133=__ZNK23device_memory_interface12space_configE16address_spacenum($132, 0);
      var $134=(($133+8)|0);
      var $135=HEAPU8[($134)];
      var $136=(($135)&255);
      var $137=(((($136)|0)/8)|0);
      $datawidth=$137;
      var $138=$cpu;
      var $139=__ZNK8device_t6memoryEv($138);
      var $140=__ZNK23device_memory_interface12space_configE16address_spacenum($139, 0);
      var $141=(($140+4)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)==0;
      var $144=(($143)&1);
      $littleendian=$144;
      __label__ = 23; break;
    case 23: // $145
      var $146=$datawidth;
      var $147=(($146)|0) > 1;
      if ($147) { __label__ = 24; break; } else { __label__ = 34; break; }
    case 24: // $148
      var $149=$littleendian;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 34; break; } else { __label__ = 25; break; }
    case 25: // $151
      $i=0;
      __label__ = 26; break;
    case 26: // $152
      var $153=$i;
      var $154=$length;
      var $155=(($153)>>>0) < (($154)>>>0);
      if ($155) { __label__ = 27; break; } else { __label__ = 33; break; }
    case 27: // $156
      var $157=(($temp)|0);
      var $158=$i;
      var $159=$ptr;
      var $160=(($159+$158)|0);
      var $161=$datawidth;
      assert($161 % 1 === 0, 'memcpy given ' + $161 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($157, $160, $161, 1);
      var $162=$datawidth;
      var $163=(($162-1)|0);
      $j=$163;
      __label__ = 28; break;
    case 28: // $164
      var $165=$j;
      var $166=(($165)|0) >= 0;
      if ($166) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $167
      var $168=$datawidth;
      var $169=(($168-1)|0);
      var $170=$j;
      var $171=(($169-$170)|0);
      var $172=(($temp+$171)|0);
      var $173=HEAP8[($172)];
      var $174=$i;
      var $175=$j;
      var $176=(($174+$175)|0);
      var $177=$ptr;
      var $178=(($177+$176)|0);
      HEAP8[($178)]=$173;
      __label__ = 30; break;
    case 30: // $179
      var $180=$j;
      var $181=(($180-1)|0);
      $j=$181;
      __label__ = 28; break;
    case 31: // $182
      __label__ = 32; break;
    case 32: // $183
      var $184=$datawidth;
      var $185=$i;
      var $186=(($185+$184)|0);
      $i=$186;
      __label__ = 26; break;
    case 33: // $187
      __label__ = 34; break;
    case 34: // $188
      __label__ = 35; break;
    case 35: // $189
      var $190=$flags;
      var $191=$190 & 134217728;
      var $192=(($191)|0)!=0;
      if ($192) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $193
      var $194=$flags;
      var $195=$194 & 67108864;
      var $196=(($195)|0)!=0;
      var $197=$196 ? 255 : 0;
      var $198=(($197) & 255);
      $clear_val=$198;
      var $199=$ptr;
      var $200=$pos;
      var $201=(($199+$200)|0);
      var $202=$clear_val;
      var $203=(($202)&255);
      var $204=(($203) & 255);
      var $205=$length;
      var $206=$pos;
      var $207=(($205-$206)|0);
      _memset($201, $204, $207, 1);
      __label__ = 37; break;
    case 37: // $208
      $1=0;
      __label__ = 38; break;
    case 38: // $209
      var $210=$1;
      STACKTOP = __stackBase__;
      return $210;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14load_cartridgeP22device_image_interfacePK9rom_entryS3_13_process_mode["X"]=1;

function __ZN22device_image_interface5fseekExi($this, $offset$0, $offset$1, $whence) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3;
  $1=$this;
  var $st$4$0=(($2)|0);
  HEAP32[(($st$4$0)>>2)]=$offset$0;
  var $st$4$1=(($2+4)|0);
  HEAP32[(($st$4$1)>>2)]=$offset$1;
  $3=$whence;
  var $4=$1;
  __ZN22device_image_interface14check_for_fileEv($4);
  var $5=(($4+80)|0);
  var $6=HEAP32[(($5)>>2)];
  var $st$13$0=(($2)|0);
  var $7$0=HEAP32[(($st$13$0)>>2)];
  var $st$13$1=(($2+4)|0);
  var $7$1=HEAP32[(($st$13$1)>>2)];
  var $8=$3;
  var $9=__Z10core_fseekP10_core_filexi($6, $7$0, $7$1, $8);
  var $9$0=$9[0];
  STACKTOP = __stackBase__;
  return $9;
}


function __ZNK23device_memory_interface12space_configE16address_spacenum($this, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$spacenum;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+56)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=FUNCTION_TABLE[$7]($3, $8);
  ;
  return $9;
}


function __Z18software_get_cloneR11emu_optionsPcPKc($options, $swlist, $swname) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $software_list_ptr;
      var $retval;
      var $tmp;
      $1=$options;
      $2=$swlist;
      $3=$swname;
      var $4=$1;
      var $5=$2;
      var $6=__Z18software_list_openR11emu_optionsPKciPFvS2_E($4, $5, 0, 0);
      $software_list_ptr=$6;
      $retval=0;
      var $7=$software_list_ptr;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$software_list_ptr;
      var $11=$3;
      var $12=__Z18software_list_findP14_software_listPKcP13software_info($10, $11, 0);
      $tmp=$12;
      var $13=$tmp;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__Z11core_strdupPKc($15);
      $retval=$16;
      var $17=$software_list_ptr;
      __Z19software_list_closeP14_software_list($17);
      __label__ = 2; break;
    case 2: // $18
      var $19=$retval;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18software_list_findP14_software_listPKcP13software_info($swlist, $look_for, $prev) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$swlist;
      $3=$look_for;
      $4=$prev;
      var $5=$2;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 16; break;
    case 2: // $8
      var $9=$3;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      $1=0;
      __label__ = 16; break;
    case 4: // $12
      var $13=$2;
      var $14=(($13+36)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $17
      var $18=$2;
      var $19=$2;
      var $20=(($19+68)|0);
      var $21=HEAP32[(($20)>>2)];
      __Z19software_list_parseP14_software_listPFvPKcEPv($18, $21, 0);
      __label__ = 6; break;
    case 6: // $22
      var $23=$4;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $25
      var $26=$4;
      var $27=(($26+36)|0);
      var $28=HEAP32[(($27)>>2)];
      var $34 = $28;__label__ = 9; break;
    case 8: // $29
      var $30=$2;
      var $31=(($30+36)|0);
      var $32=HEAP32[(($31)>>2)];
      var $34 = $32;__label__ = 9; break;
    case 9: // $33
      var $34;
      $4=$34;
      __label__ = 10; break;
    case 10: // $35
      var $36=$4;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $38
      var $39=$3;
      var $40=$4;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__Z15core_strwildcmpPKcS0_($39, $42);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $45
      __label__ = 15; break;
    case 13: // $46
      __label__ = 14; break;
    case 14: // $47
      var $48=$4;
      var $49=(($48+36)|0);
      var $50=HEAP32[(($49)>>2)];
      $4=$50;
      __label__ = 10; break;
    case 15: // $51
      var $52=$4;
      $1=$52;
      __label__ = 16; break;
    case 16: // $53
      var $54=$1;
      ;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18software_list_findP14_software_listPKcP13software_info["X"]=1;

function __Z19software_list_closeP14_software_list($swlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$swlist;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 5; break;
    case 2: // $5
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $14);
      __label__ = 4; break;
    case 4: // $15
      var $16=$1;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z13pool_free_libP12_object_pool($18);
      __label__ = 5; break;
    case 5: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20software_get_supportR11emu_optionsPcPKc($options, $swlist, $swname) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $software_list_ptr;
      var $retval;
      var $tmp;
      $1=$options;
      $2=$swlist;
      $3=$swname;
      var $4=$1;
      var $5=$2;
      var $6=__Z18software_list_openR11emu_optionsPKciPFvS2_E($4, $5, 0, 0);
      $software_list_ptr=$6;
      $retval=0;
      var $7=$software_list_ptr;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$software_list_ptr;
      var $11=$3;
      var $12=__Z18software_list_findP14_software_listPKcP13software_info($10, $11, 0);
      $tmp=$12;
      var $13=$tmp;
      var $14=(($13+28)|0);
      var $15=HEAP32[(($14)>>2)];
      $retval=$15;
      var $16=$software_list_ptr;
      __Z19software_list_closeP14_software_list($16);
      __label__ = 2; break;
    case 2: // $17
      var $18=$retval;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18software_list_openR11emu_optionsPKciPFvS2_E($options, $listname, $is_preload, $error_proc) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $swlist;
      var $pool;
      var $filerr;
      var $14;
      var $15;
      $10=$options;
      $11=$listname;
      $12=$is_preload;
      $13=$error_proc;
      $swlist=0;
      $pool=0;
      var $16=$13;
      var $17=__Z14pool_alloc_libPFvPKcE($16);
      $pool=$17;
      var $18=$pool;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $20
      __label__ = 23; break;
    case 2: // $21
      var $22=$pool;
      var $23=__Z21pool_malloc_file_lineP12_object_pooljPKci($22, 76, ((STRING_TABLE.__str11667)|0), 999);
      var $24=$23;
      $swlist=$24;
      var $25=$swlist;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $27
      __label__ = 23; break;
    case 4: // $28
      var $29=$swlist;
      var $30=$29;
      _memset($30, 0, 76, 1);
      var $31=$pool;
      var $32=$swlist;
      var $33=(($32+4)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$13;
      var $35=$swlist;
      var $36=(($35+68)|0);
      HEAP32[(($36)>>2)]=$34;
      var $37=$4;
      var $38=$5;
      var $39=$6;
      var $40=$result_i;
      var $41=$7;
      var $42=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($6)>>2)]=1009;
      var $43=HEAP32[(($4)>>2)];
      var $44=HEAP32[(($5)>>2)];
      var $45=HEAP32[(($6)>>2)];
      var $46=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43, $44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $47
      HEAP32[(($result_i)>>2)]=$46;
      var $48=HEAP32[(($result_i)>>2)];
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $50
      var $51=___cxa_allocate_exception(4);
      var $52=$51;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($52);
      (function() { try { __THREW__ = false; return ___cxa_throw($51, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      HEAP32[(($7)>>2)]=$55;
      var $56=$54.f1;
      HEAP32[(($8)>>2)]=$56;
      var $57=HEAP32[(($8)>>2)];
      var $58=(($57)|0) < 0;
      if ($58) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $59
      var $60=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($60);
      throw "Reached an unreachable!"
    case 9: // $61
      var $62=HEAP32[(($7)>>2)];
      var $63=HEAP32[(($7)>>2)];
      var $64=HEAP32[(($8)>>2)];
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $67
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKci_exit
      var $68=HEAP32[(($result_i)>>2)];
      var $69=$4;
      var $70=$5;
      var $71=$6;
      var $72=$result_i;
      var $73=$7;
      var $74=$8;
      var $75=$68;
      var $76=$10;
      var $77=(function() { try { __THREW__ = false; return __ZNK11emu_options9hash_pathEv($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $78
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($75, $77, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $79
      var $80=__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_(_global_resource_pool, $75);
      var $81=$swlist;
      var $82=(($81)|0);
      HEAP32[(($82)>>2)]=$80;
      var $83=$swlist;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$11;
      var $87=__ZN8emu_file4openEPKcS1_($85, $86, ((STRING_TABLE.__str21668)|0));
      $filerr=$87;
      var $88=$filerr;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $90
      __label__ = 23; break;
    case 15: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $93=$92.f0;
      $14=$93;
      var $94=$92.f1;
      $15=$94;
      var $95=$1;
      var $96=$2;
      var $97=$3;
      HEAP32[(($1)>>2)]=$68;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($3)>>2)]=1009;
      var $98=HEAP32[(($1)>>2)];
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $100
      var $101=HEAP32[(($1)>>2)];
      var $102=HEAP32[(($2)>>2)];
      var $103=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($101, $102, $103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 28; break; }
    case 17: // $_noexc
      __label__ = 18; break;
    case 18: // $_ZdlPvPKci_exit
      var $104=$1;
      var $105=$2;
      var $106=$3;
      __label__ = 19; break;
    case 19: // $107
      __label__ = 27; break;
    case 20: // $108
      var $109=$12;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $111
      var $112=$swlist;
      var $113=$swlist;
      var $114=(($113+68)|0);
      var $115=HEAP32[(($114)>>2)];
      __Z19software_list_parseP14_software_listPFvPKcEPv($112, $115, 0);
      var $116=$swlist;
      var $117=(($116+40)|0);
      HEAP32[(($117)>>2)]=0;
      __label__ = 22; break;
    case 22: // $118
      var $119=$swlist;
      $9=$119;
      __label__ = 26; break;
    case 23: // $120
      var $121=$swlist;
      var $122=(($121)|0)!=0;
      if ($122) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $123
      var $124=$swlist;
      __Z19software_list_closeP14_software_list($124);
      __label__ = 25; break;
    case 25: // $125
      $9=0;
      __label__ = 26; break;
    case 26: // $126
      var $127=$9;
      STACKTOP = __stackBase__;
      return $127;
    case 27: // $128
      var $129=$14;
      var $130=$14;
      var $131=$15;
      var $132=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $130, tempValue);
      var $133=($132.f1 = $131, $132);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 28: // $134
      var $135=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18software_list_openR11emu_optionsPKciPFvS2_E["X"]=1;

function __Z19software_list_parseP14_software_listPFvPKcEPv($swlist, $error_proc, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 1036; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buf=__stackBase__;
      var $len;
      var $memcallbacks=__stackBase__+1024;
      $1=$swlist;
      $2=$error_proc;
      $3=$param;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $7=__ZN8emu_file4seekExi($6, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $7$0=$7[0];
      var $8=$1;
      var $9=(($8+8)|0);
      var $10=$9;
      _memset($10, 0, 24, 1);
      var $11=$2;
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=(($13+8)|0);
      HEAP32[(($14)>>2)]=$11;
      var $15=$3;
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=(($17+12)|0);
      HEAP32[(($18)>>2)]=$15;
      var $19=(($memcallbacks)|0);
      HEAP32[(($19)>>2)]=156;
      var $20=(($memcallbacks+4)|0);
      HEAP32[(($20)>>2)]=158;
      var $21=(($memcallbacks+8)|0);
      HEAP32[(($21)>>2)]=160;
      var $22=_XML_ParserCreate_MM(0, $memcallbacks, 0);
      var $23=$1;
      var $24=(($23+8)|0);
      var $25=(($24)|0);
      HEAP32[(($25)>>2)]=$22;
      var $26=$1;
      var $27=(($26+8)|0);
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $31
      __label__ = 8; break;
    case 2: // $32
      var $33=$1;
      var $34=(($33+8)|0);
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$1;
      var $38=$37;
      _XML_SetUserData($36, $38);
      var $39=$1;
      var $40=(($39+8)|0);
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      _XML_SetElementHandler($42, 162, 164);
      var $43=$1;
      var $44=(($43+8)|0);
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      _XML_SetCharacterDataHandler($46, 166);
      __label__ = 3; break;
    case 3: // $47
      var $48=$1;
      var $49=(($48+8)|0);
      var $50=(($49+4)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)!=0;
      var $53=$52 ^ 1;
      if ($53) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $54
      var $55=$1;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($buf)|0);
      var $59=__ZN8emu_file4readEPvj($57, $58, 1024);
      $len=$59;
      var $60=$1;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__ZN8emu_file3eofEv($62);
      var $64=(($63)&1);
      var $65=$1;
      var $66=(($65+8)|0);
      var $67=(($66+4)|0);
      HEAP32[(($67)>>2)]=$64;
      var $68=$1;
      var $69=(($68+8)|0);
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($buf)|0);
      var $73=$len;
      var $74=$1;
      var $75=(($74+8)|0);
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=_XML_Parse($71, $72, $73, $77);
      var $79=(($78)|0)==0;
      if ($79) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $80
      var $81=$1;
      var $82=(($81+8)|0);
      var $83=$1;
      var $84=(($83+8)|0);
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=_XML_GetCurrentLineNumber($86);
      var $88=$1;
      var $89=(($88+8)|0);
      var $90=(($89)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=_XML_GetCurrentColumnNumber($91);
      var $93=$1;
      var $94=(($93+8)|0);
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=_XML_GetErrorCode($96);
      var $98=_XML_ErrorString($97);
      __ZL11parse_errorP12_parse_statePKcz($82, ((STRING_TABLE.__str1666)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$87,HEAP32[((tempInt+4)>>2)]=$92,HEAP32[((tempInt+8)>>2)]=$98,tempInt));
      __label__ = 8; break;
    case 6: // $99
      __label__ = 3; break;
    case 7: // $100
      __label__ = 8; break;
    case 8: // $101
      var $102=$1;
      var $103=(($102+8)|0);
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105)|0)!=0;
      if ($106) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $107
      var $108=$1;
      var $109=(($108+8)|0);
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      _XML_ParserFree($111);
      __label__ = 10; break;
    case 10: // $112
      var $113=$1;
      var $114=(($113+8)|0);
      var $115=(($114)|0);
      HEAP32[(($115)>>2)]=0;
      var $116=$1;
      var $117=(($116+36)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$1;
      var $120=(($119+40)|0);
      HEAP32[(($120)>>2)]=$118;
      var $121=$1;
      var $122=__ZL23software_list_get_countP14_software_list($121);
      var $123=$1;
      var $124=(($123+72)|0);
      HEAP32[(($124)>>2)]=$122;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19software_list_parseP14_software_listPFvPKcEPv["X"]=1;

function __ZL10expat_freePv($ptr) {
  ;
  var __label__;

  var $1;
  $1=$ptr;
  var $2=$1;
  __ZN13resource_pool6removeEPv(_global_resource_pool, $2);
  ;
  return;
}


function __ZL12expat_mallocj($size) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      $7=$size;
      var $8=$7;
      var $9=$1;
      var $10=$2;
      var $11=$3;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($1)>>2)]=$8;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($3)>>2)]=33;
      HEAP32[(($4)>>2)]=_zeromem;
      var $16=HEAP32[(($1)>>2)];
      var $17=HEAP32[(($2)>>2)];
      var $18=HEAP32[(($3)>>2)];
      var $19=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($16, $17, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $20
      HEAP32[(($result_i)>>2)]=$19;
      var $21=HEAP32[(($result_i)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $23
      var $24=___cxa_allocate_exception(4);
      var $25=$24;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25);
      (function() { try { __THREW__ = false; return ___cxa_throw($24, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($6)>>2)];
      var $31=(($30)|0) < 0;
      if ($31) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $32
      var $33=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($33);
      throw "Reached an unreachable!"
    case 5: // $34
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($5)>>2)];
      var $37=HEAP32[(($6)>>2)];
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKciRK9zeromem_t_exit
      var $41=HEAP32[(($result_i)>>2)];
      var $42=HEAP32[(($1)>>2)];
      _memset($41, 0, $42, 1);
      var $43=HEAP32[(($result_i)>>2)];
      var $44=$1;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      var $48=$result_i;
      var $49=$5;
      var $50=$6;
      var $51=$7;
      var $52=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $43, $51);
      STACKTOP = __stackBase__;
      return $52;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12expat_mallocj["X"]=1;

function __ZL13expat_reallocPvj($ptr, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      $7=$ptr;
      $8=$size;
      var $9=$7;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$7;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $12);
      __label__ = 2; break;
    case 2: // $13
      var $14=$8;
      var $15=$1;
      var $16=$2;
      var $17=$3;
      var $18=$4;
      var $19=$result_i;
      var $20=$5;
      var $21=$6;
      HEAP32[(($1)>>2)]=$14;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($3)>>2)]=39;
      HEAP32[(($4)>>2)]=_zeromem;
      var $22=HEAP32[(($1)>>2)];
      var $23=HEAP32[(($2)>>2)];
      var $24=HEAP32[(($3)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($5)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($6)>>2)]=$35;
      var $36=HEAP32[(($6)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      var $39=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 7: // $40
      var $41=HEAP32[(($5)>>2)];
      var $42=HEAP32[(($5)>>2)];
      var $43=HEAP32[(($6)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $46
      throw "Reached an unreachable!"
    case 9: // $_ZnajPKciRK9zeromem_t_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=HEAP32[(($1)>>2)];
      _memset($47, 0, $48, 1);
      var $49=HEAP32[(($result_i)>>2)];
      var $50=$1;
      var $51=$2;
      var $52=$3;
      var $53=$4;
      var $54=$result_i;
      var $55=$5;
      var $56=$6;
      var $57=$8;
      var $58=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $49, $57);
      STACKTOP = __stackBase__;
      return $58;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13expat_reallocPvj["X"]=1;

function __ZL13start_handlerPvPKcPS1_($data, $tagname, $attributes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $swlist;
      var $text_dest;
      var $name;
      var $parent;
      var $supported;
      var $elem;
      var $str_feature_name;
      var $str_feature_value;
      var $name1;
      var $value;
      var $str_name;
      var $str_interface;
      var $name2;
      var $interface;
      var $str_name3;
      var $str_size;
      var $length;
      var $s;
      var $str_name4;
      var $s5;
      var $str_feature_name6;
      var $str_feature_value7;
      var $name8;
      var $value9;
      var $str_name10;
      var $str_size11;
      var $str_crc;
      var $str_sha1;
      var $str_offset;
      var $str_value;
      var $str_status;
      var $str_loadflag;
      var $length12;
      var $offset;
      var $s_name;
      var $hashdata;
      var $baddump;
      var $nodump;
      var $romflags;
      var $str_name13;
      var $str_sha114;
      var $str_status15;
      var $str_writeable;
      var $s_name16;
      var $hashdata17;
      var $baddump18;
      var $nodump19;
      var $writeable;
      $1=$data;
      $2=$tagname;
      $3=$attributes;
      var $4=$1;
      var $5=$4;
      $swlist=$5;
      var $6=$swlist;
      var $7=(($6+8)|0);
      var $8=(($7+16)|0);
      var $9=HEAP32[(($8)>>2)];
      if ($9 == 0) {
        __label__ = 1; break;
      }
      else if ($9 == 1) {
        __label__ = 15; break;
      }
      else if ($9 == 2) {
        __label__ = 52; break;
      }
      else if ($9 == 3) {
        __label__ = 110; break;
      }
      else if ($9 == 4) {
        __label__ = 166; break;
      }
      else {
      __label__ = 273; break;
      }
      
    case 1: // $10
      var $11=$2;
      var $12=_strcmp($11, ((STRING_TABLE.__str321700)|0));
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 13; break; } else { __label__ = 2; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $20
      var $21=$3;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=_strcmp($23, ((STRING_TABLE.__str331701)|0));
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=_strcmp($30, ((STRING_TABLE.__str341702)|0));
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $33
      var $34=$swlist;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$3;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=_strlen($39);
      var $41=(($40+1)|0);
      var $42=(($41)|0);
      var $43=__Z21pool_malloc_file_lineP12_object_pooljPKci($36, $42, ((STRING_TABLE.__str11667)|0), 337);
      var $44=$swlist;
      var $45=(($44+32)|0);
      HEAP32[(($45)>>2)]=$43;
      var $46=$swlist;
      var $47=(($46+32)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $50
      __label__ = 274; break;
    case 9: // $51
      var $52=$swlist;
      var $53=(($52+32)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$3;
      var $56=(($55+4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=_strcpy($54, $57);
      __label__ = 10; break;
    case 10: // $59
      __label__ = 11; break;
    case 11: // $60
      var $61=$3;
      var $62=(($61+8)|0);
      $3=$62;
      __label__ = 3; break;
    case 12: // $63
      __label__ = 14; break;
    case 13: // $64
      var $65=$swlist;
      var $66=(($65+8)|0);
      var $67=$2;
      __ZL11unknown_tagP12_parse_statePKc($66, $67);
      __label__ = 14; break;
    case 14: // $68
      __label__ = 273; break;
    case 15: // $69
      var $70=$2;
      var $71=_strcmp($70, ((STRING_TABLE.__str351703)|0));
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 50; break; } else { __label__ = 16; break; }
    case 16: // $73
      $name=0;
      $parent=0;
      $supported=0;
      __label__ = 17; break;
    case 17: // $74
      var $75=$3;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 18; break; } else { __label__ = 26; break; }
    case 18: // $79
      var $80=$3;
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=_strcmp($82, ((STRING_TABLE.__str331701)|0));
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $85
      var $86=$3;
      var $87=(($86+4)|0);
      var $88=HEAP32[(($87)>>2)];
      $name=$88;
      __label__ = 20; break;
    case 20: // $89
      var $90=$3;
      var $91=(($90)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=_strcmp($92, ((STRING_TABLE.__str361704)|0));
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $95
      var $96=$3;
      var $97=(($96+4)|0);
      var $98=HEAP32[(($97)>>2)];
      $parent=$98;
      __label__ = 22; break;
    case 22: // $99
      var $100=$3;
      var $101=(($100)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=_strcmp($102, ((STRING_TABLE.__str371705)|0));
      var $104=(($103)|0)!=0;
      if ($104) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $105
      var $106=$3;
      var $107=(($106+4)|0);
      var $108=HEAP32[(($107)>>2)];
      $supported=$108;
      __label__ = 24; break;
    case 24: // $109
      __label__ = 25; break;
    case 25: // $110
      var $111=$3;
      var $112=(($111+8)|0);
      $3=$112;
      __label__ = 17; break;
    case 26: // $113
      var $114=$name;
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 27; break; } else { __label__ = 48; break; }
    case 27: // $116
      var $117=$swlist;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=__Z21pool_malloc_file_lineP12_object_pooljPKci($119, 40, ((STRING_TABLE.__str11667)|0), 376);
      var $121=$120;
      $elem=$121;
      var $122=$elem;
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $124
      __label__ = 274; break;
    case 29: // $125
      var $126=$elem;
      var $127=$126;
      _memset($127, 0, 40, 1);
      var $128=$swlist;
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$name;
      var $132=_strlen($131);
      var $133=(($132+1)|0);
      var $134=(($133)|0);
      var $135=__Z21pool_malloc_file_lineP12_object_pooljPKci($130, $134, ((STRING_TABLE.__str11667)|0), 385);
      var $136=$elem;
      var $137=(($136)|0);
      HEAP32[(($137)>>2)]=$135;
      var $138=$elem;
      var $139=(($138)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140)|0)!=0;
      if ($141) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $142
      __label__ = 274; break;
    case 31: // $143
      var $144=$elem;
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$name;
      var $148=_strcpy($146, $147);
      var $149=$parent;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $151
      var $152=$swlist;
      var $153=(($152+4)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$parent;
      var $156=_strlen($155);
      var $157=(($156+1)|0);
      var $158=(($157)|0);
      var $159=__Z21pool_malloc_file_lineP12_object_pooljPKci($154, $158, ((STRING_TABLE.__str11667)|0), 395);
      var $160=$elem;
      var $161=(($160+8)|0);
      HEAP32[(($161)>>2)]=$159;
      var $162=$elem;
      var $163=(($162+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$parent;
      var $166=_strcpy($164, $165);
      __label__ = 33; break;
    case 33: // $167
      var $168=$swlist;
      var $169=(($168+52)|0);
      HEAP32[(($169)>>2)]=2;
      var $170=$swlist;
      var $171=(($170+56)|0);
      HEAP32[(($171)>>2)]=0;
      var $172=$swlist;
      var $173=(($172+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$swlist;
      var $176=(($175+52)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=((($177<<4))|0);
      var $179=__Z21pool_malloc_file_lineP12_object_pooljPKci($174, $178, ((STRING_TABLE.__str11667)|0), 402);
      var $180=$179;
      var $181=$elem;
      var $182=(($181+32)|0);
      HEAP32[(($182)>>2)]=$180;
      var $183=$elem;
      var $184=(($183+32)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $187
      __label__ = 274; break;
    case 35: // $188
      var $189=$swlist;
      var $190=(($189+4)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=__Z21pool_malloc_file_lineP12_object_pooljPKci($191, 12, ((STRING_TABLE.__str11667)|0), 405);
      var $193=$192;
      var $194=$elem;
      var $195=(($194+24)|0);
      HEAP32[(($195)>>2)]=$193;
      var $196=$elem;
      var $197=(($196+24)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198)|0)!=0;
      if ($199) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $200
      __label__ = 274; break;
    case 37: // $201
      var $202=$swlist;
      var $203=(($202+4)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=__Z21pool_malloc_file_lineP12_object_pooljPKci($204, 12, ((STRING_TABLE.__str11667)|0), 410);
      var $206=$205;
      var $207=$elem;
      var $208=(($207+24)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=(($209)|0);
      HEAP32[(($210)>>2)]=$206;
      var $211=$elem;
      var $212=(($211+24)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213)|0);
      HEAP32[(($214)>>2)]=0;
      var $215=$elem;
      var $216=(($215+24)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(($217+4)|0);
      HEAP32[(($218)>>2)]=0;
      var $219=$elem;
      var $220=(($219+24)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+8)|0);
      HEAP32[(($222)>>2)]=0;
      __label__ = 38; break;
    case 38: // $223
      var $224=$elem;
      var $225=(($224+28)|0);
      HEAP32[(($225)>>2)]=0;
      var $226=$supported;
      var $227=(($226)|0)!=0;
      if ($227) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $228
      var $229=$supported;
      var $230=_strcmp($229, ((STRING_TABLE.__str381706)|0));
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $232
      var $233=$elem;
      var $234=(($233+28)|0);
      HEAP32[(($234)>>2)]=1;
      __label__ = 41; break;
    case 41: // $235
      var $236=$supported;
      var $237=(($236)|0)!=0;
      if ($237) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $238
      var $239=$supported;
      var $240=_strcmp($239, ((STRING_TABLE.__str391707)|0));
      var $241=(($240)|0)!=0;
      if ($241) { __label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $242
      var $243=$elem;
      var $244=(($243+28)|0);
      HEAP32[(($244)>>2)]=2;
      __label__ = 44; break;
    case 44: // $245
      var $246=$swlist;
      var $247=(($246+36)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=(($248)|0)==0;
      if ($249) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $250
      var $251=$elem;
      var $252=$swlist;
      var $253=(($252+36)|0);
      HEAP32[(($253)>>2)]=$251;
      var $254=$elem;
      var $255=$swlist;
      var $256=(($255+40)|0);
      HEAP32[(($256)>>2)]=$254;
      __label__ = 47; break;
    case 46: // $257
      var $258=$elem;
      var $259=$swlist;
      var $260=(($259+40)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=(($261+36)|0);
      HEAP32[(($262)>>2)]=$258;
      var $263=$elem;
      var $264=$swlist;
      var $265=(($264+40)|0);
      HEAP32[(($265)>>2)]=$263;
      __label__ = 47; break;
    case 47: // $266
      var $267=$swlist;
      var $268=(($267+40)|0);
      var $269=HEAP32[(($268)>>2)];
      var $270=$swlist;
      var $271=(($270+44)|0);
      HEAP32[(($271)>>2)]=$269;
      __label__ = 49; break;
    case 48: // $272
      var $273=$swlist;
      var $274=(($273+44)|0);
      HEAP32[(($274)>>2)]=0;
      __label__ = 49; break;
    case 49: // $275
      __label__ = 51; break;
    case 50: // $276
      var $277=$swlist;
      var $278=(($277+8)|0);
      var $279=$2;
      __ZL11unknown_tagP12_parse_statePKc($278, $279);
      __label__ = 51; break;
    case 51: // $280
      __label__ = 273; break;
    case 52: // $281
      $text_dest=0;
      var $282=$2;
      var $283=_strcmp($282, ((STRING_TABLE.__str341702)|0));
      var $284=(($283)|0)!=0;
      if ($284) { __label__ = 54; break; } else { __label__ = 53; break; }
    case 53: // $285
      var $286=$swlist;
      var $287=(($286+44)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=(($288+4)|0);
      $text_dest=$289;
      __label__ = 106; break;
    case 54: // $290
      var $291=$2;
      var $292=_strcmp($291, ((STRING_TABLE.__str401708)|0));
      var $293=(($292)|0)!=0;
      if ($293) { __label__ = 56; break; } else { __label__ = 55; break; }
    case 55: // $294
      var $295=$swlist;
      var $296=(($295+44)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=(($297+12)|0);
      $text_dest=$298;
      __label__ = 105; break;
    case 56: // $299
      var $300=$2;
      var $301=_strcmp($300, ((STRING_TABLE.__str411709)|0));
      var $302=(($301)|0)!=0;
      if ($302) { __label__ = 58; break; } else { __label__ = 57; break; }
    case 57: // $303
      var $304=$swlist;
      var $305=(($304+44)|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=(($306+16)|0);
      $text_dest=$307;
      __label__ = 104; break;
    case 58: // $308
      var $309=$2;
      var $310=_strcmp($309, ((STRING_TABLE.__str421710)|0));
      var $311=(($310)|0)!=0;
      if ($311) { __label__ = 60; break; } else { __label__ = 59; break; }
    case 59: // $312
      __label__ = 103; break;
    case 60: // $313
      var $314=$2;
      var $315=_strcmp($314, ((STRING_TABLE.__str431711)|0));
      var $316=(($315)|0)!=0;
      if ($316) { __label__ = 79; break; } else { __label__ = 61; break; }
    case 61: // $317
      $str_feature_name=0;
      $str_feature_value=0;
      __label__ = 62; break;
    case 62: // $318
      var $319=$3;
      var $320=(($319)|0);
      var $321=HEAP32[(($320)>>2)];
      var $322=(($321)|0)!=0;
      if ($322) { __label__ = 63; break; } else { __label__ = 69; break; }
    case 63: // $323
      var $324=$3;
      var $325=(($324)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=_strcmp($326, ((STRING_TABLE.__str331701)|0));
      var $328=(($327)|0)!=0;
      if ($328) { __label__ = 65; break; } else { __label__ = 64; break; }
    case 64: // $329
      var $330=$3;
      var $331=(($330+4)|0);
      var $332=HEAP32[(($331)>>2)];
      $str_feature_name=$332;
      __label__ = 65; break;
    case 65: // $333
      var $334=$3;
      var $335=(($334)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=_strcmp($336, ((STRING_TABLE.__str441712)|0));
      var $338=(($337)|0)!=0;
      if ($338) { __label__ = 67; break; } else { __label__ = 66; break; }
    case 66: // $339
      var $340=$3;
      var $341=(($340+4)|0);
      var $342=HEAP32[(($341)>>2)];
      $str_feature_value=$342;
      __label__ = 67; break;
    case 67: // $343
      __label__ = 68; break;
    case 68: // $344
      var $345=$3;
      var $346=(($345+8)|0);
      $3=$346;
      __label__ = 62; break;
    case 69: // $347
      var $348=$str_feature_name;
      var $349=(($348)|0)!=0;
      if ($349) { __label__ = 70; break; } else { __label__ = 78; break; }
    case 70: // $350
      var $351=$swlist;
      var $352=(($351+44)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($353)|0)!=0;
      if ($354) { __label__ = 71; break; } else { __label__ = 78; break; }
    case 71: // $355
      var $356=$swlist;
      var $357=(($356+4)|0);
      var $358=HEAP32[(($357)>>2)];
      var $359=$str_feature_name;
      var $360=_strlen($359);
      var $361=(($360+1)|0);
      var $362=(($361)|0);
      var $363=__Z21pool_malloc_file_lineP12_object_pooljPKci($358, $362, ((STRING_TABLE.__str11667)|0), 480);
      $name1=$363;
      $value=0;
      var $364=$name1;
      var $365=(($364)|0)!=0;
      if ($365) { __label__ = 73; break; } else { __label__ = 72; break; }
    case 72: // $366
      __label__ = 274; break;
    case 73: // $367
      var $368=$name1;
      var $369=$str_feature_name;
      var $370=_strcpy($368, $369);
      var $371=$str_feature_value;
      var $372=(($371)|0)!=0;
      if ($372) { __label__ = 74; break; } else { __label__ = 77; break; }
    case 74: // $373
      var $374=$swlist;
      var $375=(($374+4)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=$str_feature_value;
      var $378=_strlen($377);
      var $379=(($378+1)|0);
      var $380=(($379)|0);
      var $381=__Z21pool_malloc_file_lineP12_object_pooljPKci($376, $380, ((STRING_TABLE.__str11667)|0), 490);
      $value=$381;
      var $382=$value;
      var $383=(($382)|0)!=0;
      if ($383) { __label__ = 76; break; } else { __label__ = 75; break; }
    case 75: // $384
      __label__ = 274; break;
    case 76: // $385
      var $386=$value;
      var $387=$str_feature_value;
      var $388=_strcpy($386, $387);
      __label__ = 77; break;
    case 77: // $389
      var $390=$swlist;
      var $391=$name1;
      var $392=$value;
      __ZL8add_infoP14_software_listPcS1_($390, $391, $392);
      __label__ = 78; break;
    case 78: // $393
      __label__ = 102; break;
    case 79: // $394
      var $395=$2;
      var $396=_strcmp($395, ((STRING_TABLE.__str311699)|0));
      var $397=(($396)|0)!=0;
      if ($397) { __label__ = 100; break; } else { __label__ = 80; break; }
    case 80: // $398
      $str_name=0;
      $str_interface=0;
      __label__ = 81; break;
    case 81: // $399
      var $400=$3;
      var $401=(($400)|0);
      var $402=HEAP32[(($401)>>2)];
      var $403=(($402)|0)!=0;
      if ($403) { __label__ = 82; break; } else { __label__ = 88; break; }
    case 82: // $404
      var $405=$3;
      var $406=(($405)|0);
      var $407=HEAP32[(($406)>>2)];
      var $408=_strcmp($407, ((STRING_TABLE.__str331701)|0));
      var $409=(($408)|0)!=0;
      if ($409) { __label__ = 84; break; } else { __label__ = 83; break; }
    case 83: // $410
      var $411=$3;
      var $412=(($411+4)|0);
      var $413=HEAP32[(($412)>>2)];
      $str_name=$413;
      __label__ = 84; break;
    case 84: // $414
      var $415=$3;
      var $416=(($415)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=_strcmp($417, ((STRING_TABLE.__str451713)|0));
      var $419=(($418)|0)!=0;
      if ($419) { __label__ = 86; break; } else { __label__ = 85; break; }
    case 85: // $420
      var $421=$3;
      var $422=(($421+4)|0);
      var $423=HEAP32[(($422)>>2)];
      $str_interface=$423;
      __label__ = 86; break;
    case 86: // $424
      __label__ = 87; break;
    case 87: // $425
      var $426=$3;
      var $427=(($426+8)|0);
      $3=$427;
      __label__ = 81; break;
    case 88: // $428
      var $429=$str_name;
      var $430=(($429)|0)!=0;
      if ($430) { __label__ = 89; break; } else { __label__ = 98; break; }
    case 89: // $431
      var $432=$str_interface;
      var $433=(($432)|0)!=0;
      if ($433) { __label__ = 90; break; } else { __label__ = 98; break; }
    case 90: // $434
      var $435=$swlist;
      var $436=(($435+44)|0);
      var $437=HEAP32[(($436)>>2)];
      var $438=(($437)|0)!=0;
      if ($438) { __label__ = 91; break; } else { __label__ = 97; break; }
    case 91: // $439
      var $440=$swlist;
      var $441=(($440+4)|0);
      var $442=HEAP32[(($441)>>2)];
      var $443=$str_name;
      var $444=_strlen($443);
      var $445=(($444+1)|0);
      var $446=(($445)|0);
      var $447=__Z21pool_malloc_file_lineP12_object_pooljPKci($442, $446, ((STRING_TABLE.__str11667)|0), 519);
      $name2=$447;
      var $448=$swlist;
      var $449=(($448+4)|0);
      var $450=HEAP32[(($449)>>2)];
      var $451=$str_interface;
      var $452=_strlen($451);
      var $453=(($452+1)|0);
      var $454=(($453)|0);
      var $455=__Z21pool_malloc_file_lineP12_object_pooljPKci($450, $454, ((STRING_TABLE.__str11667)|0), 520);
      $interface=$455;
      var $456=$name2;
      var $457=(($456)|0)!=0;
      if ($457) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $458
      var $459=$interface;
      var $460=(($459)|0)!=0;
      if ($460) { __label__ = 94; break; } else { __label__ = 93; break; }
    case 93: // $461
      __label__ = 274; break;
    case 94: // $462
      var $463=$name2;
      var $464=$str_name;
      var $465=_strcpy($463, $464);
      var $466=$interface;
      var $467=$str_interface;
      var $468=_strcpy($466, $467);
      var $469=$swlist;
      var $470=$name2;
      var $471=$interface;
      __ZL17add_software_partP14_software_listPKcS2_($469, $470, $471);
      var $472=$swlist;
      var $473=(($472+60)|0);
      HEAP32[(($473)>>2)]=3;
      var $474=$swlist;
      var $475=(($474+64)|0);
      HEAP32[(($475)>>2)]=0;
      var $476=$swlist;
      var $477=(($476+4)|0);
      var $478=HEAP32[(($477)>>2)];
      var $479=$swlist;
      var $480=(($479+60)|0);
      var $481=HEAP32[(($480)>>2)];
      var $482=(($481*20)|0);
      var $483=__Z21pool_malloc_file_lineP12_object_pooljPKci($478, $482, ((STRING_TABLE.__str11667)|0), 533);
      var $484=$483;
      var $485=$swlist;
      var $486=(($485+56)|0);
      var $487=HEAP32[(($486)>>2)];
      var $488=(($487-1)|0);
      var $489=$swlist;
      var $490=(($489+44)|0);
      var $491=HEAP32[(($490)>>2)];
      var $492=(($491+32)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=(($493+($488<<4))|0);
      var $495=(($494+12)|0);
      HEAP32[(($495)>>2)]=$484;
      var $496=$swlist;
      var $497=(($496+56)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=(($498-1)|0);
      var $500=$swlist;
      var $501=(($500+44)|0);
      var $502=HEAP32[(($501)>>2)];
      var $503=(($502+32)|0);
      var $504=HEAP32[(($503)>>2)];
      var $505=(($504+($499<<4))|0);
      var $506=(($505+12)|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=(($507)|0)!=0;
      if ($508) { __label__ = 96; break; } else { __label__ = 95; break; }
    case 95: // $509
      __label__ = 274; break;
    case 96: // $510
      __label__ = 97; break;
    case 97: // $511
      __label__ = 99; break;
    case 98: // $512
      __label__ = 99; break;
    case 99: // $513
      __label__ = 101; break;
    case 100: // $514
      var $515=$swlist;
      var $516=(($515+8)|0);
      var $517=$2;
      __ZL11unknown_tagP12_parse_statePKc($516, $517);
      __label__ = 101; break;
    case 101: // $518
      __label__ = 102; break;
    case 102: // $519
      __label__ = 103; break;
    case 103: // $520
      __label__ = 104; break;
    case 104: // $521
      __label__ = 105; break;
    case 105: // $522
      __label__ = 106; break;
    case 106: // $523
      var $524=$text_dest;
      var $525=(($524)|0)!=0;
      if ($525) { __label__ = 107; break; } else { __label__ = 109; break; }
    case 107: // $526
      var $527=$swlist;
      var $528=(($527+44)|0);
      var $529=HEAP32[(($528)>>2)];
      var $530=(($529)|0)!=0;
      if ($530) { __label__ = 108; break; } else { __label__ = 109; break; }
    case 108: // $531
      var $532=$text_dest;
      var $533=$swlist;
      var $534=(($533+8)|0);
      var $535=(($534+20)|0);
      HEAP32[(($535)>>2)]=$532;
      __label__ = 109; break;
    case 109: // $536
      __label__ = 273; break;
    case 110: // $537
      var $538=$2;
      var $539=_strcmp($538, ((STRING_TABLE.__str461714)|0));
      var $540=(($539)|0)!=0;
      if ($540) { __label__ = 128; break; } else { __label__ = 111; break; }
    case 111: // $541
      $str_name3=0;
      $str_size=0;
      __label__ = 112; break;
    case 112: // $542
      var $543=$3;
      var $544=(($543)|0);
      var $545=HEAP32[(($544)>>2)];
      var $546=(($545)|0)!=0;
      if ($546) { __label__ = 113; break; } else { __label__ = 119; break; }
    case 113: // $547
      var $548=$3;
      var $549=(($548)|0);
      var $550=HEAP32[(($549)>>2)];
      var $551=_strcmp($550, ((STRING_TABLE.__str331701)|0));
      var $552=(($551)|0)!=0;
      if ($552) { __label__ = 115; break; } else { __label__ = 114; break; }
    case 114: // $553
      var $554=$3;
      var $555=(($554+4)|0);
      var $556=HEAP32[(($555)>>2)];
      $str_name3=$556;
      __label__ = 115; break;
    case 115: // $557
      var $558=$3;
      var $559=(($558)|0);
      var $560=HEAP32[(($559)>>2)];
      var $561=_strcmp($560, ((STRING_TABLE.__str471715)|0));
      var $562=(($561)|0)!=0;
      if ($562) { __label__ = 117; break; } else { __label__ = 116; break; }
    case 116: // $563
      var $564=$3;
      var $565=(($564+4)|0);
      var $566=HEAP32[(($565)>>2)];
      $str_size=$566;
      __label__ = 117; break;
    case 117: // $567
      __label__ = 118; break;
    case 118: // $568
      var $569=$3;
      var $570=(($569+8)|0);
      $3=$570;
      __label__ = 112; break;
    case 119: // $571
      var $572=$str_name3;
      var $573=(($572)|0)!=0;
      if ($573) { __label__ = 120; break; } else { __label__ = 126; break; }
    case 120: // $574
      var $575=$str_size;
      var $576=(($575)|0)!=0;
      if ($576) { __label__ = 121; break; } else { __label__ = 126; break; }
    case 121: // $577
      var $578=$swlist;
      var $579=(($578+44)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=(($580)|0)!=0;
      if ($581) { __label__ = 122; break; } else { __label__ = 125; break; }
    case 122: // $582
      var $583=$str_size;
      var $584=_strtol($583, 0, 0);
      $length=$584;
      var $585=$swlist;
      var $586=(($585+4)|0);
      var $587=HEAP32[(($586)>>2)];
      var $588=$str_name3;
      var $589=_strlen($588);
      var $590=(($589+1)|0);
      var $591=(($590)|0);
      var $592=__Z21pool_malloc_file_lineP12_object_pooljPKci($587, $591, ((STRING_TABLE.__str11667)|0), 569);
      $s=$592;
      var $593=$s;
      var $594=(($593)|0)!=0;
      if ($594) { __label__ = 124; break; } else { __label__ = 123; break; }
    case 123: // $595
      __label__ = 274; break;
    case 124: // $596
      var $597=$s;
      var $598=$str_name3;
      var $599=_strcpy($597, $598);
      var $600=$swlist;
      var $601=$s;
      var $602=$length;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($600, $601, 0, 0, $602, 1);
      __label__ = 125; break;
    case 125: // $603
      __label__ = 127; break;
    case 126: // $604
      __label__ = 127; break;
    case 127: // $605
      __label__ = 165; break;
    case 128: // $606
      var $607=$2;
      var $608=_strcmp($607, ((STRING_TABLE.__str481716)|0));
      var $609=(($608)|0)!=0;
      if ($609) { __label__ = 143; break; } else { __label__ = 129; break; }
    case 129: // $610
      $str_name4=0;
      __label__ = 130; break;
    case 130: // $611
      var $612=$3;
      var $613=(($612)|0);
      var $614=HEAP32[(($613)>>2)];
      var $615=(($614)|0)!=0;
      if ($615) { __label__ = 131; break; } else { __label__ = 135; break; }
    case 131: // $616
      var $617=$3;
      var $618=(($617)|0);
      var $619=HEAP32[(($618)>>2)];
      var $620=_strcmp($619, ((STRING_TABLE.__str331701)|0));
      var $621=(($620)|0)!=0;
      if ($621) { __label__ = 133; break; } else { __label__ = 132; break; }
    case 132: // $622
      var $623=$3;
      var $624=(($623+4)|0);
      var $625=HEAP32[(($624)>>2)];
      $str_name4=$625;
      __label__ = 133; break;
    case 133: // $626
      __label__ = 134; break;
    case 134: // $627
      var $628=$3;
      var $629=(($628+8)|0);
      $3=$629;
      __label__ = 130; break;
    case 135: // $630
      var $631=$str_name4;
      var $632=(($631)|0)!=0;
      if ($632) { __label__ = 136; break; } else { __label__ = 141; break; }
    case 136: // $633
      var $634=$swlist;
      var $635=(($634+44)|0);
      var $636=HEAP32[(($635)>>2)];
      var $637=(($636)|0)!=0;
      if ($637) { __label__ = 137; break; } else { __label__ = 140; break; }
    case 137: // $638
      var $639=$swlist;
      var $640=(($639+4)|0);
      var $641=HEAP32[(($640)>>2)];
      var $642=$str_name4;
      var $643=_strlen($642);
      var $644=(($643+1)|0);
      var $645=(($644)|0);
      var $646=__Z21pool_malloc_file_lineP12_object_pooljPKci($641, $645, ((STRING_TABLE.__str11667)|0), 598);
      $s5=$646;
      var $647=$s5;
      var $648=(($647)|0)!=0;
      if ($648) { __label__ = 139; break; } else { __label__ = 138; break; }
    case 138: // $649
      __label__ = 274; break;
    case 139: // $650
      var $651=$s5;
      var $652=$str_name4;
      var $653=_strcpy($651, $652);
      var $654=$swlist;
      var $655=$s5;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($654, $655, 0, 0, 1, 16385);
      __label__ = 140; break;
    case 140: // $656
      __label__ = 142; break;
    case 141: // $657
      __label__ = 142; break;
    case 142: // $658
      __label__ = 164; break;
    case 143: // $659
      var $660=$2;
      var $661=_strcmp($660, ((STRING_TABLE.__str491717)|0));
      var $662=(($661)|0)!=0;
      if ($662) { __label__ = 162; break; } else { __label__ = 144; break; }
    case 144: // $663
      $str_feature_name6=0;
      $str_feature_value7=0;
      __label__ = 145; break;
    case 145: // $664
      var $665=$3;
      var $666=(($665)|0);
      var $667=HEAP32[(($666)>>2)];
      var $668=(($667)|0)!=0;
      if ($668) { __label__ = 146; break; } else { __label__ = 152; break; }
    case 146: // $669
      var $670=$3;
      var $671=(($670)|0);
      var $672=HEAP32[(($671)>>2)];
      var $673=_strcmp($672, ((STRING_TABLE.__str331701)|0));
      var $674=(($673)|0)!=0;
      if ($674) { __label__ = 148; break; } else { __label__ = 147; break; }
    case 147: // $675
      var $676=$3;
      var $677=(($676+4)|0);
      var $678=HEAP32[(($677)>>2)];
      $str_feature_name6=$678;
      __label__ = 148; break;
    case 148: // $679
      var $680=$3;
      var $681=(($680)|0);
      var $682=HEAP32[(($681)>>2)];
      var $683=_strcmp($682, ((STRING_TABLE.__str441712)|0));
      var $684=(($683)|0)!=0;
      if ($684) { __label__ = 150; break; } else { __label__ = 149; break; }
    case 149: // $685
      var $686=$3;
      var $687=(($686+4)|0);
      var $688=HEAP32[(($687)>>2)];
      $str_feature_value7=$688;
      __label__ = 150; break;
    case 150: // $689
      __label__ = 151; break;
    case 151: // $690
      var $691=$3;
      var $692=(($691+8)|0);
      $3=$692;
      __label__ = 145; break;
    case 152: // $693
      var $694=$str_feature_name6;
      var $695=(($694)|0)!=0;
      if ($695) { __label__ = 153; break; } else { __label__ = 161; break; }
    case 153: // $696
      var $697=$swlist;
      var $698=(($697+44)|0);
      var $699=HEAP32[(($698)>>2)];
      var $700=(($699)|0)!=0;
      if ($700) { __label__ = 154; break; } else { __label__ = 161; break; }
    case 154: // $701
      var $702=$swlist;
      var $703=(($702+4)|0);
      var $704=HEAP32[(($703)>>2)];
      var $705=$str_feature_name6;
      var $706=_strlen($705);
      var $707=(($706+1)|0);
      var $708=(($707)|0);
      var $709=__Z21pool_malloc_file_lineP12_object_pooljPKci($704, $708, ((STRING_TABLE.__str11667)|0), 631);
      $name8=$709;
      $value9=0;
      var $710=$name8;
      var $711=(($710)|0)!=0;
      if ($711) { __label__ = 156; break; } else { __label__ = 155; break; }
    case 155: // $712
      __label__ = 274; break;
    case 156: // $713
      var $714=$name8;
      var $715=$str_feature_name6;
      var $716=_strcpy($714, $715);
      var $717=$str_feature_value7;
      var $718=(($717)|0)!=0;
      if ($718) { __label__ = 157; break; } else { __label__ = 160; break; }
    case 157: // $719
      var $720=$swlist;
      var $721=(($720+4)|0);
      var $722=HEAP32[(($721)>>2)];
      var $723=$str_feature_value7;
      var $724=_strlen($723);
      var $725=(($724+1)|0);
      var $726=(($725)|0);
      var $727=__Z21pool_malloc_file_lineP12_object_pooljPKci($722, $726, ((STRING_TABLE.__str11667)|0), 641);
      $value9=$727;
      var $728=$value9;
      var $729=(($728)|0)!=0;
      if ($729) { __label__ = 159; break; } else { __label__ = 158; break; }
    case 158: // $730
      __label__ = 274; break;
    case 159: // $731
      var $732=$value9;
      var $733=$str_feature_value7;
      var $734=_strcpy($732, $733);
      __label__ = 160; break;
    case 160: // $735
      var $736=$swlist;
      var $737=$name8;
      var $738=$value9;
      __ZL11add_featureP14_software_listPcS1_($736, $737, $738);
      __label__ = 161; break;
    case 161: // $739
      __label__ = 163; break;
    case 162: // $740
      var $741=$swlist;
      var $742=(($741+8)|0);
      var $743=$2;
      __ZL11unknown_tagP12_parse_statePKc($742, $743);
      __label__ = 163; break;
    case 163: // $744
      __label__ = 164; break;
    case 164: // $745
      __label__ = 165; break;
    case 165: // $746
      __label__ = 273; break;
    case 166: // $747
      var $748=$2;
      var $749=_strcmp($748, ((STRING_TABLE.__str501718)|0));
      var $750=(($749)|0)!=0;
      if ($750) { __label__ = 239; break; } else { __label__ = 167; break; }
    case 167: // $751
      $str_name10=0;
      $str_size11=0;
      $str_crc=0;
      $str_sha1=0;
      $str_offset=0;
      $str_value=0;
      $str_status=0;
      $str_loadflag=0;
      __label__ = 168; break;
    case 168: // $752
      var $753=$3;
      var $754=(($753)|0);
      var $755=HEAP32[(($754)>>2)];
      var $756=(($755)|0)!=0;
      if ($756) { __label__ = 169; break; } else { __label__ = 187; break; }
    case 169: // $757
      var $758=$3;
      var $759=(($758)|0);
      var $760=HEAP32[(($759)>>2)];
      var $761=_strcmp($760, ((STRING_TABLE.__str331701)|0));
      var $762=(($761)|0)!=0;
      if ($762) { __label__ = 171; break; } else { __label__ = 170; break; }
    case 170: // $763
      var $764=$3;
      var $765=(($764+4)|0);
      var $766=HEAP32[(($765)>>2)];
      $str_name10=$766;
      __label__ = 171; break;
    case 171: // $767
      var $768=$3;
      var $769=(($768)|0);
      var $770=HEAP32[(($769)>>2)];
      var $771=_strcmp($770, ((STRING_TABLE.__str471715)|0));
      var $772=(($771)|0)!=0;
      if ($772) { __label__ = 173; break; } else { __label__ = 172; break; }
    case 172: // $773
      var $774=$3;
      var $775=(($774+4)|0);
      var $776=HEAP32[(($775)>>2)];
      $str_size11=$776;
      __label__ = 173; break;
    case 173: // $777
      var $778=$3;
      var $779=(($778)|0);
      var $780=HEAP32[(($779)>>2)];
      var $781=_strcmp($780, ((STRING_TABLE.__str511719)|0));
      var $782=(($781)|0)!=0;
      if ($782) { __label__ = 175; break; } else { __label__ = 174; break; }
    case 174: // $783
      var $784=$3;
      var $785=(($784+4)|0);
      var $786=HEAP32[(($785)>>2)];
      $str_crc=$786;
      __label__ = 175; break;
    case 175: // $787
      var $788=$3;
      var $789=(($788)|0);
      var $790=HEAP32[(($789)>>2)];
      var $791=_strcmp($790, ((STRING_TABLE.__str521720)|0));
      var $792=(($791)|0)!=0;
      if ($792) { __label__ = 177; break; } else { __label__ = 176; break; }
    case 176: // $793
      var $794=$3;
      var $795=(($794+4)|0);
      var $796=HEAP32[(($795)>>2)];
      $str_sha1=$796;
      __label__ = 177; break;
    case 177: // $797
      var $798=$3;
      var $799=(($798)|0);
      var $800=HEAP32[(($799)>>2)];
      var $801=_strcmp($800, ((STRING_TABLE.__str531721)|0));
      var $802=(($801)|0)!=0;
      if ($802) { __label__ = 179; break; } else { __label__ = 178; break; }
    case 178: // $803
      var $804=$3;
      var $805=(($804+4)|0);
      var $806=HEAP32[(($805)>>2)];
      $str_offset=$806;
      __label__ = 179; break;
    case 179: // $807
      var $808=$3;
      var $809=(($808)|0);
      var $810=HEAP32[(($809)>>2)];
      var $811=_strcmp($810, ((STRING_TABLE.__str441712)|0));
      var $812=(($811)|0)!=0;
      if ($812) { __label__ = 181; break; } else { __label__ = 180; break; }
    case 180: // $813
      var $814=$3;
      var $815=(($814+4)|0);
      var $816=HEAP32[(($815)>>2)];
      $str_value=$816;
      __label__ = 181; break;
    case 181: // $817
      var $818=$3;
      var $819=(($818)|0);
      var $820=HEAP32[(($819)>>2)];
      var $821=_strcmp($820, ((STRING_TABLE.__str541722)|0));
      var $822=(($821)|0)!=0;
      if ($822) { __label__ = 183; break; } else { __label__ = 182; break; }
    case 182: // $823
      var $824=$3;
      var $825=(($824+4)|0);
      var $826=HEAP32[(($825)>>2)];
      $str_status=$826;
      __label__ = 183; break;
    case 183: // $827
      var $828=$3;
      var $829=(($828)|0);
      var $830=HEAP32[(($829)>>2)];
      var $831=_strcmp($830, ((STRING_TABLE.__str551723)|0));
      var $832=(($831)|0)!=0;
      if ($832) { __label__ = 185; break; } else { __label__ = 184; break; }
    case 184: // $833
      var $834=$3;
      var $835=(($834+4)|0);
      var $836=HEAP32[(($835)>>2)];
      $str_loadflag=$836;
      __label__ = 185; break;
    case 185: // $837
      __label__ = 186; break;
    case 186: // $838
      var $839=$3;
      var $840=(($839+8)|0);
      $3=$840;
      __label__ = 168; break;
    case 187: // $841
      var $842=$swlist;
      var $843=(($842+44)|0);
      var $844=HEAP32[(($843)>>2)];
      var $845=(($844)|0)!=0;
      if ($845) { __label__ = 188; break; } else { __label__ = 237; break; }
    case 188: // $846
      var $847=$str_size11;
      var $848=(($847)|0)!=0;
      if ($848) { __label__ = 189; break; } else { __label__ = 236; break; }
    case 189: // $849
      var $850=$str_offset;
      var $851=(($850)|0)!=0;
      if ($851) { __label__ = 190; break; } else { __label__ = 236; break; }
    case 190: // $852
      var $853=$str_size11;
      var $854=_strtol($853, 0, 0);
      $length12=$854;
      var $855=$str_offset;
      var $856=_strtol($855, 0, 0);
      $offset=$856;
      var $857=$str_loadflag;
      var $858=(($857)|0)!=0;
      if ($858) { __label__ = 191; break; } else { __label__ = 193; break; }
    case 191: // $859
      var $860=$str_loadflag;
      var $861=_strcmp($860, ((STRING_TABLE.__str561724)|0));
      var $862=(($861)|0)!=0;
      if ($862) { __label__ = 193; break; } else { __label__ = 192; break; }
    case 192: // $863
      var $864=$swlist;
      var $865=$offset;
      var $866=$length12;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($864, 0, 0, $865, $866, 131);
      __label__ = 235; break;
    case 193: // $867
      var $868=$str_loadflag;
      var $869=(($868)|0)!=0;
      if ($869) { __label__ = 194; break; } else { __label__ = 196; break; }
    case 194: // $870
      var $871=$str_loadflag;
      var $872=_strcmp($871, ((STRING_TABLE.__str571725)|0));
      var $873=(($872)|0)!=0;
      if ($873) { __label__ = 196; break; } else { __label__ = 195; break; }
    case 195: // $874
      var $875=$swlist;
      var $876=$offset;
      var $877=$length12;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($875, 0, 0, $876, $877, 3);
      __label__ = 234; break;
    case 196: // $878
      var $879=$str_loadflag;
      var $880=(($879)|0)!=0;
      if ($880) { __label__ = 197; break; } else { __label__ = 199; break; }
    case 197: // $881
      var $882=$str_loadflag;
      var $883=_strcmp($882, ((STRING_TABLE.__str581726)|0));
      var $884=(($883)|0)!=0;
      if ($884) { __label__ = 199; break; } else { __label__ = 198; break; }
    case 198: // $885
      var $886=$swlist;
      var $887=$offset;
      var $888=$length12;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($886, 0, 0, $887, $888, 132);
      __label__ = 233; break;
    case 199: // $889
      var $890=$str_loadflag;
      var $891=(($890)|0)!=0;
      if ($891) { __label__ = 200; break; } else { __label__ = 202; break; }
    case 200: // $892
      var $893=$str_loadflag;
      var $894=_strcmp($893, ((STRING_TABLE.__str591727)|0));
      var $895=(($894)|0)!=0;
      if ($895) { __label__ = 202; break; } else { __label__ = 201; break; }
    case 201: // $896
      var $897=$swlist;
      var $898=$str_value;
      var $899=_atoi($898);
      var $900=$899;
      var $901=$offset;
      var $902=$length12;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($897, 0, $900, $901, $902, 5);
      __label__ = 232; break;
    case 202: // $903
      var $904=$str_name10;
      var $905=(($904)|0)!=0;
      if ($905) { __label__ = 203; break; } else { __label__ = 231; break; }
    case 203: // $906
      var $907=$str_crc;
      var $908=(($907)|0)!=0;
      if ($908) { __label__ = 204; break; } else { __label__ = 231; break; }
    case 204: // $909
      var $910=$str_sha1;
      var $911=(($910)|0)!=0;
      if ($911) { __label__ = 205; break; } else { __label__ = 231; break; }
    case 205: // $912
      var $913=$swlist;
      var $914=(($913+4)|0);
      var $915=HEAP32[(($914)>>2)];
      var $916=$str_name10;
      var $917=_strlen($916);
      var $918=(($917+1)|0);
      var $919=(($918)|0);
      var $920=__Z21pool_malloc_file_lineP12_object_pooljPKci($915, $919, ((STRING_TABLE.__str11667)|0), 718);
      $s_name=$920;
      var $921=$swlist;
      var $922=(($921+4)|0);
      var $923=HEAP32[(($922)>>2)];
      var $924=$str_crc;
      var $925=_strlen($924);
      var $926=$str_sha1;
      var $927=_strlen($926);
      var $928=(($925+$927)|0);
      var $929=(($928+7)|0);
      var $930=(($929+4)|0);
      var $931=(($930)|0);
      var $932=__Z21pool_malloc_file_lineP12_object_pooljPKci($923, $931, ((STRING_TABLE.__str11667)|0), 719);
      $hashdata=$932;
      var $933=$str_status;
      var $934=(($933)|0)!=0;
      if ($934) { __label__ = 206; break; } else { var $941 = 0;__label__ = 207; break; }
    case 206: // $935
      var $936=$str_status;
      var $937=_strcmp($936, ((STRING_TABLE.__str601728)|0));
      var $938=(($937)|0)!=0;
      var $939=$938 ^ 1;
      var $941 = $939;__label__ = 207; break;
    case 207: // $940
      var $941;
      var $942=$941 ? 1 : 0;
      $baddump=$942;
      var $943=$str_status;
      var $944=(($943)|0)!=0;
      if ($944) { __label__ = 208; break; } else { var $951 = 0;__label__ = 209; break; }
    case 208: // $945
      var $946=$str_status;
      var $947=_strcmp($946, ((STRING_TABLE.__str611729)|0));
      var $948=(($947)|0)!=0;
      var $949=$948 ^ 1;
      var $951 = $949;__label__ = 209; break;
    case 209: // $950
      var $951;
      var $952=$951 ? 1 : 0;
      $nodump=$952;
      $romflags=0;
      var $953=$s_name;
      var $954=(($953)|0)!=0;
      if ($954) { __label__ = 210; break; } else { __label__ = 211; break; }
    case 210: // $955
      var $956=$hashdata;
      var $957=(($956)|0)!=0;
      if ($957) { __label__ = 212; break; } else { __label__ = 211; break; }
    case 211: // $958
      __label__ = 274; break;
    case 212: // $959
      var $960=$s_name;
      var $961=$str_name10;
      var $962=_strcpy($960, $961);
      var $963=$hashdata;
      var $964=$str_crc;
      var $965=$str_sha1;
      var $966=$nodump;
      var $967=(($966)|0)!=0;
      if ($967) { __label__ = 213; break; } else { __label__ = 214; break; }
    case 213: // $968
      var $974 = ((STRING_TABLE.__str631731)|0);__label__ = 215; break;
    case 214: // $969
      var $970=$baddump;
      var $971=(($970)|0)!=0;
      var $972=$971 ? (((STRING_TABLE.__str641732)|0)) : (((__str651733)|0));
      var $974 = $972;__label__ = 215; break;
    case 215: // $973
      var $974;
      var $975=_sprintf($963, ((STRING_TABLE.__str621730)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=82,HEAP32[((tempInt+4)>>2)]=$964,HEAP32[((tempInt+8)>>2)]=83,HEAP32[((tempInt+12)>>2)]=$965,HEAP32[((tempInt+16)>>2)]=$974,tempInt));
      var $976=$str_loadflag;
      var $977=(($976)|0)!=0;
      if ($977) { __label__ = 216; break; } else { __label__ = 218; break; }
    case 216: // $978
      var $979=$str_loadflag;
      var $980=_strcmp($979, ((STRING_TABLE.__str661734)|0));
      var $981=(($980)|0)!=0;
      if ($981) { __label__ = 218; break; } else { __label__ = 217; break; }
    case 217: // $982
      $romflags=320;
      __label__ = 230; break;
    case 218: // $983
      var $984=$str_loadflag;
      var $985=(($984)|0)!=0;
      if ($985) { __label__ = 219; break; } else { __label__ = 221; break; }
    case 219: // $986
      var $987=$str_loadflag;
      var $988=_strcmp($987, ((STRING_TABLE.__str671735)|0));
      var $989=(($988)|0)!=0;
      if ($989) { __label__ = 221; break; } else { __label__ = 220; break; }
    case 220: // $990
      $romflags=4096;
      __label__ = 229; break;
    case 221: // $991
      var $992=$str_loadflag;
      var $993=(($992)|0)!=0;
      if ($993) { __label__ = 222; break; } else { __label__ = 224; break; }
    case 222: // $994
      var $995=$str_loadflag;
      var $996=_strcmp($995, ((STRING_TABLE.__str681736)|0));
      var $997=(($996)|0)!=0;
      if ($997) { __label__ = 224; break; } else { __label__ = 223; break; }
    case 223: // $998
      $romflags=8512;
      __label__ = 228; break;
    case 224: // $999
      var $1000=$str_loadflag;
      var $1001=(($1000)|0)!=0;
      if ($1001) { __label__ = 225; break; } else { __label__ = 227; break; }
    case 225: // $1002
      var $1003=$str_loadflag;
      var $1004=_strcmp($1003, ((STRING_TABLE.__str691737)|0));
      var $1005=(($1004)|0)!=0;
      if ($1005) { __label__ = 227; break; } else { __label__ = 226; break; }
    case 226: // $1006
      $romflags=8448;
      __label__ = 227; break;
    case 227: // $1007
      __label__ = 228; break;
    case 228: // $1008
      __label__ = 229; break;
    case 229: // $1009
      __label__ = 230; break;
    case 230: // $1010
      var $1011=$swlist;
      var $1012=$s_name;
      var $1013=$hashdata;
      var $1014=$offset;
      var $1015=$length12;
      var $1016=$romflags;
      var $1017=0 | $1016;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($1011, $1012, $1013, $1014, $1015, $1017);
      __label__ = 231; break;
    case 231: // $1018
      __label__ = 232; break;
    case 232: // $1019
      __label__ = 233; break;
    case 233: // $1020
      __label__ = 234; break;
    case 234: // $1021
      __label__ = 235; break;
    case 235: // $1022
      __label__ = 236; break;
    case 236: // $1023
      __label__ = 238; break;
    case 237: // $1024
      __label__ = 238; break;
    case 238: // $1025
      __label__ = 272; break;
    case 239: // $1026
      var $1027=$2;
      var $1028=_strcmp($1027, ((STRING_TABLE.__str701738)|0));
      var $1029=(($1028)|0)!=0;
      if ($1029) { __label__ = 270; break; } else { __label__ = 240; break; }
    case 240: // $1030
      $str_name13=0;
      $str_sha114=0;
      $str_status15=0;
      $str_writeable=0;
      __label__ = 241; break;
    case 241: // $1031
      var $1032=$3;
      var $1033=(($1032)|0);
      var $1034=HEAP32[(($1033)>>2)];
      var $1035=(($1034)|0)!=0;
      if ($1035) { __label__ = 242; break; } else { __label__ = 252; break; }
    case 242: // $1036
      var $1037=$3;
      var $1038=(($1037)|0);
      var $1039=HEAP32[(($1038)>>2)];
      var $1040=_strcmp($1039, ((STRING_TABLE.__str331701)|0));
      var $1041=(($1040)|0)!=0;
      if ($1041) { __label__ = 244; break; } else { __label__ = 243; break; }
    case 243: // $1042
      var $1043=$3;
      var $1044=(($1043+4)|0);
      var $1045=HEAP32[(($1044)>>2)];
      $str_name13=$1045;
      __label__ = 244; break;
    case 244: // $1046
      var $1047=$3;
      var $1048=(($1047)|0);
      var $1049=HEAP32[(($1048)>>2)];
      var $1050=_strcmp($1049, ((STRING_TABLE.__str521720)|0));
      var $1051=(($1050)|0)!=0;
      if ($1051) { __label__ = 246; break; } else { __label__ = 245; break; }
    case 245: // $1052
      var $1053=$3;
      var $1054=(($1053+4)|0);
      var $1055=HEAP32[(($1054)>>2)];
      $str_sha114=$1055;
      __label__ = 246; break;
    case 246: // $1056
      var $1057=$3;
      var $1058=(($1057)|0);
      var $1059=HEAP32[(($1058)>>2)];
      var $1060=_strcmp($1059, ((STRING_TABLE.__str541722)|0));
      var $1061=(($1060)|0)!=0;
      if ($1061) { __label__ = 248; break; } else { __label__ = 247; break; }
    case 247: // $1062
      var $1063=$3;
      var $1064=(($1063+4)|0);
      var $1065=HEAP32[(($1064)>>2)];
      $str_status15=$1065;
      __label__ = 248; break;
    case 248: // $1066
      var $1067=$3;
      var $1068=(($1067)|0);
      var $1069=HEAP32[(($1068)>>2)];
      var $1070=_strcmp($1069, ((STRING_TABLE.__str711739)|0));
      var $1071=(($1070)|0)!=0;
      if ($1071) { __label__ = 250; break; } else { __label__ = 249; break; }
    case 249: // $1072
      var $1073=$3;
      var $1074=(($1073+4)|0);
      var $1075=HEAP32[(($1074)>>2)];
      $str_writeable=$1075;
      __label__ = 250; break;
    case 250: // $1076
      __label__ = 251; break;
    case 251: // $1077
      var $1078=$3;
      var $1079=(($1078+8)|0);
      $3=$1079;
      __label__ = 241; break;
    case 252: // $1080
      var $1081=$swlist;
      var $1082=(($1081+44)|0);
      var $1083=HEAP32[(($1082)>>2)];
      var $1084=(($1083)|0)!=0;
      if ($1084) { __label__ = 253; break; } else { __label__ = 269; break; }
    case 253: // $1085
      var $1086=$str_name13;
      var $1087=(($1086)|0)!=0;
      if ($1087) { __label__ = 254; break; } else { __label__ = 268; break; }
    case 254: // $1088
      var $1089=$str_sha114;
      var $1090=(($1089)|0)!=0;
      if ($1090) { __label__ = 255; break; } else { __label__ = 268; break; }
    case 255: // $1091
      var $1092=$swlist;
      var $1093=(($1092+4)|0);
      var $1094=HEAP32[(($1093)>>2)];
      var $1095=$str_name13;
      var $1096=_strlen($1095);
      var $1097=(($1096+1)|0);
      var $1098=(($1097)|0);
      var $1099=__Z21pool_malloc_file_lineP12_object_pooljPKci($1094, $1098, ((STRING_TABLE.__str11667)|0), 774);
      $s_name16=$1099;
      var $1100=$swlist;
      var $1101=(($1100+4)|0);
      var $1102=HEAP32[(($1101)>>2)];
      var $1103=$str_sha114;
      var $1104=_strlen($1103);
      var $1105=(($1104+7)|0);
      var $1106=(($1105+4)|0);
      var $1107=(($1106)|0);
      var $1108=__Z21pool_malloc_file_lineP12_object_pooljPKci($1102, $1107, ((STRING_TABLE.__str11667)|0), 775);
      $hashdata17=$1108;
      var $1109=$str_status15;
      var $1110=(($1109)|0)!=0;
      if ($1110) { __label__ = 256; break; } else { var $1117 = 0;__label__ = 257; break; }
    case 256: // $1111
      var $1112=$str_status15;
      var $1113=_strcmp($1112, ((STRING_TABLE.__str601728)|0));
      var $1114=(($1113)|0)!=0;
      var $1115=$1114 ^ 1;
      var $1117 = $1115;__label__ = 257; break;
    case 257: // $1116
      var $1117;
      var $1118=$1117 ? 1 : 0;
      $baddump18=$1118;
      var $1119=$str_status15;
      var $1120=(($1119)|0)!=0;
      if ($1120) { __label__ = 258; break; } else { var $1127 = 0;__label__ = 259; break; }
    case 258: // $1121
      var $1122=$str_status15;
      var $1123=_strcmp($1122, ((STRING_TABLE.__str611729)|0));
      var $1124=(($1123)|0)!=0;
      var $1125=$1124 ^ 1;
      var $1127 = $1125;__label__ = 259; break;
    case 259: // $1126
      var $1127;
      var $1128=$1127 ? 1 : 0;
      $nodump19=$1128;
      var $1129=$str_writeable;
      var $1130=(($1129)|0)!=0;
      if ($1130) { __label__ = 260; break; } else { var $1137 = 0;__label__ = 261; break; }
    case 260: // $1131
      var $1132=$str_writeable;
      var $1133=_strcmp($1132, ((STRING_TABLE.__str721740)|0));
      var $1134=(($1133)|0)!=0;
      var $1135=$1134 ^ 1;
      var $1137 = $1135;__label__ = 261; break;
    case 261: // $1136
      var $1137;
      var $1138=$1137 ? 1 : 0;
      $writeable=$1138;
      var $1139=$s_name16;
      var $1140=(($1139)|0)!=0;
      if ($1140) { __label__ = 262; break; } else { __label__ = 263; break; }
    case 262: // $1141
      var $1142=$hashdata17;
      var $1143=(($1142)|0)!=0;
      if ($1143) { __label__ = 264; break; } else { __label__ = 263; break; }
    case 263: // $1144
      __label__ = 274; break;
    case 264: // $1145
      var $1146=$s_name16;
      var $1147=$str_name13;
      var $1148=_strcpy($1146, $1147);
      var $1149=$hashdata17;
      var $1150=$str_sha114;
      var $1151=$nodump19;
      var $1152=(($1151)|0)!=0;
      if ($1152) { __label__ = 265; break; } else { __label__ = 266; break; }
    case 265: // $1153
      var $1159 = ((STRING_TABLE.__str631731)|0);__label__ = 267; break;
    case 266: // $1154
      var $1155=$baddump18;
      var $1156=(($1155)|0)!=0;
      var $1157=$1156 ? (((STRING_TABLE.__str641732)|0)) : (((__str651733)|0));
      var $1159 = $1157;__label__ = 267; break;
    case 267: // $1158
      var $1159;
      var $1160=_sprintf($1149, ((STRING_TABLE.__str731741)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=83,HEAP32[((tempInt+4)>>2)]=$1150,HEAP32[((tempInt+8)>>2)]=$1159,tempInt));
      var $1161=$swlist;
      var $1162=$s_name16;
      var $1163=$hashdata17;
      var $1164=$writeable;
      var $1165=(($1164)|0)!=0;
      var $1166=$1165 ? 0 : 16;
      var $1167=0 | $1166;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($1161, $1162, $1163, 0, 0, $1167);
      __label__ = 268; break;
    case 268: // $1168
      __label__ = 269; break;
    case 269: // $1169
      __label__ = 271; break;
    case 270: // $1170
      var $1171=$swlist;
      var $1172=(($1171+8)|0);
      var $1173=$2;
      __ZL11unknown_tagP12_parse_statePKc($1172, $1173);
      __label__ = 271; break;
    case 271: // $1174
      __label__ = 272; break;
    case 272: // $1175
      __label__ = 273; break;
    case 273: // $1176
      var $1177=$swlist;
      var $1178=(($1177+8)|0);
      var $1179=(($1178+16)|0);
      var $1180=HEAP32[(($1179)>>2)];
      var $1181=(($1180+1)|0);
      var $1182=$swlist;
      var $1183=(($1182+8)|0);
      var $1184=(($1183+16)|0);
      HEAP32[(($1184)>>2)]=$1181;
      __label__ = 274; break;
    case 274: // $1185
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13start_handlerPvPKcPS1_["X"]=1;

function __Z29software_list_get_descriptionP14_software_list($swlist) {
  ;
  var __label__;

  var $1;
  $1=$swlist;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL11end_handlerPvPKc($data, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $swlist;
      var $list;
      $1=$data;
      $2=$name;
      var $3=$1;
      var $4=$3;
      $swlist=$4;
      var $5=$swlist;
      var $6=(($5+8)|0);
      var $7=(($6+20)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=$swlist;
      var $9=(($8+8)|0);
      var $10=(($9+16)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11-1)|0);
      var $13=$swlist;
      var $14=(($13+8)|0);
      var $15=(($14+16)|0);
      HEAP32[(($15)>>2)]=$12;
      var $16=$swlist;
      var $17=(($16+8)|0);
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      if ($19 == 0 || $19 == 4) {
        __label__ = 15; break;
      }
      else if ($19 == 2) {
        __label__ = 1; break;
      }
      else if ($19 == 1) {
        __label__ = 5; break;
      }
      else if ($19 == 3) {
        __label__ = 8; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 1: // $20
      var $21=$2;
      var $22=_strcmp($21, ((STRING_TABLE.__str311699)|0));
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $24
      var $25=$swlist;
      var $26=(($25+44)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$swlist;
      __ZL13add_rom_entryP14_software_listPKcS2_jjj($30, 0, 0, 0, 0, 2);
      __label__ = 4; break;
    case 4: // $31
      __label__ = 15; break;
    case 5: // $32
      var $33=$swlist;
      var $34=(($33+44)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$swlist;
      __ZL17add_software_partP14_software_listPKcS2_($38, 0, 0);
      __label__ = 7; break;
    case 7: // $39
      __label__ = 15; break;
    case 8: // $40
      var $41=$swlist;
      var $42=(($41+44)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $45
      var $46=$swlist;
      var $47=(($46+44)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+24)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $52
      var $53=$swlist;
      var $54=(($53+44)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+24)|0);
      var $57=HEAP32[(($56)>>2)];
      $list=$57;
      __label__ = 11; break;
    case 11: // $58
      var $59=$list;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $63
      var $64=$swlist;
      var $65=$list;
      var $66=(($65)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+4)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$list;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      __ZL11add_featureP14_software_listPcS1_($64, $69, $74);
      var $75=$list;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      $list=$77;
      __label__ = 11; break;
    case 13: // $78
      __label__ = 14; break;
    case 14: // $79
      __label__ = 15; break;
    case 15: // $80
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11end_handlerPvPKc["X"]=1;

function __ZL12data_handlerPvPKci($data, $s, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $swlist;
      var $text_len;
      var $text;
      $1=$data;
      $2=$s;
      $3=$len;
      var $4=$1;
      var $5=$4;
      $swlist=$5;
      var $6=$swlist;
      var $7=(($6+8)|0);
      var $8=(($7+20)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $11
      var $12=$swlist;
      var $13=(($12+8)|0);
      var $14=(($13+20)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=HEAP32[(($15)>>2)];
      $text=$16;
      var $17=$text;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      var $20=$text;
      var $21=_strlen($20);
      var $24 = $21;__label__ = 4; break;
    case 3: // $22
      var $24 = 0;__label__ = 4; break;
    case 4: // $23
      var $24;
      $text_len=$24;
      var $25=$swlist;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$text;
      var $29=$text_len;
      var $30=$3;
      var $31=(($29+$30)|0);
      var $32=(($31+1)|0);
      var $33=__Z22pool_realloc_file_lineP12_object_poolPvjPKci($27, $28, $32, ((STRING_TABLE.__str11667)|0), 862);
      $text=$33;
      var $34=$text;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $36
      __label__ = 7; break;
    case 6: // $37
      var $38=$text_len;
      var $39=$text;
      var $40=(($39+$38)|0);
      var $41=$2;
      var $42=$3;
      assert($42 % 1 === 0, 'memcpy given ' + $42 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($40, $41, $42, 1);
      var $43=$text_len;
      var $44=$3;
      var $45=(($43+$44)|0);
      var $46=$text;
      var $47=(($46+$45)|0);
      HEAP8[($47)]=0;
      var $48=$text;
      var $49=$swlist;
      var $50=(($49+8)|0);
      var $51=(($50+20)|0);
      var $52=HEAP32[(($51)>>2)];
      HEAP32[(($52)>>2)]=$48;
      __label__ = 7; break;
    case 7: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12data_handlerPvPKci["X"]=1;

function __ZL11parse_errorP12_parse_statePKcz($state, $fmt) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $buf=__stackBase__;
      var $va=__stackBase__+256;
      $1=$state;
      $2=$fmt;
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$va;
      HEAP32[(($8)>>2)]=arguments[__ZL11parse_errorP12_parse_statePKcz.length];
      var $9=(($buf)|0);
      var $10=$2;
      var $11=HEAP32[(($va)>>2)];
      var $12=_vsnprintf($9, 256, $10, $11);
      var $13=$va;
      ;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($buf)|0);
      FUNCTION_TABLE[$16]($17);
      __label__ = 2; break;
    case 2: // $18
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23software_list_get_countP14_software_list($swlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $count;
      var $swinfo;
      $1=$swlist;
      $count=0;
      var $2=$1;
      var $3=__Z18software_list_findP14_software_listPKcP13software_info($2, ((STRING_TABLE.__str31669)|0), 0);
      $swinfo=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$swinfo;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $7
      var $8=$count;
      var $9=(($8+1)|0);
      $count=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$1;
      var $12=$swinfo;
      var $13=__Z18software_list_findP14_software_listPKcP13software_info($11, ((STRING_TABLE.__str31669)|0), $12);
      $swinfo=$13;
      __label__ = 1; break;
    case 4: // $14
      var $15=$count;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options9hash_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str301698)|0));
  ;
  return $4;
}


function __Z18software_find_partP13software_infoPKcS2_($sw, $partname, $interface) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $part;
      $1=$sw;
      $2=$partname;
      $3=$interface;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+32)|0);
      var $9=HEAP32[(($8)>>2)];
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      $part=$12;
      var $13=$2;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $15
      var $16=$3;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 5; break; } else { __label__ = 25; break; }
    case 5: // $18
      __label__ = 6; break;
    case 6: // $19
      var $20=$part;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 7; break; } else { var $28 = 0;__label__ = 8; break; }
    case 7: // $22
      var $23=$part;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      var $28 = $26;__label__ = 8; break;
    case 8: // $27
      var $28;
      if ($28) { __label__ = 9; break; } else { __label__ = 24; break; }
    case 9: // $29
      var $30=$2;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 10; break; } else { __label__ = 18; break; }
    case 10: // $32
      var $33=$2;
      var $34=$part;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=_strcmp($33, $36);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 17; break; } else { __label__ = 11; break; }
    case 11: // $39
      var $40=$3;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $42
      var $43=$3;
      var $44=$part;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=_strcmp($43, $46);
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $49
      __label__ = 24; break;
    case 14: // $50
      __label__ = 16; break;
    case 15: // $51
      __label__ = 24; break;
    case 16: // $52
      __label__ = 17; break;
    case 17: // $53
      __label__ = 23; break;
    case 18: // $54
      var $55=$3;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $57
      var $58=$3;
      var $59=$part;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=_strcmp($58, $61);
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $64
      __label__ = 24; break;
    case 21: // $65
      __label__ = 22; break;
    case 22: // $66
      __label__ = 23; break;
    case 23: // $67
      var $68=$part;
      var $69=(($68+16)|0);
      $part=$69;
      __label__ = 6; break;
    case 24: // $70
      __label__ = 25; break;
    case 25: // $71
      var $72=$part;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $76
      $part=0;
      __label__ = 27; break;
    case 27: // $77
      var $78=$part;
      ;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18software_find_partP13software_infoPKcS2_["X"]=1;

function __Z33software_list_find_approx_matchesP14_software_listPKciPP13software_infoS2_($swlist, $name, $matches, $list, $interface) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $matchnum;
      var $penalty;
      var $swinfo;
      var $curpenalty;
      var $tmp;
      var $candidate;
      var $part;
      $6=$swlist;
      $7=$name;
      $8=$matches;
      $9=$list;
      $10=$interface;
      var $11=$7;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$7;
      var $15=(($14)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      __label__ = 30; break;
    case 3: // $20
      var $21=$8;
      var $22=_llvm_umul_with_overflow_i32($21, 4);
      var $23=$22.f1;
      var $24=$22.f0;
      var $25=$23 ? -1 : $24;
      var $26=$1;
      var $27=$2;
      var $28=$3;
      var $29=$result_i;
      var $30=$4;
      var $31=$5;
      HEAP32[(($1)>>2)]=$25;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($3)>>2)]=1129;
      var $32=HEAP32[(($1)>>2)];
      var $33=HEAP32[(($2)>>2)];
      var $34=HEAP32[(($3)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($4)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($5)>>2)]=$45;
      var $46=HEAP32[(($5)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $48
      var $49=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($49);
      throw "Reached an unreachable!"
    case 8: // $50
      var $51=HEAP32[(($4)>>2)];
      var $52=HEAP32[(($4)>>2)];
      var $53=HEAP32[(($5)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $56
      throw "Reached an unreachable!"
    case 10: // $_ZnajPKci_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$1;
      var $59=$2;
      var $60=$3;
      var $61=$result_i;
      var $62=$4;
      var $63=$5;
      var $64=$57;
      var $65=$8;
      var $66=__ZN13resource_pool9add_arrayIiEEPT_S2_i(_global_resource_pool, $64, $65);
      $penalty=$66;
      $matchnum=0;
      __label__ = 11; break;
    case 11: // $67
      var $68=$matchnum;
      var $69=$8;
      var $70=(($68)|0) < (($69)|0);
      if ($70) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $71
      var $72=$matchnum;
      var $73=$penalty;
      var $74=(($73+($72<<2))|0);
      HEAP32[(($74)>>2)]=9999;
      var $75=$matchnum;
      var $76=$9;
      var $77=(($76+($75<<2))|0);
      HEAP32[(($77)>>2)]=0;
      __label__ = 13; break;
    case 13: // $78
      var $79=$matchnum;
      var $80=(($79+1)|0);
      $matchnum=$80;
      __label__ = 11; break;
    case 14: // $81
      var $82=$6;
      var $83=__Z18software_list_findP14_software_listPKcP13software_info($82, ((STRING_TABLE.__str31669)|0), 0);
      $swinfo=$83;
      __label__ = 15; break;
    case 15: // $84
      var $85=$swinfo;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 16; break; } else { __label__ = 29; break; }
    case 16: // $87
      var $88=$swinfo;
      $candidate=$88;
      var $89=$swinfo;
      var $90=__Z18software_find_partP13software_infoPKcS2_($89, 0, 0);
      $part=$90;
      var $91=$10;
      var $92=(($91)|0)==0;
      if ($92) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $93
      var $94=$10;
      var $95=$part;
      var $96=(($95+4)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=_strcmp($94, $97);
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 27; break; } else { __label__ = 18; break; }
    case 18: // $100
      var $101=$7;
      var $102=$candidate;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=__ZL24softlist_penalty_comparePKcS0_($101, $104);
      $curpenalty=$105;
      var $106=$7;
      var $107=$candidate;
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=__ZL24softlist_penalty_comparePKcS0_($106, $109);
      $tmp=$110;
      var $111=$curpenalty;
      var $112=$tmp;
      var $113=(($111)|0) < (($112)|0);
      var $114=$curpenalty;
      var $115=$tmp;
      var $116=$113 ? $114 : $115;
      $curpenalty=$116;
      var $117=$8;
      var $118=(($117-1)|0);
      $matchnum=$118;
      __label__ = 19; break;
    case 19: // $119
      var $120=$matchnum;
      var $121=(($120)|0) >= 0;
      if ($121) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $122
      var $123=$curpenalty;
      var $124=$matchnum;
      var $125=$penalty;
      var $126=(($125+($124<<2))|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($123)|0) >= (($127)|0);
      if ($128) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $129
      __label__ = 26; break;
    case 22: // $130
      var $131=$matchnum;
      var $132=$8;
      var $133=(($132-1)|0);
      var $134=(($131)|0) < (($133)|0);
      if ($134) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $135
      var $136=$matchnum;
      var $137=$penalty;
      var $138=(($137+($136<<2))|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=$matchnum;
      var $141=(($140+1)|0);
      var $142=$penalty;
      var $143=(($142+($141<<2))|0);
      HEAP32[(($143)>>2)]=$139;
      var $144=$matchnum;
      var $145=$9;
      var $146=(($145+($144<<2))|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$matchnum;
      var $149=(($148+1)|0);
      var $150=$9;
      var $151=(($150+($149<<2))|0);
      HEAP32[(($151)>>2)]=$147;
      __label__ = 24; break;
    case 24: // $152
      var $153=$candidate;
      var $154=$matchnum;
      var $155=$9;
      var $156=(($155+($154<<2))|0);
      HEAP32[(($156)>>2)]=$153;
      var $157=$curpenalty;
      var $158=$matchnum;
      var $159=$penalty;
      var $160=(($159+($158<<2))|0);
      HEAP32[(($160)>>2)]=$157;
      __label__ = 25; break;
    case 25: // $161
      var $162=$matchnum;
      var $163=(($162-1)|0);
      $matchnum=$163;
      __label__ = 19; break;
    case 26: // $164
      __label__ = 27; break;
    case 27: // $165
      __label__ = 28; break;
    case 28: // $166
      var $167=$6;
      var $168=$swinfo;
      var $169=__Z18software_list_findP14_software_listPKcP13software_info($167, ((STRING_TABLE.__str31669)|0), $168);
      $swinfo=$169;
      __label__ = 15; break;
    case 29: // $170
      var $171=$penalty;
      var $172=$171;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $172);
      __label__ = 30; break;
    case 30: // $173
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z33software_list_find_approx_matchesP14_software_listPKciPP13software_infoS2_["X"]=1;

function __ZN13resource_pool9add_arrayIiEEPT_S2_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIiEC1EPii($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIiEEPT_S2_i["X"]=1;

function __Z8downcastIPK18legacy_device_base8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18software_part_nextP13software_part($part) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$part;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10+16)|0);
      $1=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $17
      $1=0;
      __label__ = 5; break;
    case 5: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t8typenextEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cur;
      $1=$this;
      var $2=$1;
      var $3=(($2+20)|0);
      var $4=HEAP32[(($3)>>2)];
      $cur=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$cur;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { var $16 = 0;__label__ = 3; break; }
    case 2: // $8
      var $9=$cur;
      var $10=(($9+32)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($2+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($11)|0)!=(($13)|0);
      var $16 = $14;__label__ = 3; break;
    case 3: // $15
      var $16;
      if ($16) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$cur;
      var $20=(($19+20)|0);
      var $21=HEAP32[(($20)>>2)];
      $cur=$21;
      __label__ = 1; break;
    case 6: // $22
      var $23=$cur;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL24softlist_penalty_comparePKcS0_($source, $target) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $gaps;
      var $last;
      var $match;
      $1=$source;
      $2=$target;
      $gaps=1;
      $last=1;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 2; break; } else { var $12 = 0;__label__ = 3; break; }
    case 2: // $7
      var $8=$2;
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24)!=0;
      var $12 = $10;__label__ = 3; break;
    case 3: // $11
      var $12;
      if ($12) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $13
      var $14=$1;
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=_tolower($16);
      var $18=$2;
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=_tolower($20);
      var $22=(($17)|0)==(($21)|0);
      var $23=(($22)&1);
      $match=$23;
      var $24=$match;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$1;
      var $28=(($27+1)|0);
      $1=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$match;
      var $31=$last;
      var $32=(($30)|0)!=(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $33
      var $34=$match;
      $last=$34;
      var $35=$match;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $37
      var $38=$gaps;
      var $39=(($38+1)|0);
      $gaps=$39;
      __label__ = 9; break;
    case 9: // $40
      __label__ = 10; break;
    case 10: // $41
      __label__ = 11; break;
    case 11: // $42
      var $43=$2;
      var $44=(($43+1)|0);
      $2=$44;
      __label__ = 1; break;
    case 12: // $45
      __label__ = 13; break;
    case 13: // $46
      var $47=$1;
      var $48=HEAP8[($47)];
      var $49=(($48 << 24) >> 24)!=0;
      if ($49) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $50
      var $51=$gaps;
      var $52=(($51+1)|0);
      $gaps=$52;
      __label__ = 15; break;
    case 15: // $53
      var $54=$1;
      var $55=(($54+1)|0);
      $1=$55;
      __label__ = 13; break;
    case 16: // $56
      var $57=$gaps;
      var $58=(($57)|0)==1;
      if ($58) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $59
      var $60=$1;
      var $61=HEAP8[($60)];
      var $62=(($61 << 24) >> 24);
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $64
      var $65=$2;
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $69
      $gaps=0;
      __label__ = 20; break;
    case 20: // $70
      var $71=$gaps;
      ;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24softlist_penalty_comparePKcS0_["X"]=1;

function __Z24software_display_matchesRK11device_listR11emu_optionsPKcS5_($devlist, $options, $interface, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $swlists;
      var $swlist;
      var $i;
      var $list;
      var $matches=__stackBase__;
      var $softnum;
      $1=$devlist;
      $2=$options;
      $3=$interface;
      $4=$name;
      var $5=$1;
      var $6=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $7=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($5, $6);
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$4;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str41672)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,tempInt));
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $14=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($12, $13);
      $swlists=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$swlists;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 26; break; }
    case 4: // $18
      var $19=$swlists;
      var $20=__Z8downcastIPK18legacy_device_base8device_tET_PT0_($19);
      var $21=__ZNK18legacy_device_base13inline_configEv($20);
      var $22=$21;
      $swlist=$22;
      $i=0;
      __label__ = 5; break;
    case 5: // $23
      var $24=$i;
      var $25=(($24)|0) < 9;
      if ($25) { __label__ = 6; break; } else { __label__ = 24; break; }
    case 6: // $26
      var $27=$i;
      var $28=$swlist;
      var $29=(($28)|0);
      var $30=(($29+($27<<2))|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 22; break; }
    case 7: // $33
      var $34=$i;
      var $35=$swlist;
      var $36=(($35)|0);
      var $37=(($36+($34<<2))|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=HEAP8[($38)];
      var $40=(($39 << 24) >> 24)!=0;
      if ($40) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $41
      var $42=$2;
      var $43=$i;
      var $44=$swlist;
      var $45=(($44)|0);
      var $46=(($45+($43<<2))|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=__Z18software_list_openR11emu_optionsPKciPFvS2_E($42, $47, 0, 0);
      $list=$48;
      var $49=$list;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 9; break; } else { __label__ = 21; break; }
    case 9: // $51
      var $52=$matches;
      for (var $$dest = $52>>2, $$stop = $$dest + 10; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      var $53=$list;
      var $54=$list;
      var $55=(($54+68)|0);
      var $56=HEAP32[(($55)>>2)];
      __Z19software_list_parseP14_software_listPFvPKcEPv($53, $56, 0);
      var $57=$list;
      var $58=$4;
      var $59=(($matches)|0);
      var $60=$3;
      __Z33software_list_find_approx_matchesP14_software_listPKciPP13software_infoS2_($57, $58, 10, $59, $60);
      var $61=(($matches)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 10; break; } else { __label__ = 20; break; }
    case 10: // $64
      var $65=$swlist;
      var $66=(($65+40)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $69
      var $70=$i;
      var $71=$swlist;
      var $72=(($71)|0);
      var $73=(($72+($70<<2))|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$list;
      var $76=__Z29software_list_get_descriptionP14_software_list($75);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str51673)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,HEAP32[((tempInt+4)>>2)]=$76,tempInt));
      __label__ = 13; break;
    case 12: // $77
      var $78=$i;
      var $79=$swlist;
      var $80=(($79)|0);
      var $81=(($80+($78<<2))|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$list;
      var $84=__Z29software_list_get_descriptionP14_software_list($83);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str61674)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,HEAP32[((tempInt+4)>>2)]=$84,tempInt));
      __label__ = 13; break;
    case 13: // $85
      $softnum=0;
      __label__ = 14; break;
    case 14: // $86
      var $87=$softnum;
      var $88=(($87)>>>0) < 10;
      if ($88) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $89
      var $90=$softnum;
      var $91=(($matches+($90<<2))|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $94
      var $95=$softnum;
      var $96=(($matches+($95<<2))|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$softnum;
      var $101=(($matches+($100<<2))|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str71675)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$99,HEAP32[((tempInt+4)>>2)]=$104,tempInt));
      __label__ = 17; break;
    case 17: // $105
      __label__ = 18; break;
    case 18: // $106
      var $107=$softnum;
      var $108=(($107+1)|0);
      $softnum=$108;
      __label__ = 14; break;
    case 19: // $109
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str81676)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 20; break;
    case 20: // $110
      var $111=$list;
      __Z19software_list_closeP14_software_list($111);
      __label__ = 21; break;
    case 21: // $112
      __label__ = 22; break;
    case 22: // $113
      __label__ = 23; break;
    case 23: // $114
      var $115=$i;
      var $116=(($115+1)|0);
      $i=$116;
      __label__ = 5; break;
    case 24: // $117
      __label__ = 25; break;
    case 25: // $118
      var $119=$swlists;
      var $120=__ZNK8device_t8typenextEv($119);
      $swlists=$120;
      __label__ = 3; break;
    case 26: // $121
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z24software_display_matchesRK11device_listR11emu_optionsPKcS5_["X"]=1;

function __Z18load_software_partP22device_image_interfacePKcPP13software_infoPP13software_partPPc($image, $path, $sw_info, $sw_part, $full_sw_name) {
  var __stackBase__  = STACKTOP; STACKTOP += 388; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i26=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i24=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $result_i22=__stackBase__+60;
      var $14=__stackBase__+64;
      var $15=__stackBase__+68;
      var $16=__stackBase__+72;
      var $17=__stackBase__+76;
      var $18=__stackBase__+80;
      var $19=__stackBase__+84;
      var $result_i20=__stackBase__+88;
      var $20=__stackBase__+92;
      var $21=__stackBase__+96;
      var $22=__stackBase__+100;
      var $23=__stackBase__+104;
      var $24=__stackBase__+108;
      var $result_i18=__stackBase__+112;
      var $25=__stackBase__+116;
      var $26=__stackBase__+120;
      var $27=__stackBase__+124;
      var $28=__stackBase__+128;
      var $29=__stackBase__+132;
      var $result_i16=__stackBase__+136;
      var $30=__stackBase__+140;
      var $31=__stackBase__+144;
      var $32=__stackBase__+148;
      var $33=__stackBase__+152;
      var $34=__stackBase__+156;
      var $35=__stackBase__+160;
      var $result_i14=__stackBase__+164;
      var $36=__stackBase__+168;
      var $37=__stackBase__+172;
      var $38=__stackBase__+176;
      var $39=__stackBase__+180;
      var $40=__stackBase__+184;
      var $result_i12=__stackBase__+188;
      var $41=__stackBase__+192;
      var $42=__stackBase__+196;
      var $43=__stackBase__+200;
      var $44=__stackBase__+204;
      var $45=__stackBase__+208;
      var $result_i10=__stackBase__+212;
      var $46=__stackBase__+216;
      var $47=__stackBase__+220;
      var $48=__stackBase__+224;
      var $49=__stackBase__+228;
      var $50=__stackBase__+232;
      var $51=__stackBase__+236;
      var $result_i8=__stackBase__+240;
      var $52=__stackBase__+244;
      var $53=__stackBase__+248;
      var $54=__stackBase__+252;
      var $55=__stackBase__+256;
      var $56=__stackBase__+260;
      var $result_i6=__stackBase__+264;
      var $57=__stackBase__+268;
      var $58=__stackBase__+272;
      var $59=__stackBase__+276;
      var $60=__stackBase__+280;
      var $61=__stackBase__+284;
      var $result_i4=__stackBase__+288;
      var $62=__stackBase__+292;
      var $63=__stackBase__+296;
      var $64=__stackBase__+300;
      var $65=__stackBase__+304;
      var $66=__stackBase__+308;
      var $result_i2=__stackBase__+312;
      var $67=__stackBase__+316;
      var $68=__stackBase__+320;
      var $69=__stackBase__+324;
      var $70=__stackBase__+328;
      var $71=__stackBase__+332;
      var $result_i1=__stackBase__+336;
      var $72=__stackBase__+340;
      var $73=__stackBase__+344;
      var $74=__stackBase__+348;
      var $75=__stackBase__+352;
      var $76=__stackBase__+356;
      var $77=__stackBase__+360;
      var $result_i=__stackBase__+364;
      var $78=__stackBase__+368;
      var $79=__stackBase__+372;
      var $80;
      var $81;
      var $82;
      var $83;
      var $84;
      var $swlist_name=__stackBase__+376;
      var $swname=__stackBase__+380;
      var $swpart=__stackBase__+384;
      var $swname_bckp;
      var $result;
      var $software_list_ptr;
      var $software_info_ptr;
      var $software_part_ptr;
      var $interface;
      var $swlists;
      var $swlist;
      var $i;
      var $85;
      var $86;
      var $fatal;
      var $list;
      var $new_list;
      $80=$image;
      $81=$path;
      $82=$sw_info;
      $83=$sw_part;
      $84=$full_sw_name;
      $result=0;
      $software_list_ptr=0;
      $software_info_ptr=0;
      $software_part_ptr=0;
      var $87=$82;
      HEAP32[(($87)>>2)]=0;
      var $88=$83;
      HEAP32[(($88)>>2)]=0;
      var $89=$80;
      var $90=$89;
      var $91=__ZN16device_interface6deviceEv($90);
      var $92=__ZNK8device_t7machineEv($91);
      var $93=$81;
      __ZL19software_name_splitR15running_machinePKcPPcS4_S4_($92, $93, $swlist_name, $swname, $swpart);
      var $94=HEAP32[(($swname)>>2)];
      $swname_bckp=$94;
      var $95=$80;
      var $96=$95;
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+120)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=FUNCTION_TABLE[$99]($95);
      $interface=$100;
      var $101=HEAP32[(($swlist_name)>>2)];
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $103
      var $104=$80;
      var $105=$104;
      var $106=__ZN16device_interface6deviceEv($105);
      var $107=__ZNK8device_t7machineEv($106);
      var $108=__ZNK15running_machine7optionsEv($107);
      var $109=HEAP32[(($swlist_name)>>2)];
      var $110=__Z18software_list_openR11emu_optionsPKciPFvS2_E($108, $109, 0, 0);
      $software_list_ptr=$110;
      var $111=$software_list_ptr;
      var $112=(($111)|0)!=0;
      if ($112) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $113
      var $114=$software_list_ptr;
      var $115=HEAP32[(($swname)>>2)];
      var $116=__Z18software_list_findP14_software_listPKcP13software_info($114, $115, 0);
      $software_info_ptr=$116;
      var $117=$software_info_ptr;
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $119
      var $120=$software_info_ptr;
      var $121=HEAP32[(($swpart)>>2)];
      var $122=$interface;
      var $123=__Z18software_find_partP13software_infoPKcS2_($120, $121, $122);
      $software_part_ptr=$123;
      __label__ = 4; break;
    case 4: // $124
      __label__ = 5; break;
    case 5: // $125
      __label__ = 46; break;
    case 6: // $126
      var $127=$80;
      var $128=$127;
      var $129=__ZN16device_interface6deviceEv($128);
      var $130=__ZNK8device_t7machineEv($129);
      var $131=__ZNK15running_machine10devicelistEv($130);
      var $132=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $133=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($131, $132);
      $swlists=$133;
      __label__ = 7; break;
    case 7: // $134
      var $135=$swlists;
      var $136=(($135)|0)!=0;
      if ($136) { __label__ = 8; break; } else { __label__ = 27; break; }
    case 8: // $137
      var $138=$swlists;
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 9; break; } else { __label__ = 25; break; }
    case 9: // $140
      var $141=$swlists;
      var $142=__Z8downcastIPK18legacy_device_base8device_tET_PT0_($141);
      var $143=__ZNK18legacy_device_base13inline_configEv($142);
      var $144=$143;
      $swlist=$144;
      $i=229376;
      __label__ = 10; break;
    case 10: // $145
      var $146=$software_part_ptr;
      var $147=(($146)|0)!=0;
      if ($147) { var $152 = 0;__label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $148
      var $149=$i;
      var $150=(($149)>>>0) <= 229385;
      var $152 = $150;__label__ = 12; break;
    case 12: // $151
      var $152;
      if ($152) { __label__ = 13; break; } else { __label__ = 24; break; }
    case 13: // $153
      var $154=$i;
      var $155=(($154-229376)|0);
      var $156=$swlist;
      var $157=(($156)|0);
      var $158=(($157+($155<<2))|0);
      var $159=HEAP32[(($158)>>2)];
      HEAP32[(($swlist_name)>>2)]=$159;
      var $160=HEAP32[(($swlist_name)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 14; break; } else { __label__ = 23; break; }
    case 14: // $162
      var $163=HEAP32[(($swlist_name)>>2)];
      var $164=HEAP8[($163)];
      var $165=(($164 << 24) >> 24)!=0;
      if ($165) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $166
      var $167=$swlist;
      var $168=(($167+40)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169)|0)==0;
      if ($170) { __label__ = 16; break; } else { __label__ = 23; break; }
    case 16: // $171
      var $172=$software_list_ptr;
      var $173=(($172)|0)!=0;
      if ($173) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $174
      var $175=$software_list_ptr;
      __Z19software_list_closeP14_software_list($175);
      __label__ = 18; break;
    case 18: // $176
      var $177=$80;
      var $178=$177;
      var $179=__ZN16device_interface6deviceEv($178);
      var $180=__ZNK8device_t7machineEv($179);
      var $181=__ZNK15running_machine7optionsEv($180);
      var $182=HEAP32[(($swlist_name)>>2)];
      var $183=__Z18software_list_openR11emu_optionsPKciPFvS2_E($181, $182, 0, 0);
      $software_list_ptr=$183;
      var $184=$software_list_ptr;
      var $185=(($184)|0)!=0;
      if ($185) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $186
      var $187=$software_list_ptr;
      var $188=HEAP32[(($swname)>>2)];
      var $189=__Z18software_list_findP14_software_listPKcP13software_info($187, $188, 0);
      $software_info_ptr=$189;
      var $190=$software_info_ptr;
      var $191=(($190)|0)!=0;
      if ($191) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $192
      var $193=$software_info_ptr;
      var $194=HEAP32[(($swpart)>>2)];
      var $195=$interface;
      var $196=__Z18software_find_partP13software_infoPKcS2_($193, $194, $195);
      $software_part_ptr=$196;
      __label__ = 21; break;
    case 21: // $197
      __label__ = 22; break;
    case 22: // $198
      __label__ = 23; break;
    case 23: // $199
      var $200=$i;
      var $201=(($200+1)|0);
      $i=$201;
      __label__ = 10; break;
    case 24: // $202
      __label__ = 25; break;
    case 25: // $203
      __label__ = 26; break;
    case 26: // $204
      var $205=$swlists;
      var $206=__ZNK8device_t8typenextEv($205);
      $swlists=$206;
      __label__ = 7; break;
    case 27: // $207
      var $208=$software_part_ptr;
      var $209=(($208)|0)!=0;
      if ($209) { __label__ = 35; break; } else { __label__ = 28; break; }
    case 28: // $210
      var $211=$80;
      var $212=$211;
      var $213=__ZN16device_interface6deviceEv($212);
      var $214=__ZNK8device_t7machineEv($213);
      var $215=__ZNK15running_machine6systemEv($214);
      var $216=(($215+8)|0);
      var $217=HEAP32[(($216)>>2)];
      HEAP32[(($swlist_name)>>2)]=$217;
      var $218=$software_list_ptr;
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $220
      var $221=$software_list_ptr;
      __Z19software_list_closeP14_software_list($221);
      __label__ = 30; break;
    case 30: // $222
      var $223=$80;
      var $224=$223;
      var $225=__ZN16device_interface6deviceEv($224);
      var $226=__ZNK8device_t7machineEv($225);
      var $227=__ZNK15running_machine7optionsEv($226);
      var $228=HEAP32[(($swlist_name)>>2)];
      var $229=__Z18software_list_openR11emu_optionsPKciPFvS2_E($227, $228, 0, 0);
      $software_list_ptr=$229;
      var $230=$software_list_ptr;
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $232
      var $233=$software_list_ptr;
      var $234=HEAP32[(($swname)>>2)];
      var $235=__Z18software_list_findP14_software_listPKcP13software_info($233, $234, 0);
      $software_info_ptr=$235;
      var $236=$software_info_ptr;
      var $237=(($236)|0)!=0;
      if ($237) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $238
      var $239=$software_info_ptr;
      var $240=HEAP32[(($swpart)>>2)];
      var $241=$interface;
      var $242=__Z18software_find_partP13software_infoPKcS2_($239, $240, $241);
      $software_part_ptr=$242;
      __label__ = 33; break;
    case 33: // $243
      __label__ = 34; break;
    case 34: // $244
      __label__ = 35; break;
    case 35: // $245
      var $246=$software_part_ptr;
      var $247=(($246)|0)!=0;
      if ($247) { __label__ = 45; break; } else { __label__ = 36; break; }
    case 36: // $248
      var $249=HEAP32[(($swname)>>2)];
      HEAP32[(($swlist_name)>>2)]=$249;
      var $250=HEAP32[(($swpart)>>2)];
      HEAP32[(($swname)>>2)]=$250;
      HEAP32[(($swpart)>>2)]=0;
      var $251=$software_list_ptr;
      var $252=(($251)|0)!=0;
      if ($252) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $253
      var $254=$software_list_ptr;
      __Z19software_list_closeP14_software_list($254);
      __label__ = 38; break;
    case 38: // $255
      var $256=$80;
      var $257=$256;
      var $258=__ZN16device_interface6deviceEv($257);
      var $259=__ZNK8device_t7machineEv($258);
      var $260=__ZNK15running_machine7optionsEv($259);
      var $261=HEAP32[(($swlist_name)>>2)];
      var $262=__Z18software_list_openR11emu_optionsPKciPFvS2_E($260, $261, 0, 0);
      $software_list_ptr=$262;
      var $263=$software_list_ptr;
      var $264=(($263)|0)!=0;
      if ($264) { __label__ = 39; break; } else { __label__ = 44; break; }
    case 39: // $265
      var $266=$software_list_ptr;
      var $267=HEAP32[(($swname)>>2)];
      var $268=__Z18software_list_findP14_software_listPKcP13software_info($266, $267, 0);
      $software_info_ptr=$268;
      var $269=$software_info_ptr;
      var $270=(($269)|0)!=0;
      if ($270) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $271
      var $272=$software_info_ptr;
      var $273=HEAP32[(($swpart)>>2)];
      var $274=$interface;
      var $275=__Z18software_find_partP13software_infoPKcS2_($272, $273, $274);
      $software_part_ptr=$275;
      __label__ = 41; break;
    case 41: // $276
      var $277=$software_part_ptr;
      var $278=(($277)|0)!=0;
      if ($278) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $279
      var $280=$software_list_ptr;
      __Z19software_list_closeP14_software_list($280);
      $software_list_ptr=0;
      __label__ = 43; break;
    case 43: // $281
      __label__ = 44; break;
    case 44: // $282
      __label__ = 45; break;
    case 45: // $283
      __label__ = 46; break;
    case 46: // $284
      var $285=$software_info_ptr;
      var $286=(($285)|0)==0;
      if ($286) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $287
      var $288=$80;
      var $289=$288;
      var $290=__ZN16device_interface6deviceEv($289);
      var $291=__ZNK8device_t7machineEv($290);
      var $292=__ZNK15running_machine10devicelistEv($291);
      var $293=$80;
      var $294=$293;
      var $295=__ZN16device_interface6deviceEv($294);
      var $296=__ZNK8device_t7machineEv($295);
      var $297=__ZNK15running_machine7optionsEv($296);
      var $298=$80;
      var $299=$298;
      var $300=HEAP32[(($299)>>2)];
      var $301=(($300+120)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=FUNCTION_TABLE[$302]($298);
      var $304=$swname_bckp;
      __Z24software_display_matchesRK11device_listR11emu_optionsPKcS5_($292, $297, $303, $304);
      __label__ = 48; break;
    case 48: // $305
      var $306=$software_part_ptr;
      var $307=(($306)|0)!=0;
      if ($307) { __label__ = 49; break; } else { __label__ = 174; break; }
    case 49: // $308
      var $309=$80;
      var $310=$309;
      var $311=HEAP32[(($310)>>2)];
      var $312=(($311+64)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=HEAP32[(($swlist_name)>>2)];
      var $315=$software_info_ptr;
      var $316=(($315)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=$software_part_ptr;
      var $319=(($318+12)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$313]($309, $314, $317, $320) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 51; break; };
    case 50: // $322
      var $323=(($321)&1);
      $result=$323;
      __label__ = 57; break;
    case 51: // $324
      var $325=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $326=$325.f0;
      $85=$326;
      var $327=$325.f1;
      $86=$327;
      __label__ = 52; break;
    case 52: // $328
      var $329=$86;
      var $330=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $331=(($329)|0)==(($330)|0);
      if ($331) { __label__ = 53; break; } else { __label__ = 177; break; }
    case 53: // $332
      var $333=$85;
      var $334=___cxa_begin_catch($333);
      var $335=$334;
      $fatal=$335;
      var $336=$software_list_ptr;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($336) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $337
      var $338=___cxa_allocate_exception(1032);
      var $339=$338;
      var $340=$fatal;
      __ZN14emu_fatalerrorC1ERKS_($339, $340);
      (function() { try { __THREW__ = false; return ___cxa_throw($338, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 179; break; } else { __label__ = 55; break; }
    case 55: // $341
      var $342=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $343=$342.f0;
      $85=$343;
      var $344=$342.f1;
      $86=$344;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 178; break; }
    case 56: // $345
      __label__ = 177; break;
    case 57: // $346
      var $347=$80;
      var $348=$347;
      var $349=__ZN16device_interface6deviceEv($348);
      var $350=__ZNK8device_t7machineEv($349);
      var $351=__ZN15running_machine7respoolEv($350);
      var $352=$74;
      var $353=$75;
      var $354=$76;
      var $355=$77;
      var $356=$result_i;
      var $357=$78;
      var $358=$79;
      HEAP32[(($74)>>2)]=40;
      HEAP32[(($75)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($76)>>2)]=1534;
      HEAP32[(($77)>>2)]=_zeromem;
      var $359=HEAP32[(($74)>>2)];
      var $360=HEAP32[(($75)>>2)];
      var $361=HEAP32[(($76)>>2)];
      var $362=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($359, $360, $361) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 60; break; };
    case 58: // $363
      HEAP32[(($result_i)>>2)]=$362;
      var $364=HEAP32[(($result_i)>>2)];
      var $365=(($364)|0)==0;
      if ($365) { __label__ = 59; break; } else { __label__ = 64; break; }
    case 59: // $366
      var $367=___cxa_allocate_exception(4);
      var $368=$367;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($368);
      (function() { try { __THREW__ = false; return ___cxa_throw($367, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 60; break; }
    case 60: // $369
      var $370=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $371=$370.f0;
      HEAP32[(($78)>>2)]=$371;
      var $372=$370.f1;
      HEAP32[(($79)>>2)]=$372;
      var $373=HEAP32[(($79)>>2)];
      var $374=(($373)|0) < 0;
      if ($374) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $375
      var $376=HEAP32[(($78)>>2)];
      ___cxa_call_unexpected($376);
      throw "Reached an unreachable!"
    case 62: // $377
      var $378=HEAP32[(($78)>>2)];
      var $379=HEAP32[(($78)>>2)];
      var $380=HEAP32[(($79)>>2)];
      var $381=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $379, tempValue);
      var $382=($381.f1 = $380, $381);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 63: // $383
      throw "Reached an unreachable!"
    case 64: // $_ZnwjPKciRK9zeromem_t_exit
      var $384=HEAP32[(($result_i)>>2)];
      var $385=HEAP32[(($74)>>2)];
      _memset($384, 0, $385, 1);
      var $386=HEAP32[(($result_i)>>2)];
      var $387=$74;
      var $388=$75;
      var $389=$76;
      var $390=$77;
      var $391=$result_i;
      var $392=$78;
      var $393=$79;
      var $394=$386;
      var $395=__ZN13resource_pool10add_objectI13software_infoEEPT_S3_($351, $394);
      var $396=$82;
      HEAP32[(($396)>>2)]=$395;
      var $397=$80;
      var $398=$397;
      var $399=__ZN16device_interface6deviceEv($398);
      var $400=__ZNK8device_t7machineEv($399);
      var $401=__ZN15running_machine7respoolEv($400);
      var $402=$software_info_ptr;
      var $403=(($402)|0);
      var $404=HEAP32[(($403)>>2)];
      var $405=_strlen($404);
      var $406=(($405+1)|0);
      var $407=$69;
      var $408=$70;
      var $409=$71;
      var $410=$result_i1;
      var $411=$72;
      var $412=$73;
      HEAP32[(($69)>>2)]=$406;
      HEAP32[(($70)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($71)>>2)]=1535;
      var $413=HEAP32[(($69)>>2)];
      var $414=HEAP32[(($70)>>2)];
      var $415=HEAP32[(($71)>>2)];
      var $416=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($413, $414, $415) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 67; break; };
    case 65: // $417
      HEAP32[(($result_i1)>>2)]=$416;
      var $418=HEAP32[(($result_i1)>>2)];
      var $419=(($418)|0)==0;
      if ($419) { __label__ = 66; break; } else { __label__ = 71; break; }
    case 66: // $420
      var $421=___cxa_allocate_exception(4);
      var $422=$421;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($422);
      (function() { try { __THREW__ = false; return ___cxa_throw($421, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 67; break; }
    case 67: // $423
      var $424=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $425=$424.f0;
      HEAP32[(($72)>>2)]=$425;
      var $426=$424.f1;
      HEAP32[(($73)>>2)]=$426;
      var $427=HEAP32[(($73)>>2)];
      var $428=(($427)|0) < 0;
      if ($428) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $429
      var $430=HEAP32[(($72)>>2)];
      ___cxa_call_unexpected($430);
      throw "Reached an unreachable!"
    case 69: // $431
      var $432=HEAP32[(($72)>>2)];
      var $433=HEAP32[(($72)>>2)];
      var $434=HEAP32[(($73)>>2)];
      var $435=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $433, tempValue);
      var $436=($435.f1 = $434, $435);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 70: // $437
      throw "Reached an unreachable!"
    case 71: // $_ZnajPKci_exit
      var $438=HEAP32[(($result_i1)>>2)];
      var $439=$69;
      var $440=$70;
      var $441=$71;
      var $442=$result_i1;
      var $443=$72;
      var $444=$73;
      var $445=$software_info_ptr;
      var $446=(($445)|0);
      var $447=HEAP32[(($446)>>2)];
      var $448=_strlen($447);
      var $449=(($448+1)|0);
      var $450=__ZN13resource_pool9add_arrayIcEEPT_S2_i($401, $438, $449);
      var $451=$software_info_ptr;
      var $452=(($451)|0);
      var $453=HEAP32[(($452)>>2)];
      var $454=_strcpy($450, $453);
      var $455=$82;
      var $456=HEAP32[(($455)>>2)];
      var $457=(($456)|0);
      HEAP32[(($457)>>2)]=$454;
      var $458=$80;
      var $459=$458;
      var $460=__ZN16device_interface6deviceEv($459);
      var $461=__ZNK8device_t7machineEv($460);
      var $462=__ZN15running_machine7respoolEv($461);
      var $463=$software_info_ptr;
      var $464=(($463+4)|0);
      var $465=HEAP32[(($464)>>2)];
      var $466=_strlen($465);
      var $467=(($466+1)|0);
      var $468=$64;
      var $469=$65;
      var $470=$66;
      var $471=$result_i2;
      var $472=$67;
      var $473=$68;
      HEAP32[(($64)>>2)]=$467;
      HEAP32[(($65)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($66)>>2)]=1536;
      var $474=HEAP32[(($64)>>2)];
      var $475=HEAP32[(($65)>>2)];
      var $476=HEAP32[(($66)>>2)];
      var $477=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($474, $475, $476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 74; break; };
    case 72: // $478
      HEAP32[(($result_i2)>>2)]=$477;
      var $479=HEAP32[(($result_i2)>>2)];
      var $480=(($479)|0)==0;
      if ($480) { __label__ = 73; break; } else { __label__ = 78; break; }
    case 73: // $481
      var $482=___cxa_allocate_exception(4);
      var $483=$482;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($483);
      (function() { try { __THREW__ = false; return ___cxa_throw($482, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 74; break; }
    case 74: // $484
      var $485=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $486=$485.f0;
      HEAP32[(($67)>>2)]=$486;
      var $487=$485.f1;
      HEAP32[(($68)>>2)]=$487;
      var $488=HEAP32[(($68)>>2)];
      var $489=(($488)|0) < 0;
      if ($489) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $490
      var $491=HEAP32[(($67)>>2)];
      ___cxa_call_unexpected($491);
      throw "Reached an unreachable!"
    case 76: // $492
      var $493=HEAP32[(($67)>>2)];
      var $494=HEAP32[(($67)>>2)];
      var $495=HEAP32[(($68)>>2)];
      var $496=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $494, tempValue);
      var $497=($496.f1 = $495, $496);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 77: // $498
      throw "Reached an unreachable!"
    case 78: // $_ZnajPKci_exit3
      var $499=HEAP32[(($result_i2)>>2)];
      var $500=$64;
      var $501=$65;
      var $502=$66;
      var $503=$result_i2;
      var $504=$67;
      var $505=$68;
      var $506=$software_info_ptr;
      var $507=(($506+4)|0);
      var $508=HEAP32[(($507)>>2)];
      var $509=_strlen($508);
      var $510=(($509+1)|0);
      var $511=__ZN13resource_pool9add_arrayIcEEPT_S2_i($462, $499, $510);
      var $512=$software_info_ptr;
      var $513=(($512+4)|0);
      var $514=HEAP32[(($513)>>2)];
      var $515=_strcpy($511, $514);
      var $516=$82;
      var $517=HEAP32[(($516)>>2)];
      var $518=(($517+4)|0);
      HEAP32[(($518)>>2)]=$515;
      var $519=$software_info_ptr;
      var $520=(($519+12)|0);
      var $521=HEAP32[(($520)>>2)];
      var $522=(($521)|0)!=0;
      if ($522) { __label__ = 79; break; } else { __label__ = 87; break; }
    case 79: // $523
      var $524=$80;
      var $525=$524;
      var $526=__ZN16device_interface6deviceEv($525);
      var $527=__ZNK8device_t7machineEv($526);
      var $528=__ZN15running_machine7respoolEv($527);
      var $529=$software_info_ptr;
      var $530=(($529+12)|0);
      var $531=HEAP32[(($530)>>2)];
      var $532=_strlen($531);
      var $533=(($532+1)|0);
      var $534=$59;
      var $535=$60;
      var $536=$61;
      var $537=$result_i4;
      var $538=$62;
      var $539=$63;
      HEAP32[(($59)>>2)]=$533;
      HEAP32[(($60)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($61)>>2)]=1538;
      var $540=HEAP32[(($59)>>2)];
      var $541=HEAP32[(($60)>>2)];
      var $542=HEAP32[(($61)>>2)];
      var $543=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($540, $541, $542) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 82; break; };
    case 80: // $544
      HEAP32[(($result_i4)>>2)]=$543;
      var $545=HEAP32[(($result_i4)>>2)];
      var $546=(($545)|0)==0;
      if ($546) { __label__ = 81; break; } else { __label__ = 86; break; }
    case 81: // $547
      var $548=___cxa_allocate_exception(4);
      var $549=$548;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($549);
      (function() { try { __THREW__ = false; return ___cxa_throw($548, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 82; break; }
    case 82: // $550
      var $551=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $552=$551.f0;
      HEAP32[(($62)>>2)]=$552;
      var $553=$551.f1;
      HEAP32[(($63)>>2)]=$553;
      var $554=HEAP32[(($63)>>2)];
      var $555=(($554)|0) < 0;
      if ($555) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $556
      var $557=HEAP32[(($62)>>2)];
      ___cxa_call_unexpected($557);
      throw "Reached an unreachable!"
    case 84: // $558
      var $559=HEAP32[(($62)>>2)];
      var $560=HEAP32[(($62)>>2)];
      var $561=HEAP32[(($63)>>2)];
      var $562=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $560, tempValue);
      var $563=($562.f1 = $561, $562);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 85: // $564
      throw "Reached an unreachable!"
    case 86: // $_ZnajPKci_exit5
      var $565=HEAP32[(($result_i4)>>2)];
      var $566=$59;
      var $567=$60;
      var $568=$61;
      var $569=$result_i4;
      var $570=$62;
      var $571=$63;
      var $572=$software_info_ptr;
      var $573=(($572+12)|0);
      var $574=HEAP32[(($573)>>2)];
      var $575=_strlen($574);
      var $576=(($575+1)|0);
      var $577=__ZN13resource_pool9add_arrayIcEEPT_S2_i($528, $565, $576);
      var $578=$software_info_ptr;
      var $579=(($578+12)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=_strcpy($577, $580);
      var $582=$82;
      var $583=HEAP32[(($582)>>2)];
      var $584=(($583+12)|0);
      HEAP32[(($584)>>2)]=$581;
      __label__ = 87; break;
    case 87: // $585
      var $586=$software_info_ptr;
      var $587=(($586+16)|0);
      var $588=HEAP32[(($587)>>2)];
      var $589=(($588)|0)!=0;
      if ($589) { __label__ = 88; break; } else { __label__ = 96; break; }
    case 88: // $590
      var $591=$80;
      var $592=$591;
      var $593=__ZN16device_interface6deviceEv($592);
      var $594=__ZNK8device_t7machineEv($593);
      var $595=__ZN15running_machine7respoolEv($594);
      var $596=$software_info_ptr;
      var $597=(($596+16)|0);
      var $598=HEAP32[(($597)>>2)];
      var $599=_strlen($598);
      var $600=(($599+1)|0);
      var $601=$54;
      var $602=$55;
      var $603=$56;
      var $604=$result_i6;
      var $605=$57;
      var $606=$58;
      HEAP32[(($54)>>2)]=$600;
      HEAP32[(($55)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($56)>>2)]=1540;
      var $607=HEAP32[(($54)>>2)];
      var $608=HEAP32[(($55)>>2)];
      var $609=HEAP32[(($56)>>2)];
      var $610=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($607, $608, $609) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 91; break; };
    case 89: // $611
      HEAP32[(($result_i6)>>2)]=$610;
      var $612=HEAP32[(($result_i6)>>2)];
      var $613=(($612)|0)==0;
      if ($613) { __label__ = 90; break; } else { __label__ = 95; break; }
    case 90: // $614
      var $615=___cxa_allocate_exception(4);
      var $616=$615;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($616);
      (function() { try { __THREW__ = false; return ___cxa_throw($615, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 91; break; }
    case 91: // $617
      var $618=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $619=$618.f0;
      HEAP32[(($57)>>2)]=$619;
      var $620=$618.f1;
      HEAP32[(($58)>>2)]=$620;
      var $621=HEAP32[(($58)>>2)];
      var $622=(($621)|0) < 0;
      if ($622) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $623
      var $624=HEAP32[(($57)>>2)];
      ___cxa_call_unexpected($624);
      throw "Reached an unreachable!"
    case 93: // $625
      var $626=HEAP32[(($57)>>2)];
      var $627=HEAP32[(($57)>>2)];
      var $628=HEAP32[(($58)>>2)];
      var $629=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $627, tempValue);
      var $630=($629.f1 = $628, $629);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 94: // $631
      throw "Reached an unreachable!"
    case 95: // $_ZnajPKci_exit7
      var $632=HEAP32[(($result_i6)>>2)];
      var $633=$54;
      var $634=$55;
      var $635=$56;
      var $636=$result_i6;
      var $637=$57;
      var $638=$58;
      var $639=$software_info_ptr;
      var $640=(($639+16)|0);
      var $641=HEAP32[(($640)>>2)];
      var $642=_strlen($641);
      var $643=(($642+1)|0);
      var $644=__ZN13resource_pool9add_arrayIcEEPT_S2_i($595, $632, $643);
      var $645=$software_info_ptr;
      var $646=(($645+16)|0);
      var $647=HEAP32[(($646)>>2)];
      var $648=_strcpy($644, $647);
      var $649=$82;
      var $650=HEAP32[(($649)>>2)];
      var $651=(($650+16)|0);
      HEAP32[(($651)>>2)]=$648;
      __label__ = 96; break;
    case 96: // $652
      var $653=$80;
      var $654=$653;
      var $655=__ZN16device_interface6deviceEv($654);
      var $656=__ZNK8device_t7machineEv($655);
      var $657=__ZN15running_machine7respoolEv($656);
      var $658=$48;
      var $659=$49;
      var $660=$50;
      var $661=$51;
      var $662=$result_i8;
      var $663=$52;
      var $664=$53;
      HEAP32[(($48)>>2)]=16;
      HEAP32[(($49)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($50)>>2)]=1542;
      HEAP32[(($51)>>2)]=_zeromem;
      var $665=HEAP32[(($48)>>2)];
      var $666=HEAP32[(($49)>>2)];
      var $667=HEAP32[(($50)>>2)];
      var $668=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($665, $666, $667) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 99; break; };
    case 97: // $669
      HEAP32[(($result_i8)>>2)]=$668;
      var $670=HEAP32[(($result_i8)>>2)];
      var $671=(($670)|0)==0;
      if ($671) { __label__ = 98; break; } else { __label__ = 103; break; }
    case 98: // $672
      var $673=___cxa_allocate_exception(4);
      var $674=$673;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($674);
      (function() { try { __THREW__ = false; return ___cxa_throw($673, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 99; break; }
    case 99: // $675
      var $676=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $677=$676.f0;
      HEAP32[(($52)>>2)]=$677;
      var $678=$676.f1;
      HEAP32[(($53)>>2)]=$678;
      var $679=HEAP32[(($53)>>2)];
      var $680=(($679)|0) < 0;
      if ($680) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $681
      var $682=HEAP32[(($52)>>2)];
      ___cxa_call_unexpected($682);
      throw "Reached an unreachable!"
    case 101: // $683
      var $684=HEAP32[(($52)>>2)];
      var $685=HEAP32[(($52)>>2)];
      var $686=HEAP32[(($53)>>2)];
      var $687=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $685, tempValue);
      var $688=($687.f1 = $686, $687);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 102: // $689
      throw "Reached an unreachable!"
    case 103: // $_ZnwjPKciRK9zeromem_t_exit9
      var $690=HEAP32[(($result_i8)>>2)];
      var $691=HEAP32[(($48)>>2)];
      _memset($690, 0, $691, 1);
      var $692=HEAP32[(($result_i8)>>2)];
      var $693=$48;
      var $694=$49;
      var $695=$50;
      var $696=$51;
      var $697=$result_i8;
      var $698=$52;
      var $699=$53;
      var $700=$692;
      var $701=__ZN13resource_pool10add_objectI13software_partEEPT_S3_($657, $700);
      var $702=$83;
      HEAP32[(($702)>>2)]=$701;
      var $703=$80;
      var $704=$703;
      var $705=__ZN16device_interface6deviceEv($704);
      var $706=__ZNK8device_t7machineEv($705);
      var $707=__ZN15running_machine7respoolEv($706);
      var $708=$software_part_ptr;
      var $709=(($708)|0);
      var $710=HEAP32[(($709)>>2)];
      var $711=_strlen($710);
      var $712=(($711+1)|0);
      var $713=$43;
      var $714=$44;
      var $715=$45;
      var $716=$result_i10;
      var $717=$46;
      var $718=$47;
      HEAP32[(($43)>>2)]=$712;
      HEAP32[(($44)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($45)>>2)]=1543;
      var $719=HEAP32[(($43)>>2)];
      var $720=HEAP32[(($44)>>2)];
      var $721=HEAP32[(($45)>>2)];
      var $722=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($719, $720, $721) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 106; break; };
    case 104: // $723
      HEAP32[(($result_i10)>>2)]=$722;
      var $724=HEAP32[(($result_i10)>>2)];
      var $725=(($724)|0)==0;
      if ($725) { __label__ = 105; break; } else { __label__ = 110; break; }
    case 105: // $726
      var $727=___cxa_allocate_exception(4);
      var $728=$727;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($728);
      (function() { try { __THREW__ = false; return ___cxa_throw($727, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 106; break; }
    case 106: // $729
      var $730=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $731=$730.f0;
      HEAP32[(($46)>>2)]=$731;
      var $732=$730.f1;
      HEAP32[(($47)>>2)]=$732;
      var $733=HEAP32[(($47)>>2)];
      var $734=(($733)|0) < 0;
      if ($734) { __label__ = 107; break; } else { __label__ = 108; break; }
    case 107: // $735
      var $736=HEAP32[(($46)>>2)];
      ___cxa_call_unexpected($736);
      throw "Reached an unreachable!"
    case 108: // $737
      var $738=HEAP32[(($46)>>2)];
      var $739=HEAP32[(($46)>>2)];
      var $740=HEAP32[(($47)>>2)];
      var $741=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $739, tempValue);
      var $742=($741.f1 = $740, $741);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 109: // $743
      throw "Reached an unreachable!"
    case 110: // $_ZnajPKci_exit11
      var $744=HEAP32[(($result_i10)>>2)];
      var $745=$43;
      var $746=$44;
      var $747=$45;
      var $748=$result_i10;
      var $749=$46;
      var $750=$47;
      var $751=$software_part_ptr;
      var $752=(($751)|0);
      var $753=HEAP32[(($752)>>2)];
      var $754=_strlen($753);
      var $755=(($754+1)|0);
      var $756=__ZN13resource_pool9add_arrayIcEEPT_S2_i($707, $744, $755);
      var $757=$software_part_ptr;
      var $758=(($757)|0);
      var $759=HEAP32[(($758)>>2)];
      var $760=_strcpy($756, $759);
      var $761=$83;
      var $762=HEAP32[(($761)>>2)];
      var $763=(($762)|0);
      HEAP32[(($763)>>2)]=$760;
      var $764=$software_part_ptr;
      var $765=(($764+4)|0);
      var $766=HEAP32[(($765)>>2)];
      var $767=(($766)|0)!=0;
      if ($767) { __label__ = 111; break; } else { __label__ = 119; break; }
    case 111: // $768
      var $769=$80;
      var $770=$769;
      var $771=__ZN16device_interface6deviceEv($770);
      var $772=__ZNK8device_t7machineEv($771);
      var $773=__ZN15running_machine7respoolEv($772);
      var $774=$software_part_ptr;
      var $775=(($774+4)|0);
      var $776=HEAP32[(($775)>>2)];
      var $777=_strlen($776);
      var $778=(($777+1)|0);
      var $779=$38;
      var $780=$39;
      var $781=$40;
      var $782=$result_i12;
      var $783=$41;
      var $784=$42;
      HEAP32[(($38)>>2)]=$778;
      HEAP32[(($39)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($40)>>2)]=1545;
      var $785=HEAP32[(($38)>>2)];
      var $786=HEAP32[(($39)>>2)];
      var $787=HEAP32[(($40)>>2)];
      var $788=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($785, $786, $787) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 114; break; };
    case 112: // $789
      HEAP32[(($result_i12)>>2)]=$788;
      var $790=HEAP32[(($result_i12)>>2)];
      var $791=(($790)|0)==0;
      if ($791) { __label__ = 113; break; } else { __label__ = 118; break; }
    case 113: // $792
      var $793=___cxa_allocate_exception(4);
      var $794=$793;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($794);
      (function() { try { __THREW__ = false; return ___cxa_throw($793, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 117; break; } else { __label__ = 114; break; }
    case 114: // $795
      var $796=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $797=$796.f0;
      HEAP32[(($41)>>2)]=$797;
      var $798=$796.f1;
      HEAP32[(($42)>>2)]=$798;
      var $799=HEAP32[(($42)>>2)];
      var $800=(($799)|0) < 0;
      if ($800) { __label__ = 115; break; } else { __label__ = 116; break; }
    case 115: // $801
      var $802=HEAP32[(($41)>>2)];
      ___cxa_call_unexpected($802);
      throw "Reached an unreachable!"
    case 116: // $803
      var $804=HEAP32[(($41)>>2)];
      var $805=HEAP32[(($41)>>2)];
      var $806=HEAP32[(($42)>>2)];
      var $807=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $805, tempValue);
      var $808=($807.f1 = $806, $807);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 117: // $809
      throw "Reached an unreachable!"
    case 118: // $_ZnajPKci_exit13
      var $810=HEAP32[(($result_i12)>>2)];
      var $811=$38;
      var $812=$39;
      var $813=$40;
      var $814=$result_i12;
      var $815=$41;
      var $816=$42;
      var $817=$software_part_ptr;
      var $818=(($817+4)|0);
      var $819=HEAP32[(($818)>>2)];
      var $820=_strlen($819);
      var $821=(($820+1)|0);
      var $822=__ZN13resource_pool9add_arrayIcEEPT_S2_i($773, $810, $821);
      var $823=$software_part_ptr;
      var $824=(($823+4)|0);
      var $825=HEAP32[(($824)>>2)];
      var $826=_strcpy($822, $825);
      var $827=$83;
      var $828=HEAP32[(($827)>>2)];
      var $829=(($828+4)|0);
      HEAP32[(($829)>>2)]=$826;
      __label__ = 119; break;
    case 119: // $830
      var $831=$software_part_ptr;
      var $832=(($831+8)|0);
      var $833=HEAP32[(($832)>>2)];
      var $834=(($833)|0)!=0;
      if ($834) { __label__ = 120; break; } else { __label__ = 166; break; }
    case 120: // $835
      var $836=$software_part_ptr;
      var $837=(($836+8)|0);
      var $838=HEAP32[(($837)>>2)];
      $list=$838;
      var $839=$80;
      var $840=$839;
      var $841=__ZN16device_interface6deviceEv($840);
      var $842=__ZNK8device_t7machineEv($841);
      var $843=__ZN15running_machine7respoolEv($842);
      var $844=$32;
      var $845=$33;
      var $846=$34;
      var $847=$35;
      var $848=$result_i14;
      var $849=$36;
      var $850=$37;
      HEAP32[(($32)>>2)]=12;
      HEAP32[(($33)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($34)>>2)]=1550;
      HEAP32[(($35)>>2)]=_zeromem;
      var $851=HEAP32[(($32)>>2)];
      var $852=HEAP32[(($33)>>2)];
      var $853=HEAP32[(($34)>>2)];
      var $854=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($851, $852, $853) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 123; break; };
    case 121: // $855
      HEAP32[(($result_i14)>>2)]=$854;
      var $856=HEAP32[(($result_i14)>>2)];
      var $857=(($856)|0)==0;
      if ($857) { __label__ = 122; break; } else { __label__ = 127; break; }
    case 122: // $858
      var $859=___cxa_allocate_exception(4);
      var $860=$859;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($860);
      (function() { try { __THREW__ = false; return ___cxa_throw($859, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 126; break; } else { __label__ = 123; break; }
    case 123: // $861
      var $862=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $863=$862.f0;
      HEAP32[(($36)>>2)]=$863;
      var $864=$862.f1;
      HEAP32[(($37)>>2)]=$864;
      var $865=HEAP32[(($37)>>2)];
      var $866=(($865)|0) < 0;
      if ($866) { __label__ = 124; break; } else { __label__ = 125; break; }
    case 124: // $867
      var $868=HEAP32[(($36)>>2)];
      ___cxa_call_unexpected($868);
      throw "Reached an unreachable!"
    case 125: // $869
      var $870=HEAP32[(($36)>>2)];
      var $871=HEAP32[(($36)>>2)];
      var $872=HEAP32[(($37)>>2)];
      var $873=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $871, tempValue);
      var $874=($873.f1 = $872, $873);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 126: // $875
      throw "Reached an unreachable!"
    case 127: // $_ZnwjPKciRK9zeromem_t_exit15
      var $876=HEAP32[(($result_i14)>>2)];
      var $877=HEAP32[(($32)>>2)];
      _memset($876, 0, $877, 1);
      var $878=HEAP32[(($result_i14)>>2)];
      var $879=$32;
      var $880=$33;
      var $881=$34;
      var $882=$35;
      var $883=$result_i14;
      var $884=$36;
      var $885=$37;
      var $886=$878;
      var $887=__ZN13resource_pool10add_objectI12feature_listEEPT_S3_($843, $886);
      $new_list=$887;
      var $888=$new_list;
      var $889=$83;
      var $890=HEAP32[(($889)>>2)];
      var $891=(($890+8)|0);
      HEAP32[(($891)>>2)]=$888;
      var $892=$80;
      var $893=$892;
      var $894=__ZN16device_interface6deviceEv($893);
      var $895=__ZNK8device_t7machineEv($894);
      var $896=__ZN15running_machine7respoolEv($895);
      var $897=$list;
      var $898=(($897+4)|0);
      var $899=HEAP32[(($898)>>2)];
      var $900=_strlen($899);
      var $901=(($900+1)|0);
      var $902=$27;
      var $903=$28;
      var $904=$29;
      var $905=$result_i16;
      var $906=$30;
      var $907=$31;
      HEAP32[(($27)>>2)]=$901;
      HEAP32[(($28)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($29)>>2)]=1554;
      var $908=HEAP32[(($27)>>2)];
      var $909=HEAP32[(($28)>>2)];
      var $910=HEAP32[(($29)>>2)];
      var $911=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($908, $909, $910) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 128; break; } else { __label__ = 130; break; };
    case 128: // $912
      HEAP32[(($result_i16)>>2)]=$911;
      var $913=HEAP32[(($result_i16)>>2)];
      var $914=(($913)|0)==0;
      if ($914) { __label__ = 129; break; } else { __label__ = 134; break; }
    case 129: // $915
      var $916=___cxa_allocate_exception(4);
      var $917=$916;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($917);
      (function() { try { __THREW__ = false; return ___cxa_throw($916, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 133; break; } else { __label__ = 130; break; }
    case 130: // $918
      var $919=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $920=$919.f0;
      HEAP32[(($30)>>2)]=$920;
      var $921=$919.f1;
      HEAP32[(($31)>>2)]=$921;
      var $922=HEAP32[(($31)>>2)];
      var $923=(($922)|0) < 0;
      if ($923) { __label__ = 131; break; } else { __label__ = 132; break; }
    case 131: // $924
      var $925=HEAP32[(($30)>>2)];
      ___cxa_call_unexpected($925);
      throw "Reached an unreachable!"
    case 132: // $926
      var $927=HEAP32[(($30)>>2)];
      var $928=HEAP32[(($30)>>2)];
      var $929=HEAP32[(($31)>>2)];
      var $930=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $928, tempValue);
      var $931=($930.f1 = $929, $930);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 133: // $932
      throw "Reached an unreachable!"
    case 134: // $_ZnajPKci_exit17
      var $933=HEAP32[(($result_i16)>>2)];
      var $934=$27;
      var $935=$28;
      var $936=$29;
      var $937=$result_i16;
      var $938=$30;
      var $939=$31;
      var $940=$list;
      var $941=(($940+4)|0);
      var $942=HEAP32[(($941)>>2)];
      var $943=_strlen($942);
      var $944=(($943+1)|0);
      var $945=__ZN13resource_pool9add_arrayIcEEPT_S2_i($896, $933, $944);
      var $946=$list;
      var $947=(($946+4)|0);
      var $948=HEAP32[(($947)>>2)];
      var $949=_strcpy($945, $948);
      var $950=$new_list;
      var $951=(($950+4)|0);
      HEAP32[(($951)>>2)]=$949;
      var $952=$80;
      var $953=$952;
      var $954=__ZN16device_interface6deviceEv($953);
      var $955=__ZNK8device_t7machineEv($954);
      var $956=__ZN15running_machine7respoolEv($955);
      var $957=$list;
      var $958=(($957+8)|0);
      var $959=HEAP32[(($958)>>2)];
      var $960=_strlen($959);
      var $961=(($960+1)|0);
      var $962=$22;
      var $963=$23;
      var $964=$24;
      var $965=$result_i18;
      var $966=$25;
      var $967=$26;
      HEAP32[(($22)>>2)]=$961;
      HEAP32[(($23)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($24)>>2)]=1555;
      var $968=HEAP32[(($22)>>2)];
      var $969=HEAP32[(($23)>>2)];
      var $970=HEAP32[(($24)>>2)];
      var $971=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($968, $969, $970) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 135; break; } else { __label__ = 137; break; };
    case 135: // $972
      HEAP32[(($result_i18)>>2)]=$971;
      var $973=HEAP32[(($result_i18)>>2)];
      var $974=(($973)|0)==0;
      if ($974) { __label__ = 136; break; } else { __label__ = 141; break; }
    case 136: // $975
      var $976=___cxa_allocate_exception(4);
      var $977=$976;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($977);
      (function() { try { __THREW__ = false; return ___cxa_throw($976, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 140; break; } else { __label__ = 137; break; }
    case 137: // $978
      var $979=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $980=$979.f0;
      HEAP32[(($25)>>2)]=$980;
      var $981=$979.f1;
      HEAP32[(($26)>>2)]=$981;
      var $982=HEAP32[(($26)>>2)];
      var $983=(($982)|0) < 0;
      if ($983) { __label__ = 138; break; } else { __label__ = 139; break; }
    case 138: // $984
      var $985=HEAP32[(($25)>>2)];
      ___cxa_call_unexpected($985);
      throw "Reached an unreachable!"
    case 139: // $986
      var $987=HEAP32[(($25)>>2)];
      var $988=HEAP32[(($25)>>2)];
      var $989=HEAP32[(($26)>>2)];
      var $990=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $988, tempValue);
      var $991=($990.f1 = $989, $990);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 140: // $992
      throw "Reached an unreachable!"
    case 141: // $_ZnajPKci_exit19
      var $993=HEAP32[(($result_i18)>>2)];
      var $994=$22;
      var $995=$23;
      var $996=$24;
      var $997=$result_i18;
      var $998=$25;
      var $999=$26;
      var $1000=$list;
      var $1001=(($1000+8)|0);
      var $1002=HEAP32[(($1001)>>2)];
      var $1003=_strlen($1002);
      var $1004=(($1003+1)|0);
      var $1005=__ZN13resource_pool9add_arrayIcEEPT_S2_i($956, $993, $1004);
      var $1006=$list;
      var $1007=(($1006+8)|0);
      var $1008=HEAP32[(($1007)>>2)];
      var $1009=_strcpy($1005, $1008);
      var $1010=$new_list;
      var $1011=(($1010+8)|0);
      HEAP32[(($1011)>>2)]=$1009;
      var $1012=$list;
      var $1013=(($1012)|0);
      var $1014=HEAP32[(($1013)>>2)];
      $list=$1014;
      __label__ = 142; break;
    case 142: // $1015
      var $1016=$list;
      var $1017=(($1016)|0)!=0;
      if ($1017) { __label__ = 143; break; } else { __label__ = 165; break; }
    case 143: // $1018
      var $1019=$80;
      var $1020=$1019;
      var $1021=__ZN16device_interface6deviceEv($1020);
      var $1022=__ZNK8device_t7machineEv($1021);
      var $1023=__ZN15running_machine7respoolEv($1022);
      var $1024=$16;
      var $1025=$17;
      var $1026=$18;
      var $1027=$19;
      var $1028=$result_i20;
      var $1029=$20;
      var $1030=$21;
      HEAP32[(($16)>>2)]=12;
      HEAP32[(($17)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($18)>>2)]=1561;
      HEAP32[(($19)>>2)]=_zeromem;
      var $1031=HEAP32[(($16)>>2)];
      var $1032=HEAP32[(($17)>>2)];
      var $1033=HEAP32[(($18)>>2)];
      var $1034=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($1031, $1032, $1033) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 144; break; } else { __label__ = 146; break; };
    case 144: // $1035
      HEAP32[(($result_i20)>>2)]=$1034;
      var $1036=HEAP32[(($result_i20)>>2)];
      var $1037=(($1036)|0)==0;
      if ($1037) { __label__ = 145; break; } else { __label__ = 150; break; }
    case 145: // $1038
      var $1039=___cxa_allocate_exception(4);
      var $1040=$1039;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1040);
      (function() { try { __THREW__ = false; return ___cxa_throw($1039, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 149; break; } else { __label__ = 146; break; }
    case 146: // $1041
      var $1042=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1043=$1042.f0;
      HEAP32[(($20)>>2)]=$1043;
      var $1044=$1042.f1;
      HEAP32[(($21)>>2)]=$1044;
      var $1045=HEAP32[(($21)>>2)];
      var $1046=(($1045)|0) < 0;
      if ($1046) { __label__ = 147; break; } else { __label__ = 148; break; }
    case 147: // $1047
      var $1048=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($1048);
      throw "Reached an unreachable!"
    case 148: // $1049
      var $1050=HEAP32[(($20)>>2)];
      var $1051=HEAP32[(($20)>>2)];
      var $1052=HEAP32[(($21)>>2)];
      var $1053=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1051, tempValue);
      var $1054=($1053.f1 = $1052, $1053);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 149: // $1055
      throw "Reached an unreachable!"
    case 150: // $_ZnwjPKciRK9zeromem_t_exit21
      var $1056=HEAP32[(($result_i20)>>2)];
      var $1057=HEAP32[(($16)>>2)];
      _memset($1056, 0, $1057, 1);
      var $1058=HEAP32[(($result_i20)>>2)];
      var $1059=$16;
      var $1060=$17;
      var $1061=$18;
      var $1062=$19;
      var $1063=$result_i20;
      var $1064=$20;
      var $1065=$21;
      var $1066=$1058;
      var $1067=__ZN13resource_pool10add_objectI12feature_listEEPT_S3_($1023, $1066);
      var $1068=$new_list;
      var $1069=(($1068)|0);
      HEAP32[(($1069)>>2)]=$1067;
      var $1070=$new_list;
      var $1071=(($1070)|0);
      var $1072=HEAP32[(($1071)>>2)];
      $new_list=$1072;
      var $1073=$80;
      var $1074=$1073;
      var $1075=__ZN16device_interface6deviceEv($1074);
      var $1076=__ZNK8device_t7machineEv($1075);
      var $1077=__ZN15running_machine7respoolEv($1076);
      var $1078=$list;
      var $1079=(($1078+4)|0);
      var $1080=HEAP32[(($1079)>>2)];
      var $1081=_strlen($1080);
      var $1082=(($1081+1)|0);
      var $1083=$11;
      var $1084=$12;
      var $1085=$13;
      var $1086=$result_i22;
      var $1087=$14;
      var $1088=$15;
      HEAP32[(($11)>>2)]=$1082;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($13)>>2)]=1563;
      var $1089=HEAP32[(($11)>>2)];
      var $1090=HEAP32[(($12)>>2)];
      var $1091=HEAP32[(($13)>>2)];
      var $1092=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($1089, $1090, $1091) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 151; break; } else { __label__ = 153; break; };
    case 151: // $1093
      HEAP32[(($result_i22)>>2)]=$1092;
      var $1094=HEAP32[(($result_i22)>>2)];
      var $1095=(($1094)|0)==0;
      if ($1095) { __label__ = 152; break; } else { __label__ = 157; break; }
    case 152: // $1096
      var $1097=___cxa_allocate_exception(4);
      var $1098=$1097;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1098);
      (function() { try { __THREW__ = false; return ___cxa_throw($1097, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 153; break; }
    case 153: // $1099
      var $1100=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1101=$1100.f0;
      HEAP32[(($14)>>2)]=$1101;
      var $1102=$1100.f1;
      HEAP32[(($15)>>2)]=$1102;
      var $1103=HEAP32[(($15)>>2)];
      var $1104=(($1103)|0) < 0;
      if ($1104) { __label__ = 154; break; } else { __label__ = 155; break; }
    case 154: // $1105
      var $1106=HEAP32[(($14)>>2)];
      ___cxa_call_unexpected($1106);
      throw "Reached an unreachable!"
    case 155: // $1107
      var $1108=HEAP32[(($14)>>2)];
      var $1109=HEAP32[(($14)>>2)];
      var $1110=HEAP32[(($15)>>2)];
      var $1111=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1109, tempValue);
      var $1112=($1111.f1 = $1110, $1111);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 156: // $1113
      throw "Reached an unreachable!"
    case 157: // $_ZnajPKci_exit23
      var $1114=HEAP32[(($result_i22)>>2)];
      var $1115=$11;
      var $1116=$12;
      var $1117=$13;
      var $1118=$result_i22;
      var $1119=$14;
      var $1120=$15;
      var $1121=$list;
      var $1122=(($1121+4)|0);
      var $1123=HEAP32[(($1122)>>2)];
      var $1124=_strlen($1123);
      var $1125=(($1124+1)|0);
      var $1126=__ZN13resource_pool9add_arrayIcEEPT_S2_i($1077, $1114, $1125);
      var $1127=$list;
      var $1128=(($1127+4)|0);
      var $1129=HEAP32[(($1128)>>2)];
      var $1130=_strcpy($1126, $1129);
      var $1131=$new_list;
      var $1132=(($1131+4)|0);
      HEAP32[(($1132)>>2)]=$1130;
      var $1133=$80;
      var $1134=$1133;
      var $1135=__ZN16device_interface6deviceEv($1134);
      var $1136=__ZNK8device_t7machineEv($1135);
      var $1137=__ZN15running_machine7respoolEv($1136);
      var $1138=$list;
      var $1139=(($1138+8)|0);
      var $1140=HEAP32[(($1139)>>2)];
      var $1141=_strlen($1140);
      var $1142=(($1141+1)|0);
      var $1143=$6;
      var $1144=$7;
      var $1145=$8;
      var $1146=$result_i24;
      var $1147=$9;
      var $1148=$10;
      HEAP32[(($6)>>2)]=$1142;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($8)>>2)]=1564;
      var $1149=HEAP32[(($6)>>2)];
      var $1150=HEAP32[(($7)>>2)];
      var $1151=HEAP32[(($8)>>2)];
      var $1152=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($1149, $1150, $1151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 158; break; } else { __label__ = 160; break; };
    case 158: // $1153
      HEAP32[(($result_i24)>>2)]=$1152;
      var $1154=HEAP32[(($result_i24)>>2)];
      var $1155=(($1154)|0)==0;
      if ($1155) { __label__ = 159; break; } else { __label__ = 164; break; }
    case 159: // $1156
      var $1157=___cxa_allocate_exception(4);
      var $1158=$1157;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1158);
      (function() { try { __THREW__ = false; return ___cxa_throw($1157, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 163; break; } else { __label__ = 160; break; }
    case 160: // $1159
      var $1160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1161=$1160.f0;
      HEAP32[(($9)>>2)]=$1161;
      var $1162=$1160.f1;
      HEAP32[(($10)>>2)]=$1162;
      var $1163=HEAP32[(($10)>>2)];
      var $1164=(($1163)|0) < 0;
      if ($1164) { __label__ = 161; break; } else { __label__ = 162; break; }
    case 161: // $1165
      var $1166=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($1166);
      throw "Reached an unreachable!"
    case 162: // $1167
      var $1168=HEAP32[(($9)>>2)];
      var $1169=HEAP32[(($9)>>2)];
      var $1170=HEAP32[(($10)>>2)];
      var $1171=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1169, tempValue);
      var $1172=($1171.f1 = $1170, $1171);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 163: // $1173
      throw "Reached an unreachable!"
    case 164: // $_ZnajPKci_exit25
      var $1174=HEAP32[(($result_i24)>>2)];
      var $1175=$6;
      var $1176=$7;
      var $1177=$8;
      var $1178=$result_i24;
      var $1179=$9;
      var $1180=$10;
      var $1181=$list;
      var $1182=(($1181+8)|0);
      var $1183=HEAP32[(($1182)>>2)];
      var $1184=_strlen($1183);
      var $1185=(($1184+1)|0);
      var $1186=__ZN13resource_pool9add_arrayIcEEPT_S2_i($1137, $1174, $1185);
      var $1187=$list;
      var $1188=(($1187+8)|0);
      var $1189=HEAP32[(($1188)>>2)];
      var $1190=_strcpy($1186, $1189);
      var $1191=$new_list;
      var $1192=(($1191+8)|0);
      HEAP32[(($1192)>>2)]=$1190;
      var $1193=$list;
      var $1194=(($1193)|0);
      var $1195=HEAP32[(($1194)>>2)];
      $list=$1195;
      __label__ = 142; break;
    case 165: // $1196
      var $1197=$new_list;
      var $1198=(($1197)|0);
      HEAP32[(($1198)>>2)]=0;
      __label__ = 166; break;
    case 166: // $1199
      var $1200=$80;
      var $1201=$1200;
      var $1202=__ZN16device_interface6deviceEv($1201);
      var $1203=__ZNK8device_t7machineEv($1202);
      var $1204=__ZN15running_machine7respoolEv($1203);
      var $1205=HEAP32[(($swlist_name)>>2)];
      var $1206=_strlen($1205);
      var $1207=$software_info_ptr;
      var $1208=(($1207)|0);
      var $1209=HEAP32[(($1208)>>2)];
      var $1210=_strlen($1209);
      var $1211=(($1206+$1210)|0);
      var $1212=$software_part_ptr;
      var $1213=(($1212)|0);
      var $1214=HEAP32[(($1213)>>2)];
      var $1215=_strlen($1214);
      var $1216=(($1211+$1215)|0);
      var $1217=(($1216+3)|0);
      var $1218=$1;
      var $1219=$2;
      var $1220=$3;
      var $1221=$result_i26;
      var $1222=$4;
      var $1223=$5;
      HEAP32[(($1)>>2)]=$1217;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($3)>>2)]=1573;
      var $1224=HEAP32[(($1)>>2)];
      var $1225=HEAP32[(($2)>>2)];
      var $1226=HEAP32[(($3)>>2)];
      var $1227=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($1224, $1225, $1226) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 167; break; } else { __label__ = 169; break; };
    case 167: // $1228
      HEAP32[(($result_i26)>>2)]=$1227;
      var $1229=HEAP32[(($result_i26)>>2)];
      var $1230=(($1229)|0)==0;
      if ($1230) { __label__ = 168; break; } else { __label__ = 173; break; }
    case 168: // $1231
      var $1232=___cxa_allocate_exception(4);
      var $1233=$1232;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1233);
      (function() { try { __THREW__ = false; return ___cxa_throw($1232, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 172; break; } else { __label__ = 169; break; }
    case 169: // $1234
      var $1235=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1236=$1235.f0;
      HEAP32[(($4)>>2)]=$1236;
      var $1237=$1235.f1;
      HEAP32[(($5)>>2)]=$1237;
      var $1238=HEAP32[(($5)>>2)];
      var $1239=(($1238)|0) < 0;
      if ($1239) { __label__ = 170; break; } else { __label__ = 171; break; }
    case 170: // $1240
      var $1241=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($1241);
      throw "Reached an unreachable!"
    case 171: // $1242
      var $1243=HEAP32[(($4)>>2)];
      var $1244=HEAP32[(($4)>>2)];
      var $1245=HEAP32[(($5)>>2)];
      var $1246=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1244, tempValue);
      var $1247=($1246.f1 = $1245, $1246);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 172: // $1248
      throw "Reached an unreachable!"
    case 173: // $_ZnajPKci_exit27
      var $1249=HEAP32[(($result_i26)>>2)];
      var $1250=$1;
      var $1251=$2;
      var $1252=$3;
      var $1253=$result_i26;
      var $1254=$4;
      var $1255=$5;
      var $1256=HEAP32[(($swlist_name)>>2)];
      var $1257=_strlen($1256);
      var $1258=$software_info_ptr;
      var $1259=(($1258)|0);
      var $1260=HEAP32[(($1259)>>2)];
      var $1261=_strlen($1260);
      var $1262=(($1257+$1261)|0);
      var $1263=$software_part_ptr;
      var $1264=(($1263)|0);
      var $1265=HEAP32[(($1264)>>2)];
      var $1266=_strlen($1265);
      var $1267=(($1262+$1266)|0);
      var $1268=(($1267+3)|0);
      var $1269=__ZN13resource_pool9add_arrayIcEEPT_S2_i($1204, $1249, $1268);
      var $1270=$84;
      HEAP32[(($1270)>>2)]=$1269;
      var $1271=$84;
      var $1272=HEAP32[(($1271)>>2)];
      var $1273=HEAP32[(($swlist_name)>>2)];
      var $1274=$software_info_ptr;
      var $1275=(($1274)|0);
      var $1276=HEAP32[(($1275)>>2)];
      var $1277=$software_part_ptr;
      var $1278=(($1277)|0);
      var $1279=HEAP32[(($1278)>>2)];
      var $1280=_sprintf($1272, ((STRING_TABLE.__str91677)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1273,HEAP32[((tempInt+4)>>2)]=$1276,HEAP32[((tempInt+8)>>2)]=$1279,tempInt));
      __label__ = 174; break;
    case 174: // $1281
      var $1282=$software_list_ptr;
      var $1283=(($1282)|0)!=0;
      if ($1283) { __label__ = 175; break; } else { __label__ = 176; break; }
    case 175: // $1284
      var $1285=$software_list_ptr;
      __Z19software_list_closeP14_software_list($1285);
      $software_info_ptr=0;
      $software_list_ptr=0;
      __label__ = 176; break;
    case 176: // $1286
      var $1287=$80;
      var $1288=$1287;
      var $1289=__ZN16device_interface6deviceEv($1288);
      var $1290=__ZNK8device_t7machineEv($1289);
      var $1291=__ZN15running_machine7respoolEv($1290);
      var $1292=HEAP32[(($swlist_name)>>2)];
      __ZN13resource_pool6removeEPv($1291, $1292);
      var $1293=$80;
      var $1294=$1293;
      var $1295=__ZN16device_interface6deviceEv($1294);
      var $1296=__ZNK8device_t7machineEv($1295);
      var $1297=__ZN15running_machine7respoolEv($1296);
      var $1298=HEAP32[(($swname)>>2)];
      __ZN13resource_pool6removeEPv($1297, $1298);
      var $1299=$80;
      var $1300=$1299;
      var $1301=__ZN16device_interface6deviceEv($1300);
      var $1302=__ZNK8device_t7machineEv($1301);
      var $1303=__ZN15running_machine7respoolEv($1302);
      var $1304=HEAP32[(($swpart)>>2)];
      __ZN13resource_pool6removeEPv($1303, $1304);
      var $1305=$result;
      var $1306=(($1305) & 1);
      STACKTOP = __stackBase__;
      return $1306;
    case 177: // $1307
      var $1308=$85;
      var $1309=$85;
      var $1310=$86;
      var $1311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1309, tempValue);
      var $1312=($1311.f1 = $1310, $1311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 178: // $1313
      var $1314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 179: // $1315
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18load_software_partP22device_image_interfacePKcPP13software_infoPP13software_partPPc["X"]=1;

function __ZN14emu_fatalerrorC1ERKS_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN14emu_fatalerrorC2ERKS_($4, $5);
  ;
  return;
}


function __ZL19software_name_splitR15running_machinePKcPPcS4_S4_($machine, $swlist_swname, $swlist_name, $swname, $swpart) {
  var __stackBase__  = STACKTOP; STACKTOP += 164; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i10=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $result_i8=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $15=__stackBase__+64;
      var $result_i6=__stackBase__+68;
      var $16=__stackBase__+72;
      var $17=__stackBase__+76;
      var $18=__stackBase__+80;
      var $19=__stackBase__+84;
      var $20=__stackBase__+88;
      var $21=__stackBase__+92;
      var $result_i4=__stackBase__+96;
      var $22=__stackBase__+100;
      var $23=__stackBase__+104;
      var $24=__stackBase__+108;
      var $25=__stackBase__+112;
      var $26=__stackBase__+116;
      var $27=__stackBase__+120;
      var $result_i2=__stackBase__+124;
      var $28=__stackBase__+128;
      var $29=__stackBase__+132;
      var $30=__stackBase__+136;
      var $31=__stackBase__+140;
      var $32=__stackBase__+144;
      var $33=__stackBase__+148;
      var $result_i=__stackBase__+152;
      var $34=__stackBase__+156;
      var $35=__stackBase__+160;
      var $36;
      var $37;
      var $38;
      var $39;
      var $40;
      var $split_1st_loc;
      var $split_2nd_loc;
      var $size;
      var $size1;
      $36=$machine;
      $37=$swlist_swname;
      $38=$swlist_name;
      $39=$swname;
      $40=$swpart;
      var $41=$37;
      var $42=_strchr($41, 58);
      $split_1st_loc=$42;
      var $43=$split_1st_loc;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $46=$split_1st_loc;
      var $47=(($46+1)|0);
      var $48=_strchr($47, 58);
      var $51 = $48;__label__ = 3; break;
    case 2: // $49
      var $51 = 0;__label__ = 3; break;
    case 3: // $50
      var $51;
      $split_2nd_loc=$51;
      var $52=$38;
      HEAP32[(($52)>>2)]=0;
      var $53=$39;
      HEAP32[(($53)>>2)]=0;
      var $54=$40;
      HEAP32[(($54)>>2)]=0;
      var $55=$split_1st_loc;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 4; break; } else { __label__ = 43; break; }
    case 4: // $57
      var $58=$split_2nd_loc;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 5; break; } else { __label__ = 27; break; }
    case 5: // $60
      var $61=$split_1st_loc;
      var $62=$37;
      var $63=$61;
      var $64=$62;
      var $65=(($63-$64)|0);
      $size=$65;
      var $66=$36;
      var $67=__ZN15running_machine7respoolEv($66);
      var $68=$size;
      var $69=(($68+1)|0);
      var $70=(($69)|0) < 0;
      var $71=$70 ? -1 : $69;
      var $72=$30;
      var $73=$31;
      var $74=$32;
      var $75=$33;
      var $76=$result_i;
      var $77=$34;
      var $78=$35;
      HEAP32[(($30)>>2)]=$71;
      HEAP32[(($31)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($32)>>2)]=137;
      HEAP32[(($33)>>2)]=_zeromem;
      var $79=HEAP32[(($30)>>2)];
      var $80=HEAP32[(($31)>>2)];
      var $81=HEAP32[(($32)>>2)];
      var $82=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($79, $80, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $83
      HEAP32[(($result_i)>>2)]=$82;
      var $84=HEAP32[(($result_i)>>2)];
      var $85=(($84)|0)==0;
      if ($85) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $86
      var $87=___cxa_allocate_exception(4);
      var $88=$87;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($88);
      (function() { try { __THREW__ = false; return ___cxa_throw($87, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $89
      var $90=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $91=$90.f0;
      HEAP32[(($34)>>2)]=$91;
      var $92=$90.f1;
      HEAP32[(($35)>>2)]=$92;
      var $93=HEAP32[(($35)>>2)];
      var $94=(($93)|0) < 0;
      if ($94) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $95
      var $96=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($96);
      throw "Reached an unreachable!"
    case 10: // $97
      var $98=HEAP32[(($34)>>2)];
      var $99=HEAP32[(($34)>>2)];
      var $100=HEAP32[(($35)>>2)];
      var $101=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $99, tempValue);
      var $102=($101.f1 = $100, $101);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $103
      throw "Reached an unreachable!"
    case 12: // $_ZnajPKciRK9zeromem_t_exit
      var $104=HEAP32[(($result_i)>>2)];
      var $105=HEAP32[(($30)>>2)];
      _memset($104, 0, $105, 1);
      var $106=HEAP32[(($result_i)>>2)];
      var $107=$30;
      var $108=$31;
      var $109=$32;
      var $110=$33;
      var $111=$result_i;
      var $112=$34;
      var $113=$35;
      var $114=$size;
      var $115=(($114+1)|0);
      var $116=__ZN13resource_pool9add_arrayIcEEPT_S2_i($67, $106, $115);
      var $117=$38;
      HEAP32[(($117)>>2)]=$116;
      var $118=$38;
      var $119=HEAP32[(($118)>>2)];
      var $120=$37;
      var $121=$size;
      assert($121 % 1 === 0, 'memcpy given ' + $121 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($119, $120, $121, 1);
      var $122=$split_2nd_loc;
      var $123=$split_1st_loc;
      var $124=(($123+1)|0);
      var $125=$122;
      var $126=$124;
      var $127=(($125-$126)|0);
      $size=$127;
      var $128=$36;
      var $129=__ZN15running_machine7respoolEv($128);
      var $130=$size;
      var $131=(($130+1)|0);
      var $132=(($131)|0) < 0;
      var $133=$132 ? -1 : $131;
      var $134=$24;
      var $135=$25;
      var $136=$26;
      var $137=$27;
      var $138=$result_i2;
      var $139=$28;
      var $140=$29;
      HEAP32[(($24)>>2)]=$133;
      HEAP32[(($25)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($26)>>2)]=141;
      HEAP32[(($27)>>2)]=_zeromem;
      var $141=HEAP32[(($24)>>2)];
      var $142=HEAP32[(($25)>>2)];
      var $143=HEAP32[(($26)>>2)];
      var $144=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($141, $142, $143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $145
      HEAP32[(($result_i2)>>2)]=$144;
      var $146=HEAP32[(($result_i2)>>2)];
      var $147=(($146)|0)==0;
      if ($147) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $148
      var $149=___cxa_allocate_exception(4);
      var $150=$149;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($150);
      (function() { try { __THREW__ = false; return ___cxa_throw($149, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 15: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      HEAP32[(($28)>>2)]=$153;
      var $154=$152.f1;
      HEAP32[(($29)>>2)]=$154;
      var $155=HEAP32[(($29)>>2)];
      var $156=(($155)|0) < 0;
      if ($156) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $157
      var $158=HEAP32[(($28)>>2)];
      ___cxa_call_unexpected($158);
      throw "Reached an unreachable!"
    case 17: // $159
      var $160=HEAP32[(($28)>>2)];
      var $161=HEAP32[(($28)>>2)];
      var $162=HEAP32[(($29)>>2)];
      var $163=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $161, tempValue);
      var $164=($163.f1 = $162, $163);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $165
      throw "Reached an unreachable!"
    case 19: // $_ZnajPKciRK9zeromem_t_exit3
      var $166=HEAP32[(($result_i2)>>2)];
      var $167=HEAP32[(($24)>>2)];
      _memset($166, 0, $167, 1);
      var $168=HEAP32[(($result_i2)>>2)];
      var $169=$24;
      var $170=$25;
      var $171=$26;
      var $172=$27;
      var $173=$result_i2;
      var $174=$28;
      var $175=$29;
      var $176=$size;
      var $177=(($176+1)|0);
      var $178=__ZN13resource_pool9add_arrayIcEEPT_S2_i($129, $168, $177);
      var $179=$39;
      HEAP32[(($179)>>2)]=$178;
      var $180=$39;
      var $181=HEAP32[(($180)>>2)];
      var $182=$split_1st_loc;
      var $183=(($182+1)|0);
      var $184=$size;
      assert($184 % 1 === 0, 'memcpy given ' + $184 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($181, $183, $184, 1);
      var $185=$37;
      var $186=_strlen($185);
      var $187=$split_2nd_loc;
      var $188=(($187+1)|0);
      var $189=$37;
      var $190=$188;
      var $191=$189;
      var $192=(($190-$191)|0);
      var $193=(($186-$192)|0);
      $size=$193;
      var $194=$36;
      var $195=__ZN15running_machine7respoolEv($194);
      var $196=$size;
      var $197=(($196+1)|0);
      var $198=(($197)|0) < 0;
      var $199=$198 ? -1 : $197;
      var $200=$18;
      var $201=$19;
      var $202=$20;
      var $203=$21;
      var $204=$result_i4;
      var $205=$22;
      var $206=$23;
      HEAP32[(($18)>>2)]=$199;
      HEAP32[(($19)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($20)>>2)]=145;
      HEAP32[(($21)>>2)]=_zeromem;
      var $207=HEAP32[(($18)>>2)];
      var $208=HEAP32[(($19)>>2)];
      var $209=HEAP32[(($20)>>2)];
      var $210=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($207, $208, $209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; };
    case 20: // $211
      HEAP32[(($result_i4)>>2)]=$210;
      var $212=HEAP32[(($result_i4)>>2)];
      var $213=(($212)|0)==0;
      if ($213) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $214
      var $215=___cxa_allocate_exception(4);
      var $216=$215;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($216);
      (function() { try { __THREW__ = false; return ___cxa_throw($215, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 22; break; }
    case 22: // $217
      var $218=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $219=$218.f0;
      HEAP32[(($22)>>2)]=$219;
      var $220=$218.f1;
      HEAP32[(($23)>>2)]=$220;
      var $221=HEAP32[(($23)>>2)];
      var $222=(($221)|0) < 0;
      if ($222) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $223
      var $224=HEAP32[(($22)>>2)];
      ___cxa_call_unexpected($224);
      throw "Reached an unreachable!"
    case 24: // $225
      var $226=HEAP32[(($22)>>2)];
      var $227=HEAP32[(($22)>>2)];
      var $228=HEAP32[(($23)>>2)];
      var $229=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $227, tempValue);
      var $230=($229.f1 = $228, $229);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $231
      throw "Reached an unreachable!"
    case 26: // $_ZnajPKciRK9zeromem_t_exit5
      var $232=HEAP32[(($result_i4)>>2)];
      var $233=HEAP32[(($18)>>2)];
      _memset($232, 0, $233, 1);
      var $234=HEAP32[(($result_i4)>>2)];
      var $235=$18;
      var $236=$19;
      var $237=$20;
      var $238=$21;
      var $239=$result_i4;
      var $240=$22;
      var $241=$23;
      var $242=$size;
      var $243=(($242+1)|0);
      var $244=__ZN13resource_pool9add_arrayIcEEPT_S2_i($195, $234, $243);
      var $245=$40;
      HEAP32[(($245)>>2)]=$244;
      var $246=$40;
      var $247=HEAP32[(($246)>>2)];
      var $248=$split_2nd_loc;
      var $249=(($248+1)|0);
      var $250=$size;
      assert($250 % 1 === 0, 'memcpy given ' + $250 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($247, $249, $250, 1);
      __label__ = 42; break;
    case 27: // $251
      var $252=$split_1st_loc;
      var $253=$37;
      var $254=$252;
      var $255=$253;
      var $256=(($254-$255)|0);
      $size1=$256;
      var $257=$36;
      var $258=__ZN15running_machine7respoolEv($257);
      var $259=$size1;
      var $260=(($259+1)|0);
      var $261=(($260)|0) < 0;
      var $262=$261 ? -1 : $260;
      var $263=$12;
      var $264=$13;
      var $265=$14;
      var $266=$15;
      var $267=$result_i6;
      var $268=$16;
      var $269=$17;
      HEAP32[(($12)>>2)]=$262;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($14)>>2)]=151;
      HEAP32[(($15)>>2)]=_zeromem;
      var $270=HEAP32[(($12)>>2)];
      var $271=HEAP32[(($13)>>2)];
      var $272=HEAP32[(($14)>>2)];
      var $273=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($270, $271, $272) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; };
    case 28: // $274
      HEAP32[(($result_i6)>>2)]=$273;
      var $275=HEAP32[(($result_i6)>>2)];
      var $276=(($275)|0)==0;
      if ($276) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $277
      var $278=___cxa_allocate_exception(4);
      var $279=$278;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($279);
      (function() { try { __THREW__ = false; return ___cxa_throw($278, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 30; break; }
    case 30: // $280
      var $281=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $282=$281.f0;
      HEAP32[(($16)>>2)]=$282;
      var $283=$281.f1;
      HEAP32[(($17)>>2)]=$283;
      var $284=HEAP32[(($17)>>2)];
      var $285=(($284)|0) < 0;
      if ($285) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $286
      var $287=HEAP32[(($16)>>2)];
      ___cxa_call_unexpected($287);
      throw "Reached an unreachable!"
    case 32: // $288
      var $289=HEAP32[(($16)>>2)];
      var $290=HEAP32[(($16)>>2)];
      var $291=HEAP32[(($17)>>2)];
      var $292=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $290, tempValue);
      var $293=($292.f1 = $291, $292);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $294
      throw "Reached an unreachable!"
    case 34: // $_ZnajPKciRK9zeromem_t_exit7
      var $295=HEAP32[(($result_i6)>>2)];
      var $296=HEAP32[(($12)>>2)];
      _memset($295, 0, $296, 1);
      var $297=HEAP32[(($result_i6)>>2)];
      var $298=$12;
      var $299=$13;
      var $300=$14;
      var $301=$15;
      var $302=$result_i6;
      var $303=$16;
      var $304=$17;
      var $305=$size1;
      var $306=(($305+1)|0);
      var $307=__ZN13resource_pool9add_arrayIcEEPT_S2_i($258, $297, $306);
      var $308=$39;
      HEAP32[(($308)>>2)]=$307;
      var $309=$39;
      var $310=HEAP32[(($309)>>2)];
      var $311=$37;
      var $312=$size1;
      assert($312 % 1 === 0, 'memcpy given ' + $312 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($310, $311, $312, 1);
      var $313=$37;
      var $314=_strlen($313);
      var $315=$split_1st_loc;
      var $316=(($315+1)|0);
      var $317=$37;
      var $318=$316;
      var $319=$317;
      var $320=(($318-$319)|0);
      var $321=(($314-$320)|0);
      $size1=$321;
      var $322=$36;
      var $323=__ZN15running_machine7respoolEv($322);
      var $324=$size1;
      var $325=(($324+1)|0);
      var $326=(($325)|0) < 0;
      var $327=$326 ? -1 : $325;
      var $328=$6;
      var $329=$7;
      var $330=$8;
      var $331=$9;
      var $332=$result_i8;
      var $333=$10;
      var $334=$11;
      HEAP32[(($6)>>2)]=$327;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($8)>>2)]=155;
      HEAP32[(($9)>>2)]=_zeromem;
      var $335=HEAP32[(($6)>>2)];
      var $336=HEAP32[(($7)>>2)];
      var $337=HEAP32[(($8)>>2)];
      var $338=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($335, $336, $337) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 37; break; };
    case 35: // $339
      HEAP32[(($result_i8)>>2)]=$338;
      var $340=HEAP32[(($result_i8)>>2)];
      var $341=(($340)|0)==0;
      if ($341) { __label__ = 36; break; } else { __label__ = 41; break; }
    case 36: // $342
      var $343=___cxa_allocate_exception(4);
      var $344=$343;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($344);
      (function() { try { __THREW__ = false; return ___cxa_throw($343, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 37; break; }
    case 37: // $345
      var $346=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $347=$346.f0;
      HEAP32[(($10)>>2)]=$347;
      var $348=$346.f1;
      HEAP32[(($11)>>2)]=$348;
      var $349=HEAP32[(($11)>>2)];
      var $350=(($349)|0) < 0;
      if ($350) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $351
      var $352=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($352);
      throw "Reached an unreachable!"
    case 39: // $353
      var $354=HEAP32[(($10)>>2)];
      var $355=HEAP32[(($10)>>2)];
      var $356=HEAP32[(($11)>>2)];
      var $357=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $355, tempValue);
      var $358=($357.f1 = $356, $357);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 40: // $359
      throw "Reached an unreachable!"
    case 41: // $_ZnajPKciRK9zeromem_t_exit9
      var $360=HEAP32[(($result_i8)>>2)];
      var $361=HEAP32[(($6)>>2)];
      _memset($360, 0, $361, 1);
      var $362=HEAP32[(($result_i8)>>2)];
      var $363=$6;
      var $364=$7;
      var $365=$8;
      var $366=$9;
      var $367=$result_i8;
      var $368=$10;
      var $369=$11;
      var $370=$size1;
      var $371=(($370+1)|0);
      var $372=__ZN13resource_pool9add_arrayIcEEPT_S2_i($323, $362, $371);
      var $373=$40;
      HEAP32[(($373)>>2)]=$372;
      var $374=$40;
      var $375=HEAP32[(($374)>>2)];
      var $376=$split_1st_loc;
      var $377=(($376+1)|0);
      var $378=$size1;
      assert($378 % 1 === 0, 'memcpy given ' + $378 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($375, $377, $378, 1);
      __label__ = 42; break;
    case 42: // $379
      __label__ = 51; break;
    case 43: // $380
      var $381=$36;
      var $382=__ZN15running_machine7respoolEv($381);
      var $383=$37;
      var $384=_strlen($383);
      var $385=(($384+1)|0);
      var $386=$1;
      var $387=$2;
      var $388=$3;
      var $389=$result_i10;
      var $390=$4;
      var $391=$5;
      HEAP32[(($1)>>2)]=$385;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str11667)|0);
      HEAP32[(($3)>>2)]=161;
      var $392=HEAP32[(($1)>>2)];
      var $393=HEAP32[(($2)>>2)];
      var $394=HEAP32[(($3)>>2)];
      var $395=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($392, $393, $394) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; };
    case 44: // $396
      HEAP32[(($result_i10)>>2)]=$395;
      var $397=HEAP32[(($result_i10)>>2)];
      var $398=(($397)|0)==0;
      if ($398) { __label__ = 45; break; } else { __label__ = 50; break; }
    case 45: // $399
      var $400=___cxa_allocate_exception(4);
      var $401=$400;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($401);
      (function() { try { __THREW__ = false; return ___cxa_throw($400, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 46; break; }
    case 46: // $402
      var $403=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $404=$403.f0;
      HEAP32[(($4)>>2)]=$404;
      var $405=$403.f1;
      HEAP32[(($5)>>2)]=$405;
      var $406=HEAP32[(($5)>>2)];
      var $407=(($406)|0) < 0;
      if ($407) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $408
      var $409=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($409);
      throw "Reached an unreachable!"
    case 48: // $410
      var $411=HEAP32[(($4)>>2)];
      var $412=HEAP32[(($4)>>2)];
      var $413=HEAP32[(($5)>>2)];
      var $414=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $412, tempValue);
      var $415=($414.f1 = $413, $414);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $416
      throw "Reached an unreachable!"
    case 50: // $_ZnajPKci_exit
      var $417=HEAP32[(($result_i10)>>2)];
      var $418=$1;
      var $419=$2;
      var $420=$3;
      var $421=$result_i10;
      var $422=$4;
      var $423=$5;
      var $424=$37;
      var $425=_strlen($424);
      var $426=(($425+1)|0);
      var $427=__ZN13resource_pool9add_arrayIcEEPT_S2_i($382, $417, $426);
      var $428=$37;
      var $429=_strcpy($427, $428);
      var $430=$39;
      HEAP32[(($430)>>2)]=$429;
      __label__ = 51; break;
    case 51: // $431
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19software_name_splitR15running_machinePKcPPcS4_S4_["X"]=1;

function __ZN13resource_pool10add_objectI13software_infoEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13software_infoEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13software_infoEEPT_S3_["X"]=1;

function __ZL26device_start_software_listP8device_t($device) {
  ;
  var __label__;

  var $1;
  $1=$device;
  ;
  return;
}


function __Z25software_part_get_featureP13software_partPKc($part, $feature_name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $feature;
      $2=$part;
      $3=$feature_name;
      var $4=$2;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=0;
      __label__ = 9; break;
    case 2: // $7
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      $feature=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$feature;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $14
      var $15=$feature;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$3;
      var $19=_strcmp($17, $18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $21
      var $22=$feature;
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      $1=$24;
      __label__ = 9; break;
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$feature;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $feature=$29;
      __label__ = 3; break;
    case 8: // $30
      $1=0;
      __label__ = 9; break;
    case 9: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z31device_get_config_software_listPK8device_tjP10deviceinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $config;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$2;
      if ($4 == 0) {
        __label__ = 1; break;
      }
      else if ($4 == 1) {
        __label__ = 2; break;
      }
      else if ($4 == 131072) {
        __label__ = 3; break;
      }
      else if ($4 == 131073) {
        __label__ = 10; break;
      }
      else if ($4 == 131077) {
        __label__ = 4; break;
      }
      else if ($4 == 196608) {
        __label__ = 5; break;
      }
      else if ($4 == 196610) {
        __label__ = 6; break;
      }
      else if ($4 == 196611) {
        __label__ = 7; break;
      }
      else if ($4 == 196612) {
        __label__ = 8; break;
      }
      else if ($4 == 196613) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 1: // $5
      var $6=$3;
      var $7=$6;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($7)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($7+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 10; break;
    case 2: // $8
      var $9=$3;
      var $10=$9;
      var $$emscripten$temp$1$0=44;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($10)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($10+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 10; break;
    case 3: // $11
      var $12=$3;
      var $13=$12;
      HEAP32[(($13)>>2)]=168;
      __label__ = 10; break;
    case 4: // $14
      var $15=$3;
      var $16=$15;
      HEAP32[(($16)>>2)]=170;
      __label__ = 10; break;
    case 5: // $17
      var $18=$3;
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=_strcpy($20, ((STRING_TABLE.__str101678)|0));
      __label__ = 10; break;
    case 6: // $22
      var $23=$3;
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      var $26=_strcpy($25, ((STRING_TABLE.__str101678)|0));
      __label__ = 10; break;
    case 7: // $27
      var $28=$3;
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=_strcpy($30, ((STRING_TABLE.__str111679)|0));
      __label__ = 10; break;
    case 8: // $32
      var $33=$3;
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=_strcpy($35, ((STRING_TABLE.__str11667)|0));
      __label__ = 10; break;
    case 9: // $37
      var $38=$3;
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=_strcpy($40, ((STRING_TABLE.__str121680)|0));
      __label__ = 10; break;
    case 10: // $42
      var $43=$2;
      var $44=(($43)>>>0) >= 229376;
      if ($44) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $45
      var $46=$2;
      var $47=(($46)>>>0) <= 229385;
      if ($47) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $48
      var $49=$1;
      var $50=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($49);
      var $51=__ZNK18legacy_device_base13inline_configEv($50);
      var $52=$51;
      $config=$52;
      var $53=$2;
      var $54=(($53-229376)|0);
      var $55=$config;
      var $56=(($55)|0);
      var $57=(($56+($54<<2))|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $60
      var $61=$3;
      var $62=$61;
      var $63=HEAP32[(($62)>>2)];
      var $64=$2;
      var $65=(($64-229376)|0);
      var $66=$config;
      var $67=(($66)|0);
      var $68=(($67+($65<<2))|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=_strcpy($63, $69);
      __label__ = 14; break;
    case 14: // $71
      __label__ = 15; break;
    case 15: // $72
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z31device_get_config_software_listPK8device_tjP10deviceinfo["X"]=1;

function __ZN13resource_pool10add_objectI13software_partEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13software_partEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13software_partEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI12feature_listEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12feature_listEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12feature_listEEPT_S3_["X"]=1;

function __ZN20software_list_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($8, $9, $10, $11, $12, $13, 174);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV20software_list_device+8)|0);
  ;
  return;
}


function __ZN20software_list_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20software_list_deviceD2Ev($2);
  ;
  return;
}


function __ZL35device_validity_check_software_listPK11game_driverPK8device_tR11emu_options($driver, $device, $options) {
  var __stackBase__  = STACKTOP; STACKTOP += 860; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $swlist;
      var $error;
      var $names=__stackBase__;
      var $descriptions=__stackBase__+388;
      var $5;
      var $6;
      var $i;
      var $list;
      var $7;
      var $swinfo;
      var $s;
      var $is_clone;
      var $match;
      var $match1;
      var $swinfo2;
      var $swpart;
      var $swdata;
      var $data;
      var $s2;
      var $hashes=__stackBase__+776;
      $2=$driver;
      $3=$device;
      $4=$options;
      var $8=$3;
      var $9=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($8);
      var $10=__ZNK18legacy_device_base13inline_configEv($9);
      var $11=$10;
      $swlist=$11;
      $error=0;
      __ZN8tagmap_tIP13software_infoEC1Ev($names);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP13software_infoEC1Ev($descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $12
      $i=0;
      __label__ = 2; break;
    case 2: // $13
      var $14=$i;
      var $15=(($14)|0) < 9;
      if ($15) { __label__ = 3; break; } else { __label__ = 108; break; }
    case 3: // $16
      var $17=$i;
      var $18=$swlist;
      var $19=(($18)|0);
      var $20=(($19+($17<<2))|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 106; break; }
    case 4: // $23
      var $24=$4;
      var $25=$i;
      var $26=$swlist;
      var $27=(($26)|0);
      var $28=(($27+($25<<2))|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(function() { try { __THREW__ = false; return __Z18software_list_openR11emu_optionsPKciPFvS2_E($24, $29, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $31
      $list=$30;
      var $32=$list;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $34
      $1=0;
      $7=1;
      __label__ = 109; break;
    case 7: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $5=$37;
      var $38=$36.f1;
      $6=$38;
      __label__ = 113; break;
    case 8: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $5=$41;
      var $42=$40.f1;
      $6=$42;
      __label__ = 111; break;
    case 9: // $43
      var $44=$list;
      var $45=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($44, ((STRING_TABLE.__str31669)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $46
      $swinfo=$45;
      __label__ = 11; break;
    case 11: // $47
      var $48=$swinfo;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 12; break; } else { __label__ = 104; break; }
    case 12: // $50
      $is_clone=0;
      var $51=$swinfo;
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $55
      var $56=$i;
      var $57=$swlist;
      var $58=(($57)|0);
      var $59=(($58+($56<<2))|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$swinfo;
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str141682)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$60,HEAP32[((tempInt+4)>>2)]=$63,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 8; break; }
    case 14: // $64
      $1=1;
      $7=1;
      __label__ = 109; break;
    case 15: // $65
      var $66=$swinfo;
      var $67=(($66+12)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $70
      var $71=$i;
      var $72=$swlist;
      var $73=(($72)|0);
      var $74=(($73+($71<<2))|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$swinfo;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str151683)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$75,HEAP32[((tempInt+4)>>2)]=$78,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; }
    case 17: // $79
      $1=1;
      $7=1;
      __label__ = 109; break;
    case 18: // $80
      var $81=$swinfo;
      var $82=(($81+16)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $85
      var $86=$i;
      var $87=$swlist;
      var $88=(($87)|0);
      var $89=(($88+($86<<2))|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$swinfo;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str161684)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$90,HEAP32[((tempInt+4)>>2)]=$93,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 8; break; }
    case 20: // $94
      $1=1;
      $7=1;
      __label__ = 109; break;
    case 21: // $95
      var $96=$swinfo;
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$swinfo;
      var $100=(function() { try { __THREW__ = false; return __ZN8tagmap_tIP13software_infoE3addEPKcS1_b($names, $98, $99, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 8; break; };
    case 22: // $101
      var $102=(($100)|0)==2;
      if ($102) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $103
      var $104=$swinfo;
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(function() { try { __THREW__ = false; return __ZNK8tagmap_tIP13software_infoE4findEPKc($names, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 8; break; };
    case 24: // $108
      $match=$107;
      var $109=$i;
      var $110=$swlist;
      var $111=(($110)|0);
      var $112=(($111+($109<<2))|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$swinfo;
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$match;
      var $118=(($117)|0);
      var $119=HEAP32[(($118)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str171685)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$113,HEAP32[((tempInt+4)>>2)]=$116,HEAP32[((tempInt+8)>>2)]=$119,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 8; break; }
    case 25: // $120
      $error=1;
      __label__ = 26; break;
    case 26: // $121
      var $122=$swinfo;
      var $123=(($122+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$swinfo;
      var $126=(function() { try { __THREW__ = false; return __ZN8tagmap_tIP13software_infoE3addEPKcS1_b($descriptions, $124, $125, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 8; break; };
    case 27: // $127
      var $128=(($126)|0)==2;
      if ($128) { __label__ = 28; break; } else { __label__ = 31; break; }
    case 28: // $129
      var $130=$swinfo;
      var $131=(($130)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(function() { try { __THREW__ = false; return __ZNK8tagmap_tIP13software_infoE4findEPKc($names, $132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 8; break; };
    case 29: // $134
      $match1=$133;
      var $135=$i;
      var $136=$swlist;
      var $137=(($136)|0);
      var $138=(($137+($135<<2))|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=$swinfo;
      var $141=(($140+4)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$match1;
      var $144=(($143+4)|0);
      var $145=HEAP32[(($144)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str181686)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$139,HEAP32[((tempInt+4)>>2)]=$142,HEAP32[((tempInt+8)>>2)]=$145,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; }
    case 30: // $146
      $error=1;
      __label__ = 31; break;
    case 31: // $147
      var $148=$swinfo;
      var $149=(($148+8)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150)|0)!=0;
      if ($151) { __label__ = 32; break; } else { __label__ = 45; break; }
    case 32: // $152
      $is_clone=1;
      var $153=$swinfo;
      var $154=(($153+8)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$swinfo;
      var $157=(($156)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(function() { try { __THREW__ = false; return _strcmp($155, $158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 8; break; };
    case 33: // $160
      var $161=(($159)|0)==0;
      if ($161) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $162
      var $163=$i;
      var $164=$swlist;
      var $165=(($164)|0);
      var $166=(($165+($163<<2))|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$swinfo;
      var $169=(($168)|0);
      var $170=HEAP32[(($169)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str191687)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$167,HEAP32[((tempInt+4)>>2)]=$170,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 8; break; }
    case 35: // $171
      $error=1;
      __label__ = 104; break;
    case 36: // $172
      var $173=$list;
      var $174=$swinfo;
      var $175=(($174+8)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($173, $176, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 8; break; };
    case 37: // $178
      $swinfo2=$177;
      var $179=$swinfo2;
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 40; break; } else { __label__ = 38; break; }
    case 38: // $181
      var $182=$i;
      var $183=$swlist;
      var $184=(($183)|0);
      var $185=(($184+($182<<2))|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$swinfo;
      var $188=(($187+8)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=$swinfo;
      var $191=(($190)|0);
      var $192=HEAP32[(($191)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str201688)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$186,HEAP32[((tempInt+4)>>2)]=$189,HEAP32[((tempInt+8)>>2)]=$192,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 8; break; }
    case 39: // $193
      $error=1;
      __label__ = 44; break;
    case 40: // $194
      var $195=$swinfo2;
      var $196=(($195+8)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($197)|0)!=0;
      if ($198) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $199
      var $200=$i;
      var $201=$swlist;
      var $202=(($201)|0);
      var $203=(($202+($200<<2))|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$swinfo;
      var $206=(($205)|0);
      var $207=HEAP32[(($206)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str211689)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$204,HEAP32[((tempInt+4)>>2)]=$207,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 8; break; }
    case 42: // $208
      $error=1;
      __label__ = 43; break;
    case 43: // $209
      __label__ = 44; break;
    case 44: // $210
      __label__ = 45; break;
    case 45: // $211
      var $212=$is_clone;
      var $213=(($212)|0)!=0;
      if ($213) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $214
      var $215=$swinfo;
      var $216=(($215)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(function() { try { __THREW__ = false; return _strlen($217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 8; break; };
    case 47: // $219
      var $220=(($218)>>>0) > 16;
      if ($220) { __label__ = 51; break; } else { __label__ = 48; break; }
    case 48: // $221
      var $222=$is_clone;
      var $223=(($222)|0)!=0;
      if ($223) { __label__ = 53; break; } else { __label__ = 49; break; }
    case 49: // $224
      var $225=$swinfo;
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(function() { try { __THREW__ = false; return _strlen($227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 8; break; };
    case 50: // $229
      var $230=(($228)>>>0) > 8;
      if ($230) { __label__ = 51; break; } else { __label__ = 53; break; }
    case 51: // $231
      var $232=$i;
      var $233=$swlist;
      var $234=(($233)|0);
      var $235=(($234+($232<<2))|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=$swinfo;
      var $238=(($237)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$is_clone;
      var $241=(($240)|0)!=0;
      var $242=$241 ? (((STRING_TABLE.__str231691)|0)) : (((STRING_TABLE.__str241692)|0));
      var $243=$is_clone;
      var $244=(($243)|0)!=0;
      var $245=$244 ? 16 : 8;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str221690)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$236,HEAP32[((tempInt+4)>>2)]=$239,HEAP32[((tempInt+8)>>2)]=$242,HEAP32[((tempInt+12)>>2)]=$245,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 8; break; }
    case 52: // $246
      $error=1;
      __label__ = 53; break;
    case 53: // $247
      var $248=$swinfo;
      var $249=(($248+12)|0);
      var $250=HEAP32[(($249)>>2)];
      $s=$250;
      __label__ = 54; break;
    case 54: // $251
      var $252=$s;
      var $253=HEAP8[($252)];
      var $254=(($253 << 24) >> 24)!=0;
      if ($254) { __label__ = 55; break; } else { __label__ = 63; break; }
    case 55: // $255
      var $256=$s;
      var $257=HEAPU8[($256)];
      var $258=(($257)&255);
      var $259=(function() { try { __THREW__ = false; return _isdigit($258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 8; break; };
    case 56: // $260
      var $261=(($259)|0)!=0;
      if ($261) { __label__ = 61; break; } else { __label__ = 57; break; }
    case 57: // $262
      var $263=$s;
      var $264=HEAP8[($263)];
      var $265=(($264 << 24) >> 24);
      var $266=(($265)|0)!=63;
      if ($266) { __label__ = 58; break; } else { __label__ = 61; break; }
    case 58: // $267
      var $268=$s;
      var $269=HEAP8[($268)];
      var $270=(($269 << 24) >> 24);
      var $271=(($270)|0)!=43;
      if ($271) { __label__ = 59; break; } else { __label__ = 61; break; }
    case 59: // $272
      var $273=$i;
      var $274=$swlist;
      var $275=(($274)|0);
      var $276=(($275+($273<<2))|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$swinfo;
      var $279=(($278)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=$swinfo;
      var $282=(($281+12)|0);
      var $283=HEAP32[(($282)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str251693)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$277,HEAP32[((tempInt+4)>>2)]=$280,HEAP32[((tempInt+8)>>2)]=$283,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 8; break; }
    case 60: // $284
      $error=1;
      __label__ = 63; break;
    case 61: // $285
      __label__ = 62; break;
    case 62: // $286
      var $287=$s;
      var $288=(($287+1)|0);
      $s=$288;
      __label__ = 54; break;
    case 63: // $289
      var $290=$swinfo;
      var $291=(function() { try { __THREW__ = false; return __Z18software_find_partP13software_infoPKcS2_($290, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 8; break; };
    case 64: // $292
      $swpart=$291;
      __label__ = 65; break;
    case 65: // $293
      var $294=$swpart;
      var $295=(($294)|0)!=0;
      if ($295) { __label__ = 66; break; } else { __label__ = 101; break; }
    case 66: // $296
      var $297=$swpart;
      var $298=(($297+4)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=(($299)|0)==0;
      if ($300) { __label__ = 67; break; } else { __label__ = 69; break; }
    case 67: // $301
      var $302=$i;
      var $303=$swlist;
      var $304=(($303)|0);
      var $305=(($304+($302<<2))|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=$swinfo;
      var $308=(($307)|0);
      var $309=HEAP32[(($308)>>2)];
      var $310=$swpart;
      var $311=(($310)|0);
      var $312=HEAP32[(($311)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str261694)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$306,HEAP32[((tempInt+4)>>2)]=$309,HEAP32[((tempInt+8)>>2)]=$312,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 8; break; }
    case 68: // $313
      $error=1;
      __label__ = 69; break;
    case 69: // $314
      var $315=$swpart;
      var $316=(function() { try { __THREW__ = false; return __ZL21software_find_romdataP13software_partPKc($315, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 8; break; };
    case 70: // $317
      var $318=(($316)|0)==0;
      if ($318) { __label__ = 71; break; } else { __label__ = 73; break; }
    case 71: // $319
      var $320=$i;
      var $321=$swlist;
      var $322=(($321)|0);
      var $323=(($322+($320<<2))|0);
      var $324=HEAP32[(($323)>>2)];
      var $325=$swinfo;
      var $326=(($325)|0);
      var $327=HEAP32[(($326)>>2)];
      var $328=$swpart;
      var $329=(($328)|0);
      var $330=HEAP32[(($329)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str271695)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$324,HEAP32[((tempInt+4)>>2)]=$327,HEAP32[((tempInt+8)>>2)]=$330,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 8; break; }
    case 72: // $331
      $error=1;
      __label__ = 73; break;
    case 73: // $332
      var $333=$swpart;
      var $334=(function() { try { __THREW__ = false; return __ZL21software_find_romdataP13software_partPKc($333, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 8; break; };
    case 74: // $335
      $swdata=$334;
      __label__ = 75; break;
    case 75: // $336
      var $337=$swdata;
      var $338=(($337)|0)!=0;
      if ($338) { __label__ = 76; break; } else { __label__ = 98; break; }
    case 76: // $339
      var $340=$swdata;
      $data=$340;
      var $341=$data;
      var $342=(($341)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(($343)|0)!=0;
      if ($344) { __label__ = 77; break; } else { __label__ = 95; break; }
    case 77: // $345
      var $346=$data;
      var $347=(($346+4)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=(($348)|0)!=0;
      if ($349) { __label__ = 78; break; } else { __label__ = 95; break; }
    case 78: // $350
      var $351=$data;
      var $352=(($351)|0);
      var $353=HEAP32[(($352)>>2)];
      $s2=$353;
      __label__ = 79; break;
    case 79: // $354
      var $355=$s2;
      var $356=HEAP8[($355)];
      var $357=(($356 << 24) >> 24)!=0;
      if ($357) { __label__ = 80; break; } else { __label__ = 86; break; }
    case 80: // $358
      var $359=$s2;
      var $360=HEAPU8[($359)];
      var $361=(($360)&255);
      var $362=(function() { try { __THREW__ = false; return _tolower($361) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 8; break; };
    case 81: // $363
      var $364=$s2;
      var $365=HEAP8[($364)];
      var $366=(($365 << 24) >> 24);
      var $367=(($362)|0)!=(($366)|0);
      if ($367) { __label__ = 82; break; } else { __label__ = 84; break; }
    case 82: // $368
      var $369=$i;
      var $370=$swlist;
      var $371=(($370)|0);
      var $372=(($371+($369<<2))|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=$swinfo;
      var $375=(($374)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=$data;
      var $378=(($377)|0);
      var $379=HEAP32[(($378)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str281696)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$373,HEAP32[((tempInt+4)>>2)]=$376,HEAP32[((tempInt+8)>>2)]=$379,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 8; break; }
    case 83: // $380
      $error=1;
      __label__ = 86; break;
    case 84: // $381
      __label__ = 85; break;
    case 85: // $382
      var $383=$s2;
      var $384=(($383+1)|0);
      $s2=$384;
      __label__ = 79; break;
    case 86: // $385
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 8; break; }
    case 87: // $386
      var $387=$data;
      var $388=(($387+4)|0);
      var $389=HEAP32[(($388)>>2)];
      var $390=(function() { try { __THREW__ = false; return __ZN15hash_collection20from_internal_stringEPKc($hashes, $389) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 91; break; };
    case 88: // $391
      if ($390) { __label__ = 92; break; } else { __label__ = 89; break; }
    case 89: // $392
      var $393=$i;
      var $394=$swlist;
      var $395=(($394)|0);
      var $396=(($395+($393<<2))|0);
      var $397=HEAP32[(($396)>>2)];
      var $398=$swinfo;
      var $399=(($398)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=$data;
      var $402=(($401)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=$data;
      var $405=(($404+4)|0);
      var $406=HEAP32[(($405)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str291697)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$397,HEAP32[((tempInt+4)>>2)]=$400,HEAP32[((tempInt+8)>>2)]=$403,HEAP32[((tempInt+12)>>2)]=$406,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $407
      $error=1;
      __label__ = 92; break;
    case 91: // $408
      var $409=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $410=$409.f0;
      $5=$410;
      var $411=$409.f1;
      $6=$411;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 116; break; }
    case 92: // $412
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 8; break; }
    case 93: // $413
      __label__ = 95; break;
    case 94: // $414
      __label__ = 111; break;
    case 95: // $415
      __label__ = 96; break;
    case 96: // $416
      var $417=$swdata;
      var $418=(function() { try { __THREW__ = false; return __ZL21software_romdata_nextP9rom_entry($417) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 8; break; };
    case 97: // $419
      $swdata=$418;
      __label__ = 75; break;
    case 98: // $420
      __label__ = 99; break;
    case 99: // $421
      var $422=$swpart;
      var $423=(function() { try { __THREW__ = false; return __Z18software_part_nextP13software_part($422) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 8; break; };
    case 100: // $424
      $swpart=$423;
      __label__ = 65; break;
    case 101: // $425
      __label__ = 102; break;
    case 102: // $426
      var $427=$list;
      var $428=$swinfo;
      var $429=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($427, ((STRING_TABLE.__str31669)|0), $428) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 8; break; };
    case 103: // $430
      $swinfo=$429;
      __label__ = 11; break;
    case 104: // $431
      var $432=$list;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 8; break; }
    case 105: // $433
      __label__ = 106; break;
    case 106: // $434
      __label__ = 107; break;
    case 107: // $435
      var $436=$i;
      var $437=(($436+1)|0);
      $i=$437;
      __label__ = 2; break;
    case 108: // $438
      var $439=$error;
      $1=$439;
      $7=1;
      __label__ = 109; break;
    case 109: // $440
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP13software_infoED1Ev($descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 7; break; }
    case 110: // $441
      __ZN8tagmap_tIP13software_infoED1Ev($names);
      var $442=$1;
      STACKTOP = __stackBase__;
      return $442;
    case 111: // $443
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP13software_infoED1Ev($descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 116; break; }
    case 112: // $444
      __label__ = 113; break;
    case 113: // $445
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP13software_infoED1Ev($names) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 116; break; }
    case 114: // $446
      __label__ = 115; break;
    case 115: // $447
      var $448=$5;
      var $449=$5;
      var $450=$6;
      var $451=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $449, tempValue);
      var $452=($451.f1 = $450, $451);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 116: // $453
      var $454=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL35device_validity_check_software_listPK11game_driverPK8device_tR11emu_options["X"]=1;

function __Z21legacy_device_creatorI20software_list_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=368;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str131681)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN20software_list_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 172, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI20software_list_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str131681)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI20software_list_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN20software_list_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN18legacy_device_baseD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI20software_list_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI20software_list_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI20software_list_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 368);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI20software_list_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI20software_list_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI20software_list_deviceED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12feature_listEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12feature_listEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12feature_listEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 12);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12feature_listE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12feature_listED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12feature_listED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13software_partEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13software_partEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13software_partEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 16);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13software_partE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13software_partED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13software_partED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13software_infoEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13software_infoEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13software_infoEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 40);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13software_infoE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13software_infoED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13software_infoED2Ev($2);
  ;
  return;
}


function __ZN20software_list_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20software_list_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20software_list_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI20software_list_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI20software_list_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI20software_list_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI20software_list_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI20software_list_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI20software_list_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI20software_list_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI20software_list_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI12feature_listED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12feature_listED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12feature_listED0Ev["X"]=1;

function __ZN20resource_pool_objectI12feature_listED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI12feature_listE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI13software_partED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13software_partED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13software_partED0Ev["X"]=1;

function __ZN20resource_pool_objectI13software_partED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI13software_partE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt9exceptionC2ERKS_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  HEAP32[(($5)>>2)]=((__ZTVSt9exception+8)|0);
  ;
  return;
}


function __ZL21software_romdata_nextP9rom_entry($romdata) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$romdata;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10+20)|0);
      $1=$11;
      __label__ = 4; break;
    case 3: // $12
      $1=0;
      __label__ = 4; break;
    case 4: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11tagmap_hashPKc1743($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIiEC1EPii($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIiEC2EPii($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIiEC2EPii($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<2))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIiE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIiED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIiED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP13software_infoEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP13software_infoEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP13software_infoE3addEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z10tagmap_addP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZNK8tagmap_tIP13software_infoE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL11tagmap_findPK7_tagmapPKc($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZL21software_find_romdataP13software_partPKc($swpart, $dataname) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $data;
      $1=$swpart;
      $2=$dataname;
      var $3=$1;
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      $data=$11;
      var $12=$data;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      var $16=$data;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 6; break; } else { var $24 = 0;__label__ = 7; break; }
    case 6: // $18
      var $19=$data;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      var $24 = $22;__label__ = 7; break;
    case 7: // $23
      var $24;
      if ($24) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $25
      var $26=$2;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $28
      var $29=$2;
      var $30=$data;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=_strcmp($29, $32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $35
      __label__ = 14; break;
    case 11: // $36
      __label__ = 13; break;
    case 12: // $37
      __label__ = 14; break;
    case 13: // $38
      var $39=$data;
      var $40=(($39+20)|0);
      $data=$40;
      __label__ = 5; break;
    case 14: // $41
      __label__ = 15; break;
    case 15: // $42
      var $43=$data;
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $47
      $data=0;
      __label__ = 17; break;
    case 17: // $48
      var $49=$data;
      ;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21software_find_romdataP13software_partPKc["X"]=1;

function __ZN8tagmap_tIP13software_infoED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP13software_infoED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP13software_infoED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP13software_infoE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP13software_infoE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZL11tagmap_findPK7_tagmapPKc($map, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$map;
  $2=$tag;
  var $3=$1;
  var $4=$2;
  var $5=$2;
  var $6=__ZL11tagmap_hashPKc1743($5);
  var $7=__ZL21tagmap_find_prehashedPK7_tagmapPKcj($3, $4, $6);
  ;
  return $7;
}


function __ZL21tagmap_find_prehashedPK7_tagmapPKcj($map, $tag, $fullhash) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $entry;
      $2=$map;
      $3=$tag;
      $4=$fullhash;
      var $5=$4;
      var $6=(($5)>>>0)%97;
      var $7=$2;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      $entry=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $14
      var $15=$entry;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$4;
      var $19=(($17)|0)==(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=$entry;
      var $22=(($21+12)|0);
      var $23=(($22)|0);
      var $24=$3;
      var $25=_strcmp($23, $24);
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$entry;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      $1=$30;
      __label__ = 8; break;
    case 5: // $31
      __label__ = 6; break;
    case 6: // $32
      var $33=$entry;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      $entry=$35;
      __label__ = 1; break;
    case 7: // $36
      $1=0;
      __label__ = 8; break;
    case 8: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIP13software_infoEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN14emu_fatalerrorC2ERKS_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  var $4;
  $2=$this;
  $3=$0;
  var $5=$2;
  var $6=$5;
  var $7=$3;
  var $8=$7;
  __ZN13emu_exceptionC2ERKS_($6, $8);
  var $9=$5;
  HEAP32[(($9)>>2)]=((__ZTV14emu_fatalerror+8)|0);
  var $10=(($5+4)|0);
  var $11=$10;
  $4=0;
  var $12=$3;
  var $13=(($12+4)|0);
  var $14=$13;
  assert(1024 % 1 === 0, 'memcpy given ' + 1024 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($11, $14, 1024, 1);
  var $15=(($5+1028)|0);
  var $16=$3;
  var $17=(($16+1028)|0);
  var $18=HEAP32[(($17)>>2)];
  HEAP32[(($15)>>2)]=$18;
  ;
  return;
}


function __ZN13emu_exceptionC2ERKS_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZNSt9exceptionC2ERKS_($5, $7);
  var $8=$4;
  HEAP32[(($8)>>2)]=((__ZTV13emu_exception+8)|0);
  ;
  return;
}


function __ZL13add_rom_entryP14_software_listPKcS2_jjj($swlist, $name, $hashdata, $offset, $length, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $part;
      var $entry;
      var $new_entries;
      $1=$swlist;
      $2=$name;
      $3=$hashdata;
      $4=$offset;
      $5=$length;
      $6=$flags;
      var $7=$1;
      var $8=(($7+56)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9-1)|0);
      var $11=$1;
      var $12=(($11+44)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+32)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+($10<<4))|0);
      $part=$16;
      var $17=$1;
      var $18=(($17+64)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$part;
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+$19*20)|0);
      $entry=$23;
      var $24=$2;
      var $25=$entry;
      var $26=(($25)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$3;
      var $28=$entry;
      var $29=(($28+4)|0);
      HEAP32[(($29)>>2)]=$27;
      var $30=$4;
      var $31=$entry;
      var $32=(($31+8)|0);
      HEAP32[(($32)>>2)]=$30;
      var $33=$5;
      var $34=$entry;
      var $35=(($34+12)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$6;
      var $37=$entry;
      var $38=(($37+16)|0);
      HEAP32[(($38)>>2)]=$36;
      var $39=$1;
      var $40=(($39+64)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+1)|0);
      HEAP32[(($40)>>2)]=$42;
      var $43=$1;
      var $44=(($43+64)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+60)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($45)|0) >= (($48)|0);
      if ($49) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $50
      var $51=$1;
      var $52=(($51+60)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+10)|0);
      HEAP32[(($52)>>2)]=$54;
      var $55=$1;
      var $56=(($55+4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$part;
      var $59=(($58+12)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$60;
      var $62=$1;
      var $63=(($62+60)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64*20)|0);
      var $66=__Z22pool_realloc_file_lineP12_object_poolPvjPKci($57, $61, $65, ((STRING_TABLE.__str11667)|0), 188);
      var $67=$66;
      $new_entries=$67;
      var $68=$new_entries;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $70
      var $71=$new_entries;
      var $72=$part;
      var $73=(($72+12)|0);
      HEAP32[(($73)>>2)]=$71;
      __label__ = 4; break;
    case 3: // $74
      var $75=$1;
      var $76=(($75+64)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77-1)|0);
      HEAP32[(($76)>>2)]=$78;
      __label__ = 4; break;
    case 4: // $79
      __label__ = 5; break;
    case 5: // $80
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13add_rom_entryP14_software_listPKcS2_jjj["X"]=1;

function __ZL17add_software_partP14_software_listPKcS2_($swlist, $name, $interface) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $part;
      var $new_parts;
      $1=$swlist;
      $2=$name;
      $3=$interface;
      var $4=$1;
      var $5=(($4+56)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$1;
      var $8=(($7+44)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+32)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+($6<<4))|0);
      $part=$12;
      var $13=$2;
      var $14=$part;
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$3;
      var $17=$part;
      var $18=(($17+4)|0);
      HEAP32[(($18)>>2)]=$16;
      var $19=$part;
      var $20=(($19+8)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=$part;
      var $22=(($21+12)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=$1;
      var $24=(($23+56)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+1)|0);
      HEAP32[(($24)>>2)]=$26;
      var $27=$1;
      var $28=(($27+56)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$1;
      var $31=(($30+52)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($29)|0) >= (($32)|0);
      if ($33) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $34
      var $35=$1;
      var $36=(($35+52)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+2)|0);
      HEAP32[(($36)>>2)]=$38;
      var $39=$1;
      var $40=(($39+4)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+44)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+32)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$46;
      var $48=$1;
      var $49=(($48+52)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=((($50<<4))|0);
      var $52=__Z22pool_realloc_file_lineP12_object_poolPvjPKci($41, $47, $51, ((STRING_TABLE.__str11667)|0), 301);
      var $53=$52;
      $new_parts=$53;
      var $54=$new_parts;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $56
      var $57=$new_parts;
      var $58=$1;
      var $59=(($58+44)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+32)|0);
      HEAP32[(($61)>>2)]=$57;
      __label__ = 4; break;
    case 3: // $62
      var $63=$1;
      var $64=(($63+56)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65-1)|0);
      HEAP32[(($64)>>2)]=$66;
      __label__ = 4; break;
    case 4: // $67
      __label__ = 5; break;
    case 5: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17add_software_partP14_software_listPKcS2_["X"]=1;

function __ZN20resource_pool_objectI13software_infoED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13software_infoED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13software_infoED0Ev["X"]=1;

function __ZN20resource_pool_objectI13software_infoED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI13software_infoE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIiED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIiED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIiED0Ev["X"]=1;

function __ZN19resource_pool_arrayIiED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIiE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16dump_unfreed_memv() {
  ;
  var __label__;

  ;
  return;
}


function __Z12track_memoryb($track) {
  ;
  var __label__;

  var $1;
  var $2=(($track)&1);
  $1=$2;
  var $3=$1;
  var $4=(($3) & 1);
  var $5=(($4)&1);
  HEAP8[(__ZN12memory_entry10s_trackingE)]=$5;
  ;
  return;
}


function __ZL11add_featureP14_software_listPcS1_($swlist, $feature_name, $feature_value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $part;
      var $new_entry;
      var $list;
      $1=$swlist;
      $2=$feature_name;
      $3=$feature_value;
      var $4=$1;
      var $5=(($4+56)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6-1)|0);
      var $8=$1;
      var $9=(($8+44)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+32)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+($7<<4))|0);
      $part=$13;
      var $14=$1;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z21pool_malloc_file_lineP12_object_pooljPKci($16, 12, ((STRING_TABLE.__str11667)|0), 212);
      var $18=$17;
      $new_entry=$18;
      var $19=$new_entry;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $21
      var $22=$new_entry;
      var $23=(($22)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=$2;
      var $25=$new_entry;
      var $26=(($25+4)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$3;
      var $28=(($27)|0)!=0;
      var $29=$3;
      var $30=$2;
      var $31=$28 ? $29 : $30;
      var $32=$new_entry;
      var $33=(($32+8)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$part;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $38
      var $39=$part;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      $list=$41;
      __label__ = 3; break;
    case 3: // $42
      var $43=$list;
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $47
      var $48=$list;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      $list=$50;
      __label__ = 3; break;
    case 5: // $51
      var $52=$new_entry;
      var $53=$list;
      var $54=(($53)|0);
      HEAP32[(($54)>>2)]=$52;
      __label__ = 7; break;
    case 6: // $55
      var $56=$new_entry;
      var $57=$part;
      var $58=(($57+8)|0);
      HEAP32[(($58)>>2)]=$56;
      __label__ = 7; break;
    case 7: // $59
      __label__ = 9; break;
    case 8: // $60
      __label__ = 9; break;
    case 9: // $61
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11add_featureP14_software_listPcS1_["X"]=1;

function __ZL11unknown_tagP12_parse_statePKc($state, $tagname) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  $1=$state;
  $2=$tagname;
  var $3=$1;
  var $4=$1;
  var $5=(($4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=_XML_GetCurrentLineNumber($6);
  var $8=$1;
  var $9=(($8)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=_XML_GetCurrentColumnNumber($10);
  var $12=$2;
  __ZL11parse_errorP12_parse_statePKcz($3, ((STRING_TABLE.__str741742)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$7,HEAP32[((tempInt+4)>>2)]=$11,HEAP32[((tempInt+8)>>2)]=$12,tempInt));
  STACKTOP = __stackBase__;
  return;
}


function __ZL8add_infoP14_software_listPcS1_($swlist, $feature_name, $feature_value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $info;
      var $new_entry;
      var $list;
      $1=$swlist;
      $2=$feature_name;
      $3=$feature_value;
      var $4=$1;
      var $5=(($4+44)|0);
      var $6=HEAP32[(($5)>>2)];
      $info=$6;
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__Z21pool_malloc_file_lineP12_object_pooljPKci($9, 12, ((STRING_TABLE.__str11667)|0), 252);
      var $11=$10;
      $new_entry=$11;
      var $12=$new_entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $14
      var $15=$new_entry;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=$2;
      var $18=$new_entry;
      var $19=(($18+4)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$3;
      var $21=(($20)|0)!=0;
      var $22=$3;
      var $23=$2;
      var $24=$21 ? $22 : $23;
      var $25=$new_entry;
      var $26=(($25+8)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$info;
      var $28=(($27+24)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $31
      var $32=$info;
      var $33=(($32+24)|0);
      var $34=HEAP32[(($33)>>2)];
      $list=$34;
      __label__ = 3; break;
    case 3: // $35
      var $36=$list;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=$list;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      $list=$43;
      __label__ = 3; break;
    case 5: // $44
      var $45=$new_entry;
      var $46=$list;
      var $47=(($46)|0);
      HEAP32[(($47)>>2)]=$45;
      __label__ = 7; break;
    case 6: // $48
      var $49=$new_entry;
      var $50=$info;
      var $51=(($50+24)|0);
      HEAP32[(($51)>>2)]=$49;
      __label__ = 7; break;
    case 7: // $52
      __label__ = 9; break;
    case 8: // $53
      __label__ = 9; break;
    case 9: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8add_infoP14_software_listPcS1_["X"]=1;

function ___cxx_global_var_init() {
  ;
  var __label__;

  FUNCTION_TABLE[__ZN13resource_poolC1Ei](_global_resource_pool, 6151);
  var $1=___cxa_atexit(176, _global_resource_pool, ___dso_handle);
  ;
  return;
}


function __Z16malloc_file_linejPKci($size, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $result;
      $2=$size;
      $3=$file;
      $4=$line;
      var $5=$2;
      var $6=_osd_malloc($5);
      $result=$6;
      var $7=$result;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=$2;
      var $12=$result;
      var $13=$3;
      var $14=$4;
      var $15=__ZN12memory_entry8allocateEjPvPKci($11, $12, $13, $14);
      var $16=$result;
      $1=$16;
      __label__ = 3; break;
    case 3: // $17
      var $18=$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12memory_entry8allocateEjPvPKci($size, $base, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $entry;
      var $entrynum;
      var $entry1;
      var $hashval;
      $2=$size;
      $3=$base;
      $4=$file;
      $5=$line;
      __ZN12memory_entry12acquire_lockEv();
      var $6=HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $8
      var $9=_osd_malloc_array(8192);
      var $10=$9;
      $entry=$10;
      var $11=$entry;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      __ZN12memory_entry12release_lockEv();
      $1=0;
      __label__ = 17; break;
    case 3: // $14
      $entrynum=0;
      __label__ = 4; break;
    case 4: // $15
      var $16=$entrynum;
      var $17=(($16)|0) < 256;
      if ($17) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $18
      var $19=HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)];
      var $20=$entry;
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$entry;
      var $23=(($22+32)|0);
      $entry=$23;
      HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)]=$22;
      __label__ = 6; break;
    case 6: // $24
      var $25=$entrynum;
      var $26=(($25+1)|0);
      $entrynum=$26;
      __label__ = 4; break;
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)];
      $entry1=$29;
      var $30=$entry1;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)]=$32;
      var $33=$2;
      var $34=$entry1;
      var $35=(($34+8)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$3;
      var $37=$entry1;
      var $38=(($37+12)|0);
      HEAP32[(($38)>>2)]=$36;
      var $39=HEAP8[(__ZN12memory_entry10s_trackingE)];
      var $40=(($39) & 1);
      if ($40) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $41
      var $42=$4;
      var $45 = $42;__label__ = 11; break;
    case 10: // $43
      var $45 = 0;__label__ = 11; break;
    case 11: // $44
      var $45;
      var $46=$entry1;
      var $47=(($46+16)|0);
      HEAP32[(($47)>>2)]=$45;
      var $48=HEAP8[(__ZN12memory_entry10s_trackingE)];
      var $49=(($48) & 1);
      if ($49) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $50
      var $51=$5;
      var $54 = $51;__label__ = 14; break;
    case 13: // $52
      var $54 = 0;__label__ = 14; break;
    case 14: // $53
      var $54;
      var $55=$entry1;
      var $56=(($55+20)|0);
      HEAP32[(($56)>>2)]=$54;
      var $st$4$0=((__ZN12memory_entry7s_curidE)|0);
      var $57$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=((__ZN12memory_entry7s_curidE+4)|0);
      var $57$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $58$0 = ((($57$0)>>>0)+((($57$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $58$1 = Math.min(Math.floor((((($57$0)>>>0)+((($57$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$11$0=((__ZN12memory_entry7s_curidE)|0);
      HEAP32[(($st$11$0)>>2)]=$58$0;
      var $st$11$1=((__ZN12memory_entry7s_curidE+4)|0);
      HEAP32[(($st$11$1)>>2)]=$58$1;
      var $59=$entry1;
      var $60=(($59+24)|0);
      var $st$17$0=(($60)|0);
      HEAP32[(($st$17$0)>>2)]=$57$0;
      var $st$17$1=(($60+4)|0);
      HEAP32[(($st$17$1)>>2)]=$57$1;
      var $61=$3;
      var $62=$61;
      var $63=(($62)>>>0)%6151;
      $hashval=$63;
      var $64=$hashval;
      var $65=((__ZN12memory_entry6s_hashE+($64<<2))|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$entry1;
      var $68=(($67)|0);
      HEAP32[(($68)>>2)]=$66;
      var $69=$entry1;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $73
      var $74=$entry1;
      var $75=$entry1;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+4)|0);
      HEAP32[(($78)>>2)]=$74;
      __label__ = 16; break;
    case 16: // $79
      var $80=$entry1;
      var $81=(($80+4)|0);
      HEAP32[(($81)>>2)]=0;
      var $82=$entry1;
      var $83=$hashval;
      var $84=((__ZN12memory_entry6s_hashE+($83<<2))|0);
      HEAP32[(($84)>>2)]=$82;
      __ZN12memory_entry12release_lockEv();
      var $85=$entry1;
      $1=$85;
      __label__ = 17; break;
    case 17: // $86
      var $87=$1;
      ;
      return $87;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12memory_entry8allocateEjPvPKci["X"]=1;

function __Z22malloc_array_file_linejPKci($size, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $result;
      $2=$size;
      $3=$file;
      $4=$line;
      var $5=$2;
      var $6=_osd_malloc_array($5);
      $result=$6;
      var $7=$result;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=$2;
      var $12=$result;
      var $13=$3;
      var $14=$4;
      var $15=__ZN12memory_entry8allocateEjPvPKci($11, $12, $13, $14);
      var $16=$result;
      $1=$16;
      __label__ = 3; break;
    case 3: // $17
      var $18=$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14free_file_linePvPKci($memory, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      $1=$memory;
      $2=$file;
      $3=$line;
      var $4=$1;
      var $5=__ZN12memory_entry4findEPv($4);
      $entry=$5;
      var $6=$entry;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=HEAP32[((__impure_ptr)>>2)];
      var $10=(($9+12)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=$3;
      var $14=_fprintf($11, ((STRING_TABLE.__str1748)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$12,HEAP32[((tempInt+4)>>2)]=$13,tempInt));
      _osd_break_into_debugger(((STRING_TABLE.__str11749)|0));
      __label__ = 3; break;
    case 2: // $15
      var $16=$entry;
      __ZN12memory_entry7releaseEPS_($16);
      var $17=$1;
      _osd_free($17);
      __label__ = 3; break;
    case 3: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12memory_entry4findEPv($ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hashval;
      var $entry;
      $2=$ptr;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 9; break;
    case 2: // $6
      __ZN12memory_entry12acquire_lockEv();
      var $7=$2;
      var $8=$7;
      var $9=(($8)>>>0)%6151;
      $hashval=$9;
      var $10=$hashval;
      var $11=((__ZN12memory_entry6s_hashE+($10<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      $entry=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$entry;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $16
      var $17=$entry;
      var $18=(($17+12)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=(($19)|0)==(($20)|0);
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      __label__ = 8; break;
    case 6: // $23
      __label__ = 7; break;
    case 7: // $24
      var $25=$entry;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      $entry=$27;
      __label__ = 3; break;
    case 8: // $28
      __ZN12memory_entry12release_lockEv();
      var $29=$entry;
      $1=$29;
      __label__ = 9; break;
    case 9: // $30
      var $31=$1;
      ;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12memory_entry7releaseEPS_($entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hashval;
      $1=$entry;
      __ZN12memory_entry12acquire_lockEv();
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4;
      var $6=(($5)>>>0)%6151;
      $hashval=$6;
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$1;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$1;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0);
      HEAP32[(($18)>>2)]=$14;
      __label__ = 3; break;
    case 2: // $19
      var $20=$1;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$hashval;
      var $24=((__ZN12memory_entry6s_hashE+($23<<2))|0);
      HEAP32[(($24)>>2)]=$22;
      __label__ = 3; break;
    case 3: // $25
      var $26=$1;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$1;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+4)|0);
      HEAP32[(($37)>>2)]=$33;
      __label__ = 5; break;
    case 5: // $38
      var $39=HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)];
      var $40=$1;
      var $41=(($40)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$1;
      HEAP32[((__ZN12memory_entry10s_freeheadE)>>2)]=$42;
      __ZN12memory_entry12release_lockEv();
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12memory_entry7releaseEPS_["X"]=1;

function __ZN13resource_pool5clearEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      _osd_lock_acquire($4);
      __label__ = 1; break;
    case 1: // $5
      var $6=(($2+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=(($2+12)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      __ZN13resource_pool6removeEPv($2, $13);
      __label__ = 1; break;
    case 3: // $14
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      _osd_lock_release($16);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool3addER18resource_pool_item($this, $item) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hashval;
      var $entry;
      var $insert_after;
      $1=$this;
      $2=$item;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      _osd_lock_acquire($5);
      var $6=$2;
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=(($3)|0);
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($9)>>>0)%(($11)>>>0);
      $hashval=$12;
      var $13=$hashval;
      var $14=(($3+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+($13<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=(($18+4)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$2;
      var $21=$hashval;
      var $22=(($3+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+($21<<2))|0);
      HEAP32[(($24)>>2)]=$20;
      var $25=$2;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__ZN12memory_entry4findEPv($27);
      $entry=$28;
      var $29=$entry;
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $31
      var $32=$2;
      var $33=(($32+16)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34-4)|0);
      var $36=__ZN12memory_entry4findEPv($35);
      $entry=$36;
      __label__ = 2; break;
    case 2: // $37
      __label__ = 3; break;
    case 3: // $38
      __label__ = 4; break;
    case 4: // $39
      var $40=$entry;
      var $41=(($40+24)|0);
      var $st$2$0=(($41)|0);
      var $42$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$2$1)>>2)];
      var $43=$2;
      var $44=(($43+24)|0);
      var $st$8$0=(($44)|0);
      HEAP32[(($st$8$0)>>2)]=$42$0;
      var $st$8$1=(($44+4)|0);
      HEAP32[(($st$8$1)>>2)]=$42$1;
      var $45=(($3+16)|0);
      var $46=HEAP32[(($45)>>2)];
      $insert_after=$46;
      __label__ = 5; break;
    case 5: // $47
      var $48=$insert_after;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $50
      var $51=$insert_after;
      var $52=(($51+24)|0);
      var $st$2$0=(($52)|0);
      var $53$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($52+4)|0);
      var $53$1=HEAP32[(($st$2$1)>>2)];
      var $54=$2;
      var $55=(($54+24)|0);
      var $st$8$0=(($55)|0);
      var $56$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($55+4)|0);
      var $56$1=HEAP32[(($st$8$1)>>2)];
      var $57=$53$1 < $56$1 || ($53$1 == $56$1 && $53$0 < $56$0);
      if ($57) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $58
      __label__ = 10; break;
    case 8: // $59
      __label__ = 9; break;
    case 9: // $60
      var $61=$insert_after;
      var $62=(($61+12)|0);
      var $63=HEAP32[(($62)>>2)];
      $insert_after=$63;
      __label__ = 5; break;
    case 10: // $64
      var $65=$insert_after;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $67
      var $68=$insert_after;
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$2;
      var $72=(($71+8)|0);
      HEAP32[(($72)>>2)]=$70;
      var $73=$2;
      var $74=(($73+8)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $77
      var $78=$2;
      var $79=$2;
      var $80=(($79+8)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+12)|0);
      HEAP32[(($82)>>2)]=$78;
      __label__ = 14; break;
    case 13: // $83
      var $84=$2;
      var $85=(($3+16)|0);
      HEAP32[(($85)>>2)]=$84;
      __label__ = 14; break;
    case 14: // $86
      var $87=$insert_after;
      var $88=$2;
      var $89=(($88+12)|0);
      HEAP32[(($89)>>2)]=$87;
      var $90=$2;
      var $91=$insert_after;
      var $92=(($91+8)|0);
      HEAP32[(($92)>>2)]=$90;
      __label__ = 19; break;
    case 15: // $93
      var $94=(($3+12)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      var $97=(($96+8)|0);
      HEAP32[(($97)>>2)]=$95;
      var $98=$2;
      var $99=(($98+8)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $102
      var $103=$2;
      var $104=$2;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+12)|0);
      HEAP32[(($107)>>2)]=$103;
      __label__ = 18; break;
    case 17: // $108
      var $109=$2;
      var $110=(($3+16)|0);
      HEAP32[(($110)>>2)]=$109;
      __label__ = 18; break;
    case 18: // $111
      var $112=$2;
      var $113=(($112+12)|0);
      HEAP32[(($113)>>2)]=0;
      var $114=$2;
      var $115=(($3+12)|0);
      HEAP32[(($115)>>2)]=$114;
      __label__ = 19; break;
    case 19: // $116
      var $117=(($3+4)|0);
      var $118=HEAP32[(($117)>>2)];
      _osd_lock_release($118);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool3addER18resource_pool_item["X"]=1;

function __ZN13resource_poolC2Ei($this, $hash_size) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $result_i=__stackBase__+4;
      var $2=__stackBase__+8;
      var $3=__stackBase__+12;
      var $4;
      var $5;
      $4=$this;
      $5=$hash_size;
      var $6=$4;
      var $7=(($6)|0);
      var $8=$5;
      HEAP32[(($7)>>2)]=$8;
      var $9=(($6+4)|0);
      var $10=_osd_lock_alloc();
      HEAP32[(($9)>>2)]=$10;
      var $11=(($6+8)|0);
      var $12=$5;
      var $13=_llvm_umul_with_overflow_i32($12, 4);
      var $14=$13.f1;
      var $15=$13.f0;
      var $16=$14 ? -1 : $15;
      var $17=$1;
      var $18=$result_i;
      var $19=$2;
      var $20=$3;
      HEAP32[(($1)>>2)]=$16;
      var $21=HEAP32[(($1)>>2)];
      var $22=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($21, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $23
      HEAP32[(($result_i)>>2)]=$22;
      var $24=HEAP32[(($result_i)>>2)];
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $26
      var $27=___cxa_allocate_exception(4);
      var $28=$27;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28);
      (function() { try { __THREW__ = false; return ___cxa_throw($27, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      HEAP32[(($2)>>2)]=$31;
      var $32=$30.f1;
      HEAP32[(($3)>>2)]=$32;
      var $33=HEAP32[(($3)>>2)];
      var $34=(($33)|0) < 0;
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($36);
      throw "Reached an unreachable!"
    case 5: // $37
      var $38=HEAP32[(($2)>>2)];
      var $39=HEAP32[(($2)>>2)];
      var $40=HEAP32[(($3)>>2)];
      var $41=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39, tempValue);
      var $42=($41.f1 = $40, $41);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $43
      throw "Reached an unreachable!"
    case 7: // $_Znaj_exit
      var $44=HEAP32[(($result_i)>>2)];
      var $45=$1;
      var $46=$result_i;
      var $47=$2;
      var $48=$3;
      var $49=$44;
      HEAP32[(($11)>>2)]=$49;
      var $50=(($6+12)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=(($6+16)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=(($6+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$53;
      var $55=$5;
      var $56=((($55<<2))|0);
      _memset($54, 0, $56, 1);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_poolC2Ei["X"]=1;

function __ZN13resource_poolD2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      __ZN13resource_pool5clearEv($5);
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=(($5+4)|0);
      var $11=HEAP32[(($10)>>2)];
      _osd_lock_free($11);
      __label__ = 2; break;
    case 2: // $12
      var $13=(($5+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 8; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$14;
      var $18=$1;
      var $19=$2;
      var $20=$3;
      HEAP32[(($1)>>2)]=$17;
      var $21=HEAP32[(($1)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $23
      var $24=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      __label__ = 7; break;
    case 6: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($2)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($3)>>2)]=$29;
      var $30=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 7: // $_ZdaPv_exit
      var $31=$1;
      var $32=$2;
      var $33=$3;
      __label__ = 8; break;
    case 8: // $34
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool6removeEPv($this, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hashval;
      var $scanptr;
      var $deleteme;
      $1=$this;
      $2=$ptr;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 17; break;
    case 2: // $7
      var $8=(($3+4)|0);
      var $9=HEAP32[(($8)>>2)];
      _osd_lock_acquire($9);
      var $10=$2;
      var $11=$10;
      var $12=(($3)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($11)>>>0)%(($13)>>>0);
      $hashval=$14;
      var $15=$hashval;
      var $16=(($3+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+($15<<2))|0);
      $scanptr=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$scanptr;
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $23
      var $24=$scanptr;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$2;
      var $29=(($27)|0)==(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $30
      var $31=$scanptr;
      var $32=HEAP32[(($31)>>2)];
      $deleteme=$32;
      var $33=$deleteme;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$scanptr;
      HEAP32[(($36)>>2)]=$35;
      var $37=$deleteme;
      var $38=(($37+12)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$deleteme;
      var $43=(($42+8)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$deleteme;
      var $46=(($45+12)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+8)|0);
      HEAP32[(($48)>>2)]=$44;
      __label__ = 8; break;
    case 7: // $49
      var $50=$deleteme;
      var $51=(($50+8)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($3+12)|0);
      HEAP32[(($53)>>2)]=$52;
      __label__ = 8; break;
    case 8: // $54
      var $55=$deleteme;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $59
      var $60=$deleteme;
      var $61=(($60+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$deleteme;
      var $64=(($63+8)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+12)|0);
      HEAP32[(($66)>>2)]=$62;
      __label__ = 11; break;
    case 10: // $67
      var $68=$deleteme;
      var $69=(($68+12)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($3+16)|0);
      HEAP32[(($71)>>2)]=$70;
      __label__ = 11; break;
    case 11: // $72
      var $73=$deleteme;
      var $74=(($73)|0)==0;
      if ($74) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $75
      var $76=$73;
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+4)|0);
      var $79=HEAP32[(($78)>>2)];
      FUNCTION_TABLE[$79]($73);
      __label__ = 13; break;
    case 13: // $80
      __label__ = 16; break;
    case 14: // $81
      __label__ = 15; break;
    case 15: // $82
      var $83=$scanptr;
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+4)|0);
      $scanptr=$85;
      __label__ = 3; break;
    case 16: // $86
      var $87=(($3+4)|0);
      var $88=HEAP32[(($87)>>2)];
      _osd_lock_release($88);
      __label__ = 17; break;
    case 17: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool6removeEPv["X"]=1;

function __ZN12memory_entry12acquire_lockEv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=HEAP32[((__ZN12memory_entry6s_lockE)>>2)];
      var $2=(($1)|0)==0;
      if ($2) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $3
      var $4=HEAP8[(__ZN12memory_entry12s_lock_allocE)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $6
      __label__ = 5; break;
    case 3: // $7
      HEAP8[(__ZN12memory_entry12s_lock_allocE)]=1;
      var $8=_osd_lock_alloc();
      HEAP32[((__ZN12memory_entry6s_lockE)>>2)]=$8;
      HEAP8[(__ZN12memory_entry12s_lock_allocE)]=0;
      __label__ = 4; break;
    case 4: // $9
      var $10=HEAP32[((__ZN12memory_entry6s_lockE)>>2)];
      _osd_lock_acquire($10);
      __label__ = 5; break;
    case 5: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12memory_entry12release_lockEv() {
  ;
  var __label__;

  var $1=HEAP32[((__ZN12memory_entry6s_lockE)>>2)];
  _osd_lock_release($1);
  ;
  return;
}


function __GLOBAL__I_a() {
  ;
  var __label__;

  ___cxx_global_var_init();
  ;
  return;
}


function __ZN12cli_frontendC2ER11cli_optionsR13osd_interface($this, $options, $osd) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$options;
  $3=$osd;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($4+8)|0);
  HEAP32[(($9)>>2)]=0;
  __Z12track_memoryb(1);
  ;
  return;
}


function __ZN12cli_frontendD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __Z12track_memoryb(0);
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __Z16dump_unfreed_memv();
      __label__ = 2; break;
    case 2: // $7
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cli_optionsC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      __ZN11emu_optionsC2Ev($5);
      var $6=$4;
      HEAP32[(($6)>>2)]=((__ZTV11cli_options+8)|0);
      var $7=$4;
      (function() { try { __THREW__ = false; return __ZN12core_options11add_entriesEPK13options_entryb($7, ((__ZN11cli_options16s_option_entriesE)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN11emu_optionsD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12cli_frontend7executeEiPPc($this, $argc, $argv) {
  var __stackBase__  = STACKTOP; STACKTOP += 880; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $option_errors=__stackBase__;
      var $4;
      var $5;
      var $exename=__stackBase__+64;
      var $system;
      var $config=__stackBase__+128;
      var $found;
      var $swlists;
      var $swlist;
      var $i;
      var $list;
      var $swinfo;
      var $swpart;
      var $mount;
      var $image=__stackBase__+604;
      var $gotone;
      var $interface;
      var $option;
      var $val=__stackBase__+608;
      var $error=__stackBase__+672;
      var $6;
      var $7;
      var $fatal;
      var $string=__stackBase__+736;
      var $drivlist=__stackBase__+800;
      var $matches=__stackBase__+840;
      var $matchnum;
      $1=$this;
      $2=$argc;
      $3=$argv;
      var $8=$1;
      var $9=(($8+8)|0);
      HEAP32[(($9)>>2)]=0;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $10
      var $11=(($8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      var $14=$2;
      var $15=$3;
      var $16=(function() { try { __THREW__ = false; return __ZN11emu_options18parse_command_lineEiPPcR7astring($13, $14, $15, $option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $17
      if ($16) { __label__ = 22; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=(($8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      var $22=(function() { try { __THREW__ = false; return __ZNK12core_options7commandEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 15; break; };
    case 4: // $23
      var $24=(function() { try { __THREW__ = false; return _strlen($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; };
    case 5: // $25
      var $26=(($24)|0)==0;
      if ($26) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $27
      var $28=(($8)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=(function() { try { __THREW__ = false; return __ZNK11emu_options6systemEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 15; break; };
    case 7: // $32
      var $33=(($31)|0)==0;
      if ($33) { __label__ = 8; break; } else { __label__ = 17; break; }
    case 8: // $34
      var $35=(($8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36;
      var $38=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 15; break; };
    case 9: // $39
      var $40=(function() { try { __THREW__ = false; return _strlen($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; };
    case 10: // $41
      var $42=(($40)>>>0) > 0;
      if ($42) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $43
      var $44=___cxa_allocate_exception(1032);
      var $45=$44;
      var $46=(($8)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$47;
      var $49=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; };
    case 12: // $50
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($45, 5, ((STRING_TABLE.__str441807)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $51
      (function() { try { __THREW__ = false; return ___cxa_throw($44, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 215; break; } else { __label__ = 15; break; }
    case 14: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $54=$53.f0;
      $4=$54;
      var $55=$53.f1;
      $5=$55;
      __label__ = 152; break;
    case 15: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $58=$57.f0;
      $4=$58;
      var $59=$57.f1;
      $5=$59;
      __label__ = 150; break;
    case 16: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $62=$61.f0;
      $4=$62;
      var $63=$61.f1;
      $5=$63;
      ___cxa_free_exception($44);
      __label__ = 150; break;
    case 17: // $64
      var $65=___cxa_allocate_exception(1032);
      var $66=$65;
      var $67=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 21; break; };
    case 18: // $68
      var $69=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; };
    case 19: // $70
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($66, 6, ((STRING_TABLE.__str451808)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$69,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $71
      (function() { try { __THREW__ = false; return ___cxa_throw($65, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 215; break; } else { __label__ = 15; break; }
    case 21: // $72
      var $73=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $74=$73.f0;
      $4=$74;
      var $75=$73.f1;
      $5=$75;
      ___cxa_free_exception($65);
      __label__ = 150; break;
    case 22: // $76
      var $77=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; };
    case 23: // $78
      if ($77) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $79
      var $80=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $81
      var $82=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 15; break; };
    case 26: // $83
      var $84=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str461809)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 15; break; };
    case 27: // $85
      __label__ = 28; break;
    case 28: // $86
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($exename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 15; break; }
    case 29: // $87
      var $88=$3;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($exename, $90, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 36; break; };
    case 30: // $92
      var $93=(($8)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$94;
      var $96=(function() { try { __THREW__ = false; return __ZNK12core_options7commandEv($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 36; break; };
    case 31: // $97
      var $98=(function() { try { __THREW__ = false; return _strlen($96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 36; break; };
    case 32: // $99
      var $100=(($98)|0)!=0;
      if ($100) { __label__ = 33; break; } else { __label__ = 37; break; }
    case 33: // $101
      var $102=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($exename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 36; break; };
    case 34: // $103
      (function() { try { __THREW__ = false; return __ZN12cli_frontend16execute_commandsEPKc($8, $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $104
      __label__ = 145; break;
    case 36: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $107=$106.f0;
      $4=$107;
      var $108=$106.f1;
      $5=$108;
      __label__ = 148; break;
    case 37: // $109
      var $110=(($8)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(function() { try { __THREW__ = false; return __ZNK11emu_options6systemEv($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 36; break; };
    case 38: // $114
      $system=$113;
      var $115=$system;
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 39; break; } else { __label__ = 46; break; }
    case 39: // $117
      var $118=(($8)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119;
      var $121=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 36; break; };
    case 40: // $122
      var $123=(function() { try { __THREW__ = false; return _strlen($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 36; break; };
    case 41: // $124
      var $125=(($123)>>>0) > 0;
      if ($125) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $126
      var $127=___cxa_allocate_exception(1032);
      var $128=$127;
      var $129=(($8)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$130;
      var $132=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 45; break; };
    case 43: // $133
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($128, 5, ((STRING_TABLE.__str441807)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$132,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $134
      (function() { try { __THREW__ = false; return ___cxa_throw($127, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 215; break; } else { __label__ = 36; break; }
    case 45: // $135
      var $136=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $137=$136.f0;
      $4=$137;
      var $138=$136.f1;
      $5=$138;
      ___cxa_free_exception($127);
      __label__ = 148; break;
    case 46: // $139
      var $140=(($8)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$141;
      var $143=(function() { try { __THREW__ = false; return __ZNK11emu_options13software_nameEv($142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 36; break; };
    case 47: // $144
      var $145=(function() { try { __THREW__ = false; return _strlen($143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 36; break; };
    case 48: // $146
      var $147=(($145)>>>0) > 0;
      if ($147) { __label__ = 49; break; } else { __label__ = 143; break; }
    case 49: // $148
      var $149=$system;
      var $150=(($8)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$151;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($config, $149, $152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 36; break; }
    case 50: // $153
      var $154=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 55; break; };
    case 51: // $155
      var $156=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $157=(function() { try { __THREW__ = false; return __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($154, $156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 55; break; };
    case 52: // $158
      var $159=(($157)|0)!=0;
      if ($159) { __label__ = 57; break; } else { __label__ = 53; break; }
    case 53: // $160
      var $161=___cxa_allocate_exception(1032);
      var $162=$161;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($162, 3, ((STRING_TABLE.__str471810)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 56; break; }
    case 54: // $163
      (function() { try { __THREW__ = false; return ___cxa_throw($161, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 215; break; } else { __label__ = 55; break; }
    case 55: // $164
      var $165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $166=$165.f0;
      $4=$166;
      var $167=$165.f1;
      $5=$167;
      __label__ = 141; break;
    case 56: // $168
      var $169=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $170=$169.f0;
      $4=$170;
      var $171=$169.f1;
      $5=$171;
      ___cxa_free_exception($161);
      __label__ = 141; break;
    case 57: // $172
      $found=0;
      var $173=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 55; break; };
    case 58: // $174
      var $175=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $176=(function() { try { __THREW__ = false; return __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($173, $175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 55; break; };
    case 59: // $177
      $swlists=$176;
      __label__ = 60; break;
    case 60: // $178
      var $179=$swlists;
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 61; break; } else { __label__ = 132; break; }
    case 61: // $181
      var $182=$swlists;
      var $183=(function() { try { __THREW__ = false; return __Z8downcastIPK18legacy_device_base8device_tET_PT0_($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 55; break; };
    case 62: // $184
      var $185=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base13inline_configEv($183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 55; break; };
    case 63: // $186
      var $187=$185;
      $swlist=$187;
      $i=0;
      __label__ = 64; break;
    case 64: // $188
      var $189=$i;
      var $190=(($189)|0) < 9;
      if ($190) { __label__ = 65; break; } else { __label__ = 127; break; }
    case 65: // $191
      var $192=$i;
      var $193=$swlist;
      var $194=(($193)|0);
      var $195=(($194+($192<<2))|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196)|0)!=0;
      if ($197) { __label__ = 66; break; } else { __label__ = 123; break; }
    case 66: // $198
      var $199=$i;
      var $200=$swlist;
      var $201=(($200)|0);
      var $202=(($201+($199<<2))|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=HEAP8[($203)];
      var $205=(($204 << 24) >> 24)!=0;
      if ($205) { __label__ = 67; break; } else { __label__ = 123; break; }
    case 67: // $206
      var $207=(($8)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=$208;
      var $210=$i;
      var $211=$swlist;
      var $212=(($211)|0);
      var $213=(($212+($210<<2))|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(function() { try { __THREW__ = false; return __Z18software_list_openR11emu_optionsPKciPFvS2_E($209, $214, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 55; break; };
    case 68: // $216
      $list=$215;
      var $217=$list;
      var $218=(($217)|0)!=0;
      if ($218) { __label__ = 69; break; } else { __label__ = 121; break; }
    case 69: // $219
      var $220=$list;
      var $221=(($8)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$222;
      var $224=(function() { try { __THREW__ = false; return __ZNK11emu_options13software_nameEv($223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 55; break; };
    case 70: // $225
      var $226=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($220, $224, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 55; break; };
    case 71: // $227
      $swinfo=$226;
      var $228=$swinfo;
      var $229=(($228)|0)!=0;
      if ($229) { __label__ = 72; break; } else { __label__ = 120; break; }
    case 72: // $230
      var $231=$swinfo;
      var $232=(function() { try { __THREW__ = false; return __Z18software_find_partP13software_infoPKcS2_($231, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 55; break; };
    case 73: // $233
      $swpart=$232;
      __label__ = 74; break;
    case 74: // $234
      var $235=$swpart;
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 75; break; } else { __label__ = 118; break; }
    case 75: // $237
      var $238=$swpart;
      var $239=(function() { try { __THREW__ = false; return __Z25software_part_get_featureP13software_partPKc($238, ((STRING_TABLE.__str481811)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 55; break; };
    case 76: // $240
      $mount=$239;
      var $241=$mount;
      var $242=(($241)|0)==0;
      if ($242) { __label__ = 79; break; } else { __label__ = 77; break; }
    case 77: // $243
      var $244=$mount;
      var $245=(function() { try { __THREW__ = false; return _strcmp($244, ((STRING_TABLE.__str491812)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 55; break; };
    case 78: // $246
      var $247=(($245)|0)!=0;
      if ($247) { __label__ = 79; break; } else { __label__ = 115; break; }
    case 79: // $248
      HEAP32[(($image)>>2)]=0;
      var $249=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 55; break; };
    case 80: // $250
      var $251=(function() { try { __THREW__ = false; return __ZNK11device_list5firstIK22device_image_interfaceEEbRPT_($249, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 55; break; };
    case 81: // $252
      var $253=(($251)&1);
      $gotone=$253;
      __label__ = 82; break;
    case 82: // $254
      var $255=$gotone;
      var $256=(($255) & 1);
      if ($256) { __label__ = 83; break; } else { __label__ = 114; break; }
    case 83: // $257
      var $258=HEAP32[(($image)>>2)];
      var $259=$258;
      var $260=HEAP32[(($259)>>2)];
      var $261=(($260+120)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$262]($258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 55; break; };
    case 84: // $264
      $interface=$263;
      var $265=$interface;
      var $266=(($265)|0)!=0;
      if ($266) { __label__ = 85; break; } else { __label__ = 111; break; }
    case 85: // $267
      var $268=$interface;
      var $269=$swpart;
      var $270=(($269+4)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=(function() { try { __THREW__ = false; return _strcmp($268, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 55; break; };
    case 86: // $273
      var $274=(($272)|0)!=0;
      if ($274) { __label__ = 110; break; } else { __label__ = 87; break; }
    case 87: // $275
      var $276=(($8)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$277;
      var $279=HEAP32[(($image)>>2)];
      var $280=(function() { try { __THREW__ = false; return __ZNK22device_image_interface19brief_instance_nameEv($279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 55; break; };
    case 88: // $281
      var $282=(function() { try { __THREW__ = false; return __ZNK12core_options5valueEPKc($278, $280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 55; break; };
    case 89: // $283
      $option=$282;
      var $284=$option;
      var $285=(function() { try { __THREW__ = false; return _strlen($284) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 55; break; };
    case 90: // $286
      var $287=(($285)|0)==0;
      if ($287) { __label__ = 91; break; } else { __label__ = 109; break; }
    case 91: // $288
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($val) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 55; break; }
    case 92: // $289
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 104; break; }
    case 93: // $290
      var $291=(($8)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=$292;
      var $294=(function() { try { __THREW__ = false; return __ZNK11emu_options13software_nameEv($293) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 105; break; };
    case 94: // $295
      var $296=$swpart;
      var $297=(($296)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($val, ((STRING_TABLE.__str501813)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$294,HEAP32[((tempInt+4)>>2)]=$298,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 105; break; };
    case 95: // $300
      var $301=(($8)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=$302;
      var $304=HEAP32[(($image)>>2)];
      var $305=(function() { try { __THREW__ = false; return __ZNK22device_image_interface19brief_instance_nameEv($304) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 105; break; };
    case 96: // $306
      var $307=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($val) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 105; break; };
    case 97: // $308
      var $309=(function() { try { __THREW__ = false; return __ZN12core_options9set_valueEPKcS1_iR7astring($303, $305, $307, 150, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 105; break; };
    case 98: // $310
      __label__ = 99; break;
    case 99: // $311
      __label__ = 100; break;
    case 100: // $312
      __label__ = 101; break;
    case 101: // $313
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 104; break; }
    case 102: // $314
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($val) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 55; break; }
    case 103: // $315
      __label__ = 109; break;
    case 104: // $316
      var $317=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $318=$317.f0;
      $4=$318;
      var $319=$317.f1;
      $5=$319;
      __label__ = 107; break;
    case 105: // $320
      var $321=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $322=$321.f0;
      $4=$322;
      var $323=$321.f1;
      $5=$323;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 214; break; }
    case 106: // $324
      __label__ = 107; break;
    case 107: // $325
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($val) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 214; break; }
    case 108: // $326
      __label__ = 141; break;
    case 109: // $327
      __label__ = 114; break;
    case 110: // $328
      __label__ = 111; break;
    case 111: // $329
      __label__ = 112; break;
    case 112: // $330
      var $331=HEAP32[(($image)>>2)];
      var $332=$331;
      var $333=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_($332, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 55; break; };
    case 113: // $334
      var $335=(($333)&1);
      $gotone=$335;
      __label__ = 82; break;
    case 114: // $336
      __label__ = 115; break;
    case 115: // $337
      __label__ = 116; break;
    case 116: // $338
      var $339=$swpart;
      var $340=(function() { try { __THREW__ = false; return __Z18software_part_nextP13software_part($339) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 117; break; } else { __label__ = 55; break; };
    case 117: // $341
      $swpart=$340;
      __label__ = 74; break;
    case 118: // $342
      var $343=$list;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($343) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 55; break; }
    case 119: // $344
      $found=1;
      __label__ = 127; break;
    case 120: // $345
      __label__ = 121; break;
    case 121: // $346
      var $347=$list;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 55; break; }
    case 122: // $348
      __label__ = 123; break;
    case 123: // $349
      var $350=$found;
      var $351=(($350) & 1);
      if ($351) { __label__ = 124; break; } else { __label__ = 125; break; }
    case 124: // $352
      __label__ = 127; break;
    case 125: // $353
      __label__ = 126; break;
    case 126: // $354
      var $355=$i;
      var $356=(($355+1)|0);
      $i=$356;
      __label__ = 64; break;
    case 127: // $357
      var $358=$found;
      var $359=(($358) & 1);
      if ($359) { __label__ = 128; break; } else { __label__ = 129; break; }
    case 128: // $360
      __label__ = 132; break;
    case 129: // $361
      __label__ = 130; break;
    case 130: // $362
      var $363=$swlists;
      var $364=(function() { try { __THREW__ = false; return __ZNK8device_t8typenextEv($363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 131; break; } else { __label__ = 55; break; };
    case 131: // $365
      $swlists=$364;
      __label__ = 60; break;
    case 132: // $366
      var $367=$found;
      var $368=(($367) & 1);
      if ($368) { __label__ = 139; break; } else { __label__ = 133; break; }
    case 133: // $369
      var $370=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 134; break; } else { __label__ = 55; break; };
    case 134: // $371
      var $372=(($8)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=$373;
      var $375=(($8)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=$376;
      var $378=(function() { try { __THREW__ = false; return __ZNK11emu_options13software_nameEv($377) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 135; break; } else { __label__ = 55; break; };
    case 135: // $379
      (function() { try { __THREW__ = false; return __Z24software_display_matchesRK11device_listR11emu_optionsPKcS5_($370, $374, 0, $378) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 55; break; }
    case 136: // $380
      var $381=___cxa_allocate_exception(1032);
      var $382=$381;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($382, 3, ((__str511814)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 137; break; } else { __label__ = 138; break; }
    case 137: // $383
      (function() { try { __THREW__ = false; return ___cxa_throw($381, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 215; break; } else { __label__ = 55; break; }
    case 138: // $384
      var $385=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc,0]);
      var $386=$385.f0;
      $4=$386;
      var $387=$385.f1;
      $5=$387;
      ___cxa_free_exception($381);
      __label__ = 141; break;
    case 139: // $388
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 140; break; } else { __label__ = 36; break; }
    case 140: // $389
      __label__ = 143; break;
    case 141: // $390
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 214; break; }
    case 142: // $391
      __label__ = 148; break;
    case 143: // $392
      var $393=(($8)|0);
      var $394=HEAP32[(($393)>>2)];
      var $395=$394;
      var $396=(($8+4)|0);
      var $397=HEAP32[(($396)>>2)];
      var $398=(function() { try { __THREW__ = false; return __Z12mame_executeR11emu_optionsR13osd_interface($395, $397) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 144; break; } else { __label__ = 36; break; };
    case 144: // $399
      var $400=(($8+8)|0);
      HEAP32[(($400)>>2)]=$398;
      __label__ = 145; break;
    case 145: // $401
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($exename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 146; break; } else { __label__ = 15; break; }
    case 146: // $402
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 147; break; } else { __label__ = 14; break; }
    case 147: // $403
      __label__ = 208; break;
    case 148: // $404
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($exename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 149; break; } else { __label__ = 214; break; }
    case 149: // $405
      __label__ = 150; break;
    case 150: // $406
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 151; break; } else { __label__ = 214; break; }
    case 151: // $407
      __label__ = 152; break;
    case 152: // $408
      var $409=$5;
      var $410=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $411=(($409)|0)==(($410)|0);
      if ($411) { __label__ = 153; break; } else { __label__ = 184; break; }
    case 153: // $412
      var $413=$4;
      var $414=___cxa_begin_catch($413);
      var $415=$414;
      $fatal=$415;
      var $416=$fatal;
      var $417=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($416) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 154; break; } else { __label__ = 198; break; };
    case 154: // $418
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($string, $417) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 155; break; } else { __label__ = 198; break; }
    case 155: // $419
      var $420=HEAP32[((__impure_ptr)>>2)];
      var $421=(($420+12)|0);
      var $422=HEAP32[(($421)>>2)];
      var $423=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 199; break; };
    case 156: // $424
      var $425=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($423) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 157; break; } else { __label__ = 199; break; };
    case 157: // $426
      var $427=(function() { try { __THREW__ = false; return _fprintf($422, ((STRING_TABLE.__str551818)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$425,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 158; break; } else { __label__ = 199; break; };
    case 158: // $428
      var $429=$fatal;
      var $430=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror8exitcodeEv($429) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 159; break; } else { __label__ = 199; break; };
    case 159: // $431
      var $432=(($430)|0)!=0;
      if ($432) { __label__ = 160; break; } else { __label__ = 162; break; }
    case 160: // $433
      var $434=$fatal;
      var $435=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror8exitcodeEv($434) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 161; break; } else { __label__ = 199; break; };
    case 161: // $436
      var $439 = $435;__label__ = 163; break;
    case 162: // $437
      var $439 = 3;__label__ = 163; break;
    case 163: // $438
      var $439;
      var $440=(($8+8)|0);
      HEAP32[(($440)>>2)]=$439;
      var $441=(($8+8)|0);
      var $442=HEAP32[(($441)>>2)];
      var $443=(($442)|0)==5;
      if ($443) { __label__ = 164; break; } else { __label__ = 206; break; }
    case 164: // $444
      var $445=(($8)|0);
      var $446=HEAP32[(($445)>>2)];
      var $447=$446;
      var $448=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($447) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 165; break; } else { __label__ = 199; break; };
    case 165: // $449
      var $450=(function() { try { __THREW__ = false; return _strlen($448) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 166; break; } else { __label__ = 199; break; };
    case 166: // $451
      var $452=(($450)>>>0) > 0;
      if ($452) { __label__ = 167; break; } else { __label__ = 206; break; }
    case 167: // $453
      var $454=(($8)|0);
      var $455=HEAP32[(($454)>>2)];
      var $456=$455;
      var $457=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($456) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 168; break; } else { __label__ = 199; break; };
    case 168: // $458
      var $459=(function() { try { __THREW__ = false; return _strchr($457, 42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 169; break; } else { __label__ = 199; break; };
    case 169: // $460
      var $461=(($459)|0)==0;
      if ($461) { __label__ = 170; break; } else { __label__ = 206; break; }
    case 170: // $462
      var $463=(($8)|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=$464;
      var $466=(function() { try { __THREW__ = false; return __ZNK11emu_options6systemEv($465) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 171; break; } else { __label__ = 199; break; };
    case 171: // $467
      var $468=(($466)|0)==0;
      if ($468) { __label__ = 172; break; } else { __label__ = 206; break; }
    case 172: // $469
      var $470=(($8)|0);
      var $471=HEAP32[(($470)>>2)];
      var $472=$471;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_options]($drivlist, $472) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 173; break; } else { __label__ = 199; break; }
    case 173: // $473
      var $474=(($8)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=$475;
      var $477=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 174; break; } else { __label__ = 200; break; };
    case 174: // $478
      var $479=(($matches)|0);
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator24find_approximate_matchesEPKciPi($drivlist, $477, 10, $479) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 175; break; } else { __label__ = 200; break; }
    case 175: // $480
      var $481=HEAP32[((__impure_ptr)>>2)];
      var $482=(($481+12)|0);
      var $483=HEAP32[(($482)>>2)];
      var $484=(($8)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=$485;
      var $487=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($486) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 176; break; } else { __label__ = 200; break; };
    case 176: // $488
      var $489=(function() { try { __THREW__ = false; return _fprintf($483, ((STRING_TABLE.__str561819)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$487,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 177; break; } else { __label__ = 200; break; };
    case 177: // $490
      $matchnum=0;
      __label__ = 178; break;
    case 178: // $491
      var $492=$matchnum;
      var $493=(($492)>>>0) < 10;
      if ($493) { __label__ = 179; break; } else { __label__ = 203; break; }
    case 179: // $494
      var $495=$matchnum;
      var $496=(($matches+($495<<2))|0);
      var $497=HEAP32[(($496)>>2)];
      var $498=(($497)|0)!=-1;
      if ($498) { __label__ = 180; break; } else { __label__ = 201; break; }
    case 180: // $499
      var $500=HEAP32[((__impure_ptr)>>2)];
      var $501=(($500+12)|0);
      var $502=HEAP32[(($501)>>2)];
      var $503=$matchnum;
      var $504=(($matches+($503<<2))|0);
      var $505=HEAP32[(($504)>>2)];
      var $506=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($505) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 181; break; } else { __label__ = 200; break; };
    case 181: // $507
      var $508=(($506+8)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=$matchnum;
      var $511=(($matches+($510<<2))|0);
      var $512=HEAP32[(($511)>>2)];
      var $513=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 182; break; } else { __label__ = 200; break; };
    case 182: // $514
      var $515=(($513+12)|0);
      var $516=HEAP32[(($515)>>2)];
      var $517=(function() { try { __THREW__ = false; return _fprintf($502, ((STRING_TABLE.__str571820)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$509,HEAP32[((tempInt+4)>>2)]=$516,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 183; break; } else { __label__ = 200; break; };
    case 183: // $518
      __label__ = 201; break;
    case 184: // $519
      var $520=_llvm_eh_typeid_for(__ZTI13emu_exception);
      var $521=(($409)|0)==(($520)|0);
      if ($521) { __label__ = 185; break; } else { __label__ = 187; break; }
    case 185: // $522
      var $523=$4;
      var $524=___cxa_begin_catch($523);
      var $525=$524;
      $7=$525;
      var $526=HEAP32[((__impure_ptr)>>2)];
      var $527=(($526+12)|0);
      var $528=HEAP32[(($527)>>2)];
      var $529=(function() { try { __THREW__ = false; return _fprintf($528, ((STRING_TABLE.__str541817)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 186; break; } else { __label__ = 196; break; };
    case 186: // $530
      var $531=(($8+8)|0);
      HEAP32[(($531)>>2)]=3;
      ___cxa_end_catch();
      __label__ = 208; break;
    case 187: // $532
      var $533=_llvm_eh_typeid_for(__ZTISt9bad_alloc);
      var $534=(($409)|0)==(($533)|0);
      if ($534) { __label__ = 188; break; } else { __label__ = 190; break; }
    case 188: // $535
      var $536=$4;
      var $537=___cxa_begin_catch($536);
      var $538=$537;
      $6=$538;
      var $539=HEAP32[((__impure_ptr)>>2)];
      var $540=(($539+12)|0);
      var $541=HEAP32[(($540)>>2)];
      var $542=(function() { try { __THREW__ = false; return _fprintf($541, ((STRING_TABLE.__str531816)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 189; break; } else { __label__ = 194; break; };
    case 189: // $543
      var $544=(($8+8)|0);
      HEAP32[(($544)>>2)]=3;
      ___cxa_end_catch();
      __label__ = 208; break;
    case 190: // $545
      var $546=$4;
      var $547=___cxa_begin_catch($546);
      var $548=HEAP32[((__impure_ptr)>>2)];
      var $549=(($548+12)|0);
      var $550=HEAP32[(($549)>>2)];
      var $551=(function() { try { __THREW__ = false; return _fprintf($550, ((STRING_TABLE.__str521815)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 191; break; } else { __label__ = 192; break; };
    case 191: // $552
      var $553=(($8+8)|0);
      HEAP32[(($553)>>2)]=3;
      ___cxa_end_catch();
      __label__ = 208; break;
    case 192: // $554
      var $555=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $556=$555.f0;
      $4=$556;
      var $557=$555.f1;
      $5=$557;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 193; break; } else { __label__ = 214; break; }
    case 193: // $558
      __label__ = 213; break;
    case 194: // $559
      var $560=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $561=$560.f0;
      $4=$561;
      var $562=$560.f1;
      $5=$562;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 195; break; } else { __label__ = 214; break; }
    case 195: // $563
      __label__ = 213; break;
    case 196: // $564
      var $565=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $566=$565.f0;
      $4=$566;
      var $567=$565.f1;
      $5=$567;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 197; break; } else { __label__ = 214; break; }
    case 197: // $568
      __label__ = 213; break;
    case 198: // $569
      var $570=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $571=$570.f0;
      $4=$571;
      var $572=$570.f1;
      $5=$572;
      __label__ = 211; break;
    case 199: // $573
      var $574=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $575=$574.f0;
      $4=$575;
      var $576=$574.f1;
      $5=$576;
      __label__ = 209; break;
    case 200: // $577
      var $578=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $579=$578.f0;
      $4=$579;
      var $580=$578.f1;
      $5=$580;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 205; break; } else { __label__ = 214; break; }
    case 201: // $581
      __label__ = 202; break;
    case 202: // $582
      var $583=$matchnum;
      var $584=(($583+1)|0);
      $matchnum=$584;
      __label__ = 178; break;
    case 203: // $585
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 204; break; } else { __label__ = 199; break; }
    case 204: // $586
      __label__ = 206; break;
    case 205: // $587
      __label__ = 209; break;
    case 206: // $588
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 207; break; } else { __label__ = 198; break; }
    case 207: // $589
      ___cxa_end_catch();
      __label__ = 208; break;
    case 208: // $590
      var $591=(($8+8)|0);
      var $592=HEAP32[(($591)>>2)];
      STACKTOP = __stackBase__;
      return $592;
    case 209: // $593
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 210; break; } else { __label__ = 214; break; }
    case 210: // $594
      __label__ = 211; break;
    case 211: // $595
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 212; break; } else { __label__ = 214; break; }
    case 212: // $596
      __label__ = 213; break;
    case 213: // $597
      var $598=$4;
      var $599=$4;
      var $600=$5;
      var $601=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $599, tempValue);
      var $602=($601.f1 = $600, $601);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 214: // $603
      var $604=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 215: // $605
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend7executeEiPPc["X"]=1;

function __ZNK14emu_fatalerror6stringEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=(($3)|0);
  ;
  return $4;
}


function __ZNK14emu_fatalerror8exitcodeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1028)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11driver_list6driverEi($index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$index;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=((__ZN11driver_list16s_drivers_sortedE+($4<<2))|0);
      var $6=((((HEAPU8[($5)])|(HEAPU8[($5+1)]<<8)|(HEAPU8[($5+2)]<<16)|(HEAPU8[($5+3)]<<24))|0));
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17driver_enumerator5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12core_options7commandEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+400)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK11emu_options11system_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZN12core_options9unadornedEi(0);
  var $5=__ZNK12core_options5valueEPKc($3, $4);
  ;
  return $5;
}


function __ZN14emu_fatalerrorC1EiPKcz($this, $_exitcode, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ap=__stackBase__;
      var $4;
      var $5;
      $1=$this;
      $2=$_exitcode;
      $3=$format;
      var $6=$1;
      var $7=$6;
      __ZN13emu_exceptionC2Ev($7);
      var $8=$6;
      HEAP32[(($8)>>2)]=((__ZTV14emu_fatalerror+8)|0);
      var $9=(($6+1028)|0);
      var $10=$2;
      HEAP32[(($9)>>2)]=$10;
      var $11=$ap;
      HEAP32[(($11)>>2)]=arguments[__ZN14emu_fatalerrorC1EiPKcz.length];
      var $12=(($6+4)|0);
      var $13=(($12)|0);
      var $14=$3;
      var $15=HEAP32[(($ap)>>2)];
      var $16=(function() { try { __THREW__ = false; return _vsprintf($13, $14, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $17
      var $18=$ap;
      ;
      STACKTOP = __stackBase__;
      return;
    case 2: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $4=$21;
      var $22=$20.f1;
      $5=$22;
      var $23=$6;
      __ZN13emu_exceptionD2Ev($23);
      __label__ = 3; break;
    case 3: // $24
      var $25=$4;
      var $26=$4;
      var $27=$5;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring9trimspaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__Z17astring_trimspaceP7astring($2);
  ;
  return $3;
}


function __ZNK11emu_options13software_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZN12core_options9unadornedEi(1);
  var $5=__ZNK12core_options5valueEPKc($3, $4);
  ;
  return $5;
}


function __ZNK11device_list5firstIK22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceIK22device_image_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22device_image_interface19brief_instance_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+712)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextIK22device_image_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZNK17driver_enumerator6driverEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZN11driver_list6driverEi($4);
  ;
  return $5;
}


function __ZN12cli_frontend16execute_commandsEPKc($this, $exename) {
  var __stackBase__  = STACKTOP; STACKTOP += 516; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $helpstring=__stackBase__;
      var $3;
      var $4;
      var $5;
      var $option_errors=__stackBase__+64;
      var $file=__stackBase__+128;
      var $initext=__stackBase__+388;
      var $initext1=__stackBase__+452;
      var $cmdindex;
      var $sysname;
      $1=$this;
      $2=$exename;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=__ZNK12core_options7commandEv($9);
      var $11=_strcmp($10, ((STRING_TABLE.__str1501913)|0));
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      __ZN12cli_frontend12display_helpEv($6);
      __label__ = 70; break;
    case 2: // $14
      var $15=(($6)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16;
      var $18=__ZNK12core_options7commandEv($17);
      var $19=_strcmp($18, ((STRING_TABLE.__str1511914)|0));
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $21
      __ZN7astringC1Ev($helpstring);
      var $22=$2;
      var $23=(($6)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$24;
      var $26=(function() { try { __THREW__ = false; return __ZN12core_options11output_helpER7astring($25, $helpstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $27
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1521915)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str1531916)|0),HEAP32[((tempInt+8)>>2)]=$26,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      $5=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($helpstring);
      __label__ = 70; break;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $3=$31;
      var $32=$30.f1;
      $4=$32;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($helpstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 72; break; }
    case 7: // $33
      __label__ = 71; break;
    case 8: // $34
      var $35=(($6)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36;
      var $38=__ZNK12core_options7commandEv($37);
      var $39=_strcmp($38, ((STRING_TABLE.__str1541917)|0));
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $41
      var $42=(($6)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$43;
      __Z16validate_driversR11emu_optionsPK11game_driver($44, 0);
      __label__ = 70; break;
    case 10: // $45
      __ZN7astringC1Ev($option_errors);
      var $46=(($6)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$47;
      (function() { try { __THREW__ = false; return __ZN11emu_options19parse_standard_inisER7astring($48, $option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $49
      var $50=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; };
    case 12: // $51
      if ($50) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $52
      var $53=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $54
      var $55=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str551818)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; };
    case 15: // $56
      __label__ = 17; break;
    case 16: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $3=$59;
      var $60=$58.f1;
      $4=$60;
      __label__ = 68; break;
    case 17: // $61
      var $62=(($6)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$63;
      var $65=(function() { try { __THREW__ = false; return __ZNK12core_options7commandEv($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 16; break; };
    case 18: // $66
      var $67=(function() { try { __THREW__ = false; return _strcmp($65, ((STRING_TABLE.__str1551918)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; };
    case 19: // $68
      var $69=(($67)|0)==0;
      if ($69) { __label__ = 20; break; } else { __label__ = 37; break; }
    case 20: // $70
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1Ej]($file, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 16; break; }
    case 21: // $71
      var $72=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, ((STRING_TABLE.__str1561919)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 25; break; };
    case 22: // $73
      var $74=(($72)|0)!=0;
      if ($74) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $75
      var $76=___cxa_allocate_exception(1032);
      var $77=$76;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($77, ((STRING_TABLE.__str1571920)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $78
      (function() { try { __THREW__ = false; return ___cxa_throw($76, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 25; break; }
    case 25: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $81=$80.f0;
      $3=$81;
      var $82=$80.f1;
      $4=$82;
      __label__ = 35; break;
    case 26: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $3=$85;
      var $86=$84.f1;
      $4=$86;
      ___cxa_free_exception($76);
      __label__ = 35; break;
    case 27: // $87
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($initext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 25; break; }
    case 28: // $88
      var $89=(($6)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$90;
      var $92=(function() { try { __THREW__ = false; return __ZN12core_options10output_iniER7astringPKS_($91, $initext, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 31; break; };
    case 29: // $93
      var $94=(function() { try { __THREW__ = false; return __ZN8emu_file4putsEPKc($file, $92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 31; break; };
    case 30: // $95
      $5=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($initext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 25; break; }
    case 31: // $96
      var $97=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $98=$97.f0;
      $3=$98;
      var $99=$97.f1;
      $4=$99;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($initext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 72; break; }
    case 32: // $100
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 16; break; }
    case 33: // $101
      __label__ = 35; break;
    case 34: // $102
      __label__ = 67; break;
    case 35: // $103
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 72; break; }
    case 36: // $104
      __label__ = 68; break;
    case 37: // $105
      var $106=(($6)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$107;
      var $109=(function() { try { __THREW__ = false; return __ZNK12core_options7commandEv($108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 16; break; };
    case 38: // $110
      var $111=(function() { try { __THREW__ = false; return _strcmp($109, ((STRING_TABLE.__str1581921)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 16; break; };
    case 39: // $112
      var $113=(($111)|0)==0;
      if ($113) { __label__ = 40; break; } else { __label__ = 47; break; }
    case 40: // $114
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($initext1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 16; break; }
    case 41: // $115
      var $116=(($6)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$117;
      var $119=(function() { try { __THREW__ = false; return __ZN12core_options10output_iniER7astringPKS_($118, $initext1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 44; break; };
    case 42: // $120
      var $121=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str551818)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$119,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 44; break; };
    case 43: // $122
      $5=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($initext1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 16; break; }
    case 44: // $123
      var $124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $125=$124.f0;
      $3=$125;
      var $126=$124.f1;
      $4=$126;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($initext1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 72; break; }
    case 45: // $127
      __label__ = 67; break;
    case 46: // $128
      __label__ = 68; break;
    case 47: // $129
      $cmdindex=0;
      __label__ = 48; break;
    case 48: // $130
      var $131=$cmdindex;
      var $132=(($131)>>>0) < 15;
      if ($132) { __label__ = 49; break; } else { __label__ = 63; break; }
    case 49: // $133
      var $134=(($6)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$135;
      var $137=(function() { try { __THREW__ = false; return __ZNK12core_options7commandEv($136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 16; break; };
    case 50: // $138
      var $139=$cmdindex;
      var $140=((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+$139*12)|0);
      var $141=(($140)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(function() { try { __THREW__ = false; return _strcmp($137, $142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 16; break; };
    case 51: // $144
      var $145=(($143)|0)==0;
      if ($145) { __label__ = 52; break; } else { __label__ = 61; break; }
    case 52: // $146
      var $147=(($6)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=$148;
      var $150=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 16; break; };
    case 53: // $151
      $sysname=$150;
      var $152=$cmdindex;
      var $153=((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+$152*12)|0);
      var $154=(($153+4)|0);
      var $155={ f0: HEAP32[(($154)>>2)], f1: HEAP32[(($154+4)>>2)] };
      var $156=$155.f1;
      var $157=$6;
      var $158=(($157+$156)|0);
      var $159=$158;
      var $160=$155.f0;
      var $161=$160 & 1;
      var $162=(($161)|0)!=0;
      if ($162) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $163
      var $164=$159;
      var $165=HEAP32[(($164)>>2)];
      var $166=(($160-1)|0);
      var $167=(($165+$166)|0);
      var $168=$167;
      var $169=HEAP32[(($168)>>2)];
      var $173 = $169;__label__ = 56; break;
    case 55: // $170
      var $171=$160;
      var $173 = $171;__label__ = 56; break;
    case 56: // $172
      var $173;
      var $174=$sysname;
      var $175=(($174)|0);
      var $176=HEAP8[($175)];
      var $177=(($176 << 24) >> 24);
      var $178=(($177)|0)==0;
      if ($178) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $179
      var $183 = ((STRING_TABLE.__str1081871)|0);__label__ = 59; break;
    case 58: // $180
      var $181=$sysname;
      var $183 = $181;__label__ = 59; break;
    case 59: // $182
      var $183;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$173]($159, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 16; break; }
    case 60: // $184
      $5=1;
      __label__ = 67; break;
    case 61: // $185
      __label__ = 62; break;
    case 62: // $186
      var $187=$cmdindex;
      var $188=(($187+1)|0);
      $cmdindex=$188;
      __label__ = 48; break;
    case 63: // $189
      var $190=___cxa_allocate_exception(1032);
      var $191=$190;
      var $192=(($6)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$193;
      var $195=(function() { try { __THREW__ = false; return __ZNK12core_options7commandEv($194) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 66; break; };
    case 64: // $196
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($191, 6, ((STRING_TABLE.__str1681931)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$195,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $197
      (function() { try { __THREW__ = false; return ___cxa_throw($190, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 16; break; }
    case 66: // $198
      var $199=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $200=$199.f0;
      $3=$200;
      var $201=$199.f1;
      $4=$201;
      ___cxa_free_exception($190);
      __label__ = 68; break;
    case 67: // $202
      FUNCTION_TABLE[__ZN7astringD1Ev]($option_errors);
      __label__ = 70; break;
    case 68: // $203
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 72; break; }
    case 69: // $204
      __label__ = 71; break;
    case 70: // $205
      STACKTOP = __stackBase__;
      return;
    case 71: // $206
      var $207=$3;
      var $208=$3;
      var $209=$4;
      var $210=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $208, tempValue);
      var $211=($210.f1 = $209, $210);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 72: // $212
      var $213=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 73: // $214
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend16execute_commandsEPKc["X"]=1;

function __ZN12cli_frontend7listxmlEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $creator=__stackBase__+40;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 9; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 9; break;
    case 6: // $26
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16info_xml_creatorC1ER17driver_enumerator]($creator, $drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $27
      var $28=HEAP32[((__impure_ptr)>>2)];
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator6outputEP7__sFILE($creator, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; }
    case 8: // $31
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 9: // $32
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $33
      __label__ = 11; break;
    case 11: // $34
      var $35=$3;
      var $36=$3;
      var $37=$4;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 13: // $42
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend7listxmlEPKc["X"]=1;

function __ZN12cli_frontend8listfullEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 18; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 18; break;
    case 6: // $26
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str591822)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; };
    case 9: // $30
      if ($29) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $33
      var $34=(($32+44)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & 8192;
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $38
      var $39=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; };
    case 13: // $40
      var $41=(($39+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $44
      var $45=(($43+12)|0);
      var $46=HEAP32[(($45)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str601823)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,HEAP32[((tempInt+4)>>2)]=$46,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 4; break; }
    case 15: // $47
      __label__ = 16; break;
    case 16: // $48
      __label__ = 8; break;
    case 17: // $49
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 18: // $50
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $51
      __label__ = 20; break;
    case 20: // $52
      var $53=$3;
      var $54=$3;
      var $55=$4;
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 22: // $60
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend8listfullEPKc["X"]=1;

function __ZN12cli_frontend10listsourceEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $filename=__stackBase__+40;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 20; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 20; break;
    case 6: // $26
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 16; break; };
    case 9: // $30
      if ($29) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $33
      var $34=(($32+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; };
    case 12: // $37
      var $38=(($36)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($filename, $39, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; };
    case 13: // $41
      var $42=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $43
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str611824)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$35,HEAP32[((tempInt+4)>>2)]=$42,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $44
      __label__ = 8; break;
    case 16: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $3=$47;
      var $48=$46.f1;
      $4=$48;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 17: // $49
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 4; break; }
    case 18: // $50
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 19: // $51
      __label__ = 20; break;
    case 20: // $52
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $53
      __label__ = 22; break;
    case 22: // $54
      var $55=$3;
      var $56=$3;
      var $57=$4;
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 24: // $62
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend10listsourceEPKc["X"]=1;

function __ZN17driver_enumerator5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=-1;
  ;
  return;
}


function __ZNK17driver_enumerator8includedEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$6)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17driver_enumerator7currentEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN17driver_enumerator5cloneEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZN11driver_list5cloneEi($4);
  ;
  return $5;
}


function __ZN17driver_enumerator7includeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  __ZN17driver_enumerator7includeEi($2, $4);
  ;
  return;
}


function __ZN17driver_enumerator11exclude_allEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
  var $6=(($5)|0);
  _memset($4, 0, $6, 1);
  var $7=(($2+4)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZNK17driver_enumerator6configEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK17driver_enumerator6configEi($2, $4);
  ;
  return $5;
}


function __ZN12cli_frontend10listclonesEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $original_count;
      var $3;
      var $4;
      var $clone_of;
      var $5;
      var $clone_of1;
      $1=$this;
      $2=$gamename;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $9, $10);
      var $11=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 13; break; };
    case 1: // $12
      $original_count=$11;
      __label__ = 2; break;
    case 2: // $13
      var $14=(function() { try { __THREW__ = false; return __ZN17driver_enumerator13next_excludedEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; };
    case 3: // $15
      if ($14) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $16
      var $17=(function() { try { __THREW__ = false; return __ZN17driver_enumerator5cloneEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 13; break; };
    case 5: // $18
      $clone_of=$17;
      var $19=$clone_of;
      var $20=(($19)|0)!=-1;
      if ($20) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $21
      var $22=$clone_of;
      var $23=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $24
      var $25=(($23+44)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 & 4096;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $29
      var $30=$2;
      var $31=$clone_of;
      var $32=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $33
      var $34=(($32+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(function() { try { __THREW__ = false; return __ZN11driver_list7matchesEPKcS1_($30, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; };
    case 10: // $37
      if ($36) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $38
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator7includeEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $39
      __label__ = 14; break;
    case 13: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $3=$42;
      var $43=$41.f1;
      $4=$43;
      __label__ = 43; break;
    case 14: // $44
      __label__ = 15; break;
    case 15: // $45
      __label__ = 2; break;
    case 16: // $46
      var $47=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 13; break; };
    case 17: // $48
      var $49=(($47)|0)==0;
      if ($49) { __label__ = 18; break; } else { __label__ = 26; break; }
    case 18: // $50
      var $51=$original_count;
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $53
      var $54=___cxa_allocate_exception(1032);
      var $55=$54;
      var $56=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($55, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $57
      (function() { try { __THREW__ = false; return ___cxa_throw($54, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 13; break; }
    case 21: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $60=$59.f0;
      $3=$60;
      var $61=$59.f1;
      $4=$61;
      ___cxa_free_exception($54);
      __label__ = 43; break;
    case 22: // $62
      var $63=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 13; break; };
    case 23: // $64
      var $65=$2;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str621825)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$65,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 13; break; }
    case 24: // $66
      __label__ = 25; break;
    case 25: // $67
      $5=1;
      __label__ = 41; break;
    case 26: // $68
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str631826)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 13; break; }
    case 27: // $69
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator5resetEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 13; break; }
    case 28: // $70
      __label__ = 29; break;
    case 29: // $71
      var $72=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 13; break; };
    case 30: // $73
      if ($72) { __label__ = 31; break; } else { __label__ = 40; break; }
    case 31: // $74
      var $75=(function() { try { __THREW__ = false; return __ZN17driver_enumerator5cloneEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 13; break; };
    case 32: // $76
      $clone_of1=$75;
      var $77=$clone_of1;
      var $78=(($77)|0)!=-1;
      if ($78) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $79
      var $80=$clone_of1;
      var $81=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 13; break; };
    case 34: // $82
      var $83=(($81+44)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$84 & 4096;
      var $86=(($85)|0)==0;
      if ($86) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $87
      var $88=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 13; break; };
    case 36: // $89
      var $90=(($88+8)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$clone_of1;
      var $93=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 13; break; };
    case 37: // $94
      var $95=(($93+8)|0);
      var $96=HEAP32[(($95)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str641827)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$91,HEAP32[((tempInt+4)>>2)]=$96,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 13; break; }
    case 38: // $97
      __label__ = 39; break;
    case 39: // $98
      __label__ = 29; break;
    case 40: // $99
      $5=0;
      __label__ = 41; break;
    case 41: // $100
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 42; break;
      }
      else {
      __label__ = 47; break;
      }
      
    case 42: // $101
      STACKTOP = __stackBase__;
      return;
    case 43: // $102
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $103
      __label__ = 45; break;
    case 45: // $104
      var $105=$3;
      var $106=$3;
      var $107=$4;
      var $108=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $106, tempValue);
      var $109=($108.f1 = $107, $108);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 47: // $112
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend10listclonesEPKc["X"]=1;

function __ZN12cli_frontend12listbrothersEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 144; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $initial_drivlist=__stackBase__;
      var $3;
      var $4;
      var $drivlist=__stackBase__+40;
      var $filename=__stackBase__+80;
      var $clone_of;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($initial_drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($initial_drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 52; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 52; break;
    case 6: // $26
      var $27=(($5)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_options]($drivlist, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $30
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator11exclude_allEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      var $33=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($initial_drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; };
    case 10: // $34
      if ($33) { __label__ = 11; break; } else { __label__ = 28; break; }
    case 11: // $35
      var $36=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator7currentEv($initial_drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $37
      var $38=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator8includedEi($drivlist, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $39
      if ($38) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $40
      __label__ = 9; break;
    case 15: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      $3=$43;
      var $44=$42.f1;
      $4=$44;
      __label__ = 50; break;
    case 16: // $45
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator5resetEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 17: // $46
      __label__ = 18; break;
    case 18: // $47
      var $48=(function() { try { __THREW__ = false; return __ZN17driver_enumerator13next_excludedEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; };
    case 19: // $49
      if ($48) { __label__ = 20; break; } else { __label__ = 27; break; }
    case 20: // $50
      var $51=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 15; break; };
    case 21: // $52
      var $53=(($51)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($initial_drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 15; break; };
    case 22: // $56
      var $57=(($55)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(function() { try { __THREW__ = false; return _strcmp($54, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; };
    case 23: // $60
      var $61=(($59)|0)==0;
      if ($61) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $62
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator7includeEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; }
    case 25: // $63
      __label__ = 26; break;
    case 26: // $64
      __label__ = 18; break;
    case 27: // $65
      __label__ = 9; break;
    case 28: // $66
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str651828)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 15; break; }
    case 29: // $67
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator5resetEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 15; break; }
    case 30: // $68
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 15; break; }
    case 31: // $69
      __label__ = 32; break;
    case 32: // $70
      var $71=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 45; break; };
    case 33: // $72
      if ($71) { __label__ = 34; break; } else { __label__ = 46; break; }
    case 34: // $73
      var $74=(function() { try { __THREW__ = false; return __ZN17driver_enumerator5cloneEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 45; break; };
    case 35: // $75
      $clone_of=$74;
      var $76=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 45; break; };
    case 36: // $77
      var $78=(($76)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($filename, $79, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 45; break; };
    case 37: // $81
      var $82=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 45; break; };
    case 38: // $83
      var $84=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 45; break; };
    case 39: // $85
      var $86=(($84+8)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$clone_of;
      var $89=(($88)|0)==-1;
      if ($89) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $90
      var $98 = ((__str511814)|0);__label__ = 43; break;
    case 41: // $91
      var $92=$clone_of;
      var $93=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 45; break; };
    case 42: // $94
      var $95=(($93+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $98 = $96;__label__ = 43; break;
    case 43: // $97
      var $98;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str661829)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,HEAP32[((tempInt+4)>>2)]=$87,HEAP32[((tempInt+8)>>2)]=$98,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $99
      __label__ = 32; break;
    case 45: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $3=$102;
      var $103=$101.f1;
      $4=$103;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 55; break; }
    case 46: // $104
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 15; break; }
    case 47: // $105
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 4; break; }
    case 48: // $106
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($initial_drivlist);
      STACKTOP = __stackBase__;
      return;
    case 49: // $107
      __label__ = 50; break;
    case 50: // $108
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 55; break; }
    case 51: // $109
      __label__ = 52; break;
    case 52: // $110
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($initial_drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $111
      __label__ = 54; break;
    case 54: // $112
      var $113=$3;
      var $114=$3;
      var $115=$4;
      var $116=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $114, tempValue);
      var $117=($116.f1 = $115, $116);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 55: // $118
      var $119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 56: // $120
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend12listbrothersEPKc["X"]=1;

function __ZN12cli_frontend7listcrcEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $source;
      var $region;
      var $rom;
      var $crc=__stackBase__+40;
      var $5=__stackBase__+44;
      $1=$this;
      $2=$gamename;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $9, $10);
      var $11=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $12
      var $13=(($11)|0)==0;
      if ($13) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $14
      var $15=___cxa_allocate_exception(1032);
      var $16=$15;
      var $17=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($16, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      (function() { try { __THREW__ = false; return ___cxa_throw($15, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 4; break; }
    case 4: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $3=$21;
      var $22=$20.f1;
      $4=$22;
      __label__ = 39; break;
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $3=$25;
      var $26=$24.f1;
      $4=$26;
      ___cxa_free_exception($15);
      __label__ = 39; break;
    case 6: // $27
      __label__ = 7; break;
    case 7: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $30
      if ($29) { __label__ = 9; break; } else { __label__ = 38; break; }
    case 9: // $31
      var $32=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; };
    case 10: // $33
      var $34=(function() { try { __THREW__ = false; return __Z16rom_first_sourceRK14machine_config($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $35
      $source=$34;
      __label__ = 12; break;
    case 12: // $36
      var $37=$source;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 13; break; } else { __label__ = 37; break; }
    case 13: // $39
      var $40=$source;
      var $41=(function() { try { __THREW__ = false; return __Z16rom_first_regionRK8device_t($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $42
      $region=$41;
      __label__ = 15; break;
    case 15: // $43
      var $44=$region;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 16; break; } else { __label__ = 34; break; }
    case 16: // $46
      var $47=$region;
      var $48=(function() { try { __THREW__ = false; return __Z14rom_first_filePK9rom_entry($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 4; break; };
    case 17: // $49
      $rom=$48;
      __label__ = 18; break;
    case 18: // $50
      var $51=$rom;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 19; break; } else { __label__ = 31; break; }
    case 19: // $53
      var $54=$rom;
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($5, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 4; break; }
    case 20: // $57
      var $58=(function() { try { __THREW__ = false; return __ZNK15hash_collection3crcERj($5, $crc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; };
    case 21: // $59
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 4; break; }
    case 22: // $60
      if ($58) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $61
      var $62=HEAP32[(($crc)>>2)];
      var $63=$rom;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 4; break; };
    case 24: // $67
      var $68=(($66+12)|0);
      var $69=HEAP32[(($68)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str671830)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$62,HEAP32[((tempInt+4)>>2)]=$65,HEAP32[((tempInt+8)>>2)]=$69,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 4; break; }
    case 25: // $70
      __label__ = 28; break;
    case 26: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $3=$73;
      var $74=$72.f1;
      $4=$74;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 42; break; }
    case 27: // $75
      __label__ = 39; break;
    case 28: // $76
      __label__ = 29; break;
    case 29: // $77
      var $78=$rom;
      var $79=(function() { try { __THREW__ = false; return __Z13rom_next_filePK9rom_entry($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 4; break; };
    case 30: // $80
      $rom=$79;
      __label__ = 18; break;
    case 31: // $81
      __label__ = 32; break;
    case 32: // $82
      var $83=$region;
      var $84=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 4; break; };
    case 33: // $85
      $region=$84;
      __label__ = 15; break;
    case 34: // $86
      __label__ = 35; break;
    case 35: // $87
      var $88=$source;
      var $89=(function() { try { __THREW__ = false; return __Z15rom_next_sourceRK8device_t($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $90
      $source=$89;
      __label__ = 12; break;
    case 37: // $91
      __label__ = 7; break;
    case 38: // $92
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 39: // $93
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $94
      __label__ = 41; break;
    case 41: // $95
      var $96=$3;
      var $97=$3;
      var $98=$4;
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 43: // $103
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend7listcrcEPKc["X"]=1;

function __ZNK8device_t4typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK8device_t5clockEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+248)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15hash_collection4flagEc($this, $flag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$flag;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5 << 24) >> 24);
  var $7=__ZNK7astring3chrEii($4, 0, $6);
  var $8=(($7)|0)!=-1;
  ;
  return $8;
}


function __ZNK14machine_config12first_deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  var $4=$3;
  var $5=__ZNK11tagged_listI8device_tE5firstEv($4);
  ;
  return $5;
}


function __ZN12cli_frontend8listromsEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 188; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $tempstr=__stackBase__+40;
      var $first;
      var $source;
      var $region;
      var $rom;
      var $length;
      var $name;
      var $hashes=__stackBase__+104;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 65; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 65; break;
    case 6: // $26
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $27
      $first=1;
      __label__ = 8; break;
    case 8: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $30
      if ($29) { __label__ = 10; break; } else { __label__ = 61; break; }
    case 10: // $31
      var $32=$first;
      var $33=(($32) & 1);
      if ($33) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $34
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $35
      __label__ = 14; break;
    case 13: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $3=$38;
      var $39=$37.f1;
      $4=$39;
      __label__ = 63; break;
    case 14: // $40
      $first=0;
      var $41=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 13; break; };
    case 15: // $42
      var $43=(($41+8)|0);
      var $44=HEAP32[(($43)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str691832)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$44,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 16: // $45
      var $46=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 13; break; };
    case 17: // $47
      var $48=(function() { try { __THREW__ = false; return __Z16rom_first_sourceRK14machine_config($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 13; break; };
    case 18: // $49
      $source=$48;
      __label__ = 19; break;
    case 19: // $50
      var $51=$source;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 20; break; } else { __label__ = 60; break; }
    case 20: // $53
      var $54=$source;
      var $55=(function() { try { __THREW__ = false; return __Z16rom_first_regionRK8device_t($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 13; break; };
    case 21: // $56
      $region=$55;
      __label__ = 22; break;
    case 22: // $57
      var $58=$region;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 23; break; } else { __label__ = 57; break; }
    case 23: // $60
      var $61=$region;
      var $62=(function() { try { __THREW__ = false; return __Z14rom_first_filePK9rom_entry($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 13; break; };
    case 24: // $63
      $rom=$62;
      __label__ = 25; break;
    case 25: // $64
      var $65=$rom;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 26; break; } else { __label__ = 54; break; }
    case 26: // $67
      $length=-1;
      var $68=$region;
      var $69=(($68+16)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$70 & 16384;
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $73
      var $74=$rom;
      var $75=(function() { try { __THREW__ = false; return __Z13rom_file_sizePK9rom_entry($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 13; break; };
    case 28: // $76
      $length=$75;
      __label__ = 29; break;
    case 29: // $77
      var $78=$rom;
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      $name=$80;
      var $81=$name;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str701833)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 13; break; }
    case 30: // $82
      var $83=$length;
      var $84=(($83)|0) >= 0;
      if ($84) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $85
      var $86=$length;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str711834)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$86,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 13; break; }
    case 32: // $87
      __label__ = 35; break;
    case 33: // $88
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str721835)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 13; break; }
    case 34: // $89
      __label__ = 35; break;
    case 35: // $90
      var $91=$rom;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($hashes, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 13; break; }
    case 36: // $94
      var $95=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 42; break; };
    case 37: // $96
      if ($95) { __label__ = 46; break; } else { __label__ = 38; break; }
    case 38: // $97
      var $98=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 42; break; };
    case 39: // $99
      if ($98) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $100
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str731836)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $101
      __label__ = 43; break;
    case 42: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $3=$104;
      var $105=$103.f1;
      $4=$105;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 68; break; }
    case 43: // $106
      var $107=(function() { try { __THREW__ = false; return __ZNK15hash_collection12macro_stringER7astring($hashes, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 42; break; };
    case 44: // $108
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str741837)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$107,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 42; break; }
    case 45: // $109
      __label__ = 48; break;
    case 46: // $110
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str751838)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 42; break; }
    case 47: // $111
      __label__ = 48; break;
    case 48: // $112
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 42; break; }
    case 49: // $113
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 13; break; }
    case 50: // $114
      __label__ = 51; break;
    case 51: // $115
      var $116=$rom;
      var $117=(function() { try { __THREW__ = false; return __Z13rom_next_filePK9rom_entry($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 13; break; };
    case 52: // $118
      $rom=$117;
      __label__ = 25; break;
    case 53: // $119
      __label__ = 63; break;
    case 54: // $120
      __label__ = 55; break;
    case 55: // $121
      var $122=$region;
      var $123=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 13; break; };
    case 56: // $124
      $region=$123;
      __label__ = 22; break;
    case 57: // $125
      __label__ = 58; break;
    case 58: // $126
      var $127=$source;
      var $128=(function() { try { __THREW__ = false; return __Z15rom_next_sourceRK8device_t($127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 13; break; };
    case 59: // $129
      $source=$128;
      __label__ = 19; break;
    case 60: // $130
      __label__ = 8; break;
    case 61: // $131
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 4; break; }
    case 62: // $132
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 63: // $133
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $134
      __label__ = 65; break;
    case 65: // $135
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $136
      __label__ = 67; break;
    case 67: // $137
      var $138=$3;
      var $139=$3;
      var $140=$4;
      var $141=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $139, tempValue);
      var $142=($141.f1 = $140, $141);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $143
      var $144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 69: // $145
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend8listromsEPKc["X"]=1;

function __ZN12cli_frontend11listsamplesEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $first;
      var $device;
      var $samplenames;
      var $sampnum;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 46; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 46; break;
    case 6: // $26
      $first=1;
      __label__ = 7; break;
    case 7: // $27
      var $28=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $29
      if ($28) { __label__ = 9; break; } else { __label__ = 45; break; }
    case 9: // $30
      var $31=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; };
    case 10: // $32
      var $33=(function() { try { __THREW__ = false; return __ZNK14machine_config12first_deviceEv($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $34
      $device=$33;
      __label__ = 12; break;
    case 12: // $35
      var $36=$device;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $38
      var $39=$device;
      var $40=(function() { try { __THREW__ = false; return __ZNK8device_t4typeEv($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $41
      var $42=HEAP32[((_SAMPLES)>>2)];
      var $43=(($40)|0)==(($42)|0);
      if ($43) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $44
      __label__ = 19; break;
    case 16: // $45
      __label__ = 17; break;
    case 17: // $46
      var $47=$device;
      var $48=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 4; break; };
    case 18: // $49
      $device=$48;
      __label__ = 12; break;
    case 19: // $50
      var $51=$device;
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $53
      __label__ = 7; break;
    case 21: // $54
      var $55=$first;
      var $56=(($55) & 1);
      if ($56) { __label__ = 24; break; } else { __label__ = 22; break; }
    case 22: // $57
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 4; break; }
    case 23: // $58
      __label__ = 24; break;
    case 24: // $59
      $first=0;
      var $60=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 4; break; };
    case 25: // $61
      var $62=(($60+8)|0);
      var $63=HEAP32[(($62)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str761839)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 4; break; }
    case 26: // $64
      __label__ = 27; break;
    case 27: // $65
      var $66=$device;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 28; break; } else { __label__ = 44; break; }
    case 28: // $68
      var $69=$device;
      var $70=(function() { try { __THREW__ = false; return __ZNK8device_t4typeEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 4; break; };
    case 29: // $71
      var $72=HEAP32[((_SAMPLES)>>2)];
      var $73=(($70)|0)==(($72)|0);
      if ($73) { __label__ = 30; break; } else { __label__ = 41; break; }
    case 30: // $74
      var $75=$device;
      var $76=(function() { try { __THREW__ = false; return __ZNK8device_t13static_configEv($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; };
    case 31: // $77
      var $78=$76;
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      $samplenames=$80;
      var $81=$samplenames;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 32; break; } else { __label__ = 40; break; }
    case 32: // $83
      $sampnum=0;
      __label__ = 33; break;
    case 33: // $84
      var $85=$sampnum;
      var $86=$samplenames;
      var $87=(($86+($85<<2))|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $90
      var $91=$sampnum;
      var $92=$samplenames;
      var $93=(($92+($91<<2))|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24);
      var $98=(($97)|0)!=42;
      if ($98) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $99
      var $100=$sampnum;
      var $101=$samplenames;
      var $102=(($101+($100<<2))|0);
      var $103=HEAP32[(($102)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str551818)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$103,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; }
    case 36: // $104
      __label__ = 37; break;
    case 37: // $105
      __label__ = 38; break;
    case 38: // $106
      var $107=$sampnum;
      var $108=(($107+1)|0);
      $sampnum=$108;
      __label__ = 33; break;
    case 39: // $109
      __label__ = 40; break;
    case 40: // $110
      __label__ = 41; break;
    case 41: // $111
      __label__ = 42; break;
    case 42: // $112
      var $113=$device;
      var $114=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 4; break; };
    case 43: // $115
      $device=$114;
      __label__ = 27; break;
    case 44: // $116
      __label__ = 7; break;
    case 45: // $117
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 46: // $118
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 47: // $119
      __label__ = 48; break;
    case 48: // $120
      var $121=$3;
      var $122=$3;
      var $123=$4;
      var $124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $122, tempValue);
      var $125=($124.f1 = $123, $124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 50: // $128
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend11listsamplesEPKc["X"]=1;

function __ZN12cli_frontend11listdevicesEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $first;
      var $device;
      var $clock;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 45; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 45; break;
    case 6: // $26
      $first=1;
      __label__ = 7; break;
    case 7: // $27
      var $28=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $29
      if ($28) { __label__ = 9; break; } else { __label__ = 44; break; }
    case 9: // $30
      var $31=$first;
      var $32=(($31) & 1);
      if ($32) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $33
      var $34=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $35
      __label__ = 12; break;
    case 12: // $36
      $first=0;
      var $37=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; };
    case 13: // $38
      var $39=(($37+8)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $42
      var $43=(($41+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str771840)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,HEAP32[((tempInt+4)>>2)]=$44,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 4; break; };
    case 15: // $46
      var $47=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 4; break; };
    case 16: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK14machine_config12first_deviceEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 4; break; };
    case 17: // $50
      $device=$49;
      __label__ = 18; break;
    case 18: // $51
      var $52=$device;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 19; break; } else { __label__ = 43; break; }
    case 19: // $54
      var $55=$device;
      var $56=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 4; break; };
    case 20: // $57
      var $58=$device;
      var $59=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 4; break; };
    case 21: // $60
      var $61=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str781841)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,HEAP32[((tempInt+4)>>2)]=$59,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 4; break; };
    case 22: // $62
      var $63=$device;
      var $64=(function() { try { __THREW__ = false; return __ZNK8device_t5clockEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 4; break; };
    case 23: // $65
      $clock=$64;
      var $66=$clock;
      var $67=(($66)>>>0) >= 1000000000;
      if ($67) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $68
      var $69=$clock;
      var $70=Math.floor((($69)>>>0)/1000000000);
      var $71=$clock;
      var $72=Math.floor((($71)>>>0)/10000000);
      var $73=(($72)>>>0)%100;
      var $74=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str791842)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$70,HEAP32[((tempInt+4)>>2)]=$73,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 4; break; };
    case 25: // $75
      __label__ = 40; break;
    case 26: // $76
      var $77=$clock;
      var $78=(($77)>>>0) >= 1000000;
      if ($78) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $79
      var $80=$clock;
      var $81=Math.floor((($80)>>>0)/1000000);
      var $82=$clock;
      var $83=Math.floor((($82)>>>0)/10000);
      var $84=(($83)>>>0)%100;
      var $85=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str801843)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,HEAP32[((tempInt+4)>>2)]=$84,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 4; break; };
    case 28: // $86
      __label__ = 39; break;
    case 29: // $87
      var $88=$clock;
      var $89=(($88)>>>0) >= 1000;
      if ($89) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $90
      var $91=$clock;
      var $92=Math.floor((($91)>>>0)/1000);
      var $93=$clock;
      var $94=Math.floor((($93)>>>0)/10);
      var $95=(($94)>>>0)%100;
      var $96=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str811844)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$92,HEAP32[((tempInt+4)>>2)]=$95,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; };
    case 31: // $97
      __label__ = 38; break;
    case 32: // $98
      var $99=$clock;
      var $100=(($99)>>>0) > 0;
      if ($100) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $101
      var $102=$clock;
      var $103=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str821845)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$102,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 4; break; };
    case 34: // $104
      __label__ = 37; break;
    case 35: // $105
      var $106=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $107
      __label__ = 37; break;
    case 37: // $108
      __label__ = 38; break;
    case 38: // $109
      __label__ = 39; break;
    case 39: // $110
      __label__ = 40; break;
    case 40: // $111
      __label__ = 41; break;
    case 41: // $112
      var $113=$device;
      var $114=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 4; break; };
    case 42: // $115
      $device=$114;
      __label__ = 18; break;
    case 43: // $116
      __label__ = 7; break;
    case 44: // $117
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 45: // $118
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $119
      __label__ = 47; break;
    case 47: // $120
      var $121=$3;
      var $122=$3;
      var $123=$4;
      var $124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $122, tempValue);
      var $125=($124.f1 = $123, $124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 48: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 49: // $128
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend11listdevicesEPKc["X"]=1;

function __ZNK16device_interface6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK21device_slot_interface19get_slot_interfacesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11device_list5firstIK21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceIK21device_slot_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_interface4nextIK21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextIK21device_slot_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZNK22device_image_interface13instance_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+776)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK7astring3chrEii($this, $start, $ch) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$start;
  $3=$ch;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z11astring_chrPK7astringii($4, $5, $6);
  ;
  return $7;
}


function __ZN7astringC1ERKS_ii($this, $string, $start, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$string;
  $3=$start;
  $4=$count;
  var $5=$1;
  var $6=$3;
  var $7=$4;
  var $8=$2;
  __ZN7astringC2ERKS_ii($5, $8, $6, $7);
  ;
  return;
}


function __ZN12cli_frontend9listslotsEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $slot=__stackBase__+40;
      var $first;
      var $gotone;
      var $intf;
      var $i;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 43; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 43; break;
    case 6: // $26
      var $27=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str831846)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $28
      var $29=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str841847)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $30
      __label__ = 9; break;
    case 9: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; };
    case 10: // $33
      if ($32) { __label__ = 11; break; } else { __label__ = 42; break; }
    case 11: // $34
      HEAP32[(($slot)>>2)]=0;
      $first=1;
      var $35=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 4; break; };
    case 12: // $36
      var $37=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; };
    case 13: // $38
      var $39=(function() { try { __THREW__ = false; return __ZNK11device_list5firstIK21device_slot_interfaceEEbRPT_($37, $slot) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $40
      var $41=(($39)&1);
      $gotone=$41;
      __label__ = 15; break;
    case 15: // $42
      var $43=$gotone;
      var $44=(($43) & 1);
      if ($44) { __label__ = 16; break; } else { __label__ = 37; break; }
    case 16: // $45
      var $46=$first;
      var $47=(($46) & 1);
      if ($47) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 4; break; };
    case 18: // $50
      var $51=(($49+8)|0);
      var $52=HEAP32[(($51)>>2)];
      var $55 = $52;__label__ = 20; break;
    case 19: // $53
      var $55 = ((__str511814)|0);__label__ = 20; break;
    case 20: // $54
      var $55;
      var $56=HEAP32[(($slot)>>2)];
      var $57=$56;
      var $58=(function() { try { __THREW__ = false; return __ZNK16device_interface6deviceEv($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 4; break; };
    case 21: // $59
      var $60=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 4; break; };
    case 22: // $61
      var $62=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str851848)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,HEAP32[((tempInt+4)>>2)]=$60,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 4; break; };
    case 23: // $63
      var $64=HEAP32[(($slot)>>2)];
      var $65=(function() { try { __THREW__ = false; return __ZNK21device_slot_interface19get_slot_interfacesEv($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 4; break; };
    case 24: // $66
      $intf=$65;
      $i=0;
      __label__ = 25; break;
    case 25: // $67
      var $68=$i;
      var $69=$intf;
      var $70=(($69+($68<<3))|0);
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 26; break; } else { __label__ = 33; break; }
    case 26: // $74
      var $75=$i;
      var $76=(($75)|0)==0;
      if ($76) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $77
      var $78=$i;
      var $79=$intf;
      var $80=(($79+($78<<3))|0);
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str551818)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 4; break; };
    case 28: // $84
      __label__ = 31; break;
    case 29: // $85
      var $86=$i;
      var $87=$intf;
      var $88=(($87+($86<<3))|0);
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str861849)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((__str511814)|0),HEAP32[((tempInt+4)>>2)]=$90,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 4; break; };
    case 30: // $92
      __label__ = 31; break;
    case 31: // $93
      __label__ = 32; break;
    case 32: // $94
      var $95=$i;
      var $96=(($95+1)|0);
      $i=$96;
      __label__ = 25; break;
    case 33: // $97
      var $98=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 4; break; };
    case 34: // $99
      $first=0;
      __label__ = 35; break;
    case 35: // $100
      var $101=HEAP32[(($slot)>>2)];
      var $102=$101;
      var $103=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextIK21device_slot_interfaceEEbRPT_($102, $slot) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $104
      var $105=(($103)&1);
      $gotone=$105;
      __label__ = 15; break;
    case 37: // $106
      var $107=$first;
      var $108=(($107) & 1);
      if ($108) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $109
      var $110=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 4; break; };
    case 39: // $111
      var $112=(($110+8)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str871850)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$113,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 4; break; };
    case 40: // $115
      __label__ = 41; break;
    case 41: // $116
      __label__ = 9; break;
    case 42: // $117
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 43: // $118
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $119
      __label__ = 45; break;
    case 45: // $120
      var $121=$3;
      var $122=$3;
      var $123=$4;
      var $124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $122, tempValue);
      var $125=($124.f1 = $123, $124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 47: // $128
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend9listslotsEPKc["X"]=1;

function __ZN12cli_frontend9listmediaEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 236; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $imagedev=__stackBase__+40;
      var $first;
      var $gotone;
      var $paren_shortname=__stackBase__+44;
      var $extensions=__stackBase__+108;
      var $start;
      var $end;
      var $curext=__stackBase__+172;
      var $5;
      $1=$this;
      $2=$gamename;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $9, $10);
      var $11=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $12
      var $13=(($11)|0)==0;
      if ($13) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $14
      var $15=___cxa_allocate_exception(1032);
      var $16=$15;
      var $17=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($16, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      (function() { try { __THREW__ = false; return ___cxa_throw($15, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 4; break; }
    case 4: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $3=$21;
      var $22=$20.f1;
      $4=$22;
      __label__ = 65; break;
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $3=$25;
      var $26=$24.f1;
      $4=$26;
      ___cxa_free_exception($15);
      __label__ = 65; break;
    case 6: // $27
      var $28=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str881851)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $29
      var $30=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str841847)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      var $33=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; };
    case 10: // $34
      if ($33) { __label__ = 11; break; } else { __label__ = 64; break; }
    case 11: // $35
      HEAP32[(($imagedev)>>2)]=0;
      $first=1;
      var $36=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 4; break; };
    case 12: // $37
      var $38=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; };
    case 13: // $39
      var $40=(function() { try { __THREW__ = false; return __ZNK11device_list5firstIK22device_image_interfaceEEbRPT_($38, $imagedev) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $41
      var $42=(($40)&1);
      $gotone=$42;
      __label__ = 15; break;
    case 15: // $43
      var $44=$gotone;
      var $45=(($44) & 1);
      if ($45) { __label__ = 16; break; } else { __label__ = 59; break; }
    case 16: // $46
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($paren_shortname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 4; break; }
    case 17: // $47
      var $48=HEAP32[(($imagedev)>>2)];
      var $49=(function() { try { __THREW__ = false; return __ZNK22device_image_interface19brief_instance_nameEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 39; break; };
    case 18: // $50
      var $51=(function() { try { __THREW__ = false; return __ZN7astring6formatEPKcz($paren_shortname, ((STRING_TABLE.__str891852)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 39; break; };
    case 19: // $52
      var $53=$first;
      var $54=(($53) & 1);
      if ($54) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $55
      var $56=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 39; break; };
    case 21: // $57
      var $58=(($56+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $62 = $59;__label__ = 23; break;
    case 22: // $60
      var $62 = ((__str511814)|0);__label__ = 23; break;
    case 23: // $61
      var $62;
      var $63=HEAP32[(($imagedev)>>2)];
      var $64=(function() { try { __THREW__ = false; return __ZNK22device_image_interface13instance_nameEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 39; break; };
    case 24: // $65
      var $66=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($paren_shortname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 39; break; };
    case 25: // $67
      var $68=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str901853)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$62,HEAP32[((tempInt+4)>>2)]=$64,HEAP32[((tempInt+8)>>2)]=$66,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 39; break; };
    case 26: // $69
      var $70=HEAP32[(($imagedev)>>2)];
      var $71=$70;
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+124)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$74]($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 39; break; };
    case 27: // $76
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($extensions, $75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 39; break; }
    case 28: // $77
      $start=0;
      var $78=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($extensions, 0, 44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 40; break; };
    case 29: // $79
      $end=$78;
      __label__ = 30; break;
    case 30: // $80
      var $81=$start;
      var $82=$end;
      var $83=(($82)|0)==-1;
      if ($83) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $84
      var $85=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($extensions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 40; break; };
    case 32: // $86
      var $87=$start;
      var $88=(($85-$87)|0);
      var $94 = $88;__label__ = 34; break;
    case 33: // $89
      var $90=$end;
      var $91=$start;
      var $92=(($90-$91)|0);
      var $94 = $92;__label__ = 34; break;
    case 34: // $93
      var $94;
      (function() { try { __THREW__ = false; return __ZN7astringC1ERKS_ii($curext, $extensions, $81, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 40; break; }
    case 35: // $95
      var $96=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($curext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 41; break; };
    case 36: // $97
      var $98=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str911854)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$96,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 41; break; };
    case 37: // $99
      var $100=$end;
      var $101=(($100)|0)==-1;
      if ($101) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $102
      $5=7;
      __label__ = 43; break;
    case 39: // $103
      var $104=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $105=$104.f0;
      $3=$105;
      var $106=$104.f1;
      $4=$106;
      __label__ = 57; break;
    case 40: // $107
      var $108=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $109=$108.f0;
      $3=$109;
      var $110=$108.f1;
      $4=$110;
      __label__ = 55; break;
    case 41: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $3=$113;
      var $114=$112.f1;
      $4=$114;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 68; break; }
    case 42: // $115
      $5=0;
      __label__ = 43; break;
    case 43: // $116
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 40; break; }
    case 44: // $117
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0) {
        __label__ = 45; break;
      }
      else if ($cleanup_dest == 7) {
        __label__ = 49; break;
      }
      else {
      __label__ = 69; break;
      }
      
    case 45: // $118
      __label__ = 46; break;
    case 46: // $119
      var $120=$end;
      var $121=(($120+1)|0);
      $start=$121;
      var $122=$start;
      var $123=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($extensions, $122, 44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 40; break; };
    case 47: // $124
      $end=$123;
      __label__ = 30; break;
    case 48: // $125
      __label__ = 55; break;
    case 49: // $126
      var $127=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str681831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 40; break; };
    case 50: // $128
      $first=0;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($extensions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 39; break; }
    case 51: // $129
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($paren_shortname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 4; break; }
    case 52: // $130
      __label__ = 53; break;
    case 53: // $131
      var $132=HEAP32[(($imagedev)>>2)];
      var $133=$132;
      var $134=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_($133, $imagedev) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 4; break; };
    case 54: // $135
      var $136=(($134)&1);
      $gotone=$136;
      __label__ = 15; break;
    case 55: // $137
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($extensions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 68; break; }
    case 56: // $138
      __label__ = 57; break;
    case 57: // $139
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($paren_shortname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 68; break; }
    case 58: // $140
      __label__ = 65; break;
    case 59: // $141
      var $142=$first;
      var $143=(($142) & 1);
      if ($143) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $144
      var $145=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 4; break; };
    case 61: // $146
      var $147=(($145+8)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(function() { try { __THREW__ = false; return _printf(((STRING_TABLE.__str871850)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$148,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 4; break; };
    case 62: // $150
      __label__ = 63; break;
    case 63: // $151
      __label__ = 9; break;
    case 64: // $152
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 65: // $153
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $154
      __label__ = 67; break;
    case 67: // $155
      var $156=$3;
      var $157=$3;
      var $158=$4;
      var $159=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $157, tempValue);
      var $160=($159.f1 = $158, $159);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $161
      var $162=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 69: // $163
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend9listmediaEPKc["X"]=1;

function __ZN13media_auditorD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13media_auditorD2Ev($2);
  ;
  return;
}


function __ZN12cli_frontend10verifyromsEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $correct;
      var $incorrect;
      var $notfound;
      var $auditor=__stackBase__+40;
      var $summary;
      var $summary_string=__stackBase__+72;
      var $clone_of;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 57; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 57; break;
    case 6: // $26
      $correct=0;
      $incorrect=0;
      $notfound=0;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13media_auditorC1ERK17driver_enumerator]($auditor, $drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 17; break; };
    case 9: // $30
      if ($29) { __label__ = 10; break; } else { __label__ = 38; break; }
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN13media_auditor11audit_mediaEPKc($auditor, ((STRING_TABLE.__str921855)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; };
    case 11: // $33
      $summary=$32;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $34
      var $35=(function() { try { __THREW__ = false; return __ZN13media_auditor9summarizeEP7astring($auditor, $summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 18; break; };
    case 13: // $36
      var $37=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 18; break; };
    case 14: // $38
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str451808)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $39
      var $40=$summary;
      var $41=(($40)|0)==4;
      if ($41) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $42
      var $43=$notfound;
      var $44=(($43+1)|0);
      $notfound=$44;
      __label__ = 35; break;
    case 17: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $3=$47;
      var $48=$46.f1;
      $4=$48;
      __label__ = 55; break;
    case 18: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $3=$51;
      var $52=$50.f1;
      $4=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 60; break; }
    case 19: // $53
      var $54=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 18; break; };
    case 20: // $55
      var $56=(($54+8)|0);
      var $57=HEAP32[(($56)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str931856)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$57,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 18; break; }
    case 21: // $58
      var $59=(function() { try { __THREW__ = false; return __ZN17driver_enumerator5cloneEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 18; break; };
    case 22: // $60
      $clone_of=$59;
      var $61=$clone_of;
      var $62=(($61)|0)!=-1;
      if ($62) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $63
      var $64=$clone_of;
      var $65=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 18; break; };
    case 24: // $66
      var $67=(($65+8)|0);
      var $68=HEAP32[(($67)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str941857)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$68,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 18; break; }
    case 25: // $69
      __label__ = 26; break;
    case 26: // $70
      var $71=$summary;
      if ($71 == 3) {
        __label__ = 27; break;
      }
      else if ($71 == 0) {
        __label__ = 29; break;
      }
      else if ($71 == 2) {
        __label__ = 31; break;
      }
      else {
      __label__ = 33; break;
      }
      
    case 27: // $72
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str951858)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 18; break; }
    case 28: // $73
      var $74=$incorrect;
      var $75=(($74+1)|0);
      $incorrect=$75;
      __label__ = 34; break;
    case 29: // $76
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str961859)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 18; break; }
    case 30: // $77
      var $78=$correct;
      var $79=(($78+1)|0);
      $correct=$79;
      __label__ = 34; break;
    case 31: // $80
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str971860)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 18; break; }
    case 32: // $81
      var $82=$correct;
      var $83=(($82+1)|0);
      $correct=$83;
      __label__ = 34; break;
    case 33: // $84
      __label__ = 34; break;
    case 34: // $85
      __label__ = 35; break;
    case 35: // $86
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 17; break; }
    case 36: // $87
      __label__ = 8; break;
    case 37: // $88
      __label__ = 55; break;
    case 38: // $89
      (function() { try { __THREW__ = false; return __Z20zip_file_cache_clearv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 17; break; }
    case 39: // $90
      var $91=$correct;
      var $92=$incorrect;
      var $93=(($91+$92)|0);
      var $94=(($93)|0)==0;
      if ($94) { __label__ = 40; break; } else { __label__ = 47; break; }
    case 40: // $95
      var $96=$notfound;
      var $97=(($96)|0) > 0;
      if ($97) { __label__ = 41; break; } else { __label__ = 44; break; }
    case 41: // $98
      var $99=___cxa_allocate_exception(1032);
      var $100=$99;
      var $101=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($100, 5, ((STRING_TABLE.__str981861)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$101,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $102
      (function() { try { __THREW__ = false; return ___cxa_throw($99, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 17; break; }
    case 43: // $103
      var $104=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $105=$104.f0;
      $3=$105;
      var $106=$104.f1;
      $4=$106;
      ___cxa_free_exception($99);
      __label__ = 55; break;
    case 44: // $107
      var $108=___cxa_allocate_exception(1032);
      var $109=$108;
      var $110=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($109, 5, ((STRING_TABLE.__str991862)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$110,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $111
      (function() { try { __THREW__ = false; return ___cxa_throw($108, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 17; break; }
    case 46: // $112
      var $113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $114=$113.f0;
      $3=$114;
      var $115=$113.f1;
      $4=$115;
      ___cxa_free_exception($108);
      __label__ = 55; break;
    case 47: // $116
      var $117=$incorrect;
      var $118=(($117)|0) > 0;
      if ($118) { __label__ = 48; break; } else { __label__ = 51; break; }
    case 48: // $119
      var $120=___cxa_allocate_exception(1032);
      var $121=$120;
      var $122=$correct;
      var $123=$incorrect;
      var $124=(($122+$123)|0);
      var $125=$correct;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($121, 2, ((STRING_TABLE.__str1001863)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$124,HEAP32[((tempInt+4)>>2)]=$125,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $126
      (function() { try { __THREW__ = false; return ___cxa_throw($120, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 17; break; }
    case 50: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      $3=$129;
      var $130=$128.f1;
      $4=$130;
      ___cxa_free_exception($120);
      __label__ = 55; break;
    case 51: // $131
      var $132=$correct;
      var $133=$correct;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1001863)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$132,HEAP32[((tempInt+4)>>2)]=$133,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 17; break; }
    case 52: // $134
      __label__ = 53; break;
    case 53: // $135
      (function() { try { __THREW__ = false; return __ZN13media_auditorD1Ev($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 4; break; }
    case 54: // $136
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 55: // $137
      (function() { try { __THREW__ = false; return __ZN13media_auditorD1Ev($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 60; break; }
    case 56: // $138
      __label__ = 57; break;
    case 57: // $139
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 60; break; }
    case 58: // $140
      __label__ = 59; break;
    case 59: // $141
      var $142=$3;
      var $143=$3;
      var $144=$4;
      var $145=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $143, tempValue);
      var $146=($145.f1 = $144, $145);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 60: // $147
      var $148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 61: // $149
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend10verifyromsEPKc["X"]=1;

function __ZN12cli_frontend13verifysamplesEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $drivlist=__stackBase__;
      var $3;
      var $4;
      var $correct;
      var $incorrect;
      var $notfound;
      var $auditor=__stackBase__+40;
      var $summary;
      var $summary_string=__stackBase__+72;
      var $clone_of;
      $1=$this;
      $2=$gamename;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      var $9=$2;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $8, $9);
      var $10=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $11
      var $12=(($10)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($15, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      (function() { try { __THREW__ = false; return ___cxa_throw($14, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 59; break;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($14);
      __label__ = 59; break;
    case 6: // $26
      $correct=0;
      $incorrect=0;
      $notfound=0;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13media_auditorC1ERK17driver_enumerator]($auditor, $drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 19; break; };
    case 9: // $30
      if ($29) { __label__ = 10; break; } else { __label__ = 40; break; }
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN13media_auditor13audit_samplesEv($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 19; break; };
    case 11: // $33
      $summary=$32;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 19; break; }
    case 12: // $34
      var $35=(function() { try { __THREW__ = false; return __ZN13media_auditor9summarizeEP7astring($auditor, $summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; };
    case 13: // $36
      var $37=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 20; break; };
    case 14: // $38
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str451808)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $39
      var $40=$summary;
      var $41=(($40)|0)==4;
      if ($41) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $42
      var $43=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 20; break; };
    case 17: // $44
      var $45=(($43+8)|0);
      var $46=HEAP32[(($45)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1011864)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$46,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $47
      var $48=$notfound;
      var $49=(($48+1)|0);
      $notfound=$49;
      __label__ = 37; break;
    case 19: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      $3=$52;
      var $53=$51.f1;
      $4=$53;
      __label__ = 57; break;
    case 20: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      $3=$56;
      var $57=$55.f1;
      $4=$57;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 62; break; }
    case 21: // $58
      var $59=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 20; break; };
    case 22: // $60
      var $61=(($59+8)|0);
      var $62=HEAP32[(($61)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1021865)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$62,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 20; break; }
    case 23: // $63
      var $64=(function() { try { __THREW__ = false; return __ZN17driver_enumerator5cloneEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 20; break; };
    case 24: // $65
      $clone_of=$64;
      var $66=$clone_of;
      var $67=(($66)|0)!=-1;
      if ($67) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $68
      var $69=$clone_of;
      var $70=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 20; break; };
    case 26: // $71
      var $72=(($70+8)|0);
      var $73=HEAP32[(($72)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str941857)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 20; break; }
    case 27: // $74
      __label__ = 28; break;
    case 28: // $75
      var $76=$summary;
      if ($76 == 3) {
        __label__ = 29; break;
      }
      else if ($76 == 0) {
        __label__ = 31; break;
      }
      else if ($76 == 2) {
        __label__ = 33; break;
      }
      else {
      __label__ = 35; break;
      }
      
    case 29: // $77
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str951858)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 20; break; }
    case 30: // $78
      var $79=$incorrect;
      var $80=(($79+1)|0);
      $incorrect=$80;
      __label__ = 36; break;
    case 31: // $81
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str961859)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 20; break; }
    case 32: // $82
      var $83=$correct;
      var $84=(($83+1)|0);
      $correct=$84;
      __label__ = 36; break;
    case 33: // $85
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str971860)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 20; break; }
    case 34: // $86
      var $87=$correct;
      var $88=(($87+1)|0);
      $correct=$88;
      __label__ = 36; break;
    case 35: // $89
      __label__ = 36; break;
    case 36: // $90
      __label__ = 37; break;
    case 37: // $91
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($summary_string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 19; break; }
    case 38: // $92
      __label__ = 8; break;
    case 39: // $93
      __label__ = 57; break;
    case 40: // $94
      (function() { try { __THREW__ = false; return __Z20zip_file_cache_clearv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 19; break; }
    case 41: // $95
      var $96=$correct;
      var $97=$incorrect;
      var $98=(($96+$97)|0);
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 42; break; } else { __label__ = 49; break; }
    case 42: // $100
      var $101=$notfound;
      var $102=(($101)|0) > 0;
      if ($102) { __label__ = 43; break; } else { __label__ = 46; break; }
    case 43: // $103
      var $104=___cxa_allocate_exception(1032);
      var $105=$104;
      var $106=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($105, 5, ((STRING_TABLE.__str1011864)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$106,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $107
      (function() { try { __THREW__ = false; return ___cxa_throw($104, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 19; break; }
    case 45: // $108
      var $109=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $110=$109.f0;
      $3=$110;
      var $111=$109.f1;
      $4=$111;
      ___cxa_free_exception($104);
      __label__ = 57; break;
    case 46: // $112
      var $113=___cxa_allocate_exception(1032);
      var $114=$113;
      var $115=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($114, 5, ((STRING_TABLE.__str1031866)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$115,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $116
      (function() { try { __THREW__ = false; return ___cxa_throw($113, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 19; break; }
    case 48: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      $3=$119;
      var $120=$118.f1;
      $4=$120;
      ___cxa_free_exception($113);
      __label__ = 57; break;
    case 49: // $121
      var $122=$incorrect;
      var $123=(($122)|0) > 0;
      if ($123) { __label__ = 50; break; } else { __label__ = 53; break; }
    case 50: // $124
      var $125=___cxa_allocate_exception(1032);
      var $126=$125;
      var $127=$correct;
      var $128=$incorrect;
      var $129=(($127+$128)|0);
      var $130=$correct;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($126, 2, ((STRING_TABLE.__str1041867)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$129,HEAP32[((tempInt+4)>>2)]=$130,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $131
      (function() { try { __THREW__ = false; return ___cxa_throw($125, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 19; break; }
    case 52: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $134=$133.f0;
      $3=$134;
      var $135=$133.f1;
      $4=$135;
      ___cxa_free_exception($125);
      __label__ = 57; break;
    case 53: // $136
      var $137=$correct;
      var $138=$correct;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1041867)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$137,HEAP32[((tempInt+4)>>2)]=$138,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 19; break; }
    case 54: // $139
      __label__ = 55; break;
    case 55: // $140
      (function() { try { __THREW__ = false; return __ZN13media_auditorD1Ev($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 4; break; }
    case 56: // $141
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 57: // $142
      (function() { try { __THREW__ = false; return __ZN13media_auditorD1Ev($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 62; break; }
    case 58: // $143
      __label__ = 59; break;
    case 59: // $144
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $145
      __label__ = 61; break;
    case 61: // $146
      var $147=$3;
      var $148=$3;
      var $149=$4;
      var $150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $148, tempValue);
      var $151=($150.f1 = $149, $150);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $152
      var $153=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 63: // $154
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend13verifysamplesEPKc["X"]=1;

function __ZN12cli_frontend12listsoftwareEPKc($this, $gamename) {
  var __stackBase__  = STACKTOP; STACKTOP += 224; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $out;
      var $drivlist=__stackBase__+36;
      var $11;
      var $12;
      var $list_count;
      var $dev;
      var $swlist;
      var $listnum;
      var $lists;
      var $dev1;
      var $swlist2;
      var $listnum3;
      var $list;
      var $seen_before;
      var $seen_index;
      var $swinfo;
      var $part;
      var $list4;
      var $region;
      var $is_disk;
      var $rom;
      var $hashes=__stackBase__+76;
      var $tempstr=__stackBase__+160;
      var $hash;
      $9=$this;
      $10=$gamename;
      var $13=$9;
      var $14=HEAP32[((__impure_ptr)>>2)];
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      $out=$16;
      var $17=(($13)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18;
      var $20=$10;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsPKc]($drivlist, $19, $20);
      var $21=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator5countEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $22
      var $23=(($21)|0)==0;
      if ($23) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $24
      var $25=___cxa_allocate_exception(1032);
      var $26=$25;
      var $27=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($26, 5, ((STRING_TABLE.__str581821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$27,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $28
      (function() { try { __THREW__ = false; return ___cxa_throw($25, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 263; break; } else { __label__ = 4; break; }
    case 4: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $30;__label__ = 5; break;
    case 5: // $_body
      var $eh_lpad_body;
      var $31=$eh_lpad_body.f0;
      $11=$31;
      var $32=$eh_lpad_body.f1;
      $12=$32;
      __label__ = 259; break;
    case 6: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      ___cxa_free_exception($25);
      __label__ = 259; break;
    case 7: // $37
      $list_count=0;
      __label__ = 8; break;
    case 8: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; };
    case 9: // $40
      if ($39) { __label__ = 10; break; } else { __label__ = 29; break; }
    case 10: // $41
      var $42=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $43
      var $44=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 4; break; };
    case 12: // $45
      var $46=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $47=(function() { try { __THREW__ = false; return __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($44, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; };
    case 13: // $48
      $dev=$47;
      __label__ = 14; break;
    case 14: // $49
      var $50=$dev;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 15; break; } else { __label__ = 28; break; }
    case 15: // $52
      var $53=$dev;
      var $54=(function() { try { __THREW__ = false; return __Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 4; break; };
    case 16: // $55
      var $56=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base13inline_configEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 4; break; };
    case 17: // $57
      var $58=$56;
      $swlist=$58;
      $listnum=0;
      __label__ = 18; break;
    case 18: // $59
      var $60=$listnum;
      var $61=(($60)|0) < 9;
      if ($61) { __label__ = 19; break; } else { __label__ = 25; break; }
    case 19: // $62
      var $63=$listnum;
      var $64=$swlist;
      var $65=(($64)|0);
      var $66=(($65+($63<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $69
      var $70=$listnum;
      var $71=$swlist;
      var $72=(($71)|0);
      var $73=(($72+($70<<2))|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24)!=0;
      if ($76) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $77
      var $78=$swlist;
      var $79=(($78+40)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $82
      var $83=$list_count;
      var $84=(($83+1)|0);
      $list_count=$84;
      __label__ = 23; break;
    case 23: // $85
      __label__ = 24; break;
    case 24: // $86
      var $87=$listnum;
      var $88=(($87+1)|0);
      $listnum=$88;
      __label__ = 18; break;
    case 25: // $89
      __label__ = 26; break;
    case 26: // $90
      var $91=$dev;
      var $92=(function() { try { __THREW__ = false; return __ZNK8device_t8typenextEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 4; break; };
    case 27: // $93
      $dev=$92;
      __label__ = 14; break;
    case 28: // $94
      __label__ = 8; break;
    case 29: // $95
      var $96=$list_count;
      var $97=_llvm_umul_with_overflow_i32($96, 64);
      var $98=$97.f1;
      var $99=$97.f0;
      var $100=_llvm_uadd_with_overflow_i32($99, 4);
      var $101=$100.f1;
      var $102=$98 | $101;
      var $103=$100.f0;
      var $104=$102 ? -1 : $103;
      var $105=$4;
      var $106=$5;
      var $107=$6;
      var $108=$result_i;
      var $109=$7;
      var $110=$8;
      HEAP32[(($4)>>2)]=$104;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str1051868)|0);
      HEAP32[(($6)>>2)]=937;
      var $111=HEAP32[(($4)>>2)];
      var $112=HEAP32[(($5)>>2)];
      var $113=HEAP32[(($6)>>2)];
      var $114=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($111, $112, $113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; };
    case 30: // $115
      HEAP32[(($result_i)>>2)]=$114;
      var $116=HEAP32[(($result_i)>>2)];
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 31; break; } else { __label__ = 37; break; }
    case 31: // $118
      var $119=___cxa_allocate_exception(4);
      var $120=$119;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($120);
      (function() { try { __THREW__ = false; return ___cxa_throw($119, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 32; break; }
    case 32: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $123=$122.f0;
      HEAP32[(($7)>>2)]=$123;
      var $124=$122.f1;
      HEAP32[(($8)>>2)]=$124;
      var $125=HEAP32[(($8)>>2)];
      var $126=(($125)|0) < 0;
      if ($126) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $127
      var $128=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 4; break; }
    case 34: // $_noexc
      throw "Reached an unreachable!"
    case 35: // $129
      var $130=HEAP32[(($7)>>2)];
      var $131=HEAP32[(($7)>>2)];
      var $132=HEAP32[(($8)>>2)];
      var $133=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $131, tempValue);
      var $134=($133.f1 = $132, $133);
      var $eh_lpad_body = $134;__label__ = 5; break;
    case 36: // $135
      throw "Reached an unreachable!"
    case 37: // $_ZnajPKci_exit
      var $136=HEAP32[(($result_i)>>2)];
      var $137=$4;
      var $138=$5;
      var $139=$6;
      var $140=$result_i;
      var $141=$7;
      var $142=$8;
      __label__ = 38; break;
    case 38: // $143
      var $144=$136;
      HEAP32[(($144)>>2)]=$96;
      var $145=(($136+4)|0);
      var $146=$145;
      var $147=(($96)|0)==0;
      if ($147) { __label__ = 42; break; } else { __label__ = 39; break; }
    case 39: // $148
      var $149=(($146+($96<<6))|0);
      var $151 = $146;__label__ = 40; break;
    case 40: // $150
      var $151;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 46; break; }
    case 41: // $152
      var $153=(($151+64)|0);
      var $154=(($153)|0)==(($149)|0);
      if ($154) { __label__ = 42; break; } else { var $151 = $153;__label__ = 40; break; }
    case 42: // $155
      var $156=$list_count;
      var $157=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayI7astringEEPT_S3_i(_global_resource_pool, $146, $156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 4; break; };
    case 43: // $158
      $lists=$157;
      var $159=$list_count;
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 44; break; } else { __label__ = 54; break; }
    case 44: // $161
      var $162=$out;
      var $163=(function() { try { __THREW__ = false; return _fprintf($162, ((STRING_TABLE.__str1061869)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 4; break; };
    case 45: // $164
      __label__ = 54; break;
    case 46: // $165
      var $166=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $167=$166.f0;
      $11=$167;
      var $168=$166.f1;
      $12=$168;
      var $169=(($146)|0)==(($151)|0);
      if ($169) { __label__ = 49; break; } else { var $171 = $151;__label__ = 47; break; }
    case 47: // $170
      var $171;
      var $172=(($171-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 262; break; }
    case 48: // $173
      var $174=(($172)|0)==(($146)|0);
      if ($174) { __label__ = 49; break; } else { var $171 = $172;__label__ = 47; break; }
    case 49: // $175
      var $176=$1;
      var $177=$2;
      var $178=$3;
      HEAP32[(($1)>>2)]=$136;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1051868)|0);
      HEAP32[(($3)>>2)]=937;
      var $179=HEAP32[(($1)>>2)];
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $181
      var $182=HEAP32[(($1)>>2)];
      var $183=HEAP32[(($2)>>2)];
      var $184=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($182, $183, $184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 262; break; }
    case 51: // $_noexc5
      __label__ = 52; break;
    case 52: // $_ZdaPvPKci_exit
      var $185=$1;
      var $186=$2;
      var $187=$3;
      __label__ = 53; break;
    case 53: // $188
      __label__ = 259; break;
    case 54: // $189
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator5resetEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 4; break; }
    case 55: // $190
      $list_count=0;
      __label__ = 56; break;
    case 56: // $191
      var $192=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 4; break; };
    case 57: // $193
      if ($192) { __label__ = 58; break; } else { __label__ = 252; break; }
    case 58: // $194
      var $195=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6configEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 4; break; };
    case 59: // $196
      var $197=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 4; break; };
    case 60: // $198
      var $199=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $200=(function() { try { __THREW__ = false; return __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($197, $199) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 4; break; };
    case 61: // $201
      $dev1=$200;
      __label__ = 62; break;
    case 62: // $202
      var $203=$dev1;
      var $204=(($203)|0)!=0;
      if ($204) { __label__ = 63; break; } else { __label__ = 251; break; }
    case 63: // $205
      var $206=$dev1;
      var $207=(function() { try { __THREW__ = false; return __Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 4; break; };
    case 64: // $208
      var $209=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base13inline_configEv($207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 4; break; };
    case 65: // $210
      var $211=$209;
      $swlist2=$211;
      $listnum3=0;
      __label__ = 66; break;
    case 66: // $212
      var $213=$listnum3;
      var $214=(($213)|0) < 9;
      if ($214) { __label__ = 67; break; } else { __label__ = 248; break; }
    case 67: // $215
      var $216=$listnum3;
      var $217=$swlist2;
      var $218=(($217)|0);
      var $219=(($218+($216<<2))|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220)|0)!=0;
      if ($221) { __label__ = 68; break; } else { __label__ = 246; break; }
    case 68: // $222
      var $223=$listnum3;
      var $224=$swlist2;
      var $225=(($224)|0);
      var $226=(($225+($223<<2))|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=HEAP8[($227)];
      var $229=(($228 << 24) >> 24)!=0;
      if ($229) { __label__ = 69; break; } else { __label__ = 246; break; }
    case 69: // $230
      var $231=$swlist2;
      var $232=(($231+40)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($233)|0)==0;
      if ($234) { __label__ = 70; break; } else { __label__ = 246; break; }
    case 70: // $235
      var $236=(($13)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=$237;
      var $239=$listnum3;
      var $240=$swlist2;
      var $241=(($240)|0);
      var $242=(($241+($239<<2))|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(function() { try { __THREW__ = false; return __Z18software_list_openR11emu_optionsPKciPFvS2_E($238, $243, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 4; break; };
    case 71: // $245
      $list=$244;
      var $246=$list;
      var $247=(($246)|0)!=0;
      if ($247) { __label__ = 72; break; } else { __label__ = 245; break; }
    case 72: // $248
      $seen_before=0;
      $seen_index=0;
      __label__ = 73; break;
    case 73: // $249
      var $250=$seen_index;
      var $251=$list_count;
      var $252=(($250)|0) < (($251)|0);
      if ($252) { __label__ = 74; break; } else { var $258 = 0;__label__ = 75; break; }
    case 74: // $253
      var $254=$seen_before;
      var $255=(($254) & 1);
      var $256=$255 ^ 1;
      var $258 = $256;__label__ = 75; break;
    case 75: // $257
      var $258;
      if ($258) { __label__ = 76; break; } else { __label__ = 81; break; }
    case 76: // $259
      var $260=$seen_index;
      var $261=$lists;
      var $262=(($261+($260<<6))|0);
      var $263=$listnum3;
      var $264=$swlist2;
      var $265=(($264)|0);
      var $266=(($265+($263<<2))|0);
      var $267=HEAP32[(($266)>>2)];
      var $268=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($262, $267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 4; break; };
    case 77: // $269
      if ($268) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $270
      $seen_before=1;
      __label__ = 79; break;
    case 79: // $271
      __label__ = 80; break;
    case 80: // $272
      var $273=$seen_index;
      var $274=(($273+1)|0);
      $seen_index=$274;
      __label__ = 73; break;
    case 81: // $275
      var $276=$seen_before;
      var $277=(($276) & 1);
      if ($277) { __label__ = 243; break; } else { __label__ = 82; break; }
    case 82: // $278
      var $279=$list_count;
      var $280=(($279+1)|0);
      $list_count=$280;
      var $281=$lists;
      var $282=(($281+($279<<6))|0);
      var $283=$listnum3;
      var $284=$swlist2;
      var $285=(($284)|0);
      var $286=(($285+($283<<2))|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($282, $287) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 4; break; };
    case 83: // $289
      var $290=$list;
      (function() { try { __THREW__ = false; return __Z19software_list_parseP14_software_listPFvPKcEPv($290, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 4; break; }
    case 84: // $291
      var $292=$out;
      var $293=$listnum3;
      var $294=$swlist2;
      var $295=(($294)|0);
      var $296=(($295+($293<<2))|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$list;
      var $299=(function() { try { __THREW__ = false; return __Z29software_list_get_descriptionP14_software_list($298) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 4; break; };
    case 85: // $300
      var $301=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 4; break; };
    case 86: // $302
      var $303=(function() { try { __THREW__ = false; return _fprintf($292, ((STRING_TABLE.__str1071870)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$297,HEAP32[((tempInt+4)>>2)]=$301,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 4; break; };
    case 87: // $304
      var $305=$list;
      var $306=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($305, ((STRING_TABLE.__str1081871)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 4; break; };
    case 88: // $307
      $swinfo=$306;
      __label__ = 89; break;
    case 89: // $308
      var $309=$swinfo;
      var $310=(($309)|0)!=0;
      if ($310) { __label__ = 90; break; } else { __label__ = 241; break; }
    case 90: // $311
      var $312=$out;
      var $313=$swinfo;
      var $314=(($313)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=(function() { try { __THREW__ = false; return _fprintf($312, ((STRING_TABLE.__str1091872)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$315,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 4; break; };
    case 91: // $317
      var $318=$swinfo;
      var $319=(($318+8)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=(($320)|0)!=0;
      if ($321) { __label__ = 92; break; } else { __label__ = 94; break; }
    case 92: // $322
      var $323=$out;
      var $324=$swinfo;
      var $325=(($324+8)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=(function() { try { __THREW__ = false; return _fprintf($323, ((STRING_TABLE.__str1101873)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$326,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 4; break; };
    case 93: // $328
      __label__ = 94; break;
    case 94: // $329
      var $330=$swinfo;
      var $331=(($330+28)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=(($332)|0)==1;
      if ($333) { __label__ = 95; break; } else { __label__ = 97; break; }
    case 95: // $334
      var $335=$out;
      var $336=(function() { try { __THREW__ = false; return _fprintf($335, ((STRING_TABLE.__str1111874)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 4; break; };
    case 96: // $337
      __label__ = 97; break;
    case 97: // $338
      var $339=$swinfo;
      var $340=(($339+28)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=(($341)|0)==2;
      if ($342) { __label__ = 98; break; } else { __label__ = 100; break; }
    case 98: // $343
      var $344=$out;
      var $345=(function() { try { __THREW__ = false; return _fprintf($344, ((STRING_TABLE.__str1121875)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 4; break; };
    case 99: // $346
      __label__ = 100; break;
    case 100: // $347
      var $348=$out;
      var $349=(function() { try { __THREW__ = false; return _fprintf($348, ((STRING_TABLE.__str1131876)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 101; break; } else { __label__ = 4; break; };
    case 101: // $350
      var $351=$out;
      var $352=$swinfo;
      var $353=(($352+4)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 4; break; };
    case 102: // $356
      var $357=(function() { try { __THREW__ = false; return _fprintf($351, ((STRING_TABLE.__str1141877)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$355,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 4; break; };
    case 103: // $358
      var $359=$out;
      var $360=$swinfo;
      var $361=(($360+12)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($362) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 4; break; };
    case 104: // $364
      var $365=(function() { try { __THREW__ = false; return _fprintf($359, ((STRING_TABLE.__str1151878)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$363,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 4; break; };
    case 105: // $366
      var $367=$out;
      var $368=$swinfo;
      var $369=(($368+16)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($370) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 4; break; };
    case 106: // $372
      var $373=(function() { try { __THREW__ = false; return _fprintf($367, ((STRING_TABLE.__str1161879)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$371,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 4; break; };
    case 107: // $374
      var $375=$swinfo;
      var $376=(function() { try { __THREW__ = false; return __Z18software_find_partP13software_infoPKcS2_($375, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 4; break; };
    case 108: // $377
      $part=$376;
      __label__ = 109; break;
    case 109: // $378
      var $379=$part;
      var $380=(($379)|0)!=0;
      if ($380) { __label__ = 110; break; } else { __label__ = 237; break; }
    case 110: // $381
      var $382=$out;
      var $383=$part;
      var $384=(($383)|0);
      var $385=HEAP32[(($384)>>2)];
      var $386=(function() { try { __THREW__ = false; return _fprintf($382, ((STRING_TABLE.__str1171880)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$385,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 4; break; };
    case 111: // $387
      var $388=$part;
      var $389=(($388+4)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=(($390)|0)!=0;
      if ($391) { __label__ = 112; break; } else { __label__ = 114; break; }
    case 112: // $392
      var $393=$out;
      var $394=$part;
      var $395=(($394+4)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=(function() { try { __THREW__ = false; return _fprintf($393, ((STRING_TABLE.__str1181881)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$396,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 4; break; };
    case 113: // $398
      __label__ = 114; break;
    case 114: // $399
      var $400=$out;
      var $401=(function() { try { __THREW__ = false; return _fprintf($400, ((STRING_TABLE.__str1131876)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 115; break; } else { __label__ = 4; break; };
    case 115: // $402
      var $403=$part;
      var $404=(($403+8)|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=(($405)|0)!=0;
      if ($406) { __label__ = 116; break; } else { __label__ = 121; break; }
    case 116: // $407
      var $408=$part;
      var $409=(($408+8)|0);
      var $410=HEAP32[(($409)>>2)];
      $list4=$410;
      __label__ = 117; break;
    case 117: // $411
      var $412=$list4;
      var $413=(($412)|0)!=0;
      if ($413) { __label__ = 118; break; } else { __label__ = 120; break; }
    case 118: // $414
      var $415=$out;
      var $416=$list4;
      var $417=(($416+4)|0);
      var $418=HEAP32[(($417)>>2)];
      var $419=$list4;
      var $420=(($419+8)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=(function() { try { __THREW__ = false; return _fprintf($415, ((STRING_TABLE.__str1191882)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$418,HEAP32[((tempInt+4)>>2)]=$421,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 4; break; };
    case 119: // $423
      var $424=$list4;
      var $425=(($424)|0);
      var $426=HEAP32[(($425)>>2)];
      $list4=$426;
      __label__ = 117; break;
    case 120: // $427
      __label__ = 121; break;
    case 121: // $428
      var $429=$part;
      var $430=(($429+12)|0);
      var $431=HEAP32[(($430)>>2)];
      $region=$431;
      __label__ = 122; break;
    case 122: // $432
      var $433=$region;
      var $434=(($433)|0)!=0;
      if ($434) { __label__ = 123; break; } else { __label__ = 233; break; }
    case 123: // $435
      var $436=$region;
      var $437=(($436+16)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=$438 & 16384;
      var $440=(($439)|0)==16384;
      var $441=(($440)&1);
      $is_disk=$441;
      var $442=$is_disk;
      var $443=(($442)|0)!=0;
      if ($443) { __label__ = 126; break; } else { __label__ = 124; break; }
    case 124: // $444
      var $445=$out;
      var $446=$region;
      var $447=(($446)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=$region;
      var $450=(($449+12)|0);
      var $451=HEAP32[(($450)>>2)];
      var $452=(function() { try { __THREW__ = false; return _fprintf($445, ((STRING_TABLE.__str1201883)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$448,HEAP32[((tempInt+4)>>2)]=$451,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 125; break; } else { __label__ = 4; break; };
    case 125: // $453
      __label__ = 128; break;
    case 126: // $454
      var $455=$out;
      var $456=$region;
      var $457=(($456)|0);
      var $458=HEAP32[(($457)>>2)];
      var $459=(function() { try { __THREW__ = false; return _fprintf($455, ((STRING_TABLE.__str1211884)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$458,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 4; break; };
    case 127: // $460
      __label__ = 128; break;
    case 128: // $461
      var $462=$region;
      var $463=(function() { try { __THREW__ = false; return __Z14rom_first_filePK9rom_entry($462) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 129; break; } else { __label__ = 4; break; };
    case 129: // $464
      $rom=$463;
      __label__ = 130; break;
    case 130: // $465
      var $466=$rom;
      var $467=(($466)|0)!=0;
      if ($467) { __label__ = 131; break; } else { var $484 = 0;__label__ = 134; break; }
    case 131: // $468
      var $469=$rom;
      var $470=(($469+16)|0);
      var $471=HEAP32[(($470)>>2)];
      var $472=$471 & 15;
      var $473=(($472)|0)==1;
      if ($473) { var $481 = 1;__label__ = 133; break; } else { __label__ = 132; break; }
    case 132: // $474
      var $475=$rom;
      var $476=(($475+16)|0);
      var $477=HEAP32[(($476)>>2)];
      var $478=$477 & 15;
      var $479=(($478)|0)==2;
      var $481 = $479;__label__ = 133; break;
    case 133: // $480
      var $481;
      var $482=$481 ^ 1;
      var $484 = $482;__label__ = 134; break;
    case 134: // $483
      var $484;
      if ($484) { __label__ = 135; break; } else { __label__ = 225; break; }
    case 135: // $485
      var $486=$rom;
      var $487=(($486+16)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=$488 & 15;
      var $490=(($489)|0)==0;
      if ($490) { __label__ = 136; break; } else { __label__ = 211; break; }
    case 136: // $491
      var $492=$is_disk;
      var $493=(($492)|0)!=0;
      if ($493) { __label__ = 141; break; } else { __label__ = 137; break; }
    case 137: // $494
      var $495=$out;
      var $496=$rom;
      var $497=(($496)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($498) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 138; break; } else { __label__ = 4; break; };
    case 138: // $500
      var $501=$rom;
      var $502=(function() { try { __THREW__ = false; return __Z13rom_file_sizePK9rom_entry($501) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 139; break; } else { __label__ = 4; break; };
    case 139: // $503
      var $504=(function() { try { __THREW__ = false; return _fprintf($495, ((STRING_TABLE.__str1221885)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$499,HEAP32[((tempInt+4)>>2)]=$502,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 140; break; } else { __label__ = 4; break; };
    case 140: // $505
      __label__ = 144; break;
    case 141: // $506
      var $507=$out;
      var $508=$rom;
      var $509=(($508)|0);
      var $510=HEAP32[(($509)>>2)];
      var $511=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($510) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 4; break; };
    case 142: // $512
      var $513=(function() { try { __THREW__ = false; return _fprintf($507, ((STRING_TABLE.__str1231886)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$511,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 143; break; } else { __label__ = 4; break; };
    case 143: // $514
      __label__ = 144; break;
    case 144: // $515
      var $516=$rom;
      var $517=(($516+4)|0);
      var $518=HEAP32[(($517)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($hashes, $518) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 145; break; } else { __label__ = 4; break; }
    case 145: // $519
      var $520=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 146; break; } else { __label__ = 157; break; };
    case 146: // $521
      if ($520) { __label__ = 162; break; } else { __label__ = 147; break; }
    case 147: // $522
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 148; break; } else { __label__ = 157; break; }
    case 148: // $523
      var $524=(function() { try { __THREW__ = false; return __ZNK15hash_collection5firstEv($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 149; break; } else { __label__ = 158; break; };
    case 149: // $525
      $hash=$524;
      __label__ = 150; break;
    case 150: // $526
      var $527=$hash;
      var $528=(($527)|0)!=0;
      if ($528) { __label__ = 151; break; } else { __label__ = 159; break; }
    case 151: // $529
      var $530=$out;
      var $531=$hash;
      var $532=(function() { try { __THREW__ = false; return __ZNK9hash_base4nameEv($531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 158; break; };
    case 152: // $533
      var $534=$hash;
      var $535=(function() { try { __THREW__ = false; return __ZN9hash_base6stringER7astring($534, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 153; break; } else { __label__ = 158; break; };
    case 153: // $536
      var $537=(function() { try { __THREW__ = false; return _fprintf($530, ((STRING_TABLE.__str1241887)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$532,HEAP32[((tempInt+4)>>2)]=$535,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 154; break; } else { __label__ = 158; break; };
    case 154: // $538
      __label__ = 155; break;
    case 155: // $539
      var $540=$hash;
      var $541=(function() { try { __THREW__ = false; return __ZNK9hash_base4nextEv($540) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 158; break; };
    case 156: // $542
      $hash=$541;
      __label__ = 150; break;
    case 157: // $543
      var $544=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $545=$544.f0;
      $11=$545;
      var $546=$544.f1;
      $12=$546;
      __label__ = 209; break;
    case 158: // $547
      var $548=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $549=$548.f0;
      $11=$549;
      var $550=$548.f1;
      $12=$550;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 161; break; } else { __label__ = 262; break; }
    case 159: // $551
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 160; break; } else { __label__ = 157; break; }
    case 160: // $552
      __label__ = 162; break;
    case 161: // $553
      __label__ = 209; break;
    case 162: // $554
      var $555=$is_disk;
      var $556=(($555)|0)!=0;
      if ($556) { __label__ = 165; break; } else { __label__ = 163; break; }
    case 163: // $557
      var $558=$out;
      var $559=$rom;
      var $560=(($559+8)|0);
      var $561=HEAP32[(($560)>>2)];
      var $562=(function() { try { __THREW__ = false; return _fprintf($558, ((STRING_TABLE.__str1251888)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$561,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 164; break; } else { __label__ = 157; break; };
    case 164: // $563
      __label__ = 165; break;
    case 165: // $564
      var $565=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 166; break; } else { __label__ = 157; break; };
    case 166: // $566
      if ($565) { __label__ = 167; break; } else { __label__ = 169; break; }
    case 167: // $567
      var $568=$out;
      var $569=(function() { try { __THREW__ = false; return _fprintf($568, ((STRING_TABLE.__str1261889)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 168; break; } else { __label__ = 157; break; };
    case 168: // $570
      __label__ = 169; break;
    case 169: // $571
      var $572=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 170; break; } else { __label__ = 157; break; };
    case 170: // $573
      if ($572) { __label__ = 171; break; } else { __label__ = 173; break; }
    case 171: // $574
      var $575=$out;
      var $576=(function() { try { __THREW__ = false; return _fprintf($575, ((STRING_TABLE.__str1271890)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 172; break; } else { __label__ = 157; break; };
    case 172: // $577
      __label__ = 173; break;
    case 173: // $578
      var $579=$is_disk;
      var $580=(($579)|0)!=0;
      if ($580) { __label__ = 174; break; } else { __label__ = 176; break; }
    case 174: // $581
      var $582=$out;
      var $583=$rom;
      var $584=(($583+16)|0);
      var $585=HEAP32[(($584)>>2)];
      var $586=$585 & 16;
      var $587=(($586)|0)!=0;
      var $588=$587 ? (((STRING_TABLE.__str491812)|0)) : (((STRING_TABLE.__str1291892)|0));
      var $589=(function() { try { __THREW__ = false; return _fprintf($582, ((STRING_TABLE.__str1281891)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$588,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 175; break; } else { __label__ = 157; break; };
    case 175: // $590
      __label__ = 176; break;
    case 176: // $591
      var $592=$rom;
      var $593=(($592+16)|0);
      var $594=HEAP32[(($593)>>2)];
      var $595=$594 & 61440;
      var $596=(($595)|0)==4096;
      if ($596) { __label__ = 177; break; } else { __label__ = 179; break; }
    case 177: // $597
      var $598=$out;
      var $599=(function() { try { __THREW__ = false; return _fprintf($598, ((STRING_TABLE.__str1301893)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 178; break; } else { __label__ = 157; break; };
    case 178: // $600
      __label__ = 179; break;
    case 179: // $601
      var $602=$rom;
      var $603=(($602+16)|0);
      var $604=HEAP32[(($603)>>2)];
      var $605=$604 & 61440;
      var $606=(($605)|0)==12288;
      if ($606) { __label__ = 180; break; } else { __label__ = 182; break; }
    case 180: // $607
      var $608=$out;
      var $609=(function() { try { __THREW__ = false; return _fprintf($608, ((STRING_TABLE.__str1311894)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 181; break; } else { __label__ = 157; break; };
    case 181: // $610
      __label__ = 182; break;
    case 182: // $611
      var $612=$rom;
      var $613=(($612+16)|0);
      var $614=HEAP32[(($613)>>2)];
      var $615=$614 & 61440;
      var $616=(($615)|0)==8192;
      if ($616) { __label__ = 183; break; } else { __label__ = 190; break; }
    case 183: // $617
      var $618=$rom;
      var $619=(($618+16)|0);
      var $620=HEAP32[(($619)>>2)];
      var $621=$620 & 3840;
      var $622=(($621)|0)==256;
      if ($622) { __label__ = 184; break; } else { __label__ = 190; break; }
    case 184: // $623
      var $624=$rom;
      var $625=(($624+16)|0);
      var $626=HEAP32[(($625)>>2)];
      var $627=$626 & 64;
      var $628=(($627)|0)!=0;
      if ($628) { __label__ = 187; break; } else { __label__ = 185; break; }
    case 185: // $629
      var $630=$out;
      var $631=(function() { try { __THREW__ = false; return _fprintf($630, ((STRING_TABLE.__str1321895)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 186; break; } else { __label__ = 157; break; };
    case 186: // $632
      __label__ = 189; break;
    case 187: // $633
      var $634=$out;
      var $635=(function() { try { __THREW__ = false; return _fprintf($634, ((STRING_TABLE.__str1331896)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 188; break; } else { __label__ = 157; break; };
    case 188: // $636
      __label__ = 189; break;
    case 189: // $637
      __label__ = 190; break;
    case 190: // $638
      var $639=$rom;
      var $640=(($639+16)|0);
      var $641=HEAP32[(($640)>>2)];
      var $642=$641 & 61440;
      var $643=(($642)|0)==24576;
      if ($643) { __label__ = 191; break; } else { __label__ = 198; break; }
    case 191: // $644
      var $645=$rom;
      var $646=(($645+16)|0);
      var $647=HEAP32[(($646)>>2)];
      var $648=$647 & 3840;
      var $649=(($648)|0)==256;
      if ($649) { __label__ = 192; break; } else { __label__ = 198; break; }
    case 192: // $650
      var $651=$rom;
      var $652=(($651+16)|0);
      var $653=HEAP32[(($652)>>2)];
      var $654=$653 & 64;
      var $655=(($654)|0)!=0;
      if ($655) { __label__ = 195; break; } else { __label__ = 193; break; }
    case 193: // $656
      var $657=$out;
      var $658=(function() { try { __THREW__ = false; return _fprintf($657, ((STRING_TABLE.__str1341897)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 194; break; } else { __label__ = 157; break; };
    case 194: // $659
      __label__ = 197; break;
    case 195: // $660
      var $661=$out;
      var $662=(function() { try { __THREW__ = false; return _fprintf($661, ((STRING_TABLE.__str1351898)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 196; break; } else { __label__ = 157; break; };
    case 196: // $663
      __label__ = 197; break;
    case 197: // $664
      __label__ = 198; break;
    case 198: // $665
      var $666=$rom;
      var $667=(($666+16)|0);
      var $668=HEAP32[(($667)>>2)];
      var $669=$668 & 61440;
      var $670=(($669)|0)==0;
      if ($670) { __label__ = 199; break; } else { __label__ = 206; break; }
    case 199: // $671
      var $672=$rom;
      var $673=(($672+16)|0);
      var $674=HEAP32[(($673)>>2)];
      var $675=$674 & 3840;
      var $676=(($675)|0)==256;
      if ($676) { __label__ = 200; break; } else { __label__ = 206; break; }
    case 200: // $677
      var $678=$rom;
      var $679=(($678+16)|0);
      var $680=HEAP32[(($679)>>2)];
      var $681=$680 & 64;
      var $682=(($681)|0)!=0;
      if ($682) { __label__ = 203; break; } else { __label__ = 201; break; }
    case 201: // $683
      var $684=$out;
      var $685=(function() { try { __THREW__ = false; return _fprintf($684, ((STRING_TABLE.__str1361899)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 202; break; } else { __label__ = 157; break; };
    case 202: // $686
      __label__ = 205; break;
    case 203: // $687
      var $688=$out;
      var $689=(function() { try { __THREW__ = false; return _fprintf($688, ((STRING_TABLE.__str1371900)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 204; break; } else { __label__ = 157; break; };
    case 204: // $690
      __label__ = 205; break;
    case 205: // $691
      __label__ = 206; break;
    case 206: // $692
      var $693=$out;
      var $694=(function() { try { __THREW__ = false; return _fprintf($693, ((STRING_TABLE.__str1381901)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 207; break; } else { __label__ = 157; break; };
    case 207: // $695
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 208; break; } else { __label__ = 4; break; }
    case 208: // $696
      __label__ = 223; break;
    case 209: // $697
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 210; break; } else { __label__ = 262; break; }
    case 210: // $698
      __label__ = 259; break;
    case 211: // $699
      var $700=$rom;
      var $701=(($700+16)|0);
      var $702=HEAP32[(($701)>>2)];
      var $703=$702 & 15;
      var $704=(($703)|0)==3;
      if ($704) { __label__ = 212; break; } else { __label__ = 214; break; }
    case 212: // $705
      var $706=$out;
      var $707=$rom;
      var $708=(($707+12)|0);
      var $709=HEAP32[(($708)>>2)];
      var $710=$rom;
      var $711=(($710+8)|0);
      var $712=HEAP32[(($711)>>2)];
      var $713=(function() { try { __THREW__ = false; return _fprintf($706, ((STRING_TABLE.__str1391902)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$709,HEAP32[((tempInt+4)>>2)]=$712,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 213; break; } else { __label__ = 4; break; };
    case 213: // $714
      __label__ = 222; break;
    case 214: // $715
      var $716=$rom;
      var $717=(($716+16)|0);
      var $718=HEAP32[(($717)>>2)];
      var $719=$718 & 15;
      var $720=(($719)|0)==4;
      if ($720) { __label__ = 215; break; } else { __label__ = 217; break; }
    case 215: // $721
      var $722=$out;
      var $723=$rom;
      var $724=(($723+12)|0);
      var $725=HEAP32[(($724)>>2)];
      var $726=$rom;
      var $727=(($726+8)|0);
      var $728=HEAP32[(($727)>>2)];
      var $729=(function() { try { __THREW__ = false; return _fprintf($722, ((STRING_TABLE.__str1401903)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$725,HEAP32[((tempInt+4)>>2)]=$728,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 216; break; } else { __label__ = 4; break; };
    case 216: // $730
      __label__ = 221; break;
    case 217: // $731
      var $732=$rom;
      var $733=(($732+16)|0);
      var $734=HEAP32[(($733)>>2)];
      var $735=$734 & 15;
      var $736=(($735)|0)==5;
      if ($736) { __label__ = 218; break; } else { __label__ = 220; break; }
    case 218: // $737
      var $738=$out;
      var $739=$rom;
      var $740=(($739+12)|0);
      var $741=HEAP32[(($740)>>2)];
      var $742=$rom;
      var $743=(($742+8)|0);
      var $744=HEAP32[(($743)>>2)];
      var $745=(function() { try { __THREW__ = false; return _fprintf($738, ((STRING_TABLE.__str1411904)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$741,HEAP32[((tempInt+4)>>2)]=$744,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 219; break; } else { __label__ = 4; break; };
    case 219: // $746
      __label__ = 220; break;
    case 220: // $747
      __label__ = 221; break;
    case 221: // $748
      __label__ = 222; break;
    case 222: // $749
      __label__ = 223; break;
    case 223: // $750
      __label__ = 224; break;
    case 224: // $751
      var $752=$rom;
      var $753=(($752+20)|0);
      $rom=$753;
      __label__ = 130; break;
    case 225: // $754
      var $755=$is_disk;
      var $756=(($755)|0)!=0;
      if ($756) { __label__ = 228; break; } else { __label__ = 226; break; }
    case 226: // $757
      var $758=$out;
      var $759=(function() { try { __THREW__ = false; return _fprintf($758, ((STRING_TABLE.__str1421905)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 227; break; } else { __label__ = 4; break; };
    case 227: // $760
      __label__ = 230; break;
    case 228: // $761
      var $762=$out;
      var $763=(function() { try { __THREW__ = false; return _fprintf($762, ((STRING_TABLE.__str1431906)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 229; break; } else { __label__ = 4; break; };
    case 229: // $764
      __label__ = 230; break;
    case 230: // $765
      __label__ = 231; break;
    case 231: // $766
      var $767=$region;
      var $768=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($767) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 232; break; } else { __label__ = 4; break; };
    case 232: // $769
      $region=$768;
      __label__ = 122; break;
    case 233: // $770
      var $771=$out;
      var $772=(function() { try { __THREW__ = false; return _fprintf($771, ((STRING_TABLE.__str1441907)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 234; break; } else { __label__ = 4; break; };
    case 234: // $773
      __label__ = 235; break;
    case 235: // $774
      var $775=$part;
      var $776=(function() { try { __THREW__ = false; return __Z18software_part_nextP13software_part($775) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 236; break; } else { __label__ = 4; break; };
    case 236: // $777
      $part=$776;
      __label__ = 109; break;
    case 237: // $778
      var $779=$out;
      var $780=(function() { try { __THREW__ = false; return _fprintf($779, ((STRING_TABLE.__str1451908)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 238; break; } else { __label__ = 4; break; };
    case 238: // $781
      __label__ = 239; break;
    case 239: // $782
      var $783=$list;
      var $784=$swinfo;
      var $785=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($783, ((STRING_TABLE.__str1081871)|0), $784) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 240; break; } else { __label__ = 4; break; };
    case 240: // $786
      $swinfo=$785;
      __label__ = 89; break;
    case 241: // $787
      var $788=$out;
      var $789=(function() { try { __THREW__ = false; return _fprintf($788, ((STRING_TABLE.__str1461909)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 242; break; } else { __label__ = 4; break; };
    case 242: // $790
      __label__ = 243; break;
    case 243: // $791
      var $792=$list;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($792) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 244; break; } else { __label__ = 4; break; }
    case 244: // $793
      __label__ = 245; break;
    case 245: // $794
      __label__ = 246; break;
    case 246: // $795
      __label__ = 247; break;
    case 247: // $796
      var $797=$listnum3;
      var $798=(($797+1)|0);
      $listnum3=$798;
      __label__ = 66; break;
    case 248: // $799
      __label__ = 249; break;
    case 249: // $800
      var $801=$dev1;
      var $802=(function() { try { __THREW__ = false; return __ZNK8device_t8typenextEv($801) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 250; break; } else { __label__ = 4; break; };
    case 250: // $803
      $dev1=$802;
      __label__ = 62; break;
    case 251: // $804
      __label__ = 56; break;
    case 252: // $805
      var $806=$list_count;
      var $807=(($806)|0) > 0;
      if ($807) { __label__ = 253; break; } else { __label__ = 255; break; }
    case 253: // $808
      var $809=$out;
      var $810=(function() { try { __THREW__ = false; return _fprintf($809, ((STRING_TABLE.__str1471910)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 254; break; } else { __label__ = 4; break; };
    case 254: // $811
      __label__ = 257; break;
    case 255: // $812
      var $813=$out;
      var $814=(function() { try { __THREW__ = false; return _fprintf($813, ((STRING_TABLE.__str1481911)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 256; break; } else { __label__ = 4; break; };
    case 256: // $815
      __label__ = 257; break;
    case 257: // $816
      var $817=$lists;
      var $818=$817;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $818) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 258; break; } else { __label__ = 4; break; }
    case 258: // $819
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      STACKTOP = __stackBase__;
      return;
    case 259: // $820
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 260; break; } else { __label__ = 262; break; }
    case 260: // $821
      __label__ = 261; break;
    case 261: // $822
      var $823=$11;
      var $824=$11;
      var $825=$12;
      var $826=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $824, tempValue);
      var $827=($826.f1 = $825, $826);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 262: // $828
      var $829=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 263: // $830
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend12listsoftwareEPKc["X"]=1;

function __ZNK9hash_base4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK9hash_base4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16media_identifier7matchesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+44)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16media_identifier5totalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+40)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16media_identifier7nonromsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+48)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK7astringeqEPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK7astring3cmpEPKc($3, $4);
  var $6=(($5)|0)==0;
  ;
  return $6;
}


function __ZN7astringaSEPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=__ZN7astring3cpyEPKc($3, $4);
  ;
  return $5;
}


function __ZNK15hash_collection5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  var $4=__ZNK11simple_listI9hash_baseE5firstEv($3);
  ;
  return $4;
}


function __ZN16media_identifierD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16media_identifierD2Ev($2);
  ;
  return;
}


function __ZN12cli_frontend12display_helpEv($this) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1691932)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE._build_version)|0),tempInt));
  __Z16mame_printf_infoPKcz(((STRING_TABLE.__str551818)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str1701933)|0),tempInt));
  __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1711934)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str1721935)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str1531916)|0),tempInt));
  STACKTOP = __stackBase__;
  return;
}


function __ZN16media_identifierC2ER11cli_options($this, $options) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$options;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=$5;
  FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_options]($4, $6);
  var $7=(($3+40)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($3+44)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($3+48)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN7astringC1EPKcS1_S1_($this, $str1, $str2, $str3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$str1;
  $3=$str2;
  $4=$str3;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN7astringC2EPKcS1_S1_($5, $6, $7, $8);
  ;
  return;
}


function __ZN13resource_pool9add_arrayI7astringEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI7astringEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI7astringEEPT_S3_i["X"]=1;

function __ZN12cli_frontend8romidentEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ident=__stackBase__;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$filename;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      FUNCTION_TABLE[__ZN16media_identifierC1ER11cli_options]($ident, $8);
      var $9=$2;
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1491912)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$9,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $10
      var $11=$2;
      (function() { try { __THREW__ = false; return __ZN16media_identifier8identifyEPKc($ident, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK16media_identifier7matchesEv($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $14
      var $15=(function() { try { __THREW__ = false; return __ZNK16media_identifier5totalEv($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $16
      var $17=(($13)|0)==(($15)|0);
      if ($17) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $18
      $5=1;
      __ZN16media_identifierD1Ev($ident);
      STACKTOP = __stackBase__;
      return;
    case 6: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $3=$21;
      var $22=$20.f1;
      $4=$22;
      __label__ = 22; break;
    case 7: // $23
      var $24=(function() { try { __THREW__ = false; return __ZNK16media_identifier7matchesEv($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 6; break; };
    case 8: // $25
      var $26=(function() { try { __THREW__ = false; return __ZNK16media_identifier5totalEv($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; };
    case 9: // $27
      var $28=(function() { try { __THREW__ = false; return __ZNK16media_identifier7nonromsEv($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; };
    case 10: // $29
      var $30=(($26-$28)|0);
      var $31=(($24)|0)==(($30)|0);
      if ($31) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $32
      var $33=___cxa_allocate_exception(1032);
      var $34=$33;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($34, 7, ((__str511814)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $35
      (function() { try { __THREW__ = false; return ___cxa_throw($33, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 6; break; }
    case 13: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $3=$38;
      var $39=$37.f1;
      $4=$39;
      ___cxa_free_exception($33);
      __label__ = 22; break;
    case 14: // $40
      var $41=(function() { try { __THREW__ = false; return __ZNK16media_identifier7matchesEv($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 6; break; };
    case 15: // $42
      var $43=(($41)|0) > 0;
      if ($43) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $44
      var $45=___cxa_allocate_exception(1032);
      var $46=$45;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($46, 8, ((__str511814)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $47
      (function() { try { __THREW__ = false; return ___cxa_throw($45, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 6; break; }
    case 18: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      $3=$50;
      var $51=$49.f1;
      $4=$51;
      ___cxa_free_exception($45);
      __label__ = 22; break;
    case 19: // $52
      var $53=___cxa_allocate_exception(1032);
      var $54=$53;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($54, 9, ((__str511814)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $55
      (function() { try { __THREW__ = false; return ___cxa_throw($53, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 6; break; }
    case 21: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      $3=$58;
      var $59=$57.f1;
      $4=$59;
      ___cxa_free_exception($53);
      __label__ = 22; break;
    case 22: // $60
      (function() { try { __THREW__ = false; return __ZN16media_identifierD1Ev($ident) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $61
      __label__ = 24; break;
    case 24: // $62
      var $63=$3;
      var $64=$3;
      var $65=$4;
      var $66=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $64, tempValue);
      var $67=($66.f1 = $65, $66);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 26: // $70
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cli_frontend8romidentEPKc["X"]=1;

function __ZN16media_identifier8identifyEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $directory;
      var $entry;
      var $curfile=__stackBase__+24;
      var $8;
      var $9;
      var $zip=__stackBase__+88;
      var $ziperr;
      var $entry1;
      var $data;
      $6=$this;
      $7=$filename;
      var $10=$6;
      var $11=$7;
      var $12=_osd_opendir($11);
      $directory=$12;
      var $13=$directory;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $15
      var $16=$directory;
      var $17=_osd_readdir($16);
      $entry=$17;
      __label__ = 2; break;
    case 2: // $18
      var $19=$entry;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $21
      var $22=$entry;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)==1;
      if ($25) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $26
      var $27=$7;
      var $28=$entry;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      __ZN7astringC1EPKcS1_S1_($curfile, $27, ((STRING_TABLE.__str1731936)|0), $30);
      var $31=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($curfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $32
      (function() { try { __THREW__ = false; return __ZN16media_identifier13identify_fileEPKc($10, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      FUNCTION_TABLE[__ZN7astringD1Ev]($curfile);
      __label__ = 9; break;
    case 7: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $8=$36;
      var $37=$35.f1;
      $9=$37;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 38; break; }
    case 8: // $38
      __label__ = 37; break;
    case 9: // $39
      __label__ = 10; break;
    case 10: // $40
      var $41=$directory;
      var $42=_osd_readdir($41);
      $entry=$42;
      __label__ = 2; break;
    case 11: // $43
      var $44=$directory;
      _osd_closedir($44);
      __label__ = 36; break;
    case 12: // $45
      var $46=$7;
      var $47=__Z23core_filename_ends_withPKcS0_($46, ((STRING_TABLE.__str1741937)|0));
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 13; break; } else { __label__ = 34; break; }
    case 13: // $49
      HEAP32[(($zip)>>2)]=0;
      var $50=$7;
      var $51=__Z13zip_file_openPKcPP9_zip_file($50, $zip);
      $ziperr=$51;
      var $52=$ziperr;
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 14; break; } else { __label__ = 33; break; }
    case 14: // $54
      var $55=HEAP32[(($zip)>>2)];
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 15; break; } else { __label__ = 33; break; }
    case 15: // $57
      var $58=HEAP32[(($zip)>>2)];
      var $59=__Z19zip_file_first_fileP9_zip_file($58);
      $entry1=$59;
      __label__ = 16; break;
    case 16: // $60
      var $61=$entry1;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 17; break; } else { __label__ = 32; break; }
    case 17: // $63
      var $64=$entry1;
      var $65=(($64+24)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 18; break; } else { __label__ = 30; break; }
    case 18: // $68
      var $69=$entry1;
      var $70=(($69+24)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$1;
      var $73=$2;
      var $74=$3;
      var $75=$result_i;
      var $76=$4;
      var $77=$5;
      HEAP32[(($1)>>2)]=$71;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1051868)|0);
      HEAP32[(($3)>>2)]=1392;
      var $78=HEAP32[(($1)>>2)];
      var $79=HEAP32[(($2)>>2)];
      var $80=HEAP32[(($3)>>2)];
      var $81=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($78, $79, $80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; };
    case 19: // $82
      HEAP32[(($result_i)>>2)]=$81;
      var $83=HEAP32[(($result_i)>>2)];
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 20: // $85
      var $86=___cxa_allocate_exception(4);
      var $87=$86;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($87);
      (function() { try { __THREW__ = false; return ___cxa_throw($86, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 21; break; }
    case 21: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $90=$89.f0;
      HEAP32[(($4)>>2)]=$90;
      var $91=$89.f1;
      HEAP32[(($5)>>2)]=$91;
      var $92=HEAP32[(($5)>>2)];
      var $93=(($92)|0) < 0;
      if ($93) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $94
      var $95=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($95);
      throw "Reached an unreachable!"
    case 23: // $96
      var $97=HEAP32[(($4)>>2)];
      var $98=HEAP32[(($4)>>2)];
      var $99=HEAP32[(($5)>>2)];
      var $100=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $98, tempValue);
      var $101=($100.f1 = $99, $100);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $102
      throw "Reached an unreachable!"
    case 25: // $_ZnajPKci_exit
      var $103=HEAP32[(($result_i)>>2)];
      var $104=$1;
      var $105=$2;
      var $106=$3;
      var $107=$result_i;
      var $108=$4;
      var $109=$5;
      var $110=$entry1;
      var $111=(($110+24)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $103, $112);
      $data=$113;
      var $114=$data;
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $116
      var $117=HEAP32[(($zip)>>2)];
      var $118=$data;
      var $119=$entry1;
      var $120=(($119+24)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=__Z19zip_file_decompressP9_zip_filePvj($117, $118, $121);
      $ziperr=$122;
      var $123=$ziperr;
      var $124=(($123)|0)==0;
      if ($124) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $125
      var $126=$entry1;
      var $127=(($126+48)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$data;
      var $130=$entry1;
      var $131=(($130+24)|0);
      var $132=HEAP32[(($131)>>2)];
      __ZN16media_identifier13identify_dataEPKcPKhi($10, $128, $129, $132);
      __label__ = 28; break;
    case 28: // $133
      var $134=$data;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $134);
      __label__ = 29; break;
    case 29: // $135
      __label__ = 30; break;
    case 30: // $136
      __label__ = 31; break;
    case 31: // $137
      var $138=HEAP32[(($zip)>>2)];
      var $139=__Z18zip_file_next_fileP9_zip_file($138);
      $entry1=$139;
      __label__ = 16; break;
    case 32: // $140
      var $141=HEAP32[(($zip)>>2)];
      __Z14zip_file_closeP9_zip_file($141);
      __label__ = 33; break;
    case 33: // $142
      __Z20zip_file_cache_clearv();
      __label__ = 35; break;
    case 34: // $143
      var $144=$7;
      __ZN16media_identifier13identify_fileEPKc($10, $144);
      __label__ = 35; break;
    case 35: // $145
      __label__ = 36; break;
    case 36: // $146
      STACKTOP = __stackBase__;
      return;
    case 37: // $147
      var $148=$8;
      var $149=$8;
      var $150=$9;
      var $151=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $149, tempValue);
      var $152=($151.f1 = $150, $151);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $153
      var $154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16media_identifier8identifyEPKc["X"]=1;

function __ZN16media_identifier13identify_fileEPKc($this, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 308; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $basename=__stackBase__;
      var $3;
      var $4;
      var $chd=__stackBase__+64;
      var $err;
      var $5;
      var $header=__stackBase__+68;
      var $hashes=__stackBase__+216;
      var $found;
      var $length=__stackBase__+300;
      var $data=__stackBase__+304;
      var $filerr;
      $1=$this;
      $2=$name;
      var $6=$1;
      var $7=$2;
      var $8=__Z23core_filename_ends_withPKcS0_($7, ((STRING_TABLE.__str1751938)|0));
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 36; break; }
    case 1: // $10
      __ZN7astringC1Ev($basename);
      var $11=$2;
      var $12=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($basename, $11, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $13
      var $14=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $15
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1761939)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $16
      var $17=(($6+40)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+1)|0);
      HEAP32[(($17)>>2)]=$19;
      var $20=$2;
      var $21=(function() { try { __THREW__ = false; return __Z8chd_openPKciP9_chd_filePS2_($20, 1, 0, $chd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $22
      $err=$21;
      var $23=$err;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $25
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1771940)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $26
      var $27=(($6+48)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+1)|0);
      HEAP32[(($27)>>2)]=$29;
      $5=1;
      __label__ = 31; break;
    case 8: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $3=$32;
      var $33=$31.f1;
      $4=$33;
      __label__ = 34; break;
    case 9: // $34
      var $35=HEAP32[(($chd)>>2)];
      var $36=(function() { try { __THREW__ = false; return __Z14chd_get_headerP9_chd_file($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $37
      var $38=$header;
      var $39=$36;
      assert(148 % 1 === 0, 'memcpy given ' + 148 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $39>>2, $$dest = $38>>2, $$stop = $$src + 37; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $40=HEAP32[(($chd)>>2)];
      (function() { try { __THREW__ = false; return __Z9chd_closeP9_chd_file($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 11: // $41
      var $42=(($header+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$43 & 2;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $46
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1781941)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; }
    case 13: // $47
      $5=1;
      __label__ = 31; break;
    case 14: // $48
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 8; break; }
    case 15: // $49
      var $50=(($header+40)|0);
      var $51=(($50)|0);
      var $52=(function() { try { __THREW__ = false; return _memcmp(((__ZZN16media_identifier13identify_fileEPKcE8nullhash)|0), $51, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; };
    case 16: // $53
      var $54=(($52)|0)!=0;
      if ($54) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $55
      var $56=(($header+40)|0);
      var $57=(($56)|0);
      var $58=(function() { try { __THREW__ = false; return __ZN15hash_collection15add_from_bufferEcPKhi($hashes, 77, $57, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; };
    case 18: // $59
      __label__ = 20; break;
    case 19: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $3=$62;
      var $63=$61.f1;
      $4=$63;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 42; break; }
    case 20: // $64
      var $65=(($header+72)|0);
      var $66=(($65)|0);
      var $67=(function() { try { __THREW__ = false; return _memcmp(((__ZZN16media_identifier13identify_fileEPKcE8nullhash)|0), $66, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 19; break; };
    case 21: // $68
      var $69=(($67)|0)!=0;
      if ($69) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $70
      var $71=(($header+72)|0);
      var $72=(($71)|0);
      var $73=(function() { try { __THREW__ = false; return __ZN15hash_collection15add_from_bufferEcPKhi($hashes, 83, $72, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 19; break; };
    case 23: // $74
      __label__ = 24; break;
    case 24: // $75
      var $76=(($header+24)|0);
      var $st$1$0=(($76)|0);
      var $77$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($76+4)|0);
      var $77$1=HEAP32[(($st$1$1)>>2)];
      var $78$0=$77$0;
      var $78=$78$0;
      var $79=(function() { try { __THREW__ = false; return __ZN16media_identifier12find_by_hashERK15hash_collectioni($6, $hashes, $78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 19; break; };
    case 25: // $80
      $found=$79;
      var $81=$found;
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $83
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1791942)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 19; break; }
    case 27: // $84
      __label__ = 29; break;
    case 28: // $85
      var $86=(($6+44)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87+1)|0);
      HEAP32[(($86)>>2)]=$88;
      __label__ = 29; break;
    case 29: // $89
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; }
    case 30: // $90
      $5=0;
      __label__ = 31; break;
    case 31: // $91
      FUNCTION_TABLE[__ZN7astringD1Ev]($basename);
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0) {
        __label__ = 32; break;
      }
      else if ($cleanup_dest == 1) {
        __label__ = 40; break;
      }
      else {
      __label__ = 43; break;
      }
      
    case 32: // $92
      __label__ = 40; break;
    case 33: // $93
      __label__ = 34; break;
    case 34: // $94
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($basename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 42; break; }
    case 35: // $95
      __label__ = 41; break;
    case 36: // $96
      var $97=$2;
      var $98=__Z10core_floadPKcPPvPj($97, $data, $length);
      $filerr=$98;
      var $99=$filerr;
      var $100=(($99)|0)==0;
      if ($100) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $101
      var $102=HEAPU32[(($length)>>2)];
      var $103=(($102)>>>0) > 0;
      if ($103) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $104
      var $105=$2;
      var $106=HEAP32[(($data)>>2)];
      var $107=HEAP32[(($length)>>2)];
      __ZN16media_identifier13identify_dataEPKcPKhi($6, $105, $106, $107);
      __label__ = 39; break;
    case 39: // $108
      __label__ = 40; break;
    case 40: // $109
      STACKTOP = __stackBase__;
      return;
    case 41: // $110
      var $111=$3;
      var $112=$3;
      var $113=$4;
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 43: // $118
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16media_identifier13identify_fileEPKc["X"]=1;

function __ZNK17driver_enumerator7optionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN15hash_collection7computeEPKhjPKc($this, $data, $length, $types) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$data;
  $3=$length;
  $4=$types;
  var $5=$1;
  var $6=$4;
  __ZN15hash_collection5beginEPKc($5, $6);
  var $7=$2;
  var $8=$3;
  __ZN15hash_collection6bufferEPKhj($5, $7, $8);
  __ZN15hash_collection3endEv($5);
  ;
  return;
}


function __ZN19resource_pool_arrayI7astringEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI7astringEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI7astringEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<6))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI7astringE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI7astringED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI7astringED2Ev($2);
  ;
  return;
}


function __ZN16media_identifier13identify_dataEPKcPKhi($this, $name, $data, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8368; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $9;
      var $tempjed;
      var $jed=__stackBase__+24;
      var $hashes=__stackBase__+8220;
      var $10;
      var $11;
      var $basename=__stackBase__+8304;
      var $found;
      $6=$this;
      $7=$name;
      $8=$data;
      $9=$length;
      var $12=$6;
      $tempjed=0;
      var $13=$7;
      var $14=__Z23core_filename_ends_withPKcS0_($13, ((STRING_TABLE.__str1801943)|0));
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $16
      var $17=$8;
      var $18=$9;
      var $19=__Z9jed_parsePKvjP9_jed_data($17, $18, $jed);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $21
      var $22=__Z13jedbin_outputPK9_jed_dataPvj($jed, 0, 0);
      $9=$22;
      var $23=$9;
      var $24=(($23)|0) < 0;
      var $25=$24 ? -1 : $23;
      var $26=$1;
      var $27=$2;
      var $28=$3;
      var $29=$result_i;
      var $30=$4;
      var $31=$5;
      HEAP32[(($1)>>2)]=$25;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1051868)|0);
      HEAP32[(($3)>>2)]=1497;
      var $32=HEAP32[(($1)>>2)];
      var $33=HEAP32[(($2)>>2)];
      var $34=HEAP32[(($3)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($4)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($5)>>2)]=$45;
      var $46=HEAP32[(($5)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $48
      var $49=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($49);
      throw "Reached an unreachable!"
    case 7: // $50
      var $51=HEAP32[(($4)>>2)];
      var $52=HEAP32[(($4)>>2)];
      var $53=HEAP32[(($5)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $56
      throw "Reached an unreachable!"
    case 9: // $_ZnajPKci_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$1;
      var $59=$2;
      var $60=$3;
      var $61=$result_i;
      var $62=$4;
      var $63=$5;
      var $64=$9;
      var $65=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $57, $64);
      $tempjed=$65;
      var $66=$tempjed;
      var $67=$9;
      var $68=__Z13jedbin_outputPK9_jed_dataPvj($jed, $66, $67);
      var $69=$tempjed;
      $8=$69;
      __label__ = 10; break;
    case 10: // $70
      FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($hashes);
      var $71=$8;
      var $72=$9;
      var $73=HEAP32[((__ZN15hash_collection19HASH_TYPES_CRC_SHA1E)>>2)];
      (function() { try { __THREW__ = false; return __ZN15hash_collection7computeEPKhjPKc($hashes, $71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $74
      var $75=(($12+40)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76+1)|0);
      HEAP32[(($75)>>2)]=$77;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($basename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $78
      var $79=$7;
      var $80=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($basename, $79, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 21; break; };
    case 13: // $81
      var $82=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 21; break; };
    case 14: // $83
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1761939)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $84
      var $85=$9;
      var $86=(function() { try { __THREW__ = false; return __ZN16media_identifier12find_by_hashERK15hash_collectioni($12, $hashes, $85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 21; break; };
    case 16: // $87
      $found=$86;
      var $88=$found;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 17; break; } else { __label__ = 25; break; }
    case 17: // $90
      var $91=$9;
      var $92=$9;
      var $93=(($92-1)|0);
      var $94=$91 & $93;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $96
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1811944)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $97
      var $98=(($12+48)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99+1)|0);
      HEAP32[(($98)>>2)]=$100;
      __label__ = 24; break;
    case 20: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $103=$102.f0;
      $10=$103;
      var $104=$102.f1;
      $11=$104;
      __label__ = 30; break;
    case 21: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $107=$106.f0;
      $10=$107;
      var $108=$106.f1;
      $11=$108;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($basename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 22: // $109
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1791942)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 21; break; }
    case 23: // $110
      __label__ = 24; break;
    case 24: // $111
      __label__ = 26; break;
    case 25: // $112
      var $113=(($12+44)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114+1)|0);
      HEAP32[(($113)>>2)]=$115;
      __label__ = 26; break;
    case 26: // $116
      var $117=$tempjed;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 21; break; }
    case 27: // $118
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($basename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 20; break; }
    case 28: // $119
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes);
      STACKTOP = __stackBase__;
      return;
    case 29: // $120
      __label__ = 30; break;
    case 30: // $121
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $122
      __label__ = 32; break;
    case 32: // $123
      var $124=$10;
      var $125=$10;
      var $126=$11;
      var $127=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $125, tempValue);
      var $128=($127.f1 = $126, $127);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16media_identifier13identify_dataEPKcPKhi["X"]=1;

function __ZN16media_identifier12find_by_hashERK15hash_collectioni($this, $hashes, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 168; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $found;
      var $source;
      var $region;
      var $rom;
      var $romhashes=__stackBase__;
      var $4;
      var $5;
      var $baddump;
      var $dev;
      var $swlist;
      var $listnum;
      var $list;
      var $swinfo;
      var $part;
      var $region1;
      var $rom2;
      var $romhashes3=__stackBase__+84;
      var $baddump4;
      $1=$this;
      $2=$hashes;
      $3=$length;
      var $6=$1;
      $found=0;
      var $7=(($6)|0);
      __ZN17driver_enumerator5resetEv($7);
      __label__ = 1; break;
    case 1: // $8
      var $9=(($6)|0);
      var $10=__ZN17driver_enumerator4nextEv($9);
      if ($10) { __label__ = 2; break; } else { __label__ = 65; break; }
    case 2: // $11
      var $12=(($6)|0);
      var $13=__ZNK17driver_enumerator6configEv($12);
      var $14=__Z16rom_first_sourceRK14machine_config($13);
      $source=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$source;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 28; break; }
    case 4: // $18
      var $19=$source;
      var $20=__Z16rom_first_regionRK8device_t($19);
      $region=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$region;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 26; break; }
    case 6: // $24
      var $25=$region;
      var $26=__Z14rom_first_filePK9rom_entry($25);
      $rom=$26;
      __label__ = 7; break;
    case 7: // $27
      var $28=$rom;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 8; break; } else { __label__ = 24; break; }
    case 8: // $30
      var $31=$rom;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($romhashes, $33);
      var $34=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($romhashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 16; break; };
    case 9: // $35
      if ($34) { __label__ = 21; break; } else { __label__ = 10; break; }
    case 10: // $36
      var $37=$2;
      var $38=(function() { try { __THREW__ = false; return __ZNK15hash_collectioneqERKS_($37, $romhashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $39
      if ($38) { __label__ = 12; break; } else { __label__ = 21; break; }
    case 12: // $40
      var $41=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($romhashes, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; };
    case 13: // $42
      var $43=(($41)&1);
      $baddump=$43;
      var $44=$found;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $46
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1821945)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $47
      __label__ = 17; break;
    case 16: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      $4=$50;
      var $51=$49.f1;
      $5=$51;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($romhashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 67; break; }
    case 17: // $52
      var $53=$baddump;
      var $54=(($53) & 1);
      var $55=$54 ? (((STRING_TABLE.__str1841947)|0)) : (((__str511814)|0));
      var $56=$rom;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($6)|0);
      var $60=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 16; break; };
    case 18: // $61
      var $62=(($60+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($6)|0);
      var $65=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; };
    case 19: // $66
      var $67=(($65+12)|0);
      var $68=HEAP32[(($67)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1831946)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,HEAP32[((tempInt+4)>>2)]=$58,HEAP32[((tempInt+8)>>2)]=$63,HEAP32[((tempInt+12)>>2)]=$68,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 16; break; }
    case 20: // $69
      var $70=$found;
      var $71=(($70+1)|0);
      $found=$71;
      __label__ = 21; break;
    case 21: // $72
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($romhashes);
      __label__ = 22; break;
    case 22: // $73
      var $74=$rom;
      var $75=__Z13rom_next_filePK9rom_entry($74);
      $rom=$75;
      __label__ = 7; break;
    case 23: // $76
      __label__ = 66; break;
    case 24: // $77
      __label__ = 25; break;
    case 25: // $78
      var $79=$region;
      var $80=__Z15rom_next_regionPK9rom_entry($79);
      $region=$80;
      __label__ = 5; break;
    case 26: // $81
      __label__ = 27; break;
    case 27: // $82
      var $83=$source;
      var $84=__Z15rom_next_sourceRK8device_t($83);
      $source=$84;
      __label__ = 3; break;
    case 28: // $85
      var $86=(($6)|0);
      var $87=__ZNK17driver_enumerator6configEv($86);
      var $88=__ZNK14machine_config10devicelistEv($87);
      var $89=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $90=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($88, $89);
      $dev=$90;
      __label__ = 29; break;
    case 29: // $91
      var $92=$dev;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 30; break; } else { __label__ = 64; break; }
    case 30: // $94
      var $95=$dev;
      var $96=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($95);
      var $97=__ZNK18legacy_device_base13inline_configEv($96);
      var $98=$97;
      $swlist=$98;
      $listnum=0;
      __label__ = 31; break;
    case 31: // $99
      var $100=$listnum;
      var $101=(($100)|0) < 9;
      if ($101) { __label__ = 32; break; } else { __label__ = 62; break; }
    case 32: // $102
      var $103=$listnum;
      var $104=$swlist;
      var $105=(($104)|0);
      var $106=(($105+($103<<2))|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 33; break; } else { __label__ = 60; break; }
    case 33: // $109
      var $110=(($6)|0);
      var $111=__ZNK17driver_enumerator7optionsEv($110);
      var $112=$listnum;
      var $113=$swlist;
      var $114=(($113)|0);
      var $115=(($114+($112<<2))|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=__Z18software_list_openR11emu_optionsPKciPFvS2_E($111, $116, 0, 0);
      $list=$117;
      var $118=$list;
      var $119=__Z18software_list_findP14_software_listPKcP13software_info($118, ((STRING_TABLE.__str1081871)|0), 0);
      $swinfo=$119;
      __label__ = 34; break;
    case 34: // $120
      var $121=$swinfo;
      var $122=(($121)|0)!=0;
      if ($122) { __label__ = 35; break; } else { __label__ = 59; break; }
    case 35: // $123
      var $124=$swinfo;
      var $125=__Z18software_find_partP13software_infoPKcS2_($124, 0, 0);
      $part=$125;
      __label__ = 36; break;
    case 36: // $126
      var $127=$part;
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 37; break; } else { __label__ = 57; break; }
    case 37: // $129
      var $130=$part;
      var $131=(($130+12)|0);
      var $132=HEAP32[(($131)>>2)];
      $region1=$132;
      __label__ = 38; break;
    case 38: // $133
      var $134=$region1;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 39; break; } else { __label__ = 55; break; }
    case 39: // $136
      var $137=$region1;
      var $138=__Z14rom_first_filePK9rom_entry($137);
      $rom2=$138;
      __label__ = 40; break;
    case 40: // $139
      var $140=$rom2;
      var $141=(($140)|0)!=0;
      if ($141) { __label__ = 41; break; } else { __label__ = 53; break; }
    case 41: // $142
      var $143=$rom2;
      var $144=(($143+4)|0);
      var $145=HEAP32[(($144)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($romhashes3, $145);
      var $146=$2;
      var $147=(function() { try { __THREW__ = false; return __ZNK15hash_collectioneqERKS_($146, $romhashes3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 47; break; };
    case 42: // $148
      if ($147) { __label__ = 43; break; } else { __label__ = 50; break; }
    case 43: // $149
      var $150=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($romhashes3, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 47; break; };
    case 44: // $151
      var $152=(($150)&1);
      $baddump4=$152;
      var $153=$found;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 48; break; } else { __label__ = 45; break; }
    case 45: // $155
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1821945)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $156
      __label__ = 48; break;
    case 47: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $159=$158.f0;
      $4=$159;
      var $160=$158.f1;
      $5=$160;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($romhashes3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 67; break; }
    case 48: // $161
      var $162=$baddump4;
      var $163=(($162) & 1);
      var $164=$163 ? (((STRING_TABLE.__str1841947)|0)) : (((__str511814)|0));
      var $165=$rom2;
      var $166=(($165)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$listnum;
      var $169=$swlist;
      var $170=(($169)|0);
      var $171=(($170+($168<<2))|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=$swinfo;
      var $174=(($173)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=$swinfo;
      var $177=(($176+4)|0);
      var $178=HEAP32[(($177)>>2)];
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str1851948)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$164,HEAP32[((tempInt+4)>>2)]=$167,HEAP32[((tempInt+8)>>2)]=$172,HEAP32[((tempInt+12)>>2)]=$175,HEAP32[((tempInt+16)>>2)]=$178,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 47; break; }
    case 49: // $179
      var $180=$found;
      var $181=(($180+1)|0);
      $found=$181;
      __label__ = 50; break;
    case 50: // $182
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($romhashes3);
      __label__ = 51; break;
    case 51: // $183
      var $184=$rom2;
      var $185=__Z13rom_next_filePK9rom_entry($184);
      $rom2=$185;
      __label__ = 40; break;
    case 52: // $186
      __label__ = 66; break;
    case 53: // $187
      __label__ = 54; break;
    case 54: // $188
      var $189=$region1;
      var $190=__Z15rom_next_regionPK9rom_entry($189);
      $region1=$190;
      __label__ = 38; break;
    case 55: // $191
      __label__ = 56; break;
    case 56: // $192
      var $193=$part;
      var $194=__Z18software_part_nextP13software_part($193);
      $part=$194;
      __label__ = 36; break;
    case 57: // $195
      __label__ = 58; break;
    case 58: // $196
      var $197=$list;
      var $198=$swinfo;
      var $199=__Z18software_list_findP14_software_listPKcP13software_info($197, ((STRING_TABLE.__str1081871)|0), $198);
      $swinfo=$199;
      __label__ = 34; break;
    case 59: // $200
      var $201=$list;
      __Z19software_list_closeP14_software_list($201);
      __label__ = 60; break;
    case 60: // $202
      __label__ = 61; break;
    case 61: // $203
      var $204=$listnum;
      var $205=(($204+1)|0);
      $listnum=$205;
      __label__ = 31; break;
    case 62: // $206
      __label__ = 63; break;
    case 63: // $207
      var $208=$dev;
      var $209=__ZNK8device_t8typenextEv($208);
      $dev=$209;
      __label__ = 29; break;
    case 64: // $210
      __label__ = 1; break;
    case 65: // $211
      var $212=$found;
      STACKTOP = __stackBase__;
      return $212;
    case 66: // $213
      var $214=$4;
      var $215=$4;
      var $216=$5;
      var $217=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $215, tempValue);
      var $218=($217.f1 = $216, $217);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 67: // $219
      var $220=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16media_identifier12find_by_hashERK15hash_collectioni["X"]=1;

function __ZN11cli_optionsD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11cli_optionsD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11cli_optionsD0Ev["X"]=1;

function __ZN19resource_pool_arrayI7astringED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI7astringED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI7astringED0Ev["X"]=1;

function __ZNK11simple_listI9hash_baseE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI12audit_recordE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12audit_recordE6detachERS0_["X"]=1;

function __ZN17driver_enumerator7includeEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$6)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      if ($11) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $12
      var $13=$2;
      var $14=(($3+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+$13)|0);
      HEAP8[($16)]=1;
      var $17=(($3+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+1)|0);
      HEAP32[(($17)>>2)]=$19;
      __label__ = 4; break;
    case 4: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options9unadornedEi($x) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$x;
      var $2=$1;
      var $3=(($2)|0) < 16;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=$1;
      var $8 = $5;__label__ = 3; break;
    case 2: // $6
      var $8 = 16;__label__ = 3; break;
    case 3: // $7
      var $8;
      var $9=((__ZN12core_options18s_option_unadornedE+($8<<2))|0);
      var $10=((((HEAPU8[($9)])|(HEAPU8[($9+1)]<<8)|(HEAPU8[($9+2)]<<16)|(HEAPU8[($9+3)]<<24))|0));
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t4nextIK21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceIK21device_slot_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceIK21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI21device_slot_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t4nextIK22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceIK22device_image_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceIK22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_image_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astringC2EPKcS1_S1_($this, $str1, $str2, $str3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$str1;
  $3=$str2;
  $4=$str3;
  var $5=$1;
  var $6=$5;
  var $7=__ZN7astring4initEv($5);
  var $8=$2;
  var $9=__ZN7astring3cpyEPKc($7, $8);
  var $10=$3;
  var $11=__ZN7astring3catEPKc($9, $10);
  var $12=$4;
  var $13=__ZN7astring3catEPKc($11, $12);
  ;
  return;
}


function __ZN16media_identifierD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($3);
  ;
  return;
}


function __ZNK7astring3cmpEPKc($this, $str2) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$str2;
  var $3=$1;
  var $4=$2;
  var $5=__Z12astring_cmpcPK7astringPKc($3, $4);
  ;
  return $5;
}


function __ZN13media_auditorD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listI12audit_recordED1Ev($3);
  ;
  return;
}


function __ZN11simple_listI12audit_recordED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI12audit_recordED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI12audit_recordED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI12audit_recordE+8)|0);
  __ZN11simple_listI12audit_recordE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI12audit_recordE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI12audit_recordE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12audit_recordE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI12audit_recordE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN7astringC2ERKS_ii($this, $string, $start, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$string;
  $3=$start;
  $4=$count;
  var $5=$1;
  var $6=$5;
  var $7=__ZN7astring4initEv($5);
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=__ZN7astring9cpysubstrERKS_ii($7, $8, $9, $10);
  ;
  return;
}


function __ZN7astring9cpysubstrERKS_ii($this, $src, $start, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$src;
  $3=$start;
  $4=$count;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__Z17astring_cpysubstrP7astringPKS_ii($5, $6, $7, $8);
  ;
  return $9;
}


function __ZN11driver_list5cloneEi($index) {
  ;
  var __label__;

  var $1;
  $1=$index;
  var $2=$1;
  var $3=__ZN11driver_list6driverEi($2);
  var $4=(($3+4)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=__ZN11driver_list4findEPKc($5);
  ;
  return $6;
}


function __ZN19resource_pool_arrayI7astringED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV19resource_pool_arrayI7astringE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 9; break; } else { __label__ = 1; break; }
    case 1: // $15
      var $16=$13;
      var $17=(($16-4)|0);
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($13+($19<<6))|0);
      var $21=(($13)|0)==(($20)|0);
      if ($21) { __label__ = 4; break; } else { var $23 = $20;__label__ = 2; break; }
    case 2: // $22
      var $23;
      var $24=(($23-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $25
      var $26=(($24)|0)==(($13)|0);
      if ($26) { __label__ = 4; break; } else { var $23 = $24;__label__ = 2; break; }
    case 4: // $27
      var $28=$4;
      var $29=$5;
      var $30=$6;
      HEAP32[(($4)>>2)]=$17;
      var $31=HEAP32[(($4)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $33
      var $34=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($34, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      __label__ = 8; break;
    case 7: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($5)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($6)>>2)]=$39;
      var $40=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($40);
      throw "Reached an unreachable!"
    case 8: // $_ZdaPv_exit
      var $41=$4;
      var $42=$5;
      var $43=$6;
      __label__ = 9; break;
    case 9: // $44
      var $45=$10;
      __ZN18resource_pool_itemD2Ev($45);
      STACKTOP = __stackBase__;
      return;
    case 10: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $8=$48;
      var $49=$47.f1;
      $9=$49;
      var $50=(($13)|0)==(($24)|0);
      if ($50) { __label__ = 13; break; } else { var $52 = $24;__label__ = 11; break; }
    case 11: // $51
      var $52;
      var $53=(($52-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $54
      var $55=(($53)|0)==(($13)|0);
      if ($55) { __label__ = 13; break; } else { var $52 = $53;__label__ = 11; break; }
    case 13: // $56
      var $57=$1;
      var $58=$2;
      var $59=$3;
      HEAP32[(($1)>>2)]=$17;
      var $60=HEAP32[(($1)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $62
      var $63=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($63, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $64
      __label__ = 17; break;
    case 16: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      HEAP32[(($2)>>2)]=$67;
      var $68=$66.f1;
      HEAP32[(($3)>>2)]=$68;
      var $69=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($69);
      throw "Reached an unreachable!"
    case 17: // $_ZdaPv_exit1
      var $70=$1;
      var $71=$2;
      var $72=$3;
      var $73=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $74
      __label__ = 19; break;
    case 19: // $75
      var $76=$8;
      var $77=$8;
      var $78=$9;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI7astringED2Ev["X"]=1;

function __ZN11simple_listI12audit_recordED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI12audit_recordED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12audit_recordED0Ev["X"]=1;

function __ZNK21device_slot_interface16get_default_cardEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK8device_t10configuredEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+352)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN11simple_listI8device_tE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+20)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+20)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI8device_tE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+20)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+20)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+20)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+20)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI8device_tE6detachERS0_["X"]=1;

function __ZNK11device_list5firstI21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI21device_slot_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_interface4nextI21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI21device_slot_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZN11device_listD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11device_listD2Ev($2);
  ;
  return;
}


function __ZN14machine_configD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  __ZN11device_listD1Ev($3);
  ;
  return;
}


function __ZNK14machine_config12first_screenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  var $4=HEAP32[((_SCREEN)>>2)];
  var $5=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($3, $4);
  var $6=__Z8downcastIP13screen_device8device_tET_PT0_($5);
  ;
  return $6;
}


function __ZN14machine_config21device_add_subdevicesEP8device_t($this, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $additions;
      $1=$this;
      $2=$device;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK8device_t24machine_config_additionsEv($4);
      $additions=$5;
      var $6=$additions;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$additions;
      var $10=$2;
      var $11=FUNCTION_TABLE[$9]($3, $10);
      __label__ = 2; break;
    case 2: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t24machine_config_additionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+12)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZN8tagmap_tIP8device_tE6removeES1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __Z20tagmap_remove_objectP7_tagmapPv($4, $6);
  ;
  return;
}


function __ZN8tagmap_tIP8device_tE15add_unique_hashEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z22tagmap_add_unique_hashP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN11simple_listI8device_tE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI8device_tE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZNK8device_t4nextI21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI21device_slot_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceI21device_slot_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI21device_slot_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11device_listD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN11tagged_listI8device_tED2Ev($3);
  ;
  return;
}


function __ZN14machine_configC2ERK11game_driverR11emu_options($this, $gamedrv, $options) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $slot=__stackBase__;
      var $gotone;
      var $intf;
      var $owner;
      var $selval;
      var $i;
      var $root;
      var $device;
      $1=$this;
      $2=$gamedrv;
      $3=$options;
      var $6=$1;
      var $7=(($6)|0);
      var $8=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $9=(($6+12)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($6+16)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($6+20)|0);
      var $12=$11;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $13=(($6+32)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($6+36)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($6+40)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($6+44)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($6+48)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($6+52)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($6+56)|0);
      var $20=$2;
      HEAP32[(($19)>>2)]=$20;
      var $21=(($6+60)|0);
      var $22=$3;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($6+64)|0);
      FUNCTION_TABLE[__ZN11device_listC1ER13resource_pool]($23, _global_resource_pool);
      var $24=$2;
      var $25=(($24+24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$26]($6, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 14; break; };
    case 1: // $28
      HEAP32[(($slot)>>2)]=0;
      var $29=(($6+64)|0);
      var $30=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI21device_slot_interfaceEEbRPT_($29, $slot) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 14; break; };
    case 2: // $31
      var $32=(($30)&1);
      $gotone=$32;
      __label__ = 3; break;
    case 3: // $33
      var $34=$gotone;
      var $35=(($34) & 1);
      if ($35) { __label__ = 4; break; } else { __label__ = 29; break; }
    case 4: // $36
      var $37=HEAP32[(($slot)>>2)];
      var $38=(function() { try { __THREW__ = false; return __ZNK21device_slot_interface19get_slot_interfacesEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 14; break; };
    case 5: // $39
      $intf=$38;
      var $40=$intf;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 6; break; } else { __label__ = 26; break; }
    case 6: // $42
      var $43=HEAP32[(($slot)>>2)];
      var $44=$43;
      var $45=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 14; break; };
    case 7: // $46
      $owner=$45;
      var $47=$3;
      var $48=$47;
      var $49=$owner;
      var $50=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; };
    case 8: // $51
      var $52=(function() { try { __THREW__ = false; return __ZNK12core_options5valueEPKc($48, $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 14; break; };
    case 9: // $53
      $selval=$52;
      var $54=$3;
      var $55=$54;
      var $56=$owner;
      var $57=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 14; break; };
    case 10: // $58
      var $59=(function() { try { __THREW__ = false; return __ZNK12core_options5seqidEPKc($55, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $60
      var $61=(($59)|0)==0;
      if ($61) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $62
      var $63=HEAP32[(($slot)>>2)];
      var $64=(function() { try { __THREW__ = false; return __ZNK21device_slot_interface16get_default_cardEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $65
      $selval=$64;
      __label__ = 15; break;
    case 14: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      $4=$68;
      var $69=$67.f1;
      $5=$69;
      __label__ = 46; break;
    case 15: // $70
      var $71=$selval;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 16; break; } else { __label__ = 25; break; }
    case 16: // $73
      $i=0;
      __label__ = 17; break;
    case 17: // $74
      var $75=$i;
      var $76=$intf;
      var $77=(($76+($75<<3))|0);
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $81
      var $82=$selval;
      var $83=$i;
      var $84=$intf;
      var $85=(($84+($83<<3))|0);
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(function() { try { __THREW__ = false; return _strcmp($82, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 14; break; };
    case 19: // $89
      var $90=(($88)|0)==0;
      if ($90) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $91
      var $92=$owner;
      var $93=$i;
      var $94=$intf;
      var $95=(($94+($93<<3))|0);
      var $96=(($95)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$i;
      var $99=$intf;
      var $100=(($99+($98<<3))|0);
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($6, $92, $97, $102, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 14; break; };
    case 21: // $104
      __label__ = 22; break;
    case 22: // $105
      __label__ = 23; break;
    case 23: // $106
      var $107=$i;
      var $108=(($107+1)|0);
      $i=$108;
      __label__ = 17; break;
    case 24: // $109
      __label__ = 25; break;
    case 25: // $110
      __label__ = 26; break;
    case 26: // $111
      __label__ = 27; break;
    case 27: // $112
      var $113=HEAP32[(($slot)>>2)];
      var $114=$113;
      var $115=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI21device_slot_interfaceEEbRPT_($114, $slot) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 14; break; };
    case 28: // $116
      var $117=(($115)&1);
      $gotone=$117;
      __label__ = 3; break;
    case 29: // $118
      var $119=(($6+64)|0);
      var $120=$119;
      var $121=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE4findEPKc($120, ((STRING_TABLE.__str1957)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 14; break; };
    case 30: // $122
      $root=$121;
      var $123=$root;
      var $124=(($123)|0)==0;
      if ($124) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $125
      var $126=___cxa_allocate_exception(1032);
      var $127=$126;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($127, ((STRING_TABLE.__str11958)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $128
      (function() { try { __THREW__ = false; return ___cxa_throw($126, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 14; break; }
    case 33: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      $4=$131;
      var $132=$130.f1;
      $5=$132;
      ___cxa_free_exception($126);
      __label__ = 46; break;
    case 34: // $133
      var $134=$root;
      var $135=$2;
      (function() { try { __THREW__ = false; return __ZN13driver_device15static_set_gameER8device_tRK11game_driver($134, $135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 14; break; }
    case 35: // $136
      var $137=(($6+64)|0);
      var $138=$137;
      var $139=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 14; break; };
    case 36: // $140
      $device=$139;
      __label__ = 37; break;
    case 37: // $141
      var $142=$device;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 38; break; } else { __label__ = 45; break; }
    case 38: // $144
      var $145=$device;
      var $146=(function() { try { __THREW__ = false; return __ZNK8device_t10configuredEv($145) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 14; break; };
    case 39: // $147
      if ($146) { __label__ = 42; break; } else { __label__ = 40; break; }
    case 40: // $148
      var $149=$device;
      (function() { try { __THREW__ = false; return __ZN8device_t15config_completeEv($149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 14; break; }
    case 41: // $150
      __label__ = 42; break;
    case 42: // $151
      __label__ = 43; break;
    case 43: // $152
      var $153=$device;
      var $154=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 14; break; };
    case 44: // $155
      $device=$154;
      __label__ = 37; break;
    case 45: // $156
      STACKTOP = __stackBase__;
      return;
    case 46: // $157
      var $158=(($6+64)|0);
      (function() { try { __THREW__ = false; return __ZN11device_listD1Ev($158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 47: // $159
      __label__ = 48; break;
    case 48: // $160
      var $161=$4;
      var $162=$4;
      var $163=$5;
      var $164=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $162, tempValue);
      var $165=($164.f1 = $163, $164);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $166
      var $167=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 50: // $168
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14machine_configC2ERK11game_driverR11emu_options["X"]=1;

function __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($this, $owner, $tag, $type, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $tempstring=__stackBase__;
      var $fulltag;
      var $7;
      var $8;
      var $device;
      var $9;
      $2=$this;
      $3=$owner;
      $4=$tag;
      $5=$type;
      $6=$clock;
      var $10=$2;
      __ZN7astringC1Ev($tempstring);
      var $11=$3;
      var $12=$4;
      var $13=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($11, $tempstring, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $14
      var $15=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $16
      $fulltag=$15;
      var $17=(($10+64)|0);
      var $18=$17;
      var $19=$fulltag;
      var $20=$5;
      var $21=$fulltag;
      var $22=$3;
      var $23=$6;
      var $24=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$20]($10, $21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $25
      var $26=(function() { try { __THREW__ = false; return __ZN11tagged_listI8device_tE6appendEPKcRS0_($18, $19, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $27
      $device=$26;
      var $28=$device;
      (function() { try { __THREW__ = false; return __ZN14machine_config21device_add_subdevicesEP8device_t($10, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$device;
      $1=$30;
      $9=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $31=$1;
      STACKTOP = __stackBase__;
      return $31;
    case 6: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $7=$34;
      var $35=$33.f1;
      $8=$35;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $36
      __label__ = 8; break;
    case 8: // $37
      var $38=$7;
      var $39=$7;
      var $40=$8;
      var $41=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39, tempValue);
      var $42=($41.f1 = $40, $41);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj["X"]=1;

function __ZN11tagged_listI8device_tE6appendEPKcRS0_($this, $tag, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$tag;
      $3=$object;
      var $6=$1;
      var $7=(($6+20)|0);
      var $8=$2;
      var $9=$3;
      var $10=__ZN8tagmap_tIP8device_tE15add_unique_hashEPKcS1_b($7, $8, $9, 0);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=___cxa_allocate_exception(1032);
      var $14=$13;
      var $15=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($14, ((STRING_TABLE.__str41961)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      ___cxa_throw($13, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      ___cxa_free_exception($13);
      __label__ = 5; break;
    case 4: // $21
      var $22=(($6)|0);
      var $23=$3;
      var $24=__ZN11simple_listI8device_tE6appendERS0_($22, $23);
      ;
      return $24;
    case 5: // $25
      var $26=$4;
      var $27=$4;
      var $28=$5;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14machine_config11device_findEP8device_tPKc($this, $owner, $tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $tempstring=__stackBase__;
      var $fulltag;
      var $5;
      var $6;
      var $device;
      var $7;
      $2=$this;
      $3=$owner;
      $4=$tag;
      var $8=$2;
      __ZN7astringC1Ev($tempstring);
      var $9=$3;
      var $10=$4;
      var $11=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($9, $tempstring, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $14
      $fulltag=$13;
      var $15=(($8+64)|0);
      var $16=$15;
      var $17=$fulltag;
      var $18=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE4findEPKc($16, $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $19
      $device=$18;
      var $20=$device;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $22
      var $23=___cxa_allocate_exception(1032);
      var $24=$23;
      var $25=$fulltag;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($24, ((STRING_TABLE.__str21959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$25,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $26
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 6; break; }
    case 6: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $5=$29;
      var $30=$28.f1;
      $6=$30;
      __label__ = 9; break;
    case 7: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $5=$33;
      var $34=$32.f1;
      $6=$34;
      ___cxa_free_exception($23);
      __label__ = 9; break;
    case 8: // $35
      var $36=$device;
      $1=$36;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $37=$1;
      STACKTOP = __stackBase__;
      return $37;
    case 9: // $38
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $39
      __label__ = 11; break;
    case 11: // $40
      var $41=$5;
      var $42=$5;
      var $43=$6;
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 13: // $48
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14machine_config11device_findEP8device_tPKc["X"]=1;

function __ZN11tagged_listI8device_tED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP8device_tED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4)|0);
      __ZN11simple_listI8device_tED1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI8device_tED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z22get_temp_string_bufferv() {
  ;
  var __label__;

  var $string;
  var $1=HEAP32[((__ZL22temp_string_pool_index)>>2)];
  var $2=(($1+1)|0);
  HEAP32[((__ZL22temp_string_pool_index)>>2)]=$2;
  var $3=(($1)|0)%16;
  var $4=((__ZL16temp_string_pool+($3<<8))|0);
  var $5=(($4)|0);
  $string=$5;
  var $6=$string;
  var $7=(($6)|0);
  HEAP8[($7)]=0;
  var $8=$string;
  ;
  return $8;
}


function __ZNK11device_list7machineEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+408)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIP8device_tED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP8device_tED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI8device_tED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI8device_tED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI8device_tED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI8device_tE+8)|0);
  __ZN11simple_listI8device_tE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI8device_tE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI8device_tE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIP8device_tED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP8device_tE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP8device_tE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN11device_listC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  __ZN11tagged_listI8device_tEC2ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN11device_list15set_machine_allER15running_machine($this, $machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $device;
      $1=$this;
      $2=$machine;
      var $3=$1;
      var $4=$2;
      var $5=(($3+408)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=$3;
      var $7=__ZNK11tagged_listI8device_tE5firstEv($6);
      $device=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$device;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$device;
      var $13=$2;
      __ZN8device_t11set_machineER15running_machine($12, $13);
      __label__ = 3; break;
    case 3: // $14
      var $15=$device;
      var $16=__ZNK8device_t4nextEv($15);
      $device=$16;
      __label__ = 1; break;
    case 4: // $17
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t11set_machineER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=$2;
  var $5=(($3+280)|0);
  HEAP32[(($5)>>2)]=$4;
  var $6=$2;
  var $7=__ZN15running_machine4saveEv($6);
  var $8=(($3+284)|0);
  HEAP32[(($8)>>2)]=$7;
  ;
  return;
}


function __ZN11device_list9start_allEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+24;
  var $4=__stackBase__+32;
  var $5=__stackBase__+56;
  var $6=__stackBase__+64;
  var $7=__stackBase__+88;
  var $8=__stackBase__+96;
  var $9=__stackBase__+120;
  $1=$this;
  var $10=$1;
  var $11=__ZNK11device_list7machineEv($10);
  HEAP32[(($3)>>2)]={ f0: 178, f1: 0 }.f0; HEAP32[(($3+4)>>2)]={ f0: 178, f1: 0 }.f1;
  __ZN8delegateIFvvEEC1I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($2, $3, ((STRING_TABLE.__str1973)|0), $10);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($11, 1, $2);
  var $12=__ZNK11device_list7machineEv($10);
  HEAP32[(($5)>>2)]={ f0: 180, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 180, f1: 0 }.f1;
  __ZN8delegateIFvvEEC1I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($4, $5, ((STRING_TABLE.__str11974)|0), $10);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($12, 4, $4);
  var $13=__ZNK11device_list7machineEv($10);
  var $14=__ZN15running_machine4saveEv($13);
  HEAP32[(($7)>>2)]={ f0: 182, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 182, f1: 0 }.f1;
  __ZN8delegateIFvvEEC1I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($6, $7, ((STRING_TABLE.__str21975)|0), $10);
  __ZN12save_manager16register_presaveE8delegateIFvvEE($14, $6);
  var $15=__ZNK11device_list7machineEv($10);
  var $16=__ZN15running_machine4saveEv($15);
  HEAP32[(($9)>>2)]={ f0: 184, f1: 0 }.f0; HEAP32[(($9+4)>>2)]={ f0: 184, f1: 0 }.f1;
  __ZN8delegateIFvvEEC1I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($8, $9, ((STRING_TABLE.__str31976)|0), $10);
  __ZN12save_manager17register_postloadE8delegateIFvvEE($16, $8);
  __ZN11device_list17start_new_devicesEv($10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFvvEEC1I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN11device_list9reset_allEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK11tagged_listI8device_tE5firstEv($3);
      $device=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$device;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$device;
      __ZN8device_t5resetEv($9);
      __label__ = 3; break;
    case 3: // $10
      var $11=$device;
      var $12=__ZNK8device_t4nextEv($11);
      $device=$12;
      __label__ = 1; break;
    case 4: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11device_list4exitEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK11device_list7machineEv($2);
      var $4=(($3+584)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5 & 1;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=__ZNK11device_list7machineEv($2);
      var $10=__Z18debug_comment_saveR15running_machine($9);
      __label__ = 2; break;
    case 2: // $11
      __ZN11device_list8stop_allEv($2);
      var $12=$2;
      __ZN11tagged_listI8device_tE5resetEv($12);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11device_list11presave_allEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK11tagged_listI8device_tE5firstEv($3);
      $device=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$device;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$device;
      __ZN8device_t8pre_saveEv($9);
      __label__ = 3; break;
    case 3: // $10
      var $11=$device;
      var $12=__ZNK8device_t4nextEv($11);
      $device=$12;
      __label__ = 1; break;
    case 4: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11device_list12postload_allEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK11tagged_listI8device_tE5firstEv($3);
      $device=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$device;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$device;
      __ZN8device_t9post_loadEv($9);
      __label__ = 3; break;
    case 3: // $10
      var $11=$device;
      var $12=__ZNK8device_t4nextEv($11);
      $device=$12;
      __label__ = 1; break;
    case 4: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11tagged_listI8device_tE6detachERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  __ZN8tagmap_tIP8device_tE6removeES1_($4, $5);
  var $6=(($3)|0);
  var $7=$2;
  var $8=__ZN11simple_listI8device_tE6detachERS0_($6, $7);
  ;
  return $8;
}


function __ZN11simple_listI8device_tED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI8device_tED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI8device_tED0Ev["X"]=1;

function __ZN11tagged_listI8device_tEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$pool;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      __ZN11simple_listI8device_tEC1ER13resource_pool($6, $7);
      var $8=(($5+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP8device_tEC1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $3=$12;
      var $13=$11.f1;
      $4=$13;
      var $14=(($5)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI8device_tED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$3;
      var $18=$3;
      var $19=$4;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11device_list17start_new_devicesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $nextdevice;
      var $device;
      var $2;
      var $3;
      var $4;
      $1=$this;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=$5;
      var $9=__ZNK11tagged_listI8device_tE5firstEv($8);
      $device=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$device;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 33; break; }
    case 4: // $13
      var $14=$device;
      var $15=__ZNK8device_t4nextEv($14);
      $nextdevice=$15;
      var $16=$device;
      var $17=__ZNK8device_t7startedEv($16);
      if ($17) { __label__ = 31; break; } else { __label__ = 5; break; }
    case 5: // $18
      var $19=$device;
      var $20=(($19+280)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $23
      var $24=$device;
      var $25=(function() { try { __THREW__ = false; return __ZNK11device_list7machineEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $26
      (function() { try { __THREW__ = false; return __ZN8device_t11set_machineER15running_machine($24, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $27
      __label__ = 17; break;
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI27device_missing_dependencies]);
      var $30=$29.f0;
      $2=$30;
      var $31=$29.f1;
      $3=$31;
      __label__ = 10; break;
    case 10: // $32
      var $33=$3;
      var $34=_llvm_eh_typeid_for(__ZTI27device_missing_dependencies);
      var $35=(($33)|0)==(($34)|0);
      if ($35) { __label__ = 11; break; } else { __label__ = 34; break; }
    case 11: // $36
      var $37=$2;
      var $38=___cxa_begin_catch($37);
      var $39=$38;
      $4=$39;
      (function() { try { __THREW__ = false; return __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str51978)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 22; break; }
    case 12: // $40
      var $41=$nextdevice;
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 13; break; } else { __label__ = 24; break; }
    case 13: // $43
      var $44=___cxa_allocate_exception(1032);
      var $45=$44;
      var $46=$device;
      var $47=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 23; break; };
    case 14: // $48
      var $49=$device;
      var $50=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 23; break; };
    case 15: // $51
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($45, ((STRING_TABLE.__str61979)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$47,HEAP32[((tempInt+4)>>2)]=$50,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 23; break; }
    case 16: // $52
      (function() { try { __THREW__ = false; return ___cxa_throw($44, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 22; break; }
    case 17: // $53
      var $54=$device;
      var $55=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $56
      var $57=$device;
      var $58=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 9; break; };
    case 19: // $59
      (function() { try { __THREW__ = false; return __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str41977)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,HEAP32[((tempInt+4)>>2)]=$58,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 9; break; }
    case 20: // $60
      var $61=$device;
      (function() { try { __THREW__ = false; return __ZN8device_t5startEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 9; break; }
    case 21: // $62
      __label__ = 28; break;
    case 22: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      $2=$65;
      var $66=$64.f1;
      $3=$66;
      __label__ = 29; break;
    case 23: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $2=$69;
      var $70=$68.f1;
      $3=$70;
      ___cxa_free_exception($44);
      __label__ = 29; break;
    case 24: // $71
      var $72=$5;
      var $73=$device;
      var $74=(function() { try { __THREW__ = false; return __ZN11tagged_listI8device_tE6detachERS0_($72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 22; break; };
    case 25: // $75
      var $76=$5;
      var $77=$device;
      var $78=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 22; break; };
    case 26: // $79
      var $80=$device;
      var $81=(function() { try { __THREW__ = false; return __ZN11tagged_listI8device_tE6appendEPKcRS0_($76, $78, $80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 22; break; };
    case 27: // $82
      ___cxa_end_catch();
      __label__ = 28; break;
    case 28: // $83
      __label__ = 31; break;
    case 29: // $84
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $85
      __label__ = 34; break;
    case 31: // $86
      __label__ = 32; break;
    case 32: // $87
      var $88=$nextdevice;
      $device=$88;
      __label__ = 3; break;
    case 33: // $89
      ;
      return;
    case 34: // $90
      var $91=$2;
      var $92=$2;
      var $93=$3;
      var $94=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $92, tempValue);
      var $95=($94.f1 = $93, $94);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $96
      var $97=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 36: // $98
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11device_list17start_new_devicesEv["X"]=1;

function __ZN8device_t5startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $autodev;
      var $intf;
      var $state_registrations;
      var $exec=__stackBase__+36;
      var $sound=__stackBase__+40;
      var $intf1;
      var $10;
      var $11;
      $9=$this;
      var $12=$9;
      var $13=__ZNK8device_t7machineEv($12);
      var $14=__ZNK8device_t3tagEv($12);
      var $15=__ZN15running_machine6regionEPKc($13, $14);
      var $16=(($12+252)|0);
      HEAP32[(($16)>>2)]=$15;
      var $17=(($12+276)|0);
      var $18=HEAP32[(($17)>>2)];
      $autodev=$18;
      __label__ = 1; break;
    case 1: // $19
      var $20=$autodev;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $22
      var $23=$autodev;
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      FUNCTION_TABLE[$27]($23, $12);
      __label__ = 3; break;
    case 3: // $28
      var $29=$autodev;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $autodev=$31;
      __label__ = 1; break;
    case 4: // $32
      var $33=(($12+28)|0);
      var $34=HEAP32[(($33)>>2)];
      $intf=$34;
      __label__ = 5; break;
    case 5: // $35
      var $36=$intf;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $38
      var $39=$intf;
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+16)|0);
      var $43=HEAP32[(($42)>>2)];
      FUNCTION_TABLE[$43]($39);
      __label__ = 7; break;
    case 7: // $44
      var $45=$intf;
      var $46=__ZNK16device_interface14interface_nextEv($45);
      $intf=$46;
      __label__ = 5; break;
    case 8: // $47
      var $48=__ZNK8device_t7machineEv($12);
      var $49=__ZN15running_machine4saveEv($48);
      var $50=__ZNK12save_manager18registration_countEv($49);
      $state_registrations=$50;
      var $51=$12;
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+28)|0);
      var $54=HEAP32[(($53)>>2)];
      FUNCTION_TABLE[$54]($12);
      var $55=__ZNK8device_t7machineEv($12);
      var $56=__ZN15running_machine4saveEv($55);
      var $57=__ZNK12save_manager18registration_countEv($56);
      var $58=$state_registrations;
      var $59=(($57-$58)|0);
      $state_registrations=$59;
      var $60=$state_registrations;
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $62
      var $63=__ZN8device_t9interfaceERP24device_execute_interface($12, $exec);
      if ($63) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $64
      var $65=__ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_($12, $sound);
      if ($65) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $66
      var $67=__ZNK8device_t3tagEv($12);
      __Z8logerrorPKcz(((STRING_TABLE.__str71980)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$67,tempInt));
      var $68=__ZNK8device_t7machineEv($12);
      var $69=__ZNK15running_machine6systemEv($68);
      var $70=(($69+44)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71 & 2048;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $74
      var $75=__ZNK8device_t3tagEv($12);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str81981)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$75,tempInt));
      throw "Reached an unreachable!"
    case 13: // $76
      __label__ = 14; break;
    case 14: // $77
      var $78=(($12+28)|0);
      var $79=HEAP32[(($78)>>2)];
      $intf1=$79;
      __label__ = 15; break;
    case 15: // $80
      var $81=$intf1;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $83
      var $84=$intf1;
      var $85=$84;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+20)|0);
      var $88=HEAP32[(($87)>>2)];
      FUNCTION_TABLE[$88]($84);
      __label__ = 17; break;
    case 17: // $89
      var $90=$intf1;
      var $91=__ZNK16device_interface14interface_nextEv($90);
      $intf1=$91;
      __label__ = 15; break;
    case 18: // $92
      __ZN8device_t20notify_clock_changedEv($12);
      var $93=__ZNK8device_t7machineEv($12);
      var $94=(($93+584)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$95 & 1;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 19; break; } else { __label__ = 33; break; }
    case 19: // $98
      var $99=__ZNK8device_t7machineEv($12);
      var $100=__ZN15running_machine7respoolEv($99);
      var $101=$4;
      var $102=$5;
      var $103=$6;
      var $104=$result_i;
      var $105=$7;
      var $106=$8;
      HEAP32[(($4)>>2)]=1600;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str91982)|0);
      HEAP32[(($6)>>2)]=663;
      var $107=HEAP32[(($4)>>2)];
      var $108=HEAP32[(($5)>>2)];
      var $109=HEAP32[(($6)>>2)];
      var $110=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($107, $108, $109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; };
    case 20: // $111
      HEAP32[(($result_i)>>2)]=$110;
      var $112=HEAP32[(($result_i)>>2)];
      var $113=(($112)|0)==0;
      if ($113) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $114
      var $115=___cxa_allocate_exception(4);
      var $116=$115;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($116);
      (function() { try { __THREW__ = false; return ___cxa_throw($115, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 22; break; }
    case 22: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      HEAP32[(($7)>>2)]=$119;
      var $120=$118.f1;
      HEAP32[(($8)>>2)]=$120;
      var $121=HEAP32[(($8)>>2)];
      var $122=(($121)|0) < 0;
      if ($122) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $123
      var $124=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($124);
      throw "Reached an unreachable!"
    case 24: // $125
      var $126=HEAP32[(($7)>>2)];
      var $127=HEAP32[(($7)>>2)];
      var $128=HEAP32[(($8)>>2)];
      var $129=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $127, tempValue);
      var $130=($129.f1 = $128, $129);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $131
      throw "Reached an unreachable!"
    case 26: // $_ZnwjPKci_exit
      var $132=HEAP32[(($result_i)>>2)];
      var $133=$4;
      var $134=$5;
      var $135=$6;
      var $136=$result_i;
      var $137=$7;
      var $138=$8;
      var $139=$132;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debugC1ER8device_t]($139, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $140
      var $141=__ZN13resource_pool10add_objectI12device_debugEEPT_S3_($100, $139);
      var $142=(($12+4)|0);
      HEAP32[(($142)>>2)]=$141;
      __ZN8device_t11debug_setupEv($12);
      __label__ = 33; break;
    case 28: // $143
      var $144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $145=$144.f0;
      $10=$145;
      var $146=$144.f1;
      $11=$146;
      var $147=$1;
      var $148=$2;
      var $149=$3;
      HEAP32[(($1)>>2)]=$132;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str91982)|0);
      HEAP32[(($3)>>2)]=663;
      var $150=HEAP32[(($1)>>2)];
      var $151=(($150)|0)!=0;
      if ($151) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $152
      var $153=HEAP32[(($1)>>2)];
      var $154=HEAP32[(($2)>>2)];
      var $155=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($153, $154, $155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $_noexc
      __label__ = 31; break;
    case 31: // $_ZdlPvPKci_exit
      var $156=$1;
      var $157=$2;
      var $158=$3;
      __label__ = 32; break;
    case 32: // $159
      __label__ = 34; break;
    case 33: // $160
      var $161=(($12+248)|0);
      __ZN8device_t9save_itemIjEEvRT_PKci($12, $161, ((STRING_TABLE.__str101983)|0), 0);
      var $162=(($12+256)|0);
      __ZN8device_t9save_itemIjEEvRT_PKci($12, $162, ((STRING_TABLE.__str111984)|0), 0);
      var $163=(($12+260)|0);
      __ZN8device_t9save_itemIdEEvRT_PKci($12, $163, ((STRING_TABLE.__str121985)|0), 0);
      var $164=(($12+244)|0);
      HEAP8[($164)]=1;
      STACKTOP = __stackBase__;
      return;
    case 34: // $165
      var $166=$10;
      var $167=$10;
      var $168=$11;
      var $169=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $167, tempValue);
      var $170=($169.f1 = $168, $169);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $171
      var $172=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_t5startEv["X"]=1;

function __ZN18delegate_late_bindD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN18delegate_late_bindC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV18delegate_late_bind+8)|0);
  ;
  return;
}


function __ZN8device_t16static_set_clockERS_j($device, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$device;
      $2=$clock;
      var $3=$2;
      var $4=$3 & -16777216;
      var $5=(($4)|0)==-16777216;
      if ($5) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      var $9=$1;
      var $10=(($9+24)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+36)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=$14 >>> 12;
      var $16=$15 & 4095;
      var $17=(($13*$16)|0);
      var $18=$2;
      var $19=$18 >>> 0;
      var $20=$19 & 4095;
      var $21=Math.floor((($17)>>>0)/(($20)>>>0));
      $2=$21;
      __label__ = 4; break;
    case 4: // $22
      var $23=$2;
      var $24=$1;
      var $25=(($24+36)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$1;
      var $27=(($26+256)|0);
      HEAP32[(($27)>>2)]=$23;
      var $28=$1;
      var $29=(($28+248)|0);
      HEAP32[(($29)>>2)]=$23;
      var $30=$2;
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      var $38$1 = 0;var $38$0 = 0;__label__ = 7; break;
    case 6: // $33
      var $34=$2;
      var $35$0=$34;
      var $35$1=0;
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $36$0 = (tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($35$0)>>>0)+((($35$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $36$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($35$0)>>>0)+((($35$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $38$1 = $36$1;var $38$0 = $36$0;__label__ = 7; break;
    case 7: // $37
      var $38$0;
      var $38$1;
      var $39=$1;
      var $40=(($39+268)|0);
      var $st$4$0=(($40)|0);
      HEAP32[(($st$4$0)>>2)]=$38$0;
      var $st$4$1=(($40+4)|0);
      HEAP32[(($st$4$1)>>2)]=$38$1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_t16static_set_clockERS_j["X"]=1;

function __ZN8device_t5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      var $intf1;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+24)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+36)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      var $22=(($2+28)|0);
      var $23=HEAP32[(($22)>>2)];
      $intf1=$23;
      __label__ = 5; break;
    case 5: // $24
      var $25=$intf1;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $27
      var $28=$intf1;
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      FUNCTION_TABLE[$32]($28);
      __label__ = 7; break;
    case 7: // $33
      var $34=$intf1;
      var $35=__ZNK16device_interface14interface_nextEv($34);
      $intf1=$35;
      __label__ = 5; break;
    case 8: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11device_list8stop_allEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK11tagged_listI8device_tE5firstEv($3);
      $device=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$device;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$device;
      __ZN8device_t4stopEv($9);
      __label__ = 3; break;
    case 3: // $10
      var $11=$device;
      var $12=__ZNK8device_t4nextEv($11);
      $device=$12;
      __label__ = 1; break;
    case 4: // $13
      var $14=(($2+408)|0);
      HEAP32[(($14)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t4stopEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      var $intf1;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+32)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+32)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      var $22=(($2+28)|0);
      var $23=HEAP32[(($22)>>2)];
      $intf1=$23;
      __label__ = 5; break;
    case 5: // $24
      var $25=$intf1;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $27
      var $28=$intf1;
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+36)|0);
      var $32=HEAP32[(($31)>>2)];
      FUNCTION_TABLE[$32]($28);
      __label__ = 7; break;
    case 7: // $33
      var $34=$intf1;
      var $35=__ZNK16device_interface14interface_nextEv($34);
      $intf1=$35;
      __label__ = 5; break;
    case 8: // $36
      var $37=__ZNK8device_t7machineEv($2);
      var $38=__ZN15running_machine7respoolEv($37);
      var $39=(($2+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      __ZN13resource_pool6removeEPv($38, $41);
      var $42=(($2+244)|0);
      HEAP8[($42)]=0;
      var $43=(($2+280)|0);
      HEAP32[(($43)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_t4stopEv["X"]=1;

function __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cur;
      $1=$this;
      $2=$type;
      var $3=$1;
      var $4=$3;
      var $5=__ZNK11tagged_listI8device_tE5firstEv($4);
      $cur=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$cur;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { var $15 = 0;__label__ = 3; break; }
    case 2: // $9
      var $10=$cur;
      var $11=__ZNK8device_t4typeEv($10);
      var $12=$2;
      var $13=(($11)|0)!=(($12)|0);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      if ($15) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$cur;
      var $19=__ZNK8device_t4nextEv($18);
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      var $21=$cur;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $num;
      var $curdev;
      $1=$this;
      $2=$type;
      var $3=$1;
      $num=0;
      var $4=$2;
      var $5=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($3, $4);
      $curdev=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$curdev;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$num;
      var $11=(($10+1)|0);
      $num=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$curdev;
      var $14=__ZNK8device_t8typenextEv($13);
      $curdev=$14;
      __label__ = 1; break;
    case 4: // $15
      var $16=$num;
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jERS0_($this, $type, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $num;
      var $cur;
      $2=$this;
      $3=$type;
      $4=$object;
      var $5=$2;
      $num=0;
      var $6=$3;
      var $7=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($5, $6);
      $cur=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$cur;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$cur;
      var $13=$4;
      var $14=(($12)|0)==(($13)|0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$num;
      $1=$16;
      __label__ = 7; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$cur;
      var $20=__ZNK8device_t8typenextEv($19);
      $cur=$20;
      var $21=$num;
      var $22=(($21+1)|0);
      $num=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=-1;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jES6_($this, $type, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $object;
      $1=$this;
      $2=$type;
      $3=$tag;
      var $4=$1;
      var $5=$4;
      var $6=$3;
      var $7=__ZNK11tagged_listI8device_tE4findEPKc($5, $6);
      $object=$7;
      var $8=$object;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$object;
      var $12=__ZNK8device_t4typeEv($11);
      var $13=$2;
      var $14=(($12)|0)==(($13)|0);
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$2;
      var $17=$object;
      var $18=__ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jERS0_($4, $16, $17);
      var $21 = $18;__label__ = 4; break;
    case 3: // $19
      var $21 = -1;__label__ = 4; break;
    case 4: // $20
      var $21;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list4findEPFP8device_tRK14machine_configPKcS1_jEi($this, $type, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cur;
      $2=$this;
      $3=$type;
      $4=$index;
      var $5=$2;
      var $6=$3;
      var $7=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($5, $6);
      $cur=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$cur;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$4;
      var $13=(($12-1)|0);
      $4=$13;
      var $14=(($12)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$cur;
      $1=$16;
      __label__ = 7; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$cur;
      var $20=__ZNK8device_t8typenextEv($19);
      $cur=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11tagged_listI8device_tE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listI8device_tE5resetEv($3);
  var $4=(($2+20)|0);
  __ZN8tagmap_tIP8device_tE5resetEv($4);
  ;
  return;
}


function __ZN8device_t8pre_saveEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+40)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+40)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9post_loadEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+44)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+44)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($this, $mconfig, $type, $name, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $1=$this;
      $2=$mconfig;
      $3=$type;
      $4=$name;
      $5=$tag;
      $6=$owner;
      $7=$clock;
      var $10=$1;
      var $11=$10;
      __ZN18delegate_late_bindC2Ev($11);
      var $12=$10;
      HEAP32[(($12)>>2)]=((__ZTV8device_t+8)|0);
      var $13=(($10+4)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($10+8)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($10+12)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($10+16)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($10+20)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($10+24)|0);
      var $19=$6;
      HEAP32[(($18)>>2)]=$19;
      var $20=(($10+28)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($10+32)|0);
      var $22=$3;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($10+36)|0);
      var $24=$7;
      HEAP32[(($23)>>2)]=$24;
      var $25=(($10+40)|0);
      var $26=$2;
      HEAP32[(($25)>>2)]=$26;
      var $27=(($10+44)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=(($10+48)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($10+52)|0);
      var $30=$4;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $31
      var $32=(($10+116)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $33
      var $34=(($10+180)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $35
      var $36=(($10+244)|0);
      HEAP8[($36)]=0;
      var $37=(($10+248)|0);
      var $38=$7;
      HEAP32[(($37)>>2)]=$38;
      var $39=(($10+252)|0);
      HEAP32[(($39)>>2)]=0;
      var $40=(($10+256)|0);
      var $41=$7;
      HEAP32[(($40)>>2)]=$41;
      var $42=(($10+260)|0);
      (tempDoubleF64[0]=1,HEAP32[(($42)>>2)]=tempDoubleI32[0],HEAP32[(($42+4)>>2)]=tempDoubleI32[1]);
      var $43=(($10+268)|0);
      var $44=$7;
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $46
      var $52$1 = 0;var $52$0 = 0;__label__ = 6; break;
    case 5: // $47
      var $48=$7;
      var $49$0=$48;
      var $49$1=0;
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $50$0 = (tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($49$0)>>>0)+((($49$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $50$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($49$0)>>>0)+((($49$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $52$1 = $50$1;var $52$0 = $50$0;__label__ = 6; break;
    case 6: // $51
      var $52$0;
      var $52$1;
      var $st$2$0=(($43)|0);
      HEAP32[(($st$2$0)>>2)]=$52$0;
      var $st$2$1=(($43+4)|0);
      HEAP32[(($st$2$1)>>2)]=$52$1;
      var $53=(($10+276)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=(($10+280)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=(($10+284)|0);
      HEAP32[(($55)>>2)]=0;
      var $56=(($10+288)|0);
      var $57=$5;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $58
      var $59=(($10+352)|0);
      HEAP8[($59)]=0;
      var $60=$7;
      (function() { try { __THREW__ = false; return __ZN8device_t16static_set_clockERS_j($10, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $61
      ;
      return;
    case 9: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $8=$64;
      var $65=$63.f1;
      $9=$65;
      __label__ = 21; break;
    case 10: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      $8=$68;
      var $69=$67.f1;
      $9=$69;
      __label__ = 19; break;
    case 11: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $8=$72;
      var $73=$71.f1;
      $9=$73;
      __label__ = 17; break;
    case 12: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $8=$76;
      var $77=$75.f1;
      $9=$77;
      __label__ = 15; break;
    case 13: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $80=$79.f0;
      $8=$80;
      var $81=$79.f1;
      $9=$81;
      var $82=(($10+288)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $83
      __label__ = 15; break;
    case 15: // $84
      var $85=(($10+180)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $86
      __label__ = 17; break;
    case 17: // $87
      var $88=(($10+116)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $89
      __label__ = 19; break;
    case 19: // $90
      var $91=(($10+52)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $92
      __label__ = 21; break;
    case 21: // $93
      var $94=$10;
      (function() { try { __THREW__ = false; return __ZN18delegate_late_bindD2Ev($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $95
      __label__ = 23; break;
    case 23: // $96
      var $97=$8;
      var $98=$8;
      var $99=$9;
      var $100=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $98, tempValue);
      var $101=($100.f1 = $99, $100);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j["X"]=1;

function __ZN8device_tD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8device_tD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_tD0Ev["X"]=1;

function __ZN8device_tD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV8device_t+8)|0);
      var $6=(($4+288)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=(($4+180)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=(($4+116)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $11
      var $12=(($4+52)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $13
      var $14=$4;
      __ZN18delegate_late_bindD2Ev($14);
      ;
      return;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      var $19=(($4+180)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 17; break; }
    case 6: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $2=$22;
      var $23=$21.f1;
      $3=$23;
      __label__ = 9; break;
    case 7: // $24
      __label__ = 9; break;
    case 8: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $2=$27;
      var $28=$26.f1;
      $3=$28;
      __label__ = 12; break;
    case 9: // $29
      var $30=(($4+116)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $31
      __label__ = 12; break;
    case 11: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $2=$34;
      var $35=$33.f1;
      $3=$35;
      __label__ = 14; break;
    case 12: // $36
      var $37=(($4+52)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $38
      __label__ = 14; break;
    case 14: // $39
      var $40=$4;
      (function() { try { __THREW__ = false; return __ZN18delegate_late_bindD2Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $41
      __label__ = 16; break;
    case 16: // $42
      var $43=$2;
      var $44=$2;
      var $45=$3;
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_tD2Ev["X"]=1;

function __ZN8device_t22device_config_completeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNK8device_t21device_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$options;
  $3=$driver;
  var $4=$1;
  ;
  return 0;
}


function __ZNK8device_t17device_rom_regionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK8device_t24device_mconfig_additionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK8device_t18device_input_portsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZN8device_t12device_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8device_t11device_stopEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8device_t15device_pre_saveEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8device_t16device_post_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8device_t20device_clock_changedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8device_t18device_debug_setupEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8device_t12device_timerER9emu_timerjiPv($this, $timer, $id, $param, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$timer;
  $3=$id;
  $4=$param;
  $5=$ptr;
  var $6=$1;
  ;
  return;
}


function __ZN8device_t16auto_finder_baseD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNK8device_t7mconfigEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+40)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16device_interface14interface_nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL14divu_64x32_remyjPj($a$0, $a$1, $b, $remainder) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  var $st$3$0=(($1)|0);
  HEAP32[(($st$3$0)>>2)]=$a$0;
  var $st$3$1=(($1+4)|0);
  HEAP32[(($st$3$1)>>2)]=$a$1;
  $2=$b;
  $3=$remainder;
  var $st$9$0=(($1)|0);
  var $4$0=HEAP32[(($st$9$0)>>2)];
  var $st$9$1=(($1+4)|0);
  var $4$1=HEAP32[(($st$9$1)>>2)];
  var $5=$2;
  var $6$0=$5;
  var $6$1=0;
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$0;
  var $8=$8$0;
  var $9=$3;
  HEAP32[(($9)>>2)]=$8;
  var $st$21$0=(($1)|0);
  var $10$0=HEAP32[(($st$21$0)>>2)];
  var $st$21$1=(($1+4)|0);
  var $10$1=HEAP32[(($st$21$1)>>2)];
  var $11=$2;
  var $12$0=$11;
  var $12$1=0;
  var $13$0 = Math.floor(((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296)))>>>0; var $13$1 = Math.min(Math.floor((Math.floor(((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296))))/4294967296), 4294967295);
  var $14$0=$13$0;
  var $14=$14$0;
  STACKTOP = __stackBase__;
  return $14;
}


function __ZN8device_t9interfaceERP24device_execute_interface($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  HEAP32[(($6)>>2)]=$5;
  var $7=$2;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0)!=0;
  ;
  return $9;
}


function __ZN8device_t20register_auto_finderERNS_16auto_finder_baseE($this, $autodev) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$autodev;
  var $3=$1;
  var $4=(($3+276)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=$2;
  var $9=(($3+276)|0);
  HEAP32[(($9)>>2)]=$8;
  ;
  return;
}


function __ZNK8device_t10siblingtagER7astringPKc($this, $dest, $_tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$dest;
      $3=$_tag;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($4+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=(($4+24)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=$3;
      var $15=__ZNK8device_t6subtagER7astringPKc($12, $13, $14);
      var $21 = $15;__label__ = 4; break;
    case 3: // $16
      var $17=$2;
      var $18=$3;
      var $19=__ZN7astring3cpyEPKc($17, $18);
      var $21 = $19;__label__ = 4; break;
    case 4: // $20
      var $21;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t15config_completeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+20)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      var $22=(($2+352)|0);
      HEAP8[($22)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t14validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      var $intf;
      $1=$this;
      $2=$options;
      $3=$driver;
      var $4=$1;
      $error=0;
      var $5=(($4+28)|0);
      var $6=HEAP32[(($5)>>2)];
      $intf=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$intf;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$intf;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=$3;
      var $18=FUNCTION_TABLE[$15]($11, $16, $17);
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $error=1;
      __label__ = 4; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$intf;
      var $23=__ZNK16device_interface14interface_nextEv($22);
      $intf=$23;
      __label__ = 1; break;
    case 6: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+24)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=$3;
      var $31=FUNCTION_TABLE[$28]($4, $29, $30);
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      $error=1;
      __label__ = 8; break;
    case 8: // $33
      var $34=$error;
      var $35=(($34) & 1);
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t20notify_clock_changedEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+48)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+48)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t15set_clock_scaleEd($this, $clockscale) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$clockscale;
  var $3=$1;
  var $4=$2;
  var $5=(($3+260)|0);
  (tempDoubleF64[0]=$4,HEAP32[(($5)>>2)]=tempDoubleI32[0],HEAP32[(($5+4)>>2)]=tempDoubleI32[1]);
  var $6=(($3+256)|0);
  var $7=HEAPU32[(($6)>>2)];
  var $8=(($7)>>>0);
  var $9=(($3+260)|0);
  var $10=(tempDoubleI32[0]=HEAP32[(($9)>>2)],tempDoubleI32[1]=HEAP32[(($9+4)>>2)],tempDoubleF64[0]);
  var $11=$8*$10;
  var $12=($11 >= 0 ? Math.floor($11) : Math.ceil($11));
  var $13=(($3+248)|0);
  HEAP32[(($13)>>2)]=$12;
  var $14=(($3+248)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16$0=$15;
  var $16$1=0;
  var $$emscripten$temp$0$0=-1486618624;
  var $$emscripten$temp$0$1=232830643;
  var $17$0 = (tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($16$0)>>>0)+((($16$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $17$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($16$0)>>>0)+((($16$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $18=(($3+268)|0);
  var $st$25$0=(($18)|0);
  HEAP32[(($st$25$0)>>2)]=$17$0;
  var $st$25$1=(($18+4)|0);
  HEAP32[(($st$25$1)>>2)]=$17$1;
  __ZN8device_t20notify_clock_changedEv($3);
  ;
  return;
}


function __ZNK8device_t18clocks_to_attotimeEy($agg_result, $this, $numclocks$0, $numclocks$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $remainder=__stackBase__+8;
      var $quotient;
      $1=$this;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$numclocks$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$numclocks$1;
      var $3=$1;
      var $st$10$0=(($2)|0);
      var $4$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($2+4)|0);
      var $4$1=HEAP32[(($st$10$1)>>2)];
      var $5=(($3+248)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7$0=$6;
      var $7$1=0;
      var $8=$4$1 < $7$1 || ($4$1 == $7$1 && $4$0 < $7$0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $st$0$0=(($2)|0);
      var $10$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $10$1=HEAP32[(($st$0$1)>>2)];
      var $11=(($3+268)|0);
      var $st$5$0=(($11)|0);
      var $12$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$5$1)>>2)];
      var $13$0 = ((($10$0)>>>0)+((($10$1)|0)*4294967296))*((($12$0)>>>0)+((($12$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($10$0)>>>0)+((($10$1)|0)*4294967296))*((($12$0)>>>0)+((($12$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($agg_result, 0, $13$0, $13$1);
      __label__ = 3; break;
    case 2: // $14
      var $st$0$0=(($2)|0);
      var $15$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $15$1=HEAP32[(($st$0$1)>>2)];
      var $16=(($3+248)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZL14divu_64x32_remyjPj($15$0, $15$1, $17, $remainder);
      var $18$0=$18[0];
      $quotient=$18;
      var $19=$quotient;
      var $20=HEAP32[(($remainder)>>2)];
      var $21$0=$20;
      var $21$1=0;
      var $22=(($3+268)|0);
      var $st$14$0=(($22)|0);
      var $23$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($22+4)|0);
      var $23$1=HEAP32[(($st$14$1)>>2)];
      var $24$0 = ((($21$0)>>>0)+((($21$1)|0)*4294967296))*((($23$0)>>>0)+((($23$1)|0)*4294967296))>>>0; var $24$1 = Math.min(Math.floor((((($21$0)>>>0)+((($21$1)|0)*4294967296))*((($23$0)>>>0)+((($23$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($agg_result, $19, $24$0, $24$1);
      __label__ = 3; break;
    case 3: // $25
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK8device_t18clocks_to_attotimeEy["X"]=1;

function __ZN8device_t11timer_allocEjPv($this, $id, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$id;
  $3=$ptr;
  var $4=$1;
  var $5=__ZNK8device_t7machineEv($4);
  var $6=__ZN15running_machine9schedulerEv($5);
  var $7=$2;
  var $8=$3;
  var $9=__ZN16device_scheduler11timer_allocER8device_tjPv($6, $4, $7, $8);
  ;
  return $9;
}


function __ZNK12save_manager18registration_countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=__ZNK11simple_listIN12save_manager11state_entryEE5countEv($3);
  ;
  return $4;
}


function __ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_sound_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t11debug_setupEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      $intf=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$intf;
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+52)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      __label__ = 3; break;
    case 3: // $14
      var $15=$intf;
      var $16=__ZNK16device_interface14interface_nextEv($15);
      $intf=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+52)|0);
      var $21=HEAP32[(($20)>>2)];
      FUNCTION_TABLE[$21]($2);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9save_itemIjEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIjEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9save_itemIdEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIdEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t16auto_finder_baseC2ERS_PKc($this, $base, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$base;
  $3=$tag;
  var $4=$1;
  var $5=$4;
  HEAP32[(($5)>>2)]=((__ZTVN8device_t16auto_finder_baseE+8)|0);
  var $6=(($4+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($4+8)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  var $9=$2;
  __ZN8device_t20register_auto_finderERNS_16auto_finder_baseE($9, $4);
  ;
  return;
}


function __ZN8device_t16auto_finder_base11find_deviceERS_PKc($this, $base, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$base;
  $3=$tag;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZNK8device_t9subdeviceEPKc($5, $6);
  ;
  return $7;
}


function __ZNK8device_t9subdeviceEPKc($this, $_tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$_tag;
      var $7=$2;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 10; break;
    case 2: // $10
      __ZN7astringC1Ev($tempstring);
      var $11=(function() { try { __THREW__ = false; return __ZNK8device_t7mconfigEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $14
      var $15=$13;
      var $16=$3;
      var $17=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($7, $tempstring, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $18
      var $19=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $20
      var $21=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE4findEPKc($15, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $22
      $1=$21;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      __label__ = 10; break;
    case 8: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $27
      __label__ = 11; break;
    case 10: // $28
      var $29=$1;
      STACKTOP = __stackBase__;
      return $29;
    case 11: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t13siblingdeviceEPKc($this, $_tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$_tag;
      var $7=$2;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 10; break;
    case 2: // $10
      __ZN7astringC1Ev($tempstring);
      var $11=(function() { try { __THREW__ = false; return __ZNK8device_t7mconfigEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $14
      var $15=$13;
      var $16=$3;
      var $17=(function() { try { __THREW__ = false; return __ZNK8device_t10siblingtagER7astringPKc($7, $tempstring, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $18
      var $19=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $20
      var $21=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE4findEPKc($15, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $22
      $1=$21;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      __label__ = 10; break;
    case 8: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $27
      __label__ = 11; break;
    case 10: // $28
      var $29=$1;
      STACKTOP = __stackBase__;
      return $29;
    case 11: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI12device_debugEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12device_debugEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12device_debugEEPT_S3_["X"]=1;

function __ZN8device_t16auto_finder_baseD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8device_t16auto_finder_baseD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8device_t16auto_finder_baseD0Ev["X"]=1;

function __ZN16device_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface25interface_config_completeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNK16device_interface24interface_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$options;
  $3=$driver;
  var $4=$1;
  ;
  return 0;
}


function __ZN16device_interface19interface_pre_startEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface20interface_post_startEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface19interface_pre_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface20interface_post_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface18interface_pre_stopEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface19interface_post_stopEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface18interface_pre_saveEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface19interface_post_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface23interface_clock_changedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN16device_interface21interface_debug_setupEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN21delegate_internal_mfpC2IM11device_listFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_interfaceC2ER8device_t($this, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tailptr;
      $1=$this;
      $2=$device;
      var $3=$1;
      var $4=$3;
      HEAP32[(($4)>>2)]=((__ZTV16device_interface+8)|0);
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=$2;
      HEAP32[(($6)>>2)]=$7;
      var $8=$2;
      var $9=(($8+28)|0);
      $tailptr=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$tailptr;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$tailptr;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+4)|0);
      $tailptr=$18;
      __label__ = 1; break;
    case 4: // $19
      var $20=$tailptr;
      HEAP32[(($20)>>2)]=$3;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI8device_tEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI8device_tE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11simple_listIN12save_manager11state_entryEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12save_manager9save_itemIdEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 8, 1);
  ;
  return;
}


function __ZN12save_manager9save_itemIjEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 4, 1);
  ;
  return;
}


function __ZN20resource_pool_objectI12device_debugEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12device_debugEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12device_debugEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1600);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12device_debugE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12device_debugED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12device_debugED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvvEEC2I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I11device_listEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I11device_listEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM11device_listFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=186;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM11device_listFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM11device_listFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI11device_listEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI11device_list, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI8device_tEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI8device_tEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8tagmap_tIP8device_tEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP8device_tEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP8device_tEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN18delegate_late_bindD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18delegate_late_bindD2Ev($2);
  ;
  return;
}


function __ZN16device_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16device_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_interfaceD0Ev["X"]=1;

function __ZN20resource_pool_objectI12device_debugED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12device_debugED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12device_debugED0Ev["X"]=1;

function __ZN20resource_pool_objectI12device_debugED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12device_debugE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debugD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12device_debugED2Ev["X"]=1;

function __ZN18delegate_late_bindD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN18delegate_late_bindD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18delegate_late_bindD0Ev["X"]=1;

function __ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcy($this, $func, $string, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      $1=$this;
      $2=$func;
      $3=$string;
      var $st$7$0=(($4)|0);
      HEAP32[(($st$7$0)>>2)]=$unitmask$0;
      var $st$7$1=(($4+4)|0);
      HEAP32[(($st$7$1)>>2)]=$unitmask$1;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      var $10=(($5+88)|0);
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=6;
      var $12=(($5+88)|0);
      var $13=(($12+4)|0);
      HEAP8[($13)]=8;
      var $st$6$0=(($4)|0);
      var $14$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$6$1)>>2)];
      var $15=(($5+88)|0);
      var $16=(($15+8)|0);
      var $st$12$0=(($16)|0);
      HEAP32[(($st$12$0)>>2)]=$14$0;
      var $st$12$1=(($16+4)|0);
      HEAP32[(($st$12$1)>>2)]=$14$1;
      var $17=$3;
      var $18=(($5+88)|0);
      var $19=(($18+16)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$2;
      var $21=(($5+396)|0);
      HEAP32[(($21)>>2)]=$20;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17address_map_entry20internal_set_handlerEPFvP13address_spacejhEPKcy($this, $func, $string, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      $1=$this;
      $2=$func;
      $3=$string;
      var $st$7$0=(($4)|0);
      HEAP32[(($st$7$0)>>2)]=$unitmask$0;
      var $st$7$1=(($4+4)|0);
      HEAP32[(($st$7$1)>>2)]=$unitmask$1;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      var $10=(($5+176)|0);
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=6;
      var $12=(($5+176)|0);
      var $13=(($12+4)|0);
      HEAP8[($13)]=8;
      var $st$6$0=(($4)|0);
      var $14$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$6$1)>>2)];
      var $15=(($5+176)|0);
      var $16=(($15+8)|0);
      var $st$12$0=(($16)|0);
      HEAP32[(($st$12$0)>>2)]=$14$0;
      var $st$12$1=(($16+4)|0);
      HEAP32[(($st$12$1)>>2)]=$14$1;
      var $17=$3;
      var $18=(($5+176)|0);
      var $19=(($18+16)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$2;
      var $21=(($5+524)|0);
      HEAP32[(($21)>>2)]=$20;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIvR13address_spacejhhE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIvR13address_spacejttE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIjR13address_spacejj8_noparamE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIvR13address_spacejjjE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIyR13address_spacejy8_noparamE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIvR13address_spacejyyE4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN16map_handler_dataC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16map_handler_dataC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFhR13address_spacejhEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFtR13address_spacejtEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFtR13address_spacejtEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFjR13address_spacejjEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFjR13address_spacejjEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFyR13address_spacejyEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFvR13address_spacejhhEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejttEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFvR13address_spacejttEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejjjEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFvR13address_spacejjjEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejyyEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFvR13address_spacejyyEEC2Ev($2);
  ;
  return;
}


function __ZN16map_handler_dataD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16map_handler_dataD2Ev($2);
  ;
  return;
}


function __ZN16map_handler_data7set_tagERK8device_tPKc($this, $device, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$device;
      $3=$tag;
      var $4=$1;
      var $5=$3;
      var $6=_strcmp($5, ((__ZL11DEVICE_SELF2076)|0));
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=__ZNK8device_t3tagEv($9);
      var $11=(($4+20)|0);
      HEAP32[(($11)>>2)]=$10;
      __label__ = 8; break;
    case 2: // $12
      var $13=$3;
      var $14=_strcmp($13, ((STRING_TABLE.__ZL17DEVICE_SELF_OWNER2077)|0));
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$2;
      var $20=__ZNK8device_t5ownerEv($19);
      var $21=__ZNK8device_t3tagEv($20);
      var $22=(($4+20)|0);
      HEAP32[(($22)>>2)]=$21;
      __label__ = 7; break;
    case 6: // $23
      var $24=$2;
      var $25=(($4+24)|0);
      var $26=$3;
      var $27=__ZNK8device_t6subtagER7astringPKc($24, $25, $26);
      var $28=__ZNK7astringcvPKcEv($27);
      var $29=(($4+20)|0);
      HEAP32[(($29)>>2)]=$28;
      __label__ = 7; break;
    case 7: // $30
      __label__ = 8; break;
    case 8: // $31
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_y($this, $rfunc, $rstring, $wfunc, $wstring, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6=__stackBase__;
  $1=$this;
  $2=$rfunc;
  $3=$rstring;
  $4=$wfunc;
  $5=$wstring;
  var $st$11$0=(($6)|0);
  HEAP32[(($st$11$0)>>2)]=$unitmask$0;
  var $st$11$1=(($6+4)|0);
  HEAP32[(($st$11$1)>>2)]=$unitmask$1;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $st$18$0=(($6)|0);
  var $10$0=HEAP32[(($st$18$0)>>2)];
  var $st$18$1=(($6+4)|0);
  var $10$1=HEAP32[(($st$18$1)>>2)];
  __ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcy($7, $8, $9, $10$0, $10$1);
  var $11=$4;
  var $12=$5;
  var $st$25$0=(($6)|0);
  var $13$0=HEAP32[(($st$25$0)>>2)];
  var $st$25$1=(($6+4)|0);
  var $13$1=HEAP32[(($st$25$1)>>2)];
  __ZN17address_map_entry20internal_set_handlerEPFvP13address_spacejhEPKcy($7, $11, $12, $13$0, $13$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFhPS0_jES4_y($this, $device, $tag, $func, $string, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      $1=$this;
      $2=$device;
      $3=$tag;
      $4=$func;
      $5=$string;
      var $st$11$0=(($6)|0);
      HEAP32[(($st$11$0)>>2)]=$unitmask$0;
      var $st$11$1=(($6+4)|0);
      HEAP32[(($st$11$1)>>2)]=$unitmask$1;
      var $7=$1;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      __label__ = 4; break;
    case 4: // $11
      var $12=(($7+88)|0);
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=7;
      var $14=(($7+88)|0);
      var $15=(($14+4)|0);
      HEAP8[($15)]=8;
      var $st$6$0=(($6)|0);
      var $16$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($6+4)|0);
      var $16$1=HEAP32[(($st$6$1)>>2)];
      var $17=(($7+88)|0);
      var $18=(($17+8)|0);
      var $st$12$0=(($18)|0);
      HEAP32[(($st$12$0)>>2)]=$16$0;
      var $st$12$1=(($18+4)|0);
      HEAP32[(($st$12$1)>>2)]=$16$1;
      var $19=$5;
      var $20=(($7+88)|0);
      var $21=(($20+16)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=(($7+88)|0);
      var $23=$2;
      var $24=$3;
      __ZN16map_handler_data7set_tagERK8device_tPKc($22, $23, $24);
      var $25=$4;
      var $26=(($7+412)|0);
      HEAP32[(($26)>>2)]=$25;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFvPS0_jhES4_y($this, $device, $tag, $func, $string, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      $1=$this;
      $2=$device;
      $3=$tag;
      $4=$func;
      $5=$string;
      var $st$11$0=(($6)|0);
      HEAP32[(($st$11$0)>>2)]=$unitmask$0;
      var $st$11$1=(($6+4)|0);
      HEAP32[(($st$11$1)>>2)]=$unitmask$1;
      var $7=$1;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      __label__ = 4; break;
    case 4: // $11
      var $12=(($7+176)|0);
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=7;
      var $14=(($7+176)|0);
      var $15=(($14+4)|0);
      HEAP8[($15)]=8;
      var $st$6$0=(($6)|0);
      var $16$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($6+4)|0);
      var $16$1=HEAP32[(($st$6$1)>>2)];
      var $17=(($7+176)|0);
      var $18=(($17+8)|0);
      var $st$12$0=(($18)|0);
      HEAP32[(($st$12$0)>>2)]=$16$0;
      var $st$12$1=(($18+4)|0);
      HEAP32[(($st$12$1)>>2)]=$16$1;
      var $19=$5;
      var $20=(($7+176)|0);
      var $21=(($20+16)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=(($7+176)|0);
      var $23=$2;
      var $24=$3;
      __ZN16map_handler_data7set_tagERK8device_tPKc($22, $23, $24);
      var $25=$4;
      var $26=(($7+540)|0);
      HEAP32[(($26)>>2)]=$25;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_y($this, $device, $tag, $rfunc, $rstring, $wfunc, $wstring, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8=__stackBase__;
  $1=$this;
  $2=$device;
  $3=$tag;
  $4=$rfunc;
  $5=$rstring;
  $6=$wfunc;
  $7=$wstring;
  var $st$15$0=(($8)|0);
  HEAP32[(($st$15$0)>>2)]=$unitmask$0;
  var $st$15$1=(($8+4)|0);
  HEAP32[(($st$15$1)>>2)]=$unitmask$1;
  var $9=$1;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $st$24$0=(($8)|0);
  var $14$0=HEAP32[(($st$24$0)>>2)];
  var $st$24$1=(($8+4)|0);
  var $14$1=HEAP32[(($st$24$1)>>2)];
  __ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFhPS0_jES4_y($9, $10, $11, $12, $13, $14$0, $14$1);
  var $15=$2;
  var $16=$3;
  var $17=$6;
  var $18=$7;
  var $st$33$0=(($8)|0);
  var $19$0=HEAP32[(($st$33$0)>>2)];
  var $st$33$1=(($8+4)|0);
  var $19$1=HEAP32[(($st$33$1)>>2)];
  __ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFvPS0_jhES4_y($9, $15, $16, $17, $18, $19$0, $19$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN17address_map_entry20internal_set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEEy($this, $device, $tag, $func, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      $1=$this;
      $2=$device;
      $3=$tag;
      var $st$7$0=(($4)|0);
      HEAP32[(($st$7$0)>>2)]=$unitmask$0;
      var $st$7$1=(($4+4)|0);
      HEAP32[(($st$7$1)>>2)]=$unitmask$1;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      var $10=(($5+88)|0);
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=5;
      var $12=(($5+88)|0);
      var $13=(($12+4)|0);
      HEAP8[($13)]=8;
      var $st$6$0=(($4)|0);
      var $14$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$6$1)>>2)];
      var $15=(($5+88)|0);
      var $16=(($15+8)|0);
      var $st$12$0=(($16)|0);
      HEAP32[(($st$12$0)>>2)]=$14$0;
      var $st$12$1=(($16+4)|0);
      HEAP32[(($st$12$1)>>2)]=$14$1;
      var $17=$func;
      var $18=__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($17);
      var $19=(($5+88)|0);
      var $20=(($19+16)|0);
      HEAP32[(($20)>>2)]=$18;
      var $21=(($5+88)|0);
      var $22=$2;
      var $23=$3;
      __ZN16map_handler_data7set_tagERK8device_tPKc($21, $22, $23);
      var $24=(($5+300)|0);
      var $25=__ZN8delegateIFhR13address_spacejhEEaSERKS3_($24, $func);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhR13address_spacejhEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIhR13address_spacejh8_noparamEaSERKS3_($5, $7);
  ;
  return $4;
}


function __ZN17address_map_entry20internal_set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEEy($this, $device, $tag, $func, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      $1=$this;
      $2=$device;
      $3=$tag;
      var $st$7$0=(($4)|0);
      HEAP32[(($st$7$0)>>2)]=$unitmask$0;
      var $st$7$1=(($4+4)|0);
      HEAP32[(($st$7$1)>>2)]=$unitmask$1;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      var $10=(($5+176)|0);
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=5;
      var $12=(($5+176)|0);
      var $13=(($12+4)|0);
      HEAP8[($13)]=8;
      var $st$6$0=(($4)|0);
      var $14$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$6$1)>>2)];
      var $15=(($5+176)|0);
      var $16=(($15+8)|0);
      var $st$12$0=(($16)|0);
      HEAP32[(($st$12$0)>>2)]=$14$0;
      var $st$12$1=(($16+4)|0);
      HEAP32[(($st$12$1)>>2)]=$14$1;
      var $17=$func;
      var $18=__ZNK13delegate_baseIvR13address_spacejhhE4nameEv($17);
      var $19=(($5+176)|0);
      var $20=(($19+16)|0);
      HEAP32[(($20)>>2)]=$18;
      var $21=(($5+176)|0);
      var $22=$2;
      var $23=$3;
      __ZN16map_handler_data7set_tagERK8device_tPKc($21, $22, $23);
      var $24=(($5+428)|0);
      var $25=__ZN8delegateIFvR13address_spacejhhEEaSERKS3_($24, $func);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejhhEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvR13address_spacejhhEaSERKS2_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFtR13address_spacejtEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseItR13address_spacejt8_noparamEaSERKS3_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFvR13address_spacejttEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvR13address_spacejttEaSERKS2_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFtR13address_spacejtEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFtR13address_spacejtEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejttEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvR13address_spacejttEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFjR13address_spacejjEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIjR13address_spacejj8_noparamEaSERKS3_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFvR13address_spacejjjEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvR13address_spacejjjEaSERKS2_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFjR13address_spacejjEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFjR13address_spacejjEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejjjEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvR13address_spacejjjEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIyR13address_spacejy8_noparamEaSERKS3_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFvR13address_spacejyyEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvR13address_spacejyyEaSERKS2_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFyR13address_spacejyEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFyR13address_spacejyEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejyyEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvR13address_spacejyyEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZN18address_map_entry8C2ER11address_mapjj($this, $map, $start, $end) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$map;
  $3=$start;
  $4=$end;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN17address_map_entryC2ER11address_mapjj($6, $7, $8, $9);
  ;
  return;
}


function __ZN17address_map_entryC2ER11address_mapjj($this, $map, $start, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$map;
      $3=$start;
      $4=$end;
      var $7=$1;
      var $8=(($7)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=(($7+4)|0);
      var $10=$2;
      HEAP32[(($9)>>2)]=$10;
      var $11=(($7+8)|0);
      __ZN7astringC1Ev($11);
      var $12=(($7+72)|0);
      var $13=$2;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$3;
      var $26 = $18;__label__ = 3; break;
    case 2: // $19
      var $20=$3;
      var $21=$2;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$20 & $23;
      var $26 = $24;__label__ = 3; break;
    case 3: // $25
      var $26;
      HEAP32[(($12)>>2)]=$26;
      var $27=(($7+76)|0);
      var $28=$2;
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $32
      var $33=$4;
      var $41 = $33;__label__ = 6; break;
    case 5: // $34
      var $35=$4;
      var $36=$2;
      var $37=(($36+8)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$35 & $38;
      var $41 = $39;__label__ = 6; break;
    case 6: // $40
      var $41;
      HEAP32[(($27)>>2)]=$41;
      var $42=(($7+80)|0);
      HEAP32[(($42)>>2)]=0;
      var $43=(($7+84)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=(($7+88)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataC1Ev($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 17; break; }
    case 7: // $45
      var $46=(($7+176)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataC1Ev($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 8: // $47
      var $48=(($7+264)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=(($7+268)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($7+272)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=(($7+276)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=(($7+280)|0);
      HEAP32[(($52)>>2)]=0;
      var $53=(($7+284)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=(($7+288)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=(($7+292)|0);
      HEAP32[(($55)>>2)]=0;
      var $56=(($7+296)|0);
      HEAP32[(($56)>>2)]=0;
      var $57=(($7+300)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFhR13address_spacejhEEC1Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 19; break; }
    case 9: // $58
      var $59=(($7+324)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFtR13address_spacejtEEC1Ev($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $60
      var $61=(($7+348)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFjR13address_spacejjEEC1Ev($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $62
      var $63=(($7+372)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFyR13address_spacejyEEC1Ev($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 19; break; }
    case 12: // $64
      var $65=(($7+396)|0);
      HEAP32[(($65)>>2)]=0;
      var $66=(($7+400)|0);
      HEAP32[(($66)>>2)]=0;
      var $67=(($7+404)|0);
      HEAP32[(($67)>>2)]=0;
      var $68=(($7+408)|0);
      HEAP32[(($68)>>2)]=0;
      var $69=(($7+412)|0);
      HEAP32[(($69)>>2)]=0;
      var $70=(($7+416)|0);
      HEAP32[(($70)>>2)]=0;
      var $71=(($7+420)|0);
      HEAP32[(($71)>>2)]=0;
      var $72=(($7+424)|0);
      HEAP32[(($72)>>2)]=0;
      var $73=(($7+428)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejhhEEC1Ev($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $74
      var $75=(($7+452)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejttEEC1Ev($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $76
      var $77=(($7+476)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejjjEEC1Ev($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $78
      var $79=(($7+500)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejyyEEC1Ev($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $80
      var $81=(($7+524)|0);
      HEAP32[(($81)>>2)]=0;
      var $82=(($7+528)|0);
      HEAP32[(($82)>>2)]=0;
      var $83=(($7+532)|0);
      HEAP32[(($83)>>2)]=0;
      var $84=(($7+536)|0);
      HEAP32[(($84)>>2)]=0;
      var $85=(($7+540)|0);
      HEAP32[(($85)>>2)]=0;
      var $86=(($7+544)|0);
      HEAP32[(($86)>>2)]=0;
      var $87=(($7+548)|0);
      HEAP32[(($87)>>2)]=0;
      var $88=(($7+552)|0);
      HEAP32[(($88)>>2)]=0;
      var $89=(($7+556)|0);
      HEAP32[(($89)>>2)]=0;
      var $90=(($7+560)|0);
      HEAP32[(($90)>>2)]=0;
      var $91=(($7+564)|0);
      HEAP32[(($91)>>2)]=0;
      var $92=(($7+568)|0);
      HEAP32[(($92)>>2)]=0;
      var $93=(($7+572)|0);
      HEAP32[(($93)>>2)]=0;
      ;
      return;
    case 17: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      $5=$96;
      var $97=$95.f1;
      $6=$97;
      __label__ = 23; break;
    case 18: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $100=$99.f0;
      $5=$100;
      var $101=$99.f1;
      $6=$101;
      __label__ = 21; break;
    case 19: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $5=$104;
      var $105=$103.f1;
      $6=$105;
      var $106=(($7+176)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataD1Ev($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $107
      __label__ = 21; break;
    case 21: // $108
      var $109=(($7+88)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataD1Ev($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $110
      __label__ = 23; break;
    case 23: // $111
      var $112=(($7+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $113
      __label__ = 25; break;
    case 25: // $114
      var $115=$5;
      var $116=$5;
      var $117=$6;
      var $118=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $116, tempValue);
      var $119=($118.f1 = $117, $118);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17address_map_entryC2ER11address_mapjj["X"]=1;

function __ZNK23device_memory_interface11address_mapE16address_spacenum($this, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$spacenum;
      var $3=$1;
      var $4=$2;
      var $5=(($4)>>>0) < 4;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($3+12)|0);
      var $9=$8;
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11address_map9configureE16address_spacenumh($this, $spacenum, $databits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$spacenum;
      $3=$databits;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=(($4+4)|0);
      var $8=HEAPU8[($7)];
      var $9=(($8)&255);
      var $10=(($9)|0)==255;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=$3;
      var $13=(($4+4)|0);
      HEAP8[($13)]=$12;
      __label__ = 7; break;
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      __label__ = 6; break;
    case 6: // $16
      __label__ = 7; break;
    case 7: // $17
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11address_map15set_global_maskEj($this, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$mask;
  var $3=$1;
  var $4=$2;
  var $5=(($3+8)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN11simple_listI17address_map_entryE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI17address_map_entryEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI17address_map_entryEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK8device_t9interfaceIK23device_memory_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI23device_memory_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI17address_map_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI17address_map_entryED2Ev($2);
  ;
  return;
}


function __ZN11address_mapD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  __ZN11simple_listI17address_map_entryED1Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI18address_map_entry8EC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18address_map_entry8EC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18address_map_entry8EC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 576);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18address_map_entry8E+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18address_map_entry8ED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18address_map_entry8ED2Ev($2);
  ;
  return;
}


function __ZN11address_mapC2ERK8device_t16address_spacenum($this, $device, $spacenum) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $memintf=__stackBase__;
      var $4;
      var $5;
      var $spaceconfig;
      $1=$this;
      $2=$device;
      $3=$spacenum;
      var $6=$1;
      var $7=(($6)|0);
      var $8=$3;
      HEAP32[(($7)>>2)]=$8;
      var $9=(($6+4)|0);
      HEAP8[($9)]=-1;
      var $10=(($6+5)|0);
      HEAP8[($10)]=0;
      var $11=(($6+8)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($6+12)|0);
      __ZN11simple_listI17address_map_entryEC1ER13resource_pool($12, _global_resource_pool);
      var $13=$2;
      var $14=(function() { try { __THREW__ = false; return __ZNK8device_t9interfaceIK23device_memory_interfaceEEbRPT_($13, $memintf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $15
      if ($14) { __label__ = 7; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=___cxa_allocate_exception(1032);
      var $18=$17;
      var $19=$2;
      var $20=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $21
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($18, ((STRING_TABLE.__str32073)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $22
      (function() { try { __THREW__ = false; return ___cxa_throw($17, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 5; break; }
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      __label__ = 27; break;
    case 6: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $4=$29;
      var $30=$28.f1;
      $5=$30;
      ___cxa_free_exception($17);
      __label__ = 27; break;
    case 7: // $31
      var $32=HEAP32[(($memintf)>>2)];
      var $33=$3;
      var $34=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface12space_configE16address_spacenum($32, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; };
    case 8: // $35
      $spaceconfig=$34;
      var $36=$2;
      var $37=(function() { try { __THREW__ = false; return __ZNK8device_t9interfaceIK23device_memory_interfaceEEbRPT_($36, $memintf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 5; break; };
    case 9: // $38
      if ($37) { __label__ = 14; break; } else { __label__ = 10; break; }
    case 10: // $39
      var $40=___cxa_allocate_exception(1032);
      var $41=$40;
      var $42=$2;
      var $43=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $44
      var $45=$3;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($41, ((STRING_TABLE.__str42074)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$43,HEAP32[((tempInt+4)>>2)]=$45,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $46
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 5; break; }
    case 13: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $4=$49;
      var $50=$48.f1;
      $5=$50;
      ___cxa_free_exception($40);
      __label__ = 27; break;
    case 14: // $51
      var $52=$spaceconfig;
      var $53=(($52+16)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $56
      var $57=$spaceconfig;
      var $58=(($57+16)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$59]($6, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 5; break; }
    case 16: // $61
      __label__ = 17; break;
    case 17: // $62
      var $63=HEAP32[(($memintf)>>2)];
      var $64=$3;
      var $65=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface11address_mapE16address_spacenum($63, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 5; break; };
    case 18: // $66
      var $67=(($65)|0)!=0;
      if ($67) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $68
      var $69=HEAP32[(($memintf)>>2)];
      var $70=$3;
      var $71=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface11address_mapE16address_spacenum($69, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 5; break; };
    case 20: // $72
      var $73=$2;
      var $74=(function() { try { __THREW__ = false; return __ZNK8device_t5ownerEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 5; break; };
    case 21: // $75
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($6, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 5; break; }
    case 22: // $76
      __label__ = 23; break;
    case 23: // $77
      var $78=$spaceconfig;
      var $79=(($78+20)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $82
      var $83=$spaceconfig;
      var $84=(($83+20)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$85]($6, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 5; break; }
    case 25: // $87
      __label__ = 26; break;
    case 26: // $88
      STACKTOP = __stackBase__;
      return;
    case 27: // $89
      var $90=(($6+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI17address_map_entryED1Ev($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $91
      __label__ = 29; break;
    case 29: // $92
      var $93=$4;
      var $94=$4;
      var $95=$5;
      var $96=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $94, tempValue);
      var $97=($96.f1 = $95, $96);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 31: // $100
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11address_mapC2ERK8device_t16address_spacenum["X"]=1;

function __ZN11address_map3addEjjP18address_map_entry8($this, $start, $end, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$this;
      $10=$start;
      $11=$end;
      $12=$ptr;
      var $15=$9;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=576;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str52075)|0);
      HEAP32[(($6)>>2)]=772;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$10;
      var $56=$11;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_map_entry8C1ER11address_mapjj]($54, $15, $55, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $57
      var $58=__ZN13resource_pool10add_objectI18address_map_entry8EEPT_S3_(_global_resource_pool, $54);
      $12=$58;
      var $59=(($15+12)|0);
      var $60=$12;
      var $61=$60;
      var $62=__ZN11simple_listI17address_map_entryE6appendERS0_($59, $61);
      var $63=$12;
      STACKTOP = __stackBase__;
      return $63;
    case 9: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      $13=$66;
      var $67=$65.f1;
      $14=$67;
      var $68=$1;
      var $69=$2;
      var $70=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str52075)|0);
      HEAP32[(($3)>>2)]=772;
      var $71=HEAP32[(($1)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $73
      var $74=HEAP32[(($1)>>2)];
      var $75=HEAP32[(($2)>>2)];
      var $76=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($74, $75, $76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $77=$1;
      var $78=$2;
      var $79=$3;
      __label__ = 13; break;
    case 13: // $80
      __label__ = 14; break;
    case 14: // $81
      var $82=$13;
      var $83=$13;
      var $84=$14;
      var $85=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $83, tempValue);
      var $86=($85.f1 = $84, $85);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11address_map3addEjjP18address_map_entry8["X"]=1;

function __ZN13resource_pool10add_objectI18address_map_entry8EEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18address_map_entry8EC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18address_map_entry8EEPT_S3_["X"]=1;

function __ZN17address_map_entryD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+176)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataD1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($4+88)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataD1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($9);
      ;
      return;
    case 3: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=(($4+88)|0);
      (function() { try { __THREW__ = false; return __ZN16map_handler_dataD1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      __label__ = 6; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $22
      __label__ = 8; break;
    case 8: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18address_map_entry8ED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18address_map_entry8ED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18address_map_entry8ED0Ev["X"]=1;

function __ZN11simple_listI17address_map_entryE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI17address_map_entryE6detachERS0_["X"]=1;

function __ZN11simple_listI17address_map_entryEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI17address_map_entryE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN21delegate_internal_mfpaSERKS_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      __label__ = 2; break;
    case 2: // $15
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18address_map_entry8D1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18address_map_entry8D2Ev($2);
  ;
  return;
}


function __ZN18address_map_entry8D2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17address_map_entryD2Ev($3);
  ;
  return;
}


function __ZN11simple_listI17address_map_entryED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI17address_map_entryE+8)|0);
  __ZN11simple_listI17address_map_entryE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI17address_map_entryE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI17address_map_entryE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI17address_map_entryE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI17address_map_entryE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejyyEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvR13address_spacejyyEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejjjEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvR13address_spacejjjEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejttEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvR13address_spacejttEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvR13address_spacejhhEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIyR13address_spacejy8_noparamEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFjR13address_spacejjEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIjR13address_spacejj8_noparamEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFtR13address_spacejtEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseItR13address_spacejt8_noparamEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIhR13address_spacejh8_noparamEC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejyyEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIvR13address_spacejyyEC2ERKS2_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyEC2ERKS2_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIyR13address_spacejy8_noparamEC2ERKS3_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamEC2ERKS3_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyEaSERKS2_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamEaSERKS3_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejjjEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIvR13address_spacejjjEC2ERKS2_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjEC2ERKS2_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN8delegateIFjR13address_spacejjEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIjR13address_spacejj8_noparamEC2ERKS3_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamEC2ERKS3_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjEaSERKS2_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamEaSERKS3_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejttEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIvR13address_spacejttEC2ERKS2_($5, $7);
  ;
  return;
}


function __ZN20resource_pool_objectI18address_map_entry8ED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI18address_map_entry8E+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN18address_map_entry8D1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18address_map_entry8ED2Ev["X"]=1;

function __ZN11simple_listI17address_map_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI17address_map_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI17address_map_entryED0Ev["X"]=1;

function __ZN13delegate_baseIvR13address_spacejttEC2ERKS2_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN8delegateIFtR13address_spacejtEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseItR13address_spacejt8_noparamEC2ERKS3_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamEC2ERKS3_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttEaSERKS2_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseItR13address_spacejt8_noparamEaSERKS3_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvR13address_spacejhhEaSERKS2_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamEaSERKS3_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16map_handler_dataD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN16map_handler_dataC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP8[($4)]=0;
  var $5=(($2+8)|0);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $st$10$0=(($5)|0);
  HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
  var $st$10$1=(($5+4)|0);
  HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
  var $6=(($2+16)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+24)|0);
  __ZN7astringC1Ev($8);
  ;
  return;
}


function __ZN22device_image_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$mconfig;
      $3=$device;
      var $6=$1;
      var $7=$6;
      var $8=$3;
      __ZN16device_interfaceC2ER8device_t($7, $8);
      var $9=$6;
      HEAP32[(($9)>>2)]=((__ZTV22device_image_interface+8)|0);
      var $10=(($6+16)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $11
      var $12=(($6+80)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=(($6+84)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($6+88)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $15
      var $16=(($6+152)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $17
      var $18=(($6+216)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $19
      var $20=(($6+280)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 17; break; }
    case 5: // $21
      var $22=(($6+344)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 18; break; }
    case 6: // $23
      var $24=(($6+408)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($6+412)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($6+416)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=(($6+420)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 19; break; }
    case 7: // $28
      var $29=(($6+484)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 20; break; }
    case 8: // $30
      var $31=(($6+548)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 21; break; }
    case 9: // $32
      var $33=(($6+616)|0);
      HEAP8[($33)]=0;
      var $34=(($6+617)|0);
      HEAP8[($34)]=0;
      var $35=(($6+628)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 22; break; }
    case 10: // $36
      var $37=(($6+712)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 23; break; }
    case 11: // $38
      var $39=(($6+776)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 24; break; }
    case 12: // $40
      var $41=(($6+840)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=(($6+844)|0);
      HEAP8[($42)]=0;
      ;
      return;
    case 13: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $4=$45;
      var $46=$44.f1;
      $5=$46;
      __label__ = 46; break;
    case 14: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $4=$49;
      var $50=$48.f1;
      $5=$50;
      __label__ = 44; break;
    case 15: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $4=$53;
      var $54=$52.f1;
      $5=$54;
      __label__ = 42; break;
    case 16: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $4=$57;
      var $58=$56.f1;
      $5=$58;
      __label__ = 40; break;
    case 17: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      $4=$61;
      var $62=$60.f1;
      $5=$62;
      __label__ = 38; break;
    case 18: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      $4=$65;
      var $66=$64.f1;
      $5=$66;
      __label__ = 36; break;
    case 19: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $4=$69;
      var $70=$68.f1;
      $5=$70;
      __label__ = 34; break;
    case 20: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $4=$73;
      var $74=$72.f1;
      $5=$74;
      __label__ = 32; break;
    case 21: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      $4=$77;
      var $78=$76.f1;
      $5=$78;
      __label__ = 30; break;
    case 22: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $81=$80.f0;
      $4=$81;
      var $82=$80.f1;
      $5=$82;
      __label__ = 28; break;
    case 23: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $4=$85;
      var $86=$84.f1;
      $5=$86;
      __label__ = 26; break;
    case 24: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      $4=$89;
      var $90=$88.f1;
      $5=$90;
      var $91=(($6+712)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 49; break; }
    case 25: // $92
      __label__ = 26; break;
    case 26: // $93
      var $94=(($6+628)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 49; break; }
    case 27: // $95
      __label__ = 28; break;
    case 28: // $96
      var $97=(($6+548)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 49; break; }
    case 29: // $98
      __label__ = 30; break;
    case 30: // $99
      var $100=(($6+484)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 49; break; }
    case 31: // $101
      __label__ = 32; break;
    case 32: // $102
      var $103=(($6+420)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 49; break; }
    case 33: // $104
      __label__ = 34; break;
    case 34: // $105
      var $106=(($6+344)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 49; break; }
    case 35: // $107
      __label__ = 36; break;
    case 36: // $108
      var $109=(($6+280)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 49; break; }
    case 37: // $110
      __label__ = 38; break;
    case 38: // $111
      var $112=(($6+216)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 49; break; }
    case 39: // $113
      __label__ = 40; break;
    case 40: // $114
      var $115=(($6+152)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 49; break; }
    case 41: // $116
      __label__ = 42; break;
    case 42: // $117
      var $118=(($6+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 49; break; }
    case 43: // $119
      __label__ = 44; break;
    case 44: // $120
      var $121=(($6+16)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 49; break; }
    case 45: // $122
      __label__ = 46; break;
    case 46: // $123
      var $124=$6;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 47: // $125
      __label__ = 48; break;
    case 48: // $126
      var $127=$4;
      var $128=$4;
      var $129=$5;
      var $130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $128, tempValue);
      var $131=($130.f1 = $129, $130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interfaceC2ERK14machine_configR8device_t["X"]=1;

function __ZN22device_image_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN22device_image_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interfaceD0Ev["X"]=1;

function __ZN22device_image_interface16find_device_typeE10iodevice_t($type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $i;
      $2=$type;
      $i=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$i;
      var $5=(($4)>>>0) < 15;
      if ($5) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $6
      var $7=$i;
      var $8=((__ZN22device_image_interface19m_device_info_arrayE+$7*12)|0);
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=(($10)|0)==(($11)|0);
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$i;
      var $15=((__ZN22device_image_interface19m_device_info_arrayE+$14*12)|0);
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$i;
      var $19=(($18+1)|0);
      $i=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13memory_region5bytesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+76)|0);
      var $6=HEAP32[(($5)>>2)];
      var $9 = $6;__label__ = 3; break;
    case 2: // $7
      var $9 = 0;__label__ = 3; break;
    case 3: // $8
      var $9;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface15device_typenameE10iodevice_t($type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $info;
      $1=$type;
      var $2=$1;
      var $3=__ZN22device_image_interface16find_device_typeE10iodevice_t($2);
      $info=$3;
      var $4=$info;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$info;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface20device_brieftypenameE10iodevice_t($type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $info;
      $1=$type;
      var $2=$1;
      var $3=__ZN22device_image_interface16find_device_typeE10iodevice_t($2);
      $info=$3;
      var $4=$info;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$info;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22device_image_interface19device_compute_hashER15hash_collectionPKvjPKc($this, $hashes, $data, $length, $types) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $partialhash;
      $1=$this;
      $2=$hashes;
      $3=$data;
      $4=$length;
      $5=$types;
      var $6=$1;
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+92)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=FUNCTION_TABLE[$10]($6);
      $partialhash=$11;
      var $12=$partialhash;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$partialhash;
      var $16=$2;
      var $17=$3;
      var $18=$4;
      var $19=$5;
      FUNCTION_TABLE[$15]($16, $17, $18, $19);
      __label__ = 3; break;
    case 2: // $20
      var $21=$2;
      var $22=$3;
      var $23=$4;
      var $24=$5;
      __ZN15hash_collection7computeEPKhjPKc($21, $22, $23, $24);
      __label__ = 3; break;
    case 3: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface18set_image_filenameEPKc($this, $filename) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $loc1;
      var $loc2;
      var $loc3;
      var $loc;
      $1=$this;
      $2=$filename;
      var $3=$1;
      var $4=(($3+88)|0);
      var $5=$2;
      var $6=__ZN7astringaSEPKc($4, $5);
      var $7=(($3+344)|0);
      var $8=$2;
      var $9=__Z14zippath_parentP7astringPKc($7, $8);
      var $10=(($3+152)|0);
      var $11=(($3+88)|0);
      var $12=__ZN7astring3cpyERKS_($10, $11);
      var $13=(($3+88)|0);
      var $14=__ZNK7astring4rchrEii($13, 0, 92);
      $loc1=$14;
      var $15=(($3+88)|0);
      var $16=__ZNK7astring4rchrEii($15, 0, 47);
      $loc2=$16;
      var $17=(($3+88)|0);
      var $18=__ZNK7astring4rchrEii($17, 0, 58);
      $loc3=$18;
      var $19=$loc1;
      var $20=$loc2;
      var $21=$loc3;
      var $22=(($20)|0) > (($21)|0);
      var $23=$loc2;
      var $24=$loc3;
      var $25=$22 ? $23 : $24;
      var $26=(($19)|0) > (($25)|0);
      if ($26) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      var $28=$loc1;
      var $37 = $28;__label__ = 3; break;
    case 2: // $29
      var $30=$loc2;
      var $31=$loc3;
      var $32=(($30)|0) > (($31)|0);
      var $33=$loc2;
      var $34=$loc3;
      var $35=$32 ? $33 : $34;
      var $37 = $35;__label__ = 3; break;
    case 3: // $36
      var $37;
      $loc=$37;
      var $38=$loc;
      var $39=(($38)|0)!=-1;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=(($3+152)|0);
      var $42=(($3+152)|0);
      var $43=$loc;
      var $44=(($43+1)|0);
      var $45=(($3+152)|0);
      var $46=__ZNK7astring3lenEv($45);
      var $47=$loc;
      var $48=(($46-$47)|0);
      var $49=__ZN7astring6substrEii($42, $44, $48);
      var $50=__ZN7astringaSERKS_($41, $49);
      __label__ = 5; break;
    case 5: // $51
      var $52=(($3+216)|0);
      var $53=(($3+152)|0);
      var $54=(($3+152)|0);
      var $55=__ZN7astring3cpyERKS_($53, $54);
      var $56=__ZN7astringaSERKS_($52, $55);
      var $57=(($3+280)|0);
      var $58=__ZN7astringaSEPKc($57, ((__str302123)|0));
      var $59=(($3+216)|0);
      var $60=__ZNK7astring4rchrEii($59, 0, 46);
      $loc=$60;
      var $61=$loc;
      var $62=(($61)|0)!=-1;
      if ($62) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $63
      var $64=(($3+216)|0);
      var $65=(($3+216)|0);
      var $66=$loc;
      var $67=__ZN7astring6substrEii($65, 0, $66);
      var $68=__ZN7astringaSERKS_($64, $67);
      var $69=(($3+280)|0);
      var $70=(($3+152)|0);
      var $71=(($3+152)|0);
      var $72=__ZN7astring3cpyERKS_($70, $71);
      var $73=__ZN7astringaSERKS_($69, $72);
      var $74=(($3+280)|0);
      var $75=(($3+280)|0);
      var $76=$loc;
      var $77=(($76+1)|0);
      var $78=(($3+280)|0);
      var $79=__ZNK7astring3lenEv($78);
      var $80=$loc;
      var $81=(($79-$80)|0);
      var $82=__ZN7astring6substrEii($75, $77, $81);
      var $83=__ZN7astringaSERKS_($74, $82);
      __label__ = 7; break;
    case 7: // $84
      ;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface18set_image_filenameEPKc["X"]=1;

function __ZNK7astring4rchrEii($this, $start, $ch) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$start;
  $3=$ch;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z12astring_rchrPK7astringii($4, $5, $6);
  ;
  return $7;
}


function __ZN7astringaSERKS_($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=__ZN7astring3cpyERKS_($3, $4);
  ;
  return $5;
}


function __ZN7astring6substrEii($this, $start, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$start;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z14astring_substrP7astringii($4, $5, $6);
  ;
  return $7;
}


function __ZN22device_image_interface28device_get_creatable_formatsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK22device_image_interface10formatlistEv($2);
  ;
  return $3;
}


function __ZN22device_image_interface11clear_errorEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+12)|0);
      HEAP32[(($3)>>2)]=0;
      var $4=(($2+16)|0);
      var $5=__ZN7astringcvbEv($4);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+16)|0);
      var $8=__ZN7astring5resetEv($7);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface5errorEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=__ZN7astringcvbEv($3);
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=(($2+16)|0);
      var $7=__ZNK7astring4cstrEv($6);
      var $14 = $7;__label__ = 3; break;
    case 2: // $8
      var $9=(($2+12)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=((__ZL8messages+($10<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface8basenameEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+152)|0);
      var $5=__ZN7astringcvbEv($4);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      $1=0;
      __label__ = 3; break;
    case 2: // $7
      var $8=(($3+152)|0);
      var $9=__ZNK7astringcvPKcEv($8);
      $1=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$1;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface28try_change_working_directoryEPKc($this, $subdir) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $directory;
      var $entry;
      var $success;
      var $done;
      $1=$this;
      $2=$subdir;
      var $3=$1;
      $success=0;
      $done=0;
      var $4=(($3+344)|0);
      var $5=__ZNK7astring4cstrEv($4);
      var $6=_osd_opendir($5);
      $directory=$6;
      var $7=$directory;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$done;
      var $12=(($11) & 1);
      if ($12) { var $18 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$directory;
      var $15=_osd_readdir($14);
      $entry=$15;
      var $16=(($15)|0)!=0;
      var $18 = $16;__label__ = 4; break;
    case 4: // $17
      var $18;
      if ($18) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $19
      var $20=$2;
      var $21=$entry;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__Z12core_stricmpPKcS0_($20, $23);
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $26
      $done=1;
      var $27=$entry;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==2;
      var $31=(($30)&1);
      $success=$31;
      __label__ = 7; break;
    case 7: // $32
      __label__ = 2; break;
    case 8: // $33
      var $34=$directory;
      _osd_closedir($34);
      __label__ = 9; break;
    case 9: // $35
      var $36=$success;
      var $37=(($36) & 1);
      if ($37) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      var $39=(($3+344)|0);
      var $40=(($3+344)|0);
      var $41=__ZNK7astringcvPKcEv($40);
      var $42=$2;
      var $43=__Z15zippath_combineP7astringPKcS2_($39, $41, $42);
      __label__ = 11; break;
    case 11: // $44
      var $45=$success;
      var $46=(($45) & 1);
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface28try_change_working_directoryEPKc["X"]=1;

function __ZN22device_image_interface23setup_working_directoryEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $dst=__stackBase__;
      var $gamedrv;
      $1=$this;
      var $2=$1;
      HEAP32[(($dst)>>2)]=0;
      var $3=_osd_get_full_path($dst, ((STRING_TABLE.__str322125)|0));
      var $4=(($2+344)|0);
      var $5=HEAP32[(($dst)>>2)];
      var $6=__ZN7astringaSEPKc($4, $5);
      var $7=__ZN22device_image_interface28try_change_working_directoryEPKc($2, ((STRING_TABLE.__str332126)|0));
      if ($7) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $8
      var $9=$2;
      var $10=__ZN16device_interface6deviceEv($9);
      var $11=__ZNK8device_t7machineEv($10);
      var $12=__ZNK15running_machine6systemEv($11);
      var $13=__ZN11driver_list4findERK11game_driver($12);
      $gamedrv=$13;
      __label__ = 2; break;
    case 2: // $14
      var $15=$gamedrv;
      var $16=(($15)|0)!=-1;
      if ($16) { __label__ = 3; break; } else { var $25 = 0;__label__ = 4; break; }
    case 3: // $17
      var $18=$gamedrv;
      var $19=__ZN11driver_list6driverEi($18);
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=__ZN22device_image_interface28try_change_working_directoryEPKc($2, $21);
      var $23=$22 ^ 1;
      var $25 = $23;__label__ = 4; break;
    case 4: // $24
      var $25;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$gamedrv;
      var $28=__ZN11driver_list15compatible_withEi($27);
      $gamedrv=$28;
      __label__ = 2; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=HEAP32[(($dst)>>2)];
      _osd_free($31);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11driver_list4findERK11game_driver($driver) {
  ;
  var __label__;

  var $1;
  $1=$driver;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZN11driver_list4findEPKc($4);
  ;
  return $5;
}


function __ZN11driver_list15compatible_withEi($index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$index;
      var $2=$1;
      var $3=__ZN11driver_list5cloneEi($2);
      $result=$3;
      var $4=$result;
      var $5=(($4)|0)!=-1;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$result;
      var $15 = $7;__label__ = 3; break;
    case 2: // $8
      var $9=$1;
      var $10=__ZN11driver_list6driverEi($9);
      var $11=(($10+40)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__ZN11driver_list4findEPKc($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface17working_directoryEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+344)|0);
      var $4=__ZN7astringcvbEv($3);
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      __ZN22device_image_interface23setup_working_directoryEv($2);
      __label__ = 2; break;
    case 2: // $6
      var $7=(($2+344)|0);
      var $8=__ZNK7astringcvPKcEv($7);
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface19get_software_regionEPKc($this, $tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 256; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $full_tag=__stackBase__;
      $2=$this;
      $3=$tag;
      var $4=$2;
      var $5=(($4+412)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=(($4+416)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $1=0;
      __label__ = 4; break;
    case 3: // $13
      var $14=(($full_tag)|0);
      var $15=$4;
      var $16=__ZN16device_interface6deviceEv($15);
      var $17=__ZNK8device_t3tagEv($16);
      var $18=$3;
      var $19=_sprintf($14, ((STRING_TABLE.__str342127)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,HEAP32[((tempInt+4)>>2)]=$18,tempInt));
      var $20=$4;
      var $21=__ZN16device_interface6deviceEv($20);
      var $22=__ZNK8device_t7machineEv($21);
      var $23=(($full_tag)|0);
      var $24=__ZN15running_machine6regionEPKc($22, $23);
      var $25=__ZNK13memory_region4baseEv($24);
      $1=$25;
      __label__ = 4; break;
    case 4: // $26
      var $27=$1;
      STACKTOP = __stackBase__;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface26get_software_region_lengthEPKc($this, $tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 256; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $full_tag=__stackBase__;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($full_tag)|0);
  var $5=$3;
  var $6=__ZN16device_interface6deviceEv($5);
  var $7=__ZNK8device_t3tagEv($6);
  var $8=$2;
  var $9=_sprintf($4, ((STRING_TABLE.__str342127)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$7,HEAP32[((tempInt+4)>>2)]=$8,tempInt));
  var $10=$3;
  var $11=__ZN16device_interface6deviceEv($10);
  var $12=__ZNK8device_t7machineEv($11);
  var $13=(($full_tag)|0);
  var $14=__ZN15running_machine6regionEPKc($12, $13);
  var $15=__ZNK13memory_region5bytesEv($14);
  STACKTOP = __stackBase__;
  return $15;
}


function __ZN22device_image_interfaceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $formatptr;
      var $entry;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22device_image_interface+8)|0);
      var $6=(($4+840)|0);
      $formatptr=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$formatptr;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=$formatptr;
      var $13=HEAP32[(($12)>>2)];
      $entry=$13;
      var $14=$entry;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$formatptr;
      HEAP32[(($17)>>2)]=$16;
      var $18=$entry;
      var $19=$18;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 1; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $2=$23;
      var $24=$22.f1;
      $3=$24;
      var $25=(($4+776)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 56; break; }
    case 5: // $26
      var $27=(($4+776)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 18; break; }
    case 6: // $28
      var $29=(($4+712)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 20; break; }
    case 7: // $30
      var $31=(($4+628)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 23; break; }
    case 8: // $32
      var $33=(($4+548)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 26; break; }
    case 9: // $34
      var $35=(($4+484)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 29; break; }
    case 10: // $36
      var $37=(($4+420)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 32; break; }
    case 11: // $38
      var $39=(($4+344)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 35; break; }
    case 12: // $40
      var $41=(($4+280)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 38; break; }
    case 13: // $42
      var $43=(($4+216)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 41; break; }
    case 14: // $44
      var $45=(($4+152)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 44; break; }
    case 15: // $46
      var $47=(($4+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 47; break; }
    case 16: // $48
      var $49=(($4+16)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 50; break; }
    case 17: // $50
      var $51=$4;
      __ZN16device_interfaceD2Ev($51);
      ;
      return;
    case 18: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $2=$54;
      var $55=$53.f1;
      $3=$55;
      __label__ = 21; break;
    case 19: // $56
      __label__ = 21; break;
    case 20: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $2=$59;
      var $60=$58.f1;
      $3=$60;
      __label__ = 24; break;
    case 21: // $61
      var $62=(($4+712)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 56; break; }
    case 22: // $63
      __label__ = 24; break;
    case 23: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      $2=$66;
      var $67=$65.f1;
      $3=$67;
      __label__ = 27; break;
    case 24: // $68
      var $69=(($4+628)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 56; break; }
    case 25: // $70
      __label__ = 27; break;
    case 26: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $2=$73;
      var $74=$72.f1;
      $3=$74;
      __label__ = 30; break;
    case 27: // $75
      var $76=(($4+548)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 56; break; }
    case 28: // $77
      __label__ = 30; break;
    case 29: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $80=$79.f0;
      $2=$80;
      var $81=$79.f1;
      $3=$81;
      __label__ = 33; break;
    case 30: // $82
      var $83=(($4+484)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 56; break; }
    case 31: // $84
      __label__ = 33; break;
    case 32: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $87=$86.f0;
      $2=$87;
      var $88=$86.f1;
      $3=$88;
      __label__ = 36; break;
    case 33: // $89
      var $90=(($4+420)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 56; break; }
    case 34: // $91
      __label__ = 36; break;
    case 35: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $94=$93.f0;
      $2=$94;
      var $95=$93.f1;
      $3=$95;
      __label__ = 39; break;
    case 36: // $96
      var $97=(($4+344)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 56; break; }
    case 37: // $98
      __label__ = 39; break;
    case 38: // $99
      var $100=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $101=$100.f0;
      $2=$101;
      var $102=$100.f1;
      $3=$102;
      __label__ = 42; break;
    case 39: // $103
      var $104=(($4+280)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 56; break; }
    case 40: // $105
      __label__ = 42; break;
    case 41: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $108=$107.f0;
      $2=$108;
      var $109=$107.f1;
      $3=$109;
      __label__ = 45; break;
    case 42: // $110
      var $111=(($4+216)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 56; break; }
    case 43: // $112
      __label__ = 45; break;
    case 44: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $2=$115;
      var $116=$114.f1;
      $3=$116;
      __label__ = 48; break;
    case 45: // $117
      var $118=(($4+152)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 56; break; }
    case 46: // $119
      __label__ = 48; break;
    case 47: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $122=$121.f0;
      $2=$122;
      var $123=$121.f1;
      $3=$123;
      __label__ = 51; break;
    case 48: // $124
      var $125=(($4+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 56; break; }
    case 49: // $126
      __label__ = 51; break;
    case 50: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      $2=$129;
      var $130=$128.f1;
      $3=$130;
      __label__ = 53; break;
    case 51: // $131
      var $132=(($4+16)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 56; break; }
    case 52: // $133
      __label__ = 53; break;
    case 53: // $134
      var $135=$4;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 56; break; }
    case 54: // $136
      __label__ = 55; break;
    case 55: // $137
      var $138=$2;
      var $139=$2;
      var $140=$3;
      var $141=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $139, tempValue);
      var $142=($141.f1 = $140, $141);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 56: // $143
      var $144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interfaceD2Ev["X"]=1;

function __ZN22device_image_interface9is_loadedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZN22device_image_interface11get_featureEPKc($this, $feature_name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $feature;
      $2=$this;
      $3=$feature_name;
      var $4=$2;
      var $5=(($4+416)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      $1=0;
      __label__ = 9; break;
    case 2: // $11
      var $12=(($4+416)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      $feature=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$feature;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $19
      var $20=$feature;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$3;
      var $24=_strcmp($22, $23);
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $26
      var $27=$feature;
      var $28=(($27+8)|0);
      var $29=HEAP32[(($28)>>2)];
      $1=$29;
      __label__ = 9; break;
    case 6: // $30
      __label__ = 7; break;
    case 7: // $31
      var $32=$feature;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      $feature=$34;
      __label__ = 3; break;
    case 8: // $35
      $1=0;
      __label__ = 9; break;
    case 9: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface8run_hashEPFvR15hash_collectionPKhmPKcES1_S5_($this, $partialhash, $hashes, $types) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $size;
      var $buf;
      $1=$this;
      $2=$partialhash;
      $3=$hashes;
      $4=$types;
      var $5=$1;
      $buf=0;
      var $6=$3;
      __ZN15hash_collection5resetEv($6);
      var $7=__ZN22device_image_interface6lengthEv($5);
      var $7$0=$7[0];
      var $7$1=$7[1];
      var $8$0=$7$0;
      var $8=$8$0;
      $size=$8;
      var $9=$size;
      var $10=__Z22malloc_array_file_linejPKci($9, ((STRING_TABLE.__str352128)|0), 466);
      $buf=$10;
      var $11=$buf;
      var $12=$size;
      _memset($11, 0, $12, 1);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $13=__ZN22device_image_interface5fseekExi($5, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $13$0=$13[0];
      var $14=$buf;
      var $15=$size;
      var $16=__ZN22device_image_interface5freadEPvj($5, $14, $15);
      var $17=$2;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=$3;
      var $22=$buf;
      var $23=$size;
      var $24=$4;
      FUNCTION_TABLE[$20]($21, $22, $23, $24);
      __label__ = 3; break;
    case 2: // $25
      var $26=$3;
      var $27=$buf;
      var $28=$size;
      var $29=$4;
      __ZN15hash_collection7computeEPKhjPKc($26, $27, $28, $29);
      __label__ = 3; break;
    case 3: // $30
      var $31=$buf;
      __Z14free_file_linePvPKci($31, ((STRING_TABLE.__str352128)|0), 479);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $32=__ZN22device_image_interface5fseekExi($5, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      var $32$0=$32[0];
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface8run_hashEPFvR15hash_collectionPKhmPKcES1_S5_["X"]=1;

function __ZN22device_image_interface15image_checkhashEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $partialhash;
      $1=$this;
      var $2=$1;
      var $3=(($2+628)|0);
      var $4=__ZNK15hash_collection5firstEv($3);
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $6
      var $7=(($2+616)|0);
      var $8=HEAP8[($7)];
      var $9=(($8) & 1);
      if ($9) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $10
      var $11=(($2+617)|0);
      var $12=HEAP8[($11)];
      var $13=(($12) & 1);
      if ($13) { __label__ = 8; break; } else { __label__ = 3; break; }
    case 3: // $14
      var $15=$2;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+96)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=FUNCTION_TABLE[$18]($2);
      var $20=(($19)|0)==14;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      __label__ = 9; break;
    case 5: // $22
      var $23=(($2+412)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      __label__ = 9; break;
    case 7: // $27
      var $28=$2;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+92)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=FUNCTION_TABLE[$31]($2);
      $partialhash=$32;
      var $33=$partialhash;
      var $34=(($2+628)|0);
      var $35=HEAP32[((__ZN15hash_collection14HASH_TYPES_ALLE)>>2)];
      __ZN22device_image_interface8run_hashEPFvR15hash_collectionPKhmPKcES1_S5_($2, $33, $34, $35);
      __label__ = 8; break;
    case 8: // $36
      __label__ = 9; break;
    case 9: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface3crcEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $crc=__stackBase__;
  $1=$this;
  var $2=$1;
  HEAP32[(($crc)>>2)]=0;
  __ZN22device_image_interface15image_checkhashEv($2);
  var $3=(($2+628)|0);
  var $4=__ZNK15hash_collection3crcERj($3, $crc);
  var $5=HEAP32[(($crc)>>2)];
  STACKTOP = __stackBase__;
  return $5;
}


function __ZN22device_image_interface19determine_open_planEiPj($this, $is_create, $open_plan) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $i;
      $1=$this;
      $2=$is_create;
      $3=$open_plan;
      var $4=$1;
      $i=0;
      var $5=$2;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$4;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+100)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=FUNCTION_TABLE[$11]($4);
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+104)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($4);
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$i;
      var $21=(($20+1)|0);
      $i=$21;
      var $22=$3;
      var $23=(($22+($20<<2))|0);
      HEAP32[(($23)>>2)]=3;
      __label__ = 4; break;
    case 4: // $24
      var $25=$2;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $27
      var $28=$4;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+100)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=FUNCTION_TABLE[$31]($4);
      if ($32) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $34=$4;
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+104)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=FUNCTION_TABLE[$37]($4);
      if ($38) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $39
      var $40=$i;
      var $41=(($40+1)|0);
      $i=$41;
      var $42=$3;
      var $43=(($42+($40<<2))|0);
      HEAP32[(($43)>>2)]=2;
      __label__ = 8; break;
    case 8: // $44
      var $45=$2;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $47
      var $48=$4;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+100)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=FUNCTION_TABLE[$51]($4);
      if ($52) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $53
      var $54=$i;
      var $55=(($54+1)|0);
      $i=$55;
      var $56=$3;
      var $57=(($56+($54<<2))|0);
      HEAP32[(($57)>>2)]=1;
      __label__ = 11; break;
    case 11: // $58
      var $59=$4;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+104)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=FUNCTION_TABLE[$62]($4);
      if ($63) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $64
      var $65=$4;
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+108)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=FUNCTION_TABLE[$68]($4);
      if ($69) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $70
      var $71=$i;
      var $72=(($71+1)|0);
      $i=$72;
      var $73=$3;
      var $74=(($73+($71<<2))|0);
      HEAP32[(($74)>>2)]=7;
      __label__ = 14; break;
    case 14: // $75
      var $76=$i;
      var $77=$3;
      var $78=(($77+($76<<2))|0);
      HEAP32[(($78)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface19determine_open_planEiPj["X"]=1;

function __ZN22device_image_interface18load_image_by_pathEjPKc($this, $open_flags, $path) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $filerr;
      var $err;
      var $revised_path=__stackBase__;
      var $5;
      var $6;
      var $7;
      $2=$this;
      $3=$open_flags;
      $4=$path;
      var $8=$2;
      $filerr=3;
      $err=4;
      __ZN7astringC1Ev($revised_path);
      var $9=$4;
      var $10=$3;
      var $11=(($8+80)|0);
      var $12=(function() { try { __THREW__ = false; return __Z13zippath_fopenPKcjPP10_core_fileP7astring($9, $10, $11, $revised_path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $13
      $filerr=$12;
      var $14=$filerr;
      if ($14 == 0) {
        __label__ = 3; break;
      }
      else if ($14 == 3 || $14 == 4) {
        __label__ = 4; break;
      }
      else if ($14 == 2) {
        __label__ = 5; break;
      }
      else if ($14 == 5) {
        __label__ = 6; break;
      }
      else if ($14 == 1 || $14 == 6 || $14 == 7) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 2: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $5=$17;
      var $18=$16.f1;
      $6=$18;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($revised_path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 3: // $19
      var $20=$3;
      var $21=$20 & 2;
      var $22=(($21)|0)!=0;
      var $23=$22 ? 0 : 1;
      var $24=(($23)|0)!=0;
      var $25=(($8+616)|0);
      var $26=(($24)&1);
      HEAP8[($25)]=$26;
      var $27=$3;
      var $28=$27 & 4;
      var $29=(($28)|0)!=0;
      var $30=$29 ? 1 : 0;
      var $31=(($30)|0)!=0;
      var $32=(($8+617)|0);
      var $33=(($31)&1);
      HEAP8[($32)]=$33;
      $err=0;
      __label__ = 9; break;
    case 4: // $34
      $err=4;
      __label__ = 9; break;
    case 5: // $35
      $err=3;
      __label__ = 9; break;
    case 6: // $36
      $err=6;
      __label__ = 9; break;
    case 7: // $37
      __label__ = 8; break;
    case 8: // $38
      $err=1;
      __label__ = 9; break;
    case 9: // $39
      var $40=$filerr;
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $42
      var $43=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($revised_path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 2; break; };
    case 11: // $44
      var $45=(function() { try { __THREW__ = false; return __ZN22device_image_interface18set_image_filenameEPKc($8, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 2; break; };
    case 12: // $46
      __label__ = 13; break;
    case 13: // $47
      var $48=$err;
      $1=$48;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($revised_path);
      var $49=$1;
      STACKTOP = __stackBase__;
      return $49;
    case 14: // $50
      __label__ = 15; break;
    case 15: // $51
      var $52=$5;
      var $53=$5;
      var $54=$6;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface18load_image_by_pathEjPKc["X"]=1;

function __ZN7astring3catERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__ZN7astring3insEiRKS_($3, -1, $4);
  ;
  return $5;
}


function __ZN7astring3delEii($this, $start, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$start;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z11astring_delP7astringii($4, $5, $6);
  ;
  return $7;
}


function __ZN7astringC1ERKS_($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  __ZN7astringC2ERKS_($3, $4);
  ;
  return;
}


function __ZN22device_image_interface13load_softwareEPcS0_P9rom_entry($this, $swlist, $swname, $start) {
  var __stackBase__  = STACKTOP; STACKTOP += 664; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $locationtag=__stackBase__;
      var $breakstr=__stackBase__+64;
      var $6;
      var $7;
      var $region;
      var $regiontag=__stackBase__+128;
      var $retVal;
      var $romp;
      var $filerr;
      var $crc=__stackBase__+192;
      var $has_crc;
      var $8=__stackBase__+196;
      var $software_list_ptr;
      var $swinfo;
      var $tmp=__stackBase__+280;
      var $parentname;
      var $tag2=__stackBase__+344;
      var $tag3=__stackBase__+408;
      var $tag4=__stackBase__+472;
      var $tag5=__stackBase__+536;
      var $separator;
      var $tag1=__stackBase__+600;
      var $9;
      $2=$this;
      $3=$swlist;
      $4=$swname;
      $5=$start;
      var $10=$2;
      __ZN7astringC1Ev($locationtag);
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($breakstr, ((STRING_TABLE.__str392132)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 31; break; }
    case 1: // $11
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 32; break; }
    case 2: // $12
      $retVal=0;
      var $13=$5;
      $region=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$region;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 144; break; }
    case 4: // $17
      var $18=$region;
      var $19=(($18+20)|0);
      $romp=$19;
      __label__ = 5; break;
    case 5: // $20
      var $21=$romp;
      var $22=(($21+16)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23 & 15;
      var $25=(($24)|0)==1;
      if ($25) { var $33 = 1;__label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $26
      var $27=$romp;
      var $28=(($27+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 & 15;
      var $31=(($30)|0)==2;
      var $33 = $31;__label__ = 7; break;
    case 7: // $32
      var $33;
      var $34=$33 ^ 1;
      if ($34) { __label__ = 8; break; } else { __label__ = 141; break; }
    case 8: // $35
      var $36=$romp;
      var $37=(($36+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38 & 15;
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 9; break; } else { __label__ = 140; break; }
    case 9: // $41
      $filerr=3;
      HEAP32[(($crc)>>2)]=0;
      var $42=$romp;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($8, $44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 33; break; }
    case 10: // $45
      var $46=(function() { try { __THREW__ = false; return __ZNK15hash_collection3crcERj($8, $crc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 34; break; };
    case 11: // $47
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 33; break; }
    case 12: // $48
      var $49=(($46)&1);
      $has_crc=$49;
      var $50=$10;
      var $51=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 33; break; };
    case 13: // $52
      var $53=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 33; break; };
    case 14: // $54
      var $55=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 33; break; };
    case 15: // $56
      var $57=$3;
      var $58=(function() { try { __THREW__ = false; return __Z18software_list_openR11emu_optionsPKciPFvS2_E($55, $57, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 33; break; };
    case 16: // $59
      $software_list_ptr=$58;
      var $60=$software_list_ptr;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 17; break; } else { __label__ = 44; break; }
    case 17: // $62
      var $63=$software_list_ptr;
      var $64=$4;
      var $65=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($63, $64, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 33; break; };
    case 18: // $66
      $swinfo=$65;
      __label__ = 19; break;
    case 19: // $67
      var $68=$swinfo;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 20; break; } else { __label__ = 40; break; }
    case 20: // $70
      var $71=$swinfo;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($tmp, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 33; break; }
    case 21: // $74
      var $75=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($locationtag, $tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 36; break; };
    case 22: // $76
      var $77=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($locationtag, $breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 36; break; };
    case 23: // $78
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 33; break; }
    case 24: // $79
      var $80=$10;
      var $81=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 33; break; };
    case 25: // $82
      var $83=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 33; break; };
    case 26: // $84
      var $85=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 33; break; };
    case 27: // $86
      var $87=$3;
      var $88=$swinfo;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return __Z18software_get_cloneR11emu_optionsPcPKc($85, $87, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 33; break; };
    case 28: // $92
      $parentname=$91;
      var $93=$parentname;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 29; break; } else { __label__ = 38; break; }
    case 29: // $95
      var $96=$software_list_ptr;
      var $97=$parentname;
      var $98=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($96, $97, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 33; break; };
    case 30: // $99
      $swinfo=$98;
      __label__ = 39; break;
    case 31: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $6=$102;
      var $103=$101.f1;
      $7=$103;
      __label__ = 151; break;
    case 32: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $106=$105.f0;
      $6=$106;
      var $107=$105.f1;
      $7=$107;
      __label__ = 149; break;
    case 33: // $108
      var $109=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $110=$109.f0;
      $6=$110;
      var $111=$109.f1;
      $7=$111;
      __label__ = 146; break;
    case 34: // $112
      var $113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $114=$113.f0;
      $6=$114;
      var $115=$113.f1;
      $7=$115;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 154; break; }
    case 35: // $116
      __label__ = 146; break;
    case 36: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      $6=$119;
      var $120=$118.f1;
      $7=$120;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 154; break; }
    case 37: // $121
      __label__ = 146; break;
    case 38: // $122
      $swinfo=0;
      __label__ = 39; break;
    case 39: // $123
      __label__ = 19; break;
    case 40: // $124
      var $125=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 33; break; };
    case 41: // $126
      var $127=(($125-1)|0);
      var $128=(function() { try { __THREW__ = false; return __ZN7astring3delEii($locationtag, $127, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 33; break; };
    case 42: // $129
      var $130=$software_list_ptr;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 33; break; }
    case 43: // $131
      __label__ = 44; break;
    case 44: // $132
      var $133=$10;
      var $134=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 33; break; };
    case 45: // $135
      var $136=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 33; break; };
    case 46: // $137
      var $138=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 33; break; };
    case 47: // $139
      var $140=$3;
      var $141=$4;
      var $142=(function() { try { __THREW__ = false; return __Z20software_get_supportR11emu_optionsPcPKc($138, $140, $141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 33; break; };
    case 48: // $143
      var $144=(($142)|0)==1;
      if ($144) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $145
      var $146=$4;
      var $147=$3;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str402133)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$146,HEAP32[((tempInt+4)>>2)]=$147,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 33; break; }
    case 50: // $148
      __label__ = 51; break;
    case 51: // $149
      var $150=$10;
      var $151=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 33; break; };
    case 52: // $152
      var $153=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 33; break; };
    case 53: // $154
      var $155=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 33; break; };
    case 54: // $156
      var $157=$3;
      var $158=$4;
      var $159=(function() { try { __THREW__ = false; return __Z20software_get_supportR11emu_optionsPcPKc($155, $157, $158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 33; break; };
    case 55: // $160
      var $161=(($159)|0)==2;
      if ($161) { __label__ = 56; break; } else { __label__ = 58; break; }
    case 56: // $162
      var $163=$4;
      var $164=$3;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str412134)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$163,HEAP32[((tempInt+4)>>2)]=$164,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 33; break; }
    case 57: // $165
      __label__ = 58; break;
    case 58: // $166
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 33; break; }
    case 59: // $167
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 69; break; }
    case 60: // $168
      (function() { try { __THREW__ = false; return __ZN7astringC1ERKS_($tag4, $locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 70; break; }
    case 61: // $169
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 71; break; }
    case 62: // $170
      var $171=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag4, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 72; break; };
    case 63: // $172
      $separator=$171;
      var $173=$separator;
      var $174=(($173)|0)!=-1;
      if ($174) { __label__ = 64; break; } else { __label__ = 73; break; }
    case 64: // $175
      var $176=$separator;
      var $177=(($176+1)|0);
      var $178=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 72; break; };
    case 65: // $179
      var $180=$separator;
      var $181=(($178-$180)|0);
      var $182=(($181+1)|0);
      var $183=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($tag5, $tag4, $177, $182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 72; break; };
    case 66: // $184
      var $185=$separator;
      var $186=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 72; break; };
    case 67: // $187
      var $188=$separator;
      var $189=(($186-$188)|0);
      var $190=(function() { try { __THREW__ = false; return __ZN7astring3delEii($tag4, $185, $189) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 72; break; };
    case 68: // $191
      __label__ = 73; break;
    case 69: // $192
      var $193=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $194=$193.f0;
      $6=$194;
      var $195=$193.f1;
      $7=$195;
      __label__ = 138; break;
    case 70: // $196
      var $197=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $198=$197.f0;
      $6=$198;
      var $199=$197.f1;
      $7=$199;
      __label__ = 135; break;
    case 71: // $200
      var $201=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $202=$201.f0;
      $6=$202;
      var $203=$201.f1;
      $7=$203;
      __label__ = 132; break;
    case 72: // $204
      var $205=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $206=$205.f0;
      $6=$206;
      var $207=$205.f1;
      $7=$207;
      __label__ = 129; break;
    case 73: // $208
      var $209=$3;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($tag1, $209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 72; break; }
    case 74: // $210
      var $211=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tag1, ((STRING_TABLE.__str362129)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 85; break; };
    case 75: // $212
      var $213=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($tag1, $tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 85; break; };
    case 76: // $214
      var $215=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($tag2, $213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 85; break; };
    case 77: // $216
      var $217=$3;
      var $218=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tag1, $217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 85; break; };
    case 78: // $219
      var $220=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tag1, ((STRING_TABLE.__str362129)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 85; break; };
    case 79: // $221
      var $222=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($tag1, $tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 85; break; };
    case 80: // $223
      var $224=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($tag3, $222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 85; break; };
    case 81: // $225
      var $226=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag5, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 85; break; };
    case 82: // $227
      var $228=(($226)|0)!=-1;
      if ($228) { __label__ = 83; break; } else { __label__ = 86; break; }
    case 83: // $229
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str422135)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $230
      throw "Reached an unreachable!"
    case 85: // $231
      var $232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $233=$232.f0;
      $6=$233;
      var $234=$232.f1;
      $7=$234;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 154; break; }
    case 86: // $235
      var $236=(($10+84)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=(($237)|0)==0;
      if ($238) { __label__ = 87; break; } else { __label__ = 95; break; }
    case 87: // $239
      var $240=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 85; break; };
    case 88: // $241
      var $242=(($240)|0)!=0;
      if ($242) { __label__ = 89; break; } else { __label__ = 95; break; }
    case 89: // $243
      var $244=$10;
      var $245=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 85; break; };
    case 90: // $246
      var $247=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($245) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 85; break; };
    case 91: // $248
      var $249=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($247) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 85; break; };
    case 92: // $250
      var $251=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 85; break; };
    case 93: // $252
      var $253=$has_crc;
      var $254=(($253) & 1);
      var $255=HEAP32[(($crc)>>2)];
      var $256=$romp;
      var $257=(($10+84)|0);
      var $258=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($249, $251, $254, $255, $256, $257) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 85; break; };
    case 94: // $259
      $filerr=$258;
      __label__ = 95; break;
    case 95: // $260
      var $261=(($10+84)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(($262)|0)==0;
      if ($263) { __label__ = 96; break; } else { __label__ = 104; break; }
    case 96: // $264
      var $265=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 85; break; };
    case 97: // $266
      var $267=(($265)|0)!=0;
      if ($267) { __label__ = 98; break; } else { __label__ = 104; break; }
    case 98: // $268
      var $269=$10;
      var $270=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 85; break; };
    case 99: // $271
      var $272=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($270) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 85; break; };
    case 100: // $273
      var $274=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($272) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 101; break; } else { __label__ = 85; break; };
    case 101: // $275
      var $276=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 85; break; };
    case 102: // $277
      var $278=$has_crc;
      var $279=(($278) & 1);
      var $280=HEAP32[(($crc)>>2)];
      var $281=$romp;
      var $282=(($10+84)|0);
      var $283=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($274, $276, $279, $280, $281, $282) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 85; break; };
    case 103: // $284
      $filerr=$283;
      __label__ = 104; break;
    case 104: // $285
      var $286=(($10+84)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      if ($288) { __label__ = 105; break; } else { __label__ = 113; break; }
    case 105: // $289
      var $290=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 85; break; };
    case 106: // $291
      var $292=(($290)|0)!=0;
      if ($292) { __label__ = 107; break; } else { __label__ = 113; break; }
    case 107: // $293
      var $294=$10;
      var $295=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($294) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 85; break; };
    case 108: // $296
      var $297=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($295) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 85; break; };
    case 109: // $298
      var $299=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($297) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 85; break; };
    case 110: // $300
      var $301=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 85; break; };
    case 111: // $302
      var $303=$has_crc;
      var $304=(($303) & 1);
      var $305=HEAP32[(($crc)>>2)];
      var $306=$romp;
      var $307=(($10+84)|0);
      var $308=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($299, $301, $304, $305, $306, $307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 85; break; };
    case 112: // $309
      $filerr=$308;
      __label__ = 113; break;
    case 113: // $310
      var $311=(($10+84)|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=(($312)|0)==0;
      if ($313) { __label__ = 114; break; } else { __label__ = 122; break; }
    case 114: // $314
      var $315=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 115; break; } else { __label__ = 85; break; };
    case 115: // $316
      var $317=(($315)|0)!=0;
      if ($317) { __label__ = 116; break; } else { __label__ = 122; break; }
    case 116: // $318
      var $319=$10;
      var $320=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($319) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 117; break; } else { __label__ = 85; break; };
    case 117: // $321
      var $322=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($320) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 85; break; };
    case 118: // $323
      var $324=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($322) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 85; break; };
    case 119: // $325
      var $326=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 120; break; } else { __label__ = 85; break; };
    case 120: // $327
      var $328=$has_crc;
      var $329=(($328) & 1);
      var $330=HEAP32[(($crc)>>2)];
      var $331=$romp;
      var $332=(($10+84)|0);
      var $333=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($324, $326, $329, $330, $331, $332) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 85; break; };
    case 121: // $334
      $filerr=$333;
      __label__ = 122; break;
    case 122: // $335
      var $336=$filerr;
      var $337=(($336)|0)==0;
      if ($337) { __label__ = 123; break; } else { __label__ = 125; break; }
    case 123: // $338
      var $339=(($10+84)|0);
      var $340=HEAP32[(($339)>>2)];
      var $341=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 124; break; } else { __label__ = 85; break; };
    case 124: // $342
      var $343=(($10+80)|0);
      HEAP32[(($343)>>2)]=$341;
      $retVal=1;
      __label__ = 125; break;
    case 125: // $344
      $9=6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 126; break; } else { __label__ = 72; break; }
    case 126: // $345
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 128; break; } else { __label__ = 71; break; }
    case 127: // $346
      __label__ = 129; break;
    case 128: // $347
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 131; break; } else { __label__ = 70; break; }
    case 129: // $348
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 130; break; } else { __label__ = 154; break; }
    case 130: // $349
      __label__ = 132; break;
    case 131: // $350
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 134; break; } else { __label__ = 69; break; }
    case 132: // $351
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 133; break; } else { __label__ = 154; break; }
    case 133: // $352
      __label__ = 135; break;
    case 134: // $353
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 137; break; } else { __label__ = 33; break; }
    case 135: // $354
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 154; break; }
    case 136: // $355
      __label__ = 138; break;
    case 137: // $356
      __label__ = 141; break;
    case 138: // $357
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 139; break; } else { __label__ = 154; break; }
    case 139: // $358
      __label__ = 146; break;
    case 140: // $359
      var $360=$romp;
      var $361=(($360+20)|0);
      $romp=$361;
      __label__ = 5; break;
    case 141: // $362
      __label__ = 142; break;
    case 142: // $363
      var $364=$region;
      var $365=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 143; break; } else { __label__ = 33; break; };
    case 143: // $366
      $region=$365;
      __label__ = 3; break;
    case 144: // $367
      var $368=$retVal;
      var $369=(($368) & 1);
      $1=$369;
      $9=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 145; break; } else { __label__ = 32; break; }
    case 145: // $370
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 148; break; } else { __label__ = 31; break; }
    case 146: // $371
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 147; break; } else { __label__ = 154; break; }
    case 147: // $372
      __label__ = 149; break;
    case 148: // $373
      FUNCTION_TABLE[__ZN7astringD1Ev]($locationtag);
      var $374=$1;
      STACKTOP = __stackBase__;
      return $374;
    case 149: // $375
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 150; break; } else { __label__ = 154; break; }
    case 150: // $376
      __label__ = 151; break;
    case 151: // $377
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 154; break; }
    case 152: // $378
      __label__ = 153; break;
    case 153: // $379
      var $380=$6;
      var $381=$6;
      var $382=$7;
      var $383=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $381, tempValue);
      var $384=($383.f1 = $382, $383);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 154: // $385
      var $386=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface13load_softwareEPcS0_P9rom_entry["X"]=1;

function __ZN22device_image_interface9call_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZN22device_image_interface18call_softlist_loadEPcS0_P9rom_entry($this, $swlist, $swname, $start_entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$swlist;
  $3=$swname;
  $4=$start_entry;
  var $5=$1;
  ;
  return 0;
}


function __ZN22device_image_interface11call_createEiP18_option_resolution($this, $format_type, $format_options) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$format_type;
  $3=$format_options;
  var $4=$1;
  ;
  return 0;
}


function __ZN22device_image_interface11call_unloadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN22device_image_interface12call_displayEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN22device_image_interface17call_display_infoEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN22device_image_interface16call_get_devicesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN22device_image_interface24get_device_specific_callEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK22device_image_interface16get_partial_hashEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK22device_image_interface15image_interfaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK15running_machine5phaseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1304)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN22device_image_interface16has_been_createdEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+617)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK22device_image_interface10formatlistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+840)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20address_space_configC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=((STRING_TABLE.__str2165)|0);
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP8[($5)]=0;
  var $6=(($2+9)|0);
  HEAP8[($6)]=0;
  var $7=(($2+10)|0);
  HEAP8[($7)]=0;
  var $8=(($2+11)|0);
  HEAP8[($8)]=0;
  var $9=(($2+12)|0);
  HEAP8[($9)]=0;
  var $10=(($2+16)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($2+20)|0);
  HEAP32[(($11)>>2)]=0;
  ;
  return;
}


function __ZN22device_image_interface6unloadEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZN22device_image_interface9is_loadedEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=$2;
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+72)|0);
      var $8=HEAP32[(($7)>>2)];
      FUNCTION_TABLE[$8]($2);
      __label__ = 2; break;
    case 2: // $9
      __ZN22device_image_interface5clearEv($2);
      __ZN22device_image_interface11clear_errorEv($2);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface11finish_loadEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $err;
      $1=$this;
      var $2=$1;
      $err=0;
      var $3=(($2+844)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $6
      __ZN22device_image_interface15image_checkhashEv($2);
      var $7=(($2+619)|0);
      var $8=HEAP8[($7)];
      var $9=(($8) & 1);
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$2;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+80)|0);
      var $14=HEAP32[(($13)>>2)];
      FUNCTION_TABLE[$14]($2);
      __label__ = 3; break;
    case 3: // $15
      var $16=__ZN22device_image_interface16has_been_createdEv($2);
      if ($16) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $17
      var $18=$2;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+68)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($2+620)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($2+624)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=FUNCTION_TABLE[$21]($2, $23, $25);
      var $27=(($26)&1);
      $err=$27;
      var $28=$err;
      var $29=(($28) & 1);
      if ($29) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $30
      var $31=(($2+12)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $34
      var $35=(($2+12)|0);
      HEAP32[(($35)>>2)]=7;
      __label__ = 7; break;
    case 7: // $36
      __label__ = 8; break;
    case 8: // $37
      __label__ = 14; break;
    case 9: // $38
      var $39=$2;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+60)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=FUNCTION_TABLE[$42]($2);
      var $44=(($43)&1);
      $err=$44;
      var $45=$err;
      var $46=(($45) & 1);
      if ($46) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $47
      var $48=(($2+12)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $51
      var $52=(($2+12)|0);
      HEAP32[(($52)>>2)]=7;
      __label__ = 12; break;
    case 12: // $53
      __label__ = 13; break;
    case 13: // $54
      __label__ = 14; break;
    case 14: // $55
      __label__ = 15; break;
    case 15: // $56
      var $57=(($2+844)|0);
      HEAP8[($57)]=0;
      var $58=(($2+620)|0);
      HEAP32[(($58)>>2)]=0;
      var $59=(($2+624)|0);
      HEAP32[(($59)>>2)]=0;
      var $60=(($2+618)|0);
      HEAP8[($60)]=0;
      var $61=$err;
      var $62=(($61) & 1);
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface11finish_loadEv["X"]=1;

function __ZN22device_image_interface5clearEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+84)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+84)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $9);
      var $10=(($2+84)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($2+80)|0);
      HEAP32[(($11)>>2)]=0;
      __label__ = 5; break;
    case 2: // $12
      var $13=(($2+80)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($2+80)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z11core_fcloseP10_core_file($18);
      var $19=(($2+80)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 4; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=(($2+88)|0);
      var $23=__ZN7astring5resetEv($22);
      var $24=(($2+616)|0);
      HEAP8[($24)]=0;
      var $25=(($2+617)|0);
      HEAP8[($25)]=0;
      var $26=(($2+420)|0);
      var $27=__ZN7astring5resetEv($26);
      var $28=(($2+484)|0);
      var $29=__ZN7astring5resetEv($28);
      var $30=(($2+548)|0);
      var $31=__ZN7astring5resetEv($30);
      var $32=(($2+152)|0);
      var $33=__ZN7astring5resetEv($32);
      var $34=(($2+216)|0);
      var $35=__ZN7astring5resetEv($34);
      var $36=(($2+280)|0);
      var $37=__ZN7astring5resetEv($36);
      var $38=(($2+408)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=(($2+412)|0);
      HEAP32[(($39)>>2)]=0;
      var $40=(($2+416)|0);
      HEAP32[(($40)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface5clearEv["X"]=1;

function __ZN22device_image_interface4loadEPKc($this, $path) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$path;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22device_image_interface13load_internalEPKcbiP18_option_resolution($3, $4, 0, 0, 0);
  ;
  return $5;
}


function __ZN22device_image_interface6createEPKcPK19image_device_formatP18_option_resolution($this, $path, $create_format, $create_args) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $format_index;
      $1=$this;
      $2=$path;
      $3=$create_format;
      $4=$create_args;
      var $5=$1;
      var $6=$3;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      $format_index=$14;
      var $15=$2;
      var $16=$format_index;
      var $17=$4;
      var $18=__ZN22device_image_interface13load_internalEPKcbiP18_option_resolution($5, $15, 1, $16, $17);
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_image_interface12update_namesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $image=__stackBase__;
      var $count;
      var $index;
      var $gotone;
      $1=$this;
      var $2=$1;
      HEAP32[(($image)>>2)]=0;
      $count=0;
      $index=-1;
      var $3=$2;
      var $4=__ZN16device_interface6deviceEv($3);
      var $5=__ZNK8device_t7mconfigEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=__ZNK11device_list5firstIK22device_image_interfaceEEbRPT_($6, $image);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $12
      var $13=HEAP32[(($image)>>2)];
      var $14=(($2)|0)==(($13)|0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$count;
      $index=$16;
      __label__ = 4; break;
    case 4: // $17
      var $18=HEAP32[(($image)>>2)];
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+96)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=FUNCTION_TABLE[$22]($18);
      var $24=$2;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+96)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=FUNCTION_TABLE[$27]($2);
      var $29=(($23)|0)==(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$count;
      var $32=(($31+1)|0);
      $count=$32;
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=HEAP32[(($image)>>2)];
      var $36=$35;
      var $37=__ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_($36, $image);
      var $38=(($37)&1);
      $gotone=$38;
      __label__ = 1; break;
    case 8: // $39
      var $40=$count;
      var $41=(($40)|0) > 1;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      var $43=(($2+776)|0);
      var $44=$2;
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+96)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=FUNCTION_TABLE[$47]($2);
      var $49=__ZN22device_image_interface15device_typenameE10iodevice_t($48);
      var $50=$index;
      var $51=(($50+1)|0);
      var $52=__ZN7astring6printfEPKcz($43, ((STRING_TABLE.__str512144)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,HEAP32[((tempInt+4)>>2)]=$51,tempInt));
      var $53=(($2+712)|0);
      var $54=$2;
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+96)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=FUNCTION_TABLE[$57]($2);
      var $59=__ZN22device_image_interface20device_brieftypenameE10iodevice_t($58);
      var $60=$index;
      var $61=(($60+1)|0);
      var $62=__ZN7astring6printfEPKcz($53, ((STRING_TABLE.__str512144)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$59,HEAP32[((tempInt+4)>>2)]=$61,tempInt));
      __label__ = 11; break;
    case 10: // $63
      var $64=(($2+776)|0);
      var $65=$2;
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+96)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=FUNCTION_TABLE[$68]($2);
      var $70=__ZN22device_image_interface15device_typenameE10iodevice_t($69);
      var $71=__ZN7astringaSEPKc($64, $70);
      var $72=(($2+712)|0);
      var $73=$2;
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+96)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=FUNCTION_TABLE[$76]($2);
      var $78=__ZN22device_image_interface20device_brieftypenameE10iodevice_t($77);
      var $79=__ZN7astringaSEPKc($72, $78);
      __label__ = 11; break;
    case 11: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface12update_namesEv["X"]=1;

function __ZN7astringC2ERKS_($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$3;
  var $5=__ZN7astring4initEv($3);
  var $6=$2;
  var $7=__ZN7astring3cpyERKS_($5, $6);
  ;
  return;
}


function __ZN7astring3insEiRKS_($this, $insbefore, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$insbefore;
  $3=$src;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z11astring_insP7astringiPKS_($4, $5, $6);
  ;
  return $7;
}


function __ZN22device_image_interface13load_internalEPKcbiP18_option_resolution($this, $path, $is_create, $create_format, $create_args) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $open_plan=__stackBase__;
      var $i;
      var $softload;
      var $pathstr=__stackBase__+16;
      var $filename_has_period;
      var $7;
      var $8;
      var $9=__stackBase__+80;
      var $10;
      $2=$this;
      $3=$path;
      var $11=(($is_create)&1);
      $4=$11;
      $5=$create_format;
      $6=$create_args;
      var $12=$2;
      $softload=0;
      var $13=(($12+619)|0);
      HEAP8[($13)]=0;
      var $14=$3;
      __ZN7astringC1EPKc($pathstr, $14);
      var $15=(function() { try { __THREW__ = false; return __ZNK7astring4rchrEii($pathstr, 0, 46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $16
      var $17=(($15)|0)!=-1;
      var $18=$17 ? 1 : 0;
      var $19=(($18)|0)!=0;
      var $20=(($19)&1);
      $filename_has_period=$20;
      (function() { try { __THREW__ = false; return __ZN22device_image_interface6unloadEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $21
      (function() { try { __THREW__ = false; return __ZN22device_image_interface11clear_errorEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $22
      var $23=(($12+844)|0);
      HEAP8[($23)]=1;
      var $24=$3;
      var $25=(function() { try { __THREW__ = false; return __ZN22device_image_interface18set_image_filenameEPKc($12, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $26
      var $27=(($12+12)|0);
      HEAP32[(($27)>>2)]=$25;
      var $28=(($12+12)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $31
      __label__ = 43; break;
    case 6: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $7=$34;
      var $35=$33.f1;
      $8=$35;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($pathstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 84; break; }
    case 7: // $36
      var $37=$filename_has_period;
      var $38=(($37) & 1);
      if ($38) { __label__ = 14; break; } else { __label__ = 8; break; }
    case 8: // $39
      var $40=$3;
      var $41=(($12+412)|0);
      var $42=(($12+416)|0);
      var $43=(($12+408)|0);
      var $44=(function() { try { __THREW__ = false; return __Z18load_software_partP22device_image_interfacePKcPP13software_infoPP13software_partPPc($12, $40, $41, $42, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; };
    case 9: // $45
      var $46=(($44)&1);
      $softload=$46;
      var $47=(($12+412)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $50
      var $51=(($12+412)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $56
      var $57=(($12+412)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(function() { try { __THREW__ = false; return __ZN22device_image_interface18set_image_filenameEPKc($12, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 6; break; };
    case 12: // $62
      var $63=(($12+12)|0);
      HEAP32[(($63)>>2)]=$61;
      __label__ = 13; break;
    case 13: // $64
      var $65=(($12+619)|0);
      HEAP8[($65)]=1;
      __label__ = 14; break;
    case 14: // $66
      var $67=$4;
      var $68=(($67) & 1);
      if ($68) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $69
      var $70=$filename_has_period;
      var $71=(($70) & 1);
      if ($71) { __label__ = 16; break; } else { __label__ = 28; break; }
    case 16: // $72
      var $73=$4;
      var $74=(($73) & 1);
      var $75=(($74)&1);
      var $76=(($open_plan)|0);
      (function() { try { __THREW__ = false; return __ZN22device_image_interface19determine_open_planEiPj($12, $75, $76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 6; break; }
    case 17: // $77
      $i=0;
      __label__ = 18; break;
    case 18: // $78
      var $79=(($12+80)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { var $88 = 0;__label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $82
      var $83=$i;
      var $84=(($open_plan+($83<<2))|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)!=0;
      var $88 = $86;__label__ = 20; break;
    case 20: // $87
      var $88;
      if ($88) { __label__ = 21; break; } else { __label__ = 27; break; }
    case 21: // $89
      var $90=$i;
      var $91=(($open_plan+($90<<2))|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$3;
      var $94=(function() { try { __THREW__ = false; return __ZN22device_image_interface18load_image_by_pathEjPKc($12, $92, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 6; break; };
    case 22: // $95
      var $96=(($12+12)|0);
      HEAP32[(($96)>>2)]=$94;
      var $97=(($12+12)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $100
      var $101=(($12+12)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102)|0)!=4;
      if ($103) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $104
      __label__ = 43; break;
    case 25: // $105
      __label__ = 26; break;
    case 26: // $106
      var $107=$i;
      var $108=(($107+1)|0);
      $i=$108;
      __label__ = 18; break;
    case 27: // $109
      __label__ = 28; break;
    case 28: // $110
      var $111=(($12+412)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $114
      var $115=(($12+420)|0);
      var $116=(($12+412)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($115, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 6; break; };
    case 30: // $121
      var $122=(($12+484)|0);
      var $123=(($12+412)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124+16)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($122, $126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 6; break; };
    case 31: // $128
      var $129=(($12+548)|0);
      var $130=(($12+412)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($131+12)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($129, $133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 6; break; };
    case 32: // $135
      __label__ = 33; break;
    case 33: // $136
      var $137=(function() { try { __THREW__ = false; return __ZN22device_image_interface9is_loadedEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 6; break; };
    case 34: // $138
      if ($137) { __label__ = 37; break; } else { __label__ = 35; break; }
    case 35: // $139
      var $140=$softload;
      var $141=(($140) & 1);
      if ($141) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $142
      var $143=(($12+12)|0);
      HEAP32[(($143)>>2)]=4;
      __label__ = 43; break;
    case 37: // $144
      var $145=$5;
      var $146=(($12+620)|0);
      HEAP32[(($146)>>2)]=$145;
      var $147=$6;
      var $148=(($12+624)|0);
      HEAP32[(($148)>>2)]=$147;
      var $149=(($12+618)|0);
      var $150=HEAP8[($149)];
      var $151=(($150) & 1);
      var $152=(($151)&1);
      var $153=(($152)|0)==0;
      if ($153) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $154
      var $155=(function() { try { __THREW__ = false; return __ZN22device_image_interface11finish_loadEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 6; break; };
    case 39: // $156
      var $157=(($155)&1);
      var $158=(($12+12)|0);
      HEAP32[(($158)>>2)]=$157;
      var $159=(($12+12)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $162
      __label__ = 43; break;
    case 41: // $163
      __label__ = 42; break;
    case 42: // $164
      __label__ = 43; break;
    case 43: // $165
      var $166=(($12+12)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 44; break; } else { __label__ = 58; break; }
    case 44: // $169
      var $170=(($12+618)|0);
      var $171=HEAP8[($170)];
      var $172=(($171) & 1);
      if ($172) { __label__ = 56; break; } else { __label__ = 45; break; }
    case 45: // $173
      var $174=$12;
      var $175=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($174) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 6; break; };
    case 46: // $176
      var $177=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 6; break; };
    case 47: // $178
      var $179=(function() { try { __THREW__ = false; return __ZNK15running_machine5phaseEv($177) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 6; break; };
    case 48: // $180
      var $181=(($179)|0)==3;
      if ($181) { __label__ = 49; break; } else { __label__ = 52; break; }
    case 49: // $182
      var $183=$4;
      var $184=(($183) & 1);
      var $185=$184 ? (((STRING_TABLE.__str442137)|0)) : (((STRING_TABLE.__str452138)|0));
      var $186=$3;
      var $187=(function() { try { __THREW__ = false; return __ZN22device_image_interface5errorEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 6; break; };
    case 50: // $188
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str432136)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,HEAP32[((tempInt+4)>>2)]=$186,HEAP32[((tempInt+8)>>2)]=$187,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 6; break; }
    case 51: // $189
      __label__ = 55; break;
    case 52: // $190
      var $191=$4;
      var $192=(($191) & 1);
      var $193=$192 ? (((STRING_TABLE.__str442137)|0)) : (((STRING_TABLE.__str452138)|0));
      var $194=$3;
      var $195=(function() { try { __THREW__ = false; return __ZN22device_image_interface5errorEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 6; break; };
    case 53: // $196
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str462139)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$193,HEAP32[((tempInt+4)>>2)]=$194,HEAP32[((tempInt+8)>>2)]=$195,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 6; break; }
    case 54: // $197
      __label__ = 55; break;
    case 55: // $198
      __label__ = 56; break;
    case 56: // $199
      (function() { try { __THREW__ = false; return __ZN22device_image_interface5clearEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 6; break; }
    case 57: // $200
      __label__ = 81; break;
    case 58: // $201
      var $202=$12;
      var $203=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 6; break; };
    case 59: // $204
      var $205=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 6; break; };
    case 60: // $206
      (function() { try { __THREW__ = false; return __ZNK15running_machine4timeEv($9, $205) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 6; break; }
    case 61: // $207
      var $208=(function() { try { __THREW__ = false; return __ZgtRK8attotimeS1_($9, __ZN8attotime4zeroE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 6; break; };
    case 62: // $209
      if ($208) { __label__ = 63; break; } else { __label__ = 69; break; }
    case 63: // $210
      var $211=$12;
      var $212=HEAP32[(($211)>>2)];
      var $213=(($212+116)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$214]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 6; break; };
    case 64: // $216
      if ($215) { __label__ = 65; break; } else { __label__ = 69; break; }
    case 65: // $217
      var $218=$12;
      var $219=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($218) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 6; break; };
    case 66: // $220
      var $221=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 6; break; };
    case 67: // $222
      (function() { try { __THREW__ = false; return __ZN15running_machine19schedule_hard_resetEv($221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 6; break; }
    case 68: // $223
      __label__ = 80; break;
    case 69: // $224
      var $225=(($12+618)|0);
      var $226=HEAP8[($225)];
      var $227=(($226) & 1);
      if ($227) { __label__ = 79; break; } else { __label__ = 70; break; }
    case 70: // $228
      var $229=$12;
      var $230=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($229) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 6; break; };
    case 71: // $231
      var $232=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 6; break; };
    case 72: // $233
      var $234=(function() { try { __THREW__ = false; return __ZNK15running_machine5phaseEv($232) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 6; break; };
    case 73: // $235
      var $236=(($234)|0)==3;
      if ($236) { __label__ = 74; break; } else { __label__ = 76; break; }
    case 74: // $237
      var $238=$3;
      var $239=$4;
      var $240=(($239) & 1);
      var $241=$240 ? (((STRING_TABLE.__str482141)|0)) : (((STRING_TABLE.__str492142)|0));
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str472140)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$238,HEAP32[((tempInt+4)>>2)]=$241,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 6; break; }
    case 75: // $242
      __label__ = 78; break;
    case 76: // $243
      var $244=$3;
      var $245=$4;
      var $246=(($245) & 1);
      var $247=$246 ? (((STRING_TABLE.__str482141)|0)) : (((STRING_TABLE.__str492142)|0));
      (function() { try { __THREW__ = false; return __Z16mame_printf_infoPKcz(((STRING_TABLE.__str502143)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$244,HEAP32[((tempInt+4)>>2)]=$247,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 6; break; }
    case 77: // $248
      __label__ = 78; break;
    case 78: // $249
      __label__ = 79; break;
    case 79: // $250
      __label__ = 80; break;
    case 80: // $251
      __label__ = 81; break;
    case 81: // $252
      var $253=(($12+12)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($254)|0)!=0;
      var $256=$255 ? 1 : 0;
      var $257=(($256)|0)!=0;
      $1=$257;
      $10=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($pathstr);
      var $258=$1;
      STACKTOP = __stackBase__;
      return $258;
    case 82: // $259
      __label__ = 83; break;
    case 83: // $260
      var $261=$7;
      var $262=$7;
      var $263=$8;
      var $264=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $262, tempValue);
      var $265=($264.f1 = $263, $264);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 84: // $266
      var $267=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_image_interface13load_internalEPKcbiP18_option_resolution["X"]=1;

function __ZN23device_memory_interface16memory_translateE16address_spacenumiRj($this, $spacenum, $intention, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$spacenum;
  $3=$intention;
  $4=$address;
  var $5=$1;
  ;
  return 1;
}


function __ZN23device_memory_interface11memory_readE16address_spacenumjiRy($this, $spacenum, $offset, $size, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$spacenum;
  $3=$offset;
  $4=$size;
  $5=$value;
  var $6=$1;
  ;
  return 0;
}


function __ZN23device_memory_interface13memory_readopEjiRy($this, $offset, $size, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$offset;
  $3=$size;
  $4=$value;
  var $5=$1;
  ;
  return 0;
}


function __ZN23device_memory_interface17set_address_spaceE16address_spacenumR13address_space($this, $spacenum, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$spacenum;
      $3=$space;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$3;
      var $8=$2;
      var $9=(($4+28)|0);
      var $10=(($9+($8<<2))|0);
      HEAP32[(($10)>>2)]=$7;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN23device_memory_interface12memory_writeE16address_spacenumjiy($this, $spacenum, $offset, $size, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  $1=$this;
  $2=$spacenum;
  $3=$offset;
  $4=$size;
  var $st$9$0=(($5)|0);
  HEAP32[(($st$9$0)>>2)]=$value$0;
  var $st$9$1=(($5+4)|0);
  HEAP32[(($st$9$1)>>2)]=$value$1;
  var $6=$1;
  STACKTOP = __stackBase__;
  return 0;
}


function __ZN23device_memory_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$mconfig;
  $3=$device;
  var $4=$1;
  var $5=$4;
  var $6=$3;
  __ZN16device_interfaceC2ER8device_t($5, $6);
  var $7=$4;
  HEAP32[(($7)>>2)]=((__ZTV23device_memory_interface+8)|0);
  var $8=(($4+12)|0);
  var $9=$8;
  var $10=(($9)|0);
  var $11=$10;
  for (var $$dest = $11, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
    HEAP8[$$dest] = 0
  };
  var $12=(($4+28)|0);
  var $13=(($12)|0);
  var $14=$13;
  for (var $$dest = $14, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
    HEAP8[$$dest] = 0
  };
  var $15=$3;
  var $16=(($15+12)|0);
  HEAP32[(($16)>>2)]=$4;
  ;
  return;
}


function __ZN23device_memory_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN16device_interfaceD2Ev($3);
  ;
  return;
}


function __ZN23device_memory_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN23device_memory_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN23device_memory_interfaceD0Ev["X"]=1;

function __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($device, $spacenum, $map) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $memory=__stackBase__;
      var $4;
      var $5;
      $1=$device;
      $2=$spacenum;
      $3=$map;
      var $6=$1;
      var $7=__ZN8device_t9interfaceERP23device_memory_interface($6, $memory);
      if ($7) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=___cxa_allocate_exception(1032);
      var $10=$9;
      var $11=$1;
      var $12=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $13
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($10, ((STRING_TABLE.__str12166)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$12,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      ___cxa_throw($9, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $4=$17;
      var $18=$16.f1;
      $5=$18;
      ___cxa_free_exception($9);
      __label__ = 11; break;
    case 5: // $19
      var $20=$2;
      var $21=(($20)>>>0) >= 4;
      if ($21) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $22
      var $23=___cxa_allocate_exception(1032);
      var $24=$23;
      var $25=$1;
      var $26=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $27
      var $28=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($24, ((STRING_TABLE.__str22167)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=$28,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $29
      ___cxa_throw($23, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $4=$32;
      var $33=$31.f1;
      $5=$33;
      ___cxa_free_exception($23);
      __label__ = 11; break;
    case 10: // $34
      var $35=$3;
      var $36=$2;
      var $37=HEAP32[(($memory)>>2)];
      var $38=(($37+12)|0);
      var $39=$38;
      var $40=(($39+($36<<2))|0);
      HEAP32[(($40)>>2)]=$35;
      STACKTOP = __stackBase__;
      return;
    case 11: // $41
      var $42=$4;
      var $43=$4;
      var $44=$5;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E["X"]=1;

function __ZNK23device_memory_interface24interface_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  var __stackBase__  = STACKTOP; STACKTOP += 168; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $detected_overlap;
      var $error;
      var $spacenum=__stackBase__+36;
      var $spaceconfig;
      var $datawidth;
      var $alignunit;
      var $map;
      var $12;
      var $13;
      var $entry;
      var $bytestart;
      var $byteend;
      var $scan;
      var $found;
      var $source;
      var $romp;
      var $regiontag;
      var $fulltag=__stackBase__+40;
      var $regiontag1=__stackBase__+104;
      var $length;
      $9=$this;
      $10=$options;
      $11=$driver;
      var $14=$9;
      $detected_overlap=1;
      $error=0;
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 1; break;
    case 1: // $15
      var $16=HEAP32[(($spacenum)>>2)];
      var $17=(($16)|0) < 4;
      if ($17) { __label__ = 2; break; } else { __label__ = 109; break; }
    case 2: // $18
      var $19=HEAP32[(($spacenum)>>2)];
      var $20=__ZNK23device_memory_interface12space_configE16address_spacenum($14, $19);
      $spaceconfig=$20;
      var $21=$spaceconfig;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 107; break; }
    case 3: // $23
      var $24=$spaceconfig;
      var $25=(($24+8)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      $datawidth=$27;
      var $28=$datawidth;
      var $29=(((($28)|0)/8)|0);
      $alignunit=$29;
      var $30=$4;
      var $31=$5;
      var $32=$6;
      var $33=$result_i;
      var $34=$7;
      var $35=$8;
      HEAP32[(($4)>>2)]=32;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str32168)|0);
      HEAP32[(($6)>>2)]=245;
      var $36=HEAP32[(($4)>>2)];
      var $37=HEAP32[(($5)>>2)];
      var $38=HEAP32[(($6)>>2)];
      var $39=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36, $37, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $40
      HEAP32[(($result_i)>>2)]=$39;
      var $41=HEAP32[(($result_i)>>2)];
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $43
      var $44=___cxa_allocate_exception(4);
      var $45=$44;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($45);
      (function() { try { __THREW__ = false; return ___cxa_throw($44, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      HEAP32[(($7)>>2)]=$48;
      var $49=$47.f1;
      HEAP32[(($8)>>2)]=$49;
      var $50=HEAP32[(($8)>>2)];
      var $51=(($50)|0) < 0;
      if ($51) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $52
      var $53=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 8: // $54
      var $55=HEAP32[(($7)>>2)];
      var $56=HEAP32[(($7)>>2)];
      var $57=HEAP32[(($8)>>2)];
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $60
      throw "Reached an unreachable!"
    case 10: // $_ZnwjPKci_exit
      var $61=HEAP32[(($result_i)>>2)];
      var $62=$4;
      var $63=$5;
      var $64=$6;
      var $65=$result_i;
      var $66=$7;
      var $67=$8;
      var $68=$61;
      var $69=$14;
      var $70=(function() { try { __THREW__ = false; return __ZNK16device_interface6deviceEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $71
      var $72=HEAP32[(($spacenum)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11address_mapC1ERK8device_t16address_spacenum]($68, $70, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $73
      var $74=__ZN13resource_pool10add_objectI11address_mapEEPT_S3_(_global_resource_pool, $68);
      $map=$74;
      var $75=$map;
      var $76=(($75+12)|0);
      var $77=__ZNK11simple_listI17address_map_entryE5firstEv($76);
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $79
      var $80=$map;
      var $81=$80;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $81);
      __label__ = 108; break;
    case 14: // $82
      var $83=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $84=$83.f0;
      $12=$84;
      var $85=$83.f1;
      $13=$85;
      var $86=$1;
      var $87=$2;
      var $88=$3;
      HEAP32[(($1)>>2)]=$61;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str32168)|0);
      HEAP32[(($3)>>2)]=245;
      var $89=HEAP32[(($1)>>2)];
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $91
      var $92=HEAP32[(($1)>>2)];
      var $93=HEAP32[(($2)>>2)];
      var $94=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($92, $93, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 111; break; }
    case 16: // $_noexc
      __label__ = 17; break;
    case 17: // $_ZdlPvPKci_exit
      var $95=$1;
      var $96=$2;
      var $97=$3;
      __label__ = 18; break;
    case 18: // $98
      __label__ = 110; break;
    case 19: // $99
      var $100=$map;
      var $101=(($100)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=HEAP32[(($spacenum)>>2)];
      var $104=(($102)|0)!=(($103)|0);
      if ($104) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $105
      var $106=$11;
      var $107=(($106)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$11;
      var $110=(($109+8)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$14;
      var $113=__ZNK16device_interface6deviceEv($112);
      var $114=__ZNK8device_t3tagEv($113);
      var $115=HEAP32[(($spacenum)>>2)];
      var $116=$map;
      var $117=(($116)|0);
      var $118=HEAP32[(($117)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str42169)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$108,HEAP32[((tempInt+4)>>2)]=$111,HEAP32[((tempInt+8)>>2)]=$114,HEAP32[((tempInt+12)>>2)]=$115,HEAP32[((tempInt+16)>>2)]=$118,tempInt));
      $error=1;
      __label__ = 21; break;
    case 21: // $119
      var $120=$map;
      var $121=(($120+4)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=$datawidth;
      var $125=(($123)|0)!=(($124)|0);
      if ($125) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $126
      var $127=$11;
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$11;
      var $131=(($130+8)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$14;
      var $134=__ZNK16device_interface6deviceEv($133);
      var $135=__ZNK8device_t3tagEv($134);
      var $136=$spaceconfig;
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$datawidth;
      var $140=$map;
      var $141=(($140+4)|0);
      var $142=HEAPU8[($141)];
      var $143=(($142)&255);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str52170)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$129,HEAP32[((tempInt+4)>>2)]=$132,HEAP32[((tempInt+8)>>2)]=$135,HEAP32[((tempInt+12)>>2)]=$138,HEAP32[((tempInt+16)>>2)]=$139,HEAP32[((tempInt+20)>>2)]=$143,tempInt));
      $error=1;
      __label__ = 23; break;
    case 23: // $144
      var $145=$map;
      var $146=(($145+12)|0);
      var $147=__ZNK11simple_listI17address_map_entryE5firstEv($146);
      $entry=$147;
      __label__ = 24; break;
    case 24: // $148
      var $149=$entry;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 25; break; } else { __label__ = 106; break; }
    case 25: // $151
      var $152=$spaceconfig;
      var $153=$entry;
      var $154=(($153+72)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=__ZNK20address_space_config9addr2byteEj($152, $155);
      $bytestart=$156;
      var $157=$spaceconfig;
      var $158=$entry;
      var $159=(($158+76)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=__ZNK20address_space_config13addr2byte_endEj($157, $160);
      $byteend=$161;
      var $162=$detected_overlap;
      var $163=(($162) & 1);
      if ($163) { __label__ = 38; break; } else { __label__ = 26; break; }
    case 26: // $164
      var $165=$map;
      var $166=(($165+12)|0);
      var $167=__ZNK11simple_listI17address_map_entryE5firstEv($166);
      $scan=$167;
      __label__ = 27; break;
    case 27: // $168
      var $169=$scan;
      var $170=$entry;
      var $171=(($169)|0)!=(($170)|0);
      if ($171) { __label__ = 28; break; } else { __label__ = 37; break; }
    case 28: // $172
      var $173=$entry;
      var $174=(($173+72)|0);
      var $175=HEAPU32[(($174)>>2)];
      var $176=$scan;
      var $177=(($176+76)|0);
      var $178=HEAPU32[(($177)>>2)];
      var $179=(($175)>>>0) <= (($178)>>>0);
      if ($179) { __label__ = 29; break; } else { __label__ = 35; break; }
    case 29: // $180
      var $181=$entry;
      var $182=(($181+76)|0);
      var $183=HEAPU32[(($182)>>2)];
      var $184=$scan;
      var $185=(($184+72)|0);
      var $186=HEAPU32[(($185)>>2)];
      var $187=(($183)>>>0) >= (($186)>>>0);
      if ($187) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $188
      var $189=$entry;
      var $190=(($189+88)|0);
      var $191=(($190)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192)|0)!=0;
      if ($193) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $194
      var $195=$scan;
      var $196=(($195+88)|0);
      var $197=(($196)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198)|0)!=0;
      if ($199) { __label__ = 34; break; } else { __label__ = 32; break; }
    case 32: // $200
      var $201=$entry;
      var $202=(($201+176)|0);
      var $203=(($202)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $206
      var $207=$scan;
      var $208=(($207+176)|0);
      var $209=(($208)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=(($210)|0)!=0;
      if ($211) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $212
      var $213=$11;
      var $214=(($213)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=$11;
      var $217=(($216+8)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$14;
      var $220=__ZNK16device_interface6deviceEv($219);
      var $221=__ZNK8device_t3tagEv($220);
      var $222=$spaceconfig;
      var $223=(($222)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=$entry;
      var $226=(($225+72)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$entry;
      var $229=(($228+76)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$entry;
      var $232=(($231+88)|0);
      var $233=(($232)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$entry;
      var $236=(($235+176)|0);
      var $237=(($236)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$scan;
      var $240=(($239+72)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=$scan;
      var $243=(($242+76)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$scan;
      var $246=(($245+88)|0);
      var $247=(($246)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=$scan;
      var $250=(($249+176)|0);
      var $251=(($250)|0);
      var $252=HEAP32[(($251)>>2)];
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str62171)|0), (tempInt=STACKTOP,STACKTOP += 48,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$215,HEAP32[((tempInt+4)>>2)]=$218,HEAP32[((tempInt+8)>>2)]=$221,HEAP32[((tempInt+12)>>2)]=$224,HEAP32[((tempInt+16)>>2)]=$227,HEAP32[((tempInt+20)>>2)]=$230,HEAP32[((tempInt+24)>>2)]=$234,HEAP32[((tempInt+28)>>2)]=$238,HEAP32[((tempInt+32)>>2)]=$241,HEAP32[((tempInt+36)>>2)]=$244,HEAP32[((tempInt+40)>>2)]=$248,HEAP32[((tempInt+44)>>2)]=$252,tempInt));
      $detected_overlap=1;
      __label__ = 37; break;
    case 35: // $253
      __label__ = 36; break;
    case 36: // $254
      var $255=$scan;
      var $256=__ZNK17address_map_entry4nextEv($255);
      $scan=$256;
      __label__ = 27; break;
    case 37: // $257
      __label__ = 38; break;
    case 38: // $258
      var $259=$byteend;
      var $260=$bytestart;
      var $261=(($259)>>>0) < (($260)>>>0);
      if ($261) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $262
      var $263=$11;
      var $264=(($263)|0);
      var $265=HEAP32[(($264)>>2)];
      var $266=$11;
      var $267=(($266+8)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=$spaceconfig;
      var $270=(($269)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=$entry;
      var $273=(($272+72)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=$entry;
      var $276=(($275+76)|0);
      var $277=HEAP32[(($276)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str72172)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$265,HEAP32[((tempInt+4)>>2)]=$268,HEAP32[((tempInt+8)>>2)]=$271,HEAP32[((tempInt+12)>>2)]=$274,HEAP32[((tempInt+16)>>2)]=$277,tempInt));
      $error=1;
      __label__ = 40; break;
    case 40: // $278
      var $279=$bytestart;
      var $280=$alignunit;
      var $281=(($280-1)|0);
      var $282=$279 & $281;
      var $283=(($282)|0)!=0;
      if ($283) { __label__ = 42; break; } else { __label__ = 41; break; }
    case 41: // $284
      var $285=$byteend;
      var $286=$alignunit;
      var $287=(($286-1)|0);
      var $288=$285 & $287;
      var $289=$alignunit;
      var $290=(($289-1)|0);
      var $291=(($288)|0)!=(($290)|0);
      if ($291) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $292
      var $293=$11;
      var $294=(($293)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$11;
      var $297=(($296+8)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=$spaceconfig;
      var $300=(($299)|0);
      var $301=HEAP32[(($300)>>2)];
      var $302=$entry;
      var $303=(($302+72)|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=$entry;
      var $306=(($305+76)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=$alignunit;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str82173)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$295,HEAP32[((tempInt+4)>>2)]=$298,HEAP32[((tempInt+8)>>2)]=$301,HEAP32[((tempInt+12)>>2)]=$304,HEAP32[((tempInt+16)>>2)]=$307,HEAP32[((tempInt+20)>>2)]=$308,tempInt));
      $error=1;
      __label__ = 43; break;
    case 43: // $309
      var $310=$entry;
      var $311=(($310+88)|0);
      var $312=(($311)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=(($313)|0)==2;
      if ($314) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $315
      var $316=$entry;
      var $317=(($316+292)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=(($318)|0)==0;
      if ($319) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $320
      var $321=$14;
      var $322=__ZNK16device_interface6deviceEv($321);
      var $323=__ZNK8device_t3tagEv($322);
      var $324=$entry;
      var $325=(($324+292)|0);
      HEAP32[(($325)>>2)]=$323;
      var $326=$entry;
      var $327=(($326+72)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=$entry;
      var $330=(($329+296)|0);
      HEAP32[(($330)>>2)]=$328;
      __label__ = 46; break;
    case 46: // $331
      var $332=$entry;
      var $333=(($332+292)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($334)|0)!=0;
      if ($335) { __label__ = 47; break; } else { __label__ = 88; break; }
    case 47: // $336
      var $337=$entry;
      var $338=(($337+264)|0);
      var $339=HEAP32[(($338)>>2)];
      var $340=(($339)|0)==0;
      if ($340) { __label__ = 48; break; } else { __label__ = 88; break; }
    case 48: // $341
      $found=0;
      var $342=$14;
      var $343=__ZNK16device_interface6deviceEv($342);
      var $344=__ZNK8device_t7mconfigEv($343);
      var $345=__Z16rom_first_sourceRK14machine_config($344);
      $source=$345;
      __label__ = 49; break;
    case 49: // $346
      var $347=$source;
      var $348=(($347)|0)!=0;
      if ($348) { __label__ = 50; break; } else { var $354 = 0;__label__ = 51; break; }
    case 50: // $349
      var $350=$found;
      var $351=(($350) & 1);
      var $352=$351 ^ 1;
      var $354 = $352;__label__ = 51; break;
    case 51: // $353
      var $354;
      if ($354) { __label__ = 52; break; } else { __label__ = 85; break; }
    case 52: // $355
      var $356=$source;
      var $357=__Z16rom_first_regionRK8device_t($356);
      $romp=$357;
      __label__ = 53; break;
    case 53: // $358
      var $359=$romp;
      var $360=(($359+16)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=$361 & 15;
      var $363=(($362)|0)==2;
      if ($363) { var $369 = 0;__label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $364
      var $365=$found;
      var $366=(($365) & 1);
      var $367=$366 ^ 1;
      var $369 = $367;__label__ = 55; break;
    case 55: // $368
      var $369;
      if ($369) { __label__ = 56; break; } else { __label__ = 83; break; }
    case 56: // $370
      var $371=$romp;
      var $372=(($371)|0);
      var $373=HEAP32[(($372)>>2)];
      $regiontag=$373;
      var $374=$regiontag;
      var $375=(($374)|0)!=0;
      if ($375) { __label__ = 57; break; } else { __label__ = 81; break; }
    case 57: // $376
      __ZN7astringC1Ev($fulltag);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($regiontag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 62; break; }
    case 58: // $377
      var $378=$entry;
      var $379=(($378+292)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=(function() { try { __THREW__ = false; return _strchr($380, 58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 63; break; };
    case 59: // $382
      var $383=(($381)|0)!=0;
      if ($383) { __label__ = 60; break; } else { __label__ = 64; break; }
    case 60: // $384
      var $385=$entry;
      var $386=(($385+292)|0);
      var $387=HEAP32[(($386)>>2)];
      var $388=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($regiontag1, $387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 63; break; };
    case 61: // $389
      __label__ = 67; break;
    case 62: // $390
      var $391=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $392=$391.f0;
      $12=$392;
      var $393=$391.f1;
      $13=$393;
      __label__ = 79; break;
    case 63: // $394
      var $395=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $396=$395.f0;
      $12=$396;
      var $397=$395.f1;
      $13=$397;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 111; break; }
    case 64: // $398
      var $399=$14;
      var $400=(function() { try { __THREW__ = false; return __ZNK16device_interface6deviceEv($399) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 63; break; };
    case 65: // $401
      var $402=$entry;
      var $403=(($402+292)|0);
      var $404=HEAP32[(($403)>>2)];
      var $405=(function() { try { __THREW__ = false; return __ZNK8device_t10siblingtagER7astringPKc($400, $regiontag1, $404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 63; break; };
    case 66: // $406
      __label__ = 67; break;
    case 67: // $407
      var $408=$11;
      var $409=$source;
      var $410=$romp;
      var $411=(function() { try { __THREW__ = false; return __Z15rom_region_nameR7astringPK11game_driverPK8device_tPK9rom_entry($fulltag, $408, $409, $410) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 63; break; };
    case 68: // $412
      var $413=(function() { try { __THREW__ = false; return __ZNK7astring3cmpERKS_($fulltag, $regiontag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 63; break; };
    case 69: // $414
      var $415=(($413)|0)==0;
      if ($415) { __label__ = 70; break; } else { __label__ = 76; break; }
    case 70: // $416
      var $417=$romp;
      var $418=(($417+12)|0);
      var $419=HEAP32[(($418)>>2)];
      $length=$419;
      var $420=$entry;
      var $421=(($420+296)|0);
      var $422=HEAP32[(($421)>>2)];
      var $423=$byteend;
      var $424=$bytestart;
      var $425=(($423-$424)|0);
      var $426=(($425+1)|0);
      var $427=(($422+$426)|0);
      var $428=$length;
      var $429=(($427)>>>0) > (($428)>>>0);
      if ($429) { __label__ = 71; break; } else { __label__ = 75; break; }
    case 71: // $430
      var $431=$11;
      var $432=(($431)|0);
      var $433=HEAP32[(($432)>>2)];
      var $434=$11;
      var $435=(($434+8)|0);
      var $436=HEAP32[(($435)>>2)];
      var $437=$14;
      var $438=(function() { try { __THREW__ = false; return __ZNK16device_interface6deviceEv($437) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 63; break; };
    case 72: // $439
      var $440=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($438) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 63; break; };
    case 73: // $441
      var $442=$spaceconfig;
      var $443=(($442)|0);
      var $444=HEAP32[(($443)>>2)];
      var $445=$entry;
      var $446=(($445+72)|0);
      var $447=HEAP32[(($446)>>2)];
      var $448=$entry;
      var $449=(($448+76)|0);
      var $450=HEAP32[(($449)>>2)];
      var $451=$entry;
      var $452=(($451+292)|0);
      var $453=HEAP32[(($452)>>2)];
      var $454=$length;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str92174)|0), (tempInt=STACKTOP,STACKTOP += 32,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$433,HEAP32[((tempInt+4)>>2)]=$436,HEAP32[((tempInt+8)>>2)]=$440,HEAP32[((tempInt+12)>>2)]=$444,HEAP32[((tempInt+16)>>2)]=$447,HEAP32[((tempInt+20)>>2)]=$450,HEAP32[((tempInt+24)>>2)]=$453,HEAP32[((tempInt+28)>>2)]=$454,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 63; break; }
    case 74: // $455
      $error=1;
      __label__ = 75; break;
    case 75: // $456
      $found=1;
      __label__ = 76; break;
    case 76: // $457
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 62; break; }
    case 77: // $458
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      __label__ = 81; break;
    case 78: // $459
      __label__ = 79; break;
    case 79: // $460
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 111; break; }
    case 80: // $461
      __label__ = 110; break;
    case 81: // $462
      __label__ = 82; break;
    case 82: // $463
      var $464=$romp;
      var $465=(($464+20)|0);
      $romp=$465;
      __label__ = 53; break;
    case 83: // $466
      __label__ = 84; break;
    case 84: // $467
      var $468=$source;
      var $469=__Z15rom_next_sourceRK8device_t($468);
      $source=$469;
      __label__ = 49; break;
    case 85: // $470
      var $471=$found;
      var $472=(($471) & 1);
      if ($472) { __label__ = 87; break; } else { __label__ = 86; break; }
    case 86: // $473
      var $474=$11;
      var $475=(($474)|0);
      var $476=HEAP32[(($475)>>2)];
      var $477=$11;
      var $478=(($477+8)|0);
      var $479=HEAP32[(($478)>>2)];
      var $480=$14;
      var $481=__ZNK16device_interface6deviceEv($480);
      var $482=__ZNK8device_t3tagEv($481);
      var $483=$spaceconfig;
      var $484=(($483)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=$entry;
      var $487=(($486+72)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=$entry;
      var $490=(($489+76)|0);
      var $491=HEAP32[(($490)>>2)];
      var $492=$entry;
      var $493=(($492+292)|0);
      var $494=HEAP32[(($493)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str102175)|0), (tempInt=STACKTOP,STACKTOP += 28,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$476,HEAP32[((tempInt+4)>>2)]=$479,HEAP32[((tempInt+8)>>2)]=$482,HEAP32[((tempInt+12)>>2)]=$485,HEAP32[((tempInt+16)>>2)]=$488,HEAP32[((tempInt+20)>>2)]=$491,HEAP32[((tempInt+24)>>2)]=$494,tempInt));
      $error=1;
      __label__ = 87; break;
    case 87: // $495
      __label__ = 88; break;
    case 88: // $496
      var $497=$entry;
      var $498=(($497+88)|0);
      var $499=(($498)|0);
      var $500=HEAP32[(($499)>>2)];
      var $501=(($500)|0)==7;
      if ($501) { __label__ = 89; break; } else { __label__ = 91; break; }
    case 89: // $502
      var $503=$entry;
      var $504=(($503+88)|0);
      var $505=(($504+20)|0);
      var $506=HEAP32[(($505)>>2)];
      var $507=(($506)|0)!=0;
      if ($507) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $508
      var $509=$14;
      var $510=__ZNK16device_interface6deviceEv($509);
      var $511=__ZNK8device_t7mconfigEv($510);
      var $512=__ZNK14machine_config10devicelistEv($511);
      var $513=$512;
      var $514=$entry;
      var $515=(($514+88)|0);
      var $516=(($515+20)|0);
      var $517=HEAP32[(($516)>>2)];
      var $518=__ZNK11tagged_listI8device_tE4findEPKc($513, $517);
      var $519=(($518)|0)==0;
      if ($519) { __label__ = 94; break; } else { __label__ = 91; break; }
    case 91: // $520
      var $521=$entry;
      var $522=(($521+176)|0);
      var $523=(($522)|0);
      var $524=HEAP32[(($523)>>2)];
      var $525=(($524)|0)==7;
      if ($525) { __label__ = 92; break; } else { __label__ = 95; break; }
    case 92: // $526
      var $527=$entry;
      var $528=(($527+176)|0);
      var $529=(($528+20)|0);
      var $530=HEAP32[(($529)>>2)];
      var $531=(($530)|0)!=0;
      if ($531) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 93: // $532
      var $533=$14;
      var $534=__ZNK16device_interface6deviceEv($533);
      var $535=__ZNK8device_t7mconfigEv($534);
      var $536=__ZNK14machine_config10devicelistEv($535);
      var $537=$536;
      var $538=$entry;
      var $539=(($538+176)|0);
      var $540=(($539+20)|0);
      var $541=HEAP32[(($540)>>2)];
      var $542=__ZNK11tagged_listI8device_tE4findEPKc($537, $541);
      var $543=(($542)|0)==0;
      if ($543) { __label__ = 94; break; } else { __label__ = 95; break; }
    case 94: // $544
      var $545=$11;
      var $546=(($545)|0);
      var $547=HEAP32[(($546)>>2)];
      var $548=$11;
      var $549=(($548+8)|0);
      var $550=HEAP32[(($549)>>2)];
      var $551=$14;
      var $552=__ZNK16device_interface6deviceEv($551);
      var $553=__ZNK8device_t3tagEv($552);
      var $554=$spaceconfig;
      var $555=(($554)|0);
      var $556=HEAP32[(($555)>>2)];
      var $557=$entry;
      var $558=(($557+176)|0);
      var $559=(($558+20)|0);
      var $560=HEAP32[(($559)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str112176)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$547,HEAP32[((tempInt+4)>>2)]=$550,HEAP32[((tempInt+8)>>2)]=$553,HEAP32[((tempInt+12)>>2)]=$556,HEAP32[((tempInt+16)>>2)]=$560,tempInt));
      $error=1;
      __label__ = 95; break;
    case 95: // $561
      var $562=$entry;
      var $563=(($562+88)|0);
      var $564=(($563)|0);
      var $565=HEAP32[(($564)>>2)];
      var $566=(($565)|0)==9;
      if ($566) { __label__ = 96; break; } else { __label__ = 98; break; }
    case 96: // $567
      var $568=$11;
      var $569=$entry;
      var $570=(($569+88)|0);
      var $571=(($570+20)|0);
      var $572=HEAP32[(($571)>>2)];
      var $573=__Z12validate_tagRK11game_driverPKcS3_($568, ((STRING_TABLE.__str122177)|0), $572);
      if ($573) { __label__ = 98; break; } else { __label__ = 97; break; }
    case 97: // $574
      $error=1;
      __label__ = 98; break;
    case 98: // $575
      var $576=$entry;
      var $577=(($576+176)|0);
      var $578=(($577)|0);
      var $579=HEAP32[(($578)>>2)];
      var $580=(($579)|0)==9;
      if ($580) { __label__ = 99; break; } else { __label__ = 101; break; }
    case 99: // $581
      var $582=$11;
      var $583=$entry;
      var $584=(($583+176)|0);
      var $585=(($584+20)|0);
      var $586=HEAP32[(($585)>>2)];
      var $587=__Z12validate_tagRK11game_driverPKcS3_($582, ((STRING_TABLE.__str122177)|0), $586);
      if ($587) { __label__ = 101; break; } else { __label__ = 100; break; }
    case 100: // $588
      $error=1;
      __label__ = 101; break;
    case 101: // $589
      var $590=$entry;
      var $591=(($590+264)|0);
      var $592=HEAP32[(($591)>>2)];
      var $593=(($592)|0)!=0;
      if ($593) { __label__ = 102; break; } else { __label__ = 104; break; }
    case 102: // $594
      var $595=$11;
      var $596=$entry;
      var $597=(($596+264)|0);
      var $598=HEAP32[(($597)>>2)];
      var $599=__Z12validate_tagRK11game_driverPKcS3_($595, ((STRING_TABLE.__str132178)|0), $598);
      if ($599) { __label__ = 104; break; } else { __label__ = 103; break; }
    case 103: // $600
      $error=1;
      __label__ = 104; break;
    case 104: // $601
      __label__ = 105; break;
    case 105: // $602
      var $603=$entry;
      var $604=__ZNK17address_map_entry4nextEv($603);
      $entry=$604;
      __label__ = 24; break;
    case 106: // $605
      var $606=$map;
      var $607=$606;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $607);
      __label__ = 107; break;
    case 107: // $608
      __label__ = 108; break;
    case 108: // $609
      __ZppR16address_spacenumi($spacenum, 0);
      __label__ = 1; break;
    case 109: // $610
      var $611=$error;
      var $612=(($611) & 1);
      STACKTOP = __stackBase__;
      return $612;
    case 110: // $613
      var $614=$12;
      var $615=$12;
      var $616=$13;
      var $617=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $615, tempValue);
      var $618=($617.f1 = $616, $617);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 111: // $619
      var $620=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK23device_memory_interface24interface_validity_checkER11emu_optionsRK11game_driver["X"]=1;

function __ZppR16address_spacenumi($value, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$value;
  $3=$0;
  var $4=$2;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=$2;
  HEAP32[(($7)>>2)]=$6;
  ;
  return;
}


function __ZNK11simple_listI17address_map_entryE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK20address_space_config9addr2byteEj($this, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$address;
      var $3=$1;
      var $4=(($3+10)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0) < 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($3+10)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(((-$12))|0);
      var $14=$9 << $13;
      var $22 = $14;__label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+10)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=$16 >>> (($19)>>>0);
      var $22 = $20;__label__ = 3; break;
    case 3: // $21
      var $22;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK20address_space_config13addr2byte_endEj($this, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$address;
      var $3=$1;
      var $4=(($3+10)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0) < 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($3+10)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(((-$12))|0);
      var $14=$9 << $13;
      var $15=(($3+10)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(((-$17))|0);
      var $19=1 << $18;
      var $20=(($19-1)|0);
      var $21=$14 | $20;
      var $29 = $21;__label__ = 3; break;
    case 2: // $22
      var $23=$2;
      var $24=(($3+10)|0);
      var $25=HEAP8[($24)];
      var $26=(($25 << 24) >> 24);
      var $27=$23 >>> (($26)>>>0);
      var $29 = $27;__label__ = 3; break;
    case 3: // $28
      var $29;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17address_map_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK7astring3cmpERKS_($this, $str2) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$str2;
  var $3=$1;
  var $4=$2;
  var $5=__Z11astring_cmpPK7astringS1_($3, $4);
  ;
  return $5;
}


function __ZN20resource_pool_objectI11address_mapEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11address_mapEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11address_mapEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 32);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11address_mapE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11address_mapED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11address_mapED2Ev($2);
  ;
  return;
}


function ___cxx_global_var_init2460() {
  ;
  var __label__;

  __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id(__ZN9input_seq8end_codeE, 5, 0, 0, 0, 204);
  ;
  return;
}


function ___cxx_global_var_init1() {
  ;
  var __label__;

  __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id(__ZN9input_seq12default_codeE, 5, 0, 0, 0, 205);
  ;
  return;
}


function ___cxx_global_var_init2() {
  ;
  var __label__;

  __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id(__ZN9input_seq8not_codeE, 5, 0, 0, 0, 206);
  ;
  return;
}


function ___cxx_global_var_init3() {
  ;
  var __label__;

  __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id(__ZN9input_seq7or_codeE, 5, 0, 0, 0, 207);
  ;
  return;
}


function ___cxx_global_var_init4() {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  __ZN10input_codeC1ERKS_($1, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($2, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($3, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
  __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_(__ZN9input_seq9empty_seqE, $1, $2, $3, $4, $5, $6, $7);
  STACKTOP = __stackBase__;
  return;
}


function __ZN12joystick_map5parseEPKc($this, $mapstring) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $rownum;
      var $symmetric;
      var $srcrow;
      var $colnum;
      var $val;
      var $colnum1;
      var $symmetric2;
      var $val3;
      var $ptr;
      $2=$this;
      $3=$mapstring;
      var $4=$2;
      var $5=(($4+84)|0);
      var $6=$3;
      var $7=__ZN7astringaSEPKc($5, $6);
      $rownum=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$rownum;
      var $10=(($9)|0) < 9;
      if ($10) { __label__ = 2; break; } else { __label__ = 39; break; }
    case 2: // $11
      var $12=$3;
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==46;
      if ($20) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $21
      var $22=$rownum;
      var $23=(($22)|0) >= 5;
      if ($23) { __label__ = 5; break; } else { var $30 = 0;__label__ = 6; break; }
    case 5: // $24
      var $25=$3;
      var $26=HEAP8[($25)];
      var $27=(($26 << 24) >> 24);
      var $28=(($27)|0)==0;
      var $30 = $28;__label__ = 6; break;
    case 6: // $29
      var $30;
      var $31=(($30)&1);
      $symmetric=$31;
      var $32=$symmetric;
      var $33=(($32) & 1);
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$rownum;
      var $36=((8-$35)|0);
      var $41 = $36;__label__ = 9; break;
    case 8: // $37
      var $38=$rownum;
      var $39=(($38-1)|0);
      var $41 = $39;__label__ = 9; break;
    case 9: // $40
      var $41;
      var $42=(($4)|0);
      var $43=(($42+$41*9)|0);
      var $44=(($43)|0);
      $srcrow=$44;
      var $45=$rownum;
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $47
      $1=0;
      __label__ = 40; break;
    case 11: // $48
      $colnum=0;
      __label__ = 12; break;
    case 12: // $49
      var $50=$colnum;
      var $51=(($50)|0) < 9;
      if ($51) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $52
      var $53=$colnum;
      var $54=$srcrow;
      var $55=(($54+$53)|0);
      var $56=HEAP8[($55)];
      $val=$56;
      var $57=$symmetric;
      var $58=(($57) & 1);
      if ($58) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $59
      var $60=$val;
      var $61=(($60)&255);
      var $62=$61 & 3;
      var $63=$val;
      var $64=(($63)&255);
      var $65=$64 & 4;
      var $66=$65 << 1;
      var $67=$62 | $66;
      var $68=$val;
      var $69=(($68)&255);
      var $70=$69 & 8;
      var $71=$70 >> 1;
      var $72=$67 | $71;
      var $73=(($72) & 255);
      $val=$73;
      __label__ = 15; break;
    case 15: // $74
      var $75=$val;
      var $76=$colnum;
      var $77=$rownum;
      var $78=(($4)|0);
      var $79=(($78+$77*9)|0);
      var $80=(($79+$76)|0);
      HEAP8[($80)]=$75;
      __label__ = 16; break;
    case 16: // $81
      var $82=$colnum;
      var $83=(($82+1)|0);
      $colnum=$83;
      __label__ = 12; break;
    case 17: // $84
      __label__ = 35; break;
    case 18: // $85
      $colnum1=0;
      __label__ = 19; break;
    case 19: // $86
      var $87=$colnum1;
      var $88=(($87)|0) < 9;
      if ($88) { __label__ = 20; break; } else { __label__ = 34; break; }
    case 20: // $89
      var $90=$colnum1;
      var $91=(($90)|0) > 0;
      if ($91) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $92
      var $93=$3;
      var $94=HEAP8[($93)];
      var $95=(($94 << 24) >> 24);
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $97
      var $98=$3;
      var $99=HEAP8[($98)];
      var $100=(($99 << 24) >> 24);
      var $101=(($100)|0)==46;
      if ($101) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $102
      var $103=$colnum1;
      var $104=(($103)|0) >= 5;
      var $105=(($104)&1);
      $symmetric2=$105;
      var $106=$symmetric2;
      var $107=(($106) & 1);
      if ($107) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $108
      var $109=$colnum1;
      var $110=((8-$109)|0);
      var $115 = $110;__label__ = 26; break;
    case 25: // $111
      var $112=$colnum1;
      var $113=(($112-1)|0);
      var $115 = $113;__label__ = 26; break;
    case 26: // $114
      var $115;
      var $116=$rownum;
      var $117=(($4)|0);
      var $118=(($117+$116*9)|0);
      var $119=(($118+$115)|0);
      var $120=HEAP8[($119)];
      $val3=$120;
      var $121=$symmetric2;
      var $122=(($121) & 1);
      if ($122) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $123
      var $124=$val3;
      var $125=(($124)&255);
      var $126=$125 & 12;
      var $127=$val3;
      var $128=(($127)&255);
      var $129=$128 & 1;
      var $130=$129 << 1;
      var $131=$126 | $130;
      var $132=$val3;
      var $133=(($132)&255);
      var $134=$133 & 2;
      var $135=$134 >> 1;
      var $136=$131 | $135;
      var $137=(($136) & 255);
      $val3=$137;
      __label__ = 28; break;
    case 28: // $138
      var $139=$val3;
      var $140=$colnum1;
      var $141=$rownum;
      var $142=(($4)|0);
      var $143=(($142+$141*9)|0);
      var $144=(($143+$140)|0);
      HEAP8[($144)]=$139;
      __label__ = 32; break;
    case 29: // $145
      var $146=$3;
      var $147=(($146+1)|0);
      $3=$147;
      var $148=HEAP8[($146)];
      var $149=(($148 << 24) >> 24);
      var $150=_strchr(((STRING_TABLE.__ZZN12joystick_map5parseEPKcE10validchars)|0), $149);
      $ptr=$150;
      var $151=$ptr;
      var $152=(($151)|0)==0;
      if ($152) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $153
      $1=0;
      __label__ = 40; break;
    case 31: // $154
      var $155=$ptr;
      var $156=$155;
      var $157=(($156-((STRING_TABLE.__ZZN12joystick_map5parseEPKcE10validchars)))|0);
      var $158=((STRING_TABLE.__ZZN12joystick_map5parseEPKcE7charmap+$157)|0);
      var $159=HEAP8[($158)];
      var $160=$colnum1;
      var $161=$rownum;
      var $162=(($4)|0);
      var $163=(($162+$161*9)|0);
      var $164=(($163+$160)|0);
      HEAP8[($164)]=$159;
      __label__ = 32; break;
    case 32: // $165
      __label__ = 33; break;
    case 33: // $166
      var $167=$colnum1;
      var $168=(($167+1)|0);
      $colnum1=$168;
      __label__ = 19; break;
    case 34: // $169
      __label__ = 35; break;
    case 35: // $170
      var $171=$3;
      var $172=HEAP8[($171)];
      var $173=(($172 << 24) >> 24);
      var $174=(($173)|0)==46;
      if ($174) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $175
      var $176=$3;
      var $177=(($176+1)|0);
      $3=$177;
      __label__ = 37; break;
    case 37: // $178
      __label__ = 38; break;
    case 38: // $179
      var $180=$rownum;
      var $181=(($180+1)|0);
      $rownum=$181;
      __label__ = 1; break;
    case 39: // $182
      $1=1;
      __label__ = 40; break;
    case 40: // $183
      var $184=$1;
      ;
      return $184;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12joystick_map5parseEPKc["X"]=1;

function __ZN13resource_pool10add_objectI11address_mapEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11address_mapEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11address_mapEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI11address_mapED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11address_mapED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11address_mapED0Ev["X"]=1;

function __ZN20resource_pool_objectI11address_mapED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI11address_mapE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11address_mapD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11address_mapED2Ev["X"]=1;

function __ZN12joystick_mapC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+81)|0);
      HEAP8[($5)]=0;
      var $6=(($4+84)|0);
      __ZN7astringC1Ev($6);
      var $7=(function() { try { __THREW__ = false; return __ZN12joystick_map5parseEPKc($4, ((STRING_TABLE._joystick_map_8way)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $8
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=(($4+84)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12joystick_map6updateEii($this, $xaxisval, $yaxisval) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $mapval;
      $1=$this;
      $2=$xaxisval;
      $3=$yaxisval;
      var $4=$1;
      var $5=$2;
      var $6=(($5+65536)|0);
      var $7=(($6*9)|0);
      var $8=(((($7)|0)/131073)|0);
      $2=$8;
      var $9=$3;
      var $10=(($9+65536)|0);
      var $11=(($10*9)|0);
      var $12=(((($11)|0)/131073)|0);
      $3=$12;
      var $13=$2;
      var $14=$3;
      var $15=(($4)|0);
      var $16=(($15+$14*9)|0);
      var $17=(($16+$13)|0);
      var $18=HEAP8[($17)];
      $mapval=$18;
      var $19=$mapval;
      var $20=(($19)&255);
      var $21=(($20)|0)==15;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=(($4+81)|0);
      var $24=HEAP8[($23)];
      $mapval=$24;
      __label__ = 3; break;
    case 2: // $25
      var $26=$mapval;
      var $27=(($4+81)|0);
      HEAP8[($27)]=$26;
      __label__ = 3; break;
    case 3: // $28
      var $29=$mapval;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12input_device4itemE13input_item_id($this, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$index;
  var $3=$1;
  var $4=$2;
  var $5=(($3+72)|0);
  var $6=(($5+($4<<2))|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __ZNK12input_device8devindexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17input_device_item9itemclassEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17input_device_item6itemidEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+76)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK10input_code10item_classEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4 >>> 16;
  var $6=$5 & 15;
  ;
  return $6;
}


function __ZNK11input_class7managerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13input_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12joystick_map9to_stringER7astring($this, $string) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $rownum;
      var $colnum;
      $1=$this;
      $2=$string;
      var $3=$1;
      var $4=$2;
      var $5=(($3+84)|0);
      var $6=__ZNK7astring4cstrEv($5);
      var $7=__ZN7astring6printfEPKcz($4, ((STRING_TABLE.__str2032401)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$6,tempInt));
      $rownum=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$rownum;
      var $10=(($9)|0) < 9;
      if ($10) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $11
      var $12=$2;
      var $13=__ZN7astring9catprintfEPKcz($12, ((STRING_TABLE.__str2042402)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $colnum=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$colnum;
      var $16=(($15)|0) < 9;
      if ($16) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $17
      var $18=$colnum;
      var $19=$rownum;
      var $20=(($3)|0);
      var $21=(($20+$19*9)|0);
      var $22=(($21+$18)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      if ($24 == 5) {
        __label__ = 5; break;
      }
      else if ($24 == 4) {
        __label__ = 6; break;
      }
      else if ($24 == 6) {
        __label__ = 7; break;
      }
      else if ($24 == 1) {
        __label__ = 8; break;
      }
      else if ($24 == 0) {
        __label__ = 9; break;
      }
      else if ($24 == 2) {
        __label__ = 10; break;
      }
      else if ($24 == 9) {
        __label__ = 11; break;
      }
      else if ($24 == 8) {
        __label__ = 12; break;
      }
      else if ($24 == 10) {
        __label__ = 13; break;
      }
      else if ($24 == 15) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 5: // $25
      var $26=$2;
      var $27=__ZN7astring9catprintfEPKcz($26, ((STRING_TABLE.__str372231)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 6: // $28
      var $29=$2;
      var $30=__ZN7astring9catprintfEPKcz($29, ((STRING_TABLE.__str382232)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 7: // $31
      var $32=$2;
      var $33=__ZN7astring9catprintfEPKcz($32, ((STRING_TABLE.__str392233)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 8: // $34
      var $35=$2;
      var $36=__ZN7astring9catprintfEPKcz($35, ((STRING_TABLE.__str342228)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 9: // $37
      var $38=$2;
      var $39=__ZN7astring9catprintfEPKcz($38, ((STRING_TABLE.__str352229)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 10: // $40
      var $41=$2;
      var $42=__ZN7astring9catprintfEPKcz($41, ((STRING_TABLE.__str362230)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 11: // $43
      var $44=$2;
      var $45=__ZN7astring9catprintfEPKcz($44, ((STRING_TABLE.__str312225)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 12: // $46
      var $47=$2;
      var $48=__ZN7astring9catprintfEPKcz($47, ((STRING_TABLE.__str322226)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 13: // $49
      var $50=$2;
      var $51=__ZN7astring9catprintfEPKcz($50, ((STRING_TABLE.__str332227)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 14: // $52
      var $53=$2;
      var $54=__ZN7astring9catprintfEPKcz($53, ((STRING_TABLE.__str2052403)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 15: // $55
      var $56=$2;
      var $57=__ZN7astring9catprintfEPKcz($56, ((STRING_TABLE.__str2062404)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 16: // $58
      __label__ = 17; break;
    case 17: // $59
      var $60=$colnum;
      var $61=(($60+1)|0);
      $colnum=$61;
      __label__ = 3; break;
    case 18: // $62
      var $63=$2;
      var $64=__ZN7astring9catprintfEPKcz($63, ((STRING_TABLE.__str2072405)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 19; break;
    case 19: // $65
      var $66=$rownum;
      var $67=(($66+1)|0);
      $rownum=$67;
      __label__ = 1; break;
    case 20: // $68
      var $69=$2;
      var $70=__ZNK7astringcvPKcEv($69);
      STACKTOP = __stackBase__;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12joystick_map9to_stringER7astring["X"]=1;

function __ZN10input_codeC2ER12input_device13input_item_id($this, $device, $itemid) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $item;
      $1=$this;
      $2=$device;
      $3=$itemid;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$2;
      var $8=$3;
      var $9=__ZNK12input_device4itemE13input_item_id($7, $8);
      $item=$9;
      __label__ = 3; break;
    case 3: // $10
      __label__ = 4; break;
    case 4: // $11
      var $12=$2;
      var $13=__ZNK12input_device8devclassEv($12);
      var $14=$13 & 15;
      var $15=$14 << 28;
      var $16=$2;
      var $17=__ZNK12input_device8devindexEv($16);
      var $18=$17 & 255;
      var $19=$18 << 20;
      var $20=$15 | $19;
      var $21=$item;
      var $22=__ZNK17input_device_item9itemclassEv($21);
      var $23=$22 & 15;
      var $24=$23 << 16;
      var $25=$20 | $24;
      var $26=$item;
      var $27=__ZNK17input_device_item6itemidEv($26);
      var $28=$27 & 4095;
      var $29=$25 | $28;
      var $30=(($4)|0);
      HEAP32[(($30)>>2)]=$29;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12input_device8devclassEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK11input_class8devclassEv($4);
  ;
  return $5;
}


function __ZN9input_seqpLE10input_code($this, $code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curlength;
      $1=$this;
      var $2=$1;
      var $3=__ZNK9input_seq6lengthEv($2);
      $curlength=$3;
      var $4=$curlength;
      var $5=(($4)>>>0) < 15;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$curlength;
      var $8=(($7+1)|0);
      $curlength=$8;
      var $9=(($2)|0);
      var $10=(($9+($7<<2))|0);
      var $11=$10;
      var $12=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];
      var $13=$curlength;
      var $14=(($2)|0);
      var $15=(($14+($13<<2))|0);
      var $16=$15;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[((__ZN9input_seq8end_codeE)>>2)];
      __label__ = 2; break;
    case 2: // $17
      ;
      return $2;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK9input_seq6lengthEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $seqnum;
      $2=$this;
      var $3=$2;
      $seqnum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$seqnum;
      var $6=(($5)>>>0) < 16;
      if ($6) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $7
      var $8=$seqnum;
      var $9=(($3)|0);
      var $10=(($9+($8<<2))|0);
      var $11=__ZNK10input_codeeqERKS_($10, __ZN9input_seq8end_codeE);
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$seqnum;
      $1=$13;
      __label__ = 7; break;
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      var $16=$seqnum;
      var $17=(($16+1)|0);
      $seqnum=$17;
      __label__ = 1; break;
    case 6: // $18
      $1=16;
      __label__ = 7; break;
    case 7: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN9input_seqoRE10input_code($this, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      var $6=(($5)|0);
      var $7=__ZNK10input_codeeqERKS_($6, __ZN9input_seq8end_codeE);
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=(($4)|0);
      var $10=(($9)|0);
      var $11=__ZNK10input_codeeqERKS_($10, __ZN9input_seq12default_codeE);
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=(($4)|0);
      var $14=(($13)|0);
      var $15=$14;
      var $16=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];
      __label__ = 4; break;
    case 3: // $17
      __ZN10input_codeC1ERKS_($2, __ZN9input_seq7or_codeE);
      var $18=__ZN9input_seqpLE10input_code($4, $2);
      __ZN10input_codeC1ERKS_($3, $code);
      var $19=__ZN9input_seqpLE10input_code($4, $3);
      __label__ = 4; break;
    case 4: // $20
      STACKTOP = __stackBase__;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK9input_seq8is_validEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $lastclass;
      var $lastcode=__stackBase__;
      var $positive_code_count;
      var $seqnum;
      var $code=__stackBase__+4;
      var $3=__stackBase__+8;
      var $itemclass;
      $2=$this;
      var $4=$2;
      var $5=(($4)|0);
      var $6=(($5)|0);
      var $7=__ZNK10input_codeeqERKS_($6, __ZN9input_seq12default_codeE);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=__ZNK9input_seq6lengthEv($4);
      var $10=(($9)|0)==1;
      $1=$10;
      __label__ = 34; break;
    case 2: // $11
      $lastclass=0;
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($lastcode, 0, 0, 0, 0, 0);
      $positive_code_count=0;
      $seqnum=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$seqnum;
      var $14=(($13)>>>0) < 16;
      if ($14) { __label__ = 4; break; } else { __label__ = 33; break; }
    case 4: // $15
      var $16=$seqnum;
      var $17=(($4)|0);
      var $18=(($17+($16<<2))|0);
      __ZN10input_codeC1ERKS_($code, $18);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($3, 0, 0, 0, 0, 0);
      var $19=__ZNK10input_codeeqERKS_($code, $3);
      if ($19) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $20
      $1=0;
      __label__ = 34; break;
    case 6: // $21
      var $22=__ZNK10input_codeeqERKS_($code, __ZN9input_seq7or_codeE);
      if ($22) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $23
      var $24=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8end_codeE);
      if ($24) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $25
      var $26=$positive_code_count;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $28
      $1=0;
      __label__ = 34; break;
    case 10: // $29
      var $30=__ZNK10input_code8internalEv($lastcode);
      if ($30) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $31
      $1=0;
      __label__ = 34; break;
    case 12: // $32
      var $33=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8end_codeE);
      if ($33) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $34
      $1=1;
      __label__ = 34; break;
    case 14: // $35
      $positive_code_count=0;
      $lastclass=0;
      __label__ = 31; break;
    case 15: // $36
      var $37=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8not_codeE);
      if ($37) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $38
      var $39=__ZNK10input_codeeqERKS_($lastcode, __ZN9input_seq8not_codeE);
      if ($39) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $40
      $1=0;
      __label__ = 34; break;
    case 18: // $41
      __label__ = 30; break;
    case 19: // $42
      var $43=__ZNK10input_codeneERKS_($lastcode, __ZN9input_seq8not_codeE);
      if ($43) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $44
      var $45=$positive_code_count;
      var $46=(($45+1)|0);
      $positive_code_count=$46;
      __label__ = 21; break;
    case 21: // $47
      var $48=__ZNK10input_code10item_classEv($code);
      $itemclass=$48;
      var $49=$itemclass;
      var $50=(($49)|0)!=1;
      if ($50) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $51
      var $52=__ZNK10input_codeeqERKS_($lastcode, __ZN9input_seq8not_codeE);
      if ($52) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $53
      $1=0;
      __label__ = 34; break;
    case 24: // $54
      var $55=$lastclass;
      var $56=(($55)|0)==2;
      if ($56) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $57
      var $58=$itemclass;
      var $59=(($58)|0)!=2;
      if ($59) { __label__ = 28; break; } else { __label__ = 26; break; }
    case 26: // $60
      var $61=$lastclass;
      var $62=(($61)|0)==3;
      if ($62) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $63
      var $64=$itemclass;
      var $65=(($64)|0)!=3;
      if ($65) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $66
      $1=0;
      __label__ = 34; break;
    case 29: // $67
      __label__ = 30; break;
    case 30: // $68
      __label__ = 31; break;
    case 31: // $69
      var $70=$lastcode;
      var $71=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($70)>>2)]=HEAP32[(($71)>>2)];
      __label__ = 32; break;
    case 32: // $72
      var $73=$seqnum;
      var $74=(($73+1)|0);
      $seqnum=$74;
      __label__ = 3; break;
    case 33: // $75
      $1=0;
      __label__ = 34; break;
    case 34: // $76
      var $77=$1;
      STACKTOP = __stackBase__;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK9input_seq8is_validEv["X"]=1;

function __ZNK10input_code8internalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK10input_code12device_classEv($2);
  var $4=(($3)|0)==5;
  ;
  return $4;
}


function __ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_($this, $code0, $code1, $code2, $code3, $code4, $code5, $code6) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $codenum;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=(($3)|0);
      var $5=$4;
      var $6=$code0;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];
      var $7=(($2)|0);
      var $8=(($7+4)|0);
      var $9=$8;
      var $10=$code1;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=(($2)|0);
      var $12=(($11+8)|0);
      var $13=$12;
      var $14=$code2;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[(($14)>>2)];
      var $15=(($2)|0);
      var $16=(($15+12)|0);
      var $17=$16;
      var $18=$code3;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];
      var $19=(($2)|0);
      var $20=(($19+16)|0);
      var $21=$20;
      var $22=$code4;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($21)>>2)]=HEAP32[(($22)>>2)];
      var $23=(($2)|0);
      var $24=(($23+20)|0);
      var $25=$24;
      var $26=$code5;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($25)>>2)]=HEAP32[(($26)>>2)];
      var $27=(($2)|0);
      var $28=(($27+24)|0);
      var $29=$28;
      var $30=$code6;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($29)>>2)]=HEAP32[(($30)>>2)];
      $codenum=7;
      __label__ = 1; break;
    case 1: // $31
      var $32=$codenum;
      var $33=(($32)>>>0) < 16;
      if ($33) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $34
      var $35=$codenum;
      var $36=(($2)|0);
      var $37=(($36+($35<<2))|0);
      var $38=$37;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($38)>>2)]=HEAP32[((__ZN9input_seq8end_codeE)>>2)];
      __label__ = 3; break;
    case 3: // $39
      var $40=$codenum;
      var $41=(($40+1)|0);
      $codenum=$41;
      __label__ = 1; break;
    case 4: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_["X"]=1;

function __ZN9input_seq9backspaceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curlength;
      $1=$this;
      var $2=$1;
      var $3=__ZNK9input_seq6lengthEv($2);
      $curlength=$3;
      var $4=$curlength;
      var $5=(($4)|0) > 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$curlength;
      var $8=(($7-1)|0);
      var $9=(($2)|0);
      var $10=(($9+($8<<2))|0);
      var $11=$10;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[((__ZN9input_seq8end_codeE)>>2)];
      __label__ = 2; break;
    case 2: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN9input_seq7replaceE10input_codeS0_($this, $oldcode, $newcode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $codenum;
      $1=$this;
      var $2=$1;
      $codenum=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$codenum;
      var $5=(($4)>>>0) < 16;
      if ($5) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $6
      var $7=$codenum;
      var $8=(($2)|0);
      var $9=(($8+($7<<2))|0);
      var $10=__ZNK10input_codeeqERKS_($9, $oldcode);
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=$codenum;
      var $13=(($2)|0);
      var $14=(($13+($12<<2))|0);
      var $15=$14;
      var $16=$newcode;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$codenum;
      var $20=(($19+1)|0);
      $codenum=$20;
      __label__ = 1; break;
    case 6: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12input_deviceC2ER11input_classiPKcPv($this, $_class, $devindex, $name, $internal) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $mapstring;
      var $tempstr=__stackBase__;
      $1=$this;
      $2=$_class;
      $3=$devindex;
      $4=$name;
      $5=$internal;
      var $8=$1;
      var $9=(($8)|0);
      var $10=$2;
      HEAP32[(($9)>>2)]=$10;
      var $11=(($8+4)|0);
      var $12=$4;
      __ZN7astringC1EPKc($11, $12);
      var $13=(($8+68)|0);
      var $14=$3;
      HEAP32[(($13)>>2)]=$14;
      var $15=(($8+16452)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($8+16456)|0);
      var $17=$5;
      HEAP32[(($16)>>2)]=$17;
      var $18=(($8+16460)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12joystick_mapC1Ev]($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 26; break; }
    case 1: // $19
      var $20=(($8+16608)|0);
      var $21=$2;
      var $22=(function() { try { __THREW__ = false; return __ZNK11input_class7managerEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 27; break; };
    case 2: // $23
      var $24=(function() { try { __THREW__ = false; return __ZNK13input_manager7machineEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 27; break; };
    case 3: // $25
      var $26=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 27; break; };
    case 4: // $27
      var $28=(function() { try { __THREW__ = false; return __ZNK11emu_options17joystick_deadzoneEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 27; break; };
    case 5: // $29
      var $30=$28*65536;
      var $31=(($30)|0);
      HEAP32[(($20)>>2)]=$31;
      var $32=(($8+16612)|0);
      var $33=$2;
      var $34=(function() { try { __THREW__ = false; return __ZNK11input_class7managerEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 27; break; };
    case 6: // $35
      var $36=(function() { try { __THREW__ = false; return __ZNK13input_manager7machineEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 27; break; };
    case 7: // $37
      var $38=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 27; break; };
    case 8: // $39
      var $40=(function() { try { __THREW__ = false; return __ZNK11emu_options19joystick_saturationEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 27; break; };
    case 9: // $41
      var $42=$40*65536;
      var $43=(($42)|0);
      HEAP32[(($32)>>2)]=$43;
      var $44=(($8+16616)|0);
      var $45=$2;
      var $46=(function() { try { __THREW__ = false; return __ZNK11input_class7managerEv($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 27; break; };
    case 10: // $47
      var $48=(function() { try { __THREW__ = false; return __ZNK13input_manager7machineEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 27; break; };
    case 11: // $49
      var $50=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 27; break; };
    case 12: // $51
      var $52=(function() { try { __THREW__ = false; return __ZNK11emu_options9steadykeyEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 27; break; };
    case 13: // $53
      var $54=(($52)&1);
      HEAP8[($44)]=$54;
      var $55=(($8+16617)|0);
      var $56=$2;
      var $57=(function() { try { __THREW__ = false; return __ZNK11input_class7managerEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 27; break; };
    case 14: // $58
      var $59=(function() { try { __THREW__ = false; return __ZNK13input_manager7machineEv($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 27; break; };
    case 15: // $60
      var $61=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 27; break; };
    case 16: // $62
      var $63=(function() { try { __THREW__ = false; return __ZNK11emu_options16offscreen_reloadEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 27; break; };
    case 17: // $64
      var $65=(($63)&1);
      HEAP8[($55)]=$65;
      var $66=(($8+72)|0);
      var $67=(($66)|0);
      var $68=$67;
      _memset($68, 0, 16380, 1);
      var $69=(function() { try { __THREW__ = false; return __ZNK12input_device8devclassEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 27; break; };
    case 18: // $70
      var $71=(($69)|0)==4;
      if ($71) { __label__ = 19; break; } else { __label__ = 43; break; }
    case 19: // $72
      var $73=(function() { try { __THREW__ = false; return __ZNK12input_device7machineEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 27; break; };
    case 20: // $74
      var $75=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 27; break; };
    case 21: // $76
      var $77=(function() { try { __THREW__ = false; return __ZNK11emu_options12joystick_mapEv($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 27; break; };
    case 22: // $78
      $mapstring=$77;
      var $79=$mapstring;
      var $80=(($79)|0);
      var $81=HEAP8[($80)];
      var $82=(($81 << 24) >> 24);
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 25; break; } else { __label__ = 23; break; }
    case 23: // $84
      var $85=$mapstring;
      var $86=(function() { try { __THREW__ = false; return _strcmp($85, ((STRING_TABLE.__str2082406)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 27; break; };
    case 24: // $87
      var $88=(($86)|0)==0;
      if ($88) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $89
      $mapstring=((STRING_TABLE._joystick_map_8way)|0);
      __label__ = 28; break;
    case 26: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $92=$91.f0;
      $6=$92;
      var $93=$91.f1;
      $7=$93;
      __label__ = 46; break;
    case 27: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      $6=$96;
      var $97=$95.f1;
      $7=$97;
      __label__ = 44; break;
    case 28: // $98
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 27; break; }
    case 29: // $99
      var $100=(($8+16460)|0);
      var $101=$mapstring;
      var $102=(function() { try { __THREW__ = false; return __ZN12joystick_map5parseEPKc($100, $101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 34; break; };
    case 30: // $103
      if ($102) { __label__ = 35; break; } else { __label__ = 31; break; }
    case 31: // $104
      var $105=$mapstring;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str2092407)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$105,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $106
      var $107=(($8+16460)|0);
      var $108=(function() { try { __THREW__ = false; return __ZN12joystick_map5parseEPKc($107, ((STRING_TABLE._joystick_map_8way)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 34; break; };
    case 33: // $109
      __label__ = 40; break;
    case 34: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $112=$111.f0;
      $6=$112;
      var $113=$111.f1;
      $7=$113;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 49; break; }
    case 35: // $114
      var $115=$mapstring;
      var $116=(($115)|0)!=(((((STRING_TABLE._joystick_map_8way)|0)))|0);
      if ($116) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $117
      var $118=(($8+16460)|0);
      var $119=(function() { try { __THREW__ = false; return __ZNK12joystick_map9to_stringER7astring($118, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 34; break; };
    case 37: // $120
      (function() { try { __THREW__ = false; return __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str2102408)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$119,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 34; break; }
    case 38: // $121
      __label__ = 39; break;
    case 39: // $122
      __label__ = 40; break;
    case 40: // $123
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 27; break; }
    case 41: // $124
      __label__ = 43; break;
    case 42: // $125
      __label__ = 44; break;
    case 43: // $126
      STACKTOP = __stackBase__;
      return;
    case 44: // $127
      var $128=(($8+16460)|0);
      (function() { try { __THREW__ = false; return __ZN12joystick_mapD1Ev($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 49; break; }
    case 45: // $129
      __label__ = 46; break;
    case 46: // $130
      var $131=(($8+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 47: // $132
      __label__ = 48; break;
    case 48: // $133
      var $134=$6;
      var $135=$6;
      var $136=$7;
      var $137=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $135, tempValue);
      var $138=($137.f1 = $136, $137);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $139
      var $140=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12input_deviceC2ER11input_classiPKcPv["X"]=1;

function __ZppR13input_item_idi($value, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$value;
  $3=$0;
  var $4=$2;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=$2;
  HEAP32[(($7)>>2)]=$6;
  ;
  return;
}


function __ZN11input_class19standard_item_classE13input_item_id($this, $itemid) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$itemid;
      var $4=$2;
      var $5=$3;
      var $6=(($5)|0)==200;
      if ($6) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$3;
      var $9=(($8)|0) < 110;
      if ($9) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0) > 117;
      if ($12) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      var $14=$3;
      var $15=(($14)|0) < 168;
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      $1=1;
      __label__ = 11; break;
    case 5: // $17
      var $18=(($4+1024)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==2;
      if ($20) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $21
      var $22=$3;
      var $23=(($22)|0)==202;
      if ($23) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 7: // $24
      var $25=$3;
      var $26=(($25)|0) >= 184;
      if ($26) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $27
      var $28=$3;
      var $29=(($28)|0) <= 199;
      if ($29) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $30
      $1=3;
      __label__ = 11; break;
    case 10: // $31
      $1=2;
      __label__ = 11; break;
    case 11: // $32
      var $33=$1;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options17joystick_deadzoneEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str2602458)|0));
  ;
  return $4;
}


function __ZNK11emu_options19joystick_saturationEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str2592457)|0));
  ;
  return $4;
}


function __ZNK11emu_options9steadykeyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2582456)|0));
  ;
  return $4;
}


function __ZNK11emu_options16offscreen_reloadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2572455)|0));
  ;
  return $4;
}


function __ZNK12input_device7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK11input_class7machineEv($4);
  ;
  return $5;
}


function __ZN12joystick_mapD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12joystick_mapD2Ev($2);
  ;
  return;
}


function __ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_($this, $name, $itemid, $getstate, $internal) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i5=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i1=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25;
      var $26;
      var $27=__stackBase__+108;
      var $28;
      var $29;
      var $30;
      var $31;
      var $originalid;
      var $item;
      $25=$this;
      $26=$name;
      HEAP32[(($27)>>2)]=$itemid;
      $28=$getstate;
      $29=$internal;
      var $32=$25;
      __label__ = 1; break;
    case 1: // $33
      var $34=__ZNK12input_device7machineEv($32);
      var $35=__ZNK15running_machine5phaseEv($34);
      var $36=(($35)|0)==1;
      if ($36) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $37
      var $38=___cxa_allocate_exception(1032);
      var $39=$38;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($39, ((STRING_TABLE.__str2112409)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str2122410)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2132411)|0),HEAP32[((tempInt+8)>>2)]=895,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $40
      ___cxa_throw($38, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      $30=$43;
      var $44=$42.f1;
      $31=$44;
      ___cxa_free_exception($38);
      __label__ = 75; break;
    case 5: // $45
      __label__ = 6; break;
    case 6: // $46
      __label__ = 7; break;
    case 7: // $47
      __label__ = 8; break;
    case 8: // $48
      __label__ = 9; break;
    case 9: // $49
      __label__ = 10; break;
    case 10: // $50
      __label__ = 11; break;
    case 11: // $51
      __label__ = 12; break;
    case 12: // $52
      var $53=HEAP32[(($27)>>2)];
      $originalid=$53;
      var $54=HEAP32[(($27)>>2)];
      var $55=(($54)|0) >= 200;
      if ($55) { __label__ = 13; break; } else { __label__ = 21; break; }
    case 13: // $56
      var $57=HEAP32[(($27)>>2)];
      var $58=(($57)|0) <= 202;
      if ($58) { __label__ = 14; break; } else { __label__ = 21; break; }
    case 14: // $59
      HEAP32[(($27)>>2)]=204;
      __label__ = 15; break;
    case 15: // $60
      var $61=HEAP32[(($27)>>2)];
      var $62=(($61)|0) <= 4095;
      if ($62) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $63
      var $64=HEAP32[(($27)>>2)];
      var $65=(($32+72)|0);
      var $66=(($65+($64<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $69
      __label__ = 20; break;
    case 18: // $70
      __label__ = 19; break;
    case 19: // $71
      __ZppR13input_item_idi($27, 0);
      __label__ = 15; break;
    case 20: // $72
      __label__ = 21; break;
    case 21: // $73
      __label__ = 22; break;
    case 22: // $74
      __label__ = 23; break;
    case 23: // $75
      __label__ = 24; break;
    case 24: // $76
      __label__ = 25; break;
    case 25: // $77
      $item=0;
      var $78=(($32)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$originalid;
      var $81=__ZN11input_class19standard_item_classE13input_item_id($79, $80);
      if ($81 == 1) {
        __label__ = 26; break;
      }
      else if ($81 == 3) {
        __label__ = 40; break;
      }
      else if ($81 == 2) {
        __label__ = 54; break;
      }
      else {
      __label__ = 68; break;
      }
      
    case 26: // $82
      var $83=__ZNK12input_device7machineEv($32);
      var $84=__ZN15running_machine7respoolEv($83);
      var $85=$20;
      var $86=$21;
      var $87=$22;
      var $88=$result_i;
      var $89=$23;
      var $90=$24;
      HEAP32[(($20)>>2)]=168;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($22)>>2)]=916;
      var $91=HEAP32[(($20)>>2)];
      var $92=HEAP32[(($21)>>2)];
      var $93=HEAP32[(($22)>>2)];
      var $94=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($91, $92, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $95
      HEAP32[(($result_i)>>2)]=$94;
      var $96=HEAP32[(($result_i)>>2)];
      var $97=(($96)|0)==0;
      if ($97) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $98
      var $99=___cxa_allocate_exception(4);
      var $100=$99;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($100);
      (function() { try { __THREW__ = false; return ___cxa_throw($99, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 29; break; }
    case 29: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $103=$102.f0;
      HEAP32[(($23)>>2)]=$103;
      var $104=$102.f1;
      HEAP32[(($24)>>2)]=$104;
      var $105=HEAP32[(($24)>>2)];
      var $106=(($105)|0) < 0;
      if ($106) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $107
      var $108=HEAP32[(($23)>>2)];
      ___cxa_call_unexpected($108);
      throw "Reached an unreachable!"
    case 31: // $109
      var $110=HEAP32[(($23)>>2)];
      var $111=HEAP32[(($23)>>2)];
      var $112=HEAP32[(($24)>>2)];
      var $113=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $111, tempValue);
      var $114=($113.f1 = $112, $113);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 32: // $115
      throw "Reached an unreachable!"
    case 33: // $_ZnwjPKci_exit
      var $116=HEAP32[(($result_i)>>2)];
      var $117=$20;
      var $118=$21;
      var $119=$22;
      var $120=$result_i;
      var $121=$23;
      var $122=$24;
      var $123=$116;
      var $124=$26;
      var $125=$29;
      var $126=HEAP32[(($27)>>2)];
      var $127=$28;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24input_device_switch_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E]($123, $32, $124, $125, $126, $127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $128
      var $129=__ZN13resource_pool10add_objectI24input_device_switch_itemEEPT_S3_($84, $123);
      var $130=$129;
      $item=$130;
      __label__ = 71; break;
    case 35: // $131
      var $132=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $133=$132.f0;
      $30=$133;
      var $134=$132.f1;
      $31=$134;
      var $135=$17;
      var $136=$18;
      var $137=$19;
      HEAP32[(($17)>>2)]=$116;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($19)>>2)]=916;
      var $138=HEAP32[(($17)>>2)];
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $140
      var $141=HEAP32[(($17)>>2)];
      var $142=HEAP32[(($18)>>2)];
      var $143=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($141, $142, $143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 76; break; }
    case 37: // $_noexc
      __label__ = 38; break;
    case 38: // $_ZdlPvPKci_exit
      var $144=$17;
      var $145=$18;
      var $146=$19;
      __label__ = 39; break;
    case 39: // $147
      __label__ = 75; break;
    case 40: // $148
      var $149=__ZNK12input_device7machineEv($32);
      var $150=__ZN15running_machine7respoolEv($149);
      var $151=$12;
      var $152=$13;
      var $153=$14;
      var $154=$result_i1;
      var $155=$15;
      var $156=$16;
      HEAP32[(($12)>>2)]=160;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($14)>>2)]=920;
      var $157=HEAP32[(($12)>>2)];
      var $158=HEAP32[(($13)>>2)];
      var $159=HEAP32[(($14)>>2)];
      var $160=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($157, $158, $159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; };
    case 41: // $161
      HEAP32[(($result_i1)>>2)]=$160;
      var $162=HEAP32[(($result_i1)>>2)];
      var $163=(($162)|0)==0;
      if ($163) { __label__ = 42; break; } else { __label__ = 47; break; }
    case 42: // $164
      var $165=___cxa_allocate_exception(4);
      var $166=$165;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($166);
      (function() { try { __THREW__ = false; return ___cxa_throw($165, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 43; break; }
    case 43: // $167
      var $168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $169=$168.f0;
      HEAP32[(($15)>>2)]=$169;
      var $170=$168.f1;
      HEAP32[(($16)>>2)]=$170;
      var $171=HEAP32[(($16)>>2)];
      var $172=(($171)|0) < 0;
      if ($172) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $173
      var $174=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($174);
      throw "Reached an unreachable!"
    case 45: // $175
      var $176=HEAP32[(($15)>>2)];
      var $177=HEAP32[(($15)>>2)];
      var $178=HEAP32[(($16)>>2)];
      var $179=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $177, tempValue);
      var $180=($179.f1 = $178, $179);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $181
      throw "Reached an unreachable!"
    case 47: // $_ZnwjPKci_exit2
      var $182=HEAP32[(($result_i1)>>2)];
      var $183=$12;
      var $184=$13;
      var $185=$14;
      var $186=$result_i1;
      var $187=$15;
      var $188=$16;
      var $189=$182;
      var $190=$26;
      var $191=$29;
      var $192=HEAP32[(($27)>>2)];
      var $193=$28;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN26input_device_relative_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E]($189, $32, $190, $191, $192, $193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $194
      var $195=__ZN13resource_pool10add_objectI26input_device_relative_itemEEPT_S3_($150, $189);
      var $196=$195;
      $item=$196;
      __label__ = 71; break;
    case 49: // $197
      var $198=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $199=$198.f0;
      $30=$199;
      var $200=$198.f1;
      $31=$200;
      var $201=$9;
      var $202=$10;
      var $203=$11;
      HEAP32[(($9)>>2)]=$182;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($11)>>2)]=920;
      var $204=HEAP32[(($9)>>2)];
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $206
      var $207=HEAP32[(($9)>>2)];
      var $208=HEAP32[(($10)>>2)];
      var $209=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($207, $208, $209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 76; break; }
    case 51: // $_noexc3
      __label__ = 52; break;
    case 52: // $_ZdlPvPKci_exit4
      var $210=$9;
      var $211=$10;
      var $212=$11;
      __label__ = 53; break;
    case 53: // $213
      __label__ = 75; break;
    case 54: // $214
      var $215=__ZNK12input_device7machineEv($32);
      var $216=__ZN15running_machine7respoolEv($215);
      var $217=$4;
      var $218=$5;
      var $219=$6;
      var $220=$result_i5;
      var $221=$7;
      var $222=$8;
      HEAP32[(($4)>>2)]=160;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($6)>>2)]=924;
      var $223=HEAP32[(($4)>>2)];
      var $224=HEAP32[(($5)>>2)];
      var $225=HEAP32[(($6)>>2)];
      var $226=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($223, $224, $225) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 57; break; };
    case 55: // $227
      HEAP32[(($result_i5)>>2)]=$226;
      var $228=HEAP32[(($result_i5)>>2)];
      var $229=(($228)|0)==0;
      if ($229) { __label__ = 56; break; } else { __label__ = 61; break; }
    case 56: // $230
      var $231=___cxa_allocate_exception(4);
      var $232=$231;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($232);
      (function() { try { __THREW__ = false; return ___cxa_throw($231, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 57; break; }
    case 57: // $233
      var $234=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $235=$234.f0;
      HEAP32[(($7)>>2)]=$235;
      var $236=$234.f1;
      HEAP32[(($8)>>2)]=$236;
      var $237=HEAP32[(($8)>>2)];
      var $238=(($237)|0) < 0;
      if ($238) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $239
      var $240=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($240);
      throw "Reached an unreachable!"
    case 59: // $241
      var $242=HEAP32[(($7)>>2)];
      var $243=HEAP32[(($7)>>2)];
      var $244=HEAP32[(($8)>>2)];
      var $245=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $243, tempValue);
      var $246=($245.f1 = $244, $245);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 60: // $247
      throw "Reached an unreachable!"
    case 61: // $_ZnwjPKci_exit6
      var $248=HEAP32[(($result_i5)>>2)];
      var $249=$4;
      var $250=$5;
      var $251=$6;
      var $252=$result_i5;
      var $253=$7;
      var $254=$8;
      var $255=$248;
      var $256=$26;
      var $257=$29;
      var $258=HEAP32[(($27)>>2)];
      var $259=$28;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN26input_device_absolute_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E]($255, $32, $256, $257, $258, $259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $260
      var $261=__ZN13resource_pool10add_objectI26input_device_absolute_itemEEPT_S3_($216, $255);
      var $262=$261;
      $item=$262;
      __label__ = 71; break;
    case 63: // $263
      var $264=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $265=$264.f0;
      $30=$265;
      var $266=$264.f1;
      $31=$266;
      var $267=$1;
      var $268=$2;
      var $269=$3;
      HEAP32[(($1)>>2)]=$248;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($3)>>2)]=924;
      var $270=HEAP32[(($1)>>2)];
      var $271=(($270)|0)!=0;
      if ($271) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 64: // $272
      var $273=HEAP32[(($1)>>2)];
      var $274=HEAP32[(($2)>>2)];
      var $275=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 76; break; }
    case 65: // $_noexc7
      __label__ = 66; break;
    case 66: // $_ZdlPvPKci_exit8
      var $276=$1;
      var $277=$2;
      var $278=$3;
      __label__ = 67; break;
    case 67: // $279
      __label__ = 75; break;
    case 68: // $280
      __label__ = 69; break;
    case 69: // $281
      __label__ = 70; break;
    case 70: // $282
      __label__ = 71; break;
    case 71: // $283
      var $284=$item;
      var $285=HEAP32[(($27)>>2)];
      var $286=(($32+72)|0);
      var $287=(($286+($285<<2))|0);
      HEAP32[(($287)>>2)]=$284;
      var $288=(($32+16452)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=HEAP32[(($27)>>2)];
      var $291=(($289)|0) > (($290)|0);
      if ($291) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $292
      var $293=(($32+16452)|0);
      var $294=HEAP32[(($293)>>2)];
      var $298 = $294;__label__ = 74; break;
    case 73: // $295
      var $296=HEAP32[(($27)>>2)];
      var $298 = $296;__label__ = 74; break;
    case 74: // $297
      var $298;
      var $299=(($32+16452)|0);
      HEAP32[(($299)>>2)]=$298;
      var $300=HEAP32[(($27)>>2)];
      STACKTOP = __stackBase__;
      return $300;
    case 75: // $301
      var $302=$30;
      var $303=$30;
      var $304=$31;
      var $305=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $303, tempValue);
      var $306=($305.f1 = $304, $305);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 76: // $307
      var $308=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_["X"]=1;

function __ZN13resource_pool10add_objectI24input_device_switch_itemEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24input_device_switch_itemEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI24input_device_switch_itemEEPT_S3_["X"]=1;

function __Z8downcastIP24input_device_switch_item17input_device_itemET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24input_device_switch_item27steadykey_update_to_currentEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+152)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($2+160)|0);
  HEAP32[(($6)>>2)]=$5;
  ;
  return;
}


function __ZNK12input_device29apply_deadzone_and_saturationEi($this, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $negative;
      $2=$this;
      $3=$result;
      var $4=$2;
      var $5=__ZNK12input_device8devclassEv($4);
      var $6=(($5)|0)!=4;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$3;
      $1=$8;
      __label__ = 14; break;
    case 2: // $9
      $negative=0;
      var $10=$3;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      $negative=1;
      var $13=$3;
      var $14=(((-$13))|0);
      $3=$14;
      __label__ = 4; break;
    case 4: // $15
      var $16=$3;
      var $17=(($4+16608)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($16)|0) < (($18)|0);
      if ($19) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $20
      $3=0;
      __label__ = 10; break;
    case 6: // $21
      var $22=$3;
      var $23=(($4+16612)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($22)|0) > (($24)|0);
      if ($25) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $26
      $3=65536;
      __label__ = 9; break;
    case 8: // $27
      var $28=$3;
      var $29=(($4+16608)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($28-$30)|0);
      var $32$0=$31;
      var $32$1=(($31|0) < 0 ? -1 : 0);
      var $$emscripten$temp$0$0=65536;
      var $$emscripten$temp$0$1=0;
      var $33$0 = ((($32$0)>>>0)+((($32$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $33$1 = Math.min(Math.floor((((($32$0)>>>0)+((($32$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $34=(($4+16612)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($4+16608)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($35-$37)|0);
      var $39$0=$38;
      var $39$1=(($38|0) < 0 ? -1 : 0);
      var $40$0 = (tempBigIntR=((($33$0)>>>0)+((($33$1)|0)*4294967296))/((($39$0)>>>0)+((($39$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $40$1 = Math.min(Math.floor(((tempBigIntR=((($33$0)>>>0)+((($33$1)|0)*4294967296))/((($39$0)>>>0)+((($39$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $41$0=$40$0;
      var $41=$41$0;
      $3=$41;
      __label__ = 9; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      var $44=$negative;
      var $45=(($44) & 1);
      if ($45) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $46
      var $47=$3;
      var $48=(((-$47))|0);
      var $52 = $48;__label__ = 13; break;
    case 12: // $49
      var $50=$3;
      var $52 = $50;__label__ = 13; break;
    case 13: // $51
      var $52;
      $1=$52;
      __label__ = 14; break;
    case 14: // $53
      var $54=$1;
      ;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12input_device29apply_deadzone_and_saturationEi["X"]=1;

function __ZNK12input_device15apply_steadykeyEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $anything_changed;
      var $itemid=__stackBase__;
      var $item;
      var $itemid1=__stackBase__+4;
      var $item2;
      $1=$this;
      var $2=$1;
      var $3=(($2+16616)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      __label__ = 20; break;
    case 2: // $7
      $anything_changed=0;
      HEAP32[(($itemid)>>2)]=1;
      __label__ = 3; break;
    case 3: // $8
      var $9=HEAP32[(($itemid)>>2)];
      var $10=(($2+16452)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($9)|0) <= (($11)|0);
      if ($12) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $13
      var $14=HEAP32[(($itemid)>>2)];
      var $15=(($2+72)|0);
      var $16=(($15+($14<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      $item=$17;
      var $18=$item;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $20
      var $21=$item;
      var $22=__ZNK17input_device_item9itemclassEv($21);
      var $23=(($22)|0)==1;
      if ($23) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $24
      var $25=$item;
      var $26=__Z8downcastIP24input_device_switch_item17input_device_itemET_PT0_($25);
      var $27=__ZN24input_device_switch_item17steadykey_changedEv($26);
      if ($27) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $28
      $anything_changed=1;
      __label__ = 8; break;
    case 8: // $29
      __label__ = 9; break;
    case 9: // $30
      __label__ = 10; break;
    case 10: // $31
      __ZppR13input_item_idi($itemid, 0);
      __label__ = 3; break;
    case 11: // $32
      var $33=$anything_changed;
      var $34=(($33) & 1);
      if ($34) { __label__ = 20; break; } else { __label__ = 12; break; }
    case 12: // $35
      HEAP32[(($itemid1)>>2)]=1;
      __label__ = 13; break;
    case 13: // $36
      var $37=HEAP32[(($itemid1)>>2)];
      var $38=(($2+16452)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($37)|0) <= (($39)|0);
      if ($40) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $41
      var $42=HEAP32[(($itemid1)>>2)];
      var $43=(($2+72)|0);
      var $44=(($43+($42<<2))|0);
      var $45=HEAP32[(($44)>>2)];
      $item2=$45;
      var $46=$item2;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $48
      var $49=$item2;
      var $50=__ZNK17input_device_item9itemclassEv($49);
      var $51=(($50)|0)==1;
      if ($51) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $52
      var $53=$item2;
      var $54=__Z8downcastIP24input_device_switch_item17input_device_itemET_PT0_($53);
      __ZN24input_device_switch_item27steadykey_update_to_currentEv($54);
      __label__ = 17; break;
    case 17: // $55
      __label__ = 18; break;
    case 18: // $56
      __ZppR13input_item_idi($itemid1, 0);
      __label__ = 13; break;
    case 19: // $57
      __label__ = 20; break;
    case 20: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12input_device15apply_steadykeyEv["X"]=1;

function __ZN24input_device_switch_item17steadykey_changedEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $old;
      $2=$this;
      var $3=$2;
      var $4=(($3+164)|0);
      var $5=HEAP32[(($4)>>2)];
      $old=$5;
      var $6=$3;
      var $7=__ZN17input_device_item12update_valueEv($6);
      var $8=(($3+164)|0);
      HEAP32[(($8)>>2)]=$7;
      var $9=$3;
      var $10=(($9+152)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$old;
      var $13=$11 ^ $12;
      var $14=$13 & 1;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=0;
      __label__ = 5; break;
    case 2: // $17
      var $18=$3;
      var $19=(($18+152)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($3+160)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$20 | $22;
      var $24=$23 & 1;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=(($3+160)|0);
      HEAP32[(($27)>>2)]=1;
      __label__ = 4; break;
    case 4: // $28
      $1=1;
      __label__ = 5; break;
    case 5: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11input_classC2ER13input_manager18input_device_classbb($this, $manager, $devclass, $enabled, $multi) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+24;
      $1=$this;
      $2=$manager;
      $3=$devclass;
      var $8=(($enabled)&1);
      $4=$8;
      var $9=(($multi)&1);
      $5=$9;
      var $10=$1;
      var $11=(($10)|0);
      var $12=$2;
      HEAP32[(($11)>>2)]=$12;
      var $13=(($10+1024)|0);
      var $14=$3;
      HEAP32[(($13)>>2)]=$14;
      var $15=(($10+1028)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($10+1032)|0);
      var $17=$4;
      var $18=(($17) & 1);
      var $19=(($18)&1);
      HEAP8[($16)]=$19;
      var $20=(($10+1033)|0);
      var $21=$5;
      var $22=(($21) & 1);
      var $23=(($22)&1);
      HEAP8[($20)]=$23;
      var $24=(($10+4)|0);
      var $25=(($24)|0);
      var $26=$25;
      _memset($26, 0, 1020, 1);
      var $27=$3;
      var $28=(($27)|0)==1;
      if ($28) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $29
      var $30=__ZNK11input_class7machineEv($10);
      HEAP32[(($7)>>2)]={ f0: 188, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 188, f1: 0 }.f1;
      __ZN8delegateIFvvEEC1I11input_classEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($6, $7, ((STRING_TABLE.__str2142412)|0), $10);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($30, 0, $6);
      __label__ = 2; break;
    case 2: // $31
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11input_class7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK13input_manager7machineEv($4);
  ;
  return $5;
}


function __ZN8delegateIFvvEEC1I11input_classEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I11input_classEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN11input_class14frame_callbackEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $devnum;
      $1=$this;
      var $2=$1;
      $devnum=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$devnum;
      var $5=(($2+1028)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4)|0) <= (($6)|0);
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$devnum;
      var $10=(($2+4)|0);
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$devnum;
      var $16=(($2+4)|0);
      var $17=(($16+($15<<2))|0);
      var $18=HEAP32[(($17)>>2)];
      __ZNK12input_device15apply_steadykeyEv($18);
      __label__ = 4; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$devnum;
      var $22=(($21+1)|0);
      $devnum=$22;
      __label__ = 1; break;
    case 6: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11input_class10add_deviceEPKcPv($this, $name, $internal) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $devindex;
      $1=$this;
      $2=$name;
      $3=$internal;
      var $4=$1;
      $devindex=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$devindex;
      var $7=(($6)|0) < 255;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$devindex;
      var $10=(($4+4)|0);
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      __label__ = 6; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$devindex;
      var $18=(($17+1)|0);
      $devindex=$18;
      __label__ = 1; break;
    case 6: // $19
      var $20=$devindex;
      var $21=$2;
      var $22=$3;
      var $23=__ZN11input_class10add_deviceEiPKcPv($4, $20, $21, $22);
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI26input_device_relative_itemEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI26input_device_relative_itemEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI26input_device_relative_itemEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI26input_device_absolute_itemEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI26input_device_absolute_itemEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI26input_device_absolute_itemEEPT_S3_["X"]=1;

function __ZN11input_class10add_deviceEiPKcPv($this, $devindex, $name, $internal) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $device;
      $9=$this;
      $10=$devindex;
      $11=$name;
      $12=$internal;
      var $15=$9;
      __label__ = 1; break;
    case 1: // $16
      var $17=__ZNK11input_class7machineEv($15);
      var $18=__ZNK15running_machine5phaseEv($17);
      var $19=(($18)|0)==1;
      if ($19) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $20
      var $21=___cxa_allocate_exception(1032);
      var $22=$21;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($22, ((STRING_TABLE.__str2112409)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str2152413)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2132411)|0),HEAP32[((tempInt+8)>>2)]=1049,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      ___cxa_throw($21, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $13=$26;
      var $27=$25.f1;
      $14=$27;
      ___cxa_free_exception($21);
      __label__ = 29; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      __label__ = 8; break;
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      __label__ = 10; break;
    case 10: // $33
      __label__ = 11; break;
    case 11: // $34
      __label__ = 12; break;
    case 12: // $35
      var $36=__ZNK11input_class7machineEv($15);
      var $37=__ZN15running_machine7respoolEv($36);
      var $38=$4;
      var $39=$5;
      var $40=$6;
      var $41=$result_i;
      var $42=$7;
      var $43=$8;
      HEAP32[(($4)>>2)]=16620;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($6)>>2)]=1055;
      var $44=HEAP32[(($4)>>2)];
      var $45=HEAP32[(($5)>>2)];
      var $46=HEAP32[(($6)>>2)];
      var $47=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($44, $45, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $48
      HEAP32[(($result_i)>>2)]=$47;
      var $49=HEAP32[(($result_i)>>2)];
      var $50=(($49)|0)==0;
      if ($50) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $51
      var $52=___cxa_allocate_exception(4);
      var $53=$52;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($53);
      (function() { try { __THREW__ = false; return ___cxa_throw($52, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 15: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      HEAP32[(($7)>>2)]=$56;
      var $57=$55.f1;
      HEAP32[(($8)>>2)]=$57;
      var $58=HEAP32[(($8)>>2)];
      var $59=(($58)|0) < 0;
      if ($59) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $60
      var $61=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($61);
      throw "Reached an unreachable!"
    case 17: // $62
      var $63=HEAP32[(($7)>>2)];
      var $64=HEAP32[(($7)>>2)];
      var $65=HEAP32[(($8)>>2)];
      var $66=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $64, tempValue);
      var $67=($66.f1 = $65, $66);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $68
      throw "Reached an unreachable!"
    case 19: // $_ZnwjPKci_exit
      var $69=HEAP32[(($result_i)>>2)];
      var $70=$4;
      var $71=$5;
      var $72=$6;
      var $73=$result_i;
      var $74=$7;
      var $75=$8;
      var $76=$69;
      var $77=$10;
      var $78=$11;
      var $79=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12input_deviceC1ER11input_classiPKcPv]($76, $15, $77, $78, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $80
      var $81=__ZN13resource_pool10add_objectI12input_deviceEEPT_S3_($37, $76);
      var $82=$10;
      var $83=(($15+4)|0);
      var $84=(($83+($82<<2))|0);
      HEAP32[(($84)>>2)]=$81;
      $device=$81;
      var $85=(($15+1028)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$10;
      var $88=(($86)|0) > (($87)|0);
      if ($88) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $89
      var $90=(($15+1028)|0);
      var $91=HEAP32[(($90)>>2)];
      var $95 = $91;__label__ = 23; break;
    case 22: // $92
      var $93=$10;
      var $95 = $93;__label__ = 23; break;
    case 23: // $94
      var $95;
      var $96=(($15+1028)|0);
      HEAP32[(($96)>>2)]=$95;
      var $97=(($15+1024)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=__ZNK17code_string_tableixEj(((__ZL21devclass_string_table)|0), $98);
      var $100=$10;
      var $101=$11;
      __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str2162414)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$99,HEAP32[((tempInt+4)>>2)]=$100,HEAP32[((tempInt+8)>>2)]=$101,tempInt));
      var $102=$device;
      STACKTOP = __stackBase__;
      return $102;
    case 24: // $103
      var $104=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $105=$104.f0;
      $13=$105;
      var $106=$104.f1;
      $14=$106;
      var $107=$1;
      var $108=$2;
      var $109=$3;
      HEAP32[(($1)>>2)]=$69;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2132411)|0);
      HEAP32[(($3)>>2)]=1055;
      var $110=HEAP32[(($1)>>2)];
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $112
      var $113=HEAP32[(($1)>>2)];
      var $114=HEAP32[(($2)>>2)];
      var $115=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($113, $114, $115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $_noexc
      __label__ = 27; break;
    case 27: // $_ZdlPvPKci_exit
      var $116=$1;
      var $117=$2;
      var $118=$3;
      __label__ = 28; break;
    case 28: // $119
      __label__ = 29; break;
    case 29: // $120
      var $121=$13;
      var $122=$13;
      var $123=$14;
      var $124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $122, tempValue);
      var $125=($124.f1 = $123, $124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11input_class10add_deviceEiPKcPv["X"]=1;

function __ZppR18input_device_classi($value, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$value;
  $3=$0;
  var $4=$2;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=$2;
  HEAP32[(($7)>>2)]=$6;
  ;
  return;
}


function __ZNK17code_string_tableixEj($this, $code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $current;
      $2=$this;
      $3=$code;
      var $4=$2;
      $current=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$current;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=-1;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$current;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$current;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      $1=$19;
      __label__ = 7; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$current;
      var $23=(($22+8)|0);
      $current=$23;
      __label__ = 1; break;
    case 6: // $24
      $1=0;
      __label__ = 7; break;
    case 7: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10input_code12device_classEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4 >>> 28;
  var $6=$5 & 15;
  ;
  return $6;
}


function __ZNK10input_code12device_indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4 >>> 20;
  var $6=$5 & 255;
  ;
  return $6;
}


function __ZNK11input_class5multiEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1033)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK11input_class8maxindexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1028)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN10input_code16set_device_indexEi($this, $devindex) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$devindex;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=(($3)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & -267386881;
      var $9=$2;
      var $10=$9 & 255;
      var $11=$10 << 20;
      var $12=$8 | $11;
      var $13=(($3)|0);
      HEAP32[(($13)>>2)]=$12;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10input_code13item_modifierEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU32[(($3)>>2)];
  var $5=$4 >>> 12;
  var $6=$5 & 15;
  ;
  return $6;
}


function __ZNK11input_class6deviceEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      var $4=$2;
      var $5=(($3+1028)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4)|0) <= (($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($3+4)|0);
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $15 = $12;__label__ = 3; break;
    case 2: // $13
      var $15 = 0;__label__ = 3; break;
    case 3: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12input_device7maxitemEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16452)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN17input_device_item10set_memoryEi($this, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$value;
  var $3=$1;
  var $4=$2;
  var $5=(($3+156)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN13input_managerC2ER15running_machine($this, $machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+4;
      var $5=__stackBase__+8;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      $1=$this;
      $2=$machine;
      var $10=$1;
      var $11=(($10)|0);
      var $12=$2;
      HEAP32[(($11)>>2)]=$12;
      var $13=(($10+4)|0);
      var $14=(($13)|0);
      var $15=(($14+256)|0);
      var $17 = $14;__label__ = 1; break;
    case 1: // $16
      var $17;
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($17, 0, 0, 0, 0, 0);
      var $18=(($17+4)|0);
      var $19=(($18)|0)==(($15)|0);
      if ($19) { __label__ = 2; break; } else { var $17 = $18;__label__ = 1; break; }
    case 2: // $20
      var $21=(($10+260)|0);
      var $22=$2;
      var $23=__ZNK15running_machine7optionsEv($22);
      var $24=__ZNK11emu_options14multi_keyboardEv($23);
      FUNCTION_TABLE[__ZN11input_classC1ER13input_manager18input_device_classbb]($21, $10, 1, 1, $24);
      var $25=(($10+1296)|0);
      var $26=$2;
      var $27=__ZNK15running_machine7optionsEv($26);
      var $28=__ZNK11emu_options5mouseEv($27);
      var $29=$2;
      var $30=__ZNK15running_machine7optionsEv($29);
      var $31=__ZNK11emu_options11multi_mouseEv($30);
      FUNCTION_TABLE[__ZN11input_classC1ER13input_manager18input_device_classbb]($25, $10, 2, $28, $31);
      var $32=(($10+2332)|0);
      var $33=$2;
      var $34=__ZNK15running_machine7optionsEv($33);
      var $35=__ZNK11emu_options8joystickEv($34);
      FUNCTION_TABLE[__ZN11input_classC1ER13input_manager18input_device_classbb]($32, $10, 4, $35, 1);
      var $36=(($10+3368)|0);
      var $37=$2;
      var $38=__ZNK15running_machine7optionsEv($37);
      var $39=__ZNK11emu_options8lightgunEv($38);
      FUNCTION_TABLE[__ZN11input_classC1ER13input_manager18input_device_classbb]($36, $10, 3, $39, 1);
      var $40=(($10+4428)|0);
      __ZN10input_codeC1ERKS_($3, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($9, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($40, $3, $4, $5, $6, $7, $8, $9);
      var $41=(($10+4492)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$35$0=(($41)|0);
      HEAP32[(($st$35$0)>>2)]=$$emscripten$temp$0$0;
      var $st$35$1=(($41+4)|0);
      HEAP32[(($st$35$1)>>2)]=$$emscripten$temp$0$1;
      var $42=(($10+4500)|0);
      HEAP32[(($42)>>2)]=1;
      __ZN13input_manager12reset_memoryEv($10);
      var $43=(($10+4404)|0);
      var $44=(($43)|0);
      var $45=$44;
      _memset($45, 0, 24, 1);
      var $46=(($10+260)|0);
      var $47=(($10+4404)|0);
      var $48=(($47+4)|0);
      HEAP32[(($48)>>2)]=$46;
      var $49=(($10+1296)|0);
      var $50=(($10+4404)|0);
      var $51=(($50+8)|0);
      HEAP32[(($51)>>2)]=$49;
      var $52=(($10+2332)|0);
      var $53=(($10+4404)|0);
      var $54=(($53+16)|0);
      HEAP32[(($54)>>2)]=$52;
      var $55=(($10+3368)|0);
      var $56=(($10+4404)|0);
      var $57=(($56+12)|0);
      HEAP32[(($57)>>2)]=$55;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_managerC2ER15running_machine["X"]=1;

function __ZNK11emu_options14multi_keyboardEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2502448)|0));
  ;
  return $4;
}


function __ZNK11emu_options5mouseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2492447)|0));
  ;
  return $4;
}


function __ZNK11emu_options11multi_mouseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2482446)|0));
  ;
  return $4;
}


function __ZNK11emu_options8joystickEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2472445)|0));
  ;
  return $4;
}


function __ZNK11emu_options8lightgunEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str2462444)|0));
  ;
  return $4;
}


function __ZN13input_manager12reset_memoryEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $memnum;
      var $2=__stackBase__;
      $1=$this;
      var $3=$1;
      $memnum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$memnum;
      var $6=(($5)>>>0) < 64;
      if ($6) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $7
      var $8=$memnum;
      var $9=(($3+4)|0);
      var $10=(($9+($8<<2))|0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($2, 0, 0, 0, 0, 0);
      var $11=$10;
      var $12=$2;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];
      __label__ = 3; break;
    case 3: // $13
      var $14=$memnum;
      var $15=(($14+1)|0);
      $memnum=$15;
      __label__ = 1; break;
    case 4: // $16
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13input_manager10code_valueE10input_code($this, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      var $device;
      var $2=__stackBase__;
      var $devclass;
      var $startindex;
      var $stopindex;
      var $targetclass;
      var $curindex;
      var $item;
      var $3=__stackBase__+4;
      $1=$this;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 270);
      $result=0;
      __label__ = 1; break;
    case 1: // $5
      __ZN10input_codeC1ERKS_($2, $code);
      var $6=__ZNK13input_manager16device_from_codeE10input_code($4, $2);
      $device=$6;
      var $7=$device;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      __label__ = 23; break;
    case 3: // $10
      var $11=__ZNK10input_code12device_classEv($code);
      var $12=(($4+4404)|0);
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      $devclass=$14;
      var $15=$devclass;
      var $16=__ZNK11input_class7enabledEv($15);
      if ($16) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $17
      __label__ = 23; break;
    case 5: // $18
      var $19=__ZNK10input_code12device_indexEv($code);
      $startindex=$19;
      var $20=$startindex;
      $stopindex=$20;
      var $21=$devclass;
      var $22=__ZNK11input_class5multiEv($21);
      if ($22) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $23
      var $24=$startindex;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $26
      __label__ = 23; break;
    case 8: // $27
      var $28=$devclass;
      var $29=__ZNK11input_class8maxindexEv($28);
      $stopindex=$29;
      __label__ = 9; break;
    case 9: // $30
      var $31=__ZNK10input_code10item_classEv($code);
      $targetclass=$31;
      var $32=$startindex;
      $curindex=$32;
      __label__ = 10; break;
    case 10: // $33
      var $34=$curindex;
      var $35=$stopindex;
      var $36=(($34)|0) <= (($35)|0);
      if ($36) { __label__ = 11; break; } else { __label__ = 22; break; }
    case 11: // $37
      var $38=$curindex;
      __ZN10input_code16set_device_indexEi($code, $38);
      __ZN10input_codeC1ERKS_($3, $code);
      var $39=__ZNK13input_manager14item_from_codeE10input_code($4, $3);
      $item=$39;
      var $40=$item;
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $42
      __label__ = 21; break;
    case 13: // $43
      var $44=$targetclass;
      if ($44 == 2) {
        __label__ = 14; break;
      }
      else if ($44 == 3) {
        __label__ = 17; break;
      }
      else if ($44 == 1) {
        __label__ = 18; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 14: // $45
      var $46=$result;
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $48
      var $49=$item;
      var $50=$49;
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+16)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=__ZNK10input_code13item_modifierEv($code);
      var $55=FUNCTION_TABLE[$53]($49, $54);
      $result=$55;
      __label__ = 16; break;
    case 16: // $56
      __label__ = 20; break;
    case 17: // $57
      var $58=$item;
      var $59=$58;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__ZNK10input_code13item_modifierEv($code);
      var $64=FUNCTION_TABLE[$62]($58, $63);
      var $65=$result;
      var $66=(($65+$64)|0);
      $result=$66;
      __label__ = 20; break;
    case 18: // $67
      var $68=$item;
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=__ZNK10input_code13item_modifierEv($code);
      var $74=FUNCTION_TABLE[$72]($68, $73);
      var $75=$result;
      var $76=$75 | $74;
      $result=$76;
      __label__ = 20; break;
    case 19: // $77
      __label__ = 20; break;
    case 20: // $78
      __label__ = 21; break;
    case 21: // $79
      var $80=$curindex;
      var $81=(($80+1)|0);
      $curindex=$81;
      __label__ = 10; break;
    case 22: // $82
      __label__ = 23; break;
    case 23: // $83
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $84=$result;
      STACKTOP = __stackBase__;
      return $84;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager10code_valueE10input_code["X"]=1;

function __ZNK13input_manager16device_from_codeE10input_code($this, $code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $devclass;
      $2=$this;
      var $3=$2;
      var $4=__ZNK10input_code12device_classEv($code);
      $devclass=$4;
      var $5=$devclass;
      var $6=(($5)|0) >= 1;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$devclass;
      var $9=(($8)|0) <= 4;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$devclass;
      var $12=(($3+4404)|0);
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK10input_code12device_indexEv($code);
      var $16=__ZNK11input_class6deviceEi($14, $15);
      $1=$16;
      __label__ = 4; break;
    case 3: // $17
      $1=0;
      __label__ = 4; break;
    case 4: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13input_manager14item_from_codeE10input_code($this, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $device;
      var $3=__stackBase__;
      $2=$this;
      var $4=$2;
      __ZN10input_codeC1ERKS_($3, $code);
      var $5=__ZNK13input_manager16device_from_codeE10input_code($4, $3);
      $device=$5;
      var $6=$device;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 3; break;
    case 2: // $9
      var $10=$device;
      var $11=__ZNK10input_code7item_idEv($code);
      var $12=__ZNK12input_device4itemE13input_item_id($10, $11);
      $1=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$1;
      STACKTOP = __stackBase__;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13input_manager17code_pressed_onceE10input_code($this, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curvalue;
      var $3=__stackBase__;
      var $empty;
      var $memnum;
      var $4=__stackBase__+4;
      var $5=__stackBase__+8;
      $2=$this;
      var $6=$2;
      __ZN10input_codeC1ERKS_($3, $code);
      var $7=__ZN13input_manager12code_pressedE10input_code($6, $3);
      var $8=(($7)&1);
      $curvalue=$8;
      $empty=-1;
      $memnum=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$memnum;
      var $11=(($10)>>>0) < 64;
      if ($11) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $12
      var $13=$memnum;
      var $14=(($6+4)|0);
      var $15=(($14+($13<<2))|0);
      var $16=__ZNK10input_codeeqERKS_($15, $code);
      if ($16) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $17
      var $18=$curvalue;
      var $19=(($18) & 1);
      var $20=(($19)&1);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      var $23=$memnum;
      var $24=(($6+4)|0);
      var $25=(($24+($23<<2))|0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4, 0, 0, 0, 0, 0);
      var $26=$25;
      var $27=$4;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[(($27)>>2)];
      __label__ = 5; break;
    case 5: // $28
      $1=0;
      __label__ = 18; break;
    case 6: // $29
      var $30=$empty;
      var $31=(($30)|0)==-1;
      if ($31) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $32
      var $33=$memnum;
      var $34=(($6+4)|0);
      var $35=(($34+($33<<2))|0);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 0, 0, 0, 0, 0);
      var $36=__ZNK10input_codeeqERKS_($35, $5);
      if ($36) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $37
      var $38=$memnum;
      $empty=$38;
      __label__ = 9; break;
    case 9: // $39
      __label__ = 10; break;
    case 10: // $40
      var $41=$memnum;
      var $42=(($41+1)|0);
      $memnum=$42;
      __label__ = 1; break;
    case 11: // $43
      var $44=$curvalue;
      var $45=(($44) & 1);
      var $46=(($45)&1);
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $48
      $1=0;
      __label__ = 18; break;
    case 13: // $49
      __label__ = 14; break;
    case 14: // $50
      __label__ = 15; break;
    case 15: // $51
      var $52=$empty;
      var $53=(($52)|0)!=-1;
      if ($53) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $54
      var $55=$empty;
      var $56=(($6+4)|0);
      var $57=(($56+($55<<2))|0);
      var $58=$57;
      var $59=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($58)>>2)]=HEAP32[(($59)>>2)];
      __label__ = 17; break;
    case 17: // $60
      $1=1;
      __label__ = 18; break;
    case 18: // $61
      var $62=$1;
      STACKTOP = __stackBase__;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager17code_pressed_onceE10input_code["X"]=1;

function __ZN13input_manager12code_pressedE10input_code($this, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $3=$1;
  __ZN10input_codeC1ERKS_($2, $code);
  var $4=__ZN13input_manager10code_valueE10input_code($3, $2);
  var $5=(($4)|0)!=0;
  STACKTOP = __stackBase__;
  return $5;
}


function __ZN13input_manager13reset_pollingEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $devclass=__stackBase__;
      var $devnum;
      var $device;
      var $itemid=__stackBase__+4;
      var $item;
      var $2=__stackBase__+8;
      $1=$this;
      var $3=$1;
      __ZN13input_manager12reset_memoryEv($3);
      HEAP32[(($devclass)>>2)]=1;
      __label__ = 1; break;
    case 1: // $4
      var $5=HEAP32[(($devclass)>>2)];
      var $6=(($5)|0) <= 4;
      if ($6) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $7
      $devnum=0;
      __label__ = 3; break;
    case 3: // $8
      var $9=$devnum;
      var $10=HEAP32[(($devclass)>>2)];
      var $11=(($3+4404)|0);
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK11input_class8maxindexEv($13);
      var $15=(($9)|0) <= (($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $16
      var $17=HEAP32[(($devclass)>>2)];
      var $18=(($3+4404)|0);
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$devnum;
      var $22=__ZNK11input_class6deviceEi($20, $21);
      $device=$22;
      var $23=$device;
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      __label__ = 14; break;
    case 6: // $26
      HEAP32[(($itemid)>>2)]=1;
      __label__ = 7; break;
    case 7: // $27
      var $28=HEAP32[(($itemid)>>2)];
      var $29=$device;
      var $30=__ZNK12input_device7maxitemEv($29);
      var $31=(($28)|0) <= (($30)|0);
      if ($31) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $32
      var $33=$device;
      var $34=HEAP32[(($itemid)>>2)];
      var $35=__ZNK12input_device4itemE13input_item_id($33, $34);
      $item=$35;
      var $36=$item;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $38
      var $39=$item;
      var $40=__ZNK17input_device_item9itemclassEv($39);
      var $41=(($40)|0)!=1;
      if ($41) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $42
      var $43=$item;
      var $44=$device;
      var $45=HEAP32[(($itemid)>>2)];
      FUNCTION_TABLE[__ZN10input_codeC1ER12input_device13input_item_id]($2, $44, $45);
      var $46=__ZN13input_manager10code_valueE10input_code($3, $2);
      __ZN17input_device_item10set_memoryEi($43, $46);
      __label__ = 11; break;
    case 11: // $47
      __label__ = 12; break;
    case 12: // $48
      __ZppR13input_item_idi($itemid, 0);
      __label__ = 7; break;
    case 13: // $49
      __label__ = 14; break;
    case 14: // $50
      var $51=$devnum;
      var $52=(($51+1)|0);
      $devnum=$52;
      __label__ = 3; break;
    case 15: // $53
      __label__ = 16; break;
    case 16: // $54
      __ZppR18input_device_classi($devclass, 0);
      __label__ = 1; break;
    case 17: // $55
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager13reset_pollingEv["X"]=1;

function __ZN13resource_pool10add_objectI12input_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12input_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12input_deviceEEPT_S3_["X"]=1;

function __ZN10input_code14set_item_classE16input_item_class($this, $itemclass) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$itemclass;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=(($3)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & -983041;
      var $9=$2;
      var $10=$9 & 15;
      var $11=$10 << 16;
      var $12=$8 | $11;
      var $13=(($3)|0);
      HEAP32[(($13)>>2)]=$12;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10input_code7item_idEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4 & 4095;
  ;
  return $5;
}


function __ZN10input_code17set_item_modifierE19input_item_modifier($this, $modifier) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$modifier;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=(($3)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & -61441;
      var $9=$2;
      var $10=$9 & 15;
      var $11=$10 << 12;
      var $12=$8 | $11;
      var $13=(($3)|0);
      HEAP32[(($13)>>2)]=$12;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17input_device_item6memoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+156)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17input_device_item6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13input_manager13poll_switchesEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $devclass=__stackBase__;
      var $devnum;
      var $device;
      var $itemid=__stackBase__+4;
      var $item;
      var $code=__stackBase__+8;
      var $2=__stackBase__+12;
      var $3=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      $1=$this;
      var $10=$1;
      HEAP32[(($devclass)>>2)]=1;
      __label__ = 1; break;
    case 1: // $11
      var $12=HEAP32[(($devclass)>>2)];
      var $13=(($12)|0) <= 4;
      if ($13) { __label__ = 2; break; } else { __label__ = 42; break; }
    case 2: // $14
      $devnum=0;
      __label__ = 3; break;
    case 3: // $15
      var $16=$devnum;
      var $17=HEAP32[(($devclass)>>2)];
      var $18=(($10+4404)|0);
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZNK11input_class8maxindexEv($20);
      var $22=(($16)|0) <= (($21)|0);
      if ($22) { __label__ = 4; break; } else { __label__ = 40; break; }
    case 4: // $23
      var $24=HEAP32[(($devclass)>>2)];
      var $25=(($10+4404)|0);
      var $26=(($25+($24<<2))|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$devnum;
      var $29=__ZNK11input_class6deviceEi($27, $28);
      $device=$29;
      var $30=$device;
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      __label__ = 39; break;
    case 6: // $33
      HEAP32[(($itemid)>>2)]=1;
      __label__ = 7; break;
    case 7: // $34
      var $35=HEAP32[(($itemid)>>2)];
      var $36=$device;
      var $37=__ZNK12input_device7maxitemEv($36);
      var $38=(($35)|0) <= (($37)|0);
      if ($38) { __label__ = 8; break; } else { __label__ = 38; break; }
    case 8: // $39
      var $40=$device;
      var $41=HEAP32[(($itemid)>>2)];
      var $42=__ZNK12input_device4itemE13input_item_id($40, $41);
      $item=$42;
      var $43=$item;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 9; break; } else { __label__ = 36; break; }
    case 9: // $45
      var $46=$device;
      var $47=HEAP32[(($itemid)>>2)];
      FUNCTION_TABLE[__ZN10input_codeC1ER12input_device13input_item_id]($code, $46, $47);
      var $48=$item;
      var $49=__ZNK17input_device_item9itemclassEv($48);
      var $50=(($49)|0)==1;
      if ($50) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $51
      __ZN10input_codeC1ERKS_($2, $code);
      var $52=__ZN13input_manager17code_pressed_onceE10input_code($10, $2);
      if ($52) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $53
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 12: // $54
      __label__ = 37; break;
    case 13: // $55
      var $56=$item;
      __ZN10input_codeC1ERKS_($3, $code);
      var $57=__ZN13input_manager15code_check_axisER17input_device_item10input_code($10, $56, $3);
      if ($57) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $58
      __label__ = 37; break;
    case 15: // $59
      __ZN10input_code14set_item_classE16input_item_class($code, 1);
      var $60=HEAP32[(($devclass)>>2)];
      var $61=(($60)|0)==4;
      if ($61) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $62
      var $63=__ZNK10input_code7item_idEv($code);
      var $64=(($63)|0)==110;
      if ($64) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $65
      __ZN10input_code17set_item_modifierE19input_item_modifier($code, 3);
      __ZN10input_codeC1ERKS_($4, $code);
      var $66=__ZN13input_manager17code_pressed_onceE10input_code($10, $4);
      if ($66) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $67
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 19: // $68
      __ZN10input_code17set_item_modifierE19input_item_modifier($code, 4);
      __ZN10input_codeC1ERKS_($5, $code);
      var $69=__ZN13input_manager17code_pressed_onceE10input_code($10, $5);
      if ($69) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $70
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 21: // $71
      __label__ = 35; break;
    case 22: // $72
      var $73=HEAP32[(($devclass)>>2)];
      var $74=(($73)|0)==4;
      if ($74) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $75
      var $76=__ZNK10input_code7item_idEv($code);
      var $77=(($76)|0)==111;
      if ($77) { __label__ = 24; break; } else { __label__ = 29; break; }
    case 24: // $78
      __ZN10input_code17set_item_modifierE19input_item_modifier($code, 5);
      __ZN10input_codeC1ERKS_($6, $code);
      var $79=__ZN13input_manager17code_pressed_onceE10input_code($10, $6);
      if ($79) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $80
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 26: // $81
      __ZN10input_code17set_item_modifierE19input_item_modifier($code, 6);
      __ZN10input_codeC1ERKS_($7, $code);
      var $82=__ZN13input_manager17code_pressed_onceE10input_code($10, $7);
      if ($82) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $83
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 28: // $84
      __label__ = 34; break;
    case 29: // $85
      __ZN10input_code17set_item_modifierE19input_item_modifier($code, 1);
      __ZN10input_codeC1ERKS_($8, $code);
      var $86=__ZN13input_manager17code_pressed_onceE10input_code($10, $8);
      if ($86) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $87
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 31: // $88
      __ZN10input_code17set_item_modifierE19input_item_modifier($code, 2);
      __ZN10input_codeC1ERKS_($9, $code);
      var $89=__ZN13input_manager17code_pressed_onceE10input_code($10, $9);
      if ($89) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $90
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 43; break;
    case 33: // $91
      __label__ = 34; break;
    case 34: // $92
      __label__ = 35; break;
    case 35: // $93
      __label__ = 36; break;
    case 36: // $94
      __label__ = 37; break;
    case 37: // $95
      __ZppR13input_item_idi($itemid, 0);
      __label__ = 7; break;
    case 38: // $96
      __label__ = 39; break;
    case 39: // $97
      var $98=$devnum;
      var $99=(($98+1)|0);
      $devnum=$99;
      __label__ = 3; break;
    case 40: // $100
      __label__ = 41; break;
    case 41: // $101
      __ZppR18input_device_classi($devclass, 0);
      __label__ = 1; break;
    case 42: // $102
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0);
      __label__ = 43; break;
    case 43: // $103
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager13poll_switchesEv["X"]=1;

function __ZN13input_manager15code_check_axisER17input_device_item10input_code($this, $item, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curval;
      var $4=__stackBase__;
      var $diff;
      $2=$this;
      $3=$item;
      var $5=$2;
      var $6=$3;
      var $7=__ZNK17input_device_item6memoryEv($6);
      var $8=(($7)|0)==2147483647;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 17; break;
    case 2: // $10
      __ZN10input_codeC1ERKS_($4, $code);
      var $11=__ZN13input_manager10code_valueE10input_code($5, $4);
      $curval=$11;
      var $12=__ZNK10input_code12device_classEv($code);
      var $13=(($12)|0)==3;
      if ($13) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $14
      var $15=__ZNK10input_code7item_idEv($code);
      var $16=(($15)|0)==110;
      if ($16) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $17
      var $18=__ZNK10input_code7item_idEv($code);
      var $19=(($18)|0)==111;
      if ($19) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $20
      var $21=$curval;
      var $22=(($21)|0)==65536;
      if ($22) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $23
      var $24=$curval;
      var $25=(($24)|0)==-65536;
      if ($25) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $26
      $1=0;
      __label__ = 17; break;
    case 8: // $27
      var $28=$curval;
      var $29=$3;
      var $30=__ZNK17input_device_item6memoryEv($29);
      var $31=(($28-$30)|0);
      $diff=$31;
      var $32=$diff;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      var $35=$diff;
      var $36=(((-$35))|0);
      $diff=$36;
      __label__ = 10; break;
    case 10: // $37
      var $38=$3;
      var $39=__ZNK17input_device_item9itemclassEv($38);
      var $40=(($39)|0)==2;
      if ($40) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $41
      var $42=$diff;
      var $43=(($42)|0) > 32768;
      if ($43) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $44
      var $45=$3;
      __ZN17input_device_item10set_memoryEi($45, 2147483647);
      $1=1;
      __label__ = 17; break;
    case 13: // $46
      var $47=$3;
      var $48=__ZNK17input_device_item9itemclassEv($47);
      var $49=(($48)|0)==3;
      if ($49) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $50
      var $51=$diff;
      var $52=(($51)|0) > 10240;
      if ($52) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $53
      var $54=$3;
      __ZN17input_device_item10set_memoryEi($54, 2147483647);
      $1=1;
      __label__ = 17; break;
    case 16: // $55
      $1=0;
      __label__ = 17; break;
    case 17: // $56
      var $57=$1;
      STACKTOP = __stackBase__;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager15code_check_axisER17input_device_item10input_code["X"]=1;

function __ZN13input_manager9poll_axesEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $devclass=__stackBase__;
      var $devnum;
      var $device;
      var $itemid=__stackBase__+4;
      var $item;
      var $code=__stackBase__+8;
      var $2=__stackBase__+12;
      $1=$this;
      var $3=$1;
      HEAP32[(($devclass)>>2)]=1;
      __label__ = 1; break;
    case 1: // $4
      var $5=HEAP32[(($devclass)>>2)];
      var $6=(($5)|0) <= 4;
      if ($6) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $7
      $devnum=0;
      __label__ = 3; break;
    case 3: // $8
      var $9=$devnum;
      var $10=HEAP32[(($devclass)>>2)];
      var $11=(($3+4404)|0);
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK11input_class8maxindexEv($13);
      var $15=(($9)|0) <= (($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 17; break; }
    case 4: // $16
      var $17=HEAP32[(($devclass)>>2)];
      var $18=(($3+4404)|0);
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$devnum;
      var $22=__ZNK11input_class6deviceEi($20, $21);
      $device=$22;
      var $23=$device;
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      __label__ = 16; break;
    case 6: // $26
      HEAP32[(($itemid)>>2)]=1;
      __label__ = 7; break;
    case 7: // $27
      var $28=HEAP32[(($itemid)>>2)];
      var $29=$device;
      var $30=__ZNK12input_device7maxitemEv($29);
      var $31=(($28)|0) <= (($30)|0);
      if ($31) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $32
      var $33=$device;
      var $34=HEAP32[(($itemid)>>2)];
      var $35=__ZNK12input_device4itemE13input_item_id($33, $34);
      $item=$35;
      var $36=$item;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $38
      var $39=$item;
      var $40=__ZNK17input_device_item9itemclassEv($39);
      var $41=(($40)|0)!=1;
      if ($41) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $42
      var $43=$device;
      var $44=HEAP32[(($itemid)>>2)];
      FUNCTION_TABLE[__ZN10input_codeC1ER12input_device13input_item_id]($code, $43, $44);
      var $45=$item;
      __ZN10input_codeC1ERKS_($2, $code);
      var $46=__ZN13input_manager15code_check_axisER17input_device_item10input_code($3, $45, $2);
      if ($46) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $47
      __ZN10input_codeC1ERKS_($agg_result, $code);
      __label__ = 20; break;
    case 12: // $48
      __label__ = 13; break;
    case 13: // $49
      __label__ = 14; break;
    case 14: // $50
      __ZppR13input_item_idi($itemid, 0);
      __label__ = 7; break;
    case 15: // $51
      __label__ = 16; break;
    case 16: // $52
      var $53=$devnum;
      var $54=(($53+1)|0);
      $devnum=$54;
      __label__ = 3; break;
    case 17: // $55
      __label__ = 18; break;
    case 18: // $56
      __ZppR18input_device_classi($devclass, 0);
      __label__ = 1; break;
    case 19: // $57
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0);
      __label__ = 20; break;
    case 20: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager9poll_axesEv["X"]=1;

function __ZNK13input_manager16code_from_itemidE13input_item_id($agg_result, $this, $itemid) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $devclass=__stackBase__;
      var $devnum;
      var $device;
      $1=$this;
      $2=$itemid;
      var $3=$1;
      HEAP32[(($devclass)>>2)]=1;
      __label__ = 1; break;
    case 1: // $4
      var $5=HEAP32[(($devclass)>>2)];
      var $6=(($5)|0) <= 4;
      if ($6) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $7
      $devnum=0;
      __label__ = 3; break;
    case 3: // $8
      var $9=$devnum;
      var $10=HEAP32[(($devclass)>>2)];
      var $11=(($3+4404)|0);
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK11input_class8maxindexEv($13);
      var $15=(($9)|0) <= (($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=HEAP32[(($devclass)>>2)];
      var $18=(($3+4404)|0);
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$devnum;
      var $22=__ZNK11input_class6deviceEi($20, $21);
      $device=$22;
      var $23=$device;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $25
      var $26=$device;
      var $27=$2;
      var $28=__ZNK12input_device4itemE13input_item_id($26, $27);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=$device;
      var $32=$2;
      FUNCTION_TABLE[__ZN10input_codeC1ER12input_device13input_item_id]($agg_result, $31, $32);
      __label__ = 12; break;
    case 7: // $33
      __label__ = 8; break;
    case 8: // $34
      var $35=$devnum;
      var $36=(($35+1)|0);
      $devnum=$36;
      __label__ = 3; break;
    case 9: // $37
      __label__ = 10; break;
    case 10: // $38
      __ZppR18input_device_classi($devclass, 0);
      __label__ = 1; break;
    case 11: // $39
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0);
      __label__ = 12; break;
    case 12: // $40
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13input_manager16code_from_itemidE13input_item_id["X"]=1;

function __ZNK17input_device_item4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK13input_manager9code_nameER7astring10input_code($this, $string, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $item;
      var $4=__stackBase__;
      var $devclass;
      var $devindex=__stackBase__+4;
      var $5;
      var $6;
      var $device_class;
      var $devcode;
      var $modifier;
      var $7;
      $2=$this;
      $3=$string;
      var $8=$2;
      var $9=$3;
      var $10=__ZN7astring5resetEv($9);
      __ZN10input_codeC1ERKS_($4, $code);
      var $11=__ZNK13input_manager14item_from_codeE10input_code($8, $4);
      $item=$11;
      var $12=$item;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$3;
      var $16=__ZNK7astringcvPKcEv($15);
      $1=$16;
      __label__ = 47; break;
    case 2: // $17
      var $18=__ZNK10input_code12device_classEv($code);
      var $19=__ZNK17code_string_tableixEj(((__ZL21devclass_string_table)|0), $18);
      $devclass=$19;
      __ZN7astringC1Ev($devindex);
      var $20=(function() { try { __THREW__ = false; return __ZNK10input_code12device_indexEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 9; break; };
    case 3: // $21
      var $22=(($20+1)|0);
      var $23=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($devindex, ((STRING_TABLE.__str2172415)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; };
    case 4: // $24
      var $25=(function() { try { __THREW__ = false; return __ZNK10input_code12device_classEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; };
    case 5: // $26
      var $27=(($8+4404)|0);
      var $28=(($27+($25<<2))|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(function() { try { __THREW__ = false; return __ZNK11input_class5multiEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $31
      if ($30) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $32
      var $33=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $34
      __label__ = 10; break;
    case 9: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $5=$37;
      var $38=$36.f1;
      $6=$38;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 49; break; }
    case 10: // $39
      var $40=$item;
      var $41=(function() { try { __THREW__ = false; return __ZNK17input_device_item6deviceEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $42
      var $43=(function() { try { __THREW__ = false; return __ZNK12input_device8devclassEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $44
      $device_class=$43;
      var $45=$device_class;
      var $46=(($45)|0)==1;
      if ($46) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $47
      var $48=(($8+260)|0);
      var $49=(function() { try { __THREW__ = false; return __ZNK11input_class8maxindexEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 9; break; };
    case 14: // $50
      var $51=(($49)|0)==0;
      if ($51) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $52
      $devclass=((__str2182416)|0);
      var $53=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 9; break; };
    case 16: // $54
      __label__ = 17; break;
    case 17: // $55
      var $56=$item;
      var $57=(function() { try { __THREW__ = false; return __ZNK17input_device_item4nameEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $58
      $devcode=$57;
      var $59=(function() { try { __THREW__ = false; return __ZNK10input_code13item_modifierEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 9; break; };
    case 19: // $60
      var $61=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEj(((__ZL21modifier_string_table)|0), $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 9; break; };
    case 20: // $62
      $modifier=$61;
      var $63=$device_class;
      var $64=(($63)|0)==4;
      if ($64) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $65
      var $66=(function() { try { __THREW__ = false; return __ZNK10input_code10item_classEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $67
      var $68=(($66)|0)==1;
      if ($68) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $69
      var $70=(function() { try { __THREW__ = false; return __ZNK10input_code13item_modifierEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 9; break; };
    case 24: // $71
      var $72=(($70)|0) >= 3;
      if ($72) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $73
      var $74=(function() { try { __THREW__ = false; return __ZNK10input_code13item_modifierEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 9; break; };
    case 26: // $75
      var $76=(($74)|0) <= 6;
      if ($76) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $77
      $devcode=((__str2182416)|0);
      __label__ = 28; break;
    case 28: // $78
      __label__ = 29; break;
    case 29: // $79
      var $80=$3;
      var $81=$devclass;
      var $82=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($80, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 9; break; };
    case 30: // $83
      var $84=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 9; break; };
    case 31: // $85
      if ($84) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $86
      var $87=$3;
      var $88=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($87, ((STRING_TABLE.__str2192417)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 9; break; };
    case 33: // $89
      var $90=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($88, $devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 9; break; };
    case 34: // $91
      __label__ = 35; break;
    case 35: // $92
      var $93=$devcode;
      var $94=(($93)|0);
      var $95=HEAP8[($94)];
      var $96=(($95 << 24) >> 24);
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $98
      var $99=$3;
      var $100=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($99, ((STRING_TABLE.__str2192417)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 9; break; };
    case 37: // $101
      var $102=$devcode;
      var $103=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($100, $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 9; break; };
    case 38: // $104
      __label__ = 39; break;
    case 39: // $105
      var $106=$modifier;
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $108
      var $109=$3;
      var $110=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($109, ((STRING_TABLE.__str2192417)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 9; break; };
    case 41: // $111
      var $112=$modifier;
      var $113=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($110, $112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 9; break; };
    case 42: // $114
      __label__ = 43; break;
    case 43: // $115
      var $116=$3;
      var $117=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 9; break; };
    case 44: // $118
      var $119=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 9; break; };
    case 45: // $120
      $1=$119;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($devindex);
      __label__ = 47; break;
    case 46: // $121
      __label__ = 48; break;
    case 47: // $122
      var $123=$1;
      STACKTOP = __stackBase__;
      return $123;
    case 48: // $124
      var $125=$5;
      var $126=$5;
      var $127=$6;
      var $128=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $126, tempValue);
      var $129=($128.f1 = $127, $128);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $130
      var $131=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13input_manager9code_nameER7astring10input_code["X"]=1;

function __ZNK17input_device_item5tokenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+88)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK17code_string_tableixEPKc($this, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $current;
      $2=$this;
      $3=$string;
      var $4=$2;
      $current=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$current;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=-1;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$current;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=_strcmp($13, $14);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$current;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $1=$20;
      __label__ = 7; break;
    case 4: // $21
      __label__ = 5; break;
    case 5: // $22
      var $23=$current;
      var $24=(($23+8)|0);
      $current=$24;
      __label__ = 1; break;
    case 6: // $25
      $1=-1;
      __label__ = 7; break;
    case 7: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13input_manager11seq_pressedERK9input_seq($this, $seq) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $invert;
      var $first;
      var $codenum;
      var $code=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      $1=$this;
      $2=$seq;
      var $5=$1;
      $result=0;
      $invert=0;
      $first=1;
      $codenum=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=$codenum;
      __ZNK9input_seqixEi($code, $7, $8);
      var $9=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8not_codeE);
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $invert=1;
      __label__ = 16; break;
    case 3: // $11
      var $12=__ZNK10input_codeeqERKS_($code, __ZN9input_seq7or_codeE);
      if ($12) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $13
      var $14=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8end_codeE);
      if ($14) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $15
      var $16=$result;
      var $17=(($16) & 1);
      if ($17) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $18
      var $19=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8end_codeE);
      if ($19) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $20
      __label__ = 18; break;
    case 8: // $21
      $result=0;
      $invert=0;
      $first=1;
      __label__ = 15; break;
    case 9: // $22
      var $23=$first;
      var $24=(($23) & 1);
      if ($24) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $25
      __ZN10input_codeC1ERKS_($3, $code);
      var $26=__ZN13input_manager12code_pressedE10input_code($5, $3);
      var $27=(($26)&1);
      var $28=$invert;
      var $29=(($28) & 1);
      var $30=(($29)&1);
      var $31=$27 ^ $30;
      var $32=(($31)|0)!=0;
      var $33=(($32)&1);
      $result=$33;
      __label__ = 14; break;
    case 11: // $34
      var $35=$result;
      var $36=(($35) & 1);
      if ($36) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $37
      __ZN10input_codeC1ERKS_($4, $code);
      var $38=__ZN13input_manager12code_pressedE10input_code($5, $4);
      var $39=(($38)&1);
      var $40=$invert;
      var $41=(($40) & 1);
      var $42=(($41)&1);
      var $43=$39 ^ $42;
      var $44=$result;
      var $45=(($44) & 1);
      var $46=(($45)&1);
      var $47=$46 & $43;
      var $48=(($47)|0)!=0;
      var $49=(($48)&1);
      $result=$49;
      __label__ = 13; break;
    case 13: // $50
      __label__ = 14; break;
    case 14: // $51
      $invert=0;
      $first=0;
      __label__ = 15; break;
    case 15: // $52
      __label__ = 16; break;
    case 16: // $53
      __label__ = 17; break;
    case 17: // $54
      var $55=$codenum;
      var $56=(($55+1)|0);
      $codenum=$56;
      __label__ = 1; break;
    case 18: // $57
      var $58=$result;
      var $59=(($58) & 1);
      STACKTOP = __stackBase__;
      return $59;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager11seq_pressedERK9input_seq["X"]=1;

function __ZNK13input_manager13code_to_tokenER7astring10input_code($this, $string, $code) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $devclass;
      var $devindex=__stackBase__;
      var $4;
      var $5;
      var $item;
      var $6=__stackBase__+64;
      var $devcode;
      var $modifier;
      var $itemclass;
      var $7;
      $2=$this;
      $3=$string;
      var $8=$2;
      var $9=__ZNK10input_code12device_classEv($code);
      var $10=__ZNK17code_string_tableixEj(((__ZL20devclass_token_table)|0), $9);
      $devclass=$10;
      __ZN7astringC1Ev($devindex);
      var $11=(function() { try { __THREW__ = false; return __ZNK10input_code12device_indexEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $12
      var $13=(($11+1)|0);
      var $14=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($devindex, ((STRING_TABLE.__str2172415)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$13,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $15
      var $16=(function() { try { __THREW__ = false; return __ZNK10input_code12device_classEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $17
      var $18=(($16)|0)==1;
      if ($18) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK10input_code12device_indexEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $21
      var $22=(($20)|0)==0;
      if ($22) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $23
      var $24=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $25
      __label__ = 9; break;
    case 8: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $4=$28;
      var $29=$27.f1;
      $5=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 9: // $30
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($6, $code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZNK13input_manager14item_from_codeE10input_code($8, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $33
      $item=$32;
      var $34=$item;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $36
      var $37=$item;
      var $38=(function() { try { __THREW__ = false; return __ZNK17input_device_item5tokenEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $39
      var $42 = $38;__label__ = 15; break;
    case 14: // $40
      var $42 = ((STRING_TABLE.__str2202418)|0);__label__ = 15; break;
    case 15: // $41
      var $42;
      $devcode=$42;
      var $43=(function() { try { __THREW__ = false; return __ZNK10input_code13item_modifierEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 8; break; };
    case 16: // $44
      var $45=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEj(((__ZL20modifier_token_table)|0), $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; };
    case 17: // $46
      $modifier=$45;
      $itemclass=((__str2182416)|0);
      var $47=$item;
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 21; break; } else { __label__ = 18; break; }
    case 18: // $49
      var $50=$item;
      var $51=(function() { try { __THREW__ = false; return __ZNK17input_device_item9itemclassEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 8; break; };
    case 19: // $52
      var $53=(function() { try { __THREW__ = false; return __ZNK10input_code10item_classEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 8; break; };
    case 20: // $54
      var $55=(($51)|0)!=(($53)|0);
      if ($55) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $56
      var $57=(function() { try { __THREW__ = false; return __ZNK10input_code10item_classEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 8; break; };
    case 22: // $58
      var $59=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEj(((__ZL21itemclass_token_table)|0), $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 8; break; };
    case 23: // $60
      $itemclass=$59;
      __label__ = 24; break;
    case 24: // $61
      var $62=$3;
      var $63=$devclass;
      var $64=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($62, $63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 8; break; };
    case 25: // $65
      var $66=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 8; break; };
    case 26: // $67
      if ($66) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 27: // $68
      var $69=$3;
      var $70=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($69, ((STRING_TABLE.__str2212419)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 8; break; };
    case 28: // $71
      var $72=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($70, $devindex) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 8; break; };
    case 29: // $73
      __label__ = 30; break;
    case 30: // $74
      var $75=$devcode;
      var $76=(($75)|0);
      var $77=HEAP8[($76)];
      var $78=(($77 << 24) >> 24);
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $80
      var $81=$3;
      var $82=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($81, ((STRING_TABLE.__str2212419)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 8; break; };
    case 32: // $83
      var $84=$devcode;
      var $85=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($82, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 8; break; };
    case 33: // $86
      __label__ = 34; break;
    case 34: // $87
      var $88=$modifier;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $90
      var $91=$3;
      var $92=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($91, ((STRING_TABLE.__str2212419)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 8; break; };
    case 36: // $93
      var $94=$modifier;
      var $95=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($92, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 8; break; };
    case 37: // $96
      __label__ = 38; break;
    case 38: // $97
      var $98=$itemclass;
      var $99=(($98)|0);
      var $100=HEAP8[($99)];
      var $101=(($100 << 24) >> 24);
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $103
      var $104=$3;
      var $105=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($104, ((STRING_TABLE.__str2212419)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 8; break; };
    case 40: // $106
      var $107=$itemclass;
      var $108=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($105, $107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 8; break; };
    case 41: // $109
      __label__ = 42; break;
    case 42: // $110
      var $111=$3;
      var $112=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 8; break; };
    case 43: // $113
      $1=$112;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($devindex);
      var $114=$1;
      STACKTOP = __stackBase__;
      return $114;
    case 44: // $115
      __label__ = 45; break;
    case 45: // $116
      var $117=$4;
      var $118=$4;
      var $119=$5;
      var $120=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $118, tempValue);
      var $121=($120.f1 = $119, $120);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $122
      var $123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13input_manager13code_to_tokenER7astring10input_code["X"]=1;

function __ZN13input_manager15code_from_tokenEPKc($agg_result, $this, $_token) {
  var __stackBase__  = STACKTOP; STACKTOP += 392; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $token=__stackBase__;
      var $3;
      var $4;
      var $numtokens;
      var $score;
      var $curtok;
      var $devclass;
      var $5;
      var $devindex=__stackBase__+384;
      var $itemid=__stackBase__+388;
      var $standard;
      var $itemclass;
      var $device;
      var $item;
      var $modifier;
      var $temp;
      $1=$this;
      $2=$_token;
      var $6=$1;
      var $7=(($token)|0);
      var $8=(($7+384)|0);
      var $10 = $7;__label__ = 1; break;
    case 1: // $9
      var $10;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $11
      var $12=(($10+64)|0);
      var $13=(($12)|0)==(($8)|0);
      if ($13) { __label__ = 3; break; } else { var $10 = $12;__label__ = 1; break; }
    case 3: // $14
      $numtokens=0;
      __label__ = 4; break;
    case 4: // $15
      var $16=$numtokens;
      var $17=(($16)>>>0) < 6;
      if ($17) { __label__ = 5; break; } else { __label__ = 19; break; }
    case 5: // $18
      var $19=$2;
      var $20=(function() { try { __THREW__ = false; return _strchr($19, 95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 17; break; };
    case 6: // $21
      $score=$20;
      var $22=$numtokens;
      var $23=(($22+1)|0);
      $numtokens=$23;
      var $24=(($token+($22<<6))|0);
      var $25=$2;
      var $26=$score;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $28
      var $29=$2;
      var $30=(function() { try { __THREW__ = false; return _strlen($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 17; break; };
    case 8: // $31
      var $39 = $30;__label__ = 10; break;
    case 9: // $32
      var $33=$score;
      var $34=$2;
      var $35=$33;
      var $36=$34;
      var $37=(($35-$36)|0);
      var $39 = $37;__label__ = 10; break;
    case 10: // $38
      var $39;
      var $40=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKci($24, $25, $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; };
    case 11: // $41
      var $42=$score;
      var $43=(($42)|0)==0;
      if ($43) { __label__ = 12; break; } else { __label__ = 18; break; }
    case 12: // $44
      __label__ = 19; break;
    case 13: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $3=$47;
      var $48=$46.f1;
      $4=$48;
      var $49=(($7)|0)==(($10)|0);
      if ($49) { __label__ = 16; break; } else { var $51 = $10;__label__ = 14; break; }
    case 14: // $50
      var $51;
      var $52=(($51-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 89; break; }
    case 15: // $53
      var $54=(($52)|0)==(($7)|0);
      if ($54) { __label__ = 16; break; } else { var $51 = $52;__label__ = 14; break; }
    case 16: // $55
      __label__ = 88; break;
    case 17: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      $3=$58;
      var $59=$57.f1;
      $4=$59;
      var $60=(($token)|0);
      var $61=(($60+384)|0);
      var $242 = $61;__label__ = 85; break;
    case 18: // $62
      var $63=$score;
      var $64=(($63+1)|0);
      $2=$64;
      __label__ = 4; break;
    case 19: // $65
      $curtok=0;
      var $66=$curtok;
      var $67=(($66+1)|0);
      $curtok=$67;
      var $68=(($token+($66<<6))|0);
      var $69=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 17; break; };
    case 20: // $70
      var $71=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEPKc(((__ZL20devclass_token_table)|0), $69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 17; break; };
    case 21: // $72
      $devclass=$71;
      var $73=$devclass;
      var $74=(($73)|0)==-1;
      if ($74) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $75
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 17; break; }
    case 23: // $76
      $5=1;
      __label__ = 77; break;
    case 24: // $77
      HEAP32[(($devindex)>>2)]=0;
      var $78=$numtokens;
      var $79=(($78)|0) > 2;
      if ($79) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $80
      var $81=$curtok;
      var $82=(($token+($81<<6))|0);
      var $83=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 17; break; };
    case 26: // $84
      var $85=(function() { try { __THREW__ = false; return _sscanf($83, ((STRING_TABLE.__str2172415)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$devindex,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 17; break; };
    case 27: // $86
      var $87=(($85)|0)==1;
      if ($87) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $88
      var $89=$curtok;
      var $90=(($89+1)|0);
      $curtok=$90;
      var $91=HEAP32[(($devindex)>>2)];
      var $92=(($91-1)|0);
      HEAP32[(($devindex)>>2)]=$92;
      __label__ = 29; break;
    case 29: // $93
      var $94=$curtok;
      var $95=$numtokens;
      var $96=(($94)|0) >= (($95)|0);
      if ($96) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $97
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 17; break; }
    case 31: // $98
      $5=1;
      __label__ = 77; break;
    case 32: // $99
      var $100=$curtok;
      var $101=(($token+($100<<6))|0);
      var $102=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 17; break; };
    case 33: // $103
      var $104=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEPKc(((__ZL18itemid_token_table)|0), $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 17; break; };
    case 34: // $105
      HEAP32[(($itemid)>>2)]=$104;
      var $106=HEAP32[(($itemid)>>2)];
      var $107=(($106)|0)!=-1;
      var $108=(($107)&1);
      $standard=$108;
      $itemclass=0;
      var $109=$standard;
      var $110=(($109) & 1);
      if ($110) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $111
      var $112=$devclass;
      var $113=(($6+4404)|0);
      var $114=(($113+($112<<2))|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=HEAP32[(($itemid)>>2)];
      var $117=(function() { try { __THREW__ = false; return __ZN11input_class19standard_item_classE13input_item_id($115, $116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 17; break; };
    case 36: // $118
      $itemclass=$117;
      __label__ = 59; break;
    case 37: // $119
      var $120=$devclass;
      var $121=(($6+4404)|0);
      var $122=(($121+($120<<2))|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=HEAP32[(($devindex)>>2)];
      var $125=(function() { try { __THREW__ = false; return __ZNK11input_class6deviceEi($123, $124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 17; break; };
    case 38: // $126
      $device=$125;
      var $127=$device;
      var $128=(($127)|0)==0;
      if ($128) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $129
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 17; break; }
    case 40: // $130
      $5=1;
      __label__ = 77; break;
    case 41: // $131
      HEAP32[(($itemid)>>2)]=1;
      __label__ = 42; break;
    case 42: // $132
      var $133=HEAP32[(($itemid)>>2)];
      var $134=$device;
      var $135=(function() { try { __THREW__ = false; return __ZNK12input_device7maxitemEv($134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 17; break; };
    case 43: // $136
      var $137=(($133)|0) <= (($135)|0);
      if ($137) { __label__ = 44; break; } else { __label__ = 54; break; }
    case 44: // $138
      var $139=$device;
      var $140=HEAP32[(($itemid)>>2)];
      var $141=(function() { try { __THREW__ = false; return __ZNK12input_device4itemE13input_item_id($139, $140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 17; break; };
    case 45: // $142
      $item=$141;
      var $143=$item;
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 46; break; } else { __label__ = 51; break; }
    case 46: // $145
      var $146=$curtok;
      var $147=(($token+($146<<6))|0);
      var $148=$item;
      var $149=(function() { try { __THREW__ = false; return __ZNK17input_device_item5tokenEv($148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 17; break; };
    case 47: // $150
      var $151=(function() { try { __THREW__ = false; return __ZNK7astring3cmpEPKc($147, $149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 17; break; };
    case 48: // $152
      var $153=(($151)|0)==0;
      if ($153) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $154
      var $155=$item;
      var $156=(function() { try { __THREW__ = false; return __ZNK17input_device_item9itemclassEv($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 17; break; };
    case 50: // $157
      $itemclass=$156;
      __label__ = 54; break;
    case 51: // $158
      __label__ = 52; break;
    case 52: // $159
      (function() { try { __THREW__ = false; return __ZppR13input_item_idi($itemid, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 17; break; }
    case 53: // $160
      __label__ = 42; break;
    case 54: // $161
      var $162=HEAP32[(($itemid)>>2)];
      var $163=$device;
      var $164=(function() { try { __THREW__ = false; return __ZNK12input_device7maxitemEv($163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 17; break; };
    case 55: // $165
      var $166=(($162)|0) > (($164)|0);
      if ($166) { __label__ = 56; break; } else { __label__ = 58; break; }
    case 56: // $167
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 17; break; }
    case 57: // $168
      $5=1;
      __label__ = 77; break;
    case 58: // $169
      __label__ = 59; break;
    case 59: // $170
      var $171=$curtok;
      var $172=(($171+1)|0);
      $curtok=$172;
      $modifier=0;
      var $173=$curtok;
      var $174=$numtokens;
      var $175=(($173)|0) < (($174)|0);
      if ($175) { __label__ = 60; break; } else { __label__ = 66; break; }
    case 60: // $176
      var $177=$curtok;
      var $178=(($token+($177<<6))|0);
      var $179=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($178) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 17; break; };
    case 61: // $180
      var $181=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEPKc(((__ZL20modifier_token_table)|0), $179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 17; break; };
    case 62: // $182
      $modifier=$181;
      var $183=$modifier;
      var $184=(($183)|0)!=-1;
      if ($184) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $185
      var $186=$curtok;
      var $187=(($186+1)|0);
      $curtok=$187;
      __label__ = 65; break;
    case 64: // $188
      $modifier=0;
      __label__ = 65; break;
    case 65: // $189
      __label__ = 66; break;
    case 66: // $190
      var $191=$curtok;
      var $192=$numtokens;
      var $193=(($191)|0) < (($192)|0);
      if ($193) { __label__ = 67; break; } else { __label__ = 72; break; }
    case 67: // $194
      var $195=$curtok;
      var $196=(($token+($195<<6))|0);
      var $197=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 17; break; };
    case 68: // $198
      var $199=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEPKc(((__ZL21itemclass_token_table)|0), $197) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 17; break; };
    case 69: // $200
      $temp=$199;
      var $201=$temp;
      var $202=(($201)|0)!=-1;
      if ($202) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $203
      var $204=$curtok;
      var $205=(($204+1)|0);
      $curtok=$205;
      var $206=$temp;
      $itemclass=$206;
      __label__ = 71; break;
    case 71: // $207
      __label__ = 72; break;
    case 72: // $208
      var $209=$curtok;
      var $210=$numtokens;
      var $211=(($209)|0)!=(($210)|0);
      if ($211) { __label__ = 73; break; } else { __label__ = 75; break; }
    case 73: // $212
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 17; break; }
    case 74: // $213
      $5=1;
      __label__ = 77; break;
    case 75: // $214
      var $215=$devclass;
      var $216=HEAP32[(($devindex)>>2)];
      var $217=$itemclass;
      var $218=$modifier;
      var $219=HEAP32[(($itemid)>>2)];
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($agg_result, $215, $216, $217, $218, $219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 17; break; }
    case 76: // $220
      $5=1;
      __label__ = 77; break;
    case 77: // $221
      var $222=(($token)|0);
      var $223=(($222+384)|0);
      var $225 = $223;__label__ = 78; break;
    case 78: // $224
      var $225;
      var $226=(($225-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($226) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 81; break; }
    case 79: // $227
      var $228=(($226)|0)==(($222)|0);
      if ($228) { __label__ = 80; break; } else { var $225 = $226;__label__ = 78; break; }
    case 80: // $229
      STACKTOP = __stackBase__;
      return;
    case 81: // $230
      var $231=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $232=$231.f0;
      $3=$232;
      var $233=$231.f1;
      $4=$233;
      var $234=(($222)|0)==(($226)|0);
      if ($234) { __label__ = 84; break; } else { var $236 = $226;__label__ = 82; break; }
    case 82: // $235
      var $236;
      var $237=(($236-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 89; break; }
    case 83: // $238
      var $239=(($237)|0)==(($222)|0);
      if ($239) { __label__ = 84; break; } else { var $236 = $237;__label__ = 82; break; }
    case 84: // $240
      __label__ = 88; break;
    case 85: // $241
      var $242;
      var $243=(($242-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 89; break; }
    case 86: // $244
      var $245=(($243)|0)==(($60)|0);
      if ($245) { __label__ = 87; break; } else { var $242 = $243;__label__ = 85; break; }
    case 87: // $246
      __label__ = 88; break;
    case 88: // $247
      var $248=$3;
      var $249=$3;
      var $250=$4;
      var $251=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $249, tempValue);
      var $252=($251.f1 = $250, $251);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 89: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager15code_from_tokenEPKc["X"]=1;

function __ZN13input_manager14seq_axis_valueERK9input_seqR16input_item_class($this, $seq, $itemclass) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $itemclasszero;
      var $result;
      var $invert;
      var $enable;
      var $codenum;
      var $code=__stackBase__;
      var $4=__stackBase__+4;
      var $value;
      var $5=__stackBase__+8;
      $1=$this;
      $2=$seq;
      $3=$itemclass;
      var $6=$1;
      $itemclasszero=0;
      var $7=$3;
      HEAP32[(($7)>>2)]=0;
      $result=0;
      $invert=0;
      $enable=1;
      $codenum=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$2;
      var $10=$codenum;
      __ZNK9input_seqixEi($code, $9, $10);
      var $11=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8not_codeE);
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $invert=1;
      __label__ = 28; break;
    case 3: // $13
      var $14=__ZNK10input_codeeqERKS_($code, __ZN9input_seq7or_codeE);
      if ($14) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $15
      var $16=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8end_codeE);
      if ($16) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $17
      var $18=$3;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $21
      var $22=__ZNK10input_codeeqERKS_($code, __ZN9input_seq8end_codeE);
      if ($22) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $23
      __label__ = 30; break;
    case 8: // $24
      $result=0;
      $invert=0;
      $enable=1;
      __label__ = 27; break;
    case 9: // $25
      var $26=$enable;
      var $27=(($26) & 1);
      if ($27) { __label__ = 10; break; } else { __label__ = 26; break; }
    case 10: // $28
      var $29=__ZNK10input_code10item_classEv($code);
      var $30=(($29)|0)==1;
      if ($30) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $31
      var $32=$enable;
      var $33=(($32) & 1);
      if ($33) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $34
      __ZN10input_codeC1ERKS_($4, $code);
      var $35=__ZN13input_manager12code_pressedE10input_code($6, $4);
      var $36=(($35)&1);
      var $37=$invert;
      var $38=(($37) & 1);
      var $39=(($38)&1);
      var $40=$36 ^ $39;
      var $41=$enable;
      var $42=(($41) & 1);
      var $43=(($42)&1);
      var $44=$43 & $40;
      var $45=(($44)|0)!=0;
      var $46=(($45)&1);
      $enable=$46;
      __label__ = 13; break;
    case 13: // $47
      __label__ = 25; break;
    case 14: // $48
      __ZN10input_codeC1ERKS_($5, $code);
      var $49=__ZN13input_manager10code_valueE10input_code($6, $5);
      $value=$49;
      var $50=$value;
      var $51=(($50)|0)==0;
      if ($51) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $52
      var $53=$itemclasszero;
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $55
      var $56=__ZNK10input_code10item_classEv($code);
      $itemclasszero=$56;
      __label__ = 17; break;
    case 17: // $57
      __label__ = 24; break;
    case 18: // $58
      var $59=__ZNK10input_code10item_classEv($code);
      var $60=(($59)|0)==2;
      if ($60) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $61
      var $62=$3;
      HEAP32[(($62)>>2)]=2;
      var $63=$value;
      $result=$63;
      __label__ = 23; break;
    case 20: // $64
      var $65=__ZNK10input_code10item_classEv($code);
      var $66=(($65)|0)==3;
      if ($66) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $67
      var $68=$3;
      HEAP32[(($68)>>2)]=3;
      var $69=$value;
      var $70=$result;
      var $71=(($70+$69)|0);
      $result=$71;
      __label__ = 22; break;
    case 22: // $72
      __label__ = 23; break;
    case 23: // $73
      __label__ = 24; break;
    case 24: // $74
      __label__ = 25; break;
    case 25: // $75
      $invert=0;
      __label__ = 26; break;
    case 26: // $76
      __label__ = 27; break;
    case 27: // $77
      __label__ = 28; break;
    case 28: // $78
      __label__ = 29; break;
    case 29: // $79
      var $80=$codenum;
      var $81=(($80+1)|0);
      $codenum=$81;
      __label__ = 1; break;
    case 30: // $82
      var $83=$result;
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $85
      var $86=$itemclasszero;
      var $87=$3;
      HEAP32[(($87)>>2)]=$86;
      __label__ = 32; break;
    case 32: // $88
      var $89=$result;
      STACKTOP = __stackBase__;
      return $89;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager14seq_axis_valueERK9input_seqR16input_item_class["X"]=1;

function __ZN13input_manager14seq_poll_startE16input_item_classPK9input_seq($this, $itemclass, $startseq) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $dummycode=__stackBase__+4;
      var $5=__stackBase__+8;
      var $6=__stackBase__+12;
      $1=$this;
      $2=$itemclass;
      $3=$startseq;
      var $7=$1;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=(($7+4492)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$3$0=(($10)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$0$0;
      var $st$3$1=(($10+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$0$1;
      var $11=$2;
      var $12=(($7+4500)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($7+4428)|0);
      __ZN9input_seq5resetEv($13);
      var $14=$3;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $16
      var $17=(($7+4428)|0);
      var $18=$3;
      var $19=$17;
      var $20=$18;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $20>>2, $$dest = $19>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $21=(($7+4428)|0);
      var $22=__ZNK9input_seq6lengthEv($21);
      var $23=(($22)|0) > 0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=(($7+4428)|0);
      __ZN10input_codeC1ERKS_($4, __ZN9input_seq7or_codeE);
      var $26=__ZN9input_seqpLE10input_code($25, $4);
      __label__ = 5; break;
    case 5: // $27
      __label__ = 6; break;
    case 6: // $28
      __ZN13input_manager13reset_pollingEv($7);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($dummycode, 1, 0, 1, 0, 60);
      __label__ = 7; break;
    case 7: // $29
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 0, 0, 0, 0, 0);
      var $30=__ZNK10input_codeneERKS_($dummycode, $5);
      if ($30) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $31
      var $32=(($7+4500)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)==1;
      if ($34) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $35
      __ZN13input_manager13poll_switchesEv($6, $7);
      __label__ = 11; break;
    case 10: // $36
      __ZN13input_manager9poll_axesEv($6, $7);
      __label__ = 11; break;
    case 11: // $37
      var $38=$dummycode;
      var $39=$6;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($38)>>2)]=HEAP32[(($39)>>2)];
      __label__ = 7; break;
    case 12: // $40
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager14seq_poll_startE16input_item_classPK9input_seq["X"]=1;

function __ZN9input_seq5resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+4;
  var $4=__stackBase__+8;
  var $5=__stackBase__+12;
  var $6=__stackBase__+16;
  var $7=__stackBase__+20;
  var $8=__stackBase__+24;
  $1=$this;
  var $9=$1;
  __ZN10input_codeC1ERKS_($2, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($3, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($4, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
  __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
  __ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_($9, $2, $3, $4, $5, $6, $7, $8);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13input_manager8seq_pollEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curlen;
      var $lastcode=__stackBase__;
      var $newcode=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $has_or;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $last_nomodifier=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      $2=$this;
      var $13=$2;
      var $14=(($13+4428)|0);
      var $15=__ZNK9input_seq6lengthEv($14);
      $curlen=$15;
      var $16=(($13+4428)|0);
      var $17=$curlen;
      var $18=(($17-1)|0);
      __ZNK9input_seqixEi($lastcode, $16, $18);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($newcode, 0, 0, 0, 0, 0);
      var $19=(($13+4500)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==1;
      if ($21) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $22
      __ZN13input_manager13poll_switchesEv($3, $13);
      var $23=$newcode;
      var $24=$3;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($23)>>2)]=HEAP32[(($24)>>2)];
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4, 0, 0, 0, 0, 0);
      var $25=__ZNK10input_codeneERKS_($newcode, $4);
      if ($25) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $26
      var $27=$curlen;
      var $28=(($27)|0) > 0;
      if ($28) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $29
      var $30=__ZNK10input_codeeqERKS_($newcode, $lastcode);
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=(($13+4428)|0);
      __ZN9input_seq9backspaceEv($32);
      var $33=(($13+4428)|0);
      var $34=$curlen;
      var $35=(($34-2)|0);
      __ZNK9input_seqixEi($5, $33, $35);
      var $36=__ZNK10input_codeeqERKS_($5, __ZN9input_seq8not_codeE);
      if ($36) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $37
      var $38=(($13+4428)|0);
      __ZN9input_seq9backspaceEv($38);
      __label__ = 7; break;
    case 6: // $39
      var $40=(($13+4428)|0);
      __ZN10input_codeC1ERKS_($6, __ZN9input_seq8not_codeE);
      var $41=__ZN9input_seqpLE10input_code($40, $6);
      __label__ = 7; break;
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      __label__ = 9; break;
    case 9: // $44
      __label__ = 31; break;
    case 10: // $45
      $has_or=0;
      var $46=__ZNK10input_codeeqERKS_($lastcode, __ZN9input_seq7or_codeE);
      if ($46) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $47
      var $48=(($13+4428)|0);
      var $49=$curlen;
      var $50=(($49-2)|0);
      __ZNK9input_seqixEi($7, $48, $50);
      var $51=$lastcode;
      var $52=$7;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($51)>>2)]=HEAP32[(($52)>>2)];
      $has_or=1;
      __label__ = 12; break;
    case 12: // $53
      __ZN13input_manager9poll_axesEv($8, $13);
      var $54=$newcode;
      var $55=$8;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($54)>>2)]=HEAP32[(($55)>>2)];
      var $56=__ZNK10input_code10item_classEv($lastcode);
      var $57=(($56)|0)==2;
      if ($57) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $58
      var $59=__ZNK10input_code10item_classEv($newcode);
      var $60=(($59)|0)!=2;
      if ($60) { __label__ = 16; break; } else { __label__ = 14; break; }
    case 14: // $61
      var $62=__ZNK10input_code10item_classEv($lastcode);
      var $63=(($62)|0)==3;
      if ($63) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $64
      var $65=__ZNK10input_code10item_classEv($newcode);
      var $66=(($65)|0)!=3;
      if ($66) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $67
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9, 0, 0, 0, 0, 0);
      var $68=$newcode;
      var $69=$9;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($68)>>2)]=HEAP32[(($69)>>2)];
      __label__ = 17; break;
    case 17: // $70
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10, 0, 0, 0, 0, 0);
      var $71=__ZNK10input_codeneERKS_($newcode, $10);
      if ($71) { __label__ = 18; break; } else { __label__ = 30; break; }
    case 18: // $72
      var $73=$curlen;
      var $74=(($73)|0) > 0;
      if ($74) { __label__ = 19; break; } else { __label__ = 30; break; }
    case 19: // $75
      var $76=__ZNK10input_code10item_classEv($newcode);
      var $77=(($76)|0)==2;
      if ($77) { __label__ = 20; break; } else { __label__ = 30; break; }
    case 20: // $78
      __ZN10input_codeC1ERKS_($last_nomodifier, $lastcode);
      __ZN10input_code17set_item_modifierE19input_item_modifier($last_nomodifier, 0);
      var $79=__ZNK10input_codeeqERKS_($newcode, $last_nomodifier);
      if ($79) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $80
      var $81=__ZNK10input_code13item_modifierEv($lastcode);
      if ($81 == 0) {
        __label__ = 22; break;
      }
      else if ($81 == 1) {
        __label__ = 23; break;
      }
      else if ($81 == 2) {
        __label__ = 25; break;
      }
      else {
      __label__ = 24; break;
      }
      
    case 22: // $82
      __ZN10input_code17set_item_modifierE19input_item_modifier($newcode, 1);
      __label__ = 26; break;
    case 23: // $83
      __ZN10input_code17set_item_modifierE19input_item_modifier($newcode, 2);
      __label__ = 26; break;
    case 24: // $84
      __label__ = 25; break;
    case 25: // $85
      __ZN10input_code17set_item_modifierE19input_item_modifier($newcode, 0);
      __label__ = 26; break;
    case 26: // $86
      var $87=$has_or;
      var $88=(($87) & 1);
      if ($88) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $89
      var $90=(($13+4428)|0);
      __ZN9input_seq9backspaceEv($90);
      __label__ = 28; break;
    case 28: // $91
      var $92=(($13+4428)|0);
      __ZN9input_seq9backspaceEv($92);
      __label__ = 29; break;
    case 29: // $93
      __label__ = 30; break;
    case 30: // $94
      __label__ = 31; break;
    case 31: // $95
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11, 0, 0, 0, 0, 0);
      var $96=__ZNK10input_codeneERKS_($newcode, $11);
      if ($96) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $97
      var $98=(($13+4428)|0);
      __ZN10input_codeC1ERKS_($12, $newcode);
      var $99=__ZN9input_seqpLE10input_code($98, $12);
      var $100=_osd_ticks();
      var $100$0=$100[0];
      var $100$1=$100[1];
      var $101=(($13+4492)|0);
      var $st$7$0=(($101)|0);
      HEAP32[(($st$7$0)>>2)]=$100$0;
      var $st$7$1=(($101+4)|0);
      HEAP32[(($st$7$1)>>2)]=$100$1;
      __label__ = 33; break;
    case 33: // $102
      var $103=(($13+4492)|0);
      var $st$1$0=(($103)|0);
      var $104$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($103+4)|0);
      var $104$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $105=$104$0 != $$emscripten$temp$0$0 || $104$1 != $$emscripten$temp$0$1;
      if ($105) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $106
      var $107=_osd_ticks();
      var $107$0=$107[0];
      var $107$1=$107[1];
      var $108=(($13+4492)|0);
      var $st$4$0=(($108)|0);
      var $109$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($108+4)|0);
      var $109$1=HEAP32[(($st$4$1)>>2)];
      var $110=_osd_ticks_per_second();
      var $110$0=$110[0];
      var $110$1=$110[1];
      var $$emscripten$temp$1$0=2;
      var $$emscripten$temp$1$1=0;
      var $111$0 = ((($110$0)>>>0)+((($110$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $111$1 = Math.min(Math.floor((((($110$0)>>>0)+((($110$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=3;
      var $$emscripten$temp$2$1=0;
      var $112$0 = (tempBigIntR=((($111$0)>>>0)+((($111$1)|0)*4294967296))/((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $112$1 = Math.min(Math.floor(((tempBigIntR=((($111$0)>>>0)+((($111$1)|0)*4294967296))/((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $113$0 = ((($109$0)>>>0)+((($109$1)|0)*4294967296))+((($112$0)>>>0)+((($112$1)|0)*4294967296))>>>0; var $113$1 = Math.min(Math.floor((((($109$0)>>>0)+((($109$1)|0)*4294967296))+((($112$0)>>>0)+((($112$1)|0)*4294967296)))/4294967296), 4294967295);
      var $114=($107$1|0) > ($113$1|0) || (($107$1|0) == ($113$1|0) && ($107$0|0) >  ($113$0|0));
      if ($114) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $115
      var $116=(($13+4428)|0);
      var $117=__ZNK9input_seq8is_validEv($116);
      if ($117) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $118
      var $119=(($13+4428)|0);
      __ZN9input_seq5resetEv($119);
      __label__ = 37; break;
    case 37: // $120
      $1=1;
      __label__ = 39; break;
    case 38: // $121
      $1=0;
      __label__ = 39; break;
    case 39: // $122
      var $123=$1;
      STACKTOP = __stackBase__;
      return $123;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager8seq_pollEv["X"]=1;

function __ZNK13input_manager8seq_nameER7astringRK9input_seq($this, $string, $seq) {
  var __stackBase__  = STACKTOP; STACKTOP += 148; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $clean_codes=__stackBase__;
      var $clean_index;
      var $codestr=__stackBase__+64;
      var $codenum;
      var $5=__stackBase__+128;
      var $6;
      var $7;
      var $code=__stackBase__+132;
      var $8=__stackBase__+136;
      var $9;
      var $codenum1;
      var $code2=__stackBase__+140;
      var $10=__stackBase__+144;
      $2=$this;
      $3=$string;
      $4=$seq;
      var $11=$2;
      var $12=(($clean_codes)|0);
      var $13=(($12+64)|0);
      var $15 = $12;__label__ = 1; break;
    case 1: // $14
      var $15;
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($15, 0, 0, 0, 0, 0);
      var $16=(($15+4)|0);
      var $17=(($16)|0)==(($13)|0);
      if ($17) { __label__ = 2; break; } else { var $15 = $16;__label__ = 1; break; }
    case 2: // $18
      $clean_index=0;
      __ZN7astringC1Ev($codestr);
      $codenum=0;
      __label__ = 3; break;
    case 3: // $19
      var $20=$4;
      var $21=$codenum;
      (function() { try { __THREW__ = false; return __ZNK9input_seqixEi($5, $20, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 4: // $22
      var $23=(function() { try { __THREW__ = false; return __ZNK10input_codeneERKS_($5, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 19; break; };
    case 5: // $24
      if ($23) { __label__ = 6; break; } else { __label__ = 28; break; }
    case 6: // $25
      var $26=$4;
      var $27=$codenum;
      (function() { try { __THREW__ = false; return __ZNK9input_seqixEi($code, $26, $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 19; break; }
    case 7: // $28
      var $29=(function() { try { __THREW__ = false; return __ZNK10input_code8internalEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 19; break; };
    case 8: // $30
      if ($29) { __label__ = 21; break; } else { __label__ = 9; break; }
    case 9: // $31
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8, $code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $32
      var $33=(function() { try { __THREW__ = false; return __ZNK13input_manager9code_nameER7astring10input_code($11, $codestr, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 19; break; };
    case 11: // $34
      var $35=(function() { try { __THREW__ = false; return _strlen($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 19; break; };
    case 12: // $36
      var $37=(($35)|0)==0;
      if ($37) { __label__ = 13; break; } else { __label__ = 21; break; }
    case 13: // $38
      __label__ = 14; break;
    case 14: // $39
      var $40=$clean_index;
      var $41=(($40)|0) > 0;
      if ($41) { __label__ = 15; break; } else { var $49 = 0;__label__ = 17; break; }
    case 15: // $42
      var $43=$clean_index;
      var $44=(($43-1)|0);
      var $45=(($clean_codes+($44<<2))|0);
      var $46=(function() { try { __THREW__ = false; return __ZNK10input_code8internalEv($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; };
    case 16: // $47
      var $49 = $46;__label__ = 17; break;
    case 17: // $48
      var $49;
      if ($49) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $50
      var $51=$clean_index;
      var $52=(($51-1)|0);
      $clean_index=$52;
      __label__ = 14; break;
    case 19: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $6=$55;
      var $56=$54.f1;
      $7=$56;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($codestr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 60; break; }
    case 20: // $57
      __label__ = 26; break;
    case 21: // $58
      var $59=$clean_index;
      var $60=(($59)|0) > 0;
      if ($60) { __label__ = 24; break; } else { __label__ = 22; break; }
    case 22: // $61
      var $62=(function() { try { __THREW__ = false; return __ZNK10input_code8internalEv($code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 19; break; };
    case 23: // $63
      if ($62) { __label__ = 25; break; } else { __label__ = 24; break; }
    case 24: // $64
      var $65=$clean_index;
      var $66=(($65+1)|0);
      $clean_index=$66;
      var $67=(($clean_codes+($65<<2))|0);
      var $68=$67;
      var $69=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($68)>>2)]=HEAP32[(($69)>>2)];
      __label__ = 25; break;
    case 25: // $70
      __label__ = 26; break;
    case 26: // $71
      __label__ = 27; break;
    case 27: // $72
      var $73=$codenum;
      var $74=(($73+1)|0);
      $codenum=$74;
      __label__ = 3; break;
    case 28: // $75
      var $76=$clean_index;
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $78
      var $79=$3;
      var $80=$4;
      var $81=(function() { try { __THREW__ = false; return __ZNK9input_seq6lengthEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 19; break; };
    case 30: // $82
      var $83=(($81)|0)==0;
      var $84=$83 ? (((STRING_TABLE.__str2222420)|0)) : (((STRING_TABLE.__str2232421)|0));
      var $85=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($79, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 19; break; };
    case 31: // $86
      var $87=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 19; break; };
    case 32: // $88
      $1=$87;
      $9=1;
      __label__ = 57; break;
    case 33: // $89
      var $90=$3;
      var $91=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 19; break; };
    case 34: // $92
      $codenum1=0;
      __label__ = 35; break;
    case 35: // $93
      var $94=$codenum1;
      var $95=$clean_index;
      var $96=(($94)|0) < (($95)|0);
      if ($96) { __label__ = 36; break; } else { __label__ = 55; break; }
    case 36: // $97
      var $98=$codenum1;
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $100
      var $101=$3;
      var $102=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($101, ((STRING_TABLE.__str2192417)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 19; break; };
    case 38: // $103
      __label__ = 39; break;
    case 39: // $104
      var $105=$codenum1;
      var $106=(($clean_codes+($105<<2))|0);
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($code2, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 19; break; }
    case 40: // $107
      var $108=(function() { try { __THREW__ = false; return __ZNK10input_codeeqERKS_($code2, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 19; break; };
    case 41: // $109
      if ($108) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $110
      var $111=$3;
      var $112=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($111, ((STRING_TABLE.__str2242422)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 19; break; };
    case 43: // $113
      __label__ = 53; break;
    case 44: // $114
      var $115=(function() { try { __THREW__ = false; return __ZNK10input_codeeqERKS_($code2, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 19; break; };
    case 45: // $116
      if ($115) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $117
      var $118=$3;
      var $119=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($118, ((STRING_TABLE.__str2252423)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 19; break; };
    case 47: // $120
      __label__ = 52; break;
    case 48: // $121
      var $122=$3;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($10, $code2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 19; break; }
    case 49: // $123
      var $124=(function() { try { __THREW__ = false; return __ZNK13input_manager9code_nameER7astring10input_code($11, $codestr, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 19; break; };
    case 50: // $125
      var $126=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($122, $124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 19; break; };
    case 51: // $127
      __label__ = 52; break;
    case 52: // $128
      __label__ = 53; break;
    case 53: // $129
      __label__ = 54; break;
    case 54: // $130
      var $131=$codenum1;
      var $132=(($131+1)|0);
      $codenum1=$132;
      __label__ = 35; break;
    case 55: // $133
      var $134=$3;
      var $135=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 19; break; };
    case 56: // $136
      $1=$135;
      $9=1;
      __label__ = 57; break;
    case 57: // $137
      FUNCTION_TABLE[__ZN7astringD1Ev]($codestr);
      var $138=$1;
      STACKTOP = __stackBase__;
      return $138;
    case 58: // $139
      __label__ = 59; break;
    case 59: // $140
      var $141=$6;
      var $142=$6;
      var $143=$7;
      var $144=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $142, tempValue);
      var $145=($144.f1 = $143, $144);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 60: // $146
      var $147=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13input_manager8seq_nameER7astringRK9input_seq["X"]=1;

function __ZN24input_device_switch_item16read_as_relativeE19input_item_modifier($this, $modifier) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$modifier;
  var $3=$1;
  ;
  return 0;
}


function __ZN24input_device_switch_item16read_as_absoluteE19input_item_modifier($this, $modifier) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$modifier;
  var $3=$1;
  ;
  return 0;
}


function __ZNK12input_device22lightgun_reload_buttonEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16617)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK12input_device17steadykey_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16616)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN12input_device16set_joystick_mapERK12joystick_map($this, $map) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$map;
  var $3=$1;
  var $4=(($3+16460)|0);
  var $5=$2;
  var $6=__ZN12joystick_mapaSERKS_($4, $5);
  ;
  return;
}


function __ZN7astring7toupperEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__Z15astring_toupperP7astring($2);
  ;
  return $3;
}


function __ZN7astring6delchrEi($this, $ch) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$ch;
  var $3=$1;
  var $4=$2;
  var $5=__Z14astring_delchrP7astringi($3, $4);
  ;
  return $5;
}


function __ZN24input_device_switch_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E($this, $device, $name, $internal, $itemid, $getstate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$device;
  $3=$name;
  $4=$internal;
  $5=$itemid;
  $6=$getstate;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN17input_device_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E16input_item_class($8, $9, $10, $11, $12, $13, 1);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV24input_device_switch_item+8)|0);
  var $15=(($7+160)|0);
  HEAP32[(($15)>>2)]=0;
  var $16=(($7+164)|0);
  HEAP32[(($16)>>2)]=0;
  ;
  return;
}


function __ZN24input_device_switch_item14read_as_switchE19input_item_modifier($this, $modifier) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $devclass;
      var $button2_item;
      $2=$this;
      $3=$modifier;
      var $4=$2;
      var $5=$4;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__ZNK12input_device8devclassEv($7);
      $devclass=$8;
      var $9=$devclass;
      var $10=(($9)|0)==3;
      if ($10) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK12input_device22lightgun_reload_buttonEv($14);
      if ($15) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $16
      var $17=$4;
      var $18=(($17+76)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==118;
      if ($20) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $21
      var $22=$4;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK12input_device4itemE13input_item_id($24, 119);
      $button2_item=$25;
      var $26=$button2_item;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$button2_item;
      var $30=__ZN17input_device_item12update_valueEv($29);
      var $31=$4;
      var $32=__ZN17input_device_item12update_valueEv($31);
      var $33=$30 | $32;
      $1=$33;
      __label__ = 13; break;
    case 5: // $34
      __label__ = 6; break;
    case 6: // $35
      var $36=$4;
      var $37=(($36+76)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==119;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      $1=0;
      __label__ = 13; break;
    case 8: // $41
      __label__ = 9; break;
    case 9: // $42
      var $43=$devclass;
      var $44=(($43)|0)==1;
      if ($44) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $45
      var $46=$4;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=__ZNK12input_device17steadykey_enabledEv($48);
      if ($49) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $50
      var $51=(($4+160)|0);
      var $52=HEAP32[(($51)>>2)];
      $1=$52;
      __label__ = 13; break;
    case 12: // $53
      var $54=$4;
      var $55=__ZN17input_device_item12update_valueEv($54);
      $1=$55;
      __label__ = 13; break;
    case 13: // $56
      var $57=$1;
      ;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24input_device_switch_item14read_as_switchE19input_item_modifier["X"]=1;

function __ZN17input_device_item12update_valueEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($2+4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=__ZNK12input_device8internalEv($6);
  var $8=(($2+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$4]($7, $9);
  var $11=(($2+152)|0);
  HEAP32[(($11)>>2)]=$10;
  ;
  return $10;
}


function __ZN26input_device_relative_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E($this, $device, $name, $internal, $itemid, $getstate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$device;
  $3=$name;
  $4=$internal;
  $5=$itemid;
  $6=$getstate;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN17input_device_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E16input_item_class($8, $9, $10, $11, $12, $13, 3);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV26input_device_relative_item+8)|0);
  ;
  return;
}


function __ZN26input_device_relative_item14read_as_switchE19input_item_modifier($this, $modifier) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$modifier;
      var $4=$2;
      var $5=$3;
      var $6=(($5)|0)==1;
      if ($6) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$3;
      var $9=(($8)|0)==4;
      if ($9) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0)==6;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$4;
      var $15=__ZN17input_device_item12update_valueEv($14);
      var $16=(($15)|0) > 0;
      var $17=(($16)&1);
      $1=$17;
      __label__ = 10; break;
    case 4: // $18
      var $19=$3;
      var $20=(($19)|0)==2;
      if ($20) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 5: // $21
      var $22=$3;
      var $23=(($22)|0)==3;
      if ($23) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $24
      var $25=$3;
      var $26=(($25)|0)==5;
      if ($26) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $27
      var $28=$4;
      var $29=__ZN17input_device_item12update_valueEv($28);
      var $30=(($29)|0) < 0;
      var $31=(($30)&1);
      $1=$31;
      __label__ = 10; break;
    case 8: // $32
      __label__ = 9; break;
    case 9: // $33
      $1=0;
      __label__ = 10; break;
    case 10: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN26input_device_relative_item16read_as_relativeE19input_item_modifier($this, $modifier) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$modifier;
  var $3=$1;
  var $4=$3;
  var $5=__ZN17input_device_item12update_valueEv($4);
  ;
  return $5;
}


function __ZNK13input_manager13seq_to_tokensER7astringRK9input_seq($this, $string, $seq) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $codestr=__stackBase__;
      var $codenum;
      var $5=__stackBase__+64;
      var $6;
      var $7;
      var $code=__stackBase__+68;
      var $8=__stackBase__+72;
      var $9;
      $2=$this;
      $3=$string;
      $4=$seq;
      var $10=$2;
      var $11=$3;
      var $12=__ZN7astring5resetEv($11);
      __ZN7astringC1Ev($codestr);
      $codenum=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$4;
      var $15=$codenum;
      (function() { try { __THREW__ = false; return __ZNK9input_seqixEi($5, $14, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $16
      var $17=(function() { try { __THREW__ = false; return __ZNK10input_codeneERKS_($5, __ZN9input_seq8end_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $18
      if ($17) { __label__ = 4; break; } else { __label__ = 29; break; }
    case 4: // $19
      var $20=$codenum;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $22
      var $23=$3;
      var $24=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($23, ((STRING_TABLE.__str2192417)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $25
      __label__ = 8; break;
    case 7: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $6=$28;
      var $29=$27.f1;
      $7=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($codestr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 8: // $30
      var $31=$4;
      var $32=$codenum;
      (function() { try { __THREW__ = false; return __ZNK9input_seqixEi($code, $31, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 9: // $33
      var $34=(function() { try { __THREW__ = false; return __ZNK10input_codeeqERKS_($code, __ZN9input_seq7or_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; };
    case 10: // $35
      if ($34) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $36
      var $37=$3;
      var $38=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($37, ((STRING_TABLE.__str2262424)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; };
    case 12: // $39
      __label__ = 27; break;
    case 13: // $40
      var $41=(function() { try { __THREW__ = false; return __ZNK10input_codeeqERKS_($code, __ZN9input_seq8not_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 7; break; };
    case 14: // $42
      if ($41) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $43
      var $44=$3;
      var $45=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($44, ((STRING_TABLE.__str2272425)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 7; break; };
    case 16: // $46
      __label__ = 26; break;
    case 17: // $47
      var $48=(function() { try { __THREW__ = false; return __ZNK10input_codeeqERKS_($code, __ZN9input_seq12default_codeE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 7; break; };
    case 18: // $49
      if ($48) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $50
      var $51=$3;
      var $52=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($51, ((STRING_TABLE.__str2282426)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 7; break; };
    case 20: // $53
      __label__ = 25; break;
    case 21: // $54
      var $55=$3;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8, $code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 7; break; }
    case 22: // $56
      var $57=(function() { try { __THREW__ = false; return __ZNK13input_manager13code_to_tokenER7astring10input_code($10, $codestr, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 7; break; };
    case 23: // $58
      var $59=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($55, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 7; break; };
    case 24: // $60
      __label__ = 25; break;
    case 25: // $61
      __label__ = 26; break;
    case 26: // $62
      __label__ = 27; break;
    case 27: // $63
      __label__ = 28; break;
    case 28: // $64
      var $65=$codenum;
      var $66=(($65+1)|0);
      $codenum=$66;
      __label__ = 1; break;
    case 29: // $67
      var $68=$3;
      var $69=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 7; break; };
    case 30: // $70
      $1=$69;
      $9=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($codestr);
      var $71=$1;
      STACKTOP = __stackBase__;
      return $71;
    case 31: // $72
      __label__ = 32; break;
    case 32: // $73
      var $74=$6;
      var $75=$6;
      var $76=$7;
      var $77=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $75, tempValue);
      var $78=($77.f1 = $76, $77);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13input_manager13seq_to_tokensER7astringRK9input_seq["X"]=1;

function __ZN13input_manager15seq_from_tokensER9input_seqPKc($this, $seq, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $strcopy=__stackBase__;
      var $str;
      var $4;
      var $5;
      var $6;
      var $strtemp;
      var $origspace;
      var $code=__stackBase__+64;
      var $7=__stackBase__+68;
      var $8=__stackBase__+72;
      $1=$this;
      $2=$seq;
      $3=$string;
      var $9=$1;
      var $10=$2;
      __ZN9input_seq5resetEv($10);
      var $11=$3;
      __ZN7astringC1EPKc($strcopy, $11);
      var $12=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($strcopy) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 9; break; };
    case 1: // $13
      $str=$12;
      __label__ = 2; break;
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$str;
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { var $29 = 0;__label__ = 7; break; }
    case 5: // $21
      var $22=$str;
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(function() { try { __THREW__ = false; return _isspace($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $26
      var $27=(($25)|0)!=0;
      var $29 = $27;__label__ = 7; break;
    case 7: // $28
      var $29;
      if ($29) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $30
      var $31=$str;
      var $32=(($31+1)|0);
      $str=$32;
      __label__ = 4; break;
    case 9: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $4=$35;
      var $36=$34.f1;
      $5=$36;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($strcopy) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 10: // $37
      var $38=$str;
      var $39=HEAP8[($38)];
      var $40=(($39 << 24) >> 24);
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $42
      $6=1;
      __label__ = 39; break;
    case 12: // $43
      var $44=$str;
      $strtemp=$44;
      __label__ = 13; break;
    case 13: // $45
      var $46=$strtemp;
      var $47=HEAP8[($46)];
      var $48=(($47 << 24) >> 24);
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 14; break; } else { var $59 = 0;__label__ = 16; break; }
    case 14: // $50
      var $51=$strtemp;
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=(function() { try { __THREW__ = false; return _isspace($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 9; break; };
    case 15: // $55
      var $56=(($54)|0)!=0;
      var $57=$56 ^ 1;
      var $59 = $57;__label__ = 16; break;
    case 16: // $58
      var $59;
      if ($59) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $60
      var $61=$strtemp;
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=(function() { try { __THREW__ = false; return _toupper($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $65
      var $66=(($64) & 255);
      var $67=$strtemp;
      HEAP8[($67)]=$66;
      __label__ = 19; break;
    case 19: // $68
      var $69=$strtemp;
      var $70=(($69+1)|0);
      $strtemp=$70;
      __label__ = 13; break;
    case 20: // $71
      var $72=$strtemp;
      var $73=HEAP8[($72)];
      $origspace=$73;
      var $74=$strtemp;
      HEAP8[($74)]=0;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($code, 0, 0, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 9; break; }
    case 21: // $75
      var $76=$str;
      var $77=(function() { try { __THREW__ = false; return _strcmp($76, ((STRING_TABLE.__str2262424)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $78
      var $79=(($77)|0)==0;
      if ($79) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $80
      var $81=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($81)>>2)]=HEAP32[((__ZN9input_seq7or_codeE)>>2)];
      __label__ = 34; break;
    case 24: // $82
      var $83=$str;
      var $84=(function() { try { __THREW__ = false; return _strcmp($83, ((STRING_TABLE.__str2272425)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 9; break; };
    case 25: // $85
      var $86=(($84)|0)==0;
      if ($86) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $87
      var $88=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($88)>>2)]=HEAP32[((__ZN9input_seq8not_codeE)>>2)];
      __label__ = 33; break;
    case 27: // $89
      var $90=$str;
      var $91=(function() { try { __THREW__ = false; return _strcmp($90, ((STRING_TABLE.__str2282426)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 9; break; };
    case 28: // $92
      var $93=(($91)|0)==0;
      if ($93) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $94
      var $95=$code;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($95)>>2)]=HEAP32[((__ZN9input_seq12default_codeE)>>2)];
      __label__ = 32; break;
    case 30: // $96
      var $97=$str;
      (function() { try { __THREW__ = false; return __ZN13input_manager15code_from_tokenEPKc($7, $9, $97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 9; break; }
    case 31: // $98
      var $99=$code;
      var $100=$7;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($99)>>2)]=HEAP32[(($100)>>2)];
      __label__ = 32; break;
    case 32: // $101
      __label__ = 33; break;
    case 33: // $102
      __label__ = 34; break;
    case 34: // $103
      var $104=$2;
      (function() { try { __THREW__ = false; return __ZN10input_codeC1ERKS_($8, $code) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 9; break; }
    case 35: // $105
      var $106=(function() { try { __THREW__ = false; return __ZN9input_seqpLE10input_code($104, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 9; break; };
    case 36: // $107
      var $108=$origspace;
      var $109=(($108 << 24) >> 24);
      var $110=(($109)|0)==0;
      if ($110) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $111
      $6=1;
      __label__ = 39; break;
    case 38: // $112
      var $113=$strtemp;
      var $114=(($113+1)|0);
      $str=$114;
      __label__ = 2; break;
    case 39: // $115
      FUNCTION_TABLE[__ZN7astringD1Ev]($strcopy);
      STACKTOP = __stackBase__;
      return;
    case 40: // $116
      __label__ = 41; break;
    case 41: // $117
      var $118=$4;
      var $119=$4;
      var $120=$5;
      var $121=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $119, tempValue);
      var $122=($121.f1 = $120, $121);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $123
      var $124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager15seq_from_tokensER9input_seqPKc["X"]=1;

function __ZN13input_manager23set_global_joystick_mapEPKc($this, $mapstring) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $map=__stackBase__;
      var $4;
      var $5;
      var $6;
      var $tempstr=__stackBase__+148;
      var $joynum;
      var $device;
      $2=$this;
      $3=$mapstring;
      var $7=$2;
      FUNCTION_TABLE[__ZN12joystick_mapC1Ev]($map);
      var $8=$3;
      var $9=(function() { try { __THREW__ = false; return __ZN12joystick_map5parseEPKc($map, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $10
      if ($9) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $11
      $1=0;
      $6=1;
      __label__ = 20; break;
    case 3: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $4=$14;
      var $15=$13.f1;
      $5=$15;
      __label__ = 21; break;
    case 4: // $16
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 5: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK12joystick_map9to_stringER7astring($map, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 14; break; };
    case 6: // $19
      (function() { try { __THREW__ = false; return __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str2292427)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $20
      $joynum=0;
      __label__ = 8; break;
    case 8: // $21
      var $22=$joynum;
      var $23=(($7+2332)|0);
      var $24=(function() { try { __THREW__ = false; return __ZNK11input_class8maxindexEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 14; break; };
    case 9: // $25
      var $26=(($22)|0) <= (($24)|0);
      if ($26) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $27
      var $28=(($7+2332)|0);
      var $29=$joynum;
      var $30=(function() { try { __THREW__ = false; return __ZNK11input_class6deviceEi($28, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $31
      $device=$30;
      var $32=$device;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $34
      var $35=$device;
      (function() { try { __THREW__ = false; return __ZN12input_device16set_joystick_mapERK12joystick_map($35, $map) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $36
      __label__ = 15; break;
    case 14: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $4=$39;
      var $40=$38.f1;
      $5=$40;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 15: // $41
      __label__ = 16; break;
    case 16: // $42
      var $43=$joynum;
      var $44=(($43+1)|0);
      $joynum=$44;
      __label__ = 8; break;
    case 17: // $45
      $1=1;
      $6=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 3; break; }
    case 18: // $46
      __label__ = 20; break;
    case 19: // $47
      __label__ = 21; break;
    case 20: // $48
      __ZN12joystick_mapD1Ev($map);
      var $49=$1;
      STACKTOP = __stackBase__;
      return $49;
    case 21: // $50
      (function() { try { __THREW__ = false; return __ZN12joystick_mapD1Ev($map) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $51
      __label__ = 23; break;
    case 23: // $52
      var $53=$4;
      var $54=$4;
      var $55=$5;
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13input_manager23set_global_joystick_mapEPKc["X"]=1;

function __ZN17input_device_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E16input_item_class($this, $device, $name, $internal, $itemid, $getstate, $itemclass) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $1=$this;
      $2=$device;
      $3=$name;
      $4=$internal;
      $5=$itemid;
      $6=$getstate;
      $7=$itemclass;
      var $10=$1;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV17input_device_item+8)|0);
      var $12=(($10+4)|0);
      var $13=$2;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($10+8)|0);
      var $15=$3;
      __ZN7astringC1EPKc($14, $15);
      var $16=(($10+72)|0);
      var $17=$4;
      HEAP32[(($16)>>2)]=$17;
      var $18=(($10+76)|0);
      var $19=$5;
      HEAP32[(($18)>>2)]=$19;
      var $20=(($10+80)|0);
      var $21=$7;
      HEAP32[(($20)>>2)]=$21;
      var $22=(($10+84)|0);
      var $23=$6;
      HEAP32[(($22)>>2)]=$23;
      var $24=(($10+88)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $25
      var $26=(($10+152)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=(($10+156)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=$5;
      var $29=(($28)|0) <= 203;
      if ($29) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $30
      var $31=$5;
      var $32=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEj(((__ZL18itemid_token_table)|0), $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $33
      var $34=(($32)|0)!=0;
      if ($34) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $35
      var $36=(($10+88)|0);
      var $37=$5;
      var $38=(function() { try { __THREW__ = false; return __ZNK17code_string_tableixEj(((__ZL18itemid_token_table)|0), $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $39
      var $40=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($36, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $41
      __label__ = 14; break;
    case 7: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      $8=$44;
      var $45=$43.f1;
      $9=$45;
      __label__ = 16; break;
    case 8: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $8=$48;
      var $49=$47.f1;
      $9=$49;
      var $50=(($10+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 9: // $51
      var $52=(($10+88)|0);
      var $53=$3;
      var $54=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($52, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $55
      var $56=(function() { try { __THREW__ = false; return __ZN7astring7toupperEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $57
      var $58=(function() { try { __THREW__ = false; return __ZN7astring6delchrEi($56, 32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; };
    case 12: // $59
      var $60=(function() { try { __THREW__ = false; return __ZN7astring6delchrEi($58, 95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $61
      __label__ = 14; break;
    case 14: // $62
      ;
      return;
    case 15: // $63
      __label__ = 16; break;
    case 16: // $64
      var $65=(($10+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $66
      __label__ = 18; break;
    case 18: // $67
      var $68=$8;
      var $69=$8;
      var $70=$9;
      var $71=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $69, tempValue);
      var $72=($71.f1 = $70, $71);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17input_device_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E16input_item_class["X"]=1;

function __ZN26input_device_relative_item16read_as_absoluteE19input_item_modifier($this, $modifier) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$modifier;
  var $3=$1;
  ;
  return 0;
}


function __ZN26input_device_absolute_item16read_as_relativeE19input_item_modifier($this, $modifier) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$modifier;
  var $3=$1;
  ;
  return 0;
}


function __ZN12input_device6joymapEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16460)|0);
  ;
  return $3;
}


function __ZNK17input_device_item7currentEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+152)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN26input_device_absolute_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E($this, $device, $name, $internal, $itemid, $getstate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$device;
  $3=$name;
  $4=$internal;
  $5=$itemid;
  $6=$getstate;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN17input_device_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E16input_item_class($8, $9, $10, $11, $12, $13, 2);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV26input_device_absolute_item+8)|0);
  ;
  return;
}


function __ZN26input_device_absolute_item14read_as_switchE19input_item_modifier($this, $modifier) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $xaxis_item;
      var $yaxis_item;
      $2=$this;
      $3=$modifier;
      var $4=$2;
      var $5=$4;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4;
      var $9=__ZN17input_device_item12update_valueEv($8);
      var $10=__ZNK12input_device29apply_deadzone_and_saturationEi($7, $9);
      $result=$10;
      __label__ = 1; break;
    case 1: // $11
      __label__ = 2; break;
    case 2: // $12
      var $13=$4;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNK12input_device8devclassEv($15);
      var $17=(($16)|0)==4;
      if ($17) { __label__ = 3; break; } else { __label__ = 14; break; }
    case 3: // $18
      var $19=$3;
      var $20=(($19)|0) >= 3;
      if ($20) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $21
      var $22=$3;
      var $23=(($22)|0) <= 6;
      if ($23) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $24
      var $25=$4;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__ZNK12input_device4itemE13input_item_id($27, 110);
      $xaxis_item=$28;
      var $29=$4;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__ZNK12input_device4itemE13input_item_id($31, 111);
      $yaxis_item=$32;
      var $33=$xaxis_item;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $35
      var $36=$yaxis_item;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      __label__ = 9; break;
    case 9: // $40
      var $41=$4;
      var $42=$xaxis_item;
      var $43=(($41)|0)==(($42)|0);
      if ($43) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $44
      var $45=$yaxis_item;
      var $46=__ZN17input_device_item12update_valueEv($45);
      __label__ = 12; break;
    case 11: // $47
      var $48=$xaxis_item;
      var $49=__ZN17input_device_item12update_valueEv($48);
      __label__ = 12; break;
    case 12: // $50
      var $51=$4;
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=__ZN12input_device6joymapEv($53);
      var $55=$xaxis_item;
      var $56=__ZNK17input_device_item7currentEv($55);
      var $57=$yaxis_item;
      var $58=__ZNK17input_device_item7currentEv($57);
      var $59=__ZN12joystick_map6updateEii($54, $56, $58);
      var $60=(($59)&255);
      var $61=$3;
      var $62=(($61-3)|0);
      var $63=$60 >> (($62)|0);
      var $64=$63 & 1;
      $1=$64;
      __label__ = 24; break;
    case 13: // $65
      __label__ = 14; break;
    case 14: // $66
      var $67=$3;
      var $68=(($67)|0)==1;
      if ($68) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 15: // $69
      var $70=$3;
      var $71=(($70)|0)==4;
      if ($71) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $72
      var $73=$3;
      var $74=(($73)|0)==6;
      if ($74) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $75
      var $76=$result;
      var $77=(($76)|0) > 0;
      var $78=(($77)&1);
      $1=$78;
      __label__ = 24; break;
    case 18: // $79
      var $80=$3;
      var $81=(($80)|0)==2;
      if ($81) { __label__ = 21; break; } else { __label__ = 19; break; }
    case 19: // $82
      var $83=$3;
      var $84=(($83)|0)==3;
      if ($84) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $85
      var $86=$3;
      var $87=(($86)|0)==5;
      if ($87) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $88
      var $89=$result;
      var $90=(($89)|0) < 0;
      var $91=(($90)&1);
      $1=$91;
      __label__ = 24; break;
    case 22: // $92
      __label__ = 23; break;
    case 23: // $93
      $1=0;
      __label__ = 24; break;
    case 24: // $94
      var $95=$1;
      ;
      return $95;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN26input_device_absolute_item14read_as_switchE19input_item_modifier["X"]=1;

function __ZN26input_device_absolute_item16read_as_absoluteE19input_item_modifier($this, $modifier) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $button2_item;
      $1=$this;
      $2=$modifier;
      var $3=$1;
      var $4=$3;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$3;
      var $8=__ZN17input_device_item12update_valueEv($7);
      var $9=__ZNK12input_device29apply_deadzone_and_saturationEi($6, $8);
      $result=$9;
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK12input_device8devclassEv($14);
      var $16=(($15)|0)==3;
      if ($16) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZNK12input_device22lightgun_reload_buttonEv($20);
      if ($21) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $22
      var $23=$3;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZNK12input_device4itemE13input_item_id($25, 119);
      $button2_item=$26;
      var $27=$button2_item;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $29
      var $30=$button2_item;
      var $31=__ZN17input_device_item12update_valueEv($30);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      var $34=$3;
      var $35=(($34+76)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==110;
      var $38=$37 ? -65536 : 65536;
      $result=$38;
      __label__ = 7; break;
    case 7: // $39
      __label__ = 8; break;
    case 8: // $40
      var $41=$2;
      var $42=(($41)|0)==1;
      if ($42) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $43
      var $44=$result;
      var $45=(($44)|0) > 0;
      if ($45) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $46
      var $47=$result;
      var $50 = $47;__label__ = 12; break;
    case 11: // $48
      var $50 = 0;__label__ = 12; break;
    case 12: // $49
      var $50;
      var $51=((($50<<1))|0);
      var $52=(($51-65536)|0);
      $result=$52;
      __label__ = 13; break;
    case 13: // $53
      var $54=$2;
      var $55=(($54)|0)==2;
      if ($55) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $56
      var $57=$result;
      var $58=(((-$57))|0);
      var $59=(($58)|0) > 0;
      if ($59) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $60
      var $61=$result;
      var $62=(((-$61))|0);
      var $65 = $62;__label__ = 17; break;
    case 16: // $63
      var $65 = 0;__label__ = 17; break;
    case 17: // $64
      var $65;
      var $66=((($65<<1))|0);
      var $67=(($66-65536)|0);
      $result=$67;
      __label__ = 18; break;
    case 18: // $68
      var $69=$result;
      ;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN26input_device_absolute_item16read_as_absoluteE19input_item_modifier["X"]=1;

function __ZN24input_device_switch_itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN24input_device_switch_itemD2Ev($2);
  ;
  return;
}


function __ZN26input_device_relative_itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN26input_device_relative_itemD2Ev($2);
  ;
  return;
}


function __ZN26input_device_absolute_itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN26input_device_absolute_itemD2Ev($2);
  ;
  return;
}


function __ZN17input_device_itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN17input_device_itemD2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12input_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12input_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12input_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 16620);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12input_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12input_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12input_deviceED2Ev($2);
  ;
  return;
}


function __ZN24input_device_switch_itemD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN24input_device_switch_itemD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24input_device_switch_itemD0Ev["X"]=1;

function __ZN26input_device_relative_itemD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN26input_device_relative_itemD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN26input_device_relative_itemD0Ev["X"]=1;

function __ZN26input_device_absolute_itemD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN26input_device_absolute_itemD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN26input_device_absolute_itemD0Ev["X"]=1;

function __ZN17input_device_itemD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN17input_device_itemD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17input_device_itemD0Ev["X"]=1;

function __ZN17input_device_itemD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV17input_device_item+8)|0);
      var $6=(($4+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI12input_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12input_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12input_deviceED0Ev["X"]=1;

function __ZN21delegate_internal_mfpC2IM11input_classFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12input_device8internalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16456)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11input_class8devclassEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1024)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12input_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12input_deviceD2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvvEEC2I11input_classEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I11input_classEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I11input_classEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM11input_classFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=190;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM11input_classFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM11input_classFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI11input_classEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI11input_class, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI26input_device_absolute_itemEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI26input_device_absolute_itemEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI26input_device_absolute_itemEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 160);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI26input_device_absolute_itemE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI26input_device_absolute_itemED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI26input_device_absolute_itemED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI26input_device_relative_itemEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI26input_device_relative_itemEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI26input_device_relative_itemEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 160);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI26input_device_relative_itemE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI26input_device_relative_itemED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI26input_device_relative_itemED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI24input_device_switch_itemEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI24input_device_switch_itemEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI24input_device_switch_itemEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 168);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI24input_device_switch_itemE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI24input_device_switch_itemED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI24input_device_switch_itemED2Ev($2);
  ;
  return;
}


function __ZN26input_device_absolute_itemD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17input_device_itemD2Ev($3);
  ;
  return;
}


function __ZN26input_device_relative_itemD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17input_device_itemD2Ev($3);
  ;
  return;
}


function __ZN24input_device_switch_itemD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17input_device_itemD2Ev($3);
  ;
  return;
}


function __ZN12joystick_mapaSERKS_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      __ZN12joystick_map4copyERKS_($3, $7);
      __label__ = 2; break;
    case 2: // $8
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12joystick_map4copyERKS_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=(($4)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7)|0);
  var $9=(($8)|0);
  var $10=$9;
  assert(81 % 1 === 0, 'memcpy given ' + 81 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($6, $10, 81, 1);
  var $11=(($3+81)|0);
  HEAP8[($11)]=0;
  var $12=(($3+84)|0);
  var $13=$2;
  var $14=(($13+84)|0);
  var $15=__ZN7astringaSERKS_($12, $14);
  ;
  return;
}


function __ZN12joystick_mapD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+84)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZNK12core_options11float_valueEPKc($this, $name) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$name;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK12core_options5valueEPKc($3, $4);
  var $6=_atof($5);
  var $7=$6;
  ;
  return $7;
}


function __ZN20resource_pool_objectI12input_deviceED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12input_deviceE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12input_deviceD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12input_deviceED2Ev["X"]=1;

function __ZN12input_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+16460)|0);
      (function() { try { __THREW__ = false; return __ZN12joystick_mapD1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+4)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI26input_device_absolute_itemED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI26input_device_absolute_itemED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI26input_device_absolute_itemED0Ev["X"]=1;

function __ZN20resource_pool_objectI26input_device_absolute_itemED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI26input_device_absolute_itemE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI26input_device_relative_itemED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI26input_device_relative_itemED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI26input_device_relative_itemED0Ev["X"]=1;

function __ZN20resource_pool_objectI26input_device_relative_itemED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI26input_device_relative_itemE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI24input_device_switch_itemED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24input_device_switch_itemED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI24input_device_switch_itemED0Ev["X"]=1;

function __ZN20resource_pool_objectI24input_device_switch_itemED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI24input_device_switch_itemE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15running_machine12first_screenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+560)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __GLOBAL__I_a2487() {
  ;
  var __label__;

  ___cxx_global_var_init2460();
  ___cxx_global_var_init1();
  ___cxx_global_var_init2();
  ___cxx_global_var_init3();
  ___cxx_global_var_init4();
  ;
  return;
}


function __Z26debug_cpu_configure_memoryR15running_machineR12symbol_table($machine, $table) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$table;
  var $3=$2;
  var $4=$1;
  var $5=$4;
  __ZN12symbol_table16configure_memoryEPvPFN16expression_error10error_codeES0_PKc16expression_spaceEPFyS0_S4_S5_jiEPFvS0_S4_S5_jiyE($3, $5, 204, 206, 208);
  ;
  return;
}


function __ZL10get_cpunumR12symbol_tablePv($table, $ref) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $machine;
      var $target;
      var $exec=__stackBase__+8;
      var $index;
      var $gotone;
      $2=$table;
      $3=$ref;
      var $4=$2;
      var $5=__ZNK12symbol_table9globalrefEv($4);
      var $6=$5;
      $machine=$6;
      var $7=$machine;
      var $8=(($7+652)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      $target=$11;
      HEAP32[(($exec)>>2)]=0;
      $index=0;
      var $12=$machine;
      var $13=__ZNK15running_machine10devicelistEv($12);
      var $14=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($13, $exec);
      var $15=(($14)&1);
      $gotone=$15;
      __label__ = 1; break;
    case 1: // $16
      var $17=$gotone;
      var $18=(($17) & 1);
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=HEAP32[(($exec)>>2)];
      var $21=$20;
      var $22=__ZN16device_interface6deviceEv($21);
      var $23=$target;
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$index;
      var $27$0=$26;
      var $27$1=(($26|0) < 0 ? -1 : 0);
      var $st$3$0=(($1)|0);
      HEAP32[(($st$3$0)>>2)]=$27$0;
      var $st$3$1=(($1+4)|0);
      HEAP32[(($st$3$1)>>2)]=$27$1;
      __label__ = 7; break;
    case 4: // $28
      var $29=$index;
      var $30=(($29+1)|0);
      $index=$30;
      __label__ = 5; break;
    case 5: // $31
      var $32=HEAP32[(($exec)>>2)];
      var $33=$32;
      var $34=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($33, $exec);
      var $35=(($34)&1);
      $gotone=$35;
      __label__ = 1; break;
    case 6: // $36
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 7; break;
    case 7: // $37
      var $st$0$0=(($1)|0);
      var $38$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $38$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$38$0,$38$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10get_cpunumR12symbol_tablePv["X"]=1;

function __ZL9get_beamxR12symbol_tablePv($table, $ref) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $screen;
      $1=$table;
      $2=$ref;
      var $3=$2;
      var $4=$3;
      $screen=$4;
      var $5=$screen;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$screen;
      var $9=__ZNK13screen_device4hposEv($8);
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      var $13$0=$12;
      var $13$1=(($12|0) < 0 ? -1 : 0);
      ;
      return [$13$0,$13$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9get_beamyR12symbol_tablePv($table, $ref) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $screen;
      $1=$table;
      $2=$ref;
      var $3=$2;
      var $4=$3;
      $screen=$4;
      var $5=$screen;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$screen;
      var $9=__ZNK13screen_device4vposEv($8);
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      var $13$0=$12;
      var $13$1=(($12|0) < 0 ? -1 : 0);
      ;
      return [$13$0,$13$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9get_frameR12symbol_tablePv($table, $ref) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $screen;
      $1=$table;
      $2=$ref;
      var $3=$2;
      var $4=$3;
      $screen=$4;
      var $5=$screen;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$screen;
      var $9=__ZNK13screen_device12frame_numberEv($8);
      var $9$0=$9[0];
      var $9$1=$9[1];
      var $12$1 = $9$1;var $12$0 = $9$0;__label__ = 3; break;
    case 2: // $10
      var $12$1 = 0;var $12$0 = 0;__label__ = 3; break;
    case 3: // $11
      var $12$0;
      var $12$1;
      ;
      return [$12$0,$12$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13screen_devicebEEC1I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvR13screen_devicebEEC2I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_($5, $6, $7, $8);
  ;
  return;
}


function __ZL9on_vblankR15running_machineR13screen_deviceb($machine, $device, $vblank_state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$machine;
      $2=$device;
      var $4=(($vblank_state)&1);
      $3=$4;
      var $5=$3;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=$8;
      var $10=__ZNK8device_t7machineEv($9);
      var $11=(($10+652)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+21)|0);
      HEAP8[($13)]=1;
      __label__ = 2; break;
    case 2: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14debug_cpu_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$machine;
      var $2=$1;
      var $3=(($2+652)|0);
      var $4=HEAP32[(($3)>>2)];
      $global=$4;
      var $5=$global;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$global;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $11);
      __label__ = 2; break;
    case 2: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14debug_cpu_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 124; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i1=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $result_i=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $15;
      var $first_screen;
      var $global;
      var $regnum;
      var $16;
      var $17;
      var $symname=__stackBase__+64;
      var $18=__stackBase__+76;
      var $19=__stackBase__+100;
      $15=$machine;
      var $20=$15;
      var $21=__ZNK15running_machine12first_screenEv($20);
      $first_screen=$21;
      var $22=$15;
      var $23=__ZN15running_machine7respoolEv($22);
      var $24=$9;
      var $25=$10;
      var $26=$11;
      var $27=$12;
      var $28=$result_i;
      var $29=$13;
      var $30=$14;
      HEAP32[(($9)>>2)]=148;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($11)>>2)]=153;
      HEAP32[(($12)>>2)]=_zeromem;
      var $31=HEAP32[(($9)>>2)];
      var $32=HEAP32[(($10)>>2)];
      var $33=HEAP32[(($11)>>2)];
      var $34=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31, $32, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $35
      HEAP32[(($result_i)>>2)]=$34;
      var $36=HEAP32[(($result_i)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $38
      var $39=___cxa_allocate_exception(4);
      var $40=$39;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40);
      (function() { try { __THREW__ = false; return ___cxa_throw($39, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      HEAP32[(($13)>>2)]=$43;
      var $44=$42.f1;
      HEAP32[(($14)>>2)]=$44;
      var $45=HEAP32[(($14)>>2)];
      var $46=(($45)|0) < 0;
      if ($46) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $47
      var $48=HEAP32[(($13)>>2)];
      ___cxa_call_unexpected($48);
      throw "Reached an unreachable!"
    case 5: // $49
      var $50=HEAP32[(($13)>>2)];
      var $51=HEAP32[(($13)>>2)];
      var $52=HEAP32[(($14)>>2)];
      var $53=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $51, tempValue);
      var $54=($53.f1 = $52, $53);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $55
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $56=HEAP32[(($result_i)>>2)];
      var $57=HEAP32[(($9)>>2)];
      _memset($56, 0, $57, 1);
      var $58=HEAP32[(($result_i)>>2)];
      var $59=$9;
      var $60=$10;
      var $61=$11;
      var $62=$12;
      var $63=$result_i;
      var $64=$13;
      var $65=$14;
      var $66=$58;
      var $67=__ZN13resource_pool10add_objectI17_debugcpu_privateEEPT_S3_($23, $66);
      $global=$67;
      var $68=$15;
      var $69=(($68+652)|0);
      HEAP32[(($69)>>2)]=$67;
      var $70=$global;
      var $71=(($70+24)|0);
      HEAP32[(($71)>>2)]=0;
      var $72=$global;
      var $73=(($72+32)|0);
      HEAP32[(($73)>>2)]=1;
      var $74=$global;
      var $75=(($74+36)|0);
      HEAP32[(($75)>>2)]=1;
      var $76=$4;
      var $77=$5;
      var $78=$6;
      var $79=$result_i1;
      var $80=$7;
      var $81=$8;
      HEAP32[(($4)>>2)]=432;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($6)>>2)]=159;
      var $82=HEAP32[(($4)>>2)];
      var $83=HEAP32[(($5)>>2)];
      var $84=HEAP32[(($6)>>2)];
      var $85=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($82, $83, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $86
      HEAP32[(($result_i1)>>2)]=$85;
      var $87=HEAP32[(($result_i1)>>2)];
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $89
      var $90=___cxa_allocate_exception(4);
      var $91=$90;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($91);
      (function() { try { __THREW__ = false; return ___cxa_throw($90, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $94=$93.f0;
      HEAP32[(($7)>>2)]=$94;
      var $95=$93.f1;
      HEAP32[(($8)>>2)]=$95;
      var $96=HEAP32[(($8)>>2)];
      var $97=(($96)|0) < 0;
      if ($97) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $98
      var $99=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($99);
      throw "Reached an unreachable!"
    case 12: // $100
      var $101=HEAP32[(($7)>>2)];
      var $102=HEAP32[(($7)>>2)];
      var $103=HEAP32[(($8)>>2)];
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $106
      throw "Reached an unreachable!"
    case 14: // $_ZnwjPKci_exit
      var $107=HEAP32[(($result_i1)>>2)];
      var $108=$4;
      var $109=$5;
      var $110=$6;
      var $111=$result_i1;
      var $112=$7;
      var $113=$8;
      var $114=$107;
      var $115=$15;
      var $116=$115;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12symbol_tableC1EPvPS_]($114, $116, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $117
      var $118=__ZN13resource_pool10add_objectI12symbol_tableEEPT_S3_(_global_resource_pool, $114);
      var $119=$global;
      var $120=(($119+16)|0);
      HEAP32[(($120)>>2)]=$118;
      var $121=$15;
      var $122=$global;
      var $123=(($122+16)|0);
      var $124=HEAP32[(($123)>>2)];
      __Z26debug_cpu_configure_memoryR15running_machineR12symbol_table($121, $124);
      var $125=$global;
      var $126=(($125+16)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=$global;
      var $129=(($128+48)|0);
      __ZN12symbol_table3addEPKcNS_10read_writeEPy($127, ((STRING_TABLE.__str12489)|0), 0, $129);
      var $130=$global;
      var $131=(($130+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$global;
      var $134=(($133+40)|0);
      __ZN12symbol_table3addEPKcNS_10read_writeEPy($132, ((STRING_TABLE.__str22490)|0), 0, $134);
      var $135=$global;
      var $136=(($135+16)|0);
      var $137=HEAP32[(($136)>>2)];
      __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($137, ((STRING_TABLE.__str32491)|0), 0, 192, 0);
      var $138=$global;
      var $139=(($138+16)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=$first_screen;
      var $142=$141;
      __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($140, ((STRING_TABLE.__str42492)|0), $142, 194, 0);
      var $143=$global;
      var $144=(($143+16)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$first_screen;
      var $147=$146;
      __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($145, ((STRING_TABLE.__str52493)|0), $147, 196, 0);
      var $148=$global;
      var $149=(($148+16)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$first_screen;
      var $152=$151;
      __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($150, ((STRING_TABLE.__str62494)|0), $152, 198, 0);
      $regnum=0;
      __label__ = 16; break;
    case 16: // $153
      var $154=$regnum;
      var $155=(($154)|0) < 10;
      if ($155) { __label__ = 17; break; } else { __label__ = 24; break; }
    case 17: // $156
      var $157=(($symname)|0);
      var $158=$regnum;
      var $159=_sprintf($157, ((STRING_TABLE.__str72495)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$158,tempInt));
      var $160=$global;
      var $161=(($160+16)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($symname)|0);
      var $164=$regnum;
      var $165=$global;
      var $166=(($165+56)|0);
      var $167=(($166+($164<<3))|0);
      __ZN12symbol_table3addEPKcNS_10read_writeEPy($162, $163, 1, $167);
      __label__ = 18; break;
    case 18: // $168
      var $169=$regnum;
      var $170=(($169+1)|0);
      $regnum=$170;
      __label__ = 16; break;
    case 19: // $171
      var $172=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $173=$172.f0;
      $16=$173;
      var $174=$172.f1;
      $17=$174;
      var $175=$1;
      var $176=$2;
      var $177=$3;
      HEAP32[(($1)>>2)]=$107;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=159;
      var $178=HEAP32[(($1)>>2)];
      var $179=(($178)|0)!=0;
      if ($179) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $180
      var $181=HEAP32[(($1)>>2)];
      var $182=HEAP32[(($2)>>2)];
      var $183=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($181, $182, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $_noexc
      __label__ = 22; break;
    case 22: // $_ZdlPvPKci_exit
      var $184=$1;
      var $185=$2;
      var $186=$3;
      __label__ = 23; break;
    case 23: // $187
      __label__ = 27; break;
    case 24: // $188
      var $189=$15;
      var $190=(($189+428)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$191;
      var $193=$global;
      var $194=(($193+4)|0);
      HEAP32[(($194)>>2)]=$192;
      var $195=$15;
      var $196=(($195+560)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($197)|0)!=0;
      if ($198) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $199
      var $200=$15;
      var $201=(($200+560)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=$15;
      __ZN8delegateIFvR13screen_devicebEEC1I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_($18, 200, ((STRING_TABLE.__str82496)|0), $203);
      __ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE($202, $18);
      __label__ = 26; break;
    case 26: // $204
      var $205=$15;
      var $206=$15;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($19, 202, ((STRING_TABLE.__str92497)|0), $206);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($205, 4, $19);
      STACKTOP = __stackBase__;
      return;
    case 27: // $207
      var $208=$16;
      var $209=$16;
      var $210=$17;
      var $211=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $209, tempValue);
      var $212=($211.f1 = $210, $211);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 28: // $213
      var $214=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14debug_cpu_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI17_debugcpu_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17_debugcpu_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17_debugcpu_privateEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI12symbol_tableEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12symbol_tableEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12symbol_tableEEPT_S3_["X"]=1;

function __Z25debug_cpu_get_visible_cpuR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=(($2+652)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __Z33debug_cpu_within_instruction_hookR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=(($2+652)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+20)|0);
  var $6=HEAP8[($5)];
  var $7=(($6) & 1);
  var $8=(($7)&1);
  ;
  return $8;
}


function __Z20debug_cpu_is_stoppedR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$machine;
      var $2=$1;
      var $3=(($2+652)|0);
      var $4=HEAP32[(($3)>>2)];
      $global=$4;
      var $5=$global;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$global;
      var $9=(($8+24)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==0;
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      var $15=(($14)&1);
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z29debug_cpu_get_global_symtableR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=(($2+652)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+16)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __ZN12device_debug8symtableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  ;
  return $3;
}


function __ZL19expression_validatePvPKc16expression_space($param, $name, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $machine;
      var $device;
      $2=$param;
      $3=$name;
      $4=$space;
      var $5=$2;
      var $6=$5;
      $machine=$6;
      $device=0;
      var $7=$4;
      if ($7 == 1 || $7 == 2 || $7 == 3 || $7 == 4) {
        __label__ = 1; break;
      }
      else if ($7 == 5 || $7 == 6 || $7 == 7 || $7 == 8) {
        __label__ = 10; break;
      }
      else if ($7 == 9 || $7 == 10) {
        __label__ = 19; break;
      }
      else if ($7 == 11) {
        __label__ = 28; break;
      }
      else {
      __label__ = 33; break;
      }
      
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=$machine;
      var $13=$3;
      var $14=__ZL21expression_get_deviceR15running_machinePKc($12, $13);
      $device=$14;
      var $15=$device;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      $1=18;
      __label__ = 35; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$device;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $22
      var $23=$machine;
      var $24=__Z25debug_cpu_get_visible_cpuR15running_machine($23);
      $device=$24;
      __label__ = 7; break;
    case 7: // $25
      var $26=$device;
      var $27=__ZNK8device_t6memoryEv($26);
      var $28=$4;
      var $29=(($28-1)|0);
      var $30=(($29)|0);
      var $31=__ZNK23device_memory_interface5spaceEi($27, $30);
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $33
      $1=17;
      __label__ = 35; break;
    case 9: // $34
      __label__ = 34; break;
    case 10: // $35
      var $36=$3;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $38
      var $39=$machine;
      var $40=$3;
      var $41=__ZL21expression_get_deviceR15running_machinePKc($39, $40);
      $device=$41;
      var $42=$device;
      var $43=(($42)|0)==0;
      if ($43) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $44
      $1=18;
      __label__ = 35; break;
    case 13: // $45
      __label__ = 14; break;
    case 14: // $46
      var $47=$device;
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $49
      var $50=$machine;
      var $51=__Z25debug_cpu_get_visible_cpuR15running_machine($50);
      $device=$51;
      __label__ = 16; break;
    case 16: // $52
      var $53=$device;
      var $54=__ZNK8device_t6memoryEv($53);
      var $55=$4;
      var $56=(($55-5)|0);
      var $57=(($56)|0);
      var $58=__ZNK23device_memory_interface5spaceEi($54, $57);
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $60
      $1=17;
      __label__ = 35; break;
    case 18: // $61
      __label__ = 34; break;
    case 19: // $62
      var $63=$3;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $65
      var $66=$machine;
      var $67=$3;
      var $68=__ZL21expression_get_deviceR15running_machinePKc($66, $67);
      $device=$68;
      var $69=$device;
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $71
      $1=18;
      __label__ = 35; break;
    case 22: // $72
      __label__ = 23; break;
    case 23: // $73
      var $74=$device;
      var $75=(($74)|0)==0;
      if ($75) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $76
      var $77=$machine;
      var $78=__Z25debug_cpu_get_visible_cpuR15running_machine($77);
      $device=$78;
      __label__ = 25; break;
    case 25: // $79
      var $80=$device;
      var $81=__ZNK8device_t6memoryEv($80);
      var $82=__ZNK23device_memory_interface5spaceE16address_spacenum($81, 0);
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $84
      $1=17;
      __label__ = 35; break;
    case 27: // $85
      __label__ = 34; break;
    case 28: // $86
      var $87=$3;
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $89
      $1=19;
      __label__ = 35; break;
    case 30: // $90
      var $91=$machine;
      var $92=$3;
      var $93=__ZN15running_machine6regionEPKc($91, $92);
      var $94=__ZNK13memory_region4baseEv($93);
      var $95=(($94)|0)==0;
      if ($95) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $96
      $1=18;
      __label__ = 35; break;
    case 32: // $97
      __label__ = 34; break;
    case 33: // $98
      $1=17;
      __label__ = 35; break;
    case 34: // $99
      $1=0;
      __label__ = 35; break;
    case 35: // $100
      var $101=$1;
      ;
      return $101;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19expression_validatePvPKc16expression_space["X"]=1;

function __ZL22expression_read_memoryPvPKc16expression_spaceji($param, $name, $spacenum, $address, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $machine;
      var $result=__stackBase__;
      var $device;
      var $space;
      $1=$param;
      $2=$name;
      $3=$spacenum;
      $4=$address;
      $5=$size;
      var $6=$1;
      var $7=$6;
      $machine=$7;
      var $8=$5;
      var $9=((($8<<3))|0);
      var $10=((64-$9)|0);
      var $11$0=$10;
      var $11$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $12=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
      var $st$25$0=(($result)|0);
      HEAP32[(($st$25$0)>>2)]=$12$0;
      var $st$25$1=(($result+4)|0);
      HEAP32[(($st$25$1)>>2)]=$12$1;
      $device=0;
      var $13=$3;
      if ($13 == 1 || $13 == 2 || $13 == 3 || $13 == 4) {
        __label__ = 1; break;
      }
      else if ($13 == 5 || $13 == 6 || $13 == 7 || $13 == 8) {
        __label__ = 8; break;
      }
      else if ($13 == 9 || $13 == 10) {
        __label__ = 15; break;
      }
      else if ($13 == 11) {
        __label__ = 20; break;
      }
      else {
      __label__ = 23; break;
      }
      
    case 1: // $14
      var $15=$2;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$machine;
      var $19=$2;
      var $20=__ZL21expression_get_deviceR15running_machinePKc($18, $19);
      $device=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$device;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=$machine;
      var $26=__Z25debug_cpu_get_visible_cpuR15running_machine($25);
      $device=$26;
      __label__ = 5; break;
    case 5: // $27
      var $28=$device;
      var $29=__ZNK8device_t6memoryEv($28);
      var $30=$3;
      var $31=(($30-1)|0);
      var $32=(($31)|0);
      var $33=__ZNK23device_memory_interface5spaceEi($29, $32);
      $space=$33;
      var $34=$space;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $36
      var $37=$space;
      var $38=$space;
      var $39=$4;
      var $40=__ZNK13address_space15address_to_byteEj($38, $39);
      var $41=$5;
      var $42=__Z17debug_read_memoryP13address_spacejii($37, $40, $41, 1);
      var $42$0=$42[0];
      var $42$1=$42[1];
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$42$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$42$1;
      __label__ = 7; break;
    case 7: // $43
      __label__ = 24; break;
    case 8: // $44
      var $45=$2;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $47
      var $48=$machine;
      var $49=$2;
      var $50=__ZL21expression_get_deviceR15running_machinePKc($48, $49);
      $device=$50;
      __label__ = 10; break;
    case 10: // $51
      var $52=$device;
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      var $55=$machine;
      var $56=__Z25debug_cpu_get_visible_cpuR15running_machine($55);
      $device=$56;
      __label__ = 12; break;
    case 12: // $57
      var $58=$device;
      var $59=__ZNK8device_t6memoryEv($58);
      var $60=$3;
      var $61=(($60-5)|0);
      var $62=(($61)|0);
      var $63=__ZNK23device_memory_interface5spaceEi($59, $62);
      $space=$63;
      var $64=$space;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $66
      var $67=$space;
      var $68=$space;
      var $69=$4;
      var $70=__ZNK13address_space15address_to_byteEj($68, $69);
      var $71=$5;
      var $72=__Z17debug_read_memoryP13address_spacejii($67, $70, $71, 0);
      var $72$0=$72[0];
      var $72$1=$72[1];
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$72$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$72$1;
      __label__ = 14; break;
    case 14: // $73
      __label__ = 24; break;
    case 15: // $74
      var $75=$2;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $77
      var $78=$machine;
      var $79=$2;
      var $80=__ZL21expression_get_deviceR15running_machinePKc($78, $79);
      $device=$80;
      __label__ = 17; break;
    case 17: // $81
      var $82=$device;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $84
      var $85=$machine;
      var $86=__Z25debug_cpu_get_visible_cpuR15running_machine($85);
      $device=$86;
      __label__ = 19; break;
    case 19: // $87
      var $88=$device;
      var $89=__ZNK8device_t6memoryEv($88);
      var $90=__ZNK23device_memory_interface5spaceE16address_spacenum($89, 0);
      var $91=$3;
      var $92=(($91)|0)==9;
      var $93=(($92)&1);
      var $94=$4;
      var $95=$5;
      var $96=__ZL30expression_read_program_directP13address_spaceiji($90, $93, $94, $95);
      var $96$0=$96[0];
      var $96$1=$96[1];
      var $st$11$0=(($result)|0);
      HEAP32[(($st$11$0)>>2)]=$96$0;
      var $st$11$1=(($result+4)|0);
      HEAP32[(($st$11$1)>>2)]=$96$1;
      __label__ = 24; break;
    case 20: // $97
      var $98=$2;
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $100
      __label__ = 24; break;
    case 22: // $101
      var $102=$machine;
      var $103=$2;
      var $104=$4;
      var $105=$5;
      var $106=__ZL29expression_read_memory_regionR15running_machinePKcji($102, $103, $104, $105);
      var $106$0=$106[0];
      var $106$1=$106[1];
      var $st$7$0=(($result)|0);
      HEAP32[(($st$7$0)>>2)]=$106$0;
      var $st$7$1=(($result+4)|0);
      HEAP32[(($st$7$1)>>2)]=$106$1;
      __label__ = 24; break;
    case 23: // $107
      __label__ = 24; break;
    case 24: // $108
      var $st$0$0=(($result)|0);
      var $109$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $109$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$109$0,$109$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22expression_read_memoryPvPKc16expression_spaceji["X"]=1;

function __ZL23expression_write_memoryPvPKc16expression_spacejiy($param, $name, $spacenum, $address, $size, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $machine;
      var $device;
      var $space;
      $1=$param;
      $2=$name;
      $3=$spacenum;
      $4=$address;
      $5=$size;
      var $st$14$0=(($6)|0);
      HEAP32[(($st$14$0)>>2)]=$data$0;
      var $st$14$1=(($6+4)|0);
      HEAP32[(($st$14$1)>>2)]=$data$1;
      var $7=$1;
      var $8=$7;
      $machine=$8;
      $device=0;
      var $9=$3;
      if ($9 == 1 || $9 == 2 || $9 == 3 || $9 == 4) {
        __label__ = 1; break;
      }
      else if ($9 == 5 || $9 == 6 || $9 == 7 || $9 == 8) {
        __label__ = 8; break;
      }
      else if ($9 == 9 || $9 == 10) {
        __label__ = 15; break;
      }
      else if ($9 == 11) {
        __label__ = 20; break;
      }
      else {
      __label__ = 23; break;
      }
      
    case 1: // $10
      var $11=$2;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$machine;
      var $15=$2;
      var $16=__ZL21expression_get_deviceR15running_machinePKc($14, $15);
      $device=$16;
      __label__ = 3; break;
    case 3: // $17
      var $18=$device;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      var $21=$machine;
      var $22=__Z25debug_cpu_get_visible_cpuR15running_machine($21);
      $device=$22;
      __label__ = 5; break;
    case 5: // $23
      var $24=$device;
      var $25=__ZNK8device_t6memoryEv($24);
      var $26=$3;
      var $27=(($26-1)|0);
      var $28=(($27)|0);
      var $29=__ZNK23device_memory_interface5spaceEi($25, $28);
      $space=$29;
      var $30=$space;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      var $33=$space;
      var $34=$space;
      var $35=$4;
      var $36=__ZNK13address_space15address_to_byteEj($34, $35);
      var $st$4$0=(($6)|0);
      var $37$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($6+4)|0);
      var $37$1=HEAP32[(($st$4$1)>>2)];
      var $38=$5;
      __Z18debug_write_memoryP13address_spacejyii($33, $36, $37$0, $37$1, $38, 1);
      __label__ = 7; break;
    case 7: // $39
      __label__ = 24; break;
    case 8: // $40
      var $41=$2;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$machine;
      var $45=$2;
      var $46=__ZL21expression_get_deviceR15running_machinePKc($44, $45);
      $device=$46;
      __label__ = 10; break;
    case 10: // $47
      var $48=$device;
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $50
      var $51=$machine;
      var $52=__Z25debug_cpu_get_visible_cpuR15running_machine($51);
      $device=$52;
      __label__ = 12; break;
    case 12: // $53
      var $54=$device;
      var $55=__ZNK8device_t6memoryEv($54);
      var $56=$3;
      var $57=(($56-5)|0);
      var $58=(($57)|0);
      var $59=__ZNK23device_memory_interface5spaceEi($55, $58);
      $space=$59;
      var $60=$space;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $62
      var $63=$space;
      var $64=$space;
      var $65=$4;
      var $66=__ZNK13address_space15address_to_byteEj($64, $65);
      var $st$4$0=(($6)|0);
      var $67$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($6+4)|0);
      var $67$1=HEAP32[(($st$4$1)>>2)];
      var $68=$5;
      __Z18debug_write_memoryP13address_spacejyii($63, $66, $67$0, $67$1, $68, 0);
      __label__ = 14; break;
    case 14: // $69
      __label__ = 24; break;
    case 15: // $70
      var $71=$2;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $73
      var $74=$machine;
      var $75=$2;
      var $76=__ZL21expression_get_deviceR15running_machinePKc($74, $75);
      $device=$76;
      __label__ = 17; break;
    case 17: // $77
      var $78=$device;
      var $79=(($78)|0)==0;
      if ($79) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $80
      var $81=$machine;
      var $82=__Z25debug_cpu_get_visible_cpuR15running_machine($81);
      $device=$82;
      __label__ = 19; break;
    case 19: // $83
      var $84=$device;
      var $85=__ZNK8device_t6memoryEv($84);
      var $86=__ZNK23device_memory_interface5spaceE16address_spacenum($85, 0);
      var $87=$3;
      var $88=(($87)|0)==9;
      var $89=(($88)&1);
      var $90=$4;
      var $91=$5;
      var $st$8$0=(($6)|0);
      var $92$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($6+4)|0);
      var $92$1=HEAP32[(($st$8$1)>>2)];
      __ZL31expression_write_program_directP13address_spaceijiy($86, $89, $90, $91, $92$0, $92$1);
      __label__ = 24; break;
    case 20: // $93
      var $94=$2;
      var $95=(($94)|0)==0;
      if ($95) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $96
      __label__ = 24; break;
    case 22: // $97
      var $98=$machine;
      var $99=$2;
      var $100=$4;
      var $101=$5;
      var $st$4$0=(($6)|0);
      var $102$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($6+4)|0);
      var $102$1=HEAP32[(($st$4$1)>>2)];
      __ZL30expression_write_memory_regionR15running_machinePKcjiy($98, $99, $100, $101, $102$0, $102$1);
      __label__ = 24; break;
    case 23: // $103
      __label__ = 24; break;
    case 24: // $104
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23expression_write_memoryPvPKc16expression_spacejiy["X"]=1;

function __Z22debug_cpu_flush_tracesR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine10devicelistEv($2);
      var $4=$3;
      var $5=__ZNK11tagged_listI8device_tE5firstEv($4);
      $device=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$device;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$device;
      var $11=__ZNK8device_t5debugEv($10);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$device;
      var $15=__ZNK8device_t5debugEv($14);
      __ZN12device_debug11trace_flushEv($15);
      __label__ = 4; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$device;
      var $19=__ZNK8device_t4nextEv($18);
      $device=$19;
      __label__ = 1; break;
    case 6: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug11trace_flushEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+1560)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+1560)|0);
      var $8=HEAP32[(($7)>>2)];
      __ZN12device_debug6tracer5flushEv($8);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z30debug_cpu_get_visible_symtableR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=(($2+652)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=__ZNK8device_t5debugEv($6);
  var $8=__ZN12device_debug8symtableEv($7);
  ;
  return $8;
}


function __Z23debug_cpu_source_scriptR15running_machinePKc($machine, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$machine;
      $2=$file;
      var $3=$1;
      var $4=(($3+652)|0);
      var $5=HEAP32[(($4)>>2)];
      $global=$5;
      var $6=$global;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$global;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=_fclose($13);
      var $15=$global;
      var $16=(($15+12)|0);
      HEAP32[(($16)>>2)]=0;
      __label__ = 2; break;
    case 2: // $17
      var $18=$2;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $20
      var $21=$2;
      var $22=_fopen($21, ((STRING_TABLE.__str102498)|0));
      var $23=$global;
      var $24=(($23+12)|0);
      HEAP32[(($24)>>2)]=$22;
      var $25=$global;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 8; break; } else { __label__ = 4; break; }
    case 4: // $29
      var $30=$1;
      var $31=__ZNK15running_machine5phaseEv($30);
      var $32=(($31)|0)==3;
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$1;
      var $35=$2;
      __Z20debug_console_printfR15running_machinePKcz($34, ((STRING_TABLE.__str112499)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$35,tempInt));
      __label__ = 7; break;
    case 6: // $36
      var $37=$2;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str122500)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt));
      throw "Reached an unreachable!"
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      __label__ = 9; break;
    case 9: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13emu_exceptionC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13emu_exceptionC2Ev($2);
  ;
  return;
}


function __ZNK12device_debug13comment_countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1576)|0);
  var $4=__ZNK11simple_listIN12device_debug12dasm_commentEE5countEv($3);
  ;
  return $4;
}


function __ZNK11emu_options17comment_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str602548)|0));
  ;
  return $4;
}


function __ZNK15running_machine8basenameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1332)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __Z18debug_comment_saveR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $root;
      var $commentnode;
      var $3;
      var $4;
      var $systemnode;
      var $found_comments;
      var $device;
      var $curnode;
      var $file=__stackBase__;
      var $filerr;
      var $5;
      var $6;
      $2=$machine;
      var $7=__Z15xml_file_createv();
      $root=$7;
      var $8=$root;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=0;
      __label__ = 53; break;
    case 2: // $11
      var $12=$root;
      var $13=(function() { try { __THREW__ = false; return __Z13xml_add_childP14_xml_data_nodePKcS2_($12, ((STRING_TABLE.__str132501)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $14
      $commentnode=$13;
      var $15=$commentnode;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $17
      var $18=___cxa_allocate_exception(4);
      var $19=$18;
      var $20=$19;
      HEAP32[(($20)>>2)]=0;
      __ZN13emu_exceptionC1Ev($19);
      (function() { try { __THREW__ = false; return ___cxa_throw($18, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 5; break; }
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI13emu_exception]);
      var $23=$22.f0;
      $3=$23;
      var $24=$22.f1;
      $4=$24;
      __label__ = 46; break;
    case 6: // $25
      var $26=$commentnode;
      var $27=(function() { try { __THREW__ = false; return __Z21xml_set_attribute_intP14_xml_data_nodePKci($26, ((STRING_TABLE.__str142502)|0), 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 5; break; };
    case 7: // $28
      var $29=$commentnode;
      var $30=(function() { try { __THREW__ = false; return __Z13xml_add_childP14_xml_data_nodePKcS2_($29, ((STRING_TABLE.__str152503)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; };
    case 8: // $31
      $systemnode=$30;
      var $32=$systemnode;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      var $35=___cxa_allocate_exception(4);
      var $36=$35;
      var $37=$36;
      HEAP32[(($37)>>2)]=0;
      __ZN13emu_exceptionC1Ev($36);
      (function() { try { __THREW__ = false; return ___cxa_throw($35, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 5; break; }
    case 10: // $38
      var $39=$systemnode;
      var $40=$2;
      var $41=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 5; break; };
    case 11: // $42
      var $43=(($41+8)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(function() { try { __THREW__ = false; return __Z17xml_set_attributeP14_xml_data_nodePKcS2_($39, ((STRING_TABLE.__str162504)|0), $44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 5; break; };
    case 12: // $46
      $found_comments=0;
      var $47=$2;
      var $48=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 5; break; };
    case 13: // $49
      var $50=$48;
      var $51=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 5; break; };
    case 14: // $52
      $device=$51;
      __label__ = 15; break;
    case 15: // $53
      var $54=$device;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 16; break; } else { __label__ = 32; break; }
    case 16: // $56
      var $57=$device;
      var $58=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 5; break; };
    case 17: // $59
      var $60=(function() { try { __THREW__ = false; return __ZNK12device_debug13comment_countEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 5; break; };
    case 18: // $61
      var $62=(($60)>>>0) > 0;
      if ($62) { __label__ = 19; break; } else { __label__ = 29; break; }
    case 19: // $63
      var $64=$systemnode;
      var $65=(function() { try { __THREW__ = false; return __Z13xml_add_childP14_xml_data_nodePKcS2_($64, ((STRING_TABLE.__str172505)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 5; break; };
    case 20: // $66
      $curnode=$65;
      var $67=$curnode;
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $69
      var $70=___cxa_allocate_exception(4);
      var $71=$70;
      var $72=$71;
      HEAP32[(($72)>>2)]=0;
      __ZN13emu_exceptionC1Ev($71);
      (function() { try { __THREW__ = false; return ___cxa_throw($70, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 5; break; }
    case 22: // $73
      var $74=$curnode;
      var $75=$device;
      var $76=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 5; break; };
    case 23: // $77
      var $78=(function() { try { __THREW__ = false; return __Z17xml_set_attributeP14_xml_data_nodePKcS2_($74, ((STRING_TABLE.__str182506)|0), $76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 5; break; };
    case 24: // $79
      var $80=$device;
      var $81=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 5; break; };
    case 25: // $82
      var $83=$curnode;
      var $84=(function() { try { __THREW__ = false; return __ZN12device_debug14comment_exportER14_xml_data_node($81, $83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 5; break; };
    case 26: // $85
      if ($84) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $86
      var $87=___cxa_allocate_exception(4);
      var $88=$87;
      var $89=$88;
      HEAP32[(($89)>>2)]=0;
      __ZN13emu_exceptionC1Ev($88);
      (function() { try { __THREW__ = false; return ___cxa_throw($87, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 5; break; }
    case 28: // $90
      $found_comments=1;
      __label__ = 29; break;
    case 29: // $91
      __label__ = 30; break;
    case 30: // $92
      var $93=$device;
      var $94=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 5; break; };
    case 31: // $95
      $device=$94;
      __label__ = 15; break;
    case 32: // $96
      var $97=$found_comments;
      var $98=(($97) & 1);
      if ($98) { __label__ = 33; break; } else { __label__ = 49; break; }
    case 33: // $99
      var $100=$2;
      var $101=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 5; break; };
    case 34: // $102
      var $103=(function() { try { __THREW__ = false; return __ZNK11emu_options17comment_directoryEv($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 5; break; };
    case 35: // $104
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $103, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 5; break; }
    case 36: // $105
      var $106=$2;
      var $107=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 42; break; };
    case 37: // $108
      var $109=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $107, ((STRING_TABLE.__str192507)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 42; break; };
    case 38: // $110
      $filerr=$109;
      var $111=$filerr;
      var $112=(($111)|0)==0;
      if ($112) { __label__ = 39; break; } else { __label__ = 43; break; }
    case 39: // $113
      var $114=$root;
      var $115=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; };
    case 40: // $116
      (function() { try { __THREW__ = false; return __Z14xml_file_writeP14_xml_data_nodeP10_core_file($114, $115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $117
      __label__ = 43; break;
    case 42: // $118
      var $119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI13emu_exception]);
      var $120=$119.f0;
      $3=$120;
      var $121=$119.f1;
      $4=$121;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 55; break; }
    case 43: // $122
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 5; break; }
    case 44: // $123
      __label__ = 49; break;
    case 45: // $124
      __label__ = 46; break;
    case 46: // $125
      var $126=$4;
      var $127=_llvm_eh_typeid_for(__ZTI13emu_exception);
      var $128=(($126)|0)==(($127)|0);
      if ($128) { __label__ = 47; break; } else { __label__ = 54; break; }
    case 47: // $129
      var $130=$3;
      var $131=___cxa_begin_catch($130);
      var $132=$131;
      $5=$132;
      var $133=$root;
      (function() { try { __THREW__ = false; return __Z13xml_file_freeP14_xml_data_node($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $134
      $1=0;
      $6=1;
      ___cxa_end_catch();
      __label__ = 53; break;
    case 49: // $135
      __label__ = 52; break;
    case 50: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      $3=$138;
      var $139=$137.f1;
      $4=$139;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 55; break; }
    case 51: // $140
      __label__ = 54; break;
    case 52: // $141
      var $142=$root;
      __Z13xml_file_freeP14_xml_data_node($142);
      $1=1;
      __label__ = 53; break;
    case 53: // $143
      var $144=$1;
      STACKTOP = __stackBase__;
      return $144;
    case 54: // $145
      var $146=$3;
      var $147=$3;
      var $148=$4;
      var $149=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $147, tempValue);
      var $150=($149.f1 = $148, $149);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 55: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 56: // $153
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18debug_comment_saveR15running_machine["X"]=1;

function __ZN12device_debug14comment_exportER14_xml_data_node($this, $curnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $crc_buf=__stackBase__;
      var $curr;
      var $4;
      var $5;
      var $datanode;
      var $6;
      $2=$this;
      $3=$curnode;
      var $7=$2;
      __ZN7astringC1Ev($crc_buf);
      var $8=(($7+1576)|0);
      var $9=(function() { try { __THREW__ = false; return __ZNK11simple_listIN12device_debug12dasm_commentEE5firstEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $10
      $curr=$9;
      __label__ = 2; break;
    case 2: // $11
      var $12=$curr;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $14
      var $15=$3;
      var $16=$curr;
      var $17=(($16+16)|0);
      var $18=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $19
      var $20=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $21
      var $22=(function() { try { __THREW__ = false; return __Z13xml_add_childP14_xml_data_nodePKcS2_($15, ((STRING_TABLE.__str332521)|0), $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $23
      $datanode=$22;
      var $24=$datanode;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $26
      $1=0;
      $6=1;
      __label__ = 18; break;
    case 8: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $4=$29;
      var $30=$28.f1;
      $5=$30;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($crc_buf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 9: // $31
      var $32=$datanode;
      var $33=$curr;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(function() { try { __THREW__ = false; return __Z21xml_set_attribute_intP14_xml_data_nodePKci($32, ((STRING_TABLE.__str342522)|0), $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $37
      var $38=$datanode;
      var $39=$curr;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(function() { try { __THREW__ = false; return __Z21xml_set_attribute_intP14_xml_data_nodePKci($38, ((STRING_TABLE.__str352523)|0), $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $43
      var $44=$curr;
      var $45=(($44+12)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($crc_buf, ((STRING_TABLE.__str362524)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$46,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; };
    case 12: // $48
      var $49=$datanode;
      var $50=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($crc_buf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $51
      var $52=(function() { try { __THREW__ = false; return __Z17xml_set_attributeP14_xml_data_nodePKcS2_($49, ((STRING_TABLE.__str372525)|0), $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 8; break; };
    case 14: // $53
      __label__ = 15; break;
    case 15: // $54
      var $55=$curr;
      var $56=(function() { try { __THREW__ = false; return __ZNK12device_debug12dasm_comment4nextEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 8; break; };
    case 16: // $57
      $curr=$56;
      __label__ = 2; break;
    case 17: // $58
      $1=1;
      $6=1;
      __label__ = 18; break;
    case 18: // $59
      FUNCTION_TABLE[__ZN7astringD1Ev]($crc_buf);
      var $60=$1;
      STACKTOP = __stackBase__;
      return $60;
    case 19: // $61
      __label__ = 20; break;
    case 20: // $62
      var $63=$4;
      var $64=$4;
      var $65=$5;
      var $66=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $64, tempValue);
      var $67=($66.f1 = $65, $66);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug14comment_exportER14_xml_data_node["X"]=1;

function __Z18debug_comment_loadR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $file=__stackBase__;
      var $filerr;
      var $3;
      var $4;
      var $5;
      var $root;
      var $commentnode;
      var $version;
      var $systemnode;
      var $name;
      var $cpunode;
      var $device;
      var $6;
      $2=$machine;
      var $7=$2;
      var $8=__ZNK15running_machine7optionsEv($7);
      var $9=__ZNK11emu_options17comment_directoryEv($8);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $9, 1);
      var $10=$2;
      var $11=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $12
      var $13=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $11, ((STRING_TABLE.__str192507)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $14
      $filerr=$13;
      var $15=$filerr;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      $1=0;
      $5=1;
      __label__ = 47; break;
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $3=$20;
      var $21=$19.f1;
      $4=$21;
      __label__ = 48; break;
    case 5: // $22
      var $23=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 4; break; };
    case 6: // $24
      var $25=(function() { try { __THREW__ = false; return __Z13xml_file_readP10_core_fileP18_xml_parse_options($23, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $26
      $root=$25;
      var $27=$root;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      var $32=$31;
      HEAP32[(($32)>>2)]=0;
      __ZN13emu_exceptionC1Ev($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 9; break; }
    case 9: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI13emu_exception]);
      var $35=$34.f0;
      $3=$35;
      var $36=$34.f1;
      $4=$36;
      __label__ = 10; break;
    case 10: // $37
      var $38=$4;
      var $39=_llvm_eh_typeid_for(__ZTI13emu_exception);
      var $40=(($38)|0)==(($39)|0);
      if ($40) { __label__ = 11; break; } else { __label__ = 48; break; }
    case 11: // $41
      var $42=$3;
      var $43=___cxa_begin_catch($42);
      var $44=$43;
      $6=$44;
      var $45=$root;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 12; break; } else { __label__ = 42; break; }
    case 12: // $47
      var $48=$root;
      (function() { try { __THREW__ = false; return __Z13xml_file_freeP14_xml_data_node($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 41; break; }
    case 13: // $49
      __label__ = 42; break;
    case 14: // $50
      var $51=$root;
      var $52=(($51+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($53, ((STRING_TABLE.__str132501)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 9; break; };
    case 15: // $55
      $commentnode=$54;
      var $56=$commentnode;
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $58
      var $59=___cxa_allocate_exception(4);
      var $60=$59;
      var $61=$60;
      HEAP32[(($61)>>2)]=0;
      __ZN13emu_exceptionC1Ev($60);
      (function() { try { __THREW__ = false; return ___cxa_throw($59, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 9; break; }
    case 17: // $62
      var $63=$commentnode;
      var $64=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($63, ((STRING_TABLE.__str142502)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $65
      $version=$64;
      var $66=$version;
      var $67=(($66)|0)!=1;
      if ($67) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $68
      var $69=___cxa_allocate_exception(4);
      var $70=$69;
      var $71=$70;
      HEAP32[(($71)>>2)]=0;
      __ZN13emu_exceptionC1Ev($70);
      (function() { try { __THREW__ = false; return ___cxa_throw($69, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 9; break; }
    case 20: // $72
      var $73=$commentnode;
      var $74=(($73+8)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($75, ((STRING_TABLE.__str152503)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 9; break; };
    case 21: // $77
      $systemnode=$76;
      var $78=$systemnode;
      var $79=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($78, ((STRING_TABLE.__str162504)|0), ((__str202508)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $80
      $name=$79;
      var $81=$name;
      var $82=$2;
      var $83=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 9; break; };
    case 23: // $84
      var $85=(($83+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(function() { try { __THREW__ = false; return _strcmp($81, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 9; break; };
    case 24: // $88
      var $89=(($87)|0)!=0;
      if ($89) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $90
      var $91=___cxa_allocate_exception(4);
      var $92=$91;
      var $93=$92;
      HEAP32[(($93)>>2)]=0;
      __ZN13emu_exceptionC1Ev($92);
      (function() { try { __THREW__ = false; return ___cxa_throw($91, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 9; break; }
    case 26: // $94
      var $95=$systemnode;
      var $96=(($95+8)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($97, ((STRING_TABLE.__str172505)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 9; break; };
    case 27: // $99
      $cpunode=$98;
      __label__ = 28; break;
    case 28: // $100
      var $101=$cpunode;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 29; break; } else { __label__ = 40; break; }
    case 29: // $103
      var $104=$2;
      var $105=$cpunode;
      var $106=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($105, ((STRING_TABLE.__str182506)|0), ((__str202508)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 9; break; };
    case 30: // $107
      var $108=(function() { try { __THREW__ = false; return __ZN15running_machine6deviceEPKc($104, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 9; break; };
    case 31: // $109
      $device=$108;
      var $110=$device;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 32; break; } else { __label__ = 37; break; }
    case 32: // $112
      var $113=$device;
      var $114=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 9; break; };
    case 33: // $115
      var $116=$cpunode;
      var $117=(function() { try { __THREW__ = false; return __ZN12device_debug14comment_importER14_xml_data_node($114, $116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 9; break; };
    case 34: // $118
      if ($117) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $119
      var $120=___cxa_allocate_exception(4);
      var $121=$120;
      var $122=$121;
      HEAP32[(($122)>>2)]=0;
      __ZN13emu_exceptionC1Ev($121);
      (function() { try { __THREW__ = false; return ___cxa_throw($120, __ZTI13emu_exception, 210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 9; break; }
    case 36: // $123
      __label__ = 37; break;
    case 37: // $124
      __label__ = 38; break;
    case 38: // $125
      var $126=$cpunode;
      var $127=(($126)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($128, ((STRING_TABLE.__str172505)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 9; break; };
    case 39: // $130
      $cpunode=$129;
      __label__ = 28; break;
    case 40: // $131
      __label__ = 45; break;
    case 41: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $134=$133.f0;
      $3=$134;
      var $135=$133.f1;
      $4=$135;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 51; break; }
    case 42: // $136
      $1=0;
      $5=1;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 4; break; }
    case 43: // $137
      __label__ = 47; break;
    case 44: // $138
      __label__ = 48; break;
    case 45: // $139
      var $140=$root;
      (function() { try { __THREW__ = false; return __Z13xml_file_freeP14_xml_data_node($140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 4; break; }
    case 46: // $141
      $1=1;
      $5=1;
      __label__ = 47; break;
    case 47: // $142
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $143=$1;
      STACKTOP = __stackBase__;
      return $143;
    case 48: // $144
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $145
      __label__ = 50; break;
    case 50: // $146
      var $147=$3;
      var $148=$3;
      var $149=$4;
      var $150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $148, tempValue);
      var $151=($150.f1 = $149, $150);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 51: // $152
      var $153=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 52: // $154
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18debug_comment_loadR15running_machine["X"]=1;

function __ZNK13address_space6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13address_space8spacenumEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+44)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13address_space11logbytemaskEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13address_space19set_debugger_accessEb($this, $debugger) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($debugger)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  var $7=(($4+48)|0);
  var $8=(($6)&1);
  HEAP8[($7)]=$8;
  ;
  return;
}


function __Z19debug_cpu_translateP13address_spaceiPj($space, $intention, $address) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $memory=__stackBase__;
      $2=$space;
      $3=$intention;
      $4=$address;
      var $5=$2;
      var $6=__ZNK13address_space6deviceEv($5);
      var $7=__ZN8device_t9interfaceERP23device_memory_interface($6, $memory);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=HEAP32[(($memory)>>2)];
      var $10=$2;
      var $11=__ZNK13address_space8spacenumEv($10);
      var $12=$3;
      var $13=$4;
      var $14=__ZN23device_memory_interface9translateE16address_spacenumiRj($9, $11, $12, $13);
      var $15=(($14)&1);
      $1=$15;
      __label__ = 3; break;
    case 2: // $16
      $1=1;
      __label__ = 3; break;
    case 3: // $17
      var $18=$1;
      STACKTOP = __stackBase__;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN23device_memory_interface9translateE16address_spacenumiRj($this, $spacenum, $intention, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$spacenum;
  $3=$intention;
  $4=$address;
  var $5=$1;
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+60)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=FUNCTION_TABLE[$9]($5, $10, $11, $12);
  ;
  return $13;
}


function __Z15debug_read_byteP13address_spaceji($_space, $address, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $space;
      var $global;
      var $custom=__stackBase__+4;
      var $result;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$apply_translation;
      var $4=$1;
      $space=$4;
      var $5=$space;
      var $6=__ZNK13address_space7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=$space;
      var $10=__ZNK13address_space11logbytemaskEv($9);
      var $11=HEAP32[(($2)>>2)];
      var $12=$11 & $10;
      HEAP32[(($2)>>2)]=$12;
      var $13=$space;
      var $14=$global;
      var $15=(($14+23)|0);
      HEAP8[($15)]=1;
      __ZN13address_space19set_debugger_accessEb($13, 1);
      var $16=$3;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $18
      var $19=$space;
      var $20=__Z19debug_cpu_translateP13address_spaceiPj($19, 8, $2);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $22
      $result=-1;
      __label__ = 7; break;
    case 3: // $23
      var $24=$space;
      var $25=__ZNK13address_space6deviceEv($24);
      var $26=__ZNK8device_t6memoryEv($25);
      var $27=$space;
      var $28=__ZNK13address_space8spacenumEv($27);
      var $29=HEAP32[(($2)>>2)];
      var $30=__ZN23device_memory_interface4readE16address_spacenumjiRy($26, $28, $29, 1, $custom);
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $st$0$0=(($custom)|0);
      var $32$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($custom+4)|0);
      var $32$1=HEAP32[(($st$0$1)>>2)];
      var $33$0=$32$0;
      var $33=$33$0&255;
      $result=$33;
      __label__ = 6; break;
    case 5: // $34
      var $35=$space;
      var $36=$35;
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+28)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=HEAP32[(($2)>>2)];
      var $41=FUNCTION_TABLE[$39]($35, $40);
      $result=$41;
      __label__ = 6; break;
    case 6: // $42
      __label__ = 7; break;
    case 7: // $43
      var $44=$space;
      var $45=$global;
      var $46=(($45+23)|0);
      HEAP8[($46)]=0;
      __ZN13address_space19set_debugger_accessEb($44, 0);
      var $47=$result;
      STACKTOP = __stackBase__;
      return $47;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15debug_read_byteP13address_spaceji["X"]=1;

function __ZN23device_memory_interface4readE16address_spacenumjiRy($this, $spacenum, $offset, $size, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$spacenum;
  $3=$offset;
  $4=$size;
  $5=$value;
  var $6=$1;
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+64)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  var $15=FUNCTION_TABLE[$10]($6, $11, $12, $13, $14);
  ;
  return $15;
}


function __Z15debug_read_wordP13address_spaceji($_space, $address, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $space;
      var $global;
      var $result;
      var $byte0;
      var $byte1;
      var $custom=__stackBase__+4;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$apply_translation;
      var $4=$1;
      $space=$4;
      var $5=$space;
      var $6=__ZNK13address_space7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=$space;
      var $10=__ZNK13address_space11logbytemaskEv($9);
      var $11=HEAP32[(($2)>>2)];
      var $12=$11 & $10;
      HEAP32[(($2)>>2)]=$12;
      var $13=HEAP32[(($2)>>2)];
      var $14=$13 & 1;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $16
      var $17=$space;
      var $18=HEAP32[(($2)>>2)];
      var $19=(($18)|0);
      var $20=$3;
      var $21=__Z15debug_read_byteP13address_spaceji($17, $19, $20);
      $byte0=$21;
      var $22=$space;
      var $23=HEAP32[(($2)>>2)];
      var $24=(($23+1)|0);
      var $25=$3;
      var $26=__Z15debug_read_byteP13address_spaceji($22, $24, $25);
      $byte1=$26;
      var $27=$space;
      var $28=__ZNK13address_space10endiannessEv($27);
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $30
      var $31=$byte0;
      var $32=(($31)&255);
      var $33=$byte1;
      var $34=(($33)&255);
      var $35=$34 << 8;
      var $36=$32 | $35;
      var $37=(($36) & 65535);
      $result=$37;
      __label__ = 4; break;
    case 3: // $38
      var $39=$byte1;
      var $40=(($39)&255);
      var $41=$byte0;
      var $42=(($41)&255);
      var $43=$42 << 8;
      var $44=$40 | $43;
      var $45=(($44) & 65535);
      $result=$45;
      __label__ = 4; break;
    case 4: // $46
      __label__ = 13; break;
    case 5: // $47
      var $48=$space;
      var $49=$global;
      var $50=(($49+23)|0);
      HEAP8[($50)]=1;
      __ZN13address_space19set_debugger_accessEb($48, 1);
      var $51=$3;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $53
      var $54=$space;
      var $55=__Z19debug_cpu_translateP13address_spaceiPj($54, 8, $2);
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $57
      $result=-1;
      __label__ = 12; break;
    case 8: // $58
      var $59=$space;
      var $60=__ZNK13address_space6deviceEv($59);
      var $61=__ZNK8device_t6memoryEv($60);
      var $62=$space;
      var $63=__ZNK13address_space8spacenumEv($62);
      var $64=HEAP32[(($2)>>2)];
      var $65=__ZN23device_memory_interface4readE16address_spacenumjiRy($61, $63, $64, 2, $custom);
      if ($65) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $66
      var $st$0$0=(($custom)|0);
      var $67$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($custom+4)|0);
      var $67$1=HEAP32[(($st$0$1)>>2)];
      var $68$0=$67$0;
      var $68=$68$0&65535;
      $result=$68;
      __label__ = 11; break;
    case 10: // $69
      var $70=$space;
      var $71=$70;
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+32)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=HEAP32[(($2)>>2)];
      var $76=FUNCTION_TABLE[$74]($70, $75);
      $result=$76;
      __label__ = 11; break;
    case 11: // $77
      __label__ = 12; break;
    case 12: // $78
      var $79=$space;
      var $80=$global;
      var $81=(($80+23)|0);
      HEAP8[($81)]=0;
      __ZN13address_space19set_debugger_accessEb($79, 0);
      __label__ = 13; break;
    case 13: // $82
      var $83=$result;
      STACKTOP = __stackBase__;
      return $83;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15debug_read_wordP13address_spaceji["X"]=1;

function __ZNK13address_space10endiannessEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK20address_space_config10endiannessEv($4);
  ;
  return $5;
}


function __Z16debug_read_dwordP13address_spaceji($_space, $address, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $space;
      var $global;
      var $result;
      var $word0;
      var $word1;
      var $custom=__stackBase__+4;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$apply_translation;
      var $4=$1;
      $space=$4;
      var $5=$space;
      var $6=__ZNK13address_space7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=$space;
      var $10=__ZNK13address_space11logbytemaskEv($9);
      var $11=HEAP32[(($2)>>2)];
      var $12=$11 & $10;
      HEAP32[(($2)>>2)]=$12;
      var $13=HEAP32[(($2)>>2)];
      var $14=$13 & 3;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $16
      var $17=$space;
      var $18=HEAP32[(($2)>>2)];
      var $19=(($18)|0);
      var $20=$3;
      var $21=__Z15debug_read_wordP13address_spaceji($17, $19, $20);
      $word0=$21;
      var $22=$space;
      var $23=HEAP32[(($2)>>2)];
      var $24=(($23+2)|0);
      var $25=$3;
      var $26=__Z15debug_read_wordP13address_spaceji($22, $24, $25);
      $word1=$26;
      var $27=$space;
      var $28=__ZNK13address_space10endiannessEv($27);
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $30
      var $31=$word0;
      var $32=(($31)&65535);
      var $33=$word1;
      var $34=(($33)&65535);
      var $35=$34 << 16;
      var $36=$32 | $35;
      $result=$36;
      __label__ = 4; break;
    case 3: // $37
      var $38=$word1;
      var $39=(($38)&65535);
      var $40=$word0;
      var $41=(($40)&65535);
      var $42=$41 << 16;
      var $43=$39 | $42;
      $result=$43;
      __label__ = 4; break;
    case 4: // $44
      __label__ = 13; break;
    case 5: // $45
      var $46=$space;
      var $47=$global;
      var $48=(($47+23)|0);
      HEAP8[($48)]=1;
      __ZN13address_space19set_debugger_accessEb($46, 1);
      var $49=$3;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $51
      var $52=$space;
      var $53=__Z19debug_cpu_translateP13address_spaceiPj($52, 8, $2);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $55
      $result=-1;
      __label__ = 12; break;
    case 8: // $56
      var $57=$space;
      var $58=__ZNK13address_space6deviceEv($57);
      var $59=__ZNK8device_t6memoryEv($58);
      var $60=$space;
      var $61=__ZNK13address_space8spacenumEv($60);
      var $62=HEAP32[(($2)>>2)];
      var $63=__ZN23device_memory_interface4readE16address_spacenumjiRy($59, $61, $62, 4, $custom);
      if ($63) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $64
      var $st$0$0=(($custom)|0);
      var $65$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($custom+4)|0);
      var $65$1=HEAP32[(($st$0$1)>>2)];
      var $66$0=$65$0;
      var $66=$66$0;
      $result=$66;
      __label__ = 11; break;
    case 10: // $67
      var $68=$space;
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+48)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=HEAP32[(($2)>>2)];
      var $74=FUNCTION_TABLE[$72]($68, $73);
      $result=$74;
      __label__ = 11; break;
    case 11: // $75
      __label__ = 12; break;
    case 12: // $76
      var $77=$space;
      var $78=$global;
      var $79=(($78+23)|0);
      HEAP8[($79)]=0;
      __ZN13address_space19set_debugger_accessEb($77, 0);
      __label__ = 13; break;
    case 13: // $80
      var $81=$result;
      STACKTOP = __stackBase__;
      return $81;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16debug_read_dwordP13address_spaceji["X"]=1;

function __Z16debug_read_qwordP13address_spaceji($_space, $address, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $space;
      var $global;
      var $result=__stackBase__+4;
      var $dword0;
      var $dword1;
      var $custom=__stackBase__+12;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$apply_translation;
      var $4=$1;
      $space=$4;
      var $5=$space;
      var $6=__ZNK13address_space7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=$space;
      var $10=__ZNK13address_space11logbytemaskEv($9);
      var $11=HEAP32[(($2)>>2)];
      var $12=$11 & $10;
      HEAP32[(($2)>>2)]=$12;
      var $13=HEAP32[(($2)>>2)];
      var $14=$13 & 7;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $16
      var $17=$space;
      var $18=HEAP32[(($2)>>2)];
      var $19=(($18)|0);
      var $20=$3;
      var $21=__Z16debug_read_dwordP13address_spaceji($17, $19, $20);
      $dword0=$21;
      var $22=$space;
      var $23=HEAP32[(($2)>>2)];
      var $24=(($23+4)|0);
      var $25=$3;
      var $26=__Z16debug_read_dwordP13address_spaceji($22, $24, $25);
      $dword1=$26;
      var $27=$space;
      var $28=__ZNK13address_space10endiannessEv($27);
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $30
      var $31=$dword0;
      var $32$0=$31;
      var $32$1=0;
      var $33=$dword1;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=0;
      var $35$1=$34$0;
      var $36$0=$32$0 | $35$0;
      var $36$1=$32$1 | $35$1;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$36$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$36$1;
      __label__ = 4; break;
    case 3: // $37
      var $38=$dword1;
      var $39$0=$38;
      var $39$1=0;
      var $40=$dword0;
      var $41$0=$40;
      var $41$1=0;
      var $42$0=0;
      var $42$1=$41$0;
      var $43$0=$39$0 | $42$0;
      var $43$1=$39$1 | $42$1;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$43$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$43$1;
      __label__ = 4; break;
    case 4: // $44
      __label__ = 13; break;
    case 5: // $45
      var $46=$space;
      var $47=$global;
      var $48=(($47+23)|0);
      HEAP8[($48)]=1;
      __ZN13address_space19set_debugger_accessEb($46, 1);
      var $49=$3;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $51
      var $52=$space;
      var $53=__Z19debug_cpu_translateP13address_spaceiPj($52, 8, $2);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $55
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$2$0=(($result)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($result+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 12; break;
    case 8: // $56
      var $57=$space;
      var $58=__ZNK13address_space6deviceEv($57);
      var $59=__ZNK8device_t6memoryEv($58);
      var $60=$space;
      var $61=__ZNK13address_space8spacenumEv($60);
      var $62=HEAP32[(($2)>>2)];
      var $63=__ZN23device_memory_interface4readE16address_spacenumjiRy($59, $61, $62, 8, $custom);
      if ($63) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $64
      var $st$0$0=(($custom)|0);
      var $65$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($custom+4)|0);
      var $65$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($result)|0);
      HEAP32[(($st$4$0)>>2)]=$65$0;
      var $st$4$1=(($result+4)|0);
      HEAP32[(($st$4$1)>>2)]=$65$1;
      __label__ = 11; break;
    case 10: // $66
      var $67=$space;
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+64)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=FUNCTION_TABLE[$71]($67, $72);
      var $73$0=$73[0];
      var $73$1=$73[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$73$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$73$1;
      __label__ = 11; break;
    case 11: // $74
      __label__ = 12; break;
    case 12: // $75
      var $76=$space;
      var $77=$global;
      var $78=(($77+23)|0);
      HEAP8[($78)]=0;
      __ZN13address_space19set_debugger_accessEb($76, 0);
      __label__ = 13; break;
    case 13: // $79
      var $st$0$0=(($result)|0);
      var $80$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $80$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$80$0,$80$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16debug_read_qwordP13address_spaceji["X"]=1;

function __Z17debug_read_memoryP13address_spacejii($space, $address, $size, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $result=__stackBase__;
      $1=$space;
      $2=$address;
      $3=$size;
      $4=$apply_translation;
      var $5=$3;
      var $6=((($5<<3))|0);
      var $7=((64-$6)|0);
      var $8$0=$7;
      var $8$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $9=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$8$0);var $9$0 = $9[0], $9$1 = $9[1];
      var $st$17$0=(($result)|0);
      HEAP32[(($st$17$0)>>2)]=$9$0;
      var $st$17$1=(($result+4)|0);
      HEAP32[(($st$17$1)>>2)]=$9$1;
      var $10=$3;
      if ($10 == 1) {
        __label__ = 1; break;
      }
      else if ($10 == 2) {
        __label__ = 2; break;
      }
      else if ($10 == 4) {
        __label__ = 3; break;
      }
      else if ($10 == 8) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $11
      var $12=$1;
      var $13=$2;
      var $14=$4;
      var $15=__Z15debug_read_byteP13address_spaceji($12, $13, $14);
      var $16$0=$15;
      var $16$1=0;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$16$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$16$1;
      __label__ = 5; break;
    case 2: // $17
      var $18=$1;
      var $19=$2;
      var $20=$4;
      var $21=__Z15debug_read_wordP13address_spaceji($18, $19, $20);
      var $22$0=$21;
      var $22$1=0;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$22$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$22$1;
      __label__ = 5; break;
    case 3: // $23
      var $24=$1;
      var $25=$2;
      var $26=$4;
      var $27=__Z16debug_read_dwordP13address_spaceji($24, $25, $26);
      var $28$0=$27;
      var $28$1=0;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$28$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$28$1;
      __label__ = 5; break;
    case 4: // $29
      var $30=$1;
      var $31=$2;
      var $32=$4;
      var $33=__Z16debug_read_qwordP13address_spaceji($30, $31, $32);
      var $33$0=$33[0];
      var $33$1=$33[1];
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$33$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$33$1;
      __label__ = 5; break;
    case 5: // $34
      var $st$0$0=(($result)|0);
      var $35$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $35$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$35$0,$35$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17debug_read_memoryP13address_spacejii["X"]=1;

function __Z16debug_write_byteP13address_spacejhi($_space, $address, $data, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $space;
      var $global;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$data;
      $4=$apply_translation;
      var $5=$1;
      $space=$5;
      var $6=$space;
      var $7=__ZNK13address_space7machineEv($6);
      var $8=(($7+652)|0);
      var $9=HEAP32[(($8)>>2)];
      $global=$9;
      var $10=$space;
      var $11=__ZNK13address_space11logbytemaskEv($10);
      var $12=HEAP32[(($2)>>2)];
      var $13=$12 & $11;
      HEAP32[(($2)>>2)]=$13;
      var $14=$space;
      var $15=$global;
      var $16=(($15+23)|0);
      HEAP8[($16)]=1;
      __ZN13address_space19set_debugger_accessEb($14, 1);
      var $17=$4;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $19
      var $20=$space;
      var $21=__Z19debug_cpu_translateP13address_spaceiPj($20, 9, $2);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $23
      __label__ = 7; break;
    case 3: // $24
      var $25=$space;
      var $26=__ZNK13address_space6deviceEv($25);
      var $27=__ZNK8device_t6memoryEv($26);
      var $28=$space;
      var $29=__ZNK13address_space8spacenumEv($28);
      var $30=HEAP32[(($2)>>2)];
      var $31=$3;
      var $32$0=$31;
      var $32$1=0;
      var $33=__ZN23device_memory_interface5writeE16address_spacenumjiy($27, $29, $30, 1, $32$0, $32$1);
      var $33$0=$33[0];
      if ($33) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $34
      __label__ = 6; break;
    case 5: // $35
      var $36=$space;
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+80)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=HEAP32[(($2)>>2)];
      var $42=$3;
      FUNCTION_TABLE[$40]($36, $41, $42);
      __label__ = 6; break;
    case 6: // $43
      __label__ = 7; break;
    case 7: // $44
      var $45=$space;
      var $46=$global;
      var $47=(($46+23)|0);
      HEAP8[($47)]=0;
      __ZN13address_space19set_debugger_accessEb($45, 0);
      var $48=$global;
      var $49=(($48+22)|0);
      HEAP8[($49)]=1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16debug_write_byteP13address_spacejhi["X"]=1;

function __ZN23device_memory_interface5writeE16address_spacenumjiy($this, $spacenum, $offset, $size, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  $1=$this;
  $2=$spacenum;
  $3=$offset;
  $4=$size;
  var $st$9$0=(($5)|0);
  HEAP32[(($st$9$0)>>2)]=$value$0;
  var $st$9$1=(($5+4)|0);
  HEAP32[(($st$9$1)>>2)]=$value$1;
  var $6=$1;
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+68)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $st$21$0=(($5)|0);
  var $14$0=HEAP32[(($st$21$0)>>2)];
  var $st$21$1=(($5+4)|0);
  var $14$1=HEAP32[(($st$21$1)>>2)];
  var $15=FUNCTION_TABLE[$10]($6, $11, $12, $13, $14$0, $14$1);
  var $15$0=$15[0];
  STACKTOP = __stackBase__;
  return $15;
}


function __ZN12device_debug14comment_importER14_xml_data_node($this, $cpunode) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $datanode;
      var $address;
      var $color;
      var $crc=__stackBase__+36;
      var $11;
      var $12;
      $9=$this;
      $10=$cpunode;
      var $13=$9;
      var $14=$10;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z15xml_get_siblingP14_xml_data_nodePKc($16, ((STRING_TABLE.__str332521)|0));
      $datanode=$17;
      __label__ = 1; break;
    case 1: // $18
      var $19=$datanode;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $21
      var $22=$datanode;
      var $23=__Z21xml_get_attribute_intP14_xml_data_nodePKci($22, ((STRING_TABLE.__str342522)|0), 0);
      $address=$23;
      var $24=$datanode;
      var $25=__Z21xml_get_attribute_intP14_xml_data_nodePKci($24, ((STRING_TABLE.__str352523)|0), 0);
      $color=$25;
      var $26=$datanode;
      var $27=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($26, ((STRING_TABLE.__str372525)|0), 0);
      var $28=_sscanf($27, ((STRING_TABLE.__str362524)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$crc,tempInt));
      var $29=(($13+1576)|0);
      var $30=(($13)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__ZNK8device_t7machineEv($31);
      var $33=__ZN15running_machine7respoolEv($32);
      var $34=$4;
      var $35=$5;
      var $36=$6;
      var $37=$result_i;
      var $38=$7;
      var $39=$8;
      HEAP32[(($4)>>2)]=80;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($6)>>2)]=2649;
      var $40=HEAP32[(($4)>>2)];
      var $41=HEAP32[(($5)>>2)];
      var $42=HEAP32[(($6)>>2)];
      var $43=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40, $41, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $44
      HEAP32[(($result_i)>>2)]=$43;
      var $45=HEAP32[(($result_i)>>2)];
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $47
      var $48=___cxa_allocate_exception(4);
      var $49=$48;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($49);
      (function() { try { __THREW__ = false; return ___cxa_throw($48, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      HEAP32[(($7)>>2)]=$52;
      var $53=$51.f1;
      HEAP32[(($8)>>2)]=$53;
      var $54=HEAP32[(($8)>>2)];
      var $55=(($54)|0) < 0;
      if ($55) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $56
      var $57=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($57);
      throw "Reached an unreachable!"
    case 7: // $58
      var $59=HEAP32[(($7)>>2)];
      var $60=HEAP32[(($7)>>2)];
      var $61=HEAP32[(($8)>>2)];
      var $62=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $60, tempValue);
      var $63=($62.f1 = $61, $62);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $64
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $65=HEAP32[(($result_i)>>2)];
      var $66=$4;
      var $67=$5;
      var $68=$6;
      var $69=$result_i;
      var $70=$7;
      var $71=$8;
      var $72=$65;
      var $73=$datanode;
      var $74=(($73+16)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$address;
      var $77=$color;
      var $78=HEAP32[(($crc)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debug12dasm_commentC1EPKcjjj]($72, $75, $76, $77, $78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $79
      var $80=__ZN13resource_pool10add_objectIN12device_debug12dasm_commentEEEPT_S4_($33, $72);
      var $81=__ZN11simple_listIN12device_debug12dasm_commentEE6appendERS1_($29, $80);
      __label__ = 11; break;
    case 11: // $82
      var $83=$datanode;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=__Z15xml_get_siblingP14_xml_data_nodePKc($85, ((STRING_TABLE.__str332521)|0));
      $datanode=$86;
      __label__ = 1; break;
    case 12: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      $11=$89;
      var $90=$88.f1;
      $12=$90;
      var $91=$1;
      var $92=$2;
      var $93=$3;
      HEAP32[(($1)>>2)]=$65;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=2649;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $96
      var $97=HEAP32[(($1)>>2)];
      var $98=HEAP32[(($2)>>2)];
      var $99=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($97, $98, $99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $100=$1;
      var $101=$2;
      var $102=$3;
      __label__ = 16; break;
    case 16: // $103
      __label__ = 18; break;
    case 17: // $104
      STACKTOP = __stackBase__;
      return 1;
    case 18: // $105
      var $106=$11;
      var $107=$11;
      var $108=$12;
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug14comment_importER14_xml_data_node["X"]=1;

function __Z16debug_write_wordP13address_spacejti($_space, $address, $data, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $space;
      var $global;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$data;
      $4=$apply_translation;
      var $5=$1;
      $space=$5;
      var $6=$space;
      var $7=__ZNK13address_space7machineEv($6);
      var $8=(($7+652)|0);
      var $9=HEAP32[(($8)>>2)];
      $global=$9;
      var $10=$space;
      var $11=__ZNK13address_space11logbytemaskEv($10);
      var $12=HEAP32[(($2)>>2)];
      var $13=$12 & $11;
      HEAP32[(($2)>>2)]=$13;
      var $14=HEAP32[(($2)>>2)];
      var $15=$14 & 1;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $17
      var $18=$space;
      var $19=__ZNK13address_space10endiannessEv($18);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$space;
      var $23=HEAP32[(($2)>>2)];
      var $24=(($23)|0);
      var $25=$3;
      var $26=(($25)&65535);
      var $27=$26 >> 0;
      var $28=(($27) & 255);
      var $29=$4;
      __Z16debug_write_byteP13address_spacejhi($22, $24, $28, $29);
      var $30=$space;
      var $31=HEAP32[(($2)>>2)];
      var $32=(($31+1)|0);
      var $33=$3;
      var $34=(($33)&65535);
      var $35=$34 >> 8;
      var $36=(($35) & 255);
      var $37=$4;
      __Z16debug_write_byteP13address_spacejhi($30, $32, $36, $37);
      __label__ = 4; break;
    case 3: // $38
      var $39=$space;
      var $40=HEAP32[(($2)>>2)];
      var $41=(($40)|0);
      var $42=$3;
      var $43=(($42)&65535);
      var $44=$43 >> 8;
      var $45=(($44) & 255);
      var $46=$4;
      __Z16debug_write_byteP13address_spacejhi($39, $41, $45, $46);
      var $47=$space;
      var $48=HEAP32[(($2)>>2)];
      var $49=(($48+1)|0);
      var $50=$3;
      var $51=(($50)&65535);
      var $52=$51 >> 0;
      var $53=(($52) & 255);
      var $54=$4;
      __Z16debug_write_byteP13address_spacejhi($47, $49, $53, $54);
      __label__ = 4; break;
    case 4: // $55
      __label__ = 13; break;
    case 5: // $56
      var $57=$space;
      var $58=$global;
      var $59=(($58+23)|0);
      HEAP8[($59)]=1;
      __ZN13address_space19set_debugger_accessEb($57, 1);
      var $60=$4;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $62
      var $63=$space;
      var $64=__Z19debug_cpu_translateP13address_spaceiPj($63, 9, $2);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $66
      __label__ = 12; break;
    case 8: // $67
      var $68=$space;
      var $69=__ZNK13address_space6deviceEv($68);
      var $70=__ZNK8device_t6memoryEv($69);
      var $71=$space;
      var $72=__ZNK13address_space8spacenumEv($71);
      var $73=HEAP32[(($2)>>2)];
      var $74=$3;
      var $75$0=$74;
      var $75$1=0;
      var $76=__ZN23device_memory_interface5writeE16address_spacenumjiy($70, $72, $73, 2, $75$0, $75$1);
      var $76$0=$76[0];
      if ($76) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $77
      __label__ = 11; break;
    case 10: // $78
      var $79=$space;
      var $80=$79;
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+84)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=HEAP32[(($2)>>2)];
      var $85=$3;
      FUNCTION_TABLE[$83]($79, $84, $85);
      __label__ = 11; break;
    case 11: // $86
      __label__ = 12; break;
    case 12: // $87
      var $88=$space;
      var $89=$global;
      var $90=(($89+23)|0);
      HEAP8[($90)]=0;
      __ZN13address_space19set_debugger_accessEb($88, 0);
      var $91=$global;
      var $92=(($91+22)|0);
      HEAP8[($92)]=1;
      __label__ = 13; break;
    case 13: // $93
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16debug_write_wordP13address_spacejti["X"]=1;

function __Z17debug_write_dwordP13address_spacejji($_space, $address, $data, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $space;
      var $global;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      $3=$data;
      $4=$apply_translation;
      var $5=$1;
      $space=$5;
      var $6=$space;
      var $7=__ZNK13address_space7machineEv($6);
      var $8=(($7+652)|0);
      var $9=HEAP32[(($8)>>2)];
      $global=$9;
      var $10=$space;
      var $11=__ZNK13address_space11logbytemaskEv($10);
      var $12=HEAP32[(($2)>>2)];
      var $13=$12 & $11;
      HEAP32[(($2)>>2)]=$13;
      var $14=HEAP32[(($2)>>2)];
      var $15=$14 & 3;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $17
      var $18=$space;
      var $19=__ZNK13address_space10endiannessEv($18);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$space;
      var $23=HEAP32[(($2)>>2)];
      var $24=(($23)|0);
      var $25=$3;
      var $26=$25 >>> 0;
      var $27=(($26) & 65535);
      var $28=$4;
      __Z16debug_write_wordP13address_spacejti($22, $24, $27, $28);
      var $29=$space;
      var $30=HEAP32[(($2)>>2)];
      var $31=(($30+2)|0);
      var $32=$3;
      var $33=$32 >>> 16;
      var $34=(($33) & 65535);
      var $35=$4;
      __Z16debug_write_wordP13address_spacejti($29, $31, $34, $35);
      __label__ = 4; break;
    case 3: // $36
      var $37=$space;
      var $38=HEAP32[(($2)>>2)];
      var $39=(($38)|0);
      var $40=$3;
      var $41=$40 >>> 16;
      var $42=(($41) & 65535);
      var $43=$4;
      __Z16debug_write_wordP13address_spacejti($37, $39, $42, $43);
      var $44=$space;
      var $45=HEAP32[(($2)>>2)];
      var $46=(($45+2)|0);
      var $47=$3;
      var $48=$47 >>> 0;
      var $49=(($48) & 65535);
      var $50=$4;
      __Z16debug_write_wordP13address_spacejti($44, $46, $49, $50);
      __label__ = 4; break;
    case 4: // $51
      __label__ = 13; break;
    case 5: // $52
      var $53=$space;
      var $54=$global;
      var $55=(($54+23)|0);
      HEAP8[($55)]=1;
      __ZN13address_space19set_debugger_accessEb($53, 1);
      var $56=$4;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $58
      var $59=$space;
      var $60=__Z19debug_cpu_translateP13address_spaceiPj($59, 9, $2);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      __label__ = 12; break;
    case 8: // $63
      var $64=$space;
      var $65=__ZNK13address_space6deviceEv($64);
      var $66=__ZNK8device_t6memoryEv($65);
      var $67=$space;
      var $68=__ZNK13address_space8spacenumEv($67);
      var $69=HEAP32[(($2)>>2)];
      var $70=$3;
      var $71$0=$70;
      var $71$1=0;
      var $72=__ZN23device_memory_interface5writeE16address_spacenumjiy($66, $68, $69, 4, $71$0, $71$1);
      var $72$0=$72[0];
      if ($72) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $73
      __label__ = 11; break;
    case 10: // $74
      var $75=$space;
      var $76=$75;
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+100)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=HEAP32[(($2)>>2)];
      var $81=$3;
      FUNCTION_TABLE[$79]($75, $80, $81);
      __label__ = 11; break;
    case 11: // $82
      __label__ = 12; break;
    case 12: // $83
      var $84=$space;
      var $85=$global;
      var $86=(($85+23)|0);
      HEAP8[($86)]=0;
      __ZN13address_space19set_debugger_accessEb($84, 0);
      var $87=$global;
      var $88=(($87+22)|0);
      HEAP8[($88)]=1;
      __label__ = 13; break;
    case 13: // $89
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17debug_write_dwordP13address_spacejji["X"]=1;

function __Z17debug_write_qwordP13address_spacejyi($_space, $address, $data$0, $data$1, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4;
      var $space;
      var $global;
      $1=$_space;
      HEAP32[(($2)>>2)]=$address;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      $4=$apply_translation;
      var $5=$1;
      $space=$5;
      var $6=$space;
      var $7=__ZNK13address_space7machineEv($6);
      var $8=(($7+652)|0);
      var $9=HEAP32[(($8)>>2)];
      $global=$9;
      var $10=$space;
      var $11=__ZNK13address_space11logbytemaskEv($10);
      var $12=HEAP32[(($2)>>2)];
      var $13=$12 & $11;
      HEAP32[(($2)>>2)]=$13;
      var $14=HEAP32[(($2)>>2)];
      var $15=$14 & 7;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $17
      var $18=$space;
      var $19=__ZNK13address_space10endiannessEv($18);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$space;
      var $23=HEAP32[(($2)>>2)];
      var $24=(($23)|0);
      var $st$3$0=(($3)|0);
      var $25$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $25$1=HEAP32[(($st$3$1)>>2)];
      var $26$0=$25$0;
      var $26$1=$25$1;
      var $27$0=$26$0;
      var $27=$27$0;
      var $28=$4;
      __Z17debug_write_dwordP13address_spacejji($22, $24, $27, $28);
      var $29=$space;
      var $30=HEAP32[(($2)>>2)];
      var $31=(($30+4)|0);
      var $st$16$0=(($3)|0);
      var $32$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($3+4)|0);
      var $32$1=HEAP32[(($st$16$1)>>2)];
      var $33$0=$32$1;
      var $33$1=0;
      var $34$0=$33$0;
      var $34=$34$0;
      var $35=$4;
      __Z17debug_write_dwordP13address_spacejji($29, $31, $34, $35);
      __label__ = 4; break;
    case 3: // $36
      var $37=$space;
      var $38=HEAP32[(($2)>>2)];
      var $39=(($38)|0);
      var $st$3$0=(($3)|0);
      var $40$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $40$1=HEAP32[(($st$3$1)>>2)];
      var $41$0=$40$1;
      var $41$1=0;
      var $42$0=$41$0;
      var $42=$42$0;
      var $43=$4;
      __Z17debug_write_dwordP13address_spacejji($37, $39, $42, $43);
      var $44=$space;
      var $45=HEAP32[(($2)>>2)];
      var $46=(($45+4)|0);
      var $st$16$0=(($3)|0);
      var $47$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($3+4)|0);
      var $47$1=HEAP32[(($st$16$1)>>2)];
      var $48$0=$47$0;
      var $48$1=$47$1;
      var $49$0=$48$0;
      var $49=$49$0;
      var $50=$4;
      __Z17debug_write_dwordP13address_spacejji($44, $46, $49, $50);
      __label__ = 4; break;
    case 4: // $51
      __label__ = 13; break;
    case 5: // $52
      var $53=$space;
      var $54=$global;
      var $55=(($54+23)|0);
      HEAP8[($55)]=1;
      __ZN13address_space19set_debugger_accessEb($53, 1);
      var $56=$4;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $58
      var $59=$space;
      var $60=__Z19debug_cpu_translateP13address_spaceiPj($59, 9, $2);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      __label__ = 12; break;
    case 8: // $63
      var $64=$space;
      var $65=__ZNK13address_space6deviceEv($64);
      var $66=__ZNK8device_t6memoryEv($65);
      var $67=$space;
      var $68=__ZNK13address_space8spacenumEv($67);
      var $69=HEAP32[(($2)>>2)];
      var $st$6$0=(($3)|0);
      var $70$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $70$1=HEAP32[(($st$6$1)>>2)];
      var $71=__ZN23device_memory_interface5writeE16address_spacenumjiy($66, $68, $69, 8, $70$0, $70$1);
      var $71$0=$71[0];
      if ($71) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $72
      __label__ = 11; break;
    case 10: // $73
      var $74=$space;
      var $75=$74;
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76+116)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=HEAP32[(($2)>>2)];
      var $st$6$0=(($3)|0);
      var $80$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $80$1=HEAP32[(($st$6$1)>>2)];
      FUNCTION_TABLE[$78]($74, $79, $80$0, $80$1);
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      var $83=$space;
      var $84=$global;
      var $85=(($84+23)|0);
      HEAP8[($85)]=0;
      __ZN13address_space19set_debugger_accessEb($83, 0);
      var $86=$global;
      var $87=(($86+22)|0);
      HEAP8[($87)]=1;
      __label__ = 13; break;
    case 13: // $88
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17debug_write_qwordP13address_spacejyi["X"]=1;

function __Z18debug_write_memoryP13address_spacejyii($space, $address, $data$0, $data$1, $size, $apply_translation) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      $1=$space;
      $2=$address;
      var $st$7$0=(($3)|0);
      HEAP32[(($st$7$0)>>2)]=$data$0;
      var $st$7$1=(($3+4)|0);
      HEAP32[(($st$7$1)>>2)]=$data$1;
      $4=$size;
      $5=$apply_translation;
      var $6=$4;
      if ($6 == 1) {
        __label__ = 1; break;
      }
      else if ($6 == 2) {
        __label__ = 2; break;
      }
      else if ($6 == 4) {
        __label__ = 3; break;
      }
      else if ($6 == 8) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $7
      var $8=$1;
      var $9=$2;
      var $st$2$0=(($3)|0);
      var $10$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$2$1)>>2)];
      var $11$0=$10$0;
      var $11=$11$0&255;
      var $12=$5;
      __Z16debug_write_byteP13address_spacejhi($8, $9, $11, $12);
      __label__ = 5; break;
    case 2: // $13
      var $14=$1;
      var $15=$2;
      var $st$2$0=(($3)|0);
      var $16$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $16$1=HEAP32[(($st$2$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0&65535;
      var $18=$5;
      __Z16debug_write_wordP13address_spacejti($14, $15, $17, $18);
      __label__ = 5; break;
    case 3: // $19
      var $20=$1;
      var $21=$2;
      var $st$2$0=(($3)|0);
      var $22$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $22$1=HEAP32[(($st$2$1)>>2)];
      var $23$0=$22$0;
      var $23=$23$0;
      var $24=$5;
      __Z17debug_write_dwordP13address_spacejji($20, $21, $23, $24);
      __label__ = 5; break;
    case 4: // $25
      var $26=$1;
      var $27=$2;
      var $st$2$0=(($3)|0);
      var $28$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $28$1=HEAP32[(($st$2$1)>>2)];
      var $29=$5;
      __Z17debug_write_qwordP13address_spacejyi($26, $27, $28$0, $28$1, $29);
      __label__ = 5; break;
    case 5: // $30
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18debug_write_memoryP13address_spacejyii["X"]=1;

function __ZNK13address_space8bytemaskEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN23device_memory_interface6readopEjiRy($this, $offset, $size, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$offset;
  $3=$size;
  $4=$value;
  var $5=$1;
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+72)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=FUNCTION_TABLE[$9]($5, $10, $11, $12);
  ;
  return $13;
}


function __ZNK13address_space10data_widthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK20address_space_config10data_widthEv($4);
  ;
  return $5;
}


function __ZN16direct_read_data13read_raw_wordEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=$17;
      var $19=HEAP16[(($18)>>1)];
      $1=$19;
      __label__ = 3; break;
    case 2: // $20
      var $21=(($5)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+32)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=FUNCTION_TABLE[$26]($22, $27);
      $1=$28;
      __label__ = 3; break;
    case 3: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data19read_decrypted_wordEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=$17;
      var $19=HEAP16[(($18)>>1)];
      $1=$19;
      __label__ = 3; break;
    case 2: // $20
      var $21=(($5)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+32)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=FUNCTION_TABLE[$26]($22, $27);
      $1=$28;
      __label__ = 3; break;
    case 3: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data14read_raw_dwordEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      $1=$19;
      __label__ = 3; break;
    case 2: // $20
      var $21=(($5)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+48)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=FUNCTION_TABLE[$26]($22, $27);
      $1=$28;
      __label__ = 3; break;
    case 3: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data20read_decrypted_dwordEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      $1=$19;
      __label__ = 3; break;
    case 2: // $20
      var $21=(($5)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+48)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=FUNCTION_TABLE[$26]($22, $27);
      $1=$28;
      __label__ = 3; break;
    case 3: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data14read_raw_qwordEjj($this, $byteaddress, $directxor) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=$17;
      var $st$10$0=(($18)|0);
      var $19$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$10$1)>>2)];
      var $st$14$0=(($1)|0);
      HEAP32[(($st$14$0)>>2)]=$19$0;
      var $st$14$1=(($1+4)|0);
      HEAP32[(($st$14$1)>>2)]=$19$1;
      __label__ = 3; break;
    case 2: // $20
      var $21=(($5)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+64)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=FUNCTION_TABLE[$26]($22, $27);
      var $28$0=$28[0];
      var $28$1=$28[1];
      var $st$10$0=(($1)|0);
      HEAP32[(($st$10$0)>>2)]=$28$0;
      var $st$10$1=(($1+4)|0);
      HEAP32[(($st$10$1)>>2)]=$28$1;
      __label__ = 3; break;
    case 3: // $29
      var $st$0$0=(($1)|0);
      var $30$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $30$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$30$0,$30$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_data14read_raw_qwordEjj["X"]=1;

function __ZN16direct_read_data20read_decrypted_qwordEjj($this, $byteaddress, $directxor) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=$17;
      var $st$10$0=(($18)|0);
      var $19$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$10$1)>>2)];
      var $st$14$0=(($1)|0);
      HEAP32[(($st$14$0)>>2)]=$19$0;
      var $st$14$1=(($1+4)|0);
      HEAP32[(($st$14$1)>>2)]=$19$1;
      __label__ = 3; break;
    case 2: // $20
      var $21=(($5)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+64)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=FUNCTION_TABLE[$26]($22, $27);
      var $28$0=$28[0];
      var $28$1=$28[1];
      var $st$10$0=(($1)|0);
      HEAP32[(($st$10$0)>>2)]=$28$0;
      var $st$10$1=(($1+4)|0);
      HEAP32[(($st$10$1)>>2)]=$28$1;
      __label__ = 3; break;
    case 3: // $29
      var $st$0$0=(($1)|0);
      var $30$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $30$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$30$0,$30$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_data20read_decrypted_qwordEjj["X"]=1;

function __Z17debug_read_opcodeP13address_spacejii($_space, $address, $size, $arg) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+8;
      var $4;
      var $5;
      var $space;
      var $result=__stackBase__+12;
      var $result2=__stackBase__+20;
      var $global;
      var $memory=__stackBase__+28;
      var $halfsize;
      var $r0=__stackBase__+32;
      var $r1=__stackBase__+40;
      var $addrxor;
      $2=$_space;
      HEAP32[(($3)>>2)]=$address;
      $4=$size;
      $5=$arg;
      var $6=$2;
      $space=$6;
      var $7=$4;
      var $8=((($7<<3))|0);
      var $9=((64-$8)|0);
      var $10$0=$9;
      var $10$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $11=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$10$0);var $11$0 = $11[0], $11$1 = $11[1];
      var $$emscripten$temp$1$0=-1;
      var $$emscripten$temp$1$1=-1;
      var $12$0=$$emscripten$temp$1$0 & $11$0;
      var $12$1=$$emscripten$temp$1$1 & $11$1;
      var $st$32$0=(($result)|0);
      HEAP32[(($st$32$0)>>2)]=$12$0;
      var $st$32$1=(($result+4)|0);
      HEAP32[(($st$32$1)>>2)]=$12$1;
      var $13=$space;
      var $14=__ZNK13address_space7machineEv($13);
      var $15=(($14+652)|0);
      var $16=HEAP32[(($15)>>2)];
      $global=$16;
      var $17=$space;
      var $18=__ZNK13address_space11logbytemaskEv($17);
      var $19=HEAP32[(($3)>>2)];
      var $20=$19 & $18;
      HEAP32[(($3)>>2)]=$20;
      var $21=$space;
      var $22=$global;
      var $23=(($22+23)|0);
      HEAP8[($23)]=1;
      __ZN13address_space19set_debugger_accessEb($21, 1);
      var $24=$space;
      var $25=__ZNK13address_space6deviceEv($24);
      var $26=__ZN8device_t9interfaceERP23device_memory_interface($25, $memory);
      if ($26) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $27
      var $28=HEAP32[(($memory)>>2)];
      var $29=HEAP32[(($3)>>2)];
      var $30=$4;
      var $31=__ZN23device_memory_interface6readopEjiRy($28, $29, $30, $result2);
      if ($31) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $32
      var $33=$space;
      var $34=$global;
      var $35=(($34+23)|0);
      HEAP8[($35)]=0;
      __ZN13address_space19set_debugger_accessEb($33, 0);
      var $st$5$0=(($result2)|0);
      var $36$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($result2+4)|0);
      var $36$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$36$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$36$1;
      __label__ = 61; break;
    case 3: // $37
      var $38=$4;
      var $39=$space;
      var $40=__ZNK13address_space10data_widthEv($39);
      var $41=(((($40)|0)/8)|0);
      var $42=(($38)|0) > (($41)|0);
      if ($42) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $43
      var $44=$4;
      var $45=(((($44)|0)/2)|0);
      $halfsize=$45;
      var $46=$space;
      var $47=HEAP32[(($3)>>2)];
      var $48=(($47)|0);
      var $49=$halfsize;
      var $50=$5;
      var $51=__Z17debug_read_opcodeP13address_spacejii($46, $48, $49, $50);
      var $51$0=$51[0];
      var $51$1=$51[1];
      var $st$11$0=(($r0)|0);
      HEAP32[(($st$11$0)>>2)]=$51$0;
      var $st$11$1=(($r0+4)|0);
      HEAP32[(($st$11$1)>>2)]=$51$1;
      var $52=$space;
      var $53=HEAP32[(($3)>>2)];
      var $54=$halfsize;
      var $55=(($53+$54)|0);
      var $56=$halfsize;
      var $57=$5;
      var $58=__Z17debug_read_opcodeP13address_spacejii($52, $55, $56, $57);
      var $58$0=$58[0];
      var $58$1=$58[1];
      var $st$24$0=(($r1)|0);
      HEAP32[(($st$24$0)>>2)]=$58$0;
      var $st$24$1=(($r1+4)|0);
      HEAP32[(($st$24$1)>>2)]=$58$1;
      var $59=$space;
      var $60=__ZNK13address_space10endiannessEv($59);
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $62
      var $st$0$0=(($r0)|0);
      var $63$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($r0+4)|0);
      var $63$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($r1)|0);
      var $64$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($r1+4)|0);
      var $64$1=HEAP32[(($st$4$1)>>2)];
      var $65=$halfsize;
      var $66=((($65<<3))|0);
      var $67$0=$66;
      var $67$1=0;
      var $68=Runtime.bitshift64($64$0, $64$1,"shl",$67$0);var $68$0 = $68[0], $68$1 = $68[1];
      var $69$0=$63$0 | $68$0;
      var $69$1=$63$1 | $68$1;
      var $st$15$0=(($1)|0);
      HEAP32[(($st$15$0)>>2)]=$69$0;
      var $st$15$1=(($1+4)|0);
      HEAP32[(($st$15$1)>>2)]=$69$1;
      __label__ = 61; break;
    case 6: // $70
      var $st$0$0=(($r1)|0);
      var $71$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($r1+4)|0);
      var $71$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($r0)|0);
      var $72$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($r0+4)|0);
      var $72$1=HEAP32[(($st$4$1)>>2)];
      var $73=$halfsize;
      var $74=((($73<<3))|0);
      var $75$0=$74;
      var $75$1=0;
      var $76=Runtime.bitshift64($72$0, $72$1,"shl",$75$0);var $76$0 = $76[0], $76$1 = $76[1];
      var $77$0=$71$0 | $76$0;
      var $77$1=$71$1 | $76$1;
      var $st$15$0=(($1)|0);
      HEAP32[(($st$15$0)>>2)]=$77$0;
      var $st$15$1=(($1+4)|0);
      HEAP32[(($st$15$1)>>2)]=$77$1;
      __label__ = 61; break;
    case 7: // $78
      var $79=$space;
      var $80=__Z19debug_cpu_translateP13address_spaceiPj($79, 10, $3);
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $82
      var $st$0$0=(($result)|0);
      var $83$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$83$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$83$1;
      __label__ = 61; break;
    case 9: // $84
      var $85=$space;
      var $86=__ZNK13address_space8bytemaskEv($85);
      var $87=HEAP32[(($3)>>2)];
      var $88=$87 & $86;
      HEAP32[(($3)>>2)]=$88;
      $addrxor=0;
      var $89=$space;
      var $90=__ZNK13address_space10data_widthEv($89);
      var $91=(((($90)|0)/8)|0);
      var $92=(($91*10)|0);
      var $93=$4;
      var $94=(($92+$93)|0);
      if ($94 == 11 || $94 == 22 || $94 == 44 || $94 == 88) {
        __label__ = 17; break;
      }
      else if ($94 == 21) {
        __label__ = 10; break;
      }
      else if ($94 == 41) {
        __label__ = 11; break;
      }
      else if ($94 == 42) {
        __label__ = 12; break;
      }
      else if ($94 == 81) {
        __label__ = 13; break;
      }
      else if ($94 == 82) {
        __label__ = 14; break;
      }
      else if ($94 == 84) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 10: // $95
      var $96=$space;
      var $97=__ZNK13address_space10endiannessEv($96);
      var $98=(($97)|0)==0;
      var $99=$98 ? 0 : 1;
      $addrxor=$99;
      __label__ = 17; break;
    case 11: // $100
      var $101=$space;
      var $102=__ZNK13address_space10endiannessEv($101);
      var $103=(($102)|0)==0;
      var $104=$103 ? 0 : 3;
      $addrxor=$104;
      __label__ = 17; break;
    case 12: // $105
      var $106=$space;
      var $107=__ZNK13address_space10endiannessEv($106);
      var $108=(($107)|0)==0;
      var $109=$108 ? 0 : 2;
      $addrxor=$109;
      __label__ = 17; break;
    case 13: // $110
      var $111=$space;
      var $112=__ZNK13address_space10endiannessEv($111);
      var $113=(($112)|0)==0;
      var $114=$113 ? 0 : 7;
      $addrxor=$114;
      __label__ = 17; break;
    case 14: // $115
      var $116=$space;
      var $117=__ZNK13address_space10endiannessEv($116);
      var $118=(($117)|0)==0;
      var $119=$118 ? 0 : 6;
      $addrxor=$119;
      __label__ = 17; break;
    case 15: // $120
      var $121=$space;
      var $122=__ZNK13address_space10endiannessEv($121);
      var $123=(($122)|0)==0;
      var $124=$123 ? 0 : 4;
      $addrxor=$124;
      __label__ = 17; break;
    case 16: // $125
      var $126=$space;
      var $127=__ZNK13address_space10data_widthEv($126);
      var $128=(((($127)|0)/8)|0);
      var $129=(($128*10)|0);
      var $130=$4;
      var $131=(($129+$130)|0);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str212509)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$131,tempInt));
      throw "Reached an unreachable!"
    case 17: // $132
      var $133=$global;
      var $134=(($133+23)|0);
      var $135=HEAP8[($134)];
      var $136=(($135) & 1);
      if ($136) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $137
      var $138=$space;
      var $139=$global;
      var $140=(($139+23)|0);
      HEAP8[($140)]=1;
      __ZN13address_space19set_debugger_accessEb($138, 1);
      __label__ = 19; break;
    case 19: // $141
      var $142=$4;
      if ($142 == 1) {
        __label__ = 20; break;
      }
      else if ($142 == 2) {
        __label__ = 24; break;
      }
      else if ($142 == 4) {
        __label__ = 36; break;
      }
      else if ($142 == 8) {
        __label__ = 48; break;
      }
      else {
      __label__ = 60; break;
      }
      
    case 20: // $143
      var $144=$5;
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $146
      var $147=$space;
      var $148=__ZNK13address_space6directEv($147);
      var $149=HEAP32[(($3)>>2)];
      var $150=$addrxor;
      var $151=__ZN16direct_read_data13read_raw_byteEjj($148, $149, $150);
      var $159 = $151;__label__ = 23; break;
    case 22: // $152
      var $153=$space;
      var $154=__ZNK13address_space6directEv($153);
      var $155=HEAP32[(($3)>>2)];
      var $156=$addrxor;
      var $157=__ZN16direct_read_data19read_decrypted_byteEjj($154, $155, $156);
      var $159 = $157;__label__ = 23; break;
    case 23: // $158
      var $159;
      var $160$0=$159;
      var $160$1=0;
      var $st$3$0=(($result)|0);
      HEAP32[(($st$3$0)>>2)]=$160$0;
      var $st$3$1=(($result+4)|0);
      HEAP32[(($st$3$1)>>2)]=$160$1;
      __label__ = 60; break;
    case 24: // $161
      var $162=$5;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $164
      var $165=$space;
      var $166=__ZNK13address_space6directEv($165);
      var $167=HEAP32[(($3)>>2)];
      var $168=$167 & -2;
      var $169=$addrxor;
      var $170=__ZN16direct_read_data13read_raw_wordEjj($166, $168, $169);
      var $179 = $170;__label__ = 27; break;
    case 26: // $171
      var $172=$space;
      var $173=__ZNK13address_space6directEv($172);
      var $174=HEAP32[(($3)>>2)];
      var $175=$174 & -2;
      var $176=$addrxor;
      var $177=__ZN16direct_read_data19read_decrypted_wordEjj($173, $175, $176);
      var $179 = $177;__label__ = 27; break;
    case 27: // $178
      var $179;
      var $180$0=$179;
      var $180$1=0;
      var $st$3$0=(($result)|0);
      HEAP32[(($st$3$0)>>2)]=$180$0;
      var $st$3$1=(($result+4)|0);
      HEAP32[(($st$3$1)>>2)]=$180$1;
      var $181=HEAP32[(($3)>>2)];
      var $182=$181 & 1;
      var $183=(($182)|0)!=0;
      if ($183) { __label__ = 28; break; } else { __label__ = 35; break; }
    case 28: // $184
      var $185=$5;
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $187
      var $188=$space;
      var $189=__ZNK13address_space6directEv($188);
      var $190=HEAP32[(($3)>>2)];
      var $191=$190 & -2;
      var $192=(($191+2)|0);
      var $193=$addrxor;
      var $194=__ZN16direct_read_data13read_raw_wordEjj($189, $192, $193);
      var $204 = $194;__label__ = 31; break;
    case 30: // $195
      var $196=$space;
      var $197=__ZNK13address_space6directEv($196);
      var $198=HEAP32[(($3)>>2)];
      var $199=$198 & -2;
      var $200=(($199+2)|0);
      var $201=$addrxor;
      var $202=__ZN16direct_read_data19read_decrypted_wordEjj($197, $200, $201);
      var $204 = $202;__label__ = 31; break;
    case 31: // $203
      var $204;
      var $205$0=$204;
      var $205$1=0;
      var $st$3$0=(($result2)|0);
      HEAP32[(($st$3$0)>>2)]=$205$0;
      var $st$3$1=(($result2+4)|0);
      HEAP32[(($st$3$1)>>2)]=$205$1;
      var $206=$space;
      var $207=__ZNK13address_space10endiannessEv($206);
      var $208=(($207)|0)==0;
      if ($208) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $209
      var $st$0$0=(($result)|0);
      var $210$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $210$1=HEAP32[(($st$0$1)>>2)];
      var $211=HEAP32[(($3)>>2)];
      var $212=$211 & 1;
      var $213=((($212<<3))|0);
      var $214$0=$213;
      var $214$1=0;
      var $215=Runtime.bitshift64($210$0, $210$1,"lshr",$214$0);var $215$0 = $215[0], $215$1 = $215[1];
      var $st$10$0=(($result2)|0);
      var $216$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result2+4)|0);
      var $216$1=HEAP32[(($st$10$1)>>2)];
      var $217=HEAP32[(($3)>>2)];
      var $218=$217 & 1;
      var $219=((($218<<3))|0);
      var $220=((16-$219)|0);
      var $221$0=$220;
      var $221$1=0;
      var $222=Runtime.bitshift64($216$0, $216$1,"shl",$221$0);var $222$0 = $222[0], $222$1 = $222[1];
      var $223$0=$215$0 | $222$0;
      var $223$1=$215$1 | $222$1;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$223$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$223$1;
      __label__ = 34; break;
    case 33: // $224
      var $st$0$0=(($result)|0);
      var $225$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $225$1=HEAP32[(($st$0$1)>>2)];
      var $226=HEAP32[(($3)>>2)];
      var $227=$226 & 1;
      var $228=((($227<<3))|0);
      var $229$0=$228;
      var $229$1=0;
      var $230=Runtime.bitshift64($225$0, $225$1,"shl",$229$0);var $230$0 = $230[0], $230$1 = $230[1];
      var $st$10$0=(($result2)|0);
      var $231$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result2+4)|0);
      var $231$1=HEAP32[(($st$10$1)>>2)];
      var $232=HEAP32[(($3)>>2)];
      var $233=$232 & 1;
      var $234=((($233<<3))|0);
      var $235=((16-$234)|0);
      var $236$0=$235;
      var $236$1=0;
      var $237=Runtime.bitshift64($231$0, $231$1,"lshr",$236$0);var $237$0 = $237[0], $237$1 = $237[1];
      var $238$0=$230$0 | $237$0;
      var $238$1=$230$1 | $237$1;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$238$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$238$1;
      __label__ = 34; break;
    case 34: // $239
      var $st$0$0=(($result)|0);
      var $240$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $240$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=65535;
      var $$emscripten$temp$2$1=0;
      var $241$0=$240$0 & $$emscripten$temp$2$0;
      var $241$1=$240$1 & $$emscripten$temp$2$1;
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$241$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$241$1;
      __label__ = 35; break;
    case 35: // $242
      __label__ = 60; break;
    case 36: // $243
      var $244=$5;
      var $245=(($244)|0)!=0;
      if ($245) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $246
      var $247=$space;
      var $248=__ZNK13address_space6directEv($247);
      var $249=HEAP32[(($3)>>2)];
      var $250=$249 & -4;
      var $251=$addrxor;
      var $252=__ZN16direct_read_data14read_raw_dwordEjj($248, $250, $251);
      var $261 = $252;__label__ = 39; break;
    case 38: // $253
      var $254=$space;
      var $255=__ZNK13address_space6directEv($254);
      var $256=HEAP32[(($3)>>2)];
      var $257=$256 & -4;
      var $258=$addrxor;
      var $259=__ZN16direct_read_data20read_decrypted_dwordEjj($255, $257, $258);
      var $261 = $259;__label__ = 39; break;
    case 39: // $260
      var $261;
      var $262$0=$261;
      var $262$1=0;
      var $st$3$0=(($result)|0);
      HEAP32[(($st$3$0)>>2)]=$262$0;
      var $st$3$1=(($result+4)|0);
      HEAP32[(($st$3$1)>>2)]=$262$1;
      var $263=HEAP32[(($3)>>2)];
      var $264=$263 & 3;
      var $265=(($264)|0)!=0;
      if ($265) { __label__ = 40; break; } else { __label__ = 47; break; }
    case 40: // $266
      var $267=$5;
      var $268=(($267)|0)!=0;
      if ($268) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $269
      var $270=$space;
      var $271=__ZNK13address_space6directEv($270);
      var $272=HEAP32[(($3)>>2)];
      var $273=$272 & -4;
      var $274=(($273+4)|0);
      var $275=$addrxor;
      var $276=__ZN16direct_read_data14read_raw_dwordEjj($271, $274, $275);
      var $286 = $276;__label__ = 43; break;
    case 42: // $277
      var $278=$space;
      var $279=__ZNK13address_space6directEv($278);
      var $280=HEAP32[(($3)>>2)];
      var $281=$280 & -4;
      var $282=(($281+4)|0);
      var $283=$addrxor;
      var $284=__ZN16direct_read_data20read_decrypted_dwordEjj($279, $282, $283);
      var $286 = $284;__label__ = 43; break;
    case 43: // $285
      var $286;
      var $287$0=$286;
      var $287$1=0;
      var $st$3$0=(($result2)|0);
      HEAP32[(($st$3$0)>>2)]=$287$0;
      var $st$3$1=(($result2+4)|0);
      HEAP32[(($st$3$1)>>2)]=$287$1;
      var $288=$space;
      var $289=__ZNK13address_space10endiannessEv($288);
      var $290=(($289)|0)==0;
      if ($290) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $291
      var $st$0$0=(($result)|0);
      var $292$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $292$1=HEAP32[(($st$0$1)>>2)];
      var $293=HEAP32[(($3)>>2)];
      var $294=$293 & 3;
      var $295=((($294<<3))|0);
      var $296$0=$295;
      var $296$1=0;
      var $297=Runtime.bitshift64($292$0, $292$1,"lshr",$296$0);var $297$0 = $297[0], $297$1 = $297[1];
      var $st$10$0=(($result2)|0);
      var $298$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result2+4)|0);
      var $298$1=HEAP32[(($st$10$1)>>2)];
      var $299=HEAP32[(($3)>>2)];
      var $300=$299 & 3;
      var $301=((($300<<3))|0);
      var $302=((32-$301)|0);
      var $303$0=$302;
      var $303$1=0;
      var $304=Runtime.bitshift64($298$0, $298$1,"shl",$303$0);var $304$0 = $304[0], $304$1 = $304[1];
      var $305$0=$297$0 | $304$0;
      var $305$1=$297$1 | $304$1;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$305$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$305$1;
      __label__ = 46; break;
    case 45: // $306
      var $st$0$0=(($result)|0);
      var $307$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $307$1=HEAP32[(($st$0$1)>>2)];
      var $308=HEAP32[(($3)>>2)];
      var $309=$308 & 3;
      var $310=((($309<<3))|0);
      var $311$0=$310;
      var $311$1=0;
      var $312=Runtime.bitshift64($307$0, $307$1,"shl",$311$0);var $312$0 = $312[0], $312$1 = $312[1];
      var $st$10$0=(($result2)|0);
      var $313$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result2+4)|0);
      var $313$1=HEAP32[(($st$10$1)>>2)];
      var $314=HEAP32[(($3)>>2)];
      var $315=$314 & 3;
      var $316=((($315<<3))|0);
      var $317=((32-$316)|0);
      var $318$0=$317;
      var $318$1=0;
      var $319=Runtime.bitshift64($313$0, $313$1,"lshr",$318$0);var $319$0 = $319[0], $319$1 = $319[1];
      var $320$0=$312$0 | $319$0;
      var $320$1=$312$1 | $319$1;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$320$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$320$1;
      __label__ = 46; break;
    case 46: // $321
      var $st$0$0=(($result)|0);
      var $322$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $322$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=-1;
      var $$emscripten$temp$3$1=0;
      var $323$0=$322$0 & $$emscripten$temp$3$0;
      var $323$1=$322$1 & $$emscripten$temp$3$1;
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$323$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$323$1;
      __label__ = 47; break;
    case 47: // $324
      __label__ = 60; break;
    case 48: // $325
      var $326=$5;
      var $327=(($326)|0)!=0;
      if ($327) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $328
      var $329=$space;
      var $330=__ZNK13address_space6directEv($329);
      var $331=HEAP32[(($3)>>2)];
      var $332=$331 & -8;
      var $333=$addrxor;
      var $334=__ZN16direct_read_data14read_raw_qwordEjj($330, $332, $333);
      var $334$0=$334[0];
      var $334$1=$334[1];
      var $343$1 = $334$1;var $343$0 = $334$0;__label__ = 51; break;
    case 50: // $335
      var $336=$space;
      var $337=__ZNK13address_space6directEv($336);
      var $338=HEAP32[(($3)>>2)];
      var $339=$338 & -8;
      var $340=$addrxor;
      var $341=__ZN16direct_read_data20read_decrypted_qwordEjj($337, $339, $340);
      var $341$0=$341[0];
      var $341$1=$341[1];
      var $343$1 = $341$1;var $343$0 = $341$0;__label__ = 51; break;
    case 51: // $342
      var $343$0;
      var $343$1;
      var $st$2$0=(($result)|0);
      HEAP32[(($st$2$0)>>2)]=$343$0;
      var $st$2$1=(($result+4)|0);
      HEAP32[(($st$2$1)>>2)]=$343$1;
      var $344=HEAP32[(($3)>>2)];
      var $345=$344 & 7;
      var $346=(($345)|0)!=0;
      if ($346) { __label__ = 52; break; } else { __label__ = 59; break; }
    case 52: // $347
      var $348=$5;
      var $349=(($348)|0)!=0;
      if ($349) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $350
      var $351=$space;
      var $352=__ZNK13address_space6directEv($351);
      var $353=HEAP32[(($3)>>2)];
      var $354=$353 & -8;
      var $355=(($354+8)|0);
      var $356=$addrxor;
      var $357=__ZN16direct_read_data14read_raw_qwordEjj($352, $355, $356);
      var $357$0=$357[0];
      var $357$1=$357[1];
      var $367$1 = $357$1;var $367$0 = $357$0;__label__ = 55; break;
    case 54: // $358
      var $359=$space;
      var $360=__ZNK13address_space6directEv($359);
      var $361=HEAP32[(($3)>>2)];
      var $362=$361 & -8;
      var $363=(($362+8)|0);
      var $364=$addrxor;
      var $365=__ZN16direct_read_data20read_decrypted_qwordEjj($360, $363, $364);
      var $365$0=$365[0];
      var $365$1=$365[1];
      var $367$1 = $365$1;var $367$0 = $365$0;__label__ = 55; break;
    case 55: // $366
      var $367$0;
      var $367$1;
      var $st$2$0=(($result2)|0);
      HEAP32[(($st$2$0)>>2)]=$367$0;
      var $st$2$1=(($result2+4)|0);
      HEAP32[(($st$2$1)>>2)]=$367$1;
      var $368=$space;
      var $369=__ZNK13address_space10endiannessEv($368);
      var $370=(($369)|0)==0;
      if ($370) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $371
      var $st$0$0=(($result)|0);
      var $372$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $372$1=HEAP32[(($st$0$1)>>2)];
      var $373=HEAP32[(($3)>>2)];
      var $374=$373 & 7;
      var $375=((($374<<3))|0);
      var $376$0=$375;
      var $376$1=0;
      var $377=Runtime.bitshift64($372$0, $372$1,"lshr",$376$0);var $377$0 = $377[0], $377$1 = $377[1];
      var $st$10$0=(($result2)|0);
      var $378$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result2+4)|0);
      var $378$1=HEAP32[(($st$10$1)>>2)];
      var $379=HEAP32[(($3)>>2)];
      var $380=$379 & 7;
      var $381=((($380<<3))|0);
      var $382=((64-$381)|0);
      var $383$0=$382;
      var $383$1=0;
      var $384=Runtime.bitshift64($378$0, $378$1,"shl",$383$0);var $384$0 = $384[0], $384$1 = $384[1];
      var $385$0=$377$0 | $384$0;
      var $385$1=$377$1 | $384$1;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$385$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$385$1;
      __label__ = 58; break;
    case 57: // $386
      var $st$0$0=(($result)|0);
      var $387$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $387$1=HEAP32[(($st$0$1)>>2)];
      var $388=HEAP32[(($3)>>2)];
      var $389=$388 & 7;
      var $390=((($389<<3))|0);
      var $391$0=$390;
      var $391$1=0;
      var $392=Runtime.bitshift64($387$0, $387$1,"shl",$391$0);var $392$0 = $392[0], $392$1 = $392[1];
      var $st$10$0=(($result2)|0);
      var $393$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result2+4)|0);
      var $393$1=HEAP32[(($st$10$1)>>2)];
      var $394=HEAP32[(($3)>>2)];
      var $395=$394 & 7;
      var $396=((($395<<3))|0);
      var $397=((64-$396)|0);
      var $398$0=$397;
      var $398$1=0;
      var $399=Runtime.bitshift64($393$0, $393$1,"lshr",$398$0);var $399$0 = $399[0], $399$1 = $399[1];
      var $400$0=$392$0 | $399$0;
      var $400$1=$392$1 | $399$1;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$400$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$400$1;
      __label__ = 58; break;
    case 58: // $401
      __label__ = 59; break;
    case 59: // $402
      __label__ = 60; break;
    case 60: // $403
      var $404=$space;
      var $405=$global;
      var $406=(($405+23)|0);
      HEAP8[($406)]=0;
      __ZN13address_space19set_debugger_accessEb($404, 0);
      var $st$5$0=(($result)|0);
      var $407$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($result+4)|0);
      var $407$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$407$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$407$1;
      __label__ = 61; break;
    case 61: // $408
      var $st$0$0=(($1)|0);
      var $409$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $409$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$409$0,$409$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17debug_read_opcodeP13address_spacejii["X"]=1;

function __ZNK18device_state_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15running_machine10debug_viewEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+1296)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12device_debug12dasm_commentEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN12device_debug12dasm_commentEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8device_t9interfaceI23device_disasm_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI23device_disasm_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug10get_cyclesER12symbol_tablePv($table, $ref) {
  ;
  var __label__;

  var $1;
  var $2;
  var $device;
  $1=$table;
  $2=$ref;
  var $3=$1;
  var $4=__ZNK12symbol_table9globalrefEv($3);
  var $5=$4;
  $device=$5;
  var $6=$device;
  var $7=__ZNK8device_t5debugEv($6);
  var $8=(($7+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZNK24device_execute_interface16cycles_remainingEv($9);
  var $11$0=$10;
  var $11$1=(($10|0) < 0 ? -1 : 0);
  ;
  return [$11$0,$11$1];
}


function __ZN12device_debug12get_logunmapER12symbol_tablePv($table, $ref) {
  ;
  var __label__;

  var $1;
  var $2;
  var $space;
  $1=$table;
  $2=$ref;
  var $3=$1;
  var $4=__ZNK12symbol_table9globalrefEv($3);
  var $5=$4;
  $space=$5;
  var $6=$space;
  var $7=__ZNK13address_space9log_unmapEv($6);
  var $8$0=$7;
  var $8$1=0;
  ;
  return [$8$0,$8$1];
}


function __ZN12device_debug12set_logunmapER12symbol_tablePvy($table, $ref, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $space;
  $1=$table;
  $2=$ref;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$value$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$value$1;
  var $4=$1;
  var $5=__ZNK12symbol_table9globalrefEv($4);
  var $6=$5;
  $space=$6;
  var $7=$space;
  var $st$15$0=(($3)|0);
  var $8$0=HEAP32[(($st$15$0)>>2)];
  var $st$15$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$15$1)>>2)];
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $9=$8$0 != $$emscripten$temp$0$0 || $8$1 != $$emscripten$temp$0$1;
  var $10=$9 ? 1 : 0;
  __ZN13address_space13set_log_unmapEb($7, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK22device_state_interface11state_firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=__ZNK11simple_listI18device_state_entryE5firstEv($3);
  ;
  return $4;
}


function __ZNK18device_state_entry6symbolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN7astring7tolowerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__Z15astring_tolowerP7astring($2);
  ;
  return $3;
}


function __ZN12device_debug9get_stateER12symbol_tablePv($table, $ref) {
  ;
  var __label__;

  var $1;
  var $2;
  var $device;
  $1=$table;
  $2=$ref;
  var $3=$1;
  var $4=__ZNK12symbol_table9globalrefEv($3);
  var $5=$4;
  $device=$5;
  var $6=$device;
  var $7=__ZNK8device_t5debugEv($6);
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$10;
  var $12=__ZN22device_state_interface5stateEi($9, $11);
  var $12$0=$12[0];
  var $12$1=$12[1];
  ;
  return [$12$0,$12$1];
}


function __ZN12device_debug9set_stateER12symbol_tablePvy($table, $ref, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $device;
  $1=$table;
  $2=$ref;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$value$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$value$1;
  var $4=$1;
  var $5=__ZNK12symbol_table9globalrefEv($4);
  var $6=$5;
  $device=$6;
  var $7=$device;
  var $8=__ZNK8device_t5debugEv($7);
  var $9=(($8+12)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$11;
  var $st$20$0=(($3)|0);
  var $13$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($3+4)|0);
  var $13$1=HEAP32[(($st$20$1)>>2)];
  __ZN22device_state_interface9set_stateEiy($10, $12, $13$0, $13$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK12device_debug16min_opcode_bytesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+16)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK23device_disasm_interface16max_opcode_bytesEv($8);
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 1;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12symbol_table4findEPKc($this, $name) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$name;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=$2;
  var $6=__ZNK11tagged_listI12symbol_entryE4findEPKc($4, $5);
  ;
  return $6;
}


function __ZN12device_debug14get_current_pcER12symbol_tablePv($table, $ref) {
  ;
  var __label__;

  var $1;
  var $2;
  var $device;
  $1=$table;
  $2=$ref;
  var $3=$1;
  var $4=__ZNK12symbol_table9globalrefEv($3);
  var $5=$4;
  $device=$5;
  var $6=$device;
  var $7=__ZNK8device_t5debugEv($6);
  var $8=__ZNK12device_debug2pcEv($7);
  var $9$0=$8;
  var $9$1=0;
  ;
  return [$9$0,$9$1];
}


function __ZN11simple_listIN12device_debug12dasm_commentEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN12device_debug12dasm_commentEED2Ev($2);
  ;
  return;
}


function __ZN12symbol_tableD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12symbol_tableD2Ev($2);
  ;
  return;
}


function __ZN12device_debug20breakpoint_clear_allEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+1540)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+1540)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK12device_debug10breakpoint5indexEv($9);
      var $11=__ZN12device_debug16breakpoint_clearEi($2, $10);
      __label__ = 1; break;
    case 3: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug20watchpoint_clear_allEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $spacenum=__stackBase__;
      $1=$this;
      var $2=$1;
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=HEAPU32[(($spacenum)>>2)];
      var $5=(($4)>>>0) < 4;
      if ($5) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $6
      __label__ = 3; break;
    case 3: // $7
      var $8=HEAP32[(($spacenum)>>2)];
      var $9=(($2+1544)|0);
      var $10=(($9+($8<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $13
      var $14=HEAP32[(($spacenum)>>2)];
      var $15=(($2+1544)|0);
      var $16=(($15+($14<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZNK12device_debug10watchpoint5indexEv($17);
      var $19=__ZN12device_debug16watchpoint_clearEi($2, $18);
      __label__ = 3; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      __ZppR16address_spacenumi($spacenum, 0);
      __label__ = 1; break;
    case 7: // $22
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug10start_hookE8attotime($this, $endtime) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $endtime; $endtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($endtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($endtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($endtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+652)|0);
      var $7=HEAP32[(($6)>>2)];
      $global=$7;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      __label__ = 4; break;
    case 4: // $11
      var $12=(($2)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$global;
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$global;
      var $17=(($16+28)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $20
      var $21=$global;
      var $22=(($21+28)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($2)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($23)|0)!=(($25)|0);
      if ($26) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $27
      var $28=$global;
      var $29=(($28+28)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=$global;
      var $31=(($30+24)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($2)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__ZNK8device_t7machineEv($33);
      __ZL21reset_transient_flagsR15running_machine($34);
      __label__ = 7; break;
    case 7: // $35
      var $36=(($2+500)|0);
      var $37=$36;
      var $38=$endtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($37)>>2)]=HEAP32[(($38)>>2)];HEAP32[(($37+4)>>2)]=HEAP32[(($38+4)>>2)];HEAP32[(($37+8)>>2)]=HEAP32[(($38+8)>>2)];
      var $39=$global;
      var $40=(($39+24)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $43
      var $44=(($2)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$global;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($45)|0)==(($48)|0);
      if ($49) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $50
      var $51=_osd_ticks();
      var $51$0=$51[0];
      var $51$1=$51[1];
      var $52=$global;
      var $53=(($52+136)|0);
      var $st$5$0=(($53)|0);
      var $54$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($53+4)|0);
      var $54$1=HEAP32[(($st$5$1)>>2)];
      var $55=_osd_ticks_per_second();
      var $55$0=$55[0];
      var $55$1=$55[1];
      var $$emscripten$temp$0$0=4;
      var $$emscripten$temp$0$1=0;
      var $56$0 = (tempBigIntR=((($55$0)>>>0)+((($55$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $56$1 = Math.min(Math.floor(((tempBigIntR=((($55$0)>>>0)+((($55$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $57$0 = ((($54$0)>>>0)+((($54$1)|0)*4294967296))+((($56$0)>>>0)+((($56$1)|0)*4294967296))>>>0; var $57$1 = Math.min(Math.floor((((($54$0)>>>0)+((($54$1)|0)*4294967296))+((($56$0)>>>0)+((($56$1)|0)*4294967296)))/4294967296), 4294967295);
      var $58=($51$1|0) > ($57$1|0) || (($51$1|0) == ($57$1|0) && ($51$0|0) >  ($57$0|0));
      if ($58) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $59
      var $60=(($2)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__ZNK8device_t7machineEv($61);
      var $63=__ZNK15running_machine10debug_viewEv($62);
      __ZN18debug_view_manager10update_allE15debug_view_type($63, 0);
      var $64=(($2)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=__ZNK8device_t7machineEv($65);
      var $67=__ZNK15running_machine10debug_viewEv($66);
      __ZN18debug_view_manager17flush_osd_updatesEv($67);
      var $68=_osd_ticks();
      var $68$0=$68[0];
      var $68$1=$68[1];
      var $69=$global;
      var $70=(($69+136)|0);
      var $st$15$0=(($70)|0);
      HEAP32[(($st$15$0)>>2)]=$68$0;
      var $st$15$1=(($70+4)|0);
      HEAP32[(($st$15$1)>>2)]=$68$1;
      __label__ = 14; break;
    case 11: // $71
      var $72=(($2)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$global;
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($73)|0)==(($76)|0);
      if ($77) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $78
      var $79=$global;
      var $80=(($79+24)|0);
      HEAP32[(($80)>>2)]=0;
      var $81=$global;
      var $82=(($81+8)|0);
      HEAP32[(($82)>>2)]=0;
      __label__ = 13; break;
    case 13: // $83
      __label__ = 14; break;
    case 14: // $84
      var $85=$global;
      var $86=(($85+21)|0);
      var $87=HEAP8[($86)];
      var $88=(($87) & 1);
      if ($88) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $89
      var $90=$global;
      var $91=(($90+21)|0);
      HEAP8[($91)]=0;
      var $92=(($2+20)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$93 & 4096;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $96
      var $97=$global;
      var $98=(($97+24)|0);
      HEAP32[(($98)>>2)]=0;
      var $99=(($2)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=__ZNK8device_t7machineEv($100);
      __Z20debug_console_printfR15running_machinePKcz($101, ((STRING_TABLE.__str272515)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 20; break;
    case 17: // $102
      var $103=(($2)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=__ZNK8device_t7machineEv($104);
      var $106=__Z16ui_input_pressedR15running_machinei($105, 161);
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $108
      var $109=$global;
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=__ZNK8device_t5debugEv($111);
      __ZN12device_debug24halt_on_next_instructionEPKcz($112, ((STRING_TABLE.__str282516)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 19; break;
    case 19: // $113
      __label__ = 20; break;
    case 20: // $114
      __label__ = 21; break;
    case 21: // $115
      __label__ = 22; break;
    case 22: // $116
      __ZN12device_debug19compute_debug_flagsEv($2);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug10start_hookE8attotime["X"]=1;

function __ZL21reset_transient_flagsR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine10devicelistEv($2);
      var $4=$3;
      var $5=__ZNK11tagged_listI8device_tE5firstEv($4);
      $device=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$device;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$device;
      var $11=__ZNK8device_t5debugEv($10);
      __ZN12device_debug20reset_transient_flagEv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$device;
      var $14=__ZNK8device_t4nextEv($13);
      $device=$14;
      __label__ = 1; break;
    case 4: // $15
      var $16=$1;
      var $17=(($16+652)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+28)|0);
      HEAP32[(($19)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debugC2ER8device_t($this, $device) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $tempstr=__stackBase__;
      var $entry;
      $1=$this;
      $2=$device;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      HEAP32[(($6)>>2)]=$7;
      var $8=(($5+4)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=(($5+8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($5+12)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($5+16)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($5+20)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=(($5+24)|0);
      var $14=$2;
      var $15=$14;
      var $16=$2;
      var $17=__ZNK8device_t7machineEv($16);
      var $18=__Z29debug_cpu_get_global_symtableR15running_machine($17);
      FUNCTION_TABLE[__ZN12symbol_tableC1EPvPS_]($13, $15, $18);
      var $19=(($5+456)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($5+460)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($5+464)|0);
      HEAP8[($21)]=0;
      var $22=(($5+468)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($5+472)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=(($5+476)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($5+480)|0);
      var $26=$25;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $27=(($5+492)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=(($5+496)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($5+500)|0);
      var $30=$29;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($30)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($30+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($30+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $31=(($5+1536)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($5+1540)|0);
      HEAP32[(($32)>>2)]=0;
      var $33=(($5+1560)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=(($5+1564)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=(($5+1568)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=(($5+1572)|0);
      HEAP32[(($36)>>2)]=0;
      var $37=(($5+1576)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12device_debug12dasm_commentEEC1ER13resource_pool($37, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $38
      var $39=(($5+512)|0);
      var $40=(($39)|0);
      var $41=$40;
      _memset($41, 0, 1024, 1);
      var $42=(($5+1544)|0);
      var $43=(($42)|0);
      var $44=$43;
      for (var $$dest = $44, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $45=$2;
      var $46=(($5+4)|0);
      var $47=(function() { try { __THREW__ = false; return __ZN8device_t9interfaceERP24device_execute_interface($45, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 10; break; };
    case 2: // $48
      var $49=$2;
      var $50=(($5+8)|0);
      var $51=(function() { try { __THREW__ = false; return __ZN8device_t9interfaceERP23device_memory_interface($49, $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 10; break; };
    case 3: // $52
      var $53=$2;
      var $54=(($5+12)|0);
      var $55=(function() { try { __THREW__ = false; return __ZN8device_t9interfaceERP22device_state_interface($53, $54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $56
      var $57=$2;
      var $58=(($5+16)|0);
      var $59=(function() { try { __THREW__ = false; return __ZN8device_t9interfaceI23device_disasm_interfaceEEbRPT_($57, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; };
    case 5: // $60
      var $61=(($5+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 6; break; } else { __label__ = 45; break; }
    case 6: // $64
      var $65=(($5+4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $68
      var $69=(($5+24)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($69, ((STRING_TABLE.__str222510)|0), 0, 212, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $70
      __label__ = 11; break;
    case 9: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $3=$73;
      var $74=$72.f1;
      $4=$74;
      __label__ = 56; break;
    case 10: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      $3=$77;
      var $78=$76.f1;
      $4=$78;
      __label__ = 54; break;
    case 11: // $79
      var $80=(($5+8)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 12; break; } else { __label__ = 28; break; }
    case 12: // $83
      var $84=(($5+8)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($85, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; };
    case 13: // $87
      var $88=(($86)|0)!=0;
      if ($88) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $89
      var $90=(($5+24)|0);
      var $91=(($5+8)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($92, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 10; break; };
    case 15: // $94
      var $95=$93;
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($90, ((STRING_TABLE.__str232511)|0), $95, 214, 216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 10; break; }
    case 16: // $96
      __label__ = 17; break;
    case 17: // $97
      var $98=(($5+8)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($99, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 10; break; };
    case 18: // $101
      var $102=(($100)|0)!=0;
      if ($102) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $103
      var $104=(($5+24)|0);
      var $105=(($5+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($106, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 10; break; };
    case 20: // $108
      var $109=$107;
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($104, ((STRING_TABLE.__str242512)|0), $109, 214, 216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 10; break; }
    case 21: // $110
      __label__ = 22; break;
    case 22: // $111
      var $112=(($5+8)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($113, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 10; break; };
    case 23: // $115
      var $116=(($114)|0)!=0;
      if ($116) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 24: // $117
      var $118=(($5+24)|0);
      var $119=(($5+8)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($120, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 10; break; };
    case 25: // $122
      var $123=$121;
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($118, ((STRING_TABLE.__str252513)|0), $123, 214, 216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 10; break; }
    case 26: // $124
      __label__ = 27; break;
    case 27: // $125
      __label__ = 28; break;
    case 28: // $126
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 10; break; }
    case 29: // $127
      var $128=(($5+12)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(function() { try { __THREW__ = false; return __ZNK22device_state_interface11state_firstEv($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 41; break; };
    case 30: // $131
      $entry=$130;
      __label__ = 31; break;
    case 31: // $132
      var $133=$entry;
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 32; break; } else { __label__ = 42; break; }
    case 32: // $135
      var $136=(($5+24)|0);
      var $137=$entry;
      var $138=(function() { try { __THREW__ = false; return __ZNK18device_state_entry6symbolEv($137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 41; break; };
    case 33: // $139
      var $140=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tempstr, $138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 41; break; };
    case 34: // $141
      var $142=(function() { try { __THREW__ = false; return __ZN7astring7tolowerEv($140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 41; break; };
    case 35: // $143
      var $144=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 41; break; };
    case 36: // $145
      var $146=$entry;
      var $147=(function() { try { __THREW__ = false; return __ZNK18device_state_entry5indexEv($146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 41; break; };
    case 37: // $148
      var $149=$147;
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($136, $144, $149, 218, 220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $150
      __label__ = 39; break;
    case 39: // $151
      var $152=$entry;
      var $153=(function() { try { __THREW__ = false; return __ZNK18device_state_entry4nextEv($152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; };
    case 40: // $154
      $entry=$153;
      __label__ = 31; break;
    case 41: // $155
      var $156=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $157=$156.f0;
      $3=$157;
      var $158=$156.f1;
      $4=$158;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 59; break; }
    case 42: // $159
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 10; break; }
    case 43: // $160
      __label__ = 45; break;
    case 44: // $161
      __label__ = 54; break;
    case 45: // $162
      var $163=(($5+4)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 46; break; } else { __label__ = 53; break; }
    case 46: // $166
      var $167=(($5+20)|0);
      HEAP32[(($167)>>2)]=3;
      var $168=(function() { try { __THREW__ = false; return __ZNK12device_debug16min_opcode_bytesEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 10; break; };
    case 47: // $169
      var $170=(($168) & 255);
      var $171=(($5+464)|0);
      HEAP8[($171)]=$170;
      var $172=(($5+12)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=(($173)|0)!=0;
      if ($174) { __label__ = 48; break; } else { __label__ = 52; break; }
    case 48: // $175
      var $176=(($5+24)|0);
      var $177=(function() { try { __THREW__ = false; return __ZN12symbol_table4findEPKc($176, ((STRING_TABLE.__str262514)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 10; break; };
    case 49: // $178
      var $179=(($177)|0)==0;
      if ($179) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $180
      var $181=(($5+24)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($181, ((STRING_TABLE.__str262514)|0), 0, 222, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 10; break; }
    case 51: // $182
      __label__ = 52; break;
    case 52: // $183
      __label__ = 53; break;
    case 53: // $184
      STACKTOP = __stackBase__;
      return;
    case 54: // $185
      var $186=(($5+1576)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12device_debug12dasm_commentEED1Ev($186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 59; break; }
    case 55: // $187
      __label__ = 56; break;
    case 56: // $188
      var $189=(($5+24)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($189) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $190
      __label__ = 58; break;
    case 58: // $191
      var $192=$3;
      var $193=$3;
      var $194=$4;
      var $195=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $193, tempValue);
      var $196=($195.f1 = $194, $195);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 59: // $197
      var $198=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debugC2ER8device_t["X"]=1;

function __ZN12device_debugD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZN12device_debug20breakpoint_clear_allEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $5
      (function() { try { __THREW__ = false; return __ZN12device_debug20watchpoint_clear_allEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $6
      var $7=(($4+1576)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12device_debug12dasm_commentEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $8
      var $9=(($4+24)|0);
      __ZN12symbol_tableD1Ev($9);
      ;
      return;
    case 4: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=(($4+1576)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12device_debug12dasm_commentEED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      __label__ = 7; break;
    case 6: // $19
      __label__ = 7; break;
    case 7: // $20
      var $21=(($4+24)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $22
      __label__ = 9; break;
    case 9: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug24halt_on_next_instructionEPKcz($this, $fmt) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      var $arg=__stackBase__;
      $1=$this;
      $2=$fmt;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=(($3)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$global;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0)==(($15)|0);
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      __label__ = 9; break;
    case 4: // $18
      var $19=$arg;
      HEAP32[(($19)>>2)]=arguments[__ZN12device_debug24halt_on_next_instructionEPKcz.length];
      var $20=(($3)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=__ZNK8device_t7machineEv($21);
      var $23=$2;
      var $24=HEAP32[(($arg)>>2)];
      __Z21debug_console_vprintfR15running_machinePKcPc($22, $23, $24);
      var $25=$arg;
      ;
      var $26=(($3)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$global;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($27)|0)==(($30)|0);
      if ($31) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $32
      var $33=$global;
      var $34=(($33+24)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=$global;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $39
      var $40=$global;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__ZNK8device_t5debugEv($42);
      __ZN12device_debug19compute_debug_flagsEv($43);
      __label__ = 7; break;
    case 7: // $44
      __label__ = 9; break;
    case 8: // $45
      var $46=(($3)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$global;
      var $49=(($48+8)|0);
      HEAP32[(($49)>>2)]=$47;
      __label__ = 9; break;
    case 9: // $50
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug24halt_on_next_instructionEPKcz["X"]=1;

function __ZN12device_debug19compute_debug_flagsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $machine;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      $machine=$5;
      var $6=$machine;
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=$machine;
      var $10=(($9+584)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 4096;
      HEAP32[(($10)>>2)]=$12;
      var $13=$machine;
      var $14=(($13+584)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 | 1;
      HEAP32[(($14)>>2)]=$16;
      var $17=(($2+20)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18 & 1;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $21
      var $22=$machine;
      var $23=__ZNK15running_machine23scheduled_event_pendingEv($22);
      if ($23) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $24
      var $25=$machine;
      var $26=__ZNK15running_machine20save_or_load_pendingEv($25);
      if ($26) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      __label__ = 13; break;
    case 4: // $28
      var $29=$global;
      var $30=(($29+24)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$machine;
      var $35=(($34+584)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36 | 2;
      HEAP32[(($35)>>2)]=$37;
      __label__ = 6; break;
    case 6: // $38
      var $39=(($2+20)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 & 66034;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $43
      var $44=$machine;
      var $45=(($44+584)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$46 | 2;
      HEAP32[(($45)>>2)]=$47;
      __label__ = 8; break;
    case 8: // $48
      var $49=(($2+1560)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $52
      var $53=$machine;
      var $54=(($53+584)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55 | 2;
      HEAP32[(($54)>>2)]=$56;
      __label__ = 10; break;
    case 10: // $57
      var $58=(($2+20)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$59 & 8192;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $62
      var $63=(($2+500)|0);
      var $64=(($2+480)|0);
      var $65=__ZleRK8attotimeS1_($63, $64);
      if ($65) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $66
      var $67=$machine;
      var $68=(($67+584)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$69 | 2;
      HEAP32[(($68)>>2)]=$70;
      __label__ = 13; break;
    case 13: // $71
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug19compute_debug_flagsEv["X"]=1;

function __ZN12device_debug9stop_hookEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+652)|0);
      var $7=HEAP32[(($6)>>2)];
      $global=$7;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$global;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug14interrupt_hookEi($this, $irqline) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$this;
      $2=$irqline;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=(($3+20)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 1024;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $13
      var $14=(($3+492)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==-1;
      if ($16) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $17
      var $18=(($3+492)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=(($19)|0)==(($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$global;
      var $24=(($23+24)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($3)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK8device_t7machineEv($26);
      var $28=(($3)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=__ZNK8device_t3tagEv($29);
      var $31=$2;
      __Z20debug_console_printfR15running_machinePKcz($27, ((STRING_TABLE.__str292517)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$30,HEAP32[((tempInt+4)>>2)]=$31,tempInt));
      __ZN12device_debug19compute_debug_flagsEv($3);
      __label__ = 4; break;
    case 4: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug16instruction_hookEj($this, $curpc) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $machine;
      var $global;
      var $3=__stackBase__;
      var $4=__stackBase__+12;
      var $firststop;
      $1=$this;
      $2=$curpc;
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__ZNK8device_t7machineEv($7);
      $machine=$8;
      var $9=$machine;
      var $10=(($9+652)|0);
      var $11=HEAP32[(($10)>>2)];
      $global=$11;
      var $12=$global;
      var $13=(($12+20)|0);
      HEAP8[($13)]=1;
      var $14=$2;
      var $15=(($5+1536)|0);
      var $16=HEAPU32[(($15)>>2)];
      var $17=(($16+1)|0);
      HEAP32[(($15)>>2)]=$17;
      var $18=(($16)>>>0)%256;
      var $19=(($5+512)|0);
      var $20=(($19+($18<<2))|0);
      HEAP32[(($20)>>2)]=$14;
      var $21=(($5+1560)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      var $25=(($5+1560)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$2;
      __ZN12device_debug6tracer6updateEj($26, $27);
      __label__ = 2; break;
    case 2: // $28
      var $29=$global;
      var $30=(($29+24)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $33
      var $34=(($5+20)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & 16;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $38
      var $39=(($5+456)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($5)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$2;
      var $44=FUNCTION_TABLE[$40]($42, $43);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$global;
      var $48=(($47+24)|0);
      HEAP32[(($48)>>2)]=0;
      __label__ = 6; break;
    case 6: // $49
      var $50=$global;
      var $51=(($50+24)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 7; break; } else { __label__ = 19; break; }
    case 7: // $54
      var $55=(($5+20)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56 & 224;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 8; break; } else { __label__ = 19; break; }
    case 8: // $59
      var $60=(($5+468)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==-1;
      if ($62) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $63
      var $64=$2;
      var $65=(($5+468)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($64)|0)==(($66)|0);
      if ($67) { __label__ = 10; break; } else { __label__ = 18; break; }
    case 10: // $68
      var $69=(($5+472)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70-1)|0);
      HEAP32[(($69)>>2)]=$71;
      var $72=(($5+468)|0);
      HEAP32[(($72)>>2)]=-1;
      var $73=(($5+472)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)==0;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      var $77=$global;
      var $78=(($77+24)|0);
      HEAP32[(($78)>>2)]=0;
      __label__ = 17; break;
    case 12: // $79
      var $80=(($5+20)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81 & 128;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $84
      var $85=(($5+472)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0) < 200;
      if ($87) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $88
      var $89=(($5+472)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90)|0)%100;
      var $92=(($91)|0)==0;
      if ($92) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $93
      var $94=$machine;
      var $95=__ZNK15running_machine10debug_viewEv($94);
      __ZN18debug_view_manager10update_allE15debug_view_type($95, 0);
      var $96=$machine;
      var $97=__ZNK15running_machine10debug_viewEv($96);
      __ZN18debug_view_manager17flush_osd_updatesEv($97);
      var $98=$machine;
      __Z24debugger_refresh_displayR15running_machine($98);
      __label__ = 16; break;
    case 16: // $99
      __label__ = 17; break;
    case 17: // $100
      __label__ = 18; break;
    case 18: // $101
      __label__ = 19; break;
    case 19: // $102
      var $103=$global;
      var $104=(($103+24)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105)|0)!=0;
      if ($106) { __label__ = 20; break; } else { __label__ = 32; break; }
    case 20: // $107
      var $108=(($5+20)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=$109 & 73984;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 21; break; } else { __label__ = 32; break; }
    case 21: // $112
      var $113=(($5+20)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$114 & 8192;
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $117
      var $118=$machine;
      __ZNK15running_machine4timeEv($3, $118);
      var $119=(($5+480)|0);
      var $120=__ZgeRK8attotimeS1_($3, $119);
      if ($120) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $121
      var $122=$machine;
      var $123=$machine;
      __ZNK15running_machine4timeEv($4, $123);
      var $124=__ZNK8attotime9as_doubleEv($4);
      __Z20debug_console_printfR15running_machinePKcz($122, ((STRING_TABLE.__str312519)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$124,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      var $125=$global;
      var $126=(($125+24)|0);
      HEAP32[(($126)>>2)]=0;
      __label__ = 31; break;
    case 24: // $127
      var $128=(($5+20)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$129 & 256;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $132
      var $133=(($5+476)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$2;
      var $136=(($134)|0)==(($135)|0);
      if ($136) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $137
      var $138=$machine;
      var $139=(($5+476)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($5)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=__ZNK8device_t3tagEv($142);
      __Z20debug_console_printfR15running_machinePKcz($138, ((STRING_TABLE.__str322520)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$140,HEAP32[((tempInt+4)>>2)]=$143,tempInt));
      var $144=$global;
      var $145=(($144+24)|0);
      HEAP32[(($145)>>2)]=0;
      __label__ = 30; break;
    case 27: // $146
      var $147=(($5+20)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=$148 & 65536;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $151
      var $152=$2;
      __ZN12device_debug16breakpoint_checkEj($5, $152);
      __label__ = 29; break;
    case 29: // $153
      __label__ = 30; break;
    case 30: // $154
      __label__ = 31; break;
    case 31: // $155
      __label__ = 32; break;
    case 32: // $156
      var $157=$global;
      var $158=(($157+24)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($159)|0)==0;
      if ($160) { __label__ = 33; break; } else { __label__ = 48; break; }
    case 33: // $161
      $firststop=1;
      var $162=$global;
      var $163=(($162+144)|0);
      var $164=HEAP8[($163)];
      var $165=(($164) & 1);
      if ($165) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $166
      var $167=(($5)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=__ZNK8device_t7machineEv($168);
      var $170=__Z18debug_comment_loadR15running_machine($169);
      var $171=$global;
      var $172=(($171+144)|0);
      HEAP8[($172)]=1;
      __label__ = 35; break;
    case 35: // $173
      var $174=(($5)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=__ZNK8device_t7machineEv($175);
      __ZL21reset_transient_flagsR15running_machine($176);
      var $177=$global;
      var $178=(($177+8)|0);
      HEAP32[(($178)>>2)]=0;
      var $179=(($5)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$global;
      var $182=(($181+4)|0);
      HEAP32[(($182)>>2)]=$180;
      var $183=$machine;
      var $184=__ZNK15running_machine10debug_viewEv($183);
      __ZN18debug_view_manager10update_allE15debug_view_type($184, 0);
      var $185=(($5)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=__ZNK8device_t7machineEv($186);
      __Z24debugger_refresh_displayR15running_machine($187);
      var $188=(($5)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=__ZNK8device_t7machineEv($189);
      var $191=__ZNK15running_machine5soundEv($190);
      __ZN13sound_manager13debugger_muteEb($191, 1);
      __label__ = 36; break;
    case 36: // $192
      var $193=$global;
      var $194=(($193+24)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195)|0)==0;
      if ($196) { __label__ = 37; break; } else { __label__ = 47; break; }
    case 37: // $197
      var $198=$machine;
      var $199=__ZNK15running_machine10debug_viewEv($198);
      __ZN18debug_view_manager17flush_osd_updatesEv($199);
      var $200=$global;
      var $201=(($200+22)|0);
      HEAP8[($201)]=0;
      var $202=$machine;
      var $203=(($202+584)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$204 & 4096;
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $207
      var $208=$machine;
      var $209=__ZNK15running_machine3osdEv($208);
      var $210=$209;
      var $211=HEAP32[(($210)>>2)];
      var $212=(($211+20)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($5)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=$firststop;
      var $217=(($216) & 1);
      FUNCTION_TABLE[$213]($209, $215, $217);
      __label__ = 42; break;
    case 39: // $218
      var $219=$machine;
      var $220=(($219+584)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=$221 & 1;
      var $223=(($222)|0)!=0;
      if ($223) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $224
      var $225=(($5)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$firststop;
      var $228=(($227) & 1);
      __Z26debugint_wait_for_debuggerR8device_tb($226, $228);
      __label__ = 41; break;
    case 41: // $229
      __label__ = 42; break;
    case 42: // $230
      $firststop=0;
      var $231=$global;
      var $232=(($231+22)|0);
      var $233=HEAP8[($232)];
      var $234=(($233) & 1);
      if ($234) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $235
      var $236=$machine;
      var $237=__ZNK15running_machine10debug_viewEv($236);
      __ZN18debug_view_manager10update_allE15debug_view_type($237, 3);
      var $238=(($5)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=__ZNK8device_t7machineEv($239);
      __Z24debugger_refresh_displayR15running_machine($240);
      __label__ = 44; break;
    case 44: // $241
      var $242=(($5)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=__ZNK8device_t7machineEv($243);
      __ZL19process_source_fileR15running_machine($244);
      var $245=$machine;
      var $246=__ZNK15running_machine23scheduled_event_pendingEv($245);
      if ($246) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $247
      var $248=$global;
      var $249=(($248+24)|0);
      HEAP32[(($249)>>2)]=1;
      __label__ = 46; break;
    case 46: // $250
      __label__ = 36; break;
    case 47: // $251
      var $252=(($5)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=__ZNK8device_t7machineEv($253);
      var $255=__ZNK15running_machine5soundEv($254);
      __ZN13sound_manager13debugger_muteEb($255, 0);
      var $256=(($5)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=$global;
      var $259=(($258+4)|0);
      HEAP32[(($259)>>2)]=$257;
      __label__ = 48; break;
    case 48: // $260
      var $261=(($5+20)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$262 & 192;
      var $264=(($263)|0)!=0;
      if ($264) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $265
      var $266=(($5+468)|0);
      var $267=HEAP32[(($266)>>2)];
      var $268=(($267)|0)==-1;
      if ($268) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $269
      var $270=__ZNK12device_debug2pcEv($5);
      __ZN12device_debug24prepare_for_step_overoutEj($5, $270);
      __label__ = 51; break;
    case 51: // $271
      var $272=$global;
      var $273=(($272+20)|0);
      HEAP8[($273)]=0;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug16instruction_hookEj["X"]=1;

function __ZN12device_debug6tracer6updateEj($this, $pc) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $index;
      var $buffer=__stackBase__;
      var $logaddrchars;
      var $3;
      var $4;
      var $dasm=__stackBase__+64;
      var $dasmresult;
      var $extraskip;
      var $trace_over_target;
      $1=$this;
      $2=$pc;
      var $5=$1;
      var $6=(($5+336)|0);
      var $7=HEAP8[($6)];
      var $8=(($7) & 1);
      if ($8) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $9
      var $10=(($5+340)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=-1;
      if ($12) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $13
      var $14=(($5+340)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($15)|0)!=(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      __label__ = 36; break;
    case 4: // $19
      var $20=(($5+340)|0);
      HEAP32[(($20)>>2)]=-1;
      __label__ = 5; break;
    case 5: // $21
      $count=0;
      $index=0;
      __label__ = 6; break;
    case 6: // $22
      var $23=$index;
      var $24=(($23)>>>0) < 64;
      if ($24) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $25
      var $26=$index;
      var $27=(($5+72)|0);
      var $28=(($27+($26<<2))|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=(($29)|0)==(($30)|0);
      if ($31) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $32
      var $33=$count;
      var $34=(($33+1)|0);
      $count=$34;
      __label__ = 9; break;
    case 9: // $35
      __label__ = 10; break;
    case 10: // $36
      var $37=$index;
      var $38=(($37+1)|0);
      $index=$38;
      __label__ = 6; break;
    case 11: // $39
      var $40=$count;
      var $41=(($40)|0) > 1;
      if ($41) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $42
      var $43=(($5+328)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+1)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 36; break;
    case 13: // $46
      var $47=(($5+328)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $50
      var $51=(($5+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($5+328)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=_fprintf($52, ((STRING_TABLE.__str572545)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$54,tempInt));
      __label__ = 15; break;
    case 15: // $56
      var $57=(($5+328)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=(($5+8)|0);
      var $59=__ZN7astringcvbEv($58);
      if ($59) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $60
      var $61=(($5)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=__ZNK8device_t7machineEv($64);
      var $66=(($5+8)|0);
      var $67=__ZNK7astringcvPKcEv($66);
      var $68=__Z29debug_console_execute_commandR15running_machinePKci($65, $67, 0);
      __label__ = 17; break;
    case 17: // $69
      __ZN7astringC1Ev($buffer);
      var $70=(($5)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(function() { try { __THREW__ = false; return __ZNK12device_debug12logaddrcharsE16address_spacenum($71, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 31; break; };
    case 18: // $73
      $logaddrchars=$72;
      var $74=$logaddrchars;
      var $75=$2;
      var $76=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str582546)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,HEAP32[((tempInt+4)>>2)]=$75,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 31; break; };
    case 19: // $77
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($dasm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 31; break; }
    case 20: // $78
      var $79=(($5)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$2;
      var $82=(function() { try { __THREW__ = false; return __ZN12device_debug12dasm_wrappedER7astringj($80, $dasm, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 32; break; };
    case 21: // $83
      $dasmresult=$82;
      var $84=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($buffer, $dasm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 32; break; };
    case 22: // $85
      var $86=(($5+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 32; break; };
    case 23: // $89
      var $90=(function() { try { __THREW__ = false; return _fprintf($87, ((STRING_TABLE.__str542542)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$88,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 32; break; };
    case 24: // $91
      var $92=(($5+336)|0);
      var $93=HEAP8[($92)];
      var $94=(($93) & 1);
      if ($94) { __label__ = 25; break; } else { __label__ = 34; break; }
    case 25: // $95
      var $96=$dasmresult;
      var $97=$96 & -2147483648;
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 26; break; } else { __label__ = 34; break; }
    case 26: // $99
      var $100=$dasmresult;
      var $101=$100 & 536870912;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 27; break; } else { __label__ = 34; break; }
    case 27: // $103
      var $104=$dasmresult;
      var $105=$104 & 402653184;
      var $106=$105 >>> 27;
      $extraskip=$106;
      var $107=$2;
      var $108=$dasmresult;
      var $109=$108 & 65535;
      var $110=(($107+$109)|0);
      $trace_over_target=$110;
      __label__ = 28; break;
    case 28: // $111
      var $112=$extraskip;
      var $113=(($112-1)|0);
      $extraskip=$113;
      var $114=(($112)|0) > 0;
      if ($114) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $115
      var $116=(($5)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$trace_over_target;
      var $119=(function() { try { __THREW__ = false; return __ZN12device_debug12dasm_wrappedER7astringj($117, $dasm, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; };
    case 30: // $120
      var $121=$119 & 65535;
      var $122=$trace_over_target;
      var $123=(($122+$121)|0);
      $trace_over_target=$123;
      __label__ = 28; break;
    case 31: // $124
      var $125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $126=$125.f0;
      $3=$126;
      var $127=$125.f1;
      $4=$127;
      __label__ = 38; break;
    case 32: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $130=$129.f0;
      $3=$130;
      var $131=$129.f1;
      $4=$131;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($dasm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 33: // $132
      var $133=$trace_over_target;
      var $134=(($5+340)|0);
      HEAP32[(($134)>>2)]=$133;
      __label__ = 34; break;
    case 34: // $135
      var $136=(($5+332)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+1)|0);
      var $139=(($138)|0)%64;
      var $140=(($5+332)|0);
      HEAP32[(($140)>>2)]=$139;
      var $141=$2;
      var $142=(($5+332)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($5+72)|0);
      var $145=(($144+($143<<2))|0);
      HEAP32[(($145)>>2)]=$141;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($dasm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 31; break; }
    case 35: // $146
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      __label__ = 36; break;
    case 36: // $147
      STACKTOP = __stackBase__;
      return;
    case 37: // $148
      __label__ = 38; break;
    case 38: // $149
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $150
      __label__ = 40; break;
    case 40: // $151
      var $152=$3;
      var $153=$3;
      var $154=$4;
      var $155=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $153, tempValue);
      var $156=($155.f1 = $154, $155);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 41: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug6tracer6updateEj["X"]=1;

function __ZgeRK8attotimeS1_($left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) > (($8)|0);
      if ($9) { var $29 = 1;__label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0)==(($16)|0);
      if ($17) { __label__ = 2; break; } else { var $27 = 0;__label__ = 3; break; }
    case 2: // $18
      var $19=$1;
      var $20=(($19+4)|0);
      var $st$2$0=(($20)|0);
      var $21$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$2$1)>>2)];
      var $22=$2;
      var $23=(($22+4)|0);
      var $st$8$0=(($23)|0);
      var $24$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($23+4)|0);
      var $24$1=HEAP32[(($st$8$1)>>2)];
      var $25=($21$1|0) >= ($24$1|0) && (($21$1|0) >  ($24$1|0) || ($21$0|0) >= ($24$0|0));
      var $27 = $25;__label__ = 3; break;
    case 3: // $26
      var $27;
      var $29 = $27;__label__ = 4; break;
    case 4: // $28
      var $29;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8attotime9as_doubleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0);
  var $6=(($2+4)|0);
  var $st$7$0=(($6)|0);
  var $7$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($6+4)|0);
  var $7$1=HEAP32[(($st$7$1)>>2)];
  var $8=$7$0 + $7$1*4294967296;
  var $9=$8*1e-18;
  var $10=$5+$9;
  ;
  return $10;
}


function __ZNK15running_machine5soundEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+1288)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15running_machine23scheduled_event_pendingEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+1310)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { var $11 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($2+1309)|0);
      var $8=HEAP8[($7)];
      var $9=(($8) & 1);
      var $11 = $9;__label__ = 2; break;
    case 2: // $10
      var $11;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug16breakpoint_checkEj($this, $pc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $bp;
      var $global;
      $1=$this;
      $2=$pc;
      var $3=$1;
      var $4=(($3+1540)|0);
      var $5=HEAP32[(($4)>>2)];
      $bp=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$bp;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $9
      var $10=$bp;
      var $11=$2;
      var $12=__ZN12device_debug10breakpoint3hitEj($10, $11);
      if ($12) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $13
      var $14=(($3)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNK8device_t7machineEv($15);
      var $17=(($16+652)|0);
      var $18=HEAP32[(($17)>>2)];
      $global=$18;
      var $19=$global;
      var $20=(($19+24)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=$bp;
      var $22=(($21+640)|0);
      var $23=__ZN7astringcvbEv($22);
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=(($3)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK8device_t7machineEv($26);
      var $28=$bp;
      var $29=(($28+640)|0);
      var $30=__ZNK7astringcvPKcEv($29);
      var $31=__Z29debug_console_execute_commandR15running_machinePKci($27, $30, 0);
      __label__ = 5; break;
    case 5: // $32
      var $33=$global;
      var $34=(($33+24)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=(($3)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=__ZNK8device_t7machineEv($39);
      var $41=$bp;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($40, ((STRING_TABLE.__str402528)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$43,tempInt));
      __label__ = 7; break;
    case 7: // $44
      __label__ = 10; break;
    case 8: // $45
      __label__ = 9; break;
    case 9: // $46
      var $47=$bp;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      $bp=$49;
      __label__ = 1; break;
    case 10: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug16breakpoint_checkEj["X"]=1;

function __ZN13sound_manager13debugger_muteEb($this, $turn_off) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($turn_off)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  __ZN13sound_manager4muteEbh($4, $6, 4);
  ;
  return;
}


function __ZL19process_source_fileR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 512; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      var $buf=__stackBase__;
      var $i;
      var $s;
      $1=$machine;
      var $2=$1;
      var $3=(($2+652)|0);
      var $4=HEAP32[(($3)>>2)];
      $global=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$global;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { var $16 = 0;__label__ = 3; break; }
    case 2: // $10
      var $11=$global;
      var $12=(($11+24)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      var $16 = $14;__label__ = 3; break;
    case 3: // $15
      var $16;
      if ($16) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $17
      var $18=$global;
      var $19=(($18+12)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=_feof($20);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$global;
      var $25=(($24+12)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=_fclose($26);
      var $28=$global;
      var $29=(($28+12)|0);
      HEAP32[(($29)>>2)]=0;
      __label__ = 16; break;
    case 6: // $30
      var $31=(($buf)|0);
      _memset($31, 0, 512, 1);
      var $32=(($buf)|0);
      var $33=$global;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=_fgets($32, 512, $35);
      var $37=(($buf)|0);
      var $38=_strstr($37, ((STRING_TABLE.__str592547)|0));
      $s=$38;
      var $39=$s;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      var $42=$s;
      HEAP8[($42)]=0;
      __label__ = 8; break;
    case 8: // $43
      var $44=(($buf)|0);
      var $45=_strlen($44);
      $i=$45;
      __label__ = 9; break;
    case 9: // $46
      var $47=$i;
      var $48=(($47)|0) > 0;
      if ($48) { __label__ = 10; break; } else { var $58 = 0;__label__ = 11; break; }
    case 10: // $49
      var $50=$i;
      var $51=(($50-1)|0);
      var $52=(($buf+$51)|0);
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=_isspace($54);
      var $56=(($55)|0)!=0;
      var $58 = $56;__label__ = 11; break;
    case 11: // $57
      var $58;
      if ($58) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $59
      var $60=$i;
      var $61=(($60-1)|0);
      $i=$61;
      var $62=(($buf+$61)|0);
      HEAP8[($62)]=0;
      __label__ = 9; break;
    case 13: // $63
      var $64=(($buf)|0);
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24)!=0;
      if ($66) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $67
      var $68=$1;
      var $69=(($buf)|0);
      var $70=__Z29debug_console_execute_commandR15running_machinePKci($68, $69, 1);
      __label__ = 15; break;
    case 15: // $71
      __label__ = 1; break;
    case 16: // $72
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19process_source_fileR15running_machine["X"]=1;

function __ZNK12device_debug2pcEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZN22device_state_interface2pcEv($8);
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug16memory_read_hookER13address_spacejy($this, $space, $address, $mem_mask$0, $mem_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      $1=$this;
      $2=$space;
      $3=$address;
      var $st$7$0=(($4)|0);
      HEAP32[(($st$7$0)>>2)]=$mem_mask$0;
      var $st$7$1=(($4+4)|0);
      HEAP32[(($st$7$1)>>2)]=$mem_mask$1;
      var $5=$1;
      var $6=$2;
      var $7=$3;
      var $st$14$0=(($4)|0);
      var $8$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($4+4)|0);
      var $8$1=HEAP32[(($st$14$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN12device_debug16watchpoint_checkER13address_spaceijyy($5, $6, 1, $7, $$emscripten$temp$0$0, $$emscripten$temp$0$1, $8$0, $8$1);
      var $9=(($5+1564)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$3;
      __ZN12device_debug13hotspot_checkER13address_spacej($5, $13, $14);
      __label__ = 2; break;
    case 2: // $15
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug24prepare_for_step_overoutEj($this, $pc) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dasmbuffer=__stackBase__;
      var $dasmresult;
      var $3;
      var $4;
      var $extraskip;
      $1=$this;
      $2=$pc;
      var $5=$1;
      __ZN7astringC1Ev($dasmbuffer);
      var $6=$2;
      var $7=(function() { try { __THREW__ = false; return __ZN12device_debug12dasm_wrappedER7astringj($5, $dasmbuffer, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; };
    case 1: // $8
      $dasmresult=$7;
      var $9=$dasmresult;
      var $10=$9 & -2147483648;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=$dasmresult;
      var $14=$13 & 536870912;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $16
      var $17=$dasmresult;
      var $18=$17 & 402653184;
      var $19=$18 >>> 27;
      $extraskip=$19;
      var $20=$dasmresult;
      var $21=$20 & 65535;
      var $22=$2;
      var $23=(($22+$21)|0);
      $2=$23;
      __label__ = 4; break;
    case 4: // $24
      var $25=$extraskip;
      var $26=(($25-1)|0);
      $extraskip=$26;
      var $27=(($25)|0) > 0;
      if ($27) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $28
      var $29=$2;
      var $30=(function() { try { __THREW__ = false; return __ZN12device_debug12dasm_wrappedER7astringj($5, $dasmbuffer, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $31
      var $32=$30 & 65535;
      var $33=$2;
      var $34=(($33+$32)|0);
      $2=$34;
      __label__ = 4; break;
    case 7: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $3=$37;
      var $38=$36.f1;
      $4=$38;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($dasmbuffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 8: // $39
      var $40=$2;
      var $41=(($5+468)|0);
      HEAP32[(($41)>>2)]=$40;
      __label__ = 9; break;
    case 9: // $42
      var $43=(($5+20)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44 & 128;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $47
      var $48=$dasmresult;
      var $49=$48 & -2147483648;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $51
      var $52=$dasmresult;
      var $53=$52 & 1073741824;
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $55
      var $56=(($5+472)|0);
      HEAP32[(($56)>>2)]=100;
      __label__ = 14; break;
    case 13: // $57
      var $58=(($5+472)|0);
      HEAP32[(($58)>>2)]=1;
      __label__ = 14; break;
    case 14: // $59
      __label__ = 15; break;
    case 15: // $60
      FUNCTION_TABLE[__ZN7astringD1Ev]($dasmbuffer);
      STACKTOP = __stackBase__;
      return;
    case 16: // $61
      __label__ = 17; break;
    case 17: // $62
      var $63=$3;
      var $64=$3;
      var $65=$4;
      var $66=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $64, tempValue);
      var $67=($66.f1 = $65, $66);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug24prepare_for_step_overoutEj["X"]=1;

function __ZN12device_debug16watchpoint_checkER13address_spaceijyy($this, $space, $type, $address, $value_to_write$0, $value_to_write$1, $mem_mask$0, $mem_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $6=__stackBase__+8;
      var $global;
      var $size;
      var $bus_size;
      var $address_offset;
      var $wp;
      var $pc;
      var $buffer=__stackBase__+16;
      var $7;
      var $8;
      $1=$this;
      $2=$space;
      $3=$type;
      $4=$address;
      var $st$19$0=(($5)|0);
      HEAP32[(($st$19$0)>>2)]=$value_to_write$0;
      var $st$19$1=(($5+4)|0);
      HEAP32[(($st$19$1)>>2)]=$value_to_write$1;
      var $st$23$0=(($6)|0);
      HEAP32[(($st$23$0)>>2)]=$mem_mask$0;
      var $st$23$1=(($6+4)|0);
      HEAP32[(($st$23$1)>>2)]=$mem_mask$1;
      var $9=$1;
      var $10=$2;
      var $11=__ZNK13address_space7machineEv($10);
      var $12=(($11+652)|0);
      var $13=HEAP32[(($12)>>2)];
      $global=$13;
      var $14=$global;
      var $15=(($14+20)|0);
      var $16=HEAP8[($15)];
      var $17=(($16) & 1);
      if ($17) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$global;
      var $20=(($19+23)|0);
      var $21=HEAP8[($20)];
      var $22=(($21) & 1);
      if ($22) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __label__ = 52; break;
    case 3: // $24
      var $25=$global;
      var $26=(($25+20)|0);
      HEAP8[($26)]=1;
      $size=0;
      var $st$4$0=(($6)|0);
      var $27$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($6+4)|0);
      var $27$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $28=$27$0 != $$emscripten$temp$0$0 || $27$1 != $$emscripten$temp$0$1;
      if ($28) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $29
      var $30=$2;
      var $31=__ZNK13address_space10data_widthEv($30);
      var $32=(((($31)|0)/8)|0);
      $bus_size=$32;
      $address_offset=0;
      __label__ = 5; break;
    case 5: // $33
      var $34=$address_offset;
      var $35=$bus_size;
      var $36=(($34)|0) < (($35)|0);
      if ($36) { __label__ = 6; break; } else { var $42 = 0;__label__ = 7; break; }
    case 6: // $37
      var $st$0$0=(($6)|0);
      var $38$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($6+4)|0);
      var $38$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=255;
      var $$emscripten$temp$1$1=0;
      var $39$0=$38$0 & $$emscripten$temp$1$0;
      var $39$1=$38$1 & $$emscripten$temp$1$1;
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $40=$39$0 == $$emscripten$temp$2$0 && $39$1 == $$emscripten$temp$2$1;
      var $42 = $40;__label__ = 7; break;
    case 7: // $41
      var $42;
      if ($42) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $43
      var $44=$address_offset;
      var $45=(($44+1)|0);
      $address_offset=$45;
      var $st$3$0=(($5)|0);
      var $46$0=HEAPU32[(($st$3$0)>>2)];
      var $st$3$1=(($5+4)|0);
      var $46$1=HEAPU32[(($st$3$1)>>2)];
      var $47$0=($46$0 >>> 8) | ($46$1 << 24);
      var $47$1=($46$1 >>> 8) | (0 << 24);
      var $st$9$0=(($5)|0);
      HEAP32[(($st$9$0)>>2)]=$47$0;
      var $st$9$1=(($5+4)|0);
      HEAP32[(($st$9$1)>>2)]=$47$1;
      var $st$13$0=(($6)|0);
      var $48$0=HEAPU32[(($st$13$0)>>2)];
      var $st$13$1=(($6+4)|0);
      var $48$1=HEAPU32[(($st$13$1)>>2)];
      var $49$0=($48$0 >>> 8) | ($48$1 << 24);
      var $49$1=($48$1 >>> 8) | (0 << 24);
      var $st$19$0=(($6)|0);
      HEAP32[(($st$19$0)>>2)]=$49$0;
      var $st$19$1=(($6+4)|0);
      HEAP32[(($st$19$1)>>2)]=$49$1;
      __label__ = 5; break;
    case 9: // $50
      __label__ = 10; break;
    case 10: // $51
      var $st$0$0=(($6)|0);
      var $52$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($6+4)|0);
      var $52$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $53=$52$0 != $$emscripten$temp$3$0 || $52$1 != $$emscripten$temp$3$1;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      var $55=$size;
      var $56=(($55+1)|0);
      $size=$56;
      var $st$3$0=(($6)|0);
      var $57$0=HEAPU32[(($st$3$0)>>2)];
      var $st$3$1=(($6+4)|0);
      var $57$1=HEAPU32[(($st$3$1)>>2)];
      var $58$0=($57$0 >>> 8) | ($57$1 << 24);
      var $58$1=($57$1 >>> 8) | (0 << 24);
      var $st$9$0=(($6)|0);
      HEAP32[(($st$9$0)>>2)]=$58$0;
      var $st$9$1=(($6+4)|0);
      HEAP32[(($st$9$1)>>2)]=$58$1;
      __label__ = 10; break;
    case 12: // $59
      var $60=$2;
      var $61=__ZNK13address_space10endiannessEv($60);
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $63
      var $64=$address_offset;
      var $65=$4;
      var $66=(($65+$64)|0);
      $4=$66;
      __label__ = 15; break;
    case 14: // $67
      var $68=$bus_size;
      var $69=$size;
      var $70=(($68-$69)|0);
      var $71=$address_offset;
      var $72=(($70-$71)|0);
      var $73=$4;
      var $74=(($73+$72)|0);
      $4=$74;
      __label__ = 15; break;
    case 15: // $75
      __label__ = 16; break;
    case 16: // $76
      var $77=$4;
      var $78$0=$77;
      var $78$1=0;
      var $79=$global;
      var $80=(($79+48)|0);
      var $st$5$0=(($80)|0);
      HEAP32[(($st$5$0)>>2)]=$78$0;
      var $st$5$1=(($80+4)|0);
      HEAP32[(($st$5$1)>>2)]=$78$1;
      var $81=$3;
      var $82=$81 & 2;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $84
      var $st$0$0=(($5)|0);
      var $85$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $85$1=HEAP32[(($st$0$1)>>2)];
      var $86=$global;
      var $87=(($86+40)|0);
      var $st$6$0=(($87)|0);
      HEAP32[(($st$6$0)>>2)]=$85$0;
      var $st$6$1=(($87+4)|0);
      HEAP32[(($st$6$1)>>2)]=$85$1;
      __label__ = 18; break;
    case 18: // $88
      var $89=$2;
      var $90=__ZNK13address_space8spacenumEv($89);
      var $91=(($9+1544)|0);
      var $92=(($91+($90<<2))|0);
      var $93=HEAP32[(($92)>>2)];
      $wp=$93;
      __label__ = 19; break;
    case 19: // $94
      var $95=$wp;
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 20; break; } else { __label__ = 51; break; }
    case 20: // $97
      var $98=$wp;
      var $99=$3;
      var $100=$4;
      var $101=$size;
      var $102=__ZN12device_debug10watchpoint3hitEiji($98, $99, $100, $101);
      if ($102) { __label__ = 21; break; } else { __label__ = 49; break; }
    case 21: // $103
      var $104=$global;
      var $105=(($104+24)|0);
      HEAP32[(($105)>>2)]=0;
      var $106=$wp;
      var $107=(($106+648)|0);
      var $108=__ZN7astringcvbEv($107);
      if ($108) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $109
      var $110=$2;
      var $111=__ZNK13address_space7machineEv($110);
      var $112=$wp;
      var $113=(($112+648)|0);
      var $114=__ZNK7astringcvPKcEv($113);
      var $115=__Z29debug_console_execute_commandR15running_machinePKci($111, $114, 0);
      __label__ = 23; break;
    case 23: // $116
      var $117=$global;
      var $118=(($117+24)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119)|0)==0;
      if ($120) { __label__ = 24; break; } else { __label__ = 48; break; }
    case 24: // $121
      var $122=$2;
      var $123=__ZNK13address_space6deviceEv($122);
      var $124=__ZNK8device_t5debugEv($123);
      var $125=(($124+12)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126)|0)!=0;
      if ($127) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $128
      var $129=$2;
      var $130=__ZNK13address_space6deviceEv($129);
      var $131=__ZNK8device_t5debugEv($130);
      var $132=(($131+12)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=__ZN22device_state_interface2pcEv($133);
      var $137 = $134;__label__ = 27; break;
    case 26: // $135
      var $137 = 0;__label__ = 27; break;
    case 27: // $136
      var $137;
      $pc=$137;
      __ZN7astringC1Ev($buffer);
      var $138=$3;
      var $139=$138 & 2;
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 28; break; } else { __label__ = 37; break; }
    case 28: // $141
      var $142=$wp;
      var $143=(($142+8)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$size;
      var $146=((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+($145<<2))|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$2;
      var $149=$4;
      var $150=(function() { try { __THREW__ = false; return __ZNK13address_space15byte_to_addressEj($148, $149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 33; break; };
    case 29: // $151
      var $152=$pc;
      var $153=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str502538)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$144,HEAP32[((tempInt+4)>>2)]=$147,HEAP32[((tempInt+8)>>2)]=$150,HEAP32[((tempInt+12)>>2)]=$152,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 33; break; };
    case 30: // $154
      var $st$0$0=(($5)|0);
      var $155$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $155$1=HEAP32[(($st$0$1)>>2)];
      var $156$0=$155$1;
      var $156$1=0;
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $157=$156$0 != $$emscripten$temp$4$0 || $156$1 != $$emscripten$temp$4$1;
      if ($157) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $158
      var $st$0$0=(($5)|0);
      var $159$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $159$1=HEAP32[(($st$0$1)>>2)];
      var $160$0=$159$1;
      var $160$1=0;
      var $161$0=$160$0;
      var $161=$161$0;
      var $st$8$0=(($5)|0);
      var $162$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($5+4)|0);
      var $162$1=HEAP32[(($st$8$1)>>2)];
      var $163$0=$162$0;
      var $163=$163$0;
      var $164=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str512539)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$161,HEAP32[((tempInt+4)>>2)]=$163,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 33; break; };
    case 32: // $165
      __label__ = 36; break;
    case 33: // $166
      var $167=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $168=$167.f0;
      $7=$168;
      var $169=$167.f1;
      $8=$169;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 54; break; }
    case 34: // $170
      var $st$0$0=(($5)|0);
      var $171$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $171$1=HEAP32[(($st$0$1)>>2)];
      var $172$0=$171$0;
      var $172=$172$0;
      var $173=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str522540)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$172,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 33; break; };
    case 35: // $174
      __label__ = 36; break;
    case 36: // $175
      __label__ = 40; break;
    case 37: // $176
      var $177=$wp;
      var $178=(($177+8)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$size;
      var $181=((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+($180<<2))|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$2;
      var $184=$4;
      var $185=(function() { try { __THREW__ = false; return __ZNK13address_space15byte_to_addressEj($183, $184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 33; break; };
    case 38: // $186
      var $187=$pc;
      var $188=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str532541)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$179,HEAP32[((tempInt+4)>>2)]=$182,HEAP32[((tempInt+8)>>2)]=$185,HEAP32[((tempInt+12)>>2)]=$187,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 33; break; };
    case 39: // $189
      __label__ = 40; break;
    case 40: // $190
      var $191=$2;
      var $192=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 33; break; };
    case 41: // $193
      var $194=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 33; break; };
    case 42: // $195
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($192, ((STRING_TABLE.__str542542)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$194,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 33; break; }
    case 43: // $196
      var $197=$2;
      var $198=(function() { try { __THREW__ = false; return __ZNK13address_space6deviceEv($197) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 33; break; };
    case 44: // $199
      var $200=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 33; break; };
    case 45: // $201
      (function() { try { __THREW__ = false; return __ZN12device_debug19compute_debug_flagsEv($200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 33; break; }
    case 46: // $202
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      __label__ = 48; break;
    case 47: // $203
      __label__ = 53; break;
    case 48: // $204
      __label__ = 51; break;
    case 49: // $205
      __label__ = 50; break;
    case 50: // $206
      var $207=$wp;
      var $208=(($207)|0);
      var $209=HEAP32[(($208)>>2)];
      $wp=$209;
      __label__ = 19; break;
    case 51: // $210
      var $211=$global;
      var $212=(($211+20)|0);
      HEAP8[($212)]=0;
      __label__ = 52; break;
    case 52: // $213
      STACKTOP = __stackBase__;
      return;
    case 53: // $214
      var $215=$7;
      var $216=$7;
      var $217=$8;
      var $218=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $216, tempValue);
      var $219=($218.f1 = $217, $218);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 54: // $220
      var $221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug16watchpoint_checkER13address_spaceijyy["X"]=1;

function __ZN12device_debug13hotspot_checkER13address_spacej($this, $space, $address) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curpc;
      var $hotindex;
      var $spot;
      var $temp=__stackBase__;
      $1=$this;
      $2=$space;
      $3=$address;
      var $4=$1;
      var $5=__ZNK12device_debug2pcEv($4);
      $curpc=$5;
      $hotindex=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$hotindex;
      var $8=(($4+1568)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($7)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $11
      var $12=$hotindex;
      var $13=(($4+1564)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+($12<<4))|0);
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$3;
      var $19=(($17)|0)==(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $20
      var $21=$hotindex;
      var $22=(($4+1564)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+($21<<4))|0);
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$curpc;
      var $28=(($26)|0)==(($27)|0);
      if ($28) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $29
      var $30=$hotindex;
      var $31=(($4+1564)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+($30<<4))|0);
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$2;
      var $37=(($35)|0)==(($36)|0);
      if ($37) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $38
      __label__ = 8; break;
    case 6: // $39
      __label__ = 7; break;
    case 7: // $40
      var $41=$hotindex;
      var $42=(($41+1)|0);
      $hotindex=$42;
      __label__ = 1; break;
    case 8: // $43
      var $44=$hotindex;
      var $45=(($4+1568)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($44)|0)==(($46)|0);
      if ($47) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $48
      var $49=(($4+1568)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50-1)|0);
      var $52=(($4+1564)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+($51<<4))|0);
      $spot=$54;
      var $55=$spot;
      var $56=(($55+12)|0);
      var $57=HEAPU32[(($56)>>2)];
      var $58=(($4+1572)|0);
      var $59=HEAPU32[(($58)>>2)];
      var $60=(($57)>>>0) > (($59)>>>0);
      if ($60) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $61
      var $62=$2;
      var $63=__ZNK13address_space7machineEv($62);
      var $64=$2;
      var $65=__ZNK13address_space4nameEv($64);
      var $66=$spot;
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$spot;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$spot;
      var $73=(($72+12)|0);
      var $74=HEAP32[(($73)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($63, ((STRING_TABLE.__str552543)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$65,HEAP32[((tempInt+4)>>2)]=$68,HEAP32[((tempInt+8)>>2)]=$71,HEAP32[((tempInt+12)>>2)]=$74,tempInt));
      __label__ = 11; break;
    case 11: // $75
      var $76=(($4+1564)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+16)|0);
      var $79=$78;
      var $80=(($4+1564)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81)|0);
      var $83=$82;
      var $84=(($4+1568)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85-1)|0);
      var $87=((($86<<4))|0);
      _llvm_memmove_p0i8_p0i8_i32($79, $83, $87, 1, 0);
      var $88=$3;
      var $89=(($4+1564)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90)|0);
      var $92=(($91)|0);
      HEAP32[(($92)>>2)]=$88;
      var $93=$curpc;
      var $94=(($4+1564)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0);
      var $97=(($96+4)|0);
      HEAP32[(($97)>>2)]=$93;
      var $98=$2;
      var $99=(($4+1564)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0);
      var $102=(($101+8)|0);
      HEAP32[(($102)>>2)]=$98;
      var $103=(($4+1564)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104)|0);
      var $106=(($105+12)|0);
      HEAP32[(($106)>>2)]=1;
      __label__ = 15; break;
    case 12: // $107
      var $108=$hotindex;
      var $109=(($4+1564)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+($108<<4))|0);
      var $112=(($111+12)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+1)|0);
      HEAP32[(($112)>>2)]=$114;
      var $115=$hotindex;
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $117
      var $118=$hotindex;
      var $119=(($4+1564)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+($118<<4))|0);
      var $122=$temp;
      var $123=$121;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($122)>>2)]=HEAP32[(($123)>>2)];HEAP32[(($122+4)>>2)]=HEAP32[(($123+4)>>2)];HEAP32[(($122+8)>>2)]=HEAP32[(($123+8)>>2)];HEAP32[(($122+12)>>2)]=HEAP32[(($123+12)>>2)];
      var $124=(($4+1564)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125+16)|0);
      var $127=$126;
      var $128=(($4+1564)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129)|0);
      var $131=$130;
      var $132=$hotindex;
      var $133=((($132<<4))|0);
      _llvm_memmove_p0i8_p0i8_i32($127, $131, $133, 1, 0);
      var $134=(($4+1564)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135)|0);
      var $137=$136;
      var $138=$temp;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($137)>>2)]=HEAP32[(($138)>>2)];HEAP32[(($137+4)>>2)]=HEAP32[(($138+4)>>2)];HEAP32[(($137+8)>>2)]=HEAP32[(($138+8)>>2)];HEAP32[(($137+12)>>2)]=HEAP32[(($138+12)>>2)];
      __label__ = 14; break;
    case 14: // $139
      __label__ = 15; break;
    case 15: // $140
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug13hotspot_checkER13address_spacej["X"]=1;

function __ZN12device_debug17memory_write_hookER13address_spacejyy($this, $space, $address, $data$0, $data$1, $mem_mask$0, $mem_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  $1=$this;
  $2=$space;
  $3=$address;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$data$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$data$1;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mem_mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mem_mask$1;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $st$19$0=(($4)|0);
  var $9$0=HEAP32[(($st$19$0)>>2)];
  var $st$19$1=(($4+4)|0);
  var $9$1=HEAP32[(($st$19$1)>>2)];
  var $st$23$0=(($5)|0);
  var $10$0=HEAP32[(($st$23$0)>>2)];
  var $st$23$1=(($5+4)|0);
  var $10$1=HEAP32[(($st$23$1)>>2)];
  __ZN12device_debug16watchpoint_checkER13address_spaceijyy($6, $7, 2, $8, $9$0, $9$1, $10$0, $10$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK12device_debug11disassembleEPcjPKhS2_($this, $buffer, $pc, $oprom, $opram) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $result;
      $1=$this;
      $2=$buffer;
      $3=$pc;
      $4=$oprom;
      $5=$opram;
      var $6=$1;
      $result=0;
      var $7=(($6+460)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($6+460)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($6)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$2;
      var $16=$3;
      var $17=$4;
      var $18=$5;
      var $19=FUNCTION_TABLE[$12]($14, $15, $16, $17, $18, 0);
      $result=$19;
      __label__ = 2; break;
    case 2: // $20
      var $21=$result;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $23
      var $24=(($6+16)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=(($6+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=$3;
      var $32=$4;
      var $33=$5;
      var $34=__ZN23device_disasm_interface11disassembleEPcjPKhS2_j($29, $30, $31, $32, $33, 0);
      $result=$34;
      __label__ = 5; break;
    case 5: // $35
      __label__ = 6; break;
    case 6: // $36
      __label__ = 7; break;
    case 7: // $37
      var $38=$result;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN23device_disasm_interface11disassembleEPcjPKhS2_j($this, $buffer, $pc, $oprom, $opram, $options) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$buffer;
  $3=$pc;
  $4=$oprom;
  $5=$opram;
  $6=$options;
  var $7=$1;
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+64)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$2;
  var $13=$3;
  var $14=$4;
  var $15=$5;
  var $16=$6;
  var $17=FUNCTION_TABLE[$11]($7, $12, $13, $14, $15, $16);
  ;
  return $17;
}


function __ZN12device_debug6ignoreEb($this, $ignore) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$this;
      var $3=(($ignore)&1);
      $2=$3;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__ZNK8device_t7machineEv($6);
      var $8=(($7+652)|0);
      var $9=HEAP32[(($8)>>2)];
      $global=$9;
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12) & 1);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=(($4+20)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & -2;
      HEAP32[(($15)>>2)]=$17;
      __label__ = 5; break;
    case 4: // $18
      var $19=(($4+20)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20 | 1;
      HEAP32[(($19)>>2)]=$21;
      __label__ = 5; break;
    case 5: // $22
      var $23=(($4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$global;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($24)|0)==(($27)|0);
      if ($28) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $29
      var $30=$2;
      var $31=(($30) & 1);
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      __ZN12device_debug14go_next_deviceEv($4);
      __label__ = 8; break;
    case 8: // $33
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug14go_next_deviceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+652)|0);
      var $7=HEAP32[(($6)>>2)];
      $global=$7;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=(($2)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$global;
      var $13=(($12+28)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$global;
      var $15=(($14+24)|0);
      HEAP32[(($15)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug11single_stepEi($this, $numsteps) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$this;
      $2=$numsteps;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$2;
      var $12=(($3+472)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($3+468)|0);
      HEAP32[(($13)>>2)]=-1;
      var $14=(($3+20)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 | 32;
      HEAP32[(($14)>>2)]=$16;
      var $17=$global;
      var $18=(($17+24)|0);
      HEAP32[(($18)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug16single_step_overEi($this, $numsteps) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$this;
      $2=$numsteps;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$2;
      var $12=(($3+472)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($3+468)|0);
      HEAP32[(($13)>>2)]=-1;
      var $14=(($3+20)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 | 64;
      HEAP32[(($14)>>2)]=$16;
      var $17=$global;
      var $18=(($17+24)|0);
      HEAP32[(($18)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug15single_step_outEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+652)|0);
      var $7=HEAP32[(($6)>>2)];
      $global=$7;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=(($2+472)|0);
      HEAP32[(($10)>>2)]=100;
      var $11=(($2+468)|0);
      HEAP32[(($11)>>2)]=-1;
      var $12=(($2+20)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 | 128;
      HEAP32[(($12)>>2)]=$14;
      var $15=$global;
      var $16=(($15+24)|0);
      HEAP32[(($16)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug2goEj($this, $targetpc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$this;
      $2=$targetpc;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$2;
      var $12=(($3+476)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($3+20)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$14 | 256;
      HEAP32[(($13)>>2)]=$15;
      var $16=$global;
      var $17=(($16+24)|0);
      HEAP32[(($17)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug9go_vblankEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      var $6=(($5+652)|0);
      var $7=HEAP32[(($6)>>2)];
      $global=$7;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$global;
      var $11=(($10+21)|0);
      HEAP8[($11)]=0;
      var $12=(($2+20)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 | 4096;
      HEAP32[(($12)>>2)]=$14;
      var $15=$global;
      var $16=(($15+24)|0);
      HEAP32[(($16)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug12go_interruptEi($this, $irqline) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $global;
      $1=$this;
      $2=$irqline;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$2;
      var $12=(($3+492)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($3+20)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$14 | 1024;
      HEAP32[(($13)>>2)]=$15;
      var $16=$global;
      var $17=(($16+24)|0);
      HEAP32[(($17)>>2)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug15go_millisecondsEy($this, $milliseconds$0, $milliseconds$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $global;
      var $3=__stackBase__+8;
      var $4=__stackBase__+20;
      var $5=__stackBase__+32;
      $1=$this;
      var $st$7$0=(($2)|0);
      HEAP32[(($st$7$0)>>2)]=$milliseconds$0;
      var $st$7$1=(($2+4)|0);
      HEAP32[(($st$7$1)>>2)]=$milliseconds$1;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK8device_t7machineEv($8);
      var $10=(($9+652)|0);
      var $11=HEAP32[(($10)>>2)];
      $global=$11;
      __label__ = 1; break;
    case 1: // $12
      __label__ = 2; break;
    case 2: // $13
      var $14=(($6+480)|0);
      var $15=(($6)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNK8device_t7machineEv($16);
      __ZNK15running_machine4timeEv($4, $17);
      var $st$5$0=(($2)|0);
      var $18$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($2+4)|0);
      var $18$1=HEAP32[(($st$5$1)>>2)];
      __ZN8attotime9from_msecEx($5, $18$0, $18$1);
      __ZplRK8attotimeS1_($3, $4, $5);
      var $19=$14;
      var $20=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[(($20+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[(($20+8)>>2)];
      var $21=(($6+20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22 | 8192;
      HEAP32[(($21)>>2)]=$23;
      var $24=$global;
      var $25=(($24+24)|0);
      HEAP32[(($25)>>2)]=1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZplRK8attotimeS1_($agg_result, $left, $right) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result=__stackBase__;
      $1=$left;
      $2=$right;
      __ZN8attotimeC1Ev($result);
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0) >= 1000000000;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0) >= 1000000000;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$agg_result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($13+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($13+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __label__ = 8; break;
    case 3: // $14
      var $15=$1;
      var $16=(($15+4)|0);
      var $st$2$0=(($16)|0);
      var $17$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$2$1)>>2)];
      var $18=$2;
      var $19=(($18+4)|0);
      var $st$8$0=(($19)|0);
      var $20$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($19+4)|0);
      var $20$1=HEAP32[(($st$8$1)>>2)];
      var $21$0 = ((($17$0)>>>0)+((($17$1)|0)*4294967296))+((($20$0)>>>0)+((($20$1)|0)*4294967296))>>>0; var $21$1 = Math.min(Math.floor((((($17$0)>>>0)+((($17$1)|0)*4294967296))+((($20$0)>>>0)+((($20$1)|0)*4294967296)))/4294967296), 4294967295);
      var $22=(($result+4)|0);
      var $st$14$0=(($22)|0);
      HEAP32[(($st$14$0)>>2)]=$21$0;
      var $st$14$1=(($22+4)|0);
      HEAP32[(($st$14$1)>>2)]=$21$1;
      var $23=$1;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$2;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($25+$28)|0);
      var $30=(($result)|0);
      HEAP32[(($30)>>2)]=$29;
      var $31=(($result+4)|0);
      var $st$28$0=(($31)|0);
      var $32$0=HEAP32[(($st$28$0)>>2)];
      var $st$28$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$28$1)>>2)];
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $33=($32$1|0) >= ($$emscripten$temp$0$1|0) && (($32$1|0) >  ($$emscripten$temp$0$1|0) || ($32$0|0) >= ($$emscripten$temp$0$0|0));
      if ($33) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $34
      var $35=(($result+4)|0);
      var $st$1$0=(($35)|0);
      var $36$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($35+4)|0);
      var $36$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $37$0 = ((($36$0)>>>0)+((($36$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $37$1 = Math.min(Math.floor((((($36$0)>>>0)+((($36$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($35)|0);
      HEAP32[(($st$8$0)>>2)]=$37$0;
      var $st$8$1=(($35+4)|0);
      HEAP32[(($st$8$1)>>2)]=$37$1;
      var $38=(($result)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+1)|0);
      HEAP32[(($38)>>2)]=$40;
      __label__ = 5; break;
    case 5: // $41
      var $42=(($result)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0) >= 1000000000;
      if ($44) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $45
      var $46=$agg_result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($46)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($46+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($46+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __label__ = 8; break;
    case 7: // $47
      var $48=$agg_result;
      var $49=$result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($48)>>2)]=HEAP32[(($49)>>2)];HEAP32[(($48+4)>>2)]=HEAP32[(($49+4)>>2)];HEAP32[(($48+8)>>2)]=HEAP32[(($49+8)>>2)];
      __label__ = 8; break;
    case 8: // $50
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZplRK8attotimeS1_["X"]=1;

function __ZN12device_debug14breakpoint_setEjPKcS1_($this, $address, $condition, $action) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $bp;
      var $13;
      var $14;
      $9=$this;
      $10=$address;
      $11=$condition;
      $12=$action;
      var $15=$9;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZNK8device_t7machineEv($17);
      var $19=__ZN15running_machine7respoolEv($18);
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $23=$result_i;
      var $24=$7;
      var $25=$8;
      HEAP32[(($4)>>2)]=704;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($6)>>2)]=2292;
      var $26=HEAP32[(($4)>>2)];
      var $27=HEAP32[(($5)>>2)];
      var $28=HEAP32[(($6)>>2)];
      var $29=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $30
      HEAP32[(($result_i)>>2)]=$29;
      var $31=HEAP32[(($result_i)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $33
      var $34=___cxa_allocate_exception(4);
      var $35=$34;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35);
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($7)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($8)>>2)]=$39;
      var $40=HEAP32[(($8)>>2)];
      var $41=(($40)|0) < 0;
      if ($41) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $42
      var $43=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($43);
      throw "Reached an unreachable!"
    case 5: // $44
      var $45=HEAP32[(($7)>>2)];
      var $46=HEAP32[(($7)>>2)];
      var $47=HEAP32[(($8)>>2)];
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $50
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $51=HEAP32[(($result_i)>>2)];
      var $52=$4;
      var $53=$5;
      var $54=$6;
      var $55=$result_i;
      var $56=$7;
      var $57=$8;
      var $58=$51;
      var $59=(($15+24)|0);
      var $60=(($15)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $63
      var $64=(($62+652)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+32)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+1)|0);
      HEAP32[(($66)>>2)]=$68;
      var $69=$10;
      var $70=$11;
      var $71=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debug10breakpointC1ER12symbol_tableijPKcS4_]($58, $59, $67, $69, $70, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $72
      var $73=__ZN13resource_pool10add_objectIN12device_debug10breakpointEEEPT_S4_($19, $58);
      $bp=$73;
      var $74=(($15+1540)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$bp;
      var $77=(($76)|0);
      HEAP32[(($77)>>2)]=$75;
      var $78=$bp;
      var $79=(($15+1540)|0);
      HEAP32[(($79)>>2)]=$78;
      __ZN12device_debug23breakpoint_update_flagsEv($15);
      var $80=$bp;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      STACKTOP = __stackBase__;
      return $82;
    case 10: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $13=$85;
      var $86=$84.f1;
      $14=$86;
      var $87=$1;
      var $88=$2;
      var $89=$3;
      HEAP32[(($1)>>2)]=$51;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=2292;
      var $90=HEAP32[(($1)>>2)];
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $92
      var $93=HEAP32[(($1)>>2)];
      var $94=HEAP32[(($2)>>2)];
      var $95=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($93, $94, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $96=$1;
      var $97=$2;
      var $98=$3;
      __label__ = 14; break;
    case 14: // $99
      __label__ = 15; break;
    case 15: // $100
      var $101=$13;
      var $102=$13;
      var $103=$14;
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug14breakpoint_setEjPKcS1_["X"]=1;

function __ZNK12device_debug10breakpoint5indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10breakpoint4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10watchpoint5indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12device_debug23breakpoint_update_flagsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $bp;
      var $global;
      $1=$this;
      var $2=$1;
      var $3=(($2+20)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4 & -65537;
      HEAP32[(($3)>>2)]=$5;
      var $6=(($2+1540)|0);
      var $7=HEAP32[(($6)>>2)];
      $bp=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$bp;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$bp;
      var $13=(($12+8)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($2+20)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18 | 65536;
      HEAP32[(($17)>>2)]=$19;
      __label__ = 6; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$bp;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      $bp=$24;
      __label__ = 1; break;
    case 6: // $25
      var $26=(($2)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__ZNK8device_t7machineEv($27);
      var $29=(($28+652)|0);
      var $30=HEAP32[(($29)>>2)];
      $global=$30;
      var $31=$global;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$global;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=__ZNK8device_t5debugEv($38);
      __ZN12device_debug19compute_debug_flagsEv($39);
      __label__ = 8; break;
    case 8: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug23breakpoint_update_flagsEv["X"]=1;

function __ZN12device_debug16breakpoint_clearEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bp;
      var $deleteme;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=(($4+1540)|0);
      $bp=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$bp;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$bp;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $16=(($14)|0)==(($15)|0);
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$bp;
      var $19=HEAP32[(($18)>>2)];
      $deleteme=$19;
      var $20=$deleteme;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$bp;
      HEAP32[(($23)>>2)]=$22;
      var $24=(($4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZNK8device_t7machineEv($25);
      var $27=__ZN15running_machine7respoolEv($26);
      var $28=$deleteme;
      var $29=$28;
      __ZN13resource_pool6removeEPv($27, $29);
      __ZN12device_debug23breakpoint_update_flagsEv($4);
      $1=1;
      __label__ = 7; break;
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$bp;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0);
      $bp=$34;
      __label__ = 1; break;
    case 6: // $35
      $1=0;
      __label__ = 7; break;
    case 7: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug16breakpoint_clearEi["X"]=1;

function __ZN12device_debug17breakpoint_enableEib($this, $index, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $bp;
      $2=$this;
      $3=$index;
      var $5=(($enable)&1);
      $4=$5;
      var $6=$2;
      var $7=(($6+1540)|0);
      var $8=HEAP32[(($7)>>2)];
      $bp=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$bp;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$bp;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=(($15)|0)==(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$4;
      var $20=(($19) & 1);
      var $21=(($20)&1);
      var $22=$bp;
      var $23=(($22+8)|0);
      HEAP8[($23)]=$21;
      __ZN12device_debug23breakpoint_update_flagsEv($6);
      $1=1;
      __label__ = 7; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$bp;
      var $27=__ZNK12device_debug10breakpoint4nextEv($26);
      $bp=$27;
      __label__ = 1; break;
    case 6: // $28
      $1=0;
      __label__ = 7; break;
    case 7: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug21breakpoint_enable_allEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $bp;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=(($4+1540)|0);
      var $6=HEAP32[(($5)>>2)];
      $bp=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$bp;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$bp;
      var $12=__ZNK12device_debug10breakpoint5indexEv($11);
      var $13=$2;
      var $14=(($13) & 1);
      var $15=__ZN12device_debug17breakpoint_enableEib($4, $12, $14);
      __label__ = 3; break;
    case 3: // $16
      var $17=$bp;
      var $18=__ZNK12device_debug10breakpoint4nextEv($17);
      $bp=$18;
      __label__ = 1; break;
    case 4: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug23watchpoint_update_flagsER13address_space($this, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $enableread;
      var $enablewrite;
      var $wp;
      $1=$this;
      $2=$space;
      var $3=$1;
      $enableread=0;
      var $4=(($3+1564)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $enableread=1;
      __label__ = 2; break;
    case 2: // $8
      $enablewrite=0;
      var $9=$2;
      var $10=__ZNK13address_space8spacenumEv($9);
      var $11=(($3+1544)|0);
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      $wp=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$wp;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $17
      var $18=$wp;
      var $19=(($18+12)|0);
      var $20=HEAP8[($19)];
      var $21=(($20) & 1);
      if ($21) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $22
      var $23=$wp;
      var $24=(($23+13)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & 1;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      $enableread=1;
      __label__ = 7; break;
    case 7: // $30
      var $31=$wp;
      var $32=(($31+13)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$34 & 2;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $37
      $enablewrite=1;
      __label__ = 9; break;
    case 9: // $38
      __label__ = 10; break;
    case 10: // $39
      __label__ = 11; break;
    case 11: // $40
      var $41=$wp;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      $wp=$43;
      __label__ = 3; break;
    case 12: // $44
      var $45=$2;
      var $46=$45;
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$enableread;
      var $51=(($50) & 1);
      FUNCTION_TABLE[$49]($45, $51);
      var $52=$2;
      var $53=$52;
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+12)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$enablewrite;
      var $58=(($57) & 1);
      FUNCTION_TABLE[$56]($52, $58);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug23watchpoint_update_flagsER13address_space["X"]=1;

function __ZN12device_debug16watchpoint_clearEi($this, $index) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $spacenum=__stackBase__;
      var $wp;
      var $deleteme;
      var $space;
      $2=$this;
      $3=$index;
      var $4=$2;
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=HEAPU32[(($spacenum)>>2)];
      var $7=(($6)>>>0) < 4;
      if ($7) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $8
      var $9=HEAP32[(($spacenum)>>2)];
      var $10=(($4+1544)|0);
      var $11=(($10+($9<<2))|0);
      $wp=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$wp;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $16
      var $17=$wp;
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$3;
      var $22=(($20)|0)==(($21)|0);
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$wp;
      var $25=HEAP32[(($24)>>2)];
      $deleteme=$25;
      var $26=$deleteme;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      $space=$28;
      var $29=$deleteme;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$wp;
      HEAP32[(($32)>>2)]=$31;
      var $33=(($4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZNK8device_t7machineEv($34);
      var $36=__ZN15running_machine7respoolEv($35);
      var $37=$deleteme;
      var $38=$37;
      __ZN13resource_pool6removeEPv($36, $38);
      var $39=$space;
      __ZN12device_debug23watchpoint_update_flagsER13address_space($4, $39);
      $1=1;
      __label__ = 11; break;
    case 6: // $40
      __label__ = 7; break;
    case 7: // $41
      var $42=$wp;
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0);
      $wp=$44;
      __label__ = 3; break;
    case 8: // $45
      __label__ = 9; break;
    case 9: // $46
      __ZppR16address_spacenumi($spacenum, 0);
      __label__ = 1; break;
    case 10: // $47
      $1=0;
      __label__ = 11; break;
    case 11: // $48
      var $49=$1;
      STACKTOP = __stackBase__;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug16watchpoint_clearEi["X"]=1;

function __ZN13resource_pool10add_objectIN12device_debug10breakpointEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug10breakpointEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12device_debug10breakpointEEEPT_S4_["X"]=1;

function __ZN12device_debug14watchpoint_setER13address_spaceijjPKcS3_($this, $space, $type, $address, $length, $condition, $action) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $wp;
      var $16;
      var $17;
      $9=$this;
      $10=$space;
      $11=$type;
      $12=$address;
      $13=$length;
      $14=$condition;
      $15=$action;
      var $18=$9;
      __label__ = 1; break;
    case 1: // $19
      __label__ = 2; break;
    case 2: // $20
      var $21=(($18)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK8device_t7machineEv($22);
      var $24=__ZN15running_machine7respoolEv($23);
      var $25=$4;
      var $26=$5;
      var $27=$6;
      var $28=$result_i;
      var $29=$7;
      var $30=$8;
      HEAP32[(($4)>>2)]=712;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($6)>>2)]=2383;
      var $31=HEAP32[(($4)>>2)];
      var $32=HEAP32[(($5)>>2)];
      var $33=HEAP32[(($6)>>2)];
      var $34=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31, $32, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $35
      HEAP32[(($result_i)>>2)]=$34;
      var $36=HEAP32[(($result_i)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $38
      var $39=___cxa_allocate_exception(4);
      var $40=$39;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40);
      (function() { try { __THREW__ = false; return ___cxa_throw($39, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      HEAP32[(($7)>>2)]=$43;
      var $44=$42.f1;
      HEAP32[(($8)>>2)]=$44;
      var $45=HEAP32[(($8)>>2)];
      var $46=(($45)|0) < 0;
      if ($46) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $47
      var $48=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($48);
      throw "Reached an unreachable!"
    case 7: // $49
      var $50=HEAP32[(($7)>>2)];
      var $51=HEAP32[(($7)>>2)];
      var $52=HEAP32[(($8)>>2)];
      var $53=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $51, tempValue);
      var $54=($53.f1 = $52, $53);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $55
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $56=HEAP32[(($result_i)>>2)];
      var $57=$4;
      var $58=$5;
      var $59=$6;
      var $60=$result_i;
      var $61=$7;
      var $62=$8;
      var $63=$56;
      var $64=(($18+24)|0);
      var $65=(($18)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $68
      var $69=(($67+652)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+32)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+1)|0);
      HEAP32[(($71)>>2)]=$73;
      var $74=$10;
      var $75=$11;
      var $76=$12;
      var $77=$13;
      var $78=$14;
      var $79=$15;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debug10watchpointC1ER12symbol_tableiR13address_spaceijjPKcS6_]($63, $64, $72, $74, $75, $76, $77, $78, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $80
      var $81=__ZN13resource_pool10add_objectIN12device_debug10watchpointEEEPT_S4_($24, $63);
      $wp=$81;
      var $82=$10;
      var $83=__ZNK13address_space8spacenumEv($82);
      var $84=(($18+1544)|0);
      var $85=(($84+($83<<2))|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$wp;
      var $88=(($87)|0);
      HEAP32[(($88)>>2)]=$86;
      var $89=$wp;
      var $90=$10;
      var $91=__ZNK13address_space8spacenumEv($90);
      var $92=(($18+1544)|0);
      var $93=(($92+($91<<2))|0);
      HEAP32[(($93)>>2)]=$89;
      var $94=$wp;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      __ZN12device_debug23watchpoint_update_flagsER13address_space($18, $96);
      var $97=$wp;
      var $98=(($97+8)|0);
      var $99=HEAP32[(($98)>>2)];
      STACKTOP = __stackBase__;
      return $99;
    case 12: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $16=$102;
      var $103=$101.f1;
      $17=$103;
      var $104=$1;
      var $105=$2;
      var $106=$3;
      HEAP32[(($1)>>2)]=$56;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=2383;
      var $107=HEAP32[(($1)>>2)];
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $109
      var $110=HEAP32[(($1)>>2)];
      var $111=HEAP32[(($2)>>2)];
      var $112=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($110, $111, $112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $113=$1;
      var $114=$2;
      var $115=$3;
      __label__ = 16; break;
    case 16: // $116
      __label__ = 17; break;
    case 17: // $117
      var $118=$16;
      var $119=$16;
      var $120=$17;
      var $121=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $119, tempValue);
      var $122=($121.f1 = $120, $121);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $123
      var $124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug14watchpoint_setER13address_spaceijjPKcS3_["X"]=1;

function __ZN13resource_pool10add_objectIN12device_debug10watchpointEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug10watchpointEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12device_debug10watchpointEEEPT_S4_["X"]=1;

function __ZNK12device_debug10watchpoint4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10history_pcEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0) > 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $2=0;
      __label__ = 2; break;
    case 2: // $7
      var $8=$2;
      var $9=(($8)|0) <= -256;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      $2=-255;
      __label__ = 4; break;
    case 4: // $11
      var $12=(($3+1536)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+256)|0);
      var $15=(($14-1)|0);
      var $16=$2;
      var $17=(($15+$16)|0);
      var $18=(($17)>>>0)%256;
      var $19=(($3+512)|0);
      var $20=(($19+($18<<2))|0);
      var $21=HEAP32[(($20)>>2)];
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug17watchpoint_enableEib($this, $index, $enable) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $spacenum=__stackBase__;
      var $wp;
      $2=$this;
      $3=$index;
      var $5=(($enable)&1);
      $4=$5;
      var $6=$2;
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=HEAPU32[(($spacenum)>>2)];
      var $9=(($8)>>>0) < 4;
      if ($9) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $10
      var $11=HEAP32[(($spacenum)>>2)];
      var $12=(($6+1544)|0);
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      $wp=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$wp;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $18
      var $19=$wp;
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$3;
      var $23=(($21)|0)==(($22)|0);
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$4;
      var $26=(($25) & 1);
      var $27=$wp;
      var $28=(($27+12)|0);
      var $29=(($26)&1);
      HEAP8[($28)]=$29;
      var $30=$wp;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      __ZN12device_debug23watchpoint_update_flagsER13address_space($6, $32);
      $1=1;
      __label__ = 11; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$wp;
      var $36=__ZNK12device_debug10watchpoint4nextEv($35);
      $wp=$36;
      __label__ = 3; break;
    case 8: // $37
      __label__ = 9; break;
    case 9: // $38
      __ZppR16address_spacenumi($spacenum, 0);
      __label__ = 1; break;
    case 10: // $39
      $1=0;
      __label__ = 11; break;
    case 11: // $40
      var $41=$1;
      STACKTOP = __stackBase__;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug17watchpoint_enableEib["X"]=1;

function __ZN12device_debug21watchpoint_enable_allEb($this, $enable) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $spacenum=__stackBase__;
      var $wp;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=HEAPU32[(($spacenum)>>2)];
      var $7=(($6)>>>0) < 4;
      if ($7) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $8
      var $9=HEAP32[(($spacenum)>>2)];
      var $10=(($4+1544)|0);
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      $wp=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$wp;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $16
      var $17=$wp;
      var $18=__ZNK12device_debug10watchpoint5indexEv($17);
      var $19=$2;
      var $20=(($19) & 1);
      var $21=__ZN12device_debug17watchpoint_enableEib($4, $18, $20);
      __label__ = 5; break;
    case 5: // $22
      var $23=$wp;
      var $24=__ZNK12device_debug10watchpoint4nextEv($23);
      $wp=$24;
      __label__ = 3; break;
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      __ZppR16address_spacenumi($spacenum, 0);
      __label__ = 1; break;
    case 8: // $27
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12device_debug20compute_opcode_crc32Ej($this, $address) {
  var __stackBase__  = STACKTOP; STACKTOP += 384; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $space;
      var $opbuf=__stackBase__;
      var $argbuf=__stackBase__+64;
      var $maxbytes;
      var $index;
      var $buff=__stackBase__+128;
      var $numbytes;
      $2=$this;
      $3=$address;
      var $4=$2;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 9; break;
    case 2: // $9
      var $10=(($4+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=__ZNK23device_memory_interface5spaceE16address_spacenum($11, 0);
      $space=$12;
      var $13=$space;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $1=0;
      __label__ = 9; break;
    case 4: // $16
      var $17=(($opbuf)|0);
      _memset($17, 0, 64, 1);
      var $18=(($argbuf)|0);
      _memset($18, 0, 64, 1);
      var $19=(($4+16)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZNK23device_disasm_interface16max_opcode_bytesEv($20);
      $maxbytes=$21;
      $index=0;
      __label__ = 5; break;
    case 5: // $22
      var $23=$index;
      var $24=$maxbytes;
      var $25=(($23)|0) < (($24)|0);
      if ($25) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $26
      var $27=$space;
      var $28=$3;
      var $29=$index;
      var $30=(($28+$29)|0);
      var $31=__Z17debug_read_opcodeP13address_spacejii($27, $30, 1, 0);
      var $31$0=$31[0];
      var $31$1=$31[1];
      var $32$0=$31$0;
      var $32=$32$0&255;
      var $33=$index;
      var $34=(($opbuf+$33)|0);
      HEAP8[($34)]=$32;
      var $35=$space;
      var $36=$3;
      var $37=$index;
      var $38=(($36+$37)|0);
      var $39=__Z17debug_read_opcodeP13address_spacejii($35, $38, 1, 1);
      var $39$0=$39[0];
      var $39$1=$39[1];
      var $40$0=$39$0;
      var $40=$40$0&255;
      var $41=$index;
      var $42=(($argbuf+$41)|0);
      HEAP8[($42)]=$40;
      __label__ = 7; break;
    case 7: // $43
      var $44=$index;
      var $45=(($44+1)|0);
      $index=$45;
      __label__ = 5; break;
    case 8: // $46
      var $47=(($buff)|0);
      var $48=$3;
      var $49=$space;
      var $50=__ZNK13address_space11logaddrmaskEv($49);
      var $51=$48 & $50;
      var $52=(($opbuf)|0);
      var $53=(($argbuf)|0);
      var $54=__ZNK12device_debug11disassembleEPcjPKhS2_($4, $47, $51, $52, $53);
      var $55=$54 & 65535;
      $numbytes=$55;
      var $56=$space;
      var $57=$numbytes;
      var $58=__ZNK13address_space15address_to_byteEj($56, $57);
      $numbytes=$58;
      var $59=(($argbuf)|0);
      var $60=$numbytes;
      var $61=_crc32(0, $59, $60);
      $1=$61;
      __label__ = 9; break;
    case 9: // $62
      var $63=$1;
      STACKTOP = __stackBase__;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12device_debug20compute_opcode_crc32Ej["X"]=1;

function __ZN12device_debug13hotspot_trackEii($this, $numspots, $threshhold) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      $6=$this;
      $7=$numspots;
      $8=$threshhold;
      var $9=$6;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=__ZNK8device_t7machineEv($11);
      var $13=__ZN15running_machine7respoolEv($12);
      var $14=(($9+1564)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15;
      __ZN13resource_pool6removeEPv($13, $16);
      var $17=(($9+1564)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=$7;
      var $19=(($18)|0) > 0;
      if ($19) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $20
      var $21=(($9)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK8device_t7machineEv($22);
      var $24=__ZN15running_machine7respoolEv($23);
      var $25=$7;
      var $26=_llvm_umul_with_overflow_i32($25, 16);
      var $27=$26.f1;
      var $28=$26.f0;
      var $29=$27 ? -1 : $28;
      var $30=$1;
      var $31=$2;
      var $32=$3;
      var $33=$result_i;
      var $34=$4;
      var $35=$5;
      HEAP32[(($1)>>2)]=$29;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=2484;
      var $36=HEAP32[(($1)>>2)];
      var $37=HEAP32[(($2)>>2)];
      var $38=HEAP32[(($3)>>2)];
      var $39=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($36, $37, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $40
      HEAP32[(($result_i)>>2)]=$39;
      var $41=HEAP32[(($result_i)>>2)];
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $43
      var $44=___cxa_allocate_exception(4);
      var $45=$44;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($45);
      (function() { try { __THREW__ = false; return ___cxa_throw($44, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      HEAP32[(($4)>>2)]=$48;
      var $49=$47.f1;
      HEAP32[(($5)>>2)]=$49;
      var $50=HEAP32[(($5)>>2)];
      var $51=(($50)|0) < 0;
      if ($51) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $52
      var $53=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 6: // $54
      var $55=HEAP32[(($4)>>2)];
      var $56=HEAP32[(($4)>>2)];
      var $57=HEAP32[(($5)>>2)];
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $60
      throw "Reached an unreachable!"
    case 8: // $_ZnajPKci_exit
      var $61=HEAP32[(($result_i)>>2)];
      var $62=$1;
      var $63=$2;
      var $64=$3;
      var $65=$result_i;
      var $66=$4;
      var $67=$5;
      var $68=$61;
      var $69=$7;
      var $70=__ZN13resource_pool9add_arrayIN12device_debug13hotspot_entryEEEPT_S4_i($24, $68, $69);
      var $71=(($9+1564)|0);
      HEAP32[(($71)>>2)]=$70;
      var $72=(($9+1564)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73;
      var $75=$7;
      var $76=((($75<<4))|0);
      _memset($74, -1, $76, 1);
      var $77=$7;
      var $78=(($9+1568)|0);
      HEAP32[(($78)>>2)]=$77;
      var $79=$8;
      var $80=(($9+1572)|0);
      HEAP32[(($80)>>2)]=$79;
      __label__ = 9; break;
    case 9: // $81
      var $82=(($9+8)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $85
      var $86=(($9+8)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=__ZNK23device_memory_interface5spaceE16address_spacenum($87, 0);
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $90
      var $91=(($9+8)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=__ZNK23device_memory_interface5spaceE16address_spacenum($92, 0);
      __ZN12device_debug23watchpoint_update_flagsER13address_space($9, $93);
      __label__ = 12; break;
    case 12: // $94
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug13hotspot_trackEii["X"]=1;

function __ZN13resource_pool9add_arrayIN12device_debug13hotspot_entryEEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIN12device_debug13hotspot_entryEEEPT_S4_i["X"]=1;

function __ZN12device_debug11comment_addEjPKcj($this, $addr, $comment, $color) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $crc;
      var $newcomment;
      var $13;
      var $14;
      var $prev;
      var $curr;
      $9=$this;
      $10=$addr;
      $11=$comment;
      $12=$color;
      var $15=$9;
      var $16=$10;
      var $17=__ZNK12device_debug20compute_opcode_crc32Ej($15, $16);
      $crc=$17;
      var $18=(($15)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK8device_t7machineEv($19);
      var $21=__ZN15running_machine7respoolEv($20);
      var $22=$4;
      var $23=$5;
      var $24=$6;
      var $25=$result_i;
      var $26=$7;
      var $27=$8;
      HEAP32[(($4)>>2)]=80;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($6)>>2)]=2522;
      var $28=HEAP32[(($4)>>2)];
      var $29=HEAP32[(($5)>>2)];
      var $30=HEAP32[(($6)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($7)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($8)>>2)]=$41;
      var $42=HEAP32[(($8)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $44
      var $45=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 5: // $46
      var $47=HEAP32[(($7)>>2)];
      var $48=HEAP32[(($7)>>2)];
      var $49=HEAP32[(($8)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $52
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $53=HEAPU32[(($result_i)>>2)];
      var $54=$4;
      var $55=$5;
      var $56=$6;
      var $57=$result_i;
      var $58=$7;
      var $59=$8;
      var $60=$53;
      var $61=$11;
      var $62=$10;
      var $63=$12;
      var $64=$crc;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debug12dasm_commentC1EPKcjjj]($60, $61, $62, $63, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $65
      var $66=__ZN13resource_pool10add_objectIN12device_debug12dasm_commentEEEPT_S4_($21, $60);
      $newcomment=$66;
      $prev=0;
      var $67=(($15+1576)|0);
      var $68=__ZNK11simple_listIN12device_debug12dasm_commentEE5firstEv($67);
      $curr=$68;
      __label__ = 9; break;
    case 9: // $69
      var $70=$curr;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $72
      var $73=$curr;
      var $74=(($73+4)|0);
      var $75=HEAPU32[(($74)>>2)];
      var $76=$10;
      var $77=(($75)>>>0) >= (($76)>>>0);
      if ($77) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $78
      __label__ = 19; break;
    case 12: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $81=$80.f0;
      $13=$81;
      var $82=$80.f1;
      $14=$82;
      var $83=$1;
      var $84=$2;
      var $85=$3;
      HEAP32[(($1)>>2)]=$53;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=2522;
      var $86=HEAP32[(($1)>>2)];
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $88
      var $89=HEAP32[(($1)>>2)];
      var $90=HEAP32[(($2)>>2)];
      var $91=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($89, $90, $91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 32; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $92=$1;
      var $93=$2;
      var $94=$3;
      __label__ = 16; break;
    case 16: // $95
      __label__ = 31; break;
    case 17: // $96
      __label__ = 18; break;
    case 18: // $97
      var $98=$curr;
      $prev=$98;
      var $99=$curr;
      var $100=__ZNK12device_debug12dasm_comment4nextEv($99);
      $curr=$100;
      __label__ = 9; break;
    case 19: // $101
      var $102=$prev;
      var $103=(($102)|0)==0;
      if ($103) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $104
      var $105=(($15+1576)|0);
      var $106=$newcomment;
      var $107=__ZN11simple_listIN12device_debug12dasm_commentEE7prependERS1_($105, $106);
      __label__ = 22; break;
    case 21: // $108
      var $109=$prev;
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$newcomment;
      var $113=(($112)|0);
      HEAP32[(($113)>>2)]=$111;
      var $114=$newcomment;
      var $115=$prev;
      var $116=(($115)|0);
      HEAP32[(($116)>>2)]=$114;
      __label__ = 22; break;
    case 22: // $117
      __label__ = 23; break;
    case 23: // $118
      var $119=$curr;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 24; break; } else { var $128 = 0;__label__ = 25; break; }
    case 24: // $121
      var $122=$curr;
      var $123=(($122+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$10;
      var $126=(($124)|0)==(($125)|0);
      var $128 = $126;__label__ = 25; break;
    case 25: // $127
      var $128;
      if ($128) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $129
      var $130=$curr;
      var $131=(($130+12)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$crc;
      var $134=(($132)|0)==(($133)|0);
      if ($134) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $135
      var $136=(($15+1576)|0);
      var $137=$curr;
      __ZN11simple_listIN12device_debug12dasm_commentEE6removeERS1_($136, $137);
      __label__ = 30; break;
    case 28: // $138
      __label__ = 29; break;
    case 29: // $139
      var $140=$curr;
      var $141=__ZNK12device_debug12dasm_comment4nextEv($140);
      $curr=$141;
      __label__ = 23; break;
    case 30: // $142
      var $143=(($15+1596)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+1)|0);
      HEAP32[(($143)>>2)]=$145;
      STACKTOP = __stackBase__;
      return;
    case 31: // $146
      var $147=$13;
      var $148=$13;
      var $149=$14;
      var $150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $148, tempValue);
      var $151=($150.f1 = $149, $150);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 32: // $152
      var $153=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug11comment_addEjPKcj["X"]=1;
// WARNING: content after a branch in a label, line: 283429

function __ZNK11simple_listIN12device_debug12dasm_commentEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug12dasm_comment4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN12device_debug12dasm_commentEE7prependERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12device_debug12dasm_commentEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13address_space11logaddrmaskEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN12device_debug12dasm_commentEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN12device_debug12dasm_commentEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN12device_debug14comment_removeEj($this, $addr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $crc;
      var $curr;
      $2=$this;
      $3=$addr;
      var $4=$2;
      var $5=$3;
      var $6=__ZNK12device_debug20compute_opcode_crc32Ej($4, $5);
      $crc=$6;
      var $7=(($4+1576)|0);
      var $8=__ZNK11simple_listIN12device_debug12dasm_commentEE5firstEv($7);
      $curr=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$curr;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=$curr;
      var $14=(($13+4)|0);
      var $15=HEAPU32[(($14)>>2)];
      var $16=$3;
      var $17=(($15)>>>0) > (($16)>>>0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      __label__ = 9; break;
    case 4: // $19
      var $20=$curr;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$3;
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $25
      var $26=$curr;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$crc;
      var $30=(($28)|0)==(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $31
      var $32=(($4+1576)|0);
      var $33=$curr;
      __ZN11simple_listIN12device_debug12dasm_commentEE6removeERS1_($32, $33);
      var $34=(($4+1596)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+1)|0);
      HEAP32[(($34)>>2)]=$36;
      $1=1;
      __label__ = 10; break;
    case 7: // $37
      __label__ = 8; break;
    case 8: // $38
      var $39=$curr;
      var $40=__ZNK12device_debug12dasm_comment4nextEv($39);
      $curr=$40;
      __label__ = 1; break;
    case 9: // $41
      $1=0;
      __label__ = 10; break;
    case 10: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug14comment_removeEj["X"]=1;

function __ZNK12device_debug12comment_textEj($this, $addr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $crc;
      var $curr;
      $2=$this;
      $3=$addr;
      var $4=$2;
      var $5=$3;
      var $6=__ZNK12device_debug20compute_opcode_crc32Ej($4, $5);
      $crc=$6;
      var $7=(($4+1576)|0);
      var $8=__ZNK11simple_listIN12device_debug12dasm_commentEE5firstEv($7);
      $curr=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$curr;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=$curr;
      var $14=(($13+4)|0);
      var $15=HEAPU32[(($14)>>2)];
      var $16=$3;
      var $17=(($15)>>>0) > (($16)>>>0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      __label__ = 9; break;
    case 4: // $19
      var $20=$curr;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$3;
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $25
      var $26=$curr;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$crc;
      var $30=(($28)|0)==(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $31
      var $32=$curr;
      var $33=(($32+16)|0);
      var $34=__ZNK7astringcvPKcEv($33);
      $1=$34;
      __label__ = 10; break;
    case 7: // $35
      __label__ = 8; break;
    case 8: // $36
      var $37=$curr;
      var $38=__ZNK12device_debug12dasm_comment4nextEv($37);
      $curr=$38;
      __label__ = 1; break;
    case 9: // $39
      $1=0;
      __label__ = 10; break;
    case 10: // $40
      var $41=$1;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12device_debug12comment_textEj["X"]=1;

function __ZNK23device_disasm_interface16max_opcode_bytesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZNK13address_space15address_to_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK20address_space_config9addr2byteEj($5, $6);
  ;
  return $7;
}


function __ZN12device_debug12trace_printfEPKcz($this, $fmt) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $va=__stackBase__;
      $1=$this;
      $2=$fmt;
      var $3=$1;
      var $4=(($3+1560)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$va;
      HEAP32[(($8)>>2)]=arguments[__ZN12device_debug12trace_printfEPKcz.length];
      var $9=(($3+1560)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=HEAP32[(($va)>>2)];
      __ZN12device_debug6tracer7vprintfEPKcPc($10, $11, $12);
      var $13=$va;
      ;
      __label__ = 2; break;
    case 2: // $14
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug6tracer7vprintfEPKcPc($this, $format, $va) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$format;
  $3=$va;
  var $4=$1;
  var $5=(($4+4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  var $8=$3;
  var $9=_vfprintf($6, $7, $8);
  ;
  return;
}


function __ZNK15running_machine20save_or_load_pendingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1484)|0);
  var $4=__ZNK7astringcvbEv($3);
  ;
  return $4;
}


function __ZN12device_debug12dasm_wrappedER7astringj($this, $buffer, $pc) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $space;
      var $pcbyte;
      var $opbuf=__stackBase__;
      var $argbuf=__stackBase__+64;
      var $maxbytes;
      var $numbytes;
      $1=$this;
      $2=$buffer;
      $3=$pc;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=(($4+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK23device_memory_interface5spaceE16address_spacenum($8, 0);
      $space=$9;
      var $10=$space;
      var $11=$3;
      var $12=__ZNK13address_space15address_to_byteEj($10, $11);
      var $13=$space;
      var $14=__ZNK13address_space8bytemaskEv($13);
      var $15=$12 & $14;
      $pcbyte=$15;
      var $16=__ZNK12device_debug16max_opcode_bytesEv($4);
      $maxbytes=$16;
      $numbytes=0;
      __label__ = 3; break;
    case 3: // $17
      var $18=$numbytes;
      var $19=$maxbytes;
      var $20=(($18)|0) < (($19)|0);
      if ($20) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $21
      var $22=$space;
      var $23=$pcbyte;
      var $24=$numbytes;
      var $25=(($23+$24)|0);
      var $26=__Z17debug_read_opcodeP13address_spacejii($22, $25, 1, 0);
      var $26$0=$26[0];
      var $26$1=$26[1];
      var $27$0=$26$0;
      var $27=$27$0&255;
      var $28=$numbytes;
      var $29=(($opbuf+$28)|0);
      HEAP8[($29)]=$27;
      var $30=$space;
      var $31=$pcbyte;
      var $32=$numbytes;
      var $33=(($31+$32)|0);
      var $34=__Z17debug_read_opcodeP13address_spacejii($30, $33, 1, 1);
      var $34$0=$34[0];
      var $34$1=$34[1];
      var $35$0=$34$0;
      var $35=$35$0&255;
      var $36=$numbytes;
      var $37=(($argbuf+$36)|0);
      HEAP8[($37)]=$35;
      __label__ = 5; break;
    case 5: // $38
      var $39=$numbytes;
      var $40=(($39+1)|0);
      $numbytes=$40;
      __label__ = 3; break;
    case 6: // $41
      var $42=$2;
      var $43=__ZN7astring6expandEi($42, 200);
      var $44=$2;
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$3;
      var $49=(($opbuf)|0);
      var $50=(($argbuf)|0);
      var $51=__ZNK12device_debug11disassembleEPcjPKhS2_($4, $47, $48, $49, $50);
      STACKTOP = __stackBase__;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug12dasm_wrappedER7astringj["X"]=1;

function __ZN12device_debug10breakpoint3hitEj($this, $pc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $2=$this;
      $3=$pc;
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      $1=0;
      __label__ = 11; break;
    case 2: // $13
      var $14=(($8+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=(($15)|0)!=(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      $1=0;
      __label__ = 11; break;
    case 4: // $19
      var $20=(($8+16)|0);
      var $21=__ZNK17parsed_expression8is_emptyEv($20);
      if ($21) { __label__ = 10; break; } else { __label__ = 5; break; }
    case 5: // $22
      var $23=(($8+16)|0);
      var $24=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
      var $24$0=$24[0];
      var $24$1=$24[1];
    case 6: // $25
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $26=$24$0 != $$emscripten$temp$0$0 || $24$1 != $$emscripten$temp$0$1;
      $1=$26;
      __label__ = 11; break;
    case 7: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $29=$28.f0;
      $4=$29;
      var $30=$28.f1;
      $5=$30;
      __label__ = 8; break;
    case 8: // $31
      var $32=$5;
      var $33=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $35
      var $36=$4;
      var $37=___cxa_begin_catch($36);
      var $38=$37;
      $6=$38;
      $1=0;
      $7=1;
      ___cxa_end_catch();
      __label__ = 11; break;
    case 10: // $40
      $1=1;
      __label__ = 11; break;
    case 11: // $41
      var $42=$1;
      ;
      return $42;
    case 12: // $43
      var $44=$4;
      var $45=$4;
      var $46=$5;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug10breakpoint3hitEj["X"]=1;

function __ZN13resource_pool10add_objectIN12device_debug12dasm_commentEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug12dasm_commentEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12device_debug12dasm_commentEEEPT_S4_["X"]=1;

function __ZN12device_debug5traceEP7__sFILEbPKc($this, $file, $trace_over, $action) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$this;
      $10=$file;
      var $15=(($trace_over)&1);
      $11=$15;
      $12=$action;
      var $16=$9;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZNK8device_t7machineEv($18);
      var $20=__ZN15running_machine7respoolEv($19);
      var $21=(($16+1560)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      __ZN13resource_pool6removeEPv($20, $23);
      var $24=(($16+1560)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=$10;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $27
      var $28=(($16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=__ZNK8device_t7machineEv($29);
      var $31=__ZN15running_machine7respoolEv($30);
      var $32=$4;
      var $33=$5;
      var $34=$6;
      var $35=$result_i;
      var $36=$7;
      var $37=$8;
      HEAP32[(($4)>>2)]=344;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($6)>>2)]=2731;
      var $38=HEAP32[(($4)>>2)];
      var $39=HEAP32[(($5)>>2)];
      var $40=HEAP32[(($6)>>2)];
      var $41=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38, $39, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $42
      HEAP32[(($result_i)>>2)]=$41;
      var $43=HEAP32[(($result_i)>>2)];
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $45
      var $46=___cxa_allocate_exception(4);
      var $47=$46;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($47);
      (function() { try { __THREW__ = false; return ___cxa_throw($46, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      HEAP32[(($7)>>2)]=$50;
      var $51=$49.f1;
      HEAP32[(($8)>>2)]=$51;
      var $52=HEAP32[(($8)>>2)];
      var $53=(($52)|0) < 0;
      if ($53) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $54
      var $55=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($55);
      throw "Reached an unreachable!"
    case 6: // $56
      var $57=HEAP32[(($7)>>2)];
      var $58=HEAP32[(($7)>>2)];
      var $59=HEAP32[(($8)>>2)];
      var $60=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $58, tempValue);
      var $61=($60.f1 = $59, $60);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $62
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $63=HEAP32[(($result_i)>>2)];
      var $64=$4;
      var $65=$5;
      var $66=$6;
      var $67=$result_i;
      var $68=$7;
      var $69=$8;
      var $70=$63;
      var $71=$10;
      var $72=$11;
      var $73=(($72) & 1);
      var $74=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debug6tracerC1ERS_R7__sFILEbPKc]($70, $16, $71, $73, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $75
      var $76=__ZN13resource_pool10add_objectIN12device_debug6tracerEEEPT_S4_($31, $70);
      var $77=(($16+1560)|0);
      HEAP32[(($77)>>2)]=$76;
      __label__ = 15; break;
    case 10: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $80=$79.f0;
      $13=$80;
      var $81=$79.f1;
      $14=$81;
      var $82=$1;
      var $83=$2;
      var $84=$3;
      HEAP32[(($1)>>2)]=$63;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2488)|0);
      HEAP32[(($3)>>2)]=2731;
      var $85=HEAP32[(($1)>>2)];
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $87
      var $88=HEAP32[(($1)>>2)];
      var $89=HEAP32[(($2)>>2)];
      var $90=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($88, $89, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $91=$1;
      var $92=$2;
      var $93=$3;
      __label__ = 14; break;
    case 14: // $94
      __label__ = 16; break;
    case 15: // $95
      STACKTOP = __stackBase__;
      return;
    case 16: // $96
      var $97=$13;
      var $98=$13;
      var $99=$14;
      var $100=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $98, tempValue);
      var $101=($100.f1 = $99, $100);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug5traceEP7__sFILEbPKc["X"]=1;

function __ZN13resource_pool10add_objectIN12device_debug6tracerEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug6tracerEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12device_debug6tracerEEEPT_S4_["X"]=1;
// WARNING: content after a branch in a label, line: 283548

function __ZNK13address_space4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12symbol_table9globalrefEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13address_space9log_unmapEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+49)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN13address_space13set_log_unmapEb($this, $log) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($log)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  var $7=(($4+49)|0);
  var $8=(($6)&1);
  HEAP8[($7)]=$8;
  ;
  return;
}


function __ZN11simple_listIN12device_debug12dasm_commentEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12device_debug12dasm_commentEE6detachERS1_["X"]=1;

function __ZN12device_debug10watchpoint3hitEiji($this, $type, $address, $size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $2=$this;
      $3=$type;
      $4=$address;
      $5=$size;
      var $10=$2;
      var $11=(($10+12)|0);
      var $12=HEAP8[($11)];
      var $13=(($12) & 1);
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      $1=0;
      __label__ = 14; break;
    case 2: // $15
      var $16=(($10+13)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$3;
      var $20=$18 & $19;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      $1=0;
      __label__ = 14; break;
    case 4: // $23
      var $24=$4;
      var $25=$5;
      var $26=(($24+$25)|0);
      var $27=(($10+16)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=(($26)>>>0) <= (($28)>>>0);
      if ($29) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $30
      var $31=$4;
      var $32=(($10+16)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($10+20)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($33+$35)|0);
      var $37=(($31)>>>0) >= (($36)>>>0);
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      $1=0;
      __label__ = 14; break;
    case 7: // $39
      var $40=(($10+24)|0);
      var $41=__ZNK17parsed_expression8is_emptyEv($40);
      if ($41) { __label__ = 13; break; } else { __label__ = 8; break; }
    case 8: // $42
      var $43=(($10+24)|0);
      var $44=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; };
      var $44$0=$44[0];
      var $44$1=$44[1];
    case 9: // $45
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $46=$44$0 != $$emscripten$temp$0$0 || $44$1 != $$emscripten$temp$0$1;
      $1=$46;
      __label__ = 14; break;
    case 10: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $49=$48.f0;
      $6=$49;
      var $50=$48.f1;
      $7=$50;
      __label__ = 11; break;
    case 11: // $51
      var $52=$7;
      var $53=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $54=(($52)|0)==(($53)|0);
      if ($54) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $55
      var $56=$6;
      var $57=___cxa_begin_catch($56);
      var $58=$57;
      $8=$58;
      $1=0;
      $9=1;
      ___cxa_end_catch();
      __label__ = 14; break;
    case 13: // $60
      $1=1;
      __label__ = 14; break;
    case 14: // $61
      var $62=$1;
      ;
      return $62;
    case 15: // $63
      var $64=$6;
      var $65=$6;
      var $66=$7;
      var $67=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $65, tempValue);
      var $68=($67.f1 = $66, $67);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug10watchpoint3hitEiji["X"]=1;

function __ZN22device_state_interface2pcEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZN22device_state_interface5stateEi($2, -1);
  var $3$0=$3[0];
  var $3$1=$3[1];
  var $4$0=$3$0;
  var $4=$4$0;
  ;
  return $4;
}


function __ZNK13address_space15byte_to_addressEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK20address_space_config9byte2addrEj($5, $6);
  ;
  return $7;
}


function __ZNK12device_debug16max_opcode_bytesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+16)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK23device_disasm_interface16max_opcode_bytesEv($8);
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 1;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring6expandEi($this, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$length;
  var $3=$1;
  var $4=$2;
  __Z14astring_expandP7astringi($3, $4);
  ;
  return $3;
}


function __ZN17parsed_expressionD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN17parsed_expressionD2Ev($2);
  ;
  return;
}


function __ZNK17parsed_expression8is_emptyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  var $4=__ZNK11simple_listIN17parsed_expression11parse_tokenEE5countEv($3);
  var $5=(($4)|0)==0;
  ;
  return $5;
}


function __ZN17parsed_expression7executeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZN17parsed_expression14execute_tokensEv($2);
  var $3$0=$3[0];
  var $3$1=$3[1];
  ;
  return [$3$0,$3$1];
}


function __ZN12device_debug6tracerC2ERS_R7__sFILEbPKc($this, $debug, $file, $trace_over, $action) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$debug;
      $3=$file;
      var $6=(($trace_over)&1);
      $4=$6;
      $5=$action;
      var $7=$1;
      var $8=(($7)|0);
      var $9=$2;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($7+4)|0);
      var $11=$3;
      HEAP32[(($10)>>2)]=$11;
      var $12=(($7+8)|0);
      var $13=$5;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$5;
      var $19 = $16;__label__ = 3; break;
    case 2: // $17
      var $19 = ((__str202508)|0);__label__ = 3; break;
    case 3: // $18
      var $19;
      __ZN7astringC1EPKc($12, $19);
      var $20=(($7+328)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($7+332)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($7+336)|0);
      var $23=$4;
      var $24=(($23) & 1);
      var $25=(($24)&1);
      HEAP8[($22)]=$25;
      var $26=(($7+340)|0);
      HEAP32[(($26)>>2)]=-1;
      var $27=(($7+72)|0);
      var $28=(($27)|0);
      var $29=$28;
      _memset($29, 0, 256, 1);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12device_debug12logaddrcharsE16address_spacenum($this, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$spacenum;
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($3+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$2;
      var $11=__ZNK23device_memory_interface5spaceE16address_spacenum($9, $10);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=(($3+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=__ZNK23device_memory_interface5spaceE16address_spacenum($15, $16);
      var $18=__ZNK13address_space12logaddrcharsEv($17);
      var $19=(($18)&255);
      var $22 = $19;__label__ = 4; break;
    case 3: // $20
      var $22 = 8;__label__ = 4; break;
    case 4: // $21
      var $22;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12device_debug6tracer5flushEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=_fflush($4);
  ;
  return;
}


function __ZN12device_debug12dasm_commentC2EPKcjjj($this, $text, $address, $color, $crc) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$text;
  $3=$address;
  $4=$color;
  $5=$crc;
  var $6=$1;
  var $7=(($6)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($6+4)|0);
  var $9=$3;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($6+8)|0);
  var $11=$4;
  HEAP32[(($10)>>2)]=$11;
  var $12=(($6+12)|0);
  var $13=$5;
  HEAP32[(($12)>>2)]=$13;
  var $14=(($6+16)|0);
  var $15=$2;
  __ZN7astringC1EPKc($14, $15);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug6tracerEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12device_debug6tracerEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug6tracerEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 344);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12device_debug6tracerEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug6tracerEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12device_debug6tracerEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug12dasm_commentEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12device_debug12dasm_commentEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug12dasm_commentEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 80);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12device_debug12dasm_commentEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN12device_debug10breakpointC2ER12symbol_tableijPKcS4_($this, $symbols, $index, $address, $condition, $action) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      $1=$this;
      $2=$symbols;
      $3=$index;
      $4=$address;
      $5=$condition;
      $6=$action;
      var $9=$1;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($9+4)|0);
      var $12=$3;
      HEAP32[(($11)>>2)]=$12;
      var $13=(($9+8)|0);
      HEAP8[($13)]=1;
      var $14=(($9+12)|0);
      var $15=$4;
      HEAP32[(($14)>>2)]=$15;
      var $16=(($9+16)|0);
      var $17=$2;
      var $18=$5;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$5;
      var $24 = $21;__label__ = 3; break;
    case 2: // $22
      var $24 = ((STRING_TABLE.__str562544)|0);__label__ = 3; break;
    case 3: // $23
      var $24;
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($16, $17, $24, 0);
      var $25=(($9+640)|0);
      var $26=$6;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$6;
      var $32 = $29;__label__ = 6; break;
    case 5: // $30
      var $32 = ((__str202508)|0);__label__ = 6; break;
    case 6: // $31
      var $32;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($25, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      ;
      return;
    case 8: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $7=$36;
      var $37=$35.f1;
      $8=$37;
      var $38=(($9+16)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $39
      __label__ = 10; break;
    case 10: // $40
      var $41=$7;
      var $42=$7;
      var $43=$8;
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug10breakpointC2ER12symbol_tableijPKcS4_["X"]=1;

function __ZN12device_debug10watchpointC2ER12symbol_tableiR13address_spaceijjPKcS6_($this, $symbols, $index, $space, $type, $address, $length, $condition, $action) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $1=$this;
      $2=$symbols;
      $3=$index;
      $4=$space;
      $5=$type;
      $6=$address;
      $7=$length;
      $8=$condition;
      $9=$action;
      var $12=$1;
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($12+4)|0);
      var $15=$4;
      HEAP32[(($14)>>2)]=$15;
      var $16=(($12+8)|0);
      var $17=$3;
      HEAP32[(($16)>>2)]=$17;
      var $18=(($12+12)|0);
      HEAP8[($18)]=1;
      var $19=(($12+13)|0);
      var $20=$5;
      var $21=(($20) & 255);
      HEAP8[($19)]=$21;
      var $22=(($12+16)|0);
      var $23=$4;
      var $24=$6;
      var $25=__ZNK13address_space15address_to_byteEj($23, $24);
      var $26=$4;
      var $27=__ZNK13address_space8bytemaskEv($26);
      var $28=$25 & $27;
      HEAP32[(($22)>>2)]=$28;
      var $29=(($12+20)|0);
      var $30=$4;
      var $31=$7;
      var $32=__ZNK13address_space15address_to_byteEj($30, $31);
      HEAP32[(($29)>>2)]=$32;
      var $33=(($12+24)|0);
      var $34=$2;
      var $35=$8;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $37
      var $38=$8;
      var $41 = $38;__label__ = 3; break;
    case 2: // $39
      var $41 = ((STRING_TABLE.__str562544)|0);__label__ = 3; break;
    case 3: // $40
      var $41;
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($33, $34, $41, 0);
      var $42=(($12+648)|0);
      var $43=$9;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $45
      var $46=$9;
      var $49 = $46;__label__ = 6; break;
    case 5: // $47
      var $49 = ((__str202508)|0);__label__ = 6; break;
    case 6: // $48
      var $49;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($42, $49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $50
      ;
      return;
    case 8: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=(($12+24)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $56
      __label__ = 10; break;
    case 10: // $57
      var $58=$10;
      var $59=$10;
      var $60=$11;
      var $61=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $59, tempValue);
      var $62=($61.f1 = $60, $61);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12device_debug10watchpointC2ER12symbol_tableiR13address_spaceijjPKcS6_["X"]=1;

function __ZN12device_debug6tracerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(function() { try { __THREW__ = false; return _fclose($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $8
      var $9=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($9);
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$2;
      var $19=$3;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN12device_debug6tracerEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug6tracerEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug6tracerEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12device_debug6tracerEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12device_debug6tracerEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12device_debug6tracerD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug6tracerEED2Ev["X"]=1;

function __ZN20resource_pool_objectIN12device_debug12dasm_commentEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12device_debug12dasm_commentEED2Ev($2);
  ;
  return;
}


function __ZN12device_debug12dasm_commentD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12device_debug12dasm_commentD2Ev($2);
  ;
  return;
}


function __ZN12device_debug12dasm_commentD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<4))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIN12device_debug13hotspot_entryEE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10watchpointEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12device_debug10watchpointEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10watchpointEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 712);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12device_debug10watchpointEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10watchpointEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12device_debug10watchpointEED2Ev($2);
  ;
  return;
}


function __ZN12device_debug10watchpointD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12device_debug10watchpointD2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10breakpointEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12device_debug10breakpointEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10breakpointEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 704);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12device_debug10breakpointEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10breakpointEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12device_debug10breakpointEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug12dasm_commentEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug12dasm_commentEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug12dasm_commentEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12device_debug12dasm_commentEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12device_debug12dasm_commentEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12device_debug12dasm_commentD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug12dasm_commentEED2Ev["X"]=1;

function __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIN12device_debug13hotspot_entryEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN12device_debug10watchpointEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug10watchpointEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug10watchpointEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12device_debug10watchpointEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12device_debug10watchpointEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12device_debug10watchpointD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug10watchpointEED2Ev["X"]=1;

function __ZN12device_debug10watchpointD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+648)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+24)|0);
      __ZN17parsed_expressionD1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+24)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN12device_debug10breakpointEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12device_debug10breakpointEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug10breakpointEED0Ev["X"]=1;

function __ZN11simple_listIN12device_debug12dasm_commentEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN12device_debug12dasm_commentEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK13address_space12logaddrcharsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+61)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZNK11simple_listIN17parsed_expression11parse_tokenEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12device_debug10breakpointD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12device_debug10breakpointD2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN12device_debug12dasm_commentEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN12device_debug12dasm_commentEE+8)|0);
  __ZN11simple_listIN12device_debug12dasm_commentEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN12device_debug12dasm_commentEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN12device_debug12dasm_commentEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13screen_devicebEEC2I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I15running_machineEEN15delegate_traitsIT_vS1_bS2_S2_E20static_ref_func_typeEPKcPS7_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I15running_machineEEN15delegate_traitsIT_vS1_bS2_S2_E20static_ref_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=224;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI15running_machine, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI12symbol_tableEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12symbol_tableEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12symbol_tableEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 432);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12symbol_tableE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12symbol_tableED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12symbol_tableED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI17_debugcpu_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17_debugcpu_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17_debugcpu_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 148);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17_debugcpu_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17_debugcpu_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17_debugcpu_privateED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12device_debug10breakpointEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12device_debug10breakpointEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12device_debug10breakpointD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12device_debug10breakpointEED2Ev["X"]=1;

function __ZN12device_debug10breakpointD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+640)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+16)|0);
      __ZN17parsed_expressionD1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+16)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12device_debug12dasm_commentEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12device_debug12dasm_commentEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12device_debug12dasm_commentEED0Ev["X"]=1;

function __ZN20resource_pool_objectI12symbol_tableED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12symbol_tableED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12symbol_tableED0Ev["X"]=1;

function __ZN20resource_pool_objectI12symbol_tableED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12symbol_tableE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12symbol_tableED2Ev["X"]=1;

function __ZN20resource_pool_objectI17_debugcpu_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17_debugcpu_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17_debugcpu_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI17_debugcpu_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI17_debugcpu_privateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN17parsed_expression11parse_tokenEE6detachERS1_["X"]=1;

function __ZN11simple_listIN17parsed_expression17expression_stringEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN17parsed_expression17expression_stringEE6detachERS1_["X"]=1;

function __ZNK20address_space_config9byte2addrEj($this, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$address;
      var $3=$1;
      var $4=(($3+10)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($3+10)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=$9 << $12;
      var $22 = $13;__label__ = 3; break;
    case 2: // $14
      var $15=$2;
      var $16=(($3+10)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(((-$18))|0);
      var $20=$15 >>> (($19)>>>0);
      var $22 = $20;__label__ = 3; break;
    case 3: // $21
      var $22;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK7astringcvbEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5)|0);
  var $7=HEAP8[($6)];
  var $8=(($7 << 24) >> 24);
  var $9=(($8)|0)!=0;
  ;
  return $9;
}


function __ZN12device_debug20reset_transient_flagEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4 & -15841;
  HEAP32[(($3)>>2)]=$5;
  ;
  return;
}


function __ZN11simple_listI12symbol_entryE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12symbol_entryE6detachERS0_["X"]=1;

function __ZN11simple_listIN17parsed_expression17expression_stringEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN17parsed_expression17expression_stringEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN17parsed_expression11parse_tokenEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN17parsed_expression11parse_tokenEE+8)|0);
  __ZN11simple_listIN17parsed_expression11parse_tokenEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN17parsed_expression11parse_tokenEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN17parsed_expression11parse_tokenEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression17expression_stringEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN17parsed_expression17expression_stringEE+8)|0);
  __ZN11simple_listIN17parsed_expression17expression_stringEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression17expression_stringEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN17parsed_expression17expression_stringEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17parsed_expression17expression_stringEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN17parsed_expression17expression_stringEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN12symbol_tableD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  __ZN11tagged_listI12symbol_entryED1Ev($3);
  ;
  return;
}


function __ZN11tagged_listI12symbol_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11tagged_listI12symbol_entryED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP12symbol_entryED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI12symbol_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI12symbol_entryED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI12symbol_entryED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI12symbol_entryE+8)|0);
  __ZN11simple_listI12symbol_entryE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI12symbol_entryE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI12symbol_entryE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12symbol_entryE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI12symbol_entryE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP12symbol_entryE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZNK11tagged_listI12symbol_entryE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  var $6=__ZNK8tagmap_tIP12symbol_entryE14find_hash_onlyEPKc($4, $5);
  ;
  return $6;
}


function __ZNK8tagmap_tIP12symbol_entryE14find_hash_onlyEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL21tagmap_find_hash_onlyPK7_tagmapPKc2553($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZN17parsed_expressionD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+88)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression17expression_stringEED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($4+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($4+4)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($9);
      ;
      return;
    case 3: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=(($4+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      __label__ = 6; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=(($4+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $22
      __label__ = 8; break;
    case 8: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN17parsed_expression11parse_tokenEED0Ev["X"]=1;

function __ZN11simple_listIN17parsed_expression17expression_stringEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression17expression_stringEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN17parsed_expression17expression_stringEED0Ev["X"]=1;

function __ZN11tagged_listI12symbol_entryED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP12symbol_entryED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4)|0);
      __ZN11simple_listI12symbol_entryED1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12symbol_entryED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12symbol_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI12symbol_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12symbol_entryED0Ev["X"]=1;

function __ZL11tagmap_hashPKc2554($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI18device_state_entryE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device12frame_numberEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+548)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZNK23device_memory_interface5spaceEi($this, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$index;
  var $3=$1;
  var $4=$2;
  var $5=(($3+28)|0);
  var $6=(($5+($4<<2))|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __ZNK13memory_region10endiannessEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13memory_region5widthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZL21tagmap_find_hash_onlyPK7_tagmapPKc2553($map, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fullhash;
      var $entry;
      $2=$map;
      $3=$tag;
      var $4=$3;
      var $5=__ZL11tagmap_hashPKc2554($4);
      $fullhash=$5;
      var $6=$fullhash;
      var $7=(($6)>>>0)%97;
      var $8=$2;
      var $9=(($8)|0);
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $entry=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$entry;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $15
      var $16=$entry;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$fullhash;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$entry;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      $1=$24;
      __label__ = 7; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$entry;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $entry=$29;
      __label__ = 1; break;
    case 6: // $30
      $1=0;
      __label__ = 7; break;
    case 7: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceERP24device_execute_interface($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI24device_execute_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZNK8device_t4nextI24device_execute_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceERP24device_execute_interface($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21expression_get_deviceR15running_machinePKc($machine, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      $2=$machine;
      $3=$tag;
      var $4=$2;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=$5;
      var $7=__ZNK11tagged_listI8device_tE5firstEv($6);
      $device=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$device;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$device;
      var $13=__ZNK8device_t3tagEv($12);
      var $14=$3;
      var $15=__Z12core_stricmpPKcS0_($13, $14);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$device;
      $1=$18;
      __label__ = 7; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$device;
      var $22=__ZNK8device_t4nextEv($21);
      $device=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=0;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL31expression_write_program_directP13address_spaceijiy($_space, $opcode, $address, $size, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $space;
      var $global;
      var $base;
      var $halfsize;
      var $r0=__stackBase__+8;
      var $r1=__stackBase__+16;
      var $halfmask=__stackBase__+24;
      var $lowmask;
      $1=$_space;
      $2=$opcode;
      $3=$address;
      $4=$size;
      var $st$17$0=(($5)|0);
      HEAP32[(($st$17$0)>>2)]=$data$0;
      var $st$17$1=(($5+4)|0);
      HEAP32[(($st$17$1)>>2)]=$data$1;
      var $6=$1;
      $space=$6;
      var $7=$space;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 18; break; }
    case 1: // $9
      var $10=$space;
      var $11=__ZNK13address_space7machineEv($10);
      var $12=(($11+652)|0);
      var $13=HEAP32[(($12)>>2)];
      $global=$13;
      var $14=$2;
      var $15=$14 & 2;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$space;
      var $19=$3;
      var $20=__ZNK13address_space15address_to_byteEj($18, $19);
      $3=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$4;
      var $23=(($22)|0) > 1;
      if ($23) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $24
      var $25=$4;
      var $26=(((($25)|0)/2)|0);
      $halfsize=$26;
      var $27=$halfsize;
      var $28=((($27<<3))|0);
      var $29=((64-$28)|0);
      var $30$0=$29;
      var $30$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $31=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$30$0);var $31$0 = $31[0], $31$1 = $31[1];
      var $st$11$0=(($halfmask)|0);
      HEAP32[(($st$11$0)>>2)]=$31$0;
      var $st$11$1=(($halfmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$31$1;
      var $32=$space;
      var $33=__ZNK13address_space10endiannessEv($32);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $35
      var $st$0$0=(($5)|0);
      var $36$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $36$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($halfmask)|0);
      var $37$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($halfmask+4)|0);
      var $37$1=HEAP32[(($st$4$1)>>2)];
      var $38$0=$36$0 & $37$0;
      var $38$1=$36$1 & $37$1;
      var $st$10$0=(($r0)|0);
      HEAP32[(($st$10$0)>>2)]=$38$0;
      var $st$10$1=(($r0+4)|0);
      HEAP32[(($st$10$1)>>2)]=$38$1;
      var $st$14$0=(($5)|0);
      var $39$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($5+4)|0);
      var $39$1=HEAP32[(($st$14$1)>>2)];
      var $40=$halfsize;
      var $41=((($40<<3))|0);
      var $42$0=$41;
      var $42$1=0;
      var $43=Runtime.bitshift64($39$0, $39$1,"lshr",$42$0);var $43$0 = $43[0], $43$1 = $43[1];
      var $st$23$0=(($halfmask)|0);
      var $44$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($halfmask+4)|0);
      var $44$1=HEAP32[(($st$23$1)>>2)];
      var $45$0=$43$0 & $44$0;
      var $45$1=$43$1 & $44$1;
      var $st$29$0=(($r1)|0);
      HEAP32[(($st$29$0)>>2)]=$45$0;
      var $st$29$1=(($r1+4)|0);
      HEAP32[(($st$29$1)>>2)]=$45$1;
      __label__ = 7; break;
    case 6: // $46
      var $st$0$0=(($5)|0);
      var $47$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $47$1=HEAP32[(($st$0$1)>>2)];
      var $48=$halfsize;
      var $49=((($48<<3))|0);
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($47$0, $47$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$9$0=(($halfmask)|0);
      var $52$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($halfmask+4)|0);
      var $52$1=HEAP32[(($st$9$1)>>2)];
      var $53$0=$51$0 & $52$0;
      var $53$1=$51$1 & $52$1;
      var $st$15$0=(($r0)|0);
      HEAP32[(($st$15$0)>>2)]=$53$0;
      var $st$15$1=(($r0+4)|0);
      HEAP32[(($st$15$1)>>2)]=$53$1;
      var $st$19$0=(($5)|0);
      var $54$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($5+4)|0);
      var $54$1=HEAP32[(($st$19$1)>>2)];
      var $st$23$0=(($halfmask)|0);
      var $55$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($halfmask+4)|0);
      var $55$1=HEAP32[(($st$23$1)>>2)];
      var $56$0=$54$0 & $55$0;
      var $56$1=$54$1 & $55$1;
      var $st$29$0=(($r1)|0);
      HEAP32[(($st$29$0)>>2)]=$56$0;
      var $st$29$1=(($r1+4)|0);
      HEAP32[(($st$29$1)>>2)]=$56$1;
      __label__ = 7; break;
    case 7: // $57
      var $58=$space;
      var $59=$2;
      var $60=$59 | 2;
      var $61=$3;
      var $62=(($61)|0);
      var $63=$halfsize;
      var $st$6$0=(($r0)|0);
      var $64$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($r0+4)|0);
      var $64$1=HEAP32[(($st$6$1)>>2)];
      __ZL31expression_write_program_directP13address_spaceijiy($58, $60, $62, $63, $64$0, $64$1);
      var $65=$space;
      var $66=$2;
      var $67=$66 | 2;
      var $68=$3;
      var $69=$halfsize;
      var $70=(($68+$69)|0);
      var $71=$halfsize;
      var $st$18$0=(($r1)|0);
      var $72$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($r1+4)|0);
      var $72$1=HEAP32[(($st$18$1)>>2)];
      __ZL31expression_write_program_directP13address_spaceijiy($65, $67, $70, $71, $72$0, $72$1);
      __label__ = 17; break;
    case 8: // $73
      var $74=$space;
      var $75=__ZNK13address_space10data_widthEv($74);
      var $76=(((($75)|0)/8)|0);
      var $77=(($76-1)|0);
      $lowmask=$77;
      var $78=$2;
      var $79=$78 & 1;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $81
      var $82=$space;
      var $83=__ZNK13address_space6directEv($82);
      var $84=$3;
      var $85=$lowmask;
      var $86=$85 ^ -1;
      var $87=$84 & $86;
      var $88=__ZN16direct_read_data18read_decrypted_ptrEjj($83, $87, 0);
      $base=$88;
      __label__ = 11; break;
    case 10: // $89
      var $90=$space;
      var $91=$90;
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92+20)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$3;
      var $96=$lowmask;
      var $97=$96 ^ -1;
      var $98=$95 & $97;
      var $99=FUNCTION_TABLE[$94]($90, $98);
      $base=$99;
      __label__ = 11; break;
    case 11: // $100
      var $101=$base;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $103
      var $104=$space;
      var $105=__ZNK13address_space10endiannessEv($104);
      var $106=(($105)|0)==0;
      if ($106) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $107
      var $st$0$0=(($5)|0);
      var $108$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $108$1=HEAP32[(($st$0$1)>>2)];
      var $109$0=$108$0;
      var $109=$109$0&255;
      var $110=$3;
      var $111=$110 ^ 0;
      var $112=$lowmask;
      var $113=$111 & $112;
      var $114=$base;
      var $115=(($114+$113)|0);
      HEAP8[($115)]=$109;
      __label__ = 15; break;
    case 14: // $116
      var $st$0$0=(($5)|0);
      var $117$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $117$1=HEAP32[(($st$0$1)>>2)];
      var $118$0=$117$0;
      var $118=$118$0&255;
      var $119=$3;
      var $120=$119 ^ 7;
      var $121=$lowmask;
      var $122=$120 & $121;
      var $123=$base;
      var $124=(($123+$122)|0);
      HEAP8[($124)]=$118;
      __label__ = 15; break;
    case 15: // $125
      var $126=$global;
      var $127=(($126+22)|0);
      HEAP8[($127)]=1;
      __label__ = 16; break;
    case 16: // $128
      __label__ = 17; break;
    case 17: // $129
      __label__ = 18; break;
    case 18: // $130
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL31expression_write_program_directP13address_spaceijiy["X"]=1;

function __ZL30expression_write_memory_regionR15running_machinePKcjiy($machine, $rgntag, $address, $size, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $global;
      var $region;
      var $halfsize;
      var $r0=__stackBase__+8;
      var $r1=__stackBase__+16;
      var $halfmask=__stackBase__+24;
      var $lowmask;
      var $base;
      $1=$machine;
      $2=$rgntag;
      $3=$address;
      $4=$size;
      var $st$17$0=(($5)|0);
      HEAP32[(($st$17$0)>>2)]=$data$0;
      var $st$17$1=(($5+4)|0);
      HEAP32[(($st$17$1)>>2)]=$data$1;
      var $6=$1;
      var $7=(($6+652)|0);
      var $8=HEAP32[(($7)>>2)];
      $global=$8;
      var $9=$1;
      var $10=$2;
      var $11=__ZN15running_machine6regionEPKc($9, $10);
      $region=$11;
      var $12=$region;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $14
      var $15=$4;
      var $16=(($15)|0) > 1;
      if ($16) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $17
      var $18=$4;
      var $19=(((($18)|0)/2)|0);
      $halfsize=$19;
      var $20=$halfsize;
      var $21=((($20<<3))|0);
      var $22=((64-$21)|0);
      var $23$0=$22;
      var $23$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $24=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      var $st$11$0=(($halfmask)|0);
      HEAP32[(($st$11$0)>>2)]=$24$0;
      var $st$11$1=(($halfmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$24$1;
      var $25=$region;
      var $26=__ZNK13memory_region10endiannessEv($25);
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $st$0$0=(($5)|0);
      var $29$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $29$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($halfmask)|0);
      var $30$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($halfmask+4)|0);
      var $30$1=HEAP32[(($st$4$1)>>2)];
      var $31$0=$29$0 & $30$0;
      var $31$1=$29$1 & $30$1;
      var $st$10$0=(($r0)|0);
      HEAP32[(($st$10$0)>>2)]=$31$0;
      var $st$10$1=(($r0+4)|0);
      HEAP32[(($st$10$1)>>2)]=$31$1;
      var $st$14$0=(($5)|0);
      var $32$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($5+4)|0);
      var $32$1=HEAP32[(($st$14$1)>>2)];
      var $33=$halfsize;
      var $34=((($33<<3))|0);
      var $35$0=$34;
      var $35$1=0;
      var $36=Runtime.bitshift64($32$0, $32$1,"lshr",$35$0);var $36$0 = $36[0], $36$1 = $36[1];
      var $st$23$0=(($halfmask)|0);
      var $37$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($halfmask+4)|0);
      var $37$1=HEAP32[(($st$23$1)>>2)];
      var $38$0=$36$0 & $37$0;
      var $38$1=$36$1 & $37$1;
      var $st$29$0=(($r1)|0);
      HEAP32[(($st$29$0)>>2)]=$38$0;
      var $st$29$1=(($r1+4)|0);
      HEAP32[(($st$29$1)>>2)]=$38$1;
      __label__ = 5; break;
    case 4: // $39
      var $st$0$0=(($5)|0);
      var $40$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $40$1=HEAP32[(($st$0$1)>>2)];
      var $41=$halfsize;
      var $42=((($41<<3))|0);
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($40$0, $40$1,"lshr",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $st$9$0=(($halfmask)|0);
      var $45$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($halfmask+4)|0);
      var $45$1=HEAP32[(($st$9$1)>>2)];
      var $46$0=$44$0 & $45$0;
      var $46$1=$44$1 & $45$1;
      var $st$15$0=(($r0)|0);
      HEAP32[(($st$15$0)>>2)]=$46$0;
      var $st$15$1=(($r0+4)|0);
      HEAP32[(($st$15$1)>>2)]=$46$1;
      var $st$19$0=(($5)|0);
      var $47$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($5+4)|0);
      var $47$1=HEAP32[(($st$19$1)>>2)];
      var $st$23$0=(($halfmask)|0);
      var $48$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($halfmask+4)|0);
      var $48$1=HEAP32[(($st$23$1)>>2)];
      var $49$0=$47$0 & $48$0;
      var $49$1=$47$1 & $48$1;
      var $st$29$0=(($r1)|0);
      HEAP32[(($st$29$0)>>2)]=$49$0;
      var $st$29$1=(($r1+4)|0);
      HEAP32[(($st$29$1)>>2)]=$49$1;
      __label__ = 5; break;
    case 5: // $50
      var $51=$1;
      var $52=$2;
      var $53=$3;
      var $54=(($53)|0);
      var $55=$halfsize;
      var $st$5$0=(($r0)|0);
      var $56$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($r0+4)|0);
      var $56$1=HEAP32[(($st$5$1)>>2)];
      __ZL30expression_write_memory_regionR15running_machinePKcjiy($51, $52, $54, $55, $56$0, $56$1);
      var $57=$1;
      var $58=$2;
      var $59=$3;
      var $60=$halfsize;
      var $61=(($59+$60)|0);
      var $62=$halfsize;
      var $st$16$0=(($r1)|0);
      var $63$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($r1+4)|0);
      var $63$1=HEAP32[(($st$16$1)>>2)];
      __ZL30expression_write_memory_regionR15running_machinePKcjiy($57, $58, $61, $62, $63$0, $63$1);
      __label__ = 12; break;
    case 6: // $64
      var $65=$3;
      var $66=$region;
      var $67=__ZNK13memory_region5bytesEv($66);
      var $68=(($65)>>>0) < (($67)>>>0);
      if ($68) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $69
      var $70=$region;
      var $71=__ZNK13memory_region5widthEv($70);
      var $72=(($71)&255);
      var $73=(($72-1)|0);
      $lowmask=$73;
      var $74=$region;
      var $75=__ZNK13memory_region4baseEv($74);
      var $76=$3;
      var $77=$lowmask;
      var $78=$77 ^ -1;
      var $79=$76 & $78;
      var $80=(($75+$79)|0);
      $base=$80;
      var $81=$region;
      var $82=__ZNK13memory_region10endiannessEv($81);
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $84
      var $st$0$0=(($5)|0);
      var $85$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $85$1=HEAP32[(($st$0$1)>>2)];
      var $86$0=$85$0;
      var $86=$86$0&255;
      var $87=$3;
      var $88=$87 ^ 0;
      var $89=$lowmask;
      var $90=$88 & $89;
      var $91=$base;
      var $92=(($91+$90)|0);
      HEAP8[($92)]=$86;
      __label__ = 10; break;
    case 9: // $93
      var $st$0$0=(($5)|0);
      var $94$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($5+4)|0);
      var $94$1=HEAP32[(($st$0$1)>>2)];
      var $95$0=$94$0;
      var $95=$95$0&255;
      var $96=$3;
      var $97=$96 ^ 7;
      var $98=$lowmask;
      var $99=$97 & $98;
      var $100=$base;
      var $101=(($100+$99)|0);
      HEAP8[($101)]=$95;
      __label__ = 10; break;
    case 10: // $102
      var $103=$global;
      var $104=(($103+22)|0);
      HEAP8[($104)]=1;
      __label__ = 11; break;
    case 11: // $105
      __label__ = 12; break;
    case 12: // $106
      __label__ = 13; break;
    case 13: // $107
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30expression_write_memory_regionR15running_machinePKcjiy["X"]=1;

function __ZN16direct_read_data18read_decrypted_ptrEjj($this, $byteaddress, $directxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$byteaddress;
      $4=$directxor;
      var $5=$2;
      var $6=$3;
      var $7=__ZN16direct_read_data16address_is_validEj($5, $6);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=$4;
      var $11=$9 ^ $10;
      var $12=(($5+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$11 & $13;
      var $15=(($5+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      $1=$17;
      __label__ = 3; break;
    case 2: // $18
      $1=0;
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL30expression_read_program_directP13address_spaceiji($_space, $opcode, $address, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $space;
      var $result=__stackBase__;
      var $base;
      var $halfsize;
      var $r0=__stackBase__+8;
      var $r1=__stackBase__+16;
      var $lowmask;
      $1=$_space;
      $2=$opcode;
      $3=$address;
      $4=$size;
      var $5=$1;
      $space=$5;
      var $6=$4;
      var $7=((($6<<3))|0);
      var $8=((64-$7)|0);
      var $9$0=$8;
      var $9$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $10=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$9$0);var $10$0 = $10[0], $10$1 = $10[1];
      var $st$25$0=(($result)|0);
      HEAP32[(($st$25$0)>>2)]=$10$0;
      var $st$25$1=(($result+4)|0);
      HEAP32[(($st$25$1)>>2)]=$10$1;
      var $11=$space;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 18; break; }
    case 1: // $13
      var $14=$2;
      var $15=$14 & 2;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$space;
      var $19=$3;
      var $20=__ZNK13address_space15address_to_byteEj($18, $19);
      $3=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$4;
      var $23=(($22)|0) > 1;
      if ($23) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $24
      var $25=$4;
      var $26=(((($25)|0)/2)|0);
      $halfsize=$26;
      var $27=$space;
      var $28=$2;
      var $29=$28 | 2;
      var $30=$3;
      var $31=(($30)|0);
      var $32=$halfsize;
      var $33=__ZL30expression_read_program_directP13address_spaceiji($27, $29, $31, $32);
      var $33$0=$33[0];
      var $33$1=$33[1];
      var $st$12$0=(($r0)|0);
      HEAP32[(($st$12$0)>>2)]=$33$0;
      var $st$12$1=(($r0+4)|0);
      HEAP32[(($st$12$1)>>2)]=$33$1;
      var $34=$space;
      var $35=$2;
      var $36=$35 | 2;
      var $37=$3;
      var $38=$halfsize;
      var $39=(($37+$38)|0);
      var $40=$halfsize;
      var $41=__ZL30expression_read_program_directP13address_spaceiji($34, $36, $39, $40);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $st$26$0=(($r1)|0);
      HEAP32[(($st$26$0)>>2)]=$41$0;
      var $st$26$1=(($r1+4)|0);
      HEAP32[(($st$26$1)>>2)]=$41$1;
      var $42=$space;
      var $43=__ZNK13address_space10endiannessEv($42);
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $st$0$0=(($r0)|0);
      var $46$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($r0+4)|0);
      var $46$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($r1)|0);
      var $47$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($r1+4)|0);
      var $47$1=HEAP32[(($st$4$1)>>2)];
      var $48=$halfsize;
      var $49=((($48<<3))|0);
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($47$0, $47$1,"shl",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $52$0=$46$0 | $51$0;
      var $52$1=$46$1 | $51$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$52$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$52$1;
      __label__ = 7; break;
    case 6: // $53
      var $st$0$0=(($r1)|0);
      var $54$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($r1+4)|0);
      var $54$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($r0)|0);
      var $55$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($r0+4)|0);
      var $55$1=HEAP32[(($st$4$1)>>2)];
      var $56=$halfsize;
      var $57=((($56<<3))|0);
      var $58$0=$57;
      var $58$1=0;
      var $59=Runtime.bitshift64($55$0, $55$1,"shl",$58$0);var $59$0 = $59[0], $59$1 = $59[1];
      var $60$0=$54$0 | $59$0;
      var $60$1=$54$1 | $59$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$60$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$60$1;
      __label__ = 7; break;
    case 7: // $61
      __label__ = 17; break;
    case 8: // $62
      var $63=$space;
      var $64=__ZNK13address_space10data_widthEv($63);
      var $65=(((($64)|0)/8)|0);
      var $66=(($65-1)|0);
      $lowmask=$66;
      var $67=$2;
      var $68=$67 & 1;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $70
      var $71=$space;
      var $72=__ZNK13address_space6directEv($71);
      var $73=$3;
      var $74=$lowmask;
      var $75=$74 ^ -1;
      var $76=$73 & $75;
      var $77=__ZN16direct_read_data18read_decrypted_ptrEjj($72, $76, 0);
      $base=$77;
      __label__ = 11; break;
    case 10: // $78
      var $79=$space;
      var $80=$79;
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+20)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$3;
      var $85=$lowmask;
      var $86=$85 ^ -1;
      var $87=$84 & $86;
      var $88=FUNCTION_TABLE[$83]($79, $87);
      $base=$88;
      __label__ = 11; break;
    case 11: // $89
      var $90=$base;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $92
      var $93=$space;
      var $94=__ZNK13address_space10endiannessEv($93);
      var $95=(($94)|0)==0;
      if ($95) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $96
      var $97=$3;
      var $98=$97 ^ 0;
      var $99=$lowmask;
      var $100=$98 & $99;
      var $101=$base;
      var $102=(($101+$100)|0);
      var $103=HEAP8[($102)];
      var $104$0=$103;
      var $104$1=0;
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$104$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$104$1;
      __label__ = 15; break;
    case 14: // $105
      var $106=$3;
      var $107=$106 ^ 7;
      var $108=$lowmask;
      var $109=$107 & $108;
      var $110=$base;
      var $111=(($110+$109)|0);
      var $112=HEAP8[($111)];
      var $113$0=$112;
      var $113$1=0;
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$113$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$113$1;
      __label__ = 15; break;
    case 15: // $114
      __label__ = 16; break;
    case 16: // $115
      __label__ = 17; break;
    case 17: // $116
      __label__ = 18; break;
    case 18: // $117
      var $st$0$0=(($result)|0);
      var $118$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $118$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$118$0,$118$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30expression_read_program_directP13address_spaceiji["X"]=1;

function __ZNK20address_space_config10data_widthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  ;
  return $5;
}


function __ZNK20address_space_config10endiannessEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN12device_debug12dasm_commentEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN12save_manager11state_entryEE4findEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$3;
      var $12=(($11-1)|0);
      $3=$12;
      var $13=(($11)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$cur;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$cur;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $cur=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN12save_manager14state_callbackEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIv8_noparamS0_S0_S0_E4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12save_manager14state_callback4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN12save_manager14state_callbackEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12save_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL29expression_read_memory_regionR15running_machinePKcji($machine, $rgntag, $address, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $region;
      var $result=__stackBase__;
      var $halfsize;
      var $r0=__stackBase__+8;
      var $r1=__stackBase__+16;
      var $lowmask;
      var $base;
      $1=$machine;
      $2=$rgntag;
      $3=$address;
      $4=$size;
      var $5=$1;
      var $6=$2;
      var $7=__ZN15running_machine6regionEPKc($5, $6);
      $region=$7;
      var $8=$4;
      var $9=((($8<<3))|0);
      var $10=((64-$9)|0);
      var $11$0=$10;
      var $11$1=0;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $12=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"lshr",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
      var $st$27$0=(($result)|0);
      HEAP32[(($st$27$0)>>2)]=$12$0;
      var $st$27$1=(($result+4)|0);
      HEAP32[(($st$27$1)>>2)]=$12$1;
      var $13=$region;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $15
      var $16=$4;
      var $17=(($16)|0) > 1;
      if ($17) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $18
      var $19=$4;
      var $20=(((($19)|0)/2)|0);
      $halfsize=$20;
      var $21=$1;
      var $22=$2;
      var $23=$3;
      var $24=(($23)|0);
      var $25=$halfsize;
      var $26=__ZL29expression_read_memory_regionR15running_machinePKcji($21, $22, $24, $25);
      var $26$0=$26[0];
      var $26$1=$26[1];
      var $st$11$0=(($r0)|0);
      HEAP32[(($st$11$0)>>2)]=$26$0;
      var $st$11$1=(($r0+4)|0);
      HEAP32[(($st$11$1)>>2)]=$26$1;
      var $27=$1;
      var $28=$2;
      var $29=$3;
      var $30=$halfsize;
      var $31=(($29+$30)|0);
      var $32=$halfsize;
      var $33=__ZL29expression_read_memory_regionR15running_machinePKcji($27, $28, $31, $32);
      var $33$0=$33[0];
      var $33$1=$33[1];
      var $st$24$0=(($r1)|0);
      HEAP32[(($st$24$0)>>2)]=$33$0;
      var $st$24$1=(($r1+4)|0);
      HEAP32[(($st$24$1)>>2)]=$33$1;
      var $34=$region;
      var $35=__ZNK13memory_region10endiannessEv($34);
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $37
      var $st$0$0=(($r0)|0);
      var $38$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($r0+4)|0);
      var $38$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($r1)|0);
      var $39$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($r1+4)|0);
      var $39$1=HEAP32[(($st$4$1)>>2)];
      var $40=$halfsize;
      var $41=((($40<<3))|0);
      var $42$0=$41;
      var $42$1=0;
      var $43=Runtime.bitshift64($39$0, $39$1,"shl",$42$0);var $43$0 = $43[0], $43$1 = $43[1];
      var $44$0=$38$0 | $43$0;
      var $44$1=$38$1 | $43$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$44$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$44$1;
      __label__ = 5; break;
    case 4: // $45
      var $st$0$0=(($r1)|0);
      var $46$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($r1+4)|0);
      var $46$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($r0)|0);
      var $47$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($r0+4)|0);
      var $47$1=HEAP32[(($st$4$1)>>2)];
      var $48=$halfsize;
      var $49=((($48<<3))|0);
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($47$0, $47$1,"shl",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $52$0=$46$0 | $51$0;
      var $52$1=$46$1 | $51$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$52$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$52$1;
      __label__ = 5; break;
    case 5: // $53
      __label__ = 12; break;
    case 6: // $54
      var $55=$3;
      var $56=$region;
      var $57=__ZNK13memory_region5bytesEv($56);
      var $58=(($55)>>>0) < (($57)>>>0);
      if ($58) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $59
      var $60=$region;
      var $61=__ZNK13memory_region5widthEv($60);
      var $62=(($61)&255);
      var $63=(($62-1)|0);
      $lowmask=$63;
      var $64=$region;
      var $65=__ZNK13memory_region4baseEv($64);
      var $66=$3;
      var $67=$lowmask;
      var $68=$67 ^ -1;
      var $69=$66 & $68;
      var $70=(($65+$69)|0);
      $base=$70;
      var $71=$region;
      var $72=__ZNK13memory_region10endiannessEv($71);
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $74
      var $75=$3;
      var $76=$75 ^ 0;
      var $77=$lowmask;
      var $78=$76 & $77;
      var $79=$base;
      var $80=(($79+$78)|0);
      var $81=HEAP8[($80)];
      var $82$0=$81;
      var $82$1=0;
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$82$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$82$1;
      __label__ = 10; break;
    case 9: // $83
      var $84=$3;
      var $85=$84 ^ 7;
      var $86=$lowmask;
      var $87=$85 & $86;
      var $88=$base;
      var $89=(($88+$87)|0);
      var $90=HEAP8[($89)];
      var $91$0=$90;
      var $91$1=0;
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$91$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$91$1;
      __label__ = 10; break;
    case 10: // $92
      __label__ = 11; break;
    case 11: // $93
      __label__ = 12; break;
    case 12: // $94
      __label__ = 13; break;
    case 13: // $95
      var $st$0$0=(($result)|0);
      var $96$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $96$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$96$0,$96$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29expression_read_memory_regionR15running_machinePKcji["X"]=1;

function __ZN11simple_listIN12save_manager11state_entryEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN12save_manager11state_entryEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN12save_manager14state_callbackEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN12save_manager14state_callbackEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN12save_manager14state_callbackEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN12save_manager14state_callbackEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN12save_manager11state_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN12save_manager11state_entryEED2Ev($2);
  ;
  return;
}


function __ZN12save_manager18allow_registrationEb($this, $allowed) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($allowed)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      var $7=(($4+4)|0);
      var $8=(($6)&1);
      HEAP8[($7)]=$8;
      var $9=$2;
      var $10=(($9) & 1);
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __ZNK12save_manager13dump_registryEv($4);
      __label__ = 2; break;
    case 2: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12save_manager13dump_registryEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $entry;
      $1=$this;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=__ZNK11simple_listIN12save_manager11state_entryEE5firstEv($3);
      $entry=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$entry;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      __label__ = 4; break;
    case 4: // $10
      __label__ = 5; break;
    case 5: // $11
      var $12=$entry;
      var $13=__ZNK12save_manager11state_entry4nextEv($12);
      $entry=$13;
      __label__ = 1; break;
    case 6: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12save_manager12indexed_itemEiRPvRjS2_($this, $index, $base, $valsize, $valcount) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $entry;
      $2=$this;
      $3=$index;
      $4=$base;
      $5=$valsize;
      $6=$valcount;
      var $7=$2;
      var $8=(($7+12)|0);
      var $9=$3;
      var $10=__ZNK11simple_listIN12save_manager11state_entryEE4findEi($8, $9);
      $entry=$10;
      var $11=$entry;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=0;
      __label__ = 3; break;
    case 2: // $14
      var $15=$entry;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$4;
      HEAP32[(($18)>>2)]=$17;
      var $19=$entry;
      var $20=(($19+72)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$5;
      HEAP32[(($23)>>2)]=$22;
      var $24=$entry;
      var $25=(($24+76)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$6;
      HEAP32[(($27)>>2)]=$26;
      var $28=$entry;
      var $29=(($28+8)|0);
      var $30=__ZNK7astringcvPKcEv($29);
      $1=$30;
      __label__ = 3; break;
    case 3: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13delegate_baseIv8_noparamS0_S0_S0_EeqERKS1_($this, $rhs) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$rhs;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { var $23 = 0;__label__ = 3; break; }
    case 1: // $10
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0)==(($15)|0);
      if ($16) { __label__ = 2; break; } else { var $23 = 0;__label__ = 3; break; }
    case 2: // $17
      var $18=(($3+12)|0);
      var $19=$2;
      var $20=(($19+12)|0);
      var $21=__ZNK21delegate_internal_mfpeqERKS_($18, $20);
      var $23 = $21;__label__ = 3; break;
    case 3: // $22
      var $23;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvvEEC1ERKS1_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvvEEC2ERKS1_($4, $5);
  ;
  return;
}


function __ZN12save_managerC2ER15running_machine($this, $machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$machine;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      HEAP32[(($6)>>2)]=$7;
      var $8=(($5+4)|0);
      HEAP8[($8)]=1;
      var $9=(($5+8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($5+12)|0);
      var $11=$2;
      var $12=__ZN15running_machine7respoolEv($11);
      __ZN11simple_listIN12save_manager11state_entryEEC1ER13resource_pool($10, $12);
      var $13=(($5+32)|0);
      var $14=$2;
      var $15=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $16
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEEC1ER13resource_pool($13, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=(($5+52)|0);
      var $19=$2;
      var $20=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $21
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEEC1ER13resource_pool($18, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $22
      ;
      return;
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $3=$25;
      var $26=$24.f1;
      $4=$26;
      __label__ = 8; break;
    case 6: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $3=$29;
      var $30=$28.f1;
      $4=$30;
      var $31=(($5+32)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEED1Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $32
      __label__ = 8; break;
    case 8: // $33
      var $34=(($5+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager11state_entryEED1Ev($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $35
      __label__ = 10; break;
    case 10: // $36
      var $37=$3;
      var $38=$3;
      var $39=$4;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_managerC2ER15running_machine["X"]=1;

function __ZN12save_manager16register_presaveE8delegateIFvvEE($this, $func) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $cb;
      var $10=__stackBase__+36;
      var $11;
      var $12;
      $9=$this;
      var $13=$9;
      var $14=(($13+4)|0);
      var $15=HEAP8[($14)];
      var $16=(($15) & 1);
      if ($16) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $17
      __Z10fatalerrorPKcz(((STRING_TABLE.__str2559)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $18
      var $19=(($13+32)|0);
      var $20=__ZNK11simple_listIN12save_manager14state_callbackEE5firstEv($19);
      $cb=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$cb;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $24
      var $25=$cb;
      var $26=(($25+4)|0);
      var $27=$26;
      var $28=$func;
      var $29=__ZNK13delegate_baseIv8_noparamS0_S0_S0_EeqERKS1_($27, $28);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$cb;
      var $32=(($31+4)|0);
      var $33=$32;
      var $34=__ZNK13delegate_baseIv8_noparamS0_S0_S0_E4nameEv($33);
      var $35=$func;
      var $36=__ZNK13delegate_baseIv8_noparamS0_S0_S0_E4nameEv($35);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str12560)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,HEAP32[((tempInt+4)>>2)]=$36,tempInt));
      throw "Reached an unreachable!"
    case 6: // $37
      __label__ = 7; break;
    case 7: // $38
      var $39=$cb;
      var $40=__ZNK12save_manager14state_callback4nextEv($39);
      $cb=$40;
      __label__ = 3; break;
    case 8: // $41
      var $42=(($13+32)|0);
      var $43=__ZNK12save_manager7machineEv($13);
      var $44=__ZN15running_machine7respoolEv($43);
      var $45=$4;
      var $46=$5;
      var $47=$6;
      var $48=$result_i;
      var $49=$7;
      var $50=$8;
      HEAP32[(($4)>>2)]=28;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22561)|0);
      HEAP32[(($6)>>2)]=159;
      var $51=HEAP32[(($4)>>2)];
      var $52=HEAP32[(($5)>>2)];
      var $53=HEAP32[(($6)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($51, $52, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $55
      HEAP32[(($result_i)>>2)]=$54;
      var $56=HEAP32[(($result_i)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $58
      var $59=___cxa_allocate_exception(4);
      var $60=$59;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($60);
      (function() { try { __THREW__ = false; return ___cxa_throw($59, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($7)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($8)>>2)]=$64;
      var $65=HEAP32[(($8)>>2)];
      var $66=(($65)|0) < 0;
      if ($66) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $67
      var $68=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($68);
      throw "Reached an unreachable!"
    case 13: // $69
      var $70=HEAP32[(($7)>>2)];
      var $71=HEAP32[(($7)>>2)];
      var $72=HEAP32[(($8)>>2)];
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $75
      throw "Reached an unreachable!"
    case 15: // $_ZnwjPKci_exit
      var $76=HEAP32[(($result_i)>>2)];
      var $77=$4;
      var $78=$5;
      var $79=$6;
      var $80=$result_i;
      var $81=$7;
      var $82=$8;
      var $83=$76;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1ERKS1_($10, $func) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $84
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12save_manager14state_callbackC1E8delegateIFvvEE]($83, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $85
      var $86=__ZN13resource_pool10add_objectIN12save_manager14state_callbackEEEPT_S4_($44, $83);
      var $87=__ZN11simple_listIN12save_manager14state_callbackEE6appendERS1_($42, $86);
      STACKTOP = __stackBase__;
      return;
    case 18: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $90=$89.f0;
      $11=$90;
      var $91=$89.f1;
      $12=$91;
      var $92=$1;
      var $93=$2;
      var $94=$3;
      HEAP32[(($1)>>2)]=$76;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22561)|0);
      HEAP32[(($3)>>2)]=159;
      var $95=HEAP32[(($1)>>2)];
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $97
      var $98=HEAP32[(($1)>>2)];
      var $99=HEAP32[(($2)>>2)];
      var $100=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($98, $99, $100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $_noexc
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $101=$1;
      var $102=$2;
      var $103=$3;
      __label__ = 22; break;
    case 22: // $104
      __label__ = 23; break;
    case 23: // $105
      var $106=$11;
      var $107=$11;
      var $108=$12;
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager16register_presaveE8delegateIFvvEE["X"]=1;

function __ZN13resource_pool10add_objectIN12save_manager14state_callbackEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12save_manager14state_callbackEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12save_manager14state_callbackEEEPT_S4_["X"]=1;

function __ZNK11simple_listIN12save_manager11state_entryEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12save_manager11state_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK7astringgtERKS_($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK7astring3cmpERKS_($3, $4);
  var $6=(($5)|0) > 0;
  ;
  return $6;
}


function __ZNK7astringeqERKS_($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK7astring3cmpERKS_($3, $4);
  var $6=(($5)|0)==0;
  ;
  return $6;
}


function __ZN11simple_listIN12save_manager11state_entryEE12insert_afterERS1_PS1_($this, $object, $insert_after) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$object;
      $4=$insert_after;
      var $5=$2;
      var $6=$4;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=__ZN11simple_listIN12save_manager11state_entryEE7prependERS1_($5, $9);
      $1=$10;
      __label__ = 5; break;
    case 2: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$3;
      var $18=$4;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=(($5+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$4;
      var $23=(($21)|0)==(($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$3;
      var $26=(($5+8)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 4; break;
    case 4: // $27
      var $28=(($5+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+1)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$3;
      $1=$31;
      __label__ = 5; break;
    case 5: // $32
      var $33=$1;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12save_manager9signatureEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $crc;
      var $entry;
      var $temp=__stackBase__;
      $1=$this;
      var $2=$1;
      $crc=0;
      var $3=(($2+12)|0);
      var $4=__ZNK11simple_listIN12save_manager11state_entryEE5firstEv($3);
      $entry=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$entry;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$crc;
      var $10=$entry;
      var $11=(($10+8)|0);
      var $12=__ZNK7astring4cstrEv($11);
      var $13=$entry;
      var $14=(($13+8)|0);
      var $15=__ZNK7astring3lenEv($14);
      var $16=_crc32($9, $12, $15);
      $crc=$16;
      var $17=$entry;
      var $18=(($17+76)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($temp)|0);
      HEAP32[(($20)>>2)]=$19;
      var $21=$entry;
      var $22=(($21+72)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(($temp+4)|0);
      HEAP32[(($25)>>2)]=$24;
      var $26=$crc;
      var $27=(($temp)|0);
      var $28=$27;
      var $29=_crc32($26, $28, 8);
      $crc=$29;
      __label__ = 3; break;
    case 3: // $30
      var $31=$entry;
      var $32=__ZNK12save_manager11state_entry4nextEv($31);
      $entry=$32;
      __label__ = 1; break;
    case 4: // $33
      var $34=$crc;
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager15validate_headerEPKhPKcjPFvS3_zES3_($header, $gamename, $signature, $errormsg, $error_prefix) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $rawsig;
      $2=$header;
      $3=$gamename;
      $4=$signature;
      $5=$errormsg;
      $6=$error_prefix;
      var $7=$2;
      var $8=_memcmp($7, ((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0), 8);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=$5;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$5;
      var $15=$6;
      FUNCTION_TABLE[$14](((STRING_TABLE.__str102569)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt));
      __label__ = 3; break;
    case 3: // $16
      $1=2;
      __label__ = 20; break;
    case 4: // $17
      var $18=$2;
      var $19=(($18+8)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=(($21)|0)!=2;
      if ($22) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $23
      var $24=$5;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$5;
      var $28=$6;
      var $29=$2;
      var $30=(($29+8)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      FUNCTION_TABLE[$27](((STRING_TABLE.__str112570)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,HEAP32[((tempInt+4)>>2)]=$32,HEAP32[((tempInt+8)>>2)]=2,tempInt));
      __label__ = 7; break;
    case 7: // $33
      $1=2;
      __label__ = 20; break;
    case 8: // $34
      var $35=$3;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $37
      var $38=$3;
      var $39=$2;
      var $40=(($39+10)|0);
      var $41=_strncmp($38, $40, 18);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $43
      var $44=$5;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $46
      var $47=$5;
      var $48=$6;
      var $49=$3;
      FUNCTION_TABLE[$47](((STRING_TABLE.__str122571)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$48,HEAP32[((tempInt+4)>>2)]=$49,tempInt));
      __label__ = 12; break;
    case 12: // $50
      $1=2;
      __label__ = 20; break;
    case 13: // $51
      var $52=$4;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $54
      var $55=$2;
      var $56=(($55+28)|0);
      var $57=$56;
      var $58=HEAP32[(($57)>>2)];
      $rawsig=$58;
      var $59=$4;
      var $60=$rawsig;
      var $61=(($59)|0)!=(($60)|0);
      if ($61) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $62
      var $63=$5;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $65
      var $66=$5;
      var $67=$6;
      var $68=$rawsig;
      var $69=$4;
      FUNCTION_TABLE[$66](((STRING_TABLE.__str132572)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$67,HEAP32[((tempInt+4)>>2)]=$68,HEAP32[((tempInt+8)>>2)]=$69,tempInt));
      __label__ = 17; break;
    case 17: // $70
      $1=2;
      __label__ = 20; break;
    case 18: // $71
      __label__ = 19; break;
    case 19: // $72
      $1=0;
      __label__ = 20; break;
    case 20: // $73
      var $74=$1;
      ;
      return $74;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager15validate_headerEPKhPKcjPFvS3_zES3_["X"]=1;

function __ZN12save_manager17register_postloadE8delegateIFvvEE($this, $func) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $cb;
      var $10=__stackBase__+36;
      var $11;
      var $12;
      $9=$this;
      var $13=$9;
      var $14=(($13+4)|0);
      var $15=HEAP8[($14)];
      var $16=(($15) & 1);
      if ($16) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $17
      __Z10fatalerrorPKcz(((STRING_TABLE.__str2559)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $18
      var $19=(($13+52)|0);
      var $20=__ZNK11simple_listIN12save_manager14state_callbackEE5firstEv($19);
      $cb=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$cb;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $24
      var $25=$cb;
      var $26=(($25+4)|0);
      var $27=$26;
      var $28=$func;
      var $29=__ZNK13delegate_baseIv8_noparamS0_S0_S0_EeqERKS1_($27, $28);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$cb;
      var $32=(($31+4)|0);
      var $33=$32;
      var $34=__ZNK13delegate_baseIv8_noparamS0_S0_S0_E4nameEv($33);
      var $35=$func;
      var $36=__ZNK13delegate_baseIv8_noparamS0_S0_S0_E4nameEv($35);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str12560)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,HEAP32[((tempInt+4)>>2)]=$36,tempInt));
      throw "Reached an unreachable!"
    case 6: // $37
      __label__ = 7; break;
    case 7: // $38
      var $39=$cb;
      var $40=__ZNK12save_manager14state_callback4nextEv($39);
      $cb=$40;
      __label__ = 3; break;
    case 8: // $41
      var $42=(($13+52)|0);
      var $43=__ZNK12save_manager7machineEv($13);
      var $44=__ZN15running_machine7respoolEv($43);
      var $45=$4;
      var $46=$5;
      var $47=$6;
      var $48=$result_i;
      var $49=$7;
      var $50=$8;
      HEAP32[(($4)>>2)]=28;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22561)|0);
      HEAP32[(($6)>>2)]=180;
      var $51=HEAP32[(($4)>>2)];
      var $52=HEAP32[(($5)>>2)];
      var $53=HEAP32[(($6)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($51, $52, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $55
      HEAP32[(($result_i)>>2)]=$54;
      var $56=HEAP32[(($result_i)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $58
      var $59=___cxa_allocate_exception(4);
      var $60=$59;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($60);
      (function() { try { __THREW__ = false; return ___cxa_throw($59, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($7)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($8)>>2)]=$64;
      var $65=HEAP32[(($8)>>2)];
      var $66=(($65)|0) < 0;
      if ($66) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $67
      var $68=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($68);
      throw "Reached an unreachable!"
    case 13: // $69
      var $70=HEAP32[(($7)>>2)];
      var $71=HEAP32[(($7)>>2)];
      var $72=HEAP32[(($8)>>2)];
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $75
      throw "Reached an unreachable!"
    case 15: // $_ZnwjPKci_exit
      var $76=HEAP32[(($result_i)>>2)];
      var $77=$4;
      var $78=$5;
      var $79=$6;
      var $80=$result_i;
      var $81=$7;
      var $82=$8;
      var $83=$76;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1ERKS1_($10, $func) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $84
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12save_manager14state_callbackC1E8delegateIFvvEE]($83, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $85
      var $86=__ZN13resource_pool10add_objectIN12save_manager14state_callbackEEEPT_S4_($44, $83);
      var $87=__ZN11simple_listIN12save_manager14state_callbackEE6appendERS1_($42, $86);
      STACKTOP = __stackBase__;
      return;
    case 18: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $90=$89.f0;
      $11=$90;
      var $91=$89.f1;
      $12=$91;
      var $92=$1;
      var $93=$2;
      var $94=$3;
      HEAP32[(($1)>>2)]=$76;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22561)|0);
      HEAP32[(($3)>>2)]=180;
      var $95=HEAP32[(($1)>>2)];
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $97
      var $98=HEAP32[(($1)>>2)];
      var $99=HEAP32[(($2)>>2)];
      var $100=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($98, $99, $100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $_noexc
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $101=$1;
      var $102=$2;
      var $103=$3;
      __label__ = 22; break;
    case 22: // $104
      __label__ = 23; break;
    case 23: // $105
      var $106=$11;
      var $107=$11;
      var $108=$12;
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager17register_postloadE8delegateIFvvEE["X"]=1;

function __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($this, $module, $tag, $index, $name, $val, $valsize, $valcount) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      var $totalname=__stackBase__+36;
      var $17;
      var $18;
      var $insert_after;
      var $entry;
      $9=$this;
      $10=$module;
      $11=$tag;
      $12=$index;
      $13=$name;
      $14=$val;
      $15=$valsize;
      $16=$valcount;
      var $19=$9;
      __label__ = 1; break;
    case 1: // $20
      __label__ = 2; break;
    case 2: // $21
      var $22=(($19+4)|0);
      var $23=HEAP8[($22)];
      var $24=(($23) & 1);
      if ($24) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=$10;
      var $27=$11;
      var $28=$13;
      __Z8logerrorPKcz(((STRING_TABLE.__str32562)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=$27,HEAP32[((tempInt+8)>>2)]=$28,tempInt));
      var $29=__ZNK12save_manager7machineEv($19);
      var $30=__ZNK15running_machine6systemEv($29);
      var $31=(($30+44)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32 & 2048;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$10;
      var $37=$11;
      var $38=$13;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str32562)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,HEAP32[((tempInt+4)>>2)]=$37,HEAP32[((tempInt+8)>>2)]=$38,tempInt));
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=(($19+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+1)|0);
      HEAP32[(($40)>>2)]=$42;
      __label__ = 43; break;
    case 6: // $43
      __ZN7astringC1Ev($totalname);
      var $44=$11;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $46
      var $47=$10;
      var $48=$11;
      var $49=$12;
      var $50=$13;
      var $51=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($totalname, ((STRING_TABLE.__str42563)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$47,HEAP32[((tempInt+4)>>2)]=$48,HEAP32[((tempInt+8)>>2)]=$49,HEAP32[((tempInt+12)>>2)]=$50,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $52
      __label__ = 13; break;
    case 9: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $54;__label__ = 10; break;
    case 10: // $_body
      var $eh_lpad_body;
      var $55=$eh_lpad_body.f0;
      $17=$55;
      var $56=$eh_lpad_body.f1;
      $18=$56;
      __label__ = 49; break;
    case 11: // $57
      var $58=$10;
      var $59=$12;
      var $60=$13;
      var $61=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($totalname, ((STRING_TABLE.__str52564)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$58,HEAP32[((tempInt+4)>>2)]=$59,HEAP32[((tempInt+8)>>2)]=$60,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $62
      __label__ = 13; break;
    case 13: // $63
      $insert_after=0;
      var $64=(($19+12)|0);
      var $65=(function() { try { __THREW__ = false; return __ZNK11simple_listIN12save_manager11state_entryEE5firstEv($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 9; break; };
    case 14: // $66
      $entry=$65;
      __label__ = 15; break;
    case 15: // $67
      var $68=$entry;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 16; break; } else { __label__ = 27; break; }
    case 16: // $70
      var $71=$entry;
      var $72=(($71+8)|0);
      var $73=(function() { try { __THREW__ = false; return __ZNK7astringgtERKS_($72, $totalname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 9; break; };
    case 17: // $74
      if ($73) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $75
      __label__ = 27; break;
    case 19: // $76
      var $77=$entry;
      $insert_after=$77;
      var $78=$entry;
      var $79=(($78+8)|0);
      var $80=(function() { try { __THREW__ = false; return __ZNK7astringeqERKS_($79, $totalname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 9; break; };
    case 20: // $81
      if ($80) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $82
      var $83=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($totalname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $84
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str62565)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$83,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 9; break; }
    case 23: // $85
      throw "Reached an unreachable!"
    case 24: // $86
      __label__ = 25; break;
    case 25: // $87
      var $88=$entry;
      var $89=(function() { try { __THREW__ = false; return __ZNK12save_manager11state_entry4nextEv($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 9; break; };
    case 26: // $90
      $entry=$89;
      __label__ = 15; break;
    case 27: // $91
      var $92=(($19+12)|0);
      var $93=(function() { try { __THREW__ = false; return __ZNK12save_manager7machineEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 9; break; };
    case 28: // $94
      var $95=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 9; break; };
    case 29: // $96
      var $97=$4;
      var $98=$5;
      var $99=$6;
      var $100=$result_i;
      var $101=$7;
      var $102=$8;
      HEAP32[(($4)>>2)]=84;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22561)|0);
      HEAP32[(($6)>>2)]=225;
      var $103=HEAP32[(($4)>>2)];
      var $104=HEAP32[(($5)>>2)];
      var $105=HEAP32[(($6)>>2)];
      var $106=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($103, $104, $105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; };
    case 30: // $107
      HEAP32[(($result_i)>>2)]=$106;
      var $108=HEAP32[(($result_i)>>2)];
      var $109=(($108)|0)==0;
      if ($109) { __label__ = 31; break; } else { __label__ = 37; break; }
    case 31: // $110
      var $111=___cxa_allocate_exception(4);
      var $112=$111;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($112);
      (function() { try { __THREW__ = false; return ___cxa_throw($111, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 32; break; }
    case 32: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      HEAP32[(($7)>>2)]=$115;
      var $116=$114.f1;
      HEAP32[(($8)>>2)]=$116;
      var $117=HEAP32[(($8)>>2)];
      var $118=(($117)|0) < 0;
      if ($118) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $119
      var $120=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 9; break; }
    case 34: // $_noexc
      throw "Reached an unreachable!"
    case 35: // $121
      var $122=HEAP32[(($7)>>2)];
      var $123=HEAP32[(($7)>>2)];
      var $124=HEAP32[(($8)>>2)];
      var $125=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $123, tempValue);
      var $126=($125.f1 = $124, $125);
      var $eh_lpad_body = $126;__label__ = 10; break;
    case 36: // $127
      throw "Reached an unreachable!"
    case 37: // $_ZnwjPKci_exit
      var $128=HEAP32[(($result_i)>>2)];
      var $129=$4;
      var $130=$5;
      var $131=$6;
      var $132=$result_i;
      var $133=$7;
      var $134=$8;
      __label__ = 38; break;
    case 38: // $135
      var $136=$128;
      var $137=$14;
      var $138=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($totalname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 44; break; };
    case 39: // $139
      var $140=$15;
      var $141=(($140) & 255);
      var $142=$16;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12save_manager11state_entryC1EPvPKchj]($136, $137, $138, $141, $142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $143
      var $144=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN12save_manager11state_entryEEEPT_S4_($95, $136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 9; break; };
    case 41: // $145
      var $146=$insert_after;
      var $147=(function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager11state_entryEE12insert_afterERS1_PS1_($92, $144, $146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 9; break; };
    case 42: // $148
      FUNCTION_TABLE[__ZN7astringD1Ev]($totalname);
      __label__ = 43; break;
    case 43: // $149
      STACKTOP = __stackBase__;
      return;
    case 44: // $150
      var $151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $152=$151.f0;
      $17=$152;
      var $153=$151.f1;
      $18=$153;
      var $154=$1;
      var $155=$2;
      var $156=$3;
      HEAP32[(($1)>>2)]=$128;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22561)|0);
      HEAP32[(($3)>>2)]=225;
      var $157=HEAP32[(($1)>>2)];
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $159
      var $160=HEAP32[(($1)>>2)];
      var $161=HEAP32[(($2)>>2)];
      var $162=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($160, $161, $162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $_noexc1
      __label__ = 47; break;
    case 47: // $_ZdlPvPKci_exit
      var $163=$1;
      var $164=$2;
      var $165=$3;
      __label__ = 48; break;
    case 48: // $166
      __label__ = 49; break;
    case 49: // $167
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($totalname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $168
      __label__ = 51; break;
    case 51: // $169
      var $170=$17;
      var $171=$17;
      var $172=$18;
      var $173=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $171, tempValue);
      var $174=($173.f1 = $172, $173);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 52: // $175
      var $176=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj["X"]=1;

function __ZN13resource_pool10add_objectIN12save_manager11state_entryEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12save_manager11state_entryEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12save_manager11state_entryEEEPT_S4_["X"]=1;

function __ZN12save_manager11state_entry9flip_dataEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $data16;
      var $data32;
      var $data64;
      var $count;
      $1=$this;
      var $2=$1;
      var $3=(($2+72)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      if ($5 == 2) {
        __label__ = 1; break;
      }
      else if ($5 == 4) {
        __label__ = 6; break;
      }
      else if ($5 == 8) {
        __label__ = 11; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 1: // $6
      var $7=(($2+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      $data16=$9;
      $count=0;
      __label__ = 2; break;
    case 2: // $10
      var $11=$count;
      var $12=(($2+76)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($11)>>>0) < (($13)>>>0);
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$count;
      var $17=$data16;
      var $18=(($17+($16<<1))|0);
      var $19=HEAPU16[(($18)>>1)];
      var $20=(($19)&65535);
      var $21=$20 >> 8;
      var $22=$count;
      var $23=$data16;
      var $24=(($23+($22<<1))|0);
      var $25=HEAPU16[(($24)>>1)];
      var $26=(($25)&65535);
      var $27=$26 << 8;
      var $28=$21 | $27;
      var $29=$28 & 65535;
      var $30=(($29) & 65535);
      var $31=$count;
      var $32=$data16;
      var $33=(($32+($31<<1))|0);
      HEAP16[(($33)>>1)]=$30;
      __label__ = 4; break;
    case 4: // $34
      var $35=$count;
      var $36=(($35+1)|0);
      $count=$36;
      __label__ = 2; break;
    case 5: // $37
      __label__ = 16; break;
    case 6: // $38
      var $39=(($2+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      $data32=$41;
      $count=0;
      __label__ = 7; break;
    case 7: // $42
      var $43=$count;
      var $44=(($2+76)|0);
      var $45=HEAPU32[(($44)>>2)];
      var $46=(($43)>>>0) < (($45)>>>0);
      if ($46) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $47
      var $48=$count;
      var $49=$data32;
      var $50=(($49+($48<<2))|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$51 << 24;
      var $53=$count;
      var $54=$data32;
      var $55=(($54+($53<<2))|0);
      var $56=HEAPU32[(($55)>>2)];
      var $57=$56 >>> 24;
      var $58=$52 | $57;
      var $59=$count;
      var $60=$data32;
      var $61=(($60+($59<<2))|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$62 & 65280;
      var $64=$63 << 8;
      var $65=$58 | $64;
      var $66=$count;
      var $67=$data32;
      var $68=(($67+($66<<2))|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$69 & 16711680;
      var $71=$70 >>> 8;
      var $72=$65 | $71;
      var $73=$count;
      var $74=$data32;
      var $75=(($74+($73<<2))|0);
      HEAP32[(($75)>>2)]=$72;
      __label__ = 9; break;
    case 9: // $76
      var $77=$count;
      var $78=(($77+1)|0);
      $count=$78;
      __label__ = 7; break;
    case 10: // $79
      __label__ = 16; break;
    case 11: // $80
      var $81=(($2+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$82;
      $data64=$83;
      $count=0;
      __label__ = 12; break;
    case 12: // $84
      var $85=$count;
      var $86=(($2+76)|0);
      var $87=HEAPU32[(($86)>>2)];
      var $88=(($85)>>>0) < (($87)>>>0);
      if ($88) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $89
      var $90=$count;
      var $91=$data64;
      var $92=(($91+($90<<3))|0);
      var $st$3$0=(($92)|0);
      var $93$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($92+4)|0);
      var $93$1=HEAPU32[(($st$3$1)>>2)];
      var $94$0=($93$1 >>> 24) | (0 << 8);
      var $94$1=(0 >>> 24) | (0 << 8);
      var $$emscripten$temp$0$0=255;
      var $$emscripten$temp$0$1=0;
      var $95$0=$94$0 & $$emscripten$temp$0$0;
      var $95$1=$94$1 & $$emscripten$temp$0$1;
      var $96$0=$95$0;
      var $96$1=$95$1;
      var $97=$count;
      var $98=$data64;
      var $99=(($98+($97<<3))|0);
      var $st$18$0=(($99)|0);
      var $100$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($99+4)|0);
      var $100$1=HEAPU32[(($st$18$1)>>2)];
      var $101$0=($100$1 >>> 16) | (0 << 16);
      var $101$1=(0 >>> 16) | (0 << 16);
      var $$emscripten$temp$1$0=255;
      var $$emscripten$temp$1$1=0;
      var $102$0=$101$0 & $$emscripten$temp$1$0;
      var $102$1=$101$1 & $$emscripten$temp$1$1;
      var $103$0=($102$0 << 8) | (0 >>> 24);
      var $103$1=($102$1 << 8) | ($102$0 >>> 24);
      var $104$0=$96$0 | $103$0;
      var $104$1=$96$1 | $103$1;
      var $105=$count;
      var $106=$data64;
      var $107=(($106+($105<<3))|0);
      var $st$35$0=(($107)|0);
      var $108$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($107+4)|0);
      var $108$1=HEAPU32[(($st$35$1)>>2)];
      var $109$0=($108$1 >>> 8) | (0 << 24);
      var $109$1=(0 >>> 8) | (0 << 24);
      var $$emscripten$temp$2$0=255;
      var $$emscripten$temp$2$1=0;
      var $110$0=$109$0 & $$emscripten$temp$2$0;
      var $110$1=$109$1 & $$emscripten$temp$2$1;
      var $111$0=($110$0 << 16) | (0 >>> 16);
      var $111$1=($110$1 << 16) | ($110$0 >>> 16);
      var $112$0=$104$0 | $111$0;
      var $112$1=$104$1 | $111$1;
      var $113=$count;
      var $114=$data64;
      var $115=(($114+($113<<3))|0);
      var $st$52$0=(($115)|0);
      var $116$0=HEAP32[(($st$52$0)>>2)];
      var $st$52$1=(($115+4)|0);
      var $116$1=HEAP32[(($st$52$1)>>2)];
      var $117$0=$116$1;
      var $117$1=0;
      var $$emscripten$temp$3$0=255;
      var $$emscripten$temp$3$1=0;
      var $118$0=$117$0 & $$emscripten$temp$3$0;
      var $118$1=$117$1 & $$emscripten$temp$3$1;
      var $119$0=($118$0 << 24) | (0 >>> 8);
      var $119$1=($118$1 << 24) | ($118$0 >>> 8);
      var $120$0=$112$0 | $119$0;
      var $120$1=$112$1 | $119$1;
      var $121=$count;
      var $122=$data64;
      var $123=(($122+($121<<3))|0);
      var $st$69$0=(($123)|0);
      var $124$0=HEAPU32[(($st$69$0)>>2)];
      var $st$69$1=(($123+4)|0);
      var $124$1=HEAPU32[(($st$69$1)>>2)];
      var $125$0=($124$0 >>> 24) | ($124$1 << 8);
      var $125$1=($124$1 >>> 24) | (0 << 8);
      var $$emscripten$temp$4$0=255;
      var $$emscripten$temp$4$1=0;
      var $126$0=$125$0 & $$emscripten$temp$4$0;
      var $126$1=$125$1 & $$emscripten$temp$4$1;
      var $127$0=0;
      var $127$1=$126$0;
      var $128$0=$120$0 | $127$0;
      var $128$1=$120$1 | $127$1;
      var $129=$count;
      var $130=$data64;
      var $131=(($130+($129<<3))|0);
      var $st$86$0=(($131)|0);
      var $132$0=HEAPU32[(($st$86$0)>>2)];
      var $st$86$1=(($131+4)|0);
      var $132$1=HEAPU32[(($st$86$1)>>2)];
      var $133$0=($132$0 >>> 16) | ($132$1 << 16);
      var $133$1=($132$1 >>> 16) | (0 << 16);
      var $$emscripten$temp$5$0=255;
      var $$emscripten$temp$5$1=0;
      var $134$0=$133$0 & $$emscripten$temp$5$0;
      var $134$1=$133$1 & $$emscripten$temp$5$1;
      var $135$0=(0 << 8) | (0 >>> 24);
      var $135$1=($134$0 << 8) | (0 >>> 24);
      var $136$0=$128$0 | $135$0;
      var $136$1=$128$1 | $135$1;
      var $137=$count;
      var $138=$data64;
      var $139=(($138+($137<<3))|0);
      var $st$103$0=(($139)|0);
      var $140$0=HEAPU32[(($st$103$0)>>2)];
      var $st$103$1=(($139+4)|0);
      var $140$1=HEAPU32[(($st$103$1)>>2)];
      var $141$0=($140$0 >>> 8) | ($140$1 << 24);
      var $141$1=($140$1 >>> 8) | (0 << 24);
      var $$emscripten$temp$6$0=255;
      var $$emscripten$temp$6$1=0;
      var $142$0=$141$0 & $$emscripten$temp$6$0;
      var $142$1=$141$1 & $$emscripten$temp$6$1;
      var $143$0=(0 << 16) | (0 >>> 16);
      var $143$1=($142$0 << 16) | (0 >>> 16);
      var $144$0=$136$0 | $143$0;
      var $144$1=$136$1 | $143$1;
      var $145=$count;
      var $146=$data64;
      var $147=(($146+($145<<3))|0);
      var $st$120$0=(($147)|0);
      var $148$0=HEAP32[(($st$120$0)>>2)];
      var $st$120$1=(($147+4)|0);
      var $148$1=HEAP32[(($st$120$1)>>2)];
      var $149$0=$148$0;
      var $149$1=$148$1;
      var $$emscripten$temp$7$0=255;
      var $$emscripten$temp$7$1=0;
      var $150$0=$149$0 & $$emscripten$temp$7$0;
      var $150$1=$149$1 & $$emscripten$temp$7$1;
      var $151$0=(0 << 24) | (0 >>> 8);
      var $151$1=($150$0 << 24) | (0 >>> 8);
      var $152$0=$144$0 | $151$0;
      var $152$1=$144$1 | $151$1;
      var $153=$count;
      var $154=$data64;
      var $155=(($154+($153<<3))|0);
      var $st$137$0=(($155)|0);
      HEAP32[(($st$137$0)>>2)]=$152$0;
      var $st$137$1=(($155+4)|0);
      HEAP32[(($st$137$1)>>2)]=$152$1;
      __label__ = 14; break;
    case 14: // $156
      var $157=$count;
      var $158=(($157+1)|0);
      $count=$158;
      __label__ = 12; break;
    case 15: // $159
      __label__ = 16; break;
    case 16: // $160
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager11state_entry9flip_dataEv["X"]=1;

function __ZN11simple_listIN12save_manager11state_entryEE7prependERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9read_fileER8emu_file($this, $file) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $header=__stackBase__;
      var $sig;
      var $flip;
      var $entry;
      var $totalsize;
      var $func;
      $2=$this;
      $3=$file;
      var $4=$2;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=1;
      __label__ = 19; break;
    case 2: // $9
      var $10=$3;
      var $11=__ZN8emu_file8compressEi($10, 0);
      var $12=$3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $13=__ZN8emu_file4seekExi($12, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $13$0=$13[0];
      var $14=$3;
      var $15=(($header)|0);
      var $16=__ZN8emu_file4readEPvj($14, $15, 32);
      var $17=(($16)|0)!=32;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      $1=3;
      __label__ = 19; break;
    case 4: // $19
      var $20=$3;
      var $21=__ZN8emu_file8compressEi($20, 6);
      var $22=__ZNK12save_manager9signatureEv($4);
      $sig=$22;
      var $23=(($header)|0);
      var $24=__ZNK12save_manager7machineEv($4);
      var $25=__ZNK15running_machine6systemEv($24);
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$sig;
      var $29=__ZN12save_manager15validate_headerEPKhPKcjPFvS3_zES3_($23, $27, $28, 226, ((STRING_TABLE.__str92568)|0));
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      $1=2;
      __label__ = 19; break;
    case 6: // $32
      var $33=(($header+9)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=$35 & 2;
      var $37=(($36)|0)!=0;
      var $38=(($37)&1);
      $flip=$38;
      var $39=(($4+12)|0);
      var $40=__ZNK11simple_listIN12save_manager11state_entryEE5firstEv($39);
      $entry=$40;
      __label__ = 7; break;
    case 7: // $41
      var $42=$entry;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $44
      var $45=$entry;
      var $46=(($45+72)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$entry;
      var $50=(($49+76)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($48*$51)|0);
      $totalsize=$52;
      var $53=$3;
      var $54=$entry;
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$totalsize;
      var $58=__ZN8emu_file4readEPvj($53, $56, $57);
      var $59=$totalsize;
      var $60=(($58)|0)!=(($59)|0);
      if ($60) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $61
      $1=3;
      __label__ = 19; break;
    case 10: // $62
      var $63=$flip;
      var $64=(($63) & 1);
      if ($64) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $65
      var $66=$entry;
      __ZN12save_manager11state_entry9flip_dataEv($66);
      __label__ = 12; break;
    case 12: // $67
      __label__ = 13; break;
    case 13: // $68
      var $69=$entry;
      var $70=__ZNK12save_manager11state_entry4nextEv($69);
      $entry=$70;
      __label__ = 7; break;
    case 14: // $71
      var $72=(($4+52)|0);
      var $73=__ZNK11simple_listIN12save_manager14state_callbackEE5firstEv($72);
      $func=$73;
      __label__ = 15; break;
    case 15: // $74
      var $75=$func;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $77
      var $78=$func;
      var $79=(($78+4)|0);
      var $80=$79;
      __ZNK13delegate_baseIv8_noparamS0_S0_S0_EclEv($80);
      __label__ = 17; break;
    case 17: // $81
      var $82=$func;
      var $83=__ZNK12save_manager14state_callback4nextEv($82);
      $func=$83;
      __label__ = 15; break;
    case 18: // $84
      $1=0;
      __label__ = 19; break;
    case 19: // $85
      var $86=$1;
      STACKTOP = __stackBase__;
      return $86;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager9read_fileER8emu_file["X"]=1;

function __ZNK13delegate_baseIv8_noparamS0_S0_S0_EclEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($2+4)|0);
  var $6=HEAP32[(($5)>>2)];
  FUNCTION_TABLE[$4]($6);
  ;
  return;
}


function __ZN12save_manager10write_fileER8emu_file($this, $file) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $header=__stackBase__;
      var $sig;
      var $func;
      var $entry;
      var $totalsize;
      $2=$this;
      $3=$file;
      var $4=$2;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=1;
      __label__ = 15; break;
    case 2: // $9
      var $10=(($header)|0);
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($10)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0))];HEAP8[($10+1)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+1)];HEAP8[($10+2)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+2)];HEAP8[($10+3)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+3)];HEAP8[($10+4)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+4)];HEAP8[($10+5)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+5)];HEAP8[($10+6)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+6)];HEAP8[($10+7)]=HEAP8[(((STRING_TABLE.__ZN12save_manager11s_magic_numE)|0)+7)];
      var $11=(($header+8)|0);
      HEAP8[($11)]=2;
      var $12=(($header+9)|0);
      HEAP8[($12)]=0;
      var $13=(($header+10)|0);
      var $14=__ZNK12save_manager7machineEv($4);
      var $15=__ZNK15running_machine6systemEv($14);
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=_strncpy($13, $17, 18);
      var $19=__ZNK12save_manager9signatureEv($4);
      $sig=$19;
      var $20=$sig;
      var $21=(($header+28)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=$20;
      var $23=$3;
      var $24=__ZN8emu_file8compressEi($23, 0);
      var $25=$3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $26=__ZN8emu_file4seekExi($25, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $26$0=$26[0];
      var $27=$3;
      var $28=(($header)|0);
      var $29=__ZN8emu_file5writeEPKvj($27, $28, 32);
      var $30=(($29)|0)!=32;
      if ($30) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $31
      $1=4;
      __label__ = 15; break;
    case 4: // $32
      var $33=$3;
      var $34=__ZN8emu_file8compressEi($33, 6);
      var $35=(($4+32)|0);
      var $36=__ZNK11simple_listIN12save_manager14state_callbackEE5firstEv($35);
      $func=$36;
      __label__ = 5; break;
    case 5: // $37
      var $38=$func;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $40
      var $41=$func;
      var $42=(($41+4)|0);
      var $43=$42;
      __ZNK13delegate_baseIv8_noparamS0_S0_S0_EclEv($43);
      __label__ = 7; break;
    case 7: // $44
      var $45=$func;
      var $46=__ZNK12save_manager14state_callback4nextEv($45);
      $func=$46;
      __label__ = 5; break;
    case 8: // $47
      var $48=(($4+12)|0);
      var $49=__ZNK11simple_listIN12save_manager11state_entryEE5firstEv($48);
      $entry=$49;
      __label__ = 9; break;
    case 9: // $50
      var $51=$entry;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $53
      var $54=$entry;
      var $55=(($54+72)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$entry;
      var $59=(($58+76)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57*$60)|0);
      $totalsize=$61;
      var $62=$3;
      var $63=$entry;
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$totalsize;
      var $67=__ZN8emu_file5writeEPKvj($62, $65, $66);
      var $68=$totalsize;
      var $69=(($67)|0)!=(($68)|0);
      if ($69) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $70
      $1=4;
      __label__ = 15; break;
    case 12: // $71
      __label__ = 13; break;
    case 13: // $72
      var $73=$entry;
      var $74=__ZNK12save_manager11state_entry4nextEv($73);
      $entry=$74;
      __label__ = 9; break;
    case 14: // $75
      $1=0;
      __label__ = 15; break;
    case 15: // $76
      var $77=$1;
      STACKTOP = __stackBase__;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager10write_fileER8emu_file["X"]=1;

function __ZN12save_manager14state_callbackC2E8delegateIFvvEE($this, $callback) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  __ZN8delegateIFvvEEC1ERKS1_($4, $callback);
  ;
  return;
}


function __ZN12save_manager11state_entryC2EPvPKchj($this, $data, $name, $size, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$data;
  $3=$name;
  $4=$size;
  $5=$count;
  var $6=$1;
  var $7=(($6)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($6+4)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($6+8)|0);
  var $11=$3;
  __ZN7astringC1EPKc($10, $11);
  var $12=(($6+72)|0);
  var $13=$4;
  HEAP8[($12)]=$13;
  var $14=(($6+76)|0);
  var $15=$5;
  HEAP32[(($14)>>2)]=$15;
  var $16=(($6+80)|0);
  HEAP32[(($16)>>2)]=0;
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager11state_entryEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12save_manager11state_entryEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager11state_entryEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 84);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12save_manager11state_entryEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager11state_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12save_manager11state_entryEED2Ev($2);
  ;
  return;
}


function __ZN12save_manager11state_entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12save_manager11state_entryD2Ev($2);
  ;
  return;
}


function __ZN12save_manager11state_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager14state_callbackEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12save_manager14state_callbackEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager14state_callbackEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 28);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12save_manager14state_callbackEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager14state_callbackEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12save_manager14state_callbackEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager11state_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12save_manager11state_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12save_manager11state_entryEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12save_manager11state_entryEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12save_manager11state_entryEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12save_manager11state_entryD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12save_manager11state_entryEED2Ev["X"]=1;

function __ZNK21delegate_internal_mfpeqERKS_($this, $rhs) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$rhs;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { var $18 = 0;__label__ = 2; break; }
    case 1: // $10
      var $11=(($3+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0)==(($15)|0);
      var $18 = $16;__label__ = 2; break;
    case 2: // $17
      var $18;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12save_manager14state_callbackEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12save_manager14state_callbackEE6detachERS1_["X"]=1;

function __ZN11simple_listIN12save_manager11state_entryEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12save_manager11state_entryEE6detachERS1_["X"]=1;

function __ZN11simple_listIN12save_manager14state_callbackEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN12save_manager14state_callbackEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN12save_manager11state_entryEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN12save_manager11state_entryEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN12save_manager14state_callbackEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN12save_manager14state_callbackEE+8)|0);
  __ZN11simple_listIN12save_manager14state_callbackEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN12save_manager14state_callbackEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN12save_manager14state_callbackEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12save_manager14state_callbackEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN12save_manager14state_callbackEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listIN12save_manager11state_entryEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN12save_manager11state_entryEE+8)|0);
  __ZN11simple_listIN12save_manager11state_entryEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN12save_manager11state_entryEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN12save_manager11state_entryEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12save_manager11state_entryEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN12save_manager11state_entryEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8delegateIFvvEEC2ERKS1_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2ERKS1_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2ERKS1_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN20resource_pool_objectIN12save_manager14state_callbackEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12save_manager14state_callbackEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12save_manager14state_callbackEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12save_manager14state_callbackEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN12save_manager14state_callbackEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12save_manager14state_callbackEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12save_manager14state_callbackEED0Ev["X"]=1;

function __ZN11simple_listIN12save_manager11state_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager11state_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12save_manager11state_entryEED0Ev["X"]=1;

function __ZNK14machine_config7gamedrvEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16device_scheduler19currently_executingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11tagged_listI17input_port_configEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11tagged_listI17input_port_configEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11tagged_listI13memory_regionEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11tagged_listI13memory_regionEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK11emu_options11sample_rateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options9int_valueEPKc($3, ((STRING_TABLE.__str452626)|0));
  ;
  return $4;
}


function __ZN11simple_listIN15running_machine22notifier_callback_itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN15running_machine22notifier_callback_itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN15running_machine22notifier_callback_itemEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN15running_machine22logerror_callback_itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15running_machine6deviceI13driver_deviceEEPT_PKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$2;
  var $5=__ZN15running_machine6deviceEPKc($3, $4);
  var $6=__Z8downcastIP13driver_device8device_tET_PT0_($5);
  ;
  return $6;
}


function __ZNK11emu_options5debugEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str442625)|0));
  ;
  return $4;
}


function __ZNK11emu_options14debug_internalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str432624)|0));
  ;
  return $4;
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN15running_machine22logerror_callback_itemEED2Ev($2);
  ;
  return;
}


function __ZN12save_managerD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12save_managerD2Ev($2);
  ;
  return;
}


function __ZN11tagged_listI13memory_regionED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11tagged_listI13memory_regionED2Ev($2);
  ;
  return;
}


function __ZN11tagged_listI17input_port_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11tagged_listI17input_port_configED2Ev($2);
  ;
  return;
}


function __ZN15running_machine16describe_contextEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $executing;
      var $cpu;
      $1=$this;
      var $2=$1;
      var $3=(($2+1160)|0);
      var $4=__ZNK16device_scheduler19currently_executingEv($3);
      $executing=$4;
      var $5=$executing;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$executing;
      var $9=$8;
      var $10=__ZN16device_interface6deviceEv($9);
      var $11=__Z8downcastIP10cpu_device8device_tET_PT0_($10);
      $cpu=$11;
      var $12=$cpu;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($2+1396)|0);
      var $16=$cpu;
      var $17=$16;
      var $18=__ZNK8device_t3tagEv($17);
      var $19=$cpu;
      var $20=$19;
      var $21=(($20+6012)|0);
      var $22=$21;
      var $23=__ZN22device_state_interface2pcEv($22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$cpu;
      var $26=$25;
      var $27=(($26+5968)|0);
      var $28=$27;
      var $29=__ZNK23device_memory_interface5spaceE16address_spacenum($28, 0);
      var $30=__ZNK13address_space12logaddrcharsEv($29);
      var $31=__Z19core_i64_hex_formatyh($24$0, $24$1, $30);
      var $32=__ZN7astring6printfEPKcz($15, ((STRING_TABLE.__str22581)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,HEAP32[((tempInt+4)>>2)]=$31,tempInt));
      __label__ = 3; break;
    case 3: // $33
      __label__ = 5; break;
    case 4: // $34
      var $35=(($2+1396)|0);
      var $36=__ZN7astring3cpyEPKc($35, ((STRING_TABLE.__str32582)|0));
      __label__ = 5; break;
    case 5: // $37
      var $38=(($2+1396)|0);
      var $39=__ZNK7astringcvPKcEv($38);
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machineC2ERK14machine_configR13osd_interfaceb($this, $_config, $osd, $exit_to_game_select) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $device;
      $1=$this;
      $2=$_config;
      $3=$osd;
      var $7=(($exit_to_game_select)&1);
      $4=$7;
      var $8=$1;
      var $9=(($8)|0);
      FUNCTION_TABLE[__ZN13resource_poolC1Ei]($9, 193);
      var $10=(($8+20)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configEC1ER13resource_pool($10, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 21; break; }
    case 1: // $11
      var $12=(($8+428)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=(($8+560)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($8+564)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($8+568)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($8+572)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($8+576)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($8+580)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($8+584)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($8+588)|0);
      var $21=(($8+624)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($8+628)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($8+632)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=(($8+636)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($8+640)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($8+644)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=(($8+648)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=(($8+652)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($8+656)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($8+660)|0);
      HEAP32[(($30)>>2)]=0;
      var $31=(($8+664)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($8+668)|0);
      var $33=$2;
      HEAP32[(($32)>>2)]=$33;
      var $34=(($8+672)|0);
      var $35=$2;
      var $36=(function() { try { __THREW__ = false; return __ZNK14machine_config7gamedrvEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 22; break; };
    case 2: // $37
      HEAP32[(($34)>>2)]=$36;
      var $38=(($8+676)|0);
      var $39=$3;
      HEAP32[(($38)>>2)]=$39;
      var $40=(($8+680)|0);
      var $41=(($8)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI13memory_regionEC1ER13resource_pool($40, $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 22; break; }
    case 3: // $42
      var $43=(($8+1088)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12save_managerC1ER15running_machine]($43, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 23; break; }
    case 4: // $44
      var $45=(($8+1160)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16device_schedulerC1ER15running_machine]($45, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 24; break; }
    case 5: // $46
      var $47=(($8+1276)|0);
      HEAP32[(($47)>>2)]=0;
      var $48=(($8+1280)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=(($8+1284)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($8+1288)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=(($8+1292)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=(($8+1296)|0);
      HEAP32[(($52)>>2)]=0;
      var $53=(($8+1300)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=(($8+1304)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=(($8+1308)|0);
      HEAP8[($55)]=0;
      var $56=(($8+1309)|0);
      HEAP8[($56)]=0;
      var $57=(($8+1310)|0);
      HEAP8[($57)]=0;
      var $58=(($8+1311)|0);
      var $59=$4;
      var $60=(($59) & 1);
      var $61=(($60)&1);
      HEAP8[($58)]=$61;
      var $62=(($8+1312)|0);
      HEAP32[(($62)>>2)]=0;
      var $63=(($8+1316)|0);
      HEAP32[(($63)>>2)]=0;
      var $64=(($8+1320)|0);
      HEAP32[(($64)>>2)]=-1659589673;
      var $65=(($8+1324)|0);
      HEAP8[($65)]=0;
      var $66=(($8+1332)|0);
      var $67=$2;
      var $68=(function() { try { __THREW__ = false; return __ZNK14machine_config7gamedrvEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 25; break; };
    case 6: // $69
      var $70=(($68+8)|0);
      var $71=HEAP32[(($70)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($66, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 25; break; }
    case 7: // $72
      var $73=(($8+1396)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 26; break; }
    case 8: // $74
      var $75=(($8+1460)|0);
      var $76=$2;
      var $77=(function() { try { __THREW__ = false; return __ZNK14machine_config7optionsEv($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 27; break; };
    case 9: // $78
      var $79=(function() { try { __THREW__ = false; return __ZNK11emu_options11sample_rateEv($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 27; break; };
    case 10: // $80
      HEAP32[(($75)>>2)]=$79;
      var $81=(($8+1464)|0);
      HEAP32[(($81)>>2)]=0;
      var $82=(($8+1468)|0);
      HEAP32[(($82)>>2)]=0;
      var $83=(($8+1472)|0);
      var $84=$83;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($84)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($84+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($84+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $85=(($8+1484)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 27; break; }
    case 11: // $86
      var $87=(($8+1548)|0);
      HEAP32[(($87)>>2)]=0;
      var $88=(($8+1552)|0);
      var $89=(($88)|0);
      var $90=(($89+100)|0);
      var $92 = $89;__label__ = 12; break;
    case 12: // $91
      var $92;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22notifier_callback_itemEEC1ER13resource_pool($92, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 28; break; }
    case 13: // $93
      var $94=(($92+20)|0);
      var $95=(($94)|0)==(($90)|0);
      if ($95) { __label__ = 14; break; } else { var $92 = $94;__label__ = 12; break; }
    case 14: // $96
      var $97=(($8+1652)|0);
      var $98=(($8)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22logerror_callback_itemEEC1ER13resource_pool($97, $98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 32; break; }
    case 15: // $99
      var $100=(($8+432)|0);
      var $101=(($100)|0);
      var $102=$101;
      _memset($102, 0, 128, 1);
      var $103=(($8+588)|0);
      var $104=$103;
      _memset($104, 0, 36, 1);
      var $105=(($8+1328)|0);
      var $106=$105;
      HEAP8[($106)]=0; HEAP8[($106+1)]=0; HEAP8[($106+2)]=0; HEAP8[($106+3)]=0;
      var $107=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 33; break; };
    case 16: // $108
      (function() { try { __THREW__ = false; return __ZN11device_list15set_machine_allER15running_machine($107, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 33; break; }
    case 17: // $109
      var $110=(function() { try { __THREW__ = false; return __ZN15running_machine6deviceI13driver_deviceEEPT_PKc($8, ((STRING_TABLE.__str2579)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 33; break; };
    case 18: // $111
      var $112=(($8+1300)|0);
      HEAP32[(($112)>>2)]=$110;
      var $113=(($8+1300)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 19; break; } else { __label__ = 35; break; }
    case 19: // $116
      var $117=___cxa_allocate_exception(1032);
      var $118=$117;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($118, ((STRING_TABLE.__str12580)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 34; break; }
    case 20: // $119
      (function() { try { __THREW__ = false; return ___cxa_throw($117, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 33; break; }
    case 21: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $122=$121.f0;
      $5=$122;
      var $123=$121.f1;
      $6=$123;
      __label__ = 74; break;
    case 22: // $124
      var $125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $126=$125.f0;
      $5=$126;
      var $127=$125.f1;
      $6=$127;
      __label__ = 72; break;
    case 23: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $130=$129.f0;
      $5=$130;
      var $131=$129.f1;
      $6=$131;
      __label__ = 70; break;
    case 24: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $134=$133.f0;
      $5=$134;
      var $135=$133.f1;
      $6=$135;
      __label__ = 68; break;
    case 25: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      $5=$138;
      var $139=$137.f1;
      $6=$139;
      __label__ = 66; break;
    case 26: // $140
      var $141=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $142=$141.f0;
      $5=$142;
      var $143=$141.f1;
      $6=$143;
      __label__ = 64; break;
    case 27: // $144
      var $145=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $146=$145.f0;
      $5=$146;
      var $147=$145.f1;
      $6=$147;
      __label__ = 62; break;
    case 28: // $148
      var $149=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $150=$149.f0;
      $5=$150;
      var $151=$149.f1;
      $6=$151;
      var $152=(($89)|0)==(($92)|0);
      if ($152) { __label__ = 31; break; } else { var $154 = $92;__label__ = 29; break; }
    case 29: // $153
      var $154;
      var $155=(($154-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 77; break; }
    case 30: // $156
      var $157=(($155)|0)==(($89)|0);
      if ($157) { __label__ = 31; break; } else { var $154 = $155;__label__ = 29; break; }
    case 31: // $158
      __label__ = 60; break;
    case 32: // $159
      var $160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $161=$160.f0;
      $5=$161;
      var $162=$160.f1;
      $6=$162;
      __label__ = 60; break;
    case 33: // $163
      var $164=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $165=$164.f0;
      $5=$165;
      var $166=$164.f1;
      $6=$166;
      __label__ = 58; break;
    case 34: // $167
      var $168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $169=$168.f0;
      $5=$169;
      var $170=$168.f1;
      $6=$170;
      ___cxa_free_exception($117);
      __label__ = 58; break;
    case 35: // $171
      var $172=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 33; break; };
    case 36: // $173
      var $174=HEAP32[((_SCREEN)>>2)];
      var $175=(function() { try { __THREW__ = false; return __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($172, $174) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 33; break; };
    case 37: // $176
      var $177=(function() { try { __THREW__ = false; return __Z8downcastIP13screen_device8device_tET_PT0_($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 33; break; };
    case 38: // $178
      var $179=(($8+560)|0);
      HEAP32[(($179)>>2)]=$177;
      var $180=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 33; break; };
    case 39: // $181
      var $182=$180;
      var $183=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 33; break; };
    case 40: // $184
      $device=$183;
      __label__ = 41; break;
    case 41: // $185
      var $186=$device;
      var $187=(($186)|0)!=0;
      if ($187) { __label__ = 42; break; } else { __label__ = 51; break; }
    case 42: // $188
      var $189=$device;
      var $190=(($189)|0)==0;
      if ($190) { __label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $191
      var $192=$189;
      var $193=___dynamic_cast($192, __ZTI8device_t, __ZTI10cpu_device, -1);
      var $194=$193;
      var $197 = $194;__label__ = 45; break;
    case 44: // $195
      var $197 = 0;__label__ = 45; break;
    case 45: // $196
      var $197;
      var $198=(($197)|0)!=0;
      if ($198) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $199
      var $200=$device;
      var $201=(function() { try { __THREW__ = false; return __Z8downcastIP10cpu_device8device_tET_PT0_($200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 33; break; };
    case 47: // $202
      var $203=(($8+428)|0);
      HEAP32[(($203)>>2)]=$201;
      __label__ = 51; break;
    case 48: // $204
      __label__ = 49; break;
    case 49: // $205
      var $206=$device;
      var $207=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 33; break; };
    case 50: // $208
      $device=$207;
      __label__ = 41; break;
    case 51: // $209
      var $210=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 33; break; };
    case 52: // $211
      var $212=(function() { try { __THREW__ = false; return __ZNK11emu_options5debugEv($210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 33; break; };
    case 53: // $213
      if ($212) { __label__ = 54; break; } else { __label__ = 57; break; }
    case 54: // $214
      var $215=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 33; break; };
    case 55: // $216
      var $217=(function() { try { __THREW__ = false; return __ZNK11emu_options14debug_internalEv($215) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 33; break; };
    case 56: // $218
      var $219=$217 ? 0 : 4096;
      var $220=3 | $219;
      var $221=(($8+584)|0);
      HEAP32[(($221)>>2)]=$220;
      __label__ = 57; break;
    case 57: // $222
      ;
      return;
    case 58: // $223
      var $224=(($8+1652)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22logerror_callback_itemEED1Ev($224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 77; break; }
    case 59: // $225
      __label__ = 60; break;
    case 60: // $226
      var $227=(($8+1484)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 77; break; }
    case 61: // $228
      __label__ = 62; break;
    case 62: // $229
      var $230=(($8+1396)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 77; break; }
    case 63: // $231
      __label__ = 64; break;
    case 64: // $232
      var $233=(($8+1332)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($233) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 77; break; }
    case 65: // $234
      __label__ = 66; break;
    case 66: // $235
      var $236=(($8+1160)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16device_schedulerD1Ev]($236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 77; break; }
    case 67: // $237
      __label__ = 68; break;
    case 68: // $238
      var $239=(($8+1088)|0);
      (function() { try { __THREW__ = false; return __ZN12save_managerD1Ev($239) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 77; break; }
    case 69: // $240
      __label__ = 70; break;
    case 70: // $241
      var $242=(($8+680)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI13memory_regionED1Ev($242) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 77; break; }
    case 71: // $243
      __label__ = 72; break;
    case 72: // $244
      var $245=(($8+20)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configED1Ev($245) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 77; break; }
    case 73: // $246
      __label__ = 74; break;
    case 74: // $247
      var $248=(($8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13resource_poolD1Ev]($248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 77; break; }
    case 75: // $249
      __label__ = 76; break;
    case 76: // $250
      var $251=$5;
      var $252=$5;
      var $253=$6;
      var $254=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $252, tempValue);
      var $255=($254.f1 = $253, $254);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 77: // $256
      var $257=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 78: // $258
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machineC2ERK14machine_configR13osd_interfaceb["X"]=1;

function __ZN15running_machineD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+1652)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22logerror_callback_itemEED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $6
      var $7=(($4+1552)|0);
      var $8=(($7)|0);
      var $9=(($8+100)|0);
      var $11 = $9;__label__ = 2; break;
    case 2: // $10
      var $11;
      var $12=(($11-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $13
      var $14=(($12)|0)==(($8)|0);
      if ($14) { __label__ = 4; break; } else { var $11 = $12;__label__ = 2; break; }
    case 4: // $15
      var $16=(($4+1484)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 20; break; }
    case 5: // $17
      var $18=(($4+1396)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 23; break; }
    case 6: // $19
      var $20=(($4+1332)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 26; break; }
    case 7: // $21
      var $22=(($4+1160)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16device_schedulerD1Ev]($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 29; break; }
    case 8: // $23
      var $24=(($4+1088)|0);
      (function() { try { __THREW__ = false; return __ZN12save_managerD1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 32; break; }
    case 9: // $25
      var $26=(($4+680)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI13memory_regionED1Ev($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 35; break; }
    case 10: // $27
      var $28=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configED1Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 38; break; }
    case 11: // $29
      var $30=(($4)|0);
      FUNCTION_TABLE[__ZN13resource_poolD1Ev]($30);
      ;
      return;
    case 12: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $2=$33;
      var $34=$32.f1;
      $3=$34;
      var $35=(($4+1552)|0);
      var $36=(($35)|0);
      var $37=(($36+100)|0);
      var $50 = $37;__label__ = 17; break;
    case 13: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $2=$40;
      var $41=$39.f1;
      $3=$41;
      var $42=(($8)|0)==(($12)|0);
      if ($42) { __label__ = 16; break; } else { var $44 = $12;__label__ = 14; break; }
    case 14: // $43
      var $44;
      var $45=(($44-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 44; break; }
    case 15: // $46
      var $47=(($45)|0)==(($8)|0);
      if ($47) { __label__ = 16; break; } else { var $44 = $45;__label__ = 14; break; }
    case 16: // $48
      __label__ = 21; break;
    case 17: // $49
      var $50;
      var $51=(($50-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 44; break; }
    case 18: // $52
      var $53=(($51)|0)==(($36)|0);
      if ($53) { __label__ = 19; break; } else { var $50 = $51;__label__ = 17; break; }
    case 19: // $54
      __label__ = 21; break;
    case 20: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $2=$57;
      var $58=$56.f1;
      $3=$58;
      __label__ = 24; break;
    case 21: // $59
      var $60=(($4+1484)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 44; break; }
    case 22: // $61
      __label__ = 24; break;
    case 23: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $2=$64;
      var $65=$63.f1;
      $3=$65;
      __label__ = 27; break;
    case 24: // $66
      var $67=(($4+1396)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 44; break; }
    case 25: // $68
      __label__ = 27; break;
    case 26: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $71=$70.f0;
      $2=$71;
      var $72=$70.f1;
      $3=$72;
      __label__ = 30; break;
    case 27: // $73
      var $74=(($4+1332)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 44; break; }
    case 28: // $75
      __label__ = 30; break;
    case 29: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $2=$78;
      var $79=$77.f1;
      $3=$79;
      __label__ = 33; break;
    case 30: // $80
      var $81=(($4+1160)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16device_schedulerD1Ev]($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 44; break; }
    case 31: // $82
      __label__ = 33; break;
    case 32: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $2=$85;
      var $86=$84.f1;
      $3=$86;
      __label__ = 36; break;
    case 33: // $87
      var $88=(($4+1088)|0);
      (function() { try { __THREW__ = false; return __ZN12save_managerD1Ev($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 44; break; }
    case 34: // $89
      __label__ = 36; break;
    case 35: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $92=$91.f0;
      $2=$92;
      var $93=$91.f1;
      $3=$93;
      __label__ = 39; break;
    case 36: // $94
      var $95=(($4+680)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI13memory_regionED1Ev($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 44; break; }
    case 37: // $96
      __label__ = 39; break;
    case 38: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $99=$98.f0;
      $2=$99;
      var $100=$98.f1;
      $3=$100;
      __label__ = 41; break;
    case 39: // $101
      var $102=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configED1Ev($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $103
      __label__ = 41; break;
    case 41: // $104
      var $105=(($4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13resource_poolD1Ev]($105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $106
      __label__ = 43; break;
    case 43: // $107
      var $108=$2;
      var $109=$2;
      var $110=$3;
      var $111=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $109, tempValue);
      var $112=($111.f1 = $110, $111);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 44: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machineD2Ev["X"]=1;

function __ZN15running_machine5startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i13=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i9=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $result_i3=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $31=__stackBase__+132;
      var $32=__stackBase__+136;
      var $33=__stackBase__+140;
      var $result_i1=__stackBase__+144;
      var $34=__stackBase__+148;
      var $35=__stackBase__+152;
      var $36=__stackBase__+156;
      var $37=__stackBase__+160;
      var $38=__stackBase__+164;
      var $result_i=__stackBase__+168;
      var $39=__stackBase__+172;
      var $40=__stackBase__+176;
      var $41;
      var $42;
      var $43;
      var $44=__stackBase__+180;
      var $45=__stackBase__+204;
      var $newbase;
      var $savegame;
      $41=$this;
      var $46=$41;
      __Z11config_initR15running_machine($46);
      var $47=__ZN15running_machine7respoolEv($46);
      var $48=$36;
      var $49=$37;
      var $50=$38;
      var $51=$result_i;
      var $52=$39;
      var $53=$40;
      HEAP32[(($36)>>2)]=4504;
      HEAP32[(($37)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($38)>>2)]=258;
      var $54=HEAP32[(($36)>>2)];
      var $55=HEAP32[(($37)>>2)];
      var $56=HEAP32[(($38)>>2)];
      var $57=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($54, $55, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $58
      HEAP32[(($result_i)>>2)]=$57;
      var $59=HEAP32[(($result_i)>>2)];
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $61
      var $62=___cxa_allocate_exception(4);
      var $63=$62;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($63);
      (function() { try { __THREW__ = false; return ___cxa_throw($62, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      HEAP32[(($39)>>2)]=$66;
      var $67=$65.f1;
      HEAP32[(($40)>>2)]=$67;
      var $68=HEAP32[(($40)>>2)];
      var $69=(($68)|0) < 0;
      if ($69) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $70
      var $71=HEAP32[(($39)>>2)];
      ___cxa_call_unexpected($71);
      throw "Reached an unreachable!"
    case 5: // $72
      var $73=HEAP32[(($39)>>2)];
      var $74=HEAP32[(($39)>>2)];
      var $75=HEAP32[(($40)>>2)];
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $78
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $79=HEAP32[(($result_i)>>2)];
      var $80=$36;
      var $81=$37;
      var $82=$38;
      var $83=$result_i;
      var $84=$39;
      var $85=$40;
      var $86=$79;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13input_managerC1ER15running_machine]($86, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 26; break; }
    case 8: // $87
      var $88=__ZN13resource_pool10add_objectI13input_managerEEPT_S3_($47, $86);
      var $89=(($46+1284)|0);
      HEAP32[(($89)>>2)]=$88;
      __Z11output_initR15running_machine($46);
      __Z12palette_initR15running_machine($46);
      var $90=__ZN15running_machine7respoolEv($46);
      var $91=$31;
      var $92=$32;
      var $93=$33;
      var $94=$result_i1;
      var $95=$34;
      var $96=$35;
      HEAP32[(($31)>>2)]=76;
      HEAP32[(($32)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($33)>>2)]=261;
      var $97=HEAP32[(($31)>>2)];
      var $98=HEAP32[(($32)>>2)];
      var $99=HEAP32[(($33)>>2)];
      var $100=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($97, $98, $99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $101
      HEAP32[(($result_i1)>>2)]=$100;
      var $102=HEAP32[(($result_i1)>>2)];
      var $103=(($102)|0)==0;
      if ($103) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $104
      var $105=___cxa_allocate_exception(4);
      var $106=$105;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($106);
      (function() { try { __THREW__ = false; return ___cxa_throw($105, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $107
      var $108=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $109=$108.f0;
      HEAP32[(($34)>>2)]=$109;
      var $110=$108.f1;
      HEAP32[(($35)>>2)]=$110;
      var $111=HEAP32[(($35)>>2)];
      var $112=(($111)|0) < 0;
      if ($112) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $113
      var $114=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($114);
      throw "Reached an unreachable!"
    case 13: // $115
      var $116=HEAP32[(($34)>>2)];
      var $117=HEAP32[(($34)>>2)];
      var $118=HEAP32[(($35)>>2)];
      var $119=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $117, tempValue);
      var $120=($119.f1 = $118, $119);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $121
      throw "Reached an unreachable!"
    case 15: // $_ZnwjPKci_exit2
      var $122=HEAP32[(($result_i1)>>2)];
      var $123=$31;
      var $124=$32;
      var $125=$33;
      var $126=$result_i1;
      var $127=$34;
      var $128=$35;
      var $129=$122;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14render_managerC1ER15running_machine]($129, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 31; break; }
    case 16: // $130
      var $131=__ZN13resource_pool10add_objectI14render_managerEEPT_S3_($90, $129);
      var $132=(($46+1280)|0);
      HEAP32[(($132)>>2)]=$131;
      __Z20generic_machine_initR15running_machine($46);
      var $133=__Z18generic_sound_initR15running_machine($46);
      var $134=(($46+1160)|0);
      HEAP32[(($45)>>2)]={ f0: 228, f1: 0 }.f0; HEAP32[(($45+4)>>2)]={ f0: 228, f1: 0 }.f1;
      __ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($44, $45, ((STRING_TABLE.__str52584)|0), $46);
      var $135=__ZN16device_scheduler11timer_allocE8delegateIFvPviEES1_($134, $44, 0);
      var $136=(($46+1316)|0);
      HEAP32[(($136)>>2)]=$135;
      var $137=(($46+676)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$138;
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+8)|0);
      var $142=HEAP32[(($141)>>2)];
      FUNCTION_TABLE[$142]($138, $46);
      var $143=__ZN15running_machine7respoolEv($46);
      var $144=$26;
      var $145=$27;
      var $146=$28;
      var $147=$result_i3;
      var $148=$29;
      var $149=$30;
      HEAP32[(($26)>>2)]=188;
      HEAP32[(($27)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($28)>>2)]=272;
      var $150=HEAP32[(($26)>>2)];
      var $151=HEAP32[(($27)>>2)];
      var $152=HEAP32[(($28)>>2)];
      var $153=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($150, $151, $152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $154
      HEAP32[(($result_i3)>>2)]=$153;
      var $155=HEAP32[(($result_i3)>>2)];
      var $156=(($155)|0)==0;
      if ($156) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $157
      var $158=___cxa_allocate_exception(4);
      var $159=$158;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($159);
      (function() { try { __THREW__ = false; return ___cxa_throw($158, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $160
      var $161=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $162=$161.f0;
      HEAP32[(($29)>>2)]=$162;
      var $163=$161.f1;
      HEAP32[(($30)>>2)]=$163;
      var $164=HEAP32[(($30)>>2)];
      var $165=(($164)|0) < 0;
      if ($165) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $166
      var $167=HEAP32[(($29)>>2)];
      ___cxa_call_unexpected($167);
      throw "Reached an unreachable!"
    case 21: // $168
      var $169=HEAP32[(($29)>>2)];
      var $170=HEAP32[(($29)>>2)];
      var $171=HEAP32[(($30)>>2)];
      var $172=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $170, tempValue);
      var $173=($172.f1 = $171, $172);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $174
      throw "Reached an unreachable!"
    case 23: // $_ZnwjPKci_exit4
      var $175=HEAP32[(($result_i3)>>2)];
      var $176=$26;
      var $177=$27;
      var $178=$28;
      var $179=$result_i3;
      var $180=$29;
      var $181=$30;
      var $182=$175;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13video_managerC1ER15running_machine]($182, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 36; break; }
    case 24: // $183
      var $184=__ZN13resource_pool10add_objectI13video_managerEEPT_S3_($143, $182);
      var $185=(($46+1292)|0);
      HEAP32[(($185)>>2)]=$184;
      var $186=__Z7ui_initR15running_machine($46);
      var $187=(($46+1328)|0);
      var $188=_time($187);
      var $189=__Z15input_port_initR15running_machine($46);
      $newbase=$189;
      var $190=$newbase;
      var $191=(($190)|0)!=0;
      if ($191) { __label__ = 25; break; } else { __label__ = 41; break; }
    case 25: // $192
      var $193=$newbase;
      var $194=(($46+1328)|0);
      HEAP32[(($194)>>2)]=$193;
      __label__ = 41; break;
    case 26: // $195
      var $196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $197=$196.f0;
      $42=$197;
      var $198=$196.f1;
      $43=$198;
      var $199=$23;
      var $200=$24;
      var $201=$25;
      HEAP32[(($23)>>2)]=$79;
      HEAP32[(($24)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($25)>>2)]=258;
      var $202=HEAP32[(($23)>>2)];
      var $203=(($202)|0)!=0;
      if ($203) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $204
      var $205=HEAP32[(($23)>>2)];
      var $206=HEAP32[(($24)>>2)];
      var $207=HEAP32[(($25)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($205, $206, $207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 77; break; }
    case 28: // $_noexc
      __label__ = 29; break;
    case 29: // $_ZdlPvPKci_exit
      var $208=$23;
      var $209=$24;
      var $210=$25;
      __label__ = 30; break;
    case 30: // $211
      __label__ = 76; break;
    case 31: // $212
      var $213=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $214=$213.f0;
      $42=$214;
      var $215=$213.f1;
      $43=$215;
      var $216=$20;
      var $217=$21;
      var $218=$22;
      HEAP32[(($20)>>2)]=$122;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($22)>>2)]=261;
      var $219=HEAP32[(($20)>>2)];
      var $220=(($219)|0)!=0;
      if ($220) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $221
      var $222=HEAP32[(($20)>>2)];
      var $223=HEAP32[(($21)>>2)];
      var $224=HEAP32[(($22)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($222, $223, $224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 77; break; }
    case 33: // $_noexc5
      __label__ = 34; break;
    case 34: // $_ZdlPvPKci_exit6
      var $225=$20;
      var $226=$21;
      var $227=$22;
      __label__ = 35; break;
    case 35: // $228
      __label__ = 76; break;
    case 36: // $229
      var $230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $231=$230.f0;
      $42=$231;
      var $232=$230.f1;
      $43=$232;
      var $233=$17;
      var $234=$18;
      var $235=$19;
      HEAP32[(($17)>>2)]=$175;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($19)>>2)]=272;
      var $236=HEAP32[(($17)>>2)];
      var $237=(($236)|0)!=0;
      if ($237) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $238
      var $239=HEAP32[(($17)>>2)];
      var $240=HEAP32[(($18)>>2)];
      var $241=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($239, $240, $241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 77; break; }
    case 38: // $_noexc7
      __label__ = 39; break;
    case 39: // $_ZdlPvPKci_exit8
      var $242=$17;
      var $243=$18;
      var $244=$19;
      __label__ = 40; break;
    case 40: // $245
      __label__ = 76; break;
    case 41: // $246
      __Z13ui_input_initR15running_machine($46);
      var $247=__ZN15running_machine7respoolEv($46);
      var $248=$12;
      var $249=$13;
      var $250=$14;
      var $251=$result_i9;
      var $252=$15;
      var $253=$16;
      HEAP32[(($12)>>2)]=80;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($14)>>2)]=289;
      var $254=HEAP32[(($12)>>2)];
      var $255=HEAP32[(($13)>>2)];
      var $256=HEAP32[(($14)>>2)];
      var $257=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($254, $255, $256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 44; break; };
    case 42: // $258
      HEAP32[(($result_i9)>>2)]=$257;
      var $259=HEAP32[(($result_i9)>>2)];
      var $260=(($259)|0)==0;
      if ($260) { __label__ = 43; break; } else { __label__ = 48; break; }
    case 43: // $261
      var $262=___cxa_allocate_exception(4);
      var $263=$262;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($263);
      (function() { try { __THREW__ = false; return ___cxa_throw($262, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 44; break; }
    case 44: // $264
      var $265=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $266=$265.f0;
      HEAP32[(($15)>>2)]=$266;
      var $267=$265.f1;
      HEAP32[(($16)>>2)]=$267;
      var $268=HEAP32[(($16)>>2)];
      var $269=(($268)|0) < 0;
      if ($269) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $270
      var $271=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($271);
      throw "Reached an unreachable!"
    case 46: // $272
      var $273=HEAP32[(($15)>>2)];
      var $274=HEAP32[(($15)>>2)];
      var $275=HEAP32[(($16)>>2)];
      var $276=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $274, tempValue);
      var $277=($276.f1 = $275, $276);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 47: // $278
      throw "Reached an unreachable!"
    case 48: // $_ZnwjPKci_exit10
      var $279=HEAP32[(($result_i9)>>2)];
      var $280=$12;
      var $281=$13;
      var $282=$14;
      var $283=$result_i9;
      var $284=$15;
      var $285=$16;
      var $286=$279;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13sound_managerC1ER15running_machine]($286, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $287
      var $288=__ZN13resource_pool10add_objectI13sound_managerEEPT_S3_($247, $286);
      var $289=(($46+1288)|0);
      HEAP32[(($289)>>2)]=$288;
      __Z8rom_initR15running_machine($46);
      __Z11memory_initR15running_machine($46);
      __Z13watchdog_initR15running_machine($46);
      __Z18generic_video_initR15running_machine($46);
      __Z8gfx_initR15running_machine($46);
      __Z11inputx_initR15running_machine($46);
      __Z10image_initR15running_machine($46);
      __Z12tilemap_initR15running_machine($46);
      __Z14crosshair_initR15running_machine($46);
      var $290=(($46+584)|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=$291 & 1;
      var $293=(($292)|0)!=0;
      if ($293) { __label__ = 50; break; } else { __label__ = 56; break; }
    case 50: // $294
      __Z13debugger_initR15running_machine($46);
      __label__ = 56; break;
    case 51: // $295
      var $296=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $297=$296.f0;
      $42=$297;
      var $298=$296.f1;
      $43=$298;
      var $299=$9;
      var $300=$10;
      var $301=$11;
      HEAP32[(($9)>>2)]=$279;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($11)>>2)]=289;
      var $302=HEAP32[(($9)>>2)];
      var $303=(($302)|0)!=0;
      if ($303) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $304
      var $305=HEAP32[(($9)>>2)];
      var $306=HEAP32[(($10)>>2)];
      var $307=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($305, $306, $307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 77; break; }
    case 53: // $_noexc11
      __label__ = 54; break;
    case 54: // $_ZdlPvPKci_exit12
      var $308=$9;
      var $309=$10;
      var $310=$11;
      __label__ = 55; break;
    case 55: // $311
      __label__ = 76; break;
    case 56: // $312
      __Z19ui_set_startup_textR15running_machinePKci($46, ((STRING_TABLE.__str62585)|0), 1);
      var $313=__ZNK15running_machine10devicelistEv($46);
      __ZN11device_list9start_allEv($313);
      var $314=__ZNK15running_machine7optionsEv($46);
      var $315=__ZNK11emu_options5stateEv($314);
      $savegame=$315;
      var $316=$savegame;
      var $317=(($316)|0);
      var $318=HEAP8[($317)];
      var $319=(($318 << 24) >> 24);
      var $320=(($319)|0)!=0;
      if ($320) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $321
      var $322=$savegame;
      __ZN15running_machine13schedule_loadEPKc($46, $322);
      __label__ = 62; break;
    case 58: // $323
      var $324=__ZNK15running_machine7optionsEv($46);
      var $325=__ZNK11emu_options8autosaveEv($324);
      if ($325) { __label__ = 59; break; } else { __label__ = 61; break; }
    case 59: // $326
      var $327=(($46+672)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=(($328+44)|0);
      var $330=HEAP32[(($329)>>2)];
      var $331=$330 & 2048;
      var $332=(($331)|0)!=0;
      if ($332) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $333
      __ZN15running_machine13schedule_loadEPKc($46, ((STRING_TABLE.__str72586)|0));
      __label__ = 61; break;
    case 61: // $334
      __label__ = 62; break;
    case 62: // $335
      var $336=__ZN15running_machine7respoolEv($46);
      var $337=$4;
      var $338=$5;
      var $339=$6;
      var $340=$result_i13;
      var $341=$7;
      var $342=$8;
      HEAP32[(($4)>>2)]=3720;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($6)>>2)]=333;
      var $343=HEAP32[(($4)>>2)];
      var $344=HEAP32[(($5)>>2)];
      var $345=HEAP32[(($6)>>2)];
      var $346=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($343, $344, $345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; };
    case 63: // $347
      HEAP32[(($result_i13)>>2)]=$346;
      var $348=HEAP32[(($result_i13)>>2)];
      var $349=(($348)|0)==0;
      if ($349) { __label__ = 64; break; } else { __label__ = 69; break; }
    case 64: // $350
      var $351=___cxa_allocate_exception(4);
      var $352=$351;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($352);
      (function() { try { __THREW__ = false; return ___cxa_throw($351, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 65; break; }
    case 65: // $353
      var $354=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $355=$354.f0;
      HEAP32[(($7)>>2)]=$355;
      var $356=$354.f1;
      HEAP32[(($8)>>2)]=$356;
      var $357=HEAP32[(($8)>>2)];
      var $358=(($357)|0) < 0;
      if ($358) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $359
      var $360=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($360);
      throw "Reached an unreachable!"
    case 67: // $361
      var $362=HEAP32[(($7)>>2)];
      var $363=HEAP32[(($7)>>2)];
      var $364=HEAP32[(($8)>>2)];
      var $365=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $363, tempValue);
      var $366=($365.f1 = $364, $365);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $367
      throw "Reached an unreachable!"
    case 69: // $_ZnwjPKci_exit14
      var $368=HEAP32[(($result_i13)>>2)];
      var $369=$4;
      var $370=$5;
      var $371=$6;
      var $372=$result_i13;
      var $373=$7;
      var $374=$8;
      var $375=$368;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13cheat_managerC1ER15running_machine]($375, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $376
      var $377=__ZN13resource_pool10add_objectI13cheat_managerEEPT_S3_($336, $375);
      var $378=(($46+1276)|0);
      HEAP32[(($378)>>2)]=$377;
      var $379=(($46+1088)|0);
      __ZN12save_manager18allow_registrationEb($379, 0);
      STACKTOP = __stackBase__;
      return;
    case 71: // $380
      var $381=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $382=$381.f0;
      $42=$382;
      var $383=$381.f1;
      $43=$383;
      var $384=$1;
      var $385=$2;
      var $386=$3;
      HEAP32[(($1)>>2)]=$368;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($3)>>2)]=333;
      var $387=HEAP32[(($1)>>2)];
      var $388=(($387)|0)!=0;
      if ($388) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $389
      var $390=HEAP32[(($1)>>2)];
      var $391=HEAP32[(($2)>>2)];
      var $392=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($390, $391, $392) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 77; break; }
    case 73: // $_noexc15
      __label__ = 74; break;
    case 74: // $_ZdlPvPKci_exit16
      var $393=$1;
      var $394=$2;
      var $395=$3;
      __label__ = 75; break;
    case 75: // $396
      __label__ = 76; break;
    case 76: // $397
      var $398=$42;
      var $399=$42;
      var $400=$43;
      var $401=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $399, tempValue);
      var $402=($401.f1 = $400, $401);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 77: // $403
      var $404=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine5startEv["X"]=1;

function __ZN13resource_pool10add_objectI13input_managerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13input_managerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13input_managerEEPT_S3_["X"]=1;

function __ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvPviEEC2I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN15running_machine10soft_resetEPvi($this, $ptr, $param) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$ptr;
  $3=$param;
  var $4=$1;
  __ZN15running_machine8logerrorEPKcz($4, ((STRING_TABLE.__str332612)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
  var $5=(($4+1304)|0);
  HEAP32[(($5)>>2)]=2;
  __ZN15running_machine14call_notifiersE20machine_notification($4, 1);
  var $6=(($4+1304)|0);
  HEAP32[(($6)>>2)]=3;
  STACKTOP = __stackBase__;
  return;
}


function __ZNK11emu_options5stateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str422623)|0));
  ;
  return $4;
}


function __ZN15running_machine13schedule_loadEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$filename;
  var $4=$1;
  var $5=$2;
  __ZN15running_machine21set_saveload_filenameEPKc($4, $5);
  var $6=(($4+1468)|0);
  HEAP32[(($6)>>2)]=2;
  var $7=(($4+1472)|0);
  __ZNK15running_machine4timeEv($3, $4);
  var $8=$7;
  var $9=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[(($9+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[(($9+8)>>2)];
  __ZN15running_machine6resumeEv($4);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK11emu_options8autosaveEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str412622)|0));
  ;
  return $4;
}


function __ZN13resource_pool10add_objectI14render_managerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14render_managerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14render_managerEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI13video_managerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13video_managerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13video_managerEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI13sound_managerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13sound_managerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13sound_managerEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI13cheat_managerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13cheat_managerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13cheat_managerEEPT_S3_["X"]=1;

function __ZN15running_machine18add_dynamic_deviceER8device_tPFPS0_RK14machine_configPKcS2_jES7_j($this, $owner, $type, $tag, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $fulltag=__stackBase__;
      var $7;
      var $8;
      var $device;
      var $curdevice;
      var $machconfig;
      var $curdevice1;
      var $9;
      $2=$this;
      $3=$owner;
      $4=$type;
      $5=$tag;
      $6=$clock;
      var $10=$2;
      __ZN7astringC1Ev($fulltag);
      var $11=$3;
      var $12=$5;
      var $13=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($11, $fulltag, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 16; break; };
    case 1: // $14
      var $15=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 16; break; };
    case 2: // $16
      var $17=$15;
      var $18=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 16; break; };
    case 3: // $19
      var $20=$4;
      var $21=(($10+668)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 16; break; };
    case 4: // $24
      var $25=$3;
      var $26=$6;
      var $27=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$20]($22, $23, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 16; break; };
    case 5: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN11tagged_listI8device_tE6appendEPKcRS0_($17, $18, $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 16; break; };
    case 6: // $30
      $device=$29;
      var $31=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 16; break; };
    case 7: // $32
      var $33=$31;
      var $34=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 16; break; };
    case 8: // $35
      $curdevice=$34;
      __label__ = 9; break;
    case 9: // $36
      var $37=$curdevice;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 10; break; } else { __label__ = 21; break; }
    case 10: // $39
      var $40=$curdevice;
      var $41=(function() { try { __THREW__ = false; return __ZNK8device_t10configuredEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $42
      if ($41) { __label__ = 18; break; } else { __label__ = 12; break; }
    case 12: // $43
      var $44=$curdevice;
      var $45=(function() { try { __THREW__ = false; return __ZNK8device_t24machine_config_additionsEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; };
    case 13: // $46
      $machconfig=$45;
      var $47=$machconfig;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $49
      var $50=$machconfig;
      var $51=(($10+668)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$curdevice;
      var $54=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$50]($52, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; };
    case 15: // $55
      __label__ = 17; break;
    case 16: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      $7=$58;
      var $59=$57.f1;
      $8=$59;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 17: // $60
      __label__ = 18; break;
    case 18: // $61
      __label__ = 19; break;
    case 19: // $62
      var $63=$curdevice;
      var $64=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 16; break; };
    case 20: // $65
      $curdevice=$64;
      __label__ = 9; break;
    case 21: // $66
      var $67=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 16; break; };
    case 22: // $68
      var $69=$67;
      var $70=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 16; break; };
    case 23: // $71
      $curdevice1=$70;
      __label__ = 24; break;
    case 24: // $72
      var $73=$curdevice1;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 25; break; } else { __label__ = 32; break; }
    case 25: // $75
      var $76=$curdevice1;
      var $77=(function() { try { __THREW__ = false; return __ZNK8device_t10configuredEv($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 16; break; };
    case 26: // $78
      if ($77) { __label__ = 29; break; } else { __label__ = 27; break; }
    case 27: // $79
      var $80=$curdevice1;
      (function() { try { __THREW__ = false; return __ZN8device_t15config_completeEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 16; break; }
    case 28: // $81
      __label__ = 29; break;
    case 29: // $82
      __label__ = 30; break;
    case 30: // $83
      var $84=$curdevice1;
      var $85=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 16; break; };
    case 31: // $86
      $curdevice1=$85;
      __label__ = 24; break;
    case 32: // $87
      var $88=$device;
      $1=$88;
      $9=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      var $89=$1;
      STACKTOP = __stackBase__;
      return $89;
    case 33: // $90
      __label__ = 34; break;
    case 34: // $91
      var $92=$7;
      var $93=$7;
      var $94=$8;
      var $95=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $93, tempValue);
      var $96=($95.f1 = $94, $95);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine18add_dynamic_deviceER8device_tPFPS0_RK14machine_configPKcS2_jES7_j["X"]=1;

function __ZNK11emu_options3logEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str392620)|0));
  ;
  return $4;
}


function __ZN15running_machine16logfile_callbackERS_PKc($machine, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$machine;
      $2=$buffer;
      var $3=$1;
      var $4=(($3+1464)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+1464)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZN8emu_file4putsEPKc($10, $11);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13sound_manager7ui_muteEb($this, $turn_off) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($turn_off)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  __ZN13sound_manager4muteEbh($4, $6, 2);
  ;
  return;
}


function __ZN15running_machine3runEb($this, $firstrun) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $error;
      var $11;
      var $12;
      var $filerr;
      var $settingsloaded;
      var $13;
      var $14;
      var $fatal;
      $9=$this;
      var $15=(($firstrun)&1);
      $10=$15;
      var $16=$9;
      $error=0;
      var $17=(($16+1304)|0);
      HEAP32[(($17)>>2)]=1;
      var $18=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 20; break; };
    case 1: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK11emu_options3logEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 20; break; };
    case 2: // $21
      if ($20) { __label__ = 3; break; } else { __label__ = 45; break; }
    case 3: // $22
      var $23=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 20; break; };
    case 4: // $24
      var $25=$4;
      var $26=$5;
      var $27=$6;
      var $28=$result_i;
      var $29=$7;
      var $30=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($6)>>2)]=385;
      var $31=HEAP32[(($4)>>2)];
      var $32=HEAP32[(($5)>>2)];
      var $33=HEAP32[(($6)>>2)];
      var $34=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31, $32, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $35
      HEAP32[(($result_i)>>2)]=$34;
      var $36=HEAP32[(($result_i)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $38
      var $39=___cxa_allocate_exception(4);
      var $40=$39;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40);
      (function() { try { __THREW__ = false; return ___cxa_throw($39, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 7; break; }
    case 7: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc]);
      var $43=$42.f0;
      HEAP32[(($7)>>2)]=$43;
      var $44=$42.f1;
      HEAP32[(($8)>>2)]=$44;
      var $45=HEAP32[(($8)>>2)];
      var $46=(($45)|0) < 0;
      if ($46) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $47
      var $48=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 20; break; }
    case 9: // $_noexc
      throw "Reached an unreachable!"
    case 10: // $49
      var $50=HEAP32[(($7)>>2)];
      var $51=HEAP32[(($7)>>2)];
      var $52=HEAP32[(($8)>>2)];
      var $53=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $51, tempValue);
      var $54=($53.f1 = $52, $53);
      var $eh_lpad_body = $54;__label__ = 21; break;
    case 11: // $55
      throw "Reached an unreachable!"
    case 12: // $_ZnwjPKci_exit
      var $56=HEAP32[(($result_i)>>2)];
      var $57=$4;
      var $58=$5;
      var $59=$6;
      var $60=$result_i;
      var $61=$7;
      var $62=$8;
      __label__ = 13; break;
    case 13: // $63
      var $64=$56;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1Ej]($64, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 22; break; }
    case 14: // $65
      var $66=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI8emu_fileEEPT_S3_($23, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 20; break; };
    case 15: // $67
      var $68=(($16+1464)|0);
      HEAP32[(($68)>>2)]=$66;
      var $69=(($16+1464)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($70, ((STRING_TABLE.__str82587)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; };
    case 16: // $72
      $filerr=$71;
      __label__ = 17; break;
    case 17: // $73
      var $74=$filerr;
      var $75=(($74)|0)==0;
      if ($75) { __label__ = 41; break; } else { __label__ = 18; break; }
    case 18: // $76
      var $77=___cxa_allocate_exception(1032);
      var $78=$77;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($78, ((STRING_TABLE.__str92588)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str102589)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str42583)|0),HEAP32[((tempInt+8)>>2)]=387,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 27; break; }
    case 19: // $79
      (function() { try { __THREW__ = false; return ___cxa_throw($77, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 20; break; }
    case 20: // $80
      var $81=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc]);
      var $eh_lpad_body = $81;__label__ = 21; break;
    case 21: // $_body
      var $eh_lpad_body;
      var $82=$eh_lpad_body.f0;
      $11=$82;
      var $83=$eh_lpad_body.f1;
      $12=$83;
      __label__ = 28; break;
    case 22: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc]);
      var $86=$85.f0;
      $11=$86;
      var $87=$85.f1;
      $12=$87;
      var $88=$1;
      var $89=$2;
      var $90=$3;
      HEAP32[(($1)>>2)]=$56;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($3)>>2)]=385;
      var $91=HEAP32[(($1)>>2)];
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $93
      var $94=HEAP32[(($1)>>2)];
      var $95=HEAP32[(($2)>>2)];
      var $96=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($94, $95, $96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 82; break; }
    case 24: // $_noexc1
      __label__ = 25; break;
    case 25: // $_ZdlPvPKci_exit
      var $97=$1;
      var $98=$2;
      var $99=$3;
      __label__ = 26; break;
    case 26: // $100
      __label__ = 28; break;
    case 27: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror,__ZTI13emu_exception,__ZTISt9bad_alloc]);
      var $103=$102.f0;
      $11=$103;
      var $104=$102.f1;
      $12=$104;
      ___cxa_free_exception($77);
      __label__ = 28; break;
    case 28: // $105
      var $106=$12;
      var $107=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $108=(($106)|0)==(($107)|0);
      if ($108) { __label__ = 29; break; } else { __label__ = 35; break; }
    case 29: // $109
      var $110=$11;
      var $111=___cxa_begin_catch($110);
      var $112=$111;
      $fatal=$112;
      var $113=$fatal;
      var $114=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 77; break; };
    case 30: // $115
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str132592)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$114,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 77; break; }
    case 31: // $116
      $error=3;
      var $117=$fatal;
      var $118=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror8exitcodeEv($117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 77; break; };
    case 32: // $119
      var $120=(($118)|0)!=0;
      if ($120) { __label__ = 33; break; } else { __label__ = 78; break; }
    case 33: // $121
      var $122=$fatal;
      var $123=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror8exitcodeEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 77; break; };
    case 34: // $124
      $error=$123;
      __label__ = 78; break;
    case 35: // $125
      var $126=_llvm_eh_typeid_for(__ZTI13emu_exception);
      var $127=(($106)|0)==(($126)|0);
      if ($127) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $128
      var $129=$11;
      var $130=___cxa_begin_catch($129);
      var $131=$130;
      $14=$131;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str122591)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 75; break; }
    case 37: // $132
      $error=3;
      ___cxa_end_catch();
      __label__ = 79; break;
    case 38: // $133
      var $134=_llvm_eh_typeid_for(__ZTISt9bad_alloc);
      var $135=(($106)|0)==(($134)|0);
      if ($135) { __label__ = 39; break; } else { __label__ = 81; break; }
    case 39: // $136
      var $137=$11;
      var $138=___cxa_begin_catch($137);
      var $139=$138;
      $13=$139;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str112590)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 73; break; }
    case 40: // $140
      $error=3;
      ___cxa_end_catch();
      __label__ = 79; break;
    case 41: // $141
      __label__ = 42; break;
    case 42: // $142
      __label__ = 43; break;
    case 43: // $143
      (function() { try { __THREW__ = false; return __ZN15running_machine21add_logerror_callbackEPFvRS_PKcE($16, 230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 20; break; }
    case 44: // $144
      __label__ = 45; break;
    case 45: // $145
      (function() { try { __THREW__ = false; return __ZN15running_machine5startEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 20; break; }
    case 46: // $146
      var $147=(function() { try { __THREW__ = false; return __Z20config_load_settingsR15running_machine($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 20; break; };
    case 47: // $148
      var $149=(($147)|0)!=0;
      var $150=(($149)&1);
      $settingsloaded=$150;
      (function() { try { __THREW__ = false; return __Z10nvram_loadR15running_machine($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 20; break; }
    case 48: // $151
      var $152=(function() { try { __THREW__ = false; return __ZNK15running_machine5soundEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 20; break; };
    case 49: // $153
      (function() { try { __THREW__ = false; return __ZN13sound_manager7ui_muteEb($152, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 20; break; }
    case 50: // $154
      var $155=$10;
      var $156=(($155) & 1);
      var $157=(($156)&1);
      var $158=$settingsloaded;
      var $159=(($158) & 1);
      var $160=$159 ^ 1;
      var $161=(($160)&1);
      var $162=(function() { try { __THREW__ = false; return __Z26ui_display_startup_screensR15running_machineii($16, $157, $161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 20; break; };
    case 51: // $163
      (function() { try { __THREW__ = false; return __ZN15running_machine10soft_resetEPvi($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 20; break; }
    case 52: // $164
      var $165=(($16+1309)|0);
      HEAP8[($165)]=0;
      __label__ = 53; break;
    case 53: // $166
      var $167=(($16+1309)|0);
      var $168=HEAP8[($167)];
      var $169=(($168) & 1);
      if ($169) { __label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $170
      var $171=(($16+1310)|0);
      var $172=HEAP8[($171)];
      var $173=(($172) & 1);
      if ($173) { __label__ = 55; break; } else { var $179 = 1;__label__ = 56; break; }
    case 55: // $174
      var $175=(($16+1468)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176)|0)!=0;
      var $179 = $177;__label__ = 56; break;
    case 56: // $178
      var $179;
      if ($179) { __label__ = 57; break; } else { __label__ = 68; break; }
    case 57: // $180
      (function() { try { __THREW__ = false; return __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 273) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 20; break; }
    case 58: // $181
      var $182=(($16+1308)|0);
      var $183=HEAP8[($182)];
      var $184=(($183) & 1);
      if ($184) { __label__ = 61; break; } else { __label__ = 59; break; }
    case 59: // $185
      var $186=(($16+1160)|0);
      (function() { try { __THREW__ = false; return __ZN16device_scheduler9timesliceEv($186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 20; break; }
    case 60: // $187
      __label__ = 63; break;
    case 61: // $188
      var $189=(($16+1292)|0);
      var $190=HEAP32[(($189)>>2)];
      (function() { try { __THREW__ = false; return __ZN13video_manager12frame_updateEb($190, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 20; break; }
    case 62: // $191
      __label__ = 63; break;
    case 63: // $192
      var $193=(($16+1468)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 64: // $196
      (function() { try { __THREW__ = false; return __ZN15running_machine15handle_saveloadEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 20; break; }
    case 65: // $197
      __label__ = 66; break;
    case 66: // $198
      (function() { try { __THREW__ = false; return __ZN20dummy_profiler_state4stopEv(_g_profiler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 20; break; }
    case 67: // $199
      __label__ = 53; break;
    case 68: // $200
      var $201=(($16+1304)|0);
      HEAP32[(($201)>>2)]=4;
      var $202=(function() { try { __THREW__ = false; return __ZNK15running_machine5soundEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 20; break; };
    case 69: // $203
      (function() { try { __THREW__ = false; return __ZN13sound_manager7ui_muteEb($202, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 20; break; }
    case 70: // $204
      (function() { try { __THREW__ = false; return __Z10nvram_saveR15running_machine($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 20; break; }
    case 71: // $205
      (function() { try { __THREW__ = false; return __Z20config_save_settingsR15running_machine($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 20; break; }
    case 72: // $206
      __label__ = 79; break;
    case 73: // $207
      var $208=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $209=$208.f0;
      $11=$209;
      var $210=$208.f1;
      $12=$210;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 82; break; }
    case 74: // $211
      __label__ = 81; break;
    case 75: // $212
      var $213=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $214=$213.f0;
      $11=$214;
      var $215=$213.f1;
      $12=$215;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 82; break; }
    case 76: // $216
      __label__ = 81; break;
    case 77: // $217
      var $218=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $219=$218.f0;
      $11=$219;
      var $220=$218.f1;
      $12=$220;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 82; break; }
    case 78: // $221
      ___cxa_end_catch();
      __label__ = 79; break;
    case 79: // $222
      __ZN15running_machine14call_notifiersE20machine_notification($16, 4);
      __Z20zip_file_cache_clearv();
      var $223=__ZN15running_machine7respoolEv($16);
      var $224=(($16+1464)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$225;
      __ZN13resource_pool6removeEPv($223, $226);
      var $227=$error;
      STACKTOP = __stackBase__;
      return $227;
    case 80: // $228
      __label__ = 81; break;
    case 81: // $229
      var $230=$11;
      var $231=$11;
      var $232=$12;
      var $233=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $231, tempValue);
      var $234=($233.f1 = $232, $233);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 82: // $235
      var $236=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 83: // $237
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine3runEb["X"]=1;

function __ZN15running_machine21add_logerror_callbackEPFvRS_PKcE($this, $callback) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      $9=$this;
      $10=$callback;
      var $13=$9;
      __label__ = 1; break;
    case 1: // $14
      var $15=(($13+1304)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==1;
      if ($17) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $18
      var $19=___cxa_allocate_exception(1032);
      var $20=$19;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($20, ((STRING_TABLE.__str92588)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str192598)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str42583)|0),HEAP32[((tempInt+8)>>2)]=677,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      ___cxa_throw($19, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $11=$24;
      var $25=$23.f1;
      $12=$25;
      ___cxa_free_exception($19);
      __label__ = 20; break;
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=(($13+1652)|0);
      var $29=__ZN15running_machine7respoolEv($13);
      var $30=$4;
      var $31=$5;
      var $32=$6;
      var $33=$result_i;
      var $34=$7;
      var $35=$8;
      HEAP32[(($4)>>2)]=8;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($6)>>2)]=678;
      var $36=HEAP32[(($4)>>2)];
      var $37=HEAP32[(($5)>>2)];
      var $38=HEAP32[(($6)>>2)];
      var $39=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($36, $37, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $40
      HEAP32[(($result_i)>>2)]=$39;
      var $41=HEAP32[(($result_i)>>2)];
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $43
      var $44=___cxa_allocate_exception(4);
      var $45=$44;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($45);
      (function() { try { __THREW__ = false; return ___cxa_throw($44, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      HEAP32[(($7)>>2)]=$48;
      var $49=$47.f1;
      HEAP32[(($8)>>2)]=$49;
      var $50=HEAP32[(($8)>>2)];
      var $51=(($50)|0) < 0;
      if ($51) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $52
      var $53=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 11: // $54
      var $55=HEAP32[(($7)>>2)];
      var $56=HEAP32[(($7)>>2)];
      var $57=HEAP32[(($8)>>2)];
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $60
      throw "Reached an unreachable!"
    case 13: // $_ZnwjPKci_exit
      var $61=HEAP32[(($result_i)>>2)];
      var $62=$4;
      var $63=$5;
      var $64=$6;
      var $65=$result_i;
      var $66=$7;
      var $67=$8;
      var $68=$61;
      var $69=$10;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15running_machine22logerror_callback_itemC1EPFvRS_PKcE]($68, $69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $70
      var $71=__ZN13resource_pool10add_objectIN15running_machine22logerror_callback_itemEEEPT_S4_($29, $68);
      var $72=__ZN11simple_listIN15running_machine22logerror_callback_itemEE6appendERS1_($28, $71);
      STACKTOP = __stackBase__;
      return;
    case 15: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $75=$74.f0;
      $11=$75;
      var $76=$74.f1;
      $12=$76;
      var $77=$1;
      var $78=$2;
      var $79=$3;
      HEAP32[(($1)>>2)]=$61;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($3)>>2)]=678;
      var $80=HEAP32[(($1)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $82
      var $83=HEAP32[(($1)>>2)];
      var $84=HEAP32[(($2)>>2)];
      var $85=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($83, $84, $85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $_noexc
      __label__ = 18; break;
    case 18: // $_ZdlPvPKci_exit
      var $86=$1;
      var $87=$2;
      var $88=$3;
      __label__ = 19; break;
    case 19: // $89
      __label__ = 20; break;
    case 20: // $90
      var $91=$11;
      var $92=$11;
      var $93=$12;
      var $94=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $92, tempValue);
      var $95=($94.f1 = $93, $94);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $96
      var $97=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine21add_logerror_callbackEPFvRS_PKcE["X"]=1;

function __ZNK14render_manager12ui_containerEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+52)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine14call_notifiersE20machine_notification($this, $which) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cb;
      $1=$this;
      $2=$which;
      var $3=$1;
      var $4=$2;
      var $5=(($3+1552)|0);
      var $6=(($5+$4*20)|0);
      var $7=__ZNK11simple_listIN15running_machine22notifier_callback_itemEE5firstEv($6);
      $cb=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$cb;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$cb;
      var $13=(($12+4)|0);
      var $14=$13;
      __ZNK13delegate_baseIv8_noparamS0_S0_S0_EclEv($14);
      __label__ = 3; break;
    case 3: // $15
      var $16=$cb;
      var $17=__ZNK15running_machine22notifier_callback_item4nextEv($16);
      $cb=$17;
      __label__ = 1; break;
    case 4: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine13schedule_exitEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$this;
      var $3=$1;
      var $4=(($3+1311)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=__ZNK15running_machine7optionsEv($3);
      var $9=__ZNK11emu_options11system_nameEv($8);
      var $10=(($9)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=__ZNK15running_machine7optionsEv($3);
      __ZN11emu_options15set_system_nameEPKc($15, ((__str142593)|0));
      var $16=__ZNK15running_machine6renderEv($3);
      var $17=__ZNK14render_manager12ui_containerEv($16);
      __Z25ui_menu_force_game_selectR15running_machineP16render_container($3, $17);
      __label__ = 4; break;
    case 3: // $18
      var $19=(($3+1310)|0);
      HEAP8[($19)]=1;
      __label__ = 4; break;
    case 4: // $20
      var $21=(($3+1160)|0);
      __ZN16device_scheduler14eat_all_cyclesEv($21);
      var $22=__ZNK15running_machine7optionsEv($3);
      var $23=__ZNK11emu_options8autosaveEv($22);
      if ($23) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $24
      var $25=(($3+672)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+44)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & 2048;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $31
      __ZNK15running_machine4timeEv($2, $3);
      var $32=__ZgtRK8attotimeS1_($2, __ZN8attotime4zeroE);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      __ZN15running_machine13schedule_saveEPKc($3, ((STRING_TABLE.__str72586)|0));
      __label__ = 8; break;
    case 8: // $34
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine13schedule_saveEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$filename;
  var $4=$1;
  var $5=$2;
  __ZN15running_machine21set_saveload_filenameEPKc($4, $5);
  var $6=(($4+1468)|0);
  HEAP32[(($6)>>2)]=1;
  var $7=(($4+1472)|0);
  __ZNK15running_machine4timeEv($3, $4);
  var $8=$7;
  var $9=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[(($9+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[(($9+8)>>2)];
  __ZN15running_machine6resumeEv($4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN15running_machine19schedule_hard_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1309)|0);
  HEAP8[($3)]=1;
  var $4=(($2+1160)|0);
  __ZN16device_scheduler14eat_all_cyclesEv($4);
  ;
  return;
}


function __ZN15running_machine19schedule_soft_resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  $1=$this;
  var $4=$1;
  var $5=(($4+1316)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($7)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($7+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($7+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $8=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  __ZN9emu_timer6adjustE8attotimeiS0_($6, $2, 0, $3);
  __ZN15running_machine6resumeEv($4);
  var $9=(($4+1160)|0);
  __ZN16device_scheduler14eat_all_cyclesEv($9);
  STACKTOP = __stackBase__;
  return;
}


function __ZN15running_machine6resumeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+1308)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      __label__ = 3; break;
    case 2: // $7
      var $8=(($2+1308)|0);
      HEAP8[($8)]=0;
      __ZN15running_machine14call_notifiersE20machine_notification($2, 3);
      __label__ = 3; break;
    case 3: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine19schedule_new_driverERK11game_driver($this, $driver) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$driver;
  var $3=$1;
  var $4=(($3+1309)|0);
  HEAP8[($4)]=1;
  var $5=$2;
  var $6=(($3+1312)|0);
  HEAP32[(($6)>>2)]=$5;
  var $7=(($3+1160)|0);
  __ZN16device_scheduler14eat_all_cyclesEv($7);
  ;
  return;
}


function __ZN15running_machine21set_saveload_filenameEPKc($this, $filename) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$filename;
      var $3=$1;
      var $4=$2;
      var $5=_osd_is_absolute_path($4);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($3+1548)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=(($3+1484)|0);
      var $10=$2;
      var $11=__ZN7astring3cpyEPKc($9, $10);
      __label__ = 3; break;
    case 2: // $12
      var $13=__ZNK15running_machine7optionsEv($3);
      var $14=__ZNK11emu_options15state_directoryEv($13);
      var $15=(($3+1548)|0);
      HEAP32[(($15)>>2)]=$14;
      var $16=(($3+1484)|0);
      var $17=__ZNK15running_machine8basenameEv($3);
      var $18=__ZN7astring3cpyEPKc($16, $17);
      var $19=__ZN7astring3catEPKc($18, ((STRING_TABLE.__str152594)|0));
      var $20=$2;
      var $21=__ZN7astring3catEPKc($19, $20);
      var $22=__ZN7astring3catEPKc($21, ((STRING_TABLE.__str162595)|0));
      __label__ = 3; break;
    case 3: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options15state_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str382619)|0));
  ;
  return $4;
}


function __ZN15running_machine5pauseEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+1308)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 3; break;
    case 2: // $7
      var $8=(($2+1308)|0);
      HEAP8[($8)]=1;
      __ZN15running_machine14call_notifiersE20machine_notification($2, 2);
      __label__ = 3; break;
    case 3: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine11region_freeEPKc($this, $name) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$name;
  var $3=$1;
  var $4=(($3+680)|0);
  var $5=$2;
  __ZN11tagged_listI13memory_regionE6removeEPKc($4, $5);
  ;
  return;
}


function __ZN11tagged_listI13memory_regionE6removeEPKc($this, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $object;
      $1=$this;
      $2=$tag;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11tagged_listI13memory_regionE4findEPKc($3, $4);
      $object=$5;
      var $6=$object;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$object;
      __ZN11tagged_listI13memory_regionE6removeERS0_($3, $9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine15handle_saveloadEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 296; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $openflags;
      var $opnamed;
      var $opname;
      var $filerr;
      var $file=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+260;
      var $5=__stackBase__+272;
      var $6=__stackBase__+284;
      var $7;
      var $saverr;
      $1=$this;
      var $8=$1;
      var $9=(($8+1468)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==2;
      var $12=$11 ? 1 : 14;
      $openflags=$12;
      var $13=(($8+1468)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==2;
      var $16=$15 ? (((STRING_TABLE.__str202599)|0)) : (((STRING_TABLE.__str212600)|0));
      $opnamed=$16;
      var $17=(($8+1468)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)==2;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $23 = STRING_TABLE.__str222601;__label__ = 3; break;
    case 2: // $21
      var $23 = STRING_TABLE.__str232602;__label__ = 3; break;
    case 3: // $22
      var $23;
      var $24=(($23)|0);
      $opname=$24;
      $filerr=0;
      var $25=(($8+1548)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$openflags;
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $26, $27);
      var $28=(($8+1484)|0);
      var $29=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $30
      if ($29) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 5: // $31
      __label__ = 50; break;
    case 6: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $2=$34;
      var $35=$33.f1;
      $3=$35;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 56; break; }
    case 7: // $36
      var $37=(($8+1160)|0);
      var $38=(function() { try { __THREW__ = false; return __ZNK16device_scheduler8can_saveEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 6; break; };
    case 8: // $39
      if ($38) { __label__ = 17; break; } else { __label__ = 9; break; }
    case 9: // $40
      (function() { try { __THREW__ = false; return __ZNK15running_machine4timeEv($5, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; }
    case 10: // $41
      var $42=(($8+1472)|0);
      (function() { try { __THREW__ = false; return __ZmiRK8attotimeS1_($4, $5, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 6; break; }
    case 11: // $43
      (function() { try { __THREW__ = false; return __ZN8attotime12from_secondsEi($6, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 6; break; }
    case 12: // $44
      var $45=(function() { try { __THREW__ = false; return __ZgtRK8attotimeS1_($4, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 6; break; };
    case 13: // $46
      if ($45) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $47
      var $48=$opname;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str242603)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$48,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 6; break; }
    case 15: // $49
      __label__ = 50; break;
    case 16: // $50
      $7=1;
      __label__ = 52; break;
    case 17: // $51
      var $52=(($8+1484)|0);
      var $53=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 6; break; };
    case 18: // $54
      var $55=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 6; break; };
    case 19: // $56
      $filerr=$55;
      var $57=$filerr;
      var $58=(($57)|0)==0;
      if ($58) { __label__ = 20; break; } else { __label__ = 47; break; }
    case 20: // $59
      var $60=(($8+1468)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==2;
      if ($62) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $63
      var $64=(($8+1088)|0);
      var $65=(function() { try { __THREW__ = false; return __ZN12save_manager9read_fileER8emu_file($64, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 6; break; };
    case 22: // $66
      var $72 = $65;__label__ = 25; break;
    case 23: // $67
      var $68=(($8+1088)|0);
      var $69=(function() { try { __THREW__ = false; return __ZN12save_manager10write_fileER8emu_file($68, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 6; break; };
    case 24: // $70
      var $72 = $69;__label__ = 25; break;
    case 25: // $71
      var $72;
      $saverr=$72;
      var $73=$saverr;
      if ($73 == 1) {
        __label__ = 26; break;
      }
      else if ($73 == 2) {
        __label__ = 28; break;
      }
      else if ($73 == 3) {
        __label__ = 30; break;
      }
      else if ($73 == 4) {
        __label__ = 32; break;
      }
      else if ($73 == 0) {
        __label__ = 34; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 26: // $74
      var $75=$opname;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str252604)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$75,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 6; break; }
    case 27: // $76
      __label__ = 42; break;
    case 28: // $77
      var $78=$opname;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str262605)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$78,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 6; break; }
    case 29: // $79
      __label__ = 42; break;
    case 30: // $80
      var $81=$opname;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str272606)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 6; break; }
    case 31: // $82
      __label__ = 42; break;
    case 32: // $83
      var $84=$opname;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str282607)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$84,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 6; break; }
    case 33: // $85
      __label__ = 42; break;
    case 34: // $86
      var $87=(($8+672)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+44)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$90 & 2048;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 37; break; } else { __label__ = 35; break; }
    case 35: // $93
      var $94=$opnamed;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str292608)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$94,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 6; break; }
    case 36: // $95
      __label__ = 39; break;
    case 37: // $96
      var $97=$opnamed;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str302609)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$97,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 6; break; }
    case 38: // $98
      __label__ = 39; break;
    case 39: // $99
      __label__ = 42; break;
    case 40: // $100
      var $101=$opnamed;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str312610)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$101,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 6; break; }
    case 41: // $102
      __label__ = 42; break;
    case 42: // $103
      var $104=$saverr;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 43; break; } else { __label__ = 46; break; }
    case 43: // $106
      var $107=(($8+1468)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108)|0)==1;
      if ($109) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $110
      (function() { try { __THREW__ = false; return __ZN8emu_file15remove_on_closeEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 6; break; }
    case 45: // $111
      __label__ = 46; break;
    case 46: // $112
      __label__ = 49; break;
    case 47: // $113
      var $114=$opname;
      (function() { try { __THREW__ = false; return __Z10popmessagePKcz(((STRING_TABLE.__str322611)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$114,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 6; break; }
    case 48: // $115
      __label__ = 49; break;
    case 49: // $116
      __label__ = 50; break;
    case 50: // $117
      var $118=(($8+1484)|0);
      var $119=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 6; break; };
    case 51: // $120
      var $121=(($8+1548)|0);
      HEAP32[(($121)>>2)]=0;
      var $122=(($8+1468)|0);
      HEAP32[(($122)>>2)]=0;
      $7=0;
      __label__ = 52; break;
    case 52: // $123
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 53; break;
      }
      else {
      __label__ = 57; break;
      }
      
    case 53: // $124
      STACKTOP = __stackBase__;
      return;
    case 54: // $125
      __label__ = 55; break;
    case 55: // $126
      var $127=$2;
      var $128=$2;
      var $129=$3;
      var $130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $128, tempValue);
      var $131=($130.f1 = $129, $130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 56: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 57: // $134
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine15handle_saveloadEv["X"]=1;

function __ZN15running_machine12region_allocEPKcjh12endianness_t($this, $name, $length, $width, $endian) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $info;
      var $14;
      var $15;
      $9=$this;
      $10=$name;
      $11=$length;
      $12=$width;
      $13=$endian;
      var $16=$9;
      var $17=(($16+680)|0);
      var $18=$10;
      var $19=__ZNK11tagged_listI13memory_regionE4findEPKc($17, $18);
      $info=$19;
      var $20=$info;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$10;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str172596)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$23,tempInt));
      throw "Reached an unreachable!"
    case 2: // $24
      var $25=(($16+680)|0);
      var $26=$10;
      var $27=__ZN15running_machine7respoolEv($16);
      var $28=$4;
      var $29=$5;
      var $30=$6;
      var $31=$result_i;
      var $32=$7;
      var $33=$8;
      HEAP32[(($4)>>2)]=88;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($6)>>2)]=637;
      var $34=HEAP32[(($4)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($34, $35, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $38
      HEAP32[(($result_i)>>2)]=$37;
      var $39=HEAP32[(($result_i)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $41
      var $42=___cxa_allocate_exception(4);
      var $43=$42;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43);
      (function() { try { __THREW__ = false; return ___cxa_throw($42, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      HEAP32[(($7)>>2)]=$46;
      var $47=$45.f1;
      HEAP32[(($8)>>2)]=$47;
      var $48=HEAP32[(($8)>>2)];
      var $49=(($48)|0) < 0;
      if ($49) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $50
      var $51=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($51);
      throw "Reached an unreachable!"
    case 7: // $52
      var $53=HEAP32[(($7)>>2)];
      var $54=HEAP32[(($7)>>2)];
      var $55=HEAP32[(($8)>>2)];
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $58
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $59=HEAP32[(($result_i)>>2)];
      var $60=$4;
      var $61=$5;
      var $62=$6;
      var $63=$result_i;
      var $64=$7;
      var $65=$8;
      var $66=$59;
      var $67=$10;
      var $68=$11;
      var $69=$12;
      var $70=$13;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13memory_regionC1ER15running_machinePKcjh12endianness_t]($66, $16, $67, $68, $69, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $71
      var $72=__ZN13resource_pool10add_objectI13memory_regionEEPT_S3_($27, $66);
      var $73=__ZN11tagged_listI13memory_regionE6appendEPKcRS0_($25, $26, $72);
      STACKTOP = __stackBase__;
      return $73;
    case 11: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $14=$76;
      var $77=$75.f1;
      $15=$77;
      var $78=$1;
      var $79=$2;
      var $80=$3;
      HEAP32[(($1)>>2)]=$59;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($3)>>2)]=637;
      var $81=HEAP32[(($1)>>2)];
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $83
      var $84=HEAP32[(($1)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $_noexc
      __label__ = 14; break;
    case 14: // $_ZdlPvPKci_exit
      var $87=$1;
      var $88=$2;
      var $89=$3;
      __label__ = 15; break;
    case 15: // $90
      __label__ = 16; break;
    case 16: // $91
      var $92=$14;
      var $93=$14;
      var $94=$15;
      var $95=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $93, tempValue);
      var $96=($95.f1 = $94, $95);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine12region_allocEPKcjh12endianness_t["X"]=1;

function __ZN11tagged_listI13memory_regionE6appendEPKcRS0_($this, $tag, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$tag;
      $3=$object;
      var $6=$1;
      var $7=(($6+20)|0);
      var $8=$2;
      var $9=$3;
      var $10=__ZN8tagmap_tIP13memory_regionE15add_unique_hashEPKcS1_b($7, $8, $9, 0);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=___cxa_allocate_exception(1032);
      var $14=$13;
      var $15=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($14, ((STRING_TABLE.__str372618)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      ___cxa_throw($13, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      ___cxa_free_exception($13);
      __label__ = 5; break;
    case 4: // $21
      var $22=(($6)|0);
      var $23=$3;
      var $24=__ZN11simple_listI13memory_regionE6appendERS0_($22, $23);
      ;
      return $24;
    case 5: // $25
      var $26=$4;
      var $27=$4;
      var $28=$5;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI13memory_regionEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13memory_regionEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13memory_regionEEPT_S3_["X"]=1;

function __ZN11simple_listIN15running_machine22notifier_callback_itemEE7prependERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15running_machine22notifier_callback_itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN15running_machine22logerror_callback_itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15running_machine22logerror_callback_item4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN15running_machine4randEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1320)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4*1664525)|0);
  var $6=(($5+1013904223)|0);
  var $7=(($2+1320)|0);
  HEAP32[(($7)>>2)]=$6;
  var $8=(($2+1320)|0);
  var $9=HEAPU32[(($8)>>2)];
  var $10=$9 >>> 16;
  var $11=(($2+1320)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$12 << 16;
  var $14=$10 | $13;
  ;
  return $14;
}


function __ZNK11simple_listIN15running_machine22notifier_callback_itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15running_machine22notifier_callback_item4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN8emu_file15remove_on_closeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+256)|0);
  HEAP8[($3)]=1;
  ;
  return;
}


function __ZN15running_machine8logerrorEPKcz($this, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $arg=__stackBase__;
      $1=$this;
      $2=$format;
      var $3=$1;
      var $4=(($3+1652)|0);
      var $5=__ZNK11simple_listIN15running_machine22logerror_callback_itemEE5firstEv($4);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$arg;
      HEAP32[(($8)>>2)]=arguments[__ZN15running_machine8logerrorEPKcz.length];
      var $9=$2;
      var $10=HEAP32[(($arg)>>2)];
      __ZN15running_machine9vlogerrorEPKcPc($3, $9, $10);
      var $11=$arg;
      ;
      __label__ = 2; break;
    case 2: // $12
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine9vlogerrorEPKcPc($this, $format, $args) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cb;
      $1=$this;
      $2=$format;
      $3=$args;
      var $4=$1;
      var $5=(($4+1652)|0);
      var $6=__ZNK11simple_listIN15running_machine22logerror_callback_itemEE5firstEv($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $8
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 272);
      var $9=$2;
      var $10=$3;
      var $11=_vsnprintf(((__ZL19giant_string_buffer)|0), 65536, $9, $10);
      var $12=(($4+1652)|0);
      var $13=__ZNK11simple_listIN15running_machine22logerror_callback_itemEE5firstEv($12);
      $cb=$13;
      __label__ = 2; break;
    case 2: // $14
      var $15=$cb;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      var $18=$cb;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      FUNCTION_TABLE[$20]($4, ((__ZL19giant_string_buffer)|0));
      __label__ = 4; break;
    case 4: // $21
      var $22=$cb;
      var $23=__ZNK15running_machine22logerror_callback_item4nextEv($22);
      $cb=$23;
      __label__ = 2; break;
    case 5: // $24
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 6; break;
    case 6: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15running_machine13base_datetimeER11system_time($this, $systime) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$systime;
  var $3=$1;
  var $4=$2;
  var $5=(($3+1328)|0);
  var $6=HEAP32[(($5)>>2)];
  __ZN11system_time3setEl($4, $6);
  ;
  return;
}


function __ZN11system_time3setEl($this, $t) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  HEAP32[(($2)>>2)]=$t;
  var $3=$1;
  var $4=HEAP32[(($2)>>2)];
  var $5$0=$4;
  var $5$1=(($4|0) < 0 ? -1 : 0);
  var $6=(($3)|0);
  var $st$9$0=(($6)|0);
  HEAP32[(($st$9$0)>>2)]=$5$0;
  var $st$9$1=(($6+4)|0);
  HEAP32[(($st$9$1)>>2)]=$5$1;
  var $7=(($3+8)|0);
  var $8=_localtime($2);
  __ZN11system_time9full_time3setER2tm($7, $8);
  var $9=(($3+28)|0);
  var $10=_gmtime($2);
  __ZN11system_time9full_time3setER2tm($9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($this, $event, $callback) {
  var __stackBase__  = STACKTOP; STACKTOP += 120; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i1=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21=__stackBase__+72;
      var $22=__stackBase__+96;
      $17=$this;
      $18=$event;
      var $23=$17;
      __label__ = 1; break;
    case 1: // $24
      var $25=(($23+1304)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==1;
      if ($27) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(1032);
      var $30=$29;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($30, ((STRING_TABLE.__str92588)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str182597)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str42583)|0),HEAP32[((tempInt+8)>>2)]=658,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $31
      ___cxa_throw($29, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $19=$34;
      var $35=$33.f1;
      $20=$35;
      ___cxa_free_exception($29);
      __label__ = 38; break;
    case 5: // $36
      __label__ = 6; break;
    case 6: // $37
      var $38=$18;
      var $39=(($38)|0)==4;
      if ($39) { __label__ = 7; break; } else { __label__ = 22; break; }
    case 7: // $40
      var $41=$18;
      var $42=(($23+1552)|0);
      var $43=(($42+$41*20)|0);
      var $44=$12;
      var $45=$13;
      var $46=$14;
      var $47=$result_i;
      var $48=$15;
      var $49=$16;
      HEAP32[(($12)>>2)]=28;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($14)>>2)]=662;
      var $50=HEAP32[(($12)>>2)];
      var $51=HEAP32[(($13)>>2)];
      var $52=HEAP32[(($14)>>2)];
      var $53=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($50, $51, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $54
      HEAP32[(($result_i)>>2)]=$53;
      var $55=HEAP32[(($result_i)>>2)];
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $57
      var $58=___cxa_allocate_exception(4);
      var $59=$58;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($59);
      (function() { try { __THREW__ = false; return ___cxa_throw($58, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      HEAP32[(($15)>>2)]=$62;
      var $63=$61.f1;
      HEAP32[(($16)>>2)]=$63;
      var $64=HEAP32[(($16)>>2)];
      var $65=(($64)|0) < 0;
      if ($65) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $66
      var $67=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 12: // $68
      var $69=HEAP32[(($15)>>2)];
      var $70=HEAP32[(($15)>>2)];
      var $71=HEAP32[(($16)>>2)];
      var $72=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $70, tempValue);
      var $73=($72.f1 = $71, $72);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $74
      throw "Reached an unreachable!"
    case 14: // $_ZnwjPKci_exit
      var $75=HEAP32[(($result_i)>>2)];
      var $76=$12;
      var $77=$13;
      var $78=$14;
      var $79=$result_i;
      var $80=$15;
      var $81=$16;
      var $82=$75;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1ERKS1_($21, $callback) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $83
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15running_machine22notifier_callback_itemC1E8delegateIFvvEE]($82, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $84
      var $85=__ZN13resource_pool10add_objectIN15running_machine22notifier_callback_itemEEEPT_S4_(_global_resource_pool, $82);
      var $86=__ZN11simple_listIN15running_machine22notifier_callback_itemEE7prependERS1_($43, $85);
      __label__ = 37; break;
    case 17: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      $19=$89;
      var $90=$88.f1;
      $20=$90;
      var $91=$9;
      var $92=$10;
      var $93=$11;
      HEAP32[(($9)>>2)]=$75;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($11)>>2)]=662;
      var $94=HEAP32[(($9)>>2)];
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $96
      var $97=HEAP32[(($9)>>2)];
      var $98=HEAP32[(($10)>>2)];
      var $99=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($97, $98, $99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 39; break; }
    case 19: // $_noexc
      __label__ = 20; break;
    case 20: // $_ZdlPvPKci_exit
      var $100=$9;
      var $101=$10;
      var $102=$11;
      __label__ = 21; break;
    case 21: // $103
      __label__ = 38; break;
    case 22: // $104
      var $105=$18;
      var $106=(($23+1552)|0);
      var $107=(($106+$105*20)|0);
      var $108=$4;
      var $109=$5;
      var $110=$6;
      var $111=$result_i1;
      var $112=$7;
      var $113=$8;
      HEAP32[(($4)>>2)]=28;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($6)>>2)]=666;
      var $114=HEAP32[(($4)>>2)];
      var $115=HEAP32[(($5)>>2)];
      var $116=HEAP32[(($6)>>2)];
      var $117=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($114, $115, $116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; };
    case 23: // $118
      HEAP32[(($result_i1)>>2)]=$117;
      var $119=HEAP32[(($result_i1)>>2)];
      var $120=(($119)|0)==0;
      if ($120) { __label__ = 24; break; } else { __label__ = 29; break; }
    case 24: // $121
      var $122=___cxa_allocate_exception(4);
      var $123=$122;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($123);
      (function() { try { __THREW__ = false; return ___cxa_throw($122, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 25; break; }
    case 25: // $124
      var $125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $126=$125.f0;
      HEAP32[(($7)>>2)]=$126;
      var $127=$125.f1;
      HEAP32[(($8)>>2)]=$127;
      var $128=HEAP32[(($8)>>2)];
      var $129=(($128)|0) < 0;
      if ($129) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $130
      var $131=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($131);
      throw "Reached an unreachable!"
    case 27: // $132
      var $133=HEAP32[(($7)>>2)];
      var $134=HEAP32[(($7)>>2)];
      var $135=HEAP32[(($8)>>2)];
      var $136=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $134, tempValue);
      var $137=($136.f1 = $135, $136);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 28: // $138
      throw "Reached an unreachable!"
    case 29: // $_ZnwjPKci_exit2
      var $139=HEAP32[(($result_i1)>>2)];
      var $140=$4;
      var $141=$5;
      var $142=$6;
      var $143=$result_i1;
      var $144=$7;
      var $145=$8;
      var $146=$139;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1ERKS1_($22, $callback) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $147
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15running_machine22notifier_callback_itemC1E8delegateIFvvEE]($146, $22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $148
      var $149=__ZN13resource_pool10add_objectIN15running_machine22notifier_callback_itemEEEPT_S4_(_global_resource_pool, $146);
      var $150=__ZN11simple_listIN15running_machine22notifier_callback_itemEE6appendERS1_($107, $149);
      __label__ = 37; break;
    case 32: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      $19=$153;
      var $154=$152.f1;
      $20=$154;
      var $155=$1;
      var $156=$2;
      var $157=$3;
      HEAP32[(($1)>>2)]=$139;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($3)>>2)]=666;
      var $158=HEAP32[(($1)>>2)];
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $160
      var $161=HEAP32[(($1)>>2)];
      var $162=HEAP32[(($2)>>2)];
      var $163=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($161, $162, $163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $_noexc3
      __label__ = 35; break;
    case 35: // $_ZdlPvPKci_exit4
      var $164=$1;
      var $165=$2;
      var $166=$3;
      __label__ = 36; break;
    case 36: // $167
      __label__ = 38; break;
    case 37: // $168
      STACKTOP = __stackBase__;
      return;
    case 38: // $169
      var $170=$19;
      var $171=$19;
      var $172=$20;
      var $173=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $171, tempValue);
      var $174=($173.f1 = $172, $173);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 39: // $175
      var $176=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE["X"]=1;

function __ZN13resource_pool10add_objectIN15running_machine22notifier_callback_itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN15running_machine22notifier_callback_itemEEEPT_S4_["X"]=1;

function __ZN13resource_pool10add_objectIN15running_machine22logerror_callback_itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN15running_machine22logerror_callback_itemEEEPT_S4_["X"]=1;

function __ZN13driver_device12driver_startEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN13driver_device12driver_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN13driver_device13screen_updateER13screen_deviceR8bitmap_tRK10_rectangle($this, $screen, $bitmap, $cliprect) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$screen;
  $3=$bitmap;
  $4=$cliprect;
  var $5=$1;
  ;
  return 0;
}


function __ZN13driver_device10screen_eofEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __Z8downcastIR13driver_device8device_tET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13memory_region7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN15running_machine22logerror_callback_itemC2EPFvRS_PKcE($this, $func) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$func;
  var $3=$1;
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($3+4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  ;
  return;
}


function __ZNK13driver_device17device_rom_regionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+356)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+36)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __ZNK13driver_device18device_input_portsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+356)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+28)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __ZN11system_time9full_time3setER2tm($this, $t) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$t;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6) & 255);
  var $8=(($3)|0);
  HEAP8[($8)]=$7;
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11) & 255);
  var $13=(($3+1)|0);
  HEAP8[($13)]=$12;
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16) & 255);
  var $18=(($3+2)|0);
  HEAP8[($18)]=$17;
  var $19=$2;
  var $20=(($19+12)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=(($21) & 255);
  var $23=(($3+3)|0);
  HEAP8[($23)]=$22;
  var $24=$2;
  var $25=(($24+16)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=(($26) & 255);
  var $28=(($3+4)|0);
  HEAP8[($28)]=$27;
  var $29=$2;
  var $30=(($29+20)|0);
  var $31=HEAP32[(($30)>>2)];
  var $32=(($31+1900)|0);
  var $33=(($3+8)|0);
  HEAP32[(($33)>>2)]=$32;
  var $34=$2;
  var $35=(($34+24)|0);
  var $36=HEAP32[(($35)>>2)];
  var $37=(($36) & 255);
  var $38=(($3+12)|0);
  HEAP8[($38)]=$37;
  var $39=$2;
  var $40=(($39+28)|0);
  var $41=HEAP32[(($40)>>2)];
  var $42=(($41) & 65535);
  var $43=(($3+14)|0);
  HEAP16[(($43)>>1)]=$42;
  var $44=$2;
  var $45=(($44+32)|0);
  var $46=HEAP32[(($45)>>2)];
  var $47=(($46) & 255);
  var $48=(($3+16)|0);
  HEAP8[($48)]=$47;
  ;
  return;
}
__ZN11system_time9full_time3setER2tm["X"]=1;

function __ZN15running_machine22notifier_callback_itemC2E8delegateIFvvEE($this, $func) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  __ZN8delegateIFvvEEC1ERKS1_($4, $func);
  ;
  return;
}


function __ZN13driver_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_($this, $mconfig, $type, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($6, $7, $8, ((STRING_TABLE.__str342613)|0), $9, 0, 0);
  var $10=$5;
  HEAP32[(($10)>>2)]=((__ZTV13driver_device+8)|0);
  var $11=(($5+356)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($5+384)|0);
  HEAP32[(($12)>>2)]=0;
  var $13=(($5+360)|0);
  var $14=(($13)|0);
  var $15=$14;
  _memset($15, 0, 24, 1);
  ;
  return;
}


function __ZN13driver_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8device_tD2Ev($3);
  ;
  return;
}


function __ZN13driver_device15static_set_gameER8device_tRK11game_driver($device, $game) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $driver;
      var $parent;
      $1=$device;
      $2=$game;
      var $3=$1;
      var $4=__Z8downcastIR13driver_device8device_tET_RT0_($3);
      $driver=$4;
      var $5=$2;
      var $6=$driver;
      var $7=(($6+356)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$driver;
      var $9=$8;
      var $10=(($9+116)|0);
      var $11=$2;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZN7astringaSEPKc($10, $13);
      var $15=$driver;
      var $16=$15;
      var $17=(($16+180)|0);
      var $18=$2;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZN7astringaSEPKc($17, $20);
      var $22=$2;
      var $23=__ZN11driver_list5cloneERK11game_driver($22);
      $parent=$23;
      __label__ = 1; break;
    case 1: // $24
      var $25=$parent;
      var $26=(($25)|0)!=-1;
      if ($26) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $27
      var $28=$driver;
      var $29=$28;
      var $30=(($29+180)|0);
      var $31=__ZN7astring3catEPKc($30, ((STRING_TABLE.__str352614)|0));
      var $32=$parent;
      var $33=__ZN11driver_list6driverEi($32);
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZN7astring3catEPKc($31, $35);
      __label__ = 3; break;
    case 3: // $37
      var $38=$parent;
      var $39=__ZN11driver_list5cloneEi($38);
      $parent=$39;
      __label__ = 1; break;
    case 4: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11driver_list5cloneERK11game_driver($driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $index;
      $1=$driver;
      var $2=$1;
      var $3=__ZN11driver_list4findERK11game_driver($2);
      $index=$3;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$index;
      var $7=__ZN11driver_list5cloneEi($6);
      ;
      return $7;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_device19static_set_callbackER8device_tNS_13callback_typeEPFvR15running_machineE($device, $type, $callback) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$device;
  $2=$type;
  $3=$callback;
  var $4=$3;
  var $5=$2;
  var $6=$1;
  var $7=__Z8downcastIR13driver_device8device_tET_RT0_($6);
  var $8=(($7+360)|0);
  var $9=(($8+($5<<2))|0);
  HEAP32[(($9)>>2)]=$4;
  ;
  return;
}


function __ZN13driver_device23static_set_palette_initER8device_tPFvR15running_machinePKhE($device, $callback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$callback;
  var $3=$2;
  var $4=$1;
  var $5=__Z8downcastIR13driver_device8device_tET_RT0_($4);
  var $6=(($5+384)|0);
  HEAP32[(($6)>>2)]=$3;
  ;
  return;
}


function __ZN13driver_device13machine_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+360)|0);
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($2+360)|0);
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZNK8device_t7machineEv($11);
      FUNCTION_TABLE[$10]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_device11sound_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+360)|0);
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($2+360)|0);
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZNK8device_t7machineEv($11);
      FUNCTION_TABLE[$10]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_device11video_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+360)|0);
      var $4=(($3+16)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($2+360)|0);
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZNK8device_t7machineEv($11);
      FUNCTION_TABLE[$10]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_device13machine_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+360)|0);
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($2+360)|0);
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZNK8device_t7machineEv($11);
      FUNCTION_TABLE[$10]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_device11sound_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+360)|0);
      var $4=(($3+12)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($2+360)|0);
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZNK8device_t7machineEv($11);
      FUNCTION_TABLE[$10]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_device11video_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+360)|0);
      var $4=(($3+20)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($2+360)|0);
      var $9=(($8+20)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=__ZNK8device_t7machineEv($11);
      FUNCTION_TABLE[$10]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN27device_missing_dependenciesC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN27device_missing_dependenciesC2Ev($2);
  ;
  return;
}


function __ZN27device_missing_dependenciesD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN27device_missing_dependenciesD2Ev($2);
  ;
  return;
}


function __ZN13driver_device12device_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+84)|0);
  var $6=HEAP32[(($5)>>2)];
  FUNCTION_TABLE[$6]($2);
  var $7=$2;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+88)|0);
  var $10=HEAP32[(($9)>>2)];
  FUNCTION_TABLE[$10]($2);
  var $11=$2;
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+92)|0);
  var $14=HEAP32[(($13)>>2)];
  FUNCTION_TABLE[$14]($2);
  var $15=$2;
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16+96)|0);
  var $18=HEAP32[(($17)>>2)];
  FUNCTION_TABLE[$18]($2);
  ;
  return;
}


function __ZN11system_timeC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=(($2+28)|0);
  __ZN11system_time3setEl($2, 0);
  ;
  return;
}


function __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN15running_machine22logerror_callback_itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED2Ev($2);
  ;
  return;
}


function __ZN13memory_regionC2ER15running_machinePKcjh12endianness_t($this, $machine, $name, $length, $width, $endian) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      $6=$this;
      $7=$machine;
      $8=$name;
      $9=$length;
      $10=$width;
      $11=$endian;
      var $14=$6;
      var $15=(($14)|0);
      var $16=$7;
      HEAP32[(($15)>>2)]=$16;
      var $17=(($14+4)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($14+8)|0);
      var $19=$8;
      __ZN7astringC1EPKc($18, $19);
      var $20=(($14+72)|0);
      var $21=(($14+76)|0);
      var $22=$9;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($14+80)|0);
      var $24=$10;
      HEAP8[($23)]=$24;
      var $25=(($14+84)|0);
      var $26=$11;
      HEAP32[(($25)>>2)]=$26;
      __label__ = 1; break;
    case 1: // $27
      __label__ = 2; break;
    case 2: // $28
      __label__ = 3; break;
    case 3: // $29
      var $30=$7;
      var $31=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 15; break; };
    case 4: // $32
      var $33=$9;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      var $37=$result_i;
      var $38=$4;
      var $39=$5;
      HEAP32[(($1)>>2)]=$33;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str42583)|0);
      HEAP32[(($3)>>2)]=904;
      var $40=HEAP32[(($1)>>2)];
      var $41=HEAP32[(($2)>>2)];
      var $42=HEAP32[(($3)>>2)];
      var $43=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($40, $41, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $44
      HEAP32[(($result_i)>>2)]=$43;
      var $45=HEAP32[(($result_i)>>2)];
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $47
      var $48=___cxa_allocate_exception(4);
      var $49=$48;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($49);
      (function() { try { __THREW__ = false; return ___cxa_throw($48, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 7; break; }
    case 7: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      HEAP32[(($4)>>2)]=$52;
      var $53=$51.f1;
      HEAP32[(($5)>>2)]=$53;
      var $54=HEAP32[(($5)>>2)];
      var $55=(($54)|0) < 0;
      if ($55) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $56
      var $57=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $_noexc
      throw "Reached an unreachable!"
    case 10: // $58
      var $59=HEAP32[(($4)>>2)];
      var $60=HEAP32[(($4)>>2)];
      var $61=HEAP32[(($5)>>2)];
      var $62=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $60, tempValue);
      var $63=($62.f1 = $61, $62);
      var $eh_lpad_body = $63;__label__ = 16; break;
    case 11: // $64
      throw "Reached an unreachable!"
    case 12: // $_ZnajPKci_exit
      var $65=HEAP32[(($result_i)>>2)];
      var $66=$1;
      var $67=$2;
      var $68=$3;
      var $69=$result_i;
      var $70=$4;
      var $71=$5;
      __label__ = 13; break;
    case 13: // $72
      var $73=$9;
      var $74=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIhEEPT_S2_i($31, $65, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; };
    case 14: // $75
      var $76=(($14+72)|0);
      var $77=$76;
      HEAP32[(($77)>>2)]=$74;
      STACKTOP = __stackBase__;
      return;
    case 15: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $79;__label__ = 16; break;
    case 16: // $_body
      var $eh_lpad_body;
      var $80=$eh_lpad_body.f0;
      $12=$80;
      var $81=$eh_lpad_body.f1;
      $13=$81;
      var $82=(($14+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $83
      __label__ = 18; break;
    case 18: // $84
      var $85=$12;
      var $86=$12;
      var $87=$13;
      var $88=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $86, tempValue);
      var $89=($88.f1 = $87, $88);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13memory_regionC2ER15running_machinePKcjh12endianness_t["X"]=1;

function __ZN13memory_regionD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(function() { try { __THREW__ = false; return __ZNK13memory_region7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $6
      var $7=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $8
      var $9=(($4+72)|0);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($7, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($13);
      ;
      return;
    case 4: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $2=$16;
      var $17=$15.f1;
      $3=$17;
      var $18=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=$2;
      var $22=$2;
      var $23=$3;
      var $24=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22, tempValue);
      var $25=($24.f1 = $23, $24);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13driver_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13driver_deviceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13driver_deviceD0Ev["X"]=1;

function __ZN13driver_device12device_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t4nextEv($3);
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=___cxa_allocate_exception(4);
      var $8=$7;
      var $9=$8;
      HEAP32[(($9)>>2)]=0;
      __ZN27device_missing_dependenciesC1Ev($8);
      ___cxa_throw($7, __ZTI27device_missing_dependencies, 232);
      throw "Reached an unreachable!"
    case 2: // $10
      var $11=(($2+356)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+32)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($2+356)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+32)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$2;
      var $22=__ZNK8device_t7machineEv($21);
      FUNCTION_TABLE[$20]($22);
      __label__ = 4; break;
    case 4: // $23
      var $24=$2;
      var $25=__ZNK8device_t7machineEv($24);
      __Z21image_postdevice_initR15running_machine($25);
      var $26=(($2+384)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=(($2+384)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$2;
      var $33=__ZNK8device_t7machineEv($32);
      var $34=$2;
      var $35=__ZNK8device_t7machineEv($34);
      var $36=__ZN15running_machine6regionEPKc($35, ((STRING_TABLE.__str362615)|0));
      var $37=__ZNK13memory_region4baseEv($36);
      FUNCTION_TABLE[$31]($33, $37);
      __label__ = 6; break;
    case 6: // $38
      var $39=$2;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+68)|0);
      var $42=HEAP32[(($41)>>2)];
      FUNCTION_TABLE[$42]($2);
      var $43=$2;
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+72)|0);
      var $46=HEAP32[(($45)>>2)];
      FUNCTION_TABLE[$46]($2);
      var $47=$2;
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+76)|0);
      var $50=HEAP32[(($49)>>2)];
      FUNCTION_TABLE[$50]($2);
      var $51=$2;
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+80)|0);
      var $54=HEAP32[(($53)>>2)];
      FUNCTION_TABLE[$54]($2);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13driver_device12device_startEv["X"]=1;

function __ZN11simple_listI13memory_regionE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI13memory_regionE6detachERS0_["X"]=1;

function __ZN11simple_listI13memory_regionE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 28);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN15running_machine22notifier_callback_itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED2Ev($2);
  ;
  return;
}


function __ZN11tagged_listI13memory_regionE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  __ZN8tagmap_tIP13memory_regionE6removeES1_($4, $5);
  var $6=(($3)|0);
  var $7=$2;
  __ZN11simple_listI13memory_regionE6removeERS0_($6, $7);
  ;
  return;
}


function __ZN8tagmap_tIP13memory_regionE6removeES1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __Z20tagmap_remove_objectP7_tagmapPv($4, $6);
  ;
  return;
}


function __ZN11simple_listI13memory_regionE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI13memory_regionE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectI13memory_regionEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13memory_regionEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13memory_regionEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 88);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13memory_regionE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13memory_regionED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13memory_regionED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP13memory_regionE15add_unique_hashEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z22tagmap_add_unique_hashP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN20resource_pool_objectI13cheat_managerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13cheat_managerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13cheat_managerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 3720);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13cheat_managerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13cheat_managerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13cheat_managerED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN15running_machine22logerror_callback_itemEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN15running_machine22notifier_callback_itemEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI13memory_regionED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13memory_regionED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13memory_regionED0Ev["X"]=1;

function __ZN20resource_pool_objectI13memory_regionED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI13memory_regionE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13memory_regionD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13memory_regionED2Ev["X"]=1;

function __ZN20resource_pool_objectI13cheat_managerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13cheat_managerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13cheat_managerED0Ev["X"]=1;

function __ZN11simple_listI11cheat_entryE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11cheat_entryE6detachERS0_["X"]=1;

function __ZN13cheat_managerD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13cheat_managerD2Ev($2);
  ;
  return;
}


function __ZN11simple_listI11cheat_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI11cheat_entryED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI11cheat_entryED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI11cheat_entryE+8)|0);
  __ZN11simple_listI11cheat_entryE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI11cheat_entryE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI11cheat_entryE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11cheat_entryE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI11cheat_entryE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectI13sound_managerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13sound_managerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13sound_managerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 80);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13sound_managerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13sound_managerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13sound_managerED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13video_managerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13video_managerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13video_managerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 188);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13video_managerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13video_managerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13video_managerED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13cheat_managerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI13cheat_managerE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN13cheat_managerD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13cheat_managerED2Ev["X"]=1;

function __ZN13cheat_managerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+3288)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $6
      var $7=(($4+32)|0);
      var $8=(($7)|0);
      var $9=(($8+3200)|0);
      var $11 = $9;__label__ = 2; break;
    case 2: // $10
      var $11;
      var $12=(($11-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $13
      var $14=(($12)|0)==(($8)|0);
      if ($14) { __label__ = 4; break; } else { var $11 = $12;__label__ = 2; break; }
    case 4: // $15
      var $16=(($4+4)|0);
      __ZN11simple_listI11cheat_entryED1Ev($16);
      ;
      return;
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=(($4+32)|0);
      var $22=(($21)|0);
      var $23=(($22+3200)|0);
      var $36 = $23;__label__ = 10; break;
    case 6: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $2=$26;
      var $27=$25.f1;
      $3=$27;
      var $28=(($8)|0)==(($12)|0);
      if ($28) { __label__ = 9; break; } else { var $30 = $12;__label__ = 7; break; }
    case 7: // $29
      var $30;
      var $31=(($30-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $32
      var $33=(($31)|0)==(($8)|0);
      if ($33) { __label__ = 9; break; } else { var $30 = $31;__label__ = 7; break; }
    case 9: // $34
      __label__ = 13; break;
    case 10: // $35
      var $36;
      var $37=(($36-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $38
      var $39=(($37)|0)==(($22)|0);
      if ($39) { __label__ = 12; break; } else { var $36 = $37;__label__ = 10; break; }
    case 12: // $40
      __label__ = 13; break;
    case 13: // $41
      var $42=(($4+4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11cheat_entryED1Ev($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $43
      __label__ = 15; break;
    case 15: // $44
      var $45=$2;
      var $46=$2;
      var $47=$3;
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_managerD2Ev["X"]=1;

function __ZN11simple_listI11cheat_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI11cheat_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11cheat_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI13sound_managerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13sound_managerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13sound_managerED0Ev["X"]=1;

function __ZN20resource_pool_objectI13sound_managerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI13sound_managerE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13sound_managerD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13sound_managerED2Ev["X"]=1;

function __ZN20resource_pool_objectI13video_managerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13video_managerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13video_managerED0Ev["X"]=1;

function __ZN20resource_pool_objectI13video_managerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI13video_managerE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM15running_machineFvPviEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIP13driver_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN15running_machine22logerror_callback_itemEE6detachERS1_["X"]=1;

function __ZN8delegateIFvPviEEC2I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvPvi8_noparamS1_EC2I15running_machineEEN15delegate_traitsIT_vS0_iS1_S1_E16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_EC2I15running_machineEEN15delegate_traitsIT_vS0_iS1_S1_E16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM15running_machineFvPviEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=88;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvPvi8_noparamS1_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM15running_machineFvPviEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM15running_machineFvPviEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI14render_managerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14render_managerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14render_managerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 76);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14render_managerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14render_managerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14render_managerED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13input_managerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13input_managerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13input_managerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 4504);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13input_managerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13input_managerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13input_managerED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN15running_machine22logerror_callback_itemEE+8)|0);
  __ZN11simple_listIN15running_machine22logerror_callback_itemEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN15running_machine22logerror_callback_itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN15running_machine22logerror_callback_itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listIN15running_machine22notifier_callback_itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN15running_machine22notifier_callback_itemEE+8)|0);
  __ZN11simple_listIN15running_machine22notifier_callback_itemEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN15running_machine22notifier_callback_itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN15running_machine22notifier_callback_itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15running_machine22notifier_callback_itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN15running_machine22notifier_callback_itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectI14render_managerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14render_managerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14render_managerED0Ev["X"]=1;

function __ZN20resource_pool_objectI14render_managerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI14render_managerE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14render_managerD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14render_managerED2Ev["X"]=1;

function __ZN20resource_pool_objectI13input_managerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13input_managerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13input_managerED0Ev["X"]=1;

function __ZN20resource_pool_objectI13input_managerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI13input_managerE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22logerror_callback_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN15running_machine22logerror_callback_itemEED0Ev["X"]=1;

function __ZN11simple_listIN15running_machine22notifier_callback_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN15running_machine22notifier_callback_itemEED0Ev["X"]=1;

function __ZN11simple_listIN15running_machine22notifier_callback_itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN15running_machine22notifier_callback_itemEE6detachERS1_["X"]=1;

function __ZN11simple_listIN15running_machine22notifier_callback_itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN15running_machine22notifier_callback_itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI17input_port_configE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+8)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI17input_port_configE6detachERS0_["X"]=1;

function __ZN11simple_listI17input_port_configEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI17input_port_configE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN15running_machine22logerror_callback_itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN15running_machine22logerror_callback_itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI13memory_regionEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI13memory_regionE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI17input_port_configEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI17input_port_configEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8tagmap_tIP17input_port_configEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP17input_port_configEC2Ev($2);
  ;
  return;
}


function __ZN11simple_listI17input_port_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI17input_port_configED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI17input_port_configED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI17input_port_configE+8)|0);
  __ZN11simple_listI17input_port_configE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI17input_port_configE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI17input_port_configE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI17input_port_configE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI17input_port_configE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8tagmap_tIP17input_port_configEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN11simple_listI13memory_regionEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI13memory_regionEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8tagmap_tIP13memory_regionEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP13memory_regionEC2Ev($2);
  ;
  return;
}


function __ZN11simple_listI13memory_regionED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI13memory_regionED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI13memory_regionED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI13memory_regionE+8)|0);
  __ZN11simple_listI13memory_regionE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI13memory_regionE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI13memory_regionE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIP13memory_regionEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN27device_missing_dependenciesD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13emu_exceptionD2Ev($3);
  ;
  return;
}


function __ZN27device_missing_dependenciesC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13emu_exceptionC2Ev($3);
  var $4=$2;
  HEAP32[(($4)>>2)]=((__ZTV27device_missing_dependencies+8)|0);
  ;
  return;
}


function __ZN8tagmap_tIP17input_port_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP17input_port_configED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP17input_port_configED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP17input_port_configE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP17input_port_configE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN8tagmap_tIP13memory_regionED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP13memory_regionED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP13memory_regionED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP13memory_regionE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP13memory_regionE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZNK12core_options9int_valueEPKc($this, $name) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$name;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK12core_options5valueEPKc($3, $4);
  var $6=_atoi($5);
  ;
  return $6;
}


function __ZN11tagged_listI17input_port_configEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$pool;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      __ZN11simple_listI17input_port_configEC1ER13resource_pool($6, $7);
      var $8=(($5+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP17input_port_configEC1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $3=$12;
      var $13=$11.f1;
      $4=$13;
      var $14=(($5)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI17input_port_configED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$3;
      var $18=$3;
      var $19=$4;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI17input_port_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI17input_port_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI17input_port_configED0Ev["X"]=1;

function __ZN11tagged_listI13memory_regionEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$pool;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      __ZN11simple_listI13memory_regionEC1ER13resource_pool($6, $7);
      var $8=(($5+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP13memory_regionEC1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $3=$12;
      var $13=$11.f1;
      $4=$13;
      var $14=(($5)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI13memory_regionED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$3;
      var $18=$3;
      var $19=$4;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI13memory_regionED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI13memory_regionED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI13memory_regionED0Ev["X"]=1;

function __ZN27device_missing_dependenciesD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      __ZN27device_missing_dependenciesD1Ev($5);
      var $6=$5;
      var $7=$1;
      var $8=$2;
      var $9=$3;
      HEAP32[(($1)>>2)]=$6;
      var $10=HEAP32[(($1)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($13, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      __label__ = 4; break;
    case 3: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      HEAP32[(($2)>>2)]=$17;
      var $18=$16.f1;
      HEAP32[(($3)>>2)]=$18;
      var $19=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($19);
      throw "Reached an unreachable!"
    case 4: // $_ZdlPv_exit
      var $20=$1;
      var $21=$2;
      var $22=$3;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11tagged_listI17input_port_configED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP17input_port_configED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4)|0);
      __ZN11simple_listI17input_port_configED1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI17input_port_configED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11tagged_listI13memory_regionED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP13memory_regionED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4)|0);
      __ZN11simple_listI13memory_regionED1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI13memory_regionED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_managerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+52)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($4+32)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($4+12)|0);
      __ZN11simple_listIN12save_manager11state_entryEED1Ev($9);
      ;
      return;
    case 3: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=(($4+32)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager14state_callbackEED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      __label__ = 6; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=(($4+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12save_manager11state_entryEED1Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $22
      __label__ = 8; break;
    case 8: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13osd_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN13osd_interface13init_debuggerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN13osd_interface19update_audio_streamEPKsi($this, $buffer, $samples_this_frame) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$buffer;
  $3=$samples_this_frame;
  var $4=$1;
  ;
  return;
}


function __ZN13osd_interface16set_mastervolumeEi($this, $attenuation) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$attenuation;
  var $3=$1;
  ;
  return;
}


function __ZN13osd_interface25customize_input_type_listER11simple_listI16input_type_entryE($this, $typelist) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$typelist;
  var $3=$1;
  ;
  return;
}


function __ZN13osd_interface9font_openEPKcRi($this, $name, $height) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$name;
  $3=$height;
  var $4=$1;
  ;
  return 0;
}


function __ZN13osd_interface10font_closeEPv($this, $font) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$font;
  var $3=$1;
  ;
  return;
}


function __ZN13osd_interface15font_get_bitmapEPvjRiS1_S1_($this, $font, $chnum, $width, $xoffs, $yoffs) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$font;
  $3=$chnum;
  $4=$width;
  $5=$xoffs;
  $6=$yoffs;
  var $7=$1;
  ;
  return 0;
}


function __ZN13osd_interface15get_slider_listEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZN13osd_interface6updateEb($this, $skip_redraw) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($skip_redraw)&1);
  $2=$3;
  var $4=$1;
  ;
  return;
}


function __ZN13osd_interface17wait_for_debuggerER8device_tb($this, $device, $firststop) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$device;
  var $4=(($firststop)&1);
  $3=$4;
  var $5=$1;
  ;
  return;
}


function __ZN13osd_interfaceC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV13osd_interface+8)|0);
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  ;
  return;
}


function __ZN13osd_interface4initER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=$2;
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN11simple_listI16render_primitiveE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+100)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+100)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_texture5resetER14render_managerPFvR8bitmap_tRKS2_RK10_rectanglePvES9_($this, $manager, $scaler, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$manager;
  $3=$scaler;
  $4=$param;
  var $5=$1;
  var $6=$2;
  var $7=(($5)|0);
  HEAP32[(($7)>>2)]=$6;
  var $8=$3;
  var $9=(($5+36)|0);
  HEAP32[(($9)>>2)]=$8;
  var $10=$4;
  var $11=(($5+40)|0);
  HEAP32[(($11)>>2)]=$10;
  ;
  return;
}


function __ZNK14render_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN16render_primitive5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=$3;
  var $5=(($2+68)|0);
  var $6=(($5+32)|0);
  var $7=$6;
  var $8=(($2)|0);
  var $9=$8;
  var $10=(($7-$9)|0);
  _memset($4, 0, $10, 1);
  ;
  return;
}


function __ZN11simple_listI16render_primitiveEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI16render_primitiveEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN21render_primitive_list9referenceEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN21render_primitive_list9referenceEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorI16render_primitiveEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN15fixed_allocatorI16render_primitiveEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorIN21render_primitive_list9referenceEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN15fixed_allocatorIN21render_primitive_list9referenceEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorIN21render_primitive_list9referenceEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15fixed_allocatorIN21render_primitive_list9referenceEED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorI16render_primitiveED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15fixed_allocatorI16render_primitiveED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN21render_primitive_list9referenceEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN21render_primitive_list9referenceEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI16render_primitiveED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI16render_primitiveED2Ev($2);
  ;
  return;
}


function __ZN21render_primitive_list11release_allEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN21render_primitive_list12acquire_lockEv($2);
  var $3=(($2+40)|0);
  var $4=(($2)|0);
  __ZN15fixed_allocatorI16render_primitiveE11reclaim_allER11simple_listIS0_E($3, $4);
  var $5=(($2+60)|0);
  var $6=(($2+20)|0);
  __ZN15fixed_allocatorIN21render_primitive_list9referenceEE11reclaim_allER11simple_listIS1_E($5, $6);
  __ZN21render_primitive_list12release_lockEv($2);
  ;
  return;
}


function __ZN15fixed_allocatorI16render_primitiveE11reclaim_allER11simple_listIS0_E($this, $list) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$list;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listI16render_primitiveE11append_listERS1_($4, $5);
  ;
  return;
}


function __ZN15fixed_allocatorIN21render_primitive_list9referenceEE11reclaim_allER11simple_listIS1_E($this, $list) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$list;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listIN21render_primitive_list9referenceEE11append_listERS2_($4, $5);
  ;
  return;
}


function __ZN21render_primitive_list16append_or_returnER16render_primitiveb($this, $prim, $clipped) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$prim;
      var $4=(($clipped)&1);
      $3=$4;
      var $5=$1;
      var $6=$3;
      var $7=(($6) & 1);
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=(($5)|0);
      var $10=$2;
      var $11=__ZN11simple_listI16render_primitiveE6appendERS0_($9, $10);
      __label__ = 3; break;
    case 2: // $12
      var $13=(($5+40)|0);
      var $14=$2;
      __ZN15fixed_allocatorI16render_primitiveE7reclaimERS0_($13, $14);
      __label__ = 3; break;
    case 3: // $15
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15fixed_allocatorI16render_primitiveE7reclaimERS0_($this, $item) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$item;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=__ZN11simple_listI16render_primitiveE6appendERS0_($4, $5);
  ;
  return;
}


function __ZN14render_textureC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  var $7=(($2+28)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+32)|0);
  HEAP32[(($8)>>2)]=5;
  var $9=(($2+36)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=(($2+40)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($2+44)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($2+48)|0);
  var $13=(($2+112)|0);
  HEAP32[(($13)>>2)]=0;
  var $14=(($2+116)|0);
  HEAP32[(($14)>>2)]=0;
  var $15=(($2+12)|0);
  var $16=(($15+12)|0);
  HEAP32[(($16)>>2)]=0;
  var $17=(($2+12)|0);
  var $18=(($17+4)|0);
  HEAP32[(($18)>>2)]=0;
  var $19=(($2+12)|0);
  var $20=(($19+8)|0);
  HEAP32[(($20)>>2)]=0;
  var $21=(($2+12)|0);
  var $22=(($21)|0);
  HEAP32[(($22)>>2)]=0;
  var $23=(($2+48)|0);
  var $24=(($23)|0);
  var $25=$24;
  _memset($25, 0, 64, 1);
  ;
  return;
}


function __ZN14render_textureD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN14render_texture7releaseEv($2);
  ;
  return;
}


function __ZN14render_texture7releaseEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $scalenum;
      $1=$this;
      var $2=$1;
      $scalenum=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$scalenum;
      var $5=(($4)>>>0) < 8;
      if ($5) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $6
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$scalenum;
      var $10=(($2+48)|0);
      var $11=(($10+($9<<3))|0);
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13;
      __ZN14render_manager14invalidate_allEPv($8, $14);
      var $15=(($2)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNK14render_manager7machineEv($16);
      var $18=__ZN15running_machine7respoolEv($17);
      var $19=$scalenum;
      var $20=(($2+48)|0);
      var $21=(($20+($19<<3))|0);
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      __ZN13resource_pool6removeEPv($18, $24);
      var $25=$scalenum;
      var $26=(($2+48)|0);
      var $27=(($26+($25<<3))|0);
      var $28=(($27)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=$scalenum;
      var $30=(($2+48)|0);
      var $31=(($30+($29<<3))|0);
      var $32=(($31+4)|0);
      HEAP32[(($32)>>2)]=0;
      __label__ = 3; break;
    case 3: // $33
      var $34=$scalenum;
      var $35=(($34+1)|0);
      $scalenum=$35;
      __label__ = 1; break;
    case 4: // $36
      var $37=(($2)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($2+8)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      __ZN14render_manager14invalidate_allEPv($38, $41);
      var $42=(($2+8)|0);
      HEAP32[(($42)>>2)]=0;
      var $43=(($2+12)|0);
      var $44=(($43+12)|0);
      HEAP32[(($44)>>2)]=0;
      var $45=(($2+12)|0);
      var $46=(($45+4)|0);
      HEAP32[(($46)>>2)]=0;
      var $47=(($2+12)|0);
      var $48=(($47+8)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=(($2+12)|0);
      var $50=(($49)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=(($2+32)|0);
      HEAP32[(($51)>>2)]=5;
      var $52=(($2+44)|0);
      HEAP32[(($52)>>2)]=0;
      var $53=(($2+28)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=(($2+28)|0);
      var $58=HEAP32[(($57)>>2)];
      __Z13palette_derefP10_palette_t($58);
      __label__ = 6; break;
    case 6: // $59
      var $60=(($2+28)|0);
      HEAP32[(($60)>>2)]=0;
      var $61=(($2)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__ZNK14render_manager7machineEv($62);
      var $64=__ZN15running_machine7respoolEv($63);
      var $65=(($2+112)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$66;
      __ZN13resource_pool6removeEPv($64, $67);
      var $68=(($2+112)|0);
      HEAP32[(($68)>>2)]=0;
      var $69=(($2+116)|0);
      HEAP32[(($69)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_texture7releaseEv["X"]=1;

function __ZN14render_manager14invalidate_allEPv($this, $refptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $target;
      $1=$this;
      $2=$refptr;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 6; break;
    case 2: // $7
      var $8=(($3+4)|0);
      var $9=__ZNK11simple_listI13render_targetE5firstEv($8);
      $target=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$target;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $13
      var $14=$target;
      var $15=$2;
      __ZN13render_target14invalidate_allEPv($14, $15);
      __label__ = 5; break;
    case 5: // $16
      var $17=$target;
      var $18=__ZNK13render_target4nextEv($17);
      $target=$18;
      __label__ = 3; break;
    case 6: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13osd_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13osd_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13osd_interfaceD0Ev["X"]=1;

function __ZN21render_primitive_listC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      __ZN11simple_listI16render_primitiveEC1ER13resource_pool($5, _global_resource_pool);
      var $6=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN21render_primitive_list9referenceEEC1ER13resource_pool($6, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=(($4+40)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI16render_primitiveEC1ER13resource_pool($8, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=(($4+60)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN21render_primitive_list9referenceEEC1ER13resource_pool($10, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $11
      var $12=(($4+80)|0);
      var $13=(function() { try { __THREW__ = false; return _osd_lock_alloc() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $14
      HEAP32[(($12)>>2)]=$13;
      ;
      return;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      __label__ = 14; break;
    case 6: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $2=$21;
      var $22=$20.f1;
      $3=$22;
      __label__ = 12; break;
    case 7: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $2=$25;
      var $26=$24.f1;
      $3=$26;
      __label__ = 10; break;
    case 8: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $2=$29;
      var $30=$28.f1;
      $3=$30;
      var $31=(($4+60)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN21render_primitive_list9referenceEED1Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 17; break; }
    case 9: // $32
      __label__ = 10; break;
    case 10: // $33
      var $34=(($4+40)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI16render_primitiveED1Ev($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $35
      __label__ = 12; break;
    case 12: // $36
      var $37=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN21render_primitive_list9referenceEED1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $38
      __label__ = 14; break;
    case 14: // $39
      var $40=(($4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_primitiveED1Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $41
      __label__ = 16; break;
    case 16: // $42
      var $43=$2;
      var $44=$2;
      var $45=$3;
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21render_primitive_listC2Ev["X"]=1;

function __ZN21render_primitive_listD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZN21render_primitive_list11release_allEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $5
      var $6=(($4+80)|0);
      var $7=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return _osd_lock_free($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=(($4+60)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN21render_primitive_list9referenceEED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $10
      var $11=(($4+40)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI16render_primitiveED1Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $12
      var $13=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN21render_primitive_list9referenceEED1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $14
      var $15=(($4)|0);
      __ZN11simple_listI16render_primitiveED1Ev($15);
      ;
      return;
    case 6: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      var $20=(($4+60)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN21render_primitive_list9referenceEED1Ev($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 7: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $2=$23;
      var $24=$22.f1;
      $3=$24;
      __label__ = 10; break;
    case 8: // $25
      __label__ = 10; break;
    case 9: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      __label__ = 13; break;
    case 10: // $30
      var $31=(($4+40)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI16render_primitiveED1Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $32
      __label__ = 13; break;
    case 12: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $2=$35;
      var $36=$34.f1;
      $3=$36;
      __label__ = 15; break;
    case 13: // $37
      var $38=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN21render_primitive_list9referenceEED1Ev($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $39
      __label__ = 15; break;
    case 15: // $40
      var $41=(($4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_primitiveED1Ev($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $42
      __label__ = 17; break;
    case 17: // $43
      var $44=$2;
      var $45=$2;
      var $46=$3;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21render_primitive_listD2Ev["X"]=1;

function __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($this, $bitmap, $sbounds, $format, $palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $scalenum;
      $1=$this;
      $2=$bitmap;
      $3=$sbounds;
      $4=$format;
      $5=$palette;
      var $6=$1;
      var $7=$4;
      var $8=(($7)|0)==1;
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$4;
      var $11=(($10)|0)==2;
      if ($11) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $12
      __label__ = 3; break;
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      var $16=$2;
      var $17=(($6+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($16)|0)!=(($18)|0);
      if ($19) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $20
      var $21=(($6+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $24
      var $25=(($6)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($6+8)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28;
      __ZN14render_manager14invalidate_allEPv($26, $29);
      __label__ = 8; break;
    case 8: // $30
      var $31=$5;
      var $32=(($6+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($31)|0)!=(($33)|0);
      if ($34) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $35
      var $36=(($6+28)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $39
      var $40=(($6+28)|0);
      var $41=HEAP32[(($40)>>2)];
      __Z13palette_derefP10_palette_t($41);
      __label__ = 11; break;
    case 11: // $42
      var $43=$5;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $45
      var $46=$5;
      __Z11palette_refP10_palette_t($46);
      __label__ = 13; break;
    case 13: // $47
      __label__ = 14; break;
    case 14: // $48
      var $49=$2;
      var $50=(($6+8)|0);
      HEAP32[(($50)>>2)]=$49;
      var $51=$3;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $53
      var $54=$3;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $59 = $56;__label__ = 17; break;
    case 16: // $57
      var $59 = 0;__label__ = 17; break;
    case 17: // $58
      var $59;
      var $60=(($6+12)|0);
      var $61=(($60)|0);
      HEAP32[(($61)>>2)]=$59;
      var $62=$3;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $64
      var $65=$3;
      var $66=(($65+8)|0);
      var $67=HEAP32[(($66)>>2)];
      var $70 = $67;__label__ = 20; break;
    case 19: // $68
      var $70 = 0;__label__ = 20; break;
    case 20: // $69
      var $70;
      var $71=(($6+12)|0);
      var $72=(($71+8)|0);
      HEAP32[(($72)>>2)]=$70;
      var $73=$3;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $75
      var $76=$3;
      var $77=(($76+4)|0);
      var $78=HEAP32[(($77)>>2)];
      var $91 = $78;__label__ = 26; break;
    case 22: // $79
      var $80=$2;
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $82
      var $83=$2;
      var $84=$83;
      var $85=(($84+12)|0);
      var $86=HEAP32[(($85)>>2)];
      var $89 = $86;__label__ = 25; break;
    case 24: // $87
      var $89 = 1000;__label__ = 25; break;
    case 25: // $88
      var $89;
      var $91 = $89;__label__ = 26; break;
    case 26: // $90
      var $91;
      var $92=(($6+12)|0);
      var $93=(($92+4)|0);
      HEAP32[(($93)>>2)]=$91;
      var $94=$3;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $96
      var $97=$3;
      var $98=(($97+12)|0);
      var $99=HEAP32[(($98)>>2)];
      var $112 = $99;__label__ = 32; break;
    case 28: // $100
      var $101=$2;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $103
      var $104=$2;
      var $105=$104;
      var $106=(($105+16)|0);
      var $107=HEAP32[(($106)>>2)];
      var $110 = $107;__label__ = 31; break;
    case 30: // $108
      var $110 = 1000;__label__ = 31; break;
    case 31: // $109
      var $110;
      var $112 = $110;__label__ = 32; break;
    case 32: // $111
      var $112;
      var $113=(($6+12)|0);
      var $114=(($113+12)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=$5;
      var $116=(($6+28)|0);
      HEAP32[(($116)>>2)]=$115;
      var $117=$4;
      var $118=(($6+32)|0);
      HEAP32[(($118)>>2)]=$117;
      $scalenum=0;
      __label__ = 33; break;
    case 33: // $119
      var $120=$scalenum;
      var $121=(($120)>>>0) < 8;
      if ($121) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $122
      var $123=$scalenum;
      var $124=(($6+48)|0);
      var $125=(($124+($123<<3))|0);
      var $126=(($125)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $129
      var $130=(($6)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$scalenum;
      var $133=(($6+48)|0);
      var $134=(($133+($132<<3))|0);
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=$136;
      __ZN14render_manager14invalidate_allEPv($131, $137);
      var $138=(($6)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=__ZNK14render_manager7machineEv($139);
      var $141=__ZN15running_machine7respoolEv($140);
      var $142=$scalenum;
      var $143=(($6+48)|0);
      var $144=(($143+($142<<3))|0);
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$146;
      __ZN13resource_pool6removeEPv($141, $147);
      __label__ = 36; break;
    case 36: // $148
      var $149=$scalenum;
      var $150=(($6+48)|0);
      var $151=(($150+($149<<3))|0);
      var $152=(($151)|0);
      HEAP32[(($152)>>2)]=0;
      var $153=$scalenum;
      var $154=(($6+48)|0);
      var $155=(($154+($153<<3))|0);
      var $156=(($155+4)|0);
      HEAP32[(($156)>>2)]=0;
      __label__ = 37; break;
    case 37: // $157
      var $158=$scalenum;
      var $159=(($158+1)|0);
      $scalenum=$159;
      __label__ = 33; break;
    case 38: // $160
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t["X"]=1;

function __ZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePv($dest, $source, $sbounds, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $color=__stackBase__;
  $1=$dest;
  $2=$source;
  $3=$sbounds;
  $4=$param;
  var $5=$color;
  assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[((__ZZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePvE5color)>>2)];HEAP32[(($5+4)>>2)]=HEAP32[((__ZZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePvE5color+4)>>2)];HEAP32[(($5+8)>>2)]=HEAP32[((__ZZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePvE5color+8)>>2)];HEAP32[(($5+12)>>2)]=HEAP32[((__ZZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePvE5color+12)>>2)];
  var $6=$1;
  var $7=$6;
  var $8=(($7+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$1;
  var $11=$10;
  var $12=(($11+8)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$1;
  var $15=$14;
  var $16=(($15+12)|0);
  var $17=HEAP32[(($16)>>2)];
  var $18=$1;
  var $19=$18;
  var $20=(($19+16)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$2;
  var $23=$3;
  __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($9, $13, $17, $21, $22, $23, $color);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21render_primitive_list13add_referenceEPv($this, $refptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ref;
      $1=$this;
      $2=$refptr;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK21render_primitive_list13has_referenceEPv($3, $4);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 3; break;
    case 2: // $7
      var $8=(($3+60)|0);
      var $9=__ZN15fixed_allocatorIN21render_primitive_list9referenceEE5allocEv($8);
      $ref=$9;
      var $10=$2;
      var $11=$ref;
      var $12=(($11+4)|0);
      HEAP32[(($12)>>2)]=$10;
      var $13=(($3+20)|0);
      var $14=$ref;
      var $15=__ZN11simple_listIN21render_primitive_list9referenceEE6appendERS1_($13, $14);
      __label__ = 3; break;
    case 3: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK21render_primitive_list13has_referenceEPv($this, $refptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ref;
      $2=$this;
      $3=$refptr;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=__ZNK11simple_listIN21render_primitive_list9referenceEE5firstEv($5);
      $ref=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$ref;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$ref;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=1;
      __label__ = 7; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$ref;
      var $20=__ZNK21render_primitive_list9reference4nextEv($19);
      $ref=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_texture10get_scaledEjjR14render_texinfoR21render_primitive_list($this, $dwidth, $dheight, $texinfo, $primlist) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $swidth;
      var $sheight;
      var $palbase;
      var $bpp;
      var $scaled;
      var $scalenum;
      var $lowest;
      var $15;
      var $16;
      $10=$this;
      $11=$dwidth;
      $12=$dheight;
      $13=$texinfo;
      $14=$primlist;
      var $17=$10;
      var $18=(($17+12)|0);
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17+12)|0);
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($20-$23)|0);
      $swidth=$24;
      var $25=(($17+12)|0);
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($17+12)|0);
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($27-$30)|0);
      $sheight=$31;
      var $32=$11;
      var $33=(($32)>>>0) < 1;
      if ($33) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $34
      $11=1;
      __label__ = 2; break;
    case 2: // $35
      var $36=$12;
      var $37=(($36)>>>0) < 1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      $12=1;
      __label__ = 4; break;
    case 4: // $39
      var $40=(($17+32)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)==1;
      if ($42) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $43
      var $44=(($17+32)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)==2;
      if ($46) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $47
      var $48=(($17+28)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=__Z27palette_entry_list_adjustedP10_palette_t($49);
      var $53 = $50;__label__ = 8; break;
    case 7: // $51
      var $53 = 0;__label__ = 8; break;
    case 8: // $52
      var $53;
      $palbase=$53;
      var $54=(($17+36)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $57
      var $58=(($17+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $61
      var $62=$swidth;
      var $63=$11;
      var $64=(($62)|0)==(($63)|0);
      if ($64) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $65
      var $66=$sheight;
      var $67=$12;
      var $68=(($66)|0)==(($67)|0);
      if ($68) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $69
      var $70=$14;
      var $71=(($17+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$72;
      __ZN21render_primitive_list13add_referenceEPv($70, $73);
      var $74=(($17+32)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0)==1;
      if ($76) { var $90 = 1;__label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $77
      var $78=(($17+32)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)==2;
      if ($80) { var $90 = 1;__label__ = 16; break; } else { __label__ = 14; break; }
    case 14: // $81
      var $82=(($17+32)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)==3;
      if ($84) { var $90 = 1;__label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $85
      var $86=(($17+32)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)==6;
      var $90 = $88;__label__ = 16; break;
    case 16: // $89
      var $90;
      var $91=$90 ? 16 : 32;
      var $92=(($91) & 255);
      $bpp=$92;
      var $93=(($17+8)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$94;
      var $96=(($95+4)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($17+12)|0);
      var $99=(($98+8)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($17+8)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$102;
      var $104=(($103+8)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($100*$105)|0);
      var $107=(($17+12)|0);
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($106+$109)|0);
      var $111=$bpp;
      var $112=(($111)&255);
      var $113=(((($112)|0)/8)|0);
      var $114=(($110*$113)|0);
      var $115=(($97+$114)|0);
      var $116=$13;
      var $117=(($116)|0);
      HEAP32[(($117)>>2)]=$115;
      var $118=(($17+8)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119;
      var $121=(($120+8)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$13;
      var $124=(($123+4)|0);
      HEAP32[(($124)>>2)]=$122;
      var $125=$swidth;
      var $126=$13;
      var $127=(($126+8)|0);
      HEAP32[(($127)>>2)]=$125;
      var $128=$sheight;
      var $129=$13;
      var $130=(($129+12)|0);
      HEAP32[(($130)>>2)]=$128;
      var $131=$palbase;
      var $132=$13;
      var $133=(($132+16)|0);
      HEAP32[(($133)>>2)]=$131;
      var $134=(($17+44)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+1)|0);
      HEAP32[(($134)>>2)]=$136;
      var $137=$13;
      var $138=(($137+20)|0);
      HEAP32[(($138)>>2)]=$136;
      $9=1;
      __label__ = 57; break;
    case 17: // $139
      $scaled=0;
      $scalenum=0;
      __label__ = 18; break;
    case 18: // $140
      var $141=$scalenum;
      var $142=(($141)>>>0) < 8;
      if ($142) { __label__ = 19; break; } else { __label__ = 25; break; }
    case 19: // $143
      var $144=$scalenum;
      var $145=(($17+48)|0);
      var $146=(($145+($144<<3))|0);
      $scaled=$146;
      var $147=$scaled;
      var $148=(($147)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $151
      var $152=$11;
      var $153=$scaled;
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$155;
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($152)|0)==(($158)|0);
      if ($159) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $160
      var $161=$12;
      var $162=$scaled;
      var $163=(($162)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164;
      var $166=(($165+16)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($161)|0)==(($167)|0);
      if ($168) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $169
      __label__ = 25; break;
    case 23: // $170
      __label__ = 24; break;
    case 24: // $171
      var $172=$scalenum;
      var $173=(($172+1)|0);
      $scalenum=$173;
      __label__ = 18; break;
    case 25: // $174
      var $175=$scalenum;
      var $176=(($175)|0)==8;
      if ($176) { __label__ = 26; break; } else { __label__ = 56; break; }
    case 26: // $177
      $lowest=-1;
      $scalenum=0;
      __label__ = 27; break;
    case 27: // $178
      var $179=$scalenum;
      var $180=(($179)>>>0) < 8;
      if ($180) { __label__ = 28; break; } else { __label__ = 34; break; }
    case 28: // $181
      var $182=$lowest;
      var $183=(($182)|0)==-1;
      if ($183) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $184
      var $185=$scalenum;
      var $186=(($17+48)|0);
      var $187=(($186+($185<<3))|0);
      var $188=(($187+4)|0);
      var $189=HEAPU32[(($188)>>2)];
      var $190=$lowest;
      var $191=(($17+48)|0);
      var $192=(($191+($190<<3))|0);
      var $193=(($192+4)|0);
      var $194=HEAPU32[(($193)>>2)];
      var $195=(($189)>>>0) < (($194)>>>0);
      if ($195) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $196
      var $197=$14;
      var $198=$scalenum;
      var $199=(($17+48)|0);
      var $200=(($199+($198<<3))|0);
      var $201=(($200)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=$202;
      var $204=__ZNK21render_primitive_list13has_referenceEPv($197, $203);
      if ($204) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $205
      var $206=$scalenum;
      $lowest=$206;
      __label__ = 32; break;
    case 32: // $207
      __label__ = 33; break;
    case 33: // $208
      var $209=$scalenum;
      var $210=(($209+1)|0);
      $scalenum=$210;
      __label__ = 27; break;
    case 34: // $211
      __label__ = 35; break;
    case 35: // $212
      var $213=$lowest;
      var $214=(($213)|0)!=-1;
      if ($214) { __label__ = 39; break; } else { __label__ = 36; break; }
    case 36: // $215
      var $216=___cxa_allocate_exception(1032);
      var $217=$216;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($217, ((STRING_TABLE.__str2705)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str12706)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str22707)|0),HEAP32[((tempInt+8)>>2)]=541,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $218
      ___cxa_throw($216, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 38: // $219
      var $220=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $221=$220.f0;
      $15=$221;
      var $222=$220.f1;
      $16=$222;
      ___cxa_free_exception($216);
      __label__ = 58; break;
    case 39: // $223
      __label__ = 40; break;
    case 40: // $224
      var $225=$lowest;
      var $226=(($17+48)|0);
      var $227=(($226+($225<<3))|0);
      $scaled=$227;
      var $228=$scaled;
      var $229=(($228)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $232
      var $233=(($17)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$scaled;
      var $236=(($235)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=$237;
      __ZN14render_manager14invalidate_allEPv($234, $238);
      var $239=(($17)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=__ZNK14render_manager7machineEv($240);
      var $242=__ZN15running_machine7respoolEv($241);
      var $243=$scaled;
      var $244=(($243)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=$245;
      __ZN13resource_pool6removeEPv($242, $246);
      __label__ = 42; break;
    case 42: // $247
      var $248=(($17)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=__ZNK14render_manager7machineEv($249);
      var $251=__ZN15running_machine7respoolEv($250);
      var $252=$4;
      var $253=$5;
      var $254=$6;
      var $255=$result_i;
      var $256=$7;
      var $257=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=552;
      var $258=HEAP32[(($4)>>2)];
      var $259=HEAP32[(($5)>>2)];
      var $260=HEAP32[(($6)>>2)];
      var $261=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($258, $259, $260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 45; break; };
    case 43: // $262
      HEAP32[(($result_i)>>2)]=$261;
      var $263=HEAP32[(($result_i)>>2)];
      var $264=(($263)|0)==0;
      if ($264) { __label__ = 44; break; } else { __label__ = 49; break; }
    case 44: // $265
      var $266=___cxa_allocate_exception(4);
      var $267=$266;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($267);
      (function() { try { __THREW__ = false; return ___cxa_throw($266, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 45; break; }
    case 45: // $268
      var $269=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $270=$269.f0;
      HEAP32[(($7)>>2)]=$270;
      var $271=$269.f1;
      HEAP32[(($8)>>2)]=$271;
      var $272=HEAP32[(($8)>>2)];
      var $273=(($272)|0) < 0;
      if ($273) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $274
      var $275=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($275);
      throw "Reached an unreachable!"
    case 47: // $276
      var $277=HEAP32[(($7)>>2)];
      var $278=HEAP32[(($7)>>2)];
      var $279=HEAP32[(($8)>>2)];
      var $280=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $278, tempValue);
      var $281=($280.f1 = $279, $280);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 48: // $282
      throw "Reached an unreachable!"
    case 49: // $_ZnwjPKci_exit
      var $283=HEAP32[(($result_i)>>2)];
      var $284=$4;
      var $285=$5;
      var $286=$6;
      var $287=$result_i;
      var $288=$7;
      var $289=$8;
      var $290=$283;
      var $291=$11;
      var $292=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($290, $291, $292, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $293
      var $294=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($251, $290);
      var $295=$scaled;
      var $296=(($295)|0);
      HEAP32[(($296)>>2)]=$294;
      var $297=(($17+44)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(($298+1)|0);
      HEAP32[(($297)>>2)]=$299;
      var $300=$scaled;
      var $301=(($300+4)|0);
      HEAP32[(($301)>>2)]=$299;
      var $302=(($17+36)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=$scaled;
      var $305=(($304)|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=(($17+8)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=(($17+12)|0);
      var $310=(($17+40)|0);
      var $311=HEAP32[(($310)>>2)];
      FUNCTION_TABLE[$303]($306, $308, $309, $311);
      __label__ = 56; break;
    case 51: // $312
      var $313=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $314=$313.f0;
      $15=$314;
      var $315=$313.f1;
      $16=$315;
      var $316=$1;
      var $317=$2;
      var $318=$3;
      HEAP32[(($1)>>2)]=$283;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=552;
      var $319=HEAP32[(($1)>>2)];
      var $320=(($319)|0)!=0;
      if ($320) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $321
      var $322=HEAP32[(($1)>>2)];
      var $323=HEAP32[(($2)>>2)];
      var $324=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($322, $323, $324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 59; break; }
    case 53: // $_noexc
      __label__ = 54; break;
    case 54: // $_ZdlPvPKci_exit
      var $325=$1;
      var $326=$2;
      var $327=$3;
      __label__ = 55; break;
    case 55: // $328
      __label__ = 58; break;
    case 56: // $329
      var $330=$14;
      var $331=$scaled;
      var $332=(($331)|0);
      var $333=HEAP32[(($332)>>2)];
      var $334=$333;
      __ZN21render_primitive_list13add_referenceEPv($330, $334);
      var $335=$scaled;
      var $336=(($335)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=$337;
      var $339=(($338+4)|0);
      var $340=HEAP32[(($339)>>2)];
      var $341=$13;
      var $342=(($341)|0);
      HEAP32[(($342)>>2)]=$340;
      var $343=$scaled;
      var $344=(($343)|0);
      var $345=HEAP32[(($344)>>2)];
      var $346=$345;
      var $347=(($346+8)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$13;
      var $350=(($349+4)|0);
      HEAP32[(($350)>>2)]=$348;
      var $351=$11;
      var $352=$13;
      var $353=(($352+8)|0);
      HEAP32[(($353)>>2)]=$351;
      var $354=$12;
      var $355=$13;
      var $356=(($355+12)|0);
      HEAP32[(($356)>>2)]=$354;
      var $357=$palbase;
      var $358=$13;
      var $359=(($358+16)|0);
      HEAP32[(($359)>>2)]=$357;
      var $360=$scaled;
      var $361=(($360+4)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=$13;
      var $364=(($363+20)|0);
      HEAP32[(($364)>>2)]=$362;
      $9=1;
      __label__ = 57; break;
    case 57: // $365
      var $366=$9;
      STACKTOP = __stackBase__;
      return $366;
    case 58: // $367
      var $368=$15;
      var $369=$15;
      var $370=$16;
      var $371=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $369, tempValue);
      var $372=($371.f1 = $370, $371);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 59: // $373
      var $374=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_texture10get_scaledEjjR14render_texinfoR21render_primitive_list["X"]=1;

function __ZNK16render_container37has_brightness_contrast_gamma_changesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+52)|0);
      var $4=(($3+4)|0);
      var $5=HEAPF32[(($4)>>2)];
      var $6=$5 != 1;
      if ($6) { var $18 = 1;__label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=(($2+52)|0);
      var $9=(($8+8)|0);
      var $10=HEAPF32[(($9)>>2)];
      var $11=$10 != 1;
      if ($11) { var $18 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      var $13=(($2+52)|0);
      var $14=(($13+12)|0);
      var $15=HEAPF32[(($14)>>2)];
      var $16=$15 != 1;
      var $18 = $16;__label__ = 3; break;
    case 3: // $17
      var $18;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16render_container16bcg_lookup_tableEiP10_palette_t($this, $texformat, $palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$texformat;
      $4=$palette;
      var $5=$2;
      var $6=$3;
      if ($6 == 1 || $6 == 2) {
        __label__ = 1; break;
      }
      else if ($6 == 3) {
        __label__ = 6; break;
      }
      else if ($6 == 4 || $6 == 5 || $6 == 6) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 1: // $7
      var $8=$4;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$4;
      var $12=(($5+92)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__Z26palette_client_get_paletteP15_palette_client($13);
      var $15=(($11)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($5+4704)|0);
      var $18=(($17)|0);
      var $21 = $18;__label__ = 5; break;
    case 4: // $19
      var $21 = 0;__label__ = 5; break;
    case 5: // $20
      var $21;
      $1=$21;
      __label__ = 9; break;
    case 6: // $22
      var $23=(($5+4192)|0);
      var $24=(($23)|0);
      $1=$24;
      __label__ = 9; break;
    case 7: // $25
      var $26=(($5+96)|0);
      var $27=(($26)|0);
      $1=$27;
      __label__ = 9; break;
    case 8: // $28
      $1=0;
      __label__ = 9; break;
    case 9: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_texture20get_adjusted_paletteER16render_container($this, $container) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i8=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i6=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $14=__stackBase__+64;
      var $15=__stackBase__+68;
      var $16;
      var $17;
      var $18;
      var $adjusted;
      var $numentries;
      var $newlookup;
      var $index;
      var $r;
      var $g;
      var $b;
      var $newlookup1;
      var $index2;
      var $val;
      var $newlookup3;
      var $index4;
      var $val5;
      $17=$this;
      $18=$container;
      var $19=$17;
      var $20=(($19+32)|0);
      var $21=HEAP32[(($20)>>2)];
      if ($21 == 1 || $21 == 2) {
        __label__ = 1; break;
      }
      else if ($21 == 3) {
        __label__ = 22; break;
      }
      else if ($21 == 4 || $21 == 5 || $21 == 6) {
        __label__ = 44; break;
      }
      else {
      __label__ = 66; break;
      }
      
    case 1: // $22
      __label__ = 2; break;
    case 2: // $23
      __label__ = 3; break;
    case 3: // $24
      var $25=(($19+28)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__Z27palette_entry_list_adjustedP10_palette_t($26);
      $adjusted=$27;
      var $28=$18;
      var $29=__ZNK16render_container37has_brightness_contrast_gamma_changesEv($28);
      if ($29) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $30
      var $31=$adjusted;
      $16=$31;
      __label__ = 70; break;
    case 5: // $32
      var $33=$18;
      var $34=(($19+32)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($19+28)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=__ZN16render_container16bcg_lookup_tableEiP10_palette_t($33, $35, $37);
      $adjusted=$38;
      var $39=$adjusted;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$adjusted;
      $16=$42;
      __label__ = 70; break;
    case 7: // $43
      var $44=(($19+28)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=__Z22palette_get_num_colorsP10_palette_t($45);
      var $47=(($19+28)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=__Z22palette_get_num_groupsP10_palette_t($48);
      var $50=(($46*$49)|0);
      $numentries=$50;
      var $51=(($19+112)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $54
      var $55=(($19+116)|0);
      var $56=HEAPU32[(($55)>>2)];
      var $57=$numentries;
      var $58=(($56)>>>0) < (($57)>>>0);
      if ($58) { __label__ = 9; break; } else { __label__ = 17; break; }
    case 9: // $59
      var $60=(($19)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__ZNK14render_manager7machineEv($61);
      var $63=__ZN15running_machine7respoolEv($62);
      var $64=$numentries;
      var $65=_llvm_umul_with_overflow_i32($64, 4);
      var $66=$65.f1;
      var $67=$65.f0;
      var $68=$66 ? -1 : $67;
      var $69=$11;
      var $70=$12;
      var $71=$13;
      var $72=$result_i;
      var $73=$14;
      var $74=$15;
      HEAP32[(($11)>>2)]=$68;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($13)>>2)]=602;
      var $75=HEAP32[(($11)>>2)];
      var $76=HEAP32[(($12)>>2)];
      var $77=HEAP32[(($13)>>2)];
      var $78=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($75, $76, $77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $79
      HEAP32[(($result_i)>>2)]=$78;
      var $80=HEAP32[(($result_i)>>2)];
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $82
      var $83=___cxa_allocate_exception(4);
      var $84=$83;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($84);
      (function() { try { __THREW__ = false; return ___cxa_throw($83, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $87=$86.f0;
      HEAP32[(($14)>>2)]=$87;
      var $88=$86.f1;
      HEAP32[(($15)>>2)]=$88;
      var $89=HEAP32[(($15)>>2)];
      var $90=(($89)|0) < 0;
      if ($90) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $91
      var $92=HEAP32[(($14)>>2)];
      ___cxa_call_unexpected($92);
      throw "Reached an unreachable!"
    case 14: // $93
      var $94=HEAP32[(($14)>>2)];
      var $95=HEAP32[(($14)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $95, tempValue);
      var $98=($97.f1 = $96, $97);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $99
      throw "Reached an unreachable!"
    case 16: // $_ZnajPKci_exit
      var $100=HEAP32[(($result_i)>>2)];
      var $101=$11;
      var $102=$12;
      var $103=$13;
      var $104=$result_i;
      var $105=$14;
      var $106=$15;
      var $107=$100;
      var $108=$numentries;
      var $109=__ZN13resource_pool9add_arrayIjEEPT_S2_i($63, $107, $108);
      $newlookup=$109;
      var $110=$newlookup;
      var $111=$110;
      var $112=(($19+112)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113;
      var $115=(($19+116)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=((($116<<2))|0);
      assert($117 % 1 === 0, 'memcpy given ' + $117 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($111, $114, $117, 1);
      var $118=(($19)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=__ZNK14render_manager7machineEv($119);
      var $121=__ZN15running_machine7respoolEv($120);
      var $122=(($19+112)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$123;
      __ZN13resource_pool6removeEPv($121, $124);
      var $125=$newlookup;
      var $126=(($19+112)|0);
      HEAP32[(($126)>>2)]=$125;
      var $127=$numentries;
      var $128=(($19+116)|0);
      HEAP32[(($128)>>2)]=$127;
      __label__ = 17; break;
    case 17: // $129
      $index=0;
      __label__ = 18; break;
    case 18: // $130
      var $131=$index;
      var $132=$numentries;
      var $133=(($131)|0) < (($132)|0);
      if ($133) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $134
      var $135=$18;
      var $136=$index;
      var $137=$adjusted;
      var $138=(($137+($136<<2))|0);
      var $139=HEAPU32[(($138)>>2)];
      var $140=$139 >>> 16;
      var $141=$140 & 255;
      var $142=(($141) & 255);
      var $143=__ZN16render_container31apply_brightness_contrast_gammaEh($135, $142);
      $r=$143;
      var $144=$18;
      var $145=$index;
      var $146=$adjusted;
      var $147=(($146+($145<<2))|0);
      var $148=HEAPU32[(($147)>>2)];
      var $149=$148 >>> 8;
      var $150=$149 & 255;
      var $151=(($150) & 255);
      var $152=__ZN16render_container31apply_brightness_contrast_gammaEh($144, $151);
      $g=$152;
      var $153=$18;
      var $154=$index;
      var $155=$adjusted;
      var $156=(($155+($154<<2))|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$157 & 255;
      var $159=(($158) & 255);
      var $160=__ZN16render_container31apply_brightness_contrast_gammaEh($153, $159);
      $b=$160;
      var $161=$index;
      var $162=$adjusted;
      var $163=(($162+($161<<2))|0);
      var $164=HEAPU32[(($163)>>2)];
      var $165=$164 >>> 24;
      var $166=$165 & 255;
      var $167=$166 & 255;
      var $168=$167 << 24;
      var $169=$r;
      var $170=(($169)&255);
      var $171=$170 & 255;
      var $172=$171 << 16;
      var $173=$168 | $172;
      var $174=$g;
      var $175=(($174)&255);
      var $176=$175 & 255;
      var $177=$176 << 8;
      var $178=$173 | $177;
      var $179=$b;
      var $180=(($179)&255);
      var $181=$180 & 255;
      var $182=$178 | $181;
      var $183=$index;
      var $184=(($19+112)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185+($183<<2))|0);
      HEAP32[(($186)>>2)]=$182;
      __label__ = 20; break;
    case 20: // $187
      var $188=$index;
      var $189=(($188+1)|0);
      $index=$189;
      __label__ = 18; break;
    case 21: // $190
      var $191=(($19+112)|0);
      var $192=HEAP32[(($191)>>2)];
      $16=$192;
      __label__ = 70; break;
    case 22: // $193
      var $194=$18;
      var $195=__ZNK16render_container37has_brightness_contrast_gamma_changesEv($194);
      if ($195) { __label__ = 25; break; } else { __label__ = 23; break; }
    case 23: // $196
      var $197=(($19+28)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198)|0)==0;
      if ($199) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $200
      $16=0;
      __label__ = 70; break;
    case 25: // $201
      var $202=(($19+28)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(($203)|0)==0;
      if ($204) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $205
      var $206=$18;
      var $207=(($19+32)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=__ZN16render_container16bcg_lookup_tableEiP10_palette_t($206, $208, 0);
      $16=$209;
      __label__ = 70; break;
    case 27: // $210
      __label__ = 28; break;
    case 28: // $211
      __label__ = 29; break;
    case 29: // $212
      var $213=(($19+28)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=__Z27palette_entry_list_adjustedP10_palette_t($214);
      $adjusted=$215;
      var $216=(($19+112)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(($217)|0)==0;
      if ($218) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $219
      var $220=(($19+116)|0);
      var $221=HEAPU32[(($220)>>2)];
      var $222=(($221)>>>0) < 128;
      if ($222) { __label__ = 31; break; } else { __label__ = 39; break; }
    case 31: // $223
      var $224=(($19)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=__ZNK14render_manager7machineEv($225);
      var $227=__ZN15running_machine7respoolEv($226);
      var $228=$6;
      var $229=$7;
      var $230=$8;
      var $231=$result_i6;
      var $232=$9;
      var $233=$10;
      HEAP32[(($6)>>2)]=512;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($8)>>2)]=632;
      var $234=HEAP32[(($6)>>2)];
      var $235=HEAP32[(($7)>>2)];
      var $236=HEAP32[(($8)>>2)];
      var $237=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($234, $235, $236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 34; break; };
    case 32: // $238
      HEAP32[(($result_i6)>>2)]=$237;
      var $239=HEAP32[(($result_i6)>>2)];
      var $240=(($239)|0)==0;
      if ($240) { __label__ = 33; break; } else { __label__ = 38; break; }
    case 33: // $241
      var $242=___cxa_allocate_exception(4);
      var $243=$242;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($243);
      (function() { try { __THREW__ = false; return ___cxa_throw($242, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 34; break; }
    case 34: // $244
      var $245=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $246=$245.f0;
      HEAP32[(($9)>>2)]=$246;
      var $247=$245.f1;
      HEAP32[(($10)>>2)]=$247;
      var $248=HEAP32[(($10)>>2)];
      var $249=(($248)|0) < 0;
      if ($249) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $250
      var $251=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($251);
      throw "Reached an unreachable!"
    case 36: // $252
      var $253=HEAP32[(($9)>>2)];
      var $254=HEAP32[(($9)>>2)];
      var $255=HEAP32[(($10)>>2)];
      var $256=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $254, tempValue);
      var $257=($256.f1 = $255, $256);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $258
      throw "Reached an unreachable!"
    case 38: // $_ZnajPKci_exit7
      var $259=HEAP32[(($result_i6)>>2)];
      var $260=$6;
      var $261=$7;
      var $262=$8;
      var $263=$result_i6;
      var $264=$9;
      var $265=$10;
      var $266=$259;
      var $267=__ZN13resource_pool9add_arrayIjEEPT_S2_i($227, $266, 128);
      $newlookup1=$267;
      var $268=$newlookup1;
      var $269=$268;
      var $270=(($19+112)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=$271;
      var $273=(($19+116)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=((($274<<2))|0);
      assert($275 % 1 === 0, 'memcpy given ' + $275 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($269, $272, $275, 1);
      var $276=(($19)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=__ZNK14render_manager7machineEv($277);
      var $279=__ZN15running_machine7respoolEv($278);
      var $280=(($19+112)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=$281;
      __ZN13resource_pool6removeEPv($279, $282);
      var $283=$newlookup1;
      var $284=(($19+112)|0);
      HEAP32[(($284)>>2)]=$283;
      var $285=(($19+116)|0);
      HEAP32[(($285)>>2)]=128;
      __label__ = 39; break;
    case 39: // $286
      $index2=0;
      __label__ = 40; break;
    case 40: // $287
      var $288=$index2;
      var $289=(($288)|0) < 32;
      if ($289) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $290
      var $291=$18;
      var $292=$index2;
      var $293=$adjusted;
      var $294=(($293+($292<<2))|0);
      var $295=HEAPU32[(($294)>>2)];
      var $296=$295 >>> 8;
      var $297=$296 & 255;
      var $298=(($297) & 255);
      var $299=__ZN16render_container31apply_brightness_contrast_gammaEh($291, $298);
      $val=$299;
      var $300=$val;
      var $301=(($300)&255);
      var $302=$301 << 0;
      var $303=$index2;
      var $304=(($303)|0);
      var $305=(($19+112)|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=(($306+($304<<2))|0);
      HEAP32[(($307)>>2)]=$302;
      var $308=$val;
      var $309=(($308)&255);
      var $310=$309 << 8;
      var $311=$index2;
      var $312=(($311+32)|0);
      var $313=(($19+112)|0);
      var $314=HEAP32[(($313)>>2)];
      var $315=(($314+($312<<2))|0);
      HEAP32[(($315)>>2)]=$310;
      var $316=$val;
      var $317=(($316)&255);
      var $318=$317 << 16;
      var $319=$index2;
      var $320=(($319+64)|0);
      var $321=(($19+112)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=(($322+($320<<2))|0);
      HEAP32[(($323)>>2)]=$318;
      var $324=$val;
      var $325=(($324)&255);
      var $326=$325 << 24;
      var $327=$index2;
      var $328=(($327+96)|0);
      var $329=(($19+112)|0);
      var $330=HEAP32[(($329)>>2)];
      var $331=(($330+($328<<2))|0);
      HEAP32[(($331)>>2)]=$326;
      __label__ = 42; break;
    case 42: // $332
      var $333=$index2;
      var $334=(($333+1)|0);
      $index2=$334;
      __label__ = 40; break;
    case 43: // $335
      var $336=(($19+112)|0);
      var $337=HEAP32[(($336)>>2)];
      $16=$337;
      __label__ = 70; break;
    case 44: // $338
      var $339=$18;
      var $340=__ZNK16render_container37has_brightness_contrast_gamma_changesEv($339);
      if ($340) { __label__ = 47; break; } else { __label__ = 45; break; }
    case 45: // $341
      var $342=(($19+28)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(($343)|0)==0;
      if ($344) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $345
      $16=0;
      __label__ = 70; break;
    case 47: // $346
      var $347=(($19+28)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=(($348)|0)==0;
      if ($349) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $350
      var $351=$18;
      var $352=(($19+32)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=__ZN16render_container16bcg_lookup_tableEiP10_palette_t($351, $353, 0);
      $16=$354;
      __label__ = 70; break;
    case 49: // $355
      __label__ = 50; break;
    case 50: // $356
      __label__ = 51; break;
    case 51: // $357
      var $358=(($19+28)|0);
      var $359=HEAP32[(($358)>>2)];
      var $360=__Z27palette_entry_list_adjustedP10_palette_t($359);
      $adjusted=$360;
      var $361=(($19+112)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=(($362)|0)==0;
      if ($363) { __label__ = 53; break; } else { __label__ = 52; break; }
    case 52: // $364
      var $365=(($19+116)|0);
      var $366=HEAPU32[(($365)>>2)];
      var $367=(($366)>>>0) < 1024;
      if ($367) { __label__ = 53; break; } else { __label__ = 61; break; }
    case 53: // $368
      var $369=(($19)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=__ZNK14render_manager7machineEv($370);
      var $372=__ZN15running_machine7respoolEv($371);
      var $373=$1;
      var $374=$2;
      var $375=$3;
      var $376=$result_i8;
      var $377=$4;
      var $378=$5;
      HEAP32[(($1)>>2)]=4096;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=667;
      var $379=HEAP32[(($1)>>2)];
      var $380=HEAP32[(($2)>>2)];
      var $381=HEAP32[(($3)>>2)];
      var $382=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($379, $380, $381) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 56; break; };
    case 54: // $383
      HEAP32[(($result_i8)>>2)]=$382;
      var $384=HEAP32[(($result_i8)>>2)];
      var $385=(($384)|0)==0;
      if ($385) { __label__ = 55; break; } else { __label__ = 60; break; }
    case 55: // $386
      var $387=___cxa_allocate_exception(4);
      var $388=$387;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($388);
      (function() { try { __THREW__ = false; return ___cxa_throw($387, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 56; break; }
    case 56: // $389
      var $390=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $391=$390.f0;
      HEAP32[(($4)>>2)]=$391;
      var $392=$390.f1;
      HEAP32[(($5)>>2)]=$392;
      var $393=HEAP32[(($5)>>2)];
      var $394=(($393)|0) < 0;
      if ($394) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $395
      var $396=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($396);
      throw "Reached an unreachable!"
    case 58: // $397
      var $398=HEAP32[(($4)>>2)];
      var $399=HEAP32[(($4)>>2)];
      var $400=HEAP32[(($5)>>2)];
      var $401=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $399, tempValue);
      var $402=($401.f1 = $400, $401);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 59: // $403
      throw "Reached an unreachable!"
    case 60: // $_ZnajPKci_exit9
      var $404=HEAP32[(($result_i8)>>2)];
      var $405=$1;
      var $406=$2;
      var $407=$3;
      var $408=$result_i8;
      var $409=$4;
      var $410=$5;
      var $411=$404;
      var $412=__ZN13resource_pool9add_arrayIjEEPT_S2_i($372, $411, 1024);
      $newlookup3=$412;
      var $413=$newlookup3;
      var $414=$413;
      var $415=(($19+112)|0);
      var $416=HEAP32[(($415)>>2)];
      var $417=$416;
      var $418=(($19+116)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=((($419<<2))|0);
      assert($420 % 1 === 0, 'memcpy given ' + $420 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($414, $417, $420, 1);
      var $421=(($19)|0);
      var $422=HEAP32[(($421)>>2)];
      var $423=__ZNK14render_manager7machineEv($422);
      var $424=__ZN15running_machine7respoolEv($423);
      var $425=(($19+112)|0);
      var $426=HEAP32[(($425)>>2)];
      var $427=$426;
      __ZN13resource_pool6removeEPv($424, $427);
      var $428=$newlookup3;
      var $429=(($19+112)|0);
      HEAP32[(($429)>>2)]=$428;
      var $430=(($19+116)|0);
      HEAP32[(($430)>>2)]=1024;
      __label__ = 61; break;
    case 61: // $431
      $index4=0;
      __label__ = 62; break;
    case 62: // $432
      var $433=$index4;
      var $434=(($433)|0) < 256;
      if ($434) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 63: // $435
      var $436=$18;
      var $437=$index4;
      var $438=$adjusted;
      var $439=(($438+($437<<2))|0);
      var $440=HEAPU32[(($439)>>2)];
      var $441=$440 >>> 8;
      var $442=$441 & 255;
      var $443=(($442) & 255);
      var $444=__ZN16render_container31apply_brightness_contrast_gammaEh($436, $443);
      $val5=$444;
      var $445=$val5;
      var $446=(($445)&255);
      var $447=$446 << 0;
      var $448=$index4;
      var $449=(($448)|0);
      var $450=(($19+112)|0);
      var $451=HEAP32[(($450)>>2)];
      var $452=(($451+($449<<2))|0);
      HEAP32[(($452)>>2)]=$447;
      var $453=$val5;
      var $454=(($453)&255);
      var $455=$454 << 8;
      var $456=$index4;
      var $457=(($456+256)|0);
      var $458=(($19+112)|0);
      var $459=HEAP32[(($458)>>2)];
      var $460=(($459+($457<<2))|0);
      HEAP32[(($460)>>2)]=$455;
      var $461=$val5;
      var $462=(($461)&255);
      var $463=$462 << 16;
      var $464=$index4;
      var $465=(($464+512)|0);
      var $466=(($19+112)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=(($467+($465<<2))|0);
      HEAP32[(($468)>>2)]=$463;
      var $469=$val5;
      var $470=(($469)&255);
      var $471=$470 << 24;
      var $472=$index4;
      var $473=(($472+768)|0);
      var $474=(($19+112)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=(($475+($473<<2))|0);
      HEAP32[(($476)>>2)]=$471;
      __label__ = 64; break;
    case 64: // $477
      var $478=$index4;
      var $479=(($478+1)|0);
      $index4=$479;
      __label__ = 62; break;
    case 65: // $480
      var $481=(($19+112)|0);
      var $482=HEAP32[(($481)>>2)];
      $16=$482;
      __label__ = 70; break;
    case 66: // $483
      __label__ = 67; break;
    case 67: // $484
      __label__ = 68; break;
    case 68: // $485
      __label__ = 69; break;
    case 69: // $486
      $16=0;
      __label__ = 70; break;
    case 70: // $487
      var $488=$16;
      STACKTOP = __stackBase__;
      return $488;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_texture20get_adjusted_paletteER16render_container["X"]=1;

function __ZN16render_container13overlay_scaleER8bitmap_tRKS0_RK10_rectanglePv($dest, $source, $sbounds, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $y;
      var $src;
      var $dst;
      var $sx;
      var $x;
      $1=$dest;
      $2=$source;
      $3=$sbounds;
      $4=$param;
      $y=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$y;
      var $7=$1;
      var $8=$7;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6)|0) < (($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $12
      var $13=$2;
      var $14=$13;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16;
      var $18=$y;
      var $19=$2;
      var $20=$19;
      var $21=(($20+16)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($18)|0)%(($22)|0);
      var $24=$2;
      var $25=$24;
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($23*$27)|0);
      var $29=(($17+($28<<2))|0);
      $src=$29;
      var $30=$1;
      var $31=$30;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33;
      var $35=$y;
      var $36=$1;
      var $37=$36;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($35*$39)|0);
      var $41=(($34+($40<<2))|0);
      $dst=$41;
      $sx=0;
      $x=0;
      __label__ = 3; break;
    case 3: // $42
      var $43=$x;
      var $44=$1;
      var $45=$44;
      var $46=(($45+12)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($43)|0) < (($47)|0);
      if ($48) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $49
      var $50=$sx;
      var $51=(($50+1)|0);
      $sx=$51;
      var $52=$src;
      var $53=(($52+($50<<2))|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$dst;
      var $56=(($55+4)|0);
      $dst=$56;
      HEAP32[(($55)>>2)]=$54;
      var $57=$sx;
      var $58=$2;
      var $59=$58;
      var $60=(($59+12)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($57)|0) >= (($61)|0);
      if ($62) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $63
      $sx=0;
      __label__ = 6; break;
    case 6: // $64
      __label__ = 7; break;
    case 7: // $65
      var $66=$x;
      var $67=(($66+1)|0);
      $x=$67;
      __label__ = 3; break;
    case 8: // $68
      __label__ = 9; break;
    case 9: // $69
      var $70=$y;
      var $71=(($70+1)|0);
      $y=$71;
      __label__ = 1; break;
    case 10: // $72
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16render_container13overlay_scaleER8bitmap_tRKS0_RK10_rectanglePv["X"]=1;

function __ZN16render_container31apply_brightness_contrast_gammaEh($this, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$value;
  var $3=$1;
  var $4=$2;
  var $5=(($3+52)|0);
  var $6=(($5+4)|0);
  var $7=HEAPF32[(($6)>>2)];
  var $8=(($3+52)|0);
  var $9=(($8+8)|0);
  var $10=HEAPF32[(($9)>>2)];
  var $11=(($3+52)|0);
  var $12=(($11+12)|0);
  var $13=HEAPF32[(($12)>>2)];
  var $14=__ZL31apply_brightness_contrast_gammahfff($4, $7, $10, $13);
  ;
  return $14;
}


function __ZN11simple_listIN16render_container4itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN16render_container4itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorIN16render_container4itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN15fixed_allocatorIN16render_container4itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN16render_container5emptyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=(($2+8)|0);
  __ZN15fixed_allocatorIN16render_container4itemEE11reclaim_allER11simple_listIS1_E($3, $4);
  ;
  return;
}


function __ZNK11emu_options10brightnessEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str302735)|0));
  ;
  return $4;
}


function __ZNK11emu_options8contrastEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str312736)|0));
  ;
  return $4;
}


function __ZNK11emu_options5gammaEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str322737)|0));
  ;
  return $4;
}


function __ZN16render_container17recompute_lookupsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      var $adjustedval;
      var $i1;
      var $adjustedval2;
      var $palette;
      var $adjusted_palette;
      var $colors;
      var $i3;
      var $newval;
      $1=$this;
      var $2=$1;
      $i=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$i;
      var $5=(($4)|0) < 256;
      if ($5) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $6
      var $7=$i;
      var $8=(($7) & 255);
      var $9=__ZN16render_container31apply_brightness_contrast_gammaEh($2, $8);
      $adjustedval=$9;
      var $10=$adjustedval;
      var $11=(($10)&255);
      var $12=$11 << 0;
      var $13=$i;
      var $14=(($13)|0);
      var $15=(($2+96)|0);
      var $16=(($15+($14<<2))|0);
      HEAP32[(($16)>>2)]=$12;
      var $17=$adjustedval;
      var $18=(($17)&255);
      var $19=$18 << 8;
      var $20=$i;
      var $21=(($20+256)|0);
      var $22=(($2+96)|0);
      var $23=(($22+($21<<2))|0);
      HEAP32[(($23)>>2)]=$19;
      var $24=$adjustedval;
      var $25=(($24)&255);
      var $26=$25 << 16;
      var $27=$i;
      var $28=(($27+512)|0);
      var $29=(($2+96)|0);
      var $30=(($29+($28<<2))|0);
      HEAP32[(($30)>>2)]=$26;
      var $31=$adjustedval;
      var $32=(($31)&255);
      var $33=$32 << 24;
      var $34=$i;
      var $35=(($34+768)|0);
      var $36=(($2+96)|0);
      var $37=(($36+($35<<2))|0);
      HEAP32[(($37)>>2)]=$33;
      __label__ = 3; break;
    case 3: // $38
      var $39=$i;
      var $40=(($39+1)|0);
      $i=$40;
      __label__ = 1; break;
    case 4: // $41
      $i1=0;
      __label__ = 5; break;
    case 5: // $42
      var $43=$i1;
      var $44=(($43)|0) < 32;
      if ($44) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $45
      var $46=$i1;
      var $47=(($46) & 255);
      var $48=__ZL7pal5bith($47);
      var $49=__ZN16render_container31apply_brightness_contrast_gammaEh($2, $48);
      $adjustedval2=$49;
      var $50=$adjustedval2;
      var $51=(($50)&255);
      var $52=$51 << 0;
      var $53=$i1;
      var $54=(($53)|0);
      var $55=(($2+4192)|0);
      var $56=(($55+($54<<2))|0);
      HEAP32[(($56)>>2)]=$52;
      var $57=$adjustedval2;
      var $58=(($57)&255);
      var $59=$58 << 8;
      var $60=$i1;
      var $61=(($60+32)|0);
      var $62=(($2+4192)|0);
      var $63=(($62+($61<<2))|0);
      HEAP32[(($63)>>2)]=$59;
      var $64=$adjustedval2;
      var $65=(($64)&255);
      var $66=$65 << 16;
      var $67=$i1;
      var $68=(($67+64)|0);
      var $69=(($2+4192)|0);
      var $70=(($69+($68<<2))|0);
      HEAP32[(($70)>>2)]=$66;
      var $71=$adjustedval2;
      var $72=(($71)&255);
      var $73=$72 << 24;
      var $74=$i1;
      var $75=(($74+96)|0);
      var $76=(($2+4192)|0);
      var $77=(($76+($75<<2))|0);
      HEAP32[(($77)>>2)]=$73;
      __label__ = 7; break;
    case 7: // $78
      var $79=$i1;
      var $80=(($79+1)|0);
      $i1=$80;
      __label__ = 5; break;
    case 8: // $81
      var $82=(($2+92)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $85
      var $86=(($2+92)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=__Z26palette_client_get_paletteP15_palette_client($87);
      $palette=$88;
      var $89=$palette;
      var $90=__Z27palette_entry_list_adjustedP10_palette_t($89);
      $adjusted_palette=$90;
      var $91=$palette;
      var $92=__Z22palette_get_num_colorsP10_palette_t($91);
      var $93=$palette;
      var $94=__Z22palette_get_num_groupsP10_palette_t($93);
      var $95=(($92*$94)|0);
      $colors=$95;
      $i3=0;
      __label__ = 10; break;
    case 10: // $96
      var $97=$i3;
      var $98=$colors;
      var $99=(($97)|0) < (($98)|0);
      if ($99) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $100
      var $101=$i3;
      var $102=$adjusted_palette;
      var $103=(($102+($101<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      $newval=$104;
      var $105=$newval;
      var $106=$105 & -16777216;
      var $107=$newval;
      var $108=$107 >>> 16;
      var $109=$108 & 255;
      var $110=(($109+512)|0);
      var $111=(($2+96)|0);
      var $112=(($111+($110<<2))|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$106 | $113;
      var $115=$newval;
      var $116=$115 >>> 8;
      var $117=$116 & 255;
      var $118=(($117+256)|0);
      var $119=(($2+96)|0);
      var $120=(($119+($118<<2))|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$114 | $121;
      var $123=$newval;
      var $124=$123 & 255;
      var $125=(($124)|0);
      var $126=(($2+96)|0);
      var $127=(($126+($125<<2))|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$122 | $128;
      var $130=$i3;
      var $131=(($2+4704)|0);
      var $132=(($131+($130<<2))|0);
      HEAP32[(($132)>>2)]=$129;
      __label__ = 12; break;
    case 12: // $133
      var $134=$i3;
      var $135=(($134+1)|0);
      $i3=$135;
      __label__ = 10; break;
    case 13: // $136
      __label__ = 14; break;
    case 14: // $137
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16render_container17recompute_lookupsEv["X"]=1;

function __ZN15fixed_allocatorIN16render_container4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15fixed_allocatorIN16render_container4itemEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN16render_container4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN16render_container4itemEED2Ev($2);
  ;
  return;
}


function __ZN14render_manager12texture_freeEP14render_texture($this, $texture) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$texture;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($3+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8-1)|0);
      HEAP32[(($7)>>2)]=$9;
      var $10=$2;
      __ZN14render_texture7releaseEv($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=(($3+32)|0);
      var $13=$2;
      __ZN15fixed_allocatorI14render_textureE7reclaimEPS0_($12, $13);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16render_container11set_overlayEP8bitmap_t($this, $bitmap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$bitmap;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($3+88)|0);
      var $7=HEAP32[(($6)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($5, $7);
      var $8=$2;
      var $9=(($3+84)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+84)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($15, 234, 0);
      var $17=(($3+88)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+88)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($19, $20, 0, 5, 0);
      __label__ = 2; break;
    case 2: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($this, $scaler, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $tex;
  $1=$this;
  $2=$scaler;
  $3=$param;
  var $4=$1;
  var $5=(($4+32)|0);
  var $6=__ZN15fixed_allocatorI14render_textureE5allocEv($5);
  $tex=$6;
  var $7=$tex;
  var $8=$2;
  var $9=$3;
  __ZN14render_texture5resetER14render_managerPFvR8bitmap_tRKS2_RK10_rectanglePvES9_($7, $4, $8, $9);
  var $10=(($4+28)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+1)|0);
  HEAP32[(($10)>>2)]=$12;
  var $13=$tex;
  ;
  return $13;
}


function __ZN16render_container17set_user_settingsERKNS_13user_settingsE($this, $settings) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$settings;
  var $3=$1;
  var $4=(($3+52)|0);
  var $5=$2;
  var $6=$4;
  var $7=$5;
  assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[(($7+8)>>2)];HEAP32[(($6+12)>>2)]=HEAP32[(($7+12)>>2)];HEAP32[(($6+16)>>2)]=HEAP32[(($7+16)>>2)];HEAP32[(($6+20)>>2)]=HEAP32[(($7+20)>>2)];HEAP32[(($6+24)>>2)]=HEAP32[(($7+24)>>2)];HEAP32[(($6+28)>>2)]=HEAP32[(($7+28)>>2)];
  __ZN16render_container17recompute_lookupsEv($3);
  ;
  return;
}


function __ZN16render_container8add_lineEfffffjj($this, $x0, $y0, $x1, $y1, $width, $argb, $flags) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $newitem;
  $1=$this;
  $2=$x0;
  $3=$y0;
  $4=$x1;
  $5=$y1;
  $6=$width;
  $7=$argb;
  $8=$flags;
  var $9=$1;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $14=$7;
  var $15=__ZN16render_container11add_genericEhffffj($9, 0, $10, $11, $12, $13, $14);
  $newitem=$15;
  var $16=$6;
  var $17=$newitem;
  var $18=(($17+48)|0);
  HEAPF32[(($18)>>2)]=$16;
  var $19=$8;
  var $20=$newitem;
  var $21=(($20+40)|0);
  HEAP32[(($21)>>2)]=$19;
  ;
  return;
}


function __ZN13resource_pool9add_arrayIjEEPT_S2_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIjEC1EPji($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIjEEPT_S2_i["X"]=1;

function __ZN16render_containerC2ER14render_managerP13screen_device($this, $manager, $screen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $color;
      $1=$this;
      $2=$manager;
      $3=$screen;
      var $6=$1;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=(($6+4)|0);
      var $9=$2;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($6+8)|0);
      var $11=$2;
      var $12=__ZNK14render_manager7machineEv($11);
      var $13=__ZN15running_machine7respoolEv($12);
      __ZN11simple_listIN16render_container4itemEEC1ER13resource_pool($10, $13);
      var $14=(($6+28)|0);
      var $15=$2;
      var $16=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $17
      var $18=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $19
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16render_container4itemEEC1ER13resource_pool($14, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $20
      var $21=(($6+48)|0);
      var $22=$3;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($6+52)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $24
      var $25=(($6+84)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($6+88)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=(($6+92)|0);
      HEAP32[(($27)>>2)]=0;
      $color=0;
      __label__ = 5; break;
    case 5: // $28
      var $29=$color;
      var $30=(($29)>>>0) < 65536;
      if ($30) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $31
      var $32=$color;
      var $33=(($6+4704)|0);
      var $34=(($33+($32<<2))|0);
      HEAP32[(($34)>>2)]=-16777216;
      __label__ = 7; break;
    case 7: // $35
      var $36=$color;
      var $37=(($36+1)|0);
      $color=$37;
      __label__ = 5; break;
    case 8: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $4=$40;
      var $41=$39.f1;
      $5=$41;
      __label__ = 32; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      $4=$44;
      var $45=$43.f1;
      $5=$45;
      var $46=(($6+28)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16render_container4itemEED1Ev($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 10: // $47
      (function() { try { __THREW__ = false; return __ZN16render_container5emptyEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 11: // $48
      var $49=$3;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 12; break; } else { __label__ = 24; break; }
    case 12: // $51
      var $52=$2;
      var $53=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 9; break; };
    case 13: // $54
      var $55=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 9; break; };
    case 14: // $56
      var $57=(($55+44)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58 & 7;
      var $60=(($6+52)|0);
      var $61=(($60)|0);
      HEAP32[(($61)>>2)]=$59;
      var $62=$2;
      var $63=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 9; break; };
    case 15: // $64
      var $65=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 9; break; };
    case 16: // $66
      var $67=(function() { try { __THREW__ = false; return __ZNK11emu_options10brightnessEv($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 9; break; };
    case 17: // $68
      var $69=(($6+52)|0);
      var $70=(($69+4)|0);
      HEAPF32[(($70)>>2)]=$67;
      var $71=$2;
      var $72=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $73
      var $74=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 9; break; };
    case 19: // $75
      var $76=(function() { try { __THREW__ = false; return __ZNK11emu_options8contrastEv($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 9; break; };
    case 20: // $77
      var $78=(($6+52)|0);
      var $79=(($78+8)|0);
      HEAPF32[(($79)>>2)]=$76;
      var $80=$2;
      var $81=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 9; break; };
    case 21: // $82
      var $83=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $84
      var $85=(function() { try { __THREW__ = false; return __ZNK11emu_options5gammaEv($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 9; break; };
    case 23: // $86
      var $87=(($6+52)|0);
      var $88=(($87+12)|0);
      HEAPF32[(($88)>>2)]=$85;
      __label__ = 24; break;
    case 24: // $89
      var $90=$2;
      var $91=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 9; break; };
    case 25: // $92
      var $93=(($91+564)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $96
      var $97=$2;
      var $98=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 9; break; };
    case 27: // $99
      var $100=(($98+564)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(function() { try { __THREW__ = false; return __Z20palette_client_allocP10_palette_t($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 9; break; };
    case 28: // $103
      var $104=(($6+92)|0);
      HEAP32[(($104)>>2)]=$102;
      __label__ = 29; break;
    case 29: // $105
      (function() { try { __THREW__ = false; return __ZN16render_container17recompute_lookupsEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 9; break; }
    case 30: // $106
      ;
      return;
    case 31: // $107
      __label__ = 32; break;
    case 32: // $108
      var $109=(($6+8)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16render_container4itemEED1Ev($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $110
      __label__ = 34; break;
    case 34: // $111
      var $112=$4;
      var $113=$4;
      var $114=$5;
      var $115=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $113, tempValue);
      var $116=($115.f1 = $114, $115);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16render_containerC2ER14render_managerP13screen_device["X"]=1;

function __ZN16render_containerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZN16render_container5emptyEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $5
      var $6=(($4+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4+88)|0);
      var $9=HEAP32[(($8)>>2)];
      (function() { try { __THREW__ = false; return __ZN14render_manager12texture_freeEP14render_texture($7, $9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $10
      var $11=(($4+92)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $14
      var $15=(($4+92)|0);
      var $16=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return __Z19palette_client_freeP15_palette_client($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      __label__ = 6; break;
    case 5: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $2=$20;
      var $21=$19.f1;
      $3=$21;
      var $22=(($4+28)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16render_container4itemEED1Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 6: // $23
      var $24=(($4+28)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16render_container4itemEED1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $25
      var $26=(($4+8)|0);
      __ZN11simple_listIN16render_container4itemEED1Ev($26);
      ;
      return;
    case 8: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $2=$29;
      var $30=$28.f1;
      $3=$30;
      __label__ = 10; break;
    case 9: // $31
      __label__ = 10; break;
    case 10: // $32
      var $33=(($4+8)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16render_container4itemEED1Ev($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $34
      __label__ = 12; break;
    case 12: // $35
      var $36=$2;
      var $37=$2;
      var $38=$3;
      var $39=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37, tempValue);
      var $40=($39.f1 = $38, $39);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16render_containerD2Ev["X"]=1;

function __ZL7pal5bith($bits) {
  ;
  var __label__;

  var $1;
  $1=$bits;
  var $2=$1;
  var $3=(($2)&255);
  var $4=$3 & 31;
  var $5=(($4) & 255);
  $1=$5;
  var $6=$1;
  var $7=(($6)&255);
  var $8=$7 << 3;
  var $9=$1;
  var $10=(($9)&255);
  var $11=$10 >> 2;
  var $12=$8 | $11;
  var $13=(($12) & 255);
  ;
  return $13;
}


function __ZN11simple_listIN16render_container4itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16render_container13user_settingsC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAPF32[(($4)>>2)]=1;
  var $5=(($2+8)|0);
  HEAPF32[(($5)>>2)]=1;
  var $6=(($2+12)|0);
  HEAPF32[(($6)>>2)]=1;
  var $7=(($2+16)|0);
  HEAPF32[(($7)>>2)]=1;
  var $8=(($2+20)|0);
  HEAPF32[(($8)>>2)]=1;
  var $9=(($2+24)|0);
  HEAPF32[(($9)>>2)]=0;
  var $10=(($2+28)|0);
  HEAPF32[(($10)>>2)]=0;
  ;
  return;
}


function __ZN16render_container11add_genericEhffffj($this, $type, $x0, $y0, $x1, $y1, $argb) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $newitem;
  $1=$this;
  $2=$type;
  $3=$x0;
  $4=$y0;
  $5=$x1;
  $6=$y1;
  $7=$argb;
  var $8=$1;
  var $9=(($8+28)|0);
  var $10=__ZN15fixed_allocatorIN16render_container4itemEE5allocEv($9);
  $newitem=$10;
  var $11=$2;
  var $12=$newitem;
  var $13=(($12+4)|0);
  HEAP8[($13)]=$11;
  var $14=$3;
  var $15=$newitem;
  var $16=(($15+8)|0);
  var $17=(($16)|0);
  HEAPF32[(($17)>>2)]=$14;
  var $18=$4;
  var $19=$newitem;
  var $20=(($19+8)|0);
  var $21=(($20+4)|0);
  HEAPF32[(($21)>>2)]=$18;
  var $22=$5;
  var $23=$newitem;
  var $24=(($23+8)|0);
  var $25=(($24+8)|0);
  HEAPF32[(($25)>>2)]=$22;
  var $26=$6;
  var $27=$newitem;
  var $28=(($27+8)|0);
  var $29=(($28+12)|0);
  HEAPF32[(($29)>>2)]=$26;
  var $30=$7;
  var $31=$30 >>> 16;
  var $32=$31 & 255;
  var $33=(($32)>>>0);
  var $34=$33*0.003921568859368563;
  var $35=$newitem;
  var $36=(($35+24)|0);
  var $37=(($36+4)|0);
  HEAPF32[(($37)>>2)]=$34;
  var $38=$7;
  var $39=$38 >>> 8;
  var $40=$39 & 255;
  var $41=(($40)>>>0);
  var $42=$41*0.003921568859368563;
  var $43=$newitem;
  var $44=(($43+24)|0);
  var $45=(($44+8)|0);
  HEAPF32[(($45)>>2)]=$42;
  var $46=$7;
  var $47=$46 & 255;
  var $48=(($47)>>>0);
  var $49=$48*0.003921568859368563;
  var $50=$newitem;
  var $51=(($50+24)|0);
  var $52=(($51+12)|0);
  HEAPF32[(($52)>>2)]=$49;
  var $53=$7;
  var $54=$53 >>> 24;
  var $55=$54 & 255;
  var $56=(($55)>>>0);
  var $57=$56*0.003921568859368563;
  var $58=$newitem;
  var $59=(($58+24)|0);
  var $60=(($59)|0);
  HEAPF32[(($60)>>2)]=$57;
  var $61=$newitem;
  var $62=(($61+40)|0);
  HEAP32[(($62)>>2)]=0;
  var $63=$newitem;
  var $64=(($63+44)|0);
  HEAP32[(($64)>>2)]=0;
  var $65=$newitem;
  var $66=(($65+48)|0);
  HEAPF32[(($66)>>2)]=0;
  var $67=$newitem;
  var $68=(($67+52)|0);
  HEAP32[(($68)>>2)]=0;
  var $69=(($8+8)|0);
  var $70=$newitem;
  var $71=__ZN11simple_listIN16render_container4itemEE6appendERS1_($69, $70);
  ;
  return $71;
}
__ZN16render_container11add_genericEhffffj["X"]=1;

function __ZN16render_container8add_quadEffffjP14render_texturej($this, $x0, $y0, $x1, $y1, $argb, $texture, $flags) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $newitem;
  $1=$this;
  $2=$x0;
  $3=$y0;
  $4=$x1;
  $5=$y1;
  $6=$argb;
  $7=$texture;
  $8=$flags;
  var $9=$1;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $14=$6;
  var $15=__ZN16render_container11add_genericEhffffj($9, 1, $10, $11, $12, $13, $14);
  $newitem=$15;
  var $16=$7;
  var $17=$newitem;
  var $18=(($17+52)|0);
  HEAP32[(($18)>>2)]=$16;
  var $19=$8;
  var $20=$newitem;
  var $21=(($20+40)|0);
  HEAP32[(($21)>>2)]=$19;
  ;
  return;
}


function __ZN16render_container8add_charEffffjR11render_fontt($this, $x0, $y0, $height, $aspect, $argb, $font, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $bounds=__stackBase__;
  var $texture;
  var $newitem;
  $1=$this;
  $2=$x0;
  $3=$y0;
  $4=$height;
  $5=$aspect;
  $6=$argb;
  $7=$font;
  $8=$ch;
  var $9=$1;
  var $10=$2;
  var $11=(($bounds)|0);
  HEAPF32[(($11)>>2)]=$10;
  var $12=$3;
  var $13=(($bounds+4)|0);
  HEAPF32[(($13)>>2)]=$12;
  var $14=$7;
  var $15=$4;
  var $16=$5;
  var $17=$8;
  var $18=(($17)&65535);
  var $19=__ZN11render_font27get_char_texture_and_boundsEffjR13render_bounds($14, $15, $16, $18, $bounds);
  $texture=$19;
  var $20=(($bounds)|0);
  var $21=HEAPF32[(($20)>>2)];
  var $22=(($bounds+4)|0);
  var $23=HEAPF32[(($22)>>2)];
  var $24=(($bounds+8)|0);
  var $25=HEAPF32[(($24)>>2)];
  var $26=(($bounds+12)|0);
  var $27=HEAPF32[(($26)>>2)];
  var $28=$6;
  var $29=__ZN16render_container11add_genericEhffffj($9, 1, $21, $23, $25, $27, $28);
  $newitem=$29;
  var $30=$texture;
  var $31=$newitem;
  var $32=(($31+52)|0);
  HEAP32[(($32)>>2)]=$30;
  var $33=$newitem;
  var $34=(($33+40)|0);
  HEAP32[(($34)>>2)]=256;
  var $35=$newitem;
  var $36=(($35+44)|0);
  HEAP32[(($36)>>2)]=1;
  STACKTOP = __stackBase__;
  return;
}
__ZN16render_container8add_charEffffjR11render_fontt["X"]=1;

function __ZL31apply_brightness_contrast_gammahfff($src, $brightness, $contrast, $gamma) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $srcval;
  var $result;
  $1=$src;
  $2=$brightness;
  $3=$contrast;
  $4=$gamma;
  var $5=$1;
  var $6=(($5)&255);
  var $7=$6*0.003921568859368563;
  $srcval=$7;
  var $8=$srcval;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZL34apply_brightness_contrast_gamma_fpffff($8, $9, $10, $11);
  $result=$12;
  var $13=$result;
  var $14=$13*255;
  var $15=($14 >= 0 ? Math.floor($14) : Math.ceil($14));
  ;
  return $15;
}


function __ZN16render_container34apply_brightness_contrast_gamma_fpEf($this, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$value;
  var $3=$1;
  var $4=$2;
  var $5=(($3+52)|0);
  var $6=(($5+4)|0);
  var $7=HEAPF32[(($6)>>2)];
  var $8=(($3+52)|0);
  var $9=(($8+8)|0);
  var $10=HEAPF32[(($9)>>2)];
  var $11=(($3+52)|0);
  var $12=(($11+12)|0);
  var $13=HEAPF32[(($12)>>2)];
  var $14=__ZL34apply_brightness_contrast_gamma_fpffff($4, $7, $10, $13);
  ;
  return $14;
}


function __ZL34apply_brightness_contrast_gamma_fpffff($srcval, $brightness, $contrast, $gamma) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$srcval;
      $2=$brightness;
      $3=$contrast;
      $4=$gamma;
      var $5=$1;
      var $6=$5;
      var $7=$4;
      var $8=1/$7;
      var $9=$8;
      var $10=_llvm_pow_f64($6, $9);
      var $11=$10;
      $1=$11;
      var $12=$1;
      var $13=$3;
      var $14=$12*$13;
      var $15=$2;
      var $16=$14+$15;
      var $17=$16-1;
      $1=$17;
      var $18=$1;
      var $19=$18 < 0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      $1=0;
      __label__ = 2; break;
    case 2: // $21
      var $22=$1;
      var $23=$22 > 1;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      $1=1;
      __label__ = 4; break;
    case 4: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16render_container14update_paletteEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $mindirty=__stackBase__;
      var $maxdirty=__stackBase__+4;
      var $dirty;
      var $palette;
      var $adjusted_palette;
      var $entry32;
      var $dirtybits;
      var $entry;
      var $finalentry;
      var $newval;
      $1=$this;
      var $2=$1;
      var $3=(($2+92)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 16; break;
    case 2: // $7
      var $8=(($2+92)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__Z29palette_client_get_dirty_listP15_palette_clientPjS1_($9, $mindirty, $maxdirty);
      $dirty=$10;
      var $11=$dirty;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 16; break; }
    case 3: // $13
      var $14=(($2+92)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__Z26palette_client_get_paletteP15_palette_client($15);
      $palette=$16;
      var $17=$palette;
      var $18=__Z27palette_entry_list_adjustedP10_palette_t($17);
      $adjusted_palette=$18;
      var $19=HEAPU32[(($mindirty)>>2)];
      var $20=Math.floor((($19)>>>0)/32);
      $entry32=$20;
      __label__ = 4; break;
    case 4: // $21
      var $22=$entry32;
      var $23=HEAPU32[(($maxdirty)>>2)];
      var $24=Math.floor((($23)>>>0)/32);
      var $25=(($22)>>>0) <= (($24)>>>0);
      if ($25) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $26
      var $27=$entry32;
      var $28=$dirty;
      var $29=(($28+($27<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      $dirtybits=$30;
      var $31=$dirtybits;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $33
      $entry=0;
      __label__ = 7; break;
    case 7: // $34
      var $35=$entry;
      var $36=(($35)>>>0) < 32;
      if ($36) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $37
      var $38=$dirtybits;
      var $39=$entry;
      var $40=1 << $39;
      var $41=$38 & $40;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$entry32;
      var $45=((($44<<5))|0);
      var $46=$entry;
      var $47=(($45+$46)|0);
      $finalentry=$47;
      var $48=$finalentry;
      var $49=$adjusted_palette;
      var $50=(($49+($48<<2))|0);
      var $51=HEAP32[(($50)>>2)];
      $newval=$51;
      var $52=$newval;
      var $53=$52 & -16777216;
      var $54=$newval;
      var $55=$54 >>> 16;
      var $56=$55 & 255;
      var $57=(($56+512)|0);
      var $58=(($2+96)|0);
      var $59=(($58+($57<<2))|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$53 | $60;
      var $62=$newval;
      var $63=$62 >>> 8;
      var $64=$63 & 255;
      var $65=(($64+256)|0);
      var $66=(($2+96)|0);
      var $67=(($66+($65<<2))|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$61 | $68;
      var $70=$newval;
      var $71=$70 & 255;
      var $72=(($71)|0);
      var $73=(($2+96)|0);
      var $74=(($73+($72<<2))|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$69 | $75;
      var $77=$finalentry;
      var $78=(($2+4704)|0);
      var $79=(($78+($77<<2))|0);
      HEAP32[(($79)>>2)]=$76;
      __label__ = 10; break;
    case 10: // $80
      __label__ = 11; break;
    case 11: // $81
      var $82=$entry;
      var $83=(($82+1)|0);
      $entry=$83;
      __label__ = 7; break;
    case 12: // $84
      __label__ = 13; break;
    case 13: // $85
      __label__ = 14; break;
    case 14: // $86
      var $87=$entry32;
      var $88=(($87+1)|0);
      $entry32=$88;
      __label__ = 4; break;
    case 15: // $89
      __label__ = 16; break;
    case 16: // $90
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16render_container14update_paletteEv["X"]=1;

function __ZN15fixed_allocatorIN16render_container4itemEE5allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $result_i=__stackBase__+4;
      var $2=__stackBase__+8;
      var $3=__stackBase__+12;
      var $4;
      var $result;
      $4=$this;
      var $5=$4;
      var $6=(($5)|0);
      var $7=__ZN11simple_listIN16render_container4itemEE11detach_headEv($6);
      $result=$7;
      var $8=$result;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $10
      var $11=(($5)|0);
      var $12=__ZNK11simple_listIN16render_container4itemEE4poolEv($11);
      var $13=$1;
      var $14=$result_i;
      var $15=$2;
      var $16=$3;
      HEAP32[(($1)>>2)]=56;
      var $17=HEAP32[(($1)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($2)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($3)>>2)]=$28;
      var $29=HEAP32[(($3)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 6: // $33
      var $34=HEAP32[(($2)>>2)];
      var $35=HEAP32[(($2)>>2)];
      var $36=HEAP32[(($3)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $39
      throw "Reached an unreachable!"
    case 8: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$1;
      var $42=$result_i;
      var $43=$2;
      var $44=$3;
      var $45=$40;
      var $46=__ZN13resource_pool10add_objectIN16render_container4itemEEEPT_S4_($12, $45);
      $result=$46;
      __label__ = 9; break;
    case 9: // $47
      var $48=$result;
      STACKTOP = __stackBase__;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15fixed_allocatorIN16render_container4itemEE5allocEv["X"]=1;

function __ZN19render_layer_config21set_backdrops_enabledEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 1;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -2;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19render_layer_config20set_overlays_enabledEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 2;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -3;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19render_layer_config18set_bezels_enabledEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 4;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -5;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19render_layer_config19set_cpanels_enabledEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 8;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -9;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19render_layer_config20set_marquees_enabledEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 16;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -17;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11layout_fileEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI11layout_fileEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN19render_layer_configC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19render_layer_configC2Ev($2);
  ;
  return;
}


function __ZN11simple_listI16render_containerEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI16render_containerEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK11emu_options13use_backdropsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str492754)|0));
  ;
  return $4;
}


function __ZNK11emu_options12use_overlaysEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str482753)|0));
  ;
  return $4;
}


function __ZNK11emu_options10use_bezelsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str472752)|0));
  ;
  return $4;
}


function __ZNK11emu_options11use_cpanelsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str462751)|0));
  ;
  return $4;
}


function __ZNK11emu_options12use_marqueesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str452750)|0));
  ;
  return $4;
}


function __ZN13render_targetC2ER14render_managerPKcj($this, $manager, $layoutfile, $flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$this;
      $10=$manager;
      $11=$layoutfile;
      $12=$flags;
      var $15=$9;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($15+4)|0);
      var $18=$10;
      HEAP32[(($17)>>2)]=$18;
      var $19=(($15+8)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($15+12)|0);
      var $21=$10;
      var $22=__ZNK14render_manager7machineEv($21);
      var $23=__ZN15running_machine7respoolEv($22);
      var $24=$4;
      var $25=$5;
      var $26=$6;
      var $27=$result_i;
      var $28=$7;
      var $29=$8;
      HEAP32[(($4)>>2)]=20;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=1054;
      var $30=HEAP32[(($4)>>2)];
      var $31=HEAP32[(($5)>>2)];
      var $32=HEAP32[(($6)>>2)];
      var $33=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30, $31, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $34
      HEAP32[(($result_i)>>2)]=$33;
      var $35=HEAP32[(($result_i)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $37
      var $38=___cxa_allocate_exception(4);
      var $39=$38;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39);
      (function() { try { __THREW__ = false; return ___cxa_throw($38, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      HEAP32[(($7)>>2)]=$42;
      var $43=$41.f1;
      HEAP32[(($8)>>2)]=$43;
      var $44=HEAP32[(($8)>>2)];
      var $45=(($44)|0) < 0;
      if ($45) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $46
      var $47=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($47);
      throw "Reached an unreachable!"
    case 5: // $48
      var $49=HEAP32[(($7)>>2)];
      var $50=HEAP32[(($7)>>2)];
      var $51=HEAP32[(($8)>>2)];
      var $52=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $50, tempValue);
      var $53=($52.f1 = $51, $52);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $54
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $55=HEAP32[(($result_i)>>2)];
      var $56=$4;
      var $57=$5;
      var $58=$6;
      var $59=$result_i;
      var $60=$7;
      var $61=$8;
      var $62=$55;
      var $63=$10;
      var $64=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 45; break; };
    case 8: // $65
      var $66=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 45; break; };
    case 9: // $67
      (function() { try { __THREW__ = false; return __ZN11simple_listI11layout_fileEC1ER13resource_pool($62, $66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 45; break; }
    case 10: // $68
      var $69=__ZN13resource_pool10add_objectI11simple_listI11layout_fileEEEPT_S5_($23, $62);
      HEAP32[(($20)>>2)]=$69;
      var $70=(($15+16)|0);
      var $71=$12;
      HEAP32[(($70)>>2)]=$71;
      var $72=(($15+20)|0);
      var $73=(($72)|0);
      var $74=(($73+252)|0);
      var $76 = $73;__label__ = 11; break;
    case 11: // $75
      var $76;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21render_primitive_listC1Ev]($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 50; break; }
    case 12: // $77
      var $78=(($76+84)|0);
      var $79=(($78)|0)==(($74)|0);
      if ($79) { __label__ = 13; break; } else { var $76 = $78;__label__ = 11; break; }
    case 13: // $80
      var $81=(($15+272)|0);
      HEAP32[(($81)>>2)]=0;
      var $82=(($15+276)|0);
      HEAP32[(($82)>>2)]=640;
      var $83=(($15+280)|0);
      HEAP32[(($83)>>2)]=480;
      var $84=(($15+284)|0);
      var $85=(($15+300)|0);
      HEAPF32[(($85)>>2)]=0;
      var $86=(($15+304)|0);
      HEAPF32[(($86)>>2)]=0;
      var $87=(($15+308)|0);
      HEAP32[(($87)>>2)]=0;
      var $88=(($15+312)|0);
      __ZN19render_layer_configC1Ev($88);
      var $89=(($15+316)|0);
      HEAP32[(($89)>>2)]=0;
      var $90=(($15+320)|0);
      HEAP32[(($90)>>2)]=0;
      var $91=(($15+324)|0);
      __ZN19render_layer_configC1Ev($91);
      var $92=(($15+328)|0);
      HEAP32[(($92)>>2)]=65536;
      var $93=(($15+332)|0);
      HEAP32[(($93)>>2)]=65536;
      var $94=(($15+336)|0);
      var $95=$10;
      var $96=__ZNK14render_manager7machineEv($95);
      var $97=__ZN15running_machine7respoolEv($96);
      __ZN11simple_listI16render_containerEC1ER13resource_pool($94, $97);
      var $98=(($15+324)|0);
      var $99=$10;
      var $100=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 54; break; };
    case 14: // $101
      var $102=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 54; break; };
    case 15: // $103
      var $104=(function() { try { __THREW__ = false; return __ZNK11emu_options13use_backdropsEv($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 54; break; };
    case 16: // $105
      var $106=(function() { try { __THREW__ = false; return __ZN19render_layer_config21set_backdrops_enabledEb($98, $104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 54; break; };
    case 17: // $107
      var $108=(($15+324)|0);
      var $109=$10;
      var $110=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 54; break; };
    case 18: // $111
      var $112=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 54; break; };
    case 19: // $113
      var $114=(function() { try { __THREW__ = false; return __ZNK11emu_options12use_overlaysEv($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 54; break; };
    case 20: // $115
      var $116=(function() { try { __THREW__ = false; return __ZN19render_layer_config20set_overlays_enabledEb($108, $114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 54; break; };
    case 21: // $117
      var $118=(($15+324)|0);
      var $119=$10;
      var $120=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 54; break; };
    case 22: // $121
      var $122=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 54; break; };
    case 23: // $123
      var $124=(function() { try { __THREW__ = false; return __ZNK11emu_options10use_bezelsEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 54; break; };
    case 24: // $125
      var $126=(function() { try { __THREW__ = false; return __ZN19render_layer_config18set_bezels_enabledEb($118, $124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 54; break; };
    case 25: // $127
      var $128=(($15+324)|0);
      var $129=$10;
      var $130=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 54; break; };
    case 26: // $131
      var $132=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 54; break; };
    case 27: // $133
      var $134=(function() { try { __THREW__ = false; return __ZNK11emu_options11use_cpanelsEv($132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 54; break; };
    case 28: // $135
      var $136=(function() { try { __THREW__ = false; return __ZN19render_layer_config19set_cpanels_enabledEb($128, $134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 54; break; };
    case 29: // $137
      var $138=(($15+324)|0);
      var $139=$10;
      var $140=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 54; break; };
    case 30: // $141
      var $142=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 54; break; };
    case 31: // $143
      var $144=(function() { try { __THREW__ = false; return __ZNK11emu_options12use_marqueesEv($142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 54; break; };
    case 32: // $145
      var $146=(function() { try { __THREW__ = false; return __ZN19render_layer_config20set_marquees_enabledEb($138, $144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 54; break; };
    case 33: // $147
      var $148=(($15+324)|0);
      var $149=$10;
      var $150=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 54; break; };
    case 34: // $151
      var $152=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 54; break; };
    case 35: // $153
      var $154=(function() { try { __THREW__ = false; return __ZNK11emu_options12artwork_cropEv($152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 54; break; };
    case 36: // $155
      var $156=(function() { try { __THREW__ = false; return __ZN19render_layer_config18set_zoom_to_screenEb($148, $154) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 54; break; };
    case 37: // $157
      var $158=(($15+308)|0);
      HEAP32[(($158)>>2)]=0;
      var $159=$10;
      var $160=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 54; break; };
    case 38: // $161
      var $162=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 54; break; };
    case 39: // $163
      var $164=(function() { try { __THREW__ = false; return __ZNK11emu_options6rotateEv($162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 54; break; };
    case 40: // $165
      if ($164) { __label__ = 55; break; } else { __label__ = 41; break; }
    case 41: // $166
      var $167=$10;
      var $168=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 54; break; };
    case 42: // $169
      var $170=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 54; break; };
    case 43: // $171
      var $172=(($170+44)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=$173 & 7;
      var $175=(function() { try { __THREW__ = false; return __ZL19orientation_reversei($174) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 54; break; };
    case 44: // $176
      var $177=(($15+320)|0);
      HEAP32[(($177)>>2)]=$175;
      __label__ = 55; break;
    case 45: // $178
      var $179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $180=$179.f0;
      $13=$180;
      var $181=$179.f1;
      $14=$181;
      var $182=$1;
      var $183=$2;
      var $184=$3;
      HEAP32[(($1)>>2)]=$55;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=1054;
      var $185=HEAP32[(($1)>>2)];
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $187
      var $188=HEAP32[(($1)>>2)];
      var $189=HEAP32[(($2)>>2)];
      var $190=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($188, $189, $190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 101; break; }
    case 47: // $_noexc
      __label__ = 48; break;
    case 48: // $_ZdlPvPKci_exit
      var $191=$1;
      var $192=$2;
      var $193=$3;
      __label__ = 49; break;
    case 49: // $194
      __label__ = 100; break;
    case 50: // $195
      var $196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $197=$196.f0;
      $13=$197;
      var $198=$196.f1;
      $14=$198;
      var $199=(($73)|0)==(($76)|0);
      if ($199) { __label__ = 53; break; } else { var $201 = $76;__label__ = 51; break; }
    case 51: // $200
      var $201;
      var $202=(($201-84)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21render_primitive_listD1Ev]($202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 101; break; }
    case 52: // $203
      var $204=(($202)|0)==(($73)|0);
      if ($204) { __label__ = 53; break; } else { var $201 = $202;__label__ = 51; break; }
    case 53: // $205
      __label__ = 100; break;
    case 54: // $206
      var $207=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $208=$207.f0;
      $13=$208;
      var $209=$207.f1;
      $14=$209;
      var $210=(($15+336)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 101; break; }
    case 55: // $211
      var $212=$10;
      var $213=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 54; break; };
    case 56: // $214
      var $215=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 54; break; };
    case 57: // $216
      var $217=(function() { try { __THREW__ = false; return __ZNK11emu_options3rorEv($215) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 54; break; };
    case 58: // $218
      if ($217) { __label__ = 66; break; } else { __label__ = 59; break; }
    case 59: // $219
      var $220=$10;
      var $221=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 54; break; };
    case 60: // $222
      var $223=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 54; break; };
    case 61: // $224
      var $225=(function() { try { __THREW__ = false; return __ZNK11emu_options8auto_rorEv($223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 54; break; };
    case 62: // $226
      if ($225) { __label__ = 63; break; } else { __label__ = 68; break; }
    case 63: // $227
      var $228=$10;
      var $229=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 54; break; };
    case 64: // $230
      var $231=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($229) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 54; break; };
    case 65: // $232
      var $233=(($231+44)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$234 & 4;
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $237
      var $238=(($15+320)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(function() { try { __THREW__ = false; return __ZL15orientation_addii(5, $239) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 54; break; };
    case 67: // $241
      var $242=(($15+320)|0);
      HEAP32[(($242)>>2)]=$240;
      __label__ = 68; break;
    case 68: // $243
      var $244=$10;
      var $245=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 54; break; };
    case 69: // $246
      var $247=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($245) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 54; break; };
    case 70: // $248
      var $249=(function() { try { __THREW__ = false; return __ZNK11emu_options3rolEv($247) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 54; break; };
    case 71: // $250
      if ($249) { __label__ = 79; break; } else { __label__ = 72; break; }
    case 72: // $251
      var $252=$10;
      var $253=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($252) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 54; break; };
    case 73: // $254
      var $255=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($253) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 54; break; };
    case 74: // $256
      var $257=(function() { try { __THREW__ = false; return __ZNK11emu_options8auto_rolEv($255) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 54; break; };
    case 75: // $258
      if ($257) { __label__ = 76; break; } else { __label__ = 81; break; }
    case 76: // $259
      var $260=$10;
      var $261=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 54; break; };
    case 77: // $262
      var $263=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($261) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 54; break; };
    case 78: // $264
      var $265=(($263+44)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=$266 & 4;
      var $268=(($267)|0)!=0;
      if ($268) { __label__ = 79; break; } else { __label__ = 81; break; }
    case 79: // $269
      var $270=(($15+320)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=(function() { try { __THREW__ = false; return __ZL15orientation_addii(6, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 54; break; };
    case 80: // $273
      var $274=(($15+320)|0);
      HEAP32[(($274)>>2)]=$272;
      __label__ = 81; break;
    case 81: // $275
      var $276=$10;
      var $277=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 54; break; };
    case 82: // $278
      var $279=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 54; break; };
    case 83: // $280
      var $281=(function() { try { __THREW__ = false; return __ZNK11emu_options5flipxEv($279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 54; break; };
    case 84: // $282
      if ($281) { __label__ = 85; break; } else { __label__ = 86; break; }
    case 85: // $283
      var $284=(($15+320)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=$285 ^ 1;
      HEAP32[(($284)>>2)]=$286;
      __label__ = 86; break;
    case 86: // $287
      var $288=$10;
      var $289=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($288) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 54; break; };
    case 87: // $290
      var $291=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 54; break; };
    case 88: // $292
      var $293=(function() { try { __THREW__ = false; return __ZNK11emu_options5flipyEv($291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 54; break; };
    case 89: // $294
      if ($293) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $295
      var $296=(($15+320)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$297 ^ 2;
      HEAP32[(($296)>>2)]=$298;
      __label__ = 91; break;
    case 91: // $299
      var $300=(($15+320)|0);
      var $301=HEAP32[(($300)>>2)];
      var $302=(($15+308)|0);
      HEAP32[(($302)>>2)]=$301;
      var $303=(($15+312)|0);
      var $304=(($15+324)|0);
      var $305=$303;
      var $306=$304;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($305)]=HEAP8[($306)];
      var $307=$11;
      var $308=$12;
      var $309=$308 & 2;
      var $310=(($309)|0)!=0;
      (function() { try { __THREW__ = false; return __ZN13render_target17load_layout_filesEPKcb($15, $307, $310) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 54; break; }
    case 92: // $311
      (function() { try { __THREW__ = false; return __ZN13render_target8set_viewEi($15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 54; break; }
    case 93: // $312
      var $313=(function() { try { __THREW__ = false; return __ZNK13render_target6hiddenEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 54; break; };
    case 94: // $314
      if ($313) { __label__ = 98; break; } else { __label__ = 95; break; }
    case 95: // $315
      var $316=$10;
      var $317=(($316+24)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=(($318)|0)==0;
      if ($319) { __label__ = 96; break; } else { __label__ = 98; break; }
    case 96: // $320
      var $321=$10;
      (function() { try { __THREW__ = false; return __ZN14render_manager13set_ui_targetER13render_target($321, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 54; break; }
    case 97: // $322
      __label__ = 98; break;
    case 98: // $323
      STACKTOP = __stackBase__;
      return;
    case 99: // $324
      __label__ = 100; break;
    case 100: // $325
      var $326=$13;
      var $327=$13;
      var $328=$14;
      var $329=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $327, tempValue);
      var $330=($329.f1 = $328, $329);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 101: // $331
      var $332=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_targetC2ER14render_managerPKcj["X"]=1;

function __ZN13resource_pool10add_objectI11simple_listI11layout_fileEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11simple_listI11layout_fileEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11simple_listI11layout_fileEEEPT_S5_["X"]=1;

function __ZN19render_layer_config18set_zoom_to_screenEb($this, $zoom) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($zoom)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 32;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -33;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13render_target6hiddenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4 & 4;
  var $6=(($5)|0)!=0;
  ;
  return $6;
}


function __ZN14render_manager13set_ui_targetER13render_target($this, $target) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$target;
  var $3=$1;
  var $4=$2;
  var $5=(($3+24)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZNK14render_manager9ui_targetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+24)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI13render_targetE7indexofERKS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $index;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $index=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$index;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      var $17=$index;
      var $18=(($17+1)|0);
      $index=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$cur;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      $cur=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=-1;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13render_target10set_boundsEiif($this, $width, $height, $pixel_aspect) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$width;
  $3=$height;
  $4=$pixel_aspect;
  var $5=$1;
  var $6=$2;
  var $7=(($5+276)|0);
  HEAP32[(($7)>>2)]=$6;
  var $8=$3;
  var $9=(($5+280)|0);
  HEAP32[(($9)>>2)]=$8;
  var $10=(($5+284)|0);
  var $11=(($10+4)|0);
  HEAPF32[(($11)>>2)]=0;
  var $12=(($5+284)|0);
  var $13=(($12)|0);
  HEAPF32[(($13)>>2)]=0;
  var $14=$2;
  var $15=(($14)|0);
  var $16=(($5+284)|0);
  var $17=(($16+8)|0);
  HEAPF32[(($17)>>2)]=$15;
  var $18=$3;
  var $19=(($18)|0);
  var $20=(($5+284)|0);
  var $21=(($20+12)|0);
  HEAPF32[(($21)>>2)]=$19;
  var $22=$4;
  var $23=(($5+300)|0);
  HEAPF32[(($23)>>2)]=$22;
  ;
  return;
}


function __ZNK11emu_options12artwork_cropEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str442749)|0));
  ;
  return $4;
}


function __ZNK11emu_options6rotateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str202725)|0));
  ;
  return $4;
}


function __ZL19orientation_reversei($orientation) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$orientation;
      var $3=$2;
      var $4=$3 & 4;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=$2;
      $1=$7;
      __label__ = 3; break;
    case 2: // $8
      var $9=$2;
      var $10=__ZL22orientation_swap_flipsi($9);
      $1=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$1;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options3rorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str432748)|0));
  ;
  return $4;
}


function __ZNK11emu_options8auto_rorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str422747)|0));
  ;
  return $4;
}


function __ZL15orientation_addii($orientation1, $orientation2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$orientation1;
      $3=$orientation2;
      var $4=$3;
      var $5=$4 & 4;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=$3;
      var $10=$8 ^ $9;
      $1=$10;
      __label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $13=__ZL22orientation_swap_flipsi($12);
      var $14=$3;
      var $15=$13 ^ $14;
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options3rolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str412746)|0));
  ;
  return $4;
}


function __ZNK11emu_options8auto_rolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str402745)|0));
  ;
  return $4;
}


function __ZNK11emu_options5flipxEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str392744)|0));
  ;
  return $4;
}


function __ZNK11emu_options5flipyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str382743)|0));
  ;
  return $4;
}


function __ZN13render_target8set_viewEi($this, $viewindex) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $view;
      var $3=__stackBase__;
      $1=$this;
      $2=$viewindex;
      var $4=$1;
      var $5=$2;
      var $6=__ZNK13render_target13view_by_indexEi($4, $5);
      $view=$6;
      var $7=$view;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$view;
      var $11=(($4+8)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=$view;
      var $13=(($4+312)|0);
      var $14=$3;
      var $15=$13;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($14)]=HEAP8[($15)];
      __ZN11layout_view9recomputeE19render_layer_config($12, $3);
      __label__ = 2; break;
    case 2: // $16
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16render_containerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI16render_containerED2Ev($2);
  ;
  return;
}


function __ZNK13render_target12is_ui_targetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK14render_manager9ui_targetEv($4);
  var $6=(($2)|0)==(($5)|0);
  ;
  return $6;
}


function __ZNK13render_target5indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+4)|0);
  var $6=__ZNK11simple_listI13render_targetE7indexofERKS0_($5, $2);
  ;
  return $6;
}


function __ZNK13render_target13view_by_indexEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $file;
      var $view;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__ZNK11simple_listI11layout_fileE5firstEv($6);
      $file=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$file;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $11
      var $12=$file;
      var $13=__ZNK11layout_file10first_viewEv($12);
      $view=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$view;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $17
      var $18=(($4+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 1;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$view;
      var $24=__ZNK11layout_view7has_artEv($23);
      if ($24) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $25
      var $26=$3;
      var $27=(($26-1)|0);
      $3=$27;
      var $28=(($26)|0)==0;
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$view;
      $1=$30;
      __label__ = 14; break;
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      __label__ = 10; break;
    case 10: // $33
      var $34=$view;
      var $35=__ZNK11layout_view4nextEv($34);
      $view=$35;
      __label__ = 3; break;
    case 11: // $36
      __label__ = 12; break;
    case 12: // $37
      var $38=$file;
      var $39=__ZNK11layout_file4nextEv($38);
      $file=$39;
      __label__ = 1; break;
    case 13: // $40
      $1=0;
      __label__ = 14; break;
    case 14: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13render_target13view_by_indexEi["X"]=1;

function __ZN13render_target17load_layout_filesEPKcb($this, $layoutfile, $singlefile) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $basename;
      var $system;
      var $cloneof;
      var $4;
      var $5;
      $1=$this;
      $2=$layoutfile;
      var $6=(($singlefile)&1);
      $3=$6;
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK14render_manager7machineEv($9);
      var $11=__ZNK15running_machine8basenameEv($10);
      $basename=$11;
      var $12=$2;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$basename;
      var $16=$2;
      var $17=__ZN13render_target16load_layout_fileEPKcS1_($7, $15, $16);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19) & 1);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      __label__ = 25; break;
    case 4: // $22
      var $23=(($7+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK14render_manager7machineEv($24);
      var $26=__ZNK15running_machine6systemEv($25);
      $system=$26;
      var $27=$basename;
      var $28=$system;
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZN13render_target16load_layout_fileEPKcS1_($7, $27, $30);
      if ($31) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $32
      var $33=$basename;
      var $34=__ZN13render_target16load_layout_fileEPKcS1_($7, $33, ((STRING_TABLE.__str52710)|0));
      __label__ = 6; break;
    case 6: // $35
      var $36=$system;
      var $37=(($36+48)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      var $41=$system;
      var $42=(($41+48)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=__ZN13render_target16load_layout_fileEPKcS1_($7, 0, $43);
      __label__ = 8; break;
    case 8: // $45
      var $46=(($7+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=__ZNK14render_manager7machineEv($47);
      var $49=__ZNK15running_machine6configEv($48);
      var $50=(($49+52)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $53
      var $54=(($7+4)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=__ZNK14render_manager7machineEv($55);
      var $57=__ZNK15running_machine6configEv($56);
      var $58=(($57+52)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=__ZN13render_target16load_layout_fileEPKcS1_($7, 0, $59);
      __label__ = 10; break;
    case 10: // $61
      var $62=$system;
      var $63=__ZN11driver_list5cloneERK11game_driver($62);
      $cloneof=$63;
      var $64=$cloneof;
      var $65=(($64)|0)!=-1;
      if ($65) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $66
      var $67=$cloneof;
      var $68=__ZN11driver_list6driverEi($67);
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$cloneof;
      var $72=__ZN11driver_list6driverEi($71);
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=__ZN13render_target16load_layout_fileEPKcS1_($7, $70, $74);
      if ($75) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $76
      var $77=$cloneof;
      var $78=__ZN11driver_list6driverEi($77);
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=__ZN13render_target16load_layout_fileEPKcS1_($7, $80, ((STRING_TABLE.__str52710)|0));
      __label__ = 13; break;
    case 13: // $82
      __label__ = 14; break;
    case 14: // $83
      var $84=(($7+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=__ZNK14render_manager7machineEv($85);
      var $87=__ZNK15running_machine10devicelistEv($86);
      var $88=HEAP32[((_SCREEN)>>2)];
      var $89=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($87, $88);
      var $90=(($89)|0)==1;
      if ($90) { __label__ = 15; break; } else { __label__ = 25; break; }
    case 15: // $91
      var $92=$system;
      var $93=(($92+44)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$94 & 4;
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $97
      var $98=__ZN13render_target16load_layout_fileEPKcS1_($7, 0, ((STRING_TABLE._layout_vertical)|0));
      __label__ = 18; break;
    case 17: // $99
      var $100=__ZN13render_target16load_layout_fileEPKcS1_($7, 0, ((STRING_TABLE._layout_horizont)|0));
      __label__ = 18; break;
    case 18: // $101
      __label__ = 19; break;
    case 19: // $102
      var $103=(($7+12)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=__ZNK11simple_listI11layout_fileE5countEv($104);
      var $106=(($105)|0) > 0;
      if ($106) { __label__ = 23; break; } else { __label__ = 20; break; }
    case 20: // $107
      var $108=___cxa_allocate_exception(1032);
      var $109=$108;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($109, ((STRING_TABLE.__str2705)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str62711)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str22707)|0),HEAP32[((tempInt+8)>>2)]=1662,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $110
      ___cxa_throw($108, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 22: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $4=$113;
      var $114=$112.f1;
      $5=$114;
      ___cxa_free_exception($108);
      __label__ = 26; break;
    case 23: // $115
      __label__ = 24; break;
    case 24: // $116
      __label__ = 25; break;
    case 25: // $117
      ;
      return;
    case 26: // $118
      var $119=$4;
      var $120=$4;
      var $121=$5;
      var $122=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $120, tempValue);
      var $123=($122.f1 = $121, $122);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target17load_layout_filesEPKcb["X"]=1;

function __ZN13render_targetD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $8
      var $9=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $10
      var $11=(($4+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($9, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $14
      var $15=(($4+336)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=(($4+20)|0);
      var $18=(($17)|0);
      var $19=(($18+252)|0);
      var $21 = $19;__label__ = 5; break;
    case 5: // $20
      var $21;
      var $22=(($21-84)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21render_primitive_listD1Ev]($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $23
      var $24=(($22)|0)==(($18)|0);
      if ($24) { __label__ = 7; break; } else { var $21 = $22;__label__ = 5; break; }
    case 7: // $25
      ;
      return;
    case 8: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      var $30=(($4+336)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 20; break; }
    case 9: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $2=$33;
      var $34=$32.f1;
      $3=$34;
      __label__ = 15; break;
    case 10: // $35
      __label__ = 15; break;
    case 11: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $2=$38;
      var $39=$37.f1;
      $3=$39;
      var $40=(($18)|0)==(($22)|0);
      if ($40) { __label__ = 14; break; } else { var $42 = $22;__label__ = 12; break; }
    case 12: // $41
      var $42;
      var $43=(($42-84)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21render_primitive_listD1Ev]($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $44
      var $45=(($43)|0)==(($18)|0);
      if ($45) { __label__ = 14; break; } else { var $42 = $43;__label__ = 12; break; }
    case 14: // $46
      __label__ = 19; break;
    case 15: // $47
      var $48=(($4+20)|0);
      var $49=(($48)|0);
      var $50=(($49+252)|0);
      var $52 = $50;__label__ = 16; break;
    case 16: // $51
      var $52;
      var $53=(($52-84)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21render_primitive_listD1Ev]($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $54
      var $55=(($53)|0)==(($49)|0);
      if ($55) { __label__ = 18; break; } else { var $52 = $53;__label__ = 16; break; }
    case 18: // $56
      __label__ = 19; break;
    case 19: // $57
      var $58=$2;
      var $59=$2;
      var $60=$3;
      var $61=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $59, tempValue);
      var $62=($61.f1 = $60, $61);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_targetD2Ev["X"]=1;

function __ZNK11layout_view7screensEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  ;
  return $3;
}


function __ZN11layout_view4item6screenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+144)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device11screen_typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+356)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device12visible_areaEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+420)|0);
  ;
  return $3;
}


function __ZNK11layout_view4item6boundsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+152)|0);
  ;
  return $3;
}


function __ZN13render_target15configured_viewEPKcii($this, $viewname, $targetindex, $numtargets) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $view;
      var $viewindex;
      var $scrcount;
      var $ourindex;
      var $screen;
      var $viewscreens;
      var $viewscreens1;
      var $screen2;
      $1=$this;
      $2=$viewname;
      $3=$targetindex;
      $4=$numtargets;
      var $5=$1;
      $view=0;
      var $6=$2;
      var $7=_strcmp($6, ((STRING_TABLE.__str32708)|0));
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $9
      $viewindex=0;
      var $10=__ZNK13render_target13view_by_indexEi($5, 0);
      $view=$10;
      __label__ = 2; break;
    case 2: // $11
      var $12=$view;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $14
      var $15=$view;
      var $16=__ZNK11layout_view4nameEv($15);
      var $17=$2;
      var $18=$2;
      var $19=_strlen($18);
      var $20=__Z13core_strnicmpPKcS0_j($16, $17, $19);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      __label__ = 7; break;
    case 5: // $23
      __label__ = 6; break;
    case 6: // $24
      var $25=$viewindex;
      var $26=(($25+1)|0);
      $viewindex=$26;
      var $27=__ZNK13render_target13view_by_indexEi($5, $26);
      $view=$27;
      __label__ = 2; break;
    case 7: // $28
      __label__ = 8; break;
    case 8: // $29
      var $30=(($5+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__ZNK14render_manager7machineEv($31);
      var $33=__ZNK15running_machine10devicelistEv($32);
      var $34=HEAP32[((_SCREEN)>>2)];
      var $35=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($33, $34);
      $scrcount=$35;
      var $36=$view;
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 9; break; } else { __label__ = 46; break; }
    case 9: // $38
      var $39=$scrcount;
      var $40=(($39)|0) > 0;
      if ($40) { __label__ = 10; break; } else { __label__ = 46; break; }
    case 10: // $41
      var $42=$4;
      var $43=$scrcount;
      var $44=(($42)|0) >= (($43)|0);
      if ($44) { __label__ = 11; break; } else { __label__ = 27; break; }
    case 11: // $45
      var $46=__ZNK13render_target5indexEv($5);
      var $47=$scrcount;
      var $48=(($46)|0)%(($47)|0);
      $ourindex=$48;
      var $49=(($5+4)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=__ZNK14render_manager7machineEv($50);
      var $52=__ZNK15running_machine12first_screenEv($51);
      $screen=$52;
      __label__ = 12; break;
    case 12: // $53
      var $54=$screen;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $56
      var $57=$ourindex;
      var $58=(($57-1)|0);
      $ourindex=$58;
      var $59=(($57)|0)==0;
      if ($59) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $60
      __label__ = 17; break;
    case 15: // $61
      __label__ = 16; break;
    case 16: // $62
      var $63=$screen;
      var $64=__ZNK13screen_device11next_screenEv($63);
      $screen=$64;
      __label__ = 12; break;
    case 17: // $65
      $viewindex=0;
      var $66=__ZNK13render_target13view_by_indexEi($5, 0);
      $view=$66;
      __label__ = 18; break;
    case 18: // $67
      var $68=$view;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $70
      var $71=$view;
      var $72=__ZNK11layout_view7screensEv($71);
      $viewscreens=$72;
      var $73=$viewscreens;
      var $74=__ZNK18render_screen_list5countEv($73);
      var $75=(($74)|0)==1;
      if ($75) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $76
      var $77=$viewscreens;
      var $78=$screen;
      var $79=__ZNK18render_screen_list8containsER13screen_device($77, $78);
      if ($79) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $80
      __label__ = 26; break;
    case 22: // $81
      var $82=$viewscreens;
      var $83=__ZNK18render_screen_list5countEv($82);
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $85
      $view=0;
      __label__ = 26; break;
    case 24: // $86
      __label__ = 25; break;
    case 25: // $87
      var $88=$viewindex;
      var $89=(($88+1)|0);
      $viewindex=$89;
      var $90=__ZNK13render_target13view_by_indexEi($5, $89);
      $view=$90;
      __label__ = 18; break;
    case 26: // $91
      __label__ = 27; break;
    case 27: // $92
      var $93=$view;
      var $94=(($93)|0)==0;
      if ($94) { __label__ = 28; break; } else { __label__ = 45; break; }
    case 28: // $95
      $viewindex=0;
      var $96=__ZNK13render_target13view_by_indexEi($5, 0);
      $view=$96;
      __label__ = 29; break;
    case 29: // $97
      var $98=$view;
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 30; break; } else { __label__ = 44; break; }
    case 30: // $100
      var $101=$view;
      var $102=__ZNK11layout_view7screensEv($101);
      $viewscreens1=$102;
      var $103=$viewscreens1;
      var $104=__ZNK18render_screen_list5countEv($103);
      var $105=(($104)|0)==0;
      if ($105) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $106
      __label__ = 44; break;
    case 32: // $107
      var $108=$viewscreens1;
      var $109=__ZNK18render_screen_list5countEv($108);
      var $110=$scrcount;
      var $111=(($109)|0) >= (($110)|0);
      if ($111) { __label__ = 33; break; } else { __label__ = 42; break; }
    case 33: // $112
      var $113=(($5+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=__ZNK14render_manager7machineEv($114);
      var $116=__ZNK15running_machine12first_screenEv($115);
      $screen2=$116;
      __label__ = 34; break;
    case 34: // $117
      var $118=$screen2;
      var $119=(($118)|0)!=0;
      if ($119) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $120
      var $121=$viewscreens1;
      var $122=$screen2;
      var $123=__ZNK18render_screen_list8containsER13screen_device($121, $122);
      if ($123) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $124
      __label__ = 39; break;
    case 37: // $125
      __label__ = 38; break;
    case 38: // $126
      var $127=$screen2;
      var $128=__ZNK13screen_device11next_screenEv($127);
      $screen2=$128;
      __label__ = 34; break;
    case 39: // $129
      var $130=$screen2;
      var $131=(($130)|0)==0;
      if ($131) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $132
      __label__ = 44; break;
    case 41: // $133
      __label__ = 42; break;
    case 42: // $134
      __label__ = 43; break;
    case 43: // $135
      var $136=$viewindex;
      var $137=(($136+1)|0);
      $viewindex=$137;
      var $138=__ZNK13render_target13view_by_indexEi($5, $137);
      $view=$138;
      __label__ = 29; break;
    case 44: // $139
      __label__ = 45; break;
    case 45: // $140
      __label__ = 46; break;
    case 46: // $141
      var $142=$view;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $144
      var $145=$view;
      var $146=__ZNK13render_target10view_indexER11layout_view($5, $145);
      var $149 = $146;__label__ = 49; break;
    case 48: // $147
      var $149 = 0;__label__ = 49; break;
    case 49: // $148
      var $149;
      ;
      return $149;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target15configured_viewEPKcii["X"]=1;

function __ZNK11layout_view4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK13screen_device11next_screenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK8device_t8typenextEv($3);
  var $5=__Z8downcastIP13screen_device8device_tET_PT0_($4);
  ;
  return $5;
}


function __ZNK18render_screen_list5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listIN18render_screen_list4itemEE5countEv($3);
  ;
  return $4;
}


function __ZNK18render_screen_list8containsER13screen_device($this, $screen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curitem;
      $2=$this;
      $3=$screen;
      var $4=$2;
      var $5=(($4)|0);
      var $6=__ZNK11simple_listIN18render_screen_list4itemEE5firstEv($5);
      $curitem=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$curitem;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$curitem;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=1;
      __label__ = 7; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$curitem;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      $curitem=$21;
      __label__ = 1; break;
    case 6: // $22
      $1=0;
      __label__ = 7; break;
    case 7: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13render_target10view_indexER11layout_view($this, $targetview) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $index;
      var $file;
      var $view;
      $2=$this;
      $3=$targetview;
      var $4=$2;
      $index=0;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__ZNK11simple_listI11layout_fileE5firstEv($6);
      $file=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$file;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $11
      var $12=$file;
      var $13=__ZNK11layout_file10first_viewEv($12);
      $view=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$view;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $17
      var $18=(($4+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 1;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$view;
      var $24=__ZNK11layout_view7has_artEv($23);
      if ($24) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $25
      var $26=$3;
      var $27=$view;
      var $28=(($26)|0)==(($27)|0);
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$index;
      $1=$30;
      __label__ = 14; break;
    case 8: // $31
      var $32=$index;
      var $33=(($32+1)|0);
      $index=$33;
      __label__ = 9; break;
    case 9: // $34
      __label__ = 10; break;
    case 10: // $35
      var $36=$view;
      var $37=__ZNK11layout_view4nextEv($36);
      $view=$37;
      __label__ = 3; break;
    case 11: // $38
      __label__ = 12; break;
    case 12: // $39
      var $40=$file;
      var $41=__ZNK11layout_file4nextEv($40);
      $file=$41;
      __label__ = 1; break;
    case 13: // $42
      $1=0;
      __label__ = 14; break;
    case 14: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13render_target10view_indexER11layout_view["X"]=1;

function __ZN13render_target9view_nameEi($this, $viewindex) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $view;
      $1=$this;
      $2=$viewindex;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK13render_target13view_by_indexEi($3, $4);
      $view=$5;
      var $6=$view;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$view;
      var $10=__ZNK11layout_view4nameEv($9);
      var $13 = $10;__label__ = 3; break;
    case 2: // $11
      var $13 = 0;__label__ = 3; break;
    case 3: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13render_target12view_screensEi($this, $viewindex) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $view;
      $1=$this;
      $2=$viewindex;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK13render_target13view_by_indexEi($3, $4);
      $view=$5;
      var $6=$view;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$view;
      var $10=__ZNK11layout_view7screensEv($9);
      var $13 = $10;__label__ = 3; break;
    case 2: // $11
      var $13 = __ZN13render_target19s_empty_screen_listE;__label__ = 3; break;
    case 3: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13render_target20compute_visible_areaEiifiRiS0_($this, $target_width, $target_height, $target_pixel_aspect, $target_orientation, $visible_width, $visible_height) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $width;
      var $height;
      var $scale;
      var $8=__stackBase__;
      var $temp;
      $1=$this;
      $2=$target_width;
      $3=$target_height;
      $4=$target_pixel_aspect;
      $5=$target_orientation;
      $6=$visible_width;
      $7=$visible_height;
      var $9=$1;
      var $10=$4;
      var $11=$10 != 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $12
      var $13=(($9+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($9+312)|0);
      var $16=$8;
      var $17=$15;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($16)]=HEAP8[($17)];
      var $18=__ZNK11layout_view16effective_aspectE19render_layer_config($14, $8);
      $width=$18;
      $height=1;
      var $19=$5;
      var $20=$19 & 4;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $22
      __label__ = 3; break;
    case 3: // $23
      var $24=$width;
      $temp=$24;
      var $25=$height;
      $width=$25;
      var $26=$temp;
      $height=$26;
      __label__ = 4; break;
    case 4: // $27
      __label__ = 5; break;
    case 5: // $28
      var $29=$4;
      var $30=$height;
      var $31=$30*$29;
      $height=$31;
      var $32=$width;
      var $33=$height;
      var $34=$32/$33;
      var $35=$2;
      var $36=(($35)|0);
      var $37=$3;
      var $38=(($37)|0);
      var $39=$36/$38;
      var $40=$34 > $39;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$2;
      var $43=(($42)|0);
      var $44=$width;
      var $45=$43/$44;
      $scale=$45;
      __label__ = 8; break;
    case 7: // $46
      var $47=$3;
      var $48=(($47)|0);
      var $49=$height;
      var $50=$48/$49;
      $scale=$50;
      __label__ = 8; break;
    case 8: // $51
      __label__ = 10; break;
    case 9: // $52
      var $53=$2;
      var $54=(($53)|0);
      $width=$54;
      var $55=$3;
      var $56=(($55)|0);
      $height=$56;
      $scale=1;
      __label__ = 10; break;
    case 10: // $57
      var $58=$width;
      var $59=$scale;
      var $60=$58*$59;
      var $61=__ZL20render_round_nearestf($60);
      var $62=(($61)|0);
      var $63=$6;
      HEAP32[(($63)>>2)]=$62;
      var $64=$height;
      var $65=$scale;
      var $66=$64*$65;
      var $67=__ZL20render_round_nearestf($66);
      var $68=(($67)|0);
      var $69=$7;
      HEAP32[(($69)>>2)]=$68;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target20compute_visible_areaEiifiRiS0_["X"]=1;

function __ZNK11layout_view16effective_aspectE19render_layer_config($this, $config) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $config; $config = STACKTOP;STACKTOP += 1;STACKTOP = ((((STACKTOP)+3)>>2)<<2);assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");;;HEAP8[($config)]=HEAP8[(tempParam)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK19render_layer_config14zoom_to_screenEv($config);
      if ($3) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $4
      var $5=(($2+80)|0);
      var $6=__ZNK18render_screen_list5countEv($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $8
      var $9=(($2+76)|0);
      var $10=HEAPF32[(($9)>>2)];
      var $15 = $10;__label__ = 4; break;
    case 3: // $11
      var $12=(($2+72)|0);
      var $13=HEAPF32[(($12)>>2)];
      var $15 = $13;__label__ = 4; break;
    case 4: // $14
      var $15;
      STACKTOP = __stackBase__;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20render_round_nearestf($f) {
  ;
  var __label__;

  var $1;
  $1=$f;
  var $2=$1;
  var $3=$2+0.5;
  var $4=$3;
  var $5=_floor($4);
  var $6=$5;
  ;
  return $6;
}


function __ZNK11tagged_listI8device_tE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listI8device_tE5countEv($3);
  ;
  return $4;
}


function __ZN13render_target20compute_minimum_sizeERiS0_($this, $minwidth, $minheight) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $maxxscale;
      var $maxyscale;
      var $screens_considered;
      var $4;
      var $5;
      var $layer=__stackBase__;
      var $curitem;
      var $screen;
      var $visarea;
      var $bounds=__stackBase__+4;
      var $xscale;
      var $yscale;
      $1=$this;
      $2=$minwidth;
      $3=$minheight;
      var $6=$1;
      $maxxscale=1;
      $maxyscale=1;
      $screens_considered=0;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK14render_manager7machineEv($8);
      var $10=__ZNK15running_machine10devicelistEv($9);
      var $11=$10;
      var $12=__ZNK11tagged_listI8device_tE5countEv($11);
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$2;
      HEAP32[(($15)>>2)]=640;
      var $16=$3;
      HEAP32[(($16)>>2)]=480;
      __label__ = 25; break;
    case 2: // $17
      var $18=(($6+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $21
      var $22=___cxa_allocate_exception(1032);
      var $23=$22;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($23, ((STRING_TABLE.__str42709)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      ___cxa_throw($22, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $4=$27;
      var $28=$26.f1;
      $5=$28;
      ___cxa_free_exception($22);
      __label__ = 26; break;
    case 6: // $29
      HEAP32[(($layer)>>2)]=0;
      __label__ = 7; break;
    case 7: // $30
      var $31=HEAP32[(($layer)>>2)];
      var $32=(($31)|0) < 6;
      if ($32) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $33
      var $34=(($6+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=HEAP32[(($layer)>>2)];
      var $37=__ZNK11layout_view10first_itemE10item_layer($35, $36);
      $curitem=$37;
      __label__ = 9; break;
    case 9: // $38
      var $39=$curitem;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 10; break; } else { __label__ = 20; break; }
    case 10: // $41
      var $42=$curitem;
      var $43=__ZN11layout_view4item6screenEv($42);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $45
      var $46=$curitem;
      var $47=__ZN11layout_view4item6screenEv($46);
      $screen=$47;
      var $48=$screen;
      var $49=__ZNK13screen_device11screen_typeEv($48);
      var $50=(($49)|0)==2;
      if ($50) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $51
      var $56 = __ZZN13render_target20compute_minimum_sizeERiS0_E9vectorvis;__label__ = 14; break;
    case 13: // $52
      var $53=$screen;
      var $54=__ZNK13screen_device12visible_areaEv($53);
      var $56 = $54;__label__ = 14; break;
    case 14: // $55
      var $56;
      $visarea=$56;
      var $57=$curitem;
      var $58=__ZNK11layout_view4item6boundsEv($57);
      var $59=$bounds;
      var $60=$58;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];HEAP32[(($59+4)>>2)]=HEAP32[(($60+4)>>2)];HEAP32[(($59+8)>>2)]=HEAP32[(($60+8)>>2)];HEAP32[(($59+12)>>2)]=HEAP32[(($60+12)>>2)];
      var $61=(($6+308)|0);
      var $62=HEAP32[(($61)>>2)];
      __Z17apply_orientationR13render_boundsi($bounds, $62);
      __Z16normalize_boundsR13render_bounds($bounds);
      var $63=(($6+308)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$screen;
      var $66=__ZNK13screen_device9containerEv($65);
      var $67=__ZNK16render_container11orientationEv($66);
      var $68=__ZL15orientation_addii($64, $67);
      var $69=$68 & 4;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $71
      var $72=$visarea;
      var $73=(($72+4)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+1)|0);
      var $76=$visarea;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($75-$78)|0);
      var $80=(($79)|0);
      var $81=(($bounds+8)|0);
      var $82=HEAPF32[(($81)>>2)];
      var $83=(($bounds)|0);
      var $84=HEAPF32[(($83)>>2)];
      var $85=$82-$84;
      var $86=$80/$85;
      $xscale=$86;
      var $87=$visarea;
      var $88=(($87+12)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+1)|0);
      var $91=$visarea;
      var $92=(($91+8)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($90-$93)|0);
      var $95=(($94)|0);
      var $96=(($bounds+12)|0);
      var $97=HEAPF32[(($96)>>2)];
      var $98=(($bounds+4)|0);
      var $99=HEAPF32[(($98)>>2)];
      var $100=$97-$99;
      var $101=$95/$100;
      $yscale=$101;
      __label__ = 17; break;
    case 16: // $102
      var $103=$visarea;
      var $104=(($103+12)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+1)|0);
      var $107=$visarea;
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($106-$109)|0);
      var $111=(($110)|0);
      var $112=(($bounds+8)|0);
      var $113=HEAPF32[(($112)>>2)];
      var $114=(($bounds)|0);
      var $115=HEAPF32[(($114)>>2)];
      var $116=$113-$115;
      var $117=$111/$116;
      $xscale=$117;
      var $118=$visarea;
      var $119=(($118+4)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+1)|0);
      var $122=$visarea;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($121-$124)|0);
      var $126=(($125)|0);
      var $127=(($bounds+12)|0);
      var $128=HEAPF32[(($127)>>2)];
      var $129=(($bounds+4)|0);
      var $130=HEAPF32[(($129)>>2)];
      var $131=$128-$130;
      var $132=$126/$131;
      $yscale=$132;
      __label__ = 17; break;
    case 17: // $133
      var $134=$xscale;
      var $135=$maxxscale;
      var $136=$134 > $135;
      var $137=$xscale;
      var $138=$maxxscale;
      var $139=$136 ? $137 : $138;
      $maxxscale=$139;
      var $140=$yscale;
      var $141=$maxyscale;
      var $142=$140 > $141;
      var $143=$yscale;
      var $144=$maxyscale;
      var $145=$142 ? $143 : $144;
      $maxyscale=$145;
      var $146=$screens_considered;
      var $147=(($146+1)|0);
      $screens_considered=$147;
      __label__ = 18; break;
    case 18: // $148
      __label__ = 19; break;
    case 19: // $149
      var $150=$curitem;
      var $151=__ZNK11layout_view4item4nextEv($150);
      $curitem=$151;
      __label__ = 9; break;
    case 20: // $152
      __label__ = 21; break;
    case 21: // $153
      __ZppR10item_layeri($layer, 0);
      __label__ = 7; break;
    case 22: // $154
      var $155=$screens_considered;
      var $156=(($155)|0)==0;
      if ($156) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $157
      $maxxscale=640;
      $maxyscale=480;
      __label__ = 24; break;
    case 24: // $158
      var $159=$maxxscale;
      var $160=__ZL20render_round_nearestf($159);
      var $161=(($160)|0);
      var $162=$2;
      HEAP32[(($162)>>2)]=$161;
      var $163=$maxyscale;
      var $164=__ZL20render_round_nearestf($163);
      var $165=(($164)|0);
      var $166=$3;
      HEAP32[(($166)>>2)]=$165;
      __label__ = 25; break;
    case 25: // $167
      STACKTOP = __stackBase__;
      return;
    case 26: // $168
      var $169=$4;
      var $170=$4;
      var $171=$5;
      var $172=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $170, tempValue);
      var $173=($172.f1 = $171, $172);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target20compute_minimum_sizeERiS0_["X"]=1;

function __ZppR10item_layeri($value, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$value;
  $3=$0;
  var $4=$2;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=$2;
  HEAP32[(($7)>>2)]=$6;
  ;
  return;
}


function __Z17apply_orientationR13render_boundsi($bounds, $orientation) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $temp;
      var $temp1;
      $1=$bounds;
      $2=$orientation;
      var $3=$2;
      var $4=$3 & 4;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=$1;
      var $9=(($8)|0);
      var $10=HEAPF32[(($9)>>2)];
      $temp=$10;
      var $11=$1;
      var $12=(($11+4)|0);
      var $13=HEAPF32[(($12)>>2)];
      var $14=$1;
      var $15=(($14)|0);
      HEAPF32[(($15)>>2)]=$13;
      var $16=$temp;
      var $17=$1;
      var $18=(($17+4)|0);
      HEAPF32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAPF32[(($22)>>2)];
      $temp1=$23;
      var $24=$1;
      var $25=(($24+12)|0);
      var $26=HEAPF32[(($25)>>2)];
      var $27=$1;
      var $28=(($27+8)|0);
      HEAPF32[(($28)>>2)]=$26;
      var $29=$temp1;
      var $30=$1;
      var $31=(($30+12)|0);
      HEAPF32[(($31)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $32
      __label__ = 6; break;
    case 6: // $33
      var $34=$2;
      var $35=$34 & 1;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $37
      var $38=$1;
      var $39=(($38)|0);
      var $40=HEAPF32[(($39)>>2)];
      var $41=1-$40;
      var $42=$1;
      var $43=(($42)|0);
      HEAPF32[(($43)>>2)]=$41;
      var $44=$1;
      var $45=(($44+8)|0);
      var $46=HEAPF32[(($45)>>2)];
      var $47=1-$46;
      var $48=$1;
      var $49=(($48+8)|0);
      HEAPF32[(($49)>>2)]=$47;
      __label__ = 8; break;
    case 8: // $50
      var $51=$2;
      var $52=$51 & 2;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $54
      var $55=$1;
      var $56=(($55+4)|0);
      var $57=HEAPF32[(($56)>>2)];
      var $58=1-$57;
      var $59=$1;
      var $60=(($59+4)|0);
      HEAPF32[(($60)>>2)]=$58;
      var $61=$1;
      var $62=(($61+12)|0);
      var $63=HEAPF32[(($62)>>2)];
      var $64=1-$63;
      var $65=$1;
      var $66=(($65+12)|0);
      HEAPF32[(($66)>>2)]=$64;
      __label__ = 10; break;
    case 10: // $67
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17apply_orientationR13render_boundsi["X"]=1;

function __Z16normalize_boundsR13render_bounds($bounds) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $temp;
      var $temp1;
      $1=$bounds;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAPF32[(($3)>>2)];
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=HEAPF32[(($6)>>2)];
      var $8=$4 > $7;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAPF32[(($12)>>2)];
      $temp=$13;
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=HEAPF32[(($15)>>2)];
      var $17=$1;
      var $18=(($17)|0);
      HEAPF32[(($18)>>2)]=$16;
      var $19=$temp;
      var $20=$1;
      var $21=(($20+8)|0);
      HEAPF32[(($21)>>2)]=$19;
      __label__ = 3; break;
    case 3: // $22
      __label__ = 4; break;
    case 4: // $23
      var $24=$1;
      var $25=(($24+4)|0);
      var $26=HEAPF32[(($25)>>2)];
      var $27=$1;
      var $28=(($27+12)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$26 > $29;
      if ($30) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $31
      __label__ = 6; break;
    case 6: // $32
      var $33=$1;
      var $34=(($33+4)|0);
      var $35=HEAPF32[(($34)>>2)];
      $temp1=$35;
      var $36=$1;
      var $37=(($36+12)|0);
      var $38=HEAPF32[(($37)>>2)];
      var $39=$1;
      var $40=(($39+4)|0);
      HEAPF32[(($40)>>2)]=$38;
      var $41=$temp1;
      var $42=$1;
      var $43=(($42+12)|0);
      HEAPF32[(($43)>>2)]=$41;
      __label__ = 7; break;
    case 7: // $44
      __label__ = 8; break;
    case 8: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16normalize_boundsR13render_bounds["X"]=1;

function __ZNK13screen_device9containerEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+408)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16render_container11orientationEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  ;
  return $5;
}


function __ZNK11layout_view4item4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11layout_view13layer_enabledE10item_layer($this, $layer) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$layer;
  var $3=$1;
  var $4=$2;
  var $5=(($3+148)|0);
  var $6=(($5+$4)|0);
  var $7=HEAP8[($6)];
  var $8=(($7) & 1);
  ;
  return $8;
}


function __ZNK11layout_view4item5colorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+184)|0);
  ;
  return $3;
}


function __ZNK11layout_view4item11orientationEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+148)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13render_target14get_primitivesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $list;
      var $viswidth=__stackBase__;
      var $visheight=__stackBase__+4;
      var $root_xform=__stackBase__+8;
      var $layernum=__stackBase__+48;
      var $blendmode=__stackBase__+52;
      var $layer;
      var $curitem;
      var $bounds=__stackBase__+56;
      var $item_xform=__stackBase__+72;
      var $prim;
      var $debug;
      var $ui_xform=__stackBase__+112;
      var $ui_xform1=__stackBase__+152;
      $1=$this;
      var $2=$1;
      var $3=(($2+316)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($2+316)|0);
      HEAP32[(($9)>>2)]=$8;
      __label__ = 2; break;
    case 2: // $10
      var $11=(($2+272)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($2+20)|0);
      var $14=(($13+$12*84)|0);
      $list=$14;
      var $15=(($2+272)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+1)|0);
      var $18=(($17)>>>0)%3;
      var $19=(($2+272)|0);
      HEAP32[(($19)>>2)]=$18;
      var $20=$list;
      __ZN21render_primitive_list12acquire_lockEv($20);
      var $21=$list;
      __ZN21render_primitive_list11release_allEv($21);
      var $22=(($2+276)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($2+280)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($2+300)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=(($2+308)|0);
      var $29=HEAP32[(($28)>>2)];
      __ZN13render_target20compute_visible_areaEiifiRiS0_($2, $23, $25, $27, $29, $viswidth, $visheight);
      var $30=(($2+276)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=HEAP32[(($viswidth)>>2)];
      var $33=(($31-$32)|0);
      var $34=(($33)|0);
      var $35=$34/2;
      var $36=(($root_xform)|0);
      HEAPF32[(($36)>>2)]=$35;
      var $37=(($2+280)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=HEAP32[(($visheight)>>2)];
      var $40=(($38-$39)|0);
      var $41=(($40)|0);
      var $42=$41/2;
      var $43=(($root_xform+4)|0);
      HEAPF32[(($43)>>2)]=$42;
      var $44=HEAP32[(($viswidth)>>2)];
      var $45=(($44)|0);
      var $46=(($root_xform+8)|0);
      HEAPF32[(($46)>>2)]=$45;
      var $47=HEAP32[(($visheight)>>2)];
      var $48=(($47)|0);
      var $49=(($root_xform+12)|0);
      HEAPF32[(($49)>>2)]=$48;
      var $50=(($root_xform+16)|0);
      var $51=(($50)|0);
      HEAPF32[(($51)>>2)]=1;
      var $52=(($root_xform+16)|0);
      var $53=(($52+12)|0);
      HEAPF32[(($53)>>2)]=1;
      var $54=(($root_xform+16)|0);
      var $55=(($54+8)|0);
      HEAPF32[(($55)>>2)]=1;
      var $56=(($root_xform+16)|0);
      var $57=(($56+4)|0);
      HEAPF32[(($57)>>2)]=1;
      var $58=(($2+308)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($root_xform+32)|0);
      HEAP32[(($60)>>2)]=$59;
      var $61=(($root_xform+36)|0);
      HEAP8[($61)]=0;
      var $62=(($2+4)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=__ZNK14render_manager7machineEv($63);
      var $65=__ZNK15running_machine5phaseEv($64);
      var $66=(($65)|0) >= 2;
      if ($66) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $67
      HEAP32[(($layernum)>>2)]=0;
      __label__ = 4; break;
    case 4: // $68
      var $69=HEAP32[(($layernum)>>2)];
      var $70=(($69)|0) < 6;
      if ($70) { __label__ = 5; break; } else { __label__ = 16; break; }
    case 5: // $71
      var $72=(($2+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=HEAP32[(($layernum)>>2)];
      var $75=__Z23get_layer_and_blendmodeRK11layout_viewiRi($73, $74, $blendmode);
      $layer=$75;
      var $76=(($2+8)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$layer;
      var $79=__ZNK11layout_view13layer_enabledE10item_layer($77, $78);
      if ($79) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $80
      var $81=(($2+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$layer;
      var $84=__ZNK11layout_view10first_itemE10item_layer($82, $83);
      $curitem=$84;
      __label__ = 7; break;
    case 7: // $85
      var $86=$curitem;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $88
      var $89=$curitem;
      var $90=__ZNK11layout_view4item6boundsEv($89);
      var $91=$bounds;
      var $92=$90;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($91)>>2)]=HEAP32[(($92)>>2)];HEAP32[(($91+4)>>2)]=HEAP32[(($92+4)>>2)];HEAP32[(($91+8)>>2)]=HEAP32[(($92+8)>>2)];HEAP32[(($91+12)>>2)]=HEAP32[(($92+12)>>2)];
      var $93=(($root_xform+32)|0);
      var $94=HEAP32[(($93)>>2)];
      __Z17apply_orientationR13render_boundsi($bounds, $94);
      __Z16normalize_boundsR13render_bounds($bounds);
      var $95=(($root_xform)|0);
      var $96=HEAPF32[(($95)>>2)];
      var $97=(($bounds)|0);
      var $98=HEAPF32[(($97)>>2)];
      var $99=(($root_xform+8)|0);
      var $100=HEAPF32[(($99)>>2)];
      var $101=$98*$100;
      var $102=$96+$101;
      var $103=(($item_xform)|0);
      HEAPF32[(($103)>>2)]=$102;
      var $104=(($root_xform+4)|0);
      var $105=HEAPF32[(($104)>>2)];
      var $106=(($bounds+4)|0);
      var $107=HEAPF32[(($106)>>2)];
      var $108=(($root_xform+12)|0);
      var $109=HEAPF32[(($108)>>2)];
      var $110=$107*$109;
      var $111=$105+$110;
      var $112=(($item_xform+4)|0);
      HEAPF32[(($112)>>2)]=$111;
      var $113=(($bounds+8)|0);
      var $114=HEAPF32[(($113)>>2)];
      var $115=(($bounds)|0);
      var $116=HEAPF32[(($115)>>2)];
      var $117=$114-$116;
      var $118=(($root_xform+8)|0);
      var $119=HEAPF32[(($118)>>2)];
      var $120=$117*$119;
      var $121=(($item_xform+8)|0);
      HEAPF32[(($121)>>2)]=$120;
      var $122=(($bounds+12)|0);
      var $123=HEAPF32[(($122)>>2)];
      var $124=(($bounds+4)|0);
      var $125=HEAPF32[(($124)>>2)];
      var $126=$123-$125;
      var $127=(($root_xform+12)|0);
      var $128=HEAPF32[(($127)>>2)];
      var $129=$126*$128;
      var $130=(($item_xform+12)|0);
      HEAPF32[(($130)>>2)]=$129;
      var $131=$curitem;
      var $132=__ZNK11layout_view4item5colorEv($131);
      var $133=(($132+4)|0);
      var $134=HEAPF32[(($133)>>2)];
      var $135=(($root_xform+16)|0);
      var $136=(($135+4)|0);
      var $137=HEAPF32[(($136)>>2)];
      var $138=$134*$137;
      var $139=(($item_xform+16)|0);
      var $140=(($139+4)|0);
      HEAPF32[(($140)>>2)]=$138;
      var $141=$curitem;
      var $142=__ZNK11layout_view4item5colorEv($141);
      var $143=(($142+8)|0);
      var $144=HEAPF32[(($143)>>2)];
      var $145=(($root_xform+16)|0);
      var $146=(($145+8)|0);
      var $147=HEAPF32[(($146)>>2)];
      var $148=$144*$147;
      var $149=(($item_xform+16)|0);
      var $150=(($149+8)|0);
      HEAPF32[(($150)>>2)]=$148;
      var $151=$curitem;
      var $152=__ZNK11layout_view4item5colorEv($151);
      var $153=(($152+12)|0);
      var $154=HEAPF32[(($153)>>2)];
      var $155=(($root_xform+16)|0);
      var $156=(($155+12)|0);
      var $157=HEAPF32[(($156)>>2)];
      var $158=$154*$157;
      var $159=(($item_xform+16)|0);
      var $160=(($159+12)|0);
      HEAPF32[(($160)>>2)]=$158;
      var $161=$curitem;
      var $162=__ZNK11layout_view4item5colorEv($161);
      var $163=(($162)|0);
      var $164=HEAPF32[(($163)>>2)];
      var $165=(($root_xform+16)|0);
      var $166=(($165)|0);
      var $167=HEAPF32[(($166)>>2)];
      var $168=$164*$167;
      var $169=(($item_xform+16)|0);
      var $170=(($169)|0);
      HEAPF32[(($170)>>2)]=$168;
      var $171=$curitem;
      var $172=__ZNK11layout_view4item11orientationEv($171);
      var $173=(($root_xform+32)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=__ZL15orientation_addii($172, $174);
      var $176=(($item_xform+32)|0);
      HEAP32[(($176)>>2)]=$175;
      var $177=(($item_xform+36)|0);
      HEAP8[($177)]=0;
      var $178=$curitem;
      var $179=__ZN11layout_view4item6screenEv($178);
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $181
      var $182=$list;
      var $183=$curitem;
      var $184=__ZN11layout_view4item6screenEv($183);
      var $185=__ZNK13screen_device9containerEv($184);
      var $186=HEAP32[(($blendmode)>>2)];
      __ZN13render_target24add_container_primitivesER21render_primitive_listRK16object_transformR16render_containeri($2, $182, $item_xform, $185, $186);
      __label__ = 11; break;
    case 10: // $187
      var $188=$list;
      var $189=$curitem;
      var $190=__ZNK11layout_view4item7elementEv($189);
      var $191=$curitem;
      var $192=__ZNK11layout_view4item5stateEv($191);
      var $193=HEAP32[(($blendmode)>>2)];
      __ZN13render_target22add_element_primitivesER21render_primitive_listRK16object_transformR14layout_elementii($2, $188, $item_xform, $190, $192, $193);
      __label__ = 11; break;
    case 11: // $194
      __label__ = 12; break;
    case 12: // $195
      var $196=$curitem;
      var $197=__ZNK11layout_view4item4nextEv($196);
      $curitem=$197;
      __label__ = 7; break;
    case 13: // $198
      __label__ = 14; break;
    case 14: // $199
      __label__ = 15; break;
    case 15: // $200
      __ZppR10item_layeri($layernum, 0);
      __label__ = 4; break;
    case 16: // $201
      __label__ = 21; break;
    case 17: // $202
      var $203=$list;
      var $204=__ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($203, 2);
      $prim=$204;
      var $205=$prim;
      var $206=(($205+4)|0);
      var $207=(($2+276)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208)|0);
      var $210=(($2+280)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=(($211)|0);
      __ZL20set_render_bounds_xyP13render_boundsffff($206, 0, 0, $209, $212);
      var $213=$prim;
      var $214=(($213+20)|0);
      __ZL16set_render_colorP12render_colorffff($214, 1, 1, 1, 1);
      var $215=$prim;
      var $216=(($215+44)|0);
      var $217=(($216)|0);
      HEAP32[(($217)>>2)]=0;
      var $218=$prim;
      var $219=(($218+36)|0);
      HEAP32[(($219)>>2)]=256;
      var $220=$list;
      var $221=$prim;
      __ZN21render_primitive_list6appendER16render_primitive($220, $221);
      var $222=(($2+276)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(($223)|0) > 1;
      if ($224) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $225
      var $226=(($2+280)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($227)|0) > 1;
      if ($228) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $229
      var $230=$list;
      var $231=__ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($230, 2);
      $prim=$231;
      var $232=$prim;
      var $233=(($232+4)|0);
      var $234=(($2+276)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($235-1)|0);
      var $237=(($236)|0);
      var $238=(($2+280)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(($239-1)|0);
      var $241=(($240)|0);
      __ZL20set_render_bounds_xyP13render_boundsffff($233, 1, 1, $237, $241);
      var $242=$prim;
      var $243=(($242+20)|0);
      __ZL16set_render_colorP12render_colorffff($243, 1, 0, 0, 0);
      var $244=$prim;
      var $245=(($244+44)|0);
      var $246=(($245)|0);
      HEAP32[(($246)>>2)]=0;
      var $247=$prim;
      var $248=(($247+36)|0);
      HEAP32[(($248)>>2)]=256;
      var $249=$list;
      var $250=$prim;
      __ZN21render_primitive_list6appendER16render_primitive($249, $250);
      __label__ = 20; break;
    case 20: // $251
      __label__ = 21; break;
    case 21: // $252
      var $253=(($2+336)|0);
      var $254=__ZNK11simple_listI16render_containerE5firstEv($253);
      $debug=$254;
      __label__ = 22; break;
    case 22: // $255
      var $256=$debug;
      var $257=(($256)|0)!=0;
      if ($257) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $258
      var $259=(($ui_xform)|0);
      HEAPF32[(($259)>>2)]=0;
      var $260=(($ui_xform+4)|0);
      HEAPF32[(($260)>>2)]=0;
      var $261=(($2+276)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(($262)|0);
      var $264=(($ui_xform+8)|0);
      HEAPF32[(($264)>>2)]=$263;
      var $265=(($2+280)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266)|0);
      var $268=(($ui_xform+12)|0);
      HEAPF32[(($268)>>2)]=$267;
      var $269=(($ui_xform+16)|0);
      var $270=(($269)|0);
      HEAPF32[(($270)>>2)]=1;
      var $271=(($ui_xform+16)|0);
      var $272=(($271+12)|0);
      HEAPF32[(($272)>>2)]=1;
      var $273=(($ui_xform+16)|0);
      var $274=(($273+8)|0);
      HEAPF32[(($274)>>2)]=1;
      var $275=(($ui_xform+16)|0);
      var $276=(($275+4)|0);
      HEAPF32[(($276)>>2)]=1;
      var $277=(($ui_xform+16)|0);
      var $278=(($277)|0);
      HEAPF32[(($278)>>2)]=0.8999999761581421;
      var $279=(($2+308)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=(($ui_xform+32)|0);
      HEAP32[(($281)>>2)]=$280;
      var $282=(($ui_xform+36)|0);
      HEAP8[($282)]=1;
      var $283=$list;
      var $284=$debug;
      __ZN13render_target24add_container_primitivesER21render_primitive_listRK16object_transformR16render_containeri($2, $283, $ui_xform, $284, 1);
      __label__ = 24; break;
    case 24: // $285
      var $286=$debug;
      var $287=__ZNK16render_container4nextEv($286);
      $debug=$287;
      __label__ = 22; break;
    case 25: // $288
      var $289=__ZNK13render_target12is_ui_targetEv($2);
      if ($289) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $290
      var $291=(($ui_xform1)|0);
      HEAPF32[(($291)>>2)]=0;
      var $292=(($ui_xform1+4)|0);
      HEAPF32[(($292)>>2)]=0;
      var $293=(($2+276)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294)|0);
      var $296=(($ui_xform1+8)|0);
      HEAPF32[(($296)>>2)]=$295;
      var $297=(($2+280)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(($298)|0);
      var $300=(($ui_xform1+12)|0);
      HEAPF32[(($300)>>2)]=$299;
      var $301=(($ui_xform1+16)|0);
      var $302=(($301)|0);
      HEAPF32[(($302)>>2)]=1;
      var $303=(($ui_xform1+16)|0);
      var $304=(($303+12)|0);
      HEAPF32[(($304)>>2)]=1;
      var $305=(($ui_xform1+16)|0);
      var $306=(($305+8)|0);
      HEAPF32[(($306)>>2)]=1;
      var $307=(($ui_xform1+16)|0);
      var $308=(($307+4)|0);
      HEAPF32[(($308)>>2)]=1;
      var $309=(($2+308)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=(($ui_xform1+32)|0);
      HEAP32[(($311)>>2)]=$310;
      var $312=(($ui_xform1+36)|0);
      HEAP8[($312)]=0;
      var $313=$list;
      var $314=(($2+4)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=__ZNK14render_manager12ui_containerEv($315);
      __ZN13render_target24add_container_primitivesER21render_primitive_listRK16object_transformR16render_containeri($2, $313, $ui_xform1, $316, 1);
      __label__ = 27; break;
    case 27: // $317
      var $318=$list;
      __ZN13render_target37add_clear_and_optimize_primitive_listER21render_primitive_list($2, $318);
      var $319=$list;
      __ZN21render_primitive_list12release_lockEv($319);
      var $320=$list;
      STACKTOP = __stackBase__;
      return $320;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target14get_primitivesEv["X"]=1;

function __Z23get_layer_and_blendmodeRK11layout_viewiRi($view, $index, $blendmode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $layer_order;
      var $layer;
      $1=$view;
      $2=$index;
      $3=$blendmode;
      $layer_order=((__ZL20layer_order_standard)|0);
      var $4=$1;
      var $5=__ZNK11layout_view10first_itemE10item_layer($4, 0);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK11layout_view10first_itemE10item_layer($8, 0);
      var $10=__ZNK11layout_view4item4nextEv($9);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$1;
      var $14=__ZNK11layout_view10first_itemE10item_layer($13, 2);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $layer_order=((__ZL21layer_order_alternate)|0);
      __label__ = 4; break;
    case 4: // $17
      var $18=$2;
      var $19=$layer_order;
      var $20=(($19+($18<<2))|0);
      var $21=HEAP32[(($20)>>2)];
      $layer=$21;
      var $22=$layer;
      var $23=(($22)|0)==1;
      if ($23) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $24
      var $25=$layer_order;
      var $26=(($25)|0)==(((((__ZL20layer_order_standard)|0)))|0);
      if ($26) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $27
      var $28=$3;
      HEAP32[(($28)>>2)]=-1;
      __label__ = 16; break;
    case 7: // $29
      var $30=$layer;
      var $31=(($30)|0)==1;
      if ($31) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $32
      var $33=$layer;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $35
      var $36=$layer_order;
      var $37=(($36)|0)==(((((__ZL20layer_order_standard)|0)))|0);
      if ($37) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      var $39=$3;
      HEAP32[(($39)>>2)]=3;
      __label__ = 15; break;
    case 11: // $40
      var $41=$layer;
      var $42=(($41)|0)==2;
      if ($42) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $43
      var $44=$3;
      HEAP32[(($44)>>2)]=2;
      __label__ = 14; break;
    case 13: // $45
      var $46=$3;
      HEAP32[(($46)>>2)]=1;
      __label__ = 14; break;
    case 14: // $47
      __label__ = 15; break;
    case 15: // $48
      __label__ = 16; break;
    case 16: // $49
      var $50=$layer;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z23get_layer_and_blendmodeRK11layout_viewiRi["X"]=1;

function __ZN13render_target24add_container_primitivesER21render_primitive_listRK16object_transformR16render_containeri($this, $list, $xform, $container, $blendmode) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $cliprect=__stackBase__;
      var $container_xform=__stackBase__+16;
      var $xscale;
      var $yscale;
      var $xoffs;
      var $yoffs;
      var $curitem;
      var $bounds=__stackBase__+56;
      var $prim;
      var $clipped;
      var $finalorient;
      var $width;
      var $height;
      var $width1;
      var $height2;
      var $prim3;
      var $got_scaled;
      $1=$this;
      $2=$list;
      $3=$xform;
      $4=$container;
      $5=$blendmode;
      var $6=$1;
      var $7=$4;
      __ZN16render_container14update_paletteEv($7);
      var $8=$3;
      var $9=(($8)|0);
      var $10=HEAPF32[(($9)>>2)];
      var $11=(($cliprect)|0);
      HEAPF32[(($11)>>2)]=$10;
      var $12=$3;
      var $13=(($12+4)|0);
      var $14=HEAPF32[(($13)>>2)];
      var $15=(($cliprect+4)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAPF32[(($17)>>2)];
      var $19=$3;
      var $20=(($19+8)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$18+$21;
      var $23=(($cliprect+8)|0);
      HEAPF32[(($23)>>2)]=$22;
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAPF32[(($25)>>2)];
      var $27=$3;
      var $28=(($27+12)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$26+$29;
      var $31=(($cliprect+12)|0);
      HEAPF32[(($31)>>2)]=$30;
      var $32=(($6+284)|0);
      __ZL18sect_render_boundsP13render_boundsPKS_($cliprect, $32);
      var $33=$4;
      var $34=__ZNK16render_container11orientationEv($33);
      var $35=$3;
      var $36=(($35+32)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=__ZL15orientation_addii($34, $37);
      var $39=(($container_xform+32)|0);
      HEAP32[(($39)>>2)]=$38;
      var $40=(($container_xform+32)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$41 & 4;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $44
      var $45=$4;
      var $46=__ZNK16render_container6yscaleEv($45);
      var $51 = $46;__label__ = 3; break;
    case 2: // $47
      var $48=$4;
      var $49=__ZNK16render_container6xscaleEv($48);
      var $51 = $49;__label__ = 3; break;
    case 3: // $50
      var $51;
      $xscale=$51;
      var $52=(($container_xform+32)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$53 & 4;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $56
      var $57=$4;
      var $58=__ZNK16render_container6xscaleEv($57);
      var $63 = $58;__label__ = 6; break;
    case 5: // $59
      var $60=$4;
      var $61=__ZNK16render_container6yscaleEv($60);
      var $63 = $61;__label__ = 6; break;
    case 6: // $62
      var $63;
      $yscale=$63;
      var $64=(($container_xform+32)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65 & 4;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $68
      var $69=$4;
      var $70=__ZNK16render_container7yoffsetEv($69);
      var $75 = $70;__label__ = 9; break;
    case 8: // $71
      var $72=$4;
      var $73=__ZNK16render_container7xoffsetEv($72);
      var $75 = $73;__label__ = 9; break;
    case 9: // $74
      var $75;
      $xoffs=$75;
      var $76=(($container_xform+32)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$77 & 4;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $80
      var $81=$4;
      var $82=__ZNK16render_container7xoffsetEv($81);
      var $87 = $82;__label__ = 12; break;
    case 11: // $83
      var $84=$4;
      var $85=__ZNK16render_container7yoffsetEv($84);
      var $87 = $85;__label__ = 12; break;
    case 12: // $86
      var $87;
      $yoffs=$87;
      var $88=(($container_xform+32)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89 & 1;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $92
      var $93=$xoffs;
      var $94=(-$93);
      $xoffs=$94;
      __label__ = 14; break;
    case 14: // $95
      var $96=(($container_xform+32)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$97 & 2;
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $100
      var $101=$yoffs;
      var $102=(-$101);
      $yoffs=$102;
      __label__ = 16; break;
    case 16: // $103
      var $104=$3;
      var $105=(($104+8)|0);
      var $106=HEAPF32[(($105)>>2)];
      var $107=$xscale;
      var $108=$106*$107;
      var $109=(($container_xform+8)|0);
      HEAPF32[(($109)>>2)]=$108;
      var $110=$3;
      var $111=(($110+12)|0);
      var $112=HEAPF32[(($111)>>2)];
      var $113=$yscale;
      var $114=$112*$113;
      var $115=(($container_xform+12)|0);
      HEAPF32[(($115)>>2)]=$114;
      var $116=$3;
      var $117=(($116+36)|0);
      var $118=HEAP8[($117)];
      var $119=(($118) & 1);
      if ($119) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $120
      var $121=$3;
      var $122=(($121+8)|0);
      var $123=HEAPF32[(($122)>>2)];
      var $124=$xoffs;
      var $125=$123*$124;
      var $126=$3;
      var $127=(($126)|0);
      var $128=HEAPF32[(($127)>>2)];
      var $129=$125+$128;
      var $130=(($container_xform)|0);
      HEAPF32[(($130)>>2)]=$129;
      var $131=$3;
      var $132=(($131+12)|0);
      var $133=HEAPF32[(($132)>>2)];
      var $134=$yoffs;
      var $135=$133*$134;
      var $136=$3;
      var $137=(($136+4)|0);
      var $138=HEAPF32[(($137)>>2)];
      var $139=$135+$138;
      var $140=(($container_xform+4)|0);
      HEAPF32[(($140)>>2)]=$139;
      __label__ = 19; break;
    case 18: // $141
      var $142=$3;
      var $143=(($142+8)|0);
      var $144=HEAPF32[(($143)>>2)];
      var $145=$xscale;
      var $146=$145*0.5;
      var $147=0.5-$146;
      var $148=$xoffs;
      var $149=$147+$148;
      var $150=$144*$149;
      var $151=$3;
      var $152=(($151)|0);
      var $153=HEAPF32[(($152)>>2)];
      var $154=$150+$153;
      var $155=(($container_xform)|0);
      HEAPF32[(($155)>>2)]=$154;
      var $156=$3;
      var $157=(($156+12)|0);
      var $158=HEAPF32[(($157)>>2)];
      var $159=$yscale;
      var $160=$159*0.5;
      var $161=0.5-$160;
      var $162=$yoffs;
      var $163=$161+$162;
      var $164=$158*$163;
      var $165=$3;
      var $166=(($165+4)|0);
      var $167=HEAPF32[(($166)>>2)];
      var $168=$164+$167;
      var $169=(($container_xform+4)|0);
      HEAPF32[(($169)>>2)]=$168;
      __label__ = 19; break;
    case 19: // $170
      var $171=(($container_xform+16)|0);
      var $172=$3;
      var $173=(($172+16)|0);
      var $174=$171;
      var $175=$173;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($174)>>2)]=HEAP32[(($175)>>2)];HEAP32[(($174+4)>>2)]=HEAP32[(($175+4)>>2)];HEAP32[(($174+8)>>2)]=HEAP32[(($175+8)>>2)];HEAP32[(($174+12)>>2)]=HEAP32[(($175+12)>>2)];
      var $176=$4;
      var $177=__ZNK16render_container10first_itemEv($176);
      $curitem=$177;
      __label__ = 20; break;
    case 20: // $178
      var $179=$curitem;
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 21; break; } else { __label__ = 52; break; }
    case 21: // $181
      var $182=$curitem;
      var $183=__ZNK16render_container4item6boundsEv($182);
      var $184=$bounds;
      var $185=$183;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($184)>>2)]=HEAP32[(($185)>>2)];HEAP32[(($184+4)>>2)]=HEAP32[(($185+4)>>2)];HEAP32[(($184+8)>>2)]=HEAP32[(($185+8)>>2)];HEAP32[(($184+12)>>2)]=HEAP32[(($185+12)>>2)];
      var $186=(($container_xform+32)|0);
      var $187=HEAP32[(($186)>>2)];
      __Z17apply_orientationR13render_boundsi($bounds, $187);
      var $188=$2;
      var $189=__ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($188, 0);
      $prim=$189;
      var $190=(($container_xform)|0);
      var $191=HEAPF32[(($190)>>2)];
      var $192=(($bounds)|0);
      var $193=HEAPF32[(($192)>>2)];
      var $194=(($container_xform+8)|0);
      var $195=HEAPF32[(($194)>>2)];
      var $196=$193*$195;
      var $197=$191+$196;
      var $198=__ZL20render_round_nearestf($197);
      var $199=$prim;
      var $200=(($199+4)|0);
      var $201=(($200)|0);
      HEAPF32[(($201)>>2)]=$198;
      var $202=(($container_xform+4)|0);
      var $203=HEAPF32[(($202)>>2)];
      var $204=(($bounds+4)|0);
      var $205=HEAPF32[(($204)>>2)];
      var $206=(($container_xform+12)|0);
      var $207=HEAPF32[(($206)>>2)];
      var $208=$205*$207;
      var $209=$203+$208;
      var $210=__ZL20render_round_nearestf($209);
      var $211=$prim;
      var $212=(($211+4)|0);
      var $213=(($212+4)|0);
      HEAPF32[(($213)>>2)]=$210;
      var $214=$curitem;
      var $215=__ZNK16render_container4item8internalEv($214);
      var $216=$215 & 1;
      var $217=(($216)|0)!=0;
      if ($217) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $218
      var $219=$prim;
      var $220=(($219+4)|0);
      var $221=(($220)|0);
      var $222=HEAPF32[(($221)>>2)];
      var $223=(($bounds+8)|0);
      var $224=HEAPF32[(($223)>>2)];
      var $225=(($bounds)|0);
      var $226=HEAPF32[(($225)>>2)];
      var $227=$224-$226;
      var $228=(($container_xform+8)|0);
      var $229=HEAPF32[(($228)>>2)];
      var $230=$227*$229;
      var $231=__ZL20render_round_nearestf($230);
      var $232=$222+$231;
      var $233=$prim;
      var $234=(($233+4)|0);
      var $235=(($234+8)|0);
      HEAPF32[(($235)>>2)]=$232;
      var $236=$prim;
      var $237=(($236+4)|0);
      var $238=(($237+4)|0);
      var $239=HEAPF32[(($238)>>2)];
      var $240=(($bounds+12)|0);
      var $241=HEAPF32[(($240)>>2)];
      var $242=(($bounds+4)|0);
      var $243=HEAPF32[(($242)>>2)];
      var $244=$241-$243;
      var $245=(($container_xform+12)|0);
      var $246=HEAPF32[(($245)>>2)];
      var $247=$244*$246;
      var $248=__ZL20render_round_nearestf($247);
      var $249=$239+$248;
      var $250=$prim;
      var $251=(($250+4)|0);
      var $252=(($251+12)|0);
      HEAPF32[(($252)>>2)]=$249;
      __label__ = 24; break;
    case 23: // $253
      var $254=(($container_xform)|0);
      var $255=HEAPF32[(($254)>>2)];
      var $256=(($bounds+8)|0);
      var $257=HEAPF32[(($256)>>2)];
      var $258=(($container_xform+8)|0);
      var $259=HEAPF32[(($258)>>2)];
      var $260=$257*$259;
      var $261=$255+$260;
      var $262=__ZL20render_round_nearestf($261);
      var $263=$prim;
      var $264=(($263+4)|0);
      var $265=(($264+8)|0);
      HEAPF32[(($265)>>2)]=$262;
      var $266=(($container_xform+4)|0);
      var $267=HEAPF32[(($266)>>2)];
      var $268=(($bounds+12)|0);
      var $269=HEAPF32[(($268)>>2)];
      var $270=(($container_xform+12)|0);
      var $271=HEAPF32[(($270)>>2)];
      var $272=$269*$271;
      var $273=$267+$272;
      var $274=__ZL20render_round_nearestf($273);
      var $275=$prim;
      var $276=(($275+4)|0);
      var $277=(($276+12)|0);
      HEAPF32[(($277)>>2)]=$274;
      __label__ = 24; break;
    case 24: // $278
      var $279=(($container_xform+16)|0);
      var $280=(($279+4)|0);
      var $281=HEAPF32[(($280)>>2)];
      var $282=$curitem;
      var $283=__ZNK16render_container4item5colorEv($282);
      var $284=(($283+4)|0);
      var $285=HEAPF32[(($284)>>2)];
      var $286=$281*$285;
      var $287=$prim;
      var $288=(($287+20)|0);
      var $289=(($288+4)|0);
      HEAPF32[(($289)>>2)]=$286;
      var $290=(($container_xform+16)|0);
      var $291=(($290+8)|0);
      var $292=HEAPF32[(($291)>>2)];
      var $293=$curitem;
      var $294=__ZNK16render_container4item5colorEv($293);
      var $295=(($294+8)|0);
      var $296=HEAPF32[(($295)>>2)];
      var $297=$292*$296;
      var $298=$prim;
      var $299=(($298+20)|0);
      var $300=(($299+8)|0);
      HEAPF32[(($300)>>2)]=$297;
      var $301=(($container_xform+16)|0);
      var $302=(($301+12)|0);
      var $303=HEAPF32[(($302)>>2)];
      var $304=$curitem;
      var $305=__ZNK16render_container4item5colorEv($304);
      var $306=(($305+12)|0);
      var $307=HEAPF32[(($306)>>2)];
      var $308=$303*$307;
      var $309=$prim;
      var $310=(($309+20)|0);
      var $311=(($310+12)|0);
      HEAPF32[(($311)>>2)]=$308;
      var $312=(($container_xform+16)|0);
      var $313=(($312)|0);
      var $314=HEAPF32[(($313)>>2)];
      var $315=$curitem;
      var $316=__ZNK16render_container4item5colorEv($315);
      var $317=(($316)|0);
      var $318=HEAPF32[(($317)>>2)];
      var $319=$314*$318;
      var $320=$prim;
      var $321=(($320+20)|0);
      var $322=(($321)|0);
      HEAPF32[(($322)>>2)]=$319;
      $clipped=1;
      var $323=$curitem;
      var $324=__ZNK16render_container4item4typeEv($323);
      var $325=(($324)&255);
      if ($325 == 0) {
        __label__ = 25; break;
      }
      else if ($325 == 1) {
        __label__ = 29; break;
      }
      else {
      __label__ = 50; break;
      }
      
    case 25: // $326
      var $327=$4;
      var $328=$prim;
      var $329=(($328+20)|0);
      var $330=(($329)|0);
      var $331=HEAPF32[(($330)>>2)];
      var $332=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($327, $331);
      var $333=$prim;
      var $334=(($333+20)|0);
      var $335=(($334)|0);
      HEAPF32[(($335)>>2)]=$332;
      var $336=$4;
      var $337=$prim;
      var $338=(($337+20)|0);
      var $339=(($338+4)|0);
      var $340=HEAPF32[(($339)>>2)];
      var $341=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($336, $340);
      var $342=$prim;
      var $343=(($342+20)|0);
      var $344=(($343+4)|0);
      HEAPF32[(($344)>>2)]=$341;
      var $345=$4;
      var $346=$prim;
      var $347=(($346+20)|0);
      var $348=(($347+8)|0);
      var $349=HEAPF32[(($348)>>2)];
      var $350=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($345, $349);
      var $351=$prim;
      var $352=(($351+20)|0);
      var $353=(($352+8)|0);
      HEAPF32[(($353)>>2)]=$350;
      var $354=$4;
      var $355=$prim;
      var $356=(($355+20)|0);
      var $357=(($356+12)|0);
      var $358=HEAPF32[(($357)>>2)];
      var $359=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($354, $358);
      var $360=$prim;
      var $361=(($360+20)|0);
      var $362=(($361+12)|0);
      HEAPF32[(($362)>>2)]=$359;
      var $363=$prim;
      var $364=(($363)|0);
      HEAP32[(($364)>>2)]=1;
      var $365=$curitem;
      var $366=__ZNK16render_container4item5widthEv($365);
      var $367=(($container_xform+8)|0);
      var $368=HEAPF32[(($367)>>2)];
      var $369=(($container_xform+12)|0);
      var $370=HEAPF32[(($369)>>2)];
      var $371=$368 < $370;
      if ($371) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $372
      var $373=(($container_xform+8)|0);
      var $374=HEAPF32[(($373)>>2)];
      var $379 = $374;__label__ = 28; break;
    case 27: // $375
      var $376=(($container_xform+12)|0);
      var $377=HEAPF32[(($376)>>2)];
      var $379 = $377;__label__ = 28; break;
    case 28: // $378
      var $379;
      var $380=$366*$379;
      var $381=$prim;
      var $382=(($381+40)|0);
      HEAPF32[(($382)>>2)]=$380;
      var $383=$curitem;
      var $384=__ZNK16render_container4item5flagsEv($383);
      var $385=$prim;
      var $386=(($385+36)|0);
      HEAP32[(($386)>>2)]=$384;
      var $387=$prim;
      var $388=(($387+4)|0);
      var $389=__Z16render_clip_lineP13render_boundsPKS_($388, $cliprect);
      var $390=(($389)|0)!=0;
      var $391=(($390)&1);
      $clipped=$391;
      __label__ = 50; break;
    case 29: // $392
      var $393=$prim;
      var $394=(($393)|0);
      HEAP32[(($394)>>2)]=2;
      var $395=$prim;
      var $396=(($395+4)|0);
      __Z16normalize_boundsR13render_bounds($396);
      var $397=$curitem;
      var $398=__ZNK16render_container4item7textureEv($397);
      var $399=(($398)|0)!=0;
      if ($399) { __label__ = 30; break; } else { __label__ = 48; break; }
    case 30: // $400
      var $401=$curitem;
      var $402=__ZNK16render_container4item5flagsEv($401);
      var $403=$402 & 15;
      var $404=$403 >>> 0;
      var $405=(($container_xform+32)|0);
      var $406=HEAP32[(($405)>>2)];
      var $407=__ZL15orientation_addii($404, $406);
      $finalorient=$407;
      var $408=$finalorient;
      var $409=$408 & 4;
      var $410=(($409)|0)!=0;
      if ($410) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $411
      var $412=$prim;
      var $413=(($412+4)|0);
      var $414=(($413+12)|0);
      var $415=HEAPF32[(($414)>>2)];
      var $416=$prim;
      var $417=(($416+4)|0);
      var $418=(($417+4)|0);
      var $419=HEAPF32[(($418)>>2)];
      var $420=$415-$419;
      var $432 = $420;__label__ = 33; break;
    case 32: // $421
      var $422=$prim;
      var $423=(($422+4)|0);
      var $424=(($423+8)|0);
      var $425=HEAPF32[(($424)>>2)];
      var $426=$prim;
      var $427=(($426+4)|0);
      var $428=(($427)|0);
      var $429=HEAPF32[(($428)>>2)];
      var $430=$425-$429;
      var $432 = $430;__label__ = 33; break;
    case 33: // $431
      var $432;
      var $433=(($432)|0);
      $width=$433;
      var $434=$finalorient;
      var $435=$434 & 4;
      var $436=(($435)|0)!=0;
      if ($436) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $437
      var $438=$prim;
      var $439=(($438+4)|0);
      var $440=(($439+8)|0);
      var $441=HEAPF32[(($440)>>2)];
      var $442=$prim;
      var $443=(($442+4)|0);
      var $444=(($443)|0);
      var $445=HEAPF32[(($444)>>2)];
      var $446=$441-$445;
      var $458 = $446;__label__ = 36; break;
    case 35: // $447
      var $448=$prim;
      var $449=(($448+4)|0);
      var $450=(($449+12)|0);
      var $451=HEAPF32[(($450)>>2)];
      var $452=$prim;
      var $453=(($452+4)|0);
      var $454=(($453+4)|0);
      var $455=HEAPF32[(($454)>>2)];
      var $456=$451-$455;
      var $458 = $456;__label__ = 36; break;
    case 36: // $457
      var $458;
      var $459=(($458)|0);
      $height=$459;
      var $460=$width;
      var $461=(($6+328)|0);
      var $462=HEAP32[(($461)>>2)];
      var $463=(($460)|0) < (($462)|0);
      if ($463) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $464
      var $465=$width;
      var $470 = $465;__label__ = 39; break;
    case 38: // $466
      var $467=(($6+328)|0);
      var $468=HEAP32[(($467)>>2)];
      var $470 = $468;__label__ = 39; break;
    case 39: // $469
      var $470;
      $width=$470;
      var $471=$height;
      var $472=(($6+332)|0);
      var $473=HEAP32[(($472)>>2)];
      var $474=(($471)|0) < (($473)|0);
      if ($474) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $475
      var $476=$height;
      var $481 = $476;__label__ = 42; break;
    case 41: // $477
      var $478=(($6+332)|0);
      var $479=HEAP32[(($478)>>2)];
      var $481 = $479;__label__ = 42; break;
    case 42: // $480
      var $481;
      $height=$481;
      var $482=$curitem;
      var $483=__ZNK16render_container4item7textureEv($482);
      var $484=$width;
      var $485=$height;
      var $486=$prim;
      var $487=(($486+44)|0);
      var $488=$2;
      var $489=__ZN14render_texture10get_scaledEjjR14render_texinfoR21render_primitive_list($483, $484, $485, $487, $488);
      if ($489) { __label__ = 43; break; } else { __label__ = 47; break; }
    case 43: // $490
      var $491=$curitem;
      var $492=__ZNK16render_container4item7textureEv($491);
      var $493=$4;
      var $494=__ZN14render_texture20get_adjusted_paletteER16render_container($492, $493);
      var $495=$prim;
      var $496=(($495+44)|0);
      var $497=(($496+16)|0);
      HEAP32[(($497)>>2)]=$494;
      var $498=$prim;
      var $499=(($498+68)|0);
      var $500=$finalorient;
      var $501=((__ZL18oriented_texcoords+($500<<5))|0);
      var $502=$499;
      var $503=$501;
      assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($502)>>2)]=HEAP32[(($503)>>2)];HEAP32[(($502+4)>>2)]=HEAP32[(($503+4)>>2)];HEAP32[(($502+8)>>2)]=HEAP32[(($503+8)>>2)];HEAP32[(($502+12)>>2)]=HEAP32[(($503+12)>>2)];HEAP32[(($502+16)>>2)]=HEAP32[(($503+16)>>2)];HEAP32[(($502+20)>>2)]=HEAP32[(($503+20)>>2)];HEAP32[(($502+24)>>2)]=HEAP32[(($503+24)>>2)];HEAP32[(($502+28)>>2)]=HEAP32[(($503+28)>>2)];
      var $504=$prim;
      var $505=(($504+4)|0);
      var $506=$prim;
      var $507=(($506+68)|0);
      var $508=__Z16render_clip_quadP13render_boundsPKS_P17render_quad_texuv($505, $cliprect, $507);
      var $509=(($508)|0)!=0;
      var $510=(($509)&1);
      $clipped=$510;
      var $511=$curitem;
      var $512=__ZNK16render_container4item5flagsEv($511);
      var $513=$512 & -4096;
      var $514=$finalorient;
      var $515=$514 << 0;
      var $516=$513 | $515;
      var $517=$curitem;
      var $518=__ZNK16render_container4item7textureEv($517);
      var $519=__ZNK14render_texture6formatEv($518);
      var $520=$519 << 4;
      var $521=$516 | $520;
      var $522=$prim;
      var $523=(($522+36)|0);
      HEAP32[(($523)>>2)]=$521;
      var $524=$5;
      var $525=(($524)|0)!=-1;
      if ($525) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $526
      var $527=$5;
      var $528=$527 << 8;
      var $529=$prim;
      var $530=(($529+36)|0);
      var $531=HEAP32[(($530)>>2)];
      var $532=$531 | $528;
      HEAP32[(($530)>>2)]=$532;
      __label__ = 46; break;
    case 45: // $533
      var $534=$curitem;
      var $535=__ZNK16render_container4item5flagsEv($534);
      var $536=$535 & 3840;
      var $537=$536 >>> 8;
      var $538=$537 << 8;
      var $539=$prim;
      var $540=(($539+36)|0);
      var $541=HEAP32[(($540)>>2)];
      var $542=$541 | $538;
      HEAP32[(($540)>>2)]=$542;
      __label__ = 46; break;
    case 46: // $543
      __label__ = 47; break;
    case 47: // $544
      __label__ = 49; break;
    case 48: // $545
      var $546=$4;
      var $547=$prim;
      var $548=(($547+20)|0);
      var $549=(($548+4)|0);
      var $550=HEAPF32[(($549)>>2)];
      var $551=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($546, $550);
      var $552=$prim;
      var $553=(($552+20)|0);
      var $554=(($553+4)|0);
      HEAPF32[(($554)>>2)]=$551;
      var $555=$4;
      var $556=$prim;
      var $557=(($556+20)|0);
      var $558=(($557+8)|0);
      var $559=HEAPF32[(($558)>>2)];
      var $560=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($555, $559);
      var $561=$prim;
      var $562=(($561+20)|0);
      var $563=(($562+8)|0);
      HEAPF32[(($563)>>2)]=$560;
      var $564=$4;
      var $565=$prim;
      var $566=(($565+20)|0);
      var $567=(($566+12)|0);
      var $568=HEAPF32[(($567)>>2)];
      var $569=__ZN16render_container34apply_brightness_contrast_gamma_fpEf($564, $568);
      var $570=$prim;
      var $571=(($570+20)|0);
      var $572=(($571+12)|0);
      HEAPF32[(($572)>>2)]=$569;
      var $573=$prim;
      var $574=(($573+44)|0);
      var $575=(($574)|0);
      HEAP32[(($575)>>2)]=0;
      var $576=$prim;
      var $577=(($576+36)|0);
      HEAP32[(($577)>>2)]=256;
      var $578=$prim;
      var $579=(($578+4)|0);
      var $580=__Z16render_clip_quadP13render_boundsPKS_P17render_quad_texuv($579, $cliprect, 0);
      var $581=(($580)|0)!=0;
      var $582=(($581)&1);
      $clipped=$582;
      __label__ = 49; break;
    case 49: // $583
      __label__ = 50; break;
    case 50: // $584
      var $585=$2;
      var $586=$prim;
      var $587=$clipped;
      var $588=(($587) & 1);
      __ZN21render_primitive_list16append_or_returnER16render_primitiveb($585, $586, $588);
      __label__ = 51; break;
    case 51: // $589
      var $590=$curitem;
      var $591=__ZNK16render_container4item4nextEv($590);
      $curitem=$591;
      __label__ = 20; break;
    case 52: // $592
      var $593=$4;
      var $594=__ZNK16render_container7overlayEv($593);
      var $595=(($594)|0)!=0;
      if ($595) { __label__ = 53; break; } else { __label__ = 57; break; }
    case 53: // $596
      var $597=(($6+312)|0);
      var $598=__ZNK19render_layer_config22screen_overlay_enabledEv($597);
      if ($598) { __label__ = 54; break; } else { __label__ = 57; break; }
    case 54: // $599
      var $600=$2;
      var $601=__ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($600, 2);
      $prim3=$601;
      var $602=$prim3;
      var $603=(($602+4)|0);
      var $604=$3;
      var $605=(($604)|0);
      var $606=HEAPF32[(($605)>>2)];
      var $607=$3;
      var $608=(($607+4)|0);
      var $609=HEAPF32[(($608)>>2)];
      var $610=$3;
      var $611=(($610+8)|0);
      var $612=HEAPF32[(($611)>>2)];
      var $613=$3;
      var $614=(($613+12)|0);
      var $615=HEAPF32[(($614)>>2)];
      __ZL20set_render_bounds_whP13render_boundsffff($603, $606, $609, $612, $615);
      var $616=$prim3;
      var $617=(($616+20)|0);
      var $618=(($container_xform+16)|0);
      var $619=$617;
      var $620=$618;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($619)>>2)]=HEAP32[(($620)>>2)];HEAP32[(($619+4)>>2)]=HEAP32[(($620+4)>>2)];HEAP32[(($619+8)>>2)]=HEAP32[(($620+8)>>2)];HEAP32[(($619+12)>>2)]=HEAP32[(($620+12)>>2)];
      var $621=$prim3;
      var $622=(($621+4)|0);
      var $623=(($622+8)|0);
      var $624=HEAPF32[(($623)>>2)];
      var $625=__ZL20render_round_nearestf($624);
      var $626=$prim3;
      var $627=(($626+4)|0);
      var $628=(($627)|0);
      var $629=HEAPF32[(($628)>>2)];
      var $630=__ZL20render_round_nearestf($629);
      var $631=$625-$630;
      var $632=(($631)|0);
      $width1=$632;
      var $633=$prim3;
      var $634=(($633+4)|0);
      var $635=(($634+12)|0);
      var $636=HEAPF32[(($635)>>2)];
      var $637=__ZL20render_round_nearestf($636);
      var $638=$prim3;
      var $639=(($638+4)|0);
      var $640=(($639+4)|0);
      var $641=HEAPF32[(($640)>>2)];
      var $642=__ZL20render_round_nearestf($641);
      var $643=$637-$642;
      var $644=(($643)|0);
      $height2=$644;
      var $645=$4;
      var $646=__ZNK16render_container7overlayEv($645);
      var $647=(($container_xform+32)|0);
      var $648=HEAP32[(($647)>>2)];
      var $649=$648 & 4;
      var $650=(($649)|0)!=0;
      var $651=$height2;
      var $652=$width1;
      var $653=$650 ? $651 : $652;
      var $654=(($container_xform+32)|0);
      var $655=HEAP32[(($654)>>2)];
      var $656=$655 & 4;
      var $657=(($656)|0)!=0;
      var $658=$width1;
      var $659=$height2;
      var $660=$657 ? $658 : $659;
      var $661=$prim3;
      var $662=(($661+44)|0);
      var $663=$2;
      var $664=__ZN14render_texture10get_scaledEjjR14render_texinfoR21render_primitive_list($646, $653, $660, $662, $663);
      var $665=(($664)&1);
      $got_scaled=$665;
      var $666=$got_scaled;
      var $667=(($666) & 1);
      if ($667) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $668
      var $669=$prim3;
      var $670=(($669+68)|0);
      var $671=(($container_xform+32)|0);
      var $672=HEAP32[(($671)>>2)];
      var $673=((__ZL18oriented_texcoords+($672<<5))|0);
      var $674=$670;
      var $675=$673;
      assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($674)>>2)]=HEAP32[(($675)>>2)];HEAP32[(($674+4)>>2)]=HEAP32[(($675+4)>>2)];HEAP32[(($674+8)>>2)]=HEAP32[(($675+8)>>2)];HEAP32[(($674+12)>>2)]=HEAP32[(($675+12)>>2)];HEAP32[(($674+16)>>2)]=HEAP32[(($675+16)>>2)];HEAP32[(($674+20)>>2)]=HEAP32[(($675+20)>>2)];HEAP32[(($674+24)>>2)]=HEAP32[(($675+24)>>2)];HEAP32[(($674+28)>>2)]=HEAP32[(($675+28)>>2)];
      var $676=(($container_xform+32)|0);
      var $677=HEAP32[(($676)>>2)];
      var $678=$677 << 0;
      var $679=$678 | 512;
      var $680=$4;
      var $681=__ZNK16render_container7overlayEv($680);
      var $682=__ZNK14render_texture6formatEv($681);
      var $683=$682 << 4;
      var $684=$679 | $683;
      var $685=$684 | 32768;
      var $686=$prim3;
      var $687=(($686+36)|0);
      HEAP32[(($687)>>2)]=$685;
      __label__ = 56; break;
    case 56: // $688
      var $689=$2;
      var $690=$prim3;
      var $691=$got_scaled;
      var $692=(($691) & 1);
      var $693=$692 ^ 1;
      __ZN21render_primitive_list16append_or_returnER16render_primitiveb($689, $690, $693);
      __label__ = 57; break;
    case 57: // $694
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target24add_container_primitivesER21render_primitive_listRK16object_transformR16render_containeri["X"]=1;

function __ZNK11layout_view4item7elementEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL20set_render_bounds_xyP13render_boundsffff($bounds, $x0, $y0, $x1, $y1) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$bounds;
  $2=$x0;
  $3=$y0;
  $4=$x1;
  $5=$y1;
  var $6=$2;
  var $7=$1;
  var $8=(($7)|0);
  HEAPF32[(($8)>>2)]=$6;
  var $9=$3;
  var $10=$1;
  var $11=(($10+4)|0);
  HEAPF32[(($11)>>2)]=$9;
  var $12=$4;
  var $13=$1;
  var $14=(($13+8)|0);
  HEAPF32[(($14)>>2)]=$12;
  var $15=$5;
  var $16=$1;
  var $17=(($16+12)|0);
  HEAPF32[(($17)>>2)]=$15;
  ;
  return;
}


function __ZL16set_render_colorP12render_colorffff($color, $a, $r, $g, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$color;
  $2=$a;
  $3=$r;
  $4=$g;
  $5=$b;
  var $6=$2;
  var $7=$1;
  var $8=(($7)|0);
  HEAPF32[(($8)>>2)]=$6;
  var $9=$3;
  var $10=$1;
  var $11=(($10+4)|0);
  HEAPF32[(($11)>>2)]=$9;
  var $12=$4;
  var $13=$1;
  var $14=(($13+8)|0);
  HEAPF32[(($14)>>2)]=$12;
  var $15=$5;
  var $16=$1;
  var $17=(($16+12)|0);
  HEAPF32[(($17)>>2)]=$15;
  ;
  return;
}


function __ZNK11simple_listI16render_containerE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI16render_containerE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13render_target22add_element_primitivesER21render_primitive_listRK16object_transformR14layout_elementii($this, $list, $xform, $element, $state, $blendmode) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $texture;
      var $prim;
      var $width;
      var $height;
      var $temp;
      var $clipped;
      var $cliprect=__stackBase__;
      $1=$this;
      $2=$list;
      $3=$xform;
      $4=$element;
      $5=$state;
      $6=$blendmode;
      var $7=$1;
      var $8=$5;
      var $9=$4;
      var $10=__ZNK14layout_element8maxstateEv($9);
      var $11=(($8)|0) > (($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      __label__ = 18; break;
    case 2: // $13
      var $14=$5;
      var $15=(($14)|0) < 0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $5=0;
      __label__ = 4; break;
    case 4: // $17
      var $18=$4;
      var $19=$5;
      var $20=__ZN14layout_element13state_textureEi($18, $19);
      $texture=$20;
      var $21=$texture;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 18; break; }
    case 5: // $23
      var $24=$2;
      var $25=__ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($24, 2);
      $prim=$25;
      var $26=$prim;
      var $27=(($26+20)|0);
      var $28=$3;
      var $29=(($28+16)|0);
      var $30=$27;
      var $31=$29;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($30)>>2)]=HEAP32[(($31)>>2)];HEAP32[(($30+4)>>2)]=HEAP32[(($31+4)>>2)];HEAP32[(($30+8)>>2)]=HEAP32[(($31+8)>>2)];HEAP32[(($30+12)>>2)]=HEAP32[(($31+12)>>2)];
      var $32=$3;
      var $33=(($32+32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34 << 0;
      var $36=$6;
      var $37=$36 << 8;
      var $38=$35 | $37;
      var $39=$texture;
      var $40=__ZNK14render_texture6formatEv($39);
      var $41=$40 << 4;
      var $42=$38 | $41;
      var $43=$prim;
      var $44=(($43+36)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$3;
      var $46=(($45+8)|0);
      var $47=HEAPF32[(($46)>>2)];
      var $48=__ZL20render_round_nearestf($47);
      var $49=(($48)|0);
      $width=$49;
      var $50=$3;
      var $51=(($50+12)|0);
      var $52=HEAPF32[(($51)>>2)];
      var $53=__ZL20render_round_nearestf($52);
      var $54=(($53)|0);
      $height=$54;
      var $55=$prim;
      var $56=(($55+4)|0);
      var $57=$3;
      var $58=(($57)|0);
      var $59=HEAPF32[(($58)>>2)];
      var $60=__ZL20render_round_nearestf($59);
      var $61=$3;
      var $62=(($61+4)|0);
      var $63=HEAPF32[(($62)>>2)];
      var $64=__ZL20render_round_nearestf($63);
      var $65=$width;
      var $66=(($65)|0);
      var $67=$height;
      var $68=(($67)|0);
      __ZL20set_render_bounds_whP13render_boundsffff($56, $60, $64, $66, $68);
      var $69=$3;
      var $70=(($69+32)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71 & 4;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $74
      __label__ = 7; break;
    case 7: // $75
      var $76=$width;
      $temp=$76;
      var $77=$height;
      $width=$77;
      var $78=$temp;
      $height=$78;
      __label__ = 8; break;
    case 8: // $79
      __label__ = 9; break;
    case 9: // $80
      var $81=$width;
      var $82=(($7+328)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($81)|0) < (($83)|0);
      if ($84) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $85
      var $86=$width;
      var $91 = $86;__label__ = 12; break;
    case 11: // $87
      var $88=(($7+328)|0);
      var $89=HEAP32[(($88)>>2)];
      var $91 = $89;__label__ = 12; break;
    case 12: // $90
      var $91;
      $width=$91;
      var $92=$height;
      var $93=(($7+332)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($92)|0) < (($94)|0);
      if ($95) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $96
      var $97=$height;
      var $102 = $97;__label__ = 15; break;
    case 14: // $98
      var $99=(($7+332)|0);
      var $100=HEAP32[(($99)>>2)];
      var $102 = $100;__label__ = 15; break;
    case 15: // $101
      var $102;
      $height=$102;
      $clipped=1;
      var $103=$texture;
      var $104=$width;
      var $105=$height;
      var $106=$prim;
      var $107=(($106+44)|0);
      var $108=$2;
      var $109=__ZN14render_texture10get_scaledEjjR14render_texinfoR21render_primitive_list($103, $104, $105, $107, $108);
      if ($109) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $110
      var $111=$3;
      var $112=(($111)|0);
      var $113=HEAPF32[(($112)>>2)];
      var $114=__ZL20render_round_nearestf($113);
      var $115=(($cliprect)|0);
      HEAPF32[(($115)>>2)]=$114;
      var $116=$3;
      var $117=(($116+4)|0);
      var $118=HEAPF32[(($117)>>2)];
      var $119=__ZL20render_round_nearestf($118);
      var $120=(($cliprect+4)|0);
      HEAPF32[(($120)>>2)]=$119;
      var $121=$3;
      var $122=(($121)|0);
      var $123=HEAPF32[(($122)>>2)];
      var $124=$3;
      var $125=(($124+8)|0);
      var $126=HEAPF32[(($125)>>2)];
      var $127=$123+$126;
      var $128=__ZL20render_round_nearestf($127);
      var $129=(($cliprect+8)|0);
      HEAPF32[(($129)>>2)]=$128;
      var $130=$3;
      var $131=(($130+4)|0);
      var $132=HEAPF32[(($131)>>2)];
      var $133=$3;
      var $134=(($133+12)|0);
      var $135=HEAPF32[(($134)>>2)];
      var $136=$132+$135;
      var $137=__ZL20render_round_nearestf($136);
      var $138=(($cliprect+12)|0);
      HEAPF32[(($138)>>2)]=$137;
      var $139=(($7+284)|0);
      __ZL18sect_render_boundsP13render_boundsPKS_($cliprect, $139);
      var $140=$prim;
      var $141=(($140+68)|0);
      var $142=$3;
      var $143=(($142+32)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=((__ZL18oriented_texcoords+($144<<5))|0);
      var $146=$141;
      var $147=$145;
      assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($146)>>2)]=HEAP32[(($147)>>2)];HEAP32[(($146+4)>>2)]=HEAP32[(($147+4)>>2)];HEAP32[(($146+8)>>2)]=HEAP32[(($147+8)>>2)];HEAP32[(($146+12)>>2)]=HEAP32[(($147+12)>>2)];HEAP32[(($146+16)>>2)]=HEAP32[(($147+16)>>2)];HEAP32[(($146+20)>>2)]=HEAP32[(($147+20)>>2)];HEAP32[(($146+24)>>2)]=HEAP32[(($147+24)>>2)];HEAP32[(($146+28)>>2)]=HEAP32[(($147+28)>>2)];
      var $148=$prim;
      var $149=(($148+4)|0);
      var $150=$prim;
      var $151=(($150+68)|0);
      var $152=__Z16render_clip_quadP13render_boundsPKS_P17render_quad_texuv($149, $cliprect, $151);
      var $153=(($152)|0)!=0;
      var $154=(($153)&1);
      $clipped=$154;
      __label__ = 17; break;
    case 17: // $155
      var $156=$2;
      var $157=$prim;
      var $158=$clipped;
      var $159=(($158) & 1);
      __ZN21render_primitive_list16append_or_returnER16render_primitiveb($156, $157, $159);
      __label__ = 18; break;
    case 18: // $160
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target22add_element_primitivesER21render_primitive_listRK16object_transformR14layout_elementii["X"]=1;

function __ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($this, $type) {
  ;
  var __label__;

  var $1;
  var $2;
  var $result;
  $1=$this;
  $2=$type;
  var $3=$1;
  var $4=(($3+40)|0);
  var $5=__ZN15fixed_allocatorI16render_primitiveE5allocEv($4);
  $result=$5;
  var $6=$result;
  __ZN16render_primitive5resetEv($6);
  var $7=$2;
  var $8=$result;
  var $9=(($8)|0);
  HEAP32[(($9)>>2)]=$7;
  var $10=$result;
  ;
  return $10;
}


function __ZN21render_primitive_list6appendER16render_primitive($this, $prim) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$prim;
  var $3=$1;
  var $4=$2;
  __ZN21render_primitive_list16append_or_returnER16render_primitiveb($3, $4, 0);
  ;
  return;
}


function __ZN13render_target19map_point_containerEiiR16render_containerRfS2_($this, $target_x, $target_y, $container, $container_x, $container_y) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $input_tag=__stackBase__;
  var $input_mask=__stackBase__+4;
  $1=$this;
  $2=$target_x;
  $3=$target_y;
  $4=$container;
  $5=$container_x;
  $6=$container_y;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$5;
  var $12=$6;
  var $13=__ZN13render_target18map_point_internalEiiP16render_containerRfS2_RPKcRj($7, $8, $9, $10, $11, $12, $input_tag, $input_mask);
  STACKTOP = __stackBase__;
  return $13;
}


function __ZN13render_target18map_point_internalEiiP16render_containerRfS2_RPKcRj($this, $target_x, $target_y, $container, $mapped_x, $mapped_y, $mapped_input_tag, $mapped_input_mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $target_fx;
      var $target_fy;
      var $layernum=__stackBase__;
      var $blendmode=__stackBase__+4;
      var $layer;
      var $item;
      var $checkit;
      $2=$this;
      $3=$target_x;
      $4=$target_y;
      $5=$container;
      $6=$mapped_x;
      $7=$mapped_y;
      $8=$mapped_input_tag;
      $9=$mapped_input_mask;
      var $10=$2;
      var $11=$6;
      HEAPF32[(($11)>>2)]=-1;
      var $12=$7;
      HEAPF32[(($12)>>2)]=-1;
      var $13=$8;
      HEAP32[(($13)>>2)]=0;
      var $14=$9;
      HEAP32[(($14)>>2)]=0;
      var $15=$3;
      var $16=(($15)|0);
      var $17=(($10+276)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0);
      var $20=$16/$19;
      $target_fx=$20;
      var $21=$4;
      var $22=(($21)|0);
      var $23=(($10+280)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0);
      var $26=$22/$25;
      $target_fy=$26;
      var $27=$5;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $29
      var $30=$5;
      var $31=(($10+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__ZNK14render_manager12ui_containerEv($32);
      var $34=(($30)|0)==(($33)|0);
      if ($34) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $35
      var $36=$target_fx;
      var $37=$36;
      var $38=$37 >= 0;
      if ($38) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $39
      var $40=$target_fx;
      var $41=$40;
      var $42=$41 < 1;
      if ($42) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $43
      var $44=$target_fy;
      var $45=$44;
      var $46=$45 >= 0;
      if ($46) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $47
      var $48=$target_fy;
      var $49=$48;
      var $50=$49 < 1;
      if ($50) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $51
      var $52=$target_fx;
      var $53=$6;
      HEAPF32[(($53)>>2)]=$52;
      var $54=$target_fy;
      var $55=$7;
      HEAPF32[(($55)>>2)]=$54;
      $1=1;
      __label__ = 30; break;
    case 7: // $56
      $1=0;
      __label__ = 30; break;
    case 8: // $57
      HEAP32[(($layernum)>>2)]=0;
      __label__ = 9; break;
    case 9: // $58
      var $59=HEAP32[(($layernum)>>2)];
      var $60=(($59)|0) < 6;
      if ($60) { __label__ = 10; break; } else { __label__ = 29; break; }
    case 10: // $61
      var $62=(($10+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=HEAP32[(($layernum)>>2)];
      var $65=__Z23get_layer_and_blendmodeRK11layout_viewiRi($63, $64, $blendmode);
      $layer=$65;
      var $66=(($10+8)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$layer;
      var $69=__ZNK11layout_view13layer_enabledE10item_layer($67, $68);
      if ($69) { __label__ = 11; break; } else { __label__ = 27; break; }
    case 11: // $70
      var $71=(($10+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$layer;
      var $74=__ZNK11layout_view10first_itemE10item_layer($72, $73);
      $item=$74;
      __label__ = 12; break;
    case 12: // $75
      var $76=$item;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 13; break; } else { __label__ = 26; break; }
    case 13: // $78
      var $79=$5;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $81
      var $82=$item;
      var $83=__ZN11layout_view4item6screenEv($82);
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 15; break; } else { var $92 = 0;__label__ = 16; break; }
    case 15: // $85
      var $86=$item;
      var $87=__ZN11layout_view4item6screenEv($86);
      var $88=__ZNK13screen_device9containerEv($87);
      var $89=$5;
      var $90=(($88)|0)==(($89)|0);
      var $92 = $90;__label__ = 16; break;
    case 16: // $91
      var $92;
      var $93=(($92)&1);
      $checkit=$93;
      __label__ = 18; break;
    case 17: // $94
      var $95=$item;
      var $96=__ZNK11layout_view4item9has_inputEv($95);
      var $97=(($96)&1);
      $checkit=$97;
      __label__ = 18; break;
    case 18: // $98
      var $99=$checkit;
      var $100=(($99) & 1);
      if ($100) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $101
      var $102=$target_fx;
      var $103=$item;
      var $104=__ZNK11layout_view4item6boundsEv($103);
      var $105=(($104)|0);
      var $106=HEAPF32[(($105)>>2)];
      var $107=$102 >= $106;
      if ($107) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $108
      var $109=$target_fx;
      var $110=$item;
      var $111=__ZNK11layout_view4item6boundsEv($110);
      var $112=(($111+8)|0);
      var $113=HEAPF32[(($112)>>2)];
      var $114=$109 < $113;
      if ($114) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $115
      var $116=$target_fy;
      var $117=$item;
      var $118=__ZNK11layout_view4item6boundsEv($117);
      var $119=(($118+4)|0);
      var $120=HEAPF32[(($119)>>2)];
      var $121=$116 >= $120;
      if ($121) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $122
      var $123=$target_fy;
      var $124=$item;
      var $125=__ZNK11layout_view4item6boundsEv($124);
      var $126=(($125+12)|0);
      var $127=HEAPF32[(($126)>>2)];
      var $128=$123 < $127;
      if ($128) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $129
      var $130=$target_fx;
      var $131=$item;
      var $132=__ZNK11layout_view4item6boundsEv($131);
      var $133=(($132)|0);
      var $134=HEAPF32[(($133)>>2)];
      var $135=$130-$134;
      var $136=$item;
      var $137=__ZNK11layout_view4item6boundsEv($136);
      var $138=(($137+8)|0);
      var $139=HEAPF32[(($138)>>2)];
      var $140=$item;
      var $141=__ZNK11layout_view4item6boundsEv($140);
      var $142=(($141)|0);
      var $143=HEAPF32[(($142)>>2)];
      var $144=$139-$143;
      var $145=$135/$144;
      var $146=$6;
      HEAPF32[(($146)>>2)]=$145;
      var $147=$target_fy;
      var $148=$item;
      var $149=__ZNK11layout_view4item6boundsEv($148);
      var $150=(($149+4)|0);
      var $151=HEAPF32[(($150)>>2)];
      var $152=$147-$151;
      var $153=$item;
      var $154=__ZNK11layout_view4item6boundsEv($153);
      var $155=(($154+12)|0);
      var $156=HEAPF32[(($155)>>2)];
      var $157=$item;
      var $158=__ZNK11layout_view4item6boundsEv($157);
      var $159=(($158+4)|0);
      var $160=HEAPF32[(($159)>>2)];
      var $161=$156-$160;
      var $162=$152/$161;
      var $163=$7;
      HEAPF32[(($163)>>2)]=$162;
      var $164=$item;
      var $165=$9;
      var $166=__ZNK11layout_view4item18input_tag_and_maskERj($164, $165);
      var $167=$8;
      HEAP32[(($167)>>2)]=$166;
      $1=1;
      __label__ = 30; break;
    case 24: // $168
      __label__ = 25; break;
    case 25: // $169
      var $170=$item;
      var $171=__ZNK11layout_view4item4nextEv($170);
      $item=$171;
      __label__ = 12; break;
    case 26: // $172
      __label__ = 27; break;
    case 27: // $173
      __label__ = 28; break;
    case 28: // $174
      __ZppR10item_layeri($layernum, 0);
      __label__ = 9; break;
    case 29: // $175
      $1=0;
      __label__ = 30; break;
    case 30: // $176
      var $177=$1;
      STACKTOP = __stackBase__;
      return $177;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target18map_point_internalEiiP16render_containerRfS2_RPKcRj["X"]=1;

function __ZN13render_target15map_point_inputEiiRPKcRjRfS4_($this, $target_x, $target_y, $input_tag, $input_mask, $input_x, $input_y) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$target_x;
  $3=$target_y;
  $4=$input_tag;
  $5=$input_mask;
  $6=$input_x;
  $7=$input_y;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$6;
  var $12=$7;
  var $13=$4;
  var $14=$5;
  var $15=__ZN13render_target18map_point_internalEiiP16render_containerRfS2_RPKcRj($8, $9, $10, 0, $11, $12, $13, $14);
  ;
  return $15;
}


function __ZN13render_target14invalidate_allEPv($this, $refptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $listnum;
      var $list;
      $1=$this;
      $2=$refptr;
      var $3=$1;
      $listnum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$listnum;
      var $6=(($5)>>>0) < 3;
      if ($6) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $7
      var $8=$listnum;
      var $9=(($3+20)|0);
      var $10=(($9+$8*84)|0);
      $list=$10;
      var $11=$list;
      __ZN21render_primitive_list12acquire_lockEv($11);
      var $12=$list;
      var $13=$2;
      var $14=__ZNK21render_primitive_list13has_referenceEPv($12, $13);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$list;
      __ZN21render_primitive_list11release_allEv($16);
      __label__ = 4; break;
    case 4: // $17
      var $18=$list;
      __ZN21render_primitive_list12release_lockEv($18);
      __label__ = 5; break;
    case 5: // $19
      var $20=$listnum;
      var $21=(($20+1)|0);
      $listnum=$21;
      __label__ = 1; break;
    case 6: // $22
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13render_target11debug_allocEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+336)|0);
  var $4=(($2+4)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=__ZN14render_manager15container_allocEP13screen_device($5, 0);
  var $7=__ZN11simple_listI16render_containerE6appendERS0_($3, $6);
  ;
  return $7;
}


function __ZN13render_target37add_clear_and_optimize_primitive_listER21render_primitive_list($this, $list) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $prim;
      var $3;
      var $4;
      $1=$this;
      $2=$list;
      var $5=$1;
      __ZN13render_target18init_clear_extentsEv($5);
      var $6=$2;
      var $7=__ZNK21render_primitive_list5firstEv($6);
      $prim=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$prim;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $11
      var $12=$prim;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      if ($14 == 1) {
        __label__ = 3; break;
      }
      else if ($14 == 2) {
        __label__ = 4; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 3: // $15
      __label__ = 19; break;
    case 4: // $16
      var $17=$prim;
      var $18=(($17+36)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 240;
      var $21=$20 >>> 4;
      var $22=(($21)|0)==5;
      if ($22) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $23
      var $24=$prim;
      var $25=(($24+36)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 & 240;
      var $28=$27 >>> 4;
      var $29=(($28)|0)==2;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      __label__ = 19; break;
    case 7: // $31
      var $32=$prim;
      var $33=(($32+4)|0);
      var $34=__ZN13render_target19remove_clear_extentERK13render_bounds($5, $33);
      if ($34) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $35
      __label__ = 19; break;
    case 9: // $36
      var $37=$prim;
      var $38=(($37+36)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39 & 3840;
      var $41=$40 >>> 8;
      var $42=(($41)|0)==2;
      if ($42) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $43
      var $44=$prim;
      var $45=(($44+20)|0);
      __ZL16set_render_colorP12render_colorffff($45, 1, 0, 0, 0);
      var $46=$prim;
      var $47=(($46+44)|0);
      var $48=(($47)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=$prim;
      var $50=(($49+36)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$51 & -3841;
      var $53=$prim;
      var $54=(($53+36)|0);
      HEAP32[(($54)>>2)]=$52;
      __label__ = 12; break;
    case 11: // $55
      var $56=$prim;
      var $57=(($56+36)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58 & -3841;
      var $60=$prim;
      var $61=(($60+36)|0);
      HEAP32[(($61)>>2)]=$59;
      __label__ = 12; break;
    case 12: // $62
      var $63=$prim;
      var $64=(($63+20)|0);
      var $65=(($64)|0);
      var $66=HEAPF32[(($65)>>2)];
      var $67=$prim;
      var $68=(($67+20)|0);
      var $69=(($68+4)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $71=$70*$66;
      HEAPF32[(($69)>>2)]=$71;
      var $72=$prim;
      var $73=(($72+20)|0);
      var $74=(($73)|0);
      var $75=HEAPF32[(($74)>>2)];
      var $76=$prim;
      var $77=(($76+20)|0);
      var $78=(($77+8)|0);
      var $79=HEAPF32[(($78)>>2)];
      var $80=$79*$75;
      HEAPF32[(($78)>>2)]=$80;
      var $81=$prim;
      var $82=(($81+20)|0);
      var $83=(($82)|0);
      var $84=HEAPF32[(($83)>>2)];
      var $85=$prim;
      var $86=(($85+20)|0);
      var $87=(($86+12)|0);
      var $88=HEAPF32[(($87)>>2)];
      var $89=$88*$84;
      HEAPF32[(($87)>>2)]=$89;
      var $90=$prim;
      var $91=(($90+20)|0);
      var $92=(($91)|0);
      HEAPF32[(($92)>>2)]=1;
      __label__ = 16; break;
    case 13: // $93
      var $94=___cxa_allocate_exception(1032);
      var $95=$94;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($95, ((STRING_TABLE.__str232728)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $96
      ___cxa_throw($94, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 15: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $99=$98.f0;
      $3=$99;
      var $100=$98.f1;
      $4=$100;
      ___cxa_free_exception($94);
      __label__ = 20; break;
    case 16: // $101
      __label__ = 17; break;
    case 17: // $102
      var $103=$prim;
      var $104=__ZNK16render_primitive4nextEv($103);
      $prim=$104;
      __label__ = 1; break;
    case 18: // $105
      __label__ = 19; break;
    case 19: // $106
      var $107=$2;
      __ZN13render_target17add_clear_extentsER21render_primitive_list($5, $107);
      ;
      return;
    case 20: // $108
      var $109=$3;
      var $110=$3;
      var $111=$4;
      var $112=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $110, tempValue);
      var $113=($112.f1 = $111, $112);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target37add_clear_and_optimize_primitive_listER21render_primitive_list["X"]=1;

function __ZN11simple_listI16render_containerE7prependERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16render_containerE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI16render_containerE6detachERS0_["X"]=1;

function __ZNK11simple_listI11layout_fileE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13render_target7managerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI11layout_fileE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13render_target10debug_freeER16render_container($this, $container) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$container;
  var $3=$1;
  var $4=(($3+336)|0);
  var $5=$2;
  __ZN11simple_listI16render_containerE6removeERS0_($4, $5);
  ;
  return;
}


function __ZN11simple_listI16render_containerE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI16render_containerE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN13render_target9debug_topER16render_container($this, $container) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$container;
  var $3=$1;
  var $4=(($3+336)|0);
  var $5=(($3+336)|0);
  var $6=$2;
  var $7=__ZN11simple_listI16render_containerE6detachERS0_($5, $6);
  var $8=__ZN11simple_listI16render_containerE7prependERS0_($4, $7);
  ;
  return;
}


function __ZN13render_target19update_layer_configEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($3+312)|0);
  var $7=$2;
  var $8=$6;
  assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($7)]=HEAP8[($8)];
  __ZN11layout_view9recomputeE19render_layer_config($5, $2);
  STACKTOP = __stackBase__;
  return;
}


function __ZN7astringC1EPKcS1_($this, $str1, $str2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$str1;
  $3=$str2;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN7astringC2EPKcS1_($4, $5, $6);
  ;
  return;
}


function __ZNK11emu_options8art_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str372742)|0));
  ;
  return $4;
}


function __ZN14render_manager15container_allocEP13screen_device($this, $screen) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $container;
      var $11;
      var $12;
      $9=$this;
      $10=$screen;
      var $13=$9;
      var $14=__ZNK14render_manager7machineEv($13);
      var $15=__ZN15running_machine7respoolEv($14);
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=266848;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=2677;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$10;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16render_containerC1ER14render_managerP13screen_device]($54, $13, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $56
      var $57=__ZN13resource_pool10add_objectI16render_containerEEPT_S3_($15, $54);
      $container=$57;
      var $58=$10;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $60
      var $61=(($13+56)|0);
      var $62=$container;
      var $63=__ZN11simple_listI16render_containerE6appendERS0_($61, $62);
      __label__ = 15; break;
    case 10: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      $11=$66;
      var $67=$65.f1;
      $12=$67;
      var $68=$1;
      var $69=$2;
      var $70=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=2677;
      var $71=HEAP32[(($1)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $73
      var $74=HEAP32[(($1)>>2)];
      var $75=HEAP32[(($2)>>2)];
      var $76=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($74, $75, $76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $77=$1;
      var $78=$2;
      var $79=$3;
      __label__ = 14; break;
    case 14: // $80
      __label__ = 16; break;
    case 15: // $81
      var $82=$container;
      STACKTOP = __stackBase__;
      return $82;
    case 16: // $83
      var $84=$11;
      var $85=$11;
      var $86=$12;
      var $87=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $85, tempValue);
      var $88=($87.f1 = $86, $87);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $89
      var $90=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_manager15container_allocEP13screen_device["X"]=1;

function __ZN13render_target16load_layout_fileEPKcS1_($this, $dirname, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 360; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $rootnode;
      var $fname=__stackBase__+36;
      var $13;
      var $14;
      var $layoutfile=__stackBase__+100;
      var $filerr;
      var $15;
      var $result;
      var $err;
      $10=$this;
      $11=$dirname;
      $12=$filename;
      var $16=$10;
      var $17=$12;
      var $18=(($17)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)==60;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$12;
      var $24=__Z15xml_string_readPKcP18_xml_parse_options($23, 0);
      $rootnode=$24;
      __label__ = 26; break;
    case 2: // $25
      var $26=$12;
      __ZN7astringC1EPKcS1_($fname, $26, ((STRING_TABLE.__str72712)|0));
      var $27=$11;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $29
      var $30=(function() { try { __THREW__ = false; return __ZN7astring3insEiPKc($fname, 0, ((STRING_TABLE.__str82713)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $31
      var $32=$11;
      var $33=(function() { try { __THREW__ = false; return __ZN7astring3insEiPKc($30, 0, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; };
    case 5: // $34
      __label__ = 7; break;
    case 6: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $13=$37;
      var $38=$36.f1;
      $14=$38;
      __label__ = 24; break;
    case 7: // $39
      var $40=(function() { try { __THREW__ = false; return __ZNK13render_target7managerEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 6; break; };
    case 8: // $41
      var $42=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; };
    case 9: // $43
      var $44=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; };
    case 10: // $45
      var $46=(function() { try { __THREW__ = false; return __ZNK11emu_options8art_pathEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 6; break; };
    case 11: // $47
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($layoutfile, $46, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 6; break; }
    case 12: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; };
    case 13: // $50
      var $51=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($layoutfile, $49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $52
      $filerr=$51;
      var $53=$filerr;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $55
      $9=0;
      $15=1;
      __label__ = 20; break;
    case 16: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      $13=$58;
      var $59=$57.f1;
      $14=$59;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($layoutfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 68; break; }
    case 17: // $60
      var $61=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($layoutfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 16; break; };
    case 18: // $62
      var $63=(function() { try { __THREW__ = false; return __Z13xml_file_readP10_core_fileP18_xml_parse_options($61, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; };
    case 19: // $64
      $rootnode=$63;
      $15=0;
      __label__ = 20; break;
    case 20: // $65
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($layoutfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 6; break; }
    case 21: // $66
      FUNCTION_TABLE[__ZN7astringD1Ev]($fname);
      var $cleanup_dest=$15;
      if ($cleanup_dest == 0) {
        __label__ = 22; break;
      }
      else if ($cleanup_dest == 1) {
        __label__ = 66; break;
      }
      else {
      __label__ = 69; break;
      }
      
    case 22: // $67
      __label__ = 26; break;
    case 23: // $68
      __label__ = 24; break;
    case 24: // $69
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 68; break; }
    case 25: // $70
      __label__ = 67; break;
    case 26: // $71
      var $72=$rootnode;
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $74
      var $75=$12;
      var $76=(($75)|0);
      var $77=HEAP8[($76)];
      var $78=(($77 << 24) >> 24);
      var $79=(($78)|0)!=60;
      if ($79) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $80
      var $81=$12;
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str92714)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt));
      __label__ = 30; break;
    case 29: // $82
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str102715)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 30; break;
    case 30: // $83
      $9=0;
      __label__ = 66; break;
    case 31: // $84
      $result=1;
      var $85=(($16+12)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($16+4)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 47; break; };
    case 32: // $90
      var $91=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 47; break; };
    case 33: // $92
      var $93=$4;
      var $94=$5;
      var $95=$6;
      var $96=$result_i;
      var $97=$7;
      var $98=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=1711;
      var $99=HEAP32[(($4)>>2)];
      var $100=HEAP32[(($5)>>2)];
      var $101=HEAP32[(($6)>>2)];
      var $102=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($99, $100, $101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 36; break; };
    case 34: // $103
      HEAP32[(($result_i)>>2)]=$102;
      var $104=HEAP32[(($result_i)>>2)];
      var $105=(($104)|0)==0;
      if ($105) { __label__ = 35; break; } else { __label__ = 41; break; }
    case 35: // $106
      var $107=___cxa_allocate_exception(4);
      var $108=$107;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($108);
      (function() { try { __THREW__ = false; return ___cxa_throw($107, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 36; break; }
    case 36: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $111=$110.f0;
      HEAP32[(($7)>>2)]=$111;
      var $112=$110.f1;
      HEAP32[(($8)>>2)]=$112;
      var $113=HEAP32[(($8)>>2)];
      var $114=(($113)|0) < 0;
      if ($114) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $115
      var $116=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 47; break; }
    case 38: // $_noexc
      throw "Reached an unreachable!"
    case 39: // $117
      var $118=HEAP32[(($7)>>2)];
      var $119=HEAP32[(($7)>>2)];
      var $120=HEAP32[(($8)>>2)];
      var $121=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $119, tempValue);
      var $122=($121.f1 = $120, $121);
      var $eh_lpad_body = $122;__label__ = 48; break;
    case 40: // $123
      throw "Reached an unreachable!"
    case 41: // $_ZnwjPKci_exit
      var $124=HEAP32[(($result_i)>>2)];
      var $125=$4;
      var $126=$5;
      var $127=$6;
      var $128=$result_i;
      var $129=$7;
      var $130=$8;
      __label__ = 42; break;
    case 42: // $131
      var $132=$124;
      var $133=(($16+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 49; break; };
    case 43: // $136
      var $137=$rootnode;
      var $138=$11;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_fileC1ER15running_machineR14_xml_data_nodePKc]($132, $135, $137, $138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 49; break; }
    case 44: // $139
      var $140=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI11layout_fileEEPT_S3_($91, $132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; };
    case 45: // $141
      var $142=(function() { try { __THREW__ = false; return __ZN11simple_listI11layout_fileE6appendERS0_($86, $140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 47; break; };
    case 46: // $143
      __label__ = 64; break;
    case 47: // $144
      var $145=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $eh_lpad_body = $145;__label__ = 48; break;
    case 48: // $_body
      var $eh_lpad_body;
      var $146=$eh_lpad_body.f0;
      $13=$146;
      var $147=$eh_lpad_body.f1;
      $14=$147;
      __label__ = 54; break;
    case 49: // $148
      var $149=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $150=$149.f0;
      $13=$150;
      var $151=$149.f1;
      $14=$151;
      var $152=$1;
      var $153=$2;
      var $154=$3;
      HEAP32[(($1)>>2)]=$124;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=1711;
      var $155=HEAP32[(($1)>>2)];
      var $156=(($155)|0)!=0;
      if ($156) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $157
      var $158=HEAP32[(($1)>>2)];
      var $159=HEAP32[(($2)>>2)];
      var $160=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($158, $159, $160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 68; break; }
    case 51: // $_noexc1
      __label__ = 52; break;
    case 52: // $_ZdlPvPKci_exit
      var $161=$1;
      var $162=$2;
      var $163=$3;
      __label__ = 53; break;
    case 53: // $164
      __label__ = 54; break;
    case 54: // $165
      var $166=$14;
      var $167=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $168=(($166)|0)==(($167)|0);
      if ($168) { __label__ = 55; break; } else { __label__ = 67; break; }
    case 55: // $169
      var $170=$13;
      var $171=___cxa_begin_catch($170);
      var $172=$171;
      $err=$172;
      var $173=$12;
      var $174=(($173)|0);
      var $175=HEAP8[($174)];
      var $176=(($175 << 24) >> 24);
      var $177=(($176)|0)!=60;
      if ($177) { __label__ = 56; break; } else { __label__ = 60; break; }
    case 56: // $178
      var $179=$12;
      var $180=$err;
      var $181=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 59; break; };
    case 57: // $182
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str112716)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$179,HEAP32[((tempInt+4)>>2)]=$181,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $183
      __label__ = 63; break;
    case 59: // $184
      var $185=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $186=$185.f0;
      $13=$186;
      var $187=$185.f1;
      $14=$187;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 68; break; }
    case 60: // $188
      var $189=$err;
      var $190=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($189) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 59; break; };
    case 61: // $191
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str122717)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$190,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 59; break; }
    case 62: // $192
      __label__ = 63; break;
    case 63: // $193
      $result=0;
      ___cxa_end_catch();
      __label__ = 64; break;
    case 64: // $194
      var $195=$rootnode;
      __Z13xml_file_freeP14_xml_data_node($195);
      var $196=$result;
      var $197=(($196) & 1);
      $9=$197;
      __label__ = 66; break;
    case 65: // $198
      __label__ = 67; break;
    case 66: // $199
      var $200=$9;
      STACKTOP = __stackBase__;
      return $200;
    case 67: // $201
      var $202=$13;
      var $203=$13;
      var $204=$14;
      var $205=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $203, tempValue);
      var $206=($205.f1 = $204, $205);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $207
      var $208=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 69: // $209
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target16load_layout_fileEPKcS1_["X"]=1;

function __ZL18sect_render_boundsP13render_boundsPKS_($dest, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$dest;
      $2=$src;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAPF32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAPF32[(($7)>>2)];
      var $9=$5 > $8;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAPF32[(($12)>>2)];
      var $19 = $13;__label__ = 3; break;
    case 2: // $14
      var $15=$2;
      var $16=(($15)|0);
      var $17=HEAPF32[(($16)>>2)];
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      var $20=$1;
      var $21=(($20)|0);
      HEAPF32[(($21)>>2)]=$19;
      var $22=$1;
      var $23=(($22+8)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$2;
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$24 < $27;
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $29
      var $30=$1;
      var $31=(($30+8)|0);
      var $32=HEAPF32[(($31)>>2)];
      var $38 = $32;__label__ = 6; break;
    case 5: // $33
      var $34=$2;
      var $35=(($34+8)|0);
      var $36=HEAPF32[(($35)>>2)];
      var $38 = $36;__label__ = 6; break;
    case 6: // $37
      var $38;
      var $39=$1;
      var $40=(($39+8)|0);
      HEAPF32[(($40)>>2)]=$38;
      var $41=$1;
      var $42=(($41+4)|0);
      var $43=HEAPF32[(($42)>>2)];
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=HEAPF32[(($45)>>2)];
      var $47=$43 > $46;
      if ($47) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $48
      var $49=$1;
      var $50=(($49+4)|0);
      var $51=HEAPF32[(($50)>>2)];
      var $57 = $51;__label__ = 9; break;
    case 8: // $52
      var $53=$2;
      var $54=(($53+4)|0);
      var $55=HEAPF32[(($54)>>2)];
      var $57 = $55;__label__ = 9; break;
    case 9: // $56
      var $57;
      var $58=$1;
      var $59=(($58+4)|0);
      HEAPF32[(($59)>>2)]=$57;
      var $60=$1;
      var $61=(($60+12)|0);
      var $62=HEAPF32[(($61)>>2)];
      var $63=$2;
      var $64=(($63+12)|0);
      var $65=HEAPF32[(($64)>>2)];
      var $66=$62 < $65;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$1;
      var $69=(($68+12)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $76 = $70;__label__ = 12; break;
    case 11: // $71
      var $72=$2;
      var $73=(($72+12)|0);
      var $74=HEAPF32[(($73)>>2)];
      var $76 = $74;__label__ = 12; break;
    case 12: // $75
      var $76;
      var $77=$1;
      var $78=(($77+12)|0);
      HEAPF32[(($78)>>2)]=$76;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18sect_render_boundsP13render_boundsPKS_["X"]=1;

function __ZNK16render_container6yscaleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=(($3+20)|0);
  var $5=HEAPF32[(($4)>>2)];
  ;
  return $5;
}


function __ZNK16render_container6xscaleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=(($3+16)|0);
  var $5=HEAPF32[(($4)>>2)];
  ;
  return $5;
}


function __ZNK16render_container7yoffsetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=(($3+28)|0);
  var $5=HEAPF32[(($4)>>2)];
  ;
  return $5;
}


function __ZNK16render_container7xoffsetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=(($3+24)|0);
  var $5=HEAPF32[(($4)>>2)];
  ;
  return $5;
}


function __ZNK16render_container4item6boundsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  ;
  return $3;
}


function __ZNK16render_container4item8internalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+44)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container4item5colorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  ;
  return $3;
}


function __ZNK16render_container4item4typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZNK16render_container4item5widthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+48)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container4item5flagsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+40)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container4item7textureEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK14render_texture6formatEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+32)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container4item4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container7overlayEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+88)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK19render_layer_config22screen_overlay_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 64;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZL20set_render_bounds_whP13render_boundsffff($bounds, $x0, $y0, $width, $height) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$bounds;
  $2=$x0;
  $3=$y0;
  $4=$width;
  $5=$height;
  var $6=$2;
  var $7=$1;
  var $8=(($7)|0);
  HEAPF32[(($8)>>2)]=$6;
  var $9=$3;
  var $10=$1;
  var $11=(($10+4)|0);
  HEAPF32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=$4;
  var $14=$12+$13;
  var $15=$1;
  var $16=(($15+8)|0);
  HEAPF32[(($16)>>2)]=$14;
  var $17=$3;
  var $18=$5;
  var $19=$17+$18;
  var $20=$1;
  var $21=(($20+12)|0);
  HEAPF32[(($21)>>2)]=$19;
  ;
  return;
}


function __ZNK14layout_element8maxstateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+100)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI11layout_fileE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11layout_view4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11layout_file4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13render_target15set_orientationEi($this, $orientation) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$orientation;
  var $3=$1;
  var $4=$2;
  var $5=(($3+308)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZNK13render_target11orientationEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+308)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16render_container10first_itemEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=__ZNK11simple_listIN16render_container4itemEE5firstEv($3);
  ;
  return $4;
}


function __ZNK11layout_view4item9has_inputEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+76)|0);
  var $4=__ZNK7astringcvbEv($3);
  ;
  return $4;
}


function __ZNK11layout_view4item18input_tag_and_maskERj($this, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$mask;
  var $3=$1;
  var $4=(($3+140)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  HEAP32[(($6)>>2)]=$5;
  var $7=(($3+76)|0);
  var $8=__ZNK7astringcvPKcEv($7);
  ;
  return $8;
}


function __ZNK11layout_file10first_viewEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=__ZNK11simple_listI11layout_viewE5firstEv($3);
  ;
  return $4;
}


function __ZNK11layout_view7has_artEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+156)|0);
  var $4=__ZNK11simple_listIN11layout_view4itemEE5countEv($3);
  var $5=(($2+196)|0);
  var $6=__ZNK11simple_listIN11layout_view4itemEE5countEv($5);
  var $7=(($4+$6)|0);
  var $8=(($2+216)|0);
  var $9=__ZNK11simple_listIN11layout_view4itemEE5countEv($8);
  var $10=(($7+$9)|0);
  var $11=(($2+236)|0);
  var $12=__ZNK11simple_listIN11layout_view4itemEE5countEv($11);
  var $13=(($10+$12)|0);
  var $14=(($2+256)|0);
  var $15=__ZNK11simple_listIN11layout_view4itemEE5countEv($14);
  var $16=(($13+$15)|0);
  var $17=(($16)|0)!=0;
  ;
  return $17;
}


function __ZN13render_target11config_loadER14_xml_data_node($this, $targetnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $viewname;
      var $viewnum;
      var $testname;
      var $tmpint;
      var $settings=__stackBase__;
      var $ui_container;
      $1=$this;
      $2=$targetnode;
      var $3=$1;
      var $4=$2;
      var $5=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($4, ((STRING_TABLE.__str132718)|0), 0);
      $viewname=$5;
      var $6=$viewname;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $8
      $viewnum=0;
      __label__ = 2; break;
    case 2: // $9
      var $10=$viewnum;
      var $11=(($10)|0) < 1000;
      if ($11) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $12
      var $13=$viewnum;
      var $14=__ZN13render_target9view_nameEi($3, $13);
      $testname=$14;
      var $15=$testname;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      __label__ = 9; break;
    case 5: // $18
      var $19=$viewname;
      var $20=$testname;
      var $21=_strcmp($19, $20);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $23
      var $24=$viewnum;
      __ZN13render_target8set_viewEi($3, $24);
      __label__ = 9; break;
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=$viewnum;
      var $28=(($27+1)|0);
      $viewnum=$28;
      __label__ = 2; break;
    case 9: // $29
      __label__ = 10; break;
    case 10: // $30
      var $31=$2;
      var $32=__Z21xml_get_attribute_intP14_xml_data_nodePKci($31, ((STRING_TABLE.__str142719)|0), -1);
      $tmpint=$32;
      var $33=$tmpint;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $35
      var $36=$tmpint;
      var $37=(($36)|0)==1;
      if ($37) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $38
      var $39=$tmpint;
      var $40=(($39)|0)!=0;
      __ZN13render_target21set_backdrops_enabledEb($3, $40);
      __label__ = 13; break;
    case 13: // $41
      var $42=$2;
      var $43=__Z21xml_get_attribute_intP14_xml_data_nodePKci($42, ((STRING_TABLE.__str152720)|0), -1);
      $tmpint=$43;
      var $44=$tmpint;
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $46
      var $47=$tmpint;
      var $48=(($47)|0)==1;
      if ($48) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $49
      var $50=$tmpint;
      var $51=(($50)|0)!=0;
      __ZN13render_target20set_overlays_enabledEb($3, $51);
      __label__ = 16; break;
    case 16: // $52
      var $53=$2;
      var $54=__Z21xml_get_attribute_intP14_xml_data_nodePKci($53, ((STRING_TABLE.__str162721)|0), -1);
      $tmpint=$54;
      var $55=$tmpint;
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $57
      var $58=$tmpint;
      var $59=(($58)|0)==1;
      if ($59) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $60
      var $61=$tmpint;
      var $62=(($61)|0)!=0;
      __ZN13render_target18set_bezels_enabledEb($3, $62);
      __label__ = 19; break;
    case 19: // $63
      var $64=$2;
      var $65=__Z21xml_get_attribute_intP14_xml_data_nodePKci($64, ((STRING_TABLE.__str172722)|0), -1);
      $tmpint=$65;
      var $66=$tmpint;
      var $67=(($66)|0)==0;
      if ($67) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $68
      var $69=$tmpint;
      var $70=(($69)|0)==1;
      if ($70) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $71
      var $72=$tmpint;
      var $73=(($72)|0)!=0;
      __ZN13render_target19set_cpanels_enabledEb($3, $73);
      __label__ = 22; break;
    case 22: // $74
      var $75=$2;
      var $76=__Z21xml_get_attribute_intP14_xml_data_nodePKci($75, ((STRING_TABLE.__str182723)|0), -1);
      $tmpint=$76;
      var $77=$tmpint;
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $79
      var $80=$tmpint;
      var $81=(($80)|0)==1;
      if ($81) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $82
      var $83=$tmpint;
      var $84=(($83)|0)!=0;
      __ZN13render_target20set_marquees_enabledEb($3, $84);
      __label__ = 25; break;
    case 25: // $85
      var $86=$2;
      var $87=__Z21xml_get_attribute_intP14_xml_data_nodePKci($86, ((STRING_TABLE.__str192724)|0), -1);
      $tmpint=$87;
      var $88=$tmpint;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $90
      var $91=$tmpint;
      var $92=(($91)|0)==1;
      if ($92) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $93
      var $94=$tmpint;
      var $95=(($94)|0)!=0;
      __ZN13render_target18set_zoom_to_screenEb($3, $95);
      __label__ = 28; break;
    case 28: // $96
      var $97=$2;
      var $98=__Z21xml_get_attribute_intP14_xml_data_nodePKci($97, ((STRING_TABLE.__str202725)|0), -1);
      $tmpint=$98;
      var $99=$tmpint;
      var $100=(($99)|0)!=-1;
      if ($100) { __label__ = 29; break; } else { __label__ = 41; break; }
    case 29: // $101
      var $102=$tmpint;
      var $103=(($102)|0)==90;
      if ($103) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $104
      $tmpint=5;
      __label__ = 38; break;
    case 31: // $105
      var $106=$tmpint;
      var $107=(($106)|0)==180;
      if ($107) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $108
      $tmpint=3;
      __label__ = 37; break;
    case 33: // $109
      var $110=$tmpint;
      var $111=(($110)|0)==270;
      if ($111) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $112
      $tmpint=6;
      __label__ = 36; break;
    case 35: // $113
      $tmpint=0;
      __label__ = 36; break;
    case 36: // $114
      __label__ = 37; break;
    case 37: // $115
      __label__ = 38; break;
    case 38: // $116
      var $117=$tmpint;
      var $118=__ZNK13render_target11orientationEv($3);
      var $119=__ZL15orientation_addii($117, $118);
      __ZN13render_target15set_orientationEi($3, $119);
      var $120=__ZNK13render_target12is_ui_targetEv($3);
      if ($120) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $121
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $122=(($3+4)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=__ZNK14render_manager12ui_containerEv($123);
      $ui_container=$124;
      var $125=$ui_container;
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($125, $settings);
      var $126=$tmpint;
      var $127=__ZL19orientation_reversei($126);
      var $128=(($settings)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=__ZL15orientation_addii($127, $129);
      var $131=(($settings)|0);
      HEAP32[(($131)>>2)]=$130;
      var $132=$ui_container;
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($132, $settings);
      __label__ = 40; break;
    case 40: // $133
      __label__ = 41; break;
    case 41: // $134
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target11config_loadER14_xml_data_node["X"]=1;

function __ZN13render_target21set_backdrops_enabledEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config21set_backdrops_enabledEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZN13render_target20set_overlays_enabledEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config20set_overlays_enabledEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZN13render_target18set_bezels_enabledEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config18set_bezels_enabledEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZN13render_target19set_cpanels_enabledEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config19set_cpanels_enabledEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZN13render_target20set_marquees_enabledEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config20set_marquees_enabledEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZN13render_target18set_zoom_to_screenEb($this, $zoom) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($zoom)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config18set_zoom_to_screenEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZNK16render_container17get_user_settingsERNS_13user_settingsE($this, $settings) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$settings;
  var $3=$1;
  var $4=$2;
  var $5=(($3+52)|0);
  var $6=$4;
  var $7=$5;
  assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[(($7+8)>>2)];HEAP32[(($6+12)>>2)]=HEAP32[(($7+12)>>2)];HEAP32[(($6+16)>>2)]=HEAP32[(($7+16)>>2)];HEAP32[(($6+20)>>2)]=HEAP32[(($7+20)>>2)];HEAP32[(($6+24)>>2)]=HEAP32[(($7+24)>>2)];HEAP32[(($6+28)>>2)]=HEAP32[(($7+28)>>2)];
  ;
  return;
}


function __ZN13resource_pool10add_objectI11layout_fileEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11layout_fileEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11layout_fileEEPT_S3_["X"]=1;

function __ZNK19render_layer_configneERKS_($this, $rhs) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rhs;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$2;
  var $8=(($7)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=(($6)|0)!=(($10)|0);
  ;
  return $11;
}


function __ZNK19render_layer_config17backdrops_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 1;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK19render_layer_config16overlays_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 2;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK19render_layer_config14bezels_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 4;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK19render_layer_config15cpanels_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 8;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK19render_layer_config16marquees_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 16;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK19render_layer_config14zoom_to_screenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 32;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZN13render_target18init_clear_extentsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+280)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(((-$4))|0);
  var $6=(($2+360)|0);
  var $7=(($6)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=(($2+360)|0);
  var $9=(($8+4)|0);
  HEAP32[(($9)>>2)]=1;
  var $10=(($2+276)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($2+360)|0);
  var $13=(($12+8)|0);
  HEAP32[(($13)>>2)]=$11;
  var $14=(($2+356)|0);
  HEAP32[(($14)>>2)]=3;
  ;
  return;
}


function __ZN13render_target11config_saveER14_xml_data_node($this, $targetnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $changed;
      var $rotate;
      $1=$this;
      $2=$targetnode;
      var $3=$1;
      $changed=0;
      var $4=$2;
      var $5=__ZNK13render_target5indexEv($3);
      var $6=__Z21xml_set_attribute_intP14_xml_data_nodePKci($4, ((STRING_TABLE.__str212726)|0), $5);
      var $7=(($3+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($3+316)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($8)|0)!=(($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=(($3+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNK11layout_view4nameEv($15);
      var $17=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($13, ((STRING_TABLE.__str132718)|0), $16);
      $changed=1;
      __label__ = 2; break;
    case 2: // $18
      var $19=(($3+312)|0);
      var $20=(($3+324)|0);
      var $21=__ZNK19render_layer_configneERKS_($19, $20);
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$2;
      var $24=(($3+312)|0);
      var $25=__ZNK19render_layer_config17backdrops_enabledEv($24);
      var $26=(($25)&1);
      var $27=__Z21xml_set_attribute_intP14_xml_data_nodePKci($23, ((STRING_TABLE.__str142719)|0), $26);
      var $28=$2;
      var $29=(($3+312)|0);
      var $30=__ZNK19render_layer_config16overlays_enabledEv($29);
      var $31=(($30)&1);
      var $32=__Z21xml_set_attribute_intP14_xml_data_nodePKci($28, ((STRING_TABLE.__str152720)|0), $31);
      var $33=$2;
      var $34=(($3+312)|0);
      var $35=__ZNK19render_layer_config14bezels_enabledEv($34);
      var $36=(($35)&1);
      var $37=__Z21xml_set_attribute_intP14_xml_data_nodePKci($33, ((STRING_TABLE.__str162721)|0), $36);
      var $38=$2;
      var $39=(($3+312)|0);
      var $40=__ZNK19render_layer_config15cpanels_enabledEv($39);
      var $41=(($40)&1);
      var $42=__Z21xml_set_attribute_intP14_xml_data_nodePKci($38, ((STRING_TABLE.__str172722)|0), $41);
      var $43=$2;
      var $44=(($3+312)|0);
      var $45=__ZNK19render_layer_config16marquees_enabledEv($44);
      var $46=(($45)&1);
      var $47=__Z21xml_set_attribute_intP14_xml_data_nodePKci($43, ((STRING_TABLE.__str182723)|0), $46);
      var $48=$2;
      var $49=(($3+312)|0);
      var $50=__ZNK19render_layer_config14zoom_to_screenEv($49);
      var $51=(($50)&1);
      var $52=__Z21xml_set_attribute_intP14_xml_data_nodePKci($48, ((STRING_TABLE.__str192724)|0), $51);
      $changed=1;
      __label__ = 4; break;
    case 4: // $53
      var $54=(($3+308)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($3+320)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($55)|0)!=(($57)|0);
      if ($58) { __label__ = 5; break; } else { __label__ = 16; break; }
    case 5: // $59
      $rotate=0;
      var $60=(($3+320)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__ZL15orientation_addii(5, $61);
      var $63=(($3+308)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($62)|0)==(($64)|0);
      if ($65) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $66
      $rotate=90;
      __label__ = 13; break;
    case 7: // $67
      var $68=(($3+320)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=__ZL15orientation_addii(3, $69);
      var $71=(($3+308)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($70)|0)==(($72)|0);
      if ($73) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $74
      $rotate=180;
      __label__ = 12; break;
    case 9: // $75
      var $76=(($3+320)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=__ZL15orientation_addii(6, $77);
      var $79=(($3+308)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78)|0)==(($80)|0);
      if ($81) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $82
      $rotate=270;
      __label__ = 11; break;
    case 11: // $83
      __label__ = 12; break;
    case 12: // $84
      __label__ = 13; break;
    case 13: // $85
      __label__ = 14; break;
    case 14: // $86
      __label__ = 15; break;
    case 15: // $87
      var $88=$2;
      var $89=$rotate;
      var $90=__Z21xml_set_attribute_intP14_xml_data_nodePKci($88, ((STRING_TABLE.__str202725)|0), $89);
      $changed=1;
      __label__ = 16; break;
    case 16: // $91
      var $92=$changed;
      var $93=(($92) & 1);
      ;
      return $93;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target11config_saveER14_xml_data_node["X"]=1;

function __ZN13render_target19remove_clear_extentERK13render_bounds($this, $bounds) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $max;
      var $last;
      var $ext;
      var $boundsx0;
      var $boundsx1;
      var $boundsy0;
      var $boundsy1;
      var $y0;
      var $y1;
      var $linelast;
      var $xext;
      var $x0;
      var $x1;
      var $diff;
      var $4;
      var $5;
      var $diff1;
      $2=$this;
      $3=$bounds;
      var $6=$2;
      var $7=(($6+360)|0);
      var $8=(($7+4000)|0);
      $max=$8;
      var $9=(($6+356)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6+360)|0);
      var $12=(($11+($10<<2))|0);
      $last=$12;
      var $13=(($6+360)|0);
      var $14=(($13)|0);
      $ext=$14;
      var $15=$3;
      var $16=(($15)|0);
      var $17=HEAPF32[(($16)>>2)];
      var $18=$17;
      var $19=_ceil($18);
      var $20=(($19)|0);
      $boundsx0=$20;
      var $21=$3;
      var $22=(($21+8)|0);
      var $23=HEAPF32[(($22)>>2)];
      var $24=$23;
      var $25=_floor($24);
      var $26=(($25)|0);
      $boundsx1=$26;
      var $27=$3;
      var $28=(($27+4)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29;
      var $31=_ceil($30);
      var $32=(($31)|0);
      $boundsy0=$32;
      var $33=$3;
      var $34=(($33+12)|0);
      var $35=HEAPF32[(($34)>>2)];
      var $36=$35;
      var $37=_floor($36);
      var $38=(($37)|0);
      $boundsy1=$38;
      $y1=0;
      __label__ = 1; break;
    case 1: // $39
      var $40=$ext;
      var $41=$last;
      var $42=(($40)>>>0) < (($41)>>>0);
      if ($42) { __label__ = 2; break; } else { __label__ = 45; break; }
    case 2: // $43
      __label__ = 3; break;
    case 3: // $44
      __label__ = 4; break;
    case 4: // $45
      var $46=$y1;
      $y0=$46;
      var $47=$y0;
      var $48=$ext;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($47-$50)|0);
      $y1=$51;
      var $52=$boundsy0;
      var $53=$y1;
      var $54=(($52)|0) < (($53)|0);
      if ($54) { __label__ = 5; break; } else { __label__ = 44; break; }
    case 5: // $55
      var $56=$boundsy1;
      var $57=$y0;
      var $58=(($56)|0) > (($57)|0);
      if ($58) { __label__ = 6; break; } else { __label__ = 44; break; }
    case 6: // $59
      $x1=0;
      var $60=$y0;
      var $61=$boundsy0;
      var $62=(($60)|0) < (($61)|0);
      if ($62) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $63
      var $64=$boundsy0;
      var $65=$y0;
      var $66=(($64-$65)|0);
      $diff=$66;
      var $67=$ext;
      var $68=(($67+4)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+2)|0);
      var $71=$ext;
      var $72=(($71+($70<<2))|0);
      var $73=$72;
      var $74=$ext;
      var $75=(($74)|0);
      var $76=$75;
      var $77=$last;
      var $78=$ext;
      var $79=$77;
      var $80=$78;
      var $81=(($79-$80)|0);
      var $82=(((($81)|0)/4)|0);
      var $83=((($82<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32($73, $76, $83, 1, 0);
      var $84=$ext;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+2)|0);
      var $88=$last;
      var $89=(($88+($87<<2))|0);
      $last=$89;
      __label__ = 8; break;
    case 8: // $90
      var $91=$last;
      var $92=$max;
      var $93=(($91)>>>0) < (($92)>>>0);
      if ($93) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $94
      var $95=___cxa_allocate_exception(1032);
      var $96=$95;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($96, ((STRING_TABLE.__str2705)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str222727)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str22707)|0),HEAP32[((tempInt+8)>>2)]=2250,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $97
      ___cxa_throw($95, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 11: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $100=$99.f0;
      $4=$100;
      var $101=$99.f1;
      $5=$101;
      ___cxa_free_exception($95);
      __label__ = 48; break;
    case 12: // $102
      __label__ = 13; break;
    case 13: // $103
      var $104=$ext;
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(((-$106))|0);
      var $108=$diff;
      var $109=(($107-$108)|0);
      var $110=(((-$109))|0);
      var $111=$ext;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+2)|0);
      var $115=$ext;
      var $116=(($115+($114<<2))|0);
      HEAP32[(($116)>>2)]=$110;
      var $117=$diff;
      var $118=(((-$117))|0);
      var $119=$ext;
      var $120=(($119)|0);
      HEAP32[(($120)>>2)]=$118;
      var $121=$ext;
      var $122=(($121)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$y0;
      var $125=(($124-$123)|0);
      $y0=$125;
      var $126=$ext;
      var $127=(($126+4)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128+2)|0);
      var $130=$ext;
      var $131=(($130+($129<<2))|0);
      $ext=$131;
      var $132=$y0;
      var $133=$ext;
      var $134=(($133)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($132-$135)|0);
      $y1=$136;
      __label__ = 14; break;
    case 14: // $137
      var $138=$y1;
      var $139=$boundsy1;
      var $140=(($138)|0) > (($139)|0);
      if ($140) { __label__ = 15; break; } else { __label__ = 22; break; }
    case 15: // $141
      var $142=$y1;
      var $143=$boundsy1;
      var $144=(($142-$143)|0);
      $diff1=$144;
      var $145=$ext;
      var $146=(($145+4)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+2)|0);
      var $149=$ext;
      var $150=(($149+($148<<2))|0);
      var $151=$150;
      var $152=$ext;
      var $153=(($152)|0);
      var $154=$153;
      var $155=$last;
      var $156=$ext;
      var $157=$155;
      var $158=$156;
      var $159=(($157-$158)|0);
      var $160=(((($159)|0)/4)|0);
      var $161=((($160<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32($151, $154, $161, 1, 0);
      var $162=$ext;
      var $163=(($162+4)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+2)|0);
      var $166=$last;
      var $167=(($166+($165<<2))|0);
      $last=$167;
      __label__ = 16; break;
    case 16: // $168
      var $169=$last;
      var $170=$max;
      var $171=(($169)>>>0) < (($170)>>>0);
      if ($171) { __label__ = 20; break; } else { __label__ = 17; break; }
    case 17: // $172
      var $173=___cxa_allocate_exception(1032);
      var $174=$173;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($174, ((STRING_TABLE.__str2705)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str222727)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str22707)|0),HEAP32[((tempInt+8)>>2)]=2270,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $175
      ___cxa_throw($173, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 19: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $178=$177.f0;
      $4=$178;
      var $179=$177.f1;
      $5=$179;
      ___cxa_free_exception($173);
      __label__ = 48; break;
    case 20: // $180
      __label__ = 21; break;
    case 21: // $181
      var $182=$diff1;
      var $183=(((-$182))|0);
      var $184=$ext;
      var $185=(($184+4)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($186+2)|0);
      var $188=$ext;
      var $189=(($188+($187<<2))|0);
      HEAP32[(($189)>>2)]=$183;
      var $190=$ext;
      var $191=(($190)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(((-$192))|0);
      var $194=$diff1;
      var $195=(($193-$194)|0);
      var $196=(((-$195))|0);
      var $197=$ext;
      var $198=(($197)|0);
      HEAP32[(($198)>>2)]=$196;
      var $199=$y0;
      var $200=$ext;
      var $201=(($200)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($199-$202)|0);
      $y1=$203;
      __label__ = 22; break;
    case 22: // $204
      var $205=$ext;
      var $206=(($205+4)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207+2)|0);
      var $209=$ext;
      var $210=(($209+($208<<2))|0);
      $linelast=$210;
      var $211=$ext;
      var $212=(($211+8)|0);
      $xext=$212;
      __label__ = 23; break;
    case 23: // $213
      var $214=$xext;
      var $215=$linelast;
      var $216=(($214)>>>0) < (($215)>>>0);
      if ($216) { __label__ = 24; break; } else { __label__ = 43; break; }
    case 24: // $217
      var $218=$x1;
      $x0=$218;
      var $219=$x0;
      var $220=$xext;
      var $221=(($220)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($219+$222)|0);
      $x1=$223;
      var $224=$boundsx0;
      var $225=$x0;
      var $226=(($224)|0) >= (($225)|0);
      if ($226) { __label__ = 25; break; } else { __label__ = 33; break; }
    case 25: // $227
      var $228=$boundsx1;
      var $229=$x1;
      var $230=(($228)|0) <= (($229)|0);
      if ($230) { __label__ = 26; break; } else { __label__ = 33; break; }
    case 26: // $231
      var $232=$xext;
      var $233=(($232+8)|0);
      var $234=$233;
      var $235=$xext;
      var $236=(($235)|0);
      var $237=$236;
      var $238=$last;
      var $239=$xext;
      var $240=$238;
      var $241=$239;
      var $242=(($240-$241)|0);
      var $243=(((($242)|0)/4)|0);
      var $244=((($243<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32($234, $237, $244, 1, 0);
      var $245=$last;
      var $246=(($245+8)|0);
      $last=$246;
      var $247=$linelast;
      var $248=(($247+8)|0);
      $linelast=$248;
      __label__ = 27; break;
    case 27: // $249
      var $250=$last;
      var $251=$max;
      var $252=(($250)>>>0) < (($251)>>>0);
      if ($252) { __label__ = 31; break; } else { __label__ = 28; break; }
    case 28: // $253
      var $254=___cxa_allocate_exception(1032);
      var $255=$254;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($255, ((STRING_TABLE.__str2705)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str222727)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str22707)|0),HEAP32[((tempInt+8)>>2)]=2295,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $256
      ___cxa_throw($254, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 30: // $257
      var $258=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $259=$258.f0;
      $4=$259;
      var $260=$258.f1;
      $5=$260;
      ___cxa_free_exception($254);
      __label__ = 48; break;
    case 31: // $261
      __label__ = 32; break;
    case 32: // $262
      var $263=$boundsx0;
      var $264=$x0;
      var $265=(($263-$264)|0);
      var $266=$xext;
      var $267=(($266)|0);
      HEAP32[(($267)>>2)]=$265;
      var $268=$boundsx1;
      var $269=$boundsx0;
      var $270=(($268-$269)|0);
      var $271=$xext;
      var $272=(($271+4)|0);
      HEAP32[(($272)>>2)]=$270;
      var $273=$x1;
      var $274=$boundsx1;
      var $275=(($273-$274)|0);
      var $276=$xext;
      var $277=(($276+8)|0);
      HEAP32[(($277)>>2)]=$275;
      var $278=$boundsx1;
      $x1=$278;
      var $279=$xext;
      var $280=(($279+8)|0);
      $xext=$280;
      __label__ = 37; break;
    case 33: // $281
      var $282=$boundsx0;
      var $283=$x1;
      var $284=(($282)|0) < (($283)|0);
      if ($284) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $285
      var $286=$boundsx1;
      var $287=$x0;
      var $288=(($286)|0) > (($287)|0);
      if ($288) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $289
      __label__ = 46; break;
    case 36: // $290
      __label__ = 37; break;
    case 37: // $291
      var $292=$xext;
      var $293=(($292+4)|0);
      $xext=$293;
      var $294=$xext;
      var $295=$linelast;
      var $296=(($294)>>>0) < (($295)>>>0);
      if ($296) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $297
      var $298=$x1;
      $x0=$298;
      var $299=$x0;
      var $300=$xext;
      var $301=(($300)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=(($299+$302)|0);
      $x1=$303;
      var $304=$boundsx0;
      var $305=$x1;
      var $306=(($304)|0) < (($305)|0);
      if ($306) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $307
      var $308=$boundsx1;
      var $309=$x0;
      var $310=(($308)|0) > (($309)|0);
      if ($310) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $311
      __label__ = 46; break;
    case 41: // $312
      var $313=$xext;
      var $314=(($313+4)|0);
      $xext=$314;
      __label__ = 42; break;
    case 42: // $315
      __label__ = 23; break;
    case 43: // $316
      var $317=$linelast;
      var $318=$ext;
      var $319=(($318+8)|0);
      var $320=$317;
      var $321=$319;
      var $322=(($320-$321)|0);
      var $323=(((($322)|0)/4)|0);
      var $324=$ext;
      var $325=(($324+4)|0);
      HEAP32[(($325)>>2)]=$323;
      __label__ = 44; break;
    case 44: // $326
      var $327=$ext;
      var $328=(($327+4)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=(($329+2)|0);
      var $331=$ext;
      var $332=(($331+($330<<2))|0);
      $ext=$332;
      __label__ = 1; break;
    case 45: // $333
      var $334=$last;
      var $335=(($6+360)|0);
      var $336=(($335)|0);
      var $337=$334;
      var $338=$336;
      var $339=(($337-$338)|0);
      var $340=(((($339)|0)/4)|0);
      var $341=(($6+356)|0);
      HEAP32[(($341)>>2)]=$340;
      $1=1;
      __label__ = 47; break;
    case 46: // $342
      var $343=$last;
      var $344=(($6+360)|0);
      var $345=(($344)|0);
      var $346=$343;
      var $347=$345;
      var $348=(($346-$347)|0);
      var $349=(((($348)|0)/4)|0);
      var $350=(($6+356)|0);
      HEAP32[(($350)>>2)]=$349;
      $1=0;
      __label__ = 47; break;
    case 47: // $351
      var $352=$1;
      ;
      return $352;
    case 48: // $353
      var $354=$4;
      var $355=$4;
      var $356=$5;
      var $357=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $355, tempValue);
      var $358=($357.f1 = $356, $357);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target19remove_clear_extentERK13render_bounds["X"]=1;

function __ZN13render_target17add_clear_extentsER21render_primitive_list($this, $list) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $clearlist=__stackBase__;
      var $last;
      var $ext;
      var $y0;
      var $y1;
      var $linelast;
      var $xext;
      var $x0;
      var $x1;
      var $prim;
      var $3;
      var $4;
      $1=$this;
      $2=$list;
      var $5=$1;
      __ZN11simple_listI16render_primitiveEC1ER13resource_pool($clearlist, _global_resource_pool);
      var $6=(($5+356)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($5+360)|0);
      var $9=(($8+($7<<2))|0);
      $last=$9;
      var $10=(($5+360)|0);
      var $11=(($10)|0);
      $ext=$11;
      $y1=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$ext;
      var $14=$last;
      var $15=(($13)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $16
      var $17=$ext;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+2)|0);
      var $21=$ext;
      var $22=(($21+($20<<2))|0);
      $linelast=$22;
      var $23=$ext;
      var $24=(($23+8)|0);
      $xext=$24;
      $x1=0;
      __label__ = 3; break;
    case 3: // $25
      __label__ = 4; break;
    case 4: // $26
      __label__ = 5; break;
    case 5: // $27
      var $28=$y1;
      $y0=$28;
      var $29=$y0;
      var $30=$ext;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($29-$32)|0);
      $y1=$33;
      __label__ = 6; break;
    case 6: // $34
      var $35=$xext;
      var $36=$linelast;
      var $37=(($35)>>>0) < (($36)>>>0);
      if ($37) { __label__ = 7; break; } else { __label__ = 15; break; }
    case 7: // $38
      var $39=$x1;
      $x0=$39;
      var $40=$x0;
      var $41=$xext;
      var $42=(($41+4)|0);
      $xext=$42;
      var $43=HEAP32[(($41)>>2)];
      var $44=(($40+$43)|0);
      $x1=$44;
      var $45=$x1;
      var $46=$x0;
      var $47=(($45-$46)|0);
      var $48=(($47)|0) > 0;
      if ($48) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $49
      var $50=$2;
      var $51=(function() { try { __THREW__ = false; return __ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE($50, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $52
      $prim=$51;
      var $53=$prim;
      var $54=(($53+4)|0);
      var $55=$x0;
      var $56=(($55)|0);
      var $57=$y0;
      var $58=(($57)|0);
      var $59=$x1;
      var $60=(($59)|0);
      var $61=$y1;
      var $62=(($61)|0);
      (function() { try { __THREW__ = false; return __ZL20set_render_bounds_xyP13render_boundsffff($54, $56, $58, $60, $62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $63
      var $64=$prim;
      var $65=(($64+20)|0);
      (function() { try { __THREW__ = false; return __ZL16set_render_colorP12render_colorffff($65, 1, 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $66
      var $67=$prim;
      var $68=(($67+44)|0);
      var $69=(($68)|0);
      HEAP32[(($69)>>2)]=0;
      var $70=$prim;
      var $71=(($70+36)|0);
      HEAP32[(($71)>>2)]=256;
      var $72=$prim;
      var $73=(function() { try { __THREW__ = false; return __ZN11simple_listI16render_primitiveE6appendERS0_($clearlist, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; };
    case 12: // $74
      __label__ = 14; break;
    case 13: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      $3=$77;
      var $78=$76.f1;
      $4=$78;
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_primitiveED1Ev($clearlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 14: // $79
      var $80=$x1;
      $x0=$80;
      var $81=$x0;
      var $82=$xext;
      var $83=(($82+4)|0);
      $xext=$83;
      var $84=HEAP32[(($82)>>2)];
      var $85=(($81+$84)|0);
      $x1=$85;
      __label__ = 6; break;
    case 15: // $86
      var $87=$ext;
      var $88=(($87+4)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+2)|0);
      var $91=$ext;
      var $92=(($91+($90<<2))|0);
      $ext=$92;
      __label__ = 1; break;
    case 16: // $93
      var $94=$2;
      var $95=(($94)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_primitiveE12prepend_listERS1_($95, $clearlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 13; break; }
    case 17: // $96
      __ZN11simple_listI16render_primitiveED1Ev($clearlist);
      STACKTOP = __stackBase__;
      return;
    case 18: // $97
      __label__ = 19; break;
    case 19: // $98
      var $99=$3;
      var $100=$3;
      var $101=$4;
      var $102=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $100, tempValue);
      var $103=($102.f1 = $101, $102);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13render_target17add_clear_extentsER21render_primitive_list["X"]=1;

function __ZNK16render_primitive4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+100)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI16render_primitiveE12prepend_listERS1_($this, $list) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $tail;
      var $head;
      $1=$this;
      $2=$list;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11simple_listI16render_primitiveE5countEv($4);
      $count=$5;
      var $6=$count;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 5; break;
    case 2: // $9
      var $10=$2;
      var $11=__ZNK11simple_listI16render_primitiveE4lastEv($10);
      $tail=$11;
      var $12=$2;
      var $13=__ZN11simple_listI16render_primitiveE10detach_allEv($12);
      $head=$13;
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$tail;
      var $17=(($16+100)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$head;
      var $19=(($3+4)|0);
      HEAP32[(($19)>>2)]=$18;
      var $20=(($3+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$tail;
      var $25=(($3+8)|0);
      HEAP32[(($25)>>2)]=$24;
      __label__ = 4; break;
    case 4: // $26
      var $27=$count;
      var $28=(($3+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$27)|0);
      HEAP32[(($28)>>2)]=$30;
      __label__ = 5; break;
    case 5: // $31
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK21render_primitive_list5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listI16render_primitiveE5firstEv($3);
  ;
  return $4;
}


function __ZN11simple_listI13render_targetEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI13render_targetEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorI14render_textureEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN15fixed_allocatorI14render_textureEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8delegateIFviP14_xml_data_nodeEEC1I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFviP14_xml_data_nodeEEC2I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN14render_manager11config_loadEiP14_xml_data_node($this, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $uinode;
      var $target;
      var $targetnode;
      var $target1;
      var $screennode;
      var $index;
      var $container;
      var $settings=__stackBase__;
      $1=$this;
      $2=$config_type;
      $3=$parentnode;
      var $4=$1;
      var $5=$2;
      var $6=(($5)|0)!=3;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __label__ = 18; break;
    case 2: // $8
      var $9=$3;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      __label__ = 18; break;
    case 4: // $12
      var $13=$3;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__Z15xml_get_siblingP14_xml_data_nodePKc($15, ((STRING_TABLE.__str272732)|0));
      $uinode=$16;
      var $17=$uinode;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $19
      var $20=$uinode;
      var $21=__Z21xml_get_attribute_intP14_xml_data_nodePKci($20, ((STRING_TABLE.__str282733)|0), 0);
      var $22=__ZNK14render_manager15target_by_indexEi($4, $21);
      $target=$22;
      var $23=$target;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $25
      var $26=$target;
      __ZN14render_manager13set_ui_targetER13render_target($4, $26);
      __label__ = 7; break;
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=$3;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__Z15xml_get_siblingP14_xml_data_nodePKc($31, ((STRING_TABLE.__str282733)|0));
      $targetnode=$32;
      __label__ = 9; break;
    case 9: // $33
      var $34=$targetnode;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $36
      var $37=$targetnode;
      var $38=__Z21xml_get_attribute_intP14_xml_data_nodePKci($37, ((STRING_TABLE.__str212726)|0), -1);
      var $39=__ZNK14render_manager15target_by_indexEi($4, $38);
      $target1=$39;
      var $40=$target1;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $42
      var $43=$target1;
      var $44=$targetnode;
      __ZN13render_target11config_loadER14_xml_data_node($43, $44);
      __label__ = 12; break;
    case 12: // $45
      __label__ = 13; break;
    case 13: // $46
      var $47=$targetnode;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=__Z15xml_get_siblingP14_xml_data_nodePKc($49, ((STRING_TABLE.__str282733)|0));
      $targetnode=$50;
      __label__ = 9; break;
    case 14: // $51
      var $52=$3;
      var $53=(($52+8)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=__Z15xml_get_siblingP14_xml_data_nodePKc($54, ((STRING_TABLE.__str292734)|0));
      $screennode=$55;
      __label__ = 15; break;
    case 15: // $56
      var $57=$screennode;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $59
      var $60=$screennode;
      var $61=__Z21xml_get_attribute_intP14_xml_data_nodePKci($60, ((STRING_TABLE.__str212726)|0), -1);
      $index=$61;
      var $62=(($4+56)|0);
      var $63=$index;
      var $64=__ZNK11simple_listI16render_containerE4findEi($62, $63);
      $container=$64;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $65=$container;
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($65, $settings);
      var $66=$screennode;
      var $67=(($settings+4)|0);
      var $68=HEAPF32[(($67)>>2)];
      var $69=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($66, ((STRING_TABLE.__str302735)|0), $68);
      var $70=(($settings+4)|0);
      HEAPF32[(($70)>>2)]=$69;
      var $71=$screennode;
      var $72=(($settings+8)|0);
      var $73=HEAPF32[(($72)>>2)];
      var $74=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($71, ((STRING_TABLE.__str312736)|0), $73);
      var $75=(($settings+8)|0);
      HEAPF32[(($75)>>2)]=$74;
      var $76=$screennode;
      var $77=(($settings+12)|0);
      var $78=HEAPF32[(($77)>>2)];
      var $79=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($76, ((STRING_TABLE.__str322737)|0), $78);
      var $80=(($settings+12)|0);
      HEAPF32[(($80)>>2)]=$79;
      var $81=$screennode;
      var $82=(($settings+24)|0);
      var $83=HEAPF32[(($82)>>2)];
      var $84=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($81, ((STRING_TABLE.__str332738)|0), $83);
      var $85=(($settings+24)|0);
      HEAPF32[(($85)>>2)]=$84;
      var $86=$screennode;
      var $87=(($settings+16)|0);
      var $88=HEAPF32[(($87)>>2)];
      var $89=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($86, ((STRING_TABLE.__str342739)|0), $88);
      var $90=(($settings+16)|0);
      HEAPF32[(($90)>>2)]=$89;
      var $91=$screennode;
      var $92=(($settings+28)|0);
      var $93=HEAPF32[(($92)>>2)];
      var $94=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($91, ((STRING_TABLE.__str352740)|0), $93);
      var $95=(($settings+28)|0);
      HEAPF32[(($95)>>2)]=$94;
      var $96=$screennode;
      var $97=(($settings+20)|0);
      var $98=HEAPF32[(($97)>>2)];
      var $99=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($96, ((STRING_TABLE.__str362741)|0), $98);
      var $100=(($settings+20)|0);
      HEAPF32[(($100)>>2)]=$99;
      var $101=$container;
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($101, $settings);
      __label__ = 17; break;
    case 17: // $102
      var $103=$screennode;
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=__Z15xml_get_siblingP14_xml_data_nodePKc($105, ((STRING_TABLE.__str292734)|0));
      $screennode=$106;
      __label__ = 15; break;
    case 18: // $107
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_manager11config_loadEiP14_xml_data_node["X"]=1;

function __ZN14render_managerC2ER15running_machine($this, $machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13=__stackBase__+36;
      var $14=__stackBase__+60;
      var $15=__stackBase__+68;
      var $16=__stackBase__+92;
      var $screen;
      $9=$this;
      $10=$machine;
      var $17=$9;
      var $18=(($17)|0);
      var $19=$10;
      HEAP32[(($18)>>2)]=$19;
      var $20=(($17+4)|0);
      var $21=$10;
      var $22=__ZN15running_machine7respoolEv($21);
      __ZN11simple_listI13render_targetEC1ER13resource_pool($20, $22);
      var $23=(($17+24)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=(($17+28)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($17+32)|0);
      var $26=$10;
      var $27=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 27; break; };
    case 1: // $28
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI14render_textureEC1ER13resource_pool($25, $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 27; break; }
    case 2: // $29
      var $30=(($17+52)|0);
      var $31=$10;
      var $32=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 28; break; };
    case 3: // $33
      var $34=$4;
      var $35=$5;
      var $36=$6;
      var $37=$result_i;
      var $38=$7;
      var $39=$8;
      HEAP32[(($4)>>2)]=266848;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=2477;
      var $40=HEAP32[(($4)>>2)];
      var $41=HEAP32[(($5)>>2)];
      var $42=HEAP32[(($6)>>2)];
      var $43=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40, $41, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $44
      HEAP32[(($result_i)>>2)]=$43;
      var $45=HEAP32[(($result_i)>>2)];
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $47
      var $48=___cxa_allocate_exception(4);
      var $49=$48;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($49);
      (function() { try { __THREW__ = false; return ___cxa_throw($48, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; }
    case 6: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      HEAP32[(($7)>>2)]=$52;
      var $53=$51.f1;
      HEAP32[(($8)>>2)]=$53;
      var $54=HEAP32[(($8)>>2)];
      var $55=(($54)|0) < 0;
      if ($55) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $56
      var $57=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 28; break; }
    case 8: // $_noexc
      throw "Reached an unreachable!"
    case 9: // $58
      var $59=HEAP32[(($7)>>2)];
      var $60=HEAP32[(($7)>>2)];
      var $61=HEAP32[(($8)>>2)];
      var $62=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $60, tempValue);
      var $63=($62.f1 = $61, $62);
      var $eh_lpad_body = $63;__label__ = 29; break;
    case 10: // $64
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKci_exit
      var $65=HEAP32[(($result_i)>>2)];
      var $66=$4;
      var $67=$5;
      var $68=$6;
      var $69=$result_i;
      var $70=$7;
      var $71=$8;
      __label__ = 12; break;
    case 12: // $72
      var $73=$65;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16render_containerC1ER14render_managerP13screen_device]($73, $17, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 30; break; }
    case 13: // $74
      var $75=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI16render_containerEEPT_S3_($32, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 28; break; };
    case 14: // $76
      HEAP32[(($30)>>2)]=$75;
      var $77=(($17+56)|0);
      var $78=$10;
      var $79=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 28; break; };
    case 15: // $80
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerEC1ER13resource_pool($77, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 28; break; }
    case 16: // $81
      var $82=$10;
      HEAP32[(($14)>>2)]={ f0: 236, f1: 0 }.f0; HEAP32[(($14+4)>>2)]={ f0: 236, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFviP14_xml_data_nodeEEC1I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($13, $14, ((STRING_TABLE.__str252730)|0), $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 35; break; }
    case 17: // $83
      HEAP32[(($16)>>2)]={ f0: 238, f1: 0 }.f0; HEAP32[(($16+4)>>2)]={ f0: 238, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFviP14_xml_data_nodeEEC1I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($15, $16, ((STRING_TABLE.__str262731)|0), $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 35; break; }
    case 18: // $84
      (function() { try { __THREW__ = false; return __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($82, ((STRING_TABLE.__str242729)|0), $13, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 35; break; }
    case 19: // $85
      var $86=$10;
      var $87=(function() { try { __THREW__ = false; return __ZNK15running_machine12first_screenEv($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 35; break; };
    case 20: // $88
      $screen=$87;
      __label__ = 21; break;
    case 21: // $89
      var $90=$screen;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 22; break; } else { __label__ = 36; break; }
    case 22: // $92
      var $93=$screen;
      var $94=$screen;
      var $95=(function() { try { __THREW__ = false; return __ZN14render_manager15container_allocEP13screen_device($17, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 35; break; };
    case 23: // $96
      (function() { try { __THREW__ = false; return __ZN13screen_device13set_containerER16render_container($93, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 35; break; }
    case 24: // $97
      __label__ = 25; break;
    case 25: // $98
      var $99=$screen;
      var $100=(function() { try { __THREW__ = false; return __ZNK13screen_device11next_screenEv($99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 35; break; };
    case 26: // $101
      $screen=$100;
      __label__ = 21; break;
    case 27: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $11=$104;
      var $105=$103.f1;
      $12=$105;
      __label__ = 40; break;
    case 28: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $107;__label__ = 29; break;
    case 29: // $_body
      var $eh_lpad_body;
      var $108=$eh_lpad_body.f0;
      $11=$108;
      var $109=$eh_lpad_body.f1;
      $12=$109;
      __label__ = 38; break;
    case 30: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $112=$111.f0;
      $11=$112;
      var $113=$111.f1;
      $12=$113;
      var $114=$1;
      var $115=$2;
      var $116=$3;
      HEAP32[(($1)>>2)]=$65;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=2477;
      var $117=HEAP32[(($1)>>2)];
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $119
      var $120=HEAP32[(($1)>>2)];
      var $121=HEAP32[(($2)>>2)];
      var $122=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($120, $121, $122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 43; break; }
    case 32: // $_noexc1
      __label__ = 33; break;
    case 33: // $_ZdlPvPKci_exit
      var $123=$1;
      var $124=$2;
      var $125=$3;
      __label__ = 34; break;
    case 34: // $126
      __label__ = 38; break;
    case 35: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      $11=$129;
      var $130=$128.f1;
      $12=$130;
      var $131=(($17+56)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 43; break; }
    case 36: // $132
      STACKTOP = __stackBase__;
      return;
    case 37: // $133
      __label__ = 38; break;
    case 38: // $134
      var $135=(($17+32)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI14render_textureED1Ev($135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 43; break; }
    case 39: // $136
      __label__ = 40; break;
    case 40: // $137
      var $138=(($17+4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI13render_targetED1Ev($138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $139
      __label__ = 42; break;
    case 42: // $140
      var $141=$11;
      var $142=$11;
      var $143=$12;
      var $144=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $142, tempValue);
      var $145=($144.f1 = $143, $144);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $146
      var $147=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_managerC2ER15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI16render_containerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16render_containerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16render_containerEEPT_S3_["X"]=1;

function __ZN13screen_device13set_containerER16render_container($this, $container) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$container;
  var $3=$1;
  var $4=$2;
  var $5=(($3+408)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZNK11simple_listI13render_targetE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13render_target4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13render_target15max_update_rateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+304)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI13render_targetE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_manager11config_saveEiP14_xml_data_node($this, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $uinode;
      var $targetnum;
      var $target;
      var $targetnode;
      var $scrnum;
      var $container;
      var $screennode;
      var $changed;
      var $settings=__stackBase__;
      $1=$this;
      $2=$config_type;
      $3=$parentnode;
      var $4=$1;
      var $5=$2;
      var $6=(($5)|0)!=3;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __label__ = 37; break;
    case 2: // $8
      var $9=(($4+24)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK13render_target5indexEv($10);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $13
      var $14=$3;
      var $15=__Z13xml_add_childP14_xml_data_nodePKcS2_($14, ((STRING_TABLE.__str272732)|0), 0);
      $uinode=$15;
      var $16=$uinode;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$uinode;
      var $20=(($4+24)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=__ZNK13render_target5indexEv($21);
      var $23=__Z21xml_set_attribute_intP14_xml_data_nodePKci($19, ((STRING_TABLE.__str282733)|0), $22);
      __label__ = 5; break;
    case 5: // $24
      __label__ = 6; break;
    case 6: // $25
      $targetnum=0;
      __label__ = 7; break;
    case 7: // $26
      var $27=$targetnum;
      var $28=(($27)|0) < 1000;
      if ($28) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $29
      var $30=$targetnum;
      var $31=__ZNK14render_manager15target_by_indexEi($4, $30);
      $target=$31;
      var $32=$target;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      __label__ = 15; break;
    case 10: // $35
      var $36=$3;
      var $37=__Z13xml_add_childP14_xml_data_nodePKcS2_($36, ((STRING_TABLE.__str282733)|0), 0);
      $targetnode=$37;
      var $38=$targetnode;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $40
      var $41=$target;
      var $42=$targetnode;
      var $43=__ZN13render_target11config_saveER14_xml_data_node($41, $42);
      if ($43) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $44
      var $45=$targetnode;
      __Z15xml_delete_nodeP14_xml_data_node($45);
      __label__ = 13; break;
    case 13: // $46
      __label__ = 14; break;
    case 14: // $47
      var $48=$targetnum;
      var $49=(($48+1)|0);
      $targetnum=$49;
      __label__ = 7; break;
    case 15: // $50
      $scrnum=0;
      var $51=(($4+56)|0);
      var $52=__ZNK11simple_listI16render_containerE5firstEv($51);
      $container=$52;
      __label__ = 16; break;
    case 16: // $53
      var $54=$container;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 17; break; } else { __label__ = 37; break; }
    case 17: // $56
      var $57=$3;
      var $58=__Z13xml_add_childP14_xml_data_nodePKcS2_($57, ((STRING_TABLE.__str292734)|0), 0);
      $screennode=$58;
      var $59=$screennode;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 18; break; } else { __label__ = 35; break; }
    case 18: // $61
      $changed=0;
      var $62=$screennode;
      var $63=$scrnum;
      var $64=__Z21xml_set_attribute_intP14_xml_data_nodePKci($62, ((STRING_TABLE.__str212726)|0), $63);
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $65=$container;
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($65, $settings);
      var $66=(($settings+4)|0);
      var $67=HEAPF32[(($66)>>2)];
      var $68=__ZNK14render_manager7machineEv($4);
      var $69=__ZNK15running_machine7optionsEv($68);
      var $70=__ZNK11emu_options10brightnessEv($69);
      var $71=$67 != $70;
      if ($71) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $72
      var $73=$screennode;
      var $74=(($settings+4)|0);
      var $75=HEAPF32[(($74)>>2)];
      var $76=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($73, ((STRING_TABLE.__str302735)|0), $75);
      $changed=1;
      __label__ = 20; break;
    case 20: // $77
      var $78=(($settings+8)|0);
      var $79=HEAPF32[(($78)>>2)];
      var $80=__ZNK14render_manager7machineEv($4);
      var $81=__ZNK15running_machine7optionsEv($80);
      var $82=__ZNK11emu_options8contrastEv($81);
      var $83=$79 != $82;
      if ($83) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $84
      var $85=$screennode;
      var $86=(($settings+8)|0);
      var $87=HEAPF32[(($86)>>2)];
      var $88=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($85, ((STRING_TABLE.__str312736)|0), $87);
      $changed=1;
      __label__ = 22; break;
    case 22: // $89
      var $90=(($settings+12)|0);
      var $91=HEAPF32[(($90)>>2)];
      var $92=__ZNK14render_manager7machineEv($4);
      var $93=__ZNK15running_machine7optionsEv($92);
      var $94=__ZNK11emu_options5gammaEv($93);
      var $95=$91 != $94;
      if ($95) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $96
      var $97=$screennode;
      var $98=(($settings+12)|0);
      var $99=HEAPF32[(($98)>>2)];
      var $100=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($97, ((STRING_TABLE.__str322737)|0), $99);
      $changed=1;
      __label__ = 24; break;
    case 24: // $101
      var $102=(($settings+24)|0);
      var $103=HEAPF32[(($102)>>2)];
      var $104=$103 != 0;
      if ($104) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $105
      var $106=$screennode;
      var $107=(($settings+24)|0);
      var $108=HEAPF32[(($107)>>2)];
      var $109=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($106, ((STRING_TABLE.__str332738)|0), $108);
      $changed=1;
      __label__ = 26; break;
    case 26: // $110
      var $111=(($settings+16)|0);
      var $112=HEAPF32[(($111)>>2)];
      var $113=$112 != 1;
      if ($113) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $114
      var $115=$screennode;
      var $116=(($settings+16)|0);
      var $117=HEAPF32[(($116)>>2)];
      var $118=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($115, ((STRING_TABLE.__str342739)|0), $117);
      $changed=1;
      __label__ = 28; break;
    case 28: // $119
      var $120=(($settings+28)|0);
      var $121=HEAPF32[(($120)>>2)];
      var $122=$121 != 0;
      if ($122) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $123
      var $124=$screennode;
      var $125=(($settings+28)|0);
      var $126=HEAPF32[(($125)>>2)];
      var $127=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($124, ((STRING_TABLE.__str352740)|0), $126);
      $changed=1;
      __label__ = 30; break;
    case 30: // $128
      var $129=(($settings+20)|0);
      var $130=HEAPF32[(($129)>>2)];
      var $131=$130 != 1;
      if ($131) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $132
      var $133=$screennode;
      var $134=(($settings+20)|0);
      var $135=HEAPF32[(($134)>>2)];
      var $136=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($133, ((STRING_TABLE.__str362741)|0), $135);
      $changed=1;
      __label__ = 32; break;
    case 32: // $137
      var $138=$changed;
      var $139=(($138) & 1);
      if ($139) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $140
      var $141=$screennode;
      __Z15xml_delete_nodeP14_xml_data_node($141);
      __label__ = 34; break;
    case 34: // $142
      __label__ = 35; break;
    case 35: // $143
      __label__ = 36; break;
    case 36: // $144
      var $145=$container;
      var $146=__ZNK16render_container4nextEv($145);
      $container=$146;
      var $147=$scrnum;
      var $148=(($147+1)|0);
      $scrnum=$148;
      __label__ = 16; break;
    case 37: // $149
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_manager11config_saveEiP14_xml_data_node["X"]=1;

function __ZN15fixed_allocatorI14render_textureED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15fixed_allocatorI14render_textureED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI13render_targetED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI13render_targetED2Ev($2);
  ;
  return;
}


function __ZN14render_manager14container_freeEP16render_container($this, $container) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$container;
  var $3=$1;
  var $4=(($3+56)|0);
  var $5=$2;
  var $6=__ZN11simple_listI16render_containerE6detachERS0_($4, $5);
  var $7=__ZNK14render_manager7machineEv($3);
  var $8=__ZN15running_machine7respoolEv($7);
  var $9=$2;
  var $10=$9;
  __ZN13resource_pool6removeEPv($8, $10);
  ;
  return;
}


function __ZN11simple_listI16render_containerE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI16render_containerE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK14render_manager7is_liveER13screen_device($this, $screen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $target;
      $2=$this;
      $3=$screen;
      var $4=$2;
      var $5=(($4+4)|0);
      var $6=__ZNK11simple_listI13render_targetE5firstEv($5);
      $target=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$target;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$target;
      var $12=$target;
      var $13=__ZNK13render_target4viewEv($12);
      var $14=__ZN13render_target12view_screensEi($11, $13);
      var $15=$3;
      var $16=__ZNK18render_screen_list8containsER13screen_device($14, $15);
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      $1=1;
      __label__ = 7; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$target;
      var $21=__ZNK13render_target4nextEv($20);
      $target=$21;
      __label__ = 1; break;
    case 6: // $22
      $1=0;
      __label__ = 7; break;
    case 7: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13render_target4viewEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK13render_target10view_indexER11layout_view($2, $4);
  ;
  return $5;
}


function __ZNK14render_manager15max_update_rateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $minimum;
      var $target;
      $1=$this;
      var $2=$1;
      $minimum=0;
      var $3=(($2+4)|0);
      var $4=__ZNK11simple_listI13render_targetE5firstEv($3);
      $target=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$target;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $8
      var $9=$target;
      var $10=__ZNK13render_target15max_update_rateEv($9);
      var $11=$10 != 0;
      if ($11) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $12
      var $13=$minimum;
      var $14=$13 == 0;
      if ($14) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $15
      var $16=$target;
      var $17=__ZNK13render_target15max_update_rateEv($16);
      $minimum=$17;
      __label__ = 9; break;
    case 5: // $18
      var $19=$target;
      var $20=__ZNK13render_target15max_update_rateEv($19);
      var $21=$minimum;
      var $22=$20 < $21;
      if ($22) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $23
      var $24=$target;
      var $25=__ZNK13render_target15max_update_rateEv($24);
      var $29 = $25;__label__ = 8; break;
    case 7: // $26
      var $27=$minimum;
      var $29 = $27;__label__ = 8; break;
    case 8: // $28
      var $29;
      $minimum=$29;
      __label__ = 9; break;
    case 9: // $30
      __label__ = 10; break;
    case 10: // $31
      __label__ = 11; break;
    case 11: // $32
      var $33=$target;
      var $34=__ZNK13render_target4nextEv($33);
      $target=$34;
      __label__ = 1; break;
    case 12: // $35
      var $36=$minimum;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_manager11target_freeEP13render_target($this, $target) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$target;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($3+4)|0);
      var $8=$2;
      __ZN11simple_listI13render_targetE6removeERS0_($7, $8);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI13render_targetE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI13render_targetE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN14render_managerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+52)|0);
      var $6=HEAP32[(($5)>>2)];
      (function() { try { __THREW__ = false; return __ZN14render_manager14container_freeEP16render_container($4, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $7
      var $8=(($4+56)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerE5resetEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      __label__ = 4; break;
    case 4: // $11
      __label__ = 5; break;
    case 5: // $12
      var $13=(($4+56)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $14
      var $15=(($4+32)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI14render_textureED1Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $16
      var $17=(($4+4)|0);
      __ZN11simple_listI13render_targetED1Ev($17);
      ;
      return;
    case 8: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $2=$20;
      var $21=$19.f1;
      $3=$21;
      var $22=(($4+56)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 9: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $2=$25;
      var $26=$24.f1;
      $3=$26;
      __label__ = 12; break;
    case 10: // $27
      __label__ = 12; break;
    case 11: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $2=$30;
      var $31=$29.f1;
      $3=$31;
      __label__ = 14; break;
    case 12: // $32
      var $33=(($4+32)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI14render_textureED1Ev($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $34
      __label__ = 14; break;
    case 14: // $35
      var $36=(($4+4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI13render_targetED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $37
      __label__ = 16; break;
    case 16: // $38
      var $39=$2;
      var $40=$2;
      var $41=$3;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_managerD2Ev["X"]=1;

function __ZN14render_manager12target_allocEPKcj($this, $layoutfile, $flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      $9=$this;
      $10=$layoutfile;
      $11=$flags;
      var $14=$9;
      var $15=(($14+4)|0);
      var $16=__ZNK14render_manager7machineEv($14);
      var $17=__ZN15running_machine7respoolEv($16);
      var $18=$4;
      var $19=$5;
      var $20=$6;
      var $21=$result_i;
      var $22=$7;
      var $23=$8;
      HEAP32[(($4)>>2)]=4360;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=2546;
      var $24=HEAP32[(($4)>>2)];
      var $25=HEAP32[(($5)>>2)];
      var $26=HEAP32[(($6)>>2)];
      var $27=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $28
      HEAP32[(($result_i)>>2)]=$27;
      var $29=HEAP32[(($result_i)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $31
      var $32=___cxa_allocate_exception(4);
      var $33=$32;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33);
      (function() { try { __THREW__ = false; return ___cxa_throw($32, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      HEAP32[(($7)>>2)]=$36;
      var $37=$35.f1;
      HEAP32[(($8)>>2)]=$37;
      var $38=HEAP32[(($8)>>2)];
      var $39=(($38)|0) < 0;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($41);
      throw "Reached an unreachable!"
    case 5: // $42
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($8)>>2)];
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $48
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $49=HEAP32[(($result_i)>>2)];
      var $50=$4;
      var $51=$5;
      var $52=$6;
      var $53=$result_i;
      var $54=$7;
      var $55=$8;
      var $56=$49;
      var $57=$10;
      var $58=$11;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13render_targetC1ER14render_managerPKcj]($56, $14, $57, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $59
      var $60=__ZN13resource_pool10add_objectI13render_targetEEPT_S3_($17, $56);
      var $61=__ZN11simple_listI13render_targetE6appendERS0_($15, $60);
      STACKTOP = __stackBase__;
      return $61;
    case 9: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $12=$64;
      var $65=$63.f1;
      $13=$65;
      var $66=$1;
      var $67=$2;
      var $68=$3;
      HEAP32[(($1)>>2)]=$49;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=2546;
      var $69=HEAP32[(($1)>>2)];
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $71
      var $72=HEAP32[(($1)>>2)];
      var $73=HEAP32[(($2)>>2)];
      var $74=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($72, $73, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $75=$1;
      var $76=$2;
      var $77=$3;
      __label__ = 13; break;
    case 13: // $78
      __label__ = 14; break;
    case 14: // $79
      var $80=$12;
      var $81=$12;
      var $82=$13;
      var $83=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $81, tempValue);
      var $84=($83.f1 = $82, $83);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_manager12target_allocEPKcj["X"]=1;

function __ZN13resource_pool10add_objectI13render_targetEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13render_targetEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13render_targetEEPT_S3_["X"]=1;

function __ZNK13render_target6heightEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+280)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13render_target5widthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+276)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13render_target12pixel_aspectEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+300)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI16render_containerE4findEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$3;
      var $12=(($11-1)|0);
      $3=$12;
      var $13=(($11)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$cur;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$cur;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $cur=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI14render_textureE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI14render_textureE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI14render_textureE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK14render_manager15target_by_indexEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $target;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=(($4+4)|0);
      var $6=__ZNK11simple_listI13render_targetE5firstEv($5);
      $target=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$target;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $10
      var $11=$target;
      var $12=__ZNK13render_target6hiddenEv($11);
      if ($12) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$3;
      var $15=(($14-1)|0);
      $3=$15;
      var $16=(($14)|0)==0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$target;
      $1=$18;
      __label__ = 9; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      __label__ = 7; break;
    case 7: // $21
      var $22=$target;
      var $23=__ZNK13render_target4nextEv($22);
      $target=$23;
      __label__ = 1; break;
    case 8: // $24
      $1=0;
      __label__ = 9; break;
    case 9: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_manager9ui_aspectEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $orient;
      var $aspect;
      $2=$this;
      var $3=$2;
      var $4=(($3+24)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK13render_target11orientationEv($5);
      var $7=(($3+52)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK16render_container11orientationEv($8);
      var $10=__ZL15orientation_addii($6, $9);
      $orient=$10;
      var $11=$orient;
      var $12=$11 & 4;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      var $15=(($3+24)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNK13render_target6heightEv($16);
      var $18=(($17)>>>0);
      var $19=(($3+24)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZNK13render_target5widthEv($20);
      var $22=(($21)>>>0);
      var $23=$18/$22;
      $aspect=$23;
      __label__ = 3; break;
    case 2: // $24
      var $25=(($3+24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK13render_target5widthEv($26);
      var $28=(($27)>>>0);
      var $29=(($3+24)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZNK13render_target6heightEv($30);
      var $32=(($31)>>>0);
      var $33=$28/$32;
      $aspect=$33;
      __label__ = 3; break;
    case 3: // $34
      var $35=(($3+24)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=__ZNK13render_target12pixel_aspectEv($36);
      var $38=$37 != 0;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=$aspect;
      var $41=(($3+24)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__ZNK13render_target12pixel_aspectEv($42);
      var $44=$40/$43;
      $1=$44;
      __label__ = 10; break;
    case 5: // $45
      var $46=$aspect;
      var $47=$46 < 0.6600000262260437;
      if ($47) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $48
      $aspect=0.6600000262260437;
      __label__ = 7; break;
    case 7: // $49
      var $50=$aspect;
      var $51=$50 > 1.5;
      if ($51) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $52
      $aspect=1.5;
      __label__ = 9; break;
    case 9: // $53
      var $54=$aspect;
      $1=$54;
      __label__ = 10; break;
    case 10: // $55
      var $56=$1;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_manager9ui_aspectEv["X"]=1;

function __ZN15fixed_allocatorI14render_textureE7reclaimEPS0_($this, $item) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$item;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($3)|0);
      var $8=$2;
      var $9=__ZN11simple_listI14render_textureE6appendERS0_($7, $8);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14render_manager9font_freeEP11render_font($this, $font) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$font;
  var $3=$1;
  var $4=__ZNK14render_manager7machineEv($3);
  var $5=__ZN15running_machine7respoolEv($4);
  var $6=$2;
  var $7=$6;
  __ZN13resource_pool6removeEPv($5, $7);
  ;
  return;
}


function __ZN20resource_pool_objectI11render_fontEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11render_fontEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11render_fontEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1064);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11render_fontE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11render_fontED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11render_fontED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorI14render_textureE5allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $result;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=(($10)|0);
      var $12=__ZN11simple_listI14render_textureE11detach_headEv($11);
      $result=$12;
      var $13=$result;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $15
      var $16=(($10)|0);
      var $17=__ZNK11simple_listI14render_textureE4poolEv($16);
      var $18=$4;
      var $19=$result_i;
      var $20=$5;
      var $21=$6;
      HEAP32[(($4)>>2)]=120;
      var $22=HEAP32[(($4)>>2)];
      var $23=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $24
      HEAP32[(($result_i)>>2)]=$23;
      var $25=HEAP32[(($result_i)>>2)];
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $27
      var $28=___cxa_allocate_exception(4);
      var $29=$28;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29);
      (function() { try { __THREW__ = false; return ___cxa_throw($28, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      HEAP32[(($5)>>2)]=$32;
      var $33=$31.f1;
      HEAP32[(($6)>>2)]=$33;
      var $34=HEAP32[(($6)>>2)];
      var $35=(($34)|0) < 0;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      var $37=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($37);
      throw "Reached an unreachable!"
    case 6: // $38
      var $39=HEAP32[(($5)>>2)];
      var $40=HEAP32[(($5)>>2)];
      var $41=HEAP32[(($6)>>2)];
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $44
      throw "Reached an unreachable!"
    case 8: // $_Znwj_exit
      var $45=HEAP32[(($result_i)>>2)];
      var $46=$4;
      var $47=$result_i;
      var $48=$5;
      var $49=$6;
      var $50=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14render_textureC1Ev]($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $51
      var $52=__ZN13resource_pool10add_objectI14render_textureEEPT_S3_($17, $50);
      $result=$52;
      __label__ = 15; break;
    case 10: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $8=$55;
      var $56=$54.f1;
      $9=$56;
      var $57=$1;
      var $58=$2;
      var $59=$3;
      HEAP32[(($1)>>2)]=$45;
      var $60=HEAP32[(($1)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $62
      var $63=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($63, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      __label__ = 14; break;
    case 13: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      HEAP32[(($2)>>2)]=$67;
      var $68=$66.f1;
      HEAP32[(($3)>>2)]=$68;
      var $69=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($69);
      throw "Reached an unreachable!"
    case 14: // $_ZdlPv_exit
      var $70=$1;
      var $71=$2;
      var $72=$3;
      __label__ = 16; break;
    case 15: // $73
      var $74=$result;
      STACKTOP = __stackBase__;
      return $74;
    case 16: // $75
      var $76=$8;
      var $77=$8;
      var $78=$9;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15fixed_allocatorI14render_textureE5allocEv["X"]=1;

function __ZN14render_manager10font_allocEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      $9=$this;
      $10=$filename;
      var $13=$9;
      var $14=__ZNK14render_manager7machineEv($13);
      var $15=__ZN15running_machine7respoolEv($14);
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=1064;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($6)>>2)]=2640;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$10;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11render_fontC1ER14render_managerPKc]($54, $13, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $56
      var $57=__ZN13resource_pool10add_objectI11render_fontEEPT_S3_($15, $54);
      STACKTOP = __stackBase__;
      return $57;
    case 9: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $60=$59.f0;
      $11=$60;
      var $61=$59.f1;
      $12=$61;
      var $62=$1;
      var $63=$2;
      var $64=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str22707)|0);
      HEAP32[(($3)>>2)]=2640;
      var $65=HEAP32[(($1)>>2)];
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $67
      var $68=HEAP32[(($1)>>2)];
      var $69=HEAP32[(($2)>>2)];
      var $70=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($68, $69, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $71=$1;
      var $72=$2;
      var $73=$3;
      __label__ = 13; break;
    case 13: // $74
      __label__ = 14; break;
    case 14: // $75
      var $76=$11;
      var $77=$11;
      var $78=$12;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14render_manager10font_allocEPKc["X"]=1;

function __ZN13resource_pool10add_objectI11render_fontEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11render_fontEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11render_fontEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI11render_fontED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11render_fontED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11render_fontED0Ev["X"]=1;

function __ZN20resource_pool_objectI11render_fontED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI11render_fontE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM14render_managerFviP14_xml_data_nodeEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI13render_targetE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI13render_targetE6detachERS0_["X"]=1;

function __ZN20resource_pool_objectI14render_textureEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14render_textureEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14render_textureEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 120);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14render_textureE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14render_textureED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14render_textureED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI13render_targetEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13render_targetEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13render_targetEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 4360);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13render_targetE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13render_targetED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13render_targetED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFviP14_xml_data_nodeEEC2I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I14render_managerEEN15delegate_traitsIT_viS1_S2_S2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I14render_managerEEN15delegate_traitsIT_viS1_S2_S2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM14render_managerFviP14_xml_data_nodeEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=240;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM14render_managerFviP14_xml_data_nodeEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM14render_managerFviP14_xml_data_nodeEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI14render_managerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI14render_manager, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI13render_targetED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI13render_targetE+8)|0);
  __ZN11simple_listI13render_targetE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI13render_targetE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI13render_targetE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI14render_textureEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14render_textureEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14render_textureEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI14render_textureED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14render_textureED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14render_textureED0Ev["X"]=1;

function __ZN20resource_pool_objectI14render_textureED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI14render_textureE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14render_textureD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14render_textureED2Ev["X"]=1;

function __ZN20resource_pool_objectI13render_targetED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13render_targetED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13render_targetED0Ev["X"]=1;

function __ZN20resource_pool_objectI13render_targetED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI13render_targetE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13render_targetD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13render_targetED2Ev["X"]=1;

function __ZN11simple_listI14render_textureEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI14render_textureE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI14render_textureE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI14render_textureE6detachERS0_["X"]=1;

function __ZN11simple_listI13render_targetEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI13render_targetE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11simple_listI16render_primitiveE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI16render_primitiveE4lastEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI16render_primitiveE10detach_allEv($this) {
  ;
  var __label__;

  var $1;
  var $result;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  $result=$4;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$result;
  ;
  return $8;
}


function __ZNK11simple_listI8device_tE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectI16render_containerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16render_containerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16render_containerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 266848);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16render_containerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16render_containerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16render_containerED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorI14render_textureEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listI14render_textureEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN11simple_listI14render_textureEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI14render_textureEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI14render_textureED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI14render_textureED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI14render_textureED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI14render_textureE+8)|0);
  __ZN11simple_listI14render_textureE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI14render_textureE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI14render_textureE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI14render_textureE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI14render_textureE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectI11layout_fileEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11layout_fileEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11layout_fileEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 48);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11layout_fileE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11layout_fileED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11layout_fileED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI16render_containerED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI16render_containerE+8)|0);
  __ZN11simple_listI16render_containerE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI13render_targetED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI13render_targetED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI13render_targetED0Ev["X"]=1;

function __ZN20resource_pool_objectI16render_containerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16render_containerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16render_containerED0Ev["X"]=1;

function __ZN20resource_pool_objectI16render_containerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI16render_containerE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16render_containerD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16render_containerED2Ev["X"]=1;

function __ZN11simple_listI14render_textureED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI14render_textureED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI14render_textureED0Ev["X"]=1;

function __ZN20resource_pool_objectI11layout_fileED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11layout_fileED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11layout_fileED0Ev["X"]=1;

function __ZN20resource_pool_objectI11layout_fileED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI11layout_fileE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16render_containerEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI16render_containerE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI11layout_fileEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI11layout_fileE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI11layout_fileE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11layout_fileE6detachERS0_["X"]=1;

function __ZN11simple_listIN16render_container4itemEE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN16render_container4itemEE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectI11simple_listI11layout_fileEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11simple_listI11layout_fileEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11simple_listI11layout_fileEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 20);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11simple_listI11layout_fileEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11simple_listI11layout_fileEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11simple_listI11layout_fileEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI11layout_fileED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI11layout_fileED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI11layout_fileED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI11layout_fileE+8)|0);
  __ZN11simple_listI11layout_fileE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI11layout_fileE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI11layout_fileE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11layout_fileE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI11layout_fileE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN16render_container4itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN16render_container4itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN16render_container4itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 56);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN16render_container4itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN16render_container4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN16render_container4itemEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI16render_containerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_containerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI16render_containerED0Ev["X"]=1;

function __ZN20resource_pool_objectI11simple_listI11layout_fileEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11simple_listI11layout_fileEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11simple_listI11layout_fileEED0Ev["X"]=1;

function __ZN20resource_pool_objectI11simple_listI11layout_fileEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI11simple_listI11layout_fileEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11layout_fileED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI11layout_fileED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11layout_fileED0Ev["X"]=1;

function __ZN13resource_pool10add_objectIN16render_container4itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16render_container4itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN16render_container4itemEEEPT_S4_["X"]=1;

function __ZN20resource_pool_objectIN16render_container4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16render_container4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN16render_container4itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN16render_container4itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN16render_container4itemEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16render_container4itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN16render_container4itemEE6detachERS1_["X"]=1;

function __ZN11simple_listIN16render_container4itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN16render_container4itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11simple_listIN21render_primitive_list9referenceEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN21render_primitive_list9referenceEE4lastEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN21render_primitive_list9referenceEE10detach_allEv($this) {
  ;
  var __label__;

  var $1;
  var $result;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  $result=$4;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$result;
  ;
  return $8;
}


function __ZN11simple_listIN21render_primitive_list9referenceEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN21render_primitive_list9referenceEE6detachERS1_["X"]=1;

function __ZN11simple_listIN16render_container4itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN16render_container4itemEE+8)|0);
  __ZN11simple_listIN16render_container4itemEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN16render_container4itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN16render_container4itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16render_container4itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN16render_container4itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN15fixed_allocatorIN16render_container4itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listIN16render_container4itemEEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN19resource_pool_arrayIjEC1EPji($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIjEC2EPji($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIjEC2EPji($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<2))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIjE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIjED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIjED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN21render_primitive_list9referenceEE11append_listERS2_($this, $list) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $tail;
      var $head;
      $1=$this;
      $2=$list;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11simple_listIN21render_primitive_list9referenceEE5countEv($4);
      $count=$5;
      var $6=$count;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 6; break;
    case 2: // $9
      var $10=$2;
      var $11=__ZNK11simple_listIN21render_primitive_list9referenceEE4lastEv($10);
      $tail=$11;
      var $12=$2;
      var $13=__ZN11simple_listIN21render_primitive_list9referenceEE10detach_allEv($12);
      $head=$13;
      var $14=(($3+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$head;
      var $19=(($3+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=$18;
      __label__ = 5; break;
    case 4: // $22
      var $23=$head;
      var $24=(($3+4)|0);
      HEAP32[(($24)>>2)]=$23;
      __label__ = 5; break;
    case 5: // $25
      var $26=$tail;
      var $27=(($3+8)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=$count;
      var $29=(($3+16)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+$28)|0);
      HEAP32[(($29)>>2)]=$31;
      __label__ = 6; break;
    case 6: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16render_primitiveE11append_listERS1_($this, $list) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $tail;
      var $head;
      $1=$this;
      $2=$list;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11simple_listI16render_primitiveE5countEv($4);
      $count=$5;
      var $6=$count;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 6; break;
    case 2: // $9
      var $10=$2;
      var $11=__ZNK11simple_listI16render_primitiveE4lastEv($10);
      $tail=$11;
      var $12=$2;
      var $13=__ZN11simple_listI16render_primitiveE10detach_allEv($12);
      $head=$13;
      var $14=(($3+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$head;
      var $19=(($3+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+100)|0);
      HEAP32[(($21)>>2)]=$18;
      __label__ = 5; break;
    case 4: // $22
      var $23=$head;
      var $24=(($3+4)|0);
      HEAP32[(($24)>>2)]=$23;
      __label__ = 5; break;
    case 5: // $25
      var $26=$tail;
      var $27=(($3+8)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=$count;
      var $29=(($3+16)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+$28)|0);
      HEAP32[(($29)>>2)]=$31;
      __label__ = 6; break;
    case 6: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN21render_primitive_list9referenceEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN21render_primitive_list9referenceEE+8)|0);
  __ZN11simple_listIN21render_primitive_list9referenceEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN21render_primitive_list9referenceEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN21render_primitive_list9referenceEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN21render_primitive_list9referenceEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN21render_primitive_list9referenceEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI16render_primitiveED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI16render_primitiveE+8)|0);
  __ZN11simple_listI16render_primitiveE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI16render_primitiveE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI16render_primitiveE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16render_container4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16render_container4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN16render_container4itemEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIjED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIjED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIjED0Ev["X"]=1;

function __ZN19resource_pool_arrayIjED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIjE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN21render_primitive_list9referenceEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN21render_primitive_list9referenceEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN21render_primitive_list9referenceEED0Ev["X"]=1;

function __ZL22orientation_swap_flipsi($orientation) {
  ;
  var __label__;

  var $1;
  $1=$orientation;
  var $2=$1;
  var $3=$2 & 4;
  var $4=$1;
  var $5=$4 & 1;
  var $6=(($5)|0)!=0;
  var $7=$6 ? 2 : 0;
  var $8=$3 | $7;
  var $9=$1;
  var $10=$9 & 2;
  var $11=(($10)|0)!=0;
  var $12=$11 ? 1 : 0;
  var $13=$8 | $12;
  ;
  return $13;
}


function __ZN11simple_listI16render_primitiveE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+100)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+100)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+100)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+100)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI16render_primitiveE6detachERS0_["X"]=1;

function __ZN11simple_listIN21render_primitive_list9referenceEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN21render_primitive_list9referenceEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI16render_primitiveEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI16render_primitiveE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11simple_listI16render_primitiveE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN11layout_view4itemEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI11layout_viewE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN16render_container4itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI16render_primitiveE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8+100)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI16render_primitiveE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN18render_screen_list4itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN18render_screen_list4itemEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN19render_layer_configC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP8[($3)]=95;
  ;
  return;
}


function __ZNK11simple_listIN16render_container4itemEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN16render_container4itemEE4lastEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN16render_container4itemEE10detach_allEv($this) {
  ;
  var __label__;

  var $1;
  var $result;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  $result=$4;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$result;
  ;
  return $8;
}


function __ZNK11simple_listIN21render_primitive_list9referenceEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK21render_primitive_list9reference4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI16render_primitiveE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI16render_primitiveE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN15fixed_allocatorIN21render_primitive_list9referenceEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listIN21render_primitive_list9referenceEEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN15fixed_allocatorI16render_primitiveEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listI16render_primitiveEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN15fixed_allocatorI14render_textureED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listI14render_textureED1Ev($3);
  ;
  return;
}


function __ZN7astringC2EPKcS1_($this, $str1, $str2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$str1;
  $3=$str2;
  var $4=$1;
  var $5=$4;
  var $6=__ZN7astring4initEv($4);
  var $7=$2;
  var $8=__ZN7astring3cpyEPKc($6, $7);
  var $9=$3;
  var $10=__ZN7astring3catEPKc($8, $9);
  ;
  return;
}


function __ZN20resource_pool_objectI16render_primitiveEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16render_primitiveEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16render_primitiveEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 104);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16render_primitiveE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16render_primitiveED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16render_primitiveED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorIN16render_container4itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listIN16render_container4itemEED1Ev($3);
  ;
  return;
}


function __ZN15fixed_allocatorIN16render_container4itemEE11reclaim_allER11simple_listIS1_E($this, $list) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$list;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listIN16render_container4itemEE11append_listERS2_($4, $5);
  ;
  return;
}


function __ZN11simple_listIN16render_container4itemEE11append_listERS2_($this, $list) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $tail;
      var $head;
      $1=$this;
      $2=$list;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11simple_listIN16render_container4itemEE5countEv($4);
      $count=$5;
      var $6=$count;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 6; break;
    case 2: // $9
      var $10=$2;
      var $11=__ZNK11simple_listIN16render_container4itemEE4lastEv($10);
      $tail=$11;
      var $12=$2;
      var $13=__ZN11simple_listIN16render_container4itemEE10detach_allEv($12);
      $head=$13;
      var $14=(($3+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$head;
      var $19=(($3+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=$18;
      __label__ = 5; break;
    case 4: // $22
      var $23=$head;
      var $24=(($3+4)|0);
      HEAP32[(($24)>>2)]=$23;
      __label__ = 5; break;
    case 5: // $25
      var $26=$tail;
      var $27=(($3+8)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=$count;
      var $29=(($3+16)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+$28)|0);
      HEAP32[(($29)>>2)]=$31;
      __label__ = 6; break;
    case 6: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI16render_primitiveED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI16render_primitiveED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI16render_primitiveED0Ev["X"]=1;

function __ZN15fixed_allocatorI16render_primitiveE5allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $result_i=__stackBase__+4;
      var $2=__stackBase__+8;
      var $3=__stackBase__+12;
      var $4;
      var $result;
      $4=$this;
      var $5=$4;
      var $6=(($5)|0);
      var $7=__ZN11simple_listI16render_primitiveE11detach_headEv($6);
      $result=$7;
      var $8=$result;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $10
      var $11=(($5)|0);
      var $12=__ZNK11simple_listI16render_primitiveE4poolEv($11);
      var $13=$1;
      var $14=$result_i;
      var $15=$2;
      var $16=$3;
      HEAP32[(($1)>>2)]=104;
      var $17=HEAP32[(($1)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($2)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($3)>>2)]=$28;
      var $29=HEAP32[(($3)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 6: // $33
      var $34=HEAP32[(($2)>>2)];
      var $35=HEAP32[(($2)>>2)];
      var $36=HEAP32[(($3)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $39
      throw "Reached an unreachable!"
    case 8: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$1;
      var $42=$result_i;
      var $43=$2;
      var $44=$3;
      var $45=$40;
      var $46=__ZN13resource_pool10add_objectI16render_primitiveEEPT_S3_($12, $45);
      $result=$46;
      __label__ = 9; break;
    case 9: // $47
      var $48=$result;
      STACKTOP = __stackBase__;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15fixed_allocatorI16render_primitiveE5allocEv["X"]=1;

function __ZN13resource_pool10add_objectI16render_primitiveEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16render_primitiveEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16render_primitiveEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI16render_primitiveED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16render_primitiveED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16render_primitiveED0Ev["X"]=1;

function __ZN20resource_pool_objectI16render_primitiveED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI16render_primitiveE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN21render_primitive_list9referenceEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN21render_primitive_list9referenceEE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN21render_primitive_list9referenceEE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectIN21render_primitive_list9referenceEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN21render_primitive_list9referenceEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN21render_primitive_list9referenceEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN21render_primitive_list9referenceEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN21render_primitive_list9referenceEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN21render_primitive_list9referenceEED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorI16render_primitiveED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listI16render_primitiveED1Ev($3);
  ;
  return;
}


function __ZN15fixed_allocatorIN21render_primitive_list9referenceEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listIN21render_primitive_list9referenceEED1Ev($3);
  ;
  return;
}


function ___cxx_global_var_init2817() {
  ;
  var __label__;

  __ZN8attotime7from_hzEd(__ZN13screen_device20DEFAULT_FRAME_PERIODE, 60);
  ;
  return;
}


function __ZN8attotime7from_hzEd($agg_result, $frequency) {
  ;
  var __label__;

  var $1;
  $1=$frequency;
  var $2=$1;
  var $3=1000000000000000000/$2;
  var $4$0 = $3>>>0; var $4$1 = Math.min(Math.floor(($3)/4294967296), 4294967295);
  __ZN8attotimeC1Eix($agg_result, 0, $4$0, $4$1);
  ;
  return;
}


function __ZN11simple_listIN13screen_device13callback_itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN13screen_device13callback_itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorIN21render_primitive_list9referenceEE5allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $result_i=__stackBase__+4;
      var $2=__stackBase__+8;
      var $3=__stackBase__+12;
      var $4;
      var $result;
      $4=$this;
      var $5=$4;
      var $6=(($5)|0);
      var $7=__ZN11simple_listIN21render_primitive_list9referenceEE11detach_headEv($6);
      $result=$7;
      var $8=$result;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $10
      var $11=(($5)|0);
      var $12=__ZNK11simple_listIN21render_primitive_list9referenceEE4poolEv($11);
      var $13=$1;
      var $14=$result_i;
      var $15=$2;
      var $16=$3;
      HEAP32[(($1)>>2)]=8;
      var $17=HEAP32[(($1)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($2)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($3)>>2)]=$28;
      var $29=HEAP32[(($3)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 6: // $33
      var $34=HEAP32[(($2)>>2)];
      var $35=HEAP32[(($2)>>2)];
      var $36=HEAP32[(($3)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $39
      throw "Reached an unreachable!"
    case 8: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$1;
      var $42=$result_i;
      var $43=$2;
      var $44=$3;
      var $45=$40;
      var $46=__ZN13resource_pool10add_objectIN21render_primitive_list9referenceEEEPT_S4_($12, $45);
      $result=$46;
      __label__ = 9; break;
    case 9: // $47
      var $48=$result;
      STACKTOP = __stackBase__;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15fixed_allocatorIN21render_primitive_list9referenceEE5allocEv["X"]=1;

function __ZN13resource_pool10add_objectIN21render_primitive_list9referenceEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN21render_primitive_list9referenceEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN21render_primitive_list9referenceEEEPT_S4_["X"]=1;

function __ZN20resource_pool_objectIN21render_primitive_list9referenceEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN21render_primitive_list9referenceEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN21render_primitive_list9referenceEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN21render_primitive_list9referenceEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN21render_primitive_list9referenceEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14device_creatorI13screen_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=580;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str372810)|0);
      HEAP32[(($6)>>2)]=111;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13screen_deviceC1ERK14machine_configPKcP8device_tj]($53, $54, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI13screen_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str372810)|0);
      HEAP32[(($3)>>2)]=111;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14device_creatorI13screen_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN13screen_deviceC2ERK14machine_configPKcP8device_tj($this, $mconfig, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$mconfig;
      $3=$tag;
      $4=$owner;
      $5=$clock;
      var $8=$1;
      var $9=$8;
      var $10=$2;
      var $11=HEAP32[((_SCREEN)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=$5;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($9, $10, $11, ((STRING_TABLE.__str2773)|0), $12, $13, $14);
      var $15=$8;
      HEAP32[(($15)>>2)]=((__ZTV13screen_device+8)|0);
      var $16=(($8+356)|0);
      HEAP32[(($16)>>2)]=1;
      var $17=(($8+360)|0);
      HEAP8[($17)]=0;
      var $18=(($8+364)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($18)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($18+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $19=(($8+372)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$36$0=(($19)|0);
      HEAP32[(($st$36$0)>>2)]=$$emscripten$temp$1$0;
      var $st$36$1=(($19+4)|0);
      HEAP32[(($st$36$1)>>2)]=$$emscripten$temp$1$1;
      var $20=(($8+380)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($8+384)|0);
      HEAPF32[(($21)>>2)]=0;
      var $22=(($8+388)|0);
      HEAPF32[(($22)>>2)]=0;
      var $23=(($8+392)|0);
      HEAPF32[(($23)>>2)]=1;
      var $24=(($8+396)|0);
      HEAPF32[(($24)>>2)]=1;
      var $25=(($8+400)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($8+404)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=(($8+408)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=(($8+412)|0);
      HEAP32[(($28)>>2)]=100;
      var $29=(($8+416)|0);
      HEAP32[(($29)>>2)]=100;
      var $30=(($8+420)|0);
      var $31=(($8+452)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($8+456)|0);
      HEAP8[($32)]=0;
      var $33=(($8+457)|0);
      HEAP8[($33)]=0;
      var $34=(($8+460)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=(($8+464)|0);
      HEAP8[($35)]=1;
      var $36=(($8+468)|0);
      HEAP32[(($36)>>2)]=0;
      var $37=(($8+472)|0);
      HEAP32[(($37)>>2)]=0;
      var $38=(($8+476)|0);
      var $39=(function() { try { __THREW__ = false; return __ZNK8attotime14as_attosecondsEv(__ZN13screen_device20DEFAULT_FRAME_PERIODE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
      var $39$0=$39[0];
      var $39$1=$39[1];
    case 1: // $40
      var $st$0$0=(($38)|0);
      HEAP32[(($st$0$0)>>2)]=$39$0;
      var $st$0$1=(($38+4)|0);
      HEAP32[(($st$0$1)>>2)]=$39$1;
      var $41=(($8+484)|0);
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $st$7$0=(($41)|0);
      HEAP32[(($st$7$0)>>2)]=$$emscripten$temp$2$0;
      var $st$7$1=(($41+4)|0);
      HEAP32[(($st$7$1)>>2)]=$$emscripten$temp$2$1;
      var $42=(($8+492)|0);
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $st$14$0=(($42)|0);
      HEAP32[(($st$14$0)>>2)]=$$emscripten$temp$3$0;
      var $st$14$1=(($42+4)|0);
      HEAP32[(($st$14$1)>>2)]=$$emscripten$temp$3$1;
      var $43=(($8+500)|0);
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $st$21$0=(($43)|0);
      HEAP32[(($st$21$0)>>2)]=$$emscripten$temp$4$0;
      var $st$21$1=(($43+4)|0);
      HEAP32[(($st$21$1)>>2)]=$$emscripten$temp$4$1;
      var $44=(($8+508)|0);
      var $45=$44;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($45)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($45+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($45+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $46=(($8+520)|0);
      var $47=$46;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $48=(($8+532)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=(($8+536)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($8+540)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=(($8+544)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=(($8+548)|0);
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $st$42$0=(($52)|0);
      HEAP32[(($st$42$0)>>2)]=$$emscripten$temp$5$0;
      var $st$42$1=(($52+4)|0);
      HEAP32[(($st$42$1)>>2)]=$$emscripten$temp$5$1;
      var $53=(($8+556)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=(($8+560)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN13screen_device13callback_itemEEC1ER13resource_pool($54, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $55
      var $56=(($8+420)|0);
      var $57=(($56+8)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=(($8+420)|0);
      var $59=(($58)|0);
      HEAP32[(($59)>>2)]=0;
      var $60=(($8+412)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61-1)|0);
      var $63=(($8+420)|0);
      var $64=(($63+4)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=(($8+416)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66-1)|0);
      var $68=(($8+420)|0);
      var $69=(($68+12)|0);
      HEAP32[(($69)>>2)]=$67;
      var $70=(($8+436)|0);
      var $71=(($70)|0);
      var $72=$71;
      HEAP8[($72)]=0; HEAP8[($72+1)]=0; HEAP8[($72+2)]=0; HEAP8[($72+3)]=0; HEAP8[($72+4)]=0; HEAP8[($72+5)]=0; HEAP8[($72+6)]=0; HEAP8[($72+7)]=0;
      var $73=(($8+444)|0);
      var $74=(($73)|0);
      var $75=$74;
      HEAP8[($75)]=0; HEAP8[($75+1)]=0; HEAP8[($75+2)]=0; HEAP8[($75+3)]=0; HEAP8[($75+4)]=0; HEAP8[($75+5)]=0; HEAP8[($75+6)]=0; HEAP8[($75+7)]=0;
      ;
      return;
    case 3: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $6=$78;
      var $79=$77.f1;
      $7=$79;
      var $80=$8;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $81
      __label__ = 5; break;
    case 5: // $82
      var $83=$6;
      var $84=$6;
      var $85=$7;
      var $86=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $84, tempValue);
      var $87=($86.f1 = $85, $86);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_deviceC2ERK14machine_configPKcP8device_tj["X"]=1;

function __ZN13screen_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13screen_deviceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_deviceD0Ev["X"]=1;

function __Z8downcastIR13screen_device8device_tET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN13screen_device13callback_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN13screen_device13callback_itemEED2Ev($2);
  ;
  return;
}


function __ZN13screen_device17static_set_formatER8device_t14_bitmap_format($device, $format) {
  ;
  var __label__;

  var $1;
  var $2;
  var $screen;
  $1=$device;
  $2=$format;
  var $3=$1;
  var $4=__Z8downcastIR13screen_device8device_tET_RT0_($3);
  $screen=$4;
  var $5=$2;
  var $6=$screen;
  var $7=(($6+380)|0);
  HEAP32[(($7)>>2)]=$5;
  ;
  return;
}


function __ZN13screen_device15static_set_typeER8device_t16screen_type_enum($device, $type) {
  ;
  var __label__;

  var $1;
  var $2;
  var $screen;
  $1=$device;
  $2=$type;
  var $3=$1;
  var $4=__Z8downcastIR13screen_device8device_tET_RT0_($3);
  $screen=$4;
  var $5=$2;
  var $6=$screen;
  var $7=(($6+356)|0);
  HEAP32[(($7)>>2)]=$5;
  ;
  return;
}


function __ZN13screen_device18static_set_refreshER8device_tx($device, $rate$0, $rate$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $screen;
  $1=$device;
  var $st$4$0=(($2)|0);
  HEAP32[(($st$4$0)>>2)]=$rate$0;
  var $st$4$1=(($2+4)|0);
  HEAP32[(($st$4$1)>>2)]=$rate$1;
  var $3=$1;
  var $4=__Z8downcastIR13screen_device8device_tET_RT0_($3);
  $screen=$4;
  var $st$11$0=(($2)|0);
  var $5$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($2+4)|0);
  var $5$1=HEAP32[(($st$11$1)>>2)];
  var $6=$screen;
  var $7=(($6+364)|0);
  var $st$17$0=(($7)|0);
  HEAP32[(($st$17$0)>>2)]=$5$0;
  var $st$17$1=(($7+4)|0);
  HEAP32[(($st$17$1)>>2)]=$5$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZN13screen_device22static_set_vblank_timeER8device_tx($device, $time$0, $time$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $screen;
  $1=$device;
  var $st$4$0=(($2)|0);
  HEAP32[(($st$4$0)>>2)]=$time$0;
  var $st$4$1=(($2+4)|0);
  HEAP32[(($st$4$1)>>2)]=$time$1;
  var $3=$1;
  var $4=__Z8downcastIR13screen_device8device_tET_RT0_($3);
  $screen=$4;
  var $st$11$0=(($2)|0);
  var $5$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($2+4)|0);
  var $5$1=HEAP32[(($st$11$1)>>2)];
  var $6=$screen;
  var $7=(($6+372)|0);
  var $st$17$0=(($7)|0);
  HEAP32[(($st$17$0)>>2)]=$5$0;
  var $st$17$1=(($7+4)|0);
  HEAP32[(($st$17$1)>>2)]=$5$1;
  var $8=$screen;
  var $9=(($8+360)|0);
  HEAP8[($9)]=1;
  STACKTOP = __stackBase__;
  return;
}


function __ZN13screen_device15static_set_sizeER8device_ttt($device, $width, $height) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $screen;
  $1=$device;
  $2=$width;
  $3=$height;
  var $4=$1;
  var $5=__Z8downcastIR13screen_device8device_tET_RT0_($4);
  $screen=$5;
  var $6=$2;
  var $7=(($6)&65535);
  var $8=$screen;
  var $9=(($8+412)|0);
  HEAP32[(($9)>>2)]=$7;
  var $10=$3;
  var $11=(($10)&65535);
  var $12=$screen;
  var $13=(($12+416)|0);
  HEAP32[(($13)>>2)]=$11;
  ;
  return;
}


function __ZN13screen_device18static_set_visareaER8device_tssss($device, $minx, $maxx, $miny, $maxy) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $screen;
  $1=$device;
  $2=$minx;
  $3=$maxx;
  $4=$miny;
  $5=$maxy;
  var $6=$1;
  var $7=__Z8downcastIR13screen_device8device_tET_RT0_($6);
  $screen=$7;
  var $8=$2;
  var $9=(($8 << 16) >> 16);
  var $10=$screen;
  var $11=(($10+420)|0);
  var $12=(($11)|0);
  HEAP32[(($12)>>2)]=$9;
  var $13=$3;
  var $14=(($13 << 16) >> 16);
  var $15=$screen;
  var $16=(($15+420)|0);
  var $17=(($16+4)|0);
  HEAP32[(($17)>>2)]=$14;
  var $18=$4;
  var $19=(($18 << 16) >> 16);
  var $20=$screen;
  var $21=(($20+420)|0);
  var $22=(($21+8)|0);
  HEAP32[(($22)>>2)]=$19;
  var $23=$5;
  var $24=(($23 << 16) >> 16);
  var $25=$screen;
  var $26=(($25+420)|0);
  var $27=(($26+12)|0);
  HEAP32[(($27)>>2)]=$24;
  ;
  return;
}


function __ZN13screen_device24static_set_screen_updateER8device_tPFjPS_P8bitmap_tPK10_rectangleE($device, $callback) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$callback;
  var $3=$2;
  var $4=$1;
  var $5=__Z8downcastIR13screen_device8device_tET_RT0_($4);
  var $6=(($5+400)|0);
  HEAP32[(($6)>>2)]=$3;
  ;
  return;
}


function __ZNK13screen_device21device_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      $1=$this;
      $2=$options;
      $3=$driver;
      var $4=$1;
      $error=0;
      var $5=(($4+412)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) <= 0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=(($4+416)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0) <= 0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$3;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$4;
      var $20=__ZNK8device_t3tagEv($19);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str12774)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,HEAP32[((tempInt+4)>>2)]=$18,HEAP32[((tempInt+8)>>2)]=$20,tempInt));
      $error=1;
      __label__ = 3; break;
    case 3: // $21
      var $22=(($4+356)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=2;
      if ($24) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $25
      var $26=(($4+420)|0);
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($4+420)|0);
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28)|0) < (($31)|0);
      if ($32) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $33
      var $34=(($4+420)|0);
      var $35=(($34+12)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($4+420)|0);
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($36)|0) < (($39)|0);
      if ($40) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $41
      var $42=(($4+420)|0);
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($4+412)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($44)|0) >= (($46)|0);
      if ($47) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $48
      var $49=(($4+420)|0);
      var $50=(($49+12)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($4+416)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($51)|0) >= (($53)|0);
      if ($54) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $55
      var $56=$3;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$3;
      var $60=(($59+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$4;
      var $63=__ZNK8device_t3tagEv($62);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str22775)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$58,HEAP32[((tempInt+4)>>2)]=$61,HEAP32[((tempInt+8)>>2)]=$63,tempInt));
      $error=1;
      __label__ = 9; break;
    case 9: // $64
      var $65=(($4+380)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)!=2;
      if ($67) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $68
      var $69=(($4+380)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0)!=5;
      if ($71) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $72
      var $73=(($4+380)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)!=6;
      if ($75) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $76
      var $77=$3;
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$3;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$4;
      var $84=__ZNK8device_t3tagEv($83);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str32776)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$79,HEAP32[((tempInt+4)>>2)]=$82,HEAP32[((tempInt+8)>>2)]=$84,tempInt));
      $error=1;
      __label__ = 13; break;
    case 13: // $85
      __label__ = 14; break;
    case 14: // $86
      var $87=(($4+364)|0);
      var $st$1$0=(($87)|0);
      var $88$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($87+4)|0);
      var $88$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $89=$88$0 == $$emscripten$temp$0$0 && $88$1 == $$emscripten$temp$0$1;
      if ($89) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $90
      var $91=$3;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$3;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$4;
      var $98=__ZNK8device_t3tagEv($97);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str42777)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$93,HEAP32[((tempInt+4)>>2)]=$96,HEAP32[((tempInt+8)>>2)]=$98,tempInt));
      $error=1;
      __label__ = 16; break;
    case 16: // $99
      var $100=$error;
      var $101=(($100) & 1);
      ;
      return $101;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13screen_device21device_validity_checkER11emu_optionsRK11game_driver["X"]=1;

function __ZN13screen_device28static_vblank_begin_callbackER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN13screen_device21vblank_begin_callbackEv($5);
  ;
  return;
}


function __ZN13screen_device26static_vblank_end_callbackER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN13screen_device19vblank_end_callbackEv($5);
  ;
  return;
}


function __ZN13screen_device25static_scanline0_callbackER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN13screen_device18scanline0_callbackEv($5);
  ;
  return;
}


function __ZN13screen_device31static_scanline_update_callbackER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  __ZN13screen_device24scanline_update_callbackEi($5, $6);
  ;
  return;
}


function __ZN13screen_device9configureEiiRK10_rectanglex($this, $width, $height, $visarea, $frame_period$0, $frame_period$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $6=__stackBase__+8;
      var $7=__stackBase__+20;
      var $8=__stackBase__+32;
      var $9=__stackBase__+44;
      var $10=__stackBase__+56;
      var $11=__stackBase__+68;
      $1=$this;
      $2=$width;
      $3=$height;
      $4=$visarea;
      var $st$15$0=(($5)|0);
      HEAP32[(($st$15$0)>>2)]=$frame_period$0;
      var $st$15$1=(($5+4)|0);
      HEAP32[(($st$15$1)>>2)]=$frame_period$1;
      var $12=$1;
      __label__ = 1; break;
    case 1: // $13
      __label__ = 2; break;
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      __label__ = 6; break;
    case 6: // $18
      __label__ = 7; break;
    case 7: // $19
      __label__ = 8; break;
    case 8: // $20
      __label__ = 9; break;
    case 9: // $21
      __label__ = 10; break;
    case 10: // $22
      __label__ = 11; break;
    case 11: // $23
      __label__ = 12; break;
    case 12: // $24
      __label__ = 13; break;
    case 13: // $25
      __label__ = 14; break;
    case 14: // $26
      var $27=$2;
      var $28=(($12+412)|0);
      HEAP32[(($28)>>2)]=$27;
      var $29=$3;
      var $30=(($12+416)|0);
      HEAP32[(($30)>>2)]=$29;
      var $31=(($12+420)|0);
      var $32=$4;
      var $33=$31;
      var $34=$32;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($33)>>2)]=HEAP32[(($34)>>2)];HEAP32[(($33+4)>>2)]=HEAP32[(($34+4)>>2)];HEAP32[(($33+8)>>2)]=HEAP32[(($34+8)>>2)];HEAP32[(($33+12)>>2)]=HEAP32[(($34+12)>>2)];
      __ZN13screen_device22realloc_screen_bitmapsEv($12);
      var $st$12$0=(($5)|0);
      var $35$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($5+4)|0);
      var $35$1=HEAP32[(($st$12$1)>>2)];
      var $36=(($12+476)|0);
      var $st$17$0=(($36)|0);
      HEAP32[(($st$17$0)>>2)]=$35$0;
      var $st$17$1=(($36+4)|0);
      HEAP32[(($st$17$1)>>2)]=$35$1;
      var $st$21$0=(($5)|0);
      var $37$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($5+4)|0);
      var $37$1=HEAP32[(($st$21$1)>>2)];
      var $38=$3;
      var $39$0=$38;
      var $39$1=(($38|0) < 0 ? -1 : 0);
      var $40$0 = (tempBigIntR=((($37$0)>>>0)+((($37$1)|0)*4294967296))/((($39$0)>>>0)+((($39$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $40$1 = Math.min(Math.floor(((tempBigIntR=((($37$0)>>>0)+((($37$1)|0)*4294967296))/((($39$0)>>>0)+((($39$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $41=(($12+484)|0);
      var $st$30$0=(($41)|0);
      HEAP32[(($st$30$0)>>2)]=$40$0;
      var $st$30$1=(($41+4)|0);
      HEAP32[(($st$30$1)>>2)]=$40$1;
      var $st$34$0=(($5)|0);
      var $42$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($5+4)|0);
      var $42$1=HEAP32[(($st$34$1)>>2)];
      var $43=$3;
      var $44=$2;
      var $45=(($43*$44)|0);
      var $46$0=$45;
      var $46$1=(($45|0) < 0 ? -1 : 0);
      var $47$0 = (tempBigIntR=((($42$0)>>>0)+((($42$1)|0)*4294967296))/((($46$0)>>>0)+((($46$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $47$1 = Math.min(Math.floor(((tempBigIntR=((($42$0)>>>0)+((($42$1)|0)*4294967296))/((($46$0)>>>0)+((($46$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $48=(($12+492)|0);
      var $st$45$0=(($48)|0);
      HEAP32[(($st$45$0)>>2)]=$47$0;
      var $st$45$1=(($48+4)|0);
      HEAP32[(($st$45$1)>>2)]=$47$1;
      var $49=(($12+372)|0);
      var $st$50$0=(($49)|0);
      var $50$0=HEAP32[(($st$50$0)>>2)];
      var $st$50$1=(($49+4)|0);
      var $50$1=HEAP32[(($st$50$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $51=$50$0 == $$emscripten$temp$0$0 && $50$1 == $$emscripten$temp$0$1;
      if ($51) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $52
      var $53=(($12+360)|0);
      var $54=HEAP8[($53)];
      var $55=(($54) & 1);
      if ($55) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $56
      var $57=(($12+484)|0);
      var $st$1$0=(($57)|0);
      var $58$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($57+4)|0);
      var $58$1=HEAP32[(($st$1$1)>>2)];
      var $59=$3;
      var $60=$4;
      var $61=(($60+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+1)|0);
      var $64=$4;
      var $65=(($64+8)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($63-$66)|0);
      var $68=(($59-$67)|0);
      var $69$0=$68;
      var $69$1=(($68|0) < 0 ? -1 : 0);
      var $70$0 = ((($58$0)>>>0)+((($58$1)|0)*4294967296))*((($69$0)>>>0)+((($69$1)|0)*4294967296))>>>0; var $70$1 = Math.min(Math.floor((((($58$0)>>>0)+((($58$1)|0)*4294967296))*((($69$0)>>>0)+((($69$1)|0)*4294967296)))/4294967296), 4294967295);
      var $71=(($12+500)|0);
      var $st$19$0=(($71)|0);
      HEAP32[(($st$19$0)>>2)]=$70$0;
      var $st$19$1=(($71+4)|0);
      HEAP32[(($st$19$1)>>2)]=$70$1;
      __label__ = 18; break;
    case 17: // $72
      var $73=(($12+372)|0);
      var $st$1$0=(($73)|0);
      var $74$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($73+4)|0);
      var $74$1=HEAP32[(($st$1$1)>>2)];
      var $75=(($12+500)|0);
      var $st$6$0=(($75)|0);
      HEAP32[(($st$6$0)>>2)]=$74$0;
      var $st$6$1=(($75+4)|0);
      HEAP32[(($st$6$1)>>2)]=$74$1;
      __label__ = 18; break;
    case 18: // $76
      var $77=__ZNK13screen_device4vposEv($12);
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $79
      var $80=(($12+540)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($82)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($82+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($82+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $83=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($83)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($83+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($83+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($81, $6, 0, $7);
      __label__ = 21; break;
    case 20: // $84
      var $85=(($12+540)|0);
      var $86=HEAP32[(($85)>>2)];
      __ZNK13screen_device14time_until_posEii($8, $12, 0, 0);
      var $87=$9;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($87)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($87+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($87+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($86, $8, 0, $9);
      __label__ = 21; break;
    case 21: // $88
      var $89=(($12+532)|0);
      var $90=HEAP32[(($89)>>2)];
      __ZNK13screen_device23time_until_vblank_startEv($10, $12);
      var $91=$11;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($91)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($91+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($91+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($90, $10, 0, $11);
      var $92=$12;
      var $93=__ZNK8device_t7machineEv($92);
      var $94=__ZNK15running_machine5videoEv($93);
      __ZN13video_manager20update_refresh_speedEv($94);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device9configureEiiRK10_rectanglex["X"]=1;

function __ZN13screen_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV13screen_device+8)|0);
      var $6=(($4+560)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN13screen_device13callback_itemEED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      __ZN8device_tD2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device12device_startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $settings=__stackBase__+36;
      var $10=__stackBase__+68;
      var $11=__stackBase__+80;
      var $12=__stackBase__+92;
      var $width=__stackBase__+104;
      var $height=__stackBase__+108;
      var $13;
      var $14;
      var $overname;
      $9=$this;
      var $15=$9;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $16=(($15+408)|0);
      var $17=HEAP32[(($16)>>2)];
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($17, $settings);
      var $18=(($15+384)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=(($settings+24)|0);
      HEAPF32[(($20)>>2)]=$19;
      var $21=(($15+388)|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=(($settings+28)|0);
      HEAPF32[(($23)>>2)]=$22;
      var $24=(($15+392)|0);
      var $25=HEAPF32[(($24)>>2)];
      var $26=(($settings+16)|0);
      HEAPF32[(($26)>>2)]=$25;
      var $27=(($15+396)|0);
      var $28=HEAPF32[(($27)>>2)];
      var $29=(($settings+20)|0);
      HEAPF32[(($29)>>2)]=$28;
      var $30=(($15+408)|0);
      var $31=HEAP32[(($30)>>2)];
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($31, $settings);
      var $32=$15;
      var $33=__ZNK8device_t7machineEv($32);
      var $34=__ZN15running_machine9schedulerEv($33);
      var $35=$15;
      var $36=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($34, 242, ((STRING_TABLE.__str52778)|0), $35);
      var $37=(($15+532)|0);
      HEAP32[(($37)>>2)]=$36;
      var $38=$15;
      var $39=__ZNK8device_t7machineEv($38);
      var $40=__ZN15running_machine9schedulerEv($39);
      var $41=$15;
      var $42=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($40, 244, ((STRING_TABLE.__str62779)|0), $41);
      var $43=(($15+536)|0);
      HEAP32[(($43)>>2)]=$42;
      var $44=$15;
      var $45=__ZNK8device_t7machineEv($44);
      var $46=__ZN15running_machine9schedulerEv($45);
      var $47=$15;
      var $48=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($46, 246, ((STRING_TABLE.__str72780)|0), $47);
      var $49=(($15+540)|0);
      HEAP32[(($49)>>2)]=$48;
      var $50=$15;
      var $51=__ZNK8device_t7machineEv($50);
      var $52=__ZNK15running_machine6configEv($51);
      var $53=(($52+40)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$54 & 256;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $57
      var $58=$15;
      var $59=__ZNK8device_t7machineEv($58);
      var $60=__ZN15running_machine9schedulerEv($59);
      var $61=$15;
      var $62=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($60, 248, ((STRING_TABLE.__str82781)|0), $61);
      var $63=(($15+544)|0);
      HEAP32[(($63)>>2)]=$62;
      __label__ = 2; break;
    case 2: // $64
      var $65=(($15+412)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($15+416)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($15+420)|0);
      var $70=(($15+364)|0);
      var $st$6$0=(($70)|0);
      var $71$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($70+4)|0);
      var $71$1=HEAP32[(($st$6$1)>>2)];
      __ZN13screen_device9configureEiiRK10_rectanglex($15, $66, $68, $69, $71$0, $71$1);
      var $72=(($15+508)|0);
      var $73=$72;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($73)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($73+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($73+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $74=(($15+520)|0);
      var $75=(($15+500)|0);
      var $st$16$0=(($75)|0);
      var $76$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($75+4)|0);
      var $76$1=HEAP32[(($st$16$1)>>2)];
      __ZN8attotimeC1Eix($10, 0, $76$0, $76$1);
      var $77=$74;
      var $78=$10;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($77)>>2)]=HEAP32[(($78)>>2)];HEAP32[(($77+4)>>2)]=HEAP32[(($78+4)>>2)];HEAP32[(($77+8)>>2)]=HEAP32[(($78+8)>>2)];
      var $79=$15;
      var $80=__ZNK8device_t7machineEv($79);
      var $81=__ZNK15running_machine6configEv($80);
      var $82=(($81+40)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$83 & 256;
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $86
      var $87=(($15+544)|0);
      var $88=HEAP32[(($87)>>2)];
      __ZNK13screen_device14time_until_posEii($11, $15, 0, 0);
      var $89=$12;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($89)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($89+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($89+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($88, $11, 0, $12);
      __label__ = 4; break;
    case 4: // $90
      var $91=$15;
      var $92=__ZNK8device_t7machineEv($91);
      var $93=__ZNK15running_machine7optionsEv($92);
      var $94=__ZNK11emu_options6burninEv($93);
      if ($94) { __label__ = 5; break; } else { __label__ = 25; break; }
    case 5: // $95
      var $96=$15;
      var $97=__ZNK8device_t7machineEv($96);
      var $98=__ZNK15running_machine7optionsEv($97);
      var $99=__ZNK11emu_options9snap_sizeEv($98);
      var $100=_sscanf($99, ((STRING_TABLE.__str92782)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$width,HEAP32[((tempInt+4)>>2)]=$height,tempInt));
      var $101=(($100)|0)!=2;
      if ($101) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $102
      var $103=HEAP32[(($width)>>2)];
      var $104=(($103)|0)==0;
      if ($104) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $105
      var $106=HEAP32[(($height)>>2)];
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $108
      HEAP32[(($height)>>2)]=300;
      HEAP32[(($width)>>2)]=300;
      __label__ = 9; break;
    case 9: // $109
      var $110=$15;
      var $111=__ZNK8device_t7machineEv($110);
      var $112=__ZN15running_machine7respoolEv($111);
      var $113=$4;
      var $114=$5;
      var $115=$6;
      var $116=$result_i;
      var $117=$7;
      var $118=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($6)>>2)]=355;
      var $119=HEAP32[(($4)>>2)];
      var $120=HEAP32[(($5)>>2)];
      var $121=HEAP32[(($6)>>2)];
      var $122=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($119, $120, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $123
      HEAP32[(($result_i)>>2)]=$122;
      var $124=HEAP32[(($result_i)>>2)];
      var $125=(($124)|0)==0;
      if ($125) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $126
      var $127=___cxa_allocate_exception(4);
      var $128=$127;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($128);
      (function() { try { __THREW__ = false; return ___cxa_throw($127, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      HEAP32[(($7)>>2)]=$131;
      var $132=$130.f1;
      HEAP32[(($8)>>2)]=$132;
      var $133=HEAP32[(($8)>>2)];
      var $134=(($133)|0) < 0;
      if ($134) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $135
      var $136=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($136);
      throw "Reached an unreachable!"
    case 14: // $137
      var $138=HEAP32[(($7)>>2)];
      var $139=HEAP32[(($7)>>2)];
      var $140=HEAP32[(($8)>>2)];
      var $141=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $139, tempValue);
      var $142=($141.f1 = $140, $141);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $143
      throw "Reached an unreachable!"
    case 16: // $_ZnwjPKci_exit
      var $144=HEAP32[(($result_i)>>2)];
      var $145=$4;
      var $146=$5;
      var $147=$6;
      var $148=$result_i;
      var $149=$7;
      var $150=$8;
      var $151=$144;
      var $152=HEAP32[(($width)>>2)];
      var $153=HEAP32[(($height)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($151, $152, $153, 4, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $154
      var $155=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($112, $151);
      var $156=(($15+452)|0);
      HEAP32[(($156)>>2)]=$155;
      var $157=(($15+452)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($158)|0)==0;
      if ($159) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $160
      var $161=HEAP32[(($width)>>2)];
      var $162=HEAP32[(($height)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str112784)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$161,HEAP32[((tempInt+4)>>2)]=$162,tempInt));
      throw "Reached an unreachable!"
    case 19: // $163
      var $164=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $165=$164.f0;
      $13=$165;
      var $166=$164.f1;
      $14=$166;
      var $167=$1;
      var $168=$2;
      var $169=$3;
      HEAP32[(($1)>>2)]=$144;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($3)>>2)]=355;
      var $170=HEAP32[(($1)>>2)];
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $172
      var $173=HEAP32[(($1)>>2)];
      var $174=HEAP32[(($2)>>2)];
      var $175=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($173, $174, $175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 30; break; }
    case 21: // $_noexc
      __label__ = 22; break;
    case 22: // $_ZdlPvPKci_exit
      var $176=$1;
      var $177=$2;
      var $178=$3;
      __label__ = 23; break;
    case 23: // $179
      __label__ = 29; break;
    case 24: // $180
      var $181=(($15+452)|0);
      var $182=HEAP32[(($181)>>2)];
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($182, 0, 0);
      __label__ = 25; break;
    case 25: // $183
      var $184=$15;
      var $185=__ZNK8device_t7machineEv($184);
      var $186=__ZNK15running_machine7optionsEv($185);
      var $187=__ZNK11emu_options6effectEv($186);
      $overname=$187;
      var $188=$overname;
      var $189=(($188)|0)!=0;
      if ($189) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $190
      var $191=$overname;
      var $192=_strcmp($191, ((STRING_TABLE.__str122785)|0));
      var $193=(($192)|0)!=0;
      if ($193) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $194
      var $195=$overname;
      __ZN13screen_device19load_effect_overlayEPKc($15, $195);
      __label__ = 28; break;
    case 28: // $196
      var $197=$15;
      var $198=(($15+412)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($197, $198, ((STRING_TABLE.__str132786)|0), 0);
      var $199=$15;
      var $200=(($15+416)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($199, $200, ((STRING_TABLE.__str142787)|0), 0);
      var $201=$15;
      var $202=(($15+420)|0);
      var $203=(($202)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($201, $203, ((STRING_TABLE.__str152788)|0), 0);
      var $204=$15;
      var $205=(($15+420)|0);
      var $206=(($205+8)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($204, $206, ((STRING_TABLE.__str162789)|0), 0);
      var $207=$15;
      var $208=(($15+420)|0);
      var $209=(($208+4)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($207, $209, ((STRING_TABLE.__str172790)|0), 0);
      var $210=$15;
      var $211=(($15+420)|0);
      var $212=(($211+12)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($210, $212, ((STRING_TABLE.__str182791)|0), 0);
      var $213=$15;
      var $214=(($15+468)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($213, $214, ((STRING_TABLE.__str192792)|0), 0);
      var $215=$15;
      var $216=(($15+476)|0);
      __ZN8device_t9save_itemIxEEvRT_PKci($215, $216, ((STRING_TABLE.__str202793)|0), 0);
      var $217=$15;
      var $218=(($15+484)|0);
      __ZN8device_t9save_itemIxEEvRT_PKci($217, $218, ((STRING_TABLE.__str212794)|0), 0);
      var $219=$15;
      var $220=(($15+492)|0);
      __ZN8device_t9save_itemIxEEvRT_PKci($219, $220, ((STRING_TABLE.__str222795)|0), 0);
      var $221=$15;
      var $222=(($15+500)|0);
      __ZN8device_t9save_itemIxEEvRT_PKci($221, $222, ((STRING_TABLE.__str232796)|0), 0);
      var $223=$15;
      var $224=(($15+508)|0);
      __ZN8device_t9save_itemI8attotimeEEvRT_PKci($223, $224, ((STRING_TABLE.__str242797)|0), 0);
      var $225=$15;
      var $226=(($15+520)|0);
      __ZN8device_t9save_itemI8attotimeEEvRT_PKci($225, $226, ((STRING_TABLE.__str252798)|0), 0);
      var $227=$15;
      var $228=(($15+548)|0);
      __ZN8device_t9save_itemIyEEvRT_PKci($227, $228, ((STRING_TABLE.__str262799)|0), 0);
      STACKTOP = __stackBase__;
      return;
    case 29: // $229
      var $230=$13;
      var $231=$13;
      var $232=$14;
      var $233=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $231, tempValue);
      var $234=($233.f1 = $232, $233);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $235
      var $236=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device12device_startEv["X"]=1;

function __ZNK13screen_device14time_until_posEii($agg_result, $this, $vpos, $hpos) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $targetdelta=__stackBase__;
      var $curdelta=__stackBase__+8;
      var $4=__stackBase__+16;
      var $5=__stackBase__+28;
      $1=$this;
      $2=$vpos;
      $3=$hpos;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      __label__ = 4; break;
    case 4: // $10
      var $11=(($6+416)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($6+420)|0);
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      var $17=(($12-$16)|0);
      var $18=$2;
      var $19=(($18+$17)|0);
      $2=$19;
      var $20=(($6+416)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$2;
      var $23=(($22)|0)%(($21)|0);
      $2=$23;
      var $24=$2;
      var $25$0=$24;
      var $25$1=(($24|0) < 0 ? -1 : 0);
      var $26=(($6+484)|0);
      var $st$19$0=(($26)|0);
      var $27$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$19$1)>>2)];
      var $28$0 = ((($25$0)>>>0)+((($25$1)|0)*4294967296))*((($27$0)>>>0)+((($27$1)|0)*4294967296))>>>0; var $28$1 = Math.min(Math.floor((((($25$0)>>>0)+((($25$1)|0)*4294967296))*((($27$0)>>>0)+((($27$1)|0)*4294967296)))/4294967296), 4294967295);
      var $29=$3;
      var $30$0=$29;
      var $30$1=(($29|0) < 0 ? -1 : 0);
      var $31=(($6+492)|0);
      var $st$28$0=(($31)|0);
      var $32$0=HEAP32[(($st$28$0)>>2)];
      var $st$28$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$28$1)>>2)];
      var $33$0 = ((($30$0)>>>0)+((($30$1)|0)*4294967296))*((($32$0)>>>0)+((($32$1)|0)*4294967296))>>>0; var $33$1 = Math.min(Math.floor((((($30$0)>>>0)+((($30$1)|0)*4294967296))*((($32$0)>>>0)+((($32$1)|0)*4294967296)))/4294967296), 4294967295);
      var $34$0 = ((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($33$0)>>>0)+((($33$1)|0)*4294967296))>>>0; var $34$1 = Math.min(Math.floor((((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($33$0)>>>0)+((($33$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$34$0=(($targetdelta)|0);
      HEAP32[(($st$34$0)>>2)]=$34$0;
      var $st$34$1=(($targetdelta+4)|0);
      HEAP32[(($st$34$1)>>2)]=$34$1;
      var $35=$6;
      var $36=__ZNK8device_t7machineEv($35);
      __ZNK15running_machine4timeEv($4, $36);
      var $37=(($6+508)|0);
      __ZmiRK8attotimeS1_($5, $4, $37);
      var $38=__ZNK8attotime14as_attosecondsEv($5);
      var $38$0=$38[0];
      var $38$1=$38[1];
      var $st$46$0=(($curdelta)|0);
      HEAP32[(($st$46$0)>>2)]=$38$0;
      var $st$46$1=(($curdelta+4)|0);
      HEAP32[(($st$46$1)>>2)]=$38$1;
      var $st$50$0=(($targetdelta)|0);
      var $39$0=HEAP32[(($st$50$0)>>2)];
      var $st$50$1=(($targetdelta+4)|0);
      var $39$1=HEAP32[(($st$50$1)>>2)];
      var $st$54$0=(($curdelta)|0);
      var $40$0=HEAP32[(($st$54$0)>>2)];
      var $st$54$1=(($curdelta+4)|0);
      var $40$1=HEAP32[(($st$54$1)>>2)];
      var $41=(($6+492)|0);
      var $st$59$0=(($41)|0);
      var $42$0=HEAP32[(($st$59$0)>>2)];
      var $st$59$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$59$1)>>2)];
      var $$emscripten$temp$0$0=2;
      var $$emscripten$temp$0$1=0;
      var $43$0 = (tempBigIntR=((($42$0)>>>0)+((($42$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $43$1 = Math.min(Math.floor(((tempBigIntR=((($42$0)>>>0)+((($42$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $44$0 = ((($40$0)>>>0)+((($40$1)|0)*4294967296))+((($43$0)>>>0)+((($43$1)|0)*4294967296))>>>0; var $44$1 = Math.min(Math.floor((((($40$0)>>>0)+((($40$1)|0)*4294967296))+((($43$0)>>>0)+((($43$1)|0)*4294967296)))/4294967296), 4294967295);
      var $45=($39$1|0) <= ($44$1|0) && (($39$1|0) <  ($44$1|0) || ($39$0|0) <= ($44$0|0));
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=(($6+476)|0);
      var $st$1$0=(($47)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($47+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($targetdelta)|0);
      var $49$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($targetdelta+4)|0);
      var $49$1=HEAP32[(($st$5$1)>>2)];
      var $50$0 = ((($49$0)>>>0)+((($49$1)|0)*4294967296))+((($48$0)>>>0)+((($48$1)|0)*4294967296))>>>0; var $50$1 = Math.min(Math.floor((((($49$0)>>>0)+((($49$1)|0)*4294967296))+((($48$0)>>>0)+((($48$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($targetdelta)|0);
      HEAP32[(($st$10$0)>>2)]=$50$0;
      var $st$10$1=(($targetdelta+4)|0);
      HEAP32[(($st$10$1)>>2)]=$50$1;
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $st$0$0=(($targetdelta)|0);
      var $53$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($targetdelta+4)|0);
      var $53$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($curdelta)|0);
      var $54$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($curdelta+4)|0);
      var $54$1=HEAP32[(($st$4$1)>>2)];
      var $55=($53$1|0) <= ($54$1|0) && (($53$1|0) <  ($54$1|0) || ($53$0|0) <= ($54$0|0));
      if ($55) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $56
      var $57=(($6+476)|0);
      var $st$1$0=(($57)|0);
      var $58$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($57+4)|0);
      var $58$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($targetdelta)|0);
      var $59$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($targetdelta+4)|0);
      var $59$1=HEAP32[(($st$5$1)>>2)];
      var $60$0 = ((($59$0)>>>0)+((($59$1)|0)*4294967296))+((($58$0)>>>0)+((($58$1)|0)*4294967296))>>>0; var $60$1 = Math.min(Math.floor((((($59$0)>>>0)+((($59$1)|0)*4294967296))+((($58$0)>>>0)+((($58$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($targetdelta)|0);
      HEAP32[(($st$10$0)>>2)]=$60$0;
      var $st$10$1=(($targetdelta+4)|0);
      HEAP32[(($st$10$1)>>2)]=$60$1;
      __label__ = 7; break;
    case 9: // $61
      var $st$0$0=(($targetdelta)|0);
      var $62$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($targetdelta+4)|0);
      var $62$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($curdelta)|0);
      var $63$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($curdelta+4)|0);
      var $63$1=HEAP32[(($st$4$1)>>2)];
      var $64$0 = ((($62$0)>>>0)+((($62$1)|0)*4294967296))-((($63$0)>>>0)+((($63$1)|0)*4294967296))>>>0; var $64$1 = Math.min(Math.floor((((($62$0)>>>0)+((($62$1)|0)*4294967296))-((($63$0)>>>0)+((($63$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($agg_result, 0, $64$0, $64$1);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13screen_device14time_until_posEii["X"]=1;

function __ZNK11emu_options6burninEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str422815)|0));
  ;
  return $4;
}


function __ZNK11emu_options9snap_sizeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str412814)|0));
  ;
  return $4;
}


function __ZNK11emu_options6effectEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str402813)|0));
  ;
  return $4;
}


function __ZN8device_t9save_itemIiEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9save_itemIxEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIxEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9save_itemI8attotimeEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9save_itemIyEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIyEEvPKcS2_iRT_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device11device_stopEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=__ZNK15running_machine6renderEv($4);
      var $6=(($2+436)|0);
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($5, $8);
      var $9=$2;
      var $10=__ZNK8device_t7machineEv($9);
      var $11=__ZNK15running_machine6renderEv($10);
      var $12=(($2+436)|0);
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($11, $14);
      var $15=(($2+452)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      __ZN13screen_device15finalize_burninEv($2);
      __label__ = 2; break;
    case 2: // $19
      var $20=(($2+472)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $22);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device19load_effect_overlayEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 324; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $fullname=__stackBase__;
      var $extension;
      var $3;
      var $4;
      var $file=__stackBase__+64;
      $1=$this;
      $2=$filename;
      var $5=$1;
      var $6=$2;
      __ZN7astringC1EPKc($fullname, $6);
      var $7=(function() { try { __THREW__ = false; return __ZNK7astring4rchrEii($fullname, 0, 46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $8
      $extension=$7;
      var $9=$extension;
      var $10=(($9)|0)!=-1;
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=$extension;
      var $13=(function() { try { __THREW__ = false; return __ZN7astring3delEii($fullname, $12, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $14
      __label__ = 5; break;
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $3=$17;
      var $18=$16.f1;
      $4=$18;
      __label__ = 22; break;
    case 5: // $19
      var $20=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($fullname, ((STRING_TABLE.__str292802)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 4; break; };
    case 6: // $21
      var $22=$5;
      var $23=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $24
      var $25=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $26
      var $27=(function() { try { __THREW__ = false; return __ZNK11emu_options8art_pathEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; };
    case 9: // $28
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $27, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; }
    case 10: // $29
      var $30=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fullname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $31
      var $32=(function() { try { __THREW__ = false; return __Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($file, 0, $30, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $33
      var $34=(($5+472)|0);
      HEAP32[(($34)>>2)]=$32;
      var $35=(($5+472)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $38
      var $39=(($5+408)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($5+472)|0);
      var $42=HEAP32[(($41)>>2)];
      (function() { try { __THREW__ = false; return __ZN16render_container11set_overlayEP8bitmap_t($40, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $43
      __label__ = 19; break;
    case 15: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $3=$46;
      var $47=$45.f1;
      $4=$47;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 16: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($fullname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $50
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str342807)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 18: // $51
      __label__ = 19; break;
    case 19: // $52
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 4; break; }
    case 20: // $53
      FUNCTION_TABLE[__ZN7astringD1Ev]($fullname);
      STACKTOP = __stackBase__;
      return;
    case 21: // $54
      __label__ = 22; break;
    case 22: // $55
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fullname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $56
      __label__ = 24; break;
    case 24: // $57
      var $58=$3;
      var $59=$3;
      var $60=$4;
      var $61=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $59, tempValue);
      var $62=($61.f1 = $60, $61);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device19load_effect_overlayEPKc["X"]=1;

function __ZN13screen_device16device_post_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13screen_device22realloc_screen_bitmapsEv($2);
  ;
  return;
}


function __ZN13screen_device15finalize_burninEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 676; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $scaledvis=__stackBase__+36;
      var $finalmap;
      var $10;
      var $11;
      var $srcwidth;
      var $srcheight;
      var $dstwidth;
      var $dstheight;
      var $xstep;
      var $ystep;
      var $minval=__stackBase__+52;
      var $maxval=__stackBase__+60;
      var $y;
      var $src;
      var $x;
      var $y1;
      var $srcy;
      var $src2;
      var $dst;
      var $x3;
      var $srcx;
      var $brightness;
      var $file=__stackBase__+68;
      var $filerr;
      var $pnginfo=__stackBase__+328;
      var $text=__stackBase__+420;
      $9=$this;
      var $12=$9;
      var $13=(($12+452)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      __label__ = 58; break;
    case 2: // $17
      var $18=(($12+420)|0);
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($12+452)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=(($23+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($20*$25)|0);
      var $27=(($12+412)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(((($26)|0)/(($28)|0))|0);
      var $30=(($scaledvis)|0);
      HEAP32[(($30)>>2)]=$29;
      var $31=(($12+420)|0);
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($12+452)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35;
      var $37=(($36+12)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($33*$38)|0);
      var $40=(($12+412)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(((($39)|0)/(($41)|0))|0);
      var $43=(($scaledvis+4)|0);
      HEAP32[(($43)>>2)]=$42;
      var $44=(($12+420)|0);
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($12+452)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48;
      var $50=(($49+16)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($46*$51)|0);
      var $53=(($12+416)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(((($52)|0)/(($54)|0))|0);
      var $56=(($scaledvis+8)|0);
      HEAP32[(($56)>>2)]=$55;
      var $57=(($12+420)|0);
      var $58=(($57+12)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($12+452)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($59*$64)|0);
      var $66=(($12+416)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(((($65)|0)/(($67)|0))|0);
      var $69=(($scaledvis+12)|0);
      HEAP32[(($69)>>2)]=$68;
      var $70=$12;
      var $71=__ZNK8device_t7machineEv($70);
      var $72=__ZN15running_machine7respoolEv($71);
      var $73=$4;
      var $74=$5;
      var $75=$6;
      var $76=$result_i;
      var $77=$7;
      var $78=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($6)>>2)]=984;
      var $79=HEAP32[(($4)>>2)];
      var $80=HEAP32[(($5)>>2)];
      var $81=HEAP32[(($6)>>2)];
      var $82=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($79, $80, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $83
      HEAP32[(($result_i)>>2)]=$82;
      var $84=HEAP32[(($result_i)>>2)];
      var $85=(($84)|0)==0;
      if ($85) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $86
      var $87=___cxa_allocate_exception(4);
      var $88=$87;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($88);
      (function() { try { __THREW__ = false; return ___cxa_throw($87, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $89
      var $90=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $91=$90.f0;
      HEAP32[(($7)>>2)]=$91;
      var $92=$90.f1;
      HEAP32[(($8)>>2)]=$92;
      var $93=HEAP32[(($8)>>2)];
      var $94=(($93)|0) < 0;
      if ($94) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $95
      var $96=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($96);
      throw "Reached an unreachable!"
    case 7: // $97
      var $98=HEAP32[(($7)>>2)];
      var $99=HEAP32[(($7)>>2)];
      var $100=HEAP32[(($8)>>2)];
      var $101=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $99, tempValue);
      var $102=($101.f1 = $100, $101);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $103
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $104=HEAPU32[(($result_i)>>2)];
      var $105=$4;
      var $106=$5;
      var $107=$6;
      var $108=$result_i;
      var $109=$7;
      var $110=$8;
      var $111=$104;
      var $112=(($scaledvis+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+1)|0);
      var $115=(($scaledvis)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($114-$116)|0);
      var $118=(($scaledvis+12)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+1)|0);
      var $121=(($scaledvis+8)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($120-$122)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($111, $117, $123, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 22; break; }
    case 10: // $124
      var $125=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($72, $111);
      $finalmap=$125;
      var $126=(($12+452)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=$127;
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      $srcwidth=$130;
      var $131=(($12+452)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$132;
      var $134=(($133+16)|0);
      var $135=HEAP32[(($134)>>2)];
      $srcheight=$135;
      var $136=$finalmap;
      var $137=$136;
      var $138=(($137+12)|0);
      var $139=HEAP32[(($138)>>2)];
      $dstwidth=$139;
      var $140=$finalmap;
      var $141=$140;
      var $142=(($141+16)|0);
      var $143=HEAP32[(($142)>>2)];
      $dstheight=$143;
      var $144=$srcwidth;
      var $145=$144 << 16;
      var $146=$dstwidth;
      var $147=(((($145)|0)/(($146)|0))|0);
      $xstep=$147;
      var $148=$srcheight;
      var $149=$148 << 16;
      var $150=$dstheight;
      var $151=(((($149)|0)/(($150)|0))|0);
      $ystep=$151;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$36$0=(($minval)|0);
      HEAP32[(($st$36$0)>>2)]=$$emscripten$temp$0$0;
      var $st$36$1=(($minval+4)|0);
      HEAP32[(($st$36$1)>>2)]=$$emscripten$temp$0$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$42$0=(($maxval)|0);
      HEAP32[(($st$42$0)>>2)]=$$emscripten$temp$1$0;
      var $st$42$1=(($maxval+4)|0);
      HEAP32[(($st$42$1)>>2)]=$$emscripten$temp$1$1;
      $y=0;
      __label__ = 11; break;
    case 11: // $152
      var $153=$y;
      var $154=$srcheight;
      var $155=(($153)|0) < (($154)|0);
      if ($155) { __label__ = 12; break; } else { __label__ = 29; break; }
    case 12: // $156
      var $157=(($12+452)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$158;
      var $160=(($159+4)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$161;
      var $163=$y;
      var $164=(($12+452)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=$165;
      var $167=(($166+8)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($163*$168)|0);
      var $170=(($162+($169<<3))|0);
      var $171=(($170)|0);
      $src=$171;
      $x=0;
      __label__ = 13; break;
    case 13: // $172
      var $173=$x;
      var $174=$srcwidth;
      var $175=(($173)|0) < (($174)|0);
      if ($175) { __label__ = 14; break; } else { __label__ = 27; break; }
    case 14: // $176
      var $st$0$0=(($minval)|0);
      var $177$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($minval+4)|0);
      var $177$1=HEAP32[(($st$0$1)>>2)];
      var $178=$x;
      var $179=$src;
      var $180=(($179+($178<<3))|0);
      var $st$7$0=(($180)|0);
      var $181$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($180+4)|0);
      var $181$1=HEAP32[(($st$7$1)>>2)];
      var $182=$177$1 < $181$1 || ($177$1 == $181$1 && $177$0 < $181$0);
      if ($182) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $183
      var $st$0$0=(($minval)|0);
      var $184$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($minval+4)|0);
      var $184$1=HEAP32[(($st$0$1)>>2)];
      var $191$1 = $184$1;var $191$0 = $184$0;__label__ = 17; break;
    case 16: // $185
      var $186=$x;
      var $187=$src;
      var $188=(($187+($186<<3))|0);
      var $st$3$0=(($188)|0);
      var $189$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($188+4)|0);
      var $189$1=HEAP32[(($st$3$1)>>2)];
      var $191$1 = $189$1;var $191$0 = $189$0;__label__ = 17; break;
    case 17: // $190
      var $191$0;
      var $191$1;
      var $st$2$0=(($minval)|0);
      HEAP32[(($st$2$0)>>2)]=$191$0;
      var $st$2$1=(($minval+4)|0);
      HEAP32[(($st$2$1)>>2)]=$191$1;
      var $st$6$0=(($maxval)|0);
      var $192$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($maxval+4)|0);
      var $192$1=HEAP32[(($st$6$1)>>2)];
      var $193=$x;
      var $194=$src;
      var $195=(($194+($193<<3))|0);
      var $st$13$0=(($195)|0);
      var $196$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($195+4)|0);
      var $196$1=HEAP32[(($st$13$1)>>2)];
      var $197=$192$1 > $196$1 || ($192$1 == $196$1 && $192$0 > $196$0);
      if ($197) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $198
      var $st$0$0=(($maxval)|0);
      var $199$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($maxval+4)|0);
      var $199$1=HEAP32[(($st$0$1)>>2)];
      var $206$1 = $199$1;var $206$0 = $199$0;__label__ = 20; break;
    case 19: // $200
      var $201=$x;
      var $202=$src;
      var $203=(($202+($201<<3))|0);
      var $st$3$0=(($203)|0);
      var $204$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($203+4)|0);
      var $204$1=HEAP32[(($st$3$1)>>2)];
      var $206$1 = $204$1;var $206$0 = $204$0;__label__ = 20; break;
    case 20: // $205
      var $206$0;
      var $206$1;
      var $st$2$0=(($maxval)|0);
      HEAP32[(($st$2$0)>>2)]=$206$0;
      var $st$2$1=(($maxval+4)|0);
      HEAP32[(($st$2$1)>>2)]=$206$1;
      __label__ = 21; break;
    case 21: // $207
      var $208=$x;
      var $209=(($208+1)|0);
      $x=$209;
      __label__ = 13; break;
    case 22: // $210
      var $211=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $212=$211.f0;
      $10=$212;
      var $213=$211.f1;
      $11=$213;
      var $214=$1;
      var $215=$2;
      var $216=$3;
      HEAP32[(($1)>>2)]=$104;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($3)>>2)]=984;
      var $217=HEAP32[(($1)>>2)];
      var $218=(($217)|0)!=0;
      if ($218) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $219
      var $220=HEAP32[(($1)>>2)];
      var $221=HEAP32[(($2)>>2)];
      var $222=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($220, $221, $222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 61; break; }
    case 24: // $_noexc
      __label__ = 25; break;
    case 25: // $_ZdlPvPKci_exit
      var $223=$1;
      var $224=$2;
      var $225=$3;
      __label__ = 26; break;
    case 26: // $226
      __label__ = 60; break;
    case 27: // $227
      __label__ = 28; break;
    case 28: // $228
      var $229=$y;
      var $230=(($229+1)|0);
      $y=$230;
      __label__ = 11; break;
    case 29: // $231
      var $st$0$0=(($minval)|0);
      var $232$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($minval+4)|0);
      var $232$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($maxval)|0);
      var $233$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($maxval+4)|0);
      var $233$1=HEAP32[(($st$4$1)>>2)];
      var $234=$232$0 == $233$0 && $232$1 == $233$1;
      if ($234) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $235
      __label__ = 58; break;
    case 31: // $236
      $y1=0;
      $srcy=0;
      __label__ = 32; break;
    case 32: // $237
      var $238=$y1;
      var $239=$dstheight;
      var $240=(($238)|0) < (($239)|0);
      if ($240) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $241
      var $242=(($12+452)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=$243;
      var $245=(($244+4)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=$246;
      var $248=$srcy;
      var $249=$248 >> 16;
      var $250=(($12+452)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$251;
      var $253=(($252+8)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($249*$254)|0);
      var $256=(($247+($255<<3))|0);
      var $257=(($256)|0);
      $src2=$257;
      var $258=$finalmap;
      var $259=$258;
      var $260=(($259+4)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$261;
      var $263=$y1;
      var $264=$finalmap;
      var $265=$264;
      var $266=(($265+8)|0);
      var $267=HEAP32[(($266)>>2)];
      var $268=(($263*$267)|0);
      var $269=(($262+($268<<2))|0);
      var $270=(($269)|0);
      $dst=$270;
      $x3=0;
      $srcx=0;
      __label__ = 34; break;
    case 34: // $271
      var $272=$x3;
      var $273=$dstwidth;
      var $274=(($272)|0) < (($273)|0);
      if ($274) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $275
      var $st$0$0=(($maxval)|0);
      var $276$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($maxval+4)|0);
      var $276$1=HEAP32[(($st$0$1)>>2)];
      var $277=$srcx;
      var $278=$277 >> 16;
      var $279=$src2;
      var $280=(($279+($278<<3))|0);
      var $st$8$0=(($280)|0);
      var $281$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($280+4)|0);
      var $281$1=HEAP32[(($st$8$1)>>2)];
      var $282$0 = ((($276$0)>>>0)+((($276$1)|0)*4294967296))-((($281$0)>>>0)+((($281$1)|0)*4294967296))>>>0; var $282$1 = Math.min(Math.floor((((($276$0)>>>0)+((($276$1)|0)*4294967296))-((($281$0)>>>0)+((($281$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=255;
      var $$emscripten$temp$2$1=0;
      var $283$0 = ((($282$0)>>>0)+((($282$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $283$1 = Math.min(Math.floor((((($282$0)>>>0)+((($282$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$16$0=(($maxval)|0);
      var $284$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($maxval+4)|0);
      var $284$1=HEAP32[(($st$16$1)>>2)];
      var $st$20$0=(($minval)|0);
      var $285$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($minval+4)|0);
      var $285$1=HEAP32[(($st$20$1)>>2)];
      var $286$0 = ((($284$0)>>>0)+((($284$1)|0)*4294967296))-((($285$0)>>>0)+((($285$1)|0)*4294967296))>>>0; var $286$1 = Math.min(Math.floor((((($284$0)>>>0)+((($284$1)|0)*4294967296))-((($285$0)>>>0)+((($285$1)|0)*4294967296)))/4294967296), 4294967295);
      var $287$0 = Math.floor(((($283$0)>>>0)+((($283$1)|0)*4294967296))/((($286$0)>>>0)+((($286$1)|0)*4294967296)))>>>0; var $287$1 = Math.min(Math.floor((Math.floor(((($283$0)>>>0)+((($283$1)|0)*4294967296))/((($286$0)>>>0)+((($286$1)|0)*4294967296))))/4294967296), 4294967295);
      var $288$0=$287$0;
      var $288=$288$0;
      $brightness=$288;
      var $289=$brightness;
      var $290=$289 & 255;
      var $291=$290 << 16;
      var $292=-16777216 | $291;
      var $293=$brightness;
      var $294=$293 & 255;
      var $295=$294 << 8;
      var $296=$292 | $295;
      var $297=$brightness;
      var $298=$297 & 255;
      var $299=$296 | $298;
      var $300=$x3;
      var $301=$dst;
      var $302=(($301+($300<<2))|0);
      HEAP32[(($302)>>2)]=$299;
      __label__ = 36; break;
    case 36: // $303
      var $304=$x3;
      var $305=(($304+1)|0);
      $x3=$305;
      var $306=$xstep;
      var $307=$srcx;
      var $308=(($307+$306)|0);
      $srcx=$308;
      __label__ = 34; break;
    case 37: // $309
      __label__ = 38; break;
    case 38: // $310
      var $311=$y1;
      var $312=(($311+1)|0);
      $y1=$312;
      var $313=$ystep;
      var $314=$srcy;
      var $315=(($314+$313)|0);
      $srcy=$315;
      __label__ = 32; break;
    case 39: // $316
      var $317=$12;
      var $318=__ZNK8device_t7machineEv($317);
      var $319=__ZNK15running_machine7optionsEv($318);
      var $320=__ZNK11emu_options18snapshot_directoryEv($319);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $320, 14);
      var $321=$12;
      var $322=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 56; break; };
    case 40: // $323
      var $324=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($322) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 56; break; };
    case 41: // $325
      var $326=$12;
      var $327=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 56; break; };
    case 42: // $328
      var $329=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_S1_S1_($file, $324, ((STRING_TABLE.__str282801)|0), $327, ((STRING_TABLE.__str292802)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 56; break; };
    case 43: // $330
      $filerr=$329;
      var $331=$filerr;
      var $332=(($331)|0)==0;
      if ($332) { __label__ = 44; break; } else { __label__ = 57; break; }
    case 44: // $333
      var $334=$pnginfo;
      for (var $$dest = $334>>2, $$stop = $$dest + 23; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      var $335=(($text)|0);
      var $336=(function() { try { __THREW__ = false; return _sprintf($335, ((STRING_TABLE.__str302803)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE._build_version)|0),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 56; break; };
    case 45: // $337
      var $338=(($text)|0);
      var $339=(function() { try { __THREW__ = false; return __Z12png_add_textP9_png_infoPKcS2_($pnginfo, ((STRING_TABLE.__str312804)|0), $338) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 56; break; };
    case 46: // $340
      var $341=(($text)|0);
      var $342=$12;
      var $343=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($342) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 56; break; };
    case 47: // $344
      var $345=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($343) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 56; break; };
    case 48: // $346
      var $347=(($345+20)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$12;
      var $350=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($349) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 56; break; };
    case 49: // $351
      var $352=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($350) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 56; break; };
    case 50: // $353
      var $354=(($352+12)|0);
      var $355=HEAP32[(($354)>>2)];
      var $356=(function() { try { __THREW__ = false; return _sprintf($341, ((STRING_TABLE.__str322805)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$348,HEAP32[((tempInt+4)>>2)]=$355,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 56; break; };
    case 51: // $357
      var $358=(($text)|0);
      var $359=(function() { try { __THREW__ = false; return __Z12png_add_textP9_png_infoPKcS2_($pnginfo, ((STRING_TABLE.__str332806)|0), $358) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 56; break; };
    case 52: // $360
      var $361=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 56; break; };
    case 53: // $362
      var $363=$finalmap;
      var $364=(function() { try { __THREW__ = false; return __Z16png_write_bitmapP10_core_fileP9_png_infoP8bitmap_tiPKj($361, $pnginfo, $363, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 56; break; };
    case 54: // $365
      (function() { try { __THREW__ = false; return __Z8png_freeP9_png_info($pnginfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $366
      __label__ = 57; break;
    case 56: // $367
      var $368=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $369=$368.f0;
      $10=$369;
      var $370=$368.f1;
      $11=$370;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 61; break; }
    case 57: // $371
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 58; break;
    case 58: // $372
      STACKTOP = __stackBase__;
      return;
    case 59: // $373
      __label__ = 60; break;
    case 60: // $374
      var $375=$10;
      var $376=$10;
      var $377=$11;
      var $378=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $376, tempValue);
      var $379=($378.f1 = $377, $378);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 61: // $380
      var $381=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device15finalize_burninEv["X"]=1;

function __ZNK13screen_device4vposEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $delta=__stackBase__;
  var $2=__stackBase__+8;
  var $3=__stackBase__+20;
  var $vpos;
  $1=$this;
  var $4=$1;
  var $5=$4;
  var $6=__ZNK8device_t7machineEv($5);
  __ZNK15running_machine4timeEv($2, $6);
  var $7=(($4+508)|0);
  __ZmiRK8attotimeS1_($3, $2, $7);
  var $8=__ZNK8attotime14as_attosecondsEv($3);
  var $8$0=$8[0];
  var $8$1=$8[1];
  var $st$15$0=(($delta)|0);
  HEAP32[(($st$15$0)>>2)]=$8$0;
  var $st$15$1=(($delta+4)|0);
  HEAP32[(($st$15$1)>>2)]=$8$1;
  var $9=(($4+492)|0);
  var $st$20$0=(($9)|0);
  var $10$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($9+4)|0);
  var $10$1=HEAP32[(($st$20$1)>>2)];
  var $$emscripten$temp$0$0=2;
  var $$emscripten$temp$0$1=0;
  var $11$0 = (tempBigIntR=((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $11$1 = Math.min(Math.floor(((tempBigIntR=((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $st$27$0=(($delta)|0);
  var $12$0=HEAP32[(($st$27$0)>>2)];
  var $st$27$1=(($delta+4)|0);
  var $12$1=HEAP32[(($st$27$1)>>2)];
  var $13$0 = ((($12$0)>>>0)+((($12$1)|0)*4294967296))+((($11$0)>>>0)+((($11$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($12$0)>>>0)+((($12$1)|0)*4294967296))+((($11$0)>>>0)+((($11$1)|0)*4294967296)))/4294967296), 4294967295);
  var $st$32$0=(($delta)|0);
  HEAP32[(($st$32$0)>>2)]=$13$0;
  var $st$32$1=(($delta+4)|0);
  HEAP32[(($st$32$1)>>2)]=$13$1;
  var $st$36$0=(($delta)|0);
  var $14$0=HEAP32[(($st$36$0)>>2)];
  var $st$36$1=(($delta+4)|0);
  var $14$1=HEAP32[(($st$36$1)>>2)];
  var $15=(($4+484)|0);
  var $st$41$0=(($15)|0);
  var $16$0=HEAP32[(($st$41$0)>>2)];
  var $st$41$1=(($15+4)|0);
  var $16$1=HEAP32[(($st$41$1)>>2)];
  var $17$0 = (tempBigIntR=((($14$0)>>>0)+((($14$1)|0)*4294967296))/((($16$0)>>>0)+((($16$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $17$1 = Math.min(Math.floor(((tempBigIntR=((($14$0)>>>0)+((($14$1)|0)*4294967296))/((($16$0)>>>0)+((($16$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $18$0=$17$0;
  var $18=$18$0;
  $vpos=$18;
  var $19=(($4+420)|0);
  var $20=(($19+12)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=(($21+1)|0);
  var $23=$vpos;
  var $24=(($22+$23)|0);
  var $25=(($4+416)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=(($24)|0)%(($26)|0);
  STACKTOP = __stackBase__;
  return $27;
}
__ZNK13screen_device4vposEv["X"]=1;

function __ZNK13screen_device23time_until_vblank_startEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+420)|0);
  var $4=(($3+12)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  __ZNK13screen_device14time_until_posEii($agg_result, $2, $6, 0);
  ;
  return;
}


function __ZN13screen_device18scanline0_callbackEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  $1=$this;
  var $4=$1;
  var $5=(($4+468)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($4+556)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($4+540)|0);
  var $8=HEAP32[(($7)>>2)];
  __ZNK13screen_device14time_until_posEii($2, $4, 0, 0);
  var $9=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  __ZN9emu_timer6adjustE8attotimeiS0_($8, $2, 0, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13screen_device21vblank_begin_callbackEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $item;
      var $5=__stackBase__+36;
      var $6=__stackBase__+48;
      var $7=__stackBase__+60;
      var $8=__stackBase__+72;
      $1=$this;
      var $9=$1;
      var $10=(($9+508)|0);
      var $11=$9;
      var $12=__ZNK8device_t7machineEv($11);
      __ZNK15running_machine4timeEv($2, $12);
      var $13=$10;
      var $14=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[(($14)>>2)];HEAP32[(($13+4)>>2)]=HEAP32[(($14+4)>>2)];HEAP32[(($13+8)>>2)]=HEAP32[(($14+8)>>2)];
      var $15=(($9+520)|0);
      var $16=(($9+508)|0);
      var $17=(($9+500)|0);
      var $st$21$0=(($17)|0);
      var $18$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($17+4)|0);
      var $18$1=HEAP32[(($st$21$1)>>2)];
      __ZN8attotimeC1Eix($4, 0, $18$0, $18$1);
      __ZplRK8attotimeS1_($3, $16, $4);
      var $19=$15;
      var $20=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[(($20+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[(($20+8)>>2)];
      var $21=(($9+560)|0);
      var $22=__ZNK11simple_listIN13screen_device13callback_itemEE5firstEv($21);
      $item=$22;
      __label__ = 1; break;
    case 1: // $23
      var $24=$item;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $26
      var $27=$item;
      var $28=(($27+4)|0);
      var $29=$28;
      __ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EclES1_b($29, $9, 1);
      __label__ = 3; break;
    case 3: // $30
      var $31=$item;
      var $32=__ZNK13screen_device13callback_item4nextEv($31);
      $item=$32;
      __label__ = 1; break;
    case 4: // $33
      var $34=$9;
      var $35=__ZNK8device_t7machineEv($34);
      var $36=(($35+560)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($9)|0)==(($37)|0);
      if ($38) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $39
      var $40=$9;
      var $41=__ZNK8device_t7machineEv($40);
      var $42=__ZNK15running_machine6configEv($41);
      var $43=(($42+40)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44 & 4;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $47
      var $48=$9;
      var $49=__ZNK8device_t7machineEv($48);
      var $50=__ZNK15running_machine5videoEv($49);
      __ZN13video_manager12frame_updateEb($50, 0);
      __label__ = 7; break;
    case 7: // $51
      var $52=(($9+532)|0);
      var $53=HEAP32[(($52)>>2)];
      __ZNK13screen_device23time_until_vblank_startEv($5, $9);
      var $54=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($54)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($54+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($54+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($53, $5, 0, $6);
      var $55=(($9+500)|0);
      var $st$7$0=(($55)|0);
      var $56$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($55+4)|0);
      var $56$1=HEAP32[(($st$7$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $57=$56$0 == $$emscripten$temp$0$0 && $56$1 == $$emscripten$temp$0$1;
      if ($57) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      __ZN13screen_device19vblank_end_callbackEv($9);
      __label__ = 10; break;
    case 9: // $59
      var $60=(($9+536)|0);
      var $61=HEAP32[(($60)>>2)];
      __ZNK13screen_device21time_until_vblank_endEv($7, $9);
      var $62=$8;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($62)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($62+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($62+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($61, $7, 0, $8);
      __label__ = 10; break;
    case 10: // $63
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device21vblank_begin_callbackEv["X"]=1;

function __ZN13screen_device14update_partialEi($this, $scanline) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $clip=__stackBase__;
      var $result;
      var $flags;
      $2=$this;
      $3=$scanline;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      __label__ = 3; break;
    case 3: // $7
      __label__ = 4; break;
    case 4: // $8
      var $9=$4;
      var $10=__ZNK8device_t7machineEv($9);
      var $11=__ZNK15running_machine6configEv($10);
      var $12=(($11+40)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 & 128;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 14; break; } else { __label__ = 5; break; }
    case 5: // $16
      var $17=$4;
      var $18=__ZNK8device_t7machineEv($17);
      var $19=__ZNK15running_machine5videoEv($18);
      var $20=__ZNK13video_manager15skip_this_frameEv($19);
      if ($20) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $21
      __label__ = 7; break;
    case 7: // $22
      __label__ = 8; break;
    case 8: // $23
      $1=0;
      __label__ = 27; break;
    case 9: // $24
      var $25=$4;
      var $26=__ZNK8device_t7machineEv($25);
      var $27=__ZNK15running_machine6renderEv($26);
      var $28=__ZNK14render_manager7is_liveER13screen_device($27, $4);
      if ($28) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $29
      __label__ = 11; break;
    case 11: // $30
      __label__ = 12; break;
    case 12: // $31
      $1=0;
      __label__ = 27; break;
    case 13: // $32
      __label__ = 14; break;
    case 14: // $33
      var $34=$3;
      var $35=(($4+468)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($34)|0) < (($36)|0);
      if ($37) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $38
      __label__ = 16; break;
    case 16: // $39
      __label__ = 17; break;
    case 17: // $40
      $1=0;
      __label__ = 27; break;
    case 18: // $41
      var $42=(($4+420)|0);
      var $43=$clip;
      var $44=$42;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($43)>>2)]=HEAP32[(($44)>>2)];HEAP32[(($43+4)>>2)]=HEAP32[(($44+4)>>2)];HEAP32[(($43+8)>>2)]=HEAP32[(($44+8)>>2)];HEAP32[(($43+12)>>2)]=HEAP32[(($44+12)>>2)];
      var $45=(($4+468)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($clip+8)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($46)|0) > (($48)|0);
      if ($49) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $50
      var $51=(($4+468)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($clip+8)|0);
      HEAP32[(($53)>>2)]=$52;
      __label__ = 20; break;
    case 20: // $54
      var $55=$3;
      var $56=(($clip+12)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($55)|0) < (($57)|0);
      if ($58) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $59
      var $60=$3;
      var $61=(($clip+12)|0);
      HEAP32[(($61)>>2)]=$60;
      __label__ = 22; break;
    case 22: // $62
      $result=0;
      var $63=(($clip+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($clip+12)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($64)|0) <= (($66)|0);
      if ($67) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $68
      $flags=1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 261);
      __label__ = 24; break;
    case 24: // $69
      __label__ = 25; break;
    case 25: // $70
      var $71=(($4+456)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($4+444)|0);
      var $75=(($74+($73<<2))|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=__ZN13screen_device13screen_updateER8bitmap_tRK10_rectangle($4, $76, $clip);
      var $78=(($77)&1);
      $flags=$78;
      var $79=(($4+556)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+1)|0);
      HEAP32[(($79)>>2)]=$81;
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $82=$flags;
      var $83=$82 ^ -1;
      var $84=$83 & 1;
      var $85=(($4+464)|0);
      var $86=HEAP8[($85)];
      var $87=(($86) & 1);
      var $88=(($87)&1);
      var $89=$88 | $84;
      var $90=(($89)|0)!=0;
      var $91=(($90)&1);
      HEAP8[($85)]=$91;
      $result=1;
      __label__ = 26; break;
    case 26: // $92
      var $93=$3;
      var $94=(($93+1)|0);
      var $95=(($4+468)|0);
      HEAP32[(($95)>>2)]=$94;
      var $96=$result;
      var $97=(($96) & 1);
      $1=$97;
      __label__ = 27; break;
    case 27: // $98
      var $99=$1;
      STACKTOP = __stackBase__;
      return $99;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device14update_partialEi["X"]=1;

function __ZN13screen_device13screen_updateER8bitmap_tRK10_rectangle($this, $bitmap, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$bitmap;
      $4=$cliprect;
      var $5=$2;
      var $6=(($5+400)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=(($5+400)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=FUNCTION_TABLE[$11]($5, $12, $13);
      var $15=(($14)|0)!=0;
      $1=$15;
      __label__ = 4; break;
    case 2: // $16
      var $17=$5;
      var $18=__ZNK8device_t7machineEv($17);
      var $19=__ZNK15running_machine11driver_dataI13driver_deviceEEPT_v($18);
      var $20=$19;
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+60)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$3;
      var $25=$4;
      var $26=FUNCTION_TABLE[$23]($19, $5, $24, $25);
      __label__ = 3; break;
    case 3: // $27
      $1=0;
      __label__ = 4; break;
    case 4: // $28
      var $29=$1;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13screen_device4hposEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $delta=__stackBase__;
  var $2=__stackBase__+8;
  var $3=__stackBase__+20;
  var $vpos;
  $1=$this;
  var $4=$1;
  var $5=$4;
  var $6=__ZNK8device_t7machineEv($5);
  __ZNK15running_machine4timeEv($2, $6);
  var $7=(($4+508)|0);
  __ZmiRK8attotimeS1_($3, $2, $7);
  var $8=__ZNK8attotime14as_attosecondsEv($3);
  var $8$0=$8[0];
  var $8$1=$8[1];
  var $st$15$0=(($delta)|0);
  HEAP32[(($st$15$0)>>2)]=$8$0;
  var $st$15$1=(($delta+4)|0);
  HEAP32[(($st$15$1)>>2)]=$8$1;
  var $9=(($4+492)|0);
  var $st$20$0=(($9)|0);
  var $10$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($9+4)|0);
  var $10$1=HEAP32[(($st$20$1)>>2)];
  var $$emscripten$temp$0$0=2;
  var $$emscripten$temp$0$1=0;
  var $11$0 = (tempBigIntR=((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $11$1 = Math.min(Math.floor(((tempBigIntR=((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $st$27$0=(($delta)|0);
  var $12$0=HEAP32[(($st$27$0)>>2)];
  var $st$27$1=(($delta+4)|0);
  var $12$1=HEAP32[(($st$27$1)>>2)];
  var $13$0 = ((($12$0)>>>0)+((($12$1)|0)*4294967296))+((($11$0)>>>0)+((($11$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($12$0)>>>0)+((($12$1)|0)*4294967296))+((($11$0)>>>0)+((($11$1)|0)*4294967296)))/4294967296), 4294967295);
  var $st$32$0=(($delta)|0);
  HEAP32[(($st$32$0)>>2)]=$13$0;
  var $st$32$1=(($delta+4)|0);
  HEAP32[(($st$32$1)>>2)]=$13$1;
  var $st$36$0=(($delta)|0);
  var $14$0=HEAP32[(($st$36$0)>>2)];
  var $st$36$1=(($delta+4)|0);
  var $14$1=HEAP32[(($st$36$1)>>2)];
  var $15=(($4+484)|0);
  var $st$41$0=(($15)|0);
  var $16$0=HEAP32[(($st$41$0)>>2)];
  var $st$41$1=(($15+4)|0);
  var $16$1=HEAP32[(($st$41$1)>>2)];
  var $17$0 = (tempBigIntR=((($14$0)>>>0)+((($14$1)|0)*4294967296))/((($16$0)>>>0)+((($16$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $17$1 = Math.min(Math.floor(((tempBigIntR=((($14$0)>>>0)+((($14$1)|0)*4294967296))/((($16$0)>>>0)+((($16$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $18$0=$17$0;
  var $18=$18$0;
  $vpos=$18;
  var $19=$vpos;
  var $20$0=$19;
  var $20$1=(($19|0) < 0 ? -1 : 0);
  var $21=(($4+484)|0);
  var $st$53$0=(($21)|0);
  var $22$0=HEAP32[(($st$53$0)>>2)];
  var $st$53$1=(($21+4)|0);
  var $22$1=HEAP32[(($st$53$1)>>2)];
  var $23$0 = ((($20$0)>>>0)+((($20$1)|0)*4294967296))*((($22$0)>>>0)+((($22$1)|0)*4294967296))>>>0; var $23$1 = Math.min(Math.floor((((($20$0)>>>0)+((($20$1)|0)*4294967296))*((($22$0)>>>0)+((($22$1)|0)*4294967296)))/4294967296), 4294967295);
  var $st$58$0=(($delta)|0);
  var $24$0=HEAP32[(($st$58$0)>>2)];
  var $st$58$1=(($delta+4)|0);
  var $24$1=HEAP32[(($st$58$1)>>2)];
  var $25$0 = ((($24$0)>>>0)+((($24$1)|0)*4294967296))-((($23$0)>>>0)+((($23$1)|0)*4294967296))>>>0; var $25$1 = Math.min(Math.floor((((($24$0)>>>0)+((($24$1)|0)*4294967296))-((($23$0)>>>0)+((($23$1)|0)*4294967296)))/4294967296), 4294967295);
  var $st$63$0=(($delta)|0);
  HEAP32[(($st$63$0)>>2)]=$25$0;
  var $st$63$1=(($delta+4)|0);
  HEAP32[(($st$63$1)>>2)]=$25$1;
  var $st$67$0=(($delta)|0);
  var $26$0=HEAP32[(($st$67$0)>>2)];
  var $st$67$1=(($delta+4)|0);
  var $26$1=HEAP32[(($st$67$1)>>2)];
  var $27=(($4+492)|0);
  var $st$72$0=(($27)|0);
  var $28$0=HEAP32[(($st$72$0)>>2)];
  var $st$72$1=(($27+4)|0);
  var $28$1=HEAP32[(($st$72$1)>>2)];
  var $29$0 = (tempBigIntR=((($26$0)>>>0)+((($26$1)|0)*4294967296))/((($28$0)>>>0)+((($28$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $29$1 = Math.min(Math.floor(((tempBigIntR=((($26$0)>>>0)+((($26$1)|0)*4294967296))/((($28$0)>>>0)+((($28$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $30$0=$29$0;
  var $30=$30$0;
  STACKTOP = __stackBase__;
  return $30;
}
__ZNK13screen_device4hposEv["X"]=1;

function __ZNK13screen_device21time_until_vblank_endEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $target_time=__stackBase__;
      var $2=__stackBase__+12;
      var $3=__stackBase__+24;
      $1=$this;
      var $4=$1;
      var $5=(($4+520)|0);
      var $6=$target_time;
      var $7=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[(($7+8)>>2)];
      var $8=__ZNK13screen_device6vblankEv($4);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=(($4+476)|0);
      var $st$1$0=(($10)|0);
      var $11$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($10+4)|0);
      var $11$1=HEAP32[(($st$1$1)>>2)];
      __ZN8attotimeC1Eix($2, 0, $11$0, $11$1);
      var $12=__ZN8attotimepLERKS_($target_time, $2);
      __label__ = 2; break;
    case 2: // $13
      var $14=$4;
      var $15=__ZNK8device_t7machineEv($14);
      __ZNK15running_machine4timeEv($3, $15);
      __ZmiRK8attotimeS1_($agg_result, $target_time, $3);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device22realloc_screen_bitmapsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $result_i1=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $curwidth;
      var $curheight;
      var $palette;
      var $18;
      var $19;
      $17=$this;
      var $20=$17;
      var $21=(($20+356)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==2;
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      __label__ = 44; break;
    case 2: // $25
      $curwidth=0;
      $curheight=0;
      var $26=(($20+444)|0);
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $30
      var $31=(($20+444)|0);
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33;
      var $35=(($34+12)|0);
      var $36=HEAP32[(($35)>>2)];
      $curwidth=$36;
      var $37=(($20+444)|0);
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      var $41=(($40+16)|0);
      var $42=HEAP32[(($41)>>2)];
      $curheight=$42;
      __label__ = 4; break;
    case 4: // $43
      var $44=(($20+412)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$curwidth;
      var $47=(($45)|0) > (($46)|0);
      if ($47) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $48
      var $49=(($20+416)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$curheight;
      var $52=(($50)|0) > (($51)|0);
      if ($52) { __label__ = 6; break; } else { __label__ = 44; break; }
    case 6: // $53
      var $54=$20;
      var $55=__ZNK8device_t7machineEv($54);
      var $56=__ZNK15running_machine6renderEv($55);
      var $57=(($20+436)|0);
      var $58=(($57)|0);
      var $59=HEAP32[(($58)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($56, $59);
      var $60=$20;
      var $61=__ZNK8device_t7machineEv($60);
      var $62=__ZNK15running_machine6renderEv($61);
      var $63=(($20+436)|0);
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($62, $65);
      var $66=$20;
      var $67=__ZNK8device_t7machineEv($66);
      var $68=__ZN15running_machine7respoolEv($67);
      var $69=(($20+444)|0);
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71;
      __ZN13resource_pool6removeEPv($68, $72);
      var $73=$20;
      var $74=__ZNK8device_t7machineEv($73);
      var $75=__ZN15running_machine7respoolEv($74);
      var $76=(($20+444)|0);
      var $77=(($76+4)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$78;
      __ZN13resource_pool6removeEPv($75, $79);
      var $80=(($20+412)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$curwidth;
      var $83=(($81)|0) > (($82)|0);
      if ($83) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $84
      var $85=(($20+412)|0);
      var $86=HEAP32[(($85)>>2)];
      var $90 = $86;__label__ = 9; break;
    case 8: // $87
      var $88=$curwidth;
      var $90 = $88;__label__ = 9; break;
    case 9: // $89
      var $90;
      $curwidth=$90;
      var $91=(($20+416)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$curheight;
      var $94=(($92)|0) > (($93)|0);
      if ($94) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $95
      var $96=(($20+416)|0);
      var $97=HEAP32[(($96)>>2)];
      var $101 = $97;__label__ = 12; break;
    case 11: // $98
      var $99=$curheight;
      var $101 = $99;__label__ = 12; break;
    case 12: // $100
      var $101;
      $curheight=$101;
      $palette=0;
      var $102=(($20+380)|0);
      var $103=HEAP32[(($102)>>2)];
      if ($103 == 2) {
        __label__ = 13; break;
      }
      else if ($103 == 5) {
        __label__ = 14; break;
      }
      else if ($103 == 6) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 13: // $104
      var $105=(($20+460)|0);
      HEAP32[(($105)>>2)]=1;
      var $106=$20;
      var $107=__ZNK8device_t7machineEv($106);
      var $108=(($107+564)|0);
      var $109=HEAP32[(($108)>>2)];
      $palette=$109;
      __label__ = 17; break;
    case 14: // $110
      var $111=(($20+460)|0);
      HEAP32[(($111)>>2)]=3;
      $palette=0;
      __label__ = 17; break;
    case 15: // $112
      var $113=(($20+460)|0);
      HEAP32[(($113)>>2)]=4;
      $palette=0;
      __label__ = 17; break;
    case 16: // $114
      __Z10fatalerrorPKcz(((STRING_TABLE.__str272800)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 17: // $115
      var $116=$20;
      var $117=__ZNK8device_t7machineEv($116);
      var $118=__ZN15running_machine7respoolEv($117);
      var $119=$12;
      var $120=$13;
      var $121=$14;
      var $122=$result_i;
      var $123=$15;
      var $124=$16;
      HEAP32[(($12)>>2)]=48;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($14)>>2)]=531;
      var $125=HEAP32[(($12)>>2)];
      var $126=HEAP32[(($13)>>2)];
      var $127=HEAP32[(($14)>>2)];
      var $128=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($125, $126, $127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $129
      HEAP32[(($result_i)>>2)]=$128;
      var $130=HEAP32[(($result_i)>>2)];
      var $131=(($130)|0)==0;
      if ($131) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $132
      var $133=___cxa_allocate_exception(4);
      var $134=$133;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($134);
      (function() { try { __THREW__ = false; return ___cxa_throw($133, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 20; break; }
    case 20: // $135
      var $136=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $137=$136.f0;
      HEAP32[(($15)>>2)]=$137;
      var $138=$136.f1;
      HEAP32[(($16)>>2)]=$138;
      var $139=HEAP32[(($16)>>2)];
      var $140=(($139)|0) < 0;
      if ($140) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $141
      var $142=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($142);
      throw "Reached an unreachable!"
    case 22: // $143
      var $144=HEAP32[(($15)>>2)];
      var $145=HEAP32[(($15)>>2)];
      var $146=HEAP32[(($16)>>2)];
      var $147=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $145, tempValue);
      var $148=($147.f1 = $146, $147);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $149
      throw "Reached an unreachable!"
    case 24: // $_ZnwjPKci_exit
      var $150=HEAP32[(($result_i)>>2)];
      var $151=$12;
      var $152=$13;
      var $153=$14;
      var $154=$result_i;
      var $155=$15;
      var $156=$16;
      var $157=$150;
      var $158=$curwidth;
      var $159=$curheight;
      var $160=(($20+380)|0);
      var $161=HEAP32[(($160)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($157, $158, $159, $161, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 34; break; }
    case 25: // $162
      var $163=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($118, $157);
      var $164=(($20+444)|0);
      var $165=(($164)|0);
      HEAP32[(($165)>>2)]=$163;
      var $166=(($20+444)|0);
      var $167=(($166)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$20;
      var $170=__ZNK8device_t7machineEv($169);
      var $171=(($170+564)|0);
      var $172=HEAP32[(($171)>>2)];
      __Z18bitmap_set_paletteP8bitmap_tP10_palette_t($168, $172);
      var $173=$20;
      var $174=__ZNK8device_t7machineEv($173);
      var $175=__ZN15running_machine7respoolEv($174);
      var $176=$7;
      var $177=$8;
      var $178=$9;
      var $179=$result_i1;
      var $180=$10;
      var $181=$11;
      HEAP32[(($7)>>2)]=48;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($9)>>2)]=533;
      var $182=HEAP32[(($7)>>2)];
      var $183=HEAP32[(($8)>>2)];
      var $184=HEAP32[(($9)>>2)];
      var $185=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($182, $183, $184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 28; break; };
    case 26: // $186
      HEAP32[(($result_i1)>>2)]=$185;
      var $187=HEAP32[(($result_i1)>>2)];
      var $188=(($187)|0)==0;
      if ($188) { __label__ = 27; break; } else { __label__ = 32; break; }
    case 27: // $189
      var $190=___cxa_allocate_exception(4);
      var $191=$190;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($191);
      (function() { try { __THREW__ = false; return ___cxa_throw($190, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 28; break; }
    case 28: // $192
      var $193=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $194=$193.f0;
      HEAP32[(($10)>>2)]=$194;
      var $195=$193.f1;
      HEAP32[(($11)>>2)]=$195;
      var $196=HEAP32[(($11)>>2)];
      var $197=(($196)|0) < 0;
      if ($197) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $198
      var $199=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($199);
      throw "Reached an unreachable!"
    case 30: // $200
      var $201=HEAP32[(($10)>>2)];
      var $202=HEAP32[(($10)>>2)];
      var $203=HEAP32[(($11)>>2)];
      var $204=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $202, tempValue);
      var $205=($204.f1 = $203, $204);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 31: // $206
      throw "Reached an unreachable!"
    case 32: // $_ZnwjPKci_exit2
      var $207=HEAP32[(($result_i1)>>2)];
      var $208=$7;
      var $209=$8;
      var $210=$9;
      var $211=$result_i1;
      var $212=$10;
      var $213=$11;
      var $214=$207;
      var $215=$curwidth;
      var $216=$curheight;
      var $217=(($20+380)|0);
      var $218=HEAP32[(($217)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($214, $215, $216, $218, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $219
      var $220=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($175, $214);
      var $221=(($20+444)|0);
      var $222=(($221+4)|0);
      HEAP32[(($222)>>2)]=$220;
      var $223=(($20+444)|0);
      var $224=(($223+4)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$20;
      var $227=__ZNK8device_t7machineEv($226);
      var $228=(($227+564)|0);
      var $229=HEAP32[(($228)>>2)];
      __Z18bitmap_set_paletteP8bitmap_tP10_palette_t($225, $229);
      var $230=$20;
      var $231=__ZNK8device_t7machineEv($230);
      var $232=__ZNK15running_machine6renderEv($231);
      var $233=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($232, 0, 0);
      var $234=(($20+436)|0);
      var $235=(($234)|0);
      HEAP32[(($235)>>2)]=$233;
      var $236=(($20+436)|0);
      var $237=(($236)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($20+444)|0);
      var $240=(($239)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($20+420)|0);
      var $243=(($20+460)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$palette;
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($238, $241, $242, $244, $245);
      var $246=$20;
      var $247=__ZNK8device_t7machineEv($246);
      var $248=__ZNK15running_machine6renderEv($247);
      var $249=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($248, 0, 0);
      var $250=(($20+436)|0);
      var $251=(($250+4)|0);
      HEAP32[(($251)>>2)]=$249;
      var $252=(($20+436)|0);
      var $253=(($252+4)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($20+444)|0);
      var $256=(($255+4)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($20+420)|0);
      var $259=(($20+460)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=$palette;
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($254, $257, $258, $260, $261);
      __label__ = 44; break;
    case 34: // $262
      var $263=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $264=$263.f0;
      $18=$264;
      var $265=$263.f1;
      $19=$265;
      var $266=$4;
      var $267=$5;
      var $268=$6;
      HEAP32[(($4)>>2)]=$150;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($6)>>2)]=531;
      var $269=HEAP32[(($4)>>2)];
      var $270=(($269)|0)!=0;
      if ($270) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $271
      var $272=HEAP32[(($4)>>2)];
      var $273=HEAP32[(($5)>>2)];
      var $274=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($272, $273, $274) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 46; break; }
    case 36: // $_noexc
      __label__ = 37; break;
    case 37: // $_ZdlPvPKci_exit
      var $275=$4;
      var $276=$5;
      var $277=$6;
      __label__ = 38; break;
    case 38: // $278
      __label__ = 45; break;
    case 39: // $279
      var $280=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $281=$280.f0;
      $18=$281;
      var $282=$280.f1;
      $19=$282;
      var $283=$1;
      var $284=$2;
      var $285=$3;
      HEAP32[(($1)>>2)]=$207;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($3)>>2)]=533;
      var $286=HEAP32[(($1)>>2)];
      var $287=(($286)|0)!=0;
      if ($287) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $288
      var $289=HEAP32[(($1)>>2)];
      var $290=HEAP32[(($2)>>2)];
      var $291=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($289, $290, $291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 46; break; }
    case 41: // $_noexc3
      __label__ = 42; break;
    case 42: // $_ZdlPvPKci_exit4
      var $292=$1;
      var $293=$2;
      var $294=$3;
      __label__ = 43; break;
    case 43: // $295
      __label__ = 45; break;
    case 44: // $296
      STACKTOP = __stackBase__;
      return;
    case 45: // $297
      var $298=$18;
      var $299=$18;
      var $300=$19;
      var $301=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $299, tempValue);
      var $302=($301.f1 = $300, $301);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $303
      var $304=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device22realloc_screen_bitmapsEv["X"]=1;

function __ZNK11simple_listIN13screen_device13callback_itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device13callback_item4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN13screen_device13callback_itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8attotimepLERKS_($this, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$right;
      var $4=$2;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) >= 1000000000;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0) >= 1000000000;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($14)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($14+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($14+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      $1=$4;
      __label__ = 8; break;
    case 3: // $15
      var $16=$3;
      var $17=(($16+4)|0);
      var $st$2$0=(($17)|0);
      var $18$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($17+4)|0);
      var $18$1=HEAP32[(($st$2$1)>>2)];
      var $19=(($4+4)|0);
      var $st$7$0=(($19)|0);
      var $20$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($19+4)|0);
      var $20$1=HEAP32[(($st$7$1)>>2)];
      var $21$0 = ((($20$0)>>>0)+((($20$1)|0)*4294967296))+((($18$0)>>>0)+((($18$1)|0)*4294967296))>>>0; var $21$1 = Math.min(Math.floor((((($20$0)>>>0)+((($20$1)|0)*4294967296))+((($18$0)>>>0)+((($18$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($19)|0);
      HEAP32[(($st$12$0)>>2)]=$21$0;
      var $st$12$1=(($19+4)|0);
      HEAP32[(($st$12$1)>>2)]=$21$1;
      var $22=$3;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+$24)|0);
      HEAP32[(($25)>>2)]=$27;
      var $28=(($4+4)|0);
      var $st$24$0=(($28)|0);
      var $29$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$24$1)>>2)];
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $30=($29$1|0) >= ($$emscripten$temp$0$1|0) && (($29$1|0) >  ($$emscripten$temp$0$1|0) || ($29$0|0) >= ($$emscripten$temp$0$0|0));
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=(($4+4)|0);
      var $st$1$0=(($32)|0);
      var $33$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($32+4)|0);
      var $33$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $34$0 = ((($33$0)>>>0)+((($33$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $34$1 = Math.min(Math.floor((((($33$0)>>>0)+((($33$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($32)|0);
      HEAP32[(($st$8$0)>>2)]=$34$0;
      var $st$8$1=(($32+4)|0);
      HEAP32[(($st$8$1)>>2)]=$34$1;
      var $35=(($4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      HEAP32[(($35)>>2)]=$37;
      __label__ = 5; break;
    case 5: // $38
      var $39=(($4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0) >= 1000000000;
      if ($41) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $42
      var $43=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($43)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($43+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($43+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      $1=$4;
      __label__ = 8; break;
    case 7: // $44
      $1=$4;
      __label__ = 8; break;
    case 8: // $45
      var $46=$1;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8attotimepLERKS_["X"]=1;

function __ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EeqERKS3_($this, $rhs) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$rhs;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { var $23 = 0;__label__ = 3; break; }
    case 1: // $10
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0)==(($15)|0);
      if ($16) { __label__ = 2; break; } else { var $23 = 0;__label__ = 3; break; }
    case 2: // $17
      var $18=(($3+12)|0);
      var $19=$2;
      var $20=(($19+12)|0);
      var $21=__ZNK21delegate_internal_mfpeqERKS_($18, $20);
      var $23 = $21;__label__ = 3; break;
    case 3: // $22
      var $23;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device13callback_itemC1E8delegateIFvRS_bEE($this, $callback) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13screen_device13callback_itemC2E8delegateIFvRS_bEE($2, $callback);
  ;
  return;
}


function __ZN8delegateIFvR13screen_devicebEEC1ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvR13screen_devicebEEC2ERKS3_($4, $5);
  ;
  return;
}


function __ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EclES1_b($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  var $4=(($p2)&1);
  $3=$4;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($5+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $12=(($11) & 1);
  FUNCTION_TABLE[$7]($9, $10, $12);
  ;
  return;
}


function __ZN13screen_device19vblank_end_callbackEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $item;
      $1=$this;
      var $2=$1;
      var $3=(($2+560)|0);
      var $4=__ZNK11simple_listIN13screen_device13callback_itemEE5firstEv($3);
      $item=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$item;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$item;
      var $10=(($9+4)|0);
      var $11=$10;
      __ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EclES1_b($11, $2, 0);
      __label__ = 3; break;
    case 3: // $12
      var $13=$item;
      var $14=__ZNK13screen_device13callback_item4nextEv($13);
      $item=$14;
      __label__ = 1; break;
    case 4: // $15
      var $16=$2;
      var $17=__ZNK8device_t7machineEv($16);
      var $18=(($17+560)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($2)|0)==(($19)|0);
      if ($20) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $21
      var $22=$2;
      var $23=__ZNK8device_t7machineEv($22);
      var $24=__ZNK15running_machine6configEv($23);
      var $25=(($24+40)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 & 4;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      var $30=$2;
      var $31=__ZNK8device_t7machineEv($30);
      var $32=__ZNK15running_machine5videoEv($31);
      __ZN13video_manager12frame_updateEb($32, 0);
      __label__ = 7; break;
    case 7: // $33
      var $34=(($2+548)|0);
      var $st$1$0=(($34)|0);
      var $35$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($34+4)|0);
      var $35$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $36$0 = ((($35$0)>>>0)+((($35$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $36$1 = Math.min(Math.floor((((($35$0)>>>0)+((($35$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($34)|0);
      HEAP32[(($st$8$0)>>2)]=$36$0;
      var $st$8$1=(($34+4)|0);
      HEAP32[(($st$8$1)>>2)]=$36$1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device19vblank_end_callbackEv["X"]=1;

function __ZN13screen_device24scanline_update_callbackEi($this, $scanline) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+12;
      $1=$this;
      $2=$scanline;
      var $5=$1;
      var $6=$2;
      var $7=__ZN13screen_device14update_partialEi($5, $6);
      var $8=$2;
      var $9=(($8+1)|0);
      $2=$9;
      var $10=$2;
      var $11=(($5+420)|0);
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($10)|0) > (($13)|0);
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=(($5+420)|0);
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      $2=$18;
      __label__ = 2; break;
    case 2: // $19
      var $20=(($5+544)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$2;
      __ZNK13screen_device14time_until_posEii($3, $5, $22, 0);
      var $23=$2;
      var $24=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($24+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($24+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($21, $3, $23, $4);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device12update_quadsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $fixedvis=__stackBase__;
      var $palette;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=__ZNK15running_machine6renderEv($4);
      var $6=__ZNK14render_manager7is_liveER13screen_device($5, $2);
      if ($6) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $7
      var $8=(($2+356)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=2;
      if ($10) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $11
      var $12=$2;
      var $13=__ZNK8device_t7machineEv($12);
      var $14=__ZNK15running_machine6configEv($13);
      var $15=(($14+40)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 8;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $19
      var $20=$2;
      var $21=__ZNK8device_t7machineEv($20);
      var $22=__ZNK15running_machine5videoEv($21);
      var $23=__ZNK13video_manager15skip_this_frameEv($22);
      if ($23) { __label__ = 9; break; } else { __label__ = 4; break; }
    case 4: // $24
      var $25=(($2+464)|0);
      var $26=HEAP8[($25)];
      var $27=(($26) & 1);
      if ($27) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $28
      var $29=(($2+420)|0);
      var $30=$fixedvis;
      var $31=$29;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($30)>>2)]=HEAP32[(($31)>>2)];HEAP32[(($30+4)>>2)]=HEAP32[(($31+4)>>2)];HEAP32[(($30+8)>>2)]=HEAP32[(($31+8)>>2)];HEAP32[(($30+12)>>2)]=HEAP32[(($31+12)>>2)];
      var $32=(($fixedvis+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+1)|0);
      HEAP32[(($32)>>2)]=$34;
      var $35=(($fixedvis+12)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      HEAP32[(($35)>>2)]=$37;
      var $38=(($2+460)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==1;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$2;
      var $43=__ZNK8device_t7machineEv($42);
      var $44=(($43+564)|0);
      var $45=HEAP32[(($44)>>2)];
      var $48 = $45;__label__ = 8; break;
    case 7: // $46
      var $48 = 0;__label__ = 8; break;
    case 8: // $47
      var $48;
      $palette=$48;
      var $49=(($2+456)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=(($2+436)|0);
      var $53=(($52+($51<<2))|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($2+456)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=(($2+444)|0);
      var $59=(($58+($57<<2))|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($2+460)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$palette;
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($54, $60, $fixedvis, $62, $63);
      var $64=(($2+456)|0);
      var $65=HEAP8[($64)];
      var $66=(($2+457)|0);
      HEAP8[($66)]=$65;
      var $67=(($2+456)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=((1-$69)|0);
      var $71=(($70) & 255);
      var $72=(($2+456)|0);
      HEAP8[($72)]=$71;
      __label__ = 9; break;
    case 9: // $73
      var $74=(($2+408)|0);
      var $75=HEAP32[(($74)>>2)];
      __ZN16render_container5emptyEv($75);
      var $76=(($2+408)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($2+457)|0);
      var $79=HEAPU8[($78)];
      var $80=(($79)&255);
      var $81=(($2+436)|0);
      var $82=(($81+($80<<2))|0);
      var $83=HEAP32[(($82)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($77, 0, 0, 1, 1, -1, $83, 8192);
      __label__ = 10; break;
    case 10: // $84
      __label__ = 11; break;
    case 11: // $85
      var $86=(($2+464)|0);
      var $87=HEAP8[($86)];
      var $88=(($87) & 1);
      var $89=(($88)&1);
      $result=$89;
      var $90=(($2+464)|0);
      HEAP8[($90)]=0;
      var $91=$result;
      var $92=(($91) & 1);
      STACKTOP = __stackBase__;
      return $92;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device12update_quadsEv["X"]=1;

function __ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE($this, $vblank_callback) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $item;
      var $10=__stackBase__+36;
      var $11;
      var $12;
      $9=$this;
      var $13=$9;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=(($13+560)|0);
      var $17=__ZNK11simple_listIN13screen_device13callback_itemEE5firstEv($16);
      $item=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$item;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $21
      var $22=$item;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$vblank_callback;
      var $26=__ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EeqERKS3_($24, $25);
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      __label__ = 8; break;
    case 6: // $28
      __label__ = 7; break;
    case 7: // $29
      var $30=$item;
      var $31=__ZNK13screen_device13callback_item4nextEv($30);
      $item=$31;
      __label__ = 3; break;
    case 8: // $32
      var $33=$item;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 9; break; } else { __label__ = 24; break; }
    case 9: // $35
      var $36=(($13+560)|0);
      var $37=$4;
      var $38=$5;
      var $39=$6;
      var $40=$result_i;
      var $41=$7;
      var $42=$8;
      HEAP32[(($4)>>2)]=28;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($6)>>2)]=771;
      var $43=HEAP32[(($4)>>2)];
      var $44=HEAP32[(($5)>>2)];
      var $45=HEAP32[(($6)>>2)];
      var $46=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($43, $44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $47
      HEAP32[(($result_i)>>2)]=$46;
      var $48=HEAP32[(($result_i)>>2)];
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $50
      var $51=___cxa_allocate_exception(4);
      var $52=$51;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($52);
      (function() { try { __THREW__ = false; return ___cxa_throw($51, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      HEAP32[(($7)>>2)]=$55;
      var $56=$54.f1;
      HEAP32[(($8)>>2)]=$56;
      var $57=HEAP32[(($8)>>2)];
      var $58=(($57)|0) < 0;
      if ($58) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $59
      var $60=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($60);
      throw "Reached an unreachable!"
    case 14: // $61
      var $62=HEAP32[(($7)>>2)];
      var $63=HEAP32[(($7)>>2)];
      var $64=HEAP32[(($8)>>2)];
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $67
      throw "Reached an unreachable!"
    case 16: // $_ZnwjPKci_exit
      var $68=HEAP32[(($result_i)>>2)];
      var $69=$4;
      var $70=$5;
      var $71=$6;
      var $72=$result_i;
      var $73=$7;
      var $74=$8;
      var $75=$68;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13screen_devicebEEC1ERKS3_($10, $vblank_callback) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $76
      (function() { try { __THREW__ = false; return __ZN13screen_device13callback_itemC1E8delegateIFvRS_bEE($75, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $77
      var $78=__ZN13resource_pool10add_objectIN13screen_device13callback_itemEEEPT_S4_(_global_resource_pool, $75);
      var $79=__ZN11simple_listIN13screen_device13callback_itemEE6appendERS1_($36, $78);
      __label__ = 24; break;
    case 19: // $80
      var $81=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $82=$81.f0;
      $11=$82;
      var $83=$81.f1;
      $12=$83;
      var $84=$1;
      var $85=$2;
      var $86=$3;
      HEAP32[(($1)>>2)]=$68;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str102783)|0);
      HEAP32[(($3)>>2)]=771;
      var $87=HEAP32[(($1)>>2)];
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $89
      var $90=HEAP32[(($1)>>2)];
      var $91=HEAP32[(($2)>>2)];
      var $92=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($90, $91, $92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $_noexc
      __label__ = 22; break;
    case 22: // $_ZdlPvPKci_exit
      var $93=$1;
      var $94=$2;
      var $95=$3;
      __label__ = 23; break;
    case 23: // $96
      __label__ = 25; break;
    case 24: // $97
      STACKTOP = __stackBase__;
      return;
    case 25: // $98
      var $99=$11;
      var $100=$11;
      var $101=$12;
      var $102=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $100, tempValue);
      var $103=($102.f1 = $101, $102);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE["X"]=1;

function __ZN13resource_pool10add_objectIN13screen_device13callback_itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN13screen_device13callback_itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN13screen_device13callback_itemEEEPT_S4_["X"]=1;

function __Z8downcastIP13driver_deviceS0_ET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13screen_device13update_burninEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $srcbitmap;
      var $srcwidth;
      var $srcheight;
      var $dstwidth;
      var $dstheight;
      var $xstep;
      var $ystep;
      var $xstart;
      var $ystart;
      var $srcx;
      var $srcy;
      var $x;
      var $y;
      var $dst;
      var $src;
      var $palette;
      var $pixel;
      var $src1;
      var $pixel2;
      var $src3;
      var $pixel4;
      $1=$this;
      var $2=$1;
      var $3=(($2+452)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 28; break;
    case 2: // $7
      var $8=(($2+457)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($2+444)|0);
      var $12=(($11+($10<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      $srcbitmap=$13;
      var $14=$srcbitmap;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      __label__ = 28; break;
    case 4: // $17
      var $18=$srcbitmap;
      var $19=$18;
      var $20=(($19+12)|0);
      var $21=HEAP32[(($20)>>2)];
      $srcwidth=$21;
      var $22=$srcbitmap;
      var $23=$22;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      $srcheight=$25;
      var $26=(($2+452)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      var $29=(($28+12)|0);
      var $30=HEAP32[(($29)>>2)];
      $dstwidth=$30;
      var $31=(($2+452)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32;
      var $34=(($33+16)|0);
      var $35=HEAP32[(($34)>>2)];
      $dstheight=$35;
      var $36=$srcwidth;
      var $37=$36 << 16;
      var $38=$dstwidth;
      var $39=(((($37)|0)/(($38)|0))|0);
      $xstep=$39;
      var $40=$srcheight;
      var $41=$40 << 16;
      var $42=$dstheight;
      var $43=(((($41)|0)/(($42)|0))|0);
      $ystep=$43;
      var $44=_rand();
      var $45=(($44)>>>0)%32767;
      var $46=$xstep;
      var $47=(($45*$46)|0);
      var $48=Math.floor((($47)>>>0)/32767);
      $xstart=$48;
      var $49=_rand();
      var $50=(($49)>>>0)%32767;
      var $51=$ystep;
      var $52=(($50*$51)|0);
      var $53=Math.floor((($52)>>>0)/32767);
      $ystart=$53;
      $y=0;
      var $54=$ystart;
      $srcy=$54;
      __label__ = 5; break;
    case 5: // $55
      var $56=$y;
      var $57=$dstheight;
      var $58=(($56)|0) < (($57)|0);
      if ($58) { __label__ = 6; break; } else { __label__ = 28; break; }
    case 6: // $59
      var $60=(($2+452)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$64;
      var $66=$y;
      var $67=(($2+452)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$68;
      var $70=(($69+8)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($66*$71)|0);
      var $73=(($65+($72<<3))|0);
      var $74=(($73)|0);
      $dst=$74;
      var $75=$srcbitmap;
      var $76=$75;
      var $77=(($76+20)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)==2;
      if ($79) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $80
      var $81=$srcbitmap;
      var $82=$81;
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$84;
      var $86=$srcy;
      var $87=$86 >> 16;
      var $88=$srcbitmap;
      var $89=$88;
      var $90=(($89+8)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($87*$91)|0);
      var $93=(($85+($92<<1))|0);
      var $94=(($93)|0);
      $src=$94;
      var $95=$2;
      var $96=__ZNK8device_t7machineEv($95);
      var $97=(($96+564)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=__Z27palette_entry_list_adjustedP10_palette_t($98);
      $palette=$99;
      $x=0;
      var $100=$xstart;
      $srcx=$100;
      __label__ = 8; break;
    case 8: // $101
      var $102=$x;
      var $103=$dstwidth;
      var $104=(($102)|0) < (($103)|0);
      if ($104) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $105
      var $106=$srcx;
      var $107=$106 >> 16;
      var $108=$src;
      var $109=(($108+($107<<1))|0);
      var $110=HEAPU16[(($109)>>1)];
      var $111=(($110)&65535);
      var $112=$palette;
      var $113=(($112+($111<<2))|0);
      var $114=HEAP32[(($113)>>2)];
      $pixel=$114;
      var $115=$pixel;
      var $116=$115 >>> 8;
      var $117=$116 & 255;
      var $118=$pixel;
      var $119=$118 >>> 16;
      var $120=$119 & 255;
      var $121=(($117+$120)|0);
      var $122=$pixel;
      var $123=$122 & 255;
      var $124=(($121+$123)|0);
      var $125$0=$124;
      var $125$1=0;
      var $126=$x;
      var $127=$dst;
      var $128=(($127+($126<<3))|0);
      var $st$25$0=(($128)|0);
      var $129$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($128+4)|0);
      var $129$1=HEAP32[(($st$25$1)>>2)];
      var $130$0 = ((($129$0)>>>0)+((($129$1)|0)*4294967296))+((($125$0)>>>0)+((($125$1)|0)*4294967296))>>>0; var $130$1 = Math.min(Math.floor((((($129$0)>>>0)+((($129$1)|0)*4294967296))+((($125$0)>>>0)+((($125$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$30$0=(($128)|0);
      HEAP32[(($st$30$0)>>2)]=$130$0;
      var $st$30$1=(($128+4)|0);
      HEAP32[(($st$30$1)>>2)]=$130$1;
      __label__ = 10; break;
    case 10: // $131
      var $132=$x;
      var $133=(($132+1)|0);
      $x=$133;
      var $134=$xstep;
      var $135=$srcx;
      var $136=(($135+$134)|0);
      $srcx=$136;
      __label__ = 8; break;
    case 11: // $137
      __label__ = 26; break;
    case 12: // $138
      var $139=$srcbitmap;
      var $140=$139;
      var $141=(($140+20)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)==5;
      if ($143) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $144
      var $145=$srcbitmap;
      var $146=$145;
      var $147=(($146+4)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=$148;
      var $150=$srcy;
      var $151=$150 >> 16;
      var $152=$srcbitmap;
      var $153=$152;
      var $154=(($153+8)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($151*$155)|0);
      var $157=(($149+($156<<1))|0);
      var $158=(($157)|0);
      $src1=$158;
      $x=0;
      var $159=$xstart;
      $srcx=$159;
      __label__ = 14; break;
    case 14: // $160
      var $161=$x;
      var $162=$dstwidth;
      var $163=(($161)|0) < (($162)|0);
      if ($163) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $164
      var $165=$srcx;
      var $166=$165 >> 16;
      var $167=$src1;
      var $168=(($167+($166<<1))|0);
      var $169=HEAP16[(($168)>>1)];
      $pixel2=$169;
      var $170=$pixel2;
      var $171=(($170)&65535);
      var $172=$171 >> 10;
      var $173=$172 & 31;
      var $174=$pixel2;
      var $175=(($174)&65535);
      var $176=$175 >> 5;
      var $177=$176 & 31;
      var $178=(($173+$177)|0);
      var $179=$pixel2;
      var $180=(($179)&65535);
      var $181=$180 >> 0;
      var $182=$181 & 31;
      var $183=(($178+$182)|0);
      var $184$0=$183;
      var $184$1=(($183|0) < 0 ? -1 : 0);
      var $185=$x;
      var $186=$dst;
      var $187=(($186+($185<<3))|0);
      var $st$25$0=(($187)|0);
      var $188$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($187+4)|0);
      var $188$1=HEAP32[(($st$25$1)>>2)];
      var $189$0 = ((($188$0)>>>0)+((($188$1)|0)*4294967296))+((($184$0)>>>0)+((($184$1)|0)*4294967296))>>>0; var $189$1 = Math.min(Math.floor((((($188$0)>>>0)+((($188$1)|0)*4294967296))+((($184$0)>>>0)+((($184$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$30$0=(($187)|0);
      HEAP32[(($st$30$0)>>2)]=$189$0;
      var $st$30$1=(($187+4)|0);
      HEAP32[(($st$30$1)>>2)]=$189$1;
      __label__ = 16; break;
    case 16: // $190
      var $191=$x;
      var $192=(($191+1)|0);
      $x=$192;
      var $193=$xstep;
      var $194=$srcx;
      var $195=(($194+$193)|0);
      $srcx=$195;
      __label__ = 14; break;
    case 17: // $196
      __label__ = 25; break;
    case 18: // $197
      var $198=$srcbitmap;
      var $199=$198;
      var $200=(($199+20)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=(($201)|0)==6;
      if ($202) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $203
      var $204=$srcbitmap;
      var $205=$204;
      var $206=(($205+4)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$207;
      var $209=$srcy;
      var $210=$209 >> 16;
      var $211=$srcbitmap;
      var $212=$211;
      var $213=(($212+8)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(($210*$214)|0);
      var $216=(($208+($215<<2))|0);
      var $217=(($216)|0);
      $src3=$217;
      $x=0;
      var $218=$xstart;
      $srcx=$218;
      __label__ = 20; break;
    case 20: // $219
      var $220=$x;
      var $221=$dstwidth;
      var $222=(($220)|0) < (($221)|0);
      if ($222) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $223
      var $224=$srcx;
      var $225=$224 >> 16;
      var $226=$src3;
      var $227=(($226+($225<<2))|0);
      var $228=HEAP32[(($227)>>2)];
      $pixel4=$228;
      var $229=$pixel4;
      var $230=$229 >>> 8;
      var $231=$230 & 255;
      var $232=$pixel4;
      var $233=$232 >>> 16;
      var $234=$233 & 255;
      var $235=(($231+$234)|0);
      var $236=$pixel4;
      var $237=$236 & 255;
      var $238=(($235+$237)|0);
      var $239$0=$238;
      var $239$1=0;
      var $240=$x;
      var $241=$dst;
      var $242=(($241+($240<<3))|0);
      var $st$21$0=(($242)|0);
      var $243$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($242+4)|0);
      var $243$1=HEAP32[(($st$21$1)>>2)];
      var $244$0 = ((($243$0)>>>0)+((($243$1)|0)*4294967296))+((($239$0)>>>0)+((($239$1)|0)*4294967296))>>>0; var $244$1 = Math.min(Math.floor((((($243$0)>>>0)+((($243$1)|0)*4294967296))+((($239$0)>>>0)+((($239$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$26$0=(($242)|0);
      HEAP32[(($st$26$0)>>2)]=$244$0;
      var $st$26$1=(($242+4)|0);
      HEAP32[(($st$26$1)>>2)]=$244$1;
      __label__ = 22; break;
    case 22: // $245
      var $246=$x;
      var $247=(($246+1)|0);
      $x=$247;
      var $248=$xstep;
      var $249=$srcx;
      var $250=(($249+$248)|0);
      $srcx=$250;
      __label__ = 20; break;
    case 23: // $251
      __label__ = 24; break;
    case 24: // $252
      __label__ = 25; break;
    case 25: // $253
      __label__ = 26; break;
    case 26: // $254
      __label__ = 27; break;
    case 27: // $255
      var $256=$y;
      var $257=(($256+1)|0);
      $y=$257;
      var $258=$ystep;
      var $259=$srcy;
      var $260=(($259+$258)|0);
      $srcy=$260;
      __label__ = 5; break;
    case 28: // $261
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13screen_device13update_burninEv["X"]=1;

function __ZNK11emu_options18snapshot_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str392812)|0));
  ;
  return $4;
}


function __ZNK15running_machine11driver_dataI13driver_deviceEEPT_v($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1300)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__Z8downcastIP13driver_deviceS0_ET_PT0_($4);
  ;
  return $5;
}


function __ZN13screen_device10screen_eofEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+404)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+404)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$2;
      var $10=__ZNK8device_t7machineEv($9);
      FUNCTION_TABLE[$8]($2, $10);
      __label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $13=__ZNK8device_t7machineEv($12);
      var $14=__ZNK15running_machine11driver_dataI13driver_deviceEEPT_v($13);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+64)|0);
      var $18=HEAP32[(($17)>>2)];
      FUNCTION_TABLE[$18]($14);
      __label__ = 3; break;
    case 3: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN13screen_device13callback_itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN13screen_device13callback_itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN13screen_device13callback_itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 28);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN13screen_device13callback_itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN13screen_device13callback_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN13screen_device13callback_itemEED2Ev($2);
  ;
  return;
}


function __ZN12save_manager9save_itemIyEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 8, 1);
  ;
  return;
}


function __ZN12save_manager9save_itemIxEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 8, 1);
  ;
  return;
}


function __ZN11simple_listIN13screen_device13callback_itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN13screen_device13callback_itemEE+8)|0);
  __ZN11simple_listIN13screen_device13callback_itemEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN13screen_device13callback_itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN13screen_device13callback_itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN13screen_device13callback_itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN13screen_device13callback_itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN13screen_device13callback_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN13screen_device13callback_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN13screen_device13callback_itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN13screen_device13callback_itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN13screen_device13callback_itemEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_($this, $module, $tag, $index, $value, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $tempstr=__stackBase__;
      var $7;
      var $8;
      $1=$this;
      $2=$module;
      $3=$tag;
      $4=$index;
      $5=$value;
      $6=$name;
      var $9=$1;
      var $10=$6;
      __ZN7astringC1EPKcS1_($tempstr, $10, ((STRING_TABLE.__str352808)|0));
      var $11=$2;
      var $12=$3;
      var $13=$4;
      var $14=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; };
    case 1: // $15
      var $16=$5;
      var $17=(($16+4)|0);
      var $18=$17;
      (function() { try { __THREW__ = false; return __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($9, $11, $12, $13, $14, $18, 8, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $19
      var $20=$6;
      var $21=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tempstr, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $22
      var $23=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($21, ((STRING_TABLE.__str362809)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $24
      var $25=$2;
      var $26=$3;
      var $27=$4;
      var $28=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $29
      var $30=$5;
      var $31=(($30)|0);
      var $32=$31;
      (function() { try { __THREW__ = false; return __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($9, $25, $26, $27, $28, $32, 4, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      STACKTOP = __stackBase__;
      return;
    case 7: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $7=$36;
      var $37=$35.f1;
      $8=$37;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $38
      __label__ = 9; break;
    case 9: // $39
      var $40=$7;
      var $41=$7;
      var $42=$8;
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_["X"]=1;

function __ZN11simple_listIN13screen_device13callback_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN13screen_device13callback_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN13screen_device13callback_itemEED0Ev["X"]=1;

function __ZN9emu_timerD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN11simple_listIN13screen_device13callback_itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN13screen_device13callback_itemEE6detachERS1_["X"]=1;

function __ZN11simple_listIN13screen_device13callback_itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN13screen_device13callback_itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN20resource_pool_objectI13screen_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13screen_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13screen_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 580);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13screen_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13screen_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13screen_deviceED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvR13screen_devicebEEC2ERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2ERKS3_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2ERKS3_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN13screen_device13callback_itemC2E8delegateIFvRS_bEE($this, $callback) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  __ZN8delegateIFvR13screen_devicebEEC1ERKS3_($4, $callback);
  ;
  return;
}


function __GLOBAL__I_a2842() {
  ;
  var __label__;

  ___cxx_global_var_init2817();
  ;
  return;
}


function __ZN9emu_timerC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN8delegateIFvPviEEC1Ev($6);
  var $7=(($2+36)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+40)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($2+44)|0);
  HEAP8[($9)]=0;
  var $10=(($2+45)|0);
  HEAP8[($10)]=0;
  var $11=(($2+48)|0);
  var $12=$11;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $13=(($2+60)|0);
  var $14=$13;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($14)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($14+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($14+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $15=(($2+72)|0);
  var $16=$15;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  var $17=(($2+84)|0);
  HEAP32[(($17)>>2)]=0;
  var $18=(($2+88)|0);
  HEAP32[(($18)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvPviEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFvPviEEC2Ev($2);
  ;
  return;
}


function __ZN9emu_timer4initER15running_machine8delegateIFvPviEES3_b($this, $machine, $callback, $ptr, $temporary) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      $1=$this;
      $2=$machine;
      $3=$ptr;
      var $6=(($temporary)&1);
      $4=$6;
      var $7=$1;
      var $8=$2;
      var $9=(($7)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($7+4)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($7+8)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($7+12)|0);
      var $13=__ZN8delegateIFvPviEEaSERKS2_($12, $callback);
      var $14=(($7+36)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=$3;
      var $16=(($7+40)|0);
      HEAP32[(($16)>>2)]=$15;
      var $17=(($7+44)|0);
      HEAP8[($17)]=0;
      var $18=$4;
      var $19=(($18) & 1);
      var $20=(($7+45)|0);
      var $21=(($19)&1);
      HEAP8[($20)]=$21;
      var $22=(($7+48)|0);
      var $23=$22;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($23)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($23+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($23+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $24=(($7+60)|0);
      var $25=$2;
      __ZNK15running_machine4timeEv($5, $25);
      var $26=$24;
      var $27=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[(($27)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[(($27+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[(($27+8)>>2)];
      var $28=(($7+72)|0);
      var $29=$28;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($29)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($29+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($29+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $30=(($7+84)|0);
      HEAP32[(($30)>>2)]=0;
      var $31=(($7+88)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($7+45)|0);
      var $33=HEAP8[($32)];
      var $34=(($33) & 1);
      if ($34) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $35
      __ZN9emu_timer13register_saveEv($7);
      __label__ = 2; break;
    case 2: // $36
      var $37=$2;
      var $38=__ZN15running_machine9schedulerEv($37);
      var $39=__ZN16device_scheduler17timer_list_insertER9emu_timer($38, $7);
      STACKTOP = __stackBase__;
      return $7;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9emu_timer4initER15running_machine8delegateIFvPviEES3_b["X"]=1;

function __ZN8delegateIFvPviEEaSERKS2_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvPvi8_noparamS1_EaSERKS2_($5, $7);
  ;
  return $4;
}


function __ZN13resource_pool10add_objectI13screen_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13screen_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13screen_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI13screen_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13screen_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13screen_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI13screen_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI13screen_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN9emu_timer13register_saveEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $index;
      var $name=__stackBase__;
      var $2;
      var $3;
      var $curtimer;
      var $curtimer1;
      $1=$this;
      var $4=$1;
      $index=0;
      __ZN7astringC1Ev($name);
      var $5=(($4+84)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $8
      var $9=(($4+12)|0);
      var $10=$9;
      var $11=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIvPvi8_noparamS1_E4nameEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $12
      var $13=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($name, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 15; break; };
    case 3: // $14
      var $15=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 15; break; };
    case 4: // $16
      var $17=(function() { try { __THREW__ = false; return __ZN15running_machine9schedulerEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; };
    case 5: // $18
      var $19=(function() { try { __THREW__ = false; return __ZNK16device_scheduler11first_timerEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; };
    case 6: // $20
      $curtimer=$19;
      __label__ = 7; break;
    case 7: // $21
      var $22=$curtimer;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 8; break; } else { __label__ = 19; break; }
    case 8: // $24
      var $25=$curtimer;
      var $26=(($25+45)|0);
      var $27=HEAP8[($26)];
      var $28=(($27) & 1);
      if ($28) { __label__ = 16; break; } else { __label__ = 9; break; }
    case 9: // $29
      var $30=$curtimer;
      var $31=(($30+84)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $34
      var $35=$curtimer;
      var $36=(($35+12)|0);
      var $37=$36;
      var $38=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIvPvi8_noparamS1_E4nameEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $39
      var $40=(($4+12)|0);
      var $41=$40;
      var $42=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIvPvi8_noparamS1_E4nameEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $43
      var $44=(function() { try { __THREW__ = false; return _strcmp($38, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $45
      var $46=(($44)|0)==0;
      if ($46) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $47
      var $48=$index;
      var $49=(($48+1)|0);
      $index=$49;
      __label__ = 16; break;
    case 15: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      $2=$52;
      var $53=$51.f1;
      $3=$53;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 16: // $54
      __label__ = 17; break;
    case 17: // $55
      var $56=$curtimer;
      var $57=(function() { try { __THREW__ = false; return __ZNK9emu_timer4nextEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; };
    case 18: // $58
      $curtimer=$57;
      __label__ = 7; break;
    case 19: // $59
      __label__ = 36; break;
    case 20: // $60
      var $61=(($4+84)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 15; break; };
    case 21: // $64
      var $65=(($4+88)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($name, ((STRING_TABLE.__str2843)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$66,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 15; break; };
    case 22: // $68
      var $69=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; };
    case 23: // $70
      var $71=(function() { try { __THREW__ = false; return __ZN15running_machine9schedulerEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 15; break; };
    case 24: // $72
      var $73=(function() { try { __THREW__ = false; return __ZNK16device_scheduler11first_timerEv($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $74
      $curtimer1=$73;
      __label__ = 26; break;
    case 26: // $75
      var $76=$curtimer1;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 27; break; } else { __label__ = 35; break; }
    case 27: // $78
      var $79=$curtimer1;
      var $80=(($79+45)|0);
      var $81=HEAP8[($80)];
      var $82=(($81) & 1);
      if ($82) { __label__ = 32; break; } else { __label__ = 28; break; }
    case 28: // $83
      var $84=$curtimer1;
      var $85=(($84+84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 29; break; } else { __label__ = 32; break; }
    case 29: // $88
      var $89=$curtimer1;
      var $90=(($89+84)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($4+84)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($91)|0)==(($93)|0);
      if ($94) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $95
      var $96=$curtimer1;
      var $97=(($96+88)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($4+88)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($98)|0)==(($100)|0);
      if ($101) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $102
      var $103=$index;
      var $104=(($103+1)|0);
      $index=$104;
      __label__ = 32; break;
    case 32: // $105
      __label__ = 33; break;
    case 33: // $106
      var $107=$curtimer1;
      var $108=(function() { try { __THREW__ = false; return __ZNK9emu_timer4nextEv($107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 15; break; };
    case 34: // $109
      $curtimer1=$108;
      __label__ = 26; break;
    case 35: // $110
      __label__ = 36; break;
    case 36: // $111
      var $112=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 15; break; };
    case 37: // $113
      var $114=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 15; break; };
    case 38: // $115
      var $116=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 15; break; };
    case 39: // $117
      var $118=$index;
      var $119=(($4+36)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_($114, ((STRING_TABLE.__str12844)|0), $116, $118, $119, ((STRING_TABLE.__str22845)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 15; break; }
    case 40: // $120
      var $121=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 15; break; };
    case 41: // $122
      var $123=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 15; break; };
    case 42: // $124
      var $125=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 15; break; };
    case 43: // $126
      var $127=$index;
      var $128=(($4+44)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemIbEEvPKcS2_iRT_S2_($123, ((STRING_TABLE.__str12844)|0), $125, $127, $128, ((STRING_TABLE.__str32846)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 15; break; }
    case 44: // $129
      var $130=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 15; break; };
    case 45: // $131
      var $132=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 15; break; };
    case 46: // $133
      var $134=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 15; break; };
    case 47: // $135
      var $136=$index;
      var $137=(($4+48)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_($132, ((STRING_TABLE.__str12844)|0), $134, $136, $137, ((STRING_TABLE.__str42847)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 15; break; }
    case 48: // $138
      var $139=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 15; break; };
    case 49: // $140
      var $141=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 15; break; };
    case 50: // $142
      var $143=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 15; break; };
    case 51: // $144
      var $145=$index;
      var $146=(($4+60)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_($141, ((STRING_TABLE.__str12844)|0), $143, $145, $146, ((STRING_TABLE.__str52848)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 15; break; }
    case 52: // $147
      var $148=(function() { try { __THREW__ = false; return __ZNK9emu_timer7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 15; break; };
    case 53: // $149
      var $150=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 15; break; };
    case 54: // $151
      var $152=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 15; break; };
    case 55: // $153
      var $154=$index;
      var $155=(($4+72)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_($150, ((STRING_TABLE.__str12844)|0), $152, $154, $155, ((STRING_TABLE.__str62849)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 15; break; }
    case 56: // $156
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      STACKTOP = __stackBase__;
      return;
    case 57: // $157
      __label__ = 58; break;
    case 58: // $158
      var $159=$2;
      var $160=$2;
      var $161=$3;
      var $162=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $160, tempValue);
      var $163=($162.f1 = $161, $162);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 59: // $164
      var $165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9emu_timer13register_saveEv["X"]=1;

function __ZNK9emu_timer7machineEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler17timer_list_removeER9emu_timer($this, $timer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$timer;
      var $3=$1;
      var $4=$2;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+4)|0);
      HEAP32[(($15)>>2)]=$11;
      __label__ = 3; break;
    case 2: // $16
      var $17=$2;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($3+24)|0);
      HEAP32[(($20)>>2)]=$19;
      __label__ = 3; break;
    case 3: // $21
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$2;
      var $28=(($27+8)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+8)|0);
      HEAP32[(($33)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $34
      var $35=$2;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_scheduler11first_timerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13delegate_baseIvPvi8_noparamS1_E4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK9emu_timer4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN16device_scheduler17timer_list_insertER9emu_timer($this, $timer) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $expire=__stackBase__;
      var $prevtimer;
      var $curtimer;
      $2=$this;
      $3=$timer;
      var $4=$2;
      var $5=$3;
      var $6=(($5+44)|0);
      var $7=HEAP8[($6)];
      var $8=(($7) & 1);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10+72)|0);
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = __ZN8attotime5neverE;__label__ = 3; break;
    case 3: // $13
      var $14;
      var $15=$expire;
      var $16=$14;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[(($16+4)>>2)];HEAP32[(($15+8)>>2)]=HEAP32[(($16+8)>>2)];
      $prevtimer=0;
      var $17=(($4+24)|0);
      var $18=HEAP32[(($17)>>2)];
      $curtimer=$18;
      __label__ = 4; break;
    case 4: // $19
      var $20=$curtimer;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $22
      var $23=$curtimer;
      var $24=(($23+72)|0);
      var $25=__ZgtRK8attotimeS1_($24, $expire);
      if ($25) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $26
      var $27=$curtimer;
      var $28=(($27+8)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=(($30+8)|0);
      HEAP32[(($31)>>2)]=$29;
      var $32=$curtimer;
      var $33=$3;
      var $34=(($33+4)|0);
      HEAP32[(($34)>>2)]=$32;
      var $35=$curtimer;
      var $36=(($35+8)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $39
      var $40=$3;
      var $41=$curtimer;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+4)|0);
      HEAP32[(($44)>>2)]=$40;
      __label__ = 9; break;
    case 8: // $45
      var $46=$3;
      var $47=(($4+24)|0);
      HEAP32[(($47)>>2)]=$46;
      __label__ = 9; break;
    case 9: // $48
      var $49=$3;
      var $50=$curtimer;
      var $51=(($50+8)|0);
      HEAP32[(($51)>>2)]=$49;
      var $52=$3;
      $1=$52;
      __label__ = 16; break;
    case 10: // $53
      __label__ = 11; break;
    case 11: // $54
      var $55=$curtimer;
      $prevtimer=$55;
      var $56=$curtimer;
      var $57=__ZNK9emu_timer4nextEv($56);
      $curtimer=$57;
      __label__ = 4; break;
    case 12: // $58
      var $59=$prevtimer;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $61
      var $62=$3;
      var $63=$prevtimer;
      var $64=(($63+4)|0);
      HEAP32[(($64)>>2)]=$62;
      __label__ = 15; break;
    case 14: // $65
      var $66=$3;
      var $67=(($4+24)|0);
      HEAP32[(($67)>>2)]=$66;
      __label__ = 15; break;
    case 15: // $68
      var $69=$prevtimer;
      var $70=$3;
      var $71=(($70+8)|0);
      HEAP32[(($71)>>2)]=$69;
      var $72=$3;
      var $73=(($72+4)|0);
      HEAP32[(($73)>>2)]=0;
      var $74=$3;
      $1=$74;
      __label__ = 16; break;
    case 16: // $75
      var $76=$1;
      STACKTOP = __stackBase__;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler17timer_list_insertER9emu_timer["X"]=1;

function __ZN9emu_timer4initER8device_tjPvb($this, $device, $id, $ptr, $temporary) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+24;
      $1=$this;
      $2=$device;
      $3=$id;
      $4=$ptr;
      var $8=(($temporary)&1);
      $5=$8;
      var $9=$1;
      var $10=$2;
      var $11=__ZNK8device_t7machineEv($10);
      var $12=(($9)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($9+4)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($9+8)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($9+12)|0);
      __ZN8delegateIFvPviEEC1Ev($6);
      var $16=__ZN8delegateIFvPviEEaSERKS2_($15, $6);
      var $17=(($9+36)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=$4;
      var $19=(($9+40)|0);
      HEAP32[(($19)>>2)]=$18;
      var $20=(($9+44)|0);
      HEAP8[($20)]=0;
      var $21=$5;
      var $22=(($21) & 1);
      var $23=(($9+45)|0);
      var $24=(($22)&1);
      HEAP8[($23)]=$24;
      var $25=(($9+48)|0);
      var $26=$25;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $27=(($9+60)|0);
      var $28=__ZNK9emu_timer7machineEv($9);
      __ZNK15running_machine4timeEv($7, $28);
      var $29=$27;
      var $30=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($29)>>2)]=HEAP32[(($30)>>2)];HEAP32[(($29+4)>>2)]=HEAP32[(($30+4)>>2)];HEAP32[(($29+8)>>2)]=HEAP32[(($30+8)>>2)];
      var $31=(($9+72)|0);
      var $32=$31;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($32)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($32+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($32+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $33=$2;
      var $34=(($9+84)|0);
      HEAP32[(($34)>>2)]=$33;
      var $35=$3;
      var $36=(($9+88)|0);
      HEAP32[(($36)>>2)]=$35;
      var $37=(($9+45)|0);
      var $38=HEAP8[($37)];
      var $39=(($38) & 1);
      if ($39) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $40
      __ZN9emu_timer13register_saveEv($9);
      __label__ = 2; break;
    case 2: // $41
      var $42=__ZNK9emu_timer7machineEv($9);
      var $43=__ZN15running_machine9schedulerEv($42);
      var $44=__ZN16device_scheduler17timer_list_insertER9emu_timer($43, $9);
      STACKTOP = __stackBase__;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9emu_timer4initER8device_tjPvb["X"]=1;

function __ZN9emu_timer7releaseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK9emu_timer7machineEv($2);
  var $4=__ZN15running_machine9schedulerEv($3);
  var $5=__ZN16device_scheduler17timer_list_removeER9emu_timer($4, $2);
  ;
  return $2;
}


function __ZN9emu_timer6enableEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $old;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=(($4+44)|0);
      var $6=HEAP8[($5)];
      var $7=(($6) & 1);
      var $8=(($7)&1);
      $old=$8;
      var $9=$old;
      var $10=(($9) & 1);
      var $11=(($10)&1);
      var $12=$2;
      var $13=(($12) & 1);
      var $14=(($13)&1);
      var $15=(($11)|0)!=(($14)|0);
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$2;
      var $18=(($17) & 1);
      var $19=(($4+44)|0);
      var $20=(($18)&1);
      HEAP8[($19)]=$20;
      var $21=__ZNK9emu_timer7machineEv($4);
      var $22=__ZN15running_machine9schedulerEv($21);
      var $23=__ZN16device_scheduler17timer_list_removeER9emu_timer($22, $4);
      var $24=__ZNK9emu_timer7machineEv($4);
      var $25=__ZN15running_machine9schedulerEv($24);
      var $26=__ZN16device_scheduler17timer_list_insertER9emu_timer($25, $4);
      __label__ = 2; break;
    case 2: // $27
      var $28=$old;
      var $29=(($28) & 1);
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN9emu_timer6adjustE8attotimeiS0_($this, $start_delay, $param, $period) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $start_delay; $start_delay = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($start_delay)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($start_delay+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($start_delay+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var tempParam = $period; $period = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($period)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($period+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($period+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $scheduler;
      var $3=__stackBase__;
      var $4=__stackBase__+12;
      $1=$this;
      $2=$param;
      var $5=$1;
      var $6=__ZNK9emu_timer7machineEv($5);
      var $7=__ZN15running_machine9schedulerEv($6);
      $scheduler=$7;
      var $8=$scheduler;
      var $9=(($8+48)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==(($5)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$scheduler;
      var $14=(($13+52)|0);
      HEAP8[($14)]=1;
      __label__ = 2; break;
    case 2: // $15
      var $16=$2;
      var $17=(($5+36)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($5+44)|0);
      HEAP8[($18)]=1;
      var $19=(($start_delay)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0) < 0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$start_delay;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($23)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($23+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($23+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      __label__ = 4; break;
    case 4: // $24
      var $25=(($5+60)|0);
      var $26=$scheduler;
      __ZNK16device_scheduler4timeEv($3, $26);
      var $27=$25;
      var $28=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];
      var $29=(($5+72)|0);
      var $30=(($5+60)|0);
      __ZplRK8attotimeS1_($4, $30, $start_delay);
      var $31=$29;
      var $32=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($31)>>2)]=HEAP32[(($32)>>2)];HEAP32[(($31+4)>>2)]=HEAP32[(($32+4)>>2)];HEAP32[(($31+8)>>2)]=HEAP32[(($32+8)>>2)];
      var $33=(($5+48)|0);
      var $34=$33;
      var $35=$period;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];HEAP32[(($34+4)>>2)]=HEAP32[(($35+4)>>2)];HEAP32[(($34+8)>>2)]=HEAP32[(($35+8)>>2)];
      var $36=$scheduler;
      var $37=__ZN16device_scheduler17timer_list_removeER9emu_timer($36, $5);
      var $38=$scheduler;
      var $39=__ZN16device_scheduler17timer_list_insertER9emu_timer($38, $5);
      var $40=$scheduler;
      var $41=__ZNK16device_scheduler11first_timerEv($40);
      var $42=(($5)|0)==(($41)|0);
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$scheduler;
      __ZN16device_scheduler15abort_timesliceEv($44);
      __label__ = 6; break;
    case 6: // $45
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9emu_timer6adjustE8attotimeiS0_["X"]=1;

function __ZNK16device_scheduler4timeEv($agg_result, $this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+48)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+56)|0);
      var $8=$agg_result;
      var $9=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[(($9+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[(($9+8)>>2)];
      __label__ = 6; break;
    case 2: // $10
      var $11=(($2+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      __ZNK24device_execute_interface10local_timeEv($agg_result, $16);
      __label__ = 5; break;
    case 4: // $17
      var $18=(($2+12)|0);
      var $19=$agg_result;
      var $20=$18;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[(($20+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[(($20+8)>>2)];
      __label__ = 5; break;
    case 5: // $21
      __label__ = 6; break;
    case 6: // $22
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler15abort_timesliceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+4)|0);
      var $8=HEAP32[(($7)>>2)];
      __ZN24device_execute_interface15abort_timesliceEv($8);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK9emu_timer9remainingEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $3=$1;
  var $4=(($3+72)|0);
  var $5=__ZNK9emu_timer7machineEv($3);
  __ZNK15running_machine4timeEv($2, $5);
  __ZmiRK8attotimeS1_($agg_result, $4, $2);
  STACKTOP = __stackBase__;
  return;
}


function __ZN9emu_timer20schedule_next_periodEv($this) {
  ;
  var __label__;

  var $1;
  var $scheduler;
  $1=$this;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=(($2+72)|0);
  var $5=$3;
  var $6=$4;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];HEAP32[(($5+4)>>2)]=HEAP32[(($6+4)>>2)];HEAP32[(($5+8)>>2)]=HEAP32[(($6+8)>>2)];
  var $7=(($2+72)|0);
  var $8=(($2+48)|0);
  var $9=__ZN8attotimepLERKS_($7, $8);
  var $10=__ZNK9emu_timer7machineEv($2);
  var $11=__ZN15running_machine9schedulerEv($10);
  $scheduler=$11;
  var $12=$scheduler;
  var $13=__ZN16device_scheduler17timer_list_removeER9emu_timer($12, $2);
  var $14=$scheduler;
  var $15=__ZN16device_scheduler17timer_list_insertER9emu_timer($14, $2);
  ;
  return;
}


function __ZNK9emu_timer4dumpEv($this) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+44)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      var $6=(($5)&1);
      var $7=(($2+45)|0);
      var $8=HEAP8[($7)];
      var $9=(($8) & 1);
      var $10=(($9)&1);
      var $11=(($2+72)|0);
      var $12=__ZNK8attotime9as_stringEi($11, 9);
      var $13=(($2+60)|0);
      var $14=__ZNK8attotime9as_stringEi($13, 9);
      var $15=(($2+48)|0);
      var $16=__ZNK8attotime9as_stringEi($15, 9);
      var $17=(($2+36)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($2+40)|0);
      var $20=HEAP32[(($19)>>2)];
      __Z8logerrorPKcz(((STRING_TABLE.__str72850)|0), (tempInt=STACKTOP,STACKTOP += 32,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$2,HEAP32[((tempInt+4)>>2)]=$6,HEAP32[((tempInt+8)>>2)]=$10,HEAP32[((tempInt+12)>>2)]=$12,HEAP32[((tempInt+16)>>2)]=$14,HEAP32[((tempInt+20)>>2)]=$16,HEAP32[((tempInt+24)>>2)]=$18,HEAP32[((tempInt+28)>>2)]=$20,tempInt));
      var $21=(($2+84)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      var $25=(($2+12)|0);
      var $26=$25;
      var $27=__ZNK13delegate_baseIvPvi8_noparamS1_E4nameEv($26);
      __Z8logerrorPKcz(((STRING_TABLE.__str82851)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$27,tempInt));
      __label__ = 3; break;
    case 2: // $28
      var $29=(($2+84)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZNK8device_t3tagEv($30);
      var $32=(($2+88)|0);
      var $33=HEAP32[(($32)>>2)];
      __Z8logerrorPKcz(((STRING_TABLE.__str92852)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$33,tempInt));
      __label__ = 3; break;
    case 3: // $34
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15fixed_allocatorI9emu_timerEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN15fixed_allocatorI9emu_timerEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN16device_scheduler12quantum_slotEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN12save_manager9save_itemI8attotimeEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_($5, ((STRING_TABLE.__str212864)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZN8delegateIFvvEEC1I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN16device_scheduler7presaveEv($this) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __Z8logerrorPKcz(((STRING_TABLE.__str152858)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
  __ZNK16device_scheduler11dump_timersEv($2);
  STACKTOP = __stackBase__;
  return;
}


function __ZN16device_schedulerC2ER15running_machine($this, $machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $6=__stackBase__+24;
      var $7=__stackBase__+36;
      var $8=__stackBase__+48;
      var $9=__stackBase__+72;
      var $10=__stackBase__+80;
      var $11=__stackBase__+104;
      $1=$this;
      $2=$machine;
      var $12=$1;
      var $13=(($12)|0);
      var $14=$2;
      HEAP32[(($13)>>2)]=$14;
      var $15=(($12+4)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($12+8)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($12+12)|0);
      var $18=$17;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($18+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($18+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $19=(($12+24)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($12+28)|0);
      var $21=$2;
      var $22=__ZN15running_machine7respoolEv($21);
      __ZN15fixed_allocatorI9emu_timerEC1ER13resource_pool($20, $22);
      var $23=(($12+48)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=(($12+52)|0);
      HEAP8[($24)]=0;
      var $25=(($12+56)|0);
      var $26=$25;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $27=(($12+68)|0);
      var $28=$2;
      var $29=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 17; break; };
    case 1: // $30
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16device_scheduler12quantum_slotEEC1ER13resource_pool($27, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $31
      var $32=(($12+88)|0);
      var $33=$2;
      var $34=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 18; break; };
    case 3: // $35
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEEC1ER13resource_pool($32, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $36
      var $37=(($12+108)|0);
      var $$emscripten$temp$0$0=1000000;
      var $$emscripten$temp$0$1=0;
      var $st$3$0=(($37)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$0$0;
      var $st$3$1=(($37+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$0$1;
      var $38=(($12+28)|0);
      var $39=(function() { try { __THREW__ = false; return __ZN15fixed_allocatorI9emu_timerE5allocEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 19; break; };
    case 5: // $40
      var $41=$2;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvPviEEC1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $42
      var $43=(function() { try { __THREW__ = false; return __ZN9emu_timer4initER15running_machine8delegateIFvPviEES3_b($39, $41, $5, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 19; break; };
    case 7: // $44
      var $45=(($12+24)|0);
      HEAP32[(($45)>>2)]=$43;
      var $46=(($12+24)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($48)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($48+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($48+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $49=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($49)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($49+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($49+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      (function() { try { __THREW__ = false; return __ZN9emu_timer6adjustE8attotimeiS0_($47, $6, 0, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 19; break; }
    case 8: // $50
      var $51=$2;
      var $52=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 19; break; };
    case 9: // $53
      var $54=(($12+12)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemI8attotimeEEvRT_PKci($52, $54, ((STRING_TABLE.__str102853)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $55
      var $56=$2;
      var $57=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 19; break; };
    case 11: // $58
      HEAP32[(($9)>>2)]={ f0: 250, f1: 0 }.f0; HEAP32[(($9+4)>>2)]={ f0: 250, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($8, $9, ((STRING_TABLE.__str112854)|0), $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 19; break; }
    case 12: // $59
      (function() { try { __THREW__ = false; return __ZN12save_manager16register_presaveE8delegateIFvvEE($57, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $60
      var $61=$2;
      var $62=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; };
    case 14: // $63
      HEAP32[(($11)>>2)]={ f0: 252, f1: 0 }.f0; HEAP32[(($11+4)>>2)]={ f0: 252, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($10, $11, ((STRING_TABLE.__str122855)|0), $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $64
      (function() { try { __THREW__ = false; return __ZN12save_manager17register_postloadE8delegateIFvvEE($62, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $65
      STACKTOP = __stackBase__;
      return;
    case 17: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      $3=$68;
      var $69=$67.f1;
      $4=$69;
      __label__ = 23; break;
    case 18: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $3=$72;
      var $73=$71.f1;
      $4=$73;
      __label__ = 21; break;
    case 19: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $3=$76;
      var $77=$75.f1;
      $4=$77;
      var $78=(($12+88)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED1Ev($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $79
      __label__ = 21; break;
    case 21: // $80
      var $81=(($12+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $82
      __label__ = 23; break;
    case 23: // $83
      var $84=(($12+28)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI9emu_timerED1Ev($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $85
      __label__ = 25; break;
    case 25: // $86
      var $87=$3;
      var $88=$3;
      var $89=$4;
      var $90=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $88, tempValue);
      var $91=($90.f1 = $89, $90);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_schedulerC2ER15running_machine["X"]=1;

function __ZN15fixed_allocatorI9emu_timerE5allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $result;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=(($10)|0);
      var $12=__ZN11simple_listI9emu_timerE11detach_headEv($11);
      $result=$12;
      var $13=$result;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $15
      var $16=(($10)|0);
      var $17=__ZNK11simple_listI9emu_timerE4poolEv($16);
      var $18=$4;
      var $19=$result_i;
      var $20=$5;
      var $21=$6;
      HEAP32[(($4)>>2)]=92;
      var $22=HEAP32[(($4)>>2)];
      var $23=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $24
      HEAP32[(($result_i)>>2)]=$23;
      var $25=HEAP32[(($result_i)>>2)];
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $27
      var $28=___cxa_allocate_exception(4);
      var $29=$28;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29);
      (function() { try { __THREW__ = false; return ___cxa_throw($28, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      HEAP32[(($5)>>2)]=$32;
      var $33=$31.f1;
      HEAP32[(($6)>>2)]=$33;
      var $34=HEAP32[(($6)>>2)];
      var $35=(($34)|0) < 0;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      var $37=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($37);
      throw "Reached an unreachable!"
    case 6: // $38
      var $39=HEAP32[(($5)>>2)];
      var $40=HEAP32[(($5)>>2)];
      var $41=HEAP32[(($6)>>2)];
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $44
      throw "Reached an unreachable!"
    case 8: // $_Znwj_exit
      var $45=HEAP32[(($result_i)>>2)];
      var $46=$4;
      var $47=$result_i;
      var $48=$5;
      var $49=$6;
      var $50=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN9emu_timerC1Ev]($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $51
      var $52=__ZN13resource_pool10add_objectI9emu_timerEEPT_S3_($17, $50);
      $result=$52;
      __label__ = 15; break;
    case 10: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $8=$55;
      var $56=$54.f1;
      $9=$56;
      var $57=$1;
      var $58=$2;
      var $59=$3;
      HEAP32[(($1)>>2)]=$45;
      var $60=HEAP32[(($1)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $62
      var $63=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($63, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      __label__ = 14; break;
    case 13: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      HEAP32[(($2)>>2)]=$67;
      var $68=$66.f1;
      HEAP32[(($3)>>2)]=$68;
      var $69=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($69);
      throw "Reached an unreachable!"
    case 14: // $_ZdlPv_exit
      var $70=$1;
      var $71=$2;
      var $72=$3;
      __label__ = 16; break;
    case 15: // $73
      var $74=$result;
      STACKTOP = __stackBase__;
      return $74;
    case 16: // $75
      var $76=$8;
      var $77=$8;
      var $78=$9;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15fixed_allocatorI9emu_timerE5allocEv["X"]=1;

function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN16device_scheduler12quantum_slotEED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorI9emu_timerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15fixed_allocatorI9emu_timerED2Ev($2);
  ;
  return;
}


function __ZN15fixed_allocatorI9emu_timerE7reclaimERS0_($this, $item) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$item;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=__ZN11simple_listI9emu_timerE6appendERS0_($4, $5);
  ;
  return;
}


function __ZNK16device_scheduler8can_saveEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $timer;
      var $3=__stackBase__;
      $2=$this;
      var $4=$2;
      var $5=(($4+24)|0);
      var $6=HEAP32[(($5)>>2)];
      $timer=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$timer;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$timer;
      var $12=(($11+45)|0);
      var $13=HEAP8[($12)];
      var $14=(($13) & 1);
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$timer;
      __ZNK9emu_timer6expireEv($3, $16);
      var $17=__ZneRK8attotimeS1_($3, __ZN8attotime5neverE);
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      __Z8logerrorPKcz(((STRING_TABLE.__str132856)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __ZNK16device_scheduler11dump_timersEv($4);
      $1=0;
      __label__ = 8; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=$timer;
      var $22=__ZNK9emu_timer4nextEv($21);
      $timer=$22;
      __label__ = 1; break;
    case 7: // $23
      $1=1;
      __label__ = 8; break;
    case 8: // $24
      var $25=$1;
      STACKTOP = __stackBase__;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK9emu_timer6expireEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+72)|0);
  var $4=$agg_result;
  var $5=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];HEAP32[(($4+8)>>2)]=HEAP32[(($5+8)>>2)];
  ;
  return;
}


function __ZNK16device_scheduler11dump_timersEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $timer;
      $1=$this;
      var $3=$1;
      __Z8logerrorPKcz(((STRING_TABLE.__str192862)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __ZNK16device_scheduler4timeEv($2, $3);
      var $4=__ZNK8attotime9as_stringEi($2, 9);
      __Z8logerrorPKcz(((STRING_TABLE.__str202863)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$4,tempInt));
      var $5=__ZNK16device_scheduler11first_timerEv($3);
      $timer=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$timer;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$timer;
      __ZNK9emu_timer4dumpEv($10);
      __label__ = 3; break;
    case 3: // $11
      var $12=$timer;
      var $13=__ZNK9emu_timer4nextEv($12);
      $timer=$13;
      __label__ = 1; break;
    case 4: // $14
      __Z8logerrorPKcz(((STRING_TABLE.__str192862)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler9timesliceEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $call_debugger;
      var $target=__stackBase__;
      var $2=__stackBase__+12;
      var $suspendchanged;
      var $exec;
      var $exec1;
      var $delta=__stackBase__+24;
      var $ran;
      var $3=__stackBase__+32;
      var $4=__stackBase__+44;
      var $5=__stackBase__+56;
      $1=$this;
      var $6=$1;
      var $7=__ZNK16device_scheduler7machineEv($6);
      var $8=(($7+584)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9 & 1;
      var $11=(($10)|0)!=0;
      var $12=(($11)&1);
      $call_debugger=$12;
      var $13=(($6+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      __ZN16device_scheduler20rebuild_execute_listEv($6);
      __label__ = 2; break;
    case 2: // $17
      __ZN16device_scheduler14execute_timersEv($6);
      __label__ = 3; break;
    case 3: // $18
      var $19=(($6+12)|0);
      var $20=(($6+24)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+72)|0);
      var $23=__ZltRK8attotimeS1_($19, $22);
      if ($23) { __label__ = 4; break; } else { __label__ = 49; break; }
    case 4: // $24
      var $25=(($6+12)|0);
      var $26=(($6+68)|0);
      var $27=__ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv($26);
      var $28=(($27+4)|0);
      var $st$4$0=(($28)|0);
      var $29$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$4$1)>>2)];
      __ZN8attotimeC1Eix($2, 0, $29$0, $29$1);
      __ZplRK8attotimeS1_($target, $25, $2);
      var $30=(($6+24)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+72)|0);
      var $33=__ZltRK8attotimeS1_($32, $target);
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=(($6+24)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+72)|0);
      var $38=$target;
      var $39=$37;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($38)>>2)]=HEAP32[(($39)>>2)];HEAP32[(($38+4)>>2)]=HEAP32[(($39+4)>>2)];HEAP32[(($38+8)>>2)]=HEAP32[(($39+8)>>2)];
      __label__ = 6; break;
    case 6: // $40
      __label__ = 7; break;
    case 7: // $41
      __label__ = 8; break;
    case 8: // $42
      __label__ = 9; break;
    case 9: // $43
      __label__ = 10; break;
    case 10: // $44
      $suspendchanged=0;
      var $45=(($6+8)|0);
      var $46=HEAP32[(($45)>>2)];
      $exec=$46;
      __label__ = 11; break;
    case 11: // $47
      var $48=$exec;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $50
      var $51=$exec;
      var $52=(($51+5552)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$exec;
      var $55=(($54+5556)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$53 ^ $56;
      var $58=$suspendchanged;
      var $59=$58 | $57;
      $suspendchanged=$59;
      var $60=$exec;
      var $61=(($60+5556)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$exec;
      var $64=(($63+5552)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=$exec;
      var $66=(($65+5556)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$67 & -33;
      HEAP32[(($66)>>2)]=$68;
      var $69=$exec;
      var $70=(($69+5561)|0);
      var $71=HEAP8[($70)];
      var $72=$exec;
      var $73=(($72+5560)|0);
      HEAP8[($73)]=$71;
      __label__ = 13; break;
    case 13: // $74
      var $75=$exec;
      var $76=(($75+44)|0);
      var $77=HEAP32[(($76)>>2)];
      $exec=$77;
      __label__ = 11; break;
    case 14: // $78
      var $79=$suspendchanged;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $81
      __ZN16device_scheduler20rebuild_execute_listEv($6);
      __label__ = 16; break;
    case 16: // $82
      var $83=(($6+8)|0);
      var $84=HEAP32[(($83)>>2)];
      $exec1=$84;
      __label__ = 17; break;
    case 17: // $85
      var $86=$exec1;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 18; break; } else { __label__ = 48; break; }
    case 18: // $88
      var $89=(($target)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$exec1;
      var $92=(($91+5580)|0);
      var $93=(($92)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($90)|0) >= (($94)|0);
      if ($95) { __label__ = 19; break; } else { __label__ = 46; break; }
    case 19: // $96
      var $97=(($target+4)|0);
      var $st$1$0=(($97)|0);
      var $98$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($97+4)|0);
      var $98$1=HEAP32[(($st$1$1)>>2)];
      var $99=$exec1;
      var $100=(($99+5580)|0);
      var $101=(($100+4)|0);
      var $st$8$0=(($101)|0);
      var $102$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($101+4)|0);
      var $102$1=HEAP32[(($st$8$1)>>2)];
      var $103$0 = ((($98$0)>>>0)+((($98$1)|0)*4294967296))-((($102$0)>>>0)+((($102$1)|0)*4294967296))>>>0; var $103$1 = Math.min(Math.floor((((($98$0)>>>0)+((($98$1)|0)*4294967296))-((($102$0)>>>0)+((($102$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$13$0=(($delta)|0);
      HEAP32[(($st$13$0)>>2)]=$103$0;
      var $st$13$1=(($delta+4)|0);
      HEAP32[(($st$13$1)>>2)]=$103$1;
      var $st$17$0=(($delta)|0);
      var $104$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($delta+4)|0);
      var $104$1=HEAP32[(($st$17$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $105=($104$1|0) < ($$emscripten$temp$0$1|0) || (($104$1|0) == ($$emscripten$temp$0$1|0) && ($104$0|0) <  ($$emscripten$temp$0$0|0));
      if ($105) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $106
      var $107=(($target)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$exec1;
      var $110=(($109+5580)|0);
      var $111=(($110)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($108)|0) > (($112)|0);
      if ($113) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $114
      var $st$0$0=(($delta)|0);
      var $115$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $115$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $116$0 = ((($115$0)>>>0)+((($115$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $116$1 = Math.min(Math.floor((((($115$0)>>>0)+((($115$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($delta)|0);
      HEAP32[(($st$7$0)>>2)]=$116$0;
      var $st$7$1=(($delta+4)|0);
      HEAP32[(($st$7$1)>>2)]=$116$1;
      __label__ = 22; break;
    case 22: // $117
      __label__ = 23; break;
    case 23: // $118
      __label__ = 24; break;
    case 24: // $119
      var $st$0$0=(($delta)|0);
      var $120$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $120$1=HEAP32[(($st$0$1)>>2)];
      var $121=$exec1;
      var $122=(($121+5604)|0);
      var $st$6$0=(($122)|0);
      var $123$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($122+4)|0);
      var $123$1=HEAP32[(($st$6$1)>>2)];
      var $124=($120$1|0) >= ($123$1|0) && (($120$1|0) >  ($123$1|0) || ($120$0|0) >= ($123$0|0));
      if ($124) { __label__ = 25; break; } else { __label__ = 45; break; }
    case 25: // $125
      var $st$0$0=(($delta)|0);
      var $126$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $126$1=HEAP32[(($st$0$1)>>2)];
      var $127=$exec1;
      var $128=(($127+5596)|0);
      var $129=HEAPU8[($128)];
      var $130=(($129)&255);
      var $131$0=$130;
      var $131$1=0;
      var $132=Runtime.bitshift64($126$0, $126$1,"lshr",$131$0);var $132$0 = $132[0], $132$1 = $132[1];
      var $133=$exec1;
      var $134=(($133+5592)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=__ZL10divu_64x32yj($132$0, $132$1, $135);
      var $136$0=$136[0];
      var $137=$exec1;
      var $138=(($137+5544)|0);
      HEAP32[(($138)>>2)]=$136;
      $ran=$136;
      __label__ = 26; break;
    case 26: // $139
      __label__ = 27; break;
    case 27: // $140
      var $141=$exec1;
      var $142=(($141+5552)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143)|0)==0;
      if ($144) { __label__ = 28; break; } else { __label__ = 36; break; }
    case 28: // $145
      var $146=$exec1;
      var $147=(($146+5536)|0);
      var $148=HEAP32[(($147)>>2)];
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, $148);
      var $149=$exec1;
      var $150=(($149+5548)|0);
      HEAP32[(($150)>>2)]=0;
      var $151=$exec1;
      var $152=(($6+4)|0);
      HEAP32[(($152)>>2)]=$151;
      var $153=$exec1;
      var $154=(($153+5544)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$exec1;
      var $157=(($156+5540)|0);
      var $158=HEAP32[(($157)>>2)];
      HEAP32[(($158)>>2)]=$155;
      var $159=$call_debugger;
      var $160=(($159) & 1);
      if ($160) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $161
      var $162=$exec1;
      var $163=$162;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+80)|0);
      var $166=HEAP32[(($165)>>2)];
      FUNCTION_TABLE[$166]($162);
      __label__ = 31; break;
    case 30: // $167
      var $168=$exec1;
      var $169=$168;
      var $170=__ZN16device_interface6deviceEv($169);
      var $171=$3;
      var $172=$target;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($171)>>2)]=HEAP32[(($172)>>2)];HEAP32[(($171+4)>>2)]=HEAP32[(($172+4)>>2)];HEAP32[(($171+8)>>2)]=HEAP32[(($172+8)>>2)];
      __ZL23debugger_start_cpu_hookP8device_t8attotime($170, $3);
      var $173=$exec1;
      var $174=$173;
      var $175=HEAP32[(($174)>>2)];
      var $176=(($175+80)|0);
      var $177=HEAP32[(($176)>>2)];
      FUNCTION_TABLE[$177]($173);
      var $178=$exec1;
      var $179=$178;
      var $180=__ZN16device_interface6deviceEv($179);
      __ZL22debugger_stop_cpu_hookP8device_t($180);
      __label__ = 31; break;
    case 31: // $181
      __label__ = 32; break;
    case 32: // $182
      __label__ = 33; break;
    case 33: // $183
      var $184=$exec1;
      var $185=(($184+5540)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=HEAP32[(($186)>>2)];
      var $188=$ran;
      var $189=(($188-$187)|0);
      $ran=$189;
      __label__ = 34; break;
    case 34: // $190
      __label__ = 35; break;
    case 35: // $191
      var $192=$exec1;
      var $193=(($192+5548)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=$ran;
      var $196=(($195-$194)|0);
      $ran=$196;
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 36; break;
    case 36: // $197
      var $198=$ran;
      var $199$0=$198;
      var $199$1=(($198|0) < 0 ? -1 : 0);
      var $200=$exec1;
      var $201=(($200+5572)|0);
      var $st$5$0=(($201)|0);
      var $202$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($201+4)|0);
      var $202$1=HEAP32[(($st$5$1)>>2)];
      var $203$0 = ((($202$0)>>>0)+((($202$1)|0)*4294967296))+((($199$0)>>>0)+((($199$1)|0)*4294967296))>>>0; var $203$1 = Math.min(Math.floor((((($202$0)>>>0)+((($202$1)|0)*4294967296))+((($199$0)>>>0)+((($199$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($201)|0);
      HEAP32[(($st$10$0)>>2)]=$203$0;
      var $st$10$1=(($201+4)|0);
      HEAP32[(($st$10$1)>>2)]=$203$1;
      var $204=$exec1;
      var $205=(($204+5580)|0);
      var $206=$exec1;
      var $207=(($206+5604)|0);
      var $st$18$0=(($207)|0);
      var $208$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($207+4)|0);
      var $208$1=HEAP32[(($st$18$1)>>2)];
      var $209=$ran;
      var $210$0=$209;
      var $210$1=(($209|0) < 0 ? -1 : 0);
      var $211$0 = ((($208$0)>>>0)+((($208$1)|0)*4294967296))*((($210$0)>>>0)+((($210$1)|0)*4294967296))>>>0; var $211$1 = Math.min(Math.floor((((($208$0)>>>0)+((($208$1)|0)*4294967296))*((($210$0)>>>0)+((($210$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($4, 0, $211$0, $211$1);
      var $212=__ZN8attotimepLERKS_($205, $4);
      __label__ = 37; break;
    case 37: // $213
      __label__ = 38; break;
    case 38: // $214
      var $215=$exec1;
      var $216=(($215+5580)|0);
      var $217=__ZltRK8attotimeS1_($216, $target);
      if ($217) { __label__ = 39; break; } else { __label__ = 44; break; }
    case 39: // $218
      __label__ = 40; break;
    case 40: // $219
      __label__ = 41; break;
    case 41: // $220
      var $221=$exec1;
      var $222=(($221+5580)|0);
      var $223=(($6+12)|0);
      __Z3maxRK8attotimeS1_($5, $222, $223);
      var $224=$target;
      var $225=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($224)>>2)]=HEAP32[(($225)>>2)];HEAP32[(($224+4)>>2)]=HEAP32[(($225+4)>>2)];HEAP32[(($224+8)>>2)]=HEAP32[(($225+8)>>2)];
      __label__ = 42; break;
    case 42: // $226
      __label__ = 43; break;
    case 43: // $227
      __label__ = 44; break;
    case 44: // $228
      __label__ = 45; break;
    case 45: // $229
      __label__ = 46; break;
    case 46: // $230
      __label__ = 47; break;
    case 47: // $231
      var $232=$exec1;
      var $233=(($232+44)|0);
      var $234=HEAP32[(($233)>>2)];
      $exec1=$234;
      __label__ = 17; break;
    case 48: // $235
      var $236=(($6+4)|0);
      HEAP32[(($236)>>2)]=0;
      var $237=(($6+12)|0);
      var $238=$237;
      var $239=$target;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($238)>>2)]=HEAP32[(($239)>>2)];HEAP32[(($238+4)>>2)]=HEAP32[(($239+4)>>2)];HEAP32[(($238+8)>>2)]=HEAP32[(($239+8)>>2)];
      __label__ = 3; break;
    case 49: // $240
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler9timesliceEv["X"]=1;

function __ZN16device_scheduler8postloadEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $private_list=__stackBase__;
      var $timer;
      var $2=__stackBase__+20;
      var $3;
      var $4;
      var $timer1;
      $1=$this;
      var $5=$1;
      __ZN11simple_listI9emu_timerEC1ER13resource_pool($private_list, _global_resource_pool);
      __label__ = 1; break;
    case 1: // $6
      var $7=(($5+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $10
      var $11=(($5+24)|0);
      var $12=HEAP32[(($11)>>2)];
      $timer=$12;
      var $13=$timer;
      var $14=(($13+45)|0);
      var $15=HEAP8[($14)];
      var $16=(($15) & 1);
      if ($16) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $17
      var $18=$timer;
      (function() { try { __THREW__ = false; return __ZNK9emu_timer6expireEv($2, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $19
      var $20=(function() { try { __THREW__ = false; return __ZneRK8attotimeS1_($2, __ZN8attotime5neverE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; };
    case 5: // $21
      if ($20) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $22
      var $23=(($5+28)|0);
      var $24=$timer;
      var $25=(function() { try { __THREW__ = false; return __ZN9emu_timer7releaseEv($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $26
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI9emu_timerE7reclaimERS0_($23, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $27
      __label__ = 13; break;
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $3=$30;
      var $31=$29.f1;
      $4=$31;
      (function() { try { __THREW__ = false; return __ZN11simple_listI9emu_timerED1Ev($private_list) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 10: // $32
      var $33=$timer;
      var $34=(function() { try { __THREW__ = false; return __ZN16device_scheduler17timer_list_removeER9emu_timer($5, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN11simple_listI9emu_timerE6appendERS0_($private_list, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $37
      __label__ = 13; break;
    case 13: // $38
      __label__ = 1; break;
    case 14: // $39
      __label__ = 15; break;
    case 15: // $40
      var $41=(function() { try { __THREW__ = false; return __ZN11simple_listI9emu_timerE11detach_headEv($private_list) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 9; break; };
    case 16: // $42
      $timer1=$41;
      var $43=(($41)|0)!=0;
      if ($43) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $44
      var $45=$timer1;
      var $46=(function() { try { __THREW__ = false; return __ZN16device_scheduler17timer_list_insertER9emu_timer($5, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $47
      __label__ = 15; break;
    case 19: // $48
      (function() { try { __THREW__ = false; return __Z8logerrorPKcz(((STRING_TABLE.__str162859)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 9; break; }
    case 20: // $49
      (function() { try { __THREW__ = false; return __ZNK16device_scheduler11dump_timersEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 9; break; }
    case 21: // $50
      __ZN11simple_listI9emu_timerED1Ev($private_list);
      STACKTOP = __stackBase__;
      return;
    case 22: // $51
      __label__ = 23; break;
    case 23: // $52
      var $53=$3;
      var $54=$3;
      var $55=$4;
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler8postloadEv["X"]=1;

function __ZN16device_schedulerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=(($4+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=(($4+28)|0);
      var $11=(($4+24)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZN9emu_timer7releaseEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $14
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI9emu_timerE7reclaimERS0_($10, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $15
      __label__ = 1; break;
    case 5: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      var $20=(($4+88)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED1Ev($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 6: // $21
      var $22=(($4+88)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED1Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      var $24=(($4+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $25
      var $26=(($4+28)|0);
      __ZN15fixed_allocatorI9emu_timerED1Ev($26);
      ;
      return;
    case 9: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $2=$29;
      var $30=$28.f1;
      $3=$30;
      __label__ = 12; break;
    case 10: // $31
      __label__ = 12; break;
    case 11: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $2=$34;
      var $35=$33.f1;
      $3=$35;
      __label__ = 14; break;
    case 12: // $36
      var $37=(($4+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $38
      __label__ = 14; break;
    case 14: // $39
      var $40=(($4+28)|0);
      (function() { try { __THREW__ = false; return __ZN15fixed_allocatorI9emu_timerED1Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $41
      __label__ = 16; break;
    case 16: // $42
      var $43=$2;
      var $44=$2;
      var $45=$3;
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_schedulerD2Ev["X"]=1;

function __ZN16device_scheduler20rebuild_execute_listEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 108; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $min_quantum=__stackBase__;
      var $2=__stackBase__+12;
      var $device;
      var $exec=__stackBase__+24;
      var $3=__stackBase__+28;
      var $4=__stackBase__+40;
      var $5=__stackBase__+52;
      var $6=__stackBase__+64;
      var $7=__stackBase__+76;
      var $8=__stackBase__+88;
      var $active_tailptr;
      var $suspend_list=__stackBase__+100;
      var $suspend_tailptr;
      var $exec1=__stackBase__+104;
      var $gotone;
      $1=$this;
      var $9=$1;
      var $10=(($9+68)|0);
      var $11=__ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv($10);
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $13
      var $14=__ZNK16device_scheduler7machineEv($9);
      var $15=__ZNK15running_machine6configEv($14);
      var $16=(($15)|0);
      var $17=$min_quantum;
      var $18=$16;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];HEAP32[(($17+4)>>2)]=HEAP32[(($18+4)>>2)];HEAP32[(($17+8)>>2)]=HEAP32[(($18+8)>>2)];
      var $19=__ZeqRK8attotimeS1_($min_quantum, __ZN8attotime4zeroE);
      if ($19) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $20
      __ZN8attotime7from_hzEd($2, 60);
      var $21=$min_quantum;
      var $22=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($21)>>2)]=HEAP32[(($22)>>2)];HEAP32[(($21+4)>>2)]=HEAP32[(($22+4)>>2)];HEAP32[(($21+8)>>2)]=HEAP32[(($22+8)>>2)];
      __label__ = 3; break;
    case 3: // $23
      var $24=__ZNK16device_scheduler7machineEv($9);
      var $25=__ZNK15running_machine6configEv($24);
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $29
      var $30=__ZNK16device_scheduler7machineEv($9);
      var $31=__ZNK16device_scheduler7machineEv($9);
      var $32=__ZNK15running_machine6configEv($31);
      var $33=(($32+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZN15running_machine6deviceEPKc($30, $34);
      $device=$35;
      var $36=$device;
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $38
      var $39=__ZNK16device_scheduler7machineEv($9);
      var $40=__ZNK15running_machine6configEv($39);
      var $41=(($40+12)|0);
      var $42=HEAP32[(($41)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str172860)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,tempInt));
      throw "Reached an unreachable!"
    case 6: // $43
      var $44=$device;
      var $45=__ZN8device_t9interfaceERP24device_execute_interface($44, $exec);
      if ($45) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $46
      var $47=__ZNK16device_scheduler7machineEv($9);
      var $48=__ZNK15running_machine6configEv($47);
      var $49=(($48+12)|0);
      var $50=HEAP32[(($49)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str182861)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$50,tempInt));
      throw "Reached an unreachable!"
    case 8: // $51
      var $52=HEAP32[(($exec)>>2)];
      var $53=__ZNK24device_execute_interface15minimum_quantumEv($52);
      var $53$0=$53[0];
      var $53$1=$53[1];
      __ZN8attotimeC1Eix($4, 0, $53$0, $53$1);
      __Z3minRK8attotimeS1_($3, $4, $min_quantum);
      var $54=$min_quantum;
      var $55=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($54)>>2)]=HEAP32[(($55)>>2)];HEAP32[(($54+4)>>2)]=HEAP32[(($55+4)>>2)];HEAP32[(($54+8)>>2)]=HEAP32[(($55+8)>>2)];
      __label__ = 9; break;
    case 9: // $56
      __ZN8attotime7from_hzEd($6, 60);
      __Z3minRK8attotimeS1_($5, $min_quantum, $6);
      var $57=$min_quantum;
      var $58=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($57)>>2)]=HEAP32[(($58)>>2)];HEAP32[(($57+4)>>2)]=HEAP32[(($58+4)>>2)];HEAP32[(($57+8)>>2)]=HEAP32[(($58+8)>>2)];
      var $59=$7;
      var $60=$min_quantum;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];HEAP32[(($59+4)>>2)]=HEAP32[(($60+4)>>2)];HEAP32[(($59+8)>>2)]=HEAP32[(($60+8)>>2)];
      var $61=$8;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($61)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($61+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($61+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN16device_scheduler22add_scheduling_quantumE8attotimeS0_($9, $7, $8);
      __label__ = 10; break;
    case 10: // $62
      var $63=(($9+8)|0);
      $active_tailptr=$63;
      var $64=$active_tailptr;
      HEAP32[(($64)>>2)]=0;
      HEAP32[(($suspend_list)>>2)]=0;
      $suspend_tailptr=$suspend_list;
      HEAP32[(($exec1)>>2)]=0;
      var $65=__ZNK16device_scheduler7machineEv($9);
      var $66=__ZNK15running_machine10devicelistEv($65);
      var $67=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($66, $exec1);
      var $68=(($67)&1);
      $gotone=$68;
      __label__ = 11; break;
    case 11: // $69
      var $70=$gotone;
      var $71=(($70) & 1);
      if ($71) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $72
      var $73=HEAP32[(($exec1)>>2)];
      var $74=(($73+44)|0);
      HEAP32[(($74)>>2)]=0;
      var $75=HEAP32[(($exec1)>>2)];
      var $76=(($75+5552)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $79
      var $80=HEAP32[(($exec1)>>2)];
      var $81=$active_tailptr;
      HEAP32[(($81)>>2)]=$80;
      var $82=HEAP32[(($exec1)>>2)];
      var $83=(($82+44)|0);
      $active_tailptr=$83;
      __label__ = 15; break;
    case 14: // $84
      var $85=HEAP32[(($exec1)>>2)];
      var $86=$suspend_tailptr;
      HEAP32[(($86)>>2)]=$85;
      var $87=HEAP32[(($exec1)>>2)];
      var $88=(($87+44)|0);
      $suspend_tailptr=$88;
      __label__ = 15; break;
    case 15: // $89
      __label__ = 16; break;
    case 16: // $90
      var $91=HEAP32[(($exec1)>>2)];
      var $92=$91;
      var $93=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($92, $exec1);
      var $94=(($93)&1);
      $gotone=$94;
      __label__ = 11; break;
    case 17: // $95
      var $96=HEAP32[(($suspend_list)>>2)];
      var $97=$active_tailptr;
      HEAP32[(($97)>>2)]=$96;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler20rebuild_execute_listEv["X"]=1;

function __ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL10divu_64x32yj($a$0, $a$1, $b) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $st$2$0=(($1)|0);
  HEAP32[(($st$2$0)>>2)]=$a$0;
  var $st$2$1=(($1+4)|0);
  HEAP32[(($st$2$1)>>2)]=$a$1;
  $2=$b;
  var $st$7$0=(($1)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($1+4)|0);
  var $3$1=HEAP32[(($st$7$1)>>2)];
  var $4=$2;
  var $5$0=$4;
  var $5$1=0;
  var $6$0 = Math.floor(((($3$0)>>>0)+((($3$1)|0)*4294967296))/((($5$0)>>>0)+((($5$1)|0)*4294967296)))>>>0; var $6$1 = Math.min(Math.floor((Math.floor(((($3$0)>>>0)+((($3$1)|0)*4294967296))/((($5$0)>>>0)+((($5$1)|0)*4294967296))))/4294967296), 4294967295);
  var $7$0=$6$0;
  var $7=$7$0;
  STACKTOP = __stackBase__;
  return $7;
}


function __ZN11simple_listI9emu_timerE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9emu_timerE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_scheduler12quantum_slot4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZeqRK8attotimeS1_($left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { var $19 = 0;__label__ = 2; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11+4)|0);
      var $st$2$0=(($12)|0);
      var $13$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($12+4)|0);
      var $13$1=HEAP32[(($st$2$1)>>2)];
      var $14=$2;
      var $15=(($14+4)|0);
      var $st$8$0=(($15)|0);
      var $16$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$8$1)>>2)];
      var $17=$13$0 == $16$0 && $13$1 == $16$1;
      var $19 = $17;__label__ = 2; break;
    case 2: // $18
      var $19;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler14execute_timersEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $timer;
      var $was_enabled;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+12)|0);
      var $5=(($2+68)|0);
      var $6=__ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv($5);
      var $7=(($6+20)|0);
      var $8=__ZgeRK8attotimeS1_($4, $7);
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=(($2+88)|0);
      var $11=(($2+68)|0);
      var $12=__ZN11simple_listIN16device_scheduler12quantum_slotEE11detach_headEv($11);
      __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE7reclaimEPS1_($10, $12);
      __label__ = 1; break;
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      __label__ = 6; break;
    case 6: // $16
      var $17=(($2+24)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+72)|0);
      var $20=(($2+12)|0);
      var $21=__ZleRK8attotimeS1_($19, $20);
      if ($21) { __label__ = 7; break; } else { __label__ = 23; break; }
    case 7: // $22
      var $23=(($2+24)|0);
      var $24=HEAP32[(($23)>>2)];
      $timer=$24;
      var $25=$timer;
      var $26=(($25+44)|0);
      var $27=HEAP8[($26)];
      var $28=(($27) & 1);
      var $29=(($28)&1);
      $was_enabled=$29;
      var $30=$timer;
      var $31=(($30+48)|0);
      var $32=__ZeqRK8attotimeS1_($31, __ZN8attotime4zeroE);
      if ($32) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $33
      var $34=$timer;
      var $35=(($34+48)|0);
      var $36=__ZeqRK8attotimeS1_($35, __ZN8attotime5neverE);
      if ($36) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $37
      var $38=$timer;
      var $39=(($38+44)|0);
      HEAP8[($39)]=0;
      __label__ = 10; break;
    case 10: // $40
      var $41=(($2+52)|0);
      HEAP8[($41)]=0;
      var $42=$timer;
      var $43=(($2+48)|0);
      HEAP32[(($43)>>2)]=$42;
      var $44=(($2+56)|0);
      var $45=$timer;
      var $46=(($45+72)|0);
      var $47=$44;
      var $48=$46;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[(($48)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[(($48+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[(($48+8)>>2)];
      var $49=$was_enabled;
      var $50=(($49) & 1);
      if ($50) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $51
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 269);
      var $52=$timer;
      var $53=(($52+84)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $56
      var $57=$timer;
      var $58=(($57+84)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$timer;
      var $61=$timer;
      var $62=(($61+88)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$timer;
      var $65=(($64+36)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$timer;
      var $68=(($67+40)|0);
      var $69=HEAP32[(($68)>>2)];
      __ZN8device_t13timer_expiredER9emu_timerjiPv($59, $60, $63, $66, $69);
      __label__ = 16; break;
    case 13: // $70
      var $71=$timer;
      var $72=(($71+12)|0);
      var $73=$72;
      var $74=__ZNK13delegate_baseIvPvi8_noparamS1_E6isnullEv($73);
      if ($74) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $75
      var $76=$timer;
      var $77=(($76+12)|0);
      var $78=$77;
      var $79=$timer;
      var $80=(($79+40)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$timer;
      var $83=(($82+36)|0);
      var $84=HEAP32[(($83)>>2)];
      __ZNK13delegate_baseIvPvi8_noparamS1_EclES0_i($78, $81, $84);
      __label__ = 15; break;
    case 15: // $85
      __label__ = 16; break;
    case 16: // $86
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 17; break;
    case 17: // $87
      var $88=(($2+48)|0);
      HEAP32[(($88)>>2)]=0;
      var $89=(($2+52)|0);
      var $90=HEAP8[($89)];
      var $91=(($90) & 1);
      if ($91) { __label__ = 22; break; } else { __label__ = 18; break; }
    case 18: // $92
      var $93=$timer;
      var $94=(($93+45)|0);
      var $95=HEAP8[($94)];
      var $96=(($95) & 1);
      if ($96) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $97
      var $98=(($2+28)|0);
      var $99=$timer;
      var $100=__ZN9emu_timer7releaseEv($99);
      __ZN15fixed_allocatorI9emu_timerE7reclaimERS0_($98, $100);
      __label__ = 21; break;
    case 20: // $101
      var $102=$timer;
      __ZN9emu_timer20schedule_next_periodEv($102);
      __label__ = 21; break;
    case 21: // $103
      __label__ = 22; break;
    case 22: // $104
      __label__ = 6; break;
    case 23: // $105
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler14execute_timersEv["X"]=1;

function __ZL23debugger_start_cpu_hookP8device_t8attotime($device, $endtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $endtime; $endtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($endtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($endtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($endtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$device;
      var $3=$1;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=(($4+584)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 1;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=__ZNK8device_t5debugEv($10);
      var $12=$2;
      var $13=$endtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
      __ZN12device_debug10start_hookE8attotime($11, $2);
      __label__ = 2; break;
    case 2: // $14
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22debugger_stop_cpu_hookP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      var $2=$1;
      var $3=__ZNK8device_t7machineEv($2);
      var $4=(($3+584)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5 & 1;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$1;
      var $10=__ZNK8device_t5debugEv($9);
      __ZN12device_debug9stop_hookEv($10);
      __label__ = 2; break;
    case 2: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z3maxRK8attotimeS1_($agg_result, $left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) > (($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$1;
      var $12=$agg_result;
      var $13=$11;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
      __label__ = 7; break;
    case 2: // $14
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17)|0) < (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$2;
      var $24=$agg_result;
      var $25=$23;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];HEAP32[(($24+4)>>2)]=HEAP32[(($25+4)>>2)];HEAP32[(($24+8)>>2)]=HEAP32[(($25+8)>>2)];
      __label__ = 7; break;
    case 4: // $26
      var $27=$1;
      var $28=(($27+4)|0);
      var $st$2$0=(($28)|0);
      var $29$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$2$1)>>2)];
      var $30=$2;
      var $31=(($30+4)|0);
      var $st$8$0=(($31)|0);
      var $32$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$8$1)>>2)];
      var $33=($29$1|0) > ($32$1|0) || (($29$1|0) == ($32$1|0) && ($29$0|0) >  ($32$0|0));
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$1;
      var $36=$agg_result;
      var $37=$35;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      __label__ = 7; break;
    case 6: // $38
      var $39=$2;
      var $40=$agg_result;
      var $41=$39;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($40)>>2)]=HEAP32[(($41)>>2)];HEAP32[(($40+4)>>2)]=HEAP32[(($41+4)>>2)];HEAP32[(($40+8)>>2)]=HEAP32[(($41+8)>>2)];
      __label__ = 7; break;
    case 7: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z3maxRK8attotimeS1_["X"]=1;

function __ZN16device_scheduler9timer_setE8attotime8delegateIFvPviEEiS2_($this, $duration, $callback, $param, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $duration; $duration = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($duration)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($duration+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($duration+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+24;
  var $6=__stackBase__+36;
  $1=$this;
  $2=$param;
  $3=$ptr;
  var $7=$1;
  var $8=(($7+28)|0);
  var $9=__ZN15fixed_allocatorI9emu_timerE5allocEv($8);
  var $10=__ZNK16device_scheduler7machineEv($7);
  __ZN8delegateIFvPviEEC1ERKS2_($4, $callback);
  var $11=$3;
  var $12=__ZN9emu_timer4initER15running_machine8delegateIFvPviEES3_b($9, $10, $4, $11, 1);
  var $13=$5;
  var $14=$duration;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[(($14)>>2)];HEAP32[(($13+4)>>2)]=HEAP32[(($14+4)>>2)];HEAP32[(($13+8)>>2)]=HEAP32[(($14+8)>>2)];
  var $15=$2;
  var $16=$6;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  __ZN9emu_timer6adjustE8attotimeiS0_($12, $5, $15, $6);
  STACKTOP = __stackBase__;
  return;
}


function __ZN16device_scheduler16boost_interleaveE8attotimeS0_($this, $timeslice_time, $boost_duration) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $timeslice_time; $timeslice_time = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($timeslice_time)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($timeslice_time+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($timeslice_time+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var tempParam = $boost_duration; $boost_duration = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($boost_duration)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($boost_duration+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($boost_duration+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      $1=$this;
      var $4=$1;
      var $5=(($timeslice_time)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 3; break;
    case 2: // $9
      var $10=$2;
      var $11=$timeslice_time;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[(($11)>>2)];HEAP32[(($10+4)>>2)]=HEAP32[(($11+4)>>2)];HEAP32[(($10+8)>>2)]=HEAP32[(($11+8)>>2)];
      var $12=$3;
      var $13=$boost_duration;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
      __ZN16device_scheduler22add_scheduling_quantumE8attotimeS0_($4, $2, $3);
      __label__ = 3; break;
    case 3: // $14
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler22add_scheduling_quantumE8attotimeS0_($this, $quantum, $duration) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $quantum; $quantum = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($quantum)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($quantum+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($quantum+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var tempParam = $duration; $duration = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($duration)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($duration+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($duration+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curtime=__stackBase__;
      var $expire=__stackBase__+12;
      var $insert_after;
      var $next;
      var $quant;
      var $2=__stackBase__+24;
      var $quant1;
      $1=$this;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      __ZNK16device_scheduler4timeEv($curtime, $3);
      __ZplRK8attotimeS1_($expire, $curtime, $duration);
      $insert_after=0;
      var $6=(($3+68)|0);
      var $7=__ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv($6);
      $quant=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$quant;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $11
      var $12=$quant;
      var $13=__ZNK16device_scheduler12quantum_slot4nextEv($12);
      $next=$13;
      var $14=$quant;
      var $15=(($14+20)|0);
      var $16=__ZgeRK8attotimeS1_($curtime, $15);
      if ($16) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      var $18=(($3+88)|0);
      var $19=(($3+68)|0);
      var $20=$quant;
      var $21=__ZN11simple_listIN16device_scheduler12quantum_slotEE6detachERS1_($19, $20);
      __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE7reclaimERS1_($18, $21);
      __label__ = 9; break;
    case 6: // $22
      var $23=$quant;
      var $24=(($23+12)|0);
      var $st$2$0=(($24)|0);
      var $25$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$2$1)>>2)];
      var $26=(($quantum+4)|0);
      var $st$7$0=(($26)|0);
      var $27$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$7$1)>>2)];
      var $28=($25$1|0) <= ($27$1|0) && (($25$1|0) <  ($27$1|0) || ($25$0|0) <= ($27$0|0));
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$quant;
      $insert_after=$30;
      __label__ = 8; break;
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      __label__ = 10; break;
    case 10: // $33
      var $34=$next;
      $quant=$34;
      __label__ = 3; break;
    case 11: // $35
      var $36=$insert_after;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $38
      var $39=$insert_after;
      var $40=(($39+12)|0);
      var $st$2$0=(($40)|0);
      var $41$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($40+4)|0);
      var $41$1=HEAP32[(($st$2$1)>>2)];
      var $42=(($quantum+4)|0);
      var $st$7$0=(($42)|0);
      var $43$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($42+4)|0);
      var $43$1=HEAP32[(($st$7$1)>>2)];
      var $44=$41$0 == $43$0 && $41$1 == $43$1;
      if ($44) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $45
      var $46=$insert_after;
      var $47=(($46+20)|0);
      var $48=$insert_after;
      var $49=(($48+20)|0);
      __Z3maxRK8attotimeS1_($2, $49, $expire);
      var $50=$47;
      var $51=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($50)>>2)]=HEAP32[(($51)>>2)];HEAP32[(($50+4)>>2)]=HEAP32[(($51+4)>>2)];HEAP32[(($50+8)>>2)]=HEAP32[(($51+8)>>2)];
      __label__ = 18; break;
    case 14: // $52
      var $53=(($3+88)|0);
      var $54=__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE5allocEv($53);
      $quant1=$54;
      var $55=(($quantum+4)|0);
      var $st$4$0=(($55)|0);
      var $56$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($55+4)|0);
      var $56$1=HEAP32[(($st$4$1)>>2)];
      var $57=$quant1;
      var $58=(($57+12)|0);
      var $st$10$0=(($58)|0);
      HEAP32[(($st$10$0)>>2)]=$56$0;
      var $st$10$1=(($58+4)|0);
      HEAP32[(($st$10$1)>>2)]=$56$1;
      var $59=(($quantum+4)|0);
      var $st$15$0=(($59)|0);
      var $60$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($59+4)|0);
      var $60$1=HEAP32[(($st$15$1)>>2)];
      var $61=(($3+108)|0);
      var $st$20$0=(($61)|0);
      var $62$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($61+4)|0);
      var $62$1=HEAP32[(($st$20$1)>>2)];
      var $63=($60$1|0) > ($62$1|0) || (($60$1|0) == ($62$1|0) && ($60$0|0) >  ($62$0|0));
      if ($63) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $64
      var $65=(($quantum+4)|0);
      var $st$1$0=(($65)|0);
      var $66$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($65+4)|0);
      var $66$1=HEAP32[(($st$1$1)>>2)];
      var $71$1 = $66$1;var $71$0 = $66$0;__label__ = 17; break;
    case 16: // $67
      var $68=(($3+108)|0);
      var $st$1$0=(($68)|0);
      var $69$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($68+4)|0);
      var $69$1=HEAP32[(($st$1$1)>>2)];
      var $71$1 = $69$1;var $71$0 = $69$0;__label__ = 17; break;
    case 17: // $70
      var $71$0;
      var $71$1;
      var $72=$quant1;
      var $73=(($72+4)|0);
      var $st$4$0=(($73)|0);
      HEAP32[(($st$4$0)>>2)]=$71$0;
      var $st$4$1=(($73+4)|0);
      HEAP32[(($st$4$1)>>2)]=$71$1;
      var $74=$quant1;
      var $75=(($74+20)|0);
      var $76=$75;
      var $77=$expire;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($76)>>2)]=HEAP32[(($77)>>2)];HEAP32[(($76+4)>>2)]=HEAP32[(($77+4)>>2)];HEAP32[(($76+8)>>2)]=HEAP32[(($77+8)>>2)];
      var $78=(($3+68)|0);
      var $79=$quant1;
      var $80=$insert_after;
      var $81=__ZN11simple_listIN16device_scheduler12quantum_slotEE12insert_afterERS1_PS1_($78, $79, $80);
      __label__ = 18; break;
    case 18: // $82
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler22add_scheduling_quantumE8attotimeS0_["X"]=1;

function __ZN16device_scheduler11timer_allocE8delegateIFvPviEES1_($this, $callback, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$ptr;
  var $4=$1;
  var $5=(($4+28)|0);
  var $6=__ZN15fixed_allocatorI9emu_timerE5allocEv($5);
  var $7=__ZNK16device_scheduler7machineEv($4);
  __ZN8delegateIFvPviEEC1ERKS2_($3, $callback);
  var $8=$2;
  var $9=__ZN9emu_timer4initER15running_machine8delegateIFvPviEES3_b($6, $7, $3, $8, 0);
  STACKTOP = __stackBase__;
  return $9;
}


function __ZN8delegateIFvPviEEC1ERKS2_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$3;
  __ZN8delegateIFvPviEEC2ERKS2_($4, $5);
  ;
  return;
}


function __ZN16device_scheduler11timer_allocER8device_tjPv($this, $device, $id, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$device;
  $3=$id;
  $4=$ptr;
  var $5=$1;
  var $6=(($5+28)|0);
  var $7=__ZN15fixed_allocatorI9emu_timerE5allocEv($6);
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=__ZN9emu_timer4initER8device_tjPvb($7, $8, $9, $10, 0);
  ;
  return $11;
}


function __ZN16device_scheduler14eat_all_cyclesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $exec;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      $exec=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$exec;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$exec;
      __ZN24device_execute_interface10eat_cyclesEi($9, 1000000000);
      __label__ = 3; break;
    case 3: // $10
      var $11=$exec;
      var $12=(($11+44)|0);
      var $13=HEAP32[(($12)>>2)];
      $exec=$13;
      __label__ = 1; break;
    case 4: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9emu_timerEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI9emu_timerEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI9emu_timerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI9emu_timerED2Ev($2);
  ;
  return;
}


function __ZN16device_scheduler26compute_perfect_interleaveEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $first;
      var $smallest=__stackBase__;
      var $perfect=__stackBase__+8;
      var $exec;
      var $curquantum=__stackBase__+16;
      var $quant;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __ZN16device_scheduler20rebuild_execute_listEv($2);
      __label__ = 2; break;
    case 2: // $7
      var $8=(($2+8)|0);
      var $9=HEAP32[(($8)>>2)];
      $first=$9;
      var $10=$first;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 22; break; }
    case 3: // $12
      var $13=$first;
      var $14=__ZNK24device_execute_interface15minimum_quantumEv($13);
      var $14$0=$14[0];
      var $14$1=$14[1];
      var $st$4$0=(($smallest)|0);
      HEAP32[(($st$4$0)>>2)]=$14$0;
      var $st$4$1=(($smallest+4)|0);
      HEAP32[(($st$4$1)>>2)]=$14$1;
      var $$emscripten$temp$0$0=-1486618625;
      var $$emscripten$temp$0$1=232830643;
      var $st$10$0=(($perfect)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($perfect+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $15=$first;
      var $16=(($15+44)|0);
      var $17=HEAP32[(($16)>>2)];
      $exec=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$exec;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $21
      var $22=$exec;
      var $23=__ZNK24device_execute_interface15minimum_quantumEv($22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $st$4$0=(($curquantum)|0);
      HEAP32[(($st$4$0)>>2)]=$23$0;
      var $st$4$1=(($curquantum+4)|0);
      HEAP32[(($st$4$1)>>2)]=$23$1;
      var $st$8$0=(($curquantum)|0);
      var $24$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curquantum+4)|0);
      var $24$1=HEAP32[(($st$8$1)>>2)];
      var $st$12$0=(($smallest)|0);
      var $25$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($smallest+4)|0);
      var $25$1=HEAP32[(($st$12$1)>>2)];
      var $26=($24$1|0) < ($25$1|0) || (($24$1|0) == ($25$1|0) && ($24$0|0) <  ($25$0|0));
      if ($26) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $27
      var $st$0$0=(($smallest)|0);
      var $28$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($smallest+4)|0);
      var $28$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($perfect)|0);
      HEAP32[(($st$4$0)>>2)]=$28$0;
      var $st$4$1=(($perfect+4)|0);
      HEAP32[(($st$4$1)>>2)]=$28$1;
      var $st$8$0=(($curquantum)|0);
      var $29$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curquantum+4)|0);
      var $29$1=HEAP32[(($st$8$1)>>2)];
      var $st$12$0=(($smallest)|0);
      HEAP32[(($st$12$0)>>2)]=$29$0;
      var $st$12$1=(($smallest+4)|0);
      HEAP32[(($st$12$1)>>2)]=$29$1;
      __label__ = 10; break;
    case 7: // $30
      var $st$0$0=(($curquantum)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($curquantum+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($perfect)|0);
      var $32$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($perfect+4)|0);
      var $32$1=HEAP32[(($st$4$1)>>2)];
      var $33=($31$1|0) < ($32$1|0) || (($31$1|0) == ($32$1|0) && ($31$0|0) <  ($32$0|0));
      if ($33) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $34
      var $st$0$0=(($curquantum)|0);
      var $35$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($curquantum+4)|0);
      var $35$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($perfect)|0);
      HEAP32[(($st$4$0)>>2)]=$35$0;
      var $st$4$1=(($perfect+4)|0);
      HEAP32[(($st$4$1)>>2)]=$35$1;
      __label__ = 9; break;
    case 9: // $36
      __label__ = 10; break;
    case 10: // $37
      __label__ = 11; break;
    case 11: // $38
      var $39=$exec;
      var $40=(($39+44)|0);
      var $41=HEAP32[(($40)>>2)];
      $exec=$41;
      __label__ = 4; break;
    case 12: // $42
      var $43=(($2+108)|0);
      var $st$1$0=(($43)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($43+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($perfect)|0);
      var $45$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($perfect+4)|0);
      var $45$1=HEAP32[(($st$5$1)>>2)];
      var $46=$44$0 != $45$0 || $44$1 != $45$1;
      if ($46) { __label__ = 13; break; } else { __label__ = 21; break; }
    case 13: // $47
      var $st$0$0=(($perfect)|0);
      var $48$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($perfect+4)|0);
      var $48$1=HEAP32[(($st$0$1)>>2)];
      var $49=(($2+108)|0);
      var $st$5$0=(($49)|0);
      HEAP32[(($st$5$0)>>2)]=$48$0;
      var $st$5$1=(($49+4)|0);
      HEAP32[(($st$5$1)>>2)]=$48$1;
      var $50=(($2+68)|0);
      var $51=__ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv($50);
      $quant=$51;
      __label__ = 14; break;
    case 14: // $52
      var $53=$quant;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $55
      var $56=$quant;
      var $57=(($56+12)|0);
      var $st$2$0=(($57)|0);
      var $58$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($57+4)|0);
      var $58$1=HEAP32[(($st$2$1)>>2)];
      var $59=(($2+108)|0);
      var $st$7$0=(($59)|0);
      var $60$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($59+4)|0);
      var $60$1=HEAP32[(($st$7$1)>>2)];
      var $61=($58$1|0) > ($60$1|0) || (($58$1|0) == ($60$1|0) && ($58$0|0) >  ($60$0|0));
      if ($61) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $62
      var $63=$quant;
      var $64=(($63+12)|0);
      var $st$2$0=(($64)|0);
      var $65$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($64+4)|0);
      var $65$1=HEAP32[(($st$2$1)>>2)];
      var $70$1 = $65$1;var $70$0 = $65$0;__label__ = 18; break;
    case 17: // $66
      var $67=(($2+108)|0);
      var $st$1$0=(($67)|0);
      var $68$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($67+4)|0);
      var $68$1=HEAP32[(($st$1$1)>>2)];
      var $70$1 = $68$1;var $70$0 = $68$0;__label__ = 18; break;
    case 18: // $69
      var $70$0;
      var $70$1;
      var $71=$quant;
      var $72=(($71+4)|0);
      var $st$4$0=(($72)|0);
      HEAP32[(($st$4$0)>>2)]=$70$0;
      var $st$4$1=(($72+4)|0);
      HEAP32[(($st$4$1)>>2)]=$70$1;
      __label__ = 19; break;
    case 19: // $73
      var $74=$quant;
      var $75=__ZNK16device_scheduler12quantum_slot4nextEv($74);
      $quant=$75;
      __label__ = 14; break;
    case 20: // $76
      __label__ = 21; break;
    case 21: // $77
      __label__ = 22; break;
    case 22: // $78
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16device_scheduler26compute_perfect_interleaveEv["X"]=1;

function __Z3minRK8attotimeS1_($agg_result, $left, $right) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$left;
      $2=$right;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) > (($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=$agg_result;
      var $13=$11;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
      __label__ = 7; break;
    case 2: // $14
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17)|0) < (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$1;
      var $24=$agg_result;
      var $25=$23;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];HEAP32[(($24+4)>>2)]=HEAP32[(($25+4)>>2)];HEAP32[(($24+8)>>2)]=HEAP32[(($25+8)>>2)];
      __label__ = 7; break;
    case 4: // $26
      var $27=$1;
      var $28=(($27+4)|0);
      var $st$2$0=(($28)|0);
      var $29$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$2$1)>>2)];
      var $30=$2;
      var $31=(($30+4)|0);
      var $st$8$0=(($31)|0);
      var $32$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$8$1)>>2)];
      var $33=($29$1|0) > ($32$1|0) || (($29$1|0) == ($32$1|0) && ($29$0|0) >  ($32$0|0));
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$2;
      var $36=$agg_result;
      var $37=$35;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      __label__ = 7; break;
    case 6: // $38
      var $39=$1;
      var $40=$agg_result;
      var $41=$39;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($40)>>2)]=HEAP32[(($41)>>2)];HEAP32[(($40+4)>>2)]=HEAP32[(($41+4)>>2)];HEAP32[(($40+8)>>2)]=HEAP32[(($41+8)>>2)];
      __label__ = 7; break;
    case 7: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z3minRK8attotimeS1_["X"]=1;

function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE7reclaimEPS1_($this, $item) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$item;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($3)|0);
      var $8=$2;
      var $9=__ZN11simple_listIN16device_scheduler12quantum_slotEE6appendERS1_($7, $8);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t13timer_expiredER9emu_timerjiPv($this, $timer, $id, $param, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$timer;
  $3=$id;
  $4=$param;
  $5=$ptr;
  var $6=$1;
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+56)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  FUNCTION_TABLE[$10]($6, $11, $12, $13, $14);
  ;
  return;
}


function __ZNK13delegate_baseIvPvi8_noparamS1_E6isnullEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $12 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      var $12 = $10;__label__ = 2; break;
    case 2: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN16device_scheduler12quantum_slotEE6detachERS1_["X"]=1;

function __ZN11simple_listIN16device_scheduler12quantum_slotEE7prependERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN16device_scheduler12quantum_slotEE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9emu_timerEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI9emu_timerE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK13delegate_baseIvPvi8_noparamS1_EclES0_i($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  var $10=$3;
  FUNCTION_TABLE[$6]($8, $9, $10);
  ;
  return;
}


function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE7reclaimERS1_($this, $item) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$item;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=__ZN11simple_listIN16device_scheduler12quantum_slotEE6appendERS1_($4, $5);
  ;
  return;
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEE12insert_afterERS1_PS1_($this, $object, $insert_after) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$object;
      $4=$insert_after;
      var $5=$2;
      var $6=$4;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=__ZN11simple_listIN16device_scheduler12quantum_slotEE7prependERS1_($5, $9);
      $1=$10;
      __label__ = 5; break;
    case 2: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$3;
      var $18=$4;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=(($5+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$4;
      var $23=(($21)|0)==(($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$3;
      var $26=(($5+8)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 4; break;
    case 4: // $27
      var $28=(($5+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+1)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$3;
      $1=$31;
      __label__ = 5; break;
    case 5: // $32
      var $33=$1;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16device_scheduler12quantum_slotC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16device_scheduler12quantum_slotC2Ev($2);
  ;
  return;
}


function __ZN16device_scheduler12quantum_slotC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  __ZN8attotimeC1Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 32);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN16device_scheduler12quantum_slotEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvvEEC2I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I16device_schedulerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I16device_schedulerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM16device_schedulerFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=254;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM16device_schedulerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM16device_schedulerFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE5allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $result;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=(($10)|0);
      var $12=__ZN11simple_listIN16device_scheduler12quantum_slotEE11detach_headEv($11);
      $result=$12;
      var $13=$result;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $15
      var $16=(($10)|0);
      var $17=__ZNK11simple_listIN16device_scheduler12quantum_slotEE4poolEv($16);
      var $18=$4;
      var $19=$result_i;
      var $20=$5;
      var $21=$6;
      HEAP32[(($4)>>2)]=32;
      var $22=HEAP32[(($4)>>2)];
      var $23=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $24
      HEAP32[(($result_i)>>2)]=$23;
      var $25=HEAP32[(($result_i)>>2)];
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $27
      var $28=___cxa_allocate_exception(4);
      var $29=$28;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($29);
      (function() { try { __THREW__ = false; return ___cxa_throw($28, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      HEAP32[(($5)>>2)]=$32;
      var $33=$31.f1;
      HEAP32[(($6)>>2)]=$33;
      var $34=HEAP32[(($6)>>2)];
      var $35=(($34)|0) < 0;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      var $37=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($37);
      throw "Reached an unreachable!"
    case 6: // $38
      var $39=HEAP32[(($5)>>2)];
      var $40=HEAP32[(($5)>>2)];
      var $41=HEAP32[(($6)>>2)];
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $44
      throw "Reached an unreachable!"
    case 8: // $_Znwj_exit
      var $45=HEAP32[(($result_i)>>2)];
      var $46=$4;
      var $47=$result_i;
      var $48=$5;
      var $49=$6;
      var $50=$45;
      (function() { try { __THREW__ = false; return __ZN16device_scheduler12quantum_slotC1Ev($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $51
      var $52=__ZN13resource_pool10add_objectIN16device_scheduler12quantum_slotEEEPT_S4_($17, $50);
      $result=$52;
      __label__ = 15; break;
    case 10: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $8=$55;
      var $56=$54.f1;
      $9=$56;
      var $57=$1;
      var $58=$2;
      var $59=$3;
      HEAP32[(($1)>>2)]=$45;
      var $60=HEAP32[(($1)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $62
      var $63=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($63, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      __label__ = 14; break;
    case 13: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      HEAP32[(($2)>>2)]=$67;
      var $68=$66.f1;
      HEAP32[(($3)>>2)]=$68;
      var $69=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($69);
      throw "Reached an unreachable!"
    case 14: // $_ZdlPv_exit
      var $70=$1;
      var $71=$2;
      var $72=$3;
      __label__ = 16; break;
    case 15: // $73
      var $74=$result;
      STACKTOP = __stackBase__;
      return $74;
    case 16: // $75
      var $76=$8;
      var $77=$8;
      var $78=$9;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE5allocEv["X"]=1;

function __ZN13resource_pool10add_objectIN16device_scheduler12quantum_slotEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN16device_scheduler12quantum_slotEEEPT_S4_["X"]=1;

function __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN16device_scheduler12quantum_slotEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9emu_timerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI9emu_timerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI9emu_timerED0Ev["X"]=1;

function __ZN21delegate_internal_mfpC2IM16device_schedulerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI9emu_timerE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI9emu_timerE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI9emu_timerE6detachERS0_["X"]=1;

function __ZN11simple_listIN16device_scheduler12quantum_slotEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN16device_scheduler12quantum_slotEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI16device_schedulerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI16device_scheduler, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI9emu_timerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI9emu_timerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI9emu_timerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 92);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI9emu_timerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI9emu_timerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI9emu_timerED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN16device_scheduler12quantum_slotEE+8)|0);
  __ZN11simple_listIN16device_scheduler12quantum_slotEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN16device_scheduler12quantum_slotEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16device_scheduler12quantum_slotEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN16device_scheduler12quantum_slotEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI9emu_timerED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI9emu_timerE+8)|0);
  __ZN11simple_listI9emu_timerE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI9emu_timerE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI9emu_timerE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9emu_timerE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI9emu_timerE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listIN16device_scheduler12quantum_slotEEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN15fixed_allocatorI9emu_timerEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listI9emu_timerEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN8delegateIFvPviEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvPvi8_noparamS1_EC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvPviEEC2ERKS2_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  __ZN13delegate_baseIvPvi8_noparamS1_EC2ERKS2_($5, $7);
  ;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_EC2ERKS2_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3+4)|0);
  var $9=$2;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  HEAP32[(($8)>>2)]=$11;
  var $12=(($3+8)|0);
  var $13=$2;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  HEAP32[(($12)>>2)]=$15;
  var $16=(($3+12)|0);
  var $17=$2;
  var $18=(($17+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($16, $18);
  var $19=(($3+20)|0);
  var $20=$2;
  var $21=(($20+20)|0);
  var $22=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$22;
  ;
  return;
}


function __ZN15fixed_allocatorI9emu_timerED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listI9emu_timerED1Ev($3);
  ;
  return;
}


function __ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_EaSERKS2_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI9emu_timerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI9emu_timerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI9emu_timerEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI9emu_timerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI9emu_timerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI9emu_timerED0Ev["X"]=1;

function __ZN20resource_pool_objectI9emu_timerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI9emu_timerE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN9emu_timerD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI9emu_timerED2Ev["X"]=1;

function __ZN11simple_listIN16device_scheduler12quantum_slotEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN16device_scheduler12quantum_slotEED0Ev["X"]=1;

function __ZN11simple_listI13address_spaceE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15_memory_privateC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15_memory_privateC2Ev($2);
  ;
  return;
}


function __ZNK11device_list5firstI23device_memory_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceERP23device_memory_interface($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z11memory_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $memdata;
      var $12;
      var $13;
      var $memory=__stackBase__+44;
      var $gotone;
      var $spacenum=__stackBase__+48;
      var $spaceconfig;
      var $space;
      var $space1;
      var $space2;
      var $space3;
      var $14=__stackBase__+52;
      $11=$machine;
      var $15=$11;
      var $16=__ZN15running_machine7respoolEv($15);
      var $17=$5;
      var $18=$6;
      var $19=$7;
      var $20=$8;
      var $21=$result_i;
      var $22=$9;
      var $23=$10;
      HEAP32[(($5)>>2)]=1868;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($7)>>2)]=1715;
      HEAP32[(($8)>>2)]=_zeromem;
      var $24=HEAP32[(($5)>>2)];
      var $25=HEAP32[(($6)>>2)];
      var $26=HEAP32[(($7)>>2)];
      var $27=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $28
      HEAP32[(($result_i)>>2)]=$27;
      var $29=HEAP32[(($result_i)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $31
      var $32=___cxa_allocate_exception(4);
      var $33=$32;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33);
      (function() { try { __THREW__ = false; return ___cxa_throw($32, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      HEAP32[(($9)>>2)]=$36;
      var $37=$35.f1;
      HEAP32[(($10)>>2)]=$37;
      var $38=HEAP32[(($10)>>2)];
      var $39=(($38)|0) < 0;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($41);
      throw "Reached an unreachable!"
    case 5: // $42
      var $43=HEAP32[(($9)>>2)];
      var $44=HEAP32[(($9)>>2)];
      var $45=HEAP32[(($10)>>2)];
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $48
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $49=HEAP32[(($result_i)>>2)];
      var $50=HEAP32[(($5)>>2)];
      _memset($49, 0, $50, 1);
      var $51=HEAPU32[(($result_i)>>2)];
      var $52=$5;
      var $53=$6;
      var $54=$7;
      var $55=$8;
      var $56=$result_i;
      var $57=$9;
      var $58=$10;
      var $59=$51;
      (function() { try { __THREW__ = false; return __ZN15_memory_privateC1Ev($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $60
      var $61=__ZN13resource_pool10add_objectI15_memory_privateEEPT_S3_($16, $59);
      var $62=$11;
      var $63=(($62+624)|0);
      HEAP32[(($63)>>2)]=$61;
      $memdata=$61;
      var $64=$memdata;
      var $65=(($64+1476)|0);
      HEAP8[($65)]=1;
      HEAP32[(($memory)>>2)]=0;
      var $66=$11;
      var $67=__ZNK15running_machine10devicelistEv($66);
      var $68=__ZNK11device_list5firstI23device_memory_interfaceEEbRPT_($67, $memory);
      var $69=(($68)&1);
      $gotone=$69;
      __label__ = 9; break;
    case 9: // $70
      var $71=$gotone;
      var $72=(($71) & 1);
      if ($72) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $73
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 11; break;
    case 11: // $74
      var $75=HEAP32[(($spacenum)>>2)];
      var $76=(($75)|0) < 4;
      if ($76) { __label__ = 12; break; } else { __label__ = 21; break; }
    case 12: // $77
      var $78=HEAP32[(($memory)>>2)];
      var $79=HEAP32[(($spacenum)>>2)];
      var $80=__ZNK23device_memory_interface12space_configE16address_spacenum($78, $79);
      $spaceconfig=$80;
      var $81=$spaceconfig;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $83
      var $84=$memdata;
      var $85=(($84+1028)|0);
      var $86=$11;
      var $87=$spaceconfig;
      var $88=HEAP32[(($memory)>>2)];
      var $89=HEAP32[(($spacenum)>>2)];
      var $90=__ZN13address_space8allocateER15running_machineRK20address_space_configR23device_memory_interface16address_spacenum($86, $87, $88, $89);
      var $91=__ZN11simple_listI13address_spaceE6appendERS0_($85, $90);
      __label__ = 19; break;
    case 14: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $94=$93.f0;
      $12=$94;
      var $95=$93.f1;
      $13=$95;
      var $96=$1;
      var $97=$2;
      var $98=$3;
      var $99=$4;
      HEAP32[(($1)>>2)]=$51;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=1715;
      HEAP32[(($4)>>2)]=_zeromem;
      var $100=HEAP32[(($1)>>2)];
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $102
      var $103=HEAP32[(($1)>>2)];
      var $104=HEAP32[(($2)>>2)];
      var $105=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($103, $104, $105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 41; break; }
    case 16: // $_noexc
      __label__ = 17; break;
    case 17: // $_ZdlPvPKciRK9zeromem_t_exit
      var $106=$1;
      var $107=$2;
      var $108=$3;
      var $109=$4;
      __label__ = 18; break;
    case 18: // $110
      __label__ = 40; break;
    case 19: // $111
      __label__ = 20; break;
    case 20: // $112
      __ZppR16address_spacenumi($spacenum, 0);
      __label__ = 11; break;
    case 21: // $113
      __label__ = 22; break;
    case 22: // $114
      var $115=HEAP32[(($memory)>>2)];
      var $116=$115;
      var $117=__ZNK16device_interface4nextI23device_memory_interfaceEEbRPT_($116, $memory);
      var $118=(($117)&1);
      $gotone=$118;
      __label__ = 9; break;
    case 23: // $119
      var $120=$memdata;
      var $121=(($120+1028)|0);
      var $122=__ZNK11simple_listI13address_spaceE5firstEv($121);
      $space=$122;
      __label__ = 24; break;
    case 24: // $123
      var $124=$space;
      var $125=(($124)|0)!=0;
      if ($125) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $126
      var $127=$space;
      __ZN13address_space11prepare_mapEv($127);
      __label__ = 26; break;
    case 26: // $128
      var $129=$space;
      var $130=__ZNK13address_space4nextEv($129);
      $space=$130;
      __label__ = 24; break;
    case 27: // $131
      var $132=$memdata;
      var $133=(($132+1028)|0);
      var $134=__ZNK11simple_listI13address_spaceE5firstEv($133);
      $space1=$134;
      __label__ = 28; break;
    case 28: // $135
      var $136=$space1;
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $138
      var $139=$space1;
      __ZN13address_space17populate_from_mapEv($139);
      __label__ = 30; break;
    case 30: // $140
      var $141=$space1;
      var $142=__ZNK13address_space4nextEv($141);
      $space1=$142;
      __label__ = 28; break;
    case 31: // $143
      var $144=$memdata;
      var $145=(($144+1028)|0);
      var $146=__ZNK11simple_listI13address_spaceE5firstEv($145);
      $space2=$146;
      __label__ = 32; break;
    case 32: // $147
      var $148=$space2;
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $150
      var $151=$space2;
      __ZN13address_space15allocate_memoryEv($151);
      __label__ = 34; break;
    case 34: // $152
      var $153=$space2;
      var $154=__ZNK13address_space4nextEv($153);
      $space2=$154;
      __label__ = 32; break;
    case 35: // $155
      var $156=$memdata;
      var $157=(($156+1028)|0);
      var $158=__ZNK11simple_listI13address_spaceE5firstEv($157);
      $space3=$158;
      __label__ = 36; break;
    case 36: // $159
      var $160=$space3;
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $162
      var $163=$space3;
      __ZN13address_space13locate_memoryEv($163);
      __label__ = 38; break;
    case 38: // $164
      var $165=$space3;
      var $166=__ZNK13address_space4nextEv($165);
      $space3=$166;
      __label__ = 36; break;
    case 39: // $167
      var $168=$11;
      var $169=__ZN15running_machine4saveEv($168);
      var $170=$11;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($14, 256, ((STRING_TABLE.__str12892)|0), $170);
      __ZN12save_manager17register_postloadE8delegateIFvvEE($169, $14);
      var $171=$11;
      __ZL16generate_memdumpR15running_machine($171);
      var $172=$memdata;
      var $173=(($172)|0);
      HEAP8[($173)]=1;
      STACKTOP = __stackBase__;
      return;
    case 40: // $174
      var $175=$12;
      var $176=$12;
      var $177=$13;
      var $178=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $176, tempValue);
      var $179=($178.f1 = $177, $178);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 41: // $180
      var $181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11memory_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI15_memory_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI15_memory_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI15_memory_privateEEPT_S3_["X"]=1;

function __ZN13address_space8allocateER15running_machineRK20address_space_configR23device_memory_interface16address_spacenum($machine, $config, $memory, $spacenum) {
  var __stackBase__  = STACKTOP; STACKTOP += 576; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i57=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i53=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i49=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25=__stackBase__+108;
      var $26=__stackBase__+112;
      var $27=__stackBase__+116;
      var $28=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $result_i45=__stackBase__+132;
      var $31=__stackBase__+136;
      var $32=__stackBase__+140;
      var $33=__stackBase__+144;
      var $34=__stackBase__+148;
      var $35=__stackBase__+152;
      var $36=__stackBase__+156;
      var $37=__stackBase__+160;
      var $38=__stackBase__+164;
      var $result_i41=__stackBase__+168;
      var $39=__stackBase__+172;
      var $40=__stackBase__+176;
      var $41=__stackBase__+180;
      var $42=__stackBase__+184;
      var $43=__stackBase__+188;
      var $44=__stackBase__+192;
      var $45=__stackBase__+196;
      var $46=__stackBase__+200;
      var $result_i37=__stackBase__+204;
      var $47=__stackBase__+208;
      var $48=__stackBase__+212;
      var $49=__stackBase__+216;
      var $50=__stackBase__+220;
      var $51=__stackBase__+224;
      var $52=__stackBase__+228;
      var $53=__stackBase__+232;
      var $54=__stackBase__+236;
      var $result_i33=__stackBase__+240;
      var $55=__stackBase__+244;
      var $56=__stackBase__+248;
      var $57=__stackBase__+252;
      var $58=__stackBase__+256;
      var $59=__stackBase__+260;
      var $60=__stackBase__+264;
      var $61=__stackBase__+268;
      var $62=__stackBase__+272;
      var $result_i29=__stackBase__+276;
      var $63=__stackBase__+280;
      var $64=__stackBase__+284;
      var $65=__stackBase__+288;
      var $66=__stackBase__+292;
      var $67=__stackBase__+296;
      var $68=__stackBase__+300;
      var $69=__stackBase__+304;
      var $70=__stackBase__+308;
      var $result_i25=__stackBase__+312;
      var $71=__stackBase__+316;
      var $72=__stackBase__+320;
      var $73=__stackBase__+324;
      var $74=__stackBase__+328;
      var $75=__stackBase__+332;
      var $76=__stackBase__+336;
      var $77=__stackBase__+340;
      var $78=__stackBase__+344;
      var $result_i21=__stackBase__+348;
      var $79=__stackBase__+352;
      var $80=__stackBase__+356;
      var $81=__stackBase__+360;
      var $82=__stackBase__+364;
      var $83=__stackBase__+368;
      var $84=__stackBase__+372;
      var $85=__stackBase__+376;
      var $86=__stackBase__+380;
      var $result_i17=__stackBase__+384;
      var $87=__stackBase__+388;
      var $88=__stackBase__+392;
      var $89=__stackBase__+396;
      var $90=__stackBase__+400;
      var $91=__stackBase__+404;
      var $92=__stackBase__+408;
      var $93=__stackBase__+412;
      var $94=__stackBase__+416;
      var $result_i13=__stackBase__+420;
      var $95=__stackBase__+424;
      var $96=__stackBase__+428;
      var $97=__stackBase__+432;
      var $98=__stackBase__+436;
      var $99=__stackBase__+440;
      var $100=__stackBase__+444;
      var $101=__stackBase__+448;
      var $102=__stackBase__+452;
      var $result_i9=__stackBase__+456;
      var $103=__stackBase__+460;
      var $104=__stackBase__+464;
      var $105=__stackBase__+468;
      var $106=__stackBase__+472;
      var $107=__stackBase__+476;
      var $108=__stackBase__+480;
      var $109=__stackBase__+484;
      var $110=__stackBase__+488;
      var $result_i5=__stackBase__+492;
      var $111=__stackBase__+496;
      var $112=__stackBase__+500;
      var $113=__stackBase__+504;
      var $114=__stackBase__+508;
      var $115=__stackBase__+512;
      var $116=__stackBase__+516;
      var $117=__stackBase__+520;
      var $118=__stackBase__+524;
      var $result_i1=__stackBase__+528;
      var $119=__stackBase__+532;
      var $120=__stackBase__+536;
      var $121=__stackBase__+540;
      var $122=__stackBase__+544;
      var $123=__stackBase__+548;
      var $124=__stackBase__+552;
      var $125=__stackBase__+556;
      var $126=__stackBase__+560;
      var $result_i=__stackBase__+564;
      var $127=__stackBase__+568;
      var $128=__stackBase__+572;
      var $129;
      var $130;
      var $131;
      var $132;
      var $133;
      var $large;
      var $134;
      var $135;
      $130=$machine;
      $131=$config;
      $132=$memory;
      $133=$spacenum;
      var $136=$131;
      var $137=$131;
      var $138=(($137+9)|0);
      var $139=HEAPU8[($138)];
      var $140=(($139)&255);
      var $141=((32-$140)|0);
      var $142=-1 >>> (($141)>>>0);
      var $143=__ZNK20address_space_config13addr2byte_endEj($136, $142);
      var $144=(($143)>>>0) >= 262144;
      var $145=(($144)&1);
      $large=$145;
      var $146=$131;
      var $147=__ZNK20address_space_config10data_widthEv($146);
      if ($147 == 8) {
        __label__ = 1; break;
      }
      else if ($147 == 16) {
        __label__ = 60; break;
      }
      else if ($147 == 32) {
        __label__ = 119; break;
      }
      else if ($147 == 64) {
        __label__ = 178; break;
      }
      else {
      __label__ = 237; break;
      }
      
    case 1: // $148
      var $149=$131;
      var $150=__ZNK20address_space_config10endiannessEv($149);
      var $151=(($150)|0)==0;
      if ($151) { __label__ = 2; break; } else { __label__ = 31; break; }
    case 2: // $152
      var $153=$large;
      var $154=(($153) & 1);
      if ($154) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $155
      var $156=$130;
      var $157=__ZN15running_machine7respoolEv($156);
      var $158=$124;
      var $159=$125;
      var $160=$126;
      var $161=$result_i;
      var $162=$127;
      var $163=$128;
      HEAP32[(($124)>>2)]=2820;
      HEAP32[(($125)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($126)>>2)]=2056;
      var $164=HEAP32[(($124)>>2)];
      var $165=HEAP32[(($125)>>2)];
      var $166=HEAP32[(($126)>>2)];
      var $167=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($164, $165, $166) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $168
      HEAP32[(($result_i)>>2)]=$167;
      var $169=HEAP32[(($result_i)>>2)];
      var $170=(($169)|0)==0;
      if ($170) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $171
      var $172=___cxa_allocate_exception(4);
      var $173=$172;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($173);
      (function() { try { __THREW__ = false; return ___cxa_throw($172, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $174
      var $175=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $176=$175.f0;
      HEAP32[(($127)>>2)]=$176;
      var $177=$175.f1;
      HEAP32[(($128)>>2)]=$177;
      var $178=HEAP32[(($128)>>2)];
      var $179=(($178)|0) < 0;
      if ($179) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $180
      var $181=HEAP32[(($127)>>2)];
      ___cxa_call_unexpected($181);
      throw "Reached an unreachable!"
    case 8: // $182
      var $183=HEAP32[(($127)>>2)];
      var $184=HEAP32[(($127)>>2)];
      var $185=HEAP32[(($128)>>2)];
      var $186=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $184, tempValue);
      var $187=($186.f1 = $185, $186);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $188
      throw "Reached an unreachable!"
    case 10: // $_ZnwjPKci_exit
      var $189=HEAP32[(($result_i)>>2)];
      var $190=$124;
      var $191=$125;
      var $192=$126;
      var $193=$result_i;
      var $194=$127;
      var $195=$128;
      var $196=$189;
      var $197=$132;
      var $198=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($196, $197, $198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $199
      var $200=__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb1EEEEPT_S5_($157, $196);
      var $201=$200;
      $129=$201;
      __label__ = 241; break;
    case 12: // $202
      var $203=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $204=$203.f0;
      $134=$204;
      var $205=$203.f1;
      $135=$205;
      var $206=$121;
      var $207=$122;
      var $208=$123;
      HEAP32[(($121)>>2)]=$189;
      HEAP32[(($122)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($123)>>2)]=2056;
      var $209=HEAP32[(($121)>>2)];
      var $210=(($209)|0)!=0;
      if ($210) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $211
      var $212=HEAP32[(($121)>>2)];
      var $213=HEAP32[(($122)>>2)];
      var $214=HEAP32[(($123)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($212, $213, $214) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 243; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $215=$121;
      var $216=$122;
      var $217=$123;
      __label__ = 16; break;
    case 16: // $218
      __label__ = 242; break;
    case 17: // $219
      var $220=$130;
      var $221=__ZN15running_machine7respoolEv($220);
      var $222=$116;
      var $223=$117;
      var $224=$118;
      var $225=$result_i1;
      var $226=$119;
      var $227=$120;
      HEAP32[(($116)>>2)]=2820;
      HEAP32[(($117)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($118)>>2)]=2058;
      var $228=HEAP32[(($116)>>2)];
      var $229=HEAP32[(($117)>>2)];
      var $230=HEAP32[(($118)>>2)];
      var $231=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($228, $229, $230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $232
      HEAP32[(($result_i1)>>2)]=$231;
      var $233=HEAP32[(($result_i1)>>2)];
      var $234=(($233)|0)==0;
      if ($234) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $235
      var $236=___cxa_allocate_exception(4);
      var $237=$236;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($237);
      (function() { try { __THREW__ = false; return ___cxa_throw($236, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 20; break; }
    case 20: // $238
      var $239=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $240=$239.f0;
      HEAP32[(($119)>>2)]=$240;
      var $241=$239.f1;
      HEAP32[(($120)>>2)]=$241;
      var $242=HEAP32[(($120)>>2)];
      var $243=(($242)|0) < 0;
      if ($243) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $244
      var $245=HEAP32[(($119)>>2)];
      ___cxa_call_unexpected($245);
      throw "Reached an unreachable!"
    case 22: // $246
      var $247=HEAP32[(($119)>>2)];
      var $248=HEAP32[(($119)>>2)];
      var $249=HEAP32[(($120)>>2)];
      var $250=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $248, tempValue);
      var $251=($250.f1 = $249, $250);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $252
      throw "Reached an unreachable!"
    case 24: // $_ZnwjPKci_exit2
      var $253=HEAP32[(($result_i1)>>2)];
      var $254=$116;
      var $255=$117;
      var $256=$118;
      var $257=$result_i1;
      var $258=$119;
      var $259=$120;
      var $260=$253;
      var $261=$132;
      var $262=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($260, $261, $262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $263
      var $264=__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb0EEEEPT_S5_($221, $260);
      var $265=$264;
      $129=$265;
      __label__ = 241; break;
    case 26: // $266
      var $267=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $268=$267.f0;
      $134=$268;
      var $269=$267.f1;
      $135=$269;
      var $270=$113;
      var $271=$114;
      var $272=$115;
      HEAP32[(($113)>>2)]=$253;
      HEAP32[(($114)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($115)>>2)]=2058;
      var $273=HEAP32[(($113)>>2)];
      var $274=(($273)|0)!=0;
      if ($274) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $275
      var $276=HEAP32[(($113)>>2)];
      var $277=HEAP32[(($114)>>2)];
      var $278=HEAP32[(($115)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($276, $277, $278) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 243; break; }
    case 28: // $_noexc3
      __label__ = 29; break;
    case 29: // $_ZdlPvPKci_exit4
      var $279=$113;
      var $280=$114;
      var $281=$115;
      __label__ = 30; break;
    case 30: // $282
      __label__ = 242; break;
    case 31: // $283
      var $284=$large;
      var $285=(($284) & 1);
      if ($285) { __label__ = 32; break; } else { __label__ = 46; break; }
    case 32: // $286
      var $287=$130;
      var $288=__ZN15running_machine7respoolEv($287);
      var $289=$108;
      var $290=$109;
      var $291=$110;
      var $292=$result_i5;
      var $293=$111;
      var $294=$112;
      HEAP32[(($108)>>2)]=2820;
      HEAP32[(($109)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($110)>>2)]=2063;
      var $295=HEAP32[(($108)>>2)];
      var $296=HEAP32[(($109)>>2)];
      var $297=HEAP32[(($110)>>2)];
      var $298=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($295, $296, $297) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; };
    case 33: // $299
      HEAP32[(($result_i5)>>2)]=$298;
      var $300=HEAP32[(($result_i5)>>2)];
      var $301=(($300)|0)==0;
      if ($301) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $302
      var $303=___cxa_allocate_exception(4);
      var $304=$303;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($304);
      (function() { try { __THREW__ = false; return ___cxa_throw($303, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $305
      var $306=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $307=$306.f0;
      HEAP32[(($111)>>2)]=$307;
      var $308=$306.f1;
      HEAP32[(($112)>>2)]=$308;
      var $309=HEAP32[(($112)>>2)];
      var $310=(($309)|0) < 0;
      if ($310) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $311
      var $312=HEAP32[(($111)>>2)];
      ___cxa_call_unexpected($312);
      throw "Reached an unreachable!"
    case 37: // $313
      var $314=HEAP32[(($111)>>2)];
      var $315=HEAP32[(($111)>>2)];
      var $316=HEAP32[(($112)>>2)];
      var $317=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $315, tempValue);
      var $318=($317.f1 = $316, $317);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $319
      throw "Reached an unreachable!"
    case 39: // $_ZnwjPKci_exit6
      var $320=HEAP32[(($result_i5)>>2)];
      var $321=$108;
      var $322=$109;
      var $323=$110;
      var $324=$result_i5;
      var $325=$111;
      var $326=$112;
      var $327=$320;
      var $328=$132;
      var $329=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($327, $328, $329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $330
      var $331=__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb1EEEEPT_S5_($288, $327);
      var $332=$331;
      $129=$332;
      __label__ = 241; break;
    case 41: // $333
      var $334=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $335=$334.f0;
      $134=$335;
      var $336=$334.f1;
      $135=$336;
      var $337=$105;
      var $338=$106;
      var $339=$107;
      HEAP32[(($105)>>2)]=$320;
      HEAP32[(($106)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($107)>>2)]=2063;
      var $340=HEAP32[(($105)>>2)];
      var $341=(($340)|0)!=0;
      if ($341) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $342
      var $343=HEAP32[(($105)>>2)];
      var $344=HEAP32[(($106)>>2)];
      var $345=HEAP32[(($107)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($343, $344, $345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 243; break; }
    case 43: // $_noexc7
      __label__ = 44; break;
    case 44: // $_ZdlPvPKci_exit8
      var $346=$105;
      var $347=$106;
      var $348=$107;
      __label__ = 45; break;
    case 45: // $349
      __label__ = 242; break;
    case 46: // $350
      var $351=$130;
      var $352=__ZN15running_machine7respoolEv($351);
      var $353=$100;
      var $354=$101;
      var $355=$102;
      var $356=$result_i9;
      var $357=$103;
      var $358=$104;
      HEAP32[(($100)>>2)]=2820;
      HEAP32[(($101)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($102)>>2)]=2065;
      var $359=HEAP32[(($100)>>2)];
      var $360=HEAP32[(($101)>>2)];
      var $361=HEAP32[(($102)>>2)];
      var $362=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($359, $360, $361) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; };
    case 47: // $363
      HEAP32[(($result_i9)>>2)]=$362;
      var $364=HEAP32[(($result_i9)>>2)];
      var $365=(($364)|0)==0;
      if ($365) { __label__ = 48; break; } else { __label__ = 53; break; }
    case 48: // $366
      var $367=___cxa_allocate_exception(4);
      var $368=$367;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($368);
      (function() { try { __THREW__ = false; return ___cxa_throw($367, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 49; break; }
    case 49: // $369
      var $370=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $371=$370.f0;
      HEAP32[(($103)>>2)]=$371;
      var $372=$370.f1;
      HEAP32[(($104)>>2)]=$372;
      var $373=HEAP32[(($104)>>2)];
      var $374=(($373)|0) < 0;
      if ($374) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $375
      var $376=HEAP32[(($103)>>2)];
      ___cxa_call_unexpected($376);
      throw "Reached an unreachable!"
    case 51: // $377
      var $378=HEAP32[(($103)>>2)];
      var $379=HEAP32[(($103)>>2)];
      var $380=HEAP32[(($104)>>2)];
      var $381=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $379, tempValue);
      var $382=($381.f1 = $380, $381);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 52: // $383
      throw "Reached an unreachable!"
    case 53: // $_ZnwjPKci_exit10
      var $384=HEAP32[(($result_i9)>>2)];
      var $385=$100;
      var $386=$101;
      var $387=$102;
      var $388=$result_i9;
      var $389=$103;
      var $390=$104;
      var $391=$384;
      var $392=$132;
      var $393=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($391, $392, $393) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $394
      var $395=__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb0EEEEPT_S5_($352, $391);
      var $396=$395;
      $129=$396;
      __label__ = 241; break;
    case 55: // $397
      var $398=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $399=$398.f0;
      $134=$399;
      var $400=$398.f1;
      $135=$400;
      var $401=$97;
      var $402=$98;
      var $403=$99;
      HEAP32[(($97)>>2)]=$384;
      HEAP32[(($98)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($99)>>2)]=2065;
      var $404=HEAP32[(($97)>>2)];
      var $405=(($404)|0)!=0;
      if ($405) { __label__ = 56; break; } else { __label__ = 58; break; }
    case 56: // $406
      var $407=HEAP32[(($97)>>2)];
      var $408=HEAP32[(($98)>>2)];
      var $409=HEAP32[(($99)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($407, $408, $409) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 243; break; }
    case 57: // $_noexc11
      __label__ = 58; break;
    case 58: // $_ZdlPvPKci_exit12
      var $410=$97;
      var $411=$98;
      var $412=$99;
      __label__ = 59; break;
    case 59: // $413
      __label__ = 242; break;
    case 60: // $414
      var $415=$131;
      var $416=__ZNK20address_space_config10endiannessEv($415);
      var $417=(($416)|0)==0;
      if ($417) { __label__ = 61; break; } else { __label__ = 90; break; }
    case 61: // $418
      var $419=$large;
      var $420=(($419) & 1);
      if ($420) { __label__ = 62; break; } else { __label__ = 76; break; }
    case 62: // $421
      var $422=$130;
      var $423=__ZN15running_machine7respoolEv($422);
      var $424=$92;
      var $425=$93;
      var $426=$94;
      var $427=$result_i13;
      var $428=$95;
      var $429=$96;
      HEAP32[(($92)>>2)]=2820;
      HEAP32[(($93)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($94)>>2)]=2072;
      var $430=HEAP32[(($92)>>2)];
      var $431=HEAP32[(($93)>>2)];
      var $432=HEAP32[(($94)>>2)];
      var $433=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($430, $431, $432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; };
    case 63: // $434
      HEAP32[(($result_i13)>>2)]=$433;
      var $435=HEAP32[(($result_i13)>>2)];
      var $436=(($435)|0)==0;
      if ($436) { __label__ = 64; break; } else { __label__ = 69; break; }
    case 64: // $437
      var $438=___cxa_allocate_exception(4);
      var $439=$438;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($439);
      (function() { try { __THREW__ = false; return ___cxa_throw($438, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 65; break; }
    case 65: // $440
      var $441=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $442=$441.f0;
      HEAP32[(($95)>>2)]=$442;
      var $443=$441.f1;
      HEAP32[(($96)>>2)]=$443;
      var $444=HEAP32[(($96)>>2)];
      var $445=(($444)|0) < 0;
      if ($445) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $446
      var $447=HEAP32[(($95)>>2)];
      ___cxa_call_unexpected($447);
      throw "Reached an unreachable!"
    case 67: // $448
      var $449=HEAP32[(($95)>>2)];
      var $450=HEAP32[(($95)>>2)];
      var $451=HEAP32[(($96)>>2)];
      var $452=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $450, tempValue);
      var $453=($452.f1 = $451, $452);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $454
      throw "Reached an unreachable!"
    case 69: // $_ZnwjPKci_exit14
      var $455=HEAP32[(($result_i13)>>2)];
      var $456=$92;
      var $457=$93;
      var $458=$94;
      var $459=$result_i13;
      var $460=$95;
      var $461=$96;
      var $462=$455;
      var $463=$132;
      var $464=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($462, $463, $464) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $465
      var $466=__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb1EEEEPT_S5_($423, $462);
      var $467=$466;
      $129=$467;
      __label__ = 241; break;
    case 71: // $468
      var $469=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $470=$469.f0;
      $134=$470;
      var $471=$469.f1;
      $135=$471;
      var $472=$89;
      var $473=$90;
      var $474=$91;
      HEAP32[(($89)>>2)]=$455;
      HEAP32[(($90)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($91)>>2)]=2072;
      var $475=HEAP32[(($89)>>2)];
      var $476=(($475)|0)!=0;
      if ($476) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $477
      var $478=HEAP32[(($89)>>2)];
      var $479=HEAP32[(($90)>>2)];
      var $480=HEAP32[(($91)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($478, $479, $480) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 243; break; }
    case 73: // $_noexc15
      __label__ = 74; break;
    case 74: // $_ZdlPvPKci_exit16
      var $481=$89;
      var $482=$90;
      var $483=$91;
      __label__ = 75; break;
    case 75: // $484
      __label__ = 242; break;
    case 76: // $485
      var $486=$130;
      var $487=__ZN15running_machine7respoolEv($486);
      var $488=$84;
      var $489=$85;
      var $490=$86;
      var $491=$result_i17;
      var $492=$87;
      var $493=$88;
      HEAP32[(($84)>>2)]=2820;
      HEAP32[(($85)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($86)>>2)]=2074;
      var $494=HEAP32[(($84)>>2)];
      var $495=HEAP32[(($85)>>2)];
      var $496=HEAP32[(($86)>>2)];
      var $497=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($494, $495, $496) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 79; break; };
    case 77: // $498
      HEAP32[(($result_i17)>>2)]=$497;
      var $499=HEAP32[(($result_i17)>>2)];
      var $500=(($499)|0)==0;
      if ($500) { __label__ = 78; break; } else { __label__ = 83; break; }
    case 78: // $501
      var $502=___cxa_allocate_exception(4);
      var $503=$502;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($503);
      (function() { try { __THREW__ = false; return ___cxa_throw($502, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 79; break; }
    case 79: // $504
      var $505=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $506=$505.f0;
      HEAP32[(($87)>>2)]=$506;
      var $507=$505.f1;
      HEAP32[(($88)>>2)]=$507;
      var $508=HEAP32[(($88)>>2)];
      var $509=(($508)|0) < 0;
      if ($509) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $510
      var $511=HEAP32[(($87)>>2)];
      ___cxa_call_unexpected($511);
      throw "Reached an unreachable!"
    case 81: // $512
      var $513=HEAP32[(($87)>>2)];
      var $514=HEAP32[(($87)>>2)];
      var $515=HEAP32[(($88)>>2)];
      var $516=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $514, tempValue);
      var $517=($516.f1 = $515, $516);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 82: // $518
      throw "Reached an unreachable!"
    case 83: // $_ZnwjPKci_exit18
      var $519=HEAP32[(($result_i17)>>2)];
      var $520=$84;
      var $521=$85;
      var $522=$86;
      var $523=$result_i17;
      var $524=$87;
      var $525=$88;
      var $526=$519;
      var $527=$132;
      var $528=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($526, $527, $528) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $529
      var $530=__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb0EEEEPT_S5_($487, $526);
      var $531=$530;
      $129=$531;
      __label__ = 241; break;
    case 85: // $532
      var $533=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $534=$533.f0;
      $134=$534;
      var $535=$533.f1;
      $135=$535;
      var $536=$81;
      var $537=$82;
      var $538=$83;
      HEAP32[(($81)>>2)]=$519;
      HEAP32[(($82)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($83)>>2)]=2074;
      var $539=HEAP32[(($81)>>2)];
      var $540=(($539)|0)!=0;
      if ($540) { __label__ = 86; break; } else { __label__ = 88; break; }
    case 86: // $541
      var $542=HEAP32[(($81)>>2)];
      var $543=HEAP32[(($82)>>2)];
      var $544=HEAP32[(($83)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($542, $543, $544) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 243; break; }
    case 87: // $_noexc19
      __label__ = 88; break;
    case 88: // $_ZdlPvPKci_exit20
      var $545=$81;
      var $546=$82;
      var $547=$83;
      __label__ = 89; break;
    case 89: // $548
      __label__ = 242; break;
    case 90: // $549
      var $550=$large;
      var $551=(($550) & 1);
      if ($551) { __label__ = 91; break; } else { __label__ = 105; break; }
    case 91: // $552
      var $553=$130;
      var $554=__ZN15running_machine7respoolEv($553);
      var $555=$76;
      var $556=$77;
      var $557=$78;
      var $558=$result_i21;
      var $559=$79;
      var $560=$80;
      HEAP32[(($76)>>2)]=2820;
      HEAP32[(($77)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($78)>>2)]=2079;
      var $561=HEAP32[(($76)>>2)];
      var $562=HEAP32[(($77)>>2)];
      var $563=HEAP32[(($78)>>2)];
      var $564=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($561, $562, $563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 94; break; };
    case 92: // $565
      HEAP32[(($result_i21)>>2)]=$564;
      var $566=HEAP32[(($result_i21)>>2)];
      var $567=(($566)|0)==0;
      if ($567) { __label__ = 93; break; } else { __label__ = 98; break; }
    case 93: // $568
      var $569=___cxa_allocate_exception(4);
      var $570=$569;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($570);
      (function() { try { __THREW__ = false; return ___cxa_throw($569, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 94; break; }
    case 94: // $571
      var $572=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $573=$572.f0;
      HEAP32[(($79)>>2)]=$573;
      var $574=$572.f1;
      HEAP32[(($80)>>2)]=$574;
      var $575=HEAP32[(($80)>>2)];
      var $576=(($575)|0) < 0;
      if ($576) { __label__ = 95; break; } else { __label__ = 96; break; }
    case 95: // $577
      var $578=HEAP32[(($79)>>2)];
      ___cxa_call_unexpected($578);
      throw "Reached an unreachable!"
    case 96: // $579
      var $580=HEAP32[(($79)>>2)];
      var $581=HEAP32[(($79)>>2)];
      var $582=HEAP32[(($80)>>2)];
      var $583=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $581, tempValue);
      var $584=($583.f1 = $582, $583);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 97: // $585
      throw "Reached an unreachable!"
    case 98: // $_ZnwjPKci_exit22
      var $586=HEAP32[(($result_i21)>>2)];
      var $587=$76;
      var $588=$77;
      var $589=$78;
      var $590=$result_i21;
      var $591=$79;
      var $592=$80;
      var $593=$586;
      var $594=$132;
      var $595=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($593, $594, $595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 100; break; }
    case 99: // $596
      var $597=__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb1EEEEPT_S5_($554, $593);
      var $598=$597;
      $129=$598;
      __label__ = 241; break;
    case 100: // $599
      var $600=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $601=$600.f0;
      $134=$601;
      var $602=$600.f1;
      $135=$602;
      var $603=$73;
      var $604=$74;
      var $605=$75;
      HEAP32[(($73)>>2)]=$586;
      HEAP32[(($74)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($75)>>2)]=2079;
      var $606=HEAP32[(($73)>>2)];
      var $607=(($606)|0)!=0;
      if ($607) { __label__ = 101; break; } else { __label__ = 103; break; }
    case 101: // $608
      var $609=HEAP32[(($73)>>2)];
      var $610=HEAP32[(($74)>>2)];
      var $611=HEAP32[(($75)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($609, $610, $611) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 243; break; }
    case 102: // $_noexc23
      __label__ = 103; break;
    case 103: // $_ZdlPvPKci_exit24
      var $612=$73;
      var $613=$74;
      var $614=$75;
      __label__ = 104; break;
    case 104: // $615
      __label__ = 242; break;
    case 105: // $616
      var $617=$130;
      var $618=__ZN15running_machine7respoolEv($617);
      var $619=$68;
      var $620=$69;
      var $621=$70;
      var $622=$result_i25;
      var $623=$71;
      var $624=$72;
      HEAP32[(($68)>>2)]=2820;
      HEAP32[(($69)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($70)>>2)]=2081;
      var $625=HEAP32[(($68)>>2)];
      var $626=HEAP32[(($69)>>2)];
      var $627=HEAP32[(($70)>>2)];
      var $628=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($625, $626, $627) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 108; break; };
    case 106: // $629
      HEAP32[(($result_i25)>>2)]=$628;
      var $630=HEAP32[(($result_i25)>>2)];
      var $631=(($630)|0)==0;
      if ($631) { __label__ = 107; break; } else { __label__ = 112; break; }
    case 107: // $632
      var $633=___cxa_allocate_exception(4);
      var $634=$633;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($634);
      (function() { try { __THREW__ = false; return ___cxa_throw($633, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 108; break; }
    case 108: // $635
      var $636=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $637=$636.f0;
      HEAP32[(($71)>>2)]=$637;
      var $638=$636.f1;
      HEAP32[(($72)>>2)]=$638;
      var $639=HEAP32[(($72)>>2)];
      var $640=(($639)|0) < 0;
      if ($640) { __label__ = 109; break; } else { __label__ = 110; break; }
    case 109: // $641
      var $642=HEAP32[(($71)>>2)];
      ___cxa_call_unexpected($642);
      throw "Reached an unreachable!"
    case 110: // $643
      var $644=HEAP32[(($71)>>2)];
      var $645=HEAP32[(($71)>>2)];
      var $646=HEAP32[(($72)>>2)];
      var $647=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $645, tempValue);
      var $648=($647.f1 = $646, $647);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 111: // $649
      throw "Reached an unreachable!"
    case 112: // $_ZnwjPKci_exit26
      var $650=HEAP32[(($result_i25)>>2)];
      var $651=$68;
      var $652=$69;
      var $653=$70;
      var $654=$result_i25;
      var $655=$71;
      var $656=$72;
      var $657=$650;
      var $658=$132;
      var $659=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($657, $658, $659) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $660
      var $661=__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb0EEEEPT_S5_($618, $657);
      var $662=$661;
      $129=$662;
      __label__ = 241; break;
    case 114: // $663
      var $664=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $665=$664.f0;
      $134=$665;
      var $666=$664.f1;
      $135=$666;
      var $667=$65;
      var $668=$66;
      var $669=$67;
      HEAP32[(($65)>>2)]=$650;
      HEAP32[(($66)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($67)>>2)]=2081;
      var $670=HEAP32[(($65)>>2)];
      var $671=(($670)|0)!=0;
      if ($671) { __label__ = 115; break; } else { __label__ = 117; break; }
    case 115: // $672
      var $673=HEAP32[(($65)>>2)];
      var $674=HEAP32[(($66)>>2)];
      var $675=HEAP32[(($67)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($673, $674, $675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 243; break; }
    case 116: // $_noexc27
      __label__ = 117; break;
    case 117: // $_ZdlPvPKci_exit28
      var $676=$65;
      var $677=$66;
      var $678=$67;
      __label__ = 118; break;
    case 118: // $679
      __label__ = 242; break;
    case 119: // $680
      var $681=$131;
      var $682=__ZNK20address_space_config10endiannessEv($681);
      var $683=(($682)|0)==0;
      if ($683) { __label__ = 120; break; } else { __label__ = 149; break; }
    case 120: // $684
      var $685=$large;
      var $686=(($685) & 1);
      if ($686) { __label__ = 121; break; } else { __label__ = 135; break; }
    case 121: // $687
      var $688=$130;
      var $689=__ZN15running_machine7respoolEv($688);
      var $690=$60;
      var $691=$61;
      var $692=$62;
      var $693=$result_i29;
      var $694=$63;
      var $695=$64;
      HEAP32[(($60)>>2)]=2820;
      HEAP32[(($61)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($62)>>2)]=2088;
      var $696=HEAP32[(($60)>>2)];
      var $697=HEAP32[(($61)>>2)];
      var $698=HEAP32[(($62)>>2)];
      var $699=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($696, $697, $698) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 124; break; };
    case 122: // $700
      HEAP32[(($result_i29)>>2)]=$699;
      var $701=HEAP32[(($result_i29)>>2)];
      var $702=(($701)|0)==0;
      if ($702) { __label__ = 123; break; } else { __label__ = 128; break; }
    case 123: // $703
      var $704=___cxa_allocate_exception(4);
      var $705=$704;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($705);
      (function() { try { __THREW__ = false; return ___cxa_throw($704, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 124; break; }
    case 124: // $706
      var $707=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $708=$707.f0;
      HEAP32[(($63)>>2)]=$708;
      var $709=$707.f1;
      HEAP32[(($64)>>2)]=$709;
      var $710=HEAP32[(($64)>>2)];
      var $711=(($710)|0) < 0;
      if ($711) { __label__ = 125; break; } else { __label__ = 126; break; }
    case 125: // $712
      var $713=HEAP32[(($63)>>2)];
      ___cxa_call_unexpected($713);
      throw "Reached an unreachable!"
    case 126: // $714
      var $715=HEAP32[(($63)>>2)];
      var $716=HEAP32[(($63)>>2)];
      var $717=HEAP32[(($64)>>2)];
      var $718=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $716, tempValue);
      var $719=($718.f1 = $717, $718);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 127: // $720
      throw "Reached an unreachable!"
    case 128: // $_ZnwjPKci_exit30
      var $721=HEAP32[(($result_i29)>>2)];
      var $722=$60;
      var $723=$61;
      var $724=$62;
      var $725=$result_i29;
      var $726=$63;
      var $727=$64;
      var $728=$721;
      var $729=$132;
      var $730=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($728, $729, $730) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 129; break; } else { __label__ = 130; break; }
    case 129: // $731
      var $732=__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb1EEEEPT_S5_($689, $728);
      var $733=$732;
      $129=$733;
      __label__ = 241; break;
    case 130: // $734
      var $735=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $736=$735.f0;
      $134=$736;
      var $737=$735.f1;
      $135=$737;
      var $738=$57;
      var $739=$58;
      var $740=$59;
      HEAP32[(($57)>>2)]=$721;
      HEAP32[(($58)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($59)>>2)]=2088;
      var $741=HEAP32[(($57)>>2)];
      var $742=(($741)|0)!=0;
      if ($742) { __label__ = 131; break; } else { __label__ = 133; break; }
    case 131: // $743
      var $744=HEAP32[(($57)>>2)];
      var $745=HEAP32[(($58)>>2)];
      var $746=HEAP32[(($59)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($744, $745, $746) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 132; break; } else { __label__ = 243; break; }
    case 132: // $_noexc31
      __label__ = 133; break;
    case 133: // $_ZdlPvPKci_exit32
      var $747=$57;
      var $748=$58;
      var $749=$59;
      __label__ = 134; break;
    case 134: // $750
      __label__ = 242; break;
    case 135: // $751
      var $752=$130;
      var $753=__ZN15running_machine7respoolEv($752);
      var $754=$52;
      var $755=$53;
      var $756=$54;
      var $757=$result_i33;
      var $758=$55;
      var $759=$56;
      HEAP32[(($52)>>2)]=2820;
      HEAP32[(($53)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($54)>>2)]=2090;
      var $760=HEAP32[(($52)>>2)];
      var $761=HEAP32[(($53)>>2)];
      var $762=HEAP32[(($54)>>2)];
      var $763=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($760, $761, $762) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 138; break; };
    case 136: // $764
      HEAP32[(($result_i33)>>2)]=$763;
      var $765=HEAP32[(($result_i33)>>2)];
      var $766=(($765)|0)==0;
      if ($766) { __label__ = 137; break; } else { __label__ = 142; break; }
    case 137: // $767
      var $768=___cxa_allocate_exception(4);
      var $769=$768;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($769);
      (function() { try { __THREW__ = false; return ___cxa_throw($768, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 141; break; } else { __label__ = 138; break; }
    case 138: // $770
      var $771=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $772=$771.f0;
      HEAP32[(($55)>>2)]=$772;
      var $773=$771.f1;
      HEAP32[(($56)>>2)]=$773;
      var $774=HEAP32[(($56)>>2)];
      var $775=(($774)|0) < 0;
      if ($775) { __label__ = 139; break; } else { __label__ = 140; break; }
    case 139: // $776
      var $777=HEAP32[(($55)>>2)];
      ___cxa_call_unexpected($777);
      throw "Reached an unreachable!"
    case 140: // $778
      var $779=HEAP32[(($55)>>2)];
      var $780=HEAP32[(($55)>>2)];
      var $781=HEAP32[(($56)>>2)];
      var $782=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $780, tempValue);
      var $783=($782.f1 = $781, $782);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 141: // $784
      throw "Reached an unreachable!"
    case 142: // $_ZnwjPKci_exit34
      var $785=HEAP32[(($result_i33)>>2)];
      var $786=$52;
      var $787=$53;
      var $788=$54;
      var $789=$result_i33;
      var $790=$55;
      var $791=$56;
      var $792=$785;
      var $793=$132;
      var $794=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($792, $793, $794) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 143; break; } else { __label__ = 144; break; }
    case 143: // $795
      var $796=__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb0EEEEPT_S5_($753, $792);
      var $797=$796;
      $129=$797;
      __label__ = 241; break;
    case 144: // $798
      var $799=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $800=$799.f0;
      $134=$800;
      var $801=$799.f1;
      $135=$801;
      var $802=$49;
      var $803=$50;
      var $804=$51;
      HEAP32[(($49)>>2)]=$785;
      HEAP32[(($50)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($51)>>2)]=2090;
      var $805=HEAP32[(($49)>>2)];
      var $806=(($805)|0)!=0;
      if ($806) { __label__ = 145; break; } else { __label__ = 147; break; }
    case 145: // $807
      var $808=HEAP32[(($49)>>2)];
      var $809=HEAP32[(($50)>>2)];
      var $810=HEAP32[(($51)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($808, $809, $810) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 146; break; } else { __label__ = 243; break; }
    case 146: // $_noexc35
      __label__ = 147; break;
    case 147: // $_ZdlPvPKci_exit36
      var $811=$49;
      var $812=$50;
      var $813=$51;
      __label__ = 148; break;
    case 148: // $814
      __label__ = 242; break;
    case 149: // $815
      var $816=$large;
      var $817=(($816) & 1);
      if ($817) { __label__ = 150; break; } else { __label__ = 164; break; }
    case 150: // $818
      var $819=$130;
      var $820=__ZN15running_machine7respoolEv($819);
      var $821=$44;
      var $822=$45;
      var $823=$46;
      var $824=$result_i37;
      var $825=$47;
      var $826=$48;
      HEAP32[(($44)>>2)]=2820;
      HEAP32[(($45)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($46)>>2)]=2095;
      var $827=HEAP32[(($44)>>2)];
      var $828=HEAP32[(($45)>>2)];
      var $829=HEAP32[(($46)>>2)];
      var $830=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($827, $828, $829) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 151; break; } else { __label__ = 153; break; };
    case 151: // $831
      HEAP32[(($result_i37)>>2)]=$830;
      var $832=HEAP32[(($result_i37)>>2)];
      var $833=(($832)|0)==0;
      if ($833) { __label__ = 152; break; } else { __label__ = 157; break; }
    case 152: // $834
      var $835=___cxa_allocate_exception(4);
      var $836=$835;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($836);
      (function() { try { __THREW__ = false; return ___cxa_throw($835, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 153; break; }
    case 153: // $837
      var $838=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $839=$838.f0;
      HEAP32[(($47)>>2)]=$839;
      var $840=$838.f1;
      HEAP32[(($48)>>2)]=$840;
      var $841=HEAP32[(($48)>>2)];
      var $842=(($841)|0) < 0;
      if ($842) { __label__ = 154; break; } else { __label__ = 155; break; }
    case 154: // $843
      var $844=HEAP32[(($47)>>2)];
      ___cxa_call_unexpected($844);
      throw "Reached an unreachable!"
    case 155: // $845
      var $846=HEAP32[(($47)>>2)];
      var $847=HEAP32[(($47)>>2)];
      var $848=HEAP32[(($48)>>2)];
      var $849=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $847, tempValue);
      var $850=($849.f1 = $848, $849);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 156: // $851
      throw "Reached an unreachable!"
    case 157: // $_ZnwjPKci_exit38
      var $852=HEAP32[(($result_i37)>>2)];
      var $853=$44;
      var $854=$45;
      var $855=$46;
      var $856=$result_i37;
      var $857=$47;
      var $858=$48;
      var $859=$852;
      var $860=$132;
      var $861=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($859, $860, $861) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 158; break; } else { __label__ = 159; break; }
    case 158: // $862
      var $863=__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb1EEEEPT_S5_($820, $859);
      var $864=$863;
      $129=$864;
      __label__ = 241; break;
    case 159: // $865
      var $866=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $867=$866.f0;
      $134=$867;
      var $868=$866.f1;
      $135=$868;
      var $869=$41;
      var $870=$42;
      var $871=$43;
      HEAP32[(($41)>>2)]=$852;
      HEAP32[(($42)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($43)>>2)]=2095;
      var $872=HEAP32[(($41)>>2)];
      var $873=(($872)|0)!=0;
      if ($873) { __label__ = 160; break; } else { __label__ = 162; break; }
    case 160: // $874
      var $875=HEAP32[(($41)>>2)];
      var $876=HEAP32[(($42)>>2)];
      var $877=HEAP32[(($43)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($875, $876, $877) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 161; break; } else { __label__ = 243; break; }
    case 161: // $_noexc39
      __label__ = 162; break;
    case 162: // $_ZdlPvPKci_exit40
      var $878=$41;
      var $879=$42;
      var $880=$43;
      __label__ = 163; break;
    case 163: // $881
      __label__ = 242; break;
    case 164: // $882
      var $883=$130;
      var $884=__ZN15running_machine7respoolEv($883);
      var $885=$36;
      var $886=$37;
      var $887=$38;
      var $888=$result_i41;
      var $889=$39;
      var $890=$40;
      HEAP32[(($36)>>2)]=2820;
      HEAP32[(($37)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($38)>>2)]=2097;
      var $891=HEAP32[(($36)>>2)];
      var $892=HEAP32[(($37)>>2)];
      var $893=HEAP32[(($38)>>2)];
      var $894=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($891, $892, $893) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 165; break; } else { __label__ = 167; break; };
    case 165: // $895
      HEAP32[(($result_i41)>>2)]=$894;
      var $896=HEAP32[(($result_i41)>>2)];
      var $897=(($896)|0)==0;
      if ($897) { __label__ = 166; break; } else { __label__ = 171; break; }
    case 166: // $898
      var $899=___cxa_allocate_exception(4);
      var $900=$899;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($900);
      (function() { try { __THREW__ = false; return ___cxa_throw($899, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 170; break; } else { __label__ = 167; break; }
    case 167: // $901
      var $902=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $903=$902.f0;
      HEAP32[(($39)>>2)]=$903;
      var $904=$902.f1;
      HEAP32[(($40)>>2)]=$904;
      var $905=HEAP32[(($40)>>2)];
      var $906=(($905)|0) < 0;
      if ($906) { __label__ = 168; break; } else { __label__ = 169; break; }
    case 168: // $907
      var $908=HEAP32[(($39)>>2)];
      ___cxa_call_unexpected($908);
      throw "Reached an unreachable!"
    case 169: // $909
      var $910=HEAP32[(($39)>>2)];
      var $911=HEAP32[(($39)>>2)];
      var $912=HEAP32[(($40)>>2)];
      var $913=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $911, tempValue);
      var $914=($913.f1 = $912, $913);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 170: // $915
      throw "Reached an unreachable!"
    case 171: // $_ZnwjPKci_exit42
      var $916=HEAP32[(($result_i41)>>2)];
      var $917=$36;
      var $918=$37;
      var $919=$38;
      var $920=$result_i41;
      var $921=$39;
      var $922=$40;
      var $923=$916;
      var $924=$132;
      var $925=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($923, $924, $925) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 172; break; } else { __label__ = 173; break; }
    case 172: // $926
      var $927=__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb0EEEEPT_S5_($884, $923);
      var $928=$927;
      $129=$928;
      __label__ = 241; break;
    case 173: // $929
      var $930=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $931=$930.f0;
      $134=$931;
      var $932=$930.f1;
      $135=$932;
      var $933=$33;
      var $934=$34;
      var $935=$35;
      HEAP32[(($33)>>2)]=$916;
      HEAP32[(($34)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($35)>>2)]=2097;
      var $936=HEAP32[(($33)>>2)];
      var $937=(($936)|0)!=0;
      if ($937) { __label__ = 174; break; } else { __label__ = 176; break; }
    case 174: // $938
      var $939=HEAP32[(($33)>>2)];
      var $940=HEAP32[(($34)>>2)];
      var $941=HEAP32[(($35)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($939, $940, $941) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 175; break; } else { __label__ = 243; break; }
    case 175: // $_noexc43
      __label__ = 176; break;
    case 176: // $_ZdlPvPKci_exit44
      var $942=$33;
      var $943=$34;
      var $944=$35;
      __label__ = 177; break;
    case 177: // $945
      __label__ = 242; break;
    case 178: // $946
      var $947=$131;
      var $948=__ZNK20address_space_config10endiannessEv($947);
      var $949=(($948)|0)==0;
      if ($949) { __label__ = 179; break; } else { __label__ = 208; break; }
    case 179: // $950
      var $951=$large;
      var $952=(($951) & 1);
      if ($952) { __label__ = 180; break; } else { __label__ = 194; break; }
    case 180: // $953
      var $954=$130;
      var $955=__ZN15running_machine7respoolEv($954);
      var $956=$28;
      var $957=$29;
      var $958=$30;
      var $959=$result_i45;
      var $960=$31;
      var $961=$32;
      HEAP32[(($28)>>2)]=2820;
      HEAP32[(($29)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($30)>>2)]=2104;
      var $962=HEAP32[(($28)>>2)];
      var $963=HEAP32[(($29)>>2)];
      var $964=HEAP32[(($30)>>2)];
      var $965=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($962, $963, $964) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 181; break; } else { __label__ = 183; break; };
    case 181: // $966
      HEAP32[(($result_i45)>>2)]=$965;
      var $967=HEAP32[(($result_i45)>>2)];
      var $968=(($967)|0)==0;
      if ($968) { __label__ = 182; break; } else { __label__ = 187; break; }
    case 182: // $969
      var $970=___cxa_allocate_exception(4);
      var $971=$970;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($971);
      (function() { try { __THREW__ = false; return ___cxa_throw($970, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 186; break; } else { __label__ = 183; break; }
    case 183: // $972
      var $973=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $974=$973.f0;
      HEAP32[(($31)>>2)]=$974;
      var $975=$973.f1;
      HEAP32[(($32)>>2)]=$975;
      var $976=HEAP32[(($32)>>2)];
      var $977=(($976)|0) < 0;
      if ($977) { __label__ = 184; break; } else { __label__ = 185; break; }
    case 184: // $978
      var $979=HEAP32[(($31)>>2)];
      ___cxa_call_unexpected($979);
      throw "Reached an unreachable!"
    case 185: // $980
      var $981=HEAP32[(($31)>>2)];
      var $982=HEAP32[(($31)>>2)];
      var $983=HEAP32[(($32)>>2)];
      var $984=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $982, tempValue);
      var $985=($984.f1 = $983, $984);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 186: // $986
      throw "Reached an unreachable!"
    case 187: // $_ZnwjPKci_exit46
      var $987=HEAP32[(($result_i45)>>2)];
      var $988=$28;
      var $989=$29;
      var $990=$30;
      var $991=$result_i45;
      var $992=$31;
      var $993=$32;
      var $994=$987;
      var $995=$132;
      var $996=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($994, $995, $996) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 188; break; } else { __label__ = 189; break; }
    case 188: // $997
      var $998=__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb1EEEEPT_S5_($955, $994);
      var $999=$998;
      $129=$999;
      __label__ = 241; break;
    case 189: // $1000
      var $1001=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1002=$1001.f0;
      $134=$1002;
      var $1003=$1001.f1;
      $135=$1003;
      var $1004=$25;
      var $1005=$26;
      var $1006=$27;
      HEAP32[(($25)>>2)]=$987;
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($27)>>2)]=2104;
      var $1007=HEAP32[(($25)>>2)];
      var $1008=(($1007)|0)!=0;
      if ($1008) { __label__ = 190; break; } else { __label__ = 192; break; }
    case 190: // $1009
      var $1010=HEAP32[(($25)>>2)];
      var $1011=HEAP32[(($26)>>2)];
      var $1012=HEAP32[(($27)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($1010, $1011, $1012) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 191; break; } else { __label__ = 243; break; }
    case 191: // $_noexc47
      __label__ = 192; break;
    case 192: // $_ZdlPvPKci_exit48
      var $1013=$25;
      var $1014=$26;
      var $1015=$27;
      __label__ = 193; break;
    case 193: // $1016
      __label__ = 242; break;
    case 194: // $1017
      var $1018=$130;
      var $1019=__ZN15running_machine7respoolEv($1018);
      var $1020=$20;
      var $1021=$21;
      var $1022=$22;
      var $1023=$result_i49;
      var $1024=$23;
      var $1025=$24;
      HEAP32[(($20)>>2)]=2820;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($22)>>2)]=2106;
      var $1026=HEAP32[(($20)>>2)];
      var $1027=HEAP32[(($21)>>2)];
      var $1028=HEAP32[(($22)>>2)];
      var $1029=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($1026, $1027, $1028) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 195; break; } else { __label__ = 197; break; };
    case 195: // $1030
      HEAP32[(($result_i49)>>2)]=$1029;
      var $1031=HEAP32[(($result_i49)>>2)];
      var $1032=(($1031)|0)==0;
      if ($1032) { __label__ = 196; break; } else { __label__ = 201; break; }
    case 196: // $1033
      var $1034=___cxa_allocate_exception(4);
      var $1035=$1034;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1035);
      (function() { try { __THREW__ = false; return ___cxa_throw($1034, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 200; break; } else { __label__ = 197; break; }
    case 197: // $1036
      var $1037=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1038=$1037.f0;
      HEAP32[(($23)>>2)]=$1038;
      var $1039=$1037.f1;
      HEAP32[(($24)>>2)]=$1039;
      var $1040=HEAP32[(($24)>>2)];
      var $1041=(($1040)|0) < 0;
      if ($1041) { __label__ = 198; break; } else { __label__ = 199; break; }
    case 198: // $1042
      var $1043=HEAP32[(($23)>>2)];
      ___cxa_call_unexpected($1043);
      throw "Reached an unreachable!"
    case 199: // $1044
      var $1045=HEAP32[(($23)>>2)];
      var $1046=HEAP32[(($23)>>2)];
      var $1047=HEAP32[(($24)>>2)];
      var $1048=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1046, tempValue);
      var $1049=($1048.f1 = $1047, $1048);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 200: // $1050
      throw "Reached an unreachable!"
    case 201: // $_ZnwjPKci_exit50
      var $1051=HEAP32[(($result_i49)>>2)];
      var $1052=$20;
      var $1053=$21;
      var $1054=$22;
      var $1055=$result_i49;
      var $1056=$23;
      var $1057=$24;
      var $1058=$1051;
      var $1059=$132;
      var $1060=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($1058, $1059, $1060) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 202; break; } else { __label__ = 203; break; }
    case 202: // $1061
      var $1062=__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb0EEEEPT_S5_($1019, $1058);
      var $1063=$1062;
      $129=$1063;
      __label__ = 241; break;
    case 203: // $1064
      var $1065=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1066=$1065.f0;
      $134=$1066;
      var $1067=$1065.f1;
      $135=$1067;
      var $1068=$17;
      var $1069=$18;
      var $1070=$19;
      HEAP32[(($17)>>2)]=$1051;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($19)>>2)]=2106;
      var $1071=HEAP32[(($17)>>2)];
      var $1072=(($1071)|0)!=0;
      if ($1072) { __label__ = 204; break; } else { __label__ = 206; break; }
    case 204: // $1073
      var $1074=HEAP32[(($17)>>2)];
      var $1075=HEAP32[(($18)>>2)];
      var $1076=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($1074, $1075, $1076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 205; break; } else { __label__ = 243; break; }
    case 205: // $_noexc51
      __label__ = 206; break;
    case 206: // $_ZdlPvPKci_exit52
      var $1077=$17;
      var $1078=$18;
      var $1079=$19;
      __label__ = 207; break;
    case 207: // $1080
      __label__ = 242; break;
    case 208: // $1081
      var $1082=$large;
      var $1083=(($1082) & 1);
      if ($1083) { __label__ = 209; break; } else { __label__ = 223; break; }
    case 209: // $1084
      var $1085=$130;
      var $1086=__ZN15running_machine7respoolEv($1085);
      var $1087=$12;
      var $1088=$13;
      var $1089=$14;
      var $1090=$result_i53;
      var $1091=$15;
      var $1092=$16;
      HEAP32[(($12)>>2)]=2820;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($14)>>2)]=2111;
      var $1093=HEAP32[(($12)>>2)];
      var $1094=HEAP32[(($13)>>2)];
      var $1095=HEAP32[(($14)>>2)];
      var $1096=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($1093, $1094, $1095) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 210; break; } else { __label__ = 212; break; };
    case 210: // $1097
      HEAP32[(($result_i53)>>2)]=$1096;
      var $1098=HEAP32[(($result_i53)>>2)];
      var $1099=(($1098)|0)==0;
      if ($1099) { __label__ = 211; break; } else { __label__ = 216; break; }
    case 211: // $1100
      var $1101=___cxa_allocate_exception(4);
      var $1102=$1101;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1102);
      (function() { try { __THREW__ = false; return ___cxa_throw($1101, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 215; break; } else { __label__ = 212; break; }
    case 212: // $1103
      var $1104=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1105=$1104.f0;
      HEAP32[(($15)>>2)]=$1105;
      var $1106=$1104.f1;
      HEAP32[(($16)>>2)]=$1106;
      var $1107=HEAP32[(($16)>>2)];
      var $1108=(($1107)|0) < 0;
      if ($1108) { __label__ = 213; break; } else { __label__ = 214; break; }
    case 213: // $1109
      var $1110=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($1110);
      throw "Reached an unreachable!"
    case 214: // $1111
      var $1112=HEAP32[(($15)>>2)];
      var $1113=HEAP32[(($15)>>2)];
      var $1114=HEAP32[(($16)>>2)];
      var $1115=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1113, tempValue);
      var $1116=($1115.f1 = $1114, $1115);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 215: // $1117
      throw "Reached an unreachable!"
    case 216: // $_ZnwjPKci_exit54
      var $1118=HEAP32[(($result_i53)>>2)];
      var $1119=$12;
      var $1120=$13;
      var $1121=$14;
      var $1122=$result_i53;
      var $1123=$15;
      var $1124=$16;
      var $1125=$1118;
      var $1126=$132;
      var $1127=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($1125, $1126, $1127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 217; break; } else { __label__ = 218; break; }
    case 217: // $1128
      var $1129=__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb1EEEEPT_S5_($1086, $1125);
      var $1130=$1129;
      $129=$1130;
      __label__ = 241; break;
    case 218: // $1131
      var $1132=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1133=$1132.f0;
      $134=$1133;
      var $1134=$1132.f1;
      $135=$1134;
      var $1135=$9;
      var $1136=$10;
      var $1137=$11;
      HEAP32[(($9)>>2)]=$1118;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($11)>>2)]=2111;
      var $1138=HEAP32[(($9)>>2)];
      var $1139=(($1138)|0)!=0;
      if ($1139) { __label__ = 219; break; } else { __label__ = 221; break; }
    case 219: // $1140
      var $1141=HEAP32[(($9)>>2)];
      var $1142=HEAP32[(($10)>>2)];
      var $1143=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($1141, $1142, $1143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 220; break; } else { __label__ = 243; break; }
    case 220: // $_noexc55
      __label__ = 221; break;
    case 221: // $_ZdlPvPKci_exit56
      var $1144=$9;
      var $1145=$10;
      var $1146=$11;
      __label__ = 222; break;
    case 222: // $1147
      __label__ = 242; break;
    case 223: // $1148
      var $1149=$130;
      var $1150=__ZN15running_machine7respoolEv($1149);
      var $1151=$4;
      var $1152=$5;
      var $1153=$6;
      var $1154=$result_i57;
      var $1155=$7;
      var $1156=$8;
      HEAP32[(($4)>>2)]=2820;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=2113;
      var $1157=HEAP32[(($4)>>2)];
      var $1158=HEAP32[(($5)>>2)];
      var $1159=HEAP32[(($6)>>2)];
      var $1160=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($1157, $1158, $1159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 224; break; } else { __label__ = 226; break; };
    case 224: // $1161
      HEAP32[(($result_i57)>>2)]=$1160;
      var $1162=HEAP32[(($result_i57)>>2)];
      var $1163=(($1162)|0)==0;
      if ($1163) { __label__ = 225; break; } else { __label__ = 230; break; }
    case 225: // $1164
      var $1165=___cxa_allocate_exception(4);
      var $1166=$1165;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($1166);
      (function() { try { __THREW__ = false; return ___cxa_throw($1165, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 229; break; } else { __label__ = 226; break; }
    case 226: // $1167
      var $1168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1169=$1168.f0;
      HEAP32[(($7)>>2)]=$1169;
      var $1170=$1168.f1;
      HEAP32[(($8)>>2)]=$1170;
      var $1171=HEAP32[(($8)>>2)];
      var $1172=(($1171)|0) < 0;
      if ($1172) { __label__ = 227; break; } else { __label__ = 228; break; }
    case 227: // $1173
      var $1174=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($1174);
      throw "Reached an unreachable!"
    case 228: // $1175
      var $1176=HEAP32[(($7)>>2)];
      var $1177=HEAP32[(($7)>>2)];
      var $1178=HEAP32[(($8)>>2)];
      var $1179=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1177, tempValue);
      var $1180=($1179.f1 = $1178, $1179);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 229: // $1181
      throw "Reached an unreachable!"
    case 230: // $_ZnwjPKci_exit58
      var $1182=HEAP32[(($result_i57)>>2)];
      var $1183=$4;
      var $1184=$5;
      var $1185=$6;
      var $1186=$result_i57;
      var $1187=$7;
      var $1188=$8;
      var $1189=$1182;
      var $1190=$132;
      var $1191=$133;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($1189, $1190, $1191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 231; break; } else { __label__ = 232; break; }
    case 231: // $1192
      var $1193=__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb0EEEEPT_S5_($1150, $1189);
      var $1194=$1193;
      $129=$1194;
      __label__ = 241; break;
    case 232: // $1195
      var $1196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1197=$1196.f0;
      $134=$1197;
      var $1198=$1196.f1;
      $135=$1198;
      var $1199=$1;
      var $1200=$2;
      var $1201=$3;
      HEAP32[(($1)>>2)]=$1182;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=2113;
      var $1202=HEAP32[(($1)>>2)];
      var $1203=(($1202)|0)!=0;
      if ($1203) { __label__ = 233; break; } else { __label__ = 235; break; }
    case 233: // $1204
      var $1205=HEAP32[(($1)>>2)];
      var $1206=HEAP32[(($2)>>2)];
      var $1207=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($1205, $1206, $1207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 234; break; } else { __label__ = 243; break; }
    case 234: // $_noexc59
      __label__ = 235; break;
    case 235: // $_ZdlPvPKci_exit60
      var $1208=$1;
      var $1209=$2;
      var $1210=$3;
      __label__ = 236; break;
    case 236: // $1211
      __label__ = 242; break;
    case 237: // $1212
      var $1213=___cxa_allocate_exception(1032);
      var $1214=$1213;
      var $1215=$131;
      var $1216=(function() { try { __THREW__ = false; return __ZNK20address_space_config10data_widthEv($1215) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 238; break; } else { __label__ = 240; break; };
    case 238: // $1217
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($1214, ((STRING_TABLE.__str112902)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1216,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 239; break; } else { __label__ = 240; break; }
    case 239: // $1218
      ___cxa_throw($1213, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 240: // $1219
      var $1220=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1221=$1220.f0;
      $134=$1221;
      var $1222=$1220.f1;
      $135=$1222;
      ___cxa_free_exception($1213);
      __label__ = 242; break;
    case 241: // $1223
      var $1224=$129;
      STACKTOP = __stackBase__;
      return $1224;
    case 242: // $1225
      var $1226=$134;
      var $1227=$134;
      var $1228=$135;
      var $1229=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1227, tempValue);
      var $1230=($1229.f1 = $1228, $1229);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 243: // $1231
      var $1232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space8allocateER15running_machineRK20address_space_configR23device_memory_interface16address_spacenum["X"]=1;

function __ZNK11simple_listI13address_spaceE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13address_space4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16device_interface4nextI23device_memory_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI23device_memory_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZN13address_space17populate_from_mapEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $last_entry;
      var $entry;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 9; break;
    case 2: // $7
      $last_entry=0;
      __label__ = 3; break;
    case 3: // $8
      var $9=$last_entry;
      var $10=(($2+16)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+12)|0);
      var $13=__ZNK11simple_listI17address_map_entryE5firstEv($12);
      var $14=(($9)|0)!=(($13)|0);
      if ($14) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $15
      var $16=(($2+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+12)|0);
      var $19=__ZNK11simple_listI17address_map_entryE5firstEv($18);
      $entry=$19;
      __label__ = 5; break;
    case 5: // $20
      var $21=$entry;
      var $22=__ZNK17address_map_entry4nextEv($21);
      var $23=$last_entry;
      var $24=(($22)|0)!=(($23)|0);
      if ($24) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$entry;
      var $28=__ZNK17address_map_entry4nextEv($27);
      $entry=$28;
      __label__ = 5; break;
    case 8: // $29
      var $30=$entry;
      $last_entry=$30;
      var $31=$entry;
      __ZN13address_space18populate_map_entryERK17address_map_entry13read_or_write($2, $31, 1);
      var $32=$entry;
      __ZN13address_space18populate_map_entryERK17address_map_entry13read_or_write($2, $32, 2);
      __label__ = 3; break;
    case 9: // $33
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_space11prepare_mapEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $devregion;
      var $devregionsize;
      var $18;
      var $19;
      var $entry;
      var $share;
      var $regiontag=__stackBase__+72;
      var $region;
      var $regiontag1=__stackBase__+136;
      $17=$this;
      var $20=$17;
      var $21=(($20+44)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      var $25=__ZNK13address_space7machineEv($20);
      var $26=(($20+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__ZNK8device_t3tagEv($27);
      var $29=__ZN15running_machine6regionEPKc($25, $28);
      var $32 = $29;__label__ = 3; break;
    case 2: // $30
      var $32 = 0;__label__ = 3; break;
    case 3: // $31
      var $32;
      $devregion=$32;
      var $33=$devregion;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$devregion;
      var $37=__ZNK13memory_region5bytesEv($36);
      var $40 = $37;__label__ = 6; break;
    case 5: // $38
      var $40 = 0;__label__ = 6; break;
    case 6: // $39
      var $40;
      $devregionsize=$40;
      var $41=$12;
      var $42=$13;
      var $43=$14;
      var $44=$result_i;
      var $45=$15;
      var $46=$16;
      HEAP32[(($12)>>2)]=32;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($14)>>2)]=2155;
      var $47=HEAP32[(($12)>>2)];
      var $48=HEAP32[(($13)>>2)];
      var $49=HEAP32[(($14)>>2)];
      var $50=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($47, $48, $49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $51
      HEAP32[(($result_i)>>2)]=$50;
      var $52=HEAP32[(($result_i)>>2)];
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $54
      var $55=___cxa_allocate_exception(4);
      var $56=$55;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($56);
      (function() { try { __THREW__ = false; return ___cxa_throw($55, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      HEAP32[(($15)>>2)]=$59;
      var $60=$58.f1;
      HEAP32[(($16)>>2)]=$60;
      var $61=HEAP32[(($16)>>2)];
      var $62=(($61)|0) < 0;
      if ($62) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $63
      var $64=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($64);
      throw "Reached an unreachable!"
    case 11: // $65
      var $66=HEAP32[(($15)>>2)];
      var $67=HEAP32[(($15)>>2)];
      var $68=HEAP32[(($16)>>2)];
      var $69=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $67, tempValue);
      var $70=($69.f1 = $68, $69);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $71
      throw "Reached an unreachable!"
    case 13: // $_ZnwjPKci_exit
      var $72=HEAPU32[(($result_i)>>2)];
      var $73=$12;
      var $74=$13;
      var $75=$14;
      var $76=$result_i;
      var $77=$15;
      var $78=$16;
      var $79=$72;
      var $80=(($20+12)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($20+44)|0);
      var $83=HEAP32[(($82)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11address_mapC1ERK8device_t16address_spacenum]($79, $81, $83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $84
      var $85=__ZN13resource_pool10add_objectI11address_mapEEPT_S3_(_global_resource_pool, $79);
      var $86=(($20+16)|0);
      HEAP32[(($86)>>2)]=$85;
      var $87=(($20+16)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+5)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $92=(($91)|0)==0;
      var $93=$92 ? 0 : -1;
      var $94$0=$93;
      var $94$1=(($93|0) < 0 ? -1 : 0);
      var $95=(($20+36)|0);
      var $st$13$0=(($95)|0);
      HEAP32[(($st$13$0)>>2)]=$94$0;
      var $st$13$1=(($95+4)|0);
      HEAP32[(($st$13$1)>>2)]=$94$1;
      var $96=(($20+16)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+8)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $101
      var $102=(($20+16)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+8)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($20+20)|0);
      HEAP32[(($106)>>2)]=$105;
      var $107=(($20+20)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=__ZNK13address_space19address_to_byte_endEj($20, $108);
      var $110=(($20+24)|0);
      HEAP32[(($110)>>2)]=$109;
      __label__ = 21; break;
    case 16: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $18=$113;
      var $114=$112.f1;
      $19=$114;
      var $115=$9;
      var $116=$10;
      var $117=$11;
      HEAP32[(($9)>>2)]=$72;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($11)>>2)]=2155;
      var $118=HEAP32[(($9)>>2)];
      var $119=(($118)|0)!=0;
      if ($119) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $120
      var $121=HEAP32[(($9)>>2)];
      var $122=HEAP32[(($10)>>2)];
      var $123=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($121, $122, $123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 90; break; }
    case 18: // $_noexc
      __label__ = 19; break;
    case 19: // $_ZdlPvPKci_exit
      var $124=$9;
      var $125=$10;
      var $126=$11;
      __label__ = 20; break;
    case 20: // $127
      __label__ = 89; break;
    case 21: // $128
      var $129=(($20+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+12)|0);
      var $132=__ZNK11simple_listI17address_map_entryE5firstEv($131);
      $entry=$132;
      __label__ = 22; break;
    case 22: // $133
      var $134=$entry;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 23; break; } else { __label__ = 88; break; }
    case 23: // $136
      var $137=$entry;
      var $138=(($137+72)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=$entry;
      var $141=(($140+560)|0);
      HEAP32[(($141)>>2)]=$139;
      var $142=$entry;
      var $143=(($142+76)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$entry;
      var $146=(($145+564)|0);
      HEAP32[(($146)>>2)]=$144;
      var $147=$entry;
      var $148=(($147+80)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$entry;
      var $151=(($150+568)|0);
      HEAP32[(($151)>>2)]=$149;
      var $152=$entry;
      var $153=(($152+84)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$entry;
      var $156=(($155+572)|0);
      HEAP32[(($156)>>2)]=$154;
      var $157=$entry;
      var $158=(($157+560)|0);
      var $159=$entry;
      var $160=(($159+564)|0);
      var $161=$entry;
      var $162=(($161+572)|0);
      var $163=$entry;
      var $164=(($163+568)|0);
      __ZN13address_space16adjust_addressesERjS0_S0_S0_($20, $158, $160, $162, $164);
      var $165=$entry;
      var $166=(($165+264)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 24; break; } else { __label__ = 41; break; }
    case 24: // $169
      var $170=__ZNK13address_space7machineEv($20);
      var $171=(($170+624)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172+1480)|0);
      var $174=$entry;
      var $175=(($174+264)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=__ZNK8tagmap_tIP12memory_shareE4findEPKc($173, $176);
      var $178=(($177)|0)==0;
      if ($178) { __label__ = 25; break; } else { __label__ = 41; break; }
    case 25: // $179
      __label__ = 26; break;
    case 26: // $180
      __label__ = 27; break;
    case 27: // $181
      var $182=__ZNK13address_space7machineEv($20);
      var $183=__ZN15running_machine7respoolEv($182);
      var $184=$4;
      var $185=$5;
      var $186=$6;
      var $187=$result_i2;
      var $188=$7;
      var $189=$8;
      HEAP32[(($4)>>2)]=8;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=2179;
      var $190=HEAP32[(($4)>>2)];
      var $191=HEAP32[(($5)>>2)];
      var $192=HEAP32[(($6)>>2)];
      var $193=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($190, $191, $192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; };
    case 28: // $194
      HEAP32[(($result_i2)>>2)]=$193;
      var $195=HEAP32[(($result_i2)>>2)];
      var $196=(($195)|0)==0;
      if ($196) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $197
      var $198=___cxa_allocate_exception(4);
      var $199=$198;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($199);
      (function() { try { __THREW__ = false; return ___cxa_throw($198, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 30; break; }
    case 30: // $200
      var $201=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $202=$201.f0;
      HEAP32[(($7)>>2)]=$202;
      var $203=$201.f1;
      HEAP32[(($8)>>2)]=$203;
      var $204=HEAP32[(($8)>>2)];
      var $205=(($204)|0) < 0;
      if ($205) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $206
      var $207=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($207);
      throw "Reached an unreachable!"
    case 32: // $208
      var $209=HEAP32[(($7)>>2)];
      var $210=HEAP32[(($7)>>2)];
      var $211=HEAP32[(($8)>>2)];
      var $212=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $210, tempValue);
      var $213=($212.f1 = $211, $212);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $214
      throw "Reached an unreachable!"
    case 34: // $_ZnwjPKci_exit3
      var $215=HEAP32[(($result_i2)>>2)];
      var $216=$4;
      var $217=$5;
      var $218=$6;
      var $219=$result_i2;
      var $220=$7;
      var $221=$8;
      var $222=$215;
      var $223=$entry;
      var $224=(($223+564)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=(($225+1)|0);
      var $227=$entry;
      var $228=(($227+560)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=(($226-$229)|0);
      (function() { try { __THREW__ = false; return __ZN12memory_shareC1EjPv($222, $230, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $231
      var $232=__ZN13resource_pool10add_objectI12memory_shareEEPT_S3_($183, $222);
      $share=$232;
      var $233=__ZNK13address_space7machineEv($20);
      var $234=(($233+624)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($235+1480)|0);
      var $237=$entry;
      var $238=(($237+264)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$share;
      var $241=__ZN8tagmap_tIP12memory_shareE3addEPKcS1_b($236, $239, $240, 0);
      __label__ = 41; break;
    case 36: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $244=$243.f0;
      $18=$244;
      var $245=$243.f1;
      $19=$245;
      var $246=$1;
      var $247=$2;
      var $248=$3;
      HEAP32[(($1)>>2)]=$215;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=2179;
      var $249=HEAP32[(($1)>>2)];
      var $250=(($249)|0)!=0;
      if ($250) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $251
      var $252=HEAP32[(($1)>>2)];
      var $253=HEAP32[(($2)>>2)];
      var $254=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($252, $253, $254) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 90; break; }
    case 38: // $_noexc4
      __label__ = 39; break;
    case 39: // $_ZdlPvPKci_exit5
      var $255=$1;
      var $256=$2;
      var $257=$3;
      __label__ = 40; break;
    case 40: // $258
      __label__ = 89; break;
    case 41: // $259
      var $260=(($20+44)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=(($261)|0)==0;
      if ($262) { __label__ = 42; break; } else { __label__ = 47; break; }
    case 42: // $263
      var $264=$entry;
      var $265=(($264+88)|0);
      var $266=(($265)|0);
      var $267=HEAP32[(($266)>>2)];
      var $268=(($267)|0)==2;
      if ($268) { __label__ = 43; break; } else { __label__ = 47; break; }
    case 43: // $269
      var $270=$entry;
      var $271=(($270+292)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($272)|0)==0;
      if ($273) { __label__ = 44; break; } else { __label__ = 47; break; }
    case 44: // $274
      var $275=$entry;
      var $276=(($275+564)|0);
      var $277=HEAPU32[(($276)>>2)];
      var $278=$devregionsize;
      var $279=(($277)>>>0) < (($278)>>>0);
      if ($279) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $280
      var $281=(($20+12)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=__ZNK8device_t3tagEv($282);
      var $284=$entry;
      var $285=(($284+292)|0);
      HEAP32[(($285)>>2)]=$283;
      var $286=$entry;
      var $287=(($286+560)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=$entry;
      var $290=(($289+296)|0);
      HEAP32[(($290)>>2)]=$288;
      __label__ = 46; break;
    case 46: // $291
      __label__ = 47; break;
    case 47: // $292
      var $293=$entry;
      var $294=(($293+292)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=(($295)|0)!=0;
      if ($296) { __label__ = 48; break; } else { __label__ = 72; break; }
    case 48: // $297
      var $298=$entry;
      var $299=(($298+264)|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=(($300)|0)==0;
      if ($301) { __label__ = 49; break; } else { __label__ = 72; break; }
    case 49: // $302
      var $303=$entry;
      var $304=(($303+268)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=(($305)|0)==0;
      if ($306) { __label__ = 50; break; } else { __label__ = 72; break; }
    case 50: // $307
      __ZN7astringC1Ev($regiontag);
      var $308=$entry;
      var $309=(($308+292)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=(function() { try { __THREW__ = false; return _strchr($310, 58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 54; break; };
    case 51: // $312
      var $313=(($311)|0)!=0;
      if ($313) { __label__ = 52; break; } else { __label__ = 55; break; }
    case 52: // $314
      var $315=$entry;
      var $316=(($315+292)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($regiontag, $317) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 54; break; };
    case 53: // $319
      __label__ = 57; break;
    case 54: // $320
      var $321=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $322=$321.f0;
      $18=$322;
      var $323=$321.f1;
      $19=$323;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 90; break; }
    case 55: // $324
      var $325=(($20+12)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=$entry;
      var $328=(($327+292)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=(function() { try { __THREW__ = false; return __ZNK8device_t10siblingtagER7astringPKc($326, $regiontag, $329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 54; break; };
    case 56: // $331
      __label__ = 57; break;
    case 57: // $332
      var $333=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 54; break; };
    case 58: // $334
      var $335=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 54; break; };
    case 59: // $336
      var $337=(function() { try { __THREW__ = false; return __ZN15running_machine6regionEPKc($333, $335) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 54; break; };
    case 60: // $338
      $region=$337;
      var $339=$region;
      var $340=(($339)|0)==0;
      if ($340) { __label__ = 61; break; } else { __label__ = 64; break; }
    case 61: // $341
      var $342=(($20+12)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($343) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 54; break; };
    case 62: // $345
      var $346=(($20+56)|0);
      var $347=HEAP32[(($346)>>2)];
      var $348=$entry;
      var $349=(($348+72)|0);
      var $350=HEAP32[(($349)>>2)];
      var $351=$entry;
      var $352=(($351+76)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=$entry;
      var $355=(($354+292)|0);
      var $356=HEAP32[(($355)>>2)];
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str122903)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$344,HEAP32[((tempInt+4)>>2)]=$347,HEAP32[((tempInt+8)>>2)]=$350,HEAP32[((tempInt+12)>>2)]=$353,HEAP32[((tempInt+16)>>2)]=$356,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 54; break; }
    case 63: // $357
      throw "Reached an unreachable!"
    case 64: // $358
      var $359=$entry;
      var $360=(($359+296)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=$entry;
      var $363=(($362+564)|0);
      var $364=HEAP32[(($363)>>2)];
      var $365=$entry;
      var $366=(($365+560)|0);
      var $367=HEAP32[(($366)>>2)];
      var $368=(($364-$367)|0);
      var $369=(($368+1)|0);
      var $370=(($361+$369)|0);
      var $371=$region;
      var $372=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($371) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 54; break; };
    case 65: // $373
      var $374=(($370)>>>0) > (($372)>>>0);
      if ($374) { __label__ = 66; break; } else { __label__ = 70; break; }
    case 66: // $375
      var $376=(($20+12)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($377) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 54; break; };
    case 67: // $379
      var $380=(($20+56)|0);
      var $381=HEAP32[(($380)>>2)];
      var $382=$entry;
      var $383=(($382+72)|0);
      var $384=HEAP32[(($383)>>2)];
      var $385=$entry;
      var $386=(($385+76)|0);
      var $387=HEAP32[(($386)>>2)];
      var $388=$entry;
      var $389=(($388+292)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=$region;
      var $392=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($391) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 54; break; };
    case 68: // $393
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str132904)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$378,HEAP32[((tempInt+4)>>2)]=$381,HEAP32[((tempInt+8)>>2)]=$384,HEAP32[((tempInt+12)>>2)]=$387,HEAP32[((tempInt+16)>>2)]=$390,HEAP32[((tempInt+20)>>2)]=$392,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 54; break; }
    case 69: // $394
      throw "Reached an unreachable!"
    case 70: // $395
      FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag);
      __label__ = 72; break;
    case 71: // $396
      __label__ = 89; break;
    case 72: // $397
      var $398=$entry;
      var $399=(($398+292)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=(($400)|0)!=0;
      if ($401) { __label__ = 73; break; } else { __label__ = 86; break; }
    case 73: // $402
      __ZN7astringC1Ev($regiontag1);
      var $403=$entry;
      var $404=(($403+292)|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=(function() { try { __THREW__ = false; return _strchr($405, 58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 77; break; };
    case 74: // $407
      var $408=(($406)|0)!=0;
      if ($408) { __label__ = 75; break; } else { __label__ = 78; break; }
    case 75: // $409
      var $410=$entry;
      var $411=(($410+292)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($regiontag1, $412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 77; break; };
    case 76: // $414
      __label__ = 80; break;
    case 77: // $415
      var $416=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $417=$416.f0;
      $18=$417;
      var $418=$416.f1;
      $19=$418;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 90; break; }
    case 78: // $419
      var $420=(($20+12)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=$entry;
      var $423=(($422+292)|0);
      var $424=HEAP32[(($423)>>2)];
      var $425=(function() { try { __THREW__ = false; return __ZNK8device_t10siblingtagER7astringPKc($421, $regiontag1, $424) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 77; break; };
    case 79: // $426
      __label__ = 80; break;
    case 80: // $427
      var $428=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 77; break; };
    case 81: // $429
      var $430=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($regiontag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 77; break; };
    case 82: // $431
      var $432=(function() { try { __THREW__ = false; return __ZN15running_machine6regionEPKc($428, $430) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 77; break; };
    case 83: // $433
      var $434=(function() { try { __THREW__ = false; return __ZNK13memory_region4baseEv($432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 77; break; };
    case 84: // $435
      var $436=$entry;
      var $437=(($436+296)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=(($434+$438)|0);
      var $440=$entry;
      var $441=(($440+556)|0);
      HEAP32[(($441)>>2)]=$439;
      FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag1);
      __label__ = 86; break;
    case 85: // $442
      __label__ = 89; break;
    case 86: // $443
      __label__ = 87; break;
    case 87: // $444
      var $445=$entry;
      var $446=__ZNK17address_map_entry4nextEv($445);
      $entry=$446;
      __label__ = 22; break;
    case 88: // $447
      var $448=$20;
      var $449=HEAP32[(($448)>>2)];
      var $450=(($449+132)|0);
      var $451=HEAP32[(($450)>>2)];
      var $452=FUNCTION_TABLE[$451]($20);
      var $453=$452;
      var $454=(($20+24)|0);
      var $455=HEAP32[(($454)>>2)];
      __ZN13address_table17mask_all_handlersEj($453, $455);
      var $456=$20;
      var $457=HEAP32[(($456)>>2)];
      var $458=(($457+136)|0);
      var $459=HEAP32[(($458)>>2)];
      var $460=FUNCTION_TABLE[$459]($20);
      var $461=$460;
      var $462=(($20+24)|0);
      var $463=HEAP32[(($462)>>2)];
      __ZN13address_table17mask_all_handlersEj($461, $463);
      STACKTOP = __stackBase__;
      return;
    case 89: // $464
      var $465=$18;
      var $466=$18;
      var $467=$19;
      var $468=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $466, tempValue);
      var $469=($468.f1 = $467, $468);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 90: // $470
      var $471=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space11prepare_mapEv["X"]=1;

function __ZL16generate_memdumpR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  ;
  return;
}


function __ZN13address_space13locate_memoryEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $entry;
      var $bank;
      var $entry1;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+12)|0);
      var $6=__ZNK11simple_listI17address_map_entryE5firstEv($5);
      $entry=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$entry;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $10
      var $11=$entry;
      var $12=(($11+268)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$entry;
      var $17=(($16+556)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$entry;
      var $20=(($19+268)|0);
      var $21=HEAP32[(($20)>>2)];
      HEAP32[(($21)>>2)]=$18;
      __label__ = 4; break;
    case 4: // $22
      var $23=$entry;
      var $24=(($23+276)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      var $28=$entry;
      var $29=(($28+556)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZNK13address_space7machineEv($2);
      var $32=__ZNK15running_machine11driver_dataIvEEPT_v($31);
      var $33=$entry;
      var $34=(($33+276)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32+$35)|0);
      var $37=(($36-1)|0);
      var $38=$37;
      HEAP32[(($38)>>2)]=$30;
      __label__ = 6; break;
    case 6: // $39
      var $40=$entry;
      var $41=(($40+284)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $44
      var $45=$entry;
      var $46=(($45+556)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=__ZNK13address_space7machineEv($2);
      var $49=(($48+588)|0);
      var $50=$49;
      var $51=$entry;
      var $52=(($51+284)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($50+$53)|0);
      var $55=(($54-1)|0);
      var $56=$55;
      HEAP32[(($56)>>2)]=$47;
      __label__ = 8; break;
    case 8: // $57
      var $58=$entry;
      var $59=(($58+272)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $62
      var $63=$entry;
      var $64=(($63+564)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$entry;
      var $67=(($66+560)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=(($69+1)|0);
      var $71=$entry;
      var $72=(($71+272)|0);
      var $73=HEAP32[(($72)>>2)];
      HEAP32[(($73)>>2)]=$70;
      __label__ = 10; break;
    case 10: // $74
      var $75=$entry;
      var $76=(($75+280)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $79
      var $80=$entry;
      var $81=(($80+564)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$entry;
      var $84=(($83+560)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82-$85)|0);
      var $87=(($86+1)|0);
      var $88=__ZNK13address_space7machineEv($2);
      var $89=__ZNK15running_machine11driver_dataIvEEPT_v($88);
      var $90=$entry;
      var $91=(($90+280)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($89+$92)|0);
      var $94=(($93-1)|0);
      var $95=$94;
      HEAP32[(($95)>>2)]=$87;
      __label__ = 12; break;
    case 12: // $96
      var $97=$entry;
      var $98=(($97+288)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $101
      var $102=$entry;
      var $103=(($102+564)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$entry;
      var $106=(($105+560)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($104-$107)|0);
      var $109=(($108+1)|0);
      var $110=__ZNK13address_space7machineEv($2);
      var $111=(($110+588)|0);
      var $112=$111;
      var $113=$entry;
      var $114=(($113+288)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($112+$115)|0);
      var $117=(($116-1)|0);
      var $118=$117;
      HEAP32[(($118)>>2)]=$109;
      __label__ = 14; break;
    case 14: // $119
      __label__ = 15; break;
    case 15: // $120
      var $121=$entry;
      var $122=__ZNK17address_map_entry4nextEv($121);
      $entry=$122;
      __label__ = 1; break;
    case 16: // $123
      var $124=__ZNK13address_space7machineEv($2);
      var $125=(($124+624)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+1068)|0);
      var $128=__ZNK11simple_listI11memory_bankE5firstEv($127);
      $bank=$128;
      __label__ = 17; break;
    case 17: // $129
      var $130=$bank;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 18; break; } else { __label__ = 35; break; }
    case 18: // $132
      var $133=$bank;
      var $134=__ZNK11memory_bank4baseEv($133);
      var $135=(($134)|0)==0;
      if ($135) { __label__ = 19; break; } else { __label__ = 33; break; }
    case 19: // $136
      var $137=$bank;
      var $138=__ZNK11memory_bank16references_spaceER13address_space13read_or_write($137, $2, 3);
      if ($138) { __label__ = 20; break; } else { __label__ = 33; break; }
    case 20: // $139
      var $140=(($2+16)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141+12)|0);
      var $143=__ZNK11simple_listI17address_map_entryE5firstEv($142);
      $entry1=$143;
      __label__ = 21; break;
    case 21: // $144
      var $145=$entry1;
      var $146=(($145)|0)!=0;
      if ($146) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $147
      var $148=$entry1;
      var $149=(($148+560)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$bank;
      var $152=__ZNK11memory_bank9bytestartEv($151);
      var $153=(($150)|0)==(($152)|0);
      if ($153) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $154
      var $155=$entry1;
      var $156=(($155+556)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 24: // $159
      var $160=$bank;
      var $161=$entry1;
      var $162=(($161+556)|0);
      var $163=HEAP32[(($162)>>2)];
      __ZN11memory_bank8set_baseEPv($160, $163);
      __label__ = 25; break;
    case 25: // $164
      __label__ = 26; break;
    case 26: // $165
      __label__ = 29; break;
    case 27: // $166
      __label__ = 28; break;
    case 28: // $167
      var $168=$entry1;
      var $169=__ZNK17address_map_entry4nextEv($168);
      $entry1=$169;
      __label__ = 21; break;
    case 29: // $170
      var $171=$bank;
      var $172=__ZNK11memory_bank9anonymousEv($171);
      if ($172) { __label__ = 32; break; } else { __label__ = 30; break; }
    case 30: // $173
      var $174=$bank;
      var $175=__ZNK11memory_bank5entryEv($174);
      var $176=(($175)|0)!=-1;
      if ($176) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $177
      var $178=$bank;
      var $179=$bank;
      var $180=__ZNK11memory_bank5entryEv($179);
      __ZN11memory_bank9set_entryEi($178, $180);
      __label__ = 32; break;
    case 32: // $181
      __label__ = 33; break;
    case 33: // $182
      __label__ = 34; break;
    case 34: // $183
      var $184=$bank;
      var $185=__ZNK11memory_bank4nextEv($184);
      $bank=$185;
      __label__ = 17; break;
    case 35: // $186
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space13locate_memoryEv["X"]=1;

function __ZL13bank_reattachR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $bank;
      $1=$machine;
      var $2=$1;
      var $3=(($2+624)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+1068)|0);
      var $6=__ZNK11simple_listI11memory_bankE5firstEv($5);
      $bank=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$bank;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$bank;
      var $12=__ZNK11memory_bank9anonymousEv($11);
      if ($12) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$bank;
      var $15=__ZNK11memory_bank5entryEv($14);
      var $16=(($15)|0)!=-1;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$bank;
      var $19=$bank;
      var $20=__ZNK11memory_bank5entryEv($19);
      __ZN11memory_bank9set_entryEi($18, $20);
      __label__ = 5; break;
    case 5: // $21
      __label__ = 6; break;
    case 6: // $22
      var $23=$bank;
      var $24=__ZNK11memory_bank4nextEv($23);
      $bank=$24;
      __label__ = 1; break;
    case 7: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8tagmap_tIP11memory_bankE14find_hash_onlyEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL21tagmap_find_hash_onlyPK7_tagmapPKc3113($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZN13address_space15allocate_memoryEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $blocklist;
      var $prev_memblock_tail;
      var $entry;
      var $18;
      var $19;
      var $unassigned;
      var $first_new_block;
      var $memblock;
      var $curblockstart;
      var $curblockend;
      var $changed;
      var $entry1;
      var $blockstart;
      var $blockend;
      var $curbytestart;
      var $curbyteend;
      var $block;
      $17=$this;
      var $20=$17;
      var $21=__ZNK13address_space7machineEv($20);
      var $22=(($21+624)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+1048)|0);
      $blocklist=$24;
      var $25=$blocklist;
      var $26=__ZNK11simple_listI12memory_blockE4lastEv($25);
      $prev_memblock_tail=$26;
      var $27=(($20+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+12)|0);
      var $30=__ZNK11simple_listI17address_map_entryE5firstEv($29);
      $entry=$30;
      __label__ = 1; break;
    case 1: // $31
      var $32=$entry;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $34
      var $35=$entry;
      var $36=(($35+556)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $39
      var $40=$blocklist;
      var $41=__ZNK13address_space7machineEv($20);
      var $42=__ZN15running_machine7respoolEv($41);
      var $43=$12;
      var $44=$13;
      var $45=$14;
      var $46=$result_i;
      var $47=$15;
      var $48=$16;
      HEAP32[(($12)>>2)]=28;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($14)>>2)]=2388;
      var $49=HEAP32[(($12)>>2)];
      var $50=HEAP32[(($13)>>2)];
      var $51=HEAP32[(($14)>>2)];
      var $52=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($49, $50, $51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $53
      HEAP32[(($result_i)>>2)]=$52;
      var $54=HEAP32[(($result_i)>>2)];
      var $55=(($54)|0)==0;
      if ($55) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $56
      var $57=___cxa_allocate_exception(4);
      var $58=$57;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($58);
      (function() { try { __THREW__ = false; return ___cxa_throw($57, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      HEAP32[(($15)>>2)]=$61;
      var $62=$60.f1;
      HEAP32[(($16)>>2)]=$62;
      var $63=HEAP32[(($16)>>2)];
      var $64=(($63)|0) < 0;
      if ($64) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $65
      var $66=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($66);
      throw "Reached an unreachable!"
    case 8: // $67
      var $68=HEAP32[(($15)>>2)];
      var $69=HEAP32[(($15)>>2)];
      var $70=HEAP32[(($16)>>2)];
      var $71=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $69, tempValue);
      var $72=($71.f1 = $70, $71);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $73
      throw "Reached an unreachable!"
    case 10: // $_ZnwjPKci_exit
      var $74=HEAP32[(($result_i)>>2)];
      var $75=$12;
      var $76=$13;
      var $77=$14;
      var $78=$result_i;
      var $79=$15;
      var $80=$16;
      var $81=$74;
      var $82=$entry;
      var $83=(($82+560)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$entry;
      var $86=(($85+564)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$entry;
      var $89=(($88+556)|0);
      var $90=HEAP32[(($89)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12memory_blockC1ER13address_spacejjPv]($81, $20, $84, $87, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $91
      var $92=__ZN13resource_pool10add_objectI12memory_blockEEPT_S3_($42, $81);
      var $93=__ZN11simple_listI12memory_blockE6appendERS0_($40, $92);
      __label__ = 17; break;
    case 12: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      $18=$96;
      var $97=$95.f1;
      $19=$97;
      var $98=$9;
      var $99=$10;
      var $100=$11;
      HEAP32[(($9)>>2)]=$74;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($11)>>2)]=2388;
      var $101=HEAP32[(($9)>>2)];
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $103
      var $104=HEAP32[(($9)>>2)];
      var $105=HEAP32[(($10)>>2)];
      var $106=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($104, $105, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 64; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $107=$9;
      var $108=$10;
      var $109=$11;
      __label__ = 16; break;
    case 16: // $110
      __label__ = 63; break;
    case 17: // $111
      __label__ = 18; break;
    case 18: // $112
      var $113=$entry;
      var $114=__ZNK17address_map_entry4nextEv($113);
      $entry=$114;
      __label__ = 1; break;
    case 19: // $115
      $unassigned=0;
      var $116=$prev_memblock_tail;
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $118
      var $119=$prev_memblock_tail;
      var $120=__ZNK12memory_block4nextEv($119);
      var $125 = $120;__label__ = 22; break;
    case 21: // $121
      var $122=$blocklist;
      var $123=__ZNK11simple_listI12memory_blockE5firstEv($122);
      var $125 = $123;__label__ = 22; break;
    case 22: // $124
      var $125;
      $first_new_block=$125;
      var $126=$first_new_block;
      $memblock=$126;
      __label__ = 23; break;
    case 23: // $127
      var $128=$memblock;
      var $129=(($128)|0)!=0;
      if ($129) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $130
      var $131=$memblock;
      var $132=__ZNK12memory_block9bytestartEv($131);
      var $133=$memblock;
      var $134=__ZNK12memory_block7byteendEv($133);
      var $135=$memblock;
      var $136=__ZNK12memory_block4dataEv($135);
      var $137=__ZN13address_space25block_assign_intersectingEjjPh($20, $132, $134, $136);
      $unassigned=$137;
      __label__ = 25; break;
    case 25: // $138
      var $139=$memblock;
      var $140=__ZNK12memory_block4nextEv($139);
      $memblock=$140;
      __label__ = 23; break;
    case 26: // $141
      var $142=$unassigned;
      var $143=(($142)|0)==0;
      if ($143) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $144
      var $145=__ZN13address_space25block_assign_intersectingEjjPh($20, -1, 0, 0);
      $unassigned=$145;
      __label__ = 28; break;
    case 28: // $146
      __label__ = 29; break;
    case 29: // $147
      var $148=$unassigned;
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 30; break; } else { __label__ = 62; break; }
    case 30: // $150
      var $151=$unassigned;
      var $152=(($151+560)|0);
      var $153=HEAPU32[(($152)>>2)];
      var $154=Math.floor((($153)>>>0)/65536);
      $curblockstart=$154;
      var $155=$unassigned;
      var $156=(($155+564)|0);
      var $157=HEAPU32[(($156)>>2)];
      var $158=Math.floor((($157)>>>0)/65536);
      $curblockend=$158;
      __label__ = 31; break;
    case 31: // $159
      $changed=0;
      var $160=(($20+16)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+12)|0);
      var $163=__ZNK11simple_listI17address_map_entryE5firstEv($162);
      $entry1=$163;
      __label__ = 32; break;
    case 32: // $164
      var $165=$entry1;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 33; break; } else { __label__ = 46; break; }
    case 33: // $167
      var $168=$entry1;
      var $169=(($168+556)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($170)|0)==0;
      if ($171) { __label__ = 34; break; } else { __label__ = 44; break; }
    case 34: // $172
      var $173=$entry1;
      var $174=$unassigned;
      var $175=(($173)|0)!=(($174)|0);
      if ($175) { __label__ = 35; break; } else { __label__ = 44; break; }
    case 35: // $176
      var $177=$entry1;
      var $178=__ZN13address_space19needs_backing_storeEPK17address_map_entry($20, $177);
      if ($178) { __label__ = 36; break; } else { __label__ = 44; break; }
    case 36: // $179
      var $180=$entry1;
      var $181=(($180+560)|0);
      var $182=HEAPU32[(($181)>>2)];
      var $183=Math.floor((($182)>>>0)/65536);
      $blockstart=$183;
      var $184=$entry1;
      var $185=(($184+564)|0);
      var $186=HEAPU32[(($185)>>2)];
      var $187=Math.floor((($186)>>>0)/65536);
      $blockend=$187;
      var $188=$blockstart;
      var $189=$curblockend;
      var $190=(($189+1)|0);
      var $191=(($188)>>>0) <= (($190)>>>0);
      if ($191) { __label__ = 37; break; } else { __label__ = 43; break; }
    case 37: // $192
      var $193=$blockend;
      var $194=$curblockstart;
      var $195=(($194-1)|0);
      var $196=(($193)>>>0) >= (($195)>>>0);
      if ($196) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $197
      var $198=$blockstart;
      var $199=$curblockstart;
      var $200=(($198)>>>0) < (($199)>>>0);
      if ($200) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $201
      var $202=$blockstart;
      $curblockstart=$202;
      $changed=1;
      __label__ = 40; break;
    case 40: // $203
      var $204=$blockend;
      var $205=$curblockend;
      var $206=(($204)>>>0) > (($205)>>>0);
      if ($206) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $207
      var $208=$blockend;
      $curblockend=$208;
      $changed=1;
      __label__ = 42; break;
    case 42: // $209
      __label__ = 43; break;
    case 43: // $210
      __label__ = 44; break;
    case 44: // $211
      __label__ = 45; break;
    case 45: // $212
      var $213=$entry1;
      var $214=__ZNK17address_map_entry4nextEv($213);
      $entry1=$214;
      __label__ = 32; break;
    case 46: // $215
      __label__ = 47; break;
    case 47: // $216
      var $217=$changed;
      var $218=(($217) & 1);
      if ($218) { __label__ = 31; break; } else { __label__ = 48; break; }
    case 48: // $219
      var $220=$curblockstart;
      var $221=((($220<<16))|0);
      $curbytestart=$221;
      var $222=$curblockend;
      var $223=((($222<<16))|0);
      var $224=(($223+65535)|0);
      $curbyteend=$224;
      var $225=$blocklist;
      var $226=__ZNK13address_space7machineEv($20);
      var $227=__ZN15running_machine7respoolEv($226);
      var $228=$4;
      var $229=$5;
      var $230=$6;
      var $231=$result_i2;
      var $232=$7;
      var $233=$8;
      HEAP32[(($4)>>2)]=28;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=2435;
      var $234=HEAP32[(($4)>>2)];
      var $235=HEAP32[(($5)>>2)];
      var $236=HEAP32[(($6)>>2)];
      var $237=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($234, $235, $236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 51; break; };
    case 49: // $238
      HEAP32[(($result_i2)>>2)]=$237;
      var $239=HEAP32[(($result_i2)>>2)];
      var $240=(($239)|0)==0;
      if ($240) { __label__ = 50; break; } else { __label__ = 55; break; }
    case 50: // $241
      var $242=___cxa_allocate_exception(4);
      var $243=$242;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($243);
      (function() { try { __THREW__ = false; return ___cxa_throw($242, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 51; break; }
    case 51: // $244
      var $245=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $246=$245.f0;
      HEAP32[(($7)>>2)]=$246;
      var $247=$245.f1;
      HEAP32[(($8)>>2)]=$247;
      var $248=HEAP32[(($8)>>2)];
      var $249=(($248)|0) < 0;
      if ($249) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $250
      var $251=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($251);
      throw "Reached an unreachable!"
    case 53: // $252
      var $253=HEAP32[(($7)>>2)];
      var $254=HEAP32[(($7)>>2)];
      var $255=HEAP32[(($8)>>2)];
      var $256=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $254, tempValue);
      var $257=($256.f1 = $255, $256);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 54: // $258
      throw "Reached an unreachable!"
    case 55: // $_ZnwjPKci_exit3
      var $259=HEAP32[(($result_i2)>>2)];
      var $260=$4;
      var $261=$5;
      var $262=$6;
      var $263=$result_i2;
      var $264=$7;
      var $265=$8;
      var $266=$259;
      var $267=$curbytestart;
      var $268=$curbyteend;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12memory_blockC1ER13address_spacejjPv]($266, $20, $267, $268, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $269
      var $270=__ZN13resource_pool10add_objectI12memory_blockEEPT_S3_($227, $266);
      var $271=__ZN11simple_listI12memory_blockE6appendERS0_($225, $270);
      $block=$271;
      var $272=$curbytestart;
      var $273=$curbyteend;
      var $274=$block;
      var $275=__ZNK12memory_block4dataEv($274);
      var $276=__ZN13address_space25block_assign_intersectingEjjPh($20, $272, $273, $275);
      $unassigned=$276;
      __label__ = 29; break;
    case 57: // $277
      var $278=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $279=$278.f0;
      $18=$279;
      var $280=$278.f1;
      $19=$280;
      var $281=$1;
      var $282=$2;
      var $283=$3;
      HEAP32[(($1)>>2)]=$259;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=2435;
      var $284=HEAP32[(($1)>>2)];
      var $285=(($284)|0)!=0;
      if ($285) { __label__ = 58; break; } else { __label__ = 60; break; }
    case 58: // $286
      var $287=HEAP32[(($1)>>2)];
      var $288=HEAP32[(($2)>>2)];
      var $289=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($287, $288, $289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 64; break; }
    case 59: // $_noexc4
      __label__ = 60; break;
    case 60: // $_ZdlPvPKci_exit5
      var $290=$1;
      var $291=$2;
      var $292=$3;
      __label__ = 61; break;
    case 61: // $293
      __label__ = 63; break;
    case 62: // $294
      STACKTOP = __stackBase__;
      return;
    case 63: // $295
      var $296=$18;
      var $297=$18;
      var $298=$19;
      var $299=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $297, tempValue);
      var $300=($299.f1 = $298, $299);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 64: // $301
      var $302=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space15allocate_memoryEv["X"]=1;

function __ZNK11memory_bank5entryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12memory_share3ptrEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK20address_space_config4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK8tagmap_tIP12memory_shareE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL11tagmap_findPK7_tagmapPKc3110($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __Z11memory_dumpR15running_machineP7__sFILE($machine, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $space;
      $1=$machine;
      $2=$file;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      __label__ = 6; break;
    case 2: // $6
      var $7=$1;
      var $8=(($7+624)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+1028)|0);
      var $11=__ZNK11simple_listI13address_spaceE5firstEv($10);
      $space=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$space;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $15
      var $16=$2;
      var $17=$space;
      var $18=__ZNK13address_space6deviceEv($17);
      var $19=__ZNK8device_t3tagEv($18);
      var $20=$space;
      var $21=__ZNK13address_space4nameEv($20);
      var $22=_fprintf($16, ((STRING_TABLE.__str92900)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,HEAP32[((tempInt+4)>>2)]=$21,tempInt));
      var $23=$space;
      var $24=$2;
      __ZN13address_space8dump_mapEP7__sFILE13read_or_write($23, $24, 1);
      var $25=$2;
      var $26=$space;
      var $27=__ZNK13address_space6deviceEv($26);
      var $28=__ZNK8device_t3tagEv($27);
      var $29=$space;
      var $30=__ZNK13address_space4nameEv($29);
      var $31=_fprintf($25, ((STRING_TABLE.__str102901)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,HEAP32[((tempInt+4)>>2)]=$30,tempInt));
      var $32=$space;
      var $33=$2;
      __ZN13address_space8dump_mapEP7__sFILE13read_or_write($32, $33, 2);
      __label__ = 5; break;
    case 5: // $34
      var $35=$space;
      var $36=__ZNK13address_space4nextEv($35);
      $space=$36;
      __label__ = 3; break;
    case 6: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_space8dump_mapEP7__sFILE13read_or_write($this, $file, $readorwrite) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $table;
      var $bytestart=__stackBase__;
      var $byteend=__stackBase__+4;
      var $byteaddress;
      var $entry;
      $1=$this;
      $2=$file;
      $3=$readorwrite;
      var $4=$1;
      var $5=$3;
      var $6=(($5)|0)==1;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+132)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=FUNCTION_TABLE[$11]($4);
      var $13=$12;
      var $22 = $13;__label__ = 3; break;
    case 2: // $14
      var $15=$4;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+136)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=FUNCTION_TABLE[$18]($4);
      var $20=$19;
      var $22 = $20;__label__ = 3; break;
    case 3: // $21
      var $22;
      $table=$22;
      var $23=$2;
      var $24=(($4+8)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+9)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=_fprintf($23, ((STRING_TABLE.__str172908)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,tempInt));
      var $30=$2;
      var $31=(($4+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+8)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=_fprintf($30, ((STRING_TABLE.__str182909)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$35,tempInt));
      var $37=$2;
      var $38=(($4+24)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=_fprintf($37, ((STRING_TABLE.__str192910)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt));
      var $41=$2;
      var $42=_fprintf($41, ((STRING_TABLE.__str202911)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $byteaddress=0;
      __label__ = 4; break;
    case 4: // $43
      var $44=$byteaddress;
      var $45=(($4+24)|0);
      var $46=HEAPU32[(($45)>>2)];
      var $47=(($44)>>>0) <= (($46)>>>0);
      if ($47) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $48
      var $49=$table;
      var $50=$byteaddress;
      var $51=__ZNK13address_table12derive_rangeEjRjS0_($49, $50, $bytestart, $byteend);
      $entry=$51;
      var $52=$2;
      var $53=HEAP32[(($bytestart)>>2)];
      var $54=HEAP32[(($byteend)>>2)];
      var $55=$entry;
      var $56=(($55)&255);
      var $57=$table;
      var $58=$entry;
      var $59=__ZNK13address_table12handler_nameEh($57, $58);
      var $60=$table;
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$entry;
      var $66=(($65)&255);
      var $67=FUNCTION_TABLE[$64]($60, $66);
      var $68=__ZNK13handler_entry9bytestartEv($67);
      var $69=_fprintf($52, ((STRING_TABLE.__str212912)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,HEAP32[((tempInt+4)>>2)]=$54,HEAP32[((tempInt+8)>>2)]=$56,HEAP32[((tempInt+12)>>2)]=$59,HEAP32[((tempInt+16)>>2)]=$68,tempInt));
      var $70=HEAP32[(($byteend)>>2)];
      var $71=(($70+1)|0);
      HEAP32[(($byteend)>>2)]=$71;
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $73
      __label__ = 9; break;
    case 7: // $74
      __label__ = 8; break;
    case 8: // $75
      var $76=HEAP32[(($byteend)>>2)];
      $byteaddress=$76;
      __label__ = 4; break;
    case 9: // $77
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space8dump_mapEP7__sFILE13read_or_write["X"]=1;

function __ZNK13address_space19address_to_byte_endEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK20address_space_config13addr2byte_endEj($5, $6);
  ;
  return $7;
}


function __ZN13address_spaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV13address_space+8)|0);
  var $4=(($2+52)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$5;
  __ZN13resource_pool6removeEPv(_global_resource_pool, $6);
  var $7=(($2+16)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$8;
  __ZN13resource_pool6removeEPv(_global_resource_pool, $9);
  ;
  return;
}


function __ZN11memory_bank9set_entryEi($this, $entrynum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$entrynum;
      var $5=$1;
      var $6=(($5+17)|0);
      var $7=HEAP8[($6)];
      var $8=(($7) & 1);
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(1032);
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($11, ((STRING_TABLE.__str2023093)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      ___cxa_throw($10, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $3=$15;
      var $16=$14.f1;
      $4=$16;
      ___cxa_free_exception($10);
      __label__ = 15; break;
    case 4: // $17
      var $18=$2;
      var $19=(($18)|0) < 0;
      if ($19) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $20
      var $21=$2;
      var $22=(($5+36)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($21)|0) >= (($23)|0);
      if ($24) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $25
      var $26=___cxa_allocate_exception(1032);
      var $27=$26;
      var $28=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($27, ((STRING_TABLE.__str2033094)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      ___cxa_throw($26, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 8: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $3=$32;
      var $33=$31.f1;
      $4=$33;
      ___cxa_free_exception($26);
      __label__ = 15; break;
    case 9: // $34
      var $35=$2;
      var $36=(($5+32)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+($35<<3))|0);
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $42
      var $43=___cxa_allocate_exception(1032);
      var $44=$43;
      var $45=(($5+104)|0);
      var $46=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $47
      var $48=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($44, ((STRING_TABLE.__str2043095)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$46,HEAP32[((tempInt+4)>>2)]=$48,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $49
      ___cxa_throw($43, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 13: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      $3=$52;
      var $53=$51.f1;
      $4=$53;
      ___cxa_free_exception($43);
      __label__ = 15; break;
    case 14: // $54
      var $55=$2;
      var $56=(($5+28)|0);
      HEAP32[(($56)>>2)]=$55;
      var $57=$2;
      var $58=(($5+32)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+($57<<3))|0);
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($5+8)|0);
      var $64=HEAP32[(($63)>>2)];
      HEAP32[(($64)>>2)]=$62;
      var $65=$2;
      var $66=(($5+32)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+($65<<3))|0);
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($5+12)|0);
      var $72=HEAP32[(($71)>>2)];
      HEAP32[(($72)>>2)]=$70;
      __ZN11memory_bank21invalidate_referencesEv($5);
      ;
      return;
    case 15: // $73
      var $74=$3;
      var $75=$3;
      var $76=$4;
      var $77=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $75, tempValue);
      var $78=($77.f1 = $76, $77);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11memory_bank9set_entryEi["X"]=1;

function __ZN11memory_bank8set_baseEPv($this, $base) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$base;
      var $5=$1;
      var $6=$2;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=___cxa_allocate_exception(1032);
      var $10=$9;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($10, ((STRING_TABLE.__str2013092)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      ___cxa_throw($9, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $3=$14;
      var $15=$13.f1;
      $4=$15;
      ___cxa_free_exception($9);
      __label__ = 5; break;
    case 4: // $16
      var $17=$2;
      var $18=(($5+8)|0);
      var $19=HEAP32[(($18)>>2)];
      HEAP32[(($19)>>2)]=$17;
      __ZN11memory_bank21invalidate_referencesEv($5);
      ;
      return;
    case 5: // $20
      var $21=$3;
      var $22=$3;
      var $23=$4;
      var $24=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22, tempValue);
      var $25=($24.f1 = $23, $24);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($this, $memory, $spacenum, $large) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$this;
      $10=$memory;
      $11=$spacenum;
      var $15=(($large)&1);
      $12=$15;
      var $16=$9;
      var $17=$16;
      HEAP32[(($17)>>2)]=((__ZTV13address_space+8)|0);
      var $18=(($16+4)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($16+8)|0);
      var $20=$10;
      var $21=$11;
      var $22=__ZNK23device_memory_interface12space_configE16address_spacenum($20, $21);
      HEAP32[(($19)>>2)]=$22;
      var $23=(($16+12)|0);
      var $24=$10;
      var $25=$24;
      var $26=__ZN16device_interface6deviceEv($25);
      HEAP32[(($23)>>2)]=$26;
      var $27=(($16+16)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=(($16+20)|0);
      var $29=(($16+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+9)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=((32-$33)|0);
      var $35=-1 >>> (($34)>>>0);
      HEAP32[(($28)>>2)]=$35;
      var $36=(($16+24)|0);
      var $37=(($16+20)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=__ZNK13address_space19address_to_byte_endEj($16, $38);
      HEAP32[(($36)>>2)]=$39;
      var $40=(($16+28)|0);
      var $41=(($16+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+11)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=((32-$45)|0);
      var $47=-1 >>> (($46)>>>0);
      HEAP32[(($40)>>2)]=$47;
      var $48=(($16+32)|0);
      var $49=(($16+28)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=__ZNK13address_space19address_to_byte_endEj($16, $50);
      HEAP32[(($48)>>2)]=$51;
      var $52=(($16+36)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$68$0=(($52)|0);
      HEAP32[(($st$68$0)>>2)]=$$emscripten$temp$0$0;
      var $st$68$1=(($52+4)|0);
      HEAP32[(($st$68$1)>>2)]=$$emscripten$temp$0$1;
      var $53=(($16+44)|0);
      var $54=$11;
      HEAP32[(($53)>>2)]=$54;
      var $55=(($16+48)|0);
      HEAP8[($55)]=0;
      var $56=(($16+49)|0);
      HEAP8[($56)]=1;
      var $57=(($16+52)|0);
      var $58=$10;
      var $59=$58;
      var $60=__ZN16device_interface6deviceEv($59);
      var $61=__ZNK8device_t7machineEv($60);
      var $62=__ZN15running_machine7respoolEv($61);
      var $63=$4;
      var $64=$5;
      var $65=$6;
      var $66=$result_i;
      var $67=$7;
      var $68=$8;
      HEAP32[(($4)>>2)]=5192;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=2019;
      var $69=HEAP32[(($4)>>2)];
      var $70=HEAP32[(($5)>>2)];
      var $71=HEAP32[(($6)>>2)];
      var $72=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($69, $70, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $73
      HEAP32[(($result_i)>>2)]=$72;
      var $74=HEAP32[(($result_i)>>2)];
      var $75=(($74)|0)==0;
      if ($75) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $76
      var $77=___cxa_allocate_exception(4);
      var $78=$77;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($78);
      (function() { try { __THREW__ = false; return ___cxa_throw($77, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $81=$80.f0;
      HEAP32[(($7)>>2)]=$81;
      var $82=$80.f1;
      HEAP32[(($8)>>2)]=$82;
      var $83=HEAP32[(($8)>>2)];
      var $84=(($83)|0) < 0;
      if ($84) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $85
      var $86=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($86);
      throw "Reached an unreachable!"
    case 5: // $87
      var $88=HEAP32[(($7)>>2)];
      var $89=HEAP32[(($7)>>2)];
      var $90=HEAP32[(($8)>>2)];
      var $91=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $89, tempValue);
      var $92=($91.f1 = $90, $91);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $93
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $94=HEAPU32[(($result_i)>>2)];
      var $95=$4;
      var $96=$5;
      var $97=$6;
      var $98=$result_i;
      var $99=$7;
      var $100=$8;
      var $101=$94;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16direct_read_dataC1ER13address_space]($101, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $102
      var $103=__ZN13resource_pool10add_objectI16direct_read_dataEEPT_S3_($62, $101);
      HEAP32[(($57)>>2)]=$103;
      var $104=(($16+56)|0);
      var $105=$10;
      var $106=$11;
      var $107=__ZNK23device_memory_interface12space_configE16address_spacenum($105, $106);
      var $108=__ZNK20address_space_config4nameEv($107);
      HEAP32[(($104)>>2)]=$108;
      var $109=(($16+60)|0);
      var $110=(($16+8)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+9)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=(($114+3)|0);
      var $116=(((($115)|0)/4)|0);
      var $117=(($116) & 255);
      HEAP8[($109)]=$117;
      var $118=(($16+61)|0);
      var $119=(($16+8)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+11)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=(($123+3)|0);
      var $125=(((($124)|0)/4)|0);
      var $126=(($125) & 255);
      HEAP8[($118)]=$126;
      var $127=(($16+64)|0);
      var $128=$10;
      var $129=$128;
      var $130=__ZN16device_interface6deviceEv($129);
      var $131=__ZNK8device_t7machineEv($130);
      HEAP32[(($127)>>2)]=$131;
      var $132=$10;
      var $133=$11;
      __ZN23device_memory_interface17set_address_spaceE16address_spacenumR13address_space($132, $133, $16);
      STACKTOP = __stackBase__;
      return;
    case 9: // $134
      var $135=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $136=$135.f0;
      $13=$136;
      var $137=$135.f1;
      $14=$137;
      var $138=$1;
      var $139=$2;
      var $140=$3;
      HEAP32[(($1)>>2)]=$94;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=2019;
      var $141=HEAP32[(($1)>>2)];
      var $142=(($141)|0)!=0;
      if ($142) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $143
      var $144=HEAP32[(($1)>>2)];
      var $145=HEAP32[(($2)>>2)];
      var $146=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($144, $145, $146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $147=$1;
      var $148=$2;
      var $149=$3;
      __label__ = 13; break;
    case 13: // $150
      __label__ = 14; break;
    case 14: // $151
      var $152=$13;
      var $153=$13;
      var $154=$14;
      var $155=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $153, tempValue);
      var $156=($155.f1 = $154, $155);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_spaceC2ER23device_memory_interface16address_spacenumb["X"]=1;

function __ZN13resource_pool10add_objectI16direct_read_dataEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16direct_read_dataEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16direct_read_dataEEPT_S3_["X"]=1;

function __ZN13address_spaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13address_spaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_spaceD0Ev["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIhL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIhL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIhL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIhL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificItL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificItL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb0EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb0EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb0EEEEPT_S5_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificItL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificItL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIjL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIjL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIjL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIjL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb0EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb0EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb0EEEEPT_S5_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIyL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIyL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIyL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$memory;
  $3=$spacenum;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN22address_space_specificIyL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($4, $6, $5);
  ;
  return;
}


function __ZN13address_space16adjust_addressesERjS0_S0_S0_($this, $start, $end, $mask, $mirror) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$start;
      $3=$end;
      $4=$mask;
      $5=$mirror;
      var $6=$1;
      var $7=$4;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($6+20)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$5;
      var $14=HEAP32[(($13)>>2)];
      var $15=$14 ^ -1;
      var $16=$12 & $15;
      var $17=$4;
      HEAP32[(($17)>>2)]=$16;
      __label__ = 3; break;
    case 2: // $18
      var $19=(($6+20)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$4;
      var $22=HEAP32[(($21)>>2)];
      var $23=$22 & $20;
      HEAP32[(($21)>>2)]=$23;
      __label__ = 3; break;
    case 3: // $24
      var $25=$5;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 ^ -1;
      var $28=(($6+20)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$27 & $29;
      var $31=$2;
      var $32=HEAP32[(($31)>>2)];
      var $33=$32 & $30;
      HEAP32[(($31)>>2)]=$33;
      var $34=$5;
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 ^ -1;
      var $37=(($6+20)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$36 & $38;
      var $40=$3;
      var $41=HEAP32[(($40)>>2)];
      var $42=$41 & $39;
      HEAP32[(($40)>>2)]=$42;
      var $43=$2;
      var $44=HEAP32[(($43)>>2)];
      var $45=__ZNK13address_space15address_to_byteEj($6, $44);
      var $46=$2;
      HEAP32[(($46)>>2)]=$45;
      var $47=$3;
      var $48=HEAP32[(($47)>>2)];
      var $49=__ZNK13address_space19address_to_byte_endEj($6, $48);
      var $50=$3;
      HEAP32[(($50)>>2)]=$49;
      var $51=$4;
      var $52=HEAP32[(($51)>>2)];
      var $53=__ZNK13address_space19address_to_byte_endEj($6, $52);
      var $54=$4;
      HEAP32[(($54)>>2)]=$53;
      var $55=$5;
      var $56=HEAP32[(($55)>>2)];
      var $57=__ZNK13address_space15address_to_byteEj($6, $56);
      var $58=$5;
      HEAP32[(($58)>>2)]=$57;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space16adjust_addressesERjS0_S0_S0_["X"]=1;

function __ZN12memory_shareC1EjPv($this, $size, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$size;
  $3=$ptr;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN12memory_shareC2EjPv($4, $5, $6);
  ;
  return;
}


function __ZN8tagmap_tIP12memory_shareE3addEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z10tagmap_addP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN13address_table17mask_all_handlersEj($this, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $entrynum;
      $1=$this;
      $2=$mask;
      var $3=$1;
      $entrynum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$entrynum;
      var $6=(($5)|0) < 192;
      if ($6) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $7
      var $8=$3;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$entrynum;
      var $13=FUNCTION_TABLE[$11]($3, $12);
      var $14=$2;
      __ZN13handler_entry10apply_maskEj($13, $14);
      __label__ = 3; break;
    case 3: // $15
      var $16=$entrynum;
      var $17=(($16+1)|0);
      $entrynum=$17;
      __label__ = 1; break;
    case 4: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb0EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb1EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb1EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb0EEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb0EEEEPT_S5_["X"]=1;

function __ZN13resource_pool10add_objectI12memory_shareEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12memory_shareEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12memory_shareEEPT_S3_["X"]=1;

function __ZN13address_space18populate_map_entryERK17address_map_entry13read_or_write($this, $entry, $readorwrite) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $data;
      var $device;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+24;
      var $8=__stackBase__+48;
      var $9=__stackBase__+72;
      var $10=__stackBase__+96;
      var $11=__stackBase__+120;
      var $12=__stackBase__+144;
      var $13=__stackBase__+168;
      $1=$this;
      $2=$entry;
      $3=$readorwrite;
      var $14=$1;
      var $15=$3;
      var $16=(($15)|0)==1;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=(($18+88)|0);
      var $24 = $19;__label__ = 3; break;
    case 2: // $20
      var $21=$2;
      var $22=(($21+176)|0);
      var $24 = $22;__label__ = 3; break;
    case 3: // $23
      var $24;
      $data=$24;
      var $25=$data;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      if ($27 == 0) {
        __label__ = 4; break;
      }
      else if ($27 == 2) {
        __label__ = 5; break;
      }
      else if ($27 == 1) {
        __label__ = 8; break;
      }
      else if ($27 == 3) {
        __label__ = 9; break;
      }
      else if ($27 == 4) {
        __label__ = 10; break;
      }
      else if ($27 == 5) {
        __label__ = 11; break;
      }
      else if ($27 == 6) {
        __label__ = 30; break;
      }
      else if ($27 == 7) {
        __label__ = 44; break;
      }
      else if ($27 == 8) {
        __label__ = 60; break;
      }
      else if ($27 == 9) {
        __label__ = 67; break;
      }
      else {
      __label__ = 74; break;
      }
      
    case 4: // $28
      __label__ = 74; break;
    case 5: // $29
      var $30=$3;
      var $31=(($30)|0)==2;
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      __label__ = 74; break;
    case 7: // $33
      __label__ = 8; break;
    case 8: // $34
      var $35=$2;
      var $36=(($35+72)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$2;
      var $39=(($38+76)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$2;
      var $42=(($41+84)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$2;
      var $45=(($44+80)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$3;
      var $48=__ZN13address_space19install_ram_genericEjjjj13read_or_writePv($14, $37, $40, $43, $46, $47, 0);
      __label__ = 74; break;
    case 9: // $49
      var $50=$2;
      var $51=(($50+72)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$2;
      var $54=(($53+76)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$2;
      var $57=(($56+84)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$2;
      var $60=(($59+80)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$3;
      __ZN13address_space13unmap_genericEjjjj13read_or_writeb($14, $52, $55, $58, $61, $62, 1);
      __label__ = 74; break;
    case 10: // $63
      var $64=$2;
      var $65=(($64+72)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$2;
      var $68=(($67+76)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$2;
      var $71=(($70+84)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$2;
      var $74=(($73+80)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$3;
      __ZN13address_space13unmap_genericEjjjj13read_or_writeb($14, $66, $69, $72, $75, $76, 0);
      __label__ = 74; break;
    case 11: // $77
      var $78=__ZNK13address_space7machineEv($14);
      var $79=$data;
      var $80=(($79+20)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=__ZN15running_machine6deviceEPKc($78, $81);
      $device=$82;
      var $83=$device;
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $85
      var $86=___cxa_allocate_exception(1032);
      var $87=$86;
      var $88=$data;
      var $89=(($88+20)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($14+56)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($14+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $96
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($87, ((STRING_TABLE.__str142905)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$90,HEAP32[((tempInt+4)>>2)]=$92,HEAP32[((tempInt+8)>>2)]=$95,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $97
      ___cxa_throw($86, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 15: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $100=$99.f0;
      $4=$100;
      var $101=$99.f1;
      $5=$101;
      ___cxa_free_exception($86);
      __label__ = 75; break;
    case 16: // $102
      var $103=$3;
      var $104=(($103)|0)==1;
      if ($104) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $105
      var $106=$data;
      var $107=(($106+4)|0);
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      if ($109 == 8) {
        __label__ = 18; break;
      }
      else if ($109 == 16) {
        __label__ = 19; break;
      }
      else if ($109 == 32) {
        __label__ = 20; break;
      }
      else if ($109 == 64) {
        __label__ = 21; break;
      }
      else {
      __label__ = 22; break;
      }
      
    case 18: // $110
      var $111=$2;
      var $112=(($111+72)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$2;
      var $115=(($114+76)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$2;
      var $118=(($117+84)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$2;
      var $121=(($120+80)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$2;
      var $124=(($123+300)|0);
      var $125=$124;
      var $126=$device;
      var $127=$126;
      __ZN8delegateIFhR13address_spacejhEEC1ERK13delegate_baseIhS1_jh8_noparamER18delegate_late_bind($6, $125, $127);
      var $128=$data;
      var $129=(($128+8)|0);
      var $st$20$0=(($129)|0);
      var $130$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($129+4)|0);
      var $130$1=HEAP32[(($st$20$1)>>2)];
      var $131=__ZN13address_space20install_read_handlerEjjjj8delegateIFhRS_jhEEy($14, $113, $116, $119, $122, $6, $130$0, $130$1);
      __label__ = 22; break;
    case 19: // $132
      var $133=$2;
      var $134=(($133+72)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$2;
      var $137=(($136+76)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$2;
      var $140=(($139+84)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$2;
      var $143=(($142+80)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$2;
      var $146=(($145+324)|0);
      var $147=$146;
      var $148=$device;
      var $149=$148;
      __ZN8delegateIFtR13address_spacejtEEC1ERK13delegate_baseItS1_jt8_noparamER18delegate_late_bind($7, $147, $149);
      var $150=$data;
      var $151=(($150+8)|0);
      var $st$20$0=(($151)|0);
      var $152$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($151+4)|0);
      var $152$1=HEAP32[(($st$20$1)>>2)];
      var $153=__ZN13address_space20install_read_handlerEjjjj8delegateIFtRS_jtEEy($14, $135, $138, $141, $144, $7, $152$0, $152$1);
      __label__ = 22; break;
    case 20: // $154
      var $155=$2;
      var $156=(($155+72)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$2;
      var $159=(($158+76)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=$2;
      var $162=(($161+84)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$2;
      var $165=(($164+80)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$2;
      var $168=(($167+348)|0);
      var $169=$168;
      var $170=$device;
      var $171=$170;
      __ZN8delegateIFjR13address_spacejjEEC1ERK13delegate_baseIjS1_jj8_noparamER18delegate_late_bind($8, $169, $171);
      var $172=$data;
      var $173=(($172+8)|0);
      var $st$20$0=(($173)|0);
      var $174$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($173+4)|0);
      var $174$1=HEAP32[(($st$20$1)>>2)];
      var $175=__ZN13address_space20install_read_handlerEjjjj8delegateIFjRS_jjEEy($14, $157, $160, $163, $166, $8, $174$0, $174$1);
      __label__ = 22; break;
    case 21: // $176
      var $177=$2;
      var $178=(($177+72)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$2;
      var $181=(($180+76)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$2;
      var $184=(($183+84)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$2;
      var $187=(($186+80)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$2;
      var $190=(($189+372)|0);
      var $191=$190;
      var $192=$device;
      var $193=$192;
      __ZN8delegateIFyR13address_spacejyEEC1ERK13delegate_baseIyS1_jy8_noparamER18delegate_late_bind($9, $191, $193);
      var $194=$data;
      var $195=(($194+8)|0);
      var $st$20$0=(($195)|0);
      var $196$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($195+4)|0);
      var $196$1=HEAP32[(($st$20$1)>>2)];
      var $197=__ZN13address_space20install_read_handlerEjjjj8delegateIFyRS_jyEEy($14, $179, $182, $185, $188, $9, $196$0, $196$1);
      __label__ = 22; break;
    case 22: // $198
      __label__ = 29; break;
    case 23: // $199
      var $200=$data;
      var $201=(($200+4)|0);
      var $202=HEAPU8[($201)];
      var $203=(($202)&255);
      if ($203 == 8) {
        __label__ = 24; break;
      }
      else if ($203 == 16) {
        __label__ = 25; break;
      }
      else if ($203 == 32) {
        __label__ = 26; break;
      }
      else if ($203 == 64) {
        __label__ = 27; break;
      }
      else {
      __label__ = 28; break;
      }
      
    case 24: // $204
      var $205=$2;
      var $206=(($205+72)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$2;
      var $209=(($208+76)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$2;
      var $212=(($211+84)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=$2;
      var $215=(($214+80)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=$2;
      var $218=(($217+428)|0);
      var $219=$218;
      var $220=$device;
      var $221=$220;
      __ZN8delegateIFvR13address_spacejhhEEC1ERK13delegate_baseIvS1_jhhER18delegate_late_bind($10, $219, $221);
      var $222=$data;
      var $223=(($222+8)|0);
      var $st$20$0=(($223)|0);
      var $224$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($223+4)|0);
      var $224$1=HEAP32[(($st$20$1)>>2)];
      var $225=__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jhhEEy($14, $207, $210, $213, $216, $10, $224$0, $224$1);
      __label__ = 28; break;
    case 25: // $226
      var $227=$2;
      var $228=(($227+72)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=$2;
      var $231=(($230+76)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=$2;
      var $234=(($233+84)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=$2;
      var $237=(($236+80)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$2;
      var $240=(($239+452)|0);
      var $241=$240;
      var $242=$device;
      var $243=$242;
      __ZN8delegateIFvR13address_spacejttEEC1ERK13delegate_baseIvS1_jttER18delegate_late_bind($11, $241, $243);
      var $244=$data;
      var $245=(($244+8)|0);
      var $st$20$0=(($245)|0);
      var $246$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($245+4)|0);
      var $246$1=HEAP32[(($st$20$1)>>2)];
      var $247=__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jttEEy($14, $229, $232, $235, $238, $11, $246$0, $246$1);
      __label__ = 28; break;
    case 26: // $248
      var $249=$2;
      var $250=(($249+72)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$2;
      var $253=(($252+76)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=$2;
      var $256=(($255+84)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=$2;
      var $259=(($258+80)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=$2;
      var $262=(($261+476)|0);
      var $263=$262;
      var $264=$device;
      var $265=$264;
      __ZN8delegateIFvR13address_spacejjjEEC1ERK13delegate_baseIvS1_jjjER18delegate_late_bind($12, $263, $265);
      var $266=$data;
      var $267=(($266+8)|0);
      var $st$20$0=(($267)|0);
      var $268$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($267+4)|0);
      var $268$1=HEAP32[(($st$20$1)>>2)];
      var $269=__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jjjEEy($14, $251, $254, $257, $260, $12, $268$0, $268$1);
      __label__ = 28; break;
    case 27: // $270
      var $271=$2;
      var $272=(($271+72)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=$2;
      var $275=(($274+76)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$2;
      var $278=(($277+84)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=$2;
      var $281=(($280+80)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=$2;
      var $284=(($283+500)|0);
      var $285=$284;
      var $286=$device;
      var $287=$286;
      __ZN8delegateIFvR13address_spacejyyEEC1ERK13delegate_baseIvS1_jyyER18delegate_late_bind($13, $285, $287);
      var $288=$data;
      var $289=(($288+8)|0);
      var $st$20$0=(($289)|0);
      var $290$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($289+4)|0);
      var $290$1=HEAP32[(($st$20$1)>>2)];
      var $291=__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jyyEEy($14, $273, $276, $279, $282, $13, $290$0, $290$1);
      __label__ = 28; break;
    case 28: // $292
      __label__ = 29; break;
    case 29: // $293
      __label__ = 74; break;
    case 30: // $294
      var $295=$3;
      var $296=(($295)|0)==1;
      if ($296) { __label__ = 31; break; } else { __label__ = 37; break; }
    case 31: // $297
      var $298=$data;
      var $299=(($298+4)|0);
      var $300=HEAPU8[($299)];
      var $301=(($300)&255);
      if ($301 == 8) {
        __label__ = 32; break;
      }
      else if ($301 == 16) {
        __label__ = 33; break;
      }
      else if ($301 == 32) {
        __label__ = 34; break;
      }
      else if ($301 == 64) {
        __label__ = 35; break;
      }
      else {
      __label__ = 36; break;
      }
      
    case 32: // $302
      var $303=$2;
      var $304=(($303+72)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=$2;
      var $307=(($306+76)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=$2;
      var $310=(($309+84)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=$2;
      var $313=(($312+80)|0);
      var $314=HEAP32[(($313)>>2)];
      var $315=$2;
      var $316=(($315+396)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=$data;
      var $319=(($318+16)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$data;
      var $322=(($321+8)|0);
      var $st$20$0=(($322)|0);
      var $323$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($322+4)|0);
      var $323$1=HEAP32[(($st$20$1)>>2)];
      var $324=__ZN13address_space27install_legacy_read_handlerEjjjjPFhPS_jEPKcy($14, $305, $308, $311, $314, $317, $320, $323$0, $323$1);
      __label__ = 36; break;
    case 33: // $325
      var $326=$2;
      var $327=(($326+72)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=$2;
      var $330=(($329+76)|0);
      var $331=HEAP32[(($330)>>2)];
      var $332=$2;
      var $333=(($332+84)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=$2;
      var $336=(($335+80)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=$2;
      var $339=(($338+400)|0);
      var $340=HEAP32[(($339)>>2)];
      var $341=$data;
      var $342=(($341+16)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=$data;
      var $345=(($344+8)|0);
      var $st$20$0=(($345)|0);
      var $346$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($345+4)|0);
      var $346$1=HEAP32[(($st$20$1)>>2)];
      var $347=__ZN13address_space27install_legacy_read_handlerEjjjjPFtPS_jtEPKcy($14, $328, $331, $334, $337, $340, $343, $346$0, $346$1);
      __label__ = 36; break;
    case 34: // $348
      var $349=$2;
      var $350=(($349+72)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=$2;
      var $353=(($352+76)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=$2;
      var $356=(($355+84)|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=$2;
      var $359=(($358+80)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=$2;
      var $362=(($361+404)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=$data;
      var $365=(($364+16)|0);
      var $366=HEAP32[(($365)>>2)];
      var $367=$data;
      var $368=(($367+8)|0);
      var $st$20$0=(($368)|0);
      var $369$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($368+4)|0);
      var $369$1=HEAP32[(($st$20$1)>>2)];
      var $370=__ZN13address_space27install_legacy_read_handlerEjjjjPFjPS_jjEPKcy($14, $351, $354, $357, $360, $363, $366, $369$0, $369$1);
      __label__ = 36; break;
    case 35: // $371
      var $372=$2;
      var $373=(($372+72)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=$2;
      var $376=(($375+76)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=$2;
      var $379=(($378+84)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=$2;
      var $382=(($381+80)|0);
      var $383=HEAP32[(($382)>>2)];
      var $384=$2;
      var $385=(($384+408)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=$data;
      var $388=(($387+16)|0);
      var $389=HEAP32[(($388)>>2)];
      var $390=$data;
      var $391=(($390+8)|0);
      var $st$20$0=(($391)|0);
      var $392$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($391+4)|0);
      var $392$1=HEAP32[(($st$20$1)>>2)];
      var $393=__ZN13address_space27install_legacy_read_handlerEjjjjPFyPS_jyEPKcy($14, $374, $377, $380, $383, $386, $389, $392$0, $392$1);
      __label__ = 36; break;
    case 36: // $394
      __label__ = 43; break;
    case 37: // $395
      var $396=$data;
      var $397=(($396+4)|0);
      var $398=HEAPU8[($397)];
      var $399=(($398)&255);
      if ($399 == 8) {
        __label__ = 38; break;
      }
      else if ($399 == 16) {
        __label__ = 39; break;
      }
      else if ($399 == 32) {
        __label__ = 40; break;
      }
      else if ($399 == 64) {
        __label__ = 41; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 38: // $400
      var $401=$2;
      var $402=(($401+72)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=$2;
      var $405=(($404+76)|0);
      var $406=HEAP32[(($405)>>2)];
      var $407=$2;
      var $408=(($407+84)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=$2;
      var $411=(($410+80)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=$2;
      var $414=(($413+524)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=$data;
      var $417=(($416+16)|0);
      var $418=HEAP32[(($417)>>2)];
      var $419=$data;
      var $420=(($419+8)|0);
      var $st$20$0=(($420)|0);
      var $421$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($420+4)|0);
      var $421$1=HEAP32[(($st$20$1)>>2)];
      var $422=__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jhEPKcy($14, $403, $406, $409, $412, $415, $418, $421$0, $421$1);
      __label__ = 42; break;
    case 39: // $423
      var $424=$2;
      var $425=(($424+72)|0);
      var $426=HEAP32[(($425)>>2)];
      var $427=$2;
      var $428=(($427+76)|0);
      var $429=HEAP32[(($428)>>2)];
      var $430=$2;
      var $431=(($430+84)|0);
      var $432=HEAP32[(($431)>>2)];
      var $433=$2;
      var $434=(($433+80)|0);
      var $435=HEAP32[(($434)>>2)];
      var $436=$2;
      var $437=(($436+528)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=$data;
      var $440=(($439+16)|0);
      var $441=HEAP32[(($440)>>2)];
      var $442=$data;
      var $443=(($442+8)|0);
      var $st$20$0=(($443)|0);
      var $444$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($443+4)|0);
      var $444$1=HEAP32[(($st$20$1)>>2)];
      var $445=__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jttEPKcy($14, $426, $429, $432, $435, $438, $441, $444$0, $444$1);
      __label__ = 42; break;
    case 40: // $446
      var $447=$2;
      var $448=(($447+72)|0);
      var $449=HEAP32[(($448)>>2)];
      var $450=$2;
      var $451=(($450+76)|0);
      var $452=HEAP32[(($451)>>2)];
      var $453=$2;
      var $454=(($453+84)|0);
      var $455=HEAP32[(($454)>>2)];
      var $456=$2;
      var $457=(($456+80)|0);
      var $458=HEAP32[(($457)>>2)];
      var $459=$2;
      var $460=(($459+532)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=$data;
      var $463=(($462+16)|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=$data;
      var $466=(($465+8)|0);
      var $st$20$0=(($466)|0);
      var $467$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($466+4)|0);
      var $467$1=HEAP32[(($st$20$1)>>2)];
      var $468=__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jjjEPKcy($14, $449, $452, $455, $458, $461, $464, $467$0, $467$1);
      __label__ = 42; break;
    case 41: // $469
      var $470=$2;
      var $471=(($470+72)|0);
      var $472=HEAP32[(($471)>>2)];
      var $473=$2;
      var $474=(($473+76)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=$2;
      var $477=(($476+84)|0);
      var $478=HEAP32[(($477)>>2)];
      var $479=$2;
      var $480=(($479+80)|0);
      var $481=HEAP32[(($480)>>2)];
      var $482=$2;
      var $483=(($482+536)|0);
      var $484=HEAP32[(($483)>>2)];
      var $485=$data;
      var $486=(($485+16)|0);
      var $487=HEAP32[(($486)>>2)];
      var $488=$data;
      var $489=(($488+8)|0);
      var $st$20$0=(($489)|0);
      var $490$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($489+4)|0);
      var $490$1=HEAP32[(($st$20$1)>>2)];
      var $491=__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jyyEPKcy($14, $472, $475, $478, $481, $484, $487, $490$0, $490$1);
      __label__ = 42; break;
    case 42: // $492
      __label__ = 43; break;
    case 43: // $493
      __label__ = 74; break;
    case 44: // $494
      var $495=__ZNK13address_space7machineEv($14);
      var $496=$data;
      var $497=(($496+20)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=__ZN15running_machine6deviceEPKc($495, $498);
      $device=$499;
      var $500=$device;
      var $501=(($500)|0)==0;
      if ($501) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $502
      var $503=$data;
      var $504=(($503+20)|0);
      var $505=HEAP32[(($504)>>2)];
      var $506=(($14+56)|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=(($14+12)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=__ZNK8device_t3tagEv($509);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str142905)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$505,HEAP32[((tempInt+4)>>2)]=$507,HEAP32[((tempInt+8)>>2)]=$510,tempInt));
      throw "Reached an unreachable!"
    case 46: // $511
      var $512=$3;
      var $513=(($512)|0)==1;
      if ($513) { __label__ = 47; break; } else { __label__ = 53; break; }
    case 47: // $514
      var $515=$data;
      var $516=(($515+4)|0);
      var $517=HEAPU8[($516)];
      var $518=(($517)&255);
      if ($518 == 8) {
        __label__ = 48; break;
      }
      else if ($518 == 16) {
        __label__ = 49; break;
      }
      else if ($518 == 32) {
        __label__ = 50; break;
      }
      else if ($518 == 64) {
        __label__ = 51; break;
      }
      else {
      __label__ = 52; break;
      }
      
    case 48: // $519
      var $520=$device;
      var $521=$2;
      var $522=(($521+72)|0);
      var $523=HEAP32[(($522)>>2)];
      var $524=$2;
      var $525=(($524+76)|0);
      var $526=HEAP32[(($525)>>2)];
      var $527=$2;
      var $528=(($527+84)|0);
      var $529=HEAP32[(($528)>>2)];
      var $530=$2;
      var $531=(($530+80)|0);
      var $532=HEAP32[(($531)>>2)];
      var $533=$2;
      var $534=(($533+412)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$data;
      var $537=(($536+16)|0);
      var $538=HEAP32[(($537)>>2)];
      var $539=$data;
      var $540=(($539+8)|0);
      var $st$21$0=(($540)|0);
      var $541$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($540+4)|0);
      var $541$1=HEAP32[(($st$21$1)>>2)];
      var $542=__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFhPS0_jEPKcy($14, $520, $523, $526, $529, $532, $535, $538, $541$0, $541$1);
      __label__ = 52; break;
    case 49: // $543
      var $544=$device;
      var $545=$2;
      var $546=(($545+72)|0);
      var $547=HEAP32[(($546)>>2)];
      var $548=$2;
      var $549=(($548+76)|0);
      var $550=HEAP32[(($549)>>2)];
      var $551=$2;
      var $552=(($551+84)|0);
      var $553=HEAP32[(($552)>>2)];
      var $554=$2;
      var $555=(($554+80)|0);
      var $556=HEAP32[(($555)>>2)];
      var $557=$2;
      var $558=(($557+416)|0);
      var $559=HEAP32[(($558)>>2)];
      var $560=$data;
      var $561=(($560+16)|0);
      var $562=HEAP32[(($561)>>2)];
      var $563=$data;
      var $564=(($563+8)|0);
      var $st$21$0=(($564)|0);
      var $565$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($564+4)|0);
      var $565$1=HEAP32[(($st$21$1)>>2)];
      var $566=__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFtPS0_jtEPKcy($14, $544, $547, $550, $553, $556, $559, $562, $565$0, $565$1);
      __label__ = 52; break;
    case 50: // $567
      var $568=$device;
      var $569=$2;
      var $570=(($569+72)|0);
      var $571=HEAP32[(($570)>>2)];
      var $572=$2;
      var $573=(($572+76)|0);
      var $574=HEAP32[(($573)>>2)];
      var $575=$2;
      var $576=(($575+84)|0);
      var $577=HEAP32[(($576)>>2)];
      var $578=$2;
      var $579=(($578+80)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=$2;
      var $582=(($581+420)|0);
      var $583=HEAP32[(($582)>>2)];
      var $584=$data;
      var $585=(($584+16)|0);
      var $586=HEAP32[(($585)>>2)];
      var $587=$data;
      var $588=(($587+8)|0);
      var $st$21$0=(($588)|0);
      var $589$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($588+4)|0);
      var $589$1=HEAP32[(($st$21$1)>>2)];
      var $590=__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFjPS0_jjEPKcy($14, $568, $571, $574, $577, $580, $583, $586, $589$0, $589$1);
      __label__ = 52; break;
    case 51: // $591
      var $592=$device;
      var $593=$2;
      var $594=(($593+72)|0);
      var $595=HEAP32[(($594)>>2)];
      var $596=$2;
      var $597=(($596+76)|0);
      var $598=HEAP32[(($597)>>2)];
      var $599=$2;
      var $600=(($599+84)|0);
      var $601=HEAP32[(($600)>>2)];
      var $602=$2;
      var $603=(($602+80)|0);
      var $604=HEAP32[(($603)>>2)];
      var $605=$2;
      var $606=(($605+424)|0);
      var $607=HEAP32[(($606)>>2)];
      var $608=$data;
      var $609=(($608+16)|0);
      var $610=HEAP32[(($609)>>2)];
      var $611=$data;
      var $612=(($611+8)|0);
      var $st$21$0=(($612)|0);
      var $613$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($612+4)|0);
      var $613$1=HEAP32[(($st$21$1)>>2)];
      var $614=__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFyPS0_jyEPKcy($14, $592, $595, $598, $601, $604, $607, $610, $613$0, $613$1);
      __label__ = 52; break;
    case 52: // $615
      __label__ = 59; break;
    case 53: // $616
      var $617=$data;
      var $618=(($617+4)|0);
      var $619=HEAPU8[($618)];
      var $620=(($619)&255);
      if ($620 == 8) {
        __label__ = 54; break;
      }
      else if ($620 == 16) {
        __label__ = 55; break;
      }
      else if ($620 == 32) {
        __label__ = 56; break;
      }
      else if ($620 == 64) {
        __label__ = 57; break;
      }
      else {
      __label__ = 58; break;
      }
      
    case 54: // $621
      var $622=$device;
      var $623=$2;
      var $624=(($623+72)|0);
      var $625=HEAP32[(($624)>>2)];
      var $626=$2;
      var $627=(($626+76)|0);
      var $628=HEAP32[(($627)>>2)];
      var $629=$2;
      var $630=(($629+84)|0);
      var $631=HEAP32[(($630)>>2)];
      var $632=$2;
      var $633=(($632+80)|0);
      var $634=HEAP32[(($633)>>2)];
      var $635=$2;
      var $636=(($635+540)|0);
      var $637=HEAP32[(($636)>>2)];
      var $638=$data;
      var $639=(($638+16)|0);
      var $640=HEAP32[(($639)>>2)];
      var $641=$data;
      var $642=(($641+8)|0);
      var $st$21$0=(($642)|0);
      var $643$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($642+4)|0);
      var $643$1=HEAP32[(($st$21$1)>>2)];
      var $644=__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jhEPKcy($14, $622, $625, $628, $631, $634, $637, $640, $643$0, $643$1);
      __label__ = 58; break;
    case 55: // $645
      var $646=$device;
      var $647=$2;
      var $648=(($647+72)|0);
      var $649=HEAP32[(($648)>>2)];
      var $650=$2;
      var $651=(($650+76)|0);
      var $652=HEAP32[(($651)>>2)];
      var $653=$2;
      var $654=(($653+84)|0);
      var $655=HEAP32[(($654)>>2)];
      var $656=$2;
      var $657=(($656+80)|0);
      var $658=HEAP32[(($657)>>2)];
      var $659=$2;
      var $660=(($659+544)|0);
      var $661=HEAP32[(($660)>>2)];
      var $662=$data;
      var $663=(($662+16)|0);
      var $664=HEAP32[(($663)>>2)];
      var $665=$data;
      var $666=(($665+8)|0);
      var $st$21$0=(($666)|0);
      var $667$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($666+4)|0);
      var $667$1=HEAP32[(($st$21$1)>>2)];
      var $668=__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jttEPKcy($14, $646, $649, $652, $655, $658, $661, $664, $667$0, $667$1);
      __label__ = 58; break;
    case 56: // $669
      var $670=$device;
      var $671=$2;
      var $672=(($671+72)|0);
      var $673=HEAP32[(($672)>>2)];
      var $674=$2;
      var $675=(($674+76)|0);
      var $676=HEAP32[(($675)>>2)];
      var $677=$2;
      var $678=(($677+84)|0);
      var $679=HEAP32[(($678)>>2)];
      var $680=$2;
      var $681=(($680+80)|0);
      var $682=HEAP32[(($681)>>2)];
      var $683=$2;
      var $684=(($683+548)|0);
      var $685=HEAP32[(($684)>>2)];
      var $686=$data;
      var $687=(($686+16)|0);
      var $688=HEAP32[(($687)>>2)];
      var $689=$data;
      var $690=(($689+8)|0);
      var $st$21$0=(($690)|0);
      var $691$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($690+4)|0);
      var $691$1=HEAP32[(($st$21$1)>>2)];
      var $692=__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jjjEPKcy($14, $670, $673, $676, $679, $682, $685, $688, $691$0, $691$1);
      __label__ = 58; break;
    case 57: // $693
      var $694=$device;
      var $695=$2;
      var $696=(($695+72)|0);
      var $697=HEAP32[(($696)>>2)];
      var $698=$2;
      var $699=(($698+76)|0);
      var $700=HEAP32[(($699)>>2)];
      var $701=$2;
      var $702=(($701+84)|0);
      var $703=HEAP32[(($702)>>2)];
      var $704=$2;
      var $705=(($704+80)|0);
      var $706=HEAP32[(($705)>>2)];
      var $707=$2;
      var $708=(($707+552)|0);
      var $709=HEAP32[(($708)>>2)];
      var $710=$data;
      var $711=(($710+16)|0);
      var $712=HEAP32[(($711)>>2)];
      var $713=$data;
      var $714=(($713+8)|0);
      var $st$21$0=(($714)|0);
      var $715$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($714+4)|0);
      var $715$1=HEAP32[(($st$21$1)>>2)];
      var $716=__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jyyEPKcy($14, $694, $697, $700, $703, $706, $709, $712, $715$0, $715$1);
      __label__ = 58; break;
    case 58: // $717
      __label__ = 59; break;
    case 59: // $718
      __label__ = 74; break;
    case 60: // $719
      var $720=$2;
      var $721=(($720+72)|0);
      var $722=HEAP32[(($721)>>2)];
      var $723=$2;
      var $724=(($723+76)|0);
      var $725=HEAP32[(($724)>>2)];
      var $726=$2;
      var $727=(($726+84)|0);
      var $728=HEAP32[(($727)>>2)];
      var $729=$2;
      var $730=(($729+80)|0);
      var $731=HEAP32[(($730)>>2)];
      var $732=$3;
      var $733=(($732)|0)==1;
      if ($733) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $734
      var $735=$data;
      var $736=(($735+20)|0);
      var $737=HEAP32[(($736)>>2)];
      var $740 = $737;__label__ = 63; break;
    case 62: // $738
      var $740 = 0;__label__ = 63; break;
    case 63: // $739
      var $740;
      var $741=$3;
      var $742=(($741)|0)==2;
      if ($742) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $743
      var $744=$data;
      var $745=(($744+20)|0);
      var $746=HEAP32[(($745)>>2)];
      var $749 = $746;__label__ = 66; break;
    case 65: // $747
      var $749 = 0;__label__ = 66; break;
    case 66: // $748
      var $749;
      __ZN13address_space22install_readwrite_portEjjjjPKcS1_($14, $722, $725, $728, $731, $740, $749);
      __label__ = 74; break;
    case 67: // $750
      var $751=$2;
      var $752=(($751+72)|0);
      var $753=HEAP32[(($752)>>2)];
      var $754=$2;
      var $755=(($754+76)|0);
      var $756=HEAP32[(($755)>>2)];
      var $757=$2;
      var $758=(($757+84)|0);
      var $759=HEAP32[(($758)>>2)];
      var $760=$2;
      var $761=(($760+80)|0);
      var $762=HEAP32[(($761)>>2)];
      var $763=$3;
      var $764=(($763)|0)==1;
      if ($764) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $765
      var $766=$data;
      var $767=(($766+20)|0);
      var $768=HEAP32[(($767)>>2)];
      var $771 = $768;__label__ = 70; break;
    case 69: // $769
      var $771 = 0;__label__ = 70; break;
    case 70: // $770
      var $771;
      var $772=$3;
      var $773=(($772)|0)==2;
      if ($773) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $774
      var $775=$data;
      var $776=(($775+20)|0);
      var $777=HEAP32[(($776)>>2)];
      var $780 = $777;__label__ = 73; break;
    case 72: // $778
      var $780 = 0;__label__ = 73; break;
    case 73: // $779
      var $780;
      __ZN13address_space20install_bank_genericEjjjjPKcS1_($14, $753, $756, $759, $762, $771, $780);
      __label__ = 74; break;
    case 74: // $781
      STACKTOP = __stackBase__;
      return;
    case 75: // $782
      var $783=$4;
      var $784=$4;
      var $785=$5;
      var $786=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $784, tempValue);
      var $787=($786.f1 = $785, $786);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space18populate_map_entryERK17address_map_entry13read_or_write["X"]=1;

function __ZN13address_space13unmap_genericEjjjj13read_or_writeb($this, $addrstart, $addrend, $addrmask, $addrmirror, $readorwrite, $quiet) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$readorwrite;
      var $8=(($quiet)&1);
      $7=$8;
      var $9=$1;
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=$6;
      var $13=(($12)|0)==1;
      if ($13) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $14
      var $15=$6;
      var $16=(($15)|0)==3;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$9;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+132)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=FUNCTION_TABLE[$21]($9);
      var $23=$22;
      var $24=$2;
      var $25=$3;
      var $26=$4;
      var $27=$5;
      var $28=$7;
      var $29=(($28) & 1);
      var $30=$29 ? 125 : 126;
      var $31=(($30) & 255);
      __ZN13address_table9map_rangeEjjjjh($23, $24, $25, $26, $27, $31);
      __label__ = 5; break;
    case 5: // $32
      var $33=$6;
      var $34=(($33)|0)==2;
      if ($34) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $35
      var $36=$6;
      var $37=(($36)|0)==3;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      var $39=$9;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+136)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=FUNCTION_TABLE[$42]($9);
      var $44=$43;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      var $48=$5;
      var $49=$7;
      var $50=(($49) & 1);
      var $51=$50 ? 125 : 126;
      var $52=(($51) & 255);
      __ZN13address_table9map_rangeEjjjjh($44, $45, $46, $47, $48, $52);
      __label__ = 8; break;
    case 8: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space13unmap_genericEjjjj13read_or_writeb["X"]=1;

function __ZN8delegateIFhR13address_spacejhEEC1ERK13delegate_baseIhS1_jh8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFhR13address_spacejhEEC2ERK13delegate_baseIhS1_jh8_noparamER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN8delegateIFtR13address_spacejtEEC1ERK13delegate_baseItS1_jt8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFtR13address_spacejtEEC2ERK13delegate_baseItS1_jt8_noparamER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN8delegateIFjR13address_spacejjEEC1ERK13delegate_baseIjS1_jj8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFjR13address_spacejjEEC2ERK13delegate_baseIjS1_jj8_noparamER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEC1ERK13delegate_baseIyS1_jy8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFyR13address_spacejyEEC2ERK13delegate_baseIyS1_jy8_noparamER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN13address_space19install_ram_genericEjjjj13read_or_writePv($this, $addrstart, $addrend, $addrmask, $addrmirror, $readorwrite, $baseptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i4=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $memdata;
      var $bank;
      var $backing;
      var $block;
      var $24;
      var $25;
      var $bank1;
      var $backing2;
      var $block3;
      $17=$this;
      $18=$addrstart;
      $19=$addrend;
      $20=$addrmask;
      $21=$addrmirror;
      $22=$readorwrite;
      $23=$baseptr;
      var $26=$17;
      var $27=__ZNK13address_space7machineEv($26);
      var $28=(($27+624)|0);
      var $29=HEAP32[(($28)>>2)];
      $memdata=$29;
      __label__ = 1; break;
    case 1: // $30
      __label__ = 2; break;
    case 2: // $31
      var $32=$22;
      var $33=(($32)|0)==1;
      if ($33) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $34
      var $35=$22;
      var $36=(($35)|0)==3;
      if ($36) { __label__ = 4; break; } else { __label__ = 31; break; }
    case 4: // $37
      var $38=$18;
      var $39=$19;
      var $40=$20;
      var $41=$21;
      var $42=__ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write($26, 0, $38, $39, $40, $41, 1);
      $bank=$42;
      var $43=$26;
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+132)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=FUNCTION_TABLE[$46]($26);
      var $48=$47;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      var $52=$21;
      var $53=$bank;
      var $54=__ZNK11memory_bank5indexEv($53);
      var $55=(($54) & 255);
      __ZN13address_table9map_rangeEjjjjh($48, $49, $50, $51, $52, $55);
      var $56=$23;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$bank;
      var $60=$23;
      __ZN11memory_bank8set_baseEPv($59, $60);
      __label__ = 6; break;
    case 6: // $61
      var $62=$bank;
      var $63=__ZNK11memory_bank4baseEv($62);
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $65
      var $66=$18;
      var $67=$19;
      var $68=__ZN13address_space19find_backing_memoryEjj($26, $66, $67);
      $backing=$68;
      var $69=$backing;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $71
      var $72=$bank;
      var $73=$backing;
      __ZN11memory_bank8set_baseEPv($72, $73);
      __label__ = 9; break;
    case 9: // $74
      __label__ = 10; break;
    case 10: // $75
      var $76=$bank;
      var $77=__ZNK11memory_bank4baseEv($76);
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 11; break; } else { __label__ = 30; break; }
    case 11: // $79
      var $80=$memdata;
      var $81=(($80)|0);
      var $82=HEAP8[($81)];
      var $83=(($82) & 1);
      if ($83) { __label__ = 12; break; } else { __label__ = 30; break; }
    case 12: // $84
      var $85=__ZNK13address_space7machineEv($26);
      var $86=__ZNK15running_machine5phaseEv($85);
      var $87=(($86)|0) >= 2;
      if ($87) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $88
      __Z10fatalerrorPKcz(((STRING_TABLE.__str242915)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 14: // $89
      var $90=$memdata;
      var $91=(($90+1048)|0);
      var $92=__ZNK13address_space7machineEv($26);
      var $93=__ZN15running_machine7respoolEv($92);
      var $94=$12;
      var $95=$13;
      var $96=$14;
      var $97=$result_i;
      var $98=$15;
      var $99=$16;
      HEAP32[(($12)>>2)]=28;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($14)>>2)]=2757;
      var $100=HEAP32[(($12)>>2)];
      var $101=HEAP32[(($13)>>2)];
      var $102=HEAP32[(($14)>>2)];
      var $103=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($100, $101, $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $104
      HEAP32[(($result_i)>>2)]=$103;
      var $105=HEAP32[(($result_i)>>2)];
      var $106=(($105)|0)==0;
      if ($106) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $107
      var $108=___cxa_allocate_exception(4);
      var $109=$108;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($109);
      (function() { try { __THREW__ = false; return ___cxa_throw($108, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 17; break; }
    case 17: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $112=$111.f0;
      HEAP32[(($15)>>2)]=$112;
      var $113=$111.f1;
      HEAP32[(($16)>>2)]=$113;
      var $114=HEAP32[(($16)>>2)];
      var $115=(($114)|0) < 0;
      if ($115) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $116
      var $117=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($117);
      throw "Reached an unreachable!"
    case 19: // $118
      var $119=HEAP32[(($15)>>2)];
      var $120=HEAP32[(($15)>>2)];
      var $121=HEAP32[(($16)>>2)];
      var $122=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $120, tempValue);
      var $123=($122.f1 = $121, $122);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $124
      throw "Reached an unreachable!"
    case 21: // $_ZnwjPKci_exit
      var $125=HEAP32[(($result_i)>>2)];
      var $126=$12;
      var $127=$13;
      var $128=$14;
      var $129=$result_i;
      var $130=$15;
      var $131=$16;
      var $132=$125;
      var $133=$18;
      var $134=(function() { try { __THREW__ = false; return __ZNK13address_space15address_to_byteEj($26, $133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 25; break; };
    case 22: // $135
      var $136=$19;
      var $137=(function() { try { __THREW__ = false; return __ZNK13address_space19address_to_byte_endEj($26, $136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; };
    case 23: // $138
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12memory_blockC1ER13address_spacejjPv]($132, $26, $134, $137, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $139
      var $140=__ZN13resource_pool10add_objectI12memory_blockEEPT_S3_($93, $132);
      var $141=__ZN11simple_listI12memory_blockE6appendERS0_($91, $140);
      $block=$141;
      var $142=$bank;
      var $143=$block;
      var $144=__ZNK12memory_block4dataEv($143);
      __ZN11memory_bank8set_baseEPv($142, $144);
      __label__ = 30; break;
    case 25: // $145
      var $146=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $147=$146.f0;
      $24=$147;
      var $148=$146.f1;
      $25=$148;
      var $149=$9;
      var $150=$10;
      var $151=$11;
      HEAP32[(($9)>>2)]=$125;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($11)>>2)]=2757;
      var $152=HEAP32[(($9)>>2)];
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $154
      var $155=HEAP32[(($9)>>2)];
      var $156=HEAP32[(($10)>>2)];
      var $157=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($155, $156, $157) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 62; break; }
    case 27: // $_noexc
      __label__ = 28; break;
    case 28: // $_ZdlPvPKci_exit
      var $158=$9;
      var $159=$10;
      var $160=$11;
      __label__ = 29; break;
    case 29: // $161
      __label__ = 61; break;
    case 30: // $162
      __label__ = 31; break;
    case 31: // $163
      var $164=$22;
      var $165=(($164)|0)==2;
      if ($165) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $166
      var $167=$22;
      var $168=(($167)|0)==3;
      if ($168) { __label__ = 33; break; } else { __label__ = 60; break; }
    case 33: // $169
      var $170=$18;
      var $171=$19;
      var $172=$20;
      var $173=$21;
      var $174=__ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write($26, 0, $170, $171, $172, $173, 2);
      $bank1=$174;
      var $175=$26;
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176+136)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=FUNCTION_TABLE[$178]($26);
      var $180=$179;
      var $181=$18;
      var $182=$19;
      var $183=$20;
      var $184=$21;
      var $185=$bank1;
      var $186=__ZNK11memory_bank5indexEv($185);
      var $187=(($186) & 255);
      __ZN13address_table9map_rangeEjjjjh($180, $181, $182, $183, $184, $187);
      var $188=$23;
      var $189=(($188)|0)!=0;
      if ($189) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $190
      var $191=$bank1;
      var $192=$23;
      __ZN11memory_bank8set_baseEPv($191, $192);
      __label__ = 35; break;
    case 35: // $193
      var $194=$bank1;
      var $195=__ZNK11memory_bank4baseEv($194);
      var $196=(($195)|0)==0;
      if ($196) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $197
      var $198=$18;
      var $199=$19;
      var $200=__ZN13address_space19find_backing_memoryEjj($26, $198, $199);
      $backing2=$200;
      var $201=$backing2;
      var $202=(($201)|0)!=0;
      if ($202) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $203
      var $204=$bank1;
      var $205=$backing2;
      __ZN11memory_bank8set_baseEPv($204, $205);
      __label__ = 38; break;
    case 38: // $206
      __label__ = 39; break;
    case 39: // $207
      var $208=$bank1;
      var $209=__ZNK11memory_bank4baseEv($208);
      var $210=(($209)|0)==0;
      if ($210) { __label__ = 40; break; } else { __label__ = 59; break; }
    case 40: // $211
      var $212=$memdata;
      var $213=(($212)|0);
      var $214=HEAP8[($213)];
      var $215=(($214) & 1);
      if ($215) { __label__ = 41; break; } else { __label__ = 59; break; }
    case 41: // $216
      var $217=__ZNK13address_space7machineEv($26);
      var $218=__ZNK15running_machine5phaseEv($217);
      var $219=(($218)|0) >= 2;
      if ($219) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $220
      __Z10fatalerrorPKcz(((STRING_TABLE.__str242915)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 43: // $221
      var $222=$memdata;
      var $223=(($222+1048)|0);
      var $224=__ZNK13address_space7machineEv($26);
      var $225=__ZN15running_machine7respoolEv($224);
      var $226=$4;
      var $227=$5;
      var $228=$6;
      var $229=$result_i4;
      var $230=$7;
      var $231=$8;
      HEAP32[(($4)>>2)]=28;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=2786;
      var $232=HEAP32[(($4)>>2)];
      var $233=HEAP32[(($5)>>2)];
      var $234=HEAP32[(($6)>>2)];
      var $235=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($232, $233, $234) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; };
    case 44: // $236
      HEAP32[(($result_i4)>>2)]=$235;
      var $237=HEAP32[(($result_i4)>>2)];
      var $238=(($237)|0)==0;
      if ($238) { __label__ = 45; break; } else { __label__ = 50; break; }
    case 45: // $239
      var $240=___cxa_allocate_exception(4);
      var $241=$240;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($241);
      (function() { try { __THREW__ = false; return ___cxa_throw($240, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 46; break; }
    case 46: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $244=$243.f0;
      HEAP32[(($7)>>2)]=$244;
      var $245=$243.f1;
      HEAP32[(($8)>>2)]=$245;
      var $246=HEAP32[(($8)>>2)];
      var $247=(($246)|0) < 0;
      if ($247) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $248
      var $249=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($249);
      throw "Reached an unreachable!"
    case 48: // $250
      var $251=HEAP32[(($7)>>2)];
      var $252=HEAP32[(($7)>>2)];
      var $253=HEAP32[(($8)>>2)];
      var $254=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $252, tempValue);
      var $255=($254.f1 = $253, $254);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $256
      throw "Reached an unreachable!"
    case 50: // $_ZnwjPKci_exit5
      var $257=HEAP32[(($result_i4)>>2)];
      var $258=$4;
      var $259=$5;
      var $260=$6;
      var $261=$result_i4;
      var $262=$7;
      var $263=$8;
      var $264=$257;
      var $265=$18;
      var $266=(function() { try { __THREW__ = false; return __ZNK13address_space15address_to_byteEj($26, $265) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 54; break; };
    case 51: // $267
      var $268=$19;
      var $269=(function() { try { __THREW__ = false; return __ZNK13address_space19address_to_byte_endEj($26, $268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 54; break; };
    case 52: // $270
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12memory_blockC1ER13address_spacejjPv]($264, $26, $266, $269, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $271
      var $272=__ZN13resource_pool10add_objectI12memory_blockEEPT_S3_($225, $264);
      var $273=__ZN11simple_listI12memory_blockE6appendERS0_($223, $272);
      $block3=$273;
      var $274=$bank1;
      var $275=$block3;
      var $276=__ZNK12memory_block4dataEv($275);
      __ZN11memory_bank8set_baseEPv($274, $276);
      __label__ = 59; break;
    case 54: // $277
      var $278=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $279=$278.f0;
      $24=$279;
      var $280=$278.f1;
      $25=$280;
      var $281=$1;
      var $282=$2;
      var $283=$3;
      HEAP32[(($1)>>2)]=$257;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=2786;
      var $284=HEAP32[(($1)>>2)];
      var $285=(($284)|0)!=0;
      if ($285) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $286
      var $287=HEAP32[(($1)>>2)];
      var $288=HEAP32[(($2)>>2)];
      var $289=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($287, $288, $289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 62; break; }
    case 56: // $_noexc6
      __label__ = 57; break;
    case 57: // $_ZdlPvPKci_exit7
      var $290=$1;
      var $291=$2;
      var $292=$3;
      __label__ = 58; break;
    case 58: // $293
      __label__ = 61; break;
    case 59: // $294
      __label__ = 60; break;
    case 60: // $295
      var $296=$18;
      var $297=$19;
      var $298=__ZN13address_space19find_backing_memoryEjj($26, $296, $297);
      STACKTOP = __stackBase__;
      return $298;
    case 61: // $299
      var $300=$24;
      var $301=$24;
      var $302=$25;
      var $303=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $301, tempValue);
      var $304=($303.f1 = $302, $303);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $305
      var $306=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space19install_ram_genericEjjjj13read_or_writePv["X"]=1;

function __ZN13address_space20install_read_handlerEjjjj8delegateIFhRS_jhEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      __label__ = 1; break;
    case 1: // $12
      __label__ = 2; break;
    case 2: // $13
      var $14=$11;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+132)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($11);
      var $19=$2;
      var $20=$3;
      var $21=$4;
      var $22=$5;
      var $st$9$0=(($6)|0);
      var $23$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($6+4)|0);
      var $23$1=HEAP32[(($st$9$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($7, $18, $19, $20, $21, $22, $23$0, $23$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFhR13address_spacejhEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $24
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFhR13address_spacejhEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7);
      var $26=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($11, $27, $28);
      STACKTOP = __stackBase__;
      return $29;
    case 5: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $9=$32;
      var $33=$31.f1;
      $10=$33;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $34
      __label__ = 7; break;
    case 7: // $35
      var $36=$9;
      var $37=$9;
      var $38=$10;
      var $39=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37, tempValue);
      var $40=($39.f1 = $38, $39);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space20install_read_handlerEjjjj8delegateIFhRS_jhEEy["X"]=1;

function __ZN13address_space20install_read_handlerEjjjj8delegateIFtRS_jtEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+132)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $st$29$0=(($6)|0);
      var $21$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($6+4)|0);
      var $21$1=HEAP32[(($st$29$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($7, $16, $17, $18, $19, $20, $21$0, $21$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFtR13address_spacejtEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFtR13address_spacejtEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7);
      var $24=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($24);
      var $25=$2;
      var $26=$3;
      var $27=__ZN13address_space19find_backing_memoryEjj($11, $25, $26);
      var $28=$27;
      STACKTOP = __stackBase__;
      return $28;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $9=$31;
      var $32=$30.f1;
      $10=$32;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$9;
      var $36=$9;
      var $37=$10;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space20install_read_handlerEjjjj8delegateIFtRS_jtEEy["X"]=1;

function __ZN13address_space20install_read_handlerEjjjj8delegateIFjRS_jjEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+132)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $st$29$0=(($6)|0);
      var $21$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($6+4)|0);
      var $21$1=HEAP32[(($st$29$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($7, $16, $17, $18, $19, $20, $21$0, $21$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFjR13address_spacejjEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFjR13address_spacejjEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7);
      var $24=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($24);
      var $25=$2;
      var $26=$3;
      var $27=__ZN13address_space19find_backing_memoryEjj($11, $25, $26);
      var $28=$27;
      STACKTOP = __stackBase__;
      return $28;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $9=$31;
      var $32=$30.f1;
      $10=$32;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$9;
      var $36=$9;
      var $37=$10;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space20install_read_handlerEjjjj8delegateIFjRS_jjEEy["X"]=1;

function __ZN13address_space20install_read_handlerEjjjj8delegateIFyRS_jyEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+132)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $st$29$0=(($6)|0);
      var $21$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($6+4)|0);
      var $21$1=HEAP32[(($st$29$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($7, $16, $17, $18, $19, $20, $21$0, $21$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFyR13address_spacejyEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFyR13address_spacejyEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7);
      var $24=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($24);
      var $25=$2;
      var $26=$3;
      var $27=__ZN13address_space19find_backing_memoryEjj($11, $25, $26);
      var $28=$27;
      STACKTOP = __stackBase__;
      return $28;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $9=$31;
      var $32=$30.f1;
      $10=$32;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$9;
      var $36=$9;
      var $37=$10;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space20install_read_handlerEjjjj8delegateIFyRS_jyEEy["X"]=1;

function __ZN8delegateIFvR13address_spacejhhEEC1ERK13delegate_baseIvS1_jhhER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFvR13address_spacejhhEEC2ERK13delegate_baseIvS1_jhhER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejttEEC1ERK13delegate_baseIvS1_jttER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFvR13address_spacejttEEC2ERK13delegate_baseIvS1_jttER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejjjEEC1ERK13delegate_baseIvS1_jjjER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFvR13address_spacejjjEEC2ERK13delegate_baseIvS1_jjjER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejyyEEC1ERK13delegate_baseIvS1_jyyER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN8delegateIFvR13address_spacejyyEEC2ERK13delegate_baseIvS1_jyyER18delegate_late_bind($4, $5, $6);
  ;
  return;
}


function __ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jhhEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      __label__ = 1; break;
    case 1: // $12
      __label__ = 2; break;
    case 2: // $13
      var $14=$11;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+136)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($11);
      var $19=$2;
      var $20=$3;
      var $21=$4;
      var $22=$5;
      var $st$9$0=(($6)|0);
      var $23$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($6+4)|0);
      var $23$1=HEAP32[(($st$9$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($7, $18, $19, $20, $21, $22, $23$0, $23$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejhhEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $24
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejhhEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7);
      var $26=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($11, $27, $28);
      STACKTOP = __stackBase__;
      return $29;
    case 5: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $9=$32;
      var $33=$31.f1;
      $10=$33;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $34
      __label__ = 7; break;
    case 7: // $35
      var $36=$9;
      var $37=$9;
      var $38=$10;
      var $39=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37, tempValue);
      var $40=($39.f1 = $38, $39);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jhhEEy["X"]=1;

function __ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jttEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+136)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $st$29$0=(($6)|0);
      var $21$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($6+4)|0);
      var $21$1=HEAP32[(($st$29$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($7, $16, $17, $18, $19, $20, $21$0, $21$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejttEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejttEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7);
      var $24=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($24);
      var $25=$2;
      var $26=$3;
      var $27=__ZN13address_space19find_backing_memoryEjj($11, $25, $26);
      var $28=$27;
      STACKTOP = __stackBase__;
      return $28;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $9=$31;
      var $32=$30.f1;
      $10=$32;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$9;
      var $36=$9;
      var $37=$10;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jttEEy["X"]=1;

function __ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jjjEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+136)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $st$29$0=(($6)|0);
      var $21$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($6+4)|0);
      var $21$1=HEAP32[(($st$29$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($7, $16, $17, $18, $19, $20, $21$0, $21$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejjjEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejjjEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7);
      var $24=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($24);
      var $25=$2;
      var $26=$3;
      var $27=__ZN13address_space19find_backing_memoryEjj($11, $25, $26);
      var $28=$27;
      STACKTOP = __stackBase__;
      return $28;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $9=$31;
      var $32=$30.f1;
      $10=$32;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$9;
      var $36=$9;
      var $37=$10;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jjjEEy["X"]=1;

function __ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jyyEEy($this, $addrstart, $addrend, $addrmask, $addrmirror, $handler, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7=__stackBase__+8;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$15$0=(($6)|0);
      HEAP32[(($st$15$0)>>2)]=$unitmask$0;
      var $st$15$1=(($6+4)|0);
      HEAP32[(($st$15$1)>>2)]=$unitmask$1;
      var $11=$1;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+136)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=FUNCTION_TABLE[$15]($11);
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $st$29$0=(($6)|0);
      var $21$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($6+4)|0);
      var $21$1=HEAP32[(($st$29$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($7, $16, $17, $18, $19, $20, $21$0, $21$1);
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejyyEEC1ERKS3_($8, $handler) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejyyEEEEvT_($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7);
      var $24=__ZNK13address_space7machineEv($11);
      __ZL16generate_memdumpR15running_machine($24);
      var $25=$2;
      var $26=$3;
      var $27=__ZN13address_space19find_backing_memoryEjj($11, $25, $26);
      var $28=$27;
      STACKTOP = __stackBase__;
      return $28;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $9=$31;
      var $32=$30.f1;
      $10=$32;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      __label__ = 5; break;
    case 5: // $34
      var $35=$9;
      var $36=$9;
      var $37=$10;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jyyEEy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerEjjjjPFhPS_jEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$rhandler;
      $7=$rname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      __label__ = 1; break;
    case 1: // $13
      __label__ = 2; break;
    case 2: // $14
      var $15=$12;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+132)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=FUNCTION_TABLE[$18]($12);
      var $20=$2;
      var $21=$3;
      var $22=$4;
      var $23=$5;
      var $st$9$0=(($8)|0);
      var $24$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($8+4)|0);
      var $24$1=HEAP32[(($st$9$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($9, $19, $20, $21, $22, $23, $24$0, $24$1);
      var $25=$6;
      var $26=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP13address_spacejEEEvRS3_T_PKc($9, $12, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9);
      var $28=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$2;
      var $30=$3;
      var $31=__ZN13address_space19find_backing_memoryEjj($12, $29, $30);
      STACKTOP = __stackBase__;
      return $31;
    case 4: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $10=$34;
      var $35=$33.f1;
      $11=$35;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $36
      __label__ = 6; break;
    case 6: // $37
      var $38=$10;
      var $39=$10;
      var $40=$11;
      var $41=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39, tempValue);
      var $42=($41.f1 = $40, $41);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerEjjjjPFhPS_jEPKcy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerEjjjjPFtPS_jtEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$rhandler;
      $7=$rname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+132)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $st$32$0=(($8)|0);
      var $22$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($8+4)|0);
      var $22$1=HEAP32[(($st$32$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($9, $17, $18, $19, $20, $21, $22$0, $22$1);
      var $23=$6;
      var $24=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP13address_spacejtEEEvRS3_T_PKc($9, $12, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9);
      var $26=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($12, $27, $28);
      var $30=$29;
      STACKTOP = __stackBase__;
      return $30;
    case 2: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $10=$33;
      var $34=$32.f1;
      $11=$34;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $35
      __label__ = 4; break;
    case 4: // $36
      var $37=$10;
      var $38=$10;
      var $39=$11;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerEjjjjPFtPS_jtEPKcy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerEjjjjPFjPS_jjEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$rhandler;
      $7=$rname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+132)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $st$32$0=(($8)|0);
      var $22$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($8+4)|0);
      var $22$1=HEAP32[(($st$32$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($9, $17, $18, $19, $20, $21, $22$0, $22$1);
      var $23=$6;
      var $24=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP13address_spacejjEEEvRS3_T_PKc($9, $12, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9);
      var $26=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($12, $27, $28);
      var $30=$29;
      STACKTOP = __stackBase__;
      return $30;
    case 2: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $10=$33;
      var $34=$32.f1;
      $11=$34;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $35
      __label__ = 4; break;
    case 4: // $36
      var $37=$10;
      var $38=$10;
      var $39=$11;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerEjjjjPFjPS_jjEPKcy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerEjjjjPFyPS_jyEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$rhandler;
      $7=$rname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+132)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $st$32$0=(($8)|0);
      var $22$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($8+4)|0);
      var $22$1=HEAP32[(($st$32$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($9, $17, $18, $19, $20, $21, $22$0, $22$1);
      var $23=$6;
      var $24=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP13address_spacejyEEEvRS3_T_PKc($9, $12, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9);
      var $26=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($12, $27, $28);
      var $30=$29;
      STACKTOP = __stackBase__;
      return $30;
    case 2: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $10=$33;
      var $34=$32.f1;
      $11=$34;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $35
      __label__ = 4; break;
    case 4: // $36
      var $37=$10;
      var $38=$10;
      var $39=$11;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerEjjjjPFyPS_jyEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jhEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$whandler;
      $7=$wname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      __label__ = 1; break;
    case 1: // $13
      __label__ = 2; break;
    case 2: // $14
      var $15=$12;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+136)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=FUNCTION_TABLE[$18]($12);
      var $20=$2;
      var $21=$3;
      var $22=$4;
      var $23=$5;
      var $st$9$0=(($8)|0);
      var $24$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($8+4)|0);
      var $24$1=HEAP32[(($st$9$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($9, $19, $20, $21, $22, $23, $24$0, $24$1);
      var $25=$6;
      var $26=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejhEEEvRS3_T_PKc($9, $12, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9);
      var $28=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$2;
      var $30=$3;
      var $31=__ZN13address_space19find_backing_memoryEjj($12, $29, $30);
      STACKTOP = __stackBase__;
      return $31;
    case 4: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $10=$34;
      var $35=$33.f1;
      $11=$35;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $36
      __label__ = 6; break;
    case 6: // $37
      var $38=$10;
      var $39=$10;
      var $40=$11;
      var $41=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39, tempValue);
      var $42=($41.f1 = $40, $41);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jhEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jttEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$whandler;
      $7=$wname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+136)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $st$32$0=(($8)|0);
      var $22$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($8+4)|0);
      var $22$1=HEAP32[(($st$32$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($9, $17, $18, $19, $20, $21, $22$0, $22$1);
      var $23=$6;
      var $24=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejttEEEvRS3_T_PKc($9, $12, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9);
      var $26=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($12, $27, $28);
      var $30=$29;
      STACKTOP = __stackBase__;
      return $30;
    case 2: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $10=$33;
      var $34=$32.f1;
      $11=$34;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $35
      __label__ = 4; break;
    case 4: // $36
      var $37=$10;
      var $38=$10;
      var $39=$11;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jttEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jjjEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$whandler;
      $7=$wname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+136)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $st$32$0=(($8)|0);
      var $22$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($8+4)|0);
      var $22$1=HEAP32[(($st$32$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($9, $17, $18, $19, $20, $21, $22$0, $22$1);
      var $23=$6;
      var $24=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejjjEEEvRS3_T_PKc($9, $12, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9);
      var $26=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($12, $27, $28);
      var $30=$29;
      STACKTOP = __stackBase__;
      return $30;
    case 2: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $10=$33;
      var $34=$32.f1;
      $11=$34;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $35
      __label__ = 4; break;
    case 4: // $36
      var $37=$10;
      var $38=$10;
      var $39=$11;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jjjEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jyyEPKcy($this, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8=__stackBase__;
      var $9=__stackBase__+8;
      var $10;
      var $11;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$whandler;
      $7=$wname;
      var $st$18$0=(($8)|0);
      HEAP32[(($st$18$0)>>2)]=$unitmask$0;
      var $st$18$1=(($8+4)|0);
      HEAP32[(($st$18$1)>>2)]=$unitmask$1;
      var $12=$1;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+136)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=FUNCTION_TABLE[$16]($12);
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $st$32$0=(($8)|0);
      var $22$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($8+4)|0);
      var $22$1=HEAP32[(($st$32$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($9, $17, $18, $19, $20, $21, $22$0, $22$1);
      var $23=$6;
      var $24=$7;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejyyEEEvRS3_T_PKc($9, $12, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9);
      var $26=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($26);
      var $27=$2;
      var $28=$3;
      var $29=__ZN13address_space19find_backing_memoryEjj($12, $27, $28);
      var $30=$29;
      STACKTOP = __stackBase__;
      return $30;
    case 2: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $10=$33;
      var $34=$32.f1;
      $11=$34;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $35
      __label__ = 4; break;
    case 4: // $36
      var $37=$10;
      var $38=$10;
      var $39=$11;
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jyyEPKcy["X"]=1;

function __ZNK11simple_listI12memory_blockE4lastEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI12memory_blockE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_space20install_bank_genericEjjjjPKcS1_($this, $addrstart, $addrend, $addrmask, $addrmirror, $rtag, $wtag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $bank;
      var $bank1;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$rtag;
      $7=$wtag;
      var $8=$1;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$6;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$6;
      var $15=$2;
      var $16=$3;
      var $17=$4;
      var $18=$5;
      var $19=__ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write($8, $14, $15, $16, $17, $18, 1);
      $bank=$19;
      var $20=$8;
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+132)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=FUNCTION_TABLE[$23]($8);
      var $25=$24;
      var $26=$2;
      var $27=$3;
      var $28=$4;
      var $29=$5;
      var $30=$bank;
      var $31=__ZNK11memory_bank5indexEv($30);
      var $32=(($31) & 255);
      __ZN13address_table9map_rangeEjjjjh($25, $26, $27, $28, $29, $32);
      __label__ = 4; break;
    case 4: // $33
      var $34=$7;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      var $37=$7;
      var $38=$2;
      var $39=$3;
      var $40=$4;
      var $41=$5;
      var $42=__ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write($8, $37, $38, $39, $40, $41, 2);
      $bank1=$42;
      var $43=$8;
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+136)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=FUNCTION_TABLE[$46]($8);
      var $48=$47;
      var $49=$2;
      var $50=$3;
      var $51=$4;
      var $52=$5;
      var $53=$bank1;
      var $54=__ZNK11memory_bank5indexEv($53);
      var $55=(($54) & 255);
      __ZN13address_table9map_rangeEjjjjh($48, $49, $50, $51, $52, $55);
      __label__ = 6; break;
    case 6: // $56
      var $57=__ZNK13address_space7machineEv($8);
      __ZL16generate_memdumpR15running_machine($57);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space20install_bank_genericEjjjjPKcS1_["X"]=1;

function __ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFhPS0_jEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$rhandler;
      $8=$rname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=$13;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+132)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=FUNCTION_TABLE[$19]($13);
      var $21=$3;
      var $22=$4;
      var $23=$5;
      var $24=$6;
      var $st$9$0=(($9)|0);
      var $25$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($9+4)|0);
      var $25$1=HEAP32[(($st$9$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($10, $20, $21, $22, $23, $24, $25$0, $25$1);
      var $26=$2;
      var $27=$7;
      var $28=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP8device_tjEEEvRS3_T_PKc($10, $26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10);
      var $30=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($30);
      var $31=$3;
      var $32=$4;
      var $33=__ZN13address_space19find_backing_memoryEjj($13, $31, $32);
      STACKTOP = __stackBase__;
      return $33;
    case 4: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $11=$36;
      var $37=$35.f1;
      $12=$37;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $38
      __label__ = 6; break;
    case 6: // $39
      var $40=$11;
      var $41=$11;
      var $42=$12;
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFhPS0_jEPKcy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFtPS0_jtEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$rhandler;
      $8=$rname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+132)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($13);
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $st$34$0=(($9)|0);
      var $23$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($9+4)|0);
      var $23$1=HEAP32[(($st$34$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($10, $18, $19, $20, $21, $22, $23$0, $23$1);
      var $24=$2;
      var $25=$7;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP8device_tjtEEEvRS3_T_PKc($10, $24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10);
      var $28=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$3;
      var $30=$4;
      var $31=__ZN13address_space19find_backing_memoryEjj($13, $29, $30);
      var $32=$31;
      STACKTOP = __stackBase__;
      return $32;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$11;
      var $40=$11;
      var $41=$12;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFtPS0_jtEPKcy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFjPS0_jjEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$rhandler;
      $8=$rname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+132)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($13);
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $st$34$0=(($9)|0);
      var $23$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($9+4)|0);
      var $23$1=HEAP32[(($st$34$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($10, $18, $19, $20, $21, $22, $23$0, $23$1);
      var $24=$2;
      var $25=$7;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP8device_tjjEEEvRS3_T_PKc($10, $24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10);
      var $28=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$3;
      var $30=$4;
      var $31=__ZN13address_space19find_backing_memoryEjj($13, $29, $30);
      var $32=$31;
      STACKTOP = __stackBase__;
      return $32;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$11;
      var $40=$11;
      var $41=$12;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFjPS0_jjEPKcy["X"]=1;

function __ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFyPS0_jyEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $rhandler, $rname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$rhandler;
      $8=$rname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+132)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($13);
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $st$34$0=(($9)|0);
      var $23$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($9+4)|0);
      var $23$1=HEAP32[(($st$34$1)>>2)];
      __ZN18address_table_read17handler_map_rangeEjjjjy($10, $18, $19, $20, $21, $22, $23$0, $23$1);
      var $24=$2;
      var $25=$7;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP8device_tjyEEEvRS3_T_PKc($10, $24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10);
      var $28=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$3;
      var $30=$4;
      var $31=__ZN13address_space19find_backing_memoryEjj($13, $29, $30);
      var $32=$31;
      STACKTOP = __stackBase__;
      return $32;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$11;
      var $40=$11;
      var $41=$12;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFyPS0_jyEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jhEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$whandler;
      $8=$wname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=$13;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+136)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=FUNCTION_TABLE[$19]($13);
      var $21=$3;
      var $22=$4;
      var $23=$5;
      var $24=$6;
      var $st$9$0=(($9)|0);
      var $25$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($9+4)|0);
      var $25$1=HEAP32[(($st$9$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($10, $20, $21, $22, $23, $24, $25$0, $25$1);
      var $26=$2;
      var $27=$7;
      var $28=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjhEEEvRS3_T_PKc($10, $26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10);
      var $30=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($30);
      var $31=$3;
      var $32=$4;
      var $33=__ZN13address_space19find_backing_memoryEjj($13, $31, $32);
      STACKTOP = __stackBase__;
      return $33;
    case 4: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $11=$36;
      var $37=$35.f1;
      $12=$37;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $38
      __label__ = 6; break;
    case 6: // $39
      var $40=$11;
      var $41=$11;
      var $42=$12;
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jhEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jttEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$whandler;
      $8=$wname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+136)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($13);
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $st$34$0=(($9)|0);
      var $23$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($9+4)|0);
      var $23$1=HEAP32[(($st$34$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($10, $18, $19, $20, $21, $22, $23$0, $23$1);
      var $24=$2;
      var $25=$7;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjttEEEvRS3_T_PKc($10, $24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10);
      var $28=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$3;
      var $30=$4;
      var $31=__ZN13address_space19find_backing_memoryEjj($13, $29, $30);
      var $32=$31;
      STACKTOP = __stackBase__;
      return $32;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$11;
      var $40=$11;
      var $41=$12;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jttEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jjjEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$whandler;
      $8=$wname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+136)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($13);
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $st$34$0=(($9)|0);
      var $23$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($9+4)|0);
      var $23$1=HEAP32[(($st$34$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($10, $18, $19, $20, $21, $22, $23$0, $23$1);
      var $24=$2;
      var $25=$7;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjjjEEEvRS3_T_PKc($10, $24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10);
      var $28=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$3;
      var $30=$4;
      var $31=__ZN13address_space19find_backing_memoryEjj($13, $29, $30);
      var $32=$31;
      STACKTOP = __stackBase__;
      return $32;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$11;
      var $40=$11;
      var $41=$12;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jjjEPKcy["X"]=1;

function __ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jyyEPKcy($this, $device, $addrstart, $addrend, $addrmask, $addrmirror, $whandler, $wname, $unitmask$0, $unitmask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9=__stackBase__;
      var $10=__stackBase__+8;
      var $11;
      var $12;
      $1=$this;
      $2=$device;
      $3=$addrstart;
      $4=$addrend;
      $5=$addrmask;
      $6=$addrmirror;
      $7=$whandler;
      $8=$wname;
      var $st$20$0=(($9)|0);
      HEAP32[(($st$20$0)>>2)]=$unitmask$0;
      var $st$20$1=(($9+4)|0);
      HEAP32[(($st$20$1)>>2)]=$unitmask$1;
      var $13=$1;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+136)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=FUNCTION_TABLE[$17]($13);
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $st$34$0=(($9)|0);
      var $23$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($9+4)|0);
      var $23$1=HEAP32[(($st$34$1)>>2)];
      __ZN19address_table_write17handler_map_rangeEjjjjy($10, $18, $19, $20, $21, $22, $23$0, $23$1);
      var $24=$2;
      var $25=$7;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjyyEEEvRS3_T_PKc($10, $24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10);
      var $28=__ZNK13address_space7machineEv($13);
      __ZL16generate_memdumpR15running_machine($28);
      var $29=$3;
      var $30=$4;
      var $31=__ZN13address_space19find_backing_memoryEjj($13, $29, $30);
      var $32=$31;
      STACKTOP = __stackBase__;
      return $32;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $11=$35;
      var $36=$34.f1;
      $12=$36;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$11;
      var $40=$11;
      var $41=$12;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jyyEPKcy["X"]=1;

function __ZN13address_space22install_readwrite_portEjjjjPKcS1_($this, $addrstart, $addrend, $addrmask, $addrmirror, $rtag, $wtag) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $port;
      var $8;
      var $9;
      var $10=__stackBase__;
      var $port1;
      var $11=__stackBase__+20;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$rtag;
      $7=$wtag;
      var $12=$1;
      __label__ = 1; break;
    case 1: // $13
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $17
      var $18=__ZNK13address_space7machineEv($12);
      var $19=$6;
      var $20=__ZN15running_machine4portEPKc($18, $19);
      $port=$20;
      var $21=$port;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $23
      var $24=___cxa_allocate_exception(1032);
      var $25=$24;
      var $26=$6;
      var $27=(($12+56)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($12+12)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $32
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($25, ((STRING_TABLE.__str222913)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=$28,HEAP32[((tempInt+8)>>2)]=$31,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      ___cxa_throw($24, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 7: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $8=$36;
      var $37=$35.f1;
      $9=$37;
      ___cxa_free_exception($24);
      __label__ = 20; break;
    case 8: // $38
      var $39=$12;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+132)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=FUNCTION_TABLE[$42]($12);
      var $44=$2;
      var $45=$3;
      var $46=$4;
      var $47=$5;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN18address_table_read17handler_map_rangeEjjjjy($10, $43, $44, $45, $46, $47, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $48=$port;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI18handler_entry_readE10set_ioportERK17input_port_config($10, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $49
      __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10);
      __label__ = 12; break;
    case 10: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      $8=$52;
      var $53=$51.f1;
      $9=$53;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 21; break; }
    case 11: // $54
      __label__ = 20; break;
    case 12: // $55
      var $56=$7;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $58
      var $59=__ZNK13address_space7machineEv($12);
      var $60=$7;
      var $61=__ZN15running_machine4portEPKc($59, $60);
      $port1=$61;
      var $62=$port1;
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $64
      var $65=$7;
      var $66=(($12+56)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($12+12)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=__ZNK8device_t3tagEv($69);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str232914)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$65,HEAP32[((tempInt+4)>>2)]=$67,HEAP32[((tempInt+8)>>2)]=$70,tempInt));
      throw "Reached an unreachable!"
    case 15: // $71
      var $72=$12;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+136)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=FUNCTION_TABLE[$75]($12);
      var $77=$2;
      var $78=$3;
      var $79=$4;
      var $80=$5;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN19address_table_write17handler_map_rangeEjjjjy($11, $76, $77, $78, $79, $80, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      var $81=$port1;
      (function() { try { __THREW__ = false; return __ZNK19handler_entry_proxyI19handler_entry_writeE10set_ioportERK17input_port_config($11, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $82
      __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($11);
      __label__ = 19; break;
    case 17: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $8=$85;
      var $86=$84.f1;
      $9=$86;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $87
      __label__ = 20; break;
    case 19: // $88
      var $89=__ZNK13address_space7machineEv($12);
      __ZL16generate_memdumpR15running_machine($89);
      STACKTOP = __stackBase__;
      return;
    case 20: // $90
      var $91=$8;
      var $92=$8;
      var $93=$9;
      var $94=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $92, tempValue);
      var $95=($94.f1 = $93, $94);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $96
      var $97=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space22install_readwrite_portEjjjjPKcS1_["X"]=1;

function __ZNK12memory_block4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI12memory_blockE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12memory_block9bytestartEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12memory_block7byteendEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12memory_block4dataEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI11memory_bankE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11memory_bank4baseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=HEAP32[(($4)>>2)];
  ;
  return $5;
}


function __ZNK11memory_bank9bytestartEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11memory_bank9anonymousEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+17)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK11memory_bank4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12memory_share7set_ptrEPv($this, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$ptr;
  var $3=$1;
  var $4=$2;
  var $5=(($3)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN13address_space25block_assign_intersectingEjjPh($this, $bytestart, $byteend, $base) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $memdata;
      var $unassigned;
      var $entry;
      var $share;
      var $share1;
      $1=$this;
      $2=$bytestart;
      $3=$byteend;
      $4=$base;
      var $5=$1;
      var $6=__ZNK13address_space7machineEv($5);
      var $7=(($6+624)|0);
      var $8=HEAP32[(($7)>>2)];
      $memdata=$8;
      $unassigned=0;
      var $9=(($5+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+12)|0);
      var $12=__ZNK11simple_listI17address_map_entryE5firstEv($11);
      $entry=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$entry;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 33; break; }
    case 2: // $16
      var $17=$entry;
      var $18=(($17+556)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $21
      var $22=$entry;
      var $23=(($22+264)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $26
      var $27=$memdata;
      var $28=(($27+1480)|0);
      var $29=$entry;
      var $30=(($29+264)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__ZNK8tagmap_tIP12memory_shareE4findEPKc($28, $31);
      $share=$32;
      var $33=$share;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $35
      var $36=$share;
      var $37=__ZNK12memory_share3ptrEv($36);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $39
      var $40=$share;
      var $41=__ZNK12memory_share3ptrEv($40);
      var $42=$entry;
      var $43=(($42+556)|0);
      HEAP32[(($43)>>2)]=$41;
      __label__ = 7; break;
    case 7: // $44
      __label__ = 8; break;
    case 8: // $45
      __label__ = 12; break;
    case 9: // $46
      __label__ = 10; break;
    case 10: // $47
      __label__ = 11; break;
    case 11: // $48
      __label__ = 12; break;
    case 12: // $49
      __label__ = 13; break;
    case 13: // $50
      var $51=$entry;
      var $52=(($51+556)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $55
      var $56=$entry;
      var $57=(($56+560)|0);
      var $58=HEAPU32[(($57)>>2)];
      var $59=$2;
      var $60=(($58)>>>0) >= (($59)>>>0);
      if ($60) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $61
      var $62=$entry;
      var $63=(($62+564)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=$3;
      var $66=(($64)>>>0) <= (($65)>>>0);
      if ($66) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $67
      var $68=$4;
      var $69=$entry;
      var $70=(($69+560)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(($71-$72)|0);
      var $74=(($68+$73)|0);
      var $75=$entry;
      var $76=(($75+556)|0);
      HEAP32[(($76)>>2)]=$74;
      __label__ = 17; break;
    case 17: // $77
      __label__ = 18; break;
    case 18: // $78
      __label__ = 19; break;
    case 19: // $79
      var $80=$entry;
      var $81=(($80+556)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 20; break; } else { __label__ = 27; break; }
    case 20: // $84
      var $85=$entry;
      var $86=(($85+264)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 21; break; } else { __label__ = 27; break; }
    case 21: // $89
      var $90=$memdata;
      var $91=(($90+1480)|0);
      var $92=$entry;
      var $93=(($92+264)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=__ZNK8tagmap_tIP12memory_shareE4findEPKc($91, $94);
      $share1=$95;
      var $96=$share1;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $98
      var $99=$share1;
      var $100=__ZNK12memory_share3ptrEv($99);
      var $101=(($100)|0)==0;
      if ($101) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $102
      var $103=$share1;
      var $104=$entry;
      var $105=(($104+556)|0);
      var $106=HEAP32[(($105)>>2)];
      __ZN12memory_share7set_ptrEPv($103, $106);
      __label__ = 24; break;
    case 24: // $107
      __label__ = 25; break;
    case 25: // $108
      __label__ = 26; break;
    case 26: // $109
      __label__ = 27; break;
    case 27: // $110
      var $111=$entry;
      var $112=(($111+556)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 28; break; } else { __label__ = 31; break; }
    case 28: // $115
      var $116=$unassigned;
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $118
      var $119=$entry;
      var $120=__ZN13address_space19needs_backing_storeEPK17address_map_entry($5, $119);
      if ($120) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $121
      var $122=$entry;
      $unassigned=$122;
      __label__ = 31; break;
    case 31: // $123
      __label__ = 32; break;
    case 32: // $124
      var $125=$entry;
      var $126=__ZNK17address_map_entry4nextEv($125);
      $entry=$126;
      __label__ = 1; break;
    case 33: // $127
      var $128=$unassigned;
      ;
      return $128;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space25block_assign_intersectingEjjPh["X"]=1;

function __ZN13address_space19needs_backing_storeEPK17address_map_entry($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $share;
      var $region;
      $2=$this;
      $3=$entry;
      var $4=$2;
      var $5=$3;
      var $6=(($5+268)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10+276)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=$3;
      var $16=(($15+284)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $1=1;
      __label__ = 19; break;
    case 4: // $20
      var $21=$3;
      var $22=(($21+264)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $25
      var $26=__ZNK13address_space7machineEv($4);
      var $27=(($26+624)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+1480)|0);
      var $30=$3;
      var $31=(($30+264)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__ZNK8tagmap_tIP12memory_shareE4findEPKc($29, $32);
      $share=$33;
      var $34=$share;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=$share;
      var $38=__ZNK12memory_share3ptrEv($37);
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      $1=1;
      __label__ = 19; break;
    case 8: // $41
      __label__ = 9; break;
    case 9: // $42
      var $43=$3;
      var $44=(($43+176)|0);
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==9;
      if ($47) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $48
      var $49=$3;
      var $50=(($49+176)|0);
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==1;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      $1=1;
      __label__ = 19; break;
    case 12: // $55
      var $56=__ZNK13address_space7machineEv($4);
      var $57=(($4+12)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=__ZNK8device_t3tagEv($58);
      var $60=__ZN15running_machine6regionEPKc($56, $59);
      $region=$60;
      var $61=$3;
      var $62=(($61+88)|0);
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)==1;
      if ($65) { __label__ = 17; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=$3;
      var $68=(($67+88)|0);
      var $69=(($68)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0)==2;
      if ($71) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $72
      var $73=(($4+44)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 15: // $76
      var $77=$region;
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $79
      var $80=$3;
      var $81=(($80+72)|0);
      var $82=HEAPU32[(($81)>>2)];
      var $83=$region;
      var $84=__ZNK13memory_region5bytesEv($83);
      var $85=(($82)>>>0) >= (($84)>>>0);
      if ($85) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $86
      $1=1;
      __label__ = 19; break;
    case 18: // $87
      $1=0;
      __label__ = 19; break;
    case 19: // $88
      var $89=$1;
      ;
      return $89;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space19needs_backing_storeEPK17address_map_entry["X"]=1;

function __ZNK15running_machine11driver_dataIvEEPT_v($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1300)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__Z8downcastIPv13driver_deviceET_PT0_($4);
  ;
  return $5;
}


function __ZNK11memory_bank16references_spaceER13address_space13read_or_write($this, $space, $readorwrite) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $ref;
      $2=$this;
      $3=$space;
      $4=$readorwrite;
      var $5=$2;
      var $6=(($5+168)|0);
      var $7=__ZNK11simple_listIN11memory_bank14bank_referenceEE5firstEv($6);
      $ref=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$ref;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$ref;
      var $13=$3;
      var $14=$4;
      var $15=__ZNK11memory_bank14bank_reference7matchesER13address_space13read_or_write($12, $13, $14);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=1;
      __label__ = 7; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$ref;
      var $20=__ZNK11memory_bank14bank_reference4nextEv($19);
      $ref=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_space18get_handler_stringE13read_or_writej($this, $readorwrite, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$readorwrite;
      $4=$byteaddress;
      var $5=$2;
      var $6=$3;
      var $7=(($6)|0)==1;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$5;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+132)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=FUNCTION_TABLE[$12]($5);
      var $14=$13;
      var $15=$5;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+132)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=FUNCTION_TABLE[$18]($5);
      var $20=$19;
      var $21=$4;
      var $22=__ZNK13address_table6lookupEj($20, $21);
      var $23=(($22) & 255);
      var $24=__ZNK13address_table12handler_nameEh($14, $23);
      $1=$24;
      __label__ = 3; break;
    case 2: // $25
      var $26=$5;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+136)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=FUNCTION_TABLE[$29]($5);
      var $31=$30;
      var $32=$5;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+136)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=FUNCTION_TABLE[$35]($5);
      var $37=$36;
      var $38=$4;
      var $39=__ZNK13address_table6lookupEj($37, $38);
      var $40=(($39) & 255);
      var $41=__ZNK13address_table12handler_nameEh($31, $40);
      $1=$41;
      __label__ = 3; break;
    case 3: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13address_table12handler_nameEh($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $info;
      $2=$this;
      $3=$entry;
      var $4=$2;
      var $5=$3;
      var $6=(($5)&255);
      var $7=(($6)|0) >= 1;
      if ($7) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)&255);
      var $11=(($10)|0) <= 124;
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=(($4+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK13address_space7machineEv($14);
      var $16=(($15+624)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+1068)|0);
      var $19=__ZNK11simple_listI11memory_bankE5firstEv($18);
      $info=$19;
      __label__ = 3; break;
    case 3: // $20
      var $21=$info;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $23
      var $24=$info;
      var $25=__ZNK11memory_bank5indexEv($24);
      var $26=$3;
      var $27=(($26)&255);
      var $28=(($25)|0)==(($27)|0);
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$info;
      var $31=__ZNK11memory_bank4nameEv($30);
      $1=$31;
      __label__ = 14; break;
    case 6: // $32
      __label__ = 7; break;
    case 7: // $33
      var $34=$info;
      var $35=__ZNK11memory_bank4nextEv($34);
      $info=$35;
      __label__ = 3; break;
    case 8: // $36
      __label__ = 9; break;
    case 9: // $37
      var $38=$3;
      var $39=(($38)&255);
      var $40=(($39)>>>0) < 128;
      if ($40) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $41
      var $42=$3;
      var $43=(($42)&255);
      var $44=((__ZZNK13address_table12handler_nameEhE7strings+($43<<2))|0);
      var $45=HEAP32[(($44)>>2)];
      $1=$45;
      __label__ = 14; break;
    case 11: // $46
      var $47=$4;
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+8)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$3;
      var $52=(($51)&255);
      var $53=FUNCTION_TABLE[$50]($4, $52);
      __ZNK13handler_entry11descriptionEPc($53, ((__ZZNK13address_table12handler_nameEhE4desc)|0));
      var $54=HEAP8[(((__ZZNK13address_table12handler_nameEhE4desc)|0))];
      var $55=(($54 << 24) >> 24)!=0;
      if ($55) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $56
      $1=((__ZZNK13address_table12handler_nameEhE4desc)|0);
      __label__ = 14; break;
    case 13: // $57
      $1=((STRING_TABLE.__str1703061)|0);
      __label__ = 14; break;
    case 14: // $58
      var $59=$1;
      ;
      return $59;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13address_table12handler_nameEh["X"]=1;

function __ZNK13address_table6lookupEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $entry;
      $1=$this;
      $2=$byteaddress;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK13address_table12level1_indexEj($3, $4);
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+$5)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      $entry=$10;
      var $11=$entry;
      var $12=(($11)>>>0) >= 192;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$entry;
      var $15=(($14) & 255);
      var $16=$2;
      var $17=__ZNK13address_table12level2_indexEhj($3, $15, $16);
      var $18=(($3+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+$17)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      $entry=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$entry;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI12memory_blockEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12memory_blockEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12memory_blockEEPT_S3_["X"]=1;

function __ZNK13handler_entry9bytestartEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13address_table12derive_rangeEjRjS0_($this, $byteaddress, $bytestart, $byteend) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $l1entry;
      var $entry;
      var $minscan=__stackBase__;
      var $maxscan=__stackBase__+4;
      var $curl1entry;
      var $curentry;
      var $minindex;
      var $index;
      var $maxindex;
      var $index1;
      $1=$this;
      $2=$byteaddress;
      $3=$bytestart;
      $4=$byteend;
      var $5=$1;
      var $6=$2;
      var $7=__ZNK13address_table12level1_indexEj($5, $6);
      var $8=(($5+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+$7)|0);
      var $11=HEAP8[($10)];
      $l1entry=$11;
      $entry=$11;
      var $12=$l1entry;
      var $13=(($12)&255);
      var $14=(($13)|0) >= 192;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$l1entry;
      var $17=$2;
      var $18=__ZNK13address_table12level2_indexEhj($5, $16, $17);
      var $19=(($5+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+$18)|0);
      var $22=HEAP8[($21)];
      $entry=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$5;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$entry;
      var $29=(($28)&255);
      var $30=FUNCTION_TABLE[$27]($5, $29);
      var $31=$2;
      __ZNK13handler_entry18mirrored_start_endEjRjS0_($30, $31, $minscan, $maxscan);
      var $32=$l1entry;
      $curl1entry=$32;
      var $33=$entry;
      $curentry=$33;
      var $34=$2;
      var $35=$3;
      HEAP32[(($35)>>2)]=$34;
      __label__ = 3; break;
    case 3: // $36
      var $37=$curentry;
      var $38=(($37)&255);
      var $39=$curl1entry;
      var $40=(($39)&255);
      var $41=(($38)|0)!=(($40)|0);
      if ($41) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $42
      var $43=$curl1entry;
      var $44=__ZNK13address_table12level2_indexEhj($5, $43, 0);
      $minindex=$44;
      var $45=$curl1entry;
      var $46=$3;
      var $47=HEAP32[(($46)>>2)];
      var $48=__ZNK13address_table12level2_indexEhj($5, $45, $47);
      $index=$48;
      __label__ = 5; break;
    case 5: // $49
      var $50=$index;
      var $51=$minindex;
      var $52=(($50)>>>0) > (($51)>>>0);
      if ($52) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $53
      var $54=$index;
      var $55=(($54-1)|0);
      var $56=(($5+4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+$55)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=$entry;
      var $62=(($61)&255);
      var $63=(($60)|0)!=(($62)|0);
      if ($63) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $64
      __label__ = 10; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$index;
      var $68=(($67-1)|0);
      $index=$68;
      var $69=$3;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70-1)|0);
      HEAP32[(($69)>>2)]=$71;
      __label__ = 5; break;
    case 10: // $72
      var $73=$index;
      var $74=$minindex;
      var $75=(($73)|0)!=(($74)|0);
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      __label__ = 20; break;
    case 12: // $77
      __label__ = 13; break;
    case 13: // $78
      var $79=__ZNK13address_table11level2_bitsEv($5);
      var $80=1 << $79;
      var $81=(($80-1)|0);
      var $82=$81 ^ -1;
      var $83=$3;
      var $84=HEAP32[(($83)>>2)];
      var $85=$84 & $82;
      HEAP32[(($83)>>2)]=$85;
      var $86=$3;
      var $87=HEAPU32[(($86)>>2)];
      var $88=HEAPU32[(($minscan)>>2)];
      var $89=(($87)>>>0) <= (($88)>>>0);
      if ($89) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $90
      __label__ = 20; break;
    case 15: // $91
      var $92=$3;
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93-1)|0);
      var $95=__ZNK13address_table12level1_indexEj($5, $94);
      var $96=(($5+4)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+$95)|0);
      var $99=HEAP8[($98)];
      $curl1entry=$99;
      $curentry=$99;
      var $100=$curl1entry;
      var $101=(($100)&255);
      var $102=(($101)|0) >= 192;
      if ($102) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $103
      var $104=$curl1entry;
      var $105=$3;
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106-1)|0);
      var $108=__ZNK13address_table12level2_indexEhj($5, $104, $107);
      var $109=(($5+4)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+$108)|0);
      var $112=HEAP8[($111)];
      $curentry=$112;
      __label__ = 17; break;
    case 17: // $113
      var $114=$curentry;
      var $115=(($114)&255);
      var $116=$entry;
      var $117=(($116)&255);
      var $118=(($115)|0)!=(($117)|0);
      if ($118) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $119
      __label__ = 20; break;
    case 19: // $120
      var $121=$3;
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122-1)|0);
      HEAP32[(($121)>>2)]=$123;
      __label__ = 3; break;
    case 20: // $124
      var $125=$l1entry;
      $curl1entry=$125;
      var $126=$entry;
      $curentry=$126;
      var $127=$2;
      var $128=$4;
      HEAP32[(($128)>>2)]=$127;
      __label__ = 21; break;
    case 21: // $129
      var $130=$curentry;
      var $131=(($130)&255);
      var $132=$curl1entry;
      var $133=(($132)&255);
      var $134=(($131)|0)!=(($133)|0);
      if ($134) { __label__ = 22; break; } else { __label__ = 31; break; }
    case 22: // $135
      var $136=$curl1entry;
      var $137=__ZNK13address_table12level2_indexEhj($5, $136, -1);
      $maxindex=$137;
      var $138=$curl1entry;
      var $139=$4;
      var $140=HEAP32[(($139)>>2)];
      var $141=__ZNK13address_table12level2_indexEhj($5, $138, $140);
      $index1=$141;
      __label__ = 23; break;
    case 23: // $142
      var $143=$index1;
      var $144=$maxindex;
      var $145=(($143)>>>0) < (($144)>>>0);
      if ($145) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $146
      var $147=$index1;
      var $148=(($147+1)|0);
      var $149=(($5+4)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150+$148)|0);
      var $152=HEAPU8[($151)];
      var $153=(($152)&255);
      var $154=$entry;
      var $155=(($154)&255);
      var $156=(($153)|0)!=(($155)|0);
      if ($156) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $157
      __label__ = 28; break;
    case 26: // $158
      __label__ = 27; break;
    case 27: // $159
      var $160=$index1;
      var $161=(($160+1)|0);
      $index1=$161;
      var $162=$4;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+1)|0);
      HEAP32[(($162)>>2)]=$164;
      __label__ = 23; break;
    case 28: // $165
      var $166=$index1;
      var $167=$maxindex;
      var $168=(($166)|0)!=(($167)|0);
      if ($168) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $169
      __label__ = 38; break;
    case 30: // $170
      __label__ = 31; break;
    case 31: // $171
      var $172=__ZNK13address_table11level2_bitsEv($5);
      var $173=1 << $172;
      var $174=(($173-1)|0);
      var $175=$4;
      var $176=HEAP32[(($175)>>2)];
      var $177=$176 | $174;
      HEAP32[(($175)>>2)]=$177;
      var $178=$4;
      var $179=HEAPU32[(($178)>>2)];
      var $180=HEAPU32[(($maxscan)>>2)];
      var $181=(($179)>>>0) >= (($180)>>>0);
      if ($181) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $182
      __label__ = 38; break;
    case 33: // $183
      var $184=$4;
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185+1)|0);
      var $187=__ZNK13address_table12level1_indexEj($5, $186);
      var $188=(($5+4)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189+$187)|0);
      var $191=HEAP8[($190)];
      $curl1entry=$191;
      $curentry=$191;
      var $192=$curl1entry;
      var $193=(($192)&255);
      var $194=(($193)|0) >= 192;
      if ($194) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $195
      var $196=$curl1entry;
      var $197=$4;
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198+1)|0);
      var $200=__ZNK13address_table12level2_indexEhj($5, $196, $199);
      var $201=(($5+4)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($202+$200)|0);
      var $204=HEAP8[($203)];
      $curentry=$204;
      __label__ = 35; break;
    case 35: // $205
      var $206=$curentry;
      var $207=(($206)&255);
      var $208=$entry;
      var $209=(($208)&255);
      var $210=(($207)|0)!=(($209)|0);
      if ($210) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $211
      __label__ = 38; break;
    case 37: // $212
      var $213=$4;
      var $214=HEAP32[(($213)>>2)];
      var $215=(($214+1)|0);
      HEAP32[(($213)>>2)]=$215;
      __label__ = 21; break;
    case 38: // $216
      var $217=$entry;
      STACKTOP = __stackBase__;
      return $217;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13address_table12derive_rangeEjRjS0_["X"]=1;

function __ZN13address_table9map_rangeEjjjjh($this, $addrstart, $addrend, $addrmask, $addrmirror, $entry) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $bytestart=__stackBase__;
      var $byteend=__stackBase__+4;
      var $bytemask=__stackBase__+8;
      var $bytemirror=__stackBase__+12;
      var $7;
      var $8;
      var $curentry;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      $6=$entry;
      var $9=$1;
      var $10=$2;
      HEAP32[(($bytestart)>>2)]=$10;
      var $11=$3;
      HEAP32[(($byteend)>>2)]=$11;
      var $12=$4;
      HEAP32[(($bytemask)>>2)]=$12;
      var $13=$5;
      HEAP32[(($bytemirror)>>2)]=$13;
      var $14=(($9+12)|0);
      var $15=HEAP32[(($14)>>2)];
      __ZN13address_space16adjust_addressesERjS0_S0_S0_($15, $bytestart, $byteend, $bytemask, $bytemirror);
      __label__ = 1; break;
    case 1: // $16
      var $17=$2;
      var $18=$3;
      var $19=(($17)>>>0) <= (($18)>>>0);
      if ($19) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $20
      var $21=___cxa_allocate_exception(1032);
      var $22=$21;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($22, ((STRING_TABLE.__str272918)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str282919)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2891)|0),HEAP32[((tempInt+8)>>2)]=3344,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      ___cxa_throw($21, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $7=$26;
      var $27=$25.f1;
      $8=$27;
      ___cxa_free_exception($21);
      __label__ = 22; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=HEAP32[(($bytestart)>>2)];
      var $32=(($9+12)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__ZNK13address_space10data_widthEv($33);
      var $35=(((($34)|0)/8)|0);
      var $36=(($35-1)|0);
      var $37=$31 & $36;
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $39
      var $40=___cxa_allocate_exception(1032);
      var $41=$40;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($41, ((STRING_TABLE.__str272918)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str292920)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2891)|0),HEAP32[((tempInt+8)>>2)]=3345,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      ___cxa_throw($40, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 10: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $7=$45;
      var $46=$44.f1;
      $8=$46;
      ___cxa_free_exception($40);
      __label__ = 22; break;
    case 11: // $47
      __label__ = 12; break;
    case 12: // $48
      __label__ = 13; break;
    case 13: // $49
      var $50=HEAP32[(($byteend)>>2)];
      var $51=(($9+12)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=__ZNK13address_space10data_widthEv($52);
      var $54=(((($53)|0)/8)|0);
      var $55=(($54-1)|0);
      var $56=$50 & $55;
      var $57=(($9+12)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=__ZNK13address_space10data_widthEv($58);
      var $60=(((($59)|0)/8)|0);
      var $61=(($60-1)|0);
      var $62=(($56)|0)==(($61)|0);
      if ($62) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $63
      var $64=___cxa_allocate_exception(1032);
      var $65=$64;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($65, ((STRING_TABLE.__str272918)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str302921)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2891)|0),HEAP32[((tempInt+8)>>2)]=3346,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $66
      ___cxa_throw($64, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 16: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $7=$69;
      var $70=$68.f1;
      $8=$70;
      ___cxa_free_exception($64);
      __label__ = 22; break;
    case 17: // $71
      __label__ = 18; break;
    case 18: // $72
      var $73=$9;
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$6;
      var $78=(($77)&255);
      var $79=FUNCTION_TABLE[$76]($9, $78);
      $curentry=$79;
      var $80=$6;
      var $81=(($80)&255);
      var $82=(($81)|0) <= 124;
      if ($82) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $83
      var $84=$6;
      var $85=(($84)&255);
      var $86=(($85)|0) >= 128;
      if ($86) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $87
      var $88=$curentry;
      var $89=HEAP32[(($bytestart)>>2)];
      var $90=HEAP32[(($byteend)>>2)];
      var $91=HEAP32[(($bytemask)>>2)];
      __ZN13handler_entry9configureEjjj($88, $89, $90, $91);
      __label__ = 21; break;
    case 21: // $92
      var $93=HEAP32[(($bytestart)>>2)];
      var $94=HEAP32[(($byteend)>>2)];
      var $95=HEAP32[(($bytemirror)>>2)];
      var $96=$6;
      __ZN13address_table23populate_range_mirroredEjjjh($9, $93, $94, $95, $96);
      var $97=(($9+12)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+52)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$6;
      __ZN16direct_read_data12force_updateEh($100, $101);
      STACKTOP = __stackBase__;
      return;
    case 22: // $102
      var $103=$7;
      var $104=$7;
      var $105=$8;
      var $106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $104, tempValue);
      var $107=($106.f1 = $105, $106);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table9map_rangeEjjjjh["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE10set_ioportERK17input_port_config($this, $ioport) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $i=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      $21=$this;
      $22=$ioport;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$23;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$3;
      var $75=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$23;
      var $76=HEAP32[(($3)>>2)];
      var $77=HEAP32[(($4)>>2)];
      var $78=$1;
      var $79=$2;
      HEAP32[(($1)>>2)]=$76;
      HEAP32[(($2)>>2)]=$77;
      var $80=HEAP32[(($1)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($2)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$1;
      var $88=$2;
      var $89=$86 ^ 1;
      var $90=$3;
      var $91=$4;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$5;
      HEAP32[(($5)>>2)]=$i;
      var $94=HEAP32[(($5)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$5;
      var $99=HEAP32[(($97)>>2)];
      var $100=$22;
      __ZN18handler_entry_read10set_ioportERK17input_port_config($99, $100);
      __label__ = 3; break;
    case 3: // $101
      var $102=$13;
      var $103=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $104=HEAP32[(($13)>>2)];
      var $105=$24;
      var $106=$104;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($105)>>2)]=HEAP32[(($106)>>2)];
      var $107=$12;
      HEAP32[(($12)>>2)]=$104;
      var $108=HEAP32[(($12)>>2)];
      var $109=(($108)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$110;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($108)|0);
      HEAP32[(($114)>>2)]=$113;
      var $115=$12;
      var $116=$13;
      var $117=$14;
      __label__ = 1; break;
    case 4: // $118
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE10set_ioportERK17input_port_config["X"]=1;

function __ZN19handler_entry_proxyI18handler_entry_readED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19handler_entry_proxyI18handler_entry_readED2Ev($2);
  ;
  return;
}


function __ZN18address_table_read17handler_map_rangeEjjjjy($agg_result, $this, $bytestart, $byteend, $bytemask, $bytemirror, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 296; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $__p1_i4=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $__p1_i=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+216;
      var $54=__stackBase__+220;
      var $55=__stackBase__+224;
      var $56=__stackBase__+228;
      var $57=__stackBase__+232;
      var $58=__stackBase__+236;
      var $59;
      var $60;
      var $61;
      var $62;
      var $63;
      var $64=__stackBase__+240;
      var $entries=__stackBase__+248;
      var $65;
      var $66;
      var $handlers=__stackBase__+260;
      var $i=__stackBase__+272;
      var $67=__stackBase__+276;
      var $68=__stackBase__+280;
      var $69=__stackBase__+284;
      var $70=__stackBase__+288;
      var $71=__stackBase__+292;
      var $72;
      $59=$this;
      $60=$bytestart;
      $61=$byteend;
      $62=$bytemask;
      $63=$bytemirror;
      var $st$82$0=(($64)|0);
      HEAP32[(($st$82$0)>>2)]=$mask$0;
      var $st$82$1=(($64+4)|0);
      HEAP32[(($st$82$1)>>2)]=$mask$1;
      var $73=$59;
      var $74=$58;
      HEAP32[(($58)>>2)]=$entries;
      var $75=HEAP32[(($58)>>2)];
      var $76=$57;
      HEAP32[(($57)>>2)]=$75;
      var $77=HEAP32[(($57)>>2)];
      var $78=$77;
      var $79=$56;
      HEAP32[(($56)>>2)]=$78;
      var $80=HEAP32[(($56)>>2)];
      var $81=(($80)|0);
      var $82=$55;
      HEAP32[(($55)>>2)]=$81;
      var $83=HEAP32[(($55)>>2)];
      var $84=$54;
      HEAP32[(($54)>>2)]=$83;
      var $85=HEAP32[(($54)>>2)];
      var $86=(($85)|0);
      var $87=$85;
      HEAP32[(($86)>>2)]=$87;
      var $88=(($85+4)|0);
      var $89=$85;
      HEAP32[(($88)>>2)]=$89;
      var $90=$54;
      var $91=$55;
      var $92=(($80+8)|0);
      var $93=$51;
      var $94=$52;
      var $95=$53;
      HEAP32[(($51)>>2)]=$92;
      HEAP32[(($52)>>2)]=0;
      HEAP32[(($53)>>2)]=0;
      var $96=HEAP32[(($51)>>2)];
      var $97=HEAP32[(($52)>>2)];
      var $98=HEAP32[(($53)>>2)];
      var $99=$48;
      var $100=$49;
      var $101=$50;
      HEAP32[(($48)>>2)]=$96;
      HEAP32[(($49)>>2)]=$97;
      HEAP32[(($50)>>2)]=$98;
      var $102=HEAP32[(($48)>>2)];
      var $103=$102;
      var $104=$47;
      HEAP32[(($47)>>2)]=$49;
      var $105=HEAP32[(($47)>>2)];
      var $106=$47;
      var $107=HEAP32[(($105)>>2)];
      var $108=$45;
      var $109=$46;
      HEAP32[(($45)>>2)]=$103;
      HEAP32[(($46)>>2)]=$107;
      var $110=HEAP32[(($45)>>2)];
      var $111=$110;
      var $112=$44;
      HEAP32[(($44)>>2)]=$111;
      var $113=HEAP32[(($44)>>2)];
      var $114=$44;
      var $115=(($110)|0);
      var $116=$43;
      HEAP32[(($43)>>2)]=$46;
      var $117=HEAP32[(($43)>>2)];
      var $118=$43;
      var $119=HEAP32[(($117)>>2)];
      HEAP32[(($115)>>2)]=$119;
      var $120=$45;
      var $121=$46;
      var $122=$48;
      var $123=$49;
      var $124=$50;
      var $125=$51;
      var $126=$52;
      var $127=$53;
      var $128=$56;
      var $129=$57;
      var $130=$58;
      var $131=$73;
      var $132=$60;
      var $133=$61;
      var $134=$62;
      var $135=$63;
      var $st$168$0=(($64)|0);
      var $136$0=HEAP32[(($st$168$0)>>2)];
      var $st$168$1=(($64+4)|0);
      var $136$1=HEAP32[(($st$168$1)>>2)];
      (function() { try { __THREW__ = false; return __ZN13address_table11setup_rangeEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE($131, $132, $133, $134, $135, $136$0, $136$1, $entries) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $137
      var $138=$42;
      HEAP32[(($42)>>2)]=$handlers;
      var $139=HEAP32[(($42)>>2)];
      var $140=$41;
      HEAP32[(($41)>>2)]=$139;
      var $141=HEAP32[(($41)>>2)];
      var $142=$141;
      var $143=$40;
      HEAP32[(($40)>>2)]=$142;
      var $144=HEAP32[(($40)>>2)];
      var $145=(($144)|0);
      var $146=$39;
      HEAP32[(($39)>>2)]=$145;
      var $147=HEAP32[(($39)>>2)];
      var $148=$38;
      HEAP32[(($38)>>2)]=$147;
      var $149=HEAP32[(($38)>>2)];
      var $150=(($149)|0);
      var $151=$149;
      HEAP32[(($150)>>2)]=$151;
      var $152=(($149+4)|0);
      var $153=$149;
      HEAP32[(($152)>>2)]=$153;
      var $154=$38;
      var $155=$39;
      var $156=(($144+8)|0);
      var $157=$35;
      var $158=$36;
      var $159=$37;
      HEAP32[(($35)>>2)]=$156;
      HEAP32[(($36)>>2)]=0;
      HEAP32[(($37)>>2)]=0;
      var $160=HEAP32[(($35)>>2)];
      var $161=HEAP32[(($36)>>2)];
      var $162=HEAP32[(($37)>>2)];
      var $163=$32;
      var $164=$33;
      var $165=$34;
      HEAP32[(($32)>>2)]=$160;
      HEAP32[(($33)>>2)]=$161;
      HEAP32[(($34)>>2)]=$162;
      var $166=HEAP32[(($32)>>2)];
      var $167=$166;
      var $168=$31;
      HEAP32[(($31)>>2)]=$33;
      var $169=HEAP32[(($31)>>2)];
      var $170=$31;
      var $171=HEAP32[(($169)>>2)];
      var $172=$29;
      var $173=$30;
      HEAP32[(($29)>>2)]=$167;
      HEAP32[(($30)>>2)]=$171;
      var $174=HEAP32[(($29)>>2)];
      var $175=$174;
      var $176=$28;
      HEAP32[(($28)>>2)]=$175;
      var $177=HEAP32[(($28)>>2)];
      var $178=$28;
      var $179=(($174)|0);
      var $180=$27;
      HEAP32[(($27)>>2)]=$30;
      var $181=HEAP32[(($27)>>2)];
      var $182=$27;
      var $183=HEAP32[(($181)>>2)];
      HEAP32[(($179)>>2)]=$183;
      var $184=$29;
      var $185=$30;
      var $186=$32;
      var $187=$33;
      var $188=$34;
      var $189=$35;
      var $190=$36;
      var $191=$37;
      var $192=$40;
      var $193=$41;
      var $194=$42;
      __label__ = 2; break;
    case 2: // $195
      var $196=$26;
      HEAP32[(($26)>>2)]=$entries;
      var $197=HEAP32[(($26)>>2)];
      var $198=$197;
      var $199=$25;
      HEAP32[(($25)>>2)]=$198;
      var $200=HEAP32[(($25)>>2)];
      var $201=(($200)|0);
      var $202=(($201+4)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$23;
      var $205=$24;
      HEAP32[(($23)>>2)]=$67;
      HEAP32[(($24)>>2)]=$203;
      var $206=HEAP32[(($23)>>2)];
      var $207=HEAP32[(($24)>>2)];
      var $208=$21;
      var $209=$22;
      HEAP32[(($21)>>2)]=$206;
      HEAP32[(($22)>>2)]=$207;
      var $210=HEAP32[(($21)>>2)];
      var $211=(($210)|0);
      var $212=HEAP32[(($22)>>2)];
      HEAP32[(($211)>>2)]=$212;
      var $213=$21;
      var $214=$22;
      var $215=$23;
      var $216=$24;
      var $217=$25;
      var $218=$26;
      var $tmp=$20;
      var $tmp1=$67;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $219=$__p1_i;
      var $220=$19;
      HEAP32[(($19)>>2)]=$i;
      var $221=HEAP32[(($19)>>2)];
      var $tmp_i=$__p1_i;
      var $tmp2_i=$20;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];
      var $222=$18;
      HEAP32[(($18)>>2)]=$221;
      var $223=HEAP32[(($18)>>2)];
      var $224=(($223)|0);
      var $225=(($__p1_i)|0);
      var $226=HEAP32[(($225)>>2)];
      HEAP32[(($224)>>2)]=$226;
      var $227=$18;
      var $228=$__p1_i;
      var $229=$19;
      __label__ = 3; break;
    case 3: // $230
      var $231=$17;
      HEAP32[(($17)>>2)]=$entries;
      var $232=HEAP32[(($17)>>2)];
      var $233=$232;
      var $234=$16;
      HEAP32[(($16)>>2)]=$233;
      var $235=HEAP32[(($16)>>2)];
      var $236=(($235)|0);
      var $237=$236;
      var $238=$14;
      var $239=$15;
      HEAP32[(($14)>>2)]=$69;
      HEAP32[(($15)>>2)]=$237;
      var $240=HEAP32[(($14)>>2)];
      var $241=HEAP32[(($15)>>2)];
      var $242=$12;
      var $243=$13;
      HEAP32[(($12)>>2)]=$240;
      HEAP32[(($13)>>2)]=$241;
      var $244=HEAP32[(($12)>>2)];
      var $245=(($244)|0);
      var $246=HEAP32[(($13)>>2)];
      HEAP32[(($245)>>2)]=$246;
      var $247=$12;
      var $248=$13;
      var $249=$14;
      var $250=$15;
      var $251=$16;
      var $252=$17;
      var $tmp2=$11;
      var $tmp3=$69;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2)]=HEAP8[($tmp3)];HEAP8[($tmp2+1)]=HEAP8[($tmp3+1)];HEAP8[($tmp2+2)]=HEAP8[($tmp3+2)];HEAP8[($tmp2+3)]=HEAP8[($tmp3+3)];
      var $253=$__p1_i4;
      var $254=$10;
      HEAP32[(($10)>>2)]=$68;
      var $255=HEAP32[(($10)>>2)];
      var $tmp_i5=$__p1_i4;
      var $tmp2_i6=$11;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i5)]=HEAP8[($tmp2_i6)];HEAP8[($tmp_i5+1)]=HEAP8[($tmp2_i6+1)];HEAP8[($tmp_i5+2)]=HEAP8[($tmp2_i6+2)];HEAP8[($tmp_i5+3)]=HEAP8[($tmp2_i6+3)];
      var $256=$9;
      HEAP32[(($9)>>2)]=$255;
      var $257=HEAP32[(($9)>>2)];
      var $258=(($257)|0);
      var $259=(($__p1_i4)|0);
      var $260=HEAP32[(($259)>>2)];
      HEAP32[(($258)>>2)]=$260;
      var $261=$9;
      var $262=$__p1_i4;
      var $263=$10;
      var $264=$4;
      var $265=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$68;
      var $266=HEAP32[(($4)>>2)];
      var $267=HEAP32[(($5)>>2)];
      var $268=$2;
      var $269=$3;
      HEAP32[(($2)>>2)]=$266;
      HEAP32[(($3)>>2)]=$267;
      var $270=HEAP32[(($2)>>2)];
      var $271=(($270)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=HEAP32[(($3)>>2)];
      var $274=(($273)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=(($272)|0)==(($275)|0);
      var $277=$2;
      var $278=$3;
      var $279=$276 ^ 1;
      var $280=$4;
      var $281=$5;
      __label__ = 4; break;
    case 4: // $282
      if ($279) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $283
      var $284=$1;
      HEAP32[(($1)>>2)]=$i;
      var $285=HEAP32[(($1)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287+8)|0);
      var $289=$1;
      __label__ = 6; break;
    case 6: // $290
      var $291=HEAP32[(($288)>>2)];
      var $292=(function() { try { __THREW__ = false; return __ZNK18address_table_read12handler_readEj($73, $291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; };
    case 7: // $293
      HEAP32[(($70)>>2)]=$292;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEE9push_backERKS2_($handlers, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $294
      __label__ = 9; break;
    case 9: // $295
      var $296=$7;
      var $297=$8;
      HEAP32[(($7)>>2)]=$i;
      HEAP32[(($8)>>2)]=0;
      var $298=HEAP32[(($7)>>2)];
      var $299=$71;
      var $300=$298;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($299)>>2)]=HEAP32[(($300)>>2)];
      var $301=$6;
      HEAP32[(($6)>>2)]=$298;
      var $302=HEAP32[(($6)>>2)];
      var $303=(($302)|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=$304;
      var $306=(($305+4)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=(($302)|0);
      HEAP32[(($308)>>2)]=$307;
      var $309=$6;
      var $310=$7;
      var $311=$8;
      __label__ = 10; break;
    case 10: // $312
      __label__ = 3; break;
    case 11: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $315=$314.f0;
      $65=$315;
      var $316=$314.f1;
      $66=$316;
      __label__ = 17; break;
    case 12: // $317
      var $318=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $319=$318.f0;
      $65=$319;
      var $320=$318.f1;
      $66=$320;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED1Ev($handlers) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 13: // $321
      var $st$0$0=(($64)|0);
      var $322$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($64+4)|0);
      var $322$1=HEAP32[(($st$0$1)>>2)];
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI18handler_entry_readEC1ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($agg_result, $handlers, $322$0, $322$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 14: // $323
      $72=1;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED1Ev($handlers) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; }
    case 15: // $324
      __ZNSt3__14listIjNS_9allocatorIjEEED1Ev($entries);
      STACKTOP = __stackBase__;
      return;
    case 16: // $325
      __label__ = 17; break;
    case 17: // $326
      (function() { try { __THREW__ = false; return __ZNSt3__14listIjNS_9allocatorIjEEED1Ev($entries) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $327
      __label__ = 19; break;
    case 19: // $328
      var $329=$65;
      var $330=$65;
      var $331=$66;
      var $332=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $330, tempValue);
      var $333=($332.f1 = $331, $332);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $334
      var $335=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_read17handler_map_rangeEjjjjy["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE10set_ioportERK17input_port_config($this, $ioport) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $i=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      $21=$this;
      $22=$ioport;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$23;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$3;
      var $75=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$23;
      var $76=HEAP32[(($3)>>2)];
      var $77=HEAP32[(($4)>>2)];
      var $78=$1;
      var $79=$2;
      HEAP32[(($1)>>2)]=$76;
      HEAP32[(($2)>>2)]=$77;
      var $80=HEAP32[(($1)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($2)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$1;
      var $88=$2;
      var $89=$86 ^ 1;
      var $90=$3;
      var $91=$4;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$5;
      HEAP32[(($5)>>2)]=$i;
      var $94=HEAP32[(($5)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$5;
      var $99=HEAP32[(($97)>>2)];
      var $100=$22;
      __ZN19handler_entry_write10set_ioportERK17input_port_config($99, $100);
      __label__ = 3; break;
    case 3: // $101
      var $102=$13;
      var $103=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $104=HEAP32[(($13)>>2)];
      var $105=$24;
      var $106=$104;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($105)>>2)]=HEAP32[(($106)>>2)];
      var $107=$12;
      HEAP32[(($12)>>2)]=$104;
      var $108=HEAP32[(($12)>>2)];
      var $109=(($108)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$110;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($108)|0);
      HEAP32[(($114)>>2)]=$113;
      var $115=$12;
      var $116=$13;
      var $117=$14;
      __label__ = 1; break;
    case 4: // $118
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE10set_ioportERK17input_port_config["X"]=1;

function __ZN19handler_entry_proxyI19handler_entry_writeED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19handler_entry_proxyI19handler_entry_writeED2Ev($2);
  ;
  return;
}


function __ZN19address_table_write17handler_map_rangeEjjjjy($agg_result, $this, $bytestart, $byteend, $bytemask, $bytemirror, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 296; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $__p1_i4=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $__p1_i=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+216;
      var $54=__stackBase__+220;
      var $55=__stackBase__+224;
      var $56=__stackBase__+228;
      var $57=__stackBase__+232;
      var $58=__stackBase__+236;
      var $59;
      var $60;
      var $61;
      var $62;
      var $63;
      var $64=__stackBase__+240;
      var $entries=__stackBase__+248;
      var $65;
      var $66;
      var $handlers=__stackBase__+260;
      var $i=__stackBase__+272;
      var $67=__stackBase__+276;
      var $68=__stackBase__+280;
      var $69=__stackBase__+284;
      var $70=__stackBase__+288;
      var $71=__stackBase__+292;
      var $72;
      $59=$this;
      $60=$bytestart;
      $61=$byteend;
      $62=$bytemask;
      $63=$bytemirror;
      var $st$82$0=(($64)|0);
      HEAP32[(($st$82$0)>>2)]=$mask$0;
      var $st$82$1=(($64+4)|0);
      HEAP32[(($st$82$1)>>2)]=$mask$1;
      var $73=$59;
      var $74=$58;
      HEAP32[(($58)>>2)]=$entries;
      var $75=HEAP32[(($58)>>2)];
      var $76=$57;
      HEAP32[(($57)>>2)]=$75;
      var $77=HEAP32[(($57)>>2)];
      var $78=$77;
      var $79=$56;
      HEAP32[(($56)>>2)]=$78;
      var $80=HEAP32[(($56)>>2)];
      var $81=(($80)|0);
      var $82=$55;
      HEAP32[(($55)>>2)]=$81;
      var $83=HEAP32[(($55)>>2)];
      var $84=$54;
      HEAP32[(($54)>>2)]=$83;
      var $85=HEAP32[(($54)>>2)];
      var $86=(($85)|0);
      var $87=$85;
      HEAP32[(($86)>>2)]=$87;
      var $88=(($85+4)|0);
      var $89=$85;
      HEAP32[(($88)>>2)]=$89;
      var $90=$54;
      var $91=$55;
      var $92=(($80+8)|0);
      var $93=$51;
      var $94=$52;
      var $95=$53;
      HEAP32[(($51)>>2)]=$92;
      HEAP32[(($52)>>2)]=0;
      HEAP32[(($53)>>2)]=0;
      var $96=HEAP32[(($51)>>2)];
      var $97=HEAP32[(($52)>>2)];
      var $98=HEAP32[(($53)>>2)];
      var $99=$48;
      var $100=$49;
      var $101=$50;
      HEAP32[(($48)>>2)]=$96;
      HEAP32[(($49)>>2)]=$97;
      HEAP32[(($50)>>2)]=$98;
      var $102=HEAP32[(($48)>>2)];
      var $103=$102;
      var $104=$47;
      HEAP32[(($47)>>2)]=$49;
      var $105=HEAP32[(($47)>>2)];
      var $106=$47;
      var $107=HEAP32[(($105)>>2)];
      var $108=$45;
      var $109=$46;
      HEAP32[(($45)>>2)]=$103;
      HEAP32[(($46)>>2)]=$107;
      var $110=HEAP32[(($45)>>2)];
      var $111=$110;
      var $112=$44;
      HEAP32[(($44)>>2)]=$111;
      var $113=HEAP32[(($44)>>2)];
      var $114=$44;
      var $115=(($110)|0);
      var $116=$43;
      HEAP32[(($43)>>2)]=$46;
      var $117=HEAP32[(($43)>>2)];
      var $118=$43;
      var $119=HEAP32[(($117)>>2)];
      HEAP32[(($115)>>2)]=$119;
      var $120=$45;
      var $121=$46;
      var $122=$48;
      var $123=$49;
      var $124=$50;
      var $125=$51;
      var $126=$52;
      var $127=$53;
      var $128=$56;
      var $129=$57;
      var $130=$58;
      var $131=$73;
      var $132=$60;
      var $133=$61;
      var $134=$62;
      var $135=$63;
      var $st$168$0=(($64)|0);
      var $136$0=HEAP32[(($st$168$0)>>2)];
      var $st$168$1=(($64+4)|0);
      var $136$1=HEAP32[(($st$168$1)>>2)];
      (function() { try { __THREW__ = false; return __ZN13address_table11setup_rangeEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE($131, $132, $133, $134, $135, $136$0, $136$1, $entries) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $137
      var $138=$42;
      HEAP32[(($42)>>2)]=$handlers;
      var $139=HEAP32[(($42)>>2)];
      var $140=$41;
      HEAP32[(($41)>>2)]=$139;
      var $141=HEAP32[(($41)>>2)];
      var $142=$141;
      var $143=$40;
      HEAP32[(($40)>>2)]=$142;
      var $144=HEAP32[(($40)>>2)];
      var $145=(($144)|0);
      var $146=$39;
      HEAP32[(($39)>>2)]=$145;
      var $147=HEAP32[(($39)>>2)];
      var $148=$38;
      HEAP32[(($38)>>2)]=$147;
      var $149=HEAP32[(($38)>>2)];
      var $150=(($149)|0);
      var $151=$149;
      HEAP32[(($150)>>2)]=$151;
      var $152=(($149+4)|0);
      var $153=$149;
      HEAP32[(($152)>>2)]=$153;
      var $154=$38;
      var $155=$39;
      var $156=(($144+8)|0);
      var $157=$35;
      var $158=$36;
      var $159=$37;
      HEAP32[(($35)>>2)]=$156;
      HEAP32[(($36)>>2)]=0;
      HEAP32[(($37)>>2)]=0;
      var $160=HEAP32[(($35)>>2)];
      var $161=HEAP32[(($36)>>2)];
      var $162=HEAP32[(($37)>>2)];
      var $163=$32;
      var $164=$33;
      var $165=$34;
      HEAP32[(($32)>>2)]=$160;
      HEAP32[(($33)>>2)]=$161;
      HEAP32[(($34)>>2)]=$162;
      var $166=HEAP32[(($32)>>2)];
      var $167=$166;
      var $168=$31;
      HEAP32[(($31)>>2)]=$33;
      var $169=HEAP32[(($31)>>2)];
      var $170=$31;
      var $171=HEAP32[(($169)>>2)];
      var $172=$29;
      var $173=$30;
      HEAP32[(($29)>>2)]=$167;
      HEAP32[(($30)>>2)]=$171;
      var $174=HEAP32[(($29)>>2)];
      var $175=$174;
      var $176=$28;
      HEAP32[(($28)>>2)]=$175;
      var $177=HEAP32[(($28)>>2)];
      var $178=$28;
      var $179=(($174)|0);
      var $180=$27;
      HEAP32[(($27)>>2)]=$30;
      var $181=HEAP32[(($27)>>2)];
      var $182=$27;
      var $183=HEAP32[(($181)>>2)];
      HEAP32[(($179)>>2)]=$183;
      var $184=$29;
      var $185=$30;
      var $186=$32;
      var $187=$33;
      var $188=$34;
      var $189=$35;
      var $190=$36;
      var $191=$37;
      var $192=$40;
      var $193=$41;
      var $194=$42;
      __label__ = 2; break;
    case 2: // $195
      var $196=$26;
      HEAP32[(($26)>>2)]=$entries;
      var $197=HEAP32[(($26)>>2)];
      var $198=$197;
      var $199=$25;
      HEAP32[(($25)>>2)]=$198;
      var $200=HEAP32[(($25)>>2)];
      var $201=(($200)|0);
      var $202=(($201+4)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$23;
      var $205=$24;
      HEAP32[(($23)>>2)]=$67;
      HEAP32[(($24)>>2)]=$203;
      var $206=HEAP32[(($23)>>2)];
      var $207=HEAP32[(($24)>>2)];
      var $208=$21;
      var $209=$22;
      HEAP32[(($21)>>2)]=$206;
      HEAP32[(($22)>>2)]=$207;
      var $210=HEAP32[(($21)>>2)];
      var $211=(($210)|0);
      var $212=HEAP32[(($22)>>2)];
      HEAP32[(($211)>>2)]=$212;
      var $213=$21;
      var $214=$22;
      var $215=$23;
      var $216=$24;
      var $217=$25;
      var $218=$26;
      var $tmp=$20;
      var $tmp1=$67;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $219=$__p1_i;
      var $220=$19;
      HEAP32[(($19)>>2)]=$i;
      var $221=HEAP32[(($19)>>2)];
      var $tmp_i=$__p1_i;
      var $tmp2_i=$20;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];
      var $222=$18;
      HEAP32[(($18)>>2)]=$221;
      var $223=HEAP32[(($18)>>2)];
      var $224=(($223)|0);
      var $225=(($__p1_i)|0);
      var $226=HEAP32[(($225)>>2)];
      HEAP32[(($224)>>2)]=$226;
      var $227=$18;
      var $228=$__p1_i;
      var $229=$19;
      __label__ = 3; break;
    case 3: // $230
      var $231=$17;
      HEAP32[(($17)>>2)]=$entries;
      var $232=HEAP32[(($17)>>2)];
      var $233=$232;
      var $234=$16;
      HEAP32[(($16)>>2)]=$233;
      var $235=HEAP32[(($16)>>2)];
      var $236=(($235)|0);
      var $237=$236;
      var $238=$14;
      var $239=$15;
      HEAP32[(($14)>>2)]=$69;
      HEAP32[(($15)>>2)]=$237;
      var $240=HEAP32[(($14)>>2)];
      var $241=HEAP32[(($15)>>2)];
      var $242=$12;
      var $243=$13;
      HEAP32[(($12)>>2)]=$240;
      HEAP32[(($13)>>2)]=$241;
      var $244=HEAP32[(($12)>>2)];
      var $245=(($244)|0);
      var $246=HEAP32[(($13)>>2)];
      HEAP32[(($245)>>2)]=$246;
      var $247=$12;
      var $248=$13;
      var $249=$14;
      var $250=$15;
      var $251=$16;
      var $252=$17;
      var $tmp2=$11;
      var $tmp3=$69;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2)]=HEAP8[($tmp3)];HEAP8[($tmp2+1)]=HEAP8[($tmp3+1)];HEAP8[($tmp2+2)]=HEAP8[($tmp3+2)];HEAP8[($tmp2+3)]=HEAP8[($tmp3+3)];
      var $253=$__p1_i4;
      var $254=$10;
      HEAP32[(($10)>>2)]=$68;
      var $255=HEAP32[(($10)>>2)];
      var $tmp_i5=$__p1_i4;
      var $tmp2_i6=$11;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i5)]=HEAP8[($tmp2_i6)];HEAP8[($tmp_i5+1)]=HEAP8[($tmp2_i6+1)];HEAP8[($tmp_i5+2)]=HEAP8[($tmp2_i6+2)];HEAP8[($tmp_i5+3)]=HEAP8[($tmp2_i6+3)];
      var $256=$9;
      HEAP32[(($9)>>2)]=$255;
      var $257=HEAP32[(($9)>>2)];
      var $258=(($257)|0);
      var $259=(($__p1_i4)|0);
      var $260=HEAP32[(($259)>>2)];
      HEAP32[(($258)>>2)]=$260;
      var $261=$9;
      var $262=$__p1_i4;
      var $263=$10;
      var $264=$4;
      var $265=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$68;
      var $266=HEAP32[(($4)>>2)];
      var $267=HEAP32[(($5)>>2)];
      var $268=$2;
      var $269=$3;
      HEAP32[(($2)>>2)]=$266;
      HEAP32[(($3)>>2)]=$267;
      var $270=HEAP32[(($2)>>2)];
      var $271=(($270)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=HEAP32[(($3)>>2)];
      var $274=(($273)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=(($272)|0)==(($275)|0);
      var $277=$2;
      var $278=$3;
      var $279=$276 ^ 1;
      var $280=$4;
      var $281=$5;
      __label__ = 4; break;
    case 4: // $282
      if ($279) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $283
      var $284=$1;
      HEAP32[(($1)>>2)]=$i;
      var $285=HEAP32[(($1)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287+8)|0);
      var $289=$1;
      __label__ = 6; break;
    case 6: // $290
      var $291=HEAP32[(($288)>>2)];
      var $292=(function() { try { __THREW__ = false; return __ZNK19address_table_write13handler_writeEj($73, $291) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; };
    case 7: // $293
      HEAP32[(($70)>>2)]=$292;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEE9push_backERKS2_($handlers, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $294
      __label__ = 9; break;
    case 9: // $295
      var $296=$7;
      var $297=$8;
      HEAP32[(($7)>>2)]=$i;
      HEAP32[(($8)>>2)]=0;
      var $298=HEAP32[(($7)>>2)];
      var $299=$71;
      var $300=$298;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($299)>>2)]=HEAP32[(($300)>>2)];
      var $301=$6;
      HEAP32[(($6)>>2)]=$298;
      var $302=HEAP32[(($6)>>2)];
      var $303=(($302)|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=$304;
      var $306=(($305+4)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=(($302)|0);
      HEAP32[(($308)>>2)]=$307;
      var $309=$6;
      var $310=$7;
      var $311=$8;
      __label__ = 10; break;
    case 10: // $312
      __label__ = 3; break;
    case 11: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $315=$314.f0;
      $65=$315;
      var $316=$314.f1;
      $66=$316;
      __label__ = 17; break;
    case 12: // $317
      var $318=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $319=$318.f0;
      $65=$319;
      var $320=$318.f1;
      $66=$320;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED1Ev($handlers) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 13: // $321
      var $st$0$0=(($64)|0);
      var $322$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($64+4)|0);
      var $322$1=HEAP32[(($st$0$1)>>2)];
      (function() { try { __THREW__ = false; return __ZN19handler_entry_proxyI19handler_entry_writeEC1ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($agg_result, $handlers, $322$0, $322$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 14: // $323
      $72=1;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED1Ev($handlers) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; }
    case 15: // $324
      __ZNSt3__14listIjNS_9allocatorIjEEED1Ev($entries);
      STACKTOP = __stackBase__;
      return;
    case 16: // $325
      __label__ = 17; break;
    case 17: // $326
      (function() { try { __THREW__ = false; return __ZNSt3__14listIjNS_9allocatorIjEEED1Ev($entries) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $327
      __label__ = 19; break;
    case 19: // $328
      var $329=$65;
      var $330=$65;
      var $331=$66;
      var $332=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $330, tempValue);
      var $333=($332.f1 = $331, $332);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $334
      var $335=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_write17handler_map_rangeEjjjjy["X"]=1;

function __ZNK11memory_bank5indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  ;
  return $5;
}


function __ZN13address_space19find_backing_memoryEjj($this, $addrstart, $addrend) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $bytestart;
      var $byteend;
      var $entry;
      var $maskstart;
      var $maskend;
      var $block;
      $2=$this;
      $3=$addrstart;
      $4=$addrend;
      var $5=$2;
      var $6=$3;
      var $7=__ZNK13address_space15address_to_byteEj($5, $6);
      $bytestart=$7;
      var $8=$4;
      var $9=__ZNK13address_space19address_to_byte_endEj($5, $8);
      $byteend=$9;
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=(($5+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $1=0;
      __label__ = 25; break;
    case 4: // $16
      var $17=(($5+16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+12)|0);
      var $20=__ZNK11simple_listI17address_map_entryE5firstEv($19);
      $entry=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$entry;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $24
      var $25=$bytestart;
      var $26=$entry;
      var $27=(($26+572)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$25 & $28;
      $maskstart=$29;
      var $30=$byteend;
      var $31=$entry;
      var $32=(($31+572)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$30 & $33;
      $maskend=$34;
      var $35=$entry;
      var $36=(($35+556)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $39
      var $40=$maskstart;
      var $41=$entry;
      var $42=(($41+560)|0);
      var $43=HEAPU32[(($42)>>2)];
      var $44=(($40)>>>0) >= (($43)>>>0);
      if ($44) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $45
      var $46=$maskend;
      var $47=$entry;
      var $48=(($47+564)|0);
      var $49=HEAPU32[(($48)>>2)];
      var $50=(($46)>>>0) <= (($49)>>>0);
      if ($50) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $51
      __label__ = 10; break;
    case 10: // $52
      __label__ = 11; break;
    case 11: // $53
      var $54=$entry;
      var $55=(($54+556)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$maskstart;
      var $58=$entry;
      var $59=(($58+560)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57-$60)|0);
      var $62=(($56+$61)|0);
      $1=$62;
      __label__ = 25; break;
    case 12: // $63
      __label__ = 13; break;
    case 13: // $64
      var $65=$entry;
      var $66=__ZNK17address_map_entry4nextEv($65);
      $entry=$66;
      __label__ = 5; break;
    case 14: // $67
      var $68=__ZNK13address_space7machineEv($5);
      var $69=(($68+624)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+1048)|0);
      var $72=__ZNK11simple_listI12memory_blockE5firstEv($71);
      $block=$72;
      __label__ = 15; break;
    case 15: // $73
      var $74=$block;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $76
      var $77=$block;
      var $78=$bytestart;
      var $79=$byteend;
      var $80=__ZNK12memory_block8containsER13address_spacejj($77, $5, $78, $79);
      if ($80) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $81
      __label__ = 18; break;
    case 18: // $82
      __label__ = 19; break;
    case 19: // $83
      var $84=$block;
      var $85=__ZNK12memory_block4dataEv($84);
      var $86=$bytestart;
      var $87=(($85+$86)|0);
      var $88=$block;
      var $89=__ZNK12memory_block9bytestartEv($88);
      var $90=(((-$89))|0);
      var $91=(($87+$90)|0);
      $1=$91;
      __label__ = 25; break;
    case 20: // $92
      __label__ = 21; break;
    case 21: // $93
      var $94=$block;
      var $95=__ZNK12memory_block4nextEv($94);
      $block=$95;
      __label__ = 15; break;
    case 22: // $96
      __label__ = 23; break;
    case 23: // $97
      __label__ = 24; break;
    case 24: // $98
      $1=0;
      __label__ = 25; break;
    case 25: // $99
      var $100=$1;
      ;
      return $100;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space19find_backing_memoryEjj["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFhR13address_spacejhEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFhR13address_spacejhEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFhR13address_spacejhEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejhhEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFvR13address_spacejhhEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejhhEEEEvT_["X"]=1;

function __ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write($this, $tag, $addrstart, $addrend, $addrmask, $addrmirror, $readorwrite) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $memdata;
      var $bytemirror=__stackBase__+36;
      var $bytestart=__stackBase__+40;
      var $bytemask=__stackBase__+44;
      var $byteend=__stackBase__+48;
      var $bank;
      var $banknum;
      var $16;
      var $17;
      $9=$this;
      $10=$tag;
      $11=$addrstart;
      $12=$addrend;
      $13=$addrmask;
      $14=$addrmirror;
      $15=$readorwrite;
      var $18=$9;
      var $19=__ZNK13address_space7machineEv($18);
      var $20=(($19+624)|0);
      var $21=HEAP32[(($20)>>2)];
      $memdata=$21;
      var $22=$14;
      HEAP32[(($bytemirror)>>2)]=$22;
      var $23=$11;
      HEAP32[(($bytestart)>>2)]=$23;
      var $24=$13;
      HEAP32[(($bytemask)>>2)]=$24;
      var $25=$12;
      HEAP32[(($byteend)>>2)]=$25;
      __ZN13address_space16adjust_addressesERjS0_S0_S0_($18, $bytestart, $byteend, $bytemask, $bytemirror);
      $bank=0;
      var $26=$10;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $28
      var $29=$memdata;
      var $30=(($29+1088)|0);
      var $31=$10;
      var $32=__ZNK8tagmap_tIP11memory_bankE14find_hash_onlyEPKc($30, $31);
      $bank=$32;
      __label__ = 11; break;
    case 2: // $33
      var $34=$memdata;
      var $35=(($34+1068)|0);
      var $36=__ZNK11simple_listI11memory_bankE5firstEv($35);
      $bank=$36;
      __label__ = 3; break;
    case 3: // $37
      var $38=$bank;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $40
      var $41=$bank;
      var $42=__ZNK11memory_bank9anonymousEv($41);
      if ($42) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $43
      var $44=$bank;
      var $45=__ZNK11memory_bank16references_spaceER13address_space13read_or_write($44, $18, 3);
      if ($45) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $46
      var $47=$bank;
      var $48=HEAP32[(($bytestart)>>2)];
      var $49=HEAP32[(($byteend)>>2)];
      var $50=__ZNK11memory_bank15matches_exactlyEjj($47, $48, $49);
      if ($50) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $51
      __label__ = 10; break;
    case 8: // $52
      __label__ = 9; break;
    case 9: // $53
      var $54=$bank;
      var $55=__ZNK11memory_bank4nextEv($54);
      $bank=$55;
      __label__ = 3; break;
    case 10: // $56
      __label__ = 11; break;
    case 11: // $57
      var $58=$bank;
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 12; break; } else { __label__ = 36; break; }
    case 12: // $60
      var $61=$memdata;
      var $62=(($61+1476)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63+1)&255);
      HEAP8[($62)]=$64;
      var $65=(($63)&255);
      $banknum=$65;
      var $66=$banknum;
      var $67=(($66)|0) > 124;
      if ($67) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $68
      var $69=$10;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $71
      var $72=___cxa_allocate_exception(1032);
      var $73=$72;
      var $74=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($73, ((STRING_TABLE.__str252916)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $75
      ___cxa_throw($72, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 16: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $16=$78;
      var $79=$77.f1;
      $17=$79;
      ___cxa_free_exception($72);
      __label__ = 37; break;
    case 17: // $80
      var $81=___cxa_allocate_exception(1032);
      var $82=$81;
      var $83=HEAP32[(($bytestart)>>2)];
      var $84=HEAP32[(($byteend)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($82, ((STRING_TABLE.__str262917)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$83,HEAP32[((tempInt+4)>>2)]=$84,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $85
      ___cxa_throw($81, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 19: // $86
      var $87=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $88=$87.f0;
      $16=$88;
      var $89=$87.f1;
      $17=$89;
      ___cxa_free_exception($81);
      __label__ = 37; break;
    case 20: // $90
      var $91=__ZNK13address_space7machineEv($18);
      var $92=__ZN15running_machine7respoolEv($91);
      var $93=$4;
      var $94=$5;
      var $95=$6;
      var $96=$result_i;
      var $97=$7;
      var $98=$8;
      HEAP32[(($4)>>2)]=188;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=3269;
      var $99=HEAP32[(($4)>>2)];
      var $100=HEAP32[(($5)>>2)];
      var $101=HEAP32[(($6)>>2)];
      var $102=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($99, $100, $101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; };
    case 21: // $103
      HEAP32[(($result_i)>>2)]=$102;
      var $104=HEAP32[(($result_i)>>2)];
      var $105=(($104)|0)==0;
      if ($105) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $106
      var $107=___cxa_allocate_exception(4);
      var $108=$107;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($108);
      (function() { try { __THREW__ = false; return ___cxa_throw($107, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 23; break; }
    case 23: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      HEAP32[(($7)>>2)]=$111;
      var $112=$110.f1;
      HEAP32[(($8)>>2)]=$112;
      var $113=HEAP32[(($8)>>2)];
      var $114=(($113)|0) < 0;
      if ($114) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $115
      var $116=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($116);
      throw "Reached an unreachable!"
    case 25: // $117
      var $118=HEAP32[(($7)>>2)];
      var $119=HEAP32[(($7)>>2)];
      var $120=HEAP32[(($8)>>2)];
      var $121=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $119, tempValue);
      var $122=($121.f1 = $120, $121);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $123
      throw "Reached an unreachable!"
    case 27: // $_ZnwjPKci_exit
      var $124=HEAP32[(($result_i)>>2)];
      var $125=$4;
      var $126=$5;
      var $127=$6;
      var $128=$result_i;
      var $129=$7;
      var $130=$8;
      var $131=$124;
      var $132=$banknum;
      var $133=HEAP32[(($bytestart)>>2)];
      var $134=HEAP32[(($byteend)>>2)];
      var $135=$10;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11memory_bankC1ER13address_spaceijjPKc]($131, $18, $132, $133, $134, $135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $136
      var $137=__ZN13resource_pool10add_objectI11memory_bankEEPT_S3_($92, $131);
      $bank=$137;
      var $138=$memdata;
      var $139=(($138+1068)|0);
      var $140=$bank;
      var $141=__ZN11simple_listI11memory_bankE6appendERS0_($139, $140);
      var $142=$10;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 29; break; } else { __label__ = 35; break; }
    case 29: // $144
      var $145=$memdata;
      var $146=(($145+1088)|0);
      var $147=$10;
      var $148=$bank;
      var $149=__ZN8tagmap_tIP11memory_bankE15add_unique_hashEPKcS1_b($146, $147, $148, 0);
      __label__ = 35; break;
    case 30: // $150
      var $151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $152=$151.f0;
      $16=$152;
      var $153=$151.f1;
      $17=$153;
      var $154=$1;
      var $155=$2;
      var $156=$3;
      HEAP32[(($1)>>2)]=$124;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=3269;
      var $157=HEAP32[(($1)>>2)];
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $159
      var $160=HEAP32[(($1)>>2)];
      var $161=HEAP32[(($2)>>2)];
      var $162=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($160, $161, $162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 38; break; }
    case 32: // $_noexc
      __label__ = 33; break;
    case 33: // $_ZdlPvPKci_exit
      var $163=$1;
      var $164=$2;
      var $165=$3;
      __label__ = 34; break;
    case 34: // $166
      __label__ = 37; break;
    case 35: // $167
      __label__ = 36; break;
    case 36: // $168
      var $169=$bank;
      var $170=$15;
      __ZN11memory_bank13add_referenceER13address_space13read_or_write($169, $18, $170);
      var $171=$bank;
      STACKTOP = __stackBase__;
      return $171;
    case 37: // $172
      var $173=$16;
      var $174=$16;
      var $175=$17;
      var $176=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $174, tempValue);
      var $177=($176.f1 = $175, $176);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $178
      var $179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP13address_spacejEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER13address_spacePFhPS0_jEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP13address_spacejEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejhEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jhEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejhEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP8device_tjEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER8device_tPFhPS0_jEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP8device_tjEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjhEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jhEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjhEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFtR13address_spacejtEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFtR13address_spacejtEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFtR13address_spacejtEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejttEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFvR13address_spacejttEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejttEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP13address_spacejtEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER13address_spacePFtPS0_jtEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP13address_spacejtEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejttEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jttEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejttEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP8device_tjtEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER8device_tPFtPS0_jtEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP8device_tjtEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjttEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jttEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjttEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFjR13address_spacejjEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFjR13address_spacejjEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFjR13address_spacejjEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejjjEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFvR13address_spacejjjEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejjjEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP13address_spacejjEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER13address_spacePFjPS0_jjEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP13address_spacejjEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejjjEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jjjEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejjjEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP8device_tjjEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER8device_tPFjPS0_jjEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP8device_tjjEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjjjEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jjjEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjjjEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFyR13address_spacejyEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFyR13address_spacejyEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFyR13address_spacejyEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejyyEEEEvT_($this, $delegate) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $i=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+112;
      $21=$this;
      var $25=$21;
      var $26=(($25)|0);
      var $27=$20;
      HEAP32[(($20)>>2)]=$26;
      var $28=HEAP32[(($20)>>2)];
      var $29=$28;
      var $30=$19;
      HEAP32[(($19)>>2)]=$29;
      var $31=HEAP32[(($19)>>2)];
      var $32=(($31)|0);
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$17;
      var $36=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$34;
      var $37=HEAP32[(($17)>>2)];
      var $38=HEAP32[(($18)>>2)];
      var $39=$15;
      var $40=$16;
      HEAP32[(($15)>>2)]=$37;
      HEAP32[(($16)>>2)]=$38;
      var $41=HEAP32[(($15)>>2)];
      var $42=(($41)|0);
      var $43=HEAP32[(($16)>>2)];
      HEAP32[(($42)>>2)]=$43;
      var $44=$15;
      var $45=$16;
      var $46=$17;
      var $47=$18;
      var $48=$19;
      var $49=$20;
      __label__ = 1; break;
    case 1: // $50
      var $51=(($25)|0);
      var $52=$11;
      HEAP32[(($11)>>2)]=$51;
      var $53=HEAP32[(($11)>>2)];
      var $54=$53;
      var $55=$10;
      HEAP32[(($10)>>2)]=$54;
      var $56=HEAP32[(($10)>>2)];
      var $57=(($56)|0);
      var $58=$57;
      var $59=$8;
      var $60=$9;
      HEAP32[(($8)>>2)]=$22;
      HEAP32[(($9)>>2)]=$58;
      var $61=HEAP32[(($8)>>2)];
      var $62=HEAP32[(($9)>>2)];
      var $63=$6;
      var $64=$7;
      HEAP32[(($6)>>2)]=$61;
      HEAP32[(($7)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0);
      var $67=HEAP32[(($7)>>2)];
      HEAP32[(($66)>>2)]=$67;
      var $68=$6;
      var $69=$7;
      var $70=$8;
      var $71=$9;
      var $72=$10;
      var $73=$11;
      var $74=$4;
      var $75=$5;
      HEAP32[(($4)>>2)]=$i;
      HEAP32[(($5)>>2)]=$22;
      var $76=HEAP32[(($4)>>2)];
      var $77=HEAP32[(($5)>>2)];
      var $78=$2;
      var $79=$3;
      HEAP32[(($2)>>2)]=$76;
      HEAP32[(($3)>>2)]=$77;
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=HEAP32[(($3)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82)|0)==(($85)|0);
      var $87=$2;
      var $88=$3;
      var $89=$86 ^ 1;
      var $90=$4;
      var $91=$5;
      if ($89) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $92
      var $93=$1;
      HEAP32[(($1)>>2)]=$i;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+8)|0);
      var $98=$1;
      var $99=HEAP32[(($97)>>2)];
      __ZN8delegateIFvR13address_spacejyyEEC1ERKS3_($23, $delegate);
      var $100=(($25+12)|0);
      var $st$10$0=(($100)|0);
      var $101$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($100+4)|0);
      var $101$1=HEAP32[(($st$10$1)>>2)];
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($99, $23, $101$0, $101$1, 0);
      __label__ = 3; break;
    case 3: // $102
      var $103=$13;
      var $104=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $105=HEAP32[(($13)>>2)];
      var $106=$24;
      var $107=$105;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($106)>>2)]=HEAP32[(($107)>>2)];
      var $108=$12;
      HEAP32[(($12)>>2)]=$105;
      var $109=HEAP32[(($12)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=(($112+4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($109)|0);
      HEAP32[(($115)>>2)]=$114;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      __label__ = 1; break;
    case 4: // $119
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejyyEEEEvT_["X"]=1;

function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP13address_spacejyEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER13address_spacePFyPS0_jyEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP13address_spacejyEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejyyEEEvRS3_T_PKc($this, $space, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$space;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jyyEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejyyEEEvRS3_T_PKc["X"]=1;

function __ZNK12memory_block8containsER13address_spacejj($this, $space, $bytestart, $byteend) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$space;
      $3=$bytestart;
      $4=$byteend;
      var $5=$1;
      var $6=$2;
      var $7=(($5+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($6)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { var $21 = 0;__label__ = 3; break; }
    case 1: // $10
      var $11=(($5+12)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=$3;
      var $14=(($12)>>>0) <= (($13)>>>0);
      if ($14) { __label__ = 2; break; } else { var $21 = 0;__label__ = 3; break; }
    case 2: // $15
      var $16=(($5+16)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=$4;
      var $19=(($17)>>>0) >= (($18)>>>0);
      var $21 = $19;__label__ = 3; break;
    case 3: // $20
      var $21;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11memory_bank15matches_exactlyEjj($this, $bytestart, $byteend) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$bytestart;
      $3=$byteend;
      var $4=$1;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$2;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { var $15 = 0;__label__ = 2; break; }
    case 1: // $9
      var $10=(($4+24)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      var $15 = $13;__label__ = 2; break;
    case 2: // $14
      var $15;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11memory_bankE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP8device_tjyEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN18handler_entry_read15set_legacy_funcER8device_tPFyPS0_jyEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP8device_tjyEEEvRS3_T_PKc["X"]=1;

function __ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjyyEEEvRS3_T_PKc($this, $device, $func, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $i=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      $21=$this;
      $22=$device;
      $23=$func;
      $24=$name;
      var $27=$21;
      var $28=(($27)|0);
      var $29=$20;
      HEAP32[(($20)>>2)]=$28;
      var $30=HEAP32[(($20)>>2)];
      var $31=$30;
      var $32=$19;
      HEAP32[(($19)>>2)]=$31;
      var $33=HEAP32[(($19)>>2)];
      var $34=(($33)|0);
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$17;
      var $38=$18;
      HEAP32[(($17)>>2)]=$i;
      HEAP32[(($18)>>2)]=$36;
      var $39=HEAP32[(($17)>>2)];
      var $40=HEAP32[(($18)>>2)];
      var $41=$15;
      var $42=$16;
      HEAP32[(($15)>>2)]=$39;
      HEAP32[(($16)>>2)]=$40;
      var $43=HEAP32[(($15)>>2)];
      var $44=(($43)|0);
      var $45=HEAP32[(($16)>>2)];
      HEAP32[(($44)>>2)]=$45;
      var $46=$15;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      __label__ = 1; break;
    case 1: // $52
      var $53=(($27)|0);
      var $54=$11;
      HEAP32[(($11)>>2)]=$53;
      var $55=HEAP32[(($11)>>2)];
      var $56=$55;
      var $57=$10;
      HEAP32[(($10)>>2)]=$56;
      var $58=HEAP32[(($10)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$8;
      var $62=$9;
      HEAP32[(($8)>>2)]=$25;
      HEAP32[(($9)>>2)]=$60;
      var $63=HEAP32[(($8)>>2)];
      var $64=HEAP32[(($9)>>2)];
      var $65=$6;
      var $66=$7;
      HEAP32[(($6)>>2)]=$63;
      HEAP32[(($7)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($7)>>2)];
      HEAP32[(($68)>>2)]=$69;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=$3;
      var $77=$4;
      HEAP32[(($3)>>2)]=$i;
      HEAP32[(($4)>>2)]=$25;
      var $78=HEAP32[(($3)>>2)];
      var $79=HEAP32[(($4)>>2)];
      var $80=$1;
      var $81=$2;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=$79;
      var $82=HEAP32[(($1)>>2)];
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84)|0)==(($87)|0);
      var $89=$1;
      var $90=$2;
      var $91=$88 ^ 1;
      var $92=$3;
      var $93=$4;
      if ($91) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $94
      var $95=$5;
      HEAP32[(($5)>>2)]=$i;
      var $96=HEAP32[(($5)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+8)|0);
      var $100=$5;
      var $101=HEAP32[(($99)>>2)];
      var $102=$22;
      var $103=$23;
      var $104=$24;
      var $105=(($27+12)|0);
      var $st$12$0=(($105)|0);
      var $106$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($105+4)|0);
      var $106$1=HEAP32[(($st$12$1)>>2)];
      __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jyyEPKcy($101, $102, $103, $104, $106$0, $106$1);
      __label__ = 3; break;
    case 3: // $107
      var $108=$13;
      var $109=$14;
      HEAP32[(($13)>>2)]=$i;
      HEAP32[(($14)>>2)]=0;
      var $110=HEAP32[(($13)>>2)];
      var $111=$26;
      var $112=$110;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($111)>>2)]=HEAP32[(($112)>>2)];
      var $113=$12;
      HEAP32[(($12)>>2)]=$110;
      var $114=HEAP32[(($12)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($114)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=$12;
      var $122=$13;
      var $123=$14;
      __label__ = 1; break;
    case 4: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjyyEEEvRS3_T_PKc["X"]=1;

function __ZN8tagmap_tIP11memory_bankE15add_unique_hashEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z22tagmap_add_unique_hashP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN13resource_pool10add_objectI11memory_bankEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11memory_bankEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11memory_bankEEPT_S3_["X"]=1;

function __ZN11memory_bank13add_referenceER13address_space13read_or_write($this, $space, $readorwrite) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      $9=$this;
      $10=$space;
      $11=$readorwrite;
      var $14=$9;
      var $15=$10;
      var $16=$11;
      var $17=__ZNK11memory_bank16references_spaceER13address_space13read_or_write($14, $15, $16);
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      __label__ = 11; break;
    case 2: // $19
      var $20=(($14+168)|0);
      var $21=$10;
      var $22=__ZNK13address_space7machineEv($21);
      var $23=__ZN15running_machine7respoolEv($22);
      var $24=$4;
      var $25=$5;
      var $26=$6;
      var $27=$result_i;
      var $28=$7;
      var $29=$8;
      HEAP32[(($4)>>2)]=12;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=4596;
      var $30=HEAP32[(($4)>>2)];
      var $31=HEAP32[(($5)>>2)];
      var $32=HEAP32[(($6)>>2)];
      var $33=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30, $31, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $34
      HEAP32[(($result_i)>>2)]=$33;
      var $35=HEAP32[(($result_i)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $37
      var $38=___cxa_allocate_exception(4);
      var $39=$38;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39);
      (function() { try { __THREW__ = false; return ___cxa_throw($38, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      HEAP32[(($7)>>2)]=$42;
      var $43=$41.f1;
      HEAP32[(($8)>>2)]=$43;
      var $44=HEAP32[(($8)>>2)];
      var $45=(($44)|0) < 0;
      if ($45) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $46
      var $47=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($47);
      throw "Reached an unreachable!"
    case 7: // $48
      var $49=HEAP32[(($7)>>2)];
      var $50=HEAP32[(($7)>>2)];
      var $51=HEAP32[(($8)>>2)];
      var $52=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $50, tempValue);
      var $53=($52.f1 = $51, $52);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $54
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $55=HEAP32[(($result_i)>>2)];
      var $56=$4;
      var $57=$5;
      var $58=$6;
      var $59=$result_i;
      var $60=$7;
      var $61=$8;
      var $62=$55;
      var $63=$10;
      var $64=$11;
      (function() { try { __THREW__ = false; return __ZN11memory_bank14bank_referenceC1ER13address_space13read_or_write($62, $63, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $65
      var $66=__ZN13resource_pool10add_objectIN11memory_bank14bank_referenceEEEPT_S4_($23, $62);
      var $67=__ZN11simple_listIN11memory_bank14bank_referenceEE6appendERS1_($20, $66);
      __label__ = 11; break;
    case 11: // $68
      STACKTOP = __stackBase__;
      return;
    case 12: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $71=$70.f0;
      $12=$71;
      var $72=$70.f1;
      $13=$72;
      var $73=$1;
      var $74=$2;
      var $75=$3;
      HEAP32[(($1)>>2)]=$55;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=4596;
      var $76=HEAP32[(($1)>>2)];
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $78
      var $79=HEAP32[(($1)>>2)];
      var $80=HEAP32[(($2)>>2)];
      var $81=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($79, $80, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $82=$1;
      var $83=$2;
      var $84=$3;
      __label__ = 16; break;
    case 16: // $85
      __label__ = 17; break;
    case 17: // $86
      var $87=$12;
      var $88=$12;
      var $89=$13;
      var $90=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $88, tempValue);
      var $91=($90.f1 = $89, $90);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11memory_bank13add_referenceER13address_space13read_or_write["X"]=1;

function __ZN13address_table13subtable_dataC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13address_table13subtable_dataC2Ev($2);
  ;
  return;
}


function __ZN13address_tableD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV13address_table+8)|0);
  var $4=(($2+12)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=__ZNK13address_space7machineEv($5);
  var $7=__ZN15running_machine7respoolEv($6);
  var $8=(($2+4)|0);
  var $9=HEAP32[(($8)>>2)];
  __ZN13resource_pool6removeEPv($7, $9);
  var $10=(($2+12)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=__ZNK13address_space7machineEv($11);
  var $13=__ZN15running_machine7respoolEv($12);
  var $14=(($2+20)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  __ZN13resource_pool6removeEPv($13, $16);
  ;
  return;
}


function __ZN13handler_entry9configureEjjj($this, $bytestart, $byteend, $bytemask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$bytestart;
      $3=$byteend;
      $4=$bytemask;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP8[($6)];
      var $8=(($7) & 1);
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($5+28)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$2;
      __ZN13handler_entry20reconfigure_subunitsEj($5, $14);
      __label__ = 3; break;
    case 3: // $15
      var $16=(($5+4)|0);
      HEAP8[($16)]=1;
      var $17=$2;
      var $18=(($5+12)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=$3;
      var $20=(($5+16)|0);
      HEAP32[(($20)>>2)]=$19;
      var $21=$4;
      var $22=(($5+20)|0);
      HEAP32[(($22)>>2)]=$21;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_tableC2ER13address_spaceb($this, $space, $large) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i1=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $result_i=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14;
      var $15;
      var $16;
      var $17;
      var $18;
      var $i;
      $14=$this;
      $15=$space;
      var $19=(($large)&1);
      $16=$19;
      var $20=$14;
      var $21=$20;
      HEAP32[(($21)>>2)]=((__ZTV13address_table+8)|0);
      var $22=(($20+4)|0);
      var $23=$15;
      var $24=__ZNK13address_space7machineEv($23);
      var $25=__ZN15running_machine7respoolEv($24);
      var $26=$9;
      var $27=$10;
      var $28=$11;
      var $29=$result_i;
      var $30=$12;
      var $31=$13;
      HEAP32[(($9)>>2)]=262144;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($11)>>2)]=3293;
      var $32=HEAP32[(($9)>>2)];
      var $33=HEAP32[(($10)>>2)];
      var $34=HEAP32[(($11)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($12)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($13)>>2)]=$45;
      var $46=HEAP32[(($13)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $48
      var $49=HEAP32[(($12)>>2)];
      ___cxa_call_unexpected($49);
      throw "Reached an unreachable!"
    case 5: // $50
      var $51=HEAP32[(($12)>>2)];
      var $52=HEAP32[(($12)>>2)];
      var $53=HEAP32[(($13)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $56
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKci_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$9;
      var $59=$10;
      var $60=$11;
      var $61=$result_i;
      var $62=$12;
      var $63=$13;
      var $64=__ZN13resource_pool9add_arrayIhEEPT_S2_i($25, $57, 262144);
      HEAP32[(($22)>>2)]=$64;
      var $65=(($20+8)|0);
      var $66=(($20+4)|0);
      var $67=HEAP32[(($66)>>2)];
      HEAP32[(($65)>>2)]=$67;
      var $68=(($20+12)|0);
      var $69=$15;
      HEAP32[(($68)>>2)]=$69;
      var $70=(($20+16)|0);
      var $71=$16;
      var $72=(($71) & 1);
      var $73=(($72)&1);
      HEAP8[($70)]=$73;
      var $74=(($20+20)|0);
      var $75=$15;
      var $76=__ZNK13address_space7machineEv($75);
      var $77=__ZN15running_machine7respoolEv($76);
      var $78=$4;
      var $79=$5;
      var $80=$6;
      var $81=$result_i1;
      var $82=$7;
      var $83=$8;
      HEAP32[(($4)>>2)]=768;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=3297;
      var $84=HEAP32[(($4)>>2)];
      var $85=HEAP32[(($5)>>2)];
      var $86=HEAP32[(($6)>>2)];
      var $87=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $88
      HEAP32[(($result_i1)>>2)]=$87;
      var $89=HEAP32[(($result_i1)>>2)];
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $91
      var $92=___cxa_allocate_exception(4);
      var $93=$92;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($93);
      (function() { try { __THREW__ = false; return ___cxa_throw($92, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      HEAP32[(($7)>>2)]=$96;
      var $97=$95.f1;
      HEAP32[(($8)>>2)]=$97;
      var $98=HEAP32[(($8)>>2)];
      var $99=(($98)|0) < 0;
      if ($99) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $100
      var $101=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($101);
      throw "Reached an unreachable!"
    case 12: // $102
      var $103=HEAP32[(($7)>>2)];
      var $104=HEAP32[(($7)>>2)];
      var $105=HEAP32[(($8)>>2)];
      var $106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $104, tempValue);
      var $107=($106.f1 = $105, $106);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $108
      throw "Reached an unreachable!"
    case 14: // $_ZnajPKci_exit2
      var $109=HEAPU32[(($result_i1)>>2)];
      var $110=$4;
      var $111=$5;
      var $112=$6;
      var $113=$result_i1;
      var $114=$7;
      var $115=$8;
      var $116=$109;
      var $117=(($116+768)|0);
      var $119 = $116;__label__ = 15; break;
    case 15: // $118
      var $119;
      (function() { try { __THREW__ = false; return __ZN13address_table13subtable_dataC1Ev($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $120
      var $121=(($119+12)|0);
      var $122=(($121)|0)==(($117)|0);
      if ($122) { __label__ = 17; break; } else { var $119 = $121;__label__ = 15; break; }
    case 17: // $123
      var $124=__ZN13resource_pool9add_arrayIN13address_table13subtable_dataEEEPT_S4_i($77, $116, 64);
      HEAP32[(($74)>>2)]=$124;
      var $125=(($20+24)|0);
      HEAP8[($125)]=0;
      var $126=HEAPU8[(((__ZN13address_table18s_watchpoint_tableE)|0))];
      var $127=(($126)&255);
      var $128=(($127)|0)!=127;
      if ($128) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $129
      _memset(((__ZN13address_table18s_watchpoint_tableE)|0), 127, 262144, 1);
      __label__ = 24; break;
    case 19: // $130
      var $131=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $132=$131.f0;
      $17=$132;
      var $133=$131.f1;
      $18=$133;
      var $134=$1;
      var $135=$2;
      var $136=$3;
      HEAP32[(($1)>>2)]=$109;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=3297;
      var $137=HEAP32[(($1)>>2)];
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $139
      var $140=HEAP32[(($1)>>2)];
      var $141=HEAP32[(($2)>>2)];
      var $142=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($140, $141, $142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 30; break; }
    case 21: // $_noexc
      __label__ = 22; break;
    case 22: // $_ZdaPvPKci_exit
      var $143=$1;
      var $144=$2;
      var $145=$3;
      __label__ = 23; break;
    case 23: // $146
      __label__ = 29; break;
    case 24: // $147
      var $148=(($20+4)|0);
      var $149=HEAP32[(($148)>>2)];
      _memset($149, 126, 262144, 1);
      $i=0;
      __label__ = 25; break;
    case 25: // $150
      var $151=$i;
      var $152=(($151)|0)!=63;
      if ($152) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $153
      var $154=$i;
      var $155=(($154+128)|0);
      var $156=(($155+1)|0);
      var $157=(($156) & 255);
      var $158=$i;
      var $159=(($20+284)|0);
      var $160=(($159+$158)|0);
      HEAP8[($160)]=$157;
      __label__ = 27; break;
    case 27: // $161
      var $162=$i;
      var $163=(($162+1)|0);
      $i=$163;
      __label__ = 25; break;
    case 28: // $164
      var $165=(($20+284)|0);
      var $166=(($165+63)|0);
      HEAP8[($166)]=0;
      var $167=(($20+348)|0);
      HEAP8[($167)]=-128;
      var $168=(($20+28)|0);
      var $169=(($168)|0);
      var $170=$169;
      _memset($170, 0, 256, 1);
      STACKTOP = __stackBase__;
      return;
    case 29: // $171
      var $172=$17;
      var $173=$17;
      var $174=$18;
      var $175=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $173, tempValue);
      var $176=($175.f1 = $174, $175);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $177
      var $178=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_tableC2ER13address_spaceb["X"]=1;

function __ZN13resource_pool9add_arrayIN13address_table13subtable_dataEEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN13address_table13subtable_dataEEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIN13address_table13subtable_dataEEEPT_S4_i["X"]=1;

function __ZN13address_tableD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13address_tableD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_tableD0Ev["X"]=1;

function __ZN13address_table23populate_range_mirroredEjjjh($this, $bytestart, $byteend, $bytemirror, $handlerindex) {
  var __stackBase__  = STACKTOP; STACKTOP += 256; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $lmirrorbits;
      var $lmirrorbit=__stackBase__;
      var $bit;
      var $hmirrorbits;
      var $hmirrorbit=__stackBase__+128;
      var $bit1;
      var $prev_entry;
      var $prev_index;
      var $hmirrorcount;
      var $hmirrorbase;
      var $bit2;
      var $lmirrorcount;
      var $lmirrorbase;
      var $bit3;
      var $cur_index;
      var $lmirrorcount4;
      var $lmirrorbase5;
      var $bit6;
      $1=$this;
      $2=$bytestart;
      $3=$byteend;
      $4=$bytemirror;
      $5=$handlerindex;
      var $6=$1;
      $lmirrorbits=0;
      $bit=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$bit;
      var $9=__ZNK13address_table11level2_bitsEv($6);
      var $10=(($8)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$4;
      var $13=$bit;
      var $14=1 << $13;
      var $15=$12 & $14;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$bit;
      var $19=1 << $18;
      var $20=$lmirrorbits;
      var $21=(($20+1)|0);
      $lmirrorbits=$21;
      var $22=(($lmirrorbit+($20<<2))|0);
      HEAP32[(($22)>>2)]=$19;
      __label__ = 4; break;
    case 4: // $23
      __label__ = 5; break;
    case 5: // $24
      var $25=$bit;
      var $26=(($25+1)|0);
      $bit=$26;
      __label__ = 1; break;
    case 6: // $27
      $hmirrorbits=0;
      var $28=__ZNK13address_table11level2_bitsEv($6);
      $bit1=$28;
      __label__ = 7; break;
    case 7: // $29
      var $30=$bit1;
      var $31=(($30)|0) < 32;
      if ($31) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $32
      var $33=$4;
      var $34=$bit1;
      var $35=1 << $34;
      var $36=$33 & $35;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $38
      var $39=$bit1;
      var $40=1 << $39;
      var $41=$hmirrorbits;
      var $42=(($41+1)|0);
      $hmirrorbits=$42;
      var $43=(($hmirrorbit+($41<<2))|0);
      HEAP32[(($43)>>2)]=$40;
      __label__ = 10; break;
    case 10: // $44
      __label__ = 11; break;
    case 11: // $45
      var $46=$bit1;
      var $47=(($46+1)|0);
      $bit1=$47;
      __label__ = 7; break;
    case 12: // $48
      $prev_entry=0;
      $prev_index=0;
      $hmirrorcount=0;
      __label__ = 13; break;
    case 13: // $49
      var $50=$hmirrorcount;
      var $51=$hmirrorbits;
      var $52=1 << $51;
      var $53=(($50)>>>0) < (($52)>>>0);
      if ($53) { __label__ = 14; break; } else { __label__ = 55; break; }
    case 14: // $54
      $hmirrorbase=0;
      $bit2=0;
      __label__ = 15; break;
    case 15: // $55
      var $56=$bit2;
      var $57=$hmirrorbits;
      var $58=(($56)>>>0) < (($57)>>>0);
      if ($58) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $59
      var $60=$hmirrorcount;
      var $61=$bit2;
      var $62=1 << $61;
      var $63=$60 & $62;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $65
      var $66=$bit2;
      var $67=(($hmirrorbit+($66<<2))|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$hmirrorbase;
      var $70=$69 | $68;
      $hmirrorbase=$70;
      __label__ = 18; break;
    case 18: // $71
      __label__ = 19; break;
    case 19: // $72
      var $73=$bit2;
      var $74=(($73+1)|0);
      $bit2=$74;
      __label__ = 15; break;
    case 20: // $75
      $lmirrorcount=0;
      __label__ = 21; break;
    case 21: // $76
      var $77=$lmirrorcount;
      var $78=$lmirrorbits;
      var $79=1 << $78;
      var $80=(($77)>>>0) < (($79)>>>0);
      if ($80) { __label__ = 22; break; } else { __label__ = 30; break; }
    case 22: // $81
      var $82=$hmirrorbase;
      $lmirrorbase=$82;
      $bit3=0;
      __label__ = 23; break;
    case 23: // $83
      var $84=$bit3;
      var $85=$lmirrorbits;
      var $86=(($84)>>>0) < (($85)>>>0);
      if ($86) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $87
      var $88=$lmirrorcount;
      var $89=$bit3;
      var $90=1 << $89;
      var $91=$88 & $90;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $93
      var $94=$bit3;
      var $95=(($lmirrorbit+($94<<2))|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$lmirrorbase;
      var $98=$97 | $96;
      $lmirrorbase=$98;
      __label__ = 26; break;
    case 26: // $99
      __label__ = 27; break;
    case 27: // $100
      var $101=$bit3;
      var $102=(($101+1)|0);
      $bit3=$102;
      __label__ = 23; break;
    case 28: // $103
      var $104=(($6+12)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+52)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$2;
      var $109=$lmirrorbase;
      var $110=(($108+$109)|0);
      var $111=$3;
      var $112=$lmirrorbase;
      var $113=(($111+$112)|0);
      __ZN16direct_read_data26remove_intersecting_rangesEjj($107, $110, $113);
      __label__ = 29; break;
    case 29: // $114
      var $115=$lmirrorcount;
      var $116=(($115+1)|0);
      $lmirrorcount=$116;
      __label__ = 21; break;
    case 30: // $117
      var $118=$2;
      var $119=$hmirrorbase;
      var $120=(($118+$119)|0);
      var $121=__ZNK13address_table12level1_indexEj($6, $120);
      $cur_index=$121;
      var $122=$cur_index;
      var $123=$3;
      var $124=$hmirrorbase;
      var $125=(($123+$124)|0);
      var $126=__ZNK13address_table12level1_indexEj($6, $125);
      var $127=(($122)|0)==(($126)|0);
      if ($127) { __label__ = 31; break; } else { __label__ = 43; break; }
    case 31: // $128
      var $129=$hmirrorcount;
      var $130=(($129)|0)!=0;
      if ($130) { __label__ = 32; break; } else { __label__ = 42; break; }
    case 32: // $131
      var $132=$prev_entry;
      var $133=(($132)&255);
      var $134=$cur_index;
      var $135=(($6+4)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+$134)|0);
      var $138=HEAPU8[($137)];
      var $139=(($138)&255);
      var $140=(($133)|0)==(($139)|0);
      if ($140) { __label__ = 33; break; } else { __label__ = 42; break; }
    case 33: // $141
      __label__ = 34; break;
    case 34: // $142
      __label__ = 35; break;
    case 35: // $143
      var $144=$cur_index;
      var $145=(($6+4)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($146+$144)|0);
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=(($149)|0) >= 192;
      if ($150) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $151
      var $152=$cur_index;
      var $153=(($6+4)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($154+$152)|0);
      var $156=HEAP8[($155)];
      __ZN13address_table16subtable_releaseEh($6, $156);
      __label__ = 38; break;
    case 37: // $157
      var $158=$cur_index;
      var $159=(($6+4)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160+$158)|0);
      var $162=HEAP8[($161)];
      __ZN13address_table13handler_unrefEh($6, $162);
      __label__ = 38; break;
    case 38: // $163
      var $164=$prev_index;
      var $165=(($6+4)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166+$164)|0);
      var $168=HEAPU8[($167)];
      var $169=(($168)&255);
      var $170=(($169)|0) >= 192;
      if ($170) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $171
      var $172=$prev_index;
      var $173=(($6+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=(($174+$172)|0);
      var $176=HEAP8[($175)];
      __ZN13address_table16subtable_reallocEh($6, $176);
      __label__ = 41; break;
    case 40: // $177
      var $178=$prev_index;
      var $179=(($6+4)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180+$178)|0);
      var $182=HEAP8[($181)];
      __ZN13address_table11handler_refEhi($6, $182, 1);
      __label__ = 41; break;
    case 41: // $183
      var $184=$prev_index;
      var $185=(($6+4)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($186+$184)|0);
      var $188=HEAP8[($187)];
      var $189=$cur_index;
      var $190=(($6+4)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=(($191+$189)|0);
      HEAP8[($192)]=$188;
      __label__ = 54; break;
    case 42: // $193
      var $194=$cur_index;
      $prev_index=$194;
      var $195=$cur_index;
      var $196=(($6+4)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($197+$195)|0);
      var $199=HEAP8[($198)];
      $prev_entry=$199;
      __label__ = 43; break;
    case 43: // $200
      $lmirrorcount4=0;
      __label__ = 44; break;
    case 44: // $201
      var $202=$lmirrorcount4;
      var $203=$lmirrorbits;
      var $204=1 << $203;
      var $205=(($202)>>>0) < (($204)>>>0);
      if ($205) { __label__ = 45; break; } else { __label__ = 53; break; }
    case 45: // $206
      var $207=$hmirrorbase;
      $lmirrorbase5=$207;
      $bit6=0;
      __label__ = 46; break;
    case 46: // $208
      var $209=$bit6;
      var $210=$lmirrorbits;
      var $211=(($209)>>>0) < (($210)>>>0);
      if ($211) { __label__ = 47; break; } else { __label__ = 51; break; }
    case 47: // $212
      var $213=$lmirrorcount4;
      var $214=$bit6;
      var $215=1 << $214;
      var $216=$213 & $215;
      var $217=(($216)|0)!=0;
      if ($217) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $218
      var $219=$bit6;
      var $220=(($lmirrorbit+($219<<2))|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=$lmirrorbase5;
      var $223=$222 | $221;
      $lmirrorbase5=$223;
      __label__ = 49; break;
    case 49: // $224
      __label__ = 50; break;
    case 50: // $225
      var $226=$bit6;
      var $227=(($226+1)|0);
      $bit6=$227;
      __label__ = 46; break;
    case 51: // $228
      var $229=$2;
      var $230=$lmirrorbase5;
      var $231=(($229+$230)|0);
      var $232=$3;
      var $233=$lmirrorbase5;
      var $234=(($232+$233)|0);
      var $235=$5;
      __ZN13address_table14populate_rangeEjjh($6, $231, $234, $235);
      __label__ = 52; break;
    case 52: // $236
      var $237=$lmirrorcount4;
      var $238=(($237+1)|0);
      $lmirrorcount4=$238;
      __label__ = 44; break;
    case 53: // $239
      __label__ = 54; break;
    case 54: // $240
      var $241=$hmirrorcount;
      var $242=(($241+1)|0);
      $hmirrorcount=$242;
      __label__ = 13; break;
    case 55: // $243
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table23populate_range_mirroredEjjjh["X"]=1;

function __ZN16direct_read_data12force_updateEh($this, $if_match) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$if_match;
      var $3=$1;
      var $4=(($3+24)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$2;
      var $8=(($7)&255);
      var $9=(($6)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      __ZN16direct_read_data12force_updateEv($3);
      __label__ = 2; break;
    case 2: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_table11setup_rangeEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE($this, $addrstart, $addrend, $addrmask, $addrmirror, $mask$0, $mask$1, $entries) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $7;
      var $testmask=__stackBase__+8;
      $1=$this;
      $2=$addrstart;
      $3=$addrend;
      $4=$addrmask;
      $5=$addrmirror;
      var $st$13$0=(($6)|0);
      HEAP32[(($st$13$0)>>2)]=$mask$0;
      var $st$13$1=(($6+4)|0);
      HEAP32[(($st$13$1)>>2)]=$mask$1;
      $7=$entries;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK13address_space10data_widthEv($10);
      var $12=(($11-1)|0);
      var $13$0=$12;
      var $13$1=0;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $14=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=($14$0 << 1) | (0 >>> 31);
      var $15$1=($14$1 << 1) | ($14$0 >>> 31);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $16$0 = ((($15$0)>>>0)+((($15$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($15$0)>>>0)+((($15$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$33$0=(($testmask)|0);
      HEAP32[(($st$33$0)>>2)]=$16$0;
      var $st$33$1=(($testmask+4)|0);
      HEAP32[(($st$33$1)>>2)]=$16$1;
      var $st$37$0=(($6)|0);
      var $17$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($6+4)|0);
      var $17$1=HEAP32[(($st$37$1)>>2)];
      var $st$41$0=(($testmask)|0);
      var $18$0=HEAP32[(($st$41$0)>>2)];
      var $st$41$1=(($testmask+4)|0);
      var $18$1=HEAP32[(($st$41$1)>>2)];
      var $19$0=$17$0 & $18$0;
      var $19$1=$17$1 & $18$1;
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $20=$19$0 == $$emscripten$temp$2$0 && $19$1 == $$emscripten$temp$2$1;
      if ($20) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $21
      var $st$0$0=(($6)|0);
      var $22$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($6+4)|0);
      var $22$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($testmask)|0);
      var $23$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($testmask+4)|0);
      var $23$1=HEAP32[(($st$4$1)>>2)];
      var $24$0=$22$0 & $23$0;
      var $24$1=$22$1 & $23$1;
      var $st$10$0=(($testmask)|0);
      var $25$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($testmask+4)|0);
      var $25$1=HEAP32[(($st$10$1)>>2)];
      var $26=$24$0 == $25$0 && $24$1 == $25$1;
      if ($26) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $27
      var $28=$2;
      var $29=$3;
      var $30=$4;
      var $31=$5;
      var $32=$7;
      __ZN13address_table17setup_range_solidEjjjjRNSt3__14listIjNS0_9allocatorIjEEEE($8, $28, $29, $30, $31, $32);
      __label__ = 4; break;
    case 3: // $33
      var $34=$2;
      var $35=$3;
      var $36=$4;
      var $37=$5;
      var $st$4$0=(($6)|0);
      var $38$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($6+4)|0);
      var $38$1=HEAP32[(($st$4$1)>>2)];
      var $39=$7;
      __ZN13address_table18setup_range_maskedEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE($8, $34, $35, $36, $37, $38$0, $38$1, $39);
      __label__ = 4; break;
    case 4: // $40
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table11setup_rangeEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE["X"]=1;

function __ZN13address_table17setup_range_solidEjjjjRNSt3__14listIjNS0_9allocatorIjEEEE($this, $addrstart, $addrend, $addrmask, $addrmirror, $entries) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $entry;
  var $7=__stackBase__;
  $1=$this;
  $2=$addrstart;
  $3=$addrend;
  $4=$addrmask;
  $5=$addrmirror;
  $6=$entries;
  var $8=$1;
  var $9=__ZN13address_table16get_free_handlerEv($8);
  $entry=$9;
  var $10=$6;
  var $11=$entry;
  var $12=(($11)&255);
  HEAP32[(($7)>>2)]=$12;
  __ZNSt3__14listIjNS_9allocatorIjEEE9push_backERKj($10, $7);
  var $13=$2;
  var $14=$3;
  var $15=$4;
  var $16=$5;
  var $17=$entry;
  __ZN13address_table9map_rangeEjjjjh($8, $13, $14, $15, $16, $17);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13address_table16get_free_handlerEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $handler;
      $1=$this;
      var $4=$1;
      var $5=(($4+348)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(1032);
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($11, ((STRING_TABLE.__str312922)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      ___cxa_throw($10, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      ___cxa_free_exception($10);
      __label__ = 5; break;
    case 4: // $17
      var $18=(($4+348)|0);
      var $19=HEAP8[($18)];
      $handler=$19;
      var $20=$handler;
      var $21=(($20)&255);
      var $22=(($21-128)|0);
      var $23=(($4+284)|0);
      var $24=(($23+$22)|0);
      var $25=HEAP8[($24)];
      var $26=(($4+348)|0);
      HEAP8[($26)]=$25;
      var $27=$handler;
      ;
      return $27;
    case 5: // $28
      var $29=$2;
      var $30=$2;
      var $31=$3;
      var $32=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30, tempValue);
      var $33=($32.f1 = $31, $32);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_table18setup_range_maskedEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE($this, $addrstart, $addrend, $addrmask, $addrmirror, $mask$0, $mask$1, $entries) {
  var __stackBase__  = STACKTOP; STACKTOP += 408; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68;
      var $69;
      var $70;
      var $71;
      var $72;
      var $73=__stackBase__+268;
      var $74;
      var $bytestart=__stackBase__+276;
      var $byteend=__stackBase__+280;
      var $bytemask=__stackBase__+284;
      var $bytemirror=__stackBase__+288;
      var $75;
      var $76;
      var $range_override=__stackBase__+292;
      var $range_partial=__stackBase__+304;
      var $77=__stackBase__+316;
      var $base_mirror;
      var $base_address;
      var $end_address;
      var $range_start=__stackBase__+320;
      var $range_end=__stackBase__+324;
      var $entry=__stackBase__+328;
      var $stop_address;
      var $78=__stackBase__+332;
      var $79=__stackBase__+340;
      var $entry1;
      var $curentry;
      var $i=__stackBase__+348;
      var $80=__stackBase__+352;
      var $81=__stackBase__+356;
      var $82=__stackBase__+360;
      var $83=__stackBase__+364;
      var $84=__stackBase__+368;
      var $i2=__stackBase__+372;
      var $85=__stackBase__+376;
      var $86=__stackBase__+380;
      var $87=__stackBase__+384;
      var $base_entry;
      var $entry3;
      var $curentry4;
      var $j=__stackBase__+388;
      var $88=__stackBase__+392;
      var $89=__stackBase__+396;
      var $90=__stackBase__+400;
      var $91=__stackBase__+404;
      $68=$this;
      $69=$addrstart;
      $70=$addrend;
      $71=$addrmask;
      $72=$addrmirror;
      var $st$117$0=(($73)|0);
      HEAP32[(($st$117$0)>>2)]=$mask$0;
      var $st$117$1=(($73+4)|0);
      HEAP32[(($st$117$1)>>2)]=$mask$1;
      $74=$entries;
      var $92=$68;
      var $93=$69;
      HEAP32[(($bytestart)>>2)]=$93;
      var $94=$70;
      HEAP32[(($byteend)>>2)]=$94;
      var $95=$71;
      HEAP32[(($bytemask)>>2)]=$95;
      var $96=$72;
      HEAP32[(($bytemirror)>>2)]=$96;
      var $97=(($92+12)|0);
      var $98=HEAP32[(($97)>>2)];
      __ZN13address_space16adjust_addressesERjS0_S0_S0_($98, $bytestart, $byteend, $bytemask, $bytemirror);
      __label__ = 1; break;
    case 1: // $99
      var $100=$69;
      var $101=$70;
      var $102=(($100)>>>0) <= (($101)>>>0);
      if ($102) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $103
      var $104=___cxa_allocate_exception(1032);
      var $105=$104;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($105, ((STRING_TABLE.__str272918)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str322923)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2891)|0),HEAP32[((tempInt+8)>>2)]=3431,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $106
      ___cxa_throw($104, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $107
      var $108=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $109=$108.f0;
      $75=$109;
      var $110=$108.f1;
      $76=$110;
      ___cxa_free_exception($104);
      __label__ = 94; break;
    case 5: // $111
      __label__ = 6; break;
    case 6: // $112
      __label__ = 7; break;
    case 7: // $113
      var $114=HEAP32[(($bytestart)>>2)];
      var $115=(($92+12)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=__ZNK13address_space10data_widthEv($116);
      var $118=(((($117)|0)/8)|0);
      var $119=(($118-1)|0);
      var $120=$114 & $119;
      var $121=(($120)|0)==0;
      if ($121) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $122
      var $123=___cxa_allocate_exception(1032);
      var $124=$123;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($124, ((STRING_TABLE.__str272918)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str332924)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2891)|0),HEAP32[((tempInt+8)>>2)]=3432,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $125
      ___cxa_throw($123, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 10: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $128=$127.f0;
      $75=$128;
      var $129=$127.f1;
      $76=$129;
      ___cxa_free_exception($123);
      __label__ = 94; break;
    case 11: // $130
      __label__ = 12; break;
    case 12: // $131
      __label__ = 13; break;
    case 13: // $132
      var $133=HEAP32[(($byteend)>>2)];
      var $134=(($92+12)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=__ZNK13address_space10data_widthEv($135);
      var $137=(((($136)|0)/8)|0);
      var $138=(($137-1)|0);
      var $139=$133 & $138;
      var $140=(($92+12)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=__ZNK13address_space10data_widthEv($141);
      var $143=(((($142)|0)/8)|0);
      var $144=(($143-1)|0);
      var $145=(($139)|0)==(($144)|0);
      if ($145) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $146
      var $147=___cxa_allocate_exception(1032);
      var $148=$147;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($148, ((STRING_TABLE.__str272918)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str342925)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str2891)|0),HEAP32[((tempInt+8)>>2)]=3433,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $149
      ___cxa_throw($147, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 16: // $150
      var $151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $152=$151.f0;
      $75=$152;
      var $153=$151.f1;
      $76=$153;
      ___cxa_free_exception($147);
      __label__ = 94; break;
    case 17: // $154
      __label__ = 18; break;
    case 18: // $155
      FUNCTION_TABLE[__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC1Ev]($range_override);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEC1ERKS8_]($range_partial, $77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 29; break; }
    case 19: // $156
      $base_mirror=0;
      __label__ = 20; break;
    case 20: // $157
      var $158=$base_mirror;
      var $159=HEAP32[(($bytestart)>>2)];
      var $160=$158 | $159;
      $base_address=$160;
      var $161=$base_mirror;
      var $162=HEAP32[(($byteend)>>2)];
      var $163=$161 | $162;
      $end_address=$163;
      __label__ = 21; break;
    case 21: // $164
      var $165=$base_address;
      var $166=(function() { try { __THREW__ = false; return __ZNK13address_table12derive_rangeEjRjS0_($92, $165, $range_start, $range_end) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 30; break; };
    case 22: // $167
      HEAP8[($entry)]=$166;
      var $168=HEAPU32[(($range_end)>>2)];
      var $169=$end_address;
      var $170=(($168)>>>0) > (($169)>>>0);
      var $171=$end_address;
      var $172=HEAP32[(($range_end)>>2)];
      var $173=$170 ? $171 : $172;
      $stop_address=$173;
      var $174=HEAPU8[($entry)];
      var $175=(($174)&255);
      var $176=(($175)|0) < 128;
      if ($176) { __label__ = 26; break; } else { __label__ = 23; break; }
    case 23: // $177
      var $178=$92;
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+8)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=HEAPU8[($entry)];
      var $183=(($182)&255);
      var $184=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$181]($92, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 30; break; };
    case 24: // $185
      var $st$0$0=(($73)|0);
      var $186$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($73+4)|0);
      var $186$1=HEAP32[(($st$0$1)>>2)];
      var $187=(function() { try { __THREW__ = false; return __ZN13handler_entry17overriden_by_maskEy($184, $186$0, $186$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 30; break; };
      var $187$0=$187[0];
    case 25: // $188
      if ($187) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $189
      var $190=$base_address;
      var $191=$stop_address;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12_GLOBAL__N_18subrangeC1Ejj]($78, $190, $191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 27: // $192
      (function() { try { __THREW__ = false; return __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE9push_backERKS2_($range_override, $78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $193
      __label__ = 35; break;
    case 29: // $194
      var $195=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $196=$195.f0;
      $75=$196;
      var $197=$195.f1;
      $76=$197;
      __label__ = 92; break;
    case 30: // $198
      var $199=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $200=$199.f0;
      $75=$200;
      var $201=$199.f1;
      $76=$201;
      __label__ = 90; break;
    case 31: // $202
      var $203=(function() { try { __THREW__ = false; return __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEixERSA_($range_partial, $entry) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 30; break; };
    case 32: // $204
      var $205=$base_address;
      var $206=$stop_address;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12_GLOBAL__N_18subrangeC1Ejj]($79, $205, $206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 30; break; }
    case 33: // $207
      (function() { try { __THREW__ = false; return __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE9push_backERKS2_($203, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 30; break; }
    case 34: // $208
      __label__ = 35; break;
    case 35: // $209
      var $210=$stop_address;
      var $211=(($210+1)|0);
      $base_address=$211;
      __label__ = 36; break;
    case 36: // $212
      var $213=$base_address;
      var $214=$end_address;
      var $215=(($214+1)|0);
      var $216=(($213)|0)!=(($215)|0);
      if ($216) { __label__ = 21; break; } else { __label__ = 37; break; }
    case 37: // $217
      var $218=$base_mirror;
      var $219=(($218+1)|0);
      var $220=HEAP32[(($bytemirror)>>2)];
      var $221=$220 ^ -1;
      var $222=(($219+$221)|0);
      var $223=HEAP32[(($bytemirror)>>2)];
      var $224=$222 & $223;
      $base_mirror=$224;
      __label__ = 38; break;
    case 38: // $225
      var $226=$base_mirror;
      var $227=(($226)|0)!=0;
      if ($227) { __label__ = 20; break; } else { __label__ = 39; break; }
    case 39: // $228
      var $229=$67;
      HEAP32[(($67)>>2)]=$range_override;
      var $230=HEAP32[(($67)>>2)];
      var $231=$230;
      var $232=$66;
      HEAP32[(($66)>>2)]=$231;
      var $233=HEAP32[(($66)>>2)];
      var $234=$65;
      HEAP32[(($65)>>2)]=$233;
      var $235=HEAP32[(($65)>>2)];
      var $236=(($235+8)|0);
      var $237=$64;
      HEAP32[(($64)>>2)]=$236;
      var $238=HEAP32[(($64)>>2)];
      var $239=$238;
      var $240=$63;
      HEAP32[(($63)>>2)]=$239;
      var $241=HEAP32[(($63)>>2)];
      var $242=(($241)|0);
      var $243=$63;
      var $244=$64;
      var $245=$65;
      var $246=HEAP32[(($242)>>2)];
      var $247=(($246)|0)==0;
      var $248=$66;
      var $249=$67;
      if ($247) { __label__ = 55; break; } else { __label__ = 40; break; }
    case 40: // $250
      var $251=(function() { try { __THREW__ = false; return __ZN13address_table16get_free_handlerEv($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 30; break; };
    case 41: // $252
      $entry1=$251;
      var $253=$92;
      var $254=HEAP32[(($253)>>2)];
      var $255=(($254+8)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=$entry1;
      var $258=(($257)&255);
      var $259=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$256]($92, $258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 30; break; };
    case 42: // $260
      $curentry=$259;
      var $261=$curentry;
      var $262=HEAP32[(($bytestart)>>2)];
      var $263=HEAP32[(($byteend)>>2)];
      var $264=HEAP32[(($bytemask)>>2)];
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($261, $262, $263, $264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 30; break; }
    case 43: // $265
      var $266=$62;
      HEAP32[(($62)>>2)]=$range_override;
      var $267=HEAP32[(($62)>>2)];
      var $268=$267;
      var $269=$61;
      HEAP32[(($61)>>2)]=$268;
      var $270=HEAP32[(($61)>>2)];
      var $271=(($270)|0);
      var $272=(($271+4)|0);
      var $273=HEAP32[(($272)>>2)];
      FUNCTION_TABLE[__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPNS_11__list_nodeIS2_S3_EE]($80, $273);
      var $274=$61;
      var $275=$62;
      FUNCTION_TABLE[__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1ENS_15__list_iteratorIS2_S3_EE]($i, $80);
      __label__ = 44; break;
    case 44: // $276
      var $277=$60;
      HEAP32[(($60)>>2)]=$range_override;
      var $278=HEAP32[(($60)>>2)];
      var $279=$278;
      var $280=$59;
      HEAP32[(($59)>>2)]=$279;
      var $281=HEAP32[(($59)>>2)];
      var $282=(($281)|0);
      var $283=$282;
      FUNCTION_TABLE[__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPNS_11__list_nodeIS2_S3_EE]($82, $283);
      var $284=$59;
      var $285=$60;
      FUNCTION_TABLE[__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1ENS_15__list_iteratorIS2_S3_EE]($81, $82);
      var $286=$57;
      var $287=$58;
      HEAP32[(($57)>>2)]=$i;
      HEAP32[(($58)>>2)]=$81;
      var $288=HEAP32[(($57)>>2)];
      var $289=HEAP32[(($58)>>2)];
      var $290=$55;
      var $291=$56;
      HEAP32[(($55)>>2)]=$288;
      HEAP32[(($56)>>2)]=$289;
      var $292=HEAP32[(($55)>>2)];
      var $293=(($292)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=HEAP32[(($56)>>2)];
      var $296=(($295)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=(($294)|0)==(($297)|0);
      var $299=$55;
      var $300=$56;
      var $301=$298 ^ 1;
      var $302=$57;
      var $303=$58;
      __label__ = 45; break;
    case 45: // $304
      if ($301) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $305
      var $306=$54;
      HEAP32[(($54)>>2)]=$i;
      var $307=HEAP32[(($54)>>2)];
      var $308=$53;
      HEAP32[(($53)>>2)]=$307;
      var $309=HEAP32[(($53)>>2)];
      var $310=(($309)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(($311+8)|0);
      var $313=$53;
      var $314=$54;
      __label__ = 47; break;
    case 47: // $315
      var $316=(($312)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=$52;
      HEAP32[(($52)>>2)]=$i;
      var $319=HEAP32[(($52)>>2)];
      var $320=$51;
      HEAP32[(($51)>>2)]=$319;
      var $321=HEAP32[(($51)>>2)];
      var $322=(($321)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=(($323+8)|0);
      var $325=$51;
      var $326=$52;
      __label__ = 48; break;
    case 48: // $327
      var $328=(($324+4)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=$entry1;
      (function() { try { __THREW__ = false; return __ZN13address_table14populate_rangeEjjh($92, $317, $329, $330) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 30; break; }
    case 49: // $331
      __label__ = 50; break;
    case 50: // $332
      var $333=$49;
      var $334=$50;
      HEAP32[(($49)>>2)]=$i;
      HEAP32[(($50)>>2)]=0;
      var $335=HEAP32[(($49)>>2)];
      var $336=$83;
      var $337=$335;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($336)>>2)]=HEAP32[(($337)>>2)];
      var $338=$48;
      HEAP32[(($48)>>2)]=$335;
      var $339=HEAP32[(($48)>>2)];
      var $340=(($339)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$341;
      var $343=(($342+4)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=(($339)|0);
      HEAP32[(($345)>>2)]=$344;
      var $346=$48;
      var $347=$49;
      var $348=$50;
      __label__ = 51; break;
    case 51: // $349
      __label__ = 44; break;
    case 52: // $350
      var $351=$74;
      var $352=$entry1;
      var $353=(($352)&255);
      HEAP32[(($84)>>2)]=$353;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIjNS_9allocatorIjEEE9push_backERKj($351, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 30; break; }
    case 53: // $354
      var $355=(($92+12)|0);
      var $356=HEAP32[(($355)>>2)];
      var $357=(($356+52)|0);
      var $358=HEAP32[(($357)>>2)];
      var $359=$entry1;
      (function() { try { __THREW__ = false; return __ZN16direct_read_data12force_updateEh($358, $359) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 30; break; }
    case 54: // $360
      __label__ = 55; break;
    case 55: // $361
      var $362=$43;
      HEAP32[(($43)>>2)]=$range_partial;
      var $363=HEAP32[(($43)>>2)];
      var $364=(($363)|0);
      var $365=$42;
      HEAP32[(($42)>>2)]=$364;
      var $366=HEAP32[(($42)>>2)];
      var $367=(($366+8)|0);
      var $368=$41;
      HEAP32[(($41)>>2)]=$367;
      var $369=HEAP32[(($41)>>2)];
      var $370=$369;
      var $371=$40;
      HEAP32[(($40)>>2)]=$370;
      var $372=HEAP32[(($40)>>2)];
      var $373=(($372)|0);
      var $374=$40;
      var $375=$41;
      var $376=$42;
      var $377=HEAP32[(($373)>>2)];
      var $378=(($377)|0)==0;
      var $379=$43;
      if ($378) { __label__ = 88; break; } else { __label__ = 56; break; }
    case 56: // $380
      var $381=$38;
      var $382=$39;
      HEAP32[(($38)>>2)]=$range_partial;
      var $383=HEAP32[(($38)>>2)];
      var $384=(($383)|0);
      var $385=$37;
      HEAP32[(($37)>>2)]=$384;
      var $386=HEAP32[(($37)>>2)];
      var $387=$36;
      HEAP32[(($36)>>2)]=$386;
      var $388=HEAP32[(($36)>>2)];
      var $389=(($388)|0);
      var $390=$36;
      var $391=HEAP32[(($389)>>2)];
      FUNCTION_TABLE[__ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC1ESC_]($39, $391);
      var $392=$37;
      FUNCTION_TABLE[__ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC1ESE_]($85, $39);
      var $393=$38;
      var $394=$39;
      FUNCTION_TABLE[__ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC1ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE]($i2, $85);
      __label__ = 57; break;
    case 57: // $395
      var $396=$34;
      var $397=$35;
      HEAP32[(($34)>>2)]=$range_partial;
      var $398=HEAP32[(($34)>>2)];
      var $399=(($398)|0);
      var $400=$33;
      HEAP32[(($33)>>2)]=$399;
      var $401=HEAP32[(($33)>>2)];
      var $402=$32;
      HEAP32[(($32)>>2)]=$401;
      var $403=HEAP32[(($32)>>2)];
      var $404=(($403+4)|0);
      var $405=$31;
      HEAP32[(($31)>>2)]=$404;
      var $406=HEAP32[(($31)>>2)];
      var $407=$406;
      var $408=$30;
      HEAP32[(($30)>>2)]=$407;
      var $409=HEAP32[(($30)>>2)];
      var $410=(($409)|0);
      var $411=$30;
      var $412=$31;
      var $413=$29;
      HEAP32[(($29)>>2)]=$410;
      var $414=HEAP32[(($29)>>2)];
      var $415=$28;
      HEAP32[(($28)>>2)]=$414;
      var $416=HEAP32[(($28)>>2)];
      var $417=$416;
      var $418=$417;
      var $419=$28;
      var $420=$29;
      var $421=$418;
      var $422=$32;
      FUNCTION_TABLE[__ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC1ESC_]($35, $421);
      var $423=$33;
      FUNCTION_TABLE[__ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC1ESE_]($87, $35);
      var $424=$34;
      var $425=$35;
      FUNCTION_TABLE[__ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC1ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE]($86, $87);
      var $426=$26;
      var $427=$27;
      HEAP32[(($26)>>2)]=$i2;
      HEAP32[(($27)>>2)]=$86;
      var $428=HEAP32[(($26)>>2)];
      var $429=(($428)|0);
      var $430=HEAP32[(($27)>>2)];
      var $431=(($430)|0);
      var $432=$24;
      var $433=$25;
      HEAP32[(($24)>>2)]=$429;
      HEAP32[(($25)>>2)]=$431;
      var $434=HEAP32[(($24)>>2)];
      var $435=HEAP32[(($25)>>2)];
      var $436=$22;
      var $437=$23;
      HEAP32[(($22)>>2)]=$434;
      HEAP32[(($23)>>2)]=$435;
      var $438=HEAP32[(($22)>>2)];
      var $439=(($438)|0);
      var $440=HEAP32[(($439)>>2)];
      var $441=HEAP32[(($23)>>2)];
      var $442=(($441)|0);
      var $443=HEAP32[(($442)>>2)];
      var $444=(($440)|0)==(($443)|0);
      var $445=$22;
      var $446=$23;
      var $447=$444 ^ 1;
      var $448=$24;
      var $449=$25;
      var $450=$26;
      var $451=$27;
      __label__ = 58; break;
    case 58: // $452
      if ($447) { __label__ = 59; break; } else { __label__ = 87; break; }
    case 59: // $453
      var $454=$92;
      var $455=HEAP32[(($454)>>2)];
      var $456=(($455+8)|0);
      var $457=HEAP32[(($456)>>2)];
      var $458=$21;
      HEAP32[(($21)>>2)]=$i2;
      var $459=HEAP32[(($21)>>2)];
      var $460=(($459)|0);
      var $461=$20;
      HEAP32[(($20)>>2)]=$460;
      var $462=HEAP32[(($20)>>2)];
      var $463=(($462)|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=(($464+16)|0);
      var $466=$20;
      var $467=$465;
      var $468=$21;
      __label__ = 60; break;
    case 60: // $469
      var $470=(($467)|0);
      var $471=HEAPU8[($470)];
      var $472=(($471)&255);
      var $473=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$457]($92, $472) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 30; break; };
    case 61: // $474
      $base_entry=$473;
      var $475=$base_entry;
      var $476=(function() { try { __THREW__ = false; return __ZNK13handler_entry8bytemaskEv($475) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 30; break; };
    case 62: // $477
      var $478=HEAP32[(($bytemask)>>2)];
      var $479=(($476)|0)!=(($478)|0);
      if ($479) { __label__ = 63; break; } else { __label__ = 66; break; }
    case 63: // $480
      var $481=___cxa_allocate_exception(1032);
      var $482=$481;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($482, ((STRING_TABLE.__str352926)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $483
      (function() { try { __THREW__ = false; return ___cxa_throw($481, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 30; break; }
    case 65: // $484
      var $485=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $486=$485.f0;
      $75=$486;
      var $487=$485.f1;
      $76=$487;
      ___cxa_free_exception($481);
      __label__ = 90; break;
    case 66: // $488
      var $489=(function() { try { __THREW__ = false; return __ZN13address_table16get_free_handlerEv($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 30; break; };
    case 67: // $490
      $entry3=$489;
      var $491=$92;
      var $492=HEAP32[(($491)>>2)];
      var $493=(($492+8)|0);
      var $494=HEAP32[(($493)>>2)];
      var $495=$entry3;
      var $496=(($495)&255);
      var $497=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$494]($92, $496) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 30; break; };
    case 68: // $498
      $curentry4=$497;
      var $499=$curentry4;
      var $500=$499;
      var $501=HEAP32[(($500)>>2)];
      var $502=(($501+16)|0);
      var $503=HEAP32[(($502)>>2)];
      var $504=$base_entry;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$503]($499, $504) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 30; break; }
    case 69: // $505
      var $506=$curentry4;
      var $st$1$0=(($73)|0);
      var $507$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($73+4)|0);
      var $507$1=HEAP32[(($st$1$1)>>2)];
      (function() { try { __THREW__ = false; return __ZN13handler_entry26clear_conflicting_subunitsEy($506, $507$0, $507$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 30; break; }
    case 70: // $508
      var $509=$curentry4;
      var $510=HEAP32[(($bytestart)>>2)];
      var $511=HEAP32[(($byteend)>>2)];
      var $512=HEAP32[(($bytemask)>>2)];
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($509, $510, $511, $512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 30; break; }
    case 71: // $513
      var $514=$19;
      HEAP32[(($19)>>2)]=$i2;
      var $515=HEAP32[(($19)>>2)];
      var $516=(($515)|0);
      var $517=$18;
      HEAP32[(($18)>>2)]=$516;
      var $518=HEAP32[(($18)>>2)];
      var $519=(($518)|0);
      var $520=HEAP32[(($519)>>2)];
      var $521=(($520+16)|0);
      var $522=$18;
      var $523=$521;
      var $524=$19;
      __label__ = 72; break;
    case 72: // $525
      var $526=(($523+4)|0);
      var $527=$17;
      HEAP32[(($17)>>2)]=$526;
      var $528=HEAP32[(($17)>>2)];
      var $529=$528;
      var $530=$16;
      HEAP32[(($16)>>2)]=$529;
      var $531=HEAP32[(($16)>>2)];
      var $532=(($531)|0);
      var $533=(($532+4)|0);
      var $534=HEAP32[(($533)>>2)];
      FUNCTION_TABLE[__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPKNS_11__list_nodeIS2_S3_EE]($j, $534);
      var $535=$16;
      var $536=$17;
      __label__ = 73; break;
    case 73: // $537
      var $538=$15;
      HEAP32[(($15)>>2)]=$i2;
      var $539=HEAP32[(($15)>>2)];
      var $540=(($539)|0);
      var $541=$14;
      HEAP32[(($14)>>2)]=$540;
      var $542=HEAP32[(($14)>>2)];
      var $543=(($542)|0);
      var $544=HEAP32[(($543)>>2)];
      var $545=(($544+16)|0);
      var $546=$14;
      var $547=$545;
      var $548=$15;
      __label__ = 74; break;
    case 74: // $549
      var $550=(($547+4)|0);
      var $551=$10;
      HEAP32[(($10)>>2)]=$550;
      var $552=HEAP32[(($10)>>2)];
      var $553=$552;
      var $554=$9;
      HEAP32[(($9)>>2)]=$553;
      var $555=HEAP32[(($9)>>2)];
      var $556=(($555)|0);
      var $557=$556;
      FUNCTION_TABLE[__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPKNS_11__list_nodeIS2_S3_EE]($88, $557);
      var $558=$9;
      var $559=$10;
      var $560=$7;
      var $561=$8;
      HEAP32[(($7)>>2)]=$j;
      HEAP32[(($8)>>2)]=$88;
      var $562=HEAP32[(($7)>>2)];
      var $563=HEAP32[(($8)>>2)];
      var $564=$5;
      var $565=$6;
      HEAP32[(($5)>>2)]=$562;
      HEAP32[(($6)>>2)]=$563;
      var $566=HEAP32[(($5)>>2)];
      var $567=(($566)|0);
      var $568=HEAP32[(($567)>>2)];
      var $569=HEAP32[(($6)>>2)];
      var $570=(($569)|0);
      var $571=HEAP32[(($570)>>2)];
      var $572=(($568)|0)==(($571)|0);
      var $573=$5;
      var $574=$6;
      var $575=$572 ^ 1;
      var $576=$7;
      var $577=$8;
      __label__ = 75; break;
    case 75: // $578
      if ($575) { __label__ = 76; break; } else { __label__ = 82; break; }
    case 76: // $579
      var $580=$2;
      HEAP32[(($2)>>2)]=$j;
      var $581=HEAP32[(($2)>>2)];
      var $582=$1;
      HEAP32[(($1)>>2)]=$581;
      var $583=HEAP32[(($1)>>2)];
      var $584=(($583)|0);
      var $585=HEAP32[(($584)>>2)];
      var $586=(($585+8)|0);
      var $587=$1;
      var $588=$2;
      __label__ = 77; break;
    case 77: // $589
      var $590=(($586)|0);
      var $591=HEAP32[(($590)>>2)];
      var $592=$4;
      HEAP32[(($4)>>2)]=$j;
      var $593=HEAP32[(($4)>>2)];
      var $594=$3;
      HEAP32[(($3)>>2)]=$593;
      var $595=HEAP32[(($3)>>2)];
      var $596=(($595)|0);
      var $597=HEAP32[(($596)>>2)];
      var $598=(($597+8)|0);
      var $599=$3;
      var $600=$4;
      __label__ = 78; break;
    case 78: // $601
      var $602=(($598+4)|0);
      var $603=HEAP32[(($602)>>2)];
      var $604=$entry3;
      (function() { try { __THREW__ = false; return __ZN13address_table14populate_rangeEjjh($92, $591, $603, $604) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 30; break; }
    case 79: // $605
      __label__ = 80; break;
    case 80: // $606
      var $607=$12;
      var $608=$13;
      HEAP32[(($12)>>2)]=$j;
      HEAP32[(($13)>>2)]=0;
      var $609=HEAP32[(($12)>>2)];
      var $610=$89;
      var $611=$609;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($610)>>2)]=HEAP32[(($611)>>2)];
      var $612=$11;
      HEAP32[(($11)>>2)]=$609;
      var $613=HEAP32[(($11)>>2)];
      var $614=(($613)|0);
      var $615=HEAP32[(($614)>>2)];
      var $616=$615;
      var $617=(($616+4)|0);
      var $618=HEAP32[(($617)>>2)];
      var $619=(($613)|0);
      HEAP32[(($619)>>2)]=$618;
      var $620=$11;
      var $621=$12;
      var $622=$13;
      __label__ = 81; break;
    case 81: // $623
      __label__ = 73; break;
    case 82: // $624
      var $625=$74;
      var $626=$entry3;
      var $627=(($626)&255);
      HEAP32[(($90)>>2)]=$627;
      (function() { try { __THREW__ = false; return __ZNSt3__14listIjNS_9allocatorIjEEE9push_backERKj($625, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 30; break; }
    case 83: // $628
      var $629=(($92+12)|0);
      var $630=HEAP32[(($629)>>2)];
      var $631=(($630+52)|0);
      var $632=HEAP32[(($631)>>2)];
      var $633=$entry3;
      (function() { try { __THREW__ = false; return __ZN16direct_read_data12force_updateEh($632, $633) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 30; break; }
    case 84: // $634
      __label__ = 85; break;
    case 85: // $635
      var $636=$46;
      var $637=$47;
      HEAP32[(($46)>>2)]=$i2;
      HEAP32[(($47)>>2)]=0;
      var $638=HEAP32[(($46)>>2)];
      var $639=$91;
      var $640=$638;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($639)>>2)]=HEAP32[(($640)>>2)];
      var $641=$45;
      HEAP32[(($45)>>2)]=$638;
      var $642=HEAP32[(($45)>>2)];
      var $643=(($642)|0);
      var $644=$44;
      HEAP32[(($44)>>2)]=$643;
      var $645=HEAP32[(($44)>>2)];
      var $646=(($645)|0);
      var $647=HEAP32[(($646)>>2)];
      var $648=$647;
      var $649=__ZNSt3__111__tree_nextIPKNS_16__tree_node_baseIPvEEEET_S6_($648);
      var $650=$649;
      var $651=(($645)|0);
      HEAP32[(($651)>>2)]=$650;
      var $652=$44;
      var $653=$45;
      var $654=$46;
      var $655=$47;
      __label__ = 86; break;
    case 86: // $656
      __label__ = 57; break;
    case 87: // $657
      __label__ = 88; break;
    case 88: // $658
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED1Ev]($range_partial) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 29; break; }
    case 89: // $659
      FUNCTION_TABLE[__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED1Ev]($range_override);
      STACKTOP = __stackBase__;
      return;
    case 90: // $660
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED1Ev]($range_partial) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 95; break; }
    case 91: // $661
      __label__ = 92; break;
    case 92: // $662
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED1Ev]($range_override) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 93: // $663
      __label__ = 94; break;
    case 94: // $664
      var $665=$75;
      var $666=$75;
      var $667=$76;
      var $668=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $666, tempValue);
      var $669=($668.f1 = $667, $668);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 95: // $670
      var $671=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 96: // $672
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table18setup_range_maskedEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE["X"]=1;

function __ZNSt3__14listIjNS_9allocatorIjEEE9push_backERKj($this, $__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 488; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__t_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $__tmp_i_i_i2=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $__t21_i_i_i=__stackBase__+240;
      var $57=__stackBase__+248;
      var $58=__stackBase__+252;
      var $59=__stackBase__+256;
      var $60=__stackBase__+264;
      var $61=__stackBase__+268;
      var $62=__stackBase__+272;
      var $63=__stackBase__+276;
      var $__d1_i=__stackBase__+284;
      var $64=__stackBase__+292;
      var $65=__stackBase__+296;
      var $66=__stackBase__+300;
      var $67=__stackBase__+308;
      var $68=__stackBase__+312;
      var $69=__stackBase__+316;
      var $70=__stackBase__+320;
      var $71=__stackBase__+324;
      var $72=__stackBase__+328;
      var $73=__stackBase__+332;
      var $result_i_i_i=__stackBase__+336;
      var $74=__stackBase__+340;
      var $75=__stackBase__+344;
      var $76=__stackBase__+348;
      var $77=__stackBase__+352;
      var $78=__stackBase__+356;
      var $79=__stackBase__+360;
      var $80=__stackBase__+364;
      var $81=__stackBase__+368;
      var $82=__stackBase__+372;
      var $83=__stackBase__+376;
      var $84=__stackBase__+380;
      var $85=__stackBase__+384;
      var $86=__stackBase__+388;
      var $87=__stackBase__+392;
      var $88=__stackBase__+396;
      var $89=__stackBase__+400;
      var $90=__stackBase__+404;
      var $91=__stackBase__+408;
      var $92=__stackBase__+412;
      var $93=__stackBase__+416;
      var $94=__stackBase__+420;
      var $95=__stackBase__+424;
      var $96=__stackBase__+428;
      var $97=__stackBase__+432;
      var $98=__stackBase__+436;
      var $99=__stackBase__+440;
      var $__tmp_i_i_i=__stackBase__+444;
      var $100=__stackBase__+448;
      var $101=__stackBase__+452;
      var $102=__stackBase__+456;
      var $103=__stackBase__+460;
      var $104=__stackBase__+464;
      var $105;
      var $106;
      var $__na;
      var $__hold=__stackBase__+468;
      var $107=__stackBase__+480;
      var $108;
      var $109;
      $105=$this;
      $106=$__x;
      var $110=$105;
      var $111=$110;
      var $112=$104;
      HEAP32[(($104)>>2)]=$111;
      var $113=HEAP32[(($104)>>2)];
      var $114=(($113+8)|0);
      var $115=$103;
      HEAP32[(($103)>>2)]=$114;
      var $116=HEAP32[(($103)>>2)];
      var $117=$116;
      var $118=$102;
      HEAP32[(($102)>>2)]=$117;
      var $119=HEAP32[(($102)>>2)];
      var $120=$119;
      var $121=$102;
      var $122=$103;
      var $123=$104;
      $__na=$120;
      var $124=$__na;
      var $125=$79;
      var $126=$80;
      HEAP32[(($79)>>2)]=$124;
      HEAP32[(($80)>>2)]=1;
      var $127=HEAP32[(($79)>>2)];
      var $128=HEAP32[(($80)>>2)];
      var $129=$76;
      var $130=$77;
      var $131=$78;
      HEAP32[(($76)>>2)]=$127;
      HEAP32[(($77)>>2)]=$128;
      HEAP32[(($78)>>2)]=0;
      var $132=HEAP32[(($76)>>2)];
      var $133=HEAP32[(($77)>>2)];
      var $134=(($133*12)|0);
      var $135=$73;
      var $136=$result_i_i_i;
      var $137=$74;
      var $138=$75;
      HEAP32[(($73)>>2)]=$134;
      var $139=HEAP32[(($73)>>2)];
      var $140=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($139, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $141
      HEAP32[(($result_i_i_i)>>2)]=$140;
      var $142=HEAP32[(($result_i_i_i)>>2)];
      var $143=(($142)|0)==0;
      if ($143) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $144
      var $145=___cxa_allocate_exception(4);
      var $146=$145;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($146);
      (function() { try { __THREW__ = false; return ___cxa_throw($145, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $147
      var $148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $149=$148.f0;
      HEAP32[(($74)>>2)]=$149;
      var $150=$148.f1;
      HEAP32[(($75)>>2)]=$150;
      var $151=HEAP32[(($75)>>2)];
      var $152=(($151)|0) < 0;
      if ($152) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $153
      var $154=HEAP32[(($74)>>2)];
      ___cxa_call_unexpected($154);
      throw "Reached an unreachable!"
    case 5: // $155
      var $156=HEAP32[(($74)>>2)];
      var $157=HEAP32[(($74)>>2)];
      var $158=HEAP32[(($75)>>2)];
      var $159=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $157, tempValue);
      var $160=($159.f1 = $158, $159);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $161
      throw "Reached an unreachable!"
    case 7: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIjPvEEEEE8allocateERS5_j_exit
      var $162=HEAP32[(($result_i_i_i)>>2)];
      var $163=$73;
      var $164=$result_i_i_i;
      var $165=$74;
      var $166=$75;
      var $167=$162;
      var $168=$76;
      var $169=$77;
      var $170=$78;
      var $171=$79;
      var $172=$80;
      var $173=$__na;
      var $174=$70;
      var $175=$71;
      var $176=$72;
      HEAP32[(($70)>>2)]=$107;
      HEAP32[(($71)>>2)]=$173;
      HEAP32[(($72)>>2)]=1;
      var $177=HEAP32[(($70)>>2)];
      var $178=HEAP32[(($72)>>2)];
      var $179=HEAP32[(($71)>>2)];
      var $180=$67;
      var $181=$68;
      var $182=$69;
      HEAP32[(($67)>>2)]=$177;
      HEAP32[(($68)>>2)]=$179;
      HEAP32[(($69)>>2)]=$178;
      var $183=HEAP32[(($67)>>2)];
      var $184=(($183)|0);
      var $185=HEAP32[(($68)>>2)];
      HEAP32[(($184)>>2)]=$185;
      var $186=(($183+4)|0);
      var $187=HEAP32[(($69)>>2)];
      HEAP32[(($186)>>2)]=$187;
      var $188=$67;
      var $189=$68;
      var $190=$69;
      var $191=$70;
      var $192=$71;
      var $193=$72;
      var $tmp=$66;
      var $tmp1=$107;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];HEAP8[($tmp+4)]=HEAP8[($tmp1+4)];HEAP8[($tmp+5)]=HEAP8[($tmp1+5)];HEAP8[($tmp+6)]=HEAP8[($tmp1+6)];HEAP8[($tmp+7)]=HEAP8[($tmp1+7)];
      var $194=$__d1_i;
      var $195=$64;
      var $196=$65;
      HEAP32[(($64)>>2)]=$__hold;
      HEAP32[(($65)>>2)]=$167;
      var $197=HEAP32[(($64)>>2)];
      var $198=HEAP32[(($65)>>2)];
      var $tmp_i=$__d1_i;
      var $tmp2_i=$66;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];HEAP8[($tmp_i+4)]=HEAP8[($tmp2_i+4)];HEAP8[($tmp_i+5)]=HEAP8[($tmp2_i+5)];HEAP8[($tmp_i+6)]=HEAP8[($tmp2_i+6)];HEAP8[($tmp_i+7)]=HEAP8[($tmp2_i+7)];
      var $199=$59;
      var $200=$61;
      var $201=$62;
      var $202=$63;
      HEAP32[(($61)>>2)]=$197;
      HEAP32[(($62)>>2)]=$198;
      var $203=HEAP32[(($61)>>2)];
      var $204=(($203)|0);
      var $205=$60;
      HEAP32[(($60)>>2)]=$62;
      var $206=HEAP32[(($60)>>2)];
      var $207=$60;
      var $208=HEAP32[(($206)>>2)];
      var $209=$46;
      HEAP32[(($46)>>2)]=$__d1_i;
      var $210=HEAP32[(($46)>>2)];
      var $211=$46;
      var $212=$63;
      var $213=$210;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($212)>>2)]=HEAP32[(($213)>>2)];HEAP32[(($212+4)>>2)]=HEAP32[(($213+4)>>2)];
      var $tmp_i_i=$59;
      var $tmp1_i_i=$63;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];HEAP8[($tmp_i_i+1)]=HEAP8[($tmp1_i_i+1)];HEAP8[($tmp_i_i+2)]=HEAP8[($tmp1_i_i+2)];HEAP8[($tmp_i_i+3)]=HEAP8[($tmp1_i_i+3)];HEAP8[($tmp_i_i+4)]=HEAP8[($tmp1_i_i+4)];HEAP8[($tmp_i_i+5)]=HEAP8[($tmp1_i_i+5)];HEAP8[($tmp_i_i+6)]=HEAP8[($tmp1_i_i+6)];HEAP8[($tmp_i_i+7)]=HEAP8[($tmp1_i_i+7)];
      var $214=$__t21_i_i_i;
      var $215=$57;
      var $216=$58;
      HEAP32[(($57)>>2)]=$204;
      HEAP32[(($58)>>2)]=$208;
      var $217=HEAP32[(($57)>>2)];
      var $218=HEAP32[(($58)>>2)];
      var $tmp_i_i_i=$__t21_i_i_i;
      var $tmp2_i_i_i=$59;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp2_i_i_i)];HEAP8[($tmp_i_i_i+1)]=HEAP8[($tmp2_i_i_i+1)];HEAP8[($tmp_i_i_i+2)]=HEAP8[($tmp2_i_i_i+2)];HEAP8[($tmp_i_i_i+3)]=HEAP8[($tmp2_i_i_i+3)];HEAP8[($tmp_i_i_i+4)]=HEAP8[($tmp2_i_i_i+4)];HEAP8[($tmp_i_i_i+5)]=HEAP8[($tmp2_i_i_i+5)];HEAP8[($tmp_i_i_i+6)]=HEAP8[($tmp2_i_i_i+6)];HEAP8[($tmp_i_i_i+7)]=HEAP8[($tmp2_i_i_i+7)];
      var $219=$52;
      var $220=$54;
      var $221=$55;
      var $222=$56;
      HEAP32[(($54)>>2)]=$217;
      HEAP32[(($55)>>2)]=$218;
      var $223=HEAP32[(($54)>>2)];
      var $224=$223;
      var $225=$53;
      HEAP32[(($53)>>2)]=$55;
      var $226=HEAP32[(($53)>>2)];
      var $227=$53;
      var $228=HEAP32[(($226)>>2)];
      var $229=$47;
      HEAP32[(($47)>>2)]=$__t21_i_i_i;
      var $230=HEAP32[(($47)>>2)];
      var $231=$47;
      var $232=$56;
      var $233=$230;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($232)>>2)]=HEAP32[(($233)>>2)];HEAP32[(($232+4)>>2)]=HEAP32[(($233+4)>>2)];
      var $tmp_i_i_i_i=$52;
      var $tmp1_i_i_i_i=$56;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i_i)]=HEAP8[($tmp1_i_i_i_i)];HEAP8[($tmp_i_i_i_i+1)]=HEAP8[($tmp1_i_i_i_i+1)];HEAP8[($tmp_i_i_i_i+2)]=HEAP8[($tmp1_i_i_i_i+2)];HEAP8[($tmp_i_i_i_i+3)]=HEAP8[($tmp1_i_i_i_i+3)];HEAP8[($tmp_i_i_i_i+4)]=HEAP8[($tmp1_i_i_i_i+4)];HEAP8[($tmp_i_i_i_i+5)]=HEAP8[($tmp1_i_i_i_i+5)];HEAP8[($tmp_i_i_i_i+6)]=HEAP8[($tmp1_i_i_i_i+6)];HEAP8[($tmp_i_i_i_i+7)]=HEAP8[($tmp1_i_i_i_i+7)];
      var $234=$50;
      var $235=$51;
      HEAP32[(($50)>>2)]=$224;
      HEAP32[(($51)>>2)]=$228;
      var $236=HEAP32[(($50)>>2)];
      var $237=(($236)|0);
      var $238=$49;
      HEAP32[(($49)>>2)]=$51;
      var $239=HEAP32[(($49)>>2)];
      var $240=$49;
      var $241=HEAP32[(($239)>>2)];
      HEAP32[(($237)>>2)]=$241;
      var $242=(($236+4)|0);
      var $243=$48;
      HEAP32[(($48)>>2)]=$52;
      var $244=HEAP32[(($48)>>2)];
      var $245=$48;
      var $246=$242;
      var $247=$244;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($246)>>2)]=HEAP32[(($247)>>2)];HEAP32[(($246+4)>>2)]=HEAP32[(($247+4)>>2)];
      var $248=$50;
      var $249=$51;
      var $250=$52;
      var $251=$54;
      var $252=$55;
      var $253=$56;
      var $254=$__t21_i_i_i;
      var $255=$57;
      var $256=$58;
      var $257=$59;
      var $258=$61;
      var $259=$62;
      var $260=$63;
      var $261=$__d1_i;
      var $262=$64;
      var $263=$65;
      var $264=$__na;
      var $265=$45;
      HEAP32[(($45)>>2)]=$__hold;
      var $266=HEAP32[(($45)>>2)];
      var $267=(($266)|0);
      var $268=$44;
      HEAP32[(($44)>>2)]=$267;
      var $269=HEAP32[(($44)>>2)];
      var $270=$269;
      var $271=$43;
      HEAP32[(($43)>>2)]=$270;
      var $272=HEAP32[(($43)>>2)];
      var $273=(($272)|0);
      var $274=$43;
      var $275=$44;
      var $276=HEAP32[(($273)>>2)];
      var $277=$45;
      var $278=(($276+8)|0);
      var $279=$42;
      HEAP32[(($42)>>2)]=$278;
      var $280=HEAP32[(($42)>>2)];
      var $281=$280;
      var $282=$281;
      var $283=$42;
      var $284=$106;
      var $285=$39;
      var $286=$40;
      var $287=$41;
      HEAP32[(($39)>>2)]=$264;
      HEAP32[(($40)>>2)]=$282;
      HEAP32[(($41)>>2)]=$284;
      var $288=HEAP32[(($40)>>2)];
      var $289=$288;
      var $290=(($289)|0)==0;
      if ($290) { var $295 = 0;__label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $291
      var $292=$289;
      var $293=HEAP32[(($41)>>2)];
      var $294=HEAP32[(($293)>>2)];
      HEAP32[(($292)>>2)]=$294;
      var $295 = $292;__label__ = 9; break;
    case 9: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIjPvEEEEE9constructIjjEEvRS5_PT_RKT0__exit
      var $295;
      var $296=$39;
      var $297=$40;
      var $298=$41;
      __label__ = 10; break;
    case 10: // $299
      var $300=$110;
      var $301=(($300)|0);
      var $302=$301;
      var $303=$38;
      HEAP32[(($38)>>2)]=$__hold;
      var $304=HEAP32[(($38)>>2)];
      var $305=(($304)|0);
      var $306=$37;
      HEAP32[(($37)>>2)]=$305;
      var $307=HEAP32[(($37)>>2)];
      var $308=$307;
      var $309=$36;
      HEAP32[(($36)>>2)]=$308;
      var $310=HEAP32[(($36)>>2)];
      var $311=(($310)|0);
      var $312=$36;
      var $313=$37;
      var $314=HEAP32[(($311)>>2)];
      var $315=$38;
      __label__ = 11; break;
    case 11: // $316
      var $317=$14;
      HEAP32[(($14)>>2)]=$__hold;
      var $318=HEAP32[(($14)>>2)];
      var $319=(($318)|0);
      var $320=$13;
      HEAP32[(($13)>>2)]=$319;
      var $321=HEAP32[(($13)>>2)];
      var $322=$321;
      var $323=$12;
      HEAP32[(($12)>>2)]=$322;
      var $324=HEAP32[(($12)>>2)];
      var $325=(($324)|0);
      var $326=$12;
      var $327=$13;
      var $328=HEAP32[(($325)>>2)];
      var $329=$14;
      __label__ = 12; break;
    case 12: // $330
      var $331=$9;
      var $332=$10;
      var $333=$11;
      HEAP32[(($9)>>2)]=$302;
      HEAP32[(($10)>>2)]=$314;
      HEAP32[(($11)>>2)]=$328;
      var $334=HEAP32[(($10)>>2)];
      var $335=HEAP32[(($9)>>2)];
      var $336=$335;
      var $337=(($336)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=$338;
      var $340=(($339+4)|0);
      HEAP32[(($340)>>2)]=$334;
      var $341=HEAP32[(($9)>>2)];
      var $342=$341;
      var $343=(($342)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=HEAP32[(($10)>>2)];
      var $346=$345;
      var $347=(($346)|0);
      HEAP32[(($347)>>2)]=$344;
      var $348=HEAP32[(($11)>>2)];
      var $349=HEAP32[(($9)>>2)];
      var $350=$349;
      var $351=(($350)|0);
      HEAP32[(($351)>>2)]=$348;
      var $352=HEAP32[(($9)>>2)];
      var $353=HEAP32[(($11)>>2)];
      var $354=$353;
      var $355=(($354+4)|0);
      HEAP32[(($355)>>2)]=$352;
      var $356=$9;
      var $357=$10;
      var $358=$11;
      __label__ = 13; break;
    case 13: // $359
      var $360=$110;
      var $361=$3;
      HEAP32[(($3)>>2)]=$360;
      var $362=HEAP32[(($3)>>2)];
      var $363=(($362+8)|0);
      var $364=$2;
      HEAP32[(($2)>>2)]=$363;
      var $365=HEAP32[(($2)>>2)];
      var $366=$365;
      var $367=$1;
      HEAP32[(($1)>>2)]=$366;
      var $368=HEAP32[(($1)>>2)];
      var $369=(($368)|0);
      var $370=$1;
      var $371=$2;
      var $372=$3;
      var $373=HEAP32[(($369)>>2)];
      var $374=(($373+1)|0);
      HEAP32[(($369)>>2)]=$374;
      var $375=$8;
      var $376=$__t_i;
      HEAP32[(($8)>>2)]=$__hold;
      var $377=HEAP32[(($8)>>2)];
      var $378=(($377)|0);
      var $379=$7;
      HEAP32[(($7)>>2)]=$378;
      var $380=HEAP32[(($7)>>2)];
      var $381=$380;
      var $382=$6;
      HEAP32[(($6)>>2)]=$381;
      var $383=HEAP32[(($6)>>2)];
      var $384=(($383)|0);
      var $385=$6;
      var $386=$7;
      var $387=HEAP32[(($384)>>2)];
      HEAP32[(($__t_i)>>2)]=$387;
      var $388=(($377)|0);
      var $389=$5;
      HEAP32[(($5)>>2)]=$388;
      var $390=HEAP32[(($5)>>2)];
      var $391=$390;
      var $392=$4;
      HEAP32[(($4)>>2)]=$391;
      var $393=HEAP32[(($4)>>2)];
      var $394=(($393)|0);
      var $395=$4;
      var $396=$5;
      HEAP32[(($394)>>2)]=0;
      var $397=HEAP32[(($__t_i)>>2)];
      var $398=$8;
      var $399=$__t_i;
      var $400=$35;
      HEAP32[(($35)>>2)]=$__hold;
      var $401=HEAP32[(($35)>>2)];
      var $402=$34;
      HEAP32[(($34)>>2)]=$401;
      var $403=HEAP32[(($34)>>2)];
      var $404=$32;
      var $405=$33;
      var $406=$__tmp_i_i_i2;
      HEAP32[(($32)>>2)]=$403;
      HEAP32[(($33)>>2)]=0;
      var $407=HEAP32[(($32)>>2)];
      var $408=(($407)|0);
      var $409=$31;
      HEAP32[(($31)>>2)]=$408;
      var $410=HEAP32[(($31)>>2)];
      var $411=$410;
      var $412=$30;
      HEAP32[(($30)>>2)]=$411;
      var $413=HEAP32[(($30)>>2)];
      var $414=(($413)|0);
      var $415=$30;
      var $416=$31;
      var $417=HEAP32[(($414)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$417;
      var $418=HEAP32[(($33)>>2)];
      var $419=(($407)|0);
      var $420=$18;
      HEAP32[(($18)>>2)]=$419;
      var $421=HEAP32[(($18)>>2)];
      var $422=$421;
      var $423=$17;
      HEAP32[(($17)>>2)]=$422;
      var $424=HEAP32[(($17)>>2)];
      var $425=(($424)|0);
      var $426=$17;
      var $427=$18;
      HEAP32[(($425)>>2)]=$418;
      var $428=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $429=(($428)|0)!=0;
      if ($429) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $430
      var $431=(($407)|0);
      var $432=$16;
      HEAP32[(($16)>>2)]=$431;
      var $433=HEAP32[(($16)>>2)];
      var $434=$433;
      var $435=$15;
      HEAP32[(($15)>>2)]=$434;
      var $436=HEAP32[(($15)>>2)];
      var $437=(($436+4)|0);
      var $438=$15;
      var $439=$16;
      var $440=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $441=$28;
      var $442=$29;
      HEAP32[(($28)>>2)]=$437;
      HEAP32[(($29)>>2)]=$440;
      var $443=HEAP32[(($28)>>2)];
      var $444=(($443)|0);
      var $445=HEAP32[(($444)>>2)];
      var $446=HEAP32[(($29)>>2)];
      var $447=(($443+4)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=$25;
      var $450=$26;
      var $451=$27;
      HEAP32[(($25)>>2)]=$445;
      HEAP32[(($26)>>2)]=$446;
      HEAP32[(($27)>>2)]=$448;
      var $452=HEAP32[(($25)>>2)];
      var $453=HEAP32[(($26)>>2)];
      var $454=HEAP32[(($27)>>2)];
      var $455=$22;
      var $456=$23;
      var $457=$24;
      HEAP32[(($22)>>2)]=$452;
      HEAP32[(($23)>>2)]=$453;
      HEAP32[(($24)>>2)]=$454;
      var $458=HEAP32[(($22)>>2)];
      var $459=HEAP32[(($23)>>2)];
      var $460=$459;
      var $461=$19;
      var $462=$20;
      var $463=$21;
      HEAP32[(($19)>>2)]=$460;
      var $464=HEAP32[(($19)>>2)];
      var $465=(($464)|0)!=0;
      if ($465) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $466
      var $467=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($467, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $468
      __label__ = 18; break;
    case 17: // $469
      var $470=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $471=$470.f0;
      HEAP32[(($20)>>2)]=$471;
      var $472=$470.f1;
      HEAP32[(($21)>>2)]=$472;
      var $473=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($473);
      throw "Reached an unreachable!"
    case 18: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIjPvEEEEEclEPS4__exit_i_i_i3
      var $474=$19;
      var $475=$20;
      var $476=$21;
      var $477=$22;
      var $478=$23;
      var $479=$24;
      var $480=$25;
      var $481=$26;
      var $482=$27;
      var $483=$28;
      var $484=$29;
      __label__ = 19; break;
    case 19: // $_ZNSt3__110unique_ptrINS_11__list_nodeIjPvEENS_22__allocator_destructorINS_9allocatorIS3_EEEEED1Ev_exit4
      var $485=$32;
      var $486=$33;
      var $487=$__tmp_i_i_i2;
      var $488=$34;
      var $489=$35;
      STACKTOP = __stackBase__;
      return;
      var $491=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $492=$491.f0;
      $108=$492;
      var $493=$491.f1;
      $109=$493;
      var $494=$101;
      HEAP32[(($101)>>2)]=$__hold;
      var $495=HEAP32[(($101)>>2)];
      var $496=$100;
      HEAP32[(($100)>>2)]=$495;
      var $497=HEAP32[(($100)>>2)];
      var $498=$98;
      var $499=$99;
      var $500=$__tmp_i_i_i;
      HEAP32[(($98)>>2)]=$497;
      HEAP32[(($99)>>2)]=0;
      var $501=HEAP32[(($98)>>2)];
      var $502=(($501)|0);
      var $503=$97;
      HEAP32[(($97)>>2)]=$502;
      var $504=HEAP32[(($97)>>2)];
      var $505=$504;
      var $506=$96;
      HEAP32[(($96)>>2)]=$505;
      var $507=HEAP32[(($96)>>2)];
      var $508=(($507)|0);
      var $509=$96;
      var $510=$97;
      var $511=HEAP32[(($508)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$511;
      var $512=HEAP32[(($99)>>2)];
      var $513=(($501)|0);
      var $514=$84;
      HEAP32[(($84)>>2)]=$513;
      var $515=HEAP32[(($84)>>2)];
      var $516=$515;
      var $517=$83;
      HEAP32[(($83)>>2)]=$516;
      var $518=HEAP32[(($83)>>2)];
      var $519=(($518)|0);
      var $520=$83;
      var $521=$84;
      HEAP32[(($519)>>2)]=$512;
      var $522=HEAP32[(($__tmp_i_i_i)>>2)];
      var $523=(($522)|0)!=0;
      if ($523) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 20: // $524
      var $525=(($501)|0);
      var $526=$82;
      HEAP32[(($82)>>2)]=$525;
      var $527=HEAP32[(($82)>>2)];
      var $528=$527;
      var $529=$81;
      HEAP32[(($81)>>2)]=$528;
      var $530=HEAP32[(($81)>>2)];
      var $531=(($530+4)|0);
      var $532=$81;
      var $533=$82;
      var $534=HEAP32[(($__tmp_i_i_i)>>2)];
      var $535=$94;
      var $536=$95;
      HEAP32[(($94)>>2)]=$531;
      HEAP32[(($95)>>2)]=$534;
      var $537=HEAP32[(($94)>>2)];
      var $538=(($537)|0);
      var $539=HEAP32[(($538)>>2)];
      var $540=HEAP32[(($95)>>2)];
      var $541=(($537+4)|0);
      var $542=HEAP32[(($541)>>2)];
      var $543=$91;
      var $544=$92;
      var $545=$93;
      HEAP32[(($91)>>2)]=$539;
      HEAP32[(($92)>>2)]=$540;
      HEAP32[(($93)>>2)]=$542;
      var $546=HEAP32[(($91)>>2)];
      var $547=HEAP32[(($92)>>2)];
      var $548=HEAP32[(($93)>>2)];
      var $549=$88;
      var $550=$89;
      var $551=$90;
      HEAP32[(($88)>>2)]=$546;
      HEAP32[(($89)>>2)]=$547;
      HEAP32[(($90)>>2)]=$548;
      var $552=HEAP32[(($88)>>2)];
      var $553=HEAP32[(($89)>>2)];
      var $554=$553;
      var $555=$85;
      var $556=$86;
      var $557=$87;
      HEAP32[(($85)>>2)]=$554;
      var $558=HEAP32[(($85)>>2)];
      var $559=(($558)|0)!=0;
      if ($559) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $560
      var $561=HEAP32[(($85)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($561, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $562
      __label__ = 24; break;
    case 23: // $563
      var $564=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $565=$564.f0;
      HEAP32[(($86)>>2)]=$565;
      var $566=$564.f1;
      HEAP32[(($87)>>2)]=$566;
      var $567=HEAP32[(($86)>>2)];
      ___cxa_call_unexpected($567);
      throw "Reached an unreachable!"
    case 24: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIjPvEEEEEclEPS4__exit_i_i_i
      var $568=$85;
      var $569=$86;
      var $570=$87;
      var $571=$88;
      var $572=$89;
      var $573=$90;
      var $574=$91;
      var $575=$92;
      var $576=$93;
      var $577=$94;
      var $578=$95;
      __label__ = 25; break;
    case 25: // $_ZNSt3__110unique_ptrINS_11__list_nodeIjPvEENS_22__allocator_destructorINS_9allocatorIS3_EEEEED1Ev_exit
      var $579=$98;
      var $580=$99;
      var $581=$__tmp_i_i_i;
      var $582=$100;
      var $583=$101;
      __label__ = 26; break;
    case 26: // $584
      __label__ = 27; break;
    case 27: // $585
      var $586=$108;
      var $587=$108;
      var $588=$109;
      var $589=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $587, tempValue);
      var $590=($589.f1 = $588, $589);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $592=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__14listIjNS_9allocatorIjEEE9push_backERKj["X"]=1;

function __ZN13handler_entry17overriden_by_maskEy($this, $handlermask$0, $handlermask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $i;
      $2=$this;
      var $st$5$0=(($3)|0);
      HEAP32[(($st$5$0)>>2)]=$handlermask$0;
      var $st$5$1=(($3+4)|0);
      HEAP32[(($st$5$1)>>2)]=$handlermask$1;
      var $4=$2;
      var $st$10$0=(($3)|0);
      var $5$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($3+4)|0);
      var $5$1=HEAP32[(($st$10$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $6=$5$0 != $$emscripten$temp$0$0 || $5$1 != $$emscripten$temp$0$1;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      $1=1;
      __label__ = 11; break;
    case 2: // $8
      var $9=(($4+28)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      if ($11) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $12
      $1=1;
      __label__ = 11; break;
    case 4: // $13
      $i=0;
      __label__ = 5; break;
    case 5: // $14
      var $15=$i;
      var $16=(($4+28)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($15)|0)!=(($18)|0);
      if ($19) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $20
      var $st$0$0=(($3)|0);
      var $21$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $21$1=HEAP32[(($st$0$1)>>2)];
      var $22=$i;
      var $23=(($4+32)|0);
      var $24=(($23+($22<<4))|0);
      var $25=(($24+13)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28$0=$27;
      var $28$1=0;
      var $29=Runtime.bitshift64($21$0, $21$1,"lshr",$28$0);var $29$0 = $29[0], $29$1 = $29[1];
      var $30=$i;
      var $31=(($4+32)|0);
      var $32=(($31+($30<<4))|0);
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35$0=$34;
      var $35$1=0;
      var $36$0=$29$0 & $35$0;
      var $36$1=$29$1 & $35$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $37=$36$0 == $$emscripten$temp$1$0 && $36$1 == $$emscripten$temp$1$1;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      $1=0;
      __label__ = 11; break;
    case 8: // $39
      __label__ = 9; break;
    case 9: // $40
      var $41=$i;
      var $42=(($41+1)|0);
      $i=$42;
      __label__ = 5; break;
    case 10: // $43
      $1=1;
      __label__ = 11; break;
    case 11: // $44
      var $45=$1;
      STACKTOP = __stackBase__;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13handler_entry17overriden_by_maskEy["X"]=1;

function __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE9push_backERKS2_($this, $__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 168; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__t_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $result_i_i_i=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36;
      var $37;
      var $__na;
      var $__hold=__stackBase__+148;
      var $38=__stackBase__+160;
      var $39;
      var $40;
      $36=$this;
      $37=$__x;
      var $41=$36;
      var $42=$41;
      var $43=$35;
      HEAP32[(($35)>>2)]=$42;
      var $44=HEAP32[(($35)>>2)];
      var $45=(($44+8)|0);
      var $46=$34;
      HEAP32[(($34)>>2)]=$45;
      var $47=HEAP32[(($34)>>2)];
      var $48=$47;
      var $49=$33;
      HEAP32[(($33)>>2)]=$48;
      var $50=HEAP32[(($33)>>2)];
      var $51=$50;
      var $52=$33;
      var $53=$34;
      var $54=$35;
      $__na=$51;
      var $55=$__na;
      var $56=$31;
      var $57=$32;
      HEAP32[(($31)>>2)]=$55;
      HEAP32[(($32)>>2)]=1;
      var $58=HEAP32[(($31)>>2)];
      var $59=HEAP32[(($32)>>2)];
      var $60=$28;
      var $61=$29;
      var $62=$30;
      HEAP32[(($28)>>2)]=$58;
      HEAP32[(($29)>>2)]=$59;
      HEAP32[(($30)>>2)]=0;
      var $63=HEAP32[(($28)>>2)];
      var $64=HEAP32[(($29)>>2)];
      var $65=((($64<<4))|0);
      var $66=$25;
      var $67=$result_i_i_i;
      var $68=$26;
      var $69=$27;
      HEAP32[(($25)>>2)]=$65;
      var $70=HEAP32[(($25)>>2)];
      var $71=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($70, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $72
      HEAP32[(($result_i_i_i)>>2)]=$71;
      var $73=HEAP32[(($result_i_i_i)>>2)];
      var $74=(($73)|0)==0;
      if ($74) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $75
      var $76=___cxa_allocate_exception(4);
      var $77=$76;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($77);
      (function() { try { __THREW__ = false; return ___cxa_throw($76, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $80=$79.f0;
      HEAP32[(($26)>>2)]=$80;
      var $81=$79.f1;
      HEAP32[(($27)>>2)]=$81;
      var $82=HEAP32[(($27)>>2)];
      var $83=(($82)|0) < 0;
      if ($83) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $84
      var $85=HEAP32[(($26)>>2)];
      ___cxa_call_unexpected($85);
      throw "Reached an unreachable!"
    case 5: // $86
      var $87=HEAP32[(($26)>>2)];
      var $88=HEAP32[(($26)>>2)];
      var $89=HEAP32[(($27)>>2)];
      var $90=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $88, tempValue);
      var $91=($90.f1 = $89, $90);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $92
      throw "Reached an unreachable!"
    case 7: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEE8allocateERS7_j_exit
      var $93=HEAP32[(($result_i_i_i)>>2)];
      var $94=$25;
      var $95=$result_i_i_i;
      var $96=$26;
      var $97=$27;
      var $98=$93;
      var $99=$28;
      var $100=$29;
      var $101=$30;
      var $102=$31;
      var $103=$32;
      var $104=$__na;
      FUNCTION_TABLE[__ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC1ERS7_j]($38, $104, 1);
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC1EPS5_S9_]($__hold, $98, $38);
      var $105=$__na;
      var $106=$24;
      HEAP32[(($24)>>2)]=$__hold;
      var $107=HEAP32[(($24)>>2)];
      var $108=(($107)|0);
      var $109=$23;
      HEAP32[(($23)>>2)]=$108;
      var $110=HEAP32[(($23)>>2)];
      var $111=$110;
      var $112=$22;
      HEAP32[(($22)>>2)]=$111;
      var $113=HEAP32[(($22)>>2)];
      var $114=(($113)|0);
      var $115=$22;
      var $116=$23;
      var $117=HEAP32[(($114)>>2)];
      var $118=$24;
      var $119=(($117+8)|0);
      var $120=$21;
      HEAP32[(($21)>>2)]=$119;
      var $121=HEAP32[(($21)>>2)];
      var $122=$121;
      var $123=$122;
      var $124=$21;
      var $125=$37;
      var $126=$18;
      var $127=$19;
      var $128=$20;
      HEAP32[(($18)>>2)]=$105;
      HEAP32[(($19)>>2)]=$123;
      HEAP32[(($20)>>2)]=$125;
      var $129=HEAP32[(($19)>>2)];
      var $130=$129;
      var $131=(($130)|0)==0;
      if ($131) { var $137 = 0;__label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $132
      var $133=$130;
      var $134=HEAP32[(($20)>>2)];
      var $135=$133;
      var $136=$134;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($135)>>2)]=HEAP32[(($136)>>2)];HEAP32[(($135+4)>>2)]=HEAP32[(($136+4)>>2)];
      var $137 = $133;__label__ = 9; break;
    case 9: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEE9constructIS4_S4_EEvRS7_PT_RKT0__exit
      var $137;
      var $138=$18;
      var $139=$19;
      var $140=$20;
      __label__ = 10; break;
    case 10: // $141
      var $142=$41;
      var $143=(($142)|0);
      var $144=$143;
      var $145=$17;
      HEAP32[(($17)>>2)]=$__hold;
      var $146=HEAP32[(($17)>>2)];
      var $147=(($146)|0);
      var $148=$16;
      HEAP32[(($16)>>2)]=$147;
      var $149=HEAP32[(($16)>>2)];
      var $150=$149;
      var $151=$15;
      HEAP32[(($15)>>2)]=$150;
      var $152=HEAP32[(($15)>>2)];
      var $153=(($152)|0);
      var $154=$15;
      var $155=$16;
      var $156=HEAP32[(($153)>>2)];
      var $157=$17;
      __label__ = 11; break;
    case 11: // $158
      var $159=$14;
      HEAP32[(($14)>>2)]=$__hold;
      var $160=HEAP32[(($14)>>2)];
      var $161=(($160)|0);
      var $162=$13;
      HEAP32[(($13)>>2)]=$161;
      var $163=HEAP32[(($13)>>2)];
      var $164=$163;
      var $165=$12;
      HEAP32[(($12)>>2)]=$164;
      var $166=HEAP32[(($12)>>2)];
      var $167=(($166)|0);
      var $168=$12;
      var $169=$13;
      var $170=HEAP32[(($167)>>2)];
      var $171=$14;
      __label__ = 12; break;
    case 12: // $172
      var $173=$9;
      var $174=$10;
      var $175=$11;
      HEAP32[(($9)>>2)]=$144;
      HEAP32[(($10)>>2)]=$156;
      HEAP32[(($11)>>2)]=$170;
      var $176=HEAP32[(($10)>>2)];
      var $177=HEAP32[(($9)>>2)];
      var $178=$177;
      var $179=(($178)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$180;
      var $182=(($181+4)|0);
      HEAP32[(($182)>>2)]=$176;
      var $183=HEAP32[(($9)>>2)];
      var $184=$183;
      var $185=(($184)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=HEAP32[(($10)>>2)];
      var $188=$187;
      var $189=(($188)|0);
      HEAP32[(($189)>>2)]=$186;
      var $190=HEAP32[(($11)>>2)];
      var $191=HEAP32[(($9)>>2)];
      var $192=$191;
      var $193=(($192)|0);
      HEAP32[(($193)>>2)]=$190;
      var $194=HEAP32[(($9)>>2)];
      var $195=HEAP32[(($11)>>2)];
      var $196=$195;
      var $197=(($196+4)|0);
      HEAP32[(($197)>>2)]=$194;
      var $198=$9;
      var $199=$10;
      var $200=$11;
      __label__ = 13; break;
    case 13: // $201
      var $202=$41;
      var $203=$3;
      HEAP32[(($3)>>2)]=$202;
      var $204=HEAP32[(($3)>>2)];
      var $205=(($204+8)|0);
      var $206=$2;
      HEAP32[(($2)>>2)]=$205;
      var $207=HEAP32[(($2)>>2)];
      var $208=$207;
      var $209=$1;
      HEAP32[(($1)>>2)]=$208;
      var $210=HEAP32[(($1)>>2)];
      var $211=(($210)|0);
      var $212=$1;
      var $213=$2;
      var $214=$3;
      var $215=HEAP32[(($211)>>2)];
      var $216=(($215+1)|0);
      HEAP32[(($211)>>2)]=$216;
      var $217=$8;
      var $218=$__t_i;
      HEAP32[(($8)>>2)]=$__hold;
      var $219=HEAP32[(($8)>>2)];
      var $220=(($219)|0);
      var $221=$7;
      HEAP32[(($7)>>2)]=$220;
      var $222=HEAP32[(($7)>>2)];
      var $223=$222;
      var $224=$6;
      HEAP32[(($6)>>2)]=$223;
      var $225=HEAP32[(($6)>>2)];
      var $226=(($225)|0);
      var $227=$6;
      var $228=$7;
      var $229=HEAP32[(($226)>>2)];
      HEAP32[(($__t_i)>>2)]=$229;
      var $230=(($219)|0);
      var $231=$5;
      HEAP32[(($5)>>2)]=$230;
      var $232=HEAP32[(($5)>>2)];
      var $233=$232;
      var $234=$4;
      HEAP32[(($4)>>2)]=$233;
      var $235=HEAP32[(($4)>>2)];
      var $236=(($235)|0);
      var $237=$4;
      var $238=$5;
      HEAP32[(($236)>>2)]=0;
      var $239=HEAP32[(($__t_i)>>2)];
      var $240=$8;
      var $241=$__t_i;
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev]($__hold);
      STACKTOP = __stackBase__;
      return;
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $244=$243.f0;
      $39=$244;
      var $245=$243.f1;
      $40=$245;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev]($__hold) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $246
      __label__ = 15; break;
    case 15: // $247
      var $248=$39;
      var $249=$39;
      var $250=$40;
      var $251=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $249, tempValue);
      var $252=($251.f1 = $250, $251);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE9push_backERKS2_["X"]=1;

function __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEixERSA_($this, $__k) {
  var __stackBase__  = STACKTOP; STACKTOP += 96; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15;
      var $16;
      var $__parent=__stackBase__+60;
      var $__child;
      var $__r;
      var $17=__stackBase__+64;
      var $__h=__stackBase__+68;
      var $18=__stackBase__+80;
      var $19=__stackBase__+84;
      var $20;
      var $21;
      $15=$this;
      $16=$__k;
      var $22=$15;
      var $23=$16;
      var $24=__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_($22, $__parent, $23);
      $__child=$24;
      var $25=$__child;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26;
      $__r=$27;
      var $28=$__child;
      var $29=HEAP32[(($28)>>2)];
      var $30=$13;
      var $31=$14;
      HEAP32[(($13)>>2)]=$17;
      HEAP32[(($14)>>2)]=-1;
      var $32=HEAP32[(($13)>>2)];
      var $33=HEAP32[(($14)>>2)];
      var $34=$11;
      var $35=$12;
      HEAP32[(($11)>>2)]=$32;
      HEAP32[(($12)>>2)]=$33;
      var $36=HEAP32[(($11)>>2)];
      var $37=$11;
      var $38=$12;
      var $39=$13;
      var $40=$14;
      var $41=$10;
      HEAP32[(($10)>>2)]=$17;
      var $42=HEAP32[(($10)>>2)];
      var $43=$10;
      var $44=(($29)|0)==0;
      if ($44) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $45
      var $46=$16;
      __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__construct_nodeERSA_($19, $22, $46);
      var $47=$9;
      HEAP32[(($9)>>2)]=$19;
      var $48=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC1ERSG_]($18, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $_ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEcvNS_4__rvISF_EEEv_exit
      var $49=$9;
      __label__ = 3; break;
    case 3: // $50
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ENS_4__rvISF_EE]($__h, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $51
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($19);
      var $52=(($22)|0);
      var $53=HEAP32[(($__parent)>>2)];
      var $54=$__child;
      var $55=$8;
      HEAP32[(($8)>>2)]=$__h;
      var $56=HEAP32[(($8)>>2)];
      var $57=(($56)|0);
      var $58=$7;
      HEAP32[(($7)>>2)]=$57;
      var $59=HEAP32[(($7)>>2)];
      var $60=$59;
      var $61=$6;
      HEAP32[(($6)>>2)]=$60;
      var $62=HEAP32[(($6)>>2)];
      var $63=(($62)|0);
      var $64=$6;
      var $65=$7;
      var $66=HEAP32[(($63)>>2)];
      var $67=$8;
      var $68=$66;
      (function() { try { __THREW__ = false; return __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE16__insert_node_atEPNS_16__tree_node_baseIPvEERSI_SI_($52, $53, $54, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $69
      var $70=$5;
      var $71=$__t_i;
      HEAP32[(($5)>>2)]=$__h;
      var $72=HEAP32[(($5)>>2)];
      var $73=(($72)|0);
      var $74=$4;
      HEAP32[(($4)>>2)]=$73;
      var $75=HEAP32[(($4)>>2)];
      var $76=$75;
      var $77=$3;
      HEAP32[(($3)>>2)]=$76;
      var $78=HEAP32[(($3)>>2)];
      var $79=(($78)|0);
      var $80=$3;
      var $81=$4;
      var $82=HEAP32[(($79)>>2)];
      HEAP32[(($__t_i)>>2)]=$82;
      var $83=(($72)|0);
      var $84=$2;
      HEAP32[(($2)>>2)]=$83;
      var $85=HEAP32[(($2)>>2)];
      var $86=$85;
      var $87=$1;
      HEAP32[(($1)>>2)]=$86;
      var $88=HEAP32[(($1)>>2)];
      var $89=(($88)|0);
      var $90=$1;
      var $91=$2;
      HEAP32[(($89)>>2)]=0;
      var $92=HEAP32[(($__t_i)>>2)];
      var $93=$5;
      var $94=$__t_i;
      $__r=$92;
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($__h);
      __label__ = 10; break;
    case 6: // $95
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $97=$96.f0;
      $20=$97;
      var $98=$96.f1;
      $21=$98;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $99
      __label__ = 11; break;
    case 8: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $20=$102;
      var $103=$101.f1;
      $21=$103;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($__h) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $104
      __label__ = 11; break;
    case 10: // $105
      var $106=$__r;
      var $107=(($106+16)|0);
      var $108=(($107+4)|0);
      STACKTOP = __stackBase__;
      return $108;
    case 11: // $109
      var $110=$20;
      var $111=$20;
      var $112=$21;
      var $113=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $111, tempValue);
      var $114=($113.f1 = $112, $113);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEixERSA_["X"]=1;

function __ZN13address_table14subtable_closeEj($this, $l1index) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$l1index;
  var $3=$1;
  ;
  return;
}


function __ZNK13handler_entry8bytemaskEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13address_table11level2_bitsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  var $6=$5 ? 14 : 0;
  ;
  return $6;
}


function __ZN13address_table11handler_refEhi($this, $entry, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$entry;
      $3=$count;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$2;
      var $8=(($7)&255);
      var $9=(($8)|0) >= 128;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      var $11=$3;
      var $12=$2;
      var $13=(($12)&255);
      var $14=(($13-128)|0);
      var $15=(($4+28)|0);
      var $16=(($15+($14<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+$11)|0);
      HEAP32[(($16)>>2)]=$18;
      __label__ = 4; break;
    case 4: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_table14populate_rangeEjjh($this, $bytestart, $byteend, $handlerindex) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $l2mask;
      var $l1start;
      var $l2start;
      var $l1stop;
      var $l2stop;
      var $subtable;
      var $i;
      var $i1;
      var $subtable2;
      var $i3;
      var $l1index;
      var $subindex;
      $1=$this;
      $2=$bytestart;
      $3=$byteend;
      $4=$handlerindex;
      var $5=$1;
      var $6=__ZNK13address_table11level2_bitsEv($5);
      var $7=1 << $6;
      var $8=(($7-1)|0);
      $l2mask=$8;
      var $9=$2;
      var $10=__ZNK13address_table11level2_bitsEv($5);
      var $11=$9 >>> (($10)>>>0);
      $l1start=$11;
      var $12=$2;
      var $13=$l2mask;
      var $14=$12 & $13;
      $l2start=$14;
      var $15=$3;
      var $16=__ZNK13address_table11level2_bitsEv($5);
      var $17=$15 >>> (($16)>>>0);
      $l1stop=$17;
      var $18=$3;
      var $19=$l2mask;
      var $20=$18 & $19;
      $l2stop=$20;
      var $21=$2;
      var $22=$3;
      var $23=(($21)>>>0) > (($22)>>>0);
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      __label__ = 33; break;
    case 2: // $25
      var $26=$l2start;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 3; break; } else { __label__ = 16; break; }
    case 3: // $28
      var $29=$l1start;
      var $30=__ZN13address_table13subtable_openEj($5, $29);
      $subtable=$30;
      var $31=$l1start;
      var $32=$l1stop;
      var $33=(($31)|0)==(($32)|0);
      if ($33) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $34
      var $35=$4;
      var $36=$l2stop;
      var $37=$l2start;
      var $38=(($36-$37)|0);
      var $39=(($38+1)|0);
      __ZN13address_table11handler_refEhi($5, $35, $39);
      var $40=$l2start;
      $i=$40;
      __label__ = 5; break;
    case 5: // $41
      var $42=$i;
      var $43=$l2stop;
      var $44=(($42)>>>0) <= (($43)>>>0);
      if ($44) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $45
      var $46=$i;
      var $47=$subtable;
      var $48=(($47+$46)|0);
      var $49=HEAP8[($48)];
      __ZN13address_table13handler_unrefEh($5, $49);
      var $50=$4;
      var $51=$i;
      var $52=$subtable;
      var $53=(($52+$51)|0);
      HEAP8[($53)]=$50;
      __label__ = 7; break;
    case 7: // $54
      var $55=$i;
      var $56=(($55+1)|0);
      $i=$56;
      __label__ = 5; break;
    case 8: // $57
      var $58=$l1start;
      __ZN13address_table14subtable_closeEj($5, $58);
      __label__ = 33; break;
    case 9: // $59
      var $60=$4;
      var $61=$l2mask;
      var $62=$l2start;
      var $63=(($61-$62)|0);
      var $64=(($63+1)|0);
      __ZN13address_table11handler_refEhi($5, $60, $64);
      var $65=$l2start;
      $i1=$65;
      __label__ = 10; break;
    case 10: // $66
      var $67=$i1;
      var $68=$l2mask;
      var $69=(($67)>>>0) <= (($68)>>>0);
      if ($69) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $70
      var $71=$i1;
      var $72=$subtable;
      var $73=(($72+$71)|0);
      var $74=HEAP8[($73)];
      __ZN13address_table13handler_unrefEh($5, $74);
      var $75=$4;
      var $76=$i1;
      var $77=$subtable;
      var $78=(($77+$76)|0);
      HEAP8[($78)]=$75;
      __label__ = 12; break;
    case 12: // $79
      var $80=$i1;
      var $81=(($80+1)|0);
      $i1=$81;
      __label__ = 10; break;
    case 13: // $82
      var $83=$l1start;
      __ZN13address_table14subtable_closeEj($5, $83);
      var $84=$l1start;
      var $85=(($84)|0)!=-1;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      var $87=$l1start;
      var $88=(($87+1)|0);
      $l1start=$88;
      __label__ = 15; break;
    case 15: // $89
      __label__ = 16; break;
    case 16: // $90
      var $91=$l2stop;
      var $92=$l2mask;
      var $93=(($91)|0)!=(($92)|0);
      if ($93) { __label__ = 17; break; } else { __label__ = 26; break; }
    case 17: // $94
      var $95=$l1stop;
      var $96=__ZN13address_table13subtable_openEj($5, $95);
      $subtable2=$96;
      var $97=$4;
      var $98=$l2stop;
      var $99=(($98+1)|0);
      __ZN13address_table11handler_refEhi($5, $97, $99);
      $i3=0;
      __label__ = 18; break;
    case 18: // $100
      var $101=$i3;
      var $102=$l2stop;
      var $103=(($101)>>>0) <= (($102)>>>0);
      if ($103) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $104
      var $105=$i3;
      var $106=$subtable2;
      var $107=(($106+$105)|0);
      var $108=HEAP8[($107)];
      __ZN13address_table13handler_unrefEh($5, $108);
      var $109=$4;
      var $110=$i3;
      var $111=$subtable2;
      var $112=(($111+$110)|0);
      HEAP8[($112)]=$109;
      __label__ = 20; break;
    case 20: // $113
      var $114=$i3;
      var $115=(($114+1)|0);
      $i3=$115;
      __label__ = 18; break;
    case 21: // $116
      var $117=$l1stop;
      __ZN13address_table14subtable_closeEj($5, $117);
      var $118=$l1start;
      var $119=$l1stop;
      var $120=(($118)|0)==(($119)|0);
      if ($120) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $121
      __label__ = 33; break;
    case 23: // $122
      var $123=$l1stop;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $125
      var $126=$l1stop;
      var $127=(($126-1)|0);
      $l1stop=$127;
      __label__ = 25; break;
    case 25: // $128
      __label__ = 26; break;
    case 26: // $129
      var $130=$4;
      var $131=$l1stop;
      var $132=$l1start;
      var $133=(($131-$132)|0);
      var $134=(($133+1)|0);
      __ZN13address_table11handler_refEhi($5, $130, $134);
      var $135=$l1start;
      $l1index=$135;
      __label__ = 27; break;
    case 27: // $136
      var $137=$l1index;
      var $138=$l1stop;
      var $139=(($137)>>>0) <= (($138)>>>0);
      if ($139) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $140
      var $141=$l1index;
      var $142=(($5+4)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+$141)|0);
      var $145=HEAP8[($144)];
      $subindex=$145;
      var $146=$subindex;
      var $147=(($146)&255);
      var $148=(($147)|0) >= 192;
      if ($148) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $149
      var $150=$subindex;
      __ZN13address_table16subtable_releaseEh($5, $150);
      __label__ = 31; break;
    case 30: // $151
      var $152=$subindex;
      __ZN13address_table13handler_unrefEh($5, $152);
      __label__ = 31; break;
    case 31: // $153
      var $154=$4;
      var $155=$l1index;
      var $156=(($5+4)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157+$155)|0);
      HEAP8[($158)]=$154;
      __label__ = 32; break;
    case 32: // $159
      var $160=$l1index;
      var $161=(($160+1)|0);
      $l1index=$161;
      __label__ = 27; break;
    case 33: // $162
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table14populate_rangeEjjh["X"]=1;

function __ZN13handler_entry26clear_conflicting_subunitsEy($this, $handlermask$0, $handlermask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $i;
      var $i1;
      $1=$this;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$handlermask$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$handlermask$1;
      var $3=$1;
      var $st$10$0=(($2)|0);
      var $4$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($2+4)|0);
      var $4$1=HEAP32[(($st$10$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($3+28)|0);
      HEAP8[($7)]=0;
      __label__ = 15; break;
    case 2: // $8
      var $9=(($3+28)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=(($11-1)|0);
      $i=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$i;
      var $15=(($14)|0) >= 0;
      if ($15) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $16
      var $st$0$0=(($2)|0);
      var $17$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $17$1=HEAP32[(($st$0$1)>>2)];
      var $18=$i;
      var $19=(($3+32)|0);
      var $20=(($19+($18<<4))|0);
      var $21=(($20+13)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($17$0, $17$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $26=$i;
      var $27=(($3+32)|0);
      var $28=(($27+($26<<4))|0);
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31$0=$30;
      var $31$1=0;
      var $32$0=$25$0 & $31$0;
      var $32$1=$25$1 & $31$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $33=$32$0 != $$emscripten$temp$1$0 || $32$1 != $$emscripten$temp$1$1;
      if ($33) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $34
      var $35=$i;
      var $36=(($3+28)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=(($38-1)|0);
      var $40=(($35)|0)!=(($39)|0);
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=(($3+32)|0);
      var $43=(($42)|0);
      var $44=$i;
      var $45=(($43+($44<<4))|0);
      var $46=$45;
      var $47=(($3+32)|0);
      var $48=(($47)|0);
      var $49=$i;
      var $50=(($48+($49<<4))|0);
      var $51=(($50+16)|0);
      var $52=$51;
      var $53=(($3+28)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$i;
      var $57=(($55-$56)|0);
      var $58=(($57-1)|0);
      var $59=((($58<<4))|0);
      _llvm_memmove_p0i8_p0i8_i32($46, $52, $59, 1, 0);
      __label__ = 7; break;
    case 7: // $60
      var $61=$3;
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+20)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$i;
      FUNCTION_TABLE[$64]($3, $65);
      __label__ = 8; break;
    case 8: // $66
      __label__ = 9; break;
    case 9: // $67
      var $68=$i;
      var $69=(($68-1)|0);
      $i=$69;
      __label__ = 3; break;
    case 10: // $70
      var $71=(($3+160)|0);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$3$0=(($71)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$2$0;
      var $st$3$1=(($71+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$2$1;
      $i1=0;
      __label__ = 11; break;
    case 11: // $72
      var $73=$i1;
      var $74=(($3+28)|0);
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=(($73)|0) < (($76)|0);
      if ($77) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $78
      var $79=$i1;
      var $80=(($3+32)|0);
      var $81=(($80+($79<<4))|0);
      var $82=(($81)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$i1;
      var $85=(($3+32)|0);
      var $86=(($85+($84<<4))|0);
      var $87=(($86+13)|0);
      var $88=HEAPU8[($87)];
      var $89=(($88)&255);
      var $90=$83 << $89;
      var $91$0=$90;
      var $91$1=0;
      var $92=(($3+160)|0);
      var $st$15$0=(($92)|0);
      var $93$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($92+4)|0);
      var $93$1=HEAP32[(($st$15$1)>>2)];
      var $94$0=$93$0 | $91$0;
      var $94$1=$93$1 | $91$1;
      var $st$21$0=(($92)|0);
      HEAP32[(($st$21$0)>>2)]=$94$0;
      var $st$21$1=(($92+4)|0);
      HEAP32[(($st$21$1)>>2)]=$94$1;
      __label__ = 13; break;
    case 13: // $95
      var $96=$i1;
      var $97=(($96+1)|0);
      $i1=$97;
      __label__ = 11; break;
    case 14: // $98
      var $99=(($3+160)|0);
      var $st$1$0=(($99)|0);
      var $100$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($99+4)|0);
      var $100$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$3$0=-1;
      var $$emscripten$temp$3$1=-1;
      var $101$0=$100$0 ^ $$emscripten$temp$3$0;
      var $101$1=$100$1 ^ $$emscripten$temp$3$1;
      var $102=(($3+160)|0);
      var $st$10$0=(($102)|0);
      HEAP32[(($st$10$0)>>2)]=$101$0;
      var $st$10$1=(($102+4)|0);
      HEAP32[(($st$10$1)>>2)]=$101$1;
      __label__ = 15; break;
    case 15: // $103
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13handler_entry26clear_conflicting_subunitsEy["X"]=1;

function __ZN13address_table12subtable_ptrEh($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$entry;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK13address_table12level2_indexEhj($3, $4, 0);
  var $6=(($3+4)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+$5)|0);
  ;
  return $8;
}


function __ZN13address_table13subtable_openEj($this, $l1index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $subentry;
      var $size;
      var $newentry;
      var $newentry1;
      var $size2;
      var $src;
      var $i;
      $1=$this;
      $2=$l1index;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+$4)|0);
      var $8=HEAP8[($7)];
      $subentry=$8;
      var $9=$subentry;
      var $10=(($9)&255);
      var $11=(($10)|0) < 192;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=__ZNK13address_table11level2_bitsEv($3);
      var $14=1 << $13;
      $size=$14;
      var $15=__ZN13address_table14subtable_allocEv($3);
      $newentry=$15;
      var $16=$subentry;
      var $17=$size;
      var $18=(($17-1)|0);
      __ZN13address_table11handler_refEhi($3, $16, $18);
      var $19=$newentry;
      var $20=__ZN13address_table12subtable_ptrEh($3, $19);
      var $21=$subentry;
      var $22=(($21)&255);
      var $23=(($22) & 255);
      var $24=$size;
      _memset($20, $23, $24, 1);
      var $25=$newentry;
      var $26=$2;
      var $27=(($3+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+$26)|0);
      HEAP8[($29)]=$25;
      var $30=$subentry;
      var $31=(($30)&255);
      var $32=$subentry;
      var $33=(($32)&255);
      var $34=$33 << 8;
      var $35=(($31+$34)|0);
      var $36=$subentry;
      var $37=(($36)&255);
      var $38=$37 << 16;
      var $39=(($35+$38)|0);
      var $40=$subentry;
      var $41=(($40)&255);
      var $42=$41 << 24;
      var $43=(($39+$42)|0);
      var $44=__ZNK13address_table11level2_bitsEv($3);
      var $45=1 << $44;
      var $46=(((($45)|0)/4)|0);
      var $47=(($43*$46)|0);
      var $48=$newentry;
      var $49=(($48)&255);
      var $50=(($49-192)|0);
      var $51=(($3+20)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+$50*12)|0);
      var $54=(($53+4)|0);
      HEAP32[(($54)>>2)]=$47;
      var $55=$newentry;
      $subentry=$55;
      __label__ = 13; break;
    case 2: // $56
      var $57=$subentry;
      var $58=(($57)&255);
      var $59=(($58-192)|0);
      var $60=(($3+20)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+$59*12)|0);
      var $63=(($62+8)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=(($64)>>>0) > 1;
      if ($65) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $66
      var $67=__ZN13address_table14subtable_allocEv($3);
      $newentry1=$67;
      var $68=$2;
      var $69=(($3+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+$68)|0);
      var $72=HEAP8[($71)];
      $subentry=$72;
      __label__ = 4; break;
    case 4: // $73
      __label__ = 5; break;
    case 5: // $74
      __label__ = 6; break;
    case 6: // $75
      __label__ = 7; break;
    case 7: // $76
      var $77=__ZNK13address_table11level2_bitsEv($3);
      var $78=1 << $77;
      $size2=$78;
      var $79=$subentry;
      var $80=__ZN13address_table12subtable_ptrEh($3, $79);
      $src=$80;
      $i=0;
      __label__ = 8; break;
    case 8: // $81
      var $82=$i;
      var $83=$size2;
      var $84=(($82)|0)!=(($83)|0);
      if ($84) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $85
      var $86=$i;
      var $87=$src;
      var $88=(($87+$86)|0);
      var $89=HEAP8[($88)];
      __ZN13address_table11handler_refEhi($3, $89, 1);
      __label__ = 10; break;
    case 10: // $90
      var $91=$i;
      var $92=(($91+1)|0);
      $i=$92;
      __label__ = 8; break;
    case 11: // $93
      var $94=$newentry1;
      var $95=__ZN13address_table12subtable_ptrEh($3, $94);
      var $96=$src;
      var $97=$size2;
      assert($97 % 1 === 0, 'memcpy given ' + $97 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($95, $96, $97, 1);
      var $98=$subentry;
      __ZN13address_table16subtable_releaseEh($3, $98);
      var $99=$newentry1;
      var $100=$2;
      var $101=(($3+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+$100)|0);
      HEAP8[($103)]=$99;
      var $104=$subentry;
      var $105=(($104)&255);
      var $106=(($105-192)|0);
      var $107=(($3+20)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+$106*12)|0);
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$newentry1;
      var $113=(($112)&255);
      var $114=(($113-192)|0);
      var $115=(($3+20)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116+$114*12)|0);
      var $118=(($117+4)|0);
      HEAP32[(($118)>>2)]=$111;
      var $119=$newentry1;
      $subentry=$119;
      __label__ = 12; break;
    case 12: // $120
      __label__ = 13; break;
    case 13: // $121
      var $122=$subentry;
      var $123=(($122)&255);
      var $124=(($123-192)|0);
      var $125=(($3+20)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+$124*12)|0);
      var $128=(($127)|0);
      HEAP8[($128)]=0;
      var $129=$subentry;
      var $130=__ZN13address_table12subtable_ptrEh($3, $129);
      ;
      return $130;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table13subtable_openEj["X"]=1;

function __ZN13address_table13handler_unrefEh($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$entry;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($6)&255);
      var $8=(($7)|0) >= 128;
      if ($8) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $9
      var $10=$2;
      var $11=(($10)&255);
      var $12=(($11-128)|0);
      var $13=(($3+28)|0);
      var $14=(($13+($12<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15-1)|0);
      HEAP32[(($14)>>2)]=$16;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=$3;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$2;
      var $24=(($23)&255);
      var $25=FUNCTION_TABLE[$22]($3, $24);
      __ZN13handler_entry11deconfigureEv($25);
      var $26=(($3+348)|0);
      var $27=HEAP8[($26)];
      var $28=$2;
      var $29=(($28)&255);
      var $30=(($29-128)|0);
      var $31=(($3+284)|0);
      var $32=(($31+$30)|0);
      HEAP8[($32)]=$27;
      var $33=$2;
      var $34=(($3+348)|0);
      HEAP8[($34)]=$33;
      __label__ = 5; break;
    case 5: // $35
      __label__ = 6; break;
    case 6: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data26remove_intersecting_rangesEjj($this, $bytestart, $byteend) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $nextrange;
      var $range;
      $1=$this;
      $2=$bytestart;
      $3=$byteend;
      var $4=$1;
      $entry=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$entry;
      var $7=(($6)>>>0) < 256;
      if ($7) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $8
      var $9=$entry;
      var $10=(($4+28)|0);
      var $11=(($10+$9*20)|0);
      var $12=__ZNK11simple_listIN16direct_read_data12direct_rangeEE5firstEv($11);
      $range=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$range;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=$range;
      var $18=__ZNK16direct_read_data12direct_range4nextEv($17);
      $nextrange=$18;
      var $19=$2;
      var $20=$range;
      var $21=(($20+8)|0);
      var $22=HEAPU32[(($21)>>2)];
      var $23=(($19)>>>0) <= (($22)>>>0);
      if ($23) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $24
      var $25=$3;
      var $26=$range;
      var $27=(($26+4)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=(($25)>>>0) >= (($28)>>>0);
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=$entry;
      var $32=(($4+28)|0);
      var $33=(($32+$31*20)|0);
      var $34=$range;
      var $35=__ZN11simple_listIN16direct_read_data12direct_rangeEE6detachERS1_($33, $34);
      var $36=(($4+5148)|0);
      var $37=$range;
      var $38=__ZN11simple_listIN16direct_read_data12direct_rangeEE7prependERS1_($36, $37);
      __label__ = 7; break;
    case 7: // $39
      __label__ = 8; break;
    case 8: // $40
      var $41=$nextrange;
      $range=$41;
      __label__ = 3; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      var $44=$entry;
      var $45=(($44+1)|0);
      $entry=$45;
      __label__ = 1; break;
    case 11: // $46
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_data26remove_intersecting_rangesEjj["X"]=1;

function __ZNK13address_table12level1_indexEj($this, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$address;
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__ZNK13address_table18level1_index_largeEj($3, $8);
      var $13 = $9;__label__ = 3; break;
    case 2: // $10
      var $11=$2;
      var $13 = $11;__label__ = 3; break;
    case 3: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_table16subtable_releaseEh($this, $subentry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $subindex;
      var $subtable;
      var $i;
      $1=$this;
      $2=$subentry;
      var $3=$1;
      var $4=$2;
      var $5=(($4)&255);
      var $6=(($5-192)|0);
      var $7=(($6) & 255);
      $subindex=$7;
      var $8=$subindex;
      var $9=(($8)&255);
      var $10=(($3+20)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+$9*12)|0);
      var $13=(($12+8)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($14)>>>0) <= 0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      __Z10fatalerrorPKcz(((STRING_TABLE.__str412932)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $17
      var $18=$subindex;
      var $19=(($18)&255);
      var $20=(($3+20)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+$19*12)|0);
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24-1)|0);
      HEAP32[(($23)>>2)]=$25;
      var $26=$subindex;
      var $27=(($26)&255);
      var $28=(($3+20)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$27*12)|0);
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $34
      var $35=$subindex;
      var $36=(($35)&255);
      var $37=(($3+20)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+$36*12)|0);
      var $40=(($39+4)|0);
      HEAP32[(($40)>>2)]=0;
      var $41=$2;
      var $42=__ZN13address_table12subtable_ptrEh($3, $41);
      $subtable=$42;
      $i=0;
      __label__ = 4; break;
    case 4: // $43
      var $44=$i;
      var $45=(($44)|0) < 16384;
      if ($45) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $46
      var $47=$i;
      var $48=$subtable;
      var $49=(($48+$47)|0);
      var $50=HEAP8[($49)];
      __ZN13address_table13handler_unrefEh($3, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$i;
      var $53=(($52+1)|0);
      $i=$53;
      __label__ = 4; break;
    case 7: // $54
      __label__ = 8; break;
    case 8: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table16subtable_releaseEh["X"]=1;

function __ZN13address_table16subtable_reallocEh($this, $subentry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $subindex;
      $1=$this;
      $2=$subentry;
      var $3=$1;
      var $4=$2;
      var $5=(($4)&255);
      var $6=(($5-192)|0);
      var $7=(($6) & 255);
      $subindex=$7;
      var $8=$subindex;
      var $9=(($8)&255);
      var $10=(($3+20)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+$9*12)|0);
      var $13=(($12+8)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($14)>>>0) <= 0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      __Z10fatalerrorPKcz(((STRING_TABLE.__str402931)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $17
      var $18=$subindex;
      var $19=(($18)&255);
      var $20=(($3+20)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+$19*12)|0);
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+1)|0);
      HEAP32[(($23)>>2)]=$25;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13handler_entry18mirrored_start_endEjRjS0_($this, $byteaddress, $start, $end) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $mirrorbits;
  $1=$this;
  $2=$byteaddress;
  $3=$start;
  $4=$end;
  var $5=$1;
  var $6=$2;
  var $7=(($5+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6-$8)|0);
  var $10=(($5+20)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$11 ^ -1;
  var $13=$9 & $12;
  $mirrorbits=$13;
  var $14=(($5+12)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$mirrorbits;
  var $17=$15 | $16;
  var $18=$3;
  HEAP32[(($18)>>2)]=$17;
  var $19=(($5+16)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$mirrorbits;
  var $22=$20 | $21;
  var $23=$4;
  HEAP32[(($23)>>2)]=$22;
  ;
  return;
}


function __ZN13handler_entry10apply_maskEj($this, $bytemask) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$bytemask;
  var $3=$1;
  var $4=$2;
  var $5=(($3+20)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6 & $4;
  HEAP32[(($5)>>2)]=$7;
  ;
  return;
}


function __ZNK13address_table12level2_indexEhj($this, $l1entry, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$l1entry;
      $3=$address;
      var $4=$1;
      var $5=(($4+16)|0);
      var $6=HEAP8[($5)];
      var $7=(($6) & 1);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=$3;
      var $11=__ZNK13address_table18level2_index_largeEhj($4, $9, $10);
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13address_table14subtable_mergeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $merged;
      var $subindex;
      var $subtable;
      var $checksum;
      var $l2index;
      var $subtable1;
      var $checksum2;
      var $sumindex;
      var $l1index;
      $1=$this;
      var $2=$1;
      $merged=0;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      $subindex=0;
      __label__ = 3; break;
    case 3: // $5
      var $6=$subindex;
      var $7=(($6)&255);
      var $8=(($7)|0) < 64;
      if ($8) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $9
      var $10=$subindex;
      var $11=(($10)&255);
      var $12=(($2+20)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$11*12)|0);
      var $15=(($14)|0);
      var $16=HEAP8[($15)];
      var $17=(($16) & 1);
      if ($17) { __label__ = 11; break; } else { __label__ = 5; break; }
    case 5: // $18
      var $19=$subindex;
      var $20=(($19)&255);
      var $21=(($2+20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+$20*12)|0);
      var $24=(($23+8)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $27
      var $28=$subindex;
      var $29=(($28)&255);
      var $30=(($29+192)|0);
      var $31=(($30) & 255);
      var $32=__ZN13address_table12subtable_ptrEh($2, $31);
      var $33=$32;
      $subtable=$33;
      $checksum=0;
      $l2index=0;
      __label__ = 7; break;
    case 7: // $34
      var $35=$l2index;
      var $36=__ZNK13address_table11level2_bitsEv($2);
      var $37=1 << $36;
      var $38=(((($37)|0)/4)|0);
      var $39=(($35)|0) < (($38)|0);
      if ($39) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $40
      var $41=$l2index;
      var $42=$subtable;
      var $43=(($42+($41<<2))|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$checksum;
      var $46=(($45+$44)|0);
      $checksum=$46;
      __label__ = 9; break;
    case 9: // $47
      var $48=$l2index;
      var $49=(($48+1)|0);
      $l2index=$49;
      __label__ = 7; break;
    case 10: // $50
      var $51=$checksum;
      var $52=$subindex;
      var $53=(($52)&255);
      var $54=(($2+20)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+$53*12)|0);
      var $57=(($56+4)|0);
      HEAP32[(($57)>>2)]=$51;
      var $58=$subindex;
      var $59=(($58)&255);
      var $60=(($2+20)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+$59*12)|0);
      var $63=(($62)|0);
      HEAP8[($63)]=1;
      __label__ = 11; break;
    case 11: // $64
      __label__ = 12; break;
    case 12: // $65
      var $66=$subindex;
      var $67=(($66+1)&255);
      $subindex=$67;
      __label__ = 3; break;
    case 13: // $68
      $subindex=0;
      __label__ = 14; break;
    case 14: // $69
      var $70=$subindex;
      var $71=(($70)&255);
      var $72=(($71)|0) < 64;
      if ($72) { __label__ = 15; break; } else { __label__ = 35; break; }
    case 15: // $73
      var $74=$subindex;
      var $75=(($74)&255);
      var $76=(($2+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+$75*12)|0);
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 16; break; } else { __label__ = 33; break; }
    case 16: // $82
      var $83=$subindex;
      var $84=(($83)&255);
      var $85=(($84+192)|0);
      var $86=(($85) & 255);
      var $87=__ZN13address_table12subtable_ptrEh($2, $86);
      $subtable1=$87;
      var $88=$subindex;
      var $89=(($88)&255);
      var $90=(($2+20)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91+$89*12)|0);
      var $93=(($92+4)|0);
      var $94=HEAP32[(($93)>>2)];
      $checksum2=$94;
      var $95=$subindex;
      var $96=(($95)&255);
      var $97=(($96+1)|0);
      var $98=(($97) & 255);
      $sumindex=$98;
      __label__ = 17; break;
    case 17: // $99
      var $100=$sumindex;
      var $101=(($100)&255);
      var $102=(($101)|0) < 64;
      if ($102) { __label__ = 18; break; } else { __label__ = 32; break; }
    case 18: // $103
      var $104=$sumindex;
      var $105=(($104)&255);
      var $106=(($2+20)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107+$105*12)|0);
      var $109=(($108+8)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 19; break; } else { __label__ = 30; break; }
    case 19: // $112
      var $113=$sumindex;
      var $114=(($113)&255);
      var $115=(($2+20)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116+$114*12)|0);
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$checksum2;
      var $121=(($119)|0)==(($120)|0);
      if ($121) { __label__ = 20; break; } else { __label__ = 30; break; }
    case 20: // $122
      var $123=$subtable1;
      var $124=$sumindex;
      var $125=(($124)&255);
      var $126=(($125+192)|0);
      var $127=(($126) & 255);
      var $128=__ZN13address_table12subtable_ptrEh($2, $127);
      var $129=__ZNK13address_table11level2_bitsEv($2);
      var $130=1 << $129;
      var $131=_memcmp($123, $128, $130);
      var $132=(($131)|0)!=0;
      if ($132) { __label__ = 30; break; } else { __label__ = 21; break; }
    case 21: // $133
      __label__ = 22; break;
    case 22: // $134
      __label__ = 23; break;
    case 23: // $135
      $l1index=0;
      __label__ = 24; break;
    case 24: // $136
      var $137=$l1index;
      var $138=__ZNK13address_table11level2_bitsEv($2);
      var $139=-1 >>> (($138)>>>0);
      var $140=(($137)>>>0) <= (($139)>>>0);
      if ($140) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $141
      var $142=$l1index;
      var $143=(($2+4)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+$142)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$sumindex;
      var $149=(($148)&255);
      var $150=(($149+192)|0);
      var $151=(($147)|0)==(($150)|0);
      if ($151) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $152
      var $153=$sumindex;
      var $154=(($153)&255);
      var $155=(($154+192)|0);
      var $156=(($155) & 255);
      __ZN13address_table16subtable_releaseEh($2, $156);
      var $157=$subindex;
      var $158=(($157)&255);
      var $159=(($158+192)|0);
      var $160=(($159) & 255);
      __ZN13address_table16subtable_reallocEh($2, $160);
      var $161=$subindex;
      var $162=(($161)&255);
      var $163=(($162+192)|0);
      var $164=(($163) & 255);
      var $165=$l1index;
      var $166=(($2+4)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167+$165)|0);
      HEAP8[($168)]=$164;
      var $169=$merged;
      var $170=(($169+1)|0);
      $merged=$170;
      __label__ = 27; break;
    case 27: // $171
      __label__ = 28; break;
    case 28: // $172
      var $173=$l1index;
      var $174=(($173+1)|0);
      $l1index=$174;
      __label__ = 24; break;
    case 29: // $175
      __label__ = 30; break;
    case 30: // $176
      __label__ = 31; break;
    case 31: // $177
      var $178=$sumindex;
      var $179=(($178+1)&255);
      $sumindex=$179;
      __label__ = 17; break;
    case 32: // $180
      __label__ = 33; break;
    case 33: // $181
      __label__ = 34; break;
    case 34: // $182
      var $183=$subindex;
      var $184=(($183+1)&255);
      $subindex=$184;
      __label__ = 14; break;
    case 35: // $185
      var $186=$merged;
      ;
      return $186;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table14subtable_mergeEv["X"]=1;

function __ZNK11memory_bank4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+40)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK13handler_entry11descriptionEPc($this, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $i;
      $1=$this;
      $2=$buffer;
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $7
      $i=0;
      __label__ = 2; break;
    case 2: // $8
      var $9=$i;
      var $10=(($3+28)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($9)|0)!=(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $14
      var $15=$i;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$2;
      var $19=(($18+1)|0);
      $2=$19;
      HEAP8[($18)]=32;
      __label__ = 5; break;
    case 5: // $20
      var $21=$2;
      var $22=$i;
      var $23=(($3+32)|0);
      var $24=(($23+($22<<4))|0);
      var $25=(($24+12)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$i;
      var $29=(($3+32)|0);
      var $30=(($29+($28<<4))|0);
      var $31=(($30+13)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$i;
      var $35=(($3+32)|0);
      var $36=(($35+($34<<4))|0);
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$i;
      var $40=(($3+32)|0);
      var $41=(($40+($39<<4))|0);
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$3;
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+12)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$i;
      var $49=FUNCTION_TABLE[$47]($3, $48);
      var $50=_sprintf($21, ((STRING_TABLE.__str2063097)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$27,HEAP32[((tempInt+4)>>2)]=$33,HEAP32[((tempInt+8)>>2)]=$38,HEAP32[((tempInt+12)>>2)]=$43,HEAP32[((tempInt+16)>>2)]=$49,tempInt));
      var $51=$2;
      var $52=(($51+$50)|0);
      $2=$52;
      __label__ = 6; break;
    case 6: // $53
      var $54=$i;
      var $55=(($54+1)|0);
      $i=$55;
      __label__ = 2; break;
    case 7: // $56
      __label__ = 9; break;
    case 8: // $57
      var $58=$2;
      var $59=$3;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+8)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=FUNCTION_TABLE[$62]($3);
      var $64=_strcpy($58, $63);
      __label__ = 9; break;
    case 9: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13handler_entry11descriptionEPc["X"]=1;

function __ZN13address_table14subtable_allocEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $subindex;
      var $oldsize;
      var $newsize;
      var $newtable;
      $7=$this;
      var $8=$7;
      __label__ = 1; break;
    case 1: // $9
      $subindex=0;
      __label__ = 2; break;
    case 2: // $10
      var $11=$subindex;
      var $12=(($11)&255);
      var $13=(($12)|0) < 64;
      if ($13) { __label__ = 3; break; } else { __label__ = 18; break; }
    case 3: // $14
      var $15=$subindex;
      var $16=(($15)&255);
      var $17=(($8+20)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+$16*12)|0);
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $23
      var $24=$subindex;
      var $25=(($24)&255);
      var $26=(($8+24)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($25)|0) >= (($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $30
      var $31=(($8+24)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=__ZNK13address_table11level2_bitsEv($8);
      var $35=$33 << $34;
      var $36=(($35+262144)|0);
      $oldsize=$36;
      var $37=(($8+24)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=(($39+8)|0);
      var $41=(($40) & 255);
      HEAP8[($37)]=$41;
      var $42=(($8+24)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=__ZNK13address_table11level2_bitsEv($8);
      var $46=$44 << $45;
      var $47=(($46+262144)|0);
      $newsize=$47;
      var $48=(($8+12)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=__ZNK13address_space7machineEv($49);
      var $51=__ZN15running_machine7respoolEv($50);
      var $52=$newsize;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      var $56=$4;
      var $57=$result_i;
      var $58=$5;
      var $59=$6;
      HEAP32[(($1)>>2)]=$52;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=3890;
      HEAP32[(($4)>>2)]=_zeromem;
      var $60=HEAP32[(($1)>>2)];
      var $61=HEAP32[(($2)>>2)];
      var $62=HEAP32[(($3)>>2)];
      var $63=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($60, $61, $62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $64
      HEAP32[(($result_i)>>2)]=$63;
      var $65=HEAP32[(($result_i)>>2)];
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $67
      var $68=___cxa_allocate_exception(4);
      var $69=$68;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($69);
      (function() { try { __THREW__ = false; return ___cxa_throw($68, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      HEAP32[(($5)>>2)]=$72;
      var $73=$71.f1;
      HEAP32[(($6)>>2)]=$73;
      var $74=HEAP32[(($6)>>2)];
      var $75=(($74)|0) < 0;
      if ($75) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $76
      var $77=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($77);
      throw "Reached an unreachable!"
    case 10: // $78
      var $79=HEAP32[(($5)>>2)];
      var $80=HEAP32[(($5)>>2)];
      var $81=HEAP32[(($6)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $84
      throw "Reached an unreachable!"
    case 12: // $_ZnajPKciRK9zeromem_t_exit
      var $85=HEAP32[(($result_i)>>2)];
      var $86=HEAP32[(($1)>>2)];
      _memset($85, 0, $86, 1);
      var $87=HEAP32[(($result_i)>>2)];
      var $88=$1;
      var $89=$2;
      var $90=$3;
      var $91=$4;
      var $92=$result_i;
      var $93=$5;
      var $94=$6;
      var $95=$newsize;
      var $96=__ZN13resource_pool9add_arrayIhEEPT_S2_i($51, $87, $95);
      $newtable=$96;
      var $97=$newtable;
      var $98=(($8+4)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$oldsize;
      assert($100 % 1 === 0, 'memcpy given ' + $100 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($97, $99, $100, 1);
      var $101=(($8+8)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($8+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($102)|0)==(($104)|0);
      if ($105) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $106
      var $107=$newtable;
      var $108=(($8+8)|0);
      HEAP32[(($108)>>2)]=$107;
      __label__ = 14; break;
    case 14: // $109
      var $110=(($8+12)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=__ZNK13address_space7machineEv($111);
      var $113=__ZN15running_machine7respoolEv($112);
      var $114=(($8+4)|0);
      var $115=HEAP32[(($114)>>2)];
      __ZN13resource_pool6removeEPv($113, $115);
      var $116=$newtable;
      var $117=(($8+4)|0);
      HEAP32[(($117)>>2)]=$116;
      __label__ = 15; break;
    case 15: // $118
      var $119=$subindex;
      var $120=(($119)&255);
      var $121=(($8+20)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122+$120*12)|0);
      var $124=(($123+8)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125+1)|0);
      HEAP32[(($124)>>2)]=$126;
      var $127=$subindex;
      var $128=(($127)&255);
      var $129=(($128+192)|0);
      var $130=(($129) & 255);
      STACKTOP = __stackBase__;
      return $130;
    case 16: // $131
      __label__ = 17; break;
    case 17: // $132
      var $133=$subindex;
      var $134=(($133+1)&255);
      $subindex=$134;
      __label__ = 2; break;
    case 18: // $135
      var $136=__ZN13address_table14subtable_mergeEv($8);
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $138
      __Z10fatalerrorPKcz(((STRING_TABLE.__str392930)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 20: // $139
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13address_table14subtable_allocEv["X"]=1;

function __ZN18handler_entry_readC1Eh12endianness_tPPh($this, $width, $endianness, $rambaseptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$width;
  $3=$endianness;
  $4=$rambaseptr;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN18handler_entry_readC2Eh12endianness_tPPh($5, $6, $7, $8);
  ;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC1I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFhR13address_spacejhEEC2I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18address_table_read7unmap_rIhEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$mask;
      var $5=$1;
      var $6=$5;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK13address_space9log_unmapEv($8);
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$5;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK13address_space15debugger_accessEv($13);
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      var $16=$5;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZNK13address_space7machineEv($18);
      var $20=__ZN15running_machine16describe_contextEv($19);
      var $21=$5;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__ZNK13address_space4nameEv($23);
      var $25=$5;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=(($28)|0);
      var $30=__ZNK13address_space15byte_to_addressEj($27, $29);
      var $31$0=$30;
      var $31$1=0;
      var $32=$5;
      var $33=(($32+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZNK13address_space9addrcharsEv($34);
      var $36=__Z19core_i64_hex_formatyh($31$0, $31$1, $35);
      var $37=$4;
      var $38$0=$37;
      var $38$1=0;
      var $39=__Z19core_i64_hex_formatyh($38$0, $38$1, 2);
      __Z8logerrorPKcz(((STRING_TABLE.__str2093100)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,HEAP32[((tempInt+4)>>2)]=$24,HEAP32[((tempInt+8)>>2)]=$36,HEAP32[((tempInt+12)>>2)]=$39,tempInt));
      __label__ = 3; break;
    case 3: // $40
      var $41=$5;
      var $42=(($41+12)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=__ZNK13address_space5unmapEv($43);
      var $44$0=$44[0];
      var $44$1=$44[1];
      var $45$0=$44$0;
      var $45=$45$0&255;
      ;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_read7unmap_rIhEET_R13address_spacejS1_["X"]=1;

function __ZN18address_table_read5nop_rIhEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space5unmapEv($8);
  var $9$0=$9[0];
  var $9$1=$9[1];
  var $10$0=$9$0;
  var $10=$10$0&255;
  ;
  return $10;
}


function __ZN18address_table_readC2ER13address_spaceb($this, $space, $large) {
  var __stackBase__  = STACKTOP; STACKTOP += 420; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $entrynum;
      var $bankptr;
      var $12;
      var $13;
      var $14=__stackBase__+36;
      var $15=__stackBase__+60;
      var $16=__stackBase__+68;
      var $17=__stackBase__+92;
      var $18=__stackBase__+100;
      var $19=__stackBase__+124;
      var $20=__stackBase__+132;
      var $21=__stackBase__+156;
      var $22=__stackBase__+164;
      var $23=__stackBase__+188;
      var $24=__stackBase__+196;
      var $25=__stackBase__+220;
      var $26=__stackBase__+228;
      var $27=__stackBase__+252;
      var $28=__stackBase__+260;
      var $29=__stackBase__+284;
      var $30=__stackBase__+292;
      var $31=__stackBase__+316;
      var $32=__stackBase__+324;
      var $33=__stackBase__+348;
      var $34=__stackBase__+356;
      var $35=__stackBase__+380;
      var $36=__stackBase__+388;
      var $37=__stackBase__+412;
      $9=$this;
      $10=$space;
      var $38=(($large)&1);
      $11=$38;
      var $39=$9;
      var $40=$39;
      var $41=$10;
      var $42=$11;
      var $43=(($42) & 1);
      __ZN13address_tableC2ER13address_spaceb($40, $41, $43);
      var $44=$39;
      HEAP32[(($44)>>2)]=((__ZTV18address_table_read+8)|0);
      $entrynum=0;
      __label__ = 1; break;
    case 1: // $45
      var $46=$entrynum;
      var $47=(($46)>>>0) < 256;
      if ($47) { __label__ = 2; break; } else { __label__ = 31; break; }
    case 2: // $48
      var $49=$entrynum;
      var $50=(($49)|0) >= 1;
      if ($50) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $51
      var $52=$entrynum;
      var $53=(($52)|0) <= 124;
      if ($53) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $54
      var $55=$entrynum;
      var $56=$10;
      var $57=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 24; break; };
    case 5: // $58
      var $59=(($57+624)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+4)|0);
      var $62=(($61+($55<<2))|0);
      var $65 = $62;__label__ = 7; break;
    case 6: // $63
      var $65 = 0;__label__ = 7; break;
    case 7: // $64
      var $65;
      $bankptr=$65;
      var $66=$10;
      var $67=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 24; break; };
    case 8: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 24; break; };
    case 9: // $70
      var $71=$4;
      var $72=$5;
      var $73=$6;
      var $74=$result_i;
      var $75=$7;
      var $76=$8;
      HEAP32[(($4)>>2)]=1116;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=4149;
      var $77=HEAP32[(($4)>>2)];
      var $78=HEAP32[(($5)>>2)];
      var $79=HEAP32[(($6)>>2)];
      var $80=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($77, $78, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $81
      HEAP32[(($result_i)>>2)]=$80;
      var $82=HEAP32[(($result_i)>>2)];
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $84
      var $85=___cxa_allocate_exception(4);
      var $86=$85;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($86);
      (function() { try { __THREW__ = false; return ___cxa_throw($85, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 12: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      HEAP32[(($7)>>2)]=$89;
      var $90=$88.f1;
      HEAP32[(($8)>>2)]=$90;
      var $91=HEAP32[(($8)>>2)];
      var $92=(($91)|0) < 0;
      if ($92) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $93
      var $94=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $_noexc
      throw "Reached an unreachable!"
    case 15: // $95
      var $96=HEAP32[(($7)>>2)];
      var $97=HEAP32[(($7)>>2)];
      var $98=HEAP32[(($8)>>2)];
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      var $eh_lpad_body = $100;__label__ = 25; break;
    case 16: // $101
      throw "Reached an unreachable!"
    case 17: // $_ZnwjPKci_exit
      var $102=HEAP32[(($result_i)>>2)];
      var $103=$4;
      var $104=$5;
      var $105=$6;
      var $106=$result_i;
      var $107=$7;
      var $108=$8;
      __label__ = 18; break;
    case 18: // $109
      var $110=$102;
      var $111=$10;
      var $112=(function() { try { __THREW__ = false; return __ZNK13address_space10data_widthEv($111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 26; break; };
    case 19: // $113
      var $114=(($112) & 255);
      var $115=$10;
      var $116=(function() { try { __THREW__ = false; return __ZNK13address_space10endiannessEv($115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; };
    case 20: // $117
      var $118=$bankptr;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_readC1Eh12endianness_tPPh($110, $114, $116, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $119
      var $120=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI18handler_entry_readEEPT_S3_($69, $110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; };
    case 22: // $121
      var $122=$entrynum;
      var $123=(($39+352)|0);
      var $124=(($123+($122<<2))|0);
      HEAP32[(($124)>>2)]=$120;
      __label__ = 23; break;
    case 23: // $125
      var $126=$entrynum;
      var $127=(($126+1)|0);
      $entrynum=$127;
      __label__ = 1; break;
    case 24: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $129;__label__ = 25; break;
    case 25: // $_body
      var $eh_lpad_body;
      var $130=$eh_lpad_body.f0;
      $12=$130;
      var $131=$eh_lpad_body.f1;
      $13=$131;
      __label__ = 68; break;
    case 26: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $134=$133.f0;
      $12=$134;
      var $135=$133.f1;
      $13=$135;
      var $136=$1;
      var $137=$2;
      var $138=$3;
      HEAP32[(($1)>>2)]=$102;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=4149;
      var $139=HEAP32[(($1)>>2)];
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $141
      var $142=HEAP32[(($1)>>2)];
      var $143=HEAP32[(($2)>>2)];
      var $144=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($142, $143, $144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 71; break; }
    case 28: // $_noexc1
      __label__ = 29; break;
    case 29: // $_ZdlPvPKci_exit
      var $145=$1;
      var $146=$2;
      var $147=$3;
      __label__ = 30; break;
    case 30: // $148
      __label__ = 68; break;
    case 31: // $149
      var $150=$10;
      var $151=(function() { try { __THREW__ = false; return __ZNK13address_space10data_widthEv($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 24; break; };
    case 32: // $152
      if ($151 == 8) {
        __label__ = 33; break;
      }
      else if ($151 == 16) {
        __label__ = 40; break;
      }
      else if ($151 == 32) {
        __label__ = 47; break;
      }
      else if ($151 == 64) {
        __label__ = 54; break;
      }
      else {
      __label__ = 61; break;
      }
      
    case 33: // $153
      var $154=(($39+352)|0);
      var $155=(($154+504)|0);
      var $156=HEAP32[(($155)>>2)];
      HEAP32[(($15)>>2)]={ f0: 258, f1: 0 }.f0; HEAP32[(($15+4)>>2)]={ f0: 258, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFhR13address_spacejhEEC1I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($14, $15, ((STRING_TABLE.__str1713062)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 24; break; }
    case 34: // $157
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($156, $14, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 24; break; }
    case 35: // $158
      var $159=(($39+352)|0);
      var $160=(($159+500)|0);
      var $161=HEAP32[(($160)>>2)];
      HEAP32[(($17)>>2)]={ f0: 260, f1: 0 }.f0; HEAP32[(($17+4)>>2)]={ f0: 260, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFhR13address_spacejhEEC1I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($16, $17, ((STRING_TABLE.__str1723063)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 24; break; }
    case 36: // $162
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($161, $16, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 24; break; }
    case 37: // $163
      var $164=(($39+352)|0);
      var $165=(($164+508)|0);
      var $166=HEAP32[(($165)>>2)];
      HEAP32[(($19)>>2)]={ f0: 262, f1: 0 }.f0; HEAP32[(($19+4)>>2)]={ f0: 262, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFhR13address_spacejhEEC1I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($18, $19, ((STRING_TABLE.__str1733064)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 24; break; }
    case 38: // $167
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($166, $18, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 24; break; }
    case 39: // $168
      __label__ = 61; break;
    case 40: // $169
      var $170=(($39+352)|0);
      var $171=(($170+504)|0);
      var $172=HEAP32[(($171)>>2)];
      HEAP32[(($21)>>2)]={ f0: 264, f1: 0 }.f0; HEAP32[(($21+4)>>2)]={ f0: 264, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFtR13address_spacejtEEC1I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($20, $21, ((STRING_TABLE.__str1743065)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 24; break; }
    case 41: // $173
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($172, $20, $$emscripten$temp$3$0, $$emscripten$temp$3$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 24; break; }
    case 42: // $174
      var $175=(($39+352)|0);
      var $176=(($175+500)|0);
      var $177=HEAP32[(($176)>>2)];
      HEAP32[(($23)>>2)]={ f0: 266, f1: 0 }.f0; HEAP32[(($23+4)>>2)]={ f0: 266, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFtR13address_spacejtEEC1I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($22, $23, ((STRING_TABLE.__str1753066)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 24; break; }
    case 43: // $178
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($177, $22, $$emscripten$temp$4$0, $$emscripten$temp$4$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 24; break; }
    case 44: // $179
      var $180=(($39+352)|0);
      var $181=(($180+508)|0);
      var $182=HEAP32[(($181)>>2)];
      HEAP32[(($25)>>2)]={ f0: 268, f1: 0 }.f0; HEAP32[(($25+4)>>2)]={ f0: 268, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFtR13address_spacejtEEC1I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($24, $25, ((STRING_TABLE.__str1763067)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 24; break; }
    case 45: // $183
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($182, $24, $$emscripten$temp$5$0, $$emscripten$temp$5$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 24; break; }
    case 46: // $184
      __label__ = 61; break;
    case 47: // $185
      var $186=(($39+352)|0);
      var $187=(($186+504)|0);
      var $188=HEAP32[(($187)>>2)];
      HEAP32[(($27)>>2)]={ f0: 270, f1: 0 }.f0; HEAP32[(($27+4)>>2)]={ f0: 270, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFjR13address_spacejjEEC1I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($26, $27, ((STRING_TABLE.__str1773068)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 24; break; }
    case 48: // $189
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($188, $26, $$emscripten$temp$6$0, $$emscripten$temp$6$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 24; break; }
    case 49: // $190
      var $191=(($39+352)|0);
      var $192=(($191+500)|0);
      var $193=HEAP32[(($192)>>2)];
      HEAP32[(($29)>>2)]={ f0: 272, f1: 0 }.f0; HEAP32[(($29+4)>>2)]={ f0: 272, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFjR13address_spacejjEEC1I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($28, $29, ((STRING_TABLE.__str1783069)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 24; break; }
    case 50: // $194
      var $$emscripten$temp$7$0=0;
      var $$emscripten$temp$7$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($193, $28, $$emscripten$temp$7$0, $$emscripten$temp$7$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 24; break; }
    case 51: // $195
      var $196=(($39+352)|0);
      var $197=(($196+508)|0);
      var $198=HEAP32[(($197)>>2)];
      HEAP32[(($31)>>2)]={ f0: 274, f1: 0 }.f0; HEAP32[(($31+4)>>2)]={ f0: 274, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFjR13address_spacejjEEC1I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($30, $31, ((STRING_TABLE.__str1793070)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 24; break; }
    case 52: // $199
      var $$emscripten$temp$8$0=0;
      var $$emscripten$temp$8$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($198, $30, $$emscripten$temp$8$0, $$emscripten$temp$8$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 24; break; }
    case 53: // $200
      __label__ = 61; break;
    case 54: // $201
      var $202=(($39+352)|0);
      var $203=(($202+504)|0);
      var $204=HEAP32[(($203)>>2)];
      HEAP32[(($33)>>2)]={ f0: 276, f1: 0 }.f0; HEAP32[(($33+4)>>2)]={ f0: 276, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFyR13address_spacejyEEC1I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($32, $33, ((STRING_TABLE.__str1803071)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 24; break; }
    case 55: // $205
      var $$emscripten$temp$9$0=0;
      var $$emscripten$temp$9$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($204, $32, $$emscripten$temp$9$0, $$emscripten$temp$9$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 24; break; }
    case 56: // $206
      var $207=(($39+352)|0);
      var $208=(($207+500)|0);
      var $209=HEAP32[(($208)>>2)];
      HEAP32[(($35)>>2)]={ f0: 278, f1: 0 }.f0; HEAP32[(($35+4)>>2)]={ f0: 278, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFyR13address_spacejyEEC1I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($34, $35, ((STRING_TABLE.__str1813072)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 24; break; }
    case 57: // $210
      var $$emscripten$temp$10$0=0;
      var $$emscripten$temp$10$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($209, $34, $$emscripten$temp$10$0, $$emscripten$temp$10$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 24; break; }
    case 58: // $211
      var $212=(($39+352)|0);
      var $213=(($212+508)|0);
      var $214=HEAP32[(($213)>>2)];
      HEAP32[(($37)>>2)]={ f0: 280, f1: 0 }.f0; HEAP32[(($37+4)>>2)]={ f0: 280, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFyR13address_spacejyEEC1I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($36, $37, ((STRING_TABLE.__str1823073)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 24; break; }
    case 59: // $215
      var $$emscripten$temp$11$0=0;
      var $$emscripten$temp$11$1=0;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($214, $36, $$emscripten$temp$11$0, $$emscripten$temp$11$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 24; break; }
    case 60: // $216
      __label__ = 61; break;
    case 61: // $217
      var $218=(($39+352)|0);
      var $219=(($218+504)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$220;
      var $222=$10;
      var $223=(function() { try { __THREW__ = false; return __ZNK13address_space8bytemaskEv($222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 24; break; };
    case 62: // $224
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($221, 0, $223, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 24; break; }
    case 63: // $225
      var $226=(($39+352)|0);
      var $227=(($226+500)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$228;
      var $230=$10;
      var $231=(function() { try { __THREW__ = false; return __ZNK13address_space8bytemaskEv($230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 24; break; };
    case 64: // $232
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($229, 0, $231, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 24; break; }
    case 65: // $233
      var $234=(($39+352)|0);
      var $235=(($234+508)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=$236;
      var $238=$10;
      var $239=(function() { try { __THREW__ = false; return __ZNK13address_space8bytemaskEv($238) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 24; break; };
    case 66: // $240
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($237, 0, $239, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 24; break; }
    case 67: // $241
      STACKTOP = __stackBase__;
      return;
    case 68: // $242
      var $243=$39;
      (function() { try { __THREW__ = false; return __ZN13address_tableD2Ev($243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $244
      __label__ = 70; break;
    case 70: // $245
      var $246=$12;
      var $247=$12;
      var $248=$13;
      var $249=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $247, tempValue);
      var $250=($249.f1 = $248, $249);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 71: // $251
      var $252=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_readC2ER13address_spaceb["X"]=1;

function __ZN13resource_pool10add_objectI18handler_entry_readEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18handler_entry_readEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18handler_entry_readEEPT_S3_["X"]=1;

function __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $5;
      var $start_slot=__stackBase__+8;
      var $end_slot=__stackBase__+12;
      var $i;
      var $i1;
      var $6=__stackBase__+16;
      var $7=__stackBase__+40;
      var $8=__stackBase__+48;
      var $9=__stackBase__+72;
      var $10=__stackBase__+80;
      var $11=__stackBase__+104;
      $1=$this;
      var $st$16$0=(($2)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($2+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      $3=$info;
      var $12=$1;
      var $13=$delegate;
      var $14=__ZNK13delegate_baseIhR13address_spacejh8_noparamE10has_objectEv($13);
      if ($14) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $15
      var $16=___cxa_allocate_exception(1032);
      var $17=$16;
      var $18=$delegate;
      var $19=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $20
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($17, ((STRING_TABLE.__str2073098)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      ___cxa_throw($16, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $4=$24;
      var $25=$23.f1;
      $5=$25;
      ___cxa_free_exception($16);
      __label__ = 32; break;
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      __label__ = 7; break;
    case 7: // $28
      var $29=$12;
      var $30=(($29+5)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=(($32)|0)!=8;
      if ($33) { __label__ = 8; break; } else { __label__ = 28; break; }
    case 8: // $34
      var $35=$12;
      var $st$1$0=(($2)|0);
      var $36$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($2+4)|0);
      var $36$1=HEAP32[(($st$1$1)>>2)];
      __ZN13handler_entry18configure_subunitsEyiRiS0_($35, $36$0, $36$1, 8, $start_slot, $end_slot);
      var $37=$3;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $39
      var $40=HEAP32[(($start_slot)>>2)];
      $i=$40;
      __label__ = 10; break;
    case 10: // $41
      var $42=$i;
      var $43=HEAP32[(($end_slot)>>2)];
      var $44=(($42)|0)!=(($43)|0);
      if ($44) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $45
      var $46=$i;
      var $47=(($12+1052)|0);
      var $48=(($47+($46<<3))|0);
      var $49=$3;
      var $50=$48;
      var $51=$49;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($50)>>2)]=HEAP32[(($51)>>2)];HEAP32[(($50+4)>>2)]=HEAP32[(($51+4)>>2)];
      var $52=$i;
      var $53=(($12+1036)|0);
      var $54=(($53+$52)|0);
      HEAP8[($54)]=1;
      __label__ = 12; break;
    case 12: // $55
      var $56=$i;
      var $57=(($56+1)|0);
      $i=$57;
      __label__ = 10; break;
    case 13: // $58
      __label__ = 19; break;
    case 14: // $59
      var $60=HEAP32[(($start_slot)>>2)];
      $i1=$60;
      __label__ = 15; break;
    case 15: // $61
      var $62=$i1;
      var $63=HEAP32[(($end_slot)>>2)];
      var $64=(($62)|0)!=(($63)|0);
      if ($64) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $65
      var $66=$i1;
      var $67=(($12+264)|0);
      var $68=(($67+$66*96)|0);
      var $69=(($68)|0);
      var $70=__ZN8delegateIFhR13address_spacejhEEaSERKS3_($69, $delegate);
      var $71=$i1;
      var $72=(($12+1036)|0);
      var $73=(($72+$71)|0);
      HEAP8[($73)]=0;
      __label__ = 17; break;
    case 17: // $74
      var $75=$i1;
      var $76=(($75+1)|0);
      $i1=$76;
      __label__ = 15; break;
    case 18: // $77
      __label__ = 19; break;
    case 19: // $78
      var $79=$12;
      var $80=(($79+5)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=(($82)|0)==16;
      if ($83) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $84
      var $85=$delegate;
      var $86=__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($85);
      HEAP32[(($7)>>2)]={ f0: 282, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 282, f1: 0 }.f1;
      __ZN8delegateIFtR13address_spacejtEEC1I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($6, $7, $86, $12);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($12, $6, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 27; break;
    case 21: // $87
      var $88=$12;
      var $89=(($88+5)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $92=(($91)|0)==32;
      if ($92) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $93
      var $94=$delegate;
      var $95=__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($94);
      HEAP32[(($9)>>2)]={ f0: 284, f1: 0 }.f0; HEAP32[(($9+4)>>2)]={ f0: 284, f1: 0 }.f1;
      __ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($8, $9, $95, $12);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($12, $8, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      __label__ = 26; break;
    case 23: // $96
      var $97=$12;
      var $98=(($97+5)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      var $101=(($100)|0)==64;
      if ($101) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $102
      var $103=$delegate;
      var $104=__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($103);
      HEAP32[(($11)>>2)]={ f0: 286, f1: 0 }.f0; HEAP32[(($11+4)>>2)]={ f0: 286, f1: 0 }.f1;
      __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($10, $11, $104, $12);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($12, $10, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0);
      __label__ = 25; break;
    case 25: // $105
      __label__ = 26; break;
    case 26: // $106
      __label__ = 27; break;
    case 27: // $107
      __label__ = 31; break;
    case 28: // $108
      var $109=(($12+168)|0);
      var $110=(($109)|0);
      var $111=__ZN8delegateIFhR13address_spacejhEEaSERKS3_($110, $delegate);
      var $112=$3;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $114
      var $115=(($12+1044)|0);
      var $116=$3;
      var $117=$115;
      var $118=$116;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($117)>>2)]=HEAP32[(($118)>>2)];HEAP32[(($117+4)>>2)]=HEAP32[(($118+4)>>2)];
      __label__ = 30; break;
    case 30: // $119
      __label__ = 31; break;
    case 31: // $120
      STACKTOP = __stackBase__;
      return;
    case 32: // $121
      var $122=$4;
      var $123=$4;
      var $124=$5;
      var $125=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $123, tempValue);
      var $126=($125.f1 = $124, $125);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE["X"]=1;

function __ZN18address_table_read12watchpoint_rIhEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $oldtable;
  var $result;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space6deviceEv($8);
  var $10=__ZNK8device_t5debugEv($9);
  var $11=$5;
  var $12=(($11+12)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=(($14)|0);
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  __ZN12device_debug16memory_read_hookER13address_spacejy($10, $13, $15, $17$0, $17$1);
  var $18=$5;
  var $19=(($18+8)|0);
  var $20=HEAP32[(($19)>>2)];
  $oldtable=$20;
  var $21=$5;
  var $22=(($21+4)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=$5;
  var $25=(($24+8)|0);
  HEAP32[(($25)>>2)]=$23;
  var $26=$5;
  var $27=(($26+12)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$28;
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30+28)|0);
  var $32=HEAP32[(($31)>>2)];
  var $33=$3;
  var $34=FUNCTION_TABLE[$32]($28, $33);
  $result=$34;
  var $35=$oldtable;
  var $36=$5;
  var $37=(($36+8)|0);
  HEAP32[(($37)>>2)]=$35;
  var $38=$result;
  ;
  return $38;
}
__ZN18address_table_read12watchpoint_rIhEET_R13address_spacejS1_["X"]=1;

function __ZN8delegateIFtR13address_spacejtEEC1I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFtR13address_spacejtEEC2I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18address_table_read7unmap_rItEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$mask;
      var $5=$1;
      var $6=$5;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK13address_space9log_unmapEv($8);
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$5;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK13address_space15debugger_accessEv($13);
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      var $16=$5;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZNK13address_space7machineEv($18);
      var $20=__ZN15running_machine16describe_contextEv($19);
      var $21=$5;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__ZNK13address_space4nameEv($23);
      var $25=$5;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=((($28<<1))|0);
      var $30=__ZNK13address_space15byte_to_addressEj($27, $29);
      var $31$0=$30;
      var $31$1=0;
      var $32=$5;
      var $33=(($32+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZNK13address_space9addrcharsEv($34);
      var $36=__Z19core_i64_hex_formatyh($31$0, $31$1, $35);
      var $37=$4;
      var $38$0=$37;
      var $38$1=0;
      var $39=__Z19core_i64_hex_formatyh($38$0, $38$1, 4);
      __Z8logerrorPKcz(((STRING_TABLE.__str2093100)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,HEAP32[((tempInt+4)>>2)]=$24,HEAP32[((tempInt+8)>>2)]=$36,HEAP32[((tempInt+12)>>2)]=$39,tempInt));
      __label__ = 3; break;
    case 3: // $40
      var $41=$5;
      var $42=(($41+12)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=__ZNK13address_space5unmapEv($43);
      var $44$0=$44[0];
      var $44$1=$44[1];
      var $45$0=$44$0;
      var $45=$45$0&65535;
      ;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_read7unmap_rItEET_R13address_spacejS1_["X"]=1;

function __ZN18address_table_read5nop_rItEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space5unmapEv($8);
  var $9$0=$9[0];
  var $9$1=$9[1];
  var $10$0=$9$0;
  var $10=$10$0&65535;
  ;
  return $10;
}


function __ZN18address_table_read12watchpoint_rItEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $oldtable;
  var $result;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space6deviceEv($8);
  var $10=__ZNK8device_t5debugEv($9);
  var $11=$5;
  var $12=(($11+12)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=((($14<<1))|0);
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  __ZN12device_debug16memory_read_hookER13address_spacejy($10, $13, $15, $17$0, $17$1);
  var $18=$5;
  var $19=(($18+8)|0);
  var $20=HEAP32[(($19)>>2)];
  $oldtable=$20;
  var $21=$5;
  var $22=(($21+4)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=$5;
  var $25=(($24+8)|0);
  HEAP32[(($25)>>2)]=$23;
  var $26=$5;
  var $27=(($26+12)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$28;
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30+36)|0);
  var $32=HEAP32[(($31)>>2)];
  var $33=$3;
  var $34=$33 << 1;
  var $35=$4;
  var $36=FUNCTION_TABLE[$32]($28, $34, $35);
  $result=$36;
  var $37=$oldtable;
  var $38=$5;
  var $39=(($38+8)|0);
  HEAP32[(($39)>>2)]=$37;
  var $40=$result;
  ;
  return $40;
}
__ZN18address_table_read12watchpoint_rItEET_R13address_spacejS1_["X"]=1;

function __ZN8delegateIFjR13address_spacejjEEC1I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFjR13address_spacejjEEC2I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18address_table_read7unmap_rIjEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$mask;
      var $5=$1;
      var $6=$5;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK13address_space9log_unmapEv($8);
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$5;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK13address_space15debugger_accessEv($13);
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      var $16=$5;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZNK13address_space7machineEv($18);
      var $20=__ZN15running_machine16describe_contextEv($19);
      var $21=$5;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__ZNK13address_space4nameEv($23);
      var $25=$5;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=((($28<<2))|0);
      var $30=__ZNK13address_space15byte_to_addressEj($27, $29);
      var $31$0=$30;
      var $31$1=0;
      var $32=$5;
      var $33=(($32+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZNK13address_space9addrcharsEv($34);
      var $36=__Z19core_i64_hex_formatyh($31$0, $31$1, $35);
      var $37=$4;
      var $38$0=$37;
      var $38$1=0;
      var $39=__Z19core_i64_hex_formatyh($38$0, $38$1, 8);
      __Z8logerrorPKcz(((STRING_TABLE.__str2093100)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,HEAP32[((tempInt+4)>>2)]=$24,HEAP32[((tempInt+8)>>2)]=$36,HEAP32[((tempInt+12)>>2)]=$39,tempInt));
      __label__ = 3; break;
    case 3: // $40
      var $41=$5;
      var $42=(($41+12)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=__ZNK13address_space5unmapEv($43);
      var $44$0=$44[0];
      var $44$1=$44[1];
      var $45$0=$44$0;
      var $45=$45$0;
      ;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_read7unmap_rIjEET_R13address_spacejS1_["X"]=1;

function __ZN18address_table_read5nop_rIjEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space5unmapEv($8);
  var $9$0=$9[0];
  var $9$1=$9[1];
  var $10$0=$9$0;
  var $10=$10$0;
  ;
  return $10;
}


function __ZN18address_table_read12watchpoint_rIjEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $oldtable;
  var $result;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space6deviceEv($8);
  var $10=__ZNK8device_t5debugEv($9);
  var $11=$5;
  var $12=(($11+12)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=((($14<<2))|0);
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  __ZN12device_debug16memory_read_hookER13address_spacejy($10, $13, $15, $17$0, $17$1);
  var $18=$5;
  var $19=(($18+8)|0);
  var $20=HEAP32[(($19)>>2)];
  $oldtable=$20;
  var $21=$5;
  var $22=(($21+4)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=$5;
  var $25=(($24+8)|0);
  HEAP32[(($25)>>2)]=$23;
  var $26=$5;
  var $27=(($26+12)|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$28;
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30+52)|0);
  var $32=HEAP32[(($31)>>2)];
  var $33=$3;
  var $34=$33 << 2;
  var $35=$4;
  var $36=FUNCTION_TABLE[$32]($28, $34, $35);
  $result=$36;
  var $37=$oldtable;
  var $38=$5;
  var $39=(($38+8)|0);
  HEAP32[(($39)>>2)]=$37;
  var $40=$result;
  ;
  return $40;
}
__ZN18address_table_read12watchpoint_rIjEET_R13address_spacejS1_["X"]=1;

function __ZN8delegateIFyR13address_spacejyEEC1I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFyR13address_spacejyEEC2I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18address_table_read7unmap_rIyEET_R13address_spacejS1_($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      $1=$this;
      $2=$space;
      $3=$offset;
      var $st$7$0=(($4)|0);
      HEAP32[(($st$7$0)>>2)]=$mask$0;
      var $st$7$1=(($4+4)|0);
      HEAP32[(($st$7$1)>>2)]=$mask$1;
      var $5=$1;
      var $6=$5;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK13address_space9log_unmapEv($8);
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$5;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK13address_space15debugger_accessEv($13);
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      var $16=$5;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZNK13address_space7machineEv($18);
      var $20=__ZN15running_machine16describe_contextEv($19);
      var $21=$5;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__ZNK13address_space4nameEv($23);
      var $25=$5;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=((($28<<3))|0);
      var $30=__ZNK13address_space15byte_to_addressEj($27, $29);
      var $31$0=$30;
      var $31$1=0;
      var $32=$5;
      var $33=(($32+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZNK13address_space9addrcharsEv($34);
      var $36=__Z19core_i64_hex_formatyh($31$0, $31$1, $35);
      var $st$22$0=(($4)|0);
      var $37$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($4+4)|0);
      var $37$1=HEAP32[(($st$22$1)>>2)];
      var $38=__Z19core_i64_hex_formatyh($37$0, $37$1, 16);
      __Z8logerrorPKcz(((STRING_TABLE.__str2093100)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,HEAP32[((tempInt+4)>>2)]=$24,HEAP32[((tempInt+8)>>2)]=$36,HEAP32[((tempInt+12)>>2)]=$38,tempInt));
      __label__ = 3; break;
    case 3: // $39
      var $40=$5;
      var $41=(($40+12)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__ZNK13address_space5unmapEv($42);
      var $43$0=$43[0];
      var $43$1=$43[1];
      STACKTOP = __stackBase__;
      return [$43$0,$43$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_read7unmap_rIyEET_R13address_spacejS1_["X"]=1;

function __ZN18address_table_read5nop_rIyEET_R13address_spacejS1_($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$7$0=(($4)|0);
  HEAP32[(($st$7$0)>>2)]=$mask$0;
  var $st$7$1=(($4+4)|0);
  HEAP32[(($st$7$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space5unmapEv($8);
  var $9$0=$9[0];
  var $9$1=$9[1];
  STACKTOP = __stackBase__;
  return [$9$0,$9$1];
}


function __ZN18address_table_read12watchpoint_rIyEET_R13address_spacejS1_($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $oldtable;
  var $result=__stackBase__+8;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$9$0=(($4)|0);
  HEAP32[(($st$9$0)>>2)]=$mask$0;
  var $st$9$1=(($4+4)|0);
  HEAP32[(($st$9$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$5;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__ZNK13address_space6deviceEv($8);
  var $10=__ZNK8device_t5debugEv($9);
  var $11=$5;
  var $12=(($11+12)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=((($14<<3))|0);
  var $st$24$0=(($4)|0);
  var $16$0=HEAP32[(($st$24$0)>>2)];
  var $st$24$1=(($4+4)|0);
  var $16$1=HEAP32[(($st$24$1)>>2)];
  __ZN12device_debug16memory_read_hookER13address_spacejy($10, $13, $15, $16$0, $16$1);
  var $17=$5;
  var $18=(($17+8)|0);
  var $19=HEAP32[(($18)>>2)];
  $oldtable=$19;
  var $20=$5;
  var $21=(($20+4)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$5;
  var $24=(($23+8)|0);
  HEAP32[(($24)>>2)]=$22;
  var $25=$5;
  var $26=(($25+12)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=$27;
  var $29=HEAP32[(($28)>>2)];
  var $30=(($29+68)|0);
  var $31=HEAP32[(($30)>>2)];
  var $32=$3;
  var $33=$32 << 3;
  var $st$48$0=(($4)|0);
  var $34$0=HEAP32[(($st$48$0)>>2)];
  var $st$48$1=(($4+4)|0);
  var $34$1=HEAP32[(($st$48$1)>>2)];
  var $35=FUNCTION_TABLE[$31]($27, $33, $34$0, $34$1);
  var $35$0=$35[0];
  var $35$1=$35[1];
  var $st$55$0=(($result)|0);
  HEAP32[(($st$55$0)>>2)]=$35$0;
  var $st$55$1=(($result+4)|0);
  HEAP32[(($st$55$1)>>2)]=$35$1;
  var $36=$oldtable;
  var $37=$5;
  var $38=(($37+8)|0);
  HEAP32[(($38)>>2)]=$36;
  var $st$63$0=(($result)|0);
  var $39$0=HEAP32[(($st$63$0)>>2)];
  var $st$63$1=(($result+4)|0);
  var $39$1=HEAP32[(($st$63$1)>>2)];
  STACKTOP = __stackBase__;
  return [$39$0,$39$1];
}
__ZN18address_table_read12watchpoint_rIyEET_R13address_spacejS1_["X"]=1;

function __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $5;
      var $start_slot=__stackBase__+8;
      var $end_slot=__stackBase__+12;
      var $i;
      var $i1;
      var $6=__stackBase__+16;
      var $7=__stackBase__+40;
      var $8=__stackBase__+48;
      var $9=__stackBase__+72;
      $1=$this;
      var $st$14$0=(($2)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($2+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      $3=$info;
      var $10=$1;
      var $11=$delegate;
      var $12=__ZNK13delegate_baseItR13address_spacejt8_noparamE10has_objectEv($11);
      if ($12) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      var $16=$delegate;
      var $17=(function() { try { __THREW__ = false; return __ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $18
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($15, ((STRING_TABLE.__str2073098)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      ___cxa_throw($14, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $4=$22;
      var $23=$21.f1;
      $5=$23;
      ___cxa_free_exception($14);
      __label__ = 29; break;
    case 5: // $24
      __label__ = 6; break;
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$10;
      var $28=(($27+5)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=(($30)|0)!=16;
      if ($31) { __label__ = 8; break; } else { __label__ = 25; break; }
    case 8: // $32
      var $33=$10;
      var $st$1$0=(($2)|0);
      var $34$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($2+4)|0);
      var $34$1=HEAP32[(($st$1$1)>>2)];
      __ZN13handler_entry18configure_subunitsEyiRiS0_($33, $34$0, $34$1, 16, $start_slot, $end_slot);
      var $35=$3;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $37
      var $38=HEAP32[(($start_slot)>>2)];
      $i=$38;
      __label__ = 10; break;
    case 10: // $39
      var $40=$i;
      var $41=HEAP32[(($end_slot)>>2)];
      var $42=(($40)|0)!=(($41)|0);
      if ($42) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $43
      var $44=$i;
      var $45=(($10+1052)|0);
      var $46=(($45+($44<<3))|0);
      var $47=$3;
      var $48=$46;
      var $49=$47;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($48)>>2)]=HEAP32[(($49)>>2)];HEAP32[(($48+4)>>2)]=HEAP32[(($49+4)>>2)];
      var $50=$i;
      var $51=(($10+1036)|0);
      var $52=(($51+$50)|0);
      HEAP8[($52)]=1;
      __label__ = 12; break;
    case 12: // $53
      var $54=$i;
      var $55=(($54+1)|0);
      $i=$55;
      __label__ = 10; break;
    case 13: // $56
      __label__ = 19; break;
    case 14: // $57
      var $58=HEAP32[(($start_slot)>>2)];
      $i1=$58;
      __label__ = 15; break;
    case 15: // $59
      var $60=$i1;
      var $61=HEAP32[(($end_slot)>>2)];
      var $62=(($60)|0)!=(($61)|0);
      if ($62) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $63
      var $64=$i1;
      var $65=(($10+264)|0);
      var $66=(($65+$64*96)|0);
      var $67=(($66+24)|0);
      var $68=__ZN8delegateIFtR13address_spacejtEEaSERKS3_($67, $delegate);
      var $69=$i1;
      var $70=(($10+1036)|0);
      var $71=(($70+$69)|0);
      HEAP8[($71)]=0;
      __label__ = 17; break;
    case 17: // $72
      var $73=$i1;
      var $74=(($73+1)|0);
      $i1=$74;
      __label__ = 15; break;
    case 18: // $75
      __label__ = 19; break;
    case 19: // $76
      var $77=$10;
      var $78=(($77+5)|0);
      var $79=HEAPU8[($78)];
      var $80=(($79)&255);
      var $81=(($80)|0)==32;
      if ($81) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $82
      var $83=$delegate;
      var $84=__ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv($83);
      HEAP32[(($7)>>2)]={ f0: 284, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 284, f1: 0 }.f1;
      __ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($6, $7, $84, $10);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($10, $6, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 24; break;
    case 21: // $85
      var $86=$10;
      var $87=(($86+5)|0);
      var $88=HEAPU8[($87)];
      var $89=(($88)&255);
      var $90=(($89)|0)==64;
      if ($90) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $91
      var $92=$delegate;
      var $93=__ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv($92);
      HEAP32[(($9)>>2)]={ f0: 286, f1: 0 }.f0; HEAP32[(($9+4)>>2)]={ f0: 286, f1: 0 }.f1;
      __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($8, $9, $93, $10);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($10, $8, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      __label__ = 23; break;
    case 23: // $94
      __label__ = 24; break;
    case 24: // $95
      __label__ = 28; break;
    case 25: // $96
      var $97=(($10+168)|0);
      var $98=(($97+24)|0);
      var $99=__ZN8delegateIFtR13address_spacejtEEaSERKS3_($98, $delegate);
      var $100=$3;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $102
      var $103=(($10+1044)|0);
      var $104=$3;
      var $105=$103;
      var $106=$104;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($105)>>2)]=HEAP32[(($106)>>2)];HEAP32[(($105+4)>>2)]=HEAP32[(($106+4)>>2)];
      __label__ = 27; break;
    case 27: // $107
      __label__ = 28; break;
    case 28: // $108
      STACKTOP = __stackBase__;
      return;
    case 29: // $109
      var $110=$4;
      var $111=$4;
      var $112=$5;
      var $113=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $111, tempValue);
      var $114=($113.f1 = $112, $113);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE["X"]=1;

function __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $5;
      var $start_slot=__stackBase__+8;
      var $end_slot=__stackBase__+12;
      var $i;
      var $i1;
      var $6=__stackBase__+16;
      var $7=__stackBase__+40;
      $1=$this;
      var $st$12$0=(($2)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($2+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      $3=$info;
      var $8=$1;
      var $9=$delegate;
      var $10=__ZNK13delegate_baseIjR13address_spacejj8_noparamE10has_objectEv($9);
      if ($10) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $11
      var $12=___cxa_allocate_exception(1032);
      var $13=$12;
      var $14=$delegate;
      var $15=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIjR13address_spacejj8_noparamE4nameEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $16
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($13, ((STRING_TABLE.__str2073098)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      ___cxa_throw($12, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $4=$20;
      var $21=$19.f1;
      $5=$21;
      ___cxa_free_exception($12);
      __label__ = 26; break;
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      __label__ = 7; break;
    case 7: // $24
      var $25=$8;
      var $26=(($25+5)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)!=32;
      if ($29) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $30
      var $31=$8;
      var $st$1$0=(($2)|0);
      var $32$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($2+4)|0);
      var $32$1=HEAP32[(($st$1$1)>>2)];
      __ZN13handler_entry18configure_subunitsEyiRiS0_($31, $32$0, $32$1, 32, $start_slot, $end_slot);
      var $33=$3;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $35
      var $36=HEAP32[(($start_slot)>>2)];
      $i=$36;
      __label__ = 10; break;
    case 10: // $37
      var $38=$i;
      var $39=HEAP32[(($end_slot)>>2)];
      var $40=(($38)|0)!=(($39)|0);
      if ($40) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $41
      var $42=$i;
      var $43=(($8+1052)|0);
      var $44=(($43+($42<<3))|0);
      var $45=$3;
      var $46=$44;
      var $47=$45;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($46)>>2)]=HEAP32[(($47)>>2)];HEAP32[(($46+4)>>2)]=HEAP32[(($47+4)>>2)];
      var $48=$i;
      var $49=(($8+1036)|0);
      var $50=(($49+$48)|0);
      HEAP8[($50)]=1;
      __label__ = 12; break;
    case 12: // $51
      var $52=$i;
      var $53=(($52+1)|0);
      $i=$53;
      __label__ = 10; break;
    case 13: // $54
      __label__ = 19; break;
    case 14: // $55
      var $56=HEAP32[(($start_slot)>>2)];
      $i1=$56;
      __label__ = 15; break;
    case 15: // $57
      var $58=$i1;
      var $59=HEAP32[(($end_slot)>>2)];
      var $60=(($58)|0)!=(($59)|0);
      if ($60) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $61
      var $62=$i1;
      var $63=(($8+264)|0);
      var $64=(($63+$62*96)|0);
      var $65=(($64+48)|0);
      var $66=__ZN8delegateIFjR13address_spacejjEEaSERKS3_($65, $delegate);
      var $67=$i1;
      var $68=(($8+1036)|0);
      var $69=(($68+$67)|0);
      HEAP8[($69)]=0;
      __label__ = 17; break;
    case 17: // $70
      var $71=$i1;
      var $72=(($71+1)|0);
      $i1=$72;
      __label__ = 15; break;
    case 18: // $73
      __label__ = 19; break;
    case 19: // $74
      var $75=$8;
      var $76=(($75+5)|0);
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $79=(($78)|0)==64;
      if ($79) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $80
      var $81=$delegate;
      var $82=__ZNK13delegate_baseIjR13address_spacejj8_noparamE4nameEv($81);
      HEAP32[(($7)>>2)]={ f0: 286, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 286, f1: 0 }.f1;
      __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($6, $7, $82, $8);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($8, $6, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 21; break;
    case 21: // $83
      __label__ = 25; break;
    case 22: // $84
      var $85=(($8+168)|0);
      var $86=(($85+48)|0);
      var $87=__ZN8delegateIFjR13address_spacejjEEaSERKS3_($86, $delegate);
      var $88=$3;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $90
      var $91=(($8+1044)|0);
      var $92=$3;
      var $93=$91;
      var $94=$92;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($93)>>2)]=HEAP32[(($94)>>2)];HEAP32[(($93+4)>>2)]=HEAP32[(($94+4)>>2)];
      __label__ = 24; break;
    case 24: // $95
      __label__ = 25; break;
    case 25: // $96
      STACKTOP = __stackBase__;
      return;
    case 26: // $97
      var $98=$4;
      var $99=$4;
      var $100=$5;
      var $101=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $99, tempValue);
      var $102=($101.f1 = $100, $101);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE["X"]=1;

function __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $5;
      $1=$this;
      var $st$6$0=(($2)|0);
      HEAP32[(($st$6$0)>>2)]=$mask$0;
      var $st$6$1=(($2+4)|0);
      HEAP32[(($st$6$1)>>2)]=$mask$1;
      $3=$info;
      var $6=$1;
      var $7=$delegate;
      var $8=__ZNK13delegate_baseIyR13address_spacejy8_noparamE10has_objectEv($7);
      if ($8) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(1032);
      var $11=$10;
      var $12=$delegate;
      var $13=(function() { try { __THREW__ = false; return __ZNK13delegate_baseIyR13address_spacejy8_noparamE4nameEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $14
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($11, ((STRING_TABLE.__str2073098)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$13,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      ___cxa_throw($10, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      ___cxa_free_exception($10);
      __label__ = 10; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      __label__ = 7; break;
    case 7: // $22
      var $23=(($6+168)|0);
      var $24=(($23+72)|0);
      var $25=__ZN8delegateIFyR13address_spacejyEEaSERKS3_($24, $delegate);
      var $26=$3;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $28
      var $29=(($6+1044)|0);
      var $30=$3;
      var $31=$29;
      var $32=$30;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($31)>>2)]=HEAP32[(($32)>>2)];HEAP32[(($31+4)>>2)]=HEAP32[(($32+4)>>2)];
      __label__ = 9; break;
    case 9: // $33
      STACKTOP = __stackBase__;
      return;
    case 10: // $34
      var $35=$4;
      var $36=$4;
      var $37=$5;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE["X"]=1;

function __ZNK18address_table_read7handlerEj($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+352)|0);
      var $8=(($7+($6<<2))|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9;
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19handler_entry_writeC1Eh12endianness_tPPh($this, $width, $endianness, $rambaseptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$width;
  $3=$endianness;
  $4=$rambaseptr;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN19handler_entry_writeC2Eh12endianness_tPPh($5, $6, $7, $8);
  ;
  return;
}


function __ZN18address_table_readD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18address_table_readD0Ev["X"]=1;

function __ZN18address_table_readD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $handnum;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV18address_table_read+8)|0);
      $handnum=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$handnum;
      var $8=(($7)>>>0) < 256;
      if ($8) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      var $10=$4;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $14
      var $15=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $16
      var $17=$handnum;
      var $18=(($4+352)|0);
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($15, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$handnum;
      var $25=(($24+1)|0);
      $handnum=$25;
      __label__ = 1; break;
    case 7: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      var $30=$4;
      (function() { try { __THREW__ = false; return __ZN13address_tableD2Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 8: // $31
      var $32=$4;
      __ZN13address_tableD2Ev($32);
      ;
      return;
    case 9: // $33
      __label__ = 10; break;
    case 10: // $34
      var $35=$2;
      var $36=$2;
      var $37=$3;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19address_table_writeC2ER13address_spaceb($this, $space, $large) {
  var __stackBase__  = STACKTOP; STACKTOP += 420; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $entrynum;
      var $bankptr;
      var $12;
      var $13;
      var $14=__stackBase__+36;
      var $15=__stackBase__+60;
      var $16=__stackBase__+68;
      var $17=__stackBase__+92;
      var $18=__stackBase__+100;
      var $19=__stackBase__+124;
      var $20=__stackBase__+132;
      var $21=__stackBase__+156;
      var $22=__stackBase__+164;
      var $23=__stackBase__+188;
      var $24=__stackBase__+196;
      var $25=__stackBase__+220;
      var $26=__stackBase__+228;
      var $27=__stackBase__+252;
      var $28=__stackBase__+260;
      var $29=__stackBase__+284;
      var $30=__stackBase__+292;
      var $31=__stackBase__+316;
      var $32=__stackBase__+324;
      var $33=__stackBase__+348;
      var $34=__stackBase__+356;
      var $35=__stackBase__+380;
      var $36=__stackBase__+388;
      var $37=__stackBase__+412;
      $9=$this;
      $10=$space;
      var $38=(($large)&1);
      $11=$38;
      var $39=$9;
      var $40=$39;
      var $41=$10;
      var $42=$11;
      var $43=(($42) & 1);
      __ZN13address_tableC2ER13address_spaceb($40, $41, $43);
      var $44=$39;
      HEAP32[(($44)>>2)]=((__ZTV19address_table_write+8)|0);
      $entrynum=0;
      __label__ = 1; break;
    case 1: // $45
      var $46=$entrynum;
      var $47=(($46)>>>0) < 256;
      if ($47) { __label__ = 2; break; } else { __label__ = 31; break; }
    case 2: // $48
      var $49=$entrynum;
      var $50=(($49)|0) >= 1;
      if ($50) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $51
      var $52=$entrynum;
      var $53=(($52)|0) <= 124;
      if ($53) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $54
      var $55=$entrynum;
      var $56=$10;
      var $57=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 24; break; };
    case 5: // $58
      var $59=(($57+624)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+4)|0);
      var $62=(($61+($55<<2))|0);
      var $65 = $62;__label__ = 7; break;
    case 6: // $63
      var $65 = 0;__label__ = 7; break;
    case 7: // $64
      var $65;
      $bankptr=$65;
      var $66=$10;
      var $67=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 24; break; };
    case 8: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 24; break; };
    case 9: // $70
      var $71=$4;
      var $72=$5;
      var $73=$6;
      var $74=$result_i;
      var $75=$7;
      var $76=$8;
      HEAP32[(($4)>>2)]=1116;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=4225;
      var $77=HEAP32[(($4)>>2)];
      var $78=HEAP32[(($5)>>2)];
      var $79=HEAP32[(($6)>>2)];
      var $80=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($77, $78, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $81
      HEAP32[(($result_i)>>2)]=$80;
      var $82=HEAP32[(($result_i)>>2)];
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $84
      var $85=___cxa_allocate_exception(4);
      var $86=$85;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($86);
      (function() { try { __THREW__ = false; return ___cxa_throw($85, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 12: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      HEAP32[(($7)>>2)]=$89;
      var $90=$88.f1;
      HEAP32[(($8)>>2)]=$90;
      var $91=HEAP32[(($8)>>2)];
      var $92=(($91)|0) < 0;
      if ($92) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $93
      var $94=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $_noexc
      throw "Reached an unreachable!"
    case 15: // $95
      var $96=HEAP32[(($7)>>2)];
      var $97=HEAP32[(($7)>>2)];
      var $98=HEAP32[(($8)>>2)];
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      var $eh_lpad_body = $100;__label__ = 25; break;
    case 16: // $101
      throw "Reached an unreachable!"
    case 17: // $_ZnwjPKci_exit
      var $102=HEAP32[(($result_i)>>2)];
      var $103=$4;
      var $104=$5;
      var $105=$6;
      var $106=$result_i;
      var $107=$7;
      var $108=$8;
      __label__ = 18; break;
    case 18: // $109
      var $110=$102;
      var $111=$10;
      var $112=(function() { try { __THREW__ = false; return __ZNK13address_space10data_widthEv($111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 26; break; };
    case 19: // $113
      var $114=(($112) & 255);
      var $115=$10;
      var $116=(function() { try { __THREW__ = false; return __ZNK13address_space10endiannessEv($115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; };
    case 20: // $117
      var $118=$bankptr;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_writeC1Eh12endianness_tPPh($110, $114, $116, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $119
      var $120=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI19handler_entry_writeEEPT_S3_($69, $110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; };
    case 22: // $121
      var $122=$entrynum;
      var $123=(($39+352)|0);
      var $124=(($123+($122<<2))|0);
      HEAP32[(($124)>>2)]=$120;
      __label__ = 23; break;
    case 23: // $125
      var $126=$entrynum;
      var $127=(($126+1)|0);
      $entrynum=$127;
      __label__ = 1; break;
    case 24: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $129;__label__ = 25; break;
    case 25: // $_body
      var $eh_lpad_body;
      var $130=$eh_lpad_body.f0;
      $12=$130;
      var $131=$eh_lpad_body.f1;
      $13=$131;
      __label__ = 68; break;
    case 26: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $134=$133.f0;
      $12=$134;
      var $135=$133.f1;
      $13=$135;
      var $136=$1;
      var $137=$2;
      var $138=$3;
      HEAP32[(($1)>>2)]=$102;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=4225;
      var $139=HEAP32[(($1)>>2)];
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $141
      var $142=HEAP32[(($1)>>2)];
      var $143=HEAP32[(($2)>>2)];
      var $144=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($142, $143, $144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 71; break; }
    case 28: // $_noexc1
      __label__ = 29; break;
    case 29: // $_ZdlPvPKci_exit
      var $145=$1;
      var $146=$2;
      var $147=$3;
      __label__ = 30; break;
    case 30: // $148
      __label__ = 68; break;
    case 31: // $149
      var $150=$10;
      var $151=(function() { try { __THREW__ = false; return __ZNK13address_space10data_widthEv($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 24; break; };
    case 32: // $152
      if ($151 == 8) {
        __label__ = 33; break;
      }
      else if ($151 == 16) {
        __label__ = 40; break;
      }
      else if ($151 == 32) {
        __label__ = 47; break;
      }
      else if ($151 == 64) {
        __label__ = 54; break;
      }
      else {
      __label__ = 61; break;
      }
      
    case 33: // $153
      var $154=(($39+352)|0);
      var $155=(($154+504)|0);
      var $156=HEAP32[(($155)>>2)];
      HEAP32[(($15)>>2)]={ f0: 288, f1: 0 }.f0; HEAP32[(($15+4)>>2)]={ f0: 288, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejhhEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($14, $15, ((STRING_TABLE.__str1833074)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 24; break; }
    case 34: // $157
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($156, $14, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 24; break; }
    case 35: // $158
      var $159=(($39+352)|0);
      var $160=(($159+500)|0);
      var $161=HEAP32[(($160)>>2)];
      HEAP32[(($17)>>2)]={ f0: 290, f1: 0 }.f0; HEAP32[(($17+4)>>2)]={ f0: 290, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejhhEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($16, $17, ((STRING_TABLE.__str1843075)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 24; break; }
    case 36: // $162
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($161, $16, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 24; break; }
    case 37: // $163
      var $164=(($39+352)|0);
      var $165=(($164+508)|0);
      var $166=HEAP32[(($165)>>2)];
      HEAP32[(($19)>>2)]={ f0: 292, f1: 0 }.f0; HEAP32[(($19+4)>>2)]={ f0: 292, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejhhEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($18, $19, ((STRING_TABLE.__str1853076)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 24; break; }
    case 38: // $167
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($166, $18, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 24; break; }
    case 39: // $168
      __label__ = 61; break;
    case 40: // $169
      var $170=(($39+352)|0);
      var $171=(($170+504)|0);
      var $172=HEAP32[(($171)>>2)];
      HEAP32[(($21)>>2)]={ f0: 294, f1: 0 }.f0; HEAP32[(($21+4)>>2)]={ f0: 294, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejttEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($20, $21, ((STRING_TABLE.__str1863077)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 24; break; }
    case 41: // $173
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($172, $20, $$emscripten$temp$3$0, $$emscripten$temp$3$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 24; break; }
    case 42: // $174
      var $175=(($39+352)|0);
      var $176=(($175+500)|0);
      var $177=HEAP32[(($176)>>2)];
      HEAP32[(($23)>>2)]={ f0: 296, f1: 0 }.f0; HEAP32[(($23+4)>>2)]={ f0: 296, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejttEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($22, $23, ((STRING_TABLE.__str1873078)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 24; break; }
    case 43: // $178
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($177, $22, $$emscripten$temp$4$0, $$emscripten$temp$4$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 24; break; }
    case 44: // $179
      var $180=(($39+352)|0);
      var $181=(($180+508)|0);
      var $182=HEAP32[(($181)>>2)];
      HEAP32[(($25)>>2)]={ f0: 298, f1: 0 }.f0; HEAP32[(($25+4)>>2)]={ f0: 298, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejttEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($24, $25, ((STRING_TABLE.__str1883079)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 24; break; }
    case 45: // $183
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($182, $24, $$emscripten$temp$5$0, $$emscripten$temp$5$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 24; break; }
    case 46: // $184
      __label__ = 61; break;
    case 47: // $185
      var $186=(($39+352)|0);
      var $187=(($186+504)|0);
      var $188=HEAP32[(($187)>>2)];
      HEAP32[(($27)>>2)]={ f0: 300, f1: 0 }.f0; HEAP32[(($27+4)>>2)]={ f0: 300, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejjjEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($26, $27, ((STRING_TABLE.__str1893080)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 24; break; }
    case 48: // $189
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($188, $26, $$emscripten$temp$6$0, $$emscripten$temp$6$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 24; break; }
    case 49: // $190
      var $191=(($39+352)|0);
      var $192=(($191+500)|0);
      var $193=HEAP32[(($192)>>2)];
      HEAP32[(($29)>>2)]={ f0: 302, f1: 0 }.f0; HEAP32[(($29+4)>>2)]={ f0: 302, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejjjEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($28, $29, ((STRING_TABLE.__str1903081)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 24; break; }
    case 50: // $194
      var $$emscripten$temp$7$0=0;
      var $$emscripten$temp$7$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($193, $28, $$emscripten$temp$7$0, $$emscripten$temp$7$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 24; break; }
    case 51: // $195
      var $196=(($39+352)|0);
      var $197=(($196+508)|0);
      var $198=HEAP32[(($197)>>2)];
      HEAP32[(($31)>>2)]={ f0: 304, f1: 0 }.f0; HEAP32[(($31+4)>>2)]={ f0: 304, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejjjEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($30, $31, ((STRING_TABLE.__str1913082)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 24; break; }
    case 52: // $199
      var $$emscripten$temp$8$0=0;
      var $$emscripten$temp$8$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($198, $30, $$emscripten$temp$8$0, $$emscripten$temp$8$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 24; break; }
    case 53: // $200
      __label__ = 61; break;
    case 54: // $201
      var $202=(($39+352)|0);
      var $203=(($202+504)|0);
      var $204=HEAP32[(($203)>>2)];
      HEAP32[(($33)>>2)]={ f0: 306, f1: 0 }.f0; HEAP32[(($33+4)>>2)]={ f0: 306, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejyyEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($32, $33, ((STRING_TABLE.__str1923083)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 24; break; }
    case 55: // $205
      var $$emscripten$temp$9$0=0;
      var $$emscripten$temp$9$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($204, $32, $$emscripten$temp$9$0, $$emscripten$temp$9$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 24; break; }
    case 56: // $206
      var $207=(($39+352)|0);
      var $208=(($207+500)|0);
      var $209=HEAP32[(($208)>>2)];
      HEAP32[(($35)>>2)]={ f0: 308, f1: 0 }.f0; HEAP32[(($35+4)>>2)]={ f0: 308, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejyyEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($34, $35, ((STRING_TABLE.__str1933084)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 24; break; }
    case 57: // $210
      var $$emscripten$temp$10$0=0;
      var $$emscripten$temp$10$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($209, $34, $$emscripten$temp$10$0, $$emscripten$temp$10$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 24; break; }
    case 58: // $211
      var $212=(($39+352)|0);
      var $213=(($212+508)|0);
      var $214=HEAP32[(($213)>>2)];
      HEAP32[(($37)>>2)]={ f0: 310, f1: 0 }.f0; HEAP32[(($37+4)>>2)]={ f0: 310, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvR13address_spacejyyEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($36, $37, ((STRING_TABLE.__str1943085)|0), $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 24; break; }
    case 59: // $215
      var $$emscripten$temp$11$0=0;
      var $$emscripten$temp$11$1=0;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($214, $36, $$emscripten$temp$11$0, $$emscripten$temp$11$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 24; break; }
    case 60: // $216
      __label__ = 61; break;
    case 61: // $217
      var $218=(($39+352)|0);
      var $219=(($218+504)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$220;
      var $222=$10;
      var $223=(function() { try { __THREW__ = false; return __ZNK13address_space8bytemaskEv($222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 24; break; };
    case 62: // $224
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($221, 0, $223, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 24; break; }
    case 63: // $225
      var $226=(($39+352)|0);
      var $227=(($226+500)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$228;
      var $230=$10;
      var $231=(function() { try { __THREW__ = false; return __ZNK13address_space8bytemaskEv($230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 24; break; };
    case 64: // $232
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($229, 0, $231, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 24; break; }
    case 65: // $233
      var $234=(($39+352)|0);
      var $235=(($234+508)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=$236;
      var $238=$10;
      var $239=(function() { try { __THREW__ = false; return __ZNK13address_space8bytemaskEv($238) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 24; break; };
    case 66: // $240
      (function() { try { __THREW__ = false; return __ZN13handler_entry9configureEjjj($237, 0, $239, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 24; break; }
    case 67: // $241
      STACKTOP = __stackBase__;
      return;
    case 68: // $242
      var $243=$39;
      (function() { try { __THREW__ = false; return __ZN13address_tableD2Ev($243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $244
      __label__ = 70; break;
    case 70: // $245
      var $246=$12;
      var $247=$12;
      var $248=$13;
      var $249=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $247, tempValue);
      var $250=($249.f1 = $248, $249);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 71: // $251
      var $252=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_writeC2ER13address_spaceb["X"]=1;

function __ZN13resource_pool10add_objectI19handler_entry_writeEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19handler_entry_writeEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI19handler_entry_writeEEPT_S3_["X"]=1;

function __ZN19address_table_write5nop_wIhEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  ;
  return;
}


function __ZN19address_table_write5nop_wItEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  ;
  return;
}


function __ZN19address_table_write5nop_wIjEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  ;
  return;
}


function __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $start_slot=__stackBase__+8;
      var $end_slot=__stackBase__+12;
      var $i;
      var $i1;
      var $4=__stackBase__+16;
      var $5=__stackBase__+40;
      var $6=__stackBase__+48;
      var $7=__stackBase__+72;
      var $8=__stackBase__+80;
      var $9=__stackBase__+104;
      $1=$this;
      var $st$14$0=(($2)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($2+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      $3=$info;
      var $10=$1;
      __label__ = 1; break;
    case 1: // $11
      __label__ = 2; break;
    case 2: // $12
      var $13=$10;
      var $14=(($13+5)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=(($16)|0)!=8;
      if ($17) { __label__ = 3; break; } else { __label__ = 23; break; }
    case 3: // $18
      var $19=$10;
      var $st$1$0=(($2)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($2+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      __ZN13handler_entry18configure_subunitsEyiRiS0_($19, $20$0, $20$1, 8, $start_slot, $end_slot);
      var $21=$3;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $23
      var $24=HEAP32[(($start_slot)>>2)];
      $i=$24;
      __label__ = 5; break;
    case 5: // $25
      var $26=$i;
      var $27=HEAP32[(($end_slot)>>2)];
      var $28=(($26)|0)!=(($27)|0);
      if ($28) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $29
      var $30=$i;
      var $31=(($10+1052)|0);
      var $32=(($31+($30<<3))|0);
      var $33=$3;
      var $34=$32;
      var $35=$33;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];HEAP32[(($34+4)>>2)]=HEAP32[(($35+4)>>2)];
      var $36=$i;
      var $37=(($10+1036)|0);
      var $38=(($37+$36)|0);
      HEAP8[($38)]=1;
      __label__ = 7; break;
    case 7: // $39
      var $40=$i;
      var $41=(($40+1)|0);
      $i=$41;
      __label__ = 5; break;
    case 8: // $42
      __label__ = 14; break;
    case 9: // $43
      var $44=HEAP32[(($start_slot)>>2)];
      $i1=$44;
      __label__ = 10; break;
    case 10: // $45
      var $46=$i1;
      var $47=HEAP32[(($end_slot)>>2)];
      var $48=(($46)|0)!=(($47)|0);
      if ($48) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $49
      var $50=$i1;
      var $51=(($10+264)|0);
      var $52=(($51+$50*96)|0);
      var $53=(($52)|0);
      var $54=__ZN8delegateIFvR13address_spacejhhEEaSERKS3_($53, $delegate);
      var $55=$i1;
      var $56=(($10+1036)|0);
      var $57=(($56+$55)|0);
      HEAP8[($57)]=0;
      __label__ = 12; break;
    case 12: // $58
      var $59=$i1;
      var $60=(($59+1)|0);
      $i1=$60;
      __label__ = 10; break;
    case 13: // $61
      __label__ = 14; break;
    case 14: // $62
      var $63=$10;
      var $64=(($63+5)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=(($66)|0)==16;
      if ($67) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $68
      var $69=$delegate;
      var $70=__ZNK13delegate_baseIvR13address_spacejhhE4nameEv($69);
      HEAP32[(($5)>>2)]={ f0: 312, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 312, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejttEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($4, $5, $70, $10);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($10, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 22; break;
    case 16: // $71
      var $72=$10;
      var $73=(($72+5)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=(($75)|0)==32;
      if ($76) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $77
      var $78=$delegate;
      var $79=__ZNK13delegate_baseIvR13address_spacejhhE4nameEv($78);
      HEAP32[(($7)>>2)]={ f0: 314, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 314, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($6, $7, $79, $10);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($10, $6, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      __label__ = 21; break;
    case 18: // $80
      var $81=$10;
      var $82=(($81+5)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=(($84)|0)==64;
      if ($85) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $86
      var $87=$delegate;
      var $88=__ZNK13delegate_baseIvR13address_spacejhhE4nameEv($87);
      HEAP32[(($9)>>2)]={ f0: 316, f1: 0 }.f0; HEAP32[(($9+4)>>2)]={ f0: 316, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($8, $9, $88, $10);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($10, $8, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0);
      __label__ = 20; break;
    case 20: // $89
      __label__ = 21; break;
    case 21: // $90
      __label__ = 22; break;
    case 22: // $91
      __label__ = 26; break;
    case 23: // $92
      var $93=(($10+168)|0);
      var $94=(($93)|0);
      var $95=__ZN8delegateIFvR13address_spacejhhEEaSERKS3_($94, $delegate);
      var $96=$3;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $98
      var $99=(($10+1044)|0);
      var $100=$3;
      var $101=$99;
      var $102=$100;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($101)>>2)]=HEAP32[(($102)>>2)];HEAP32[(($101+4)>>2)]=HEAP32[(($102+4)>>2)];
      __label__ = 25; break;
    case 25: // $103
      __label__ = 26; break;
    case 26: // $104
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE["X"]=1;

function __ZN8delegateIFvR13address_spacejhhEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejhhEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19address_table_write7unmap_wIhEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$data;
      $5=$mask;
      var $6=$1;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK13address_space9log_unmapEv($9);
      if ($10) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $11
      var $12=$6;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK13address_space15debugger_accessEv($14);
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$6;
      var $18=(($17+12)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK13address_space7machineEv($19);
      var $21=__ZN15running_machine16describe_contextEv($20);
      var $22=$6;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK13address_space4nameEv($24);
      var $26=$6;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=(($29)|0);
      var $31=__ZNK13address_space15byte_to_addressEj($28, $30);
      var $32$0=$31;
      var $32$1=0;
      var $33=$6;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZNK13address_space9addrcharsEv($35);
      var $37=__Z19core_i64_hex_formatyh($32$0, $32$1, $36);
      var $38=$4;
      var $39$0=$38;
      var $39$1=0;
      var $40=__Z19core_i64_hex_formatyh($39$0, $39$1, 2);
      var $41=$5;
      var $42$0=$41;
      var $42$1=0;
      var $43=__Z19core_i64_hex_formatyh($42$0, $42$1, 2);
      __Z8logerrorPKcz(((STRING_TABLE.__str2083099)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$25,HEAP32[((tempInt+8)>>2)]=$37,HEAP32[((tempInt+12)>>2)]=$40,HEAP32[((tempInt+16)>>2)]=$43,tempInt));
      __label__ = 3; break;
    case 3: // $44
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_write7unmap_wIhEEvR13address_spacejT_S3_["X"]=1;

function __ZN19address_table_write12watchpoint_wIhEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $oldtable;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=$6;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZNK13address_space6deviceEv($9);
  var $11=__ZNK8device_t5debugEv($10);
  var $12=$6;
  var $13=(($12+12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=(($15)|0);
  var $17=$4;
  var $18$0=$17;
  var $18$1=0;
  var $19=$5;
  var $20$0=$19;
  var $20$1=0;
  __ZN12device_debug17memory_write_hookER13address_spacejyy($11, $14, $16, $18$0, $18$1, $20$0, $20$1);
  var $21=$6;
  var $22=(($21+8)|0);
  var $23=HEAP32[(($22)>>2)];
  $oldtable=$23;
  var $24=$6;
  var $25=(($24+4)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=$6;
  var $28=(($27+8)|0);
  HEAP32[(($28)>>2)]=$26;
  var $29=$6;
  var $30=(($29+12)|0);
  var $31=HEAP32[(($30)>>2)];
  var $32=$31;
  var $33=HEAP32[(($32)>>2)];
  var $34=(($33+80)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$3;
  var $37=$4;
  FUNCTION_TABLE[$35]($31, $36, $37);
  var $38=$oldtable;
  var $39=$6;
  var $40=(($39+8)|0);
  HEAP32[(($40)>>2)]=$38;
  ;
  return;
}
__ZN19address_table_write12watchpoint_wIhEEvR13address_spacejT_S3_["X"]=1;

function __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $start_slot=__stackBase__+8;
      var $end_slot=__stackBase__+12;
      var $i;
      var $i1;
      var $4=__stackBase__+16;
      var $5=__stackBase__+40;
      var $6=__stackBase__+48;
      var $7=__stackBase__+72;
      $1=$this;
      var $st$12$0=(($2)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($2+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      $3=$info;
      var $8=$1;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      var $11=$8;
      var $12=(($11+5)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=(($14)|0)!=16;
      if ($15) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $16
      var $17=$8;
      var $st$1$0=(($2)|0);
      var $18$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($2+4)|0);
      var $18$1=HEAP32[(($st$1$1)>>2)];
      __ZN13handler_entry18configure_subunitsEyiRiS0_($17, $18$0, $18$1, 16, $start_slot, $end_slot);
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $21
      var $22=HEAP32[(($start_slot)>>2)];
      $i=$22;
      __label__ = 5; break;
    case 5: // $23
      var $24=$i;
      var $25=HEAP32[(($end_slot)>>2)];
      var $26=(($24)|0)!=(($25)|0);
      if ($26) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $27
      var $28=$i;
      var $29=(($8+1052)|0);
      var $30=(($29+($28<<3))|0);
      var $31=$3;
      var $32=$30;
      var $33=$31;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($32)>>2)]=HEAP32[(($33)>>2)];HEAP32[(($32+4)>>2)]=HEAP32[(($33+4)>>2)];
      var $34=$i;
      var $35=(($8+1036)|0);
      var $36=(($35+$34)|0);
      HEAP8[($36)]=1;
      __label__ = 7; break;
    case 7: // $37
      var $38=$i;
      var $39=(($38+1)|0);
      $i=$39;
      __label__ = 5; break;
    case 8: // $40
      __label__ = 14; break;
    case 9: // $41
      var $42=HEAP32[(($start_slot)>>2)];
      $i1=$42;
      __label__ = 10; break;
    case 10: // $43
      var $44=$i1;
      var $45=HEAP32[(($end_slot)>>2)];
      var $46=(($44)|0)!=(($45)|0);
      if ($46) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $47
      var $48=$i1;
      var $49=(($8+264)|0);
      var $50=(($49+$48*96)|0);
      var $51=(($50+24)|0);
      var $52=__ZN8delegateIFvR13address_spacejttEEaSERKS3_($51, $delegate);
      var $53=$i1;
      var $54=(($8+1036)|0);
      var $55=(($54+$53)|0);
      HEAP8[($55)]=0;
      __label__ = 12; break;
    case 12: // $56
      var $57=$i1;
      var $58=(($57+1)|0);
      $i1=$58;
      __label__ = 10; break;
    case 13: // $59
      __label__ = 14; break;
    case 14: // $60
      var $61=$8;
      var $62=(($61+5)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=(($64)|0)==32;
      if ($65) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $66
      var $67=$delegate;
      var $68=__ZNK13delegate_baseIvR13address_spacejttE4nameEv($67);
      HEAP32[(($5)>>2)]={ f0: 314, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 314, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($4, $5, $68, $8);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($8, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 19; break;
    case 16: // $69
      var $70=$8;
      var $71=(($70+5)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($73)|0)==64;
      if ($74) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $75
      var $76=$delegate;
      var $77=__ZNK13delegate_baseIvR13address_spacejttE4nameEv($76);
      HEAP32[(($7)>>2)]={ f0: 316, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 316, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($6, $7, $77, $8);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($8, $6, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      __label__ = 18; break;
    case 18: // $78
      __label__ = 19; break;
    case 19: // $79
      __label__ = 23; break;
    case 20: // $80
      var $81=(($8+168)|0);
      var $82=(($81+24)|0);
      var $83=__ZN8delegateIFvR13address_spacejttEEaSERKS3_($82, $delegate);
      var $84=$3;
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $86
      var $87=(($8+1044)|0);
      var $88=$3;
      var $89=$87;
      var $90=$88;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($89)>>2)]=HEAP32[(($90)>>2)];HEAP32[(($89+4)>>2)]=HEAP32[(($90+4)>>2)];
      __label__ = 22; break;
    case 22: // $91
      __label__ = 23; break;
    case 23: // $92
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE["X"]=1;

function __ZN8delegateIFvR13address_spacejttEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejttEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19address_table_write7unmap_wItEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$data;
      $5=$mask;
      var $6=$1;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK13address_space9log_unmapEv($9);
      if ($10) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $11
      var $12=$6;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK13address_space15debugger_accessEv($14);
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$6;
      var $18=(($17+12)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK13address_space7machineEv($19);
      var $21=__ZN15running_machine16describe_contextEv($20);
      var $22=$6;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK13address_space4nameEv($24);
      var $26=$6;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=((($29<<1))|0);
      var $31=__ZNK13address_space15byte_to_addressEj($28, $30);
      var $32$0=$31;
      var $32$1=0;
      var $33=$6;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZNK13address_space9addrcharsEv($35);
      var $37=__Z19core_i64_hex_formatyh($32$0, $32$1, $36);
      var $38=$4;
      var $39$0=$38;
      var $39$1=0;
      var $40=__Z19core_i64_hex_formatyh($39$0, $39$1, 4);
      var $41=$5;
      var $42$0=$41;
      var $42$1=0;
      var $43=__Z19core_i64_hex_formatyh($42$0, $42$1, 4);
      __Z8logerrorPKcz(((STRING_TABLE.__str2083099)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$25,HEAP32[((tempInt+8)>>2)]=$37,HEAP32[((tempInt+12)>>2)]=$40,HEAP32[((tempInt+16)>>2)]=$43,tempInt));
      __label__ = 3; break;
    case 3: // $44
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_write7unmap_wItEEvR13address_spacejT_S3_["X"]=1;

function __ZN19address_table_write12watchpoint_wItEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $oldtable;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=$6;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZNK13address_space6deviceEv($9);
  var $11=__ZNK8device_t5debugEv($10);
  var $12=$6;
  var $13=(($12+12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=((($15<<1))|0);
  var $17=$4;
  var $18$0=$17;
  var $18$1=0;
  var $19=$5;
  var $20$0=$19;
  var $20$1=0;
  __ZN12device_debug17memory_write_hookER13address_spacejyy($11, $14, $16, $18$0, $18$1, $20$0, $20$1);
  var $21=$6;
  var $22=(($21+8)|0);
  var $23=HEAP32[(($22)>>2)];
  $oldtable=$23;
  var $24=$6;
  var $25=(($24+4)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=$6;
  var $28=(($27+8)|0);
  HEAP32[(($28)>>2)]=$26;
  var $29=$6;
  var $30=(($29+12)|0);
  var $31=HEAP32[(($30)>>2)];
  var $32=$31;
  var $33=HEAP32[(($32)>>2)];
  var $34=(($33+88)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$3;
  var $37=$36 << 1;
  var $38=$4;
  var $39=$5;
  FUNCTION_TABLE[$35]($31, $37, $38, $39);
  var $40=$oldtable;
  var $41=$6;
  var $42=(($41+8)|0);
  HEAP32[(($42)>>2)]=$40;
  ;
  return;
}
__ZN19address_table_write12watchpoint_wItEEvR13address_spacejT_S3_["X"]=1;

function __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $start_slot=__stackBase__+8;
      var $end_slot=__stackBase__+12;
      var $i;
      var $i1;
      var $4=__stackBase__+16;
      var $5=__stackBase__+40;
      $1=$this;
      var $st$10$0=(($2)|0);
      HEAP32[(($st$10$0)>>2)]=$mask$0;
      var $st$10$1=(($2+4)|0);
      HEAP32[(($st$10$1)>>2)]=$mask$1;
      $3=$info;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=$6;
      var $10=(($9+5)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($12)|0)!=32;
      if ($13) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $14
      var $15=$6;
      var $st$1$0=(($2)|0);
      var $16$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($2+4)|0);
      var $16$1=HEAP32[(($st$1$1)>>2)];
      __ZN13handler_entry18configure_subunitsEyiRiS0_($15, $16$0, $16$1, 32, $start_slot, $end_slot);
      var $17=$3;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $19
      var $20=HEAP32[(($start_slot)>>2)];
      $i=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$i;
      var $23=HEAP32[(($end_slot)>>2)];
      var $24=(($22)|0)!=(($23)|0);
      if ($24) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $25
      var $26=$i;
      var $27=(($6+1052)|0);
      var $28=(($27+($26<<3))|0);
      var $29=$3;
      var $30=$28;
      var $31=$29;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($30)>>2)]=HEAP32[(($31)>>2)];HEAP32[(($30+4)>>2)]=HEAP32[(($31+4)>>2)];
      var $32=$i;
      var $33=(($6+1036)|0);
      var $34=(($33+$32)|0);
      HEAP8[($34)]=1;
      __label__ = 7; break;
    case 7: // $35
      var $36=$i;
      var $37=(($36+1)|0);
      $i=$37;
      __label__ = 5; break;
    case 8: // $38
      __label__ = 14; break;
    case 9: // $39
      var $40=HEAP32[(($start_slot)>>2)];
      $i1=$40;
      __label__ = 10; break;
    case 10: // $41
      var $42=$i1;
      var $43=HEAP32[(($end_slot)>>2)];
      var $44=(($42)|0)!=(($43)|0);
      if ($44) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $45
      var $46=$i1;
      var $47=(($6+264)|0);
      var $48=(($47+$46*96)|0);
      var $49=(($48+48)|0);
      var $50=__ZN8delegateIFvR13address_spacejjjEEaSERKS3_($49, $delegate);
      var $51=$i1;
      var $52=(($6+1036)|0);
      var $53=(($52+$51)|0);
      HEAP8[($53)]=0;
      __label__ = 12; break;
    case 12: // $54
      var $55=$i1;
      var $56=(($55+1)|0);
      $i1=$56;
      __label__ = 10; break;
    case 13: // $57
      __label__ = 14; break;
    case 14: // $58
      var $59=$6;
      var $60=(($59+5)|0);
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=(($62)|0)==64;
      if ($63) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $64
      var $65=$delegate;
      var $66=__ZNK13delegate_baseIvR13address_spacejjjE4nameEv($65);
      HEAP32[(($5)>>2)]={ f0: 316, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 316, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($4, $5, $66, $6);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($6, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 16; break;
    case 16: // $67
      __label__ = 20; break;
    case 17: // $68
      var $69=(($6+168)|0);
      var $70=(($69+48)|0);
      var $71=__ZN8delegateIFvR13address_spacejjjEEaSERKS3_($70, $delegate);
      var $72=$3;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $74
      var $75=(($6+1044)|0);
      var $76=$3;
      var $77=$75;
      var $78=$76;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($77)>>2)]=HEAP32[(($78)>>2)];HEAP32[(($77+4)>>2)]=HEAP32[(($78+4)>>2)];
      __label__ = 19; break;
    case 19: // $79
      __label__ = 20; break;
    case 20: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE["X"]=1;

function __ZN8delegateIFvR13address_spacejjjEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejjjEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19address_table_write7unmap_wIjEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$data;
      $5=$mask;
      var $6=$1;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK13address_space9log_unmapEv($9);
      if ($10) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $11
      var $12=$6;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK13address_space15debugger_accessEv($14);
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$6;
      var $18=(($17+12)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK13address_space7machineEv($19);
      var $21=__ZN15running_machine16describe_contextEv($20);
      var $22=$6;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK13address_space4nameEv($24);
      var $26=$6;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=((($29<<2))|0);
      var $31=__ZNK13address_space15byte_to_addressEj($28, $30);
      var $32$0=$31;
      var $32$1=0;
      var $33=$6;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZNK13address_space9addrcharsEv($35);
      var $37=__Z19core_i64_hex_formatyh($32$0, $32$1, $36);
      var $38=$4;
      var $39$0=$38;
      var $39$1=0;
      var $40=__Z19core_i64_hex_formatyh($39$0, $39$1, 8);
      var $41=$5;
      var $42$0=$41;
      var $42$1=0;
      var $43=__Z19core_i64_hex_formatyh($42$0, $42$1, 8);
      __Z8logerrorPKcz(((STRING_TABLE.__str2083099)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$25,HEAP32[((tempInt+8)>>2)]=$37,HEAP32[((tempInt+12)>>2)]=$40,HEAP32[((tempInt+16)>>2)]=$43,tempInt));
      __label__ = 3; break;
    case 3: // $44
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_write7unmap_wIjEEvR13address_spacejT_S3_["X"]=1;

function __ZN19address_table_write12watchpoint_wIjEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $oldtable;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=$6;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZNK13address_space6deviceEv($9);
  var $11=__ZNK8device_t5debugEv($10);
  var $12=$6;
  var $13=(($12+12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=((($15<<2))|0);
  var $17=$4;
  var $18$0=$17;
  var $18$1=0;
  var $19=$5;
  var $20$0=$19;
  var $20$1=0;
  __ZN12device_debug17memory_write_hookER13address_spacejyy($11, $14, $16, $18$0, $18$1, $20$0, $20$1);
  var $21=$6;
  var $22=(($21+8)|0);
  var $23=HEAP32[(($22)>>2)];
  $oldtable=$23;
  var $24=$6;
  var $25=(($24+4)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=$6;
  var $28=(($27+8)|0);
  HEAP32[(($28)>>2)]=$26;
  var $29=$6;
  var $30=(($29+12)|0);
  var $31=HEAP32[(($30)>>2)];
  var $32=$31;
  var $33=HEAP32[(($32)>>2)];
  var $34=(($33+104)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$3;
  var $37=$36 << 2;
  var $38=$4;
  var $39=$5;
  FUNCTION_TABLE[$35]($31, $37, $38, $39);
  var $40=$oldtable;
  var $41=$6;
  var $42=(($41+8)|0);
  HEAP32[(($42)>>2)]=$40;
  ;
  return;
}
__ZN19address_table_write12watchpoint_wIjEEvR13address_spacejT_S3_["X"]=1;

function __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($this, $delegate, $mask$0, $mask$1, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      $1=$this;
      var $st$4$0=(($2)|0);
      HEAP32[(($st$4$0)>>2)]=$mask$0;
      var $st$4$1=(($2+4)|0);
      HEAP32[(($st$4$1)>>2)]=$mask$1;
      $3=$info;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=(($4+168)|0);
      var $8=(($7+72)|0);
      var $9=__ZN8delegateIFvR13address_spacejyyEEaSERKS3_($8, $delegate);
      var $10=$3;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=(($4+1044)|0);
      var $14=$3;
      var $15=$13;
      var $16=$14;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[(($16+4)>>2)];
      __label__ = 4; break;
    case 4: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejyyEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejyyEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19address_table_write5nop_wIyEEvR13address_spacejT_S3_($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$data$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$data$1;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $6=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNK19address_table_write7handlerEj($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+352)|0);
      var $8=(($7+($6<<2))|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9;
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13delegate_baseIjR16direct_read_dataj8_noparamS2_E6isnullEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $12 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      var $12 = $10;__label__ = 2; break;
    case 2: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19address_table_write7unmap_wIyEEvR13address_spacejT_S3_($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+8;
      $1=$this;
      $2=$space;
      $3=$offset;
      var $st$8$0=(($4)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($4+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      var $st$12$0=(($5)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($5+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $6=$1;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK13address_space9log_unmapEv($9);
      if ($10) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $11
      var $12=$6;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK13address_space15debugger_accessEv($14);
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$6;
      var $18=(($17+12)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK13address_space7machineEv($19);
      var $21=__ZN15running_machine16describe_contextEv($20);
      var $22=$6;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK13address_space4nameEv($24);
      var $26=$6;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=((($29<<3))|0);
      var $31=__ZNK13address_space15byte_to_addressEj($28, $30);
      var $32$0=$31;
      var $32$1=0;
      var $33=$6;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZNK13address_space9addrcharsEv($35);
      var $37=__Z19core_i64_hex_formatyh($32$0, $32$1, $36);
      var $st$22$0=(($4)|0);
      var $38$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$22$1)>>2)];
      var $39=__Z19core_i64_hex_formatyh($38$0, $38$1, 16);
      var $st$27$0=(($5)|0);
      var $40$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($5+4)|0);
      var $40$1=HEAP32[(($st$27$1)>>2)];
      var $41=__Z19core_i64_hex_formatyh($40$0, $40$1, 16);
      __Z8logerrorPKcz(((STRING_TABLE.__str2083099)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$25,HEAP32[((tempInt+8)>>2)]=$37,HEAP32[((tempInt+12)>>2)]=$39,HEAP32[((tempInt+16)>>2)]=$41,tempInt));
      __label__ = 3; break;
    case 3: // $42
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_write7unmap_wIyEEvR13address_spacejT_S3_["X"]=1;

function __ZN19address_table_write12watchpoint_wIyEEvR13address_spacejT_S3_($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  var $oldtable;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$9$0=(($4)|0);
  HEAP32[(($st$9$0)>>2)]=$data$0;
  var $st$9$1=(($4+4)|0);
  HEAP32[(($st$9$1)>>2)]=$data$1;
  var $st$13$0=(($5)|0);
  HEAP32[(($st$13$0)>>2)]=$mask$0;
  var $st$13$1=(($5+4)|0);
  HEAP32[(($st$13$1)>>2)]=$mask$1;
  var $6=$1;
  var $7=$6;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZNK13address_space6deviceEv($9);
  var $11=__ZNK8device_t5debugEv($10);
  var $12=$6;
  var $13=(($12+12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=((($15<<3))|0);
  var $st$28$0=(($4)|0);
  var $17$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($4+4)|0);
  var $17$1=HEAP32[(($st$28$1)>>2)];
  var $st$32$0=(($5)|0);
  var $18$0=HEAP32[(($st$32$0)>>2)];
  var $st$32$1=(($5+4)|0);
  var $18$1=HEAP32[(($st$32$1)>>2)];
  __ZN12device_debug17memory_write_hookER13address_spacejyy($11, $14, $16, $17$0, $17$1, $18$0, $18$1);
  var $19=$6;
  var $20=(($19+8)|0);
  var $21=HEAP32[(($20)>>2)];
  $oldtable=$21;
  var $22=$6;
  var $23=(($22+4)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=$6;
  var $26=(($25+8)|0);
  HEAP32[(($26)>>2)]=$24;
  var $27=$6;
  var $28=(($27+12)|0);
  var $29=HEAP32[(($28)>>2)];
  var $30=$29;
  var $31=HEAP32[(($30)>>2)];
  var $32=(($31+120)|0);
  var $33=HEAP32[(($32)>>2)];
  var $34=$3;
  var $35=$34 << 3;
  var $st$56$0=(($4)|0);
  var $36$0=HEAP32[(($st$56$0)>>2)];
  var $st$56$1=(($4+4)|0);
  var $36$1=HEAP32[(($st$56$1)>>2)];
  var $st$60$0=(($5)|0);
  var $37$0=HEAP32[(($st$60$0)>>2)];
  var $st$60$1=(($5+4)|0);
  var $37$1=HEAP32[(($st$60$1)>>2)];
  FUNCTION_TABLE[$33]($29, $35, $36$0, $36$1, $37$0, $37$1);
  var $38=$oldtable;
  var $39=$6;
  var $40=(($39+8)|0);
  HEAP32[(($40)>>2)]=$38;
  STACKTOP = __stackBase__;
  return;
}
__ZN19address_table_write12watchpoint_wIyEEvR13address_spacejT_S3_["X"]=1;

function __ZN11simple_listIN16direct_read_data12direct_rangeEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN16direct_read_data12direct_rangeEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN16direct_read_data12direct_rangeEED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFjR16direct_read_datajEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFjR16direct_read_datajEEC2Ev($2);
  ;
  return;
}


function __ZN16direct_read_data17set_direct_regionERj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $overrideaddress;
      var $maskedbits;
      var $range;
      var $base;
      var $based;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$3;
      var $6=HEAP32[(($5)>>2)];
      $overrideaddress=$6;
      var $7=(($4+5168)|0);
      var $8=$7;
      var $9=__ZNK13delegate_baseIjR16direct_read_dataj8_noparamS2_E6isnullEv($8);
      if ($9) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=(($4+5168)|0);
      var $12=$11;
      var $13=$overrideaddress;
      var $14=__ZNK13delegate_baseIjR16direct_read_dataj8_noparamS2_EclES1_j($12, $4, $13);
      $overrideaddress=$14;
      var $15=$overrideaddress;
      var $16=(($15)|0)==-1;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      $1=1;
      __label__ = 10; break;
    case 3: // $18
      var $19=$overrideaddress;
      var $20=$3;
      HEAP32[(($20)>>2)]=$19;
      __label__ = 4; break;
    case 4: // $21
      var $22=$overrideaddress;
      var $23=(($4+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$24 ^ -1;
      var $26=$22 & $25;
      $maskedbits=$26;
      var $27=$overrideaddress;
      var $28=(($4+24)|0);
      var $29=__ZN16direct_read_data10find_rangeEjRh($4, $27, $28);
      $range=$29;
      var $30=(($4+24)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=(($32)|0) < 1;
      if ($33) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $34
      var $35=(($4+24)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=(($37)|0) > 124;
      if ($38) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $39
      var $40=(($4+20)|0);
      HEAP32[(($40)>>2)]=0;
      var $41=(($4+16)|0);
      HEAP32[(($41)>>2)]=1;
      $1=0;
      __label__ = 10; break;
    case 7: // $42
      var $43=(($4+24)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=(($4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=__ZNK13address_space7machineEv($47);
      var $49=(($48+624)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+4)|0);
      var $52=(($51+($45<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      $base=$53;
      var $54=(($4+24)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=(($4)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=__ZNK13address_space7machineEv($58);
      var $60=(($59+624)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+516)|0);
      var $63=(($62+($56<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      $based=$64;
      var $65=$based;
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $67
      var $68=$base;
      $based=$68;
      __label__ = 9; break;
    case 9: // $69
      var $70=(($4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+132)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=FUNCTION_TABLE[$75]($71);
      var $77=(($4+24)|0);
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $80=__ZNK18address_table_read12handler_readEj($76, $79);
      $handler=$80;
      var $81=$handler;
      var $82=$81;
      var $83=__ZNK13handler_entry8bytemaskEv($82);
      var $84=(($4+12)|0);
      HEAP32[(($84)>>2)]=$83;
      var $85=$base;
      var $86=$handler;
      var $87=$86;
      var $88=__ZNK13handler_entry9bytestartEv($87);
      var $89=(($4+12)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$88 & $90;
      var $92=(((-$91))|0);
      var $93=(($85+$92)|0);
      var $94=(($4+4)|0);
      HEAP32[(($94)>>2)]=$93;
      var $95=$based;
      var $96=$handler;
      var $97=$96;
      var $98=__ZNK13handler_entry9bytestartEv($97);
      var $99=(($4+12)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$98 & $100;
      var $102=(((-$101))|0);
      var $103=(($95+$102)|0);
      var $104=(($4+8)|0);
      HEAP32[(($104)>>2)]=$103;
      var $105=$maskedbits;
      var $106=$range;
      var $107=(($106+4)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$105 | $108;
      var $110=(($4+16)|0);
      HEAP32[(($110)>>2)]=$109;
      var $111=$maskedbits;
      var $112=$range;
      var $113=(($112+8)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$111 | $114;
      var $116=(($4+20)|0);
      HEAP32[(($116)>>2)]=$115;
      $1=1;
      __label__ = 10; break;
    case 10: // $117
      var $118=$1;
      ;
      return $118;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_data17set_direct_regionERj["X"]=1;

function __ZNK13delegate_baseIjR16direct_read_dataj8_noparamS2_EclES1_j($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  var $10=$3;
  var $11=FUNCTION_TABLE[$6]($8, $9, $10);
  ;
  return $11;
}


function __ZN19address_table_writeD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19address_table_writeD0Ev["X"]=1;

function __ZN19address_table_writeD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $handnum;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV19address_table_write+8)|0);
      $handnum=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$handnum;
      var $8=(($7)>>>0) < 256;
      if ($8) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      var $10=$4;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $14
      var $15=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $16
      var $17=$handnum;
      var $18=(($4+352)|0);
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($15, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$handnum;
      var $25=(($24+1)|0);
      $handnum=$25;
      __label__ = 1; break;
    case 7: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      var $30=$4;
      (function() { try { __THREW__ = false; return __ZN13address_tableD2Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 8: // $31
      var $32=$4;
      __ZN13address_tableD2Ev($32);
      ;
      return;
    case 9: // $33
      __label__ = 10; break;
    case 10: // $34
      var $35=$2;
      var $36=$2;
      var $37=$3;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_dataC2ER13address_space($this, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$space;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      HEAP32[(($6)>>2)]=$7;
      var $8=(($5+4)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=(($5+8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($5+12)|0);
      var $11=$2;
      var $12=__ZNK13address_space8bytemaskEv($11);
      HEAP32[(($10)>>2)]=$12;
      var $13=(($5+16)|0);
      HEAP32[(($13)>>2)]=1;
      var $14=(($5+20)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($5+24)|0);
      HEAP8[($15)]=126;
      var $16=(($5+28)|0);
      var $17=(($16)|0);
      var $18=(($17+5120)|0);
      var $20 = $17;__label__ = 1; break;
    case 1: // $19
      var $20;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEEC1ER13resource_pool($20, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $21
      var $22=(($20+20)|0);
      var $23=(($22)|0)==(($18)|0);
      if ($23) { __label__ = 3; break; } else { var $20 = $22;__label__ = 1; break; }
    case 3: // $24
      var $25=(($5+5148)|0);
      __ZN11simple_listIN16direct_read_data12direct_rangeEEC1ER13resource_pool($25, _global_resource_pool);
      var $26=(($5+5168)|0);
      (function() { try { __THREW__ = false; return __ZN8delegateIFjR16direct_read_datajEEC1Ev($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $27
      ;
      return;
    case 5: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $3=$30;
      var $31=$29.f1;
      $4=$31;
      var $32=(($17)|0)==(($20)|0);
      if ($32) { __label__ = 8; break; } else { var $34 = $20;__label__ = 6; break; }
    case 6: // $33
      var $34;
      var $35=(($34-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $36
      var $37=(($35)|0)==(($17)|0);
      if ($37) { __label__ = 8; break; } else { var $34 = $35;__label__ = 6; break; }
    case 8: // $38
      __label__ = 11; break;
    case 9: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $3=$41;
      var $42=$40.f1;
      $4=$42;
      var $43=(($5+5148)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $44
      __label__ = 11; break;
    case 11: // $45
      var $46=$3;
      var $47=$3;
      var $48=$4;
      var $49=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $47, tempValue);
      var $50=($49.f1 = $48, $49);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_dataC2ER13address_space["X"]=1;

function __ZN16direct_read_dataD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+5148)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $6
      var $7=(($4+28)|0);
      var $8=(($7)|0);
      var $9=(($8+5120)|0);
      var $11 = $9;__label__ = 2; break;
    case 2: // $10
      var $11;
      var $12=(($11-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $13
      var $14=(($12)|0)==(($8)|0);
      if ($14) { __label__ = 4; break; } else { var $11 = $12;__label__ = 2; break; }
    case 4: // $15
      ;
      return;
    case 5: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      var $20=(($4+28)|0);
      var $21=(($20)|0);
      var $22=(($21+5120)|0);
      var $35 = $22;__label__ = 10; break;
    case 6: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $2=$25;
      var $26=$24.f1;
      $3=$26;
      var $27=(($8)|0)==(($12)|0);
      if ($27) { __label__ = 9; break; } else { var $29 = $12;__label__ = 7; break; }
    case 7: // $28
      var $29;
      var $30=(($29-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $31
      var $32=(($30)|0)==(($8)|0);
      if ($32) { __label__ = 9; break; } else { var $29 = $30;__label__ = 7; break; }
    case 9: // $33
      __label__ = 13; break;
    case 10: // $34
      var $35;
      var $36=(($35-20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $37
      var $38=(($36)|0)==(($21)|0);
      if ($38) { __label__ = 12; break; } else { var $35 = $36;__label__ = 10; break; }
    case 12: // $39
      __label__ = 13; break;
    case 13: // $40
      var $41=$2;
      var $42=$2;
      var $43=$3;
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_dataD2Ev["X"]=1;

function __ZNK18address_table_read12handler_readEj($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+352)|0);
      var $8=(($7+($6<<2))|0);
      var $9=HEAP32[(($8)>>2)];
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN16direct_read_data12direct_rangeEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16direct_read_data12direct_range4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN16direct_read_data12direct_rangeEE6detachERS1_["X"]=1;

function __ZN11simple_listIN16direct_read_data12direct_rangeEE7prependERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13address_table11lookup_liveEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$byteaddress;
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__ZNK13address_table17lookup_live_largeEj($3, $8);
      var $14 = $9;__label__ = 3; break;
    case 2: // $10
      var $11=$2;
      var $12=__ZNK13address_table17lookup_live_smallEj($3, $11);
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16direct_read_data12direct_rangeC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16direct_read_data12direct_rangeC2Ev($2);
  ;
  return;
}


function __ZN16direct_read_data10find_rangeEjRh($this, $byteaddress, $entry) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $range;
      var $range1;
      var $13;
      var $14;
      $10=$this;
      $11=$byteaddress;
      $12=$entry;
      var $15=$10;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+24)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$11;
      var $21=$20 & $19;
      $11=$21;
      var $22=(($15)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+132)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=FUNCTION_TABLE[$27]($23);
      var $29=$28;
      var $30=$11;
      var $31=__ZNK13address_table11lookup_liveEj($29, $30);
      var $32=(($31) & 255);
      var $33=$12;
      HEAP8[($33)]=$32;
      var $34=$12;
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=(($15+28)|0);
      var $38=(($37+$36*20)|0);
      var $39=__ZNK11simple_listIN16direct_read_data12direct_rangeEE5firstEv($38);
      $range=$39;
      __label__ = 1; break;
    case 1: // $40
      var $41=$range;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $43
      var $44=$11;
      var $45=$range;
      var $46=(($45+4)|0);
      var $47=HEAPU32[(($46)>>2)];
      var $48=(($44)>>>0) >= (($47)>>>0);
      if ($48) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $49
      var $50=$11;
      var $51=$range;
      var $52=(($51+8)|0);
      var $53=HEAPU32[(($52)>>2)];
      var $54=(($50)>>>0) <= (($53)>>>0);
      if ($54) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $55
      var $56=$range;
      $9=$56;
      __label__ = 24; break;
    case 5: // $57
      __label__ = 6; break;
    case 6: // $58
      var $59=$range;
      var $60=__ZNK16direct_read_data12direct_range4nextEv($59);
      $range=$60;
      __label__ = 1; break;
    case 7: // $61
      var $62=(($15+5148)|0);
      var $63=__ZNK11simple_listIN16direct_read_data12direct_rangeEE5firstEv($62);
      $range1=$63;
      var $64=$range1;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $66
      var $67=(($15+5148)|0);
      var $68=$range1;
      var $69=__ZN11simple_listIN16direct_read_data12direct_rangeEE6detachERS1_($67, $68);
      __label__ = 23; break;
    case 9: // $70
      var $71=(($15)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=__ZNK13address_space7machineEv($72);
      var $74=__ZN15running_machine7respoolEv($73);
      var $75=$4;
      var $76=$5;
      var $77=$6;
      var $78=$result_i;
      var $79=$7;
      var $80=$8;
      HEAP32[(($4)>>2)]=12;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($6)>>2)]=4390;
      var $81=HEAP32[(($4)>>2)];
      var $82=HEAP32[(($5)>>2)];
      var $83=HEAP32[(($6)>>2)];
      var $84=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($81, $82, $83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $85
      HEAP32[(($result_i)>>2)]=$84;
      var $86=HEAP32[(($result_i)>>2)];
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $88
      var $89=___cxa_allocate_exception(4);
      var $90=$89;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($90);
      (function() { try { __THREW__ = false; return ___cxa_throw($89, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $93=$92.f0;
      HEAP32[(($7)>>2)]=$93;
      var $94=$92.f1;
      HEAP32[(($8)>>2)]=$94;
      var $95=HEAP32[(($8)>>2)];
      var $96=(($95)|0) < 0;
      if ($96) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $97
      var $98=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($98);
      throw "Reached an unreachable!"
    case 14: // $99
      var $100=HEAP32[(($7)>>2)];
      var $101=HEAP32[(($7)>>2)];
      var $102=HEAP32[(($8)>>2)];
      var $103=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $101, tempValue);
      var $104=($103.f1 = $102, $103);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $105
      throw "Reached an unreachable!"
    case 16: // $_ZnwjPKci_exit
      var $106=HEAP32[(($result_i)>>2)];
      var $107=$4;
      var $108=$5;
      var $109=$6;
      var $110=$result_i;
      var $111=$7;
      var $112=$8;
      var $113=$106;
      (function() { try { __THREW__ = false; return __ZN16direct_read_data12direct_rangeC1Ev($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $114
      var $115=__ZN13resource_pool10add_objectIN16direct_read_data12direct_rangeEEEPT_S4_($74, $113);
      $range1=$115;
      __label__ = 23; break;
    case 18: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $118=$117.f0;
      $13=$118;
      var $119=$117.f1;
      $14=$119;
      var $120=$1;
      var $121=$2;
      var $122=$3;
      HEAP32[(($1)>>2)]=$106;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=4390;
      var $123=HEAP32[(($1)>>2)];
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $125
      var $126=HEAP32[(($1)>>2)];
      var $127=HEAP32[(($2)>>2)];
      var $128=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($126, $127, $128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $_noexc
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $129=$1;
      var $130=$2;
      var $131=$3;
      __label__ = 22; break;
    case 22: // $132
      __label__ = 25; break;
    case 23: // $133
      var $134=(($15)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$135;
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+132)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=FUNCTION_TABLE[$139]($135);
      var $141=$140;
      var $142=$11;
      var $143=$range1;
      var $144=(($143+4)|0);
      var $145=$range1;
      var $146=(($145+8)|0);
      var $147=__ZNK13address_table12derive_rangeEjRjS0_($141, $142, $144, $146);
      var $148=$12;
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=(($15+28)|0);
      var $152=(($151+$150*20)|0);
      var $153=$range1;
      var $154=__ZN11simple_listIN16direct_read_data12direct_rangeEE7prependERS1_($152, $153);
      var $155=$range1;
      $9=$155;
      __label__ = 24; break;
    case 24: // $156
      var $157=$9;
      STACKTOP = __stackBase__;
      return $157;
    case 25: // $158
      var $159=$13;
      var $160=$13;
      var $161=$14;
      var $162=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $160, tempValue);
      var $163=($162.f1 = $161, $162);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $164
      var $165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16direct_read_data10find_rangeEjRh["X"]=1;

function __ZN13resource_pool10add_objectIN16direct_read_data12direct_rangeEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN16direct_read_data12direct_rangeEEEPT_S4_["X"]=1;

function __ZNK13memory_region3endEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+72)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($2+76)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($7+$9)|0);
      var $13 = $10;__label__ = 3; break;
    case 2: // $11
      var $13 = 0;__label__ = 3; break;
    case 3: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13memory_region4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12memory_block7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12save_manager20registration_allowedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK11memory_bank7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN11memory_bank14bank_referenceEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11memory_bank14bank_reference7matchesER13address_space13read_or_write($this, $space, $readorwrite) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$space;
      $3=$readorwrite;
      var $4=$1;
      var $5=$2;
      var $6=(($4+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($5)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { var $20 = 0;__label__ = 4; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10)|0)==3;
      if ($11) { var $18 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      var $13=$3;
      var $14=(($4+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($13)|0)==(($15)|0);
      var $18 = $16;__label__ = 3; break;
    case 3: // $17
      var $18;
      var $20 = $18;__label__ = 4; break;
    case 4: // $19
      var $20;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11memory_bank14bank_reference4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN11memory_bank14bank_referenceEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15running_machine12first_regionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+680)|0);
  var $4=__ZNK11tagged_listI13memory_regionE5firstEv($3);
  ;
  return $4;
}


function __ZN12memory_blockD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+24)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=__ZNK12memory_block7machineEv($2);
      var $8=__ZN15running_machine7respoolEv($7);
      var $9=(($2+24)|0);
      var $10=HEAP32[(($9)>>2)];
      __ZN13resource_pool6removeEPv($8, $10);
      __label__ = 2; break;
    case 2: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11memory_bank14bank_referenceEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN11memory_bank14bank_referenceEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN11memory_bank14bank_referenceEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN11memory_bank14bank_referenceEED2Ev($2);
  ;
  return;
}


function __ZN12memory_blockC2ER13address_spacejjPv($this, $space, $bytestart, $byteend, $memory) {
  var __stackBase__  = STACKTOP; STACKTOP += 120; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $result_i=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13;
      var $14;
      var $15;
      var $16;
      var $17;
      var $length;
      var $region;
      var $bytes_per_element;
      var $name=__stackBase__+56;
      var $18;
      var $19;
      $13=$this;
      $14=$space;
      $15=$bytestart;
      $16=$byteend;
      $17=$memory;
      var $20=$13;
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($20+4)|0);
      var $23=$14;
      var $24=__ZNK13address_space7machineEv($23);
      HEAP32[(($22)>>2)]=$24;
      var $25=(($20+8)|0);
      var $26=$14;
      HEAP32[(($25)>>2)]=$26;
      var $27=(($20+12)|0);
      var $28=$15;
      HEAP32[(($27)>>2)]=$28;
      var $29=(($20+16)|0);
      var $30=$16;
      HEAP32[(($29)>>2)]=$30;
      var $31=(($20+20)|0);
      var $32=$17;
      HEAP32[(($31)>>2)]=$32;
      var $33=(($20+24)|0);
      HEAP32[(($33)>>2)]=0;
      __label__ = 1; break;
    case 1: // $34
      __label__ = 2; break;
    case 2: // $35
      var $36=(($20+20)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 3; break; } else { __label__ = 21; break; }
    case 3: // $39
      var $40=$16;
      var $41=(($40+1)|0);
      var $42=$15;
      var $43=(($41-$42)|0);
      $length=$43;
      var $44=$length;
      var $45=(($44)>>>0) < 4096;
      if ($45) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $46
      var $47=$14;
      var $48=__ZNK13address_space7machineEv($47);
      var $49=__ZN15running_machine7respoolEv($48);
      var $50=$length;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      var $54=$10;
      var $55=$result_i;
      var $56=$11;
      var $57=$12;
      HEAP32[(($7)>>2)]=$50;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($9)>>2)]=4483;
      HEAP32[(($10)>>2)]=_zeromem;
      var $58=HEAP32[(($7)>>2)];
      var $59=HEAP32[(($8)>>2)];
      var $60=HEAP32[(($9)>>2)];
      var $61=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($58, $59, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $62
      HEAP32[(($result_i)>>2)]=$61;
      var $63=HEAP32[(($result_i)>>2)];
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $65
      var $66=___cxa_allocate_exception(4);
      var $67=$66;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($67);
      (function() { try { __THREW__ = false; return ___cxa_throw($66, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      HEAP32[(($11)>>2)]=$70;
      var $71=$69.f1;
      HEAP32[(($12)>>2)]=$71;
      var $72=HEAP32[(($12)>>2)];
      var $73=(($72)|0) < 0;
      if ($73) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $74
      var $75=HEAP32[(($11)>>2)];
      ___cxa_call_unexpected($75);
      throw "Reached an unreachable!"
    case 9: // $76
      var $77=HEAP32[(($11)>>2)];
      var $78=HEAP32[(($11)>>2)];
      var $79=HEAP32[(($12)>>2)];
      var $80=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $78, tempValue);
      var $81=($80.f1 = $79, $80);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $82
      throw "Reached an unreachable!"
    case 11: // $_ZnajPKciRK9zeromem_t_exit
      var $83=HEAP32[(($result_i)>>2)];
      var $84=HEAP32[(($7)>>2)];
      _memset($83, 0, $84, 1);
      var $85=HEAP32[(($result_i)>>2)];
      var $86=$7;
      var $87=$8;
      var $88=$9;
      var $89=$10;
      var $90=$result_i;
      var $91=$11;
      var $92=$12;
      var $93=$length;
      var $94=__ZN13resource_pool9add_arrayIhEEPT_S2_i($49, $85, $93);
      var $95=(($20+20)|0);
      HEAP32[(($95)>>2)]=$94;
      var $96=(($20+24)|0);
      HEAP32[(($96)>>2)]=$94;
      __label__ = 20; break;
    case 12: // $97
      var $98=$14;
      var $99=__ZNK13address_space7machineEv($98);
      var $100=__ZN15running_machine7respoolEv($99);
      var $101=$length;
      var $102=(($101+4095)|0);
      var $103=$1;
      var $104=$2;
      var $105=$3;
      var $106=$4;
      var $107=$result_i1;
      var $108=$5;
      var $109=$6;
      HEAP32[(($1)>>2)]=$102;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2891)|0);
      HEAP32[(($3)>>2)]=4486;
      HEAP32[(($4)>>2)]=_zeromem;
      var $110=HEAP32[(($1)>>2)];
      var $111=HEAP32[(($2)>>2)];
      var $112=HEAP32[(($3)>>2)];
      var $113=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($110, $111, $112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $114
      HEAP32[(($result_i1)>>2)]=$113;
      var $115=HEAP32[(($result_i1)>>2)];
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $117
      var $118=___cxa_allocate_exception(4);
      var $119=$118;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($119);
      (function() { try { __THREW__ = false; return ___cxa_throw($118, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 15: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $122=$121.f0;
      HEAP32[(($5)>>2)]=$122;
      var $123=$121.f1;
      HEAP32[(($6)>>2)]=$123;
      var $124=HEAP32[(($6)>>2)];
      var $125=(($124)|0) < 0;
      if ($125) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $126
      var $127=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($127);
      throw "Reached an unreachable!"
    case 17: // $128
      var $129=HEAP32[(($5)>>2)];
      var $130=HEAP32[(($5)>>2)];
      var $131=HEAP32[(($6)>>2)];
      var $132=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $130, tempValue);
      var $133=($132.f1 = $131, $132);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $134
      throw "Reached an unreachable!"
    case 19: // $_ZnajPKciRK9zeromem_t_exit2
      var $135=HEAP32[(($result_i1)>>2)];
      var $136=HEAP32[(($1)>>2)];
      _memset($135, 0, $136, 1);
      var $137=HEAP32[(($result_i1)>>2)];
      var $138=$1;
      var $139=$2;
      var $140=$3;
      var $141=$4;
      var $142=$result_i1;
      var $143=$5;
      var $144=$6;
      var $145=$length;
      var $146=(($145+4095)|0);
      var $147=__ZN13resource_pool9add_arrayIhEEPT_S2_i($100, $137, $146);
      var $148=(($20+24)|0);
      HEAP32[(($148)>>2)]=$147;
      var $149=(($20+24)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$150;
      var $152=(($151+4095)|0);
      var $153=$152 & -4096;
      var $154=$153;
      var $155=(($20+20)|0);
      HEAP32[(($155)>>2)]=$154;
      __label__ = 20; break;
    case 20: // $156
      __label__ = 21; break;
    case 21: // $157
      var $158=$14;
      var $159=__ZNK13address_space7machineEv($158);
      var $160=__ZNK15running_machine12first_regionEv($159);
      $region=$160;
      __label__ = 22; break;
    case 22: // $161
      var $162=$region;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $164
      var $165=(($20+20)|0);
      var $166=HEAPU32[(($165)>>2)];
      var $167=$region;
      var $168=__ZNK13memory_region4baseEv($167);
      var $169=(($166)>>>0) >= (($168)>>>0);
      if ($169) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $170
      var $171=(($20+20)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=$16;
      var $174=$15;
      var $175=(($173-$174)|0);
      var $176=(($175+1)|0);
      var $177=(($172+$176)|0);
      var $178=$region;
      var $179=__ZNK13memory_region3endEv($178);
      var $180=(($177)>>>0) < (($179)>>>0);
      if ($180) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $181
      __label__ = 26; break;
    case 26: // $182
      __label__ = 27; break;
    case 27: // $183
      __label__ = 30; break;
    case 28: // $184
      __label__ = 29; break;
    case 29: // $185
      var $186=$region;
      var $187=__ZNK13memory_region4nextEv($186);
      $region=$187;
      __label__ = 22; break;
    case 30: // $188
      var $189=$region;
      var $190=(($189)|0)==0;
      if ($190) { __label__ = 31; break; } else { __label__ = 42; break; }
    case 31: // $191
      var $192=$14;
      var $193=__ZNK13address_space10data_widthEv($192);
      var $194=(((($193)|0)/8)|0);
      $bytes_per_element=$194;
      __ZN7astringC1Ev($name);
      var $195=$15;
      var $196=$16;
      var $197=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($name, ((STRING_TABLE.__str1953086)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$195,HEAP32[((tempInt+4)>>2)]=$196,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 40; break; };
    case 32: // $198
      var $199=$14;
      var $200=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($199) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 40; break; };
    case 33: // $201
      var $202=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 40; break; };
    case 34: // $203
      var $204=$14;
      var $205=(function() { try { __THREW__ = false; return __ZNK13address_space6deviceEv($204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 40; break; };
    case 35: // $206
      var $207=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($205) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 40; break; };
    case 36: // $208
      var $209=$14;
      var $210=(function() { try { __THREW__ = false; return __ZNK13address_space8spacenumEv($209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 40; break; };
    case 37: // $211
      var $212=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 40; break; };
    case 38: // $213
      var $214=(($20+20)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=$bytes_per_element;
      var $217=$16;
      var $218=(($217+1)|0);
      var $219=$15;
      var $220=(($218-$219)|0);
      var $221=$bytes_per_element;
      var $222=Math.floor((($220)>>>0)/(($221)>>>0));
      (function() { try { __THREW__ = false; return __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($202, ((STRING_TABLE.__str1963087)|0), $207, $210, $212, $215, $216, $222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $223
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      __label__ = 42; break;
    case 40: // $224
      var $225=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $226=$225.f0;
      $18=$226;
      var $227=$225.f1;
      $19=$227;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 44; break; }
    case 41: // $228
      __label__ = 43; break;
    case 42: // $229
      STACKTOP = __stackBase__;
      return;
    case 43: // $230
      var $231=$18;
      var $232=$18;
      var $233=$19;
      var $234=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $232, tempValue);
      var $235=($234.f1 = $233, $234);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 44: // $236
      var $237=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12memory_blockC2ER13address_spacejjPv["X"]=1;

function __ZN11memory_bankC2ER13address_spaceijjPKc($this, $space, $index, $bytestart, $byteend, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      $1=$this;
      $2=$space;
      $3=$index;
      $4=$bytestart;
      $5=$byteend;
      $6=$tag;
      var $9=$1;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($9+4)|0);
      var $12=$2;
      var $13=__ZNK13address_space7machineEv($12);
      HEAP32[(($11)>>2)]=$13;
      var $14=(($9+8)|0);
      var $15=$3;
      var $16=$2;
      var $17=__ZNK13address_space7machineEv($16);
      var $18=(($17+624)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+4)|0);
      var $21=(($20+($15<<2))|0);
      HEAP32[(($14)>>2)]=$21;
      var $22=(($9+12)|0);
      var $23=$3;
      var $24=$2;
      var $25=__ZNK13address_space7machineEv($24);
      var $26=(($25+624)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+516)|0);
      var $29=(($28+($23<<2))|0);
      HEAP32[(($22)>>2)]=$29;
      var $30=(($9+16)|0);
      var $31=$3;
      var $32=(($31) & 255);
      HEAP8[($30)]=$32;
      var $33=(($9+17)|0);
      var $34=$6;
      var $35=(($34)|0)==0;
      var $36=(($35)&1);
      HEAP8[($33)]=$36;
      var $37=(($9+20)|0);
      var $38=$4;
      HEAP32[(($37)>>2)]=$38;
      var $39=(($9+24)|0);
      var $40=$5;
      HEAP32[(($39)>>2)]=$40;
      var $41=(($9+28)|0);
      HEAP32[(($41)>>2)]=-1;
      var $42=(($9+32)|0);
      HEAP32[(($42)>>2)]=0;
      var $43=(($9+36)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=(($9+40)|0);
      __ZN7astringC1Ev($44);
      var $45=(($9+104)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $46
      var $47=(($9+168)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11memory_bank14bank_referenceEEC1ER13resource_pool($47, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $48
      var $49=$6;
      var $50=(($49)|0)==0;
      if ($50) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $51
      var $52=(($9+104)|0);
      var $53=$3;
      var $54=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($52, ((STRING_TABLE.__str1973088)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $55
      var $56=(($9+40)|0);
      var $57=$3;
      var $58=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($56, ((STRING_TABLE.__str1983089)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$57,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $59
      __label__ = 12; break;
    case 6: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $7=$62;
      var $63=$61.f1;
      $8=$63;
      __label__ = 26; break;
    case 7: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      $7=$66;
      var $67=$65.f1;
      $8=$67;
      __label__ = 24; break;
    case 8: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $7=$70;
      var $71=$69.f1;
      $8=$71;
      var $72=(($9+168)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11memory_bank14bank_referenceEED1Ev($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 9: // $73
      var $74=(($9+104)|0);
      var $75=$6;
      var $76=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($74, $75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $77
      var $78=(($9+40)|0);
      var $79=$6;
      var $80=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($78, ((STRING_TABLE.__str1993090)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$79,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      var $83=(($9+17)|0);
      var $84=HEAP8[($83)];
      var $85=(($84) & 1);
      if ($85) { __label__ = 22; break; } else { __label__ = 13; break; }
    case 13: // $86
      var $87=$2;
      var $88=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 8; break; };
    case 14: // $89
      var $90=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 8; break; };
    case 15: // $91
      var $92=(function() { try { __THREW__ = false; return __ZNK12save_manager20registration_allowedEv($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 8; break; };
    case 16: // $93
      if ($92) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $94
      var $95=$2;
      var $96=(function() { try { __THREW__ = false; return __ZNK13address_space7machineEv($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 8; break; };
    case 18: // $97
      var $98=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 8; break; };
    case 19: // $99
      var $100=(($9+104)|0);
      var $101=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 8; break; };
    case 20: // $102
      var $103=(($9+28)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_($98, ((STRING_TABLE.__str1963087)|0), $101, 0, $103, ((STRING_TABLE.__str2003091)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 8; break; }
    case 21: // $104
      __label__ = 22; break;
    case 22: // $105
      ;
      return;
    case 23: // $106
      __label__ = 24; break;
    case 24: // $107
      var $108=(($9+104)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $109
      __label__ = 26; break;
    case 26: // $110
      var $111=(($9+40)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $112
      __label__ = 28; break;
    case 28: // $113
      var $114=$7;
      var $115=$7;
      var $116=$8;
      var $117=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $115, tempValue);
      var $118=($117.f1 = $116, $117);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $119
      var $120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11memory_bankC2ER13address_spaceijjPKc["X"]=1;

function __ZN11memory_bankD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(function() { try { __THREW__ = false; return __ZNK11memory_bank7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $6
      var $7=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $8
      var $9=(($4+32)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($7, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $12
      var $13=(($4+168)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11memory_bank14bank_referenceEED1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $14
      var $15=(($4+104)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $16
      var $17=(($4+40)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($17);
      ;
      return;
    case 6: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $2=$20;
      var $21=$19.f1;
      $3=$21;
      var $22=(($4+168)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11memory_bank14bank_referenceEED1Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 7: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $2=$25;
      var $26=$24.f1;
      $3=$26;
      __label__ = 10; break;
    case 8: // $27
      __label__ = 10; break;
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $2=$30;
      var $31=$29.f1;
      $3=$31;
      __label__ = 12; break;
    case 10: // $32
      var $33=(($4+104)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $34
      __label__ = 12; break;
    case 12: // $35
      var $36=(($4+40)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $37
      __label__ = 14; break;
    case 14: // $38
      var $39=$2;
      var $40=$2;
      var $41=$3;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11memory_bankD2Ev["X"]=1;

function __ZN13handler_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNK11memory_bank14bank_reference5spaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN16direct_read_data12force_updateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+16)|0);
  HEAP32[(($4)>>2)]=1;
  ;
  return;
}


function __ZN13handler_entryC2Eh12endianness_tPPh($this, $width, $endianness, $rambaseptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$width;
  $3=$endianness;
  $4=$rambaseptr;
  var $5=$1;
  var $6=$5;
  HEAP32[(($6)>>2)]=((__ZTV13handler_entry+8)|0);
  var $7=(($5+4)|0);
  HEAP8[($7)]=0;
  var $8=(($5+5)|0);
  var $9=$2;
  HEAP8[($8)]=$9;
  var $10=(($5+8)|0);
  var $11=$3;
  HEAP32[(($10)>>2)]=$11;
  var $12=(($5+12)|0);
  HEAP32[(($12)>>2)]=0;
  var $13=(($5+16)|0);
  HEAP32[(($13)>>2)]=0;
  var $14=(($5+20)|0);
  HEAP32[(($14)>>2)]=-1;
  var $15=(($5+24)|0);
  var $16=$4;
  HEAP32[(($15)>>2)]=$16;
  var $17=(($5+28)|0);
  HEAP8[($17)]=0;
  var $18=(($5+32)|0);
  ;
  return;
}


function __ZN13handler_entry20reconfigure_subunitsEj($this, $bytestart) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $delta;
      var $i;
      $1=$this;
      $2=$bytestart;
      var $3=$1;
      var $4=$2;
      var $5=(($3+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4-$6)|0);
      $delta=$7;
      $i=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$i;
      var $10=(($3+28)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($9)|0)!=(($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      var $15=$delta;
      var $16=$i;
      var $17=(($3+32)|0);
      var $18=(($17+($16<<4))|0);
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20-$15)|0);
      HEAP32[(($19)>>2)]=$21;
      __label__ = 3; break;
    case 3: // $22
      var $23=$i;
      var $24=(($23+1)|0);
      $i=$24;
      __label__ = 1; break;
    case 4: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13handler_entry18configure_subunitsEyiRiS0_($this, $handlermask$0, $handlermask$1, $handlerbits, $start_slot, $end_slot) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $5;
      var $unitmask=__stackBase__+8;
      var $maxunits;
      var $shift_xor_mask;
      var $count;
      var $unitnum;
      var $shift;
      var $scanmask;
      var $cur_offset;
      var $unitnum1;
      var $shift2;
      var $i;
      $1=$this;
      var $st$17$0=(($2)|0);
      HEAP32[(($st$17$0)>>2)]=$handlermask$0;
      var $st$17$1=(($2+4)|0);
      HEAP32[(($st$17$1)>>2)]=$handlermask$1;
      $3=$handlerbits;
      $4=$start_slot;
      $5=$end_slot;
      var $6=$1;
      var $7=$3;
      var $8$0=$7;
      var $8$1=0;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $9=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"shl",$8$0);var $9$0 = $9[0], $9$1 = $9[1];
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $10$0 = ((($9$0)>>>0)+((($9$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $10$1 = Math.min(Math.floor((((($9$0)>>>0)+((($9$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$34$0=(($unitmask)|0);
      HEAP32[(($st$34$0)>>2)]=$10$0;
      var $st$34$1=(($unitmask+4)|0);
      HEAP32[(($st$34$1)>>2)]=$10$1;
      __label__ = 1; break;
    case 1: // $11
      __label__ = 2; break;
    case 2: // $12
      var $13=(($6+5)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$3;
      var $17=(((($15)|0)/(($16)|0))|0);
      $maxunits=$17;
      __label__ = 3; break;
    case 3: // $18
      __label__ = 4; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=(($6+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $25
      var $30 = 0;__label__ = 9; break;
    case 8: // $26
      var $27=$maxunits;
      var $28=(($27-1)|0);
      var $30 = $28;__label__ = 9; break;
    case 9: // $29
      var $30;
      $shift_xor_mask=$30;
      $count=0;
      $unitnum=0;
      __label__ = 10; break;
    case 10: // $31
      var $32=$unitnum;
      var $33=$maxunits;
      var $34=(($32)|0) < (($33)|0);
      if ($34) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $35
      var $36=$unitnum;
      var $37=$3;
      var $38=(($36*$37)|0);
      $shift=$38;
      var $st$4$0=(($2)|0);
      var $39$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($2+4)|0);
      var $39$1=HEAP32[(($st$4$1)>>2)];
      var $40=$shift;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $43$0=$42$0;
      var $43=$43$0;
      $scanmask=$43;
      __label__ = 12; break;
    case 12: // $44
      __label__ = 13; break;
    case 13: // $45
      var $46=$scanmask;
      var $47$0=$46;
      var $47$1=0;
      var $st$3$0=(($unitmask)|0);
      var $48$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($unitmask+4)|0);
      var $48$1=HEAP32[(($st$3$1)>>2)];
      var $49$0=$47$0 & $48$0;
      var $49$1=$47$1 & $48$1;
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $50=$49$0 != $$emscripten$temp$2$0 || $49$1 != $$emscripten$temp$2$1;
      if ($50) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $51
      var $52=$count;
      var $53=(($52+1)|0);
      $count=$53;
      __label__ = 15; break;
    case 15: // $54
      __label__ = 16; break;
    case 16: // $55
      var $56=$unitnum;
      var $57=(($56+1)|0);
      $unitnum=$57;
      __label__ = 10; break;
    case 17: // $58
      $cur_offset=0;
      var $59=(($6+28)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=$4;
      HEAP32[(($62)>>2)]=$61;
      $unitnum1=0;
      __label__ = 18; break;
    case 18: // $63
      var $64=$unitnum1;
      var $65=$maxunits;
      var $66=(($64)|0) < (($65)|0);
      if ($66) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $67
      var $68=$unitnum1;
      var $69=$shift_xor_mask;
      var $70=$68 ^ $69;
      var $71=$3;
      var $72=(($70*$71)|0);
      $shift2=$72;
      var $st$6$0=(($2)|0);
      var $73$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($2+4)|0);
      var $73$1=HEAP32[(($st$6$1)>>2)];
      var $74=$shift2;
      var $75$0=$74;
      var $75$1=0;
      var $76=Runtime.bitshift64($73$0, $73$1,"lshr",$75$0);var $76$0 = $76[0], $76$1 = $76[1];
      var $st$14$0=(($unitmask)|0);
      var $77$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($unitmask+4)|0);
      var $77$1=HEAP32[(($st$14$1)>>2)];
      var $78$0=$76$0 & $77$0;
      var $78$1=$76$1 & $77$1;
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $79=$78$0 != $$emscripten$temp$3$0 || $78$1 != $$emscripten$temp$3$1;
      if ($79) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $80
      var $st$0$0=(($unitmask)|0);
      var $81$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($unitmask+4)|0);
      var $81$1=HEAP32[(($st$0$1)>>2)];
      var $82$0=$81$0;
      var $82=$82$0;
      var $83=(($6+28)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=(($6+32)|0);
      var $87=(($86+($85<<4))|0);
      var $88=(($87)|0);
      HEAP32[(($88)>>2)]=$82;
      var $89=$cur_offset;
      var $90=(($89+1)|0);
      $cur_offset=$90;
      var $91=(($6+28)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=(($6+32)|0);
      var $95=(($94+($93<<4))|0);
      var $96=(($95+4)|0);
      HEAP32[(($96)>>2)]=$89;
      var $97=$3;
      var $98=(($97) & 255);
      var $99=(($6+28)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=(($6+32)|0);
      var $103=(($102+($101<<4))|0);
      var $104=(($103+12)|0);
      HEAP8[($104)]=$98;
      var $105=$shift2;
      var $106=(($105) & 255);
      var $107=(($6+28)|0);
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      var $110=(($6+32)|0);
      var $111=(($110+($109<<4))|0);
      var $112=(($111+13)|0);
      HEAP8[($112)]=$106;
      var $113=$count;
      var $114=(($6+28)|0);
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $117=(($6+32)|0);
      var $118=(($117+($116<<4))|0);
      var $119=(($118+8)|0);
      HEAP32[(($119)>>2)]=$113;
      var $120=(($6+28)|0);
      var $121=HEAP8[($120)];
      var $122=(($121+1)&255);
      HEAP8[($120)]=$122;
      __label__ = 21; break;
    case 21: // $123
      __label__ = 22; break;
    case 22: // $124
      var $125=$unitnum1;
      var $126=(($125+1)|0);
      $unitnum1=$126;
      __label__ = 18; break;
    case 23: // $127
      var $128=(($6+28)|0);
      var $129=HEAPU8[($128)];
      var $130=(($129)&255);
      var $131=$5;
      HEAP32[(($131)>>2)]=$130;
      var $132=(($6+160)|0);
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $st$8$0=(($132)|0);
      HEAP32[(($st$8$0)>>2)]=$$emscripten$temp$4$0;
      var $st$8$1=(($132+4)|0);
      HEAP32[(($st$8$1)>>2)]=$$emscripten$temp$4$1;
      $i=0;
      __label__ = 24; break;
    case 24: // $133
      var $134=$i;
      var $135=(($6+28)|0);
      var $136=HEAPU8[($135)];
      var $137=(($136)&255);
      var $138=(($134)|0) < (($137)|0);
      if ($138) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $139
      var $140=$i;
      var $141=(($6+32)|0);
      var $142=(($141+($140<<4))|0);
      var $143=(($142)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$i;
      var $146=(($6+32)|0);
      var $147=(($146+($145<<4))|0);
      var $148=(($147+13)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$144 << $150;
      var $152$0=$151;
      var $152$1=0;
      var $153=(($6+160)|0);
      var $st$15$0=(($153)|0);
      var $154$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($153+4)|0);
      var $154$1=HEAP32[(($st$15$1)>>2)];
      var $155$0=$154$0 | $152$0;
      var $155$1=$154$1 | $152$1;
      var $st$21$0=(($153)|0);
      HEAP32[(($st$21$0)>>2)]=$155$0;
      var $st$21$1=(($153+4)|0);
      HEAP32[(($st$21$1)>>2)]=$155$1;
      __label__ = 26; break;
    case 26: // $156
      var $157=$i;
      var $158=(($157+1)|0);
      $i=$158;
      __label__ = 24; break;
    case 27: // $159
      var $160=(($6+160)|0);
      var $st$1$0=(($160)|0);
      var $161$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($160+4)|0);
      var $161$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$5$0=-1;
      var $$emscripten$temp$5$1=-1;
      var $162$0=$161$0 ^ $$emscripten$temp$5$0;
      var $162$1=$161$1 ^ $$emscripten$temp$5$1;
      var $163=(($6+160)|0);
      var $st$10$0=(($163)|0);
      HEAP32[(($st$10$0)>>2)]=$162$0;
      var $st$10$1=(($163+4)|0);
      HEAP32[(($st$10$1)>>2)]=$162$1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13handler_entry18configure_subunitsEyiRiS0_["X"]=1;

function __ZN11memory_bank14bank_referenceC1ER13address_space13read_or_write($this, $space, $readorwrite) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$space;
  $3=$readorwrite;
  var $4=$1;
  var $5=$3;
  var $6=$2;
  __ZN11memory_bank14bank_referenceC2ER13address_space13read_or_write($4, $6, $5);
  ;
  return;
}


function __ZN11memory_bank21invalidate_referencesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ref;
      $1=$this;
      var $2=$1;
      var $3=(($2+168)|0);
      var $4=__ZNK11simple_listIN11memory_bank14bank_referenceEE5firstEv($3);
      $ref=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$ref;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$ref;
      var $10=__ZNK11memory_bank14bank_reference5spaceEv($9);
      var $11=__ZNK13address_space6directEv($10);
      __ZN16direct_read_data12force_updateEv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$ref;
      var $14=__ZNK11memory_bank14bank_reference4nextEv($13);
      $ref=$14;
      __label__ = 1; break;
    case 4: // $15
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13handler_entry4copyEPS_($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$entry;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      __label__ = 3; break;
    case 3: // $6
      __label__ = 4; break;
    case 4: // $7
      __label__ = 5; break;
    case 5: // $8
      __label__ = 6; break;
    case 6: // $9
      __label__ = 7; break;
    case 7: // $10
      __label__ = 8; break;
    case 8: // $11
      var $12=(($3+4)|0);
      HEAP8[($12)]=1;
      var $13=$2;
      var $14=(($13+5)|0);
      var $15=HEAP8[($14)];
      var $16=(($3+5)|0);
      HEAP8[($16)]=$15;
      var $17=$2;
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($3+8)|0);
      HEAP32[(($20)>>2)]=$19;
      var $21=$2;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($3+12)|0);
      HEAP32[(($24)>>2)]=$23;
      var $25=$2;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($3+16)|0);
      HEAP32[(($28)>>2)]=$27;
      var $29=$2;
      var $30=(($29+20)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($3+20)|0);
      HEAP32[(($32)>>2)]=$31;
      var $33=(($3+24)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=$2;
      var $35=(($34+28)|0);
      var $36=HEAP8[($35)];
      var $37=(($3+28)|0);
      HEAP8[($37)]=$36;
      var $38=(($3+32)|0);
      var $39=(($38)|0);
      var $40=$39;
      var $41=$2;
      var $42=(($41+32)|0);
      var $43=(($42)|0);
      var $44=$43;
      var $45=(($3+28)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=((($47<<4))|0);
      assert($48 % 1 === 0, 'memcpy given ' + $48 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($40, $44, $48, 1);
      var $49=$2;
      var $50=(($49+160)|0);
      var $st$48$0=(($50)|0);
      var $51$0=HEAP32[(($st$48$0)>>2)];
      var $st$48$1=(($50+4)|0);
      var $51$1=HEAP32[(($st$48$1)>>2)];
      var $52=(($3+160)|0);
      var $st$53$0=(($52)|0);
      HEAP32[(($st$53$0)>>2)]=$51$0;
      var $st$53$1=(($52+4)|0);
      HEAP32[(($st$53$1)>>2)]=$51$1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13handler_entry4copyEPS_["X"]=1;

function __ZN18handler_entry_read4copyEP13handler_entry($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $rentry;
  $1=$this;
  $2=$entry;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  __ZN13handler_entry4copyEPS_($4, $5);
  var $6=$2;
  var $7=$6;
  $rentry=$7;
  var $8=(($3+168)|0);
  var $9=$rentry;
  var $10=(($9+168)|0);
  var $11=__ZN18handler_entry_read14access_handleraSERKS0_($8, $10);
  var $12=(($3+264)|0);
  var $13=(($12)|0);
  var $14=$13;
  var $15=$rentry;
  var $16=(($15+264)|0);
  var $17=(($16)|0);
  var $18=$17;
  var $19=$3;
  var $20=(($19+28)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=(($22*96)|0);
  assert($23 % 1 === 0, 'memcpy given ' + $23 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($14, $18, $23, 1);
  var $24=(($3+1036)|0);
  var $25=(($24)|0);
  var $26=$rentry;
  var $27=(($26+1036)|0);
  var $28=(($27)|0);
  var $29=$3;
  var $30=(($29+28)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=(($32)|0);
  assert($33 % 1 === 0, 'memcpy given ' + $33 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($25, $28, $33, 1);
  var $34=(($3+1052)|0);
  var $35=(($34)|0);
  var $36=$35;
  var $37=$rentry;
  var $38=(($37+1052)|0);
  var $39=(($38)|0);
  var $40=$39;
  var $41=$3;
  var $42=(($41+28)|0);
  var $43=HEAPU8[($42)];
  var $44=(($43)&255);
  var $45=((($44<<3))|0);
  assert($45 % 1 === 0, 'memcpy given ' + $45 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($36, $40, $45, 1);
  ;
  return;
}
__ZN18handler_entry_read4copyEP13handler_entry["X"]=1;

function __ZN18handler_entry_read14access_handleraSERKS0_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=(($4)|0);
  var $6=$3;
  var $7=(($6)|0);
  var $8=__ZN8delegateIFhR13address_spacejhEEaSERKS3_($5, $7);
  var $9=(($4+24)|0);
  var $10=$3;
  var $11=(($10+24)|0);
  var $12=__ZN8delegateIFtR13address_spacejtEEaSERKS3_($9, $11);
  var $13=(($4+48)|0);
  var $14=$3;
  var $15=(($14+48)|0);
  var $16=__ZN8delegateIFjR13address_spacejjEEaSERKS3_($13, $15);
  var $17=(($4+72)|0);
  var $18=$3;
  var $19=(($18+72)|0);
  var $20=__ZN8delegateIFyR13address_spacejyEEaSERKS3_($17, $19);
  ;
  return $4;
}


function __ZNK18handler_entry_read4nameEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=$3;
      var $5=(($4+5)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      if ($7 == 8) {
        __label__ = 1; break;
      }
      else if ($7 == 16) {
        __label__ = 2; break;
      }
      else if ($7 == 32) {
        __label__ = 3; break;
      }
      else if ($7 == 64) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $8
      var $9=(($3+168)|0);
      var $10=(($9)|0);
      var $11=$10;
      var $12=__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($11);
      $1=$12;
      __label__ = 6; break;
    case 2: // $13
      var $14=(($3+168)|0);
      var $15=(($14+24)|0);
      var $16=$15;
      var $17=__ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv($16);
      $1=$17;
      __label__ = 6; break;
    case 3: // $18
      var $19=(($3+168)|0);
      var $20=(($19+48)|0);
      var $21=$20;
      var $22=__ZNK13delegate_baseIjR13address_spacejj8_noparamE4nameEv($21);
      $1=$22;
      __label__ = 6; break;
    case 4: // $23
      var $24=(($3+168)|0);
      var $25=(($24+72)|0);
      var $26=$25;
      var $27=__ZNK13delegate_baseIyR13address_spacejy8_noparamE4nameEv($26);
      $1=$27;
      __label__ = 6; break;
    case 5: // $28
      $1=0;
      __label__ = 6; break;
    case 6: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18handler_entry_read12subunit_nameEi($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$entry;
      var $4=$2;
      var $5=$3;
      var $6=$4;
      var $7=(($6+32)|0);
      var $8=(($7+($5<<4))|0);
      var $9=(($8+12)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      if ($11 == 8) {
        __label__ = 1; break;
      }
      else if ($11 == 16) {
        __label__ = 2; break;
      }
      else if ($11 == 32) {
        __label__ = 3; break;
      }
      else if ($11 == 64) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $12
      var $13=$3;
      var $14=(($4+264)|0);
      var $15=(($14+$13*96)|0);
      var $16=(($15)|0);
      var $17=$16;
      var $18=__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv($17);
      $1=$18;
      __label__ = 6; break;
    case 2: // $19
      var $20=$3;
      var $21=(($4+264)|0);
      var $22=(($21+$20*96)|0);
      var $23=(($22+24)|0);
      var $24=$23;
      var $25=__ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv($24);
      $1=$25;
      __label__ = 6; break;
    case 3: // $26
      var $27=$3;
      var $28=(($4+264)|0);
      var $29=(($28+$27*96)|0);
      var $30=(($29+48)|0);
      var $31=$30;
      var $32=__ZNK13delegate_baseIjR13address_spacejj8_noparamE4nameEv($31);
      $1=$32;
      __label__ = 6; break;
    case 4: // $33
      var $34=$3;
      var $35=(($4+264)|0);
      var $36=(($35+$34*96)|0);
      var $37=(($36+72)|0);
      var $38=$37;
      var $39=__ZNK13delegate_baseIyR13address_spacejy8_noparamE4nameEv($38);
      $1=$39;
      __label__ = 6; break;
    case 5: // $40
      $1=0;
      __label__ = 6; break;
    case 6: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK18handler_entry_read12subunit_nameEi["X"]=1;

function __ZN13resource_pool10add_objectIN11memory_bank14bank_referenceEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN11memory_bank14bank_referenceEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN11memory_bank14bank_referenceEEEPT_S4_["X"]=1;

function __ZN13handler_entryD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13handler_entryD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13handler_entryD0Ev["X"]=1;

function __ZNK13delegate_baseIhR13address_spacejh8_noparamE10has_objectEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK13delegate_baseItR13address_spacejt8_noparamE10has_objectEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK13delegate_baseIjR13address_spacejj8_noparamE10has_objectEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK13delegate_baseIyR13address_spacejy8_noparamE10has_objectEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZN18handler_entry_read14remove_subunitEi($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $moving;
      $1=$this;
      $2=$entry;
      var $3=$1;
      var $4=$3;
      var $5=(($4+28)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=$2;
      var $9=(($7-$8)|0);
      var $10=(($9-1)|0);
      $moving=$10;
      var $11=$moving;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+264)|0);
      var $15=(($14)|0);
      var $16=$2;
      var $17=(($15+$16*96)|0);
      var $18=$17;
      var $19=(($3+264)|0);
      var $20=(($19)|0);
      var $21=$2;
      var $22=(($20+$21*96)|0);
      var $23=(($22+96)|0);
      var $24=$23;
      var $25=$moving;
      var $26=(($25*96)|0);
      _llvm_memmove_p0i8_p0i8_i32($18, $24, $26, 1, 0);
      var $27=(($3+1036)|0);
      var $28=(($27)|0);
      var $29=$2;
      var $30=(($28+$29)|0);
      var $31=(($3+1036)|0);
      var $32=(($31)|0);
      var $33=$2;
      var $34=(($32+$33)|0);
      var $35=(($34+1)|0);
      var $36=$moving;
      var $37=(($36)|0);
      _llvm_memmove_p0i8_p0i8_i32($30, $35, $37, 1, 0);
      var $38=(($3+1052)|0);
      var $39=(($38)|0);
      var $40=$2;
      var $41=(($39+($40<<3))|0);
      var $42=$41;
      var $43=(($3+1052)|0);
      var $44=(($43)|0);
      var $45=$2;
      var $46=(($44+($45<<3))|0);
      var $47=(($46+8)|0);
      var $48=$47;
      var $49=$moving;
      var $50=((($49<<3))|0);
      _llvm_memmove_p0i8_p0i8_i32($42, $48, $50, 1, 0);
      __label__ = 2; break;
    case 2: // $51
      var $52=$3;
      var $53=(($52+28)|0);
      var $54=HEAP8[($53)];
      var $55=(($54-1)&255);
      HEAP8[($53)]=$55;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read14remove_subunitEi["X"]=1;

function __ZN8delegateIFtR13address_spacejtEEC1I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFtR13address_spacejtEEC2I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read12read_stub_16ER13address_spacejt($this, $space, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $result;
      var $index;
      var $si;
      var $submask;
      var $aoffset;
      var $val;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$mask;
      var $5=$1;
      var $6=$2;
      var $7=__ZNK13address_space5unmapEv($6);
      var $7$0=$7[0];
      var $7$1=$7[1];
      var $8=$5;
      var $9=(($8+160)|0);
      var $st$21$0=(($9)|0);
      var $10$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$21$1)>>2)];
      var $11$0=$7$0 & $10$0;
      var $11$1=$7$1 & $10$1;
      var $12$0=$11$0;
      var $12=$12$0&65535;
      $result=$12;
      $index=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$index;
      var $15=$5;
      var $16=(($15+28)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($14)|0) < (($18)|0);
      if ($19) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $20
      var $21=$index;
      var $22=$5;
      var $23=(($22+32)|0);
      var $24=(($23+($21<<4))|0);
      $si=$24;
      var $25=$4;
      var $26=(($25)&65535);
      var $27=$si;
      var $28=(($27+13)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$26 >> (($30)|0);
      var $32=$si;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$31 & $34;
      $submask=$35;
      var $36=$submask;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $38
      var $39=$3;
      var $40=$si;
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($39*$42)|0);
      var $44=$si;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($43+$46)|0);
      $aoffset=$47;
      var $48=$index;
      var $49=(($5+1036)|0);
      var $50=(($49+$48)|0);
      var $51=HEAP8[($50)];
      var $52=(($51) & 1);
      if ($52) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $53
      var $54=$index;
      var $55=(($5+1052)|0);
      var $56=(($55+($54<<3))|0);
      var $57=(($56+4)|0);
      var $58=$57;
      var $59=HEAP32[(($58)>>2)];
      var $60=$index;
      var $61=(($5+1052)|0);
      var $62=(($61+($60<<3))|0);
      var $63=(($62)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      var $66=$aoffset;
      var $67=FUNCTION_TABLE[$59]($65, $66);
      $val=$67;
      __label__ = 6; break;
    case 5: // $68
      var $69=$index;
      var $70=(($5+264)|0);
      var $71=(($70+$69*96)|0);
      var $72=(($71)|0);
      var $73=$72;
      var $74=$2;
      var $75=$aoffset;
      var $76=$submask;
      var $77=(($76) & 255);
      var $78=__ZNK13delegate_baseIhR13address_spacejh8_noparamEclES1_jh($73, $74, $75, $77);
      $val=$78;
      __label__ = 6; break;
    case 6: // $79
      var $80=$val;
      var $81=(($80)&255);
      var $82=$si;
      var $83=(($82+13)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$81 << $85;
      var $87=$result;
      var $88=(($87)&65535);
      var $89=$88 | $86;
      var $90=(($89) & 65535);
      $result=$90;
      __label__ = 7; break;
    case 7: // $91
      __label__ = 8; break;
    case 8: // $92
      var $93=$index;
      var $94=(($93+1)|0);
      $index=$94;
      __label__ = 1; break;
    case 9: // $95
      var $96=$result;
      ;
      return $96;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12read_stub_16ER13address_spacejt["X"]=1;

function __ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFjR13address_spacejjEEC2I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read12read_stub_32ER13address_spacejj($this, $space, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $result;
      var $index;
      var $si;
      var $submask;
      var $aoffset;
      var $val;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$mask;
      var $5=$1;
      var $6=$2;
      var $7=__ZNK13address_space5unmapEv($6);
      var $7$0=$7[0];
      var $7$1=$7[1];
      var $8=$5;
      var $9=(($8+160)|0);
      var $st$21$0=(($9)|0);
      var $10$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$21$1)>>2)];
      var $11$0=$7$0 & $10$0;
      var $11$1=$7$1 & $10$1;
      var $12$0=$11$0;
      var $12=$12$0;
      $result=$12;
      $index=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$index;
      var $15=$5;
      var $16=(($15+28)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($14)|0) < (($18)|0);
      if ($19) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $20
      var $21=$index;
      var $22=$5;
      var $23=(($22+32)|0);
      var $24=(($23+($21<<4))|0);
      $si=$24;
      var $25=$4;
      var $26=$si;
      var $27=(($26+13)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$25 >>> (($29)>>>0);
      var $31=$si;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$30 & $33;
      $submask=$34;
      var $35=$submask;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $37
      var $38=$3;
      var $39=$si;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($38*$41)|0);
      var $43=$si;
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($42+$45)|0);
      $aoffset=$46;
      $val=0;
      var $47=$index;
      var $48=(($5+1036)|0);
      var $49=(($48+$47)|0);
      var $50=HEAP8[($49)];
      var $51=(($50) & 1);
      if ($51) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $52
      var $53=$si;
      var $54=(($53+12)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      if ($56 == 8) {
        __label__ = 5; break;
      }
      else if ($56 == 16) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 5: // $57
      var $58=$index;
      var $59=(($5+1052)|0);
      var $60=(($59+($58<<3))|0);
      var $61=(($60+4)|0);
      var $62=$61;
      var $63=HEAP32[(($62)>>2)];
      var $64=$index;
      var $65=(($5+1052)|0);
      var $66=(($65+($64<<3))|0);
      var $67=(($66)|0);
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=$aoffset;
      var $71=FUNCTION_TABLE[$63]($69, $70);
      var $72=(($71)&255);
      $val=$72;
      __label__ = 7; break;
    case 6: // $73
      var $74=$index;
      var $75=(($5+1052)|0);
      var $76=(($75+($74<<3))|0);
      var $77=(($76+4)|0);
      var $78=$77;
      var $79=HEAP32[(($78)>>2)];
      var $80=$index;
      var $81=(($5+1052)|0);
      var $82=(($81+($80<<3))|0);
      var $83=(($82)|0);
      var $84=$83;
      var $85=HEAP32[(($84)>>2)];
      var $86=$aoffset;
      var $87=$submask;
      var $88=(($87) & 65535);
      var $89=FUNCTION_TABLE[$79]($85, $86, $88);
      $val=$89;
      __label__ = 7; break;
    case 7: // $90
      __label__ = 12; break;
    case 8: // $91
      var $92=$si;
      var $93=(($92+12)|0);
      var $94=HEAPU8[($93)];
      var $95=(($94)&255);
      if ($95 == 8) {
        __label__ = 9; break;
      }
      else if ($95 == 16) {
        __label__ = 10; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 9: // $96
      var $97=$index;
      var $98=(($5+264)|0);
      var $99=(($98+$97*96)|0);
      var $100=(($99)|0);
      var $101=$100;
      var $102=$2;
      var $103=$aoffset;
      var $104=$submask;
      var $105=(($104) & 255);
      var $106=__ZNK13delegate_baseIhR13address_spacejh8_noparamEclES1_jh($101, $102, $103, $105);
      var $107=(($106)&255);
      $val=$107;
      __label__ = 11; break;
    case 10: // $108
      var $109=$index;
      var $110=(($5+264)|0);
      var $111=(($110+$109*96)|0);
      var $112=(($111+24)|0);
      var $113=$112;
      var $114=$2;
      var $115=$aoffset;
      var $116=$submask;
      var $117=(($116) & 65535);
      var $118=__ZNK13delegate_baseItR13address_spacejt8_noparamEclES1_jt($113, $114, $115, $117);
      $val=$118;
      __label__ = 11; break;
    case 11: // $119
      __label__ = 12; break;
    case 12: // $120
      var $121=$val;
      var $122=(($121)&65535);
      var $123=$si;
      var $124=(($123+13)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=$122 << $126;
      var $128=$result;
      var $129=$128 | $127;
      $result=$129;
      __label__ = 13; break;
    case 13: // $130
      __label__ = 14; break;
    case 14: // $131
      var $132=$index;
      var $133=(($132+1)|0);
      $index=$133;
      __label__ = 1; break;
    case 15: // $134
      var $135=$result;
      ;
      return $135;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12read_stub_32ER13address_spacejj["X"]=1;

function __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFyR13address_spacejyEEC2I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read12read_stub_64ER13address_spacejy($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $result=__stackBase__+8;
      var $index;
      var $si;
      var $submask;
      var $aoffset;
      var $val;
      $1=$this;
      $2=$space;
      $3=$offset;
      var $st$13$0=(($4)|0);
      HEAP32[(($st$13$0)>>2)]=$mask$0;
      var $st$13$1=(($4+4)|0);
      HEAP32[(($st$13$1)>>2)]=$mask$1;
      var $5=$1;
      var $6=$2;
      var $7=__ZNK13address_space5unmapEv($6);
      var $7$0=$7[0];
      var $7$1=$7[1];
      var $8=$5;
      var $9=(($8+160)|0);
      var $st$24$0=(($9)|0);
      var $10$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$24$1)>>2)];
      var $11$0=$7$0 & $10$0;
      var $11$1=$7$1 & $10$1;
      var $st$30$0=(($result)|0);
      HEAP32[(($st$30$0)>>2)]=$11$0;
      var $st$30$1=(($result+4)|0);
      HEAP32[(($st$30$1)>>2)]=$11$1;
      $index=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$index;
      var $14=$5;
      var $15=(($14+28)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=(($13)|0) < (($17)|0);
      if ($18) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $19
      var $20=$index;
      var $21=$5;
      var $22=(($21+32)|0);
      var $23=(($22+($20<<4))|0);
      $si=$23;
      var $st$5$0=(($4)|0);
      var $24$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($4+4)|0);
      var $24$1=HEAP32[(($st$5$1)>>2)];
      var $25=$si;
      var $26=(($25+13)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29$0=$28;
      var $29$1=0;
      var $30=Runtime.bitshift64($24$0, $24$1,"lshr",$29$0);var $30$0 = $30[0], $30$1 = $30[1];
      var $31=$si;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34$0=$33;
      var $34$1=0;
      var $35$0=$30$0 & $34$0;
      var $35$1=$30$1 & $34$1;
      var $36$0=$35$0;
      var $36=$36$0;
      $submask=$36;
      var $37=$submask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $39
      var $40=$3;
      var $41=$si;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($40*$43)|0);
      var $45=$si;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44+$47)|0);
      $aoffset=$48;
      $val=0;
      var $49=$index;
      var $50=(($5+1036)|0);
      var $51=(($50+$49)|0);
      var $52=HEAP8[($51)];
      var $53=(($52) & 1);
      if ($53) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $54
      var $55=$si;
      var $56=(($55+12)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      if ($58 == 8) {
        __label__ = 5; break;
      }
      else if ($58 == 16) {
        __label__ = 6; break;
      }
      else if ($58 == 32) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 5: // $59
      var $60=$index;
      var $61=(($5+1052)|0);
      var $62=(($61+($60<<3))|0);
      var $63=(($62+4)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      var $66=$index;
      var $67=(($5+1052)|0);
      var $68=(($67+($66<<3))|0);
      var $69=(($68)|0);
      var $70=$69;
      var $71=HEAP32[(($70)>>2)];
      var $72=$aoffset;
      var $73=FUNCTION_TABLE[$65]($71, $72);
      var $74=(($73)&255);
      $val=$74;
      __label__ = 8; break;
    case 6: // $75
      var $76=$index;
      var $77=(($5+1052)|0);
      var $78=(($77+($76<<3))|0);
      var $79=(($78+4)|0);
      var $80=$79;
      var $81=HEAP32[(($80)>>2)];
      var $82=$index;
      var $83=(($5+1052)|0);
      var $84=(($83+($82<<3))|0);
      var $85=(($84)|0);
      var $86=$85;
      var $87=HEAP32[(($86)>>2)];
      var $88=$aoffset;
      var $89=$submask;
      var $90=(($89) & 65535);
      var $91=FUNCTION_TABLE[$81]($87, $88, $90);
      var $92=(($91)&65535);
      $val=$92;
      __label__ = 8; break;
    case 7: // $93
      var $94=$index;
      var $95=(($5+1052)|0);
      var $96=(($95+($94<<3))|0);
      var $97=(($96+4)|0);
      var $98=$97;
      var $99=HEAP32[(($98)>>2)];
      var $100=$index;
      var $101=(($5+1052)|0);
      var $102=(($101+($100<<3))|0);
      var $103=(($102)|0);
      var $104=$103;
      var $105=HEAP32[(($104)>>2)];
      var $106=$aoffset;
      var $107=$submask;
      var $108=FUNCTION_TABLE[$99]($105, $106, $107);
      $val=$108;
      __label__ = 8; break;
    case 8: // $109
      __label__ = 14; break;
    case 9: // $110
      var $111=$si;
      var $112=(($111+12)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      if ($114 == 8) {
        __label__ = 10; break;
      }
      else if ($114 == 16) {
        __label__ = 11; break;
      }
      else if ($114 == 32) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 10: // $115
      var $116=$index;
      var $117=(($5+264)|0);
      var $118=(($117+$116*96)|0);
      var $119=(($118)|0);
      var $120=$119;
      var $121=$2;
      var $122=$aoffset;
      var $123=$submask;
      var $124=(($123) & 255);
      var $125=__ZNK13delegate_baseIhR13address_spacejh8_noparamEclES1_jh($120, $121, $122, $124);
      var $126=(($125)&255);
      $val=$126;
      __label__ = 13; break;
    case 11: // $127
      var $128=$index;
      var $129=(($5+264)|0);
      var $130=(($129+$128*96)|0);
      var $131=(($130+24)|0);
      var $132=$131;
      var $133=$2;
      var $134=$aoffset;
      var $135=$submask;
      var $136=(($135) & 65535);
      var $137=__ZNK13delegate_baseItR13address_spacejt8_noparamEclES1_jt($132, $133, $134, $136);
      var $138=(($137)&65535);
      $val=$138;
      __label__ = 13; break;
    case 12: // $139
      var $140=$index;
      var $141=(($5+264)|0);
      var $142=(($141+$140*96)|0);
      var $143=(($142+48)|0);
      var $144=$143;
      var $145=$2;
      var $146=$aoffset;
      var $147=$submask;
      var $148=__ZNK13delegate_baseIjR13address_spacejj8_noparamEclES1_jj($144, $145, $146, $147);
      $val=$148;
      __label__ = 13; break;
    case 13: // $149
      __label__ = 14; break;
    case 14: // $150
      var $151=$val;
      var $152$0=$151;
      var $152$1=0;
      var $153=$si;
      var $154=(($153+13)|0);
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157$0=$156;
      var $157$1=0;
      var $158=Runtime.bitshift64($152$0, $152$1,"shl",$157$0);var $158$0 = $158[0], $158$1 = $158[1];
      var $st$10$0=(($result)|0);
      var $159$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $159$1=HEAP32[(($st$10$1)>>2)];
      var $160$0=$159$0 | $158$0;
      var $160$1=$159$1 | $158$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$160$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$160$1;
      __label__ = 15; break;
    case 15: // $161
      __label__ = 16; break;
    case 16: // $162
      var $163=$index;
      var $164=(($163+1)|0);
      $index=$164;
      __label__ = 1; break;
    case 17: // $165
      var $st$0$0=(($result)|0);
      var $166$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $166$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$166$0,$166$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read12read_stub_64ER13address_spacejy["X"]=1;

function __ZN18handler_entry_read15set_legacy_funcER13address_spacePFhPS0_jEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 318, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 318, f1: 0 }.f1;
  __ZN8delegateIFhR13address_spacejhEEC1I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC1I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFhR13address_spacejhEEC2I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read16read_stub_legacyER13address_spacejh($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+1044)|0);
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($5+1044)|0);
  var $11=(($10)|0);
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=FUNCTION_TABLE[$9]($13, $14);
  ;
  return $15;
}


function __ZN18handler_entry_read15set_legacy_funcER13address_spacePFtPS0_jtEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 320, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 320, f1: 0 }.f1;
  __ZN8delegateIFtR13address_spacejtEEC1I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read16read_stub_legacyER13address_spacejt($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+1044)|0);
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($5+1044)|0);
  var $11=(($10)|0);
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=$4;
  var $16=FUNCTION_TABLE[$9]($13, $14, $15);
  ;
  return $16;
}


function __ZN18handler_entry_read15set_legacy_funcER13address_spacePFjPS0_jjEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 322, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 322, f1: 0 }.f1;
  __ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read16read_stub_legacyER13address_spacejj($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+1044)|0);
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($5+1044)|0);
  var $11=(($10)|0);
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $15=$4;
  var $16=FUNCTION_TABLE[$9]($13, $14, $15);
  ;
  return $16;
}


function __ZN18handler_entry_read15set_legacy_funcER13address_spacePFyPS0_jyEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 324, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 324, f1: 0 }.f1;
  __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read16read_stub_legacyER13address_spacejy($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$7$0=(($4)|0);
  HEAP32[(($st$7$0)>>2)]=$mask$0;
  var $st$7$1=(($4+4)|0);
  HEAP32[(($st$7$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=(($5+1044)|0);
  var $7=(($6+4)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=(($5+1044)|0);
  var $11=(($10)|0);
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=$3;
  var $st$21$0=(($4)|0);
  var $15$0=HEAP32[(($st$21$0)>>2)];
  var $st$21$1=(($4+4)|0);
  var $15$1=HEAP32[(($st$21$1)>>2)];
  var $16=FUNCTION_TABLE[$9]($13, $14, $15$0, $15$1);
  var $16$0=$16[0];
  var $16$1=$16[1];
  STACKTOP = __stackBase__;
  return [$16$0,$16$1];
}


function __ZN18handler_entry_read15set_legacy_funcER8device_tPFhPS0_jEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 318, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 318, f1: 0 }.f1;
  __ZN8delegateIFhR13address_spacejhEEC1I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK13address_space5unmapEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+36)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZN18handler_entry_read15set_legacy_funcER8device_tPFtPS0_jtEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 320, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 320, f1: 0 }.f1;
  __ZN8delegateIFtR13address_spacejtEEC1I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read15set_legacy_funcER8device_tPFjPS0_jjEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 322, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 322, f1: 0 }.f1;
  __ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read15set_legacy_funcER8device_tPFyPS0_jyEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 324, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 324, f1: 0 }.f1;
  __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN18handler_entry_read10set_ioportERK17input_port_config($this, $ioport) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+24;
      var $5=__stackBase__+32;
      var $6=__stackBase__+56;
      var $7=__stackBase__+64;
      var $8=__stackBase__+88;
      var $9=__stackBase__+96;
      var $10=__stackBase__+120;
      $1=$this;
      $2=$ioport;
      var $11=$1;
      var $12=$2;
      var $13=(($11+1032)|0);
      HEAP32[(($13)>>2)]=$12;
      var $14=$11;
      var $15=(($14+5)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=(($17)|0)==8;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=__ZNK17input_port_config3tagEv($20);
      HEAP32[(($4)>>2)]={ f0: 326, f1: 0 }.f0; HEAP32[(($4+4)>>2)]={ f0: 326, f1: 0 }.f1;
      __ZN8delegateIFhR13address_spacejhEEC1I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($3, $4, $21, $11);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE($11, $3, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 11; break;
    case 2: // $22
      var $23=$11;
      var $24=(($23+5)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=(($26)|0)==16;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$2;
      var $30=__ZNK17input_port_config3tagEv($29);
      HEAP32[(($6)>>2)]={ f0: 328, f1: 0 }.f0; HEAP32[(($6+4)>>2)]={ f0: 328, f1: 0 }.f1;
      __ZN8delegateIFtR13address_spacejtEEC1I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($5, $6, $30, $11);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE($11, $5, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      __label__ = 10; break;
    case 4: // $31
      var $32=$11;
      var $33=(($32+5)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=(($35)|0)==32;
      if ($36) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $37
      var $38=$2;
      var $39=__ZNK17input_port_config3tagEv($38);
      HEAP32[(($8)>>2)]={ f0: 330, f1: 0 }.f0; HEAP32[(($8+4)>>2)]={ f0: 330, f1: 0 }.f1;
      __ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($7, $8, $39, $11);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE($11, $7, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0);
      __label__ = 9; break;
    case 6: // $40
      var $41=$11;
      var $42=(($41+5)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==64;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      var $47=$2;
      var $48=__ZNK17input_port_config3tagEv($47);
      HEAP32[(($10)>>2)]={ f0: 332, f1: 0 }.f0; HEAP32[(($10+4)>>2)]={ f0: 332, f1: 0 }.f1;
      __ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($9, $10, $48, $11);
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      __ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE($11, $9, $$emscripten$temp$3$0, $$emscripten$temp$3$1, 0);
      __label__ = 8; break;
    case 8: // $49
      __label__ = 9; break;
    case 9: // $50
      __label__ = 10; break;
    case 10: // $51
      __label__ = 11; break;
    case 11: // $52
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_read10set_ioportERK17input_port_config["X"]=1;

function __ZN18handler_entry_read16read_stub_ioportIhEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+1032)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__Z22input_port_read_directPK17input_port_config($7);
  var $9=(($8) & 255);
  ;
  return $9;
}


function __ZN18handler_entry_read16read_stub_ioportItEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+1032)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__Z22input_port_read_directPK17input_port_config($7);
  var $9=(($8) & 65535);
  ;
  return $9;
}


function __ZN18handler_entry_read16read_stub_ioportIjEET_R13address_spacejS1_($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+1032)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__Z22input_port_read_directPK17input_port_config($7);
  ;
  return $8;
}


function __ZN18handler_entry_read16read_stub_ioportIyEET_R13address_spacejS1_($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$7$0=(($4)|0);
  HEAP32[(($st$7$0)>>2)]=$mask$0;
  var $st$7$1=(($4+4)|0);
  HEAP32[(($st$7$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=(($5+1032)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__Z22input_port_read_directPK17input_port_config($7);
  var $9$0=$8;
  var $9$1=0;
  STACKTOP = __stackBase__;
  return [$9$0,$9$1];
}


function __ZNK13delegate_baseIhR13address_spacejh8_noparamEclES1_jh($this, $p1, $p2, $p3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($5+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=FUNCTION_TABLE[$7]($9, $10, $11, $12);
  ;
  return $13;
}


function __ZNK13delegate_baseItR13address_spacejt8_noparamEclES1_jt($this, $p1, $p2, $p3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($5+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=FUNCTION_TABLE[$7]($9, $10, $11, $12);
  ;
  return $13;
}


function __ZNK13delegate_baseIjR13address_spacejj8_noparamEclES1_jj($this, $p1, $p2, $p3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($5+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=FUNCTION_TABLE[$7]($9, $10, $11, $12);
  ;
  return $13;
}


function __ZN19handler_entry_write4copyEP13handler_entry($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $wentry;
  $1=$this;
  $2=$entry;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  __ZN13handler_entry4copyEPS_($4, $5);
  var $6=$2;
  var $7=$6;
  $wentry=$7;
  var $8=(($3+168)|0);
  var $9=$wentry;
  var $10=(($9+168)|0);
  var $11=__ZN19handler_entry_write14access_handleraSERKS0_($8, $10);
  var $12=(($3+264)|0);
  var $13=(($12)|0);
  var $14=$13;
  var $15=$wentry;
  var $16=(($15+264)|0);
  var $17=(($16)|0);
  var $18=$17;
  var $19=$3;
  var $20=(($19+28)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=(($22*96)|0);
  assert($23 % 1 === 0, 'memcpy given ' + $23 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($14, $18, $23, 1);
  var $24=(($3+1036)|0);
  var $25=(($24)|0);
  var $26=$wentry;
  var $27=(($26+1036)|0);
  var $28=(($27)|0);
  var $29=$3;
  var $30=(($29+28)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=(($32)|0);
  assert($33 % 1 === 0, 'memcpy given ' + $33 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($25, $28, $33, 1);
  var $34=(($3+1052)|0);
  var $35=(($34)|0);
  var $36=$35;
  var $37=$wentry;
  var $38=(($37+1052)|0);
  var $39=(($38)|0);
  var $40=$39;
  var $41=$3;
  var $42=(($41+28)|0);
  var $43=HEAPU8[($42)];
  var $44=(($43)&255);
  var $45=((($44<<3))|0);
  assert($45 % 1 === 0, 'memcpy given ' + $45 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($36, $40, $45, 1);
  ;
  return;
}
__ZN19handler_entry_write4copyEP13handler_entry["X"]=1;

function __ZN19handler_entry_write14access_handleraSERKS0_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=(($4)|0);
  var $6=$3;
  var $7=(($6)|0);
  var $8=__ZN8delegateIFvR13address_spacejhhEEaSERKS3_($5, $7);
  var $9=(($4+24)|0);
  var $10=$3;
  var $11=(($10+24)|0);
  var $12=__ZN8delegateIFvR13address_spacejttEEaSERKS3_($9, $11);
  var $13=(($4+48)|0);
  var $14=$3;
  var $15=(($14+48)|0);
  var $16=__ZN8delegateIFvR13address_spacejjjEEaSERKS3_($13, $15);
  var $17=(($4+72)|0);
  var $18=$3;
  var $19=(($18+72)|0);
  var $20=__ZN8delegateIFvR13address_spacejyyEEaSERKS3_($17, $19);
  ;
  return $4;
}


function __ZNK19handler_entry_write4nameEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=$3;
      var $5=(($4+5)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      if ($7 == 8) {
        __label__ = 1; break;
      }
      else if ($7 == 16) {
        __label__ = 2; break;
      }
      else if ($7 == 32) {
        __label__ = 3; break;
      }
      else if ($7 == 64) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $8
      var $9=(($3+168)|0);
      var $10=(($9)|0);
      var $11=$10;
      var $12=__ZNK13delegate_baseIvR13address_spacejhhE4nameEv($11);
      $1=$12;
      __label__ = 6; break;
    case 2: // $13
      var $14=(($3+168)|0);
      var $15=(($14+24)|0);
      var $16=$15;
      var $17=__ZNK13delegate_baseIvR13address_spacejttE4nameEv($16);
      $1=$17;
      __label__ = 6; break;
    case 3: // $18
      var $19=(($3+168)|0);
      var $20=(($19+48)|0);
      var $21=$20;
      var $22=__ZNK13delegate_baseIvR13address_spacejjjE4nameEv($21);
      $1=$22;
      __label__ = 6; break;
    case 4: // $23
      var $24=(($3+168)|0);
      var $25=(($24+72)|0);
      var $26=$25;
      var $27=__ZNK13delegate_baseIvR13address_spacejyyE4nameEv($26);
      $1=$27;
      __label__ = 6; break;
    case 5: // $28
      $1=0;
      __label__ = 6; break;
    case 6: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK19handler_entry_write12subunit_nameEi($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$entry;
      var $4=$2;
      var $5=$3;
      var $6=$4;
      var $7=(($6+32)|0);
      var $8=(($7+($5<<4))|0);
      var $9=(($8+12)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      if ($11 == 8) {
        __label__ = 1; break;
      }
      else if ($11 == 16) {
        __label__ = 2; break;
      }
      else if ($11 == 32) {
        __label__ = 3; break;
      }
      else if ($11 == 64) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $12
      var $13=$3;
      var $14=(($4+264)|0);
      var $15=(($14+$13*96)|0);
      var $16=(($15)|0);
      var $17=$16;
      var $18=__ZNK13delegate_baseIvR13address_spacejhhE4nameEv($17);
      $1=$18;
      __label__ = 6; break;
    case 2: // $19
      var $20=$3;
      var $21=(($4+264)|0);
      var $22=(($21+$20*96)|0);
      var $23=(($22+24)|0);
      var $24=$23;
      var $25=__ZNK13delegate_baseIvR13address_spacejttE4nameEv($24);
      $1=$25;
      __label__ = 6; break;
    case 3: // $26
      var $27=$3;
      var $28=(($4+264)|0);
      var $29=(($28+$27*96)|0);
      var $30=(($29+48)|0);
      var $31=$30;
      var $32=__ZNK13delegate_baseIvR13address_spacejjjE4nameEv($31);
      $1=$32;
      __label__ = 6; break;
    case 4: // $33
      var $34=$3;
      var $35=(($4+264)|0);
      var $36=(($35+$34*96)|0);
      var $37=(($36+72)|0);
      var $38=$37;
      var $39=__ZNK13delegate_baseIvR13address_spacejyyE4nameEv($38);
      $1=$39;
      __label__ = 6; break;
    case 5: // $40
      $1=0;
      __label__ = 6; break;
    case 6: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK19handler_entry_write12subunit_nameEi["X"]=1;

function __ZN19handler_entry_write14remove_subunitEi($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $moving;
      $1=$this;
      $2=$entry;
      var $3=$1;
      var $4=$3;
      var $5=(($4+28)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=$2;
      var $9=(($7-$8)|0);
      var $10=(($9-1)|0);
      $moving=$10;
      var $11=$moving;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+264)|0);
      var $15=(($14)|0);
      var $16=$2;
      var $17=(($15+$16*96)|0);
      var $18=$17;
      var $19=(($3+264)|0);
      var $20=(($19)|0);
      var $21=$2;
      var $22=(($20+$21*96)|0);
      var $23=(($22+96)|0);
      var $24=$23;
      var $25=$moving;
      var $26=(($25*96)|0);
      _llvm_memmove_p0i8_p0i8_i32($18, $24, $26, 1, 0);
      var $27=(($3+1036)|0);
      var $28=(($27)|0);
      var $29=$2;
      var $30=(($28+$29)|0);
      var $31=(($3+1036)|0);
      var $32=(($31)|0);
      var $33=$2;
      var $34=(($32+$33)|0);
      var $35=(($34+1)|0);
      var $36=$moving;
      var $37=(($36)|0);
      _llvm_memmove_p0i8_p0i8_i32($30, $35, $37, 1, 0);
      var $38=(($3+1052)|0);
      var $39=(($38)|0);
      var $40=$2;
      var $41=(($39+($40<<3))|0);
      var $42=$41;
      var $43=(($3+1052)|0);
      var $44=(($43)|0);
      var $45=$2;
      var $46=(($44+($45<<3))|0);
      var $47=(($46+8)|0);
      var $48=$47;
      var $49=$moving;
      var $50=((($49<<3))|0);
      _llvm_memmove_p0i8_p0i8_i32($42, $48, $50, 1, 0);
      __label__ = 2; break;
    case 2: // $51
      var $52=$3;
      var $53=(($52+28)|0);
      var $54=HEAP8[($53)];
      var $55=(($54-1)&255);
      HEAP8[($53)]=$55;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write14remove_subunitEi["X"]=1;

function __ZN8delegateIFvR13address_spacejttEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejttEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write13write_stub_16ER13address_spacejtt($this, $space, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $index;
      var $si;
      var $submask;
      var $aoffset;
      var $adata;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$data;
      $5=$mask;
      var $6=$1;
      $index=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$index;
      var $9=$6;
      var $10=(($9+28)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($8)|0) < (($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $14
      var $15=$index;
      var $16=$6;
      var $17=(($16+32)|0);
      var $18=(($17+($15<<4))|0);
      $si=$18;
      var $19=$5;
      var $20=(($19)&65535);
      var $21=$si;
      var $22=(($21+13)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$20 >> (($24)|0);
      var $26=$si;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$25 & $28;
      $submask=$29;
      var $30=$submask;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $32
      var $33=$3;
      var $34=$si;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($33*$36)|0);
      var $38=$si;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($37+$40)|0);
      $aoffset=$41;
      var $42=$4;
      var $43=(($42)&65535);
      var $44=$si;
      var $45=(($44+13)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=$43 >> (($47)|0);
      var $49=(($48) & 255);
      $adata=$49;
      var $50=$index;
      var $51=(($6+1036)|0);
      var $52=(($51+$50)|0);
      var $53=HEAP8[($52)];
      var $54=(($53) & 1);
      if ($54) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $55
      var $56=$index;
      var $57=(($6+1052)|0);
      var $58=(($57+($56<<3))|0);
      var $59=(($58+4)|0);
      var $60=$59;
      var $61=HEAP32[(($60)>>2)];
      var $62=$index;
      var $63=(($6+1052)|0);
      var $64=(($63+($62<<3))|0);
      var $65=(($64)|0);
      var $66=$65;
      var $67=HEAP32[(($66)>>2)];
      var $68=$aoffset;
      var $69=$adata;
      FUNCTION_TABLE[$61]($67, $68, $69);
      __label__ = 6; break;
    case 5: // $70
      var $71=$index;
      var $72=(($6+264)|0);
      var $73=(($72+$71*96)|0);
      var $74=(($73)|0);
      var $75=$74;
      var $76=$2;
      var $77=$aoffset;
      var $78=$adata;
      var $79=$submask;
      var $80=(($79) & 255);
      __ZNK13delegate_baseIvR13address_spacejhhEclES1_jhh($75, $76, $77, $78, $80);
      __label__ = 6; break;
    case 6: // $81
      __label__ = 7; break;
    case 7: // $82
      __label__ = 8; break;
    case 8: // $83
      var $84=$index;
      var $85=(($84+1)|0);
      $index=$85;
      __label__ = 1; break;
    case 9: // $86
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write13write_stub_16ER13address_spacejtt["X"]=1;

function __ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejjjEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write13write_stub_32ER13address_spacejjj($this, $space, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $index;
      var $si;
      var $submask;
      var $aoffset;
      var $adata;
      $1=$this;
      $2=$space;
      $3=$offset;
      $4=$data;
      $5=$mask;
      var $6=$1;
      $index=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$index;
      var $9=$6;
      var $10=(($9+28)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($8)|0) < (($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $14
      var $15=$index;
      var $16=$6;
      var $17=(($16+32)|0);
      var $18=(($17+($15<<4))|0);
      $si=$18;
      var $19=$5;
      var $20=$si;
      var $21=(($20+13)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$19 >>> (($23)>>>0);
      var $25=$si;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$24 & $27;
      $submask=$28;
      var $29=$submask;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $31
      var $32=$3;
      var $33=$si;
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32*$35)|0);
      var $37=$si;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($36+$39)|0);
      $aoffset=$40;
      var $41=$4;
      var $42=$si;
      var $43=(($42+13)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$41 >>> (($45)>>>0);
      var $47=(($46) & 65535);
      $adata=$47;
      var $48=$index;
      var $49=(($6+1036)|0);
      var $50=(($49+$48)|0);
      var $51=HEAP8[($50)];
      var $52=(($51) & 1);
      if ($52) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $53
      var $54=$si;
      var $55=(($54+12)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      if ($57 == 8) {
        __label__ = 5; break;
      }
      else if ($57 == 16) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 5: // $58
      var $59=$index;
      var $60=(($6+1052)|0);
      var $61=(($60+($59<<3))|0);
      var $62=(($61+4)|0);
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      var $65=$index;
      var $66=(($6+1052)|0);
      var $67=(($66+($65<<3))|0);
      var $68=(($67)|0);
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=$aoffset;
      var $72=$adata;
      var $73=(($72) & 255);
      FUNCTION_TABLE[$64]($70, $71, $73);
      __label__ = 7; break;
    case 6: // $74
      var $75=$index;
      var $76=(($6+1052)|0);
      var $77=(($76+($75<<3))|0);
      var $78=(($77+4)|0);
      var $79=$78;
      var $80=HEAP32[(($79)>>2)];
      var $81=$index;
      var $82=(($6+1052)|0);
      var $83=(($82+($81<<3))|0);
      var $84=(($83)|0);
      var $85=$84;
      var $86=HEAP32[(($85)>>2)];
      var $87=$aoffset;
      var $88=$adata;
      var $89=$submask;
      var $90=(($89) & 65535);
      FUNCTION_TABLE[$80]($86, $87, $88, $90);
      __label__ = 7; break;
    case 7: // $91
      __label__ = 12; break;
    case 8: // $92
      var $93=$si;
      var $94=(($93+12)|0);
      var $95=HEAPU8[($94)];
      var $96=(($95)&255);
      if ($96 == 8) {
        __label__ = 9; break;
      }
      else if ($96 == 16) {
        __label__ = 10; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 9: // $97
      var $98=$index;
      var $99=(($6+264)|0);
      var $100=(($99+$98*96)|0);
      var $101=(($100)|0);
      var $102=$101;
      var $103=$2;
      var $104=$aoffset;
      var $105=$adata;
      var $106=(($105) & 255);
      var $107=$submask;
      var $108=(($107) & 255);
      __ZNK13delegate_baseIvR13address_spacejhhEclES1_jhh($102, $103, $104, $106, $108);
      __label__ = 11; break;
    case 10: // $109
      var $110=$index;
      var $111=(($6+264)|0);
      var $112=(($111+$110*96)|0);
      var $113=(($112+24)|0);
      var $114=$113;
      var $115=$2;
      var $116=$aoffset;
      var $117=$adata;
      var $118=$submask;
      var $119=(($118) & 65535);
      __ZNK13delegate_baseIvR13address_spacejttEclES1_jtt($114, $115, $116, $117, $119);
      __label__ = 11; break;
    case 11: // $120
      __label__ = 12; break;
    case 12: // $121
      __label__ = 13; break;
    case 13: // $122
      __label__ = 14; break;
    case 14: // $123
      var $124=$index;
      var $125=(($124+1)|0);
      $index=$125;
      __label__ = 1; break;
    case 15: // $126
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write13write_stub_32ER13address_spacejjj["X"]=1;

function __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejyyEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write13write_stub_64ER13address_spacejyy($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+8;
      var $index;
      var $si;
      var $submask;
      var $aoffset;
      var $adata;
      $1=$this;
      $2=$space;
      $3=$offset;
      var $st$13$0=(($4)|0);
      HEAP32[(($st$13$0)>>2)]=$data$0;
      var $st$13$1=(($4+4)|0);
      HEAP32[(($st$13$1)>>2)]=$data$1;
      var $st$17$0=(($5)|0);
      HEAP32[(($st$17$0)>>2)]=$mask$0;
      var $st$17$1=(($5+4)|0);
      HEAP32[(($st$17$1)>>2)]=$mask$1;
      var $6=$1;
      $index=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$index;
      var $9=$6;
      var $10=(($9+28)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($8)|0) < (($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $14
      var $15=$index;
      var $16=$6;
      var $17=(($16+32)|0);
      var $18=(($17+($15<<4))|0);
      $si=$18;
      var $st$5$0=(($5)|0);
      var $19$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($5+4)|0);
      var $19$1=HEAP32[(($st$5$1)>>2)];
      var $20=$si;
      var $21=(($20+13)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($19$0, $19$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $26=$si;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29$0=$28;
      var $29$1=0;
      var $30$0=$25$0 & $29$0;
      var $30$1=$25$1 & $29$1;
      var $31$0=$30$0;
      var $31=$31$0;
      $submask=$31;
      var $32=$submask;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $34
      var $35=$3;
      var $36=$si;
      var $37=(($36+8)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($35*$38)|0);
      var $40=$si;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($39+$42)|0);
      $aoffset=$43;
      var $st$10$0=(($4)|0);
      var $44$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($4+4)|0);
      var $44$1=HEAP32[(($st$10$1)>>2)];
      var $45=$si;
      var $46=(($45+13)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($44$0, $44$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $51$0=$50$0;
      var $51=$51$0;
      $adata=$51;
      var $52=$index;
      var $53=(($6+1036)|0);
      var $54=(($53+$52)|0);
      var $55=HEAP8[($54)];
      var $56=(($55) & 1);
      if ($56) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $57
      var $58=$si;
      var $59=(($58+12)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      if ($61 == 8) {
        __label__ = 5; break;
      }
      else if ($61 == 16) {
        __label__ = 6; break;
      }
      else if ($61 == 32) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 5: // $62
      var $63=$index;
      var $64=(($6+1052)|0);
      var $65=(($64+($63<<3))|0);
      var $66=(($65+4)|0);
      var $67=$66;
      var $68=HEAP32[(($67)>>2)];
      var $69=$index;
      var $70=(($6+1052)|0);
      var $71=(($70+($69<<3))|0);
      var $72=(($71)|0);
      var $73=$72;
      var $74=HEAP32[(($73)>>2)];
      var $75=$aoffset;
      var $76=$adata;
      var $77=(($76) & 255);
      FUNCTION_TABLE[$68]($74, $75, $77);
      __label__ = 8; break;
    case 6: // $78
      var $79=$index;
      var $80=(($6+1052)|0);
      var $81=(($80+($79<<3))|0);
      var $82=(($81+4)|0);
      var $83=$82;
      var $84=HEAP32[(($83)>>2)];
      var $85=$index;
      var $86=(($6+1052)|0);
      var $87=(($86+($85<<3))|0);
      var $88=(($87)|0);
      var $89=$88;
      var $90=HEAP32[(($89)>>2)];
      var $91=$aoffset;
      var $92=$adata;
      var $93=(($92) & 65535);
      var $94=$submask;
      var $95=(($94) & 65535);
      FUNCTION_TABLE[$84]($90, $91, $93, $95);
      __label__ = 8; break;
    case 7: // $96
      var $97=$index;
      var $98=(($6+1052)|0);
      var $99=(($98+($97<<3))|0);
      var $100=(($99+4)|0);
      var $101=$100;
      var $102=HEAP32[(($101)>>2)];
      var $103=$index;
      var $104=(($6+1052)|0);
      var $105=(($104+($103<<3))|0);
      var $106=(($105)|0);
      var $107=$106;
      var $108=HEAP32[(($107)>>2)];
      var $109=$aoffset;
      var $110=$adata;
      var $111=$submask;
      FUNCTION_TABLE[$102]($108, $109, $110, $111);
      __label__ = 8; break;
    case 8: // $112
      __label__ = 14; break;
    case 9: // $113
      var $114=$si;
      var $115=(($114+12)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      if ($117 == 8) {
        __label__ = 10; break;
      }
      else if ($117 == 16) {
        __label__ = 11; break;
      }
      else if ($117 == 32) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 10: // $118
      var $119=$index;
      var $120=(($6+264)|0);
      var $121=(($120+$119*96)|0);
      var $122=(($121)|0);
      var $123=$122;
      var $124=$2;
      var $125=$aoffset;
      var $126=$adata;
      var $127=(($126) & 255);
      var $128=$submask;
      var $129=(($128) & 255);
      __ZNK13delegate_baseIvR13address_spacejhhEclES1_jhh($123, $124, $125, $127, $129);
      __label__ = 13; break;
    case 11: // $130
      var $131=$index;
      var $132=(($6+264)|0);
      var $133=(($132+$131*96)|0);
      var $134=(($133+24)|0);
      var $135=$134;
      var $136=$2;
      var $137=$aoffset;
      var $138=$adata;
      var $139=(($138) & 65535);
      var $140=$submask;
      var $141=(($140) & 65535);
      __ZNK13delegate_baseIvR13address_spacejttEclES1_jtt($135, $136, $137, $139, $141);
      __label__ = 13; break;
    case 12: // $142
      var $143=$index;
      var $144=(($6+264)|0);
      var $145=(($144+$143*96)|0);
      var $146=(($145+48)|0);
      var $147=$146;
      var $148=$2;
      var $149=$aoffset;
      var $150=$adata;
      var $151=$submask;
      __ZNK13delegate_baseIvR13address_spacejjjEclES1_jjj($147, $148, $149, $150, $151);
      __label__ = 13; break;
    case 13: // $152
      __label__ = 14; break;
    case 14: // $153
      __label__ = 15; break;
    case 15: // $154
      __label__ = 16; break;
    case 16: // $155
      var $156=$index;
      var $157=(($156+1)|0);
      $index=$157;
      __label__ = 1; break;
    case 17: // $158
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write13write_stub_64ER13address_spacejyy["X"]=1;

function __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jhEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 334, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 334, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejhhEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13address_spacejhhEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write17write_stub_legacyER13address_spacejhh($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+1044)|0);
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=(($6+1044)|0);
  var $12=(($11)|0);
  var $13=$12;
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=$4;
  FUNCTION_TABLE[$10]($14, $15, $16);
  ;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jttEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 336, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 336, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejttEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write17write_stub_legacyER13address_spacejtt($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+1044)|0);
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=(($6+1044)|0);
  var $12=(($11)|0);
  var $13=$12;
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=$4;
  var $17=$5;
  FUNCTION_TABLE[$10]($14, $15, $16, $17);
  ;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jjjEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 338, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 338, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write17write_stub_legacyER13address_spacejjj($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+1044)|0);
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=(($6+1044)|0);
  var $12=(($11)|0);
  var $13=$12;
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $16=$4;
  var $17=$5;
  FUNCTION_TABLE[$10]($14, $15, $16, $17);
  ;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jyyEPKcy($this, $space, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$space;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 340, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 340, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write17write_stub_legacyER13address_spacejyy($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$data$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$data$1;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $6=$1;
  var $7=(($6+1044)|0);
  var $8=(($7+4)|0);
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=(($6+1044)|0);
  var $12=(($11)|0);
  var $13=$12;
  var $14=HEAP32[(($13)>>2)];
  var $15=$3;
  var $st$26$0=(($4)|0);
  var $16$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $16$1=HEAP32[(($st$26$1)>>2)];
  var $st$30$0=(($5)|0);
  var $17$0=HEAP32[(($st$30$0)>>2)];
  var $st$30$1=(($5+4)|0);
  var $17$1=HEAP32[(($st$30$1)>>2)];
  FUNCTION_TABLE[$10]($14, $15, $16$0, $16$1, $17$0, $17$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jhEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 334, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 334, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejhhEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jttEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 336, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 336, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejttEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jjjEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 338, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 338, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jyyEPKcy($this, $device, $func, $name, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $info=__stackBase__+8;
  var $6=__stackBase__+16;
  var $7=__stackBase__+40;
  $1=$this;
  $2=$device;
  $3=$func;
  $4=$name;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $8=$1;
  var $9=$3;
  var $10=(($info+4)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$9;
  var $12=$2;
  var $13=(($info)|0);
  var $14=$13;
  HEAP32[(($14)>>2)]=$12;
  var $15=$4;
  HEAP32[(($7)>>2)]={ f0: 340, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 340, f1: 0 }.f1;
  __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($6, $7, $15, $8);
  var $st$28$0=(($5)|0);
  var $16$0=HEAP32[(($st$28$0)>>2)];
  var $st$28$1=(($5+4)|0);
  var $16$1=HEAP32[(($st$28$1)>>2)];
  __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($8, $6, $16$0, $16$1, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_write10set_ioportERK17input_port_config($this, $ioport) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+24;
      var $5=__stackBase__+32;
      var $6=__stackBase__+56;
      var $7=__stackBase__+64;
      var $8=__stackBase__+88;
      var $9=__stackBase__+96;
      var $10=__stackBase__+120;
      $1=$this;
      $2=$ioport;
      var $11=$1;
      var $12=$2;
      var $13=(($11+1032)|0);
      HEAP32[(($13)>>2)]=$12;
      var $14=$11;
      var $15=(($14+5)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=(($17)|0)==8;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=__ZNK17input_port_config3tagEv($20);
      HEAP32[(($4)>>2)]={ f0: 342, f1: 0 }.f0; HEAP32[(($4+4)>>2)]={ f0: 342, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejhhEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($3, $4, $21, $11);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE($11, $3, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      __label__ = 11; break;
    case 2: // $22
      var $23=$11;
      var $24=(($23+5)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=(($26)|0)==16;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$2;
      var $30=__ZNK17input_port_config3tagEv($29);
      HEAP32[(($6)>>2)]={ f0: 344, f1: 0 }.f0; HEAP32[(($6+4)>>2)]={ f0: 344, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejttEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($5, $6, $30, $11);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE($11, $5, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      __label__ = 10; break;
    case 4: // $31
      var $32=$11;
      var $33=(($32+5)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=(($35)|0)==32;
      if ($36) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $37
      var $38=$2;
      var $39=__ZNK17input_port_config3tagEv($38);
      HEAP32[(($8)>>2)]={ f0: 346, f1: 0 }.f0; HEAP32[(($8+4)>>2)]={ f0: 346, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($7, $8, $39, $11);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE($11, $7, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0);
      __label__ = 9; break;
    case 6: // $40
      var $41=$11;
      var $42=(($41+5)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==64;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      var $47=$2;
      var $48=__ZNK17input_port_config3tagEv($47);
      HEAP32[(($10)>>2)]={ f0: 348, f1: 0 }.f0; HEAP32[(($10+4)>>2)]={ f0: 348, f1: 0 }.f1;
      __ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($9, $10, $48, $11);
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      __ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE($11, $9, $$emscripten$temp$3$0, $$emscripten$temp$3$1, 0);
      __label__ = 8; break;
    case 8: // $49
      __label__ = 9; break;
    case 9: // $50
      __label__ = 10; break;
    case 10: // $51
      __label__ = 11; break;
    case 11: // $52
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_write10set_ioportERK17input_port_config["X"]=1;

function __ZN19handler_entry_write17write_stub_ioportIhEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+1032)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$4;
  var $10=(($9)&255);
  var $11=$5;
  var $12=(($11)&255);
  __Z23input_port_write_directPK17input_port_configjj($8, $10, $12);
  ;
  return;
}


function __ZN19handler_entry_write17write_stub_ioportItEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+1032)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$4;
  var $10=(($9)&65535);
  var $11=$5;
  var $12=(($11)&65535);
  __Z23input_port_write_directPK17input_port_configjj($8, $10, $12);
  ;
  return;
}


function __ZN19handler_entry_write17write_stub_ioportIjEEvR13address_spacejT_S3_($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+1032)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$4;
  var $10=$5;
  __Z23input_port_write_directPK17input_port_configjj($8, $9, $10);
  ;
  return;
}


function __ZN19handler_entry_write17write_stub_ioportIyEEvR13address_spacejT_S3_($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$data$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$data$1;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $6=$1;
  var $7=(($6+1032)|0);
  var $8=HEAP32[(($7)>>2)];
  var $st$19$0=(($4)|0);
  var $9$0=HEAP32[(($st$19$0)>>2)];
  var $st$19$1=(($4+4)|0);
  var $9$1=HEAP32[(($st$19$1)>>2)];
  var $10$0=$9$0;
  var $10=$10$0;
  var $st$25$0=(($5)|0);
  var $11$0=HEAP32[(($st$25$0)>>2)];
  var $st$25$1=(($5+4)|0);
  var $11$1=HEAP32[(($st$25$1)>>2)];
  var $12$0=$11$0;
  var $12=$12$0;
  __Z23input_port_write_directPK17input_port_configjj($8, $10, $12);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK13delegate_baseIvR13address_spacejhhEclES1_jhh($this, $p1, $p2, $p3, $p4) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  $5=$p4;
  var $6=$1;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  FUNCTION_TABLE[$8]($10, $11, $12, $13, $14);
  ;
  return;
}


function __ZNK13delegate_baseIvR13address_spacejttEclES1_jtt($this, $p1, $p2, $p3, $p4) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  $5=$p4;
  var $6=$1;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  FUNCTION_TABLE[$8]($10, $11, $12, $13, $14);
  ;
  return;
}


function __ZNK13delegate_baseIvR13address_spacejjjEclES1_jjj($this, $p1, $p2, $p3, $p4) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$p1;
  $3=$p2;
  $4=$p3;
  $5=$p4;
  var $6=$1;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  FUNCTION_TABLE[$8]($10, $11, $12, $13, $14);
  ;
  return;
}


function __ZN18handler_entry_readD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18handler_entry_readD2Ev($2);
  ;
  return;
}


function __ZN19handler_entry_writeD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19handler_entry_writeD2Ev($2);
  ;
  return;
}


function __ZN18handler_entry_readD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_readD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_readD0Ev["X"]=1;

function __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejhhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejyyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejjjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejttEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM18handler_entry_readFhR13address_spacejhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM18handler_entry_readFyR13address_spacejyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM18handler_entry_readFjR13address_spacejjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejhhEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejhhEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejhhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=350;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejhhE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejhhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejhhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19handler_entry_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejyyEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejyyEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejyyEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=352;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejyyE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejyyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejyyEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19handler_entry_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvR13address_spacejyyE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejjjEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejjjEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejjjEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=354;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejjjE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejjjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejjjEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19handler_entry_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvR13address_spacejjjE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejttEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejttEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejttEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=356;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejttE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejttEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejttEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19handler_entry_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvR13address_spacejttE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhR13address_spacejhEEC2I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIhR13address_spacejh8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18handler_entry_readFhR13address_spacejhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=358;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIhR13address_spacejh8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18handler_entry_readFhR13address_spacejhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18handler_entry_readFhR13address_spacejhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18handler_entry_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFyR13address_spacejyEEC2I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIyR13address_spacejy8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_yS1_jyS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_yS1_jyS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18handler_entry_readFyR13address_spacejyEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=360;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIyR13address_spacejy8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18handler_entry_readFyR13address_spacejyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18handler_entry_readFyR13address_spacejyEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18handler_entry_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFjR13address_spacejjEEC2I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIjR13address_spacejj8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_jS1_jjS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_jS1_jjS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18handler_entry_readFjR13address_spacejjEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=362;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIjR13address_spacejj8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18handler_entry_readFjR13address_spacejjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18handler_entry_readFjR13address_spacejjEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18handler_entry_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19handler_entry_writeD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_writeD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_writeD0Ev["X"]=1;

function __ZN21delegate_internal_mfpC2IM18handler_entry_readFtR13address_spacejtEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11memory_bank14bank_referenceEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN11memory_bank14bank_referenceEE6detachERS1_["X"]=1;

function __ZN11simple_listIN11memory_bank14bank_referenceEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN11memory_bank14bank_referenceEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFtR13address_spacejtEEC2I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseItR13address_spacejt8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_tS1_jtS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_tS1_jtS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18handler_entry_readFtR13address_spacejtEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=364;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseItR13address_spacejt8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18handler_entry_readFtR13address_spacejtEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18handler_entry_readFtR13address_spacejtEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18handler_entry_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseItR13address_spacejt8_noparamE4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN11memory_bank14bank_referenceEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN11memory_bank14bank_referenceEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN11memory_bank14bank_referenceEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 12);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN11memory_bank14bank_referenceEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN11memory_bank14bank_referenceEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN11memory_bank14bank_referenceEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN11memory_bank14bank_referenceEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN11memory_bank14bank_referenceEE+8)|0);
  __ZN11simple_listIN11memory_bank14bank_referenceEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN11memory_bank14bank_referenceEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN11memory_bank14bank_referenceEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11memory_bank14bank_referenceEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN11memory_bank14bank_referenceEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 12);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN16direct_read_data12direct_rangeEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN16direct_read_data12direct_rangeEE+8)|0);
  __ZN11simple_listIN16direct_read_data12direct_rangeEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN16direct_read_data12direct_rangeEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN16direct_read_data12direct_rangeEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8delegateIFjR16direct_read_datajEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIjR16direct_read_dataj8_noparamS2_EC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIjR16direct_read_dataj8_noparamS2_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN20resource_pool_objectIN11memory_bank14bank_referenceEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN11memory_bank14bank_referenceEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN11memory_bank14bank_referenceEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN11memory_bank14bank_referenceEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN11memory_bank14bank_referenceEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11memory_bank14bank_referenceEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11memory_bank14bank_referenceEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN11memory_bank14bank_referenceEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN16direct_read_data12direct_rangeEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN16direct_read_data12direct_rangeEED0Ev["X"]=1;

function __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejyyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejjjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejttEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejhhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM18address_table_readFyR13address_spacejyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM18address_table_readFjR13address_spacejjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM18address_table_readFtR13address_spacejtEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN16direct_read_data12direct_rangeEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN16direct_read_data12direct_rangeEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK13address_space15debugger_accessEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+48)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK13address_space9addrcharsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+60)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZN8delegateIFvR13address_spacejyyEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejyyEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejyyEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=366;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejyyE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejyyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejyyEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19address_table_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejjjEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejjjEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejjjEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=368;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejjjE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejjjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejjjEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19address_table_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejttEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejttEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejttEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=370;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejttE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejttEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejttEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19address_table_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvR13address_spacejhhEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13address_spacejhhEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejhhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=372;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13address_spacejhhE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejhhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejhhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI19address_table_write, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI19handler_entry_writeEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI19handler_entry_writeEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI19handler_entry_writeEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1116);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI19handler_entry_writeE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI19handler_entry_writeED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI19handler_entry_writeED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEC2I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIyR13address_spacejy8_noparamEC2I18address_table_readEEN15delegate_traitsIT_yS1_jyS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamEC2I18address_table_readEEN15delegate_traitsIT_yS1_jyS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18address_table_readFyR13address_spacejyEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=374;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIyR13address_spacejy8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18address_table_readFyR13address_spacejyEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18address_table_readFyR13address_spacejyEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18address_table_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFjR13address_spacejjEEC2I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIjR13address_spacejj8_noparamEC2I18address_table_readEEN15delegate_traitsIT_jS1_jjS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamEC2I18address_table_readEEN15delegate_traitsIT_jS1_jjS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18address_table_readFjR13address_spacejjEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=376;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIjR13address_spacejj8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18address_table_readFjR13address_spacejjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18address_table_readFjR13address_spacejjEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18address_table_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFtR13address_spacejtEEC2I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseItR13address_spacejt8_noparamEC2I18address_table_readEEN15delegate_traitsIT_tS1_jtS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamEC2I18address_table_readEEN15delegate_traitsIT_tS1_jtS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18address_table_readFtR13address_spacejtEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=378;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseItR13address_spacejt8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18address_table_readFtR13address_spacejtEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18address_table_readFtR13address_spacejtEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18address_table_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhR13address_spacejhEEC2I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIhR13address_spacejh8_noparamEC2I18address_table_readEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI19handler_entry_writeED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19handler_entry_writeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI19handler_entry_writeED0Ev["X"]=1;

function __ZN20resource_pool_objectI19handler_entry_writeED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI19handler_entry_writeE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}

// WARNING: content after a branch in a label, line: 375163
// WARNING: content after a branch in a label, line: 375165
// WARNING: content after a branch in a label, line: 375166
// WARNING: content after a branch in a label, line: 375167
// WARNING: content after a branch in a label, line: 375168
// WARNING: content after a branch in a label, line: 375169

function __ZN21delegate_internal_mfpC2IM18address_table_readFhR13address_spacejhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC2EPKNS_11__list_nodeIS2_S3_EE($this, $__p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__p;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  ;
  return;
}


function __ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC2ESC_($this, $__p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__p;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  ;
  return;
}


function __ZNSt3__121__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPKNS_11__tree_nodeIS8_PvEEiEC2ENS_15__tree_iteratorIS8_PSB_iEE($this, $__p) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__p; $__p = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__p)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=(($__p)|0);
  var $5=HEAP32[(($4)>>2)];
  HEAP32[(($3)>>2)]=$5;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC2EPNS_11__list_nodeIS2_S3_EE($this, $__p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__p;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  ;
  return;
}


function __ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC2ENS_15__list_iteratorIS2_S3_EE($this, $__p) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__p; $__p = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__p)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=(($__p)|0);
  var $5=HEAP32[(($4)>>2)];
  HEAP32[(($3)>>2)]=$5;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_($this, $__parent, $__k) {
  var __stackBase__  = STACKTOP; STACKTOP += 172; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41;
      var $42;
      var $43;
      var $44;
      var $__nd;
      var $45=__stackBase__+160;
      var $46=__stackBase__+164;
      var $47=__stackBase__+168;
      $42=$this;
      $43=$__parent;
      $44=$__k;
      var $48=$42;
      var $49=(($48)|0);
      var $50=$40;
      HEAP32[(($40)>>2)]=$49;
      var $51=HEAP32[(($40)>>2)];
      var $52=$39;
      HEAP32[(($39)>>2)]=$51;
      var $53=HEAP32[(($39)>>2)];
      var $54=(($53+4)|0);
      var $55=$38;
      HEAP32[(($38)>>2)]=$54;
      var $56=HEAP32[(($38)>>2)];
      var $57=$56;
      var $58=$37;
      HEAP32[(($37)>>2)]=$57;
      var $59=HEAP32[(($37)>>2)];
      var $60=(($59)|0);
      var $61=$37;
      var $62=$38;
      var $63=$36;
      HEAP32[(($36)>>2)]=$60;
      var $64=HEAP32[(($36)>>2)];
      var $65=$35;
      HEAP32[(($35)>>2)]=$64;
      var $66=HEAP32[(($35)>>2)];
      var $67=$66;
      var $68=$67;
      var $69=$35;
      var $70=$36;
      var $71=$68;
      var $72=$39;
      var $73=$71;
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$75;
      var $77=$40;
      $__nd=$76;
      var $78=$__nd;
      var $79=$3;
      var $80=$4;
      HEAP32[(($3)>>2)]=$45;
      HEAP32[(($4)>>2)]=-1;
      var $81=HEAP32[(($3)>>2)];
      var $82=HEAP32[(($4)>>2)];
      var $83=$1;
      var $84=$2;
      HEAP32[(($1)>>2)]=$81;
      HEAP32[(($2)>>2)]=$82;
      var $85=HEAP32[(($1)>>2)];
      var $86=$1;
      var $87=$2;
      var $88=$3;
      var $89=$4;
      var $90=$5;
      HEAP32[(($5)>>2)]=$45;
      var $91=HEAP32[(($5)>>2)];
      var $92=$5;
      var $93=(($78)|0)!=0;
      if ($93) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $94
      __label__ = 2; break;
    case 2: // $95
      var $96=(($48)|0);
      var $97=$8;
      HEAP32[(($8)>>2)]=$96;
      var $98=HEAP32[(($8)>>2)];
      var $99=(($98+8)|0);
      var $100=$7;
      HEAP32[(($7)>>2)]=$99;
      var $101=HEAP32[(($7)>>2)];
      var $102=$101;
      var $103=$6;
      HEAP32[(($6)>>2)]=$102;
      var $104=HEAP32[(($6)>>2)];
      var $105=$104;
      var $106=$6;
      var $107=$7;
      var $108=$8;
      var $109=$9;
      HEAP32[(($9)>>2)]=$105;
      var $110=HEAP32[(($9)>>2)];
      var $111=$110;
      var $112=$9;
      var $113=$44;
      var $114=$__nd;
      var $115=(($114+16)|0);
      var $116=(($115)|0);
      var $117=$10;
      var $118=$11;
      var $119=$12;
      HEAP32[(($10)>>2)]=$111;
      HEAP32[(($11)>>2)]=$113;
      HEAP32[(($12)>>2)]=$116;
      var $120=HEAP32[(($10)>>2)];
      var $121=HEAP32[(($11)>>2)];
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=HEAP32[(($12)>>2)];
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=(($123)|0) < (($126)|0);
      var $128=$10;
      var $129=$11;
      var $130=$12;
      if ($127) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $131
      var $132=$__nd;
      var $133=$132;
      var $134=(($133)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$15;
      var $137=$16;
      HEAP32[(($15)>>2)]=$46;
      HEAP32[(($16)>>2)]=-1;
      var $138=HEAP32[(($15)>>2)];
      var $139=HEAP32[(($16)>>2)];
      var $140=$13;
      var $141=$14;
      HEAP32[(($13)>>2)]=$138;
      HEAP32[(($14)>>2)]=$139;
      var $142=HEAP32[(($13)>>2)];
      var $143=$13;
      var $144=$14;
      var $145=$15;
      var $146=$16;
      var $147=$17;
      HEAP32[(($17)>>2)]=$46;
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=(($135)|0)!=0;
      if ($150) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $151
      var $152=$__nd;
      var $153=$152;
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$155;
      $__nd=$156;
      __label__ = 6; break;
    case 5: // $157
      var $158=$__nd;
      var $159=$158;
      var $160=$43;
      HEAP32[(($160)>>2)]=$159;
      var $161=$43;
      var $162=HEAP32[(($161)>>2)];
      var $163=$162;
      var $164=(($163)|0);
      $41=$164;
      __label__ = 16; break;
    case 6: // $165
      __label__ = 14; break;
    case 7: // $166
      var $167=(($48)|0);
      var $168=$20;
      HEAP32[(($20)>>2)]=$167;
      var $169=HEAP32[(($20)>>2)];
      var $170=(($169+8)|0);
      var $171=$19;
      HEAP32[(($19)>>2)]=$170;
      var $172=HEAP32[(($19)>>2)];
      var $173=$172;
      var $174=$18;
      HEAP32[(($18)>>2)]=$173;
      var $175=HEAP32[(($18)>>2)];
      var $176=$175;
      var $177=$18;
      var $178=$19;
      var $179=$20;
      var $180=$21;
      HEAP32[(($21)>>2)]=$176;
      var $181=HEAP32[(($21)>>2)];
      var $182=$181;
      var $183=$21;
      var $184=$__nd;
      var $185=(($184+16)|0);
      var $186=(($185)|0);
      var $187=$44;
      var $188=$22;
      var $189=$23;
      var $190=$24;
      HEAP32[(($22)>>2)]=$182;
      HEAP32[(($23)>>2)]=$186;
      HEAP32[(($24)>>2)]=$187;
      var $191=HEAP32[(($22)>>2)];
      var $192=HEAP32[(($23)>>2)];
      var $193=HEAPU8[($192)];
      var $194=(($193)&255);
      var $195=HEAP32[(($24)>>2)];
      var $196=HEAPU8[($195)];
      var $197=(($196)&255);
      var $198=(($194)|0) < (($197)|0);
      var $199=$22;
      var $200=$23;
      var $201=$24;
      if ($198) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $202
      var $203=$__nd;
      var $204=$203;
      var $205=(($204+4)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=$27;
      var $208=$28;
      HEAP32[(($27)>>2)]=$47;
      HEAP32[(($28)>>2)]=-1;
      var $209=HEAP32[(($27)>>2)];
      var $210=HEAP32[(($28)>>2)];
      var $211=$25;
      var $212=$26;
      HEAP32[(($25)>>2)]=$209;
      HEAP32[(($26)>>2)]=$210;
      var $213=HEAP32[(($25)>>2)];
      var $214=$25;
      var $215=$26;
      var $216=$27;
      var $217=$28;
      var $218=$29;
      HEAP32[(($29)>>2)]=$47;
      var $219=HEAP32[(($29)>>2)];
      var $220=$29;
      var $221=(($206)|0)!=0;
      if ($221) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $222
      var $223=$__nd;
      var $224=$223;
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$226;
      $__nd=$227;
      __label__ = 11; break;
    case 10: // $228
      var $229=$__nd;
      var $230=$229;
      var $231=$43;
      HEAP32[(($231)>>2)]=$230;
      var $232=$43;
      var $233=HEAP32[(($232)>>2)];
      var $234=(($233+4)|0);
      $41=$234;
      __label__ = 16; break;
    case 11: // $235
      __label__ = 13; break;
    case 12: // $236
      var $237=$__nd;
      var $238=$237;
      var $239=$43;
      HEAP32[(($239)>>2)]=$238;
      var $240=$43;
      $41=$240;
      __label__ = 16; break;
    case 13: // $241
      __label__ = 14; break;
    case 14: // $242
      __label__ = 2; break;
    case 15: // $243
      var $244=(($48)|0);
      var $245=$34;
      HEAP32[(($34)>>2)]=$244;
      var $246=HEAP32[(($34)>>2)];
      var $247=(($246+4)|0);
      var $248=$33;
      HEAP32[(($33)>>2)]=$247;
      var $249=HEAP32[(($33)>>2)];
      var $250=$249;
      var $251=$32;
      HEAP32[(($32)>>2)]=$250;
      var $252=HEAP32[(($32)>>2)];
      var $253=(($252)|0);
      var $254=$32;
      var $255=$33;
      var $256=$31;
      HEAP32[(($31)>>2)]=$253;
      var $257=HEAP32[(($31)>>2)];
      var $258=$30;
      HEAP32[(($30)>>2)]=$257;
      var $259=HEAP32[(($30)>>2)];
      var $260=$259;
      var $261=$260;
      var $262=$30;
      var $263=$31;
      var $264=$261;
      var $265=$34;
      var $266=$264;
      var $267=$43;
      HEAP32[(($267)>>2)]=$266;
      var $268=$43;
      var $269=HEAP32[(($268)>>2)];
      var $270=$269;
      var $271=(($270)|0);
      $41=$271;
      __label__ = 16; break;
    case 16: // $272
      var $273=$41;
      STACKTOP = __stackBase__;
      return $273;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_["X"]=1;

function __ZN13delegate_baseIhR13address_spacejh8_noparamEC2I18address_table_readEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM18address_table_readFhR13address_spacejhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=380;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIhR13address_spacejh8_noparamE4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM18address_table_readFhR13address_spacejhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM18address_table_readFhR13address_spacejhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI18address_table_read, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18handler_entry_readEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18handler_entry_readEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18handler_entry_readEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1116);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18handler_entry_readE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18handler_entry_readED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18handler_entry_readED2Ev($2);
  ;
  return;
}


function __ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC2ESE_($this, $__i) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__i; $__i = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__i)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=$3;
  var $5=$__i;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC2ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE($this, $__i) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__i; $__i = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__i)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $3=$1;
  var $4=(($3)|0);
  var $5=(($__i)|0);
  var $6=$2;
  var $7=$5;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];
  FUNCTION_TABLE[__ZNSt3__121__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPKNS_11__tree_nodeIS8_PvEEiEC1ENS_15__tree_iteratorIS8_PSB_iEE]($4, $2);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI18handler_entry_readED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18handler_entry_readED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18handler_entry_readED0Ev["X"]=1;

function __ZN20resource_pool_objectI18handler_entry_readED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI18handler_entry_readE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__111__tree_nextIPKNS_16__tree_node_baseIPvEEEET_S6_($__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16;
      var $17;
      var $18=__stackBase__+60;
      var $19;
      var $20;
      $17=$__x;
      var $21=$17;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$14;
      var $25=$15;
      HEAP32[(($14)>>2)]=$18;
      HEAP32[(($15)>>2)]=-1;
      var $26=HEAP32[(($14)>>2)];
      var $27=HEAP32[(($15)>>2)];
      var $28=$12;
      var $29=$13;
      HEAP32[(($12)>>2)]=$26;
      HEAP32[(($13)>>2)]=$27;
      var $30=HEAP32[(($12)>>2)];
      var $31=$12;
      var $32=$13;
      var $33=$14;
      var $34=$15;
      __label__ = 1; break;
    case 1: // $35
      var $36=$1;
      HEAP32[(($1)>>2)]=$18;
      var $37=HEAP32[(($1)>>2)];
      var $38=$1;
      __label__ = 2; break;
    case 2: // $39
      var $40=(($23)|0)!=0;
      if ($40) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $41
      var $42=$17;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$7;
      var $46=$8;
      var $47=$9;
      var $48=$10;
      HEAP32[(($7)>>2)]=$44;
      __label__ = 4; break;
    case 4: // $49
      var $50=HEAP32[(($7)>>2)];
      var $51=$50;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$5;
      var $55=$6;
      HEAP32[(($5)>>2)]=$8;
      HEAP32[(($6)>>2)]=-1;
      var $56=HEAP32[(($5)>>2)];
      var $57=HEAP32[(($6)>>2)];
      var $58=$3;
      var $59=$4;
      HEAP32[(($3)>>2)]=$56;
      HEAP32[(($4)>>2)]=$57;
      var $60=HEAP32[(($3)>>2)];
      var $61=$3;
      var $62=$4;
      var $63=$5;
      var $64=$6;
      var $65=$2;
      HEAP32[(($2)>>2)]=$8;
      var $66=HEAP32[(($2)>>2)];
      var $67=$2;
      var $68=(($53)|0)!=0;
      if ($68) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $69
      var $70=HEAP32[(($7)>>2)];
      var $71=$70;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      HEAP32[(($7)>>2)]=$73;
      __label__ = 4; break;
    case 6: // $_ZNSt3__110__tree_minIPNS_16__tree_node_baseIPvEEEET_S5__exit
      var $74=HEAP32[(($7)>>2)];
      var $75=$7;
      var $76=$8;
      var $77=$9;
      var $78=$10;
      $16=$74;
      __label__ = 12; break;
    case 7: // $83
      var $84=$19;
      ___cxa_call_unexpected($84);
      throw "Reached an unreachable!"
    case 8: // $85
      __label__ = 9; break;
    case 9: // $86
      var $87=$17;
      var $88=$11;
      HEAP32[(($11)>>2)]=$87;
      var $89=HEAP32[(($11)>>2)];
      var $90=HEAP32[(($11)>>2)];
      var $91=(($90+8)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$92;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($89)|0)==(($95)|0);
      var $97=$11;
      var $98=$96 ^ 1;
      if ($98) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $99
      var $100=$17;
      var $101=(($100+8)|0);
      var $102=HEAP32[(($101)>>2)];
      $17=$102;
      __label__ = 9; break;
    case 11: // $103
      var $104=$17;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      $16=$106;
      __label__ = 12; break;
    case 12: // $107
      var $108=$16;
      STACKTOP = __stackBase__;
      return $108;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__tree_nextIPKNS_16__tree_node_baseIPvEEEET_S6_["X"]=1;

function __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE16__insert_node_atEPNS_16__tree_node_baseIPvEERSI_SI_($this, $__parent, $__child, $__new_node) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27;
      var $28;
      var $29;
      var $30;
      var $31=__stackBase__+104;
      var $32=__stackBase__+108;
      var $33=__stackBase__+112;
      $27=$this;
      $28=$__parent;
      $29=$__child;
      $30=$__new_node;
      var $34=$27;
      var $35=$25;
      var $36=$26;
      HEAP32[(($25)>>2)]=$31;
      HEAP32[(($26)>>2)]=-1;
      var $37=HEAP32[(($25)>>2)];
      var $38=HEAP32[(($26)>>2)];
      var $39=$23;
      var $40=$24;
      HEAP32[(($23)>>2)]=$37;
      HEAP32[(($24)>>2)]=$38;
      var $41=HEAP32[(($23)>>2)];
      var $42=$23;
      var $43=$24;
      var $44=$25;
      var $45=$26;
      var $46=$19;
      HEAP32[(($19)>>2)]=$31;
      var $47=HEAP32[(($19)>>2)];
      var $48=$19;
      var $49=$30;
      var $50=$49;
      var $51=(($50)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=$3;
      var $53=$4;
      HEAP32[(($3)>>2)]=$32;
      HEAP32[(($4)>>2)]=-1;
      var $54=HEAP32[(($3)>>2)];
      var $55=HEAP32[(($4)>>2)];
      var $56=$1;
      var $57=$2;
      HEAP32[(($1)>>2)]=$54;
      HEAP32[(($2)>>2)]=$55;
      var $58=HEAP32[(($1)>>2)];
      var $59=$1;
      var $60=$2;
      var $61=$3;
      var $62=$4;
      var $63=$5;
      HEAP32[(($5)>>2)]=$32;
      var $64=HEAP32[(($5)>>2)];
      var $65=$5;
      var $66=$30;
      var $67=(($66+4)|0);
      HEAP32[(($67)>>2)]=0;
      var $68=$28;
      var $69=$30;
      var $70=(($69+8)|0);
      HEAP32[(($70)>>2)]=$68;
      var $71=$30;
      var $72=$29;
      HEAP32[(($72)>>2)]=$71;
      var $73=$6;
      HEAP32[(($6)>>2)]=$34;
      var $74=HEAP32[(($6)>>2)];
      var $75=(($74)|0);
      var $76=$6;
      var $77=HEAP32[(($75)>>2)];
      var $78=$77;
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$9;
      var $82=$10;
      HEAP32[(($9)>>2)]=$33;
      HEAP32[(($10)>>2)]=-1;
      var $83=HEAP32[(($9)>>2)];
      var $84=HEAP32[(($10)>>2)];
      var $85=$7;
      var $86=$8;
      HEAP32[(($7)>>2)]=$83;
      HEAP32[(($8)>>2)]=$84;
      var $87=HEAP32[(($7)>>2)];
      var $88=$7;
      var $89=$8;
      var $90=$9;
      var $91=$10;
      var $92=$11;
      HEAP32[(($11)>>2)]=$33;
      var $93=HEAP32[(($11)>>2)];
      var $94=$11;
      var $95=(($80)|0)!=0;
      if ($95) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $96
      var $97=$12;
      HEAP32[(($12)>>2)]=$34;
      var $98=HEAP32[(($12)>>2)];
      var $99=(($98)|0);
      var $100=$12;
      var $101=HEAP32[(($99)>>2)];
      var $102=$101;
      var $103=(($102)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$104;
      var $106=$13;
      HEAP32[(($13)>>2)]=$34;
      var $107=HEAP32[(($13)>>2)];
      var $108=(($107)|0);
      var $109=$13;
      HEAP32[(($108)>>2)]=$105;
      __label__ = 2; break;
    case 2: // $110
      var $111=$18;
      HEAP32[(($18)>>2)]=$34;
      var $112=HEAP32[(($18)>>2)];
      var $113=(($112+4)|0);
      var $114=$17;
      HEAP32[(($17)>>2)]=$113;
      var $115=HEAP32[(($17)>>2)];
      var $116=$115;
      var $117=$16;
      HEAP32[(($16)>>2)]=$116;
      var $118=HEAP32[(($16)>>2)];
      var $119=(($118)|0);
      var $120=$16;
      var $121=$17;
      var $122=$15;
      HEAP32[(($15)>>2)]=$119;
      var $123=HEAP32[(($15)>>2)];
      var $124=$14;
      HEAP32[(($14)>>2)]=$123;
      var $125=HEAP32[(($14)>>2)];
      var $126=$125;
      var $127=$126;
      var $128=$14;
      var $129=$15;
      var $130=$127;
      var $131=$18;
      var $132=$130;
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$29;
      var $136=HEAP32[(($135)>>2)];
      __ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_($134, $136);
      var $137=$22;
      HEAP32[(($22)>>2)]=$34;
      var $138=HEAP32[(($22)>>2)];
      var $139=(($138+8)|0);
      var $140=$21;
      HEAP32[(($21)>>2)]=$139;
      var $141=HEAP32[(($21)>>2)];
      var $142=$141;
      var $143=$20;
      HEAP32[(($20)>>2)]=$142;
      var $144=HEAP32[(($20)>>2)];
      var $145=(($144)|0);
      var $146=$20;
      var $147=$21;
      var $148=$22;
      var $149=HEAP32[(($145)>>2)];
      var $150=(($149+1)|0);
      HEAP32[(($145)>>2)]=$150;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE16__insert_node_atEPNS_16__tree_node_baseIPvEERSI_SI_["X"]=1;

function __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__construct_nodeERSA_($agg_result, $this, $__k) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $result_i_i_i=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $31=__stackBase__+132;
      var $32=__stackBase__+136;
      var $33=__stackBase__+140;
      var $34=__stackBase__+144;
      var $35=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39;
      var $40;
      var $__na;
      var $__h=__stackBase__+164;
      var $41=__stackBase__+176;
      var $42;
      var $43;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46;
      $39=$this;
      $40=$__k;
      var $47=$39;
      var $48=(($47)|0);
      var $49=$38;
      HEAP32[(($38)>>2)]=$48;
      var $50=HEAP32[(($38)>>2)];
      var $51=(($50+4)|0);
      var $52=$37;
      HEAP32[(($37)>>2)]=$51;
      var $53=HEAP32[(($37)>>2)];
      var $54=$53;
      var $55=$36;
      HEAP32[(($36)>>2)]=$54;
      var $56=HEAP32[(($36)>>2)];
      var $57=$56;
      var $58=$36;
      var $59=$37;
      var $60=$38;
      $__na=$57;
      var $61=$__na;
      var $62=$34;
      var $63=$35;
      HEAP32[(($34)>>2)]=$61;
      HEAP32[(($35)>>2)]=1;
      var $64=HEAP32[(($34)>>2)];
      var $65=HEAP32[(($35)>>2)];
      var $66=$31;
      var $67=$32;
      var $68=$33;
      HEAP32[(($31)>>2)]=$64;
      HEAP32[(($32)>>2)]=$65;
      HEAP32[(($33)>>2)]=0;
      var $69=HEAP32[(($31)>>2)];
      var $70=HEAP32[(($32)>>2)];
      var $71=((($70<<5))|0);
      var $72=$28;
      var $73=$result_i_i_i;
      var $74=$29;
      var $75=$30;
      HEAP32[(($28)>>2)]=$71;
      var $76=HEAP32[(($28)>>2)];
      var $77=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($76, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $78
      HEAP32[(($result_i_i_i)>>2)]=$77;
      var $79=HEAP32[(($result_i_i_i)>>2)];
      var $80=(($79)|0)==0;
      if ($80) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $81
      var $82=___cxa_allocate_exception(4);
      var $83=$82;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($83);
      (function() { try { __THREW__ = false; return ___cxa_throw($82, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $86=$85.f0;
      HEAP32[(($29)>>2)]=$86;
      var $87=$85.f1;
      HEAP32[(($30)>>2)]=$87;
      var $88=HEAP32[(($30)>>2)];
      var $89=(($88)|0) < 0;
      if ($89) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $90
      var $91=HEAP32[(($29)>>2)];
      ___cxa_call_unexpected($91);
      throw "Reached an unreachable!"
    case 5: // $92
      var $93=HEAP32[(($29)>>2)];
      var $94=HEAP32[(($29)>>2)];
      var $95=HEAP32[(($30)>>2)];
      var $96=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $94, tempValue);
      var $97=($96.f1 = $95, $96);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $98
      throw "Reached an unreachable!"
    case 7: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE8allocateERSC_j_exit
      var $99=HEAP32[(($result_i_i_i)>>2)];
      var $100=$28;
      var $101=$result_i_i_i;
      var $102=$29;
      var $103=$30;
      var $104=$99;
      var $105=$31;
      var $106=$32;
      var $107=$33;
      var $108=$34;
      var $109=$35;
      var $110=$__na;
      FUNCTION_TABLE[__ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEC1ERSC_]($41, $110);
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1EPSB_SE_]($__h, $104, $41);
      var $111=$__na;
      var $112=$27;
      HEAP32[(($27)>>2)]=$__h;
      var $113=HEAP32[(($27)>>2)];
      var $114=(($113)|0);
      var $115=$26;
      HEAP32[(($26)>>2)]=$114;
      var $116=HEAP32[(($26)>>2)];
      var $117=$116;
      var $118=$25;
      HEAP32[(($25)>>2)]=$117;
      var $119=HEAP32[(($25)>>2)];
      var $120=(($119)|0);
      var $121=$25;
      var $122=$26;
      var $123=HEAP32[(($120)>>2)];
      var $124=$27;
      var $125=(($123+16)|0);
      var $126=(($125)|0);
      var $127=$24;
      HEAP32[(($24)>>2)]=$126;
      var $128=HEAP32[(($24)>>2)];
      var $129=$24;
      var $130=$40;
      var $131=$21;
      var $132=$22;
      var $133=$23;
      HEAP32[(($21)>>2)]=$111;
      HEAP32[(($22)>>2)]=$128;
      HEAP32[(($23)>>2)]=$130;
      var $134=HEAP32[(($22)>>2)];
      var $135=(($134)|0)==0;
      if ($135) { var $139 = 0;__label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $136
      var $137=HEAP32[(($23)>>2)];
      var $138=HEAP8[($137)];
      HEAP8[($134)]=$138;
      var $139 = $134;__label__ = 9; break;
    case 9: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE9constructIhhEEvRSC_PT_RKT0__exit
      var $139;
      var $140=$21;
      var $141=$22;
      var $142=$23;
      __label__ = 10; break;
    case 10: // $143
      var $144=$20;
      HEAP32[(($20)>>2)]=$__h;
      var $145=HEAP32[(($20)>>2)];
      var $146=(($145)|0);
      var $147=$19;
      HEAP32[(($19)>>2)]=$146;
      var $148=HEAP32[(($19)>>2)];
      var $149=$148;
      var $150=$18;
      HEAP32[(($18)>>2)]=$149;
      var $151=HEAP32[(($18)>>2)];
      var $152=(($151+4)|0);
      var $153=$18;
      var $154=$19;
      var $155=$20;
      var $156=(($152+4)|0);
      HEAP8[($156)]=1;
      var $157=$__na;
      var $158=$17;
      HEAP32[(($17)>>2)]=$__h;
      var $159=HEAP32[(($17)>>2)];
      var $160=(($159)|0);
      var $161=$16;
      HEAP32[(($16)>>2)]=$160;
      var $162=HEAP32[(($16)>>2)];
      var $163=$162;
      var $164=$15;
      HEAP32[(($15)>>2)]=$163;
      var $165=HEAP32[(($15)>>2)];
      var $166=(($165)|0);
      var $167=$15;
      var $168=$16;
      var $169=HEAP32[(($166)>>2)];
      var $170=$17;
      var $171=(($169+16)|0);
      var $172=(($171+4)|0);
      var $173=$14;
      HEAP32[(($14)>>2)]=$172;
      var $174=HEAP32[(($14)>>2)];
      var $175=$174;
      var $176=$175;
      var $177=$14;
      var $178=$12;
      var $179=$13;
      HEAP32[(($12)>>2)]=$157;
      HEAP32[(($13)>>2)]=$176;
      var $180=HEAP32[(($13)>>2)];
      var $181=$180;
      var $182=(($181)|0)==0;
      if ($182) { var $185 = 0;__label__ = 13; break; } else { __label__ = 11; break; }
    case 11: // $183
      var $184=$181;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC1Ev]($184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 28; break; }
    case 12: // $_noexc
      var $185 = $184;__label__ = 13; break;
    case 13: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE9constructIS8_EEvRSC_PT__exit
      var $185;
      var $186=$12;
      var $187=$13;
      __label__ = 14; break;
    case 14: // $188
      var $189=$11;
      HEAP32[(($11)>>2)]=$__h;
      var $190=HEAP32[(($11)>>2)];
      var $191=(($190)|0);
      var $192=$10;
      HEAP32[(($10)>>2)]=$191;
      var $193=HEAP32[(($10)>>2)];
      var $194=$193;
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196+4)|0);
      var $198=$9;
      var $199=$10;
      var $200=$11;
      var $201=(($197+5)|0);
      HEAP8[($201)]=1;
      var $202=$3;
      var $203=$4;
      var $204=$5;
      var $205=$6;
      var $206=$7;
      var $207=$8;
      HEAP32[(($3)>>2)]=$__h;
      var $208=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC1ERSG_]($6, $208) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 28; break; }
    case 15: // $_noexc1
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ENS_4__rvISF_EE]($5, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 28; break; }
    case 16: // $_noexc2
      var $209=$2;
      HEAP32[(($2)>>2)]=$5;
      var $210=HEAP32[(($2)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC1ERSG_]($4, $210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $_ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEcvNS_4__rvISF_EEEv_exit_i
      var $211=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ENS_4__rvISF_EE]($45, $4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $212
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 28; break; }
    case 19: // $213
      var $214=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $215=$214.f0;
      HEAP32[(($7)>>2)]=$215;
      var $216=$214.f1;
      HEAP32[(($8)>>2)]=$216;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $217
      var $218=HEAP32[(($7)>>2)];
      var $219=HEAP32[(($7)>>2)];
      var $220=HEAP32[(($8)>>2)];
      var $221=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $219, tempValue);
      var $222=($221.f1 = $220, $221);
      var $eh_lpad_body = $222;__label__ = 29; break;
    case 21: // $223
      var $224=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 22: // $_ZNSt3__14moveINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEENS_9enable_ifIXsr14is_convertibleIT_NS_4__rvISI_EEEE5valueESI_E4typeERSI__exit
      var $225=$3;
      var $226=$4;
      var $227=$5;
      var $228=$6;
      var $229=$7;
      var $230=$8;
      __label__ = 23; break;
    case 23: // $231
      var $232=$1;
      HEAP32[(($1)>>2)]=$45;
      var $233=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC1ERSG_]($44, $233) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 30; break; }
    case 24: // $_ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEcvNS_4__rvISF_EEEv_exit
      var $234=$1;
      __label__ = 25; break;
    case 25: // $235
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ENS_4__rvISF_EE]($agg_result, $44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $236
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $237
      $46=1;
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($__h);
      STACKTOP = __stackBase__;
      return;
    case 28: // $238
      var $239=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $239;__label__ = 29; break;
    case 29: // $_body
      var $eh_lpad_body;
      var $240=$eh_lpad_body.f0;
      $42=$240;
      var $241=$eh_lpad_body.f1;
      $43=$241;
      __label__ = 32; break;
    case 30: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $244=$243.f0;
      $42=$244;
      var $245=$243.f1;
      $43=$245;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 31: // $246
      __label__ = 32; break;
    case 32: // $247
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev]($__h) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $248
      __label__ = 34; break;
    case 34: // $249
      var $250=$42;
      var $251=$42;
      var $252=$43;
      var $253=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $251, tempValue);
      var $254=($253.f1 = $252, $253);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $255
      var $256=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__construct_nodeERSA_["X"]=1;
// WARNING: content after a branch in a label, line: 376624
// WARNING: content after a branch in a label, line: 376626
// WARNING: content after a branch in a label, line: 376627
// WARNING: content after a branch in a label, line: 376628
// WARNING: content after a branch in a label, line: 376629
// WARNING: content after a branch in a label, line: 376630
// WARNING: content after a branch in a label, line: 376894
// WARNING: content after a branch in a label, line: 376896
// WARNING: content after a branch in a label, line: 376897
// WARNING: content after a branch in a label, line: 376898
// WARNING: content after a branch in a label, line: 376899
// WARNING: content after a branch in a label, line: 376900
// WARNING: content after a branch in a label, line: 377039
// WARNING: content after a branch in a label, line: 377041
// WARNING: content after a branch in a label, line: 377042
// WARNING: content after a branch in a label, line: 377043
// WARNING: content after a branch in a label, line: 377044
// WARNING: content after a branch in a label, line: 377045

function __ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC2ERSG_($this, $__t) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__t;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  ;
  return;
}


function __ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_($__root, $__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14;
      var $15;
      var $__y;
      var $16=__stackBase__+52;
      var $17;
      var $18;
      var $__y1;
      var $19=__stackBase__+56;
      $14=$__root;
      $15=$__x;
      var $20=$15;
      var $21=$14;
      var $22=(($20)|0)==(($21)|0);
      var $23=$15;
      var $24=(($23+12)|0);
      var $25=(($22)&1);
      HEAP8[($24)]=$25;
      __label__ = 1; break;
    case 1: // $26
      var $27=$15;
      var $28=$14;
      var $29=(($27)|0)!=(($28)|0);
      if ($29) { __label__ = 2; break; } else { var $39 = 0;__label__ = 3; break; }
    case 2: // $30
      var $31=$15;
      var $32=(($31+8)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+12)|0);
      var $35=HEAP8[($34)];
      var $36=(($35) & 1);
      var $37=$36 ^ 1;
      var $39 = $37;__label__ = 3; break;
    case 3: // $38
      var $39;
      if ($39) { __label__ = 4; break; } else { __label__ = 25; break; }
    case 4: // $40
      var $41=$15;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$13;
      HEAP32[(($13)>>2)]=$43;
      var $45=HEAP32[(($13)>>2)];
      var $46=HEAP32[(($13)>>2)];
      var $47=(($46+8)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($45)|0)==(($51)|0);
      var $53=$13;
      if ($52) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $54
      var $55=$15;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      $__y=$61;
      var $62=$__y;
      var $63=$11;
      var $64=$12;
      HEAP32[(($11)>>2)]=$16;
      HEAP32[(($12)>>2)]=-1;
      var $65=HEAP32[(($11)>>2)];
      var $66=HEAP32[(($12)>>2)];
      var $67=$9;
      var $68=$10;
      HEAP32[(($9)>>2)]=$65;
      HEAP32[(($10)>>2)]=$66;
      var $69=HEAP32[(($9)>>2)];
      var $70=$9;
      var $71=$10;
      var $72=$11;
      var $73=$12;
      __label__ = 6; break;
    case 6: // $74
      var $75=$8;
      HEAP32[(($8)>>2)]=$16;
      var $76=HEAP32[(($8)>>2)];
      var $77=$8;
      __label__ = 7; break;
    case 7: // $78
      var $79=(($62)|0)!=0;
      if ($79) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $80
      var $81=$__y;
      var $82=(($81+12)|0);
      var $83=HEAP8[($82)];
      var $84=(($83) & 1);
      if ($84) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $85
      var $86=$15;
      var $87=(($86+8)|0);
      var $88=HEAP32[(($87)>>2)];
      $15=$88;
      var $89=$15;
      var $90=(($89+12)|0);
      HEAP8[($90)]=1;
      var $91=$15;
      var $92=(($91+8)|0);
      var $93=HEAP32[(($92)>>2)];
      $15=$93;
      var $94=$15;
      var $95=$14;
      var $96=(($94)|0)==(($95)|0);
      var $97=$15;
      var $98=(($97+12)|0);
      var $99=(($96)&1);
      HEAP8[($98)]=$99;
      var $100=$__y;
      var $101=(($100+12)|0);
      HEAP8[($101)]=1;
      __label__ = 14; break;
    case 10: // $106
      var $107=$17;
      ___cxa_call_unexpected($107);
      throw "Reached an unreachable!"
    case 11: // $108
      var $109=$15;
      var $110=$1;
      HEAP32[(($1)>>2)]=$109;
      var $111=HEAP32[(($1)>>2)];
      var $112=HEAP32[(($1)>>2)];
      var $113=(($112+8)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$114;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($111)|0)==(($117)|0);
      var $119=$1;
      if ($118) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $120
      var $121=$15;
      var $122=(($121+8)|0);
      var $123=HEAP32[(($122)>>2)];
      $15=$123;
      var $124=$15;
      __ZNSt3__118__tree_left_rotateIPNS_16__tree_node_baseIPvEEEEvT_($124);
      __label__ = 13; break;
    case 13: // $125
      var $126=$15;
      var $127=(($126+8)|0);
      var $128=HEAP32[(($127)>>2)];
      $15=$128;
      var $129=$15;
      var $130=(($129+12)|0);
      HEAP8[($130)]=1;
      var $131=$15;
      var $132=(($131+8)|0);
      var $133=HEAP32[(($132)>>2)];
      $15=$133;
      var $134=$15;
      var $135=(($134+12)|0);
      HEAP8[($135)]=0;
      var $136=$15;
      __ZNSt3__119__tree_right_rotateIPNS_16__tree_node_baseIPvEEEEvT_($136);
      __label__ = 25; break;
    case 14: // $137
      __label__ = 24; break;
    case 15: // $138
      var $139=$15;
      var $140=(($139+8)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141+8)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$143;
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      $__y1=$146;
      var $147=$__y1;
      var $148=$4;
      var $149=$5;
      HEAP32[(($4)>>2)]=$19;
      HEAP32[(($5)>>2)]=-1;
      var $150=HEAP32[(($4)>>2)];
      var $151=HEAP32[(($5)>>2)];
      var $152=$2;
      var $153=$3;
      HEAP32[(($2)>>2)]=$150;
      HEAP32[(($3)>>2)]=$151;
      var $154=HEAP32[(($2)>>2)];
      var $155=$2;
      var $156=$3;
      var $157=$4;
      var $158=$5;
      __label__ = 16; break;
    case 16: // $159
      var $160=$6;
      HEAP32[(($6)>>2)]=$19;
      var $161=HEAP32[(($6)>>2)];
      var $162=$6;
      __label__ = 17; break;
    case 17: // $163
      var $164=(($147)|0)!=0;
      if ($164) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $165
      var $166=$__y1;
      var $167=(($166+12)|0);
      var $168=HEAP8[($167)];
      var $169=(($168) & 1);
      if ($169) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $170
      var $171=$15;
      var $172=(($171+8)|0);
      var $173=HEAP32[(($172)>>2)];
      $15=$173;
      var $174=$15;
      var $175=(($174+12)|0);
      HEAP8[($175)]=1;
      var $176=$15;
      var $177=(($176+8)|0);
      var $178=HEAP32[(($177)>>2)];
      $15=$178;
      var $179=$15;
      var $180=$14;
      var $181=(($179)|0)==(($180)|0);
      var $182=$15;
      var $183=(($182+12)|0);
      var $184=(($181)&1);
      HEAP8[($183)]=$184;
      var $185=$__y1;
      var $186=(($185+12)|0);
      HEAP8[($186)]=1;
      __label__ = 23; break;
    case 20: // $187
      var $188=$15;
      var $189=$7;
      HEAP32[(($7)>>2)]=$188;
      var $190=HEAP32[(($7)>>2)];
      var $191=HEAP32[(($7)>>2)];
      var $192=(($191+8)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$193;
      var $195=(($194)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($190)|0)==(($196)|0);
      var $198=$7;
      if ($197) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $199
      var $200=$15;
      var $201=(($200+8)|0);
      var $202=HEAP32[(($201)>>2)];
      $15=$202;
      var $203=$15;
      __ZNSt3__119__tree_right_rotateIPNS_16__tree_node_baseIPvEEEEvT_($203);
      __label__ = 22; break;
    case 22: // $204
      var $205=$15;
      var $206=(($205+8)|0);
      var $207=HEAP32[(($206)>>2)];
      $15=$207;
      var $208=$15;
      var $209=(($208+12)|0);
      HEAP8[($209)]=1;
      var $210=$15;
      var $211=(($210+8)|0);
      var $212=HEAP32[(($211)>>2)];
      $15=$212;
      var $213=$15;
      var $214=(($213+12)|0);
      HEAP8[($214)]=0;
      var $215=$15;
      __ZNSt3__118__tree_left_rotateIPNS_16__tree_node_baseIPvEEEEvT_($215);
      __label__ = 25; break;
    case 23: // $216
      __label__ = 24; break;
    case 24: // $217
      __label__ = 1; break;
    case 25: // $218
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_["X"]=1;

function __ZNSt3__118__tree_left_rotateIPNS_16__tree_node_baseIPvEEEEvT_($__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $__y;
      var $8=__stackBase__+24;
      var $9;
      var $10;
      $7=$__x;
      var $11=$7;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      $__y=$13;
      var $14=$__y;
      var $15=$14;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$7;
      var $19=(($18+4)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$7;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$5;
      var $24=$6;
      HEAP32[(($5)>>2)]=$8;
      HEAP32[(($6)>>2)]=-1;
      var $25=HEAP32[(($5)>>2)];
      var $26=HEAP32[(($6)>>2)];
      var $27=$3;
      var $28=$4;
      HEAP32[(($3)>>2)]=$25;
      HEAP32[(($4)>>2)]=$26;
      var $29=HEAP32[(($3)>>2)];
      var $30=$3;
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 1; break;
    case 1: // $34
      var $35=$1;
      HEAP32[(($1)>>2)]=$8;
      var $36=HEAP32[(($1)>>2)];
      var $37=$1;
      __label__ = 2; break;
    case 2: // $38
      var $39=(($22)|0)!=0;
      if ($39) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $40
      var $41=$7;
      var $42=$7;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+8)|0);
      HEAP32[(($45)>>2)]=$41;
      __label__ = 5; break;
    case 4: // $50
      var $51=$9;
      ___cxa_call_unexpected($51);
      throw "Reached an unreachable!"
    case 5: // $52
      var $53=$7;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$__y;
      var $57=(($56+8)|0);
      HEAP32[(($57)>>2)]=$55;
      var $58=$7;
      var $59=$2;
      HEAP32[(($2)>>2)]=$58;
      var $60=HEAP32[(($2)>>2)];
      var $61=HEAP32[(($2)>>2)];
      var $62=(($61+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$63;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($60)|0)==(($66)|0);
      var $68=$2;
      if ($67) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $69
      var $70=$__y;
      var $71=$7;
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73;
      var $75=(($74)|0);
      HEAP32[(($75)>>2)]=$70;
      __label__ = 8; break;
    case 7: // $76
      var $77=$__y;
      var $78=$7;
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+4)|0);
      HEAP32[(($81)>>2)]=$77;
      __label__ = 8; break;
    case 8: // $82
      var $83=$7;
      var $84=$__y;
      var $85=$84;
      var $86=(($85)|0);
      HEAP32[(($86)>>2)]=$83;
      var $87=$__y;
      var $88=$7;
      var $89=(($88+8)|0);
      HEAP32[(($89)>>2)]=$87;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__118__tree_left_rotateIPNS_16__tree_node_baseIPvEEEEvT_["X"]=1;

function __ZNSt3__119__tree_right_rotateIPNS_16__tree_node_baseIPvEEEEvT_($__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $__y;
      var $8=__stackBase__+24;
      var $9;
      var $10;
      $7=$__x;
      var $11=$7;
      var $12=$11;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      $__y=$14;
      var $15=$__y;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$7;
      var $19=$18;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=$17;
      var $21=$7;
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$5;
      var $26=$6;
      HEAP32[(($5)>>2)]=$8;
      HEAP32[(($6)>>2)]=-1;
      var $27=HEAP32[(($5)>>2)];
      var $28=HEAP32[(($6)>>2)];
      var $29=$3;
      var $30=$4;
      HEAP32[(($3)>>2)]=$27;
      HEAP32[(($4)>>2)]=$28;
      var $31=HEAP32[(($3)>>2)];
      var $32=$3;
      var $33=$4;
      var $34=$5;
      var $35=$6;
      __label__ = 1; break;
    case 1: // $36
      var $37=$1;
      HEAP32[(($1)>>2)]=$8;
      var $38=HEAP32[(($1)>>2)];
      var $39=$1;
      __label__ = 2; break;
    case 2: // $40
      var $41=(($24)|0)!=0;
      if ($41) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $42
      var $43=$7;
      var $44=$7;
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+8)|0);
      HEAP32[(($48)>>2)]=$43;
      __label__ = 5; break;
    case 4: // $53
      var $54=$9;
      ___cxa_call_unexpected($54);
      throw "Reached an unreachable!"
    case 5: // $55
      var $56=$7;
      var $57=(($56+8)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$__y;
      var $60=(($59+8)|0);
      HEAP32[(($60)>>2)]=$58;
      var $61=$7;
      var $62=$2;
      HEAP32[(($2)>>2)]=$61;
      var $63=HEAP32[(($2)>>2)];
      var $64=HEAP32[(($2)>>2)];
      var $65=(($64+8)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$66;
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($63)|0)==(($69)|0);
      var $71=$2;
      if ($70) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $72
      var $73=$__y;
      var $74=$7;
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$76;
      var $78=(($77)|0);
      HEAP32[(($78)>>2)]=$73;
      __label__ = 8; break;
    case 7: // $79
      var $80=$__y;
      var $81=$7;
      var $82=(($81+8)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+4)|0);
      HEAP32[(($84)>>2)]=$80;
      __label__ = 8; break;
    case 8: // $85
      var $86=$7;
      var $87=$__y;
      var $88=(($87+4)|0);
      HEAP32[(($88)>>2)]=$86;
      var $89=$__y;
      var $90=$7;
      var $91=(($90+8)|0);
      HEAP32[(($91)>>2)]=$89;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__119__tree_right_rotateIPNS_16__tree_node_baseIPvEEEEvT_["X"]=1;

function __ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 152; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $__tmp_i=__stackBase__+148;
      var $38;
      $38=$this;
      var $39=$38;
      var $40=$36;
      var $41=$37;
      var $42=$__tmp_i;
      HEAP32[(($36)>>2)]=$39;
      HEAP32[(($37)>>2)]=0;
      var $43=HEAP32[(($36)>>2)];
      var $44=(($43)|0);
      var $45=$35;
      HEAP32[(($35)>>2)]=$44;
      var $46=HEAP32[(($35)>>2)];
      var $47=$46;
      var $48=$34;
      HEAP32[(($34)>>2)]=$47;
      var $49=HEAP32[(($34)>>2)];
      var $50=(($49)|0);
      var $51=$34;
      var $52=$35;
      var $53=HEAP32[(($50)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$53;
      var $54=HEAP32[(($37)>>2)];
      var $55=(($43)|0);
      var $56=$4;
      HEAP32[(($4)>>2)]=$55;
      var $57=HEAP32[(($4)>>2)];
      var $58=$57;
      var $59=$3;
      HEAP32[(($3)>>2)]=$58;
      var $60=HEAP32[(($3)>>2)];
      var $61=(($60)|0);
      var $62=$3;
      var $63=$4;
      HEAP32[(($61)>>2)]=$54;
      var $64=HEAP32[(($__tmp_i)>>2)];
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $66
      var $67=(($43)|0);
      var $68=$2;
      HEAP32[(($2)>>2)]=$67;
      var $69=HEAP32[(($2)>>2)];
      var $70=$69;
      var $71=$1;
      HEAP32[(($1)>>2)]=$70;
      var $72=HEAP32[(($1)>>2)];
      var $73=(($72+4)|0);
      var $74=$1;
      var $75=$2;
      var $76=HEAP32[(($__tmp_i)>>2)];
      var $77=$30;
      var $78=$31;
      var $79=$32;
      var $80=$33;
      HEAP32[(($30)>>2)]=$73;
      HEAP32[(($31)>>2)]=$76;
      var $81=HEAP32[(($30)>>2)];
      var $82=(($81+5)|0);
      var $83=HEAP8[($82)];
      var $84=(($83) & 1);
      if ($84) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $85
      var $86=(($81)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=HEAP32[(($31)>>2)];
      var $89=(($88+16)|0);
      var $90=(($89+4)|0);
      var $91=$29;
      HEAP32[(($29)>>2)]=$90;
      var $92=HEAP32[(($29)>>2)];
      var $93=$92;
      var $94=$93;
      var $95=$29;
      var $96=$15;
      var $97=$16;
      var $98=$17;
      var $99=$18;
      var $100=$19;
      HEAP32[(($16)>>2)]=$87;
      HEAP32[(($17)>>2)]=$94;
      var $101=$19;
      var $102=HEAP32[(($16)>>2)];
      var $103=HEAP32[(($17)>>2)];
      var $tmp_i_i_i=$15;
      var $tmp1_i_i_i=$18;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
      var $104=$13;
      var $105=$14;
      HEAP32[(($13)>>2)]=$102;
      HEAP32[(($14)>>2)]=$103;
      var $106=HEAP32[(($14)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED1Ev]($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE7destroyIS8_EEvRSC_PT__exit_i_i
      var $107=$13;
      var $108=$14;
      var $109=$15;
      var $110=$16;
      var $111=$17;
      var $112=$18;
      var $113=$19;
      __label__ = 5; break;
    case 4: // $114
      var $115=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $116=$115.f0;
      HEAP32[(($32)>>2)]=$116;
      var $117=$115.f1;
      HEAP32[(($33)>>2)]=$117;
      var $118=HEAP32[(($32)>>2)];
      ___cxa_call_unexpected($118);
      throw "Reached an unreachable!"
    case 5: // $119
      var $120=(($81+4)|0);
      var $121=HEAP8[($120)];
      var $122=(($121) & 1);
      if ($122) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $123
      var $124=(($81)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=HEAP32[(($31)>>2)];
      var $127=(($126+16)|0);
      var $128=(($127)|0);
      var $129=$12;
      HEAP32[(($12)>>2)]=$128;
      var $130=HEAP32[(($12)>>2)];
      var $131=$12;
      var $132=$7;
      var $133=$8;
      var $134=$9;
      var $135=$10;
      var $136=$11;
      HEAP32[(($8)>>2)]=$125;
      HEAP32[(($9)>>2)]=$130;
      var $137=$11;
      var $138=HEAP32[(($8)>>2)];
      var $139=HEAP32[(($9)>>2)];
      var $tmp_i1_i_i=$7;
      var $tmp1_i2_i_i=$10;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i1_i_i)]=HEAP8[($tmp1_i2_i_i)];
      var $140=$5;
      var $141=$6;
      HEAP32[(($5)>>2)]=$138;
      HEAP32[(($6)>>2)]=$139;
      var $142=HEAP32[(($6)>>2)];
      var $143=$5;
      var $144=$6;
      var $145=$7;
      var $146=$8;
      var $147=$9;
      var $148=$10;
      var $149=$11;
      __label__ = 7; break;
    case 7: // $150
      var $151=HEAP32[(($31)>>2)];
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $153
      var $154=(($81)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=HEAP32[(($31)>>2)];
      var $157=$26;
      var $158=$27;
      var $159=$28;
      HEAP32[(($26)>>2)]=$155;
      HEAP32[(($27)>>2)]=$156;
      HEAP32[(($28)>>2)]=1;
      var $160=HEAP32[(($26)>>2)];
      var $161=HEAP32[(($27)>>2)];
      var $162=HEAP32[(($28)>>2)];
      var $163=$23;
      var $164=$24;
      var $165=$25;
      HEAP32[(($23)>>2)]=$160;
      HEAP32[(($24)>>2)]=$161;
      HEAP32[(($25)>>2)]=$162;
      var $166=HEAP32[(($23)>>2)];
      var $167=HEAP32[(($24)>>2)];
      var $168=$167;
      var $169=$20;
      var $170=$21;
      var $171=$22;
      HEAP32[(($20)>>2)]=$168;
      var $172=HEAP32[(($20)>>2)];
      var $173=(($172)|0)!=0;
      if ($173) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $174
      var $175=HEAP32[(($20)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($175, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $176
      __label__ = 12; break;
    case 11: // $177
      var $178=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $179=$178.f0;
      HEAP32[(($21)>>2)]=$179;
      var $180=$178.f1;
      HEAP32[(($22)>>2)]=$180;
      var $181=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($181);
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE10deallocateERSC_PSB_j_exit_i_i
      var $182=$20;
      var $183=$21;
      var $184=$22;
      var $185=$23;
      var $186=$24;
      var $187=$25;
      var $188=$26;
      var $189=$27;
      var $190=$28;
      __label__ = 13; break;
    case 13: // $_ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEclEPSB__exit_i
      var $191=$30;
      var $192=$31;
      var $193=$32;
      var $194=$33;
      __label__ = 14; break;
    case 14: // $_ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEE5resetEPSB__exit
      var $195=$36;
      var $196=$37;
      var $197=$__tmp_i;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED2Ev["X"]=1;

function __ZNSt3__119__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEELb1EEC2ES8_($this, $c) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $c; $c = STACKTOP;STACKTOP += 1;STACKTOP = ((((STACKTOP)+3)>>2)<<2);assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");;;HEAP8[($c)]=HEAP8[(tempParam)];
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEC2ERSC_($this, $__na) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__na;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  var $6=(($3+4)|0);
  HEAP8[($6)]=0;
  var $7=(($3+5)|0);
  HEAP8[($7)]=0;
  ;
  return;
}


function __ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC2ERS7_j($this, $__a, $__s) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$__a;
  $3=$__s;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  ;
  return;
}


function __ZNSt3__117__compressed_pairINS_15__tree_end_nodeIPNS_16__tree_node_baseIPvEEEENS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS7_ISC_EEEEEES3_EEEEEC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5;
  $5=$this;
  var $6=$5;
  var $7=$6;
  var $8=$4;
  HEAP32[(($4)>>2)]=$7;
  var $9=HEAP32[(($4)>>2)];
  var $10=$9;
  var $11=$3;
  HEAP32[(($3)>>2)]=$10;
  var $12=HEAP32[(($3)>>2)];
  var $13=$3;
  var $14=(($9)|0);
  var $15=$2;
  HEAP32[(($2)>>2)]=$14;
  var $16=HEAP32[(($2)>>2)];
  var $17=$1;
  HEAP32[(($1)>>2)]=$16;
  var $18=HEAP32[(($1)>>2)];
  var $19=(($18)|0);
  HEAP32[(($19)>>2)]=0;
  var $20=$1;
  var $21=$2;
  var $22=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__117__compressed_pairIjNS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC2Eji($this, $__t1, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $2=__stackBase__;
  var $3=__stackBase__+4;
  var $4=__stackBase__+8;
  var $5=__stackBase__+12;
  var $6=__stackBase__+16;
  var $7;
  var $8=__stackBase__+20;
  var $9;
  $7=$this;
  HEAP32[(($8)>>2)]=$__t1;
  $9=$0;
  var $10=$7;
  var $11=$10;
  var $12=$6;
  HEAP32[(($6)>>2)]=$8;
  var $13=HEAP32[(($6)>>2)];
  var $14=$6;
  var $15=HEAP32[(($13)>>2)];
  var $16=$4;
  var $17=$5;
  HEAP32[(($4)>>2)]=$11;
  HEAP32[(($5)>>2)]=$15;
  var $18=HEAP32[(($4)>>2)];
  var $19=$18;
  var $20=$3;
  HEAP32[(($3)>>2)]=$19;
  var $21=HEAP32[(($3)>>2)];
  var $22=$3;
  var $23=(($18)|0);
  var $24=$2;
  HEAP32[(($2)>>2)]=$5;
  var $25=HEAP32[(($2)>>2)];
  var $26=$2;
  var $27=HEAP32[(($25)>>2)];
  HEAP32[(($23)>>2)]=$27;
  var $28=$4;
  var $29=$5;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__116__list_node_baseIN12_GLOBAL__N_18subrangeEPvEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=$2;
  HEAP32[(($3)>>2)]=$4;
  var $5=(($2+4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  ;
  return;
}


function __ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2EPSB_SE_($this, $__p, $__d) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__d; $__d = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__d)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($__d+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3;
  var $4=__stackBase__+8;
  var $5=__stackBase__+12;
  $3=$this;
  HEAP32[(($4)>>2)]=$__p;
  var $6=$3;
  var $7=(($6)|0);
  var $8=$2;
  HEAP32[(($2)>>2)]=$4;
  var $9=HEAP32[(($2)>>2)];
  var $10=$2;
  var $11=HEAP32[(($9)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$__d;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$5;
  var $16=$13;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[(($16+4)>>2)];
  FUNCTION_TABLE[__ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ESC_SF_]($7, $11, $5);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ESC_SF_($this, $__t1, $__t2) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__t2; $__t2 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__t2)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($__t2+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+28;
  var $8;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  $8=$this;
  HEAP32[(($9)>>2)]=$__t1;
  var $11=$8;
  var $12=$11;
  var $13=$7;
  HEAP32[(($7)>>2)]=$9;
  var $14=HEAP32[(($7)>>2)];
  var $15=$7;
  var $16=HEAP32[(($14)>>2)];
  var $17=$1;
  HEAP32[(($1)>>2)]=$__t2;
  var $18=HEAP32[(($1)>>2)];
  var $19=$1;
  var $20=$10;
  var $21=$18;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];HEAP32[(($20+4)>>2)]=HEAP32[(($21+4)>>2)];
  var $tmp=$6;
  var $tmp1=$10;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];HEAP8[($tmp+4)]=HEAP8[($tmp1+4)];HEAP8[($tmp+5)]=HEAP8[($tmp1+5)];HEAP8[($tmp+6)]=HEAP8[($tmp1+6)];HEAP8[($tmp+7)]=HEAP8[($tmp1+7)];
  var $22=$4;
  var $23=$5;
  HEAP32[(($4)>>2)]=$12;
  HEAP32[(($5)>>2)]=$16;
  var $24=HEAP32[(($4)>>2)];
  var $25=(($24)|0);
  var $26=$3;
  HEAP32[(($3)>>2)]=$5;
  var $27=HEAP32[(($3)>>2)];
  var $28=$3;
  var $29=HEAP32[(($27)>>2)];
  HEAP32[(($25)>>2)]=$29;
  var $30=(($24+4)|0);
  var $31=$2;
  HEAP32[(($2)>>2)]=$6;
  var $32=HEAP32[(($2)>>2)];
  var $33=$2;
  var $34=$30;
  var $35=$32;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];HEAP32[(($34+4)>>2)]=HEAP32[(($35+4)>>2)];
  var $36=$4;
  var $37=$5;
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ESC_SF_["X"]=1;

function __ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ENS_4__rvISF_EE($this, $__u) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__u; $__u = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__u)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  var $__t_i=__stackBase__+40;
  var $11=__stackBase__+44;
  var $12;
  var $13=__stackBase__+48;
  $12=$this;
  var $14=$12;
  var $15=(($14)|0);
  var $16=$11;
  HEAP32[(($11)>>2)]=$__u;
  var $17=HEAP32[(($11)>>2)];
  var $18=(($17)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$11;
  var $21=$10;
  var $22=$__t_i;
  HEAP32[(($10)>>2)]=$19;
  var $23=HEAP32[(($10)>>2)];
  var $24=(($23)|0);
  var $25=$9;
  HEAP32[(($9)>>2)]=$24;
  var $26=HEAP32[(($9)>>2)];
  var $27=$26;
  var $28=$8;
  HEAP32[(($8)>>2)]=$27;
  var $29=HEAP32[(($8)>>2)];
  var $30=(($29)|0);
  var $31=$8;
  var $32=$9;
  var $33=HEAP32[(($30)>>2)];
  HEAP32[(($__t_i)>>2)]=$33;
  var $34=(($23)|0);
  var $35=$7;
  HEAP32[(($7)>>2)]=$34;
  var $36=HEAP32[(($7)>>2)];
  var $37=$36;
  var $38=$6;
  HEAP32[(($6)>>2)]=$37;
  var $39=HEAP32[(($6)>>2)];
  var $40=(($39)|0);
  var $41=$6;
  var $42=$7;
  HEAP32[(($40)>>2)]=0;
  var $43=HEAP32[(($__t_i)>>2)];
  var $44=$10;
  var $45=$__t_i;
  var $46=$1;
  HEAP32[(($1)>>2)]=$__u;
  var $47=HEAP32[(($1)>>2)];
  var $48=(($47)|0);
  var $49=HEAP32[(($48)>>2)];
  var $50=$1;
  var $51=$4;
  HEAP32[(($4)>>2)]=$49;
  var $52=HEAP32[(($4)>>2)];
  var $53=(($52)|0);
  var $54=$3;
  HEAP32[(($3)>>2)]=$53;
  var $55=HEAP32[(($3)>>2)];
  var $56=$55;
  var $57=$2;
  HEAP32[(($2)>>2)]=$56;
  var $58=HEAP32[(($2)>>2)];
  var $59=(($58+4)|0);
  var $60=$2;
  var $61=$3;
  var $62=$4;
  var $63=$5;
  HEAP32[(($5)>>2)]=$59;
  var $64=HEAP32[(($5)>>2)];
  var $65=$5;
  var $66=$13;
  var $67=$64;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($66)>>2)]=HEAP32[(($67)>>2)];HEAP32[(($66+4)>>2)]=HEAP32[(($67+4)>>2)];
  FUNCTION_TABLE[__ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ESC_SF_]($15, $43, $13);
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ENS_4__rvISF_EE["X"]=1;

function __ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2EPS5_S9_($this, $__p, $__d) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__d; $__d = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__d)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($__d+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3;
  var $4=__stackBase__+8;
  var $5=__stackBase__+12;
  $3=$this;
  HEAP32[(($4)>>2)]=$__p;
  var $6=$3;
  var $7=(($6)|0);
  var $8=$2;
  HEAP32[(($2)>>2)]=$4;
  var $9=HEAP32[(($2)>>2)];
  var $10=$2;
  var $11=HEAP32[(($9)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$__d;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$5;
  var $16=$13;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[(($16+4)>>2)];
  FUNCTION_TABLE[__ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC1ES6_SA_]($7, $11, $5);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2ES6_SA_($this, $__t1, $__t2) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__t2; $__t2 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__t2)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($__t2+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+28;
  var $8;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  $8=$this;
  HEAP32[(($9)>>2)]=$__t1;
  var $11=$8;
  var $12=$11;
  var $13=$7;
  HEAP32[(($7)>>2)]=$9;
  var $14=HEAP32[(($7)>>2)];
  var $15=$7;
  var $16=HEAP32[(($14)>>2)];
  var $17=$1;
  HEAP32[(($1)>>2)]=$__t2;
  var $18=HEAP32[(($1)>>2)];
  var $19=$1;
  var $20=$10;
  var $21=$18;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];HEAP32[(($20+4)>>2)]=HEAP32[(($21+4)>>2)];
  var $tmp=$6;
  var $tmp1=$10;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];HEAP8[($tmp+4)]=HEAP8[($tmp1+4)];HEAP8[($tmp+5)]=HEAP8[($tmp1+5)];HEAP8[($tmp+6)]=HEAP8[($tmp1+6)];HEAP8[($tmp+7)]=HEAP8[($tmp1+7)];
  var $22=$4;
  var $23=$5;
  HEAP32[(($4)>>2)]=$12;
  HEAP32[(($5)>>2)]=$16;
  var $24=HEAP32[(($4)>>2)];
  var $25=(($24)|0);
  var $26=$3;
  HEAP32[(($3)>>2)]=$5;
  var $27=HEAP32[(($3)>>2)];
  var $28=$3;
  var $29=HEAP32[(($27)>>2)];
  HEAP32[(($25)>>2)]=$29;
  var $30=(($24+4)|0);
  var $31=$2;
  HEAP32[(($2)>>2)]=$6;
  var $32=HEAP32[(($2)>>2)];
  var $33=$2;
  var $34=$30;
  var $35=$32;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];HEAP32[(($34+4)>>2)]=HEAP32[(($35+4)>>2)];
  var $36=$4;
  var $37=$5;
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2ES6_SA_["X"]=1;

function __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEC2ERKS8_($this, $__comp) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+4;
  $1=$this;
  $2=$__comp;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$2;
  FUNCTION_TABLE[__ZNSt3__119__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEELb1EEC1ES8_]($3, $4);
  FUNCTION_TABLE[__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC1ERKSC_]($6, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC2ERKSC_($this, $__comp) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7;
  var $8;
  var $9=__stackBase__+24;
  $7=$this;
  $8=$__comp;
  var $10=$7;
  var $11=(($10+4)|0);
  FUNCTION_TABLE[__ZNSt3__117__compressed_pairINS_15__tree_end_nodeIPNS_16__tree_node_baseIPvEEEENS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS7_ISC_EEEEEES3_EEEEEC1Ev]($11);
  var $12=(($10+8)|0);
  var $13=$8;
  FUNCTION_TABLE[__ZNSt3__117__compressed_pairIjNS_19__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEENS_4lessIhEELb1EEEEC1EjSA_]($12, 0, $9);
  var $14=$6;
  HEAP32[(($6)>>2)]=$10;
  var $15=HEAP32[(($6)>>2)];
  var $16=(($15+4)|0);
  var $17=$5;
  HEAP32[(($5)>>2)]=$16;
  var $18=HEAP32[(($5)>>2)];
  var $19=$18;
  var $20=$4;
  HEAP32[(($4)>>2)]=$19;
  var $21=HEAP32[(($4)>>2)];
  var $22=(($21)|0);
  var $23=$4;
  var $24=$5;
  var $25=$3;
  HEAP32[(($3)>>2)]=$22;
  var $26=HEAP32[(($3)>>2)];
  var $27=$2;
  HEAP32[(($2)>>2)]=$26;
  var $28=HEAP32[(($2)>>2)];
  var $29=$28;
  var $30=$29;
  var $31=$2;
  var $32=$3;
  var $33=$30;
  var $34=$6;
  var $35=$1;
  HEAP32[(($1)>>2)]=$10;
  var $36=HEAP32[(($1)>>2)];
  var $37=(($36)|0);
  var $38=$1;
  HEAP32[(($37)>>2)]=$33;
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC2ERKSC_["X"]=1;

function __ZNSt3__117__compressed_pairIjNS_19__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEENS_4lessIhEELb1EEEEC2EjSA_($this, $__t1, $__t2) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__t2; $__t2 = STACKTOP;STACKTOP += 1;STACKTOP = ((((STACKTOP)+3)>>2)<<2);assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");;;HEAP8[($__t2)]=HEAP8[(tempParam)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8;
  var $9=__stackBase__+28;
  var $10=__stackBase__+32;
  $8=$this;
  HEAP32[(($9)>>2)]=$__t1;
  var $11=$8;
  var $12=$11;
  var $13=$7;
  HEAP32[(($7)>>2)]=$9;
  var $14=HEAP32[(($7)>>2)];
  var $15=$7;
  var $16=HEAP32[(($14)>>2)];
  var $17=$1;
  HEAP32[(($1)>>2)]=$__t2;
  var $18=HEAP32[(($1)>>2)];
  var $19=$1;
  var $tmp=$6;
  var $tmp1=$10;
  assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];
  var $20=$4;
  var $21=$5;
  HEAP32[(($4)>>2)]=$12;
  HEAP32[(($5)>>2)]=$16;
  var $22=HEAP32[(($4)>>2)];
  var $23=$22;
  var $24=$3;
  HEAP32[(($3)>>2)]=$6;
  var $25=HEAP32[(($3)>>2)];
  var $26=$3;
  var $27=(($22)|0);
  var $28=$2;
  HEAP32[(($2)>>2)]=$5;
  var $29=HEAP32[(($2)>>2)];
  var $30=$2;
  var $31=HEAP32[(($29)>>2)];
  HEAP32[(($27)>>2)]=$31;
  var $32=$4;
  var $33=$5;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$3;
  var $5=$1;
  HEAP32[(($1)>>2)]=$4;
  var $6=HEAP32[(($1)>>2)];
  var $7=(($6)|0);
  FUNCTION_TABLE[__ZNSt3__116__list_node_baseIN12_GLOBAL__N_18subrangeEPvEC1Ev]($7);
  var $8=(($6+8)|0);
  FUNCTION_TABLE[__ZNSt3__117__compressed_pairIjNS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC1Eji]($8, 0, 0);
  var $9=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZN19resource_pool_arrayIN13address_table13subtable_dataEEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIN13address_table13subtable_dataEEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIN13address_table13subtable_dataEEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=(($8*12)|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIN13address_table13subtable_dataEE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIN13address_table13subtable_dataEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIN13address_table13subtable_dataEED2Ev($2);
  ;
  return;
}


function __ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $__tmp_i=__stackBase__+76;
      var $20;
      $20=$this;
      var $21=$20;
      var $22=$18;
      var $23=$19;
      var $24=$__tmp_i;
      HEAP32[(($18)>>2)]=$21;
      HEAP32[(($19)>>2)]=0;
      var $25=HEAP32[(($18)>>2)];
      var $26=(($25)|0);
      var $27=$17;
      HEAP32[(($17)>>2)]=$26;
      var $28=HEAP32[(($17)>>2)];
      var $29=$28;
      var $30=$16;
      HEAP32[(($16)>>2)]=$29;
      var $31=HEAP32[(($16)>>2)];
      var $32=(($31)|0);
      var $33=$16;
      var $34=$17;
      var $35=HEAP32[(($32)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$35;
      var $36=HEAP32[(($19)>>2)];
      var $37=(($25)|0);
      var $38=$4;
      HEAP32[(($4)>>2)]=$37;
      var $39=HEAP32[(($4)>>2)];
      var $40=$39;
      var $41=$3;
      HEAP32[(($3)>>2)]=$40;
      var $42=HEAP32[(($3)>>2)];
      var $43=(($42)|0);
      var $44=$3;
      var $45=$4;
      HEAP32[(($43)>>2)]=$36;
      var $46=HEAP32[(($__tmp_i)>>2)];
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $48
      var $49=(($25)|0);
      var $50=$2;
      HEAP32[(($2)>>2)]=$49;
      var $51=HEAP32[(($2)>>2)];
      var $52=$51;
      var $53=$1;
      HEAP32[(($1)>>2)]=$52;
      var $54=HEAP32[(($1)>>2)];
      var $55=(($54+4)|0);
      var $56=$1;
      var $57=$2;
      var $58=HEAP32[(($__tmp_i)>>2)];
      var $59=$14;
      var $60=$15;
      HEAP32[(($14)>>2)]=$55;
      HEAP32[(($15)>>2)]=$58;
      var $61=HEAP32[(($14)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=HEAP32[(($15)>>2)];
      var $65=(($61+4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$11;
      var $68=$12;
      var $69=$13;
      HEAP32[(($11)>>2)]=$63;
      HEAP32[(($12)>>2)]=$64;
      HEAP32[(($13)>>2)]=$66;
      var $70=HEAP32[(($11)>>2)];
      var $71=HEAP32[(($12)>>2)];
      var $72=HEAP32[(($13)>>2)];
      var $73=$8;
      var $74=$9;
      var $75=$10;
      HEAP32[(($8)>>2)]=$70;
      HEAP32[(($9)>>2)]=$71;
      HEAP32[(($10)>>2)]=$72;
      var $76=HEAP32[(($8)>>2)];
      var $77=HEAP32[(($9)>>2)];
      var $78=$77;
      var $79=$5;
      var $80=$6;
      var $81=$7;
      HEAP32[(($5)>>2)]=$78;
      var $82=HEAP32[(($5)>>2)];
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $84
      var $85=HEAP32[(($5)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($85, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $86
      __label__ = 5; break;
    case 4: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      HEAP32[(($6)>>2)]=$89;
      var $90=$88.f1;
      HEAP32[(($7)>>2)]=$90;
      var $91=HEAP32[(($6)>>2)];
      ___cxa_call_unexpected($91);
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEclEPS6__exit_i
      var $92=$5;
      var $93=$6;
      var $94=$7;
      var $95=$8;
      var $96=$9;
      var $97=$10;
      var $98=$11;
      var $99=$12;
      var $100=$13;
      var $101=$14;
      var $102=$15;
      __label__ = 6; break;
    case 6: // $_ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEE5resetEPS5__exit
      var $103=$18;
      var $104=$19;
      var $105=$__tmp_i;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED2Ev["X"]=1;

function __ZN19resource_pool_arrayIN13address_table13subtable_dataEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN13address_table13subtable_dataEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN13address_table13subtable_dataEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN13address_table13subtable_dataEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIN13address_table13subtable_dataEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIPv13driver_deviceET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI11memory_bankEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11memory_bankEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11memory_bankEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 188);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11memory_bankE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11memory_bankED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11memory_bankED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12memory_blockEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12memory_blockEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12memory_blockEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 28);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12memory_blockE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12memory_blockED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12memory_blockED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejyyEEC2ERK13delegate_baseIvS1_jyyER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIvR13address_spacejyyEC2ERKS2_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyEC2ERKS2_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIvR13address_spacejyyE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejyyE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIvR13address_spacejyyE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejjjEEC2ERK13delegate_baseIvS1_jjjER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIvR13address_spacejjjEC2ERKS2_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjEC2ERKS2_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIvR13address_spacejjjE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejjjE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIvR13address_spacejjjE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejttEEC2ERK13delegate_baseIvS1_jttER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIvR13address_spacejttEC2ERKS2_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttEC2ERKS2_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIvR13address_spacejttE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejttE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIvR13address_spacejttE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFvR13address_spacejhhEEC2ERK13delegate_baseIvS1_jhhER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIvR13address_spacejhhEC2ERKS2_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhEC2ERKS2_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIvR13address_spacejhhE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIvR13address_spacejhhE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIvR13address_spacejhhE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFyR13address_spacejyEEC2ERK13delegate_baseIyS1_jy8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIyR13address_spacejy8_noparamEC2ERKS3_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamEC2ERKS3_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIyR13address_spacejy8_noparamE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIyR13address_spacejy8_noparamE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIyR13address_spacejy8_noparamE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFjR13address_spacejjEEC2ERK13delegate_baseIjS1_jj8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIjR13address_spacejj8_noparamEC2ERKS3_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamEC2ERKS3_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIjR13address_spacejj8_noparamE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIjR13address_spacejj8_noparamE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIjR13address_spacejj8_noparamE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFtR13address_spacejtEEC2ERK13delegate_baseItS1_jt8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseItR13address_spacejt8_noparamEC2ERKS3_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN20resource_pool_objectI11memory_bankED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11memory_bankED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11memory_bankED0Ev["X"]=1;

function __ZN20resource_pool_objectI11memory_bankED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI11memory_bankE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11memory_bankD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11memory_bankED2Ev["X"]=1;

function __ZN20resource_pool_objectI12memory_blockED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12memory_blockED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12memory_blockED0Ev["X"]=1;

function __ZN20resource_pool_objectI12memory_blockED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12memory_blockE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12memory_blockD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12memory_blockED2Ev["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t1ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=382;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=384;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=386;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=388;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=390;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=392;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=394;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=396;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=398;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=400;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=402;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=404;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=406;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=408;
  ;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamEC2ERKS3_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseItR13address_spacejt8_noparamE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseItR13address_spacejt8_noparamE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseItR13address_spacejt8_noparamE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN8delegateIFhR13address_spacejhEEC2ERK13delegate_baseIhS1_jh8_noparamER18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  __ZN13delegate_baseIhR13address_spacejh8_noparamEC2ERKS3_R18delegate_late_bind($5, $6, $7);
  ;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamEC2ERKS3_R18delegate_late_bind($this, $src, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$object;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($5)>>2)]=$8;
  var $9=(($4+4)|0);
  var $10=$2;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  HEAP32[(($9)>>2)]=$12;
  var $13=(($4+8)|0);
  var $14=$2;
  var $15=(($14+8)|0);
  var $16=HEAP32[(($15)>>2)];
  HEAP32[(($13)>>2)]=$16;
  var $17=(($4+12)|0);
  var $18=$2;
  var $19=(($18+12)|0);
  __ZN21delegate_internal_mfpC1ERKS_($17, $19);
  var $20=(($4+20)|0);
  var $21=$2;
  var $22=(($21+20)|0);
  var $23=HEAP32[(($22)>>2)];
  HEAP32[(($20)>>2)]=$23;
  var $24=$3;
  __ZN13delegate_baseIhR13address_spacejh8_noparamE9late_bindER18delegate_late_bind($4, $24);
  ;
  return;
}


function __ZN13delegate_baseIhR13address_spacejh8_noparamE9late_bindER18delegate_late_bind($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=FUNCTION_TABLE[$5]($6);
  __ZN13delegate_baseIhR13address_spacejh8_noparamE4bindEP22delegate_generic_class($3, $7);
  ;
  return;
}


function __ZN20resource_pool_objectI12memory_shareEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12memory_shareEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12memory_shareEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12memory_shareE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12memory_shareED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12memory_shareED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIyL12endianness_t1ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN20resource_pool_objectI12memory_shareED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12memory_shareED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12memory_shareED0Ev["X"]=1;

function __ZN20resource_pool_objectI12memory_shareED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI12memory_shareE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIyL12endianness_t1ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t1ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZNK19address_table_write13handler_writeEj($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$index;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+352)|0);
      var $8=(($7+($6<<2))|0);
      var $9=HEAP32[(($8)>>2)];
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13handler_entry10byteoffsetEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=$2;
  var $5=(($3+12)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4-$6)|0);
  var $8=(($3+20)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$7 & $9;
  ;
  return $10;
}


function __ZNK13handler_entry6ramptrEj($this, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$offset;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  var $8=(($6+$7)|0);
  ;
  return $8;
}


function __ZNK13address_table17lookup_live_smallEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=$2;
  var $5=(($3+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+$4)|0);
  var $8=HEAPU8[($7)];
  var $9=(($8)&255);
  ;
  return $9;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata=__stackBase__+16;
      var $ljmask=__stackBase__+24;
      var $curmask=__stackBase__+32;
      $1=$this;
      $2=$address;
      var $st$13$0=(($3)|0);
      HEAP32[(($st$13$0)>>2)]=$data$0;
      var $st$13$1=(($3+4)|0);
      HEAP32[(($st$13$1)>>2)]=$data$1;
      var $st$17$0=(($4)|0);
      HEAP32[(($st$17$0)>>2)]=$mask$0;
      var $st$17$1=(($4+4)|0);
      HEAP32[(($st$17$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -8;
      var $st$2$0=(($3)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($4)|0);
      var $13$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$6$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $11, $12$0, $12$1, $13$0, $13$1);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -8;
      $2=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $st$8$0=(($3)|0);
      var $20$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$8$1)>>2)];
      var $21$0=$20$0;
      var $21$1=$20$1;
      var $st$14$0=(($ljdata)|0);
      HEAP32[(($st$14$0)>>2)]=$21$0;
      var $st$14$1=(($ljdata+4)|0);
      HEAP32[(($st$14$1)>>2)]=$21$1;
      var $st$18$0=(($4)|0);
      var $22$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($4+4)|0);
      var $22$1=HEAP32[(($st$18$1)>>2)];
      var $23$0=$22$0;
      var $23$1=$22$1;
      var $st$24$0=(($ljmask)|0);
      HEAP32[(($st$24$0)>>2)]=$23$0;
      var $st$24$1=(($ljmask+4)|0);
      HEAP32[(($st$24$1)>>2)]=$23$1;
      var $st$28$0=(($ljmask)|0);
      var $24$0=HEAP32[(($st$28$0)>>2)];
      var $st$28$1=(($ljmask+4)|0);
      var $24$1=HEAP32[(($st$28$1)>>2)];
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"lshr",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$36$0=(($curmask)|0);
      HEAP32[(($st$36$0)>>2)]=$27$0;
      var $st$36$1=(($curmask+4)|0);
      HEAP32[(($st$36$1)>>2)]=$27$1;
      var $st$40$0=(($curmask)|0);
      var $28$0=HEAP32[(($st$40$0)>>2)];
      var $st$40$1=(($curmask+4)|0);
      var $28$1=HEAP32[(($st$40$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $29=$28$0 != $$emscripten$temp$0$0 || $28$1 != $$emscripten$temp$0$1;
      if ($29) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $30
      var $31=$2;
      var $st$1$0=(($ljdata)|0);
      var $32$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($ljdata+4)|0);
      var $32$1=HEAP32[(($st$1$1)>>2)];
      var $33=$offsbits;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"lshr",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$9$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $31, $35$0, $35$1, $36$0, $36$1);
      __label__ = 4; break;
    case 4: // $37
      var $38=$offsbits;
      var $39=((64-$38)|0);
      $offsbits=$39;
      var $st$3$0=(($ljmask)|0);
      var $40$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $40$1=HEAP32[(($st$3$1)>>2)];
      var $41=$offsbits;
      var $42$0=$41;
      var $42$1=0;
      var $43=Runtime.bitshift64($40$0, $40$1,"shl",$42$0);var $43$0 = $43[0], $43$1 = $43[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$43$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$43$1;
      var $st$15$0=(($curmask)|0);
      var $44$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $44$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $45=$44$0 != $$emscripten$temp$1$0 || $44$1 != $$emscripten$temp$1$1;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=(($47+8)|0);
      var $st$2$0=(($ljdata)|0);
      var $49$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($ljdata+4)|0);
      var $49$1=HEAP32[(($st$2$1)>>2)];
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"shl",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $st$10$0=(($curmask)|0);
      var $53$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $53$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $48, $52$0, $52$1, $53$0, $53$1);
      __label__ = 6; break;
    case 6: // $54
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($this, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$data$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$data$1;
      var $st$14$0=(($4)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($4+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIyL12endianness_t1ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $st$7$0=(($28)|0);
      var $29$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$7$1)>>2)];
      var $st$11$0=(($4)|0);
      var $30$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($4+4)|0);
      var $30$1=HEAP32[(($st$11$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $31$0=$30$0 ^ $$emscripten$temp$0$0;
      var $31$1=$30$1 ^ $$emscripten$temp$0$1;
      var $32$0=$29$0 & $31$0;
      var $32$1=$29$1 & $31$1;
      var $st$21$0=(($3)|0);
      var $33$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$21$1)>>2)];
      var $st$25$0=(($4)|0);
      var $34$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($4+4)|0);
      var $34$1=HEAP32[(($st$25$1)>>2)];
      var $35$0=$33$0 & $34$0;
      var $35$1=$33$1 & $34$1;
      var $36$0=$32$0 | $35$0;
      var $36$1=$32$1 | $35$1;
      var $37=$dest;
      var $st$34$0=(($37)|0);
      HEAP32[(($st$34$0)>>2)]=$36$0;
      var $st$34$1=(($37+4)|0);
      HEAP32[(($st$34$1)>>2)]=$36$1;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 3;
      var $st$4$0=(($3)|0);
      var $43$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $43$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($4)|0);
      var $44$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($4+4)|0);
      var $44$1=HEAP32[(($st$8$1)>>2)];
      __ZNK19handler_entry_write7write64ER13address_spacejyy($39, $40, $42, $43$0, $43$1, $44$0, $44$1);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t1ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK19handler_entry_write7write64ER13address_spacejyy($this, $space, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$data$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$data$1;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$mask$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$mask$1;
  var $6=$1;
  var $7=(($6+168)|0);
  var $8=(($7+72)|0);
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $st$22$0=(($4)|0);
  var $12$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($4+4)|0);
  var $12$1=HEAP32[(($st$22$1)>>2)];
  var $st$26$0=(($5)|0);
  var $13$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($5+4)|0);
  var $13$1=HEAP32[(($st$26$1)>>2)];
  __ZNK13delegate_baseIvR13address_spacejyyEclES1_jyy($9, $10, $11, $12$0, $12$1, $13$0, $13$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK13delegate_baseIvR13address_spacejyyEclES1_jyy($this, $p1, $p2, $p3$0, $p3$1, $p4$0, $p4$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+8;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $st$8$0=(($4)|0);
  HEAP32[(($st$8$0)>>2)]=$p3$0;
  var $st$8$1=(($4+4)|0);
  HEAP32[(($st$8$1)>>2)]=$p3$1;
  var $st$12$0=(($5)|0);
  HEAP32[(($st$12$0)>>2)]=$p4$0;
  var $st$12$1=(($5+4)|0);
  HEAP32[(($st$12$1)>>2)]=$p4$1;
  var $6=$1;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=$3;
  var $st$23$0=(($4)|0);
  var $13$0=HEAP32[(($st$23$0)>>2)];
  var $st$23$1=(($4+4)|0);
  var $13$1=HEAP32[(($st$23$1)>>2)];
  var $st$27$0=(($5)|0);
  var $14$0=HEAP32[(($st$27$0)>>2)];
  var $st$27$1=(($5+4)|0);
  var $14$1=HEAP32[(($st$27$1)>>2)];
  FUNCTION_TABLE[$8]($10, $11, $12, $13$0, $13$1, $14$0, $14$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$9$0=(($3)|0);
  HEAP32[(($st$9$0)>>2)]=$data$0;
  var $st$9$1=(($3+4)|0);
  HEAP32[(($st$9$1)>>2)]=$data$1;
  var $st$13$0=(($4)|0);
  HEAP32[(($st$13$0)>>2)]=$mask$0;
  var $st$13$1=(($4+4)|0);
  HEAP32[(($st$13$1)>>2)]=$mask$1;
  var $5=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $6=$2;
  var $7=$6 & -8;
  var $st$22$0=(($3)|0);
  var $8$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$22$1)>>2)];
  var $st$26$0=(($4)|0);
  var $9$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $9$1=HEAP32[(($st$26$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $7, $8$0, $8$1, $9$0, $9$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjy($this, $offset, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $st$0$0=(($3)|0);
      var $22$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $22$1=HEAP32[(($st$0$1)>>2)];
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      var $st$9$0=(($27)|0);
      HEAP32[(($st$9$0)>>2)]=$22$0;
      var $st$9$1=(($27+4)|0);
      HEAP32[(($st$9$1)>>2)]=$22$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      __ZNK19handler_entry_write7write64ER13address_spacejyy($29, $30, $32, $33$0, $33$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjy["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((32-$13)|0);
      $offsbits=$14;
      var $15=$2;
      var $16=$15 & -8;
      var $17=$3;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=$4;
      var $23$0=$22;
      var $23$1=0;
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"shl",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $16, $21$0, $21$1, $26$0, $26$1);
      __label__ = 6; break;
    case 2: // $27
      var $28=$2;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$2;
      var $32=$31 & -8;
      $2=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=32;
      var $33=$3;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=0;
      var $35$1=$34$0;
      var $st$13$0=(($ljdata)|0);
      HEAP32[(($st$13$0)>>2)]=$35$0;
      var $st$13$1=(($ljdata+4)|0);
      HEAP32[(($st$13$1)>>2)]=$35$1;
      var $36=$4;
      var $37$0=$36;
      var $37$1=0;
      var $38$0=0;
      var $38$1=$37$0;
      var $st$22$0=(($ljmask)|0);
      HEAP32[(($st$22$0)>>2)]=$38$0;
      var $st$22$1=(($ljmask+4)|0);
      HEAP32[(($st$22$1)>>2)]=$38$1;
      var $st$26$0=(($ljmask)|0);
      var $39$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($ljmask+4)|0);
      var $39$1=HEAP32[(($st$26$1)>>2)];
      var $40=$offsbits1;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $st$34$0=(($curmask)|0);
      HEAP32[(($st$34$0)>>2)]=$42$0;
      var $st$34$1=(($curmask+4)|0);
      HEAP32[(($st$34$1)>>2)]=$42$1;
      var $st$38$0=(($curmask)|0);
      var $43$0=HEAP32[(($st$38$0)>>2)];
      var $st$38$1=(($curmask+4)|0);
      var $43$1=HEAP32[(($st$38$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $44=$43$0 != $$emscripten$temp$0$0 || $43$1 != $$emscripten$temp$0$1;
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      var $46=$2;
      var $st$1$0=(($ljdata)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($ljdata+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits1;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($curmask)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $46, $50$0, $50$1, $51$0, $51$1);
      __label__ = 4; break;
    case 4: // $52
      var $53=$offsbits1;
      var $54=((64-$53)|0);
      $offsbits1=$54;
      var $st$3$0=(($ljmask)|0);
      var $55$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $55$1=HEAP32[(($st$3$1)>>2)];
      var $56=$offsbits1;
      var $57$0=$56;
      var $57$1=0;
      var $58=Runtime.bitshift64($55$0, $55$1,"shl",$57$0);var $58$0 = $58[0], $58$1 = $58[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$58$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$58$1;
      var $st$15$0=(($curmask)|0);
      var $59$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $59$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $60=$59$0 != $$emscripten$temp$1$0 || $59$1 != $$emscripten$temp$1$1;
      if ($60) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $61
      var $62=$2;
      var $63=(($62+8)|0);
      var $st$2$0=(($ljdata)|0);
      var $64$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($ljdata+4)|0);
      var $64$1=HEAP32[(($st$2$1)>>2)];
      var $65=$offsbits1;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $st$10$0=(($curmask)|0);
      var $68$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $68$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $63, $67$0, $67$1, $68$0, $68$1);
      __label__ = 6; break;
    case 6: // $69
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & 4;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((32-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -8;
  var $13=$3;
  var $14$0=$13;
  var $14$1=0;
  var $15=$offsbits;
  var $16$0=$15;
  var $16$1=0;
  var $17=Runtime.bitshift64($14$0, $14$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
  var $18=$4;
  var $19$0=$18;
  var $19$1=0;
  var $20=$offsbits;
  var $21$0=$20;
  var $21$1=0;
  var $22=Runtime.bitshift64($19$0, $19$1,"shl",$21$0);var $22$0 = $22[0], $22$1 = $22[1];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $12, $17$0, $17$1, $22$0, $22$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((48-$13)|0);
      $offsbits=$14;
      var $15=$2;
      var $16=$15 & -8;
      var $17=$3;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=$4;
      var $23$0=$22;
      var $23$1=0;
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"shl",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $16, $21$0, $21$1, $26$0, $26$1);
      __label__ = 6; break;
    case 2: // $27
      var $28=$2;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$2;
      var $32=$31 & -8;
      $2=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=48;
      var $33=$3;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=(0 << 16) | (0 >>> 16);
      var $35$1=($34$0 << 16) | (0 >>> 16);
      var $st$13$0=(($ljdata)|0);
      HEAP32[(($st$13$0)>>2)]=$35$0;
      var $st$13$1=(($ljdata+4)|0);
      HEAP32[(($st$13$1)>>2)]=$35$1;
      var $36=$4;
      var $37$0=$36;
      var $37$1=0;
      var $38$0=(0 << 16) | (0 >>> 16);
      var $38$1=($37$0 << 16) | (0 >>> 16);
      var $st$22$0=(($ljmask)|0);
      HEAP32[(($st$22$0)>>2)]=$38$0;
      var $st$22$1=(($ljmask+4)|0);
      HEAP32[(($st$22$1)>>2)]=$38$1;
      var $st$26$0=(($ljmask)|0);
      var $39$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($ljmask+4)|0);
      var $39$1=HEAP32[(($st$26$1)>>2)];
      var $40=$offsbits1;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $st$34$0=(($curmask)|0);
      HEAP32[(($st$34$0)>>2)]=$42$0;
      var $st$34$1=(($curmask+4)|0);
      HEAP32[(($st$34$1)>>2)]=$42$1;
      var $st$38$0=(($curmask)|0);
      var $43$0=HEAP32[(($st$38$0)>>2)];
      var $st$38$1=(($curmask+4)|0);
      var $43$1=HEAP32[(($st$38$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $44=$43$0 != $$emscripten$temp$0$0 || $43$1 != $$emscripten$temp$0$1;
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      var $46=$2;
      var $st$1$0=(($ljdata)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($ljdata+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits1;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($curmask)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $46, $50$0, $50$1, $51$0, $51$1);
      __label__ = 4; break;
    case 4: // $52
      var $53=$offsbits1;
      var $54=((64-$53)|0);
      $offsbits1=$54;
      var $st$3$0=(($ljmask)|0);
      var $55$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $55$1=HEAP32[(($st$3$1)>>2)];
      var $56=$offsbits1;
      var $57$0=$56;
      var $57$1=0;
      var $58=Runtime.bitshift64($55$0, $55$1,"shl",$57$0);var $58$0 = $58[0], $58$1 = $58[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$58$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$58$1;
      var $st$15$0=(($curmask)|0);
      var $59$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $59$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $60=$59$0 != $$emscripten$temp$1$0 || $59$1 != $$emscripten$temp$1$1;
      if ($60) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $61
      var $62=$2;
      var $63=(($62+8)|0);
      var $st$2$0=(($ljdata)|0);
      var $64$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($ljdata+4)|0);
      var $64$1=HEAP32[(($st$2$1)>>2)];
      var $65=$offsbits1;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $st$10$0=(($curmask)|0);
      var $68$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $68$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $63, $67$0, $67$1, $68$0, $68$1);
      __label__ = 6; break;
    case 6: // $69
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 6;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((48-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -8;
  var $13=$3;
  var $14$0=$13;
  var $14$1=0;
  var $15=$offsbits;
  var $16$0=$15;
  var $16$1=0;
  var $17=Runtime.bitshift64($14$0, $14$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
  var $18=$4;
  var $19$0=$18;
  var $19$1=0;
  var $20=$offsbits;
  var $21$0=$20;
  var $21$1=0;
  var $22=Runtime.bitshift64($19$0, $19$1,"shl",$21$0);var $22$0 = $22[0], $22$1 = $22[1];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $12, $17$0, $17$1, $22$0, $22$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 7;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((56-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -8;
  var $13=$3;
  var $14$0=$13;
  var $14$1=0;
  var $15=$offsbits;
  var $16$0=$15;
  var $16$1=0;
  var $17=Runtime.bitshift64($14$0, $14$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
  var $18=$4;
  var $19$0=$18;
  var $19$1=0;
  var $20=$offsbits;
  var $21$0=$20;
  var $21$1=0;
  var $22=Runtime.bitshift64($19$0, $19$1,"shl",$21$0);var $22$0 = $22[0], $22$1 = $22[1];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy($5, $12, $17$0, $17$1, $22$0, $22$1);
  ;
  return;
}


function __ZN13address_table18enable_watchpointsEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $12 = ((__ZN13address_table18s_watchpoint_tableE)|0);__label__ = 3; break;
    case 2: // $8
      var $9=(($4+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $12 = $10;__label__ = 3; break;
    case 3: // $11
      var $12;
      var $13=(($4+8)|0);
      HEAP32[(($13)>>2)]=$12;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result=__stackBase__+16;
      var $ljmask=__stackBase__+24;
      var $curmask=__stackBase__+32;
      $2=$this;
      $3=$address;
      var $st$13$0=(($4)|0);
      HEAP32[(($st$13$0)>>2)]=$mask$0;
      var $st$13$1=(($4+4)|0);
      HEAP32[(($st$13$1)>>2)]=$mask$1;
      var $5=$2;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$3;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -8;
      var $st$2$0=(($4)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($4+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $13=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $11, $12$0, $12$1);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$13$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$13$1;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -8;
      $3=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $st$14$0=(($4)|0);
      var $20$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($4+4)|0);
      var $20$1=HEAP32[(($st$14$1)>>2)];
      var $21$0=$20$0;
      var $21$1=$20$1;
      var $st$20$0=(($ljmask)|0);
      HEAP32[(($st$20$0)>>2)]=$21$0;
      var $st$20$1=(($ljmask+4)|0);
      HEAP32[(($st$20$1)>>2)]=$21$1;
      var $st$24$0=(($ljmask)|0);
      var $22$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($ljmask+4)|0);
      var $22$1=HEAP32[(($st$24$1)>>2)];
      var $23=$offsbits;
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($22$0, $22$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $st$32$0=(($curmask)|0);
      HEAP32[(($st$32$0)>>2)]=$25$0;
      var $st$32$1=(($curmask+4)|0);
      HEAP32[(($st$32$1)>>2)]=$25$1;
      var $st$36$0=(($curmask)|0);
      var $26$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($curmask+4)|0);
      var $26$1=HEAP32[(($st$36$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $27=$26$0 != $$emscripten$temp$1$0 || $26$1 != $$emscripten$temp$1$1;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$3;
      var $st$1$0=(($curmask)|0);
      var $30$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $30$1=HEAP32[(($st$1$1)>>2)];
      var $31=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $29, $30$0, $30$1);
      var $31$0=$31[0];
      var $31$1=$31[1];
      var $32=$offsbits;
      var $33$0=$32;
      var $33$1=0;
      var $34=Runtime.bitshift64($31$0, $31$1,"shl",$33$0);var $34$0 = $34[0], $34$1 = $34[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$34$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$34$1;
      __label__ = 4; break;
    case 4: // $35
      var $36=$offsbits;
      var $37=((64-$36)|0);
      $offsbits=$37;
      var $st$3$0=(($ljmask)|0);
      var $38$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $38$1=HEAP32[(($st$3$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"shl",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$41$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$41$1;
      var $st$15$0=(($curmask)|0);
      var $42$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $42$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $43=$42$0 != $$emscripten$temp$2$0 || $42$1 != $$emscripten$temp$2$1;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$3;
      var $46=(($45+8)|0);
      var $st$2$0=(($curmask)|0);
      var $47$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $47$1=HEAP32[(($st$2$1)>>2)];
      var $48=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $46, $47$0, $47$1);
      var $48$0=$48[0];
      var $48$1=$48[1];
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$13$0=(($result)|0);
      var $52$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $52$1=HEAP32[(($st$13$1)>>2)];
      var $53$0=$52$0 | $51$0;
      var $53$1=$52$1 | $51$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$53$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$53$1;
      __label__ = 6; break;
    case 6: // $54
      var $st$0$0=(($result)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      var $56$0=$55$0;
      var $56$1=$55$1;
      var $st$6$0=(($1)|0);
      HEAP32[(($st$6$0)>>2)]=$56$0;
      var $st$6$1=(($1+4)|0);
      HEAP32[(($st$6$1)>>2)]=$56$1;
      __label__ = 7; break;
    case 7: // $57
      var $st$0$0=(($1)|0);
      var $58$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $58$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$58$0,$58$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($this, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__+8;
      $1=$this;
      $2=$offset;
      var $st$9$0=(($3)|0);
      HEAP32[(($st$9$0)>>2)]=$mask$0;
      var $st$9$1=(($3+4)|0);
      HEAP32[(($st$9$1)>>2)]=$mask$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $st$5$0=(($26)|0);
      var $27$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $34=__ZNK18handler_entry_read6read64ER13address_spacejy($29, $30, $32, $33$0, $33$1);
      var $34$0=$34[0];
      var $34$1=$34[1];
      var $st$11$0=(($result)|0);
      HEAP32[(($st$11$0)>>2)]=$34$0;
      var $st$11$1=(($result+4)|0);
      HEAP32[(($st$11$1)>>2)]=$34$1;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $36$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $36$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$36$0,$36$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t1ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK18handler_entry_read6read64ER13address_spacejy($this, $space, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$space;
  $3=$offset;
  var $st$7$0=(($4)|0);
  HEAP32[(($st$7$0)>>2)]=$mask$0;
  var $st$7$1=(($4+4)|0);
  HEAP32[(($st$7$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=(($5+168)|0);
  var $7=(($6+72)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $st$17$0=(($4)|0);
  var $11$0=HEAP32[(($st$17$0)>>2)];
  var $st$17$1=(($4+4)|0);
  var $11$1=HEAP32[(($st$17$1)>>2)];
  var $12=__ZNK13delegate_baseIyR13address_spacejy8_noparamEclES1_jy($8, $9, $10, $11$0, $11$1);
  var $12$0=$12[0];
  var $12$1=$12[1];
  STACKTOP = __stackBase__;
  return [$12$0,$12$1];
}


function __ZNK13delegate_baseIyR13address_spacejy8_noparamEclES1_jy($this, $p1, $p2, $p3$0, $p3$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $st$7$0=(($4)|0);
  HEAP32[(($st$7$0)>>2)]=$p3$0;
  var $st$7$1=(($4+4)|0);
  HEAP32[(($st$7$1)>>2)]=$p3$1;
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($5+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=$3;
  var $st$18$0=(($4)|0);
  var $12$0=HEAP32[(($st$18$0)>>2)];
  var $st$18$1=(($4+4)|0);
  var $12$1=HEAP32[(($st$18$1)>>2)];
  var $13=FUNCTION_TABLE[$7]($9, $10, $11, $12$0, $12$1);
  var $13$0=$13[0];
  var $13$1=$13[1];
  STACKTOP = __stackBase__;
  return [$13$0,$13$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$8$0=(($3)|0);
  HEAP32[(($st$8$0)>>2)]=$mask$0;
  var $st$8$1=(($3+4)|0);
  HEAP32[(($st$8$1)>>2)]=$mask$1;
  var $4=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $5=$2;
  var $6=$5 & -8;
  var $st$17$0=(($3)|0);
  var $7$0=HEAP32[(($st$17$0)>>2)];
  var $st$17$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$17$1)>>2)];
  var $8=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($4, $6, $7$0, $7$1);
  var $8$0=$8[0];
  var $8$1=$8[1];
  STACKTOP = __stackBase__;
  return [$8$0,$8$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEj($this, $offset) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIyL12endianness_t1ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $st$5$0=(($25)|0);
      var $26$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$26$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$26$1;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 3;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $32=__ZNK18handler_entry_read6read64ER13address_spacejy($28, $29, $31, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $32$0=$32[0];
      var $32$1=$32[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$32$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$32$1;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $34$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $34$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$34$0,$34$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEj["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((32-$13)|0);
      $offsbits=$14;
      var $15=$3;
      var $16=$15 & -8;
      var $17=$4;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $16, $21$0, $21$1);
      var $22$0=$22[0];
      var $22$1=$22[1];
      var $23=$offsbits;
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($22$0, $22$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $26$0=$25$0;
      var $26=$26$0;
      $1=$26;
      __label__ = 7; break;
    case 2: // $27
      var $28=$3;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$3;
      var $32=$31 & -8;
      $3=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=32;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $33=$4;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=0;
      var $35$1=$34$0;
      var $st$19$0=(($ljmask)|0);
      HEAP32[(($st$19$0)>>2)]=$35$0;
      var $st$19$1=(($ljmask+4)|0);
      HEAP32[(($st$19$1)>>2)]=$35$1;
      var $st$23$0=(($ljmask)|0);
      var $36$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($ljmask+4)|0);
      var $36$1=HEAP32[(($st$23$1)>>2)];
      var $37=$offsbits1;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$31$0=(($curmask)|0);
      HEAP32[(($st$31$0)>>2)]=$39$0;
      var $st$31$1=(($curmask+4)|0);
      HEAP32[(($st$31$1)>>2)]=$39$1;
      var $st$35$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$35$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $41=$40$0 != $$emscripten$temp$1$0 || $40$1 != $$emscripten$temp$1$1;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$3;
      var $st$1$0=(($curmask)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $43, $44$0, $44$1);
      var $45$0=$45[0];
      var $45$1=$45[1];
      var $46=$offsbits1;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"shl",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$48$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$48$1;
      __label__ = 4; break;
    case 4: // $49
      var $50=$offsbits1;
      var $51=((64-$50)|0);
      $offsbits1=$51;
      var $st$3$0=(($ljmask)|0);
      var $52$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $52$1=HEAP32[(($st$3$1)>>2)];
      var $53=$offsbits1;
      var $54$0=$53;
      var $54$1=0;
      var $55=Runtime.bitshift64($52$0, $52$1,"shl",$54$0);var $55$0 = $55[0], $55$1 = $55[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$55$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$55$1;
      var $st$15$0=(($curmask)|0);
      var $56$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $56$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $57=$56$0 != $$emscripten$temp$2$0 || $56$1 != $$emscripten$temp$2$1;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$3;
      var $60=(($59+8)|0);
      var $st$2$0=(($curmask)|0);
      var $61$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $61$1=HEAP32[(($st$2$1)>>2)];
      var $62=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $60, $61$0, $61$1);
      var $62$0=$62[0];
      var $62$1=$62[1];
      var $63=$offsbits1;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $st$13$0=(($result)|0);
      var $66$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $66$1=HEAP32[(($st$13$1)>>2)];
      var $67$0=$66$0 | $65$0;
      var $67$1=$66$1 | $65$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$67$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$67$1;
      __label__ = 6; break;
    case 6: // $68
      var $st$0$0=(($result)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $69$1=HEAP32[(($st$0$1)>>2)];
      var $70$0=$69$1;
      var $70$1=0;
      var $71$0=$70$0;
      var $71=$71$0;
      $1=$71;
      __label__ = 7; break;
    case 7: // $72
      var $73=$1;
      STACKTOP = __stackBase__;
      return $73;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & 4;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((32-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -8;
  var $12=$3;
  var $13$0=$12;
  var $13$1=0;
  var $14=$offsbits;
  var $15$0=$14;
  var $15$1=0;
  var $16=Runtime.bitshift64($13$0, $13$1,"shl",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
  var $17=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($4, $11, $16$0, $16$1);
  var $17$0=$17[0];
  var $17$1=$17[1];
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"lshr",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  var $21$0=$20$0;
  var $21=$21$0;
  ;
  return $21;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((48-$13)|0);
      $offsbits=$14;
      var $15=$3;
      var $16=$15 & -8;
      var $17=$4;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $16, $21$0, $21$1);
      var $22$0=$22[0];
      var $22$1=$22[1];
      var $23=$offsbits;
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($22$0, $22$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $26$0=$25$0;
      var $26=$26$0&65535;
      $1=$26;
      __label__ = 7; break;
    case 2: // $27
      var $28=$3;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$3;
      var $32=$31 & -8;
      $3=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=48;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $33=$4;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=(0 << 16) | (0 >>> 16);
      var $35$1=($34$0 << 16) | (0 >>> 16);
      var $st$19$0=(($ljmask)|0);
      HEAP32[(($st$19$0)>>2)]=$35$0;
      var $st$19$1=(($ljmask+4)|0);
      HEAP32[(($st$19$1)>>2)]=$35$1;
      var $st$23$0=(($ljmask)|0);
      var $36$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($ljmask+4)|0);
      var $36$1=HEAP32[(($st$23$1)>>2)];
      var $37=$offsbits1;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$31$0=(($curmask)|0);
      HEAP32[(($st$31$0)>>2)]=$39$0;
      var $st$31$1=(($curmask+4)|0);
      HEAP32[(($st$31$1)>>2)]=$39$1;
      var $st$35$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$35$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $41=$40$0 != $$emscripten$temp$1$0 || $40$1 != $$emscripten$temp$1$1;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$3;
      var $st$1$0=(($curmask)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $43, $44$0, $44$1);
      var $45$0=$45[0];
      var $45$1=$45[1];
      var $46=$offsbits1;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"shl",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$48$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$48$1;
      __label__ = 4; break;
    case 4: // $49
      var $50=$offsbits1;
      var $51=((64-$50)|0);
      $offsbits1=$51;
      var $st$3$0=(($ljmask)|0);
      var $52$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $52$1=HEAP32[(($st$3$1)>>2)];
      var $53=$offsbits1;
      var $54$0=$53;
      var $54$1=0;
      var $55=Runtime.bitshift64($52$0, $52$1,"shl",$54$0);var $55$0 = $55[0], $55$1 = $55[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$55$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$55$1;
      var $st$15$0=(($curmask)|0);
      var $56$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $56$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $57=$56$0 != $$emscripten$temp$2$0 || $56$1 != $$emscripten$temp$2$1;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$3;
      var $60=(($59+8)|0);
      var $st$2$0=(($curmask)|0);
      var $61$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $61$1=HEAP32[(($st$2$1)>>2)];
      var $62=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($5, $60, $61$0, $61$1);
      var $62$0=$62[0];
      var $62$1=$62[1];
      var $63=$offsbits1;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $st$13$0=(($result)|0);
      var $66$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $66$1=HEAP32[(($st$13$1)>>2)];
      var $67$0=$66$0 | $65$0;
      var $67$1=$66$1 | $65$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$67$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$67$1;
      __label__ = 6; break;
    case 6: // $68
      var $st$0$0=(($result)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $69$1=HEAPU32[(($st$0$1)>>2)];
      var $70$0=($69$1 >>> 16) | (0 << 16);
      var $70$1=(0 >>> 16) | (0 << 16);
      var $71$0=$70$0;
      var $71=$71$0&65535;
      $1=$71;
      __label__ = 7; break;
    case 7: // $72
      var $73=$1;
      STACKTOP = __stackBase__;
      return $73;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 6;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((48-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -8;
  var $12=$3;
  var $13$0=$12;
  var $13$1=0;
  var $14=$offsbits;
  var $15$0=$14;
  var $15$1=0;
  var $16=Runtime.bitshift64($13$0, $13$1,"shl",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
  var $17=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($4, $11, $16$0, $16$1);
  var $17$0=$17[0];
  var $17$1=$17[1];
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"lshr",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  var $21$0=$20$0;
  var $21=$21$0&65535;
  ;
  return $21;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 7;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((56-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -8;
  var $12=$3;
  var $13$0=$12;
  var $13$1=0;
  var $14=$offsbits;
  var $15$0=$14;
  var $15$1=0;
  var $16=Runtime.bitshift64($13$0, $13$1,"shl",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
  var $17=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy($4, $11, $16$0, $16$1);
  var $17$0=$17[0];
  var $17$1=$17[1];
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"lshr",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  var $21$0=$20$0;
  var $21=$21$0&255;
  ;
  return $21;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIyL12endianness_t1ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22address_space_specificIyL12endianness_t1ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=410;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=412;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=414;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=416;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=418;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=420;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=422;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=424;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=426;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=428;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=430;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=432;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=434;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=436;
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIyL12endianness_t1ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata=__stackBase__+16;
      var $ljmask=__stackBase__+24;
      var $curmask=__stackBase__+32;
      $1=$this;
      $2=$address;
      var $st$13$0=(($3)|0);
      HEAP32[(($st$13$0)>>2)]=$data$0;
      var $st$13$1=(($3+4)|0);
      HEAP32[(($st$13$1)>>2)]=$data$1;
      var $st$17$0=(($4)|0);
      HEAP32[(($st$17$0)>>2)]=$mask$0;
      var $st$17$1=(($4+4)|0);
      HEAP32[(($st$17$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -8;
      var $st$2$0=(($3)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($4)|0);
      var $13$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$6$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $11, $12$0, $12$1, $13$0, $13$1);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -8;
      $2=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $st$8$0=(($3)|0);
      var $20$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$8$1)>>2)];
      var $21$0=$20$0;
      var $21$1=$20$1;
      var $st$14$0=(($ljdata)|0);
      HEAP32[(($st$14$0)>>2)]=$21$0;
      var $st$14$1=(($ljdata+4)|0);
      HEAP32[(($st$14$1)>>2)]=$21$1;
      var $st$18$0=(($4)|0);
      var $22$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($4+4)|0);
      var $22$1=HEAP32[(($st$18$1)>>2)];
      var $23$0=$22$0;
      var $23$1=$22$1;
      var $st$24$0=(($ljmask)|0);
      HEAP32[(($st$24$0)>>2)]=$23$0;
      var $st$24$1=(($ljmask+4)|0);
      HEAP32[(($st$24$1)>>2)]=$23$1;
      var $st$28$0=(($ljmask)|0);
      var $24$0=HEAP32[(($st$28$0)>>2)];
      var $st$28$1=(($ljmask+4)|0);
      var $24$1=HEAP32[(($st$28$1)>>2)];
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"lshr",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$36$0=(($curmask)|0);
      HEAP32[(($st$36$0)>>2)]=$27$0;
      var $st$36$1=(($curmask+4)|0);
      HEAP32[(($st$36$1)>>2)]=$27$1;
      var $st$40$0=(($curmask)|0);
      var $28$0=HEAP32[(($st$40$0)>>2)];
      var $st$40$1=(($curmask+4)|0);
      var $28$1=HEAP32[(($st$40$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $29=$28$0 != $$emscripten$temp$0$0 || $28$1 != $$emscripten$temp$0$1;
      if ($29) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $30
      var $31=$2;
      var $st$1$0=(($ljdata)|0);
      var $32$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($ljdata+4)|0);
      var $32$1=HEAP32[(($st$1$1)>>2)];
      var $33=$offsbits;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"lshr",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$9$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $31, $35$0, $35$1, $36$0, $36$1);
      __label__ = 4; break;
    case 4: // $37
      var $38=$offsbits;
      var $39=((64-$38)|0);
      $offsbits=$39;
      var $st$3$0=(($ljmask)|0);
      var $40$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $40$1=HEAP32[(($st$3$1)>>2)];
      var $41=$offsbits;
      var $42$0=$41;
      var $42$1=0;
      var $43=Runtime.bitshift64($40$0, $40$1,"shl",$42$0);var $43$0 = $43[0], $43$1 = $43[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$43$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$43$1;
      var $st$15$0=(($curmask)|0);
      var $44$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $44$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $45=$44$0 != $$emscripten$temp$1$0 || $44$1 != $$emscripten$temp$1$1;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=(($47+8)|0);
      var $st$2$0=(($ljdata)|0);
      var $49$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($ljdata+4)|0);
      var $49$1=HEAP32[(($st$2$1)>>2)];
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"shl",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $st$10$0=(($curmask)|0);
      var $53$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $53$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $48, $52$0, $52$1, $53$0, $53$1);
      __label__ = 6; break;
    case 6: // $54
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIyL12endianness_t1ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t1ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EED0Ev["X"]=1;

function __ZNK13address_table18level1_index_largeEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 >>> 14;
  ;
  return $5;
}


function __ZNK13address_table18level2_index_largeEhj($this, $l1entry, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$l1entry;
  $3=$address;
  var $4=$1;
  var $5=$2;
  var $6=(($5)&255);
  var $7=(($6-192)|0);
  var $8=$7 << 14;
  var $9=(($8+262144)|0);
  var $10=$3;
  var $11=$10 & 16383;
  var $12=(($9+$11)|0);
  ;
  return $12;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($this, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$data$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$data$1;
      var $st$14$0=(($4)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($4+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIyL12endianness_t1ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $st$7$0=(($28)|0);
      var $29$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$7$1)>>2)];
      var $st$11$0=(($4)|0);
      var $30$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($4+4)|0);
      var $30$1=HEAP32[(($st$11$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $31$0=$30$0 ^ $$emscripten$temp$0$0;
      var $31$1=$30$1 ^ $$emscripten$temp$0$1;
      var $32$0=$29$0 & $31$0;
      var $32$1=$29$1 & $31$1;
      var $st$21$0=(($3)|0);
      var $33$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$21$1)>>2)];
      var $st$25$0=(($4)|0);
      var $34$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($4+4)|0);
      var $34$1=HEAP32[(($st$25$1)>>2)];
      var $35$0=$33$0 & $34$0;
      var $35$1=$33$1 & $34$1;
      var $36$0=$32$0 | $35$0;
      var $36$1=$32$1 | $35$1;
      var $37=$dest;
      var $st$34$0=(($37)|0);
      HEAP32[(($st$34$0)>>2)]=$36$0;
      var $st$34$1=(($37+4)|0);
      HEAP32[(($st$34$1)>>2)]=$36$1;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 3;
      var $st$4$0=(($3)|0);
      var $43$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $43$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($4)|0);
      var $44$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($4+4)|0);
      var $44$1=HEAP32[(($st$8$1)>>2)];
      __ZNK19handler_entry_write7write64ER13address_spacejyy($39, $40, $42, $43$0, $43$1, $44$0, $44$1);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t1ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZNK13address_table17lookup_live_largeEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $entry;
      $1=$this;
      $2=$byteaddress;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK13address_table18level1_index_largeEj($3, $4);
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7+$5)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      $entry=$10;
      var $11=$entry;
      var $12=(($11)>>>0) >= 192;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$entry;
      var $15=(($14) & 255);
      var $16=$2;
      var $17=__ZNK13address_table18level2_index_largeEhj($3, $15, $16);
      var $18=(($3+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+$17)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      $entry=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$entry;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$9$0=(($3)|0);
  HEAP32[(($st$9$0)>>2)]=$data$0;
  var $st$9$1=(($3+4)|0);
  HEAP32[(($st$9$1)>>2)]=$data$1;
  var $st$13$0=(($4)|0);
  HEAP32[(($st$13$0)>>2)]=$mask$0;
  var $st$13$1=(($4+4)|0);
  HEAP32[(($st$13$1)>>2)]=$mask$1;
  var $5=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $6=$2;
  var $7=$6 & -8;
  var $st$22$0=(($3)|0);
  var $8$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$22$1)>>2)];
  var $st$26$0=(($4)|0);
  var $9$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $9$1=HEAP32[(($st$26$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $7, $8$0, $8$1, $9$0, $9$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjy($this, $offset, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $st$0$0=(($3)|0);
      var $22$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $22$1=HEAP32[(($st$0$1)>>2)];
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      var $st$9$0=(($27)|0);
      HEAP32[(($st$9$0)>>2)]=$22$0;
      var $st$9$1=(($27+4)|0);
      HEAP32[(($st$9$1)>>2)]=$22$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      __ZNK19handler_entry_write7write64ER13address_spacejyy($29, $30, $32, $33$0, $33$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjy["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((32-$13)|0);
      $offsbits=$14;
      var $15=$2;
      var $16=$15 & -8;
      var $17=$3;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=$4;
      var $23$0=$22;
      var $23$1=0;
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"shl",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $16, $21$0, $21$1, $26$0, $26$1);
      __label__ = 6; break;
    case 2: // $27
      var $28=$2;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$2;
      var $32=$31 & -8;
      $2=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=32;
      var $33=$3;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=0;
      var $35$1=$34$0;
      var $st$13$0=(($ljdata)|0);
      HEAP32[(($st$13$0)>>2)]=$35$0;
      var $st$13$1=(($ljdata+4)|0);
      HEAP32[(($st$13$1)>>2)]=$35$1;
      var $36=$4;
      var $37$0=$36;
      var $37$1=0;
      var $38$0=0;
      var $38$1=$37$0;
      var $st$22$0=(($ljmask)|0);
      HEAP32[(($st$22$0)>>2)]=$38$0;
      var $st$22$1=(($ljmask+4)|0);
      HEAP32[(($st$22$1)>>2)]=$38$1;
      var $st$26$0=(($ljmask)|0);
      var $39$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($ljmask+4)|0);
      var $39$1=HEAP32[(($st$26$1)>>2)];
      var $40=$offsbits1;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $st$34$0=(($curmask)|0);
      HEAP32[(($st$34$0)>>2)]=$42$0;
      var $st$34$1=(($curmask+4)|0);
      HEAP32[(($st$34$1)>>2)]=$42$1;
      var $st$38$0=(($curmask)|0);
      var $43$0=HEAP32[(($st$38$0)>>2)];
      var $st$38$1=(($curmask+4)|0);
      var $43$1=HEAP32[(($st$38$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $44=$43$0 != $$emscripten$temp$0$0 || $43$1 != $$emscripten$temp$0$1;
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      var $46=$2;
      var $st$1$0=(($ljdata)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($ljdata+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits1;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($curmask)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $46, $50$0, $50$1, $51$0, $51$1);
      __label__ = 4; break;
    case 4: // $52
      var $53=$offsbits1;
      var $54=((64-$53)|0);
      $offsbits1=$54;
      var $st$3$0=(($ljmask)|0);
      var $55$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $55$1=HEAP32[(($st$3$1)>>2)];
      var $56=$offsbits1;
      var $57$0=$56;
      var $57$1=0;
      var $58=Runtime.bitshift64($55$0, $55$1,"shl",$57$0);var $58$0 = $58[0], $58$1 = $58[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$58$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$58$1;
      var $st$15$0=(($curmask)|0);
      var $59$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $59$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $60=$59$0 != $$emscripten$temp$1$0 || $59$1 != $$emscripten$temp$1$1;
      if ($60) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $61
      var $62=$2;
      var $63=(($62+8)|0);
      var $st$2$0=(($ljdata)|0);
      var $64$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($ljdata+4)|0);
      var $64$1=HEAP32[(($st$2$1)>>2)];
      var $65=$offsbits1;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $st$10$0=(($curmask)|0);
      var $68$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $68$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $63, $67$0, $67$1, $68$0, $68$1);
      __label__ = 6; break;
    case 6: // $69
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & 4;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((32-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -8;
  var $13=$3;
  var $14$0=$13;
  var $14$1=0;
  var $15=$offsbits;
  var $16$0=$15;
  var $16$1=0;
  var $17=Runtime.bitshift64($14$0, $14$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
  var $18=$4;
  var $19$0=$18;
  var $19$1=0;
  var $20=$offsbits;
  var $21$0=$20;
  var $21$1=0;
  var $22=Runtime.bitshift64($19$0, $19$1,"shl",$21$0);var $22$0 = $22[0], $22$1 = $22[1];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $12, $17$0, $17$1, $22$0, $22$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((48-$13)|0);
      $offsbits=$14;
      var $15=$2;
      var $16=$15 & -8;
      var $17=$3;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=$4;
      var $23$0=$22;
      var $23$1=0;
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"shl",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $16, $21$0, $21$1, $26$0, $26$1);
      __label__ = 6; break;
    case 2: // $27
      var $28=$2;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$2;
      var $32=$31 & -8;
      $2=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=48;
      var $33=$3;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=(0 << 16) | (0 >>> 16);
      var $35$1=($34$0 << 16) | (0 >>> 16);
      var $st$13$0=(($ljdata)|0);
      HEAP32[(($st$13$0)>>2)]=$35$0;
      var $st$13$1=(($ljdata+4)|0);
      HEAP32[(($st$13$1)>>2)]=$35$1;
      var $36=$4;
      var $37$0=$36;
      var $37$1=0;
      var $38$0=(0 << 16) | (0 >>> 16);
      var $38$1=($37$0 << 16) | (0 >>> 16);
      var $st$22$0=(($ljmask)|0);
      HEAP32[(($st$22$0)>>2)]=$38$0;
      var $st$22$1=(($ljmask+4)|0);
      HEAP32[(($st$22$1)>>2)]=$38$1;
      var $st$26$0=(($ljmask)|0);
      var $39$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($ljmask+4)|0);
      var $39$1=HEAP32[(($st$26$1)>>2)];
      var $40=$offsbits1;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $st$34$0=(($curmask)|0);
      HEAP32[(($st$34$0)>>2)]=$42$0;
      var $st$34$1=(($curmask+4)|0);
      HEAP32[(($st$34$1)>>2)]=$42$1;
      var $st$38$0=(($curmask)|0);
      var $43$0=HEAP32[(($st$38$0)>>2)];
      var $st$38$1=(($curmask+4)|0);
      var $43$1=HEAP32[(($st$38$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $44=$43$0 != $$emscripten$temp$0$0 || $43$1 != $$emscripten$temp$0$1;
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      var $46=$2;
      var $st$1$0=(($ljdata)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($ljdata+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits1;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($curmask)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $46, $50$0, $50$1, $51$0, $51$1);
      __label__ = 4; break;
    case 4: // $52
      var $53=$offsbits1;
      var $54=((64-$53)|0);
      $offsbits1=$54;
      var $st$3$0=(($ljmask)|0);
      var $55$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $55$1=HEAP32[(($st$3$1)>>2)];
      var $56=$offsbits1;
      var $57$0=$56;
      var $57$1=0;
      var $58=Runtime.bitshift64($55$0, $55$1,"shl",$57$0);var $58$0 = $58[0], $58$1 = $58[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$58$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$58$1;
      var $st$15$0=(($curmask)|0);
      var $59$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $59$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $60=$59$0 != $$emscripten$temp$1$0 || $59$1 != $$emscripten$temp$1$1;
      if ($60) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $61
      var $62=$2;
      var $63=(($62+8)|0);
      var $st$2$0=(($ljdata)|0);
      var $64$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($ljdata+4)|0);
      var $64$1=HEAP32[(($st$2$1)>>2)];
      var $65=$offsbits1;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $st$10$0=(($curmask)|0);
      var $68$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $68$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $63, $67$0, $67$1, $68$0, $68$1);
      __label__ = 6; break;
    case 6: // $69
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 6;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((48-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -8;
  var $13=$3;
  var $14$0=$13;
  var $14$1=0;
  var $15=$offsbits;
  var $16$0=$15;
  var $16$1=0;
  var $17=Runtime.bitshift64($14$0, $14$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
  var $18=$4;
  var $19$0=$18;
  var $19$1=0;
  var $20=$offsbits;
  var $21$0=$20;
  var $21$1=0;
  var $22=Runtime.bitshift64($19$0, $19$1,"shl",$21$0);var $22$0 = $22[0], $22$1 = $22[1];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $12, $17$0, $17$1, $22$0, $22$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 7;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((56-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -8;
  var $13=$3;
  var $14$0=$13;
  var $14$1=0;
  var $15=$offsbits;
  var $16$0=$15;
  var $16$1=0;
  var $17=Runtime.bitshift64($14$0, $14$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
  var $18=$4;
  var $19$0=$18;
  var $19$1=0;
  var $20=$offsbits;
  var $21$0=$20;
  var $21$1=0;
  var $22=Runtime.bitshift64($19$0, $19$1,"shl",$21$0);var $22$0 = $22[0], $22$1 = $22[1];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy($5, $12, $17$0, $17$1, $22$0, $22$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result=__stackBase__+16;
      var $ljmask=__stackBase__+24;
      var $curmask=__stackBase__+32;
      $2=$this;
      $3=$address;
      var $st$13$0=(($4)|0);
      HEAP32[(($st$13$0)>>2)]=$mask$0;
      var $st$13$1=(($4+4)|0);
      HEAP32[(($st$13$1)>>2)]=$mask$1;
      var $5=$2;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$3;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -8;
      var $st$2$0=(($4)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($4+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $13=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $11, $12$0, $12$1);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$13$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$13$1;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -8;
      $3=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $st$14$0=(($4)|0);
      var $20$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($4+4)|0);
      var $20$1=HEAP32[(($st$14$1)>>2)];
      var $21$0=$20$0;
      var $21$1=$20$1;
      var $st$20$0=(($ljmask)|0);
      HEAP32[(($st$20$0)>>2)]=$21$0;
      var $st$20$1=(($ljmask+4)|0);
      HEAP32[(($st$20$1)>>2)]=$21$1;
      var $st$24$0=(($ljmask)|0);
      var $22$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($ljmask+4)|0);
      var $22$1=HEAP32[(($st$24$1)>>2)];
      var $23=$offsbits;
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($22$0, $22$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $st$32$0=(($curmask)|0);
      HEAP32[(($st$32$0)>>2)]=$25$0;
      var $st$32$1=(($curmask+4)|0);
      HEAP32[(($st$32$1)>>2)]=$25$1;
      var $st$36$0=(($curmask)|0);
      var $26$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($curmask+4)|0);
      var $26$1=HEAP32[(($st$36$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $27=$26$0 != $$emscripten$temp$1$0 || $26$1 != $$emscripten$temp$1$1;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$3;
      var $st$1$0=(($curmask)|0);
      var $30$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $30$1=HEAP32[(($st$1$1)>>2)];
      var $31=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $29, $30$0, $30$1);
      var $31$0=$31[0];
      var $31$1=$31[1];
      var $32=$offsbits;
      var $33$0=$32;
      var $33$1=0;
      var $34=Runtime.bitshift64($31$0, $31$1,"shl",$33$0);var $34$0 = $34[0], $34$1 = $34[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$34$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$34$1;
      __label__ = 4; break;
    case 4: // $35
      var $36=$offsbits;
      var $37=((64-$36)|0);
      $offsbits=$37;
      var $st$3$0=(($ljmask)|0);
      var $38$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $38$1=HEAP32[(($st$3$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"shl",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$41$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$41$1;
      var $st$15$0=(($curmask)|0);
      var $42$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $42$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $43=$42$0 != $$emscripten$temp$2$0 || $42$1 != $$emscripten$temp$2$1;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$3;
      var $46=(($45+8)|0);
      var $st$2$0=(($curmask)|0);
      var $47$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $47$1=HEAP32[(($st$2$1)>>2)];
      var $48=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $46, $47$0, $47$1);
      var $48$0=$48[0];
      var $48$1=$48[1];
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$13$0=(($result)|0);
      var $52$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $52$1=HEAP32[(($st$13$1)>>2)];
      var $53$0=$52$0 | $51$0;
      var $53$1=$52$1 | $51$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$53$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$53$1;
      __label__ = 6; break;
    case 6: // $54
      var $st$0$0=(($result)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      var $56$0=$55$0;
      var $56$1=$55$1;
      var $st$6$0=(($1)|0);
      HEAP32[(($st$6$0)>>2)]=$56$0;
      var $st$6$1=(($1+4)|0);
      HEAP32[(($st$6$1)>>2)]=$56$1;
      __label__ = 7; break;
    case 7: // $57
      var $st$0$0=(($1)|0);
      var $58$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $58$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$58$0,$58$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($this, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__+8;
      $1=$this;
      $2=$offset;
      var $st$9$0=(($3)|0);
      HEAP32[(($st$9$0)>>2)]=$mask$0;
      var $st$9$1=(($3+4)|0);
      HEAP32[(($st$9$1)>>2)]=$mask$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $st$5$0=(($26)|0);
      var $27$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $34=__ZNK18handler_entry_read6read64ER13address_spacejy($29, $30, $32, $33$0, $33$1);
      var $34$0=$34[0];
      var $34$1=$34[1];
      var $st$11$0=(($result)|0);
      HEAP32[(($st$11$0)>>2)]=$34$0;
      var $st$11$1=(($result+4)|0);
      HEAP32[(($st$11$1)>>2)]=$34$1;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $36$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $36$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$36$0,$36$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t1ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$8$0=(($3)|0);
  HEAP32[(($st$8$0)>>2)]=$mask$0;
  var $st$8$1=(($3+4)|0);
  HEAP32[(($st$8$1)>>2)]=$mask$1;
  var $4=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $5=$2;
  var $6=$5 & -8;
  var $st$17$0=(($3)|0);
  var $7$0=HEAP32[(($st$17$0)>>2)];
  var $st$17$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$17$1)>>2)];
  var $8=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($4, $6, $7$0, $7$1);
  var $8$0=$8[0];
  var $8$1=$8[1];
  STACKTOP = __stackBase__;
  return [$8$0,$8$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEj($this, $offset) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIyL12endianness_t1ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $st$5$0=(($25)|0);
      var $26$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$26$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$26$1;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 3;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $32=__ZNK18handler_entry_read6read64ER13address_spacejy($28, $29, $31, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $32$0=$32[0];
      var $32$1=$32[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$32$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$32$1;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $34$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $34$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$34$0,$34$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEj["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((32-$13)|0);
      $offsbits=$14;
      var $15=$3;
      var $16=$15 & -8;
      var $17=$4;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $16, $21$0, $21$1);
      var $22$0=$22[0];
      var $22$1=$22[1];
      var $23=$offsbits;
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($22$0, $22$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $26$0=$25$0;
      var $26=$26$0;
      $1=$26;
      __label__ = 7; break;
    case 2: // $27
      var $28=$3;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$3;
      var $32=$31 & -8;
      $3=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=32;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $33=$4;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=0;
      var $35$1=$34$0;
      var $st$19$0=(($ljmask)|0);
      HEAP32[(($st$19$0)>>2)]=$35$0;
      var $st$19$1=(($ljmask+4)|0);
      HEAP32[(($st$19$1)>>2)]=$35$1;
      var $st$23$0=(($ljmask)|0);
      var $36$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($ljmask+4)|0);
      var $36$1=HEAP32[(($st$23$1)>>2)];
      var $37=$offsbits1;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$31$0=(($curmask)|0);
      HEAP32[(($st$31$0)>>2)]=$39$0;
      var $st$31$1=(($curmask+4)|0);
      HEAP32[(($st$31$1)>>2)]=$39$1;
      var $st$35$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$35$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $41=$40$0 != $$emscripten$temp$1$0 || $40$1 != $$emscripten$temp$1$1;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$3;
      var $st$1$0=(($curmask)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $43, $44$0, $44$1);
      var $45$0=$45[0];
      var $45$1=$45[1];
      var $46=$offsbits1;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"shl",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$48$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$48$1;
      __label__ = 4; break;
    case 4: // $49
      var $50=$offsbits1;
      var $51=((64-$50)|0);
      $offsbits1=$51;
      var $st$3$0=(($ljmask)|0);
      var $52$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $52$1=HEAP32[(($st$3$1)>>2)];
      var $53=$offsbits1;
      var $54$0=$53;
      var $54$1=0;
      var $55=Runtime.bitshift64($52$0, $52$1,"shl",$54$0);var $55$0 = $55[0], $55$1 = $55[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$55$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$55$1;
      var $st$15$0=(($curmask)|0);
      var $56$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $56$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $57=$56$0 != $$emscripten$temp$2$0 || $56$1 != $$emscripten$temp$2$1;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$3;
      var $60=(($59+8)|0);
      var $st$2$0=(($curmask)|0);
      var $61$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $61$1=HEAP32[(($st$2$1)>>2)];
      var $62=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $60, $61$0, $61$1);
      var $62$0=$62[0];
      var $62$1=$62[1];
      var $63=$offsbits1;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $st$13$0=(($result)|0);
      var $66$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $66$1=HEAP32[(($st$13$1)>>2)];
      var $67$0=$66$0 | $65$0;
      var $67$1=$66$1 | $65$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$67$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$67$1;
      __label__ = 6; break;
    case 6: // $68
      var $st$0$0=(($result)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $69$1=HEAP32[(($st$0$1)>>2)];
      var $70$0=$69$1;
      var $70$1=0;
      var $71$0=$70$0;
      var $71=$71$0;
      $1=$71;
      __label__ = 7; break;
    case 7: // $72
      var $73=$1;
      STACKTOP = __stackBase__;
      return $73;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & 4;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((32-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -8;
  var $12=$3;
  var $13$0=$12;
  var $13$1=0;
  var $14=$offsbits;
  var $15$0=$14;
  var $15$1=0;
  var $16=Runtime.bitshift64($13$0, $13$1,"shl",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
  var $17=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($4, $11, $16$0, $16$1);
  var $17$0=$17[0];
  var $17$1=$17[1];
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"lshr",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  var $21$0=$20$0;
  var $21=$21$0;
  ;
  return $21;
}


function __ZNK22address_space_specificIyL12endianness_t0ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=438;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=440;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=442;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=444;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=446;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=448;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=450;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=452;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=454;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=456;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=458;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=460;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=462;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=464;
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result=__stackBase__;
      var $ljmask=__stackBase__+8;
      var $curmask=__stackBase__+16;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((48-$13)|0);
      $offsbits=$14;
      var $15=$3;
      var $16=$15 & -8;
      var $17=$4;
      var $18$0=$17;
      var $18$1=0;
      var $19=$offsbits;
      var $20$0=$19;
      var $20$1=0;
      var $21=Runtime.bitshift64($18$0, $18$1,"shl",$20$0);var $21$0 = $21[0], $21$1 = $21[1];
      var $22=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $16, $21$0, $21$1);
      var $22$0=$22[0];
      var $22$1=$22[1];
      var $23=$offsbits;
      var $24$0=$23;
      var $24$1=0;
      var $25=Runtime.bitshift64($22$0, $22$1,"lshr",$24$0);var $25$0 = $25[0], $25$1 = $25[1];
      var $26$0=$25$0;
      var $26=$26$0&65535;
      $1=$26;
      __label__ = 7; break;
    case 2: // $27
      var $28=$3;
      var $29=$28 & 7;
      var $30=((($29<<3))|0);
      $offsbits1=$30;
      var $31=$3;
      var $32=$31 & -8;
      $3=$32;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=48;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$10$0=(($result)|0);
      HEAP32[(($st$10$0)>>2)]=$$emscripten$temp$0$0;
      var $st$10$1=(($result+4)|0);
      HEAP32[(($st$10$1)>>2)]=$$emscripten$temp$0$1;
      var $33=$4;
      var $34$0=$33;
      var $34$1=0;
      var $35$0=(0 << 16) | (0 >>> 16);
      var $35$1=($34$0 << 16) | (0 >>> 16);
      var $st$19$0=(($ljmask)|0);
      HEAP32[(($st$19$0)>>2)]=$35$0;
      var $st$19$1=(($ljmask+4)|0);
      HEAP32[(($st$19$1)>>2)]=$35$1;
      var $st$23$0=(($ljmask)|0);
      var $36$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($ljmask+4)|0);
      var $36$1=HEAP32[(($st$23$1)>>2)];
      var $37=$offsbits1;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$31$0=(($curmask)|0);
      HEAP32[(($st$31$0)>>2)]=$39$0;
      var $st$31$1=(($curmask+4)|0);
      HEAP32[(($st$31$1)>>2)]=$39$1;
      var $st$35$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$35$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $41=$40$0 != $$emscripten$temp$1$0 || $40$1 != $$emscripten$temp$1$1;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$3;
      var $st$1$0=(($curmask)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $43, $44$0, $44$1);
      var $45$0=$45[0];
      var $45$1=$45[1];
      var $46=$offsbits1;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"shl",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$48$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$48$1;
      __label__ = 4; break;
    case 4: // $49
      var $50=$offsbits1;
      var $51=((64-$50)|0);
      $offsbits1=$51;
      var $st$3$0=(($ljmask)|0);
      var $52$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($ljmask+4)|0);
      var $52$1=HEAP32[(($st$3$1)>>2)];
      var $53=$offsbits1;
      var $54$0=$53;
      var $54$1=0;
      var $55=Runtime.bitshift64($52$0, $52$1,"shl",$54$0);var $55$0 = $55[0], $55$1 = $55[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$55$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$55$1;
      var $st$15$0=(($curmask)|0);
      var $56$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $56$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $57=$56$0 != $$emscripten$temp$2$0 || $56$1 != $$emscripten$temp$2$1;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$3;
      var $60=(($59+8)|0);
      var $st$2$0=(($curmask)|0);
      var $61$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $61$1=HEAP32[(($st$2$1)>>2)];
      var $62=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($5, $60, $61$0, $61$1);
      var $62$0=$62[0];
      var $62$1=$62[1];
      var $63=$offsbits1;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $st$13$0=(($result)|0);
      var $66$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $66$1=HEAP32[(($st$13$1)>>2)];
      var $67$0=$66$0 | $65$0;
      var $67$1=$66$1 | $65$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$67$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$67$1;
      __label__ = 6; break;
    case 6: // $68
      var $st$0$0=(($result)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $69$1=HEAPU32[(($st$0$1)>>2)];
      var $70$0=($69$1 >>> 16) | (0 << 16);
      var $70$1=(0 >>> 16) | (0 << 16);
      var $71$0=$70$0;
      var $71=$71$0&65535;
      $1=$71;
      __label__ = 7; break;
    case 7: // $72
      var $73=$1;
      STACKTOP = __stackBase__;
      return $73;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 6;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((48-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -8;
  var $12=$3;
  var $13$0=$12;
  var $13$1=0;
  var $14=$offsbits;
  var $15$0=$14;
  var $15$1=0;
  var $16=Runtime.bitshift64($13$0, $13$1,"shl",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
  var $17=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($4, $11, $16$0, $16$1);
  var $17$0=$17[0];
  var $17$1=$17[1];
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"lshr",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  var $21$0=$20$0;
  var $21=$21$0&65535;
  ;
  return $21;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 7;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((56-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -8;
  var $12=$3;
  var $13$0=$12;
  var $13$1=0;
  var $14=$offsbits;
  var $15$0=$14;
  var $15$1=0;
  var $16=Runtime.bitshift64($13$0, $13$1,"shl",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
  var $17=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy($4, $11, $16$0, $16$1);
  var $17$0=$17[0];
  var $17$1=$17[1];
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"lshr",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  var $21$0=$20$0;
  var $21=$21$0&255;
  ;
  return $21;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIyL12endianness_t0ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t1ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIyL12endianness_t1ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIyL12endianness_t0ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t0ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $curmask=__stackBase__+16;
      $1=$this;
      $2=$address;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$data$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$data$1;
      var $st$14$0=(($4)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($4+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -8;
      var $st$2$0=(($3)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($4)|0);
      var $13$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$6$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $11, $12$0, $12$1, $13$0, $13$1);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -8;
      $2=$19;
      var $st$7$0=(($4)|0);
      var $20$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($4+4)|0);
      var $20$1=HEAP32[(($st$7$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $st$15$0=(($curmask)|0);
      HEAP32[(($st$15$0)>>2)]=$23$0;
      var $st$15$1=(($curmask+4)|0);
      HEAP32[(($st$15$1)>>2)]=$23$1;
      var $st$19$0=(($curmask)|0);
      var $24$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($curmask+4)|0);
      var $24$1=HEAP32[(($st$19$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $25=$24$0 != $$emscripten$temp$0$0 || $24$1 != $$emscripten$temp$0$1;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=$2;
      var $st$1$0=(($3)|0);
      var $28$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $28$1=HEAP32[(($st$1$1)>>2)];
      var $29=$offsbits;
      var $30$0=$29;
      var $30$1=0;
      var $31=Runtime.bitshift64($28$0, $28$1,"shl",$30$0);var $31$0 = $31[0], $31$1 = $31[1];
      var $st$9$0=(($curmask)|0);
      var $32$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $32$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $27, $31$0, $31$1, $32$0, $32$1);
      __label__ = 4; break;
    case 4: // $33
      var $34=$offsbits;
      var $35=((64-$34)|0);
      $offsbits=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$39$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$39$1;
      var $st$15$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $41=$40$0 != $$emscripten$temp$1$0 || $40$1 != $$emscripten$temp$1$1;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=(($43+8)|0);
      var $st$2$0=(($3)|0);
      var $45$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $45$1=HEAP32[(($st$2$1)>>2)];
      var $46=$offsbits;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"lshr",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $st$10$0=(($curmask)|0);
      var $49$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $49$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $44, $48$0, $48$1, $49$0, $49$1);
      __label__ = 6; break;
    case 6: // $50
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($this, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$data$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$data$1;
      var $st$14$0=(($4)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($4+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIyL12endianness_t0ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $st$7$0=(($28)|0);
      var $29$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$7$1)>>2)];
      var $st$11$0=(($4)|0);
      var $30$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($4+4)|0);
      var $30$1=HEAP32[(($st$11$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $31$0=$30$0 ^ $$emscripten$temp$0$0;
      var $31$1=$30$1 ^ $$emscripten$temp$0$1;
      var $32$0=$29$0 & $31$0;
      var $32$1=$29$1 & $31$1;
      var $st$21$0=(($3)|0);
      var $33$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$21$1)>>2)];
      var $st$25$0=(($4)|0);
      var $34$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($4+4)|0);
      var $34$1=HEAP32[(($st$25$1)>>2)];
      var $35$0=$33$0 & $34$0;
      var $35$1=$33$1 & $34$1;
      var $36$0=$32$0 | $35$0;
      var $36$1=$32$1 | $35$1;
      var $37=$dest;
      var $st$34$0=(($37)|0);
      HEAP32[(($st$34$0)>>2)]=$36$0;
      var $st$34$1=(($37+4)|0);
      HEAP32[(($st$34$1)>>2)]=$36$1;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 3;
      var $st$4$0=(($3)|0);
      var $43$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $43$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($4)|0);
      var $44$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($4+4)|0);
      var $44$1=HEAP32[(($st$8$1)>>2)];
      __ZNK19handler_entry_write7write64ER13address_spacejyy($39, $40, $42, $43$0, $43$1, $44$0, $44$1);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t0ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$9$0=(($3)|0);
  HEAP32[(($st$9$0)>>2)]=$data$0;
  var $st$9$1=(($3+4)|0);
  HEAP32[(($st$9$1)>>2)]=$data$1;
  var $st$13$0=(($4)|0);
  HEAP32[(($st$13$0)>>2)]=$mask$0;
  var $st$13$1=(($4+4)|0);
  HEAP32[(($st$13$1)>>2)]=$mask$1;
  var $5=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $6=$2;
  var $7=$6 & -8;
  var $st$22$0=(($3)|0);
  var $8$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$22$1)>>2)];
  var $st$26$0=(($4)|0);
  var $9$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $9$1=HEAP32[(($st$26$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $7, $8$0, $8$1, $9$0, $9$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjy($this, $offset, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $st$0$0=(($3)|0);
      var $22$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $22$1=HEAP32[(($st$0$1)>>2)];
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      var $st$9$0=(($27)|0);
      HEAP32[(($st$9$0)>>2)]=$22$0;
      var $st$9$1=(($27+4)|0);
      HEAP32[(($st$9$1)>>2)]=$22$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      __ZNK19handler_entry_write7write64ER13address_spacejyy($29, $30, $32, $33$0, $33$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjy["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $curmask=__stackBase__;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$13 & -8;
      var $15=$3;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=$4;
      var $21$0=$20;
      var $21$1=0;
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $14, $19$0, $19$1, $24$0, $24$1);
      __label__ = 6; break;
    case 2: // $25
      var $26=$2;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$2;
      var $30=$29 & -8;
      $2=$30;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$14$0=(($curmask)|0);
      HEAP32[(($st$14$0)>>2)]=$35$0;
      var $st$14$1=(($curmask+4)|0);
      HEAP32[(($st$14$1)>>2)]=$35$1;
      var $st$18$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$18$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$2;
      var $40=$3;
      var $41$0=$40;
      var $41$1=0;
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"shl",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $st$8$0=(($curmask)|0);
      var $45$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curmask+4)|0);
      var $45$1=HEAP32[(($st$8$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $39, $44$0, $44$1, $45$0, $45$1);
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=$offsbits1;
      var $51=$49 >>> (($50)>>>0);
      var $52$0=$51;
      var $52$1=0;
      var $st$8$0=(($curmask)|0);
      HEAP32[(($st$8$0)>>2)]=$52$0;
      var $st$8$1=(($curmask+4)|0);
      HEAP32[(($st$8$1)>>2)]=$52$1;
      var $st$12$0=(($curmask)|0);
      var $53$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($curmask+4)|0);
      var $53$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $54=$53$0 != $$emscripten$temp$1$0 || $53$1 != $$emscripten$temp$1$1;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$2;
      var $57=(($56+8)|0);
      var $58=$3;
      var $59=$offsbits1;
      var $60=$58 >>> (($59)>>>0);
      var $61$0=$60;
      var $61$1=0;
      var $st$7$0=(($curmask)|0);
      var $62$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($curmask+4)|0);
      var $62$1=HEAP32[(($st$7$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $57, $61$0, $61$1, $62$0, $62$1);
      __label__ = 6; break;
    case 6: // $63
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & 4;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -8;
  var $11=$3;
  var $12$0=$11;
  var $12$1=0;
  var $13=$offsbits;
  var $14$0=$13;
  var $14$1=0;
  var $15=Runtime.bitshift64($12$0, $12$1,"shl",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"shl",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $10, $15$0, $15$1, $20$0, $20$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $curmask=__stackBase__;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$13 & -8;
      var $15=$3;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=$4;
      var $21$0=$20;
      var $21$1=0;
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $14, $19$0, $19$1, $24$0, $24$1);
      __label__ = 6; break;
    case 2: // $25
      var $26=$2;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$2;
      var $30=$29 & -8;
      $2=$30;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$14$0=(($curmask)|0);
      HEAP32[(($st$14$0)>>2)]=$35$0;
      var $st$14$1=(($curmask+4)|0);
      HEAP32[(($st$14$1)>>2)]=$35$1;
      var $st$18$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$18$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$2;
      var $40=$3;
      var $41$0=$40;
      var $41$1=0;
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"shl",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $st$8$0=(($curmask)|0);
      var $45$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curmask+4)|0);
      var $45$1=HEAP32[(($st$8$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $39, $44$0, $44$1, $45$0, $45$1);
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=(($49)&65535);
      var $51=$offsbits1;
      var $52=$50 >> (($51)|0);
      var $53$0=$52;
      var $53$1=(($52|0) < 0 ? -1 : 0);
      var $st$9$0=(($curmask)|0);
      HEAP32[(($st$9$0)>>2)]=$53$0;
      var $st$9$1=(($curmask+4)|0);
      HEAP32[(($st$9$1)>>2)]=$53$1;
      var $st$13$0=(($curmask)|0);
      var $54$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($curmask+4)|0);
      var $54$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $55=$54$0 != $$emscripten$temp$1$0 || $54$1 != $$emscripten$temp$1$1;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$2;
      var $58=(($57+8)|0);
      var $59=$3;
      var $60=(($59)&65535);
      var $61=$offsbits1;
      var $62=$60 >> (($61)|0);
      var $63$0=$62;
      var $63$1=(($62|0) < 0 ? -1 : 0);
      var $st$8$0=(($curmask)|0);
      var $64$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curmask+4)|0);
      var $64$1=HEAP32[(($st$8$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $58, $63$0, $63$1, $64$0, $64$1);
      __label__ = 6; break;
    case 6: // $65
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 6;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -8;
  var $11=$3;
  var $12$0=$11;
  var $12$1=0;
  var $13=$offsbits;
  var $14$0=$13;
  var $14$1=0;
  var $15=Runtime.bitshift64($12$0, $12$1,"shl",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"shl",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $10, $15$0, $15$1, $20$0, $20$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 7;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -8;
  var $11=$3;
  var $12$0=$11;
  var $12$1=0;
  var $13=$offsbits;
  var $14$0=$13;
  var $14$1=0;
  var $15=Runtime.bitshift64($12$0, $12$1,"shl",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"shl",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy($5, $10, $15$0, $15$1, $20$0, $20$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $result=__stackBase__+16;
      var $curmask=__stackBase__+24;
      $2=$this;
      $3=$address;
      var $st$11$0=(($4)|0);
      HEAP32[(($st$11$0)>>2)]=$mask$0;
      var $st$11$1=(($4+4)|0);
      HEAP32[(($st$11$1)>>2)]=$mask$1;
      var $5=$2;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$3;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -8;
      var $st$2$0=(($4)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($4+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $13=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $11, $12$0, $12$1);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$13$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$13$1;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -8;
      $3=$19;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$$emscripten$temp$0$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$$emscripten$temp$0$1;
      var $st$13$0=(($4)|0);
      var $20$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($4+4)|0);
      var $20$1=HEAP32[(($st$13$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $st$21$0=(($curmask)|0);
      HEAP32[(($st$21$0)>>2)]=$23$0;
      var $st$21$1=(($curmask+4)|0);
      HEAP32[(($st$21$1)>>2)]=$23$1;
      var $st$25$0=(($curmask)|0);
      var $24$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($curmask+4)|0);
      var $24$1=HEAP32[(($st$25$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $25=$24$0 != $$emscripten$temp$1$0 || $24$1 != $$emscripten$temp$1$1;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=$3;
      var $st$1$0=(($curmask)|0);
      var $28$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $28$1=HEAP32[(($st$1$1)>>2)];
      var $29=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $27, $28$0, $28$1);
      var $29$0=$29[0];
      var $29$1=$29[1];
      var $30=$offsbits;
      var $31$0=$30;
      var $31$1=0;
      var $32=Runtime.bitshift64($29$0, $29$1,"lshr",$31$0);var $32$0 = $32[0], $32$1 = $32[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$32$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$32$1;
      __label__ = 4; break;
    case 4: // $33
      var $34=$offsbits;
      var $35=((64-$34)|0);
      $offsbits=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$39$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$39$1;
      var $st$15$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $41=$40$0 != $$emscripten$temp$2$0 || $40$1 != $$emscripten$temp$2$1;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$3;
      var $44=(($43+8)|0);
      var $st$2$0=(($curmask)|0);
      var $45$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $45$1=HEAP32[(($st$2$1)>>2)];
      var $46=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $44, $45$0, $45$1);
      var $46$0=$46[0];
      var $46$1=$46[1];
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"shl",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $st$13$0=(($result)|0);
      var $50$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $50$1=HEAP32[(($st$13$1)>>2)];
      var $51$0=$50$0 | $49$0;
      var $51$1=$50$1 | $49$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$51$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$51$1;
      __label__ = 6; break;
    case 6: // $52
      var $st$0$0=(($result)|0);
      var $53$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $53$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$53$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$53$1;
      __label__ = 7; break;
    case 7: // $54
      var $st$0$0=(($1)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$55$0,$55$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($this, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__+8;
      $1=$this;
      $2=$offset;
      var $st$9$0=(($3)|0);
      HEAP32[(($st$9$0)>>2)]=$mask$0;
      var $st$9$1=(($3+4)|0);
      HEAP32[(($st$9$1)>>2)]=$mask$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $st$5$0=(($26)|0);
      var $27$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $34=__ZNK18handler_entry_read6read64ER13address_spacejy($29, $30, $32, $33$0, $33$1);
      var $34$0=$34[0];
      var $34$1=$34[1];
      var $st$11$0=(($result)|0);
      HEAP32[(($st$11$0)>>2)]=$34$0;
      var $st$11$1=(($result+4)|0);
      HEAP32[(($st$11$1)>>2)]=$34$1;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $36$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $36$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$36$0,$36$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t0ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$8$0=(($3)|0);
  HEAP32[(($st$8$0)>>2)]=$mask$0;
  var $st$8$1=(($3+4)|0);
  HEAP32[(($st$8$1)>>2)]=$mask$1;
  var $4=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $5=$2;
  var $6=$5 & -8;
  var $st$17$0=(($3)|0);
  var $7$0=HEAP32[(($st$17$0)>>2)];
  var $st$17$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$17$1)>>2)];
  var $8=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($4, $6, $7$0, $7$1);
  var $8$0=$8[0];
  var $8$1=$8[1];
  STACKTOP = __stackBase__;
  return [$8$0,$8$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEj($this, $offset) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIyL12endianness_t0ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $st$5$0=(($25)|0);
      var $26$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$26$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$26$1;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 3;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $32=__ZNK18handler_entry_read6read64ER13address_spacejy($28, $29, $31, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $32$0=$32[0];
      var $32$1=$32[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$32$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$32$1;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $34$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $34$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$34$0,$34$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEj["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $result;
      var $curmask=__stackBase__;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$3;
      var $14=$13 & -8;
      var $15=$4;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $14, $19$0, $19$1);
      var $20$0=$20[0];
      var $20$1=$20[1];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"lshr",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0;
      $1=$24;
      __label__ = 7; break;
    case 2: // $25
      var $26=$3;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$3;
      var $30=$29 & -8;
      $3=$30;
      $result=0;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$15$0=(($curmask)|0);
      HEAP32[(($st$15$0)>>2)]=$35$0;
      var $st$15$1=(($curmask+4)|0);
      HEAP32[(($st$15$1)>>2)]=$35$1;
      var $st$19$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$19$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$3;
      var $st$1$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$1$1)>>2)];
      var $41=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $39, $40$0, $40$1);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"lshr",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $45$0=$44$0;
      var $45=$45$0;
      $result=$45;
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=$offsbits1;
      var $51=$49 >>> (($50)>>>0);
      var $52$0=$51;
      var $52$1=0;
      var $st$8$0=(($curmask)|0);
      HEAP32[(($st$8$0)>>2)]=$52$0;
      var $st$8$1=(($curmask+4)|0);
      HEAP32[(($st$8$1)>>2)]=$52$1;
      var $st$12$0=(($curmask)|0);
      var $53$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($curmask+4)|0);
      var $53$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $54=$53$0 != $$emscripten$temp$1$0 || $53$1 != $$emscripten$temp$1$1;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$3;
      var $57=(($56+8)|0);
      var $st$2$0=(($curmask)|0);
      var $58$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $58$1=HEAP32[(($st$2$1)>>2)];
      var $59=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $57, $58$0, $58$1);
      var $59$0=$59[0];
      var $59$1=$59[1];
      var $60=$offsbits1;
      var $61$0=$60;
      var $61$1=0;
      var $62=Runtime.bitshift64($59$0, $59$1,"shl",$61$0);var $62$0 = $62[0], $62$1 = $62[1];
      var $63=$result;
      var $64$0=$63;
      var $64$1=0;
      var $65$0=$64$0 | $62$0;
      var $65$1=$64$1 | $62$1;
      var $66$0=$65$0;
      var $66=$66$0;
      $result=$66;
      __label__ = 6; break;
    case 6: // $67
      var $68=$result;
      $1=$68;
      __label__ = 7; break;
    case 7: // $69
      var $70=$1;
      STACKTOP = __stackBase__;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & 4;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -8;
  var $10=$3;
  var $11$0=$10;
  var $11$1=0;
  var $12=$offsbits;
  var $13$0=$12;
  var $13$1=0;
  var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
  var $15=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($4, $9, $14$0, $14$1);
  var $15$0=$15[0];
  var $15$1=$15[1];
  var $16=$offsbits;
  var $17$0=$16;
  var $17$1=0;
  var $18=Runtime.bitshift64($15$0, $15$1,"lshr",$17$0);var $18$0 = $18[0], $18$1 = $18[1];
  var $19$0=$18$0;
  var $19=$19$0;
  ;
  return $19;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $result;
      var $curmask=__stackBase__;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$3;
      var $14=$13 & -8;
      var $15=$4;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $14, $19$0, $19$1);
      var $20$0=$20[0];
      var $20$1=$20[1];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"lshr",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0&65535;
      $1=$24;
      __label__ = 7; break;
    case 2: // $25
      var $26=$3;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$3;
      var $30=$29 & -8;
      $3=$30;
      $result=0;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$15$0=(($curmask)|0);
      HEAP32[(($st$15$0)>>2)]=$35$0;
      var $st$15$1=(($curmask+4)|0);
      HEAP32[(($st$15$1)>>2)]=$35$1;
      var $st$19$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$19$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$3;
      var $st$1$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$1$1)>>2)];
      var $41=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $39, $40$0, $40$1);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"lshr",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $45$0=$44$0;
      var $45=$45$0&65535;
      $result=$45;
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=(($49)&65535);
      var $51=$offsbits1;
      var $52=$50 >> (($51)|0);
      var $53$0=$52;
      var $53$1=(($52|0) < 0 ? -1 : 0);
      var $st$9$0=(($curmask)|0);
      HEAP32[(($st$9$0)>>2)]=$53$0;
      var $st$9$1=(($curmask+4)|0);
      HEAP32[(($st$9$1)>>2)]=$53$1;
      var $st$13$0=(($curmask)|0);
      var $54$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($curmask+4)|0);
      var $54$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $55=$54$0 != $$emscripten$temp$1$0 || $54$1 != $$emscripten$temp$1$1;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$3;
      var $58=(($57+8)|0);
      var $st$2$0=(($curmask)|0);
      var $59$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $59$1=HEAP32[(($st$2$1)>>2)];
      var $60=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($5, $58, $59$0, $59$1);
      var $60$0=$60[0];
      var $60$1=$60[1];
      var $61=$offsbits1;
      var $62$0=$61;
      var $62$1=0;
      var $63=Runtime.bitshift64($60$0, $60$1,"shl",$62$0);var $63$0 = $63[0], $63$1 = $63[1];
      var $64=$result;
      var $65$0=$64;
      var $65$1=0;
      var $66$0=$65$0 | $63$0;
      var $66$1=$65$1 | $63$1;
      var $67$0=$66$0;
      var $67=$67$0&65535;
      $result=$67;
      __label__ = 6; break;
    case 6: // $68
      var $69=$result;
      $1=$69;
      __label__ = 7; break;
    case 7: // $70
      var $71=$1;
      STACKTOP = __stackBase__;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 6;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -8;
  var $10=$3;
  var $11$0=$10;
  var $11$1=0;
  var $12=$offsbits;
  var $13$0=$12;
  var $13$1=0;
  var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
  var $15=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($4, $9, $14$0, $14$1);
  var $15$0=$15[0];
  var $15$1=$15[1];
  var $16=$offsbits;
  var $17$0=$16;
  var $17$1=0;
  var $18=Runtime.bitshift64($15$0, $15$1,"lshr",$17$0);var $18$0 = $18[0], $18$1 = $18[1];
  var $19$0=$18$0;
  var $19=$19$0&65535;
  ;
  return $19;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 7;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -8;
  var $10=$3;
  var $11$0=$10;
  var $11$1=0;
  var $12=$offsbits;
  var $13$0=$12;
  var $13$1=0;
  var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
  var $15=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy($4, $9, $14$0, $14$1);
  var $15$0=$15[0];
  var $15$1=$15[1];
  var $16=$offsbits;
  var $17$0=$16;
  var $17$1=0;
  var $18=Runtime.bitshift64($15$0, $15$1,"lshr",$17$0);var $18$0 = $18[0], $18$1 = $18[1];
  var $19$0=$18$0;
  var $19=$19$0&255;
  ;
  return $19;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIyL12endianness_t0ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED0Ev["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t0ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=466;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=468;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=470;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=472;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=474;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=476;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=478;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=480;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=482;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=484;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=486;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=488;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=490;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=492;
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIyL12endianness_t0ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $curmask=__stackBase__+16;
      $1=$this;
      $2=$address;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$data$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$data$1;
      var $st$14$0=(($4)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($4+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -8;
      var $st$2$0=(($3)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($4)|0);
      var $13$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$6$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $11, $12$0, $12$1, $13$0, $13$1);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -8;
      $2=$19;
      var $st$7$0=(($4)|0);
      var $20$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($4+4)|0);
      var $20$1=HEAP32[(($st$7$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $st$15$0=(($curmask)|0);
      HEAP32[(($st$15$0)>>2)]=$23$0;
      var $st$15$1=(($curmask+4)|0);
      HEAP32[(($st$15$1)>>2)]=$23$1;
      var $st$19$0=(($curmask)|0);
      var $24$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($curmask+4)|0);
      var $24$1=HEAP32[(($st$19$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $25=$24$0 != $$emscripten$temp$0$0 || $24$1 != $$emscripten$temp$0$1;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=$2;
      var $st$1$0=(($3)|0);
      var $28$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $28$1=HEAP32[(($st$1$1)>>2)];
      var $29=$offsbits;
      var $30$0=$29;
      var $30$1=0;
      var $31=Runtime.bitshift64($28$0, $28$1,"shl",$30$0);var $31$0 = $31[0], $31$1 = $31[1];
      var $st$9$0=(($curmask)|0);
      var $32$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($curmask+4)|0);
      var $32$1=HEAP32[(($st$9$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $27, $31$0, $31$1, $32$0, $32$1);
      __label__ = 4; break;
    case 4: // $33
      var $34=$offsbits;
      var $35=((64-$34)|0);
      $offsbits=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$39$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$39$1;
      var $st$15$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $41=$40$0 != $$emscripten$temp$1$0 || $40$1 != $$emscripten$temp$1$1;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=(($43+8)|0);
      var $st$2$0=(($3)|0);
      var $45$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $45$1=HEAP32[(($st$2$1)>>2)];
      var $46=$offsbits;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"lshr",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $st$10$0=(($curmask)|0);
      var $49$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($curmask+4)|0);
      var $49$1=HEAP32[(($st$10$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $44, $48$0, $48$1, $49$0, $49$1);
      __label__ = 6; break;
    case 6: // $50
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($this, $offset, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$data$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$data$1;
      var $st$14$0=(($4)|0);
      HEAP32[(($st$14$0)>>2)]=$mask$0;
      var $st$14$1=(($4+4)|0);
      HEAP32[(($st$14$1)>>2)]=$mask$1;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIyL12endianness_t0ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $st$7$0=(($28)|0);
      var $29$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$7$1)>>2)];
      var $st$11$0=(($4)|0);
      var $30$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($4+4)|0);
      var $30$1=HEAP32[(($st$11$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $31$0=$30$0 ^ $$emscripten$temp$0$0;
      var $31$1=$30$1 ^ $$emscripten$temp$0$1;
      var $32$0=$29$0 & $31$0;
      var $32$1=$29$1 & $31$1;
      var $st$21$0=(($3)|0);
      var $33$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$21$1)>>2)];
      var $st$25$0=(($4)|0);
      var $34$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($4+4)|0);
      var $34$1=HEAP32[(($st$25$1)>>2)];
      var $35$0=$33$0 & $34$0;
      var $35$1=$33$1 & $34$1;
      var $36$0=$32$0 | $35$0;
      var $36$1=$32$1 | $35$1;
      var $37=$dest;
      var $st$34$0=(($37)|0);
      HEAP32[(($st$34$0)>>2)]=$36$0;
      var $st$34$1=(($37+4)|0);
      HEAP32[(($st$34$1)>>2)]=$36$1;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 3;
      var $st$4$0=(($3)|0);
      var $43$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $43$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($4)|0);
      var $44$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($4+4)|0);
      var $44$1=HEAP32[(($st$8$1)>>2)];
      __ZNK19handler_entry_write7write64ER13address_spacejyy($39, $40, $42, $43$0, $43$1, $44$0, $44$1);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t0ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$9$0=(($3)|0);
  HEAP32[(($st$9$0)>>2)]=$data$0;
  var $st$9$1=(($3+4)|0);
  HEAP32[(($st$9$1)>>2)]=$data$1;
  var $st$13$0=(($4)|0);
  HEAP32[(($st$13$0)>>2)]=$mask$0;
  var $st$13$1=(($4+4)|0);
  HEAP32[(($st$13$1)>>2)]=$mask$1;
  var $5=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $6=$2;
  var $7=$6 & -8;
  var $st$22$0=(($3)|0);
  var $8$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$22$1)>>2)];
  var $st$26$0=(($4)|0);
  var $9$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $9$1=HEAP32[(($st$26$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $7, $8$0, $8$1, $9$0, $9$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIyL12endianness_t0ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIyL12endianness_t0ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EED0Ev["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjy($this, $offset, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $st$0$0=(($3)|0);
      var $22$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $22$1=HEAP32[(($st$0$1)>>2)];
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      var $st$9$0=(($27)|0);
      HEAP32[(($st$9$0)>>2)]=$22$0;
      var $st$9$1=(($27+4)|0);
      HEAP32[(($st$9$1)>>2)]=$22$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      __ZNK19handler_entry_write7write64ER13address_spacejyy($29, $30, $32, $33$0, $33$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjy["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $curmask=__stackBase__;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$13 & -8;
      var $15=$3;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=$4;
      var $21$0=$20;
      var $21$1=0;
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $14, $19$0, $19$1, $24$0, $24$1);
      __label__ = 6; break;
    case 2: // $25
      var $26=$2;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$2;
      var $30=$29 & -8;
      $2=$30;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$14$0=(($curmask)|0);
      HEAP32[(($st$14$0)>>2)]=$35$0;
      var $st$14$1=(($curmask+4)|0);
      HEAP32[(($st$14$1)>>2)]=$35$1;
      var $st$18$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$18$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$2;
      var $40=$3;
      var $41$0=$40;
      var $41$1=0;
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"shl",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $st$8$0=(($curmask)|0);
      var $45$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curmask+4)|0);
      var $45$1=HEAP32[(($st$8$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $39, $44$0, $44$1, $45$0, $45$1);
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=$offsbits1;
      var $51=$49 >>> (($50)>>>0);
      var $52$0=$51;
      var $52$1=0;
      var $st$8$0=(($curmask)|0);
      HEAP32[(($st$8$0)>>2)]=$52$0;
      var $st$8$1=(($curmask+4)|0);
      HEAP32[(($st$8$1)>>2)]=$52$1;
      var $st$12$0=(($curmask)|0);
      var $53$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($curmask+4)|0);
      var $53$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $54=$53$0 != $$emscripten$temp$1$0 || $53$1 != $$emscripten$temp$1$1;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$2;
      var $57=(($56+8)|0);
      var $58=$3;
      var $59=$offsbits1;
      var $60=$58 >>> (($59)>>>0);
      var $61$0=$60;
      var $61$1=0;
      var $st$7$0=(($curmask)|0);
      var $62$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($curmask+4)|0);
      var $62$1=HEAP32[(($st$7$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $57, $61$0, $61$1, $62$0, $62$1);
      __label__ = 6; break;
    case 6: // $63
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & 4;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -8;
  var $11=$3;
  var $12$0=$11;
  var $12$1=0;
  var $13=$offsbits;
  var $14$0=$13;
  var $14$1=0;
  var $15=Runtime.bitshift64($12$0, $12$1,"shl",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"shl",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $10, $15$0, $15$1, $20$0, $20$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $curmask=__stackBase__;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$13 & -8;
      var $15=$3;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=$4;
      var $21$0=$20;
      var $21$1=0;
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $14, $19$0, $19$1, $24$0, $24$1);
      __label__ = 6; break;
    case 2: // $25
      var $26=$2;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$2;
      var $30=$29 & -8;
      $2=$30;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$14$0=(($curmask)|0);
      HEAP32[(($st$14$0)>>2)]=$35$0;
      var $st$14$1=(($curmask+4)|0);
      HEAP32[(($st$14$1)>>2)]=$35$1;
      var $st$18$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$18$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$2;
      var $40=$3;
      var $41$0=$40;
      var $41$1=0;
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"shl",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $st$8$0=(($curmask)|0);
      var $45$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curmask+4)|0);
      var $45$1=HEAP32[(($st$8$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $39, $44$0, $44$1, $45$0, $45$1);
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=(($49)&65535);
      var $51=$offsbits1;
      var $52=$50 >> (($51)|0);
      var $53$0=$52;
      var $53$1=(($52|0) < 0 ? -1 : 0);
      var $st$9$0=(($curmask)|0);
      HEAP32[(($st$9$0)>>2)]=$53$0;
      var $st$9$1=(($curmask+4)|0);
      HEAP32[(($st$9$1)>>2)]=$53$1;
      var $st$13$0=(($curmask)|0);
      var $54$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($curmask+4)|0);
      var $54$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $55=$54$0 != $$emscripten$temp$1$0 || $54$1 != $$emscripten$temp$1$1;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$2;
      var $58=(($57+8)|0);
      var $59=$3;
      var $60=(($59)&65535);
      var $61=$offsbits1;
      var $62=$60 >> (($61)|0);
      var $63$0=$62;
      var $63$1=(($62|0) < 0 ? -1 : 0);
      var $st$8$0=(($curmask)|0);
      var $64$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($curmask+4)|0);
      var $64$1=HEAP32[(($st$8$1)>>2)];
      __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $58, $63$0, $63$1, $64$0, $64$1);
      __label__ = 6; break;
    case 6: // $65
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 6;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -8;
  var $11=$3;
  var $12$0=$11;
  var $12$1=0;
  var $13=$offsbits;
  var $14$0=$13;
  var $14$1=0;
  var $15=Runtime.bitshift64($12$0, $12$1,"shl",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"shl",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $10, $15$0, $15$1, $20$0, $20$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 7;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -8;
  var $11=$3;
  var $12$0=$11;
  var $12$1=0;
  var $13=$offsbits;
  var $14$0=$13;
  var $14$1=0;
  var $15=Runtime.bitshift64($12$0, $12$1,"shl",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
  var $16=$4;
  var $17$0=$16;
  var $17$1=0;
  var $18=$offsbits;
  var $19$0=$18;
  var $19$1=0;
  var $20=Runtime.bitshift64($17$0, $17$1,"shl",$19$0);var $20$0 = $20[0], $20$1 = $20[1];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy($5, $10, $15$0, $15$1, $20$0, $20$1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $result=__stackBase__+16;
      var $curmask=__stackBase__+24;
      $2=$this;
      $3=$address;
      var $st$11$0=(($4)|0);
      HEAP32[(($st$11$0)>>2)]=$mask$0;
      var $st$11$1=(($4+4)|0);
      HEAP32[(($st$11$1)>>2)]=$mask$1;
      var $5=$2;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$3;
      var $7=$6 & 7;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -8;
      var $st$2$0=(($4)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($4+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $13=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $11, $12$0, $12$1);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$13$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$13$1;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 7;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -8;
      $3=$19;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$$emscripten$temp$0$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$$emscripten$temp$0$1;
      var $st$13$0=(($4)|0);
      var $20$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($4+4)|0);
      var $20$1=HEAP32[(($st$13$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $st$21$0=(($curmask)|0);
      HEAP32[(($st$21$0)>>2)]=$23$0;
      var $st$21$1=(($curmask+4)|0);
      HEAP32[(($st$21$1)>>2)]=$23$1;
      var $st$25$0=(($curmask)|0);
      var $24$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($curmask+4)|0);
      var $24$1=HEAP32[(($st$25$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $25=$24$0 != $$emscripten$temp$1$0 || $24$1 != $$emscripten$temp$1$1;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=$3;
      var $st$1$0=(($curmask)|0);
      var $28$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $28$1=HEAP32[(($st$1$1)>>2)];
      var $29=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $27, $28$0, $28$1);
      var $29$0=$29[0];
      var $29$1=$29[1];
      var $30=$offsbits;
      var $31$0=$30;
      var $31$1=0;
      var $32=Runtime.bitshift64($29$0, $29$1,"lshr",$31$0);var $32$0 = $32[0], $32$1 = $32[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$32$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$32$1;
      __label__ = 4; break;
    case 4: // $33
      var $34=$offsbits;
      var $35=((64-$34)|0);
      $offsbits=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $st$11$0=(($curmask)|0);
      HEAP32[(($st$11$0)>>2)]=$39$0;
      var $st$11$1=(($curmask+4)|0);
      HEAP32[(($st$11$1)>>2)]=$39$1;
      var $st$15$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $41=$40$0 != $$emscripten$temp$2$0 || $40$1 != $$emscripten$temp$2$1;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$3;
      var $44=(($43+8)|0);
      var $st$2$0=(($curmask)|0);
      var $45$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $45$1=HEAP32[(($st$2$1)>>2)];
      var $46=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $44, $45$0, $45$1);
      var $46$0=$46[0];
      var $46$1=$46[1];
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"shl",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $st$13$0=(($result)|0);
      var $50$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $50$1=HEAP32[(($st$13$1)>>2)];
      var $51$0=$50$0 | $49$0;
      var $51$1=$50$1 | $49$1;
      var $st$19$0=(($result)|0);
      HEAP32[(($st$19$0)>>2)]=$51$0;
      var $st$19$1=(($result+4)|0);
      HEAP32[(($st$19$1)>>2)]=$51$1;
      __label__ = 6; break;
    case 6: // $52
      var $st$0$0=(($result)|0);
      var $53$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $53$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$53$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$53$1;
      __label__ = 7; break;
    case 7: // $54
      var $st$0$0=(($1)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$55$0,$55$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($this, $offset, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__+8;
      $1=$this;
      $2=$offset;
      var $st$9$0=(($3)|0);
      HEAP32[(($st$9$0)>>2)]=$mask$0;
      var $st$9$1=(($3+4)|0);
      HEAP32[(($st$9$1)>>2)]=$mask$1;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIyL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $st$5$0=(($26)|0);
      var $27$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 3;
      var $st$4$0=(($3)|0);
      var $33$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$4$1)>>2)];
      var $34=__ZNK18handler_entry_read6read64ER13address_spacejy($29, $30, $32, $33$0, $33$1);
      var $34$0=$34[0];
      var $34$1=$34[1];
      var $st$11$0=(($result)|0);
      HEAP32[(($st$11$0)>>2)]=$34$0;
      var $st$11$1=(($result+4)|0);
      HEAP32[(($st$11$1)>>2)]=$34$1;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $36$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $36$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$36$0,$36$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy["X"]=1;

function __ZNK22address_space_specificIyL12endianness_t0ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  var $st$8$0=(($3)|0);
  HEAP32[(($st$8$0)>>2)]=$mask$0;
  var $st$8$1=(($3+4)|0);
  HEAP32[(($st$8$1)>>2)]=$mask$1;
  var $4=$1;
  $TARGET_BYTES=8;
  $TARGET_BITS=64;
  var $5=$2;
  var $6=$5 & -8;
  var $st$17$0=(($3)|0);
  var $7$0=HEAP32[(($st$17$0)>>2)];
  var $st$17$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$17$1)>>2)];
  var $8=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($4, $6, $7$0, $7$1);
  var $8$0=$8[0];
  var $8$1=$8[1];
  STACKTOP = __stackBase__;
  return [$8$0,$8$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEj($this, $offset) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result=__stackBase__;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIyL12endianness_t0ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $st$5$0=(($25)|0);
      var $26$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$26$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$26$1;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 3;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $32=__ZNK18handler_entry_read6read64ER13address_spacejy($28, $29, $31, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $32$0=$32[0];
      var $32$1=$32[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$32$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$32$1;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($result)|0);
      var $34$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($result+4)|0);
      var $34$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$34$0,$34$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEj["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $result;
      var $curmask=__stackBase__;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+32)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$3;
      var $14=$13 & -8;
      var $15=$4;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $14, $19$0, $19$1);
      var $20$0=$20[0];
      var $20$1=$20[1];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"lshr",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0;
      $1=$24;
      __label__ = 7; break;
    case 2: // $25
      var $26=$3;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$3;
      var $30=$29 & -8;
      $3=$30;
      $result=0;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$15$0=(($curmask)|0);
      HEAP32[(($st$15$0)>>2)]=$35$0;
      var $st$15$1=(($curmask+4)|0);
      HEAP32[(($st$15$1)>>2)]=$35$1;
      var $st$19$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$19$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$3;
      var $st$1$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$1$1)>>2)];
      var $41=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $39, $40$0, $40$1);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"lshr",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $45$0=$44$0;
      var $45=$45$0;
      $result=$45;
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=$offsbits1;
      var $51=$49 >>> (($50)>>>0);
      var $52$0=$51;
      var $52$1=0;
      var $st$8$0=(($curmask)|0);
      HEAP32[(($st$8$0)>>2)]=$52$0;
      var $st$8$1=(($curmask+4)|0);
      HEAP32[(($st$8$1)>>2)]=$52$1;
      var $st$12$0=(($curmask)|0);
      var $53$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($curmask+4)|0);
      var $53$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $54=$53$0 != $$emscripten$temp$1$0 || $53$1 != $$emscripten$temp$1$1;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$3;
      var $57=(($56+8)|0);
      var $st$2$0=(($curmask)|0);
      var $58$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $58$1=HEAP32[(($st$2$1)>>2)];
      var $59=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $57, $58$0, $58$1);
      var $59$0=$59[0];
      var $59$1=$59[1];
      var $60=$offsbits1;
      var $61$0=$60;
      var $61$1=0;
      var $62=Runtime.bitshift64($59$0, $59$1,"shl",$61$0);var $62$0 = $62[0], $62$1 = $62[1];
      var $63=$result;
      var $64$0=$63;
      var $64$1=0;
      var $65$0=$64$0 | $62$0;
      var $65$1=$64$1 | $62$1;
      var $66$0=$65$0;
      var $66=$66$0;
      $result=$66;
      __label__ = 6; break;
    case 6: // $67
      var $68=$result;
      $1=$68;
      __label__ = 7; break;
    case 7: // $69
      var $70=$1;
      STACKTOP = __stackBase__;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & 4;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -8;
  var $10=$3;
  var $11$0=$10;
  var $11$1=0;
  var $12=$offsbits;
  var $13$0=$12;
  var $13$1=0;
  var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
  var $15=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($4, $9, $14$0, $14$1);
  var $15$0=$15[0];
  var $15$1=$15[1];
  var $16=$offsbits;
  var $17$0=$16;
  var $17$1=0;
  var $18=Runtime.bitshift64($15$0, $15$1,"lshr",$17$0);var $18$0 = $18[0], $18$1 = $18[1];
  var $19$0=$18$0;
  var $19=$19$0;
  ;
  return $19;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $result;
      var $curmask=__stackBase__;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 7;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 64;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$3;
      var $14=$13 & -8;
      var $15=$4;
      var $16$0=$15;
      var $16$1=0;
      var $17=$offsbits;
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($16$0, $16$1,"shl",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $20=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $14, $19$0, $19$1);
      var $20$0=$20[0];
      var $20$1=$20[1];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"lshr",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0&65535;
      $1=$24;
      __label__ = 7; break;
    case 2: // $25
      var $26=$3;
      var $27=$26 & 7;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$3;
      var $30=$29 & -8;
      $3=$30;
      $result=0;
      var $31=$4;
      var $32$0=$31;
      var $32$1=0;
      var $33=$offsbits1;
      var $34$0=$33;
      var $34$1=0;
      var $35=Runtime.bitshift64($32$0, $32$1,"shl",$34$0);var $35$0 = $35[0], $35$1 = $35[1];
      var $st$15$0=(($curmask)|0);
      HEAP32[(($st$15$0)>>2)]=$35$0;
      var $st$15$1=(($curmask+4)|0);
      HEAP32[(($st$15$1)>>2)]=$35$1;
      var $st$19$0=(($curmask)|0);
      var $36$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($curmask+4)|0);
      var $36$1=HEAP32[(($st$19$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$0 != $$emscripten$temp$0$0 || $36$1 != $$emscripten$temp$0$1;
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$3;
      var $st$1$0=(($curmask)|0);
      var $40$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curmask+4)|0);
      var $40$1=HEAP32[(($st$1$1)>>2)];
      var $41=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $39, $40$0, $40$1);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $42=$offsbits1;
      var $43$0=$42;
      var $43$1=0;
      var $44=Runtime.bitshift64($41$0, $41$1,"lshr",$43$0);var $44$0 = $44[0], $44$1 = $44[1];
      var $45$0=$44$0;
      var $45=$45$0&65535;
      $result=$45;
      __label__ = 4; break;
    case 4: // $46
      var $47=$offsbits1;
      var $48=((64-$47)|0);
      $offsbits1=$48;
      var $49=$4;
      var $50=(($49)&65535);
      var $51=$offsbits1;
      var $52=$50 >> (($51)|0);
      var $53$0=$52;
      var $53$1=(($52|0) < 0 ? -1 : 0);
      var $st$9$0=(($curmask)|0);
      HEAP32[(($st$9$0)>>2)]=$53$0;
      var $st$9$1=(($curmask+4)|0);
      HEAP32[(($st$9$1)>>2)]=$53$1;
      var $st$13$0=(($curmask)|0);
      var $54$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($curmask+4)|0);
      var $54$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $55=$54$0 != $$emscripten$temp$1$0 || $54$1 != $$emscripten$temp$1$1;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$3;
      var $58=(($57+8)|0);
      var $st$2$0=(($curmask)|0);
      var $59$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($curmask+4)|0);
      var $59$1=HEAP32[(($st$2$1)>>2)];
      var $60=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($5, $58, $59$0, $59$1);
      var $60$0=$60[0];
      var $60$1=$60[1];
      var $61=$offsbits1;
      var $62$0=$61;
      var $62$1=0;
      var $63=Runtime.bitshift64($60$0, $60$1,"shl",$62$0);var $63$0 = $63[0], $63$1 = $63[1];
      var $64=$result;
      var $65$0=$64;
      var $65$1=0;
      var $66$0=$65$0 | $63$0;
      var $66$1=$65$1 | $63$1;
      var $67$0=$66$0;
      var $67=$67$0&65535;
      $result=$67;
      __label__ = 6; break;
    case 6: // $68
      var $69=$result;
      $1=$69;
      __label__ = 7; break;
    case 7: // $70
      var $71=$1;
      STACKTOP = __stackBase__;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 6;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -8;
  var $10=$3;
  var $11$0=$10;
  var $11$1=0;
  var $12=$offsbits;
  var $13$0=$12;
  var $13$1=0;
  var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
  var $15=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($4, $9, $14$0, $14$1);
  var $15$0=$15[0];
  var $15$1=$15[1];
  var $16=$offsbits;
  var $17$0=$16;
  var $17$1=0;
  var $18=Runtime.bitshift64($15$0, $15$1,"lshr",$17$0);var $18$0 = $18[0], $18$1 = $18[1];
  var $19$0=$18$0;
  var $19=$19$0&65535;
  ;
  return $19;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 7;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -8;
  var $10=$3;
  var $11$0=$10;
  var $11$1=0;
  var $12=$offsbits;
  var $13$0=$12;
  var $13$1=0;
  var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
  var $15=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy($4, $9, $14$0, $14$1);
  var $15$0=$15[0];
  var $15$1=$15[1];
  var $16=$offsbits;
  var $17$0=$16;
  var $17$1=0;
  var $18=Runtime.bitshift64($15$0, $15$1,"lshr",$17$0);var $18$0 = $18[0], $18$1 = $18[1];
  var $19$0=$18$0;
  var $19=$19$0&255;
  ;
  return $19;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&255;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0&65535;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  var $6$0=$5;
  var $6$1=0;
  var $7$0=$6$0;
  var $7=$7$0;
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -8;
  var $6=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEj($3, $5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  ;
  return [$6$0,$6$1];
}


function __ZNK22address_space_specificIjL12endianness_t1ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=494;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=496;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=498;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=500;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=502;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=504;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=506;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=508;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=510;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=512;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=514;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=516;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=518;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=520;
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -8;
  var $st$12$0=(($3)|0);
  var $7$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$12$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjy($4, $6, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIjL12endianness_t1ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIyL12endianness_t0ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIyL12endianness_t0ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIjL12endianness_t1ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t1ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((32-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0;
      var $28=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-32)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+4)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $st$1$0=(($3)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $51$0=$50$0;
      var $51=$51$0;
      var $52=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $46, $51, $52);
      __label__ = 6; break;
    case 6: // $53
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      var $58=$offsbits;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $60
      var $61=$offsbits;
      var $62=((32-$61)|0);
      $offsbits=$62;
      var $st$3$0=(($4)|0);
      var $63$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $63$1=HEAP32[(($st$3$1)>>2)];
      var $64=$offsbits;
      var $65$0=$64;
      var $65$1=0;
      var $66=Runtime.bitshift64($63$0, $63$1,"shl",$65$0);var $66$0 = $66[0], $66$1 = $66[1];
      var $67$0=$66$0;
      var $67=$67$0;
      $curmask=$67;
      var $68=$curmask;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$2;
      var $72=(($71+4)|0);
      var $st$2$0=(($3)|0);
      var $73$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $73$1=HEAP32[(($st$2$1)>>2)];
      var $74=$offsbits;
      var $75$0=$74;
      var $75$1=0;
      var $76=Runtime.bitshift64($73$0, $73$1,"shl",$75$0);var $76$0 = $76[0], $76$1 = $76[1];
      var $77$0=$76$0;
      var $77=$77$0;
      var $78=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $72, $77, $78);
      __label__ = 11; break;
    case 11: // $79
      __label__ = 12; break;
    case 12: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIjL12endianness_t1ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAP32[(($28)>>2)];
      var $30=$4;
      var $31=$30 ^ -1;
      var $32=$29 & $31;
      var $33=$3;
      var $34=$4;
      var $35=$33 & $34;
      var $36=$32 | $35;
      var $37=$dest;
      HEAP32[(($37)>>2)]=$36;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 2;
      var $43=$3;
      var $44=$4;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($39, $40, $42, $43, $44);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t1ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK19handler_entry_write7write32ER13address_spacejjj($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+168)|0);
  var $8=(($7+48)|0);
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  __ZNK13delegate_baseIvR13address_spacejjjEclES1_jjj($9, $10, $11, $12, $13);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((32-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0;
      var $28=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-32)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+4)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $st$1$0=(($3)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $51$0=$50$0;
      var $51=$51$0;
      var $52=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $46, $51, $52);
      __label__ = 6; break;
    case 6: // $53
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata;
      var $ljmask;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -4;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -4;
      $2=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $20=$3;
      var $21=$20 << 0;
      $ljdata=$21;
      var $22=$4;
      var $23=$22 << 0;
      $ljmask=$23;
      var $24=$ljmask;
      var $25=$offsbits;
      var $26=$24 >>> (($25)>>>0);
      $curmask=$26;
      var $27=$curmask;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$2;
      var $31=$ljdata;
      var $32=$offsbits;
      var $33=$31 >>> (($32)>>>0);
      var $34=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $30, $33, $34);
      __label__ = 4; break;
    case 4: // $35
      var $36=$offsbits;
      var $37=((32-$36)|0);
      $offsbits=$37;
      var $38=$ljmask;
      var $39=$offsbits;
      var $40=$38 << $39;
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=$ljdata;
      var $47=$offsbits;
      var $48=$46 << $47;
      var $49=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $45, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & -4;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjj($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP32[(($27)>>2)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata;
      var $ljmask;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((16-$13)|0);
      $offsbits=$14;
      var $15=$2;
      var $16=$15 & -4;
      var $17=$3;
      var $18=(($17)&65535);
      var $19=$offsbits;
      var $20=$18 << $19;
      var $21=$4;
      var $22=(($21)&65535);
      var $23=$offsbits;
      var $24=$22 << $23;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $16, $20, $24);
      __label__ = 6; break;
    case 2: // $25
      var $26=$2;
      var $27=$26 & 3;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$2;
      var $30=$29 & -4;
      $2=$30;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=16;
      var $31=$3;
      var $32=(($31)&65535);
      var $33=$32 << 16;
      $ljdata=$33;
      var $34=$4;
      var $35=(($34)&65535);
      var $36=$35 << 16;
      $ljmask=$36;
      var $37=$ljmask;
      var $38=$offsbits1;
      var $39=$37 >>> (($38)>>>0);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$2;
      var $44=$ljdata;
      var $45=$offsbits1;
      var $46=$44 >>> (($45)>>>0);
      var $47=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $43, $46, $47);
      __label__ = 4; break;
    case 4: // $48
      var $49=$offsbits1;
      var $50=((32-$49)|0);
      $offsbits1=$50;
      var $51=$ljmask;
      var $52=$offsbits1;
      var $53=$51 << $52;
      $curmask=$53;
      var $54=$curmask;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$2;
      var $58=(($57+4)|0);
      var $59=$ljdata;
      var $60=$offsbits1;
      var $61=$59 << $60;
      var $62=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $58, $61, $62);
      __label__ = 6; break;
    case 6: // $63
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 2;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((16-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -4;
  var $13=$3;
  var $14=(($13)&65535);
  var $15=$offsbits;
  var $16=$14 << $15;
  var $17=$4;
  var $18=(($17)&65535);
  var $19=$offsbits;
  var $20=$18 << $19;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $12, $16, $20);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 3;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((24-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -4;
  var $13=$3;
  var $14=(($13)&255);
  var $15=$offsbits;
  var $16=$14 << $15;
  var $17=$4;
  var $18=(($17)&255);
  var $19=$offsbits;
  var $20=$18 << $19;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj($5, $12, $16, $20);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((32-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-32)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+4)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$curmask;
      var $47=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $45, $46);
      var $48$0=$47;
      var $48$1=0;
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"shl",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$9$0=(($result)|0);
      var $52$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $52$1=HEAP32[(($st$9$1)>>2)];
      var $53$0=$52$0 | $51$0;
      var $53$1=$52$1 | $51$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$53$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$53$1;
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $62=$offsbits;
      var $63=((32-$62)|0);
      $offsbits=$63;
      var $st$3$0=(($3)|0);
      var $64$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $64$1=HEAP32[(($st$3$1)>>2)];
      var $65=$offsbits;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $68$0=$67$0;
      var $68=$68$0;
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $71
      var $72=$2;
      var $73=(($72+4)|0);
      var $74=$curmask;
      var $75=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $73, $74);
      var $76=$offsbits;
      var $77=$75 >>> (($76)>>>0);
      var $78$0=$77;
      var $78$1=0;
      var $st$8$0=(($result)|0);
      var $79$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($result+4)|0);
      var $79$1=HEAP32[(($st$8$1)>>2)];
      var $80$0=$79$0 | $78$0;
      var $80$1=$79$1 | $78$1;
      var $st$14$0=(($result)|0);
      HEAP32[(($st$14$0)>>2)]=$80$0;
      var $st$14$1=(($result+4)|0);
      HEAP32[(($st$14$1)>>2)]=$80$1;
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      var $st$0$0=(($result)|0);
      var $83$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$83$0,$83$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read32ER13address_spacejj($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t1ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK18handler_entry_read6read32ER13address_spacejj($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+168)|0);
  var $7=(($6+48)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZNK13delegate_baseIjR13address_spacejj8_noparamEclES1_jj($8, $9, $10, $11);
  ;
  return $12;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((32-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-32)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+4)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$curmask;
      var $47=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $45, $46);
      var $48$0=$47;
      var $48$1=0;
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"shl",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$9$0=(($result)|0);
      var $52$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $52$1=HEAP32[(($st$9$1)>>2)];
      var $53$0=$52$0 | $51$0;
      var $53$1=$52$1 | $51$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$53$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$53$1;
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $st$0$0=(($result)|0);
      var $59$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $59$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$59$0,$59$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result;
      var $ljmask;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -4;
      var $12=$4;
      var $13=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -4;
      $3=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      $result=0;
      var $20=$4;
      var $21=$20 << 0;
      $ljmask=$21;
      var $22=$ljmask;
      var $23=$offsbits;
      var $24=$22 >>> (($23)>>>0);
      $curmask=$24;
      var $25=$curmask;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      var $28=$3;
      var $29=$curmask;
      var $30=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($5, $28, $29);
      var $31=$offsbits;
      var $32=$30 << $31;
      $result=$32;
      __label__ = 4; break;
    case 4: // $33
      var $34=$offsbits;
      var $35=((32-$34)|0);
      $offsbits=$35;
      var $36=$ljmask;
      var $37=$offsbits;
      var $38=$36 << $37;
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$3;
      var $43=(($42+4)|0);
      var $44=$curmask;
      var $45=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($5, $43, $44);
      var $46=$offsbits;
      var $47=$45 >>> (($46)>>>0);
      var $48=$result;
      var $49=$48 | $47;
      $result=$49;
      __label__ = 6; break;
    case 6: // $50
      var $51=$result;
      var $52=$51 >>> 0;
      $1=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$1;
      ;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  var $8=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIjL12endianness_t1ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP32[(($25)>>2)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 2;
      var $32=__ZNK18handler_entry_read6read32ER13address_spacejj($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result;
      var $ljmask;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((16-$13)|0);
      $offsbits=$14;
      var $15=$3;
      var $16=$15 & -4;
      var $17=$4;
      var $18=(($17)&65535);
      var $19=$offsbits;
      var $20=$18 << $19;
      var $21=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($5, $16, $20);
      var $22=$offsbits;
      var $23=$21 >>> (($22)>>>0);
      var $24=(($23) & 65535);
      $1=$24;
      __label__ = 7; break;
    case 2: // $25
      var $26=$3;
      var $27=$26 & 3;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$3;
      var $30=$29 & -4;
      $3=$30;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=16;
      $result=0;
      var $31=$4;
      var $32=(($31)&65535);
      var $33=$32 << 16;
      $ljmask=$33;
      var $34=$ljmask;
      var $35=$offsbits1;
      var $36=$34 >>> (($35)>>>0);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $39
      var $40=$3;
      var $41=$curmask;
      var $42=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($5, $40, $41);
      var $43=$offsbits1;
      var $44=$42 << $43;
      $result=$44;
      __label__ = 4; break;
    case 4: // $45
      var $46=$offsbits1;
      var $47=((32-$46)|0);
      $offsbits1=$47;
      var $48=$ljmask;
      var $49=$offsbits1;
      var $50=$48 << $49;
      $curmask=$50;
      var $51=$curmask;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $53
      var $54=$3;
      var $55=(($54+4)|0);
      var $56=$curmask;
      var $57=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($5, $55, $56);
      var $58=$offsbits1;
      var $59=$57 >>> (($58)>>>0);
      var $60=$result;
      var $61=$60 | $59;
      $result=$61;
      __label__ = 6; break;
    case 6: // $62
      var $63=$result;
      var $64=$63 >>> 16;
      var $65=(($64) & 65535);
      $1=$65;
      __label__ = 7; break;
    case 7: // $66
      var $67=$1;
      ;
      return $67;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 2;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((16-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -4;
  var $12=$3;
  var $13=(($12)&65535);
  var $14=$offsbits;
  var $15=$13 << $14;
  var $16=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $11, $15);
  var $17=$offsbits;
  var $18=$16 >>> (($17)>>>0);
  var $19=(($18) & 65535);
  ;
  return $19;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 3;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((24-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -4;
  var $12=$3;
  var $13=(($12)&255);
  var $14=$offsbits;
  var $15=$13 << $14;
  var $16=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj($4, $11, $15);
  var $17=$offsbits;
  var $18=$16 >>> (($17)>>>0);
  var $19=(($18) & 255);
  ;
  return $19;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIjL12endianness_t1ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIjL12endianness_t1ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22address_space_specificIjL12endianness_t1ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=522;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=524;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=526;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=528;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=530;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=532;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=534;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=536;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=538;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=540;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=542;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=544;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=546;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=548;
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIjL12endianness_t1ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((32-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0;
      var $28=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-32)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+4)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $st$1$0=(($3)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $51$0=$50$0;
      var $51=$51$0;
      var $52=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $46, $51, $52);
      __label__ = 6; break;
    case 6: // $53
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      var $58=$offsbits;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $60
      var $61=$offsbits;
      var $62=((32-$61)|0);
      $offsbits=$62;
      var $st$3$0=(($4)|0);
      var $63$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $63$1=HEAP32[(($st$3$1)>>2)];
      var $64=$offsbits;
      var $65$0=$64;
      var $65$1=0;
      var $66=Runtime.bitshift64($63$0, $63$1,"shl",$65$0);var $66$0 = $66[0], $66$1 = $66[1];
      var $67$0=$66$0;
      var $67=$67$0;
      $curmask=$67;
      var $68=$curmask;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$2;
      var $72=(($71+4)|0);
      var $st$2$0=(($3)|0);
      var $73$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $73$1=HEAP32[(($st$2$1)>>2)];
      var $74=$offsbits;
      var $75$0=$74;
      var $75$1=0;
      var $76=Runtime.bitshift64($73$0, $73$1,"shl",$75$0);var $76$0 = $76[0], $76$1 = $76[1];
      var $77$0=$76$0;
      var $77=$77$0;
      var $78=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $72, $77, $78);
      __label__ = 11; break;
    case 11: // $79
      __label__ = 12; break;
    case 12: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIjL12endianness_t1ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAP32[(($28)>>2)];
      var $30=$4;
      var $31=$30 ^ -1;
      var $32=$29 & $31;
      var $33=$3;
      var $34=$4;
      var $35=$33 & $34;
      var $36=$32 | $35;
      var $37=$dest;
      HEAP32[(($37)>>2)]=$36;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 2;
      var $43=$3;
      var $44=$4;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($39, $40, $42, $43, $44);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t1ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((32-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0;
      var $28=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-32)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+4)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $st$1$0=(($3)|0);
      var $47$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $47$1=HEAP32[(($st$1$1)>>2)];
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"lshr",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $51$0=$50$0;
      var $51=$51$0;
      var $52=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $46, $51, $52);
      __label__ = 6; break;
    case 6: // $53
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t1ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EED0Ev["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata;
      var $ljmask;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -4;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -4;
      $2=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $20=$3;
      var $21=$20 << 0;
      $ljdata=$21;
      var $22=$4;
      var $23=$22 << 0;
      $ljmask=$23;
      var $24=$ljmask;
      var $25=$offsbits;
      var $26=$24 >>> (($25)>>>0);
      $curmask=$26;
      var $27=$curmask;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$2;
      var $31=$ljdata;
      var $32=$offsbits;
      var $33=$31 >>> (($32)>>>0);
      var $34=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $30, $33, $34);
      __label__ = 4; break;
    case 4: // $35
      var $36=$offsbits;
      var $37=((32-$36)|0);
      $offsbits=$37;
      var $38=$ljmask;
      var $39=$offsbits;
      var $40=$38 << $39;
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=$ljdata;
      var $47=$offsbits;
      var $48=$46 << $47;
      var $49=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $45, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & -4;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjj($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP32[(($27)>>2)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata;
      var $ljmask;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((16-$13)|0);
      $offsbits=$14;
      var $15=$2;
      var $16=$15 & -4;
      var $17=$3;
      var $18=(($17)&65535);
      var $19=$offsbits;
      var $20=$18 << $19;
      var $21=$4;
      var $22=(($21)&65535);
      var $23=$offsbits;
      var $24=$22 << $23;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $16, $20, $24);
      __label__ = 6; break;
    case 2: // $25
      var $26=$2;
      var $27=$26 & 3;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$2;
      var $30=$29 & -4;
      $2=$30;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=16;
      var $31=$3;
      var $32=(($31)&65535);
      var $33=$32 << 16;
      $ljdata=$33;
      var $34=$4;
      var $35=(($34)&65535);
      var $36=$35 << 16;
      $ljmask=$36;
      var $37=$ljmask;
      var $38=$offsbits1;
      var $39=$37 >>> (($38)>>>0);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$2;
      var $44=$ljdata;
      var $45=$offsbits1;
      var $46=$44 >>> (($45)>>>0);
      var $47=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $43, $46, $47);
      __label__ = 4; break;
    case 4: // $48
      var $49=$offsbits1;
      var $50=((32-$49)|0);
      $offsbits1=$50;
      var $51=$ljmask;
      var $52=$offsbits1;
      var $53=$51 << $52;
      $curmask=$53;
      var $54=$curmask;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$2;
      var $58=(($57+4)|0);
      var $59=$ljdata;
      var $60=$offsbits1;
      var $61=$59 << $60;
      var $62=$curmask;
      __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $58, $61, $62);
      __label__ = 6; break;
    case 6: // $63
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 2;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((16-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -4;
  var $13=$3;
  var $14=(($13)&65535);
  var $15=$offsbits;
  var $16=$14 << $15;
  var $17=$4;
  var $18=(($17)&65535);
  var $19=$offsbits;
  var $20=$18 << $19;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $12, $16, $20);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 3;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((24-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -4;
  var $13=$3;
  var $14=(($13)&255);
  var $15=$offsbits;
  var $16=$14 << $15;
  var $17=$4;
  var $18=(($17)&255);
  var $19=$offsbits;
  var $20=$18 << $19;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj($5, $12, $16, $20);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((32-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-32)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+4)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$curmask;
      var $47=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $45, $46);
      var $48$0=$47;
      var $48$1=0;
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"shl",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$9$0=(($result)|0);
      var $52$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $52$1=HEAP32[(($st$9$1)>>2)];
      var $53$0=$52$0 | $51$0;
      var $53$1=$52$1 | $51$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$53$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$53$1;
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $62=$offsbits;
      var $63=((32-$62)|0);
      $offsbits=$63;
      var $st$3$0=(($3)|0);
      var $64$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $64$1=HEAP32[(($st$3$1)>>2)];
      var $65=$offsbits;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $68$0=$67$0;
      var $68=$68$0;
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $71
      var $72=$2;
      var $73=(($72+4)|0);
      var $74=$curmask;
      var $75=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $73, $74);
      var $76=$offsbits;
      var $77=$75 >>> (($76)>>>0);
      var $78$0=$77;
      var $78$1=0;
      var $st$8$0=(($result)|0);
      var $79$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($result+4)|0);
      var $79$1=HEAP32[(($st$8$1)>>2)];
      var $80$0=$79$0 | $78$0;
      var $80$1=$79$1 | $78$1;
      var $st$14$0=(($result)|0);
      HEAP32[(($st$14$0)>>2)]=$80$0;
      var $st$14$1=(($result+4)|0);
      HEAP32[(($st$14$1)>>2)]=$80$1;
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      var $st$0$0=(($result)|0);
      var $83$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$83$0,$83$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read32ER13address_spacejj($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t1ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((32-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-32)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+4)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$curmask;
      var $47=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $45, $46);
      var $48$0=$47;
      var $48$1=0;
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"shl",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $st$9$0=(($result)|0);
      var $52$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $52$1=HEAP32[(($st$9$1)>>2)];
      var $53$0=$52$0 | $51$0;
      var $53$1=$52$1 | $51$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$53$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$53$1;
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $st$0$0=(($result)|0);
      var $59$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $59$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$59$0,$59$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result;
      var $ljmask;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -4;
      var $12=$4;
      var $13=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -4;
      $3=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      $result=0;
      var $20=$4;
      var $21=$20 << 0;
      $ljmask=$21;
      var $22=$ljmask;
      var $23=$offsbits;
      var $24=$22 >>> (($23)>>>0);
      $curmask=$24;
      var $25=$curmask;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      var $28=$3;
      var $29=$curmask;
      var $30=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($5, $28, $29);
      var $31=$offsbits;
      var $32=$30 << $31;
      $result=$32;
      __label__ = 4; break;
    case 4: // $33
      var $34=$offsbits;
      var $35=((32-$34)|0);
      $offsbits=$35;
      var $36=$ljmask;
      var $37=$offsbits;
      var $38=$36 << $37;
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$3;
      var $43=(($42+4)|0);
      var $44=$curmask;
      var $45=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($5, $43, $44);
      var $46=$offsbits;
      var $47=$45 >>> (($46)>>>0);
      var $48=$result;
      var $49=$48 | $47;
      $result=$49;
      __label__ = 6; break;
    case 6: // $50
      var $51=$result;
      var $52=$51 >>> 0;
      $1=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$1;
      ;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  var $8=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIjL12endianness_t1ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP32[(($25)>>2)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 2;
      var $32=__ZNK18handler_entry_read6read32ER13address_spacejj($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result;
      var $ljmask;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$offsbits;
      var $14=((16-$13)|0);
      $offsbits=$14;
      var $15=$3;
      var $16=$15 & -4;
      var $17=$4;
      var $18=(($17)&65535);
      var $19=$offsbits;
      var $20=$18 << $19;
      var $21=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($5, $16, $20);
      var $22=$offsbits;
      var $23=$21 >>> (($22)>>>0);
      var $24=(($23) & 65535);
      $1=$24;
      __label__ = 7; break;
    case 2: // $25
      var $26=$3;
      var $27=$26 & 3;
      var $28=((($27<<3))|0);
      $offsbits1=$28;
      var $29=$3;
      var $30=$29 & -4;
      $3=$30;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=16;
      $result=0;
      var $31=$4;
      var $32=(($31)&65535);
      var $33=$32 << 16;
      $ljmask=$33;
      var $34=$ljmask;
      var $35=$offsbits1;
      var $36=$34 >>> (($35)>>>0);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $39
      var $40=$3;
      var $41=$curmask;
      var $42=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($5, $40, $41);
      var $43=$offsbits1;
      var $44=$42 << $43;
      $result=$44;
      __label__ = 4; break;
    case 4: // $45
      var $46=$offsbits1;
      var $47=((32-$46)|0);
      $offsbits1=$47;
      var $48=$ljmask;
      var $49=$offsbits1;
      var $50=$48 << $49;
      $curmask=$50;
      var $51=$curmask;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $53
      var $54=$3;
      var $55=(($54+4)|0);
      var $56=$curmask;
      var $57=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($5, $55, $56);
      var $58=$offsbits1;
      var $59=$57 >>> (($58)>>>0);
      var $60=$result;
      var $61=$60 | $59;
      $result=$61;
      __label__ = 6; break;
    case 6: // $62
      var $63=$result;
      var $64=$63 >>> 16;
      var $65=(($64) & 65535);
      $1=$65;
      __label__ = 7; break;
    case 7: // $66
      var $67=$1;
      ;
      return $67;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 2;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((16-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -4;
  var $12=$3;
  var $13=(($12)&65535);
  var $14=$offsbits;
  var $15=$13 << $14;
  var $16=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $11, $15);
  var $17=$offsbits;
  var $18=$16 >>> (($17)>>>0);
  var $19=(($18) & 65535);
  ;
  return $19;
}


function __ZNK22address_space_specificIjL12endianness_t0ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=550;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=552;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=554;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=556;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=558;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=560;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=562;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=564;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=566;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=568;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=570;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=572;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=574;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=576;
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 3;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((24-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -4;
  var $12=$3;
  var $13=(($12)&255);
  var $14=$offsbits;
  var $15=$13 << $14;
  var $16=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj($4, $11, $15);
  var $17=$offsbits;
  var $18=$16 >>> (($17)>>>0);
  var $19=(($18) & 255);
  ;
  return $19;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIjL12endianness_t0ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t1ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIjL12endianness_t1ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIjL12endianness_t0ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t0ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0;
      var $25=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((32-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+4)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $st$1$0=(($3)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"lshr",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $48$0=$47$0;
      var $48=$48$0;
      var $49=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $43, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$offsbits;
      var $58=(($57)>>>0) < 64;
      if ($58) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $59
      var $st$0$0=(($4)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      var $61=$offsbits;
      var $62$0=$61;
      var $62$1=0;
      var $63=Runtime.bitshift64($60$0, $60$1,"lshr",$62$0);var $63$0 = $63[0], $63$1 = $63[1];
      var $64$0=$63$0;
      var $64=$64$0;
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=(($68+4)|0);
      var $st$2$0=(($3)|0);
      var $70$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $70$1=HEAP32[(($st$2$1)>>2)];
      var $71=$offsbits;
      var $72$0=$71;
      var $72$1=0;
      var $73=Runtime.bitshift64($70$0, $70$1,"lshr",$72$0);var $73$0 = $73[0], $73$1 = $73[1];
      var $74$0=$73$0;
      var $74=$74$0;
      var $75=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $69, $74, $75);
      __label__ = 11; break;
    case 11: // $76
      __label__ = 12; break;
    case 12: // $77
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIjL12endianness_t0ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAP32[(($28)>>2)];
      var $30=$4;
      var $31=$30 ^ -1;
      var $32=$29 & $31;
      var $33=$3;
      var $34=$4;
      var $35=$33 & $34;
      var $36=$32 | $35;
      var $37=$dest;
      HEAP32[(($37)>>2)]=$36;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 2;
      var $43=$3;
      var $44=$4;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($39, $40, $42, $43, $44);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t0ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0;
      var $25=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((32-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+4)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $st$1$0=(($3)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"lshr",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $48$0=$47$0;
      var $48=$48$0;
      var $49=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $43, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -4;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -4;
      $2=$19;
      var $20=$4;
      var $21=$offsbits;
      var $22=$20 << $21;
      $curmask=$22;
      var $23=$curmask;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$2;
      var $27=$3;
      var $28=$offsbits;
      var $29=$27 << $28;
      var $30=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $26, $29, $30);
      __label__ = 4; break;
    case 4: // $31
      var $32=$offsbits;
      var $33=((32-$32)|0);
      $offsbits=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$2;
      var $41=(($40+4)|0);
      var $42=$3;
      var $43=$offsbits;
      var $44=$42 >>> (($43)>>>0);
      var $45=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $41, $44, $45);
      __label__ = 6; break;
    case 6: // $46
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & -4;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjj($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP32[(($27)>>2)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$13 & -4;
      var $15=$3;
      var $16=(($15)&65535);
      var $17=$offsbits;
      var $18=$16 << $17;
      var $19=$4;
      var $20=(($19)&65535);
      var $21=$offsbits;
      var $22=$20 << $21;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $14, $18, $22);
      __label__ = 6; break;
    case 2: // $23
      var $24=$2;
      var $25=$24 & 3;
      var $26=((($25<<3))|0);
      $offsbits1=$26;
      var $27=$2;
      var $28=$27 & -4;
      $2=$28;
      var $29=$4;
      var $30=(($29)&65535);
      var $31=$offsbits1;
      var $32=$30 << $31;
      $curmask=$32;
      var $33=$curmask;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$2;
      var $37=$3;
      var $38=(($37)&65535);
      var $39=$offsbits1;
      var $40=$38 << $39;
      var $41=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $36, $40, $41);
      __label__ = 4; break;
    case 4: // $42
      var $43=$offsbits1;
      var $44=((32-$43)|0);
      $offsbits1=$44;
      var $45=$4;
      var $46=(($45)&65535);
      var $47=$offsbits1;
      var $48=$46 >> (($47)|0);
      $curmask=$48;
      var $49=$curmask;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$2;
      var $53=(($52+4)|0);
      var $54=$3;
      var $55=(($54)&65535);
      var $56=$offsbits1;
      var $57=$55 >> (($56)|0);
      var $58=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $53, $57, $58);
      __label__ = 6; break;
    case 6: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 2;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -4;
  var $11=$3;
  var $12=(($11)&65535);
  var $13=$offsbits;
  var $14=$12 << $13;
  var $15=$4;
  var $16=(($15)&65535);
  var $17=$offsbits;
  var $18=$16 << $17;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $10, $14, $18);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 3;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -4;
  var $11=$3;
  var $12=(($11)&255);
  var $13=$offsbits;
  var $14=$12 << $13;
  var $15=$4;
  var $16=(($15)&255);
  var $17=$offsbits;
  var $18=$16 << $17;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj($5, $10, $14, $18);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $18, $19);
      var $21=$offsbits;
      var $22=$20 >>> (($21)>>>0);
      var $23$0=$22;
      var $23$1=0;
      var $st$7$0=(($result)|0);
      HEAP32[(($st$7$0)>>2)]=$23$0;
      var $st$7$1=(($result+4)|0);
      HEAP32[(($st$7$1)>>2)]=$23$1;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((32-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+4)|0);
      $2=$32;
      var $st$3$0=(($3)|0);
      var $33$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$3$1)>>2)];
      var $34=$offsbits;
      var $35$0=$34;
      var $35$1=0;
      var $36=Runtime.bitshift64($33$0, $33$1,"lshr",$35$0);var $36$0 = $36[0], $36$1 = $36[1];
      var $37$0=$36$0;
      var $37=$37$0;
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $41, $42);
      var $44$0=$43;
      var $44$1=0;
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"shl",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $st$9$0=(($result)|0);
      var $48$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $48$1=HEAP32[(($st$9$1)>>2)];
      var $49$0=$48$0 | $47$0;
      var $49$1=$48$1 | $47$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$49$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$49$1;
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$offsbits;
      var $58=(($57)>>>0) < 64;
      if ($58) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $59
      var $st$0$0=(($3)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      var $61=$offsbits;
      var $62$0=$61;
      var $62$1=0;
      var $63=Runtime.bitshift64($60$0, $60$1,"lshr",$62$0);var $63$0 = $63[0], $63$1 = $63[1];
      var $64$0=$63$0;
      var $64=$64$0;
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=(($68+4)|0);
      var $70=$curmask;
      var $71=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $69, $70);
      var $72$0=$71;
      var $72$1=0;
      var $73=$offsbits;
      var $74$0=$73;
      var $74$1=0;
      var $75=Runtime.bitshift64($72$0, $72$1,"shl",$74$0);var $75$0 = $75[0], $75$1 = $75[1];
      var $st$10$0=(($result)|0);
      var $76$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $76$1=HEAP32[(($st$10$1)>>2)];
      var $77$0=$76$0 | $75$0;
      var $77$1=$76$1 | $75$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$77$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$77$1;
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      var $st$0$0=(($result)|0);
      var $80$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $80$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$80$0,$80$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read32ER13address_spacejj($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t0ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $18, $19);
      var $21=$offsbits;
      var $22=$20 >>> (($21)>>>0);
      var $23$0=$22;
      var $23$1=0;
      var $st$7$0=(($result)|0);
      HEAP32[(($st$7$0)>>2)]=$23$0;
      var $st$7$1=(($result+4)|0);
      HEAP32[(($st$7$1)>>2)]=$23$1;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((32-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+4)|0);
      $2=$32;
      var $st$3$0=(($3)|0);
      var $33$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$3$1)>>2)];
      var $34=$offsbits;
      var $35$0=$34;
      var $35$1=0;
      var $36=Runtime.bitshift64($33$0, $33$1,"lshr",$35$0);var $36$0 = $36[0], $36$1 = $36[1];
      var $37$0=$36$0;
      var $37=$37$0;
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $41, $42);
      var $44$0=$43;
      var $44$1=0;
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"shl",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $st$9$0=(($result)|0);
      var $48$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $48$1=HEAP32[(($st$9$1)>>2)];
      var $49$0=$48$0 | $47$0;
      var $49$1=$48$1 | $47$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$49$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$49$1;
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $st$0$0=(($result)|0);
      var $57$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $57$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$57$0,$57$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $result;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -4;
      var $12=$4;
      var $13=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -4;
      $3=$19;
      $result=0;
      var $20=$4;
      var $21=$offsbits;
      var $22=$20 << $21;
      $curmask=$22;
      var $23=$curmask;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$3;
      var $27=$curmask;
      var $28=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($5, $26, $27);
      var $29=$offsbits;
      var $30=$28 >>> (($29)>>>0);
      $result=$30;
      __label__ = 4; break;
    case 4: // $31
      var $32=$offsbits;
      var $33=((32-$32)|0);
      $offsbits=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$3;
      var $41=(($40+4)|0);
      var $42=$curmask;
      var $43=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($5, $41, $42);
      var $44=$offsbits;
      var $45=$43 << $44;
      var $46=$result;
      var $47=$46 | $45;
      $result=$47;
      __label__ = 6; break;
    case 6: // $48
      var $49=$result;
      $1=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$1;
      ;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  var $8=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIjL12endianness_t0ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP32[(($25)>>2)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 2;
      var $32=__ZNK18handler_entry_read6read32ER13address_spacejj($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $result;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$3;
      var $14=$13 & -4;
      var $15=$4;
      var $16=(($15)&65535);
      var $17=$offsbits;
      var $18=$16 << $17;
      var $19=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($5, $14, $18);
      var $20=$offsbits;
      var $21=$19 >>> (($20)>>>0);
      var $22=(($21) & 65535);
      $1=$22;
      __label__ = 7; break;
    case 2: // $23
      var $24=$3;
      var $25=$24 & 3;
      var $26=((($25<<3))|0);
      $offsbits1=$26;
      var $27=$3;
      var $28=$27 & -4;
      $3=$28;
      $result=0;
      var $29=$4;
      var $30=(($29)&65535);
      var $31=$offsbits1;
      var $32=$30 << $31;
      $curmask=$32;
      var $33=$curmask;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$3;
      var $37=$curmask;
      var $38=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($5, $36, $37);
      var $39=$offsbits1;
      var $40=$38 >>> (($39)>>>0);
      var $41=(($40) & 65535);
      $result=$41;
      __label__ = 4; break;
    case 4: // $42
      var $43=$offsbits1;
      var $44=((32-$43)|0);
      $offsbits1=$44;
      var $45=$4;
      var $46=(($45)&65535);
      var $47=$offsbits1;
      var $48=$46 >> (($47)|0);
      $curmask=$48;
      var $49=$curmask;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$3;
      var $53=(($52+4)|0);
      var $54=$curmask;
      var $55=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($5, $53, $54);
      var $56=$offsbits1;
      var $57=$55 << $56;
      var $58=$result;
      var $59=(($58)&65535);
      var $60=$59 | $57;
      var $61=(($60) & 65535);
      $result=$61;
      __label__ = 6; break;
    case 6: // $62
      var $63=$result;
      $1=$63;
      __label__ = 7; break;
    case 7: // $64
      var $65=$1;
      ;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 2;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -4;
  var $10=$3;
  var $11=(($10)&65535);
  var $12=$offsbits;
  var $13=$11 << $12;
  var $14=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $9, $13);
  var $15=$offsbits;
  var $16=$14 >>> (($15)>>>0);
  var $17=(($16) & 65535);
  ;
  return $17;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 3;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -4;
  var $10=$3;
  var $11=(($10)&255);
  var $12=$offsbits;
  var $13=$11 << $12;
  var $14=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj($4, $9, $13);
  var $15=$offsbits;
  var $16=$14 >>> (($15)>>>0);
  var $17=(($16) & 255);
  ;
  return $17;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIjL12endianness_t0ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22address_space_specificIjL12endianness_t0ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=578;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=580;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=582;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=584;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=586;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=588;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=590;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=592;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=594;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=596;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=598;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=600;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=602;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=604;
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIjL12endianness_t0ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0;
      var $25=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((32-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+4)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $st$1$0=(($3)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"lshr",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $48$0=$47$0;
      var $48=$48$0;
      var $49=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $43, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$offsbits;
      var $58=(($57)>>>0) < 64;
      if ($58) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $59
      var $st$0$0=(($4)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      var $61=$offsbits;
      var $62$0=$61;
      var $62$1=0;
      var $63=Runtime.bitshift64($60$0, $60$1,"lshr",$62$0);var $63$0 = $63[0], $63$1 = $63[1];
      var $64$0=$63$0;
      var $64=$64$0;
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=(($68+4)|0);
      var $st$2$0=(($3)|0);
      var $70$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $70$1=HEAP32[(($st$2$1)>>2)];
      var $71=$offsbits;
      var $72$0=$71;
      var $72$1=0;
      var $73=Runtime.bitshift64($70$0, $70$1,"lshr",$72$0);var $73$0 = $73[0], $73$1 = $73[1];
      var $74$0=$73$0;
      var $74=$74$0;
      var $75=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $69, $74, $75);
      __label__ = 11; break;
    case 11: // $76
      __label__ = 12; break;
    case 12: // $77
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIjL12endianness_t0ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAP32[(($28)>>2)];
      var $30=$4;
      var $31=$30 ^ -1;
      var $32=$29 & $31;
      var $33=$3;
      var $34=$4;
      var $35=$33 & $34;
      var $36=$32 | $35;
      var $37=$dest;
      HEAP32[(($37)>>2)]=$36;
      __label__ = 3; break;
    case 2: // $38
      var $39=$handler;
      var $40=$5;
      var $41=$2;
      var $42=$41 >>> 2;
      var $43=$3;
      var $44=$4;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($39, $40, $42, $43, $44);
      __label__ = 3; break;
    case 3: // $45
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t0ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIjL12endianness_t0ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIjL12endianness_t0ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EED0Ev["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -4;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0;
      var $25=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((32-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+4)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $st$1$0=(($3)|0);
      var $44$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $44$1=HEAP32[(($st$1$1)>>2)];
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"lshr",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $48$0=$47$0;
      var $48=$48$0;
      var $49=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $43, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -4;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -4;
      $2=$19;
      var $20=$4;
      var $21=$offsbits;
      var $22=$20 << $21;
      $curmask=$22;
      var $23=$curmask;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$2;
      var $27=$3;
      var $28=$offsbits;
      var $29=$27 << $28;
      var $30=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $26, $29, $30);
      __label__ = 4; break;
    case 4: // $31
      var $32=$offsbits;
      var $33=((32-$32)|0);
      $offsbits=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$2;
      var $41=(($40+4)|0);
      var $42=$3;
      var $43=$offsbits;
      var $44=$42 >>> (($43)>>>0);
      var $45=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $41, $44, $45);
      __label__ = 6; break;
    case 6: // $46
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $6=$2;
  var $7=$6 & -4;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjj($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP32[(($27)>>2)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      __ZNK19handler_entry_write7write32ER13address_spacejjj($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=$13 & -4;
      var $15=$3;
      var $16=(($15)&65535);
      var $17=$offsbits;
      var $18=$16 << $17;
      var $19=$4;
      var $20=(($19)&65535);
      var $21=$offsbits;
      var $22=$20 << $21;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $14, $18, $22);
      __label__ = 6; break;
    case 2: // $23
      var $24=$2;
      var $25=$24 & 3;
      var $26=((($25<<3))|0);
      $offsbits1=$26;
      var $27=$2;
      var $28=$27 & -4;
      $2=$28;
      var $29=$4;
      var $30=(($29)&65535);
      var $31=$offsbits1;
      var $32=$30 << $31;
      $curmask=$32;
      var $33=$curmask;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$2;
      var $37=$3;
      var $38=(($37)&65535);
      var $39=$offsbits1;
      var $40=$38 << $39;
      var $41=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $36, $40, $41);
      __label__ = 4; break;
    case 4: // $42
      var $43=$offsbits1;
      var $44=((32-$43)|0);
      $offsbits1=$44;
      var $45=$4;
      var $46=(($45)&65535);
      var $47=$offsbits1;
      var $48=$46 >> (($47)|0);
      $curmask=$48;
      var $49=$curmask;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$2;
      var $53=(($52+4)|0);
      var $54=$3;
      var $55=(($54)&65535);
      var $56=$offsbits1;
      var $57=$55 >> (($56)|0);
      var $58=$curmask;
      __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $53, $57, $58);
      __label__ = 6; break;
    case 6: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & 2;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -4;
  var $11=$3;
  var $12=(($11)&65535);
  var $13=$offsbits;
  var $14=$12 << $13;
  var $15=$4;
  var $16=(($15)&65535);
  var $17=$offsbits;
  var $18=$16 << $17;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $10, $14, $18);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 3;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -4;
  var $11=$3;
  var $12=(($11)&255);
  var $13=$offsbits;
  var $14=$12 << $13;
  var $15=$4;
  var $16=(($15)&255);
  var $17=$offsbits;
  var $18=$16 << $17;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj($5, $10, $14, $18);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $18, $19);
      var $21=$offsbits;
      var $22=$20 >>> (($21)>>>0);
      var $23$0=$22;
      var $23$1=0;
      var $st$7$0=(($result)|0);
      HEAP32[(($st$7$0)>>2)]=$23$0;
      var $st$7$1=(($result+4)|0);
      HEAP32[(($st$7$1)>>2)]=$23$1;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((32-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+4)|0);
      $2=$32;
      var $st$3$0=(($3)|0);
      var $33$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$3$1)>>2)];
      var $34=$offsbits;
      var $35$0=$34;
      var $35$1=0;
      var $36=Runtime.bitshift64($33$0, $33$1,"lshr",$35$0);var $36$0 = $36[0], $36$1 = $36[1];
      var $37$0=$36$0;
      var $37=$37$0;
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $41, $42);
      var $44$0=$43;
      var $44$1=0;
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"shl",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $st$9$0=(($result)|0);
      var $48$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $48$1=HEAP32[(($st$9$1)>>2)];
      var $49$0=$48$0 | $47$0;
      var $49$1=$48$1 | $47$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$49$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$49$1;
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$offsbits;
      var $58=(($57)>>>0) < 64;
      if ($58) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $59
      var $st$0$0=(($3)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      var $61=$offsbits;
      var $62$0=$61;
      var $62$1=0;
      var $63=Runtime.bitshift64($60$0, $60$1,"lshr",$62$0);var $63$0 = $63[0], $63$1 = $63[1];
      var $64$0=$63$0;
      var $64=$64$0;
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=(($68+4)|0);
      var $70=$curmask;
      var $71=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $69, $70);
      var $72$0=$71;
      var $72$1=0;
      var $73=$offsbits;
      var $74$0=$73;
      var $74$1=0;
      var $75=Runtime.bitshift64($72$0, $72$1,"shl",$74$0);var $75$0 = $75[0], $75$1 = $75[1];
      var $st$10$0=(($result)|0);
      var $76$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $76$1=HEAP32[(($st$10$1)>>2)];
      var $77$0=$76$0 | $75$0;
      var $77$1=$76$1 | $75$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$77$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$77$1;
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      var $st$0$0=(($result)|0);
      var $80$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $80$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$80$0,$80$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIjL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 2;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read32ER13address_spacejj($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj["X"]=1;

function __ZNK22address_space_specificIjL12endianness_t0ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 3;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -4;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $18, $19);
      var $21=$offsbits;
      var $22=$20 >>> (($21)>>>0);
      var $23$0=$22;
      var $23$1=0;
      var $st$7$0=(($result)|0);
      HEAP32[(($st$7$0)>>2)]=$23$0;
      var $st$7$1=(($result+4)|0);
      HEAP32[(($st$7$1)>>2)]=$23$1;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((32-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+4)|0);
      $2=$32;
      var $st$3$0=(($3)|0);
      var $33$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $33$1=HEAP32[(($st$3$1)>>2)];
      var $34=$offsbits;
      var $35$0=$34;
      var $35$1=0;
      var $36=Runtime.bitshift64($33$0, $33$1,"lshr",$35$0);var $36$0 = $36[0], $36$1 = $36[1];
      var $37$0=$36$0;
      var $37=$37$0;
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $41, $42);
      var $44$0=$43;
      var $44$1=0;
      var $45=$offsbits;
      var $46$0=$45;
      var $46$1=0;
      var $47=Runtime.bitshift64($44$0, $44$1,"shl",$46$0);var $47$0 = $47[0], $47$1 = $47[1];
      var $st$9$0=(($result)|0);
      var $48$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $48$1=HEAP32[(($st$9$1)>>2)];
      var $49$0=$48$0 | $47$0;
      var $49$1=$48$1 | $47$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$49$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$49$1;
      __label__ = 6; break;
    case 6: // $50
      var $51=$offsbits;
      var $52=(($51+32)|0);
      $offsbits=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $st$0$0=(($result)|0);
      var $57$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $57$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$57$0,$57$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $result;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$3;
      var $7=$6 & 3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -4;
      var $12=$4;
      var $13=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 3;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -4;
      $3=$19;
      $result=0;
      var $20=$4;
      var $21=$offsbits;
      var $22=$20 << $21;
      $curmask=$22;
      var $23=$curmask;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$3;
      var $27=$curmask;
      var $28=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($5, $26, $27);
      var $29=$offsbits;
      var $30=$28 >>> (($29)>>>0);
      $result=$30;
      __label__ = 4; break;
    case 4: // $31
      var $32=$offsbits;
      var $33=((32-$32)|0);
      $offsbits=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$3;
      var $41=(($40+4)|0);
      var $42=$curmask;
      var $43=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($5, $41, $42);
      var $44=$offsbits;
      var $45=$43 << $44;
      var $46=$result;
      var $47=$46 | $45;
      $result=$47;
      __label__ = 6; break;
    case 6: // $48
      var $49=$result;
      $1=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$1;
      ;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=4;
  $TARGET_BITS=32;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  var $8=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIjL12endianness_t0ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP32[(($25)>>2)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 2;
      var $32=__ZNK18handler_entry_read6read32ER13address_spacejj($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $offsbits1;
      var $result;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 3;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$offsbits;
      var $10=(($9+16)|0);
      var $11=(($10)>>>0) <= 32;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$3;
      var $14=$13 & -4;
      var $15=$4;
      var $16=(($15)&65535);
      var $17=$offsbits;
      var $18=$16 << $17;
      var $19=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($5, $14, $18);
      var $20=$offsbits;
      var $21=$19 >>> (($20)>>>0);
      var $22=(($21) & 65535);
      $1=$22;
      __label__ = 7; break;
    case 2: // $23
      var $24=$3;
      var $25=$24 & 3;
      var $26=((($25<<3))|0);
      $offsbits1=$26;
      var $27=$3;
      var $28=$27 & -4;
      $3=$28;
      $result=0;
      var $29=$4;
      var $30=(($29)&65535);
      var $31=$offsbits1;
      var $32=$30 << $31;
      $curmask=$32;
      var $33=$curmask;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$3;
      var $37=$curmask;
      var $38=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($5, $36, $37);
      var $39=$offsbits1;
      var $40=$38 >>> (($39)>>>0);
      var $41=(($40) & 65535);
      $result=$41;
      __label__ = 4; break;
    case 4: // $42
      var $43=$offsbits1;
      var $44=((32-$43)|0);
      $offsbits1=$44;
      var $45=$4;
      var $46=(($45)&65535);
      var $47=$offsbits1;
      var $48=$46 >> (($47)|0);
      $curmask=$48;
      var $49=$curmask;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$3;
      var $53=(($52+4)|0);
      var $54=$curmask;
      var $55=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($5, $53, $54);
      var $56=$offsbits1;
      var $57=$55 << $56;
      var $58=$result;
      var $59=(($58)&65535);
      var $60=$59 | $57;
      var $61=(($60) & 65535);
      $result=$61;
      __label__ = 6; break;
    case 6: // $62
      var $63=$result;
      $1=$63;
      __label__ = 7; break;
    case 7: // $64
      var $65=$1;
      ;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZNK22address_space_specificItL12endianness_t1ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=606;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=608;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=610;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=612;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=614;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=616;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=618;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=620;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=622;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=624;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=626;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=628;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=630;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=632;
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & 2;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -4;
  var $10=$3;
  var $11=(($10)&65535);
  var $12=$offsbits;
  var $13=$11 << $12;
  var $14=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $9, $13);
  var $15=$offsbits;
  var $16=$14 >>> (($15)>>>0);
  var $17=(($16) & 65535);
  ;
  return $17;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 3;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -4;
  var $10=$3;
  var $11=(($10)&255);
  var $12=$offsbits;
  var $13=$11 << $12;
  var $14=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj($4, $9, $13);
  var $15=$offsbits;
  var $16=$14 >>> (($15)>>>0);
  var $17=(($16) & 255);
  ;
  return $17;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -4;
  var $6=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -4;
  var $7=$3;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjj($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificItL12endianness_t1ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIjL12endianness_t0ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIjL12endianness_t0ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificItL12endianness_t1ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t1ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0&65535;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)&65535);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$2;
      var $st$1$0=(($3)|0);
      var $24$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $24$1=HEAP32[(($st$1$1)>>2)];
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"lshr",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $28$0=$27$0;
      var $28=$28$0&65535;
      var $29=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $23, $28, $29);
      __label__ = 2; break;
    case 2: // $30
      $index=0;
      __label__ = 3; break;
    case 3: // $31
      var $32=$index;
      var $33=(($32)>>>0) < 3;
      if ($33) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $34
      var $35=$offsbits;
      var $36=(($35-16)|0);
      $offsbits=$36;
      var $37=$2;
      var $38=(($37+2)|0);
      $2=$38;
      var $st$6$0=(($4)|0);
      var $39$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $39$1=HEAP32[(($st$6$1)>>2)];
      var $40=$offsbits;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $43$0=$42$0;
      var $43=$43$0&65535;
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$2;
      var $st$1$0=(($3)|0);
      var $49$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $49$1=HEAP32[(($st$1$1)>>2)];
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"lshr",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $53$0=$52$0;
      var $53=$53$0&65535;
      var $54=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $48, $53, $54);
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $60=$offsbits;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $62
      var $63=$offsbits;
      var $64=((16-$63)|0);
      $offsbits=$64;
      var $st$3$0=(($4)|0);
      var $65$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $65$1=HEAP32[(($st$3$1)>>2)];
      var $66=$offsbits;
      var $67$0=$66;
      var $67$1=0;
      var $68=Runtime.bitshift64($65$0, $65$1,"shl",$67$0);var $68$0 = $68[0], $68$1 = $68[1];
      var $69$0=$68$0;
      var $69=$69$0&65535;
      $curmask=$69;
      var $70=$curmask;
      var $71=(($70)&65535);
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$2;
      var $75=(($74+2)|0);
      var $st$2$0=(($3)|0);
      var $76$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $76$1=HEAP32[(($st$2$1)>>2)];
      var $77=$offsbits;
      var $78$0=$77;
      var $78$1=0;
      var $79=Runtime.bitshift64($76$0, $76$1,"shl",$78$0);var $79$0 = $79[0], $79$1 = $79[1];
      var $80$0=$79$0;
      var $80=$80$0&65535;
      var $81=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $75, $80, $81);
      __label__ = 11; break;
    case 11: // $82
      __label__ = 12; break;
    case 12: // $83
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificItL12endianness_t1ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$4;
      var $32=(($31)&65535);
      var $33=$32 ^ -1;
      var $34=$30 & $33;
      var $35=$3;
      var $36=(($35)&65535);
      var $37=$4;
      var $38=(($37)&65535);
      var $39=$36 & $38;
      var $40=$34 | $39;
      var $41=(($40) & 65535);
      var $42=$dest;
      HEAP16[(($42)>>1)]=$41;
      __label__ = 3; break;
    case 2: // $43
      var $44=$handler;
      var $45=$5;
      var $46=$2;
      var $47=$46 >>> 1;
      var $48=$3;
      var $49=$4;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($44, $45, $47, $48, $49);
      __label__ = 3; break;
    case 3: // $50
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t1ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK19handler_entry_write7write16ER13address_spacejtt($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+168)|0);
  var $8=(($7+24)|0);
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  __ZNK13delegate_baseIvR13address_spacejttEclES1_jtt($9, $10, $11, $12, $13);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0&65535;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)&65535);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$2;
      var $st$1$0=(($3)|0);
      var $24$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $24$1=HEAP32[(($st$1$1)>>2)];
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"lshr",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $28$0=$27$0;
      var $28=$28$0&65535;
      var $29=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $23, $28, $29);
      __label__ = 2; break;
    case 2: // $30
      $index=0;
      __label__ = 3; break;
    case 3: // $31
      var $32=$index;
      var $33=(($32)>>>0) < 3;
      if ($33) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $34
      var $35=$offsbits;
      var $36=(($35-16)|0);
      $offsbits=$36;
      var $37=$2;
      var $38=(($37+2)|0);
      $2=$38;
      var $st$6$0=(($4)|0);
      var $39$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $39$1=HEAP32[(($st$6$1)>>2)];
      var $40=$offsbits;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $43$0=$42$0;
      var $43=$43$0&65535;
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$2;
      var $st$1$0=(($3)|0);
      var $49$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $49$1=HEAP32[(($st$1$1)>>2)];
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"lshr",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $53$0=$52$0;
      var $53=$53$0&65535;
      var $54=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $48, $53, $54);
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((32-$12)|0);
      $offsbits=$13;
      var $14=$4;
      var $15=$offsbits;
      var $16=$14 >>> (($15)>>>0);
      var $17=(($16) & 65535);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=$offsbits;
      var $25=$23 >>> (($24)>>>0);
      var $26=(($25) & 65535);
      var $27=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $22, $26, $27);
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-16)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+2)|0);
      $2=$36;
      var $37=$4;
      var $38=$offsbits;
      var $39=$37 >>> (($38)>>>0);
      var $40=(($39) & 65535);
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$3;
      var $47=$offsbits;
      var $48=$46 >>> (($47)>>>0);
      var $49=(($48) & 65535);
      var $50=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $45, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$offsbits;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=$offsbits;
      var $60=((16-$59)|0);
      $offsbits=$60;
      var $61=$4;
      var $62=$offsbits;
      var $63=$61 << $62;
      var $64=(($63) & 65535);
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)&65535);
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $68
      var $69=$2;
      var $70=(($69+2)|0);
      var $71=$3;
      var $72=$offsbits;
      var $73=$71 << $72;
      var $74=(($73) & 65535);
      var $75=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $70, $74, $75);
      __label__ = 11; break;
    case 11: // $76
      __label__ = 12; break;
    case 12: // $77
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((32-$12)|0);
      $offsbits=$13;
      var $14=$4;
      var $15=$offsbits;
      var $16=$14 >>> (($15)>>>0);
      var $17=(($16) & 65535);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=$offsbits;
      var $25=$23 >>> (($24)>>>0);
      var $26=(($25) & 65535);
      var $27=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $22, $26, $27);
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-16)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+2)|0);
      $2=$36;
      var $37=$4;
      var $38=$offsbits;
      var $39=$37 >>> (($38)>>>0);
      var $40=(($39) & 65535);
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$3;
      var $47=$offsbits;
      var $48=$46 >>> (($47)>>>0);
      var $49=(($48) & 65535);
      var $50=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $45, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata;
      var $ljmask;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -2;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -2;
      $2=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $20=$3;
      var $21=(($20)&65535);
      var $22=$21 << 0;
      var $23=(($22) & 65535);
      $ljdata=$23;
      var $24=$4;
      var $25=(($24)&65535);
      var $26=$25 << 0;
      var $27=(($26) & 65535);
      $ljmask=$27;
      var $28=$ljmask;
      var $29=(($28)&65535);
      var $30=$offsbits;
      var $31=$29 >> (($30)|0);
      var $32=(($31) & 65535);
      $curmask=$32;
      var $33=$curmask;
      var $34=(($33)&65535);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $36
      var $37=$2;
      var $38=$ljdata;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 65535);
      var $43=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $37, $42, $43);
      __label__ = 4; break;
    case 4: // $44
      var $45=$offsbits;
      var $46=((16-$45)|0);
      $offsbits=$46;
      var $47=$ljmask;
      var $48=(($47)&65535);
      var $49=$offsbits;
      var $50=$48 << $49;
      var $51=(($50) & 65535);
      $curmask=$51;
      var $52=$curmask;
      var $53=(($52)&65535);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$2;
      var $57=(($56+2)|0);
      var $58=$ljdata;
      var $59=(($58)&65535);
      var $60=$offsbits;
      var $61=$59 << $60;
      var $62=(($61) & 65535);
      var $63=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $57, $62, $63);
      __label__ = 6; break;
    case 6: // $64
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & -2;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjt($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP16[(($27)>>1)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 1;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((8-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -2;
  var $13=$3;
  var $14=(($13)&255);
  var $15=(($14)&65535);
  var $16=$offsbits;
  var $17=$15 << $16;
  var $18=(($17) & 65535);
  var $19=$4;
  var $20=(($19)&255);
  var $21=(($20)&65535);
  var $22=$offsbits;
  var $23=$21 << $22;
  var $24=(($23) & 65535);
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt($5, $12, $18, $24);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&65535;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$curmask;
      var $24=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $22, $23);
      var $25$0=$24;
      var $25$1=0;
      var $26=$offsbits;
      var $27$0=$26;
      var $27$1=0;
      var $28=Runtime.bitshift64($25$0, $25$1,"shl",$27$0);var $28$0 = $28[0], $28$1 = $28[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$28$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$28$1;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-16)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+2)|0);
      $2=$37;
      var $st$6$0=(($3)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&65535;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&65535);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $47, $48);
      var $50$0=$49;
      var $50$1=0;
      var $51=$offsbits;
      var $52$0=$51;
      var $52$1=0;
      var $53=Runtime.bitshift64($50$0, $50$1,"shl",$52$0);var $53$0 = $53[0], $53$1 = $53[1];
      var $st$9$0=(($result)|0);
      var $54$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $54$1=HEAP32[(($st$9$1)>>2)];
      var $55$0=$54$0 | $53$0;
      var $55$1=$54$1 | $53$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$55$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$55$1;
      __label__ = 6; break;
    case 6: // $56
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $61=$offsbits;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $63
      var $64=$offsbits;
      var $65=((16-$64)|0);
      $offsbits=$65;
      var $st$3$0=(($3)|0);
      var $66$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $66$1=HEAP32[(($st$3$1)>>2)];
      var $67=$offsbits;
      var $68$0=$67;
      var $68$1=0;
      var $69=Runtime.bitshift64($66$0, $66$1,"shl",$68$0);var $69$0 = $69[0], $69$1 = $69[1];
      var $70$0=$69$0;
      var $70=$70$0&65535;
      $curmask=$70;
      var $71=$curmask;
      var $72=(($71)&65535);
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $74
      var $75=$2;
      var $76=(($75+2)|0);
      var $77=$curmask;
      var $78=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $76, $77);
      var $79=(($78)&65535);
      var $80=$offsbits;
      var $81=$79 >> (($80)|0);
      var $82$0=$81;
      var $82$1=(($81|0) < 0 ? -1 : 0);
      var $st$9$0=(($result)|0);
      var $83$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$9$1)>>2)];
      var $84$0=$83$0 | $82$0;
      var $84$1=$83$1 | $82$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$84$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$84$1;
      __label__ = 11; break;
    case 11: // $85
      __label__ = 12; break;
    case 12: // $86
      var $st$0$0=(($result)|0);
      var $87$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $87$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$87$0,$87$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP16[(($26)>>1)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read16ER13address_spacejt($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t1ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK18handler_entry_read6read16ER13address_spacejt($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+168)|0);
  var $7=(($6+24)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZNK13delegate_baseItR13address_spacejt8_noparamEclES1_jt($8, $9, $10, $11);
  ;
  return $12;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&65535;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$curmask;
      var $24=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $22, $23);
      var $25$0=$24;
      var $25$1=0;
      var $26=$offsbits;
      var $27$0=$26;
      var $27$1=0;
      var $28=Runtime.bitshift64($25$0, $25$1,"shl",$27$0);var $28$0 = $28[0], $28$1 = $28[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$28$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$28$1;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-16)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+2)|0);
      $2=$37;
      var $st$6$0=(($3)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&65535;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&65535);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $47, $48);
      var $50$0=$49;
      var $50$1=0;
      var $51=$offsbits;
      var $52$0=$51;
      var $52$1=0;
      var $53=Runtime.bitshift64($50$0, $50$1,"shl",$52$0);var $53$0 = $53[0], $53$1 = $53[1];
      var $st$9$0=(($result)|0);
      var $54$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $54$1=HEAP32[(($st$9$1)>>2)];
      var $55$0=$54$0 | $53$0;
      var $55$1=$54$1 | $53$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$55$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$55$1;
      __label__ = 6; break;
    case 6: // $56
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $st$0$0=(($result)|0);
      var $61$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $61$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$61$0,$61$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$3;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 65535);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&65535);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $21, $22);
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 << $25;
      $result=$26;
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-16)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $36=$3;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 65535);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $44, $45);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=$50 | $49;
      $result=$51;
      __label__ = 6; break;
    case 6: // $52
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$offsbits;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $59
      var $60=$offsbits;
      var $61=((16-$60)|0);
      $offsbits=$61;
      var $62=$3;
      var $63=$offsbits;
      var $64=$62 << $63;
      var $65=(($64) & 65535);
      $curmask=$65;
      var $66=$curmask;
      var $67=(($66)&65535);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $69
      var $70=$2;
      var $71=(($70+2)|0);
      var $72=$curmask;
      var $73=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $71, $72);
      var $74=(($73)&65535);
      var $75=$offsbits;
      var $76=$74 >> (($75)|0);
      var $77=$result;
      var $78=$77 | $76;
      $result=$78;
      __label__ = 11; break;
    case 11: // $79
      __label__ = 12; break;
    case 12: // $80
      var $81=$result;
      ;
      return $81;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$3;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 65535);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&65535);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $21, $22);
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 << $25;
      $result=$26;
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-16)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $36=$3;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 65535);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $44, $45);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=$50 | $49;
      $result=$51;
      __label__ = 6; break;
    case 6: // $52
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$result;
      ;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result;
      var $ljmask;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -2;
      var $12=$4;
      var $13=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -2;
      $3=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      $result=0;
      var $20=$4;
      var $21=(($20)&65535);
      var $22=$21 << 0;
      var $23=(($22) & 65535);
      $ljmask=$23;
      var $24=$ljmask;
      var $25=(($24)&65535);
      var $26=$offsbits;
      var $27=$25 >> (($26)|0);
      var $28=(($27) & 65535);
      $curmask=$28;
      var $29=$curmask;
      var $30=(($29)&65535);
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $32
      var $33=$3;
      var $34=$curmask;
      var $35=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($5, $33, $34);
      var $36=(($35)&65535);
      var $37=$offsbits;
      var $38=$36 << $37;
      var $39=(($38) & 65535);
      $result=$39;
      __label__ = 4; break;
    case 4: // $40
      var $41=$offsbits;
      var $42=((16-$41)|0);
      $offsbits=$42;
      var $43=$ljmask;
      var $44=(($43)&65535);
      var $45=$offsbits;
      var $46=$44 << $45;
      var $47=(($46) & 65535);
      $curmask=$47;
      var $48=$curmask;
      var $49=(($48)&65535);
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$3;
      var $53=(($52+2)|0);
      var $54=$curmask;
      var $55=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($5, $53, $54);
      var $56=(($55)&65535);
      var $57=$offsbits;
      var $58=$56 >> (($57)|0);
      var $59=$result;
      var $60=(($59)&65535);
      var $61=$60 | $58;
      var $62=(($61) & 65535);
      $result=$62;
      __label__ = 6; break;
    case 6: // $63
      var $64=$result;
      var $65=(($64)&65535);
      var $66=$65 >> 0;
      var $67=(($66) & 65535);
      $1=$67;
      __label__ = 7; break;
    case 7: // $68
      var $69=$1;
      ;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  var $8=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificItL12endianness_t1ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP16[(($25)>>1)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 1;
      var $32=__ZNK18handler_entry_read6read16ER13address_spacejt($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 1;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((8-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -2;
  var $12=$3;
  var $13=(($12)&255);
  var $14=(($13)&65535);
  var $15=$offsbits;
  var $16=$14 << $15;
  var $17=(($16) & 65535);
  var $18=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt($4, $11, $17);
  var $19=(($18)&65535);
  var $20=$offsbits;
  var $21=$19 >> (($20)|0);
  var $22=(($21) & 255);
  ;
  return $22;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZNK22address_space_specificItL12endianness_t1ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=634;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=636;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=638;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=640;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=642;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=644;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=646;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=648;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=650;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=652;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=654;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=656;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=658;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=660;
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificItL12endianness_t1ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificItL12endianness_t1ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificItL12endianness_t1ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t1ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EED0Ev["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0&65535;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)&65535);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$2;
      var $st$1$0=(($3)|0);
      var $24$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $24$1=HEAP32[(($st$1$1)>>2)];
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"lshr",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $28$0=$27$0;
      var $28=$28$0&65535;
      var $29=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $23, $28, $29);
      __label__ = 2; break;
    case 2: // $30
      $index=0;
      __label__ = 3; break;
    case 3: // $31
      var $32=$index;
      var $33=(($32)>>>0) < 3;
      if ($33) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $34
      var $35=$offsbits;
      var $36=(($35-16)|0);
      $offsbits=$36;
      var $37=$2;
      var $38=(($37+2)|0);
      $2=$38;
      var $st$6$0=(($4)|0);
      var $39$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $39$1=HEAP32[(($st$6$1)>>2)];
      var $40=$offsbits;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $43$0=$42$0;
      var $43=$43$0&65535;
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$2;
      var $st$1$0=(($3)|0);
      var $49$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $49$1=HEAP32[(($st$1$1)>>2)];
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"lshr",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $53$0=$52$0;
      var $53=$53$0&65535;
      var $54=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $48, $53, $54);
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $60=$offsbits;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $62
      var $63=$offsbits;
      var $64=((16-$63)|0);
      $offsbits=$64;
      var $st$3$0=(($4)|0);
      var $65$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $65$1=HEAP32[(($st$3$1)>>2)];
      var $66=$offsbits;
      var $67$0=$66;
      var $67$1=0;
      var $68=Runtime.bitshift64($65$0, $65$1,"shl",$67$0);var $68$0 = $68[0], $68$1 = $68[1];
      var $69$0=$68$0;
      var $69=$69$0&65535;
      $curmask=$69;
      var $70=$curmask;
      var $71=(($70)&65535);
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$2;
      var $75=(($74+2)|0);
      var $st$2$0=(($3)|0);
      var $76$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $76$1=HEAP32[(($st$2$1)>>2)];
      var $77=$offsbits;
      var $78$0=$77;
      var $78$1=0;
      var $79=Runtime.bitshift64($76$0, $76$1,"shl",$78$0);var $79$0 = $79[0], $79$1 = $79[1];
      var $80$0=$79$0;
      var $80=$80$0&65535;
      var $81=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $75, $80, $81);
      __label__ = 11; break;
    case 11: // $82
      __label__ = 12; break;
    case 12: // $83
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificItL12endianness_t1ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$4;
      var $32=(($31)&65535);
      var $33=$32 ^ -1;
      var $34=$30 & $33;
      var $35=$3;
      var $36=(($35)&65535);
      var $37=$4;
      var $38=(($37)&65535);
      var $39=$36 & $38;
      var $40=$34 | $39;
      var $41=(($40) & 65535);
      var $42=$dest;
      HEAP16[(($42)>>1)]=$41;
      __label__ = 3; break;
    case 2: // $43
      var $44=$handler;
      var $45=$5;
      var $46=$2;
      var $47=$46 >>> 1;
      var $48=$3;
      var $49=$4;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($44, $45, $47, $48, $49);
      __label__ = 3; break;
    case 3: // $50
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t1ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((64-$12)|0);
      $offsbits=$13;
      var $st$35$0=(($4)|0);
      var $14$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($4+4)|0);
      var $14$1=HEAP32[(($st$35$1)>>2)];
      var $15=$offsbits;
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($14$0, $14$1,"lshr",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $18$0=$17$0;
      var $18=$18$0&65535;
      $curmask=$18;
      var $19=$curmask;
      var $20=(($19)&65535);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$2;
      var $st$1$0=(($3)|0);
      var $24$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $24$1=HEAP32[(($st$1$1)>>2)];
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"lshr",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $28$0=$27$0;
      var $28=$28$0&65535;
      var $29=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $23, $28, $29);
      __label__ = 2; break;
    case 2: // $30
      $index=0;
      __label__ = 3; break;
    case 3: // $31
      var $32=$index;
      var $33=(($32)>>>0) < 3;
      if ($33) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $34
      var $35=$offsbits;
      var $36=(($35-16)|0);
      $offsbits=$36;
      var $37=$2;
      var $38=(($37+2)|0);
      $2=$38;
      var $st$6$0=(($4)|0);
      var $39$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $39$1=HEAP32[(($st$6$1)>>2)];
      var $40=$offsbits;
      var $41$0=$40;
      var $41$1=0;
      var $42=Runtime.bitshift64($39$0, $39$1,"lshr",$41$0);var $42$0 = $42[0], $42$1 = $42[1];
      var $43$0=$42$0;
      var $43=$43$0&65535;
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$2;
      var $st$1$0=(($3)|0);
      var $49$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $49$1=HEAP32[(($st$1$1)>>2)];
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"lshr",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $53$0=$52$0;
      var $53=$53$0&65535;
      var $54=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $48, $53, $54);
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((32-$12)|0);
      $offsbits=$13;
      var $14=$4;
      var $15=$offsbits;
      var $16=$14 >>> (($15)>>>0);
      var $17=(($16) & 65535);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=$offsbits;
      var $25=$23 >>> (($24)>>>0);
      var $26=(($25) & 65535);
      var $27=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $22, $26, $27);
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-16)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+2)|0);
      $2=$36;
      var $37=$4;
      var $38=$offsbits;
      var $39=$37 >>> (($38)>>>0);
      var $40=(($39) & 65535);
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$3;
      var $47=$offsbits;
      var $48=$46 >>> (($47)>>>0);
      var $49=(($48) & 65535);
      var $50=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $45, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$offsbits;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=$offsbits;
      var $60=((16-$59)|0);
      $offsbits=$60;
      var $61=$4;
      var $62=$offsbits;
      var $63=$61 << $62;
      var $64=(($63) & 65535);
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)&65535);
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $68
      var $69=$2;
      var $70=(($69+2)|0);
      var $71=$3;
      var $72=$offsbits;
      var $73=$71 << $72;
      var $74=(($73) & 65535);
      var $75=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $70, $74, $75);
      __label__ = 11; break;
    case 11: // $76
      __label__ = 12; break;
    case 12: // $77
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$offsbits;
      var $12=((16-$11)|0);
      var $13=((32-$12)|0);
      $offsbits=$13;
      var $14=$4;
      var $15=$offsbits;
      var $16=$14 >>> (($15)>>>0);
      var $17=(($16) & 65535);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=$offsbits;
      var $25=$23 >>> (($24)>>>0);
      var $26=(($25) & 65535);
      var $27=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $22, $26, $27);
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-16)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+2)|0);
      $2=$36;
      var $37=$4;
      var $38=$offsbits;
      var $39=$37 >>> (($38)>>>0);
      var $40=(($39) & 65535);
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $46=$3;
      var $47=$offsbits;
      var $48=$46 >>> (($47)>>>0);
      var $49=(($48) & 65535);
      var $50=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $45, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $ljdata;
      var $ljmask;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -2;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -2;
      $2=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      var $20=$3;
      var $21=(($20)&65535);
      var $22=$21 << 0;
      var $23=(($22) & 65535);
      $ljdata=$23;
      var $24=$4;
      var $25=(($24)&65535);
      var $26=$25 << 0;
      var $27=(($26) & 65535);
      $ljmask=$27;
      var $28=$ljmask;
      var $29=(($28)&65535);
      var $30=$offsbits;
      var $31=$29 >> (($30)|0);
      var $32=(($31) & 65535);
      $curmask=$32;
      var $33=$curmask;
      var $34=(($33)&65535);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $36
      var $37=$2;
      var $38=$ljdata;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 65535);
      var $43=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $37, $42, $43);
      __label__ = 4; break;
    case 4: // $44
      var $45=$offsbits;
      var $46=((16-$45)|0);
      $offsbits=$46;
      var $47=$ljmask;
      var $48=(($47)&65535);
      var $49=$offsbits;
      var $50=$48 << $49;
      var $51=(($50) & 65535);
      $curmask=$51;
      var $52=$curmask;
      var $53=(($52)&65535);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$2;
      var $57=(($56+2)|0);
      var $58=$ljdata;
      var $59=(($58)&65535);
      var $60=$offsbits;
      var $61=$59 << $60;
      var $62=(($61) & 65535);
      var $63=$curmask;
      __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $57, $62, $63);
      __label__ = 6; break;
    case 6: // $64
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & -2;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjt($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP16[(($27)>>1)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 1;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$offsbits;
  var $10=((8-$9)|0);
  $offsbits=$10;
  var $11=$2;
  var $12=$11 & -2;
  var $13=$3;
  var $14=(($13)&255);
  var $15=(($14)&65535);
  var $16=$offsbits;
  var $17=$15 << $16;
  var $18=(($17) & 65535);
  var $19=$4;
  var $20=(($19)&255);
  var $21=(($20)&65535);
  var $22=$offsbits;
  var $23=$21 << $22;
  var $24=(($23) & 65535);
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt($5, $12, $18, $24);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&65535;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$curmask;
      var $24=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $22, $23);
      var $25$0=$24;
      var $25$1=0;
      var $26=$offsbits;
      var $27$0=$26;
      var $27$1=0;
      var $28=Runtime.bitshift64($25$0, $25$1,"shl",$27$0);var $28$0 = $28[0], $28$1 = $28[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$28$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$28$1;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-16)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+2)|0);
      $2=$37;
      var $st$6$0=(($3)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&65535;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&65535);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $47, $48);
      var $50$0=$49;
      var $50$1=0;
      var $51=$offsbits;
      var $52$0=$51;
      var $52$1=0;
      var $53=Runtime.bitshift64($50$0, $50$1,"shl",$52$0);var $53$0 = $53[0], $53$1 = $53[1];
      var $st$9$0=(($result)|0);
      var $54$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $54$1=HEAP32[(($st$9$1)>>2)];
      var $55$0=$54$0 | $53$0;
      var $55$1=$54$1 | $53$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$55$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$55$1;
      __label__ = 6; break;
    case 6: // $56
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $61=$offsbits;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $63
      var $64=$offsbits;
      var $65=((16-$64)|0);
      $offsbits=$65;
      var $st$3$0=(($3)|0);
      var $66$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $66$1=HEAP32[(($st$3$1)>>2)];
      var $67=$offsbits;
      var $68$0=$67;
      var $68$1=0;
      var $69=Runtime.bitshift64($66$0, $66$1,"shl",$68$0);var $69$0 = $69[0], $69$1 = $69[1];
      var $70$0=$69$0;
      var $70=$70$0&65535;
      $curmask=$70;
      var $71=$curmask;
      var $72=(($71)&65535);
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $74
      var $75=$2;
      var $76=(($75+2)|0);
      var $77=$curmask;
      var $78=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $76, $77);
      var $79=(($78)&65535);
      var $80=$offsbits;
      var $81=$79 >> (($80)|0);
      var $82$0=$81;
      var $82$1=(($81|0) < 0 ? -1 : 0);
      var $st$9$0=(($result)|0);
      var $83$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$9$1)>>2)];
      var $84$0=$83$0 | $82$0;
      var $84$1=$83$1 | $82$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$84$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$84$1;
      __label__ = 11; break;
    case 11: // $85
      __label__ = 12; break;
    case 12: // $86
      var $st$0$0=(($result)|0);
      var $87$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $87$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$87$0,$87$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP16[(($26)>>1)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read16ER13address_spacejt($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t1ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$37$0=(($3)|0);
      var $13$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$37$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&65535;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&65535);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$curmask;
      var $24=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $22, $23);
      var $25$0=$24;
      var $25$1=0;
      var $26=$offsbits;
      var $27$0=$26;
      var $27$1=0;
      var $28=Runtime.bitshift64($25$0, $25$1,"shl",$27$0);var $28$0 = $28[0], $28$1 = $28[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$28$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$28$1;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-16)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+2)|0);
      $2=$37;
      var $st$6$0=(($3)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&65535;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&65535);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $47, $48);
      var $50$0=$49;
      var $50$1=0;
      var $51=$offsbits;
      var $52$0=$51;
      var $52$1=0;
      var $53=Runtime.bitshift64($50$0, $50$1,"shl",$52$0);var $53$0 = $53[0], $53$1 = $53[1];
      var $st$9$0=(($result)|0);
      var $54$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $54$1=HEAP32[(($st$9$1)>>2)];
      var $55$0=$54$0 | $53$0;
      var $55$1=$54$1 | $53$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$55$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$55$1;
      __label__ = 6; break;
    case 6: // $56
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $st$0$0=(($result)|0);
      var $61$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $61$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$61$0,$61$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$3;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 65535);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&65535);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $21, $22);
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 << $25;
      $result=$26;
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-16)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $36=$3;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 65535);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $44, $45);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=$50 | $49;
      $result=$51;
      __label__ = 6; break;
    case 6: // $52
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$offsbits;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $59
      var $60=$offsbits;
      var $61=((16-$60)|0);
      $offsbits=$61;
      var $62=$3;
      var $63=$offsbits;
      var $64=$62 << $63;
      var $65=(($64) & 65535);
      $curmask=$65;
      var $66=$curmask;
      var $67=(($66)&65535);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $69
      var $70=$2;
      var $71=(($70+2)|0);
      var $72=$curmask;
      var $73=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $71, $72);
      var $74=(($73)&65535);
      var $75=$offsbits;
      var $76=$74 >> (($75)|0);
      var $77=$result;
      var $78=$77 | $76;
      $result=$78;
      __label__ = 11; break;
    case 11: // $79
      __label__ = 12; break;
    case 12: // $80
      var $81=$result;
      ;
      return $81;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$offsbits;
      var $11=((16-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$3;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 65535);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&65535);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $21, $22);
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 << $25;
      $result=$26;
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-16)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $36=$3;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 65535);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $44, $45);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=$50 | $49;
      $result=$51;
      __label__ = 6; break;
    case 6: // $52
      __label__ = 7; break;
    case 7: // $53
      var $54=$index;
      var $55=(($54+1)|0);
      $index=$55;
      __label__ = 3; break;
    case 8: // $56
      var $57=$result;
      ;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT;
      var $result;
      var $ljmask;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -2;
      var $12=$4;
      var $13=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -2;
      $3=$19;
      $LEFT_JUSTIFY_TARGET_TO_NATIVE_SHIFT=0;
      $result=0;
      var $20=$4;
      var $21=(($20)&65535);
      var $22=$21 << 0;
      var $23=(($22) & 65535);
      $ljmask=$23;
      var $24=$ljmask;
      var $25=(($24)&65535);
      var $26=$offsbits;
      var $27=$25 >> (($26)|0);
      var $28=(($27) & 65535);
      $curmask=$28;
      var $29=$curmask;
      var $30=(($29)&65535);
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $32
      var $33=$3;
      var $34=$curmask;
      var $35=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($5, $33, $34);
      var $36=(($35)&65535);
      var $37=$offsbits;
      var $38=$36 << $37;
      var $39=(($38) & 65535);
      $result=$39;
      __label__ = 4; break;
    case 4: // $40
      var $41=$offsbits;
      var $42=((16-$41)|0);
      $offsbits=$42;
      var $43=$ljmask;
      var $44=(($43)&65535);
      var $45=$offsbits;
      var $46=$44 << $45;
      var $47=(($46) & 65535);
      $curmask=$47;
      var $48=$curmask;
      var $49=(($48)&65535);
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$3;
      var $53=(($52+2)|0);
      var $54=$curmask;
      var $55=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($5, $53, $54);
      var $56=(($55)&65535);
      var $57=$offsbits;
      var $58=$56 >> (($57)|0);
      var $59=$result;
      var $60=(($59)&65535);
      var $61=$60 | $58;
      var $62=(($61) & 65535);
      $result=$62;
      __label__ = 6; break;
    case 6: // $63
      var $64=$result;
      var $65=(($64)&65535);
      var $66=$65 >> 0;
      var $67=(($66) & 65535);
      $1=$67;
      __label__ = 7; break;
    case 7: // $68
      var $69=$1;
      ;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  var $8=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificItL12endianness_t1ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP16[(($25)>>1)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 1;
      var $32=__ZNK18handler_entry_read6read16ER13address_spacejt($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 1;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$offsbits;
  var $9=((8-$8)|0);
  $offsbits=$9;
  var $10=$2;
  var $11=$10 & -2;
  var $12=$3;
  var $13=(($12)&255);
  var $14=(($13)&65535);
  var $15=$offsbits;
  var $16=$14 << $15;
  var $17=(($16) & 65535);
  var $18=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt($4, $11, $17);
  var $19=(($18)&65535);
  var $20=$offsbits;
  var $21=$19 >> (($20)|0);
  var $22=(($21) & 255);
  ;
  return $22;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t1ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificItL12endianness_t1ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED0Ev["X"]=1;

function __ZNK22address_space_specificItL12endianness_t0ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=662;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=664;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=666;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=668;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=670;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=672;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=674;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=676;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=678;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=680;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=682;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=684;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=686;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=688;
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificItL12endianness_t0ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0&65535;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&65535);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $st$1$0=(($3)|0);
      var $21$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $21$1=HEAP32[(($st$1$1)>>2)];
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      var $25$0=$24$0;
      var $25=$25$0&65535;
      var $26=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $20, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      var $28=$offsbits;
      var $29=((16-$28)|0);
      $offsbits=$29;
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $40$0=$39$0;
      var $40=$40$0&65535;
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $st$1$0=(($3)|0);
      var $46$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $46$1=HEAP32[(($st$1$1)>>2)];
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"lshr",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $50$0=$49$0;
      var $50=$50$0&65535;
      var $51=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $45, $50, $51);
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+16)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)>>>0) < 64;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $st$0$0=(($4)|0);
      var $62$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $62$1=HEAP32[(($st$0$1)>>2)];
      var $63=$offsbits;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $66$0=$65$0;
      var $66=$66$0&65535;
      $curmask=$66;
      var $67=$curmask;
      var $68=(($67)&65535);
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$2;
      var $72=(($71+2)|0);
      var $st$2$0=(($3)|0);
      var $73$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $73$1=HEAP32[(($st$2$1)>>2)];
      var $74=$offsbits;
      var $75$0=$74;
      var $75$1=0;
      var $76=Runtime.bitshift64($73$0, $73$1,"lshr",$75$0);var $76$0 = $76[0], $76$1 = $76[1];
      var $77$0=$76$0;
      var $77=$77$0&65535;
      var $78=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $72, $77, $78);
      __label__ = 11; break;
    case 11: // $79
      __label__ = 12; break;
    case 12: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificItL12endianness_t0ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$4;
      var $32=(($31)&65535);
      var $33=$32 ^ -1;
      var $34=$30 & $33;
      var $35=$3;
      var $36=(($35)&65535);
      var $37=$4;
      var $38=(($37)&65535);
      var $39=$36 & $38;
      var $40=$34 | $39;
      var $41=(($40) & 65535);
      var $42=$dest;
      HEAP16[(($42)>>1)]=$41;
      __label__ = 3; break;
    case 2: // $43
      var $44=$handler;
      var $45=$5;
      var $46=$2;
      var $47=$46 >>> 1;
      var $48=$3;
      var $49=$4;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($44, $45, $47, $48, $49);
      __label__ = 3; break;
    case 3: // $50
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t0ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificItL12endianness_t0ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t0ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0&65535;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&65535);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $st$1$0=(($3)|0);
      var $21$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $21$1=HEAP32[(($st$1$1)>>2)];
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      var $25$0=$24$0;
      var $25=$25$0&65535;
      var $26=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $20, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      var $28=$offsbits;
      var $29=((16-$28)|0);
      $offsbits=$29;
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $40$0=$39$0;
      var $40=$40$0&65535;
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $st$1$0=(($3)|0);
      var $46$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $46$1=HEAP32[(($st$1$1)>>2)];
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"lshr",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $50$0=$49$0;
      var $50=$50$0&65535;
      var $51=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $45, $50, $51);
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+16)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$4;
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 65535);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=$offsbits;
      var $22=$20 << $21;
      var $23=(($22) & 65535);
      var $24=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $19, $23, $24);
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((16-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+2)|0);
      $2=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      var $37=(($36) & 65535);
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)&65535);
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$2;
      var $43=$3;
      var $44=$offsbits;
      var $45=$43 >>> (($44)>>>0);
      var $46=(($45) & 65535);
      var $47=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $42, $46, $47);
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+16)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$offsbits;
      var $56=(($55)>>>0) < 32;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$4;
      var $59=$offsbits;
      var $60=$58 >>> (($59)>>>0);
      var $61=(($60) & 65535);
      $curmask=$61;
      var $62=$curmask;
      var $63=(($62)&65535);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $65
      var $66=$2;
      var $67=(($66+2)|0);
      var $68=$3;
      var $69=$offsbits;
      var $70=$68 >>> (($69)>>>0);
      var $71=(($70) & 65535);
      var $72=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $67, $71, $72);
      __label__ = 11; break;
    case 11: // $73
      __label__ = 12; break;
    case 12: // $74
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$4;
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 65535);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=$offsbits;
      var $22=$20 << $21;
      var $23=(($22) & 65535);
      var $24=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $19, $23, $24);
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((16-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+2)|0);
      $2=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      var $37=(($36) & 65535);
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)&65535);
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$2;
      var $43=$3;
      var $44=$offsbits;
      var $45=$43 >>> (($44)>>>0);
      var $46=(($45) & 65535);
      var $47=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $42, $46, $47);
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+16)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -2;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -2;
      $2=$19;
      var $20=$4;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 65535);
      $curmask=$24;
      var $25=$curmask;
      var $26=(($25)&65535);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$2;
      var $30=$3;
      var $31=(($30)&65535);
      var $32=$offsbits;
      var $33=$31 << $32;
      var $34=(($33) & 65535);
      var $35=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $29, $34, $35);
      __label__ = 4; break;
    case 4: // $36
      var $37=$offsbits;
      var $38=((16-$37)|0);
      $offsbits=$38;
      var $39=$4;
      var $40=(($39)&65535);
      var $41=$offsbits;
      var $42=$40 >> (($41)|0);
      var $43=(($42) & 65535);
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$2;
      var $49=(($48+2)|0);
      var $50=$3;
      var $51=(($50)&65535);
      var $52=$offsbits;
      var $53=$51 >> (($52)|0);
      var $54=(($53) & 65535);
      var $55=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $49, $54, $55);
      __label__ = 6; break;
    case 6: // $56
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & -2;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjt($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP16[(($27)>>1)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 1;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -2;
  var $11=$3;
  var $12=(($11)&255);
  var $13=(($12)&65535);
  var $14=$offsbits;
  var $15=$13 << $14;
  var $16=(($15) & 65535);
  var $17=$4;
  var $18=(($17)&255);
  var $19=(($18)&65535);
  var $20=$offsbits;
  var $21=$19 << $20;
  var $22=(($21) & 65535);
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt($5, $10, $16, $22);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&65535;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$curmask;
      var $21=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $19, $20);
      var $22=(($21)&65535);
      var $23=$offsbits;
      var $24=$22 >> (($23)|0);
      var $25$0=$24;
      var $25$1=(($24|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$25$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$25$1;
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((16-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 3;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+2)|0);
      $2=$34;
      var $st$3$0=(($3)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&65535;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $44, $45);
      var $47$0=$46;
      var $47$1=0;
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"shl",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($result)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      var $52$0=$51$0 | $50$0;
      var $52$1=$51$1 | $50$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$52$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$52$1;
      __label__ = 6; break;
    case 6: // $53
      var $54=$offsbits;
      var $55=(($54+16)|0);
      $offsbits=$55;
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $60=$offsbits;
      var $61=(($60)>>>0) < 64;
      if ($61) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $62
      var $st$0$0=(($3)|0);
      var $63$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $63$1=HEAP32[(($st$0$1)>>2)];
      var $64=$offsbits;
      var $65$0=$64;
      var $65$1=0;
      var $66=Runtime.bitshift64($63$0, $63$1,"lshr",$65$0);var $66$0 = $66[0], $66$1 = $66[1];
      var $67$0=$66$0;
      var $67=$67$0&65535;
      $curmask=$67;
      var $68=$curmask;
      var $69=(($68)&65535);
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $71
      var $72=$2;
      var $73=(($72+2)|0);
      var $74=$curmask;
      var $75=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $73, $74);
      var $76$0=$75;
      var $76$1=0;
      var $77=$offsbits;
      var $78$0=$77;
      var $78$1=0;
      var $79=Runtime.bitshift64($76$0, $76$1,"shl",$78$0);var $79$0 = $79[0], $79$1 = $79[1];
      var $st$10$0=(($result)|0);
      var $80$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $80$1=HEAP32[(($st$10$1)>>2)];
      var $81$0=$80$0 | $79$0;
      var $81$1=$80$1 | $79$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$81$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$81$1;
      __label__ = 11; break;
    case 11: // $82
      __label__ = 12; break;
    case 12: // $83
      var $st$0$0=(($result)|0);
      var $84$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $84$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$84$0,$84$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP16[(($26)>>1)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read16ER13address_spacejt($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t0ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&65535;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$curmask;
      var $21=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $19, $20);
      var $22=(($21)&65535);
      var $23=$offsbits;
      var $24=$22 >> (($23)|0);
      var $25$0=$24;
      var $25$1=(($24|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$25$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$25$1;
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((16-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 3;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+2)|0);
      $2=$34;
      var $st$3$0=(($3)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&65535;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $44, $45);
      var $47$0=$46;
      var $47$1=0;
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"shl",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($result)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      var $52$0=$51$0 | $50$0;
      var $52$1=$51$1 | $50$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$52$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$52$1;
      __label__ = 6; break;
    case 6: // $53
      var $54=$offsbits;
      var $55=(($54+16)|0);
      $offsbits=$55;
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $st$0$0=(($result)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$60$0,$60$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$3;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 65535);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&65535);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $18, $19);
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      $result=$23;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((16-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      $2=$32;
      var $33=$3;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 65535);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&65535);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $41, $42);
      var $44=(($43)&65535);
      var $45=$offsbits;
      var $46=$44 << $45;
      var $47=$result;
      var $48=$47 | $46;
      $result=$48;
      __label__ = 6; break;
    case 6: // $49
      var $50=$offsbits;
      var $51=(($50+16)|0);
      $offsbits=$51;
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$offsbits;
      var $57=(($56)>>>0) < 32;
      if ($57) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=$3;
      var $60=$offsbits;
      var $61=$59 >>> (($60)>>>0);
      var $62=(($61) & 65535);
      $curmask=$62;
      var $63=$curmask;
      var $64=(($63)&65535);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $66
      var $67=$2;
      var $68=(($67+2)|0);
      var $69=$curmask;
      var $70=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $68, $69);
      var $71=(($70)&65535);
      var $72=$offsbits;
      var $73=$71 << $72;
      var $74=$result;
      var $75=$74 | $73;
      $result=$75;
      __label__ = 11; break;
    case 11: // $76
      __label__ = 12; break;
    case 12: // $77
      var $78=$result;
      ;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$3;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 65535);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&65535);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $18, $19);
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      $result=$23;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((16-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      $2=$32;
      var $33=$3;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 65535);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&65535);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $41, $42);
      var $44=(($43)&65535);
      var $45=$offsbits;
      var $46=$44 << $45;
      var $47=$result;
      var $48=$47 | $46;
      $result=$48;
      __label__ = 6; break;
    case 6: // $49
      var $50=$offsbits;
      var $51=(($50+16)|0);
      $offsbits=$51;
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$result;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $result;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -2;
      var $12=$4;
      var $13=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -2;
      $3=$19;
      $result=0;
      var $20=$4;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 65535);
      $curmask=$24;
      var $25=$curmask;
      var $26=(($25)&65535);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$3;
      var $30=$curmask;
      var $31=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($5, $29, $30);
      var $32=(($31)&65535);
      var $33=$offsbits;
      var $34=$32 >> (($33)|0);
      var $35=(($34) & 65535);
      $result=$35;
      __label__ = 4; break;
    case 4: // $36
      var $37=$offsbits;
      var $38=((16-$37)|0);
      $offsbits=$38;
      var $39=$4;
      var $40=(($39)&65535);
      var $41=$offsbits;
      var $42=$40 >> (($41)|0);
      var $43=(($42) & 65535);
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$3;
      var $49=(($48+2)|0);
      var $50=$curmask;
      var $51=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($5, $49, $50);
      var $52=(($51)&65535);
      var $53=$offsbits;
      var $54=$52 << $53;
      var $55=$result;
      var $56=(($55)&65535);
      var $57=$56 | $54;
      var $58=(($57) & 65535);
      $result=$58;
      __label__ = 6; break;
    case 6: // $59
      var $60=$result;
      $1=$60;
      __label__ = 7; break;
    case 7: // $61
      var $62=$1;
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  var $8=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $6, $7);
  ;
  return $8;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificItL12endianness_t0ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP16[(($25)>>1)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 1;
      var $32=__ZNK18handler_entry_read6read16ER13address_spacejt($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 1;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -2;
  var $10=$3;
  var $11=(($10)&255);
  var $12=(($11)&65535);
  var $13=$offsbits;
  var $14=$12 << $13;
  var $15=(($14) & 65535);
  var $16=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt($4, $9, $15);
  var $17=(($16)&65535);
  var $18=$offsbits;
  var $19=$17 >> (($18)|0);
  var $20=(($19) & 255);
  ;
  return $20;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificItL12endianness_t0ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificItL12endianness_t0ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificItL12endianness_t0ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificItL12endianness_t0ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EED0Ev["X"]=1;

function __ZNK22address_space_specificItL12endianness_t0ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=690;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=692;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=694;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=696;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=698;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=700;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=702;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=704;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=706;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=708;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=710;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=712;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=714;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=716;
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0&65535;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&65535);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $st$1$0=(($3)|0);
      var $21$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $21$1=HEAP32[(($st$1$1)>>2)];
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      var $25$0=$24$0;
      var $25=$25$0&65535;
      var $26=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $20, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      var $28=$offsbits;
      var $29=((16-$28)|0);
      $offsbits=$29;
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $40$0=$39$0;
      var $40=$40$0&65535;
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $st$1$0=(($3)|0);
      var $46$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $46$1=HEAP32[(($st$1$1)>>2)];
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"lshr",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $50$0=$49$0;
      var $50=$50$0&65535;
      var $51=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $45, $50, $51);
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+16)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)>>>0) < 64;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $st$0$0=(($4)|0);
      var $62$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $62$1=HEAP32[(($st$0$1)>>2)];
      var $63=$offsbits;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $66$0=$65$0;
      var $66=$66$0&65535;
      $curmask=$66;
      var $67=$curmask;
      var $68=(($67)&65535);
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$2;
      var $72=(($71+2)|0);
      var $st$2$0=(($3)|0);
      var $73$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $73$1=HEAP32[(($st$2$1)>>2)];
      var $74=$offsbits;
      var $75$0=$74;
      var $75$1=0;
      var $76=Runtime.bitshift64($73$0, $73$1,"lshr",$75$0);var $76$0 = $76[0], $76$1 = $76[1];
      var $77$0=$76$0;
      var $77=$77$0&65535;
      var $78=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $72, $77, $78);
      __label__ = 11; break;
    case 11: // $79
      __label__ = 12; break;
    case 12: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificItL12endianness_t0ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      $dest=$27;
      var $28=$dest;
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$4;
      var $32=(($31)&65535);
      var $33=$32 ^ -1;
      var $34=$30 & $33;
      var $35=$3;
      var $36=(($35)&65535);
      var $37=$4;
      var $38=(($37)&65535);
      var $39=$36 & $38;
      var $40=$34 | $39;
      var $41=(($40) & 65535);
      var $42=$dest;
      HEAP16[(($42)>>1)]=$41;
      __label__ = 3; break;
    case 2: // $43
      var $44=$handler;
      var $45=$5;
      var $46=$2;
      var $47=$46 >>> 1;
      var $48=$3;
      var $49=$4;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($44, $45, $47, $48, $49);
      __label__ = 3; break;
    case 3: // $50
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t0ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=3;
      var $st$31$0=(($4)|0);
      var $11$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($4+4)|0);
      var $11$1=HEAP32[(($st$31$1)>>2)];
      var $12=$offsbits;
      var $13$0=$12;
      var $13$1=0;
      var $14=Runtime.bitshift64($11$0, $11$1,"shl",$13$0);var $14$0 = $14[0], $14$1 = $14[1];
      var $15$0=$14$0;
      var $15=$15$0&65535;
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&65535);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $st$1$0=(($3)|0);
      var $21$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $21$1=HEAP32[(($st$1$1)>>2)];
      var $22=$offsbits;
      var $23$0=$22;
      var $23$1=0;
      var $24=Runtime.bitshift64($21$0, $21$1,"shl",$23$0);var $24$0 = $24[0], $24$1 = $24[1];
      var $25$0=$24$0;
      var $25=$25$0&65535;
      var $26=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $20, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      var $28=$offsbits;
      var $29=((16-$28)|0);
      $offsbits=$29;
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 3;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$2;
      var $35=(($34+2)|0);
      $2=$35;
      var $st$3$0=(($4)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37=$offsbits;
      var $38$0=$37;
      var $38$1=0;
      var $39=Runtime.bitshift64($36$0, $36$1,"lshr",$38$0);var $39$0 = $39[0], $39$1 = $39[1];
      var $40$0=$39$0;
      var $40=$40$0&65535;
      $curmask=$40;
      var $41=$curmask;
      var $42=(($41)&65535);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=$2;
      var $st$1$0=(($3)|0);
      var $46$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $46$1=HEAP32[(($st$1$1)>>2)];
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"lshr",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $50$0=$49$0;
      var $50=$50$0&65535;
      var $51=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $45, $50, $51);
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+16)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$4;
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 65535);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=$offsbits;
      var $22=$20 << $21;
      var $23=(($22) & 65535);
      var $24=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $19, $23, $24);
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((16-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+2)|0);
      $2=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      var $37=(($36) & 65535);
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)&65535);
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$2;
      var $43=$3;
      var $44=$offsbits;
      var $45=$43 >>> (($44)>>>0);
      var $46=(($45) & 65535);
      var $47=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $42, $46, $47);
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+16)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$offsbits;
      var $56=(($55)>>>0) < 32;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$4;
      var $59=$offsbits;
      var $60=$58 >>> (($59)>>>0);
      var $61=(($60) & 65535);
      $curmask=$61;
      var $62=$curmask;
      var $63=(($62)&65535);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $65
      var $66=$2;
      var $67=(($66+2)|0);
      var $68=$3;
      var $69=$offsbits;
      var $70=$68 >>> (($69)>>>0);
      var $71=(($70) & 65535);
      var $72=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $67, $71, $72);
      __label__ = 11; break;
    case 11: // $73
      __label__ = 12; break;
    case 12: // $74
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 1;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      var $10=$9 & -2;
      $2=$10;
      $MAX_SPLITS_MINUS_ONE=1;
      var $11=$4;
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 65535);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=$offsbits;
      var $22=$20 << $21;
      var $23=(($22) & 65535);
      var $24=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $19, $23, $24);
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((16-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+2)|0);
      $2=$33;
      var $34=$4;
      var $35=$offsbits;
      var $36=$34 >>> (($35)>>>0);
      var $37=(($36) & 65535);
      $curmask=$37;
      var $38=$curmask;
      var $39=(($38)&65535);
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$2;
      var $43=$3;
      var $44=$offsbits;
      var $45=$43 >>> (($44)>>>0);
      var $46=(($45) & 65535);
      var $47=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $42, $46, $47);
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+16)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $curmask;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$10 & -2;
      var $12=$3;
      var $13=$4;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $11, $12, $13);
      __label__ = 6; break;
    case 2: // $14
      var $15=$2;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$2;
      var $19=$18 & -2;
      $2=$19;
      var $20=$4;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 65535);
      $curmask=$24;
      var $25=$curmask;
      var $26=(($25)&65535);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$2;
      var $30=$3;
      var $31=(($30)&65535);
      var $32=$offsbits;
      var $33=$31 << $32;
      var $34=(($33) & 65535);
      var $35=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $29, $34, $35);
      __label__ = 4; break;
    case 4: // $36
      var $37=$offsbits;
      var $38=((16-$37)|0);
      $offsbits=$38;
      var $39=$4;
      var $40=(($39)&65535);
      var $41=$offsbits;
      var $42=$40 >> (($41)|0);
      var $43=(($42) & 65535);
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$2;
      var $49=(($48+2)|0);
      var $50=$3;
      var $51=(($50)&65535);
      var $52=$offsbits;
      var $53=$51 >> (($52)|0);
      var $54=(($53) & 65535);
      var $55=$curmask;
      __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $49, $54, $55);
      __label__ = 6; break;
    case 6: // $56
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $6=$2;
  var $7=$6 & -2;
  var $8=$3;
  var $9=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $7, $8, $9);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjt($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      var $27=$26;
      HEAP16[(($27)>>1)]=$22;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      __ZNK19handler_entry_write7write16ER13address_spacejtt($29, $30, $32, $33, -1);
      __label__ = 3; break;
    case 3: // $34
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $6=$2;
  var $7=$6 & 1;
  var $8=((($7<<3))|0);
  $offsbits=$8;
  var $9=$2;
  var $10=$9 & -2;
  var $11=$3;
  var $12=(($11)&255);
  var $13=(($12)&65535);
  var $14=$offsbits;
  var $15=$13 << $14;
  var $16=(($15) & 65535);
  var $17=$4;
  var $18=(($17)&255);
  var $19=(($18)&65535);
  var $20=$offsbits;
  var $21=$19 << $20;
  var $22=(($21) & 65535);
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt($5, $10, $16, $22);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&65535;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$curmask;
      var $21=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $19, $20);
      var $22=(($21)&65535);
      var $23=$offsbits;
      var $24=$22 >> (($23)|0);
      var $25$0=$24;
      var $25$1=(($24|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$25$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$25$1;
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((16-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 3;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+2)|0);
      $2=$34;
      var $st$3$0=(($3)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&65535;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $44, $45);
      var $47$0=$46;
      var $47$1=0;
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"shl",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($result)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      var $52$0=$51$0 | $50$0;
      var $52$1=$51$1 | $50$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$52$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$52$1;
      __label__ = 6; break;
    case 6: // $53
      var $54=$offsbits;
      var $55=(($54+16)|0);
      $offsbits=$55;
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $60=$offsbits;
      var $61=(($60)>>>0) < 64;
      if ($61) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $62
      var $st$0$0=(($3)|0);
      var $63$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $63$1=HEAP32[(($st$0$1)>>2)];
      var $64=$offsbits;
      var $65$0=$64;
      var $65$1=0;
      var $66=Runtime.bitshift64($63$0, $63$1,"lshr",$65$0);var $66$0 = $66[0], $66$1 = $66[1];
      var $67$0=$66$0;
      var $67=$67$0&65535;
      $curmask=$67;
      var $68=$curmask;
      var $69=(($68)&65535);
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $71
      var $72=$2;
      var $73=(($72+2)|0);
      var $74=$curmask;
      var $75=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $73, $74);
      var $76$0=$75;
      var $76$1=0;
      var $77=$offsbits;
      var $78$0=$77;
      var $78$1=0;
      var $79=Runtime.bitshift64($76$0, $76$1,"shl",$78$0);var $79$0 = $79[0], $79$1 = $79[1];
      var $st$10$0=(($result)|0);
      var $80$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $80$1=HEAP32[(($st$10$1)>>2)];
      var $81$0=$80$0 | $79$0;
      var $81$1=$80$1 | $79$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$81$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$81$1;
      __label__ = 11; break;
    case 11: // $82
      __label__ = 12; break;
    case 12: // $83
      var $st$0$0=(($result)|0);
      var $84$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $84$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$84$0,$84$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificItL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=$25;
      var $27=HEAP16[(($26)>>1)];
      $result=$27;
      __label__ = 3; break;
    case 2: // $28
      var $29=$handler;
      var $30=$4;
      var $31=$2;
      var $32=$31 >>> 1;
      var $33=$3;
      var $34=__ZNK18handler_entry_read6read16ER13address_spacejt($29, $30, $32, $33);
      $result=$34;
      __label__ = 3; break;
    case 3: // $35
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt["X"]=1;

function __ZNK22address_space_specificItL12endianness_t0ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $st$33$0=(($3)|0);
      var $10$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$33$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&65535;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&65535);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$curmask;
      var $21=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $19, $20);
      var $22=(($21)&65535);
      var $23=$offsbits;
      var $24=$22 >> (($23)|0);
      var $25$0=$24;
      var $25$1=(($24|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$25$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$25$1;
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((16-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 3;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+2)|0);
      $2=$34;
      var $st$3$0=(($3)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&65535;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&65535);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$curmask;
      var $46=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $44, $45);
      var $47$0=$46;
      var $47$1=0;
      var $48=$offsbits;
      var $49$0=$48;
      var $49$1=0;
      var $50=Runtime.bitshift64($47$0, $47$1,"shl",$49$0);var $50$0 = $50[0], $50$1 = $50[1];
      var $st$9$0=(($result)|0);
      var $51$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $51$1=HEAP32[(($st$9$1)>>2)];
      var $52$0=$51$0 | $50$0;
      var $52$1=$51$1 | $50$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$52$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$52$1;
      __label__ = 6; break;
    case 6: // $53
      var $54=$offsbits;
      var $55=(($54+16)|0);
      $offsbits=$55;
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $st$0$0=(($result)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$60$0,$60$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$3;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 65535);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&65535);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $18, $19);
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      $result=$23;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((16-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      $2=$32;
      var $33=$3;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 65535);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&65535);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $41, $42);
      var $44=(($43)&65535);
      var $45=$offsbits;
      var $46=$44 << $45;
      var $47=$result;
      var $48=$47 | $46;
      $result=$48;
      __label__ = 6; break;
    case 6: // $49
      var $50=$offsbits;
      var $51=(($50+16)|0);
      $offsbits=$51;
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$offsbits;
      var $57=(($56)>>>0) < 32;
      if ($57) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=$3;
      var $60=$offsbits;
      var $61=$59 >>> (($60)>>>0);
      var $62=(($61) & 65535);
      $curmask=$62;
      var $63=$curmask;
      var $64=(($63)&65535);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $66
      var $67=$2;
      var $68=(($67+2)|0);
      var $69=$curmask;
      var $70=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $68, $69);
      var $71=(($70)&65535);
      var $72=$offsbits;
      var $73=$71 << $72;
      var $74=$result;
      var $75=$74 | $73;
      $result=$75;
      __label__ = 11; break;
    case 11: // $76
      __label__ = 12; break;
    case 12: // $77
      var $78=$result;
      ;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 1;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      var $9=$8 & -2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $10=$3;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 65535);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&65535);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $18, $19);
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      $result=$23;
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((16-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 1;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      $2=$32;
      var $33=$3;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 65535);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&65535);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$curmask;
      var $43=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $41, $42);
      var $44=(($43)&65535);
      var $45=$offsbits;
      var $46=$44 << $45;
      var $47=$result;
      var $48=$47 | $46;
      $result=$48;
      __label__ = 6; break;
    case 6: // $49
      var $50=$offsbits;
      var $51=(($50+16)|0);
      $offsbits=$51;
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$result;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $result;
      var $curmask;
      $2=$this;
      $3=$address;
      $4=$mask;
      var $5=$2;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$3;
      var $7=$6 & 1;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & -2;
      var $12=$4;
      var $13=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($5, $11, $12);
      $1=$13;
      __label__ = 7; break;
    case 2: // $14
      var $15=$3;
      var $16=$15 & 1;
      var $17=((($16<<3))|0);
      $offsbits=$17;
      var $18=$3;
      var $19=$18 & -2;
      $3=$19;
      $result=0;
      var $20=$4;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 65535);
      $curmask=$24;
      var $25=$curmask;
      var $26=(($25)&65535);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      var $29=$3;
      var $30=$curmask;
      var $31=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($5, $29, $30);
      var $32=(($31)&65535);
      var $33=$offsbits;
      var $34=$32 >> (($33)|0);
      var $35=(($34) & 65535);
      $result=$35;
      __label__ = 4; break;
    case 4: // $36
      var $37=$offsbits;
      var $38=((16-$37)|0);
      $offsbits=$38;
      var $39=$4;
      var $40=(($39)&65535);
      var $41=$offsbits;
      var $42=$40 >> (($41)|0);
      var $43=(($42) & 65535);
      $curmask=$43;
      var $44=$curmask;
      var $45=(($44)&65535);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $47
      var $48=$3;
      var $49=(($48+2)|0);
      var $50=$curmask;
      var $51=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($5, $49, $50);
      var $52=(($51)&65535);
      var $53=$offsbits;
      var $54=$52 << $53;
      var $55=$result;
      var $56=(($55)&65535);
      var $57=$56 | $54;
      var $58=(($57) & 65535);
      $result=$58;
      __label__ = 6; break;
    case 6: // $59
      var $60=$result;
      $1=$60;
      __label__ = 7; break;
    case 7: // $61
      var $62=$1;
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=2;
  $TARGET_BITS=16;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  var $8=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $6, $7);
  ;
  return $8;
}


function __ZNK22address_space_specificIhL12endianness_t1ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=718;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=720;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=722;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=724;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=726;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=728;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=730;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=732;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=734;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=736;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=738;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=740;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=742;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=744;
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificItL12endianness_t0ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=$24;
      var $26=HEAP16[(($25)>>1)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$3;
      var $30=$2;
      var $31=$30 >>> 1;
      var $32=__ZNK18handler_entry_read6read16ER13address_spacejt($28, $29, $31, -1);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $TARGET_BYTES;
  var $TARGET_BITS;
  var $offsbits;
  var $offsbits1;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  $TARGET_BYTES=1;
  $TARGET_BITS=8;
  var $5=$2;
  var $6=$5 & 1;
  var $7=((($6<<3))|0);
  $offsbits=$7;
  var $8=$2;
  var $9=$8 & -2;
  var $10=$3;
  var $11=(($10)&255);
  var $12=(($11)&65535);
  var $13=$offsbits;
  var $14=$12 << $13;
  var $15=(($14) & 65535);
  var $16=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt($4, $9, $15);
  var $17=(($16)&65535);
  var $18=$offsbits;
  var $19=$17 >> (($18)|0);
  var $20=(($19) & 255);
  ;
  return $20;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&255);
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=$4 & -2;
  var $6=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEj($3, $5);
  ;
  return $6;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$5 & -2;
  var $7=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjt($4, $6, $7);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIhL12endianness_t1ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificItL12endianness_t0ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificItL12endianness_t0ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIhL12endianness_t1ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t1ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$34$0=(($4)|0);
      var $13$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$34$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&255;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0&255;
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 7;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&255;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $st$1$0=(($3)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $52$0=$51$0;
      var $52=$52$0&255;
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $62=$offsbits;
      var $63=((8-$62)|0);
      $offsbits=$63;
      var $st$3$0=(($4)|0);
      var $64$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $64$1=HEAP32[(($st$3$1)>>2)];
      var $65=$offsbits;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $68$0=$67$0;
      var $68=$68$0&255;
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)&255);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      var $st$2$0=(($3)|0);
      var $75$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $75$1=HEAP32[(($st$2$1)>>2)];
      var $76=$offsbits;
      var $77$0=$76;
      var $77$1=0;
      var $78=Runtime.bitshift64($75$0, $75$1,"shl",$77$0);var $78$0 = $78[0], $78$1 = $78[1];
      var $79$0=$78$0;
      var $79=$79$0&255;
      var $80=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $74, $79, $80);
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIhL12endianness_t1ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      $dest=$26;
      var $27=$dest;
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$4;
      var $31=(($30)&255);
      var $32=$31 ^ -1;
      var $33=$29 & $32;
      var $34=$3;
      var $35=(($34)&255);
      var $36=$4;
      var $37=(($36)&255);
      var $38=$35 & $37;
      var $39=$33 | $38;
      var $40=(($39) & 255);
      var $41=$dest;
      HEAP8[($41)]=$40;
      __label__ = 3; break;
    case 2: // $42
      var $43=$handler;
      var $44=$5;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($43, $44, $45, $46, $47);
      __label__ = 3; break;
    case 3: // $48
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t1ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK19handler_entry_write6write8ER13address_spacejhh($this, $space, $offset, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$data;
  $5=$mask;
  var $6=$1;
  var $7=(($6+168)|0);
  var $8=(($7)|0);
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  __ZNK13delegate_baseIvR13address_spacejhhEclES1_jhh($9, $10, $11, $12, $13);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$34$0=(($4)|0);
      var $13$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$34$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&255;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0&255;
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 7;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&255;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $st$1$0=(($3)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $52$0=$51$0;
      var $52=$52$0&255;
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$3;
      var $23=$offsbits;
      var $24=$22 >>> (($23)>>>0);
      var $25=(($24) & 255);
      var $26=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $21, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 3;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-8)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+1)|0);
      $2=$35;
      var $36=$4;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=$offsbits;
      var $47=$45 >>> (($46)>>>0);
      var $48=(($47) & 255);
      var $49=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $44, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$offsbits;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$offsbits;
      var $59=((8-$58)|0);
      $offsbits=$59;
      var $60=$4;
      var $61=$offsbits;
      var $62=$60 << $61;
      var $63=(($62) & 255);
      $curmask=$63;
      var $64=$curmask;
      var $65=(($64)&255);
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=(($68+1)|0);
      var $70=$3;
      var $71=$offsbits;
      var $72=$70 << $71;
      var $73=(($72) & 255);
      var $74=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $69, $73, $74);
      __label__ = 11; break;
    case 11: // $75
      __label__ = 12; break;
    case 12: // $76
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$3;
      var $23=$offsbits;
      var $24=$22 >>> (($23)>>>0);
      var $25=(($24) & 255);
      var $26=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $21, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 3;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-8)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+1)|0);
      $2=$35;
      var $36=$4;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=$offsbits;
      var $47=$45 >>> (($46)>>>0);
      var $48=(($47) & 255);
      var $49=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $44, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((16-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=(($13)&65535);
      var $15=$offsbits;
      var $16=$14 >> (($15)|0);
      var $17=(($16) & 255);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 >> (($25)|0);
      var $27=(($26) & 255);
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$4;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$3;
      var $49=(($48)&65535);
      var $50=$offsbits;
      var $51=$49 >> (($50)|0);
      var $52=(($51) & 255);
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $62=$offsbits;
      var $63=((8-$62)|0);
      $offsbits=$63;
      var $64=$4;
      var $65=(($64)&65535);
      var $66=$offsbits;
      var $67=$65 << $66;
      var $68=(($67) & 255);
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)&255);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      var $75=$3;
      var $76=(($75)&65535);
      var $77=$offsbits;
      var $78=$76 << $77;
      var $79=(($78) & 255);
      var $80=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $74, $79, $80);
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((16-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=(($13)&65535);
      var $15=$offsbits;
      var $16=$14 >> (($15)|0);
      var $17=(($16) & 255);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 >> (($25)|0);
      var $27=(($26) & 255);
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$4;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$3;
      var $49=(($48)&65535);
      var $50=$offsbits;
      var $51=$49 >> (($50)|0);
      var $52=(($51) & 255);
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjh($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      HEAP8[($26)]=$22;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($28, $29, $30, $31, -1);
      __label__ = 3; break;
    case 3: // $32
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((64-$10)|0);
      $offsbits=$11;
      var $st$36$0=(($3)|0);
      var $12$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$36$1)>>2)];
      var $13=$offsbits;
      var $14$0=$13;
      var $14$1=0;
      var $15=Runtime.bitshift64($12$0, $12$1,"lshr",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
      var $16$0=$15$0;
      var $16=$16$0&255;
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-8)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+1)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0&255;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)&255);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $47=$curmask;
      var $48=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $46, $47);
      var $49$0=$48;
      var $49$1=0;
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"shl",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $st$9$0=(($result)|0);
      var $53$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $53$1=HEAP32[(($st$9$1)>>2)];
      var $54$0=$53$0 | $52$0;
      var $54$1=$53$1 | $52$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$54$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$54$1;
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $60=$offsbits;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $62
      var $63=$offsbits;
      var $64=((8-$63)|0);
      $offsbits=$64;
      var $st$3$0=(($3)|0);
      var $65$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $65$1=HEAP32[(($st$3$1)>>2)];
      var $66=$offsbits;
      var $67$0=$66;
      var $67$1=0;
      var $68=Runtime.bitshift64($65$0, $65$1,"shl",$67$0);var $68$0 = $68[0], $68$1 = $68[1];
      var $69$0=$68$0;
      var $69=$69$0&255;
      $curmask=$69;
      var $70=$curmask;
      var $71=(($70)&255);
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$2;
      var $75=(($74+1)|0);
      var $76=$curmask;
      var $77=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $75, $76);
      var $78=(($77)&255);
      var $79=$offsbits;
      var $80=$78 >> (($79)|0);
      var $81$0=$80;
      var $81$1=(($80|0) < 0 ? -1 : 0);
      var $st$9$0=(($result)|0);
      var $82$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $82$1=HEAP32[(($st$9$1)>>2)];
      var $83$0=$82$0 | $81$0;
      var $83$1=$82$1 | $81$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$83$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$83$1;
      __label__ = 11; break;
    case 11: // $84
      __label__ = 12; break;
    case 12: // $85
      var $st$0$0=(($result)|0);
      var $86$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $86$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$86$0,$86$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=HEAP8[($25)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      var $32=__ZNK18handler_entry_read5read8ER13address_spacejh($28, $29, $30, $31);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t1ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZNK18handler_entry_read5read8ER13address_spacejh($this, $space, $offset, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$space;
  $3=$offset;
  $4=$mask;
  var $5=$1;
  var $6=(($5+168)|0);
  var $7=(($6)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZNK13delegate_baseIhR13address_spacejh8_noparamEclES1_jh($8, $9, $10, $11);
  ;
  return $12;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((64-$10)|0);
      $offsbits=$11;
      var $st$36$0=(($3)|0);
      var $12$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$36$1)>>2)];
      var $13=$offsbits;
      var $14$0=$13;
      var $14$1=0;
      var $15=Runtime.bitshift64($12$0, $12$1,"lshr",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
      var $16$0=$15$0;
      var $16=$16$0&255;
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-8)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+1)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0&255;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)&255);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $47=$curmask;
      var $48=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $46, $47);
      var $49$0=$48;
      var $49$1=0;
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"shl",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $st$9$0=(($result)|0);
      var $53$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $53$1=HEAP32[(($st$9$1)>>2)];
      var $54$0=$53$0 | $52$0;
      var $54$1=$53$1 | $52$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$54$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$54$1;
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $st$0$0=(($result)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$60$0,$60$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((32-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=$offsbits;
      var $14=$12 >>> (($13)>>>0);
      var $15=(($14) & 255);
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&255);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=$curmask;
      var $22=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $20, $21);
      var $23=(($22)&255);
      var $24=$offsbits;
      var $25=$23 << $24;
      $result=$25;
      __label__ = 2; break;
    case 2: // $26
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$offsbits;
      var $32=(($31-8)|0);
      $offsbits=$32;
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$3;
      var $36=$offsbits;
      var $37=$35 >>> (($36)>>>0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=$offsbits;
      var $48=$46 << $47;
      var $49=$result;
      var $50=$49 | $48;
      $result=$50;
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$offsbits;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=$offsbits;
      var $60=((8-$59)|0);
      $offsbits=$60;
      var $61=$3;
      var $62=$offsbits;
      var $63=$61 << $62;
      var $64=(($63) & 255);
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)&255);
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $68
      var $69=$2;
      var $70=(($69+1)|0);
      var $71=$curmask;
      var $72=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $70, $71);
      var $73=(($72)&255);
      var $74=$offsbits;
      var $75=$73 >> (($74)|0);
      var $76=$result;
      var $77=$76 | $75;
      $result=$77;
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      var $80=$result;
      ;
      return $80;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((32-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=$offsbits;
      var $14=$12 >>> (($13)>>>0);
      var $15=(($14) & 255);
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&255);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=$curmask;
      var $22=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $20, $21);
      var $23=(($22)&255);
      var $24=$offsbits;
      var $25=$23 << $24;
      $result=$25;
      __label__ = 2; break;
    case 2: // $26
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$offsbits;
      var $32=(($31-8)|0);
      $offsbits=$32;
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$3;
      var $36=$offsbits;
      var $37=$35 >>> (($36)>>>0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=$offsbits;
      var $48=$46 << $47;
      var $49=$result;
      var $50=$49 | $48;
      $result=$50;
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$result;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((16-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=(($12)&65535);
      var $14=$offsbits;
      var $15=$13 >> (($14)|0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $21, $22);
      var $24=(($23)&255);
      var $25=(($24)&65535);
      var $26=$offsbits;
      var $27=$25 << $26;
      var $28=(($27) & 65535);
      $result=$28;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$3;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $47, $48);
      var $50=(($49)&255);
      var $51=(($50)&65535);
      var $52=$offsbits;
      var $53=$51 << $52;
      var $54=$result;
      var $55=(($54)&65535);
      var $56=$55 | $53;
      var $57=(($56) & 65535);
      $result=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 7; break;
    case 7: // $59
      var $60=$index;
      var $61=(($60+1)|0);
      $index=$61;
      __label__ = 3; break;
    case 8: // $62
      var $63=$offsbits;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $65
      var $66=$offsbits;
      var $67=((8-$66)|0);
      $offsbits=$67;
      var $68=$3;
      var $69=(($68)&65535);
      var $70=$offsbits;
      var $71=$69 << $70;
      var $72=(($71) & 255);
      $curmask=$72;
      var $73=$curmask;
      var $74=(($73)&255);
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $76
      var $77=$2;
      var $78=(($77+1)|0);
      var $79=$curmask;
      var $80=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $78, $79);
      var $81=(($80)&255);
      var $82=$offsbits;
      var $83=$81 >> (($82)|0);
      var $84=$result;
      var $85=(($84)&65535);
      var $86=$85 | $83;
      var $87=(($86) & 65535);
      $result=$87;
      __label__ = 11; break;
    case 11: // $88
      __label__ = 12; break;
    case 12: // $89
      var $90=$result;
      ;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((16-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=(($12)&65535);
      var $14=$offsbits;
      var $15=$13 >> (($14)|0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $21, $22);
      var $24=(($23)&255);
      var $25=(($24)&65535);
      var $26=$offsbits;
      var $27=$25 << $26;
      var $28=(($27) & 65535);
      $result=$28;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$3;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh($4, $47, $48);
      var $50=(($49)&255);
      var $51=(($50)&65535);
      var $52=$offsbits;
      var $53=$51 << $52;
      var $54=$result;
      var $55=(($54)&65535);
      var $56=$55 | $53;
      var $57=(($56) & 65535);
      $result=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 7; break;
    case 7: // $59
      var $60=$index;
      var $61=(($60+1)|0);
      $index=$61;
      __label__ = 3; break;
    case 8: // $62
      var $63=$result;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t1ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=746;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=748;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=750;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=752;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=754;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=756;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=758;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=760;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=762;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=764;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=766;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=768;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=770;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=772;
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIhL12endianness_t1ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=HEAP8[($24)];
      $result=$25;
      __label__ = 3; break;
    case 2: // $26
      var $27=$handler;
      var $28=$3;
      var $29=$2;
      var $30=__ZNK18handler_entry_read5read8ER13address_spacejh($27, $28, $29, -1);
      $result=$30;
      __label__ = 3; break;
    case 3: // $31
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $32=$result;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIhL12endianness_t1ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIhL12endianness_t1ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIhL12endianness_t1ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t1ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EED0Ev["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$34$0=(($4)|0);
      var $13$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$34$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&255;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0&255;
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 7;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&255;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $st$1$0=(($3)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $52$0=$51$0;
      var $52=$52$0&255;
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $62=$offsbits;
      var $63=((8-$62)|0);
      $offsbits=$63;
      var $st$3$0=(($4)|0);
      var $64$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $64$1=HEAP32[(($st$3$1)>>2)];
      var $65=$offsbits;
      var $66$0=$65;
      var $66$1=0;
      var $67=Runtime.bitshift64($64$0, $64$1,"shl",$66$0);var $67$0 = $67[0], $67$1 = $67[1];
      var $68$0=$67$0;
      var $68=$68$0&255;
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)&255);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      var $st$2$0=(($3)|0);
      var $75$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $75$1=HEAP32[(($st$2$1)>>2)];
      var $76=$offsbits;
      var $77$0=$76;
      var $77$1=0;
      var $78=Runtime.bitshift64($75$0, $75$1,"shl",$77$0);var $78$0 = $78[0], $78$1 = $78[1];
      var $79$0=$78$0;
      var $79=$79$0&255;
      var $80=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $74, $79, $80);
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIhL12endianness_t1ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      $dest=$26;
      var $27=$dest;
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$4;
      var $31=(($30)&255);
      var $32=$31 ^ -1;
      var $33=$29 & $32;
      var $34=$3;
      var $35=(($34)&255);
      var $36=$4;
      var $37=(($36)&255);
      var $38=$35 & $37;
      var $39=$33 | $38;
      var $40=(($39) & 255);
      var $41=$dest;
      HEAP8[($41)]=$40;
      __label__ = 3; break;
    case 2: // $42
      var $43=$handler;
      var $44=$5;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($43, $44, $45, $46, $47);
      __label__ = 3; break;
    case 3: // $48
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t1ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((64-$11)|0);
      $offsbits=$12;
      var $st$34$0=(($4)|0);
      var $13$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($4+4)|0);
      var $13$1=HEAP32[(($st$34$1)>>2)];
      var $14=$offsbits;
      var $15$0=$14;
      var $15$1=0;
      var $16=Runtime.bitshift64($13$0, $13$1,"lshr",$15$0);var $16$0 = $16[0], $16$1 = $16[1];
      var $17$0=$16$0;
      var $17=$17$0&255;
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $st$1$0=(($3)|0);
      var $23$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$1$1)>>2)];
      var $24=$offsbits;
      var $25$0=$24;
      var $25$1=0;
      var $26=Runtime.bitshift64($23$0, $23$1,"lshr",$25$0);var $26$0 = $26[0], $26$1 = $26[1];
      var $27$0=$26$0;
      var $27=$27$0&255;
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 7;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $st$6$0=(($4)|0);
      var $38$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $38$1=HEAP32[(($st$6$1)>>2)];
      var $39=$offsbits;
      var $40$0=$39;
      var $40$1=0;
      var $41=Runtime.bitshift64($38$0, $38$1,"lshr",$40$0);var $41$0 = $41[0], $41$1 = $41[1];
      var $42$0=$41$0;
      var $42=$42$0&255;
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $st$1$0=(($3)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $49=$offsbits;
      var $50$0=$49;
      var $50$1=0;
      var $51=Runtime.bitshift64($48$0, $48$1,"lshr",$50$0);var $51$0 = $51[0], $51$1 = $51[1];
      var $52$0=$51$0;
      var $52=$52$0&255;
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$3;
      var $23=$offsbits;
      var $24=$22 >>> (($23)>>>0);
      var $25=(($24) & 255);
      var $26=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $21, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 3;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-8)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+1)|0);
      $2=$35;
      var $36=$4;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=$offsbits;
      var $47=$45 >>> (($46)>>>0);
      var $48=(($47) & 255);
      var $49=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $44, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$offsbits;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$offsbits;
      var $59=((8-$58)|0);
      $offsbits=$59;
      var $60=$4;
      var $61=$offsbits;
      var $62=$60 << $61;
      var $63=(($62) & 255);
      $curmask=$63;
      var $64=$curmask;
      var $65=(($64)&255);
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=(($68+1)|0);
      var $70=$3;
      var $71=$offsbits;
      var $72=$70 << $71;
      var $73=(($72) & 255);
      var $74=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $69, $73, $74);
      __label__ = 11; break;
    case 11: // $75
      __label__ = 12; break;
    case 12: // $76
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((32-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=$offsbits;
      var $15=$13 >>> (($14)>>>0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$3;
      var $23=$offsbits;
      var $24=$22 >>> (($23)>>>0);
      var $25=(($24) & 255);
      var $26=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $21, $25, $26);
      __label__ = 2; break;
    case 2: // $27
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 3;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$offsbits;
      var $33=(($32-8)|0);
      $offsbits=$33;
      var $34=$2;
      var $35=(($34+1)|0);
      $2=$35;
      var $36=$4;
      var $37=$offsbits;
      var $38=$36 >>> (($37)>>>0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=$offsbits;
      var $47=$45 >>> (($46)>>>0);
      var $48=(($47) & 255);
      var $49=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $44, $48, $49);
      __label__ = 6; break;
    case 6: // $50
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((16-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=(($13)&65535);
      var $15=$offsbits;
      var $16=$14 >> (($15)|0);
      var $17=(($16) & 255);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 >> (($25)|0);
      var $27=(($26) & 255);
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$4;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$3;
      var $49=(($48)&65535);
      var $50=$offsbits;
      var $51=$49 >> (($50)|0);
      var $52=(($51) & 255);
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $62=$offsbits;
      var $63=((8-$62)|0);
      $offsbits=$63;
      var $64=$4;
      var $65=(($64)&65535);
      var $66=$offsbits;
      var $67=$65 << $66;
      var $68=(($67) & 255);
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)&255);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      var $75=$3;
      var $76=(($75)&65535);
      var $77=$offsbits;
      var $78=$76 << $77;
      var $79=(($78) & 255);
      var $80=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $74, $79, $80);
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$offsbits;
      var $11=((8-$10)|0);
      var $12=((16-$11)|0);
      $offsbits=$12;
      var $13=$4;
      var $14=(($13)&65535);
      var $15=$offsbits;
      var $16=$14 >> (($15)|0);
      var $17=(($16) & 255);
      $curmask=$17;
      var $18=$curmask;
      var $19=(($18)&255);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$2;
      var $23=$3;
      var $24=(($23)&65535);
      var $25=$offsbits;
      var $26=$24 >> (($25)|0);
      var $27=(($26) & 255);
      var $28=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $22, $27, $28);
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$4;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$3;
      var $49=(($48)&65535);
      var $50=$offsbits;
      var $51=$49 >> (($50)|0);
      var $52=(($51) & 255);
      var $53=$curmask;
      __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh($5, $47, $52, $53);
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjh($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      HEAP8[($26)]=$22;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($28, $29, $30, $31, -1);
      __label__ = 3; break;
    case 3: // $32
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((64-$10)|0);
      $offsbits=$11;
      var $st$36$0=(($3)|0);
      var $12$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$36$1)>>2)];
      var $13=$offsbits;
      var $14$0=$13;
      var $14$1=0;
      var $15=Runtime.bitshift64($12$0, $12$1,"lshr",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
      var $16$0=$15$0;
      var $16=$16$0&255;
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-8)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+1)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0&255;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)&255);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $47=$curmask;
      var $48=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $46, $47);
      var $49$0=$48;
      var $49$1=0;
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"shl",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $st$9$0=(($result)|0);
      var $53$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $53$1=HEAP32[(($st$9$1)>>2)];
      var $54$0=$53$0 | $52$0;
      var $54$1=$53$1 | $52$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$54$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$54$1;
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $60=$offsbits;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $62
      var $63=$offsbits;
      var $64=((8-$63)|0);
      $offsbits=$64;
      var $st$3$0=(($3)|0);
      var $65$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $65$1=HEAP32[(($st$3$1)>>2)];
      var $66=$offsbits;
      var $67$0=$66;
      var $67$1=0;
      var $68=Runtime.bitshift64($65$0, $65$1,"shl",$67$0);var $68$0 = $68[0], $68$1 = $68[1];
      var $69$0=$68$0;
      var $69=$69$0&255;
      $curmask=$69;
      var $70=$curmask;
      var $71=(($70)&255);
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$2;
      var $75=(($74+1)|0);
      var $76=$curmask;
      var $77=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $75, $76);
      var $78=(($77)&255);
      var $79=$offsbits;
      var $80=$78 >> (($79)|0);
      var $81$0=$80;
      var $81$1=(($80|0) < 0 ? -1 : 0);
      var $st$9$0=(($result)|0);
      var $82$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $82$1=HEAP32[(($st$9$1)>>2)];
      var $83$0=$82$0 | $81$0;
      var $83$1=$82$1 | $81$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$83$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$83$1;
      __label__ = 11; break;
    case 11: // $84
      __label__ = 12; break;
    case 12: // $85
      var $st$0$0=(($result)|0);
      var $86$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $86$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$86$0,$86$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t1ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=HEAP8[($25)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      var $32=__ZNK18handler_entry_read5read8ER13address_spacejh($28, $29, $30, $31);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t1ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((64-$10)|0);
      $offsbits=$11;
      var $st$36$0=(($3)|0);
      var $12$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$36$1)>>2)];
      var $13=$offsbits;
      var $14$0=$13;
      var $14$1=0;
      var $15=Runtime.bitshift64($12$0, $12$1,"lshr",$14$0);var $15$0 = $15[0], $15$1 = $15[1];
      var $16$0=$15$0;
      var $16=$16$0&255;
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $21, $22);
      var $24$0=$23;
      var $24$1=0;
      var $25=$offsbits;
      var $26$0=$25;
      var $26$1=0;
      var $27=Runtime.bitshift64($24$0, $24$1,"shl",$26$0);var $27$0 = $27[0], $27$1 = $27[1];
      var $st$9$0=(($result)|0);
      HEAP32[(($st$9$0)>>2)]=$27$0;
      var $st$9$1=(($result+4)|0);
      HEAP32[(($st$9$1)>>2)]=$27$1;
      __label__ = 2; break;
    case 2: // $28
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$offsbits;
      var $34=(($33-8)|0);
      $offsbits=$34;
      var $35=$2;
      var $36=(($35+1)|0);
      $2=$36;
      var $st$6$0=(($3)|0);
      var $37$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $37$1=HEAP32[(($st$6$1)>>2)];
      var $38=$offsbits;
      var $39$0=$38;
      var $39$1=0;
      var $40=Runtime.bitshift64($37$0, $37$1,"lshr",$39$0);var $40$0 = $40[0], $40$1 = $40[1];
      var $41$0=$40$0;
      var $41=$41$0&255;
      $curmask=$41;
      var $42=$curmask;
      var $43=(($42)&255);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$2;
      var $47=$curmask;
      var $48=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $46, $47);
      var $49$0=$48;
      var $49$1=0;
      var $50=$offsbits;
      var $51$0=$50;
      var $51$1=0;
      var $52=Runtime.bitshift64($49$0, $49$1,"shl",$51$0);var $52$0 = $52[0], $52$1 = $52[1];
      var $st$9$0=(($result)|0);
      var $53$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $53$1=HEAP32[(($st$9$1)>>2)];
      var $54$0=$53$0 | $52$0;
      var $54$1=$53$1 | $52$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$54$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$54$1;
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$index;
      var $58=(($57+1)|0);
      $index=$58;
      __label__ = 3; break;
    case 8: // $59
      var $st$0$0=(($result)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$60$0,$60$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((32-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=$offsbits;
      var $14=$12 >>> (($13)>>>0);
      var $15=(($14) & 255);
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&255);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=$curmask;
      var $22=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $20, $21);
      var $23=(($22)&255);
      var $24=$offsbits;
      var $25=$23 << $24;
      $result=$25;
      __label__ = 2; break;
    case 2: // $26
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$offsbits;
      var $32=(($31-8)|0);
      $offsbits=$32;
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$3;
      var $36=$offsbits;
      var $37=$35 >>> (($36)>>>0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=$offsbits;
      var $48=$46 << $47;
      var $49=$result;
      var $50=$49 | $48;
      $result=$50;
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$offsbits;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=$offsbits;
      var $60=((8-$59)|0);
      $offsbits=$60;
      var $61=$3;
      var $62=$offsbits;
      var $63=$61 << $62;
      var $64=(($63) & 255);
      $curmask=$64;
      var $65=$curmask;
      var $66=(($65)&255);
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $68
      var $69=$2;
      var $70=(($69+1)|0);
      var $71=$curmask;
      var $72=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $70, $71);
      var $73=(($72)&255);
      var $74=$offsbits;
      var $75=$73 >> (($74)|0);
      var $76=$result;
      var $77=$76 | $75;
      $result=$77;
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      var $80=$result;
      ;
      return $80;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((32-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=$offsbits;
      var $14=$12 >>> (($13)>>>0);
      var $15=(($14) & 255);
      $curmask=$15;
      var $16=$curmask;
      var $17=(($16)&255);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$2;
      var $21=$curmask;
      var $22=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $20, $21);
      var $23=(($22)&255);
      var $24=$offsbits;
      var $25=$23 << $24;
      $result=$25;
      __label__ = 2; break;
    case 2: // $26
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$offsbits;
      var $32=(($31-8)|0);
      $offsbits=$32;
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$3;
      var $36=$offsbits;
      var $37=$35 >>> (($36)>>>0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=$offsbits;
      var $48=$46 << $47;
      var $49=$result;
      var $50=$49 | $48;
      $result=$50;
      __label__ = 6; break;
    case 6: // $51
      __label__ = 7; break;
    case 7: // $52
      var $53=$index;
      var $54=(($53+1)|0);
      $index=$54;
      __label__ = 3; break;
    case 8: // $55
      var $56=$result;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((16-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=(($12)&65535);
      var $14=$offsbits;
      var $15=$13 >> (($14)|0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $21, $22);
      var $24=(($23)&255);
      var $25=(($24)&65535);
      var $26=$offsbits;
      var $27=$25 << $26;
      var $28=(($27) & 65535);
      $result=$28;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$3;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $47, $48);
      var $50=(($49)&255);
      var $51=(($50)&65535);
      var $52=$offsbits;
      var $53=$51 << $52;
      var $54=$result;
      var $55=(($54)&65535);
      var $56=$55 | $53;
      var $57=(($56) & 65535);
      $result=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 7; break;
    case 7: // $59
      var $60=$index;
      var $61=(($60+1)|0);
      $index=$61;
      __label__ = 3; break;
    case 8: // $62
      var $63=$offsbits;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $65
      var $66=$offsbits;
      var $67=((8-$66)|0);
      $offsbits=$67;
      var $68=$3;
      var $69=(($68)&65535);
      var $70=$offsbits;
      var $71=$69 << $70;
      var $72=(($71) & 255);
      $curmask=$72;
      var $73=$curmask;
      var $74=(($73)&255);
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $76
      var $77=$2;
      var $78=(($77+1)|0);
      var $79=$curmask;
      var $80=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $78, $79);
      var $81=(($80)&255);
      var $82=$offsbits;
      var $83=$81 >> (($82)|0);
      var $84=$result;
      var $85=(($84)&65535);
      var $86=$85 | $83;
      var $87=(($86) & 65535);
      $result=$87;
      __label__ = 11; break;
    case 11: // $88
      __label__ = 12; break;
    case 12: // $89
      var $90=$result;
      ;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$offsbits;
      var $10=((8-$9)|0);
      var $11=((16-$10)|0);
      $offsbits=$11;
      var $12=$3;
      var $13=(($12)&65535);
      var $14=$offsbits;
      var $15=$13 >> (($14)|0);
      var $16=(($15) & 255);
      $curmask=$16;
      var $17=$curmask;
      var $18=(($17)&255);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=$curmask;
      var $23=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $21, $22);
      var $24=(($23)&255);
      var $25=(($24)&65535);
      var $26=$offsbits;
      var $27=$25 << $26;
      var $28=(($27) & 65535);
      $result=$28;
      __label__ = 2; break;
    case 2: // $29
      $index=0;
      __label__ = 3; break;
    case 3: // $30
      var $31=$index;
      var $32=(($31)>>>0) < 1;
      if ($32) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $33
      var $34=$offsbits;
      var $35=(($34-8)|0);
      $offsbits=$35;
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$3;
      var $39=(($38)&65535);
      var $40=$offsbits;
      var $41=$39 >> (($40)|0);
      var $42=(($41) & 255);
      $curmask=$42;
      var $43=$curmask;
      var $44=(($43)&255);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$2;
      var $48=$curmask;
      var $49=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh($4, $47, $48);
      var $50=(($49)&255);
      var $51=(($50)&65535);
      var $52=$offsbits;
      var $53=$51 << $52;
      var $54=$result;
      var $55=(($54)&65535);
      var $56=$55 | $53;
      var $57=(($56) & 65535);
      $result=$57;
      __label__ = 6; break;
    case 6: // $58
      __label__ = 7; break;
    case 7: // $59
      var $60=$index;
      var $61=(($60+1)|0);
      $index=$61;
      __label__ = 3; break;
    case 8: // $62
      var $63=$result;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t0ELb0EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=774;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=776;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=778;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=780;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=782;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=784;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=786;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=788;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=790;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=792;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=794;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=796;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=798;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=800;
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIhL12endianness_t1ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=HEAP8[($24)];
      $result=$25;
      __label__ = 3; break;
    case 2: // $26
      var $27=$handler;
      var $28=$3;
      var $29=$2;
      var $30=__ZNK18handler_entry_read5read8ER13address_spacejh($27, $28, $29, -1);
      $result=$30;
      __label__ = 3; break;
    case 3: // $31
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $32=$result;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIhL12endianness_t0ELb0EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t1ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIhL12endianness_t1ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 0);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIhL12endianness_t0ELb0EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t0ELb0EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EED0Ev["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $st$30$0=(($4)|0);
      var $10$0=HEAP32[(($st$30$0)>>2)];
      var $st$30$1=(($4+4)|0);
      var $10$1=HEAP32[(($st$30$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&255;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0&255;
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&255;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $st$1$0=(($3)|0);
      var $45$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $45$1=HEAP32[(($st$1$1)>>2)];
      var $46=$offsbits;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"lshr",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $49$0=$48$0;
      var $49=$49$0&255;
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      var $58=$offsbits;
      var $59=(($58)>>>0) < 64;
      if ($59) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $60
      var $st$0$0=(($4)|0);
      var $61$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $61$1=HEAP32[(($st$0$1)>>2)];
      var $62=$offsbits;
      var $63$0=$62;
      var $63$1=0;
      var $64=Runtime.bitshift64($61$0, $61$1,"lshr",$63$0);var $64$0 = $64[0], $64$1 = $64[1];
      var $65$0=$64$0;
      var $65=$65$0&255;
      $curmask=$65;
      var $66=$curmask;
      var $67=(($66)&255);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $69
      var $70=$2;
      var $71=(($70+1)|0);
      var $st$2$0=(($3)|0);
      var $72$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $72$1=HEAP32[(($st$2$1)>>2)];
      var $73=$offsbits;
      var $74$0=$73;
      var $74$1=0;
      var $75=Runtime.bitshift64($72$0, $72$1,"lshr",$74$0);var $75$0 = $75[0], $75$1 = $75[1];
      var $76$0=$75$0;
      var $76=$76$0&255;
      var $77=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $71, $76, $77);
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIhL12endianness_t0ELb0EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      $dest=$26;
      var $27=$dest;
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$4;
      var $31=(($30)&255);
      var $32=$31 ^ -1;
      var $33=$29 & $32;
      var $34=$3;
      var $35=(($34)&255);
      var $36=$4;
      var $37=(($36)&255);
      var $38=$35 & $37;
      var $39=$33 | $38;
      var $40=(($39) & 255);
      var $41=$dest;
      HEAP8[($41)]=$40;
      __label__ = 3; break;
    case 2: // $42
      var $43=$handler;
      var $44=$5;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($43, $44, $45, $46, $47);
      __label__ = 3; break;
    case 3: // $48
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t0ELb0EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $st$30$0=(($4)|0);
      var $10$0=HEAP32[(($st$30$0)>>2)];
      var $st$30$1=(($4+4)|0);
      var $10$1=HEAP32[(($st$30$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&255;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0&255;
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&255;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $st$1$0=(($3)|0);
      var $45$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $45$1=HEAP32[(($st$1$1)>>2)];
      var $46=$offsbits;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"lshr",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $49$0=$48$0;
      var $49=$49$0&255;
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$4;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$3;
      var $20=$offsbits;
      var $21=$19 << $20;
      var $22=(($21) & 255);
      var $23=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $18, $22, $23);
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((8-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+1)|0);
      $2=$32;
      var $33=$4;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 255);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&255);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$3;
      var $43=$offsbits;
      var $44=$42 >>> (($43)>>>0);
      var $45=(($44) & 255);
      var $46=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $41, $45, $46);
      __label__ = 6; break;
    case 6: // $47
      var $48=$offsbits;
      var $49=(($48+8)|0);
      $offsbits=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$index;
      var $52=(($51+1)|0);
      $index=$52;
      __label__ = 3; break;
    case 8: // $53
      var $54=$offsbits;
      var $55=(($54)>>>0) < 32;
      if ($55) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $56
      var $57=$4;
      var $58=$offsbits;
      var $59=$57 >>> (($58)>>>0);
      var $60=(($59) & 255);
      $curmask=$60;
      var $61=$curmask;
      var $62=(($61)&255);
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      var $65=$2;
      var $66=(($65+1)|0);
      var $67=$3;
      var $68=$offsbits;
      var $69=$67 >>> (($68)>>>0);
      var $70=(($69) & 255);
      var $71=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $66, $70, $71);
      __label__ = 11; break;
    case 11: // $72
      __label__ = 12; break;
    case 12: // $73
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$4;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$3;
      var $20=$offsbits;
      var $21=$19 << $20;
      var $22=(($21) & 255);
      var $23=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $18, $22, $23);
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((8-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+1)|0);
      $2=$32;
      var $33=$4;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 255);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&255);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$3;
      var $43=$offsbits;
      var $44=$42 >>> (($43)>>>0);
      var $45=(($44) & 255);
      var $46=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $41, $45, $46);
      __label__ = 6; break;
    case 6: // $47
      var $48=$offsbits;
      var $49=(($48+8)|0);
      $offsbits=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$index;
      var $52=(($51+1)|0);
      $index=$52;
      __label__ = 3; break;
    case 8: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$4;
      var $11=(($10)&65535);
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 255);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 255);
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$4;
      var $36=(($35)&65535);
      var $37=$offsbits;
      var $38=$36 >> (($37)|0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=(($45)&65535);
      var $47=$offsbits;
      var $48=$46 >> (($47)|0);
      var $49=(($48) & 255);
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      var $58=$offsbits;
      var $59=(($58)>>>0) < 16;
      if ($59) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $60
      var $61=$4;
      var $62=(($61)&65535);
      var $63=$offsbits;
      var $64=$62 >> (($63)|0);
      var $65=(($64) & 255);
      $curmask=$65;
      var $66=$curmask;
      var $67=(($66)&255);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $69
      var $70=$2;
      var $71=(($70+1)|0);
      var $72=$3;
      var $73=(($72)&65535);
      var $74=$offsbits;
      var $75=$73 >> (($74)|0);
      var $76=(($75) & 255);
      var $77=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $71, $76, $77);
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$4;
      var $11=(($10)&65535);
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 255);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 255);
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$4;
      var $36=(($35)&65535);
      var $37=$offsbits;
      var $38=$36 >> (($37)|0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=(($45)&65535);
      var $47=$offsbits;
      var $48=$46 >> (($47)|0);
      var $49=(($48) & 255);
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjh($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb0EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      HEAP8[($26)]=$22;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($28, $29, $30, $31, -1);
      __label__ = 3; break;
    case 3: // $32
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $st$32$0=(($3)|0);
      var $9$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($3+4)|0);
      var $9$1=HEAP32[(($st$32$1)>>2)];
      var $10=$offsbits;
      var $11$0=$10;
      var $11$1=0;
      var $12=Runtime.bitshift64($9$0, $9$1,"shl",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
      var $13$0=$12$0;
      var $13=$13$0&255;
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24$0=$23;
      var $24$1=(($23|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$24$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$24$1;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 7;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $st$3$0=(($3)|0);
      var $34$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $34$1=HEAP32[(($st$3$1)>>2)];
      var $35=$offsbits;
      var $36$0=$35;
      var $36$1=0;
      var $37=Runtime.bitshift64($34$0, $34$1,"lshr",$36$0);var $37$0 = $37[0], $37$1 = $37[1];
      var $38$0=$37$0;
      var $38=$38$0&255;
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $43, $44);
      var $46$0=$45;
      var $46$1=0;
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"shl",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $st$9$0=(($result)|0);
      var $50$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $50$1=HEAP32[(($st$9$1)>>2)];
      var $51$0=$50$0 | $49$0;
      var $51$1=$50$1 | $49$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$51$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$51$1;
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+8)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)>>>0) < 64;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $st$0$0=(($3)|0);
      var $62$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $62$1=HEAP32[(($st$0$1)>>2)];
      var $63=$offsbits;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $66$0=$65$0;
      var $66=$66$0&255;
      $curmask=$66;
      var $67=$curmask;
      var $68=(($67)&255);
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$2;
      var $72=(($71+1)|0);
      var $73=$curmask;
      var $74=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $72, $73);
      var $75$0=$74;
      var $75$1=0;
      var $76=$offsbits;
      var $77$0=$76;
      var $77$1=0;
      var $78=Runtime.bitshift64($75$0, $75$1,"shl",$77$0);var $78$0 = $78[0], $78$1 = $78[1];
      var $st$10$0=(($result)|0);
      var $79$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $79$1=HEAP32[(($st$10$1)>>2)];
      var $80$0=$79$0 | $78$0;
      var $80$1=$79$1 | $78$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$80$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$80$1;
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      var $st$0$0=(($result)|0);
      var $83$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$83$0,$83$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb0EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=HEAP8[($25)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      var $32=__ZNK18handler_entry_read5read8ER13address_spacejh($28, $29, $30, $31);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t0ELb0EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_smallEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $st$32$0=(($3)|0);
      var $9$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($3+4)|0);
      var $9$1=HEAP32[(($st$32$1)>>2)];
      var $10=$offsbits;
      var $11$0=$10;
      var $11$1=0;
      var $12=Runtime.bitshift64($9$0, $9$1,"shl",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
      var $13$0=$12$0;
      var $13=$13$0&255;
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24$0=$23;
      var $24$1=(($23|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$24$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$24$1;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 7;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $st$3$0=(($3)|0);
      var $34$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $34$1=HEAP32[(($st$3$1)>>2)];
      var $35=$offsbits;
      var $36$0=$35;
      var $36$1=0;
      var $37=Runtime.bitshift64($34$0, $34$1,"lshr",$36$0);var $37$0 = $37[0], $37$1 = $37[1];
      var $38$0=$37$0;
      var $38=$38$0&255;
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $43, $44);
      var $46$0=$45;
      var $46$1=0;
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"shl",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $st$9$0=(($result)|0);
      var $50$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $50$1=HEAP32[(($st$9$1)>>2)];
      var $51$0=$50$0 | $49$0;
      var $51$1=$50$1 | $49$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$51$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$51$1;
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+8)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $st$0$0=(($result)|0);
      var $59$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $59$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$59$0,$59$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$3;
      var $10=$offsbits;
      var $11=$9 << $10;
      var $12=(($11) & 255);
      $curmask=$12;
      var $13=$curmask;
      var $14=(($13)&255);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$2;
      var $18=$curmask;
      var $19=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $17, $18);
      var $20=(($19)&255);
      var $21=$offsbits;
      var $22=$20 >> (($21)|0);
      $result=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$offsbits;
      var $25=((8-$24)|0);
      $offsbits=$25;
      $index=0;
      __label__ = 3; break;
    case 3: // $26
      var $27=$index;
      var $28=(($27)>>>0) < 3;
      if ($28) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      var $32=$3;
      var $33=$offsbits;
      var $34=$32 >>> (($33)>>>0);
      var $35=(($34) & 255);
      $curmask=$35;
      var $36=$curmask;
      var $37=(($36)&255);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$2;
      var $41=$curmask;
      var $42=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $40, $41);
      var $43=(($42)&255);
      var $44=$offsbits;
      var $45=$43 << $44;
      var $46=$result;
      var $47=$46 | $45;
      $result=$47;
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+8)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$offsbits;
      var $56=(($55)>>>0) < 32;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$3;
      var $59=$offsbits;
      var $60=$58 >>> (($59)>>>0);
      var $61=(($60) & 255);
      $curmask=$61;
      var $62=$curmask;
      var $63=(($62)&255);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $65
      var $66=$2;
      var $67=(($66+1)|0);
      var $68=$curmask;
      var $69=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $67, $68);
      var $70=(($69)&255);
      var $71=$offsbits;
      var $72=$70 << $71;
      var $73=$result;
      var $74=$73 | $72;
      $result=$74;
      __label__ = 11; break;
    case 11: // $75
      __label__ = 12; break;
    case 12: // $76
      var $77=$result;
      ;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$3;
      var $10=$offsbits;
      var $11=$9 << $10;
      var $12=(($11) & 255);
      $curmask=$12;
      var $13=$curmask;
      var $14=(($13)&255);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$2;
      var $18=$curmask;
      var $19=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $17, $18);
      var $20=(($19)&255);
      var $21=$offsbits;
      var $22=$20 >> (($21)|0);
      $result=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$offsbits;
      var $25=((8-$24)|0);
      $offsbits=$25;
      $index=0;
      __label__ = 3; break;
    case 3: // $26
      var $27=$index;
      var $28=(($27)>>>0) < 3;
      if ($28) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      var $32=$3;
      var $33=$offsbits;
      var $34=$32 >>> (($33)>>>0);
      var $35=(($34) & 255);
      $curmask=$35;
      var $36=$curmask;
      var $37=(($36)&255);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$2;
      var $41=$curmask;
      var $42=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $40, $41);
      var $43=(($42)&255);
      var $44=$offsbits;
      var $45=$43 << $44;
      var $46=$result;
      var $47=$46 | $45;
      $result=$47;
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+8)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$result;
      ;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$3;
      var $10=(($9)&65535);
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24=(($23) & 65535);
      $result=$24;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $34=$3;
      var $35=(($34)&65535);
      var $36=$offsbits;
      var $37=$35 >> (($36)|0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=(($50)&65535);
      var $52=$51 | $49;
      var $53=(($52) & 65535);
      $result=$53;
      __label__ = 6; break;
    case 6: // $54
      var $55=$offsbits;
      var $56=(($55+8)|0);
      $offsbits=$56;
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $61=$offsbits;
      var $62=(($61)>>>0) < 16;
      if ($62) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $63
      var $64=$3;
      var $65=(($64)&65535);
      var $66=$offsbits;
      var $67=$65 >> (($66)|0);
      var $68=(($67) & 255);
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)&255);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      var $75=$curmask;
      var $76=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $74, $75);
      var $77=(($76)&255);
      var $78=(($77)&65535);
      var $79=$offsbits;
      var $80=$78 << $79;
      var $81=$result;
      var $82=(($81)&65535);
      var $83=$82 | $80;
      var $84=(($83) & 65535);
      $result=$84;
      __label__ = 11; break;
    case 11: // $85
      __label__ = 12; break;
    case 12: // $86
      var $87=$result;
      ;
      return $87;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$3;
      var $10=(($9)&65535);
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24=(($23) & 65535);
      $result=$24;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $34=$3;
      var $35=(($34)&65535);
      var $36=$offsbits;
      var $37=$35 >> (($36)|0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=(($50)&65535);
      var $52=$51 | $49;
      var $53=(($52) & 65535);
      $result=$53;
      __label__ = 6; break;
    case 6: // $54
      var $55=$offsbits;
      var $56=(($55+8)|0);
      $offsbits=$56;
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $61=$result;
      ;
      return $61;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIhL12endianness_t0ELb0EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=HEAP8[($24)];
      $result=$25;
      __label__ = 3; break;
    case 2: // $26
      var $27=$handler;
      var $28=$3;
      var $29=$2;
      var $30=__ZNK18handler_entry_read5read8ER13address_spacejh($27, $28, $29, -1);
      $result=$30;
      __label__ = 3; break;
    case 3: // $31
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $32=$result;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZNK22address_space_specificIhL12endianness_t0ELb1EE9accessorsER14data_accessors($this, $accessors) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$accessors;
  var $3=$1;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=802;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=804;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=806;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=808;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=810;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=812;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=814;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=816;
  var $20=$2;
  var $21=(($20+32)|0);
  HEAP32[(($21)>>2)]=818;
  var $22=$2;
  var $23=(($22+36)|0);
  HEAP32[(($23)>>2)]=820;
  var $24=$2;
  var $25=(($24+40)|0);
  HEAP32[(($25)>>2)]=822;
  var $26=$2;
  var $27=(($26+44)|0);
  HEAP32[(($27)>>2)]=824;
  var $28=$2;
  var $29=(($28+48)|0);
  HEAP32[(($29)>>2)]=826;
  var $30=$2;
  var $31=(($30+52)|0);
  HEAP32[(($31)>>2)]=828;
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 2820);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22address_space_specificIhL12endianness_t0ELb1EED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE23enable_read_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+68)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE24enable_write_watchpointsEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+1444)|0);
  var $6=$5;
  var $7=$2;
  var $8=(($7) & 1);
  __ZN13address_table18enable_watchpointsEb($6, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE12get_read_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE13get_write_ptrEj($this, $byteaddress) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $handler;
      $2=$this;
      $3=$byteaddress;
      var $4=$2;
      var $5=$4;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=$8 & $7;
      $3=$9;
      var $10=$3;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$entry;
      var $16=(($15)>>>0) > 124;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$handler;
      var $20=$19;
      var $21=$handler;
      var $22=$21;
      var $23=$3;
      var $24=__ZNK13handler_entry10byteoffsetEj($22, $23);
      var $25=__ZNK13handler_entry6ramptrEj($20, $24);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE9read_byteEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE9read_wordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE9read_wordEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE19read_word_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE19read_word_unalignedEjt($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10read_dwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10read_dwordEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE20read_dword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE20read_dword_unalignedEjj($this, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10read_qwordEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10read_qwordEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE20read_qword_unalignedEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE20read_qword_unalignedEjy($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10write_byteEjh($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10write_wordEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE10write_wordEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE20write_word_unalignedEjt($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE20write_word_unalignedEjtt($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE11write_dwordEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE11write_dwordEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE21write_dword_unalignedEjj($this, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE21write_dword_unalignedEjjj($this, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb0EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIhL12endianness_t0ELb0EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED0Ev["X"]=1;

function __ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum($this, $memory, $spacenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$memory;
      $3=$spacenum;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN13address_spaceC2ER23device_memory_interface16address_spacenumb($7, $8, $9, 1);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV22address_space_specificIhL12endianness_t0ELb1EE+8)|0);
      var $11=(($6+68)|0);
      var $12=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readC1ER13address_spaceb]($11, $12, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=(($6+1444)|0);
      var $15=$6;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeC1ER13address_spaceb]($14, $15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      ;
      return;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      var $25=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$6;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$4;
      var $32=$4;
      var $33=$5;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN22address_space_specificIhL12endianness_t0ELb1EED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EED0Ev["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE4readEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE5writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1444)|0);
  ;
  return $3;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE11write_qwordEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE11write_qwordEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE21write_qword_unalignedEjy($this, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE21write_qword_unalignedEjyy($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$this;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $st$30$0=(($4)|0);
      var $10$0=HEAP32[(($st$30$0)>>2)];
      var $st$30$1=(($4+4)|0);
      var $10$1=HEAP32[(($st$30$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&255;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0&255;
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&255;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $st$1$0=(($3)|0);
      var $45$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $45$1=HEAP32[(($st$1$1)>>2)];
      var $46=$offsbits;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"lshr",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $49$0=$48$0;
      var $49=$49$0&255;
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      var $58=$offsbits;
      var $59=(($58)>>>0) < 64;
      if ($59) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $60
      var $st$0$0=(($4)|0);
      var $61$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $61$1=HEAP32[(($st$0$1)>>2)];
      var $62=$offsbits;
      var $63$0=$62;
      var $63$1=0;
      var $64=Runtime.bitshift64($61$0, $61$1,"lshr",$63$0);var $64$0 = $64[0], $64$1 = $64[1];
      var $65$0=$64$0;
      var $65=$65$0&255;
      $curmask=$65;
      var $66=$curmask;
      var $67=(($66)&255);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $69
      var $70=$2;
      var $71=(($70+1)|0);
      var $st$2$0=(($3)|0);
      var $72$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $72$1=HEAP32[(($st$2$1)>>2)];
      var $73=$offsbits;
      var $74$0=$73;
      var $74$1=0;
      var $75=Runtime.bitshift64($72$0, $72$1,"lshr",$74$0);var $75$0 = $75[0], $75$1 = $75[1];
      var $76$0=$75$0;
      var $76=$76$0&255;
      var $77=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $71, $76, $77);
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($this, $offset, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $byteaddress;
      var $entry;
      var $handler;
      var $dest;
      $1=$this;
      $2=$offset;
      $3=$data;
      $4=$mask;
      var $5=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $6=$2;
      var $7=$5;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$6 & $9;
      $byteaddress=$10;
      var $11=$byteaddress;
      var $12=__ZNK22address_space_specificIhL12endianness_t0ELb1EE12write_lookupEj($5, $11);
      $entry=$12;
      var $13=(($5+1444)|0);
      var $14=$entry;
      var $15=__ZNK19address_table_write13handler_writeEj($13, $14);
      $handler=$15;
      var $16=$handler;
      var $17=$16;
      var $18=$byteaddress;
      var $19=__ZNK13handler_entry10byteoffsetEj($17, $18);
      $2=$19;
      var $20=$entry;
      var $21=(($20)>>>0) <= 124;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      $dest=$26;
      var $27=$dest;
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$4;
      var $31=(($30)&255);
      var $32=$31 ^ -1;
      var $33=$29 & $32;
      var $34=$3;
      var $35=(($34)&255);
      var $36=$4;
      var $37=(($36)&255);
      var $38=$35 & $37;
      var $39=$33 | $38;
      var $40=(($39) & 255);
      var $41=$dest;
      HEAP8[($41)]=$40;
      __label__ = 3; break;
    case 2: // $42
      var $43=$handler;
      var $44=$5;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($43, $44, $45, $46, $47);
      __label__ = 3; break;
    case 3: // $48
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t0ELb1EE12write_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+1444)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($this, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$data$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$data$1;
      var $st$16$0=(($4)|0);
      HEAP32[(($st$16$0)>>2)]=$mask$0;
      var $st$16$1=(($4+4)|0);
      HEAP32[(($st$16$1)>>2)]=$mask$1;
      var $5=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=7;
      var $st$30$0=(($4)|0);
      var $10$0=HEAP32[(($st$30$0)>>2)];
      var $st$30$1=(($4+4)|0);
      var $10$1=HEAP32[(($st$30$1)>>2)];
      var $11=$offsbits;
      var $12$0=$11;
      var $12$1=0;
      var $13=Runtime.bitshift64($10$0, $10$1,"shl",$12$0);var $13$0 = $13[0], $13$1 = $13[1];
      var $14$0=$13$0;
      var $14=$14$0&255;
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $st$1$0=(($3)|0);
      var $20$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$1$1)>>2)];
      var $21=$offsbits;
      var $22$0=$21;
      var $22$1=0;
      var $23=Runtime.bitshift64($20$0, $20$1,"shl",$22$0);var $23$0 = $23[0], $23$1 = $23[1];
      var $24$0=$23$0;
      var $24=$24$0&255;
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 7;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $st$3$0=(($4)|0);
      var $35$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($4+4)|0);
      var $35$1=HEAP32[(($st$3$1)>>2)];
      var $36=$offsbits;
      var $37$0=$36;
      var $37$1=0;
      var $38=Runtime.bitshift64($35$0, $35$1,"lshr",$37$0);var $38$0 = $38[0], $38$1 = $38[1];
      var $39$0=$38$0;
      var $39=$39$0&255;
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $st$1$0=(($3)|0);
      var $45$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $45$1=HEAP32[(($st$1$1)>>2)];
      var $46=$offsbits;
      var $47$0=$46;
      var $47$1=0;
      var $48=Runtime.bitshift64($45$0, $45$1,"lshr",$47$0);var $48$0 = $48[0], $48$1 = $48[1];
      var $49$0=$48$0;
      var $49=$49$0&255;
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$4;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$3;
      var $20=$offsbits;
      var $21=$19 << $20;
      var $22=(($21) & 255);
      var $23=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $18, $22, $23);
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((8-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+1)|0);
      $2=$32;
      var $33=$4;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 255);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&255);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$3;
      var $43=$offsbits;
      var $44=$42 >>> (($43)>>>0);
      var $45=(($44) & 255);
      var $46=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $41, $45, $46);
      __label__ = 6; break;
    case 6: // $47
      var $48=$offsbits;
      var $49=(($48+8)|0);
      $offsbits=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$index;
      var $52=(($51+1)|0);
      $index=$52;
      __label__ = 3; break;
    case 8: // $53
      var $54=$offsbits;
      var $55=(($54)>>>0) < 32;
      if ($55) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $56
      var $57=$4;
      var $58=$offsbits;
      var $59=$57 >>> (($58)>>>0);
      var $60=(($59) & 255);
      $curmask=$60;
      var $61=$curmask;
      var $62=(($61)&255);
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      var $65=$2;
      var $66=(($65+1)|0);
      var $67=$3;
      var $68=$offsbits;
      var $69=$67 >>> (($68)>>>0);
      var $70=(($69) & 255);
      var $71=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $66, $70, $71);
      __label__ = 11; break;
    case 11: // $72
      __label__ = 12; break;
    case 12: // $73
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=3;
      var $10=$4;
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$3;
      var $20=$offsbits;
      var $21=$19 << $20;
      var $22=(($21) & 255);
      var $23=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $18, $22, $23);
      __label__ = 2; break;
    case 2: // $24
      var $25=$offsbits;
      var $26=((8-$25)|0);
      $offsbits=$26;
      $index=0;
      __label__ = 3; break;
    case 3: // $27
      var $28=$index;
      var $29=(($28)>>>0) < 3;
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$2;
      var $32=(($31+1)|0);
      $2=$32;
      var $33=$4;
      var $34=$offsbits;
      var $35=$33 >>> (($34)>>>0);
      var $36=(($35) & 255);
      $curmask=$36;
      var $37=$curmask;
      var $38=(($37)&255);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=$3;
      var $43=$offsbits;
      var $44=$42 >>> (($43)>>>0);
      var $45=(($44) & 255);
      var $46=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $41, $45, $46);
      __label__ = 6; break;
    case 6: // $47
      var $48=$offsbits;
      var $49=(($48+8)|0);
      $offsbits=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$index;
      var $52=(($51+1)|0);
      $index=$52;
      __label__ = 3; break;
    case 8: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$4;
      var $11=(($10)&65535);
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 255);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 255);
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$4;
      var $36=(($35)&65535);
      var $37=$offsbits;
      var $38=$36 >> (($37)|0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=(($45)&65535);
      var $47=$offsbits;
      var $48=$46 >> (($47)|0);
      var $49=(($48) & 255);
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      var $58=$offsbits;
      var $59=(($58)>>>0) < 16;
      if ($59) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $60
      var $61=$4;
      var $62=(($61)&65535);
      var $63=$offsbits;
      var $64=$62 >> (($63)|0);
      var $65=(($64) & 255);
      $curmask=$65;
      var $66=$curmask;
      var $67=(($66)&255);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $69
      var $70=$2;
      var $71=(($70+1)|0);
      var $72=$3;
      var $73=(($72)&65535);
      var $74=$offsbits;
      var $75=$73 >> (($74)|0);
      var $76=(($75) & 255);
      var $77=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $71, $76, $77);
      __label__ = 11; break;
    case 11: // $78
      __label__ = 12; break;
    case 12: // $79
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($this, $address, $data, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$data;
      $4=$mask;
      var $5=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $6=$2;
      var $7=$6 & 0;
      var $8=((($7<<3))|0);
      $offsbits=$8;
      var $9=$2;
      $2=$9;
      $MAX_SPLITS_MINUS_ONE=1;
      var $10=$4;
      var $11=(($10)&65535);
      var $12=$offsbits;
      var $13=$11 << $12;
      var $14=(($13) & 255);
      $curmask=$14;
      var $15=$curmask;
      var $16=(($15)&255);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=$3;
      var $21=(($20)&65535);
      var $22=$offsbits;
      var $23=$21 << $22;
      var $24=(($23) & 255);
      var $25=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $19, $24, $25);
      __label__ = 2; break;
    case 2: // $26
      var $27=$offsbits;
      var $28=((8-$27)|0);
      $offsbits=$28;
      $index=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$index;
      var $31=(($30)>>>0) < 1;
      if ($31) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=$4;
      var $36=(($35)&65535);
      var $37=$offsbits;
      var $38=$36 >> (($37)|0);
      var $39=(($38) & 255);
      $curmask=$39;
      var $40=$curmask;
      var $41=(($40)&255);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$2;
      var $45=$3;
      var $46=(($45)&65535);
      var $47=$offsbits;
      var $48=$46 >> (($47)|0);
      var $49=(($48) & 255);
      var $50=$curmask;
      __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh($5, $44, $49, $50);
      __label__ = 6; break;
    case 6: // $51
      var $52=$offsbits;
      var $53=(($52+8)|0);
      $offsbits=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$index;
      var $56=(($55+1)|0);
      $index=$56;
      __label__ = 3; break;
    case 8: // $57
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjh($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 260);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb1EE12write_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+1444)|0);
      var $13=$entry;
      var $14=__ZNK19address_table_write13handler_writeEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$3;
      var $23=$handler;
      var $24=$23;
      var $25=$2;
      var $26=__ZNK13handler_entry6ramptrEj($24, $25);
      HEAP8[($26)]=$22;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      __ZNK19handler_entry_write6write8ER13address_spacejhh($28, $29, $30, $31, -1);
      __label__ = 3; break;
    case 3: // $32
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $st$32$0=(($3)|0);
      var $9$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($3+4)|0);
      var $9$1=HEAP32[(($st$32$1)>>2)];
      var $10=$offsbits;
      var $11$0=$10;
      var $11$1=0;
      var $12=Runtime.bitshift64($9$0, $9$1,"shl",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
      var $13$0=$12$0;
      var $13=$13$0&255;
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24$0=$23;
      var $24$1=(($23|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$24$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$24$1;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 7;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $st$3$0=(($3)|0);
      var $34$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $34$1=HEAP32[(($st$3$1)>>2)];
      var $35=$offsbits;
      var $36$0=$35;
      var $36$1=0;
      var $37=Runtime.bitshift64($34$0, $34$1,"lshr",$36$0);var $37$0 = $37[0], $37$1 = $37[1];
      var $38$0=$37$0;
      var $38=$38$0&255;
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $43, $44);
      var $46$0=$45;
      var $46$1=0;
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"shl",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $st$9$0=(($result)|0);
      var $50$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $50$1=HEAP32[(($st$9$1)>>2)];
      var $51$0=$50$0 | $49$0;
      var $51$1=$50$1 | $49$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$51$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$51$1;
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+8)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $59=$offsbits;
      var $60=(($59)>>>0) < 64;
      if ($60) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $61
      var $st$0$0=(($3)|0);
      var $62$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $62$1=HEAP32[(($st$0$1)>>2)];
      var $63=$offsbits;
      var $64$0=$63;
      var $64$1=0;
      var $65=Runtime.bitshift64($62$0, $62$1,"lshr",$64$0);var $65$0 = $65[0], $65$1 = $65[1];
      var $66$0=$65$0;
      var $66=$66$0&255;
      $curmask=$66;
      var $67=$curmask;
      var $68=(($67)&255);
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$2;
      var $72=(($71+1)|0);
      var $73=$curmask;
      var $74=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $72, $73);
      var $75$0=$74;
      var $75$1=0;
      var $76=$offsbits;
      var $77$0=$76;
      var $77$1=0;
      var $78=Runtime.bitshift64($75$0, $75$1,"shl",$77$0);var $78$0 = $78[0], $78$1 = $78[1];
      var $st$10$0=(($result)|0);
      var $79$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($result+4)|0);
      var $79$1=HEAP32[(($st$10$1)>>2)];
      var $80$0=$79$0 | $78$0;
      var $80$1=$79$1 | $78$1;
      var $st$16$0=(($result)|0);
      HEAP32[(($st$16$0)>>2)]=$80$0;
      var $st$16$1=(($result+4)|0);
      HEAP32[(($st$16$1)>>2)]=$80$1;
      __label__ = 11; break;
    case 11: // $81
      __label__ = 12; break;
    case 12: // $82
      var $st$0$0=(($result)|0);
      var $83$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $83$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$83$0,$83$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($this, $offset, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      $3=$mask;
      var $4=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $5=$2;
      var $6=$4;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$5 & $8;
      $byteaddress=$9;
      var $10=$byteaddress;
      var $11=__ZNK22address_space_specificIhL12endianness_t0ELb1EE11read_lookupEj($4, $10);
      $entry=$11;
      var $12=(($4+68)|0);
      var $13=$entry;
      var $14=__ZNK18address_table_read12handler_readEj($12, $13);
      $handler=$14;
      var $15=$handler;
      var $16=$15;
      var $17=$byteaddress;
      var $18=__ZNK13handler_entry10byteoffsetEj($16, $17);
      $2=$18;
      var $19=$entry;
      var $20=(($19)>>>0) <= 124;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$handler;
      var $23=$22;
      var $24=$2;
      var $25=__ZNK13handler_entry6ramptrEj($23, $24);
      var $26=HEAP8[($25)];
      $result=$26;
      __label__ = 3; break;
    case 2: // $27
      var $28=$handler;
      var $29=$4;
      var $30=$2;
      var $31=$3;
      var $32=__ZNK18handler_entry_read5read8ER13address_spacejh($28, $29, $30, $31);
      $result=$32;
      __label__ = 3; break;
    case 3: // $33
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $34=$result;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh["X"]=1;

function __ZNK22address_space_specificIhL12endianness_t0ELb1EE11read_lookupEj($this, $byteaddress) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$byteaddress;
  var $3=$1;
  var $4=(($3+68)|0);
  var $5=$4;
  var $6=$2;
  var $7=__ZNK13address_table17lookup_live_largeEj($5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($this, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result=__stackBase__+8;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      var $st$12$0=(($3)|0);
      HEAP32[(($st$12$0)>>2)]=$mask$0;
      var $st$12$1=(($3+4)|0);
      HEAP32[(($st$12$1)>>2)]=$mask$1;
      var $4=$1;
      $TARGET_BYTES=8;
      $TARGET_BITS=64;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=7;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      var $st$32$0=(($3)|0);
      var $9$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($3+4)|0);
      var $9$1=HEAP32[(($st$32$1)>>2)];
      var $10=$offsbits;
      var $11$0=$10;
      var $11$1=0;
      var $12=Runtime.bitshift64($9$0, $9$1,"shl",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
      var $13$0=$12$0;
      var $13=$13$0&255;
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24$0=$23;
      var $24$1=(($23|0) < 0 ? -1 : 0);
      var $st$8$0=(($result)|0);
      HEAP32[(($st$8$0)>>2)]=$24$0;
      var $st$8$1=(($result+4)|0);
      HEAP32[(($st$8$1)>>2)]=$24$1;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 7;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $st$3$0=(($3)|0);
      var $34$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $34$1=HEAP32[(($st$3$1)>>2)];
      var $35=$offsbits;
      var $36$0=$35;
      var $36$1=0;
      var $37=Runtime.bitshift64($34$0, $34$1,"lshr",$36$0);var $37$0 = $37[0], $37$1 = $37[1];
      var $38$0=$37$0;
      var $38=$38$0&255;
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $43, $44);
      var $46$0=$45;
      var $46$1=0;
      var $47=$offsbits;
      var $48$0=$47;
      var $48$1=0;
      var $49=Runtime.bitshift64($46$0, $46$1,"shl",$48$0);var $49$0 = $49[0], $49$1 = $49[1];
      var $st$9$0=(($result)|0);
      var $50$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($result+4)|0);
      var $50$1=HEAP32[(($st$9$1)>>2)];
      var $51$0=$50$0 | $49$0;
      var $51$1=$50$1 | $49$1;
      var $st$15$0=(($result)|0);
      HEAP32[(($st$15$0)>>2)]=$51$0;
      var $st$15$1=(($result+4)|0);
      HEAP32[(($st$15$1)>>2)]=$51$1;
      __label__ = 6; break;
    case 6: // $52
      var $53=$offsbits;
      var $54=(($53+8)|0);
      $offsbits=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$index;
      var $57=(($56+1)|0);
      $index=$57;
      __label__ = 3; break;
    case 8: // $58
      var $st$0$0=(($result)|0);
      var $59$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $59$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$59$0,$59$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$3;
      var $10=$offsbits;
      var $11=$9 << $10;
      var $12=(($11) & 255);
      $curmask=$12;
      var $13=$curmask;
      var $14=(($13)&255);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$2;
      var $18=$curmask;
      var $19=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $17, $18);
      var $20=(($19)&255);
      var $21=$offsbits;
      var $22=$20 >> (($21)|0);
      $result=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$offsbits;
      var $25=((8-$24)|0);
      $offsbits=$25;
      $index=0;
      __label__ = 3; break;
    case 3: // $26
      var $27=$index;
      var $28=(($27)>>>0) < 3;
      if ($28) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      var $32=$3;
      var $33=$offsbits;
      var $34=$32 >>> (($33)>>>0);
      var $35=(($34) & 255);
      $curmask=$35;
      var $36=$curmask;
      var $37=(($36)&255);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$2;
      var $41=$curmask;
      var $42=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $40, $41);
      var $43=(($42)&255);
      var $44=$offsbits;
      var $45=$43 << $44;
      var $46=$result;
      var $47=$46 | $45;
      $result=$47;
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+8)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$offsbits;
      var $56=(($55)>>>0) < 32;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$3;
      var $59=$offsbits;
      var $60=$58 >>> (($59)>>>0);
      var $61=(($60) & 255);
      $curmask=$61;
      var $62=$curmask;
      var $63=(($62)&255);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $65
      var $66=$2;
      var $67=(($66+1)|0);
      var $68=$curmask;
      var $69=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $67, $68);
      var $70=(($69)&255);
      var $71=$offsbits;
      var $72=$70 << $71;
      var $73=$result;
      var $74=$73 | $72;
      $result=$74;
      __label__ = 11; break;
    case 11: // $75
      __label__ = 12; break;
    case 12: // $76
      var $77=$result;
      ;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=4;
      $TARGET_BITS=32;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=3;
      $result=0;
      var $9=$3;
      var $10=$offsbits;
      var $11=$9 << $10;
      var $12=(($11) & 255);
      $curmask=$12;
      var $13=$curmask;
      var $14=(($13)&255);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$2;
      var $18=$curmask;
      var $19=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $17, $18);
      var $20=(($19)&255);
      var $21=$offsbits;
      var $22=$20 >> (($21)|0);
      $result=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=$offsbits;
      var $25=((8-$24)|0);
      $offsbits=$25;
      $index=0;
      __label__ = 3; break;
    case 3: // $26
      var $27=$index;
      var $28=(($27)>>>0) < 3;
      if ($28) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      var $32=$3;
      var $33=$offsbits;
      var $34=$32 >>> (($33)>>>0);
      var $35=(($34) & 255);
      $curmask=$35;
      var $36=$curmask;
      var $37=(($36)&255);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$2;
      var $41=$curmask;
      var $42=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $40, $41);
      var $43=(($42)&255);
      var $44=$offsbits;
      var $45=$43 << $44;
      var $46=$result;
      var $47=$46 | $45;
      $result=$47;
      __label__ = 6; break;
    case 6: // $48
      var $49=$offsbits;
      var $50=(($49+8)|0);
      $offsbits=$50;
      __label__ = 7; break;
    case 7: // $51
      var $52=$index;
      var $53=(($52+1)|0);
      $index=$53;
      __label__ = 3; break;
    case 8: // $54
      var $55=$result;
      ;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$3;
      var $10=(($9)&65535);
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24=(($23) & 65535);
      $result=$24;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $34=$3;
      var $35=(($34)&65535);
      var $36=$offsbits;
      var $37=$35 >> (($36)|0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=(($50)&65535);
      var $52=$51 | $49;
      var $53=(($52) & 65535);
      $result=$53;
      __label__ = 6; break;
    case 6: // $54
      var $55=$offsbits;
      var $56=(($55+8)|0);
      $offsbits=$56;
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $61=$offsbits;
      var $62=(($61)>>>0) < 16;
      if ($62) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $63
      var $64=$3;
      var $65=(($64)&65535);
      var $66=$offsbits;
      var $67=$65 >> (($66)|0);
      var $68=(($67) & 255);
      $curmask=$68;
      var $69=$curmask;
      var $70=(($69)&255);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      var $75=$curmask;
      var $76=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $74, $75);
      var $77=(($76)&255);
      var $78=(($77)&65535);
      var $79=$offsbits;
      var $80=$78 << $79;
      var $81=$result;
      var $82=(($81)&65535);
      var $83=$82 | $80;
      var $84=(($83) & 65535);
      $result=$84;
      __label__ = 11; break;
    case 11: // $85
      __label__ = 12; break;
    case 12: // $86
      var $87=$result;
      ;
      return $87;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($this, $address, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $TARGET_BYTES;
      var $TARGET_BITS;
      var $offsbits;
      var $MAX_SPLITS_MINUS_ONE;
      var $result;
      var $curmask;
      var $index;
      $1=$this;
      $2=$address;
      $3=$mask;
      var $4=$1;
      $TARGET_BYTES=2;
      $TARGET_BITS=16;
      var $5=$2;
      var $6=$5 & 0;
      var $7=((($6<<3))|0);
      $offsbits=$7;
      var $8=$2;
      $2=$8;
      $MAX_SPLITS_MINUS_ONE=1;
      $result=0;
      var $9=$3;
      var $10=(($9)&65535);
      var $11=$offsbits;
      var $12=$10 << $11;
      var $13=(($12) & 255);
      $curmask=$13;
      var $14=$curmask;
      var $15=(($14)&255);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=$curmask;
      var $20=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $18, $19);
      var $21=(($20)&255);
      var $22=$offsbits;
      var $23=$21 >> (($22)|0);
      var $24=(($23) & 65535);
      $result=$24;
      __label__ = 2; break;
    case 2: // $25
      var $26=$offsbits;
      var $27=((8-$26)|0);
      $offsbits=$27;
      $index=0;
      __label__ = 3; break;
    case 3: // $28
      var $29=$index;
      var $30=(($29)>>>0) < 1;
      if ($30) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $31
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      var $34=$3;
      var $35=(($34)&65535);
      var $36=$offsbits;
      var $37=$35 >> (($36)|0);
      var $38=(($37) & 255);
      $curmask=$38;
      var $39=$curmask;
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=$2;
      var $44=$curmask;
      var $45=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh($4, $43, $44);
      var $46=(($45)&255);
      var $47=(($46)&65535);
      var $48=$offsbits;
      var $49=$47 << $48;
      var $50=$result;
      var $51=(($50)&65535);
      var $52=$51 | $49;
      var $53=(($52) & 65535);
      $result=$53;
      __label__ = 6; break;
    case 6: // $54
      var $55=$offsbits;
      var $56=(($55+8)|0);
      $offsbits=$56;
      __label__ = 7; break;
    case 7: // $57
      var $58=$index;
      var $59=(($58+1)|0);
      $index=$59;
      __label__ = 3; break;
    case 8: // $60
      var $61=$result;
      ;
      return $61;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_["X"]=1;

function __ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $byteaddress;
      var $entry;
      var $handler;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 259);
      var $4=$2;
      var $5=$3;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$4 & $7;
      $byteaddress=$8;
      var $9=$byteaddress;
      var $10=__ZNK22address_space_specificIhL12endianness_t0ELb1EE11read_lookupEj($3, $9);
      $entry=$10;
      var $11=(($3+68)|0);
      var $12=$entry;
      var $13=__ZNK18address_table_read12handler_readEj($11, $12);
      $handler=$13;
      var $14=$handler;
      var $15=$14;
      var $16=$byteaddress;
      var $17=__ZNK13handler_entry10byteoffsetEj($15, $16);
      $2=$17;
      var $18=$entry;
      var $19=(($18)>>>0) <= 124;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$handler;
      var $22=$21;
      var $23=$2;
      var $24=__ZNK13handler_entry6ramptrEj($22, $23);
      var $25=HEAP8[($24)];
      $result=$25;
      __label__ = 3; break;
    case 2: // $26
      var $27=$handler;
      var $28=$3;
      var $29=$2;
      var $30=__ZNK18handler_entry_read5read8ER13address_spacejh($27, $28, $29, -1);
      $result=$30;
      __label__ = 3; break;
    case 3: // $31
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $32=$result;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE16read_byte_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEj($3, $4);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE16read_word_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($3, $4, -1);
  var $6=(($5)&65535);
  var $7=(($6) & 65535);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE17read_dword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($3, $4, -1);
  ;
  return $5;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj($space, $address, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$mask;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_($4, $5, $6);
  ;
  return $7;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE17read_qword_staticEPS1_j($space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$address;
  var $3=$1;
  var $4=$2;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $5=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($3, $4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy($space, $address, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$mask$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $7=__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_($4, $5, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  STACKTOP = __stackBase__;
  return [$7$0,$7$1];
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE17write_byte_staticEPS1_jh($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjh($4, $5, $6);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE17write_word_staticEPS1_jt($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE18write_dword_staticEPS1_jj($space, $address, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$address;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($4, $5, $6, -1);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj($space, $address, $data, $mask) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$space;
  $2=$address;
  $3=$data;
  $4=$mask;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_($5, $6, $7, $8);
  ;
  return;
}


function __ZL11tagmap_hashPKc3112($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE18write_qword_staticEPS1_jy($space, $address, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$space;
  $2=$address;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$data$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$data$1;
  var $4=$1;
  var $5=$2;
  var $st$11$0=(($3)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($4, $5, $6$0, $6$1, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy($space, $address, $data$0, $data$1, $mask$0, $mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $1=$space;
  $2=$address;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$data$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$data$1;
  var $st$10$0=(($4)|0);
  HEAP32[(($st$10$0)>>2)]=$mask$0;
  var $st$10$1=(($4+4)|0);
  HEAP32[(($st$10$1)>>2)]=$mask$1;
  var $5=$1;
  var $6=$2;
  var $st$16$0=(($3)|0);
  var $7$0=HEAP32[(($st$16$0)>>2)];
  var $st$16$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$16$1)>>2)];
  var $st$20$0=(($4)|0);
  var $8$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($4+4)|0);
  var $8$1=HEAP32[(($st$20$1)>>2)];
  __ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_($5, $6, $7$0, $7$1, $8$0, $8$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20resource_pool_objectI16direct_read_dataEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16direct_read_dataEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16direct_read_dataEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 5192);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16direct_read_dataE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16direct_read_dataED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16direct_read_dataED2Ev($2);
  ;
  return;
}


function __ZL11tagmap_findPK7_tagmapPKc3110($map, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$map;
  $2=$tag;
  var $3=$1;
  var $4=$2;
  var $5=$2;
  var $6=__ZL11tagmap_hashPKc3112($5);
  var $7=__ZL21tagmap_find_prehashedPK7_tagmapPKcj3111($3, $4, $6);
  ;
  return $7;
}


function __ZL21tagmap_find_prehashedPK7_tagmapPKcj3111($map, $tag, $fullhash) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $entry;
      $2=$map;
      $3=$tag;
      $4=$fullhash;
      var $5=$4;
      var $6=(($5)>>>0)%97;
      var $7=$2;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      $entry=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $14
      var $15=$entry;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$4;
      var $19=(($17)|0)==(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=$entry;
      var $22=(($21+12)|0);
      var $23=(($22)|0);
      var $24=$3;
      var $25=_strcmp($23, $24);
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$entry;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      $1=$30;
      __label__ = 8; break;
    case 5: // $31
      __label__ = 6; break;
    case 6: // $32
      var $33=$entry;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      $entry=$35;
      __label__ = 1; break;
    case 7: // $36
      $1=0;
      __label__ = 8; break;
    case 8: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21tagmap_find_hash_onlyPK7_tagmapPKc3113($map, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fullhash;
      var $entry;
      $2=$map;
      $3=$tag;
      var $4=$3;
      var $5=__ZL11tagmap_hashPKc3112($4);
      $fullhash=$5;
      var $6=$fullhash;
      var $7=(($6)>>>0)%97;
      var $8=$2;
      var $9=(($8)|0);
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $entry=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$entry;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $15
      var $16=$entry;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$fullhash;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$entry;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      $1=$24;
      __label__ = 7; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$entry;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      $entry=$29;
      __label__ = 1; break;
    case 6: // $30
      $1=0;
      __label__ = 7; break;
    case 7: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t4nextI23device_memory_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceERP23device_memory_interface($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI15_memory_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI15_memory_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI15_memory_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1868);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI15_memory_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI15_memory_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI15_memory_privateED2Ev($2);
  ;
  return;
}


function __ZN15_memory_privateD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15_memory_privateD2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP12memory_shareED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP12memory_shareED2Ev($2);
  ;
  return;
}


function __ZN22address_space_specificIhL12endianness_t0ELb1EED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22address_space_specificIhL12endianness_t0ELb1EE+8)|0);
      var $6=(($4+1444)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN19address_table_writeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN13address_spaceD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18address_table_readD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN13address_spaceD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI16direct_read_dataED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16direct_read_dataED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16direct_read_dataED0Ev["X"]=1;

function __ZN20resource_pool_objectI16direct_read_dataED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI16direct_read_dataE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16direct_read_dataD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16direct_read_dataED2Ev["X"]=1;

function __ZN20resource_pool_objectI15_memory_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI15_memory_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI15_memory_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI15_memory_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI15_memory_privateE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN15_memory_privateD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI15_memory_privateED2Ev["X"]=1;

function __ZN15_memory_privateD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+1480)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP12memory_shareED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $6
      var $7=(($4+1088)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP11memory_bankED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=(($4+1068)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11memory_bankED1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $10
      var $11=(($4+1048)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12memory_blockED1Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $12
      var $13=(($4+1028)|0);
      __ZN11simple_listI13address_spaceED1Ev($13);
      ;
      return;
    case 5: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $2=$16;
      var $17=$15.f1;
      $3=$17;
      var $18=(($4+1088)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP11memory_bankED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 17; break; }
    case 6: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $2=$21;
      var $22=$20.f1;
      $3=$22;
      __label__ = 9; break;
    case 7: // $23
      __label__ = 9; break;
    case 8: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $2=$26;
      var $27=$25.f1;
      $3=$27;
      __label__ = 12; break;
    case 9: // $28
      var $29=(($4+1068)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11memory_bankED1Ev($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $30
      __label__ = 12; break;
    case 11: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $2=$33;
      var $34=$32.f1;
      $3=$34;
      __label__ = 14; break;
    case 12: // $35
      var $36=(($4+1048)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12memory_blockED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $37
      __label__ = 14; break;
    case 14: // $38
      var $39=(($4+1028)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI13address_spaceED1Ev($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $40
      __label__ = 16; break;
    case 16: // $41
      var $42=$2;
      var $43=$2;
      var $44=$3;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15_memory_privateD2Ev["X"]=1;

function __ZN11simple_listI13address_spaceE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI13address_spaceE6detachERS0_["X"]=1;

function __ZN11simple_listI12memory_blockE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12memory_blockE6detachERS0_["X"]=1;

function __ZN11simple_listI11memory_bankE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11memory_bankE6detachERS0_["X"]=1;

function __ZN11memory_bank14bank_referenceC2ER13address_space13read_or_write($this, $space, $readorwrite) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$space;
  $3=$readorwrite;
  var $4=$1;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($4+4)|0);
  var $7=$2;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($4+8)|0);
  var $9=$3;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZNK11simple_listI13memory_regionE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN16direct_read_data12direct_rangeC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=-1;
  ;
  return;
}


function __ZN8tagmap_tIP11memory_bankED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP11memory_bankED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI11memory_bankED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI11memory_bankED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI12memory_blockED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI12memory_blockED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI13address_spaceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI13address_spaceED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI13address_spaceED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI13address_spaceE+8)|0);
  __ZN11simple_listI13address_spaceE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI13address_spaceE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI13address_spaceE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI13address_spaceE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI13address_spaceE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI12memory_blockED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI12memory_blockE+8)|0);
  __ZN11simple_listI12memory_blockE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI12memory_blockE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI12memory_blockE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12memory_blockE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI12memory_blockE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI11memory_bankED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI11memory_bankE+8)|0);
  __ZN11simple_listI11memory_bankE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI11memory_bankE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI11memory_bankE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11memory_bankE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI11memory_bankE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8tagmap_tIP11memory_bankED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP11memory_bankE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP11memory_bankE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN8tagmap_tIP12memory_shareED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP12memory_shareE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIP12memory_shareE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN19handler_entry_writeD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13handler_entryD2Ev($3);
  ;
  return;
}


function __ZN18handler_entry_readD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13handler_entryD2Ev($3);
  ;
  return;
}


function __ZNK11tagged_listI13memory_regionE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listI13memory_regionE5firstEv($3);
  ;
  return $4;
}


function __ZN19handler_entry_write14access_handlerC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19handler_entry_write14access_handlerC2Ev($2);
  ;
  return;
}


function __ZN19handler_entry_write14access_handlerC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN8delegateIFvR13address_spacejhhEEC1Ev($3);
  var $4=(($2+24)|0);
  __ZN8delegateIFvR13address_spacejttEEC1Ev($4);
  var $5=(($2+48)|0);
  __ZN8delegateIFvR13address_spacejjjEEC1Ev($5);
  var $6=(($2+72)|0);
  __ZN8delegateIFvR13address_spacejyyEEC1Ev($6);
  ;
  return;
}


function __ZN11simple_listI13address_spaceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI13address_spaceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI13address_spaceED0Ev["X"]=1;

function __ZN11simple_listI12memory_blockED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI12memory_blockED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12memory_blockED0Ev["X"]=1;

function __ZN11simple_listI11memory_bankED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI11memory_bankED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11memory_bankED0Ev["X"]=1;

function __ZN19handler_entry_writeC2Eh12endianness_tPPh($this, $width, $endianness, $rambaseptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$width;
      $3=$endianness;
      $4=$rambaseptr;
      var $7=$1;
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      __ZN13handler_entryC2Eh12endianness_tPPh($8, $9, $10, $11);
      var $12=$7;
      HEAP32[(($12)>>2)]=((__ZTV19handler_entry_write+8)|0);
      var $13=(($7+168)|0);
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write14access_handlerC1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $14
      var $15=(($7+264)|0);
      var $16=(($15)|0);
      var $17=(($16+768)|0);
      var $19 = $16;__label__ = 2; break;
    case 2: // $18
      var $19;
      (function() { try { __THREW__ = false; return __ZN19handler_entry_write14access_handlerC1Ev($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=(($19+96)|0);
      var $22=(($21)|0)==(($17)|0);
      if ($22) { __label__ = 4; break; } else { var $19 = $21;__label__ = 2; break; }
    case 4: // $23
      var $24=(($7+1044)|0);
      var $25=(($7+1052)|0);
      var $26=(($7+1044)|0);
      var $27=$26;
      HEAP8[($27)]=0; HEAP8[($27+1)]=0; HEAP8[($27+2)]=0; HEAP8[($27+3)]=0; HEAP8[($27+4)]=0; HEAP8[($27+5)]=0; HEAP8[($27+6)]=0; HEAP8[($27+7)]=0;
      ;
      return;
    case 5: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $5=$30;
      var $31=$29.f1;
      $6=$31;
      var $32=$7;
      (function() { try { __THREW__ = false; return __ZN13handler_entryD2Ev($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$5;
      var $36=$5;
      var $37=$6;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19handler_entry_writeC2Eh12endianness_tPPh["X"]=1;
// WARNING: content after a branch in a label, line: 425081
// WARNING: content after a branch in a label, line: 425083
// WARNING: content after a branch in a label, line: 425084
// WARNING: content after a branch in a label, line: 425085
// WARNING: content after a branch in a label, line: 425086
// WARNING: content after a branch in a label, line: 425087

function __ZN13handler_entry11deconfigureEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  HEAP8[($3)]=0;
  var $4=(($2+28)|0);
  HEAP8[($4)]=0;
  ;
  return;
}


function __ZN12_GLOBAL__N_18subrangeC2Ejj($this, $_start, $_end) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$_start;
  $3=$_end;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  ;
  return;
}


function __ZN13address_table13subtable_dataC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP8[($3)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  ;
  return;
}


function __ZN18handler_entry_read14access_handlerC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18handler_entry_read14access_handlerC2Ev($2);
  ;
  return;
}


function __ZN18handler_entry_read14access_handlerC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN8delegateIFhR13address_spacejhEEC1Ev($3);
  var $4=(($2+24)|0);
  __ZN8delegateIFtR13address_spacejtEEC1Ev($4);
  var $5=(($2+48)|0);
  __ZN8delegateIFjR13address_spacejjEEC1Ev($5);
  var $6=(($2+72)|0);
  __ZN8delegateIFyR13address_spacejyEEC1Ev($6);
  ;
  return;
}


function __ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE5clearEv($2);
  ;
  return;
}


function __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  FUNCTION_TABLE[__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEED1Ev]($3);
  ;
  return;
}


function __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7;
  $7=$this;
  var $8=$7;
  var $9=$6;
  HEAP32[(($6)>>2)]=$8;
  var $10=HEAP32[(($6)>>2)];
  var $11=$5;
  HEAP32[(($5)>>2)]=$10;
  var $12=HEAP32[(($5)>>2)];
  var $13=(($12+4)|0);
  var $14=$4;
  HEAP32[(($4)>>2)]=$13;
  var $15=HEAP32[(($4)>>2)];
  var $16=$15;
  var $17=$3;
  HEAP32[(($3)>>2)]=$16;
  var $18=HEAP32[(($3)>>2)];
  var $19=(($18)|0);
  var $20=$3;
  var $21=$4;
  var $22=$2;
  HEAP32[(($2)>>2)]=$19;
  var $23=HEAP32[(($2)>>2)];
  var $24=$1;
  HEAP32[(($1)>>2)]=$23;
  var $25=HEAP32[(($1)>>2)];
  var $26=$25;
  var $27=$26;
  var $28=$1;
  var $29=$2;
  var $30=$27;
  var $31=$5;
  var $32=$30;
  var $33=(($32)|0);
  var $34=HEAP32[(($33)>>2)];
  var $35=$34;
  var $36=$6;
  __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE($8, $35);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__14pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  FUNCTION_TABLE[__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED1Ev]($3);
  ;
  return;
}


function __ZN19handler_entry_proxyI19handler_entry_writeED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED1Ev($3);
  ;
  return;
}


function __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev($2);
  ;
  return;
}


function __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev($3);
  ;
  return;
}


function __ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEE5clearEv($2);
  ;
  return;
}


function __ZN18handler_entry_readC2Eh12endianness_tPPh($this, $width, $endianness, $rambaseptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$width;
      $3=$endianness;
      $4=$rambaseptr;
      var $7=$1;
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      __ZN13handler_entryC2Eh12endianness_tPPh($8, $9, $10, $11);
      var $12=$7;
      HEAP32[(($12)>>2)]=((__ZTV18handler_entry_read+8)|0);
      var $13=(($7+168)|0);
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read14access_handlerC1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $14
      var $15=(($7+264)|0);
      var $16=(($15)|0);
      var $17=(($16+768)|0);
      var $19 = $16;__label__ = 2; break;
    case 2: // $18
      var $19;
      (function() { try { __THREW__ = false; return __ZN18handler_entry_read14access_handlerC1Ev($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=(($19+96)|0);
      var $22=(($21)|0)==(($17)|0);
      if ($22) { __label__ = 4; break; } else { var $19 = $21;__label__ = 2; break; }
    case 4: // $23
      var $24=(($7+1044)|0);
      var $25=(($7+1052)|0);
      var $26=(($7+1044)|0);
      var $27=$26;
      HEAP8[($27)]=0; HEAP8[($27+1)]=0; HEAP8[($27+2)]=0; HEAP8[($27+3)]=0; HEAP8[($27+4)]=0; HEAP8[($27+5)]=0; HEAP8[($27+6)]=0; HEAP8[($27+7)]=0;
      ;
      return;
    case 5: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $5=$30;
      var $31=$29.f1;
      $6=$31;
      var $32=$7;
      (function() { try { __THREW__ = false; return __ZN13handler_entryD2Ev($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$5;
      var $36=$5;
      var $37=$6;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18handler_entry_readC2Eh12endianness_tPPh["X"]=1;

function __ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE5clearEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 156; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38;
      var $__na;
      var $__f=__stackBase__+148;
      var $__l=__stackBase__+152;
      var $39;
      var $40;
      var $__n;
      $38=$this;
      var $41=$38;
      var $42=$37;
      HEAP32[(($37)>>2)]=$41;
      var $43=HEAP32[(($37)>>2)];
      var $44=$36;
      HEAP32[(($36)>>2)]=$43;
      var $45=HEAP32[(($36)>>2)];
      var $46=(($45+8)|0);
      var $47=$35;
      HEAP32[(($35)>>2)]=$46;
      var $48=HEAP32[(($35)>>2)];
      var $49=$48;
      var $50=$34;
      HEAP32[(($34)>>2)]=$49;
      var $51=HEAP32[(($34)>>2)];
      var $52=(($51)|0);
      var $53=$34;
      var $54=$35;
      var $55=$36;
      var $56=HEAP32[(($52)>>2)];
      var $57=(($56)|0)==0;
      var $58=$37;
      if ($57) { __label__ = 13; break; } else { __label__ = 1; break; }
    case 1: // $59
      var $60=$24;
      HEAP32[(($24)>>2)]=$41;
      var $61=HEAP32[(($24)>>2)];
      var $62=(($61+8)|0);
      var $63=$23;
      HEAP32[(($23)>>2)]=$62;
      var $64=HEAP32[(($23)>>2)];
      var $65=$64;
      var $66=$22;
      HEAP32[(($22)>>2)]=$65;
      var $67=HEAP32[(($22)>>2)];
      var $68=$67;
      var $69=$22;
      var $70=$23;
      var $71=$24;
      $__na=$68;
      var $72=$21;
      HEAP32[(($21)>>2)]=$41;
      var $73=HEAP32[(($21)>>2)];
      var $74=(($73)|0);
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      FUNCTION_TABLE[__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPNS_11__list_nodeIS2_S3_EE]($__f, $76);
      var $77=$21;
      var $78=$20;
      HEAP32[(($20)>>2)]=$41;
      var $79=HEAP32[(($20)>>2)];
      var $80=(($79)|0);
      var $81=$80;
      FUNCTION_TABLE[__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPNS_11__list_nodeIS2_S3_EE]($__l, $81);
      var $82=$20;
      var $83=(($__f)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$84;
      var $86=(($__l)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$87;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$90;
      var $92=$18;
      var $93=$19;
      HEAP32[(($18)>>2)]=$85;
      HEAP32[(($19)>>2)]=$91;
      var $94=HEAP32[(($19)>>2)];
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=HEAP32[(($18)>>2)];
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$99;
      var $101=(($100+4)|0);
      HEAP32[(($101)>>2)]=$96;
      var $102=HEAP32[(($18)>>2)];
      var $103=(($102)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=HEAP32[(($19)>>2)];
      var $106=(($105+4)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$107;
      var $109=(($108)|0);
      HEAP32[(($109)>>2)]=$104;
      var $110=$18;
      var $111=$19;
      var $112=$3;
      HEAP32[(($3)>>2)]=$41;
      var $113=HEAP32[(($3)>>2)];
      var $114=(($113+8)|0);
      var $115=$2;
      HEAP32[(($2)>>2)]=$114;
      var $116=HEAP32[(($2)>>2)];
      var $117=$116;
      var $118=$1;
      HEAP32[(($1)>>2)]=$117;
      var $119=HEAP32[(($1)>>2)];
      var $120=(($119)|0);
      var $121=$1;
      var $122=$2;
      var $123=$3;
      HEAP32[(($120)>>2)]=0;
      __label__ = 2; break;
    case 2: // $124
      var $125=$6;
      var $126=$7;
      HEAP32[(($6)>>2)]=$__f;
      HEAP32[(($7)>>2)]=$__l;
      var $127=HEAP32[(($6)>>2)];
      var $128=HEAP32[(($7)>>2)];
      var $129=$4;
      var $130=$5;
      HEAP32[(($4)>>2)]=$127;
      HEAP32[(($5)>>2)]=$128;
      var $131=HEAP32[(($4)>>2)];
      var $132=(($131)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=HEAP32[(($5)>>2)];
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($133)|0)==(($136)|0);
      var $138=$4;
      var $139=$5;
      var $140=$137 ^ 1;
      var $141=$6;
      var $142=$7;
      __label__ = 3; break;
    case 3: // $143
      if ($140) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $144
      var $145=(($__f)|0);
      var $146=HEAP32[(($145)>>2)];
      $__n=$146;
      var $147=$8;
      HEAP32[(($8)>>2)]=$__f;
      var $148=HEAP32[(($8)>>2)];
      var $149=(($148)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$150;
      var $152=(($151+4)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($148)|0);
      HEAP32[(($154)>>2)]=$153;
      var $155=$8;
      __label__ = 5; break;
    case 5: // $156
      var $157=$__na;
      var $158=$__n;
      var $159=(($158+8)|0);
      var $160=$9;
      HEAP32[(($9)>>2)]=$159;
      var $161=HEAP32[(($9)>>2)];
      var $162=$161;
      var $163=$162;
      var $164=$9;
      var $165=$12;
      var $166=$13;
      var $167=$14;
      var $168=$15;
      var $169=$16;
      HEAP32[(($13)>>2)]=$157;
      HEAP32[(($14)>>2)]=$163;
      var $170=$16;
      var $171=HEAP32[(($13)>>2)];
      var $172=HEAP32[(($14)>>2)];
      var $tmp_i=$12;
      var $tmp1_i=$15;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $173=$10;
      var $174=$11;
      HEAP32[(($10)>>2)]=$171;
      HEAP32[(($11)>>2)]=$172;
      var $175=HEAP32[(($11)>>2)];
      var $176=$10;
      var $177=$11;
      var $178=$12;
      var $179=$13;
      var $180=$14;
      var $181=$15;
      var $182=$16;
      __label__ = 6; break;
    case 6: // $183
      var $184=$__na;
      var $185=$__n;
      var $186=$17;
      HEAP32[(($17)>>2)]=$185;
      var $187=HEAP32[(($17)>>2)];
      var $188=$187;
      var $189=$188;
      var $190=$17;
      var $191=$31;
      var $192=$32;
      var $193=$33;
      HEAP32[(($31)>>2)]=$184;
      HEAP32[(($32)>>2)]=$189;
      HEAP32[(($33)>>2)]=1;
      var $194=HEAP32[(($31)>>2)];
      var $195=HEAP32[(($32)>>2)];
      var $196=HEAP32[(($33)>>2)];
      var $197=$28;
      var $198=$29;
      var $199=$30;
      HEAP32[(($28)>>2)]=$194;
      HEAP32[(($29)>>2)]=$195;
      HEAP32[(($30)>>2)]=$196;
      var $200=HEAP32[(($28)>>2)];
      var $201=HEAP32[(($29)>>2)];
      var $202=$201;
      var $203=$25;
      var $204=$26;
      var $205=$27;
      HEAP32[(($25)>>2)]=$202;
      var $206=HEAP32[(($25)>>2)];
      var $207=(($206)|0)!=0;
      if ($207) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $208
      var $209=HEAP32[(($25)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($209, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $210
      __label__ = 10; break;
    case 9: // $211
      var $212=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $213=$212.f0;
      HEAP32[(($26)>>2)]=$213;
      var $214=$212.f1;
      HEAP32[(($27)>>2)]=$214;
      var $215=HEAP32[(($26)>>2)];
      ___cxa_call_unexpected($215);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEE10deallocateERS7_PS6_j_exit
      var $216=$25;
      var $217=$26;
      var $218=$27;
      var $219=$28;
      var $220=$29;
      var $221=$30;
      var $222=$31;
      var $223=$32;
      var $224=$33;
      __label__ = 2; break;
    case 11: // $229
      var $230=$39;
      ___cxa_call_unexpected($230);
      throw "Reached an unreachable!"
    case 12: // $231
      __label__ = 13; break;
    case 13: // $232
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE5clearEv["X"]=1;

function __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE($this, $__nd) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26;
      var $27;
      var $28=__stackBase__+100;
      var $29;
      var $30;
      var $__na;
      $26=$this;
      $27=$__nd;
      var $31=$26;
      var $32=$27;
      var $33=$24;
      var $34=$25;
      HEAP32[(($24)>>2)]=$28;
      HEAP32[(($25)>>2)]=-1;
      var $35=HEAP32[(($24)>>2)];
      var $36=HEAP32[(($25)>>2)];
      var $37=$22;
      var $38=$23;
      HEAP32[(($22)>>2)]=$35;
      HEAP32[(($23)>>2)]=$36;
      var $39=HEAP32[(($22)>>2)];
      var $40=$22;
      var $41=$23;
      var $42=$24;
      var $43=$25;
      __label__ = 1; break;
    case 1: // $44
      var $45=$21;
      HEAP32[(($21)>>2)]=$28;
      var $46=HEAP32[(($21)>>2)];
      var $47=$21;
      __label__ = 2; break;
    case 2: // $48
      var $49=(($32)|0)!=0;
      if ($49) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $50
      var $51=$27;
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$54;
      __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE($31, $55);
      var $56=$27;
      var $57=$56;
      var $58=(($57+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$59;
      __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE($31, $60);
      var $61=$4;
      HEAP32[(($4)>>2)]=$31;
      var $62=HEAP32[(($4)>>2)];
      var $63=(($62+4)|0);
      var $64=$3;
      HEAP32[(($3)>>2)]=$63;
      var $65=HEAP32[(($3)>>2)];
      var $66=$65;
      var $67=$2;
      HEAP32[(($2)>>2)]=$66;
      var $68=HEAP32[(($2)>>2)];
      var $69=$68;
      var $70=$2;
      var $71=$3;
      var $72=$4;
      $__na=$69;
      var $73=$__na;
      var $74=$27;
      var $75=(($74+16)|0);
      var $76=$1;
      HEAP32[(($1)>>2)]=$75;
      var $77=HEAP32[(($1)>>2)];
      var $78=$77;
      var $79=$78;
      var $80=$1;
      var $81=$7;
      var $82=$8;
      var $83=$9;
      var $84=$10;
      var $85=$11;
      HEAP32[(($8)>>2)]=$73;
      HEAP32[(($9)>>2)]=$79;
      var $86=$11;
      var $87=HEAP32[(($8)>>2)];
      var $88=HEAP32[(($9)>>2)];
      var $tmp_i=$7;
      var $tmp1_i=$10;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $89=$5;
      var $90=$6;
      HEAP32[(($5)>>2)]=$87;
      HEAP32[(($6)>>2)]=$88;
      var $91=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__14pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEEED1Ev]($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE7destroyIS9_EEvRSC_PT__exit
      var $92=$5;
      var $93=$6;
      var $94=$7;
      var $95=$8;
      var $96=$9;
      var $97=$10;
      var $98=$11;
      __label__ = 5; break;
    case 5: // $99
      var $100=$__na;
      var $101=$27;
      var $102=$18;
      var $103=$19;
      var $104=$20;
      HEAP32[(($18)>>2)]=$100;
      HEAP32[(($19)>>2)]=$101;
      HEAP32[(($20)>>2)]=1;
      var $105=HEAP32[(($18)>>2)];
      var $106=HEAP32[(($19)>>2)];
      var $107=HEAP32[(($20)>>2)];
      var $108=$15;
      var $109=$16;
      var $110=$17;
      HEAP32[(($15)>>2)]=$105;
      HEAP32[(($16)>>2)]=$106;
      HEAP32[(($17)>>2)]=$107;
      var $111=HEAP32[(($15)>>2)];
      var $112=HEAP32[(($16)>>2)];
      var $113=$112;
      var $114=$12;
      var $115=$13;
      var $116=$14;
      HEAP32[(($12)>>2)]=$113;
      var $117=HEAP32[(($12)>>2)];
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $119
      var $120=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($120, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $121
      __label__ = 9; break;
    case 8: // $122
      var $123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $124=$123.f0;
      HEAP32[(($13)>>2)]=$124;
      var $125=$123.f1;
      HEAP32[(($14)>>2)]=$125;
      var $126=HEAP32[(($13)>>2)];
      ___cxa_call_unexpected($126);
      throw "Reached an unreachable!"
    case 9: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEE10deallocateERSC_PSB_j_exit
      var $127=$12;
      var $128=$13;
      var $129=$14;
      var $130=$15;
      var $131=$16;
      var $132=$17;
      var $133=$18;
      var $134=$19;
      var $135=$20;
      __label__ = 12; break;
    case 10: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      $29=$138;
      var $139=$137.f1;
      $30=$139;
      __label__ = 11; break;
    case 11: // $140
      var $141=$29;
      ___cxa_call_unexpected($141);
      throw "Reached an unreachable!"
    case 12: // $142
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE["X"]=1;
// WARNING: content after a branch in a label, line: 425937
// WARNING: content after a branch in a label, line: 425939
// WARNING: content after a branch in a label, line: 425940
// WARNING: content after a branch in a label, line: 425941
// WARNING: content after a branch in a label, line: 425942
// WARNING: content after a branch in a label, line: 425943

function __ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEE5clearEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 188; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46;
      var $__na;
      var $__f=__stackBase__+180;
      var $__l=__stackBase__+184;
      var $47;
      var $48;
      var $__n;
      $46=$this;
      var $49=$46;
      var $50=$45;
      HEAP32[(($45)>>2)]=$49;
      var $51=HEAP32[(($45)>>2)];
      var $52=$44;
      HEAP32[(($44)>>2)]=$51;
      var $53=HEAP32[(($44)>>2)];
      var $54=(($53+8)|0);
      var $55=$43;
      HEAP32[(($43)>>2)]=$54;
      var $56=HEAP32[(($43)>>2)];
      var $57=$56;
      var $58=$42;
      HEAP32[(($42)>>2)]=$57;
      var $59=HEAP32[(($42)>>2)];
      var $60=(($59)|0);
      var $61=$42;
      var $62=$43;
      var $63=$44;
      var $64=HEAP32[(($60)>>2)];
      var $65=(($64)|0)==0;
      var $66=$45;
      if ($65) { __label__ = 13; break; } else { __label__ = 1; break; }
    case 1: // $67
      var $68=$32;
      HEAP32[(($32)>>2)]=$49;
      var $69=HEAP32[(($32)>>2)];
      var $70=(($69+8)|0);
      var $71=$31;
      HEAP32[(($31)>>2)]=$70;
      var $72=HEAP32[(($31)>>2)];
      var $73=$72;
      var $74=$30;
      HEAP32[(($30)>>2)]=$73;
      var $75=HEAP32[(($30)>>2)];
      var $76=$75;
      var $77=$30;
      var $78=$31;
      var $79=$32;
      $__na=$76;
      var $80=$29;
      HEAP32[(($29)>>2)]=$49;
      var $81=HEAP32[(($29)>>2)];
      var $82=(($81)|0);
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$27;
      var $86=$28;
      HEAP32[(($27)>>2)]=$__f;
      HEAP32[(($28)>>2)]=$84;
      var $87=HEAP32[(($27)>>2)];
      var $88=HEAP32[(($28)>>2)];
      var $89=$25;
      var $90=$26;
      HEAP32[(($25)>>2)]=$87;
      HEAP32[(($26)>>2)]=$88;
      var $91=HEAP32[(($25)>>2)];
      var $92=(($91)|0);
      var $93=HEAP32[(($26)>>2)];
      HEAP32[(($92)>>2)]=$93;
      var $94=$25;
      var $95=$26;
      var $96=$27;
      var $97=$28;
      var $98=$29;
      var $99=$5;
      HEAP32[(($5)>>2)]=$49;
      var $100=HEAP32[(($5)>>2)];
      var $101=(($100)|0);
      var $102=$101;
      var $103=$3;
      var $104=$4;
      HEAP32[(($3)>>2)]=$__l;
      HEAP32[(($4)>>2)]=$102;
      var $105=HEAP32[(($3)>>2)];
      var $106=HEAP32[(($4)>>2)];
      var $107=$1;
      var $108=$2;
      HEAP32[(($1)>>2)]=$105;
      HEAP32[(($2)>>2)]=$106;
      var $109=HEAP32[(($1)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($2)>>2)];
      HEAP32[(($110)>>2)]=$111;
      var $112=$1;
      var $113=$2;
      var $114=$3;
      var $115=$4;
      var $116=$5;
      var $117=(($__f)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$118;
      var $120=(($__l)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$124;
      var $126=$6;
      var $127=$7;
      HEAP32[(($6)>>2)]=$119;
      HEAP32[(($7)>>2)]=$125;
      var $128=HEAP32[(($7)>>2)];
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=HEAP32[(($6)>>2)];
      var $132=(($131)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$133;
      var $135=(($134+4)|0);
      HEAP32[(($135)>>2)]=$130;
      var $136=HEAP32[(($6)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=HEAP32[(($7)>>2)];
      var $140=(($139+4)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$141;
      var $143=(($142)|0);
      HEAP32[(($143)>>2)]=$138;
      var $144=$6;
      var $145=$7;
      var $146=$10;
      HEAP32[(($10)>>2)]=$49;
      var $147=HEAP32[(($10)>>2)];
      var $148=(($147+8)|0);
      var $149=$9;
      HEAP32[(($9)>>2)]=$148;
      var $150=HEAP32[(($9)>>2)];
      var $151=$150;
      var $152=$8;
      HEAP32[(($8)>>2)]=$151;
      var $153=HEAP32[(($8)>>2)];
      var $154=(($153)|0);
      var $155=$8;
      var $156=$9;
      var $157=$10;
      HEAP32[(($154)>>2)]=0;
      __label__ = 2; break;
    case 2: // $158
      var $159=$13;
      var $160=$14;
      HEAP32[(($13)>>2)]=$__f;
      HEAP32[(($14)>>2)]=$__l;
      var $161=HEAP32[(($13)>>2)];
      var $162=HEAP32[(($14)>>2)];
      var $163=$11;
      var $164=$12;
      HEAP32[(($11)>>2)]=$161;
      HEAP32[(($12)>>2)]=$162;
      var $165=HEAP32[(($11)>>2)];
      var $166=(($165)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=HEAP32[(($12)>>2)];
      var $169=(($168)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($167)|0)==(($170)|0);
      var $172=$11;
      var $173=$12;
      var $174=$171 ^ 1;
      var $175=$13;
      var $176=$14;
      __label__ = 3; break;
    case 3: // $177
      if ($174) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $178
      var $179=(($__f)|0);
      var $180=HEAP32[(($179)>>2)];
      $__n=$180;
      var $181=$15;
      HEAP32[(($15)>>2)]=$__f;
      var $182=HEAP32[(($15)>>2)];
      var $183=(($182)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$184;
      var $186=(($185+4)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($182)|0);
      HEAP32[(($188)>>2)]=$187;
      var $189=$15;
      __label__ = 5; break;
    case 5: // $190
      var $191=$__na;
      var $192=$__n;
      var $193=(($192+8)|0);
      var $194=$16;
      HEAP32[(($16)>>2)]=$193;
      var $195=HEAP32[(($16)>>2)];
      var $196=$195;
      var $197=$196;
      var $198=$16;
      var $199=$19;
      var $200=$20;
      var $201=$21;
      var $202=$22;
      var $203=$23;
      HEAP32[(($20)>>2)]=$191;
      HEAP32[(($21)>>2)]=$197;
      var $204=$23;
      var $205=HEAP32[(($20)>>2)];
      var $206=HEAP32[(($21)>>2)];
      var $tmp_i=$19;
      var $tmp1_i=$22;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $207=$17;
      var $208=$18;
      HEAP32[(($17)>>2)]=$205;
      HEAP32[(($18)>>2)]=$206;
      var $209=HEAP32[(($18)>>2)];
      var $210=$17;
      var $211=$18;
      var $212=$19;
      var $213=$20;
      var $214=$21;
      var $215=$22;
      var $216=$23;
      __label__ = 6; break;
    case 6: // $217
      var $218=$__na;
      var $219=$__n;
      var $220=$24;
      HEAP32[(($24)>>2)]=$219;
      var $221=HEAP32[(($24)>>2)];
      var $222=$221;
      var $223=$222;
      var $224=$24;
      var $225=$39;
      var $226=$40;
      var $227=$41;
      HEAP32[(($39)>>2)]=$218;
      HEAP32[(($40)>>2)]=$223;
      HEAP32[(($41)>>2)]=1;
      var $228=HEAP32[(($39)>>2)];
      var $229=HEAP32[(($40)>>2)];
      var $230=HEAP32[(($41)>>2)];
      var $231=$36;
      var $232=$37;
      var $233=$38;
      HEAP32[(($36)>>2)]=$228;
      HEAP32[(($37)>>2)]=$229;
      HEAP32[(($38)>>2)]=$230;
      var $234=HEAP32[(($36)>>2)];
      var $235=HEAP32[(($37)>>2)];
      var $236=$235;
      var $237=$33;
      var $238=$34;
      var $239=$35;
      HEAP32[(($33)>>2)]=$236;
      var $240=HEAP32[(($33)>>2)];
      var $241=(($240)|0)!=0;
      if ($241) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $242
      var $243=HEAP32[(($33)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($243, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $244
      __label__ = 10; break;
    case 9: // $245
      var $246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $247=$246.f0;
      HEAP32[(($34)>>2)]=$247;
      var $248=$246.f1;
      HEAP32[(($35)>>2)]=$248;
      var $249=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($249);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIP19handler_entry_writePvEEEEE10deallocateERS7_PS6_j_exit
      var $250=$33;
      var $251=$34;
      var $252=$35;
      var $253=$36;
      var $254=$37;
      var $255=$38;
      var $256=$39;
      var $257=$40;
      var $258=$41;
      __label__ = 2; break;
    case 11: // $263
      var $264=$47;
      ___cxa_call_unexpected($264);
      throw "Reached an unreachable!"
    case 12: // $265
      __label__ = 13; break;
    case 13: // $266
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEE5clearEv["X"]=1;

function __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEE9push_backERKS2_($this, $__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 488; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__t_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $__tmp_i_i_i2=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $__t21_i_i_i=__stackBase__+240;
      var $57=__stackBase__+248;
      var $58=__stackBase__+252;
      var $59=__stackBase__+256;
      var $60=__stackBase__+264;
      var $61=__stackBase__+268;
      var $62=__stackBase__+272;
      var $63=__stackBase__+276;
      var $__d1_i=__stackBase__+284;
      var $64=__stackBase__+292;
      var $65=__stackBase__+296;
      var $66=__stackBase__+300;
      var $67=__stackBase__+308;
      var $68=__stackBase__+312;
      var $69=__stackBase__+316;
      var $70=__stackBase__+320;
      var $71=__stackBase__+324;
      var $72=__stackBase__+328;
      var $73=__stackBase__+332;
      var $result_i_i_i=__stackBase__+336;
      var $74=__stackBase__+340;
      var $75=__stackBase__+344;
      var $76=__stackBase__+348;
      var $77=__stackBase__+352;
      var $78=__stackBase__+356;
      var $79=__stackBase__+360;
      var $80=__stackBase__+364;
      var $81=__stackBase__+368;
      var $82=__stackBase__+372;
      var $83=__stackBase__+376;
      var $84=__stackBase__+380;
      var $85=__stackBase__+384;
      var $86=__stackBase__+388;
      var $87=__stackBase__+392;
      var $88=__stackBase__+396;
      var $89=__stackBase__+400;
      var $90=__stackBase__+404;
      var $91=__stackBase__+408;
      var $92=__stackBase__+412;
      var $93=__stackBase__+416;
      var $94=__stackBase__+420;
      var $95=__stackBase__+424;
      var $96=__stackBase__+428;
      var $97=__stackBase__+432;
      var $98=__stackBase__+436;
      var $99=__stackBase__+440;
      var $__tmp_i_i_i=__stackBase__+444;
      var $100=__stackBase__+448;
      var $101=__stackBase__+452;
      var $102=__stackBase__+456;
      var $103=__stackBase__+460;
      var $104=__stackBase__+464;
      var $105;
      var $106;
      var $__na;
      var $__hold=__stackBase__+468;
      var $107=__stackBase__+480;
      var $108;
      var $109;
      $105=$this;
      $106=$__x;
      var $110=$105;
      var $111=$110;
      var $112=$104;
      HEAP32[(($104)>>2)]=$111;
      var $113=HEAP32[(($104)>>2)];
      var $114=(($113+8)|0);
      var $115=$103;
      HEAP32[(($103)>>2)]=$114;
      var $116=HEAP32[(($103)>>2)];
      var $117=$116;
      var $118=$102;
      HEAP32[(($102)>>2)]=$117;
      var $119=HEAP32[(($102)>>2)];
      var $120=$119;
      var $121=$102;
      var $122=$103;
      var $123=$104;
      $__na=$120;
      var $124=$__na;
      var $125=$79;
      var $126=$80;
      HEAP32[(($79)>>2)]=$124;
      HEAP32[(($80)>>2)]=1;
      var $127=HEAP32[(($79)>>2)];
      var $128=HEAP32[(($80)>>2)];
      var $129=$76;
      var $130=$77;
      var $131=$78;
      HEAP32[(($76)>>2)]=$127;
      HEAP32[(($77)>>2)]=$128;
      HEAP32[(($78)>>2)]=0;
      var $132=HEAP32[(($76)>>2)];
      var $133=HEAP32[(($77)>>2)];
      var $134=(($133*12)|0);
      var $135=$73;
      var $136=$result_i_i_i;
      var $137=$74;
      var $138=$75;
      HEAP32[(($73)>>2)]=$134;
      var $139=HEAP32[(($73)>>2)];
      var $140=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($139, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $141
      HEAP32[(($result_i_i_i)>>2)]=$140;
      var $142=HEAP32[(($result_i_i_i)>>2)];
      var $143=(($142)|0)==0;
      if ($143) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $144
      var $145=___cxa_allocate_exception(4);
      var $146=$145;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($146);
      (function() { try { __THREW__ = false; return ___cxa_throw($145, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $147
      var $148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $149=$148.f0;
      HEAP32[(($74)>>2)]=$149;
      var $150=$148.f1;
      HEAP32[(($75)>>2)]=$150;
      var $151=HEAP32[(($75)>>2)];
      var $152=(($151)|0) < 0;
      if ($152) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $153
      var $154=HEAP32[(($74)>>2)];
      ___cxa_call_unexpected($154);
      throw "Reached an unreachable!"
    case 5: // $155
      var $156=HEAP32[(($74)>>2)];
      var $157=HEAP32[(($74)>>2)];
      var $158=HEAP32[(($75)>>2)];
      var $159=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $157, tempValue);
      var $160=($159.f1 = $158, $159);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $161
      throw "Reached an unreachable!"
    case 7: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIP19handler_entry_writePvEEEEE8allocateERS7_j_exit
      var $162=HEAP32[(($result_i_i_i)>>2)];
      var $163=$73;
      var $164=$result_i_i_i;
      var $165=$74;
      var $166=$75;
      var $167=$162;
      var $168=$76;
      var $169=$77;
      var $170=$78;
      var $171=$79;
      var $172=$80;
      var $173=$__na;
      var $174=$70;
      var $175=$71;
      var $176=$72;
      HEAP32[(($70)>>2)]=$107;
      HEAP32[(($71)>>2)]=$173;
      HEAP32[(($72)>>2)]=1;
      var $177=HEAP32[(($70)>>2)];
      var $178=HEAP32[(($72)>>2)];
      var $179=HEAP32[(($71)>>2)];
      var $180=$67;
      var $181=$68;
      var $182=$69;
      HEAP32[(($67)>>2)]=$177;
      HEAP32[(($68)>>2)]=$179;
      HEAP32[(($69)>>2)]=$178;
      var $183=HEAP32[(($67)>>2)];
      var $184=(($183)|0);
      var $185=HEAP32[(($68)>>2)];
      HEAP32[(($184)>>2)]=$185;
      var $186=(($183+4)|0);
      var $187=HEAP32[(($69)>>2)];
      HEAP32[(($186)>>2)]=$187;
      var $188=$67;
      var $189=$68;
      var $190=$69;
      var $191=$70;
      var $192=$71;
      var $193=$72;
      var $tmp=$66;
      var $tmp1=$107;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];HEAP8[($tmp+4)]=HEAP8[($tmp1+4)];HEAP8[($tmp+5)]=HEAP8[($tmp1+5)];HEAP8[($tmp+6)]=HEAP8[($tmp1+6)];HEAP8[($tmp+7)]=HEAP8[($tmp1+7)];
      var $194=$__d1_i;
      var $195=$64;
      var $196=$65;
      HEAP32[(($64)>>2)]=$__hold;
      HEAP32[(($65)>>2)]=$167;
      var $197=HEAP32[(($64)>>2)];
      var $198=HEAP32[(($65)>>2)];
      var $tmp_i=$__d1_i;
      var $tmp2_i=$66;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];HEAP8[($tmp_i+4)]=HEAP8[($tmp2_i+4)];HEAP8[($tmp_i+5)]=HEAP8[($tmp2_i+5)];HEAP8[($tmp_i+6)]=HEAP8[($tmp2_i+6)];HEAP8[($tmp_i+7)]=HEAP8[($tmp2_i+7)];
      var $199=$59;
      var $200=$61;
      var $201=$62;
      var $202=$63;
      HEAP32[(($61)>>2)]=$197;
      HEAP32[(($62)>>2)]=$198;
      var $203=HEAP32[(($61)>>2)];
      var $204=(($203)|0);
      var $205=$60;
      HEAP32[(($60)>>2)]=$62;
      var $206=HEAP32[(($60)>>2)];
      var $207=$60;
      var $208=HEAP32[(($206)>>2)];
      var $209=$46;
      HEAP32[(($46)>>2)]=$__d1_i;
      var $210=HEAP32[(($46)>>2)];
      var $211=$46;
      var $212=$63;
      var $213=$210;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($212)>>2)]=HEAP32[(($213)>>2)];HEAP32[(($212+4)>>2)]=HEAP32[(($213+4)>>2)];
      var $tmp_i_i=$59;
      var $tmp1_i_i=$63;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];HEAP8[($tmp_i_i+1)]=HEAP8[($tmp1_i_i+1)];HEAP8[($tmp_i_i+2)]=HEAP8[($tmp1_i_i+2)];HEAP8[($tmp_i_i+3)]=HEAP8[($tmp1_i_i+3)];HEAP8[($tmp_i_i+4)]=HEAP8[($tmp1_i_i+4)];HEAP8[($tmp_i_i+5)]=HEAP8[($tmp1_i_i+5)];HEAP8[($tmp_i_i+6)]=HEAP8[($tmp1_i_i+6)];HEAP8[($tmp_i_i+7)]=HEAP8[($tmp1_i_i+7)];
      var $214=$__t21_i_i_i;
      var $215=$57;
      var $216=$58;
      HEAP32[(($57)>>2)]=$204;
      HEAP32[(($58)>>2)]=$208;
      var $217=HEAP32[(($57)>>2)];
      var $218=HEAP32[(($58)>>2)];
      var $tmp_i_i_i=$__t21_i_i_i;
      var $tmp2_i_i_i=$59;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp2_i_i_i)];HEAP8[($tmp_i_i_i+1)]=HEAP8[($tmp2_i_i_i+1)];HEAP8[($tmp_i_i_i+2)]=HEAP8[($tmp2_i_i_i+2)];HEAP8[($tmp_i_i_i+3)]=HEAP8[($tmp2_i_i_i+3)];HEAP8[($tmp_i_i_i+4)]=HEAP8[($tmp2_i_i_i+4)];HEAP8[($tmp_i_i_i+5)]=HEAP8[($tmp2_i_i_i+5)];HEAP8[($tmp_i_i_i+6)]=HEAP8[($tmp2_i_i_i+6)];HEAP8[($tmp_i_i_i+7)]=HEAP8[($tmp2_i_i_i+7)];
      var $219=$52;
      var $220=$54;
      var $221=$55;
      var $222=$56;
      HEAP32[(($54)>>2)]=$217;
      HEAP32[(($55)>>2)]=$218;
      var $223=HEAP32[(($54)>>2)];
      var $224=$223;
      var $225=$53;
      HEAP32[(($53)>>2)]=$55;
      var $226=HEAP32[(($53)>>2)];
      var $227=$53;
      var $228=HEAP32[(($226)>>2)];
      var $229=$47;
      HEAP32[(($47)>>2)]=$__t21_i_i_i;
      var $230=HEAP32[(($47)>>2)];
      var $231=$47;
      var $232=$56;
      var $233=$230;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($232)>>2)]=HEAP32[(($233)>>2)];HEAP32[(($232+4)>>2)]=HEAP32[(($233+4)>>2)];
      var $tmp_i_i_i_i=$52;
      var $tmp1_i_i_i_i=$56;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i_i)]=HEAP8[($tmp1_i_i_i_i)];HEAP8[($tmp_i_i_i_i+1)]=HEAP8[($tmp1_i_i_i_i+1)];HEAP8[($tmp_i_i_i_i+2)]=HEAP8[($tmp1_i_i_i_i+2)];HEAP8[($tmp_i_i_i_i+3)]=HEAP8[($tmp1_i_i_i_i+3)];HEAP8[($tmp_i_i_i_i+4)]=HEAP8[($tmp1_i_i_i_i+4)];HEAP8[($tmp_i_i_i_i+5)]=HEAP8[($tmp1_i_i_i_i+5)];HEAP8[($tmp_i_i_i_i+6)]=HEAP8[($tmp1_i_i_i_i+6)];HEAP8[($tmp_i_i_i_i+7)]=HEAP8[($tmp1_i_i_i_i+7)];
      var $234=$50;
      var $235=$51;
      HEAP32[(($50)>>2)]=$224;
      HEAP32[(($51)>>2)]=$228;
      var $236=HEAP32[(($50)>>2)];
      var $237=(($236)|0);
      var $238=$49;
      HEAP32[(($49)>>2)]=$51;
      var $239=HEAP32[(($49)>>2)];
      var $240=$49;
      var $241=HEAP32[(($239)>>2)];
      HEAP32[(($237)>>2)]=$241;
      var $242=(($236+4)|0);
      var $243=$48;
      HEAP32[(($48)>>2)]=$52;
      var $244=HEAP32[(($48)>>2)];
      var $245=$48;
      var $246=$242;
      var $247=$244;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($246)>>2)]=HEAP32[(($247)>>2)];HEAP32[(($246+4)>>2)]=HEAP32[(($247+4)>>2)];
      var $248=$50;
      var $249=$51;
      var $250=$52;
      var $251=$54;
      var $252=$55;
      var $253=$56;
      var $254=$__t21_i_i_i;
      var $255=$57;
      var $256=$58;
      var $257=$59;
      var $258=$61;
      var $259=$62;
      var $260=$63;
      var $261=$__d1_i;
      var $262=$64;
      var $263=$65;
      var $264=$__na;
      var $265=$45;
      HEAP32[(($45)>>2)]=$__hold;
      var $266=HEAP32[(($45)>>2)];
      var $267=(($266)|0);
      var $268=$44;
      HEAP32[(($44)>>2)]=$267;
      var $269=HEAP32[(($44)>>2)];
      var $270=$269;
      var $271=$43;
      HEAP32[(($43)>>2)]=$270;
      var $272=HEAP32[(($43)>>2)];
      var $273=(($272)|0);
      var $274=$43;
      var $275=$44;
      var $276=HEAP32[(($273)>>2)];
      var $277=$45;
      var $278=(($276+8)|0);
      var $279=$42;
      HEAP32[(($42)>>2)]=$278;
      var $280=HEAP32[(($42)>>2)];
      var $281=$280;
      var $282=$281;
      var $283=$42;
      var $284=$106;
      var $285=$39;
      var $286=$40;
      var $287=$41;
      HEAP32[(($39)>>2)]=$264;
      HEAP32[(($40)>>2)]=$282;
      HEAP32[(($41)>>2)]=$284;
      var $288=HEAP32[(($40)>>2)];
      var $289=$288;
      var $290=(($289)|0)==0;
      if ($290) { var $295 = 0;__label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $291
      var $292=$289;
      var $293=HEAP32[(($41)>>2)];
      var $294=HEAP32[(($293)>>2)];
      HEAP32[(($292)>>2)]=$294;
      var $295 = $292;__label__ = 9; break;
    case 9: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIP19handler_entry_writePvEEEEE9constructIS4_S4_EEvRS7_PT_RKT0__exit
      var $295;
      var $296=$39;
      var $297=$40;
      var $298=$41;
      __label__ = 10; break;
    case 10: // $299
      var $300=$110;
      var $301=(($300)|0);
      var $302=$301;
      var $303=$38;
      HEAP32[(($38)>>2)]=$__hold;
      var $304=HEAP32[(($38)>>2)];
      var $305=(($304)|0);
      var $306=$37;
      HEAP32[(($37)>>2)]=$305;
      var $307=HEAP32[(($37)>>2)];
      var $308=$307;
      var $309=$36;
      HEAP32[(($36)>>2)]=$308;
      var $310=HEAP32[(($36)>>2)];
      var $311=(($310)|0);
      var $312=$36;
      var $313=$37;
      var $314=HEAP32[(($311)>>2)];
      var $315=$38;
      __label__ = 11; break;
    case 11: // $316
      var $317=$14;
      HEAP32[(($14)>>2)]=$__hold;
      var $318=HEAP32[(($14)>>2)];
      var $319=(($318)|0);
      var $320=$13;
      HEAP32[(($13)>>2)]=$319;
      var $321=HEAP32[(($13)>>2)];
      var $322=$321;
      var $323=$12;
      HEAP32[(($12)>>2)]=$322;
      var $324=HEAP32[(($12)>>2)];
      var $325=(($324)|0);
      var $326=$12;
      var $327=$13;
      var $328=HEAP32[(($325)>>2)];
      var $329=$14;
      __label__ = 12; break;
    case 12: // $330
      var $331=$9;
      var $332=$10;
      var $333=$11;
      HEAP32[(($9)>>2)]=$302;
      HEAP32[(($10)>>2)]=$314;
      HEAP32[(($11)>>2)]=$328;
      var $334=HEAP32[(($10)>>2)];
      var $335=HEAP32[(($9)>>2)];
      var $336=$335;
      var $337=(($336)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=$338;
      var $340=(($339+4)|0);
      HEAP32[(($340)>>2)]=$334;
      var $341=HEAP32[(($9)>>2)];
      var $342=$341;
      var $343=(($342)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=HEAP32[(($10)>>2)];
      var $346=$345;
      var $347=(($346)|0);
      HEAP32[(($347)>>2)]=$344;
      var $348=HEAP32[(($11)>>2)];
      var $349=HEAP32[(($9)>>2)];
      var $350=$349;
      var $351=(($350)|0);
      HEAP32[(($351)>>2)]=$348;
      var $352=HEAP32[(($9)>>2)];
      var $353=HEAP32[(($11)>>2)];
      var $354=$353;
      var $355=(($354+4)|0);
      HEAP32[(($355)>>2)]=$352;
      var $356=$9;
      var $357=$10;
      var $358=$11;
      __label__ = 13; break;
    case 13: // $359
      var $360=$110;
      var $361=$3;
      HEAP32[(($3)>>2)]=$360;
      var $362=HEAP32[(($3)>>2)];
      var $363=(($362+8)|0);
      var $364=$2;
      HEAP32[(($2)>>2)]=$363;
      var $365=HEAP32[(($2)>>2)];
      var $366=$365;
      var $367=$1;
      HEAP32[(($1)>>2)]=$366;
      var $368=HEAP32[(($1)>>2)];
      var $369=(($368)|0);
      var $370=$1;
      var $371=$2;
      var $372=$3;
      var $373=HEAP32[(($369)>>2)];
      var $374=(($373+1)|0);
      HEAP32[(($369)>>2)]=$374;
      var $375=$8;
      var $376=$__t_i;
      HEAP32[(($8)>>2)]=$__hold;
      var $377=HEAP32[(($8)>>2)];
      var $378=(($377)|0);
      var $379=$7;
      HEAP32[(($7)>>2)]=$378;
      var $380=HEAP32[(($7)>>2)];
      var $381=$380;
      var $382=$6;
      HEAP32[(($6)>>2)]=$381;
      var $383=HEAP32[(($6)>>2)];
      var $384=(($383)|0);
      var $385=$6;
      var $386=$7;
      var $387=HEAP32[(($384)>>2)];
      HEAP32[(($__t_i)>>2)]=$387;
      var $388=(($377)|0);
      var $389=$5;
      HEAP32[(($5)>>2)]=$388;
      var $390=HEAP32[(($5)>>2)];
      var $391=$390;
      var $392=$4;
      HEAP32[(($4)>>2)]=$391;
      var $393=HEAP32[(($4)>>2)];
      var $394=(($393)|0);
      var $395=$4;
      var $396=$5;
      HEAP32[(($394)>>2)]=0;
      var $397=HEAP32[(($__t_i)>>2)];
      var $398=$8;
      var $399=$__t_i;
      var $400=$35;
      HEAP32[(($35)>>2)]=$__hold;
      var $401=HEAP32[(($35)>>2)];
      var $402=$34;
      HEAP32[(($34)>>2)]=$401;
      var $403=HEAP32[(($34)>>2)];
      var $404=$32;
      var $405=$33;
      var $406=$__tmp_i_i_i2;
      HEAP32[(($32)>>2)]=$403;
      HEAP32[(($33)>>2)]=0;
      var $407=HEAP32[(($32)>>2)];
      var $408=(($407)|0);
      var $409=$31;
      HEAP32[(($31)>>2)]=$408;
      var $410=HEAP32[(($31)>>2)];
      var $411=$410;
      var $412=$30;
      HEAP32[(($30)>>2)]=$411;
      var $413=HEAP32[(($30)>>2)];
      var $414=(($413)|0);
      var $415=$30;
      var $416=$31;
      var $417=HEAP32[(($414)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$417;
      var $418=HEAP32[(($33)>>2)];
      var $419=(($407)|0);
      var $420=$18;
      HEAP32[(($18)>>2)]=$419;
      var $421=HEAP32[(($18)>>2)];
      var $422=$421;
      var $423=$17;
      HEAP32[(($17)>>2)]=$422;
      var $424=HEAP32[(($17)>>2)];
      var $425=(($424)|0);
      var $426=$17;
      var $427=$18;
      HEAP32[(($425)>>2)]=$418;
      var $428=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $429=(($428)|0)!=0;
      if ($429) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $430
      var $431=(($407)|0);
      var $432=$16;
      HEAP32[(($16)>>2)]=$431;
      var $433=HEAP32[(($16)>>2)];
      var $434=$433;
      var $435=$15;
      HEAP32[(($15)>>2)]=$434;
      var $436=HEAP32[(($15)>>2)];
      var $437=(($436+4)|0);
      var $438=$15;
      var $439=$16;
      var $440=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $441=$28;
      var $442=$29;
      HEAP32[(($28)>>2)]=$437;
      HEAP32[(($29)>>2)]=$440;
      var $443=HEAP32[(($28)>>2)];
      var $444=(($443)|0);
      var $445=HEAP32[(($444)>>2)];
      var $446=HEAP32[(($29)>>2)];
      var $447=(($443+4)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=$25;
      var $450=$26;
      var $451=$27;
      HEAP32[(($25)>>2)]=$445;
      HEAP32[(($26)>>2)]=$446;
      HEAP32[(($27)>>2)]=$448;
      var $452=HEAP32[(($25)>>2)];
      var $453=HEAP32[(($26)>>2)];
      var $454=HEAP32[(($27)>>2)];
      var $455=$22;
      var $456=$23;
      var $457=$24;
      HEAP32[(($22)>>2)]=$452;
      HEAP32[(($23)>>2)]=$453;
      HEAP32[(($24)>>2)]=$454;
      var $458=HEAP32[(($22)>>2)];
      var $459=HEAP32[(($23)>>2)];
      var $460=$459;
      var $461=$19;
      var $462=$20;
      var $463=$21;
      HEAP32[(($19)>>2)]=$460;
      var $464=HEAP32[(($19)>>2)];
      var $465=(($464)|0)!=0;
      if ($465) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $466
      var $467=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($467, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $468
      __label__ = 18; break;
    case 17: // $469
      var $470=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $471=$470.f0;
      HEAP32[(($20)>>2)]=$471;
      var $472=$470.f1;
      HEAP32[(($21)>>2)]=$472;
      var $473=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($473);
      throw "Reached an unreachable!"
    case 18: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIP19handler_entry_writePvEEEEEclEPS6__exit_i_i_i3
      var $474=$19;
      var $475=$20;
      var $476=$21;
      var $477=$22;
      var $478=$23;
      var $479=$24;
      var $480=$25;
      var $481=$26;
      var $482=$27;
      var $483=$28;
      var $484=$29;
      __label__ = 19; break;
    case 19: // $_ZNSt3__110unique_ptrINS_11__list_nodeIP19handler_entry_writePvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev_exit4
      var $485=$32;
      var $486=$33;
      var $487=$__tmp_i_i_i2;
      var $488=$34;
      var $489=$35;
      STACKTOP = __stackBase__;
      return;
      var $491=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $492=$491.f0;
      $108=$492;
      var $493=$491.f1;
      $109=$493;
      var $494=$101;
      HEAP32[(($101)>>2)]=$__hold;
      var $495=HEAP32[(($101)>>2)];
      var $496=$100;
      HEAP32[(($100)>>2)]=$495;
      var $497=HEAP32[(($100)>>2)];
      var $498=$98;
      var $499=$99;
      var $500=$__tmp_i_i_i;
      HEAP32[(($98)>>2)]=$497;
      HEAP32[(($99)>>2)]=0;
      var $501=HEAP32[(($98)>>2)];
      var $502=(($501)|0);
      var $503=$97;
      HEAP32[(($97)>>2)]=$502;
      var $504=HEAP32[(($97)>>2)];
      var $505=$504;
      var $506=$96;
      HEAP32[(($96)>>2)]=$505;
      var $507=HEAP32[(($96)>>2)];
      var $508=(($507)|0);
      var $509=$96;
      var $510=$97;
      var $511=HEAP32[(($508)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$511;
      var $512=HEAP32[(($99)>>2)];
      var $513=(($501)|0);
      var $514=$84;
      HEAP32[(($84)>>2)]=$513;
      var $515=HEAP32[(($84)>>2)];
      var $516=$515;
      var $517=$83;
      HEAP32[(($83)>>2)]=$516;
      var $518=HEAP32[(($83)>>2)];
      var $519=(($518)|0);
      var $520=$83;
      var $521=$84;
      HEAP32[(($519)>>2)]=$512;
      var $522=HEAP32[(($__tmp_i_i_i)>>2)];
      var $523=(($522)|0)!=0;
      if ($523) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 20: // $524
      var $525=(($501)|0);
      var $526=$82;
      HEAP32[(($82)>>2)]=$525;
      var $527=HEAP32[(($82)>>2)];
      var $528=$527;
      var $529=$81;
      HEAP32[(($81)>>2)]=$528;
      var $530=HEAP32[(($81)>>2)];
      var $531=(($530+4)|0);
      var $532=$81;
      var $533=$82;
      var $534=HEAP32[(($__tmp_i_i_i)>>2)];
      var $535=$94;
      var $536=$95;
      HEAP32[(($94)>>2)]=$531;
      HEAP32[(($95)>>2)]=$534;
      var $537=HEAP32[(($94)>>2)];
      var $538=(($537)|0);
      var $539=HEAP32[(($538)>>2)];
      var $540=HEAP32[(($95)>>2)];
      var $541=(($537+4)|0);
      var $542=HEAP32[(($541)>>2)];
      var $543=$91;
      var $544=$92;
      var $545=$93;
      HEAP32[(($91)>>2)]=$539;
      HEAP32[(($92)>>2)]=$540;
      HEAP32[(($93)>>2)]=$542;
      var $546=HEAP32[(($91)>>2)];
      var $547=HEAP32[(($92)>>2)];
      var $548=HEAP32[(($93)>>2)];
      var $549=$88;
      var $550=$89;
      var $551=$90;
      HEAP32[(($88)>>2)]=$546;
      HEAP32[(($89)>>2)]=$547;
      HEAP32[(($90)>>2)]=$548;
      var $552=HEAP32[(($88)>>2)];
      var $553=HEAP32[(($89)>>2)];
      var $554=$553;
      var $555=$85;
      var $556=$86;
      var $557=$87;
      HEAP32[(($85)>>2)]=$554;
      var $558=HEAP32[(($85)>>2)];
      var $559=(($558)|0)!=0;
      if ($559) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $560
      var $561=HEAP32[(($85)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($561, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $562
      __label__ = 24; break;
    case 23: // $563
      var $564=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $565=$564.f0;
      HEAP32[(($86)>>2)]=$565;
      var $566=$564.f1;
      HEAP32[(($87)>>2)]=$566;
      var $567=HEAP32[(($86)>>2)];
      ___cxa_call_unexpected($567);
      throw "Reached an unreachable!"
    case 24: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIP19handler_entry_writePvEEEEEclEPS6__exit_i_i_i
      var $568=$85;
      var $569=$86;
      var $570=$87;
      var $571=$88;
      var $572=$89;
      var $573=$90;
      var $574=$91;
      var $575=$92;
      var $576=$93;
      var $577=$94;
      var $578=$95;
      __label__ = 25; break;
    case 25: // $_ZNSt3__110unique_ptrINS_11__list_nodeIP19handler_entry_writePvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev_exit
      var $579=$98;
      var $580=$99;
      var $581=$__tmp_i_i_i;
      var $582=$100;
      var $583=$101;
      __label__ = 26; break;
    case 26: // $584
      __label__ = 27; break;
    case 27: // $585
      var $586=$108;
      var $587=$108;
      var $588=$109;
      var $589=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $587, tempValue);
      var $590=($589.f1 = $588, $589);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $592=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEE9push_backERKS2_["X"]=1;
// WARNING: content after a branch in a label, line: 427465
// WARNING: content after a branch in a label, line: 427467
// WARNING: content after a branch in a label, line: 427468
// WARNING: content after a branch in a label, line: 427469
// WARNING: content after a branch in a label, line: 427470
// WARNING: content after a branch in a label, line: 427471

function __ZN19handler_entry_proxyI19handler_entry_writeEC1ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($this, $_handlers, $_mask$0, $_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$_handlers;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$_mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$_mask$1;
  var $4=$1;
  var $st$10$0=(($3)|0);
  var $5$0=HEAP32[(($st$10$0)>>2)];
  var $st$10$1=(($3+4)|0);
  var $5$1=HEAP32[(($st$10$1)>>2)];
  var $6=$2;
  __ZN19handler_entry_proxyI19handler_entry_writeEC2ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($4, $6, $5$0, $5$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__14listIjNS_9allocatorIjEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__14listIjNS_9allocatorIjEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__14listIjNS_9allocatorIjEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__110__list_impIjNS_9allocatorIjEEED2Ev($3);
  ;
  return;
}


function __ZNSt3__110__list_impIjNS_9allocatorIjEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__110__list_impIjNS_9allocatorIjEEE5clearEv($2);
  ;
  return;
}


function __ZN19handler_entry_proxyI19handler_entry_writeEC2ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($this, $_handlers, $_mask$0, $_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$_handlers;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$_mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$_mask$1;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC1ERKS5_($5, $6);
  var $7=(($4+12)|0);
  var $st$14$0=(($3)|0);
  var $8$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$14$1)>>2)];
  var $st$18$0=(($7)|0);
  HEAP32[(($st$18$0)>>2)]=$8$0;
  var $st$18$1=(($7+4)|0);
  HEAP32[(($st$18$1)>>2)]=$8$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC1ERKS5_($this, $__c) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__c;
  var $3=$1;
  var $4=$2;
  __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC2ERKS5_($3, $4);
  ;
  return;
}


function __ZNSt3__110__list_impIjNS_9allocatorIjEEE5clearEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 188; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46;
      var $__na;
      var $__f=__stackBase__+180;
      var $__l=__stackBase__+184;
      var $47;
      var $48;
      var $__n;
      $46=$this;
      var $49=$46;
      var $50=$45;
      HEAP32[(($45)>>2)]=$49;
      var $51=HEAP32[(($45)>>2)];
      var $52=$44;
      HEAP32[(($44)>>2)]=$51;
      var $53=HEAP32[(($44)>>2)];
      var $54=(($53+8)|0);
      var $55=$43;
      HEAP32[(($43)>>2)]=$54;
      var $56=HEAP32[(($43)>>2)];
      var $57=$56;
      var $58=$42;
      HEAP32[(($42)>>2)]=$57;
      var $59=HEAP32[(($42)>>2)];
      var $60=(($59)|0);
      var $61=$42;
      var $62=$43;
      var $63=$44;
      var $64=HEAP32[(($60)>>2)];
      var $65=(($64)|0)==0;
      var $66=$45;
      if ($65) { __label__ = 13; break; } else { __label__ = 1; break; }
    case 1: // $67
      var $68=$32;
      HEAP32[(($32)>>2)]=$49;
      var $69=HEAP32[(($32)>>2)];
      var $70=(($69+8)|0);
      var $71=$31;
      HEAP32[(($31)>>2)]=$70;
      var $72=HEAP32[(($31)>>2)];
      var $73=$72;
      var $74=$30;
      HEAP32[(($30)>>2)]=$73;
      var $75=HEAP32[(($30)>>2)];
      var $76=$75;
      var $77=$30;
      var $78=$31;
      var $79=$32;
      $__na=$76;
      var $80=$29;
      HEAP32[(($29)>>2)]=$49;
      var $81=HEAP32[(($29)>>2)];
      var $82=(($81)|0);
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$27;
      var $86=$28;
      HEAP32[(($27)>>2)]=$__f;
      HEAP32[(($28)>>2)]=$84;
      var $87=HEAP32[(($27)>>2)];
      var $88=HEAP32[(($28)>>2)];
      var $89=$25;
      var $90=$26;
      HEAP32[(($25)>>2)]=$87;
      HEAP32[(($26)>>2)]=$88;
      var $91=HEAP32[(($25)>>2)];
      var $92=(($91)|0);
      var $93=HEAP32[(($26)>>2)];
      HEAP32[(($92)>>2)]=$93;
      var $94=$25;
      var $95=$26;
      var $96=$27;
      var $97=$28;
      var $98=$29;
      var $99=$5;
      HEAP32[(($5)>>2)]=$49;
      var $100=HEAP32[(($5)>>2)];
      var $101=(($100)|0);
      var $102=$101;
      var $103=$3;
      var $104=$4;
      HEAP32[(($3)>>2)]=$__l;
      HEAP32[(($4)>>2)]=$102;
      var $105=HEAP32[(($3)>>2)];
      var $106=HEAP32[(($4)>>2)];
      var $107=$1;
      var $108=$2;
      HEAP32[(($1)>>2)]=$105;
      HEAP32[(($2)>>2)]=$106;
      var $109=HEAP32[(($1)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($2)>>2)];
      HEAP32[(($110)>>2)]=$111;
      var $112=$1;
      var $113=$2;
      var $114=$3;
      var $115=$4;
      var $116=$5;
      var $117=(($__f)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$118;
      var $120=(($__l)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$124;
      var $126=$6;
      var $127=$7;
      HEAP32[(($6)>>2)]=$119;
      HEAP32[(($7)>>2)]=$125;
      var $128=HEAP32[(($7)>>2)];
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=HEAP32[(($6)>>2)];
      var $132=(($131)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$133;
      var $135=(($134+4)|0);
      HEAP32[(($135)>>2)]=$130;
      var $136=HEAP32[(($6)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=HEAP32[(($7)>>2)];
      var $140=(($139+4)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$141;
      var $143=(($142)|0);
      HEAP32[(($143)>>2)]=$138;
      var $144=$6;
      var $145=$7;
      var $146=$10;
      HEAP32[(($10)>>2)]=$49;
      var $147=HEAP32[(($10)>>2)];
      var $148=(($147+8)|0);
      var $149=$9;
      HEAP32[(($9)>>2)]=$148;
      var $150=HEAP32[(($9)>>2)];
      var $151=$150;
      var $152=$8;
      HEAP32[(($8)>>2)]=$151;
      var $153=HEAP32[(($8)>>2)];
      var $154=(($153)|0);
      var $155=$8;
      var $156=$9;
      var $157=$10;
      HEAP32[(($154)>>2)]=0;
      __label__ = 2; break;
    case 2: // $158
      var $159=$13;
      var $160=$14;
      HEAP32[(($13)>>2)]=$__f;
      HEAP32[(($14)>>2)]=$__l;
      var $161=HEAP32[(($13)>>2)];
      var $162=HEAP32[(($14)>>2)];
      var $163=$11;
      var $164=$12;
      HEAP32[(($11)>>2)]=$161;
      HEAP32[(($12)>>2)]=$162;
      var $165=HEAP32[(($11)>>2)];
      var $166=(($165)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=HEAP32[(($12)>>2)];
      var $169=(($168)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($167)|0)==(($170)|0);
      var $172=$11;
      var $173=$12;
      var $174=$171 ^ 1;
      var $175=$13;
      var $176=$14;
      __label__ = 3; break;
    case 3: // $177
      if ($174) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $178
      var $179=(($__f)|0);
      var $180=HEAP32[(($179)>>2)];
      $__n=$180;
      var $181=$15;
      HEAP32[(($15)>>2)]=$__f;
      var $182=HEAP32[(($15)>>2)];
      var $183=(($182)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$184;
      var $186=(($185+4)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($182)|0);
      HEAP32[(($188)>>2)]=$187;
      var $189=$15;
      __label__ = 5; break;
    case 5: // $190
      var $191=$__na;
      var $192=$__n;
      var $193=(($192+8)|0);
      var $194=$16;
      HEAP32[(($16)>>2)]=$193;
      var $195=HEAP32[(($16)>>2)];
      var $196=$195;
      var $197=$196;
      var $198=$16;
      var $199=$19;
      var $200=$20;
      var $201=$21;
      var $202=$22;
      var $203=$23;
      HEAP32[(($20)>>2)]=$191;
      HEAP32[(($21)>>2)]=$197;
      var $204=$23;
      var $205=HEAP32[(($20)>>2)];
      var $206=HEAP32[(($21)>>2)];
      var $tmp_i=$19;
      var $tmp1_i=$22;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $207=$17;
      var $208=$18;
      HEAP32[(($17)>>2)]=$205;
      HEAP32[(($18)>>2)]=$206;
      var $209=HEAP32[(($18)>>2)];
      var $210=$17;
      var $211=$18;
      var $212=$19;
      var $213=$20;
      var $214=$21;
      var $215=$22;
      var $216=$23;
      __label__ = 6; break;
    case 6: // $217
      var $218=$__na;
      var $219=$__n;
      var $220=$24;
      HEAP32[(($24)>>2)]=$219;
      var $221=HEAP32[(($24)>>2)];
      var $222=$221;
      var $223=$222;
      var $224=$24;
      var $225=$39;
      var $226=$40;
      var $227=$41;
      HEAP32[(($39)>>2)]=$218;
      HEAP32[(($40)>>2)]=$223;
      HEAP32[(($41)>>2)]=1;
      var $228=HEAP32[(($39)>>2)];
      var $229=HEAP32[(($40)>>2)];
      var $230=HEAP32[(($41)>>2)];
      var $231=$36;
      var $232=$37;
      var $233=$38;
      HEAP32[(($36)>>2)]=$228;
      HEAP32[(($37)>>2)]=$229;
      HEAP32[(($38)>>2)]=$230;
      var $234=HEAP32[(($36)>>2)];
      var $235=HEAP32[(($37)>>2)];
      var $236=$235;
      var $237=$33;
      var $238=$34;
      var $239=$35;
      HEAP32[(($33)>>2)]=$236;
      var $240=HEAP32[(($33)>>2)];
      var $241=(($240)|0)!=0;
      if ($241) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $242
      var $243=HEAP32[(($33)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($243, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $244
      __label__ = 10; break;
    case 9: // $245
      var $246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $247=$246.f0;
      HEAP32[(($34)>>2)]=$247;
      var $248=$246.f1;
      HEAP32[(($35)>>2)]=$248;
      var $249=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($249);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIjPvEEEEE10deallocateERS5_PS4_j_exit
      var $250=$33;
      var $251=$34;
      var $252=$35;
      var $253=$36;
      var $254=$37;
      var $255=$38;
      var $256=$39;
      var $257=$40;
      var $258=$41;
      __label__ = 2; break;
    case 11: // $263
      var $264=$47;
      ___cxa_call_unexpected($264);
      throw "Reached an unreachable!"
    case 12: // $265
      __label__ = 13; break;
    case 13: // $266
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__list_impIjNS_9allocatorIjEEE5clearEv["X"]=1;

function __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC2ERKS5_($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 228; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $__t21_i_i=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $34=__stackBase__+136;
      var $35=__stackBase__+140;
      var $36=__stackBase__+144;
      var $37=__stackBase__+148;
      var $38=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48=__stackBase__+192;
      var $49=__stackBase__+196;
      var $50=__stackBase__+200;
      var $51=__stackBase__+204;
      var $52=__stackBase__+208;
      var $53;
      var $54;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $__i=__stackBase__+220;
      var $__e=__stackBase__+224;
      var $57;
      var $58;
      $53=$this;
      $54=$__c;
      var $59=$53;
      var $60=$59;
      var $61=$54;
      var $62=$61;
      var $63=$52;
      HEAP32[(($52)>>2)]=$62;
      var $64=HEAP32[(($52)>>2)];
      var $65=(($64+8)|0);
      var $66=$51;
      HEAP32[(($51)>>2)]=$65;
      var $67=HEAP32[(($51)>>2)];
      var $68=$67;
      var $69=$50;
      HEAP32[(($50)>>2)]=$68;
      var $70=HEAP32[(($50)>>2)];
      var $71=$70;
      var $72=$50;
      var $73=$51;
      var $74=$52;
      var $75=$46;
      var $76=$47;
      var $77=$48;
      var $78=$49;
      HEAP32[(($47)>>2)]=$71;
      var $79=$49;
      var $80=HEAP32[(($47)>>2)];
      var $tmp_i=$46;
      var $tmp1_i=$48;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $81=$45;
      HEAP32[(($45)>>2)]=$80;
      var $82=HEAP32[(($45)>>2)];
      var $83=$45;
      var $84=$46;
      var $85=$47;
      var $86=$48;
      var $87=$49;
      var $88=$42;
      var $89=$43;
      HEAP32[(($42)>>2)]=$55;
      HEAP32[(($43)>>2)]=$56;
      var $90=HEAP32[(($42)>>2)];
      var $91=HEAP32[(($43)>>2)];
      var $92=$40;
      var $93=$41;
      HEAP32[(($40)>>2)]=$90;
      HEAP32[(($41)>>2)]=$91;
      var $94=HEAP32[(($40)>>2)];
      var $95=$40;
      var $96=$41;
      var $97=$42;
      var $98=$43;
      var $99=$17;
      var $100=$20;
      var $101=$21;
      var $102=$22;
      HEAP32[(($20)>>2)]=$60;
      HEAP32[(($21)>>2)]=$55;
      var $103=HEAP32[(($20)>>2)];
      var $104=(($103)|0);
      var $105=$19;
      HEAP32[(($19)>>2)]=$104;
      var $106=HEAP32[(($19)>>2)];
      var $107=$18;
      HEAP32[(($18)>>2)]=$106;
      var $108=HEAP32[(($18)>>2)];
      var $109=(($108)|0);
      var $110=$108;
      HEAP32[(($109)>>2)]=$110;
      var $111=(($108+4)|0);
      var $112=$108;
      HEAP32[(($111)>>2)]=$112;
      var $113=$18;
      var $114=$19;
      var $115=(($103+8)|0);
      var $116=HEAP32[(($21)>>2)];
      var $117=$3;
      var $118=$4;
      HEAP32[(($3)>>2)]=$22;
      HEAP32[(($4)>>2)]=$116;
      var $119=HEAP32[(($3)>>2)];
      var $120=HEAP32[(($4)>>2)];
      var $121=$1;
      var $122=$2;
      HEAP32[(($1)>>2)]=$119;
      HEAP32[(($2)>>2)]=$120;
      var $123=HEAP32[(($1)>>2)];
      var $124=$1;
      var $125=$2;
      var $126=$3;
      var $127=$4;
      var $tmp_i1=$17;
      var $tmp1_i2=$22;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i1)]=HEAP8[($tmp1_i2)];
      var $128=$__t21_i_i;
      var $129=$15;
      var $130=$16;
      HEAP32[(($15)>>2)]=$115;
      HEAP32[(($16)>>2)]=0;
      var $131=HEAP32[(($15)>>2)];
      var $132=HEAP32[(($16)>>2)];
      var $tmp_i_i=$__t21_i_i;
      var $tmp2_i_i=$17;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp2_i_i)];
      var $133=$10;
      var $134=$12;
      var $135=$13;
      var $136=$14;
      HEAP32[(($12)>>2)]=$131;
      HEAP32[(($13)>>2)]=$132;
      var $137=HEAP32[(($12)>>2)];
      var $138=$137;
      var $139=$11;
      HEAP32[(($11)>>2)]=$13;
      var $140=HEAP32[(($11)>>2)];
      var $141=$11;
      var $142=HEAP32[(($140)>>2)];
      var $143=$5;
      HEAP32[(($5)>>2)]=$__t21_i_i;
      var $144=HEAP32[(($5)>>2)];
      var $145=$5;
      var $tmp_i_i_i=$10;
      var $tmp1_i_i_i=$14;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
      var $146=$8;
      var $147=$9;
      HEAP32[(($8)>>2)]=$138;
      HEAP32[(($9)>>2)]=$142;
      var $148=HEAP32[(($8)>>2)];
      var $149=$148;
      var $150=$7;
      HEAP32[(($7)>>2)]=$10;
      var $151=HEAP32[(($7)>>2)];
      var $152=$7;
      var $153=(($148)|0);
      var $154=$6;
      HEAP32[(($6)>>2)]=$9;
      var $155=HEAP32[(($6)>>2)];
      var $156=$6;
      var $157=HEAP32[(($155)>>2)];
      HEAP32[(($153)>>2)]=$157;
      var $158=$8;
      var $159=$9;
      var $160=$10;
      var $161=$12;
      var $162=$13;
      var $163=$14;
      var $164=$__t21_i_i;
      var $165=$15;
      var $166=$16;
      var $167=$17;
      var $168=$20;
      var $169=$21;
      var $170=$22;
      var $171=$54;
      var $172=$28;
      HEAP32[(($28)>>2)]=$171;
      var $173=HEAP32[(($28)>>2)];
      var $174=$173;
      var $175=$27;
      HEAP32[(($27)>>2)]=$174;
      var $176=HEAP32[(($27)>>2)];
      var $177=(($176)|0);
      var $178=(($177+4)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$25;
      var $181=$26;
      HEAP32[(($25)>>2)]=$__i;
      HEAP32[(($26)>>2)]=$179;
      var $182=HEAP32[(($25)>>2)];
      var $183=HEAP32[(($26)>>2)];
      var $184=$23;
      var $185=$24;
      HEAP32[(($23)>>2)]=$182;
      HEAP32[(($24)>>2)]=$183;
      var $186=HEAP32[(($23)>>2)];
      var $187=(($186)|0);
      var $188=HEAP32[(($24)>>2)];
      HEAP32[(($187)>>2)]=$188;
      var $189=$23;
      var $190=$24;
      var $191=$25;
      var $192=$26;
      var $193=$27;
      var $194=$28;
      var $195=$54;
      var $196=$34;
      HEAP32[(($34)>>2)]=$195;
      var $197=HEAP32[(($34)>>2)];
      var $198=$197;
      var $199=$33;
      HEAP32[(($33)>>2)]=$198;
      var $200=HEAP32[(($33)>>2)];
      var $201=(($200)|0);
      var $202=$201;
      var $203=$31;
      var $204=$32;
      HEAP32[(($31)>>2)]=$__e;
      HEAP32[(($32)>>2)]=$202;
      var $205=HEAP32[(($31)>>2)];
      var $206=HEAP32[(($32)>>2)];
      var $207=$29;
      var $208=$30;
      HEAP32[(($29)>>2)]=$205;
      HEAP32[(($30)>>2)]=$206;
      var $209=HEAP32[(($29)>>2)];
      var $210=(($209)|0);
      var $211=HEAP32[(($30)>>2)];
      HEAP32[(($210)>>2)]=$211;
      var $212=$29;
      var $213=$30;
      var $214=$31;
      var $215=$32;
      var $216=$33;
      var $217=$34;
      __label__ = 1; break;
    case 1: // $218
      var $219=$37;
      var $220=$38;
      HEAP32[(($37)>>2)]=$__i;
      HEAP32[(($38)>>2)]=$__e;
      var $221=HEAP32[(($37)>>2)];
      var $222=HEAP32[(($38)>>2)];
      var $223=$35;
      var $224=$36;
      HEAP32[(($35)>>2)]=$221;
      HEAP32[(($36)>>2)]=$222;
      var $225=HEAP32[(($35)>>2)];
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=HEAP32[(($36)>>2)];
      var $229=(($228)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=(($227)|0)==(($230)|0);
      var $232=$35;
      var $233=$36;
      var $234=$231 ^ 1;
      var $235=$37;
      var $236=$38;
      __label__ = 2; break;
    case 2: // $237
      if ($234) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $238
      var $239=$39;
      HEAP32[(($39)>>2)]=$__i;
      var $240=HEAP32[(($39)>>2)];
      var $241=(($240)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242+8)|0);
      var $244=$39;
      __label__ = 4; break;
    case 4: // $245
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEE9push_backERKS2_($59, $243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $246
      __label__ = 6; break;
    case 6: // $247
      var $248=$44;
      HEAP32[(($44)>>2)]=$__i;
      var $249=HEAP32[(($44)>>2)];
      var $250=(($249)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$251;
      var $253=(($252+4)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($249)|0);
      HEAP32[(($255)>>2)]=$254;
      var $256=$44;
      __label__ = 7; break;
    case 7: // $257
      __label__ = 1; break;
    case 8: // $258
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $260=$259.f0;
      $57=$260;
      var $261=$259.f1;
      $58=$261;
      var $262=$59;
      (function() { try { __THREW__ = false; return __ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev($262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 9: // $263
      STACKTOP = __stackBase__;
      return;
    case 10: // $264
      __label__ = 11; break;
    case 11: // $265
      var $266=$57;
      var $267=$57;
      var $268=$58;
      var $269=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $267, tempValue);
      var $270=($269.f1 = $268, $269);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $271
      var $272=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC2ERKS5_["X"]=1;
// WARNING: content after a branch in a label, line: 428461
// WARNING: content after a branch in a label, line: 428463
// WARNING: content after a branch in a label, line: 428464
// WARNING: content after a branch in a label, line: 428465
// WARNING: content after a branch in a label, line: 428466
// WARNING: content after a branch in a label, line: 428467

function __ZN19handler_entry_proxyI18handler_entry_readED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED1Ev($3);
  ;
  return;
}


function __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED2Ev($2);
  ;
  return;
}


function __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEED2Ev($3);
  ;
  return;
}


function __ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEE5clearEv($2);
  ;
  return;
}


function __ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEE5clearEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 188; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46;
      var $__na;
      var $__f=__stackBase__+180;
      var $__l=__stackBase__+184;
      var $47;
      var $48;
      var $__n;
      $46=$this;
      var $49=$46;
      var $50=$45;
      HEAP32[(($45)>>2)]=$49;
      var $51=HEAP32[(($45)>>2)];
      var $52=$44;
      HEAP32[(($44)>>2)]=$51;
      var $53=HEAP32[(($44)>>2)];
      var $54=(($53+8)|0);
      var $55=$43;
      HEAP32[(($43)>>2)]=$54;
      var $56=HEAP32[(($43)>>2)];
      var $57=$56;
      var $58=$42;
      HEAP32[(($42)>>2)]=$57;
      var $59=HEAP32[(($42)>>2)];
      var $60=(($59)|0);
      var $61=$42;
      var $62=$43;
      var $63=$44;
      var $64=HEAP32[(($60)>>2)];
      var $65=(($64)|0)==0;
      var $66=$45;
      if ($65) { __label__ = 13; break; } else { __label__ = 1; break; }
    case 1: // $67
      var $68=$32;
      HEAP32[(($32)>>2)]=$49;
      var $69=HEAP32[(($32)>>2)];
      var $70=(($69+8)|0);
      var $71=$31;
      HEAP32[(($31)>>2)]=$70;
      var $72=HEAP32[(($31)>>2)];
      var $73=$72;
      var $74=$30;
      HEAP32[(($30)>>2)]=$73;
      var $75=HEAP32[(($30)>>2)];
      var $76=$75;
      var $77=$30;
      var $78=$31;
      var $79=$32;
      $__na=$76;
      var $80=$29;
      HEAP32[(($29)>>2)]=$49;
      var $81=HEAP32[(($29)>>2)];
      var $82=(($81)|0);
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$27;
      var $86=$28;
      HEAP32[(($27)>>2)]=$__f;
      HEAP32[(($28)>>2)]=$84;
      var $87=HEAP32[(($27)>>2)];
      var $88=HEAP32[(($28)>>2)];
      var $89=$25;
      var $90=$26;
      HEAP32[(($25)>>2)]=$87;
      HEAP32[(($26)>>2)]=$88;
      var $91=HEAP32[(($25)>>2)];
      var $92=(($91)|0);
      var $93=HEAP32[(($26)>>2)];
      HEAP32[(($92)>>2)]=$93;
      var $94=$25;
      var $95=$26;
      var $96=$27;
      var $97=$28;
      var $98=$29;
      var $99=$5;
      HEAP32[(($5)>>2)]=$49;
      var $100=HEAP32[(($5)>>2)];
      var $101=(($100)|0);
      var $102=$101;
      var $103=$3;
      var $104=$4;
      HEAP32[(($3)>>2)]=$__l;
      HEAP32[(($4)>>2)]=$102;
      var $105=HEAP32[(($3)>>2)];
      var $106=HEAP32[(($4)>>2)];
      var $107=$1;
      var $108=$2;
      HEAP32[(($1)>>2)]=$105;
      HEAP32[(($2)>>2)]=$106;
      var $109=HEAP32[(($1)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($2)>>2)];
      HEAP32[(($110)>>2)]=$111;
      var $112=$1;
      var $113=$2;
      var $114=$3;
      var $115=$4;
      var $116=$5;
      var $117=(($__f)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$118;
      var $120=(($__l)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$124;
      var $126=$6;
      var $127=$7;
      HEAP32[(($6)>>2)]=$119;
      HEAP32[(($7)>>2)]=$125;
      var $128=HEAP32[(($7)>>2)];
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=HEAP32[(($6)>>2)];
      var $132=(($131)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$133;
      var $135=(($134+4)|0);
      HEAP32[(($135)>>2)]=$130;
      var $136=HEAP32[(($6)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=HEAP32[(($7)>>2)];
      var $140=(($139+4)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$141;
      var $143=(($142)|0);
      HEAP32[(($143)>>2)]=$138;
      var $144=$6;
      var $145=$7;
      var $146=$10;
      HEAP32[(($10)>>2)]=$49;
      var $147=HEAP32[(($10)>>2)];
      var $148=(($147+8)|0);
      var $149=$9;
      HEAP32[(($9)>>2)]=$148;
      var $150=HEAP32[(($9)>>2)];
      var $151=$150;
      var $152=$8;
      HEAP32[(($8)>>2)]=$151;
      var $153=HEAP32[(($8)>>2)];
      var $154=(($153)|0);
      var $155=$8;
      var $156=$9;
      var $157=$10;
      HEAP32[(($154)>>2)]=0;
      __label__ = 2; break;
    case 2: // $158
      var $159=$13;
      var $160=$14;
      HEAP32[(($13)>>2)]=$__f;
      HEAP32[(($14)>>2)]=$__l;
      var $161=HEAP32[(($13)>>2)];
      var $162=HEAP32[(($14)>>2)];
      var $163=$11;
      var $164=$12;
      HEAP32[(($11)>>2)]=$161;
      HEAP32[(($12)>>2)]=$162;
      var $165=HEAP32[(($11)>>2)];
      var $166=(($165)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=HEAP32[(($12)>>2)];
      var $169=(($168)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($167)|0)==(($170)|0);
      var $172=$11;
      var $173=$12;
      var $174=$171 ^ 1;
      var $175=$13;
      var $176=$14;
      __label__ = 3; break;
    case 3: // $177
      if ($174) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $178
      var $179=(($__f)|0);
      var $180=HEAP32[(($179)>>2)];
      $__n=$180;
      var $181=$15;
      HEAP32[(($15)>>2)]=$__f;
      var $182=HEAP32[(($15)>>2)];
      var $183=(($182)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$184;
      var $186=(($185+4)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($182)|0);
      HEAP32[(($188)>>2)]=$187;
      var $189=$15;
      __label__ = 5; break;
    case 5: // $190
      var $191=$__na;
      var $192=$__n;
      var $193=(($192+8)|0);
      var $194=$16;
      HEAP32[(($16)>>2)]=$193;
      var $195=HEAP32[(($16)>>2)];
      var $196=$195;
      var $197=$196;
      var $198=$16;
      var $199=$19;
      var $200=$20;
      var $201=$21;
      var $202=$22;
      var $203=$23;
      HEAP32[(($20)>>2)]=$191;
      HEAP32[(($21)>>2)]=$197;
      var $204=$23;
      var $205=HEAP32[(($20)>>2)];
      var $206=HEAP32[(($21)>>2)];
      var $tmp_i=$19;
      var $tmp1_i=$22;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $207=$17;
      var $208=$18;
      HEAP32[(($17)>>2)]=$205;
      HEAP32[(($18)>>2)]=$206;
      var $209=HEAP32[(($18)>>2)];
      var $210=$17;
      var $211=$18;
      var $212=$19;
      var $213=$20;
      var $214=$21;
      var $215=$22;
      var $216=$23;
      __label__ = 6; break;
    case 6: // $217
      var $218=$__na;
      var $219=$__n;
      var $220=$24;
      HEAP32[(($24)>>2)]=$219;
      var $221=HEAP32[(($24)>>2)];
      var $222=$221;
      var $223=$222;
      var $224=$24;
      var $225=$39;
      var $226=$40;
      var $227=$41;
      HEAP32[(($39)>>2)]=$218;
      HEAP32[(($40)>>2)]=$223;
      HEAP32[(($41)>>2)]=1;
      var $228=HEAP32[(($39)>>2)];
      var $229=HEAP32[(($40)>>2)];
      var $230=HEAP32[(($41)>>2)];
      var $231=$36;
      var $232=$37;
      var $233=$38;
      HEAP32[(($36)>>2)]=$228;
      HEAP32[(($37)>>2)]=$229;
      HEAP32[(($38)>>2)]=$230;
      var $234=HEAP32[(($36)>>2)];
      var $235=HEAP32[(($37)>>2)];
      var $236=$235;
      var $237=$33;
      var $238=$34;
      var $239=$35;
      HEAP32[(($33)>>2)]=$236;
      var $240=HEAP32[(($33)>>2)];
      var $241=(($240)|0)!=0;
      if ($241) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $242
      var $243=HEAP32[(($33)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($243, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $244
      __label__ = 10; break;
    case 9: // $245
      var $246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $247=$246.f0;
      HEAP32[(($34)>>2)]=$247;
      var $248=$246.f1;
      HEAP32[(($35)>>2)]=$248;
      var $249=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($249);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIP18handler_entry_readPvEEEEE10deallocateERS7_PS6_j_exit
      var $250=$33;
      var $251=$34;
      var $252=$35;
      var $253=$36;
      var $254=$37;
      var $255=$38;
      var $256=$39;
      var $257=$40;
      var $258=$41;
      __label__ = 2; break;
    case 11: // $263
      var $264=$47;
      ___cxa_call_unexpected($264);
      throw "Reached an unreachable!"
    case 12: // $265
      __label__ = 13; break;
    case 13: // $266
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEE5clearEv["X"]=1;

function __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEE9push_backERKS2_($this, $__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 488; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__t_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $__tmp_i_i_i2=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $__t21_i_i_i=__stackBase__+240;
      var $57=__stackBase__+248;
      var $58=__stackBase__+252;
      var $59=__stackBase__+256;
      var $60=__stackBase__+264;
      var $61=__stackBase__+268;
      var $62=__stackBase__+272;
      var $63=__stackBase__+276;
      var $__d1_i=__stackBase__+284;
      var $64=__stackBase__+292;
      var $65=__stackBase__+296;
      var $66=__stackBase__+300;
      var $67=__stackBase__+308;
      var $68=__stackBase__+312;
      var $69=__stackBase__+316;
      var $70=__stackBase__+320;
      var $71=__stackBase__+324;
      var $72=__stackBase__+328;
      var $73=__stackBase__+332;
      var $result_i_i_i=__stackBase__+336;
      var $74=__stackBase__+340;
      var $75=__stackBase__+344;
      var $76=__stackBase__+348;
      var $77=__stackBase__+352;
      var $78=__stackBase__+356;
      var $79=__stackBase__+360;
      var $80=__stackBase__+364;
      var $81=__stackBase__+368;
      var $82=__stackBase__+372;
      var $83=__stackBase__+376;
      var $84=__stackBase__+380;
      var $85=__stackBase__+384;
      var $86=__stackBase__+388;
      var $87=__stackBase__+392;
      var $88=__stackBase__+396;
      var $89=__stackBase__+400;
      var $90=__stackBase__+404;
      var $91=__stackBase__+408;
      var $92=__stackBase__+412;
      var $93=__stackBase__+416;
      var $94=__stackBase__+420;
      var $95=__stackBase__+424;
      var $96=__stackBase__+428;
      var $97=__stackBase__+432;
      var $98=__stackBase__+436;
      var $99=__stackBase__+440;
      var $__tmp_i_i_i=__stackBase__+444;
      var $100=__stackBase__+448;
      var $101=__stackBase__+452;
      var $102=__stackBase__+456;
      var $103=__stackBase__+460;
      var $104=__stackBase__+464;
      var $105;
      var $106;
      var $__na;
      var $__hold=__stackBase__+468;
      var $107=__stackBase__+480;
      var $108;
      var $109;
      $105=$this;
      $106=$__x;
      var $110=$105;
      var $111=$110;
      var $112=$104;
      HEAP32[(($104)>>2)]=$111;
      var $113=HEAP32[(($104)>>2)];
      var $114=(($113+8)|0);
      var $115=$103;
      HEAP32[(($103)>>2)]=$114;
      var $116=HEAP32[(($103)>>2)];
      var $117=$116;
      var $118=$102;
      HEAP32[(($102)>>2)]=$117;
      var $119=HEAP32[(($102)>>2)];
      var $120=$119;
      var $121=$102;
      var $122=$103;
      var $123=$104;
      $__na=$120;
      var $124=$__na;
      var $125=$79;
      var $126=$80;
      HEAP32[(($79)>>2)]=$124;
      HEAP32[(($80)>>2)]=1;
      var $127=HEAP32[(($79)>>2)];
      var $128=HEAP32[(($80)>>2)];
      var $129=$76;
      var $130=$77;
      var $131=$78;
      HEAP32[(($76)>>2)]=$127;
      HEAP32[(($77)>>2)]=$128;
      HEAP32[(($78)>>2)]=0;
      var $132=HEAP32[(($76)>>2)];
      var $133=HEAP32[(($77)>>2)];
      var $134=(($133*12)|0);
      var $135=$73;
      var $136=$result_i_i_i;
      var $137=$74;
      var $138=$75;
      HEAP32[(($73)>>2)]=$134;
      var $139=HEAP32[(($73)>>2)];
      var $140=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($139, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $141
      HEAP32[(($result_i_i_i)>>2)]=$140;
      var $142=HEAP32[(($result_i_i_i)>>2)];
      var $143=(($142)|0)==0;
      if ($143) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $144
      var $145=___cxa_allocate_exception(4);
      var $146=$145;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($146);
      (function() { try { __THREW__ = false; return ___cxa_throw($145, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $147
      var $148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $149=$148.f0;
      HEAP32[(($74)>>2)]=$149;
      var $150=$148.f1;
      HEAP32[(($75)>>2)]=$150;
      var $151=HEAP32[(($75)>>2)];
      var $152=(($151)|0) < 0;
      if ($152) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $153
      var $154=HEAP32[(($74)>>2)];
      ___cxa_call_unexpected($154);
      throw "Reached an unreachable!"
    case 5: // $155
      var $156=HEAP32[(($74)>>2)];
      var $157=HEAP32[(($74)>>2)];
      var $158=HEAP32[(($75)>>2)];
      var $159=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $157, tempValue);
      var $160=($159.f1 = $158, $159);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $161
      throw "Reached an unreachable!"
    case 7: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIP18handler_entry_readPvEEEEE8allocateERS7_j_exit
      var $162=HEAP32[(($result_i_i_i)>>2)];
      var $163=$73;
      var $164=$result_i_i_i;
      var $165=$74;
      var $166=$75;
      var $167=$162;
      var $168=$76;
      var $169=$77;
      var $170=$78;
      var $171=$79;
      var $172=$80;
      var $173=$__na;
      var $174=$70;
      var $175=$71;
      var $176=$72;
      HEAP32[(($70)>>2)]=$107;
      HEAP32[(($71)>>2)]=$173;
      HEAP32[(($72)>>2)]=1;
      var $177=HEAP32[(($70)>>2)];
      var $178=HEAP32[(($72)>>2)];
      var $179=HEAP32[(($71)>>2)];
      var $180=$67;
      var $181=$68;
      var $182=$69;
      HEAP32[(($67)>>2)]=$177;
      HEAP32[(($68)>>2)]=$179;
      HEAP32[(($69)>>2)]=$178;
      var $183=HEAP32[(($67)>>2)];
      var $184=(($183)|0);
      var $185=HEAP32[(($68)>>2)];
      HEAP32[(($184)>>2)]=$185;
      var $186=(($183+4)|0);
      var $187=HEAP32[(($69)>>2)];
      HEAP32[(($186)>>2)]=$187;
      var $188=$67;
      var $189=$68;
      var $190=$69;
      var $191=$70;
      var $192=$71;
      var $193=$72;
      var $tmp=$66;
      var $tmp1=$107;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];HEAP8[($tmp+4)]=HEAP8[($tmp1+4)];HEAP8[($tmp+5)]=HEAP8[($tmp1+5)];HEAP8[($tmp+6)]=HEAP8[($tmp1+6)];HEAP8[($tmp+7)]=HEAP8[($tmp1+7)];
      var $194=$__d1_i;
      var $195=$64;
      var $196=$65;
      HEAP32[(($64)>>2)]=$__hold;
      HEAP32[(($65)>>2)]=$167;
      var $197=HEAP32[(($64)>>2)];
      var $198=HEAP32[(($65)>>2)];
      var $tmp_i=$__d1_i;
      var $tmp2_i=$66;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];HEAP8[($tmp_i+4)]=HEAP8[($tmp2_i+4)];HEAP8[($tmp_i+5)]=HEAP8[($tmp2_i+5)];HEAP8[($tmp_i+6)]=HEAP8[($tmp2_i+6)];HEAP8[($tmp_i+7)]=HEAP8[($tmp2_i+7)];
      var $199=$59;
      var $200=$61;
      var $201=$62;
      var $202=$63;
      HEAP32[(($61)>>2)]=$197;
      HEAP32[(($62)>>2)]=$198;
      var $203=HEAP32[(($61)>>2)];
      var $204=(($203)|0);
      var $205=$60;
      HEAP32[(($60)>>2)]=$62;
      var $206=HEAP32[(($60)>>2)];
      var $207=$60;
      var $208=HEAP32[(($206)>>2)];
      var $209=$46;
      HEAP32[(($46)>>2)]=$__d1_i;
      var $210=HEAP32[(($46)>>2)];
      var $211=$46;
      var $212=$63;
      var $213=$210;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($212)>>2)]=HEAP32[(($213)>>2)];HEAP32[(($212+4)>>2)]=HEAP32[(($213+4)>>2)];
      var $tmp_i_i=$59;
      var $tmp1_i_i=$63;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];HEAP8[($tmp_i_i+1)]=HEAP8[($tmp1_i_i+1)];HEAP8[($tmp_i_i+2)]=HEAP8[($tmp1_i_i+2)];HEAP8[($tmp_i_i+3)]=HEAP8[($tmp1_i_i+3)];HEAP8[($tmp_i_i+4)]=HEAP8[($tmp1_i_i+4)];HEAP8[($tmp_i_i+5)]=HEAP8[($tmp1_i_i+5)];HEAP8[($tmp_i_i+6)]=HEAP8[($tmp1_i_i+6)];HEAP8[($tmp_i_i+7)]=HEAP8[($tmp1_i_i+7)];
      var $214=$__t21_i_i_i;
      var $215=$57;
      var $216=$58;
      HEAP32[(($57)>>2)]=$204;
      HEAP32[(($58)>>2)]=$208;
      var $217=HEAP32[(($57)>>2)];
      var $218=HEAP32[(($58)>>2)];
      var $tmp_i_i_i=$__t21_i_i_i;
      var $tmp2_i_i_i=$59;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp2_i_i_i)];HEAP8[($tmp_i_i_i+1)]=HEAP8[($tmp2_i_i_i+1)];HEAP8[($tmp_i_i_i+2)]=HEAP8[($tmp2_i_i_i+2)];HEAP8[($tmp_i_i_i+3)]=HEAP8[($tmp2_i_i_i+3)];HEAP8[($tmp_i_i_i+4)]=HEAP8[($tmp2_i_i_i+4)];HEAP8[($tmp_i_i_i+5)]=HEAP8[($tmp2_i_i_i+5)];HEAP8[($tmp_i_i_i+6)]=HEAP8[($tmp2_i_i_i+6)];HEAP8[($tmp_i_i_i+7)]=HEAP8[($tmp2_i_i_i+7)];
      var $219=$52;
      var $220=$54;
      var $221=$55;
      var $222=$56;
      HEAP32[(($54)>>2)]=$217;
      HEAP32[(($55)>>2)]=$218;
      var $223=HEAP32[(($54)>>2)];
      var $224=$223;
      var $225=$53;
      HEAP32[(($53)>>2)]=$55;
      var $226=HEAP32[(($53)>>2)];
      var $227=$53;
      var $228=HEAP32[(($226)>>2)];
      var $229=$47;
      HEAP32[(($47)>>2)]=$__t21_i_i_i;
      var $230=HEAP32[(($47)>>2)];
      var $231=$47;
      var $232=$56;
      var $233=$230;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($232)>>2)]=HEAP32[(($233)>>2)];HEAP32[(($232+4)>>2)]=HEAP32[(($233+4)>>2)];
      var $tmp_i_i_i_i=$52;
      var $tmp1_i_i_i_i=$56;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i_i)]=HEAP8[($tmp1_i_i_i_i)];HEAP8[($tmp_i_i_i_i+1)]=HEAP8[($tmp1_i_i_i_i+1)];HEAP8[($tmp_i_i_i_i+2)]=HEAP8[($tmp1_i_i_i_i+2)];HEAP8[($tmp_i_i_i_i+3)]=HEAP8[($tmp1_i_i_i_i+3)];HEAP8[($tmp_i_i_i_i+4)]=HEAP8[($tmp1_i_i_i_i+4)];HEAP8[($tmp_i_i_i_i+5)]=HEAP8[($tmp1_i_i_i_i+5)];HEAP8[($tmp_i_i_i_i+6)]=HEAP8[($tmp1_i_i_i_i+6)];HEAP8[($tmp_i_i_i_i+7)]=HEAP8[($tmp1_i_i_i_i+7)];
      var $234=$50;
      var $235=$51;
      HEAP32[(($50)>>2)]=$224;
      HEAP32[(($51)>>2)]=$228;
      var $236=HEAP32[(($50)>>2)];
      var $237=(($236)|0);
      var $238=$49;
      HEAP32[(($49)>>2)]=$51;
      var $239=HEAP32[(($49)>>2)];
      var $240=$49;
      var $241=HEAP32[(($239)>>2)];
      HEAP32[(($237)>>2)]=$241;
      var $242=(($236+4)|0);
      var $243=$48;
      HEAP32[(($48)>>2)]=$52;
      var $244=HEAP32[(($48)>>2)];
      var $245=$48;
      var $246=$242;
      var $247=$244;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($246)>>2)]=HEAP32[(($247)>>2)];HEAP32[(($246+4)>>2)]=HEAP32[(($247+4)>>2)];
      var $248=$50;
      var $249=$51;
      var $250=$52;
      var $251=$54;
      var $252=$55;
      var $253=$56;
      var $254=$__t21_i_i_i;
      var $255=$57;
      var $256=$58;
      var $257=$59;
      var $258=$61;
      var $259=$62;
      var $260=$63;
      var $261=$__d1_i;
      var $262=$64;
      var $263=$65;
      var $264=$__na;
      var $265=$45;
      HEAP32[(($45)>>2)]=$__hold;
      var $266=HEAP32[(($45)>>2)];
      var $267=(($266)|0);
      var $268=$44;
      HEAP32[(($44)>>2)]=$267;
      var $269=HEAP32[(($44)>>2)];
      var $270=$269;
      var $271=$43;
      HEAP32[(($43)>>2)]=$270;
      var $272=HEAP32[(($43)>>2)];
      var $273=(($272)|0);
      var $274=$43;
      var $275=$44;
      var $276=HEAP32[(($273)>>2)];
      var $277=$45;
      var $278=(($276+8)|0);
      var $279=$42;
      HEAP32[(($42)>>2)]=$278;
      var $280=HEAP32[(($42)>>2)];
      var $281=$280;
      var $282=$281;
      var $283=$42;
      var $284=$106;
      var $285=$39;
      var $286=$40;
      var $287=$41;
      HEAP32[(($39)>>2)]=$264;
      HEAP32[(($40)>>2)]=$282;
      HEAP32[(($41)>>2)]=$284;
      var $288=HEAP32[(($40)>>2)];
      var $289=$288;
      var $290=(($289)|0)==0;
      if ($290) { var $295 = 0;__label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $291
      var $292=$289;
      var $293=HEAP32[(($41)>>2)];
      var $294=HEAP32[(($293)>>2)];
      HEAP32[(($292)>>2)]=$294;
      var $295 = $292;__label__ = 9; break;
    case 9: // $_ZNSt3__116allocator_traitsINS_9allocatorINS_11__list_nodeIP18handler_entry_readPvEEEEE9constructIS4_S4_EEvRS7_PT_RKT0__exit
      var $295;
      var $296=$39;
      var $297=$40;
      var $298=$41;
      __label__ = 10; break;
    case 10: // $299
      var $300=$110;
      var $301=(($300)|0);
      var $302=$301;
      var $303=$38;
      HEAP32[(($38)>>2)]=$__hold;
      var $304=HEAP32[(($38)>>2)];
      var $305=(($304)|0);
      var $306=$37;
      HEAP32[(($37)>>2)]=$305;
      var $307=HEAP32[(($37)>>2)];
      var $308=$307;
      var $309=$36;
      HEAP32[(($36)>>2)]=$308;
      var $310=HEAP32[(($36)>>2)];
      var $311=(($310)|0);
      var $312=$36;
      var $313=$37;
      var $314=HEAP32[(($311)>>2)];
      var $315=$38;
      __label__ = 11; break;
    case 11: // $316
      var $317=$14;
      HEAP32[(($14)>>2)]=$__hold;
      var $318=HEAP32[(($14)>>2)];
      var $319=(($318)|0);
      var $320=$13;
      HEAP32[(($13)>>2)]=$319;
      var $321=HEAP32[(($13)>>2)];
      var $322=$321;
      var $323=$12;
      HEAP32[(($12)>>2)]=$322;
      var $324=HEAP32[(($12)>>2)];
      var $325=(($324)|0);
      var $326=$12;
      var $327=$13;
      var $328=HEAP32[(($325)>>2)];
      var $329=$14;
      __label__ = 12; break;
    case 12: // $330
      var $331=$9;
      var $332=$10;
      var $333=$11;
      HEAP32[(($9)>>2)]=$302;
      HEAP32[(($10)>>2)]=$314;
      HEAP32[(($11)>>2)]=$328;
      var $334=HEAP32[(($10)>>2)];
      var $335=HEAP32[(($9)>>2)];
      var $336=$335;
      var $337=(($336)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=$338;
      var $340=(($339+4)|0);
      HEAP32[(($340)>>2)]=$334;
      var $341=HEAP32[(($9)>>2)];
      var $342=$341;
      var $343=(($342)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=HEAP32[(($10)>>2)];
      var $346=$345;
      var $347=(($346)|0);
      HEAP32[(($347)>>2)]=$344;
      var $348=HEAP32[(($11)>>2)];
      var $349=HEAP32[(($9)>>2)];
      var $350=$349;
      var $351=(($350)|0);
      HEAP32[(($351)>>2)]=$348;
      var $352=HEAP32[(($9)>>2)];
      var $353=HEAP32[(($11)>>2)];
      var $354=$353;
      var $355=(($354+4)|0);
      HEAP32[(($355)>>2)]=$352;
      var $356=$9;
      var $357=$10;
      var $358=$11;
      __label__ = 13; break;
    case 13: // $359
      var $360=$110;
      var $361=$3;
      HEAP32[(($3)>>2)]=$360;
      var $362=HEAP32[(($3)>>2)];
      var $363=(($362+8)|0);
      var $364=$2;
      HEAP32[(($2)>>2)]=$363;
      var $365=HEAP32[(($2)>>2)];
      var $366=$365;
      var $367=$1;
      HEAP32[(($1)>>2)]=$366;
      var $368=HEAP32[(($1)>>2)];
      var $369=(($368)|0);
      var $370=$1;
      var $371=$2;
      var $372=$3;
      var $373=HEAP32[(($369)>>2)];
      var $374=(($373+1)|0);
      HEAP32[(($369)>>2)]=$374;
      var $375=$8;
      var $376=$__t_i;
      HEAP32[(($8)>>2)]=$__hold;
      var $377=HEAP32[(($8)>>2)];
      var $378=(($377)|0);
      var $379=$7;
      HEAP32[(($7)>>2)]=$378;
      var $380=HEAP32[(($7)>>2)];
      var $381=$380;
      var $382=$6;
      HEAP32[(($6)>>2)]=$381;
      var $383=HEAP32[(($6)>>2)];
      var $384=(($383)|0);
      var $385=$6;
      var $386=$7;
      var $387=HEAP32[(($384)>>2)];
      HEAP32[(($__t_i)>>2)]=$387;
      var $388=(($377)|0);
      var $389=$5;
      HEAP32[(($5)>>2)]=$388;
      var $390=HEAP32[(($5)>>2)];
      var $391=$390;
      var $392=$4;
      HEAP32[(($4)>>2)]=$391;
      var $393=HEAP32[(($4)>>2)];
      var $394=(($393)|0);
      var $395=$4;
      var $396=$5;
      HEAP32[(($394)>>2)]=0;
      var $397=HEAP32[(($__t_i)>>2)];
      var $398=$8;
      var $399=$__t_i;
      var $400=$35;
      HEAP32[(($35)>>2)]=$__hold;
      var $401=HEAP32[(($35)>>2)];
      var $402=$34;
      HEAP32[(($34)>>2)]=$401;
      var $403=HEAP32[(($34)>>2)];
      var $404=$32;
      var $405=$33;
      var $406=$__tmp_i_i_i2;
      HEAP32[(($32)>>2)]=$403;
      HEAP32[(($33)>>2)]=0;
      var $407=HEAP32[(($32)>>2)];
      var $408=(($407)|0);
      var $409=$31;
      HEAP32[(($31)>>2)]=$408;
      var $410=HEAP32[(($31)>>2)];
      var $411=$410;
      var $412=$30;
      HEAP32[(($30)>>2)]=$411;
      var $413=HEAP32[(($30)>>2)];
      var $414=(($413)|0);
      var $415=$30;
      var $416=$31;
      var $417=HEAP32[(($414)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$417;
      var $418=HEAP32[(($33)>>2)];
      var $419=(($407)|0);
      var $420=$18;
      HEAP32[(($18)>>2)]=$419;
      var $421=HEAP32[(($18)>>2)];
      var $422=$421;
      var $423=$17;
      HEAP32[(($17)>>2)]=$422;
      var $424=HEAP32[(($17)>>2)];
      var $425=(($424)|0);
      var $426=$17;
      var $427=$18;
      HEAP32[(($425)>>2)]=$418;
      var $428=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $429=(($428)|0)!=0;
      if ($429) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $430
      var $431=(($407)|0);
      var $432=$16;
      HEAP32[(($16)>>2)]=$431;
      var $433=HEAP32[(($16)>>2)];
      var $434=$433;
      var $435=$15;
      HEAP32[(($15)>>2)]=$434;
      var $436=HEAP32[(($15)>>2)];
      var $437=(($436+4)|0);
      var $438=$15;
      var $439=$16;
      var $440=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $441=$28;
      var $442=$29;
      HEAP32[(($28)>>2)]=$437;
      HEAP32[(($29)>>2)]=$440;
      var $443=HEAP32[(($28)>>2)];
      var $444=(($443)|0);
      var $445=HEAP32[(($444)>>2)];
      var $446=HEAP32[(($29)>>2)];
      var $447=(($443+4)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=$25;
      var $450=$26;
      var $451=$27;
      HEAP32[(($25)>>2)]=$445;
      HEAP32[(($26)>>2)]=$446;
      HEAP32[(($27)>>2)]=$448;
      var $452=HEAP32[(($25)>>2)];
      var $453=HEAP32[(($26)>>2)];
      var $454=HEAP32[(($27)>>2)];
      var $455=$22;
      var $456=$23;
      var $457=$24;
      HEAP32[(($22)>>2)]=$452;
      HEAP32[(($23)>>2)]=$453;
      HEAP32[(($24)>>2)]=$454;
      var $458=HEAP32[(($22)>>2)];
      var $459=HEAP32[(($23)>>2)];
      var $460=$459;
      var $461=$19;
      var $462=$20;
      var $463=$21;
      HEAP32[(($19)>>2)]=$460;
      var $464=HEAP32[(($19)>>2)];
      var $465=(($464)|0)!=0;
      if ($465) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $466
      var $467=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($467, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $468
      __label__ = 18; break;
    case 17: // $469
      var $470=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $471=$470.f0;
      HEAP32[(($20)>>2)]=$471;
      var $472=$470.f1;
      HEAP32[(($21)>>2)]=$472;
      var $473=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($473);
      throw "Reached an unreachable!"
    case 18: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIP18handler_entry_readPvEEEEEclEPS6__exit_i_i_i3
      var $474=$19;
      var $475=$20;
      var $476=$21;
      var $477=$22;
      var $478=$23;
      var $479=$24;
      var $480=$25;
      var $481=$26;
      var $482=$27;
      var $483=$28;
      var $484=$29;
      __label__ = 19; break;
    case 19: // $_ZNSt3__110unique_ptrINS_11__list_nodeIP18handler_entry_readPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev_exit4
      var $485=$32;
      var $486=$33;
      var $487=$__tmp_i_i_i2;
      var $488=$34;
      var $489=$35;
      STACKTOP = __stackBase__;
      return;
      var $491=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $492=$491.f0;
      $108=$492;
      var $493=$491.f1;
      $109=$493;
      var $494=$101;
      HEAP32[(($101)>>2)]=$__hold;
      var $495=HEAP32[(($101)>>2)];
      var $496=$100;
      HEAP32[(($100)>>2)]=$495;
      var $497=HEAP32[(($100)>>2)];
      var $498=$98;
      var $499=$99;
      var $500=$__tmp_i_i_i;
      HEAP32[(($98)>>2)]=$497;
      HEAP32[(($99)>>2)]=0;
      var $501=HEAP32[(($98)>>2)];
      var $502=(($501)|0);
      var $503=$97;
      HEAP32[(($97)>>2)]=$502;
      var $504=HEAP32[(($97)>>2)];
      var $505=$504;
      var $506=$96;
      HEAP32[(($96)>>2)]=$505;
      var $507=HEAP32[(($96)>>2)];
      var $508=(($507)|0);
      var $509=$96;
      var $510=$97;
      var $511=HEAP32[(($508)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$511;
      var $512=HEAP32[(($99)>>2)];
      var $513=(($501)|0);
      var $514=$84;
      HEAP32[(($84)>>2)]=$513;
      var $515=HEAP32[(($84)>>2)];
      var $516=$515;
      var $517=$83;
      HEAP32[(($83)>>2)]=$516;
      var $518=HEAP32[(($83)>>2)];
      var $519=(($518)|0);
      var $520=$83;
      var $521=$84;
      HEAP32[(($519)>>2)]=$512;
      var $522=HEAP32[(($__tmp_i_i_i)>>2)];
      var $523=(($522)|0)!=0;
      if ($523) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 20: // $524
      var $525=(($501)|0);
      var $526=$82;
      HEAP32[(($82)>>2)]=$525;
      var $527=HEAP32[(($82)>>2)];
      var $528=$527;
      var $529=$81;
      HEAP32[(($81)>>2)]=$528;
      var $530=HEAP32[(($81)>>2)];
      var $531=(($530+4)|0);
      var $532=$81;
      var $533=$82;
      var $534=HEAP32[(($__tmp_i_i_i)>>2)];
      var $535=$94;
      var $536=$95;
      HEAP32[(($94)>>2)]=$531;
      HEAP32[(($95)>>2)]=$534;
      var $537=HEAP32[(($94)>>2)];
      var $538=(($537)|0);
      var $539=HEAP32[(($538)>>2)];
      var $540=HEAP32[(($95)>>2)];
      var $541=(($537+4)|0);
      var $542=HEAP32[(($541)>>2)];
      var $543=$91;
      var $544=$92;
      var $545=$93;
      HEAP32[(($91)>>2)]=$539;
      HEAP32[(($92)>>2)]=$540;
      HEAP32[(($93)>>2)]=$542;
      var $546=HEAP32[(($91)>>2)];
      var $547=HEAP32[(($92)>>2)];
      var $548=HEAP32[(($93)>>2)];
      var $549=$88;
      var $550=$89;
      var $551=$90;
      HEAP32[(($88)>>2)]=$546;
      HEAP32[(($89)>>2)]=$547;
      HEAP32[(($90)>>2)]=$548;
      var $552=HEAP32[(($88)>>2)];
      var $553=HEAP32[(($89)>>2)];
      var $554=$553;
      var $555=$85;
      var $556=$86;
      var $557=$87;
      HEAP32[(($85)>>2)]=$554;
      var $558=HEAP32[(($85)>>2)];
      var $559=(($558)|0)!=0;
      if ($559) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $560
      var $561=HEAP32[(($85)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($561, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $562
      __label__ = 24; break;
    case 23: // $563
      var $564=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $565=$564.f0;
      HEAP32[(($86)>>2)]=$565;
      var $566=$564.f1;
      HEAP32[(($87)>>2)]=$566;
      var $567=HEAP32[(($86)>>2)];
      ___cxa_call_unexpected($567);
      throw "Reached an unreachable!"
    case 24: // $_ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIP18handler_entry_readPvEEEEEclEPS6__exit_i_i_i
      var $568=$85;
      var $569=$86;
      var $570=$87;
      var $571=$88;
      var $572=$89;
      var $573=$90;
      var $574=$91;
      var $575=$92;
      var $576=$93;
      var $577=$94;
      var $578=$95;
      __label__ = 25; break;
    case 25: // $_ZNSt3__110unique_ptrINS_11__list_nodeIP18handler_entry_readPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev_exit
      var $579=$98;
      var $580=$99;
      var $581=$__tmp_i_i_i;
      var $582=$100;
      var $583=$101;
      __label__ = 26; break;
    case 26: // $584
      __label__ = 27; break;
    case 27: // $585
      var $586=$108;
      var $587=$108;
      var $588=$109;
      var $589=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $587, tempValue);
      var $590=($589.f1 = $588, $589);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $592=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEE9push_backERKS2_["X"]=1;

function __ZN12memory_shareC2EjPv($this, $size, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$size;
  $3=$ptr;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$3;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  ;
  return;
}


function __ZN11simple_listI11memory_bankEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI11memory_bankE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI12memory_blockEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI12memory_blockE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI13address_spaceEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI13address_spaceE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN19handler_entry_proxyI18handler_entry_readEC1ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($this, $_handlers, $_mask$0, $_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$_handlers;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$_mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$_mask$1;
  var $4=$1;
  var $st$10$0=(($3)|0);
  var $5$0=HEAP32[(($st$10$0)>>2)];
  var $st$10$1=(($3+4)|0);
  var $5$1=HEAP32[(($st$10$1)>>2)];
  var $6=$2;
  __ZN19handler_entry_proxyI18handler_entry_readEC2ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($4, $6, $5$0, $5$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZN19handler_entry_proxyI18handler_entry_readEC2ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy($this, $_handlers, $_mask$0, $_mask$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$_handlers;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$_mask$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$_mask$1;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC1ERKS5_($5, $6);
  var $7=(($4+12)|0);
  var $st$14$0=(($3)|0);
  var $8$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$14$1)>>2)];
  var $st$18$0=(($7)|0);
  HEAP32[(($st$18$0)>>2)]=$8$0;
  var $st$18$1=(($7+4)|0);
  HEAP32[(($st$18$1)>>2)]=$8$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC1ERKS5_($this, $__c) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__c;
  var $3=$1;
  var $4=$2;
  __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC2ERKS5_($3, $4);
  ;
  return;
}


function __ZN11simple_listI13address_spaceEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI13address_spaceEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI12memory_blockEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI12memory_blockEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI11memory_bankEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI11memory_bankEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8tagmap_tIP11memory_bankEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP11memory_bankEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP12memory_shareEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP12memory_shareEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP12memory_shareEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN8tagmap_tIP11memory_bankEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC2ERKS5_($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 228; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $__t21_i_i=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $34=__stackBase__+136;
      var $35=__stackBase__+140;
      var $36=__stackBase__+144;
      var $37=__stackBase__+148;
      var $38=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48=__stackBase__+192;
      var $49=__stackBase__+196;
      var $50=__stackBase__+200;
      var $51=__stackBase__+204;
      var $52=__stackBase__+208;
      var $53;
      var $54;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $__i=__stackBase__+220;
      var $__e=__stackBase__+224;
      var $57;
      var $58;
      $53=$this;
      $54=$__c;
      var $59=$53;
      var $60=$59;
      var $61=$54;
      var $62=$61;
      var $63=$52;
      HEAP32[(($52)>>2)]=$62;
      var $64=HEAP32[(($52)>>2)];
      var $65=(($64+8)|0);
      var $66=$51;
      HEAP32[(($51)>>2)]=$65;
      var $67=HEAP32[(($51)>>2)];
      var $68=$67;
      var $69=$50;
      HEAP32[(($50)>>2)]=$68;
      var $70=HEAP32[(($50)>>2)];
      var $71=$70;
      var $72=$50;
      var $73=$51;
      var $74=$52;
      var $75=$46;
      var $76=$47;
      var $77=$48;
      var $78=$49;
      HEAP32[(($47)>>2)]=$71;
      var $79=$49;
      var $80=HEAP32[(($47)>>2)];
      var $tmp_i=$46;
      var $tmp1_i=$48;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $81=$45;
      HEAP32[(($45)>>2)]=$80;
      var $82=HEAP32[(($45)>>2)];
      var $83=$45;
      var $84=$46;
      var $85=$47;
      var $86=$48;
      var $87=$49;
      var $88=$42;
      var $89=$43;
      HEAP32[(($42)>>2)]=$55;
      HEAP32[(($43)>>2)]=$56;
      var $90=HEAP32[(($42)>>2)];
      var $91=HEAP32[(($43)>>2)];
      var $92=$40;
      var $93=$41;
      HEAP32[(($40)>>2)]=$90;
      HEAP32[(($41)>>2)]=$91;
      var $94=HEAP32[(($40)>>2)];
      var $95=$40;
      var $96=$41;
      var $97=$42;
      var $98=$43;
      var $99=$17;
      var $100=$20;
      var $101=$21;
      var $102=$22;
      HEAP32[(($20)>>2)]=$60;
      HEAP32[(($21)>>2)]=$55;
      var $103=HEAP32[(($20)>>2)];
      var $104=(($103)|0);
      var $105=$19;
      HEAP32[(($19)>>2)]=$104;
      var $106=HEAP32[(($19)>>2)];
      var $107=$18;
      HEAP32[(($18)>>2)]=$106;
      var $108=HEAP32[(($18)>>2)];
      var $109=(($108)|0);
      var $110=$108;
      HEAP32[(($109)>>2)]=$110;
      var $111=(($108+4)|0);
      var $112=$108;
      HEAP32[(($111)>>2)]=$112;
      var $113=$18;
      var $114=$19;
      var $115=(($103+8)|0);
      var $116=HEAP32[(($21)>>2)];
      var $117=$3;
      var $118=$4;
      HEAP32[(($3)>>2)]=$22;
      HEAP32[(($4)>>2)]=$116;
      var $119=HEAP32[(($3)>>2)];
      var $120=HEAP32[(($4)>>2)];
      var $121=$1;
      var $122=$2;
      HEAP32[(($1)>>2)]=$119;
      HEAP32[(($2)>>2)]=$120;
      var $123=HEAP32[(($1)>>2)];
      var $124=$1;
      var $125=$2;
      var $126=$3;
      var $127=$4;
      var $tmp_i1=$17;
      var $tmp1_i2=$22;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i1)]=HEAP8[($tmp1_i2)];
      var $128=$__t21_i_i;
      var $129=$15;
      var $130=$16;
      HEAP32[(($15)>>2)]=$115;
      HEAP32[(($16)>>2)]=0;
      var $131=HEAP32[(($15)>>2)];
      var $132=HEAP32[(($16)>>2)];
      var $tmp_i_i=$__t21_i_i;
      var $tmp2_i_i=$17;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp2_i_i)];
      var $133=$10;
      var $134=$12;
      var $135=$13;
      var $136=$14;
      HEAP32[(($12)>>2)]=$131;
      HEAP32[(($13)>>2)]=$132;
      var $137=HEAP32[(($12)>>2)];
      var $138=$137;
      var $139=$11;
      HEAP32[(($11)>>2)]=$13;
      var $140=HEAP32[(($11)>>2)];
      var $141=$11;
      var $142=HEAP32[(($140)>>2)];
      var $143=$5;
      HEAP32[(($5)>>2)]=$__t21_i_i;
      var $144=HEAP32[(($5)>>2)];
      var $145=$5;
      var $tmp_i_i_i=$10;
      var $tmp1_i_i_i=$14;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
      var $146=$8;
      var $147=$9;
      HEAP32[(($8)>>2)]=$138;
      HEAP32[(($9)>>2)]=$142;
      var $148=HEAP32[(($8)>>2)];
      var $149=$148;
      var $150=$7;
      HEAP32[(($7)>>2)]=$10;
      var $151=HEAP32[(($7)>>2)];
      var $152=$7;
      var $153=(($148)|0);
      var $154=$6;
      HEAP32[(($6)>>2)]=$9;
      var $155=HEAP32[(($6)>>2)];
      var $156=$6;
      var $157=HEAP32[(($155)>>2)];
      HEAP32[(($153)>>2)]=$157;
      var $158=$8;
      var $159=$9;
      var $160=$10;
      var $161=$12;
      var $162=$13;
      var $163=$14;
      var $164=$__t21_i_i;
      var $165=$15;
      var $166=$16;
      var $167=$17;
      var $168=$20;
      var $169=$21;
      var $170=$22;
      var $171=$54;
      var $172=$28;
      HEAP32[(($28)>>2)]=$171;
      var $173=HEAP32[(($28)>>2)];
      var $174=$173;
      var $175=$27;
      HEAP32[(($27)>>2)]=$174;
      var $176=HEAP32[(($27)>>2)];
      var $177=(($176)|0);
      var $178=(($177+4)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$25;
      var $181=$26;
      HEAP32[(($25)>>2)]=$__i;
      HEAP32[(($26)>>2)]=$179;
      var $182=HEAP32[(($25)>>2)];
      var $183=HEAP32[(($26)>>2)];
      var $184=$23;
      var $185=$24;
      HEAP32[(($23)>>2)]=$182;
      HEAP32[(($24)>>2)]=$183;
      var $186=HEAP32[(($23)>>2)];
      var $187=(($186)|0);
      var $188=HEAP32[(($24)>>2)];
      HEAP32[(($187)>>2)]=$188;
      var $189=$23;
      var $190=$24;
      var $191=$25;
      var $192=$26;
      var $193=$27;
      var $194=$28;
      var $195=$54;
      var $196=$34;
      HEAP32[(($34)>>2)]=$195;
      var $197=HEAP32[(($34)>>2)];
      var $198=$197;
      var $199=$33;
      HEAP32[(($33)>>2)]=$198;
      var $200=HEAP32[(($33)>>2)];
      var $201=(($200)|0);
      var $202=$201;
      var $203=$31;
      var $204=$32;
      HEAP32[(($31)>>2)]=$__e;
      HEAP32[(($32)>>2)]=$202;
      var $205=HEAP32[(($31)>>2)];
      var $206=HEAP32[(($32)>>2)];
      var $207=$29;
      var $208=$30;
      HEAP32[(($29)>>2)]=$205;
      HEAP32[(($30)>>2)]=$206;
      var $209=HEAP32[(($29)>>2)];
      var $210=(($209)|0);
      var $211=HEAP32[(($30)>>2)];
      HEAP32[(($210)>>2)]=$211;
      var $212=$29;
      var $213=$30;
      var $214=$31;
      var $215=$32;
      var $216=$33;
      var $217=$34;
      __label__ = 1; break;
    case 1: // $218
      var $219=$37;
      var $220=$38;
      HEAP32[(($37)>>2)]=$__i;
      HEAP32[(($38)>>2)]=$__e;
      var $221=HEAP32[(($37)>>2)];
      var $222=HEAP32[(($38)>>2)];
      var $223=$35;
      var $224=$36;
      HEAP32[(($35)>>2)]=$221;
      HEAP32[(($36)>>2)]=$222;
      var $225=HEAP32[(($35)>>2)];
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=HEAP32[(($36)>>2)];
      var $229=(($228)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=(($227)|0)==(($230)|0);
      var $232=$35;
      var $233=$36;
      var $234=$231 ^ 1;
      var $235=$37;
      var $236=$38;
      __label__ = 2; break;
    case 2: // $237
      if ($234) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $238
      var $239=$39;
      HEAP32[(($39)>>2)]=$__i;
      var $240=HEAP32[(($39)>>2)];
      var $241=(($240)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242+8)|0);
      var $244=$39;
      __label__ = 4; break;
    case 4: // $245
      (function() { try { __THREW__ = false; return __ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEE9push_backERKS2_($59, $243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $246
      __label__ = 6; break;
    case 6: // $247
      var $248=$44;
      HEAP32[(($44)>>2)]=$__i;
      var $249=HEAP32[(($44)>>2)];
      var $250=(($249)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$251;
      var $253=(($252+4)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($249)|0);
      HEAP32[(($255)>>2)]=$254;
      var $256=$44;
      __label__ = 7; break;
    case 7: // $257
      __label__ = 1; break;
    case 8: // $258
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $260=$259.f0;
      $57=$260;
      var $261=$259.f1;
      $58=$261;
      var $262=$59;
      (function() { try { __THREW__ = false; return __ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEED2Ev($262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 9: // $263
      STACKTOP = __stackBase__;
      return;
    case 10: // $264
      __label__ = 11; break;
    case 11: // $265
      var $266=$57;
      var $267=$57;
      var $268=$58;
      var $269=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $267, tempValue);
      var $270=($269.f1 = $268, $269);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $271
      var $272=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC2ERKS5_["X"]=1;

function __ZN15_memory_privateC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+1028)|0);
      __ZN11simple_listI13address_spaceEC1ER13resource_pool($5, _global_resource_pool);
      var $6=(($4+1048)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12memory_blockEC1ER13resource_pool($6, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=(($4+1068)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11memory_bankEC1ER13resource_pool($8, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=(($4+1088)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP11memory_bankEC1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $11
      var $12=(($4+1480)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP12memory_shareEC1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $13
      ;
      return;
    case 5: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $2=$16;
      var $17=$15.f1;
      $3=$17;
      __label__ = 14; break;
    case 6: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $2=$20;
      var $21=$19.f1;
      $3=$21;
      __label__ = 12; break;
    case 7: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      __label__ = 10; break;
    case 8: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      var $30=(($4+1088)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP11memory_bankED1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 17; break; }
    case 9: // $31
      __label__ = 10; break;
    case 10: // $32
      var $33=(($4+1068)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11memory_bankED1Ev($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $34
      __label__ = 12; break;
    case 12: // $35
      var $36=(($4+1048)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12memory_blockED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $37
      __label__ = 14; break;
    case 14: // $38
      var $39=(($4+1028)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI13address_spaceED1Ev($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $40
      __label__ = 16; break;
    case 16: // $41
      var $42=$2;
      var $43=$2;
      var $44=$3;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15_memory_privateC2Ev["X"]=1;

function __ZThn356_N10cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN10cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn5968_N10cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN10cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn6012_N10cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN10cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn7088_N10cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN10cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn356_N10cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN10cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZThn5968_N10cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN10cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZThn6012_N10cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN10cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZThn7088_N10cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN10cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZN10cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S6_S4_j($this, $mconfig, $type, $name, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $1=$this;
      $2=$mconfig;
      $3=$type;
      $4=$name;
      $5=$tag;
      $6=$owner;
      $7=$clock;
      var $10=$1;
      var $11=$10;
      var $12=$2;
      var $13=$3;
      var $14=$4;
      var $15=$5;
      var $16=$6;
      var $17=$7;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($11, $12, $13, $14, $15, $16, $17);
      var $18=$10;
      HEAP32[(($18)>>2)]=((__ZTV10cpu_device+8)|0);
      var $19=$10;
      var $20=(($19+356)|0);
      var $21=$20;
      HEAP32[(($21)>>2)]=((__ZTV10cpu_device+76)|0);
      var $22=$10;
      var $23=(($22+5968)|0);
      var $24=$23;
      HEAP32[(($24)>>2)]=((__ZTV10cpu_device+176)|0);
      var $25=$10;
      var $26=(($25+6012)|0);
      var $27=$26;
      HEAP32[(($27)>>2)]=((__ZTV10cpu_device+260)|0);
      var $28=$10;
      var $29=(($28+7088)|0);
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTV10cpu_device+340)|0);
      var $31=$10;
      var $32=(($31+356)|0);
      var $33=$32;
      var $34=$2;
      var $35=$10;
      (function() { try { __THREW__ = false; return __ZN24device_execute_interfaceC2ERK14machine_configR8device_t($33, $34, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $36
      var $37=$10;
      HEAP32[(($37)>>2)]=((__ZTV10cpu_device+8)|0);
      var $38=$10;
      var $39=(($38+356)|0);
      var $40=$39;
      HEAP32[(($40)>>2)]=((__ZTV10cpu_device+76)|0);
      var $41=$10;
      var $42=(($41+5968)|0);
      var $43=$42;
      HEAP32[(($43)>>2)]=((__ZTV10cpu_device+176)|0);
      var $44=$10;
      var $45=(($44+6012)|0);
      var $46=$45;
      HEAP32[(($46)>>2)]=((__ZTV10cpu_device+260)|0);
      var $47=$10;
      var $48=(($47+7088)|0);
      var $49=$48;
      HEAP32[(($49)>>2)]=((__ZTV10cpu_device+340)|0);
      var $50=$10;
      var $51=(($50+5968)|0);
      var $52=$51;
      var $53=$2;
      var $54=$10;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interfaceC2ERK14machine_configR8device_t($52, $53, $54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $55
      var $56=$10;
      HEAP32[(($56)>>2)]=((__ZTV10cpu_device+8)|0);
      var $57=$10;
      var $58=(($57+356)|0);
      var $59=$58;
      HEAP32[(($59)>>2)]=((__ZTV10cpu_device+76)|0);
      var $60=$10;
      var $61=(($60+5968)|0);
      var $62=$61;
      HEAP32[(($62)>>2)]=((__ZTV10cpu_device+176)|0);
      var $63=$10;
      var $64=(($63+6012)|0);
      var $65=$64;
      HEAP32[(($65)>>2)]=((__ZTV10cpu_device+260)|0);
      var $66=$10;
      var $67=(($66+7088)|0);
      var $68=$67;
      HEAP32[(($68)>>2)]=((__ZTV10cpu_device+340)|0);
      var $69=$10;
      var $70=(($69+6012)|0);
      var $71=$70;
      var $72=$2;
      var $73=$10;
      (function() { try { __THREW__ = false; return __ZN22device_state_interfaceC2ERK14machine_configR8device_t($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $74
      var $75=$10;
      HEAP32[(($75)>>2)]=((__ZTV10cpu_device+8)|0);
      var $76=$10;
      var $77=(($76+356)|0);
      var $78=$77;
      HEAP32[(($78)>>2)]=((__ZTV10cpu_device+76)|0);
      var $79=$10;
      var $80=(($79+5968)|0);
      var $81=$80;
      HEAP32[(($81)>>2)]=((__ZTV10cpu_device+176)|0);
      var $82=$10;
      var $83=(($82+6012)|0);
      var $84=$83;
      HEAP32[(($84)>>2)]=((__ZTV10cpu_device+260)|0);
      var $85=$10;
      var $86=(($85+7088)|0);
      var $87=$86;
      HEAP32[(($87)>>2)]=((__ZTV10cpu_device+340)|0);
      var $88=$10;
      var $89=(($88+7088)|0);
      var $90=$89;
      var $91=$2;
      var $92=$10;
      (function() { try { __THREW__ = false; return __ZN23device_disasm_interfaceC2ERK14machine_configR8device_t($90, $91, $92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $93
      var $94=$10;
      HEAP32[(($94)>>2)]=((__ZTV10cpu_device+8)|0);
      var $95=$10;
      var $96=(($95+356)|0);
      var $97=$96;
      HEAP32[(($97)>>2)]=((__ZTV10cpu_device+76)|0);
      var $98=$10;
      var $99=(($98+5968)|0);
      var $100=$99;
      HEAP32[(($100)>>2)]=((__ZTV10cpu_device+176)|0);
      var $101=$10;
      var $102=(($101+6012)|0);
      var $103=$102;
      HEAP32[(($103)>>2)]=((__ZTV10cpu_device+260)|0);
      var $104=$10;
      var $105=(($104+7088)|0);
      var $106=$105;
      HEAP32[(($106)>>2)]=((__ZTV10cpu_device+340)|0);
      ;
      return;
    case 5: // $107
      var $108=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $109=$108.f0;
      $8=$109;
      var $110=$108.f1;
      $9=$110;
      __label__ = 14; break;
    case 6: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $8=$113;
      var $114=$112.f1;
      $9=$114;
      __label__ = 12; break;
    case 7: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $117=$116.f0;
      $8=$117;
      var $118=$116.f1;
      $9=$118;
      __label__ = 10; break;
    case 8: // $119
      var $120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $121=$120.f0;
      $8=$121;
      var $122=$120.f1;
      $9=$122;
      var $123=$10;
      var $124=(($123+6012)|0);
      var $125=$124;
      (function() { try { __THREW__ = false; return __ZN22device_state_interfaceD2Ev($125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 17; break; }
    case 9: // $126
      __label__ = 10; break;
    case 10: // $127
      var $128=$10;
      var $129=(($128+5968)|0);
      var $130=$129;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interfaceD2Ev($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $131
      __label__ = 12; break;
    case 12: // $132
      var $133=$10;
      var $134=(($133+356)|0);
      var $135=$134;
      (function() { try { __THREW__ = false; return __ZN24device_execute_interfaceD2Ev($135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $136
      __label__ = 14; break;
    case 14: // $137
      var $138=$10;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $139
      __label__ = 16; break;
    case 16: // $140
      var $141=$8;
      var $142=$8;
      var $143=$9;
      var $144=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $142, tempValue);
      var $145=($144.f1 = $143, $144);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $146
      var $147=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S6_S4_j["X"]=1;

function __ZN10cpu_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10cpu_deviceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10cpu_deviceD0Ev["X"]=1;

function __ZN10cpu_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+7088)|0);
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN23device_disasm_interfaceD2Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=$4;
      var $10=(($9+6012)|0);
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN22device_state_interfaceD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$4;
      var $14=(($13+5968)|0);
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interfaceD2Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $16
      var $17=$4;
      var $18=(($17+356)|0);
      var $19=$18;
      (function() { try { __THREW__ = false; return __ZN24device_execute_interfaceD2Ev($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $20
      var $21=$4;
      __ZN8device_tD2Ev($21);
      ;
      return;
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      var $26=$4;
      var $27=(($26+6012)|0);
      var $28=$27;
      (function() { try { __THREW__ = false; return __ZN22device_state_interfaceD2Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 17; break; }
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $2=$31;
      var $32=$30.f1;
      $3=$32;
      __label__ = 9; break;
    case 7: // $33
      __label__ = 9; break;
    case 8: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $2=$36;
      var $37=$35.f1;
      $3=$37;
      __label__ = 12; break;
    case 9: // $38
      var $39=$4;
      var $40=(($39+5968)|0);
      var $41=$40;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interfaceD2Ev($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $42
      __label__ = 12; break;
    case 11: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $2=$45;
      var $46=$44.f1;
      $3=$46;
      __label__ = 14; break;
    case 12: // $47
      var $48=$4;
      var $49=(($48+356)|0);
      var $50=$49;
      (function() { try { __THREW__ = false; return __ZN24device_execute_interfaceD2Ev($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $51
      __label__ = 14; break;
    case 14: // $52
      var $53=$4;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $54
      __label__ = 16; break;
    case 16: // $55
      var $56=$2;
      var $57=$2;
      var $58=$3;
      var $59=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $57, tempValue);
      var $60=($59.f1 = $58, $59);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10cpu_deviceD2Ev["X"]=1;

function __ZNK17legacy_cpu_device14get_legacy_fctEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=$info;
  HEAP32[(($4)>>2)]=0; HEAP32[(($4+4)>>2)]=0;
  var $5=(($3+7100)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  FUNCTION_TABLE[$6]($3, $7, $info);
  var $8=$info;
  var $9=HEAP32[(($8)>>2)];
  STACKTOP = __stackBase__;
  return $9;
}


function __ZNK17legacy_cpu_device14get_legacy_intEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=$info;
  HEAP32[(($4)>>2)]=0; HEAP32[(($4+4)>>2)]=0;
  var $5=(($3+7100)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  FUNCTION_TABLE[$6]($3, $7, $info);
  var $8=$info;
  var $st$13$0=(($8)|0);
  var $9$0=HEAP32[(($st$13$0)>>2)];
  var $st$13$1=(($8+4)|0);
  var $9$1=HEAP32[(($st$13$1)>>2)];
  STACKTOP = __stackBase__;
  return [$9$0,$9$1];
}


function __ZNK17legacy_cpu_device17get_legacy_stringEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=__Z22get_temp_string_bufferv();
  var $5=$info;
  HEAP32[(($5)>>2)]=$4;
  var $6=(($3+7100)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  FUNCTION_TABLE[$7]($3, $8, $info);
  var $9=$info;
  var $10=HEAP32[(($9)>>2)];
  STACKTOP = __stackBase__;
  return $10;
}


function __ZThn356_N17legacy_cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN17legacy_cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn5968_N17legacy_cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  __ZN17legacy_cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn6012_N17legacy_cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  __ZN17legacy_cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn7088_N17legacy_cpu_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  __ZN17legacy_cpu_deviceD0Ev($5);
  ;
  return;
}


function __ZThn356_N17legacy_cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN17legacy_cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZThn5968_N17legacy_cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-5968)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN17legacy_cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZThn6012_N17legacy_cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-6012)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN17legacy_cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZThn7088_N17legacy_cpu_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-7088)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN17legacy_cpu_deviceD1Ev]($5);
  ;
  return;
}


function __ZN17legacy_cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPS_jP7cpuinfoE($this, $mconfig, $type, $tag, $owner, $clock, $get_info) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $spacenum=__stackBase__+28;
      var $tokenbytes;
      $7=$this;
      $8=$mconfig;
      $9=$type;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      $13=$get_info;
      var $16=$7;
      var $17=$16;
      var $18=$8;
      var $19=$9;
      var $20=$10;
      var $21=$11;
      var $22=$12;
      __ZN10cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S6_S4_j($17, $18, $19, ((STRING_TABLE.__str3114)|0), $20, $21, $22);
      var $23=$16;
      HEAP32[(($23)>>2)]=((__ZTV17legacy_cpu_device+8)|0);
      var $24=$16;
      var $25=(($24+356)|0);
      var $26=$25;
      HEAP32[(($26)>>2)]=((__ZTV17legacy_cpu_device+156)|0);
      var $27=$16;
      var $28=(($27+5968)|0);
      var $29=$28;
      HEAP32[(($29)>>2)]=((__ZTV17legacy_cpu_device+256)|0);
      var $30=$16;
      var $31=(($30+6012)|0);
      var $32=$31;
      HEAP32[(($32)>>2)]=((__ZTV17legacy_cpu_device+340)|0);
      var $33=$16;
      var $34=(($33+7088)|0);
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTV17legacy_cpu_device+420)|0);
      var $36=(($16+7100)|0);
      var $37=$13;
      HEAP32[(($36)>>2)]=$37;
      var $38=(($16+7104)|0);
      var $39=(($38)|0);
      var $40=(($39+72)|0);
      var $42 = $39;__label__ = 1; break;
    case 1: // $41
      var $42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN20address_space_configC1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 27; break; }
    case 2: // $43
      var $44=(($42+24)|0);
      var $45=(($44)|0)==(($40)|0);
      if ($45) { __label__ = 3; break; } else { var $42 = $44;__label__ = 1; break; }
    case 3: // $46
      var $47=(($16+7176)|0);
      HEAP32[(($47)>>2)]=0;
      var $48=(($16+7180)|0);
      var $49=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147456) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 27; break; };
    case 4: // $50
      var $51=$49;
      HEAP32[(($48)>>2)]=$51;
      var $52=(($16+7184)|0);
      var $53=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 27; break; };
    case 5: // $54
      var $55=$53;
      HEAP32[(($52)>>2)]=$55;
      var $56=(($16+7188)|0);
      var $57=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147461) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 27; break; };
    case 6: // $58
      var $59=$57;
      HEAP32[(($56)>>2)]=$59;
      var $60=(($16+7192)|0);
      var $61=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147463) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 27; break; };
    case 7: // $62
      var $63=$61;
      HEAP32[(($60)>>2)]=$63;
      var $64=(($16+7196)|0);
      var $65=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147464) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 27; break; };
    case 8: // $66
      var $67=$65;
      HEAP32[(($64)>>2)]=$67;
      var $68=(($16+7200)|0);
      var $69=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147465) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 27; break; };
    case 9: // $70
      var $71=$69;
      HEAP32[(($68)>>2)]=$71;
      var $72=(($16+7204)|0);
      var $73=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147466) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 27; break; };
    case 10: // $74
      var $75=$73;
      HEAP32[(($72)>>2)]=$75;
      var $76=(($16+7208)|0);
      var $77=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147462) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 27; break; };
    case 11: // $78
      var $79=$77;
      HEAP32[(($76)>>2)]=$79;
      var $80=(($16+7212)|0);
      var $81=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 27; break; };
    case 12: // $82
      var $83=$81;
      HEAP32[(($80)>>2)]=$83;
      var $84=(($16+7216)|0);
      var $85=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147469) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 27; break; };
    case 13: // $86
      var $87=$85;
      HEAP32[(($84)>>2)]=$87;
      var $88=(($16+7220)|0);
      var $89=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 27; break; };
    case 14: // $90
      var $91=$89;
      HEAP32[(($88)>>2)]=$91;
      var $92=(($16+7224)|0);
      var $93=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, 147459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 27; break; };
    case 15: // $94
      var $95=$93;
      HEAP32[(($92)>>2)]=$95;
      var $96=(($16+7236)|0);
      HEAP8[($96)]=0;
      var $97=(($16+7237)|0);
      HEAP8[($97)]=0;
      var $98=(($16+7104)|0);
      var $99=(($98)|0);
      var $100=$99;
      _memset($100, 0, 72, 1);
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 16; break;
    case 16: // $101
      var $102=HEAPU32[(($spacenum)>>2)];
      var $103=(($102)>>>0) < 3;
      if ($103) { __label__ = 17; break; } else { __label__ = 35; break; }
    case 17: // $104
      var $105=HEAP32[(($spacenum)>>2)];
      var $106=(($105)|0)==1;
      if ($106) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $107
      var $113 = ((STRING_TABLE.__str13115)|0);__label__ = 20; break;
    case 19: // $108
      var $109=HEAP32[(($spacenum)>>2)];
      var $110=(($109)|0)==2;
      var $111=$110 ? (((STRING_TABLE.__str23116)|0)) : (((STRING_TABLE.__str33117)|0));
      var $113 = $111;__label__ = 20; break;
    case 20: // $112
      var $113;
      var $114=HEAP32[(($spacenum)>>2)];
      var $115=(($16+7104)|0);
      var $116=(($115+$114*24)|0);
      var $117=(($116)|0);
      HEAP32[(($117)>>2)]=$113;
      var $118=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 27; break; };
      var $118$0=$118[0];
      var $118$1=$118[1];
    case 21: // $119
      var $120$0=$118$0;
      var $120=$120$0;
      var $121=HEAP32[(($spacenum)>>2)];
      var $122=(($16+7104)|0);
      var $123=(($122+$121*24)|0);
      var $124=(($123+4)|0);
      HEAP32[(($124)>>2)]=$120;
      var $125=HEAP32[(($spacenum)>>2)];
      var $126=(($125+3)|0);
      var $127=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, $126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 27; break; };
      var $127$0=$127[0];
      var $127$1=$127[1];
    case 22: // $128
      var $129$0=$127$0;
      var $129=$129$0&255;
      var $130=HEAP32[(($spacenum)>>2)];
      var $131=(($16+7104)|0);
      var $132=(($131+$130*24)|0);
      var $133=(($132+8)|0);
      HEAP8[($133)]=$129;
      var $134=HEAP32[(($spacenum)>>2)];
      var $135=(($134+7)|0);
      var $136=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, $135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 27; break; };
      var $136$0=$136[0];
      var $136$1=$136[1];
    case 23: // $137
      var $138$0=$136$0;
      var $138=$138$0&255;
      var $139=HEAP32[(($spacenum)>>2)];
      var $140=(($16+7104)|0);
      var $141=(($140+$139*24)|0);
      var $142=(($141+9)|0);
      HEAP8[($142)]=$138;
      var $143=HEAP32[(($spacenum)>>2)];
      var $144=(($143+11)|0);
      var $145=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, $144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 27; break; };
      var $145$0=$145[0];
      var $145$1=$145[1];
    case 24: // $146
      var $147$0=$145$0;
      var $147=$147$0&255;
      var $148=HEAP32[(($spacenum)>>2)];
      var $149=(($16+7104)|0);
      var $150=(($149+$148*24)|0);
      var $151=(($150+10)|0);
      HEAP8[($151)]=$147;
      var $152=HEAP32[(($spacenum)>>2)];
      var $153=(($152+16393)|0);
      var $154=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, $153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 27; break; };
      var $154$0=$154[0];
      var $154$1=$154[1];
    case 25: // $155
      var $156$0=$154$0;
      var $156=$156$0&255;
      var $157=HEAP32[(($spacenum)>>2)];
      var $158=(($16+7104)|0);
      var $159=(($158+$157*24)|0);
      var $160=(($159+11)|0);
      HEAP8[($160)]=$156;
      var $161=HEAP32[(($spacenum)>>2)];
      var $162=(($16+7104)|0);
      var $163=(($162+$161*24)|0);
      var $164=(($163+11)|0);
      var $165=HEAPU8[($164)];
      var $166=(($165)&255);
      var $167=(($166)|0)==0;
      if ($167) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $168
      var $169=HEAP32[(($spacenum)>>2)];
      var $170=(($16+7104)|0);
      var $171=(($170+$169*24)|0);
      var $172=(($171+9)|0);
      var $173=HEAP8[($172)];
      var $174=HEAP32[(($spacenum)>>2)];
      var $175=(($16+7104)|0);
      var $176=(($175+$174*24)|0);
      var $177=(($176+11)|0);
      HEAP8[($177)]=$173;
      __label__ = 29; break;
    case 27: // $178
      var $179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $179;__label__ = 28; break;
    case 28: // $_body
      var $eh_lpad_body;
      var $180=$eh_lpad_body.f0;
      $14=$180;
      var $181=$eh_lpad_body.f1;
      $15=$181;
      __label__ = 56; break;
    case 29: // $182
      var $183=HEAP32[(($spacenum)>>2)];
      var $184=(($183+16397)|0);
      var $185=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, $184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 27; break; };
      var $185$0=$185[0];
      var $185$1=$185[1];
    case 30: // $186
      var $187$0=$185$0;
      var $187=$187$0&255;
      var $188=HEAP32[(($spacenum)>>2)];
      var $189=(($16+7104)|0);
      var $190=(($189+$188*24)|0);
      var $191=(($190+12)|0);
      HEAP8[($191)]=$187;
      var $192=HEAP32[(($spacenum)>>2)];
      var $193=(($192+65539)|0);
      var $194=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, $193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 27; break; };
    case 31: // $195
      var $196=$194;
      var $197=HEAP32[(($spacenum)>>2)];
      var $198=(($16+7104)|0);
      var $199=(($198+$197*24)|0);
      var $200=(($199+16)|0);
      var $201=$200;
      HEAP32[(($201)>>2)]=$196;
      var $202=HEAP32[(($spacenum)>>2)];
      var $203=(($202+65543)|0);
      var $204=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_fctEj($16, $203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 27; break; };
    case 32: // $205
      var $206=$204;
      var $207=HEAP32[(($spacenum)>>2)];
      var $208=(($16+7104)|0);
      var $209=(($208+$207*24)|0);
      var $210=(($209+20)|0);
      var $211=$210;
      HEAP32[(($211)>>2)]=$206;
      __label__ = 33; break;
    case 33: // $212
      (function() { try { __THREW__ = false; return __ZppR16address_spacenumi($spacenum, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 27; break; }
    case 34: // $213
      __label__ = 16; break;
    case 35: // $214
      var $215=$16;
      var $216=(($215+52)|0);
      var $217=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device17get_legacy_stringEj($16, 196608) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 27; break; };
    case 36: // $218
      var $219=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($216, $217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 27; break; };
    case 37: // $220
      var $221=$16;
      var $222=(($221+116)|0);
      var $223=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device17get_legacy_stringEj($16, 196609) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 27; break; };
    case 38: // $224
      var $225=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($222, $223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 27; break; };
    case 39: // $226
      var $227=$16;
      var $228=(($227+180)|0);
      var $229=$16;
      var $230=(($229+116)|0);
      var $231=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($228, $230) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 27; break; };
    case 40: // $232
      var $233=$16;
      var $234=(($233+356)|0);
      var $235=$234;
      var $236=(($235+5524)|0);
      var $237=$236;
      for (var $$dest = $237, $$stop = $$dest + 12; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $238=(function() { try { __THREW__ = false; return __ZNK17legacy_cpu_device14get_legacy_intEj($16, 16384) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 27; break; };
      var $238$0=$238[0];
      var $238$1=$238[1];
    case 41: // $239
      var $240$0=$238$0;
      var $240=$240$0;
      $tokenbytes=$240;
      var $241=$tokenbytes;
      var $242=(($241)|0)==0;
      if ($242) { __label__ = 42; break; } else { __label__ = 45; break; }
    case 42: // $243
      var $244=___cxa_allocate_exception(1032);
      var $245=$244;
      var $246=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($245, ((STRING_TABLE.__str43118)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$246,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $247
      (function() { try { __THREW__ = false; return ___cxa_throw($244, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 27; break; }
    case 44: // $248
      var $249=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $250=$249.f0;
      $14=$250;
      var $251=$249.f1;
      $15=$251;
      ___cxa_free_exception($244);
      __label__ = 56; break;
    case 45: // $252
      var $253=$tokenbytes;
      var $254=(($253)|0) < 0;
      var $255=$254 ? -1 : $253;
      var $256=$1;
      var $257=$2;
      var $258=$3;
      var $259=$4;
      var $260=$result_i;
      var $261=$5;
      var $262=$6;
      HEAP32[(($1)>>2)]=$255;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str53119)|0);
      HEAP32[(($3)>>2)]=124;
      HEAP32[(($4)>>2)]=_zeromem;
      var $263=HEAP32[(($1)>>2)];
      var $264=HEAP32[(($2)>>2)];
      var $265=HEAP32[(($3)>>2)];
      var $266=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($263, $264, $265) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 48; break; };
    case 46: // $267
      HEAP32[(($result_i)>>2)]=$266;
      var $268=HEAP32[(($result_i)>>2)];
      var $269=(($268)|0)==0;
      if ($269) { __label__ = 47; break; } else { __label__ = 53; break; }
    case 47: // $270
      var $271=___cxa_allocate_exception(4);
      var $272=$271;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($272);
      (function() { try { __THREW__ = false; return ___cxa_throw($271, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 48; break; }
    case 48: // $273
      var $274=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $275=$274.f0;
      HEAP32[(($5)>>2)]=$275;
      var $276=$274.f1;
      HEAP32[(($6)>>2)]=$276;
      var $277=HEAP32[(($6)>>2)];
      var $278=(($277)|0) < 0;
      if ($278) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $279
      var $280=HEAP32[(($5)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 27; break; }
    case 50: // $_noexc
      throw "Reached an unreachable!"
    case 51: // $281
      var $282=HEAP32[(($5)>>2)];
      var $283=HEAP32[(($5)>>2)];
      var $284=HEAP32[(($6)>>2)];
      var $285=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $283, tempValue);
      var $286=($285.f1 = $284, $285);
      var $eh_lpad_body = $286;__label__ = 28; break;
    case 52: // $287
      throw "Reached an unreachable!"
    case 53: // $_ZnajPKciRK9zeromem_t_exit
      var $288=HEAP32[(($result_i)>>2)];
      var $289=HEAP32[(($1)>>2)];
      _memset($288, 0, $289, 1);
      var $290=HEAP32[(($result_i)>>2)];
      var $291=$1;
      var $292=$2;
      var $293=$3;
      var $294=$4;
      var $295=$result_i;
      var $296=$5;
      var $297=$6;
      __label__ = 54; break;
    case 54: // $298
      var $299=$tokenbytes;
      var $300=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $290, $299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 27; break; };
    case 55: // $301
      var $302=(($16+7176)|0);
      HEAP32[(($302)>>2)]=$300;
      STACKTOP = __stackBase__;
      return;
    case 56: // $303
      var $304=$16;
      (function() { try { __THREW__ = false; return __ZN10cpu_deviceD2Ev($304) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $305
      __label__ = 58; break;
    case 58: // $306
      var $307=$14;
      var $308=$14;
      var $309=$15;
      var $310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $308, tempValue);
      var $311=($310.f1 = $309, $310);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 59: // $312
      var $313=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 60: // $314
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17legacy_cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPS_jP7cpuinfoE["X"]=1;

function __ZN17legacy_cpu_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17legacy_cpu_deviceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17legacy_cpu_deviceD0Ev["X"]=1;

function __ZN17legacy_cpu_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV17legacy_cpu_device+8)|0);
      var $6=$4;
      var $7=(($6+356)|0);
      var $8=$7;
      HEAP32[(($8)>>2)]=((__ZTV17legacy_cpu_device+156)|0);
      var $9=$4;
      var $10=(($9+5968)|0);
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV17legacy_cpu_device+256)|0);
      var $12=$4;
      var $13=(($12+6012)|0);
      var $14=$13;
      HEAP32[(($14)>>2)]=((__ZTV17legacy_cpu_device+340)|0);
      var $15=$4;
      var $16=(($15+7088)|0);
      var $17=$16;
      HEAP32[(($17)>>2)]=((__ZTV17legacy_cpu_device+420)|0);
      var $18=(($4+7176)|0);
      var $19=HEAP32[(($18)>>2)];
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$4;
      __ZN10cpu_deviceD2Ev($21);
      ;
      return;
    case 2: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      var $26=$4;
      (function() { try { __THREW__ = false; return __ZN10cpu_deviceD2Ev($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $27
      __label__ = 4; break;
    case 4: // $28
      var $29=$2;
      var $30=$2;
      var $31=$3;
      var $32=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30, tempValue);
      var $33=($32.f1 = $31, $32);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI18device_state_entryE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN22device_state_interface9state_addIyEER18device_state_entryiPKcRT_($this, $index, $symbol, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$index;
  $3=$symbol;
  $4=$data;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=$8;
  var $10=__ZN22device_state_interface9state_addEiPKcPvh($5, $6, $7, $9, 8);
  ;
  return $10;
}


function __ZNK17legacy_cpu_device14get_legacy_ptrEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=$info;
  HEAP32[(($4)>>2)]=0; HEAP32[(($4+4)>>2)]=0;
  var $5=(($3+7100)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  FUNCTION_TABLE[$6]($3, $7, $info);
  var $8=$info;
  var $9=HEAP32[(($8)>>2)];
  STACKTOP = __stackBase__;
  return $9;
}


function __ZN17legacy_cpu_device12device_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $reset;
      $1=$this;
      var $2=$1;
      var $3=__ZNK17legacy_cpu_device14get_legacy_fctEj($2, 147458);
      var $4=$3;
      $reset=$4;
      var $5=$reset;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$reset;
      FUNCTION_TABLE[$8]($2);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17legacy_cpu_device11device_stopEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+7237)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($2+7224)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=(($2+7224)|0);
      var $12=HEAP32[(($11)>>2)];
      FUNCTION_TABLE[$12]($2);
      __label__ = 3; break;
    case 3: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17legacy_cpu_device24execute_clocks_to_cyclesEy($this, $clocks$0, $clocks$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $multiplier;
      var $divider;
      $1=$this;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$clocks$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$clocks$1;
      var $3=$1;
      var $4=__ZNK17legacy_cpu_device14get_legacy_intEj($3, 16387);
      var $4$0=$4[0];
      var $4$1=$4[1];
      var $5$0=$4$0;
      var $5=$5$0;
      $multiplier=$5;
      var $6=__ZNK17legacy_cpu_device14get_legacy_intEj($3, 16388);
      var $6$0=$6[0];
      var $6$1=$6[1];
      var $7$0=$6$0;
      var $7=$7$0;
      $divider=$7;
      var $8=$multiplier;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $multiplier=1;
      __label__ = 2; break;
    case 2: // $11
      var $12=$divider;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $divider=1;
      __label__ = 4; break;
    case 4: // $15
      var $st$0$0=(($2)|0);
      var $16$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $16$1=HEAP32[(($st$0$1)>>2)];
      var $17=$multiplier;
      var $18$0=$17;
      var $18$1=0;
      var $19$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($18$0)>>>0)+((($18$1)|0)*4294967296))>>>0; var $19$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($18$0)>>>0)+((($18$1)|0)*4294967296)))/4294967296), 4294967295);
      var $20=$divider;
      var $21$0=$20;
      var $21$1=0;
      var $22$0 = ((($19$0)>>>0)+((($19$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296))>>>0; var $22$1 = Math.min(Math.floor((((($19$0)>>>0)+((($19$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $23$0 = ((($22$0)>>>0)+((($22$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $23$1 = Math.min(Math.floor((((($22$0)>>>0)+((($22$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $24=$divider;
      var $25$0=$24;
      var $25$1=0;
      var $26$0 = Math.floor(((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($25$0)>>>0)+((($25$1)|0)*4294967296)))>>>0; var $26$1 = Math.min(Math.floor((Math.floor(((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($25$0)>>>0)+((($25$1)|0)*4294967296))))/4294967296), 4294967295);
      STACKTOP = __stackBase__;
      return [$26$0,$26$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK17legacy_cpu_device24execute_clocks_to_cyclesEy["X"]=1;

function __ZThn356_NK17legacy_cpu_device24execute_clocks_to_cyclesEy($this, $clocks$0, $clocks$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$clocks$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$clocks$1;
  var $3=$1;
  var $4=$3;
  var $5=(($4-356)|0);
  var $6=$5;
  var $st$11$0=(($2)|0);
  var $7$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($2+4)|0);
  var $7$1=HEAP32[(($st$11$1)>>2)];
  var $8=__ZNK17legacy_cpu_device24execute_clocks_to_cyclesEy($6, $7$0, $7$1);
  var $8$0=$8[0];
  var $8$1=$8[1];
  STACKTOP = __stackBase__;
  return [$8$0,$8$1];
}


function __ZNK17legacy_cpu_device24execute_cycles_to_clocksEy($this, $cycles$0, $cycles$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $multiplier;
      var $divider;
      $1=$this;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$cycles$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$cycles$1;
      var $3=$1;
      var $4=__ZNK17legacy_cpu_device14get_legacy_intEj($3, 16387);
      var $4$0=$4[0];
      var $4$1=$4[1];
      var $5$0=$4$0;
      var $5=$5$0;
      $multiplier=$5;
      var $6=__ZNK17legacy_cpu_device14get_legacy_intEj($3, 16388);
      var $6$0=$6[0];
      var $6$1=$6[1];
      var $7$0=$6$0;
      var $7=$7$0;
      $divider=$7;
      var $8=$multiplier;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $multiplier=1;
      __label__ = 2; break;
    case 2: // $11
      var $12=$divider;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $divider=1;
      __label__ = 4; break;
    case 4: // $15
      var $st$0$0=(($2)|0);
      var $16$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $16$1=HEAP32[(($st$0$1)>>2)];
      var $17=$divider;
      var $18$0=$17;
      var $18$1=0;
      var $19$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($18$0)>>>0)+((($18$1)|0)*4294967296))>>>0; var $19$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($18$0)>>>0)+((($18$1)|0)*4294967296)))/4294967296), 4294967295);
      var $20=$multiplier;
      var $21$0=$20;
      var $21$1=0;
      var $22$0 = ((($19$0)>>>0)+((($19$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296))>>>0; var $22$1 = Math.min(Math.floor((((($19$0)>>>0)+((($19$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $23$0 = ((($22$0)>>>0)+((($22$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $23$1 = Math.min(Math.floor((((($22$0)>>>0)+((($22$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $24=$multiplier;
      var $25$0=$24;
      var $25$1=0;
      var $26$0 = Math.floor(((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($25$0)>>>0)+((($25$1)|0)*4294967296)))>>>0; var $26$1 = Math.min(Math.floor((Math.floor(((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($25$0)>>>0)+((($25$1)|0)*4294967296))))/4294967296), 4294967295);
      STACKTOP = __stackBase__;
      return [$26$0,$26$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK17legacy_cpu_device24execute_cycles_to_clocksEy["X"]=1;

function __ZThn356_NK17legacy_cpu_device24execute_cycles_to_clocksEy($this, $cycles$0, $cycles$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$cycles$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$cycles$1;
  var $3=$1;
  var $4=$3;
  var $5=(($4-356)|0);
  var $6=$5;
  var $st$11$0=(($2)|0);
  var $7$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($2+4)|0);
  var $7$1=HEAP32[(($st$11$1)>>2)];
  var $8=__ZNK17legacy_cpu_device24execute_cycles_to_clocksEy($6, $7$0, $7$1);
  var $8$0=$8[0];
  var $8$1=$8[1];
  STACKTOP = __stackBase__;
  return [$8$0,$8$1];
}


function __ZN17legacy_cpu_device11execute_runEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+7184)|0);
  var $4=HEAP32[(($3)>>2)];
  FUNCTION_TABLE[$4]($2);
  ;
  return;
}


function __ZThn356_N17legacy_cpu_device11execute_runEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN17legacy_cpu_device11execute_runEv($5);
  ;
  return;
}


function __ZN17legacy_cpu_device12execute_burnEi($this, $cycles) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$cycles;
      var $3=$1;
      var $4=(($3+7188)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($3+7188)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$2;
      FUNCTION_TABLE[$9]($3, $10);
      __label__ = 2; break;
    case 2: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn356_N17legacy_cpu_device12execute_burnEi($this, $cycles) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$cycles;
  var $3=$1;
  var $4=$3;
  var $5=(($4-356)|0);
  var $6=$5;
  var $7=$2;
  __ZN17legacy_cpu_device12execute_burnEi($6, $7);
  ;
  return;
}


function __ZN17legacy_cpu_device16memory_translateE16address_spacenumiRj($this, $spacenum, $intention, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$this;
      $3=$spacenum;
      $4=$intention;
      $5=$address;
      var $6=$2;
      var $7=(($6+7192)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($6+7192)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$3;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($6, $13, $14, $15);
      var $17=(($16)|0)!=0;
      var $18=$17 ? 1 : 0;
      $1=$18;
      __label__ = 3; break;
    case 2: // $19
      $1=1;
      __label__ = 3; break;
    case 3: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn5968_N17legacy_cpu_device16memory_translateE16address_spacenumiRj($this, $spacenum, $intention, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$spacenum;
  $3=$intention;
  $4=$address;
  var $5=$1;
  var $6=$5;
  var $7=(($6-5968)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZN17legacy_cpu_device16memory_translateE16address_spacenumiRj($8, $9, $10, $11);
  ;
  return $12;
}


function __ZN17legacy_cpu_device11memory_readE16address_spacenumjiRy($this, $spacenum, $offset, $size, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$spacenum;
      $4=$offset;
      $5=$size;
      $6=$value;
      var $7=$2;
      var $8=(($7+7196)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($7+7196)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=FUNCTION_TABLE[$13]($7, $14, $15, $16, $17);
      var $19=(($18)|0)!=0;
      var $20=$19 ? 1 : 0;
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      $1=0;
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn5968_N17legacy_cpu_device11memory_readE16address_spacenumjiRy($this, $spacenum, $offset, $size, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$spacenum;
  $3=$offset;
  $4=$size;
  $5=$value;
  var $6=$1;
  var $7=$6;
  var $8=(($7-5968)|0);
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $14=__ZN17legacy_cpu_device11memory_readE16address_spacenumjiRy($9, $10, $11, $12, $13);
  ;
  return $14;
}


function __ZN17legacy_cpu_device12memory_writeE16address_spacenumjiy($this, $spacenum, $offset, $size, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      $2=$this;
      $3=$spacenum;
      $4=$offset;
      $5=$size;
      var $st$10$0=(($6)|0);
      HEAP32[(($st$10$0)>>2)]=$value$0;
      var $st$10$1=(($6+4)|0);
      HEAP32[(($st$10$1)>>2)]=$value$1;
      var $7=$2;
      var $8=(($7+7200)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($7+7200)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=$4;
      var $16=$5;
      var $st$5$0=(($6)|0);
      var $17$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($6+4)|0);
      var $17$1=HEAP32[(($st$5$1)>>2)];
      var $18=FUNCTION_TABLE[$13]($7, $14, $15, $16, $17$0, $17$1);
      var $18$0=$18[0];
      var $19=(($18)|0)!=0;
      var $20=$19 ? 1 : 0;
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      $1=0;
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      STACKTOP = __stackBase__;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn5968_N17legacy_cpu_device12memory_writeE16address_spacenumjiy($this, $spacenum, $offset, $size, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  $1=$this;
  $2=$spacenum;
  $3=$offset;
  $4=$size;
  var $st$9$0=(($5)|0);
  HEAP32[(($st$9$0)>>2)]=$value$0;
  var $st$9$1=(($5+4)|0);
  HEAP32[(($st$9$1)>>2)]=$value$1;
  var $6=$1;
  var $7=$6;
  var $8=(($7-5968)|0);
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $st$20$0=(($5)|0);
  var $13$0=HEAP32[(($st$20$0)>>2)];
  var $st$20$1=(($5+4)|0);
  var $13$1=HEAP32[(($st$20$1)>>2)];
  var $14=__ZN17legacy_cpu_device12memory_writeE16address_spacenumjiy($9, $10, $11, $12, $13$0, $13$1);
  var $14$0=$14[0];
  STACKTOP = __stackBase__;
  return $14;
}


function __ZN17legacy_cpu_device13memory_readopEjiRy($this, $offset, $size, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$this;
      $3=$offset;
      $4=$size;
      $5=$value;
      var $6=$2;
      var $7=(($6+7204)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($6+7204)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$3;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($6, $13, $14, $15);
      var $17=(($16)|0)!=0;
      var $18=$17 ? 1 : 0;
      $1=$18;
      __label__ = 3; break;
    case 2: // $19
      $1=0;
      __label__ = 3; break;
    case 3: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn5968_N17legacy_cpu_device13memory_readopEjiRy($this, $offset, $size, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$offset;
  $3=$size;
  $4=$value;
  var $5=$1;
  var $6=$5;
  var $7=(($6-5968)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZN17legacy_cpu_device13memory_readopEjiRy($8, $9, $10, $11);
  ;
  return $12;
}


function __ZN17legacy_cpu_device18device_debug_setupEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $init;
      $1=$this;
      var $2=$1;
      var $3=__ZNK17legacy_cpu_device14get_legacy_fctEj($2, 147467);
      var $4=$3;
      $init=$4;
      var $5=$init;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$init;
      FUNCTION_TABLE[$8]($2);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j($this, $buffer, $pc, $oprom, $opram, $options) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $width;
      $2=$this;
      $3=$buffer;
      $4=$pc;
      $5=$oprom;
      $6=$opram;
      $7=$options;
      var $8=$2;
      var $9=(($8+7208)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=(($8+7208)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$7;
      var $20=FUNCTION_TABLE[$14]($8, $15, $16, $17, $18, $19);
      $1=$20;
      __label__ = 9; break;
    case 2: // $21
      var $22=$8;
      var $23=(($22+7088)|0);
      var $24=$23;
      var $25=__ZNK23device_disasm_interface16min_opcode_bytesEv($24);
      $width=$25;
      var $26=$width;
      if ($26 == 1) {
        __label__ = 3; break;
      }
      else if ($26 == 2) {
        __label__ = 5; break;
      }
      else if ($26 == 4) {
        __label__ = 6; break;
      }
      else if ($26 == 8) {
        __label__ = 7; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 3: // $27
      __label__ = 4; break;
    case 4: // $28
      var $29=$3;
      var $30=$5;
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=_sprintf($29, ((STRING_TABLE.__str113125)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,tempInt));
      __label__ = 8; break;
    case 5: // $34
      var $35=$3;
      var $36=$5;
      var $37=$36;
      var $38=HEAPU16[(($37)>>1)];
      var $39=(($38)&65535);
      var $40=_sprintf($35, ((STRING_TABLE.__str123126)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt));
      __label__ = 8; break;
    case 6: // $41
      var $42=$3;
      var $43=$5;
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=_sprintf($42, ((STRING_TABLE.__str133127)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,tempInt));
      __label__ = 8; break;
    case 7: // $47
      var $48=$3;
      var $49=$5;
      var $50=$49;
      var $st$3$0=(($50)|0);
      var $51$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($50+4)|0);
      var $51$1=HEAP32[(($st$3$1)>>2)];
      var $52$0=$51$1;
      var $52$1=0;
      var $53$0=$52$0;
      var $53=$53$0;
      var $54=$5;
      var $55=$54;
      var $st$13$0=(($55)|0);
      var $56$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($55+4)|0);
      var $56$1=HEAP32[(($st$13$1)>>2)];
      var $57$0=$56$0;
      var $57$1=$56$1;
      var $58$0=$57$0;
      var $58=$58$0;
      var $59=_sprintf($48, ((STRING_TABLE.__str143128)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,HEAP32[((tempInt+4)>>2)]=$58,tempInt));
      __label__ = 8; break;
    case 8: // $60
      var $61=$width;
      $1=$61;
      __label__ = 9; break;
    case 9: // $62
      var $63=$1;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j["X"]=1;

function __ZNK23device_disasm_interface16min_opcode_bytesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+56)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZThn7088_N17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j($this, $buffer, $pc, $oprom, $opram, $options) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$buffer;
  $3=$pc;
  $4=$oprom;
  $5=$opram;
  $6=$options;
  var $7=$1;
  var $8=$7;
  var $9=(($8-7088)|0);
  var $10=$9;
  var $11=$2;
  var $12=$3;
  var $13=$4;
  var $14=$5;
  var $15=$6;
  var $16=__ZN17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j($10, $11, $12, $13, $14, $15);
  ;
  return $16;
}


function __ZN17legacy_cpu_device14set_legacy_intEjx($this, $state, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $info=__stackBase__+8;
  $1=$this;
  $2=$state;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$value$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$value$1;
  var $4=$1;
  var $5=$info;
  HEAP32[(($5)>>2)]=0; HEAP32[(($5+4)>>2)]=0;
  var $st$13$0=(($3)|0);
  var $6$0=HEAP32[(($st$13$0)>>2)];
  var $st$13$1=(($3+4)|0);
  var $6$1=HEAP32[(($st$13$1)>>2)];
  var $7=$info;
  var $st$18$0=(($7)|0);
  HEAP32[(($st$18$0)>>2)]=$6$0;
  var $st$18$1=(($7+4)|0);
  HEAP32[(($st$18$1)>>2)]=$6$1;
  var $8=(($4+7180)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  FUNCTION_TABLE[$9]($4, $10, $info);
  STACKTOP = __stackBase__;
  return;
}


function __ZN17legacy_cpu_device12device_startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $init;
      var $index;
      var $string;
      var $tempstr=__stackBase__;
      var $noshow;
      var $2;
      var $3;
      var $colon;
      var $length;
      var $formatstr=__stackBase__+64;
      var $entry;
      var $string1;
      var $flagstr=__stackBase__+128;
      $1=$this;
      var $4=$1;
      var $5=__ZNK17legacy_cpu_device14get_legacy_fctEj($4, 147457);
      var $6=$5;
      $init=$6;
      var $7=$init;
      FUNCTION_TABLE[$7]($4, 830);
      var $8=(($4+7237)|0);
      HEAP8[($8)]=1;
      var $9=$4;
      var $10=(($9+6012)|0);
      var $11=$10;
      var $12=(($11+12)|0);
      var $13=__ZNK11simple_listI18device_state_entryE5countEv($12);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 46; break; }
    case 1: // $15
      var $16=(($4+7236)|0);
      HEAP8[($16)]=1;
      $index=0;
      __label__ = 2; break;
    case 2: // $17
      var $18=$index;
      var $19=(($18)|0) < 256;
      if ($19) { __label__ = 3; break; } else { __label__ = 32; break; }
    case 3: // $20
      var $21=$index;
      var $22=(($21+213002)|0);
      var $23=__ZNK17legacy_cpu_device17get_legacy_stringEj($4, $22);
      $string=$23;
      var $24=$string;
      var $25=_strchr($24, 58);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 30; break; }
    case 4: // $27
      var $28=$string;
      __ZN7astringC1EPKc($tempstr, $28);
      var $29=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tempstr, 0, 126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $30
      var $31=(($29)|0)==0;
      var $32=(($31)&1);
      $noshow=$32;
      var $33=$noshow;
      var $34=(($33) & 1);
      if ($34) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN7astring6substrEii($tempstr, 1, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $37
      __label__ = 9; break;
    case 8: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $2=$40;
      var $41=$39.f1;
      $3=$41;
      __label__ = 28; break;
    case 9: // $42
      var $43=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tempstr, 0, 58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $44
      $colon=$43;
      var $45=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $46
      var $47=$colon;
      var $48=(($45-$47)|0);
      var $49=(($48-1)|0);
      $length=$49;
      var $50=$colon;
      var $51=(function() { try { __THREW__ = false; return __ZN7astring6substrEii($tempstr, 0, $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; };
    case 12: // $52
      var $53=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $54
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($formatstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 8; break; }
    case 14: // $55
      var $56=$length;
      var $57=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($formatstr, ((STRING_TABLE.__str63120)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 24; break; };
    case 15: // $58
      var $59=$4;
      var $60=(($59+6012)|0);
      var $61=$60;
      var $62=$index;
      var $63=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 24; break; };
    case 16: // $64
      var $65=(($4+7228)|0);
      var $66=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIyEER18device_state_entryiPKcRT_($61, $62, $63, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 24; break; };
    case 17: // $67
      var $68=(function() { try { __THREW__ = false; return __ZN18device_state_entry10callimportEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 24; break; };
    case 18: // $69
      var $70=(function() { try { __THREW__ = false; return __ZN18device_state_entry10callexportEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 24; break; };
    case 19: // $71
      var $72=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($formatstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; };
    case 20: // $73
      var $74=(function() { try { __THREW__ = false; return __ZN18device_state_entry9formatstrEPKc($70, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 24; break; };
    case 21: // $75
      $entry=$74;
      var $76=$noshow;
      var $77=(($76) & 1);
      if ($77) { __label__ = 22; break; } else { __label__ = 25; break; }
    case 22: // $78
      var $79=$entry;
      var $80=(function() { try { __THREW__ = false; return __ZN18device_state_entry6noshowEv($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; };
    case 23: // $81
      __label__ = 25; break;
    case 24: // $82
      var $83=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $84=$83.f0;
      $2=$84;
      var $85=$83.f1;
      $3=$85;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($formatstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 50; break; }
    case 25: // $86
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($formatstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 8; break; }
    case 26: // $87
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      __label__ = 30; break;
    case 27: // $88
      __label__ = 28; break;
    case 28: // $89
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 50; break; }
    case 29: // $90
      __label__ = 49; break;
    case 30: // $91
      __label__ = 31; break;
    case 31: // $92
      var $93=$index;
      var $94=(($93+1)|0);
      $index=$94;
      __label__ = 2; break;
    case 32: // $95
      var $96=$4;
      var $97=(($96+6012)|0);
      var $98=$97;
      var $99=(($4+7228)|0);
      var $100=__ZN22device_state_interface9state_addIyEER18device_state_entryiPKcRT_($98, -1, ((STRING_TABLE.__str73121)|0), $99);
      var $101=__ZN18device_state_entry10callimportEv($100);
      var $102=__ZN18device_state_entry10callexportEv($101);
      var $103=__ZN18device_state_entry9formatstrEPKc($102, ((STRING_TABLE.__str83122)|0));
      var $104=__ZN18device_state_entry6noshowEv($103);
      var $105=$4;
      var $106=(($105+6012)|0);
      var $107=$106;
      var $108=(($4+7228)|0);
      var $109=__ZN22device_state_interface9state_addIyEER18device_state_entryiPKcRT_($107, -2, ((STRING_TABLE.__str93123)|0), $108);
      var $110=__ZN18device_state_entry10callimportEv($109);
      var $111=__ZN18device_state_entry10callexportEv($110);
      var $112=__ZN18device_state_entry9formatstrEPKc($111, ((STRING_TABLE.__str83122)|0));
      var $113=__ZN18device_state_entry6noshowEv($112);
      var $114=__ZNK17legacy_cpu_device17get_legacy_stringEj($4, 212998);
      $string1=$114;
      var $115=$string1;
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 33; break; } else { __label__ = 45; break; }
    case 33: // $117
      var $118=$string1;
      var $119=(($118)|0);
      var $120=HEAP8[($119)];
      var $121=(($120 << 24) >> 24);
      var $122=(($121)|0)!=0;
      if ($122) { __label__ = 34; break; } else { __label__ = 45; break; }
    case 34: // $123
      __ZN7astringC1Ev($flagstr);
      var $124=$string1;
      var $125=(function() { try { __THREW__ = false; return _strlen($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 43; break; };
    case 35: // $126
      var $127=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($flagstr, ((STRING_TABLE.__str63120)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$125,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 43; break; };
    case 36: // $128
      var $129=$4;
      var $130=(($129+6012)|0);
      var $131=$130;
      var $132=(($4+7228)|0);
      var $133=(function() { try { __THREW__ = false; return __ZN22device_state_interface9state_addIyEER18device_state_entryiPKcRT_($131, -4, ((STRING_TABLE.__str103124)|0), $132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 43; break; };
    case 37: // $134
      var $135=(function() { try { __THREW__ = false; return __ZN18device_state_entry10callimportEv($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 43; break; };
    case 38: // $136
      var $137=(function() { try { __THREW__ = false; return __ZN18device_state_entry10callexportEv($135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 43; break; };
    case 39: // $138
      var $139=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($flagstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 43; break; };
    case 40: // $140
      var $141=(function() { try { __THREW__ = false; return __ZN18device_state_entry9formatstrEPKc($137, $139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; };
    case 41: // $142
      var $143=(function() { try { __THREW__ = false; return __ZN18device_state_entry6noshowEv($141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 43; break; };
    case 42: // $144
      FUNCTION_TABLE[__ZN7astringD1Ev]($flagstr);
      __label__ = 45; break;
    case 43: // $145
      var $146=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $147=$146.f0;
      $2=$147;
      var $148=$146.f1;
      $3=$148;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($flagstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 50; break; }
    case 44: // $149
      __label__ = 49; break;
    case 45: // $150
      __label__ = 46; break;
    case 46: // $151
      var $152=__ZNK17legacy_cpu_device14get_legacy_ptrEj($4, 81920);
      var $153=$152;
      var $154=$4;
      var $155=(($154+356)|0);
      var $156=$155;
      var $157=(($156+5540)|0);
      HEAP32[(($157)>>2)]=$153;
      __label__ = 47; break;
    case 47: // $158
      __label__ = 48; break;
    case 48: // $159
      var $160=$4;
      var $161=(($160+356)|0);
      var $162=$161;
      var $163=(($162+5540)|0);
      var $164=HEAP32[(($163)>>2)];
      HEAP32[(($164)>>2)]=0;
      STACKTOP = __stackBase__;
      return;
    case 49: // $165
      var $166=$2;
      var $167=$2;
      var $168=$3;
      var $169=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $167, tempValue);
      var $170=($169.f1 = $168, $169);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $171
      var $172=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17legacy_cpu_device12device_startEv["X"]=1;

function __ZN17legacy_cpu_device12state_importERK18device_state_entry($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$entry;
      var $3=$1;
      var $4=(($3+7236)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=$2;
      var $9=__ZNK18device_state_entry5indexEv($8);
      var $10=(($9)|0)==-4;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=__ZNK18device_state_entry5indexEv($13);
      var $15=(($14+16445)|0);
      var $16=(($3+7228)|0);
      var $st$4$0=(($16)|0);
      var $17$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$4$1)>>2)];
      __ZN17legacy_cpu_device14set_legacy_intEjx($3, $15, $17$0, $17$1);
      __label__ = 4; break;
    case 4: // $18
      __label__ = 8; break;
    case 5: // $19
      var $20=(($3+7212)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $23
      var $24=(($3+7212)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$2;
      FUNCTION_TABLE[$25]($3, $26);
      __label__ = 7; break;
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn6012_N17legacy_cpu_device12state_importERK18device_state_entry($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$entry;
  var $3=$1;
  var $4=$3;
  var $5=(($4-6012)|0);
  var $6=$5;
  var $7=$2;
  __ZN17legacy_cpu_device12state_importERK18device_state_entry($6, $7);
  ;
  return;
}


function __ZN17legacy_cpu_device12state_exportERK18device_state_entry($this, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $temp;
      $1=$this;
      $2=$entry;
      var $3=$1;
      var $4=(($3+7236)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $7
      var $8=$2;
      var $9=__ZNK18device_state_entry5indexEv($8);
      var $10=(($9)|0)==-4;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=__ZNK17legacy_cpu_device17get_legacy_stringEj($3, 212998);
      $temp=$12;
      var $13=(($3+7228)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$5$0=(($13)|0);
      HEAP32[(($st$5$0)>>2)]=$$emscripten$temp$0$0;
      var $st$5$1=(($13+4)|0);
      HEAP32[(($st$5$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 3; break;
    case 3: // $14
      var $15=$temp;
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=(($3+7228)|0);
      var $st$1$0=(($20)|0);
      var $21$0=HEAPU32[(($st$1$0)>>2)];
      var $st$1$1=(($20+4)|0);
      var $21$1=HEAPU32[(($st$1$1)>>2)];
      var $22$0=($21$0 << 5) | (0 >>> 27);
      var $22$1=($21$1 << 5) | ($21$0 >>> 27);
      var $23=(($3+7228)|0);
      var $st$8$0=(($23)|0);
      var $24$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($23+4)|0);
      var $24$1=HEAPU32[(($st$8$1)>>2)];
      var $25$0=($24$1 >>> 27) | (0 << 5);
      var $25$1=(0 >>> 27) | (0 << 5);
      var $26$0=$22$0 | $25$0;
      var $26$1=$22$1 | $25$1;
      var $27=$temp;
      var $28=(($27+1)|0);
      $temp=$28;
      var $29=HEAP8[($27)];
      var $30$0=$29;
      var $30$1=(($29|0) < 0 ? -1 : 0);
      var $31$0=$26$0 ^ $30$0;
      var $31$1=$26$1 ^ $30$1;
      var $32=(($3+7228)|0);
      var $st$25$0=(($32)|0);
      HEAP32[(($st$25$0)>>2)]=$31$0;
      var $st$25$1=(($32+4)|0);
      HEAP32[(($st$25$1)>>2)]=$31$1;
      __label__ = 3; break;
    case 5: // $33
      __label__ = 7; break;
    case 6: // $34
      var $35=$2;
      var $36=__ZNK18device_state_entry5indexEv($35);
      var $37=(($36+16445)|0);
      var $38=__ZNK17legacy_cpu_device14get_legacy_intEj($3, $37);
      var $38$0=$38[0];
      var $38$1=$38[1];
      var $39=(($3+7228)|0);
      var $st$7$0=(($39)|0);
      HEAP32[(($st$7$0)>>2)]=$38$0;
      var $st$7$1=(($39+4)|0);
      HEAP32[(($st$7$1)>>2)]=$38$1;
      __label__ = 7; break;
    case 7: // $40
      __label__ = 11; break;
    case 8: // $41
      var $42=(($3+7216)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $45
      var $46=(($3+7216)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$2;
      FUNCTION_TABLE[$47]($3, $48);
      __label__ = 10; break;
    case 10: // $49
      __label__ = 11; break;
    case 11: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17legacy_cpu_device12state_exportERK18device_state_entry["X"]=1;

function __ZThn6012_N17legacy_cpu_device12state_exportERK18device_state_entry($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$entry;
  var $3=$1;
  var $4=$3;
  var $5=(($4-6012)|0);
  var $6=$5;
  var $7=$2;
  __ZN17legacy_cpu_device12state_exportERK18device_state_entry($6, $7);
  ;
  return;
}


function __ZN17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring($this, $entry, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$entry;
      $3=$string;
      var $4=$1;
      var $5=(($4+7236)|0);
      var $6=HEAP8[($5)];
      var $7=(($6) & 1);
      if ($7) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=$2;
      var $10=__ZNK18device_state_entry5indexEv($9);
      var $11=(($10)|0)==-4;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$3;
      var $14=__ZNK17legacy_cpu_device17get_legacy_stringEj($4, 212998);
      var $15=__ZN7astring3cpyEPKc($13, $14);
      __label__ = 4; break;
    case 3: // $16
      var $17=$3;
      var $18=$2;
      var $19=__ZNK18device_state_entry5indexEv($18);
      var $20=(($19+213002)|0);
      var $21=__ZNK17legacy_cpu_device17get_legacy_stringEj($4, $20);
      var $22=_strchr($21, 58);
      var $23=(($22+1)|0);
      var $24=__ZN7astring3cpyEPKc($17, $23);
      __label__ = 4; break;
    case 4: // $25
      __label__ = 8; break;
    case 5: // $26
      var $27=(($4+7220)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=(($4+7220)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$2;
      var $34=$3;
      FUNCTION_TABLE[$32]($4, $33, $34);
      __label__ = 7; break;
    case 7: // $35
      __label__ = 8; break;
    case 8: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn6012_N17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring($this, $entry, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$entry;
  $3=$string;
  var $4=$1;
  var $5=$4;
  var $6=(($5-6012)|0);
  var $7=$6;
  var $8=$2;
  var $9=$3;
  __ZN17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring($7, $8, $9);
  ;
  return;
}


function __ZN18device_state_entry16format_from_maskEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $width;
      var $tempmask=__stackBase__;
      $1=$this;
      var $2=$1;
      var $3=(($2+152)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      __label__ = 7; break;
    case 2: // $7
      $width=0;
      var $8=(($2+12)|0);
      var $st$2$0=(($8)|0);
      var $9$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($8+4)|0);
      var $9$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($tempmask)|0);
      HEAP32[(($st$6$0)>>2)]=$9$0;
      var $st$6$1=(($tempmask+4)|0);
      HEAP32[(($st$6$1)>>2)]=$9$1;
      __label__ = 3; break;
    case 3: // $10
      var $st$0$0=(($tempmask)|0);
      var $11$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($tempmask+4)|0);
      var $11$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $12=$11$0 != $$emscripten$temp$0$0 || $11$1 != $$emscripten$temp$0$1;
      if ($12) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $13
      var $14=$width;
      var $15=(($14+1)|0);
      $width=$15;
      __label__ = 5; break;
    case 5: // $16
      var $st$0$0=(($tempmask)|0);
      var $17$0=HEAPU32[(($st$0$0)>>2)];
      var $st$0$1=(($tempmask+4)|0);
      var $17$1=HEAPU32[(($st$0$1)>>2)];
      var $18$0=($17$0 >>> 4) | ($17$1 << 28);
      var $18$1=($17$1 >>> 4) | (0 << 28);
      var $st$6$0=(($tempmask)|0);
      HEAP32[(($st$6$0)>>2)]=$18$0;
      var $st$6$1=(($tempmask+4)|0);
      HEAP32[(($st$6$1)>>2)]=$18$1;
      __label__ = 3; break;
    case 6: // $19
      var $20=(($2+88)|0);
      var $21=$width;
      var $22=__ZN7astring6printfEPKcz($20, ((STRING_TABLE.__str43203)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,tempInt));
      __label__ = 7; break;
    case 7: // $23
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18device_state_entryC2EiPKcPvh($this, $index, $symbol, $dataptr, $size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$index;
      $3=$symbol;
      $4=$dataptr;
      $5=$size;
      var $8=$1;
      var $9=(($8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($8+4)|0);
      var $11=$2;
      HEAP32[(($10)>>2)]=$11;
      var $12=(($8+8)|0);
      var $13=(($8+12)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$22$0=(($13)|0);
      HEAP32[(($st$22$0)>>2)]=$$emscripten$temp$0$0;
      var $st$22$1=(($13+4)|0);
      HEAP32[(($st$22$1)>>2)]=$$emscripten$temp$0$1;
      var $14=(($8+20)|0);
      var $15=$5;
      HEAP8[($14)]=$15;
      var $16=(($8+21)|0);
      HEAP8[($16)]=0;
      var $17=(($8+24)|0);
      var $18=$3;
      __ZN7astringC1EPKc($17, $18);
      var $19=(($8+88)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $20
      var $21=(($8+152)|0);
      HEAP8[($21)]=1;
      var $22=(($8+156)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$5$0=(($22)|0);
      HEAP32[(($st$5$0)>>2)]=$$emscripten$temp$1$0;
      var $st$5$1=(($22+4)|0);
      HEAP32[(($st$5$1)>>2)]=$$emscripten$temp$1$1;
      var $23=$4;
      var $24=(($8+8)|0);
      var $25=$24;
      HEAP32[(($25)>>2)]=$23;
      __label__ = 2; break;
    case 2: // $26
      __label__ = 3; break;
    case 3: // $27
      __label__ = 4; break;
    case 4: // $28
      var $29=$5;
      var $30=(($29)&255);
      var $31=(($30)|0)==1;
      if ($31) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $32
      var $33=(($8+156)|0);
      var $$emscripten$temp$2$0=255;
      var $$emscripten$temp$2$1=0;
      var $st$3$0=(($33)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$2$0;
      var $st$3$1=(($33+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 14; break;
    case 6: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $6=$36;
      var $37=$35.f1;
      $7=$37;
      __label__ = 33; break;
    case 7: // $38
      var $39=$5;
      var $40=(($39)&255);
      var $41=(($40)|0)==2;
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=(($8+156)|0);
      var $$emscripten$temp$3$0=65535;
      var $$emscripten$temp$3$1=0;
      var $st$3$0=(($43)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$3$0;
      var $st$3$1=(($43+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 13; break;
    case 9: // $44
      var $45=$5;
      var $46=(($45)&255);
      var $47=(($46)|0)==4;
      if ($47) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      var $49=(($8+156)|0);
      var $$emscripten$temp$4$0=-1;
      var $$emscripten$temp$4$1=0;
      var $st$3$0=(($49)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$4$0;
      var $st$3$1=(($49+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 12; break;
    case 11: // $50
      var $51=(($8+156)|0);
      var $$emscripten$temp$5$0=-1;
      var $$emscripten$temp$5$1=-1;
      var $st$3$0=(($51)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$5$0;
      var $st$3$1=(($51+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 12; break;
    case 12: // $52
      __label__ = 13; break;
    case 13: // $53
      __label__ = 14; break;
    case 14: // $54
      var $55=(($8+156)|0);
      var $st$1$0=(($55)|0);
      var $56$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($55+4)|0);
      var $56$1=HEAP32[(($st$1$1)>>2)];
      var $57=(($8+12)|0);
      var $st$6$0=(($57)|0);
      HEAP32[(($st$6$0)>>2)]=$56$0;
      var $st$6$1=(($57+4)|0);
      HEAP32[(($st$6$1)>>2)]=$56$1;
      (function() { try { __THREW__ = false; return __ZN18device_state_entry16format_from_maskEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $58
      var $59=$2;
      var $60=(($59)|0)==-1;
      if ($60) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $61
      var $62=(($8+24)|0);
      var $63=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($62, ((STRING_TABLE.__str3199)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; };
    case 17: // $64
      __label__ = 31; break;
    case 18: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      $6=$67;
      var $68=$66.f1;
      $7=$68;
      var $69=(($8+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 36; break; }
    case 19: // $70
      var $71=$2;
      var $72=(($71)|0)==-2;
      if ($72) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $73
      var $74=(($8+24)|0);
      var $75=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($74, ((STRING_TABLE.__str13200)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 18; break; };
    case 21: // $76
      __label__ = 30; break;
    case 22: // $77
      var $78=$2;
      var $79=(($78)|0)==-3;
      if ($79) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $80
      var $81=(($8+24)|0);
      var $82=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($81, ((STRING_TABLE.__str23201)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 18; break; };
    case 24: // $83
      __label__ = 29; break;
    case 25: // $84
      var $85=$2;
      var $86=(($85)|0)==-4;
      if ($86) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $87
      var $88=(($8+24)|0);
      var $89=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($88, ((STRING_TABLE.__str33202)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 18; break; };
    case 27: // $90
      __label__ = 28; break;
    case 28: // $91
      __label__ = 29; break;
    case 29: // $92
      __label__ = 30; break;
    case 30: // $93
      __label__ = 31; break;
    case 31: // $94
      ;
      return;
    case 32: // $95
      __label__ = 33; break;
    case 33: // $96
      var $97=(($8+24)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $98
      __label__ = 35; break;
    case 35: // $99
      var $100=$6;
      var $101=$6;
      var $102=$7;
      var $103=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $101, tempValue);
      var $104=($103.f1 = $102, $103);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 36: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18device_state_entryC2EiPKcPvh["X"]=1;

function __ZN18device_state_entry9formatstrEPKc($this, $_format) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $dummy=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$_format;
      var $7=$2;
      var $8=(($7+88)|0);
      var $9=$3;
      var $10=__ZN7astring3cpyEPKc($8, $9);
      var $11=(($7+152)|0);
      HEAP8[($11)]=0;
      var $12=(($7+21)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & -17;
      var $16=(($15) & 255);
      HEAP8[($12)]=$16;
      __ZN7astringC1Ev($dummy);
      var $17=(function() { try { __THREW__ = false; return __ZNK18device_state_entry6formatER7astringPKcb($7, $dummy, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $18
      $1=$7;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($dummy);
      var $19=$1;
      STACKTOP = __stackBase__;
      return $19;
    case 2: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $4=$22;
      var $23=$21.f1;
      $5=$23;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($dummy) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $24
      __label__ = 4; break;
    case 4: // $25
      var $26=$4;
      var $27=$4;
      var $28=$5;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18device_state_entry5valueEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result=__stackBase__;
      $1=$this;
      var $2=$1;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$$emscripten$temp$0$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$$emscripten$temp$0$1;
      var $3=(($2+20)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      if ($5 == 1) {
        __label__ = 2; break;
      }
      else if ($5 == 2) {
        __label__ = 3; break;
      }
      else if ($5 == 4) {
        __label__ = 4; break;
      }
      else if ($5 == 8) {
        __label__ = 5; break;
      }
      else {
      __label__ = 1; break;
      }
      
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($2+8)|0);
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=HEAP8[($10)];
      var $12$0=$11;
      var $12$1=0;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$12$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$12$1;
      __label__ = 6; break;
    case 3: // $13
      var $14=(($2+8)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=HEAP16[(($16)>>1)];
      var $18$0=$17;
      var $18$1=0;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$18$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$18$1;
      __label__ = 6; break;
    case 4: // $19
      var $20=(($2+8)|0);
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      var $23=HEAP32[(($22)>>2)];
      var $24$0=$23;
      var $24$1=0;
      var $st$6$0=(($result)|0);
      HEAP32[(($st$6$0)>>2)]=$24$0;
      var $st$6$1=(($result+4)|0);
      HEAP32[(($st$6$1)>>2)]=$24$1;
      __label__ = 6; break;
    case 5: // $25
      var $26=(($2+8)|0);
      var $27=$26;
      var $28=HEAP32[(($27)>>2)];
      var $st$3$0=(($28)|0);
      var $29$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$3$1)>>2)];
      var $st$7$0=(($result)|0);
      HEAP32[(($st$7$0)>>2)]=$29$0;
      var $st$7$1=(($result+4)|0);
      HEAP32[(($st$7$1)>>2)]=$29$1;
      __label__ = 6; break;
    case 6: // $30
      var $st$0$0=(($result)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      var $32=(($2+12)|0);
      var $st$5$0=(($32)|0);
      var $33$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($32+4)|0);
      var $33$1=HEAP32[(($st$5$1)>>2)];
      var $34$0=$31$0 & $33$0;
      var $34$1=$31$1 & $33$1;
      STACKTOP = __stackBase__;
      return [$34$0,$34$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK18device_state_entry5valueEv["X"]=1;

function __ZNK18device_state_entry9set_valueEy($this, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$this;
      var $st$3$0=(($2)|0);
      HEAP32[(($st$3$0)>>2)]=$value$0;
      var $st$3$1=(($2+4)|0);
      HEAP32[(($st$3$1)>>2)]=$value$1;
      var $3=$1;
      var $4=(($3+12)|0);
      var $st$9$0=(($4)|0);
      var $5$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($4+4)|0);
      var $5$1=HEAP32[(($st$9$1)>>2)];
      var $st$13$0=(($2)|0);
      var $6$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($2+4)|0);
      var $6$1=HEAP32[(($st$13$1)>>2)];
      var $7$0=$6$0 & $5$0;
      var $7$1=$6$1 & $5$1;
      var $st$19$0=(($2)|0);
      HEAP32[(($st$19$0)>>2)]=$7$0;
      var $st$19$1=(($2+4)|0);
      HEAP32[(($st$19$1)>>2)]=$7$1;
      var $8=(($3+21)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 & 4;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $st$0$0=(($2)|0);
      var $14$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $14$1=HEAP32[(($st$0$1)>>2)];
      var $15=(($3+12)|0);
      var $st$5$0=(($15)|0);
      var $16$0=HEAPU32[(($st$5$0)>>2)];
      var $st$5$1=(($15+4)|0);
      var $16$1=HEAPU32[(($st$5$1)>>2)];
      var $17$0=($16$0 >>> 1) | ($16$1 << 31);
      var $17$1=($16$1 >>> 1) | (0 << 31);
      var $18=$14$1 > $17$1 || ($14$1 == $17$1 && $14$0 > $17$0);
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      var $20=(($3+12)|0);
      var $st$1$0=(($20)|0);
      var $21$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $22$0=$21$0 ^ $$emscripten$temp$0$0;
      var $22$1=$21$1 ^ $$emscripten$temp$0$1;
      var $st$9$0=(($2)|0);
      var $23$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($2+4)|0);
      var $23$1=HEAP32[(($st$9$1)>>2)];
      var $24$0=$23$0 | $22$0;
      var $24$1=$23$1 | $22$1;
      var $st$15$0=(($2)|0);
      HEAP32[(($st$15$0)>>2)]=$24$0;
      var $st$15$1=(($2+4)|0);
      HEAP32[(($st$15$1)>>2)]=$24$1;
      __label__ = 3; break;
    case 3: // $25
      var $26=(($3+20)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      if ($28 == 1) {
        __label__ = 5; break;
      }
      else if ($28 == 2) {
        __label__ = 6; break;
      }
      else if ($28 == 4) {
        __label__ = 7; break;
      }
      else if ($28 == 8) {
        __label__ = 8; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 4: // $29
      __label__ = 5; break;
    case 5: // $30
      var $st$0$0=(($2)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      var $32$0=$31$0;
      var $32=$32$0&255;
      var $33=(($3+8)|0);
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      HEAP8[($35)]=$32;
      __label__ = 9; break;
    case 6: // $36
      var $st$0$0=(($2)|0);
      var $37$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $37$1=HEAP32[(($st$0$1)>>2)];
      var $38$0=$37$0;
      var $38=$38$0&65535;
      var $39=(($3+8)|0);
      var $40=$39;
      var $41=HEAP32[(($40)>>2)];
      HEAP16[(($41)>>1)]=$38;
      __label__ = 9; break;
    case 7: // $42
      var $st$0$0=(($2)|0);
      var $43$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $43$1=HEAP32[(($st$0$1)>>2)];
      var $44$0=$43$0;
      var $44=$44$0;
      var $45=(($3+8)|0);
      var $46=$45;
      var $47=HEAP32[(($46)>>2)];
      HEAP32[(($47)>>2)]=$44;
      __label__ = 9; break;
    case 8: // $48
      var $st$0$0=(($2)|0);
      var $49$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $49$1=HEAP32[(($st$0$1)>>2)];
      var $50=(($3+8)|0);
      var $51=$50;
      var $52=HEAP32[(($51)>>2)];
      var $st$7$0=(($52)|0);
      HEAP32[(($st$7$0)>>2)]=$49$0;
      var $st$7$1=(($52+4)|0);
      HEAP32[(($st$7$1)>>2)]=$49$1;
      __label__ = 9; break;
    case 9: // $53
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK18device_state_entry9set_valueEy["X"]=1;

function __ZN7astring3catEPKci($this, $src, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$src;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZN7astring3insEiPKci($4, -1, $5, $6);
  ;
  return $7;
}


function __ZN11simple_listI18device_state_entryEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI18device_state_entryEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK18device_state_entry6formatER7astringPKcb($this, $dest, $string, $maxout) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $result=__stackBase__;
      var $leadzero;
      var $percent;
      var $explicitsign;
      var $hitnonzero;
      var $reset;
      var $width;
      var $fptr;
      var $6;
      var $7;
      var $digitnum;
      var $digit;
      var $digitnum1;
      var $digit2;
      $2=$this;
      $3=$dest;
      $4=$string;
      var $8=(($maxout)&1);
      $5=$8;
      var $9=$2;
      var $10=__ZNK18device_state_entry5valueEv($9);
      var $10$0=$10[0];
      var $10$1=$10[1];
      var $st$28$0=(($result)|0);
      HEAP32[(($st$28$0)>>2)]=$10$0;
      var $st$28$1=(($result+4)|0);
      HEAP32[(($st$28$1)>>2)]=$10$1;
      $leadzero=0;
      $percent=0;
      $explicitsign=0;
      $hitnonzero=0;
      $reset=1;
      $width=0;
      var $11=(($9+88)|0);
      var $12=__ZNK7astringcvPKcEv($11);
      $fptr=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$fptr;
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 93; break; }
    case 2: // $18
      var $19=$reset;
      var $20=(($19) & 1);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$5;
      var $23=(($22) & 1);
      var $24=(($23)&1);
      $leadzero=$24;
      $reset=0;
      $explicitsign=0;
      $percent=0;
      $width=0;
      __label__ = 4; break;
    case 4: // $25
      var $26=$percent;
      var $27=(($26) & 1);
      if ($27) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 5: // $28
      var $29=$fptr;
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24);
      var $32=(($31)|0)!=37;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      var $34=$3;
      var $35=$fptr;
      var $36=__ZN7astring3catEPKci($34, $35, 1);
      __label__ = 92; break;
    case 7: // $37
      var $38=$fptr;
      var $39=HEAP8[($38)];
      var $40=(($39 << 24) >> 24);
      if ($40 == 37) {
        __label__ = 8; break;
      }
      else if ($40 == 48) {
        __label__ = 12; break;
      }
      else if ($40 == 49 || $40 == 50 || $40 == 51 || $40 == 52 || $40 == 53 || $40 == 54 || $40 == 55 || $40 == 56 || $40 == 57) {
        __label__ = 16; break;
      }
      else if ($40 == 43) {
        __label__ = 17; break;
      }
      else if ($40 == 88) {
        __label__ = 18; break;
      }
      else if ($40 == 100) {
        __label__ = 40; break;
      }
      else if ($40 == 117) {
        __label__ = 50; break;
      }
      else if ($40 == 115) {
        __label__ = 75; break;
      }
      else {
      __label__ = 88; break;
      }
      
    case 8: // $41
      var $42=$percent;
      var $43=(($42) & 1);
      if ($43) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $44
      $percent=1;
      __label__ = 11; break;
    case 10: // $45
      var $46=$3;
      var $47=$fptr;
      var $48=__ZN7astring3catEPKci($46, $47, 1);
      $percent=0;
      __label__ = 11; break;
    case 11: // $49
      __label__ = 91; break;
    case 12: // $50
      var $51=$width;
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $53
      $leadzero=1;
      __label__ = 15; break;
    case 14: // $54
      var $55=$width;
      var $56=(($55*10)|0);
      $width=$56;
      __label__ = 15; break;
    case 15: // $57
      __label__ = 91; break;
    case 16: // $58
      var $59=$width;
      var $60=(($59*10)|0);
      var $61=$fptr;
      var $62=HEAP8[($61)];
      var $63=(($62 << 24) >> 24);
      var $64=(($63-48)|0);
      var $65=(($60+$64)|0);
      $width=$65;
      __label__ = 91; break;
    case 17: // $66
      $explicitsign=1;
      __label__ = 91; break;
    case 18: // $67
      var $68=$width;
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $70
      var $71=___cxa_allocate_exception(1032);
      var $72=$71;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($72, ((STRING_TABLE.__str53204)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $73
      ___cxa_throw($71, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 21: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $6=$76;
      var $77=$75.f1;
      $7=$77;
      ___cxa_free_exception($71);
      __label__ = 95; break;
    case 22: // $78
      $hitnonzero=0;
      __label__ = 23; break;
    case 23: // $79
      var $80=$leadzero;
      var $81=(($80) & 1);
      if ($81) { __label__ = 24; break; } else { var $86 = 0;__label__ = 25; break; }
    case 24: // $82
      var $83=$width;
      var $84=(($83)|0) > 16;
      var $86 = $84;__label__ = 25; break;
    case 25: // $85
      var $86;
      if ($86) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $87
      var $88=$3;
      var $89=__ZN7astring3catEPKc($88, ((STRING_TABLE.__str63205)|0));
      var $90=$width;
      var $91=(($90-1)|0);
      $width=$91;
      __label__ = 23; break;
    case 27: // $92
      $digitnum=15;
      __label__ = 28; break;
    case 28: // $93
      var $94=$digitnum;
      var $95=(($94)|0) >= 0;
      if ($95) { __label__ = 29; break; } else { __label__ = 39; break; }
    case 29: // $96
      var $st$0$0=(($result)|0);
      var $97$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $97$1=HEAP32[(($st$0$1)>>2)];
      var $98=$digitnum;
      var $99=((($98<<2))|0);
      var $100$0=$99;
      var $100$1=0;
      var $101=Runtime.bitshift64($97$0, $97$1,"lshr",$100$0);var $101$0 = $101[0], $101$1 = $101[1];
      var $$emscripten$temp$0$0=15;
      var $$emscripten$temp$0$1=0;
      var $102$0=$101$0 & $$emscripten$temp$0$0;
      var $102$1=$101$1 & $$emscripten$temp$0$1;
      var $103$0=$102$0;
      var $103=$103$0;
      $digit=$103;
      var $104=$digit;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $106
      var $107=$3;
      var $108=$digit;
      var $109=((STRING_TABLE.__ZZNK18device_state_entry6formatER7astringPKcbE8hexchars+$108)|0);
      var $110=__ZN7astring3catEPKci($107, $109, 1);
      $hitnonzero=1;
      __label__ = 37; break;
    case 31: // $111
      var $112=$hitnonzero;
      var $113=(($112) & 1);
      if ($113) { __label__ = 35; break; } else { __label__ = 32; break; }
    case 32: // $114
      var $115=$leadzero;
      var $116=(($115) & 1);
      if ($116) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $117
      var $118=$digitnum;
      var $119=$width;
      var $120=(($118)|0) < (($119)|0);
      if ($120) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $121
      var $122=$digitnum;
      var $123=(($122)|0)==0;
      if ($123) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $124
      var $125=$3;
      var $126=__ZN7astring3catEPKc($125, ((STRING_TABLE.__str73206)|0));
      __label__ = 36; break;
    case 36: // $127
      __label__ = 37; break;
    case 37: // $128
      __label__ = 38; break;
    case 38: // $129
      var $130=$digitnum;
      var $131=(($130-1)|0);
      $digitnum=$131;
      __label__ = 28; break;
    case 39: // $132
      $reset=1;
      __label__ = 91; break;
    case 40: // $133
      var $134=$width;
      var $135=(($134)|0)==0;
      if ($135) { __label__ = 41; break; } else { __label__ = 44; break; }
    case 41: // $136
      var $137=___cxa_allocate_exception(1032);
      var $138=$137;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($138, ((STRING_TABLE.__str83207)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $139
      ___cxa_throw($137, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 43: // $140
      var $141=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $142=$141.f0;
      $6=$142;
      var $143=$141.f1;
      $7=$143;
      ___cxa_free_exception($137);
      __label__ = 95; break;
    case 44: // $144
      var $st$0$0=(($result)|0);
      var $145$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $145$1=HEAP32[(($st$0$1)>>2)];
      var $146=(($9+12)|0);
      var $st$5$0=(($146)|0);
      var $147$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($146+4)|0);
      var $147$1=HEAP32[(($st$5$1)>>2)];
      var $148$0=$145$0 & $147$0;
      var $148$1=$145$1 & $147$1;
      var $149=(($9+12)|0);
      var $st$12$0=(($149)|0);
      var $150$0=HEAPU32[(($st$12$0)>>2)];
      var $st$12$1=(($149+4)|0);
      var $150$1=HEAPU32[(($st$12$1)>>2)];
      var $151$0=($150$0 >>> 1) | ($150$1 << 31);
      var $151$1=($150$1 >>> 1) | (0 << 31);
      var $152=$148$1 > $151$1 || ($148$1 == $151$1 && $148$0 > $151$0);
      if ($152) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $153
      var $st$0$0=(($result)|0);
      var $154$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $154$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $155$0 = ((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))-((($154$0)>>>0)+((($154$1)|0)*4294967296))>>>0; var $155$1 = Math.min(Math.floor((((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))-((($154$0)>>>0)+((($154$1)|0)*4294967296)))/4294967296), 4294967295);
      var $156=(($9+12)|0);
      var $st$8$0=(($156)|0);
      var $157$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($156+4)|0);
      var $157$1=HEAP32[(($st$8$1)>>2)];
      var $158$0=$155$0 & $157$0;
      var $158$1=$155$1 & $157$1;
      var $st$14$0=(($result)|0);
      HEAP32[(($st$14$0)>>2)]=$158$0;
      var $st$14$1=(($result+4)|0);
      HEAP32[(($st$14$1)>>2)]=$158$1;
      var $159=$3;
      var $160=__ZN7astring3catEPKc($159, ((STRING_TABLE.__str93208)|0));
      var $161=$width;
      var $162=(($161-1)|0);
      $width=$162;
      __label__ = 49; break;
    case 46: // $163
      var $164=$explicitsign;
      var $165=(($164) & 1);
      if ($165) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $166
      var $167=$3;
      var $168=__ZN7astring3catEPKc($167, ((STRING_TABLE.__str103209)|0));
      var $169=$width;
      var $170=(($169-1)|0);
      $width=$170;
      __label__ = 48; break;
    case 48: // $171
      __label__ = 49; break;
    case 49: // $172
      __label__ = 50; break;
    case 50: // $173
      var $174=$width;
      var $175=(($174)|0)==0;
      if ($175) { __label__ = 51; break; } else { __label__ = 54; break; }
    case 51: // $176
      var $177=___cxa_allocate_exception(1032);
      var $178=$177;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($178, ((STRING_TABLE.__str113210)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $179
      ___cxa_throw($177, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 53: // $180
      var $181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $182=$181.f0;
      $6=$182;
      var $183=$181.f1;
      $7=$183;
      ___cxa_free_exception($177);
      __label__ = 95; break;
    case 54: // $184
      $hitnonzero=0;
      __label__ = 55; break;
    case 55: // $185
      var $186=$leadzero;
      var $187=(($186) & 1);
      if ($187) { __label__ = 56; break; } else { var $192 = 0;__label__ = 57; break; }
    case 56: // $188
      var $189=$width;
      var $190=(($189)>>>0) > 20;
      var $192 = $190;__label__ = 57; break;
    case 57: // $191
      var $192;
      if ($192) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $193
      var $194=$3;
      var $195=__ZN7astring3catEPKc($194, ((STRING_TABLE.__str63205)|0));
      var $196=$width;
      var $197=(($196-1)|0);
      $width=$197;
      __label__ = 55; break;
    case 59: // $198
      $digitnum1=19;
      __label__ = 60; break;
    case 60: // $199
      var $200=$digitnum1;
      var $201=(($200)|0) >= 0;
      if ($201) { __label__ = 61; break; } else { __label__ = 74; break; }
    case 61: // $202
      var $st$0$0=(($result)|0);
      var $203$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $203$1=HEAP32[(($st$0$1)>>2)];
      var $204=$digitnum1;
      var $205=((__ZN18device_state_entry17k_decimal_divisorE+($204<<3))|0);
      var $st$6$0=(($205)|0);
      var $206$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($205+4)|0);
      var $206$1=HEAP32[(($st$6$1)>>2)];
      var $207=$203$1 >= $206$1 && ($203$1 > $206$1 || $203$0 >= $206$0);
      if ($207) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $208
      var $st$0$0=(($result)|0);
      var $209$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $209$1=HEAP32[(($st$0$1)>>2)];
      var $210=$digitnum1;
      var $211=((__ZN18device_state_entry17k_decimal_divisorE+($210<<3))|0);
      var $st$6$0=(($211)|0);
      var $212$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($211+4)|0);
      var $212$1=HEAP32[(($st$6$1)>>2)];
      var $213$0 = Math.floor(((($209$0)>>>0)+((($209$1)|0)*4294967296))/((($212$0)>>>0)+((($212$1)|0)*4294967296)))>>>0; var $213$1 = Math.min(Math.floor((Math.floor(((($209$0)>>>0)+((($209$1)|0)*4294967296))/((($212$0)>>>0)+((($212$1)|0)*4294967296))))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=10;
      var $$emscripten$temp$2$1=0;
      var $214$0 = ((($213$0)>>>0)+((($213$1)|0)*4294967296))%((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $214$1 = Math.min(Math.floor((((($213$0)>>>0)+((($213$1)|0)*4294967296))%((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $217$1 = $214$1;var $217$0 = $214$0;__label__ = 64; break;
    case 63: // $215
      var $217$1 = 0;var $217$0 = 0;__label__ = 64; break;
    case 64: // $216
      var $217$0;
      var $217$1;
      var $218$0=$217$0;
      var $218=$218$0;
      $digit2=$218;
      var $219=$digit2;
      var $220=(($219)|0)!=0;
      if ($220) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $221
      var $222=$3;
      var $223=$digit2;
      var $224=((STRING_TABLE.__ZZNK18device_state_entry6formatER7astringPKcbE8decchars+$223)|0);
      var $225=__ZN7astring3catEPKci($222, $224, 1);
      $hitnonzero=1;
      __label__ = 72; break;
    case 66: // $226
      var $227=$hitnonzero;
      var $228=(($227) & 1);
      if ($228) { __label__ = 70; break; } else { __label__ = 67; break; }
    case 67: // $229
      var $230=$leadzero;
      var $231=(($230) & 1);
      if ($231) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $232
      var $233=$digitnum1;
      var $234=$width;
      var $235=(($233)|0) < (($234)|0);
      if ($235) { __label__ = 70; break; } else { __label__ = 69; break; }
    case 69: // $236
      var $237=$digitnum1;
      var $238=(($237)|0)==0;
      if ($238) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $239
      var $240=$3;
      var $241=__ZN7astring3catEPKc($240, ((STRING_TABLE.__str73206)|0));
      __label__ = 71; break;
    case 71: // $242
      __label__ = 72; break;
    case 72: // $243
      __label__ = 73; break;
    case 73: // $244
      var $245=$digitnum1;
      var $246=(($245-1)|0);
      $digitnum1=$246;
      __label__ = 60; break;
    case 74: // $247
      $reset=1;
      __label__ = 91; break;
    case 75: // $248
      var $249=$width;
      var $250=(($249)|0)==0;
      if ($250) { __label__ = 76; break; } else { __label__ = 79; break; }
    case 76: // $251
      var $252=___cxa_allocate_exception(1032);
      var $253=$252;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($253, ((STRING_TABLE.__str123211)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $254
      ___cxa_throw($252, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 78: // $255
      var $256=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $257=$256.f0;
      $6=$257;
      var $258=$256.f1;
      $7=$258;
      ___cxa_free_exception($252);
      __label__ = 95; break;
    case 79: // $259
      var $260=$4;
      var $261=(($260)|0)==0;
      if ($261) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $262
      var $263=(($9+21)|0);
      var $264=HEAPU8[($263)];
      var $265=(($264)&255);
      var $266=$265 | 16;
      var $267=(($266) & 255);
      HEAP8[($263)]=$267;
      var $268=$3;
      $1=$268;
      __label__ = 94; break;
    case 81: // $269
      var $270=$4;
      var $271=_strlen($270);
      var $272=$width;
      var $273=(($271)>>>0) <= (($272)>>>0);
      if ($273) { __label__ = 82; break; } else { __label__ = 86; break; }
    case 82: // $274
      var $275=$3;
      var $276=$4;
      var $277=__ZN7astring3catEPKc($275, $276);
      var $278=$4;
      var $279=_strlen($278);
      var $280=$width;
      var $281=(($280-$279)|0);
      $width=$281;
      __label__ = 83; break;
    case 83: // $282
      var $283=$width;
      var $284=(($283-1)|0);
      $width=$284;
      var $285=(($283)|0)!=0;
      if ($285) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $286
      var $287=$3;
      var $288=__ZN7astring3catEPKc($287, ((STRING_TABLE.__str63205)|0));
      __label__ = 83; break;
    case 85: // $289
      __label__ = 87; break;
    case 86: // $290
      var $291=$3;
      var $292=$4;
      var $293=$width;
      var $294=__ZN7astring3catEPKci($291, $292, $293);
      __label__ = 87; break;
    case 87: // $295
      $reset=1;
      __label__ = 91; break;
    case 88: // $296
      var $297=___cxa_allocate_exception(1032);
      var $298=$297;
      var $299=$fptr;
      var $300=HEAP8[($299)];
      var $301=(($300 << 24) >> 24);
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($298, ((STRING_TABLE.__str133212)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$301,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $302
      ___cxa_throw($297, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 90: // $303
      var $304=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $305=$304.f0;
      $6=$305;
      var $306=$304.f1;
      $7=$306;
      ___cxa_free_exception($297);
      __label__ = 95; break;
    case 91: // $307
      __label__ = 92; break;
    case 92: // $308
      var $309=$fptr;
      var $310=(($309+1)|0);
      $fptr=$310;
      __label__ = 1; break;
    case 93: // $311
      var $312=$3;
      $1=$312;
      __label__ = 94; break;
    case 94: // $313
      var $314=$1;
      STACKTOP = __stackBase__;
      return $314;
    case 95: // $315
      var $316=$6;
      var $317=$6;
      var $318=$7;
      var $319=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $317, tempValue);
      var $320=($319.f1 = $318, $319);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK18device_state_entry6formatER7astringPKcb["X"]=1;

function __ZN22device_state_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$mconfig;
      $3=$device;
      var $6=$1;
      var $7=$6;
      var $8=$3;
      __ZN16device_interfaceC2ER8device_t($7, $8);
      var $9=$6;
      HEAP32[(($9)>>2)]=((__ZTV22device_state_interface+8)|0);
      var $10=(($6+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI18device_state_entryEC1ER13resource_pool($10, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($6+32)|0);
      var $13=(($12)|0);
      var $14=$13;
      _memset($14, 0, 1044, 1);
      var $15=$3;
      var $16=(($15+16)|0);
      HEAP32[(($16)>>2)]=$6;
      ;
      return;
    case 2: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      var $21=$6;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      __label__ = 4; break;
    case 4: // $23
      var $24=$4;
      var $25=$4;
      var $26=$5;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_state_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN22device_state_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_state_interfaceD0Ev["X"]=1;

function __ZN22device_state_interface12state_importERK18device_state_entry($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$entry;
  var $3=$1;
  ;
  return;
}


function __ZN22device_state_interface12state_exportERK18device_state_entry($this, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$entry;
  var $3=$1;
  ;
  return;
}


function __ZN22device_state_interface19state_string_importERK18device_state_entryR7astring($this, $entry, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$entry;
  $3=$string;
  var $4=$1;
  ;
  return;
}


function __ZN22device_state_interface19state_string_exportERK18device_state_entryR7astring($this, $entry, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$entry;
  $3=$string;
  var $4=$1;
  ;
  return;
}


function __ZNK18device_state_entry12needs_exportEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 8;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK18device_state_entry19needs_custom_stringEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 16;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZNK18device_state_entry12needs_importEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 2;
  var $7=(($6)|0)!=0;
  ;
  return $7;
}


function __ZN11simple_listI18device_state_entryE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI18device_state_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI18device_state_entryED2Ev($2);
  ;
  return;
}


function __ZN22device_state_interface5stateEi($this, $index) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $entry;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=$3;
      var $6=__ZN22device_state_interface16state_find_entryEi($4, $5);
      $entry=$6;
      var $7=$entry;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 5; break;
    case 2: // $10
      var $11=$entry;
      var $12=__ZNK18device_state_entry12needs_exportEv($11);
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+60)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$entry;
      FUNCTION_TABLE[$17]($4, $18);
      __label__ = 4; break;
    case 4: // $19
      var $20=$entry;
      var $21=__ZNK18device_state_entry5valueEv($20);
      var $21$0=$21[0];
      var $21$1=$21[1];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$21$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$21$1;
      __label__ = 5; break;
    case 5: // $22
      var $st$0$0=(($1)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$23$0,$23$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_state_interface16state_find_entryEi($this, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      $2=$this;
      $3=$index;
      var $4=$2;
      var $5=$3;
      var $6=(($5)|0) >= -4;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$3;
      var $9=(($8)|0) <= 256;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$3;
      var $12=(($11+4)|0);
      var $13=(($4+32)|0);
      var $14=(($13+($12<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $1=$15;
      __label__ = 10; break;
    case 3: // $16
      var $17=(($4+12)|0);
      var $18=__ZNK11simple_listI18device_state_entryE5firstEv($17);
      $entry=$18;
      __label__ = 4; break;
    case 4: // $19
      var $20=$entry;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $22
      var $23=$entry;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$3;
      var $27=(($25)|0)==(($26)|0);
      if ($27) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $28
      var $29=$entry;
      $1=$29;
      __label__ = 10; break;
    case 7: // $30
      __label__ = 8; break;
    case 8: // $31
      var $32=$entry;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      $entry=$34;
      __label__ = 4; break;
    case 9: // $35
      $1=0;
      __label__ = 10; break;
    case 10: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_state_interface9set_stateEiy($this, $index, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $entry;
      $1=$this;
      $2=$index;
      var $st$6$0=(($3)|0);
      HEAP32[(($st$6$0)>>2)]=$value$0;
      var $st$6$1=(($3+4)|0);
      HEAP32[(($st$6$1)>>2)]=$value$1;
      var $4=$1;
      var $5=$2;
      var $6=__ZN22device_state_interface16state_find_entryEi($4, $5);
      $entry=$6;
      var $7=$entry;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      __label__ = 4; break;
    case 2: // $10
      var $11=$entry;
      var $st$1$0=(($3)|0);
      var $12$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$1$1)>>2)];
      __ZNK18device_state_entry9set_valueEy($11, $12$0, $12$1);
      var $13=$entry;
      var $14=__ZNK18device_state_entry12needs_importEv($13);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$4;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+56)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$entry;
      FUNCTION_TABLE[$19]($4, $20);
      __label__ = 4; break;
    case 4: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18device_state_entryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18device_state_entryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18device_state_entryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 164);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18device_state_entryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18device_state_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18device_state_entryED2Ev($2);
  ;
  return;
}


function __ZN22device_state_interfaceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22device_state_interface+8)|0);
      var $6=(($4+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI18device_state_entryED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      __ZN16device_interfaceD2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_state_interface12state_stringEiR7astring($this, $index, $dest) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $entry;
      var $custom=__stackBase__;
      var $5;
      var $6;
      var $7;
      $2=$this;
      $3=$index;
      $4=$dest;
      var $8=$2;
      var $9=$3;
      var $10=__ZN22device_state_interface16state_find_entryEi($8, $9);
      $entry=$10;
      var $11=$entry;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$4;
      var $15=__ZN7astring3cpyEPKc($14, ((STRING_TABLE.__str143213)|0));
      $1=$15;
      __label__ = 11; break;
    case 2: // $16
      __ZN7astringC1Ev($custom);
      var $17=$entry;
      var $18=(function() { try { __THREW__ = false; return __ZNK18device_state_entry19needs_custom_stringEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $19
      if ($18) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $20
      var $21=$8;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+68)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$entry;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$24]($8, $25, $custom) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      __label__ = 7; break;
    case 6: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $5=$29;
      var $30=$28.f1;
      $6=$30;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($custom) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 7: // $31
      var $32=$entry;
      var $33=$4;
      var $34=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($custom) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 6; break; };
    case 8: // $35
      var $36=(function() { try { __THREW__ = false; return __ZNK18device_state_entry6formatER7astringPKcb($32, $33, $34, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; };
    case 9: // $37
      $1=$36;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($custom);
      __label__ = 11; break;
    case 10: // $38
      __label__ = 12; break;
    case 11: // $39
      var $40=$1;
      STACKTOP = __stackBase__;
      return $40;
    case 12: // $41
      var $42=$5;
      var $43=$5;
      var $44=$6;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_state_interface12state_stringEiR7astring["X"]=1;

function __ZN22device_state_interface23state_string_max_lengthEi($this, $index) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$index;
      var $7=$2;
      var $8=$3;
      var $9=__ZN22device_state_interface16state_find_entryEi($7, $8);
      $entry=$9;
      var $10=$entry;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $1=3;
      __label__ = 7; break;
    case 2: // $13
      __ZN7astringC1Ev($tempstring);
      var $14=$entry;
      var $15=(function() { try { __THREW__ = false; return __ZNK18device_state_entry6formatER7astringPKcb($14, $tempstring, ((__str153214)|0), 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $16
      var $17=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; };
    case 4: // $18
      $1=$17;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      __label__ = 7; break;
    case 5: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $4=$21;
      var $22=$20.f1;
      $5=$22;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $23
      __label__ = 8; break;
    case 7: // $24
      var $25=$1;
      STACKTOP = __stackBase__;
      return $25;
    case 8: // $26
      var $27=$4;
      var $28=$4;
      var $29=$5;
      var $30=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28, tempValue);
      var $31=($30.f1 = $29, $30);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_state_interface9state_addEiPKcPvh($this, $index, $symbol, $data, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $entry;
      var $14;
      var $15;
      $9=$this;
      $10=$index;
      $11=$symbol;
      $12=$data;
      $13=$size;
      var $16=$9;
      __label__ = 1; break;
    case 1: // $17
      __label__ = 2; break;
    case 2: // $18
      __label__ = 3; break;
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$16;
      var $22=__ZN16device_interface6deviceEv($21);
      var $23=__ZNK8device_t7machineEv($22);
      var $24=__ZN15running_machine7respoolEv($23);
      var $25=$4;
      var $26=$5;
      var $27=$6;
      var $28=$result_i;
      var $29=$7;
      var $30=$8;
      HEAP32[(($4)>>2)]=164;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str163215)|0);
      HEAP32[(($6)>>2)]=520;
      var $31=HEAP32[(($4)>>2)];
      var $32=HEAP32[(($5)>>2)];
      var $33=HEAP32[(($6)>>2)];
      var $34=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($31, $32, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $35
      HEAP32[(($result_i)>>2)]=$34;
      var $36=HEAP32[(($result_i)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $38
      var $39=___cxa_allocate_exception(4);
      var $40=$39;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($40);
      (function() { try { __THREW__ = false; return ___cxa_throw($39, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      HEAP32[(($7)>>2)]=$43;
      var $44=$42.f1;
      HEAP32[(($8)>>2)]=$44;
      var $45=HEAP32[(($8)>>2)];
      var $46=(($45)|0) < 0;
      if ($46) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $47
      var $48=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($48);
      throw "Reached an unreachable!"
    case 9: // $49
      var $50=HEAP32[(($7)>>2)];
      var $51=HEAP32[(($7)>>2)];
      var $52=HEAP32[(($8)>>2)];
      var $53=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $51, tempValue);
      var $54=($53.f1 = $52, $53);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $55
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKci_exit
      var $56=HEAP32[(($result_i)>>2)];
      var $57=$4;
      var $58=$5;
      var $59=$6;
      var $60=$result_i;
      var $61=$7;
      var $62=$8;
      var $63=$56;
      var $64=$10;
      var $65=$11;
      var $66=$12;
      var $67=$13;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18device_state_entryC1EiPKcPvh]($63, $64, $65, $66, $67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $68
      var $69=__ZN13resource_pool10add_objectI18device_state_entryEEPT_S3_($24, $63);
      $entry=$69;
      var $70=(($16+12)|0);
      var $71=$entry;
      var $72=__ZN11simple_listI18device_state_entryE6appendERS0_($70, $71);
      var $73=$10;
      var $74=(($73)|0) >= -4;
      if ($74) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $75
      var $76=$10;
      var $77=(($76)|0) <= 256;
      if ($77) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $78
      var $79=$entry;
      var $80=$10;
      var $81=(($80+4)|0);
      var $82=(($16+32)|0);
      var $83=(($82+($81<<2))|0);
      HEAP32[(($83)>>2)]=$79;
      __label__ = 20; break;
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $86=$85.f0;
      $14=$86;
      var $87=$85.f1;
      $15=$87;
      var $88=$1;
      var $89=$2;
      var $90=$3;
      HEAP32[(($1)>>2)]=$56;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str163215)|0);
      HEAP32[(($3)>>2)]=520;
      var $91=HEAP32[(($1)>>2)];
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $93
      var $94=HEAP32[(($1)>>2)];
      var $95=HEAP32[(($2)>>2)];
      var $96=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($94, $95, $96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $_noexc
      __label__ = 18; break;
    case 18: // $_ZdlPvPKci_exit
      var $97=$1;
      var $98=$2;
      var $99=$3;
      __label__ = 19; break;
    case 19: // $100
      __label__ = 21; break;
    case 20: // $101
      var $102=$entry;
      STACKTOP = __stackBase__;
      return $102;
    case 21: // $103
      var $104=$14;
      var $105=$14;
      var $106=$15;
      var $107=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $105, tempValue);
      var $108=($107.f1 = $106, $107);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_state_interface9state_addEiPKcPvh["X"]=1;

function __ZN13resource_pool10add_objectI18device_state_entryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18device_state_entryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18device_state_entryEEPT_S3_["X"]=1;

function __ZN22device_state_interface20interface_post_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+12)|0);
      var $6=__ZNK11simple_listI18device_state_entryE5countEv($5);
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=___cxa_allocate_exception(1032);
      var $10=$9;
      var $11=$4;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $15
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($10, ((STRING_TABLE.__str173216)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      ___cxa_throw($9, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      ___cxa_free_exception($9);
      __label__ = 6; break;
    case 5: // $21
      ;
      return;
    case 6: // $22
      var $23=$2;
      var $24=$2;
      var $25=$3;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI18device_state_entryE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI18device_state_entryE6detachERS0_["X"]=1;

function __ZN11simple_listI18device_state_entryEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI18device_state_entryE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN18device_state_entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18device_state_entryD2Ev($2);
  ;
  return;
}


function __ZN11simple_listI18device_state_entryED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI18device_state_entryE+8)|0);
  __ZN11simple_listI18device_state_entryE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI18device_state_entryE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI18device_state_entryE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI18device_state_entryE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI18device_state_entryE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN7astring3insEiPKci($this, $insbefore, $src, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$insbefore;
  $3=$src;
  $4=$count;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__Z13astring_inschP7astringiPKci($5, $6, $7, $8);
  ;
  return $9;
}


function __ZNK18legacy_device_base14get_legacy_intEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=$info;
  HEAP32[(($4)>>2)]=0; HEAP32[(($4+4)>>2)]=0;
  var $5=(($3+356)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$3;
  var $8=$2;
  FUNCTION_TABLE[$6]($7, $8, $info);
  var $9=$info;
  var $st$14$0=(($9)|0);
  var $10$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($9+4)|0);
  var $10$1=HEAP32[(($st$14$1)>>2)];
  STACKTOP = __stackBase__;
  return [$10$0,$10$1];
}


function __ZNK18legacy_device_base17get_legacy_stringEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=__Z22get_temp_string_bufferv();
  var $5=$info;
  HEAP32[(($5)>>2)]=$4;
  var $6=(($3+356)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$3;
  var $9=$2;
  FUNCTION_TABLE[$7]($8, $9, $info);
  var $10=$info;
  var $11=HEAP32[(($10)>>2)];
  STACKTOP = __stackBase__;
  return $11;
}


function __ZN20resource_pool_objectI18device_state_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18device_state_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18device_state_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI18device_state_entryED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI18device_state_entryE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN18device_state_entryD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18device_state_entryED2Ev["X"]=1;

function __ZN18device_state_entryD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+88)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+24)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+24)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI18device_state_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI18device_state_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI18device_state_entryED0Ev["X"]=1;

function __ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($this, $mconfig, $type, $tag, $owner, $clock, $get_config) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $result_i=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13;
      var $14;
      var $15;
      var $16;
      var $17;
      var $18;
      var $19;
      var $configlen;
      var $20;
      var $21;
      var $tokenbytes;
      $13=$this;
      $14=$mconfig;
      $15=$type;
      $16=$tag;
      $17=$owner;
      $18=$clock;
      $19=$get_config;
      var $22=$13;
      var $23=$22;
      var $24=$14;
      var $25=$15;
      var $26=$16;
      var $27=$17;
      var $28=$18;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($23, $24, $25, ((STRING_TABLE.__str3243)|0), $26, $27, $28);
      var $29=$22;
      HEAP32[(($29)>>2)]=((__ZTV18legacy_device_base+8)|0);
      var $30=(($22+356)|0);
      var $31=$19;
      HEAP32[(($30)>>2)]=$31;
      var $32=(($22+360)|0);
      HEAP32[(($32)>>2)]=0;
      var $33=(($22+364)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base14get_legacy_intEj($22, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 13; break; };
      var $34$0=$34[0];
      var $34$1=$34[1];
    case 1: // $35
      var $36$0=$34$0;
      var $36=$36$0;
      $configlen=$36;
      var $37=$configlen;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $39
      var $40=$configlen;
      var $41=$7;
      var $42=$8;
      var $43=$9;
      var $44=$10;
      var $45=$result_i;
      var $46=$11;
      var $47=$12;
      HEAP32[(($7)>>2)]=$40;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str13244)|0);
      HEAP32[(($9)>>2)]=61;
      HEAP32[(($10)>>2)]=_zeromem;
      var $48=HEAP32[(($7)>>2)];
      var $49=HEAP32[(($8)>>2)];
      var $50=HEAP32[(($9)>>2)];
      var $51=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($48, $49, $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $52
      HEAP32[(($result_i)>>2)]=$51;
      var $53=HEAP32[(($result_i)>>2)];
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $55
      var $56=___cxa_allocate_exception(4);
      var $57=$56;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($57);
      (function() { try { __THREW__ = false; return ___cxa_throw($56, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 5; break; }
    case 5: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $60=$59.f0;
      HEAP32[(($11)>>2)]=$60;
      var $61=$59.f1;
      HEAP32[(($12)>>2)]=$61;
      var $62=HEAP32[(($12)>>2)];
      var $63=(($62)|0) < 0;
      if ($63) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $64
      var $65=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $_noexc
      throw "Reached an unreachable!"
    case 8: // $66
      var $67=HEAP32[(($11)>>2)];
      var $68=HEAP32[(($11)>>2)];
      var $69=HEAP32[(($12)>>2)];
      var $70=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $68, tempValue);
      var $71=($70.f1 = $69, $70);
      var $eh_lpad_body = $71;__label__ = 15; break;
    case 9: // $72
      throw "Reached an unreachable!"
    case 10: // $_ZnajPKciRK9zeromem_t_exit
      var $73=HEAP32[(($result_i)>>2)];
      var $74=HEAP32[(($7)>>2)];
      _memset($73, 0, $74, 1);
      var $75=HEAP32[(($result_i)>>2)];
      var $76=$7;
      var $77=$8;
      var $78=$9;
      var $79=$10;
      var $80=$result_i;
      var $81=$11;
      var $82=$12;
      __label__ = 11; break;
    case 11: // $83
      var $84=$configlen;
      var $85=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $75, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; };
    case 12: // $86
      var $87=(($22+360)|0);
      HEAP32[(($87)>>2)]=$85;
      __label__ = 16; break;
    case 13: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body4 = $89;__label__ = 14; break;
    case 14: // $_body3
      var $eh_lpad_body4;
      var $eh_lpad_body = $eh_lpad_body4;__label__ = 15; break;
    case 15: // $_body
      var $eh_lpad_body;
      var $90=$eh_lpad_body.f0;
      $20=$90;
      var $91=$eh_lpad_body.f1;
      $21=$91;
      var $92=$22;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 16: // $93
      var $94=$22;
      var $95=(($94+52)|0);
      var $96=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base17get_legacy_stringEj($22, 196608) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 13; break; };
    case 17: // $97
      var $98=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($95, $96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 13; break; };
    case 18: // $99
      var $100=$22;
      var $101=(($100+116)|0);
      var $102=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base17get_legacy_stringEj($22, 196609) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 13; break; };
    case 19: // $103
      var $104=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($101, $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 13; break; };
    case 20: // $105
      var $106=$22;
      var $107=(($106+180)|0);
      var $108=$22;
      var $109=(($108+116)|0);
      var $110=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($107, $109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 13; break; };
    case 21: // $111
      var $112=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base14get_legacy_intEj($22, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 13; break; };
      var $112$0=$112[0];
      var $112$1=$112[1];
    case 22: // $113
      var $114$0=$112$0;
      var $114=$114$0;
      $tokenbytes=$114;
      var $115=$tokenbytes;
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 23; break; } else { __label__ = 34; break; }
    case 23: // $117
      var $118=$tokenbytes;
      var $119=(($118)|0) < 0;
      var $120=$119 ? -1 : $118;
      var $121=$1;
      var $122=$2;
      var $123=$3;
      var $124=$4;
      var $125=$result_i1;
      var $126=$5;
      var $127=$6;
      HEAP32[(($1)>>2)]=$120;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str13244)|0);
      HEAP32[(($3)>>2)]=71;
      HEAP32[(($4)>>2)]=_zeromem;
      var $128=HEAP32[(($1)>>2)];
      var $129=HEAP32[(($2)>>2)];
      var $130=HEAP32[(($3)>>2)];
      var $131=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($128, $129, $130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; };
    case 24: // $132
      HEAP32[(($result_i1)>>2)]=$131;
      var $133=HEAP32[(($result_i1)>>2)];
      var $134=(($133)|0)==0;
      if ($134) { __label__ = 25; break; } else { __label__ = 31; break; }
    case 25: // $135
      var $136=___cxa_allocate_exception(4);
      var $137=$136;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($137);
      (function() { try { __THREW__ = false; return ___cxa_throw($136, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 26; break; }
    case 26: // $138
      var $139=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $140=$139.f0;
      HEAP32[(($5)>>2)]=$140;
      var $141=$139.f1;
      HEAP32[(($6)>>2)]=$141;
      var $142=HEAP32[(($6)>>2)];
      var $143=(($142)|0) < 0;
      if ($143) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $144
      var $145=HEAP32[(($5)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($145) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 13; break; }
    case 28: // $_noexc2
      throw "Reached an unreachable!"
    case 29: // $146
      var $147=HEAP32[(($5)>>2)];
      var $148=HEAP32[(($5)>>2)];
      var $149=HEAP32[(($6)>>2)];
      var $150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $148, tempValue);
      var $151=($150.f1 = $149, $150);
      var $eh_lpad_body4 = $151;__label__ = 14; break;
    case 30: // $152
      throw "Reached an unreachable!"
    case 31: // $_ZnajPKciRK9zeromem_t_exit5
      var $153=HEAP32[(($result_i1)>>2)];
      var $154=HEAP32[(($1)>>2)];
      _memset($153, 0, $154, 1);
      var $155=HEAP32[(($result_i1)>>2)];
      var $156=$1;
      var $157=$2;
      var $158=$3;
      var $159=$4;
      var $160=$result_i1;
      var $161=$5;
      var $162=$6;
      __label__ = 32; break;
    case 32: // $163
      var $164=$tokenbytes;
      var $165=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $155, $164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 13; break; };
    case 33: // $166
      var $167=(($22+364)|0);
      HEAP32[(($167)>>2)]=$165;
      __label__ = 34; break;
    case 34: // $168
      STACKTOP = __stackBase__;
      return;
    case 35: // $169
      __label__ = 36; break;
    case 36: // $170
      var $171=$20;
      var $172=$20;
      var $173=$21;
      var $174=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $172, tempValue);
      var $175=($174.f1 = $173, $174);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE["X"]=1;

function __Z8downcastIR18legacy_device_base8device_tET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18legacy_device_base14get_legacy_ptrEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=$info;
  HEAP32[(($4)>>2)]=0; HEAP32[(($4+4)>>2)]=0;
  var $5=(($3+356)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$3;
  var $8=$2;
  FUNCTION_TABLE[$6]($7, $8, $info);
  var $9=$info;
  var $10=HEAP32[(($9)>>2)];
  STACKTOP = __stackBase__;
  return $10;
}


function __ZNK18legacy_device_base14get_legacy_fctEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $info=__stackBase__;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=$info;
  HEAP32[(($4)>>2)]=0; HEAP32[(($4+4)>>2)]=0;
  var $5=(($3+356)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$3;
  var $8=$2;
  FUNCTION_TABLE[$6]($7, $8, $info);
  var $9=$info;
  var $10=HEAP32[(($9)>>2)];
  STACKTOP = __stackBase__;
  return $10;
}


function __ZNK18legacy_device_base21device_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $validity_func;
      $2=$this;
      $3=$options;
      $4=$driver;
      var $5=$2;
      var $6=__ZNK18legacy_device_base14get_legacy_fctEj($5, 131077);
      var $7=$6;
      $validity_func=$7;
      var $8=$validity_func;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$validity_func;
      var $12=$4;
      var $13=$5;
      var $14=$3;
      var $15=FUNCTION_TABLE[$11]($12, $13, $14);
      var $16=(($15)|0)!=0;
      $1=$16;
      __label__ = 3; break;
    case 2: // $17
      $1=0;
      __label__ = 3; break;
    case 3: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18legacy_device_base12device_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $start_func;
      $1=$this;
      var $2=$1;
      var $3=__ZNK18legacy_device_base14get_legacy_fctEj($2, 131072);
      var $4=$3;
      $start_func=$4;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$start_func;
      var $8=$2;
      FUNCTION_TABLE[$7]($8);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18legacy_device_base12device_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $reset_func;
      $1=$this;
      var $2=$1;
      var $3=__ZNK18legacy_device_base14get_legacy_fctEj($2, 131074);
      var $4=$3;
      $reset_func=$4;
      var $5=$reset_func;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$reset_func;
      var $9=$2;
      FUNCTION_TABLE[$8]($9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18legacy_device_base11device_stopEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $stop_func;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+244)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=__ZNK18legacy_device_base14get_legacy_fctEj($2, 131073);
      var $9=$8;
      $stop_func=$9;
      var $10=$stop_func;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$stop_func;
      var $14=$2;
      FUNCTION_TABLE[$13]($14);
      __label__ = 3; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i($this, $stream, $inputs, $outputs, $samples) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$stream;
  $3=$inputs;
  $4=$outputs;
  $5=$samples;
  var $6=$1;
  var $7=$6;
  var $8=(($7-368)|0);
  var $9=$8;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$2;
  __ZN24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i($9, $13, $10, $11, $12);
  ;
  return;
}


function __ZN24legacy_sound_device_baseD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN24legacy_sound_device_baseD2Ev($2);
  ;
  return;
}


function __ZThn368_N24legacy_sound_device_baseD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_sound_device_baseD1Ev($5);
  ;
  return;
}


function __ZThn368_N24legacy_sound_device_baseD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_sound_device_baseD0Ev($5);
  ;
  return;
}


function __ZN24device_execute_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN16device_interfaceD2Ev($3);
  ;
  return;
}


function __ZN18legacy_device_baseD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18legacy_device_baseD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18legacy_device_baseD0Ev["X"]=1;

function __ZN18legacy_device_baseD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV18legacy_device_base+8)|0);
      var $6=(($4+364)|0);
      var $7=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=(($4+360)|0);
      var $10=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$4;
      __ZN8device_tD2Ev($12);
      ;
      return;
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      var $17=$4;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18legacy_device_base19static_set_inline32ER8device_tjjj($device, $offset, $size, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $legacy;
      var $dest;
      var $5;
      var $6;
      $1=$device;
      $2=$offset;
      $3=$size;
      $4=$value;
      var $7=$1;
      var $8=__Z8downcastIR18legacy_device_base8device_tET_RT0_($7);
      $legacy=$8;
      var $9=$legacy;
      var $10=(($9+360)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=(($11+$12)|0);
      $dest=$13;
      var $14=$3;
      var $15=(($14)|0)==1;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$4;
      var $18=(($17) & 255);
      var $19=$dest;
      HEAP8[($19)]=$18;
      __label__ = 11; break;
    case 2: // $20
      var $21=$3;
      var $22=(($21)|0)==2;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$4;
      var $25=(($24) & 65535);
      var $26=$dest;
      var $27=$26;
      HEAP16[(($27)>>1)]=$25;
      __label__ = 10; break;
    case 4: // $28
      var $29=$3;
      var $30=(($29)|0)==4;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=$4;
      var $33=$dest;
      var $34=$33;
      HEAP32[(($34)>>2)]=$32;
      __label__ = 9; break;
    case 6: // $35
      var $36=___cxa_allocate_exception(1032);
      var $37=$36;
      var $38=$3;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($37, ((STRING_TABLE.__str23245)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$38,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $39
      ___cxa_throw($36, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 8: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $5=$42;
      var $43=$41.f1;
      $6=$43;
      ___cxa_free_exception($36);
      __label__ = 12; break;
    case 9: // $44
      __label__ = 10; break;
    case 10: // $45
      __label__ = 11; break;
    case 11: // $46
      ;
      return;
    case 12: // $47
      var $48=$5;
      var $49=$5;
      var $50=$6;
      var $51=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $49, tempValue);
      var $52=($51.f1 = $50, $51);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18legacy_device_base19static_set_inline32ER8device_tjjj["X"]=1;

function __ZN24legacy_sound_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($this, $mconfig, $type, $tag, $owner, $clock, $get_config) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $1=$this;
      $2=$mconfig;
      $3=$type;
      $4=$tag;
      $5=$owner;
      $6=$clock;
      $7=$get_config;
      var $10=$1;
      var $11=$10;
      var $12=$2;
      var $13=$3;
      var $14=$4;
      var $15=$5;
      var $16=$6;
      var $17=$7;
      __ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($11, $12, $13, $14, $15, $16, $17);
      var $18=$10;
      HEAP32[(($18)>>2)]=((__ZTV24legacy_sound_device_base+8)|0);
      var $19=$10;
      var $20=(($19+368)|0);
      var $21=$20;
      HEAP32[(($21)>>2)]=((__ZTV24legacy_sound_device_base+80)|0);
      var $22=$10;
      var $23=(($22+368)|0);
      var $24=$23;
      var $25=$2;
      var $26=$10;
      (function() { try { __THREW__ = false; return __ZN22device_sound_interfaceC2ERK14machine_configR8device_t($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      var $28=$10;
      HEAP32[(($28)>>2)]=((__ZTV24legacy_sound_device_base+8)|0);
      var $29=$10;
      var $30=(($29+368)|0);
      var $31=$30;
      HEAP32[(($31)>>2)]=((__ZTV24legacy_sound_device_base+80)|0);
      ;
      return;
    case 2: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $8=$34;
      var $35=$33.f1;
      $9=$35;
      var $36=$10;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_baseD2Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$8;
      var $40=$8;
      var $41=$9;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24legacy_sound_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE["X"]=1;

function __ZN24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i($this, $stream, $inputs, $outputs, $samples) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$stream;
  $3=$inputs;
  $4=$outputs;
  $5=$samples;
  var $6=$1;
  __Z10fatalerrorPKcz(((STRING_TABLE.__str53248)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
  throw "Reached an unreachable!"
  STACKTOP = __stackBase__;
  return;
}


function __ZN24legacy_sound_device_baseD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN24legacy_sound_device_baseD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24legacy_sound_device_baseD0Ev["X"]=1;

function __ZN24legacy_sound_device_baseD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+368)|0);
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN22device_sound_interfaceD2Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      __ZN18legacy_device_baseD2Ev($9);
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=$4;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_baseD2Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$2;
      var $19=$3;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$mconfig;
      $3=$device;
      var $6=$1;
      var $7=$6;
      var $8=$3;
      __ZN16device_interfaceC2ER8device_t($7, $8);
      var $9=$6;
      HEAP32[(($9)>>2)]=((__ZTV24device_execute_interface+8)|0);
      var $10=(($6+12)|0);
      HEAP8[($10)]=0;
      var $11=(($6+16)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($6+20)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=(($6+24)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($6+28)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($6+32)|0);
      var $16=$15;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $17=(($6+44)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($6+48)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($6+52)|0);
      var $20=(($19)|0);
      var $21=(($20+5460)|0);
      var $23 = $20;__label__ = 1; break;
    case 1: // $22
      var $23;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24device_execute_interface12device_inputC1Ev]($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $24
      var $25=(($23+156)|0);
      var $26=(($25)|0)==(($21)|0);
      if ($26) { __label__ = 3; break; } else { var $23 = $25;__label__ = 1; break; }
    case 3: // $27
      var $28=(($6+5512)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($6+5516)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($6+5520)|0);
      HEAP32[(($30)>>2)]=0;
      var $31=(($6+5524)|0);
      (function() { try { __THREW__ = false; return __ZN8attotimeC1Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $32
      var $33=(($6+5536)|0);
      HEAP32[(($33)>>2)]=283;
      var $34=(($6+5540)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=(($6+5544)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=(($6+5548)|0);
      HEAP32[(($36)>>2)]=0;
      var $37=(($6+5552)|0);
      HEAP32[(($37)>>2)]=0;
      var $38=(($6+5556)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=(($6+5560)|0);
      HEAP8[($39)]=0;
      var $40=(($6+5561)|0);
      HEAP8[($40)]=0;
      var $41=(($6+5564)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=(($6+5568)|0);
      HEAP32[(($42)>>2)]=0;
      var $43=(($6+5572)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$23$0=(($43)|0);
      HEAP32[(($st$23$0)>>2)]=$$emscripten$temp$0$0;
      var $st$23$1=(($43+4)|0);
      HEAP32[(($st$23$1)>>2)]=$$emscripten$temp$0$1;
      var $44=(($6+5580)|0);
      (function() { try { __THREW__ = false; return __ZN8attotimeC1Ev($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=(($6+5592)|0);
      HEAP32[(($46)>>2)]=0;
      var $47=(($6+5596)|0);
      HEAP8[($47)]=0;
      var $48=(($6+5600)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=(($6+5604)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$9$0=(($49)|0);
      HEAP32[(($st$9$0)>>2)]=$$emscripten$temp$1$0;
      var $st$9$1=(($49+4)|0);
      HEAP32[(($st$9$1)>>2)]=$$emscripten$temp$1$1;
      var $50=(($6+5580)|0);
      var $51=$50;
      for (var $$dest = $51, $$stop = $$dest + 12; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $52=$3;
      var $53=(($52+8)|0);
      HEAP32[(($53)>>2)]=$6;
      ;
      return;
    case 6: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      $4=$56;
      var $57=$55.f1;
      $5=$57;
      var $58=$6;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $59
      __label__ = 8; break;
    case 8: // $60
      var $61=$4;
      var $62=$4;
      var $63=$5;
      var $64=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $62, tempValue);
      var $65=($64.f1 = $63, $64);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interfaceC2ERK14machine_configR8device_t["X"]=1;

function __ZN24device_execute_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24device_execute_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interfaceD0Ev["X"]=1;

function __ZNK24device_execute_interface18execute_min_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNK24device_execute_interface18execute_max_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNK24device_execute_interface19execute_input_linesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK24device_execute_interface26execute_default_irq_vectorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZN24device_execute_interface12execute_burnEi($this, $cycles) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$cycles;
  var $3=$1;
  ;
  return;
}


function __ZN24device_execute_interface17execute_set_inputEii($this, $linenum, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$linenum;
  $3=$state;
  var $4=$1;
  ;
  return;
}


function __ZNK24device_execute_interface24execute_clocks_to_cyclesEy($this, $clocks$0, $clocks$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$clocks$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$clocks$1;
  var $3=$1;
  var $st$8$0=(($2)|0);
  var $4$0=HEAP32[(($st$8$0)>>2)];
  var $st$8$1=(($2+4)|0);
  var $4$1=HEAP32[(($st$8$1)>>2)];
  STACKTOP = __stackBase__;
  return [$4$0,$4$1];
}


function __ZNK24device_execute_interface24execute_cycles_to_clocksEy($this, $cycles$0, $cycles$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$cycles$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$cycles$1;
  var $3=$1;
  var $st$8$0=(($2)|0);
  var $4$0=HEAP32[(($st$8$0)>>2)];
  var $st$8$1=(($2+4)|0);
  var $4$1=HEAP32[(($st$8$1)>>2)];
  STACKTOP = __stackBase__;
  return [$4$0,$4$1];
}


function __ZNK24device_execute_interface8disabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK24device_execute_interface9executingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK16device_interface6deviceEv($3);
  var $5=__ZNK8device_t7machineEv($4);
  var $6=__ZN15running_machine9schedulerEv($5);
  var $7=__ZNK16device_scheduler19currently_executingEv($6);
  var $8=(($2)|0)==(($7)|0);
  ;
  return $8;
}


function __ZNK24device_execute_interface16cycles_remainingEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK24device_execute_interface9executingEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+5540)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=HEAP32[(($6)>>2)];
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface10eat_cyclesEi($this, $cycles) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$cycles;
      var $3=$1;
      var $4=__ZNK24device_execute_interface9executingEv($3);
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      __label__ = 5; break;
    case 2: // $6
      var $7=$2;
      var $8=(($3+5540)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=HEAP32[(($9)>>2)];
      var $11=(($7)|0) > (($10)|0);
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=(($3+5540)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=HEAP32[(($14)>>2)];
      $2=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=(($3+5540)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20-$17)|0);
      HEAP32[(($19)>>2)]=$21;
      __label__ = 5; break;
    case 5: // $22
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface15abort_timesliceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $delta;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZN16device_interface6deviceEv($3);
      var $5=__ZNK8device_t7machineEv($4);
      var $6=__ZN15running_machine9schedulerEv($5);
      var $7=__ZNK16device_scheduler19currently_executingEv($6);
      var $8=(($2)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      __label__ = 4; break;
    case 2: // $10
      var $11=(($2+5540)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=(($2+5540)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=HEAP32[(($16)>>2)];
      $delta=$17;
      var $18=$delta;
      var $19=(($2+5548)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+$18)|0);
      HEAP32[(($19)>>2)]=$21;
      var $22=$delta;
      var $23=(($2+5544)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24-$22)|0);
      HEAP32[(($23)>>2)]=$25;
      var $26=$delta;
      var $27=(($2+5540)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29-$26)|0);
      HEAP32[(($28)>>2)]=$30;
      __label__ = 4; break;
    case 4: // $31
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface7suspendEjb($this, $reason, $eatcycles) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$reason;
  var $4=(($eatcycles)&1);
  $3=$4;
  var $5=$1;
  var $6=$2;
  var $7=(($5+5556)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$8 | $6;
  HEAP32[(($7)>>2)]=$9;
  var $10=$3;
  var $11=(($10) & 1);
  var $12=(($11)&1);
  var $13=(($5+5561)|0);
  HEAP8[($13)]=$12;
  __ZN24device_execute_interface15abort_timesliceEv($5);
  ;
  return;
}


function __ZN24device_execute_interface6resumeEj($this, $reason) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$reason;
  var $3=$1;
  var $4=$2;
  var $5=$4 ^ -1;
  var $6=(($3+5556)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$7 & $5;
  HEAP32[(($6)>>2)]=$8;
  __ZN24device_execute_interface15abort_timesliceEv($3);
  ;
  return;
}


function __ZN24device_execute_interface7triggerEi($this, $trigid) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$trigid;
      var $3=$1;
      __ZN24device_execute_interface15abort_timesliceEv($3);
      var $4=(($3+5556)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5 & 8;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=(($3+5564)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=(($10)|0)==(($11)|0);
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      __ZN24device_execute_interface6resumeEj($3, 8);
      var $14=(($3+5564)|0);
      HEAP32[(($14)>>2)]=0;
      __label__ = 3; break;
    case 3: // $15
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24device_execute_interface10local_timeEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cycles;
      var $2=__stackBase__;
      $1=$this;
      var $3=$1;
      var $4=(($3+5580)|0);
      var $5=$agg_result;
      var $6=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];HEAP32[(($5+4)>>2)]=HEAP32[(($6+4)>>2)];HEAP32[(($5+8)>>2)]=HEAP32[(($6+8)>>2)];
      var $7=__ZNK24device_execute_interface9executingEv($3);
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      var $11=(($3+5544)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($3+5540)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12-$15)|0);
      $cycles=$16;
      var $17=$cycles;
      var $18$0=$17;
      var $18$1=(($17|0) < 0 ? -1 : 0);
      __ZNK24device_execute_interface18cycles_to_attotimeEy($2, $3, $18$0, $18$1);
      var $19=__ZN8attotimepLERKS_($agg_result, $2);
      __label__ = 4; break;
    case 4: // $20
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24device_execute_interface18cycles_to_attotimeEy($agg_result, $this, $cycles$0, $cycles$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$cycles$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$cycles$1;
  var $3=$1;
  var $4=$3;
  var $5=__ZNK16device_interface6deviceEv($4);
  var $st$10$0=(($2)|0);
  var $6$0=HEAP32[(($st$10$0)>>2)];
  var $st$10$1=(($2+4)|0);
  var $6$1=HEAP32[(($st$10$1)>>2)];
  var $7=__ZNK24device_execute_interface16cycles_to_clocksEy($3, $6$0, $6$1);
  var $7$0=$7[0];
  var $7$1=$7[1];
  __ZNK8device_t18clocks_to_attotimeEy($agg_result, $5, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK24device_execute_interface12total_cyclesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=__ZNK24device_execute_interface9executingEv($3);
      if ($4) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      __label__ = 3; break;
    case 3: // $7
      var $8=(($3+5572)|0);
      var $st$1$0=(($8)|0);
      var $9$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($8+4)|0);
      var $9$1=HEAP32[(($st$1$1)>>2)];
      var $10=(($3+5544)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12$0=$11;
      var $12$1=(($11|0) < 0 ? -1 : 0);
      var $13$0 = ((($9$0)>>>0)+((($9$1)|0)*4294967296))+((($12$0)>>>0)+((($12$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($9$0)>>>0)+((($9$1)|0)*4294967296))+((($12$0)>>>0)+((($12$1)|0)*4294967296)))/4294967296), 4294967295);
      var $14=(($3+5540)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=HEAP32[(($15)>>2)];
      var $17$0=$16;
      var $17$1=(($16|0) < 0 ? -1 : 0);
      var $18$0 = ((($13$0)>>>0)+((($13$1)|0)*4294967296))-((($17$0)>>>0)+((($17$1)|0)*4294967296))>>>0; var $18$1 = Math.min(Math.floor((((($13$0)>>>0)+((($13$1)|0)*4294967296))-((($17$0)>>>0)+((($17$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$16$0=(($1)|0);
      HEAP32[(($st$16$0)>>2)]=$18$0;
      var $st$16$1=(($1+4)|0);
      HEAP32[(($st$16$1)>>2)]=$18$1;
      __label__ = 5; break;
    case 4: // $19
      var $20=(($3+5572)|0);
      var $st$1$0=(($20)|0);
      var $21$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($1)|0);
      HEAP32[(($st$5$0)>>2)]=$21$0;
      var $st$5$1=(($1+4)|0);
      HEAP32[(($st$5$1)>>2)]=$21$1;
      __label__ = 5; break;
    case 5: // $22
      var $st$0$0=(($1)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$23$0,$23$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24device_execute_interface24interface_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      $1=$this;
      $2=$options;
      $3=$driver;
      var $4=$1;
      $error=0;
      var $5=(($4+16)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $8
      var $9=$4;
      var $10=__ZNK16device_interface6deviceEv($9);
      var $11=__ZNK8device_t7mconfigEv($10);
      var $12=__ZNK14machine_config10devicelistEv($11);
      var $13=HEAP32[((_SCREEN)>>2)];
      var $14=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($12, $13);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$3;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$3;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$4;
      var $24=__ZNK16device_interface6deviceEv($23);
      var $25=__ZNK8device_t3tagEv($24);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str43276)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,HEAP32[((tempInt+4)>>2)]=$22,HEAP32[((tempInt+8)>>2)]=$25,tempInt));
      $error=1;
      __label__ = 15; break;
    case 3: // $26
      var $27=(($4+24)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      var $31=(($4+20)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$3;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$3;
      var $39=(($38+8)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$4;
      var $42=__ZNK16device_interface6deviceEv($41);
      var $43=__ZNK8device_t3tagEv($42);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str53277)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,HEAP32[((tempInt+4)>>2)]=$40,HEAP32[((tempInt+8)>>2)]=$43,tempInt));
      $error=1;
      __label__ = 14; break;
    case 6: // $44
      var $45=(($4+24)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $48
      var $49=$4;
      var $50=__ZNK16device_interface6deviceEv($49);
      var $51=__ZNK8device_t7mconfigEv($50);
      var $52=__ZNK14machine_config10devicelistEv($51);
      var $53=$52;
      var $54=(($4+24)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=__ZNK11tagged_listI8device_tE4findEPKc($53, $55);
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=$3;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$3;
      var $63=(($62+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$4;
      var $66=__ZNK16device_interface6deviceEv($65);
      var $67=__ZNK8device_t3tagEv($66);
      var $68=(($4+24)|0);
      var $69=HEAP32[(($68)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str63278)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$61,HEAP32[((tempInt+4)>>2)]=$64,HEAP32[((tempInt+8)>>2)]=$67,HEAP32[((tempInt+12)>>2)]=$69,tempInt));
      $error=1;
      __label__ = 13; break;
    case 9: // $70
      var $71=(($4+24)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $74
      var $75=(($4+20)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $78
      var $79=$3;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$3;
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$4;
      var $86=__ZNK16device_interface6deviceEv($85);
      var $87=__ZNK8device_t3tagEv($86);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str73279)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,HEAP32[((tempInt+4)>>2)]=$84,HEAP32[((tempInt+8)>>2)]=$87,tempInt));
      $error=1;
      __label__ = 12; break;
    case 12: // $88
      __label__ = 13; break;
    case 13: // $89
      __label__ = 14; break;
    case 14: // $90
      __label__ = 15; break;
    case 15: // $91
      __label__ = 19; break;
    case 16: // $92
      var $93=(($4+20)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $96
      var $97=$3;
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$3;
      var $101=(($100+8)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$4;
      var $104=__ZNK16device_interface6deviceEv($103);
      var $105=__ZNK8device_t3tagEv($104);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str83280)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$99,HEAP32[((tempInt+4)>>2)]=$102,HEAP32[((tempInt+8)>>2)]=$105,tempInt));
      $error=1;
      __label__ = 18; break;
    case 18: // $106
      __label__ = 19; break;
    case 19: // $107
      var $108=(($4+28)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $111
      var $112=(($4+32)|0);
      var $113=__ZeqRK8attotimeS1_($112, __ZN8attotime4zeroE);
      if ($113) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $114
      var $115=$3;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$3;
      var $119=(($118+8)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$4;
      var $122=__ZNK16device_interface6deviceEv($121);
      var $123=__ZNK8device_t3tagEv($122);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str93281)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$117,HEAP32[((tempInt+4)>>2)]=$120,HEAP32[((tempInt+8)>>2)]=$123,tempInt));
      $error=1;
      __label__ = 26; break;
    case 22: // $124
      var $125=(($4+28)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126)|0)==0;
      if ($127) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $128
      var $129=(($4+32)|0);
      var $130=__ZneRK8attotimeS1_($129, __ZN8attotime4zeroE);
      if ($130) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $131
      var $132=$3;
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$3;
      var $136=(($135+8)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$4;
      var $139=__ZNK16device_interface6deviceEv($138);
      var $140=__ZNK8device_t3tagEv($139);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str103282)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,HEAP32[((tempInt+4)>>2)]=$137,HEAP32[((tempInt+8)>>2)]=$140,tempInt));
      $error=1;
      __label__ = 25; break;
    case 25: // $141
      __label__ = 26; break;
    case 26: // $142
      var $143=$error;
      var $144=(($143) & 1);
      ;
      return $144;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK24device_execute_interface24interface_validity_checkER11emu_optionsRK11game_driver["X"]=1;

function __ZN24device_execute_interface19interface_pre_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $index;
      var $line;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZN16device_interface6deviceEv($3);
      var $5=__ZNK8device_t7machineEv($4);
      var $6=__ZNK15running_machine10devicelistEv($5);
      var $7=$6;
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK11tagged_listI8device_tE7indexofERKS0_($7, $10);
      $index=$11;
      var $12=(($2+5552)|0);
      HEAP32[(($12)>>2)]=2;
      var $13=$index;
      var $14=(($13)|0);
      var $15=(($2+5536)|0);
      HEAP32[(($15)>>2)]=$14;
      var $16=$index;
      var $17=(($16-2000)|0);
      var $18=(($2+5568)|0);
      HEAP32[(($18)>>2)]=$17;
      $line=0;
      __label__ = 1; break;
    case 1: // $19
      var $20=$line;
      var $21=(($20)>>>0) < 35;
      if ($21) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $22
      var $23=$line;
      var $24=(($2+52)|0);
      var $25=(($24+$23*156)|0);
      var $26=$line;
      __ZN24device_execute_interface12device_input5startEPS_i($25, $2, $26);
      __label__ = 3; break;
    case 3: // $27
      var $28=$line;
      var $29=(($28+1)|0);
      $line=$29;
      __label__ = 1; break;
    case 4: // $30
      var $31=(($2+20)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0) > 1;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$2;
      var $36=__ZN16device_interface6deviceEv($35);
      var $37=__ZNK8device_t7machineEv($36);
      var $38=__ZN15running_machine9schedulerEv($37);
      var $39=$2;
      var $40=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($38, 832, ((STRING_TABLE.__str113283)|0), $39);
      var $41=(($2+5520)|0);
      HEAP32[(($41)>>2)]=$40;
      __label__ = 6; break;
    case 6: // $42
      var $43=(($2+32)|0);
      var $44=__ZneRK8attotimeS1_($43, __ZN8attotime4zeroE);
      if ($44) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $45
      var $46=$2;
      var $47=__ZN16device_interface6deviceEv($46);
      var $48=__ZNK8device_t7machineEv($47);
      var $49=__ZN15running_machine9schedulerEv($48);
      var $50=$2;
      var $51=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($49, 834, ((STRING_TABLE.__str123284)|0), $50);
      var $52=(($2+5512)|0);
      HEAP32[(($52)>>2)]=$51;
      __label__ = 8; break;
    case 8: // $53
      var $54=$2;
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($2+5552)|0);
      __ZN8device_t9save_itemIjEEvRT_PKci($56, $57, ((STRING_TABLE.__str133285)|0), 0);
      var $58=$2;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($2+5556)|0);
      __ZN8device_t9save_itemIjEEvRT_PKci($60, $61, ((STRING_TABLE.__str143286)|0), 0);
      var $62=$2;
      var $63=(($62+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($2+5560)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($64, $65, ((STRING_TABLE.__str153287)|0), 0);
      var $66=$2;
      var $67=(($66+8)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($2+5561)|0);
      __ZN8device_t9save_itemIhEEvRT_PKci($68, $69, ((STRING_TABLE.__str163288)|0), 0);
      var $70=$2;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($2+5564)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($72, $73, ((STRING_TABLE.__str173289)|0), 0);
      var $74=$2;
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($2+5572)|0);
      __ZN8device_t9save_itemIyEEvRT_PKci($76, $77, ((STRING_TABLE.__str183290)|0), 0);
      var $78=$2;
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($2+5580)|0);
      __ZN8device_t9save_itemI8attotimeEEvRT_PKci($80, $81, ((STRING_TABLE.__str193291)|0), 0);
      var $82=$2;
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($2+5516)|0);
      __ZN8device_t9save_itemIiEEvRT_PKci($84, $85, ((STRING_TABLE.__str203292)|0), 0);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interface19interface_pre_startEv["X"]=1;

function __ZNK11tagged_listI8device_tE7indexofERKS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=__ZNK11simple_listI8device_tE7indexofERKS0_($4, $5);
  ;
  return $6;
}


function __ZN24device_execute_interface12device_input5startEPS_i($this, $execute, $linenum) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$execute;
  $3=$linenum;
  var $4=$1;
  var $5=$2;
  var $6=(($4)|0);
  HEAP32[(($6)>>2)]=$5;
  var $7=(($4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$8;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($4+4)|0);
  HEAP32[(($12)>>2)]=$11;
  var $13=$3;
  var $14=(($4+8)|0);
  HEAP32[(($14)>>2)]=$13;
  __ZN24device_execute_interface12device_input5resetEv($4);
  var $15=(($4+4)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=(($4+12)|0);
  var $18=(($4+8)|0);
  var $19=HEAP32[(($18)>>2)];
  __ZN8device_t9save_itemIiEEvRT_PKci($16, $17, ((STRING_TABLE.__str253297)|0), $19);
  var $20=(($4+4)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=(($4+16)|0);
  var $23=(($4+8)|0);
  var $24=HEAP32[(($23)>>2)];
  __ZN8device_t9save_itemIiEEvRT_PKci($21, $22, ((STRING_TABLE.__str263298)|0), $24);
  var $25=(($4+4)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=(($4+20)|0);
  var $28=(($4+8)|0);
  var $29=HEAP32[(($28)>>2)];
  __ZN8device_t9save_itemIhEEvRT_PKci($26, $27, ((STRING_TABLE.__str273299)|0), $29);
  ;
  return;
}


function __ZN24device_execute_interface38static_trigger_partial_frame_interruptER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN24device_execute_interface31trigger_partial_frame_interruptEv($5);
  ;
  return;
}


function __ZN24device_execute_interface33static_trigger_periodic_interruptER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN24device_execute_interface26trigger_periodic_interruptEv($5);
  ;
  return;
}


function __ZN24device_execute_interface19interface_pre_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+5572)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$6$0=(($3)|0);
      HEAP32[(($st$6$0)>>2)]=$$emscripten$temp$0$0;
      var $st$6$1=(($3+4)|0);
      HEAP32[(($st$6$1)>>2)]=$$emscripten$temp$0$1;
      var $4=__ZNK24device_execute_interface8disabledEv($2);
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      __ZN24device_execute_interface6resumeEj($2, -1);
      __label__ = 3; break;
    case 2: // $6
      __ZN24device_execute_interface7suspendEjb($2, 16, 1);
      __label__ = 3; break;
    case 3: // $7
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface21static_set_vblank_intER8device_tPFvPS0_EPKci($device, $function, $tag, $rate) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $exec=__stackBase__;
      var $5;
      var $6;
      $1=$device;
      $2=$function;
      $3=$tag;
      $4=$rate;
      var $7=$1;
      var $8=__ZN8device_t9interfaceERP24device_execute_interface($7, $exec);
      if ($8) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(1032);
      var $11=$10;
      var $12=$1;
      var $13=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $14
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($11, ((STRING_TABLE.__str13273)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$13,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      ___cxa_throw($10, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $5=$18;
      var $19=$17.f1;
      $6=$19;
      ___cxa_free_exception($10);
      __label__ = 6; break;
    case 5: // $20
      var $21=$2;
      var $22=HEAP32[(($exec)>>2)];
      var $23=(($22+16)|0);
      HEAP32[(($23)>>2)]=$21;
      var $24=$4;
      var $25=HEAP32[(($exec)>>2)];
      var $26=(($25+20)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$3;
      var $28=HEAP32[(($exec)>>2)];
      var $29=(($28+24)|0);
      HEAP32[(($29)>>2)]=$27;
      STACKTOP = __stackBase__;
      return;
    case 6: // $30
      var $31=$5;
      var $32=$5;
      var $33=$6;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface20interface_post_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=(($4+5540)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=___cxa_allocate_exception(1032);
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($11, ((STRING_TABLE.__str213293)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str223294)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str233295)|0),HEAP32[((tempInt+8)>>2)]=562,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      ___cxa_throw($10, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      ___cxa_free_exception($10);
      __label__ = 7; break;
    case 5: // $17
      __label__ = 6; break;
    case 6: // $18
      ;
      return;
    case 7: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface9suspendedEj($this, $reason) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$reason;
  var $3=$1;
  var $4=(($3+5556)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=$5 & $6;
  var $8=(($7)|0)!=0;
  ;
  return $8;
}


function __ZN24device_execute_interface20interface_post_resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $line;
      var $screen;
      var $2=__stackBase__;
      var $3=__stackBase__+24;
      var $timedint_period=__stackBase__+32;
      var $4=__stackBase__+44;
      var $5=__stackBase__+56;
      $1=$this;
      var $6=$1;
      $line=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$line;
      var $9=(($8)>>>0) < 35;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$line;
      var $12=(($6+52)|0);
      var $13=(($12+$11*156)|0);
      __ZN24device_execute_interface12device_input5resetEv($13);
      __label__ = 3; break;
    case 3: // $14
      var $15=$line;
      var $16=(($15+1)|0);
      $line=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=(($6+20)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0) > 0;
      if ($20) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $21
      var $22=(($6+24)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $25
      var $26=(($6+24)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$6;
      var $31=__ZN16device_interface6deviceEv($30);
      var $32=__ZNK8device_t7machineEv($31);
      var $33=(($6+24)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZN15running_machine6deviceEPKc($32, $34);
      var $36=__Z8downcastIP13screen_device8device_tET_PT0_($35);
      $screen=$36;
      __label__ = 9; break;
    case 8: // $37
      var $38=$6;
      var $39=__ZN16device_interface6deviceEv($38);
      var $40=__ZNK8device_t7machineEv($39);
      var $41=__ZNK15running_machine12first_screenEv($40);
      $screen=$41;
      __label__ = 9; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      __label__ = 11; break;
    case 11: // $44
      var $45=$screen;
      HEAP32[(($3)>>2)]={ f0: 836, f1: 0 }.f0; HEAP32[(($3+4)>>2)]={ f0: 836, f1: 0 }.f1;
      __ZN8delegateIFvR13screen_devicebEEC1I24device_execute_interfaceEEN15delegate_traitsIT_vS1_b8_noparamS8_E16member_func_typeEPKcPS7_($2, $3, ((STRING_TABLE.__str243296)|0), $6);
      __ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE($45, $2);
      __label__ = 12; break;
    case 12: // $46
      var $47=(($6+32)|0);
      var $48=__ZneRK8attotimeS1_($47, __ZN8attotime4zeroE);
      if ($48) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $49
      var $50=(($6+32)|0);
      var $51=$timedint_period;
      var $52=$50;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($51)>>2)]=HEAP32[(($52)>>2)];HEAP32[(($51+4)>>2)]=HEAP32[(($52+4)>>2)];HEAP32[(($51+8)>>2)]=HEAP32[(($52+8)>>2)];
      __label__ = 14; break;
    case 14: // $53
      __label__ = 15; break;
    case 15: // $54
      var $55=(($6+5512)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$4;
      var $58=$timedint_period;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($57)>>2)]=HEAP32[(($58)>>2)];HEAP32[(($57+4)>>2)]=HEAP32[(($58+4)>>2)];HEAP32[(($57+8)>>2)]=HEAP32[(($58+8)>>2)];
      var $59=$5;
      var $60=$timedint_period;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];HEAP32[(($59+4)>>2)]=HEAP32[(($60+4)>>2)];HEAP32[(($59+8)>>2)]=HEAP32[(($60+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($56, $4, 0, $5);
      __label__ = 16; break;
    case 16: // $61
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interface20interface_post_resetEv["X"]=1;

function __ZN24device_execute_interface12device_input5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=__ZNK24device_execute_interface18default_irq_vectorEv($4);
  var $6=(($2+12)|0);
  HEAP32[(($6)>>2)]=$5;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=(($2+152)|0);
  HEAP32[(($8)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvR13screen_devicebEEC1I24device_execute_interfaceEEN15delegate_traitsIT_vS1_b8_noparamS8_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvR13screen_devicebEEC2I24device_execute_interfaceEEN15delegate_traitsIT_vS1_b8_noparamS8_E16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN24device_execute_interface9on_vblankER13screen_deviceb($this, $screen, $vblank_state) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      var $6=__stackBase__+24;
      var $7=__stackBase__+36;
      $1=$this;
      $2=$screen;
      var $8=(($vblank_state)&1);
      $3=$8;
      var $9=$1;
      var $10=$3;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      __label__ = 10; break;
    case 2: // $13
      var $14=__ZN24device_execute_interface9suspendedEj($9, 16);
      if ($14) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $15
      var $16=(($9+5516)|0);
      HEAP32[(($16)>>2)]=0;
      __label__ = 5; break;
    case 4: // $17
      var $18=(($9+5516)|0);
      HEAP32[(($18)>>2)]=-1;
      __label__ = 5; break;
    case 5: // $19
      var $20=__ZN24device_execute_interface9suspendedEj($9, 19);
      if ($20) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $21
      var $22=(($9+16)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$9;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      FUNCTION_TABLE[$23]($26);
      __label__ = 7; break;
    case 7: // $27
      var $28=(($9+20)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0) > 1;
      if ($30) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $31
      var $32=__ZN24device_execute_interface9suspendedEj($9, 16);
      if ($32) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $33
      var $34=(($9+5524)|0);
      var $35=$9;
      var $36=__ZN16device_interface6deviceEv($35);
      var $37=__ZNK8device_t7machineEv($36);
      var $38=(($37+560)|0);
      var $39=HEAP32[(($38)>>2)];
      __ZNK13screen_device12frame_periodEv($5, $39);
      var $40=(($9+20)|0);
      var $41=HEAP32[(($40)>>2)];
      __ZdvRK8attotimej($4, $5, $41);
      var $42=$34;
      var $43=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($42)>>2)]=HEAP32[(($43)>>2)];HEAP32[(($42+4)>>2)]=HEAP32[(($43+4)>>2)];HEAP32[(($42+8)>>2)]=HEAP32[(($43+8)>>2)];
      var $44=(($9+5520)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($9+5524)|0);
      var $47=$6;
      var $48=$46;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[(($48)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[(($48+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[(($48+8)>>2)];
      var $49=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($49)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($49+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($49+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($45, $6, 0, $7);
      __label__ = 10; break;
    case 10: // $50
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interface9on_vblankER13screen_deviceb["X"]=1;

function __ZN24device_execute_interface23interface_clock_changedEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $attos=__stackBase__;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t5clockEv($5);
      var $7$0=$6;
      var $7$1=0;
      var $8=__ZNK24device_execute_interface16clocks_to_cyclesEy($2, $7$0, $7$1);
      var $8$0=$8[0];
      var $8$1=$8[1];
      var $9$0=$8$0;
      var $9=$9$0;
      var $10=(($2+5600)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=(($2+5600)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13$0=$12;
      var $13$1=0;
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $14$0 = (tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($13$0)>>>0)+((($13$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $14$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($13$0)>>>0)+((($13$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $15=(($2+5604)|0);
      var $st$25$0=(($15)|0);
      HEAP32[(($st$25$0)>>2)]=$14$0;
      var $st$25$1=(($15+4)|0);
      HEAP32[(($st$25$1)>>2)]=$14$1;
      var $16=(($2+5604)|0);
      var $st$30$0=(($16)|0);
      var $17$0=HEAP32[(($st$30$0)>>2)];
      var $st$30$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$30$1)>>2)];
      var $st$34$0=(($attos)|0);
      HEAP32[(($st$34$0)>>2)]=$17$0;
      var $st$34$1=(($attos+4)|0);
      HEAP32[(($st$34$1)>>2)]=$17$1;
      var $18=(($2+5596)|0);
      HEAP8[($18)]=0;
      __label__ = 1; break;
    case 1: // $19
      var $st$0$0=(($attos)|0);
      var $20$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($attos+4)|0);
      var $20$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=-2147483648;
      var $$emscripten$temp$1$1=0;
      var $21=($20$1|0) >= ($$emscripten$temp$1$1|0) && (($20$1|0) >  ($$emscripten$temp$1$1|0) || ($20$0|0) >= ($$emscripten$temp$1$0|0));
      if ($21) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $22
      var $23=(($2+5596)|0);
      var $24=HEAP8[($23)];
      var $25=(($24+1)&255);
      HEAP8[($23)]=$25;
      var $st$4$0=(($attos)|0);
      var $26$0=HEAPU32[(($st$4$0)>>2)];
      var $st$4$1=(($attos+4)|0);
      var $26$1=HEAP32[(($st$4$1)>>2)];
      var $27$0=($26$0 >>> 1) | ($26$1 << 31);
      var $27$1=($26$1 >> 1) | (((($26$1|0) < 0 ? -1 : 0)) << 31);
      var $st$10$0=(($attos)|0);
      HEAP32[(($st$10$0)>>2)]=$27$0;
      var $st$10$1=(($attos+4)|0);
      HEAP32[(($st$10$1)>>2)]=$27$1;
      __label__ = 1; break;
    case 3: // $28
      var $st$0$0=(($attos)|0);
      var $29$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($attos+4)|0);
      var $29$1=HEAP32[(($st$0$1)>>2)];
      var $30$0=$29$0;
      var $30=$30$0;
      var $31=(($2+5592)|0);
      HEAP32[(($31)>>2)]=$30;
      var $32=$2;
      var $33=__ZN16device_interface6deviceEv($32);
      var $34=__ZNK8device_t7machineEv($33);
      var $35=__ZN15running_machine9schedulerEv($34);
      __ZN16device_scheduler26compute_perfect_interleaveEv($35);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interface23interface_clock_changedEv["X"]=1;

function __ZNK24device_execute_interface16clocks_to_cyclesEy($this, $clocks$0, $clocks$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$clocks$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$clocks$1;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+56)|0);
  var $7=HEAP32[(($6)>>2)];
  var $st$12$0=(($2)|0);
  var $8$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($2+4)|0);
  var $8$1=HEAP32[(($st$12$1)>>2)];
  var $9=FUNCTION_TABLE[$7]($3, $8$0, $8$1);
  var $9$0=$9[0];
  var $9$1=$9[1];
  STACKTOP = __stackBase__;
  return [$9$0,$9$1];
}


function __ZN24device_execute_interface28static_standard_irq_callbackEP8device_ti($device, $irqline) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$irqline;
  var $3=$1;
  var $4=__Z14device_executeP8device_t($3);
  var $5=$2;
  var $6=__ZN24device_execute_interface21standard_irq_callbackEi($4, $5);
  ;
  return $6;
}


function __ZN24device_execute_interface21standard_irq_callbackEi($this, $irqline) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $vector;
      $1=$this;
      $2=$irqline;
      var $3=$1;
      var $4=$2;
      var $5=(($3+52)|0);
      var $6=(($5+$4*156)|0);
      var $7=__ZN24device_execute_interface12device_input20default_irq_callbackEv($6);
      $vector=$7;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=(($3+48)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=(($3+48)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=FUNCTION_TABLE[$15]($18, $19);
      $vector=$20;
      __label__ = 4; break;
    case 4: // $21
      var $22=$3;
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      __ZL23debugger_interrupt_hookP8device_ti($24, $25);
      var $26=$vector;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface12device_input20default_irq_callbackEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $vector;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      $vector=$4;
      var $5=(($2+20)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=(($7)|0)==2;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      __label__ = 3; break;
    case 3: // $11
      var $12=(($2)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+88)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($2+8)|0);
      var $19=HEAP32[(($18)>>2)];
      FUNCTION_TABLE[$17]($13, $19, 0);
      var $20=(($2+20)|0);
      HEAP8[($20)]=0;
      __label__ = 4; break;
    case 4: // $21
      var $22=$vector;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23debugger_interrupt_hookP8device_ti($device, $irqline) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$device;
      $2=$irqline;
      var $3=$1;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=(($4+584)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 1;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=__ZNK8device_t5debugEv($10);
      var $12=$2;
      __ZN12device_debug14interrupt_hookEi($11, $12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24device_execute_interface15minimum_quantumEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $basetick=__stackBase__;
      $1=$this;
      var $2=$1;
      var $3=(($2+5604)|0);
      var $st$5$0=(($3)|0);
      var $4$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($3+4)|0);
      var $4$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($basetick)|0);
      HEAP32[(($st$9$0)>>2)]=$4$0;
      var $st$9$1=(($basetick+4)|0);
      HEAP32[(($st$9$1)>>2)]=$4$1;
      var $st$13$0=(($basetick)|0);
      var $5$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($basetick+4)|0);
      var $5$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $6=$5$0 == $$emscripten$temp$0$0 && $5$1 == $$emscripten$temp$0$1;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK8device_t5clockEv($10);
      var $12$0=$11;
      var $12$1=0;
      var $13=__ZNK24device_execute_interface16clocks_to_cyclesEy($2, $12$0, $12$1);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $14$0 = Math.floor(((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))/((($13$0)>>>0)+((($13$1)|0)*4294967296)))>>>0; var $14$1 = Math.min(Math.floor((Math.floor(((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))/((($13$0)>>>0)+((($13$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$12$0=(($basetick)|0);
      HEAP32[(($st$12$0)>>2)]=$14$0;
      var $st$12$1=(($basetick+4)|0);
      HEAP32[(($st$12$1)>>2)]=$14$1;
      __label__ = 2; break;
    case 2: // $15
      var $st$0$0=(($basetick)|0);
      var $16$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($basetick+4)|0);
      var $16$1=HEAP32[(($st$0$1)>>2)];
      var $17=__ZNK24device_execute_interface10min_cyclesEv($2);
      var $18$0=$17;
      var $18$1=0;
      var $19$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($18$0)>>>0)+((($18$1)|0)*4294967296))>>>0; var $19$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($18$0)>>>0)+((($18$1)|0)*4294967296)))/4294967296), 4294967295);
      STACKTOP = __stackBase__;
      return [$19$0,$19$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24device_execute_interface10min_cyclesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+64)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZdvRK8attotimej($agg_result, $left, $factor) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$left;
  $2=$factor;
  var $3=$1;
  var $4=$agg_result;
  var $5=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];HEAP32[(($4+8)>>2)]=HEAP32[(($5+8)>>2)];
  var $6=$2;
  var $7=__ZN8attotimedVEj($agg_result, $6);
  ;
  return;
}


function __ZN24device_execute_interface31trigger_partial_frame_interruptEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      $1=$this;
      var $4=$1;
      var $5=(($4+5516)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($4+20)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($4+5516)|0);
      HEAP32[(($11)>>2)]=$10;
      __label__ = 2; break;
    case 2: // $12
      var $13=(($4+5516)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14-1)|0);
      HEAP32[(($13)>>2)]=$15;
      var $16=__ZN24device_execute_interface9suspendedEj($4, 19);
      if ($16) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $17
      var $18=(($4+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$4;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      FUNCTION_TABLE[$19]($22);
      __label__ = 4; break;
    case 4: // $23
      var $24=(($4+5516)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0) > 1;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      var $28=(($4+5520)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($4+5524)|0);
      var $31=$2;
      var $32=$30;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($31)>>2)]=HEAP32[(($32)>>2)];HEAP32[(($31+4)>>2)]=HEAP32[(($32+4)>>2)];HEAP32[(($31+8)>>2)]=HEAP32[(($32+8)>>2)];
      var $33=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($33)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($33+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($33+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($29, $2, 0, $3);
      __label__ = 6; break;
    case 6: // $34
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface26trigger_periodic_interruptEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=__ZN24device_execute_interface9suspendedEj($2, 19);
      if ($7) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $8
      var $9=(($2+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$10]($13);
      __label__ = 3; break;
    case 3: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface12device_inputC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+20)|0);
  HEAP8[($8)]=0;
  var $9=(($2+152)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=(($2+24)|0);
  var $11=(($10)|0);
  var $12=$11;
  _memset($12, 0, 128, 1);
  ;
  return;
}


function __ZNK24device_execute_interface18default_irq_vectorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+76)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZN24device_execute_interface12device_input17empty_event_queueEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curevent;
      var $input_event;
      $1=$this;
      var $2=$1;
      $curevent=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$curevent;
      var $5=(($2+152)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4)|0) < (($6)|0);
      if ($7) { __label__ = 2; break; } else { __label__ = 28; break; }
    case 2: // $8
      var $9=$curevent;
      var $10=(($2+24)|0);
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      $input_event=$12;
      var $13=$input_event;
      var $14=$13 & 255;
      var $15=(($14) & 255);
      var $16=(($2+20)|0);
      HEAP8[($16)]=$15;
      var $17=$input_event;
      var $18=$17 >> 8;
      var $19=(($2+16)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=(($2+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)==33;
      if ($24) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $25
      var $26=(($2+20)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)==1;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=(($2)|0);
      var $32=HEAP32[(($31)>>2)];
      __ZN24device_execute_interface7suspendEjb($32, 2, 1);
      __label__ = 10; break;
    case 7: // $33
      var $34=(($2)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZN24device_execute_interface9suspendedEj($35, 2);
      if ($36) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $37
      var $38=(($2+4)|0);
      var $39=HEAP32[(($38)>>2)];
      __ZN8device_t5resetEv($39);
      var $40=(($2)|0);
      var $41=HEAP32[(($40)>>2)];
      __ZN24device_execute_interface6resumeEj($41, 2);
      __label__ = 9; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      __label__ = 26; break;
    case 11: // $44
      var $45=(($2+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==34;
      if ($47) { __label__ = 12; break; } else { __label__ = 18; break; }
    case 12: // $48
      var $49=(($2+20)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=(($51)|0)==1;
      if ($52) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $53
      var $54=(($2)|0);
      var $55=HEAP32[(($54)>>2)];
      __ZN24device_execute_interface7suspendEjb($55, 1, 1);
      __label__ = 17; break;
    case 14: // $56
      var $57=(($2+20)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $61
      var $62=(($2)|0);
      var $63=HEAP32[(($62)>>2)];
      __ZN24device_execute_interface6resumeEj($63, 1);
      __label__ = 16; break;
    case 16: // $64
      __label__ = 17; break;
    case 17: // $65
      __label__ = 25; break;
    case 18: // $66
      var $67=(($2+20)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      if ($69 == 2 || $69 == 1) {
        __label__ = 19; break;
      }
      else if ($69 == 0) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 19: // $70
      var $71=(($2)|0);
      var $72=HEAPU32[(($71)>>2)];
      var $73=$72;
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+88)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($2+8)|0);
      var $78=HEAP32[(($77)>>2)];
      FUNCTION_TABLE[$76]($72, $78, 1);
      __label__ = 22; break;
    case 20: // $79
      var $80=(($2)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+88)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($2+8)|0);
      var $87=HEAP32[(($86)>>2)];
      FUNCTION_TABLE[$85]($81, $87, 0);
      __label__ = 22; break;
    case 21: // $88
      var $89=(($2+4)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=__ZNK8device_t3tagEv($90);
      var $92=(($2+8)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($2+20)|0);
      var $95=HEAPU8[($94)];
      var $96=(($95)&255);
      __Z8logerrorPKcz(((STRING_TABLE.__str313303)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$91,HEAP32[((tempInt+4)>>2)]=$93,HEAP32[((tempInt+8)>>2)]=$96,tempInt));
      __label__ = 22; break;
    case 22: // $97
      var $98=(($2+20)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $102
      var $103=(($2)|0);
      var $104=HEAP32[(($103)>>2)];
      __ZN24device_execute_interface24signal_interrupt_triggerEv($104);
      __label__ = 24; break;
    case 24: // $105
      __label__ = 25; break;
    case 25: // $106
      __label__ = 26; break;
    case 26: // $107
      __label__ = 27; break;
    case 27: // $108
      var $109=$curevent;
      var $110=(($109+1)|0);
      $curevent=$110;
      __label__ = 1; break;
    case 28: // $111
      var $112=(($2+152)|0);
      HEAP32[(($112)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interface12device_input17empty_event_queueEv["X"]=1;

function __Z14device_executeP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf=__stackBase__;
      var $2;
      var $3;
      $1=$device;
      var $4=$1;
      var $5=__ZN8device_t9interfaceERP24device_execute_interface($4, $intf);
      if ($5) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=___cxa_allocate_exception(1032);
      var $8=$7;
      var $9=$1;
      var $10=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $11
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($8, ((STRING_TABLE.__str343308)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      ___cxa_throw($7, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      ___cxa_free_exception($7);
      __label__ = 6; break;
    case 5: // $17
      var $18=HEAP32[(($intf)>>2)];
      STACKTOP = __stackBase__;
      return $18;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface12device_input16set_state_syncedEii($this, $state, $vector) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $event_index;
      $1=$this;
      $2=$state;
      $3=$vector;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      __label__ = 4; break;
    case 4: // $10
      var $11=$2;
      var $12=(($11)|0)==3;
      if ($12) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $13
      var $14=(($6+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=32;
      if ($16) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $17
      var $18=(($6+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=33;
      if ($20) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $21
      var $22=___cxa_allocate_exception(1032);
      var $23=$22;
      var $24=(($6+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $27
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($23, ((STRING_TABLE.__str283300)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $28
      ___cxa_throw($22, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 10: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $4=$31;
      var $32=$30.f1;
      $5=$32;
      ___cxa_free_exception($22);
      __label__ = 21; break;
    case 11: // $33
      var $34=$3;
      __ZN24device_execute_interface12device_input16set_state_syncedEii($6, 1, $34);
      var $35=$3;
      __ZN24device_execute_interface12device_input16set_state_syncedEii($6, 0, $35);
      __label__ = 20; break;
    case 12: // $36
      var $37=(($6+152)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+1)|0);
      HEAP32[(($37)>>2)]=$39;
      $event_index=$38;
      var $40=$event_index;
      var $41=(($40)>>>0) >= 32;
      if ($41) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $42
      var $43=(($6+152)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-1)|0);
      HEAP32[(($43)>>2)]=$45;
      __ZN24device_execute_interface12device_input17empty_event_queueEv($6);
      var $46=(($6+152)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      $event_index=$47;
      var $49=(($6+4)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=__ZNK8device_t3tagEv($50);
      __Z8logerrorPKcz(((STRING_TABLE.__str293301)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$51,tempInt));
      __label__ = 14; break;
    case 14: // $52
      var $53=$event_index;
      var $54=(($53)>>>0) < 32;
      if ($54) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $55
      var $56=$3;
      var $57=(($56)|0)==-16777216;
      if ($57) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $58
      var $59=(($6+12)|0);
      var $60=HEAP32[(($59)>>2)];
      $3=$60;
      __label__ = 17; break;
    case 17: // $61
      var $62=$2;
      var $63=$62 & 255;
      var $64=$3;
      var $65=$64 << 8;
      var $66=$63 | $65;
      var $67=$event_index;
      var $68=(($6+24)|0);
      var $69=(($68+($67<<2))|0);
      HEAP32[(($69)>>2)]=$66;
      var $70=$event_index;
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $72
      var $73=(($6)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$74;
      var $76=__ZN16device_interface6deviceEv($75);
      var $77=__ZNK8device_t7machineEv($76);
      var $78=__ZN15running_machine9schedulerEv($77);
      var $79=$6;
      __ZN16device_scheduler11synchronizeEPFvR15running_machinePviEPKciS2_($78, 838, ((STRING_TABLE.__str303302)|0), 0, $79);
      __label__ = 19; break;
    case 19: // $80
      __label__ = 20; break;
    case 20: // $81
      ;
      return;
    case 21: // $82
      var $83=$4;
      var $84=$4;
      var $85=$5;
      var $86=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $84, tempValue);
      var $87=($86.f1 = $85, $86);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24device_execute_interface12device_input16set_state_syncedEii["X"]=1;

function __ZL10mulu_32x32jj3374($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=0;
  var $5=$2;
  var $6$0=$5;
  var $6$1=0;
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  ;
  return [$7$0,$7$1];
}


function __ZL9mul_32x32ii($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=(($3|0) < 0 ? -1 : 0);
  var $5=$2;
  var $6$0=$5;
  var $6$1=(($5|0) < 0 ? -1 : 0);
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  ;
  return [$7$0,$7$1];
}


function __ZN21delegate_internal_mfpC2IM24device_execute_interfaceFvR13screen_devicebEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI8device_tE7indexofERKS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $index;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $index=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$index;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      var $17=$index;
      var $18=(($17+1)|0);
      $index=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$cur;
      var $21=(($20+20)|0);
      var $22=HEAP32[(($21)>>2)];
      $cur=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=-1;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14divu_64x32_remyjPj3373($a$0, $a$1, $b, $remainder) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  var $st$3$0=(($1)|0);
  HEAP32[(($st$3$0)>>2)]=$a$0;
  var $st$3$1=(($1+4)|0);
  HEAP32[(($st$3$1)>>2)]=$a$1;
  $2=$b;
  $3=$remainder;
  var $st$9$0=(($1)|0);
  var $4$0=HEAP32[(($st$9$0)>>2)];
  var $st$9$1=(($1+4)|0);
  var $4$1=HEAP32[(($st$9$1)>>2)];
  var $5=$2;
  var $6$0=$5;
  var $6$1=0;
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$0;
  var $8=$8$0;
  var $9=$3;
  HEAP32[(($9)>>2)]=$8;
  var $st$21$0=(($1)|0);
  var $10$0=HEAP32[(($st$21$0)>>2)];
  var $st$21$1=(($1+4)|0);
  var $10$1=HEAP32[(($st$21$1)>>2)];
  var $11=$2;
  var $12$0=$11;
  var $12$1=0;
  var $13$0 = Math.floor(((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296)))>>>0; var $13$1 = Math.min(Math.floor((Math.floor(((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296))))/4294967296), 4294967295);
  var $14$0=$13$0;
  var $14=$14$0;
  STACKTOP = __stackBase__;
  return $14;
}


function __ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $vtable_base;
      $2=$this;
      $3=$object;
      var $4=$2;
      var $5=$3;
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      var $8=(($4+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($7+$9)|0);
      var $11=$10;
      var $12=$3;
      HEAP32[(($12)>>2)]=$11;
      var $13=(($4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$14 & 1;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $17
      var $18=(($4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      var $22=$3;
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      $vtable_base=$25;
      var $26=$vtable_base;
      var $27=(($4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($26+$28)|0);
      var $30=(($29-1)|0);
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      $1=$32;
      __label__ = 3; break;
    case 3: // $33
      var $34=$1;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24device_execute_interface12device_input24static_empty_event_queueER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN24device_execute_interface12device_input17empty_event_queueEv($5);
  ;
  return;
}


function __ZN24device_execute_interface24signal_interrupt_triggerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+5568)|0);
  var $4=HEAP32[(($3)>>2)];
  __ZN24device_execute_interface7triggerEi($2, $4);
  ;
  return;
}


function __ZN8delegateIFvR13screen_devicebEEC2I24device_execute_interfaceEEN15delegate_traitsIT_vS1_b8_noparamS8_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I24device_execute_interfaceEEN15delegate_traitsIT_vS1_bS2_S2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I24device_execute_interfaceEEN15delegate_traitsIT_vS1_bS2_S2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM24device_execute_interfaceFvR13screen_devicebEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=840;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM24device_execute_interfaceFvR13screen_devicebEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM24device_execute_interfaceFvR13screen_devicebEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI24device_execute_interfaceEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI24device_execute_interface, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24device_execute_interface16cycles_to_clocksEy($this, $cycles$0, $cycles$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$cycles$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$cycles$1;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+60)|0);
  var $7=HEAP32[(($6)>>2)];
  var $st$12$0=(($2)|0);
  var $8$0=HEAP32[(($st$12$0)>>2)];
  var $st$12$1=(($2+4)|0);
  var $8$1=HEAP32[(($st$12$1)>>2)];
  var $9=FUNCTION_TABLE[$7]($3, $8$0, $8$1);
  var $9$0=$9[0];
  var $9$1=$9[1];
  STACKTOP = __stackBase__;
  return [$9$0,$9$1];
}


function ___cxx_global_var_init3371() {
  ;
  var __label__;

  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN8attotimeC1Eix(__ZN8attotime4zeroE, 0, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function ___cxx_global_var_init13372() {
  ;
  var __label__;

  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN8attotimeC1Eix(__ZN8attotime5neverE, 1000000000, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function __ZN8attotimemLEj($this, $factor) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $attolo=__stackBase__;
      var $attohi;
      var $temp=__stackBase__+4;
      var $reslo=__stackBase__+12;
      var $reshi=__stackBase__+16;
      $2=$this;
      $3=$factor;
      var $4=$2;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) >= 1000000000;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      $1=$4;
      __label__ = 7; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($14)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($14+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($14+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      $1=$4;
      __label__ = 7; break;
    case 4: // $15
      var $16=(($4+4)|0);
      var $st$1$0=(($16)|0);
      var $17$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$1$1)>>2)];
      var $18=__ZL14divu_64x32_remyjPj3373($17$0, $17$1, 1000000000, $attolo);
      var $18$0=$18[0];
      $attohi=$18;
      var $19=HEAP32[(($attolo)>>2)];
      var $20=$3;
      var $21=__ZL10mulu_32x32jj3374($19, $20);
      var $21$0=$21[0];
      var $21$1=$21[1];
      var $st$13$0=(($temp)|0);
      HEAP32[(($st$13$0)>>2)]=$21$0;
      var $st$13$1=(($temp+4)|0);
      HEAP32[(($st$13$1)>>2)]=$21$1;
      var $st$17$0=(($temp)|0);
      var $22$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($temp+4)|0);
      var $22$1=HEAP32[(($st$17$1)>>2)];
      var $23=__ZL14divu_64x32_remyjPj3373($22$0, $22$1, 1000000000, $reslo);
      var $23$0=$23[0];
      var $24$0=$23;
      var $24$1=0;
      var $st$25$0=(($temp)|0);
      HEAP32[(($st$25$0)>>2)]=$24$0;
      var $st$25$1=(($temp+4)|0);
      HEAP32[(($st$25$1)>>2)]=$24$1;
      var $25=$attohi;
      var $26=$3;
      var $27=__ZL10mulu_32x32jj3374($25, $26);
      var $27$0=$27[0];
      var $27$1=$27[1];
      var $st$34$0=(($temp)|0);
      var $28$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($temp+4)|0);
      var $28$1=HEAP32[(($st$34$1)>>2)];
      var $29$0 = ((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($27$0)>>>0)+((($27$1)|0)*4294967296))>>>0; var $29$1 = Math.min(Math.floor((((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($27$0)>>>0)+((($27$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$39$0=(($temp)|0);
      HEAP32[(($st$39$0)>>2)]=$29$0;
      var $st$39$1=(($temp+4)|0);
      HEAP32[(($st$39$1)>>2)]=$29$1;
      var $st$43$0=(($temp)|0);
      var $30$0=HEAP32[(($st$43$0)>>2)];
      var $st$43$1=(($temp+4)|0);
      var $30$1=HEAP32[(($st$43$1)>>2)];
      var $31=__ZL14divu_64x32_remyjPj3373($30$0, $30$1, 1000000000, $reshi);
      var $31$0=$31[0];
      var $32$0=$31;
      var $32$1=0;
      var $st$51$0=(($temp)|0);
      HEAP32[(($st$51$0)>>2)]=$32$0;
      var $st$51$1=(($temp+4)|0);
      HEAP32[(($st$51$1)>>2)]=$32$1;
      var $33=(($4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$3;
      var $36=__ZL10mulu_32x32jj3374($34, $35);
      var $36$0=$36[0];
      var $36$1=$36[1];
      var $st$61$0=(($temp)|0);
      var $37$0=HEAP32[(($st$61$0)>>2)];
      var $st$61$1=(($temp+4)|0);
      var $37$1=HEAP32[(($st$61$1)>>2)];
      var $38$0 = ((($37$0)>>>0)+((($37$1)|0)*4294967296))+((($36$0)>>>0)+((($36$1)|0)*4294967296))>>>0; var $38$1 = Math.min(Math.floor((((($37$0)>>>0)+((($37$1)|0)*4294967296))+((($36$0)>>>0)+((($36$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$66$0=(($temp)|0);
      HEAP32[(($st$66$0)>>2)]=$38$0;
      var $st$66$1=(($temp+4)|0);
      HEAP32[(($st$66$1)>>2)]=$38$1;
      var $st$70$0=(($temp)|0);
      var $39$0=HEAP32[(($st$70$0)>>2)];
      var $st$70$1=(($temp+4)|0);
      var $39$1=HEAP32[(($st$70$1)>>2)];
      var $$emscripten$temp$0$0=1000000000;
      var $$emscripten$temp$0$1=0;
      var $40=$39$1 >= $$emscripten$temp$0$1 && ($39$1 > $$emscripten$temp$0$1 || $39$0 >= $$emscripten$temp$0$0);
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($42)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($42+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($42+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      $1=$4;
      __label__ = 7; break;
    case 6: // $43
      var $st$0$0=(($temp)|0);
      var $44$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($temp+4)|0);
      var $44$1=HEAP32[(($st$0$1)>>2)];
      var $45$0=$44$0;
      var $45=$45$0;
      var $46=(($4)|0);
      HEAP32[(($46)>>2)]=$45;
      var $47=HEAP32[(($reslo)>>2)];
      var $48$0=$47;
      var $48$1=0;
      var $49=HEAP32[(($reshi)>>2)];
      var $50=__ZL9mul_32x32ii($49, 1000000000);
      var $50$0=$50[0];
      var $50$1=$50[1];
      var $51$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($50$0)>>>0)+((($50$1)|0)*4294967296))>>>0; var $51$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($50$0)>>>0)+((($50$1)|0)*4294967296)))/4294967296), 4294967295);
      var $52=(($4+4)|0);
      var $st$17$0=(($52)|0);
      HEAP32[(($st$17$0)>>2)]=$51$0;
      var $st$17$1=(($52+4)|0);
      HEAP32[(($st$17$1)>>2)]=$51$1;
      $1=$4;
      __label__ = 7; break;
    case 7: // $53
      var $54=$1;
      STACKTOP = __stackBase__;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8attotimemLEj["X"]=1;

function __ZN8attotimedVEj($this, $factor) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $attolo=__stackBase__;
      var $attohi;
      var $remainder=__stackBase__+4;
      var $temp=__stackBase__+8;
      var $reshi;
      var $reslo;
      $2=$this;
      $3=$factor;
      var $4=$2;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0) >= 1000000000;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      $1=$4;
      __label__ = 9; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $1=$4;
      __label__ = 9; break;
    case 4: // $14
      var $15=(($4+4)|0);
      var $st$1$0=(($15)|0);
      var $16$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$1$1)>>2)];
      var $17=__ZL14divu_64x32_remyjPj3373($16$0, $16$1, 1000000000, $attolo);
      var $17$0=$17[0];
      $attohi=$17;
      var $18=(($4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20$0=$19;
      var $20$1=(($19|0) < 0 ? -1 : 0);
      var $21=$3;
      var $22=__ZL14divu_64x32_remyjPj3373($20$0, $20$1, $21, $remainder);
      var $22$0=$22[0];
      var $23=(($4)|0);
      HEAP32[(($23)>>2)]=$22;
      var $24=$attohi;
      var $25$0=$24;
      var $25$1=0;
      var $26=HEAP32[(($remainder)>>2)];
      var $27=__ZL10mulu_32x32jj3374($26, 1000000000);
      var $27$0=$27[0];
      var $27$1=$27[1];
      var $28$0 = ((($25$0)>>>0)+((($25$1)|0)*4294967296))+((($27$0)>>>0)+((($27$1)|0)*4294967296))>>>0; var $28$1 = Math.min(Math.floor((((($25$0)>>>0)+((($25$1)|0)*4294967296))+((($27$0)>>>0)+((($27$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$25$0=(($temp)|0);
      HEAP32[(($st$25$0)>>2)]=$28$0;
      var $st$25$1=(($temp+4)|0);
      HEAP32[(($st$25$1)>>2)]=$28$1;
      var $st$29$0=(($temp)|0);
      var $29$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($temp+4)|0);
      var $29$1=HEAP32[(($st$29$1)>>2)];
      var $30=$3;
      var $31=__ZL14divu_64x32_remyjPj3373($29$0, $29$1, $30, $remainder);
      var $31$0=$31[0];
      $reshi=$31;
      var $32=HEAP32[(($attolo)>>2)];
      var $33$0=$32;
      var $33$1=0;
      var $34=HEAP32[(($remainder)>>2)];
      var $35=__ZL10mulu_32x32jj3374($34, 1000000000);
      var $35$0=$35[0];
      var $35$1=$35[1];
      var $36$0 = ((($33$0)>>>0)+((($33$1)|0)*4294967296))+((($35$0)>>>0)+((($35$1)|0)*4294967296))>>>0; var $36$1 = Math.min(Math.floor((((($33$0)>>>0)+((($33$1)|0)*4294967296))+((($35$0)>>>0)+((($35$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$45$0=(($temp)|0);
      HEAP32[(($st$45$0)>>2)]=$36$0;
      var $st$45$1=(($temp+4)|0);
      HEAP32[(($st$45$1)>>2)]=$36$1;
      var $st$49$0=(($temp)|0);
      var $37$0=HEAP32[(($st$49$0)>>2)];
      var $st$49$1=(($temp+4)|0);
      var $37$1=HEAP32[(($st$49$1)>>2)];
      var $38=$3;
      var $39=__ZL14divu_64x32_remyjPj3373($37$0, $37$1, $38, $remainder);
      var $39$0=$39[0];
      $reslo=$39;
      var $40=$reslo;
      var $41$0=$40;
      var $41$1=0;
      var $42=$reshi;
      var $43=__ZL10mulu_32x32jj3374($42, 1000000000);
      var $43$0=$43[0];
      var $43$1=$43[1];
      var $44$0 = ((($41$0)>>>0)+((($41$1)|0)*4294967296))+((($43$0)>>>0)+((($43$1)|0)*4294967296))>>>0; var $44$1 = Math.min(Math.floor((((($41$0)>>>0)+((($41$1)|0)*4294967296))+((($43$0)>>>0)+((($43$1)|0)*4294967296)))/4294967296), 4294967295);
      var $45=(($4+4)|0);
      var $st$66$0=(($45)|0);
      HEAP32[(($st$66$0)>>2)]=$44$0;
      var $st$66$1=(($45+4)|0);
      HEAP32[(($st$66$1)>>2)]=$44$1;
      var $46=HEAPU32[(($remainder)>>2)];
      var $47=$3;
      var $48=Math.floor((($47)>>>0)/2);
      var $49=(($46)>>>0) >= (($48)>>>0);
      if ($49) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $50
      var $51=(($4+4)|0);
      var $st$1$0=(($51)|0);
      var $52$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($51+4)|0);
      var $52$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $53$0 = ((($52$0)>>>0)+((($52$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $53$1 = Math.min(Math.floor((((($52$0)>>>0)+((($52$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($51)|0);
      HEAP32[(($st$8$0)>>2)]=$53$0;
      var $st$8$1=(($51+4)|0);
      HEAP32[(($st$8$1)>>2)]=$53$1;
      var $$emscripten$temp$1$0=-1486618624;
      var $$emscripten$temp$1$1=232830643;
      var $54=($53$1|0) >= ($$emscripten$temp$1$1|0) && (($53$1|0) >  ($$emscripten$temp$1$1|0) || ($53$0|0) >= ($$emscripten$temp$1$0|0));
      if ($54) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $55
      var $56=(($4+4)|0);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$3$0=(($56)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$2$0;
      var $st$3$1=(($56+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$2$1;
      var $57=(($4)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58+1)|0);
      HEAP32[(($57)>>2)]=$59;
      __label__ = 7; break;
    case 7: // $60
      __label__ = 8; break;
    case 8: // $61
      $1=$4;
      __label__ = 9; break;
    case 9: // $62
      var $63=$1;
      STACKTOP = __stackBase__;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8attotimedVEj["X"]=1;

function __ZNK8attotime9as_stringEi($this, $precision) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $buffer;
      var $upper;
      var $temp;
      var $lower=__stackBase__;
      var $upper1;
      var $temp2;
      $1=$this;
      $2=$precision;
      var $3=$1;
      var $4=HEAP32[((__ZZNK8attotime9as_stringEiE7nextbuf)>>2)];
      var $5=(($4+1)|0);
      HEAP32[((__ZZNK8attotime9as_stringEiE7nextbuf)>>2)]=$5;
      var $6=(($4)|0)%8;
      var $7=((__ZZNK8attotime9as_stringEiE7buffers+$6*30)|0);
      var $8=(($7)|0);
      $buffer=$8;
      var $9=__ZeqRK8attotimeS1_($3, __ZN8attotime5neverE);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$buffer;
      var $12=$2;
      var $13=_sprintf($11, ((STRING_TABLE.__str3365)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$12,HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str23366)|0),tempInt));
      __label__ = 15; break;
    case 2: // $14
      var $15=$2;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$buffer;
      var $19=(($3)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=_sprintf($18, ((STRING_TABLE.__str33367)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,tempInt));
      __label__ = 14; break;
    case 4: // $22
      var $23=$2;
      var $24=(($23)|0) <= 9;
      if ($24) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $25
      var $26=(($3+4)|0);
      var $st$1$0=(($26)|0);
      var $27$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=1000000000;
      var $$emscripten$temp$0$1=0;
      var $28$0 = (tempBigIntR=((($27$0)>>>0)+((($27$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $28$1 = Math.min(Math.floor(((tempBigIntR=((($27$0)>>>0)+((($27$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $29$0=$28$0;
      var $29=$29$0;
      $upper=$29;
      var $30=$2;
      $temp=$30;
      __label__ = 6; break;
    case 6: // $31
      var $32=$temp;
      var $33=(($32)|0) < 9;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$upper;
      var $36=Math.floor((($35)>>>0)/10);
      $upper=$36;
      var $37=$temp;
      var $38=(($37+1)|0);
      $temp=$38;
      __label__ = 6; break;
    case 8: // $39
      var $40=$buffer;
      var $41=(($3)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$2;
      var $44=$upper;
      var $45=_sprintf($40, ((STRING_TABLE.__str43368)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,HEAP32[((tempInt+4)>>2)]=$43,HEAP32[((tempInt+8)>>2)]=$44,tempInt));
      __label__ = 13; break;
    case 9: // $46
      var $47=(($3+4)|0);
      var $st$1$0=(($47)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($47+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $49=__ZL14divu_64x32_remyjPj3373($48$0, $48$1, 1000000000, $lower);
      var $49$0=$49[0];
      $upper1=$49;
      var $50=$2;
      $temp2=$50;
      __label__ = 10; break;
    case 10: // $51
      var $52=$temp2;
      var $53=(($52)|0) < 18;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      var $55=HEAPU32[(($lower)>>2)];
      var $56=Math.floor((($55)>>>0)/10);
      HEAP32[(($lower)>>2)]=$56;
      var $57=$temp2;
      var $58=(($57+1)|0);
      $temp2=$58;
      __label__ = 10; break;
    case 12: // $59
      var $60=$buffer;
      var $61=(($3)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$upper1;
      var $64=$2;
      var $65=(($64-9)|0);
      var $66=HEAP32[(($lower)>>2)];
      var $67=_sprintf($60, ((STRING_TABLE.__str53369)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$62,HEAP32[((tempInt+4)>>2)]=$63,HEAP32[((tempInt+8)>>2)]=$65,HEAP32[((tempInt+12)>>2)]=$66,tempInt));
      __label__ = 13; break;
    case 13: // $68
      __label__ = 14; break;
    case 14: // $69
      __label__ = 15; break;
    case 15: // $70
      var $71=$buffer;
      STACKTOP = __stackBase__;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK8attotime9as_stringEi["X"]=1;

function __GLOBAL__I_a3379() {
  ;
  var __label__;

  ___cxx_global_var_init3371();
  ___cxx_global_var_init13372();
  ;
  return;
}


function __ZL22machine_start____emptyR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=$1;
  var $4=__ZNK15running_machine6renderEv($3);
  var $5=__ZNK14render_manager12ui_containerEv($4);
  __Z25ui_menu_force_game_selectR15running_machineP16render_container($2, $5);
  ;
  return;
}


function __ZL33construct_machine_config____emptyR14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      var $7=$3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$2;
      var $11=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($10, 0, ((STRING_TABLE.__str73391)|0), 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $12
      $3=$11;
      __label__ = 4; break;
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $4=$15;
      var $16=$14.f1;
      $5=$16;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 4: // $17
      var $18=$3;
      (function() { try { __THREW__ = false; return __ZN13driver_device19static_set_callbackER8device_tNS_13callback_typeEPFvR15running_machineE($18, 0, 842) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 5: // $19
      var $20=$2;
      var $21=$3;
      var $22=HEAP32[((_SCREEN)>>2)];
      var $23=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($20, $21, ((STRING_TABLE.__str83392)|0), $22, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; };
    case 6: // $24
      $device=$23;
      var $25=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device15static_set_typeER8device_t16screen_type_enum($25, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 3; break; }
    case 7: // $26
      var $27=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device17static_set_formatER8device_t14_bitmap_format($27, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 3; break; }
    case 8: // $28
      var $29=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device15static_set_sizeER8device_ttt($29, 640, 480) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 3; break; }
    case 9: // $30
      var $31=$device;
      (function() { try { __THREW__ = false; return __ZN13screen_device18static_set_visareaER8device_tssss($31, 0, 639, 0, 479) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 3; break; }
    case 10: // $32
      var $33=$device;
      var $$emscripten$temp$0$0=1954764116;
      var $$emscripten$temp$0$1=7761021;
      (function() { try { __THREW__ = false; return __ZN13screen_device18static_set_refreshER8device_tx($33, $$emscripten$temp$0$0, $$emscripten$temp$0$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 3; break; }
    case 11: // $34
      var $35=$3;
      $1=$35;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $36=$1;
      STACKTOP = __stackBase__;
      return $36;
    case 12: // $37
      __label__ = 13; break;
    case 13: // $38
      var $39=$4;
      var $40=$4;
      var $41=$5;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL33construct_machine_config____emptyR14machine_configP8device_t["X"]=1;

function __ZNK13cheat_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN15cheat_parameter4itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17number_and_formatcvRyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  ;
  return $3;
}


function __ZNK15cheat_parameter4item5valueEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  ;
  return $3;
}


function __ZNK17number_and_formatcvRKyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  ;
  return $3;
}


function __ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15cheat_parameter4item4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN17number_and_formatC1Eyi($this, $value$0, $value$1, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3;
  $1=$this;
  var $st$4$0=(($2)|0);
  HEAP32[(($st$4$0)>>2)]=$value$0;
  var $st$4$1=(($2+4)|0);
  HEAP32[(($st$4$1)>>2)]=$value$1;
  $3=$format;
  var $4=$1;
  var $st$10$0=(($2)|0);
  var $5$0=HEAP32[(($st$10$0)>>2)];
  var $st$10$1=(($2+4)|0);
  var $5$1=HEAP32[(($st$10$1)>>2)];
  var $6=$3;
  __ZN17number_and_formatC2Eyi($4, $5$0, $5$1, $6);
  STACKTOP = __stackBase__;
  return;
}


function __ZN11simple_listIN15cheat_parameter4itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN15cheat_parameter4itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15cheat_parameter4itemC1EPKcyi($this, $text, $value$0, $value$1, $valformat) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4;
  $1=$this;
  $2=$text;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$value$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$value$1;
  $4=$valformat;
  var $5=$1;
  var $6=$2;
  var $st$13$0=(($3)|0);
  var $7$0=HEAP32[(($st$13$0)>>2)];
  var $st$13$1=(($3+4)|0);
  var $7$1=HEAP32[(($st$13$1)>>2)];
  var $8=$4;
  __ZN15cheat_parameter4itemC2EPKcyi($5, $6, $7$0, $7$1, $8);
  STACKTOP = __stackBase__;
  return;
}


function __ZN11simple_listIN15cheat_parameter4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN15cheat_parameter4itemEED2Ev($2);
  ;
  return;
}


function __ZN15cheat_parameter4textEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curitem;
      $1=$this;
      var $2=$1;
      var $3=__ZNK15cheat_parameter12has_itemlistEv($2);
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=(($2+44)|0);
      var $6=(($2+36)|0);
      var $st$2$0=(($6)|0);
      var $7$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$2$1)>>2)];
      var $8$0=$7$0;
      var $8=$8$0;
      var $9=(($2+36)|0);
      var $st$9$0=(($9)|0);
      var $10$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$9$1)>>2)];
      var $11$0=$10$0;
      var $11=$11$0;
      var $12=__ZN7astring6formatEPKcz($5, ((STRING_TABLE.__str93403)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$8,HEAP32[((tempInt+4)>>2)]=$11,tempInt));
      __label__ = 9; break;
    case 2: // $13
      var $14=(($2+44)|0);
      var $15=(($2+36)|0);
      var $st$2$0=(($15)|0);
      var $16$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$2$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      var $18=__ZN7astring6formatEPKcz($14, ((STRING_TABLE.__str103404)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt));
      var $19=(($2+108)|0);
      var $20=__ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($19);
      $curitem=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$curitem;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $24
      var $25=$curitem;
      var $26=__ZNK15cheat_parameter4item5valueEv($25);
      var $27=__ZNK17number_and_formatcvRKyEv($26);
      var $st$3$0=(($27)|0);
      var $28$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($27+4)|0);
      var $28$1=HEAP32[(($st$3$1)>>2)];
      var $29=(($2+36)|0);
      var $st$8$0=(($29)|0);
      var $30$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($29+4)|0);
      var $30$1=HEAP32[(($st$8$1)>>2)];
      var $31=$28$0 == $30$0 && $28$1 == $30$1;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      var $33=(($2+44)|0);
      var $34=$curitem;
      var $35=__ZNK15cheat_parameter4item4textEv($34);
      var $36=__ZN7astring3cpyEPKc($33, $35);
      __label__ = 8; break;
    case 6: // $37
      __label__ = 7; break;
    case 7: // $38
      var $39=$curitem;
      var $40=__ZNK15cheat_parameter4item4nextEv($39);
      $curitem=$40;
      __label__ = 3; break;
    case 8: // $41
      __label__ = 9; break;
    case 9: // $42
      var $43=(($2+44)|0);
      var $44=__ZNK7astringcvPKcEv($43);
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15cheat_parameter4textEv["X"]=1;

function __ZNK15cheat_parameter12has_itemlistEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+108)|0);
  var $4=__ZNK11simple_listIN15cheat_parameter4itemEE5countEv($3);
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK15cheat_parameter4item4textEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN15cheat_parameterC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node($this, $manager, $symbols, $filename, $paramnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16=__stackBase__+36;
      var $17=__stackBase__+48;
      var $18=__stackBase__+60;
      var $itemnode;
      var $value=__stackBase__+72;
      var $format;
      var $curitem;
      $9=$this;
      $10=$manager;
      $11=$symbols;
      $12=$filename;
      $13=$paramnode;
      var $19=$9;
      var $20=(($19)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __ZN17number_and_formatC1Eyi($20, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $21=(($19+12)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      __ZN17number_and_formatC1Eyi($21, $$emscripten$temp$1$0, $$emscripten$temp$1$1, 0);
      var $22=(($19+24)|0);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      __ZN17number_and_formatC1Eyi($22, $$emscripten$temp$2$0, $$emscripten$temp$2$1, 0);
      var $23=(($19+36)|0);
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$44$0=(($23)|0);
      HEAP32[(($st$44$0)>>2)]=$$emscripten$temp$3$0;
      var $st$44$1=(($23+4)|0);
      HEAP32[(($st$44$1)>>2)]=$$emscripten$temp$3$1;
      var $24=(($19+44)|0);
      __ZN7astringC1Ev($24);
      var $25=(($19+108)|0);
      var $26=$10;
      var $27=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 19; break; };
    case 1: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 19; break; };
    case 2: // $30
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15cheat_parameter4itemEEC1ER13resource_pool($25, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 19; break; }
    case 3: // $31
      var $32=(($19)|0);
      var $33=$13;
      var $34=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($33, ((STRING_TABLE.__str3394)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 20; break; };
    case 4: // $35
      var $36$0=$34;
      var $36$1=(($34|0) < 0 ? -1 : 0);
      var $37=$13;
      var $38=(function() { try { __THREW__ = false; return __Z28xml_get_attribute_int_formatP14_xml_data_nodePKc($37, ((STRING_TABLE.__str3394)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 20; break; };
    case 5: // $39
      (function() { try { __THREW__ = false; return __ZN17number_and_formatC1Eyi($16, $36$0, $36$1, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 20; break; }
    case 6: // $40
      var $41=$32;
      var $42=$16;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($41)>>2)]=HEAP32[(($42)>>2)];HEAP32[(($41+4)>>2)]=HEAP32[(($42+4)>>2)];HEAP32[(($41+8)>>2)]=HEAP32[(($42+8)>>2)];
      var $43=(($19+12)|0);
      var $44=$13;
      var $45=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($44, ((STRING_TABLE.__str13395)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 20; break; };
    case 7: // $46
      var $47$0=$45;
      var $47$1=(($45|0) < 0 ? -1 : 0);
      var $48=$13;
      var $49=(function() { try { __THREW__ = false; return __Z28xml_get_attribute_int_formatP14_xml_data_nodePKc($48, ((STRING_TABLE.__str13395)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 20; break; };
    case 8: // $50
      (function() { try { __THREW__ = false; return __ZN17number_and_formatC1Eyi($17, $47$0, $47$1, $49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 20; break; }
    case 9: // $51
      var $52=$43;
      var $53=$17;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($52)>>2)]=HEAP32[(($53)>>2)];HEAP32[(($52+4)>>2)]=HEAP32[(($53+4)>>2)];HEAP32[(($52+8)>>2)]=HEAP32[(($53+8)>>2)];
      var $54=(($19+24)|0);
      var $55=$13;
      var $56=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($55, ((STRING_TABLE.__str23396)|0), 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 20; break; };
    case 10: // $57
      var $58$0=$56;
      var $58$1=(($56|0) < 0 ? -1 : 0);
      var $59=$13;
      var $60=(function() { try { __THREW__ = false; return __Z28xml_get_attribute_int_formatP14_xml_data_nodePKc($59, ((STRING_TABLE.__str23396)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 20; break; };
    case 11: // $61
      (function() { try { __THREW__ = false; return __ZN17number_and_formatC1Eyi($18, $58$0, $58$1, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $62
      var $63=$54;
      var $64=$18;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($63)>>2)]=HEAP32[(($64)>>2)];HEAP32[(($63+4)>>2)]=HEAP32[(($64+4)>>2)];HEAP32[(($63+8)>>2)]=HEAP32[(($64+8)>>2)];
      var $65=$13;
      var $66=(($65+8)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($67, ((STRING_TABLE.__str33397)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; };
    case 13: // $69
      $itemnode=$68;
      __label__ = 14; break;
    case 14: // $70
      var $71=$itemnode;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 15; break; } else { __label__ = 59; break; }
    case 15: // $73
      var $74=$itemnode;
      var $75=(($74+16)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $78
      var $79=$itemnode;
      var $80=(($79+16)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81)|0);
      var $83=HEAP8[($82)];
      var $84=(($83 << 24) >> 24);
      var $85=(($84)|0)==0;
      if ($85) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $86
      var $87=___cxa_allocate_exception(1032);
      var $88=$87;
      var $89=$12;
      var $90=$itemnode;
      var $91=(($90+24)|0);
      var $92=HEAP32[(($91)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($88, ((STRING_TABLE.__str43398)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$89,HEAP32[((tempInt+4)>>2)]=$92,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $93
      (function() { try { __THREW__ = false; return ___cxa_throw($87, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 20; break; }
    case 19: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      $14=$96;
      var $97=$95.f1;
      $15=$97;
      __label__ = 63; break;
    case 20: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $99;__label__ = 21; break;
    case 21: // $_body
      var $eh_lpad_body;
      var $100=$eh_lpad_body.f0;
      $14=$100;
      var $101=$eh_lpad_body.f1;
      $15=$101;
      __label__ = 61; break;
    case 22: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $14=$104;
      var $105=$103.f1;
      $15=$105;
      ___cxa_free_exception($87);
      __label__ = 61; break;
    case 23: // $106
      var $107=$itemnode;
      var $108=(function() { try { __THREW__ = false; return __Z17xml_get_attributeP14_xml_data_nodePKc($107, ((STRING_TABLE.__str53399)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 20; break; };
    case 24: // $109
      var $110=(($108)|0)==0;
      if ($110) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $111
      var $112=___cxa_allocate_exception(1032);
      var $113=$112;
      var $114=$12;
      var $115=$itemnode;
      var $116=(($115+24)|0);
      var $117=HEAP32[(($116)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($113, ((STRING_TABLE.__str63400)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$114,HEAP32[((tempInt+4)>>2)]=$117,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $118
      (function() { try { __THREW__ = false; return ___cxa_throw($112, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 20; break; }
    case 27: // $119
      var $120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $121=$120.f0;
      $14=$121;
      var $122=$120.f1;
      $15=$122;
      ___cxa_free_exception($112);
      __label__ = 61; break;
    case 28: // $123
      var $124=$itemnode;
      var $125=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($124, ((STRING_TABLE.__str53399)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 20; break; };
    case 29: // $126
      var $127$0=$125;
      var $127$1=(($125|0) < 0 ? -1 : 0);
      var $st$2$0=(($value)|0);
      HEAP32[(($st$2$0)>>2)]=$127$0;
      var $st$2$1=(($value+4)|0);
      HEAP32[(($st$2$1)>>2)]=$127$1;
      var $128=$itemnode;
      var $129=(function() { try { __THREW__ = false; return __Z28xml_get_attribute_int_formatP14_xml_data_nodePKc($128, ((STRING_TABLE.__str53399)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 20; break; };
    case 30: // $130
      $format=$129;
      var $131=(($19+108)|0);
      var $132=$10;
      var $133=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 20; break; };
    case 31: // $134
      var $135=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 20; break; };
    case 32: // $136
      var $137=$4;
      var $138=$5;
      var $139=$6;
      var $140=$result_i;
      var $141=$7;
      var $142=$8;
      HEAP32[(($4)>>2)]=80;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($6)>>2)]=193;
      var $143=HEAP32[(($4)>>2)];
      var $144=HEAP32[(($5)>>2)];
      var $145=HEAP32[(($6)>>2)];
      var $146=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($143, $144, $145) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; };
    case 33: // $147
      HEAP32[(($result_i)>>2)]=$146;
      var $148=HEAP32[(($result_i)>>2)];
      var $149=(($148)|0)==0;
      if ($149) { __label__ = 34; break; } else { __label__ = 40; break; }
    case 34: // $150
      var $151=___cxa_allocate_exception(4);
      var $152=$151;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($152);
      (function() { try { __THREW__ = false; return ___cxa_throw($151, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 35; break; }
    case 35: // $153
      var $154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $155=$154.f0;
      HEAP32[(($7)>>2)]=$155;
      var $156=$154.f1;
      HEAP32[(($8)>>2)]=$156;
      var $157=HEAP32[(($8)>>2)];
      var $158=(($157)|0) < 0;
      if ($158) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $159
      var $160=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 20; break; }
    case 37: // $_noexc
      throw "Reached an unreachable!"
    case 38: // $161
      var $162=HEAP32[(($7)>>2)];
      var $163=HEAP32[(($7)>>2)];
      var $164=HEAP32[(($8)>>2)];
      var $165=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $163, tempValue);
      var $166=($165.f1 = $164, $165);
      var $eh_lpad_body = $166;__label__ = 21; break;
    case 39: // $167
      throw "Reached an unreachable!"
    case 40: // $_ZnwjPKci_exit
      var $168=HEAPU32[(($result_i)>>2)];
      var $169=$4;
      var $170=$5;
      var $171=$6;
      var $172=$result_i;
      var $173=$7;
      var $174=$8;
      __label__ = 41; break;
    case 41: // $175
      var $176=$168;
      var $177=$itemnode;
      var $178=(($177+16)|0);
      var $179=HEAP32[(($178)>>2)];
      var $st$4$0=(($value)|0);
      var $180$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($value+4)|0);
      var $180$1=HEAP32[(($st$4$1)>>2)];
      var $181=$format;
      (function() { try { __THREW__ = false; return __ZN15cheat_parameter4itemC1EPKcyi($176, $179, $180$0, $180$1, $181) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 54; break; }
    case 42: // $182
      var $183=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN15cheat_parameter4itemEEEPT_S4_($135, $176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 20; break; };
    case 43: // $184
      var $185=(function() { try { __THREW__ = false; return __ZN11simple_listIN15cheat_parameter4itemEE6appendERS1_($131, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 20; break; };
    case 44: // $186
      $curitem=$185;
      var $187=(($19+12)|0);
      var $188=(($19+12)|0);
      var $189=(function() { try { __THREW__ = false; return __ZN17number_and_formatcvRyEv($188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 20; break; };
    case 45: // $190
      var $st$0$0=(($189)|0);
      var $191$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($189+4)|0);
      var $191$1=HEAP32[(($st$0$1)>>2)];
      var $192=$curitem;
      var $193=(function() { try { __THREW__ = false; return __ZNK15cheat_parameter4item5valueEv($192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 20; break; };
    case 46: // $194
      var $195=(function() { try { __THREW__ = false; return __ZNK17number_and_formatcvRKyEv($193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 20; break; };
    case 47: // $196
      var $st$0$0=(($195)|0);
      var $197$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($195+4)|0);
      var $197$1=HEAP32[(($st$0$1)>>2)];
      var $198=$191$1 > $197$1 || ($191$1 == $197$1 && $191$0 > $197$0);
      if ($198) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $199
      var $200=(($19+12)|0);
      var $206 = $200;__label__ = 51; break;
    case 49: // $201
      var $202=$curitem;
      var $203=(function() { try { __THREW__ = false; return __ZNK15cheat_parameter4item5valueEv($202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 20; break; };
    case 50: // $204
      var $206 = $203;__label__ = 51; break;
    case 51: // $205
      var $206;
      var $207=$187;
      var $208=$206;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($207)>>2)]=HEAP32[(($208)>>2)];HEAP32[(($207+4)>>2)]=HEAP32[(($208+4)>>2)];HEAP32[(($207+8)>>2)]=HEAP32[(($208+8)>>2)];
      __label__ = 52; break;
    case 52: // $209
      var $210=$itemnode;
      var $211=(($210)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($212, ((STRING_TABLE.__str33397)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 20; break; };
    case 53: // $214
      $itemnode=$213;
      __label__ = 14; break;
    case 54: // $215
      var $216=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $217=$216.f0;
      $14=$217;
      var $218=$216.f1;
      $15=$218;
      var $219=$1;
      var $220=$2;
      var $221=$3;
      HEAP32[(($1)>>2)]=$168;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($3)>>2)]=193;
      var $222=HEAP32[(($1)>>2)];
      var $223=(($222)|0)!=0;
      if ($223) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $224
      var $225=HEAP32[(($1)>>2)];
      var $226=HEAP32[(($2)>>2)];
      var $227=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($225, $226, $227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 66; break; }
    case 56: // $_noexc1
      __label__ = 57; break;
    case 57: // $_ZdlPvPKci_exit
      var $228=$1;
      var $229=$2;
      var $230=$3;
      __label__ = 58; break;
    case 58: // $231
      __label__ = 61; break;
    case 59: // $232
      var $233=$11;
      var $234=(($19+36)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcNS_10read_writeEPy($233, ((STRING_TABLE.__str83402)|0), 0, $234) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 20; break; }
    case 60: // $235
      STACKTOP = __stackBase__;
      return;
    case 61: // $236
      var $237=(($19+108)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15cheat_parameter4itemEED1Ev($237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 66; break; }
    case 62: // $238
      __label__ = 63; break;
    case 63: // $239
      var $240=(($19+44)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($240) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 64: // $241
      __label__ = 65; break;
    case 65: // $242
      var $243=$14;
      var $244=$14;
      var $245=$15;
      var $246=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $244, tempValue);
      var $247=($246.f1 = $245, $246);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $248
      var $249=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 67: // $250
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15cheat_parameterC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node["X"]=1;

function __ZN13resource_pool10add_objectIN15cheat_parameter4itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15cheat_parameter4itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN15cheat_parameter4itemEEEPT_S4_["X"]=1;

function __ZNK17number_and_format6formatER7astring($this, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$string;
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      if ($5 == 0) {
        __label__ = 2; break;
      }
      else if ($5 == 1) {
        __label__ = 3; break;
      }
      else if ($5 == 2) {
        __label__ = 4; break;
      }
      else if ($5 == 3) {
        __label__ = 5; break;
      }
      else {
      __label__ = 1; break;
      }
      
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=$2;
      var $9=(($3)|0);
      var $st$2$0=(($9)|0);
      var $10$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$2$1)>>2)];
      var $11$0=$10$0;
      var $11=$11$0;
      var $12=__ZN7astring6printfEPKcz($8, ((STRING_TABLE.__str1383532)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$11,tempInt));
      __label__ = 6; break;
    case 3: // $13
      var $14=$2;
      var $15=(($3)|0);
      var $st$2$0=(($15)|0);
      var $16$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$2$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      var $18=__ZN7astring6printfEPKcz($14, ((STRING_TABLE.__str1393533)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt));
      __label__ = 6; break;
    case 4: // $19
      var $20=$2;
      var $21=(($3)|0);
      var $st$2$0=(($21)|0);
      var $22$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($21+4)|0);
      var $22$1=HEAP32[(($st$2$1)>>2)];
      var $23$0=$22$0;
      var $23=$23$0;
      var $24=__ZN7astring6printfEPKcz($20, ((STRING_TABLE.__str1403534)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$23,tempInt));
      __label__ = 6; break;
    case 5: // $25
      var $26=$2;
      var $27=(($3)|0);
      var $st$2$0=(($27)|0);
      var $28$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($27+4)|0);
      var $28$1=HEAP32[(($st$2$1)>>2)];
      var $29$0=$28$0;
      var $29=$29$0;
      var $30=__ZN7astring6printfEPKcz($26, ((STRING_TABLE.__str1413535)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$29,tempInt));
      __label__ = 6; break;
    case 6: // $31
      var $32=$2;
      var $33=__ZNK7astringcvPKcEv($32);
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK17number_and_format6formatER7astring["X"]=1;

function __ZN15cheat_parameter17set_minimum_stateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $origvalue=__stackBase__;
      $1=$this;
      var $2=$1;
      var $3=(($2+36)|0);
      var $st$5$0=(($3)|0);
      var $4$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($3+4)|0);
      var $4$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($origvalue)|0);
      HEAP32[(($st$9$0)>>2)]=$4$0;
      var $st$9$1=(($origvalue+4)|0);
      HEAP32[(($st$9$1)>>2)]=$4$1;
      var $5=__ZNK15cheat_parameter12has_itemlistEv($2);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($2)|0);
      var $13 = $7;__label__ = 3; break;
    case 2: // $8
      var $9=(($2+108)|0);
      var $10=__ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($9);
      var $11=__ZNK15cheat_parameter4item5valueEv($10);
      var $13 = $11;__label__ = 3; break;
    case 3: // $12
      var $13;
      var $14=__ZNK17number_and_formatcvRKyEv($13);
      var $st$2$0=(($14)|0);
      var $15$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$2$1)>>2)];
      var $16=(($2+36)|0);
      var $st$7$0=(($16)|0);
      HEAP32[(($st$7$0)>>2)]=$15$0;
      var $st$7$1=(($16+4)|0);
      HEAP32[(($st$7$1)>>2)]=$15$1;
      var $17=(($2+36)|0);
      var $st$12$0=(($17)|0);
      var $18$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($17+4)|0);
      var $18$1=HEAP32[(($st$12$1)>>2)];
      var $st$16$0=(($origvalue)|0);
      var $19$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($origvalue+4)|0);
      var $19$1=HEAP32[(($st$16$1)>>2)];
      var $20=$18$0 != $19$0 || $18$1 != $19$1;
      STACKTOP = __stackBase__;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15cheat_parameter14set_prev_stateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $origvalue=__stackBase__;
      var $curitem;
      var $previtem;
      $1=$this;
      var $2=$1;
      var $3=(($2+36)|0);
      var $st$7$0=(($3)|0);
      var $4$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($3+4)|0);
      var $4$1=HEAP32[(($st$7$1)>>2)];
      var $st$11$0=(($origvalue)|0);
      HEAP32[(($st$11$0)>>2)]=$4$0;
      var $st$11$1=(($origvalue+4)|0);
      HEAP32[(($st$11$1)>>2)]=$4$1;
      var $5=__ZNK15cheat_parameter12has_itemlistEv($2);
      if ($5) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($2+36)|0);
      var $st$1$0=(($7)|0);
      var $8$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($7+4)|0);
      var $8$1=HEAP32[(($st$1$1)>>2)];
      var $9=(($2)|0);
      var $10=__ZN17number_and_formatcvRyEv($9);
      var $st$7$0=(($10)|0);
      var $11$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($10+4)|0);
      var $11$1=HEAP32[(($st$7$1)>>2)];
      var $12=(($2+24)|0);
      var $13=__ZN17number_and_formatcvRyEv($12);
      var $st$13$0=(($13)|0);
      var $14$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($13+4)|0);
      var $14$1=HEAP32[(($st$13$1)>>2)];
      var $15$0 = ((($11$0)>>>0)+((($11$1)|0)*4294967296))+((($14$0)>>>0)+((($14$1)|0)*4294967296))>>>0; var $15$1 = Math.min(Math.floor((((($11$0)>>>0)+((($11$1)|0)*4294967296))+((($14$0)>>>0)+((($14$1)|0)*4294967296)))/4294967296), 4294967295);
      var $16=$8$1 < $15$1 || ($8$1 == $15$1 && $8$0 < $15$0);
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=(($2)|0);
      var $19=__ZN17number_and_formatcvRyEv($18);
      var $st$2$0=(($19)|0);
      var $20$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($19+4)|0);
      var $20$1=HEAP32[(($st$2$1)>>2)];
      var $21=(($2+36)|0);
      var $st$7$0=(($21)|0);
      HEAP32[(($st$7$0)>>2)]=$20$0;
      var $st$7$1=(($21+4)|0);
      HEAP32[(($st$7$1)>>2)]=$20$1;
      __label__ = 4; break;
    case 3: // $22
      var $23=(($2+24)|0);
      var $24=__ZN17number_and_formatcvRyEv($23);
      var $st$2$0=(($24)|0);
      var $25$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$2$1)>>2)];
      var $26=(($2+36)|0);
      var $st$7$0=(($26)|0);
      var $27$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$7$1)>>2)];
      var $28$0 = ((($27$0)>>>0)+((($27$1)|0)*4294967296))-((($25$0)>>>0)+((($25$1)|0)*4294967296))>>>0; var $28$1 = Math.min(Math.floor((((($27$0)>>>0)+((($27$1)|0)*4294967296))-((($25$0)>>>0)+((($25$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($26)|0);
      HEAP32[(($st$12$0)>>2)]=$28$0;
      var $st$12$1=(($26+4)|0);
      HEAP32[(($st$12$1)>>2)]=$28$1;
      __label__ = 4; break;
    case 4: // $29
      __label__ = 14; break;
    case 5: // $30
      $previtem=0;
      var $31=(($2+108)|0);
      var $32=__ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($31);
      $curitem=$32;
      __label__ = 6; break;
    case 6: // $33
      var $34=$curitem;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $36
      var $37=$curitem;
      var $38=__ZNK15cheat_parameter4item5valueEv($37);
      var $39=__ZNK17number_and_formatcvRKyEv($38);
      var $st$3$0=(($39)|0);
      var $40$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$3$1)>>2)];
      var $41=(($2+36)|0);
      var $st$8$0=(($41)|0);
      var $42$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$8$1)>>2)];
      var $43=$40$0 == $42$0 && $40$1 == $42$1;
      if ($43) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $44
      __label__ = 11; break;
    case 9: // $45
      __label__ = 10; break;
    case 10: // $46
      var $47=$curitem;
      $previtem=$47;
      var $48=$curitem;
      var $49=__ZNK15cheat_parameter4item4nextEv($48);
      $curitem=$49;
      __label__ = 6; break;
    case 11: // $50
      var $51=$previtem;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $53
      var $54=$previtem;
      var $55=__ZNK15cheat_parameter4item5valueEv($54);
      var $56=__ZNK17number_and_formatcvRKyEv($55);
      var $st$3$0=(($56)|0);
      var $57$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($56+4)|0);
      var $57$1=HEAP32[(($st$3$1)>>2)];
      var $58=(($2+36)|0);
      var $st$8$0=(($58)|0);
      HEAP32[(($st$8$0)>>2)]=$57$0;
      var $st$8$1=(($58+4)|0);
      HEAP32[(($st$8$1)>>2)]=$57$1;
      __label__ = 13; break;
    case 13: // $59
      __label__ = 14; break;
    case 14: // $60
      var $61=(($2+36)|0);
      var $st$1$0=(($61)|0);
      var $62$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($61+4)|0);
      var $62$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($origvalue)|0);
      var $63$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($origvalue+4)|0);
      var $63$1=HEAP32[(($st$5$1)>>2)];
      var $64=$62$0 != $63$0 || $62$1 != $63$1;
      STACKTOP = __stackBase__;
      return $64;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15cheat_parameter14set_prev_stateEv["X"]=1;

function __ZN15cheat_parameter14set_next_stateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $origvalue=__stackBase__;
      var $curitem;
      $1=$this;
      var $2=$1;
      var $3=(($2+36)|0);
      var $st$6$0=(($3)|0);
      var $4$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $4$1=HEAP32[(($st$6$1)>>2)];
      var $st$10$0=(($origvalue)|0);
      HEAP32[(($st$10$0)>>2)]=$4$0;
      var $st$10$1=(($origvalue+4)|0);
      HEAP32[(($st$10$1)>>2)]=$4$1;
      var $5=__ZNK15cheat_parameter12has_itemlistEv($2);
      if ($5) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($2+36)|0);
      var $st$1$0=(($7)|0);
      var $8$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($7+4)|0);
      var $8$1=HEAP32[(($st$1$1)>>2)];
      var $9=(($2+12)|0);
      var $10=__ZN17number_and_formatcvRyEv($9);
      var $st$7$0=(($10)|0);
      var $11$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($10+4)|0);
      var $11$1=HEAP32[(($st$7$1)>>2)];
      var $12=(($2+24)|0);
      var $13=__ZN17number_and_formatcvRyEv($12);
      var $st$13$0=(($13)|0);
      var $14$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($13+4)|0);
      var $14$1=HEAP32[(($st$13$1)>>2)];
      var $15$0 = ((($11$0)>>>0)+((($11$1)|0)*4294967296))-((($14$0)>>>0)+((($14$1)|0)*4294967296))>>>0; var $15$1 = Math.min(Math.floor((((($11$0)>>>0)+((($11$1)|0)*4294967296))-((($14$0)>>>0)+((($14$1)|0)*4294967296)))/4294967296), 4294967295);
      var $16=$8$1 > $15$1 || ($8$1 == $15$1 && $8$0 > $15$0);
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=(($2+12)|0);
      var $19=__ZN17number_and_formatcvRyEv($18);
      var $st$2$0=(($19)|0);
      var $20$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($19+4)|0);
      var $20$1=HEAP32[(($st$2$1)>>2)];
      var $21=(($2+36)|0);
      var $st$7$0=(($21)|0);
      HEAP32[(($st$7$0)>>2)]=$20$0;
      var $st$7$1=(($21+4)|0);
      HEAP32[(($st$7$1)>>2)]=$20$1;
      __label__ = 4; break;
    case 3: // $22
      var $23=(($2+24)|0);
      var $24=__ZN17number_and_formatcvRyEv($23);
      var $st$2$0=(($24)|0);
      var $25$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$2$1)>>2)];
      var $26=(($2+36)|0);
      var $st$7$0=(($26)|0);
      var $27$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$7$1)>>2)];
      var $28$0 = ((($27$0)>>>0)+((($27$1)|0)*4294967296))+((($25$0)>>>0)+((($25$1)|0)*4294967296))>>>0; var $28$1 = Math.min(Math.floor((((($27$0)>>>0)+((($27$1)|0)*4294967296))+((($25$0)>>>0)+((($25$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($26)|0);
      HEAP32[(($st$12$0)>>2)]=$28$0;
      var $st$12$1=(($26+4)|0);
      HEAP32[(($st$12$1)>>2)]=$28$1;
      __label__ = 4; break;
    case 4: // $29
      __label__ = 15; break;
    case 5: // $30
      var $31=(($2+108)|0);
      var $32=__ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($31);
      $curitem=$32;
      __label__ = 6; break;
    case 6: // $33
      var $34=$curitem;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $36
      var $37=$curitem;
      var $38=__ZNK15cheat_parameter4item5valueEv($37);
      var $39=__ZNK17number_and_formatcvRKyEv($38);
      var $st$3$0=(($39)|0);
      var $40$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$3$1)>>2)];
      var $41=(($2+36)|0);
      var $st$8$0=(($41)|0);
      var $42$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$8$1)>>2)];
      var $43=$40$0 == $42$0 && $40$1 == $42$1;
      if ($43) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $44
      __label__ = 11; break;
    case 9: // $45
      __label__ = 10; break;
    case 10: // $46
      var $47=$curitem;
      var $48=__ZNK15cheat_parameter4item4nextEv($47);
      $curitem=$48;
      __label__ = 6; break;
    case 11: // $49
      var $50=$curitem;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $52
      var $53=$curitem;
      var $54=__ZNK15cheat_parameter4item4nextEv($53);
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $56
      var $57=$curitem;
      var $58=__ZNK15cheat_parameter4item4nextEv($57);
      var $59=__ZNK15cheat_parameter4item5valueEv($58);
      var $60=__ZNK17number_and_formatcvRKyEv($59);
      var $st$4$0=(($60)|0);
      var $61$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($60+4)|0);
      var $61$1=HEAP32[(($st$4$1)>>2)];
      var $62=(($2+36)|0);
      var $st$9$0=(($62)|0);
      HEAP32[(($st$9$0)>>2)]=$61$0;
      var $st$9$1=(($62+4)|0);
      HEAP32[(($st$9$1)>>2)]=$61$1;
      __label__ = 14; break;
    case 14: // $63
      __label__ = 15; break;
    case 15: // $64
      var $65=(($2+36)|0);
      var $st$1$0=(($65)|0);
      var $66$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($65+4)|0);
      var $66$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($origvalue)|0);
      var $67$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($origvalue+4)|0);
      var $67$1=HEAP32[(($st$5$1)>>2)];
      var $68=$66$0 != $67$0 || $66$1 != $67$1;
      STACKTOP = __stackBase__;
      return $68;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15cheat_parameter14set_next_stateEv["X"]=1;

function __ZNK15cheat_parameter4saveER8emu_file($this, $cheatfile) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $string=__stackBase__;
      var $3;
      var $4;
      var $curitem;
      $1=$this;
      $2=$cheatfile;
      var $5=$1;
      var $6=$2;
      var $7=__ZN8emu_file6printfEPKcz($6, ((STRING_TABLE.__str113405)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __ZN7astringC1Ev($string);
      var $8=(function() { try { __THREW__ = false; return __ZNK15cheat_parameter12has_itemlistEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; };
    case 1: // $9
      if ($8) { __label__ = 20; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=(($5)|0);
      var $12=(function() { try { __THREW__ = false; return __ZNK17number_and_formatcvRKyEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $13
      var $st$0$0=(($12)|0);
      var $14$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($12+4)|0);
      var $14$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $15=$14$0 != $$emscripten$temp$0$0 || $14$1 != $$emscripten$temp$0$1;
      if ($15) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $16
      var $17=$2;
      var $18=(($5)|0);
      var $19=(function() { try { __THREW__ = false; return __ZNK17number_and_format6formatER7astring($18, $string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $20
      var $21=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($17, ((STRING_TABLE.__str123406)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $22
      __label__ = 8; break;
    case 7: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $3=$25;
      var $26=$24.f1;
      $4=$26;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 8: // $27
      var $28=(($5+12)|0);
      var $29=(function() { try { __THREW__ = false; return __ZNK17number_and_formatcvRKyEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 7; break; };
    case 9: // $30
      var $st$0$0=(($29)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($29+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $32=$31$0 != $$emscripten$temp$1$0 || $31$1 != $$emscripten$temp$1$1;
      if ($32) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $33
      var $34=$2;
      var $35=(($5+12)|0);
      var $36=(function() { try { __THREW__ = false; return __ZNK17number_and_format6formatER7astring($35, $string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 7; break; };
    case 11: // $37
      var $38=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($34, ((STRING_TABLE.__str133407)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; };
    case 12: // $39
      __label__ = 13; break;
    case 13: // $40
      var $41=(($5+24)|0);
      var $42=(function() { try { __THREW__ = false; return __ZNK17number_and_formatcvRKyEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 7; break; };
    case 14: // $43
      var $st$0$0=(($42)|0);
      var $44$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($42+4)|0);
      var $44$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $45=$44$0 != $$emscripten$temp$2$0 || $44$1 != $$emscripten$temp$2$1;
      if ($45) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $46
      var $47=$2;
      var $48=(($5+24)|0);
      var $49=(function() { try { __THREW__ = false; return __ZNK17number_and_format6formatER7astring($48, $string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 7; break; };
    case 16: // $50
      var $51=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($47, ((STRING_TABLE.__str143408)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 7; break; };
    case 17: // $52
      __label__ = 18; break;
    case 18: // $53
      var $54=$2;
      var $55=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($54, ((STRING_TABLE.__str153409)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 7; break; };
    case 19: // $56
      __label__ = 32; break;
    case 20: // $57
      var $58=(($5+108)|0);
      var $59=(function() { try { __THREW__ = false; return __ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 7; break; };
    case 21: // $60
      $curitem=$59;
      __label__ = 22; break;
    case 22: // $61
      var $62=$curitem;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $64
      var $65=$2;
      var $66=$curitem;
      var $67=(function() { try { __THREW__ = false; return __ZNK15cheat_parameter4item5valueEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 7; break; };
    case 24: // $68
      var $69=(function() { try { __THREW__ = false; return __ZNK17number_and_format6formatER7astring($67, $string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 7; break; };
    case 25: // $70
      var $71=$curitem;
      var $72=(function() { try { __THREW__ = false; return __ZNK15cheat_parameter4item4textEv($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 7; break; };
    case 26: // $73
      var $74=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($65, ((STRING_TABLE.__str163410)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$69,HEAP32[((tempInt+4)>>2)]=$72,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 7; break; };
    case 27: // $75
      __label__ = 28; break;
    case 28: // $76
      var $77=$curitem;
      var $78=(function() { try { __THREW__ = false; return __ZNK15cheat_parameter4item4nextEv($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 7; break; };
    case 29: // $79
      $curitem=$78;
      __label__ = 22; break;
    case 30: // $80
      var $81=$2;
      var $82=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($81, ((STRING_TABLE.__str173411)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 7; break; };
    case 31: // $83
      __label__ = 32; break;
    case 32: // $84
      FUNCTION_TABLE[__ZN7astringD1Ev]($string);
      STACKTOP = __stackBase__;
      return;
    case 33: // $85
      __label__ = 34; break;
    case 34: // $86
      var $87=$3;
      var $88=$3;
      var $89=$4;
      var $90=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $88, tempValue);
      var $91=($90.f1 = $89, $90);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK15cheat_parameter4saveER8emu_file["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entryEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13cheat_manager7enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+3284)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  var $6=$5 ^ 1;
  ;
  return $6;
}


function __ZNK11simple_listIN12cheat_script12script_entryEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN12cheat_script12script_entryEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN12cheat_script12script_entryEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN12cheat_script12script_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN12cheat_script12script_entryEED2Ev($2);
  ;
  return;
}


function __ZN12cheat_script7executeER13cheat_managerRy($this, $manager, $argindex) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      $1=$this;
      $2=$manager;
      $3=$argindex;
      var $4=$1;
      var $5=$2;
      var $6=__ZNK13cheat_manager7enabledEv($5);
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      __label__ = 6; break;
    case 2: // $8
      var $9=(($4)|0);
      var $10=__ZNK11simple_listIN12cheat_script12script_entryEE5firstEv($9);
      $entry=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $14
      var $15=$entry;
      var $16=$2;
      var $17=$3;
      __ZN12cheat_script12script_entry7executeER13cheat_managerRy($15, $16, $17);
      __label__ = 5; break;
    case 5: // $18
      var $19=$entry;
      var $20=__ZNK12cheat_script12script_entry4nextEv($19);
      $entry=$20;
      __label__ = 3; break;
    case 6: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12cheat_scriptC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node($this, $manager, $symbols, $filename, $scriptnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $state;
      var $22;
      var $23;
      var $entrynode;
      $17=$this;
      $18=$manager;
      $19=$symbols;
      $20=$filename;
      $21=$scriptnode;
      var $24=$17;
      var $25=(($24)|0);
      var $26=$18;
      var $27=__ZNK13cheat_manager7machineEv($26);
      var $28=__ZN15running_machine7respoolEv($27);
      __ZN11simple_listIN12cheat_script12script_entryEEC1ER13resource_pool($25, $28);
      var $29=(($24+20)|0);
      HEAP32[(($29)>>2)]=2;
      var $30=$21;
      var $31=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($30, ((STRING_TABLE.__str183412)|0), ((STRING_TABLE.__str193413)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $32
      $state=$31;
      var $33=$state;
      var $34=(function() { try { __THREW__ = false; return _strcmp($33, ((STRING_TABLE.__str203414)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $35
      var $36=(($34)|0)==0;
      if ($36) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $37
      var $38=(($24+20)|0);
      HEAP32[(($38)>>2)]=1;
      __label__ = 21; break;
    case 4: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body5 = $40;__label__ = 5; break;
    case 5: // $_body4
      var $eh_lpad_body5;
      var $eh_lpad_body = $eh_lpad_body5;__label__ = 6; break;
    case 6: // $_body
      var $eh_lpad_body;
      var $41=$eh_lpad_body.f0;
      $22=$41;
      var $42=$eh_lpad_body.f1;
      $23=$42;
      __label__ = 73; break;
    case 7: // $43
      var $44=$state;
      var $45=(function() { try { __THREW__ = false; return _strcmp($44, ((STRING_TABLE.__str213415)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $46
      var $47=(($45)|0)==0;
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      var $49=(($24+20)|0);
      HEAP32[(($49)>>2)]=0;
      __label__ = 20; break;
    case 10: // $50
      var $51=$state;
      var $52=(function() { try { __THREW__ = false; return _strcmp($51, ((STRING_TABLE.__str223416)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $53
      var $54=(($52)|0)==0;
      if ($54) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $55
      var $56=(($24+20)|0);
      HEAP32[(($56)>>2)]=3;
      __label__ = 19; break;
    case 13: // $57
      var $58=$state;
      var $59=(function() { try { __THREW__ = false; return _strcmp($58, ((STRING_TABLE.__str193413)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $60
      var $61=(($59)|0)!=0;
      if ($61) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $62
      var $63=___cxa_allocate_exception(1032);
      var $64=$63;
      var $65=$20;
      var $66=$21;
      var $67=(($66+24)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$state;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($64, ((STRING_TABLE.__str233417)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$65,HEAP32[((tempInt+4)>>2)]=$68,HEAP32[((tempInt+8)>>2)]=$69,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $70
      (function() { try { __THREW__ = false; return ___cxa_throw($63, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 4; break; }
    case 17: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $22=$73;
      var $74=$72.f1;
      $23=$74;
      ___cxa_free_exception($63);
      __label__ = 73; break;
    case 18: // $75
      __label__ = 19; break;
    case 19: // $76
      __label__ = 20; break;
    case 20: // $77
      __label__ = 21; break;
    case 21: // $78
      var $79=$21;
      var $80=(($79+8)|0);
      var $81=HEAP32[(($80)>>2)];
      $entrynode=$81;
      __label__ = 22; break;
    case 22: // $82
      var $83=$entrynode;
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 23; break; } else { __label__ = 72; break; }
    case 23: // $85
      var $86=$entrynode;
      var $87=(($86+12)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return _strcmp($88, ((STRING_TABLE.__str243418)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 4; break; };
    case 24: // $90
      var $91=(($89)|0)==0;
      if ($91) { __label__ = 25; break; } else { __label__ = 45; break; }
    case 25: // $92
      var $93=(($24)|0);
      var $94=$18;
      var $95=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 4; break; };
    case 26: // $96
      var $97=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 4; break; };
    case 27: // $98
      var $99=$12;
      var $100=$13;
      var $101=$14;
      var $102=$result_i;
      var $103=$15;
      var $104=$16;
      HEAP32[(($12)>>2)]=1340;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($14)>>2)]=369;
      var $105=HEAP32[(($12)>>2)];
      var $106=HEAP32[(($13)>>2)];
      var $107=HEAP32[(($14)>>2)];
      var $108=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($105, $106, $107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; };
    case 28: // $109
      HEAP32[(($result_i)>>2)]=$108;
      var $110=HEAP32[(($result_i)>>2)];
      var $111=(($110)|0)==0;
      if ($111) { __label__ = 29; break; } else { __label__ = 35; break; }
    case 29: // $112
      var $113=___cxa_allocate_exception(4);
      var $114=$113;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($114);
      (function() { try { __THREW__ = false; return ___cxa_throw($113, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 30; break; }
    case 30: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $117=$116.f0;
      HEAP32[(($15)>>2)]=$117;
      var $118=$116.f1;
      HEAP32[(($16)>>2)]=$118;
      var $119=HEAP32[(($16)>>2)];
      var $120=(($119)|0) < 0;
      if ($120) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $121
      var $122=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 4; break; }
    case 32: // $_noexc
      throw "Reached an unreachable!"
    case 33: // $123
      var $124=HEAP32[(($15)>>2)];
      var $125=HEAP32[(($15)>>2)];
      var $126=HEAP32[(($16)>>2)];
      var $127=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $125, tempValue);
      var $128=($127.f1 = $126, $127);
      var $eh_lpad_body = $128;__label__ = 6; break;
    case 34: // $129
      throw "Reached an unreachable!"
    case 35: // $_ZnwjPKci_exit
      var $130=HEAP32[(($result_i)>>2)];
      var $131=$12;
      var $132=$13;
      var $133=$14;
      var $134=$result_i;
      var $135=$15;
      var $136=$16;
      __label__ = 36; break;
    case 36: // $137
      var $138=$130;
      var $139=$18;
      var $140=$19;
      var $141=$20;
      var $142=$entrynode;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cheat_script12script_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb]($138, $139, $140, $141, $142, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $143
      var $144=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN12cheat_script12script_entryEEEPT_S4_($97, $138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 4; break; };
    case 38: // $145
      var $146=(function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entryEE6appendERS1_($93, $144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 4; break; };
    case 39: // $147
      __label__ = 70; break;
    case 40: // $148
      var $149=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $150=$149.f0;
      $22=$150;
      var $151=$149.f1;
      $23=$151;
      var $152=$9;
      var $153=$10;
      var $154=$11;
      HEAP32[(($9)>>2)]=$130;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($11)>>2)]=369;
      var $155=HEAP32[(($9)>>2)];
      var $156=(($155)|0)!=0;
      if ($156) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $157
      var $158=HEAP32[(($9)>>2)];
      var $159=HEAP32[(($10)>>2)];
      var $160=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($158, $159, $160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 76; break; }
    case 42: // $_noexc1
      __label__ = 43; break;
    case 43: // $_ZdlPvPKci_exit
      var $161=$9;
      var $162=$10;
      var $163=$11;
      __label__ = 44; break;
    case 44: // $164
      __label__ = 73; break;
    case 45: // $165
      var $166=$entrynode;
      var $167=(($166+12)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(function() { try { __THREW__ = false; return _strcmp($168, ((STRING_TABLE.__str253419)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 4; break; };
    case 46: // $170
      var $171=(($169)|0)==0;
      if ($171) { __label__ = 47; break; } else { __label__ = 67; break; }
    case 47: // $172
      var $173=(($24)|0);
      var $174=$18;
      var $175=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($174) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 4; break; };
    case 48: // $176
      var $177=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 4; break; };
    case 49: // $178
      var $179=$4;
      var $180=$5;
      var $181=$6;
      var $182=$result_i2;
      var $183=$7;
      var $184=$8;
      HEAP32[(($4)>>2)]=1340;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($6)>>2)]=373;
      var $185=HEAP32[(($4)>>2)];
      var $186=HEAP32[(($5)>>2)];
      var $187=HEAP32[(($6)>>2)];
      var $188=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($185, $186, $187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 52; break; };
    case 50: // $189
      HEAP32[(($result_i2)>>2)]=$188;
      var $190=HEAP32[(($result_i2)>>2)];
      var $191=(($190)|0)==0;
      if ($191) { __label__ = 51; break; } else { __label__ = 57; break; }
    case 51: // $192
      var $193=___cxa_allocate_exception(4);
      var $194=$193;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($194);
      (function() { try { __THREW__ = false; return ___cxa_throw($193, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 52; break; }
    case 52: // $195
      var $196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $197=$196.f0;
      HEAP32[(($7)>>2)]=$197;
      var $198=$196.f1;
      HEAP32[(($8)>>2)]=$198;
      var $199=HEAP32[(($8)>>2)];
      var $200=(($199)|0) < 0;
      if ($200) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $201
      var $202=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 4; break; }
    case 54: // $_noexc3
      throw "Reached an unreachable!"
    case 55: // $203
      var $204=HEAP32[(($7)>>2)];
      var $205=HEAP32[(($7)>>2)];
      var $206=HEAP32[(($8)>>2)];
      var $207=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $205, tempValue);
      var $208=($207.f1 = $206, $207);
      var $eh_lpad_body5 = $208;__label__ = 5; break;
    case 56: // $209
      throw "Reached an unreachable!"
    case 57: // $_ZnwjPKci_exit6
      var $210=HEAP32[(($result_i2)>>2)];
      var $211=$4;
      var $212=$5;
      var $213=$6;
      var $214=$result_i2;
      var $215=$7;
      var $216=$8;
      __label__ = 58; break;
    case 58: // $217
      var $218=$210;
      var $219=$18;
      var $220=$19;
      var $221=$20;
      var $222=$entrynode;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cheat_script12script_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb]($218, $219, $220, $221, $222, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 62; break; }
    case 59: // $223
      var $224=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN12cheat_script12script_entryEEEPT_S4_($177, $218) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 4; break; };
    case 60: // $225
      var $226=(function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entryEE6appendERS1_($173, $224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 4; break; };
    case 61: // $227
      __label__ = 69; break;
    case 62: // $228
      var $229=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $230=$229.f0;
      $22=$230;
      var $231=$229.f1;
      $23=$231;
      var $232=$1;
      var $233=$2;
      var $234=$3;
      HEAP32[(($1)>>2)]=$210;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($3)>>2)]=373;
      var $235=HEAP32[(($1)>>2)];
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 63: // $237
      var $238=HEAP32[(($1)>>2)];
      var $239=HEAP32[(($2)>>2)];
      var $240=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($238, $239, $240) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 76; break; }
    case 64: // $_noexc7
      __label__ = 65; break;
    case 65: // $_ZdlPvPKci_exit8
      var $241=$1;
      var $242=$2;
      var $243=$3;
      __label__ = 66; break;
    case 66: // $244
      __label__ = 73; break;
    case 67: // $245
      var $246=$20;
      var $247=$entrynode;
      var $248=(($247+24)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=$entrynode;
      var $251=(($250+12)|0);
      var $252=HEAP32[(($251)>>2)];
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str263420)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$246,HEAP32[((tempInt+4)>>2)]=$249,HEAP32[((tempInt+8)>>2)]=$252,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 4; break; }
    case 68: // $253
      __label__ = 71; break;
    case 69: // $254
      __label__ = 70; break;
    case 70: // $255
      __label__ = 71; break;
    case 71: // $256
      var $257=$entrynode;
      var $258=(($257)|0);
      var $259=HEAP32[(($258)>>2)];
      $entrynode=$259;
      __label__ = 22; break;
    case 72: // $260
      STACKTOP = __stackBase__;
      return;
    case 73: // $261
      var $262=(($24)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entryEED1Ev($262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 76; break; }
    case 74: // $263
      __label__ = 75; break;
    case 75: // $264
      var $265=$22;
      var $266=$22;
      var $267=$23;
      var $268=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $266, tempValue);
      var $269=($268.f1 = $267, $268);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 76: // $270
      var $271=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 77: // $272
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cheat_scriptC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node["X"]=1;

function __ZN13resource_pool10add_objectIN12cheat_script12script_entryEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12cheat_script12script_entryEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12cheat_script12script_entryEEEPT_S4_["X"]=1;

function __ZNK12cheat_script12script_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12cheat_script4saveER8emu_file($this, $cheatfile) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $entry;
      $1=$this;
      $2=$cheatfile;
      var $3=$1;
      var $4=$2;
      var $5=__ZN8emu_file6printfEPKcz($4, ((STRING_TABLE.__str273421)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $6=(($3+20)|0);
      var $7=HEAP32[(($6)>>2)];
      if ($7 == 0) {
        __label__ = 1; break;
      }
      else if ($7 == 1) {
        __label__ = 2; break;
      }
      else if ($7 == 2) {
        __label__ = 4; break;
      }
      else if ($7 == 3) {
        __label__ = 5; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      var $9=$2;
      var $10=__ZN8emu_file6printfEPKcz($9, ((STRING_TABLE.__str283422)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 2: // $11
      var $12=$2;
      var $13=__ZN8emu_file6printfEPKcz($12, ((STRING_TABLE.__str293423)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=__ZN8emu_file6printfEPKcz($16, ((STRING_TABLE.__str303424)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 5: // $18
      var $19=$2;
      var $20=__ZN8emu_file6printfEPKcz($19, ((STRING_TABLE.__str313425)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 6: // $21
      var $22=$2;
      var $23=__ZN8emu_file6printfEPKcz($22, ((STRING_TABLE.__str323426)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $24=(($3)|0);
      var $25=__ZNK11simple_listIN12cheat_script12script_entryEE5firstEv($24);
      $entry=$25;
      __label__ = 7; break;
    case 7: // $26
      var $27=$entry;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $29
      var $30=$entry;
      var $31=$2;
      __ZNK12cheat_script12script_entry4saveER8emu_file($30, $31);
      __label__ = 9; break;
    case 9: // $32
      var $33=$entry;
      var $34=__ZNK12cheat_script12script_entry4nextEv($33);
      $entry=$34;
      __label__ = 7; break;
    case 10: // $35
      var $36=$2;
      var $37=__ZN8emu_file6printfEPKcz($36, ((STRING_TABLE.__str333427)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12cheat_script12script_entry7executeER13cheat_managerRy($this, $manager, $argindex) {
  var __stackBase__  = STACKTOP; STACKTOP += 264; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result=__stackBase__;
      var $4;
      var $5;
      var $err;
      var $6;
      var $err1;
      var $params=__stackBase__+8;
      var $curarg;
      var $arg;
      $1=$this;
      $2=$manager;
      $3=$argindex;
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=__ZNK17parsed_expression8is_emptyEv($8);
      if ($9) { __label__ = 14; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=(($7+4)|0);
      var $12=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
      var $12$0=$12[0];
      var $12$1=$12[1];
    case 2: // $13
      var $st$0$0=(($result)|0);
      HEAP32[(($st$0$0)>>2)]=$12$0;
      var $st$0$1=(($result+4)|0);
      HEAP32[(($st$0$1)>>2)]=$12$1;
      var $st$4$0=(($result)|0);
      var $14$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($result+4)|0);
      var $14$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $15=$14$0 == $$emscripten$temp$0$0 && $14$1 == $$emscripten$temp$0$1;
      if ($15) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $16
      __label__ = 32; break;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$5;
      var $23=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 6; break; } else { __label__ = 33; break; }
    case 6: // $25
      var $26=$4;
      var $27=___cxa_begin_catch($26);
      var $28=$27;
      $err=$28;
      var $29=(($7+4)|0);
      var $30=(function() { try { __THREW__ = false; return __ZNK17parsed_expression15original_stringEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $31
      var $32=$err;
      var $33=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $34
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str473441)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$30,HEAP32[((tempInt+4)>>2)]=$33,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $35
      $6=1;
      ___cxa_end_catch();
      __label__ = 32; break;
    case 10: // $36
      __label__ = 13; break;
    case 11: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $4=$39;
      var $40=$38.f1;
      $5=$40;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 34; break; }
    case 12: // $41
      __label__ = 33; break;
    case 13: // $42
      __label__ = 14; break;
    case 14: // $43
      var $44=(($7+628)|0);
      var $45=__ZNK17parsed_expression8is_emptyEv($44);
      if ($45) { __label__ = 26; break; } else { __label__ = 15; break; }
    case 15: // $46
      var $47=(($7+628)|0);
      var $48=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; };
      var $48$0=$48[0];
      var $48$1=$48[1];
    case 16: // $49
      __label__ = 23; break;
    case 17: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $52=$51.f0;
      $4=$52;
      var $53=$51.f1;
      $5=$53;
      __label__ = 18; break;
    case 18: // $54
      var $55=$5;
      var $56=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $57=(($55)|0)==(($56)|0);
      if ($57) { __label__ = 19; break; } else { __label__ = 33; break; }
    case 19: // $58
      var $59=$4;
      var $60=___cxa_begin_catch($59);
      var $61=$60;
      $err1=$61;
      var $62=(($7+628)|0);
      var $63=(function() { try { __THREW__ = false; return __ZNK17parsed_expression15original_stringEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; };
    case 20: // $64
      var $65=$err1;
      var $66=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 24; break; };
    case 21: // $67
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str483442)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$66,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $68
      ___cxa_end_catch();
      __label__ = 23; break;
    case 23: // $69
      __label__ = 26; break;
    case 24: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $4=$72;
      var $73=$71.f1;
      $5=$73;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 34; break; }
    case 25: // $74
      __label__ = 33; break;
    case 26: // $75
      var $76=(($7+1252)|0);
      var $77=__ZN7astringcvbEv($76);
      if ($77) { __label__ = 27; break; } else { __label__ = 32; break; }
    case 27: // $78
      $curarg=0;
      var $79=(($7+1316)|0);
      var $80=__ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5firstEv($79);
      $arg=$80;
      __label__ = 28; break;
    case 28: // $81
      var $82=$arg;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $84
      var $85=$arg;
      var $86=$3;
      var $87=$curarg;
      var $88=(($params+($87<<3))|0);
      var $89=__ZN12cheat_script12script_entry15output_argument6valuesERyPy($85, $86, $88);
      var $90=$curarg;
      var $91=(($90+$89)|0);
      $curarg=$91;
      __label__ = 30; break;
    case 30: // $92
      var $93=$arg;
      var $94=__ZNK12cheat_script12script_entry15output_argument4nextEv($93);
      $arg=$94;
      __label__ = 28; break;
    case 31: // $95
      var $96=$2;
      var $97=(($7+1336)|0);
      var $98=HEAP8[($97)];
      var $99=(($98 << 24) >> 24);
      var $100=(($7+1337)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      var $103=__ZN13cheat_manager18get_output_astringEii($96, $99, $102);
      var $104=(($7+1252)|0);
      var $105=__ZNK7astringcvPKcEv($104);
      var $106=(($params)|0);
      var $st$11$0=(($106)|0);
      var $107$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($106+4)|0);
      var $107$1=HEAP32[(($st$11$1)>>2)];
      var $108$0=$107$0;
      var $108=$108$0;
      var $109=(($params+8)|0);
      var $st$18$0=(($109)|0);
      var $110$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($109+4)|0);
      var $110$1=HEAP32[(($st$18$1)>>2)];
      var $111$0=$110$0;
      var $111=$111$0;
      var $112=(($params+16)|0);
      var $st$25$0=(($112)|0);
      var $113$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($112+4)|0);
      var $113$1=HEAP32[(($st$25$1)>>2)];
      var $114$0=$113$0;
      var $114=$114$0;
      var $115=(($params+24)|0);
      var $st$32$0=(($115)|0);
      var $116$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($115+4)|0);
      var $116$1=HEAP32[(($st$32$1)>>2)];
      var $117$0=$116$0;
      var $117=$117$0;
      var $118=(($params+32)|0);
      var $st$39$0=(($118)|0);
      var $119$0=HEAP32[(($st$39$0)>>2)];
      var $st$39$1=(($118+4)|0);
      var $119$1=HEAP32[(($st$39$1)>>2)];
      var $120$0=$119$0;
      var $120=$120$0;
      var $121=(($params+40)|0);
      var $st$46$0=(($121)|0);
      var $122$0=HEAP32[(($st$46$0)>>2)];
      var $st$46$1=(($121+4)|0);
      var $122$1=HEAP32[(($st$46$1)>>2)];
      var $123$0=$122$0;
      var $123=$123$0;
      var $124=(($params+48)|0);
      var $st$53$0=(($124)|0);
      var $125$0=HEAP32[(($st$53$0)>>2)];
      var $st$53$1=(($124+4)|0);
      var $125$1=HEAP32[(($st$53$1)>>2)];
      var $126$0=$125$0;
      var $126=$126$0;
      var $127=(($params+56)|0);
      var $st$60$0=(($127)|0);
      var $128$0=HEAP32[(($st$60$0)>>2)];
      var $st$60$1=(($127+4)|0);
      var $128$1=HEAP32[(($st$60$1)>>2)];
      var $129$0=$128$0;
      var $129=$129$0;
      var $130=(($params+64)|0);
      var $st$67$0=(($130)|0);
      var $131$0=HEAP32[(($st$67$0)>>2)];
      var $st$67$1=(($130+4)|0);
      var $131$1=HEAP32[(($st$67$1)>>2)];
      var $132$0=$131$0;
      var $132=$132$0;
      var $133=(($params+72)|0);
      var $st$74$0=(($133)|0);
      var $134$0=HEAP32[(($st$74$0)>>2)];
      var $st$74$1=(($133+4)|0);
      var $134$1=HEAP32[(($st$74$1)>>2)];
      var $135$0=$134$0;
      var $135=$135$0;
      var $136=(($params+80)|0);
      var $st$81$0=(($136)|0);
      var $137$0=HEAP32[(($st$81$0)>>2)];
      var $st$81$1=(($136+4)|0);
      var $137$1=HEAP32[(($st$81$1)>>2)];
      var $138$0=$137$0;
      var $138=$138$0;
      var $139=(($params+88)|0);
      var $st$88$0=(($139)|0);
      var $140$0=HEAP32[(($st$88$0)>>2)];
      var $st$88$1=(($139+4)|0);
      var $140$1=HEAP32[(($st$88$1)>>2)];
      var $141$0=$140$0;
      var $141=$141$0;
      var $142=(($params+96)|0);
      var $st$95$0=(($142)|0);
      var $143$0=HEAP32[(($st$95$0)>>2)];
      var $st$95$1=(($142+4)|0);
      var $143$1=HEAP32[(($st$95$1)>>2)];
      var $144$0=$143$0;
      var $144=$144$0;
      var $145=(($params+104)|0);
      var $st$102$0=(($145)|0);
      var $146$0=HEAP32[(($st$102$0)>>2)];
      var $st$102$1=(($145+4)|0);
      var $146$1=HEAP32[(($st$102$1)>>2)];
      var $147$0=$146$0;
      var $147=$147$0;
      var $148=(($params+112)|0);
      var $st$109$0=(($148)|0);
      var $149$0=HEAP32[(($st$109$0)>>2)];
      var $st$109$1=(($148+4)|0);
      var $149$1=HEAP32[(($st$109$1)>>2)];
      var $150$0=$149$0;
      var $150=$150$0;
      var $151=(($params+120)|0);
      var $st$116$0=(($151)|0);
      var $152$0=HEAP32[(($st$116$0)>>2)];
      var $st$116$1=(($151+4)|0);
      var $152$1=HEAP32[(($st$116$1)>>2)];
      var $153$0=$152$0;
      var $153=$153$0;
      var $154=(($params+128)|0);
      var $st$123$0=(($154)|0);
      var $155$0=HEAP32[(($st$123$0)>>2)];
      var $st$123$1=(($154+4)|0);
      var $155$1=HEAP32[(($st$123$1)>>2)];
      var $156$0=$155$0;
      var $156=$156$0;
      var $157=(($params+136)|0);
      var $st$130$0=(($157)|0);
      var $158$0=HEAP32[(($st$130$0)>>2)];
      var $st$130$1=(($157+4)|0);
      var $158$1=HEAP32[(($st$130$1)>>2)];
      var $159$0=$158$0;
      var $159=$159$0;
      var $160=(($params+144)|0);
      var $st$137$0=(($160)|0);
      var $161$0=HEAP32[(($st$137$0)>>2)];
      var $st$137$1=(($160+4)|0);
      var $161$1=HEAP32[(($st$137$1)>>2)];
      var $162$0=$161$0;
      var $162=$162$0;
      var $163=(($params+152)|0);
      var $st$144$0=(($163)|0);
      var $164$0=HEAP32[(($st$144$0)>>2)];
      var $st$144$1=(($163+4)|0);
      var $164$1=HEAP32[(($st$144$1)>>2)];
      var $165$0=$164$0;
      var $165=$165$0;
      var $166=(($params+160)|0);
      var $st$151$0=(($166)|0);
      var $167$0=HEAP32[(($st$151$0)>>2)];
      var $st$151$1=(($166+4)|0);
      var $167$1=HEAP32[(($st$151$1)>>2)];
      var $168$0=$167$0;
      var $168=$168$0;
      var $169=(($params+168)|0);
      var $st$158$0=(($169)|0);
      var $170$0=HEAP32[(($st$158$0)>>2)];
      var $st$158$1=(($169+4)|0);
      var $170$1=HEAP32[(($st$158$1)>>2)];
      var $171$0=$170$0;
      var $171=$171$0;
      var $172=(($params+176)|0);
      var $st$165$0=(($172)|0);
      var $173$0=HEAP32[(($st$165$0)>>2)];
      var $st$165$1=(($172+4)|0);
      var $173$1=HEAP32[(($st$165$1)>>2)];
      var $174$0=$173$0;
      var $174=$174$0;
      var $175=(($params+184)|0);
      var $st$172$0=(($175)|0);
      var $176$0=HEAP32[(($st$172$0)>>2)];
      var $st$172$1=(($175+4)|0);
      var $176$1=HEAP32[(($st$172$1)>>2)];
      var $177$0=$176$0;
      var $177=$177$0;
      var $178=(($params+192)|0);
      var $st$179$0=(($178)|0);
      var $179$0=HEAP32[(($st$179$0)>>2)];
      var $st$179$1=(($178+4)|0);
      var $179$1=HEAP32[(($st$179$1)>>2)];
      var $180$0=$179$0;
      var $180=$180$0;
      var $181=(($params+200)|0);
      var $st$186$0=(($181)|0);
      var $182$0=HEAP32[(($st$186$0)>>2)];
      var $st$186$1=(($181+4)|0);
      var $182$1=HEAP32[(($st$186$1)>>2)];
      var $183$0=$182$0;
      var $183=$183$0;
      var $184=(($params+208)|0);
      var $st$193$0=(($184)|0);
      var $185$0=HEAP32[(($st$193$0)>>2)];
      var $st$193$1=(($184+4)|0);
      var $185$1=HEAP32[(($st$193$1)>>2)];
      var $186$0=$185$0;
      var $186=$186$0;
      var $187=(($params+216)|0);
      var $st$200$0=(($187)|0);
      var $188$0=HEAP32[(($st$200$0)>>2)];
      var $st$200$1=(($187+4)|0);
      var $188$1=HEAP32[(($st$200$1)>>2)];
      var $189$0=$188$0;
      var $189=$189$0;
      var $190=(($params+224)|0);
      var $st$207$0=(($190)|0);
      var $191$0=HEAP32[(($st$207$0)>>2)];
      var $st$207$1=(($190+4)|0);
      var $191$1=HEAP32[(($st$207$1)>>2)];
      var $192$0=$191$0;
      var $192=$192$0;
      var $193=(($params+232)|0);
      var $st$214$0=(($193)|0);
      var $194$0=HEAP32[(($st$214$0)>>2)];
      var $st$214$1=(($193+4)|0);
      var $194$1=HEAP32[(($st$214$1)>>2)];
      var $195$0=$194$0;
      var $195=$195$0;
      var $196=(($params+240)|0);
      var $st$221$0=(($196)|0);
      var $197$0=HEAP32[(($st$221$0)>>2)];
      var $st$221$1=(($196+4)|0);
      var $197$1=HEAP32[(($st$221$1)>>2)];
      var $198$0=$197$0;
      var $198=$198$0;
      var $199=(($params+248)|0);
      var $st$228$0=(($199)|0);
      var $200$0=HEAP32[(($st$228$0)>>2)];
      var $st$228$1=(($199+4)|0);
      var $200$1=HEAP32[(($st$228$1)>>2)];
      var $201$0=$200$0;
      var $201=$201$0;
      var $202=__ZN7astring6printfEPKcz($103, $105, (tempInt=STACKTOP,STACKTOP += 128,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$108,HEAP32[((tempInt+4)>>2)]=$111,HEAP32[((tempInt+8)>>2)]=$114,HEAP32[((tempInt+12)>>2)]=$117,HEAP32[((tempInt+16)>>2)]=$120,HEAP32[((tempInt+20)>>2)]=$123,HEAP32[((tempInt+24)>>2)]=$126,HEAP32[((tempInt+28)>>2)]=$129,HEAP32[((tempInt+32)>>2)]=$132,HEAP32[((tempInt+36)>>2)]=$135,HEAP32[((tempInt+40)>>2)]=$138,HEAP32[((tempInt+44)>>2)]=$141,HEAP32[((tempInt+48)>>2)]=$144,HEAP32[((tempInt+52)>>2)]=$147,HEAP32[((tempInt+56)>>2)]=$150,HEAP32[((tempInt+60)>>2)]=$153,HEAP32[((tempInt+64)>>2)]=$156,HEAP32[((tempInt+68)>>2)]=$159,HEAP32[((tempInt+72)>>2)]=$162,HEAP32[((tempInt+76)>>2)]=$165,HEAP32[((tempInt+80)>>2)]=$168,HEAP32[((tempInt+84)>>2)]=$171,HEAP32[((tempInt+88)>>2)]=$174,HEAP32[((tempInt+92)>>2)]=$177,HEAP32[((tempInt+96)>>2)]=$180,HEAP32[((tempInt+100)>>2)]=$183,HEAP32[((tempInt+104)>>2)]=$186,HEAP32[((tempInt+108)>>2)]=$189,HEAP32[((tempInt+112)>>2)]=$192,HEAP32[((tempInt+116)>>2)]=$195,HEAP32[((tempInt+120)>>2)]=$198,HEAP32[((tempInt+124)>>2)]=$201,tempInt));
      __label__ = 32; break;
    case 32: // $203
      STACKTOP = __stackBase__;
      return;
    case 33: // $204
      var $205=$4;
      var $206=$4;
      var $207=$5;
      var $208=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $206, tempValue);
      var $209=($208.f1 = $207, $208);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 34: // $210
      var $211=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cheat_script12script_entry7executeER13cheat_managerRy["X"]=1;

function __ZNK12cheat_script12script_entry4saveER8emu_file($this, $cheatfile) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tempstring=__stackBase__;
      var $3;
      var $4;
      var $curarg;
      $1=$this;
      $2=$cheatfile;
      var $5=$1;
      __ZN7astringC1Ev($tempstring);
      var $6=(($5+1252)|0);
      var $7=(function() { try { __THREW__ = false; return __ZNK7astringcvbEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $8
      if ($7) { __label__ = 12; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=$2;
      var $11=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($10, ((STRING_TABLE.__str493443)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $12
      var $13=(($5+4)|0);
      var $14=(function() { try { __THREW__ = false; return __ZNK17parsed_expression8is_emptyEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $15
      if ($14) { __label__ = 9; break; } else { __label__ = 5; break; }
    case 5: // $16
      var $17=$2;
      var $18=(($5+4)|0);
      var $19=(function() { try { __THREW__ = false; return __ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression($tempstring, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $20
      var $21=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($17, ((STRING_TABLE.__str503444)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $22
      __label__ = 9; break;
    case 8: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $3=$25;
      var $26=$24.f1;
      $4=$26;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 9: // $27
      var $28=$2;
      var $29=(($5+628)|0);
      var $30=(function() { try { __THREW__ = false; return __ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression($tempstring, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($28, ((STRING_TABLE.__str513445)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$30,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $33
      __label__ = 44; break;
    case 12: // $34
      var $35=$2;
      var $36=(($5+1252)|0);
      var $37=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($35, ((STRING_TABLE.__str523446)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 8; break; };
    case 14: // $40
      var $41=(($5+4)|0);
      var $42=(function() { try { __THREW__ = false; return __ZNK17parsed_expression8is_emptyEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 8; break; };
    case 15: // $43
      if ($42) { __label__ = 19; break; } else { __label__ = 16; break; }
    case 16: // $44
      var $45=$2;
      var $46=(($5+4)|0);
      var $47=(function() { try { __THREW__ = false; return __ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression($tempstring, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; };
    case 17: // $48
      var $49=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($45, ((STRING_TABLE.__str503444)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$47,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 8; break; };
    case 18: // $50
      __label__ = 19; break;
    case 19: // $51
      var $52=(($5+1336)|0);
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24);
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $56
      var $57=$2;
      var $58=(($5+1336)|0);
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $61=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($57, ((STRING_TABLE.__str533447)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$60,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 8; break; };
    case 21: // $62
      __label__ = 22; break;
    case 22: // $63
      var $64=(($5+1337)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=(($66)|0)==1;
      if ($67) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $68
      var $69=$2;
      var $70=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($69, ((STRING_TABLE.__str543448)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 8; break; };
    case 24: // $71
      __label__ = 29; break;
    case 25: // $72
      var $73=(($5+1337)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=(($75)|0)==2;
      if ($76) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $77
      var $78=$2;
      var $79=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($78, ((STRING_TABLE.__str553449)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 8; break; };
    case 27: // $80
      __label__ = 28; break;
    case 28: // $81
      __label__ = 29; break;
    case 29: // $82
      var $83=(($5+1316)|0);
      var $84=(function() { try { __THREW__ = false; return __ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5countEv($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; };
    case 30: // $85
      var $86=(($84)|0)==0;
      if ($86) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $87
      var $88=$2;
      var $89=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($88, ((STRING_TABLE.__str563450)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 8; break; };
    case 32: // $90
      __label__ = 43; break;
    case 33: // $91
      var $92=$2;
      var $93=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($92, ((STRING_TABLE.__str323426)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 8; break; };
    case 34: // $94
      var $95=(($5+1316)|0);
      var $96=(function() { try { __THREW__ = false; return __ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5firstEv($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 8; break; };
    case 35: // $97
      $curarg=$96;
      __label__ = 36; break;
    case 36: // $98
      var $99=$curarg;
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $101
      var $102=$curarg;
      var $103=$2;
      (function() { try { __THREW__ = false; return __ZNK12cheat_script12script_entry15output_argument4saveER8emu_file($102, $103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 8; break; }
    case 38: // $104
      __label__ = 39; break;
    case 39: // $105
      var $106=$curarg;
      var $107=(function() { try { __THREW__ = false; return __ZNK12cheat_script12script_entry15output_argument4nextEv($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 8; break; };
    case 40: // $108
      $curarg=$107;
      __label__ = 36; break;
    case 41: // $109
      var $110=$2;
      var $111=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($110, ((STRING_TABLE.__str573451)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 8; break; };
    case 42: // $112
      __label__ = 43; break;
    case 43: // $113
      __label__ = 44; break;
    case 44: // $114
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 45: // $115
      __label__ = 46; break;
    case 46: // $116
      var $117=$3;
      var $118=$3;
      var $119=$4;
      var $120=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $118, tempValue);
      var $121=($120.f1 = $119, $120);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 47: // $122
      var $123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12cheat_script12script_entry4saveER8emu_file["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6appendERS2_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12cheat_script12script_entry15output_argument5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+628)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  var $5$0=$4$0;
  var $5=$5$0;
  ;
  return $5;
}


function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN12cheat_script12script_entry15output_argumentEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN12cheat_script12script_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb($this, $manager, $symbols, $filename, $entrynode, $isaction) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      var $expression;
      var $format;
      var $align;
      var $totalargs;
      var $argnode;
      var $curarg;
      var $err;
      $9=$this;
      $10=$manager;
      $11=$symbols;
      $12=$filename;
      $13=$entrynode;
      var $17=(($isaction)&1);
      $14=$17;
      var $18=$9;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($18+4)|0);
      var $21=$11;
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($20, $21, 0, 0);
      var $22=(($18+628)|0);
      var $23=$11;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($22, $23, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $24
      var $25=(($18+1252)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $26
      var $27=(($18+1316)|0);
      var $28=$10;
      var $29=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; };
    case 3: // $30
      var $31=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 11; break; };
    case 4: // $32
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entry15output_argumentEEC1ER13resource_pool($27, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $33
      $expression=0;
      var $34=$13;
      var $35=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($34, ((STRING_TABLE.__str343428)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 12; break; };
    case 6: // $36
      $expression=$35;
      var $37=$expression;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $39
      var $40=(($18+4)|0);
      var $41=$expression;
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($40, $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $42
      __label__ = 14; break;
    case 9: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $15=$45;
      var $46=$44.f1;
      $16=$46;
      __label__ = 92; break;
    case 10: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $15=$49;
      var $50=$48.f1;
      $16=$50;
      __label__ = 90; break;
    case 11: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $15=$53;
      var $54=$52.f1;
      $16=$54;
      __label__ = 88; break;
    case 12: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $eh_lpad_body = $56;__label__ = 13; break;
    case 13: // $_body
      var $eh_lpad_body;
      var $57=$eh_lpad_body.f0;
      $15=$57;
      var $58=$eh_lpad_body.f1;
      $16=$58;
      __label__ = 71; break;
    case 14: // $59
      var $60=$14;
      var $61=(($60) & 1);
      if ($61) { __label__ = 15; break; } else { __label__ = 22; break; }
    case 15: // $62
      var $63=$13;
      var $64=(($63+16)|0);
      var $65=HEAP32[(($64)>>2)];
      $expression=$65;
      var $66=$expression;
      var $67=(($66)|0)==0;
      if ($67) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $68
      var $69=$expression;
      var $70=(($69)|0);
      var $71=HEAP8[($70)];
      var $72=(($71 << 24) >> 24);
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $74
      var $75=___cxa_allocate_exception(1032);
      var $76=$75;
      var $77=$12;
      var $78=$13;
      var $79=(($78+24)|0);
      var $80=HEAP32[(($79)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($76, ((STRING_TABLE.__str353429)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$77,HEAP32[((tempInt+4)>>2)]=$80,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $81
      (function() { try { __THREW__ = false; return ___cxa_throw($75, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 12; break; }
    case 19: // $82
      var $83=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $84=$83.f0;
      $15=$84;
      var $85=$83.f1;
      $16=$85;
      ___cxa_free_exception($75);
      __label__ = 71; break;
    case 20: // $86
      var $87=(($18+628)|0);
      var $88=$expression;
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($87, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 12; break; }
    case 21: // $89
      __label__ = 80; break;
    case 22: // $90
      var $91=$13;
      var $92=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($91, ((STRING_TABLE.__str363430)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 12; break; };
    case 23: // $93
      $format=$92;
      var $94=$format;
      var $95=(($94)|0)==0;
      if ($95) { __label__ = 25; break; } else { __label__ = 24; break; }
    case 24: // $96
      var $97=$format;
      var $98=(($97)|0);
      var $99=HEAP8[($98)];
      var $100=(($99 << 24) >> 24);
      var $101=(($100)|0)==0;
      if ($101) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $102
      var $103=___cxa_allocate_exception(1032);
      var $104=$103;
      var $105=$12;
      var $106=$13;
      var $107=(($106+24)|0);
      var $108=HEAP32[(($107)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($104, ((STRING_TABLE.__str373431)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$105,HEAP32[((tempInt+4)>>2)]=$108,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $109
      (function() { try { __THREW__ = false; return ___cxa_throw($103, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 12; break; }
    case 27: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $112=$111.f0;
      $15=$112;
      var $113=$111.f1;
      $16=$113;
      ___cxa_free_exception($103);
      __label__ = 71; break;
    case 28: // $114
      var $115=(($18+1252)|0);
      var $116=$format;
      var $117=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($115, $116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 12; break; };
    case 29: // $118
      var $119=$13;
      var $120=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($119, ((STRING_TABLE.__str383432)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 12; break; };
    case 30: // $121
      var $122=(($120) & 255);
      var $123=(($18+1336)|0);
      HEAP8[($123)]=$122;
      var $124=(($18+1337)|0);
      HEAP8[($124)]=0;
      var $125=$13;
      var $126=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($125, ((STRING_TABLE.__str393433)|0), ((STRING_TABLE.__str403434)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 12; break; };
    case 31: // $127
      $align=$126;
      var $128=$align;
      var $129=(function() { try { __THREW__ = false; return _strcmp($128, ((STRING_TABLE.__str413435)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 12; break; };
    case 32: // $130
      var $131=(($129)|0)==0;
      if ($131) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $132
      var $133=(($18+1337)|0);
      HEAP8[($133)]=1;
      __label__ = 44; break;
    case 34: // $134
      var $135=$align;
      var $136=(function() { try { __THREW__ = false; return _strcmp($135, ((STRING_TABLE.__str423436)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 12; break; };
    case 35: // $137
      var $138=(($136)|0)==0;
      if ($138) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $139
      var $140=(($18+1337)|0);
      HEAP8[($140)]=2;
      __label__ = 43; break;
    case 37: // $141
      var $142=$align;
      var $143=(function() { try { __THREW__ = false; return _strcmp($142, ((STRING_TABLE.__str403434)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 12; break; };
    case 38: // $144
      var $145=(($143)|0)!=0;
      if ($145) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $146
      var $147=___cxa_allocate_exception(1032);
      var $148=$147;
      var $149=$12;
      var $150=$13;
      var $151=(($150+24)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$align;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($148, ((STRING_TABLE.__str433437)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,HEAP32[((tempInt+4)>>2)]=$152,HEAP32[((tempInt+8)>>2)]=$153,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $154
      (function() { try { __THREW__ = false; return ___cxa_throw($147, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 12; break; }
    case 41: // $155
      var $156=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $157=$156.f0;
      $15=$157;
      var $158=$156.f1;
      $16=$158;
      ___cxa_free_exception($147);
      __label__ = 71; break;
    case 42: // $159
      __label__ = 43; break;
    case 43: // $160
      __label__ = 44; break;
    case 44: // $161
      $totalargs=0;
      var $162=$13;
      var $163=(($162+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($164, ((STRING_TABLE.__str443438)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 12; break; };
    case 45: // $166
      $argnode=$165;
      __label__ = 46; break;
    case 46: // $167
      var $168=$argnode;
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 47; break; } else { __label__ = 78; break; }
    case 47: // $170
      var $171=(($18+1316)|0);
      var $172=$10;
      var $173=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 12; break; };
    case 48: // $174
      var $175=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 12; break; };
    case 49: // $176
      var $177=$4;
      var $178=$5;
      var $179=$6;
      var $180=$result_i;
      var $181=$7;
      var $182=$8;
      HEAP32[(($4)>>2)]=636;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($6)>>2)]=479;
      var $183=HEAP32[(($4)>>2)];
      var $184=HEAP32[(($5)>>2)];
      var $185=HEAP32[(($6)>>2)];
      var $186=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($183, $184, $185) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 52; break; };
    case 50: // $187
      HEAP32[(($result_i)>>2)]=$186;
      var $188=HEAP32[(($result_i)>>2)];
      var $189=(($188)|0)==0;
      if ($189) { __label__ = 51; break; } else { __label__ = 57; break; }
    case 51: // $190
      var $191=___cxa_allocate_exception(4);
      var $192=$191;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($192);
      (function() { try { __THREW__ = false; return ___cxa_throw($191, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 52; break; }
    case 52: // $193
      var $194=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $195=$194.f0;
      HEAP32[(($7)>>2)]=$195;
      var $196=$194.f1;
      HEAP32[(($8)>>2)]=$196;
      var $197=HEAP32[(($8)>>2)];
      var $198=(($197)|0) < 0;
      if ($198) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $199
      var $200=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 12; break; }
    case 54: // $_noexc
      throw "Reached an unreachable!"
    case 55: // $201
      var $202=HEAP32[(($7)>>2)];
      var $203=HEAP32[(($7)>>2)];
      var $204=HEAP32[(($8)>>2)];
      var $205=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $203, tempValue);
      var $206=($205.f1 = $204, $205);
      var $eh_lpad_body = $206;__label__ = 13; break;
    case 56: // $207
      throw "Reached an unreachable!"
    case 57: // $_ZnwjPKci_exit
      var $208=HEAP32[(($result_i)>>2)];
      var $209=$4;
      var $210=$5;
      var $211=$6;
      var $212=$result_i;
      var $213=$7;
      var $214=$8;
      __label__ = 58; break;
    case 58: // $215
      var $216=$208;
      var $217=$10;
      var $218=$11;
      var $219=$12;
      var $220=$argnode;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cheat_script12script_entry15output_argumentC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node]($216, $217, $218, $219, $220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 65; break; }
    case 59: // $221
      var $222=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN12cheat_script12script_entry15output_argumentEEEPT_S5_($175, $216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 12; break; };
    case 60: // $223
      var $224=(function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6appendERS2_($171, $222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 12; break; };
    case 61: // $225
      $curarg=$224;
      var $226=$curarg;
      var $227=(function() { try { __THREW__ = false; return __ZNK12cheat_script12script_entry15output_argument5countEv($226) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 12; break; };
    case 62: // $228
      var $229=$totalargs;
      var $230=(($229+$227)|0);
      $totalargs=$230;
      var $231=$totalargs;
      var $232=(($231)|0) > 32;
      if ($232) { __label__ = 63; break; } else { __label__ = 75; break; }
    case 63: // $233
      var $234=___cxa_allocate_exception(1032);
      var $235=$234;
      var $236=$12;
      var $237=$argnode;
      var $238=(($237+24)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$totalargs;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($235, ((STRING_TABLE.__str453439)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$236,HEAP32[((tempInt+4)>>2)]=$239,HEAP32[((tempInt+8)>>2)]=$240,HEAP32[((tempInt+12)>>2)]=32,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 70; break; }
    case 64: // $241
      (function() { try { __THREW__ = false; return ___cxa_throw($234, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 12; break; }
    case 65: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $244=$243.f0;
      $15=$244;
      var $245=$243.f1;
      $16=$245;
      var $246=$1;
      var $247=$2;
      var $248=$3;
      HEAP32[(($1)>>2)]=$208;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($3)>>2)]=479;
      var $249=HEAP32[(($1)>>2)];
      var $250=(($249)|0)!=0;
      if ($250) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $251
      var $252=HEAP32[(($1)>>2)];
      var $253=HEAP32[(($2)>>2)];
      var $254=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($252, $253, $254) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 95; break; }
    case 67: // $_noexc1
      __label__ = 68; break;
    case 68: // $_ZdlPvPKci_exit
      var $255=$1;
      var $256=$2;
      var $257=$3;
      __label__ = 69; break;
    case 69: // $258
      __label__ = 71; break;
    case 70: // $259
      var $260=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $261=$260.f0;
      $15=$261;
      var $262=$260.f1;
      $16=$262;
      ___cxa_free_exception($234);
      __label__ = 71; break;
    case 71: // $263
      var $264=$16;
      var $265=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $266=(($264)|0)==(($265)|0);
      if ($266) { __label__ = 72; break; } else { __label__ = 86; break; }
    case 72: // $267
      var $268=$15;
      var $269=___cxa_begin_catch($268);
      var $270=$269;
      $err=$270;
      var $271=___cxa_allocate_exception(1032);
      var $272=$271;
      var $273=$12;
      var $274=$13;
      var $275=(($274+24)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$expression;
      var $278=$err;
      var $279=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($278) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 81; break; };
    case 73: // $280
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($272, ((STRING_TABLE.__str463440)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$273,HEAP32[((tempInt+4)>>2)]=$276,HEAP32[((tempInt+8)>>2)]=$277,HEAP32[((tempInt+12)>>2)]=$279,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 81; break; }
    case 74: // $281
      (function() { try { __THREW__ = false; return ___cxa_throw($271, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 82; break; }
    case 75: // $282
      __label__ = 76; break;
    case 76: // $283
      var $284=$argnode;
      var $285=(($284)|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($286, ((STRING_TABLE.__str443438)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 12; break; };
    case 77: // $288
      $argnode=$287;
      __label__ = 46; break;
    case 78: // $289
      var $290=$12;
      var $291=$13;
      var $292=(($291+24)|0);
      var $293=HEAP32[(($292)>>2)];
      (function() { try { __THREW__ = false; return __ZN12cheat_script12script_entry15validate_formatEPKci($18, $290, $293) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 12; break; }
    case 79: // $294
      __label__ = 80; break;
    case 80: // $295
      __label__ = 85; break;
    case 81: // $296
      var $297=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $298=$297.f0;
      $15=$298;
      var $299=$297.f1;
      $16=$299;
      ___cxa_free_exception($271);
      __label__ = 83; break;
    case 82: // $300
      var $301=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $302=$301.f0;
      $15=$302;
      var $303=$301.f1;
      $16=$303;
      __label__ = 83; break;
    case 83: // $304
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 95; break; }
    case 84: // $305
      __label__ = 86; break;
    case 85: // $306
      STACKTOP = __stackBase__;
      return;
    case 86: // $307
      var $308=(($18+1316)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED1Ev($308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 95; break; }
    case 87: // $309
      __label__ = 88; break;
    case 88: // $310
      var $311=(($18+1252)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($311) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 95; break; }
    case 89: // $312
      __label__ = 90; break;
    case 90: // $313
      var $314=(($18+628)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($314) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 95; break; }
    case 91: // $315
      __label__ = 92; break;
    case 92: // $316
      var $317=(($18+4)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($317) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 93: // $318
      __label__ = 94; break;
    case 94: // $319
      var $320=$15;
      var $321=$15;
      var $322=$16;
      var $323=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $321, tempValue);
      var $324=($323.f1 = $322, $323);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 95: // $325
      var $326=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 96: // $327
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cheat_script12script_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb["X"]=1;

function __ZN13resource_pool10add_objectIN12cheat_script12script_entry15output_argumentEEEPT_S5_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEEC1EPS2_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN12cheat_script12script_entry15output_argumentEEEPT_S5_["X"]=1;

function __ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12cheat_script12script_entry15output_argument4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13cheat_manager18get_output_astringEii($this, $row, $justify) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$row;
      $3=$justify;
      var $4=$1;
      var $5=$2;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=(($4+3283)|0);
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0) >= 0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=(($4+3283)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15+1)|0);
      var $23 = $16;__label__ = 4; break;
    case 3: // $17
      var $18=(($4+3283)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20-1)|0);
      var $23 = $21;__label__ = 4; break;
    case 4: // $22
      var $23;
      $2=$23;
      __label__ = 5; break;
    case 5: // $24
      var $25=$2;
      var $26=(($25) & 255);
      var $27=(($4+3283)|0);
      HEAP8[($27)]=$26;
      var $28=$2;
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=(($4+3282)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$2;
      var $35=(($33+$34)|0);
      var $40 = $35;__label__ = 8; break;
    case 7: // $36
      var $37=$2;
      var $38=(($37-1)|0);
      var $40 = $38;__label__ = 8; break;
    case 8: // $39
      var $40;
      $2=$40;
      var $41=$2;
      var $42=(($41)|0) > 0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$2;
      var $47 = $44;__label__ = 11; break;
    case 10: // $45
      var $47 = 0;__label__ = 11; break;
    case 11: // $46
      var $47;
      $2=$47;
      var $48=$2;
      var $49=(($4+3282)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=(($51-1)|0);
      var $53=(($48)|0) < (($52)|0);
      if ($53) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $54
      var $55=$2;
      var $62 = $55;__label__ = 14; break;
    case 13: // $56
      var $57=(($4+3282)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=(($59-1)|0);
      var $62 = $60;__label__ = 14; break;
    case 14: // $61
      var $62;
      $2=$62;
      var $63=$3;
      var $64=(($63) & 255);
      var $65=$2;
      var $66=(($4+3232)|0);
      var $67=(($66+$65)|0);
      HEAP8[($67)]=$64;
      var $68=$2;
      var $69=(($4+32)|0);
      var $70=(($69+($68<<6))|0);
      ;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager18get_output_astringEii["X"]=1;

function __ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED2Ev($2);
  ;
  return;
}


function __ZNK17parsed_expression15original_stringEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression($string, $expression) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$string;
  $2=$expression;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK17parsed_expression15original_stringEv($4);
  var $6=__ZN7astring3cpyEPKc($3, $5);
  var $7=$1;
  var $8=__ZN7astring7replaceEiPKcS1_($7, 0, ((STRING_TABLE.__str1043498)|0), ((STRING_TABLE.__str1053499)|0));
  var $9=$1;
  var $10=__ZN7astring7replaceEiPKcS1_($9, 0, ((STRING_TABLE.__str1063500)|0), ((STRING_TABLE.__str1053499)|0));
  var $11=$1;
  var $12=__ZN7astring7replaceEiPKcS1_($11, 0, ((STRING_TABLE.__str1073501)|0), ((STRING_TABLE.__str1053499)|0));
  var $13=$1;
  var $14=__ZN7astring7replaceEiPKcS1_($13, 0, ((STRING_TABLE.__str1083502)|0), ((STRING_TABLE.__str1053499)|0));
  var $15=$1;
  var $16=__ZN7astring7replaceEiPKcS1_($15, 0, ((STRING_TABLE.__str1093503)|0), ((STRING_TABLE.__str1103504)|0));
  var $17=$1;
  var $18=__ZN7astring7replaceEiPKcS1_($17, 0, ((STRING_TABLE.__str1113505)|0), ((STRING_TABLE.__str1103504)|0));
  var $19=$1;
  var $20=__ZN7astring7replaceEiPKcS1_($19, 0, ((STRING_TABLE.__str1123506)|0), ((STRING_TABLE.__str1103504)|0));
  var $21=$1;
  var $22=__ZN7astring7replaceEiPKcS1_($21, 0, ((STRING_TABLE.__str1133507)|0), ((STRING_TABLE.__str1103504)|0));
  var $23=$1;
  var $24=__ZN7astring7replaceEiPKcS1_($23, 0, ((STRING_TABLE.__str1143508)|0), ((STRING_TABLE.__str1153509)|0));
  var $25=$1;
  var $26=__ZN7astring7replaceEiPKcS1_($25, 0, ((STRING_TABLE.__str1163510)|0), ((STRING_TABLE.__str1153509)|0));
  var $27=$1;
  var $28=__ZN7astring7replaceEiPKcS1_($27, 0, ((STRING_TABLE.__str1173511)|0), ((STRING_TABLE.__str1153509)|0));
  var $29=$1;
  var $30=__ZN7astring7replaceEiPKcS1_($29, 0, ((STRING_TABLE.__str1183512)|0), ((STRING_TABLE.__str1153509)|0));
  var $31=$1;
  var $32=__ZN7astring7replaceEiPKcS1_($31, 0, ((STRING_TABLE.__str1193513)|0), ((STRING_TABLE.__str1203514)|0));
  var $33=$1;
  var $34=__ZN7astring7replaceEiPKcS1_($33, 0, ((STRING_TABLE.__str1213515)|0), ((STRING_TABLE.__str1203514)|0));
  var $35=$1;
  var $36=__ZN7astring7replaceEiPKcS1_($35, 0, ((STRING_TABLE.__str1223516)|0), ((STRING_TABLE.__str1203514)|0));
  var $37=$1;
  var $38=__ZN7astring7replaceEiPKcS1_($37, 0, ((STRING_TABLE.__str1233517)|0), ((STRING_TABLE.__str1203514)|0));
  var $39=$1;
  var $40=__ZN7astring7replaceEiPKcS1_($39, 0, ((STRING_TABLE.__str1243518)|0), ((STRING_TABLE.__str1253519)|0));
  var $41=$1;
  var $42=__ZN7astring7replaceEiPKcS1_($41, 0, ((STRING_TABLE.__str1263520)|0), ((STRING_TABLE.__str1253519)|0));
  var $43=$1;
  var $44=__ZN7astring7replaceEiPKcS1_($43, 0, ((STRING_TABLE.__str1273521)|0), ((STRING_TABLE.__str1253519)|0));
  var $45=$1;
  var $46=__ZN7astring7replaceEiPKcS1_($45, 0, ((STRING_TABLE.__str1283522)|0), ((STRING_TABLE.__str1253519)|0));
  var $47=$1;
  var $48=__ZNK7astringcvPKcEv($47);
  ;
  return $48;
}
__ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression["X"]=1;

function __ZN12cheat_script12script_entry15validate_formatEPKci($this, $filename, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $argsprovided;
      var $curarg;
      var $p;
      var $argscounted;
      var $4;
      var $5;
      $1=$this;
      $2=$filename;
      $3=$line;
      var $6=$1;
      $argsprovided=0;
      var $7=(($6+1316)|0);
      var $8=__ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5firstEv($7);
      $curarg=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$curarg;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$curarg;
      var $14=__ZNK12cheat_script12script_entry15output_argument5countEv($13);
      var $15=$argsprovided;
      var $16=(($15+$14)|0);
      $argsprovided=$16;
      __label__ = 3; break;
    case 3: // $17
      var $18=$curarg;
      var $19=__ZNK12cheat_script12script_entry15output_argument4nextEv($18);
      $curarg=$19;
      __label__ = 1; break;
    case 4: // $20
      var $21=(($6+1252)|0);
      var $22=__ZNK7astringcvPKcEv($21);
      var $23=_strchr($22, 37);
      $p=$23;
      $argscounted=0;
      __label__ = 5; break;
    case 5: // $24
      var $25=$p;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $27
      var $28=$p;
      var $29=(($28+1)|0);
      $p=$29;
      __label__ = 7; break;
    case 7: // $30
      var $31=$p;
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=_strchr(((STRING_TABLE.__str583452)|0), $33);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $36
      var $37=$p;
      var $38=(($37+1)|0);
      $p=$38;
      __label__ = 7; break;
    case 9: // $39
      var $40=$p;
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $43=_strchr(((STRING_TABLE.__str593453)|0), $42);
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $45
      var $46=___cxa_allocate_exception(1032);
      var $47=$46;
      var $48=$2;
      var $49=$3;
      var $50=(($6+1252)|0);
      var $51=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $52
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($47, ((STRING_TABLE.__str603454)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$48,HEAP32[((tempInt+4)>>2)]=$49,HEAP32[((tempInt+8)>>2)]=$51,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $53
      ___cxa_throw($46, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 13: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      $4=$56;
      var $57=$55.f1;
      $5=$57;
      ___cxa_free_exception($46);
      __label__ = 26; break;
    case 14: // $58
      var $59=$argscounted;
      var $60=(($59+1)|0);
      $argscounted=$60;
      var $61=$p;
      var $62=_strchr($61, 37);
      $p=$62;
      __label__ = 5; break;
    case 15: // $63
      var $64=$argscounted;
      var $65=$argsprovided;
      var $66=(($64)|0) < (($65)|0);
      if ($66) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $67
      var $68=___cxa_allocate_exception(1032);
      var $69=$68;
      var $70=$2;
      var $71=$3;
      var $72=$argsprovided;
      var $73=(($6+1252)|0);
      var $74=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $75
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($69, ((STRING_TABLE.__str613455)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$70,HEAP32[((tempInt+4)>>2)]=$71,HEAP32[((tempInt+8)>>2)]=$72,HEAP32[((tempInt+12)>>2)]=$74,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $76
      ___cxa_throw($68, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 19: // $77
      var $78=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $79=$78.f0;
      $4=$79;
      var $80=$78.f1;
      $5=$80;
      ___cxa_free_exception($68);
      __label__ = 26; break;
    case 20: // $81
      var $82=$argscounted;
      var $83=$argsprovided;
      var $84=(($82)|0) > (($83)|0);
      if ($84) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $85
      var $86=___cxa_allocate_exception(1032);
      var $87=$86;
      var $88=$2;
      var $89=$3;
      var $90=$argsprovided;
      var $91=(($6+1252)|0);
      var $92=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; };
    case 22: // $93
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($87, ((STRING_TABLE.__str623456)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$88,HEAP32[((tempInt+4)>>2)]=$89,HEAP32[((tempInt+8)>>2)]=$90,HEAP32[((tempInt+12)>>2)]=$92,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $94
      ___cxa_throw($86, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 24: // $95
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $97=$96.f0;
      $4=$97;
      var $98=$96.f1;
      $5=$98;
      ___cxa_free_exception($86);
      __label__ = 26; break;
    case 25: // $99
      ;
      return;
    case 26: // $100
      var $101=$4;
      var $102=$4;
      var $103=$5;
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cheat_script12script_entry15validate_formatEPKci["X"]=1;

function __ZN12cheat_script12script_entry15output_argument6valuesERyPy($this, $argindex, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $err;
      $1=$this;
      $2=$argindex;
      $3=$result;
      var $6=$1;
      var $7=$2;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$13$0=(($7)|0);
      HEAP32[(($st$13$0)>>2)]=$$emscripten$temp$0$0;
      var $st$13$1=(($7+4)|0);
      HEAP32[(($st$13$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 1; break;
    case 1: // $8
      var $9=$2;
      var $st$1$0=(($9)|0);
      var $10$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$1$1)>>2)];
      var $11=(($6+628)|0);
      var $st$6$0=(($11)|0);
      var $12$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$6$1)>>2)];
      var $13=$10$1 < $12$1 || ($10$1 == $12$1 && $10$0 < $12$0);
      if ($13) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $14
      var $15=(($6+4)|0);
      var $16=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
      var $16$0=$16[0];
      var $16$1=$16[1];
    case 3: // $17
      var $18=$2;
      var $st$1$0=(($18)|0);
      var $19$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$1$1)>>2)];
      var $20$0=$19$0;
      var $20=$20$0;
      var $21=$3;
      var $22=(($21+($20<<3))|0);
      var $st$9$0=(($22)|0);
      HEAP32[(($st$9$0)>>2)]=$16$0;
      var $st$9$1=(($22+4)|0);
      HEAP32[(($st$9$1)>>2)]=$16$1;
      __label__ = 10; break;
    case 4: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      __label__ = 5; break;
    case 5: // $27
      var $28=$5;
      var $29=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $30=(($28)|0)==(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $31
      var $32=$4;
      var $33=___cxa_begin_catch($32);
      var $34=$33;
      $err=$34;
      var $35=(($6+4)|0);
      var $36=(function() { try { __THREW__ = false; return __ZNK17parsed_expression15original_stringEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; };
    case 7: // $37
      var $38=$err;
      var $39=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $40
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str653459)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,HEAP32[((tempInt+4)>>2)]=$39,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $41
      ___cxa_end_catch();
      __label__ = 10; break;
    case 10: // $42
      __label__ = 11; break;
    case 11: // $43
      var $44=$2;
      var $st$1$0=(($44)|0);
      var $45$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($44+4)|0);
      var $45$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $46$0 = ((($45$0)>>>0)+((($45$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $46$1 = Math.min(Math.floor((((($45$0)>>>0)+((($45$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($44)|0);
      HEAP32[(($st$8$0)>>2)]=$46$0;
      var $st$8$1=(($44+4)|0);
      HEAP32[(($st$8$1)>>2)]=$46$1;
      __label__ = 1; break;
    case 12: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $4=$49;
      var $50=$48.f1;
      $5=$50;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $51
      __label__ = 15; break;
    case 14: // $52
      var $53=(($6+628)|0);
      var $st$1$0=(($53)|0);
      var $54$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($53+4)|0);
      var $54$1=HEAP32[(($st$1$1)>>2)];
      var $55$0=$54$0;
      var $55=$55$0;
      ;
      return $55;
    case 15: // $56
      var $57=$4;
      var $58=$4;
      var $59=$5;
      var $60=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $58, tempValue);
      var $61=($60.f1 = $59, $60);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cheat_script12script_entry15output_argument6valuesERyPy["X"]=1;

function __ZNK12cheat_script12script_entry15output_argument4saveER8emu_file($this, $cheatfile) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tempstring=__stackBase__;
      var $3;
      var $4;
      $1=$this;
      $2=$cheatfile;
      var $5=$1;
      __ZN7astringC1Ev($tempstring);
      var $6=$2;
      var $7=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($6, ((STRING_TABLE.__str663460)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $8
      var $9=(($5+628)|0);
      var $st$1$0=(($9)|0);
      var $10$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $11=$10$0 != $$emscripten$temp$0$0 || $10$1 != $$emscripten$temp$0$1;
      if ($11) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $12
      var $13=$2;
      var $14=(($5+628)|0);
      var $st$2$0=(($14)|0);
      var $15$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$2$1)>>2)];
      var $16$0=$15$0;
      var $16=$16$0;
      var $17=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($13, ((STRING_TABLE.__str673461)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $18
      __label__ = 5; break;
    case 4: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $3=$21;
      var $22=$20.f1;
      $4=$22;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 5: // $23
      var $24=$2;
      var $25=(($5+4)|0);
      var $26=(function() { try { __THREW__ = false; return __ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression($tempstring, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 4; break; };
    case 6: // $27
      var $28=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($24, ((STRING_TABLE.__str683462)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $29
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 8: // $30
      __label__ = 9; break;
    case 9: // $31
      var $32=$3;
      var $33=$3;
      var $34=$4;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12cheat_script12script_entry15output_argument4saveER8emu_file["X"]=1;

function __ZN12cheat_script12script_entry15output_argumentC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node($this, $manager, $symbols, $filename, $argnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $expression;
      var $err;
      $1=$this;
      $2=$manager;
      $3=$symbols;
      $4=$filename;
      $5=$argnode;
      var $8=$1;
      var $9=(($8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($8+4)|0);
      var $11=$3;
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($10, $11, 0, 0);
      var $12=(($8+628)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$23$0=(($12)|0);
      HEAP32[(($st$23$0)>>2)]=$$emscripten$temp$0$0;
      var $st$23$1=(($12+4)|0);
      HEAP32[(($st$23$1)>>2)]=$$emscripten$temp$0$1;
      var $13=$5;
      var $14=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($13, ((STRING_TABLE.__str633457)|0), 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $15
      var $16$0=$14;
      var $16$1=(($14|0) < 0 ? -1 : 0);
      var $17=(($8+628)|0);
      var $st$3$0=(($17)|0);
      HEAP32[(($st$3$0)>>2)]=$16$0;
      var $st$3$1=(($17+4)|0);
      HEAP32[(($st$3$1)>>2)]=$16$1;
      var $18=$5;
      var $19=(($18+16)|0);
      var $20=HEAP32[(($19)>>2)];
      $expression=$20;
      var $21=$expression;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $23
      var $24=$expression;
      var $25=(($24)|0);
      var $26=HEAP8[($25)];
      var $27=(($26 << 24) >> 24);
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $29
      var $30=___cxa_allocate_exception(1032);
      var $31=$30;
      var $32=$4;
      var $33=$5;
      var $34=(($33+24)|0);
      var $35=HEAP32[(($34)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($31, ((STRING_TABLE.__str643458)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,HEAP32[((tempInt+4)>>2)]=$35,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $36
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 5; break; }
    case 5: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $6=$39;
      var $40=$38.f1;
      $7=$40;
      __label__ = 19; break;
    case 6: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      $6=$43;
      var $44=$42.f1;
      $7=$44;
      ___cxa_free_exception($30);
      __label__ = 19; break;
    case 7: // $45
      var $46=(($8+4)|0);
      var $47=$expression;
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      __label__ = 18; break;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $51=$50.f0;
      $6=$51;
      var $52=$50.f1;
      $7=$52;
      __label__ = 10; break;
    case 10: // $53
      var $54=$7;
      var $55=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $56=(($54)|0)==(($55)|0);
      if ($56) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $57
      var $58=$6;
      var $59=___cxa_begin_catch($58);
      var $60=$59;
      $err=$60;
      var $61=___cxa_allocate_exception(1032);
      var $62=$61;
      var $63=$4;
      var $64=$5;
      var $65=(($64+24)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$expression;
      var $68=$err;
      var $69=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $70
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($62, ((STRING_TABLE.__str463440)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$66,HEAP32[((tempInt+8)>>2)]=$67,HEAP32[((tempInt+12)>>2)]=$69,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $71
      (function() { try { __THREW__ = false; return ___cxa_throw($61, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; }
    case 14: // $72
      var $73=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $74=$73.f0;
      $6=$74;
      var $75=$73.f1;
      $7=$75;
      ___cxa_free_exception($61);
      __label__ = 16; break;
    case 15: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $6=$78;
      var $79=$77.f1;
      $7=$79;
      __label__ = 16; break;
    case 16: // $80
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $81
      __label__ = 19; break;
    case 18: // $82
      ;
      return;
    case 19: // $83
      var $84=(($8+4)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $85
      __label__ = 21; break;
    case 21: // $86
      var $87=$6;
      var $88=$6;
      var $89=$7;
      var $90=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $88, tempValue);
      var $91=($90.f1 = $89, $90);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 23: // $94
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12cheat_script12script_entry15output_argumentC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node["X"]=1;

function __ZN11cheat_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node($this, $manager, $globaltable, $filename, $cheatnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $tempcount;
      var $description;
      var $tempname=__stackBase__+72;
      var $curtemp;
      var $commentnode;
      var $paramnode;
      var $scriptnode;
      var $curscript;
      var $slot;
      var $24;
      $17=$this;
      $18=$manager;
      $19=$globaltable;
      $20=$filename;
      $21=$cheatnode;
      var $25=$17;
      var $26=(($25)|0);
      var $27=$18;
      HEAP32[(($26)>>2)]=$27;
      var $28=(($25+4)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($25+8)|0);
      __ZN7astringC1Ev($29);
      var $30=(($25+72)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $31
      var $32=(($25+136)|0);
      HEAP32[(($32)>>2)]=0;
      var $33=(($25+140)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=(($25+144)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=(($25+148)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=(($25+152)|0);
      HEAP32[(($36)>>2)]=0;
      var $37=(($25+156)|0);
      var $38=$18;
      var $39=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $40
      var $41=$39;
      var $42=$19;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12symbol_tableC1EPvPS_]($37, $41, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $43
      var $44=(($25+588)|0);
      HEAP32[(($44)>>2)]=0;
      var $45=(($25+592)|0);
      HEAP32[(($45)>>2)]=10;
      var $46=(($25+596)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$7$0=(($46)|0);
      HEAP32[(($st$7$0)>>2)]=$$emscripten$temp$0$0;
      var $st$7$1=(($46+4)|0);
      HEAP32[(($st$7$1)>>2)]=$$emscripten$temp$0$1;
      var $47=$21;
      var $48=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($47, ((STRING_TABLE.__str693463)|0), 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; };
    case 4: // $49
      $tempcount=$48;
      var $50=$tempcount;
      var $51=(($50)|0) < 1;
      if ($51) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $52
      var $53=___cxa_allocate_exception(1032);
      var $54=$53;
      var $55=$20;
      var $56=$21;
      var $57=(($56+24)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$tempcount;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($54, ((STRING_TABLE.__str703464)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,HEAP32[((tempInt+4)>>2)]=$58,HEAP32[((tempInt+8)>>2)]=$59,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $60
      (function() { try { __THREW__ = false; return ___cxa_throw($53, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 9; break; }
    case 7: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $22=$63;
      var $64=$62.f1;
      $23=$64;
      __label__ = 110; break;
    case 8: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      $22=$67;
      var $68=$66.f1;
      $23=$68;
      __label__ = 108; break;
    case 9: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $71=$70.f0;
      $22=$71;
      var $72=$70.f1;
      $23=$72;
      __label__ = 100; break;
    case 10: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $75=$74.f0;
      $22=$75;
      var $76=$74.f1;
      $23=$76;
      ___cxa_free_exception($53);
      __label__ = 100; break;
    case 11: // $77
      var $78=$tempcount;
      var $79=(($25+592)|0);
      HEAP32[(($79)>>2)]=$78;
      var $80=$21;
      var $81=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($80, ((STRING_TABLE.__str713465)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $82
      $description=$81;
      var $83=$description;
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $85
      var $86=$description;
      var $87=(($86)|0);
      var $88=HEAP8[($87)];
      var $89=(($88 << 24) >> 24);
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $91
      var $92=___cxa_allocate_exception(1032);
      var $93=$92;
      var $94=$20;
      var $95=$21;
      var $96=(($95+24)|0);
      var $97=HEAP32[(($96)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($93, ((STRING_TABLE.__str723466)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$94,HEAP32[((tempInt+4)>>2)]=$97,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $98
      (function() { try { __THREW__ = false; return ___cxa_throw($92, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 9; break; }
    case 16: // $99
      var $100=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $101=$100.f0;
      $22=$101;
      var $102=$100.f1;
      $23=$102;
      ___cxa_free_exception($92);
      __label__ = 100; break;
    case 17: // $103
      var $104=(($25+8)|0);
      var $105=$description;
      var $106=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($104, $105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
    case 18: // $107
      var $108=(($25+156)|0);
      var $109=(($25+596)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcNS_10read_writeEPy($108, ((STRING_TABLE.__str733467)|0), 0, $109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 9; break; }
    case 19: // $110
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 9; break; }
    case 20: // $111
      $curtemp=0;
      __label__ = 21; break;
    case 21: // $112
      var $113=$curtemp;
      var $114=$tempcount;
      var $115=(($113)|0) < (($114)|0);
      if ($115) { __label__ = 22; break; } else { __label__ = 30; break; }
    case 22: // $116
      var $117=(($25+156)|0);
      var $118=$curtemp;
      var $119=(function() { try { __THREW__ = false; return __ZN7astring6formatEPKcz($tempname, ((STRING_TABLE.__str743468)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$118,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 27; break; };
    case 23: // $120
      var $121=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 27; break; };
    case 24: // $122
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcNS_10read_writeEPy($117, $121, 1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $123
      __label__ = 26; break;
    case 26: // $124
      var $125=$curtemp;
      var $126=(($125+1)|0);
      $curtemp=$126;
      __label__ = 21; break;
    case 27: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $eh_lpad_body5 = $128;__label__ = 28; break;
    case 28: // $_body4
      var $eh_lpad_body5;
      var $eh_lpad_body = $eh_lpad_body5;__label__ = 29; break;
    case 29: // $_body
      var $eh_lpad_body;
      var $129=$eh_lpad_body.f0;
      $22=$129;
      var $130=$eh_lpad_body.f1;
      $23=$130;
      __label__ = 98; break;
    case 30: // $131
      var $132=$21;
      var $133=(($132+8)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($134, ((STRING_TABLE.__str753469)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 27; break; };
    case 31: // $136
      $commentnode=$135;
      var $137=$commentnode;
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 32; break; } else { __label__ = 41; break; }
    case 32: // $139
      var $140=$commentnode;
      var $141=(($140+16)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 33; break; } else { __label__ = 36; break; }
    case 33: // $144
      var $145=$commentnode;
      var $146=(($145+16)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147)|0);
      var $149=HEAP8[($148)];
      var $150=(($149 << 24) >> 24);
      var $151=(($150)|0)!=0;
      if ($151) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $152
      var $153=(($25+72)|0);
      var $154=$commentnode;
      var $155=(($154+16)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($153, $156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 27; break; };
    case 35: // $158
      __label__ = 36; break;
    case 36: // $159
      var $160=$commentnode;
      var $161=(($160)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($162, ((STRING_TABLE.__str753469)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 27; break; };
    case 37: // $164
      $commentnode=$163;
      var $165=$commentnode;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $167
      var $168=$20;
      var $169=$commentnode;
      var $170=(($169+24)|0);
      var $171=HEAP32[(($170)>>2)];
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str763470)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$168,HEAP32[((tempInt+4)>>2)]=$171,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 27; break; }
    case 39: // $172
      __label__ = 40; break;
    case 40: // $173
      __label__ = 41; break;
    case 41: // $174
      var $175=$21;
      var $176=(($175+8)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($177, ((STRING_TABLE.__str773471)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 27; break; };
    case 42: // $179
      $paramnode=$178;
      var $180=$paramnode;
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 43; break; } else { __label__ = 66; break; }
    case 43: // $182
      var $183=$18;
      var $184=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 27; break; };
    case 44: // $185
      var $186=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 27; break; };
    case 45: // $187
      var $188=$12;
      var $189=$13;
      var $190=$14;
      var $191=$result_i;
      var $192=$15;
      var $193=$16;
      HEAP32[(($12)>>2)]=128;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($14)>>2)]=769;
      var $194=HEAP32[(($12)>>2)];
      var $195=HEAP32[(($13)>>2)];
      var $196=HEAP32[(($14)>>2)];
      var $197=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($194, $195, $196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 48; break; };
    case 46: // $198
      HEAP32[(($result_i)>>2)]=$197;
      var $199=HEAP32[(($result_i)>>2)];
      var $200=(($199)|0)==0;
      if ($200) { __label__ = 47; break; } else { __label__ = 53; break; }
    case 47: // $201
      var $202=___cxa_allocate_exception(4);
      var $203=$202;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($203);
      (function() { try { __THREW__ = false; return ___cxa_throw($202, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 48; break; }
    case 48: // $204
      var $205=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $206=$205.f0;
      HEAP32[(($15)>>2)]=$206;
      var $207=$205.f1;
      HEAP32[(($16)>>2)]=$207;
      var $208=HEAP32[(($16)>>2)];
      var $209=(($208)|0) < 0;
      if ($209) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $210
      var $211=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 27; break; }
    case 50: // $_noexc
      throw "Reached an unreachable!"
    case 51: // $212
      var $213=HEAP32[(($15)>>2)];
      var $214=HEAP32[(($15)>>2)];
      var $215=HEAP32[(($16)>>2)];
      var $216=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $214, tempValue);
      var $217=($216.f1 = $215, $216);
      var $eh_lpad_body = $217;__label__ = 29; break;
    case 52: // $218
      throw "Reached an unreachable!"
    case 53: // $_ZnwjPKci_exit
      var $219=HEAP32[(($result_i)>>2)];
      var $220=$12;
      var $221=$13;
      var $222=$14;
      var $223=$result_i;
      var $224=$15;
      var $225=$16;
      __label__ = 54; break;
    case 54: // $226
      var $227=$219;
      var $228=$18;
      var $229=(($25+156)|0);
      var $230=$20;
      var $231=$paramnode;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15cheat_parameterC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node]($227, $228, $229, $230, $231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 60; break; }
    case 55: // $232
      var $233=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI15cheat_parameterEEPT_S3_($186, $227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 27; break; };
    case 56: // $234
      var $235=(($25+136)|0);
      HEAP32[(($235)>>2)]=$233;
      var $236=$paramnode;
      var $237=(($236)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($238, ((STRING_TABLE.__str773471)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 27; break; };
    case 57: // $240
      $paramnode=$239;
      var $241=$paramnode;
      var $242=(($241)|0)!=0;
      if ($242) { __label__ = 58; break; } else { __label__ = 65; break; }
    case 58: // $243
      var $244=$20;
      var $245=$paramnode;
      var $246=(($245+24)|0);
      var $247=HEAP32[(($246)>>2)];
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str783472)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$244,HEAP32[((tempInt+4)>>2)]=$247,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 27; break; }
    case 59: // $248
      __label__ = 65; break;
    case 60: // $249
      var $250=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $251=$250.f0;
      $22=$251;
      var $252=$250.f1;
      $23=$252;
      var $253=$9;
      var $254=$10;
      var $255=$11;
      HEAP32[(($9)>>2)]=$219;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($11)>>2)]=769;
      var $256=HEAP32[(($9)>>2)];
      var $257=(($256)|0)!=0;
      if ($257) { __label__ = 61; break; } else { __label__ = 63; break; }
    case 61: // $258
      var $259=HEAP32[(($9)>>2)];
      var $260=HEAP32[(($10)>>2)];
      var $261=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($259, $260, $261) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 113; break; }
    case 62: // $_noexc1
      __label__ = 63; break;
    case 63: // $_ZdlPvPKci_exit
      var $262=$9;
      var $263=$10;
      var $264=$11;
      __label__ = 64; break;
    case 64: // $265
      __label__ = 98; break;
    case 65: // $266
      __label__ = 66; break;
    case 66: // $267
      var $268=$21;
      var $269=(($268+8)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($270, ((STRING_TABLE.__str793473)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 27; break; };
    case 67: // $272
      $scriptnode=$271;
      __label__ = 68; break;
    case 68: // $273
      var $274=$scriptnode;
      var $275=(($274)|0)!=0;
      if ($275) { __label__ = 69; break; } else { __label__ = 96; break; }
    case 69: // $276
      var $277=$18;
      var $278=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 27; break; };
    case 70: // $279
      var $280=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($278) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 27; break; };
    case 71: // $281
      var $282=$4;
      var $283=$5;
      var $284=$6;
      var $285=$result_i2;
      var $286=$7;
      var $287=$8;
      HEAP32[(($4)>>2)]=24;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($6)>>2)]=781;
      var $288=HEAP32[(($4)>>2)];
      var $289=HEAP32[(($5)>>2)];
      var $290=HEAP32[(($6)>>2)];
      var $291=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($288, $289, $290) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 74; break; };
    case 72: // $292
      HEAP32[(($result_i2)>>2)]=$291;
      var $293=HEAP32[(($result_i2)>>2)];
      var $294=(($293)|0)==0;
      if ($294) { __label__ = 73; break; } else { __label__ = 79; break; }
    case 73: // $295
      var $296=___cxa_allocate_exception(4);
      var $297=$296;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($297);
      (function() { try { __THREW__ = false; return ___cxa_throw($296, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 74; break; }
    case 74: // $298
      var $299=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $300=$299.f0;
      HEAP32[(($7)>>2)]=$300;
      var $301=$299.f1;
      HEAP32[(($8)>>2)]=$301;
      var $302=HEAP32[(($8)>>2)];
      var $303=(($302)|0) < 0;
      if ($303) { __label__ = 75; break; } else { __label__ = 77; break; }
    case 75: // $304
      var $305=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($305) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 27; break; }
    case 76: // $_noexc3
      throw "Reached an unreachable!"
    case 77: // $306
      var $307=HEAP32[(($7)>>2)];
      var $308=HEAP32[(($7)>>2)];
      var $309=HEAP32[(($8)>>2)];
      var $310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $308, tempValue);
      var $311=($310.f1 = $309, $310);
      var $eh_lpad_body5 = $311;__label__ = 28; break;
    case 78: // $312
      throw "Reached an unreachable!"
    case 79: // $_ZnwjPKci_exit6
      var $313=HEAP32[(($result_i2)>>2)];
      var $314=$4;
      var $315=$5;
      var $316=$6;
      var $317=$result_i2;
      var $318=$7;
      var $319=$8;
      __label__ = 80; break;
    case 80: // $320
      var $321=$313;
      var $322=$18;
      var $323=(($25+156)|0);
      var $324=$20;
      var $325=$scriptnode;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12cheat_scriptC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node]($321, $322, $323, $324, $325) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 87; break; }
    case 81: // $326
      var $327=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI12cheat_scriptEEPT_S3_($280, $321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 27; break; };
    case 82: // $328
      $curscript=$327;
      var $329=$curscript;
      var $330=(function() { try { __THREW__ = false; return __ZNK12cheat_script5stateEv($329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 27; break; };
    case 83: // $331
      var $332=(function() { try { __THREW__ = false; return __ZN11cheat_entry16script_for_stateE12script_state($25, $330) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 27; break; };
    case 84: // $333
      $slot=$332;
      var $334=$slot;
      var $335=HEAP32[(($334)>>2)];
      var $336=(($335)|0)!=0;
      if ($336) { __label__ = 85; break; } else { __label__ = 92; break; }
    case 85: // $337
      var $338=$20;
      var $339=$scriptnode;
      var $340=(($339+24)|0);
      var $341=HEAP32[(($340)>>2)];
      (function() { try { __THREW__ = false; return __Z19mame_printf_warningPKcz(((STRING_TABLE.__str803474)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$338,HEAP32[((tempInt+4)>>2)]=$341,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 27; break; }
    case 86: // $342
      __label__ = 93; break;
    case 87: // $343
      var $344=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $345=$344.f0;
      $22=$345;
      var $346=$344.f1;
      $23=$346;
      var $347=$1;
      var $348=$2;
      var $349=$3;
      HEAP32[(($1)>>2)]=$313;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($3)>>2)]=781;
      var $350=HEAP32[(($1)>>2)];
      var $351=(($350)|0)!=0;
      if ($351) { __label__ = 88; break; } else { __label__ = 90; break; }
    case 88: // $352
      var $353=HEAP32[(($1)>>2)];
      var $354=HEAP32[(($2)>>2)];
      var $355=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($353, $354, $355) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 113; break; }
    case 89: // $_noexc7
      __label__ = 90; break;
    case 90: // $_ZdlPvPKci_exit8
      var $356=$1;
      var $357=$2;
      var $358=$3;
      __label__ = 91; break;
    case 91: // $359
      __label__ = 98; break;
    case 92: // $360
      var $361=$curscript;
      var $362=$slot;
      HEAP32[(($362)>>2)]=$361;
      __label__ = 93; break;
    case 93: // $363
      __label__ = 94; break;
    case 94: // $364
      var $365=$scriptnode;
      var $366=(($365)|0);
      var $367=HEAP32[(($366)>>2)];
      var $368=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($367, ((STRING_TABLE.__str793473)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 27; break; };
    case 95: // $369
      $scriptnode=$368;
      __label__ = 68; break;
    case 96: // $370
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 9; break; }
    case 97: // $371
      __label__ = 105; break;
    case 98: // $372
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 113; break; }
    case 99: // $373
      __label__ = 100; break;
    case 100: // $374
      var $375=$23;
      var $376=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $377=(($375)|0)==(($376)|0);
      if ($377) { __label__ = 101; break; } else { __label__ = 106; break; }
    case 101: // $378
      var $379=$22;
      var $380=___cxa_begin_catch($379);
      var $381=$380;
      $24=$381;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11cheat_entryD1Ev]($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 103; break; }
    case 102: // $382
      (function() { try { __THREW__ = false; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 103; break; }
    case 103: // $383
      var $384=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $385=$384.f0;
      $22=$385;
      var $386=$384.f1;
      $23=$386;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 113; break; }
    case 104: // $387
      __label__ = 106; break;
    case 105: // $388
      STACKTOP = __stackBase__;
      return;
    case 106: // $389
      var $390=(($25+156)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($390) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 113; break; }
    case 107: // $391
      __label__ = 108; break;
    case 108: // $392
      var $393=(($25+72)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($393) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 113; break; }
    case 109: // $394
      __label__ = 110; break;
    case 110: // $395
      var $396=(($25+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 113; break; }
    case 111: // $397
      __label__ = 112; break;
    case 112: // $398
      var $399=$22;
      var $400=$22;
      var $401=$23;
      var $402=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $400, tempValue);
      var $403=($402.f1 = $401, $402);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 113: // $404
      var $405=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 114: // $406
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11cheat_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node["X"]=1;

function __ZN13resource_pool10add_objectI15cheat_parameterEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI15cheat_parameterEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI15cheat_parameterEEPT_S3_["X"]=1;

function __ZN11cheat_entry16script_for_stateE12script_state($this, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$state;
      var $4=$2;
      var $5=$3;
      if ($5 == 1) {
        __label__ = 1; break;
      }
      else if ($5 == 0) {
        __label__ = 2; break;
      }
      else if ($5 == 3) {
        __label__ = 3; break;
      }
      else if ($5 == 2) {
        __label__ = 5; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $6
      var $7=(($4+140)|0);
      $1=$7;
      __label__ = 6; break;
    case 2: // $8
      var $9=(($4+144)|0);
      $1=$9;
      __label__ = 6; break;
    case 3: // $10
      var $11=(($4+148)|0);
      $1=$11;
      __label__ = 6; break;
    case 4: // $12
      __label__ = 5; break;
    case 5: // $13
      var $14=(($4+152)|0);
      $1=$14;
      __label__ = 6; break;
    case 6: // $15
      var $16=$1;
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12cheat_script5stateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11cheat_entry4saveER8emu_file($this, $cheatfile) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $has_scripts;
      $1=$this;
      $2=$cheatfile;
      var $3=$1;
      var $4=(($3+144)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { var $20 = 1;__label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=(($3+140)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { var $20 = 1;__label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=(($3+152)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { var $20 = 1;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $15
      var $16=(($3+148)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      var $20 = $18;__label__ = 4; break;
    case 4: // $19
      var $20;
      var $21=(($20)&1);
      $has_scripts=$21;
      var $22=$2;
      var $23=(($3+8)|0);
      var $24=__ZNK7astring4cstrEv($23);
      var $25=__ZN8emu_file6printfEPKcz($22, ((STRING_TABLE.__str813475)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      var $26=(($3+592)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=10;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$2;
      var $31=(($3+592)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__ZN8emu_file6printfEPKcz($30, ((STRING_TABLE.__str823476)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,tempInt));
      __label__ = 6; break;
    case 6: // $34
      var $35=(($3+72)|0);
      var $36=__ZNK7astringcvbEv($35);
      if ($36) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $37
      var $38=(($3+136)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $41
      var $42=$has_scripts;
      var $43=(($42) & 1);
      if ($43) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $44
      var $45=$2;
      var $46=__ZN8emu_file6printfEPKcz($45, ((STRING_TABLE.__str563450)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 23; break;
    case 10: // $47
      var $48=$2;
      var $49=__ZN8emu_file6printfEPKcz($48, ((STRING_TABLE.__str323426)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $50=(($3+72)|0);
      var $51=__ZNK7astringcvbEv($50);
      if ($51) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $52
      var $53=$2;
      var $54=(($3+72)|0);
      var $55=__ZNK7astring4cstrEv($54);
      var $56=__ZN8emu_file6printfEPKcz($53, ((STRING_TABLE.__str833477)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,tempInt));
      __label__ = 12; break;
    case 12: // $57
      var $58=(($3+136)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $61
      var $62=(($3+136)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$2;
      __ZNK15cheat_parameter4saveER8emu_file($63, $64);
      __label__ = 14; break;
    case 14: // $65
      var $66=(($3+140)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $69
      var $70=(($3+140)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      __ZNK12cheat_script4saveER8emu_file($71, $72);
      __label__ = 16; break;
    case 16: // $73
      var $74=(($3+144)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $77
      var $78=(($3+144)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$2;
      __ZNK12cheat_script4saveER8emu_file($79, $80);
      __label__ = 18; break;
    case 18: // $81
      var $82=(($3+148)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $85
      var $86=(($3+148)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$2;
      __ZNK12cheat_script4saveER8emu_file($87, $88);
      __label__ = 20; break;
    case 20: // $89
      var $90=(($3+152)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $93
      var $94=(($3+152)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      __ZNK12cheat_script4saveER8emu_file($95, $96);
      __label__ = 22; break;
    case 22: // $97
      var $98=$2;
      var $99=__ZN8emu_file6printfEPKcz($98, ((STRING_TABLE.__str843478)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 23; break;
    case 23: // $100
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK11cheat_entry4saveER8emu_file["X"]=1;

function __ZN11cheat_entry8activateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $changed;
      $2=$this;
      var $3=$2;
      $changed=0;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK13cheat_manager7enabledEv($5);
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$changed;
      var $9=(($8) & 1);
      $1=$9;
      __label__ = 9; break;
    case 2: // $10
      var $11=__ZNK11cheat_entry10is_oneshotEv($3);
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      __ZN11cheat_entry17execute_on_scriptEv($3);
      $changed=1;
      var $13=(($3+8)|0);
      var $14=__ZNK7astring4cstrEv($13);
      __Z10popmessagePKcz(((STRING_TABLE.__str853479)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,tempInt));
      __label__ = 8; break;
    case 4: // $15
      var $16=__ZNK11cheat_entry20is_oneshot_parameterEv($3);
      if ($16) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $17
      var $18=(($3+588)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $21
      __ZN11cheat_entry21execute_change_scriptEv($3);
      $changed=1;
      var $22=(($3+8)|0);
      var $23=__ZNK7astring4cstrEv($22);
      var $24=(($3+136)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZN15cheat_parameter4textEv($25);
      __Z10popmessagePKcz(((STRING_TABLE.__str863480)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$23,HEAP32[((tempInt+4)>>2)]=$26,tempInt));
      __label__ = 7; break;
    case 7: // $27
      __label__ = 8; break;
    case 8: // $28
      var $29=$changed;
      var $30=(($29) & 1);
      $1=$30;
      __label__ = 9; break;
    case 9: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11cheat_entry10is_oneshotEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+136)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $13 = 0;__label__ = 4; break; }
    case 1: // $6
      var $7=__ZNK11cheat_entry14has_run_scriptEv($2);
      if ($7) { var $13 = 0;__label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $8
      var $9=__ZNK11cheat_entry14has_off_scriptEv($2);
      if ($9) { var $13 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $10
      var $11=__ZNK11cheat_entry13has_on_scriptEv($2);
      var $13 = $11;__label__ = 4; break;
    case 4: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry17execute_on_scriptEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK11cheat_entry13has_on_scriptEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+140)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($2+596)|0);
      __ZN12cheat_script7executeER13cheat_managerRy($6, $8, $9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11cheat_entry20is_oneshot_parameterEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+136)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { var $13 = 0;__label__ = 4; break; }
    case 1: // $6
      var $7=__ZNK11cheat_entry14has_run_scriptEv($2);
      if ($7) { var $13 = 0;__label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $8
      var $9=__ZNK11cheat_entry14has_off_scriptEv($2);
      if ($9) { var $13 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $10
      var $11=__ZNK11cheat_entry17has_change_scriptEv($2);
      var $13 = $11;__label__ = 4; break;
    case 4: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry21execute_change_scriptEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK11cheat_entry17has_change_scriptEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+148)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($2+596)|0);
      __ZN12cheat_script7executeER13cheat_managerRy($6, $8, $9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry20select_default_stateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $changed;
      $1=$this;
      var $2=$1;
      $changed=0;
      var $3=__ZNK11cheat_entry10is_oneshotEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 3; break;
    case 2: // $5
      var $6=__ZN11cheat_entry9set_stateE12script_state($2, 0);
      var $7=(($6)&1);
      $changed=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$changed;
      var $10=(($9) & 1);
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry9set_stateE12script_state($this, $newstate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$newstate;
      var $4=$2;
      var $5=(($4+588)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$3;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 9; break;
    case 2: // $10
      var $11=$3;
      var $12=(($4+588)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=$3;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      __ZN11cheat_entry18execute_off_scriptEv($4);
      __label__ = 8; break;
    case 4: // $16
      var $17=$3;
      var $18=(($17)|0)==1;
      if ($18) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $19
      var $20=$3;
      var $21=(($20)|0)==2;
      if ($21) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $22
      __ZN11cheat_entry17execute_on_scriptEv($4);
      __label__ = 7; break;
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      $1=1;
      __label__ = 9; break;
    case 9: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry21select_previous_stateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $changed;
      $1=$this;
      var $2=$1;
      $changed=0;
      var $3=__ZNK11cheat_entry10is_oneshotEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 15; break;
    case 2: // $5
      var $6=__ZNK11cheat_entry8is_onoffEv($2);
      if ($6) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $7
      var $8=__ZN11cheat_entry9set_stateE12script_state($2, 0);
      var $9=(($8)&1);
      $changed=$9;
      __label__ = 14; break;
    case 4: // $10
      var $11=(($2+136)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $14
      var $15=(($2+136)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNK15cheat_parameter10is_minimumEv($16);
      if ($17) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $18
      var $19=__ZN11cheat_entry9set_stateE12script_state($2, 0);
      var $20=(($19)&1);
      $changed=$20;
      __label__ = 12; break;
    case 7: // $21
      var $22=(($2+136)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__ZN15cheat_parameter14set_prev_stateEv($23);
      var $25=(($24)&1);
      $changed=$25;
      var $26=$changed;
      var $27=(($26) & 1);
      if ($27) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $28
      var $29=__ZN11cheat_entry9set_stateE12script_state($2, 2);
      var $30=__ZNK11cheat_entry20is_oneshot_parameterEv($2);
      if ($30) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $31
      __ZN11cheat_entry21execute_change_scriptEv($2);
      __label__ = 10; break;
    case 10: // $32
      __label__ = 11; break;
    case 11: // $33
      __label__ = 12; break;
    case 12: // $34
      __label__ = 13; break;
    case 13: // $35
      __label__ = 14; break;
    case 14: // $36
      __label__ = 15; break;
    case 15: // $37
      var $38=$changed;
      var $39=(($38) & 1);
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11cheat_entry8is_onoffEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+136)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $17 = 0;__label__ = 6; break; }
    case 1: // $6
      var $7=__ZNK11cheat_entry14has_run_scriptEv($2);
      if ($7) { var $15 = 1;__label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $8
      var $9=__ZNK11cheat_entry14has_off_scriptEv($2);
      if ($9) { __label__ = 3; break; } else { var $13 = 0;__label__ = 4; break; }
    case 3: // $10
      var $11=__ZNK11cheat_entry13has_on_scriptEv($2);
      var $13 = $11;__label__ = 4; break;
    case 4: // $12
      var $13;
      var $15 = $13;__label__ = 5; break;
    case 5: // $14
      var $15;
      var $17 = $15;__label__ = 6; break;
    case 6: // $16
      var $17;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15cheat_parameter10is_minimumEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+36)|0);
      var $st$4$0=(($3)|0);
      var $4$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $4$1=HEAP32[(($st$4$1)>>2)];
      var $5=(($2+108)|0);
      var $6=__ZNK11simple_listIN15cheat_parameter4itemEE5countEv($5);
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($2)|0);
      var $15 = $9;__label__ = 3; break;
    case 2: // $10
      var $11=(($2+108)|0);
      var $12=__ZNK11simple_listIN15cheat_parameter4itemEE5firstEv($11);
      var $13=__ZNK15cheat_parameter4item5valueEv($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      var $16=__ZNK17number_and_formatcvRKyEv($15);
      var $st$2$0=(($16)|0);
      var $17$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$2$1)>>2)];
      var $18=$4$0 == $17$0 && $4$1 == $17$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry17select_next_stateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $changed;
      $1=$this;
      var $2=$1;
      $changed=0;
      var $3=__ZNK11cheat_entry10is_oneshotEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 14; break;
    case 2: // $5
      var $6=__ZNK11cheat_entry8is_onoffEv($2);
      if ($6) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $7
      var $8=__ZN11cheat_entry9set_stateE12script_state($2, 2);
      var $9=(($8)&1);
      $changed=$9;
      __label__ = 13; break;
    case 4: // $10
      var $11=(($2+136)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $14
      var $15=(($2+588)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $18
      var $19=__ZN11cheat_entry9set_stateE12script_state($2, 2);
      var $20=(($19)&1);
      $changed=$20;
      var $21=(($2+136)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZN15cheat_parameter17set_minimum_stateEv($22);
      __label__ = 8; break;
    case 7: // $24
      var $25=(($2+136)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZN15cheat_parameter14set_next_stateEv($26);
      var $28=(($27)&1);
      $changed=$28;
      __label__ = 8; break;
    case 8: // $29
      var $30=$changed;
      var $31=(($30) & 1);
      if ($31) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $32
      var $33=__ZNK11cheat_entry20is_oneshot_parameterEv($2);
      if ($33) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $34
      __ZN11cheat_entry21execute_change_scriptEv($2);
      __label__ = 11; break;
    case 11: // $35
      __label__ = 12; break;
    case 12: // $36
      __label__ = 13; break;
    case 13: // $37
      __label__ = 14; break;
    case 14: // $38
      var $39=$changed;
      var $40=(($39) & 1);
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI12cheat_scriptEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12cheat_scriptEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12cheat_scriptEEPT_S3_["X"]=1;

function __ZN11cheat_entryD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 18; break; };
    case 1: // $8
      var $9=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 18; break; };
    case 2: // $10
      var $11=(($4+140)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($9, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 18; break; }
    case 3: // $14
      var $15=(($4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 18; break; };
    case 4: // $18
      var $19=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 18; break; };
    case 5: // $20
      var $21=(($4+144)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($19, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 18; break; }
    case 6: // $24
      var $25=(($4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 18; break; };
    case 7: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 18; break; };
    case 8: // $30
      var $31=(($4+148)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($29, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 18; break; }
    case 9: // $34
      var $35=(($4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 18; break; };
    case 10: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 18; break; };
    case 11: // $40
      var $41=(($4+152)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$42;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($39, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 18; break; }
    case 12: // $44
      var $45=(($4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 18; break; };
    case 13: // $48
      var $49=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 18; break; };
    case 14: // $50
      var $51=(($4+136)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$52;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($49, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $54
      var $55=(($4+156)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $56
      var $57=(($4+72)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $58
      var $59=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($59);
      ;
      return;
    case 18: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $2=$62;
      var $63=$61.f1;
      $3=$63;
      var $64=(($4+156)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 27; break; }
    case 19: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      $2=$67;
      var $68=$66.f1;
      $3=$68;
      __label__ = 22; break;
    case 20: // $69
      __label__ = 22; break;
    case 21: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $2=$72;
      var $73=$71.f1;
      $3=$73;
      __label__ = 24; break;
    case 22: // $74
      var $75=(($4+72)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $76
      __label__ = 24; break;
    case 24: // $77
      var $78=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $79
      __label__ = 26; break;
    case 26: // $80
      var $81=$2;
      var $82=$2;
      var $83=$3;
      var $84=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $82, tempValue);
      var $85=($84.f1 = $83, $84);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 27: // $86
      var $87=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11cheat_entryD2Ev["X"]=1;

function __ZN13cheat_manager15execute_frombcdER12symbol_tablePviPKy($table, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $value=__stackBase__;
      var $multiplier=__stackBase__+8;
      var $result=__stackBase__+16;
      $1=$table;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$4;
      var $6=(($5)|0);
      var $st$13$0=(($6)|0);
      var $7$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$13$1)>>2)];
      var $st$17$0=(($value)|0);
      HEAP32[(($st$17$0)>>2)]=$7$0;
      var $st$17$1=(($value+4)|0);
      HEAP32[(($st$17$1)>>2)]=$7$1;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$23$0=(($multiplier)|0);
      HEAP32[(($st$23$0)>>2)]=$$emscripten$temp$0$0;
      var $st$23$1=(($multiplier+4)|0);
      HEAP32[(($st$23$1)>>2)]=$$emscripten$temp$0$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$29$0=(($result)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$1$0;
      var $st$29$1=(($result+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 1; break;
    case 1: // $8
      var $st$0$0=(($value)|0);
      var $9$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($value+4)|0);
      var $9$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $10=$9$0 != $$emscripten$temp$2$0 || $9$1 != $$emscripten$temp$2$1;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $st$0$0=(($value)|0);
      var $12$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($value+4)|0);
      var $12$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=15;
      var $$emscripten$temp$3$1=0;
      var $13$0=$12$0 & $$emscripten$temp$3$0;
      var $13$1=$12$1 & $$emscripten$temp$3$1;
      var $st$8$0=(($multiplier)|0);
      var $14$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($multiplier+4)|0);
      var $14$1=HEAP32[(($st$8$1)>>2)];
      var $15$0 = ((($13$0)>>>0)+((($13$1)|0)*4294967296))*((($14$0)>>>0)+((($14$1)|0)*4294967296))>>>0; var $15$1 = Math.min(Math.floor((((($13$0)>>>0)+((($13$1)|0)*4294967296))*((($14$0)>>>0)+((($14$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$13$0=(($result)|0);
      var $16$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($result+4)|0);
      var $16$1=HEAP32[(($st$13$1)>>2)];
      var $17$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))+((($15$0)>>>0)+((($15$1)|0)*4294967296))>>>0; var $17$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))+((($15$0)>>>0)+((($15$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$18$0=(($result)|0);
      HEAP32[(($st$18$0)>>2)]=$17$0;
      var $st$18$1=(($result+4)|0);
      HEAP32[(($st$18$1)>>2)]=$17$1;
      var $st$22$0=(($value)|0);
      var $18$0=HEAPU32[(($st$22$0)>>2)];
      var $st$22$1=(($value+4)|0);
      var $18$1=HEAPU32[(($st$22$1)>>2)];
      var $19$0=($18$0 >>> 4) | ($18$1 << 28);
      var $19$1=($18$1 >>> 4) | (0 << 28);
      var $st$28$0=(($value)|0);
      HEAP32[(($st$28$0)>>2)]=$19$0;
      var $st$28$1=(($value+4)|0);
      HEAP32[(($st$28$1)>>2)]=$19$1;
      var $st$32$0=(($multiplier)|0);
      var $20$0=HEAP32[(($st$32$0)>>2)];
      var $st$32$1=(($multiplier+4)|0);
      var $20$1=HEAP32[(($st$32$1)>>2)];
      var $$emscripten$temp$4$0=10;
      var $$emscripten$temp$4$1=0;
      var $21$0 = ((($20$0)>>>0)+((($20$1)|0)*4294967296))*((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $21$1 = Math.min(Math.floor((((($20$0)>>>0)+((($20$1)|0)*4294967296))*((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$39$0=(($multiplier)|0);
      HEAP32[(($st$39$0)>>2)]=$21$0;
      var $st$39$1=(($multiplier+4)|0);
      HEAP32[(($st$39$1)>>2)]=$21$1;
      __label__ = 1; break;
    case 3: // $22
      var $st$0$0=(($result)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$23$0,$23$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager15execute_frombcdER12symbol_tablePviPKy["X"]=1;

function __ZN13cheat_manager13execute_tobcdER12symbol_tablePviPKy($table, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $value=__stackBase__;
      var $result=__stackBase__+8;
      var $shift;
      $1=$table;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$4;
      var $6=(($5)|0);
      var $st$13$0=(($6)|0);
      var $7$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$13$1)>>2)];
      var $st$17$0=(($value)|0);
      HEAP32[(($st$17$0)>>2)]=$7$0;
      var $st$17$1=(($value+4)|0);
      HEAP32[(($st$17$1)>>2)]=$7$1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$23$0=(($result)|0);
      HEAP32[(($st$23$0)>>2)]=$$emscripten$temp$0$0;
      var $st$23$1=(($result+4)|0);
      HEAP32[(($st$23$1)>>2)]=$$emscripten$temp$0$1;
      $shift=0;
      __label__ = 1; break;
    case 1: // $8
      var $st$0$0=(($value)|0);
      var $9$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($value+4)|0);
      var $9$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $10=$9$0 != $$emscripten$temp$1$0 || $9$1 != $$emscripten$temp$1$1;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $st$0$0=(($value)|0);
      var $12$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($value+4)|0);
      var $12$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=10;
      var $$emscripten$temp$2$1=0;
      var $13$0 = ((($12$0)>>>0)+((($12$1)|0)*4294967296))%((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($12$0)>>>0)+((($12$1)|0)*4294967296))%((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $14=$shift;
      var $15=(($14)&255);
      var $16$0=$15;
      var $16$1=0;
      var $17=Runtime.bitshift64($13$0, $13$1,"shl",$16$0);var $17$0 = $17[0], $17$1 = $17[1];
      var $st$12$0=(($result)|0);
      var $18$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($result+4)|0);
      var $18$1=HEAP32[(($st$12$1)>>2)];
      var $19$0 = ((($18$0)>>>0)+((($18$1)|0)*4294967296))+((($17$0)>>>0)+((($17$1)|0)*4294967296))>>>0; var $19$1 = Math.min(Math.floor((((($18$0)>>>0)+((($18$1)|0)*4294967296))+((($17$0)>>>0)+((($17$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$17$0=(($result)|0);
      HEAP32[(($st$17$0)>>2)]=$19$0;
      var $st$17$1=(($result+4)|0);
      HEAP32[(($st$17$1)>>2)]=$19$1;
      var $st$21$0=(($value)|0);
      var $20$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($value+4)|0);
      var $20$1=HEAP32[(($st$21$1)>>2)];
      var $$emscripten$temp$3$0=10;
      var $$emscripten$temp$3$1=0;
      var $21$0 = Math.floor(((($20$0)>>>0)+((($20$1)|0)*4294967296))/((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))>>>0; var $21$1 = Math.min(Math.floor((Math.floor(((($20$0)>>>0)+((($20$1)|0)*4294967296))/((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$28$0=(($value)|0);
      HEAP32[(($st$28$0)>>2)]=$21$0;
      var $st$28$1=(($value+4)|0);
      HEAP32[(($st$28$1)>>2)]=$21$1;
      var $22=$shift;
      var $23=(($22)&255);
      var $24=(($23+4)|0);
      var $25=(($24) & 255);
      $shift=$25;
      __label__ = 1; break;
    case 3: // $26
      var $st$0$0=(($result)|0);
      var $27$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($result+4)|0);
      var $27$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$27$0,$27$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager13execute_tobcdER12symbol_tablePviPKy["X"]=1;

function __ZNK11simple_listI11cheat_entryE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11cheat_entry5stateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+588)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11cheat_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11cheat_entry9menu_textER7astringS1_Rj($this, $description, $state, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$description;
      $3=$state;
      $4=$flags;
      var $5=$1;
      var $6=$2;
      var $7=(($5+8)|0);
      var $8=__ZN7astring3cpyERKS_($6, $7);
      var $9=$3;
      var $10=__ZN7astring5resetEv($9);
      var $11=$4;
      HEAP32[(($11)>>2)]=0;
      var $12=__ZNK11cheat_entry12is_text_onlyEv($5);
      if ($12) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $13
      var $14=$2;
      var $15=__ZN7astringcvbEv($14);
      if ($15) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $16
      var $17=$2;
      var $18=__ZN7astring9trimspaceEv($17);
      var $19=$2;
      var $20=__ZN7astringcvbEv($19);
      if ($20) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $21
      var $22=$2;
      var $23=__ZN7astring3cpyEPKc($22, ((STRING_TABLE.__str873481)|0));
      __label__ = 4; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$4;
      HEAP32[(($26)>>2)]=32;
      __label__ = 23; break;
    case 6: // $27
      var $28=__ZNK11cheat_entry10is_oneshotEv($5);
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$3;
      var $31=__ZN7astring3cpyEPKc($30, ((STRING_TABLE.__str883482)|0));
      __label__ = 22; break;
    case 8: // $32
      var $33=__ZNK11cheat_entry8is_onoffEv($5);
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      var $35=$3;
      var $36=(($5+588)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)==2;
      var $39=$38 ? (((STRING_TABLE.__str893483)|0)) : (((STRING_TABLE.__str903484)|0));
      var $40=__ZN7astring3cpyEPKc($35, $39);
      var $41=(($5+588)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      var $44=$43 ? 1 : 2;
      var $45=$4;
      HEAP32[(($45)>>2)]=$44;
      __label__ = 21; break;
    case 10: // $46
      var $47=(($5+136)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $50
      var $51=(($5+588)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $54
      var $55=$3;
      var $56=__ZNK11cheat_entry20is_oneshot_parameterEv($5);
      if ($56) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $57
      var $60 = STRING_TABLE.__str883482;__label__ = 15; break;
    case 14: // $58
      var $60 = STRING_TABLE.__str903484;__label__ = 15; break;
    case 15: // $59
      var $60;
      var $61=(($60)|0);
      var $62=__ZN7astring3cpyEPKc($55, $61);
      var $63=$4;
      HEAP32[(($63)>>2)]=2;
      __label__ = 19; break;
    case 16: // $64
      var $65=$3;
      var $66=(($5+136)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=__ZN15cheat_parameter4textEv($67);
      var $69=__ZN7astring3cpyEPKc($65, $68);
      var $70=$4;
      HEAP32[(($70)>>2)]=1;
      var $71=(($5+136)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=__ZNK15cheat_parameter10is_maximumEv($72);
      if ($73) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $74
      var $75=$4;
      var $76=HEAP32[(($75)>>2)];
      var $77=$76 | 2;
      HEAP32[(($75)>>2)]=$77;
      __label__ = 18; break;
    case 18: // $78
      __label__ = 19; break;
    case 19: // $79
      __label__ = 20; break;
    case 20: // $80
      __label__ = 21; break;
    case 21: // $81
      __label__ = 22; break;
    case 22: // $82
      __label__ = 23; break;
    case 23: // $83
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11cheat_entry9menu_textER7astringS1_Rj["X"]=1;

function __ZNK11cheat_entry12is_text_onlyEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+136)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { var $14 = 0;__label__ = 4; break; }
    case 1: // $6
      var $7=__ZNK11cheat_entry14has_run_scriptEv($2);
      if ($7) { var $14 = 0;__label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $8
      var $9=__ZNK11cheat_entry14has_off_scriptEv($2);
      if ($9) { var $14 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $10
      var $11=__ZNK11cheat_entry13has_on_scriptEv($2);
      var $12=$11 ^ 1;
      var $14 = $12;__label__ = 4; break;
    case 4: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15cheat_parameter10is_maximumEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+36)|0);
      var $st$4$0=(($3)|0);
      var $4$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($3+4)|0);
      var $4$1=HEAP32[(($st$4$1)>>2)];
      var $5=(($2+108)|0);
      var $6=__ZNK11simple_listIN15cheat_parameter4itemEE5countEv($5);
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($2+12)|0);
      var $15 = $9;__label__ = 3; break;
    case 2: // $10
      var $11=(($2+108)|0);
      var $12=__ZNK11simple_listIN15cheat_parameter4itemEE4lastEv($11);
      var $13=__ZNK15cheat_parameter4item5valueEv($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      var $16=__ZNK17number_and_formatcvRKyEv($15);
      var $st$2$0=(($16)|0);
      var $17$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$2$1)>>2)];
      var $18=$4$0 == $17$0 && $4$1 == $17$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11cheat_entry18execute_off_scriptEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK11cheat_entry14has_off_scriptEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+144)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($2+596)|0);
      __ZN12cheat_script7executeER13cheat_managerRy($6, $8, $9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11cheat_entryEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI11cheat_entryEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK11emu_options5cheatEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str1353529)|0));
  ;
  return $4;
}


function __ZN8delegateIFvvEEC1I13cheat_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I13cheat_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13cheat_manager12frame_updateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $linenum;
      var $cheat;
      $1=$this;
      var $2=$1;
      var $3=(($2+3283)|0);
      HEAP8[($3)]=0;
      var $4=__ZNK13cheat_manager7machineEv($2);
      var $5=__Z18ui_get_line_heightR15running_machine($4);
      var $6=1/$5;
      var $7=$6;
      var $8=_floor($7);
      var $9=($8 >= 0 ? Math.floor($8) : Math.ceil($8));
      var $10=(($2+3282)|0);
      HEAP8[($10)]=$9;
      var $11=(($2+3282)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=(($13)>>>0) < 50;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=(($2+3282)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $21 = $18;__label__ = 3; break;
    case 2: // $19
      var $21 = 50;__label__ = 3; break;
    case 3: // $20
      var $21;
      var $22=(($21) & 255);
      var $23=(($2+3282)|0);
      HEAP8[($23)]=$22;
      $linenum=0;
      __label__ = 4; break;
    case 4: // $24
      var $25=$linenum;
      var $26=(($25)>>>0) < 50;
      if ($26) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $27
      var $28=$linenum;
      var $29=(($2+32)|0);
      var $30=(($29+($28<<6))|0);
      var $31=__ZN7astring5resetEv($30);
      __label__ = 6; break;
    case 6: // $32
      var $33=$linenum;
      var $34=(($33+1)|0);
      $linenum=$34;
      __label__ = 4; break;
    case 7: // $35
      var $36=(($2+4)|0);
      var $37=__ZNK11simple_listI11cheat_entryE5firstEv($36);
      $cheat=$37;
      __label__ = 8; break;
    case 8: // $38
      var $39=$cheat;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $41
      var $42=$cheat;
      __ZN11cheat_entry12frame_updateEv($42);
      __label__ = 10; break;
    case 10: // $43
      var $44=$cheat;
      var $45=__ZNK11cheat_entry4nextEv($44);
      $cheat=$45;
      __label__ = 8; break;
    case 11: // $46
      var $47=(($2+24)|0);
      var $st$1$0=(($47)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($47+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $49$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $49$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($47)|0);
      HEAP32[(($st$8$0)>>2)]=$49$0;
      var $st$8$1=(($47+4)|0);
      HEAP32[(($st$8$1)>>2)]=$49$1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager12frame_updateEv["X"]=1;

function __ZN13cheat_manager10set_enableEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cheat;
      var $cheat1;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=__ZNK13cheat_manager7machineEv($4);
      var $6=__ZNK15running_machine7optionsEv($5);
      var $7=__ZNK11emu_options5cheatEv($6);
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      __label__ = 21; break;
    case 2: // $9
      var $10=(($4+3284)|0);
      var $11=HEAP8[($10)];
      var $12=(($11) & 1);
      if ($12) { __label__ = 11; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$2;
      var $15=(($14) & 1);
      if ($15) { __label__ = 11; break; } else { __label__ = 4; break; }
    case 4: // $16
      var $17=(($4+4)|0);
      var $18=__ZNK11simple_listI11cheat_entryE5firstEv($17);
      $cheat=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$cheat;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $22
      var $23=$cheat;
      var $24=__ZNK11cheat_entry5stateEv($23);
      var $25=(($24)|0)==2;
      if ($25) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $26
      var $27=$cheat;
      __ZN11cheat_entry18execute_off_scriptEv($27);
      __label__ = 8; break;
    case 8: // $28
      __label__ = 9; break;
    case 9: // $29
      var $30=$cheat;
      var $31=__ZNK11cheat_entry4nextEv($30);
      $cheat=$31;
      __label__ = 5; break;
    case 10: // $32
      __Z10popmessagePKcz(((STRING_TABLE.__str953489)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $33=(($4+3284)|0);
      HEAP8[($33)]=1;
      __label__ = 21; break;
    case 11: // $34
      var $35=(($4+3284)|0);
      var $36=HEAP8[($35)];
      var $37=(($36) & 1);
      if ($37) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $38
      var $39=$2;
      var $40=(($39) & 1);
      if ($40) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $41
      var $42=(($4+3284)|0);
      HEAP8[($42)]=0;
      var $43=(($4+4)|0);
      var $44=__ZNK11simple_listI11cheat_entryE5firstEv($43);
      $cheat1=$44;
      __label__ = 14; break;
    case 14: // $45
      var $46=$cheat1;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $48
      var $49=$cheat1;
      var $50=__ZNK11cheat_entry5stateEv($49);
      var $51=(($50)|0)==2;
      if ($51) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $52
      var $53=$cheat1;
      __ZN11cheat_entry17execute_on_scriptEv($53);
      __label__ = 17; break;
    case 17: // $54
      __label__ = 18; break;
    case 18: // $55
      var $56=$cheat1;
      var $57=__ZNK11cheat_entry4nextEv($56);
      $cheat1=$57;
      __label__ = 14; break;
    case 19: // $58
      __Z10popmessagePKcz(((STRING_TABLE.__str963490)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 20; break;
    case 20: // $59
      __label__ = 21; break;
    case 21: // $60
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager10set_enableEb["X"]=1;

function __ZNK11device_list5firstI22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI22device_image_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13cheat_managerC2ER15running_machine($this, $machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $6=__stackBase__+24;
      $1=$this;
      $2=$machine;
      var $7=$1;
      var $8=(($7)|0);
      var $9=$2;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($7+4)|0);
      var $11=$2;
      var $12=__ZN15running_machine7respoolEv($11);
      __ZN11simple_listI11cheat_entryEC1ER13resource_pool($10, $12);
      var $13=(($7+32)|0);
      var $14=(($13)|0);
      var $15=(($14+3200)|0);
      var $17 = $14;__label__ = 1; break;
    case 1: // $16
      var $17;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $18
      var $19=(($17+64)|0);
      var $20=(($19)|0)==(($15)|0);
      if ($20) { __label__ = 3; break; } else { var $17 = $19;__label__ = 1; break; }
    case 3: // $21
      var $22=(($7+3284)|0);
      HEAP8[($22)]=1;
      var $23=(($7+3288)|0);
      var $24=$2;
      var $25=$24;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12symbol_tableC1EPvPS_]($23, $25, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $26
      var $27=$2;
      var $28=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 13; break; };
    case 5: // $29
      var $30=(function() { try { __THREW__ = false; return __ZNK11emu_options5cheatEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; };
    case 6: // $31
      if ($30) { __label__ = 14; break; } else { __label__ = 7; break; }
    case 7: // $32
      __label__ = 24; break;
    case 8: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $3=$35;
      var $36=$34.f1;
      $4=$36;
      var $37=(($14)|0)==(($17)|0);
      if ($37) { __label__ = 11; break; } else { var $39 = $17;__label__ = 9; break; }
    case 9: // $38
      var $39;
      var $40=(($39-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 29; break; }
    case 10: // $41
      var $42=(($40)|0)==(($14)|0);
      if ($42) { __label__ = 11; break; } else { var $39 = $40;__label__ = 9; break; }
    case 11: // $43
      __label__ = 26; break;
    case 12: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $3=$46;
      var $47=$45.f1;
      $4=$47;
      __label__ = 26; break;
    case 13: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      $3=$50;
      var $51=$49.f1;
      $4=$51;
      var $52=(($7+3288)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_tableD1Ev($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 14: // $53
      var $54=$2;
      HEAP32[(($6)>>2)]={ f0: 844, f1: 0 }.f0; HEAP32[(($6+4)>>2)]={ f0: 844, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I13cheat_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($5, $6, ((STRING_TABLE.__str913485)|0), $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 13; break; }
    case 15: // $55
      (function() { try { __THREW__ = false; return __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($54, 0, $5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 16: // $56
      var $57=(($7+3288)|0);
      var $58=(($7+24)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcNS_10read_writeEPy($57, ((STRING_TABLE.__str923486)|0), 0, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 13; break; }
    case 17: // $59
      var $60=(($7+3288)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE($60, ((STRING_TABLE.__str933487)|0), 0, 1, 1, 846) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 13; break; }
    case 18: // $61
      var $62=(($7+3288)|0);
      (function() { try { __THREW__ = false; return __ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE($62, ((STRING_TABLE.__str943488)|0), 0, 1, 1, 848) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 13; break; }
    case 19: // $63
      var $64=$2;
      var $65=(($64+584)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$66 & 1;
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $69
      var $70=$2;
      (function() { try { __THREW__ = false; return __Z14debug_cpu_initR15running_machine($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 13; break; }
    case 21: // $71
      __label__ = 22; break;
    case 22: // $72
      var $73=$2;
      var $74=(($7+3288)|0);
      (function() { try { __THREW__ = false; return __Z26debug_cpu_configure_memoryR15running_machineR12symbol_table($73, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 13; break; }
    case 23: // $75
      (function() { try { __THREW__ = false; return __ZN13cheat_manager6reloadEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 13; break; }
    case 24: // $76
      STACKTOP = __stackBase__;
      return;
    case 25: // $77
      __label__ = 26; break;
    case 26: // $78
      var $79=(($7+4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11cheat_entryED1Ev($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $80
      __label__ = 28; break;
    case 28: // $81
      var $82=$3;
      var $83=$3;
      var $84=$4;
      var $85=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $83, tempValue);
      var $86=($85.f1 = $84, $85);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_managerC2ER15running_machine["X"]=1;

function __ZN13cheat_manager6reloadEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $image=__stackBase__;
      var $gotone;
      var $crc;
      var $filename=__stackBase__+4;
      var $2;
      var $3;
      var $4;
      $1=$this;
      var $5=$1;
      var $6=__ZNK13cheat_manager7machineEv($5);
      var $7=__ZNK15running_machine7optionsEv($6);
      var $8=__ZNK11emu_options5cheatEv($7);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      __label__ = 22; break;
    case 2: // $10
      var $11=(($5+4)|0);
      __ZN11simple_listI11cheat_entryE5resetEv($11);
      var $12=(($5+24)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$5$0=(($12)|0);
      HEAP32[(($st$5$0)>>2)]=$$emscripten$temp$0$0;
      var $st$5$1=(($12+4)|0);
      HEAP32[(($st$5$1)>>2)]=$$emscripten$temp$0$1;
      var $13=(($5+3282)|0);
      HEAP8[($13)]=0;
      var $14=(($5+3283)|0);
      HEAP8[($14)]=0;
      var $15=(($5+3284)|0);
      HEAP8[($15)]=0;
      HEAP32[(($image)>>2)]=0;
      var $16=__ZNK13cheat_manager7machineEv($5);
      var $17=__ZNK15running_machine10devicelistEv($16);
      var $18=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($17, $image);
      var $19=(($18)&1);
      $gotone=$19;
      __label__ = 3; break;
    case 3: // $20
      var $21=$gotone;
      var $22=(($21) & 1);
      if ($22) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $23
      var $24=HEAP32[(($image)>>2)];
      var $25=__ZN22device_image_interface6existsEv($24);
      if ($25) { __label__ = 5; break; } else { __label__ = 16; break; }
    case 5: // $26
      var $27=HEAP32[(($image)>>2)];
      var $28=__ZN22device_image_interface14software_entryEv($27);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=HEAP32[(($image)>>2)];
      var $32=__ZN22device_image_interface8basenameEv($31);
      __ZN13cheat_manager11load_cheatsEPKc($5, $32);
      __label__ = 18; break;
    case 7: // $33
      var $34=HEAP32[(($image)>>2)];
      var $35=__ZN22device_image_interface3crcEv($34);
      $crc=$35;
      var $36=$crc;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $38
      __ZN7astringC1Ev($filename);
      var $39=$crc;
      var $40=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($filename, ((STRING_TABLE.__str973491)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; };
    case 9: // $41
      var $42=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $43
      (function() { try { __THREW__ = false; return __ZN13cheat_manager11load_cheatsEPKc($5, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $44
      $4=2;
      FUNCTION_TABLE[__ZN7astringD1Ev]($filename);
      __label__ = 18; break;
    case 12: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $2=$47;
      var $48=$46.f1;
      $3=$48;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 24; break; }
    case 13: // $49
      __label__ = 23; break;
    case 14: // $50
      __label__ = 15; break;
    case 15: // $51
      __label__ = 16; break;
    case 16: // $52
      __label__ = 17; break;
    case 17: // $53
      var $54=HEAP32[(($image)>>2)];
      var $55=$54;
      var $56=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($55, $image);
      var $57=(($56)&1);
      $gotone=$57;
      __label__ = 3; break;
    case 18: // $58
      var $59=(($5+4)|0);
      var $60=__ZNK11simple_listI11cheat_entryE5countEv($59);
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $62
      var $63=__ZNK13cheat_manager7machineEv($5);
      var $64=__ZNK15running_machine8basenameEv($63);
      __ZN13cheat_manager11load_cheatsEPKc($5, $64);
      __label__ = 20; break;
    case 20: // $65
      var $66=(($5+4)|0);
      var $67=__ZNK11simple_listI11cheat_entryE5countEv($66);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $69
      var $70=__ZN13cheat_manager8save_allEPKc($5, ((STRING_TABLE.__str253419)|0));
      __label__ = 22; break;
    case 22: // $71
      STACKTOP = __stackBase__;
      return;
    case 23: // $72
      var $73=$2;
      var $74=$2;
      var $75=$3;
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager6reloadEv["X"]=1;

function __ZNK11simple_listI11cheat_entryE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listI11cheat_entryE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI22device_image_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZNK11emu_options10cheat_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str1363530)|0));
  ;
  return $4;
}


function __ZN13cheat_manager11render_textER16render_container($this, $container) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $linenum;
      $1=$this;
      $2=$container;
      var $3=$1;
      $linenum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$linenum;
      var $6=(($5)>>>0) < 50;
      if ($6) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $7
      var $8=$linenum;
      var $9=(($3+32)|0);
      var $10=(($9+($8<<6))|0);
      var $11=__ZN7astringcvbEv($10);
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$2;
      var $14=$linenum;
      var $15=(($3+32)|0);
      var $16=(($15+($14<<6))|0);
      var $17=__ZNK7astringcvPKcEv($16);
      var $18=$linenum;
      var $19=(($18)|0);
      var $20=__ZNK13cheat_manager7machineEv($3);
      var $21=__Z18ui_get_line_heightR15running_machine($20);
      var $22=$19*$21;
      var $23=$linenum;
      var $24=(($3+3232)|0);
      var $25=(($24+$23)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($13, $17, 0, $22, 1, $27, 0, 2, -1, -16777216, 0, 0);
      __label__ = 4; break;
    case 4: // $28
      __label__ = 5; break;
    case 5: // $29
      var $30=$linenum;
      var $31=(($30+1)|0);
      $linenum=$31;
      __label__ = 1; break;
    case 6: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring7replaceEiPKcS1_($this, $start, $search, $replace) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$start;
  $3=$search;
  $4=$replace;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__Z16astring_replacecP7astringiPKcS2_($5, $6, $7, $8);
  ;
  return $9;
}


function __ZN11cheat_entry12frame_updateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+588)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==2;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __ZN11cheat_entry18execute_run_scriptEv($2);
      __label__ = 2; break;
    case 2: // $7
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8emu_file8fullpathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN20resource_pool_objectI11cheat_entryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11cheat_entryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN13cheat_manager11load_cheatsEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 320; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $rootnode;
      var $cheatfile=__stackBase__+36;
      var $filerr;
      var $11;
      var $12;
      var $options=__stackBase__+296;
      var $error=__stackBase__+308;
      var $mamecheatnode;
      var $version;
      var $cheatnode;
      var $curcheat;
      var $scannode;
      var $err;
      $9=$this;
      $10=$filename;
      var $13=$9;
      $rootnode=0;
      var $14=__ZNK13cheat_manager7machineEv($13);
      var $15=__ZNK15running_machine7optionsEv($14);
      var $16=__ZNK11emu_options10cheat_pathEv($15);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($cheatfile, $16, 1);
      var $17=$10;
      var $18=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($cheatfile, $17, ((STRING_TABLE.__str983492)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 10; break; };
    case 1: // $19
      $filerr=$18;
      __label__ = 2; break;
    case 2: // $20
      var $21=$filerr;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 64; break; }
    case 3: // $23
      var $24=(function() { try { __THREW__ = false; return __ZNK8emu_file8fullpathEv($cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $25
      (function() { try { __THREW__ = false; return __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str1293523)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $26
      var $27=$options;
      HEAP32[(($27)>>2)]=0; HEAP32[(($27+4)>>2)]=0; HEAP32[(($27+8)>>2)]=0;
      var $28=(($options)|0);
      HEAP32[(($28)>>2)]=$error;
      var $29=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; };
    case 6: // $30
      var $31=(function() { try { __THREW__ = false; return __Z13xml_file_readP10_core_fileP18_xml_parse_options($29, $options) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $32
      $rootnode=$31;
      var $33=$rootnode;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $35
      var $36=___cxa_allocate_exception(1032);
      var $37=$36;
      var $38=$10;
      var $39=(($error+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($error)|0);
      var $42=HEAP32[(($41)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($37, ((STRING_TABLE.__str1303524)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$38,HEAP32[((tempInt+4)>>2)]=$40,HEAP32[((tempInt+8)>>2)]=$42,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $43
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 10; break; }
    case 10: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $eh_lpad_body = $45;__label__ = 11; break;
    case 11: // $_body
      var $eh_lpad_body;
      var $46=$eh_lpad_body.f0;
      $11=$46;
      var $47=$eh_lpad_body.f1;
      $12=$47;
      __label__ = 47; break;
    case 12: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $50=$49.f0;
      $11=$50;
      var $51=$49.f1;
      $12=$51;
      ___cxa_free_exception($36);
      __label__ = 47; break;
    case 13: // $52
      var $53=$rootnode;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($55, ((STRING_TABLE.__str1313525)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 10; break; };
    case 14: // $57
      $mamecheatnode=$56;
      var $58=$mamecheatnode;
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $60
      var $61=___cxa_allocate_exception(1032);
      var $62=$61;
      var $63=$10;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($62, ((STRING_TABLE.__str1323526)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $64
      (function() { try { __THREW__ = false; return ___cxa_throw($61, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 10; break; }
    case 17: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $67=$66.f0;
      $11=$67;
      var $68=$66.f1;
      $12=$68;
      ___cxa_free_exception($61);
      __label__ = 47; break;
    case 18: // $69
      var $70=$mamecheatnode;
      var $71=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($70, ((STRING_TABLE.__str1333527)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 10; break; };
    case 19: // $72
      $version=$71;
      var $73=$version;
      var $74=(($73)|0)!=1;
      if ($74) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $75
      var $76=___cxa_allocate_exception(1032);
      var $77=$76;
      var $78=$10;
      var $79=$mamecheatnode;
      var $80=(($79+24)|0);
      var $81=HEAP32[(($80)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($77, ((STRING_TABLE.__str1343528)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$78,HEAP32[((tempInt+4)>>2)]=$81,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $82
      (function() { try { __THREW__ = false; return ___cxa_throw($76, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 10; break; }
    case 22: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $85=$84.f0;
      $11=$85;
      var $86=$84.f1;
      $12=$86;
      ___cxa_free_exception($76);
      __label__ = 47; break;
    case 23: // $87
      var $88=$mamecheatnode;
      var $89=(($88+8)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($90, ((STRING_TABLE.__str1353529)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 10; break; };
    case 24: // $92
      $cheatnode=$91;
      __label__ = 25; break;
    case 25: // $93
      var $94=$cheatnode;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 26; break; } else { __label__ = 61; break; }
    case 26: // $96
      var $97=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 10; break; };
    case 27: // $98
      var $99=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 10; break; };
    case 28: // $100
      var $101=$4;
      var $102=$5;
      var $103=$6;
      var $104=$result_i;
      var $105=$7;
      var $106=$8;
      HEAP32[(($4)>>2)]=604;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($6)>>2)]=1444;
      var $107=HEAP32[(($4)>>2)];
      var $108=HEAP32[(($5)>>2)];
      var $109=HEAP32[(($6)>>2)];
      var $110=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($107, $108, $109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 31; break; };
    case 29: // $111
      HEAP32[(($result_i)>>2)]=$110;
      var $112=HEAP32[(($result_i)>>2)];
      var $113=(($112)|0)==0;
      if ($113) { __label__ = 30; break; } else { __label__ = 36; break; }
    case 30: // $114
      var $115=___cxa_allocate_exception(4);
      var $116=$115;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($116);
      (function() { try { __THREW__ = false; return ___cxa_throw($115, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 31; break; }
    case 31: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $119=$118.f0;
      HEAP32[(($7)>>2)]=$119;
      var $120=$118.f1;
      HEAP32[(($8)>>2)]=$120;
      var $121=HEAP32[(($8)>>2)];
      var $122=(($121)|0) < 0;
      if ($122) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $123
      var $124=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 10; break; }
    case 33: // $_noexc
      throw "Reached an unreachable!"
    case 34: // $125
      var $126=HEAP32[(($7)>>2)];
      var $127=HEAP32[(($7)>>2)];
      var $128=HEAP32[(($8)>>2)];
      var $129=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $127, tempValue);
      var $130=($129.f1 = $128, $129);
      var $eh_lpad_body = $130;__label__ = 11; break;
    case 35: // $131
      throw "Reached an unreachable!"
    case 36: // $_ZnwjPKci_exit
      var $132=HEAP32[(($result_i)>>2)];
      var $133=$4;
      var $134=$5;
      var $135=$6;
      var $136=$result_i;
      var $137=$7;
      var $138=$8;
      __label__ = 37; break;
    case 37: // $139
      var $140=$132;
      var $141=(($13+3288)|0);
      var $142=$10;
      var $143=$cheatnode;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11cheat_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node]($140, $13, $141, $142, $143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $144
      var $145=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI11cheat_entryEEPT_S3_($99, $140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 10; break; };
    case 39: // $146
      $curcheat=$145;
      $scannode=0;
      var $147=$scannode;
      var $148=(($147)|0)==0;
      if ($148) { __label__ = 40; break; } else { __label__ = 54; break; }
    case 40: // $149
      var $150=(($13+4)|0);
      var $151=$curcheat;
      var $152=(function() { try { __THREW__ = false; return __ZN11simple_listI11cheat_entryE6appendERS0_($150, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 10; break; };
    case 41: // $153
      __label__ = 58; break;
    case 42: // $154
      var $155=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $156=$155.f0;
      $11=$156;
      var $157=$155.f1;
      $12=$157;
      var $158=$1;
      var $159=$2;
      var $160=$3;
      HEAP32[(($1)>>2)]=$132;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str73401)|0);
      HEAP32[(($3)>>2)]=1444;
      var $161=HEAP32[(($1)>>2)];
      var $162=(($161)|0)!=0;
      if ($162) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $163
      var $164=HEAP32[(($1)>>2)];
      var $165=HEAP32[(($2)>>2)];
      var $166=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($164, $165, $166) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 74; break; }
    case 44: // $_noexc1
      __label__ = 45; break;
    case 45: // $_ZdlPvPKci_exit
      var $167=$1;
      var $168=$2;
      var $169=$3;
      __label__ = 46; break;
    case 46: // $170
      __label__ = 47; break;
    case 47: // $171
      var $172=$12;
      var $173=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $174=(($172)|0)==(($173)|0);
      if ($174) { __label__ = 48; break; } else { __label__ = 71; break; }
    case 48: // $175
      var $176=$11;
      var $177=___cxa_begin_catch($176);
      var $178=$177;
      $err=$178;
      var $179=$err;
      var $180=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 65; break; };
    case 49: // $181
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1033497)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$180,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 65; break; }
    case 50: // $182
      var $183=(($13+4)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11cheat_entryE5resetEv($183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 65; break; }
    case 51: // $184
      var $185=$rootnode;
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 52; break; } else { __label__ = 66; break; }
    case 52: // $187
      var $188=$rootnode;
      (function() { try { __THREW__ = false; return __Z13xml_file_freeP14_xml_data_node($188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 65; break; }
    case 53: // $189
      __label__ = 66; break;
    case 54: // $190
      var $191=(function() { try { __THREW__ = false; return __ZNK13cheat_manager7machineEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 10; break; };
    case 55: // $192
      var $193=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 10; break; };
    case 56: // $194
      var $195=$curcheat;
      var $196=$195;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($193, $196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 10; break; }
    case 57: // $197
      __label__ = 58; break;
    case 58: // $198
      __label__ = 59; break;
    case 59: // $199
      var $200=$cheatnode;
      var $201=(($200)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($202, ((STRING_TABLE.__str1353529)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 10; break; };
    case 60: // $204
      $cheatnode=$203;
      __label__ = 25; break;
    case 61: // $205
      var $206=$rootnode;
      (function() { try { __THREW__ = false; return __Z13xml_file_freeP14_xml_data_node($206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 10; break; }
    case 62: // $207
      var $208=(function() { try { __THREW__ = false; return __ZN8emu_file9open_nextEv($cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 10; break; };
    case 63: // $209
      $filerr=$208;
      __label__ = 2; break;
    case 64: // $210
      __label__ = 68; break;
    case 65: // $211
      var $212=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $213=$212.f0;
      $11=$213;
      var $214=$212.f1;
      $12=$214;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 74; break; }
    case 66: // $215
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 69; break; }
    case 67: // $216
      __label__ = 68; break;
    case 68: // $217
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($cheatfile);
      STACKTOP = __stackBase__;
      return;
    case 69: // $218
      var $219=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $220=$219.f0;
      $11=$220;
      var $221=$219.f1;
      $12=$221;
      __label__ = 71; break;
    case 70: // $222
      __label__ = 71; break;
    case 71: // $223
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $224
      __label__ = 73; break;
    case 73: // $225
      var $226=$11;
      var $227=$11;
      var $228=$12;
      var $229=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $227, tempValue);
      var $230=($229.f1 = $228, $229);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 74: // $231
      var $232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 75: // $233
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager11load_cheatsEPKc["X"]=1;

function __ZN13cheat_manager8save_allEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cheatfile=__stackBase__;
      var $filerr;
      var $4;
      var $5;
      var $6;
      var $cheat;
      var $err;
      $2=$this;
      $3=$filename;
      var $7=$2;
      var $8=__ZNK13cheat_manager7machineEv($7);
      var $9=__ZNK15running_machine7optionsEv($8);
      var $10=__ZNK11emu_options10cheat_pathEv($9);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($cheatfile, $10, 14);
      var $11=$3;
      var $12=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($cheatfile, $11, ((STRING_TABLE.__str983492)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $13
      $filerr=$12;
      var $14=$filerr;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      $1=0;
      $6=1;
      __label__ = 26; break;
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      __label__ = 27; break;
    case 4: // $21
      var $22=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($cheatfile, ((STRING_TABLE.__str993493)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 14; break; };
    case 5: // $23
      var $24=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($cheatfile, ((STRING_TABLE.__str1003494)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 14; break; };
    case 6: // $25
      var $26=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($cheatfile, ((STRING_TABLE.__str1013495)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=1,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 14; break; };
    case 7: // $27
      var $28=(($7+4)|0);
      var $29=(function() { try { __THREW__ = false; return __ZNK11simple_listI11cheat_entryE5firstEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; };
    case 8: // $30
      $cheat=$29;
      __label__ = 9; break;
    case 9: // $31
      var $32=$cheat;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 10; break; } else { __label__ = 22; break; }
    case 10: // $34
      var $35=$cheat;
      (function() { try { __THREW__ = false; return __ZNK11cheat_entry4saveER8emu_file($35, $cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $36
      __label__ = 12; break;
    case 12: // $37
      var $38=$cheat;
      var $39=(function() { try { __THREW__ = false; return __ZNK11cheat_entry4nextEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $40
      $cheat=$39;
      __label__ = 9; break;
    case 14: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $43=$42.f0;
      $4=$43;
      var $44=$42.f1;
      $5=$44;
      __label__ = 15; break;
    case 15: // $45
      var $46=$5;
      var $47=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $48=(($46)|0)==(($47)|0);
      if ($48) { __label__ = 16; break; } else { __label__ = 27; break; }
    case 16: // $49
      var $50=$4;
      var $51=___cxa_begin_catch($50);
      var $52=$51;
      $err=$52;
      var $53=$err;
      var $54=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 24; break; };
    case 17: // $55
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1033497)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$54,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $56
      (function() { try { __THREW__ = false; return __ZN8emu_file15remove_on_closeEv($cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $57
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 3; break; }
    case 20: // $58
      __label__ = 21; break;
    case 21: // $59
      $1=0;
      $6=1;
      __label__ = 26; break;
    case 22: // $60
      var $61=(function() { try { __THREW__ = false; return __ZN8emu_file6printfEPKcz($cheatfile, ((STRING_TABLE.__str1023496)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 14; break; };
    case 23: // $62
      $1=1;
      $6=1;
      __label__ = 26; break;
    case 24: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      $4=$65;
      var $66=$64.f1;
      $5=$66;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $67
      __label__ = 27; break;
    case 26: // $68
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($cheatfile);
      var $69=$1;
      STACKTOP = __stackBase__;
      return $69;
    case 27: // $70
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($cheatfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $71
      __label__ = 29; break;
    case 29: // $72
      var $73=$4;
      var $74=$4;
      var $75=$5;
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13cheat_manager8save_allEPKc["X"]=1;

function __ZN13resource_pool10add_objectI11cheat_entryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11cheat_entryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11cheat_entryEEPT_S3_["X"]=1;

function __ZN21delegate_internal_mfpC2IM13cheat_managerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11cheat_entryEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI11cheat_entryE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN20resource_pool_objectI11cheat_entryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 604);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11cheat_entryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11cheat_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11cheat_entryED2Ev($2);
  ;
  return;
}


function __ZNK8device_t4nextI22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI22device_image_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceI22device_image_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_image_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvvEEC2I13cheat_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13cheat_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13cheat_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM13cheat_managerFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=850;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM13cheat_managerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM13cheat_managerFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13cheat_managerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13cheat_manager, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI12cheat_scriptEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12cheat_scriptEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12cheat_scriptEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 24);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12cheat_scriptE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12cheat_scriptED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12cheat_scriptED2Ev($2);
  ;
  return;
}


function __ZN12cheat_scriptD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12cheat_scriptD2Ev($2);
  ;
  return;
}


function __ZN12cheat_scriptD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listIN12cheat_script12script_entryEED1Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI15cheat_parameterEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI15cheat_parameterEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI15cheat_parameterEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 128);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI15cheat_parameterE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI15cheat_parameterED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI15cheat_parameterED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI11cheat_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11cheat_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11cheat_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI11cheat_entryED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI11cheat_entryE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11cheat_entryD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11cheat_entryED2Ev["X"]=1;

function __ZN20resource_pool_objectI12cheat_scriptED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12cheat_scriptED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12cheat_scriptED0Ev["X"]=1;

function __ZN20resource_pool_objectI12cheat_scriptED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12cheat_scriptE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12cheat_scriptD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12cheat_scriptED2Ev["X"]=1;

function __ZN20resource_pool_objectI15cheat_parameterED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI15cheat_parameterED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI15cheat_parameterED0Ev["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6detachERS2_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6detachERS2_["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN12cheat_script12script_entry15output_argumentEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN15cheat_parameterD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15cheat_parameterD2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEEC1EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEEC2EPS2_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEEC2EPS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 636);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED2Ev($2);
  ;
  return;
}


function __ZN12cheat_script12script_entry15output_argumentD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12cheat_script12script_entry15output_argumentD2Ev($2);
  ;
  return;
}


function __ZN12cheat_script12script_entry15output_argumentD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  __ZN17parsed_expressionD1Ev($3);
  ;
  return;
}


function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN12cheat_script12script_entry15output_argumentEE+8)|0);
  __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6removeERS2_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6removeERS2_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6detachERS2_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entryEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN12cheat_script12script_entryEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entryEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1340);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN12cheat_script12script_entryEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN12cheat_script12script_entryEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI15cheat_parameterED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI15cheat_parameterE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN15cheat_parameterD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI15cheat_parameterED2Ev["X"]=1;

function __ZN15cheat_parameterD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+108)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15cheat_parameter4itemEED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+44)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+44)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12cheat_script12script_entry15output_argumentD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED2Ev["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12cheat_script12script_entry15output_argumentEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN12cheat_script12script_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN12cheat_script12script_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12cheat_script12script_entryEED0Ev["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entryEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12cheat_script12script_entryEE6detachERS1_["X"]=1;

function __ZN11simple_listIN12cheat_script12script_entryEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN12cheat_script12script_entryEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN12cheat_script12script_entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12cheat_script12script_entryD2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN12cheat_script12script_entryEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN12cheat_script12script_entryEE+8)|0);
  __ZN11simple_listIN12cheat_script12script_entryEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN12cheat_script12script_entryEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN12cheat_script12script_entryEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12cheat_script12script_entryEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN12cheat_script12script_entryEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN15cheat_parameter4itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN15cheat_parameter4itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN15cheat_parameter4itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 80);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN15cheat_parameter4itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN15cheat_parameter4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN15cheat_parameter4itemEED2Ev($2);
  ;
  return;
}


function __ZN15cheat_parameter4itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN15cheat_parameter4itemD2Ev($2);
  ;
  return;
}


function __ZN15cheat_parameter4itemD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN11simple_listIN15cheat_parameter4itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN15cheat_parameter4itemEE+8)|0);
  __ZN11simple_listIN15cheat_parameter4itemEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN15cheat_parameter4itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN15cheat_parameter4itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN15cheat_parameter4itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN15cheat_parameter4itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN12cheat_script12script_entryEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN12cheat_script12script_entryEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12cheat_script12script_entryD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN12cheat_script12script_entryEED2Ev["X"]=1;

function __ZN12cheat_script12script_entryD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+1316)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entry15output_argumentEED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      var $7=(($4+1252)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $8
      var $9=(($4+628)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $10
      var $11=(($4+4)|0);
      __ZN17parsed_expressionD1Ev($11);
      ;
      return;
    case 4: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      var $16=(($4+1252)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      __label__ = 8; break;
    case 6: // $21
      __label__ = 8; break;
    case 7: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      __label__ = 10; break;
    case 8: // $26
      var $27=(($4+628)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $28
      __label__ = 10; break;
    case 10: // $29
      var $30=(($4+4)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $31
      __label__ = 12; break;
    case 12: // $32
      var $33=$2;
      var $34=$2;
      var $35=$3;
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN12cheat_script12script_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN12cheat_script12script_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN12cheat_script12script_entryEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN15cheat_parameter4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN15cheat_parameter4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN15cheat_parameter4itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN15cheat_parameter4itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN15cheat_parameter4itemEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN15cheat_parameter4itemD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN15cheat_parameter4itemEED2Ev["X"]=1;

function __ZN11simple_listIN15cheat_parameter4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN15cheat_parameter4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN15cheat_parameter4itemEED0Ev["X"]=1;

function __ZN11simple_listIN15cheat_parameter4itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN15cheat_parameter4itemEE6detachERS1_["X"]=1;

function __ZN11simple_listIN15cheat_parameter4itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN15cheat_parameter4itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11cheat_entry14has_run_scriptEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+152)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK11cheat_entry14has_off_scriptEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+144)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK11simple_listIN15cheat_parameter4itemEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN15cheat_parameter4itemEE4lastEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11cheat_entry13has_on_scriptEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+140)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK11cheat_entry17has_change_scriptEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+148)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZN17number_and_formatC2Eyi($this, $value$0, $value$1, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3;
  $1=$this;
  var $st$4$0=(($2)|0);
  HEAP32[(($st$4$0)>>2)]=$value$0;
  var $st$4$1=(($2+4)|0);
  HEAP32[(($st$4$1)>>2)]=$value$1;
  $3=$format;
  var $4=$1;
  var $5=(($4)|0);
  var $st$11$0=(($2)|0);
  var $6$0=HEAP32[(($st$11$0)>>2)];
  var $st$11$1=(($2+4)|0);
  var $6$1=HEAP32[(($st$11$1)>>2)];
  var $st$15$0=(($5)|0);
  HEAP32[(($st$15$0)>>2)]=$6$0;
  var $st$15$1=(($5+4)|0);
  HEAP32[(($st$15$1)>>2)]=$6$1;
  var $7=(($4+8)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  STACKTOP = __stackBase__;
  return;
}


function __ZN11cheat_entry18execute_run_scriptEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK11cheat_entry14has_run_scriptEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+152)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($2+596)|0);
      __ZN12cheat_script7executeER13cheat_managerRy($6, $8, $9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_var_init3571() {
  ;
  var __label__;

  __ZN8attotime7from_hzEd(__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE, 50);
  ;
  return;
}


function __ZN15cheat_parameter4itemC2EPKcyi($this, $text, $value$0, $value$1, $valformat) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$text;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$value$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$value$1;
      $4=$valformat;
      var $7=$1;
      var $8=(($7)|0);
      HEAP32[(($8)>>2)]=0;
      var $9=(($7+4)|0);
      var $10=$2;
      __ZN7astringC1EPKc($9, $10);
      var $11=(($7+68)|0);
      var $st$20$0=(($3)|0);
      var $12$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($3+4)|0);
      var $12$1=HEAP32[(($st$20$1)>>2)];
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN17number_and_formatC1Eyi($11, $12$0, $12$1, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      STACKTOP = __stackBase__;
      return;
    case 2: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $5=$17;
      var $18=$16.f1;
      $6=$18;
      var $19=(($7+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$5;
      var $23=$5;
      var $24=$6;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12sound_streamC2ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE($this, $device, $inputs, $outputs, $sample_rate, $param, $callback) {
  var __stackBase__  = STACKTOP; STACKTOP += 244; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $result_i5=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $result_i3=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $result_i1=__stackBase__+104;
      var $25=__stackBase__+108;
      var $26=__stackBase__+112;
      var $27=__stackBase__+116;
      var $28=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $result_i=__stackBase__+132;
      var $31=__stackBase__+136;
      var $32=__stackBase__+140;
      var $33;
      var $34;
      var $35;
      var $36;
      var $37;
      var $38;
      var $39;
      var $40;
      var $41;
      var $42;
      var $43;
      var $44;
      var $45;
      var $46;
      var $47;
      var $48;
      var $49;
      var $50;
      var $51;
      var $52;
      var $53;
      var $sound=__stackBase__+144;
      var $state_tag=__stackBase__+148;
      var $54=__stackBase__+212;
      var $55=__stackBase__+236;
      var $inputnum;
      var $outputnum;
      $53=0;
      $50=0;
      $47=0;
      $42=0;
      $33=$this;
      $34=$device;
      $35=$inputs;
      $36=$outputs;
      $37=$sample_rate;
      $38=$param;
      $39=$callback;
      var $56=$33;
      var $57=(($56)|0);
      var $58=$34;
      HEAP32[(($57)>>2)]=$58;
      var $59=(($56+4)|0);
      HEAP32[(($59)>>2)]=0;
      var $60=(($56+8)|0);
      var $61=$37;
      HEAP32[(($60)>>2)]=$61;
      var $62=(($56+12)|0);
      HEAP32[(($62)>>2)]=0;
      var $63=(($56+16)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$88$0=(($63)|0);
      HEAP32[(($st$88$0)>>2)]=$$emscripten$temp$0$0;
      var $st$88$1=(($63+4)|0);
      HEAP32[(($st$88$1)>>2)]=$$emscripten$temp$0$1;
      var $64=(($56+24)|0);
      HEAP32[(($64)>>2)]=0;
      var $65=(($56+28)|0);
      var $66=$35;
      HEAP32[(($65)>>2)]=$66;
      var $67=(($56+32)|0);
      var $68=$35;
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $70
      var $135 = 0;__label__ = 14; break;
    case 2: // $71
      var $72=$34;
      var $73=__ZNK8device_t7machineEv($72);
      var $74=__ZN15running_machine7respoolEv($73);
      var $75=$35;
      var $76=_llvm_umul_with_overflow_i32($75, 28);
      var $77=$76.f1;
      var $78=$76.f0;
      var $79=$77 ? -1 : $78;
      var $80=$27;
      var $81=$28;
      var $82=$29;
      var $83=$30;
      var $84=$result_i;
      var $85=$31;
      var $86=$32;
      HEAP32[(($27)>>2)]=$79;
      HEAP32[(($28)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($29)>>2)]=89;
      HEAP32[(($30)>>2)]=_zeromem;
      var $87=HEAP32[(($27)>>2)];
      var $88=HEAP32[(($28)>>2)];
      var $89=HEAP32[(($29)>>2)];
      var $90=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($87, $88, $89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $91
      HEAP32[(($result_i)>>2)]=$90;
      var $92=HEAP32[(($result_i)>>2)];
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $94
      var $95=___cxa_allocate_exception(4);
      var $96=$95;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($96);
      (function() { try { __THREW__ = false; return ___cxa_throw($95, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $99=$98.f0;
      HEAP32[(($31)>>2)]=$99;
      var $100=$98.f1;
      HEAP32[(($32)>>2)]=$100;
      var $101=HEAP32[(($32)>>2)];
      var $102=(($101)|0) < 0;
      if ($102) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $103
      var $104=HEAP32[(($31)>>2)];
      ___cxa_call_unexpected($104);
      throw "Reached an unreachable!"
    case 7: // $105
      var $106=HEAP32[(($31)>>2)];
      var $107=HEAP32[(($31)>>2)];
      var $108=HEAP32[(($32)>>2)];
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $111
      throw "Reached an unreachable!"
    case 9: // $_ZnajPKciRK9zeromem_t_exit
      var $112=HEAP32[(($result_i)>>2)];
      var $113=HEAP32[(($27)>>2)];
      _memset($112, 0, $113, 1);
      var $114=HEAP32[(($result_i)>>2)];
      var $115=$27;
      var $116=$28;
      var $117=$29;
      var $118=$30;
      var $119=$result_i;
      var $120=$31;
      var $121=$32;
      $40=$114;
      $41=$79;
      $42=1;
      var $122=$114;
      var $123=(($75)|0)==0;
      if ($123) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $124
      var $125=(($122+$75*28)|0);
      var $127 = $122;__label__ = 11; break;
    case 11: // $126
      var $127;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12sound_stream12stream_inputC1Ev]($127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 51; break; }
    case 12: // $128
      var $129=(($127+28)|0);
      var $130=(($129)|0)==(($125)|0);
      if ($130) { __label__ = 13; break; } else { var $127 = $129;__label__ = 11; break; }
    case 13: // $131
      var $132=$35;
      var $133=__ZN13resource_pool9add_arrayIN12sound_stream12stream_inputEEEPT_S4_i($74, $122, $132);
      var $135 = $133;__label__ = 14; break;
    case 14: // $134
      var $135;
      HEAP32[(($67)>>2)]=$135;
      var $136=(($56+36)|0);
      var $137=$35;
      var $138=(($137)|0)==0;
      if ($138) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $139
      var $195 = 0;__label__ = 24; break;
    case 16: // $140
      var $141=$34;
      var $142=__ZNK8device_t7machineEv($141);
      var $143=__ZN15running_machine7respoolEv($142);
      var $144=$35;
      var $145=_llvm_umul_with_overflow_i32($144, 4);
      var $146=$145.f1;
      var $147=$145.f0;
      var $148=$146 ? -1 : $147;
      var $149=$21;
      var $150=$22;
      var $151=$23;
      var $152=$24;
      var $153=$result_i1;
      var $154=$25;
      var $155=$26;
      HEAP32[(($21)>>2)]=$148;
      HEAP32[(($22)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($23)>>2)]=90;
      HEAP32[(($24)>>2)]=_zeromem;
      var $156=HEAP32[(($21)>>2)];
      var $157=HEAP32[(($22)>>2)];
      var $158=HEAP32[(($23)>>2)];
      var $159=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($156, $157, $158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $160
      HEAP32[(($result_i1)>>2)]=$159;
      var $161=HEAP32[(($result_i1)>>2)];
      var $162=(($161)|0)==0;
      if ($162) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $163
      var $164=___cxa_allocate_exception(4);
      var $165=$164;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($165);
      (function() { try { __THREW__ = false; return ___cxa_throw($164, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $166
      var $167=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $168=$167.f0;
      HEAP32[(($25)>>2)]=$168;
      var $169=$167.f1;
      HEAP32[(($26)>>2)]=$169;
      var $170=HEAP32[(($26)>>2)];
      var $171=(($170)|0) < 0;
      if ($171) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $172
      var $173=HEAP32[(($25)>>2)];
      ___cxa_call_unexpected($173);
      throw "Reached an unreachable!"
    case 21: // $174
      var $175=HEAP32[(($25)>>2)];
      var $176=HEAP32[(($25)>>2)];
      var $177=HEAP32[(($26)>>2)];
      var $178=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $176, tempValue);
      var $179=($178.f1 = $177, $178);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $180
      throw "Reached an unreachable!"
    case 23: // $_ZnajPKciRK9zeromem_t_exit2
      var $181=HEAP32[(($result_i1)>>2)];
      var $182=HEAP32[(($21)>>2)];
      _memset($181, 0, $182, 1);
      var $183=HEAP32[(($result_i1)>>2)];
      var $184=$21;
      var $185=$22;
      var $186=$23;
      var $187=$24;
      var $188=$result_i1;
      var $189=$25;
      var $190=$26;
      $45=$183;
      $46=$148;
      $47=1;
      var $191=$183;
      var $192=$35;
      var $193=__ZN13resource_pool9add_arrayIPiEEPT_S3_i($143, $191, $192);
      var $195 = $193;__label__ = 24; break;
    case 24: // $194
      var $195;
      HEAP32[(($136)>>2)]=$195;
      var $196=(($56+40)|0);
      HEAP32[(($196)>>2)]=0;
      var $197=(($56+44)|0);
      var $198=$36;
      HEAP32[(($197)>>2)]=$198;
      var $199=(($56+48)|0);
      var $200=$36;
      var $201=(($200)|0)==0;
      if ($201) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $202
      var $267 = 0;__label__ = 38; break;
    case 26: // $203
      var $204=$34;
      var $205=__ZNK8device_t7machineEv($204);
      var $206=__ZN15running_machine7respoolEv($205);
      var $207=$36;
      var $208=_llvm_umul_with_overflow_i32($207, 16);
      var $209=$208.f1;
      var $210=$208.f0;
      var $211=$209 ? -1 : $210;
      var $212=$15;
      var $213=$16;
      var $214=$17;
      var $215=$18;
      var $216=$result_i3;
      var $217=$19;
      var $218=$20;
      HEAP32[(($15)>>2)]=$211;
      HEAP32[(($16)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($17)>>2)]=93;
      HEAP32[(($18)>>2)]=_zeromem;
      var $219=HEAP32[(($15)>>2)];
      var $220=HEAP32[(($16)>>2)];
      var $221=HEAP32[(($17)>>2)];
      var $222=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($219, $220, $221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $223
      HEAP32[(($result_i3)>>2)]=$222;
      var $224=HEAP32[(($result_i3)>>2)];
      var $225=(($224)|0)==0;
      if ($225) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $226
      var $227=___cxa_allocate_exception(4);
      var $228=$227;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($228);
      (function() { try { __THREW__ = false; return ___cxa_throw($227, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 29; break; }
    case 29: // $229
      var $230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $231=$230.f0;
      HEAP32[(($19)>>2)]=$231;
      var $232=$230.f1;
      HEAP32[(($20)>>2)]=$232;
      var $233=HEAP32[(($20)>>2)];
      var $234=(($233)|0) < 0;
      if ($234) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $235
      var $236=HEAP32[(($19)>>2)];
      ___cxa_call_unexpected($236);
      throw "Reached an unreachable!"
    case 31: // $237
      var $238=HEAP32[(($19)>>2)];
      var $239=HEAP32[(($19)>>2)];
      var $240=HEAP32[(($20)>>2)];
      var $241=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $239, tempValue);
      var $242=($241.f1 = $240, $241);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 32: // $243
      throw "Reached an unreachable!"
    case 33: // $_ZnajPKciRK9zeromem_t_exit4
      var $244=HEAP32[(($result_i3)>>2)];
      var $245=HEAP32[(($15)>>2)];
      _memset($244, 0, $245, 1);
      var $246=HEAP32[(($result_i3)>>2)];
      var $247=$15;
      var $248=$16;
      var $249=$17;
      var $250=$18;
      var $251=$result_i3;
      var $252=$19;
      var $253=$20;
      $48=$246;
      $49=$211;
      $50=1;
      var $254=$246;
      var $255=(($207)|0)==0;
      if ($255) { __label__ = 37; break; } else { __label__ = 34; break; }
    case 34: // $256
      var $257=(($254+($207<<4))|0);
      var $259 = $254;__label__ = 35; break;
    case 35: // $258
      var $259;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12sound_stream13stream_outputC1Ev]($259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 56; break; }
    case 36: // $260
      var $261=(($259+16)|0);
      var $262=(($261)|0)==(($257)|0);
      if ($262) { __label__ = 37; break; } else { var $259 = $261;__label__ = 35; break; }
    case 37: // $263
      var $264=$36;
      var $265=__ZN13resource_pool9add_arrayIN12sound_stream13stream_outputEEEPT_S4_i($206, $254, $264);
      var $267 = $265;__label__ = 38; break;
    case 38: // $266
      var $267;
      HEAP32[(($199)>>2)]=$267;
      var $268=(($56+52)|0);
      var $269=$36;
      var $270=(($269)|0)==0;
      if ($270) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $271
      var $327 = 0;__label__ = 48; break;
    case 40: // $272
      var $273=$34;
      var $274=__ZNK8device_t7machineEv($273);
      var $275=__ZN15running_machine7respoolEv($274);
      var $276=$36;
      var $277=_llvm_umul_with_overflow_i32($276, 4);
      var $278=$277.f1;
      var $279=$277.f0;
      var $280=$278 ? -1 : $279;
      var $281=$9;
      var $282=$10;
      var $283=$11;
      var $284=$12;
      var $285=$result_i5;
      var $286=$13;
      var $287=$14;
      HEAP32[(($9)>>2)]=$280;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($11)>>2)]=94;
      HEAP32[(($12)>>2)]=_zeromem;
      var $288=HEAP32[(($9)>>2)];
      var $289=HEAP32[(($10)>>2)];
      var $290=HEAP32[(($11)>>2)];
      var $291=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($288, $289, $290) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; };
    case 41: // $292
      HEAP32[(($result_i5)>>2)]=$291;
      var $293=HEAP32[(($result_i5)>>2)];
      var $294=(($293)|0)==0;
      if ($294) { __label__ = 42; break; } else { __label__ = 47; break; }
    case 42: // $295
      var $296=___cxa_allocate_exception(4);
      var $297=$296;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($297);
      (function() { try { __THREW__ = false; return ___cxa_throw($296, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 43; break; }
    case 43: // $298
      var $299=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $300=$299.f0;
      HEAP32[(($13)>>2)]=$300;
      var $301=$299.f1;
      HEAP32[(($14)>>2)]=$301;
      var $302=HEAP32[(($14)>>2)];
      var $303=(($302)|0) < 0;
      if ($303) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $304
      var $305=HEAP32[(($13)>>2)];
      ___cxa_call_unexpected($305);
      throw "Reached an unreachable!"
    case 45: // $306
      var $307=HEAP32[(($13)>>2)];
      var $308=HEAP32[(($13)>>2)];
      var $309=HEAP32[(($14)>>2)];
      var $310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $308, tempValue);
      var $311=($310.f1 = $309, $310);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $312
      throw "Reached an unreachable!"
    case 47: // $_ZnajPKciRK9zeromem_t_exit6
      var $313=HEAP32[(($result_i5)>>2)];
      var $314=HEAP32[(($9)>>2)];
      _memset($313, 0, $314, 1);
      var $315=HEAP32[(($result_i5)>>2)];
      var $316=$9;
      var $317=$10;
      var $318=$11;
      var $319=$12;
      var $320=$result_i5;
      var $321=$13;
      var $322=$14;
      $51=$315;
      $52=$280;
      $53=1;
      var $323=$315;
      var $324=$36;
      var $325=__ZN13resource_pool9add_arrayIPiEEPT_S3_i($275, $323, $324);
      var $327 = $325;__label__ = 48; break;
    case 48: // $326
      var $327;
      HEAP32[(($268)>>2)]=$327;
      var $328=(($56+56)|0);
      HEAP32[(($328)>>2)]=0;
      var $329=(($56+60)|0);
      HEAP32[(($329)>>2)]=0;
      var $330=(($56+64)|0);
      HEAP32[(($330)>>2)]=0;
      var $331=(($56+68)|0);
      HEAP32[(($331)>>2)]=0;
      var $332=(($56+72)|0);
      var $333=$39;
      HEAP32[(($332)>>2)]=$333;
      var $334=(($56+76)|0);
      var $335=$38;
      HEAP32[(($334)>>2)]=$335;
      var $336=$34;
      var $337=__ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_($336, $sound);
      if ($337) { __label__ = 62; break; } else { __label__ = 49; break; }
    case 49: // $338
      var $339=___cxa_allocate_exception(1032);
      var $340=$339;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($340, ((STRING_TABLE.__str13539)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 61; break; }
    case 50: // $341
      ___cxa_throw($339, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 51: // $342
      var $343=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $344=$343.f0;
      $43=$344;
      var $345=$343.f1;
      $44=$345;
      var $346=$40;
      var $347=$5;
      var $348=$6;
      var $349=$7;
      var $350=$8;
      HEAP32[(($5)>>2)]=$346;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($7)>>2)]=89;
      HEAP32[(($8)>>2)]=_zeromem;
      var $351=HEAP32[(($5)>>2)];
      var $352=(($351)|0)!=0;
      if ($352) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $353
      var $354=HEAP32[(($5)>>2)];
      var $355=HEAP32[(($6)>>2)];
      var $356=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($354, $355, $356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 97; break; }
    case 53: // $_noexc
      __label__ = 54; break;
    case 54: // $_ZdaPvPKciRK9zeromem_t_exit
      var $357=$5;
      var $358=$6;
      var $359=$7;
      var $360=$8;
      __label__ = 55; break;
    case 55: // $361
      __label__ = 96; break;
    case 56: // $362
      var $363=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $364=$363.f0;
      $43=$364;
      var $365=$363.f1;
      $44=$365;
      var $366=$48;
      var $367=$1;
      var $368=$2;
      var $369=$3;
      var $370=$4;
      HEAP32[(($1)>>2)]=$366;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($3)>>2)]=93;
      HEAP32[(($4)>>2)]=_zeromem;
      var $371=HEAP32[(($1)>>2)];
      var $372=(($371)|0)!=0;
      if ($372) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $373
      var $374=HEAP32[(($1)>>2)];
      var $375=HEAP32[(($2)>>2)];
      var $376=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($374, $375, $376) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 97; break; }
    case 58: // $_noexc7
      __label__ = 59; break;
    case 59: // $_ZdaPvPKciRK9zeromem_t_exit8
      var $377=$1;
      var $378=$2;
      var $379=$3;
      var $380=$4;
      __label__ = 60; break;
    case 60: // $381
      __label__ = 96; break;
    case 61: // $382
      var $383=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $384=$383.f0;
      $43=$384;
      var $385=$383.f1;
      $44=$385;
      ___cxa_free_exception($339);
      __label__ = 96; break;
    case 62: // $386
      var $387=(($56+72)|0);
      var $388=HEAP32[(($387)>>2)];
      var $389=(($388)|0)==854;
      if ($389) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $390
      var $391=HEAP32[(($sound)>>2)];
      var $392=$391;
      var $393=(($56+76)|0);
      HEAP32[(($393)>>2)]=$392;
      __label__ = 64; break;
    case 64: // $394
      __ZN7astringC1Ev($state_tag);
      var $395=(($56)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($396) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 84; break; };
    case 65: // $398
      var $399=(function() { try { __THREW__ = false; return __ZNK15running_machine5soundEv($397) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 84; break; };
    case 66: // $400
      var $401=(($399+40)|0);
      var $402=(function() { try { __THREW__ = false; return __ZNK11simple_listI12sound_streamE5countEv($401) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 84; break; };
    case 67: // $403
      var $404=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($state_tag, ((STRING_TABLE.__str23540)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$402,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 84; break; };
    case 68: // $405
      var $406=(($56)|0);
      var $407=HEAP32[(($406)>>2)];
      var $408=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($407) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 84; break; };
    case 69: // $409
      var $410=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($408) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 84; break; };
    case 70: // $411
      var $412=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($state_tag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 84; break; };
    case 71: // $413
      var $414=(($56+8)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemIjEEvPKcS2_iRT_S2_($410, ((STRING_TABLE.__str33541)|0), $412, 0, $414, ((STRING_TABLE.__str43542)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 84; break; }
    case 72: // $415
      var $416=(($56)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($417) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 84; break; };
    case 73: // $419
      var $420=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($418) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 84; break; };
    case 74: // $421
      HEAP32[(($55)>>2)]={ f0: 852, f1: 0 }.f0; HEAP32[(($55+4)>>2)]={ f0: 852, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I12sound_streamEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($54, $55, ((STRING_TABLE.__str53543)|0), $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 84; break; }
    case 75: // $422
      (function() { try { __THREW__ = false; return __ZN12save_manager17register_postloadE8delegateIFvvEE($420, $54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 84; break; }
    case 76: // $423
      $inputnum=0;
      __label__ = 77; break;
    case 77: // $424
      var $425=$inputnum;
      var $426=(($56+28)|0);
      var $427=HEAP32[(($426)>>2)];
      var $428=(($425)|0) < (($427)|0);
      if ($428) { __label__ = 78; break; } else { __label__ = 85; break; }
    case 78: // $429
      var $430=(($56)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($431) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 84; break; };
    case 79: // $433
      var $434=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 84; break; };
    case 80: // $435
      var $436=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($state_tag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 84; break; };
    case 81: // $437
      var $438=$inputnum;
      var $439=$inputnum;
      var $440=(($56+32)|0);
      var $441=HEAP32[(($440)>>2)];
      var $442=(($441+$439*28)|0);
      var $443=(($442+24)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemIsEEvPKcS2_iRT_S2_($434, ((STRING_TABLE.__str33541)|0), $436, $438, $443, ((STRING_TABLE.__str63544)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 84; break; }
    case 82: // $444
      __label__ = 83; break;
    case 83: // $445
      var $446=$inputnum;
      var $447=(($446+1)|0);
      $inputnum=$447;
      __label__ = 77; break;
    case 84: // $448
      var $449=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $450=$449.f0;
      $43=$450;
      var $451=$449.f1;
      $44=$451;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($state_tag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 97; break; }
    case 85: // $452
      $outputnum=0;
      __label__ = 86; break;
    case 86: // $453
      var $454=$outputnum;
      var $455=(($56+44)|0);
      var $456=HEAP32[(($455)>>2)];
      var $457=(($454)|0) < (($456)|0);
      if ($457) { __label__ = 87; break; } else { __label__ = 93; break; }
    case 87: // $458
      var $459=$outputnum;
      var $460=(($56+48)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=(($461+($459<<4))|0);
      var $463=(($462)|0);
      HEAP32[(($463)>>2)]=$56;
      var $464=(($56)|0);
      var $465=HEAP32[(($464)>>2)];
      var $466=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($465) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 84; break; };
    case 88: // $467
      var $468=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($466) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 84; break; };
    case 89: // $469
      var $470=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($state_tag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 84; break; };
    case 90: // $471
      var $472=$outputnum;
      var $473=$outputnum;
      var $474=(($56+48)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=(($475+($473<<4))|0);
      var $477=(($476+12)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemIsEEvPKcS2_iRT_S2_($468, ((STRING_TABLE.__str33541)|0), $470, $472, $477, ((STRING_TABLE.__str73545)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 84; break; }
    case 91: // $478
      __label__ = 92; break;
    case 92: // $479
      var $480=$outputnum;
      var $481=(($480+1)|0);
      $outputnum=$481;
      __label__ = 86; break;
    case 93: // $482
      (function() { try { __THREW__ = false; return __ZN12sound_stream26recompute_sample_rate_dataEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 84; break; }
    case 94: // $483
      var $484=(($56+24)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=(((-$485))|0);
      var $487=(($56+68)|0);
      HEAP32[(($487)>>2)]=$486;
      FUNCTION_TABLE[__ZN7astringD1Ev]($state_tag);
      STACKTOP = __stackBase__;
      return;
    case 95: // $488
      __label__ = 96; break;
    case 96: // $489
      var $490=$43;
      var $491=$43;
      var $492=$44;
      var $493=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $491, tempValue);
      var $494=($493.f1 = $492, $493);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 97: // $495
      var $496=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_streamC2ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE["X"]=1;

function __ZNK11simple_listI12sound_streamE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12sound_stream10input_gainEi($this, $inputnum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$inputnum;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$6*28)|0);
      var $10=(($9+24)|0);
      var $11=HEAP16[(($10)>>1)];
      var $12=(($11 << 16) >> 16);
      var $13=$12/256;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12sound_stream18initial_input_gainEi($this, $inputnum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$inputnum;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$6*28)|0);
      var $10=(($9+26)|0);
      var $11=HEAP16[(($10)>>1)];
      var $12=(($11 << 16) >> 16);
      var $13=$12/256;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12sound_stream6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN12sound_stream25device_stream_update_stubEP8device_tPS_PvPPiS5_i($device, $stream, $param, $inputs, $outputs, $samples) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $sound;
  $1=$device;
  $2=$stream;
  $3=$param;
  $4=$inputs;
  $5=$outputs;
  $6=$samples;
  var $7=$3;
  var $8=$7;
  $sound=$8;
  var $9=$sound;
  var $10=$9;
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+56)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=$2;
  var $15=$4;
  var $16=$5;
  var $17=$6;
  FUNCTION_TABLE[$13]($9, $14, $15, $16, $17);
  ;
  return;
}


function __ZN8delegateIFvvEEC1I12sound_streamEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I12sound_streamEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN12sound_stream8postloadEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $outputnum;
      var $2=__stackBase__;
      $1=$this;
      var $3=$1;
      __ZN12sound_stream26recompute_sample_rate_dataEv($3);
      $outputnum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$outputnum;
      var $6=(($3+44)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($5)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$outputnum;
      var $11=(($3+48)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+($10<<4))|0);
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15;
      var $17=(($3+56)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=((($18<<2))|0);
      _memset($16, 0, $19, 1);
      __label__ = 3; break;
    case 3: // $20
      var $21=$outputnum;
      var $22=(($21+1)|0);
      $outputnum=$22;
      __label__ = 1; break;
    case 4: // $23
      var $24=(($3)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZNK8device_t7machineEv($25);
      var $27=__ZNK15running_machine5soundEv($26);
      __ZNK13sound_manager11last_updateEv($2, $27);
      var $28=(($2+4)|0);
      var $st$6$0=(($28)|0);
      var $29$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$6$1)>>2)];
      var $30=(($3+16)|0);
      var $st$11$0=(($30)|0);
      var $31$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($30+4)|0);
      var $31$1=HEAP32[(($st$11$1)>>2)];
      var $32$0 = (tempBigIntR=((($29$0)>>>0)+((($29$1)|0)*4294967296))/((($31$0)>>>0)+((($31$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $32$1 = Math.min(Math.floor(((tempBigIntR=((($29$0)>>>0)+((($29$1)|0)*4294967296))/((($31$0)>>>0)+((($31$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $33$0=$32$0;
      var $33=$33$0;
      var $34=(($3+60)|0);
      HEAP32[(($34)>>2)]=$33;
      var $35=(($3+60)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($3+64)|0);
      HEAP32[(($37)>>2)]=$36;
      var $38=(($3+60)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($3+24)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($39-$41)|0);
      var $43=(($3+68)|0);
      HEAP32[(($43)>>2)]=$42;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream8postloadEv["X"]=1;

function __ZN12save_manager9save_itemIsEEvPKcS2_iRT_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=$12;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 2, 1);
  ;
  return;
}


function __ZN12sound_stream26recompute_sample_rate_dataEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $update_attoseconds=__stackBase__;
      var $inputnum;
      var $input;
      var $new_attosecs_per_sample=__stackBase__+8;
      var $latency=__stackBase__+16;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      var $6=__ZNK15running_machine5soundEv($5);
      var $7=__ZNK13sound_manager18update_attosecondsEv($6);
      var $7$0=$7[0];
      var $7$1=$7[1];
      var $st$15$0=(($update_attoseconds)|0);
      HEAP32[(($st$15$0)>>2)]=$7$0;
      var $st$15$1=(($update_attoseconds+4)|0);
      HEAP32[(($st$15$1)>>2)]=$7$1;
      var $8=(($2+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10$0=$9;
      var $10$1=0;
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $11$0 = (tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($10$0)>>>0)+((($10$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $11$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($10$0)>>>0)+((($10$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $12=(($2+16)|0);
      var $st$27$0=(($12)|0);
      HEAP32[(($st$27$0)>>2)]=$11$0;
      var $st$27$1=(($12+4)|0);
      HEAP32[(($st$27$1)>>2)]=$11$1;
      var $st$31$0=(($update_attoseconds)|0);
      var $13$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($update_attoseconds+4)|0);
      var $13$1=HEAP32[(($st$31$1)>>2)];
      var $14=(($2+16)|0);
      var $st$36$0=(($14)|0);
      var $15$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$36$1)>>2)];
      var $16$0 = ((($13$0)>>>0)+((($13$1)|0)*4294967296))+((($15$0)>>>0)+((($15$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($13$0)>>>0)+((($13$1)|0)*4294967296))+((($15$0)>>>0)+((($15$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $17$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $17$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $18=(($2+16)|0);
      var $st$45$0=(($18)|0);
      var $19$0=HEAP32[(($st$45$0)>>2)];
      var $st$45$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$45$1)>>2)];
      var $20$0 = (tempBigIntR=((($17$0)>>>0)+((($17$1)|0)*4294967296))/((($19$0)>>>0)+((($19$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $20$1 = Math.min(Math.floor(((tempBigIntR=((($17$0)>>>0)+((($17$1)|0)*4294967296))/((($19$0)>>>0)+((($19$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $21$0=$20$0;
      var $21=$21$0;
      var $22=(($2+24)|0);
      HEAP32[(($22)>>2)]=$21;
      __ZN12sound_stream25allocate_resample_buffersEv($2);
      __ZN12sound_stream23allocate_output_buffersEv($2);
      $inputnum=0;
      __label__ = 1; break;
    case 1: // $23
      var $24=$inputnum;
      var $25=(($2+28)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($24)|0) < (($26)|0);
      if ($27) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $28
      var $29=$inputnum;
      var $30=(($2+32)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+$29*28)|0);
      $input=$32;
      var $33=$input;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $37
      var $38=$input;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+8)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45$0=$44;
      var $45$1=0;
      var $$emscripten$temp$2$0=-1486618624;
      var $$emscripten$temp$2$1=232830643;
      var $46$0 = (tempBigIntR=((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))/((($45$0)>>>0)+((($45$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $46$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))/((($45$0)>>>0)+((($45$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$12$0=(($new_attosecs_per_sample)|0);
      HEAP32[(($st$12$0)>>2)]=$46$0;
      var $st$12$1=(($new_attosecs_per_sample+4)|0);
      HEAP32[(($st$12$1)>>2)]=$46$1;
      var $st$16$0=(($new_attosecs_per_sample)|0);
      var $47$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($new_attosecs_per_sample+4)|0);
      var $47$1=HEAP32[(($st$16$1)>>2)];
      var $48=(($2+16)|0);
      var $st$21$0=(($48)|0);
      var $49$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($48+4)|0);
      var $49$1=HEAP32[(($st$21$1)>>2)];
      var $50=($47$1|0) > ($49$1|0) || (($47$1|0) == ($49$1|0) && ($47$0|0) >  ($49$0|0));
      if ($50) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $51
      var $st$0$0=(($new_attosecs_per_sample)|0);
      var $52$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($new_attosecs_per_sample+4)|0);
      var $52$1=HEAP32[(($st$0$1)>>2)];
      var $57$1 = $52$1;var $57$0 = $52$0;__label__ = 6; break;
    case 5: // $53
      var $54=(($2+16)|0);
      var $st$1$0=(($54)|0);
      var $55$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($54+4)|0);
      var $55$1=HEAP32[(($st$1$1)>>2)];
      var $57$1 = $55$1;var $57$0 = $55$0;__label__ = 6; break;
    case 6: // $56
      var $57$0;
      var $57$1;
      var $st$2$0=(($latency)|0);
      HEAP32[(($st$2$0)>>2)]=$57$0;
      var $st$2$1=(($latency+4)|0);
      HEAP32[(($st$2$1)>>2)]=$57$1;
      var $58=$input;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+8)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=(($2+8)|0);
      var $66=HEAPU32[(($65)>>2)];
      var $67=(($64)>>>0) < (($66)>>>0);
      if ($67) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $68
      var $st$0$0=(($new_attosecs_per_sample)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($new_attosecs_per_sample+4)|0);
      var $69$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($latency)|0);
      var $70$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($latency+4)|0);
      var $70$1=HEAP32[(($st$4$1)>>2)];
      var $71$0 = ((($70$0)>>>0)+((($70$1)|0)*4294967296))+((($69$0)>>>0)+((($69$1)|0)*4294967296))>>>0; var $71$1 = Math.min(Math.floor((((($70$0)>>>0)+((($70$1)|0)*4294967296))+((($69$0)>>>0)+((($69$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($latency)|0);
      HEAP32[(($st$9$0)>>2)]=$71$0;
      var $st$9$1=(($latency+4)|0);
      HEAP32[(($st$9$1)>>2)]=$71$1;
      __label__ = 11; break;
    case 8: // $72
      var $73=$input;
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+8)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($2+8)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($79)|0)==(($81)|0);
      if ($82) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $83
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$2$0=(($latency)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$3$0;
      var $st$2$1=(($latency+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 10; break;
    case 10: // $84
      __label__ = 11; break;
    case 11: // $85
      var $86=$input;
      var $87=(($86+16)|0);
      var $st$2$0=(($87)|0);
      var $88$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($87+4)|0);
      var $88$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($latency)|0);
      var $89$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($latency+4)|0);
      var $89$1=HEAP32[(($st$6$1)>>2)];
      var $90=($88$1|0) > ($89$1|0) || (($88$1|0) == ($89$1|0) && ($88$0|0) >  ($89$0|0));
      if ($90) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $91
      var $92=$input;
      var $93=(($92+16)|0);
      var $st$2$0=(($93)|0);
      var $94$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($93+4)|0);
      var $94$1=HEAP32[(($st$2$1)>>2)];
      var $98$1 = $94$1;var $98$0 = $94$0;__label__ = 14; break;
    case 13: // $95
      var $st$0$0=(($latency)|0);
      var $96$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($latency+4)|0);
      var $96$1=HEAP32[(($st$0$1)>>2)];
      var $98$1 = $96$1;var $98$0 = $96$0;__label__ = 14; break;
    case 14: // $97
      var $98$0;
      var $98$1;
      var $99=$input;
      var $100=(($99+16)|0);
      var $st$4$0=(($100)|0);
      HEAP32[(($st$4$0)>>2)]=$98$0;
      var $st$4$1=(($100+4)|0);
      HEAP32[(($st$4$1)>>2)]=$98$1;
      __label__ = 15; break;
    case 15: // $101
      __label__ = 16; break;
    case 16: // $102
      __label__ = 17; break;
    case 17: // $103
      __label__ = 18; break;
    case 18: // $104
      var $105=$inputnum;
      var $106=(($105+1)|0);
      $inputnum=$106;
      __label__ = 1; break;
    case 19: // $107
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream26recompute_sample_rate_dataEv["X"]=1;

function __ZNK13sound_manager11last_updateEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  var $4=$agg_result;
  var $5=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];HEAP32[(($4+8)>>2)]=HEAP32[(($5+8)>>2)];
  ;
  return;
}


function __ZNK12sound_stream10input_nameEiR7astring($this, $inputnum, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $source;
      var $sound=__stackBase__;
      var $outstream;
      var $streamoutputnum=__stackBase__+4;
      var $outputnum;
      $1=$this;
      $2=$inputnum;
      $3=$string;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$3;
      var $8=(($4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($9);
      var $11=(($4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__ZNK8device_t3tagEv($12);
      var $14=__ZN7astring6printfEPKcz($7, ((STRING_TABLE.__str83546)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,HEAP32[((tempInt+4)>>2)]=$13,tempInt));
      var $15=$2;
      var $16=(($4+32)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+$15*28)|0);
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $22
      var $23=$2;
      var $24=(($4+32)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+$23*28)|0);
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($4+32)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+$33*28)|0);
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=__ZNK12sound_stream6deviceEv($40);
      $source=$41;
      var $42=$3;
      var $43=$source;
      var $44=__ZNK8device_t4nameEv($43);
      var $45=$source;
      var $46=__ZNK8device_t3tagEv($45);
      var $47=__ZN7astring9catprintfEPKcz($42, ((STRING_TABLE.__str93547)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$44,HEAP32[((tempInt+4)>>2)]=$46,tempInt));
      var $48=$source;
      var $49=__ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_($48, $sound);
      if ($49) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $50
      var $51=HEAP32[(($sound)>>2)];
      var $52=__ZNK22device_sound_interface7outputsEv($51);
      var $53=(($52)|0) > 1;
      if ($53) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $54
      $outputnum=0;
      __label__ = 7; break;
    case 7: // $55
      var $56=HEAP32[(($sound)>>2)];
      var $57=$outputnum;
      var $58=__ZN22device_sound_interface23output_to_stream_outputEiRi($56, $57, $streamoutputnum);
      $outstream=$58;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $60
      var $61=$outstream;
      var $62=$2;
      var $63=(($4+32)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+$62*28)|0);
      var $66=(($65)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($61)|0)==(($69)|0);
      if ($70) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $71
      var $72=$2;
      var $73=(($4+32)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+$72*28)|0);
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=HEAP32[(($streamoutputnum)>>2)];
      var $79=$outstream;
      var $80=(($79+48)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+($78<<4))|0);
      var $83=(($77)|0)==(($82)|0);
      if ($83) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $84
      var $85=$3;
      var $86=$outputnum;
      var $87=__ZN7astring9catprintfEPKcz($85, ((STRING_TABLE.__str103548)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$86,tempInt));
      __label__ = 13; break;
    case 11: // $88
      __label__ = 12; break;
    case 12: // $89
      var $90=$outputnum;
      var $91=(($90+1)|0);
      $outputnum=$91;
      __label__ = 7; break;
    case 13: // $92
      __label__ = 14; break;
    case 14: // $93
      __label__ = 15; break;
    case 15: // $94
      var $95=$3;
      var $96=__ZNK7astringcvPKcEv($95);
      STACKTOP = __stackBase__;
      return $96;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK12sound_stream10input_nameEiR7astring["X"]=1;

function __ZN13resource_pool9add_arrayIN12sound_stream12stream_inputEEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN12sound_stream12stream_inputEEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIN12sound_stream12stream_inputEEEPT_S4_i["X"]=1;

function __ZN13resource_pool9add_arrayIPiEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIPiEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIPiEEPT_S3_i["X"]=1;

function __ZN13resource_pool9add_arrayIN12sound_stream13stream_outputEEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN12sound_stream13stream_outputEEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIN12sound_stream13stream_outputEEEPT_S4_i["X"]=1;

function __ZNK12sound_stream11sample_rateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $13 = $8;__label__ = 3; break;
    case 2: // $9
      var $10=(($2+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $13 = $11;__label__ = 3; break;
    case 3: // $12
      var $13;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13sound_manager18update_attosecondsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+60)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZN12sound_stream6updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $time=__stackBase__;
      var $update_sampindex;
      var $last_update=__stackBase__+12;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK8device_t7machineEv($4);
      __ZNK15running_machine4timeEv($time, $5);
      var $6=(($time+4)|0);
      var $st$11$0=(($6)|0);
      var $7$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$11$1)>>2)];
      var $8=(($2+16)|0);
      var $st$16$0=(($8)|0);
      var $9$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($8+4)|0);
      var $9$1=HEAP32[(($st$16$1)>>2)];
      var $10$0 = (tempBigIntR=((($7$0)>>>0)+((($7$1)|0)*4294967296))/((($9$0)>>>0)+((($9$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $10$1 = Math.min(Math.floor(((tempBigIntR=((($7$0)>>>0)+((($7$1)|0)*4294967296))/((($9$0)>>>0)+((($9$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $11$0=$10$0;
      var $11=$11$0;
      $update_sampindex=$11;
      var $12=(($2)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK8device_t7machineEv($13);
      var $15=__ZNK15running_machine5soundEv($14);
      __ZNK13sound_manager11last_updateEv($last_update, $15);
      var $16=(($time)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($last_update)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($17)|0) > (($19)|0);
      if ($20) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $21
      __label__ = 2; break;
    case 2: // $22
      __label__ = 3; break;
    case 3: // $23
      var $24=(($2+8)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$update_sampindex;
      var $27=(($26+$25)|0);
      $update_sampindex=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=(($time)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($last_update)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($30)|0) < (($32)|0);
      if ($33) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $34
      __label__ = 6; break;
    case 6: // $35
      __label__ = 7; break;
    case 7: // $36
      var $37=(($2+8)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$update_sampindex;
      var $40=(($39-$38)|0);
      $update_sampindex=$40;
      __label__ = 8; break;
    case 8: // $41
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 268);
      __label__ = 9; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      __label__ = 11; break;
    case 11: // $44
      __label__ = 12; break;
    case 12: // $45
      var $46=$update_sampindex;
      var $47=(($2+60)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($46-$48)|0);
      __ZN12sound_stream16generate_samplesEi($2, $49);
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $50=$update_sampindex;
      var $51=(($2+60)|0);
      HEAP32[(($51)>>2)]=$50;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream6updateEv["X"]=1;

function __ZN12sound_stream16generate_samplesEi($this, $samples) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $inputnum;
      var $input;
      var $outputnum;
      var $output;
      $1=$this;
      $2=$samples;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0) <= 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 18; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      $inputnum=0;
      __label__ = 5; break;
    case 5: // $10
      var $11=$inputnum;
      var $12=(($3+28)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($11)|0) < (($13)|0);
      if ($14) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $15
      var $16=$inputnum;
      var $17=(($3+32)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+$16*28)|0);
      $input=$19;
      var $20=$input;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $24
      var $25=$input;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      __ZN12sound_stream6updateEv($29);
      __label__ = 8; break;
    case 8: // $30
      var $31=$input;
      var $32=$2;
      var $33=__ZN12sound_stream23generate_resampled_dataERNS_12stream_inputEj($3, $31, $32);
      var $34=$inputnum;
      var $35=(($3+36)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+($34<<2))|0);
      HEAP32[(($37)>>2)]=$33;
      __label__ = 9; break;
    case 9: // $38
      var $39=$inputnum;
      var $40=(($39+1)|0);
      $inputnum=$40;
      __label__ = 5; break;
    case 10: // $41
      $outputnum=0;
      __label__ = 11; break;
    case 11: // $42
      var $43=$outputnum;
      var $44=(($3+44)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($43)|0) < (($45)|0);
      if ($46) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $47
      var $48=$outputnum;
      var $49=(($3+48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+($48<<4))|0);
      $output=$51;
      var $52=$output;
      var $53=(($52+4)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($3+60)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($3+68)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($56-$58)|0);
      var $60=(($54+($59<<2))|0);
      var $61=$outputnum;
      var $62=(($3+52)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+($61<<2))|0);
      HEAP32[(($64)>>2)]=$60;
      __label__ = 13; break;
    case 13: // $65
      var $66=$outputnum;
      var $67=(($66+1)|0);
      $outputnum=$67;
      __label__ = 11; break;
    case 14: // $68
      __label__ = 15; break;
    case 15: // $69
      __label__ = 16; break;
    case 16: // $70
      var $71=(($3+72)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($3)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($3+76)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($3+36)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($3+52)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$2;
      FUNCTION_TABLE[$72]($74, $3, $76, $78, $80, $81);
      __label__ = 17; break;
    case 17: // $82
      __label__ = 18; break;
    case 18: // $83
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream16generate_samplesEi["X"]=1;

function __ZN12sound_stream24output_since_last_updateEiRi($this, $outputnum, $numsamples) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$outputnum;
  $3=$numsamples;
  var $4=$1;
  __ZN12sound_stream6updateEv($4);
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+64)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($6-$8)|0);
  var $10=$3;
  HEAP32[(($10)>>2)]=$9;
  var $11=$2;
  var $12=(($4+48)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=(($13+($11<<4))|0);
  var $15=(($14+4)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=(($4+64)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=(($4+68)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=(($18-$20)|0);
  var $22=(($16+($21<<2))|0);
  ;
  return $22;
}


function __ZN12sound_stream15set_sample_rateEi($this, $new_rate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$new_rate;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK12sound_stream11sample_rateEv($3);
      var $6=(($4)|0)!=(($5)|0);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($3+12)|0);
      HEAP32[(($9)>>2)]=$8;
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12sound_stream14set_input_gainEif($this, $inputnum, $gain) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$inputnum;
      $3=$gain;
      var $4=$1;
      __ZN12sound_stream6updateEv($4);
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$3;
      var $8=$7*256;
      var $9=(($8)|0);
      var $10=(($9) & 65535);
      var $11=$2;
      var $12=(($4+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$11*28)|0);
      var $15=(($14+24)|0);
      HEAP16[(($15)>>1)]=$10;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12sound_stream22update_with_accountingEb($this, $second_tick) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $output_bufindex;
      var $samples_to_lose;
      var $outputnum;
      var $output;
      $1=$this;
      var $3=(($second_tick)&1);
      $2=$3;
      var $4=$1;
      __ZN12sound_stream6updateEv($4);
      var $5=(($4+60)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4+68)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($6-$8)|0);
      $output_bufindex=$9;
      var $10=$2;
      var $11=(($10) & 1);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=(($4+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($4+60)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16-$14)|0);
      HEAP32[(($15)>>2)]=$17;
      var $18=(($4+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($4+68)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21-$19)|0);
      HEAP32[(($20)>>2)]=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=(($4+60)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($4+64)|0);
      HEAP32[(($26)>>2)]=$25;
      var $27=(($4+56)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$output_bufindex;
      var $30=(($28-$29)|0);
      var $31=(($4+24)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=((($32<<1))|0);
      var $34=(($30)>>>0) < (($33)>>>0);
      if ($34) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $35
      var $36=$output_bufindex;
      var $37=(($4+24)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($36-$38)|0);
      $samples_to_lose=$39;
      var $40=$samples_to_lose;
      var $41=(($40)|0) > 0;
      if ($41) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $42
      var $43=$output_bufindex;
      var $44=(($43)|0) > 0;
      if ($44) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $45
      $outputnum=0;
      __label__ = 6; break;
    case 6: // $46
      var $47=$outputnum;
      var $48=(($4+44)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($47)|0) < (($49)|0);
      if ($50) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $51
      var $52=$outputnum;
      var $53=(($4+48)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+($52<<4))|0);
      $output=$55;
      var $56=$output;
      var $57=(($56+4)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0);
      var $60=$59;
      var $61=$samples_to_lose;
      var $62=$output;
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+($61<<2))|0);
      var $66=$65;
      var $67=$output_bufindex;
      var $68=$samples_to_lose;
      var $69=(($67-$68)|0);
      var $70=((($69<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32($60, $66, $70, 1, 0);
      __label__ = 8; break;
    case 8: // $71
      var $72=$outputnum;
      var $73=(($72+1)|0);
      $outputnum=$73;
      __label__ = 6; break;
    case 9: // $74
      __label__ = 10; break;
    case 10: // $75
      var $76=$samples_to_lose;
      var $77=(($4+68)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+$76)|0);
      HEAP32[(($77)>>2)]=$79;
      __label__ = 11; break;
    case 11: // $80
      __label__ = 12; break;
    case 12: // $81
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream22update_with_accountingEb["X"]=1;

function __ZN12sound_stream25apply_sample_rate_changesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $old_rate;
      var $outputnum;
      $1=$this;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 6; break;
    case 2: // $7
      var $8=(($2+8)|0);
      var $9=HEAP32[(($8)>>2)];
      $old_rate=$9;
      var $10=(($2+12)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($2+8)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=(($2+12)|0);
      HEAP32[(($13)>>2)]=0;
      __ZN12sound_stream26recompute_sample_rate_dataEv($2);
      var $14=(($2+60)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16$0=$15;
      var $16$1=(($15|0) < 0 ? -1 : 0);
      var $17=(($2+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19$0=$18;
      var $19$1=0;
      var $20$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($19$0)>>>0)+((($19$1)|0)*4294967296))>>>0; var $20$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))*((($19$0)>>>0)+((($19$1)|0)*4294967296)))/4294967296), 4294967295);
      var $21=$old_rate;
      var $22$0=$21;
      var $22$1=0;
      var $23$0 = (tempBigIntR=((($20$0)>>>0)+((($20$1)|0)*4294967296))/((($22$0)>>>0)+((($22$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $23$1 = Math.min(Math.floor(((tempBigIntR=((($20$0)>>>0)+((($20$1)|0)*4294967296))/((($22$0)>>>0)+((($22$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $24$0=$23$0;
      var $24=$24$0;
      var $25=(($2+60)|0);
      HEAP32[(($25)>>2)]=$24;
      var $26=(($2+64)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28$0=$27;
      var $28$1=(($27|0) < 0 ? -1 : 0);
      var $29=(($2+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31$0=$30;
      var $31$1=0;
      var $32$0 = ((($28$0)>>>0)+((($28$1)|0)*4294967296))*((($31$0)>>>0)+((($31$1)|0)*4294967296))>>>0; var $32$1 = Math.min(Math.floor((((($28$0)>>>0)+((($28$1)|0)*4294967296))*((($31$0)>>>0)+((($31$1)|0)*4294967296)))/4294967296), 4294967295);
      var $33=$old_rate;
      var $34$0=$33;
      var $34$1=0;
      var $35$0 = (tempBigIntR=((($32$0)>>>0)+((($32$1)|0)*4294967296))/((($34$0)>>>0)+((($34$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $35$1 = Math.min(Math.floor(((tempBigIntR=((($32$0)>>>0)+((($32$1)|0)*4294967296))/((($34$0)>>>0)+((($34$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $36$0=$35$0;
      var $36=$36$0;
      var $37=(($2+64)|0);
      HEAP32[(($37)>>2)]=$36;
      var $38=(($2+60)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($2+24)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($39-$41)|0);
      var $43=(($2+68)|0);
      HEAP32[(($43)>>2)]=$42;
      $outputnum=0;
      __label__ = 3; break;
    case 3: // $44
      var $45=$outputnum;
      var $46=(($2+44)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($45)|0) < (($47)|0);
      if ($48) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $49
      var $50=$outputnum;
      var $51=(($2+48)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+($50<<4))|0);
      var $54=(($53+4)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55;
      var $57=(($2+24)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=((($58<<2))|0);
      _memset($56, 0, $59, 1);
      __label__ = 5; break;
    case 5: // $60
      var $61=$outputnum;
      var $62=(($61+1)|0);
      $outputnum=$62;
      __label__ = 3; break;
    case 6: // $63
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream25apply_sample_rate_changesEv["X"]=1;

function __ZN12sound_stream9set_inputEiPS_if($this, $index, $input_stream, $output_index, $gain) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $input;
      $1=$this;
      $2=$index;
      $3=$input_stream;
      $4=$output_index;
      $5=$gain;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=$2;
      var $10=(($6+28)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($9)|0) >= (($11)|0);
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$2;
      var $15=(($6+28)|0);
      var $16=HEAP32[(($15)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str113549)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,HEAP32[((tempInt+4)>>2)]=$16,tempInt));
      throw "Reached an unreachable!"
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $20
      var $21=$4;
      var $22=$3;
      var $23=(($22+44)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($21)|0) >= (($24)|0);
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$4;
      var $28=(($6+44)|0);
      var $29=HEAP32[(($28)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str123550)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$27,HEAP32[((tempInt+4)>>2)]=$29,tempInt));
      throw "Reached an unreachable!"
    case 7: // $30
      var $31=$2;
      var $32=(($6+32)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$31*28)|0);
      $input=$34;
      var $35=$input;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      var $40=$input;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+8)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-1)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 9; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $49
      var $50=$4;
      var $51=$3;
      var $52=(($51+48)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+($50<<4))|0);
      var $57 = $54;__label__ = 12; break;
    case 11: // $55
      var $57 = 0;__label__ = 12; break;
    case 12: // $56
      var $57;
      var $58=$input;
      var $59=(($58)|0);
      HEAP32[(($59)>>2)]=$57;
      var $60=$5;
      var $61=$60*256;
      var $62=(($61)|0);
      var $63=(($62) & 65535);
      var $64=$input;
      var $65=(($64+26)|0);
      HEAP16[(($65)>>1)]=$63;
      var $66=$input;
      var $67=(($66+24)|0);
      HEAP16[(($67)>>1)]=$63;
      var $68=$input;
      var $69=(($68)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $72
      var $73=$input;
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+8)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+1)|0);
      HEAP32[(($76)>>2)]=$78;
      __label__ = 14; break;
    case 14: // $79
      __ZN12sound_stream26recompute_sample_rate_dataEv($6);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream9set_inputEiPS_if["X"]=1;

function __ZN12sound_stream25allocate_resample_buffersEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $bufsize;
      var $oldsize;
      var $inputnum;
      var $input;
      var $newbuffer;
      $6=$this;
      var $7=$6;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=((($9<<1))|0);
      $bufsize=$10;
      var $11=(($7+40)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=$bufsize;
      var $14=(($12)>>>0) < (($13)>>>0);
      if ($14) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $15
      var $16=(($7+40)|0);
      var $17=HEAP32[(($16)>>2)];
      $oldsize=$17;
      var $18=$bufsize;
      var $19=(($7+40)|0);
      HEAP32[(($19)>>2)]=$18;
      $inputnum=0;
      __label__ = 2; break;
    case 2: // $20
      var $21=$inputnum;
      var $22=(($7+28)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($21)|0) < (($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $25
      var $26=$inputnum;
      var $27=(($7+32)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+$26*28)|0);
      $input=$29;
      var $30=(($7)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__ZNK8device_t7machineEv($31);
      var $33=__ZN15running_machine7respoolEv($32);
      var $34=(($7+40)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=_llvm_umul_with_overflow_i32($35, 4);
      var $37=$36.f1;
      var $38=$36.f0;
      var $39=$37 ? -1 : $38;
      var $40=$1;
      var $41=$2;
      var $42=$3;
      var $43=$result_i;
      var $44=$4;
      var $45=$5;
      HEAP32[(($1)>>2)]=$39;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($3)>>2)]=501;
      var $46=HEAP32[(($1)>>2)];
      var $47=HEAP32[(($2)>>2)];
      var $48=HEAP32[(($3)>>2)];
      var $49=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($46, $47, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $50
      HEAP32[(($result_i)>>2)]=$49;
      var $51=HEAP32[(($result_i)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $53
      var $54=___cxa_allocate_exception(4);
      var $55=$54;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($55);
      (function() { try { __THREW__ = false; return ___cxa_throw($54, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      HEAP32[(($4)>>2)]=$58;
      var $59=$57.f1;
      HEAP32[(($5)>>2)]=$59;
      var $60=HEAP32[(($5)>>2)];
      var $61=(($60)|0) < 0;
      if ($61) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $62
      var $63=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($63);
      throw "Reached an unreachable!"
    case 8: // $64
      var $65=HEAP32[(($4)>>2)];
      var $66=HEAP32[(($4)>>2)];
      var $67=HEAP32[(($5)>>2)];
      var $68=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $66, tempValue);
      var $69=($68.f1 = $67, $68);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $70
      throw "Reached an unreachable!"
    case 10: // $_ZnajPKci_exit
      var $71=HEAP32[(($result_i)>>2)];
      var $72=$1;
      var $73=$2;
      var $74=$3;
      var $75=$result_i;
      var $76=$4;
      var $77=$5;
      var $78=$71;
      var $79=(($7+40)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=__ZN13resource_pool9add_arrayIiEEPT_S2_i($33, $78, $80);
      $newbuffer=$81;
      var $82=$newbuffer;
      var $83=$82;
      var $84=$input;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86;
      var $88=$oldsize;
      var $89=((($88<<2))|0);
      assert($89 % 1 === 0, 'memcpy given ' + $89 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($83, $87, $89, 1);
      var $90=(($7)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=__ZNK8device_t7machineEv($91);
      var $93=__ZN15running_machine7respoolEv($92);
      var $94=$input;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$96;
      __ZN13resource_pool6removeEPv($93, $97);
      var $98=$newbuffer;
      var $99=$input;
      var $100=(($99+4)|0);
      HEAP32[(($100)>>2)]=$98;
      __label__ = 11; break;
    case 11: // $101
      var $102=$inputnum;
      var $103=(($102+1)|0);
      $inputnum=$103;
      __label__ = 2; break;
    case 12: // $104
      __label__ = 13; break;
    case 13: // $105
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream25allocate_resample_buffersEv["X"]=1;

function __ZN12sound_stream12stream_inputC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $st$14$0=(($7)|0);
  HEAP32[(($st$14$0)>>2)]=$$emscripten$temp$0$0;
  var $st$14$1=(($7+4)|0);
  HEAP32[(($st$14$1)>>2)]=$$emscripten$temp$0$1;
  var $8=(($2+24)|0);
  HEAP16[(($8)>>1)]=256;
  var $9=(($2+26)|0);
  HEAP16[(($9)>>1)]=256;
  ;
  return;
}


function __ZN12sound_stream13stream_outputC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+8)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+12)|0);
  HEAP16[(($5)>>1)]=256;
  ;
  return;
}


function __ZN12sound_stream23generate_resampled_dataERNS_12stream_inputEj($this, $input, $numsamples) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $dest;
      var $output;
      var $input_stream;
      var $gain;
      var $basetime=__stackBase__;
      var $basesample;
      var $source;
      var $basefrac;
      var $step;
      var $sample;
      var $nextfrac;
      var $startfrac;
      var $endfrac;
      var $sample1;
      var $smallstep;
      var $remainder;
      var $tpos;
      var $scale;
      var $sample2;
      $2=$this;
      $3=$input;
      $4=$numsamples;
      var $5=$2;
      var $6=$3;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      $dest=$8;
      var $9=$3;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$dest;
      var $15=$14;
      var $16=$4;
      var $17=((($16<<2))|0);
      _memset($15, 0, $17, 1);
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      $1=$20;
      __label__ = 37; break;
    case 2: // $21
      var $22=$3;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      $output=$24;
      var $25=$output;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      $input_stream=$27;
      var $28=$3;
      var $29=(($28+24)|0);
      var $30=HEAP16[(($29)>>1)];
      var $31=(($30 << 16) >> 16);
      var $32=$output;
      var $33=(($32+12)|0);
      var $34=HEAP16[(($33)>>1)];
      var $35=(($34 << 16) >> 16);
      var $36=(($31*$35)|0);
      var $37=$36 >> 8;
      $gain=$37;
      var $38=(($5+60)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40$0=$39;
      var $40$1=(($39|0) < 0 ? -1 : 0);
      var $41=(($5+16)|0);
      var $st$24$0=(($41)|0);
      var $42$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$24$1)>>2)];
      var $43$0 = ((($40$0)>>>0)+((($40$1)|0)*4294967296))*((($42$0)>>>0)+((($42$1)|0)*4294967296))>>>0; var $43$1 = Math.min(Math.floor((((($40$0)>>>0)+((($40$1)|0)*4294967296))*((($42$0)>>>0)+((($42$1)|0)*4294967296)))/4294967296), 4294967295);
      var $44=$3;
      var $45=(($44+16)|0);
      var $st$31$0=(($45)|0);
      var $46$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($45+4)|0);
      var $46$1=HEAP32[(($st$31$1)>>2)];
      var $47$0 = ((($43$0)>>>0)+((($43$1)|0)*4294967296))-((($46$0)>>>0)+((($46$1)|0)*4294967296))>>>0; var $47$1 = Math.min(Math.floor((((($43$0)>>>0)+((($43$1)|0)*4294967296))-((($46$0)>>>0)+((($46$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$36$0=(($basetime)|0);
      HEAP32[(($st$36$0)>>2)]=$47$0;
      var $st$36$1=(($basetime+4)|0);
      HEAP32[(($st$36$1)>>2)]=$47$1;
      var $st$40$0=(($basetime)|0);
      var $48$0=HEAP32[(($st$40$0)>>2)];
      var $st$40$1=(($basetime+4)|0);
      var $48$1=HEAP32[(($st$40$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $49=($48$1|0) >= ($$emscripten$temp$0$1|0) && (($48$1|0) >  ($$emscripten$temp$0$1|0) || ($48$0|0) >= ($$emscripten$temp$0$0|0));
      if ($49) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $50
      var $st$0$0=(($basetime)|0);
      var $51$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($basetime+4)|0);
      var $51$1=HEAP32[(($st$0$1)>>2)];
      var $52=$input_stream;
      var $53=(($52+16)|0);
      var $st$6$0=(($53)|0);
      var $54$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($53+4)|0);
      var $54$1=HEAP32[(($st$6$1)>>2)];
      var $55$0 = (tempBigIntR=((($51$0)>>>0)+((($51$1)|0)*4294967296))/((($54$0)>>>0)+((($54$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $55$1 = Math.min(Math.floor(((tempBigIntR=((($51$0)>>>0)+((($51$1)|0)*4294967296))/((($54$0)>>>0)+((($54$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $56$0=$55$0;
      var $56=$56$0;
      $basesample=$56;
      __label__ = 5; break;
    case 4: // $57
      var $st$0$0=(($basetime)|0);
      var $58$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($basetime+4)|0);
      var $58$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $59$0 = ((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))-((($58$0)>>>0)+((($58$1)|0)*4294967296))>>>0; var $59$1 = Math.min(Math.floor((((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))-((($58$0)>>>0)+((($58$1)|0)*4294967296)))/4294967296), 4294967295);
      var $60=$input_stream;
      var $61=(($60+16)|0);
      var $st$9$0=(($61)|0);
      var $62$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($61+4)|0);
      var $62$1=HEAP32[(($st$9$1)>>2)];
      var $63$0 = (tempBigIntR=((($59$0)>>>0)+((($59$1)|0)*4294967296))/((($62$0)>>>0)+((($62$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $63$1 = Math.min(Math.floor(((tempBigIntR=((($59$0)>>>0)+((($59$1)|0)*4294967296))/((($62$0)>>>0)+((($62$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $64$0 = ((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))-((($63$0)>>>0)+((($63$1)|0)*4294967296))>>>0; var $64$1 = Math.min(Math.floor((((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))-((($63$0)>>>0)+((($63$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $65$0 = ((($64$0)>>>0)+((($64$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $65$1 = Math.min(Math.floor((((($64$0)>>>0)+((($64$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $66$0=$65$0;
      var $66=$66$0;
      $basesample=$66;
      __label__ = 5; break;
    case 5: // $67
      __label__ = 6; break;
    case 6: // $68
      __label__ = 7; break;
    case 7: // $69
      var $70=$output;
      var $71=(($70+4)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$basesample;
      var $74=$input_stream;
      var $75=(($74+68)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($73-$76)|0);
      var $78=(($72+($77<<2))|0);
      $source=$78;
      var $st$10$0=(($basetime)|0);
      var $79$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($basetime+4)|0);
      var $79$1=HEAP32[(($st$10$1)>>2)];
      var $80=$basesample;
      var $81$0=$80;
      var $81$1=(($80|0) < 0 ? -1 : 0);
      var $82=$input_stream;
      var $83=(($82+16)|0);
      var $st$19$0=(($83)|0);
      var $84$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($83+4)|0);
      var $84$1=HEAP32[(($st$19$1)>>2)];
      var $85$0 = ((($81$0)>>>0)+((($81$1)|0)*4294967296))*((($84$0)>>>0)+((($84$1)|0)*4294967296))>>>0; var $85$1 = Math.min(Math.floor((((($81$0)>>>0)+((($81$1)|0)*4294967296))*((($84$0)>>>0)+((($84$1)|0)*4294967296)))/4294967296), 4294967295);
      var $86$0 = ((($79$0)>>>0)+((($79$1)|0)*4294967296))-((($85$0)>>>0)+((($85$1)|0)*4294967296))>>>0; var $86$1 = Math.min(Math.floor((((($79$0)>>>0)+((($79$1)|0)*4294967296))-((($85$0)>>>0)+((($85$1)|0)*4294967296)))/4294967296), 4294967295);
      var $87=$input_stream;
      var $88=(($87+16)|0);
      var $st$27$0=(($88)|0);
      var $89$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($88+4)|0);
      var $89$1=HEAP32[(($st$27$1)>>2)];
      var $$emscripten$temp$4$0=4194304;
      var $$emscripten$temp$4$1=0;
      var $90$0 = ((($89$0)>>>0)+((($89$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $90$1 = Math.min(Math.floor((((($89$0)>>>0)+((($89$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$5$0=1;
      var $$emscripten$temp$5$1=0;
      var $91$0 = ((($90$0)>>>0)+((($90$1)|0)*4294967296))-((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))>>>0; var $91$1 = Math.min(Math.floor((((($90$0)>>>0)+((($90$1)|0)*4294967296))-((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)))/4294967296), 4294967295);
      var $92$0=($91$0 >>> 22) | ($91$1 << 10);
      var $92$1=($91$1 >> 22) | (((($91$1|0) < 0 ? -1 : 0)) << 10);
      var $93$0 = (tempBigIntR=((($86$0)>>>0)+((($86$1)|0)*4294967296))/((($92$0)>>>0)+((($92$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $93$1 = Math.min(Math.floor(((tempBigIntR=((($86$0)>>>0)+((($86$1)|0)*4294967296))/((($92$0)>>>0)+((($92$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $94$0=$93$0;
      var $94=$94$0;
      $basefrac=$94;
      __label__ = 8; break;
    case 8: // $95
      __label__ = 9; break;
    case 9: // $96
      __label__ = 10; break;
    case 10: // $97
      __label__ = 11; break;
    case 11: // $98
      var $99=$input_stream;
      var $100=(($99+8)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102$0=$101;
      var $102$1=0;
      var $103$0=($102$0 << 22) | (0 >>> 10);
      var $103$1=($102$1 << 22) | ($102$0 >>> 10);
      var $104=(($5+8)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106$0=$105;
      var $106$1=0;
      var $107$0 = Math.floor(((($103$0)>>>0)+((($103$1)|0)*4294967296))/((($106$0)>>>0)+((($106$1)|0)*4294967296)))>>>0; var $107$1 = Math.min(Math.floor((Math.floor(((($103$0)>>>0)+((($103$1)|0)*4294967296))/((($106$0)>>>0)+((($106$1)|0)*4294967296))))/4294967296), 4294967295);
      var $108$0=$107$0;
      var $108=$108$0;
      $step=$108;
      var $109=$step;
      var $110=(($109)|0)==4194304;
      if ($110) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $111
      __label__ = 13; break;
    case 13: // $112
      var $113=$4;
      var $114=(($113-1)|0);
      $4=$114;
      var $115=(($113)|0)!=0;
      if ($115) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $116
      var $117=$source;
      var $118=(($117+4)|0);
      $source=$118;
      var $119=HEAP32[(($117)>>2)];
      $sample=$119;
      var $120=$sample;
      var $121=$gain;
      var $122=(($120*$121)|0);
      var $123=$122 >> 8;
      var $124=$dest;
      var $125=(($124+4)|0);
      $dest=$125;
      HEAP32[(($124)>>2)]=$123;
      __label__ = 13; break;
    case 15: // $126
      __label__ = 36; break;
    case 16: // $127
      var $128=$step;
      var $129=(($128)>>>0) < 4194304;
      if ($129) { __label__ = 17; break; } else { __label__ = 28; break; }
    case 17: // $130
      __label__ = 18; break;
    case 18: // $131
      var $132=$4;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 19; break; } else { __label__ = 27; break; }
    case 19: // $134
      __label__ = 20; break;
    case 20: // $135
      var $136=$basefrac;
      var $137=$step;
      var $138=(($136+$137)|0);
      $nextfrac=$138;
      var $139=(($138)>>>0) < 4194304;
      if ($139) { __label__ = 21; break; } else { var $145 = 0;__label__ = 22; break; }
    case 21: // $140
      var $141=$4;
      var $142=(($141-1)|0);
      $4=$142;
      var $143=(($141)|0)!=0;
      var $145 = $143;__label__ = 22; break;
    case 22: // $144
      var $145;
      if ($145) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $146
      var $147=$source;
      var $148=(($147)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$gain;
      var $151=(($149*$150)|0);
      var $152=$151 >> 8;
      var $153=$dest;
      var $154=(($153+4)|0);
      $dest=$154;
      HEAP32[(($153)>>2)]=$152;
      var $155=$nextfrac;
      $basefrac=$155;
      __label__ = 20; break;
    case 24: // $156
      var $157=$4;
      var $158=(($157-1)|0);
      $4=$158;
      var $159=(($157)|0) < 0;
      if ($159) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $160
      __label__ = 27; break;
    case 26: // $161
      var $162=$basefrac;
      var $163=$162 >>> 10;
      $startfrac=$163;
      var $164=$nextfrac;
      var $165=$164 >> 10;
      $endfrac=$165;
      var $166=$source;
      var $167=(($166)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$startfrac;
      var $170=((4096-$169)|0);
      var $171=(($168*$170)|0);
      var $172=$source;
      var $173=(($172+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$endfrac;
      var $176=(($175-4096)|0);
      var $177=(($174*$176)|0);
      var $178=(($171+$177)|0);
      var $179=$endfrac;
      var $180=$startfrac;
      var $181=(($179-$180)|0);
      var $182=(((($178)|0)/(($181)|0))|0);
      $sample1=$182;
      var $183=$sample1;
      var $184=$gain;
      var $185=(($183*$184)|0);
      var $186=$185 >> 8;
      var $187=$dest;
      var $188=(($187+4)|0);
      $dest=$188;
      HEAP32[(($187)>>2)]=$186;
      var $189=$nextfrac;
      var $190=$189 & 4194303;
      $basefrac=$190;
      var $191=$source;
      var $192=(($191+4)|0);
      $source=$192;
      __label__ = 18; break;
    case 27: // $193
      __label__ = 35; break;
    case 28: // $194
      var $195=$step;
      var $196=$195 >>> 14;
      $smallstep=$196;
      __label__ = 29; break;
    case 29: // $197
      var $198=$4;
      var $199=(($198-1)|0);
      $4=$199;
      var $200=(($198)|0)!=0;
      if ($200) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $201
      var $202=$smallstep;
      $remainder=$202;
      $tpos=0;
      var $203=$basefrac;
      var $204=((4194304-$203)|0);
      var $205=$204 >>> 14;
      $scale=$205;
      var $206=$tpos;
      var $207=(($206+1)|0);
      $tpos=$207;
      var $208=$source;
      var $209=(($208+($206<<2))|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$scale;
      var $212=(($210*$211)|0);
      $sample2=$212;
      var $213=$scale;
      var $214=$remainder;
      var $215=(($214-$213)|0);
      $remainder=$215;
      __label__ = 31; break;
    case 31: // $216
      var $217=$remainder;
      var $218=(($217)|0) > 256;
      if ($218) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $219
      var $220=$tpos;
      var $221=(($220+1)|0);
      $tpos=$221;
      var $222=$source;
      var $223=(($222+($220<<2))|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=((($224<<8))|0);
      var $226=$sample2;
      var $227=(($226+$225)|0);
      $sample2=$227;
      var $228=$remainder;
      var $229=(($228-256)|0);
      $remainder=$229;
      __label__ = 31; break;
    case 33: // $230
      var $231=$tpos;
      var $232=$source;
      var $233=(($232+($231<<2))|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$remainder;
      var $236=(($234*$235)|0);
      var $237=$sample2;
      var $238=(($237+$236)|0);
      $sample2=$238;
      var $239=$smallstep;
      var $240=$sample2;
      var $241=(((($240)|0)/(($239)|0))|0);
      $sample2=$241;
      var $242=$sample2;
      var $243=$gain;
      var $244=(($242*$243)|0);
      var $245=$244 >> 8;
      var $246=$dest;
      var $247=(($246+4)|0);
      $dest=$247;
      HEAP32[(($246)>>2)]=$245;
      var $248=$step;
      var $249=$basefrac;
      var $250=(($249+$248)|0);
      $basefrac=$250;
      var $251=$basefrac;
      var $252=$251 >>> 22;
      var $253=$source;
      var $254=(($253+($252<<2))|0);
      $source=$254;
      var $255=$basefrac;
      var $256=$255 & 4194303;
      $basefrac=$256;
      __label__ = 29; break;
    case 34: // $257
      __label__ = 35; break;
    case 35: // $258
      __label__ = 36; break;
    case 36: // $259
      var $260=$3;
      var $261=(($260+4)|0);
      var $262=HEAP32[(($261)>>2)];
      $1=$262;
      __label__ = 37; break;
    case 37: // $263
      var $264=$1;
      STACKTOP = __stackBase__;
      return $264;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream23generate_resampled_dataERNS_12stream_inputEj["X"]=1;

function __ZN12sound_stream23allocate_output_buffersEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $bufsize;
      var $oldsize;
      var $outputnum;
      var $output;
      var $newbuffer;
      $6=$this;
      var $7=$6;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9*5)|0);
      $bufsize=$10;
      var $11=(($7+56)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=$bufsize;
      var $14=(($12)>>>0) < (($13)>>>0);
      if ($14) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $15
      var $16=(($7+56)|0);
      var $17=HEAP32[(($16)>>2)];
      $oldsize=$17;
      var $18=$bufsize;
      var $19=(($7+56)|0);
      HEAP32[(($19)>>2)]=$18;
      $outputnum=0;
      __label__ = 2; break;
    case 2: // $20
      var $21=$outputnum;
      var $22=(($7+44)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($21)|0) < (($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $25
      var $26=$outputnum;
      var $27=(($7+48)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+($26<<4))|0);
      $output=$29;
      var $30=(($7)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__ZNK8device_t7machineEv($31);
      var $33=__ZN15running_machine7respoolEv($32);
      var $34=(($7+56)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=_llvm_umul_with_overflow_i32($35, 4);
      var $37=$36.f1;
      var $38=$36.f0;
      var $39=$37 ? -1 : $38;
      var $40=$1;
      var $41=$2;
      var $42=$3;
      var $43=$result_i;
      var $44=$4;
      var $45=$5;
      HEAP32[(($1)>>2)]=$39;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($3)>>2)]=529;
      var $46=HEAP32[(($1)>>2)];
      var $47=HEAP32[(($2)>>2)];
      var $48=HEAP32[(($3)>>2)];
      var $49=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($46, $47, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $50
      HEAP32[(($result_i)>>2)]=$49;
      var $51=HEAP32[(($result_i)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $53
      var $54=___cxa_allocate_exception(4);
      var $55=$54;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($55);
      (function() { try { __THREW__ = false; return ___cxa_throw($54, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      HEAP32[(($4)>>2)]=$58;
      var $59=$57.f1;
      HEAP32[(($5)>>2)]=$59;
      var $60=HEAP32[(($5)>>2)];
      var $61=(($60)|0) < 0;
      if ($61) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $62
      var $63=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($63);
      throw "Reached an unreachable!"
    case 8: // $64
      var $65=HEAP32[(($4)>>2)];
      var $66=HEAP32[(($4)>>2)];
      var $67=HEAP32[(($5)>>2)];
      var $68=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $66, tempValue);
      var $69=($68.f1 = $67, $68);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $70
      throw "Reached an unreachable!"
    case 10: // $_ZnajPKci_exit
      var $71=HEAP32[(($result_i)>>2)];
      var $72=$1;
      var $73=$2;
      var $74=$3;
      var $75=$result_i;
      var $76=$4;
      var $77=$5;
      var $78=$71;
      var $79=(($7+56)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=__ZN13resource_pool9add_arrayIiEEPT_S2_i($33, $78, $80);
      $newbuffer=$81;
      var $82=$newbuffer;
      var $83=$82;
      var $84=$output;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86;
      var $88=$oldsize;
      var $89=((($88<<2))|0);
      assert($89 % 1 === 0, 'memcpy given ' + $89 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($83, $87, $89, 1);
      var $90=$newbuffer;
      var $91=$oldsize;
      var $92=(($90+($91<<2))|0);
      var $93=$92;
      var $94=(($7+56)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$oldsize;
      var $97=(($95-$96)|0);
      var $98=((($97<<2))|0);
      _memset($93, 0, $98, 1);
      var $99=(($7)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=__ZNK8device_t7machineEv($100);
      var $102=__ZN15running_machine7respoolEv($101);
      var $103=$output;
      var $104=(($103+4)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$105;
      __ZN13resource_pool6removeEPv($102, $106);
      var $107=$newbuffer;
      var $108=$output;
      var $109=(($108+4)|0);
      HEAP32[(($109)>>2)]=$107;
      __label__ = 11; break;
    case 11: // $110
      var $111=$outputnum;
      var $112=(($111+1)|0);
      $outputnum=$112;
      __label__ = 2; break;
    case 12: // $113
      __label__ = 13; break;
    case 13: // $114
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12sound_stream23allocate_output_buffersEv["X"]=1;

function __ZNK15running_machine11sample_rateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1460)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13sound_manager13update_staticER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN13sound_manager6updateEv($5);
  ;
  return;
}


function __ZNK11emu_options5soundEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str313569)|0));
  ;
  return $4;
}


function __ZN11simple_listI12sound_streamEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI12sound_streamEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK11emu_options9wav_writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str303568)|0));
  ;
  return $4;
}


function __ZNK11emu_options9avi_writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str293567)|0));
  ;
  return $4;
}


function __ZN8delegateIFviP14_xml_data_nodeEEC1I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFviP14_xml_data_nodeEEC2I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13sound_manager11config_loadEiP14_xml_data_node($this, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $channelnode;
      var $info=__stackBase__;
      var $defvol;
      var $newvol;
      $1=$this;
      $2=$config_type;
      $3=$parentnode;
      var $4=$1;
      var $5=$2;
      var $6=(($5)|0)!=3;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __label__ = 13; break;
    case 2: // $8
      var $9=$3;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      __label__ = 13; break;
    case 4: // $12
      var $13=$3;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__Z15xml_get_siblingP14_xml_data_nodePKc($15, ((STRING_TABLE.__str213559)|0));
      $channelnode=$16;
      __label__ = 5; break;
    case 5: // $17
      var $18=$channelnode;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $20
      var $21=$channelnode;
      var $22=__Z21xml_get_attribute_intP14_xml_data_nodePKci($21, ((STRING_TABLE.__str223560)|0), -1);
      var $23=__ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input($4, $22, $info);
      if ($23) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $24
      var $25=$channelnode;
      var $26=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($25, ((STRING_TABLE.__str233561)|0), -1000);
      $defvol=$26;
      var $27=$channelnode;
      var $28=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($27, ((STRING_TABLE.__str243562)|0), -1000);
      $newvol=$28;
      var $29=$defvol;
      var $30=(($info+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($info+8)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__ZNK12sound_stream18initial_input_gainEi($31, $33);
      var $35=$29-$34;
      var $36=$35;
      var $37=_fabs($36);
      var $38=$37 < 0.000001;
      if ($38) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $39
      var $40=$newvol;
      var $41=$40;
      var $42=$41 != -1000;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=(($info+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($info+8)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$newvol;
      __ZN12sound_stream14set_input_gainEif($45, $47, $48);
      __label__ = 10; break;
    case 10: // $49
      __label__ = 11; break;
    case 11: // $50
      __label__ = 12; break;
    case 12: // $51
      var $52=$channelnode;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=__Z15xml_get_siblingP14_xml_data_nodePKc($54, ((STRING_TABLE.__str213559)|0));
      $channelnode=$55;
      __label__ = 5; break;
    case 13: // $56
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13sound_manager11config_loadEiP14_xml_data_node["X"]=1;

function __ZN13sound_managerC2ER15running_machine($this, $machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 256; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i6=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i1=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $14=__stackBase__+64;
      var $15=__stackBase__+68;
      var $16;
      var $17;
      var $wavfile;
      var $18;
      var $19;
      var $avifile;
      var $20=__stackBase__+72;
      var $21=__stackBase__+96;
      var $22=__stackBase__+104;
      var $23=__stackBase__+128;
      var $24=__stackBase__+136;
      var $25=__stackBase__+160;
      var $26=__stackBase__+168;
      var $27=__stackBase__+192;
      var $28=__stackBase__+200;
      var $29=__stackBase__+224;
      var $30=__stackBase__+232;
      var $31=__stackBase__+244;
      $16=$this;
      $17=$machine;
      var $32=$16;
      var $33=(($32)|0);
      var $34=$17;
      HEAP32[(($33)>>2)]=$34;
      var $35=(($32+4)|0);
      var $36=$17;
      var $37=__ZN15running_machine9schedulerEv($36);
      var $38=$32;
      var $39=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($37, 866, ((STRING_TABLE.__str133551)|0), $38);
      HEAP32[(($35)>>2)]=$39;
      var $40=(($32+8)|0);
      HEAP32[(($40)>>2)]=0;
      var $41=(($32+12)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=(($32+16)|0);
      HEAP32[(($42)>>2)]=0;
      var $43=(($32+20)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=(($32+24)|0);
      HEAP8[($44)]=0;
      var $45=(($32+28)|0);
      HEAP32[(($45)>>2)]=0;
      var $46=(($32+32)|0);
      var $47=$17;
      var $48=__ZNK15running_machine7optionsEv($47);
      var $49=__ZNK11emu_options5soundEv($48);
      var $50=$49 ^ 1;
      var $51=(($50)&1);
      HEAP32[(($46)>>2)]=$51;
      var $52=(($32+36)|0);
      HEAP32[(($52)>>2)]=0;
      var $53=(($32+40)|0);
      var $54=$17;
      var $55=__ZN15running_machine7respoolEv($54);
      __ZN11simple_listI12sound_streamEC1ER13resource_pool($53, $55);
      var $56=(($32+60)|0);
      var $$emscripten$temp$0=((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE+4)|0);
      var $st$75$0=(($$emscripten$temp$0)|0);
      var $57$0=HEAP32[(($st$75$0)>>2)];
      var $st$75$1=(($$emscripten$temp$0+4)|0);
      var $57$1=HEAP32[(($st$75$1)>>2)];
      var $st$79$0=(($56)|0);
      HEAP32[(($st$79$0)>>2)]=$57$0;
      var $st$79$1=(($56+4)|0);
      HEAP32[(($st$79$1)>>2)]=$57$1;
      var $58=(($32+68)|0);
      var $59=$58;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($59+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($59+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $60=$17;
      var $61=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $62
      var $63=(function() { try { __THREW__ = false; return __ZNK11emu_options9wav_writeEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $64
      $wavfile=$63;
      var $65=$17;
      var $66=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $67
      var $68=(function() { try { __THREW__ = false; return __ZNK11emu_options9avi_writeEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $69
      $avifile=$68;
      var $70=(($32+32)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $73
      var $74=$wavfile;
      var $75=(($74)|0);
      var $76=HEAP8[($75)];
      var $77=(($76 << 24) >> 24);
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $79
      var $80=$avifile;
      var $81=(($80)|0);
      var $82=HEAP8[($81)];
      var $83=(($82 << 24) >> 24);
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $85
      var $86=$17;
      var $87=(($86+1460)|0);
      HEAP32[(($87)>>2)]=11025;
      __label__ = 12; break;
    case 8: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body9 = $89;__label__ = 9; break;
    case 9: // $_body8
      var $eh_lpad_body9;
      var $eh_lpad_body4 = $eh_lpad_body9;__label__ = 10; break;
    case 10: // $_body3
      var $eh_lpad_body4;
      var $eh_lpad_body = $eh_lpad_body4;__label__ = 11; break;
    case 11: // $_body
      var $eh_lpad_body;
      var $90=$eh_lpad_body.f0;
      $18=$90;
      var $91=$eh_lpad_body.f1;
      $19=$91;
      var $92=(($32+40)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12sound_streamED1Ev($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 76; break; }
    case 12: // $93
      __label__ = 13; break;
    case 13: // $94
      __label__ = 14; break;
    case 14: // $95
      __label__ = 15; break;
    case 15: // $96
      var $97=$17;
      var $98=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 8; break; };
    case 16: // $99
      var $100=$17;
      var $101=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; };
    case 17: // $102
      var $103=_llvm_umul_with_overflow_i32($101, 4);
      var $104=$103.f1;
      var $105=$103.f0;
      var $106=$104 ? -1 : $105;
      var $107=$11;
      var $108=$12;
      var $109=$13;
      var $110=$result_i;
      var $111=$14;
      var $112=$15;
      HEAP32[(($11)>>2)]=$106;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($13)>>2)]=794;
      var $113=HEAP32[(($11)>>2)];
      var $114=HEAP32[(($12)>>2)];
      var $115=HEAP32[(($13)>>2)];
      var $116=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($113, $114, $115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $117
      HEAP32[(($result_i)>>2)]=$116;
      var $118=HEAP32[(($result_i)>>2)];
      var $119=(($118)|0)==0;
      if ($119) { __label__ = 19; break; } else { __label__ = 25; break; }
    case 19: // $120
      var $121=___cxa_allocate_exception(4);
      var $122=$121;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($122);
      (function() { try { __THREW__ = false; return ___cxa_throw($121, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 20; break; }
    case 20: // $123
      var $124=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $125=$124.f0;
      HEAP32[(($14)>>2)]=$125;
      var $126=$124.f1;
      HEAP32[(($15)>>2)]=$126;
      var $127=HEAP32[(($15)>>2)];
      var $128=(($127)|0) < 0;
      if ($128) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $129
      var $130=HEAP32[(($14)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 8; break; }
    case 22: // $_noexc
      throw "Reached an unreachable!"
    case 23: // $131
      var $132=HEAP32[(($14)>>2)];
      var $133=HEAP32[(($14)>>2)];
      var $134=HEAP32[(($15)>>2)];
      var $135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $133, tempValue);
      var $136=($135.f1 = $134, $135);
      var $eh_lpad_body = $136;__label__ = 11; break;
    case 24: // $137
      throw "Reached an unreachable!"
    case 25: // $_ZnajPKci_exit
      var $138=HEAP32[(($result_i)>>2)];
      var $139=$11;
      var $140=$12;
      var $141=$13;
      var $142=$result_i;
      var $143=$14;
      var $144=$15;
      __label__ = 26; break;
    case 26: // $145
      var $146=$138;
      var $147=$17;
      var $148=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 8; break; };
    case 27: // $149
      var $150=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIiEEPT_S2_i($98, $146, $148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 8; break; };
    case 28: // $151
      var $152=(($32+16)|0);
      HEAP32[(($152)>>2)]=$150;
      var $153=$17;
      var $154=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 8; break; };
    case 29: // $155
      var $156=$17;
      var $157=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; };
    case 30: // $158
      var $159=_llvm_umul_with_overflow_i32($157, 4);
      var $160=$159.f1;
      var $161=$159.f0;
      var $162=$160 ? -1 : $161;
      var $163=$6;
      var $164=$7;
      var $165=$8;
      var $166=$result_i1;
      var $167=$9;
      var $168=$10;
      HEAP32[(($6)>>2)]=$162;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($8)>>2)]=795;
      var $169=HEAP32[(($6)>>2)];
      var $170=HEAP32[(($7)>>2)];
      var $171=HEAP32[(($8)>>2)];
      var $172=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($169, $170, $171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 33; break; };
    case 31: // $173
      HEAP32[(($result_i1)>>2)]=$172;
      var $174=HEAP32[(($result_i1)>>2)];
      var $175=(($174)|0)==0;
      if ($175) { __label__ = 32; break; } else { __label__ = 38; break; }
    case 32: // $176
      var $177=___cxa_allocate_exception(4);
      var $178=$177;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($178);
      (function() { try { __THREW__ = false; return ___cxa_throw($177, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 33; break; }
    case 33: // $179
      var $180=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $181=$180.f0;
      HEAP32[(($9)>>2)]=$181;
      var $182=$180.f1;
      HEAP32[(($10)>>2)]=$182;
      var $183=HEAP32[(($10)>>2)];
      var $184=(($183)|0) < 0;
      if ($184) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $185
      var $186=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 8; break; }
    case 35: // $_noexc2
      throw "Reached an unreachable!"
    case 36: // $187
      var $188=HEAP32[(($9)>>2)];
      var $189=HEAP32[(($9)>>2)];
      var $190=HEAP32[(($10)>>2)];
      var $191=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $189, tempValue);
      var $192=($191.f1 = $190, $191);
      var $eh_lpad_body4 = $192;__label__ = 10; break;
    case 37: // $193
      throw "Reached an unreachable!"
    case 38: // $_ZnajPKci_exit5
      var $194=HEAP32[(($result_i1)>>2)];
      var $195=$6;
      var $196=$7;
      var $197=$8;
      var $198=$result_i1;
      var $199=$9;
      var $200=$10;
      __label__ = 39; break;
    case 39: // $201
      var $202=$194;
      var $203=$17;
      var $204=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 8; break; };
    case 40: // $205
      var $206=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIiEEPT_S2_i($154, $202, $204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 8; break; };
    case 41: // $207
      var $208=(($32+20)|0);
      HEAP32[(($208)>>2)]=$206;
      var $209=$17;
      var $210=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 8; break; };
    case 42: // $211
      var $212=$17;
      var $213=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 8; break; };
    case 43: // $214
      var $215=_llvm_umul_with_overflow_i32($213, 2);
      var $216=$215.f1;
      var $217=$215.f0;
      var $218=$216 ? -1 : $217;
      var $219=$1;
      var $220=$2;
      var $221=$3;
      var $222=$result_i6;
      var $223=$4;
      var $224=$5;
      HEAP32[(($1)>>2)]=$218;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($3)>>2)]=796;
      var $225=HEAP32[(($1)>>2)];
      var $226=HEAP32[(($2)>>2)];
      var $227=HEAP32[(($3)>>2)];
      var $228=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($225, $226, $227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; };
    case 44: // $229
      HEAP32[(($result_i6)>>2)]=$228;
      var $230=HEAP32[(($result_i6)>>2)];
      var $231=(($230)|0)==0;
      if ($231) { __label__ = 45; break; } else { __label__ = 51; break; }
    case 45: // $232
      var $233=___cxa_allocate_exception(4);
      var $234=$233;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($234);
      (function() { try { __THREW__ = false; return ___cxa_throw($233, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 46; break; }
    case 46: // $235
      var $236=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $237=$236.f0;
      HEAP32[(($4)>>2)]=$237;
      var $238=$236.f1;
      HEAP32[(($5)>>2)]=$238;
      var $239=HEAP32[(($5)>>2)];
      var $240=(($239)|0) < 0;
      if ($240) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 47: // $241
      var $242=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($242) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 8; break; }
    case 48: // $_noexc7
      throw "Reached an unreachable!"
    case 49: // $243
      var $244=HEAP32[(($4)>>2)];
      var $245=HEAP32[(($4)>>2)];
      var $246=HEAP32[(($5)>>2)];
      var $247=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $245, tempValue);
      var $248=($247.f1 = $246, $247);
      var $eh_lpad_body9 = $248;__label__ = 9; break;
    case 50: // $249
      throw "Reached an unreachable!"
    case 51: // $_ZnajPKci_exit10
      var $250=HEAP32[(($result_i6)>>2)];
      var $251=$1;
      var $252=$2;
      var $253=$3;
      var $254=$result_i6;
      var $255=$4;
      var $256=$5;
      __label__ = 52; break;
    case 52: // $257
      var $258=$250;
      var $259=$17;
      var $260=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 8; break; };
    case 53: // $261
      var $262=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIsEEPT_S2_i($210, $258, $260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 8; break; };
    case 54: // $263
      var $264=(($32+12)|0);
      HEAP32[(($264)>>2)]=$262;
      var $265=$wavfile;
      var $266=(($265)|0);
      var $267=HEAP8[($266)];
      var $268=(($267 << 24) >> 24);
      var $269=(($268)|0)!=0;
      if ($269) { __label__ = 55; break; } else { __label__ = 58; break; }
    case 55: // $270
      var $271=$wavfile;
      var $272=$17;
      var $273=(function() { try { __THREW__ = false; return __ZNK15running_machine11sample_rateEv($272) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 8; break; };
    case 56: // $274
      var $275=(function() { try { __THREW__ = false; return __Z8wav_openPKcii($271, $273, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 8; break; };
    case 57: // $276
      var $277=(($32+36)|0);
      HEAP32[(($277)>>2)]=$275;
      __label__ = 58; break;
    case 58: // $278
      var $279=$17;
      HEAP32[(($21)>>2)]={ f0: 856, f1: 0 }.f0; HEAP32[(($21+4)>>2)]={ f0: 856, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFviP14_xml_data_nodeEEC1I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($20, $21, ((STRING_TABLE.__str153553)|0), $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 8; break; }
    case 59: // $280
      HEAP32[(($23)>>2)]={ f0: 858, f1: 0 }.f0; HEAP32[(($23+4)>>2)]={ f0: 858, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFviP14_xml_data_nodeEEC1I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($22, $23, ((STRING_TABLE.__str163554)|0), $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 8; break; }
    case 60: // $281
      (function() { try { __THREW__ = false; return __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($279, ((STRING_TABLE.__str143552)|0), $20, $22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 8; break; }
    case 61: // $282
      var $283=$17;
      HEAP32[(($25)>>2)]={ f0: 860, f1: 0 }.f0; HEAP32[(($25+4)>>2)]={ f0: 860, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($24, $25, ((STRING_TABLE.__str173555)|0), $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 8; break; }
    case 62: // $284
      (function() { try { __THREW__ = false; return __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($283, 2, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 8; break; }
    case 63: // $285
      var $286=$17;
      HEAP32[(($27)>>2)]={ f0: 862, f1: 0 }.f0; HEAP32[(($27+4)>>2)]={ f0: 862, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($26, $27, ((STRING_TABLE.__str183556)|0), $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 8; break; }
    case 64: // $287
      (function() { try { __THREW__ = false; return __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($286, 3, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 8; break; }
    case 65: // $288
      var $289=$17;
      HEAP32[(($29)>>2)]={ f0: 864, f1: 0 }.f0; HEAP32[(($29+4)>>2)]={ f0: 864, f1: 0 }.f1;
      (function() { try { __THREW__ = false; return __ZN8delegateIFvvEEC1I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($28, $29, ((STRING_TABLE.__str193557)|0), $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 8; break; }
    case 66: // $290
      (function() { try { __THREW__ = false; return __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($289, 1, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 8; break; }
    case 67: // $291
      var $292=$17;
      var $293=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 8; break; };
    case 68: // $294
      var $295=(($32+68)|0);
      (function() { try { __THREW__ = false; return __ZN12save_manager9save_itemI8attotimeEEvRT_PKci($293, $295, ((STRING_TABLE.__str203558)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 8; break; }
    case 69: // $296
      var $297=$17;
      var $298=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($297) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 8; break; };
    case 70: // $299
      var $300=(function() { try { __THREW__ = false; return __ZNK11emu_options6volumeEv($298) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 8; break; };
    case 71: // $301
      (function() { try { __THREW__ = false; return __ZN13sound_manager15set_attenuationEi($32, $300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 8; break; }
    case 72: // $302
      var $303=(($32+4)|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=$30;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($305)>>2)]=HEAP32[((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE)>>2)];HEAP32[(($305+4)>>2)]=HEAP32[((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE+4)>>2)];HEAP32[(($305+8)>>2)]=HEAP32[((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE+8)>>2)];
      var $306=$31;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE)>>2)];HEAP32[(($306+4)>>2)]=HEAP32[((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE+4)>>2)];HEAP32[(($306+8)>>2)]=HEAP32[((__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE+8)>>2)];
      (function() { try { __THREW__ = false; return __ZN9emu_timer6adjustE8attotimeiS0_($304, $30, 0, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 8; break; }
    case 73: // $307
      STACKTOP = __stackBase__;
      return;
    case 74: // $308
      __label__ = 75; break;
    case 75: // $309
      var $310=$18;
      var $311=$18;
      var $312=$19;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 76: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13sound_managerC2ER15running_machine["X"]=1;

function __ZN13resource_pool9add_arrayIsEEPT_S2_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIsEC1EPsi($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIsEEPT_S2_i["X"]=1;

function __Z8downcastIP14speaker_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12sound_streamE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13sound_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13sound_manager11config_saveEiP14_xml_data_node($this, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $mixernum;
      var $info=__stackBase__;
      var $defvol;
      var $newvol;
      var $channelnode;
      $1=$this;
      $2=$config_type;
      $3=$parentnode;
      var $4=$1;
      var $5=$2;
      var $6=(($5)|0)!=3;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __label__ = 13; break;
    case 2: // $8
      var $9=$3;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $11
      $mixernum=0;
      __label__ = 4; break;
    case 4: // $12
      var $13=$mixernum;
      var $14=__ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input($4, $13, $info);
      if ($14) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $15
      __label__ = 12; break;
    case 6: // $16
      var $17=(($info+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($info+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZNK12sound_stream18initial_input_gainEi($18, $20);
      $defvol=$21;
      var $22=(($info+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($info+8)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZNK12sound_stream10input_gainEi($23, $25);
      $newvol=$26;
      var $27=$defvol;
      var $28=$newvol;
      var $29=$27 != $28;
      if ($29) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $30
      var $31=$3;
      var $32=__Z13xml_add_childP14_xml_data_nodePKcS2_($31, ((STRING_TABLE.__str213559)|0), 0);
      $channelnode=$32;
      var $33=$channelnode;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $35
      var $36=$channelnode;
      var $37=$mixernum;
      var $38=__Z21xml_set_attribute_intP14_xml_data_nodePKci($36, ((STRING_TABLE.__str223560)|0), $37);
      var $39=$channelnode;
      var $40=$defvol;
      var $41=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($39, ((STRING_TABLE.__str233561)|0), $40);
      var $42=$channelnode;
      var $43=$newvol;
      var $44=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($42, ((STRING_TABLE.__str243562)|0), $43);
      __label__ = 9; break;
    case 9: // $45
      __label__ = 10; break;
    case 10: // $46
      __label__ = 11; break;
    case 11: // $47
      var $48=$mixernum;
      var $49=(($48+1)|0);
      $mixernum=$49;
      __label__ = 4; break;
    case 12: // $50
      __label__ = 13; break;
    case 13: // $51
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13sound_manager11config_saveEiP14_xml_data_node["X"]=1;

function __ZN8delegateIFvvEEC1I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13sound_manager5pauseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13sound_manager4muteEbh($2, 1, 1);
  ;
  return;
}


function __ZN13sound_manager6resumeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13sound_manager4muteEbh($2, 0, 1);
  ;
  return;
}


function __ZN13sound_manager5resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $sound=__stackBase__;
      var $gotone;
      $1=$this;
      var $2=$1;
      HEAP32[(($sound)>>2)]=0;
      var $3=__ZNK13sound_manager7machineEv($2);
      var $4=__ZNK15running_machine10devicelistEv($3);
      var $5=__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($4, $sound);
      var $6=(($5)&1);
      $gotone=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$gotone;
      var $9=(($8) & 1);
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=HEAP32[(($sound)>>2)];
      var $12=$11;
      var $13=__ZN16device_interface6deviceEv($12);
      __ZN8device_t5resetEv($13);
      __label__ = 3; break;
    case 3: // $14
      var $15=HEAP32[(($sound)>>2)];
      var $16=$15;
      var $17=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($16, $sound);
      var $18=(($17)&1);
      $gotone=$18;
      __label__ = 1; break;
    case 4: // $19
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13sound_manager15set_attenuationEi($this, $attenuation) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$attenuation;
      var $3=$1;
      var $4=$2;
      var $5=(($3+28)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=__ZNK13sound_manager7machineEv($3);
      var $7=__ZNK15running_machine3osdEv($6);
      var $8=$7;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+28)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($3+24)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $20 = -32;__label__ = 3; break;
    case 2: // $16
      var $17=(($3+28)|0);
      var $18=HEAP32[(($17)>>2)];
      var $20 = $18;__label__ = 3; break;
    case 3: // $19
      var $20;
      FUNCTION_TABLE[$11]($7, $20);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options6volumeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options9int_valueEPKc($3, ((STRING_TABLE.__str283566)|0));
  ;
  return $4;
}


function __ZN11simple_listI12sound_streamED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI12sound_streamED2Ev($2);
  ;
  return;
}


function __ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input($this, $index, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$index;
      $4=$info;
      var $5=$2;
      var $6=__ZNK13sound_manager7machineEv($5);
      var $7=__ZNK15running_machine10devicelistEv($6);
      var $8=HEAP32[((_SPEAKER)>>2)];
      var $9=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($7, $8);
      var $10=__Z8downcastIP14speaker_device8device_tET_PT0_($9);
      var $11=$4;
      var $12=(($11)|0);
      HEAP32[(($12)>>2)]=$10;
      __label__ = 1; break;
    case 1: // $13
      var $14=$4;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $18
      var $19=$3;
      var $20=$4;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=(($23+356)|0);
      var $25=$24;
      var $26=__ZNK22device_sound_interface6inputsEv($25);
      var $27=(($19)|0) < (($26)|0);
      if ($27) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $28
      var $29=$4;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$31;
      var $33=(($32+356)|0);
      var $34=$33;
      var $35=$3;
      var $36=$4;
      var $37=(($36+8)|0);
      var $38=__ZN22device_sound_interface21input_to_stream_inputEiRi($34, $35, $37);
      var $39=$4;
      var $40=(($39+4)|0);
      HEAP32[(($40)>>2)]=$38;
      __label__ = 4; break;
    case 4: // $41
      __label__ = 5; break;
    case 5: // $42
      $1=1;
      __label__ = 9; break;
    case 6: // $43
      var $44=$4;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$46;
      var $48=(($47+356)|0);
      var $49=$48;
      var $50=__ZNK22device_sound_interface6inputsEv($49);
      var $51=$3;
      var $52=(($51-$50)|0);
      $3=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$4;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__ZNK14speaker_device12next_speakerEv($56);
      var $58=$4;
      var $59=(($58)|0);
      HEAP32[(($59)>>2)]=$57;
      __label__ = 1; break;
    case 8: // $60
      $1=0;
      __label__ = 9; break;
    case 9: // $61
      var $62=$1;
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input["X"]=1;

function __ZNK14speaker_device12next_speakerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK8device_t8typenextEv($3);
  var $5=__Z8downcastIP14speaker_device8device_tET_PT0_($4);
  ;
  return $5;
}


function __ZN13sound_manager4muteEbh($this, $mute, $reason) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=(($mute)&1);
      $2=$4;
      $3=$reason;
      var $5=$1;
      var $6=$2;
      var $7=(($6) & 1);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)&255);
      var $11=(($5+24)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$13 | $10;
      var $15=(($14) & 255);
      HEAP8[($11)]=$15;
      __label__ = 3; break;
    case 2: // $16
      var $17=$3;
      var $18=(($17)&255);
      var $19=$18 ^ -1;
      var $20=(($5+24)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$22 & $19;
      var $24=(($23) & 255);
      HEAP8[($20)]=$24;
      __label__ = 3; break;
    case 3: // $25
      var $26=(($5+28)|0);
      var $27=HEAP32[(($26)>>2)];
      __ZN13sound_manager15set_attenuationEi($5, $27);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13sound_managerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+36)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=(($4+36)|0);
      var $10=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return __Z9wav_closeP9_wav_file($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      __label__ = 4; break;
    case 3: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      var $16=(($4+40)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12sound_streamED1Ev($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 4: // $17
      var $18=(($4+36)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($4+40)|0);
      __ZN11simple_listI12sound_streamED1Ev($19);
      ;
      return;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$2;
      var $23=$2;
      var $24=$3;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13sound_manager12stream_allocER8device_tiiiPvPFvPS0_P12sound_streamS2_PPiS7_iE($this, $device, $inputs, $outputs, $sample_rate, $param, $callback) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i1=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $26;
      $18=$this;
      $19=$device;
      $20=$inputs;
      $21=$outputs;
      $22=$sample_rate;
      $23=$param;
      $24=$callback;
      var $27=$18;
      var $28=$24;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $30
      var $31=(($27+40)|0);
      var $32=$19;
      var $33=__ZNK8device_t7machineEv($32);
      var $34=__ZN15running_machine7respoolEv($33);
      var $35=$12;
      var $36=$13;
      var $37=$14;
      var $38=$result_i;
      var $39=$15;
      var $40=$16;
      HEAP32[(($12)>>2)]=80;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($14)>>2)]=839;
      var $41=HEAP32[(($12)>>2)];
      var $42=HEAP32[(($13)>>2)];
      var $43=HEAP32[(($14)>>2)];
      var $44=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41, $42, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $45
      HEAP32[(($result_i)>>2)]=$44;
      var $46=HEAP32[(($result_i)>>2)];
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $48
      var $49=___cxa_allocate_exception(4);
      var $50=$49;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($50);
      (function() { try { __THREW__ = false; return ___cxa_throw($49, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      HEAP32[(($15)>>2)]=$53;
      var $54=$52.f1;
      HEAP32[(($16)>>2)]=$54;
      var $55=HEAP32[(($16)>>2)];
      var $56=(($55)|0) < 0;
      if ($56) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $57
      var $58=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($58);
      throw "Reached an unreachable!"
    case 6: // $59
      var $60=HEAP32[(($15)>>2)];
      var $61=HEAP32[(($15)>>2)];
      var $62=HEAP32[(($16)>>2)];
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $65
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $66=HEAP32[(($result_i)>>2)];
      var $67=$12;
      var $68=$13;
      var $69=$14;
      var $70=$result_i;
      var $71=$15;
      var $72=$16;
      var $73=$66;
      var $74=$19;
      var $75=$20;
      var $76=$21;
      var $77=$22;
      var $78=$23;
      var $79=$24;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12sound_streamC1ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE]($73, $74, $75, $76, $77, $78, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $80
      var $81=__ZN13resource_pool10add_objectI12sound_streamEEPT_S3_($34, $73);
      var $82=__ZN11simple_listI12sound_streamE6appendERS0_($31, $81);
      $17=$82;
      __label__ = 29; break;
    case 10: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $25=$85;
      var $86=$84.f1;
      $26=$86;
      var $87=$9;
      var $88=$10;
      var $89=$11;
      HEAP32[(($9)>>2)]=$66;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($11)>>2)]=839;
      var $90=HEAP32[(($9)>>2)];
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $92
      var $93=HEAP32[(($9)>>2)];
      var $94=HEAP32[(($10)>>2)];
      var $95=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($93, $94, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 31; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $96=$9;
      var $97=$10;
      var $98=$11;
      __label__ = 14; break;
    case 14: // $99
      __label__ = 30; break;
    case 15: // $100
      var $101=(($27+40)|0);
      var $102=$19;
      var $103=__ZNK8device_t7machineEv($102);
      var $104=__ZN15running_machine7respoolEv($103);
      var $105=$4;
      var $106=$5;
      var $107=$6;
      var $108=$result_i1;
      var $109=$7;
      var $110=$8;
      HEAP32[(($4)>>2)]=80;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($6)>>2)]=841;
      var $111=HEAP32[(($4)>>2)];
      var $112=HEAP32[(($5)>>2)];
      var $113=HEAP32[(($6)>>2)];
      var $114=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($111, $112, $113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; };
    case 16: // $115
      HEAP32[(($result_i1)>>2)]=$114;
      var $116=HEAP32[(($result_i1)>>2)];
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $118
      var $119=___cxa_allocate_exception(4);
      var $120=$119;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($120);
      (function() { try { __THREW__ = false; return ___cxa_throw($119, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 18; break; }
    case 18: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $123=$122.f0;
      HEAP32[(($7)>>2)]=$123;
      var $124=$122.f1;
      HEAP32[(($8)>>2)]=$124;
      var $125=HEAP32[(($8)>>2)];
      var $126=(($125)|0) < 0;
      if ($126) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $127
      var $128=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($128);
      throw "Reached an unreachable!"
    case 20: // $129
      var $130=HEAP32[(($7)>>2)];
      var $131=HEAP32[(($7)>>2)];
      var $132=HEAP32[(($8)>>2)];
      var $133=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $131, tempValue);
      var $134=($133.f1 = $132, $133);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $135
      throw "Reached an unreachable!"
    case 22: // $_ZnwjPKci_exit2
      var $136=HEAP32[(($result_i1)>>2)];
      var $137=$4;
      var $138=$5;
      var $139=$6;
      var $140=$result_i1;
      var $141=$7;
      var $142=$8;
      var $143=$136;
      var $144=$19;
      var $145=$20;
      var $146=$21;
      var $147=$22;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12sound_streamC1ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE]($143, $144, $145, $146, $147, 0, 854) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $148
      var $149=__ZN13resource_pool10add_objectI12sound_streamEEPT_S3_($104, $143);
      var $150=__ZN11simple_listI12sound_streamE6appendERS0_($101, $149);
      $17=$150;
      __label__ = 29; break;
    case 24: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      $25=$153;
      var $154=$152.f1;
      $26=$154;
      var $155=$1;
      var $156=$2;
      var $157=$3;
      HEAP32[(($1)>>2)]=$136;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3538)|0);
      HEAP32[(($3)>>2)]=841;
      var $158=HEAP32[(($1)>>2)];
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $160
      var $161=HEAP32[(($1)>>2)];
      var $162=HEAP32[(($2)>>2)];
      var $163=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($161, $162, $163) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $_noexc3
      __label__ = 27; break;
    case 27: // $_ZdlPvPKci_exit4
      var $164=$1;
      var $165=$2;
      var $166=$3;
      __label__ = 28; break;
    case 28: // $167
      __label__ = 30; break;
    case 29: // $168
      var $169=$17;
      STACKTOP = __stackBase__;
      return $169;
    case 30: // $170
      var $171=$25;
      var $172=$25;
      var $173=$26;
      var $174=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $172, tempValue);
      var $175=($174.f1 = $173, $174);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 31: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13sound_manager12stream_allocER8device_tiiiPvPFvPS0_P12sound_streamS2_PPiS7_iE["X"]=1;

function __ZN13resource_pool10add_objectI12sound_streamEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12sound_streamEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12sound_streamEEPT_S3_["X"]=1;

function __ZN21delegate_internal_mfpC2IM13sound_managerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM13sound_managerFviP14_xml_data_nodeEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13video_manager12speed_factorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+112)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI12sound_streamE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12sound_stream4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI22device_sound_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZN13sound_manager6updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $samples_this_update=__stackBase__;
      var $speaker;
      var $finalmix_step;
      var $finalmix_offset;
      var $finalmix;
      var $sample;
      var $sampindex;
      var $samp;
      var $curtime=__stackBase__+4;
      var $second_tick;
      var $stream;
      var $stream1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 268);
      HEAP32[(($samples_this_update)>>2)]=0;
      var $5=__ZNK13sound_manager7machineEv($2);
      var $6=__ZNK15running_machine10devicelistEv($5);
      var $7=HEAP32[((_SPEAKER)>>2)];
      var $8=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($6, $7);
      var $9=__Z8downcastIP14speaker_device8device_tET_PT0_($8);
      $speaker=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$speaker;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $13
      var $14=$speaker;
      var $15=(($2+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($2+20)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($2+24)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$21 & 8;
      var $23=(($22)|0)!=0;
      __ZN14speaker_device3mixEPiS0_Rib($14, $16, $18, $samples_this_update, $23);
      __label__ = 5; break;
    case 5: // $24
      var $25=$speaker;
      var $26=__ZNK14speaker_device12next_speakerEv($25);
      $speaker=$26;
      __label__ = 3; break;
    case 6: // $27
      var $28=__ZNK13sound_manager7machineEv($2);
      var $29=__ZNK15running_machine5videoEv($28);
      var $30=__ZNK13video_manager12speed_factorEv($29);
      $finalmix_step=$30;
      $finalmix_offset=0;
      var $31=(($2+12)|0);
      var $32=HEAP32[(($31)>>2)];
      $finalmix=$32;
      var $33=(($2+8)|0);
      var $34=HEAP32[(($33)>>2)];
      $sample=$34;
      __label__ = 7; break;
    case 7: // $35
      var $36=$sample;
      var $37=HEAP32[(($samples_this_update)>>2)];
      var $38=(($37*100)|0);
      var $39=(($36)|0) < (($38)|0);
      if ($39) { __label__ = 8; break; } else { __label__ = 20; break; }
    case 8: // $40
      var $41=$sample;
      var $42=(((($41)|0)/100)|0);
      $sampindex=$42;
      var $43=$sampindex;
      var $44=(($2+16)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+($43<<2))|0);
      var $47=HEAP32[(($46)>>2)];
      $samp=$47;
      var $48=$samp;
      var $49=(($48)|0) < -32768;
      if ($49) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $50
      $samp=-32768;
      __label__ = 13; break;
    case 10: // $51
      var $52=$samp;
      var $53=(($52)|0) > 32767;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      $samp=32767;
      __label__ = 12; break;
    case 12: // $55
      __label__ = 13; break;
    case 13: // $56
      var $57=$samp;
      var $58=(($57) & 65535);
      var $59=$finalmix_offset;
      var $60=(($59+1)|0);
      $finalmix_offset=$60;
      var $61=$finalmix;
      var $62=(($61+($59<<1))|0);
      HEAP16[(($62)>>1)]=$58;
      var $63=$sampindex;
      var $64=(($2+20)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+($63<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      $samp=$67;
      var $68=$samp;
      var $69=(($68)|0) < -32768;
      if ($69) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $70
      $samp=-32768;
      __label__ = 18; break;
    case 15: // $71
      var $72=$samp;
      var $73=(($72)|0) > 32767;
      if ($73) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $74
      $samp=32767;
      __label__ = 17; break;
    case 17: // $75
      __label__ = 18; break;
    case 18: // $76
      var $77=$samp;
      var $78=(($77) & 65535);
      var $79=$finalmix_offset;
      var $80=(($79+1)|0);
      $finalmix_offset=$80;
      var $81=$finalmix;
      var $82=(($81+($79<<1))|0);
      HEAP16[(($82)>>1)]=$78;
      __label__ = 19; break;
    case 19: // $83
      var $84=$finalmix_step;
      var $85=$sample;
      var $86=(($85+$84)|0);
      $sample=$86;
      __label__ = 7; break;
    case 20: // $87
      var $88=$sample;
      var $89=HEAP32[(($samples_this_update)>>2)];
      var $90=(($89*100)|0);
      var $91=(($88-$90)|0);
      var $92=(($2+8)|0);
      HEAP32[(($92)>>2)]=$91;
      var $93=$finalmix_offset;
      var $94=(($93)>>>0) > 0;
      if ($94) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $95
      var $96=(($2+32)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $99
      var $100=__ZNK13sound_manager7machineEv($2);
      var $101=__ZNK15running_machine3osdEv($100);
      var $102=$101;
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+24)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$finalmix;
      var $107=$finalmix_offset;
      var $108=Math.floor((($107)>>>0)/2);
      FUNCTION_TABLE[$105]($101, $106, $108);
      __label__ = 23; break;
    case 23: // $109
      var $110=__ZNK13sound_manager7machineEv($2);
      var $111=__ZNK15running_machine5videoEv($110);
      var $112=$finalmix;
      var $113=$finalmix_offset;
      var $114=Math.floor((($113)>>>0)/2);
      __ZN13video_manager22add_sound_to_recordingEPKsi($111, $112, $114);
      var $115=(($2+36)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $118
      var $119=(($2+36)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$finalmix;
      var $122=$finalmix_offset;
      __Z15wav_add_data_16P9_wav_filePsi($120, $121, $122);
      __label__ = 25; break;
    case 25: // $123
      __label__ = 26; break;
    case 26: // $124
      var $125=__ZNK13sound_manager7machineEv($2);
      __ZNK15running_machine4timeEv($curtime, $125);
      $second_tick=0;
      var $126=(($curtime)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($2+68)|0);
      var $129=(($128)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($127)|0)!=(($130)|0);
      if ($131) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 27: // $132
      __label__ = 28; break;
    case 28: // $133
      __label__ = 29; break;
    case 29: // $134
      $second_tick=1;
      __label__ = 30; break;
    case 30: // $135
      var $136=(($2+40)|0);
      var $137=__ZNK11simple_listI12sound_streamE5firstEv($136);
      $stream=$137;
      __label__ = 31; break;
    case 31: // $138
      var $139=$stream;
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $141
      var $142=$stream;
      var $143=$second_tick;
      var $144=(($143) & 1);
      __ZN12sound_stream22update_with_accountingEb($142, $144);
      __label__ = 33; break;
    case 33: // $145
      var $146=$stream;
      var $147=__ZNK12sound_stream4nextEv($146);
      $stream=$147;
      __label__ = 31; break;
    case 34: // $148
      var $149=(($2+68)|0);
      var $150=$149;
      var $151=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($150)>>2)]=HEAP32[(($151)>>2)];HEAP32[(($150+4)>>2)]=HEAP32[(($151+4)>>2)];HEAP32[(($150+8)>>2)]=HEAP32[(($151+8)>>2)];
      var $152=(($2+40)|0);
      var $153=__ZNK11simple_listI12sound_streamE5firstEv($152);
      $stream1=$153;
      __label__ = 35; break;
    case 35: // $154
      var $155=$stream1;
      var $156=(($155)|0)!=0;
      if ($156) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $157
      var $158=$stream1;
      __ZN12sound_stream25apply_sample_rate_changesEv($158);
      __label__ = 37; break;
    case 37: // $159
      var $160=$stream1;
      var $161=__ZNK12sound_stream4nextEv($160);
      $stream1=$161;
      __label__ = 35; break;
    case 38: // $162
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13sound_manager6updateEv["X"]=1;

function __ZNK8device_t4nextI22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI12sound_streamEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12sound_streamEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12sound_streamEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 80);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12sound_streamE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12sound_streamED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12sound_streamED2Ev($2);
  ;
  return;
}


function __ZN8delegateIFvvEEC2I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13sound_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13sound_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM13sound_managerFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=868;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM13sound_managerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM13sound_managerFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13sound_managerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13sound_manager, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFviP14_xml_data_nodeEEC2I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I13sound_managerEEN15delegate_traitsIT_viS1_S2_S2_E16member_func_typeEPKcPS7_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I13sound_managerEEN15delegate_traitsIT_viS1_S2_S2_E16member_func_typeEPKcPS7_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM13sound_managerFviP14_xml_data_nodeEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=870;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM13sound_managerFviP14_xml_data_nodeEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM13sound_managerFviP14_xml_data_nodeEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI13sound_managerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13sound_manager, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIsEC1EPsi($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIsEC2EPsi($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIsEC2EPsi($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<1))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIsE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIsED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIsED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12sound_streamED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12sound_streamED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12sound_streamED0Ev["X"]=1;

function __ZN20resource_pool_objectI12sound_streamED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI12sound_streamE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIsED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIsED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIsED0Ev["X"]=1;

function __ZN19resource_pool_arrayIsED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIsE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM12sound_streamFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12sound_streamE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12sound_streamE6detachERS0_["X"]=1;

function __ZN11simple_listI12sound_streamEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI12sound_streamE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI12sound_streamED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI12sound_streamE+8)|0);
  __ZN11simple_listI12sound_streamE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI12sound_streamE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI12sound_streamE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12sound_streamE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI12sound_streamE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN8delegateIFvvEEC2I12sound_streamEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I12sound_streamEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I12sound_streamEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM12sound_streamFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=872;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM12sound_streamFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM12sound_streamFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI12sound_streamEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI12sound_stream, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIN12sound_stream13stream_outputEEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIN12sound_stream13stream_outputEEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIN12sound_stream13stream_outputEEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<4))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIN12sound_stream13stream_outputEE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIN12sound_stream13stream_outputEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIN12sound_stream13stream_outputEED2Ev($2);
  ;
  return;
}


function __ZN19resource_pool_arrayIPiEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIPiEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIPiEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<2))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIPiE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIPiED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIPiED2Ev($2);
  ;
  return;
}


function __ZN19resource_pool_arrayIN12sound_stream12stream_inputEEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIN12sound_stream12stream_inputEEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIN12sound_stream12stream_inputEEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=(($8*28)|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIN12sound_stream12stream_inputEE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIN12sound_stream12stream_inputEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIN12sound_stream12stream_inputEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI12sound_streamED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI12sound_streamED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI12sound_streamED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN12sound_stream13stream_outputEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN12sound_stream13stream_outputEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN12sound_stream13stream_outputEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN12sound_stream13stream_outputEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIN12sound_stream13stream_outputEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIPiED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIPiED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIPiED0Ev["X"]=1;

function __ZN19resource_pool_arrayIPiED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIPiE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIN12sound_stream12stream_inputEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN12sound_stream12stream_inputEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN12sound_stream12stream_inputEED0Ev["X"]=1;

function __GLOBAL__I_a3574() {
  ;
  var __label__;

  ___cxx_global_var_init3571();
  ;
  return;
}


function __Z8gfx_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 8504; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $gfxdecodeinfo;
      var $curgfx;
      var $gfxdecode;
      var $region;
      var $region_length;
      var $region_base;
      var $xscale;
      var $yscale;
      var $extpoffs;
      var $extxoffs=__stackBase__;
      var $extyoffs=__stackBase__+4096;
      var $gl;
      var $israw;
      var $planes;
      var $width;
      var $height;
      var $total;
      var $charincrement;
      var $glcopy=__stackBase__+8192;
      var $j;
      var $value1;
      var $value2;
      var $value3;
      var $base;
      var $end;
      var $linemod;
      var $elementbase;
      var $lastpixelbase;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine6configEv($2);
      var $4=(($3+44)|0);
      var $5=HEAP32[(($4)>>2)];
      $gfxdecodeinfo=$5;
      var $6=$gfxdecodeinfo;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 78; break;
    case 2: // $9
      $curgfx=0;
      __label__ = 3; break;
    case 3: // $10
      var $11=$curgfx;
      var $12=(($11)|0) < 32;
      if ($12) { __label__ = 4; break; } else { var $21 = 0;__label__ = 5; break; }
    case 4: // $13
      var $14=$curgfx;
      var $15=$gfxdecodeinfo;
      var $16=(($15+$14*20)|0);
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      var $21 = $19;__label__ = 5; break;
    case 5: // $20
      var $21;
      if ($21) { __label__ = 6; break; } else { __label__ = 78; break; }
    case 6: // $22
      var $23=$curgfx;
      var $24=$gfxdecodeinfo;
      var $25=(($24+$23*20)|0);
      $gfxdecode=$25;
      var $26=$gfxdecode;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $30
      var $31=$1;
      var $32=$gfxdecode;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZN15running_machine6regionEPKc($31, $34);
      var $38 = $35;__label__ = 9; break;
    case 8: // $36
      var $38 = 0;__label__ = 9; break;
    case 9: // $37
      var $38;
      $region=$38;
      var $39=$region;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $41
      var $42=$region;
      var $43=__ZNK13memory_region5bytesEv($42);
      var $44=((($43<<3))|0);
      var $47 = $44;__label__ = 12; break;
    case 11: // $45
      var $47 = 0;__label__ = 12; break;
    case 12: // $46
      var $47;
      $region_length=$47;
      var $48=$region;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $50
      var $51=$region;
      var $52=__ZNK13memory_region4baseEv($51);
      var $55 = $52;__label__ = 15; break;
    case 14: // $53
      var $55 = 0;__label__ = 15; break;
    case 15: // $54
      var $55;
      $region_base=$55;
      var $56=$gfxdecode;
      var $57=(($56+16)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $61
      var $68 = 1;__label__ = 18; break;
    case 17: // $62
      var $63=$gfxdecode;
      var $64=(($63+16)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $68 = $66;__label__ = 18; break;
    case 18: // $67
      var $68;
      $xscale=$68;
      var $69=$gfxdecode;
      var $70=(($69+17)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $74
      var $81 = 1;__label__ = 21; break;
    case 20: // $75
      var $76=$gfxdecode;
      var $77=(($76+17)|0);
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $81 = $79;__label__ = 21; break;
    case 21: // $80
      var $81;
      $yscale=$81;
      var $82=$gfxdecode;
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      $gl=$84;
      var $85=$gl;
      var $86=(($85+12)|0);
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)==305419896;
      var $90=(($89)&1);
      $israw=$90;
      var $91=$gl;
      var $92=(($91+8)|0);
      var $93=HEAPU16[(($92)>>1)];
      var $94=(($93)&65535);
      $planes=$94;
      var $95=$gl;
      var $96=(($95)|0);
      var $97=HEAPU16[(($96)>>1)];
      var $98=(($97)&65535);
      $width=$98;
      var $99=$gl;
      var $100=(($99+2)|0);
      var $101=HEAPU16[(($100)>>1)];
      var $102=(($101)&65535);
      $height=$102;
      var $103=$gl;
      var $104=(($103+4)|0);
      var $105=HEAP32[(($104)>>2)];
      $total=$105;
      var $106=$gl;
      var $107=(($106+300)|0);
      var $108=HEAP32[(($107)>>2)];
      $charincrement=$108;
      var $109=$gfxdecode;
      var $110=(($109+8)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$glcopy;
      var $113=$111;
      assert(312 % 1 === 0, 'memcpy given ' + 312 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $113>>2, $$dest = $112>>2, $$stop = $$src + 78; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $114=(($extxoffs)|0);
      var $115=$114;
      var $116=(($glcopy+44)|0);
      var $117=(($116)|0);
      var $118=$117;
      assert(128 % 1 === 0, 'memcpy given ' + 128 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($115, $118, 128, 1);
      var $119=(($extyoffs)|0);
      var $120=$119;
      var $121=(($glcopy+172)|0);
      var $122=(($121)|0);
      var $123=$122;
      assert(128 % 1 === 0, 'memcpy given ' + 128 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($120, $123, 128, 1);
      var $124=(($glcopy+304)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $127
      var $128=(($extxoffs)|0);
      var $129=$128;
      var $130=(($glcopy+304)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$131;
      var $133=(($glcopy)|0);
      var $134=HEAPU16[(($133)>>1)];
      var $135=(($134)&65535);
      var $136=((($135<<2))|0);
      assert($136 % 1 === 0, 'memcpy given ' + $136 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($129, $132, $136, 1);
      __label__ = 23; break;
    case 23: // $137
      var $138=(($glcopy+308)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $141
      var $142=(($extyoffs)|0);
      var $143=$142;
      var $144=(($glcopy+308)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$145;
      var $147=(($glcopy+2)|0);
      var $148=HEAPU16[(($147)>>1)];
      var $149=(($148)&65535);
      var $150=((($149<<2))|0);
      assert($150 % 1 === 0, 'memcpy given ' + $150 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($143, $146, $150, 1);
      __label__ = 25; break;
    case 25: // $151
      var $152=(($extxoffs)|0);
      var $153=(($glcopy+304)|0);
      HEAP32[(($153)>>2)]=$152;
      var $154=(($extyoffs)|0);
      var $155=(($glcopy+308)|0);
      HEAP32[(($155)>>2)]=$154;
      var $156=(($glcopy+12)|0);
      var $157=(($156)|0);
      $extpoffs=$157;
      var $158=$xscale;
      var $159=(($158)>>>0) > 1;
      if ($159) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $160
      var $161=$xscale;
      var $162=$width;
      var $163=(($162*$161)|0);
      $width=$163;
      var $164=$width;
      var $165=(($164-1)|0);
      $j=$165;
      __label__ = 27; break;
    case 27: // $166
      var $167=$j;
      var $168=(($167)|0) >= 0;
      if ($168) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $169
      var $170=$j;
      var $171=$xscale;
      var $172=Math.floor((($170)>>>0)/(($171)>>>0));
      var $173=(($extxoffs+($172<<2))|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$j;
      var $176=(($extxoffs+($175<<2))|0);
      HEAP32[(($176)>>2)]=$174;
      __label__ = 29; break;
    case 29: // $177
      var $178=$j;
      var $179=(($178-1)|0);
      $j=$179;
      __label__ = 27; break;
    case 30: // $180
      __label__ = 31; break;
    case 31: // $181
      var $182=$yscale;
      var $183=(($182)>>>0) > 1;
      if ($183) { __label__ = 32; break; } else { __label__ = 37; break; }
    case 32: // $184
      var $185=$yscale;
      var $186=$height;
      var $187=(($186*$185)|0);
      $height=$187;
      var $188=$height;
      var $189=(($188-1)|0);
      $j=$189;
      __label__ = 33; break;
    case 33: // $190
      var $191=$j;
      var $192=(($191)|0) >= 0;
      if ($192) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $193
      var $194=$j;
      var $195=$yscale;
      var $196=Math.floor((($194)>>>0)/(($195)>>>0));
      var $197=(($extyoffs+($196<<2))|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=$j;
      var $200=(($extyoffs+($199<<2))|0);
      HEAP32[(($200)>>2)]=$198;
      __label__ = 35; break;
    case 35: // $201
      var $202=$j;
      var $203=(($202-1)|0);
      $j=$203;
      __label__ = 33; break;
    case 36: // $204
      __label__ = 37; break;
    case 37: // $205
      var $206=$total;
      var $207=$206 & -2147483648;
      var $208=(($207)|0)!=0;
      if ($208) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $209
      __label__ = 39; break;
    case 39: // $210
      __label__ = 40; break;
    case 40: // $211
      var $212=$region_length;
      var $213=$charincrement;
      var $214=Math.floor((($212)>>>0)/(($213)>>>0));
      var $215=$total;
      var $216=$215 >>> 27;
      var $217=$216 & 15;
      var $218=(($214*$217)|0);
      var $219=$total;
      var $220=$219 >>> 23;
      var $221=$220 & 15;
      var $222=Math.floor((($218)>>>0)/(($221)>>>0));
      $total=$222;
      __label__ = 41; break;
    case 41: // $223
      var $224=$israw;
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 67; break; } else { __label__ = 42; break; }
    case 42: // $226
      $j=0;
      __label__ = 43; break;
    case 43: // $227
      var $228=$j;
      var $229=$planes;
      var $230=(($228)|0) < (($229)|0);
      if ($230) { __label__ = 44; break; } else { __label__ = 50; break; }
    case 44: // $231
      var $232=$j;
      var $233=$extpoffs;
      var $234=(($233+($232<<2))|0);
      var $235=HEAP32[(($234)>>2)];
      $value1=$235;
      var $236=$value1;
      var $237=$236 & -2147483648;
      var $238=(($237)|0)!=0;
      if ($238) { __label__ = 45; break; } else { __label__ = 48; break; }
    case 45: // $239
      __label__ = 46; break;
    case 46: // $240
      __label__ = 47; break;
    case 47: // $241
      var $242=$value1;
      var $243=$242 & 8388607;
      var $244=$region_length;
      var $245=$value1;
      var $246=$245 >>> 27;
      var $247=$246 & 15;
      var $248=(($244*$247)|0);
      var $249=$value1;
      var $250=$249 >>> 23;
      var $251=$250 & 15;
      var $252=Math.floor((($248)>>>0)/(($251)>>>0));
      var $253=(($243+$252)|0);
      var $254=$j;
      var $255=$extpoffs;
      var $256=(($255+($254<<2))|0);
      HEAP32[(($256)>>2)]=$253;
      __label__ = 48; break;
    case 48: // $257
      __label__ = 49; break;
    case 49: // $258
      var $259=$j;
      var $260=(($259+1)|0);
      $j=$260;
      __label__ = 43; break;
    case 50: // $261
      $j=0;
      __label__ = 51; break;
    case 51: // $262
      var $263=$j;
      var $264=$width;
      var $265=(($263)>>>0) < (($264)>>>0);
      if ($265) { __label__ = 52; break; } else { __label__ = 58; break; }
    case 52: // $266
      var $267=$j;
      var $268=(($extxoffs+($267<<2))|0);
      var $269=HEAP32[(($268)>>2)];
      $value2=$269;
      var $270=$value2;
      var $271=$270 & -2147483648;
      var $272=(($271)|0)!=0;
      if ($272) { __label__ = 53; break; } else { __label__ = 56; break; }
    case 53: // $273
      __label__ = 54; break;
    case 54: // $274
      __label__ = 55; break;
    case 55: // $275
      var $276=$value2;
      var $277=$276 & 8388607;
      var $278=$region_length;
      var $279=$value2;
      var $280=$279 >>> 27;
      var $281=$280 & 15;
      var $282=(($278*$281)|0);
      var $283=$value2;
      var $284=$283 >>> 23;
      var $285=$284 & 15;
      var $286=Math.floor((($282)>>>0)/(($285)>>>0));
      var $287=(($277+$286)|0);
      var $288=$j;
      var $289=(($extxoffs+($288<<2))|0);
      HEAP32[(($289)>>2)]=$287;
      __label__ = 56; break;
    case 56: // $290
      __label__ = 57; break;
    case 57: // $291
      var $292=$j;
      var $293=(($292+1)|0);
      $j=$293;
      __label__ = 51; break;
    case 58: // $294
      $j=0;
      __label__ = 59; break;
    case 59: // $295
      var $296=$j;
      var $297=$height;
      var $298=(($296)>>>0) < (($297)>>>0);
      if ($298) { __label__ = 60; break; } else { __label__ = 66; break; }
    case 60: // $299
      var $300=$j;
      var $301=(($extyoffs+($300<<2))|0);
      var $302=HEAP32[(($301)>>2)];
      $value3=$302;
      var $303=$value3;
      var $304=$303 & -2147483648;
      var $305=(($304)|0)!=0;
      if ($305) { __label__ = 61; break; } else { __label__ = 64; break; }
    case 61: // $306
      __label__ = 62; break;
    case 62: // $307
      __label__ = 63; break;
    case 63: // $308
      var $309=$value3;
      var $310=$309 & 8388607;
      var $311=$region_length;
      var $312=$value3;
      var $313=$312 >>> 27;
      var $314=$313 & 15;
      var $315=(($311*$314)|0);
      var $316=$value3;
      var $317=$316 >>> 23;
      var $318=$317 & 15;
      var $319=Math.floor((($315)>>>0)/(($318)>>>0));
      var $320=(($310+$319)|0);
      var $321=$j;
      var $322=(($extyoffs+($321<<2))|0);
      HEAP32[(($322)>>2)]=$320;
      __label__ = 64; break;
    case 64: // $323
      __label__ = 65; break;
    case 65: // $324
      var $325=$j;
      var $326=(($325+1)|0);
      $j=$326;
      __label__ = 59; break;
    case 66: // $327
      __label__ = 73; break;
    case 67: // $328
      var $329=$gfxdecode;
      var $330=(($329+4)|0);
      var $331=HEAP32[(($330)>>2)];
      $base=$331;
      var $332=$region_length;
      var $333=Math.floor((($332)>>>0)/8);
      $end=$333;
      var $334=$gl;
      var $335=(($334+172)|0);
      var $336=(($335)|0);
      var $337=HEAP32[(($336)>>2)];
      $linemod=$337;
      __label__ = 68; break;
    case 68: // $338
      var $339=$total;
      var $340=(($339)>>>0) > 0;
      if ($340) { __label__ = 69; break; } else { __label__ = 72; break; }
    case 69: // $341
      var $342=$base;
      var $343=$total;
      var $344=(($343-1)|0);
      var $345=$charincrement;
      var $346=(($344*$345)|0);
      var $347=Math.floor((($346)>>>0)/8);
      var $348=(($342+$347)|0);
      $elementbase=$348;
      var $349=$elementbase;
      var $350=$height;
      var $351=$linemod;
      var $352=(($350*$351)|0);
      var $353=Math.floor((($352)>>>0)/8);
      var $354=(($349+$353)|0);
      var $355=(($354-1)|0);
      $lastpixelbase=$355;
      var $356=$lastpixelbase;
      var $357=$end;
      var $358=(($356)|0) < (($357)|0);
      if ($358) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $359
      __label__ = 72; break;
    case 71: // $360
      var $361=$total;
      var $362=(($361-1)|0);
      $total=$362;
      __label__ = 68; break;
    case 72: // $363
      __label__ = 73; break;
    case 73: // $364
      var $365=$width;
      var $366=(($365) & 65535);
      var $367=(($glcopy)|0);
      HEAP16[(($367)>>1)]=$366;
      var $368=$height;
      var $369=(($368) & 65535);
      var $370=(($glcopy+2)|0);
      HEAP16[(($370)>>1)]=$369;
      var $371=$total;
      var $372=(($glcopy+4)|0);
      HEAP32[(($372)>>2)]=$371;
      var $373=$1;
      var $374=$region_base;
      var $375=(($374)|0)!=0;
      if ($375) { __label__ = 74; break; } else { __label__ = 75; break; }
    case 74: // $376
      var $377=$region_base;
      var $378=$gfxdecode;
      var $379=(($378+4)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=(($377+$380)|0);
      var $384 = $381;__label__ = 76; break;
    case 75: // $382
      var $384 = 0;__label__ = 76; break;
    case 76: // $383
      var $384;
      var $385=$gfxdecode;
      var $386=(($385+14)|0);
      var $387=HEAPU16[(($386)>>1)];
      var $388=(($387)&65535);
      var $389=$gfxdecode;
      var $390=(($389+12)|0);
      var $391=HEAPU16[(($390)>>1)];
      var $392=(($391)&65535);
      var $393=__Z17gfx_element_allocR15running_machinePK11_gfx_layoutPKhjj($373, $glcopy, $384, $388, $392);
      var $394=$curgfx;
      var $395=$1;
      var $396=(($395+432)|0);
      var $397=(($396+($394<<2))|0);
      HEAP32[(($397)>>2)]=$393;
      __label__ = 77; break;
    case 77: // $398
      var $399=$curgfx;
      var $400=(($399+1)|0);
      $curgfx=$400;
      __label__ = 3; break;
    case 78: // $401
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z8gfx_initR15running_machine["X"]=1;

function __ZN19resource_pool_arrayIN12sound_stream12stream_inputEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIN12sound_stream12stream_inputEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17gfx_element_allocR15running_machinePK11_gfx_layoutPKhjj($machine, $gl, $srcdata, $total_colors, $color_base) {
  var __stackBase__  = STACKTOP; STACKTOP += 164; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i9=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i7=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $result_i5=__stackBase__+60;
      var $14=__stackBase__+64;
      var $15=__stackBase__+68;
      var $16=__stackBase__+72;
      var $17=__stackBase__+76;
      var $18=__stackBase__+80;
      var $result_i3=__stackBase__+84;
      var $19=__stackBase__+88;
      var $20=__stackBase__+92;
      var $21=__stackBase__+96;
      var $22=__stackBase__+100;
      var $23=__stackBase__+104;
      var $result_i2=__stackBase__+108;
      var $24=__stackBase__+112;
      var $25=__stackBase__+116;
      var $26=__stackBase__+120;
      var $27=__stackBase__+124;
      var $28=__stackBase__+128;
      var $29=__stackBase__+132;
      var $30=__stackBase__+136;
      var $31=__stackBase__+140;
      var $32=__stackBase__+144;
      var $33=__stackBase__+148;
      var $result_i=__stackBase__+152;
      var $34=__stackBase__+156;
      var $35=__stackBase__+160;
      var $36;
      var $37;
      var $38;
      var $39;
      var $40;
      var $israw;
      var $planes;
      var $width;
      var $height;
      var $total;
      var $gfx;
      var $41;
      var $42;
      var $buffer;
      var $buffer1;
      $36=$machine;
      $37=$gl;
      $38=$srcdata;
      $39=$total_colors;
      $40=$color_base;
      var $43=$37;
      var $44=(($43+12)|0);
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==305419896;
      var $48=(($47)&1);
      $israw=$48;
      var $49=$37;
      var $50=(($49+8)|0);
      var $51=HEAPU16[(($50)>>1)];
      var $52=(($51)&65535);
      $planes=$52;
      var $53=$37;
      var $54=(($53)|0);
      var $55=HEAP16[(($54)>>1)];
      $width=$55;
      var $56=$37;
      var $57=(($56+2)|0);
      var $58=HEAP16[(($57)>>1)];
      $height=$58;
      var $59=$37;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      $total=$61;
      var $62=$36;
      var $63=__ZN15running_machine7respoolEv($62);
      var $64=$30;
      var $65=$31;
      var $66=$32;
      var $67=$33;
      var $68=$result_i;
      var $69=$34;
      var $70=$35;
      HEAP32[(($30)>>2)]=376;
      HEAP32[(($31)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($32)>>2)]=230;
      HEAP32[(($33)>>2)]=_zeromem;
      var $71=HEAP32[(($30)>>2)];
      var $72=HEAP32[(($31)>>2)];
      var $73=HEAP32[(($32)>>2)];
      var $74=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $75
      HEAP32[(($result_i)>>2)]=$74;
      var $76=HEAP32[(($result_i)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $78
      var $79=___cxa_allocate_exception(4);
      var $80=$79;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($80);
      (function() { try { __THREW__ = false; return ___cxa_throw($79, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      HEAP32[(($34)>>2)]=$83;
      var $84=$82.f1;
      HEAP32[(($35)>>2)]=$84;
      var $85=HEAP32[(($35)>>2)];
      var $86=(($85)|0) < 0;
      if ($86) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $87
      var $88=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($88);
      throw "Reached an unreachable!"
    case 5: // $89
      var $90=HEAP32[(($34)>>2)];
      var $91=HEAP32[(($34)>>2)];
      var $92=HEAP32[(($35)>>2)];
      var $93=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $91, tempValue);
      var $94=($93.f1 = $92, $93);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $95
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $96=HEAP32[(($result_i)>>2)];
      var $97=HEAP32[(($30)>>2)];
      _memset($96, 0, $97, 1);
      var $98=HEAPU32[(($result_i)>>2)];
      var $99=$30;
      var $100=$31;
      var $101=$32;
      var $102=$33;
      var $103=$result_i;
      var $104=$34;
      var $105=$35;
      var $106=$98;
      var $107=$36;
      (function() { try { __THREW__ = false; return __ZN11gfx_elementC1ER15running_machine($106, $107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $108
      var $109=__ZN13resource_pool10add_objectI11gfx_elementEEPT_S3_($63, $106);
      $gfx=$109;
      var $110=$width;
      var $111=$gfx;
      var $112=(($111)|0);
      HEAP16[(($112)>>1)]=$110;
      var $113=$height;
      var $114=$gfx;
      var $115=(($114+2)|0);
      HEAP16[(($115)>>1)]=$113;
      var $116=$width;
      var $117=$gfx;
      var $118=(($117+8)|0);
      HEAP16[(($118)>>1)]=$116;
      var $119=$height;
      var $120=$gfx;
      var $121=(($120+10)|0);
      HEAP16[(($121)>>1)]=$119;
      var $122=$total;
      var $123=$gfx;
      var $124=(($123+16)|0);
      HEAP32[(($124)>>2)]=$122;
      var $125=$40;
      var $126=$gfx;
      var $127=(($126+20)|0);
      HEAP32[(($127)>>2)]=$125;
      var $128=$planes;
      var $129=1 << $128;
      var $130=(($129) & 65535);
      var $131=$gfx;
      var $132=(($131+24)|0);
      HEAP16[(($132)>>1)]=$130;
      var $133=$planes;
      var $134=1 << $133;
      var $135=(($134) & 65535);
      var $136=$gfx;
      var $137=(($136+26)|0);
      HEAP16[(($137)>>1)]=$135;
      var $138=$39;
      var $139=$gfx;
      var $140=(($139+28)|0);
      HEAP32[(($140)>>2)]=$138;
      var $141=$38;
      var $142=$gfx;
      var $143=(($142+48)|0);
      HEAP32[(($143)>>2)]=$141;
      var $144=$gfx;
      var $145=(($144+60)|0);
      var $146=$37;
      var $147=$145;
      var $148=$146;
      assert(312 % 1 === 0, 'memcpy given ' + 312 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $148>>2, $$dest = $147>>2, $$stop = $$src + 78; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $149=$gfx;
      var $150=(($149+60)|0);
      var $151=(($150+304)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 9; break; } else { __label__ = 25; break; }
    case 9: // $154
      var $155=$gfx;
      var $156=(($155+60)|0);
      var $157=(($156)|0);
      var $158=HEAPU16[(($157)>>1)];
      var $159=(($158)&65535);
      var $160=(($159)>>>0) < 32;
      if ($160) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $161
      var $162=$gfx;
      var $163=(($162+60)|0);
      var $164=(($163+44)|0);
      var $165=(($164)|0);
      var $166=$165;
      var $167=$gfx;
      var $168=(($167+60)|0);
      var $169=(($168+304)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$170;
      var $172=$gfx;
      var $173=(($172+60)|0);
      var $174=(($173)|0);
      var $175=HEAPU16[(($174)>>1)];
      var $176=(($175)&65535);
      var $177=((($176<<2))|0);
      assert($177 % 1 === 0, 'memcpy given ' + $177 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($166, $171, $177, 1);
      var $178=$gfx;
      var $179=(($178+60)|0);
      var $180=(($179+304)|0);
      HEAP32[(($180)>>2)]=0;
      __label__ = 24; break;
    case 11: // $181
      var $182=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $183=$182.f0;
      $41=$183;
      var $184=$182.f1;
      $42=$184;
      var $185=$26;
      var $186=$27;
      var $187=$28;
      var $188=$29;
      HEAP32[(($26)>>2)]=$98;
      HEAP32[(($27)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($28)>>2)]=230;
      HEAP32[(($29)>>2)]=_zeromem;
      var $189=HEAP32[(($26)>>2)];
      var $190=(($189)|0)!=0;
      if ($190) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $191
      var $192=HEAP32[(($26)>>2)];
      var $193=HEAP32[(($27)>>2)];
      var $194=HEAP32[(($28)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($192, $193, $194) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 70; break; }
    case 13: // $_noexc
      __label__ = 14; break;
    case 14: // $_ZdlPvPKciRK9zeromem_t_exit
      var $195=$26;
      var $196=$27;
      var $197=$28;
      var $198=$29;
      __label__ = 15; break;
    case 15: // $199
      __label__ = 69; break;
    case 16: // $200
      var $201=$36;
      var $202=__ZN15running_machine7respoolEv($201);
      var $203=$gfx;
      var $204=(($203+60)|0);
      var $205=(($204)|0);
      var $206=HEAPU16[(($205)>>1)];
      var $207=(($206)&65535);
      var $208=_llvm_umul_with_overflow_i32($207, 4);
      var $209=$208.f1;
      var $210=$208.f0;
      var $211=$209 ? -1 : $210;
      var $212=$21;
      var $213=$22;
      var $214=$23;
      var $215=$result_i2;
      var $216=$24;
      var $217=$25;
      HEAP32[(($21)>>2)]=$211;
      HEAP32[(($22)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($23)>>2)]=258;
      var $218=HEAP32[(($21)>>2)];
      var $219=HEAP32[(($22)>>2)];
      var $220=HEAP32[(($23)>>2)];
      var $221=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($218, $219, $220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $222
      HEAP32[(($result_i2)>>2)]=$221;
      var $223=HEAP32[(($result_i2)>>2)];
      var $224=(($223)|0)==0;
      if ($224) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $225
      var $226=___cxa_allocate_exception(4);
      var $227=$226;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($227);
      (function() { try { __THREW__ = false; return ___cxa_throw($226, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $228
      var $229=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $230=$229.f0;
      HEAP32[(($24)>>2)]=$230;
      var $231=$229.f1;
      HEAP32[(($25)>>2)]=$231;
      var $232=HEAP32[(($25)>>2)];
      var $233=(($232)|0) < 0;
      if ($233) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $234
      var $235=HEAP32[(($24)>>2)];
      ___cxa_call_unexpected($235);
      throw "Reached an unreachable!"
    case 21: // $236
      var $237=HEAP32[(($24)>>2)];
      var $238=HEAP32[(($24)>>2)];
      var $239=HEAP32[(($25)>>2)];
      var $240=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $238, tempValue);
      var $241=($240.f1 = $239, $240);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $242
      throw "Reached an unreachable!"
    case 23: // $_ZnajPKci_exit
      var $243=HEAP32[(($result_i2)>>2)];
      var $244=$21;
      var $245=$22;
      var $246=$23;
      var $247=$result_i2;
      var $248=$24;
      var $249=$25;
      var $250=$243;
      var $251=$gfx;
      var $252=(($251+60)|0);
      var $253=(($252)|0);
      var $254=HEAPU16[(($253)>>1)];
      var $255=(($254)&65535);
      var $256=__ZN13resource_pool9add_arrayIjEEPT_S2_i($202, $250, $255);
      $buffer=$256;
      var $257=$buffer;
      var $258=$257;
      var $259=$gfx;
      var $260=(($259+60)|0);
      var $261=(($260+304)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$262;
      var $264=$gfx;
      var $265=(($264+60)|0);
      var $266=(($265)|0);
      var $267=HEAPU16[(($266)>>1)];
      var $268=(($267)&65535);
      var $269=((($268<<2))|0);
      assert($269 % 1 === 0, 'memcpy given ' + $269 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($258, $263, $269, 1);
      var $270=$buffer;
      var $271=$gfx;
      var $272=(($271+60)|0);
      var $273=(($272+304)|0);
      HEAP32[(($273)>>2)]=$270;
      __label__ = 24; break;
    case 24: // $274
      __label__ = 25; break;
    case 25: // $275
      var $276=$gfx;
      var $277=(($276+60)|0);
      var $278=(($277+308)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=(($279)|0)!=0;
      if ($280) { __label__ = 26; break; } else { __label__ = 37; break; }
    case 26: // $281
      var $282=$gfx;
      var $283=(($282+60)|0);
      var $284=(($283+2)|0);
      var $285=HEAPU16[(($284)>>1)];
      var $286=(($285)&65535);
      var $287=(($286)>>>0) < 32;
      if ($287) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $288
      var $289=$gfx;
      var $290=(($289+60)|0);
      var $291=(($290+172)|0);
      var $292=(($291)|0);
      var $293=$292;
      var $294=$gfx;
      var $295=(($294+60)|0);
      var $296=(($295+308)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$297;
      var $299=$gfx;
      var $300=(($299+60)|0);
      var $301=(($300+2)|0);
      var $302=HEAPU16[(($301)>>1)];
      var $303=(($302)&65535);
      var $304=((($303<<2))|0);
      assert($304 % 1 === 0, 'memcpy given ' + $304 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($293, $298, $304, 1);
      var $305=$gfx;
      var $306=(($305+60)|0);
      var $307=(($306+308)|0);
      HEAP32[(($307)>>2)]=0;
      __label__ = 36; break;
    case 28: // $308
      var $309=$36;
      var $310=__ZN15running_machine7respoolEv($309);
      var $311=$gfx;
      var $312=(($311+60)|0);
      var $313=(($312+2)|0);
      var $314=HEAPU16[(($313)>>1)];
      var $315=(($314)&65535);
      var $316=_llvm_umul_with_overflow_i32($315, 4);
      var $317=$316.f1;
      var $318=$316.f0;
      var $319=$317 ? -1 : $318;
      var $320=$16;
      var $321=$17;
      var $322=$18;
      var $323=$result_i3;
      var $324=$19;
      var $325=$20;
      HEAP32[(($16)>>2)]=$319;
      HEAP32[(($17)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($18)>>2)]=273;
      var $326=HEAP32[(($16)>>2)];
      var $327=HEAP32[(($17)>>2)];
      var $328=HEAP32[(($18)>>2)];
      var $329=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($326, $327, $328) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 31; break; };
    case 29: // $330
      HEAP32[(($result_i3)>>2)]=$329;
      var $331=HEAP32[(($result_i3)>>2)];
      var $332=(($331)|0)==0;
      if ($332) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $333
      var $334=___cxa_allocate_exception(4);
      var $335=$334;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($335);
      (function() { try { __THREW__ = false; return ___cxa_throw($334, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 31; break; }
    case 31: // $336
      var $337=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $338=$337.f0;
      HEAP32[(($19)>>2)]=$338;
      var $339=$337.f1;
      HEAP32[(($20)>>2)]=$339;
      var $340=HEAP32[(($20)>>2)];
      var $341=(($340)|0) < 0;
      if ($341) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $342
      var $343=HEAP32[(($19)>>2)];
      ___cxa_call_unexpected($343);
      throw "Reached an unreachable!"
    case 33: // $344
      var $345=HEAP32[(($19)>>2)];
      var $346=HEAP32[(($19)>>2)];
      var $347=HEAP32[(($20)>>2)];
      var $348=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $346, tempValue);
      var $349=($348.f1 = $347, $348);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 34: // $350
      throw "Reached an unreachable!"
    case 35: // $_ZnajPKci_exit4
      var $351=HEAP32[(($result_i3)>>2)];
      var $352=$16;
      var $353=$17;
      var $354=$18;
      var $355=$result_i3;
      var $356=$19;
      var $357=$20;
      var $358=$351;
      var $359=$gfx;
      var $360=(($359+60)|0);
      var $361=(($360+2)|0);
      var $362=HEAPU16[(($361)>>1)];
      var $363=(($362)&65535);
      var $364=__ZN13resource_pool9add_arrayIjEEPT_S2_i($310, $358, $363);
      $buffer1=$364;
      var $365=$buffer1;
      var $366=$365;
      var $367=$gfx;
      var $368=(($367+60)|0);
      var $369=(($368+308)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=$370;
      var $372=$gfx;
      var $373=(($372+60)|0);
      var $374=(($373+2)|0);
      var $375=HEAPU16[(($374)>>1)];
      var $376=(($375)&65535);
      var $377=((($376<<2))|0);
      assert($377 % 1 === 0, 'memcpy given ' + $377 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($366, $371, $377, 1);
      var $378=$buffer1;
      var $379=$gfx;
      var $380=(($379+60)|0);
      var $381=(($380+308)|0);
      HEAP32[(($381)>>2)]=$378;
      __label__ = 36; break;
    case 36: // $382
      __label__ = 37; break;
    case 37: // $383
      var $384=$gfx;
      var $385=(($384+24)|0);
      var $386=HEAPU16[(($385)>>1)];
      var $387=(($386)&65535);
      var $388=(($387)|0) <= 32;
      if ($388) { __label__ = 38; break; } else { __label__ = 46; break; }
    case 38: // $389
      var $390=$36;
      var $391=__ZN15running_machine7respoolEv($390);
      var $392=$gfx;
      var $393=(($392+16)|0);
      var $394=HEAP32[(($393)>>2)];
      var $395=_llvm_umul_with_overflow_i32($394, 4);
      var $396=$395.f1;
      var $397=$395.f0;
      var $398=$396 ? -1 : $397;
      var $399=$11;
      var $400=$12;
      var $401=$13;
      var $402=$result_i5;
      var $403=$14;
      var $404=$15;
      HEAP32[(($11)>>2)]=$398;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($13)>>2)]=281;
      var $405=HEAP32[(($11)>>2)];
      var $406=HEAP32[(($12)>>2)];
      var $407=HEAP32[(($13)>>2)];
      var $408=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($405, $406, $407) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 41; break; };
    case 39: // $409
      HEAP32[(($result_i5)>>2)]=$408;
      var $410=HEAP32[(($result_i5)>>2)];
      var $411=(($410)|0)==0;
      if ($411) { __label__ = 40; break; } else { __label__ = 45; break; }
    case 40: // $412
      var $413=___cxa_allocate_exception(4);
      var $414=$413;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($414);
      (function() { try { __THREW__ = false; return ___cxa_throw($413, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 41; break; }
    case 41: // $415
      var $416=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $417=$416.f0;
      HEAP32[(($14)>>2)]=$417;
      var $418=$416.f1;
      HEAP32[(($15)>>2)]=$418;
      var $419=HEAP32[(($15)>>2)];
      var $420=(($419)|0) < 0;
      if ($420) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $421
      var $422=HEAP32[(($14)>>2)];
      ___cxa_call_unexpected($422);
      throw "Reached an unreachable!"
    case 43: // $423
      var $424=HEAP32[(($14)>>2)];
      var $425=HEAP32[(($14)>>2)];
      var $426=HEAP32[(($15)>>2)];
      var $427=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $425, tempValue);
      var $428=($427.f1 = $426, $427);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 44: // $429
      throw "Reached an unreachable!"
    case 45: // $_ZnajPKci_exit6
      var $430=HEAP32[(($result_i5)>>2)];
      var $431=$11;
      var $432=$12;
      var $433=$13;
      var $434=$result_i5;
      var $435=$14;
      var $436=$15;
      var $437=$430;
      var $438=$gfx;
      var $439=(($438+16)|0);
      var $440=HEAP32[(($439)>>2)];
      var $441=__ZN13resource_pool9add_arrayIjEEPT_S2_i($391, $437, $440);
      var $442=$gfx;
      var $443=(($442+32)|0);
      HEAP32[(($443)>>2)]=$441;
      __label__ = 46; break;
    case 46: // $444
      var $445=$36;
      var $446=__ZN15running_machine7respoolEv($445);
      var $447=$gfx;
      var $448=(($447+16)|0);
      var $449=HEAP32[(($448)>>2)];
      var $450=$6;
      var $451=$7;
      var $452=$8;
      var $453=$result_i7;
      var $454=$9;
      var $455=$10;
      HEAP32[(($6)>>2)]=$449;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($8)>>2)]=284;
      var $456=HEAP32[(($6)>>2)];
      var $457=HEAP32[(($7)>>2)];
      var $458=HEAP32[(($8)>>2)];
      var $459=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($456, $457, $458) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; };
    case 47: // $460
      HEAP32[(($result_i7)>>2)]=$459;
      var $461=HEAP32[(($result_i7)>>2)];
      var $462=(($461)|0)==0;
      if ($462) { __label__ = 48; break; } else { __label__ = 53; break; }
    case 48: // $463
      var $464=___cxa_allocate_exception(4);
      var $465=$464;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($465);
      (function() { try { __THREW__ = false; return ___cxa_throw($464, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 49; break; }
    case 49: // $466
      var $467=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $468=$467.f0;
      HEAP32[(($9)>>2)]=$468;
      var $469=$467.f1;
      HEAP32[(($10)>>2)]=$469;
      var $470=HEAP32[(($10)>>2)];
      var $471=(($470)|0) < 0;
      if ($471) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $472
      var $473=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($473);
      throw "Reached an unreachable!"
    case 51: // $474
      var $475=HEAP32[(($9)>>2)];
      var $476=HEAP32[(($9)>>2)];
      var $477=HEAP32[(($10)>>2)];
      var $478=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $476, tempValue);
      var $479=($478.f1 = $477, $478);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 52: // $480
      throw "Reached an unreachable!"
    case 53: // $_ZnajPKci_exit8
      var $481=HEAP32[(($result_i7)>>2)];
      var $482=$6;
      var $483=$7;
      var $484=$8;
      var $485=$result_i7;
      var $486=$9;
      var $487=$10;
      var $488=$gfx;
      var $489=(($488+16)|0);
      var $490=HEAP32[(($489)>>2)];
      var $491=__ZN13resource_pool9add_arrayIhEEPT_S2_i($446, $481, $490);
      var $492=$gfx;
      var $493=(($492+52)|0);
      HEAP32[(($493)>>2)]=$491;
      var $494=$gfx;
      var $495=(($494+52)|0);
      var $496=HEAP32[(($495)>>2)];
      var $497=$gfx;
      var $498=(($497+16)|0);
      var $499=HEAP32[(($498)>>2)];
      var $500=(($499)|0);
      _memset($496, 1, $500, 1);
      var $501=$israw;
      var $502=(($501)|0)!=0;
      if ($502) { __label__ = 54; break; } else { __label__ = 60; break; }
    case 54: // $503
      var $504=$37;
      var $505=(($504+308)|0);
      var $506=HEAP32[(($505)>>2)];
      var $507=(($506)|0)!=0;
      if ($507) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $508
      var $509=$37;
      var $510=(($509+308)|0);
      var $511=HEAP32[(($510)>>2)];
      var $512=(($511)|0);
      var $513=HEAP32[(($512)>>2)];
      var $520 = $513;__label__ = 57; break;
    case 56: // $514
      var $515=$37;
      var $516=(($515+172)|0);
      var $517=(($516)|0);
      var $518=HEAP32[(($517)>>2)];
      var $520 = $518;__label__ = 57; break;
    case 57: // $519
      var $520;
      var $521=Math.floor((($520)>>>0)/8);
      var $522=$gfx;
      var $523=(($522+40)|0);
      HEAP32[(($523)>>2)]=$521;
      var $524=$37;
      var $525=(($524+300)|0);
      var $526=HEAPU32[(($525)>>2)];
      var $527=Math.floor((($526)>>>0)/8);
      var $528=$gfx;
      var $529=(($528+44)|0);
      HEAP32[(($529)>>2)]=$527;
      var $530=$gfx;
      var $531=(($530+12)|0);
      var $532=HEAPU8[($531)];
      var $533=(($532)&255);
      var $534=$533 | 2;
      var $535=(($534) & 255);
      HEAP8[($531)]=$535;
      var $536=$planes;
      var $537=(($536)|0) <= 4;
      if ($537) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $538
      var $539=$gfx;
      var $540=(($539+12)|0);
      var $541=HEAPU8[($540)];
      var $542=(($541)&255);
      var $543=$542 | 1;
      var $544=(($543) & 255);
      HEAP8[($540)]=$544;
      __label__ = 59; break;
    case 59: // $545
      var $546=$gfx;
      var $547=(($546+48)|0);
      var $548=HEAP32[(($547)>>2)];
      var $549=$gfx;
      var $550=(($549+36)|0);
      HEAP32[(($550)>>2)]=$548;
      __label__ = 68; break;
    case 60: // $551
      var $552=$gfx;
      var $553=(($552+8)|0);
      var $554=HEAPU16[(($553)>>1)];
      var $555=(($554)&65535);
      var $556=$gfx;
      var $557=(($556+40)|0);
      HEAP32[(($557)>>2)]=$555;
      var $558=$gfx;
      var $559=(($558+40)|0);
      var $560=HEAP32[(($559)>>2)];
      var $561=$gfx;
      var $562=(($561+10)|0);
      var $563=HEAPU16[(($562)>>1)];
      var $564=(($563)&65535);
      var $565=(($560*$564)|0);
      var $566=$gfx;
      var $567=(($566+44)|0);
      HEAP32[(($567)>>2)]=$565;
      var $568=$36;
      var $569=__ZN15running_machine7respoolEv($568);
      var $570=$gfx;
      var $571=(($570+16)|0);
      var $572=HEAP32[(($571)>>2)];
      var $573=$gfx;
      var $574=(($573+44)|0);
      var $575=HEAP32[(($574)>>2)];
      var $576=(($572*$575)|0);
      var $577=$1;
      var $578=$2;
      var $579=$3;
      var $580=$result_i9;
      var $581=$4;
      var $582=$5;
      HEAP32[(($1)>>2)]=$576;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3579)|0);
      HEAP32[(($3)>>2)]=311;
      var $583=HEAP32[(($1)>>2)];
      var $584=HEAP32[(($2)>>2)];
      var $585=HEAP32[(($3)>>2)];
      var $586=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($583, $584, $585) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 63; break; };
    case 61: // $587
      HEAP32[(($result_i9)>>2)]=$586;
      var $588=HEAP32[(($result_i9)>>2)];
      var $589=(($588)|0)==0;
      if ($589) { __label__ = 62; break; } else { __label__ = 67; break; }
    case 62: // $590
      var $591=___cxa_allocate_exception(4);
      var $592=$591;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($592);
      (function() { try { __THREW__ = false; return ___cxa_throw($591, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 63; break; }
    case 63: // $593
      var $594=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $595=$594.f0;
      HEAP32[(($4)>>2)]=$595;
      var $596=$594.f1;
      HEAP32[(($5)>>2)]=$596;
      var $597=HEAP32[(($5)>>2)];
      var $598=(($597)|0) < 0;
      if ($598) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $599
      var $600=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($600);
      throw "Reached an unreachable!"
    case 65: // $601
      var $602=HEAP32[(($4)>>2)];
      var $603=HEAP32[(($4)>>2)];
      var $604=HEAP32[(($5)>>2)];
      var $605=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $603, tempValue);
      var $606=($605.f1 = $604, $605);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $607
      throw "Reached an unreachable!"
    case 67: // $_ZnajPKci_exit10
      var $608=HEAP32[(($result_i9)>>2)];
      var $609=$1;
      var $610=$2;
      var $611=$3;
      var $612=$result_i9;
      var $613=$4;
      var $614=$5;
      var $615=$gfx;
      var $616=(($615+16)|0);
      var $617=HEAP32[(($616)>>2)];
      var $618=$gfx;
      var $619=(($618+44)|0);
      var $620=HEAP32[(($619)>>2)];
      var $621=(($617*$620)|0);
      var $622=__ZN13resource_pool9add_arrayIhEEPT_S2_i($569, $608, $621);
      var $623=$gfx;
      var $624=(($623+36)|0);
      HEAP32[(($624)>>2)]=$622;
      __label__ = 68; break;
    case 68: // $625
      var $626=$gfx;
      STACKTOP = __stackBase__;
      return $626;
    case 69: // $627
      var $628=$41;
      var $629=$41;
      var $630=$42;
      var $631=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $629, tempValue);
      var $632=($631.f1 = $630, $631);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 70: // $633
      var $634=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17gfx_element_allocR15running_machinePK11_gfx_layoutPKhjj["X"]=1;

function __ZNK11gfx_element7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+372)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15running_machine12total_colorsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+668)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+48)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __ZN11gfx_elementC1ER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=$2;
  __ZN11gfx_elementC2ER15running_machine($3, $4);
  ;
  return;
}


function __Z18gfx_element_decodePK11gfx_elementj($gfx, $code) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$gfx;
  $2=$code;
  var $3=$1;
  var $4=$2;
  var $5=$1;
  var $6=(($5+48)|0);
  var $7=HEAP32[(($6)>>2)];
  __ZL10decodecharPK11gfx_elementjPKh($3, $4, $7);
  ;
  return;
}


function __ZL10decodecharPK11gfx_elementjPKh($gfx, $code, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $gl;
      var $israw;
      var $planes;
      var $charincrement;
      var $poffset;
      var $xoffset;
      var $yoffset;
      var $dp;
      var $plane;
      var $x;
      var $y;
      var $planebit;
      var $planeoffs;
      var $yoffs;
      var $planebit1;
      var $planeoffs2;
      var $yoffs3;
      $1=$gfx;
      $2=$code;
      $3=$src;
      var $4=$1;
      var $5=(($4+60)|0);
      $gl=$5;
      var $6=$gl;
      var $7=(($6+12)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==305419896;
      var $11=(($10)&1);
      $israw=$11;
      var $12=$gl;
      var $13=(($12+8)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      $planes=$15;
      var $16=$gl;
      var $17=(($16+300)|0);
      var $18=HEAP32[(($17)>>2)];
      $charincrement=$18;
      var $19=$gl;
      var $20=(($19+12)|0);
      var $21=(($20)|0);
      $poffset=$21;
      var $22=$gl;
      var $23=(($22+304)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $26
      var $27=$gl;
      var $28=(($27+304)|0);
      var $29=HEAP32[(($28)>>2)];
      var $35 = $29;__label__ = 3; break;
    case 2: // $30
      var $31=$gl;
      var $32=(($31+44)|0);
      var $33=(($32)|0);
      var $35 = $33;__label__ = 3; break;
    case 3: // $34
      var $35;
      $xoffset=$35;
      var $36=$gl;
      var $37=(($36+308)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=$gl;
      var $42=(($41+308)|0);
      var $43=HEAP32[(($42)>>2)];
      var $49 = $43;__label__ = 6; break;
    case 5: // $44
      var $45=$gl;
      var $46=(($45+172)|0);
      var $47=(($46)|0);
      var $49 = $47;__label__ = 6; break;
    case 6: // $48
      var $49;
      $yoffset=$49;
      var $50=$1;
      var $51=(($50+36)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$2;
      var $54=$1;
      var $55=(($54+44)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($53*$56)|0);
      var $58=(($52+$57)|0);
      $dp=$58;
      var $59=$israw;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 41; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=$dp;
      var $63=$1;
      var $64=(($63+44)|0);
      var $65=HEAP32[(($64)>>2)];
      _memset($62, 0, $65, 1);
      var $66=$1;
      var $67=(($66+12)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=$69 & 1;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 8; break; } else { __label__ = 25; break; }
    case 8: // $72
      $plane=0;
      __label__ = 9; break;
    case 9: // $73
      var $74=$plane;
      var $75=$planes;
      var $76=(($74)|0) < (($75)|0);
      if ($76) { __label__ = 10; break; } else { __label__ = 24; break; }
    case 10: // $77
      var $78=$planes;
      var $79=(($78-1)|0);
      var $80=$plane;
      var $81=(($79-$80)|0);
      var $82=1 << $81;
      $planebit=$82;
      var $83=$2;
      var $84=$charincrement;
      var $85=(($83*$84)|0);
      var $86=$plane;
      var $87=$poffset;
      var $88=(($87+($86<<2))|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($85+$89)|0);
      $planeoffs=$90;
      $y=0;
      __label__ = 11; break;
    case 11: // $91
      var $92=$y;
      var $93=$1;
      var $94=(($93+10)|0);
      var $95=HEAPU16[(($94)>>1)];
      var $96=(($95)&65535);
      var $97=(($92)|0) < (($96)|0);
      if ($97) { __label__ = 12; break; } else { __label__ = 22; break; }
    case 12: // $98
      var $99=$planeoffs;
      var $100=$y;
      var $101=$yoffset;
      var $102=(($101+($100<<2))|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($99+$103)|0);
      $yoffs=$104;
      var $105=$1;
      var $106=(($105+36)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$2;
      var $109=$1;
      var $110=(($109+44)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($108*$111)|0);
      var $113=(($107+$112)|0);
      var $114=$y;
      var $115=$1;
      var $116=(($115+40)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($114*$117)|0);
      var $119=(($113+$118)|0);
      $dp=$119;
      $x=0;
      __label__ = 13; break;
    case 13: // $120
      var $121=$x;
      var $122=$1;
      var $123=(($122+8)|0);
      var $124=HEAPU16[(($123)>>1)];
      var $125=(($124)&65535);
      var $126=(($121)|0) < (($125)|0);
      if ($126) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $127
      var $128=$3;
      var $129=$yoffs;
      var $130=$x;
      var $131=(($130)|0);
      var $132=$xoffset;
      var $133=(($132+($131<<2))|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($129+$134)|0);
      var $136=__ZL7readbitPKhj($128, $135);
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $138
      var $139=$planebit;
      var $140=$x;
      var $141=(($140)|0);
      var $142=$dp;
      var $143=(($142+$141)|0);
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=$145 | $139;
      var $147=(($146) & 255);
      HEAP8[($143)]=$147;
      __label__ = 16; break;
    case 16: // $148
      var $149=$3;
      var $150=$yoffs;
      var $151=$x;
      var $152=(($151+1)|0);
      var $153=$xoffset;
      var $154=(($153+($152<<2))|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($150+$155)|0);
      var $157=__ZL7readbitPKhj($149, $156);
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $159
      var $160=$planebit;
      var $161=$x;
      var $162=(($161+1)|0);
      var $163=$dp;
      var $164=(($163+$162)|0);
      var $165=HEAPU8[($164)];
      var $166=(($165)&255);
      var $167=$166 | $160;
      var $168=(($167) & 255);
      HEAP8[($164)]=$168;
      __label__ = 18; break;
    case 18: // $169
      __label__ = 19; break;
    case 19: // $170
      var $171=$x;
      var $172=(($171+2)|0);
      $x=$172;
      __label__ = 13; break;
    case 20: // $173
      __label__ = 21; break;
    case 21: // $174
      var $175=$y;
      var $176=(($175+1)|0);
      $y=$176;
      __label__ = 11; break;
    case 22: // $177
      __label__ = 23; break;
    case 23: // $178
      var $179=$plane;
      var $180=(($179+1)|0);
      $plane=$180;
      __label__ = 9; break;
    case 24: // $181
      __label__ = 40; break;
    case 25: // $182
      $plane=0;
      __label__ = 26; break;
    case 26: // $183
      var $184=$plane;
      var $185=$planes;
      var $186=(($184)|0) < (($185)|0);
      if ($186) { __label__ = 27; break; } else { __label__ = 39; break; }
    case 27: // $187
      var $188=$planes;
      var $189=(($188-1)|0);
      var $190=$plane;
      var $191=(($189-$190)|0);
      var $192=1 << $191;
      $planebit1=$192;
      var $193=$2;
      var $194=$charincrement;
      var $195=(($193*$194)|0);
      var $196=$plane;
      var $197=$poffset;
      var $198=(($197+($196<<2))|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=(($195+$199)|0);
      $planeoffs2=$200;
      $y=0;
      __label__ = 28; break;
    case 28: // $201
      var $202=$y;
      var $203=$1;
      var $204=(($203+10)|0);
      var $205=HEAPU16[(($204)>>1)];
      var $206=(($205)&65535);
      var $207=(($202)|0) < (($206)|0);
      if ($207) { __label__ = 29; break; } else { __label__ = 37; break; }
    case 29: // $208
      var $209=$planeoffs2;
      var $210=$y;
      var $211=$yoffset;
      var $212=(($211+($210<<2))|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($209+$213)|0);
      $yoffs3=$214;
      var $215=$1;
      var $216=(($215+36)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=$2;
      var $219=$1;
      var $220=(($219+44)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($218*$221)|0);
      var $223=(($217+$222)|0);
      var $224=$y;
      var $225=$1;
      var $226=(($225+40)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($224*$227)|0);
      var $229=(($223+$228)|0);
      $dp=$229;
      $x=0;
      __label__ = 30; break;
    case 30: // $230
      var $231=$x;
      var $232=$1;
      var $233=(($232+8)|0);
      var $234=HEAPU16[(($233)>>1)];
      var $235=(($234)&65535);
      var $236=(($231)|0) < (($235)|0);
      if ($236) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 31: // $237
      var $238=$3;
      var $239=$yoffs3;
      var $240=$x;
      var $241=$xoffset;
      var $242=(($241+($240<<2))|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($239+$243)|0);
      var $245=__ZL7readbitPKhj($238, $244);
      var $246=(($245)|0)!=0;
      if ($246) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $247
      var $248=$planebit1;
      var $249=$x;
      var $250=$dp;
      var $251=(($250+$249)|0);
      var $252=HEAPU8[($251)];
      var $253=(($252)&255);
      var $254=$253 | $248;
      var $255=(($254) & 255);
      HEAP8[($251)]=$255;
      __label__ = 33; break;
    case 33: // $256
      __label__ = 34; break;
    case 34: // $257
      var $258=$x;
      var $259=(($258+1)|0);
      $x=$259;
      __label__ = 30; break;
    case 35: // $260
      __label__ = 36; break;
    case 36: // $261
      var $262=$y;
      var $263=(($262+1)|0);
      $y=$263;
      __label__ = 28; break;
    case 37: // $264
      __label__ = 38; break;
    case 38: // $265
      var $266=$plane;
      var $267=(($266+1)|0);
      $plane=$267;
      __label__ = 26; break;
    case 39: // $268
      __label__ = 40; break;
    case 40: // $269
      __label__ = 41; break;
    case 41: // $270
      var $271=$1;
      var $272=$2;
      __ZL13calc_penusagePK11gfx_elementj($271, $272);
      var $273=$2;
      var $274=$1;
      var $275=(($274+52)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=(($276+$273)|0);
      HEAP8[($277)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10decodecharPK11gfx_elementjPKh["X"]=1;

function __Z16gfx_element_freeP11gfx_element($gfx) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$gfx;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 3; break;
    case 2: // $5
      var $6=$1;
      var $7=__ZNK11gfx_element7machineEv($6);
      var $8=__ZN15running_machine7respoolEv($7);
      var $9=$1;
      var $10=(($9+60)|0);
      var $11=(($10+308)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      __ZN13resource_pool6removeEPKv($8, $13);
      var $14=$1;
      var $15=__ZNK11gfx_element7machineEv($14);
      var $16=__ZN15running_machine7respoolEv($15);
      var $17=$1;
      var $18=(($17+60)|0);
      var $19=(($18+304)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      __ZN13resource_pool6removeEPKv($16, $21);
      var $22=$1;
      var $23=__ZNK11gfx_element7machineEv($22);
      var $24=__ZN15running_machine7respoolEv($23);
      var $25=$1;
      var $26=(($25+32)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      __ZN13resource_pool6removeEPv($24, $28);
      var $29=$1;
      var $30=__ZNK11gfx_element7machineEv($29);
      var $31=__ZN15running_machine7respoolEv($30);
      var $32=$1;
      var $33=(($32+52)|0);
      var $34=HEAP32[(($33)>>2)];
      __ZN13resource_pool6removeEPv($31, $34);
      var $35=$1;
      var $36=__ZNK11gfx_element7machineEv($35);
      var $37=__ZN15running_machine7respoolEv($36);
      var $38=$1;
      var $39=(($38+36)|0);
      var $40=HEAP32[(($39)>>2)];
      __ZN13resource_pool6removeEPv($37, $40);
      var $41=$1;
      var $42=__ZNK11gfx_element7machineEv($41);
      var $43=__ZN15running_machine7respoolEv($42);
      var $44=$1;
      var $45=$44;
      __ZN13resource_pool6removeEPv($43, $45);
      __label__ = 3; break;
    case 3: // $46
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16gfx_element_freeP11gfx_element["X"]=1;

function __ZN13resource_pool6removeEPKv($this, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$ptr;
  var $3=$1;
  var $4=$2;
  __ZN13resource_pool6removeEPv($3, $4);
  ;
  return;
}


function __ZN13resource_pool10add_objectI11gfx_elementEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11gfx_elementEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11gfx_elementEEPT_S3_["X"]=1;

function __Z10copybitmapP8bitmap_tS0_iiiiPK10_rectangle($dest, $src, $flipx, $flipy, $destx, $desty, $cliprect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $priority;
      var $srcdata;
      var $numblocks;
      var $leftovers;
      var $destendx;
      var $destendy;
      var $srcx;
      var $srcy;
      var $curx;
      var $cury;
      var $dx;
      var $dy;
      var $priptr;
      var $destptr;
      var $srcptr;
      var $priptr1;
      var $destptr2;
      var $srcptr3;
      var $srcdata4;
      var $numblocks5;
      var $leftovers6;
      var $destendx7;
      var $destendy8;
      var $srcx9;
      var $srcy10;
      var $curx11;
      var $cury12;
      var $dx13;
      var $dy14;
      var $priptr15;
      var $destptr16;
      var $srcptr17;
      var $priptr18;
      var $destptr19;
      var $srcptr20;
      var $srcdata21;
      var $numblocks22;
      var $leftovers23;
      var $destendx24;
      var $destendy25;
      var $srcx26;
      var $srcy27;
      var $curx28;
      var $cury29;
      var $dx30;
      var $dy31;
      var $priptr32;
      var $destptr33;
      var $srcptr34;
      var $priptr35;
      var $destptr36;
      var $srcptr37;
      $1=$dest;
      $2=$src;
      $3=$flipx;
      $4=$flipy;
      $5=$destx;
      $6=$desty;
      $7=$cliprect;
      $priority=0;
      __label__ = 1; break;
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      __label__ = 4; break;
    case 4: // $11
      __label__ = 5; break;
    case 5: // $12
      __label__ = 6; break;
    case 6: // $13
      __label__ = 7; break;
    case 7: // $14
      __label__ = 8; break;
    case 8: // $15
      var $16=$1;
      var $17=$16;
      var $18=(($17+24)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==8;
      if ($20) { __label__ = 9; break; } else { __label__ = 106; break; }
    case 9: // $21
      __label__ = 10; break;
    case 10: // $22
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 263);
      __label__ = 11; break;
    case 11: // $23
      __label__ = 12; break;
    case 12: // $24
      __label__ = 13; break;
    case 13: // $25
      __label__ = 14; break;
    case 14: // $26
      __label__ = 15; break;
    case 15: // $27
      __label__ = 16; break;
    case 16: // $28
      __label__ = 17; break;
    case 17: // $29
      __label__ = 18; break;
    case 18: // $30
      __label__ = 19; break;
    case 19: // $31
      __label__ = 20; break;
    case 20: // $32
      __label__ = 21; break;
    case 21: // $33
      __label__ = 22; break;
    case 22: // $34
      __label__ = 23; break;
    case 23: // $35
      __label__ = 24; break;
    case 24: // $36
      __label__ = 25; break;
    case 25: // $37
      var $38=$7;
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $40
      var $41=$1;
      var $42=$41;
      var $43=(($42+32)|0);
      $7=$43;
      __label__ = 27; break;
    case 27: // $44
      var $45=$7;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$7;
      var $49=(($48+4)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($47)|0) > (($50)|0);
      if ($51) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $52
      var $53=$7;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$7;
      var $57=(($56+12)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($55)|0) > (($58)|0);
      if ($59) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $60
      __label__ = 104; break;
    case 30: // $61
      $dx=1;
      var $62=$2;
      var $63=$62;
      var $64=(($63+8)|0);
      var $65=HEAP32[(($64)>>2)];
      $dy=$65;
      var $66=$5;
      var $67=$2;
      var $68=$67;
      var $69=(($68+12)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($66+$70)|0);
      var $72=(($71-1)|0);
      $destendx=$72;
      var $73=$5;
      var $74=$7;
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($73)|0) > (($76)|0);
      if ($77) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $78
      var $79=$destendx;
      var $80=$7;
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($79)|0) < (($82)|0);
      if ($83) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $84
      __label__ = 104; break;
    case 33: // $85
      $srcx=0;
      var $86=$5;
      var $87=$7;
      var $88=(($87)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($86)|0) < (($89)|0);
      if ($90) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $91
      var $92=$7;
      var $93=(($92)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$5;
      var $96=(($94-$95)|0);
      $srcx=$96;
      var $97=$7;
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      $5=$99;
      __label__ = 35; break;
    case 35: // $100
      var $101=$destendx;
      var $102=$7;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($101)|0) > (($104)|0);
      if ($105) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $106
      var $107=$7;
      var $108=(($107+4)|0);
      var $109=HEAP32[(($108)>>2)];
      $destendx=$109;
      __label__ = 37; break;
    case 37: // $110
      var $111=$6;
      var $112=$2;
      var $113=$112;
      var $114=(($113+16)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($111+$115)|0);
      var $117=(($116-1)|0);
      $destendy=$117;
      var $118=$6;
      var $119=$7;
      var $120=(($119+12)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($118)|0) > (($121)|0);
      if ($122) { __label__ = 39; break; } else { __label__ = 38; break; }
    case 38: // $123
      var $124=$destendy;
      var $125=$7;
      var $126=(($125+8)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($124)|0) < (($127)|0);
      if ($128) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $129
      __label__ = 104; break;
    case 40: // $130
      $srcy=0;
      var $131=$6;
      var $132=$7;
      var $133=(($132+8)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($131)|0) < (($134)|0);
      if ($135) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $136
      var $137=$7;
      var $138=(($137+8)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=$6;
      var $141=(($139-$140)|0);
      $srcy=$141;
      var $142=$7;
      var $143=(($142+8)|0);
      var $144=HEAP32[(($143)>>2)];
      $6=$144;
      __label__ = 42; break;
    case 42: // $145
      var $146=$destendy;
      var $147=$7;
      var $148=(($147+12)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($146)|0) > (($149)|0);
      if ($150) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $151
      var $152=$7;
      var $153=(($152+12)|0);
      var $154=HEAP32[(($153)>>2)];
      $destendy=$154;
      __label__ = 44; break;
    case 44: // $155
      var $156=$3;
      var $157=(($156)|0)!=0;
      if ($157) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $158
      var $159=$2;
      var $160=$159;
      var $161=(($160+12)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162-1)|0);
      var $164=$srcx;
      var $165=(($163-$164)|0);
      $srcx=$165;
      var $166=$dx;
      var $167=(((-$166))|0);
      $dx=$167;
      __label__ = 46; break;
    case 46: // $168
      var $169=$4;
      var $170=(($169)|0)!=0;
      if ($170) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $171
      var $172=$2;
      var $173=$172;
      var $174=(($173+16)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=(($175-1)|0);
      var $177=$srcy;
      var $178=(($176-$177)|0);
      $srcy=$178;
      var $179=$dy;
      var $180=(((-$179))|0);
      $dy=$180;
      __label__ = 48; break;
    case 48: // $181
      var $182=$destendx;
      var $183=(($182+1)|0);
      var $184=$5;
      var $185=(($183-$184)|0);
      var $186=(((($185)|0)/4)|0);
      $numblocks=$186;
      var $187=$destendx;
      var $188=(($187+1)|0);
      var $189=$5;
      var $190=(($188-$189)|0);
      var $191=$numblocks;
      var $192=((($191<<2))|0);
      var $193=(($190-$192)|0);
      $leftovers=$193;
      var $194=$2;
      var $195=$194;
      var $196=(($195+4)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=$srcy;
      var $199=$2;
      var $200=$199;
      var $201=(($200+8)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($198*$202)|0);
      var $204=(($197+$203)|0);
      var $205=$srcx;
      var $206=(($204+$205)|0);
      $srcdata=$206;
      var $207=$3;
      var $208=(($207)|0)!=0;
      if ($208) { __label__ = 76; break; } else { __label__ = 49; break; }
    case 49: // $209
      var $210=$6;
      $cury=$210;
      __label__ = 50; break;
    case 50: // $211
      var $212=$cury;
      var $213=$destendy;
      var $214=(($212)|0) <= (($213)|0);
      if ($214) { __label__ = 51; break; } else { __label__ = 75; break; }
    case 51: // $215
      $priptr=0;
      var $216=$1;
      var $217=$216;
      var $218=(($217+4)|0);
      var $219=HEAP32[(($218)>>2)];
      var $220=$cury;
      var $221=$1;
      var $222=$221;
      var $223=(($222+8)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($220*$224)|0);
      var $226=(($219+$225)|0);
      var $227=$5;
      var $228=(($226+$227)|0);
      $destptr=$228;
      var $229=$srcdata;
      $srcptr=$229;
      var $230=$dy;
      var $231=$srcdata;
      var $232=(($231+$230)|0);
      $srcdata=$232;
      $curx=0;
      __label__ = 52; break;
    case 52: // $233
      var $234=$curx;
      var $235=$numblocks;
      var $236=(($234)>>>0) < (($235)>>>0);
      if ($236) { __label__ = 53; break; } else { __label__ = 65; break; }
    case 53: // $237
      __label__ = 54; break;
    case 54: // $238
      var $239=$srcptr;
      var $240=(($239)|0);
      var $241=HEAP8[($240)];
      var $242=$destptr;
      var $243=(($242)|0);
      HEAP8[($243)]=$241;
      __label__ = 55; break;
    case 55: // $244
      __label__ = 56; break;
    case 56: // $245
      var $246=$srcptr;
      var $247=(($246+1)|0);
      var $248=HEAP8[($247)];
      var $249=$destptr;
      var $250=(($249+1)|0);
      HEAP8[($250)]=$248;
      __label__ = 57; break;
    case 57: // $251
      __label__ = 58; break;
    case 58: // $252
      var $253=$srcptr;
      var $254=(($253+2)|0);
      var $255=HEAP8[($254)];
      var $256=$destptr;
      var $257=(($256+2)|0);
      HEAP8[($257)]=$255;
      __label__ = 59; break;
    case 59: // $258
      __label__ = 60; break;
    case 60: // $259
      var $260=$srcptr;
      var $261=(($260+3)|0);
      var $262=HEAP8[($261)];
      var $263=$destptr;
      var $264=(($263+3)|0);
      HEAP8[($264)]=$262;
      __label__ = 61; break;
    case 61: // $265
      var $266=$srcptr;
      var $267=(($266+4)|0);
      $srcptr=$267;
      var $268=$destptr;
      var $269=(($268+4)|0);
      $destptr=$269;
      __label__ = 62; break;
    case 62: // $270
      __label__ = 63; break;
    case 63: // $271
      __label__ = 64; break;
    case 64: // $272
      var $273=$curx;
      var $274=(($273+1)|0);
      $curx=$274;
      __label__ = 52; break;
    case 65: // $275
      $curx=0;
      __label__ = 66; break;
    case 66: // $276
      var $277=$curx;
      var $278=$leftovers;
      var $279=(($277)>>>0) < (($278)>>>0);
      if ($279) { __label__ = 67; break; } else { __label__ = 73; break; }
    case 67: // $280
      __label__ = 68; break;
    case 68: // $281
      var $282=$srcptr;
      var $283=(($282)|0);
      var $284=HEAP8[($283)];
      var $285=$destptr;
      var $286=(($285)|0);
      HEAP8[($286)]=$284;
      __label__ = 69; break;
    case 69: // $287
      var $288=$srcptr;
      var $289=(($288+1)|0);
      $srcptr=$289;
      var $290=$destptr;
      var $291=(($290+1)|0);
      $destptr=$291;
      __label__ = 70; break;
    case 70: // $292
      __label__ = 71; break;
    case 71: // $293
      __label__ = 72; break;
    case 72: // $294
      var $295=$curx;
      var $296=(($295+1)|0);
      $curx=$296;
      __label__ = 66; break;
    case 73: // $297
      __label__ = 74; break;
    case 74: // $298
      var $299=$cury;
      var $300=(($299+1)|0);
      $cury=$300;
      __label__ = 50; break;
    case 75: // $301
      __label__ = 103; break;
    case 76: // $302
      var $303=$6;
      $cury=$303;
      __label__ = 77; break;
    case 77: // $304
      var $305=$cury;
      var $306=$destendy;
      var $307=(($305)|0) <= (($306)|0);
      if ($307) { __label__ = 78; break; } else { __label__ = 102; break; }
    case 78: // $308
      $priptr1=0;
      var $309=$1;
      var $310=$309;
      var $311=(($310+4)|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=$cury;
      var $314=$1;
      var $315=$314;
      var $316=(($315+8)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=(($313*$317)|0);
      var $319=(($312+$318)|0);
      var $320=$5;
      var $321=(($319+$320)|0);
      $destptr2=$321;
      var $322=$srcdata;
      $srcptr3=$322;
      var $323=$dy;
      var $324=$srcdata;
      var $325=(($324+$323)|0);
      $srcdata=$325;
      $curx=0;
      __label__ = 79; break;
    case 79: // $326
      var $327=$curx;
      var $328=$numblocks;
      var $329=(($327)>>>0) < (($328)>>>0);
      if ($329) { __label__ = 80; break; } else { __label__ = 92; break; }
    case 80: // $330
      __label__ = 81; break;
    case 81: // $331
      var $332=$srcptr3;
      var $333=(($332)|0);
      var $334=HEAP8[($333)];
      var $335=$destptr2;
      var $336=(($335)|0);
      HEAP8[($336)]=$334;
      __label__ = 82; break;
    case 82: // $337
      __label__ = 83; break;
    case 83: // $338
      var $339=$srcptr3;
      var $340=(($339-1)|0);
      var $341=HEAP8[($340)];
      var $342=$destptr2;
      var $343=(($342+1)|0);
      HEAP8[($343)]=$341;
      __label__ = 84; break;
    case 84: // $344
      __label__ = 85; break;
    case 85: // $345
      var $346=$srcptr3;
      var $347=(($346-2)|0);
      var $348=HEAP8[($347)];
      var $349=$destptr2;
      var $350=(($349+2)|0);
      HEAP8[($350)]=$348;
      __label__ = 86; break;
    case 86: // $351
      __label__ = 87; break;
    case 87: // $352
      var $353=$srcptr3;
      var $354=(($353-3)|0);
      var $355=HEAP8[($354)];
      var $356=$destptr2;
      var $357=(($356+3)|0);
      HEAP8[($357)]=$355;
      __label__ = 88; break;
    case 88: // $358
      var $359=$srcptr3;
      var $360=(($359-4)|0);
      $srcptr3=$360;
      var $361=$destptr2;
      var $362=(($361+4)|0);
      $destptr2=$362;
      __label__ = 89; break;
    case 89: // $363
      __label__ = 90; break;
    case 90: // $364
      __label__ = 91; break;
    case 91: // $365
      var $366=$curx;
      var $367=(($366+1)|0);
      $curx=$367;
      __label__ = 79; break;
    case 92: // $368
      $curx=0;
      __label__ = 93; break;
    case 93: // $369
      var $370=$curx;
      var $371=$leftovers;
      var $372=(($370)>>>0) < (($371)>>>0);
      if ($372) { __label__ = 94; break; } else { __label__ = 100; break; }
    case 94: // $373
      __label__ = 95; break;
    case 95: // $374
      var $375=$srcptr3;
      var $376=(($375)|0);
      var $377=HEAP8[($376)];
      var $378=$destptr2;
      var $379=(($378)|0);
      HEAP8[($379)]=$377;
      __label__ = 96; break;
    case 96: // $380
      var $381=$srcptr3;
      var $382=(($381-1)|0);
      $srcptr3=$382;
      var $383=$destptr2;
      var $384=(($383+1)|0);
      $destptr2=$384;
      __label__ = 97; break;
    case 97: // $385
      __label__ = 98; break;
    case 98: // $386
      __label__ = 99; break;
    case 99: // $387
      var $388=$curx;
      var $389=(($388+1)|0);
      $curx=$389;
      __label__ = 93; break;
    case 100: // $390
      __label__ = 101; break;
    case 101: // $391
      var $392=$cury;
      var $393=(($392+1)|0);
      $cury=$393;
      __label__ = 77; break;
    case 102: // $394
      __label__ = 103; break;
    case 103: // $395
      __label__ = 104; break;
    case 104: // $396
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 105; break;
    case 105: // $397
      __label__ = 302; break;
    case 106: // $398
      var $399=$1;
      var $400=$399;
      var $401=(($400+24)|0);
      var $402=HEAP32[(($401)>>2)];
      var $403=(($402)|0)==16;
      if ($403) { __label__ = 107; break; } else { __label__ = 204; break; }
    case 107: // $404
      __label__ = 108; break;
    case 108: // $405
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 263);
      __label__ = 109; break;
    case 109: // $406
      __label__ = 110; break;
    case 110: // $407
      __label__ = 111; break;
    case 111: // $408
      __label__ = 112; break;
    case 112: // $409
      __label__ = 113; break;
    case 113: // $410
      __label__ = 114; break;
    case 114: // $411
      __label__ = 115; break;
    case 115: // $412
      __label__ = 116; break;
    case 116: // $413
      __label__ = 117; break;
    case 117: // $414
      __label__ = 118; break;
    case 118: // $415
      __label__ = 119; break;
    case 119: // $416
      __label__ = 120; break;
    case 120: // $417
      __label__ = 121; break;
    case 121: // $418
      __label__ = 122; break;
    case 122: // $419
      __label__ = 123; break;
    case 123: // $420
      var $421=$7;
      var $422=(($421)|0)==0;
      if ($422) { __label__ = 124; break; } else { __label__ = 125; break; }
    case 124: // $423
      var $424=$1;
      var $425=$424;
      var $426=(($425+32)|0);
      $7=$426;
      __label__ = 125; break;
    case 125: // $427
      var $428=$7;
      var $429=(($428)|0);
      var $430=HEAP32[(($429)>>2)];
      var $431=$7;
      var $432=(($431+4)|0);
      var $433=HEAP32[(($432)>>2)];
      var $434=(($430)|0) > (($433)|0);
      if ($434) { __label__ = 127; break; } else { __label__ = 126; break; }
    case 126: // $435
      var $436=$7;
      var $437=(($436+8)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=$7;
      var $440=(($439+12)|0);
      var $441=HEAP32[(($440)>>2)];
      var $442=(($438)|0) > (($441)|0);
      if ($442) { __label__ = 127; break; } else { __label__ = 128; break; }
    case 127: // $443
      __label__ = 202; break;
    case 128: // $444
      $dx13=1;
      var $445=$2;
      var $446=$445;
      var $447=(($446+8)|0);
      var $448=HEAP32[(($447)>>2)];
      $dy14=$448;
      var $449=$5;
      var $450=$2;
      var $451=$450;
      var $452=(($451+12)|0);
      var $453=HEAP32[(($452)>>2)];
      var $454=(($449+$453)|0);
      var $455=(($454-1)|0);
      $destendx7=$455;
      var $456=$5;
      var $457=$7;
      var $458=(($457+4)|0);
      var $459=HEAP32[(($458)>>2)];
      var $460=(($456)|0) > (($459)|0);
      if ($460) { __label__ = 130; break; } else { __label__ = 129; break; }
    case 129: // $461
      var $462=$destendx7;
      var $463=$7;
      var $464=(($463)|0);
      var $465=HEAP32[(($464)>>2)];
      var $466=(($462)|0) < (($465)|0);
      if ($466) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $467
      __label__ = 202; break;
    case 131: // $468
      $srcx9=0;
      var $469=$5;
      var $470=$7;
      var $471=(($470)|0);
      var $472=HEAP32[(($471)>>2)];
      var $473=(($469)|0) < (($472)|0);
      if ($473) { __label__ = 132; break; } else { __label__ = 133; break; }
    case 132: // $474
      var $475=$7;
      var $476=(($475)|0);
      var $477=HEAP32[(($476)>>2)];
      var $478=$5;
      var $479=(($477-$478)|0);
      $srcx9=$479;
      var $480=$7;
      var $481=(($480)|0);
      var $482=HEAP32[(($481)>>2)];
      $5=$482;
      __label__ = 133; break;
    case 133: // $483
      var $484=$destendx7;
      var $485=$7;
      var $486=(($485+4)|0);
      var $487=HEAP32[(($486)>>2)];
      var $488=(($484)|0) > (($487)|0);
      if ($488) { __label__ = 134; break; } else { __label__ = 135; break; }
    case 134: // $489
      var $490=$7;
      var $491=(($490+4)|0);
      var $492=HEAP32[(($491)>>2)];
      $destendx7=$492;
      __label__ = 135; break;
    case 135: // $493
      var $494=$6;
      var $495=$2;
      var $496=$495;
      var $497=(($496+16)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=(($494+$498)|0);
      var $500=(($499-1)|0);
      $destendy8=$500;
      var $501=$6;
      var $502=$7;
      var $503=(($502+12)|0);
      var $504=HEAP32[(($503)>>2)];
      var $505=(($501)|0) > (($504)|0);
      if ($505) { __label__ = 137; break; } else { __label__ = 136; break; }
    case 136: // $506
      var $507=$destendy8;
      var $508=$7;
      var $509=(($508+8)|0);
      var $510=HEAP32[(($509)>>2)];
      var $511=(($507)|0) < (($510)|0);
      if ($511) { __label__ = 137; break; } else { __label__ = 138; break; }
    case 137: // $512
      __label__ = 202; break;
    case 138: // $513
      $srcy10=0;
      var $514=$6;
      var $515=$7;
      var $516=(($515+8)|0);
      var $517=HEAP32[(($516)>>2)];
      var $518=(($514)|0) < (($517)|0);
      if ($518) { __label__ = 139; break; } else { __label__ = 140; break; }
    case 139: // $519
      var $520=$7;
      var $521=(($520+8)|0);
      var $522=HEAP32[(($521)>>2)];
      var $523=$6;
      var $524=(($522-$523)|0);
      $srcy10=$524;
      var $525=$7;
      var $526=(($525+8)|0);
      var $527=HEAP32[(($526)>>2)];
      $6=$527;
      __label__ = 140; break;
    case 140: // $528
      var $529=$destendy8;
      var $530=$7;
      var $531=(($530+12)|0);
      var $532=HEAP32[(($531)>>2)];
      var $533=(($529)|0) > (($532)|0);
      if ($533) { __label__ = 141; break; } else { __label__ = 142; break; }
    case 141: // $534
      var $535=$7;
      var $536=(($535+12)|0);
      var $537=HEAP32[(($536)>>2)];
      $destendy8=$537;
      __label__ = 142; break;
    case 142: // $538
      var $539=$3;
      var $540=(($539)|0)!=0;
      if ($540) { __label__ = 143; break; } else { __label__ = 144; break; }
    case 143: // $541
      var $542=$2;
      var $543=$542;
      var $544=(($543+12)|0);
      var $545=HEAP32[(($544)>>2)];
      var $546=(($545-1)|0);
      var $547=$srcx9;
      var $548=(($546-$547)|0);
      $srcx9=$548;
      var $549=$dx13;
      var $550=(((-$549))|0);
      $dx13=$550;
      __label__ = 144; break;
    case 144: // $551
      var $552=$4;
      var $553=(($552)|0)!=0;
      if ($553) { __label__ = 145; break; } else { __label__ = 146; break; }
    case 145: // $554
      var $555=$2;
      var $556=$555;
      var $557=(($556+16)|0);
      var $558=HEAP32[(($557)>>2)];
      var $559=(($558-1)|0);
      var $560=$srcy10;
      var $561=(($559-$560)|0);
      $srcy10=$561;
      var $562=$dy14;
      var $563=(((-$562))|0);
      $dy14=$563;
      __label__ = 146; break;
    case 146: // $564
      var $565=$destendx7;
      var $566=(($565+1)|0);
      var $567=$5;
      var $568=(($566-$567)|0);
      var $569=(((($568)|0)/4)|0);
      $numblocks5=$569;
      var $570=$destendx7;
      var $571=(($570+1)|0);
      var $572=$5;
      var $573=(($571-$572)|0);
      var $574=$numblocks5;
      var $575=((($574<<2))|0);
      var $576=(($573-$575)|0);
      $leftovers6=$576;
      var $577=$2;
      var $578=$577;
      var $579=(($578+4)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=$580;
      var $582=$srcy10;
      var $583=$2;
      var $584=$583;
      var $585=(($584+8)|0);
      var $586=HEAP32[(($585)>>2)];
      var $587=(($582*$586)|0);
      var $588=(($581+($587<<1))|0);
      var $589=$srcx9;
      var $590=(($588+($589<<1))|0);
      $srcdata4=$590;
      var $591=$3;
      var $592=(($591)|0)!=0;
      if ($592) { __label__ = 174; break; } else { __label__ = 147; break; }
    case 147: // $593
      var $594=$6;
      $cury12=$594;
      __label__ = 148; break;
    case 148: // $595
      var $596=$cury12;
      var $597=$destendy8;
      var $598=(($596)|0) <= (($597)|0);
      if ($598) { __label__ = 149; break; } else { __label__ = 173; break; }
    case 149: // $599
      $priptr15=0;
      var $600=$1;
      var $601=$600;
      var $602=(($601+4)|0);
      var $603=HEAP32[(($602)>>2)];
      var $604=$603;
      var $605=$cury12;
      var $606=$1;
      var $607=$606;
      var $608=(($607+8)|0);
      var $609=HEAP32[(($608)>>2)];
      var $610=(($605*$609)|0);
      var $611=(($604+($610<<1))|0);
      var $612=$5;
      var $613=(($611+($612<<1))|0);
      $destptr16=$613;
      var $614=$srcdata4;
      $srcptr17=$614;
      var $615=$dy14;
      var $616=$srcdata4;
      var $617=(($616+($615<<1))|0);
      $srcdata4=$617;
      $curx11=0;
      __label__ = 150; break;
    case 150: // $618
      var $619=$curx11;
      var $620=$numblocks5;
      var $621=(($619)>>>0) < (($620)>>>0);
      if ($621) { __label__ = 151; break; } else { __label__ = 163; break; }
    case 151: // $622
      __label__ = 152; break;
    case 152: // $623
      var $624=$srcptr17;
      var $625=(($624)|0);
      var $626=HEAP16[(($625)>>1)];
      var $627=$destptr16;
      var $628=(($627)|0);
      HEAP16[(($628)>>1)]=$626;
      __label__ = 153; break;
    case 153: // $629
      __label__ = 154; break;
    case 154: // $630
      var $631=$srcptr17;
      var $632=(($631+2)|0);
      var $633=HEAP16[(($632)>>1)];
      var $634=$destptr16;
      var $635=(($634+2)|0);
      HEAP16[(($635)>>1)]=$633;
      __label__ = 155; break;
    case 155: // $636
      __label__ = 156; break;
    case 156: // $637
      var $638=$srcptr17;
      var $639=(($638+4)|0);
      var $640=HEAP16[(($639)>>1)];
      var $641=$destptr16;
      var $642=(($641+4)|0);
      HEAP16[(($642)>>1)]=$640;
      __label__ = 157; break;
    case 157: // $643
      __label__ = 158; break;
    case 158: // $644
      var $645=$srcptr17;
      var $646=(($645+6)|0);
      var $647=HEAP16[(($646)>>1)];
      var $648=$destptr16;
      var $649=(($648+6)|0);
      HEAP16[(($649)>>1)]=$647;
      __label__ = 159; break;
    case 159: // $650
      var $651=$srcptr17;
      var $652=(($651+8)|0);
      $srcptr17=$652;
      var $653=$destptr16;
      var $654=(($653+8)|0);
      $destptr16=$654;
      __label__ = 160; break;
    case 160: // $655
      __label__ = 161; break;
    case 161: // $656
      __label__ = 162; break;
    case 162: // $657
      var $658=$curx11;
      var $659=(($658+1)|0);
      $curx11=$659;
      __label__ = 150; break;
    case 163: // $660
      $curx11=0;
      __label__ = 164; break;
    case 164: // $661
      var $662=$curx11;
      var $663=$leftovers6;
      var $664=(($662)>>>0) < (($663)>>>0);
      if ($664) { __label__ = 165; break; } else { __label__ = 171; break; }
    case 165: // $665
      __label__ = 166; break;
    case 166: // $666
      var $667=$srcptr17;
      var $668=(($667)|0);
      var $669=HEAP16[(($668)>>1)];
      var $670=$destptr16;
      var $671=(($670)|0);
      HEAP16[(($671)>>1)]=$669;
      __label__ = 167; break;
    case 167: // $672
      var $673=$srcptr17;
      var $674=(($673+2)|0);
      $srcptr17=$674;
      var $675=$destptr16;
      var $676=(($675+2)|0);
      $destptr16=$676;
      __label__ = 168; break;
    case 168: // $677
      __label__ = 169; break;
    case 169: // $678
      __label__ = 170; break;
    case 170: // $679
      var $680=$curx11;
      var $681=(($680+1)|0);
      $curx11=$681;
      __label__ = 164; break;
    case 171: // $682
      __label__ = 172; break;
    case 172: // $683
      var $684=$cury12;
      var $685=(($684+1)|0);
      $cury12=$685;
      __label__ = 148; break;
    case 173: // $686
      __label__ = 201; break;
    case 174: // $687
      var $688=$6;
      $cury12=$688;
      __label__ = 175; break;
    case 175: // $689
      var $690=$cury12;
      var $691=$destendy8;
      var $692=(($690)|0) <= (($691)|0);
      if ($692) { __label__ = 176; break; } else { __label__ = 200; break; }
    case 176: // $693
      $priptr18=0;
      var $694=$1;
      var $695=$694;
      var $696=(($695+4)|0);
      var $697=HEAP32[(($696)>>2)];
      var $698=$697;
      var $699=$cury12;
      var $700=$1;
      var $701=$700;
      var $702=(($701+8)|0);
      var $703=HEAP32[(($702)>>2)];
      var $704=(($699*$703)|0);
      var $705=(($698+($704<<1))|0);
      var $706=$5;
      var $707=(($705+($706<<1))|0);
      $destptr19=$707;
      var $708=$srcdata4;
      $srcptr20=$708;
      var $709=$dy14;
      var $710=$srcdata4;
      var $711=(($710+($709<<1))|0);
      $srcdata4=$711;
      $curx11=0;
      __label__ = 177; break;
    case 177: // $712
      var $713=$curx11;
      var $714=$numblocks5;
      var $715=(($713)>>>0) < (($714)>>>0);
      if ($715) { __label__ = 178; break; } else { __label__ = 190; break; }
    case 178: // $716
      __label__ = 179; break;
    case 179: // $717
      var $718=$srcptr20;
      var $719=(($718)|0);
      var $720=HEAP16[(($719)>>1)];
      var $721=$destptr19;
      var $722=(($721)|0);
      HEAP16[(($722)>>1)]=$720;
      __label__ = 180; break;
    case 180: // $723
      __label__ = 181; break;
    case 181: // $724
      var $725=$srcptr20;
      var $726=(($725-2)|0);
      var $727=HEAP16[(($726)>>1)];
      var $728=$destptr19;
      var $729=(($728+2)|0);
      HEAP16[(($729)>>1)]=$727;
      __label__ = 182; break;
    case 182: // $730
      __label__ = 183; break;
    case 183: // $731
      var $732=$srcptr20;
      var $733=(($732-4)|0);
      var $734=HEAP16[(($733)>>1)];
      var $735=$destptr19;
      var $736=(($735+4)|0);
      HEAP16[(($736)>>1)]=$734;
      __label__ = 184; break;
    case 184: // $737
      __label__ = 185; break;
    case 185: // $738
      var $739=$srcptr20;
      var $740=(($739-6)|0);
      var $741=HEAP16[(($740)>>1)];
      var $742=$destptr19;
      var $743=(($742+6)|0);
      HEAP16[(($743)>>1)]=$741;
      __label__ = 186; break;
    case 186: // $744
      var $745=$srcptr20;
      var $746=(($745-8)|0);
      $srcptr20=$746;
      var $747=$destptr19;
      var $748=(($747+8)|0);
      $destptr19=$748;
      __label__ = 187; break;
    case 187: // $749
      __label__ = 188; break;
    case 188: // $750
      __label__ = 189; break;
    case 189: // $751
      var $752=$curx11;
      var $753=(($752+1)|0);
      $curx11=$753;
      __label__ = 177; break;
    case 190: // $754
      $curx11=0;
      __label__ = 191; break;
    case 191: // $755
      var $756=$curx11;
      var $757=$leftovers6;
      var $758=(($756)>>>0) < (($757)>>>0);
      if ($758) { __label__ = 192; break; } else { __label__ = 198; break; }
    case 192: // $759
      __label__ = 193; break;
    case 193: // $760
      var $761=$srcptr20;
      var $762=(($761)|0);
      var $763=HEAP16[(($762)>>1)];
      var $764=$destptr19;
      var $765=(($764)|0);
      HEAP16[(($765)>>1)]=$763;
      __label__ = 194; break;
    case 194: // $766
      var $767=$srcptr20;
      var $768=(($767-2)|0);
      $srcptr20=$768;
      var $769=$destptr19;
      var $770=(($769+2)|0);
      $destptr19=$770;
      __label__ = 195; break;
    case 195: // $771
      __label__ = 196; break;
    case 196: // $772
      __label__ = 197; break;
    case 197: // $773
      var $774=$curx11;
      var $775=(($774+1)|0);
      $curx11=$775;
      __label__ = 191; break;
    case 198: // $776
      __label__ = 199; break;
    case 199: // $777
      var $778=$cury12;
      var $779=(($778+1)|0);
      $cury12=$779;
      __label__ = 175; break;
    case 200: // $780
      __label__ = 201; break;
    case 201: // $781
      __label__ = 202; break;
    case 202: // $782
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 203; break;
    case 203: // $783
      __label__ = 301; break;
    case 204: // $784
      __label__ = 205; break;
    case 205: // $785
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 263);
      __label__ = 206; break;
    case 206: // $786
      __label__ = 207; break;
    case 207: // $787
      __label__ = 208; break;
    case 208: // $788
      __label__ = 209; break;
    case 209: // $789
      __label__ = 210; break;
    case 210: // $790
      __label__ = 211; break;
    case 211: // $791
      __label__ = 212; break;
    case 212: // $792
      __label__ = 213; break;
    case 213: // $793
      __label__ = 214; break;
    case 214: // $794
      __label__ = 215; break;
    case 215: // $795
      __label__ = 216; break;
    case 216: // $796
      __label__ = 217; break;
    case 217: // $797
      __label__ = 218; break;
    case 218: // $798
      __label__ = 219; break;
    case 219: // $799
      __label__ = 220; break;
    case 220: // $800
      var $801=$7;
      var $802=(($801)|0)==0;
      if ($802) { __label__ = 221; break; } else { __label__ = 222; break; }
    case 221: // $803
      var $804=$1;
      var $805=$804;
      var $806=(($805+32)|0);
      $7=$806;
      __label__ = 222; break;
    case 222: // $807
      var $808=$7;
      var $809=(($808)|0);
      var $810=HEAP32[(($809)>>2)];
      var $811=$7;
      var $812=(($811+4)|0);
      var $813=HEAP32[(($812)>>2)];
      var $814=(($810)|0) > (($813)|0);
      if ($814) { __label__ = 224; break; } else { __label__ = 223; break; }
    case 223: // $815
      var $816=$7;
      var $817=(($816+8)|0);
      var $818=HEAP32[(($817)>>2)];
      var $819=$7;
      var $820=(($819+12)|0);
      var $821=HEAP32[(($820)>>2)];
      var $822=(($818)|0) > (($821)|0);
      if ($822) { __label__ = 224; break; } else { __label__ = 225; break; }
    case 224: // $823
      __label__ = 299; break;
    case 225: // $824
      $dx30=1;
      var $825=$2;
      var $826=$825;
      var $827=(($826+8)|0);
      var $828=HEAP32[(($827)>>2)];
      $dy31=$828;
      var $829=$5;
      var $830=$2;
      var $831=$830;
      var $832=(($831+12)|0);
      var $833=HEAP32[(($832)>>2)];
      var $834=(($829+$833)|0);
      var $835=(($834-1)|0);
      $destendx24=$835;
      var $836=$5;
      var $837=$7;
      var $838=(($837+4)|0);
      var $839=HEAP32[(($838)>>2)];
      var $840=(($836)|0) > (($839)|0);
      if ($840) { __label__ = 227; break; } else { __label__ = 226; break; }
    case 226: // $841
      var $842=$destendx24;
      var $843=$7;
      var $844=(($843)|0);
      var $845=HEAP32[(($844)>>2)];
      var $846=(($842)|0) < (($845)|0);
      if ($846) { __label__ = 227; break; } else { __label__ = 228; break; }
    case 227: // $847
      __label__ = 299; break;
    case 228: // $848
      $srcx26=0;
      var $849=$5;
      var $850=$7;
      var $851=(($850)|0);
      var $852=HEAP32[(($851)>>2)];
      var $853=(($849)|0) < (($852)|0);
      if ($853) { __label__ = 229; break; } else { __label__ = 230; break; }
    case 229: // $854
      var $855=$7;
      var $856=(($855)|0);
      var $857=HEAP32[(($856)>>2)];
      var $858=$5;
      var $859=(($857-$858)|0);
      $srcx26=$859;
      var $860=$7;
      var $861=(($860)|0);
      var $862=HEAP32[(($861)>>2)];
      $5=$862;
      __label__ = 230; break;
    case 230: // $863
      var $864=$destendx24;
      var $865=$7;
      var $866=(($865+4)|0);
      var $867=HEAP32[(($866)>>2)];
      var $868=(($864)|0) > (($867)|0);
      if ($868) { __label__ = 231; break; } else { __label__ = 232; break; }
    case 231: // $869
      var $870=$7;
      var $871=(($870+4)|0);
      var $872=HEAP32[(($871)>>2)];
      $destendx24=$872;
      __label__ = 232; break;
    case 232: // $873
      var $874=$6;
      var $875=$2;
      var $876=$875;
      var $877=(($876+16)|0);
      var $878=HEAP32[(($877)>>2)];
      var $879=(($874+$878)|0);
      var $880=(($879-1)|0);
      $destendy25=$880;
      var $881=$6;
      var $882=$7;
      var $883=(($882+12)|0);
      var $884=HEAP32[(($883)>>2)];
      var $885=(($881)|0) > (($884)|0);
      if ($885) { __label__ = 234; break; } else { __label__ = 233; break; }
    case 233: // $886
      var $887=$destendy25;
      var $888=$7;
      var $889=(($888+8)|0);
      var $890=HEAP32[(($889)>>2)];
      var $891=(($887)|0) < (($890)|0);
      if ($891) { __label__ = 234; break; } else { __label__ = 235; break; }
    case 234: // $892
      __label__ = 299; break;
    case 235: // $893
      $srcy27=0;
      var $894=$6;
      var $895=$7;
      var $896=(($895+8)|0);
      var $897=HEAP32[(($896)>>2)];
      var $898=(($894)|0) < (($897)|0);
      if ($898) { __label__ = 236; break; } else { __label__ = 237; break; }
    case 236: // $899
      var $900=$7;
      var $901=(($900+8)|0);
      var $902=HEAP32[(($901)>>2)];
      var $903=$6;
      var $904=(($902-$903)|0);
      $srcy27=$904;
      var $905=$7;
      var $906=(($905+8)|0);
      var $907=HEAP32[(($906)>>2)];
      $6=$907;
      __label__ = 237; break;
    case 237: // $908
      var $909=$destendy25;
      var $910=$7;
      var $911=(($910+12)|0);
      var $912=HEAP32[(($911)>>2)];
      var $913=(($909)|0) > (($912)|0);
      if ($913) { __label__ = 238; break; } else { __label__ = 239; break; }
    case 238: // $914
      var $915=$7;
      var $916=(($915+12)|0);
      var $917=HEAP32[(($916)>>2)];
      $destendy25=$917;
      __label__ = 239; break;
    case 239: // $918
      var $919=$3;
      var $920=(($919)|0)!=0;
      if ($920) { __label__ = 240; break; } else { __label__ = 241; break; }
    case 240: // $921
      var $922=$2;
      var $923=$922;
      var $924=(($923+12)|0);
      var $925=HEAP32[(($924)>>2)];
      var $926=(($925-1)|0);
      var $927=$srcx26;
      var $928=(($926-$927)|0);
      $srcx26=$928;
      var $929=$dx30;
      var $930=(((-$929))|0);
      $dx30=$930;
      __label__ = 241; break;
    case 241: // $931
      var $932=$4;
      var $933=(($932)|0)!=0;
      if ($933) { __label__ = 242; break; } else { __label__ = 243; break; }
    case 242: // $934
      var $935=$2;
      var $936=$935;
      var $937=(($936+16)|0);
      var $938=HEAP32[(($937)>>2)];
      var $939=(($938-1)|0);
      var $940=$srcy27;
      var $941=(($939-$940)|0);
      $srcy27=$941;
      var $942=$dy31;
      var $943=(((-$942))|0);
      $dy31=$943;
      __label__ = 243; break;
    case 243: // $944
      var $945=$destendx24;
      var $946=(($945+1)|0);
      var $947=$5;
      var $948=(($946-$947)|0);
      var $949=(((($948)|0)/4)|0);
      $numblocks22=$949;
      var $950=$destendx24;
      var $951=(($950+1)|0);
      var $952=$5;
      var $953=(($951-$952)|0);
      var $954=$numblocks22;
      var $955=((($954<<2))|0);
      var $956=(($953-$955)|0);
      $leftovers23=$956;
      var $957=$2;
      var $958=$957;
      var $959=(($958+4)|0);
      var $960=HEAP32[(($959)>>2)];
      var $961=$960;
      var $962=$srcy27;
      var $963=$2;
      var $964=$963;
      var $965=(($964+8)|0);
      var $966=HEAP32[(($965)>>2)];
      var $967=(($962*$966)|0);
      var $968=(($961+($967<<2))|0);
      var $969=$srcx26;
      var $970=(($968+($969<<2))|0);
      $srcdata21=$970;
      var $971=$3;
      var $972=(($971)|0)!=0;
      if ($972) { __label__ = 271; break; } else { __label__ = 244; break; }
    case 244: // $973
      var $974=$6;
      $cury29=$974;
      __label__ = 245; break;
    case 245: // $975
      var $976=$cury29;
      var $977=$destendy25;
      var $978=(($976)|0) <= (($977)|0);
      if ($978) { __label__ = 246; break; } else { __label__ = 270; break; }
    case 246: // $979
      $priptr32=0;
      var $980=$1;
      var $981=$980;
      var $982=(($981+4)|0);
      var $983=HEAP32[(($982)>>2)];
      var $984=$983;
      var $985=$cury29;
      var $986=$1;
      var $987=$986;
      var $988=(($987+8)|0);
      var $989=HEAP32[(($988)>>2)];
      var $990=(($985*$989)|0);
      var $991=(($984+($990<<2))|0);
      var $992=$5;
      var $993=(($991+($992<<2))|0);
      $destptr33=$993;
      var $994=$srcdata21;
      $srcptr34=$994;
      var $995=$dy31;
      var $996=$srcdata21;
      var $997=(($996+($995<<2))|0);
      $srcdata21=$997;
      $curx28=0;
      __label__ = 247; break;
    case 247: // $998
      var $999=$curx28;
      var $1000=$numblocks22;
      var $1001=(($999)>>>0) < (($1000)>>>0);
      if ($1001) { __label__ = 248; break; } else { __label__ = 260; break; }
    case 248: // $1002
      __label__ = 249; break;
    case 249: // $1003
      var $1004=$srcptr34;
      var $1005=(($1004)|0);
      var $1006=HEAP32[(($1005)>>2)];
      var $1007=$destptr33;
      var $1008=(($1007)|0);
      HEAP32[(($1008)>>2)]=$1006;
      __label__ = 250; break;
    case 250: // $1009
      __label__ = 251; break;
    case 251: // $1010
      var $1011=$srcptr34;
      var $1012=(($1011+4)|0);
      var $1013=HEAP32[(($1012)>>2)];
      var $1014=$destptr33;
      var $1015=(($1014+4)|0);
      HEAP32[(($1015)>>2)]=$1013;
      __label__ = 252; break;
    case 252: // $1016
      __label__ = 253; break;
    case 253: // $1017
      var $1018=$srcptr34;
      var $1019=(($1018+8)|0);
      var $1020=HEAP32[(($1019)>>2)];
      var $1021=$destptr33;
      var $1022=(($1021+8)|0);
      HEAP32[(($1022)>>2)]=$1020;
      __label__ = 254; break;
    case 254: // $1023
      __label__ = 255; break;
    case 255: // $1024
      var $1025=$srcptr34;
      var $1026=(($1025+12)|0);
      var $1027=HEAP32[(($1026)>>2)];
      var $1028=$destptr33;
      var $1029=(($1028+12)|0);
      HEAP32[(($1029)>>2)]=$1027;
      __label__ = 256; break;
    case 256: // $1030
      var $1031=$srcptr34;
      var $1032=(($1031+16)|0);
      $srcptr34=$1032;
      var $1033=$destptr33;
      var $1034=(($1033+16)|0);
      $destptr33=$1034;
      __label__ = 257; break;
    case 257: // $1035
      __label__ = 258; break;
    case 258: // $1036
      __label__ = 259; break;
    case 259: // $1037
      var $1038=$curx28;
      var $1039=(($1038+1)|0);
      $curx28=$1039;
      __label__ = 247; break;
    case 260: // $1040
      $curx28=0;
      __label__ = 261; break;
    case 261: // $1041
      var $1042=$curx28;
      var $1043=$leftovers23;
      var $1044=(($1042)>>>0) < (($1043)>>>0);
      if ($1044) { __label__ = 262; break; } else { __label__ = 268; break; }
    case 262: // $1045
      __label__ = 263; break;
    case 263: // $1046
      var $1047=$srcptr34;
      var $1048=(($1047)|0);
      var $1049=HEAP32[(($1048)>>2)];
      var $1050=$destptr33;
      var $1051=(($1050)|0);
      HEAP32[(($1051)>>2)]=$1049;
      __label__ = 264; break;
    case 264: // $1052
      var $1053=$srcptr34;
      var $1054=(($1053+4)|0);
      $srcptr34=$1054;
      var $1055=$destptr33;
      var $1056=(($1055+4)|0);
      $destptr33=$1056;
      __label__ = 265; break;
    case 265: // $1057
      __label__ = 266; break;
    case 266: // $1058
      __label__ = 267; break;
    case 267: // $1059
      var $1060=$curx28;
      var $1061=(($1060+1)|0);
      $curx28=$1061;
      __label__ = 261; break;
    case 268: // $1062
      __label__ = 269; break;
    case 269: // $1063
      var $1064=$cury29;
      var $1065=(($1064+1)|0);
      $cury29=$1065;
      __label__ = 245; break;
    case 270: // $1066
      __label__ = 298; break;
    case 271: // $1067
      var $1068=$6;
      $cury29=$1068;
      __label__ = 272; break;
    case 272: // $1069
      var $1070=$cury29;
      var $1071=$destendy25;
      var $1072=(($1070)|0) <= (($1071)|0);
      if ($1072) { __label__ = 273; break; } else { __label__ = 297; break; }
    case 273: // $1073
      $priptr35=0;
      var $1074=$1;
      var $1075=$1074;
      var $1076=(($1075+4)|0);
      var $1077=HEAP32[(($1076)>>2)];
      var $1078=$1077;
      var $1079=$cury29;
      var $1080=$1;
      var $1081=$1080;
      var $1082=(($1081+8)|0);
      var $1083=HEAP32[(($1082)>>2)];
      var $1084=(($1079*$1083)|0);
      var $1085=(($1078+($1084<<2))|0);
      var $1086=$5;
      var $1087=(($1085+($1086<<2))|0);
      $destptr36=$1087;
      var $1088=$srcdata21;
      $srcptr37=$1088;
      var $1089=$dy31;
      var $1090=$srcdata21;
      var $1091=(($1090+($1089<<2))|0);
      $srcdata21=$1091;
      $curx28=0;
      __label__ = 274; break;
    case 274: // $1092
      var $1093=$curx28;
      var $1094=$numblocks22;
      var $1095=(($1093)>>>0) < (($1094)>>>0);
      if ($1095) { __label__ = 275; break; } else { __label__ = 287; break; }
    case 275: // $1096
      __label__ = 276; break;
    case 276: // $1097
      var $1098=$srcptr37;
      var $1099=(($1098)|0);
      var $1100=HEAP32[(($1099)>>2)];
      var $1101=$destptr36;
      var $1102=(($1101)|0);
      HEAP32[(($1102)>>2)]=$1100;
      __label__ = 277; break;
    case 277: // $1103
      __label__ = 278; break;
    case 278: // $1104
      var $1105=$srcptr37;
      var $1106=(($1105-4)|0);
      var $1107=HEAP32[(($1106)>>2)];
      var $1108=$destptr36;
      var $1109=(($1108+4)|0);
      HEAP32[(($1109)>>2)]=$1107;
      __label__ = 279; break;
    case 279: // $1110
      __label__ = 280; break;
    case 280: // $1111
      var $1112=$srcptr37;
      var $1113=(($1112-8)|0);
      var $1114=HEAP32[(($1113)>>2)];
      var $1115=$destptr36;
      var $1116=(($1115+8)|0);
      HEAP32[(($1116)>>2)]=$1114;
      __label__ = 281; break;
    case 281: // $1117
      __label__ = 282; break;
    case 282: // $1118
      var $1119=$srcptr37;
      var $1120=(($1119-12)|0);
      var $1121=HEAP32[(($1120)>>2)];
      var $1122=$destptr36;
      var $1123=(($1122+12)|0);
      HEAP32[(($1123)>>2)]=$1121;
      __label__ = 283; break;
    case 283: // $1124
      var $1125=$srcptr37;
      var $1126=(($1125-16)|0);
      $srcptr37=$1126;
      var $1127=$destptr36;
      var $1128=(($1127+16)|0);
      $destptr36=$1128;
      __label__ = 284; break;
    case 284: // $1129
      __label__ = 285; break;
    case 285: // $1130
      __label__ = 286; break;
    case 286: // $1131
      var $1132=$curx28;
      var $1133=(($1132+1)|0);
      $curx28=$1133;
      __label__ = 274; break;
    case 287: // $1134
      $curx28=0;
      __label__ = 288; break;
    case 288: // $1135
      var $1136=$curx28;
      var $1137=$leftovers23;
      var $1138=(($1136)>>>0) < (($1137)>>>0);
      if ($1138) { __label__ = 289; break; } else { __label__ = 295; break; }
    case 289: // $1139
      __label__ = 290; break;
    case 290: // $1140
      var $1141=$srcptr37;
      var $1142=(($1141)|0);
      var $1143=HEAP32[(($1142)>>2)];
      var $1144=$destptr36;
      var $1145=(($1144)|0);
      HEAP32[(($1145)>>2)]=$1143;
      __label__ = 291; break;
    case 291: // $1146
      var $1147=$srcptr37;
      var $1148=(($1147-4)|0);
      $srcptr37=$1148;
      var $1149=$destptr36;
      var $1150=(($1149+4)|0);
      $destptr36=$1150;
      __label__ = 292; break;
    case 292: // $1151
      __label__ = 293; break;
    case 293: // $1152
      __label__ = 294; break;
    case 294: // $1153
      var $1154=$curx28;
      var $1155=(($1154+1)|0);
      $curx28=$1155;
      __label__ = 288; break;
    case 295: // $1156
      __label__ = 296; break;
    case 296: // $1157
      var $1158=$cury29;
      var $1159=(($1158+1)|0);
      $cury29=$1159;
      __label__ = 272; break;
    case 297: // $1160
      __label__ = 298; break;
    case 298: // $1161
      __label__ = 299; break;
    case 299: // $1162
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 300; break;
    case 300: // $1163
      __label__ = 301; break;
    case 301: // $1164
      __label__ = 302; break;
    case 302: // $1165
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10copybitmapP8bitmap_tS0_iiiiPK10_rectangle["X"]=1;

function __Z11config_initR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  HEAP32[((__ZL8typelist)>>2)]=0;
  ;
  return;
}


function __ZL7readbitPKhj($src, $bitnum) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$src;
  $2=$bitnum;
  var $3=$2;
  var $4=Math.floor((($3)>>>0)/8);
  var $5=$1;
  var $6=(($5+$4)|0);
  var $7=HEAPU8[($6)];
  var $8=(($7)&255);
  var $9=$2;
  var $10=(($9)>>>0)%8;
  var $11=128 >> (($10)|0);
  var $12=$8 & $11;
  ;
  return $12;
}


function __ZL13calc_penusagePK11gfx_elementj($gfx, $code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dp;
      var $usage;
      var $x;
      var $y;
      $1=$gfx;
      $2=$code;
      var $3=$1;
      var $4=(($3+36)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=$1;
      var $8=(($7+44)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6*$9)|0);
      var $11=(($5+$10)|0);
      $dp=$11;
      $usage=0;
      var $12=$1;
      var $13=(($12+32)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      __label__ = 22; break;
    case 2: // $17
      var $18=$1;
      var $19=(($18+12)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$21 & 1;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $24
      $y=0;
      __label__ = 4; break;
    case 4: // $25
      var $26=$y;
      var $27=$1;
      var $28=(($27+10)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($26)|0) < (($30)|0);
      if ($31) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $32
      $x=0;
      __label__ = 6; break;
    case 6: // $33
      var $34=$x;
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=HEAPU16[(($36)>>1)];
      var $38=(($37)&65535);
      var $39=(((($38)|0)/2)|0);
      var $40=(($34)|0) < (($39)|0);
      if ($40) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $41
      var $42=$x;
      var $43=$dp;
      var $44=(($43+$42)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$46 & 15;
      var $48=1 << $47;
      var $49=$x;
      var $50=$dp;
      var $51=(($50+$49)|0);
      var $52=HEAPU8[($51)];
      var $53=(($52)&255);
      var $54=$53 >> 4;
      var $55=1 << $54;
      var $56=$48 | $55;
      var $57=$usage;
      var $58=$57 | $56;
      $usage=$58;
      __label__ = 8; break;
    case 8: // $59
      var $60=$x;
      var $61=(($60+1)|0);
      $x=$61;
      __label__ = 6; break;
    case 9: // $62
      var $63=$1;
      var $64=(($63+40)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$dp;
      var $67=(($66+$65)|0);
      $dp=$67;
      __label__ = 10; break;
    case 10: // $68
      var $69=$y;
      var $70=(($69+1)|0);
      $y=$70;
      __label__ = 4; break;
    case 11: // $71
      __label__ = 21; break;
    case 12: // $72
      $y=0;
      __label__ = 13; break;
    case 13: // $73
      var $74=$y;
      var $75=$1;
      var $76=(($75+10)|0);
      var $77=HEAPU16[(($76)>>1)];
      var $78=(($77)&65535);
      var $79=(($74)|0) < (($78)|0);
      if ($79) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $80
      $x=0;
      __label__ = 15; break;
    case 15: // $81
      var $82=$x;
      var $83=$1;
      var $84=(($83+8)|0);
      var $85=HEAPU16[(($84)>>1)];
      var $86=(($85)&65535);
      var $87=(($82)|0) < (($86)|0);
      if ($87) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $88
      var $89=$x;
      var $90=$dp;
      var $91=(($90+$89)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=1 << $93;
      var $95=$usage;
      var $96=$95 | $94;
      $usage=$96;
      __label__ = 17; break;
    case 17: // $97
      var $98=$x;
      var $99=(($98+1)|0);
      $x=$99;
      __label__ = 15; break;
    case 18: // $100
      var $101=$1;
      var $102=(($101+40)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$dp;
      var $105=(($104+$103)|0);
      $dp=$105;
      __label__ = 19; break;
    case 19: // $106
      var $107=$y;
      var $108=(($107+1)|0);
      $y=$108;
      __label__ = 13; break;
    case 20: // $109
      __label__ = 21; break;
    case 21: // $110
      var $111=$usage;
      var $112=$2;
      var $113=$1;
      var $114=(($113+32)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115+($112<<2))|0);
      HEAP32[(($116)>>2)]=$111;
      __label__ = 22; break;
    case 22: // $117
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13calc_penusagePK11gfx_elementj["X"]=1;

function __ZN11gfx_elementC2ER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=(($3+60)|0);
  var $5=(($3+372)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  ;
  return;
}


function __ZN20resource_pool_objectI11gfx_elementEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11gfx_elementEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11gfx_elementEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 376);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11gfx_elementE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11gfx_elementED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11gfx_elementED2Ev($2);
  ;
  return;
}


function __ZN12_config_typeC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12_config_typeC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFviP14_xml_data_nodeEEaSERKS3_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EaSERKS3_($5, $7);
  ;
  return $4;
}


function __ZN20resource_pool_objectI11gfx_elementED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11gfx_elementED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11gfx_elementED0Ev["X"]=1;

function __ZN20resource_pool_objectI11gfx_elementED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI11gfx_elementE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($machine, $nodename, $load, $save) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $newtype;
      var $ptype;
      var $11;
      var $12;
      $9=$machine;
      $10=$nodename;
      var $13=$9;
      var $14=__ZN15running_machine7respoolEv($13);
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=56;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3586)|0);
      HEAP32[(($6)>>2)]=84;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      (function() { try { __THREW__ = false; return __ZN12_config_typeC1Ev($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $54
      var $55=__ZN13resource_pool10add_objectI12_config_typeEEPT_S3_($14, $53);
      $newtype=$55;
      var $56=$newtype;
      var $57=(($56)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=$10;
      var $59=$newtype;
      var $60=(($59+4)|0);
      HEAP32[(($60)>>2)]=$58;
      var $61=$newtype;
      var $62=(($61+8)|0);
      var $63=__ZN8delegateIFviP14_xml_data_nodeEEaSERKS3_($62, $load);
      var $64=$newtype;
      var $65=(($64+32)|0);
      var $66=__ZN8delegateIFviP14_xml_data_nodeEEaSERKS3_($65, $save);
      $ptype=__ZL8typelist;
      __label__ = 9; break;
    case 9: // $67
      var $68=$ptype;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $71
      __label__ = 11; break;
    case 11: // $72
      var $73=$ptype;
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0);
      $ptype=$75;
      __label__ = 9; break;
    case 12: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $11=$78;
      var $79=$77.f1;
      $12=$79;
      var $80=$1;
      var $81=$2;
      var $82=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3586)|0);
      HEAP32[(($3)>>2)]=84;
      var $83=HEAP32[(($1)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $85
      var $86=HEAP32[(($1)>>2)];
      var $87=HEAP32[(($2)>>2)];
      var $88=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($86, $87, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $89=$1;
      var $90=$2;
      var $91=$3;
      __label__ = 16; break;
    case 16: // $92
      __label__ = 18; break;
    case 17: // $93
      var $94=$newtype;
      var $95=$ptype;
      HEAP32[(($95)>>2)]=$94;
      STACKTOP = __stackBase__;
      return;
    case 18: // $96
      var $97=$11;
      var $98=$11;
      var $99=$12;
      var $100=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $98, tempValue);
      var $101=($100.f1 = $99, $100);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_["X"]=1;

function __ZN13resource_pool10add_objectI12_config_typeEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12_config_typeEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12_config_typeEEPT_S3_["X"]=1;

function __ZNK11emu_options5ctrlrEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str123598)|0));
  ;
  return $4;
}


function __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  var $10=$3;
  FUNCTION_TABLE[$6]($8, $9, $10);
  ;
  return;
}


function __ZNK11emu_options10ctrlr_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str113597)|0));
  ;
  return $4;
}


function __ZL15config_load_xmlR15running_machineR8emu_filei($machine, $file, $which_type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $root;
      var $confignode;
      var $systemnode;
      var $type;
      var $srcfile;
      var $version;
      var $count;
      var $name;
      var $clone_of;
      $2=$machine;
      $3=$file;
      $4=$which_type;
      var $5=$3;
      var $6=__ZN8emu_filecvP10_core_fileEv($5);
      var $7=__Z13xml_file_readP10_core_fileP18_xml_parse_options($6, 0);
      $root=$7;
      var $8=$root;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      __label__ = 41; break;
    case 2: // $11
      var $12=$root;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z15xml_get_siblingP14_xml_data_nodePKc($14, ((STRING_TABLE.__str43590)|0));
      $confignode=$15;
      var $16=$confignode;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      __label__ = 41; break;
    case 4: // $19
      var $20=$confignode;
      var $21=__Z21xml_get_attribute_intP14_xml_data_nodePKci($20, ((STRING_TABLE.__str53591)|0), 0);
      $version=$21;
      var $22=$version;
      var $23=(($22)|0)!=10;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      __label__ = 41; break;
    case 6: // $25
      var $26=$2;
      var $27=__ZNK15running_machine6systemEv($26);
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=_strrchr($29, 47);
      $srcfile=$30;
      var $31=$srcfile;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $33
      var $34=$2;
      var $35=__ZNK15running_machine6systemEv($34);
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=_strrchr($37, 92);
      $srcfile=$38;
      __label__ = 8; break;
    case 8: // $39
      var $40=$srcfile;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $42
      var $43=$2;
      var $44=__ZNK15running_machine6systemEv($43);
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=_strrchr($46, 58);
      $srcfile=$47;
      __label__ = 10; break;
    case 10: // $48
      var $49=$srcfile;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $51
      var $52=$2;
      var $53=__ZNK15running_machine6systemEv($52);
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      $srcfile=$55;
      __label__ = 13; break;
    case 12: // $56
      var $57=$srcfile;
      var $58=(($57+1)|0);
      $srcfile=$58;
      __label__ = 13; break;
    case 13: // $59
      $count=0;
      var $60=$confignode;
      var $61=(($60+8)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__Z15xml_get_siblingP14_xml_data_nodePKc($62, ((STRING_TABLE.__str63592)|0));
      $systemnode=$63;
      __label__ = 14; break;
    case 14: // $64
      var $65=$systemnode;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 15; break; } else { __label__ = 38; break; }
    case 15: // $67
      var $68=$systemnode;
      var $69=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($68, ((STRING_TABLE.__str73593)|0), ((__str93595)|0));
      $name=$69;
      var $70=$4;
      if ($70 == 3) {
        __label__ = 16; break;
      }
      else if ($70 == 2) {
        __label__ = 19; break;
      }
      else if ($70 == 1) {
        __label__ = 22; break;
      }
      else {
      __label__ = 32; break;
      }
      
    case 16: // $71
      var $72=$name;
      var $73=$2;
      var $74=__ZNK15running_machine6systemEv($73);
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=_strcmp($72, $76);
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $79
      __label__ = 37; break;
    case 18: // $80
      __label__ = 32; break;
    case 19: // $81
      var $82=$name;
      var $83=_strcmp($82, ((STRING_TABLE.__str83594)|0));
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $85
      __label__ = 37; break;
    case 21: // $86
      __label__ = 32; break;
    case 22: // $87
      var $88=$name;
      var $89=_strcmp($88, ((STRING_TABLE.__str83594)|0));
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 23; break; } else { __label__ = 31; break; }
    case 23: // $91
      var $92=$name;
      var $93=$2;
      var $94=__ZNK15running_machine6systemEv($93);
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=_strcmp($92, $96);
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 24; break; } else { __label__ = 31; break; }
    case 24: // $99
      var $100=$name;
      var $101=$srcfile;
      var $102=_strcmp($100, $101);
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 25; break; } else { __label__ = 31; break; }
    case 25: // $104
      var $105=$2;
      var $106=__ZNK15running_machine6systemEv($105);
      var $107=__ZN11driver_list5cloneERK11game_driver($106);
      $clone_of=$107;
      var $108=(($107)|0)==-1;
      if ($108) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $109
      var $110=$name;
      var $111=$clone_of;
      var $112=__ZN11driver_list6driverEi($111);
      var $113=(($112+8)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=_strcmp($110, $114);
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $117
      var $118=$clone_of;
      var $119=(($118)|0)==-1;
      if ($119) { __label__ = 30; break; } else { __label__ = 28; break; }
    case 28: // $120
      var $121=$clone_of;
      var $122=__ZN11driver_list5cloneEi($121);
      $clone_of=$122;
      var $123=(($122)|0)==-1;
      if ($123) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $124
      var $125=$name;
      var $126=$clone_of;
      var $127=__ZN11driver_list6driverEi($126);
      var $128=(($127+8)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=_strcmp($125, $129);
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $132
      __label__ = 37; break;
    case 31: // $133
      __label__ = 32; break;
    case 32: // $134
      var $135=HEAP32[((__ZL8typelist)>>2)];
      $type=$135;
      __label__ = 33; break;
    case 33: // $136
      var $137=$type;
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $139
      var $140=$type;
      var $141=(($140+8)|0);
      var $142=$141;
      var $143=$4;
      var $144=$systemnode;
      var $145=(($144+8)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$type;
      var $148=(($147+4)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=__Z15xml_get_siblingP14_xml_data_nodePKc($146, $149);
      __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($142, $143, $150);
      __label__ = 35; break;
    case 35: // $151
      var $152=$type;
      var $153=(($152)|0);
      var $154=HEAP32[(($153)>>2)];
      $type=$154;
      __label__ = 33; break;
    case 36: // $155
      var $156=$count;
      var $157=(($156+1)|0);
      $count=$157;
      __label__ = 37; break;
    case 37: // $158
      var $159=$systemnode;
      var $160=(($159)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=__Z15xml_get_siblingP14_xml_data_nodePKc($161, ((STRING_TABLE.__str63592)|0));
      $systemnode=$162;
      __label__ = 14; break;
    case 38: // $163
      var $164=$count;
      var $165=(($164)|0)==0;
      if ($165) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $166
      __label__ = 41; break;
    case 40: // $167
      var $168=$root;
      __Z13xml_file_freeP14_xml_data_node($168);
      $1=1;
      __label__ = 44; break;
    case 41: // $169
      var $170=$root;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $172
      var $173=$root;
      __Z13xml_file_freeP14_xml_data_node($173);
      __label__ = 43; break;
    case 43: // $174
      $1=0;
      __label__ = 44; break;
    case 44: // $175
      var $176=$1;
      ;
      return $176;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15config_load_xmlR15running_machineR8emu_filei["X"]=1;

function __ZNK11emu_options13cfg_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str103596)|0));
  ;
  return $4;
}


function __ZL15config_save_xmlR15running_machineR8emu_filei($machine, $file, $which_type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $root;
      var $confignode;
      var $systemnode;
      var $type;
      var $curnode;
      $2=$machine;
      $3=$file;
      $4=$which_type;
      var $5=__Z15xml_file_createv();
      $root=$5;
      var $6=$root;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      $1=0;
      __label__ = 20; break;
    case 2: // $9
      var $10=$root;
      var $11=__Z13xml_add_childP14_xml_data_nodePKcS2_($10, ((STRING_TABLE.__str43590)|0), 0);
      $confignode=$11;
      var $12=$confignode;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $14
      __label__ = 19; break;
    case 4: // $15
      var $16=$confignode;
      var $17=__Z21xml_set_attribute_intP14_xml_data_nodePKci($16, ((STRING_TABLE.__str53591)|0), 10);
      var $18=$confignode;
      var $19=__Z13xml_add_childP14_xml_data_nodePKcS2_($18, ((STRING_TABLE.__str63592)|0), 0);
      $systemnode=$19;
      var $20=$systemnode;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $22
      __label__ = 19; break;
    case 6: // $23
      var $24=$systemnode;
      var $25=$4;
      var $26=(($25)|0)==2;
      if ($26) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $27
      var $34 = ((STRING_TABLE.__str83594)|0);__label__ = 9; break;
    case 8: // $28
      var $29=$2;
      var $30=__ZNK15running_machine6systemEv($29);
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $34 = $32;__label__ = 9; break;
    case 9: // $33
      var $34;
      var $35=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($24, ((STRING_TABLE.__str73593)|0), $34);
      var $36=HEAP32[((__ZL8typelist)>>2)];
      $type=$36;
      __label__ = 10; break;
    case 10: // $37
      var $38=$type;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $40
      var $41=$systemnode;
      var $42=$type;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=__Z13xml_add_childP14_xml_data_nodePKcS2_($41, $44, 0);
      $curnode=$45;
      var $46=$curnode;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $48
      __label__ = 19; break;
    case 13: // $49
      var $50=$type;
      var $51=(($50+32)|0);
      var $52=$51;
      var $53=$4;
      var $54=$curnode;
      __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($52, $53, $54);
      var $55=$curnode;
      var $56=(($55+16)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 16; break; } else { __label__ = 14; break; }
    case 14: // $59
      var $60=$curnode;
      var $61=(($60+8)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $64
      var $65=$curnode;
      __Z15xml_delete_nodeP14_xml_data_node($65);
      __label__ = 16; break;
    case 16: // $66
      __label__ = 17; break;
    case 17: // $67
      var $68=$type;
      var $69=(($68)|0);
      var $70=HEAP32[(($69)>>2)];
      $type=$70;
      __label__ = 10; break;
    case 18: // $71
      var $72=$root;
      var $73=$3;
      var $74=__ZN8emu_filecvP10_core_fileEv($73);
      __Z14xml_file_writeP14_xml_data_nodeP10_core_file($72, $74);
      var $75=$root;
      __Z13xml_file_freeP14_xml_data_node($75);
      $1=1;
      __label__ = 20; break;
    case 19: // $76
      var $77=$root;
      __Z13xml_file_freeP14_xml_data_node($77);
      $1=0;
      __label__ = 20; break;
    case 20: // $78
      var $79=$1;
      ;
      return $79;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15config_save_xmlR15running_machineR8emu_filei["X"]=1;

function __ZN20resource_pool_objectI12_config_typeEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12_config_typeEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12_config_typeEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 56);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12_config_typeE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12_config_typeED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12_config_typeED2Ev($2);
  ;
  return;
}


function __Z20config_load_settingsR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 520; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $controller;
      var $type;
      var $loaded;
      var $file=__stackBase__;
      var $filerr;
      var $3;
      var $4;
      var $file1=__stackBase__+260;
      var $filerr2;
      var $5;
      $2=$machine;
      var $6=$2;
      var $7=__ZNK15running_machine7optionsEv($6);
      var $8=__ZNK11emu_options5ctrlrEv($7);
      $controller=$8;
      $loaded=0;
      var $9=HEAP32[((__ZL8typelist)>>2)];
      $type=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$type;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$type;
      var $15=(($14+8)|0);
      var $16=$15;
      __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($16, 0, 0);
      __label__ = 3; break;
    case 3: // $17
      var $18=$type;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $type=$20;
      __label__ = 1; break;
    case 4: // $21
      var $22=$controller;
      var $23=(($22)|0);
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 19; break; }
    case 5: // $27
      var $28=$2;
      var $29=__ZNK15running_machine7optionsEv($28);
      var $30=__ZNK11emu_options10ctrlr_pathEv($29);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $30, 1);
      var $31=$controller;
      var $32=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $31, ((STRING_TABLE.__str13587)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $33
      $filerr=$32;
      var $34=$filerr;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $36
      var $37=___cxa_allocate_exception(1032);
      var $38=$37;
      var $39=$controller;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($38, ((STRING_TABLE.__str23588)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $40
      (function() { try { __THREW__ = false; return ___cxa_throw($37, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 9; break; }
    case 9: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      $3=$43;
      var $44=$42.f1;
      $4=$44;
      __label__ = 17; break;
    case 10: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $3=$47;
      var $48=$46.f1;
      $4=$48;
      ___cxa_free_exception($37);
      __label__ = 17; break;
    case 11: // $49
      var $50=$2;
      var $51=(function() { try { __THREW__ = false; return __ZL15config_load_xmlR15running_machineR8emu_filei($50, $file, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $52
      var $53=(($51)|0)!=0;
      if ($53) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $54
      var $55=___cxa_allocate_exception(1032);
      var $56=$55;
      var $57=$controller;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($56, ((STRING_TABLE.__str23588)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$57,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $58
      (function() { try { __THREW__ = false; return ___cxa_throw($55, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 9; break; }
    case 15: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      $3=$61;
      var $62=$60.f1;
      $4=$62;
      ___cxa_free_exception($55);
      __label__ = 17; break;
    case 16: // $63
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 19; break;
    case 17: // $64
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 37; break; }
    case 18: // $65
      __label__ = 36; break;
    case 19: // $66
      var $67=$2;
      var $68=__ZNK15running_machine7optionsEv($67);
      var $69=__ZNK11emu_options13cfg_directoryEv($68);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file1, $69, 1);
      var $70=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file1, ((STRING_TABLE.__str33589)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 23; break; };
    case 20: // $71
      $filerr2=$70;
      var $72=$filerr2;
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $74
      var $75=$2;
      var $76=(function() { try { __THREW__ = false; return __ZL15config_load_xmlR15running_machineR8emu_filei($75, $file1, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 23; break; };
    case 22: // $77
      __label__ = 24; break;
    case 23: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $80=$79.f0;
      $3=$80;
      var $81=$79.f1;
      $4=$81;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 24: // $82
      var $83=$2;
      var $84=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 23; break; };
    case 25: // $85
      var $86=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file1, $84, ((STRING_TABLE.__str13587)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 23; break; };
    case 26: // $87
      $filerr2=$86;
      var $88=$filerr2;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $90
      var $91=$2;
      var $92=(function() { try { __THREW__ = false; return __ZL15config_load_xmlR15running_machineR8emu_filei($91, $file1, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 23; break; };
    case 28: // $93
      $loaded=$92;
      __label__ = 29; break;
    case 29: // $94
      var $95=HEAP32[((__ZL8typelist)>>2)];
      $type=$95;
      __label__ = 30; break;
    case 30: // $96
      var $97=$type;
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $99
      var $100=$type;
      var $101=(($100+8)|0);
      var $102=$101;
      (function() { try { __THREW__ = false; return __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($102, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 23; break; }
    case 32: // $103
      __label__ = 33; break;
    case 33: // $104
      var $105=$type;
      var $106=(($105)|0);
      var $107=HEAP32[(($106)>>2)];
      $type=$107;
      __label__ = 30; break;
    case 34: // $108
      var $109=$loaded;
      $1=$109;
      $5=1;
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file1);
      var $110=$1;
      STACKTOP = __stackBase__;
      return $110;
    case 35: // $111
      __label__ = 36; break;
    case 36: // $112
      var $113=$3;
      var $114=$3;
      var $115=$4;
      var $116=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $114, tempValue);
      var $117=($116.f1 = $115, $116);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $118
      var $119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 38: // $120
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20config_load_settingsR15running_machine["X"]=1;

function __Z20config_save_settingsR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $type;
      var $file=__stackBase__;
      var $filerr;
      var $2;
      var $3;
      $1=$machine;
      var $4=HEAP32[((__ZL8typelist)>>2)];
      $type=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$type;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$type;
      var $10=(($9+32)|0);
      var $11=$10;
      __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($11, 0, 0);
      __label__ = 3; break;
    case 3: // $12
      var $13=$type;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      $type=$15;
      __label__ = 1; break;
    case 4: // $16
      var $17=$1;
      var $18=__ZNK15running_machine7optionsEv($17);
      var $19=__ZNK11emu_options13cfg_directoryEv($18);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $19, 14);
      var $20=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, ((STRING_TABLE.__str33589)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $21
      $filerr=$20;
      var $22=$filerr;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $24
      var $25=$1;
      var $26=(function() { try { __THREW__ = false; return __ZL15config_save_xmlR15running_machineR8emu_filei($25, $file, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $27
      __label__ = 9; break;
    case 8: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $2=$30;
      var $31=$29.f1;
      $3=$31;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 9: // $32
      var $33=$1;
      var $34=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $34, ((STRING_TABLE.__str13587)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $37
      $filerr=$36;
      var $38=$filerr;
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $40
      var $41=$1;
      var $42=(function() { try { __THREW__ = false; return __ZL15config_save_xmlR15running_machineR8emu_filei($41, $file, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $43
      __label__ = 14; break;
    case 14: // $44
      var $45=HEAP32[((__ZL8typelist)>>2)];
      $type=$45;
      __label__ = 15; break;
    case 15: // $46
      var $47=$type;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $49
      var $50=$type;
      var $51=(($50+32)|0);
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_($52, 4, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; }
    case 17: // $53
      __label__ = 18; break;
    case 18: // $54
      var $55=$type;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      $type=$57;
      __label__ = 15; break;
    case 19: // $58
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      STACKTOP = __stackBase__;
      return;
    case 20: // $59
      __label__ = 21; break;
    case 21: // $60
      var $61=$2;
      var $62=$2;
      var $63=$3;
      var $64=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $62, tempValue);
      var $65=($64.f1 = $63, $64);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20config_save_settingsR15running_machine["X"]=1;

function __ZL15interrupt_resetR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $state;
      var $cpunum;
      $1=$machine;
      var $2=$1;
      var $3=(($2+656)|0);
      var $4=HEAP32[(($3)>>2)];
      $state=$4;
      $cpunum=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$cpunum;
      var $7=(($6)>>>0) < 8;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$cpunum;
      var $10=$state;
      var $11=(($10+136)|0);
      var $12=(($11+$9)|0);
      HEAP8[($12)]=1;
      __label__ = 3; break;
    case 3: // $13
      var $14=$cpunum;
      var $15=(($14+1)|0);
      $cpunum=$15;
      __label__ = 1; break;
    case 4: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EaSERKS3_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12_config_typeC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  __ZN8delegateIFviP14_xml_data_nodeEEC1Ev($3);
  var $4=(($2+32)|0);
  __ZN8delegateIFviP14_xml_data_nodeEEC1Ev($4);
  ;
  return;
}


function __ZN8delegateIFviP14_xml_data_nodeEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8delegateIFviP14_xml_data_nodeEEC2Ev($2);
  ;
  return;
}


function __ZN8delegateIFviP14_xml_data_nodeEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2Ev($3);
  ;
  return;
}


function __ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN12save_manager9save_itemIA8_jEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemIjLj8EEEvPKcS2_iRAT0__T_S2_($5, ((STRING_TABLE.__str173624)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZN12save_manager9save_itemIA8_hEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemIhLj8EEEvPKcS2_iRAT0__T_S2_($5, ((STRING_TABLE.__str173624)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZL13counters_loadR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      var $coinnode;
      var $ticketnode;
      var $index;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$1;
      var $5=(($4+656)|0);
      var $6=HEAP32[(($5)>>2)];
      $state=$6;
      var $7=$2;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$state;
      var $11=(($10+4)|0);
      var $12=(($11)|0);
      var $13=$12;
      _memset($13, 0, 32, 1);
      var $14=$state;
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=0;
      __label__ = 2; break;
    case 2: // $16
      var $17=$2;
      var $18=(($17)|0)!=3;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 15; break;
    case 4: // $20
      var $21=$3;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      __label__ = 15; break;
    case 6: // $24
      var $25=$3;
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__Z15xml_get_siblingP14_xml_data_nodePKc($27, ((STRING_TABLE.__str233630)|0));
      $coinnode=$28;
      __label__ = 7; break;
    case 7: // $29
      var $30=$coinnode;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $32
      var $33=$coinnode;
      var $34=__Z21xml_get_attribute_intP14_xml_data_nodePKci($33, ((STRING_TABLE.__str243631)|0), -1);
      $index=$34;
      var $35=$index;
      var $36=(($35)|0) >= 0;
      if ($36) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $37
      var $38=$index;
      var $39=(($38)|0) < 8;
      if ($39) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $40
      var $41=$coinnode;
      var $42=__Z21xml_get_attribute_intP14_xml_data_nodePKci($41, ((STRING_TABLE.__str253632)|0), 0);
      var $43=$index;
      var $44=$state;
      var $45=(($44+4)|0);
      var $46=(($45+($43<<2))|0);
      HEAP32[(($46)>>2)]=$42;
      __label__ = 11; break;
    case 11: // $47
      __label__ = 12; break;
    case 12: // $48
      var $49=$coinnode;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=__Z15xml_get_siblingP14_xml_data_nodePKc($51, ((STRING_TABLE.__str233630)|0));
      $coinnode=$52;
      __label__ = 7; break;
    case 13: // $53
      var $54=$3;
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__Z15xml_get_siblingP14_xml_data_nodePKc($56, ((STRING_TABLE.__str263633)|0));
      $ticketnode=$57;
      var $58=$ticketnode;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $60
      var $61=$ticketnode;
      var $62=__Z21xml_get_attribute_intP14_xml_data_nodePKci($61, ((STRING_TABLE.__str253632)|0), 0);
      var $63=$state;
      var $64=(($63)|0);
      HEAP32[(($64)>>2)]=$62;
      __label__ = 15; break;
    case 15: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13counters_loadR15running_machineiP14_xml_data_node["X"]=1;

function __ZL13counters_saveR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      var $i;
      var $coinnode;
      var $tickets;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$1;
      var $5=(($4+656)|0);
      var $6=HEAP32[(($5)>>2)];
      $state=$6;
      var $7=$2;
      var $8=(($7)|0)!=3;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      __label__ = 14; break;
    case 2: // $10
      $i=0;
      __label__ = 3; break;
    case 3: // $11
      var $12=$i;
      var $13=(($12)|0) < 8;
      if ($13) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $14
      var $15=$i;
      var $16=$state;
      var $17=(($16+4)|0);
      var $18=(($17+($15<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $21
      var $22=$3;
      var $23=__Z13xml_add_childP14_xml_data_nodePKcS2_($22, ((STRING_TABLE.__str233630)|0), 0);
      $coinnode=$23;
      var $24=$coinnode;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$coinnode;
      var $28=$i;
      var $29=__Z21xml_set_attribute_intP14_xml_data_nodePKci($27, ((STRING_TABLE.__str243631)|0), $28);
      var $30=$coinnode;
      var $31=$i;
      var $32=$state;
      var $33=(($32+4)|0);
      var $34=(($33+($31<<2))|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z21xml_set_attribute_intP14_xml_data_nodePKci($30, ((STRING_TABLE.__str253632)|0), $35);
      __label__ = 7; break;
    case 7: // $37
      __label__ = 8; break;
    case 8: // $38
      __label__ = 9; break;
    case 9: // $39
      var $40=$i;
      var $41=(($40+1)|0);
      $i=$41;
      __label__ = 3; break;
    case 10: // $42
      var $43=$state;
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $47
      var $48=$3;
      var $49=__Z13xml_add_childP14_xml_data_nodePKcS2_($48, ((STRING_TABLE.__str263633)|0), 0);
      $tickets=$49;
      var $50=$tickets;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $52
      var $53=$tickets;
      var $54=$state;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__Z21xml_set_attribute_intP14_xml_data_nodePKci($53, ((STRING_TABLE.__str253632)|0), $56);
      __label__ = 13; break;
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13counters_saveR15running_machineiP14_xml_data_node["X"]=1;

function __ZN12save_manager9save_itemIiEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_($5, ((STRING_TABLE.__str173624)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZN20resource_pool_objectI12_config_typeED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12_config_typeED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12_config_typeED0Ev["X"]=1;

function __ZN20resource_pool_objectI12_config_typeED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI12_config_typeE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20generic_machine_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $state;
      var $counternum;
      var $exec=__stackBase__+28;
      var $index;
      var $gotone;
      var $8=__stackBase__+32;
      var $9=__stackBase__+56;
      var $10=__stackBase__+80;
      var $11=__stackBase__+104;
      $7=$machine;
      var $12=$7;
      var $13=__ZN15running_machine7respoolEv($12);
      var $14=$1;
      var $15=$2;
      var $16=$3;
      var $17=$4;
      var $18=$result_i;
      var $19=$5;
      var $20=$6;
      HEAP32[(($1)>>2)]=144;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3607)|0);
      HEAP32[(($3)>>2)]=85;
      HEAP32[(($4)>>2)]=_zeromem;
      var $21=HEAP32[(($1)>>2)];
      var $22=HEAP32[(($2)>>2)];
      var $23=HEAP32[(($3)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($5)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($6)>>2)]=$34;
      var $35=HEAP32[(($6)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($5)>>2)];
      var $41=HEAP32[(($5)>>2)];
      var $42=HEAP32[(($6)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=HEAP32[(($1)>>2)];
      _memset($46, 0, $47, 1);
      var $48=HEAP32[(($result_i)>>2)];
      var $49=$1;
      var $50=$2;
      var $51=$3;
      var $52=$4;
      var $53=$result_i;
      var $54=$5;
      var $55=$6;
      var $56=$48;
      var $57=__ZN13resource_pool10add_objectI24_generic_machine_privateEEPT_S3_($13, $56);
      var $58=$7;
      var $59=(($58+656)|0);
      HEAP32[(($59)>>2)]=$57;
      var $60=$7;
      var $61=(($60+656)|0);
      var $62=HEAP32[(($61)>>2)];
      $state=$62;
      $counternum=0;
      __label__ = 8; break;
    case 8: // $63
      var $64=$counternum;
      var $65=(($64)|0) < 8;
      if ($65) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $66
      var $67=$counternum;
      var $68=$state;
      var $69=(($68+68)|0);
      var $70=(($69+($67<<2))|0);
      HEAP32[(($70)>>2)]=0;
      var $71=$counternum;
      var $72=$state;
      var $73=(($72+36)|0);
      var $74=(($73+($71<<2))|0);
      HEAP32[(($74)>>2)]=0;
      __label__ = 10; break;
    case 10: // $75
      var $76=$counternum;
      var $77=(($76+1)|0);
      $counternum=$77;
      __label__ = 8; break;
    case 11: // $78
      var $79=$state;
      var $80=(($79+104)|0);
      var $81=(($80)|0);
      var $82=$81;
      _memset($82, 0, 32, 1);
      HEAP32[(($exec)>>2)]=0;
      $index=0;
      var $83=$7;
      var $84=__ZNK15running_machine10devicelistEv($83);
      var $85=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($84, $exec);
      var $86=(($85)&1);
      $gotone=$86;
      __label__ = 12; break;
    case 12: // $87
      var $88=$gotone;
      var $89=(($88) & 1);
      if ($89) { __label__ = 13; break; } else { var $94 = 0;__label__ = 14; break; }
    case 13: // $90
      var $91=$index;
      var $92=(($91)>>>0) < 8;
      var $94 = $92;__label__ = 14; break;
    case 14: // $93
      var $94;
      if ($94) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $95
      var $96=HEAP32[(($exec)>>2)];
      var $97=$96;
      var $98=__ZN16device_interface6deviceEv($97);
      var $99=$index;
      var $100=(($99+1)|0);
      $index=$100;
      var $101=$state;
      var $102=(($101+104)|0);
      var $103=(($102+($99<<2))|0);
      HEAP32[(($103)>>2)]=$98;
      __label__ = 16; break;
    case 16: // $104
      var $105=HEAP32[(($exec)>>2)];
      var $106=$105;
      var $107=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($106, $exec);
      var $108=(($107)&1);
      $gotone=$108;
      __label__ = 12; break;
    case 17: // $109
      var $110=$7;
      var $111=__ZN15running_machine4saveEv($110);
      var $112=$state;
      var $113=(($112+4)|0);
      __ZN12save_manager9save_itemIA8_jEEvRT_PKci($111, $113, ((STRING_TABLE.__str13608)|0), 0);
      var $114=$7;
      var $115=__ZN15running_machine4saveEv($114);
      var $116=$state;
      var $117=(($116+36)|0);
      __ZN12save_manager9save_itemIA8_jEEvRT_PKci($115, $117, ((STRING_TABLE.__str23609)|0), 0);
      var $118=$7;
      var $119=__ZN15running_machine4saveEv($118);
      var $120=$state;
      var $121=(($120+68)|0);
      __ZN12save_manager9save_itemIA8_jEEvRT_PKci($119, $121, ((STRING_TABLE.__str33610)|0), 0);
      var $122=$state;
      var $123=(($122+100)|0);
      HEAP32[(($123)>>2)]=-1;
      var $124=$7;
      var $125=$7;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($8, 874, ((STRING_TABLE.__str43611)|0), $125);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($124, 1, $8);
      var $126=$7;
      var $127=__ZN15running_machine4saveEv($126);
      var $128=$state;
      var $129=(($128+136)|0);
      __ZN12save_manager9save_itemIA8_hEEvRT_PKci($127, $129, ((STRING_TABLE.__str53612)|0), 0);
      var $130=$7;
      var $131=$7;
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($9, 876, ((STRING_TABLE.__str73614)|0), $131);
      var $132=$7;
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($10, 878, ((STRING_TABLE.__str83615)|0), $132);
      __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($130, ((STRING_TABLE.__str63613)|0), $9, $10);
      var $133=$7;
      var $134=__ZNK15running_machine6configEv($133);
      var $135=(($134+36)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $138
      var $139=$7;
      var $140=__ZN15running_machine4saveEv($139);
      var $141=$state;
      var $142=(($141+100)|0);
      __ZN12save_manager9save_itemIiEEvRT_PKci($140, $142, ((STRING_TABLE.__str93616)|0), 0);
      var $143=$7;
      var $144=$7;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($11, 880, ((STRING_TABLE.__str103617)|0), $144);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($143, 4, $11);
      __label__ = 19; break;
    case 19: // $145
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20generic_machine_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI24_generic_machine_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24_generic_machine_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI24_generic_machine_privateEEPT_S3_["X"]=1;

function __Z21get_dispensed_ticketsR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  var $state;
  $1=$machine;
  var $2=$1;
  var $3=(($2+656)|0);
  var $4=HEAP32[(($3)>>2)];
  $state=$4;
  var $5=$state;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __Z22coin_counter_get_countR15running_machinei($machine, $num) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      $2=$machine;
      $3=$num;
      var $4=$2;
      var $5=(($4+656)|0);
      var $6=HEAP32[(($5)>>2)];
      $state=$6;
      var $7=$3;
      var $8=(($7)>>>0) >= 8;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=$3;
      var $12=$state;
      var $13=(($12+4)|0);
      var $14=(($13+($11<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z22coin_lockout_get_stateR15running_machinei($machine, $num) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      $2=$machine;
      $3=$num;
      var $4=$2;
      var $5=(($4+656)|0);
      var $6=HEAP32[(($5)>>2)];
      $state=$6;
      var $7=$3;
      var $8=(($7)>>>0) >= 8;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=$3;
      var $12=$state;
      var $13=(($12+36)|0);
      var $14=(($13+($11<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list5firstI22device_nvram_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI22device_nvram_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options15nvram_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str223629)|0));
  ;
  return $4;
}


function __ZN22device_nvram_interface10nvram_loadER8emu_file($this, $file) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$file;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+60)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  FUNCTION_TABLE[$7]($3, $8);
  ;
  return;
}


function __ZNK16device_interface4nextI22device_nvram_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI22device_nvram_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZN22device_nvram_interface11nvram_resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+56)|0);
  var $6=HEAP32[(($5)>>2)];
  FUNCTION_TABLE[$6]($2);
  ;
  return;
}


function __ZN22device_nvram_interface10nvram_saveER8emu_file($this, $file) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$file;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+64)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  FUNCTION_TABLE[$7]($3, $8);
  ;
  return;
}


function __ZL12memcard_nameiPc($index, $buffer) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  $1=$index;
  $2=$buffer;
  var $3=$2;
  var $4=$1;
  var $5=_sprintf($3, ((STRING_TABLE.__str213628)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$4,tempInt));
  STACKTOP = __stackBase__;
  return;
}


function __ZNK11emu_options17memcard_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str203627)|0));
  ;
  return $4;
}


function __Z13memcard_ejectR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 276; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $state;
      var $name=__stackBase__;
      var $file=__stackBase__+16;
      var $filerr;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      var $5=$1;
      var $6=(($5+656)|0);
      var $7=HEAP32[(($6)>>2)];
      $state=$7;
      var $8=$state;
      var $9=(($8+100)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==-1;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      __label__ = 14; break;
    case 2: // $13
      var $14=$state;
      var $15=(($14+100)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($name)|0);
      __ZL12memcard_nameiPc($16, $17);
      var $18=$1;
      var $19=__ZNK15running_machine7optionsEv($18);
      var $20=__ZNK11emu_options17memcard_directoryEv($19);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $20, 14);
      var $21=$1;
      var $22=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $23
      var $24=(($name)|0);
      var $25=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_S1_($file, $22, ((STRING_TABLE.__str123619)|0), $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $26
      $filerr=$25;
      var $27=$filerr;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $29
      $4=1;
      __label__ = 13; break;
    case 6: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $2=$32;
      var $33=$31.f1;
      $3=$33;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 7: // $34
      var $35=$1;
      var $36=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 6; break; };
    case 8: // $37
      var $38=(($36+36)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $41
      var $42=$1;
      var $43=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; };
    case 10: // $44
      var $45=(($43+36)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$46]($47, $file, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 6; break; }
    case 11: // $48
      __label__ = 12; break;
    case 12: // $49
      var $50=$state;
      var $51=(($50+100)|0);
      HEAP32[(($51)>>2)]=-1;
      $4=0;
      __label__ = 13; break;
    case 13: // $52
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $cleanup_dest=$4;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 14; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 14: // $53
      STACKTOP = __stackBase__;
      return;
    case 15: // $54
      __label__ = 16; break;
    case 16: // $55
      var $56=$2;
      var $57=$2;
      var $58=$3;
      var $59=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $57, tempValue);
      var $60=($59.f1 = $58, $59);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 18: // $63
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13memcard_ejectR15running_machine["X"]=1;

function __Z10nvram_loadR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 264; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $nvram=__stackBase__;
      var $file=__stackBase__+4;
      var $2;
      var $3;
      var $gotone;
      var $gotone1;
      $1=$machine;
      HEAP32[(($nvram)>>2)]=0;
      var $4=$1;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=__ZNK11device_list5firstI22device_nvram_interfaceEEbRPT_($5, $nvram);
      if ($6) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine6configEv($8);
      var $10=(($9+32)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      __label__ = 32; break;
    case 3: // $14
      var $15=$1;
      var $16=__ZNK15running_machine7optionsEv($15);
      var $17=__ZNK11emu_options15nvram_directoryEv($16);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $17, 1);
      var $18=$1;
      var $19=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 11; break; };
    case 4: // $20
      var $21=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $19, ((STRING_TABLE.__str113618)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $22
      var $23=(($21)|0)==0;
      if ($23) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $24
      var $25=$1;
      var $26=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $27
      var $28=(($26+32)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $31
      var $32=$1;
      var $33=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $34
      var $35=(($33+32)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$36]($37, $file, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      __label__ = 12; break;
    case 11: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $2=$41;
      var $42=$40.f1;
      $3=$42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 12: // $43
      var $44=HEAP32[(($nvram)>>2)];
      var $45=(($44)|0)!=0;
      var $46=(($45)&1);
      $gotone=$46;
      __label__ = 13; break;
    case 13: // $47
      var $48=$gotone;
      var $49=(($48) & 1);
      if ($49) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $50
      var $51=HEAP32[(($nvram)>>2)];
      (function() { try { __THREW__ = false; return __ZN22device_nvram_interface10nvram_loadER8emu_file($51, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; }
    case 15: // $52
      __label__ = 16; break;
    case 16: // $53
      var $54=HEAP32[(($nvram)>>2)];
      var $55=$54;
      var $56=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI22device_nvram_interfaceEEbRPT_($55, $nvram) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 11; break; };
    case 17: // $57
      var $58=(($56)&1);
      $gotone=$58;
      __label__ = 13; break;
    case 18: // $59
      __label__ = 31; break;
    case 19: // $60
      var $61=$1;
      var $62=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 11; break; };
    case 20: // $63
      var $64=(($62+32)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $67
      var $68=$1;
      var $69=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 11; break; };
    case 22: // $70
      var $71=(($69+32)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$72]($73, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 11; break; }
    case 23: // $74
      __label__ = 24; break;
    case 24: // $75
      var $76=HEAP32[(($nvram)>>2)];
      var $77=(($76)|0)!=0;
      var $78=(($77)&1);
      $gotone1=$78;
      __label__ = 25; break;
    case 25: // $79
      var $80=$gotone1;
      var $81=(($80) & 1);
      if ($81) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $82
      var $83=HEAP32[(($nvram)>>2)];
      (function() { try { __THREW__ = false; return __ZN22device_nvram_interface11nvram_resetEv($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 11; break; }
    case 27: // $84
      __label__ = 28; break;
    case 28: // $85
      var $86=HEAP32[(($nvram)>>2)];
      var $87=$86;
      var $88=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI22device_nvram_interfaceEEbRPT_($87, $nvram) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 11; break; };
    case 29: // $89
      var $90=(($88)&1);
      $gotone1=$90;
      __label__ = 25; break;
    case 30: // $91
      __label__ = 31; break;
    case 31: // $92
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 32; break;
    case 32: // $93
      STACKTOP = __stackBase__;
      return;
    case 33: // $94
      __label__ = 34; break;
    case 34: // $95
      var $96=$2;
      var $97=$2;
      var $98=$3;
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10nvram_loadR15running_machine["X"]=1;

function __Z10nvram_saveR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 264; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $nvram=__stackBase__;
      var $file=__stackBase__+4;
      var $2;
      var $3;
      var $gotone;
      $1=$machine;
      HEAP32[(($nvram)>>2)]=0;
      var $4=$1;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=__ZNK11device_list5firstI22device_nvram_interfaceEEbRPT_($5, $nvram);
      if ($6) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine6configEv($8);
      var $10=(($9+32)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      __label__ = 20; break;
    case 3: // $14
      var $15=$1;
      var $16=__ZNK15running_machine7optionsEv($15);
      var $17=__ZNK11emu_options15nvram_directoryEv($16);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $17, 14);
      var $18=$1;
      var $19=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 11; break; };
    case 4: // $20
      var $21=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $19, ((STRING_TABLE.__str113618)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $22
      var $23=(($21)|0)==0;
      if ($23) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $24
      var $25=$1;
      var $26=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $27
      var $28=(($26+32)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $31
      var $32=$1;
      var $33=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $34
      var $35=(($33+32)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$36]($37, $file, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      __label__ = 12; break;
    case 11: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $2=$41;
      var $42=$40.f1;
      $3=$42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 12: // $43
      var $44=HEAP32[(($nvram)>>2)];
      var $45=(($44)|0)!=0;
      var $46=(($45)&1);
      $gotone=$46;
      __label__ = 13; break;
    case 13: // $47
      var $48=$gotone;
      var $49=(($48) & 1);
      if ($49) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $50
      var $51=HEAP32[(($nvram)>>2)];
      (function() { try { __THREW__ = false; return __ZN22device_nvram_interface10nvram_saveER8emu_file($51, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; }
    case 15: // $52
      __label__ = 16; break;
    case 16: // $53
      var $54=HEAP32[(($nvram)>>2)];
      var $55=$54;
      var $56=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI22device_nvram_interfaceEEbRPT_($55, $nvram) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 11; break; };
    case 17: // $57
      var $58=(($56)&1);
      $gotone=$58;
      __label__ = 13; break;
    case 18: // $59
      __label__ = 19; break;
    case 19: // $60
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 20; break;
    case 20: // $61
      STACKTOP = __stackBase__;
      return;
    case 21: // $62
      __label__ = 22; break;
    case 22: // $63
      var $64=$2;
      var $65=$2;
      var $66=$3;
      var $67=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $65, tempValue);
      var $68=($67.f1 = $66, $67);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10nvram_saveR15running_machine["X"]=1;

function __Z14memcard_createR15running_machineii($machine, $index, $overwrite) {
  var __stackBase__  = STACKTOP; STACKTOP += 600; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $name=__stackBase__;
      var $fname=__stackBase__+16;
      var $testfile=__stackBase__+80;
      var $5;
      var $6;
      var $7;
      var $file=__stackBase__+340;
      var $filerr;
      $2=$machine;
      $3=$index;
      $4=$overwrite;
      var $8=$3;
      var $9=(($name)|0);
      __ZL12memcard_nameiPc($8, $9);
      var $10=$2;
      var $11=__ZNK15running_machine8basenameEv($10);
      var $12=(($name)|0);
      __ZN7astringC1EPKcS1_S1_($fname, $11, ((STRING_TABLE.__str123619)|0), $12);
      var $13=$4;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 15; break; } else { __label__ = 1; break; }
    case 1: // $15
      var $16=$2;
      var $17=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $18
      var $19=(function() { try { __THREW__ = false; return __ZNK11emu_options17memcard_directoryEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $20
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($testfile, $19, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $21
      var $22=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; };
    case 5: // $23
      var $24=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($testfile, $22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $25
      var $26=(($24)|0)==0;
      if ($26) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $27
      $1=1;
      $7=1;
      __label__ = 11; break;
    case 8: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $5=$30;
      var $31=$29.f1;
      $6=$31;
      __label__ = 33; break;
    case 9: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $5=$34;
      var $35=$33.f1;
      $6=$35;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($testfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 36; break; }
    case 10: // $36
      $7=0;
      __label__ = 11; break;
    case 11: // $37
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($testfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 12: // $38
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0) {
        __label__ = 13; break;
      }
      else {
      __label__ = 32; break;
      }
      
    case 13: // $39
      __label__ = 15; break;
    case 14: // $40
      __label__ = 33; break;
    case 15: // $41
      var $42=$2;
      var $43=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 8; break; };
    case 16: // $44
      var $45=(function() { try { __THREW__ = false; return __ZNK11emu_options17memcard_directoryEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; };
    case 17: // $46
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $45, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 8; break; }
    case 18: // $47
      var $48=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 22; break; };
    case 19: // $49
      var $50=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; };
    case 20: // $51
      $filerr=$50;
      var $52=$filerr;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $54
      $1=1;
      $7=1;
      __label__ = 29; break;
    case 22: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $5=$57;
      var $58=$56.f1;
      $6=$58;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 36; break; }
    case 23: // $59
      var $60=$2;
      var $61=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 22; break; };
    case 24: // $62
      var $63=(($61+36)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $66
      var $67=$2;
      var $68=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 22; break; };
    case 26: // $69
      var $70=(($68+36)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($72, $file, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 22; break; }
    case 27: // $73
      __label__ = 28; break;
    case 28: // $74
      $1=0;
      $7=1;
      __label__ = 29; break;
    case 29: // $75
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; }
    case 30: // $76
      __label__ = 32; break;
    case 31: // $77
      __label__ = 33; break;
    case 32: // $78
      FUNCTION_TABLE[__ZN7astringD1Ev]($fname);
      var $79=$1;
      STACKTOP = __stackBase__;
      return $79;
    case 33: // $80
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $81
      __label__ = 35; break;
    case 35: // $82
      var $83=$5;
      var $84=$5;
      var $85=$6;
      var $86=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $84, tempValue);
      var $87=($86.f1 = $85, $86);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 36: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14memcard_createR15running_machineii["X"]=1;

function __Z14memcard_insertR15running_machinei($machine, $index) {
  var __stackBase__  = STACKTOP; STACKTOP += 276; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      var $name=__stackBase__;
      var $file=__stackBase__+16;
      var $filerr;
      var $4;
      var $5;
      var $6;
      $2=$machine;
      $3=$index;
      var $7=$2;
      var $8=(($7+656)|0);
      var $9=HEAP32[(($8)>>2)];
      $state=$9;
      var $10=$state;
      var $11=(($10+100)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=-1;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$2;
      __Z13memcard_ejectR15running_machine($15);
      __label__ = 2; break;
    case 2: // $16
      __label__ = 3; break;
    case 3: // $17
      __label__ = 4; break;
    case 4: // $18
      var $19=$3;
      var $20=(($name)|0);
      __ZL12memcard_nameiPc($19, $20);
      var $21=$2;
      var $22=__ZNK15running_machine7optionsEv($21);
      var $23=__ZNK11emu_options17memcard_directoryEv($22);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $23, 1);
      var $24=$2;
      var $25=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $26
      var $27=(($name)|0);
      var $28=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_S1_($file, $25, ((STRING_TABLE.__str123619)|0), $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $29
      $filerr=$28;
      var $30=$filerr;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $32
      $1=1;
      $6=1;
      __label__ = 15; break;
    case 8: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $4=$35;
      var $36=$34.f1;
      $5=$36;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 9: // $37
      var $38=$2;
      var $39=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $40
      var $41=(($39+36)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $44
      var $45=$2;
      var $46=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; };
    case 12: // $47
      var $48=(($46+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$49]($50, $file, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; }
    case 13: // $51
      __label__ = 14; break;
    case 14: // $52
      var $53=$3;
      var $54=$state;
      var $55=(($54+100)|0);
      HEAP32[(($55)>>2)]=$53;
      $1=0;
      $6=1;
      __label__ = 15; break;
    case 15: // $56
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $57=$1;
      STACKTOP = __stackBase__;
      return $57;
    case 16: // $58
      __label__ = 17; break;
    case 17: // $59
      var $60=$4;
      var $61=$4;
      var $62=$5;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14memcard_insertR15running_machinei["X"]=1;

function __Z15memcard_presentR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  var $state;
  $1=$machine;
  var $2=$1;
  var $3=(($2+656)|0);
  var $4=HEAP32[(($3)>>2)];
  $state=$4;
  var $5=$state;
  var $6=(($5+100)|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __Z21device_set_input_lineP8device_tii($device, $line, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$device;
  $2=$line;
  $3=$state;
  var $4=$1;
  var $5=__Z14device_executeP8device_t($4);
  var $6=$2;
  var $7=$3;
  __ZN24device_execute_interface14set_input_lineEii($5, $6, $7);
  ;
  return;
}


function __ZNK8device_t4nextI22device_nvram_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI22device_nvram_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceI22device_nvram_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_nvram_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9save_itemIhLj8EEEvPKcS2_iRAT0__T_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=(($12)|0);
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 1, 8);
  ;
  return;
}


function __ZN12save_manager9save_itemIjLj8EEEvPKcS2_iRAT0__T_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=(($12)|0);
  var $14=$13;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $14, 4, 8);
  ;
  return;
}


function __ZN20resource_pool_objectI24_generic_machine_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI24_generic_machine_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI24_generic_machine_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 144);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI24_generic_machine_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI24_generic_machine_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI24_generic_machine_privateED2Ev($2);
  ;
  return;
}


function __Z11output_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+24;
  var $4=__stackBase__+48;
  $1=$machine;
  var $5=$1;
  var $6=$1;
  __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 882, ((STRING_TABLE.__str3642)|0), $6);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($5, 2, $2);
  var $7=$1;
  var $8=$1;
  __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($3, 884, ((STRING_TABLE.__str13643)|0), $8);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($7, 3, $3);
  var $9=$1;
  var $10=$1;
  __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($4, 886, ((STRING_TABLE.__str23644)|0), $10);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($9, 4, $4);
  _memset(__ZL9itemtable, 0, 212, 1);
  HEAP32[((__ZL17global_notifylist)>>2)]=0;
  STACKTOP = __stackBase__;
  return;
}


function __ZL12output_pauseR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  __Z16output_set_valuePKci(((STRING_TABLE.__str43646)|0), 1);
  ;
  return;
}


function __ZL13output_resumeR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  __Z16output_set_valuePKci(((STRING_TABLE.__str43646)|0), 0);
  ;
  return;
}


function __ZL11output_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $notify;
      var $item;
      var $hash;
      var $next;
      var $next_notify;
      var $next1;
      $1=$machine;
      $hash=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$hash;
      var $4=(($3)|0) < 53;
      if ($4) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $5
      var $6=$hash;
      var $7=((__ZL9itemtable+($6<<2))|0);
      var $8=HEAP32[(($7)>>2)];
      $item=$8;
      __label__ = 3; break;
    case 3: // $9
      var $10=$item;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $12
      var $13=$item;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      $next=$15;
      var $16=$item;
      var $17=(($16+20)|0);
      var $18=HEAP32[(($17)>>2)];
      $notify=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$notify;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $22
      var $23=$notify;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      $next_notify=$25;
      var $26=$notify;
      var $27=$26;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $27);
      var $28=$next_notify;
      $notify=$28;
      __label__ = 5; break;
    case 7: // $29
      var $30=$item;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $34
      var $35=$item;
      var $36=(($35+4)|0);
      var $37=HEAP32[(($36)>>2)];
      __ZN13resource_pool6removeEPKv(_global_resource_pool, $37);
      __label__ = 9; break;
    case 9: // $38
      var $39=$item;
      var $40=$39;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $40);
      var $41=$next;
      $item=$41;
      __label__ = 3; break;
    case 10: // $42
      __label__ = 11; break;
    case 11: // $43
      var $44=$hash;
      var $45=(($44+1)|0);
      $hash=$45;
      __label__ = 1; break;
    case 12: // $46
      var $47=HEAP32[((__ZL17global_notifylist)>>2)];
      $notify=$47;
      __label__ = 13; break;
    case 13: // $48
      var $49=$notify;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $51
      var $52=$notify;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      $next1=$54;
      var $55=$notify;
      var $56=$55;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $56);
      var $57=$next1;
      $notify=$57;
      __label__ = 13; break;
    case 15: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11output_exitR15running_machine["X"]=1;

function __Z16output_set_valuePKci($outname, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $item;
      var $notify;
      var $oldval;
      $1=$outname;
      $2=$value;
      var $3=$1;
      var $4=__ZL9find_itemPKc($3);
      $item=$4;
      var $5=$item;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=$2;
      var $10=__ZL15create_new_itemPKci($8, $9);
      $item=$10;
      var $11=$2;
      var $12=(($11+1)|0);
      $oldval=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=$item;
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      $oldval=$16;
      var $17=$2;
      var $18=$item;
      var $19=(($18+16)|0);
      HEAP32[(($19)>>2)]=$17;
      __label__ = 3; break;
    case 3: // $20
      var $21=$oldval;
      var $22=$2;
      var $23=(($21)|0)!=(($22)|0);
      if ($23) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $24
      var $25=$item;
      var $26=(($25+20)|0);
      var $27=HEAP32[(($26)>>2)];
      $notify=$27;
      __label__ = 5; break;
    case 5: // $28
      var $29=$notify;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $31
      var $32=$notify;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$1;
      var $36=$2;
      var $37=$notify;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      FUNCTION_TABLE[$34]($35, $36, $39);
      __label__ = 7; break;
    case 7: // $40
      var $41=$notify;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      $notify=$43;
      __label__ = 5; break;
    case 8: // $44
      var $45=HEAP32[((__ZL17global_notifylist)>>2)];
      $notify=$45;
      __label__ = 9; break;
    case 9: // $46
      var $47=$notify;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $49
      var $50=$notify;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$1;
      var $54=$2;
      var $55=$notify;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      FUNCTION_TABLE[$52]($53, $54, $57);
      __label__ = 11; break;
    case 11: // $58
      var $59=$notify;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      $notify=$61;
      __label__ = 9; break;
    case 12: // $62
      __label__ = 13; break;
    case 13: // $63
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16output_set_valuePKci["X"]=1;

function __ZL9find_itemPKc($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hash;
      var $item;
      $2=$string;
      var $3=$2;
      var $4=__ZL8get_hashPKc($3);
      $hash=$4;
      var $5=$hash;
      var $6=(($5)>>>0)%53;
      var $7=((__ZL9itemtable+($6<<2))|0);
      var $8=HEAP32[(($7)>>2)];
      $item=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$item;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $12
      var $13=$item;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$hash;
      var $17=(($15)|0)==(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      var $19=$2;
      var $20=$item;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=_strcmp($19, $22);
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      var $26=$item;
      $1=$26;
      __label__ = 8; break;
    case 5: // $27
      __label__ = 6; break;
    case 6: // $28
      var $29=$item;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      $item=$31;
      __label__ = 1; break;
    case 7: // $32
      $1=0;
      __label__ = 8; break;
    case 8: // $33
      var $34=$1;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16output_get_valuePKc($outname) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $item;
      $2=$outname;
      var $3=$2;
      var $4=__ZL9find_itemPKc($3);
      $item=$4;
      var $5=$item;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 3; break;
    case 2: // $8
      var $9=$item;
      var $10=(($9+16)|0);
      var $11=HEAP32[(($10)>>2)];
      $1=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8get_hashPKc($string) {
  ;
  var __label__;

  var $1;
  $1=$string;
  var $2=$1;
  var $3=$1;
  var $4=_strlen($3);
  var $5=_crc32(0, $2, $4);
  ;
  return $5;
}


function __ZN20resource_pool_objectI24_generic_machine_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24_generic_machine_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI24_generic_machine_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI24_generic_machine_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI24_generic_machine_privateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15create_new_itemPKci($outname, $value) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $item;
      var $hash;
      $6=$outname;
      $7=$value;
      var $8=$1;
      var $9=$2;
      var $10=$3;
      var $11=$result_i;
      var $12=$4;
      var $13=$5;
      HEAP32[(($1)>>2)]=24;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str33645)|0);
      HEAP32[(($3)>>2)]=121;
      var $14=HEAP32[(($1)>>2)];
      var $15=HEAP32[(($2)>>2)];
      var $16=HEAP32[(($3)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($14, $15, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($4)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($5)>>2)]=$27;
      var $28=HEAP32[(($5)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($4)>>2)];
      var $34=HEAP32[(($4)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$1;
      var $41=$2;
      var $42=$3;
      var $43=$result_i;
      var $44=$4;
      var $45=$5;
      var $46=$39;
      var $47=__ZN13resource_pool10add_objectI12_output_itemEEPT_S3_(_global_resource_pool, $46);
      $item=$47;
      var $48=$6;
      var $49=__ZL8get_hashPKc($48);
      $hash=$49;
      var $50=$hash;
      var $51=(($50)>>>0)%53;
      var $52=((__ZL9itemtable+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$item;
      var $55=(($54)|0);
      HEAP32[(($55)>>2)]=$53;
      var $56=$6;
      var $57=__ZL11copy_stringPKc($56);
      var $58=$item;
      var $59=(($58+4)|0);
      HEAP32[(($59)>>2)]=$57;
      var $60=$hash;
      var $61=$item;
      var $62=(($61+8)|0);
      HEAP32[(($62)>>2)]=$60;
      var $63=HEAP32[((__ZL8uniqueid)>>2)];
      var $64=(($63+1)|0);
      HEAP32[((__ZL8uniqueid)>>2)]=$64;
      var $65=$item;
      var $66=(($65+12)|0);
      HEAP32[(($66)>>2)]=$63;
      var $67=$7;
      var $68=$item;
      var $69=(($68+16)|0);
      HEAP32[(($69)>>2)]=$67;
      var $70=$item;
      var $71=(($70+20)|0);
      HEAP32[(($71)>>2)]=0;
      var $72=$item;
      var $73=$hash;
      var $74=(($73)>>>0)%53;
      var $75=((__ZL9itemtable+($74<<2))|0);
      HEAP32[(($75)>>2)]=$72;
      var $76=$item;
      STACKTOP = __stackBase__;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15create_new_itemPKci["X"]=1;

function __ZN13resource_pool10add_objectI12_output_itemEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12_output_itemEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12_output_itemEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI12_output_itemEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12_output_itemEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12_output_itemEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 24);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12_output_itemE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12_output_itemED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12_output_itemED2Ev($2);
  ;
  return;
}


function __ZL12palette_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=$1;
      var $3=(($2+564)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+564)|0);
      var $9=HEAP32[(($8)>>2)];
      __Z13palette_derefP10_palette_t($9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11copy_stringPKc($string) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $newstring;
      $6=$string;
      var $7=$6;
      var $8=_strlen($7);
      var $9=(($8+1)|0);
      var $10=$1;
      var $11=$2;
      var $12=$3;
      var $13=$result_i;
      var $14=$4;
      var $15=$5;
      HEAP32[(($1)>>2)]=$9;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str33645)|0);
      HEAP32[(($3)>>2)]=81;
      var $16=HEAP32[(($1)>>2)];
      var $17=HEAP32[(($2)>>2)];
      var $18=HEAP32[(($3)>>2)];
      var $19=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($16, $17, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $20
      HEAP32[(($result_i)>>2)]=$19;
      var $21=HEAP32[(($result_i)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $23
      var $24=___cxa_allocate_exception(4);
      var $25=$24;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($25);
      (function() { try { __THREW__ = false; return ___cxa_throw($24, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($4)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($5)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30)|0) < 0;
      if ($31) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $32
      var $33=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($33);
      throw "Reached an unreachable!"
    case 5: // $34
      var $35=HEAP32[(($4)>>2)];
      var $36=HEAP32[(($4)>>2)];
      var $37=HEAP32[(($5)>>2)];
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $40
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKci_exit
      var $41=HEAP32[(($result_i)>>2)];
      var $42=$1;
      var $43=$2;
      var $44=$3;
      var $45=$result_i;
      var $46=$4;
      var $47=$5;
      var $48=$6;
      var $49=_strlen($48);
      var $50=(($49+1)|0);
      var $51=__ZN13resource_pool9add_arrayIcEEPT_S2_i(_global_resource_pool, $41, $50);
      $newstring=$51;
      var $52=$newstring;
      var $53=$6;
      var $54=_strcpy($52, $53);
      var $55=$newstring;
      STACKTOP = __stackBase__;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11copy_stringPKc["X"]=1;

function __ZN20resource_pool_objectI12_output_itemED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12_output_itemED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12_output_itemED0Ev["X"]=1;

function __ZN20resource_pool_objectI12_output_itemED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI12_output_itemE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z12palette_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 148; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i2=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i1=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $result_i=__stackBase__+64;
      var $15=__stackBase__+68;
      var $16=__stackBase__+72;
      var $17;
      var $palette;
      var $device;
      var $format;
      var $18=__stackBase__+76;
      var $numcolors;
      var $19=__stackBase__+100;
      var $20=__stackBase__+124;
      $17=$machine;
      var $21=$17;
      var $22=__ZN15running_machine7respoolEv($21);
      var $23=$11;
      var $24=$12;
      var $25=$13;
      var $26=$14;
      var $27=$result_i;
      var $28=$15;
      var $29=$16;
      HEAP32[(($11)>>2)]=76;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str3651)|0);
      HEAP32[(($13)>>2)]=106;
      HEAP32[(($14)>>2)]=_zeromem;
      var $30=HEAP32[(($11)>>2)];
      var $31=HEAP32[(($12)>>2)];
      var $32=HEAP32[(($13)>>2)];
      var $33=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($30, $31, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $34
      HEAP32[(($result_i)>>2)]=$33;
      var $35=HEAP32[(($result_i)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $37
      var $38=___cxa_allocate_exception(4);
      var $39=$38;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39);
      (function() { try { __THREW__ = false; return ___cxa_throw($38, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      HEAP32[(($15)>>2)]=$42;
      var $43=$41.f1;
      HEAP32[(($16)>>2)]=$43;
      var $44=HEAP32[(($16)>>2)];
      var $45=(($44)|0) < 0;
      if ($45) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $46
      var $47=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($47);
      throw "Reached an unreachable!"
    case 5: // $48
      var $49=HEAP32[(($15)>>2)];
      var $50=HEAP32[(($15)>>2)];
      var $51=HEAP32[(($16)>>2)];
      var $52=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $50, tempValue);
      var $53=($52.f1 = $51, $52);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $54
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $55=HEAP32[(($result_i)>>2)];
      var $56=HEAP32[(($11)>>2)];
      _memset($55, 0, $56, 1);
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$11;
      var $59=$12;
      var $60=$13;
      var $61=$14;
      var $62=$result_i;
      var $63=$15;
      var $64=$16;
      var $65=$57;
      var $66=__ZN13resource_pool10add_objectI16_palette_privateEEPT_S3_($22, $65);
      $palette=$66;
      var $67=$17;
      var $68=__ZNK15running_machine12first_screenEv($67);
      $device=$68;
      var $69=$device;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $71
      var $72=$device;
      var $73=__ZNK13screen_device6formatEv($72);
      var $76 = $73;__label__ = 10; break;
    case 9: // $74
      var $76 = 0;__label__ = 10; break;
    case 10: // $75
      var $76;
      $format=$76;
      var $77=$palette;
      var $78=$17;
      var $79=(($78+628)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$17;
      var $81=$17;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($18, 888, ((STRING_TABLE.__str13652)|0), $81);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($80, 4, $18);
      var $82=$format;
      var $83=$palette;
      var $84=(($83)|0);
      HEAP32[(($84)>>2)]=$82;
      var $85=$format;
      if ($85 == 2 || $85 == 5 || $85 == 6) {
        __label__ = 11; break;
      }
      else if ($85 == 0) {
        __label__ = 12; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 11: // $86
      __label__ = 16; break;
    case 12: // $87
      __label__ = 13; break;
    case 13: // $88
      __label__ = 14; break;
    case 14: // $89
      __label__ = 32; break;
    case 15: // $90
      __Z10fatalerrorPKcz(((STRING_TABLE.__str23653)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 16: // $91
      var $92=$17;
      var $93=__ZNK15running_machine12total_colorsEv($92);
      var $94=(($93)>>>0) > 0;
      if ($94) { __label__ = 17; break; } else { __label__ = 32; break; }
    case 17: // $95
      var $96=$17;
      var $97=$palette;
      __ZL16allocate_paletteR15running_machineP16_palette_private($96, $97);
      var $98=$17;
      var $99=$palette;
      __ZL21allocate_color_tablesR15running_machineP16_palette_private($98, $99);
      var $100=$17;
      var $101=$palette;
      __ZL22allocate_shadow_tablesR15running_machineP16_palette_private($100, $101);
      var $102=$17;
      var $103=(($102+564)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=__Z22palette_get_num_colorsP10_palette_t($104);
      $numcolors=$105;
      var $106=$17;
      var $107=__ZN15running_machine7respoolEv($106);
      var $108=$numcolors;
      var $109=_llvm_umul_with_overflow_i32($108, 4);
      var $110=$109.f1;
      var $111=$109.f0;
      var $112=$110 ? -1 : $111;
      var $113=$6;
      var $114=$7;
      var $115=$8;
      var $116=$result_i1;
      var $117=$9;
      var $118=$10;
      HEAP32[(($6)>>2)]=$112;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str3651)|0);
      HEAP32[(($8)>>2)]=149;
      var $119=HEAP32[(($6)>>2)];
      var $120=HEAP32[(($7)>>2)];
      var $121=HEAP32[(($8)>>2)];
      var $122=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($119, $120, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $123
      HEAP32[(($result_i1)>>2)]=$122;
      var $124=HEAP32[(($result_i1)>>2)];
      var $125=(($124)|0)==0;
      if ($125) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $126
      var $127=___cxa_allocate_exception(4);
      var $128=$127;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($128);
      (function() { try { __THREW__ = false; return ___cxa_throw($127, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 20; break; }
    case 20: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      HEAP32[(($9)>>2)]=$131;
      var $132=$130.f1;
      HEAP32[(($10)>>2)]=$132;
      var $133=HEAP32[(($10)>>2)];
      var $134=(($133)|0) < 0;
      if ($134) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $135
      var $136=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($136);
      throw "Reached an unreachable!"
    case 22: // $137
      var $138=HEAP32[(($9)>>2)];
      var $139=HEAP32[(($9)>>2)];
      var $140=HEAP32[(($10)>>2)];
      var $141=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $139, tempValue);
      var $142=($141.f1 = $140, $141);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $143
      throw "Reached an unreachable!"
    case 24: // $_ZnajPKci_exit
      var $144=HEAP32[(($result_i1)>>2)];
      var $145=$6;
      var $146=$7;
      var $147=$8;
      var $148=$result_i1;
      var $149=$9;
      var $150=$10;
      var $151=$144;
      var $152=$numcolors;
      var $153=__ZN13resource_pool9add_arrayIjEEPT_S2_i($107, $151, $152);
      var $154=$palette;
      var $155=(($154+68)|0);
      HEAP32[(($155)>>2)]=$153;
      var $156=$17;
      var $157=__ZN15running_machine7respoolEv($156);
      var $158=$numcolors;
      var $159=_llvm_umul_with_overflow_i32($158, 4);
      var $160=$159.f1;
      var $161=$159.f0;
      var $162=$160 ? -1 : $161;
      var $163=$1;
      var $164=$2;
      var $165=$3;
      var $166=$result_i2;
      var $167=$4;
      var $168=$5;
      HEAP32[(($1)>>2)]=$162;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3651)|0);
      HEAP32[(($3)>>2)]=150;
      var $169=HEAP32[(($1)>>2)];
      var $170=HEAP32[(($2)>>2)];
      var $171=HEAP32[(($3)>>2)];
      var $172=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($169, $170, $171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 27; break; };
    case 25: // $173
      HEAP32[(($result_i2)>>2)]=$172;
      var $174=HEAP32[(($result_i2)>>2)];
      var $175=(($174)|0)==0;
      if ($175) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $176
      var $177=___cxa_allocate_exception(4);
      var $178=$177;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($178);
      (function() { try { __THREW__ = false; return ___cxa_throw($177, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 27; break; }
    case 27: // $179
      var $180=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $181=$180.f0;
      HEAP32[(($4)>>2)]=$181;
      var $182=$180.f1;
      HEAP32[(($5)>>2)]=$182;
      var $183=HEAP32[(($5)>>2)];
      var $184=(($183)|0) < 0;
      if ($184) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $185
      var $186=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($186);
      throw "Reached an unreachable!"
    case 29: // $187
      var $188=HEAP32[(($4)>>2)];
      var $189=HEAP32[(($4)>>2)];
      var $190=HEAP32[(($5)>>2)];
      var $191=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $189, tempValue);
      var $192=($191.f1 = $190, $191);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $193
      throw "Reached an unreachable!"
    case 31: // $_ZnajPKci_exit3
      var $194=HEAP32[(($result_i2)>>2)];
      var $195=$1;
      var $196=$2;
      var $197=$3;
      var $198=$result_i2;
      var $199=$4;
      var $200=$5;
      var $201=$194;
      var $202=$numcolors;
      var $203=__ZN13resource_pool9add_arrayIfEEPT_S2_i($157, $201, $202);
      var $204=$palette;
      var $205=(($204+72)|0);
      HEAP32[(($205)>>2)]=$203;
      var $206=$17;
      var $207=__ZN15running_machine4saveEv($206);
      var $208=$palette;
      var $209=(($208+68)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$numcolors;
      __ZN12save_manager12save_pointerIjEEvPT_PKcji($207, $210, ((STRING_TABLE.__str33654)|0), $211, 0);
      var $212=$17;
      var $213=__ZN15running_machine4saveEv($212);
      var $214=$palette;
      var $215=(($214+72)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=$numcolors;
      __ZN12save_manager12save_pointerIfEEvPT_PKcji($213, $216, ((STRING_TABLE.__str43655)|0), $217, 0);
      var $218=$17;
      var $219=__ZN15running_machine4saveEv($218);
      var $220=$17;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($19, 890, ((STRING_TABLE.__str53656)|0), $220);
      __ZN12save_manager16register_presaveE8delegateIFvvEE($219, $19);
      var $221=$17;
      var $222=__ZN15running_machine4saveEv($221);
      var $223=$17;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($20, 892, ((STRING_TABLE.__str63657)|0), $223);
      __ZN12save_manager17register_postloadE8delegateIFvvEE($222, $20);
      __label__ = 32; break;
    case 32: // $224
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12palette_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI16_palette_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16_palette_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16_palette_privateEEPT_S3_["X"]=1;

function __ZL16allocate_paletteR15running_machineP16_palette_private($machine, $palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $numgroups;
      var $index;
      var $3;
      var $4;
      $1=$machine;
      $2=$palette;
      $numgroups=1;
      var $5=$1;
      var $6=__ZNK15running_machine6configEv($5);
      var $7=(($6+40)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8 & 16;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$numgroups;
      var $13=(($12+1)|0);
      $numgroups=$13;
      var $14=$2;
      var $15=(($14+4)|0);
      HEAP32[(($15)>>2)]=$12;
      __label__ = 2; break;
    case 2: // $16
      var $17=$1;
      var $18=__ZNK15running_machine6configEv($17);
      var $19=(($18+40)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20 & 32;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$numgroups;
      var $25=(($24+1)|0);
      $numgroups=$25;
      var $26=$2;
      var $27=(($26+8)|0);
      HEAP32[(($27)>>2)]=$24;
      __label__ = 4; break;
    case 4: // $28
      __label__ = 5; break;
    case 5: // $29
      var $30=$1;
      var $31=__ZNK15running_machine12total_colorsEv($30);
      var $32=$numgroups;
      var $33=(($31*$32)|0);
      var $34=(($33)>>>0) <= 65536;
      if ($34) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $35
      var $36=___cxa_allocate_exception(1032);
      var $37=$36;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($37, ((STRING_TABLE.__str103661)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str113662)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str3651)|0),HEAP32[((tempInt+8)>>2)]=594,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      ___cxa_throw($36, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 8: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $3=$41;
      var $42=$40.f1;
      $4=$42;
      ___cxa_free_exception($36);
      __label__ = 35; break;
    case 9: // $43
      __label__ = 10; break;
    case 10: // $44
      var $45=$1;
      var $46=__ZNK15running_machine12total_colorsEv($45);
      var $47=$numgroups;
      var $48=__Z13palette_allocjj($46, $47);
      var $49=$1;
      var $50=(($49+564)|0);
      HEAP32[(($50)>>2)]=$48;
      __label__ = 11; break;
    case 11: // $51
      var $52=$1;
      var $53=(($52+564)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $56
      var $57=___cxa_allocate_exception(1032);
      var $58=$57;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($58, ((STRING_TABLE.__str103661)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str123663)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str3651)|0),HEAP32[((tempInt+8)>>2)]=598,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $59
      ___cxa_throw($57, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 14: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $3=$62;
      var $63=$61.f1;
      $4=$63;
      ___cxa_free_exception($57);
      __label__ = 35; break;
    case 15: // $64
      __label__ = 16; break;
    case 16: // $65
      var $66=$2;
      var $67=(($66+4)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $70
      var $71=$1;
      var $72=(($71+564)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$2;
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      __Z26palette_group_set_contrastP10_palette_tjf($73, $76, 0.6000000238418579);
      __label__ = 18; break;
    case 18: // $77
      var $78=$2;
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $82
      var $83=$1;
      var $84=(($83+564)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$2;
      var $87=(($86+8)|0);
      var $88=HEAP32[(($87)>>2)];
      __Z26palette_group_set_contrastP10_palette_tjf($85, $88, 1.6666666269302368);
      __label__ = 20; break;
    case 20: // $89
      $index=0;
      __label__ = 21; break;
    case 21: // $90
      var $91=$index;
      var $92=$1;
      var $93=__ZNK15running_machine12total_colorsEv($92);
      var $94=(($91)>>>0) < (($93)>>>0);
      if ($94) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $95
      var $96=$1;
      var $97=(($96+564)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$index;
      var $100=$index;
      var $101=$100 >> 0;
      var $102=(($101) & 255);
      var $103=__ZL7pal1bith($102);
      var $104=(($103)&255);
      var $105=$104 & 255;
      var $106=$105 << 16;
      var $107=-16777216 | $106;
      var $108=$index;
      var $109=$108 >> 1;
      var $110=(($109) & 255);
      var $111=__ZL7pal1bith($110);
      var $112=(($111)&255);
      var $113=$112 & 255;
      var $114=$113 << 8;
      var $115=$107 | $114;
      var $116=$index;
      var $117=$116 >> 2;
      var $118=(($117) & 255);
      var $119=__ZL7pal1bith($118);
      var $120=(($119)&255);
      var $121=$120 & 255;
      var $122=$115 | $121;
      __Z23palette_entry_set_colorP10_palette_tjj($98, $99, $122);
      __label__ = 23; break;
    case 23: // $123
      var $124=$index;
      var $125=(($124+1)|0);
      $index=$125;
      __label__ = 21; break;
    case 24: // $126
      var $127=$2;
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      if ($129 == 2) {
        __label__ = 25; break;
      }
      else if ($129 == 5) {
        __label__ = 30; break;
      }
      else if ($129 == 6) {
        __label__ = 31; break;
      }
      else if ($129 == 0) {
        __label__ = 32; break;
      }
      else {
      __label__ = 33; break;
      }
      
    case 25: // $130
      var $131=$1;
      var $132=(($131+564)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=__Z23palette_get_black_entryP10_palette_t($133);
      var $135=$2;
      var $136=(($135+12)|0);
      HEAP32[(($136)>>2)]=$134;
      var $137=$1;
      var $138=(($137+564)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=__Z23palette_get_white_entryP10_palette_t($139);
      var $141=$2;
      var $142=(($141+16)|0);
      HEAP32[(($142)>>2)]=$140;
      var $143=$2;
      var $144=(($143+12)|0);
      var $145=HEAPU32[(($144)>>2)];
      var $146=(($145)>>>0) >= 65536;
      if ($146) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $147
      var $148=$2;
      var $149=(($148+12)|0);
      HEAP32[(($149)>>2)]=0;
      __label__ = 27; break;
    case 27: // $150
      var $151=$2;
      var $152=(($151+16)|0);
      var $153=HEAPU32[(($152)>>2)];
      var $154=(($153)>>>0) >= 65536;
      if ($154) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $155
      var $156=$2;
      var $157=(($156+16)|0);
      HEAP32[(($157)>>2)]=65536;
      __label__ = 29; break;
    case 29: // $158
      __label__ = 34; break;
    case 30: // $159
      var $160=__ZL12rgb_to_rgb15j3667(-16777216);
      var $161=(($160)&65535);
      var $162=$2;
      var $163=(($162+12)|0);
      HEAP32[(($163)>>2)]=$161;
      var $164=__ZL12rgb_to_rgb15j3667(-1);
      var $165=(($164)&65535);
      var $166=$2;
      var $167=(($166+16)|0);
      HEAP32[(($167)>>2)]=$165;
      __label__ = 34; break;
    case 31: // $168
      var $169=$2;
      var $170=(($169+12)|0);
      HEAP32[(($170)>>2)]=-16777216;
      var $171=$2;
      var $172=(($171+16)|0);
      HEAP32[(($172)>>2)]=-1;
      __label__ = 34; break;
    case 32: // $173
      __label__ = 33; break;
    case 33: // $174
      __label__ = 34; break;
    case 34: // $175
      ;
      return;
    case 35: // $176
      var $177=$3;
      var $178=$3;
      var $179=$4;
      var $180=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $178, tempValue);
      var $181=($180.f1 = $179, $180);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16allocate_paletteR15running_machineP16_palette_private["X"]=1;

function __ZL21allocate_color_tablesR15running_machineP16_palette_private($machine, $palette) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $total_colors;
      var $pentable;
      var $i;
      $6=$machine;
      $7=$palette;
      var $8=$6;
      var $9=(($8+564)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__Z22palette_get_num_colorsP10_palette_t($10);
      var $12=$6;
      var $13=(($12+564)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z22palette_get_num_groupsP10_palette_t($14);
      var $16=(($11*$15)|0);
      $total_colors=$16;
      var $17=$7;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      if ($19 == 2) {
        __label__ = 1; break;
      }
      else if ($19 == 5) {
        __label__ = 13; break;
      }
      else if ($19 == 6) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 1: // $20
      var $21=$6;
      var $22=__ZN15running_machine7respoolEv($21);
      var $23=$total_colors;
      var $24=(($23+2)|0);
      var $25=_llvm_umul_with_overflow_i32($24, 4);
      var $26=$25.f1;
      var $27=$25.f0;
      var $28=$26 ? -1 : $27;
      var $29=$1;
      var $30=$2;
      var $31=$3;
      var $32=$result_i;
      var $33=$4;
      var $34=$5;
      HEAP32[(($1)>>2)]=$28;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3651)|0);
      HEAP32[(($3)>>2)]=659;
      var $35=HEAP32[(($1)>>2)];
      var $36=HEAP32[(($2)>>2)];
      var $37=HEAP32[(($3)>>2)];
      var $38=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($35, $36, $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $39
      HEAP32[(($result_i)>>2)]=$38;
      var $40=HEAP32[(($result_i)>>2)];
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $42
      var $43=___cxa_allocate_exception(4);
      var $44=$43;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($44);
      (function() { try { __THREW__ = false; return ___cxa_throw($43, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      HEAP32[(($4)>>2)]=$47;
      var $48=$46.f1;
      HEAP32[(($5)>>2)]=$48;
      var $49=HEAP32[(($5)>>2)];
      var $50=(($49)|0) < 0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($52);
      throw "Reached an unreachable!"
    case 6: // $53
      var $54=HEAP32[(($4)>>2)];
      var $55=HEAP32[(($4)>>2)];
      var $56=HEAP32[(($5)>>2)];
      var $57=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $55, tempValue);
      var $58=($57.f1 = $56, $57);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $59
      throw "Reached an unreachable!"
    case 8: // $_ZnajPKci_exit
      var $60=HEAP32[(($result_i)>>2)];
      var $61=$1;
      var $62=$2;
      var $63=$3;
      var $64=$result_i;
      var $65=$4;
      var $66=$5;
      var $67=$60;
      var $68=$total_colors;
      var $69=(($68+2)|0);
      var $70=__ZN13resource_pool9add_arrayIjEEPT_S2_i($22, $67, $69);
      $pentable=$70;
      var $71=$6;
      var $72=(($71+568)|0);
      HEAP32[(($72)>>2)]=$70;
      $i=0;
      __label__ = 9; break;
    case 9: // $73
      var $74=$i;
      var $75=$total_colors;
      var $76=(($75+2)|0);
      var $77=(($74)|0) < (($76)|0);
      if ($77) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $78
      var $79=$i;
      var $80=$i;
      var $81=$pentable;
      var $82=(($81+($80<<2))|0);
      HEAP32[(($82)>>2)]=$79;
      __label__ = 11; break;
    case 11: // $83
      var $84=$i;
      var $85=(($84+1)|0);
      $i=$85;
      __label__ = 9; break;
    case 12: // $86
      __label__ = 16; break;
    case 13: // $87
      var $88=$6;
      var $89=(($88+564)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=__Z33palette_entry_list_adjusted_rgb15P10_palette_t($90);
      var $92=$6;
      var $93=(($92+568)|0);
      HEAP32[(($93)>>2)]=$91;
      __label__ = 16; break;
    case 14: // $94
      var $95=$6;
      var $96=(($95+564)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=__Z27palette_entry_list_adjustedP10_palette_t($97);
      var $99=$6;
      var $100=(($99+568)|0);
      HEAP32[(($100)>>2)]=$98;
      __label__ = 16; break;
    case 15: // $101
      var $102=$6;
      var $103=(($102+568)|0);
      HEAP32[(($103)>>2)]=0;
      __label__ = 16; break;
    case 16: // $104
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21allocate_color_tablesR15running_machineP16_palette_private["X"]=1;

function __ZL22allocate_shadow_tablesR15running_machineP16_palette_private($machine, $palette) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i3=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $12;
      var $table;
      var $i;
      var $table1;
      var $i2;
      $11=$machine;
      $12=$palette;
      var $13=$11;
      var $14=__ZNK15running_machine6configEv($13);
      var $15=(($14+40)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 16;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 19; break; }
    case 1: // $19
      var $20=$11;
      var $21=__ZN15running_machine7respoolEv($20);
      var $22=$6;
      var $23=$7;
      var $24=$8;
      var $25=$result_i;
      var $26=$9;
      var $27=$10;
      HEAP32[(($6)>>2)]=262144;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str3651)|0);
      HEAP32[(($8)>>2)]=689;
      var $28=HEAP32[(($6)>>2)];
      var $29=HEAP32[(($7)>>2)];
      var $30=HEAP32[(($8)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($9)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($10)>>2)]=$41;
      var $42=HEAP32[(($10)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 6: // $46
      var $47=HEAP32[(($9)>>2)];
      var $48=HEAP32[(($9)>>2)];
      var $49=HEAP32[(($10)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $52
      throw "Reached an unreachable!"
    case 8: // $_ZnajPKci_exit
      var $53=HEAP32[(($result_i)>>2)];
      var $54=$6;
      var $55=$7;
      var $56=$8;
      var $57=$result_i;
      var $58=$9;
      var $59=$10;
      var $60=$53;
      var $61=__ZN13resource_pool9add_arrayIjEEPT_S2_i($21, $60, 65536);
      $table=$61;
      var $62=$12;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)==2;
      if ($65) { __label__ = 9; break; } else { __label__ = 17; break; }
    case 9: // $66
      var $67=$table;
      var $68=$12;
      var $69=(($68+20)|0);
      var $70=(($69+24)|0);
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=$67;
      var $72=$12;
      var $73=(($72+20)|0);
      var $74=(($73)|0);
      var $75=(($74)|0);
      HEAP32[(($75)>>2)]=$67;
      $i=0;
      __label__ = 10; break;
    case 10: // $76
      var $77=$i;
      var $78=(($77)|0) < 65536;
      if ($78) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $79
      var $80=$i;
      var $81=$11;
      var $82=__ZNK15running_machine12total_colorsEv($81);
      var $83=(($80)>>>0) < (($82)>>>0);
      if ($83) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $84
      var $85=$i;
      var $86=$11;
      var $87=__ZNK15running_machine12total_colorsEv($86);
      var $88=(($85+$87)|0);
      var $92 = $88;__label__ = 14; break;
    case 13: // $89
      var $90=$i;
      var $92 = $90;__label__ = 14; break;
    case 14: // $91
      var $92;
      var $93=$i;
      var $94=$table;
      var $95=(($94+($93<<2))|0);
      HEAP32[(($95)>>2)]=$92;
      __label__ = 15; break;
    case 15: // $96
      var $97=$i;
      var $98=(($97+1)|0);
      $i=$98;
      __label__ = 10; break;
    case 16: // $99
      __label__ = 18; break;
    case 17: // $100
      var $101=$table;
      var $102=$12;
      var $103=(($102+20)|0);
      var $104=(($103)|0);
      var $105=(($104)|0);
      HEAP32[(($105)>>2)]=$101;
      var $106=$table;
      var $107=(($106+131072)|0);
      var $108=$12;
      var $109=(($108+20)|0);
      var $110=(($109+24)|0);
      var $111=(($110)|0);
      HEAP32[(($111)>>2)]=$107;
      var $112=$11;
      __ZL21configure_rgb_shadowsR15running_machineif($112, 0, 0.6000000238418579);
      __label__ = 18; break;
    case 18: // $113
      __label__ = 19; break;
    case 19: // $114
      var $115=$11;
      var $116=__ZNK15running_machine6configEv($115);
      var $117=(($116+40)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$118 & 32;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 20; break; } else { __label__ = 38; break; }
    case 20: // $121
      var $122=$11;
      var $123=__ZN15running_machine7respoolEv($122);
      var $124=$1;
      var $125=$2;
      var $126=$3;
      var $127=$result_i3;
      var $128=$4;
      var $129=$5;
      HEAP32[(($1)>>2)]=262144;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3651)|0);
      HEAP32[(($3)>>2)]=712;
      var $130=HEAP32[(($1)>>2)];
      var $131=HEAP32[(($2)>>2)];
      var $132=HEAP32[(($3)>>2)];
      var $133=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($130, $131, $132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; };
    case 21: // $134
      HEAP32[(($result_i3)>>2)]=$133;
      var $135=HEAP32[(($result_i3)>>2)];
      var $136=(($135)|0)==0;
      if ($136) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $137
      var $138=___cxa_allocate_exception(4);
      var $139=$138;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($139);
      (function() { try { __THREW__ = false; return ___cxa_throw($138, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 23; break; }
    case 23: // $140
      var $141=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $142=$141.f0;
      HEAP32[(($4)>>2)]=$142;
      var $143=$141.f1;
      HEAP32[(($5)>>2)]=$143;
      var $144=HEAP32[(($5)>>2)];
      var $145=(($144)|0) < 0;
      if ($145) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $146
      var $147=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($147);
      throw "Reached an unreachable!"
    case 25: // $148
      var $149=HEAP32[(($4)>>2)];
      var $150=HEAP32[(($4)>>2)];
      var $151=HEAP32[(($5)>>2)];
      var $152=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $150, tempValue);
      var $153=($152.f1 = $151, $152);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $154
      throw "Reached an unreachable!"
    case 27: // $_ZnajPKci_exit4
      var $155=HEAP32[(($result_i3)>>2)];
      var $156=$1;
      var $157=$2;
      var $158=$3;
      var $159=$result_i3;
      var $160=$4;
      var $161=$5;
      var $162=$155;
      var $163=__ZN13resource_pool9add_arrayIjEEPT_S2_i($123, $162, 65536);
      $table1=$163;
      var $164=$12;
      var $165=(($164)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166)|0)==2;
      if ($167) { __label__ = 28; break; } else { __label__ = 36; break; }
    case 28: // $168
      var $169=$table1;
      var $170=$12;
      var $171=(($170+20)|0);
      var $172=(($171+36)|0);
      var $173=(($172)|0);
      HEAP32[(($173)>>2)]=$169;
      var $174=$12;
      var $175=(($174+20)|0);
      var $176=(($175+12)|0);
      var $177=(($176)|0);
      HEAP32[(($177)>>2)]=$169;
      $i2=0;
      __label__ = 29; break;
    case 29: // $178
      var $179=$i2;
      var $180=(($179)|0) < 65536;
      if ($180) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $181
      var $182=$i2;
      var $183=$11;
      var $184=__ZNK15running_machine12total_colorsEv($183);
      var $185=(($182)>>>0) < (($184)>>>0);
      if ($185) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $186
      var $187=$i2;
      var $188=$11;
      var $189=__ZNK15running_machine12total_colorsEv($188);
      var $190=((($189<<1))|0);
      var $191=(($187+$190)|0);
      var $195 = $191;__label__ = 33; break;
    case 32: // $192
      var $193=$i2;
      var $195 = $193;__label__ = 33; break;
    case 33: // $194
      var $195;
      var $196=$i2;
      var $197=$table1;
      var $198=(($197+($196<<2))|0);
      HEAP32[(($198)>>2)]=$195;
      __label__ = 34; break;
    case 34: // $199
      var $200=$i2;
      var $201=(($200+1)|0);
      $i2=$201;
      __label__ = 29; break;
    case 35: // $202
      __label__ = 37; break;
    case 36: // $203
      var $204=$table1;
      var $205=$12;
      var $206=(($205+20)|0);
      var $207=(($206+12)|0);
      var $208=(($207)|0);
      HEAP32[(($208)>>2)]=$204;
      var $209=$table1;
      var $210=(($209+131072)|0);
      var $211=$12;
      var $212=(($211+20)|0);
      var $213=(($212+36)|0);
      var $214=(($213)|0);
      HEAP32[(($214)>>2)]=$210;
      var $215=$11;
      __ZL21configure_rgb_shadowsR15running_machineif($215, 1, 1.6666666269302368);
      __label__ = 37; break;
    case 37: // $216
      __label__ = 38; break;
    case 38: // $217
      var $218=$12;
      var $219=(($218+20)|0);
      var $220=(($219)|0);
      var $221=(($220)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$11;
      var $224=(($223+576)|0);
      HEAP32[(($224)>>2)]=$222;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22allocate_shadow_tablesR15running_machineP16_palette_private["X"]=1;

function __ZN13resource_pool9add_arrayIfEEPT_S2_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIfEC1EPfi($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIfEEPT_S2_i["X"]=1;

function __ZL7pal5bith3666($bits) {
  ;
  var __label__;

  var $1;
  $1=$bits;
  var $2=$1;
  var $3=(($2)&255);
  var $4=$3 & 31;
  var $5=(($4) & 255);
  $1=$5;
  var $6=$1;
  var $7=(($6)&255);
  var $8=$7 << 3;
  var $9=$1;
  var $10=(($9)&255);
  var $11=$10 >> 2;
  var $12=$8 | $11;
  var $13=(($12) & 255);
  ;
  return $13;
}


function __ZL9rgb_clampi($value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$value;
      var $3=$2;
      var $4=(($3)|0) < 0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 5; break;
    case 2: // $6
      var $7=$2;
      var $8=(($7)|0) > 255;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      $1=-1;
      __label__ = 5; break;
    case 4: // $10
      var $11=$2;
      var $12=(($11) & 255);
      $1=$12;
      __label__ = 5; break;
    case 5: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12rgb_to_rgb15j3667($rgb) {
  ;
  var __label__;

  var $1;
  $1=$rgb;
  var $2=$1;
  var $3=$2 >>> 16;
  var $4=$3 & 255;
  var $5=$4 >>> 3;
  var $6=$5 << 10;
  var $7=$1;
  var $8=$7 >>> 8;
  var $9=$8 & 255;
  var $10=$9 >>> 3;
  var $11=$10 << 5;
  var $12=$6 | $11;
  var $13=$1;
  var $14=$13 & 255;
  var $15=$14 >>> 3;
  var $16=$15 << 0;
  var $17=$12 | $16;
  var $18=(($17) & 65535);
  ;
  return $18;
}


function __ZL7pal1bith($bits) {
  ;
  var __label__;

  var $1;
  $1=$bits;
  var $2=$1;
  var $3=(($2)&255);
  var $4=$3 & 1;
  var $5=(($4)|0)!=0;
  var $6=$5 ? 255 : 0;
  var $7=(($6) & 255);
  ;
  return $7;
}


function __Z28colortable_palette_get_colorP12colortable_tj($ctable, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$ctable;
      $2=$entry;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      __label__ = 3; break;
    case 3: // $5
      __label__ = 4; break;
    case 4: // $6
      var $7=$2;
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+($7<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z27colortable_palette_get_sizeP12colortable_t($ctable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$ctable;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager12save_pointerIjEEvPT_PKcji($this, $value, $valname, $count, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$count;
  $5=$index;
  var $6=$1;
  var $7=$5;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  __ZN12save_manager12save_pointerIjEEvPKcS2_iPT_S2_j($6, ((STRING_TABLE.__str93660)|0), 0, $7, $8, $9, $10);
  ;
  return;
}


function __ZN12save_manager12save_pointerIfEEvPT_PKcji($this, $value, $valname, $count, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$count;
  $5=$index;
  var $6=$1;
  var $7=$5;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  __ZN12save_manager12save_pointerIfEEvPKcS2_iPT_S2_j($6, ((STRING_TABLE.__str93660)|0), 0, $7, $8, $9, $10);
  ;
  return;
}


function __ZL15palette_presaveR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $numcolors;
      var $palette;
      var $index;
      $1=$machine;
      var $2=$1;
      var $3=(($2+564)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__Z22palette_get_num_colorsP10_palette_t($4);
      $numcolors=$5;
      var $6=$1;
      var $7=(($6+628)|0);
      var $8=HEAP32[(($7)>>2)];
      $palette=$8;
      $index=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$index;
      var $11=$numcolors;
      var $12=(($10)|0) < (($11)|0);
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$1;
      var $15=(($14+564)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$index;
      var $18=__Z23palette_entry_get_colorP10_palette_tj($16, $17);
      var $19=$index;
      var $20=$palette;
      var $21=(($20+68)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+($19<<2))|0);
      HEAP32[(($23)>>2)]=$18;
      var $24=$1;
      var $25=(($24+564)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$index;
      var $28=__Z26palette_entry_get_contrastP10_palette_tj($26, $27);
      var $29=$index;
      var $30=$palette;
      var $31=(($30+72)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+($29<<2))|0);
      HEAPF32[(($33)>>2)]=$28;
      __label__ = 3; break;
    case 3: // $34
      var $35=$index;
      var $36=(($35+1)|0);
      $index=$36;
      __label__ = 1; break;
    case 4: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16palette_postloadR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $numcolors;
      var $palette;
      var $index;
      $1=$machine;
      var $2=$1;
      var $3=(($2+564)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__Z22palette_get_num_colorsP10_palette_t($4);
      $numcolors=$5;
      var $6=$1;
      var $7=(($6+628)|0);
      var $8=HEAP32[(($7)>>2)];
      $palette=$8;
      $index=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$index;
      var $11=$numcolors;
      var $12=(($10)|0) < (($11)|0);
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$1;
      var $15=(($14+564)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$index;
      var $18=$index;
      var $19=$palette;
      var $20=(($19+68)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+($18<<2))|0);
      var $23=HEAP32[(($22)>>2)];
      __Z23palette_entry_set_colorP10_palette_tjj($16, $17, $23);
      var $24=$1;
      var $25=(($24+564)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$index;
      var $28=$index;
      var $29=$palette;
      var $30=(($29+72)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+($28<<2))|0);
      var $33=HEAPF32[(($32)>>2)];
      __Z26palette_entry_set_contrastP10_palette_tjf($26, $27, $33);
      __label__ = 3; break;
    case 3: // $34
      var $35=$index;
      var $36=(($35+1)|0);
      $index=$36;
      __label__ = 1; break;
    case 4: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager12save_pointerIfEEvPKcS2_iPT_S2_j($this, $module, $tag, $index, $value, $valname, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  $7=$count;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$6;
  var $13=$5;
  var $14=$13;
  var $15=$7;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($8, $9, $10, $11, $12, $14, 4, $15);
  ;
  return;
}


function __ZN12save_manager12save_pointerIjEEvPKcS2_iPT_S2_j($this, $module, $tag, $index, $value, $valname, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  $7=$count;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$6;
  var $13=$5;
  var $14=$13;
  var $15=$7;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($8, $9, $10, $11, $12, $14, 4, $15);
  ;
  return;
}


function __ZN19resource_pool_arrayIfEC1EPfi($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIfEC2EPfi($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIfEC2EPfi($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<2))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIfE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIfED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIfED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI16_palette_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16_palette_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16_palette_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 76);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16_palette_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16_palette_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16_palette_privateED2Ev($2);
  ;
  return;
}


function __ZL21configure_rgb_shadowsR15running_machineif($machine, $mode, $factor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $palette;
      var $stable;
      var $ifactor;
      var $i;
      var $r;
      var $g;
      var $b;
      var $final;
      $1=$machine;
      $2=$mode;
      $3=$factor;
      var $4=$1;
      var $5=(($4+628)|0);
      var $6=HEAP32[(($5)>>2)];
      $palette=$6;
      var $7=$2;
      var $8=$palette;
      var $9=(($8+20)|0);
      var $10=(($9+$7*12)|0);
      $stable=$10;
      var $11=$3;
      var $12=$11*256;
      var $13=(($12)|0);
      $ifactor=$13;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      __label__ = 3; break;
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      $i=0;
      __label__ = 5; break;
    case 5: // $18
      var $19=$i;
      var $20=(($19)|0) < 32768;
      if ($20) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $21
      var $22=$i;
      var $23=$22 >> 10;
      var $24=(($23) & 255);
      var $25=__ZL7pal5bith3666($24);
      var $26=(($25)&255);
      var $27=$ifactor;
      var $28=(($26*$27)|0);
      var $29=$28 >> 8;
      var $30=__ZL9rgb_clampi($29);
      $r=$30;
      var $31=$i;
      var $32=$31 >> 5;
      var $33=(($32) & 255);
      var $34=__ZL7pal5bith3666($33);
      var $35=(($34)&255);
      var $36=$ifactor;
      var $37=(($35*$36)|0);
      var $38=$37 >> 8;
      var $39=__ZL9rgb_clampi($38);
      $g=$39;
      var $40=$i;
      var $41=$40 >> 0;
      var $42=(($41) & 255);
      var $43=__ZL7pal5bith3666($42);
      var $44=(($43)&255);
      var $45=$ifactor;
      var $46=(($44*$45)|0);
      var $47=$46 >> 8;
      var $48=__ZL9rgb_clampi($47);
      $b=$48;
      var $49=$r;
      var $50=(($49)&255);
      var $51=$50 & 255;
      var $52=$51 << 16;
      var $53=-16777216 | $52;
      var $54=$g;
      var $55=(($54)&255);
      var $56=$55 & 255;
      var $57=$56 << 8;
      var $58=$53 | $57;
      var $59=$b;
      var $60=(($59)&255);
      var $61=$60 & 255;
      var $62=$58 | $61;
      $final=$62;
      var $63=$palette;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65)|0)==6;
      if ($66) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $67
      var $68=$final;
      var $69=$i;
      var $70=$stable;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+($69<<2))|0);
      HEAP32[(($73)>>2)]=$68;
      __label__ = 9; break;
    case 8: // $74
      var $75=$final;
      var $76=__ZL12rgb_to_rgb15j3667($75);
      var $77=(($76)&65535);
      var $78=$i;
      var $79=$stable;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+($78<<2))|0);
      HEAP32[(($82)>>2)]=$77;
      __label__ = 9; break;
    case 9: // $83
      __label__ = 10; break;
    case 10: // $84
      var $85=$i;
      var $86=(($85+1)|0);
      $i=$86;
      __label__ = 5; break;
    case 11: // $87
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21configure_rgb_shadowsR15running_machineif["X"]=1;

function __ZL17image_fseek_thunkPvxi($file, $offset$0, $offset$1, $whence) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3;
  var $image;
  $1=$file;
  var $st$5$0=(($2)|0);
  HEAP32[(($st$5$0)>>2)]=$offset$0;
  var $st$5$1=(($2+4)|0);
  HEAP32[(($st$5$1)>>2)]=$offset$1;
  $3=$whence;
  var $4=$1;
  var $5=$4;
  $image=$5;
  var $6=$image;
  var $st$14$0=(($2)|0);
  var $7$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($2+4)|0);
  var $7$1=HEAP32[(($st$14$1)>>2)];
  var $8=$3;
  var $9=__ZN22device_image_interface5fseekExi($6, $7$0, $7$1, $8);
  var $9$0=$9[0];
  STACKTOP = __stackBase__;
  return $9;
}


function __ZL17image_fread_thunkPvS_j($file, $buffer, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $image;
  $1=$file;
  $2=$buffer;
  $3=$length;
  var $4=$1;
  var $5=$4;
  $image=$5;
  var $6=$image;
  var $7=$2;
  var $8=$3;
  var $9=__ZN22device_image_interface5freadEPvj($6, $7, $8);
  ;
  return $9;
}


function __ZL18image_fwrite_thunkPvPKvj($file, $buffer, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $image;
  $1=$file;
  $2=$buffer;
  $3=$length;
  var $4=$1;
  var $5=$4;
  $image=$5;
  var $6=$image;
  var $7=$2;
  var $8=$3;
  var $9=__ZN22device_image_interface6fwriteEPKvj($6, $7, $8);
  ;
  return $9;
}


function __ZL17image_fsize_thunkPv($file) {
  ;
  var __label__;

  var $1;
  var $image;
  $1=$file;
  var $2=$1;
  var $3=$2;
  $image=$3;
  var $4=$image;
  var $5=__ZN22device_image_interface6lengthEv($4);
  var $5$0=$5[0];
  var $5$1=$5[1];
  ;
  return [$5$0,$5$1];
}


function __Z16image_unload_allR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $image=__stackBase__;
      var $gotone;
      $1=$machine;
      HEAP32[(($image)>>2)]=0;
      var $2=$1;
      __ZL21image_options_extractR15running_machine($2);
      var $3=$1;
      var $4=__ZNK15running_machine10devicelistEv($3);
      var $5=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($4, $image);
      var $6=(($5)&1);
      $gotone=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$gotone;
      var $9=(($8) & 1);
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=HEAP32[(($image)>>2)];
      __ZN22device_image_interface6unloadEv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=HEAP32[(($image)>>2)];
      var $14=$13;
      var $15=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($14, $image);
      var $16=(($15)&1);
      $gotone=$16;
      __label__ = 1; break;
    case 4: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIfED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIfED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIfED0Ev["X"]=1;

function __ZN19resource_pool_arrayIfED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIfE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI16_palette_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16_palette_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16_palette_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI16_palette_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI16_palette_privateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}

// WARNING: content after a branch in a label, line: 470864

function __ZN22device_image_interface14set_init_phaseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+618)|0);
  HEAP8[($3)]=1;
  ;
  return;
}


function __Z10image_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+24;
  $1=$machine;
  var $4=$1;
  __Z17image_device_initR15running_machine($4);
  var $5=$1;
  var $6=$1;
  __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($2, 896, ((STRING_TABLE.__str53674)|0), $6);
  var $7=$1;
  __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($3, 898, ((STRING_TABLE.__str63675)|0), $7);
  __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($5, ((STRING_TABLE.__str43673)|0), $2, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZL15image_dirs_loadR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $node;
      var $dev_instance;
      var $working_directory;
      var $image=__stackBase__;
      var $gotone;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      HEAP32[(($image)>>2)]=0;
      var $4=$2;
      var $5=(($4)|0)==3;
      if ($5) { __label__ = 1; break; } else { __label__ = 18; break; }
    case 1: // $6
      var $7=$3;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $9
      var $10=$3;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__Z15xml_get_siblingP14_xml_data_nodePKc($12, ((STRING_TABLE.__str203689)|0));
      $node=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$node;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 17; break; }
    case 4: // $17
      var $18=$node;
      var $19=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($18, ((STRING_TABLE.__str213690)|0), 0);
      $dev_instance=$19;
      var $20=$dev_instance;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $22
      var $23=$dev_instance;
      var $24=(($23)|0);
      var $25=HEAP8[($24)];
      var $26=(($25 << 24) >> 24);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $28
      var $29=$1;
      var $30=__ZNK15running_machine10devicelistEv($29);
      var $31=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($30, $image);
      var $32=(($31)&1);
      $gotone=$32;
      __label__ = 7; break;
    case 7: // $33
      var $34=$gotone;
      var $35=(($34) & 1);
      if ($35) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $36
      var $37=$dev_instance;
      var $38=HEAP32[(($image)>>2)];
      var $39=__ZNK22device_image_interface13instance_nameEv($38);
      var $40=_strcmp($37, $39);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $42
      var $43=$node;
      var $44=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($43, ((STRING_TABLE.__str223691)|0), 0);
      $working_directory=$44;
      var $45=$working_directory;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $47
      var $48=HEAP32[(($image)>>2)];
      var $49=$working_directory;
      __ZN22device_image_interface21set_working_directoryEPKc($48, $49);
      __label__ = 11; break;
    case 11: // $50
      __label__ = 12; break;
    case 12: // $51
      __label__ = 13; break;
    case 13: // $52
      var $53=HEAP32[(($image)>>2)];
      var $54=$53;
      var $55=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($54, $image);
      var $56=(($55)&1);
      $gotone=$56;
      __label__ = 7; break;
    case 14: // $57
      __label__ = 15; break;
    case 15: // $58
      __label__ = 16; break;
    case 16: // $59
      var $60=$node;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__Z15xml_get_siblingP14_xml_data_nodePKc($62, ((STRING_TABLE.__str203689)|0));
      $node=$63;
      __label__ = 3; break;
    case 17: // $64
      __label__ = 18; break;
    case 18: // $65
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15image_dirs_loadR15running_machineiP14_xml_data_node["X"]=1;

function __ZL15image_dirs_saveR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $node;
      var $dev_instance;
      var $image=__stackBase__;
      var $gotone;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      HEAP32[(($image)>>2)]=0;
      var $4=$2;
      var $5=(($4)|0)==3;
      if ($5) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $6
      var $7=$1;
      var $8=__ZNK15running_machine10devicelistEv($7);
      var $9=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($8, $image);
      var $10=(($9)&1);
      $gotone=$10;
      __label__ = 2; break;
    case 2: // $11
      var $12=$gotone;
      var $13=(($12) & 1);
      if ($13) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $14
      var $15=HEAP32[(($image)>>2)];
      var $16=__ZNK22device_image_interface13instance_nameEv($15);
      $dev_instance=$16;
      var $17=$3;
      var $18=__Z13xml_add_childP14_xml_data_nodePKcS2_($17, ((STRING_TABLE.__str203689)|0), 0);
      $node=$18;
      var $19=$node;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      var $22=$node;
      var $23=$dev_instance;
      var $24=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($22, ((STRING_TABLE.__str213690)|0), $23);
      var $25=$node;
      var $26=HEAP32[(($image)>>2)];
      var $27=__ZN22device_image_interface17working_directoryEv($26);
      var $28=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($25, ((STRING_TABLE.__str223691)|0), $27);
      __label__ = 5; break;
    case 5: // $29
      __label__ = 6; break;
    case 6: // $30
      var $31=HEAP32[(($image)>>2)];
      var $32=$31;
      var $33=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($32, $image);
      var $34=(($33)&1);
      $gotone=$34;
      __label__ = 2; break;
    case 7: // $35
      __label__ = 8; break;
    case 8: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18image_info_astringR15running_machineP7astring($machine, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $image=__stackBase__;
      var $gotone;
      var $name;
      var $base_filename;
      var $info;
      var $base_filename_noextension;
      $1=$machine;
      $2=$string;
      HEAP32[(($image)>>2)]=0;
      var $3=$2;
      var $4=$1;
      var $5=__ZNK15running_machine6systemEv($4);
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__Z14astring_printfP7astringPKcz($3, ((STRING_TABLE.__str73676)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$7,tempInt));
      var $9=$1;
      var $10=__ZNK15running_machine10devicelistEv($9);
      var $11=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($10, $image);
      var $12=(($11)&1);
      $gotone=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$gotone;
      var $15=(($14) & 1);
      if ($15) { __label__ = 2; break; } else { __label__ = 22; break; }
    case 2: // $16
      var $17=HEAP32[(($image)>>2)];
      var $18=__ZN22device_image_interface8filenameEv($17);
      $name=$18;
      var $19=$name;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 19; break; }
    case 3: // $21
      var $22=HEAP32[(($image)>>2)];
      var $23=__ZN22device_image_interface8basenameEv($22);
      $base_filename=$23;
      var $24=$base_filename;
      var $25=__ZL15strip_extensionPKc($24);
      $base_filename_noextension=$25;
      var $26=$2;
      var $27=HEAP32[(($image)>>2)];
      var $28=$27;
      var $29=__ZN16device_interface6deviceEv($28);
      var $30=__ZNK8device_t4nameEv($29);
      var $31=$base_filename;
      var $32=__Z17astring_catprintfP7astringPKcz($26, ((STRING_TABLE.__str83677)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$30,HEAP32[((tempInt+4)>>2)]=$31,tempInt));
      var $33=HEAP32[(($image)>>2)];
      var $34=__ZN22device_image_interface8longnameEv($33);
      $info=$34;
      var $35=$info;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $37
      var $38=$base_filename_noextension;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$info;
      var $42=$base_filename_noextension;
      var $43=__Z12core_stricmpPKcS0_($41, $42);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $45
      var $46=$2;
      var $47=$info;
      var $48=__Z17astring_catprintfP7astringPKcz($46, ((STRING_TABLE.__str93678)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$47,tempInt));
      __label__ = 7; break;
    case 7: // $49
      var $50=HEAP32[(($image)>>2)];
      var $51=__ZN22device_image_interface12manufacturerEv($50);
      $info=$51;
      var $52=$info;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $54
      var $55=$2;
      var $56=$info;
      var $57=__Z17astring_catprintfP7astringPKcz($55, ((STRING_TABLE.__str103679)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,tempInt));
      var $58=HEAP32[(($image)>>2)];
      var $59=__ZN22device_image_interface4yearEv($58);
      var $60=__ZL10stripspacePKc($59);
      $info=$60;
      var $61=$info;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $63
      var $64=$info;
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24)!=0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$2;
      var $69=$info;
      var $70=__Z17astring_catprintfP7astringPKcz($68, ((STRING_TABLE.__str113680)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$69,tempInt));
      __label__ = 11; break;
    case 11: // $71
      var $72=$2;
      var $73=__Z17astring_catprintfP7astringPKcz($72, ((STRING_TABLE.__str123681)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 12; break;
    case 12: // $74
      var $75=HEAP32[(($image)>>2)];
      var $76=__ZN22device_image_interface9supportedEv($75);
      if ($76 == 2) {
        __label__ = 13; break;
      }
      else if ($76 == 1) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 13: // $77
      var $78=$2;
      var $79=__Z17astring_catprintfP7astringPKcz($78, ((STRING_TABLE.__str133682)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 14: // $80
      var $81=$2;
      var $82=__Z17astring_catprintfP7astringPKcz($81, ((STRING_TABLE.__str143683)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 15: // $83
      __label__ = 16; break;
    case 16: // $84
      var $85=$base_filename_noextension;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $87
      var $88=$base_filename_noextension;
      __Z14free_file_linePvPKci($88, ((STRING_TABLE.__str153684)|0), 420);
      __label__ = 18; break;
    case 18: // $89
      __label__ = 20; break;
    case 19: // $90
      var $91=$2;
      var $92=HEAP32[(($image)>>2)];
      var $93=$92;
      var $94=__ZN16device_interface6deviceEv($93);
      var $95=__ZNK8device_t4nameEv($94);
      var $96=__Z17astring_catprintfP7astringPKcz($91, ((STRING_TABLE.__str163685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$95,tempInt));
      __label__ = 20; break;
    case 20: // $97
      __label__ = 21; break;
    case 21: // $98
      var $99=HEAP32[(($image)>>2)];
      var $100=$99;
      var $101=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($100, $image);
      var $102=(($101)&1);
      $gotone=$102;
      __label__ = 1; break;
    case 22: // $103
      var $104=$2;
      STACKTOP = __stackBase__;
      return $104;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18image_info_astringR15running_machineP7astring["X"]=1;

function __ZL15strip_extensionPKc($filename) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $newname;
      var $c;
      $2=$filename;
      var $3=$2;
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      $1=0;
      __label__ = 15; break;
    case 2: // $6
      var $7=$2;
      var $8=_strlen($7);
      var $9=(($8+1)|0);
      var $10=__Z22malloc_array_file_linejPKci($9, ((STRING_TABLE.__str153684)|0), 337);
      $newname=$10;
      var $11=$newname;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      $1=0;
      __label__ = 15; break;
    case 4: // $14
      var $15=$newname;
      var $16=$2;
      var $17=_strcpy($15, $16);
      var $18=$newname;
      var $19=$newname;
      var $20=_strlen($19);
      var $21=(($18+$20)|0);
      var $22=(($21-1)|0);
      $c=$22;
      __label__ = 5; break;
    case 5: // $23
      var $24=$c;
      var $25=$newname;
      var $26=(($24)>>>0) >= (($25)>>>0);
      if ($26) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $27
      var $28=$c;
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==46;
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      var $33=$c;
      HEAP8[($33)]=0;
      __label__ = 14; break;
    case 8: // $34
      var $35=$c;
      var $36=HEAP8[($35)];
      var $37=(($36 << 24) >> 24);
      var $38=(($37)|0)==92;
      if ($38) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $39
      var $40=$c;
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $43=(($42)|0)==47;
      if ($43) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $44
      var $45=$c;
      var $46=HEAP8[($45)];
      var $47=(($46 << 24) >> 24);
      var $48=(($47)|0)==58;
      if ($48) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $49
      __label__ = 14; break;
    case 12: // $50
      __label__ = 13; break;
    case 13: // $51
      var $52=$c;
      var $53=(($52-1)|0);
      $c=$53;
      __label__ = 5; break;
    case 14: // $54
      var $55=$newname;
      $1=$55;
      __label__ = 15; break;
    case 15: // $56
      var $57=$1;
      ;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15strip_extensionPKc["X"]=1;

function __ZN22device_image_interface8longnameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+420)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN22device_image_interface12manufacturerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+484)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZL21image_options_extractR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $index;
      var $image=__stackBase__;
      var $gotone;
      var $filename;
      var $error=__stackBase__+4;
      var $2;
      var $3;
      $1=$machine;
      $index=0;
      HEAP32[(($image)>>2)]=0;
      var $4=$1;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($5, $image);
      var $7=(($6)&1);
      $gotone=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$gotone;
      var $10=(($9) & 1);
      if ($10) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $11
      var $12=HEAP32[(($image)>>2)];
      var $13=__ZN22device_image_interface8filenameEv($12);
      $filename=$13;
      __ZN7astringC1Ev($error);
      var $14=$1;
      var $15=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 10; break; };
    case 3: // $16
      var $17=$15;
      var $18=HEAP32[(($image)>>2)];
      var $19=(function() { try { __THREW__ = false; return __ZNK22device_image_interface13instance_nameEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $20
      var $21=$filename;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$filename;
      var $27 = $24;__label__ = 7; break;
    case 6: // $25
      var $27 = ((__str233692)|0);__label__ = 7; break;
    case 7: // $26
      var $27;
      var $28=(function() { try { __THREW__ = false; return __ZN12core_options9set_valueEPKcS1_iR7astring($17, $19, $27, 150, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $29
      var $30=$index;
      var $31=(($30+1)|0);
      $index=$31;
      FUNCTION_TABLE[__ZN7astringD1Ev]($error);
      __label__ = 9; break;
    case 9: // $32
      var $33=HEAP32[(($image)>>2)];
      var $34=$33;
      var $35=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($34, $image);
      var $36=(($35)&1);
      $gotone=$36;
      __label__ = 1; break;
    case 10: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $2=$39;
      var $40=$38.f1;
      $3=$40;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $41
      __label__ = 15; break;
    case 12: // $42
      var $43=$1;
      var $44=__ZNK15running_machine7optionsEv($43);
      var $45=__ZNK11emu_options12write_configEv($44);
      if ($45) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $46
      var $47=$1;
      var $48=__ZNK15running_machine7optionsEv($47);
      var $49=$1;
      var $50=__ZNK15running_machine6systemEv($49);
      var $51=__ZL12write_configR11emu_optionsPKcPK11game_driver($48, 0, $50);
      __label__ = 14; break;
    case 14: // $52
      STACKTOP = __stackBase__;
      return;
    case 15: // $53
      var $54=$2;
      var $55=$2;
      var $56=$3;
      var $57=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $55, tempValue);
      var $58=($57.f1 = $56, $57);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21image_options_extractR15running_machine["X"]=1;

function __Z17image_device_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 132; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $image_name;
      var $image=__stackBase__;
      var $gotone;
      var $result;
      var $image_err=__stackBase__+4;
      var $image_basename=__stackBase__+68;
      var $2;
      var $3;
      $1=$machine;
      HEAP32[(($image)>>2)]=0;
      var $4=$1;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($5, $image);
      var $7=(($6)&1);
      $gotone=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$gotone;
      var $10=(($9) & 1);
      if ($10) { __label__ = 2; break; } else { __label__ = 24; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZNK15running_machine7optionsEv($12);
      var $14=HEAP32[(($image)>>2)];
      var $15=__ZN11emu_options13device_optionER22device_image_interface($13, $14);
      $image_name=$15;
      var $16=$image_name;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 19; break; }
    case 3: // $18
      var $19=$image_name;
      var $20=(($19)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 4: // $24
      var $25=HEAP32[(($image)>>2)];
      __ZN22device_image_interface14set_init_phaseEv($25);
      var $26=HEAP32[(($image)>>2)];
      var $27=$image_name;
      var $28=__ZN22device_image_interface4loadEPKc($26, $27);
      var $29=(($28)&1);
      $result=$29;
      var $30=$result;
      var $31=(($30) & 1);
      if ($31) { __label__ = 5; break; } else { __label__ = 18; break; }
    case 5: // $32
      var $33=HEAP32[(($image)>>2)];
      var $34=__ZN22device_image_interface5errorEv($33);
      __ZN7astringC1EPKc($image_err, $34);
      var $35=$image_name;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($image_basename, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $36
      var $37=$1;
      (function() { try { __THREW__ = false; return __Z16image_unload_allR15running_machine($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $38
      var $39=$1;
      var $40=HEAP32[(($image)>>2)];
      var $41=$40;
      var $42=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; };
    case 8: // $43
      var $44=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 14; break; };
    case 9: // $45
      var $46=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($image_basename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 14; break; };
    case 10: // $47
      var $48=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($image_err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $49
      (function() { try { __THREW__ = false; return __Z19fatalerror_exitcodeR15running_machineiPKcz($39, 4, ((STRING_TABLE.__str3669)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$44,HEAP32[((tempInt+4)>>2)]=$46,HEAP32[((tempInt+8)>>2)]=$48,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $50
      throw "Reached an unreachable!"
    case 13: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $2=$53;
      var $54=$52.f1;
      $3=$54;
      __label__ = 16; break;
    case 14: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $2=$57;
      var $58=$56.f1;
      $3=$58;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($image_basename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 26; break; }
    case 15: // $59
      __label__ = 16; break;
    case 16: // $60
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($image_err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 26; break; }
    case 17: // $61
      __label__ = 25; break;
    case 18: // $62
      __label__ = 22; break;
    case 19: // $63
      var $64=HEAP32[(($image)>>2)];
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+112)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=FUNCTION_TABLE[$68]($64);
      if ($69) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $70
      var $71=$1;
      var $72=HEAP32[(($image)>>2)];
      var $73=__ZNK22device_image_interface13instance_nameEv($72);
      __Z19fatalerror_exitcodeR15running_machineiPKcz($71, 4, ((STRING_TABLE.__str13670)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,tempInt));
      throw "Reached an unreachable!"
    case 21: // $74
      __label__ = 22; break;
    case 22: // $75
      var $76=HEAP32[(($image)>>2)];
      var $77=$76;
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+84)|0);
      var $80=HEAP32[(($79)>>2)];
      FUNCTION_TABLE[$80]($76);
      __label__ = 23; break;
    case 23: // $81
      var $82=HEAP32[(($image)>>2)];
      var $83=$82;
      var $84=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($83, $image);
      var $85=(($84)&1);
      $gotone=$85;
      __label__ = 1; break;
    case 24: // $86
      STACKTOP = __stackBase__;
      return;
    case 25: // $87
      var $88=$2;
      var $89=$2;
      var $90=$3;
      var $91=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $89, tempValue);
      var $92=($91.f1 = $90, $91);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $93
      var $94=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17image_device_initR15running_machine["X"]=1;

function __Z19fatalerror_exitcodeR15running_machineiPKcz($machine, $exitcode, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ap=__stackBase__;
      var $4;
      var $5;
      $1=$machine;
      $2=$exitcode;
      $3=$format;
      var $6=$ap;
      HEAP32[(($6)>>2)]=arguments[__Z19fatalerror_exitcodeR15running_machineiPKcz.length];
      var $7=___cxa_allocate_exception(1032);
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=HEAP32[(($ap)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcPc($8, $9, $10, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      ___cxa_throw($7, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 2: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $4=$15;
      var $16=$14.f1;
      $5=$16;
      ___cxa_free_exception($7);
      __label__ = 3; break;
    case 3: // $18
      var $19=$4;
      var $20=$4;
      var $21=$5;
      var $22=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20, tempValue);
      var $23=($22.f1 = $21, $22);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21image_postdevice_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $image=__stackBase__;
      var $gotone;
      var $result;
      var $image_err=__stackBase__+4;
      var $2;
      var $3;
      var $4=__stackBase__+68;
      $1=$machine;
      HEAP32[(($image)>>2)]=0;
      var $5=$1;
      var $6=__ZNK15running_machine10devicelistEv($5);
      var $7=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($6, $image);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $12
      var $13=HEAP32[(($image)>>2)];
      var $14=__ZN22device_image_interface11finish_loadEv($13);
      var $15=(($14)&1);
      $result=$15;
      var $16=$result;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $18
      var $19=HEAP32[(($image)>>2)];
      var $20=__ZN22device_image_interface5errorEv($19);
      __ZN7astringC1EPKc($image_err, $20);
      var $21=$1;
      (function() { try { __THREW__ = false; return __Z16image_unload_allR15running_machine($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $22
      var $23=$1;
      var $24=HEAP32[(($image)>>2)];
      var $25=$24;
      var $26=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; };
    case 5: // $27
      var $28=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $29
      var $30=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($image_err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $31
      (function() { try { __THREW__ = false; return __Z19fatalerror_exitcodeR15running_machineiPKcz($23, 4, ((STRING_TABLE.__str23671)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,HEAP32[((tempInt+4)>>2)]=$30,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $32
      throw "Reached an unreachable!"
    case 9: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $2=$35;
      var $36=$34.f1;
      $3=$36;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($image_err) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $37
      __label__ = 14; break;
    case 11: // $38
      __label__ = 12; break;
    case 12: // $39
      var $40=HEAP32[(($image)>>2)];
      var $41=$40;
      var $42=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($41, $image);
      var $43=(($42)&1);
      $gotone=$43;
      __label__ = 1; break;
    case 13: // $44
      var $45=$1;
      var $46=$1;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($4, 894, ((STRING_TABLE.__str33672)|0), $46);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($45, 4, $4);
      STACKTOP = __stackBase__;
      return;
    case 14: // $47
      var $48=$2;
      var $49=$2;
      var $50=$3;
      var $51=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $49, tempValue);
      var $52=($51.f1 = $50, $51);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21image_postdevice_initR15running_machine["X"]=1;

function __ZN22device_image_interface9supportedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+612)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL10stripspacePKc($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dst;
      $2=$src;
      var $3=$2;
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7=$2;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 3; break; } else { var $17 = 0;__label__ = 4; break; }
    case 3: // $10
      var $11=$2;
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=_isspace($13);
      var $15=(($14)|0)!=0;
      var $17 = $15;__label__ = 4; break;
    case 4: // $16
      var $17;
      if ($17) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $18
      var $19=$2;
      var $20=(($19+1)|0);
      $2=$20;
      __label__ = 2; break;
    case 6: // $21
      var $22=$2;
      var $23=_strcpy(((__ZZL10stripspacePKcE4buff)|0), $22);
      var $24=_strlen(((__ZZL10stripspacePKcE4buff)|0));
      var $25=((((__ZZL10stripspacePKcE4buff)|0)+$24)|0);
      $dst=$25;
      __label__ = 7; break;
    case 7: // $26
      var $27=$dst;
      var $28=(($27)>>>0) >= (((((__ZZL10stripspacePKcE4buff)|0)))>>>0);
      if ($28) { __label__ = 8; break; } else { var $37 = 0;__label__ = 9; break; }
    case 8: // $29
      var $30=$dst;
      var $31=(($30-1)|0);
      $dst=$31;
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=_isspace($33);
      var $35=(($34)|0)!=0;
      var $37 = $35;__label__ = 9; break;
    case 9: // $36
      var $37;
      if ($37) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      var $39=$dst;
      HEAP8[($39)]=0;
      __label__ = 7; break;
    case 11: // $40
      $1=((__ZZL10stripspacePKcE4buff)|0);
      __label__ = 13; break;
    case 12: // $41
      $1=0;
      __label__ = 13; break;
    case 13: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10stripspacePKc["X"]=1;

function __ZN22device_image_interface4yearEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+548)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __Z32image_add_device_with_subdevicesP8device_tPFS0_RK14machine_configPKcS0_jES5_j($owner, $type, $tag, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$owner;
  $2=$type;
  $3=$tag;
  $4=$clock;
  var $5=$1;
  var $6=__ZNK8device_t7machineEv($5);
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=__ZN15running_machine18add_dynamic_deviceER8device_tPFPS0_RK14machine_configPKcS2_jES7_j($6, $7, $8, $9, $10);
  ;
  return;
}


function __ZN22device_image_interface21set_working_directoryEPKc($this, $working_directory) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$working_directory;
  var $3=$1;
  var $4=(($3+344)|0);
  var $5=$2;
  var $6=__ZN7astringaSEPKc($4, $5);
  ;
  return;
}


function __ZN14emu_fatalerrorC1EiPKcPc($this, $_exitcode, $format, $ap) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$_exitcode;
  $3=$format;
  $4=$ap;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN14emu_fatalerrorC2EiPKcPc($5, $6, $7, $8);
  ;
  return;
}


function __ZN14emu_fatalerrorC2EiPKcPc($this, $_exitcode, $format, $ap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$_exitcode;
      $3=$format;
      $4=$ap;
      var $7=$1;
      var $8=$7;
      __ZN13emu_exceptionC2Ev($8);
      var $9=$7;
      HEAP32[(($9)>>2)]=((__ZTV14emu_fatalerror+8)|0);
      var $10=(($7+1028)|0);
      var $11=$2;
      HEAP32[(($10)>>2)]=$11;
      var $12=(($7+4)|0);
      var $13=(($12)|0);
      var $14=$3;
      var $15=$4;
      var $16=(function() { try { __THREW__ = false; return _vsprintf($13, $14, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $17
      ;
      return;
    case 2: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $5=$20;
      var $21=$19.f1;
      $6=$21;
      var $22=$7;
      __ZN13emu_exceptionD2Ev($22);
      __label__ = 3; break;
    case 3: // $23
      var $24=$5;
      var $25=$5;
      var $26=$6;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options12write_configEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str263695)|0));
  ;
  return $4;
}


function __ZNK11emu_options8ini_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str253694)|0));
  ;
  return $4;
}


function __ZN22device_image_interface6fwriteEPKvj($this, $buffer, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$buffer;
  $3=$length;
  var $4=$1;
  __ZN22device_image_interface14check_for_fileEv($4);
  var $5=(($4+80)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  var $8=$3;
  var $9=__Z11core_fwriteP10_core_filePKvj($6, $7, $8);
  ;
  return $9;
}


function __ZL12tilemap_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tilemap_data;
      var $next;
      $1=$machine;
      var $2=$1;
      var $3=(($2+632)|0);
      var $4=HEAP32[(($3)>>2)];
      $tilemap_data=$4;
      var $5=$tilemap_data;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=$tilemap_data;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$tilemap_data;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      $next=$18;
      var $19=$tilemap_data;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      __ZL15tilemap_disposeP9tilemap_t($21);
      var $22=$next;
      var $23=$tilemap_data;
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=$22;
      __label__ = 2; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z26image_battery_load_by_nameR11emu_optionsPKcPvii($options, $filename, $buffer, $length, $fill) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $filerr;
      var $bytes_read;
      var $6;
      var $7;
      var $file=__stackBase__;
      $1=$options;
      $2=$filename;
      $3=$buffer;
      $4=$length;
      $5=$fill;
      $bytes_read=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$4;
      var $13=(($12)|0) > 0;
      if ($13) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $14
      var $15=___cxa_allocate_exception(1032);
      var $16=$15;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($16, ((STRING_TABLE.__str173686)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str183687)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str153684)|0),HEAP32[((tempInt+8)>>2)]=442,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      ___cxa_throw($15, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $6=$20;
      var $21=$19.f1;
      $7=$21;
      ___cxa_free_exception($15);
      __label__ = 14; break;
    case 6: // $22
      __label__ = 7; break;
    case 7: // $23
      var $24=$1;
      var $25=__ZNK11emu_options15nvram_directoryEv($24);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $25, 1);
      var $26=$2;
      var $27=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $28
      $filerr=$27;
      var $29=$filerr;
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $31
      var $32=$3;
      var $33=$4;
      var $34=(function() { try { __THREW__ = false; return __ZN8emu_file4readEPvj($file, $32, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; };
    case 10: // $35
      $bytes_read=$34;
      __label__ = 12; break;
    case 11: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $6=$38;
      var $39=$37.f1;
      $7=$39;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 12: // $40
      var $41=$3;
      var $42=$bytes_read;
      var $43=(($41+$42)|0);
      var $44=$5;
      var $45=(($44) & 255);
      var $46=$4;
      var $47=$bytes_read;
      var $48=(($46-$47)|0);
      _memset($43, $45, $48, 1);
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      STACKTOP = __stackBase__;
      return;
    case 13: // $49
      __label__ = 14; break;
    case 14: // $50
      var $51=$6;
      var $52=$6;
      var $53=$7;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26image_battery_load_by_nameR11emu_optionsPKcPvii["X"]=1;

function __Z26image_battery_save_by_nameR11emu_optionsPKcPKvi($options, $filename, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $file=__stackBase__;
      var $filerr;
      $1=$options;
      $2=$filename;
      $3=$buffer;
      $4=$length;
      __label__ = 1; break;
    case 1: // $7
      var $8=$3;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$4;
      var $12=(($11)|0) > 0;
      if ($12) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=___cxa_allocate_exception(1032);
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($15, ((STRING_TABLE.__str173686)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str183687)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str153684)|0),HEAP32[((tempInt+8)>>2)]=461,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      ___cxa_throw($14, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $5=$19;
      var $20=$18.f1;
      $6=$20;
      ___cxa_free_exception($14);
      __label__ = 14; break;
    case 6: // $21
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      var $24=__ZNK11emu_options15nvram_directoryEv($23);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $24, 14);
      var $25=$2;
      var $26=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $27
      $filerr=$26;
      var $28=$filerr;
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $30
      var $31=$3;
      var $32=$4;
      var $33=(function() { try { __THREW__ = false; return __ZN8emu_file5writeEPKvj($file, $31, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; };
    case 10: // $34
      __label__ = 12; break;
    case 11: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $5=$37;
      var $38=$36.f1;
      $6=$38;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 12: // $39
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      STACKTOP = __stackBase__;
      return;
    case 13: // $40
      __label__ = 14; break;
    case 14: // $41
      var $42=$5;
      var $43=$5;
      var $44=$6;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26image_battery_save_by_nameR11emu_optionsPKcPKvi["X"]=1;

function __ZL12write_configR11emu_optionsPKcPK11game_driver($options, $filename, $gamedrv) {
  var __stackBase__  = STACKTOP; STACKTOP += 452; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buffer=__stackBase__;
      var $retval;
      var $file=__stackBase__+128;
      var $filerr;
      var $5;
      var $6;
      var $inistring=__stackBase__+388;
      var $7;
      $2=$options;
      $3=$filename;
      $4=$gamedrv;
      $retval=1;
      var $8=$4;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($buffer)|0);
      var $12=$4;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=_sprintf($11, ((STRING_TABLE.__str243693)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,tempInt));
      var $16=(($buffer)|0);
      $3=$16;
      __label__ = 2; break;
    case 2: // $17
      var $18=$2;
      var $19=__ZNK11emu_options8ini_pathEv($18);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $19, 6);
      var $20=$3;
      var $21=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 10; break; };
    case 3: // $22
      $filerr=$21;
      var $23=$filerr;
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $25
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($inistring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $26
      var $27=$2;
      var $28=$27;
      var $29=(function() { try { __THREW__ = false; return __ZN12core_options10output_iniER7astringPKS_($28, $inistring, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 11; break; };
    case 6: // $30
      var $31=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($inistring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $32
      var $33=(function() { try { __THREW__ = false; return __ZN8emu_file4putsEPKc($file, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $34
      $retval=0;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($inistring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $35
      __label__ = 13; break;
    case 10: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $5=$38;
      var $39=$37.f1;
      $6=$39;
      __label__ = 14; break;
    case 11: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $5=$42;
      var $43=$41.f1;
      $6=$43;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($inistring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $44
      __label__ = 14; break;
    case 13: // $45
      var $46=$retval;
      $1=$46;
      $7=1;
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $47=$1;
      STACKTOP = __stackBase__;
      return $47;
    case 14: // $48
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $49
      __label__ = 16; break;
    case 16: // $50
      var $51=$5;
      var $52=$5;
      var $53=$6;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12write_configR11emu_optionsPKcPK11game_driver["X"]=1;

function __Z12tilemap_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $screen_width;
      var $screen_height;
      var $10;
      var $11;
      var $12=__stackBase__+36;
      $9=$machine;
      var $13=$9;
      var $14=(($13+560)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      __label__ = 18; break;
    case 2: // $18
      var $19=$9;
      var $20=(($19+560)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=__ZNK13screen_device5widthEv($21);
      $screen_width=$22;
      var $23=$9;
      var $24=(($23+560)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__ZNK13screen_device6heightEv($25);
      $screen_height=$26;
      var $27=$screen_width;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 18; break; }
    case 3: // $29
      var $30=$screen_height;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $32
      var $33=$9;
      var $34=__ZN15running_machine7respoolEv($33);
      var $35=$4;
      var $36=$5;
      var $37=$6;
      var $38=$result_i;
      var $39=$7;
      var $40=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3708)|0);
      HEAP32[(($6)>>2)]=307;
      var $41=HEAP32[(($4)>>2)];
      var $42=HEAP32[(($5)>>2)];
      var $43=HEAP32[(($6)>>2)];
      var $44=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($41, $42, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $45
      HEAP32[(($result_i)>>2)]=$44;
      var $46=HEAP32[(($result_i)>>2)];
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $48
      var $49=___cxa_allocate_exception(4);
      var $50=$49;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($50);
      (function() { try { __THREW__ = false; return ___cxa_throw($49, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      HEAP32[(($7)>>2)]=$53;
      var $54=$52.f1;
      HEAP32[(($8)>>2)]=$54;
      var $55=HEAP32[(($8)>>2)];
      var $56=(($55)|0) < 0;
      if ($56) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $57
      var $58=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($58);
      throw "Reached an unreachable!"
    case 9: // $59
      var $60=HEAP32[(($7)>>2)];
      var $61=HEAP32[(($7)>>2)];
      var $62=HEAP32[(($8)>>2)];
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $65
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKci_exit
      var $66=HEAP32[(($result_i)>>2)];
      var $67=$4;
      var $68=$5;
      var $69=$6;
      var $70=$result_i;
      var $71=$7;
      var $72=$8;
      var $73=$66;
      var $74=$screen_width;
      var $75=$screen_height;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($73, $74, $75, 1, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $76
      var $77=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($34, $73);
      var $78=$9;
      var $79=(($78+580)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$9;
      var $81=$9;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($12, 900, ((STRING_TABLE.__str13709)|0), $81);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($80, 4, $12);
      __label__ = 18; break;
    case 13: // $82
      var $83=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $84=$83.f0;
      $10=$84;
      var $85=$83.f1;
      $11=$85;
      var $86=$1;
      var $87=$2;
      var $88=$3;
      HEAP32[(($1)>>2)]=$66;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3708)|0);
      HEAP32[(($3)>>2)]=307;
      var $89=HEAP32[(($1)>>2)];
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $91
      var $92=HEAP32[(($1)>>2)];
      var $93=HEAP32[(($2)>>2)];
      var $94=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($92, $93, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $_noexc
      __label__ = 16; break;
    case 16: // $_ZdlPvPKci_exit
      var $95=$1;
      var $96=$2;
      var $97=$3;
      __label__ = 17; break;
    case 17: // $98
      __label__ = 19; break;
    case 18: // $99
      STACKTOP = __stackBase__;
      return;
    case 19: // $100
      var $101=$10;
      var $102=$10;
      var $103=$11;
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12tilemap_initR15running_machine["X"]=1;

function __ZNK9tilemap_t7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+272)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL20gfx_elements_changedP9tilemap_t($tmap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $usedmask;
      var $isdirty;
      var $gfxnum;
      $1=$tmap;
      var $2=$1;
      var $3=(($2+92)|0);
      var $4=HEAP32[(($3)>>2)];
      $usedmask=$4;
      $isdirty=0;
      $gfxnum=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$usedmask;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $8
      var $9=$usedmask;
      var $10=$9 & 1;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $12
      var $13=$gfxnum;
      var $14=$1;
      var $15=(($14+96)|0);
      var $16=(($15+($13<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$gfxnum;
      var $19=$1;
      var $20=__ZNK9tilemap_t7machineEv($19);
      var $21=(($20+432)|0);
      var $22=(($21+($18<<2))|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+56)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($17)|0)!=(($25)|0);
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$gfxnum;
      var $29=$1;
      var $30=__ZNK9tilemap_t7machineEv($29);
      var $31=(($30+432)|0);
      var $32=(($31+($28<<2))|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+56)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$gfxnum;
      var $37=$1;
      var $38=(($37+96)|0);
      var $39=(($38+($36<<2))|0);
      HEAP32[(($39)>>2)]=$35;
      $isdirty=1;
      __label__ = 5; break;
    case 5: // $40
      __label__ = 6; break;
    case 6: // $41
      __label__ = 7; break;
    case 7: // $42
      var $43=$usedmask;
      var $44=$43 >>> 1;
      $usedmask=$44;
      var $45=$gfxnum;
      var $46=(($45+1)|0);
      $gfxnum=$46;
      __label__ = 1; break;
    case 8: // $47
      var $48=$isdirty;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20gfx_elements_changedP9tilemap_t["X"]=1;

function __ZL25configure_blit_parametersP16_blit_parametersP9tilemap_tP8bitmap_tPK10_rectanglejhh($blit, $tmap, $dest, $cliprect, $flags, $priority, $priority_mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$blit;
      $2=$tmap;
      $3=$dest;
      $4=$cliprect;
      $5=$flags;
      $6=$priority;
      $7=$priority_mask;
      var $8=$1;
      var $9=$8;
      _memset($9, 0, 36, 1);
      var $10=$3;
      var $11=$1;
      var $12=(($11)|0);
      HEAP32[(($12)>>2)]=$10;
      var $13=$4;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$1;
      var $17=(($16+4)|0);
      var $18=$4;
      var $19=$17;
      var $20=$18;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[(($20+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[(($20+8)>>2)];HEAP32[(($19+12)>>2)]=HEAP32[(($20+12)>>2)];
      __label__ = 3; break;
    case 2: // $21
      var $22=$1;
      var $23=(($22+4)|0);
      var $24=(($23+8)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=$3;
      var $29=$28;
      var $30=(($29+12)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31-1)|0);
      var $33=$1;
      var $34=(($33+4)|0);
      var $35=(($34+4)|0);
      HEAP32[(($35)>>2)]=$32;
      var $36=$3;
      var $37=$36;
      var $38=(($37+16)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-1)|0);
      var $41=$1;
      var $42=(($41+4)|0);
      var $43=(($42+12)|0);
      HEAP32[(($43)>>2)]=$40;
      __label__ = 3; break;
    case 3: // $44
      var $45=$6;
      var $46=(($45)&255);
      var $47=$7;
      var $48=(($47)&255);
      var $49=$48 << 8;
      var $50=$46 | $49;
      var $51=$2;
      var $52=(($51+84)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$53 << 16;
      var $55=$50 | $54;
      var $56=$1;
      var $57=(($56+28)|0);
      HEAP32[(($57)>>2)]=$55;
      var $58=$5;
      var $59=$58 & 256;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $61
      var $62=$5;
      var $63=$62 >>> 24;
      var $66 = $63;__label__ = 6; break;
    case 5: // $64
      var $66 = 255;__label__ = 6; break;
    case 6: // $65
      var $66;
      var $67=(($66) & 255);
      var $68=$1;
      var $69=(($68+34)|0);
      HEAP8[($69)]=$67;
      var $70=$3;
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $72
      var $73=$1;
      var $74=(($73+20)|0);
      HEAP32[(($74)>>2)]=902;
      var $75=$1;
      var $76=(($75+24)|0);
      HEAP32[(($76)>>2)]=904;
      __label__ = 26; break;
    case 8: // $77
      var $78=$3;
      var $79=$78;
      var $80=(($79+20)|0);
      var $81=HEAP32[(($80)>>2)];
      if ($81 == 6) {
        __label__ = 9; break;
      }
      else if ($81 == 5) {
        __label__ = 16; break;
      }
      else if ($81 == 2) {
        __label__ = 23; break;
      }
      else {
      __label__ = 24; break;
      }
      
    case 9: // $82
      var $83=$1;
      var $84=(($83+34)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=(($86)|0) < 255;
      if ($87) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $88
      var $91 = 910;__label__ = 12; break;
    case 11: // $89
      var $91 = 912;__label__ = 12; break;
    case 12: // $90
      var $91;
      var $92=$1;
      var $93=(($92+20)|0);
      HEAP32[(($93)>>2)]=$91;
      var $94=$1;
      var $95=(($94+34)|0);
      var $96=HEAPU8[($95)];
      var $97=(($96)&255);
      var $98=(($97)|0) < 255;
      if ($98) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $99
      var $102 = 914;__label__ = 15; break;
    case 14: // $100
      var $102 = 916;__label__ = 15; break;
    case 15: // $101
      var $102;
      var $103=$1;
      var $104=(($103+24)|0);
      HEAP32[(($104)>>2)]=$102;
      __label__ = 25; break;
    case 16: // $105
      var $106=$1;
      var $107=(($106+34)|0);
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      var $110=(($109)|0) < 255;
      if ($110) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $111
      var $114 = 918;__label__ = 19; break;
    case 18: // $112
      var $114 = 920;__label__ = 19; break;
    case 19: // $113
      var $114;
      var $115=$1;
      var $116=(($115+20)|0);
      HEAP32[(($116)>>2)]=$114;
      var $117=$1;
      var $118=(($117+34)|0);
      var $119=HEAPU8[($118)];
      var $120=(($119)&255);
      var $121=(($120)|0) < 255;
      if ($121) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $122
      var $125 = 922;__label__ = 22; break;
    case 21: // $123
      var $125 = 924;__label__ = 22; break;
    case 22: // $124
      var $125;
      var $126=$1;
      var $127=(($126+24)|0);
      HEAP32[(($127)>>2)]=$125;
      __label__ = 25; break;
    case 23: // $128
      var $129=$1;
      var $130=(($129+20)|0);
      HEAP32[(($130)>>2)]=906;
      var $131=$1;
      var $132=(($131+24)|0);
      HEAP32[(($132)>>2)]=908;
      __label__ = 25; break;
    case 24: // $133
      __Z10fatalerrorPKcz(((STRING_TABLE.__str23710)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 25: // $134
      __label__ = 26; break;
    case 26: // $135
      var $136=$1;
      var $137=(($136+32)|0);
      HEAP8[($137)]=15;
      var $138=$5;
      var $139=$138 & 15;
      var $140=(($139) & 255);
      var $141=$1;
      var $142=(($141+33)|0);
      HEAP8[($142)]=$140;
      var $143=$5;
      var $144=$143 & 112;
      var $145=(($144)|0)==0;
      if ($145) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $146
      var $147=$5;
      var $148=$147 | 16;
      $5=$148;
      __label__ = 28; break;
    case 28: // $149
      var $150=$5;
      var $151=$150 & 112;
      var $152=$1;
      var $153=(($152+32)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $156=$155 | $151;
      var $157=(($156) & 255);
      HEAP8[($153)]=$157;
      var $158=$5;
      var $159=$158 & 112;
      var $160=$1;
      var $161=(($160+33)|0);
      var $162=HEAPU8[($161)];
      var $163=(($162)&255);
      var $164=$163 | $159;
      var $165=(($164) & 255);
      HEAP8[($161)]=$165;
      var $166=$5;
      var $167=$166 & 128;
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $169
      var $170=$1;
      var $171=(($170+32)|0);
      var $172=HEAPU8[($171)];
      var $173=(($172)&255);
      var $174=$173 & -113;
      var $175=(($174) & 255);
      HEAP8[($171)]=$175;
      var $176=$1;
      var $177=(($176+33)|0);
      var $178=HEAPU8[($177)];
      var $179=(($178)&255);
      var $180=$179 & -113;
      var $181=(($180) & 255);
      HEAP8[($177)]=$181;
      __label__ = 30; break;
    case 30: // $182
      var $183=$5;
      var $184=$183 & 512;
      var $185=(($184)|0)!=0;
      if ($185) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $186
      var $187=$1;
      var $188=(($187+32)|0);
      var $189=HEAPU8[($188)];
      var $190=(($189)&255);
      var $191=$190 & -16;
      var $192=(($191) & 255);
      HEAP8[($188)]=$192;
      var $193=$1;
      var $194=(($193+33)|0);
      var $195=HEAPU8[($194)];
      var $196=(($195)&255);
      var $197=$196 & -16;
      var $198=(($197) & 255);
      HEAP8[($194)]=$198;
      __label__ = 32; break;
    case 32: // $199
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25configure_blit_parametersP16_blit_parametersP9tilemap_tP8bitmap_tPK10_rectanglejhh["X"]=1;

function __Z13tilemap_countR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tmap;
      var $count;
      $2=$machine;
      $count=0;
      var $3=$2;
      var $4=(($3+632)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 7; break;
    case 2: // $8
      var $9=$2;
      var $10=(($9+632)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      $tmap=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$tmap;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $17
      var $18=$count;
      var $19=(($18+1)|0);
      $count=$19;
      __label__ = 5; break;
    case 5: // $20
      var $21=$tmap;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      $tmap=$23;
      __label__ = 3; break;
    case 6: // $24
      var $25=$count;
      $1=$25;
      __label__ = 7; break;
    case 7: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15indexed_tilemapR15running_machinei($machine, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tmap;
      $2=$machine;
      $3=$index;
      var $4=$2;
      var $5=(($4+632)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      $tmap=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$tmap;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$3;
      var $14=(($13-1)|0);
      $3=$14;
      var $15=(($13)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$tmap;
      $1=$17;
      __label__ = 7; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$tmap;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      $tmap=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=0;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21tilemap_draw_instanceP9tilemap_tPK16_blit_parametersii($tmap, $blit, $xpos, $ypos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $priority_bitmap;
      var $dest;
      var $source_baseaddr;
      var $mask_baseaddr;
      var $dest_baseaddr;
      var $priority_baseaddr;
      var $dest_line_pitch_bytes;
      var $dest_bytespp;
      var $mincol;
      var $maxcol;
      var $x1;
      var $y1;
      var $x2;
      var $y2;
      var $y;
      var $nexty;
      var $row;
      var $prev_trans;
      var $cur_trans;
      var $x_start;
      var $column;
      var $x_end;
      var $logindex;
      var $source0;
      var $dest0;
      var $pmap0;
      var $cury;
      var $mask0;
      $1=$tmap;
      $2=$blit;
      $3=$xpos;
      $4=$ypos;
      var $5=$1;
      var $6=__ZNK9tilemap_t7machineEv($5);
      var $7=(($6+580)|0);
      var $8=HEAP32[(($7)>>2)];
      $priority_bitmap=$8;
      var $9=$2;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dest=$11;
      $dest_baseaddr=0;
      $dest_line_pitch_bytes=0;
      $dest_bytespp=0;
      var $12=$3;
      var $13=$2;
      var $14=(($13+4)|0);
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($12)|0) > (($16)|0);
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$3;
      var $26 = $19;__label__ = 3; break;
    case 2: // $20
      var $21=$2;
      var $22=(($21+4)|0);
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $26 = $24;__label__ = 3; break;
    case 3: // $25
      var $26;
      $x1=$26;
      var $27=$3;
      var $28=$1;
      var $29=(($28+20)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($27+$30)|0);
      var $32=$2;
      var $33=(($32+4)|0);
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+1)|0);
      var $37=(($31)|0) < (($36)|0);
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=$3;
      var $40=$1;
      var $41=(($40+20)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($39+$42)|0);
      var $51 = $43;__label__ = 6; break;
    case 5: // $44
      var $45=$2;
      var $46=(($45+4)|0);
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+1)|0);
      var $51 = $49;__label__ = 6; break;
    case 6: // $50
      var $51;
      $x2=$51;
      var $52=$4;
      var $53=$2;
      var $54=(($53+4)|0);
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($52)|0) > (($56)|0);
      if ($57) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $58
      var $59=$4;
      var $66 = $59;__label__ = 9; break;
    case 8: // $60
      var $61=$2;
      var $62=(($61+4)|0);
      var $63=(($62+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $66 = $64;__label__ = 9; break;
    case 9: // $65
      var $66;
      $y1=$66;
      var $67=$4;
      var $68=$1;
      var $69=(($68+24)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($67+$70)|0);
      var $72=$2;
      var $73=(($72+4)|0);
      var $74=(($73+12)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+1)|0);
      var $77=(($71)|0) < (($76)|0);
      if ($77) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $78
      var $79=$4;
      var $80=$1;
      var $81=(($80+24)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($79+$82)|0);
      var $91 = $83;__label__ = 12; break;
    case 11: // $84
      var $85=$2;
      var $86=(($85+4)|0);
      var $87=(($86+12)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+1)|0);
      var $91 = $89;__label__ = 12; break;
    case 12: // $90
      var $91;
      $y2=$91;
      var $92=$x1;
      var $93=$x2;
      var $94=(($92)|0) >= (($93)|0);
      if ($94) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $95
      var $96=$y1;
      var $97=$y2;
      var $98=(($96)|0) >= (($97)|0);
      if ($98) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $99
      __label__ = 48; break;
    case 15: // $100
      var $101=$priority_bitmap;
      var $102=$101;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$y1;
      var $106=$priority_bitmap;
      var $107=$106;
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($105*$109)|0);
      var $111=(($104+$110)|0);
      var $112=$3;
      var $113=(($111+$112)|0);
      $priority_baseaddr=$113;
      var $114=$dest;
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $116
      var $117=$dest;
      var $118=$117;
      var $119=(($118+24)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(((($120)|0)/8)|0);
      $dest_bytespp=$121;
      var $122=$dest;
      var $123=$122;
      var $124=(($123+8)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$dest_bytespp;
      var $127=(($125*$126)|0);
      $dest_line_pitch_bytes=$127;
      var $128=$dest;
      var $129=$128;
      var $130=(($129+4)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$y1;
      var $133=$dest;
      var $134=$133;
      var $135=(($134+8)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($132*$136)|0);
      var $138=$3;
      var $139=(($137+$138)|0);
      var $140=$dest_bytespp;
      var $141=(($139*$140)|0);
      var $142=(($131+$141)|0);
      $dest_baseaddr=$142;
      __label__ = 17; break;
    case 17: // $143
      var $144=$3;
      var $145=$x1;
      var $146=(($145-$144)|0);
      $x1=$146;
      var $147=$4;
      var $148=$y1;
      var $149=(($148-$147)|0);
      $y1=$149;
      var $150=$3;
      var $151=$x2;
      var $152=(($151-$150)|0);
      $x2=$152;
      var $153=$4;
      var $154=$y2;
      var $155=(($154-$153)|0);
      $y2=$155;
      var $156=$1;
      var $157=(($156+256)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$158;
      var $160=(($159+4)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$161;
      var $163=$y1;
      var $164=$1;
      var $165=(($164+256)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$166;
      var $168=(($167+8)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($163*$169)|0);
      var $171=(($162+($170<<1))|0);
      var $172=(($171)|0);
      $source_baseaddr=$172;
      var $173=$1;
      var $174=(($173+260)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=$175;
      var $177=(($176+4)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=$y1;
      var $180=$1;
      var $181=(($180+260)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$182;
      var $184=(($183+8)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($179*$185)|0);
      var $187=(($178+$186)|0);
      var $188=(($187)|0);
      $mask_baseaddr=$188;
      var $189=$x1;
      var $190=$1;
      var $191=(($190+12)|0);
      var $192=HEAPU32[(($191)>>2)];
      var $193=Math.floor((($189)>>>0)/(($192)>>>0));
      $mincol=$193;
      var $194=$x2;
      var $195=$1;
      var $196=(($195+12)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($194+$197)|0);
      var $199=(($198-1)|0);
      var $200=$1;
      var $201=(($200+12)|0);
      var $202=HEAPU32[(($201)>>2)];
      var $203=Math.floor((($199)>>>0)/(($202)>>>0));
      $maxcol=$203;
      var $204=$y1;
      $y=$204;
      var $205=$1;
      var $206=(($205+16)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$y1;
      var $209=$1;
      var $210=(($209+16)|0);
      var $211=HEAPU32[(($210)>>2)];
      var $212=Math.floor((($208)>>>0)/(($211)>>>0));
      var $213=(($207*$212)|0);
      var $214=$1;
      var $215=(($214+16)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($213+$216)|0);
      $nexty=$217;
      var $218=$nexty;
      var $219=$y2;
      var $220=(($218)|0) < (($219)|0);
      var $221=$nexty;
      var $222=$y2;
      var $223=$220 ? $221 : $222;
      $nexty=$223;
      __label__ = 18; break;
    case 18: // $224
      var $225=$y;
      var $226=$1;
      var $227=(($226+16)|0);
      var $228=HEAPU32[(($227)>>2)];
      var $229=Math.floor((($225)>>>0)/(($228)>>>0));
      $row=$229;
      $prev_trans=0;
      var $230=$x1;
      $x_start=$230;
      var $231=$mincol;
      $column=$231;
      __label__ = 19; break;
    case 19: // $232
      var $233=$column;
      var $234=$maxcol;
      var $235=(($233)|0) <= (($234)|0);
      if ($235) { __label__ = 20; break; } else { __label__ = 45; break; }
    case 20: // $236
      var $237=$column;
      var $238=$maxcol;
      var $239=(($237)|0)==(($238)|0);
      if ($239) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $240
      $cur_trans=0;
      __label__ = 28; break;
    case 22: // $241
      var $242=$row;
      var $243=$1;
      var $244=(($243+8)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=(($242*$245)|0);
      var $247=$column;
      var $248=(($246+$247)|0);
      $logindex=$248;
      var $249=$logindex;
      var $250=$1;
      var $251=(($250+264)|0);
      var $252=HEAP32[(($251)>>2)];
      var $253=(($252+$249)|0);
      var $254=HEAPU8[($253)];
      var $255=(($254)&255);
      var $256=(($255)|0)==255;
      if ($256) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $257
      var $258=$1;
      var $259=$logindex;
      var $260=$column;
      var $261=$row;
      __ZL11tile_updateP9tilemap_tjjj($258, $259, $260, $261);
      __label__ = 24; break;
    case 24: // $262
      var $263=$logindex;
      var $264=$1;
      var $265=(($264+264)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266+$263)|0);
      var $268=HEAPU8[($267)];
      var $269=(($268)&255);
      var $270=$2;
      var $271=(($270+32)|0);
      var $272=HEAPU8[($271)];
      var $273=(($272)&255);
      var $274=$269 & $273;
      var $275=(($274)|0)!=0;
      if ($275) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $276
      $cur_trans=2;
      __label__ = 27; break;
    case 26: // $277
      var $278=$column;
      var $279=$1;
      var $280=(($279+12)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($278*$281)|0);
      var $283=$mask_baseaddr;
      var $284=(($283+$282)|0);
      var $285=HEAPU8[($284)];
      var $286=(($285)&255);
      var $287=$2;
      var $288=(($287+32)|0);
      var $289=HEAPU8[($288)];
      var $290=(($289)&255);
      var $291=$286 & $290;
      var $292=$2;
      var $293=(($292+33)|0);
      var $294=HEAPU8[($293)];
      var $295=(($294)&255);
      var $296=(($291)|0)==(($295)|0);
      var $297=$296 ? 1 : 0;
      $cur_trans=$297;
      __label__ = 27; break;
    case 27: // $298
      __label__ = 28; break;
    case 28: // $299
      var $300=$cur_trans;
      var $301=$prev_trans;
      var $302=(($300)|0)==(($301)|0);
      if ($302) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $303
      __label__ = 44; break;
    case 30: // $304
      var $305=$column;
      var $306=$1;
      var $307=(($306+12)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=(($305*$308)|0);
      $x_end=$309;
      var $310=$x_end;
      var $311=$x1;
      var $312=(($310)|0) > (($311)|0);
      var $313=$x_end;
      var $314=$x1;
      var $315=$312 ? $313 : $314;
      $x_end=$315;
      var $316=$x_end;
      var $317=$x2;
      var $318=(($316)|0) < (($317)|0);
      var $319=$x_end;
      var $320=$x2;
      var $321=$318 ? $319 : $320;
      $x_end=$321;
      var $322=$prev_trans;
      var $323=(($322)|0)!=0;
      if ($323) { __label__ = 31; break; } else { __label__ = 43; break; }
    case 31: // $324
      var $325=$source_baseaddr;
      var $326=$x_start;
      var $327=(($325+($326<<1))|0);
      $source0=$327;
      var $328=$dest_baseaddr;
      var $329=$x_start;
      var $330=$dest_bytespp;
      var $331=(($329*$330)|0);
      var $332=(($328+$331)|0);
      $dest0=$332;
      var $333=$priority_baseaddr;
      var $334=$x_start;
      var $335=(($333+$334)|0);
      $pmap0=$335;
      var $336=$prev_trans;
      var $337=(($336)|0)==1;
      if ($337) { __label__ = 32; break; } else { __label__ = 37; break; }
    case 32: // $338
      var $339=$y;
      $cury=$339;
      __label__ = 33; break;
    case 33: // $340
      var $341=$cury;
      var $342=$nexty;
      var $343=(($341)|0) < (($342)|0);
      if ($343) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $344
      var $345=$2;
      var $346=(($345+24)|0);
      var $347=HEAP32[(($346)>>2)];
      var $348=$dest0;
      var $349=$source0;
      var $350=$x_end;
      var $351=$x_start;
      var $352=(($350-$351)|0);
      var $353=$1;
      var $354=__ZNK9tilemap_t7machineEv($353);
      var $355=(($354+568)|0);
      var $356=HEAP32[(($355)>>2)];
      var $357=$pmap0;
      var $358=$2;
      var $359=(($358+28)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=$2;
      var $362=(($361+34)|0);
      var $363=HEAP8[($362)];
      FUNCTION_TABLE[$347]($348, $349, $352, $356, $357, $360, $363);
      var $364=$dest0;
      var $365=$dest_line_pitch_bytes;
      var $366=(($364+$365)|0);
      $dest0=$366;
      var $367=$1;
      var $368=(($367+256)|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=$369;
      var $371=(($370+8)|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=$source0;
      var $374=(($373+($372<<1))|0);
      $source0=$374;
      var $375=$priority_bitmap;
      var $376=$375;
      var $377=(($376+8)|0);
      var $378=HEAP32[(($377)>>2)];
      var $379=$pmap0;
      var $380=(($379+$378)|0);
      $pmap0=$380;
      __label__ = 35; break;
    case 35: // $381
      var $382=$cury;
      var $383=(($382+1)|0);
      $cury=$383;
      __label__ = 33; break;
    case 36: // $384
      __label__ = 42; break;
    case 37: // $385
      var $386=$mask_baseaddr;
      var $387=$x_start;
      var $388=(($386+$387)|0);
      $mask0=$388;
      var $389=$y;
      $cury=$389;
      __label__ = 38; break;
    case 38: // $390
      var $391=$cury;
      var $392=$nexty;
      var $393=(($391)|0) < (($392)|0);
      if ($393) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $394
      var $395=$2;
      var $396=(($395+20)|0);
      var $397=HEAP32[(($396)>>2)];
      var $398=$dest0;
      var $399=$source0;
      var $400=$mask0;
      var $401=$2;
      var $402=(($401+32)|0);
      var $403=HEAPU8[($402)];
      var $404=(($403)&255);
      var $405=$2;
      var $406=(($405+33)|0);
      var $407=HEAPU8[($406)];
      var $408=(($407)&255);
      var $409=$x_end;
      var $410=$x_start;
      var $411=(($409-$410)|0);
      var $412=$1;
      var $413=__ZNK9tilemap_t7machineEv($412);
      var $414=(($413+568)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=$pmap0;
      var $417=$2;
      var $418=(($417+28)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=$2;
      var $421=(($420+34)|0);
      var $422=HEAP8[($421)];
      FUNCTION_TABLE[$397]($398, $399, $400, $404, $408, $411, $415, $416, $419, $422);
      var $423=$dest0;
      var $424=$dest_line_pitch_bytes;
      var $425=(($423+$424)|0);
      $dest0=$425;
      var $426=$1;
      var $427=(($426+256)|0);
      var $428=HEAP32[(($427)>>2)];
      var $429=$428;
      var $430=(($429+8)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=$source0;
      var $433=(($432+($431<<1))|0);
      $source0=$433;
      var $434=$1;
      var $435=(($434+260)|0);
      var $436=HEAP32[(($435)>>2)];
      var $437=$436;
      var $438=(($437+8)|0);
      var $439=HEAP32[(($438)>>2)];
      var $440=$mask0;
      var $441=(($440+$439)|0);
      $mask0=$441;
      var $442=$priority_bitmap;
      var $443=$442;
      var $444=(($443+8)|0);
      var $445=HEAP32[(($444)>>2)];
      var $446=$pmap0;
      var $447=(($446+$445)|0);
      $pmap0=$447;
      __label__ = 40; break;
    case 40: // $448
      var $449=$cury;
      var $450=(($449+1)|0);
      $cury=$450;
      __label__ = 38; break;
    case 41: // $451
      __label__ = 42; break;
    case 42: // $452
      __label__ = 43; break;
    case 43: // $453
      var $454=$x_end;
      $x_start=$454;
      var $455=$cur_trans;
      $prev_trans=$455;
      __label__ = 44; break;
    case 44: // $456
      var $457=$column;
      var $458=(($457+1)|0);
      $column=$458;
      __label__ = 19; break;
    case 45: // $459
      var $460=$nexty;
      var $461=$y2;
      var $462=(($460)|0)==(($461)|0);
      if ($462) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $463
      __label__ = 48; break;
    case 47: // $464
      var $465=$priority_bitmap;
      var $466=$465;
      var $467=(($466+8)|0);
      var $468=HEAP32[(($467)>>2)];
      var $469=$nexty;
      var $470=$y;
      var $471=(($469-$470)|0);
      var $472=(($468*$471)|0);
      var $473=$priority_baseaddr;
      var $474=(($473+$472)|0);
      $priority_baseaddr=$474;
      var $475=$1;
      var $476=(($475+256)|0);
      var $477=HEAP32[(($476)>>2)];
      var $478=$477;
      var $479=(($478+8)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=$nexty;
      var $482=$y;
      var $483=(($481-$482)|0);
      var $484=(($480*$483)|0);
      var $485=$source_baseaddr;
      var $486=(($485+($484<<1))|0);
      $source_baseaddr=$486;
      var $487=$1;
      var $488=(($487+260)|0);
      var $489=HEAP32[(($488)>>2)];
      var $490=$489;
      var $491=(($490+8)|0);
      var $492=HEAP32[(($491)>>2)];
      var $493=$nexty;
      var $494=$y;
      var $495=(($493-$494)|0);
      var $496=(($492*$495)|0);
      var $497=$mask_baseaddr;
      var $498=(($497+$496)|0);
      $mask_baseaddr=$498;
      var $499=$dest_baseaddr;
      var $500=$dest_line_pitch_bytes;
      var $501=$nexty;
      var $502=$y;
      var $503=(($501-$502)|0);
      var $504=(($500*$503)|0);
      var $505=(($499+$504)|0);
      $dest_baseaddr=$505;
      var $506=$nexty;
      $y=$506;
      var $507=$1;
      var $508=(($507+16)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=$nexty;
      var $511=(($510+$509)|0);
      $nexty=$511;
      var $512=$nexty;
      var $513=$y2;
      var $514=(($512)|0) < (($513)|0);
      var $515=$nexty;
      var $516=$y2;
      var $517=$514 ? $515 : $516;
      $nexty=$517;
      __label__ = 18; break;
    case 48: // $518
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21tilemap_draw_instanceP9tilemap_tPK16_blit_parametersii["X"]=1;

function __Z21tilemap_size_by_indexR15running_machineiPjS1_($machine, $number, $width, $height) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $tmap;
  $1=$machine;
  $2=$number;
  $3=$width;
  $4=$height;
  var $5=$1;
  var $6=$2;
  var $7=__ZL15indexed_tilemapR15running_machinei($5, $6);
  $tmap=$7;
  var $8=$tmap;
  var $9=(($8+20)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$3;
  HEAP32[(($11)>>2)]=$10;
  var $12=$tmap;
  var $13=(($12+24)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$4;
  HEAP32[(($15)>>2)]=$14;
  ;
  return;
}


function __Z21tilemap_draw_by_indexR15running_machineP8bitmap_tijj($machine, $dest, $number, $scrollx, $scrolly) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tmap;
      var $blit=__stackBase__;
      var $xpos;
      var $ypos;
      $1=$machine;
      $2=$dest;
      $3=$number;
      $4=$scrollx;
      $5=$scrolly;
      var $6=$1;
      var $7=$3;
      var $8=__ZL15indexed_tilemapR15running_machinei($6, $7);
      $tmap=$8;
      var $9=$tmap;
      var $10=$2;
      __ZL25configure_blit_parametersP16_blit_parametersP9tilemap_tP8bitmap_tPK10_rectanglejhh($blit, $9, $10, 0, 640, 0, -1);
      var $11=$tmap;
      var $12=(($11+20)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$4;
      var $15=$tmap;
      var $16=(($15+20)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=(($14)>>>0)%(($17)>>>0);
      var $19=(($13-$18)|0);
      $4=$19;
      var $20=$tmap;
      var $21=(($20+24)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$5;
      var $24=$tmap;
      var $25=(($24+24)|0);
      var $26=HEAPU32[(($25)>>2)];
      var $27=(($23)>>>0)%(($26)>>>0);
      var $28=(($22-$27)|0);
      $5=$28;
      var $29=$tmap;
      var $30=(($29+82)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24)!=0;
      if ($32) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $33
      var $34=$tmap;
      var $35=__ZL20gfx_elements_changedP9tilemap_t($34);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $37
      var $38=$tmap;
      var $39=(($38+264)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$tmap;
      var $42=(($41+36)|0);
      var $43=HEAP32[(($42)>>2)];
      _memset($40, -1, $43, 1);
      var $44=$tmap;
      var $45=(($44+82)|0);
      HEAP8[($45)]=0;
      var $46=$tmap;
      var $47=(($46+92)|0);
      HEAP32[(($47)>>2)]=0;
      __label__ = 3; break;
    case 3: // $48
      var $49=$5;
      var $50=$tmap;
      var $51=(($50+24)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49-$52)|0);
      $ypos=$53;
      __label__ = 4; break;
    case 4: // $54
      var $55=$ypos;
      var $56=(($blit+4)|0);
      var $57=(($56+12)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($55)|0) <= (($58)|0);
      if ($59) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $60
      var $61=$4;
      var $62=$tmap;
      var $63=(($62+20)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($61-$64)|0);
      $xpos=$65;
      __label__ = 6; break;
    case 6: // $66
      var $67=$xpos;
      var $68=(($blit+4)|0);
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($67)|0) <= (($70)|0);
      if ($71) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $72
      var $73=$tmap;
      var $74=$xpos;
      var $75=$ypos;
      __ZL21tilemap_draw_instanceP9tilemap_tPK16_blit_parametersii($73, $blit, $74, $75);
      __label__ = 8; break;
    case 8: // $76
      var $77=$tmap;
      var $78=(($77+20)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$xpos;
      var $81=(($80+$79)|0);
      $xpos=$81;
      __label__ = 6; break;
    case 9: // $82
      __label__ = 10; break;
    case 10: // $83
      var $84=$tmap;
      var $85=(($84+24)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$ypos;
      var $88=(($87+$86)|0);
      $ypos=$88;
      __label__ = 4; break;
    case 11: // $89
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21tilemap_draw_by_indexR15running_machineP8bitmap_tijj["X"]=1;

function __ZL15alpha_blend_r32jjh3730($d, $s, $level) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $alphad;
  $1=$d;
  $2=$s;
  $3=$level;
  var $4=$3;
  var $5=(($4)&255);
  var $6=((256-$5)|0);
  $alphad=$6;
  var $7=$2;
  var $8=$7 & 255;
  var $9=$3;
  var $10=(($9)&255);
  var $11=(($8*$10)|0);
  var $12=$1;
  var $13=$12 & 255;
  var $14=$alphad;
  var $15=(($13*$14)|0);
  var $16=(($11+$15)|0);
  var $17=$16 >>> 8;
  var $18=$2;
  var $19=$18 & 65280;
  var $20=$3;
  var $21=(($20)&255);
  var $22=(($19*$21)|0);
  var $23=$1;
  var $24=$23 & 65280;
  var $25=$alphad;
  var $26=(($24*$25)|0);
  var $27=(($22+$26)|0);
  var $28=$27 >>> 8;
  var $29=$28 & 65280;
  var $30=$17 | $29;
  var $31=$2;
  var $32=$31 & 16711680;
  var $33=$3;
  var $34=(($33)&255);
  var $35=(($32*$34)|0);
  var $36=$1;
  var $37=$36 & 16711680;
  var $38=$alphad;
  var $39=(($37*$38)|0);
  var $40=(($35+$39)|0);
  var $41=$40 >>> 8;
  var $42=$41 & 16711680;
  var $43=$30 | $42;
  ;
  return $43;
}


function __ZL15alpha_blend_r16jjh3731($d, $s, $level) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $alphad;
  $1=$d;
  $2=$s;
  $3=$level;
  var $4=$3;
  var $5=(($4)&255);
  var $6=((256-$5)|0);
  $alphad=$6;
  var $7=$2;
  var $8=$7 & 31;
  var $9=$3;
  var $10=(($9)&255);
  var $11=(($8*$10)|0);
  var $12=$1;
  var $13=$12 & 31;
  var $14=$alphad;
  var $15=(($13*$14)|0);
  var $16=(($11+$15)|0);
  var $17=$16 >>> 8;
  var $18=$2;
  var $19=$18 & 992;
  var $20=$3;
  var $21=(($20)&255);
  var $22=(($19*$21)|0);
  var $23=$1;
  var $24=$23 & 992;
  var $25=$alphad;
  var $26=(($24*$25)|0);
  var $27=(($22+$26)|0);
  var $28=$27 >>> 8;
  var $29=$28 & 992;
  var $30=$17 | $29;
  var $31=$2;
  var $32=$31 & 31744;
  var $33=$3;
  var $34=(($33)&255);
  var $35=(($32*$34)|0);
  var $36=$1;
  var $37=$36 & 31744;
  var $38=$alphad;
  var $39=(($37*$38)|0);
  var $40=(($35+$39)|0);
  var $41=$40 >>> 8;
  var $42=$41 & 31744;
  var $43=$30 | $42;
  ;
  return $43;
}


function __ZL26scanline_draw_masked_ind16PvPKtPKhiiiPKjPhjh($_dest, $source, $maskptr, $mask, $value, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $dest;
      var $pal;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$maskptr;
      $4=$mask;
      $5=$value;
      $6=$count;
      $7=$pens;
      $8=$pri;
      $9=$pcode;
      $10=$alpha;
      var $11=$1;
      var $12=$11;
      $dest=$12;
      var $13=$9;
      var $14=$13 >>> 16;
      $pal=$14;
      var $15=$9;
      var $16=$15 & 65535;
      var $17=(($16)|0)!=65280;
      if ($17) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $18
      $i=0;
      __label__ = 2; break;
    case 2: // $19
      var $20=$i;
      var $21=$6;
      var $22=(($20)|0) < (($21)|0);
      if ($22) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $23
      var $24=$i;
      var $25=$3;
      var $26=(($25+$24)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$4;
      var $30=$28 & $29;
      var $31=$5;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $33
      var $34=$i;
      var $35=$2;
      var $36=(($35+($34<<1))|0);
      var $37=HEAPU16[(($36)>>1)];
      var $38=(($37)&65535);
      var $39=$pal;
      var $40=(($38+$39)|0);
      var $41=(($40) & 65535);
      var $42=$i;
      var $43=$dest;
      var $44=(($43+($42<<1))|0);
      HEAP16[(($44)>>1)]=$41;
      var $45=$i;
      var $46=$8;
      var $47=(($46+$45)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$9;
      var $51=$50 >>> 8;
      var $52=$49 & $51;
      var $53=$9;
      var $54=$52 | $53;
      var $55=(($54) & 255);
      var $56=$i;
      var $57=$8;
      var $58=(($57+$56)|0);
      HEAP8[($58)]=$55;
      __label__ = 5; break;
    case 5: // $59
      __label__ = 6; break;
    case 6: // $60
      var $61=$i;
      var $62=(($61+1)|0);
      $i=$62;
      __label__ = 2; break;
    case 7: // $63
      __label__ = 15; break;
    case 8: // $64
      $i=0;
      __label__ = 9; break;
    case 9: // $65
      var $66=$i;
      var $67=$6;
      var $68=(($66)|0) < (($67)|0);
      if ($68) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $69
      var $70=$i;
      var $71=$3;
      var $72=(($71+$70)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$4;
      var $76=$74 & $75;
      var $77=$5;
      var $78=(($76)|0)==(($77)|0);
      if ($78) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $79
      var $80=$i;
      var $81=$2;
      var $82=(($81+($80<<1))|0);
      var $83=HEAPU16[(($82)>>1)];
      var $84=(($83)&65535);
      var $85=$pal;
      var $86=(($84+$85)|0);
      var $87=(($86) & 65535);
      var $88=$i;
      var $89=$dest;
      var $90=(($89+($88<<1))|0);
      HEAP16[(($90)>>1)]=$87;
      __label__ = 12; break;
    case 12: // $91
      __label__ = 13; break;
    case 13: // $92
      var $93=$i;
      var $94=(($93+1)|0);
      $i=$94;
      __label__ = 9; break;
    case 14: // $95
      __label__ = 15; break;
    case 15: // $96
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26scanline_draw_masked_ind16PvPKtPKhiiiPKjPhjh["X"]=1;

function __ZL26scanline_draw_masked_rgb32PvPKtPKhiiiPKjPhjh($_dest, $source, $maskptr, $mask, $value, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$maskptr;
      $4=$mask;
      $5=$value;
      $6=$count;
      $7=$pens;
      $8=$pri;
      $9=$pcode;
      $10=$alpha;
      var $11=$9;
      var $12=$11 >>> 16;
      var $13=$7;
      var $14=(($13+($12<<2))|0);
      $clut=$14;
      var $15=$1;
      var $16=$15;
      $dest=$16;
      var $17=$9;
      var $18=$17 & 65535;
      var $19=(($18)|0)!=65280;
      if ($19) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $20
      $i=0;
      __label__ = 2; break;
    case 2: // $21
      var $22=$i;
      var $23=$6;
      var $24=(($22)|0) < (($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $25
      var $26=$i;
      var $27=$3;
      var $28=(($27+$26)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$4;
      var $32=$30 & $31;
      var $33=$5;
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$i;
      var $37=$2;
      var $38=(($37+($36<<1))|0);
      var $39=HEAPU16[(($38)>>1)];
      var $40=(($39)&65535);
      var $41=$clut;
      var $42=(($41+($40<<2))|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$i;
      var $45=$dest;
      var $46=(($45+($44<<2))|0);
      HEAP32[(($46)>>2)]=$43;
      var $47=$i;
      var $48=$8;
      var $49=(($48+$47)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$9;
      var $53=$52 >>> 8;
      var $54=$51 & $53;
      var $55=$9;
      var $56=$54 | $55;
      var $57=(($56) & 255);
      var $58=$i;
      var $59=$8;
      var $60=(($59+$58)|0);
      HEAP8[($60)]=$57;
      __label__ = 5; break;
    case 5: // $61
      __label__ = 6; break;
    case 6: // $62
      var $63=$i;
      var $64=(($63+1)|0);
      $i=$64;
      __label__ = 2; break;
    case 7: // $65
      __label__ = 15; break;
    case 8: // $66
      $i=0;
      __label__ = 9; break;
    case 9: // $67
      var $68=$i;
      var $69=$6;
      var $70=(($68)|0) < (($69)|0);
      if ($70) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $71
      var $72=$i;
      var $73=$3;
      var $74=(($73+$72)|0);
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=$4;
      var $78=$76 & $77;
      var $79=$5;
      var $80=(($78)|0)==(($79)|0);
      if ($80) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $81
      var $82=$i;
      var $83=$2;
      var $84=(($83+($82<<1))|0);
      var $85=HEAPU16[(($84)>>1)];
      var $86=(($85)&65535);
      var $87=$clut;
      var $88=(($87+($86<<2))|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$i;
      var $91=$dest;
      var $92=(($91+($90<<2))|0);
      HEAP32[(($92)>>2)]=$89;
      __label__ = 12; break;
    case 12: // $93
      __label__ = 13; break;
    case 13: // $94
      var $95=$i;
      var $96=(($95+1)|0);
      $i=$96;
      __label__ = 9; break;
    case 14: // $97
      __label__ = 15; break;
    case 15: // $98
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26scanline_draw_masked_rgb32PvPKtPKhiiiPKjPhjh["X"]=1;

function __ZL26scanline_draw_masked_rgb16PvPKtPKhiiiPKjPhjh($_dest, $source, $maskptr, $mask, $value, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$maskptr;
      $4=$mask;
      $5=$value;
      $6=$count;
      $7=$pens;
      $8=$pri;
      $9=$pcode;
      $10=$alpha;
      var $11=$9;
      var $12=$11 >>> 16;
      var $13=$7;
      var $14=(($13+($12<<2))|0);
      $clut=$14;
      var $15=$1;
      var $16=$15;
      $dest=$16;
      var $17=$9;
      var $18=$17 & 65535;
      var $19=(($18)|0)!=65280;
      if ($19) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $20
      $i=0;
      __label__ = 2; break;
    case 2: // $21
      var $22=$i;
      var $23=$6;
      var $24=(($22)|0) < (($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $25
      var $26=$i;
      var $27=$3;
      var $28=(($27+$26)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$4;
      var $32=$30 & $31;
      var $33=$5;
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$i;
      var $37=$2;
      var $38=(($37+($36<<1))|0);
      var $39=HEAPU16[(($38)>>1)];
      var $40=(($39)&65535);
      var $41=$clut;
      var $42=(($41+($40<<2))|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43) & 65535);
      var $45=$i;
      var $46=$dest;
      var $47=(($46+($45<<1))|0);
      HEAP16[(($47)>>1)]=$44;
      var $48=$i;
      var $49=$8;
      var $50=(($49+$48)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=$9;
      var $54=$53 >>> 8;
      var $55=$52 & $54;
      var $56=$9;
      var $57=$55 | $56;
      var $58=(($57) & 255);
      var $59=$i;
      var $60=$8;
      var $61=(($60+$59)|0);
      HEAP8[($61)]=$58;
      __label__ = 5; break;
    case 5: // $62
      __label__ = 6; break;
    case 6: // $63
      var $64=$i;
      var $65=(($64+1)|0);
      $i=$65;
      __label__ = 2; break;
    case 7: // $66
      __label__ = 15; break;
    case 8: // $67
      $i=0;
      __label__ = 9; break;
    case 9: // $68
      var $69=$i;
      var $70=$6;
      var $71=(($69)|0) < (($70)|0);
      if ($71) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $72
      var $73=$i;
      var $74=$3;
      var $75=(($74+$73)|0);
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$4;
      var $79=$77 & $78;
      var $80=$5;
      var $81=(($79)|0)==(($80)|0);
      if ($81) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $82
      var $83=$i;
      var $84=$2;
      var $85=(($84+($83<<1))|0);
      var $86=HEAPU16[(($85)>>1)];
      var $87=(($86)&65535);
      var $88=$clut;
      var $89=(($88+($87<<2))|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90) & 65535);
      var $92=$i;
      var $93=$dest;
      var $94=(($93+($92<<1))|0);
      HEAP16[(($94)>>1)]=$91;
      __label__ = 12; break;
    case 12: // $95
      __label__ = 13; break;
    case 13: // $96
      var $97=$i;
      var $98=(($97+1)|0);
      $i=$98;
      __label__ = 9; break;
    case 14: // $99
      __label__ = 15; break;
    case 15: // $100
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26scanline_draw_masked_rgb16PvPKtPKhiiiPKjPhjh["X"]=1;

function __ZL32scanline_draw_masked_rgb32_alphaPvPKtPKhiiiPKjPhjh($_dest, $source, $maskptr, $mask, $value, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$maskptr;
      $4=$mask;
      $5=$value;
      $6=$count;
      $7=$pens;
      $8=$pri;
      $9=$pcode;
      $10=$alpha;
      var $11=$9;
      var $12=$11 >>> 16;
      var $13=$7;
      var $14=(($13+($12<<2))|0);
      $clut=$14;
      var $15=$1;
      var $16=$15;
      $dest=$16;
      var $17=$9;
      var $18=$17 & 65535;
      var $19=(($18)|0)!=65280;
      if ($19) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $20
      $i=0;
      __label__ = 2; break;
    case 2: // $21
      var $22=$i;
      var $23=$6;
      var $24=(($22)|0) < (($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $25
      var $26=$i;
      var $27=$3;
      var $28=(($27+$26)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$4;
      var $32=$30 & $31;
      var $33=$5;
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$i;
      var $37=$dest;
      var $38=(($37+($36<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$i;
      var $41=$2;
      var $42=(($41+($40<<1))|0);
      var $43=HEAPU16[(($42)>>1)];
      var $44=(($43)&65535);
      var $45=$clut;
      var $46=(($45+($44<<2))|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$10;
      var $49=__ZL15alpha_blend_r32jjh3730($39, $47, $48);
      var $50=$i;
      var $51=$dest;
      var $52=(($51+($50<<2))|0);
      HEAP32[(($52)>>2)]=$49;
      var $53=$i;
      var $54=$8;
      var $55=(($54+$53)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$9;
      var $59=$58 >>> 8;
      var $60=$57 & $59;
      var $61=$9;
      var $62=$60 | $61;
      var $63=(($62) & 255);
      var $64=$i;
      var $65=$8;
      var $66=(($65+$64)|0);
      HEAP8[($66)]=$63;
      __label__ = 5; break;
    case 5: // $67
      __label__ = 6; break;
    case 6: // $68
      var $69=$i;
      var $70=(($69+1)|0);
      $i=$70;
      __label__ = 2; break;
    case 7: // $71
      __label__ = 15; break;
    case 8: // $72
      $i=0;
      __label__ = 9; break;
    case 9: // $73
      var $74=$i;
      var $75=$6;
      var $76=(($74)|0) < (($75)|0);
      if ($76) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $77
      var $78=$i;
      var $79=$3;
      var $80=(($79+$78)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=$4;
      var $84=$82 & $83;
      var $85=$5;
      var $86=(($84)|0)==(($85)|0);
      if ($86) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $87
      var $88=$i;
      var $89=$dest;
      var $90=(($89+($88<<2))|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$i;
      var $93=$2;
      var $94=(($93+($92<<1))|0);
      var $95=HEAPU16[(($94)>>1)];
      var $96=(($95)&65535);
      var $97=$clut;
      var $98=(($97+($96<<2))|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$10;
      var $101=__ZL15alpha_blend_r32jjh3730($91, $99, $100);
      var $102=$i;
      var $103=$dest;
      var $104=(($103+($102<<2))|0);
      HEAP32[(($104)>>2)]=$101;
      __label__ = 12; break;
    case 12: // $105
      __label__ = 13; break;
    case 13: // $106
      var $107=$i;
      var $108=(($107+1)|0);
      $i=$108;
      __label__ = 9; break;
    case 14: // $109
      __label__ = 15; break;
    case 15: // $110
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32scanline_draw_masked_rgb32_alphaPvPKtPKhiiiPKjPhjh["X"]=1;

function __ZL32scanline_draw_masked_rgb16_alphaPvPKtPKhiiiPKjPhjh($_dest, $source, $maskptr, $mask, $value, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$maskptr;
      $4=$mask;
      $5=$value;
      $6=$count;
      $7=$pens;
      $8=$pri;
      $9=$pcode;
      $10=$alpha;
      var $11=$9;
      var $12=$11 >>> 16;
      var $13=$7;
      var $14=(($13+($12<<2))|0);
      $clut=$14;
      var $15=$1;
      var $16=$15;
      $dest=$16;
      var $17=$9;
      var $18=$17 & 65535;
      var $19=(($18)|0)!=65280;
      if ($19) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $20
      $i=0;
      __label__ = 2; break;
    case 2: // $21
      var $22=$i;
      var $23=$6;
      var $24=(($22)|0) < (($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $25
      var $26=$i;
      var $27=$3;
      var $28=(($27+$26)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$4;
      var $32=$30 & $31;
      var $33=$5;
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$i;
      var $37=$dest;
      var $38=(($37+($36<<1))|0);
      var $39=HEAPU16[(($38)>>1)];
      var $40=(($39)&65535);
      var $41=$i;
      var $42=$2;
      var $43=(($42+($41<<1))|0);
      var $44=HEAPU16[(($43)>>1)];
      var $45=(($44)&65535);
      var $46=$clut;
      var $47=(($46+($45<<2))|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$10;
      var $50=__ZL15alpha_blend_r16jjh3731($40, $48, $49);
      var $51=(($50) & 65535);
      var $52=$i;
      var $53=$dest;
      var $54=(($53+($52<<1))|0);
      HEAP16[(($54)>>1)]=$51;
      var $55=$i;
      var $56=$8;
      var $57=(($56+$55)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=$9;
      var $61=$60 >>> 8;
      var $62=$59 & $61;
      var $63=$9;
      var $64=$62 | $63;
      var $65=(($64) & 255);
      var $66=$i;
      var $67=$8;
      var $68=(($67+$66)|0);
      HEAP8[($68)]=$65;
      __label__ = 5; break;
    case 5: // $69
      __label__ = 6; break;
    case 6: // $70
      var $71=$i;
      var $72=(($71+1)|0);
      $i=$72;
      __label__ = 2; break;
    case 7: // $73
      __label__ = 15; break;
    case 8: // $74
      $i=0;
      __label__ = 9; break;
    case 9: // $75
      var $76=$i;
      var $77=$6;
      var $78=(($76)|0) < (($77)|0);
      if ($78) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $79
      var $80=$i;
      var $81=$3;
      var $82=(($81+$80)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$4;
      var $86=$84 & $85;
      var $87=$5;
      var $88=(($86)|0)==(($87)|0);
      if ($88) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $89
      var $90=$i;
      var $91=$dest;
      var $92=(($91+($90<<1))|0);
      var $93=HEAPU16[(($92)>>1)];
      var $94=(($93)&65535);
      var $95=$i;
      var $96=$2;
      var $97=(($96+($95<<1))|0);
      var $98=HEAPU16[(($97)>>1)];
      var $99=(($98)&65535);
      var $100=$clut;
      var $101=(($100+($99<<2))|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$10;
      var $104=__ZL15alpha_blend_r16jjh3731($94, $102, $103);
      var $105=(($104) & 65535);
      var $106=$i;
      var $107=$dest;
      var $108=(($107+($106<<1))|0);
      HEAP16[(($108)>>1)]=$105;
      __label__ = 12; break;
    case 12: // $109
      __label__ = 13; break;
    case 13: // $110
      var $111=$i;
      var $112=(($111+1)|0);
      $i=$112;
      __label__ = 9; break;
    case 14: // $113
      __label__ = 15; break;
    case 15: // $114
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32scanline_draw_masked_rgb16_alphaPvPKtPKhiiiPKjPhjh["X"]=1;

function __ZL9tile_drawP9tilemap_tPKhjjjhhhh($tmap, $pendata, $x0, $y0, $palette_base, $category, $group, $flags, $pen_mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $penmap;
      var $flagsmap;
      var $pixmap;
      var $height;
      var $width;
      var $andmask;
      var $ormask;
      var $dx0;
      var $dy0;
      var $tx;
      var $ty;
      var $pixptr;
      var $flagsptr;
      var $xoffs;
      var $pen;
      var $map;
      var $data;
      var $pen1;
      var $map2;
      $1=$tmap;
      $2=$pendata;
      $3=$x0;
      $4=$y0;
      $5=$palette_base;
      $6=$category;
      $7=$group;
      $8=$flags;
      $9=$pen_mask;
      var $10=$1;
      var $11=(($10+268)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$7;
      var $14=(($13)&255);
      var $15=((($14<<8))|0);
      var $16=(($12+$15)|0);
      $penmap=$16;
      var $17=$1;
      var $18=(($17+260)|0);
      var $19=HEAP32[(($18)>>2)];
      $flagsmap=$19;
      var $20=$1;
      var $21=(($20+256)|0);
      var $22=HEAP32[(($21)>>2)];
      $pixmap=$22;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      $height=$25;
      var $26=$1;
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      $width=$28;
      $andmask=-1;
      $ormask=0;
      $dx0=1;
      $dy0=1;
      var $29=$8;
      var $30=(($29)&255);
      var $31=$30 & 112;
      var $32=$6;
      var $33=(($32)&255);
      var $34=$33 | $31;
      var $35=(($34) & 255);
      $6=$35;
      var $36=$8;
      var $37=(($36)&255);
      var $38=$37 & 2;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $40
      var $41=$height;
      var $42=(($41-1)|0);
      var $43=$4;
      var $44=(($43+$42)|0);
      $4=$44;
      $dy0=-1;
      __label__ = 2; break;
    case 2: // $45
      var $46=$8;
      var $47=(($46)&255);
      var $48=$47 & 1;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $50
      var $51=$width;
      var $52=(($51-1)|0);
      var $53=$3;
      var $54=(($53+$52)|0);
      $3=$54;
      $dx0=-1;
      __label__ = 4; break;
    case 4: // $55
      var $56=$8;
      var $57=(($56)&255);
      var $58=$57 & 4;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $60
      __label__ = 6; break;
    case 6: // $61
      __label__ = 7; break;
    case 7: // $62
      var $63=$width;
      var $64=(((($63)|0)/2)|0);
      $width=$64;
      __label__ = 8; break;
    case 8: // $65
      $ty=0;
      __label__ = 9; break;
    case 9: // $66
      var $67=$ty;
      var $68=$height;
      var $69=(($67)|0) < (($68)|0);
      if ($69) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $70
      var $71=$pixmap;
      var $72=$71;
      var $73=(($72+4)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$74;
      var $76=$4;
      var $77=$pixmap;
      var $78=$77;
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($76*$80)|0);
      var $82=(($75+($81<<1))|0);
      var $83=$3;
      var $84=(($82+($83<<1))|0);
      $pixptr=$84;
      var $85=$flagsmap;
      var $86=$85;
      var $87=(($86+4)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$4;
      var $90=$flagsmap;
      var $91=$90;
      var $92=(($91+8)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($89*$93)|0);
      var $95=(($88+$94)|0);
      var $96=$3;
      var $97=(($95+$96)|0);
      $flagsptr=$97;
      $xoffs=0;
      var $98=$dy0;
      var $99=$4;
      var $100=(($99+$98)|0);
      $4=$100;
      var $101=$8;
      var $102=(($101)&255);
      var $103=$102 & 4;
      var $104=(($103)|0)!=0;
      if ($104) { __label__ = 16; break; } else { __label__ = 11; break; }
    case 11: // $105
      $tx=0;
      __label__ = 12; break;
    case 12: // $106
      var $107=$tx;
      var $108=$width;
      var $109=(($107)|0) < (($108)|0);
      if ($109) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $110
      var $111=$2;
      var $112=(($111+1)|0);
      $2=$112;
      var $113=HEAPU8[($111)];
      var $114=(($113)&255);
      var $115=$9;
      var $116=(($115)&255);
      var $117=$114 & $116;
      var $118=(($117) & 255);
      $pen=$118;
      var $119=$pen;
      var $120=(($119)&255);
      var $121=$penmap;
      var $122=(($121+$120)|0);
      var $123=HEAP8[($122)];
      $map=$123;
      var $124=$5;
      var $125=$pen;
      var $126=(($125)&255);
      var $127=(($124+$126)|0);
      var $128=(($127) & 65535);
      var $129=$xoffs;
      var $130=$pixptr;
      var $131=(($130+($129<<1))|0);
      HEAP16[(($131)>>1)]=$128;
      var $132=$map;
      var $133=(($132)&255);
      var $134=$6;
      var $135=(($134)&255);
      var $136=$133 | $135;
      var $137=(($136) & 255);
      var $138=$xoffs;
      var $139=$flagsptr;
      var $140=(($139+$138)|0);
      HEAP8[($140)]=$137;
      var $141=$map;
      var $142=(($141)&255);
      var $143=$andmask;
      var $144=(($143)&255);
      var $145=$144 & $142;
      var $146=(($145) & 255);
      $andmask=$146;
      var $147=$map;
      var $148=(($147)&255);
      var $149=$ormask;
      var $150=(($149)&255);
      var $151=$150 | $148;
      var $152=(($151) & 255);
      $ormask=$152;
      var $153=$dx0;
      var $154=$xoffs;
      var $155=(($154+$153)|0);
      $xoffs=$155;
      __label__ = 14; break;
    case 14: // $156
      var $157=$tx;
      var $158=(($157+1)|0);
      $tx=$158;
      __label__ = 12; break;
    case 15: // $159
      __label__ = 21; break;
    case 16: // $160
      $tx=0;
      __label__ = 17; break;
    case 17: // $161
      var $162=$tx;
      var $163=$width;
      var $164=(($162)|0) < (($163)|0);
      if ($164) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $165
      var $166=$2;
      var $167=(($166+1)|0);
      $2=$167;
      var $168=HEAP8[($166)];
      $data=$168;
      var $169=$data;
      var $170=(($169)&255);
      var $171=$170 & 15;
      var $172=$9;
      var $173=(($172)&255);
      var $174=$171 & $173;
      var $175=(($174) & 255);
      $pen1=$175;
      var $176=$pen1;
      var $177=(($176)&255);
      var $178=$penmap;
      var $179=(($178+$177)|0);
      var $180=HEAP8[($179)];
      $map2=$180;
      var $181=$5;
      var $182=$pen1;
      var $183=(($182)&255);
      var $184=(($181+$183)|0);
      var $185=(($184) & 65535);
      var $186=$xoffs;
      var $187=$pixptr;
      var $188=(($187+($186<<1))|0);
      HEAP16[(($188)>>1)]=$185;
      var $189=$map2;
      var $190=(($189)&255);
      var $191=$6;
      var $192=(($191)&255);
      var $193=$190 | $192;
      var $194=(($193) & 255);
      var $195=$xoffs;
      var $196=$flagsptr;
      var $197=(($196+$195)|0);
      HEAP8[($197)]=$194;
      var $198=$map2;
      var $199=(($198)&255);
      var $200=$andmask;
      var $201=(($200)&255);
      var $202=$201 & $199;
      var $203=(($202) & 255);
      $andmask=$203;
      var $204=$map2;
      var $205=(($204)&255);
      var $206=$ormask;
      var $207=(($206)&255);
      var $208=$207 | $205;
      var $209=(($208) & 255);
      $ormask=$209;
      var $210=$dx0;
      var $211=$xoffs;
      var $212=(($211+$210)|0);
      $xoffs=$212;
      var $213=$data;
      var $214=(($213)&255);
      var $215=$214 >> 4;
      var $216=$9;
      var $217=(($216)&255);
      var $218=$215 & $217;
      var $219=(($218) & 255);
      $pen1=$219;
      var $220=$pen1;
      var $221=(($220)&255);
      var $222=$penmap;
      var $223=(($222+$221)|0);
      var $224=HEAP8[($223)];
      $map2=$224;
      var $225=$5;
      var $226=$pen1;
      var $227=(($226)&255);
      var $228=(($225+$227)|0);
      var $229=(($228) & 65535);
      var $230=$xoffs;
      var $231=$pixptr;
      var $232=(($231+($230<<1))|0);
      HEAP16[(($232)>>1)]=$229;
      var $233=$map2;
      var $234=(($233)&255);
      var $235=$6;
      var $236=(($235)&255);
      var $237=$234 | $236;
      var $238=(($237) & 255);
      var $239=$xoffs;
      var $240=$flagsptr;
      var $241=(($240+$239)|0);
      HEAP8[($241)]=$238;
      var $242=$map2;
      var $243=(($242)&255);
      var $244=$andmask;
      var $245=(($244)&255);
      var $246=$245 & $243;
      var $247=(($246) & 255);
      $andmask=$247;
      var $248=$map2;
      var $249=(($248)&255);
      var $250=$ormask;
      var $251=(($250)&255);
      var $252=$251 | $249;
      var $253=(($252) & 255);
      $ormask=$253;
      var $254=$dx0;
      var $255=$xoffs;
      var $256=(($255+$254)|0);
      $xoffs=$256;
      __label__ = 19; break;
    case 19: // $257
      var $258=$tx;
      var $259=(($258+1)|0);
      $tx=$259;
      __label__ = 17; break;
    case 20: // $260
      __label__ = 21; break;
    case 21: // $261
      __label__ = 22; break;
    case 22: // $262
      var $263=$ty;
      var $264=(($263+1)|0);
      $ty=$264;
      __label__ = 9; break;
    case 23: // $265
      var $266=$andmask;
      var $267=(($266)&255);
      var $268=$ormask;
      var $269=(($268)&255);
      var $270=$267 ^ $269;
      var $271=(($270) & 255);
      ;
      return $271;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9tile_drawP9tilemap_tPKhjjjhhhh["X"]=1;

function __ZL18tile_apply_bitmaskP9tilemap_tPKhjjhh($tmap, $maskdata, $x0, $y0, $category, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $flagsmap;
      var $height;
      var $width;
      var $andmask;
      var $ormask;
      var $dx0;
      var $dy0;
      var $bitoffs;
      var $tx;
      var $ty;
      var $flagsptr;
      var $xoffs;
      var $map;
      $1=$tmap;
      $2=$maskdata;
      $3=$x0;
      $4=$y0;
      $5=$category;
      $6=$flags;
      var $7=$1;
      var $8=(($7+260)|0);
      var $9=HEAP32[(($8)>>2)];
      $flagsmap=$9;
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      $height=$12;
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      $width=$15;
      $andmask=-1;
      $ormask=0;
      $dx0=1;
      $dy0=1;
      $bitoffs=0;
      var $16=$6;
      var $17=(($16)&255);
      var $18=$17 & 2;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$height;
      var $22=(($21-1)|0);
      var $23=$4;
      var $24=(($23+$22)|0);
      $4=$24;
      $dy0=-1;
      __label__ = 2; break;
    case 2: // $25
      var $26=$6;
      var $27=(($26)&255);
      var $28=$27 & 1;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $30
      var $31=$width;
      var $32=(($31-1)|0);
      var $33=$3;
      var $34=(($33+$32)|0);
      $3=$34;
      $dx0=-1;
      __label__ = 4; break;
    case 4: // $35
      $ty=0;
      __label__ = 5; break;
    case 5: // $36
      var $37=$ty;
      var $38=$height;
      var $39=(($37)|0) < (($38)|0);
      if ($39) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $40
      var $41=$flagsmap;
      var $42=$41;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$4;
      var $46=$flagsmap;
      var $47=$46;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($45*$49)|0);
      var $51=(($44+$50)|0);
      var $52=$3;
      var $53=(($51+$52)|0);
      $flagsptr=$53;
      $xoffs=0;
      var $54=$dy0;
      var $55=$4;
      var $56=(($55+$54)|0);
      $4=$56;
      $tx=0;
      __label__ = 7; break;
    case 7: // $57
      var $58=$tx;
      var $59=$width;
      var $60=(($58)|0) < (($59)|0);
      if ($60) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $61
      var $62=$xoffs;
      var $63=$flagsptr;
      var $64=(($63+$62)|0);
      var $65=HEAP8[($64)];
      $map=$65;
      var $66=$bitoffs;
      var $67=(((($66)|0)/8)|0);
      var $68=$2;
      var $69=(($68+$67)|0);
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=$bitoffs;
      var $73=$72 & 7;
      var $74=128 >> (($73)|0);
      var $75=$71 & $74;
      var $76=(($75)|0)==0;
      if ($76) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $77
      var $78=$5;
      var $79=(($78)&255);
      var $80=0 | $79;
      var $81=(($80) & 255);
      var $82=$xoffs;
      var $83=$flagsptr;
      var $84=(($83+$82)|0);
      HEAP8[($84)]=$81;
      $map=$81;
      __label__ = 10; break;
    case 10: // $85
      var $86=$map;
      var $87=(($86)&255);
      var $88=$andmask;
      var $89=(($88)&255);
      var $90=$89 & $87;
      var $91=(($90) & 255);
      $andmask=$91;
      var $92=$map;
      var $93=(($92)&255);
      var $94=$ormask;
      var $95=(($94)&255);
      var $96=$95 | $93;
      var $97=(($96) & 255);
      $ormask=$97;
      var $98=$dx0;
      var $99=$xoffs;
      var $100=(($99+$98)|0);
      $xoffs=$100;
      var $101=$bitoffs;
      var $102=(($101+1)|0);
      $bitoffs=$102;
      __label__ = 11; break;
    case 11: // $103
      var $104=$tx;
      var $105=(($104+1)|0);
      $tx=$105;
      __label__ = 7; break;
    case 12: // $106
      __label__ = 13; break;
    case 13: // $107
      var $108=$ty;
      var $109=(($108+1)|0);
      $ty=$109;
      __label__ = 5; break;
    case 14: // $110
      var $111=$andmask;
      var $112=(($111)&255);
      var $113=$ormask;
      var $114=(($113)&255);
      var $115=$112 ^ $114;
      var $116=(($115) & 255);
      ;
      return $116;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18tile_apply_bitmaskP9tilemap_tPKhjjhh["X"]=1;

function __ZL25scanline_draw_masked_nullPvPKtPKhiiiPKjPhjh($dest, $source, $maskptr, $mask, $value, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $i;
      $1=$dest;
      $2=$source;
      $3=$maskptr;
      $4=$mask;
      $5=$value;
      $6=$count;
      $7=$pens;
      $8=$pri;
      $9=$pcode;
      $10=$alpha;
      var $11=$9;
      var $12=(($11)|0)!=65280;
      if ($12) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $13
      $i=0;
      __label__ = 2; break;
    case 2: // $14
      var $15=$i;
      var $16=$6;
      var $17=(($15)|0) < (($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $18
      var $19=$i;
      var $20=$3;
      var $21=(($20+$19)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$4;
      var $25=$23 & $24;
      var $26=$5;
      var $27=(($25)|0)==(($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$i;
      var $30=$8;
      var $31=(($30+$29)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$9;
      var $35=$34 >>> 8;
      var $36=$33 & $35;
      var $37=$9;
      var $38=$36 | $37;
      var $39=(($38) & 255);
      var $40=$i;
      var $41=$8;
      var $42=(($41+$40)|0);
      HEAP8[($42)]=$39;
      __label__ = 5; break;
    case 5: // $43
      __label__ = 6; break;
    case 6: // $44
      var $45=$i;
      var $46=(($45+1)|0);
      $i=$46;
      __label__ = 2; break;
    case 7: // $47
      __label__ = 8; break;
    case 8: // $48
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25scanline_draw_masked_nullPvPKtPKhiiiPKjPhjh["X"]=1;

function __ZL25scanline_draw_opaque_nullPvPKtiPKjPhjh($dest, $source, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $i;
      $1=$dest;
      $2=$source;
      $3=$count;
      $4=$pens;
      $5=$pri;
      $6=$pcode;
      $7=$alpha;
      var $8=$6;
      var $9=(($8)|0)!=65280;
      if ($9) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $10
      $i=0;
      __label__ = 2; break;
    case 2: // $11
      var $12=$i;
      var $13=$3;
      var $14=(($12)|0) < (($13)|0);
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$i;
      var $17=$5;
      var $18=(($17+$16)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$6;
      var $22=$21 >>> 8;
      var $23=$20 & $22;
      var $24=$6;
      var $25=$23 | $24;
      var $26=(($25) & 255);
      var $27=$i;
      var $28=$5;
      var $29=(($28+$27)|0);
      HEAP8[($29)]=$26;
      __label__ = 4; break;
    case 4: // $30
      var $31=$i;
      var $32=(($31+1)|0);
      $i=$32;
      __label__ = 2; break;
    case 5: // $33
      __label__ = 6; break;
    case 6: // $34
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11tile_updateP9tilemap_tjjj($tmap, $logindex, $col, $row) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $x0;
      var $y0;
      var $memindex;
      var $flags;
      $1=$tmap;
      $2=$logindex;
      $3=$col;
      $4=$row;
      var $5=$1;
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=(($7*$8)|0);
      $x0=$9;
      var $10=$1;
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$4;
      var $14=(($12*$13)|0);
      $y0=$14;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 266);
      var $15=$2;
      var $16=$1;
      var $17=(($16+40)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+($15<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      $memindex=$20;
      var $21=$1;
      var $22=(($21+48)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+52)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26;
      var $28=$1;
      var $29=(($28+56)|0);
      var $30=$memindex;
      var $31=$1;
      var $32=(($31+76)|0);
      var $33=HEAP32[(($32)>>2)];
      FUNCTION_TABLE[$23]($27, $29, $30, $33);
      var $34=$1;
      var $35=(($34+56)|0);
      var $36=(($35+14)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$1;
      var $40=(($39+81)|0);
      var $41=HEAPU8[($40)];
      var $42=(($41)&255);
      var $43=$42 & 3;
      var $44=$38 ^ $43;
      $flags=$44;
      var $45=$1;
      var $46=$1;
      var $47=(($46+56)|0);
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$1;
      var $51=(($50+88)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49+$52)|0);
      var $54=$x0;
      var $55=$y0;
      var $56=$1;
      var $57=(($56+56)|0);
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$1;
      var $61=(($60+56)|0);
      var $62=(($61+12)|0);
      var $63=HEAP8[($62)];
      var $64=$1;
      var $65=(($64+56)|0);
      var $66=(($65+13)|0);
      var $67=HEAP8[($66)];
      var $68=$flags;
      var $69=(($68) & 255);
      var $70=$1;
      var $71=(($70+56)|0);
      var $72=(($71+15)|0);
      var $73=HEAP8[($72)];
      var $74=__ZL9tile_drawP9tilemap_tPKhjjjhhhh($45, $53, $54, $55, $59, $63, $67, $69, $73);
      var $75=$2;
      var $76=$1;
      var $77=(($76+264)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+$75)|0);
      HEAP8[($79)]=$74;
      var $80=$flags;
      var $81=$80 & 112;
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $83
      var $84=$1;
      var $85=(($84+56)|0);
      var $86=(($85+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $89
      var $90=$1;
      var $91=$1;
      var $92=(($91+56)|0);
      var $93=(($92+4)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$x0;
      var $96=$y0;
      var $97=$1;
      var $98=(($97+56)|0);
      var $99=(($98+12)|0);
      var $100=HEAP8[($99)];
      var $101=$flags;
      var $102=(($101) & 255);
      var $103=__ZL18tile_apply_bitmaskP9tilemap_tPKhjjhh($90, $94, $95, $96, $100, $102);
      var $104=$2;
      var $105=$1;
      var $106=(($105+264)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107+$104)|0);
      HEAP8[($108)]=$103;
      __label__ = 3; break;
    case 3: // $109
      var $110=$1;
      var $111=(($110+56)|0);
      var $112=(($111+16)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=(($114)|0)!=255;
      if ($115) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $116
      var $117=$1;
      var $118=(($117+92)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$1;
      var $121=(($120+56)|0);
      var $122=(($121+16)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=1 << $124;
      var $126=$119 & $125;
      var $127=(($126)|0)==0;
      if ($127) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $128
      var $129=$1;
      var $130=(($129+56)|0);
      var $131=(($130+16)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=1 << $133;
      var $135=$1;
      var $136=(($135+92)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$137 | $134;
      HEAP32[(($136)>>2)]=$138;
      var $139=$1;
      var $140=(($139+56)|0);
      var $141=(($140+16)|0);
      var $142=HEAPU8[($141)];
      var $143=(($142)&255);
      var $144=$1;
      var $145=__ZNK9tilemap_t7machineEv($144);
      var $146=(($145+432)|0);
      var $147=(($146+($143<<2))|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+56)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$1;
      var $152=(($151+56)|0);
      var $153=(($152+16)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $156=$1;
      var $157=(($156+96)|0);
      var $158=(($157+($155<<2))|0);
      HEAP32[(($158)>>2)]=$150;
      __label__ = 6; break;
    case 6: // $159
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11tile_updateP9tilemap_tjjj["X"]=1;

function __ZL26scanline_draw_opaque_rgb32PvPKtiPKjPhjh($_dest, $source, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$count;
      $4=$pens;
      $5=$pri;
      $6=$pcode;
      $7=$alpha;
      var $8=$6;
      var $9=$8 >>> 16;
      var $10=$4;
      var $11=(($10+($9<<2))|0);
      $clut=$11;
      var $12=$1;
      var $13=$12;
      $dest=$13;
      var $14=$6;
      var $15=$14 & 65535;
      var $16=(($15)|0)!=65280;
      if ($16) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $17
      $i=0;
      __label__ = 2; break;
    case 2: // $18
      var $19=$i;
      var $20=$3;
      var $21=(($19)|0) < (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      var $23=$i;
      var $24=$2;
      var $25=(($24+($23<<1))|0);
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      var $28=$clut;
      var $29=(($28+($27<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$i;
      var $32=$dest;
      var $33=(($32+($31<<2))|0);
      HEAP32[(($33)>>2)]=$30;
      var $34=$i;
      var $35=$5;
      var $36=(($35+$34)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$6;
      var $40=$39 >>> 8;
      var $41=$38 & $40;
      var $42=$6;
      var $43=$41 | $42;
      var $44=(($43) & 255);
      var $45=$i;
      var $46=$5;
      var $47=(($46+$45)|0);
      HEAP8[($47)]=$44;
      __label__ = 4; break;
    case 4: // $48
      var $49=$i;
      var $50=(($49+1)|0);
      $i=$50;
      __label__ = 2; break;
    case 5: // $51
      __label__ = 11; break;
    case 6: // $52
      $i=0;
      __label__ = 7; break;
    case 7: // $53
      var $54=$i;
      var $55=$3;
      var $56=(($54)|0) < (($55)|0);
      if ($56) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $57
      var $58=$i;
      var $59=$2;
      var $60=(($59+($58<<1))|0);
      var $61=HEAPU16[(($60)>>1)];
      var $62=(($61)&65535);
      var $63=$clut;
      var $64=(($63+($62<<2))|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$i;
      var $67=$dest;
      var $68=(($67+($66<<2))|0);
      HEAP32[(($68)>>2)]=$65;
      __label__ = 9; break;
    case 9: // $69
      var $70=$i;
      var $71=(($70+1)|0);
      $i=$71;
      __label__ = 7; break;
    case 10: // $72
      __label__ = 11; break;
    case 11: // $73
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26scanline_draw_opaque_rgb32PvPKtiPKjPhjh["X"]=1;

function __ZL26scanline_draw_opaque_rgb16PvPKtiPKjPhjh($_dest, $source, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$count;
      $4=$pens;
      $5=$pri;
      $6=$pcode;
      $7=$alpha;
      var $8=$6;
      var $9=$8 >>> 16;
      var $10=$4;
      var $11=(($10+($9<<2))|0);
      $clut=$11;
      var $12=$1;
      var $13=$12;
      $dest=$13;
      var $14=$6;
      var $15=$14 & 65535;
      var $16=(($15)|0)!=65280;
      if ($16) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $17
      $i=0;
      __label__ = 2; break;
    case 2: // $18
      var $19=$i;
      var $20=$3;
      var $21=(($19)|0) < (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      var $23=$i;
      var $24=$2;
      var $25=(($24+($23<<1))|0);
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      var $28=$clut;
      var $29=(($28+($27<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30) & 65535);
      var $32=$i;
      var $33=$dest;
      var $34=(($33+($32<<1))|0);
      HEAP16[(($34)>>1)]=$31;
      var $35=$i;
      var $36=$5;
      var $37=(($36+$35)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$6;
      var $41=$40 >>> 8;
      var $42=$39 & $41;
      var $43=$6;
      var $44=$42 | $43;
      var $45=(($44) & 255);
      var $46=$i;
      var $47=$5;
      var $48=(($47+$46)|0);
      HEAP8[($48)]=$45;
      __label__ = 4; break;
    case 4: // $49
      var $50=$i;
      var $51=(($50+1)|0);
      $i=$51;
      __label__ = 2; break;
    case 5: // $52
      __label__ = 11; break;
    case 6: // $53
      $i=0;
      __label__ = 7; break;
    case 7: // $54
      var $55=$i;
      var $56=$3;
      var $57=(($55)|0) < (($56)|0);
      if ($57) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $58
      var $59=$i;
      var $60=$2;
      var $61=(($60+($59<<1))|0);
      var $62=HEAPU16[(($61)>>1)];
      var $63=(($62)&65535);
      var $64=$clut;
      var $65=(($64+($63<<2))|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66) & 65535);
      var $68=$i;
      var $69=$dest;
      var $70=(($69+($68<<1))|0);
      HEAP16[(($70)>>1)]=$67;
      __label__ = 9; break;
    case 9: // $71
      var $72=$i;
      var $73=(($72+1)|0);
      $i=$73;
      __label__ = 7; break;
    case 10: // $74
      __label__ = 11; break;
    case 11: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26scanline_draw_opaque_rgb16PvPKtiPKjPhjh["X"]=1;

function __ZL32scanline_draw_opaque_rgb32_alphaPvPKtiPKjPhjh($_dest, $source, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$count;
      $4=$pens;
      $5=$pri;
      $6=$pcode;
      $7=$alpha;
      var $8=$6;
      var $9=$8 >>> 16;
      var $10=$4;
      var $11=(($10+($9<<2))|0);
      $clut=$11;
      var $12=$1;
      var $13=$12;
      $dest=$13;
      var $14=$6;
      var $15=$14 & 65535;
      var $16=(($15)|0)!=65280;
      if ($16) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $17
      $i=0;
      __label__ = 2; break;
    case 2: // $18
      var $19=$i;
      var $20=$3;
      var $21=(($19)|0) < (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      var $23=$i;
      var $24=$dest;
      var $25=(($24+($23<<2))|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$i;
      var $28=$2;
      var $29=(($28+($27<<1))|0);
      var $30=HEAPU16[(($29)>>1)];
      var $31=(($30)&65535);
      var $32=$clut;
      var $33=(($32+($31<<2))|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$7;
      var $36=__ZL15alpha_blend_r32jjh3730($26, $34, $35);
      var $37=$i;
      var $38=$dest;
      var $39=(($38+($37<<2))|0);
      HEAP32[(($39)>>2)]=$36;
      var $40=$i;
      var $41=$5;
      var $42=(($41+$40)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$6;
      var $46=$45 >>> 8;
      var $47=$44 & $46;
      var $48=$6;
      var $49=$47 | $48;
      var $50=(($49) & 255);
      var $51=$i;
      var $52=$5;
      var $53=(($52+$51)|0);
      HEAP8[($53)]=$50;
      __label__ = 4; break;
    case 4: // $54
      var $55=$i;
      var $56=(($55+1)|0);
      $i=$56;
      __label__ = 2; break;
    case 5: // $57
      __label__ = 11; break;
    case 6: // $58
      $i=0;
      __label__ = 7; break;
    case 7: // $59
      var $60=$i;
      var $61=$3;
      var $62=(($60)|0) < (($61)|0);
      if ($62) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $63
      var $64=$i;
      var $65=$dest;
      var $66=(($65+($64<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$i;
      var $69=$2;
      var $70=(($69+($68<<1))|0);
      var $71=HEAPU16[(($70)>>1)];
      var $72=(($71)&65535);
      var $73=$clut;
      var $74=(($73+($72<<2))|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$7;
      var $77=__ZL15alpha_blend_r32jjh3730($67, $75, $76);
      var $78=$i;
      var $79=$dest;
      var $80=(($79+($78<<2))|0);
      HEAP32[(($80)>>2)]=$77;
      __label__ = 9; break;
    case 9: // $81
      var $82=$i;
      var $83=(($82+1)|0);
      $i=$83;
      __label__ = 7; break;
    case 10: // $84
      __label__ = 11; break;
    case 11: // $85
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32scanline_draw_opaque_rgb32_alphaPvPKtiPKjPhjh["X"]=1;

function __ZL32scanline_draw_opaque_rgb16_alphaPvPKtiPKjPhjh($_dest, $source, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $clut;
      var $dest;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$count;
      $4=$pens;
      $5=$pri;
      $6=$pcode;
      $7=$alpha;
      var $8=$6;
      var $9=$8 >>> 16;
      var $10=$4;
      var $11=(($10+($9<<2))|0);
      $clut=$11;
      var $12=$1;
      var $13=$12;
      $dest=$13;
      var $14=$6;
      var $15=$14 & 65535;
      var $16=(($15)|0)!=65280;
      if ($16) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $17
      $i=0;
      __label__ = 2; break;
    case 2: // $18
      var $19=$i;
      var $20=$3;
      var $21=(($19)|0) < (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      var $23=$i;
      var $24=$dest;
      var $25=(($24+($23<<1))|0);
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      var $28=$i;
      var $29=$2;
      var $30=(($29+($28<<1))|0);
      var $31=HEAPU16[(($30)>>1)];
      var $32=(($31)&65535);
      var $33=$clut;
      var $34=(($33+($32<<2))|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$7;
      var $37=__ZL15alpha_blend_r16jjh3731($27, $35, $36);
      var $38=(($37) & 65535);
      var $39=$i;
      var $40=$dest;
      var $41=(($40+($39<<1))|0);
      HEAP16[(($41)>>1)]=$38;
      var $42=$i;
      var $43=$5;
      var $44=(($43+$42)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$6;
      var $48=$47 >>> 8;
      var $49=$46 & $48;
      var $50=$6;
      var $51=$49 | $50;
      var $52=(($51) & 255);
      var $53=$i;
      var $54=$5;
      var $55=(($54+$53)|0);
      HEAP8[($55)]=$52;
      __label__ = 4; break;
    case 4: // $56
      var $57=$i;
      var $58=(($57+1)|0);
      $i=$58;
      __label__ = 2; break;
    case 5: // $59
      __label__ = 11; break;
    case 6: // $60
      $i=0;
      __label__ = 7; break;
    case 7: // $61
      var $62=$i;
      var $63=$3;
      var $64=(($62)|0) < (($63)|0);
      if ($64) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $65
      var $66=$i;
      var $67=$dest;
      var $68=(($67+($66<<1))|0);
      var $69=HEAPU16[(($68)>>1)];
      var $70=(($69)&65535);
      var $71=$i;
      var $72=$2;
      var $73=(($72+($71<<1))|0);
      var $74=HEAPU16[(($73)>>1)];
      var $75=(($74)&65535);
      var $76=$clut;
      var $77=(($76+($75<<2))|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$7;
      var $80=__ZL15alpha_blend_r16jjh3731($70, $78, $79);
      var $81=(($80) & 65535);
      var $82=$i;
      var $83=$dest;
      var $84=(($83+($82<<1))|0);
      HEAP16[(($84)>>1)]=$81;
      __label__ = 9; break;
    case 9: // $85
      var $86=$i;
      var $87=(($86+1)|0);
      $i=$87;
      __label__ = 7; break;
    case 10: // $88
      __label__ = 11; break;
    case 11: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32scanline_draw_opaque_rgb16_alphaPvPKtiPKjPhjh["X"]=1;

function __ZL26scanline_draw_opaque_ind16PvPKtiPKjPhjh($_dest, $source, $count, $pens, $pri, $pcode, $alpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $dest;
      var $pal;
      var $i;
      $1=$_dest;
      $2=$source;
      $3=$count;
      $4=$pens;
      $5=$pri;
      $6=$pcode;
      $7=$alpha;
      var $8=$1;
      var $9=$8;
      $dest=$9;
      var $10=$6;
      var $11=$10 >>> 16;
      $pal=$11;
      var $12=$pal;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $14
      var $15=$dest;
      var $16=$15;
      var $17=$2;
      var $18=$17;
      var $19=$3;
      var $20=((($19<<1))|0);
      assert($20 % 1 === 0, 'memcpy given ' + $20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($16, $18, $20, 1);
      var $21=$6;
      var $22=(($21)|0)!=65280;
      if ($22) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $23
      $i=0;
      __label__ = 3; break;
    case 3: // $24
      var $25=$i;
      var $26=$3;
      var $27=(($25)|0) < (($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $28
      var $29=$i;
      var $30=$5;
      var $31=(($30+$29)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$6;
      var $35=$34 >>> 8;
      var $36=$33 & $35;
      var $37=$6;
      var $38=$36 | $37;
      var $39=(($38) & 255);
      var $40=$i;
      var $41=$5;
      var $42=(($41+$40)|0);
      HEAP8[($42)]=$39;
      __label__ = 5; break;
    case 5: // $43
      var $44=$i;
      var $45=(($44+1)|0);
      $i=$45;
      __label__ = 3; break;
    case 6: // $46
      __label__ = 7; break;
    case 7: // $47
      __label__ = 20; break;
    case 8: // $48
      var $49=$6;
      var $50=$49 & 65535;
      var $51=(($50)|0)!=65280;
      if ($51) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $52
      $i=0;
      __label__ = 10; break;
    case 10: // $53
      var $54=$i;
      var $55=$3;
      var $56=(($54)|0) < (($55)|0);
      if ($56) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $57
      var $58=$i;
      var $59=$2;
      var $60=(($59+($58<<1))|0);
      var $61=HEAPU16[(($60)>>1)];
      var $62=(($61)&65535);
      var $63=$pal;
      var $64=(($62+$63)|0);
      var $65=(($64) & 65535);
      var $66=$i;
      var $67=$dest;
      var $68=(($67+($66<<1))|0);
      HEAP16[(($68)>>1)]=$65;
      var $69=$i;
      var $70=$5;
      var $71=(($70+$69)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=$6;
      var $75=$74 >>> 8;
      var $76=$73 & $75;
      var $77=$6;
      var $78=$76 | $77;
      var $79=(($78) & 255);
      var $80=$i;
      var $81=$5;
      var $82=(($81+$80)|0);
      HEAP8[($82)]=$79;
      __label__ = 12; break;
    case 12: // $83
      var $84=$i;
      var $85=(($84+1)|0);
      $i=$85;
      __label__ = 10; break;
    case 13: // $86
      __label__ = 19; break;
    case 14: // $87
      $i=0;
      __label__ = 15; break;
    case 15: // $88
      var $89=$i;
      var $90=$3;
      var $91=(($89)|0) < (($90)|0);
      if ($91) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $92
      var $93=$i;
      var $94=$2;
      var $95=(($94+($93<<1))|0);
      var $96=HEAPU16[(($95)>>1)];
      var $97=(($96)&65535);
      var $98=$pal;
      var $99=(($97+$98)|0);
      var $100=(($99) & 65535);
      var $101=$i;
      var $102=$dest;
      var $103=(($102+($101<<1))|0);
      HEAP16[(($103)>>1)]=$100;
      __label__ = 17; break;
    case 17: // $104
      var $105=$i;
      var $106=(($105+1)|0);
      $i=$106;
      __label__ = 15; break;
    case 18: // $107
      __label__ = 19; break;
    case 19: // $108
      __label__ = 20; break;
    case 20: // $109
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26scanline_draw_opaque_ind16PvPKtiPKjPhjh["X"]=1;

function __ZL15tilemap_disposeP9tilemap_t($tmap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tmapptr;
      $1=$tmap;
      var $2=$1;
      var $3=__ZNK9tilemap_t7machineEv($2);
      var $4=(($3+632)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0);
      $tmapptr=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$tmapptr;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$tmapptr;
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$tmapptr;
      HEAP32[(($20)>>2)]=$19;
      __label__ = 6; break;
    case 4: // $21
      __label__ = 5; break;
    case 5: // $22
      var $23=$tmapptr;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0);
      $tmapptr=$25;
      __label__ = 1; break;
    case 6: // $26
      var $27=$1;
      var $28=__ZNK9tilemap_t7machineEv($27);
      var $29=__ZN15running_machine7respoolEv($28);
      var $30=$1;
      var $31=(($30+268)|0);
      var $32=HEAP32[(($31)>>2)];
      __ZN13resource_pool6removeEPv($29, $32);
      var $33=$1;
      var $34=__ZNK9tilemap_t7machineEv($33);
      var $35=__ZN15running_machine7respoolEv($34);
      var $36=$1;
      var $37=(($36+264)|0);
      var $38=HEAP32[(($37)>>2)];
      __ZN13resource_pool6removeEPv($35, $38);
      var $39=$1;
      var $40=__ZNK9tilemap_t7machineEv($39);
      var $41=__ZN15running_machine7respoolEv($40);
      var $42=$1;
      var $43=(($42+260)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44;
      __ZN13resource_pool6removeEPv($41, $45);
      var $46=$1;
      var $47=__ZNK9tilemap_t7machineEv($46);
      var $48=__ZN15running_machine7respoolEv($47);
      var $49=$1;
      var $50=(($49+256)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$51;
      __ZN13resource_pool6removeEPv($48, $52);
      var $53=$1;
      var $54=__ZNK9tilemap_t7machineEv($53);
      var $55=__ZN15running_machine7respoolEv($54);
      var $56=$1;
      var $57=(($56+236)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58;
      __ZN13resource_pool6removeEPv($55, $59);
      var $60=$1;
      var $61=__ZNK9tilemap_t7machineEv($60);
      var $62=__ZN15running_machine7respoolEv($61);
      var $63=$1;
      var $64=(($63+232)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65;
      __ZN13resource_pool6removeEPv($62, $66);
      var $67=$1;
      var $68=__ZNK9tilemap_t7machineEv($67);
      var $69=__ZN15running_machine7respoolEv($68);
      var $70=$1;
      var $71=(($70+40)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$72;
      __ZN13resource_pool6removeEPv($69, $73);
      var $74=$1;
      var $75=__ZNK9tilemap_t7machineEv($74);
      var $76=__ZN15running_machine7respoolEv($75);
      var $77=$1;
      var $78=(($77+32)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$79;
      __ZN13resource_pool6removeEPv($76, $80);
      var $81=$1;
      var $82=__ZNK9tilemap_t7machineEv($81);
      var $83=__ZN15running_machine7respoolEv($82);
      var $84=$1;
      var $85=$84;
      __ZN13resource_pool6removeEPv($83, $85);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15tilemap_disposeP9tilemap_t["X"]=1;

function __Z12validate_tagRK11game_driverPKcS3_($driver, $object, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $validchars;
      var $begin;
      var $p;
      var $error;
      $1=$driver;
      $2=$object;
      $3=$tag;
      $validchars=((STRING_TABLE.__str3732)|0);
      var $4=$3;
      var $5=_strrchr($4, 58);
      $begin=$5;
      $error=0;
      var $6=$3;
      var $7=_strcmp($6, ((STRING_TABLE.__str13733)|0));
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$3;
      var $11=_strcmp($10, ((STRING_TABLE.__str23734)|0));
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $13
      var $14=$3;
      var $15=_strcmp($14, ((STRING_TABLE.__str33735)|0));
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $17
      var $18=$3;
      var $19=_strcmp($18, ((STRING_TABLE.__str43736)|0));
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $21
      var $22=$3;
      var $23=_strcmp($22, ((STRING_TABLE.__str53737)|0));
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=$1;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$1;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$3;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str63738)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,HEAP32[((tempInt+4)>>2)]=$31,HEAP32[((tempInt+8)>>2)]=$32,tempInt));
      $error=1;
      __label__ = 6; break;
    case 6: // $33
      var $34=$3;
      $p=$34;
      __label__ = 7; break;
    case 7: // $35
      var $36=$p;
      var $37=HEAP8[($36)];
      var $38=(($37 << 24) >> 24);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $40
      var $41=$p;
      var $42=HEAP8[($41)];
      var $43=(($42 << 24) >> 24);
      var $44=$p;
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=_tolower($46);
      var $48=(($43)|0)!=(($47)|0);
      if ($48) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $49
      var $50=$1;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$1;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$2;
      var $57=$3;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str73739)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$52,HEAP32[((tempInt+4)>>2)]=$55,HEAP32[((tempInt+8)>>2)]=$56,HEAP32[((tempInt+12)>>2)]=$57,tempInt));
      $error=1;
      __label__ = 16; break;
    case 10: // $58
      var $59=$p;
      var $60=HEAP8[($59)];
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)==32;
      if ($62) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $63
      var $64=$1;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$1;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$2;
      var $71=$3;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str83740)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,HEAP32[((tempInt+4)>>2)]=$69,HEAP32[((tempInt+8)>>2)]=$70,HEAP32[((tempInt+12)>>2)]=$71,tempInt));
      $error=1;
      __label__ = 16; break;
    case 12: // $72
      var $73=$validchars;
      var $74=$p;
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24);
      var $77=_strchr($73, $76);
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $79
      var $80=$1;
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$1;
      var $84=(($83+8)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$2;
      var $87=$3;
      var $88=$p;
      var $89=HEAP8[($88)];
      var $90=(($89 << 24) >> 24);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str93741)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,HEAP32[((tempInt+4)>>2)]=$85,HEAP32[((tempInt+8)>>2)]=$86,HEAP32[((tempInt+12)>>2)]=$87,HEAP32[((tempInt+16)>>2)]=$90,tempInt));
      $error=1;
      __label__ = 16; break;
    case 14: // $91
      __label__ = 15; break;
    case 15: // $92
      var $93=$p;
      var $94=(($93+1)|0);
      $p=$94;
      __label__ = 7; break;
    case 16: // $95
      var $96=$begin;
      var $97=(($96)|0)==0;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      var $99=$3;
      $begin=$99;
      __label__ = 19; break;
    case 18: // $100
      var $101=$begin;
      var $102=(($101+1)|0);
      $begin=$102;
      __label__ = 19; break;
    case 19: // $103
      var $104=$begin;
      var $105=_strlen($104);
      var $106=(($105)|0)==0;
      if ($106) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $107
      var $108=$1;
      var $109=(($108)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$1;
      var $112=(($111+8)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$2;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str103742)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$110,HEAP32[((tempInt+4)>>2)]=$113,HEAP32[((tempInt+8)>>2)]=$114,tempInt));
      $error=1;
      __label__ = 21; break;
    case 21: // $115
      var $116=$begin;
      var $117=_strlen($116);
      var $118=(($117)>>>0) < 2;
      if ($118) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $119
      var $120=$1;
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$1;
      var $124=(($123+8)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$2;
      var $127=$3;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str113743)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$122,HEAP32[((tempInt+4)>>2)]=$125,HEAP32[((tempInt+8)>>2)]=$126,HEAP32[((tempInt+12)>>2)]=$127,HEAP32[((tempInt+16)>>2)]=2,tempInt));
      $error=1;
      __label__ = 23; break;
    case 23: // $128
      var $129=$begin;
      var $130=_strlen($129);
      var $131=(($130)>>>0) > 15;
      if ($131) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $132
      var $133=$1;
      var $134=(($133)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$1;
      var $137=(($136+8)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$2;
      var $140=$3;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str123744)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$135,HEAP32[((tempInt+4)>>2)]=$138,HEAP32[((tempInt+8)>>2)]=$139,HEAP32[((tempInt+12)>>2)]=$140,HEAP32[((tempInt+16)>>2)]=15,tempInt));
      $error=1;
      __label__ = 25; break;
    case 25: // $141
      var $142=$error;
      var $143=(($142) & 1);
      var $144=$143 ^ 1;
      ;
      return $144;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12validate_tagRK11game_driverPKcS3_["X"]=1;

function __ZN8tagmap_tIPK11game_driverEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIPK11game_driverEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIjEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIjEC2Ev($2);
  ;
  return;
}


function __Z16validate_driversR11emu_optionsPK11game_driver($options, $curdriver) {
  var __stackBase__  = STACKTOP; STACKTOP += 19468; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $prep=__stackBase__;
      var $driver_checks=__stackBase__+8;
      var $rom_checks=__stackBase__+16;
      var $gfx_checks=__stackBase__+24;
      var $display_checks=__stackBase__+32;
      var $input_checks=__stackBase__+40;
      var $device_checks=__stackBase__+48;
      var $strnum;
      var $error;
      var $lsbtest=__stackBase__+56;
      var $a;
      var $b;
      var $names=__stackBase__+60;
      var $descriptions=__stackBase__+448;
      var $3;
      var $4;
      var $roms=__stackBase__+836;
      var $defstr=__stackBase__+1224;
      var $string;
      var $drivlist=__stackBase__+1612;
      var $driver;
      var $portlist=__stackBase__+1652;
      var $rgninfo=__stackBase__+2060;
      var $5;
      var $err;
      $1=$options;
      $2=$curdriver;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$31$0=(($prep)|0);
      HEAP32[(($st$31$0)>>2)]=$$emscripten$temp$0$0;
      var $st$31$1=(($prep+4)|0);
      HEAP32[(($st$31$1)>>2)]=$$emscripten$temp$0$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$37$0=(($driver_checks)|0);
      HEAP32[(($st$37$0)>>2)]=$$emscripten$temp$1$0;
      var $st$37$1=(($driver_checks+4)|0);
      HEAP32[(($st$37$1)>>2)]=$$emscripten$temp$1$1;
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$43$0=(($rom_checks)|0);
      HEAP32[(($st$43$0)>>2)]=$$emscripten$temp$2$0;
      var $st$43$1=(($rom_checks+4)|0);
      HEAP32[(($st$43$1)>>2)]=$$emscripten$temp$2$1;
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$49$0=(($gfx_checks)|0);
      HEAP32[(($st$49$0)>>2)]=$$emscripten$temp$3$0;
      var $st$49$1=(($gfx_checks+4)|0);
      HEAP32[(($st$49$1)>>2)]=$$emscripten$temp$3$1;
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $st$55$0=(($display_checks)|0);
      HEAP32[(($st$55$0)>>2)]=$$emscripten$temp$4$0;
      var $st$55$1=(($display_checks+4)|0);
      HEAP32[(($st$55$1)>>2)]=$$emscripten$temp$4$1;
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $st$61$0=(($input_checks)|0);
      HEAP32[(($st$61$0)>>2)]=$$emscripten$temp$5$0;
      var $st$61$1=(($input_checks+4)|0);
      HEAP32[(($st$61$1)>>2)]=$$emscripten$temp$5$1;
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      var $st$67$0=(($device_checks)|0);
      HEAP32[(($st$67$0)>>2)]=$$emscripten$temp$6$0;
      var $st$67$1=(($device_checks+4)|0);
      HEAP32[(($st$67$1)>>2)]=$$emscripten$temp$6$1;
      $error=0;
      __ZN8tagmap_tIPK11game_driverEC1Ev($names);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverEC1Ev($descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $6
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverEC1Ev($roms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $7
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIjEC1Ev($defstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $8
      $a=-1;
      var $9=$a;
      var $10=(($9)&255);
      var $11=(($10+1)|0);
      var $12=(($11) & 255);
      $b=$12;
      var $13=$b;
      var $14=(($13)&255);
      var $15=$a;
      var $16=(($15)&255);
      var $17=(($14)|0) > (($16)|0);
      if ($17) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $18
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str133745)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $19
      $error=1;
      __label__ = 10; break;
    case 6: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $3=$22;
      var $23=$21.f1;
      $4=$23;
      __label__ = 107; break;
    case 7: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $3=$26;
      var $27=$25.f1;
      $4=$27;
      __label__ = 105; break;
    case 8: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $3=$30;
      var $31=$29.f1;
      $4=$31;
      __label__ = 103; break;
    case 9: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $3=$34;
      var $35=$33.f1;
      $4=$35;
      __label__ = 101; break;
    case 10: // $36
      HEAP16[(($lsbtest)>>1)]=0;
      var $37=$lsbtest;
      HEAP8[($37)]=-1;
      var $38=HEAPU16[(($lsbtest)>>1)];
      var $39=(($38)&65535);
      var $40=(($39)|0)==65280;
      if ($40) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $41
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str143746)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 12: // $42
      $error=1;
      __label__ = 13; break;
    case 13: // $43
      var $44=(function() { try { __THREW__ = false; return __ZL16validate_inlinesv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 9; break; };
    case 14: // $45
      if ($44) { var $50 = 1;__label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $46
      var $47=$error;
      var $48=(($47) & 1);
      var $50 = $48;__label__ = 16; break;
    case 16: // $49
      var $50;
      var $51=(($50)&1);
      $error=$51;
      var $52=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 9; break; };
      var $52$0=$52[0];
      var $52$1=$52[1];
    case 17: // $53
      var $54=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 9; break; };
      var $54$0=$54[0];
      var $54$1=$54[1];
    case 18: // $55
      var $st$0$0=(($prep)|0);
      var $56$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($prep+4)|0);
      var $56$1=HEAP32[(($st$0$1)>>2)];
      var $57$0 = ((($56$0)>>>0)+((($56$1)|0)*4294967296))-((($54$0)>>>0)+((($54$1)|0)*4294967296))>>>0; var $57$1 = Math.min(Math.floor((((($56$0)>>>0)+((($56$1)|0)*4294967296))-((($54$0)>>>0)+((($54$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($prep)|0);
      HEAP32[(($st$5$0)>>2)]=$57$0;
      var $st$5$1=(($prep+4)|0);
      HEAP32[(($st$5$1)>>2)]=$57$1;
      $strnum=1;
      __label__ = 19; break;
    case 19: // $58
      var $59=$strnum;
      var $60=(($59)|0) < 116;
      if ($60) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $61
      var $62=$strnum;
      var $63=(function() { try { __THREW__ = false; return __ZL28input_port_string_from_indexj($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 9; break; };
    case 21: // $64
      $string=$63;
      var $65=$string;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $67
      var $68=$string;
      var $69=$strnum;
      var $70=(function() { try { __THREW__ = false; return __ZN8tagmap_tIjE3addEPKcjb($defstr, $68, $69, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 9; break; };
    case 23: // $71
      __label__ = 24; break;
    case 24: // $72
      __label__ = 25; break;
    case 25: // $73
      var $74=$strnum;
      var $75=(($74+1)|0);
      $strnum=$75;
      __label__ = 19; break;
    case 26: // $76
      var $77=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 9; break; };
      var $77$0=$77[0];
      var $77$1=$77[1];
    case 27: // $78
      var $st$0$0=(($prep)|0);
      var $79$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($prep+4)|0);
      var $79$1=HEAP32[(($st$0$1)>>2)];
      var $80$0 = ((($79$0)>>>0)+((($79$1)|0)*4294967296))+((($77$0)>>>0)+((($77$1)|0)*4294967296))>>>0; var $80$1 = Math.min(Math.floor((((($79$0)>>>0)+((($79$1)|0)*4294967296))+((($77$0)>>>0)+((($77$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($prep)|0);
      HEAP32[(($st$5$0)>>2)]=$80$0;
      var $st$5$1=(($prep+4)|0);
      HEAP32[(($st$5$1)>>2)]=$80$1;
      var $81=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_options]($drivlist, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 9; break; }
    case 28: // $82
      __label__ = 29; break;
    case 29: // $83
      var $84=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 38; break; };
    case 30: // $85
      if ($84) { __label__ = 31; break; } else { __label__ = 90; break; }
    case 31: // $86
      var $87=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 38; break; };
    case 32: // $88
      $driver=$87;
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configEC1ER13resource_pool($portlist, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 38; break; }
    case 33: // $89
      (function() { try { __THREW__ = false; return __ZN12region_arrayC1Ev($rgninfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $90
      var $91=$2;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 35; break; } else { __label__ = 41; break; }
    case 35: // $93
      var $94=$2;
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$driver;
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(function() { try { __THREW__ = false; return _strcmp($96, $99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 40; break; };
    case 36: // $101
      var $102=(($100)|0)!=0;
      if ($102) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $103
      $5=5;
      __label__ = 82; break;
    case 38: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $106=$105.f0;
      $3=$106;
      var $107=$105.f1;
      $4=$107;
      __label__ = 99; break;
    case 39: // $108
      var $109=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $110=$109.f0;
      $3=$110;
      var $111=$109.f1;
      $4=$111;
      __label__ = 88; break;
    case 40: // $112
      var $113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $114=$113.f0;
      $3=$114;
      var $115=$113.f1;
      $4=$115;
      __label__ = 86; break;
    case 41: // $116
      var $117=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 72; break; };
      var $117$0=$117[0];
      var $117$1=$117[1];
    case 42: // $118
      var $st$0$0=(($driver_checks)|0);
      var $119$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($driver_checks+4)|0);
      var $119$1=HEAP32[(($st$0$1)>>2)];
      var $120$0 = ((($119$0)>>>0)+((($119$1)|0)*4294967296))-((($117$0)>>>0)+((($117$1)|0)*4294967296))>>>0; var $120$1 = Math.min(Math.floor((((($119$0)>>>0)+((($119$1)|0)*4294967296))-((($117$0)>>>0)+((($117$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($driver_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$120$0;
      var $st$5$1=(($driver_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$120$1;
      var $121=(function() { try { __THREW__ = false; return __ZL15validate_driverR17driver_enumeratorR8tagmap_tIPK11game_driverES6_($drivlist, $names, $descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 72; break; };
    case 43: // $122
      if ($121) { var $127 = 1;__label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $123
      var $124=$error;
      var $125=(($124) & 1);
      var $127 = $125;__label__ = 45; break;
    case 45: // $126
      var $127;
      var $128=(($127)&1);
      $error=$128;
      var $129=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 72; break; };
      var $129$0=$129[0];
      var $129$1=$129[1];
    case 46: // $130
      var $st$0$0=(($driver_checks)|0);
      var $131$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($driver_checks+4)|0);
      var $131$1=HEAP32[(($st$0$1)>>2)];
      var $132$0 = ((($131$0)>>>0)+((($131$1)|0)*4294967296))+((($129$0)>>>0)+((($129$1)|0)*4294967296))>>>0; var $132$1 = Math.min(Math.floor((((($131$0)>>>0)+((($131$1)|0)*4294967296))+((($129$0)>>>0)+((($129$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($driver_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$132$0;
      var $st$5$1=(($driver_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$132$1;
      var $133=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 72; break; };
      var $133$0=$133[0];
      var $133$1=$133[1];
    case 47: // $134
      var $st$0$0=(($rom_checks)|0);
      var $135$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($rom_checks+4)|0);
      var $135$1=HEAP32[(($st$0$1)>>2)];
      var $136$0 = ((($135$0)>>>0)+((($135$1)|0)*4294967296))-((($133$0)>>>0)+((($133$1)|0)*4294967296))>>>0; var $136$1 = Math.min(Math.floor((((($135$0)>>>0)+((($135$1)|0)*4294967296))-((($133$0)>>>0)+((($133$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($rom_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$136$0;
      var $st$5$1=(($rom_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$136$1;
      var $137=(function() { try { __THREW__ = false; return __ZL13validate_romsR17driver_enumeratorP12region_arrayR8tagmap_tIPK11game_driverE($drivlist, $rgninfo, $roms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 72; break; };
    case 48: // $138
      if ($137) { var $143 = 1;__label__ = 50; break; } else { __label__ = 49; break; }
    case 49: // $139
      var $140=$error;
      var $141=(($140) & 1);
      var $143 = $141;__label__ = 50; break;
    case 50: // $142
      var $143;
      var $144=(($143)&1);
      $error=$144;
      var $145=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 72; break; };
      var $145$0=$145[0];
      var $145$1=$145[1];
    case 51: // $146
      var $st$0$0=(($rom_checks)|0);
      var $147$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($rom_checks+4)|0);
      var $147$1=HEAP32[(($st$0$1)>>2)];
      var $148$0 = ((($147$0)>>>0)+((($147$1)|0)*4294967296))+((($145$0)>>>0)+((($145$1)|0)*4294967296))>>>0; var $148$1 = Math.min(Math.floor((((($147$0)>>>0)+((($147$1)|0)*4294967296))+((($145$0)>>>0)+((($145$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($rom_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$148$0;
      var $st$5$1=(($rom_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$148$1;
      var $149=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 72; break; };
      var $149$0=$149[0];
      var $149$1=$149[1];
    case 52: // $150
      var $st$0$0=(($input_checks)|0);
      var $151$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($input_checks+4)|0);
      var $151$1=HEAP32[(($st$0$1)>>2)];
      var $152$0 = ((($151$0)>>>0)+((($151$1)|0)*4294967296))-((($149$0)>>>0)+((($149$1)|0)*4294967296))>>>0; var $152$1 = Math.min(Math.floor((((($151$0)>>>0)+((($151$1)|0)*4294967296))-((($149$0)>>>0)+((($149$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($input_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$152$0;
      var $st$5$1=(($input_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$152$1;
      var $153=(function() { try { __THREW__ = false; return __ZL15validate_inputsR17driver_enumeratorR8tagmap_tIjER11tagged_listI17input_port_configE($drivlist, $defstr, $portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 72; break; };
    case 53: // $154
      if ($153) { var $159 = 1;__label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $155
      var $156=$error;
      var $157=(($156) & 1);
      var $159 = $157;__label__ = 55; break;
    case 55: // $158
      var $159;
      var $160=(($159)&1);
      $error=$160;
      var $161=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 72; break; };
      var $161$0=$161[0];
      var $161$1=$161[1];
    case 56: // $162
      var $st$0$0=(($input_checks)|0);
      var $163$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($input_checks+4)|0);
      var $163$1=HEAP32[(($st$0$1)>>2)];
      var $164$0 = ((($163$0)>>>0)+((($163$1)|0)*4294967296))+((($161$0)>>>0)+((($161$1)|0)*4294967296))>>>0; var $164$1 = Math.min(Math.floor((((($163$0)>>>0)+((($163$1)|0)*4294967296))+((($161$0)>>>0)+((($161$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($input_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$164$0;
      var $st$5$1=(($input_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$164$1;
      var $165=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 72; break; };
      var $165$0=$165[0];
      var $165$1=$165[1];
    case 57: // $166
      var $st$0$0=(($display_checks)|0);
      var $167$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($display_checks+4)|0);
      var $167$1=HEAP32[(($st$0$1)>>2)];
      var $168$0 = ((($167$0)>>>0)+((($167$1)|0)*4294967296))-((($165$0)>>>0)+((($165$1)|0)*4294967296))>>>0; var $168$1 = Math.min(Math.floor((((($167$0)>>>0)+((($167$1)|0)*4294967296))-((($165$0)>>>0)+((($165$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($display_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$168$0;
      var $st$5$1=(($display_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$168$1;
      var $169=(function() { try { __THREW__ = false; return __ZL16validate_displayR17driver_enumerator($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 72; break; };
    case 58: // $170
      if ($169) { var $175 = 1;__label__ = 60; break; } else { __label__ = 59; break; }
    case 59: // $171
      var $172=$error;
      var $173=(($172) & 1);
      var $175 = $173;__label__ = 60; break;
    case 60: // $174
      var $175;
      var $176=(($175)&1);
      $error=$176;
      var $177=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 72; break; };
      var $177$0=$177[0];
      var $177$1=$177[1];
    case 61: // $178
      var $st$0$0=(($display_checks)|0);
      var $179$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($display_checks+4)|0);
      var $179$1=HEAP32[(($st$0$1)>>2)];
      var $180$0 = ((($179$0)>>>0)+((($179$1)|0)*4294967296))+((($177$0)>>>0)+((($177$1)|0)*4294967296))>>>0; var $180$1 = Math.min(Math.floor((((($179$0)>>>0)+((($179$1)|0)*4294967296))+((($177$0)>>>0)+((($177$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($display_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$180$0;
      var $st$5$1=(($display_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$180$1;
      var $181=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 72; break; };
      var $181$0=$181[0];
      var $181$1=$181[1];
    case 62: // $182
      var $st$0$0=(($gfx_checks)|0);
      var $183$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($gfx_checks+4)|0);
      var $183$1=HEAP32[(($st$0$1)>>2)];
      var $184$0 = ((($183$0)>>>0)+((($183$1)|0)*4294967296))-((($181$0)>>>0)+((($181$1)|0)*4294967296))>>>0; var $184$1 = Math.min(Math.floor((((($183$0)>>>0)+((($183$1)|0)*4294967296))-((($181$0)>>>0)+((($181$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($gfx_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$184$0;
      var $st$5$1=(($gfx_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$184$1;
      var $185=(function() { try { __THREW__ = false; return __ZL12validate_gfxR17driver_enumeratorP12region_array($drivlist, $rgninfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 72; break; };
    case 63: // $186
      if ($185) { var $191 = 1;__label__ = 65; break; } else { __label__ = 64; break; }
    case 64: // $187
      var $188=$error;
      var $189=(($188) & 1);
      var $191 = $189;__label__ = 65; break;
    case 65: // $190
      var $191;
      var $192=(($191)&1);
      $error=$192;
      var $193=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 72; break; };
      var $193$0=$193[0];
      var $193$1=$193[1];
    case 66: // $194
      var $st$0$0=(($gfx_checks)|0);
      var $195$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($gfx_checks+4)|0);
      var $195$1=HEAP32[(($st$0$1)>>2)];
      var $196$0 = ((($195$0)>>>0)+((($195$1)|0)*4294967296))+((($193$0)>>>0)+((($193$1)|0)*4294967296))>>>0; var $196$1 = Math.min(Math.floor((((($195$0)>>>0)+((($195$1)|0)*4294967296))+((($193$0)>>>0)+((($193$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($gfx_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$196$0;
      var $st$5$1=(($gfx_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$196$1;
      var $197=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 72; break; };
      var $197$0=$197[0];
      var $197$1=$197[1];
    case 67: // $198
      var $st$0$0=(($device_checks)|0);
      var $199$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($device_checks+4)|0);
      var $199$1=HEAP32[(($st$0$1)>>2)];
      var $200$0 = ((($199$0)>>>0)+((($199$1)|0)*4294967296))-((($197$0)>>>0)+((($197$1)|0)*4294967296))>>>0; var $200$1 = Math.min(Math.floor((((($199$0)>>>0)+((($199$1)|0)*4294967296))-((($197$0)>>>0)+((($197$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($device_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$200$0;
      var $st$5$1=(($device_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$200$1;
      var $201=(function() { try { __THREW__ = false; return __ZL16validate_devicesR17driver_enumeratorRK11tagged_listI17input_port_configEP12region_array($drivlist, $portlist, $rgninfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 72; break; };
    case 68: // $202
      if ($201) { var $207 = 1;__label__ = 70; break; } else { __label__ = 69; break; }
    case 69: // $203
      var $204=$error;
      var $205=(($204) & 1);
      var $207 = $205;__label__ = 70; break;
    case 70: // $206
      var $207;
      var $208=(($207)&1);
      $error=$208;
      var $209=(function() { try { __THREW__ = false; return __ZL17get_profile_ticksv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 72; break; };
      var $209$0=$209[0];
      var $209$1=$209[1];
    case 71: // $210
      var $st$0$0=(($device_checks)|0);
      var $211$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($device_checks+4)|0);
      var $211$1=HEAP32[(($st$0$1)>>2)];
      var $212$0 = ((($211$0)>>>0)+((($211$1)|0)*4294967296))+((($209$0)>>>0)+((($209$1)|0)*4294967296))>>>0; var $212$1 = Math.min(Math.floor((((($211$0)>>>0)+((($211$1)|0)*4294967296))+((($209$0)>>>0)+((($209$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$5$0=(($device_checks)|0);
      HEAP32[(($st$5$0)>>2)]=$212$0;
      var $st$5$1=(($device_checks+4)|0);
      HEAP32[(($st$5$1)>>2)]=$212$1;
      __label__ = 81; break;
    case 72: // $213
      var $214=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI14emu_fatalerror]);
      var $215=$214.f0;
      $3=$215;
      var $216=$214.f1;
      $4=$216;
      __label__ = 73; break;
    case 73: // $217
      var $218=$4;
      var $219=_llvm_eh_typeid_for(__ZTI14emu_fatalerror);
      var $220=(($218)|0)==(($219)|0);
      if ($220) { __label__ = 74; break; } else { __label__ = 86; break; }
    case 74: // $221
      var $222=$3;
      var $223=___cxa_begin_catch($222);
      var $224=$223;
      $err=$224;
      var $225=___cxa_allocate_exception(1032);
      var $226=$225;
      var $227=$driver;
      var $228=(($227+8)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=$driver;
      var $231=(($230)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=$err;
      var $234=(function() { try { __THREW__ = false; return __ZNK14emu_fatalerror6stringEv($233) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 77; break; };
    case 75: // $235
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($226, ((STRING_TABLE.__str153747)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$229,HEAP32[((tempInt+4)>>2)]=$232,HEAP32[((tempInt+8)>>2)]=$234,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $236
      (function() { try { __THREW__ = false; return ___cxa_throw($225, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 78; break; }
    case 77: // $237
      var $238=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $239=$238.f0;
      $3=$239;
      var $240=$238.f1;
      $4=$240;
      ___cxa_free_exception($225);
      __label__ = 79; break;
    case 78: // $241
      var $242=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $243=$242.f0;
      $3=$243;
      var $244=$242.f1;
      $4=$244;
      __label__ = 79; break;
    case 79: // $245
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 110; break; }
    case 80: // $246
      __label__ = 86; break;
    case 81: // $247
      $5=0;
      __label__ = 82; break;
    case 82: // $248
      (function() { try { __THREW__ = false; return __ZN12region_arrayD1Ev($rgninfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 39; break; }
    case 83: // $249
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configED1Ev($portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 38; break; }
    case 84: // $250
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0) {
        __label__ = 85; break;
      }
      else if ($cleanup_dest == 5) {
        __label__ = 29; break;
      }
      else {
      __label__ = 111; break;
      }
      
    case 85: // $251
      __label__ = 29; break;
    case 86: // $252
      (function() { try { __THREW__ = false; return __ZN12region_arrayD1Ev($rgninfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 110; break; }
    case 87: // $253
      __label__ = 88; break;
    case 88: // $254
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configED1Ev($portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 110; break; }
    case 89: // $255
      __label__ = 99; break;
    case 90: // $256
      var $257=$error;
      var $258=(($257) & 1);
      if ($258) { __label__ = 91; break; } else { __label__ = 94; break; }
    case 91: // $259
      var $260=___cxa_allocate_exception(1032);
      var $261=$260;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EiPKcz($261, 1, ((STRING_TABLE.__str163748)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $262
      (function() { try { __THREW__ = false; return ___cxa_throw($260, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 38; break; }
    case 93: // $263
      var $264=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $265=$264.f0;
      $3=$265;
      var $266=$264.f1;
      $4=$266;
      ___cxa_free_exception($260);
      __label__ = 99; break;
    case 94: // $267
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 9; break; }
    case 95: // $268
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIjED1Ev($defstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 8; break; }
    case 96: // $269
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverED1Ev($roms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 7; break; }
    case 97: // $270
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverED1Ev($descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 6; break; }
    case 98: // $271
      __ZN8tagmap_tIPK11game_driverED1Ev($names);
      STACKTOP = __stackBase__;
      return;
    case 99: // $272
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 110; break; }
    case 100: // $273
      __label__ = 101; break;
    case 101: // $274
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIjED1Ev($defstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 110; break; }
    case 102: // $275
      __label__ = 103; break;
    case 103: // $276
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverED1Ev($roms) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 110; break; }
    case 104: // $277
      __label__ = 105; break;
    case 105: // $278
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverED1Ev($descriptions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 110; break; }
    case 106: // $279
      __label__ = 107; break;
    case 107: // $280
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPK11game_driverED1Ev($names) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 110; break; }
    case 108: // $281
      __label__ = 109; break;
    case 109: // $282
      var $283=$3;
      var $284=$3;
      var $285=$4;
      var $286=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $284, tempValue);
      var $287=($286.f1 = $285, $286);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 110: // $288
      var $289=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 111: // $290
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16validate_driversR11emu_optionsPK11game_driver["X"]=1;

function __ZL16validate_inlinesv() {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $testu64a=__stackBase__;
      var $testi64a=__stackBase__+8;
      var $testu32a;
      var $testu32b;
      var $testi32a=__stackBase__+16;
      var $testi32b;
      var $resulti32;
      var $expectedi32;
      var $resultu32;
      var $expectedu32;
      var $resulti64=__stackBase__+20;
      var $expectedi64=__stackBase__+28;
      var $resultu64=__stackBase__+36;
      var $expectedu64=__stackBase__+44;
      var $remainder=__stackBase__+52;
      var $expremainder;
      var $uremainder=__stackBase__+56;
      var $expuremainder;
      var $bigu32;
      var $error;
      var $1=_rand();
      var $2=_rand();
      var $3=$2 << 15;
      var $4=$1 ^ $3;
      var $5$0=$4;
      var $5$1=(($4|0) < 0 ? -1 : 0);
      var $6=_rand();
      var $7$0=$6;
      var $7$1=(($6|0) < 0 ? -1 : 0);
      var $8$0=($7$0 << 30) | (0 >>> 2);
      var $8$1=($7$1 << 30) | ($7$0 >>> 2);
      var $9$0=$5$0 ^ $8$0;
      var $9$1=$5$1 ^ $8$1;
      var $10=_rand();
      var $11$0=$10;
      var $11$1=(($10|0) < 0 ? -1 : 0);
      var $12$0=(0 << 13) | (0 >>> 19);
      var $12$1=($11$0 << 13) | (0 >>> 19);
      var $13$0=$9$0 ^ $12$0;
      var $13$1=$9$1 ^ $12$1;
      var $st$40$0=(($testu64a)|0);
      HEAP32[(($st$40$0)>>2)]=$13$0;
      var $st$40$1=(($testu64a+4)|0);
      HEAP32[(($st$40$1)>>2)]=$13$1;
      var $14=_rand();
      var $15=_rand();
      var $16=$15 << 15;
      var $17=$14 ^ $16;
      var $18$0=$17;
      var $18$1=(($17|0) < 0 ? -1 : 0);
      var $19=_rand();
      var $20$0=$19;
      var $20$1=(($19|0) < 0 ? -1 : 0);
      var $21$0=($20$0 << 30) | (0 >>> 2);
      var $21$1=($20$1 << 30) | ($20$0 >>> 2);
      var $22$0=$18$0 ^ $21$0;
      var $22$1=$18$1 ^ $21$1;
      var $23=_rand();
      var $24$0=$23;
      var $24$1=(($23|0) < 0 ? -1 : 0);
      var $25$0=(0 << 13) | (0 >>> 19);
      var $25$1=($24$0 << 13) | (0 >>> 19);
      var $26$0=$22$0 ^ $25$0;
      var $26$1=$22$1 ^ $25$1;
      var $st$64$0=(($testi64a)|0);
      HEAP32[(($st$64$0)>>2)]=$26$0;
      var $st$64$1=(($testi64a+4)|0);
      HEAP32[(($st$64$1)>>2)]=$26$1;
      var $27=_rand();
      var $28=_rand();
      var $29=$28 << 15;
      var $30=$27 ^ $29;
      $testu32a=$30;
      var $31=_rand();
      var $32=_rand();
      var $33=$32 << 15;
      var $34=$31 ^ $33;
      $testu32b=$34;
      var $35=_rand();
      var $36=_rand();
      var $37=$36 << 15;
      var $38=$35 ^ $37;
      HEAP32[(($testi32a)>>2)]=$38;
      var $39=_rand();
      var $40=_rand();
      var $41=$40 << 15;
      var $42=$39 ^ $41;
      $testi32b=$42;
      $bigu32=-1;
      $error=0;
      var $st$90$0=(($testu64a)|0);
      var $43$0=HEAP32[(($st$90$0)>>2)];
      var $st$90$1=(($testu64a+4)|0);
      var $43$1=HEAP32[(($st$90$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $44=$43$0 == $$emscripten$temp$0$0 && $43$1 == $$emscripten$temp$0$1;
      if ($44) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $st$0$0=(($testu64a)|0);
      var $46$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $46$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $47$0 = ((($46$0)>>>0)+((($46$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $47$1 = Math.min(Math.floor((((($46$0)>>>0)+((($46$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($testu64a)|0);
      HEAP32[(($st$7$0)>>2)]=$47$0;
      var $st$7$1=(($testu64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$47$1;
      __label__ = 2; break;
    case 2: // $48
      var $st$0$0=(($testi64a)|0);
      var $49$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $49$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $50=$49$0 == $$emscripten$temp$2$0 && $49$1 == $$emscripten$temp$2$1;
      if ($50) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $51
      var $st$0$0=(($testi64a)|0);
      var $52$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $52$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $53$0 = ((($52$0)>>>0)+((($52$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $53$1 = Math.min(Math.floor((((($52$0)>>>0)+((($52$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($testi64a)|0);
      HEAP32[(($st$7$0)>>2)]=$53$0;
      var $st$7$1=(($testi64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$53$1;
      __label__ = 7; break;
    case 4: // $54
      var $st$0$0=(($testi64a)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $56=($55$1|0) < ($$emscripten$temp$4$1|0) || (($55$1|0) == ($$emscripten$temp$4$1|0) && ($55$0|0) <  ($$emscripten$temp$4$0|0));
      if ($56) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $57
      var $st$0$0=(($testi64a)|0);
      var $58$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $58$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $59$0 = ((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))-((($58$0)>>>0)+((($58$1)|0)*4294967296))>>>0; var $59$1 = Math.min(Math.floor((((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))-((($58$0)>>>0)+((($58$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($testi64a)|0);
      HEAP32[(($st$7$0)>>2)]=$59$0;
      var $st$7$1=(($testi64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$59$1;
      __label__ = 6; break;
    case 6: // $60
      __label__ = 7; break;
    case 7: // $61
      var $62=$testu32a;
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $64
      var $65=$testu32a;
      var $66=(($65+1)|0);
      $testu32a=$66;
      __label__ = 9; break;
    case 9: // $67
      var $68=$testu32b;
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$testu32b;
      var $72=(($71+1)|0);
      $testu32b=$72;
      __label__ = 11; break;
    case 11: // $73
      var $74=HEAP32[(($testi32a)>>2)];
      var $75=(($74)|0)==0;
      if ($75) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $76
      var $77=HEAP32[(($testi32a)>>2)];
      var $78=(($77+1)|0);
      HEAP32[(($testi32a)>>2)]=$78;
      __label__ = 16; break;
    case 13: // $79
      var $80=HEAP32[(($testi32a)>>2)];
      var $81=(($80)|0) < 0;
      if ($81) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $82
      var $83=HEAP32[(($testi32a)>>2)];
      var $84=(((-$83))|0);
      HEAP32[(($testi32a)>>2)]=$84;
      __label__ = 15; break;
    case 15: // $85
      __label__ = 16; break;
    case 16: // $86
      var $87=$testi32b;
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $89
      var $90=$testi32b;
      var $91=(($90+1)|0);
      $testi32b=$91;
      __label__ = 21; break;
    case 18: // $92
      var $93=$testi32b;
      var $94=(($93)|0) < 0;
      if ($94) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $95
      var $96=$testi32b;
      var $97=(((-$96))|0);
      $testi32b=$97;
      __label__ = 20; break;
    case 20: // $98
      __label__ = 21; break;
    case 21: // $99
      var $100=HEAP32[(($testi32a)>>2)];
      var $101=$testi32b;
      var $102=__ZL9mul_32x32ii3841($100, $101);
      var $102$0=$102[0];
      var $102$1=$102[1];
      var $st$5$0=(($resulti64)|0);
      HEAP32[(($st$5$0)>>2)]=$102$0;
      var $st$5$1=(($resulti64+4)|0);
      HEAP32[(($st$5$1)>>2)]=$102$1;
      var $103=HEAP32[(($testi32a)>>2)];
      var $104$0=$103;
      var $104$1=(($103|0) < 0 ? -1 : 0);
      var $105=$testi32b;
      var $106$0=$105;
      var $106$1=(($105|0) < 0 ? -1 : 0);
      var $107$0 = ((($104$0)>>>0)+((($104$1)|0)*4294967296))*((($106$0)>>>0)+((($106$1)|0)*4294967296))>>>0; var $107$1 = Math.min(Math.floor((((($104$0)>>>0)+((($104$1)|0)*4294967296))*((($106$0)>>>0)+((($106$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$16$0=(($expectedi64)|0);
      HEAP32[(($st$16$0)>>2)]=$107$0;
      var $st$16$1=(($expectedi64+4)|0);
      HEAP32[(($st$16$1)>>2)]=$107$1;
      var $st$20$0=(($resulti64)|0);
      var $108$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($resulti64+4)|0);
      var $108$1=HEAP32[(($st$20$1)>>2)];
      var $st$24$0=(($expectedi64)|0);
      var $109$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($expectedi64+4)|0);
      var $109$1=HEAP32[(($st$24$1)>>2)];
      var $110=$108$0 != $109$0 || $108$1 != $109$1;
      if ($110) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $111
      var $112=HEAP32[(($testi32a)>>2)];
      var $113=$testi32b;
      var $st$2$0=(($resulti64)|0);
      var $114$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($resulti64+4)|0);
      var $114$1=HEAP32[(($st$2$1)>>2)];
      var $115$0=$114$1;
      var $115$1=(($114$1|0) < 0 ? -1 : 0);
      var $116$0=$115$0;
      var $116=$116$0;
      var $st$10$0=(($resulti64)|0);
      var $117$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($resulti64+4)|0);
      var $117$1=HEAP32[(($st$10$1)>>2)];
      var $118$0=$117$0;
      var $118=$118$0;
      var $st$16$0=(($expectedi64)|0);
      var $119$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($expectedi64+4)|0);
      var $119$1=HEAP32[(($st$16$1)>>2)];
      var $120$0=$119$1;
      var $120$1=(($119$1|0) < 0 ? -1 : 0);
      var $121$0=$120$0;
      var $121=$121$0;
      var $st$24$0=(($expectedi64)|0);
      var $122$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($expectedi64+4)|0);
      var $122$1=HEAP32[(($st$24$1)>>2)];
      var $123$0=$122$0;
      var $123=$123$0;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str803812)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$112,HEAP32[((tempInt+4)>>2)]=$113,HEAP32[((tempInt+8)>>2)]=$116,HEAP32[((tempInt+12)>>2)]=$118,HEAP32[((tempInt+16)>>2)]=$121,HEAP32[((tempInt+20)>>2)]=$123,tempInt));
      $error=1;
      __label__ = 23; break;
    case 23: // $124
      var $125=$testu32a;
      var $126=$testu32b;
      var $127=__ZL10mulu_32x32jj3842($125, $126);
      var $127$0=$127[0];
      var $127$1=$127[1];
      var $st$5$0=(($resultu64)|0);
      HEAP32[(($st$5$0)>>2)]=$127$0;
      var $st$5$1=(($resultu64+4)|0);
      HEAP32[(($st$5$1)>>2)]=$127$1;
      var $128=$testu32a;
      var $129$0=$128;
      var $129$1=0;
      var $130=$testu32b;
      var $131$0=$130;
      var $131$1=0;
      var $132$0 = ((($129$0)>>>0)+((($129$1)|0)*4294967296))*((($131$0)>>>0)+((($131$1)|0)*4294967296))>>>0; var $132$1 = Math.min(Math.floor((((($129$0)>>>0)+((($129$1)|0)*4294967296))*((($131$0)>>>0)+((($131$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$16$0=(($expectedu64)|0);
      HEAP32[(($st$16$0)>>2)]=$132$0;
      var $st$16$1=(($expectedu64+4)|0);
      HEAP32[(($st$16$1)>>2)]=$132$1;
      var $st$20$0=(($resultu64)|0);
      var $133$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($resultu64+4)|0);
      var $133$1=HEAP32[(($st$20$1)>>2)];
      var $st$24$0=(($expectedu64)|0);
      var $134$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($expectedu64+4)|0);
      var $134$1=HEAP32[(($st$24$1)>>2)];
      var $135=$133$0 != $134$0 || $133$1 != $134$1;
      if ($135) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $136
      var $137=$testu32a;
      var $138=$testu32b;
      var $st$2$0=(($resultu64)|0);
      var $139$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($resultu64+4)|0);
      var $139$1=HEAP32[(($st$2$1)>>2)];
      var $140$0=$139$1;
      var $140$1=0;
      var $141$0=$140$0;
      var $141=$141$0;
      var $st$10$0=(($resultu64)|0);
      var $142$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($resultu64+4)|0);
      var $142$1=HEAP32[(($st$10$1)>>2)];
      var $143$0=$142$0;
      var $143=$143$0;
      var $st$16$0=(($expectedu64)|0);
      var $144$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($expectedu64+4)|0);
      var $144$1=HEAP32[(($st$16$1)>>2)];
      var $145$0=$144$1;
      var $145$1=0;
      var $146$0=$145$0;
      var $146=$146$0;
      var $st$24$0=(($expectedu64)|0);
      var $147$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($expectedu64+4)|0);
      var $147$1=HEAP32[(($st$24$1)>>2)];
      var $148$0=$147$0;
      var $148=$148$0;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str813813)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$137,HEAP32[((tempInt+4)>>2)]=$138,HEAP32[((tempInt+8)>>2)]=$141,HEAP32[((tempInt+12)>>2)]=$143,HEAP32[((tempInt+16)>>2)]=$146,HEAP32[((tempInt+20)>>2)]=$148,tempInt));
      $error=1;
      __label__ = 25; break;
    case 25: // $149
      var $150=HEAP32[(($testi32a)>>2)];
      var $151=$testi32b;
      var $152=__ZL12mul_32x32_hiii($150, $151);
      $resulti32=$152;
      var $153=HEAP32[(($testi32a)>>2)];
      var $154$0=$153;
      var $154$1=(($153|0) < 0 ? -1 : 0);
      var $155=$testi32b;
      var $156$0=$155;
      var $156$1=(($155|0) < 0 ? -1 : 0);
      var $157$0 = ((($154$0)>>>0)+((($154$1)|0)*4294967296))*((($156$0)>>>0)+((($156$1)|0)*4294967296))>>>0; var $157$1 = Math.min(Math.floor((((($154$0)>>>0)+((($154$1)|0)*4294967296))*((($156$0)>>>0)+((($156$1)|0)*4294967296)))/4294967296), 4294967295);
      var $158$0=$157$1;
      var $158$1=(($157$1|0) < 0 ? -1 : 0);
      var $159$0=$158$0;
      var $159=$159$0;
      $expectedi32=$159;
      var $160=$resulti32;
      var $161=$expectedi32;
      var $162=(($160)|0)!=(($161)|0);
      if ($162) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $163
      var $164=HEAP32[(($testi32a)>>2)];
      var $165=$testi32b;
      var $166=$resulti32;
      var $167=$expectedi32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str823814)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$164,HEAP32[((tempInt+4)>>2)]=$165,HEAP32[((tempInt+8)>>2)]=$166,HEAP32[((tempInt+12)>>2)]=$167,tempInt));
      $error=1;
      __label__ = 27; break;
    case 27: // $168
      var $169=$testu32a;
      var $170=$testu32b;
      var $171=__ZL13mulu_32x32_hijj($169, $170);
      $resultu32=$171;
      var $172=$testu32a;
      var $173$0=$172;
      var $173$1=0;
      var $174=$testu32b;
      var $175$0=$174;
      var $175$1=0;
      var $176$0 = ((($173$0)>>>0)+((($173$1)|0)*4294967296))*((($175$0)>>>0)+((($175$1)|0)*4294967296))>>>0; var $176$1 = Math.min(Math.floor((((($173$0)>>>0)+((($173$1)|0)*4294967296))*((($175$0)>>>0)+((($175$1)|0)*4294967296)))/4294967296), 4294967295);
      var $177$0=$176$1;
      var $177$1=(($176$1|0) < 0 ? -1 : 0);
      var $178$0=$177$0;
      var $178=$178$0;
      $expectedu32=$178;
      var $179=$resultu32;
      var $180=$expectedu32;
      var $181=(($179)|0)!=(($180)|0);
      if ($181) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $182
      var $183=$testu32a;
      var $184=$testu32b;
      var $185=$resultu32;
      var $186=$expectedu32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str833815)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$183,HEAP32[((tempInt+4)>>2)]=$184,HEAP32[((tempInt+8)>>2)]=$185,HEAP32[((tempInt+12)>>2)]=$186,tempInt));
      $error=1;
      __label__ = 29; break;
    case 29: // $187
      var $188=HEAP32[(($testi32a)>>2)];
      var $189=$testi32b;
      var $190=__ZL15mul_32x32_shiftiih($188, $189, 7);
      $resulti32=$190;
      var $191=HEAP32[(($testi32a)>>2)];
      var $192$0=$191;
      var $192$1=(($191|0) < 0 ? -1 : 0);
      var $193=$testi32b;
      var $194$0=$193;
      var $194$1=(($193|0) < 0 ? -1 : 0);
      var $195$0 = ((($192$0)>>>0)+((($192$1)|0)*4294967296))*((($194$0)>>>0)+((($194$1)|0)*4294967296))>>>0; var $195$1 = Math.min(Math.floor((((($192$0)>>>0)+((($192$1)|0)*4294967296))*((($194$0)>>>0)+((($194$1)|0)*4294967296)))/4294967296), 4294967295);
      var $196$0=($195$0 >>> 7) | ($195$1 << 25);
      var $196$1=($195$1 >> 7) | (((($195$1|0) < 0 ? -1 : 0)) << 25);
      var $197$0=$196$0;
      var $197=$197$0;
      $expectedi32=$197;
      var $198=$resulti32;
      var $199=$expectedi32;
      var $200=(($198)|0)!=(($199)|0);
      if ($200) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $201
      var $202=HEAP32[(($testi32a)>>2)];
      var $203=$testi32b;
      var $204=$resulti32;
      var $205=$expectedi32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str843816)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$202,HEAP32[((tempInt+4)>>2)]=$203,HEAP32[((tempInt+8)>>2)]=$204,HEAP32[((tempInt+12)>>2)]=$205,tempInt));
      $error=1;
      __label__ = 31; break;
    case 31: // $206
      var $207=$testu32a;
      var $208=$testu32b;
      var $209=__ZL16mulu_32x32_shiftjjh($207, $208, 7);
      $resultu32=$209;
      var $210=$testu32a;
      var $211$0=$210;
      var $211$1=0;
      var $212=$testu32b;
      var $213$0=$212;
      var $213$1=0;
      var $214$0 = ((($211$0)>>>0)+((($211$1)|0)*4294967296))*((($213$0)>>>0)+((($213$1)|0)*4294967296))>>>0; var $214$1 = Math.min(Math.floor((((($211$0)>>>0)+((($211$1)|0)*4294967296))*((($213$0)>>>0)+((($213$1)|0)*4294967296)))/4294967296), 4294967295);
      var $215$0=($214$0 >>> 7) | ($214$1 << 25);
      var $215$1=($214$1 >> 7) | (((($214$1|0) < 0 ? -1 : 0)) << 25);
      var $216$0=$215$0;
      var $216=$216$0;
      $expectedu32=$216;
      var $217=$resultu32;
      var $218=$expectedu32;
      var $219=(($217)|0)!=(($218)|0);
      if ($219) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $220
      var $221=$testu32a;
      var $222=$testu32b;
      var $223=$resultu32;
      var $224=$expectedu32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str853817)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$221,HEAP32[((tempInt+4)>>2)]=$222,HEAP32[((tempInt+8)>>2)]=$223,HEAP32[((tempInt+12)>>2)]=$224,tempInt));
      $error=1;
      __label__ = 33; break;
    case 33: // $225
      __label__ = 34; break;
    case 34: // $226
      var $227=HEAP32[(($testi32a)>>2)];
      var $228$0=$227;
      var $228$1=(($227|0) < 0 ? -1 : 0);
      var $$emscripten$temp$6$0=2147483647;
      var $$emscripten$temp$6$1=0;
      var $229$0 = ((($228$0)>>>0)+((($228$1)|0)*4294967296))*((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))>>>0; var $229$1 = Math.min(Math.floor((((($228$0)>>>0)+((($228$1)|0)*4294967296))*((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$6$0=(($testi64a)|0);
      var $230$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($testi64a+4)|0);
      var $230$1=HEAP32[(($st$6$1)>>2)];
      var $231=($229$1|0) < ($230$1|0) || (($229$1|0) == ($230$1|0) && ($229$0|0) <  ($230$0|0));
      if ($231) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $232
      var $st$0$0=(($testi64a)|0);
      var $233$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $233$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$7$0=2;
      var $$emscripten$temp$7$1=0;
      var $234$0 = (tempBigIntR=((($233$0)>>>0)+((($233$1)|0)*4294967296))/((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $234$1 = Math.min(Math.floor(((tempBigIntR=((($233$0)>>>0)+((($233$1)|0)*4294967296))/((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$7$0=(($testi64a)|0);
      HEAP32[(($st$7$0)>>2)]=$234$0;
      var $st$7$1=(($testi64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$234$1;
      __label__ = 34; break;
    case 36: // $235
      __label__ = 37; break;
    case 37: // $236
      var $237=$testu32a;
      var $238$0=$237;
      var $238$1=0;
      var $239=$bigu32;
      var $240$0=$239;
      var $240$1=0;
      var $241$0 = ((($238$0)>>>0)+((($238$1)|0)*4294967296))*((($240$0)>>>0)+((($240$1)|0)*4294967296))>>>0; var $241$1 = Math.min(Math.floor((((($238$0)>>>0)+((($238$1)|0)*4294967296))*((($240$0)>>>0)+((($240$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($testu64a)|0);
      var $242$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($testu64a+4)|0);
      var $242$1=HEAP32[(($st$7$1)>>2)];
      var $243=$241$1 < $242$1 || ($241$1 == $242$1 && $241$0 < $242$0);
      if ($243) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $244
      var $st$0$0=(($testu64a)|0);
      var $245$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $245$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$8$0=2;
      var $$emscripten$temp$8$1=0;
      var $246$0 = Math.floor(((($245$0)>>>0)+((($245$1)|0)*4294967296))/((($$emscripten$temp$8$0)>>>0)+((($$emscripten$temp$8$1)|0)*4294967296)))>>>0; var $246$1 = Math.min(Math.floor((Math.floor(((($245$0)>>>0)+((($245$1)|0)*4294967296))/((($$emscripten$temp$8$0)>>>0)+((($$emscripten$temp$8$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$7$0=(($testu64a)|0);
      HEAP32[(($st$7$0)>>2)]=$246$0;
      var $st$7$1=(($testu64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$246$1;
      __label__ = 37; break;
    case 39: // $247
      var $st$0$0=(($testi64a)|0);
      var $248$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $248$1=HEAP32[(($st$0$1)>>2)];
      var $249=HEAP32[(($testi32a)>>2)];
      var $250=__ZL9div_64x32xi($248$0, $248$1, $249);
      var $250$0=$250[0];
      $resulti32=$250;
      var $st$8$0=(($testi64a)|0);
      var $251$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testi64a+4)|0);
      var $251$1=HEAP32[(($st$8$1)>>2)];
      var $252=HEAP32[(($testi32a)>>2)];
      var $253$0=$252;
      var $253$1=(($252|0) < 0 ? -1 : 0);
      var $254$0 = (tempBigIntR=((($251$0)>>>0)+((($251$1)|0)*4294967296))/((($253$0)>>>0)+((($253$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $254$1 = Math.min(Math.floor(((tempBigIntR=((($251$0)>>>0)+((($251$1)|0)*4294967296))/((($253$0)>>>0)+((($253$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $255$0=$254$0;
      var $255=$255$0;
      $expectedi32=$255;
      var $256=$resulti32;
      var $257=$expectedi32;
      var $258=(($256)|0)!=(($257)|0);
      if ($258) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $259
      var $st$0$0=(($testi64a)|0);
      var $260$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $260$1=HEAP32[(($st$0$1)>>2)];
      var $261$0=$260$1;
      var $261$1=(($260$1|0) < 0 ? -1 : 0);
      var $262$0=$261$0;
      var $262=$262$0;
      var $st$8$0=(($testi64a)|0);
      var $263$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testi64a+4)|0);
      var $263$1=HEAP32[(($st$8$1)>>2)];
      var $264$0=$263$0;
      var $264=$264$0;
      var $265=HEAP32[(($testi32a)>>2)];
      var $266=$resulti32;
      var $267=$expectedi32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str863818)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$262,HEAP32[((tempInt+4)>>2)]=$264,HEAP32[((tempInt+8)>>2)]=$265,HEAP32[((tempInt+12)>>2)]=$266,HEAP32[((tempInt+16)>>2)]=$267,tempInt));
      $error=1;
      __label__ = 41; break;
    case 41: // $268
      var $st$0$0=(($testu64a)|0);
      var $269$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $269$1=HEAP32[(($st$0$1)>>2)];
      var $270=$testu32a;
      var $271=__ZL10divu_64x32yj3843($269$0, $269$1, $270);
      var $271$0=$271[0];
      $resultu32=$271;
      var $st$8$0=(($testu64a)|0);
      var $272$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testu64a+4)|0);
      var $272$1=HEAP32[(($st$8$1)>>2)];
      var $273=$testu32a;
      var $274$0=$273;
      var $274$1=0;
      var $275$0 = Math.floor(((($272$0)>>>0)+((($272$1)|0)*4294967296))/((($274$0)>>>0)+((($274$1)|0)*4294967296)))>>>0; var $275$1 = Math.min(Math.floor((Math.floor(((($272$0)>>>0)+((($272$1)|0)*4294967296))/((($274$0)>>>0)+((($274$1)|0)*4294967296))))/4294967296), 4294967295);
      var $276$0=$275$0;
      var $276=$276$0;
      $expectedu32=$276;
      var $277=$resultu32;
      var $278=$expectedu32;
      var $279=(($277)|0)!=(($278)|0);
      if ($279) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $280
      var $st$0$0=(($testu64a)|0);
      var $281$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $281$1=HEAP32[(($st$0$1)>>2)];
      var $282$0=$281$1;
      var $282$1=0;
      var $283$0=$282$0;
      var $283=$283$0;
      var $st$8$0=(($testu64a)|0);
      var $284$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testu64a+4)|0);
      var $284$1=HEAP32[(($st$8$1)>>2)];
      var $285$0=$284$0;
      var $285=$285$0;
      var $286=$testu32a;
      var $287=$resultu32;
      var $288=$expectedu32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str873819)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$283,HEAP32[((tempInt+4)>>2)]=$285,HEAP32[((tempInt+8)>>2)]=$286,HEAP32[((tempInt+12)>>2)]=$287,HEAP32[((tempInt+16)>>2)]=$288,tempInt));
      $error=1;
      __label__ = 43; break;
    case 43: // $289
      var $st$0$0=(($testi64a)|0);
      var $290$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $290$1=HEAP32[(($st$0$1)>>2)];
      var $291=HEAP32[(($testi32a)>>2)];
      var $292=__ZL13div_64x32_remxiPi($290$0, $290$1, $291, $remainder);
      var $292$0=$292[0];
      $resulti32=$292;
      var $st$8$0=(($testi64a)|0);
      var $293$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testi64a+4)|0);
      var $293$1=HEAP32[(($st$8$1)>>2)];
      var $294=HEAP32[(($testi32a)>>2)];
      var $295$0=$294;
      var $295$1=(($294|0) < 0 ? -1 : 0);
      var $296$0 = (tempBigIntR=((($293$0)>>>0)+((($293$1)|0)*4294967296))/((($295$0)>>>0)+((($295$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $296$1 = Math.min(Math.floor(((tempBigIntR=((($293$0)>>>0)+((($293$1)|0)*4294967296))/((($295$0)>>>0)+((($295$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $297$0=$296$0;
      var $297=$297$0;
      $expectedi32=$297;
      var $st$19$0=(($testi64a)|0);
      var $298$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($testi64a+4)|0);
      var $298$1=HEAP32[(($st$19$1)>>2)];
      var $299=HEAP32[(($testi32a)>>2)];
      var $300$0=$299;
      var $300$1=(($299|0) < 0 ? -1 : 0);
      var $301$0 = ((($298$0)>>>0)+((($298$1)|0)*4294967296))%((($300$0)>>>0)+((($300$1)|0)*4294967296))>>>0; var $301$1 = Math.min(Math.floor((((($298$0)>>>0)+((($298$1)|0)*4294967296))%((($300$0)>>>0)+((($300$1)|0)*4294967296)))/4294967296), 4294967295);
      var $302$0=$301$0;
      var $302=$302$0;
      $expremainder=$302;
      var $303=$resulti32;
      var $304=$expectedi32;
      var $305=(($303)|0)!=(($304)|0);
      if ($305) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $306
      var $307=HEAP32[(($remainder)>>2)];
      var $308=$expremainder;
      var $309=(($307)|0)!=(($308)|0);
      if ($309) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $310
      var $st$0$0=(($testi64a)|0);
      var $311$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $311$1=HEAP32[(($st$0$1)>>2)];
      var $312$0=$311$1;
      var $312$1=(($311$1|0) < 0 ? -1 : 0);
      var $313$0=$312$0;
      var $313=$313$0;
      var $st$8$0=(($testi64a)|0);
      var $314$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testi64a+4)|0);
      var $314$1=HEAP32[(($st$8$1)>>2)];
      var $315$0=$314$0;
      var $315=$315$0;
      var $316=HEAP32[(($testi32a)>>2)];
      var $317=$resulti32;
      var $318=HEAP32[(($remainder)>>2)];
      var $319=$expectedi32;
      var $320=$expremainder;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str883820)|0), (tempInt=STACKTOP,STACKTOP += 28,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$313,HEAP32[((tempInt+4)>>2)]=$315,HEAP32[((tempInt+8)>>2)]=$316,HEAP32[((tempInt+12)>>2)]=$317,HEAP32[((tempInt+16)>>2)]=$318,HEAP32[((tempInt+20)>>2)]=$319,HEAP32[((tempInt+24)>>2)]=$320,tempInt));
      $error=1;
      __label__ = 46; break;
    case 46: // $321
      var $st$0$0=(($testu64a)|0);
      var $322$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $322$1=HEAP32[(($st$0$1)>>2)];
      var $323=$testu32a;
      var $324=__ZL14divu_64x32_remyjPj3844($322$0, $322$1, $323, $uremainder);
      var $324$0=$324[0];
      $resultu32=$324;
      var $st$8$0=(($testu64a)|0);
      var $325$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testu64a+4)|0);
      var $325$1=HEAP32[(($st$8$1)>>2)];
      var $326=$testu32a;
      var $327$0=$326;
      var $327$1=0;
      var $328$0 = Math.floor(((($325$0)>>>0)+((($325$1)|0)*4294967296))/((($327$0)>>>0)+((($327$1)|0)*4294967296)))>>>0; var $328$1 = Math.min(Math.floor((Math.floor(((($325$0)>>>0)+((($325$1)|0)*4294967296))/((($327$0)>>>0)+((($327$1)|0)*4294967296))))/4294967296), 4294967295);
      var $329$0=$328$0;
      var $329=$329$0;
      $expectedu32=$329;
      var $st$19$0=(($testu64a)|0);
      var $330$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($testu64a+4)|0);
      var $330$1=HEAP32[(($st$19$1)>>2)];
      var $331=$testu32a;
      var $332$0=$331;
      var $332$1=0;
      var $333$0 = ((($330$0)>>>0)+((($330$1)|0)*4294967296))%((($332$0)>>>0)+((($332$1)|0)*4294967296))>>>0; var $333$1 = Math.min(Math.floor((((($330$0)>>>0)+((($330$1)|0)*4294967296))%((($332$0)>>>0)+((($332$1)|0)*4294967296)))/4294967296), 4294967295);
      var $334$0=$333$0;
      var $334=$334$0;
      $expuremainder=$334;
      var $335=$resultu32;
      var $336=$expectedu32;
      var $337=(($335)|0)!=(($336)|0);
      if ($337) { __label__ = 48; break; } else { __label__ = 47; break; }
    case 47: // $338
      var $339=HEAP32[(($uremainder)>>2)];
      var $340=$expuremainder;
      var $341=(($339)|0)!=(($340)|0);
      if ($341) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $342
      var $st$0$0=(($testu64a)|0);
      var $343$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $343$1=HEAP32[(($st$0$1)>>2)];
      var $344$0=$343$1;
      var $344$1=0;
      var $345$0=$344$0;
      var $345=$345$0;
      var $st$8$0=(($testu64a)|0);
      var $346$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testu64a+4)|0);
      var $346$1=HEAP32[(($st$8$1)>>2)];
      var $347$0=$346$0;
      var $347=$347$0;
      var $348=$testu32a;
      var $349=$resultu32;
      var $350=HEAP32[(($uremainder)>>2)];
      var $351=$expectedu32;
      var $352=$expuremainder;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str893821)|0), (tempInt=STACKTOP,STACKTOP += 28,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$345,HEAP32[((tempInt+4)>>2)]=$347,HEAP32[((tempInt+8)>>2)]=$348,HEAP32[((tempInt+12)>>2)]=$349,HEAP32[((tempInt+16)>>2)]=$350,HEAP32[((tempInt+20)>>2)]=$351,HEAP32[((tempInt+24)>>2)]=$352,tempInt));
      $error=1;
      __label__ = 49; break;
    case 49: // $353
      var $st$0$0=(($testi64a)|0);
      var $354$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $354$1=HEAP32[(($st$0$1)>>2)];
      var $355=HEAP32[(($testi32a)>>2)];
      var $356=__ZL9mod_64x32xi($354$0, $354$1, $355);
      var $356$0=$356[0];
      $resulti32=$356;
      var $st$8$0=(($testi64a)|0);
      var $357$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testi64a+4)|0);
      var $357$1=HEAP32[(($st$8$1)>>2)];
      var $358=HEAP32[(($testi32a)>>2)];
      var $359$0=$358;
      var $359$1=(($358|0) < 0 ? -1 : 0);
      var $360$0 = ((($357$0)>>>0)+((($357$1)|0)*4294967296))%((($359$0)>>>0)+((($359$1)|0)*4294967296))>>>0; var $360$1 = Math.min(Math.floor((((($357$0)>>>0)+((($357$1)|0)*4294967296))%((($359$0)>>>0)+((($359$1)|0)*4294967296)))/4294967296), 4294967295);
      var $361$0=$360$0;
      var $361=$361$0;
      $expectedi32=$361;
      var $362=$resulti32;
      var $363=$expectedi32;
      var $364=(($362)|0)!=(($363)|0);
      if ($364) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $365
      var $st$0$0=(($testi64a)|0);
      var $366$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $366$1=HEAP32[(($st$0$1)>>2)];
      var $367$0=$366$1;
      var $367$1=(($366$1|0) < 0 ? -1 : 0);
      var $368$0=$367$0;
      var $368=$368$0;
      var $st$8$0=(($testi64a)|0);
      var $369$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testi64a+4)|0);
      var $369$1=HEAP32[(($st$8$1)>>2)];
      var $370$0=$369$0;
      var $370=$370$0;
      var $371=HEAP32[(($testi32a)>>2)];
      var $372=$resulti32;
      var $373=$expectedi32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str903822)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$368,HEAP32[((tempInt+4)>>2)]=$370,HEAP32[((tempInt+8)>>2)]=$371,HEAP32[((tempInt+12)>>2)]=$372,HEAP32[((tempInt+16)>>2)]=$373,tempInt));
      $error=1;
      __label__ = 51; break;
    case 51: // $374
      var $st$0$0=(($testu64a)|0);
      var $375$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $375$1=HEAP32[(($st$0$1)>>2)];
      var $376=$testu32a;
      var $377=__ZL10modu_64x32yj($375$0, $375$1, $376);
      var $377$0=$377[0];
      $resultu32=$377;
      var $st$8$0=(($testu64a)|0);
      var $378$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testu64a+4)|0);
      var $378$1=HEAP32[(($st$8$1)>>2)];
      var $379=$testu32a;
      var $380$0=$379;
      var $380$1=0;
      var $381$0 = ((($378$0)>>>0)+((($378$1)|0)*4294967296))%((($380$0)>>>0)+((($380$1)|0)*4294967296))>>>0; var $381$1 = Math.min(Math.floor((((($378$0)>>>0)+((($378$1)|0)*4294967296))%((($380$0)>>>0)+((($380$1)|0)*4294967296)))/4294967296), 4294967295);
      var $382$0=$381$0;
      var $382=$382$0;
      $expectedu32=$382;
      var $383=$resultu32;
      var $384=$expectedu32;
      var $385=(($383)|0)!=(($384)|0);
      if ($385) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $386
      var $st$0$0=(($testu64a)|0);
      var $387$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $387$1=HEAP32[(($st$0$1)>>2)];
      var $388$0=$387$1;
      var $388$1=0;
      var $389$0=$388$0;
      var $389=$389$0;
      var $st$8$0=(($testu64a)|0);
      var $390$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($testu64a+4)|0);
      var $390$1=HEAP32[(($st$8$1)>>2)];
      var $391$0=$390$0;
      var $391=$391$0;
      var $392=$testu32a;
      var $393=$resultu32;
      var $394=$expectedu32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str913823)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$389,HEAP32[((tempInt+4)>>2)]=$391,HEAP32[((tempInt+8)>>2)]=$392,HEAP32[((tempInt+12)>>2)]=$393,HEAP32[((tempInt+16)>>2)]=$394,tempInt));
      $error=1;
      __label__ = 53; break;
    case 53: // $395
      __label__ = 54; break;
    case 54: // $396
      var $397=HEAP32[(($testi32a)>>2)];
      var $398$0=$397;
      var $398$1=(($397|0) < 0 ? -1 : 0);
      var $$emscripten$temp$9$0=2147483647;
      var $$emscripten$temp$9$1=0;
      var $399$0 = ((($398$0)>>>0)+((($398$1)|0)*4294967296))*((($$emscripten$temp$9$0)>>>0)+((($$emscripten$temp$9$1)|0)*4294967296))>>>0; var $399$1 = Math.min(Math.floor((((($398$0)>>>0)+((($398$1)|0)*4294967296))*((($$emscripten$temp$9$0)>>>0)+((($$emscripten$temp$9$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$6$0=(($testi64a)|0);
      var $400$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($testi64a+4)|0);
      var $400$1=HEAP32[(($st$6$1)>>2)];
      var $401$0=$400$0;
      var $401=$401$0;
      var $402=$401 << 3;
      var $403$0=$402;
      var $403$1=(($402|0) < 0 ? -1 : 0);
      var $404=($399$1|0) < ($403$1|0) || (($399$1|0) == ($403$1|0) && ($399$0|0) <  ($403$0|0));
      if ($404) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $405
      var $st$0$0=(($testi64a)|0);
      var $406$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $406$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$10$0=2;
      var $$emscripten$temp$10$1=0;
      var $407$0 = (tempBigIntR=((($406$0)>>>0)+((($406$1)|0)*4294967296))/((($$emscripten$temp$10$0)>>>0)+((($$emscripten$temp$10$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $407$1 = Math.min(Math.floor(((tempBigIntR=((($406$0)>>>0)+((($406$1)|0)*4294967296))/((($$emscripten$temp$10$0)>>>0)+((($$emscripten$temp$10$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$7$0=(($testi64a)|0);
      HEAP32[(($st$7$0)>>2)]=$407$0;
      var $st$7$1=(($testi64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$407$1;
      __label__ = 54; break;
    case 56: // $408
      __label__ = 57; break;
    case 57: // $409
      var $410=$testu32a;
      var $411$0=$410;
      var $411$1=0;
      var $$emscripten$temp$11$0=-1;
      var $$emscripten$temp$11$1=0;
      var $412$0 = ((($411$0)>>>0)+((($411$1)|0)*4294967296))*((($$emscripten$temp$11$0)>>>0)+((($$emscripten$temp$11$1)|0)*4294967296))>>>0; var $412$1 = Math.min(Math.floor((((($411$0)>>>0)+((($411$1)|0)*4294967296))*((($$emscripten$temp$11$0)>>>0)+((($$emscripten$temp$11$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$6$0=(($testu64a)|0);
      var $413$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($testu64a+4)|0);
      var $413$1=HEAP32[(($st$6$1)>>2)];
      var $414$0=$413$0;
      var $414=$414$0;
      var $415=$414 << 3;
      var $416$0=$415;
      var $416$1=0;
      var $417=$412$1 < $416$1 || ($412$1 == $416$1 && $412$0 < $416$0);
      if ($417) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $418
      var $st$0$0=(($testu64a)|0);
      var $419$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $419$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$12$0=2;
      var $$emscripten$temp$12$1=0;
      var $420$0 = Math.floor(((($419$0)>>>0)+((($419$1)|0)*4294967296))/((($$emscripten$temp$12$0)>>>0)+((($$emscripten$temp$12$1)|0)*4294967296)))>>>0; var $420$1 = Math.min(Math.floor((Math.floor(((($419$0)>>>0)+((($419$1)|0)*4294967296))/((($$emscripten$temp$12$0)>>>0)+((($$emscripten$temp$12$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$7$0=(($testu64a)|0);
      HEAP32[(($st$7$0)>>2)]=$420$0;
      var $st$7$1=(($testu64a+4)|0);
      HEAP32[(($st$7$1)>>2)]=$420$1;
      __label__ = 57; break;
    case 59: // $421
      var $st$0$0=(($testi64a)|0);
      var $422$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $422$1=HEAP32[(($st$0$1)>>2)];
      var $423$0=$422$0;
      var $423=$423$0;
      var $424=HEAP32[(($testi32a)>>2)];
      var $425=__ZL15div_32x32_shiftiih($423, $424, 3);
      $resulti32=$425;
      var $st$9$0=(($testi64a)|0);
      var $426$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($testi64a+4)|0);
      var $426$1=HEAP32[(($st$9$1)>>2)];
      var $427$0=$426$0;
      var $427=$427$0;
      var $428$0=$427;
      var $428$1=(($427|0) < 0 ? -1 : 0);
      var $429$0=($428$0 << 3) | (0 >>> 29);
      var $429$1=($428$1 << 3) | ($428$0 >>> 29);
      var $430=HEAP32[(($testi32a)>>2)];
      var $431$0=$430;
      var $431$1=(($430|0) < 0 ? -1 : 0);
      var $432$0 = (tempBigIntR=((($429$0)>>>0)+((($429$1)|0)*4294967296))/((($431$0)>>>0)+((($431$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $432$1 = Math.min(Math.floor(((tempBigIntR=((($429$0)>>>0)+((($429$1)|0)*4294967296))/((($431$0)>>>0)+((($431$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $433$0=$432$0;
      var $433=$433$0;
      $expectedi32=$433;
      var $434=$resulti32;
      var $435=$expectedi32;
      var $436=(($434)|0)!=(($435)|0);
      if ($436) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $437
      var $st$0$0=(($testi64a)|0);
      var $438$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testi64a+4)|0);
      var $438$1=HEAP32[(($st$0$1)>>2)];
      var $439$0=$438$0;
      var $439=$439$0;
      var $440=HEAP32[(($testi32a)>>2)];
      var $441=$resulti32;
      var $442=$expectedi32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str923824)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$439,HEAP32[((tempInt+4)>>2)]=$440,HEAP32[((tempInt+8)>>2)]=$441,HEAP32[((tempInt+12)>>2)]=$442,tempInt));
      $error=1;
      __label__ = 61; break;
    case 61: // $443
      var $st$0$0=(($testu64a)|0);
      var $444$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $444$1=HEAP32[(($st$0$1)>>2)];
      var $445$0=$444$0;
      var $445=$445$0;
      var $446=$testu32a;
      var $447=__ZL16divu_32x32_shiftjjh($445, $446, 3);
      $resultu32=$447;
      var $st$9$0=(($testu64a)|0);
      var $448$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($testu64a+4)|0);
      var $448$1=HEAP32[(($st$9$1)>>2)];
      var $449$0=$448$0;
      var $449=$449$0;
      var $450$0=$449;
      var $450$1=0;
      var $451$0=($450$0 << 3) | (0 >>> 29);
      var $451$1=($450$1 << 3) | ($450$0 >>> 29);
      var $452=$testu32a;
      var $453$0=$452;
      var $453$1=0;
      var $454$0 = Math.floor(((($451$0)>>>0)+((($451$1)|0)*4294967296))/((($453$0)>>>0)+((($453$1)|0)*4294967296)))>>>0; var $454$1 = Math.min(Math.floor((Math.floor(((($451$0)>>>0)+((($451$1)|0)*4294967296))/((($453$0)>>>0)+((($453$1)|0)*4294967296))))/4294967296), 4294967295);
      var $455$0=$454$0;
      var $455=$455$0;
      $expectedu32=$455;
      var $456=$resultu32;
      var $457=$expectedu32;
      var $458=(($456)|0)!=(($457)|0);
      if ($458) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $459
      var $st$0$0=(($testu64a)|0);
      var $460$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($testu64a+4)|0);
      var $460$1=HEAP32[(($st$0$1)>>2)];
      var $461$0=$460$0;
      var $461=$461$0;
      var $462=$testu32a;
      var $463=$resultu32;
      var $464=$expectedu32;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str933825)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$461,HEAP32[((tempInt+4)>>2)]=$462,HEAP32[((tempInt+8)>>2)]=$463,HEAP32[((tempInt+12)>>2)]=$464,tempInt));
      $error=1;
      __label__ = 63; break;
    case 63: // $465
      var $466=__ZL12recip_approxf(100);
      var $467=$466;
      var $468=$467-0.01;
      var $469=_fabs($468);
      var $470=$469 > 0.0001;
      if ($470) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $471
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str943826)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 65; break;
    case 65: // $472
      var $473=HEAP32[(($testi32a)>>2)];
      var $474=$473 & 65535;
      var $475=$474 | 4194304;
      HEAP32[(($testi32a)>>2)]=$475;
      var $476=HEAP32[(($testi32a)>>2)];
      var $477=__ZL19count_leading_zerosj($476);
      var $478=(($477)&255);
      var $479=(($478)|0)!=9;
      if ($479) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $480
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str953827)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 67; break;
    case 67: // $481
      var $482=HEAP32[(($testi32a)>>2)];
      var $483=$482 | -65536;
      var $484=$483 & -4194305;
      HEAP32[(($testi32a)>>2)]=$484;
      var $485=HEAP32[(($testi32a)>>2)];
      var $486=__ZL18count_leading_onesj($485);
      var $487=(($486)&255);
      var $488=(($487)|0)!=9;
      if ($488) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $489
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str963828)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 69; break;
    case 69: // $490
      var $491=HEAP32[(($testi32a)>>2)];
      $testi32b=$491;
      var $492=$testi32b;
      var $493=__ZL18compare_exchange32PViii($testi32a, $492, 1000);
      var $494=$testi32b;
      var $495=(($493)|0)!=(($494)|0);
      if ($495) { __label__ = 71; break; } else { __label__ = 70; break; }
    case 70: // $496
      var $497=HEAP32[(($testi32a)>>2)];
      var $498=(($497)|0)!=1000;
      if ($498) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $499
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str973829)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 72; break;
    case 72: // $500
      var $501=$testi32b;
      var $502=__ZL17atomic_exchange32PVii($testi32a, $501);
      var $503=(($502)|0)!=1000;
      if ($503) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $504
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str983830)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 74; break;
    case 74: // $505
      var $506=__ZL12atomic_add32PVii($testi32a, 45);
      var $507=$testi32b;
      var $508=(($507+45)|0);
      var $509=(($506)|0)!=(($508)|0);
      if ($509) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $510
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str993831)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 76; break;
    case 76: // $511
      var $512=__ZL18atomic_increment32PVi($testi32a);
      var $513=$testi32b;
      var $514=(($513+46)|0);
      var $515=(($512)|0)!=(($514)|0);
      if ($515) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $516
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1003832)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 78; break;
    case 78: // $517
      var $518=__ZL18atomic_decrement32PVi($testi32a);
      var $519=$testi32b;
      var $520=(($519+45)|0);
      var $521=(($518)|0)!=(($520)|0);
      if ($521) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $522
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str1013833)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $error=1;
      __label__ = 80; break;
    case 80: // $523
      var $524=$error;
      var $525=(($524) & 1);
      STACKTOP = __stackBase__;
      return $525;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16validate_inlinesv["X"]=1;

function __ZL17get_profile_ticksv() {
  ;
  var __label__;

  var $1=_osd_ticks();
  var $1$0=$1[0];
  var $1$1=$1[1];
  ;
  return [$1$0,$1$1];
}


function __ZL28input_port_string_from_indexj($index) {
  ;
  var __label__;

  var $1;
  $1=$index;
  var $2=$1;
  var $3=$2;
  var $4=__Z28input_port_string_from_tokenPKc($3);
  ;
  return $4;
}


function __ZN8tagmap_tIjE3addEPKcjb($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z10tagmap_addP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN12region_arrayC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12region_arrayC2Ev($2);
  ;
  return;
}


function __ZL15validate_driverR17driver_enumeratorR8tagmap_tIPK11game_driverES6_($drivlist, $names, $descriptions) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $driver;
      var $config;
      var $compatible_with;
      var $error;
      var $is_clone;
      var $s;
      var $match;
      var $match1;
      var $clone_of;
      var $other_drv;
      var $sound=__stackBase__;
      $1=$drivlist;
      $2=$names;
      $3=$descriptions;
      var $4=$1;
      var $5=__ZNK17driver_enumerator6driverEv($4);
      $driver=$5;
      var $6=$1;
      var $7=__ZNK17driver_enumerator6configEv($6);
      $config=$7;
      $error=0;
      var $8=$2;
      var $9=$driver;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$driver;
      var $13=__ZN8tagmap_tIPK11game_driverE3addEPKcS2_b($8, $11, $12, 0);
      var $14=(($13)|0)==2;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$2;
      var $17=$driver;
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK8tagmap_tIPK11game_driverE4findEPKc($16, $19);
      $match=$20;
      var $21=$driver;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$driver;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$match;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$match;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str663798)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$23,HEAP32[((tempInt+4)>>2)]=$26,HEAP32[((tempInt+8)>>2)]=$29,HEAP32[((tempInt+12)>>2)]=$32,tempInt));
      $error=1;
      __label__ = 2; break;
    case 2: // $33
      var $34=$3;
      var $35=$driver;
      var $36=(($35+12)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$driver;
      var $39=__ZN8tagmap_tIPK11game_driverE3addEPKcS2_b($34, $37, $38, 0);
      var $40=(($39)|0)==2;
      if ($40) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $41
      var $42=$3;
      var $43=$driver;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=__ZNK8tagmap_tIPK11game_driverE4findEPKc($42, $45);
      $match1=$46;
      var $47=$driver;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$driver;
      var $51=(($50+12)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$match1;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$match1;
      var $57=(($56+12)|0);
      var $58=HEAP32[(($57)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str673799)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,HEAP32[((tempInt+4)>>2)]=$52,HEAP32[((tempInt+8)>>2)]=$55,HEAP32[((tempInt+12)>>2)]=$58,tempInt));
      $error=1;
      __label__ = 4; break;
    case 4: // $59
      var $60=$driver;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=_strcmp($62, ((STRING_TABLE.__str683800)|0));
      var $64=(($63)|0)!=0;
      var $65=(($64)&1);
      $is_clone=$65;
      var $66=$1;
      var $67=$driver;
      var $68=__ZN11driver_list5cloneERK11game_driver($67);
      $clone_of=$68;
      var $69=$clone_of;
      var $70=(($69)|0)!=-1;
      if ($70) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $71
      var $72=$1;
      var $73=$clone_of;
      var $74=__ZN11driver_list6driverEi($73);
      var $75=(($74+44)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$76 & 4096;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $79
      $is_clone=0;
      __label__ = 7; break;
    case 7: // $80
      var $81=__ZN11driver_list5totalEv();
      var $82=(($81)|0) > 100;
      if ($82) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $83
      var $84=$clone_of;
      var $85=(($84)|0)==-1;
      if ($85) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $86
      var $87=$is_clone;
      var $88=(($87) & 1);
      if ($88) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $89
      var $90=$driver;
      var $91=(($90)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$driver;
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str693801)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$92,HEAP32[((tempInt+4)>>2)]=$95,tempInt));
      $error=1;
      __label__ = 11; break;
    case 11: // $96
      var $97=$clone_of;
      var $98=(($97)|0)!=-1;
      if ($98) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $99
      var $100=$1;
      var $101=$clone_of;
      var $102=__ZN11driver_list6driverEi($101);
      var $103=$driver;
      var $104=(($102)|0)==(($103)|0);
      if ($104) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $105
      var $106=$driver;
      var $107=(($106)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$driver;
      var $110=(($109+8)|0);
      var $111=HEAP32[(($110)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str703802)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$108,HEAP32[((tempInt+4)>>2)]=$111,tempInt));
      $error=1;
      __label__ = 14; break;
    case 14: // $112
      var $113=$clone_of;
      var $114=(($113)|0)!=-1;
      if ($114) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $115
      var $116=$1;
      var $117=$clone_of;
      var $118=__ZN11driver_list14non_bios_cloneEi($117);
      $clone_of=$118;
      var $119=(($118)|0)!=-1;
      if ($119) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $120
      var $121=$driver;
      var $122=(($121)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$driver;
      var $125=(($124+8)|0);
      var $126=HEAP32[(($125)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str713803)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$123,HEAP32[((tempInt+4)>>2)]=$126,tempInt));
      $error=1;
      __label__ = 17; break;
    case 17: // $127
      var $128=$is_clone;
      var $129=(($128) & 1);
      if ($129) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $130
      var $131=$driver;
      var $132=(($131+8)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=_strlen($133);
      var $135=(($134)>>>0) > 16;
      if ($135) { __label__ = 21; break; } else { __label__ = 19; break; }
    case 19: // $136
      var $137=$is_clone;
      var $138=(($137) & 1);
      if ($138) { __label__ = 22; break; } else { __label__ = 20; break; }
    case 20: // $139
      var $140=$driver;
      var $141=(($140+8)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=_strlen($142);
      var $144=(($143)>>>0) > 8;
      if ($144) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $145
      var $146=$driver;
      var $147=(($146)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=$driver;
      var $150=(($149+8)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$is_clone;
      var $153=(($152) & 1);
      var $154=$153 ? (((STRING_TABLE.__str733805)|0)) : (((STRING_TABLE.__str743806)|0));
      var $155=$is_clone;
      var $156=(($155) & 1);
      var $157=$156 ? 16 : 8;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str723804)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$148,HEAP32[((tempInt+4)>>2)]=$151,HEAP32[((tempInt+8)>>2)]=$154,HEAP32[((tempInt+12)>>2)]=$157,tempInt));
      $error=1;
      __label__ = 22; break;
    case 22: // $158
      var $159=$driver;
      var $160=(($159+16)|0);
      var $161=HEAP32[(($160)>>2)];
      $s=$161;
      __label__ = 23; break;
    case 23: // $162
      var $163=$s;
      var $164=HEAP8[($163)];
      var $165=(($164 << 24) >> 24)!=0;
      if ($165) { __label__ = 24; break; } else { __label__ = 30; break; }
    case 24: // $166
      var $167=$s;
      var $168=HEAPU8[($167)];
      var $169=(($168)&255);
      var $170=_isdigit($169);
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 28; break; } else { __label__ = 25; break; }
    case 25: // $172
      var $173=$s;
      var $174=HEAP8[($173)];
      var $175=(($174 << 24) >> 24);
      var $176=(($175)|0)!=63;
      if ($176) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $177
      var $178=$s;
      var $179=HEAP8[($178)];
      var $180=(($179 << 24) >> 24);
      var $181=(($180)|0)!=43;
      if ($181) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $182
      var $183=$driver;
      var $184=(($183)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$driver;
      var $187=(($186+8)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$driver;
      var $190=(($189+16)|0);
      var $191=HEAP32[(($190)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str753807)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,HEAP32[((tempInt+4)>>2)]=$188,HEAP32[((tempInt+8)>>2)]=$191,tempInt));
      $error=1;
      __label__ = 30; break;
    case 28: // $192
      __label__ = 29; break;
    case 29: // $193
      var $194=$s;
      var $195=(($194+1)|0);
      $s=$195;
      __label__ = 23; break;
    case 30: // $196
      var $197=$driver;
      var $198=(($197+40)|0);
      var $199=HEAP32[(($198)>>2)];
      $compatible_with=$199;
      var $200=$compatible_with;
      var $201=(($200)|0)!=0;
      if ($201) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $202
      var $203=$compatible_with;
      var $204=_strcmp($203, ((STRING_TABLE.__str683800)|0));
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $206
      $compatible_with=0;
      __label__ = 33; break;
    case 33: // $207
      var $208=$compatible_with;
      var $209=(($208)|0)!=0;
      if ($209) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $210
      var $211=$1;
      var $212=$driver;
      var $213=(($212+40)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=__ZN11driver_list4findEPKc($214);
      var $216=(($215)|0)==-1;
      if ($216) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $217
      var $218=$driver;
      var $219=(($218+8)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$driver;
      var $222=(($221+40)|0);
      var $223=HEAP32[(($222)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str763808)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$220,HEAP32[((tempInt+4)>>2)]=$223,tempInt));
      $error=1;
      __label__ = 36; break;
    case 36: // $224
      var $225=$1;
      var $226=$driver;
      var $227=__ZN11driver_list5cloneERK11game_driver($226);
      var $228=(($227)|0)!=-1;
      if ($228) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $229
      var $230=$compatible_with;
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $232
      var $233=$driver;
      var $234=(($233+8)|0);
      var $235=HEAP32[(($234)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str773809)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$235,tempInt));
      $error=1;
      __label__ = 39; break;
    case 39: // $236
      var $237=$1;
      var $238=$driver;
      var $239=__ZN11driver_list15compatible_withERK11game_driver($238);
      $other_drv=$239;
      __label__ = 40; break;
    case 40: // $240
      var $241=$other_drv;
      var $242=(($241)|0)!=-1;
      if ($242) { __label__ = 41; break; } else { __label__ = 45; break; }
    case 41: // $243
      var $244=$driver;
      var $245=$1;
      var $246=$other_drv;
      var $247=__ZN11driver_list6driverEi($246);
      var $248=(($244)|0)==(($247)|0);
      if ($248) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $249
      var $250=$driver;
      var $251=(($250+8)|0);
      var $252=HEAP32[(($251)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str783810)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$252,tempInt));
      $error=1;
      __label__ = 45; break;
    case 43: // $253
      __label__ = 44; break;
    case 44: // $254
      var $255=$1;
      var $256=$other_drv;
      var $257=__ZN11driver_list15compatible_withEi($256);
      $other_drv=$257;
      __label__ = 40; break;
    case 45: // $258
      var $259=$driver;
      var $260=(($259+44)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$261 & 4096;
      var $263=(($262)|0)==0;
      if ($263) { __label__ = 46; break; } else { __label__ = 50; break; }
    case 46: // $264
      var $265=$config;
      var $266=__ZNK14machine_config10devicelistEv($265);
      var $267=__ZNK11device_list5firstIK22device_sound_interfaceEEbRPT_($266, $sound);
      if ($267) { __label__ = 50; break; } else { __label__ = 47; break; }
    case 47: // $268
      var $269=$driver;
      var $270=(($269+44)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=$271 & 512;
      var $273=(($272)|0)==0;
      if ($273) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $274
      var $275=$driver;
      var $276=(($275+44)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$277 & 65536;
      var $279=(($278)|0)==0;
      if ($279) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $280
      var $281=$driver;
      var $282=(($281)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=$driver;
      var $285=(($284+8)|0);
      var $286=HEAP32[(($285)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str793811)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$283,HEAP32[((tempInt+4)>>2)]=$286,tempInt));
      $error=1;
      __label__ = 50; break;
    case 50: // $287
      var $288=$error;
      var $289=(($288) & 1);
      STACKTOP = __stackBase__;
      return $289;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15validate_driverR17driver_enumeratorR8tagmap_tIPK11game_driverES6_["X"]=1;

function __ZL13validate_romsR17driver_enumeratorP12region_arrayR8tagmap_tIPK11game_driverE($drivlist, $rgninfo, $roms) {
  var __stackBase__  = STACKTOP; STACKTOP += 148; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $driver;
      var $config;
      var $bios_flags;
      var $last_bios;
      var $last_rgnname;
      var $last_name;
      var $currgn;
      var $items_since_region;
      var $error;
      var $source;
      var $romp;
      var $regiontag;
      var $fulltag=__stackBase__;
      var $4;
      var $5;
      var $rgnnum;
      var $name;
      var $s;
      var $hashes=__stackBase__+64;
      $1=$drivlist;
      $2=$rgninfo;
      $3=$roms;
      var $6=$1;
      var $7=__ZNK17driver_enumerator6driverEv($6);
      $driver=$7;
      var $8=$1;
      var $9=__ZNK17driver_enumerator6configEv($8);
      $config=$9;
      $bios_flags=0;
      $last_bios=0;
      $last_rgnname=((STRING_TABLE.__str553787)|0);
      $last_name=((STRING_TABLE.__str553787)|0);
      $currgn=0;
      $items_since_region=1;
      $error=0;
      var $10=$config;
      var $11=__Z16rom_first_sourceRK14machine_config($10);
      $source=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$source;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 71; break; }
    case 2: // $15
      var $16=$source;
      var $17=__Z16rom_first_regionRK8device_t($16);
      $romp=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$romp;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 & 15;
      var $23=(($22)|0)==2;
      var $24=$23 ^ 1;
      if ($24) { __label__ = 4; break; } else { __label__ = 67; break; }
    case 4: // $25
      var $26=$romp;
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & 15;
      var $30=(($29)|0)==1;
      if ($30) { __label__ = 5; break; } else { __label__ = 35; break; }
    case 5: // $31
      var $32=$romp;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      $regiontag=$34;
      var $35=$items_since_region;
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$driver;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$driver;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$last_rgnname;
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str563788)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,HEAP32[((tempInt+4)>>2)]=$43,HEAP32[((tempInt+8)>>2)]=$44,tempInt));
      __label__ = 7; break;
    case 7: // $45
      var $46=$romp;
      var $47=(($46+16)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48 & 8192;
      var $50=(($49)|0)==8192;
      if ($50) { var $58 = 1;__label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $51
      var $52=$romp;
      var $53=(($52+16)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$54 & 16384;
      var $56=(($55)|0)==16384;
      var $58 = $56;__label__ = 9; break;
    case 9: // $57
      var $58;
      var $59=$58 ? 1 : 0;
      $items_since_region=$59;
      $currgn=0;
      var $60=$regiontag;
      $last_rgnname=$60;
      var $61=$regiontag;
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $63
      var $64=$driver;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$driver;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str573789)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,HEAP32[((tempInt+4)>>2)]=$69,tempInt));
      $error=1;
      __label__ = 32; break;
    case 11: // $70
      var $71=$romp;
      var $72=(($71+16)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73 & 32768;
      var $75=(($74)|0)==32768;
      if ($75) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $76
      var $77=$regiontag;
      var $78=_strlen($77);
      var $79=(($78)>>>0) > 8;
      if ($79) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $80
      var $81=$driver;
      var $82=(($81)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$driver;
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$regiontag;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str583790)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$83,HEAP32[((tempInt+4)>>2)]=$86,HEAP32[((tempInt+8)>>2)]=$87,tempInt));
      $error=1;
      __label__ = 31; break;
    case 14: // $88
      __ZN7astringC1Ev($fulltag);
      var $89=$driver;
      var $90=$source;
      var $91=$romp;
      var $92=(function() { try { __THREW__ = false; return __Z15rom_region_nameR7astringPK11game_driverPK8device_tPK9rom_entry($fulltag, $89, $90, $91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; };
    case 15: // $93
      $rgnnum=0;
      __label__ = 16; break;
    case 16: // $94
      var $95=$rgnnum;
      var $96=(($95)>>>0) < 256;
      if ($96) { __label__ = 17; break; } else { __label__ = 29; break; }
    case 17: // $97
      var $98=$rgnnum;
      var $99=$2;
      var $100=(($99)|0);
      var $101=(($100+$98*68)|0);
      var $102=(($101)|0);
      var $103=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 21; break; };
    case 18: // $104
      if ($103) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $105
      var $106=$rgnnum;
      var $107=$2;
      var $108=(($107)|0);
      var $109=(($108+$106*68)|0);
      $currgn=$109;
      var $110=$currgn;
      var $111=(($110)|0);
      var $112=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($111, $fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; };
    case 20: // $113
      var $114=$romp;
      var $115=(($114+12)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$currgn;
      var $118=(($117+64)|0);
      HEAP32[(($118)>>2)]=$116;
      __label__ = 29; break;
    case 21: // $119
      var $120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $121=$120.f0;
      $4=$121;
      var $122=$120.f1;
      $5=$122;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 73; break; }
    case 22: // $123
      var $124=$rgnnum;
      var $125=$2;
      var $126=(($125)|0);
      var $127=(($126+$124*68)|0);
      var $128=(($127)|0);
      var $129=(function() { try { __THREW__ = false; return __ZNK7astringeqERKS_($fulltag, $128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 21; break; };
    case 23: // $130
      if ($129) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 24: // $131
      var $132=$driver;
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$driver;
      var $136=(($135+8)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($fulltag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 21; break; };
    case 25: // $139
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str593791)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,HEAP32[((tempInt+4)>>2)]=$137,HEAP32[((tempInt+8)>>2)]=$138,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 21; break; }
    case 26: // $140
      $error=1;
      __label__ = 29; break;
    case 27: // $141
      __label__ = 28; break;
    case 28: // $142
      var $143=$rgnnum;
      var $144=(($143+1)|0);
      $rgnnum=$144;
      __label__ = 16; break;
    case 29: // $145
      FUNCTION_TABLE[__ZN7astringD1Ev]($fulltag);
      __label__ = 31; break;
    case 30: // $146
      __label__ = 72; break;
    case 31: // $147
      __label__ = 32; break;
    case 32: // $148
      var $149=$driver;
      var $150=$regiontag;
      var $151=__Z12validate_tagRK11game_driverPKcS3_($149, ((STRING_TABLE.__str603792)|0), $150);
      if ($151) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $152
      $error=1;
      __label__ = 34; break;
    case 34: // $153
      __label__ = 59; break;
    case 35: // $154
      var $155=$romp;
      var $156=(($155+16)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$157 & 15;
      var $159=(($158)|0)==9;
      if ($159) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $160
      var $161=$romp;
      var $162=(($161+16)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$163 & -16777216;
      var $165=$164 >>> 24;
      $bios_flags=$165;
      var $166=$last_bios;
      var $167=(($166+1)|0);
      var $168=$bios_flags;
      var $169=(($167)|0)!=(($168)|0);
      if ($169) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $170
      var $171=$romp;
      var $172=(($171)|0);
      var $173=HEAP32[(($172)>>2)];
      $name=$173;
      var $174=$driver;
      var $175=(($174)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$driver;
      var $178=(($177+8)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$name;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str613793)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$176,HEAP32[((tempInt+4)>>2)]=$179,HEAP32[((tempInt+8)>>2)]=$180,tempInt));
      $error=1;
      __label__ = 38; break;
    case 38: // $181
      var $182=$bios_flags;
      $last_bios=$182;
      __label__ = 58; break;
    case 39: // $183
      var $184=$romp;
      var $185=(($184+16)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$186 & 15;
      var $188=(($187)|0)==0;
      if ($188) { __label__ = 40; break; } else { __label__ = 53; break; }
    case 40: // $189
      var $190=$items_since_region;
      var $191=(($190+1)|0);
      $items_since_region=$191;
      var $192=$romp;
      var $193=(($192)|0);
      var $194=HEAP32[(($193)>>2)];
      $last_name=$194;
      var $195=$last_name;
      $s=$195;
      __label__ = 41; break;
    case 41: // $196
      var $197=$s;
      var $198=HEAP8[($197)];
      var $199=(($198 << 24) >> 24)!=0;
      if ($199) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $200
      var $201=$s;
      var $202=HEAPU8[($201)];
      var $203=(($202)&255);
      var $204=_tolower($203);
      var $205=$s;
      var $206=HEAP8[($205)];
      var $207=(($206 << 24) >> 24);
      var $208=(($204)|0)!=(($207)|0);
      if ($208) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $209
      var $210=$driver;
      var $211=(($210)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=$driver;
      var $214=(($213+8)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=$last_name;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str623794)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$212,HEAP32[((tempInt+4)>>2)]=$215,HEAP32[((tempInt+8)>>2)]=$216,tempInt));
      $error=1;
      __label__ = 46; break;
    case 44: // $217
      __label__ = 45; break;
    case 45: // $218
      var $219=$s;
      var $220=(($219+1)|0);
      $s=$220;
      __label__ = 41; break;
    case 46: // $221
      FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($hashes);
      var $222=$romp;
      var $223=(($222+4)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(function() { try { __THREW__ = false; return __ZN15hash_collection20from_internal_stringEPKc($hashes, $224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 50; break; };
    case 47: // $226
      if ($225) { __label__ = 51; break; } else { __label__ = 48; break; }
    case 48: // $227
      var $228=$driver;
      var $229=(($228+8)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$last_name;
      var $232=$romp;
      var $233=(($232+4)|0);
      var $234=HEAP32[(($233)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str633795)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$230,HEAP32[((tempInt+4)>>2)]=$231,HEAP32[((tempInt+8)>>2)]=$234,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $235
      $error=1;
      __label__ = 51; break;
    case 50: // $236
      var $237=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $238=$237.f0;
      $4=$238;
      var $239=$237.f1;
      $5=$239;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 73; break; }
    case 51: // $240
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes);
      __label__ = 57; break;
    case 52: // $241
      __label__ = 72; break;
    case 53: // $242
      var $243=$romp;
      var $244=(($243+16)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=$245 & 15;
      var $247=(($246)|0)==6;
      if ($247) { __label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $248
      var $249=$romp;
      var $250=(($249+16)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$251 & 15;
      var $253=(($252)|0)==5;
      if ($253) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $254
      var $255=$items_since_region;
      var $256=(($255+1)|0);
      $items_since_region=$256;
      __label__ = 56; break;
    case 56: // $257
      __label__ = 57; break;
    case 57: // $258
      __label__ = 58; break;
    case 58: // $259
      __label__ = 59; break;
    case 59: // $260
      var $261=$romp;
      var $262=(($261+16)|0);
      var $263=HEAP32[(($262)>>2)];
      var $264=$263 & 15;
      var $265=(($264)|0)==1;
      if ($265) { __label__ = 65; break; } else { __label__ = 60; break; }
    case 60: // $266
      var $267=$romp;
      var $268=(($267+16)|0);
      var $269=HEAP32[(($268)>>2)];
      var $270=$269 & 15;
      var $271=(($270)|0)==2;
      if ($271) { __label__ = 65; break; } else { __label__ = 61; break; }
    case 61: // $272
      var $273=$currgn;
      var $274=(($273)|0)!=0;
      if ($274) { __label__ = 62; break; } else { __label__ = 65; break; }
    case 62: // $275
      var $276=$items_since_region;
      var $277=(($276+1)|0);
      $items_since_region=$277;
      var $278=$romp;
      var $279=(($278+8)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=$romp;
      var $282=(($281+12)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=(($280+$283)|0);
      var $285=$currgn;
      var $286=(($285+64)|0);
      var $287=HEAPU32[(($286)>>2)];
      var $288=(($284)>>>0) > (($287)>>>0);
      if ($288) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $289
      var $290=$driver;
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=$driver;
      var $294=(($293+8)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$last_name;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str643796)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$292,HEAP32[((tempInt+4)>>2)]=$295,HEAP32[((tempInt+8)>>2)]=$296,tempInt));
      $error=1;
      __label__ = 64; break;
    case 64: // $297
      __label__ = 65; break;
    case 65: // $298
      __label__ = 66; break;
    case 66: // $299
      var $300=$romp;
      var $301=(($300+20)|0);
      $romp=$301;
      __label__ = 3; break;
    case 67: // $302
      var $303=$items_since_region;
      var $304=(($303)|0)==0;
      if ($304) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $305
      var $306=$driver;
      var $307=(($306)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=$driver;
      var $310=(($309+8)|0);
      var $311=HEAP32[(($310)>>2)];
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str653797)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$308,HEAP32[((tempInt+4)>>2)]=$311,tempInt));
      __label__ = 69; break;
    case 69: // $312
      __label__ = 70; break;
    case 70: // $313
      var $314=$source;
      var $315=__Z15rom_next_sourceRK8device_t($314);
      $source=$315;
      __label__ = 1; break;
    case 71: // $316
      var $317=$error;
      var $318=(($317) & 1);
      STACKTOP = __stackBase__;
      return $318;
    case 72: // $319
      var $320=$4;
      var $321=$4;
      var $322=$5;
      var $323=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $321, tempValue);
      var $324=($323.f1 = $322, $323);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 73: // $325
      var $326=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13validate_romsR17driver_enumeratorP12region_arrayR8tagmap_tIPK11game_driverE["X"]=1;

function __ZL16validate_displayR17driver_enumerator($drivlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $driver;
      var $config;
      var $palette_modes;
      var $error;
      var $scrconfig;
      $1=$drivlist;
      var $2=$1;
      var $3=__ZNK17driver_enumerator6driverEv($2);
      $driver=$3;
      var $4=$1;
      var $5=__ZNK17driver_enumerator6configEv($4);
      $config=$5;
      $palette_modes=0;
      $error=0;
      var $6=$config;
      var $7=__ZNK14machine_config12first_screenEv($6);
      $scrconfig=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$scrconfig;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$scrconfig;
      var $13=__ZNK13screen_device6formatEv($12);
      var $14=(($13)|0)==2;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $palette_modes=1;
      __label__ = 4; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$scrconfig;
      var $19=__ZNK13screen_device11next_screenEv($18);
      $scrconfig=$19;
      __label__ = 1; break;
    case 6: // $20
      var $21=$palette_modes;
      var $22=(($21) & 1);
      if ($22) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      var $24=$config;
      var $25=(($24+48)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $28
      var $29=$driver;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$driver;
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str263758)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$34,tempInt));
      $error=1;
      __label__ = 9; break;
    case 9: // $35
      var $36=$error;
      var $37=(($36) & 1);
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16validate_displayR17driver_enumerator["X"]=1;

function __ZL15validate_inputsR17driver_enumeratorR8tagmap_tIjER11tagged_listI17input_port_configE($drivlist, $defstr_map, $portlist) {
  var __stackBase__  = STACKTOP; STACKTOP += 196; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $scanport;
      var $port;
      var $field;
      var $driver;
      var $config;
      var $empty_string_found;
      var $error=__stackBase__;
      var $errorbuf=__stackBase__+4;
      var $5;
      var $cfg;
      var $6;
      var $7;
      var $setting;
      var $porttag=__stackBase__+68;
      var $porttag1=__stackBase__+132;
      $2=$drivlist;
      $3=$defstr_map;
      $4=$portlist;
      var $8=$2;
      var $9=__ZNK17driver_enumerator6driverEv($8);
      $driver=$9;
      var $10=$2;
      var $11=__ZNK17driver_enumerator6configEv($10);
      $config=$11;
      $empty_string_found=0;
      HEAP8[($error)]=0;
      __ZN7astringC1Ev($errorbuf);
      var $12=$driver;
      var $13=(($12+28)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=0;
      $5=1;
      __label__ = 136; break;
    case 2: // $17
      var $18=$config;
      var $19=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 12; break; };
    case 3: // $20
      var $21=$19;
      var $22=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; };
    case 4: // $23
      $cfg=$22;
      __label__ = 5; break;
    case 5: // $24
      var $25=$cfg;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 16; break; }
    case 6: // $27
      var $28=$cfg;
      var $29=$4;
      (function() { try { __THREW__ = false; return __Z20input_port_list_initR8device_tR11tagged_listI17input_port_configER7astring($28, $29, $errorbuf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $30
      var $31=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($errorbuf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $32
      if ($31) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $33
      var $34=$driver;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$driver;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($errorbuf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $41
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str273759)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,HEAP32[((tempInt+4)>>2)]=$39,HEAP32[((tempInt+8)>>2)]=$40,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $42
      HEAP8[($error)]=1;
      __label__ = 13; break;
    case 12: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $6=$45;
      var $46=$44.f1;
      $7=$46;
      __label__ = 137; break;
    case 13: // $47
      __label__ = 14; break;
    case 14: // $48
      var $49=$cfg;
      var $50=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; };
    case 15: // $51
      $cfg=$50;
      __label__ = 5; break;
    case 16: // $52
      var $53=$4;
      var $54=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 12; break; };
    case 17: // $55
      $port=$54;
      __label__ = 18; break;
    case 18: // $56
      var $57=$port;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 19; break; } else { __label__ = 35; break; }
    case 19: // $59
      var $60=$port;
      var $61=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 12; break; };
    case 20: // $62
      $scanport=$61;
      __label__ = 21; break;
    case 21: // $63
      var $64=$scanport;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 22; break; } else { __label__ = 32; break; }
    case 22: // $66
      var $67=$port;
      var $68=(function() { try { __THREW__ = false; return __ZNK17input_port_config3tagEv($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 12; break; };
    case 23: // $69
      var $70=$scanport;
      var $71=(function() { try { __THREW__ = false; return __ZNK17input_port_config3tagEv($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 12; break; };
    case 24: // $72
      var $73=(function() { try { __THREW__ = false; return _strcmp($68, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 12; break; };
    case 25: // $74
      var $75=(($73)|0)==0;
      if ($75) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $76
      var $77=$driver;
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$driver;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$port;
      var $84=(function() { try { __THREW__ = false; return __ZNK17input_port_config3tagEv($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 12; break; };
    case 27: // $85
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str283760)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$79,HEAP32[((tempInt+4)>>2)]=$82,HEAP32[((tempInt+8)>>2)]=$84,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 12; break; }
    case 28: // $86
      HEAP8[($error)]=1;
      __label__ = 29; break;
    case 29: // $87
      __label__ = 30; break;
    case 30: // $88
      var $89=$scanport;
      var $90=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 12; break; };
    case 31: // $91
      $scanport=$90;
      __label__ = 21; break;
    case 32: // $92
      __label__ = 33; break;
    case 33: // $93
      var $94=$port;
      var $95=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 12; break; };
    case 34: // $96
      $port=$95;
      __label__ = 18; break;
    case 35: // $97
      var $98=$4;
      var $99=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 12; break; };
    case 36: // $100
      $port=$99;
      __label__ = 37; break;
    case 37: // $101
      var $102=$port;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 38; break; } else { __label__ = 132; break; }
    case 38: // $104
      var $105=$port;
      var $106=(function() { try { __THREW__ = false; return __ZN17input_port_config9fieldlistEv($105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 12; break; };
    case 39: // $107
      var $108=(function() { try { __THREW__ = false; return __ZNK11simple_listI18input_field_configE5firstEv($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 12; break; };
    case 40: // $109
      $field=$108;
      __label__ = 41; break;
    case 41: // $110
      var $111=$field;
      var $112=(($111)|0)!=0;
      if ($112) { __label__ = 42; break; } else { __label__ = 129; break; }
    case 42: // $113
      var $114=$field;
      var $115=(($114+24)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(function() { try { __THREW__ = false; return __Z20input_type_is_analogi($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 12; break; };
    case 43: // $118
      var $119=(($117)|0)!=0;
      if ($119) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $120
      var $121=$field;
      var $122=$driver;
      (function() { try { __THREW__ = false; return __ZL27validate_analog_input_fieldP18input_field_configRK11game_driverPb($121, $122, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 12; break; }
    case 45: // $123
      __label__ = 46; break;
    case 46: // $124
      var $125=$field;
      var $126=(($125+24)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0)==5;
      if ($128) { __label__ = 47; break; } else { __label__ = 52; break; }
    case 47: // $129
      var $130=$field;
      var $131=(($130+40)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132)|0)==0;
      if ($133) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $134
      var $135=$driver;
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$driver;
      var $139=(($138+8)|0);
      var $140=HEAP32[(($139)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str293761)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$137,HEAP32[((tempInt+4)>>2)]=$140,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 12; break; }
    case 49: // $141
      HEAP8[($error)]=1;
      __label__ = 50; break;
    case 50: // $142
      var $143=$field;
      var $144=$driver;
      var $145=$3;
      (function() { try { __THREW__ = false; return __ZL21validate_dip_settingsP18input_field_configRK11game_driverR8tagmap_tIjEPb($143, $144, $145, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 12; break; }
    case 51: // $146
      __label__ = 52; break;
    case 52: // $147
      var $148=$field;
      var $149=(($148+24)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150)|0)==0;
      if ($151) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $152
      var $153=$driver;
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$driver;
      var $157=(($156+8)|0);
      var $158=HEAP32[(($157)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str303762)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$155,HEAP32[((tempInt+4)>>2)]=$158,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 12; break; }
    case 54: // $159
      HEAP8[($error)]=1;
      __label__ = 55; break;
    case 55: // $160
      var $161=$field;
      var $162=(($161+40)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 56; break; } else { __label__ = 71; break; }
    case 56: // $165
      var $166=$field;
      var $167=(($166+40)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168)|0);
      var $170=HEAP8[($169)];
      var $171=(($170 << 24) >> 24);
      var $172=(($171)|0)==0;
      if ($172) { __label__ = 57; break; } else { __label__ = 60; break; }
    case 57: // $173
      var $174=$empty_string_found;
      var $175=(($174)|0)!=0;
      if ($175) { __label__ = 60; break; } else { __label__ = 58; break; }
    case 58: // $176
      var $177=$driver;
      var $178=(($177)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$driver;
      var $181=(($180+8)|0);
      var $182=HEAP32[(($181)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str313763)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$179,HEAP32[((tempInt+4)>>2)]=$182,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 12; break; }
    case 59: // $183
      HEAP8[($error)]=1;
      $empty_string_found=1;
      __label__ = 60; break;
    case 60: // $184
      var $185=$field;
      var $186=(($185+40)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187)|0);
      var $189=HEAP8[($188)];
      var $190=(($189 << 24) >> 24);
      var $191=(($190)|0)!=0;
      if ($191) { __label__ = 61; break; } else { __label__ = 65; break; }
    case 61: // $192
      var $193=$field;
      var $194=(($193+40)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(function() { try { __THREW__ = false; return _strlen($195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 12; break; };
    case 62: // $197
      var $198=(($196-1)|0);
      var $199=$field;
      var $200=(($199+40)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=(($201+$198)|0);
      var $203=HEAP8[($202)];
      var $204=(($203 << 24) >> 24);
      var $205=(($204)|0)==32;
      if ($205) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 63: // $206
      var $207=$driver;
      var $208=(($207)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$driver;
      var $211=(($210+8)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=$field;
      var $214=(($213+40)|0);
      var $215=HEAP32[(($214)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str323764)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$209,HEAP32[((tempInt+4)>>2)]=$212,HEAP32[((tempInt+8)>>2)]=$215,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 12; break; }
    case 64: // $216
      HEAP8[($error)]=1;
      __label__ = 65; break;
    case 65: // $217
      var $218=$field;
      var $219=(($218+40)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(function() { try { __THREW__ = false; return __Z20utf8_is_valid_stringPKc($220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 12; break; };
    case 66: // $222
      var $223=(($221)|0)!=0;
      if ($223) { __label__ = 69; break; } else { __label__ = 67; break; }
    case 67: // $224
      var $225=$driver;
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$driver;
      var $229=(($228+8)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$field;
      var $232=(($231+40)|0);
      var $233=HEAP32[(($232)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str333765)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$227,HEAP32[((tempInt+4)>>2)]=$230,HEAP32[((tempInt+8)>>2)]=$233,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 12; break; }
    case 68: // $234
      HEAP8[($error)]=1;
      __label__ = 69; break;
    case 69: // $235
      var $236=$3;
      var $237=$field;
      var $238=(($237+40)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$driver;
      var $241=(function() { try { __THREW__ = false; return __ZL16get_defstr_indexR8tagmap_tIjEPKcRK11game_driverPb($236, $239, $240, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 12; break; };
    case 70: // $242
      __label__ = 71; break;
    case 71: // $243
      var $244=$field;
      var $245=(($244+8)|0);
      var $246=(($245)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=(($247)|0)!=0;
      if ($248) { __label__ = 72; break; } else { __label__ = 95; break; }
    case 72: // $249
      var $250=$4;
      var $251=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($250) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 12; break; };
    case 73: // $252
      $scanport=$251;
      __label__ = 74; break;
    case 74: // $253
      var $254=$scanport;
      var $255=(($254)|0)!=0;
      if ($255) { __label__ = 75; break; } else { __label__ = 91; break; }
    case 75: // $256
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($porttag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 12; break; }
    case 76: // $257
      var $258=$port;
      var $259=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 83; break; };
    case 77: // $260
      var $261=$field;
      var $262=(($261+8)|0);
      var $263=(($262)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($259, $porttag, $264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 83; break; };
    case 78: // $266
      var $267=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($porttag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 83; break; };
    case 79: // $268
      var $269=$scanport;
      var $270=(function() { try { __THREW__ = false; return __ZNK17input_port_config3tagEv($269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 83; break; };
    case 80: // $271
      var $272=(function() { try { __THREW__ = false; return _strcmp($267, $270) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 83; break; };
    case 81: // $273
      var $274=(($272)|0)==0;
      if ($274) { __label__ = 82; break; } else { __label__ = 84; break; }
    case 82: // $275
      $5=17;
      __label__ = 85; break;
    case 83: // $276
      var $277=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $278=$277.f0;
      $6=$278;
      var $279=$277.f1;
      $7=$279;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($porttag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 140; break; }
    case 84: // $280
      $5=0;
      __label__ = 85; break;
    case 85: // $281
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($porttag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 12; break; }
    case 86: // $282
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0) {
        __label__ = 87; break;
      }
      else if ($cleanup_dest == 17) {
        __label__ = 91; break;
      }
      else {
      __label__ = 141; break;
      }
      
    case 87: // $283
      __label__ = 88; break;
    case 88: // $284
      var $285=$scanport;
      var $286=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($285) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 12; break; };
    case 89: // $287
      $scanport=$286;
      __label__ = 74; break;
    case 90: // $288
      __label__ = 137; break;
    case 91: // $289
      var $290=$scanport;
      var $291=(($290)|0)==0;
      if ($291) { __label__ = 92; break; } else { __label__ = 94; break; }
    case 92: // $292
      var $293=$driver;
      var $294=(($293)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$driver;
      var $297=(($296+8)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=$field;
      var $300=(($299+8)|0);
      var $301=(($300)|0);
      var $302=HEAP32[(($301)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str343766)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$295,HEAP32[((tempInt+4)>>2)]=$298,HEAP32[((tempInt+8)>>2)]=$302,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 12; break; }
    case 93: // $303
      HEAP8[($error)]=1;
      __label__ = 94; break;
    case 94: // $304
      __label__ = 95; break;
    case 95: // $305
      var $306=$field;
      var $307=(function() { try { __THREW__ = false; return __ZN18input_field_config11settinglistEv($306) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 12; break; };
    case 96: // $308
      var $309=(function() { try { __THREW__ = false; return __ZNK11simple_listI20input_setting_configE5firstEv($307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 12; break; };
    case 97: // $310
      $setting=$309;
      __label__ = 98; break;
    case 98: // $311
      var $312=$setting;
      var $313=(($312)|0)!=0;
      if ($313) { __label__ = 99; break; } else { __label__ = 126; break; }
    case 99: // $314
      var $315=$setting;
      var $316=(($315+4)|0);
      var $317=(($316)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=(($318)|0)!=0;
      if ($319) { __label__ = 100; break; } else { __label__ = 123; break; }
    case 100: // $320
      var $321=$4;
      var $322=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 101; break; } else { __label__ = 12; break; };
    case 101: // $323
      $scanport=$322;
      __label__ = 102; break;
    case 102: // $324
      var $325=$scanport;
      var $326=(($325)|0)!=0;
      if ($326) { __label__ = 103; break; } else { __label__ = 119; break; }
    case 103: // $327
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($porttag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 12; break; }
    case 104: // $328
      var $329=$port;
      var $330=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 111; break; };
    case 105: // $331
      var $332=$setting;
      var $333=(($332+4)|0);
      var $334=(($333)|0);
      var $335=HEAP32[(($334)>>2)];
      var $336=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($330, $porttag1, $335) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 111; break; };
    case 106: // $337
      var $338=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($porttag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 111; break; };
    case 107: // $339
      var $340=$scanport;
      var $341=(function() { try { __THREW__ = false; return __ZNK17input_port_config3tagEv($340) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 111; break; };
    case 108: // $342
      var $343=(function() { try { __THREW__ = false; return _strcmp($338, $341) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 111; break; };
    case 109: // $344
      var $345=(($343)|0)==0;
      if ($345) { __label__ = 110; break; } else { __label__ = 112; break; }
    case 110: // $346
      $5=23;
      __label__ = 113; break;
    case 111: // $347
      var $348=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $349=$348.f0;
      $6=$349;
      var $350=$348.f1;
      $7=$350;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($porttag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 140; break; }
    case 112: // $351
      $5=0;
      __label__ = 113; break;
    case 113: // $352
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($porttag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 12; break; }
    case 114: // $353
      var $cleanup_dest2=$5;
      if ($cleanup_dest2 == 0) {
        __label__ = 115; break;
      }
      else if ($cleanup_dest2 == 23) {
        __label__ = 119; break;
      }
      else {
      __label__ = 141; break;
      }
      
    case 115: // $354
      __label__ = 116; break;
    case 116: // $355
      var $356=$scanport;
      var $357=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($356) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 117; break; } else { __label__ = 12; break; };
    case 117: // $358
      $scanport=$357;
      __label__ = 102; break;
    case 118: // $359
      __label__ = 137; break;
    case 119: // $360
      var $361=$scanport;
      var $362=(($361)|0)==0;
      if ($362) { __label__ = 120; break; } else { __label__ = 122; break; }
    case 120: // $363
      var $364=$driver;
      var $365=(($364)|0);
      var $366=HEAP32[(($365)>>2)];
      var $367=$driver;
      var $368=(($367+8)|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=$setting;
      var $371=(($370+4)|0);
      var $372=(($371)|0);
      var $373=HEAP32[(($372)>>2)];
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str343766)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$366,HEAP32[((tempInt+4)>>2)]=$369,HEAP32[((tempInt+8)>>2)]=$373,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 12; break; }
    case 121: // $374
      HEAP8[($error)]=1;
      __label__ = 122; break;
    case 122: // $375
      __label__ = 123; break;
    case 123: // $376
      __label__ = 124; break;
    case 124: // $377
      var $378=$setting;
      var $379=(function() { try { __THREW__ = false; return __ZNK20input_setting_config4nextEv($378) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 125; break; } else { __label__ = 12; break; };
    case 125: // $380
      $setting=$379;
      __label__ = 98; break;
    case 126: // $381
      __label__ = 127; break;
    case 127: // $382
      var $383=$field;
      var $384=(function() { try { __THREW__ = false; return __ZNK18input_field_config4nextEv($383) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 128; break; } else { __label__ = 12; break; };
    case 128: // $385
      $field=$384;
      __label__ = 41; break;
    case 129: // $386
      __label__ = 130; break;
    case 130: // $387
      var $388=$port;
      var $389=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 131; break; } else { __label__ = 12; break; };
    case 131: // $390
      $port=$389;
      __label__ = 37; break;
    case 132: // $391
      var $392=HEAP8[($error)];
      var $393=(($392) & 1);
      if ($393) { var $399 = 1;__label__ = 135; break; } else { __label__ = 133; break; }
    case 133: // $394
      var $395=(function() { try { __THREW__ = false; return __Z33validate_natural_keyboard_staticsv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 134; break; } else { __label__ = 12; break; };
    case 134: // $396
      var $397=(($395)|0)!=0;
      var $399 = $397;__label__ = 135; break;
    case 135: // $398
      var $399;
      var $400=(($399)&1);
      HEAP8[($error)]=$400;
      var $401=HEAP8[($error)];
      var $402=(($401) & 1);
      $1=$402;
      $5=1;
      __label__ = 136; break;
    case 136: // $403
      FUNCTION_TABLE[__ZN7astringD1Ev]($errorbuf);
      var $404=$1;
      STACKTOP = __stackBase__;
      return $404;
    case 137: // $405
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($errorbuf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 138; break; } else { __label__ = 140; break; }
    case 138: // $406
      __label__ = 139; break;
    case 139: // $407
      var $408=$6;
      var $409=$6;
      var $410=$7;
      var $411=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $409, tempValue);
      var $412=($411.f1 = $410, $411);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 140: // $413
      var $414=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 141: // $415
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15validate_inputsR17driver_enumeratorR8tagmap_tIjER11tagged_listI17input_port_configE["X"]=1;

function __ZL12validate_gfxR17driver_enumeratorP12region_array($drivlist, $rgninfo) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $driver;
      var $config;
      var $error;
      var $gfxnum;
      var $gfx;
      var $region;
      var $xscale;
      var $yscale;
      var $gl;
      var $israw;
      var $planes;
      var $width;
      var $height;
      var $total;
      var $rgnnum;
      var $len;
      var $avail;
      var $plane;
      var $start;
      var $charincrement;
      var $poffset;
      $2=$drivlist;
      $3=$rgninfo;
      var $4=$2;
      var $5=__ZNK17driver_enumerator6driverEv($4);
      $driver=$5;
      var $6=$2;
      var $7=__ZNK17driver_enumerator6configEv($6);
      $config=$7;
      $error=0;
      var $8=$config;
      var $9=(($8+44)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      $1=0;
      __label__ = 48; break;
    case 2: // $13
      $gfxnum=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$gfxnum;
      var $16=(($15)|0) < 32;
      if ($16) { __label__ = 4; break; } else { var $27 = 0;__label__ = 5; break; }
    case 4: // $17
      var $18=$gfxnum;
      var $19=$config;
      var $20=(($19+44)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+$18*20)|0);
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      var $27 = $25;__label__ = 5; break;
    case 5: // $26
      var $27;
      if ($27) { __label__ = 6; break; } else { __label__ = 47; break; }
    case 6: // $28
      var $29=$gfxnum;
      var $30=$config;
      var $31=(($30+44)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+$29*20)|0);
      $gfx=$33;
      var $34=$gfx;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      $region=$36;
      var $37=$gfxnum;
      var $38=$config;
      var $39=(($38+44)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+$37*20)|0);
      var $42=(($41+16)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      var $57 = 1;__label__ = 9; break;
    case 8: // $47
      var $48=$gfxnum;
      var $49=$config;
      var $50=(($49+44)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$48*20)|0);
      var $53=(($52+16)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $57 = $55;__label__ = 9; break;
    case 9: // $56
      var $57;
      $xscale=$57;
      var $58=$gfxnum;
      var $59=$config;
      var $60=(($59+44)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+$58*20)|0);
      var $63=(($62+17)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $78 = 1;__label__ = 12; break;
    case 11: // $68
      var $69=$gfxnum;
      var $70=$config;
      var $71=(($70+44)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+$69*20)|0);
      var $74=(($73+17)|0);
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $78 = $76;__label__ = 12; break;
    case 12: // $77
      var $78;
      $yscale=$78;
      var $79=$gfx;
      var $80=(($79+8)|0);
      var $81=HEAP32[(($80)>>2)];
      $gl=$81;
      var $82=$gl;
      var $83=(($82+12)|0);
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)==305419896;
      var $87=(($86)&1);
      $israw=$87;
      var $88=$gl;
      var $89=(($88+8)|0);
      var $90=HEAPU16[(($89)>>1)];
      var $91=(($90)&65535);
      $planes=$91;
      var $92=$gl;
      var $93=(($92)|0);
      var $94=HEAP16[(($93)>>1)];
      $width=$94;
      var $95=$gl;
      var $96=(($95+2)|0);
      var $97=HEAP16[(($96)>>1)];
      $height=$97;
      var $98=$gl;
      var $99=(($98+4)|0);
      var $100=HEAP32[(($99)>>2)];
      $total=$100;
      var $101=$region;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 13; break; } else { __label__ = 32; break; }
    case 13: // $103
      $rgnnum=0;
      __label__ = 14; break;
    case 14: // $104
      var $105=$rgnnum;
      var $106=(($105)>>>0) < 256;
      if ($106) { __label__ = 15; break; } else { __label__ = 31; break; }
    case 15: // $107
      var $108=$rgnnum;
      var $109=$3;
      var $110=(($109)|0);
      var $111=(($110+$108*68)|0);
      var $112=(($111)|0);
      var $113=__ZN7astringcvbEv($112);
      if ($113) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $114
      var $115=$driver;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$driver;
      var $119=(($118+8)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$gfxnum;
      var $122=$region;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str203752)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$117,HEAP32[((tempInt+4)>>2)]=$120,HEAP32[((tempInt+8)>>2)]=$121,HEAP32[((tempInt+12)>>2)]=$122,tempInt));
      $error=1;
      __label__ = 31; break;
    case 17: // $123
      var $124=$rgnnum;
      var $125=$3;
      var $126=(($125)|0);
      var $127=(($126+$124*68)|0);
      var $128=(($127)|0);
      var $129=$region;
      var $130=__ZNK7astringeqEPKc($128, $129);
      if ($130) { __label__ = 18; break; } else { __label__ = 29; break; }
    case 18: // $131
      var $132=$total;
      var $133=$132 & -2147483648;
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 28; break; } else { __label__ = 19; break; }
    case 19: // $135
      var $136=$gl;
      var $137=(($136+300)|0);
      var $138=HEAP32[(($137)>>2)];
      $charincrement=$138;
      var $139=$gl;
      var $140=(($139+12)|0);
      var $141=(($140)|0);
      $poffset=$141;
      $start=0;
      $plane=0;
      __label__ = 20; break;
    case 20: // $142
      var $143=$plane;
      var $144=$planes;
      var $145=(($143)|0) < (($144)|0);
      if ($145) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $146
      var $147=$plane;
      var $148=$poffset;
      var $149=(($148+($147<<2))|0);
      var $150=HEAPU32[(($149)>>2)];
      var $151=$start;
      var $152=(($150)>>>0) > (($151)>>>0);
      if ($152) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $153
      var $154=$plane;
      var $155=$poffset;
      var $156=(($155+($154<<2))|0);
      var $157=HEAP32[(($156)>>2)];
      $start=$157;
      __label__ = 23; break;
    case 23: // $158
      __label__ = 24; break;
    case 24: // $159
      var $160=$plane;
      var $161=(($160+1)|0);
      $plane=$161;
      __label__ = 20; break;
    case 25: // $162
      var $163=$charincrement;
      var $164=(($163-1)|0);
      var $165=$164 ^ -1;
      var $166=$start;
      var $167=$166 & $165;
      $start=$167;
      var $168=$total;
      var $169=$charincrement;
      var $170=(($168*$169)|0);
      $len=$170;
      var $171=$rgnnum;
      var $172=$3;
      var $173=(($172)|0);
      var $174=(($173+$171*68)|0);
      var $175=(($174+64)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$gfx;
      var $178=(($177+4)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$charincrement;
      var $181=Math.floor((($180)>>>0)/8);
      var $182=(($181-1)|0);
      var $183=$182 ^ -1;
      var $184=$179 & $183;
      var $185=(($176-$184)|0);
      $avail=$185;
      var $186=$start;
      var $187=$len;
      var $188=(($186+$187)|0);
      var $189=(((($188)|0)/8)|0);
      var $190=$avail;
      var $191=(($189)|0) > (($190)|0);
      if ($191) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $192
      var $193=$driver;
      var $194=(($193)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=$driver;
      var $197=(($196+8)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=$gfxnum;
      var $200=$region;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str213753)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$195,HEAP32[((tempInt+4)>>2)]=$198,HEAP32[((tempInt+8)>>2)]=$199,HEAP32[((tempInt+12)>>2)]=$200,tempInt));
      $error=1;
      __label__ = 27; break;
    case 27: // $201
      __label__ = 28; break;
    case 28: // $202
      __label__ = 31; break;
    case 29: // $203
      __label__ = 30; break;
    case 30: // $204
      var $205=$rgnnum;
      var $206=(($205+1)|0);
      $rgnnum=$206;
      __label__ = 14; break;
    case 31: // $207
      __label__ = 32; break;
    case 32: // $208
      var $209=$israw;
      var $210=(($209)|0)!=0;
      if ($210) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $211
      var $212=$total;
      var $213=(($212)|0)!=-2004877312;
      if ($213) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $214
      var $215=$driver;
      var $216=(($215)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=$driver;
      var $219=(($218+8)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$gfxnum;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str223754)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$217,HEAP32[((tempInt+4)>>2)]=$220,HEAP32[((tempInt+8)>>2)]=$221,tempInt));
      $error=1;
      __label__ = 35; break;
    case 35: // $222
      var $223=$xscale;
      var $224=(($223)|0)!=1;
      if ($224) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $225
      var $226=$yscale;
      var $227=(($226)|0)!=1;
      if ($227) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $228
      var $229=$driver;
      var $230=(($229)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=$driver;
      var $233=(($232+8)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$gfxnum;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str233755)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$231,HEAP32[((tempInt+4)>>2)]=$234,HEAP32[((tempInt+8)>>2)]=$235,tempInt));
      $error=1;
      __label__ = 38; break;
    case 38: // $236
      __label__ = 45; break;
    case 39: // $237
      var $238=$planes;
      var $239=(($238)|0) > 8;
      if ($239) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $240
      var $241=$driver;
      var $242=(($241)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=$driver;
      var $245=(($244+8)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=$gfxnum;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str243756)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$243,HEAP32[((tempInt+4)>>2)]=$246,HEAP32[((tempInt+8)>>2)]=$247,tempInt));
      $error=1;
      __label__ = 41; break;
    case 41: // $248
      var $249=$xscale;
      var $250=$width;
      var $251=(($250)&65535);
      var $252=(($249*$251)|0);
      var $253=(($252)|0) > 1024;
      if ($253) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $254
      var $255=$yscale;
      var $256=$height;
      var $257=(($256)&65535);
      var $258=(($255*$257)|0);
      var $259=(($258)|0) > 1024;
      if ($259) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $260
      var $261=$driver;
      var $262=(($261)|0);
      var $263=HEAP32[(($262)>>2)];
      var $264=$driver;
      var $265=(($264+8)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=$gfxnum;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str253757)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$263,HEAP32[((tempInt+4)>>2)]=$266,HEAP32[((tempInt+8)>>2)]=$267,tempInt));
      $error=1;
      __label__ = 44; break;
    case 44: // $268
      __label__ = 45; break;
    case 45: // $269
      __label__ = 46; break;
    case 46: // $270
      var $271=$gfxnum;
      var $272=(($271+1)|0);
      $gfxnum=$272;
      __label__ = 3; break;
    case 47: // $273
      var $274=$error;
      var $275=(($274) & 1);
      $1=$275;
      __label__ = 48; break;
    case 48: // $276
      var $277=$1;
      ;
      return $277;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12validate_gfxR17driver_enumeratorP12region_array["X"]=1;

function __ZL16validate_devicesR17driver_enumeratorRK11tagged_listI17input_port_configEP12region_array($drivlist, $portlist, $rgninfo) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      var $driver;
      var $config;
      var $device;
      var $scandevice;
      $1=$drivlist;
      $2=$portlist;
      $3=$rgninfo;
      $error=0;
      var $4=$1;
      var $5=__ZNK17driver_enumerator6driverEv($4);
      $driver=$5;
      var $6=$1;
      var $7=__ZNK17driver_enumerator6configEv($6);
      $config=$7;
      var $8=$config;
      var $9=__ZNK14machine_config10devicelistEv($8);
      var $10=$9;
      var $11=__ZNK11tagged_listI8device_tE5firstEv($10);
      $device=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $15
      var $16=$driver;
      var $17=$device;
      var $18=__ZNK8device_t4nameEv($17);
      var $19=$device;
      var $20=__ZNK8device_t3tagEv($19);
      var $21=__Z12validate_tagRK11game_driverPKcS3_($16, $18, $20);
      if ($21) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $22
      $error=1;
      __label__ = 4; break;
    case 4: // $23
      var $24=$config;
      var $25=__ZNK14machine_config10devicelistEv($24);
      var $26=$25;
      var $27=__ZNK11tagged_listI8device_tE5firstEv($26);
      $scandevice=$27;
      __label__ = 5; break;
    case 5: // $28
      var $29=$scandevice;
      var $30=$device;
      var $31=(($29)|0)!=(($30)|0);
      if ($31) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $32
      var $33=$scandevice;
      var $34=__ZNK8device_t3tagEv($33);
      var $35=$device;
      var $36=__ZNK8device_t3tagEv($35);
      var $37=_strcmp($34, $36);
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $39
      var $40=$driver;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$driver;
      var $44=(($43+8)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$device;
      var $47=__ZNK8device_t3tagEv($46);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str173749)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,HEAP32[((tempInt+4)>>2)]=$45,HEAP32[((tempInt+8)>>2)]=$47,tempInt));
      __label__ = 10; break;
    case 8: // $48
      __label__ = 9; break;
    case 9: // $49
      var $50=$scandevice;
      var $51=__ZNK8device_t4nextEv($50);
      $scandevice=$51;
      __label__ = 5; break;
    case 10: // $52
      var $53=$device;
      var $54=__ZNK8device_t10rom_regionEv($53);
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $56
      var $57=$device;
      var $58=__ZNK8device_t9shortnameEv($57);
      var $59=_strcmp($58, ((__str183750)|0));
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $61
      var $62=$device;
      var $63=__ZNK8device_t4nameEv($62);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str193751)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,tempInt));
      __label__ = 13; break;
    case 13: // $64
      var $65=$device;
      var $66=$config;
      var $67=__ZNK14machine_config7optionsEv($66);
      var $68=$driver;
      var $69=__ZNK8device_t14validity_checkER11emu_optionsRK11game_driver($65, $67, $68);
      if ($69) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $70
      $error=1;
      __label__ = 15; break;
    case 15: // $71
      __label__ = 16; break;
    case 16: // $72
      var $73=$device;
      var $74=__ZNK8device_t4nextEv($73);
      $device=$74;
      __label__ = 1; break;
    case 17: // $75
      var $76=$error;
      var $77=(($76) & 1);
      ;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16validate_devicesR17driver_enumeratorRK11tagged_listI17input_port_configEP12region_array["X"]=1;

function __ZN12region_arrayD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12region_arrayD2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIjED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIjED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIPK11game_driverED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIPK11game_driverED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIjED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIjE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIjE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN8tagmap_tIjEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN8tagmap_tIPK11game_driverED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIPK11game_driverE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIPK11game_driverE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN8tagmap_tIPK11game_driverEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN12region_entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12region_entryD2Ev($2);
  ;
  return;
}


function __ZN12region_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZNK8device_t10rom_regionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  ;
  return $7;
}


function __ZNK8device_t9shortnameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+116)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN12region_arrayD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      var $6=(($5)|0);
      var $7=(($6+17408)|0);
      var $9 = $7;__label__ = 1; break;
    case 1: // $8
      var $9;
      var $10=(($9-68)|0);
      (function() { try { __THREW__ = false; return __ZN12region_entryD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=(($10)|0)==(($6)|0);
      if ($12) { __label__ = 3; break; } else { var $9 = $10;__label__ = 1; break; }
    case 3: // $13
      ;
      return;
    case 4: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $2=$16;
      var $17=$15.f1;
      $3=$17;
      var $18=(($6)|0)==(($10)|0);
      if ($18) { __label__ = 7; break; } else { var $20 = $10;__label__ = 5; break; }
    case 5: // $19
      var $20;
      var $21=(($20-68)|0);
      (function() { try { __THREW__ = false; return __ZN12region_entryD1Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $22
      var $23=(($21)|0)==(($6)|0);
      if ($23) { __label__ = 7; break; } else { var $20 = $21;__label__ = 5; break; }
    case 7: // $24
      __label__ = 8; break;
    case 8: // $25
      var $26=$2;
      var $27=$2;
      var $28=$3;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11driver_list5totalEv() {
  ;
  var __label__;

  var $1=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
  ;
  return $1;
}


function __ZL11tagmap_hashPKc3840($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL27validate_analog_input_fieldP18input_field_configRK11game_driverPb($field, $driver, $error) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $analog_max;
      var $analog_min;
      var $shift;
      var $default_value;
      $1=$field;
      $2=$driver;
      $3=$error;
      var $4=$1;
      var $5=(($4+304)|0);
      var $6=HEAP32[(($5)>>2)];
      $analog_max=$6;
      var $7=$1;
      var $8=(($7+300)|0);
      var $9=HEAP32[(($8)>>2)];
      $analog_min=$9;
      var $10=$1;
      var $11=(($10+24)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)==150;
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      var $15=$1;
      var $16=(($15+24)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==151;
      if ($18) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $19
      $shift=0;
      __label__ = 3; break;
    case 3: // $20
      var $21=$shift;
      var $22=(($21)|0) <= 31;
      if ($22) { __label__ = 4; break; } else { var $33 = 0;__label__ = 5; break; }
    case 4: // $23
      var $24=$1;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 ^ -1;
      var $28=$shift;
      var $29=1 << $28;
      var $30=$27 & $29;
      var $31=(($30)|0)!=0;
      var $33 = $31;__label__ = 5; break;
    case 5: // $32
      var $33;
      if ($33) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $34
      __label__ = 7; break;
    case 7: // $35
      var $36=$shift;
      var $37=(($36+1)|0);
      $shift=$37;
      __label__ = 3; break;
    case 8: // $38
      var $39=$analog_max;
      var $40=(($39-1)|0);
      var $41=$shift;
      var $42=$40 << $41;
      $analog_max=$42;
      var $43=$1;
      var $44=(($43)|0);
      var $45=HEAPU32[(($44)>>2)];
      var $46=$shift;
      var $47=$45 >>> (($46)>>>0);
      var $48=(($47+1)|0);
      var $49=$1;
      var $50=(($49+304)|0);
      var $51=HEAPU32[(($50)>>2)];
      var $52=(($48)>>>0) < (($51)>>>0);
      if ($52) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $53
      var $54=$2;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$2;
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str463778)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,HEAP32[((tempInt+4)>>2)]=$59,tempInt));
      var $60=$3;
      HEAP8[($60)]=1;
      __label__ = 10; break;
    case 10: // $61
      __label__ = 14; break;
    case 11: // $62
      var $63=$1;
      var $64=(($63+32)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65 & 64;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $68
      var $69=$2;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str473779)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$71,HEAP32[((tempInt+4)>>2)]=$74,tempInt));
      var $75=$3;
      HEAP8[($75)]=1;
      __label__ = 13; break;
    case 13: // $76
      __label__ = 14; break;
    case 14: // $77
      var $78=$1;
      var $79=(($78+308)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $82
      var $83=$2;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$2;
      var $87=(($86+8)|0);
      var $88=HEAP32[(($87)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str483780)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$85,HEAP32[((tempInt+4)>>2)]=$88,tempInt));
      var $89=$3;
      HEAP8[($89)]=1;
      __label__ = 16; break;
    case 16: // $90
      var $91=$1;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$1;
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$96 ^ -1;
      var $98=$93 & $97;
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $100
      var $101=$2;
      var $102=(($101)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$2;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str493781)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$103,HEAP32[((tempInt+4)>>2)]=$106,tempInt));
      var $107=$3;
      HEAP8[($107)]=1;
      __label__ = 18; break;
    case 18: // $108
      var $109=$1;
      var $110=(($109+24)|0);
      var $111=HEAPU32[(($110)>>2)];
      var $112=(($111)>>>0) >= 140;
      if ($112) { __label__ = 19; break; } else { __label__ = 33; break; }
    case 19: // $113
      var $114=$1;
      var $115=(($114+24)|0);
      var $116=HEAPU32[(($115)>>2)];
      var $117=(($116)>>>0) <= 151;
      if ($117) { __label__ = 20; break; } else { __label__ = 33; break; }
    case 20: // $118
      var $119=$1;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      $default_value=$121;
      var $122=$analog_min;
      var $123=$analog_max;
      var $124=(($122)|0) > (($123)|0);
      if ($124) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $125
      var $126=$analog_min;
      var $127=(((-$126))|0);
      $analog_min=$127;
      var $128=$default_value;
      var $129=$analog_max;
      var $130=(($128)|0) > (($129)|0);
      if ($130) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $131
      var $132=$default_value;
      var $133=(((-$132))|0);
      $default_value=$133;
      __label__ = 23; break;
    case 23: // $134
      __label__ = 24; break;
    case 24: // $135
      var $136=$default_value;
      var $137=$analog_min;
      var $138=(($136)|0) < (($137)|0);
      if ($138) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $139
      var $140=$default_value;
      var $141=$analog_max;
      var $142=(($140)|0) > (($141)|0);
      if ($142) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $143
      var $144=$2;
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$2;
      var $148=(($147+8)|0);
      var $149=HEAP32[(($148)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str503782)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$146,HEAP32[((tempInt+4)>>2)]=$149,tempInt));
      var $150=$3;
      HEAP8[($150)]=1;
      __label__ = 27; break;
    case 27: // $151
      var $152=$1;
      var $153=(($152+300)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$1;
      var $156=(($155)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$157 ^ -1;
      var $159=$154 & $158;
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $161
      var $162=$analog_max;
      var $163=$1;
      var $164=(($163)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=$165 ^ -1;
      var $167=$162 & $166;
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $169
      var $170=$2;
      var $171=(($170)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=$2;
      var $174=(($173+8)|0);
      var $175=HEAP32[(($174)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str513783)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$172,HEAP32[((tempInt+4)>>2)]=$175,tempInt));
      var $176=$3;
      HEAP8[($176)]=1;
      __label__ = 30; break;
    case 30: // $177
      var $178=$1;
      var $179=(($178+32)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$180 & 32;
      var $182=(($181)|0)!=0;
      if ($182) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $183
      var $184=$2;
      var $185=(($184)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$2;
      var $188=(($187+8)|0);
      var $189=HEAP32[(($188)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str523784)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$186,HEAP32[((tempInt+4)>>2)]=$189,tempInt));
      var $190=$3;
      HEAP8[($190)]=1;
      __label__ = 32; break;
    case 32: // $191
      __label__ = 42; break;
    case 33: // $192
      var $193=$1;
      var $194=(($193+24)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195)|0)!=150;
      if ($196) { __label__ = 34; break; } else { __label__ = 41; break; }
    case 34: // $197
      var $198=$1;
      var $199=(($198+24)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200)|0)!=151;
      if ($201) { __label__ = 35; break; } else { __label__ = 41; break; }
    case 35: // $202
      var $203=$1;
      var $204=(($203+300)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $207
      var $208=$1;
      var $209=(($208+304)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$1;
      var $212=(($211)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($210)|0)!=(($213)|0);
      if ($214) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $215
      var $216=$2;
      var $217=(($216)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$2;
      var $220=(($219+8)|0);
      var $221=HEAP32[(($220)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str533785)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$218,HEAP32[((tempInt+4)>>2)]=$221,tempInt));
      var $222=$3;
      HEAP8[($222)]=1;
      __label__ = 38; break;
    case 38: // $223
      var $224=$1;
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=(($226)|0)!=0;
      if ($227) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $228
      var $229=$2;
      var $230=(($229)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=$2;
      var $233=(($232+8)|0);
      var $234=HEAP32[(($233)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str543786)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$231,HEAP32[((tempInt+4)>>2)]=$234,tempInt));
      var $235=$3;
      HEAP8[($235)]=1;
      __label__ = 40; break;
    case 40: // $236
      __label__ = 41; break;
    case 41: // $237
      __label__ = 42; break;
    case 42: // $238
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27validate_analog_input_fieldP18input_field_configRK11game_driverPb["X"]=1;

function __ZL21validate_dip_settingsP18input_field_configRK11game_driverR8tagmap_tIjEPb($field, $driver, $defstr_map, $error) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $demo_sounds;
      var $flipscreen;
      var $coin_list=__stackBase__;
      var $setting;
      var $coin_error;
      var $strindex;
      var $next_strindex;
      var $entry;
      $1=$field;
      $2=$driver;
      $3=$defstr_map;
      $4=$error;
      var $5=__ZL28input_port_string_from_indexj(8);
      $demo_sounds=$5;
      var $6=__ZL28input_port_string_from_indexj(50);
      $flipscreen=$6;
      var $7=$coin_list;
      _memset($7, 0, 34, 1);
      $coin_error=0;
      var $8=$1;
      var $9=__ZN18input_field_config11settinglistEv($8);
      var $10=__ZNK11simple_listI20input_setting_configE5firstEv($9);
      $setting=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$setting;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 40; break; }
    case 2: // $14
      var $15=$3;
      var $16=$setting;
      var $17=(($16+20)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=$4;
      var $21=__ZL16get_defstr_indexR8tagmap_tIjEPKcRK11game_driverPb($15, $18, $19, $20);
      $strindex=$21;
      var $22=$strindex;
      var $23=(($22)|0) >= 12;
      if ($23) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $24
      var $25=$strindex;
      var $26=(($25)|0) <= 45;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$strindex;
      var $29=(($28-12)|0);
      var $30=(($coin_list+$29)|0);
      HEAP8[($30)]=1;
      __label__ = 5; break;
    case 5: // $31
      var $32=$1;
      var $33=(($32+40)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$demo_sounds;
      var $36=(($34)|0)==(($35)|0);
      if ($36) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $37
      var $38=$strindex;
      var $39=(($38)|0)==2;
      if ($39) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $40
      var $41=$1;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$setting;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($43)|0)!=(($46)|0);
      if ($47) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$2;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$2;
      var $53=(($52+8)|0);
      var $54=HEAP32[(($53)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str373769)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$51,HEAP32[((tempInt+4)>>2)]=$54,tempInt));
      var $55=$4;
      HEAP8[($55)]=1;
      __label__ = 9; break;
    case 9: // $56
      var $57=$1;
      var $58=(($57+40)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$demo_sounds;
      var $61=(($59)|0)==(($60)|0);
      if ($61) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $62
      var $63=$strindex;
      var $64=(($63)|0)==4;
      if ($64) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $65
      var $66=$strindex;
      var $67=(($66)|0)==3;
      if ($67) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $68
      var $69=$2;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$setting;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str383770)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$71,HEAP32[((tempInt+4)>>2)]=$74,HEAP32[((tempInt+8)>>2)]=$77,tempInt));
      var $78=$4;
      HEAP8[($78)]=1;
      __label__ = 13; break;
    case 13: // $79
      var $80=$1;
      var $81=(($80+40)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$flipscreen;
      var $84=(($82)|0)==(($83)|0);
      if ($84) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $85
      var $86=$strindex;
      var $87=(($86)|0)==4;
      if ($87) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $88
      var $89=$strindex;
      var $90=(($89)|0)==3;
      if ($90) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $91
      var $92=$2;
      var $93=(($92)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$2;
      var $96=(($95+8)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$setting;
      var $99=(($98+20)|0);
      var $100=HEAP32[(($99)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str393771)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$94,HEAP32[((tempInt+4)>>2)]=$97,HEAP32[((tempInt+8)>>2)]=$100,tempInt));
      var $101=$4;
      HEAP8[($101)]=1;
      __label__ = 17; break;
    case 17: // $102
      var $103=$setting;
      var $104=__ZNK20input_setting_config4nextEv($103);
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 18; break; } else { __label__ = 38; break; }
    case 18: // $106
      var $107=$3;
      var $108=$setting;
      var $109=__ZNK20input_setting_config4nextEv($108);
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$2;
      var $113=$4;
      var $114=__ZL16get_defstr_indexR8tagmap_tIjEPKcRK11game_driverPb($107, $111, $112, $113);
      $next_strindex=$114;
      var $115=$strindex;
      var $116=(($115)|0)==2;
      if ($116) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $117
      var $118=$next_strindex;
      var $119=(($118)|0)==1;
      if ($119) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $120
      var $121=$2;
      var $122=(($121)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$2;
      var $125=(($124+8)|0);
      var $126=HEAP32[(($125)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str403772)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$123,HEAP32[((tempInt+4)>>2)]=$126,tempInt));
      var $127=$4;
      HEAP8[($127)]=1;
      __label__ = 37; break;
    case 21: // $128
      var $129=$strindex;
      var $130=(($129)|0)==4;
      if ($130) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $131
      var $132=$next_strindex;
      var $133=(($132)|0)==3;
      if ($133) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $134
      var $135=$2;
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$2;
      var $139=(($138+8)|0);
      var $140=HEAP32[(($139)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str413773)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$137,HEAP32[((tempInt+4)>>2)]=$140,tempInt));
      var $141=$4;
      HEAP8[($141)]=1;
      __label__ = 36; break;
    case 24: // $142
      var $143=$strindex;
      var $144=(($143)|0)==49;
      if ($144) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $145
      var $146=$next_strindex;
      var $147=(($146)|0)==48;
      if ($147) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $148
      var $149=$2;
      var $150=(($149)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$2;
      var $153=(($152+8)|0);
      var $154=HEAP32[(($153)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str423774)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$151,HEAP32[((tempInt+4)>>2)]=$154,tempInt));
      var $155=$4;
      HEAP8[($155)]=1;
      __label__ = 35; break;
    case 27: // $156
      var $157=$strindex;
      var $158=(($157)|0) >= 12;
      if ($158) { __label__ = 28; break; } else { __label__ = 34; break; }
    case 28: // $159
      var $160=$strindex;
      var $161=(($160)|0) <= 45;
      if ($161) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $162
      var $163=$next_strindex;
      var $164=(($163)|0) >= 12;
      if ($164) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $165
      var $166=$next_strindex;
      var $167=(($166)|0) <= 45;
      if ($167) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $168
      var $169=$strindex;
      var $170=$next_strindex;
      var $171=(($169)|0) >= (($170)|0);
      if ($171) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $172
      var $173=$setting;
      var $174=(($173+4)|0);
      var $175=$174;
      var $176=$setting;
      var $177=__ZNK20input_setting_config4nextEv($176);
      var $178=(($177+4)|0);
      var $179=$178;
      var $180=_memcmp($175, $179, 16);
      var $181=(($180)|0)==0;
      if ($181) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $182
      var $183=$2;
      var $184=(($183)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$2;
      var $187=(($186+8)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$setting;
      var $190=(($189+20)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$setting;
      var $193=__ZNK20input_setting_config4nextEv($192);
      var $194=(($193+20)|0);
      var $195=HEAP32[(($194)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str433775)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,HEAP32[((tempInt+4)>>2)]=$188,HEAP32[((tempInt+8)>>2)]=$191,HEAP32[((tempInt+12)>>2)]=$195,tempInt));
      var $196=$4;
      HEAP8[($196)]=1;
      $coin_error=1;
      __label__ = 34; break;
    case 34: // $197
      __label__ = 35; break;
    case 35: // $198
      __label__ = 36; break;
    case 36: // $199
      __label__ = 37; break;
    case 37: // $200
      __label__ = 38; break;
    case 38: // $201
      __label__ = 39; break;
    case 39: // $202
      var $203=$setting;
      var $204=__ZNK20input_setting_config4nextEv($203);
      $setting=$204;
      __label__ = 1; break;
    case 40: // $205
      var $206=$coin_error;
      var $207=(($206)|0)!=0;
      if ($207) { __label__ = 41; break; } else { __label__ = 48; break; }
    case 41: // $208
      var $209=$2;
      var $210=(($209)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=$2;
      var $213=(($212+8)|0);
      var $214=HEAP32[(($213)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str443776)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$211,HEAP32[((tempInt+4)>>2)]=$214,tempInt));
      $entry=0;
      __label__ = 42; break;
    case 42: // $215
      var $216=$entry;
      var $217=(($216)>>>0) < 34;
      if ($217) { __label__ = 43; break; } else { __label__ = 47; break; }
    case 43: // $218
      var $219=$entry;
      var $220=(($coin_list+$219)|0);
      var $221=HEAP8[($220)];
      var $222=(($221 << 24) >> 24)!=0;
      if ($222) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $223
      var $224=$entry;
      var $225=(($224+12)|0);
      var $226=__ZL28input_port_string_from_indexj($225);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str453777)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$226,tempInt));
      __label__ = 45; break;
    case 45: // $227
      __label__ = 46; break;
    case 46: // $228
      var $229=$entry;
      var $230=(($229+1)|0);
      $entry=$230;
      __label__ = 42; break;
    case 47: // $231
      __label__ = 48; break;
    case 48: // $232
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21validate_dip_settingsP18input_field_configRK11game_driverR8tagmap_tIjEPb["X"]=1;

function __ZL16get_defstr_indexR8tagmap_tIjEPKcRK11game_driverPb($defstr_map, $name, $driver, $error) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $strindex;
      $1=$defstr_map;
      $2=$name;
      $3=$driver;
      $4=$error;
      var $5=$1;
      var $6=$2;
      var $7=__ZNK8tagmap_tIjE4findEPKc($5, $6);
      $strindex=$7;
      var $8=$strindex;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=$2;
      var $12=$strindex;
      var $13=__ZL28input_port_string_from_indexj($12);
      var $14=(($11)|0)!=(($13)|0);
      if ($14) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $15
      var $16=$4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$3;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$3;
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str363768)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$24,HEAP32[((tempInt+8)>>2)]=$25,tempInt));
      var $26=$4;
      HEAP8[($26)]=1;
      __label__ = 4; break;
    case 4: // $27
      var $28=$strindex;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8tagmap_tIjE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL11tagmap_findPK7_tagmapPKc3838($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZL11tagmap_findPK7_tagmapPKc3838($map, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$map;
  $2=$tag;
  var $3=$1;
  var $4=$2;
  var $5=$2;
  var $6=__ZL11tagmap_hashPKc3840($5);
  var $7=__ZL21tagmap_find_prehashedPK7_tagmapPKcj3839($3, $4, $6);
  ;
  return $7;
}


function __ZL21tagmap_find_prehashedPK7_tagmapPKcj3839($map, $tag, $fullhash) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $entry;
      $2=$map;
      $3=$tag;
      $4=$fullhash;
      var $5=$4;
      var $6=(($5)>>>0)%97;
      var $7=$2;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      $entry=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $14
      var $15=$entry;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$4;
      var $19=(($17)|0)==(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=$entry;
      var $22=(($21+12)|0);
      var $23=(($22)|0);
      var $24=$3;
      var $25=_strcmp($23, $24);
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$entry;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      $1=$30;
      __label__ = 8; break;
    case 5: // $31
      __label__ = 6; break;
    case 6: // $32
      var $33=$entry;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      $entry=$35;
      __label__ = 1; break;
    case 7: // $36
      $1=0;
      __label__ = 8; break;
    case 8: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIPK11game_driverE3addEPKcS2_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z10tagmap_addP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZNK8tagmap_tIPK11game_driverE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL11tagmap_findPK7_tagmapPKc3838($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZN11driver_list14non_bios_cloneEi($index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$index;
      var $2=$1;
      var $3=__ZN11driver_list6driverEi($2);
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZN11driver_list4findEPKc($5);
      $result=$6;
      var $7=$result;
      var $8=(($7)|0)!=-1;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=$result;
      var $11=__ZN11driver_list6driverEi($10);
      var $12=(($11+44)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 & 4096;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$result;
      var $20 = $17;__label__ = 4; break;
    case 3: // $18
      var $20 = -1;__label__ = 4; break;
    case 4: // $19
      var $20;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11driver_list15compatible_withERK11game_driver($driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $index;
      $1=$driver;
      var $2=$1;
      var $3=__ZN11driver_list4findERK11game_driver($2);
      $index=$3;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$index;
      var $7=__ZN11driver_list15compatible_withEi($6);
      ;
      return $7;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17atomic_exchange32PVii($ptr, $exchange) {
  ;
  var __label__;

  var $1;
  var $2;
  var $oldval;
  $1=$ptr;
  $2=$exchange;
  var $3=$1;
  var $4=HEAP32[(($3)>>2)];
  $oldval=$4;
  var $5=$2;
  var $6=$1;
  HEAP32[(($6)>>2)]=$5;
  var $7=$oldval;
  ;
  return $7;
}


function __ZL9mul_32x32ii3841($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=(($3|0) < 0 ? -1 : 0);
  var $5=$2;
  var $6$0=$5;
  var $6$1=(($5|0) < 0 ? -1 : 0);
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  ;
  return [$7$0,$7$1];
}


function __ZL10mulu_32x32jj3842($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=0;
  var $5=$2;
  var $6$0=$5;
  var $6$1=0;
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  ;
  return [$7$0,$7$1];
}


function __ZL12mul_32x32_hiii($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=(($3|0) < 0 ? -1 : 0);
  var $5=$2;
  var $6$0=$5;
  var $6$1=(($5|0) < 0 ? -1 : 0);
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$1;
  var $8$1=(($7$1|0) < 0 ? -1 : 0);
  var $9$0=$8$0;
  var $9=$9$0;
  ;
  return $9;
}


function __ZL13mulu_32x32_hijj($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=0;
  var $5=$2;
  var $6$0=$5;
  var $6$1=0;
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$1;
  var $8$1=0;
  var $9$0=$8$0;
  var $9=$9$0;
  ;
  return $9;
}


function __ZL15mul_32x32_shiftiih($a, $b, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$a;
  $2=$b;
  $3=$shift;
  var $4=$1;
  var $5$0=$4;
  var $5$1=(($4|0) < 0 ? -1 : 0);
  var $6=$2;
  var $7$0=$6;
  var $7$1=(($6|0) < 0 ? -1 : 0);
  var $8$0 = ((($5$0)>>>0)+((($5$1)|0)*4294967296))*((($7$0)>>>0)+((($7$1)|0)*4294967296))>>>0; var $8$1 = Math.min(Math.floor((((($5$0)>>>0)+((($5$1)|0)*4294967296))*((($7$0)>>>0)+((($7$1)|0)*4294967296)))/4294967296), 4294967295);
  var $9=$3;
  var $10=(($9)&255);
  var $11$0=$10;
  var $11$1=0;
  var $12=Runtime.bitshift64($8$0, $8$1,"ashr",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
  var $13$0=$12$0;
  var $13=$13$0;
  ;
  return $13;
}


function __ZL16mulu_32x32_shiftjjh($a, $b, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$a;
  $2=$b;
  $3=$shift;
  var $4=$1;
  var $5$0=$4;
  var $5$1=0;
  var $6=$2;
  var $7$0=$6;
  var $7$1=0;
  var $8$0 = ((($5$0)>>>0)+((($5$1)|0)*4294967296))*((($7$0)>>>0)+((($7$1)|0)*4294967296))>>>0; var $8$1 = Math.min(Math.floor((((($5$0)>>>0)+((($5$1)|0)*4294967296))*((($7$0)>>>0)+((($7$1)|0)*4294967296)))/4294967296), 4294967295);
  var $9=$3;
  var $10=(($9)&255);
  var $11$0=$10;
  var $11$1=0;
  var $12=Runtime.bitshift64($8$0, $8$1,"lshr",$11$0);var $12$0 = $12[0], $12$1 = $12[1];
  var $13$0=$12$0;
  var $13=$13$0;
  ;
  return $13;
}


function __ZL15div_32x32_shiftiih($a, $b, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$a;
  $2=$b;
  $3=$shift;
  var $4=$1;
  var $5$0=$4;
  var $5$1=(($4|0) < 0 ? -1 : 0);
  var $6=$3;
  var $7=(($6)&255);
  var $8$0=$7;
  var $8$1=0;
  var $9=Runtime.bitshift64($5$0, $5$1,"shl",$8$0);var $9$0 = $9[0], $9$1 = $9[1];
  var $10=$2;
  var $11$0=$10;
  var $11$1=(($10|0) < 0 ? -1 : 0);
  var $12$0 = (tempBigIntR=((($9$0)>>>0)+((($9$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $12$1 = Math.min(Math.floor(((tempBigIntR=((($9$0)>>>0)+((($9$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $13$0=$12$0;
  var $13=$13$0;
  ;
  return $13;
}


function __ZL16divu_32x32_shiftjjh($a, $b, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$a;
  $2=$b;
  $3=$shift;
  var $4=$1;
  var $5$0=$4;
  var $5$1=0;
  var $6=$3;
  var $7=(($6)&255);
  var $8$0=$7;
  var $8$1=0;
  var $9=Runtime.bitshift64($5$0, $5$1,"shl",$8$0);var $9$0 = $9[0], $9$1 = $9[1];
  var $10=$2;
  var $11$0=$10;
  var $11$1=0;
  var $12$0 = Math.floor(((($9$0)>>>0)+((($9$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)))>>>0; var $12$1 = Math.min(Math.floor((Math.floor(((($9$0)>>>0)+((($9$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296))))/4294967296), 4294967295);
  var $13$0=$12$0;
  var $13=$13$0;
  ;
  return $13;
}


function __ZL12recip_approxf($value) {
  ;
  var __label__;

  var $1;
  $1=$value;
  var $2=$1;
  var $3=1/$2;
  ;
  return $3;
}


function __ZL19count_leading_zerosj($val) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $count;
      $1=$val;
      $count=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3)|0) >= 0;
      if ($4) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $5
      var $6=$1;
      var $7=$6 << 1;
      $1=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$count;
      var $10=(($9+1)&255);
      $count=$10;
      __label__ = 1; break;
    case 4: // $11
      var $12=$count;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18count_leading_onesj($val) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $count;
      $1=$val;
      $count=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3)|0) < 0;
      if ($4) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $5
      var $6=$1;
      var $7=$6 << 1;
      $1=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$count;
      var $10=(($9+1)&255);
      $count=$10;
      __label__ = 1; break;
    case 4: // $11
      var $12=$count;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18compare_exchange32PViii($ptr, $compare, $exchange) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $oldval;
      $1=$ptr;
      $2=$compare;
      $3=$exchange;
      var $4=$1;
      var $5=HEAP32[(($4)>>2)];
      $oldval=$5;
      var $6=$1;
      var $7=HEAP32[(($6)>>2)];
      var $8=$2;
      var $9=(($7)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$3;
      var $12=$1;
      HEAP32[(($12)>>2)]=$11;
      __label__ = 2; break;
    case 2: // $13
      var $14=$oldval;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12atomic_add32PVii($ptr, $delta) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$ptr;
  $2=$delta;
  var $3=$2;
  var $4=$1;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+$3)|0);
  HEAP32[(($4)>>2)]=$6;
  var $7=HEAP32[(($4)>>2)];
  ;
  return $7;
}


function __ZL9div_64x32xi($a$0, $a$1, $b) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $st$2$0=(($1)|0);
  HEAP32[(($st$2$0)>>2)]=$a$0;
  var $st$2$1=(($1+4)|0);
  HEAP32[(($st$2$1)>>2)]=$a$1;
  $2=$b;
  var $st$7$0=(($1)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($1+4)|0);
  var $3$1=HEAP32[(($st$7$1)>>2)];
  var $4=$2;
  var $5$0=$4;
  var $5$1=(($4|0) < 0 ? -1 : 0);
  var $6$0 = (tempBigIntR=((($3$0)>>>0)+((($3$1)|0)*4294967296))/((($5$0)>>>0)+((($5$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $6$1 = Math.min(Math.floor(((tempBigIntR=((($3$0)>>>0)+((($3$1)|0)*4294967296))/((($5$0)>>>0)+((($5$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $7$0=$6$0;
  var $7=$7$0;
  STACKTOP = __stackBase__;
  return $7;
}


function __ZL10divu_64x32yj3843($a$0, $a$1, $b) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $st$2$0=(($1)|0);
  HEAP32[(($st$2$0)>>2)]=$a$0;
  var $st$2$1=(($1+4)|0);
  HEAP32[(($st$2$1)>>2)]=$a$1;
  $2=$b;
  var $st$7$0=(($1)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($1+4)|0);
  var $3$1=HEAP32[(($st$7$1)>>2)];
  var $4=$2;
  var $5$0=$4;
  var $5$1=0;
  var $6$0 = Math.floor(((($3$0)>>>0)+((($3$1)|0)*4294967296))/((($5$0)>>>0)+((($5$1)|0)*4294967296)))>>>0; var $6$1 = Math.min(Math.floor((Math.floor(((($3$0)>>>0)+((($3$1)|0)*4294967296))/((($5$0)>>>0)+((($5$1)|0)*4294967296))))/4294967296), 4294967295);
  var $7$0=$6$0;
  var $7=$7$0;
  STACKTOP = __stackBase__;
  return $7;
}


function __ZL13div_64x32_remxiPi($a$0, $a$1, $b, $remainder) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  var $st$3$0=(($1)|0);
  HEAP32[(($st$3$0)>>2)]=$a$0;
  var $st$3$1=(($1+4)|0);
  HEAP32[(($st$3$1)>>2)]=$a$1;
  $2=$b;
  $3=$remainder;
  var $st$9$0=(($1)|0);
  var $4$0=HEAP32[(($st$9$0)>>2)];
  var $st$9$1=(($1+4)|0);
  var $4$1=HEAP32[(($st$9$1)>>2)];
  var $5=$2;
  var $6$0=$5;
  var $6$1=(($5|0) < 0 ? -1 : 0);
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$0;
  var $8=$8$0;
  var $9=$3;
  HEAP32[(($9)>>2)]=$8;
  var $st$21$0=(($1)|0);
  var $10$0=HEAP32[(($st$21$0)>>2)];
  var $st$21$1=(($1+4)|0);
  var $10$1=HEAP32[(($st$21$1)>>2)];
  var $11=$2;
  var $12$0=$11;
  var $12$1=(($11|0) < 0 ? -1 : 0);
  var $13$0 = (tempBigIntR=((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $13$1 = Math.min(Math.floor(((tempBigIntR=((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $14$0=$13$0;
  var $14=$14$0;
  STACKTOP = __stackBase__;
  return $14;
}


function __ZL14divu_64x32_remyjPj3844($a$0, $a$1, $b, $remainder) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  var $st$3$0=(($1)|0);
  HEAP32[(($st$3$0)>>2)]=$a$0;
  var $st$3$1=(($1+4)|0);
  HEAP32[(($st$3$1)>>2)]=$a$1;
  $2=$b;
  $3=$remainder;
  var $st$9$0=(($1)|0);
  var $4$0=HEAP32[(($st$9$0)>>2)];
  var $st$9$1=(($1+4)|0);
  var $4$1=HEAP32[(($st$9$1)>>2)];
  var $5=$2;
  var $6$0=$5;
  var $6$1=0;
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))%((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$0;
  var $8=$8$0;
  var $9=$3;
  HEAP32[(($9)>>2)]=$8;
  var $st$21$0=(($1)|0);
  var $10$0=HEAP32[(($st$21$0)>>2)];
  var $st$21$1=(($1+4)|0);
  var $10$1=HEAP32[(($st$21$1)>>2)];
  var $11=$2;
  var $12$0=$11;
  var $12$1=0;
  var $13$0 = Math.floor(((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296)))>>>0; var $13$1 = Math.min(Math.floor((Math.floor(((($10$0)>>>0)+((($10$1)|0)*4294967296))/((($12$0)>>>0)+((($12$1)|0)*4294967296))))/4294967296), 4294967295);
  var $14$0=$13$0;
  var $14=$14$0;
  STACKTOP = __stackBase__;
  return $14;
}


function __ZL9mod_64x32xi($a$0, $a$1, $b) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $st$2$0=(($1)|0);
  HEAP32[(($st$2$0)>>2)]=$a$0;
  var $st$2$1=(($1+4)|0);
  HEAP32[(($st$2$1)>>2)]=$a$1;
  $2=$b;
  var $st$7$0=(($1)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($1+4)|0);
  var $3$1=HEAP32[(($st$7$1)>>2)];
  var $4=$2;
  var $5$0=$4;
  var $5$1=(($4|0) < 0 ? -1 : 0);
  var $6$0 = ((($3$0)>>>0)+((($3$1)|0)*4294967296))%((($5$0)>>>0)+((($5$1)|0)*4294967296))>>>0; var $6$1 = Math.min(Math.floor((((($3$0)>>>0)+((($3$1)|0)*4294967296))%((($5$0)>>>0)+((($5$1)|0)*4294967296)))/4294967296), 4294967295);
  var $7$0=$6$0;
  var $7=$7$0;
  STACKTOP = __stackBase__;
  return $7;
}


function __ZL10modu_64x32yj($a$0, $a$1, $b) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $st$2$0=(($1)|0);
  HEAP32[(($st$2$0)>>2)]=$a$0;
  var $st$2$1=(($1+4)|0);
  HEAP32[(($st$2$1)>>2)]=$a$1;
  $2=$b;
  var $st$7$0=(($1)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($1+4)|0);
  var $3$1=HEAP32[(($st$7$1)>>2)];
  var $4=$2;
  var $5$0=$4;
  var $5$1=0;
  var $6$0 = ((($3$0)>>>0)+((($3$1)|0)*4294967296))%((($5$0)>>>0)+((($5$1)|0)*4294967296))>>>0; var $6$1 = Math.min(Math.floor((((($3$0)>>>0)+((($3$1)|0)*4294967296))%((($5$0)>>>0)+((($5$1)|0)*4294967296)))/4294967296), 4294967295);
  var $7$0=$6$0;
  var $7=$7$0;
  STACKTOP = __stackBase__;
  return $7;
}


function __ZNK11device_list5firstIK22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceIK22device_sound_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8device_t9interfaceIK22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_sound_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12region_entryC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12region_entryC2Ev($2);
  ;
  return;
}


function __ZN12region_entryC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN7astringC1Ev($3);
  var $4=(($2+64)|0);
  HEAP32[(($4)>>2)]=0;
  ;
  return;
}


function __ZL18atomic_increment32PVi($ptr) {
  ;
  var __label__;

  var $1;
  $1=$ptr;
  var $2=$1;
  var $3=__ZL12atomic_add32PVii($2, 1);
  ;
  return $3;
}


function __ZL18atomic_decrement32PVi($ptr) {
  ;
  var __label__;

  var $1;
  $1=$ptr;
  var $2=$1;
  var $3=__ZL12atomic_add32PVii($2, -1);
  ;
  return $3;
}


function __ZL13debugger_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $entryptr;
      var $deleteme;
      $1=$machine;
      $entryptr=__ZL12machine_list;
      __label__ = 1; break;
    case 1: // $2
      var $3=$entryptr;
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $6
      var $7=$entryptr;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=(($10)|0)==(($11)|0);
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$entryptr;
      var $15=HEAP32[(($14)>>2)];
      $deleteme=$15;
      var $16=$deleteme;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$entryptr;
      HEAP32[(($19)>>2)]=$18;
      var $20=$deleteme;
      var $21=$20;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $21);
      __label__ = 6; break;
    case 4: // $22
      __label__ = 5; break;
    case 5: // $23
      var $24=$entryptr;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0);
      $entryptr=$26;
      __label__ = 1; break;
    case 6: // $27
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12region_arrayC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      var $6=(($5)|0);
      var $7=(($6+17408)|0);
      var $9 = $6;__label__ = 1; break;
    case 1: // $8
      var $9;
      (function() { try { __THREW__ = false; return __ZN12region_entryC1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(($9+68)|0);
      var $12=(($11)|0)==(($7)|0);
      if ($12) { __label__ = 3; break; } else { var $9 = $11;__label__ = 1; break; }
    case 3: // $13
      ;
      return;
    case 4: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $2=$16;
      var $17=$15.f1;
      $3=$17;
      var $18=(($6)|0)==(($9)|0);
      if ($18) { __label__ = 7; break; } else { var $20 = $9;__label__ = 5; break; }
    case 5: // $19
      var $20;
      var $21=(($20-68)|0);
      (function() { try { __THREW__ = false; return __ZN12region_entryD1Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $22
      var $23=(($21)|0)==(($6)|0);
      if ($23) { __label__ = 7; break; } else { var $20 = $21;__label__ = 5; break; }
    case 7: // $24
      __label__ = 8; break;
    case 8: // $25
      var $26=$2;
      var $27=$2;
      var $28=$3;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13debugger_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i1=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $result_i=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14;
      var $entry;
      var $15;
      var $16;
      var $17=__stackBase__+60;
      $14=$machine;
      var $18=$14;
      var $19=(($18+584)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20 & 1;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 1; break; } else { __label__ = 24; break; }
    case 1: // $23
      var $24=$14;
      var $25=__ZN15running_machine7respoolEv($24);
      var $26=$9;
      var $27=$10;
      var $28=$11;
      var $29=$result_i;
      var $30=$12;
      var $31=$13;
      HEAP32[(($9)>>2)]=8;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str3845)|0);
      HEAP32[(($11)>>2)]=71;
      var $32=HEAP32[(($9)>>2)];
      var $33=HEAP32[(($10)>>2)];
      var $34=HEAP32[(($11)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($12)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($13)>>2)]=$45;
      var $46=HEAP32[(($13)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $48
      var $49=HEAP32[(($12)>>2)];
      ___cxa_call_unexpected($49);
      throw "Reached an unreachable!"
    case 6: // $50
      var $51=HEAP32[(($12)>>2)];
      var $52=HEAP32[(($12)>>2)];
      var $53=HEAP32[(($13)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $56
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$9;
      var $59=$10;
      var $60=$11;
      var $61=$result_i;
      var $62=$12;
      var $63=$13;
      var $64=$57;
      var $65=$14;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18debug_view_managerC1ER15running_machine]($64, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 18; break; }
    case 9: // $66
      var $67=__ZN13resource_pool10add_objectI18debug_view_managerEEPT_S3_($25, $64);
      var $68=$14;
      var $69=(($68+1296)|0);
      HEAP32[(($69)>>2)]=$67;
      var $70=$14;
      __Z14debug_cpu_initR15running_machine($70);
      var $71=$14;
      __Z18debug_command_initR15running_machine($71);
      var $72=$14;
      __Z18debug_console_initR15running_machine($72);
      var $73=$14;
      __Z13debugint_initR15running_machine($73);
      var $74=$14;
      var $75=$14;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($17, 926, ((STRING_TABLE.__str13846)|0), $75);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($74, 4, $17);
      var $76=$4;
      var $77=$5;
      var $78=$6;
      var $79=$result_i1;
      var $80=$7;
      var $81=$8;
      HEAP32[(($4)>>2)]=8;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3845)|0);
      HEAP32[(($6)>>2)]=81;
      var $82=HEAP32[(($4)>>2)];
      var $83=HEAP32[(($5)>>2)];
      var $84=HEAP32[(($6)>>2)];
      var $85=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($82, $83, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $86
      HEAP32[(($result_i1)>>2)]=$85;
      var $87=HEAP32[(($result_i1)>>2)];
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $89
      var $90=___cxa_allocate_exception(4);
      var $91=$90;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($91);
      (function() { try { __THREW__ = false; return ___cxa_throw($90, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $94=$93.f0;
      HEAP32[(($7)>>2)]=$94;
      var $95=$93.f1;
      HEAP32[(($8)>>2)]=$95;
      var $96=HEAP32[(($8)>>2)];
      var $97=(($96)|0) < 0;
      if ($97) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $98
      var $99=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($99);
      throw "Reached an unreachable!"
    case 14: // $100
      var $101=HEAP32[(($7)>>2)];
      var $102=HEAP32[(($7)>>2)];
      var $103=HEAP32[(($8)>>2)];
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $106
      throw "Reached an unreachable!"
    case 16: // $_ZnwjPKci_exit2
      var $107=HEAP32[(($result_i1)>>2)];
      var $108=$4;
      var $109=$5;
      var $110=$6;
      var $111=$result_i1;
      var $112=$7;
      var $113=$8;
      var $114=$107;
      var $115=__ZN13resource_pool10add_objectI14_machine_entryEEPT_S3_(_global_resource_pool, $114);
      $entry=$115;
      var $116=HEAP32[((__ZL12machine_list)>>2)];
      var $117=$entry;
      var $118=(($117)|0);
      HEAP32[(($118)>>2)]=$116;
      var $119=$14;
      var $120=$entry;
      var $121=(($120+4)|0);
      HEAP32[(($121)>>2)]=$119;
      var $122=$entry;
      HEAP32[((__ZL12machine_list)>>2)]=$122;
      var $123=HEAP32[((__ZL17atexit_registered)>>2)];
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 23; break; } else { __label__ = 17; break; }
    case 17: // $125
      var $126=_atexit(928);
      __label__ = 23; break;
    case 18: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      $15=$129;
      var $130=$128.f1;
      $16=$130;
      var $131=$1;
      var $132=$2;
      var $133=$3;
      HEAP32[(($1)>>2)]=$57;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3845)|0);
      HEAP32[(($3)>>2)]=71;
      var $134=HEAP32[(($1)>>2)];
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $136
      var $137=HEAP32[(($1)>>2)];
      var $138=HEAP32[(($2)>>2)];
      var $139=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($137, $138, $139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $_noexc
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $140=$1;
      var $141=$2;
      var $142=$3;
      __label__ = 22; break;
    case 22: // $143
      __label__ = 25; break;
    case 23: // $144
      HEAP32[((__ZL17atexit_registered)>>2)]=1;
      var $145=$14;
      __ZN15running_machine21add_logerror_callbackEPFvRS_PKcE($145, 930);
      var $146=$14;
      var $147=__ZNK15running_machine3osdEv($146);
      var $148=$147;
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+16)|0);
      var $151=HEAP32[(($150)>>2)];
      FUNCTION_TABLE[$151]($147);
      __label__ = 24; break;
    case 24: // $152
      STACKTOP = __stackBase__;
      return;
    case 25: // $153
      var $154=$15;
      var $155=$15;
      var $156=$16;
      var $157=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $155, tempValue);
      var $158=($157.f1 = $156, $157);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $159
      var $160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13debugger_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI18debug_view_managerEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18debug_view_managerEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18debug_view_managerEEPT_S3_["X"]=1;

function __Z42debugger_flush_all_traces_on_abnormal_exitv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $deleteme;
      __label__ = 1; break;
    case 1: // $1
      var $2=HEAP32[((__ZL12machine_list)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $4
      var $5=HEAP32[((__ZL12machine_list)>>2)];
      $deleteme=$5;
      var $6=$deleteme;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      __Z22debug_cpu_flush_tracesR15running_machine($8);
      var $9=$deleteme;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      HEAP32[((__ZL12machine_list)>>2)]=$11;
      var $12=$deleteme;
      var $13=$12;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $13);
      __label__ = 1; break;
    case 3: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z24debugger_refresh_displayR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=__ZNK15running_machine5videoEv($2);
  __ZN13video_manager12frame_updateEb($3, 1);
  ;
  return;
}


function __ZN20resource_pool_objectI14_machine_entryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14_machine_entryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14_machine_entryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14_machine_entryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14_machine_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14_machine_entryED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI18debug_view_managerEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18debug_view_managerEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18debug_view_managerEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18debug_view_managerE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18debug_view_managerED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18debug_view_managerED2Ev($2);
  ;
  return;
}


function __ZNK11emu_options10media_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str473898)|0));
  ;
  return $4;
}


function __ZN13resource_pool10add_objectI14_machine_entryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14_machine_entryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14_machine_entryEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI14_machine_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14_machine_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14_machine_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI14_machine_entryED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI14_machine_entryE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18debug_view_managerED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18debug_view_managerED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18debug_view_managerED0Ev["X"]=1;

function __ZN20resource_pool_objectI18debug_view_managerED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI18debug_view_managerE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18debug_view_managerD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18debug_view_managerED2Ev["X"]=1;

function __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($options, $location, $ext, $romp, $image_file) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $filerr;
      $9=$options;
      $10=$location;
      $11=$ext;
      $12=$romp;
      $13=$image_file;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($6)>>2)]=88;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$9;
      var $56=(function() { try { __THREW__ = false; return __ZNK11emu_options10media_pathEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $57
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($54, $56, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $58
      var $59=__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_(_global_resource_pool, $54);
      var $60=$13;
      HEAP32[(($60)>>2)]=$59;
      var $61=$10;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $63
      var $64=$10;
      var $65=_strcmp($64, ((__str13852)|0));
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $67
      var $68=$13;
      var $69=HEAP32[(($68)>>2)];
      var $70=$10;
      var $71=$12;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$11;
      var $75=__ZN8emu_file4openEPKcS1_S1_S1_($69, $70, ((STRING_TABLE.__str23853)|0), $73, $74);
      $filerr=$75;
      __label__ = 18; break;
    case 12: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $14=$78;
      var $79=$77.f1;
      $15=$79;
      var $80=$1;
      var $81=$2;
      var $82=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($3)>>2)]=88;
      var $83=HEAP32[(($1)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $85
      var $86=HEAP32[(($1)>>2)];
      var $87=HEAP32[(($2)>>2)];
      var $88=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($86, $87, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 22; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $89=$1;
      var $90=$2;
      var $91=$3;
      __label__ = 16; break;
    case 16: // $92
      __label__ = 21; break;
    case 17: // $93
      var $94=$13;
      var $95=HEAP32[(($94)>>2)];
      var $96=$12;
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$11;
      var $100=__ZN8emu_file4openEPKcS1_($95, $98, $99);
      $filerr=$100;
      __label__ = 18; break;
    case 18: // $101
      var $102=$filerr;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $104
      var $105=$13;
      var $106=HEAP32[(($105)>>2)];
      var $107=$106;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $107);
      var $108=$13;
      HEAP32[(($108)>>2)]=0;
      __label__ = 20; break;
    case 20: // $109
      var $110=$filerr;
      STACKTOP = __stackBase__;
      return $110;
    case 21: // $111
      var $112=$14;
      var $113=$14;
      var $114=$15;
      var $115=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $113, tempValue);
      var $116=($115.f1 = $114, $115);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file["X"]=1;

function __Z15rom_next_regionPK9rom_entry($romp) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$romp;
      var $2=$1;
      var $3=(($2+20)|0);
      $1=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$1;
      var $6=(($5+16)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & 15;
      var $9=(($8)|0)==1;
      if ($9) { var $17 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 & 15;
      var $15=(($14)|0)==2;
      var $17 = $15;__label__ = 3; break;
    case 3: // $16
      var $17;
      var $18=$17 ^ 1;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$1;
      var $21=(($20+20)|0);
      $1=$21;
      __label__ = 1; break;
    case 5: // $22
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25 & 15;
      var $27=(($26)|0)==2;
      if ($27) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $28
      var $32 = 0;__label__ = 8; break;
    case 7: // $29
      var $30=$1;
      var $32 = $30;__label__ = 8; break;
    case 8: // $31
      var $32;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14rom_first_filePK9rom_entry($romp) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$romp;
      var $2=$1;
      var $3=(($2+20)|0);
      $1=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$1;
      var $6=(($5+16)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & 15;
      var $9=(($8)|0)==0;
      if ($9) { var $26 = 0;__label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 & 15;
      var $15=(($14)|0)==1;
      if ($15) { var $23 = 1;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 15;
      var $21=(($20)|0)==2;
      var $23 = $21;__label__ = 4; break;
    case 4: // $22
      var $23;
      var $24=$23 ^ 1;
      var $26 = $24;__label__ = 5; break;
    case 5: // $25
      var $26;
      if ($26) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $27
      var $28=$1;
      var $29=(($28+20)|0);
      $1=$29;
      __label__ = 1; break;
    case 7: // $30
      var $31=$1;
      var $32=(($31+16)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33 & 15;
      var $35=(($34)|0)==1;
      if ($35) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $36
      var $37=$1;
      var $38=(($37+16)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39 & 15;
      var $41=(($40)|0)==2;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      var $46 = 0;__label__ = 11; break;
    case 10: // $43
      var $44=$1;
      var $46 = $44;__label__ = 11; break;
    case 11: // $45
      var $46;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14rom_first_filePK9rom_entry["X"]=1;

function __Z13rom_next_filePK9rom_entry($romp) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$romp;
      var $2=$1;
      var $3=(($2+20)|0);
      $1=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$1;
      var $6=(($5+16)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & 15;
      var $9=(($8)|0)==0;
      if ($9) { var $26 = 0;__label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 & 15;
      var $15=(($14)|0)==1;
      if ($15) { var $23 = 1;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 15;
      var $21=(($20)|0)==2;
      var $23 = $21;__label__ = 4; break;
    case 4: // $22
      var $23;
      var $24=$23 ^ 1;
      var $26 = $24;__label__ = 5; break;
    case 5: // $25
      var $26;
      if ($26) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $27
      var $28=$1;
      var $29=(($28+20)|0);
      $1=$29;
      __label__ = 1; break;
    case 7: // $30
      var $31=$1;
      var $32=(($31+16)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33 & 15;
      var $35=(($34)|0)==1;
      if ($35) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $36
      var $37=$1;
      var $38=(($37+16)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39 & 15;
      var $41=(($40)|0)==2;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      var $46 = 0;__label__ = 11; break;
    case 10: // $43
      var $44=$1;
      var $46 = $44;__label__ = 11; break;
    case 11: // $45
      var $46;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13rom_next_filePK9rom_entry["X"]=1;

function __Z13rom_file_sizePK9rom_entry($romp) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $maxlength;
      var $curlength;
      $1=$romp;
      $maxlength=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+20)|0);
      $1=$4;
      var $5=(($3+12)|0);
      var $6=HEAP32[(($5)>>2)];
      $curlength=$6;
      __label__ = 2; break;
    case 2: // $7
      var $8=$1;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 15;
      var $12=(($11)|0)==4;
      if ($12) { var $20 = 1;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$1;
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 15;
      var $18=(($17)|0)==8;
      var $20 = $18;__label__ = 4; break;
    case 4: // $19
      var $20;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=$1;
      var $23=(($22+20)|0);
      $1=$23;
      var $24=(($22+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$curlength;
      var $27=(($26+$25)|0);
      $curlength=$27;
      __label__ = 2; break;
    case 6: // $28
      var $29=$maxlength;
      var $30=$curlength;
      var $31=(($29)>>>0) > (($30)>>>0);
      var $32=$maxlength;
      var $33=$curlength;
      var $34=$31 ? $32 : $33;
      $maxlength=$34;
      __label__ = 7; break;
    case 7: // $35
      var $36=$1;
      var $37=(($36+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38 & 15;
      var $40=(($39)|0)==3;
      if ($40) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 8: // $41
      var $42=$maxlength;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13rom_file_sizePK9rom_entry["X"]=1;

function __Z15get_disk_handleR15running_machinePKc($machine, $region) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curdisk;
      $2=$machine;
      $3=$region;
      var $4=$2;
      var $5=(($4+636)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+40)|0);
      var $8=HEAP32[(($7)>>2)];
      $curdisk=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$curdisk;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=$curdisk;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=_strcmp($15, $16);
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $19
      var $20=$curdisk;
      var $21=(($20+16)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=$curdisk;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $33 = $27;__label__ = 6; break;
    case 5: // $28
      var $29=$curdisk;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $33 = $31;__label__ = 6; break;
    case 6: // $32
      var $33;
      $1=$33;
      __label__ = 10; break;
    case 7: // $34
      __label__ = 8; break;
    case 8: // $35
      var $36=$curdisk;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      $curdisk=$38;
      __label__ = 1; break;
    case 9: // $39
      $1=0;
      __label__ = 10; break;
    case 10: // $40
      var $41=$1;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16rom_first_sourceRK14machine_config($config) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $device;
      $2=$config;
      var $3=$2;
      var $4=__ZNK14machine_config10devicelistEv($3);
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $device=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$device;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$device;
      var $12=__ZNK8device_t10rom_regionEv($11);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$device;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$device;
      var $19=__ZNK8device_t4nextEv($18);
      $device=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15rom_next_sourceRK8device_t($previous) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $device;
      $2=$previous;
      var $3=$2;
      var $4=__ZNK8device_t4nextEv($3);
      $device=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$device;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$device;
      var $10=__ZNK8device_t10rom_regionEv($9);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$device;
      $1=$13;
      __label__ = 7; break;
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      var $16=$device;
      var $17=__ZNK8device_t4nextEv($16);
      $device=$17;
      __label__ = 1; break;
    case 6: // $18
      $1=0;
      __label__ = 7; break;
    case 7: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16rom_first_regionRK8device_t($source) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $romp;
      $1=$source;
      var $2=$1;
      var $3=__ZNK8device_t10rom_regionEv($2);
      $romp=$3;
      var $4=$romp;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$romp;
      var $8=(($7+16)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9 & 15;
      var $11=(($10)|0)==2;
      if ($11) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      var $13=$romp;
      var $16 = $13;__label__ = 4; break;
    case 3: // $14
      var $16 = 0;__label__ = 4; break;
    case 4: // $15
      var $16;
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15rom_region_nameR7astringPK11game_driverPK8device_tPK9rom_entry($result, $drv, $source, $romp) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$result;
  $2=$drv;
  $3=$source;
  $4=$romp;
  var $5=$3;
  var $6=$1;
  var $7=$4;
  var $8=(($7)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZNK8device_t6subtagER7astringPKc($5, $6, $9);
  ;
  return $10;
}


function __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($options, $location, $has_crc, $crc, $romp, $image_file) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      var $filerr;
      $9=$options;
      $10=$location;
      var $17=(($has_crc)&1);
      $11=$17;
      $12=$crc;
      $13=$romp;
      $14=$image_file;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      var $21=$result_i;
      var $22=$7;
      var $23=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($6)>>2)]=106;
      var $24=HEAP32[(($4)>>2)];
      var $25=HEAP32[(($5)>>2)];
      var $26=HEAP32[(($6)>>2)];
      var $27=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $28
      HEAP32[(($result_i)>>2)]=$27;
      var $29=HEAP32[(($result_i)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $31
      var $32=___cxa_allocate_exception(4);
      var $33=$32;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33);
      (function() { try { __THREW__ = false; return ___cxa_throw($32, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      HEAP32[(($7)>>2)]=$36;
      var $37=$35.f1;
      HEAP32[(($8)>>2)]=$37;
      var $38=HEAP32[(($8)>>2)];
      var $39=(($38)|0) < 0;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($41);
      throw "Reached an unreachable!"
    case 5: // $42
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($8)>>2)];
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $48
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $49=HEAP32[(($result_i)>>2)];
      var $50=$4;
      var $51=$5;
      var $52=$6;
      var $53=$result_i;
      var $54=$7;
      var $55=$8;
      var $56=$49;
      var $57=$9;
      var $58=(function() { try { __THREW__ = false; return __ZNK11emu_options10media_pathEv($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $59
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($56, $58, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $60
      var $61=__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_(_global_resource_pool, $56);
      var $62=$14;
      HEAP32[(($62)>>2)]=$61;
      var $63=$11;
      var $64=(($63) & 1);
      if ($64) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $65
      var $66=$14;
      var $67=HEAP32[(($66)>>2)];
      var $68=$10;
      var $69=$13;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$12;
      var $73=__ZN8emu_file4openEPKcS1_S1_j($67, $68, ((STRING_TABLE.__str23853)|0), $71, $72);
      $filerr=$73;
      __label__ = 17; break;
    case 11: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $15=$76;
      var $77=$75.f1;
      $16=$77;
      var $78=$1;
      var $79=$2;
      var $80=$3;
      HEAP32[(($1)>>2)]=$49;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($3)>>2)]=106;
      var $81=HEAP32[(($1)>>2)];
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $83
      var $84=HEAP32[(($1)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 21; break; }
    case 13: // $_noexc
      __label__ = 14; break;
    case 14: // $_ZdlPvPKci_exit
      var $87=$1;
      var $88=$2;
      var $89=$3;
      __label__ = 15; break;
    case 15: // $90
      __label__ = 20; break;
    case 16: // $91
      var $92=$14;
      var $93=HEAP32[(($92)>>2)];
      var $94=$10;
      var $95=$13;
      var $96=(($95)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=__ZN8emu_file4openEPKcS1_S1_($93, $94, ((STRING_TABLE.__str23853)|0), $97);
      $filerr=$98;
      __label__ = 17; break;
    case 17: // $99
      var $100=$filerr;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $102
      var $103=$14;
      var $104=HEAP32[(($103)>>2)];
      var $105=$104;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $105);
      var $106=$14;
      HEAP32[(($106)>>2)]=0;
      __label__ = 19; break;
    case 19: // $107
      var $108=$filerr;
      STACKTOP = __stackBase__;
      return $108;
    case 20: // $109
      var $110=$15;
      var $111=$15;
      var $112=$16;
      var $113=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $111, tempValue);
      var $114=($113.f1 = $112, $113);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file["X"]=1;

function __ZL15add_disk_handleR15running_machineP9_open_chd($machine, $chd) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $romload_data;
      $6=$machine;
      $7=$chd;
      var $8=$6;
      var $9=(($8+636)|0);
      var $10=HEAP32[(($9)>>2)];
      $romload_data=$10;
      var $11=$6;
      var $12=__ZN15running_machine7respoolEv($11);
      var $13=$1;
      var $14=$2;
      var $15=$3;
      var $16=$result_i;
      var $17=$4;
      var $18=$5;
      HEAP32[(($1)>>2)]=24;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($3)>>2)]=152;
      var $19=HEAP32[(($1)>>2)];
      var $20=HEAP32[(($2)>>2)];
      var $21=HEAP32[(($3)>>2)];
      var $22=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($19, $20, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $23
      HEAP32[(($result_i)>>2)]=$22;
      var $24=HEAP32[(($result_i)>>2)];
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $26
      var $27=___cxa_allocate_exception(4);
      var $28=$27;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($28);
      (function() { try { __THREW__ = false; return ___cxa_throw($27, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      HEAP32[(($4)>>2)]=$31;
      var $32=$30.f1;
      HEAP32[(($5)>>2)]=$32;
      var $33=HEAP32[(($5)>>2)];
      var $34=(($33)|0) < 0;
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($36);
      throw "Reached an unreachable!"
    case 5: // $37
      var $38=HEAP32[(($4)>>2)];
      var $39=HEAP32[(($4)>>2)];
      var $40=HEAP32[(($5)>>2)];
      var $41=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $39, tempValue);
      var $42=($41.f1 = $40, $41);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $43
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $44=HEAP32[(($result_i)>>2)];
      var $45=$1;
      var $46=$2;
      var $47=$3;
      var $48=$result_i;
      var $49=$4;
      var $50=$5;
      var $51=$44;
      var $52=__ZN13resource_pool10add_objectI9_open_chdEEPT_S3_($12, $51);
      var $53=$romload_data;
      var $54=(($53+44)|0);
      var $55=HEAP32[(($54)>>2)];
      HEAP32[(($55)>>2)]=$52;
      var $56=$romload_data;
      var $57=(($56+44)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=HEAP32[(($58)>>2)];
      var $60=$7;
      var $61=$59;
      var $62=$60;
      assert(24 % 1 === 0, 'memcpy given ' + 24 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($61)>>2)]=HEAP32[(($62)>>2)];HEAP32[(($61+4)>>2)]=HEAP32[(($62+4)>>2)];HEAP32[(($61+8)>>2)]=HEAP32[(($62+8)>>2)];HEAP32[(($61+12)>>2)]=HEAP32[(($62+12)>>2)];HEAP32[(($61+16)>>2)]=HEAP32[(($62+16)>>2)];HEAP32[(($61+20)>>2)]=HEAP32[(($62+20)>>2)];
      var $63=$romload_data;
      var $64=(($63+44)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0);
      var $68=$romload_data;
      var $69=(($68+44)|0);
      HEAP32[(($69)>>2)]=$67;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15add_disk_handleR15running_machineP9_open_chd["X"]=1;

function __Z15open_disk_imageR11emu_optionsPK11game_driverPK9rom_entryPP8emu_filePP9_chd_filePKc($options, $gamedrv, $romp, $image_file, $image_chd, $locationtag) {
  var __stackBase__  = STACKTOP; STACKTOP += 1028; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $region;
      var $rom;
      var $source;
      var $filerr;
      var $err;
      var $searchdrv;
      var $tag1=__stackBase__;
      var $tag2=__stackBase__+64;
      var $8;
      var $9;
      var $tag3=__stackBase__+128;
      var $tag4=__stackBase__+192;
      var $tag5=__stackBase__+256;
      var $is_list;
      var $has_parent;
      var $separator1;
      var $separator2;
      var $swlist=__stackBase__+320;
      var $romphashes=__stackBase__+384;
      var $drv;
      var $config=__stackBase__+468;
      var $10=__stackBase__+944;
      var $11;
      var $searchdrv1;
      var $12;
      $2=$options;
      $3=$gamedrv;
      $4=$romp;
      $5=$image_file;
      $6=$image_chd;
      $7=$locationtag;
      var $13=$5;
      HEAP32[(($13)>>2)]=0;
      var $14=$6;
      HEAP32[(($14)>>2)]=0;
      $filerr=3;
      var $15=$3;
      var $16=__ZN11driver_list4findERK11game_driver($15);
      $searchdrv=$16;
      __label__ = 1; break;
    case 1: // $17
      var $18=$searchdrv;
      var $19=(($18)|0)!=-1;
      if ($19) { __label__ = 2; break; } else { var $24 = 0;__label__ = 3; break; }
    case 2: // $20
      var $21=$filerr;
      var $22=(($21)|0)!=0;
      var $24 = $22;__label__ = 3; break;
    case 3: // $23
      var $24;
      if ($24) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $25
      var $26=$2;
      var $27=$searchdrv;
      var $28=__ZN11driver_list6driverEi($27);
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$4;
      var $32=$5;
      var $33=__Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($26, $30, ((STRING_TABLE.__str33854)|0), $31, $32);
      $filerr=$33;
      __label__ = 5; break;
    case 5: // $34
      var $35=$searchdrv;
      var $36=__ZN11driver_list5cloneEi($35);
      $searchdrv=$36;
      __label__ = 1; break;
    case 6: // $37
      var $38=$filerr;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      var $41=$2;
      var $42=$4;
      var $43=$5;
      var $44=__Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($41, 0, ((STRING_TABLE.__str33854)|0), $42, $43);
      $filerr=$44;
      __label__ = 8; break;
    case 8: // $45
      var $46=$filerr;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 9; break; } else { __label__ = 103; break; }
    case 9: // $48
      var $49=$7;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 10; break; } else { __label__ = 103; break; }
    case 10: // $51
      var $52=$7;
      __ZN7astringC1EPKc($tag1, $52);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 28; break; }
    case 11: // $53
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 29; break; }
    case 12: // $54
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 30; break; }
    case 13: // $55
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 31; break; }
    case 14: // $56
      $is_list=0;
      $has_parent=0;
      var $57=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag1, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 32; break; };
    case 15: // $58
      $separator1=$57;
      var $59=$separator1;
      var $60=(($59)|0)!=-1;
      if ($60) { __label__ = 16; break; } else { __label__ = 46; break; }
    case 16: // $61
      $is_list=1;
      var $62=$separator1;
      var $63=(($62+1)|0);
      var $64=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 32; break; };
    case 17: // $65
      var $66=$separator1;
      var $67=(($64-$66)|0);
      var $68=(($67+1)|0);
      var $69=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($tag4, $tag1, $63, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 32; break; };
    case 18: // $70
      var $71=$separator1;
      var $72=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 32; break; };
    case 19: // $73
      var $74=$separator1;
      var $75=(($72-$74)|0);
      var $76=(function() { try { __THREW__ = false; return __ZN7astring3delEii($tag1, $71, $75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 32; break; };
    case 20: // $77
      var $78=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tag1, ((STRING_TABLE.__str23853)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 32; break; };
    case 21: // $79
      var $80=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag4, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 32; break; };
    case 22: // $81
      $separator2=$80;
      var $82=$separator2;
      var $83=(($82)|0)!=-1;
      if ($83) { __label__ = 23; break; } else { __label__ = 33; break; }
    case 23: // $84
      $has_parent=1;
      var $85=$separator2;
      var $86=(($85+1)|0);
      var $87=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 32; break; };
    case 24: // $88
      var $89=$separator2;
      var $90=(($87-$89)|0);
      var $91=(($90+1)|0);
      var $92=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($tag5, $tag4, $86, $91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 32; break; };
    case 25: // $93
      var $94=$separator2;
      var $95=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 32; break; };
    case 26: // $96
      var $97=$separator2;
      var $98=(($95-$97)|0);
      var $99=(function() { try { __THREW__ = false; return __ZN7astring3delEii($tag4, $94, $98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 32; break; };
    case 27: // $100
      __label__ = 33; break;
    case 28: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $103=$102.f0;
      $8=$103;
      var $104=$102.f1;
      $9=$104;
      __label__ = 101; break;
    case 29: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $107=$106.f0;
      $8=$107;
      var $108=$106.f1;
      $9=$108;
      __label__ = 99; break;
    case 30: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $8=$111;
      var $112=$110.f1;
      $9=$112;
      __label__ = 97; break;
    case 31: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $8=$115;
      var $116=$114.f1;
      $9=$116;
      __label__ = 95; break;
    case 32: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      $8=$119;
      var $120=$118.f1;
      $9=$120;
      __label__ = 93; break;
    case 33: // $121
      var $122=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 32; break; };
    case 34: // $123
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($swlist, $122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 32; break; }
    case 35: // $124
      var $125=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($swlist, $tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 42; break; };
    case 36: // $126
      var $127=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($tag2, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 42; break; };
    case 37: // $128
      var $129=$has_parent;
      var $130=(($129) & 1);
      if ($130) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $131
      var $132=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($swlist, $tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 42; break; };
    case 39: // $133
      var $134=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($swlist, $tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; };
    case 40: // $135
      var $136=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($tag3, $134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 42; break; };
    case 41: // $137
      __label__ = 43; break;
    case 42: // $138
      var $139=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $140=$139.f0;
      $8=$140;
      var $141=$139.f1;
      $9=$141;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($swlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 182; break; }
    case 43: // $142
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($swlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 32; break; }
    case 44: // $143
      __label__ = 46; break;
    case 45: // $144
      __label__ = 93; break;
    case 46: // $145
      var $146=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag5, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 32; break; };
    case 47: // $147
      var $148=(($146)|0)!=-1;
      if ($148) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $149
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str43855)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 32; break; }
    case 49: // $150
      throw "Reached an unreachable!"
    case 50: // $151
      var $152=$is_list;
      var $153=(($152) & 1);
      if ($153) { __label__ = 53; break; } else { __label__ = 51; break; }
    case 51: // $154
      var $155=$2;
      var $156=$7;
      var $157=$4;
      var $158=$5;
      var $159=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($155, $156, ((STRING_TABLE.__str33854)|0), $157, $158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 32; break; };
    case 52: // $160
      $filerr=$159;
      __label__ = 88; break;
    case 53: // $161
      var $162=$filerr;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 54; break; } else { __label__ = 59; break; }
    case 54: // $164
      var $165=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 32; break; };
    case 55: // $166
      var $167=(($165)|0)!=0;
      if ($167) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $168
      var $169=$2;
      var $170=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 32; break; };
    case 57: // $171
      var $172=$4;
      var $173=$5;
      var $174=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($169, $170, ((STRING_TABLE.__str33854)|0), $172, $173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 32; break; };
    case 58: // $175
      $filerr=$174;
      __label__ = 59; break;
    case 59: // $176
      var $177=$filerr;
      var $178=(($177)|0)!=0;
      if ($178) { __label__ = 60; break; } else { __label__ = 66; break; }
    case 60: // $179
      var $180=$has_parent;
      var $181=(($180) & 1);
      if ($181) { __label__ = 61; break; } else { __label__ = 66; break; }
    case 61: // $182
      var $183=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 32; break; };
    case 62: // $184
      var $185=(($183)|0)!=0;
      if ($185) { __label__ = 63; break; } else { __label__ = 66; break; }
    case 63: // $186
      var $187=$2;
      var $188=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 32; break; };
    case 64: // $189
      var $190=$4;
      var $191=$5;
      var $192=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($187, $188, ((STRING_TABLE.__str33854)|0), $190, $191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 32; break; };
    case 65: // $193
      $filerr=$192;
      __label__ = 66; break;
    case 66: // $194
      var $195=$filerr;
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 67; break; } else { __label__ = 72; break; }
    case 67: // $197
      var $198=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 32; break; };
    case 68: // $199
      var $200=(($198)|0)!=0;
      if ($200) { __label__ = 69; break; } else { __label__ = 72; break; }
    case 69: // $201
      var $202=$2;
      var $203=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 32; break; };
    case 70: // $204
      var $205=$4;
      var $206=$5;
      var $207=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($202, $203, ((STRING_TABLE.__str33854)|0), $205, $206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 32; break; };
    case 71: // $208
      $filerr=$207;
      __label__ = 72; break;
    case 72: // $209
      var $210=$filerr;
      var $211=(($210)|0)!=0;
      if ($211) { __label__ = 73; break; } else { __label__ = 79; break; }
    case 73: // $212
      var $213=$has_parent;
      var $214=(($213) & 1);
      if ($214) { __label__ = 74; break; } else { __label__ = 79; break; }
    case 74: // $215
      var $216=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 32; break; };
    case 75: // $217
      var $218=(($216)|0)!=0;
      if ($218) { __label__ = 76; break; } else { __label__ = 79; break; }
    case 76: // $219
      var $220=$2;
      var $221=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 32; break; };
    case 77: // $222
      var $223=$4;
      var $224=$5;
      var $225=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($220, $221, ((STRING_TABLE.__str33854)|0), $223, $224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 32; break; };
    case 78: // $226
      $filerr=$225;
      __label__ = 79; break;
    case 79: // $227
      var $228=$filerr;
      var $229=(($228)|0)!=0;
      if ($229) { __label__ = 80; break; } else { __label__ = 87; break; }
    case 80: // $230
      var $231=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 32; break; };
    case 81: // $232
      var $233=(($231)|0)!=0;
      if ($233) { __label__ = 82; break; } else { __label__ = 87; break; }
    case 82: // $234
      var $235=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 32; break; };
    case 83: // $236
      var $237=(($235-1)|0);
      var $238=(function() { try { __THREW__ = false; return __ZN7astring3delEii($tag1, $237, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 32; break; };
    case 84: // $239
      var $240=$2;
      var $241=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 32; break; };
    case 85: // $242
      var $243=$4;
      var $244=$5;
      var $245=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($240, $241, ((STRING_TABLE.__str33854)|0), $243, $244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 32; break; };
    case 86: // $246
      $filerr=$245;
      __label__ = 87; break;
    case 87: // $247
      __label__ = 88; break;
    case 88: // $248
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 31; break; }
    case 89: // $249
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 30; break; }
    case 90: // $250
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 29; break; }
    case 91: // $251
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 28; break; }
    case 92: // $252
      FUNCTION_TABLE[__ZN7astringD1Ev]($tag1);
      __label__ = 103; break;
    case 93: // $253
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 182; break; }
    case 94: // $254
      __label__ = 95; break;
    case 95: // $255
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 182; break; }
    case 96: // $256
      __label__ = 97; break;
    case 97: // $257
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 182; break; }
    case 98: // $258
      __label__ = 99; break;
    case 99: // $259
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 182; break; }
    case 100: // $260
      __label__ = 101; break;
    case 101: // $261
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 182; break; }
    case 102: // $262
      __label__ = 181; break;
    case 103: // $263
      var $264=$filerr;
      var $265=(($264)|0)==0;
      if ($265) { __label__ = 104; break; } else { __label__ = 107; break; }
    case 104: // $266
      var $267=$5;
      var $268=HEAP32[(($267)>>2)];
      var $269=__ZN8emu_filecvP10_core_fileEv($268);
      var $270=$6;
      var $271=__Z13chd_open_fileP10_core_fileiP9_chd_filePS2_($269, 1, 0, $270);
      $err=$271;
      var $272=$err;
      var $273=(($272)|0)==0;
      if ($273) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $274
      var $275=$err;
      $1=$275;
      __label__ = 180; break;
    case 106: // $276
      var $277=$5;
      var $278=HEAP32[(($277)>>2)];
      var $279=$278;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $279);
      var $280=$5;
      HEAP32[(($280)>>2)]=0;
      __label__ = 108; break;
    case 107: // $281
      $err=6;
      __label__ = 108; break;
    case 108: // $282
      var $283=$4;
      var $284=(($283+4)|0);
      var $285=HEAP32[(($284)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($romphashes, $285);
      var $286=$3;
      var $287=(function() { try { __THREW__ = false; return __ZN11driver_list4findERK11game_driver($286) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 141; break; };
    case 109: // $288
      $drv=$287;
      __label__ = 110; break;
    case 110: // $289
      var $290=$drv;
      var $291=(($290)|0)!=-1;
      if ($291) { __label__ = 111; break; } else { __label__ = 176; break; }
    case 111: // $292
      var $293=$drv;
      var $294=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($293) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 141; break; };
    case 112: // $295
      var $296=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($config, $294, $296) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 141; break; }
    case 113: // $297
      var $298=(function() { try { __THREW__ = false; return __Z16rom_first_sourceRK14machine_config($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 142; break; };
    case 114: // $299
      $source=$298;
      __label__ = 115; break;
    case 115: // $300
      var $301=$source;
      var $302=(($301)|0)!=0;
      if ($302) { __label__ = 116; break; } else { __label__ = 168; break; }
    case 116: // $303
      var $304=$source;
      var $305=(function() { try { __THREW__ = false; return __Z16rom_first_regionRK8device_t($304) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 117; break; } else { __label__ = 142; break; };
    case 117: // $306
      $region=$305;
      __label__ = 118; break;
    case 118: // $307
      var $308=$region;
      var $309=(($308)|0)!=0;
      if ($309) { __label__ = 119; break; } else { __label__ = 165; break; }
    case 119: // $310
      var $311=$region;
      var $312=(($311+16)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=$313 & 16384;
      var $315=(($314)|0)==16384;
      if ($315) { __label__ = 120; break; } else { __label__ = 162; break; }
    case 120: // $316
      var $317=$region;
      var $318=(function() { try { __THREW__ = false; return __Z14rom_first_filePK9rom_entry($317) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 142; break; };
    case 121: // $319
      $rom=$318;
      __label__ = 122; break;
    case 122: // $320
      var $321=$rom;
      var $322=(($321)|0)!=0;
      if ($322) { __label__ = 123; break; } else { __label__ = 161; break; }
    case 123: // $323
      var $324=$4;
      var $325=(($324)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=$rom;
      var $328=(($327)|0);
      var $329=HEAP32[(($328)>>2)];
      $11=0;
      var $330=(function() { try { __THREW__ = false; return _strcmp($326, $329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 124; break; } else { __label__ = 142; break; };
    case 124: // $331
      var $332=(($330)|0)!=0;
      if ($332) { __label__ = 125; break; } else { var $341 = 0;__label__ = 128; break; }
    case 125: // $333
      var $334=$rom;
      var $335=(($334+4)|0);
      var $336=HEAP32[(($335)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($10, $336) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 126; break; } else { __label__ = 142; break; }
    case 126: // $337
      $11=1;
      var $338=(function() { try { __THREW__ = false; return __ZNK15hash_collectioneqERKS_($romphashes, $10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 143; break; };
    case 127: // $339
      var $341 = $338;__label__ = 128; break;
    case 128: // $340
      var $341;
      var $342=$11;
      if ($342) { __label__ = 129; break; } else { __label__ = 131; break; }
    case 129: // $343
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 130; break; } else { __label__ = 142; break; }
    case 130: // $344
      __label__ = 131; break;
    case 131: // $345
      if ($341) { __label__ = 132; break; } else { __label__ = 158; break; }
    case 132: // $346
      $filerr=3;
      var $347=$drv;
      $searchdrv1=$347;
      __label__ = 133; break;
    case 133: // $348
      var $349=$searchdrv1;
      var $350=(($349)|0)!=-1;
      if ($350) { __label__ = 134; break; } else { var $355 = 0;__label__ = 135; break; }
    case 134: // $351
      var $352=$filerr;
      var $353=(($352)|0)!=0;
      var $355 = $353;__label__ = 135; break;
    case 135: // $354
      var $355;
      if ($355) { __label__ = 136; break; } else { __label__ = 147; break; }
    case 136: // $356
      var $357=$2;
      var $358=$searchdrv1;
      var $359=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($358) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 137; break; } else { __label__ = 142; break; };
    case 137: // $360
      var $361=(($359+8)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=$rom;
      var $364=$5;
      var $365=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($357, $362, ((STRING_TABLE.__str33854)|0), $363, $364) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 138; break; } else { __label__ = 142; break; };
    case 138: // $366
      $filerr=$365;
      __label__ = 139; break;
    case 139: // $367
      var $368=$searchdrv1;
      var $369=(function() { try { __THREW__ = false; return __ZN11driver_list5cloneEi($368) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 140; break; } else { __label__ = 142; break; };
    case 140: // $370
      $searchdrv1=$369;
      __label__ = 133; break;
    case 141: // $371
      var $372=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $373=$372.f0;
      $8=$373;
      var $374=$372.f1;
      $9=$374;
      __label__ = 178; break;
    case 142: // $375
      var $376=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $377=$376.f0;
      $8=$377;
      var $378=$376.f1;
      $9=$378;
      __label__ = 174; break;
    case 143: // $379
      var $380=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $381=$380.f0;
      $8=$381;
      var $382=$380.f1;
      $9=$382;
      var $383=$11;
      if ($383) { __label__ = 144; break; } else { __label__ = 146; break; }
    case 144: // $384
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 145; break; } else { __label__ = 182; break; }
    case 145: // $385
      __label__ = 146; break;
    case 146: // $386
      __label__ = 174; break;
    case 147: // $387
      var $388=$filerr;
      var $389=(($388)|0)!=0;
      if ($389) { __label__ = 148; break; } else { __label__ = 150; break; }
    case 148: // $390
      var $391=$2;
      var $392=$rom;
      var $393=$5;
      var $394=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file($391, 0, ((STRING_TABLE.__str33854)|0), $392, $393) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 149; break; } else { __label__ = 142; break; };
    case 149: // $395
      $filerr=$394;
      __label__ = 150; break;
    case 150: // $396
      var $397=$filerr;
      var $398=(($397)|0)==0;
      if ($398) { __label__ = 151; break; } else { __label__ = 157; break; }
    case 151: // $399
      var $400=$5;
      var $401=HEAP32[(($400)>>2)];
      var $402=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($401) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 142; break; };
    case 152: // $403
      var $404=$6;
      var $405=(function() { try { __THREW__ = false; return __Z13chd_open_fileP10_core_fileiP9_chd_filePS2_($402, 1, 0, $404) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 153; break; } else { __label__ = 142; break; };
    case 153: // $406
      $err=$405;
      var $407=$err;
      var $408=(($407)|0)==0;
      if ($408) { __label__ = 154; break; } else { __label__ = 155; break; }
    case 154: // $409
      var $410=$err;
      $1=$410;
      $12=1;
      __label__ = 169; break;
    case 155: // $411
      var $412=$5;
      var $413=HEAP32[(($412)>>2)];
      var $414=$413;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $414) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 142; break; }
    case 156: // $415
      var $416=$5;
      HEAP32[(($416)>>2)]=0;
      __label__ = 157; break;
    case 157: // $417
      __label__ = 158; break;
    case 158: // $418
      __label__ = 159; break;
    case 159: // $419
      var $420=$rom;
      var $421=(function() { try { __THREW__ = false; return __Z13rom_next_filePK9rom_entry($420) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 160; break; } else { __label__ = 142; break; };
    case 160: // $422
      $rom=$421;
      __label__ = 122; break;
    case 161: // $423
      __label__ = 162; break;
    case 162: // $424
      __label__ = 163; break;
    case 163: // $425
      var $426=$region;
      var $427=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($426) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 164; break; } else { __label__ = 142; break; };
    case 164: // $428
      $region=$427;
      __label__ = 118; break;
    case 165: // $429
      __label__ = 166; break;
    case 166: // $430
      var $431=$source;
      var $432=(function() { try { __THREW__ = false; return __Z15rom_next_sourceRK8device_t($431) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 167; break; } else { __label__ = 142; break; };
    case 167: // $433
      $source=$432;
      __label__ = 115; break;
    case 168: // $434
      $12=0;
      __label__ = 169; break;
    case 169: // $435
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 170; break; } else { __label__ = 141; break; }
    case 170: // $436
      var $cleanup_dest=$12;
      if ($cleanup_dest == 0) {
        __label__ = 171; break;
      }
      else {
      __label__ = 177; break;
      }
      
    case 171: // $437
      __label__ = 172; break;
    case 172: // $438
      var $439=$drv;
      var $440=(function() { try { __THREW__ = false; return __ZN11driver_list5cloneEi($439) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 173; break; } else { __label__ = 141; break; };
    case 173: // $441
      $drv=$440;
      __label__ = 110; break;
    case 174: // $442
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 175; break; } else { __label__ = 182; break; }
    case 175: // $443
      __label__ = 178; break;
    case 176: // $444
      var $445=$err;
      $1=$445;
      $12=1;
      __label__ = 177; break;
    case 177: // $446
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($romphashes);
      __label__ = 180; break;
    case 178: // $447
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($romphashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 179; break; } else { __label__ = 182; break; }
    case 179: // $448
      __label__ = 181; break;
    case 180: // $449
      var $450=$1;
      STACKTOP = __stackBase__;
      return $450;
    case 181: // $451
      var $452=$8;
      var $453=$8;
      var $454=$9;
      var $455=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $453, tempValue);
      var $456=($455.f1 = $454, $455);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 182: // $457
      var $458=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15open_disk_imageR11emu_optionsPK11game_driverPK9rom_entryPP8emu_filePP9_chd_filePKc["X"]=1;

function __ZNK16_romload_private7machineEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL26normalize_flags_for_deviceR15running_machinePKcRhR12endianness_t($machine, $rgntag, $width, $endian) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $device;
      var $memory=__stackBase__;
      var $spaceconfig;
      var $buswidth;
      $1=$machine;
      $2=$rgntag;
      $3=$width;
      $4=$endian;
      var $5=$1;
      var $6=$2;
      var $7=__ZN15running_machine6deviceEPKc($5, $6);
      $device=$7;
      var $8=$device;
      var $9=__ZN8device_t9interfaceERP23device_memory_interface($8, $memory);
      if ($9) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $10
      var $11=HEAP32[(($memory)>>2)];
      var $12=__ZNK23device_memory_interface12space_configE16address_spacenum($11, 0);
      $spaceconfig=$12;
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $15
      var $16=$spaceconfig;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 16; break; }
    case 3: // $18
      var $19=$spaceconfig;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$4;
      HEAP32[(($24)>>2)]=0;
      __label__ = 6; break;
    case 5: // $25
      var $26=$4;
      HEAP32[(($26)>>2)]=1;
      __label__ = 6; break;
    case 6: // $27
      var $28=$spaceconfig;
      var $29=(($28+8)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      $buswidth=$31;
      var $32=$buswidth;
      var $33=(($32)|0) <= 8;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$3;
      HEAP8[($35)]=1;
      __label__ = 15; break;
    case 8: // $36
      var $37=$buswidth;
      var $38=(($37)|0) <= 16;
      if ($38) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      var $40=$3;
      HEAP8[($40)]=2;
      __label__ = 14; break;
    case 10: // $41
      var $42=$buswidth;
      var $43=(($42)|0) <= 32;
      if ($43) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $44
      var $45=$3;
      HEAP8[($45)]=4;
      __label__ = 13; break;
    case 12: // $46
      var $47=$3;
      HEAP8[($47)]=8;
      __label__ = 13; break;
    case 13: // $48
      __label__ = 14; break;
    case 14: // $49
      __label__ = 15; break;
    case 15: // $50
      __label__ = 16; break;
    case 16: // $51
      __label__ = 17; break;
    case 17: // $52
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26normalize_flags_for_deviceR15running_machinePKcRhR12endianness_t["X"]=1;

function __ZNK13memory_region4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __Z25load_software_part_regionP8device_tPcS1_P9rom_entry($device, $swlist, $swname, $start_region) {
  var __stackBase__  = STACKTOP; STACKTOP += 264; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $locationtag=__stackBase__;
      var $breakstr=__stackBase__+64;
      var $5;
      var $6;
      var $romdata;
      var $region;
      var $regiontag=__stackBase__+128;
      var $software_list_ptr;
      var $swinfo;
      var $tmp=__stackBase__+192;
      var $parentname;
      var $regionlength;
      var $endianness=__stackBase__+256;
      var $width=__stackBase__+260;
      var $memregion;
      $1=$device;
      $2=$swlist;
      $3=$swname;
      $4=$start_region;
      var $7=$2;
      __ZN7astringC1EPKc($locationtag, $7);
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($breakstr, ((STRING_TABLE.__str53856)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 21; break; }
    case 1: // $8
      var $9=$1;
      var $10=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 22; break; };
    case 2: // $11
      var $12=(($10+636)|0);
      var $13=HEAP32[(($12)>>2)];
      $romdata=$13;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 22; break; }
    case 3: // $14
      var $15=$1;
      var $16=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 23; break; };
    case 4: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 23; break; };
    case 5: // $19
      var $20=$2;
      var $21=(function() { try { __THREW__ = false; return __Z18software_list_openR11emu_optionsPKciPFvS2_E($18, $20, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 23; break; };
    case 6: // $22
      $software_list_ptr=$21;
      var $23=$software_list_ptr;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 32; break; }
    case 7: // $25
      var $26=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($locationtag, $breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 23; break; };
    case 8: // $27
      var $28=$software_list_ptr;
      var $29=$3;
      var $30=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($28, $29, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 23; break; };
    case 9: // $31
      $swinfo=$30;
      __label__ = 10; break;
    case 10: // $32
      var $33=$swinfo;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 11; break; } else { __label__ = 28; break; }
    case 11: // $35
      var $36=$swinfo;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($tmp, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 23; break; }
    case 12: // $39
      var $40=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($locationtag, $tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 24; break; };
    case 13: // $41
      var $42=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($locationtag, $breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 24; break; };
    case 14: // $43
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $44
      var $45=$1;
      var $46=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 23; break; };
    case 16: // $47
      var $48=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 23; break; };
    case 17: // $49
      var $50=$2;
      var $51=$swinfo;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z18software_get_cloneR11emu_optionsPcPKc($48, $50, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 23; break; };
    case 18: // $55
      $parentname=$54;
      var $56=$parentname;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $58
      var $59=$software_list_ptr;
      var $60=$parentname;
      var $61=(function() { try { __THREW__ = false; return __Z18software_list_findP14_software_listPKcP13software_info($59, $60, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 23; break; };
    case 20: // $62
      $swinfo=$61;
      __label__ = 27; break;
    case 21: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      $5=$65;
      var $66=$64.f1;
      $6=$66;
      __label__ = 119; break;
    case 22: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $5=$69;
      var $70=$68.f1;
      $6=$70;
      __label__ = 117; break;
    case 23: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $5=$73;
      var $74=$72.f1;
      $6=$74;
      __label__ = 115; break;
    case 24: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      $5=$77;
      var $78=$76.f1;
      $6=$78;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 122; break; }
    case 25: // $79
      __label__ = 115; break;
    case 26: // $80
      $swinfo=0;
      __label__ = 27; break;
    case 27: // $81
      __label__ = 10; break;
    case 28: // $82
      var $83=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 23; break; };
    case 29: // $84
      var $85=(($83-1)|0);
      var $86=(function() { try { __THREW__ = false; return __ZN7astring3delEii($locationtag, $85, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 23; break; };
    case 30: // $87
      var $88=$software_list_ptr;
      (function() { try { __THREW__ = false; return __Z19software_list_closeP14_software_list($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 23; break; }
    case 31: // $89
      __label__ = 32; break;
    case 32: // $90
      __label__ = 33; break;
    case 33: // $91
      __label__ = 34; break;
    case 34: // $92
      __label__ = 35; break;
    case 35: // $93
      var $94=$romdata;
      var $95=(($94+52)|0);
      var $96=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 23; break; };
    case 36: // $97
      var $98=$1;
      var $99=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 23; break; };
    case 37: // $100
      var $101=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 23; break; };
    case 38: // $102
      var $103=$2;
      var $104=$3;
      var $105=(function() { try { __THREW__ = false; return __Z20software_get_supportR11emu_optionsPcPKc($101, $103, $104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 23; break; };
    case 39: // $106
      var $107=(($105)|0)==1;
      if ($107) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $108
      var $109=$romdata;
      var $110=(($109+52)|0);
      var $111=$3;
      var $112=$2;
      var $113=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($110, ((STRING_TABLE.__str63857)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$111,HEAP32[((tempInt+4)>>2)]=$112,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 23; break; };
    case 41: // $114
      var $115=$romdata;
      var $116=(($115+8)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117+1)|0);
      HEAP32[(($116)>>2)]=$118;
      __label__ = 42; break;
    case 42: // $119
      var $120=$1;
      var $121=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 23; break; };
    case 43: // $122
      var $123=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 23; break; };
    case 44: // $124
      var $125=$2;
      var $126=$3;
      var $127=(function() { try { __THREW__ = false; return __Z20software_get_supportR11emu_optionsPcPKc($123, $125, $126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 23; break; };
    case 45: // $128
      var $129=(($127)|0)==2;
      if ($129) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $130
      var $131=$romdata;
      var $132=(($131+52)|0);
      var $133=$3;
      var $134=$2;
      var $135=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($132, ((STRING_TABLE.__str73858)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$133,HEAP32[((tempInt+4)>>2)]=$134,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 23; break; };
    case 47: // $136
      var $137=$romdata;
      var $138=(($137+8)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139+1)|0);
      HEAP32[(($138)>>2)]=$140;
      __label__ = 48; break;
    case 48: // $141
      var $142=$4;
      $region=$142;
      __label__ = 49; break;
    case 49: // $143
      var $144=$region;
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 50; break; } else { __label__ = 103; break; }
    case 50: // $146
      var $147=$region;
      var $148=(($147+12)|0);
      var $149=HEAP32[(($148)>>2)];
      $regionlength=$149;
      var $150=$1;
      var $151=$region;
      var $152=(($151)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($150, $regiontag, $153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 23; break; };
    case 51: // $155
      __label__ = 52; break;
    case 52: // $156
      __label__ = 53; break;
    case 53: // $157
      __label__ = 54; break;
    case 54: // $158
      __label__ = 55; break;
    case 55: // $159
      __label__ = 56; break;
    case 56: // $160
      __label__ = 57; break;
    case 57: // $161
      var $162=$region;
      var $163=(($162+16)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164 & 1024;
      var $166=(($165)|0)==1024;
      var $167=$166 ? 1 : 0;
      HEAP32[(($endianness)>>2)]=$167;
      var $168=$region;
      var $169=(($168+16)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$170 & 768;
      var $172=$171 >>> 8;
      var $173=8 << $172;
      var $174=(((($173)|0)/8)|0);
      var $175=(($174) & 255);
      HEAP8[($width)]=$175;
      var $176=$romdata;
      var $177=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 23; break; };
    case 58: // $178
      var $179=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 23; break; };
    case 59: // $180
      var $181=(function() { try { __THREW__ = false; return __ZN15running_machine6regionEPKc($177, $179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 23; break; };
    case 60: // $182
      $memregion=$181;
      var $183=$memregion;
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 61; break; } else { __label__ = 73; break; }
    case 61: // $185
      var $186=$romdata;
      var $187=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 23; break; };
    case 62: // $188
      var $189=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 23; break; };
    case 63: // $190
      var $191=(function() { try { __THREW__ = false; return __ZN15running_machine6deviceEPKc($187, $189) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 23; break; };
    case 64: // $192
      var $193=(($191)|0)!=0;
      if ($193) { __label__ = 65; break; } else { __label__ = 69; break; }
    case 65: // $194
      var $195=$romdata;
      var $196=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 23; break; };
    case 66: // $197
      var $198=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 23; break; };
    case 67: // $199
      (function() { try { __THREW__ = false; return __ZL26normalize_flags_for_deviceR15running_machinePKcRhR12endianness_t($196, $198, $width, $endianness) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 23; break; }
    case 68: // $200
      __label__ = 69; break;
    case 69: // $201
      var $202=$romdata;
      var $203=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 23; break; };
    case 70: // $204
      var $205=$memregion;
      var $206=(function() { try { __THREW__ = false; return __ZNK13memory_region4nameEv($205) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 23; break; };
    case 71: // $207
      (function() { try { __THREW__ = false; return __ZN15running_machine11region_freeEPKc($203, $206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 23; break; }
    case 72: // $208
      __label__ = 73; break;
    case 73: // $209
      var $210=$romdata;
      var $211=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 23; break; };
    case 74: // $212
      var $213=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 23; break; };
    case 75: // $214
      var $215=$regionlength;
      var $216=HEAP8[($width)];
      var $217=HEAP32[(($endianness)>>2)];
      var $218=(function() { try { __THREW__ = false; return __ZN15running_machine12region_allocEPKcjh12endianness_t($211, $213, $215, $216, $217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 23; break; };
    case 76: // $219
      var $220=$romdata;
      var $221=(($220+48)|0);
      HEAP32[(($221)>>2)]=$218;
      __label__ = 77; break;
    case 77: // $222
      __label__ = 78; break;
    case 78: // $223
      __label__ = 79; break;
    case 79: // $224
      var $225=$region;
      var $226=(($225+16)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$227 & 8192;
      var $229=(($228)|0)==8192;
      if ($229) { __label__ = 80; break; } else { __label__ = 83; break; }
    case 80: // $230
      var $231=$romdata;
      var $232=(($231+48)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(function() { try { __THREW__ = false; return __ZNK13memory_region4baseEv($233) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 23; break; };
    case 81: // $235
      var $236=$region;
      var $237=(($236+16)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$238 & 16711680;
      var $240=$239 >>> 16;
      var $241=(($240) & 255);
      var $242=$romdata;
      var $243=(($242+48)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 23; break; };
    case 82: // $246
      _memset($234, $241, $245, 1);
      __label__ = 89; break;
    case 83: // $247
      var $248=$romdata;
      var $249=(($248+48)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($250) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 23; break; };
    case 84: // $252
      var $253=(($251)>>>0) <= 4194304;
      if ($253) { __label__ = 85; break; } else { __label__ = 88; break; }
    case 85: // $254
      var $255=$romdata;
      var $256=(($255+48)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(function() { try { __THREW__ = false; return __ZNK13memory_region4baseEv($257) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 23; break; };
    case 86: // $259
      var $260=$romdata;
      var $261=(($260+48)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 23; break; };
    case 87: // $264
      _memset($258, 0, $263, 1);
      __label__ = 88; break;
    case 88: // $265
      __label__ = 89; break;
    case 89: // $266
      var $267=$region;
      var $268=(($267+16)|0);
      var $269=HEAP32[(($268)>>2)];
      var $270=$269 & 16384;
      var $271=(($270)|0)==0;
      if ($271) { __label__ = 90; break; } else { __label__ = 93; break; }
    case 90: // $272
      var $273=$romdata;
      var $274=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 23; break; };
    case 91: // $275
      var $276=$region;
      var $277=(($276+20)|0);
      (function() { try { __THREW__ = false; return __ZL19process_rom_entriesP16_romload_privatePKcPK9rom_entry($273, $274, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 23; break; }
    case 92: // $278
      __label__ = 100; break;
    case 93: // $279
      var $280=$region;
      var $281=(($280+16)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=$282 & 16384;
      var $284=(($283)|0)==16384;
      if ($284) { __label__ = 94; break; } else { __label__ = 99; break; }
    case 94: // $285
      var $286=$romdata;
      var $287=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 23; break; };
    case 95: // $288
      var $289=(function() { try { __THREW__ = false; return __Z11core_strdupPKc($287) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 23; break; };
    case 96: // $290
      var $291=$region;
      var $292=(($291+20)|0);
      var $293=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 23; break; };
    case 97: // $294
      (function() { try { __THREW__ = false; return __ZL20process_disk_entriesP16_romload_privatePKcPK9rom_entryS2_($286, $289, $292, $293) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 23; break; }
    case 98: // $295
      __label__ = 99; break;
    case 99: // $296
      __label__ = 100; break;
    case 100: // $297
      __label__ = 101; break;
    case 101: // $298
      var $299=$region;
      var $300=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 23; break; };
    case 102: // $301
      $region=$300;
      __label__ = 49; break;
    case 103: // $302
      var $303=$4;
      $region=$303;
      __label__ = 104; break;
    case 104: // $304
      var $305=$region;
      var $306=(($305)|0)!=0;
      if ($306) { __label__ = 105; break; } else { __label__ = 111; break; }
    case 105: // $307
      var $308=$1;
      var $309=$region;
      var $310=(($309)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(function() { try { __THREW__ = false; return __ZNK8device_t6subtagER7astringPKc($308, $regiontag, $311) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 23; break; };
    case 106: // $313
      var $314=$romdata;
      var $315=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 23; break; };
    case 107: // $316
      var $317=$region;
      var $318=(($317+16)|0);
      var $319=HEAP32[(($318)>>2)];
      var $320=$319 & 2048;
      var $321=(($320)|0)==2048;
      (function() { try { __THREW__ = false; return __ZL19region_post_processP16_romload_privatePKcb($314, $315, $321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 23; break; }
    case 108: // $322
      __label__ = 109; break;
    case 109: // $323
      var $324=$region;
      var $325=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 23; break; };
    case 110: // $326
      $region=$325;
      __label__ = 104; break;
    case 111: // $327
      var $328=$romdata;
      (function() { try { __THREW__ = false; return __ZL24display_rom_load_resultsP16_romload_private($328) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 23; break; }
    case 112: // $329
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 22; break; }
    case 113: // $330
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 21; break; }
    case 114: // $331
      FUNCTION_TABLE[__ZN7astringD1Ev]($locationtag);
      STACKTOP = __stackBase__;
      return;
    case 115: // $332
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 122; break; }
    case 116: // $333
      __label__ = 117; break;
    case 117: // $334
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($breakstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 122; break; }
    case 118: // $335
      __label__ = 119; break;
    case 119: // $336
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($locationtag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 120; break; } else { __label__ = 122; break; }
    case 120: // $337
      __label__ = 121; break;
    case 121: // $338
      var $339=$5;
      var $340=$5;
      var $341=$6;
      var $342=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $340, tempValue);
      var $343=($342.f1 = $341, $342);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 122: // $344
      var $345=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z25load_software_part_regionP8device_tPcS1_P9rom_entry["X"]=1;

function __ZL19region_post_processP16_romload_privatePKcb($romdata, $rgntag, $invert) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $region;
      var $base;
      var $i;
      var $j;
      var $datawidth;
      var $temp=__stackBase__;
      $1=$romdata;
      $2=$rgntag;
      var $4=(($invert)&1);
      $3=$4;
      var $5=$1;
      var $6=__ZNK16_romload_private7machineEv($5);
      var $7=$2;
      var $8=__ZN15running_machine6regionEPKc($6, $7);
      $region=$8;
      var $9=$region;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      __label__ = 25; break;
    case 2: // $12
      __label__ = 3; break;
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$3;
      var $16=(($15) & 1);
      if ($16) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $17
      __label__ = 6; break;
    case 6: // $18
      __label__ = 7; break;
    case 7: // $19
      $i=0;
      var $20=$region;
      var $21=__ZNK13memory_region4baseEv($20);
      $base=$21;
      __label__ = 8; break;
    case 8: // $22
      var $23=$i;
      var $24=$region;
      var $25=__ZNK13memory_region5bytesEv($24);
      var $26=(($23)>>>0) < (($25)>>>0);
      if ($26) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $27
      var $28=$base;
      var $29=(($28+1)|0);
      $base=$29;
      var $30=HEAPU8[($28)];
      var $31=(($30)&255);
      var $32=$31 ^ 255;
      var $33=(($32) & 255);
      HEAP8[($28)]=$33;
      __label__ = 10; break;
    case 10: // $34
      var $35=$i;
      var $36=(($35+1)|0);
      $i=$36;
      __label__ = 8; break;
    case 11: // $37
      __label__ = 12; break;
    case 12: // $38
      var $39=$region;
      var $40=__ZNK13memory_region5widthEv($39);
      var $41=(($40)&255);
      var $42=(($41)|0) > 1;
      if ($42) { __label__ = 13; break; } else { __label__ = 25; break; }
    case 13: // $43
      var $44=$region;
      var $45=__ZNK13memory_region10endiannessEv($44);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 14; break; } else { __label__ = 25; break; }
    case 14: // $47
      __label__ = 15; break;
    case 15: // $48
      __label__ = 16; break;
    case 16: // $49
      var $50=$region;
      var $51=__ZNK13memory_region5widthEv($50);
      var $52=(($51)&255);
      $datawidth=$52;
      $i=0;
      var $53=$region;
      var $54=__ZNK13memory_region4baseEv($53);
      $base=$54;
      __label__ = 17; break;
    case 17: // $55
      var $56=$i;
      var $57=$region;
      var $58=__ZNK13memory_region5bytesEv($57);
      var $59=(($56)>>>0) < (($58)>>>0);
      if ($59) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $60
      var $61=(($temp)|0);
      var $62=$base;
      var $63=$datawidth;
      assert($63 % 1 === 0, 'memcpy given ' + $63 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($61, $62, $63, 1);
      var $64=$datawidth;
      var $65=(($64-1)|0);
      $j=$65;
      __label__ = 19; break;
    case 19: // $66
      var $67=$j;
      var $68=(($67)|0) >= 0;
      if ($68) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $69
      var $70=$j;
      var $71=(($temp+$70)|0);
      var $72=HEAP8[($71)];
      var $73=$base;
      var $74=(($73+1)|0);
      $base=$74;
      HEAP8[($73)]=$72;
      __label__ = 21; break;
    case 21: // $75
      var $76=$j;
      var $77=(($76-1)|0);
      $j=$77;
      __label__ = 19; break;
    case 22: // $78
      __label__ = 23; break;
    case 23: // $79
      var $80=$datawidth;
      var $81=$i;
      var $82=(($81+$80)|0);
      $i=$82;
      __label__ = 17; break;
    case 24: // $83
      __label__ = 25; break;
    case 25: // $84
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19region_post_processP16_romload_privatePKcb["X"]=1;

function __ZL19process_rom_entriesP16_romload_privatePKcPK9rom_entry($romdata, $regiontag, $romp) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $lastflags;
      var $irrelevantbios;
      var $baserom;
      var $explength;
      var $modified_romp=__stackBase__;
      var $4=__stackBase__+20;
      var $5;
      var $6;
      $1=$romdata;
      $2=$regiontag;
      $3=$romp;
      $lastflags=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$3;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 15;
      var $12=(($11)|0)==1;
      if ($12) { var $20 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $13
      var $14=$3;
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 15;
      var $18=(($17)|0)==2;
      var $20 = $18;__label__ = 3; break;
    case 3: // $19
      var $20;
      var $21=$20 ^ 1;
      if ($21) { __label__ = 4; break; } else { __label__ = 56; break; }
    case 4: // $22
      var $23=$3;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25 & 15;
      var $27=(($26)|0)==4;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      __Z10fatalerrorPKcz(((STRING_TABLE.__str293880)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 6: // $29
      var $30=$3;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32 & 15;
      var $34=(($33)|0)==8;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      __Z10fatalerrorPKcz(((STRING_TABLE.__str303881)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 8: // $36
      var $37=$3;
      var $38=(($37+16)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39 & 15;
      var $41=(($40)|0)==3;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      __Z10fatalerrorPKcz(((STRING_TABLE.__str313882)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 10: // $43
      var $44=$3;
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$46 & 15;
      var $48=(($47)|0)==5;
      if ($48) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $49
      var $50=$1;
      var $51=$3;
      var $52=(($51+20)|0);
      $3=$52;
      __ZL13fill_rom_dataP16_romload_privatePK9rom_entry($50, $51);
      __label__ = 55; break;
    case 12: // $53
      var $54=$3;
      var $55=(($54+16)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56 & 15;
      var $58=(($57)|0)==6;
      if ($58) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $59
      var $60=$1;
      var $61=$3;
      var $62=(($61+20)|0);
      $3=$62;
      __ZL13copy_rom_dataP16_romload_privatePK9rom_entry($60, $61);
      __label__ = 54; break;
    case 14: // $63
      var $64=$3;
      var $65=(($64+16)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$66 & 15;
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 15; break; } else { __label__ = 52; break; }
    case 15: // $69
      var $70=$3;
      var $71=(($70+16)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$72 & -16777216;
      var $74=$73 >>> 24;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 16; break; } else { var $87 = 0;__label__ = 17; break; }
    case 16: // $76
      var $77=$3;
      var $78=(($77+16)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$79 & -16777216;
      var $81=$80 >>> 24;
      var $82=$1;
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($81)|0)!=(($84)|0);
      var $87 = $85;__label__ = 17; break;
    case 17: // $86
      var $87;
      var $88=(($87)&1);
      $irrelevantbios=$88;
      var $89=$3;
      $baserom=$89;
      $explength=0;
      __label__ = 18; break;
    case 18: // $90
      __label__ = 19; break;
    case 19: // $91
      var $92=$irrelevantbios;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 22; break; } else { __label__ = 20; break; }
    case 20: // $94
      var $95=$1;
      var $96=$2;
      var $97=$3;
      var $98=__ZL13open_rom_fileP16_romload_privatePKcPK9rom_entry($95, $96, $97);
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $100
      var $101=$1;
      var $102=$3;
      __ZL19handle_missing_fileP16_romload_privatePK9rom_entry($101, $102);
      __label__ = 22; break;
    case 22: // $103
      __label__ = 23; break;
    case 23: // $104
      __label__ = 24; break;
    case 24: // $105
      var $106=$3;
      var $107=(($106+20)|0);
      $3=$107;
      var $108=$modified_romp;
      var $109=$106;
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($108)>>2)]=HEAP32[(($109)>>2)];HEAP32[(($108+4)>>2)]=HEAP32[(($109+4)>>2)];HEAP32[(($108+8)>>2)]=HEAP32[(($109+8)>>2)];HEAP32[(($108+12)>>2)]=HEAP32[(($109+12)>>2)];HEAP32[(($108+16)>>2)]=HEAP32[(($109+16)>>2)];
      var $110=(($modified_romp+16)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111 & 128;
      var $113=(($112)|0)==128;
      if ($113) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $114
      var $115=(($modified_romp+16)|0);
      var $116=HEAP32[(($115)>>2)];
      $lastflags=$116;
      __label__ = 27; break;
    case 26: // $117
      var $118=(($modified_romp+16)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119 & 191;
      var $121=$lastflags;
      var $122=$120 | $121;
      var $123=(($modified_romp+16)|0);
      HEAP32[(($123)>>2)]=$122;
      __label__ = 27; break;
    case 27: // $124
      var $125=(($modified_romp+12)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=$explength;
      var $128=(($127+$126)|0);
      $explength=$128;
      var $129=(($modified_romp+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$130 & 15;
      var $132=(($131)|0)==8;
      if ($132) { __label__ = 30; break; } else { __label__ = 28; break; }
    case 28: // $133
      var $134=$irrelevantbios;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $136
      var $137=$1;
      var $138=__ZL13read_rom_dataP16_romload_privatePK9rom_entry($137, $modified_romp);
      __label__ = 30; break;
    case 30: // $139
      __label__ = 31; break;
    case 31: // $140
      var $141=$3;
      var $142=(($141+16)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$143 & 15;
      var $145=(($144)|0)==4;
      if ($145) { var $153 = 1;__label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $146
      var $147=$3;
      var $148=(($147+16)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$149 & 15;
      var $151=(($150)|0)==8;
      var $153 = $151;__label__ = 33; break;
    case 33: // $152
      var $153;
      if ($153) { __label__ = 24; break; } else { __label__ = 34; break; }
    case 34: // $154
      var $155=$baserom;
      var $156=(($155)|0)!=0;
      if ($156) { __label__ = 35; break; } else { __label__ = 43; break; }
    case 35: // $157
      __label__ = 36; break;
    case 36: // $158
      __label__ = 37; break;
    case 37: // $159
      var $160=$1;
      var $161=$baserom;
      var $162=(($161)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$explength;
      var $165=$baserom;
      var $166=(($165+4)|0);
      var $167=HEAP32[(($166)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($4, $167);
      (function() { try { __THREW__ = false; return __ZL22verify_length_and_hashP16_romload_privatePKcjRK15hash_collection($160, $163, $164, $4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $168
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($4);
      __label__ = 39; break;
    case 39: // $169
      __label__ = 40; break;
    case 40: // $170
      __label__ = 43; break;
    case 41: // $171
      var $172=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $173=$172.f0;
      $5=$173;
      var $174=$172.f1;
      $6=$174;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 58; break; }
    case 42: // $175
      __label__ = 57; break;
    case 43: // $176
      var $177=$1;
      var $178=(($177+36)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $181
      var $182=$1;
      var $183=(($182+36)|0);
      var $184=HEAP32[(($183)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $185=__ZN8emu_file4seekExi($184, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $185$0=$185[0];
      __label__ = 45; break;
    case 45: // $186
      $baserom=0;
      $explength=0;
      __label__ = 46; break;
    case 46: // $187
      var $188=$3;
      var $189=(($188+16)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$190 & 15;
      var $192=(($191)|0)==3;
      if ($192) { __label__ = 23; break; } else { __label__ = 47; break; }
    case 47: // $193
      var $194=$1;
      var $195=(($194+36)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196)|0)!=0;
      if ($197) { __label__ = 48; break; } else { __label__ = 51; break; }
    case 48: // $198
      __label__ = 49; break;
    case 49: // $199
      __label__ = 50; break;
    case 50: // $200
      var $201=$1;
      var $202=(($201+36)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$203;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $204);
      var $205=$1;
      var $206=(($205+36)|0);
      HEAP32[(($206)>>2)]=0;
      __label__ = 51; break;
    case 51: // $207
      __label__ = 53; break;
    case 52: // $208
      var $209=$3;
      var $210=(($209+20)|0);
      $3=$210;
      __label__ = 53; break;
    case 53: // $211
      __label__ = 54; break;
    case 54: // $212
      __label__ = 55; break;
    case 55: // $213
      __label__ = 1; break;
    case 56: // $214
      STACKTOP = __stackBase__;
      return;
    case 57: // $215
      var $216=$5;
      var $217=$5;
      var $218=$6;
      var $219=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $217, tempValue);
      var $220=($219.f1 = $218, $219);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 58: // $221
      var $222=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19process_rom_entriesP16_romload_privatePKcPK9rom_entry["X"]=1;

function __ZL20process_disk_entriesP16_romload_privatePKcPK9rom_entryS2_($romdata, $regiontag, $romp, $locationtag) {
  var __stackBase__  = STACKTOP; STACKTOP += 404; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $hashes=__stackBase__;
      var $chd=__stackBase__+84;
      var $header=__stackBase__+108;
      var $err;
      var $filename=__stackBase__+256;
      var $5;
      var $6;
      var $7;
      var $acthashes=__stackBase__+320;
      $1=$romdata;
      $2=$regiontag;
      $3=$romp;
      $4=$locationtag;
      __label__ = 1; break;
    case 1: // $8
      var $9=$3;
      var $10=(($9+16)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 15;
      var $13=(($12)|0)==1;
      if ($13) { var $21 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=$3;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$17 & 15;
      var $19=(($18)|0)==2;
      var $21 = $19;__label__ = 3; break;
    case 3: // $20
      var $21;
      var $22=$21 ^ 1;
      if ($22) { __label__ = 4; break; } else { __label__ = 77; break; }
    case 4: // $23
      var $24=$3;
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 & 15;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 5; break; } else { __label__ = 75; break; }
    case 5: // $29
      var $30=$3;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($hashes, $32);
      var $33=$chd;
      HEAP32[(($33)>>2)]=0; HEAP32[(($33+4)>>2)]=0; HEAP32[(($33+8)>>2)]=0; HEAP32[(($33+12)>>2)]=0; HEAP32[(($33+16)>>2)]=0; HEAP32[(($33+20)>>2)]=0;
      var $34=$2;
      var $35=(($chd+4)|0);
      HEAP32[(($35)>>2)]=$34;
      var $36=$3;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKcS1_($filename, $38, ((STRING_TABLE.__str33854)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $39
      __label__ = 7; break;
    case 7: // $40
      __label__ = 8; break;
    case 8: // $41
      __label__ = 9; break;
    case 9: // $42
      var $43=$1;
      var $44=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 20; break; };
    case 10: // $45
      var $46=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 20; break; };
    case 11: // $47
      var $48=$1;
      var $49=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 20; break; };
    case 12: // $50
      var $51=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; };
    case 13: // $52
      var $53=$3;
      var $54=(($chd+12)|0);
      var $55=(($chd+8)|0);
      var $56=$4;
      var $57=(function() { try { __THREW__ = false; return __Z15open_disk_imageR11emu_optionsPK11game_driverPK9rom_entryPP8emu_filePP9_chd_filePKc($46, $51, $53, $54, $55, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 20; break; };
    case 14: // $58
      $err=$57;
      var $59=$err;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 15; break; } else { __label__ = 33; break; }
    case 15: // $61
      var $62=$err;
      var $63=(($62)|0)==6;
      if ($63) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $64
      var $65=$1;
      var $66=(($65+52)|0);
      var $67=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 20; break; };
    case 17: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($66, ((STRING_TABLE.__str193870)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$67,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $70
      __label__ = 25; break;
    case 19: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $5=$73;
      var $74=$72.f1;
      $6=$74;
      __label__ = 73; break;
    case 20: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      $5=$77;
      var $78=$76.f1;
      $6=$78;
      __label__ = 71; break;
    case 21: // $79
      var $80=$1;
      var $81=(($80+52)|0);
      var $82=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 20; break; };
    case 22: // $83
      var $84=$err;
      var $85=(function() { try { __THREW__ = false; return __Z16chd_error_string10_chd_error($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 20; break; };
    case 23: // $86
      var $87=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($81, ((STRING_TABLE.__str203871)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,HEAP32[((tempInt+4)>>2)]=$85,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 20; break; };
    case 24: // $88
      __label__ = 25; break;
    case 25: // $89
      var $90=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 20; break; };
    case 26: // $91
      if ($90) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $92
      var $93=$1;
      var $94=(($93+12)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95+1)|0);
      HEAP32[(($94)>>2)]=$96;
      __label__ = 32; break;
    case 28: // $97
      var $98=$3;
      var $99=(($98+16)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100 & 32;
      var $102=(($101)|0)==32;
      if ($102) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $103
      var $104=$1;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+1)|0);
      HEAP32[(($105)>>2)]=$107;
      __label__ = 31; break;
    case 30: // $108
      var $109=$1;
      var $110=(($109+16)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+1)|0);
      HEAP32[(($110)>>2)]=$112;
      __label__ = 31; break;
    case 31: // $113
      __label__ = 32; break;
    case 32: // $114
      $7=4;
      __label__ = 67; break;
    case 33: // $115
      var $116=(($chd+8)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(function() { try { __THREW__ = false; return __Z14chd_get_headerP9_chd_file($117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 20; break; };
    case 34: // $119
      var $120=$header;
      var $121=$118;
      assert(148 % 1 === 0, 'memcpy given ' + 148 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $121>>2, $$dest = $120>>2, $$stop = $$src + 37; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($acthashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 20; break; }
    case 35: // $122
      var $123=(($header+72)|0);
      var $124=(($123)|0);
      var $125=(function() { try { __THREW__ = false; return __ZN15hash_collection15add_from_bufferEcPKhi($acthashes, 83, $124, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 42; break; };
    case 36: // $126
      var $127=(function() { try { __THREW__ = false; return __ZNK15hash_collectionneERKS_($hashes, $acthashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 42; break; };
    case 37: // $128
      if ($127) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $129
      var $130=$1;
      var $131=(($130+52)|0);
      var $132=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 42; break; };
    case 39: // $133
      var $134=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($131, ((STRING_TABLE.__str213872)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$132,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; };
    case 40: // $135
      var $136=$1;
      (function() { try { __THREW__ = false; return __ZL32dump_wrong_and_correct_checksumsP16_romload_privateRK15hash_collectionS3_($136, $hashes, $acthashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $137
      var $138=$1;
      var $139=(($138+8)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+1)|0);
      HEAP32[(($139)>>2)]=$141;
      __label__ = 49; break;
    case 42: // $142
      var $143=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $144=$143.f0;
      $5=$144;
      var $145=$143.f1;
      $6=$145;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($acthashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 79; break; }
    case 43: // $146
      var $147=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 42; break; };
    case 44: // $148
      if ($147) { __label__ = 45; break; } else { __label__ = 48; break; }
    case 45: // $149
      var $150=$1;
      var $151=(($150+52)|0);
      var $152=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 42; break; };
    case 46: // $153
      var $154=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($151, ((STRING_TABLE.__str223873)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$152,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 42; break; };
    case 47: // $155
      var $156=$1;
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($158+1)|0);
      HEAP32[(($157)>>2)]=$159;
      __label__ = 48; break;
    case 48: // $160
      __label__ = 49; break;
    case 49: // $161
      var $162=$3;
      var $163=(($162+16)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164 & 16;
      var $166=(($165)|0)==16;
      if ($166) { __label__ = 59; break; } else { __label__ = 50; break; }
    case 50: // $167
      var $168=$1;
      var $169=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 42; break; };
    case 51: // $170
      var $171=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($169) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 42; break; };
    case 52: // $172
      var $173=$3;
      var $174=(($chd+8)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=(($chd+20)|0);
      var $177=(($chd+16)|0);
      var $178=(function() { try { __THREW__ = false; return __ZL14open_disk_diffR11emu_optionsPK9rom_entryP9_chd_filePP8emu_filePS5_($171, $173, $175, $176, $177) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 42; break; };
    case 53: // $179
      $err=$178;
      var $180=$err;
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 54; break; } else { __label__ = 58; break; }
    case 54: // $182
      var $183=$1;
      var $184=(($183+52)|0);
      var $185=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 42; break; };
    case 55: // $186
      var $187=$err;
      var $188=(function() { try { __THREW__ = false; return __Z16chd_error_string10_chd_error($187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 42; break; };
    case 56: // $189
      var $190=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($184, ((STRING_TABLE.__str233874)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,HEAP32[((tempInt+4)>>2)]=$188,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 42; break; };
    case 57: // $191
      var $192=$1;
      var $193=(($192+16)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194+1)|0);
      HEAP32[(($193)>>2)]=$195;
      $7=4;
      __label__ = 65; break;
    case 58: // $196
      __label__ = 59; break;
    case 59: // $197
      __label__ = 60; break;
    case 60: // $198
      __label__ = 61; break;
    case 61: // $199
      __label__ = 62; break;
    case 62: // $200
      var $201=$1;
      var $202=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 42; break; };
    case 63: // $203
      (function() { try { __THREW__ = false; return __ZL15add_disk_handleR15running_machineP9_open_chd($202, $chd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 42; break; }
    case 64: // $204
      $7=0;
      __label__ = 65; break;
    case 65: // $205
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($acthashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 20; break; }
    case 66: // $206
      __label__ = 67; break;
    case 67: // $207
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 19; break; }
    case 68: // $208
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes);
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0) {
        __label__ = 69; break;
      }
      else if ($cleanup_dest == 4) {
        __label__ = 76; break;
      }
      else {
      __label__ = 80; break;
      }
      
    case 69: // $209
      __label__ = 75; break;
    case 70: // $210
      __label__ = 71; break;
    case 71: // $211
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 79; break; }
    case 72: // $212
      __label__ = 73; break;
    case 73: // $213
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 79; break; }
    case 74: // $214
      __label__ = 78; break;
    case 75: // $215
      __label__ = 76; break;
    case 76: // $216
      var $217=$3;
      var $218=(($217+20)|0);
      $3=$218;
      __label__ = 1; break;
    case 77: // $219
      STACKTOP = __stackBase__;
      return;
    case 78: // $220
      var $221=$5;
      var $222=$5;
      var $223=$6;
      var $224=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $222, tempValue);
      var $225=($224.f1 = $223, $224);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 79: // $226
      var $227=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 80: // $228
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20process_disk_entriesP16_romload_privatePKcPK9rom_entryS2_["X"]=1;

function __ZN16_romload_privateC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16_romload_privateC2Ev($2);
  ;
  return;
}


function __ZL8rom_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curchd;
      $1=$machine;
      var $2=$1;
      var $3=(($2+636)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+40)|0);
      var $6=HEAP32[(($5)>>2)];
      $curchd=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$curchd;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $10
      var $11=$curchd;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$curchd;
      var $17=(($16+16)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z9chd_closeP9_chd_file($18);
      __label__ = 4; break;
    case 4: // $19
      var $20=$curchd;
      var $21=(($20+20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$curchd;
      var $26=(($25+20)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $28);
      __label__ = 6; break;
    case 6: // $29
      var $30=$curchd;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$curchd;
      var $36=(($35+8)|0);
      var $37=HEAP32[(($36)>>2)];
      __Z9chd_closeP9_chd_file($37);
      __label__ = 8; break;
    case 8: // $38
      var $39=$curchd;
      var $40=(($39+12)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$curchd;
      var $45=(($44+12)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$46;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $47);
      __label__ = 10; break;
    case 10: // $48
      __label__ = 11; break;
    case 11: // $49
      var $50=$curchd;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      $curchd=$52;
      __label__ = 1; break;
    case 12: // $53
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8rom_exitR15running_machine["X"]=1;

function __ZL18determine_bios_romP16_romload_private($romdata) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $specbios;
      var $defaultname;
      var $rom;
      var $default_no;
      var $bios_count;
      var $source;
      var $biosname;
      var $bios_flags;
      var $bios_number=__stackBase__;
      $1=$romdata;
      var $2=$1;
      var $3=__ZNK16_romload_private7machineEv($2);
      var $4=__ZNK15running_machine7optionsEv($3);
      var $5=__ZNK11emu_options4biosEv($4);
      $specbios=$5;
      $defaultname=0;
      $default_no=1;
      $bios_count=0;
      var $6=$1;
      var $7=(($6+4)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=$1;
      var $9=__ZNK16_romload_private7machineEv($8);
      var $10=__ZNK15running_machine6configEv($9);
      var $11=__Z16rom_first_sourceRK14machine_config($10);
      $source=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$source;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 31; break; }
    case 2: // $15
      var $16=$source;
      var $17=__ZNK8device_t10rom_regionEv($16);
      $rom=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$rom;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 & 15;
      var $23=(($22)|0)==2;
      var $24=$23 ^ 1;
      if ($24) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $25
      var $26=$rom;
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & 15;
      var $30=(($29)|0)==10;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=$rom;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      $defaultname=$34;
      __label__ = 6; break;
    case 6: // $35
      __label__ = 7; break;
    case 7: // $36
      var $37=$rom;
      var $38=(($37+20)|0);
      $rom=$38;
      __label__ = 3; break;
    case 8: // $39
      var $40=$source;
      var $41=__ZNK8device_t10rom_regionEv($40);
      $rom=$41;
      __label__ = 9; break;
    case 9: // $42
      var $43=$rom;
      var $44=(($43+16)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$45 & 15;
      var $47=(($46)|0)==2;
      var $48=$47 ^ 1;
      if ($48) { __label__ = 10; break; } else { __label__ = 20; break; }
    case 10: // $49
      var $50=$rom;
      var $51=(($50+16)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$52 & 15;
      var $54=(($53)|0)==9;
      if ($54) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $55
      var $56=$rom;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      $biosname=$58;
      var $59=$rom;
      var $60=(($59+16)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61 & -16777216;
      var $63=$62 >>> 24;
      $bios_flags=$63;
      var $64=(($bios_number)|0);
      var $65=$bios_flags;
      var $66=(($65-1)|0);
      var $67=_sprintf($64, ((STRING_TABLE.__str93860)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,tempInt));
      var $68=(($bios_number)|0);
      var $69=$specbios;
      var $70=__Z12core_stricmpPKcS0_($68, $69);
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $72
      var $73=$biosname;
      var $74=$specbios;
      var $75=__Z12core_stricmpPKcS0_($73, $74);
      var $76=(($75)|0)==0;
      if ($76) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $77
      var $78=$bios_flags;
      var $79=$1;
      var $80=(($79+4)|0);
      HEAP32[(($80)>>2)]=$78;
      __label__ = 14; break;
    case 14: // $81
      var $82=$defaultname;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $84
      var $85=$biosname;
      var $86=$defaultname;
      var $87=__Z12core_stricmpPKcS0_($85, $86);
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $89
      var $90=$bios_flags;
      $default_no=$90;
      __label__ = 17; break;
    case 17: // $91
      var $92=$bios_count;
      var $93=(($92+1)|0);
      $bios_count=$93;
      __label__ = 18; break;
    case 18: // $94
      __label__ = 19; break;
    case 19: // $95
      var $96=$rom;
      var $97=(($96+20)|0);
      $rom=$97;
      __label__ = 9; break;
    case 20: // $98
      var $99=$1;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101)|0)==0;
      if ($102) { __label__ = 21; break; } else { __label__ = 27; break; }
    case 21: // $103
      var $104=$bios_count;
      var $105=(($104)|0) > 0;
      if ($105) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $106
      var $107=$specbios;
      var $108=(($107)|0);
      var $109=HEAP8[($108)];
      var $110=(($109 << 24) >> 24);
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $112
      var $113=$specbios;
      var $114=_strcmp($113, ((STRING_TABLE.__str103861)|0));
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $116
      var $117=$1;
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $119
      var $120=$1;
      var $121=(($120+52)|0);
      var $122=$specbios;
      var $123=__ZN7astring9catprintfEPKcz($121, ((STRING_TABLE.__str113862)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$122,tempInt));
      var $124=$1;
      var $125=(($124+8)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+1)|0);
      HEAP32[(($125)>>2)]=$127;
      __label__ = 26; break;
    case 26: // $128
      var $129=$default_no;
      var $130=$1;
      var $131=(($130+4)|0);
      HEAP32[(($131)>>2)]=$129;
      __label__ = 27; break;
    case 27: // $132
      __label__ = 28; break;
    case 28: // $133
      __label__ = 29; break;
    case 29: // $134
      __label__ = 30; break;
    case 30: // $135
      var $136=$source;
      var $137=__Z15rom_next_sourceRK8device_t($136);
      $source=$137;
      __label__ = 1; break;
    case 31: // $138
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18determine_bios_romP16_romload_private["X"]=1;

function __ZL10count_romsP16_romload_private($romdata) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $region;
      var $rom;
      var $source;
      $1=$romdata;
      var $2=$1;
      var $3=(($2+24)|0);
      HEAP32[(($3)>>2)]=0;
      var $4=$1;
      var $5=(($4+32)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=$1;
      var $7=__ZNK16_romload_private7machineEv($6);
      var $8=__ZNK15running_machine6configEv($7);
      var $9=__Z16rom_first_sourceRK14machine_config($8);
      $source=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$source;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $13
      var $14=$source;
      var $15=__Z16rom_first_regionRK8device_t($14);
      $region=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$region;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $19
      var $20=$region;
      var $21=__Z14rom_first_filePK9rom_entry($20);
      $rom=$21;
      __label__ = 5; break;
    case 5: // $22
      var $23=$rom;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $25
      var $26=$rom;
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & -16777216;
      var $30=$29 >>> 24;
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $32
      var $33=$rom;
      var $34=(($33+16)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35 & -16777216;
      var $37=$36 >>> 24;
      var $38=$1;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($37)|0)==(($40)|0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+24)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+1)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$rom;
      var $48=__Z13rom_file_sizePK9rom_entry($47);
      var $49=$1;
      var $50=(($49+32)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$48)|0);
      HEAP32[(($50)>>2)]=$52;
      __label__ = 9; break;
    case 9: // $53
      __label__ = 10; break;
    case 10: // $54
      var $55=$rom;
      var $56=__Z13rom_next_filePK9rom_entry($55);
      $rom=$56;
      __label__ = 5; break;
    case 11: // $57
      __label__ = 12; break;
    case 12: // $58
      var $59=$region;
      var $60=__Z15rom_next_regionPK9rom_entry($59);
      $region=$60;
      __label__ = 3; break;
    case 13: // $61
      __label__ = 14; break;
    case 14: // $62
      var $63=$source;
      var $64=__Z15rom_next_sourceRK8device_t($63);
      $source=$64;
      __label__ = 1; break;
    case 15: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10count_romsP16_romload_private["X"]=1;

function __ZL24display_rom_load_resultsP16_romload_private($romdata) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$romdata;
      var $2=$1;
      __ZL27display_loading_rom_messageP16_romload_privatePKc($2, 0);
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+52)|0);
      var $10=__ZNK7astring4cstrEv($9);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str133864)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,tempInt));
      var $11=$1;
      var $12=__ZNK16_romload_private7machineEv($11);
      __Z19fatalerror_exitcodeR15running_machineiPKcz($12, 2, ((STRING_TABLE.__str143865)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $13
      var $14=$1;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$1;
      var $20=(($19+12)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$1;
      var $25=(($24+52)|0);
      var $26=__ZN7astring3catEPKc($25, ((STRING_TABLE.__str153866)|0));
      var $27=$1;
      var $28=(($27+52)|0);
      var $29=__ZNK7astring4cstrEv($28);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str163867)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$29,tempInt));
      __label__ = 5; break;
    case 5: // $30
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8rom_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $romdata;
      var $12;
      var $13;
      var $14=__stackBase__+44;
      $11=$machine;
      var $15=$11;
      var $16=__ZN15running_machine7respoolEv($15);
      var $17=$5;
      var $18=$6;
      var $19=$7;
      var $20=$8;
      var $21=$result_i;
      var $22=$9;
      var $23=$10;
      HEAP32[(($5)>>2)]=116;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($7)>>2)]=1516;
      HEAP32[(($8)>>2)]=_zeromem;
      var $24=HEAP32[(($5)>>2)];
      var $25=HEAP32[(($6)>>2)];
      var $26=HEAP32[(($7)>>2)];
      var $27=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $28
      HEAP32[(($result_i)>>2)]=$27;
      var $29=HEAP32[(($result_i)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $31
      var $32=___cxa_allocate_exception(4);
      var $33=$32;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($33);
      (function() { try { __THREW__ = false; return ___cxa_throw($32, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      HEAP32[(($9)>>2)]=$36;
      var $37=$35.f1;
      HEAP32[(($10)>>2)]=$37;
      var $38=HEAP32[(($10)>>2)];
      var $39=(($38)|0) < 0;
      if ($39) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $40
      var $41=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($41);
      throw "Reached an unreachable!"
    case 5: // $42
      var $43=HEAP32[(($9)>>2)];
      var $44=HEAP32[(($9)>>2)];
      var $45=HEAP32[(($10)>>2)];
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $48
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $49=HEAP32[(($result_i)>>2)];
      var $50=HEAP32[(($5)>>2)];
      _memset($49, 0, $50, 1);
      var $51=HEAP32[(($result_i)>>2)];
      var $52=$5;
      var $53=$6;
      var $54=$7;
      var $55=$8;
      var $56=$result_i;
      var $57=$9;
      var $58=$10;
      var $59=$51;
      (function() { try { __THREW__ = false; return __ZN16_romload_privateC1Ev($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $60
      var $61=__ZN13resource_pool10add_objectI16_romload_privateEEPT_S3_($16, $59);
      $romdata=$61;
      var $62=$11;
      var $63=(($62+636)|0);
      HEAP32[(($63)>>2)]=$61;
      var $64=$11;
      var $65=$11;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($14, 932, ((STRING_TABLE.__str83859)|0), $65);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($64, 4, $14);
      var $66=$11;
      var $67=$romdata;
      var $68=(($67)|0);
      HEAP32[(($68)>>2)]=$66;
      var $69=$romdata;
      __ZL18determine_bios_romP16_romload_private($69);
      var $70=$romdata;
      __ZL10count_romsP16_romload_private($70);
      var $71=$romdata;
      var $72=(($71+40)|0);
      HEAP32[(($72)>>2)]=0;
      var $73=$11;
      var $74=(($73+636)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+40)|0);
      var $77=$romdata;
      var $78=(($77+44)|0);
      HEAP32[(($78)>>2)]=$76;
      var $79=$romdata;
      __ZL19process_region_listP16_romload_private($79);
      var $80=$romdata;
      __ZL24display_rom_load_resultsP16_romload_private($80);
      STACKTOP = __stackBase__;
      return;
    case 9: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      $12=$83;
      var $84=$82.f1;
      $13=$84;
      var $85=$1;
      var $86=$2;
      var $87=$3;
      var $88=$4;
      HEAP32[(($1)>>2)]=$51;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($3)>>2)]=1516;
      HEAP32[(($4)>>2)]=_zeromem;
      var $89=HEAP32[(($1)>>2)];
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $91
      var $92=HEAP32[(($1)>>2)];
      var $93=HEAP32[(($2)>>2)];
      var $94=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($92, $93, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKciRK9zeromem_t_exit
      var $95=$1;
      var $96=$2;
      var $97=$3;
      var $98=$4;
      __label__ = 13; break;
    case 13: // $99
      __label__ = 14; break;
    case 14: // $100
      var $101=$12;
      var $102=$12;
      var $103=$13;
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z8rom_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI16_romload_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16_romload_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16_romload_privateEEPT_S3_["X"]=1;

function __Z17rom_load_warningsR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=(($2+636)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __Z17rom_load_knownbadR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=(($2+636)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+12)|0);
  var $6=HEAP32[(($5)>>2)];
  ;
  return $6;
}


function __ZN20resource_pool_objectI16_romload_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16_romload_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16_romload_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 116);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16_romload_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16_romload_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16_romload_privateED2Ev($2);
  ;
  return;
}


function __ZN16_romload_privateD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16_romload_privateD2Ev($2);
  ;
  return;
}


function __ZN16_romload_privateD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZNK11emu_options4biosEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str123863)|0));
  ;
  return $4;
}


function __ZN16_romload_privateC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+52)|0);
  __ZN7astringC1Ev($3);
  ;
  return;
}


function __ZL27display_loading_rom_messageP16_romload_privatePKc($romdata, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $buffer=__stackBase__;
      $1=$romdata;
      $2=$name;
      var $3=$2;
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=(($buffer)|0);
      var $12=$1;
      var $13=(($12+28)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15$0=$14;
      var $15$1=0;
      var $$emscripten$temp$0$0=100;
      var $$emscripten$temp$0$1=0;
      var $16$0 = ((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))*((($15$0)>>>0)+((($15$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))*((($15$0)>>>0)+((($15$1)|0)*4294967296)))/4294967296), 4294967295);
      var $17=$1;
      var $18=(($17+32)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20$0=$19;
      var $20$1=0;
      var $21$0 = Math.floor(((($16$0)>>>0)+((($16$1)|0)*4294967296))/((($20$0)>>>0)+((($20$1)|0)*4294967296)))>>>0; var $21$1 = Math.min(Math.floor((Math.floor(((($16$0)>>>0)+((($16$1)|0)*4294967296))/((($20$0)>>>0)+((($20$1)|0)*4294967296))))/4294967296), 4294967295);
      var $22$0=$21$0;
      var $22=$22$0;
      var $23=_sprintf($11, ((STRING_TABLE.__str173868)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,tempInt));
      __label__ = 4; break;
    case 3: // $24
      var $25=(($buffer)|0);
      var $26=_sprintf($25, ((STRING_TABLE.__str183869)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=$1;
      var $29=__ZNK16_romload_private7machineEv($28);
      var $30=(($buffer)|0);
      __Z19ui_set_startup_textR15running_machinePKci($29, $30, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15hash_collectionneERKS_($this, $rhs) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rhs;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK15hash_collectioneqERKS_($3, $4);
  var $6=$5 ^ 1;
  ;
  return $6;
}


function __ZL19process_region_listP16_romload_private($romdata) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $regiontag=__stackBase__;
      var $source;
      var $region;
      var $2;
      var $3;
      var $regionlength;
      var $width=__stackBase__+64;
      var $endianness=__stackBase__+68;
      $1=$romdata;
      __ZN7astringC1Ev($regiontag);
      var $4=$1;
      var $5=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 26; break; };
    case 1: // $6
      var $7=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 26; break; };
    case 2: // $8
      var $9=(function() { try { __THREW__ = false; return __Z16rom_first_sourceRK14machine_config($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 26; break; };
    case 3: // $10
      $source=$9;
      __label__ = 4; break;
    case 4: // $11
      var $12=$source;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 5; break; } else { __label__ = 58; break; }
    case 5: // $14
      var $15=$source;
      var $16=(function() { try { __THREW__ = false; return __Z16rom_first_regionRK8device_t($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 26; break; };
    case 6: // $17
      $region=$16;
      __label__ = 7; break;
    case 7: // $18
      var $19=$region;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 8; break; } else { __label__ = 55; break; }
    case 8: // $21
      var $22=$region;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      $regionlength=$24;
      var $25=$1;
      var $26=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 26; break; };
    case 9: // $27
      var $28=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 26; break; };
    case 10: // $29
      var $30=$source;
      var $31=$region;
      var $32=(function() { try { __THREW__ = false; return __Z15rom_region_nameR7astringPK11game_driverPK8device_tPK9rom_entry($regiontag, $28, $30, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 26; break; };
    case 11: // $33
      __label__ = 12; break;
    case 12: // $34
      __label__ = 13; break;
    case 13: // $35
      __label__ = 14; break;
    case 14: // $36
      __label__ = 15; break;
    case 15: // $37
      __label__ = 16; break;
    case 16: // $38
      __label__ = 17; break;
    case 17: // $39
      var $40=$region;
      var $41=(($40+16)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$42 & 16384;
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 18; break; } else { __label__ = 48; break; }
    case 18: // $45
      var $46=$region;
      var $47=(($46+16)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48 & 768;
      var $50=$49 >>> 8;
      var $51=8 << $50;
      var $52=(((($51)|0)/8)|0);
      var $53=(($52) & 255);
      HEAP8[($width)]=$53;
      var $54=$region;
      var $55=(($54+16)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56 & 1024;
      var $58=(($57)|0)==1024;
      var $59=$58 ? 1 : 0;
      HEAP32[(($endianness)>>2)]=$59;
      var $60=$1;
      var $61=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 26; break; };
    case 19: // $62
      var $63=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; };
    case 20: // $64
      var $65=(function() { try { __THREW__ = false; return __ZN15running_machine6deviceEPKc($61, $63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; };
    case 21: // $66
      var $67=(($65)|0)!=0;
      if ($67) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $68
      var $69=$1;
      var $70=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 26; break; };
    case 23: // $71
      var $72=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; };
    case 24: // $73
      (function() { try { __THREW__ = false; return __ZL26normalize_flags_for_deviceR15running_machinePKcRhR12endianness_t($70, $72, $width, $endianness) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $74
      __label__ = 27; break;
    case 26: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      $2=$77;
      var $78=$76.f1;
      $3=$78;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 27: // $79
      var $80=$1;
      var $81=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 26; break; };
    case 28: // $82
      var $83=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 26; break; };
    case 29: // $84
      var $85=$regionlength;
      var $86=HEAP8[($width)];
      var $87=HEAP32[(($endianness)>>2)];
      var $88=(function() { try { __THREW__ = false; return __ZN15running_machine12region_allocEPKcjh12endianness_t($81, $83, $85, $86, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 26; break; };
    case 30: // $89
      var $90=$1;
      var $91=(($90+48)|0);
      HEAP32[(($91)>>2)]=$88;
      __label__ = 31; break;
    case 31: // $92
      __label__ = 32; break;
    case 32: // $93
      __label__ = 33; break;
    case 33: // $94
      var $95=$region;
      var $96=(($95+16)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$97 & 8192;
      var $99=(($98)|0)==8192;
      if ($99) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 34: // $100
      var $101=$1;
      var $102=(($101+48)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(function() { try { __THREW__ = false; return __ZNK13memory_region4baseEv($103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 26; break; };
    case 35: // $105
      var $106=$region;
      var $107=(($106+16)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$108 & 16711680;
      var $110=$109 >>> 16;
      var $111=(($110) & 255);
      var $112=$1;
      var $113=(($112+48)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 26; break; };
    case 36: // $116
      _memset($104, $111, $115, 1);
      __label__ = 43; break;
    case 37: // $117
      var $118=$1;
      var $119=(($118+48)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 26; break; };
    case 38: // $122
      var $123=(($121)>>>0) <= 4194304;
      if ($123) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $124
      var $125=$1;
      var $126=(($125+48)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(function() { try { __THREW__ = false; return __ZNK13memory_region4baseEv($127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 26; break; };
    case 40: // $129
      var $130=$1;
      var $131=(($130+48)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 26; break; };
    case 41: // $134
      _memset($128, 0, $133, 1);
      __label__ = 42; break;
    case 42: // $135
      __label__ = 43; break;
    case 43: // $136
      var $137=$1;
      var $138=$region;
      var $139=(($138+16)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=$140 & 32768;
      var $142=(($141)|0)==32768;
      if ($142) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $143
      var $144=$region;
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      var $149 = $146;__label__ = 46; break;
    case 45: // $147
      var $149 = 0;__label__ = 46; break;
    case 46: // $148
      var $149;
      var $150=$region;
      var $151=(($150+20)|0);
      (function() { try { __THREW__ = false; return __ZL19process_rom_entriesP16_romload_privatePKcPK9rom_entry($137, $149, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 26; break; }
    case 47: // $152
      __label__ = 52; break;
    case 48: // $153
      var $154=$region;
      var $155=(($154+16)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$156 & 16384;
      var $158=(($157)|0)==16384;
      if ($158) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $159
      var $160=$1;
      var $161=$region;
      var $162=(($161)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$region;
      var $165=(($164+20)|0);
      (function() { try { __THREW__ = false; return __ZL20process_disk_entriesP16_romload_privatePKcPK9rom_entryS2_($160, $163, $165, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 26; break; }
    case 50: // $166
      __label__ = 51; break;
    case 51: // $167
      __label__ = 52; break;
    case 52: // $168
      __label__ = 53; break;
    case 53: // $169
      var $170=$region;
      var $171=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 26; break; };
    case 54: // $172
      $region=$171;
      __label__ = 7; break;
    case 55: // $173
      __label__ = 56; break;
    case 56: // $174
      var $175=$source;
      var $176=(function() { try { __THREW__ = false; return __Z15rom_next_sourceRK8device_t($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 26; break; };
    case 57: // $177
      $source=$176;
      __label__ = 4; break;
    case 58: // $178
      var $179=$1;
      var $180=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 26; break; };
    case 59: // $181
      var $182=(function() { try { __THREW__ = false; return __ZNK15running_machine6configEv($180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 26; break; };
    case 60: // $183
      var $184=(function() { try { __THREW__ = false; return __Z16rom_first_sourceRK14machine_config($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 26; break; };
    case 61: // $185
      $source=$184;
      __label__ = 62; break;
    case 62: // $186
      var $187=$source;
      var $188=(($187)|0)!=0;
      if ($188) { __label__ = 63; break; } else { __label__ = 77; break; }
    case 63: // $189
      var $190=$source;
      var $191=(function() { try { __THREW__ = false; return __Z16rom_first_regionRK8device_t($190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 26; break; };
    case 64: // $192
      $region=$191;
      __label__ = 65; break;
    case 65: // $193
      var $194=$region;
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 66; break; } else { __label__ = 74; break; }
    case 66: // $196
      var $197=$1;
      var $198=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($197) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 26; break; };
    case 67: // $199
      var $200=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 26; break; };
    case 68: // $201
      var $202=$source;
      var $203=$region;
      var $204=(function() { try { __THREW__ = false; return __Z15rom_region_nameR7astringPK11game_driverPK8device_tPK9rom_entry($regiontag, $200, $202, $203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 26; break; };
    case 69: // $205
      var $206=$1;
      var $207=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($regiontag) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 26; break; };
    case 70: // $208
      var $209=$region;
      var $210=(($209+16)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=$211 & 2048;
      var $213=(($212)|0)==2048;
      (function() { try { __THREW__ = false; return __ZL19region_post_processP16_romload_privatePKcb($206, $207, $213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 26; break; }
    case 71: // $214
      __label__ = 72; break;
    case 72: // $215
      var $216=$region;
      var $217=(function() { try { __THREW__ = false; return __Z15rom_next_regionPK9rom_entry($216) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 26; break; };
    case 73: // $218
      $region=$217;
      __label__ = 65; break;
    case 74: // $219
      __label__ = 75; break;
    case 75: // $220
      var $221=$source;
      var $222=(function() { try { __THREW__ = false; return __Z15rom_next_sourceRK8device_t($221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 26; break; };
    case 76: // $223
      $source=$222;
      __label__ = 62; break;
    case 77: // $224
      FUNCTION_TABLE[__ZN7astringD1Ev]($regiontag);
      STACKTOP = __stackBase__;
      return;
    case 78: // $225
      __label__ = 79; break;
    case 79: // $226
      var $227=$2;
      var $228=$2;
      var $229=$3;
      var $230=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $228, tempValue);
      var $231=($230.f1 = $229, $230);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 80: // $232
      var $233=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19process_region_listP16_romload_private["X"]=1;

function __ZN20resource_pool_objectI16_romload_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16_romload_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16_romload_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI16_romload_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI16_romload_privateE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN16_romload_privateD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16_romload_privateED2Ev["X"]=1;

function __ZL32dump_wrong_and_correct_checksumsP16_romload_privateRK15hash_collectionS3_($romdata, $hashes, $acthashes) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tempstr=__stackBase__;
      var $4;
      var $5;
      var $hash;
      $1=$romdata;
      $2=$hashes;
      $3=$acthashes;
      __ZN7astringC1Ev($tempstr);
      var $6=$1;
      var $7=(($6+52)|0);
      var $8=$2;
      var $9=(function() { try { __THREW__ = false; return __ZNK15hash_collection12macro_stringER7astring($8, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 12; break; };
    case 1: // $10
      var $11=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($7, ((STRING_TABLE.__str263877)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$9,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 12; break; };
    case 2: // $12
      var $13=$1;
      var $14=(($13+52)|0);
      var $15=$3;
      var $16=(function() { try { __THREW__ = false; return __ZNK15hash_collection12macro_stringER7astring($15, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 12; break; };
    case 3: // $17
      var $18=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($14, ((STRING_TABLE.__str273878)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; };
    case 4: // $19
      var $20=$2;
      var $21=(function() { try { __THREW__ = false; return __ZNK15hash_collection5firstEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; };
    case 5: // $22
      $hash=$21;
      __label__ = 6; break;
    case 6: // $23
      var $24=$hash;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $26
      var $27=$hash;
      var $28=(function() { try { __THREW__ = false; return __ZNK9hash_base11parse_errorEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $29
      if ($28) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $30
      var $31=$1;
      var $32=(($31+52)|0);
      var $33=$hash;
      var $34=(function() { try { __THREW__ = false; return __ZNK9hash_base4nameEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($32, ((STRING_TABLE.__str283879)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; };
    case 11: // $37
      var $38=$1;
      var $39=(($38+8)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+1)|0);
      HEAP32[(($39)>>2)]=$41;
      __label__ = 13; break;
    case 12: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      $4=$44;
      var $45=$43.f1;
      $5=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 13: // $46
      __label__ = 14; break;
    case 14: // $47
      var $48=$hash;
      var $49=(function() { try { __THREW__ = false; return __ZNK9hash_base4nextEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; };
    case 15: // $50
      $hash=$49;
      __label__ = 6; break;
    case 16: // $51
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      STACKTOP = __stackBase__;
      return;
    case 17: // $52
      __label__ = 18; break;
    case 18: // $53
      var $54=$4;
      var $55=$4;
      var $56=$5;
      var $57=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $55, tempValue);
      var $58=($57.f1 = $56, $57);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32dump_wrong_and_correct_checksumsP16_romload_privateRK15hash_collectionS3_["X"]=1;

function __ZN8emu_file13set_openflagsEj($this, $openflags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$openflags;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+152)|0);
      HEAP32[(($7)>>2)]=$6;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK9hash_base11parse_errorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+13)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK11emu_options14diff_directoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str253876)|0));
  ;
  return $4;
}


function __ZL14open_disk_diffR11emu_optionsPK9rom_entryP9_chd_filePP8emu_filePS5_($options, $romp, $source, $diff_file, $diff_chd) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $fname=__stackBase__+36;
      var $err;
      var $15;
      var $16;
      var $filerr;
      var $17;
      $10=$options;
      $11=$romp;
      $12=$source;
      $13=$diff_file;
      $14=$diff_chd;
      var $18=$11;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      __ZN7astringC1EPKcS1_($fname, $20, ((STRING_TABLE.__str243875)|0));
      var $21=$13;
      HEAP32[(($21)>>2)]=0;
      var $22=$14;
      HEAP32[(($22)>>2)]=0;
      __label__ = 1; break;
    case 1: // $23
      __label__ = 2; break;
    case 2: // $24
      __label__ = 3; break;
    case 3: // $25
      var $26=$4;
      var $27=$5;
      var $28=$6;
      var $29=$result_i;
      var $30=$7;
      var $31=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($6)>>2)]=1167;
      var $32=HEAP32[(($4)>>2)];
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($6)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; }
    case 6: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($7)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($8)>>2)]=$45;
      var $46=HEAP32[(($8)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $48
      var $49=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 26; break; }
    case 8: // $_noexc
      throw "Reached an unreachable!"
    case 9: // $50
      var $51=HEAP32[(($7)>>2)];
      var $52=HEAP32[(($7)>>2)];
      var $53=HEAP32[(($8)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      var $eh_lpad_body = $55;__label__ = 27; break;
    case 10: // $56
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKci_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$4;
      var $59=$5;
      var $60=$6;
      var $61=$result_i;
      var $62=$7;
      var $63=$8;
      __label__ = 12; break;
    case 12: // $64
      var $65=$57;
      var $66=$10;
      var $67=(function() { try { __THREW__ = false; return __ZNK11emu_options14diff_directoryEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 28; break; };
    case 13: // $68
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($65, $67, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 28; break; }
    case 14: // $69
      var $70=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI8emu_fileEEPT_S3_(_global_resource_pool, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 26; break; };
    case 15: // $71
      var $72=$13;
      HEAP32[(($72)>>2)]=$70;
      var $73=$13;
      var $74=HEAP32[(($73)>>2)];
      var $75=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 26; break; };
    case 16: // $76
      var $77=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($74, $75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 26; break; };
    case 17: // $78
      $filerr=$77;
      var $79=$filerr;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 18; break; } else { __label__ = 38; break; }
    case 18: // $81
      __label__ = 19; break;
    case 19: // $82
      __label__ = 20; break;
    case 20: // $83
      __label__ = 21; break;
    case 21: // $84
      var $85=$13;
      var $86=HEAP32[(($85)>>2)];
      (function() { try { __THREW__ = false; return __ZN8emu_file13set_openflagsEj($86, 15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $87
      var $88=$13;
      var $89=HEAP32[(($88)>>2)];
      var $90=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 26; break; };
    case 23: // $91
      var $92=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($89, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; };
    case 24: // $93
      $filerr=$92;
      var $94=$filerr;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 25; break; } else { __label__ = 33; break; }
    case 25: // $96
      $err=6;
      __label__ = 46; break;
    case 26: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $98;__label__ = 27; break;
    case 27: // $_body
      var $eh_lpad_body;
      var $99=$eh_lpad_body.f0;
      $15=$99;
      var $100=$eh_lpad_body.f1;
      $16=$100;
      __label__ = 51; break;
    case 28: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $103=$102.f0;
      $15=$103;
      var $104=$102.f1;
      $16=$104;
      var $105=$1;
      var $106=$2;
      var $107=$3;
      HEAP32[(($1)>>2)]=$57;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($3)>>2)]=1167;
      var $108=HEAP32[(($1)>>2)];
      var $109=(($108)|0)!=0;
      if ($109) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $110
      var $111=HEAP32[(($1)>>2)];
      var $112=HEAP32[(($2)>>2)];
      var $113=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($111, $112, $113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 54; break; }
    case 30: // $_noexc1
      __label__ = 31; break;
    case 31: // $_ZdlPvPKci_exit
      var $114=$1;
      var $115=$2;
      var $116=$3;
      __label__ = 32; break;
    case 32: // $117
      __label__ = 51; break;
    case 33: // $118
      var $119=$13;
      var $120=HEAP32[(($119)>>2)];
      var $121=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 26; break; };
    case 34: // $122
      var $123=$12;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $124=(function() { try { __THREW__ = false; return __Z15chd_create_fileP10_core_fileyjjP9_chd_file($121, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0, 0, $123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 26; break; };
      var $124$0=$124[0];
    case 35: // $125
      $err=$124;
      var $126=$err;
      var $127=(($126)|0)!=0;
      if ($127) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $128
      __label__ = 46; break;
    case 37: // $129
      __label__ = 38; break;
    case 38: // $130
      __label__ = 39; break;
    case 39: // $131
      __label__ = 40; break;
    case 40: // $132
      __label__ = 41; break;
    case 41: // $133
      var $134=$13;
      var $135=HEAP32[(($134)>>2)];
      var $136=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 26; break; };
    case 42: // $137
      var $138=$12;
      var $139=$14;
      var $140=(function() { try { __THREW__ = false; return __Z13chd_open_fileP10_core_fileiP9_chd_filePS2_($136, 2, $138, $139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 26; break; };
    case 43: // $141
      $err=$140;
      var $142=$err;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $144
      __label__ = 46; break;
    case 45: // $145
      __label__ = 46; break;
    case 46: // $146
      var $147=$err;
      var $148=(($147)|0)!=0;
      if ($148) { __label__ = 47; break; } else { __label__ = 50; break; }
    case 47: // $149
      var $150=$13;
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $153
      var $154=$13;
      var $155=HEAP32[(($154)>>2)];
      var $156=$155;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 26; break; }
    case 49: // $157
      var $158=$13;
      HEAP32[(($158)>>2)]=0;
      __label__ = 50; break;
    case 50: // $159
      var $160=$err;
      $9=$160;
      $17=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($fname);
      var $161=$9;
      STACKTOP = __stackBase__;
      return $161;
    case 51: // $162
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $163
      __label__ = 53; break;
    case 53: // $164
      var $165=$15;
      var $166=$15;
      var $167=$16;
      var $168=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $166, tempValue);
      var $169=($168.f1 = $167, $168);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 54: // $170
      var $171=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14open_disk_diffR11emu_optionsPK9rom_entryP9_chd_filePP8emu_filePS5_["X"]=1;

function __ZL13fill_rom_dataP16_romload_privatePK9rom_entry($romdata, $romp) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $numbytes;
      var $base;
      $1=$romdata;
      $2=$romp;
      var $3=$2;
      var $4=(($3+12)|0);
      var $5=HEAP32[(($4)>>2)];
      $numbytes=$5;
      var $6=$1;
      var $7=(($6+48)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK13memory_region4baseEv($8);
      var $10=$2;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($9+$12)|0);
      $base=$13;
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$numbytes;
      var $18=(($16+$17)|0);
      var $19=$1;
      var $20=(($19+48)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=__ZNK13memory_region5bytesEv($21);
      var $23=(($18)>>>0) > (($22)>>>0);
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      __Z10fatalerrorPKcz(((STRING_TABLE.__str443895)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $25
      var $26=$numbytes;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      __Z10fatalerrorPKcz(((STRING_TABLE.__str453896)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 4: // $29
      var $30=$base;
      var $31=$2;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33;
      var $35=$34 & 255;
      var $36=(($35) & 255);
      var $37=$numbytes;
      _memset($30, $36, $37, 1);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13copy_rom_dataP16_romload_privatePK9rom_entry($romdata, $romp) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $base;
      var $srcrgntag;
      var $numbytes;
      var $srcoffs;
      var $region;
      $1=$romdata;
      $2=$romp;
      var $3=$1;
      var $4=(($3+48)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK13memory_region4baseEv($5);
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6+$9)|0);
      $base=$10;
      var $11=$2;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      $srcrgntag=$13;
      var $14=$2;
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      $numbytes=$16;
      var $17=$2;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      $srcoffs=$20;
      var $21=$2;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$numbytes;
      var $25=(($23+$24)|0);
      var $26=$1;
      var $27=(($26+48)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=__ZNK13memory_region5bytesEv($28);
      var $30=(($25)>>>0) > (($29)>>>0);
      if ($30) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $31
      __Z10fatalerrorPKcz(((STRING_TABLE.__str403891)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $32
      var $33=$numbytes;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      __Z10fatalerrorPKcz(((STRING_TABLE.__str413892)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 4: // $36
      var $37=$1;
      var $38=__ZNK16_romload_private7machineEv($37);
      var $39=$srcrgntag;
      var $40=__ZN15running_machine6regionEPKc($38, $39);
      $region=$40;
      var $41=$region;
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      __Z10fatalerrorPKcz(((STRING_TABLE.__str423893)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 6: // $44
      var $45=$srcoffs;
      var $46=$numbytes;
      var $47=(($45+$46)|0);
      var $48=$region;
      var $49=__ZNK13memory_region5bytesEv($48);
      var $50=(($47)>>>0) > (($49)>>>0);
      if ($50) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $51
      __Z10fatalerrorPKcz(((STRING_TABLE.__str433894)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 8: // $52
      var $53=$base;
      var $54=$region;
      var $55=__ZNK13memory_region4baseEv($54);
      var $56=$srcoffs;
      var $57=(($55+$56)|0);
      var $58=$numbytes;
      assert($58 % 1 === 0, 'memcpy given ' + $58 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($53, $57, $58, 1);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13copy_rom_dataP16_romload_privatePK9rom_entry["X"]=1;

function __ZL13open_rom_fileP16_romload_privatePKcPK9rom_entry($romdata, $regiontag, $romp) {
  var __stackBase__  = STACKTOP; STACKTOP += 472; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $filerr;
      var $romsize;
      var $crc=__stackBase__;
      var $has_crc;
      var $4=__stackBase__+4;
      var $5;
      var $6;
      var $drv;
      var $tag1=__stackBase__+88;
      var $tag2=__stackBase__+152;
      var $tag3=__stackBase__+216;
      var $tag4=__stackBase__+280;
      var $tag5=__stackBase__+344;
      var $is_list;
      var $has_parent;
      var $separator1;
      var $separator2;
      var $swlist=__stackBase__+408;
      $1=$romdata;
      $2=$regiontag;
      $3=$romp;
      $filerr=3;
      var $7=$3;
      var $8=__Z13rom_file_sizePK9rom_entry($7);
      $romsize=$8;
      var $9=$1;
      var $10=$3;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      __ZL27display_loading_rom_messageP16_romload_privatePKc($9, $12);
      HEAP32[(($crc)>>2)]=0;
      var $13=$3;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($4, $15);
      var $16=(function() { try { __THREW__ = false; return __ZNK15hash_collection3crcERj($4, $crc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; };
    case 1: // $17
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($4);
      var $18=(($16)&1);
      $has_crc=$18;
      var $19=$1;
      var $20=(($19+36)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=$1;
      var $22=__ZNK16_romload_private7machineEv($21);
      var $23=__ZNK15running_machine6systemEv($22);
      var $24=__ZN11driver_list4findERK11game_driver($23);
      $drv=$24;
      __label__ = 2; break;
    case 2: // $25
      var $26=$1;
      var $27=(($26+36)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 3; break; } else { var $34 = 0;__label__ = 4; break; }
    case 3: // $30
      var $31=$drv;
      var $32=(($31)|0)!=-1;
      var $34 = $32;__label__ = 4; break;
    case 4: // $33
      var $34;
      if ($34) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $35
      var $36=$1;
      var $37=__ZNK16_romload_private7machineEv($36);
      var $38=__ZNK15running_machine7optionsEv($37);
      var $39=$drv;
      var $40=__ZN11driver_list6driverEi($39);
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$has_crc;
      var $44=(($43) & 1);
      var $45=HEAP32[(($crc)>>2)];
      var $46=$3;
      var $47=$1;
      var $48=(($47+36)|0);
      var $49=__Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($38, $42, $44, $45, $46, $48);
      $filerr=$49;
      __label__ = 6; break;
    case 6: // $50
      var $51=$drv;
      var $52=__ZN11driver_list5cloneEi($51);
      $drv=$52;
      __label__ = 2; break;
    case 7: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $5=$55;
      var $56=$54.f1;
      $6=$56;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 109; break; }
    case 8: // $57
      __label__ = 108; break;
    case 9: // $58
      var $59=$1;
      var $60=(($59+36)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 10; break; } else { __label__ = 107; break; }
    case 10: // $63
      var $64=$2;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 11; break; } else { __label__ = 107; break; }
    case 11: // $66
      var $67=$2;
      __ZN7astringC1EPKc($tag1, $67);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 29; break; }
    case 12: // $68
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 30; break; }
    case 13: // $69
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 31; break; }
    case 14: // $70
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 32; break; }
    case 15: // $71
      $is_list=0;
      $has_parent=0;
      var $72=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag1, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 33; break; };
    case 16: // $73
      $separator1=$72;
      var $74=$separator1;
      var $75=(($74)|0)!=-1;
      if ($75) { __label__ = 17; break; } else { __label__ = 47; break; }
    case 17: // $76
      $is_list=1;
      var $77=$separator1;
      var $78=(($77+1)|0);
      var $79=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 33; break; };
    case 18: // $80
      var $81=$separator1;
      var $82=(($79-$81)|0);
      var $83=(($82+1)|0);
      var $84=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($tag4, $tag1, $78, $83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 33; break; };
    case 19: // $85
      var $86=$separator1;
      var $87=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 33; break; };
    case 20: // $88
      var $89=$separator1;
      var $90=(($87-$89)|0);
      var $91=(function() { try { __THREW__ = false; return __ZN7astring3delEii($tag1, $86, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 33; break; };
    case 21: // $92
      var $93=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tag1, ((STRING_TABLE.__str23853)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 33; break; };
    case 22: // $94
      var $95=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag4, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 33; break; };
    case 23: // $96
      $separator2=$95;
      var $97=$separator2;
      var $98=(($97)|0)!=-1;
      if ($98) { __label__ = 24; break; } else { __label__ = 34; break; }
    case 24: // $99
      $has_parent=1;
      var $100=$separator2;
      var $101=(($100+1)|0);
      var $102=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 33; break; };
    case 25: // $103
      var $104=$separator2;
      var $105=(($102-$104)|0);
      var $106=(($105+1)|0);
      var $107=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($tag5, $tag4, $101, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 33; break; };
    case 26: // $108
      var $109=$separator2;
      var $110=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 33; break; };
    case 27: // $111
      var $112=$separator2;
      var $113=(($110-$112)|0);
      var $114=(function() { try { __THREW__ = false; return __ZN7astring3delEii($tag4, $109, $113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 33; break; };
    case 28: // $115
      __label__ = 34; break;
    case 29: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $118=$117.f0;
      $5=$118;
      var $119=$117.f1;
      $6=$119;
      __label__ = 105; break;
    case 30: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $122=$121.f0;
      $5=$122;
      var $123=$121.f1;
      $6=$123;
      __label__ = 103; break;
    case 31: // $124
      var $125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $126=$125.f0;
      $5=$126;
      var $127=$125.f1;
      $6=$127;
      __label__ = 101; break;
    case 32: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $130=$129.f0;
      $5=$130;
      var $131=$129.f1;
      $6=$131;
      __label__ = 99; break;
    case 33: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $134=$133.f0;
      $5=$134;
      var $135=$133.f1;
      $6=$135;
      __label__ = 97; break;
    case 34: // $136
      var $137=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 33; break; };
    case 35: // $138
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($swlist, $137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 33; break; }
    case 36: // $139
      var $140=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($swlist, $tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 43; break; };
    case 37: // $141
      var $142=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($tag2, $140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 43; break; };
    case 38: // $143
      var $144=$has_parent;
      var $145=(($144) & 1);
      if ($145) { __label__ = 39; break; } else { __label__ = 44; break; }
    case 39: // $146
      var $147=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($swlist, $tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 43; break; };
    case 40: // $148
      var $149=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($swlist, $tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; };
    case 41: // $150
      var $151=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($tag3, $149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 43; break; };
    case 42: // $152
      __label__ = 44; break;
    case 43: // $153
      var $154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $155=$154.f0;
      $5=$155;
      var $156=$154.f1;
      $6=$156;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($swlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 109; break; }
    case 44: // $157
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($swlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 33; break; }
    case 45: // $158
      __label__ = 47; break;
    case 46: // $159
      __label__ = 97; break;
    case 47: // $160
      var $161=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($tag5, 0, 37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 33; break; };
    case 48: // $162
      var $163=(($161)|0)!=-1;
      if ($163) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $164
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str43855)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 33; break; }
    case 50: // $165
      throw "Reached an unreachable!"
    case 51: // $166
      var $167=$is_list;
      var $168=(($167) & 1);
      if ($168) { __label__ = 57; break; } else { __label__ = 52; break; }
    case 52: // $169
      var $170=$1;
      var $171=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 33; break; };
    case 53: // $172
      var $173=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 33; break; };
    case 54: // $174
      var $175=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 33; break; };
    case 55: // $176
      var $177=$has_crc;
      var $178=(($177) & 1);
      var $179=HEAP32[(($crc)>>2)];
      var $180=$3;
      var $181=$1;
      var $182=(($181+36)|0);
      var $183=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($173, $175, $178, $179, $180, $182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 33; break; };
    case 56: // $184
      $filerr=$183;
      __label__ = 92; break;
    case 57: // $185
      var $186=$1;
      var $187=(($186+36)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($188)|0)==0;
      if ($189) { __label__ = 58; break; } else { __label__ = 65; break; }
    case 58: // $190
      var $191=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 33; break; };
    case 59: // $192
      var $193=(($191)|0)!=0;
      if ($193) { __label__ = 60; break; } else { __label__ = 65; break; }
    case 60: // $194
      var $195=$1;
      var $196=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 33; break; };
    case 61: // $197
      var $198=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($196) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 33; break; };
    case 62: // $199
      var $200=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 33; break; };
    case 63: // $201
      var $202=$has_crc;
      var $203=(($202) & 1);
      var $204=HEAP32[(($crc)>>2)];
      var $205=$3;
      var $206=$1;
      var $207=(($206+36)|0);
      var $208=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($198, $200, $203, $204, $205, $207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 33; break; };
    case 64: // $209
      $filerr=$208;
      __label__ = 65; break;
    case 65: // $210
      var $211=$1;
      var $212=(($211+36)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213)|0)==0;
      if ($214) { __label__ = 66; break; } else { __label__ = 74; break; }
    case 66: // $215
      var $216=$has_parent;
      var $217=(($216) & 1);
      if ($217) { __label__ = 67; break; } else { __label__ = 74; break; }
    case 67: // $218
      var $219=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 33; break; };
    case 68: // $220
      var $221=(($219)|0)!=0;
      if ($221) { __label__ = 69; break; } else { __label__ = 74; break; }
    case 69: // $222
      var $223=$1;
      var $224=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 33; break; };
    case 70: // $225
      var $226=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 33; break; };
    case 71: // $227
      var $228=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 33; break; };
    case 72: // $229
      var $230=$has_crc;
      var $231=(($230) & 1);
      var $232=HEAP32[(($crc)>>2)];
      var $233=$3;
      var $234=$1;
      var $235=(($234+36)|0);
      var $236=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($226, $228, $231, $232, $233, $235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 33; break; };
    case 73: // $237
      $filerr=$236;
      __label__ = 74; break;
    case 74: // $238
      var $239=$1;
      var $240=(($239+36)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241)|0)==0;
      if ($242) { __label__ = 75; break; } else { __label__ = 82; break; }
    case 75: // $243
      var $244=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 33; break; };
    case 76: // $245
      var $246=(($244)|0)!=0;
      if ($246) { __label__ = 77; break; } else { __label__ = 82; break; }
    case 77: // $247
      var $248=$1;
      var $249=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 33; break; };
    case 78: // $250
      var $251=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($249) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 33; break; };
    case 79: // $252
      var $253=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 33; break; };
    case 80: // $254
      var $255=$has_crc;
      var $256=(($255) & 1);
      var $257=HEAP32[(($crc)>>2)];
      var $258=$3;
      var $259=$1;
      var $260=(($259+36)|0);
      var $261=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($251, $253, $256, $257, $258, $260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 33; break; };
    case 81: // $262
      $filerr=$261;
      __label__ = 82; break;
    case 82: // $263
      var $264=$1;
      var $265=(($264+36)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266)|0)==0;
      if ($267) { __label__ = 83; break; } else { __label__ = 91; break; }
    case 83: // $268
      var $269=$has_parent;
      var $270=(($269) & 1);
      if ($270) { __label__ = 84; break; } else { __label__ = 91; break; }
    case 84: // $271
      var $272=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 33; break; };
    case 85: // $273
      var $274=(($272)|0)!=0;
      if ($274) { __label__ = 86; break; } else { __label__ = 91; break; }
    case 86: // $275
      var $276=$1;
      var $277=(function() { try { __THREW__ = false; return __ZNK16_romload_private7machineEv($276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 33; break; };
    case 87: // $278
      var $279=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 33; break; };
    case 88: // $280
      var $281=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 33; break; };
    case 89: // $282
      var $283=$has_crc;
      var $284=(($283) & 1);
      var $285=HEAP32[(($crc)>>2)];
      var $286=$3;
      var $287=$1;
      var $288=(($287+36)|0);
      var $289=(function() { try { __THREW__ = false; return __Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file($279, $281, $284, $285, $286, $288) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 33; break; };
    case 90: // $290
      $filerr=$289;
      __label__ = 91; break;
    case 91: // $291
      __label__ = 92; break;
    case 92: // $292
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 32; break; }
    case 93: // $293
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 31; break; }
    case 94: // $294
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 30; break; }
    case 95: // $295
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 29; break; }
    case 96: // $296
      FUNCTION_TABLE[__ZN7astringD1Ev]($tag1);
      __label__ = 107; break;
    case 97: // $297
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 109; break; }
    case 98: // $298
      __label__ = 99; break;
    case 99: // $299
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 109; break; }
    case 100: // $300
      __label__ = 101; break;
    case 101: // $301
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 109; break; }
    case 102: // $302
      __label__ = 103; break;
    case 103: // $303
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 109; break; }
    case 104: // $304
      __label__ = 105; break;
    case 105: // $305
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tag1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 109; break; }
    case 106: // $306
      __label__ = 108; break;
    case 107: // $307
      var $308=$1;
      var $309=(($308+20)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=(($310+1)|0);
      HEAP32[(($309)>>2)]=$311;
      var $312=$romsize;
      var $313=$1;
      var $314=(($313+28)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=(($315+$312)|0);
      HEAP32[(($314)>>2)]=$316;
      var $317=$filerr;
      var $318=(($317)|0)==0;
      var $319=(($318)&1);
      STACKTOP = __stackBase__;
      return $319;
    case 108: // $320
      var $321=$5;
      var $322=$5;
      var $323=$6;
      var $324=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $322, tempValue);
      var $325=($324.f1 = $323, $324);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 109: // $326
      var $327=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13open_rom_fileP16_romload_privatePKcPK9rom_entry["X"]=1;

function __ZL19handle_missing_fileP16_romload_privatePK9rom_entry($romdata, $romp) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      $1=$romdata;
      $2=$romp;
      var $6=$2;
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8 & 32;
      var $10=(($9)|0)==32;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$1;
      var $13=(($12+52)|0);
      var $14=$2;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZN7astring9catprintfEPKcz($13, ((STRING_TABLE.__str383889)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt));
      var $18=$1;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+1)|0);
      HEAP32[(($19)>>2)]=$21;
      __label__ = 9; break;
    case 2: // $22
      var $23=$2;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($3, $25);
      var $26=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($3, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $27
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($3);
      if ($26) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $28
      var $29=$1;
      var $30=(($29+52)|0);
      var $31=$2;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__ZN7astring9catprintfEPKcz($30, ((STRING_TABLE.__str393890)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$33,tempInt));
      var $35=$1;
      var $36=(($35+12)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+1)|0);
      HEAP32[(($36)>>2)]=$38;
      __label__ = 8; break;
    case 5: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $4=$41;
      var $42=$40.f1;
      $5=$42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $43
      __label__ = 10; break;
    case 7: // $44
      var $45=$1;
      var $46=(($45+52)|0);
      var $47=$2;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=__ZN7astring9catprintfEPKcz($46, ((STRING_TABLE.__str193870)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt));
      var $51=$1;
      var $52=(($51+16)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+1)|0);
      HEAP32[(($52)>>2)]=$54;
      __label__ = 8; break;
    case 8: // $55
      __label__ = 9; break;
    case 9: // $56
      STACKTOP = __stackBase__;
      return;
    case 10: // $57
      var $58=$4;
      var $59=$4;
      var $60=$5;
      var $61=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $59, tempValue);
      var $62=($61.f1 = $60, $61);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19handle_missing_fileP16_romload_privatePK9rom_entry["X"]=1;

function __ZL9rom_freadP16_romload_privatePhi($romdata, $buffer, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$romdata;
      $3=$buffer;
      $4=$length;
      var $5=$2;
      var $6=(($5+36)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10+36)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$3;
      var $14=$4;
      var $15=__ZN8emu_file4readEPvj($12, $13, $14);
      $1=$15;
      __label__ = 4; break;
    case 2: // $16
      var $17=$2;
      var $18=__ZNK16_romload_private7machineEv($17);
      var $19=$3;
      var $20=$4;
      __ZL11fill_randomR15running_machinePhj($18, $19, $20);
      __label__ = 3; break;
    case 3: // $21
      var $22=$4;
      $1=$22;
      __label__ = 4; break;
    case 4: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11fill_randomR15running_machinePhj($machine, $base, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$machine;
      $2=$base;
      $3=$length;
      __label__ = 1; break;
    case 1: // $4
      var $5=$3;
      var $6=(($5-1)|0);
      $3=$6;
      var $7=(($5)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $8
      var $9=$1;
      var $10=__ZN15running_machine4randEv($9);
      var $11=(($10) & 255);
      var $12=$2;
      var $13=(($12+1)|0);
      $2=$13;
      HEAP8[($12)]=$11;
      __label__ = 1; break;
    case 3: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13read_rom_dataP16_romload_privatePK9rom_entry($romdata, $romp) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $datashift;
      var $datamask;
      var $numbytes;
      var $groupsize;
      var $skip;
      var $reversed;
      var $numgroups;
      var $base;
      var $tempbufsize;
      var $tempbuf;
      var $i;
      var $evengroupcount;
      var $bytesleft;
      var $bufptr;
      $7=$romdata;
      $8=$romp;
      var $9=$8;
      var $10=(($9+16)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 15728640;
      var $13=$12 >>> 20;
      $datashift=$13;
      var $14=$8;
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 983040;
      var $18=$17 >>> 16;
      var $19=$8;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 & 983040;
      var $23=(($22)|0)==0;
      var $24=(($23)&1);
      var $25=((($24<<3))|0);
      var $26=(($18+$25)|0);
      var $27=1 << $26;
      var $28=(($27-1)|0);
      var $29=$datashift;
      var $30=$28 << $29;
      $datamask=$30;
      var $31=$8;
      var $32=(($31+12)|0);
      var $33=HEAP32[(($32)>>2)];
      $numbytes=$33;
      var $34=$8;
      var $35=(($34+16)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36 & 3840;
      var $38=$37 >>> 8;
      var $39=(($38+1)|0);
      $groupsize=$39;
      var $40=$8;
      var $41=(($40+16)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$42 & 61440;
      var $44=$43 >>> 12;
      $skip=$44;
      var $45=$8;
      var $46=(($45+16)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$47 & 64;
      var $49=(($48)|0)==64;
      var $50=(($49)&1);
      $reversed=$50;
      var $51=$numbytes;
      var $52=$groupsize;
      var $53=(($51+$52)|0);
      var $54=(($53-1)|0);
      var $55=$groupsize;
      var $56=(((($54)|0)/(($55)|0))|0);
      $numgroups=$56;
      var $57=$7;
      var $58=(($57+48)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=__ZNK13memory_region4baseEv($59);
      var $61=$8;
      var $62=(($61+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($60+$63)|0);
      $base=$64;
      __label__ = 1; break;
    case 1: // $65
      __label__ = 2; break;
    case 2: // $66
      var $67=$numbytes;
      var $68=$groupsize;
      var $69=(($67)|0)%(($68)|0);
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $71
      var $72=$8;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str353886)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,tempInt));
      __label__ = 4; break;
    case 4: // $75
      var $76=$8;
      var $77=(($76+8)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$numgroups;
      var $80=$groupsize;
      var $81=(($79*$80)|0);
      var $82=(($78+$81)|0);
      var $83=$numgroups;
      var $84=(($83-1)|0);
      var $85=$skip;
      var $86=(($84*$85)|0);
      var $87=(($82+$86)|0);
      var $88=$7;
      var $89=(($88+48)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=__ZNK13memory_region5bytesEv($90);
      var $92=(($87)>>>0) > (($91)>>>0);
      if ($92) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $93
      var $94=$8;
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str363887)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$96,tempInt));
      throw "Reached an unreachable!"
    case 6: // $97
      var $98=$numbytes;
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $100
      var $101=$8;
      var $102=(($101)|0);
      var $103=HEAP32[(($102)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str373888)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$103,tempInt));
      throw "Reached an unreachable!"
    case 8: // $104
      var $105=$datamask;
      var $106=(($105)|0)==255;
      if ($106) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $107
      var $108=$groupsize;
      var $109=(($108)|0)==1;
      if ($109) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $110
      var $111=$reversed;
      var $112=(($111)|0)!=0;
      if ($112) { __label__ = 13; break; } else { __label__ = 11; break; }
    case 11: // $113
      var $114=$skip;
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $116
      var $117=$7;
      var $118=$base;
      var $119=$numbytes;
      var $120=__ZL9rom_freadP16_romload_privatePhi($117, $118, $119);
      $6=$120;
      __label__ = 94; break;
    case 13: // $121
      var $122=$numbytes;
      var $123=1073741824 < (($122)|0);
      if ($123) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $124
      var $128 = 1073741824;__label__ = 16; break;
    case 15: // $125
      var $126=$numbytes;
      var $128 = $126;__label__ = 16; break;
    case 16: // $127
      var $128;
      $tempbufsize=$128;
      var $129=$7;
      var $130=__ZNK16_romload_private7machineEv($129);
      var $131=__ZN15running_machine7respoolEv($130);
      var $132=$tempbufsize;
      var $133=$1;
      var $134=$2;
      var $135=$3;
      var $136=$result_i;
      var $137=$4;
      var $138=$5;
      HEAP32[(($1)>>2)]=$132;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3851)|0);
      HEAP32[(($3)>>2)]=764;
      var $139=HEAP32[(($1)>>2)];
      var $140=HEAP32[(($2)>>2)];
      var $141=HEAP32[(($3)>>2)];
      var $142=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($139, $140, $141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $143
      HEAP32[(($result_i)>>2)]=$142;
      var $144=HEAP32[(($result_i)>>2)];
      var $145=(($144)|0)==0;
      if ($145) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $146
      var $147=___cxa_allocate_exception(4);
      var $148=$147;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($148);
      (function() { try { __THREW__ = false; return ___cxa_throw($147, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $149
      var $150=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $151=$150.f0;
      HEAP32[(($4)>>2)]=$151;
      var $152=$150.f1;
      HEAP32[(($5)>>2)]=$152;
      var $153=HEAP32[(($5)>>2)];
      var $154=(($153)|0) < 0;
      if ($154) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $155
      var $156=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($156);
      throw "Reached an unreachable!"
    case 21: // $157
      var $158=HEAP32[(($4)>>2)];
      var $159=HEAP32[(($4)>>2)];
      var $160=HEAP32[(($5)>>2)];
      var $161=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $159, tempValue);
      var $162=($161.f1 = $160, $161);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $163
      throw "Reached an unreachable!"
    case 23: // $_ZnajPKci_exit
      var $164=HEAP32[(($result_i)>>2)];
      var $165=$1;
      var $166=$2;
      var $167=$3;
      var $168=$result_i;
      var $169=$4;
      var $170=$5;
      var $171=$tempbufsize;
      var $172=__ZN13resource_pool9add_arrayIhEEPT_S2_i($131, $164, $171);
      $tempbuf=$172;
      var $173=$groupsize;
      var $174=$skip;
      var $175=(($174+$173)|0);
      $skip=$175;
      __label__ = 24; break;
    case 24: // $176
      var $177=$numbytes;
      var $178=(($177)|0) > 0;
      if ($178) { __label__ = 25; break; } else { __label__ = 91; break; }
    case 25: // $179
      var $180=$tempbufsize;
      var $181=$groupsize;
      var $182=Math.floor((($180)>>>0)/(($181)>>>0));
      var $183=$groupsize;
      var $184=(($182*$183)|0);
      $evengroupcount=$184;
      var $185=$numbytes;
      var $186=$evengroupcount;
      var $187=(($185)|0) > (($186)|0);
      var $188=$evengroupcount;
      var $189=$numbytes;
      var $190=$187 ? $188 : $189;
      $bytesleft=$190;
      var $191=$tempbuf;
      $bufptr=$191;
      __label__ = 26; break;
    case 26: // $192
      __label__ = 27; break;
    case 27: // $193
      var $194=$7;
      var $195=$bufptr;
      var $196=$bytesleft;
      var $197=__ZL9rom_freadP16_romload_privatePhi($194, $195, $196);
      var $198=$bytesleft;
      var $199=(($197)|0)!=(($198)|0);
      if ($199) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $200
      var $201=$7;
      var $202=__ZNK16_romload_private7machineEv($201);
      var $203=__ZN15running_machine7respoolEv($202);
      var $204=$tempbuf;
      __ZN13resource_pool6removeEPv($203, $204);
      $6=0;
      __label__ = 94; break;
    case 29: // $205
      var $206=$bytesleft;
      var $207=$numbytes;
      var $208=(($207-$206)|0);
      $numbytes=$208;
      __label__ = 30; break;
    case 30: // $209
      __label__ = 31; break;
    case 31: // $210
      var $211=$datamask;
      var $212=(($211)|0)==255;
      if ($212) { __label__ = 32; break; } else { __label__ = 61; break; }
    case 32: // $213
      var $214=$groupsize;
      var $215=(($214)|0)==1;
      if ($215) { __label__ = 33; break; } else { __label__ = 38; break; }
    case 33: // $216
      $i=0;
      __label__ = 34; break;
    case 34: // $217
      var $218=$i;
      var $219=$bytesleft;
      var $220=(($218)|0) < (($219)|0);
      if ($220) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $221
      var $222=$bufptr;
      var $223=(($222+1)|0);
      $bufptr=$223;
      var $224=HEAP8[($222)];
      var $225=$base;
      HEAP8[($225)]=$224;
      __label__ = 36; break;
    case 36: // $226
      var $227=$i;
      var $228=(($227+1)|0);
      $i=$228;
      var $229=$skip;
      var $230=$base;
      var $231=(($230+$229)|0);
      $base=$231;
      __label__ = 34; break;
    case 37: // $232
      __label__ = 60; break;
    case 38: // $233
      var $234=$reversed;
      var $235=(($234)|0)!=0;
      if ($235) { __label__ = 49; break; } else { __label__ = 39; break; }
    case 39: // $236
      __label__ = 40; break;
    case 40: // $237
      var $238=$bytesleft;
      var $239=(($238)|0)!=0;
      if ($239) { __label__ = 41; break; } else { __label__ = 48; break; }
    case 41: // $240
      $i=0;
      __label__ = 42; break;
    case 42: // $241
      var $242=$i;
      var $243=$groupsize;
      var $244=(($242)|0) < (($243)|0);
      if ($244) { __label__ = 43; break; } else { var $249 = 0;__label__ = 44; break; }
    case 43: // $245
      var $246=$bytesleft;
      var $247=(($246)|0)!=0;
      var $249 = $247;__label__ = 44; break;
    case 44: // $248
      var $249;
      if ($249) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $250
      var $251=$bufptr;
      var $252=(($251+1)|0);
      $bufptr=$252;
      var $253=HEAP8[($251)];
      var $254=$i;
      var $255=$base;
      var $256=(($255+$254)|0);
      HEAP8[($256)]=$253;
      __label__ = 46; break;
    case 46: // $257
      var $258=$i;
      var $259=(($258+1)|0);
      $i=$259;
      var $260=$bytesleft;
      var $261=(($260-1)|0);
      $bytesleft=$261;
      __label__ = 42; break;
    case 47: // $262
      var $263=$skip;
      var $264=$base;
      var $265=(($264+$263)|0);
      $base=$265;
      __label__ = 40; break;
    case 48: // $266
      __label__ = 59; break;
    case 49: // $267
      __label__ = 50; break;
    case 50: // $268
      var $269=$bytesleft;
      var $270=(($269)|0)!=0;
      if ($270) { __label__ = 51; break; } else { __label__ = 58; break; }
    case 51: // $271
      var $272=$groupsize;
      var $273=(($272-1)|0);
      $i=$273;
      __label__ = 52; break;
    case 52: // $274
      var $275=$i;
      var $276=(($275)|0) >= 0;
      if ($276) { __label__ = 53; break; } else { var $281 = 0;__label__ = 54; break; }
    case 53: // $277
      var $278=$bytesleft;
      var $279=(($278)|0)!=0;
      var $281 = $279;__label__ = 54; break;
    case 54: // $280
      var $281;
      if ($281) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $282
      var $283=$bufptr;
      var $284=(($283+1)|0);
      $bufptr=$284;
      var $285=HEAP8[($283)];
      var $286=$i;
      var $287=$base;
      var $288=(($287+$286)|0);
      HEAP8[($288)]=$285;
      __label__ = 56; break;
    case 56: // $289
      var $290=$i;
      var $291=(($290-1)|0);
      $i=$291;
      var $292=$bytesleft;
      var $293=(($292-1)|0);
      $bytesleft=$293;
      __label__ = 52; break;
    case 57: // $294
      var $295=$skip;
      var $296=$base;
      var $297=(($296+$295)|0);
      $base=$297;
      __label__ = 50; break;
    case 58: // $298
      __label__ = 59; break;
    case 59: // $299
      __label__ = 60; break;
    case 60: // $300
      __label__ = 90; break;
    case 61: // $301
      var $302=$groupsize;
      var $303=(($302)|0)==1;
      if ($303) { __label__ = 62; break; } else { __label__ = 67; break; }
    case 62: // $304
      $i=0;
      __label__ = 63; break;
    case 63: // $305
      var $306=$i;
      var $307=$bytesleft;
      var $308=(($306)|0) < (($307)|0);
      if ($308) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 64: // $309
      var $310=$base;
      var $311=HEAPU8[($310)];
      var $312=(($311)&255);
      var $313=$datamask;
      var $314=$313 ^ -1;
      var $315=$312 & $314;
      var $316=$bufptr;
      var $317=(($316+1)|0);
      $bufptr=$317;
      var $318=HEAPU8[($316)];
      var $319=(($318)&255);
      var $320=$datashift;
      var $321=$319 << $320;
      var $322=$datamask;
      var $323=$321 & $322;
      var $324=$315 | $323;
      var $325=(($324) & 255);
      var $326=$base;
      HEAP8[($326)]=$325;
      __label__ = 65; break;
    case 65: // $327
      var $328=$i;
      var $329=(($328+1)|0);
      $i=$329;
      var $330=$skip;
      var $331=$base;
      var $332=(($331+$330)|0);
      $base=$332;
      __label__ = 63; break;
    case 66: // $333
      __label__ = 89; break;
    case 67: // $334
      var $335=$reversed;
      var $336=(($335)|0)!=0;
      if ($336) { __label__ = 78; break; } else { __label__ = 68; break; }
    case 68: // $337
      __label__ = 69; break;
    case 69: // $338
      var $339=$bytesleft;
      var $340=(($339)|0)!=0;
      if ($340) { __label__ = 70; break; } else { __label__ = 77; break; }
    case 70: // $341
      $i=0;
      __label__ = 71; break;
    case 71: // $342
      var $343=$i;
      var $344=$groupsize;
      var $345=(($343)|0) < (($344)|0);
      if ($345) { __label__ = 72; break; } else { var $350 = 0;__label__ = 73; break; }
    case 72: // $346
      var $347=$bytesleft;
      var $348=(($347)|0)!=0;
      var $350 = $348;__label__ = 73; break;
    case 73: // $349
      var $350;
      if ($350) { __label__ = 74; break; } else { __label__ = 76; break; }
    case 74: // $351
      var $352=$i;
      var $353=$base;
      var $354=(($353+$352)|0);
      var $355=HEAPU8[($354)];
      var $356=(($355)&255);
      var $357=$datamask;
      var $358=$357 ^ -1;
      var $359=$356 & $358;
      var $360=$bufptr;
      var $361=(($360+1)|0);
      $bufptr=$361;
      var $362=HEAPU8[($360)];
      var $363=(($362)&255);
      var $364=$datashift;
      var $365=$363 << $364;
      var $366=$datamask;
      var $367=$365 & $366;
      var $368=$359 | $367;
      var $369=(($368) & 255);
      var $370=$i;
      var $371=$base;
      var $372=(($371+$370)|0);
      HEAP8[($372)]=$369;
      __label__ = 75; break;
    case 75: // $373
      var $374=$i;
      var $375=(($374+1)|0);
      $i=$375;
      var $376=$bytesleft;
      var $377=(($376-1)|0);
      $bytesleft=$377;
      __label__ = 71; break;
    case 76: // $378
      var $379=$skip;
      var $380=$base;
      var $381=(($380+$379)|0);
      $base=$381;
      __label__ = 69; break;
    case 77: // $382
      __label__ = 88; break;
    case 78: // $383
      __label__ = 79; break;
    case 79: // $384
      var $385=$bytesleft;
      var $386=(($385)|0)!=0;
      if ($386) { __label__ = 80; break; } else { __label__ = 87; break; }
    case 80: // $387
      var $388=$groupsize;
      var $389=(($388-1)|0);
      $i=$389;
      __label__ = 81; break;
    case 81: // $390
      var $391=$i;
      var $392=(($391)|0) >= 0;
      if ($392) { __label__ = 82; break; } else { var $397 = 0;__label__ = 83; break; }
    case 82: // $393
      var $394=$bytesleft;
      var $395=(($394)|0)!=0;
      var $397 = $395;__label__ = 83; break;
    case 83: // $396
      var $397;
      if ($397) { __label__ = 84; break; } else { __label__ = 86; break; }
    case 84: // $398
      var $399=$i;
      var $400=$base;
      var $401=(($400+$399)|0);
      var $402=HEAPU8[($401)];
      var $403=(($402)&255);
      var $404=$datamask;
      var $405=$404 ^ -1;
      var $406=$403 & $405;
      var $407=$bufptr;
      var $408=(($407+1)|0);
      $bufptr=$408;
      var $409=HEAPU8[($407)];
      var $410=(($409)&255);
      var $411=$datashift;
      var $412=$410 << $411;
      var $413=$datamask;
      var $414=$412 & $413;
      var $415=$406 | $414;
      var $416=(($415) & 255);
      var $417=$i;
      var $418=$base;
      var $419=(($418+$417)|0);
      HEAP8[($419)]=$416;
      __label__ = 85; break;
    case 85: // $420
      var $421=$i;
      var $422=(($421-1)|0);
      $i=$422;
      var $423=$bytesleft;
      var $424=(($423-1)|0);
      $bytesleft=$424;
      __label__ = 81; break;
    case 86: // $425
      var $426=$skip;
      var $427=$base;
      var $428=(($427+$426)|0);
      $base=$428;
      __label__ = 79; break;
    case 87: // $429
      __label__ = 88; break;
    case 88: // $430
      __label__ = 89; break;
    case 89: // $431
      __label__ = 90; break;
    case 90: // $432
      __label__ = 24; break;
    case 91: // $433
      var $434=$7;
      var $435=__ZNK16_romload_private7machineEv($434);
      var $436=__ZN15running_machine7respoolEv($435);
      var $437=$tempbuf;
      __ZN13resource_pool6removeEPv($436, $437);
      __label__ = 92; break;
    case 92: // $438
      __label__ = 93; break;
    case 93: // $439
      var $440=$8;
      var $441=(($440+12)|0);
      var $442=HEAP32[(($441)>>2)];
      $6=$442;
      __label__ = 94; break;
    case 94: // $443
      var $444=$6;
      STACKTOP = __stackBase__;
      return $444;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13read_rom_dataP16_romload_privatePK9rom_entry["X"]=1;

function __ZL22verify_length_and_hashP16_romload_privatePKcjRK15hash_collection($romdata, $name, $explength, $hashes) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $actlength;
      var $tempstr=__stackBase__;
      var $acthashes;
      var $5;
      var $6;
      $1=$romdata;
      $2=$name;
      $3=$explength;
      $4=$hashes;
      var $7=$1;
      var $8=(($7+36)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      __label__ = 23; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+36)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZN8emu_file4sizeEv($15);
      var $16$0=$16[0];
      var $16$1=$16[1];
      var $17$0=$16$0;
      var $17=$17$0;
      $actlength=$17;
      var $18=$3;
      var $19=$actlength;
      var $20=(($18)|0)!=(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$1;
      var $23=(($22+52)|0);
      var $24=$2;
      var $25=$3;
      var $26=$actlength;
      var $27=__ZN7astring9catprintfEPKcz($23, ((STRING_TABLE.__str323883)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,HEAP32[((tempInt+4)>>2)]=$25,HEAP32[((tempInt+8)>>2)]=$26,tempInt));
      var $28=$1;
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+1)|0);
      HEAP32[(($29)>>2)]=$31;
      __label__ = 4; break;
    case 4: // $32
      __ZN7astringC1Ev($tempstr);
      var $33=$1;
      var $34=(($33+36)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$4;
      var $37=(function() { try { __THREW__ = false; return __ZNK15hash_collection10hash_typesER7astring($36, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; };
    case 5: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN8emu_file6hashesEPKc($35, $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; };
    case 6: // $40
      $acthashes=$39;
      var $41=$4;
      var $42=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($41, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $43
      if ($42) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $44
      var $45=$1;
      var $46=(($45+52)|0);
      var $47=$2;
      var $48=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($46, ((STRING_TABLE.__str333884)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$47,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; };
    case 9: // $49
      var $50=$1;
      var $51=(($50+12)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+1)|0);
      HEAP32[(($51)>>2)]=$53;
      __label__ = 22; break;
    case 10: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      $5=$56;
      var $57=$55.f1;
      $6=$57;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 11: // $58
      var $59=$4;
      var $60=$acthashes;
      var $61=(function() { try { __THREW__ = false; return __ZNK15hash_collectionneERKS_($59, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 10; break; };
    case 12: // $62
      if ($61) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $63
      var $64=$1;
      var $65=(($64+52)|0);
      var $66=$2;
      var $67=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($65, ((STRING_TABLE.__str213872)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 10; break; };
    case 14: // $68
      var $69=$1;
      var $70=$4;
      var $71=$acthashes;
      (function() { try { __THREW__ = false; return __ZL32dump_wrong_and_correct_checksumsP16_romload_privateRK15hash_collectionS3_($69, $70, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 10; break; }
    case 15: // $72
      var $73=$1;
      var $74=(($73+8)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+1)|0);
      HEAP32[(($74)>>2)]=$76;
      __label__ = 21; break;
    case 16: // $77
      var $78=$4;
      var $79=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($78, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 10; break; };
    case 17: // $80
      if ($79) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $81
      var $82=$1;
      var $83=(($82+52)|0);
      var $84=$2;
      var $85=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($83, ((STRING_TABLE.__str343885)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$84,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 10; break; };
    case 19: // $86
      var $87=$1;
      var $88=(($87+12)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+1)|0);
      HEAP32[(($88)>>2)]=$90;
      __label__ = 20; break;
    case 20: // $91
      __label__ = 21; break;
    case 21: // $92
      __label__ = 22; break;
    case 22: // $93
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      __label__ = 23; break;
    case 23: // $94
      STACKTOP = __stackBase__;
      return;
    case 24: // $95
      __label__ = 25; break;
    case 25: // $96
      var $97=$5;
      var $98=$5;
      var $99=$6;
      var $100=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $98, tempValue);
      var $101=($100.f1 = $99, $100);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22verify_length_and_hashP16_romload_privatePKcjRK15hash_collection["X"]=1;

function __Z14ui_input_resetR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $uidata;
      var $code;
      $1=$machine;
      var $2=$1;
      var $3=(($2+648)|0);
      var $4=HEAP32[(($3)>>2)];
      $uidata=$4;
      var $5=$uidata;
      var $6=(($5+5032)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=$uidata;
      var $8=(($7+5036)|0);
      HEAP32[(($8)>>2)]=0;
      $code=159;
      __label__ = 1; break;
    case 1: // $9
      var $10=$code;
      var $11=(($10)|0) <= 212;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$code;
      var $14=$uidata;
      var $15=(($14+1728)|0);
      var $16=(($15+$13)|0);
      HEAP8[($16)]=2;
      var $17=$code;
      var $18=$uidata;
      var $19=(($18)|0);
      var $20=(($19+($17<<3))|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$11$0=(($20)|0);
      HEAP32[(($st$11$0)>>2)]=$$emscripten$temp$0$0;
      var $st$11$1=(($20+4)|0);
      HEAP32[(($st$11$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 3; break;
    case 3: // $21
      var $22=$code;
      var $23=(($22+1)|0);
      $code=$23;
      __label__ = 1; break;
    case 4: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19ui_input_find_mouseR15running_machinePiS1_S1_($machine, $x, $y, $button) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $uidata;
      $1=$machine;
      $2=$x;
      $3=$y;
      $4=$button;
      var $5=$1;
      var $6=(($5+648)|0);
      var $7=HEAP32[(($6)>>2)];
      $uidata=$7;
      var $8=$2;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$uidata;
      var $12=(($11+1948)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      HEAP32[(($14)>>2)]=$13;
      __label__ = 2; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$uidata;
      var $20=(($19+1952)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$3;
      HEAP32[(($22)>>2)]=$21;
      __label__ = 4; break;
    case 4: // $23
      var $24=$4;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$uidata;
      var $28=(($27+1956)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$4;
      HEAP32[(($30)>>2)]=$29;
      __label__ = 6; break;
    case 6: // $31
      var $32=$uidata;
      var $33=(($32+1944)|0);
      var $34=HEAP32[(($33)>>2)];
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI9_open_chdEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI9_open_chdEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI9_open_chdEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 24);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI9_open_chdE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI9_open_chdED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI9_open_chdED2Ev($2);
  ;
  return;
}


function __Z21ui_input_frame_updateR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $uidata;
      var $code;
      var $pressed;
      $1=$machine;
      var $2=$1;
      var $3=(($2+648)|0);
      var $4=HEAP32[(($3)>>2)];
      $uidata=$4;
      $code=159;
      __label__ = 1; break;
    case 1: // $5
      var $6=$code;
      var $7=(($6)|0) <= 212;
      if ($7) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $8
      var $9=$1;
      var $10=__ZNK15running_machine5inputEv($9);
      var $11=$1;
      var $12=$code;
      var $13=__Z14input_type_seqR15running_machineii15_input_seq_type($11, $12, 0, 0);
      var $14=__ZN13input_manager11seq_pressedERK9input_seq($10, $13);
      var $15=(($14)&1);
      $pressed=$15;
      var $16=$pressed;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$code;
      var $20=$uidata;
      var $21=(($20+1728)|0);
      var $22=(($21+$19)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(($24)|0)!=2;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$pressed;
      var $28=(($27) & 255);
      var $29=$code;
      var $30=$uidata;
      var $31=(($30+1728)|0);
      var $32=(($31+$29)|0);
      HEAP8[($32)]=$28;
      __label__ = 5; break;
    case 5: // $33
      __label__ = 6; break;
    case 6: // $34
      var $35=$code;
      var $36=(($35+1)|0);
      $code=$36;
      __label__ = 1; break;
    case 7: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18ui_input_pop_eventR15running_machineP9_ui_event($machine, $evt) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $uidata;
      var $result;
      $1=$machine;
      $2=$evt;
      var $3=$1;
      var $4=(($3+648)|0);
      var $5=HEAP32[(($4)>>2)];
      $uidata=$5;
      var $6=$uidata;
      var $7=(($6+5032)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$uidata;
      var $10=(($9+5036)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($8)|0)!=(($11)|0);
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$2;
      var $15=$uidata;
      var $16=(($15+5032)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+1)|0);
      HEAP32[(($16)>>2)]=$18;
      var $19=$uidata;
      var $20=(($19+1960)|0);
      var $21=(($20+$17*24)|0);
      var $22=$14;
      var $23=$21;
      assert(24 % 1 === 0, 'memcpy given ' + 24 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($22)>>2)]=HEAP32[(($23)>>2)];HEAP32[(($22+4)>>2)]=HEAP32[(($23+4)>>2)];HEAP32[(($22+8)>>2)]=HEAP32[(($23+8)>>2)];HEAP32[(($22+12)>>2)]=HEAP32[(($23+12)>>2)];HEAP32[(($22+16)>>2)]=HEAP32[(($23+16)>>2)];HEAP32[(($22+20)>>2)]=HEAP32[(($23+20)>>2)];
      var $24=$uidata;
      var $25=(($24+5032)|0);
      var $26=HEAPU32[(($25)>>2)];
      var $27=(($26)>>>0)%128;
      HEAP32[(($25)>>2)]=$27;
      $result=1;
      __label__ = 3; break;
    case 2: // $28
      var $29=$2;
      var $30=$29;
      _memset($30, 0, 24, 1);
      $result=0;
      __label__ = 3; break;
    case 3: // $31
      var $32=$result;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16ui_input_pressedR15running_machinei($machine, $code) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$code;
  var $3=$1;
  var $4=$2;
  var $5=__Z23ui_input_pressed_repeatR15running_machineii($3, $4, 0);
  ;
  return $5;
}


function __Z23ui_input_pressed_repeatR15running_machineii($machine, $code, $speed) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $uidata;
      var $pressed;
      var $tps=__stackBase__;
      $1=$machine;
      $2=$code;
      $3=$speed;
      var $4=$1;
      var $5=(($4+648)|0);
      var $6=HEAP32[(($5)>>2)];
      $uidata=$6;
      $pressed=0;
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 270);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=$2;
      var $10=$uidata;
      var $11=(($10+1728)|0);
      var $12=(($11+$9)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=(($14)|0)==1;
      var $16=(($15)&1);
      $pressed=$16;
      var $17=$pressed;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $19
      var $20=_osd_ticks_per_second();
      var $20$0=$20[0];
      var $20$1=$20[1];
      var $st$3$0=(($tps)|0);
      HEAP32[(($st$3$0)>>2)]=$20$0;
      var $st$3$1=(($tps+4)|0);
      HEAP32[(($st$3$1)>>2)]=$20$1;
      var $21=$2;
      var $22=$uidata;
      var $23=(($22)|0);
      var $24=(($23+($21<<3))|0);
      var $st$11$0=(($24)|0);
      var $25$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$11$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $26=$25$0 == $$emscripten$temp$0$0 && $25$1 == $$emscripten$temp$0$1;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=_osd_ticks();
      var $28$0=$28[0];
      var $28$1=$28[1];
      var $29=$3;
      var $30=(($29*3)|0);
      var $31$0=$30;
      var $31$1=(($30|0) < 0 ? -1 : 0);
      var $st$7$0=(($tps)|0);
      var $32$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($tps+4)|0);
      var $32$1=HEAP32[(($st$7$1)>>2)];
      var $33$0 = ((($31$0)>>>0)+((($31$1)|0)*4294967296))*((($32$0)>>>0)+((($32$1)|0)*4294967296))>>>0; var $33$1 = Math.min(Math.floor((((($31$0)>>>0)+((($31$1)|0)*4294967296))*((($32$0)>>>0)+((($32$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=60;
      var $$emscripten$temp$1$1=0;
      var $34$0 = (tempBigIntR=((($33$0)>>>0)+((($33$1)|0)*4294967296))/((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $34$1 = Math.min(Math.floor(((tempBigIntR=((($33$0)>>>0)+((($33$1)|0)*4294967296))/((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $35$0 = ((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($34$0)>>>0)+((($34$1)|0)*4294967296))>>>0; var $35$1 = Math.min(Math.floor((((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($34$0)>>>0)+((($34$1)|0)*4294967296)))/4294967296), 4294967295);
      var $36=$2;
      var $37=$uidata;
      var $38=(($37)|0);
      var $39=(($38+($36<<3))|0);
      var $st$20$0=(($39)|0);
      HEAP32[(($st$20$0)>>2)]=$35$0;
      var $st$20$1=(($39+4)|0);
      HEAP32[(($st$20$1)>>2)]=$35$1;
      __label__ = 10; break;
    case 5: // $40
      var $41=$3;
      var $42=(($41)|0) > 0;
      if ($42) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $43
      var $44=_osd_ticks();
      var $44$0=$44[0];
      var $44$1=$44[1];
      var $st$3$0=(($tps)|0);
      var $45$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($tps+4)|0);
      var $45$1=HEAP32[(($st$3$1)>>2)];
      var $46$0 = ((($44$0)>>>0)+((($44$1)|0)*4294967296))+((($45$0)>>>0)+((($45$1)|0)*4294967296))>>>0; var $46$1 = Math.min(Math.floor((((($44$0)>>>0)+((($44$1)|0)*4294967296))+((($45$0)>>>0)+((($45$1)|0)*4294967296)))/4294967296), 4294967295);
      var $47=$2;
      var $48=$uidata;
      var $49=(($48)|0);
      var $50=(($49+($47<<3))|0);
      var $st$12$0=(($50)|0);
      var $51$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($50+4)|0);
      var $51$1=HEAP32[(($st$12$1)>>2)];
      var $52$0 = ((($46$0)>>>0)+((($46$1)|0)*4294967296))-((($51$0)>>>0)+((($51$1)|0)*4294967296))>>>0; var $52$1 = Math.min(Math.floor((((($46$0)>>>0)+((($46$1)|0)*4294967296))-((($51$0)>>>0)+((($51$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$17$0=(($tps)|0);
      var $53$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($tps+4)|0);
      var $53$1=HEAP32[(($st$17$1)>>2)];
      var $54=($52$1|0) >= ($53$1|0) && (($52$1|0) >  ($53$1|0) || ($52$0|0) >= ($53$0|0));
      if ($54) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $55
      var $56=$3;
      var $57=(($56)|0);
      var $58$0=$57;
      var $58$1=(($57|0) < 0 ? -1 : 0);
      var $st$4$0=(($tps)|0);
      var $59$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($tps+4)|0);
      var $59$1=HEAP32[(($st$4$1)>>2)];
      var $60$0 = ((($58$0)>>>0)+((($58$1)|0)*4294967296))*((($59$0)>>>0)+((($59$1)|0)*4294967296))>>>0; var $60$1 = Math.min(Math.floor((((($58$0)>>>0)+((($58$1)|0)*4294967296))*((($59$0)>>>0)+((($59$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=60;
      var $$emscripten$temp$2$1=0;
      var $61$0 = (tempBigIntR=((($60$0)>>>0)+((($60$1)|0)*4294967296))/((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $61$1 = Math.min(Math.floor(((tempBigIntR=((($60$0)>>>0)+((($60$1)|0)*4294967296))/((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $62=$2;
      var $63=$uidata;
      var $64=(($63)|0);
      var $65=(($64+($62<<3))|0);
      var $st$16$0=(($65)|0);
      var $66$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($65+4)|0);
      var $66$1=HEAP32[(($st$16$1)>>2)];
      var $67$0 = ((($66$0)>>>0)+((($66$1)|0)*4294967296))+((($61$0)>>>0)+((($61$1)|0)*4294967296))>>>0; var $67$1 = Math.min(Math.floor((((($66$0)>>>0)+((($66$1)|0)*4294967296))+((($61$0)>>>0)+((($61$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$21$0=(($65)|0);
      HEAP32[(($st$21$0)>>2)]=$67$0;
      var $st$21$1=(($65+4)|0);
      HEAP32[(($st$21$1)>>2)]=$67$1;
      __label__ = 9; break;
    case 8: // $68
      $pressed=0;
      __label__ = 9; break;
    case 9: // $69
      __label__ = 10; break;
    case 10: // $70
      __label__ = 12; break;
    case 11: // $71
      var $72=$2;
      var $73=$uidata;
      var $74=(($73)|0);
      var $75=(($74+($72<<3))|0);
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$6$0=(($75)|0);
      HEAP32[(($st$6$0)>>2)]=$$emscripten$temp$3$0;
      var $st$6$1=(($75+4)|0);
      HEAP32[(($st$6$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 12; break;
    case 12: // $76
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $77=$pressed;
      STACKTOP = __stackBase__;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z23ui_input_pressed_repeatR15running_machineii["X"]=1;

function __ZN20resource_pool_objectI17_ui_input_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17_ui_input_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17_ui_input_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 5040);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17_ui_input_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17_ui_input_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17_ui_input_privateED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectI9_open_chdEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI9_open_chdEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI9_open_chdEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI9_open_chdED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI9_open_chdED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI9_open_chdED0Ev["X"]=1;

function __ZN20resource_pool_objectI9_open_chdED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI9_open_chdE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13ui_input_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8=__stackBase__+28;
      $7=$machine;
      var $9=$7;
      var $10=__ZN15running_machine7respoolEv($9);
      var $11=$1;
      var $12=$2;
      var $13=$3;
      var $14=$4;
      var $15=$result_i;
      var $16=$5;
      var $17=$6;
      HEAP32[(($1)>>2)]=5040;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str3923)|0);
      HEAP32[(($3)>>2)]=78;
      HEAP32[(($4)>>2)]=_zeromem;
      var $18=HEAP32[(($1)>>2)];
      var $19=HEAP32[(($2)>>2)];
      var $20=HEAP32[(($3)>>2)];
      var $21=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($18, $19, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $22
      HEAP32[(($result_i)>>2)]=$21;
      var $23=HEAP32[(($result_i)>>2)];
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $25
      var $26=___cxa_allocate_exception(4);
      var $27=$26;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($27);
      (function() { try { __THREW__ = false; return ___cxa_throw($26, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      HEAP32[(($5)>>2)]=$30;
      var $31=$29.f1;
      HEAP32[(($6)>>2)]=$31;
      var $32=HEAP32[(($6)>>2)];
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $34
      var $35=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($35);
      throw "Reached an unreachable!"
    case 5: // $36
      var $37=HEAP32[(($5)>>2)];
      var $38=HEAP32[(($5)>>2)];
      var $39=HEAP32[(($6)>>2)];
      var $40=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $38, tempValue);
      var $41=($40.f1 = $39, $40);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $42
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $43=HEAP32[(($result_i)>>2)];
      var $44=HEAP32[(($1)>>2)];
      _memset($43, 0, $44, 1);
      var $45=HEAP32[(($result_i)>>2)];
      var $46=$1;
      var $47=$2;
      var $48=$3;
      var $49=$4;
      var $50=$result_i;
      var $51=$5;
      var $52=$6;
      var $53=$45;
      var $54=__ZN13resource_pool10add_objectI17_ui_input_privateEEPT_S3_($10, $53);
      var $55=$7;
      var $56=(($55+648)|0);
      HEAP32[(($56)>>2)]=$54;
      var $57=$7;
      var $58=(($57+648)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+1948)|0);
      HEAP32[(($60)>>2)]=-1;
      var $61=$7;
      var $62=(($61+648)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+1952)|0);
      HEAP32[(($64)>>2)]=-1;
      var $65=$7;
      var $66=$7;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($8, 934, ((STRING_TABLE.__str13924)|0), $66);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($65, 0, $8);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13ui_input_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI17_ui_input_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17_ui_input_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17_ui_input_privateEEPT_S3_["X"]=1;

function __ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj($callback, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$callback;
  $2=$param;
  var $3=$1;
  HEAP32[((__ZL19ui_handler_callback)>>2)]=$3;
  var $4=$2;
  HEAP32[((__ZL16ui_handler_param)>>2)]=$4;
  var $5=$2;
  ;
  return $5;
}


function ___cxx_global_var_init4019() {
  ;
  var __label__;

  __ZN7astringC1Ev(__ZL15messagebox_text);
  var $1=___cxa_atexit(938, __ZL15messagebox_text, ___dso_handle);
  ;
  return;
}


function __Z7ui_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$machine;
  var $3=$1;
  var $4=$1;
  __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 940, ((STRING_TABLE.__str3931)|0), $4);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($3, 4, $2);
  var $5=$1;
  __Z12ui_menu_initR15running_machine($5);
  var $6=$1;
  __Z11ui_gfx_initR15running_machine($6);
  HEAP32[((__ZL11single_step)>>2)]=0;
  var $7=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(942, 0);
  var $8=$1;
  var $9=__ZNK15running_machine7optionsEv($8);
  var $10=__ZNK11emu_options16natural_keyboardEv($9);
  var $11=(($10)&1);
  HEAP32[((__ZL23ui_use_natural_keyboard)>>2)]=$11;
  STACKTOP = __stackBase__;
  return 0;
}


function __ZL7ui_exitR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=__ZNK15running_machine6renderEv($2);
  var $4=HEAP32[((__ZL7ui_font)>>2)];
  __ZN14render_manager9font_freeEP11render_font($3, $4);
  HEAP32[((__ZL7ui_font)>>2)]=0;
  ;
  return;
}


function __ZL18handler_messageboxR15running_machineP16render_containerj($machine, $container, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$container;
  $3=$state;
  var $4=$2;
  var $5=__ZNK7astringcvPKcEv(__ZL15messagebox_text);
  var $6=HEAP32[((__ZL20messagebox_backcolor)>>2)];
  __Z16ui_draw_text_boxP16render_containerPKciffj($4, $5, 0, 0.5, 0.5, $6);
  ;
  return 0;
}


function __ZNK11emu_options16natural_keyboardEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str143945)|0));
  ;
  return $4;
}


function __Z26ui_display_startup_screensR15running_machineii($machine, $first_time, $show_disclaimer) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $maxstate;
      var $str;
      var $show_gameinfo;
      var $show_warnings;
      var $state;
      var $4=__stackBase__;
      var $5=__stackBase__+4;
      $1=$machine;
      $2=$first_time;
      $3=$show_disclaimer;
      $maxstate=3;
      var $6=$1;
      var $7=__ZNK15running_machine7optionsEv($6);
      var $8=__ZNK11emu_options14seconds_to_runEv($7);
      $str=$8;
      var $9=$1;
      var $10=__ZNK15running_machine7optionsEv($9);
      var $11=__ZNK11emu_options13skip_gameinfoEv($10);
      var $12=$11 ^ 1;
      var $13=(($12)&1);
      $show_gameinfo=$13;
      $show_warnings=1;
      var $14=$2;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $16
      var $17=$str;
      var $18=(($17)|0) > 0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      var $20=$str;
      var $21=(($20)|0) < 300;
      if ($21) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $22
      var $23=$1;
      var $24=__ZNK15running_machine6systemEv($23);
      var $25=(($24)|0)==((_driver____empty)|0);
      if ($25) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $26
      var $27=$1;
      var $28=(($27+584)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 & 1;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      $3=0;
      $show_warnings=0;
      $show_gameinfo=0;
      __label__ = 6; break;
    case 6: // $33
      var $34=$1;
      var $35=__ZL11slider_initR15running_machine($34);
      HEAP32[((__ZL14slider_current)>>2)]=$35;
      HEAP32[((__ZL11slider_list)>>2)]=$35;
      var $36=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(936, 0);
      $state=0;
      __label__ = 7; break;
    case 7: // $37
      var $38=$state;
      var $39=(($38)|0) < 3;
      if ($39) { __label__ = 8; break; } else { var $48 = 0;__label__ = 10; break; }
    case 8: // $40
      var $41=$1;
      var $42=__ZNK15running_machine23scheduled_event_pendingEv($41);
      if ($42) { var $48 = 0;__label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $43
      var $44=__Z28ui_menu_is_force_game_selectv();
      var $45=(($44)|0)!=0;
      var $46=$45 ^ 1;
      var $48 = $46;__label__ = 10; break;
    case 10: // $47
      var $48;
      if ($48) { __label__ = 11; break; } else { __label__ = 39; break; }
    case 11: // $49
      HEAP32[((__ZL20messagebox_backcolor)>>2)]=-284159952;
      var $50=$state;
      if ($50 == 0) {
        __label__ = 12; break;
      }
      else if ($50 == 1) {
        __label__ = 16; break;
      }
      else if ($50 == 2) {
        __label__ = 24; break;
      }
      else {
      __label__ = 28; break;
      }
      
    case 12: // $51
      var $52=$3;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $54
      var $55=$1;
      var $56=__ZL17disclaimer_stringR15running_machineR7astring($55, __ZL15messagebox_text);
      var $57=__ZNK7astring3lenEv($56);
      var $58=(($57)|0) > 0;
      if ($58) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $59
      var $60=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(944, 0);
      __label__ = 15; break;
    case 15: // $61
      __label__ = 28; break;
    case 16: // $62
      var $63=$show_warnings;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $65
      var $66=$1;
      var $67=__ZL15warnings_stringR15running_machineR7astring($66, __ZL15messagebox_text);
      var $68=__ZNK7astring3lenEv($67);
      var $69=(($68)|0) > 0;
      if ($69) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $70
      var $71=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(944, 0);
      var $72=$1;
      var $73=__ZNK15running_machine6systemEv($72);
      var $74=(($73+44)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$75 & 18144;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $78
      HEAP32[((__ZL20messagebox_backcolor)>>2)]=-278896624;
      __label__ = 20; break;
    case 20: // $79
      var $80=$1;
      var $81=__ZNK15running_machine6systemEv($80);
      var $82=(($81+44)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$83 & 131096;
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $86
      HEAP32[((__ZL20messagebox_backcolor)>>2)]=-262139888;
      __label__ = 22; break;
    case 22: // $87
      __label__ = 23; break;
    case 23: // $88
      __label__ = 28; break;
    case 24: // $89
      var $90=$show_gameinfo;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $92
      var $93=$1;
      var $94=__Z17game_info_astringR15running_machineR7astring($93, __ZL15messagebox_text);
      var $95=__ZNK7astring3lenEv($94);
      var $96=(($95)|0) > 0;
      if ($96) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $97
      var $98=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(946, 0);
      __label__ = 27; break;
    case 27: // $99
      __label__ = 28; break;
    case 28: // $100
      var $101=$1;
      var $102=__ZNK15running_machine5inputEv($101);
      __ZN13input_manager13reset_pollingEv($102);
      __label__ = 29; break;
    case 29: // $103
      var $104=$1;
      var $105=__ZNK15running_machine5inputEv($104);
      __ZN13input_manager13poll_switchesEv($4, $105);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 0, 0, 0, 0, 0);
      var $106=__ZNK10input_codeneERKS_($4, $5);
      if ($106) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $107
      __label__ = 29; break;
    case 31: // $108
      __label__ = 32; break;
    case 32: // $109
      var $110=HEAP32[((__ZL19ui_handler_callback)>>2)];
      var $111=(($110)|0)!=936;
      if ($111) { __label__ = 33; break; } else { var $120 = 0;__label__ = 35; break; }
    case 33: // $112
      var $113=$1;
      var $114=__ZNK15running_machine23scheduled_event_pendingEv($113);
      if ($114) { var $120 = 0;__label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $115
      var $116=__Z28ui_menu_is_force_game_selectv();
      var $117=(($116)|0)!=0;
      var $118=$117 ^ 1;
      var $120 = $118;__label__ = 35; break;
    case 35: // $119
      var $120;
      if ($120) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $121
      var $122=$1;
      var $123=__ZNK15running_machine5videoEv($122);
      __ZN13video_manager12frame_updateEb($123, 0);
      __label__ = 32; break;
    case 37: // $124
      var $125=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(936, 0);
      var $126=$1;
      var $127=__ZNK15running_machine5videoEv($126);
      __ZN13video_manager12frame_updateEb($127, 0);
      __label__ = 38; break;
    case 38: // $128
      var $129=$state;
      var $130=(($129+1)|0);
      $state=$130;
      __label__ = 7; break;
    case 39: // $131
      var $132=__Z28ui_menu_is_force_game_selectv();
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $134
      var $135=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(948, 0);
      __label__ = 41; break;
    case 41: // $136
      STACKTOP = __stackBase__;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26ui_display_startup_screensR15running_machineii["X"]=1;

function __ZNK11emu_options14seconds_to_runEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options9int_valueEPKc($3, ((STRING_TABLE.__str864017)|0));
  ;
  return $4;
}


function __ZNK11emu_options13skip_gameinfoEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str854016)|0));
  ;
  return $4;
}


function __ZN20resource_pool_objectI17_ui_input_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17_ui_input_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17_ui_input_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI17_ui_input_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI17_ui_input_privateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11slider_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $field;
      var $port;
      var $device;
      var $listhead=__stackBase__;
      var $tailptr;
      var $string=__stackBase__+4;
      var $item;
      var $3;
      var $4;
      var $info=__stackBase__+68;
      var $maxval;
      var $defval;
      var $param;
      var $exec=__stackBase__+80;
      var $gotone;
      var $param1;
      var $screen;
      var $defxscale;
      var $defyscale;
      var $defxoffset;
      var $defyoffset;
      var $param2;
      var $config;
      var $defxscale3;
      var $defyscale4;
      var $defxoffset5;
      var $defyoffset6;
      var $param7;
      var $screen8;
      var $5;
      $2=$machine;
      HEAP32[(($listhead)>>2)]=0;
      $tailptr=$listhead;
      __ZN7astringC1Ev($string);
      var $6=$2;
      var $7=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($6, ((STRING_TABLE.__str173948)|0), -32, 0, 0, 1, 950, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $8
      var $9=$tailptr;
      HEAP32[(($9)>>2)]=$7;
      var $10=$tailptr;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0);
      $tailptr=$12;
      $item=0;
      __label__ = 2; break;
    case 2: // $13
      var $14=$2;
      var $15=(function() { try { __THREW__ = false; return __ZNK15running_machine5soundEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $16
      var $17=$item;
      var $18=(function() { try { __THREW__ = false; return __ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input($15, $17, $info) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $19
      if ($18) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $20
      $maxval=2000;
      var $21=(($info+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($info+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(function() { try { __THREW__ = false; return __ZNK12sound_stream18initial_input_gainEi($22, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $26
      var $27=$25*1000;
      var $28=$27+0.5;
      var $29=(($28)|0);
      $defval=$29;
      var $30=$defval;
      var $31=(($30)|0) > 1000;
      if ($31) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $32
      var $33=$defval;
      var $34=((($33<<1))|0);
      $maxval=$34;
      __label__ = 9; break;
    case 8: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $3=$37;
      var $38=$36.f1;
      $4=$38;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 147; break; } else { __label__ = 149; break; }
    case 9: // $39
      var $40=(($info+4)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($info+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(function() { try { __THREW__ = false; return __ZNK12sound_stream10input_nameEiR7astring($41, $43, $string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 8; break; };
    case 10: // $45
      var $46=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($string, ((STRING_TABLE.__str183949)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; };
    case 11: // $47
      var $48=$2;
      var $49=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; };
    case 12: // $50
      var $51=$defval;
      var $52=$maxval;
      var $53=$item;
      var $54=$53;
      var $55=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($48, $49, 0, $51, $52, 20, 952, $54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 8; break; };
    case 13: // $56
      var $57=$tailptr;
      HEAP32[(($57)>>2)]=$55;
      var $58=$tailptr;
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0);
      $tailptr=$60;
      __label__ = 14; break;
    case 14: // $61
      var $62=$item;
      var $63=(($62+1)|0);
      $item=$63;
      __label__ = 2; break;
    case 15: // $64
      var $65=$2;
      var $66=(($65+20)|0);
      var $67=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 8; break; };
    case 16: // $68
      $port=$67;
      __label__ = 17; break;
    case 17: // $69
      var $70=$port;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 18; break; } else { __label__ = 31; break; }
    case 18: // $72
      var $73=$port;
      var $74=(function() { try { __THREW__ = false; return __ZN17input_port_config9fieldlistEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 8; break; };
    case 19: // $75
      var $76=(function() { try { __THREW__ = false; return __ZNK11simple_listI18input_field_configE5firstEv($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 8; break; };
    case 20: // $77
      $field=$76;
      __label__ = 21; break;
    case 21: // $78
      var $79=$field;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 22; break; } else { __label__ = 28; break; }
    case 22: // $81
      var $82=$field;
      var $83=(($82+24)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84)|0)==158;
      if ($85) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $86
      var $87=$field;
      var $88=$87;
      $param=$88;
      var $89=$2;
      var $90=$field;
      var $91=(($90+40)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$field;
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$param;
      var $97=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($89, $92, 0, $95, 100, 1, 954, $96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 8; break; };
    case 24: // $98
      var $99=$tailptr;
      HEAP32[(($99)>>2)]=$97;
      var $100=$tailptr;
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101)|0);
      $tailptr=$102;
      __label__ = 25; break;
    case 25: // $103
      __label__ = 26; break;
    case 26: // $104
      var $105=$field;
      var $106=(function() { try { __THREW__ = false; return __ZNK18input_field_config4nextEv($105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 8; break; };
    case 27: // $107
      $field=$106;
      __label__ = 21; break;
    case 28: // $108
      __label__ = 29; break;
    case 29: // $109
      var $110=$port;
      var $111=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; };
    case 30: // $112
      $port=$111;
      __label__ = 17; break;
    case 31: // $113
      var $114=$2;
      var $115=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 8; break; };
    case 32: // $116
      var $117=(function() { try { __THREW__ = false; return __ZNK11emu_options5cheatEv($115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 8; break; };
    case 33: // $118
      if ($117) { __label__ = 34; break; } else { __label__ = 48; break; }
    case 34: // $119
      HEAP32[(($exec)>>2)]=0;
      var $120=$2;
      var $121=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 8; break; };
    case 35: // $122
      var $123=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($121, $exec) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 8; break; };
    case 36: // $124
      var $125=(($123)&1);
      $gotone=$125;
      __label__ = 37; break;
    case 37: // $126
      var $127=$gotone;
      var $128=(($127) & 1);
      if ($128) { __label__ = 38; break; } else { __label__ = 47; break; }
    case 38: // $129
      var $130=HEAP32[(($exec)>>2)];
      var $131=$130;
      var $132=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 8; break; };
    case 39: // $133
      var $134=$132;
      $param1=$134;
      var $135=HEAP32[(($exec)>>2)];
      var $136=$135;
      var $137=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 8; break; };
    case 40: // $138
      var $139=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 8; break; };
    case 41: // $140
      var $141=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str193950)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$139,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 8; break; };
    case 42: // $142
      var $143=$2;
      var $144=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 8; break; };
    case 43: // $145
      var $146=$param1;
      var $147=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($143, $144, 10, 1000, 2000, 1, 956, $146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 8; break; };
    case 44: // $148
      var $149=$tailptr;
      HEAP32[(($149)>>2)]=$147;
      var $150=$tailptr;
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151)|0);
      $tailptr=$152;
      __label__ = 45; break;
    case 45: // $153
      var $154=HEAP32[(($exec)>>2)];
      var $155=$154;
      var $156=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($155, $exec) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 8; break; };
    case 46: // $157
      var $158=(($156)&1);
      $gotone=$158;
      __label__ = 37; break;
    case 47: // $159
      __label__ = 48; break;
    case 48: // $160
      var $161=$2;
      var $162=(function() { try { __THREW__ = false; return __ZNK15running_machine12first_screenEv($161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 8; break; };
    case 49: // $163
      $screen=$162;
      __label__ = 50; break;
    case 50: // $164
      var $165=$screen;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 51; break; } else { __label__ = 98; break; }
    case 51: // $167
      var $168=$screen;
      var $169=(function() { try { __THREW__ = false; return __ZNK13screen_device6xscaleEv($168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 8; break; };
    case 52: // $170
      var $171=$169*1000;
      var $172=$171+0.5;
      var $173=$172;
      var $174=(function() { try { __THREW__ = false; return _floor($173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 8; break; };
    case 53: // $175
      var $176=(($174)|0);
      $defxscale=$176;
      var $177=$screen;
      var $178=(function() { try { __THREW__ = false; return __ZNK13screen_device6yscaleEv($177) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 8; break; };
    case 54: // $179
      var $180=$178*1000;
      var $181=$180+0.5;
      var $182=$181;
      var $183=(function() { try { __THREW__ = false; return _floor($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 8; break; };
    case 55: // $184
      var $185=(($183)|0);
      $defyscale=$185;
      var $186=$screen;
      var $187=(function() { try { __THREW__ = false; return __ZNK13screen_device7xoffsetEv($186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 8; break; };
    case 56: // $188
      var $189=$187*1000;
      var $190=$189+0.5;
      var $191=$190;
      var $192=(function() { try { __THREW__ = false; return _floor($191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 8; break; };
    case 57: // $193
      var $194=(($192)|0);
      $defxoffset=$194;
      var $195=$screen;
      var $196=(function() { try { __THREW__ = false; return __ZNK13screen_device7yoffsetEv($195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 8; break; };
    case 58: // $197
      var $198=$196*1000;
      var $199=$198+0.5;
      var $200=$199;
      var $201=(function() { try { __THREW__ = false; return _floor($200) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 8; break; };
    case 59: // $202
      var $203=(($201)|0);
      $defyoffset=$203;
      var $204=$screen;
      var $205=$204;
      $param2=$205;
      var $206=$2;
      var $207=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 8; break; };
    case 60: // $208
      var $209=(function() { try { __THREW__ = false; return __ZNK11emu_options5cheatEv($207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 8; break; };
    case 61: // $210
      if ($209) { __label__ = 62; break; } else { __label__ = 67; break; }
    case 62: // $211
      var $212=$screen;
      var $213=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 8; break; };
    case 63: // $214
      var $215=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str203951)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$213,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 8; break; };
    case 64: // $216
      var $217=$2;
      var $218=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 8; break; };
    case 65: // $219
      var $220=$param2;
      var $221=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($217, $218, -10000, 0, 10000, 1000, 958, $220) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 8; break; };
    case 66: // $222
      var $223=$tailptr;
      HEAP32[(($223)>>2)]=$221;
      var $224=$tailptr;
      var $225=HEAP32[(($224)>>2)];
      var $226=(($225)|0);
      $tailptr=$226;
      __label__ = 67; break;
    case 67: // $227
      var $228=$screen;
      var $229=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 8; break; };
    case 68: // $230
      var $231=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str213952)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$229,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 8; break; };
    case 69: // $232
      var $233=$2;
      var $234=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 8; break; };
    case 70: // $235
      var $236=$param2;
      var $237=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($233, $234, 100, 1000, 2000, 10, 960, $236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 8; break; };
    case 71: // $238
      var $239=$tailptr;
      HEAP32[(($239)>>2)]=$237;
      var $240=$tailptr;
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241)|0);
      $tailptr=$242;
      var $243=$screen;
      var $244=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 8; break; };
    case 72: // $245
      var $246=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str223953)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$244,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 8; break; };
    case 73: // $247
      var $248=$2;
      var $249=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 8; break; };
    case 74: // $250
      var $251=$param2;
      var $252=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($248, $249, 100, 1000, 2000, 50, 962, $251) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 8; break; };
    case 75: // $253
      var $254=$tailptr;
      HEAP32[(($254)>>2)]=$252;
      var $255=$tailptr;
      var $256=HEAP32[(($255)>>2)];
      var $257=(($256)|0);
      $tailptr=$257;
      var $258=$screen;
      var $259=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($258) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 8; break; };
    case 76: // $260
      var $261=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str233954)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$259,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 8; break; };
    case 77: // $262
      var $263=$2;
      var $264=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 8; break; };
    case 78: // $265
      var $266=$param2;
      var $267=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($263, $264, 100, 1000, 3000, 50, 964, $266) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 8; break; };
    case 79: // $268
      var $269=$tailptr;
      HEAP32[(($269)>>2)]=$267;
      var $270=$tailptr;
      var $271=HEAP32[(($270)>>2)];
      var $272=(($271)|0);
      $tailptr=$272;
      var $273=$screen;
      var $274=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($273) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 8; break; };
    case 80: // $275
      var $276=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str243955)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$274,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 8; break; };
    case 81: // $277
      var $278=$2;
      var $279=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 8; break; };
    case 82: // $280
      var $281=$defxscale;
      var $282=$param2;
      var $283=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($278, $279, 500, $281, 1500, 2, 966, $282) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 8; break; };
    case 83: // $284
      var $285=$tailptr;
      HEAP32[(($285)>>2)]=$283;
      var $286=$tailptr;
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0);
      $tailptr=$288;
      var $289=$screen;
      var $290=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 8; break; };
    case 84: // $291
      var $292=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str253956)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$290,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 8; break; };
    case 85: // $293
      var $294=$2;
      var $295=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 8; break; };
    case 86: // $296
      var $297=$defxoffset;
      var $298=$param2;
      var $299=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($294, $295, -500, $297, 500, 2, 968, $298) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 8; break; };
    case 87: // $300
      var $301=$tailptr;
      HEAP32[(($301)>>2)]=$299;
      var $302=$tailptr;
      var $303=HEAP32[(($302)>>2)];
      var $304=(($303)|0);
      $tailptr=$304;
      var $305=$screen;
      var $306=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($305) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 8; break; };
    case 88: // $307
      var $308=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str263957)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$306,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 8; break; };
    case 89: // $309
      var $310=$2;
      var $311=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 8; break; };
    case 90: // $312
      var $313=$defyscale;
      var $314=$param2;
      var $315=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($310, $311, 500, $313, 1500, 2, 970, $314) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 8; break; };
    case 91: // $316
      var $317=$tailptr;
      HEAP32[(($317)>>2)]=$315;
      var $318=$tailptr;
      var $319=HEAP32[(($318)>>2)];
      var $320=(($319)|0);
      $tailptr=$320;
      var $321=$screen;
      var $322=(function() { try { __THREW__ = false; return __ZL22slider_get_screen_descR13screen_device($321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 8; break; };
    case 92: // $323
      var $324=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str273958)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$322,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 8; break; };
    case 93: // $325
      var $326=$2;
      var $327=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 8; break; };
    case 94: // $328
      var $329=$defyoffset;
      var $330=$param2;
      var $331=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($326, $327, -500, $329, 500, 2, 972, $330) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 8; break; };
    case 95: // $332
      var $333=$tailptr;
      HEAP32[(($333)>>2)]=$331;
      var $334=$tailptr;
      var $335=HEAP32[(($334)>>2)];
      var $336=(($335)|0);
      $tailptr=$336;
      __label__ = 96; break;
    case 96: // $337
      var $338=$screen;
      var $339=(function() { try { __THREW__ = false; return __ZNK13screen_device11next_screenEv($338) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 8; break; };
    case 97: // $340
      $screen=$339;
      __label__ = 50; break;
    case 98: // $341
      var $342=$2;
      var $343=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($342) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 8; break; };
    case 99: // $344
      var $345=HEAP32[((_LASERDISC)>>2)];
      var $346=(function() { try { __THREW__ = false; return __ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($343, $345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 8; break; };
    case 100: // $347
      $device=$346;
      __label__ = 101; break;
    case 101: // $348
      var $349=$device;
      var $350=(($349)|0)!=0;
      if ($350) { __label__ = 102; break; } else { __label__ = 135; break; }
    case 102: // $351
      var $352=$device;
      var $353=(function() { try { __THREW__ = false; return __Z8downcastIPK18legacy_device_base8device_tET_PT0_($352) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 8; break; };
    case 103: // $354
      var $355=(function() { try { __THREW__ = false; return __ZNK18legacy_device_base13inline_configEv($353) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 8; break; };
    case 104: // $356
      var $357=$355;
      $config=$357;
      var $358=$config;
      var $359=(($358+20)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=(($360)|0)!=0;
      if ($361) { __label__ = 105; break; } else { __label__ = 132; break; }
    case 105: // $362
      var $363=$config;
      var $364=(($363+60)|0);
      var $365=HEAPF32[(($364)>>2)];
      var $366=$365*1000;
      var $367=$366+0.5;
      var $368=$367;
      var $369=(function() { try { __THREW__ = false; return _floor($368) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 8; break; };
    case 106: // $370
      var $371=(($369)|0);
      $defxscale3=$371;
      var $372=$config;
      var $373=(($372+64)|0);
      var $374=HEAPF32[(($373)>>2)];
      var $375=$374*1000;
      var $376=$375+0.5;
      var $377=$376;
      var $378=(function() { try { __THREW__ = false; return _floor($377) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 8; break; };
    case 107: // $379
      var $380=(($378)|0);
      $defyscale4=$380;
      var $381=$config;
      var $382=(($381+52)|0);
      var $383=HEAPF32[(($382)>>2)];
      var $384=$383*1000;
      var $385=$384+0.5;
      var $386=$385;
      var $387=(function() { try { __THREW__ = false; return _floor($386) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 8; break; };
    case 108: // $388
      var $389=(($387)|0);
      $defxoffset5=$389;
      var $390=$config;
      var $391=(($390+56)|0);
      var $392=HEAPF32[(($391)>>2)];
      var $393=$392*1000;
      var $394=$393+0.5;
      var $395=$394;
      var $396=(function() { try { __THREW__ = false; return _floor($395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 8; break; };
    case 109: // $397
      var $398=(($396)|0);
      $defyoffset6=$398;
      var $399=$device;
      var $400=$399;
      $param7=$400;
      var $401=$device;
      var $402=(function() { try { __THREW__ = false; return __ZL25slider_get_laserdisc_descP8device_t($401) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 8; break; };
    case 110: // $403
      var $404=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str243955)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$402,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 8; break; };
    case 111: // $405
      var $406=$2;
      var $407=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 8; break; };
    case 112: // $408
      var $409=$defxscale3;
      var $410=(($409)|0)==0;
      if ($410) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $411
      var $415 = 1000;__label__ = 115; break;
    case 114: // $412
      var $413=$defxscale3;
      var $415 = $413;__label__ = 115; break;
    case 115: // $414
      var $415;
      var $416=$param7;
      var $417=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($406, $407, 500, $415, 1500, 2, 974, $416) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 8; break; };
    case 116: // $418
      var $419=$tailptr;
      HEAP32[(($419)>>2)]=$417;
      var $420=$tailptr;
      var $421=HEAP32[(($420)>>2)];
      var $422=(($421)|0);
      $tailptr=$422;
      var $423=$device;
      var $424=(function() { try { __THREW__ = false; return __ZL25slider_get_laserdisc_descP8device_t($423) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 117; break; } else { __label__ = 8; break; };
    case 117: // $425
      var $426=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str253956)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$424,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 8; break; };
    case 118: // $427
      var $428=$2;
      var $429=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 8; break; };
    case 119: // $430
      var $431=$defxoffset5;
      var $432=$param7;
      var $433=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($428, $429, -500, $431, 500, 2, 976, $432) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 120; break; } else { __label__ = 8; break; };
    case 120: // $434
      var $435=$tailptr;
      HEAP32[(($435)>>2)]=$433;
      var $436=$tailptr;
      var $437=HEAP32[(($436)>>2)];
      var $438=(($437)|0);
      $tailptr=$438;
      var $439=$device;
      var $440=(function() { try { __THREW__ = false; return __ZL25slider_get_laserdisc_descP8device_t($439) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 8; break; };
    case 121: // $441
      var $442=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str263957)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$440,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 8; break; };
    case 122: // $443
      var $444=$2;
      var $445=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 123; break; } else { __label__ = 8; break; };
    case 123: // $446
      var $447=$defyscale4;
      var $448=(($447)|0)==0;
      if ($448) { __label__ = 124; break; } else { __label__ = 125; break; }
    case 124: // $449
      var $453 = 1000;__label__ = 126; break;
    case 125: // $450
      var $451=$defyscale4;
      var $453 = $451;__label__ = 126; break;
    case 126: // $452
      var $453;
      var $454=$param7;
      var $455=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($444, $445, 500, $453, 1500, 2, 978, $454) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 8; break; };
    case 127: // $456
      var $457=$tailptr;
      HEAP32[(($457)>>2)]=$455;
      var $458=$tailptr;
      var $459=HEAP32[(($458)>>2)];
      var $460=(($459)|0);
      $tailptr=$460;
      var $461=$device;
      var $462=(function() { try { __THREW__ = false; return __ZL25slider_get_laserdisc_descP8device_t($461) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 128; break; } else { __label__ = 8; break; };
    case 128: // $463
      var $464=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($string, ((STRING_TABLE.__str273958)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$462,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 129; break; } else { __label__ = 8; break; };
    case 129: // $465
      var $466=$2;
      var $467=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($string) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 130; break; } else { __label__ = 8; break; };
    case 130: // $468
      var $469=$defyoffset6;
      var $470=$param7;
      var $471=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($466, $467, -500, $469, 500, 2, 980, $470) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 131; break; } else { __label__ = 8; break; };
    case 131: // $472
      var $473=$tailptr;
      HEAP32[(($473)>>2)]=$471;
      var $474=$tailptr;
      var $475=HEAP32[(($474)>>2)];
      var $476=(($475)|0);
      $tailptr=$476;
      __label__ = 132; break;
    case 132: // $477
      __label__ = 133; break;
    case 133: // $478
      var $479=$device;
      var $480=(function() { try { __THREW__ = false; return __ZNK8device_t8typenextEv($479) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 134; break; } else { __label__ = 8; break; };
    case 134: // $481
      $device=$480;
      __label__ = 101; break;
    case 135: // $482
      var $483=$2;
      var $484=(function() { try { __THREW__ = false; return __ZNK15running_machine12first_screenEv($483) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 8; break; };
    case 136: // $485
      $screen8=$484;
      __label__ = 137; break;
    case 137: // $486
      var $487=$screen8;
      var $488=(($487)|0)!=0;
      if ($488) { __label__ = 138; break; } else { __label__ = 146; break; }
    case 138: // $489
      var $490=$screen8;
      var $491=(function() { try { __THREW__ = false; return __ZNK13screen_device11screen_typeEv($490) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 139; break; } else { __label__ = 8; break; };
    case 139: // $492
      var $493=(($491)|0)==2;
      if ($493) { __label__ = 140; break; } else { __label__ = 143; break; }
    case 140: // $494
      var $495=$2;
      var $496=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($495, ((STRING_TABLE.__str283959)|0), 0, 0, 1000, 10, 982, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 141; break; } else { __label__ = 8; break; };
    case 141: // $497
      var $498=$tailptr;
      HEAP32[(($498)>>2)]=$496;
      var $499=$tailptr;
      var $500=HEAP32[(($499)>>2)];
      var $501=(($500)|0);
      $tailptr=$501;
      var $502=$2;
      var $503=(function() { try { __THREW__ = false; return __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($502, ((STRING_TABLE.__str293960)|0), 10, 100, 1000, 10, 984, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 8; break; };
    case 142: // $504
      var $505=$tailptr;
      HEAP32[(($505)>>2)]=$503;
      var $506=$tailptr;
      var $507=HEAP32[(($506)>>2)];
      var $508=(($507)|0);
      $tailptr=$508;
      __label__ = 146; break;
    case 143: // $509
      __label__ = 144; break;
    case 144: // $510
      var $511=$screen8;
      var $512=(function() { try { __THREW__ = false; return __ZNK13screen_device11next_screenEv($511) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 145; break; } else { __label__ = 8; break; };
    case 145: // $513
      $screen8=$512;
      __label__ = 137; break;
    case 146: // $514
      var $515=HEAP32[(($listhead)>>2)];
      $1=$515;
      $5=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($string);
      var $516=$1;
      STACKTOP = __stackBase__;
      return $516;
    case 147: // $517
      __label__ = 148; break;
    case 148: // $518
      var $519=$3;
      var $520=$3;
      var $521=$4;
      var $522=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $520, tempValue);
      var $523=($522.f1 = $521, $522);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 149: // $524
      var $525=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11slider_initR15running_machine["X"]=1;

function __ZL17disclaimer_stringR15running_machineR7astring($machine, $string) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$string;
  var $3=$2;
  var $4=__ZN7astring3cpyEPKc($3, ((STRING_TABLE.__str804011)|0));
  var $5=$2;
  var $6=$1;
  var $7=__ZNK15running_machine6systemEv($6);
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZN7astring9catprintfEPKcz($5, ((STRING_TABLE.__str814012)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$9,tempInt));
  var $11=$2;
  var $12=__ZN7astring3catEPKc($11, ((STRING_TABLE.__str824013)|0));
  var $13=$2;
  STACKTOP = __stackBase__;
  return $13;
}


function __ZL21handler_messagebox_okR15running_machineP16render_containerj($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+4;
      $1=$machine;
      $2=$container;
      $3=$state;
      var $6=$2;
      var $7=__ZNK7astringcvPKcEv(__ZL15messagebox_text);
      var $8=HEAP32[((__ZL20messagebox_backcolor)>>2)];
      __Z16ui_draw_text_boxP16render_containerPKciffj($6, $7, 0, 0.5, 0.5, $8);
      var $9=$3;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $11
      var $12=$1;
      var $13=__ZNK15running_machine5inputEv($12);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($4, 1, 0, 1, 0, 15);
      var $14=__ZN13input_manager17code_pressed_onceE10input_code($13, $4);
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      var $16=$1;
      var $17=__Z16ui_input_pressedR15running_machinei($16, 176);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($20+1)|0);
      $3=$21;
      __label__ = 12; break;
    case 4: // $22
      var $23=$3;
      var $24=(($23)|0)==1;
      if ($24) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $25
      var $26=$1;
      var $27=__ZNK15running_machine5inputEv($26);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 1, 0, 1, 0, 11);
      var $28=__ZN13input_manager17code_pressed_onceE10input_code($27, $5);
      if ($28) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $29
      var $30=$1;
      var $31=__Z16ui_input_pressedR15running_machinei($30, 177);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      $3=-1;
      __label__ = 11; break;
    case 8: // $34
      var $35=$1;
      var $36=__Z16ui_input_pressedR15running_machinei($35, 183);
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $38
      var $39=$1;
      __ZN15running_machine13schedule_exitEv($39);
      $3=-1;
      __label__ = 10; break;
    case 10: // $40
      __label__ = 11; break;
    case 11: // $41
      __label__ = 12; break;
    case 12: // $42
      var $43=$3;
      STACKTOP = __stackBase__;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21handler_messagebox_okR15running_machineP16render_containerj["X"]=1;

function __ZL14handler_ingameR15running_machineP16render_containerj($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $is_paused;
      var $tempstring=__stackBase__;
      var $5;
      var $6;
      var $profilertext=__stackBase__+64;
      var $ui_disabled;
      var $7=__stackBase__+128;
      var $8=__stackBase__+132;
      var $newframeskip;
      var $newframeskip1;
      $2=$machine;
      $3=$container;
      $4=$state;
      var $9=$2;
      var $10=__ZNK15running_machine6pausedEv($9);
      var $11=(($10)&1);
      $is_paused=$11;
      var $12=HEAP32[((__ZL7showfps)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      var $15=_osd_ticks();
      var $15$0=$15[0];
      var $15$1=$15[1];
      var $st$3$0=((__ZL11showfps_end)|0);
      var $16$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=((__ZL11showfps_end+4)|0);
      var $16$1=HEAP32[(($st$3$1)>>2)];
      var $17=($15$1|0) < ($16$1|0) || (($15$1|0) == ($16$1|0) && ($15$0|0) <  ($16$0|0));
      if ($17) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $18
      __ZN7astringC1Ev($tempstring);
      var $19=$3;
      var $20=$2;
      var $21=(function() { try { __THREW__ = false; return __ZNK15running_machine5videoEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $22
      var $23=(function() { try { __THREW__ = false; return __ZN13video_manager10speed_textER7astring($21, $tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $24
      var $25=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $26
      (function() { try { __THREW__ = false; return __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($19, $25, 0, 0, 1, 2, 2, 2, -1, -16777216, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $27
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      __label__ = 10; break;
    case 7: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $5=$30;
      var $31=$29.f1;
      $6=$31;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 98; break; }
    case 8: // $32
      __label__ = 97; break;
    case 9: // $33
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=((__ZL11showfps_end)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=((__ZL11showfps_end+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 10; break;
    case 10: // $34
      var $35=HEAP32[((__ZL13show_profiler)>>2)];
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $37
      __ZN7astringC1Ev($profilertext);
      var $38=$2;
      var $39=(function() { try { __THREW__ = false; return __ZN20dummy_profiler_state4textER15running_machineR7astring(_g_profiler, $38, $profilertext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $40
      var $41=$3;
      var $42=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($profilertext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $43
      (function() { try { __THREW__ = false; return __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($41, $42, 0, 0, 1, 0, 2, 2, -1, -16777216, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $44
      FUNCTION_TABLE[__ZN7astringD1Ev]($profilertext);
      __label__ = 17; break;
    case 15: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $5=$47;
      var $48=$46.f1;
      $6=$48;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($profilertext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 98; break; }
    case 16: // $49
      __label__ = 97; break;
    case 17: // $50
      var $51=HEAP32[((__ZL11single_step)>>2)];
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $53
      var $54=$2;
      __ZN15running_machine5pauseEv($54);
      HEAP32[((__ZL11single_step)>>2)]=0;
      __label__ = 19; break;
    case 19: // $55
      var $56=$2;
      var $57=__Z26input_machine_has_keyboardR15running_machine($56);
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 20; break; } else { var $64 = 0;__label__ = 21; break; }
    case 20: // $59
      var $60=$2;
      var $61=__ZNK15running_machine9ui_activeEv($60);
      var $62=$61 ^ 1;
      var $64 = $62;__label__ = 21; break;
    case 21: // $63
      var $64;
      var $65=(($64)&1);
      $ui_disabled=$65;
      var $66=$2;
      var $67=__Z26input_machine_has_keyboardR15running_machine($66);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 22; break; } else { __label__ = 28; break; }
    case 22: // $69
      var $70=$2;
      var $71=__Z16ui_input_pressedR15running_machinei($70, 192);
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $73
      var $74=$2;
      var $75=$2;
      var $76=__ZNK15running_machine9ui_activeEv($75);
      var $77=$76 ^ 1;
      __ZN15running_machine13set_ui_activeEb($74, $77);
      var $78=$2;
      var $79=__ZNK15running_machine9ui_activeEv($78);
      if ($79) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $80
      __Z13ui_popup_timeiPKcz(2, ((STRING_TABLE.__str413972)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str423973)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str433974)|0),HEAP32[((tempInt+8)>>2)]=((STRING_TABLE.__str443975)|0),HEAP32[((tempInt+12)>>2)]=((STRING_TABLE.__str453976)|0),HEAP32[((tempInt+16)>>2)]=((STRING_TABLE.__str433974)|0),HEAP32[((tempInt+20)>>2)]=((STRING_TABLE.__str463977)|0),tempInt));
      __label__ = 26; break;
    case 25: // $81
      __Z13ui_popup_timeiPKcz(2, ((STRING_TABLE.__str413972)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str423973)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str433974)|0),HEAP32[((tempInt+8)>>2)]=((STRING_TABLE.__str473978)|0),HEAP32[((tempInt+12)>>2)]=((STRING_TABLE.__str483979)|0),HEAP32[((tempInt+16)>>2)]=((STRING_TABLE.__str433974)|0),HEAP32[((tempInt+20)>>2)]=((STRING_TABLE.__str463977)|0),tempInt));
      __label__ = 26; break;
    case 26: // $82
      __label__ = 27; break;
    case 27: // $83
      __label__ = 28; break;
    case 28: // $84
      var $85=$2;
      var $86=__Z27ui_get_use_natural_keyboardR15running_machine($85);
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $88
      var $89=$2;
      var $90=__ZNK15running_machine5phaseEv($89);
      var $91=(($90)|0)==3;
      if ($91) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $92
      var $93=$2;
      __ZL24process_natural_keyboardR15running_machine($93);
      __label__ = 31; break;
    case 31: // $94
      var $95=$ui_disabled;
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 35; break; } else { __label__ = 32; break; }
    case 32: // $97
      var $98=$2;
      var $99=__Z16ui_input_pressedR15running_machinei($98, 194);
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $101
      var $102=$2;
      __Z8ui_pasteR15running_machine($102);
      __label__ = 34; break;
    case 34: // $103
      __label__ = 35; break;
    case 35: // $104
      var $105=$2;
      __Z23ui_image_handler_ingameR15running_machine($105);
      var $106=$ui_disabled;
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $108
      var $109=$ui_disabled;
      $1=$109;
      __label__ = 96; break;
    case 37: // $110
      var $111=$2;
      var $112=__Z16ui_input_pressedR15running_machinei($111, 183);
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $114
      var $115=$2;
      var $116=__ZNK15running_machine7optionsEv($115);
      var $117=__ZNK11emu_options12confirm_quitEv($116);
      if ($117) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $118
      var $119=$2;
      __ZN15running_machine13schedule_exitEv($119);
      __label__ = 41; break;
    case 40: // $120
      var $121=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(986, 0);
      $1=$121;
      __label__ = 96; break;
    case 41: // $122
      __label__ = 42; break;
    case 42: // $123
      var $124=$2;
      var $125=__Z16ui_input_pressedR15running_machinei($124, 159);
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $127
      var $128=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(948, 0);
      $1=$128;
      __label__ = 96; break;
    case 44: // $129
      var $130=$2;
      var $131=(($130+584)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$132 & 1;
      var $134=(($133)|0)==0;
      if ($134) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $135
      var $136=$2;
      var $137=__Z16ui_input_pressedR15running_machinei($136, 160);
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $139
      var $140=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(988, 1);
      $1=$140;
      __label__ = 96; break;
    case 47: // $141
      var $142=$2;
      var $143=__Z16ui_input_pressedR15running_machinei($142, 163);
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $145
      var $146=$2;
      __ZN15running_machine19schedule_hard_resetEv($146);
      __label__ = 49; break;
    case 49: // $147
      var $148=$2;
      var $149=__Z16ui_input_pressedR15running_machinei($148, 164);
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $151
      var $152=$2;
      __ZN15running_machine19schedule_soft_resetEv($152);
      __label__ = 51; break;
    case 51: // $153
      var $154=$2;
      var $155=__Z16ui_input_pressedR15running_machinei($154, 165);
      var $156=(($155)|0)!=0;
      if ($156) { __label__ = 52; break; } else { __label__ = 55; break; }
    case 52: // $157
      var $158=$is_paused;
      var $159=(($158) & 1);
      if ($159) { __label__ = 54; break; } else { __label__ = 53; break; }
    case 53: // $160
      var $161=$2;
      __ZN15running_machine5pauseEv($161);
      __label__ = 54; break;
    case 54: // $162
      var $163=$is_paused;
      var $164=(($163) & 1);
      var $165=(($164)&1);
      var $166=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(990, $165);
      $1=$166;
      __label__ = 96; break;
    case 55: // $167
      var $168=$2;
      var $169=__Z16ui_input_pressedR15running_machinei($168, 195);
      var $170=(($169)|0)!=0;
      if ($170) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $171
      var $172=$2;
      __ZN15running_machine5pauseEv($172);
      var $173=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(992, 2);
      $1=$173;
      __label__ = 96; break;
    case 57: // $174
      var $175=$2;
      var $176=__Z16ui_input_pressedR15running_machinei($175, 196);
      var $177=(($176)|0)!=0;
      if ($177) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $178
      var $179=$2;
      __ZN15running_machine5pauseEv($179);
      var $180=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(992, 1);
      $1=$180;
      __label__ = 96; break;
    case 59: // $181
      var $182=$2;
      var $183=__Z16ui_input_pressedR15running_machinei($182, 171);
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $185
      var $186=$2;
      var $187=__ZNK15running_machine5videoEv($186);
      __ZN13video_manager28save_active_screen_snapshotsEv($187);
      __label__ = 61; break;
    case 61: // $188
      var $189=$2;
      var $190=__Z16ui_input_pressedR15running_machinei($189, 162);
      var $191=(($190)|0)!=0;
      if ($191) { __label__ = 62; break; } else { __label__ = 71; break; }
    case 62: // $192
      var $193=$is_paused;
      var $194=(($193) & 1);
      if ($194) { __label__ = 63; break; } else { __label__ = 66; break; }
    case 63: // $195
      var $196=$2;
      var $197=__ZNK15running_machine5inputEv($196);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 97);
      var $198=__ZN13input_manager12code_pressedE10input_code($197, $7);
      if ($198) { __label__ = 65; break; } else { __label__ = 64; break; }
    case 64: // $199
      var $200=$2;
      var $201=__ZNK15running_machine5inputEv($200);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 1, 0, 1, 0, 98);
      var $202=__ZN13input_manager12code_pressedE10input_code($201, $8);
      if ($202) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $203
      HEAP32[((__ZL11single_step)>>2)]=1;
      var $204=$2;
      __ZN15running_machine6resumeEv($204);
      __label__ = 70; break;
    case 66: // $205
      var $206=$2;
      var $207=__ZNK15running_machine6pausedEv($206);
      if ($207) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $208
      var $209=$2;
      __ZN15running_machine6resumeEv($209);
      __label__ = 69; break;
    case 68: // $210
      var $211=$2;
      __ZN15running_machine5pauseEv($211);
      __label__ = 69; break;
    case 69: // $212
      __label__ = 70; break;
    case 70: // $213
      __label__ = 71; break;
    case 71: // $214
      var $215=$2;
      var $216=__Z16ui_input_pressedR15running_machinei($215, 173);
      var $217=(($216)|0)!=0;
      if ($217) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $218
      var $219=$2;
      var $220=__ZNK15running_machine5cheatEv($219);
      var $221=$2;
      var $222=__ZNK15running_machine5cheatEv($221);
      var $223=__ZNK13cheat_manager7enabledEv($222);
      var $224=$223 ^ 1;
      __ZN13cheat_manager10set_enableEb($220, $224);
      __label__ = 73; break;
    case 73: // $225
      var $226=$2;
      var $227=__Z16ui_input_pressedR15running_machinei($226, 172);
      var $228=(($227)|0)!=0;
      if ($228) { __label__ = 74; break; } else { __label__ = 78; break; }
    case 74: // $229
      var $230=$2;
      var $231=__ZNK15running_machine5videoEv($230);
      var $232=__ZNK13video_manager12is_recordingEv($231);
      if ($232) { __label__ = 76; break; } else { __label__ = 75; break; }
    case 75: // $233
      var $234=$2;
      var $235=__ZNK15running_machine5videoEv($234);
      __ZN13video_manager15begin_recordingEPKcNS_12movie_formatE($235, 0, 0);
      __Z10popmessagePKcz(((STRING_TABLE.__str493980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 77; break;
    case 76: // $236
      var $237=$2;
      var $238=__ZNK15running_machine5videoEv($237);
      __ZN13video_manager13end_recordingEv($238);
      __Z10popmessagePKcz(((STRING_TABLE.__str503981)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 77; break;
    case 77: // $239
      __label__ = 78; break;
    case 78: // $240
      var $241=$2;
      var $242=__Z16ui_input_pressedR15running_machinei($241, 191);
      var $243=(($242)|0)!=0;
      if ($243) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $244
      var $245=__Z20ui_get_show_profilerv();
      var $246=(($245)|0)!=0;
      var $247=$246 ^ 1;
      var $248=(($247)&1);
      __Z20ui_set_show_profileri($248);
      __label__ = 80; break;
    case 80: // $249
      var $250=$2;
      var $251=__Z16ui_input_pressedR15running_machinei($250, 170);
      var $252=(($251)|0)!=0;
      if ($252) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $253
      var $254=__Z15ui_get_show_fpsv();
      var $255=(($254)|0)!=0;
      var $256=$255 ^ 1;
      var $257=(($256)&1);
      __Z15ui_set_show_fpsi($257);
      __label__ = 82; break;
    case 82: // $258
      var $259=$2;
      var $260=__Z16ui_input_pressedR15running_machinei($259, 167);
      var $261=(($260)|0)!=0;
      if ($261) { __label__ = 83; break; } else { __label__ = 86; break; }
    case 83: // $262
      var $263=$2;
      var $264=__ZNK15running_machine5videoEv($263);
      var $265=__ZNK13video_manager9frameskipEv($264);
      var $266=(($265+1)|0);
      $newframeskip=$266;
      var $267=$newframeskip;
      var $268=(($267)|0) > 10;
      if ($268) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $269
      $newframeskip=-1;
      __label__ = 85; break;
    case 85: // $270
      var $271=$2;
      var $272=__ZNK15running_machine5videoEv($271);
      var $273=$newframeskip;
      __ZN13video_manager13set_frameskipEi($272, $273);
      __Z16ui_show_fps_tempd(2);
      __label__ = 86; break;
    case 86: // $274
      var $275=$2;
      var $276=__Z16ui_input_pressedR15running_machinei($275, 166);
      var $277=(($276)|0)!=0;
      if ($277) { __label__ = 87; break; } else { __label__ = 90; break; }
    case 87: // $278
      var $279=$2;
      var $280=__ZNK15running_machine5videoEv($279);
      var $281=__ZNK13video_manager9frameskipEv($280);
      var $282=(($281-1)|0);
      $newframeskip1=$282;
      var $283=$newframeskip1;
      var $284=(($283)|0) < -1;
      if ($284) { __label__ = 88; break; } else { __label__ = 89; break; }
    case 88: // $285
      $newframeskip1=10;
      __label__ = 89; break;
    case 89: // $286
      var $287=$2;
      var $288=__ZNK15running_machine5videoEv($287);
      var $289=$newframeskip1;
      __ZN13video_manager13set_frameskipEi($288, $289);
      __Z16ui_show_fps_tempd(2);
      __label__ = 90; break;
    case 90: // $290
      var $291=$2;
      var $292=__Z16ui_input_pressedR15running_machinei($291, 168);
      var $293=(($292)|0)!=0;
      if ($293) { __label__ = 91; break; } else { __label__ = 92; break; }
    case 91: // $294
      var $295=$2;
      var $296=__ZNK15running_machine5videoEv($295);
      var $297=$2;
      var $298=__ZNK15running_machine5videoEv($297);
      var $299=__ZNK13video_manager9throttledEv($298);
      var $300=$299 ^ 1;
      __ZN13video_manager13set_throttledEb($296, $300);
      __label__ = 92; break;
    case 92: // $301
      var $302=$2;
      var $303=__Z18input_type_pressedR15running_machineii($302, 169, 0);
      var $304=(($303)|0)!=0;
      if ($304) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $305
      var $306=$2;
      var $307=__ZNK15running_machine5videoEv($306);
      __ZN13video_manager15set_fastforwardEb($307, 1);
      __Z16ui_show_fps_tempd(0.5);
      __label__ = 95; break;
    case 94: // $308
      var $309=$2;
      var $310=__ZNK15running_machine5videoEv($309);
      __ZN13video_manager15set_fastforwardEb($310, 0);
      __label__ = 95; break;
    case 95: // $311
      $1=0;
      __label__ = 96; break;
    case 96: // $312
      var $313=$1;
      STACKTOP = __stackBase__;
      return $313;
    case 97: // $314
      var $315=$5;
      var $316=$5;
      var $317=$6;
      var $318=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $316, tempValue);
      var $319=($318.f1 = $317, $318);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 98: // $320
      var $321=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14handler_ingameR15running_machineP16render_containerj["X"]=1;

function __Z17game_info_astringR15running_machineR7astring($machine, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $scrcount;
      var $found_sound;
      var $exec=__stackBase__;
      var $gotone;
      var $clock;
      var $count;
      var $scan=__stackBase__+4;
      var $gotone1;
      var $sound=__stackBase__+8;
      var $gotone2;
      var $count3;
      var $scan4=__stackBase__+12;
      var $gotanother;
      var $clock5;
      var $screen;
      var $visarea;
      var $3=__stackBase__+16;
      $1=$machine;
      $2=$string;
      var $4=$1;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=HEAP32[((_SCREEN)>>2)];
      var $7=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($5, $6);
      $scrcount=$7;
      $found_sound=0;
      var $8=$2;
      var $9=$1;
      var $10=__ZNK15running_machine6systemEv($9);
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$1;
      var $14=__ZNK15running_machine6systemEv($13);
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=__ZNK15running_machine6systemEv($17);
      var $19=(($18+20)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZN7astring6printfEPKcz($8, ((STRING_TABLE.__str13932)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$12,HEAP32[((tempInt+4)>>2)]=$16,HEAP32[((tempInt+8)>>2)]=$20,tempInt));
      HEAP32[(($exec)>>2)]=0;
      var $22=$1;
      var $23=__ZNK15running_machine10devicelistEv($22);
      var $24=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($23, $exec);
      var $25=(($24)&1);
      $gotone=$25;
      __label__ = 1; break;
    case 1: // $26
      var $27=$gotone;
      var $28=(($27) & 1);
      if ($28) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $29
      var $30=HEAP32[(($exec)>>2)];
      var $31=$30;
      var $32=__ZN16device_interface6deviceEv($31);
      var $33=__ZNK8device_t5clockEv($32);
      $clock=$33;
      $count=1;
      HEAP32[(($scan)>>2)]=0;
      var $34=HEAP32[(($exec)>>2)];
      var $35=$34;
      var $36=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($35, $scan);
      var $37=(($36)&1);
      $gotone1=$37;
      __label__ = 3; break;
    case 3: // $38
      var $39=$gotone1;
      var $40=(($39) & 1);
      if ($40) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $41
      var $42=HEAP32[(($exec)>>2)];
      var $43=$42;
      var $44=__ZN16device_interface6deviceEv($43);
      var $45=__ZNK8device_t4typeEv($44);
      var $46=HEAP32[(($scan)>>2)];
      var $47=$46;
      var $48=__ZN16device_interface6deviceEv($47);
      var $49=__ZNK8device_t4typeEv($48);
      var $50=(($45)|0)!=(($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $51
      var $52=HEAP32[(($exec)>>2)];
      var $53=$52;
      var $54=__ZN16device_interface6deviceEv($53);
      var $55=__ZNK8device_t5clockEv($54);
      var $56=HEAP32[(($scan)>>2)];
      var $57=$56;
      var $58=__ZN16device_interface6deviceEv($57);
      var $59=__ZNK8device_t5clockEv($58);
      var $60=(($55)|0)!=(($59)|0);
      if ($60) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $61
      __label__ = 9; break;
    case 7: // $62
      var $63=$count;
      var $64=(($63+1)|0);
      $count=$64;
      var $65=HEAP32[(($scan)>>2)];
      HEAP32[(($exec)>>2)]=$65;
      __label__ = 8; break;
    case 8: // $66
      var $67=HEAP32[(($scan)>>2)];
      var $68=$67;
      var $69=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($68, $scan);
      var $70=(($69)&1);
      $gotone1=$70;
      __label__ = 3; break;
    case 9: // $71
      var $72=$count;
      var $73=(($72)|0) > 1;
      if ($73) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $74
      var $75=$2;
      var $76=$count;
      var $77=__ZN7astring9catprintfEPKcz($75, ((STRING_TABLE.__str23933)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$76,tempInt));
      __label__ = 11; break;
    case 11: // $78
      var $79=$2;
      var $80=HEAP32[(($exec)>>2)];
      var $81=$80;
      var $82=__ZN16device_interface6deviceEv($81);
      var $83=__ZNK8device_t4nameEv($82);
      var $84=__ZN7astring3catEPKc($79, $83);
      var $85=$clock;
      var $86=(($85)|0) >= 1000000;
      if ($86) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $87
      var $88=$2;
      var $89=$clock;
      var $90=(((($89)|0)/1000000)|0);
      var $91=$clock;
      var $92=(($91)|0)%1000000;
      var $93=__ZN7astring9catprintfEPKcz($88, ((STRING_TABLE.__str33934)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$90,HEAP32[((tempInt+4)>>2)]=$92,tempInt));
      __label__ = 14; break;
    case 13: // $94
      var $95=$2;
      var $96=$clock;
      var $97=(((($96)|0)/1000)|0);
      var $98=$clock;
      var $99=(($98)|0)%1000;
      var $100=__ZN7astring9catprintfEPKcz($95, ((STRING_TABLE.__str43935)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$97,HEAP32[((tempInt+4)>>2)]=$99,tempInt));
      __label__ = 14; break;
    case 14: // $101
      __label__ = 15; break;
    case 15: // $102
      var $103=HEAP32[(($exec)>>2)];
      var $104=$103;
      var $105=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($104, $exec);
      var $106=(($105)&1);
      $gotone=$106;
      __label__ = 1; break;
    case 16: // $107
      HEAP32[(($sound)>>2)]=0;
      var $108=$1;
      var $109=__ZNK15running_machine10devicelistEv($108);
      var $110=__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($109, $sound);
      var $111=(($110)&1);
      $gotone2=$111;
      __label__ = 17; break;
    case 17: // $112
      var $113=$gotone2;
      var $114=(($113) & 1);
      if ($114) { __label__ = 18; break; } else { __label__ = 37; break; }
    case 18: // $115
      var $116=$found_sound;
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $118
      var $119=$2;
      var $120=__ZN7astring3catEPKc($119, ((STRING_TABLE.__str53936)|0));
      __label__ = 20; break;
    case 20: // $121
      $found_sound=1;
      $count3=1;
      HEAP32[(($scan4)>>2)]=0;
      var $122=HEAP32[(($sound)>>2)];
      var $123=$122;
      var $124=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($123, $scan4);
      var $125=(($124)&1);
      $gotanother=$125;
      __label__ = 21; break;
    case 21: // $126
      var $127=$gotanother;
      var $128=(($127) & 1);
      if ($128) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $129
      var $130=HEAP32[(($sound)>>2)];
      var $131=$130;
      var $132=__ZN16device_interface6deviceEv($131);
      var $133=__ZNK8device_t4typeEv($132);
      var $134=HEAP32[(($scan4)>>2)];
      var $135=$134;
      var $136=__ZN16device_interface6deviceEv($135);
      var $137=__ZNK8device_t4typeEv($136);
      var $138=(($133)|0)!=(($137)|0);
      if ($138) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $139
      var $140=HEAP32[(($sound)>>2)];
      var $141=$140;
      var $142=__ZN16device_interface6deviceEv($141);
      var $143=__ZNK8device_t5clockEv($142);
      var $144=HEAP32[(($scan4)>>2)];
      var $145=$144;
      var $146=__ZN16device_interface6deviceEv($145);
      var $147=__ZNK8device_t5clockEv($146);
      var $148=(($143)|0)!=(($147)|0);
      if ($148) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $149
      __label__ = 27; break;
    case 25: // $150
      var $151=$count3;
      var $152=(($151+1)|0);
      $count3=$152;
      var $153=HEAP32[(($scan4)>>2)];
      HEAP32[(($sound)>>2)]=$153;
      __label__ = 26; break;
    case 26: // $154
      var $155=HEAP32[(($scan4)>>2)];
      var $156=$155;
      var $157=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($156, $scan4);
      var $158=(($157)&1);
      $gotanother=$158;
      __label__ = 21; break;
    case 27: // $159
      var $160=$count3;
      var $161=(($160)|0) > 1;
      if ($161) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $162
      var $163=$2;
      var $164=$count3;
      var $165=__ZN7astring9catprintfEPKcz($163, ((STRING_TABLE.__str23933)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$164,tempInt));
      __label__ = 29; break;
    case 29: // $166
      var $167=$2;
      var $168=HEAP32[(($sound)>>2)];
      var $169=$168;
      var $170=__ZN16device_interface6deviceEv($169);
      var $171=__ZNK8device_t4nameEv($170);
      var $172=__ZN7astring3catEPKc($167, $171);
      var $173=HEAP32[(($sound)>>2)];
      var $174=$173;
      var $175=__ZN16device_interface6deviceEv($174);
      var $176=__ZNK8device_t5clockEv($175);
      $clock5=$176;
      var $177=$clock5;
      var $178=(($177)|0) >= 1000000;
      if ($178) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $179
      var $180=$2;
      var $181=$clock5;
      var $182=(((($181)|0)/1000000)|0);
      var $183=$clock5;
      var $184=(($183)|0)%1000000;
      var $185=__ZN7astring9catprintfEPKcz($180, ((STRING_TABLE.__str33934)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$182,HEAP32[((tempInt+4)>>2)]=$184,tempInt));
      __label__ = 35; break;
    case 31: // $186
      var $187=$clock5;
      var $188=(($187)|0)!=0;
      if ($188) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $189
      var $190=$2;
      var $191=$clock5;
      var $192=(((($191)|0)/1000)|0);
      var $193=$clock5;
      var $194=(($193)|0)%1000;
      var $195=__ZN7astring9catprintfEPKcz($190, ((STRING_TABLE.__str43935)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$192,HEAP32[((tempInt+4)>>2)]=$194,tempInt));
      __label__ = 34; break;
    case 33: // $196
      var $197=$2;
      var $198=__ZN7astring3catEPKc($197, ((STRING_TABLE.__str63937)|0));
      __label__ = 34; break;
    case 34: // $199
      __label__ = 35; break;
    case 35: // $200
      __label__ = 36; break;
    case 36: // $201
      var $202=HEAP32[(($sound)>>2)];
      var $203=$202;
      var $204=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($203, $sound);
      var $205=(($204)&1);
      $gotone2=$205;
      __label__ = 17; break;
    case 37: // $206
      var $207=$2;
      var $208=__ZN7astring3catEPKc($207, ((STRING_TABLE.__str73938)|0));
      var $209=$scrcount;
      var $210=(($209)|0)==0;
      if ($210) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $211
      var $212=$2;
      var $213=__ZN7astring3catEPKc($212, ((STRING_TABLE.__str83939)|0));
      __label__ = 52; break;
    case 39: // $214
      var $215=$1;
      var $216=__ZNK15running_machine12first_screenEv($215);
      $screen=$216;
      __label__ = 40; break;
    case 40: // $217
      var $218=$screen;
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 41; break; } else { __label__ = 51; break; }
    case 41: // $220
      var $221=$scrcount;
      var $222=(($221)|0) > 1;
      if ($222) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $223
      var $224=$2;
      var $225=$screen;
      var $226=__ZL22slider_get_screen_descR13screen_device($225);
      var $227=__ZN7astring3catEPKc($224, $226);
      var $228=$2;
      var $229=__ZN7astring3catEPKc($228, ((STRING_TABLE.__str93940)|0));
      __label__ = 43; break;
    case 43: // $230
      var $231=$screen;
      var $232=__ZNK13screen_device11screen_typeEv($231);
      var $233=(($232)|0)==2;
      if ($233) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $234
      var $235=$2;
      var $236=__ZN7astring3catEPKc($235, ((STRING_TABLE.__str103941)|0));
      __label__ = 49; break;
    case 45: // $237
      var $238=$screen;
      var $239=__ZNK13screen_device12visible_areaEv($238);
      $visarea=$239;
      var $240=$2;
      var $241=$visarea;
      var $242=(($241+4)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=$visarea;
      var $245=(($244)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($243-$246)|0);
      var $248=(($247+1)|0);
      var $249=$visarea;
      var $250=(($249+12)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$visarea;
      var $253=(($252+8)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($251-$254)|0);
      var $256=(($255+1)|0);
      var $257=$1;
      var $258=__ZNK15running_machine6systemEv($257);
      var $259=(($258+44)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=$260 & 4;
      var $262=(($261)|0)!=0;
      if ($262) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $263
      var $266 = STRING_TABLE.__str123943;__label__ = 48; break;
    case 47: // $264
      var $266 = STRING_TABLE.__str133944;__label__ = 48; break;
    case 48: // $265
      var $266;
      var $267=(($266)|0);
      var $268=$screen;
      __ZNK13screen_device12frame_periodEv($3, $268);
      var $269=(($3+4)|0);
      var $st$5$0=(($269)|0);
      var $270$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($269+4)|0);
      var $270$1=HEAP32[(($st$5$1)>>2)];
      var $271=$270$0 + $270$1*4294967296;
      var $272=1000000000000000000/$271;
      var $273=__ZN7astring9catprintfEPKcz($240, ((STRING_TABLE.__str113942)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$248,HEAP32[((tempInt+4)>>2)]=$256,HEAP32[((tempInt+8)>>2)]=$267,(tempDoubleF64[0]=$272,HEAP32[((tempInt+12)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+12+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 49; break;
    case 49: // $274
      __label__ = 50; break;
    case 50: // $275
      var $276=$screen;
      var $277=__ZNK13screen_device11next_screenEv($276);
      $screen=$277;
      __label__ = 40; break;
    case 51: // $278
      __label__ = 52; break;
    case 52: // $279
      var $280=$2;
      STACKTOP = __stackBase__;
      return $280;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17game_info_astringR15running_machineR7astring["X"]=1;

function __ZL25handler_messagebox_anykeyR15running_machineP16render_containerj($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+4;
      $1=$machine;
      $2=$container;
      $3=$state;
      var $6=$2;
      var $7=__ZNK7astringcvPKcEv(__ZL15messagebox_text);
      var $8=HEAP32[((__ZL20messagebox_backcolor)>>2)];
      __Z16ui_draw_text_boxP16render_containerPKciffj($6, $7, 0, 0.5, 0.5, $8);
      var $9=$1;
      var $10=__Z16ui_input_pressedR15running_machinei($9, 183);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$1;
      __ZN15running_machine13schedule_exitEv($13);
      $3=-1;
      __label__ = 5; break;
    case 2: // $14
      var $15=$1;
      var $16=__ZNK15running_machine5inputEv($15);
      __ZN13input_manager13poll_switchesEv($4, $16);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 0, 0, 0, 0, 0);
      var $17=__ZNK10input_codeneERKS_($4, $5);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      $3=-1;
      __label__ = 4; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$3;
      STACKTOP = __stackBase__;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19ui_set_startup_textR15running_machinePKci($machine, $text, $force) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curtime=__stackBase__;
      $1=$machine;
      $2=$text;
      $3=$force;
      var $4=_osd_ticks();
      var $4$0=$4[0];
      var $4$1=$4[1];
      var $st$10$0=(($curtime)|0);
      HEAP32[(($st$10$0)>>2)]=$4$0;
      var $st$10$1=(($curtime+4)|0);
      HEAP32[(($st$10$1)>>2)]=$4$1;
      var $5=$2;
      var $6=__ZN7astring3cpyEPKc(__ZL15messagebox_text, $5);
      HEAP32[((__ZL20messagebox_backcolor)>>2)]=-284159952;
      var $7=$3;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $st$0$0=(($curtime)|0);
      var $10$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($curtime+4)|0);
      var $10$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=((__ZZ19ui_set_startup_textR15running_machinePKciE14lastupdatetime)|0);
      var $11$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=((__ZZ19ui_set_startup_textR15running_machinePKciE14lastupdatetime+4)|0);
      var $11$1=HEAP32[(($st$4$1)>>2)];
      var $12$0 = ((($10$0)>>>0)+((($10$1)|0)*4294967296))-((($11$0)>>>0)+((($11$1)|0)*4294967296))>>>0; var $12$1 = Math.min(Math.floor((((($10$0)>>>0)+((($10$1)|0)*4294967296))-((($11$0)>>>0)+((($11$1)|0)*4294967296)))/4294967296), 4294967295);
      var $13=_osd_ticks_per_second();
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $$emscripten$temp$0$0=4;
      var $$emscripten$temp$0$1=0;
      var $14$0 = (tempBigIntR=((($13$0)>>>0)+((($13$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $14$1 = Math.min(Math.floor(((tempBigIntR=((($13$0)>>>0)+((($13$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $15=($12$1|0) > ($14$1|0) || (($12$1|0) == ($14$1|0) && ($12$0|0) >  ($14$0|0));
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $st$0$0=(($curtime)|0);
      var $17$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($curtime+4)|0);
      var $17$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=((__ZZ19ui_set_startup_textR15running_machinePKciE14lastupdatetime)|0);
      HEAP32[(($st$4$0)>>2)]=$17$0;
      var $st$4$1=((__ZZ19ui_set_startup_textR15running_machinePKciE14lastupdatetime+4)|0);
      HEAP32[(($st$4$1)>>2)]=$17$1;
      var $18=$1;
      var $19=__ZNK15running_machine5videoEv($18);
      __ZN13video_manager12frame_updateEb($19, 0);
      __label__ = 3; break;
    case 3: // $20
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19ui_set_startup_textR15running_machinePKci["X"]=1;

function __ZL15warnings_stringR15running_machineR7astring($machine, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $drivlist=__stackBase__;
      var $maindrv;
      var $4;
      var $5;
      var $clone_of;
      var $foundworking;
      $2=$machine;
      $3=$string;
      var $6=$3;
      var $7=__ZN7astring5resetEv($6);
      var $8=$2;
      var $9=__Z17rom_load_warningsR15running_machine($8);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $11
      var $12=$2;
      var $13=__Z17rom_load_knownbadR15running_machine($12);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $15
      var $16=$2;
      var $17=__ZNK15running_machine6systemEv($16);
      var $18=(($17+44)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 149496;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $22
      var $23=$3;
      $1=$23;
      __label__ = 67; break;
    case 4: // $24
      var $25=$2;
      var $26=__Z17rom_load_warningsR15running_machine($25);
      var $27=(($26)|0) > 0;
      if ($27) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $28
      var $29=$3;
      var $30=__ZN7astring3catEPKc($29, ((STRING_TABLE.__str633994)|0));
      var $31=$2;
      var $32=__ZNK15running_machine6systemEv($31);
      var $33=(($32+44)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34 & 149496;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$3;
      var $39=__ZN7astring3catEPKc($38, ((STRING_TABLE.__str63937)|0));
      __label__ = 7; break;
    case 7: // $40
      __label__ = 8; break;
    case 8: // $41
      var $42=$2;
      var $43=__ZNK15running_machine6systemEv($42);
      var $44=(($43+44)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$45 & 149496;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $48
      var $49=$2;
      var $50=__Z17rom_load_knownbadR15running_machine($49);
      var $51=(($50)|0) > 0;
      if ($51) { __label__ = 10; break; } else { __label__ = 66; break; }
    case 10: // $52
      var $53=$3;
      var $54=__ZN7astring3catEPKc($53, ((STRING_TABLE.__str643995)|0));
      var $55=$2;
      var $56=__Z17rom_load_knownbadR15running_machine($55);
      var $57=(($56)|0) > 0;
      if ($57) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $58
      var $59=$3;
      var $60=__ZN7astring3catEPKc($59, ((STRING_TABLE.__str653996)|0));
      __label__ = 12; break;
    case 12: // $61
      var $62=$2;
      var $63=__Z26input_machine_has_keyboardR15running_machine($62);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $65
      var $66=$3;
      var $67=__ZN7astring3catEPKc($66, ((STRING_TABLE.__str663997)|0));
      __label__ = 14; break;
    case 14: // $68
      var $69=$2;
      var $70=__ZNK15running_machine6systemEv($69);
      var $71=(($70+44)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$72 & 64;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $75
      var $76=$3;
      var $77=__ZN7astring3catEPKc($76, ((STRING_TABLE.__str673998)|0));
      __label__ = 16; break;
    case 16: // $78
      var $79=$2;
      var $80=__ZNK15running_machine6systemEv($79);
      var $81=(($80+44)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$82 & 32;
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $85
      var $86=$3;
      var $87=__ZN7astring3catEPKc($86, ((STRING_TABLE.__str683999)|0));
      __label__ = 18; break;
    case 18: // $88
      var $89=$2;
      var $90=__ZNK15running_machine6systemEv($89);
      var $91=(($90+44)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$92 & 128;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $95
      var $96=$3;
      var $97=__ZN7astring3catEPKc($96, ((STRING_TABLE.__str694000)|0));
      __label__ = 20; break;
    case 20: // $98
      var $99=$2;
      var $100=__ZNK15running_machine6systemEv($99);
      var $101=(($100+44)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$102 & 1024;
      var $104=(($103)|0)!=0;
      if ($104) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $105
      var $106=$3;
      var $107=__ZN7astring3catEPKc($106, ((STRING_TABLE.__str704001)|0));
      __label__ = 22; break;
    case 22: // $108
      var $109=$2;
      var $110=__ZNK15running_machine6systemEv($109);
      var $111=(($110+44)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$112 & 512;
      var $114=(($113)|0)!=0;
      if ($114) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $115
      var $116=$3;
      var $117=__ZN7astring3catEPKc($116, ((STRING_TABLE.__str714002)|0));
      __label__ = 24; break;
    case 24: // $118
      var $119=$2;
      var $120=__ZNK15running_machine6systemEv($119);
      var $121=(($120+44)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$122 & 256;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $125
      var $126=$3;
      var $127=__ZN7astring3catEPKc($126, ((STRING_TABLE.__str724003)|0));
      __label__ = 26; break;
    case 26: // $128
      var $129=$2;
      var $130=__ZNK15running_machine6systemEv($129);
      var $131=(($130+44)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$132 & 16384;
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $135
      var $136=$3;
      var $137=__ZN7astring3catEPKc($136, ((STRING_TABLE.__str734004)|0));
      __label__ = 28; break;
    case 28: // $138
      var $139=$2;
      var $140=__ZNK15running_machine6systemEv($139);
      var $141=(($140+44)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$142 & 131096;
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 29; break; } else { __label__ = 65; break; }
    case 29: // $145
      var $146=$2;
      var $147=__ZNK15running_machine6systemEv($146);
      var $148=(($147+44)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$149 & 16;
      var $151=(($150)|0)!=0;
      if ($151) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $152
      var $153=$3;
      var $154=__ZN7astring3catEPKc($153, ((STRING_TABLE.__str744005)|0));
      __label__ = 31; break;
    case 31: // $155
      var $156=$2;
      var $157=__ZNK15running_machine6systemEv($156);
      var $158=(($157+44)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=$159 & 8;
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $162
      var $163=$3;
      var $164=__ZN7astring3catEPKc($163, ((STRING_TABLE.__str754006)|0));
      __label__ = 33; break;
    case 33: // $165
      var $166=$2;
      var $167=__ZNK15running_machine6systemEv($166);
      var $168=(($167+44)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=$169 & 131072;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $172
      var $173=$3;
      var $174=__ZN7astring3catEPKc($173, ((STRING_TABLE.__str764007)|0));
      __label__ = 35; break;
    case 35: // $175
      var $176=$2;
      var $177=__ZNK15running_machine7optionsEv($176);
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_options]($drivlist, $177);
      var $178=$2;
      var $179=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($178) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 40; break; };
    case 36: // $180
      var $181=(function() { try { __THREW__ = false; return __ZN11driver_list4findERK11game_driver($179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 40; break; };
    case 37: // $182
      $maindrv=$181;
      var $183=$maindrv;
      var $184=(function() { try { __THREW__ = false; return __ZN11driver_list14non_bios_cloneEi($183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 40; break; };
    case 38: // $185
      $clone_of=$184;
      var $186=$clone_of;
      var $187=(($186)|0)!=-1;
      if ($187) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $188
      var $189=$clone_of;
      $maindrv=$189;
      __label__ = 41; break;
    case 40: // $190
      var $191=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $192=$191.f0;
      $4=$192;
      var $193=$191.f1;
      $5=$193;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 69; break; }
    case 41: // $194
      $foundworking=0;
      __label__ = 42; break;
    case 42: // $195
      var $196=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 40; break; };
    case 43: // $197
      if ($196) { __label__ = 44; break; } else { __label__ = 60; break; }
    case 44: // $198
      var $199=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator7currentEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 40; break; };
    case 45: // $200
      var $201=$maindrv;
      var $202=(($199)|0)==(($201)|0);
      if ($202) { __label__ = 48; break; } else { __label__ = 46; break; }
    case 46: // $203
      var $204=(function() { try { __THREW__ = false; return __ZN17driver_enumerator5cloneEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 40; break; };
    case 47: // $205
      var $206=$maindrv;
      var $207=(($204)|0)==(($206)|0);
      if ($207) { __label__ = 48; break; } else { __label__ = 59; break; }
    case 48: // $208
      var $209=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 40; break; };
    case 49: // $210
      var $211=(($209+44)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=$212 & 131096;
      var $214=(($213)|0)==0;
      if ($214) { __label__ = 50; break; } else { __label__ = 58; break; }
    case 50: // $215
      var $216=$foundworking;
      var $217=(($216) & 1);
      if ($217) { __label__ = 53; break; } else { __label__ = 51; break; }
    case 51: // $218
      var $219=$3;
      var $220=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($219, ((STRING_TABLE.__str774008)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 40; break; };
    case 52: // $221
      __label__ = 55; break;
    case 53: // $222
      var $223=$3;
      var $224=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($223, ((STRING_TABLE.__str784009)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 40; break; };
    case 54: // $225
      __label__ = 55; break;
    case 55: // $226
      var $227=$3;
      var $228=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($drivlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 40; break; };
    case 56: // $229
      var $230=(($228+8)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($227, $231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 40; break; };
    case 57: // $233
      $foundworking=1;
      __label__ = 58; break;
    case 58: // $234
      __label__ = 59; break;
    case 59: // $235
      __label__ = 42; break;
    case 60: // $236
      var $237=$foundworking;
      var $238=(($237) & 1);
      if ($238) { __label__ = 61; break; } else { __label__ = 63; break; }
    case 61: // $239
      var $240=$3;
      var $241=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($240, ((STRING_TABLE.__str63937)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 40; break; };
    case 62: // $242
      __label__ = 63; break;
    case 63: // $243
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($drivlist);
      __label__ = 65; break;
    case 64: // $244
      __label__ = 68; break;
    case 65: // $245
      __label__ = 66; break;
    case 66: // $246
      var $247=$3;
      var $248=__ZN7astring3catEPKc($247, ((STRING_TABLE.__str794010)|0));
      var $249=$3;
      $1=$249;
      __label__ = 67; break;
    case 67: // $250
      var $251=$1;
      STACKTOP = __stackBase__;
      return $251;
    case 68: // $252
      var $253=$4;
      var $254=$4;
      var $255=$5;
      var $256=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $254, tempValue);
      var $257=($256.f1 = $255, $256);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 69: // $258
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15warnings_stringR15running_machineR7astring["X"]=1;

function __ZNK15running_machine5cheatEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+1276)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11render_font12pixel_heightEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z20ui_update_and_renderR15running_machineP16render_container($machine, $container) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $alpha;
      $1=$machine;
      $2=$container;
      var $3=$2;
      __ZN16render_container5emptyEv($3);
      var $4=$1;
      var $5=__ZNK15running_machine5phaseEv($4);
      var $6=(($5)|0) >= 2;
      if ($6) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $7
      var $8=HEAP32[((__ZL11single_step)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$1;
      var $12=__ZNK15running_machine6pausedEv($11);
      if ($12) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $13
      var $14=$1;
      var $15=__ZNK15running_machine7optionsEv($14);
      var $16=__ZNK11emu_options16pause_brightnessEv($15);
      var $17=1-$16;
      var $18=$17*255;
      var $19=(($18)|0);
      $alpha=$19;
      var $20=__Z28ui_menu_is_force_game_selectv();
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      $alpha=255;
      __label__ = 5; break;
    case 5: // $23
      var $24=$alpha;
      var $25=(($24)|0) > 255;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      $alpha=255;
      __label__ = 7; break;
    case 7: // $27
      var $28=$alpha;
      var $29=(($28)|0) >= 0;
      if ($29) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $30
      var $31=$2;
      var $32=$alpha;
      var $33=$32 & 255;
      var $34=$33 << 24;
      __ZN16render_container8add_rectEffffjj($31, 0, 0, 1, 1, $34, 256);
      __label__ = 9; break;
    case 9: // $35
      __label__ = 10; break;
    case 10: // $36
      var $37=$1;
      var $38=__ZNK15running_machine5phaseEv($37);
      var $39=(($38)|0) >= 2;
      if ($39) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $40
      var $41=$1;
      var $42=__ZNK15running_machine5cheatEv($41);
      var $43=$2;
      __ZN13cheat_manager11render_textER16render_container($42, $43);
      __label__ = 12; break;
    case 12: // $44
      __label__ = 13; break;
    case 13: // $45
      __label__ = 14; break;
    case 14: // $46
      var $47=HEAP32[((__ZL19ui_handler_callback)>>2)];
      var $48=$1;
      var $49=$2;
      var $50=HEAP32[((__ZL16ui_handler_param)>>2)];
      var $51=FUNCTION_TABLE[$47]($48, $49, $50);
      HEAP32[((__ZL16ui_handler_param)>>2)]=$51;
      var $52=_osd_ticks();
      var $52$0=$52[0];
      var $52$1=$52[1];
      var $st$9$0=((__ZL14popup_text_end)|0);
      var $53$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=((__ZL14popup_text_end+4)|0);
      var $53$1=HEAP32[(($st$9$1)>>2)];
      var $54=($52$1|0) < ($53$1|0) || (($52$1|0) == ($53$1|0) && ($52$0|0) <  ($53$0|0));
      if ($54) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $55
      var $56=$2;
      var $57=__ZNK7astringcvPKcEv(__ZL15messagebox_text);
      var $58=HEAP32[((__ZL20messagebox_backcolor)>>2)];
      __Z16ui_draw_text_boxP16render_containerPKciffj($56, $57, 1, 0.5, 0.8999999761581421, $58);
      __label__ = 17; break;
    case 16: // $59
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=((__ZL14popup_text_end)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=((__ZL14popup_text_end+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 17; break;
    case 17: // $60
      var $61=HEAP32[((__ZL16ui_handler_param)>>2)];
      var $62=(($61)|0)==-1;
      if ($62) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $63
      var $64=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(936, 0);
      __label__ = 19; break;
    case 19: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20ui_update_and_renderR15running_machineP16render_container["X"]=1;

function __ZNK11emu_options16pause_brightnessEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str844015)|0));
  ;
  return $4;
}


function __ZN16render_container8add_rectEffffjj($this, $x0, $y0, $x1, $y1, $argb, $flags) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$x0;
  $3=$y0;
  $4=$x1;
  $5=$y1;
  $6=$argb;
  $7=$flags;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  var $14=$7;
  __ZN16render_container8add_quadEffffjP14render_texturej($8, $9, $10, $11, $12, $13, 0, $14);
  ;
  return;
}


function __Z16ui_draw_text_boxP16render_containerPKciffj($container, $text, $justify, $xpos, $ypos, $backcolor) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $line_height;
      var $max_width;
      var $target_width=__stackBase__;
      var $target_height=__stackBase__+4;
      var $target_x;
      var $target_y;
      var $last_target_height;
      var $pass;
      $1=$container;
      $2=$text;
      $3=$justify;
      $4=$xpos;
      $5=$ypos;
      $6=$backcolor;
      var $7=$1;
      var $8=__ZNK16render_container7managerEv($7);
      var $9=__ZNK14render_manager7machineEv($8);
      var $10=__Z18ui_get_line_heightR15running_machine($9);
      $line_height=$10;
      var $11=$4;
      var $12=$11 <= 0.5;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$4;
      var $19 = $14;__label__ = 3; break;
    case 2: // $15
      var $16=$4;
      var $17=1-$16;
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      var $20=$19*2;
      var $21=$20-0.019999999552965164;
      $max_width=$21;
      var $22=$max_width;
      HEAPF32[(($target_width)>>2)]=$22;
      var $23=$line_height;
      HEAPF32[(($target_height)>>2)]=$23;
      $target_x=0;
      $target_y=0;
      $last_target_height=0;
      $pass=0;
      __label__ = 4; break;
    case 4: // $24
      var $25=$pass;
      var $26=(($25)|0) < 5;
      if ($26) { __label__ = 5; break; } else { __label__ = 19; break; }
    case 5: // $27
      var $28=$4;
      var $29=HEAPF32[(($target_width)>>2)];
      var $30=$29*0.5;
      var $31=$28-$30;
      $target_x=$31;
      var $32=$5;
      var $33=HEAPF32[(($target_height)>>2)];
      var $34=$33*0.5;
      var $35=$32-$34;
      $target_y=$35;
      var $36=$target_x;
      var $37=$36 < 0.009999999776482582;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      $target_x=0.009999999776482582;
      __label__ = 7; break;
    case 7: // $39
      var $40=$target_x;
      var $41=HEAPF32[(($target_width)>>2)];
      var $42=$40+$41;
      var $43=$42+0.009999999776482582;
      var $44=$43 > 1;
      if ($44) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $45
      var $46=HEAPF32[(($target_width)>>2)];
      var $47=0.9900000095367432-$46;
      $target_x=$47;
      __label__ = 9; break;
    case 9: // $48
      var $49=$target_y;
      var $50=$49 < 0.009999999776482582;
      if ($50) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $51
      $target_y=0.009999999776482582;
      __label__ = 11; break;
    case 11: // $52
      var $53=$target_y;
      var $54=HEAPF32[(($target_height)>>2)];
      var $55=$53+$54;
      var $56=$55+0.009999999776482582;
      var $57=$56 > 1;
      if ($57) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $58
      var $59=HEAPF32[(($target_height)>>2)];
      var $60=0.9900000095367432-$59;
      $target_y=$60;
      __label__ = 13; break;
    case 13: // $61
      var $62=$1;
      var $63=$2;
      var $64=$target_x;
      var $65=$target_y;
      var $66=HEAPF32[(($target_width)>>2)];
      var $67=$66+0.000009999999747378752;
      var $68=$3;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($62, $63, $64, $65, $67, $68, 2, 0, -1, -285212672, $target_width, $target_height);
      var $69=HEAPF32[(($target_height)>>2)];
      var $70=$69 > 0.9800000190734863;
      if ($70) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $71
      var $72=$line_height;
      var $73=0.9800000190734863/$72;
      var $74=$73;
      var $75=_floor($74);
      var $76=$line_height;
      var $77=$76;
      var $78=$75*$77;
      var $79=$78;
      HEAPF32[(($target_height)>>2)]=$79;
      __label__ = 15; break;
    case 15: // $80
      var $81=HEAPF32[(($target_height)>>2)];
      var $82=$last_target_height;
      var $83=$81 == $82;
      if ($83) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $84
      __label__ = 19; break;
    case 17: // $85
      var $86=HEAPF32[(($target_height)>>2)];
      $last_target_height=$86;
      __label__ = 18; break;
    case 18: // $87
      var $88=$pass;
      var $89=(($88+1)|0);
      $pass=$89;
      __label__ = 4; break;
    case 19: // $90
      var $91=$1;
      var $92=$target_x;
      var $93=$92-0.009999999776482582;
      var $94=$target_y;
      var $95=$94-0.009999999776482582;
      var $96=$target_x;
      var $97=HEAPF32[(($target_width)>>2)];
      var $98=$96+$97;
      var $99=$98+0.009999999776482582;
      var $100=$target_y;
      var $101=HEAPF32[(($target_height)>>2)];
      var $102=$100+$101;
      var $103=$102+0.009999999776482582;
      var $104=$6;
      __Z20ui_draw_outlined_boxP16render_containerffffj($91, $93, $95, $99, $103, $104);
      var $105=$1;
      var $106=$2;
      var $107=$target_x;
      var $108=$target_y;
      var $109=HEAPF32[(($target_width)>>2)];
      var $110=$109+0.000009999999747378752;
      var $111=$3;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($105, $106, $107, $108, $110, $111, 2, 1, -1, -285212672, 0, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16ui_draw_text_boxP16render_containerPKciffj["X"]=1;

function __Z11ui_get_fontR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=HEAP32[((__ZL7ui_font)>>2)];
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=$1;
      var $6=__ZNK15running_machine6renderEv($5);
      var $7=$1;
      var $8=__ZNK15running_machine7optionsEv($7);
      var $9=__ZNK11emu_options7ui_fontEv($8);
      var $10=__ZN14render_manager10font_allocEPKc($6, $9);
      HEAP32[((__ZL7ui_font)>>2)]=$10;
      __label__ = 2; break;
    case 2: // $11
      var $12=HEAP32[((__ZL7ui_font)>>2)];
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options7ui_fontEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str834014)|0));
  ;
  return $4;
}


function __Z18ui_get_line_heightR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $raw_font_pixel_height;
      var $ui_target;
      var $target_pixel_height;
      var $one_to_one_line_height;
      var $scale_factor;
      var $height;
      $1=$machine;
      var $2=$1;
      var $3=__Z11ui_get_fontR15running_machine($2);
      var $4=__ZNK11render_font12pixel_heightEv($3);
      $raw_font_pixel_height=$4;
      var $5=$1;
      var $6=__ZNK15running_machine6renderEv($5);
      var $7=__ZNK14render_manager9ui_targetEv($6);
      $ui_target=$7;
      var $8=$ui_target;
      var $9=__ZNK13render_target6heightEv($8);
      $target_pixel_height=$9;
      var $10=$raw_font_pixel_height;
      var $11=(($10)|0);
      var $12=$target_pixel_height;
      var $13=(($12)|0);
      var $14=$11/$13;
      $one_to_one_line_height=$14;
      var $15=$one_to_one_line_height;
      var $16=0.03999999910593033/$15;
      $scale_factor=$16;
      var $17=$raw_font_pixel_height;
      var $18=(($17)|0) < 24;
      if ($18) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $19
      var $20=$scale_factor;
      var $21=$20 <= 1;
      if ($21) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $22
      var $23=$one_to_one_line_height;
      var $24=$23 < 0.06666667014360428;
      if ($24) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=$raw_font_pixel_height;
      var $27=(($26)|0) < 12;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      $scale_factor=1;
      __label__ = 5; break;
    case 5: // $29
      __label__ = 7; break;
    case 6: // $30
      var $31=$scale_factor;
      var $32=$31;
      var $33=_floor($32);
      var $34=$33;
      $scale_factor=$34;
      __label__ = 7; break;
    case 7: // $35
      __label__ = 9; break;
    case 8: // $36
      var $37=$scale_factor;
      var $38=$one_to_one_line_height;
      var $39=$37*$38;
      var $40=$target_pixel_height;
      var $41=(($40)|0);
      var $42=$39*$41;
      var $43=(($42)|0);
      $height=$43;
      var $44=$height;
      var $45=(($44)|0);
      var $46=$one_to_one_line_height;
      var $47=$target_pixel_height;
      var $48=(($47)|0);
      var $49=$46*$48;
      var $50=$45/$49;
      $scale_factor=$50;
      __label__ = 9; break;
    case 9: // $51
      var $52=$scale_factor;
      var $53=$one_to_one_line_height;
      var $54=$52*$53;
      ;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18ui_get_line_heightR15running_machine["X"]=1;

function __Z17ui_get_char_widthR15running_machinej($machine, $ch) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$ch;
  var $3=$1;
  var $4=__Z11ui_get_fontR15running_machine($3);
  var $5=$1;
  var $6=__Z18ui_get_line_heightR15running_machine($5);
  var $7=$1;
  var $8=__ZNK15running_machine6renderEv($7);
  var $9=__ZN14render_manager9ui_aspectEv($8);
  var $10=$2;
  var $11=__ZN11render_font10char_widthEffj($4, $6, $9, $10);
  ;
  return $11;
}


function __Z19ui_get_string_widthR15running_machinePKc($machine, $s) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$s;
  var $3=$1;
  var $4=__Z11ui_get_fontR15running_machine($3);
  var $5=$1;
  var $6=__Z18ui_get_line_heightR15running_machine($5);
  var $7=$1;
  var $8=__ZNK15running_machine6renderEv($7);
  var $9=__ZN14render_manager9ui_aspectEv($8);
  var $10=$2;
  var $11=__ZN11render_font16utf8string_widthEffPKc($4, $6, $9, $10);
  ;
  return $11;
}


function __Z20ui_draw_outlined_boxP16render_containerffffj($container, $x0, $y0, $x1, $y1, $backcolor) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$container;
  $2=$x0;
  $3=$y0;
  $4=$x1;
  $5=$y1;
  $6=$backcolor;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$5;
  var $12=$6;
  __ZN16render_container8add_rectEffffjj($7, $8, $9, $10, $11, $12, 256);
  var $13=$1;
  var $14=$2;
  var $15=$3;
  var $16=$4;
  var $17=$3;
  __ZN16render_container8add_lineEfffffjj($13, $14, $15, $16, $17, 0.0020000000949949026, -1, 256);
  var $18=$1;
  var $19=$4;
  var $20=$3;
  var $21=$4;
  var $22=$5;
  __ZN16render_container8add_lineEfffffjj($18, $19, $20, $21, $22, 0.0020000000949949026, -1, 256);
  var $23=$1;
  var $24=$4;
  var $25=$5;
  var $26=$2;
  var $27=$5;
  __ZN16render_container8add_lineEfffffjj($23, $24, $25, $26, $27, 0.0020000000949949026, -1, 256);
  var $28=$1;
  var $29=$2;
  var $30=$5;
  var $31=$2;
  var $32=$3;
  __ZN16render_container8add_lineEfffffjj($28, $29, $30, $31, $32, 0.0020000000949949026, -1, 256);
  ;
  return;
}


function __Z20ui_get_show_profilerv() {
  ;
  var __label__;

  var $1=HEAP32[((__ZL13show_profiler)>>2)];
  ;
  return $1;
}


function __Z18ui_get_slider_listv() {
  ;
  var __label__;

  var $1=HEAP32[((__ZL11slider_list)>>2)];
  ;
  return $1;
}


function __Z27ui_get_use_natural_keyboardR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=HEAP32[((__ZL23ui_use_natural_keyboard)>>2)];
  ;
  return $2;
}


function __ZL17is_breakable_charj($ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$ch;
      var $3=$2;
      var $4=(($3)|0)==32;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6)|0)==45;
      if ($7) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $8
      $1=1;
      __label__ = 13; break;
    case 3: // $9
      var $10=$2;
      var $11=(($10)>>>0) >= 12352;
      if ($11) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $12
      var $13=$2;
      var $14=(($13)>>>0) <= 40959;
      if ($14) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $15
      $1=1;
      __label__ = 13; break;
    case 6: // $16
      var $17=$2;
      var $18=(($17)>>>0) >= 44032;
      if ($18) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $19
      var $20=$2;
      var $21=(($20)>>>0) <= 55215;
      if ($21) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $22
      $1=1;
      __label__ = 13; break;
    case 9: // $23
      var $24=$2;
      var $25=(($24)>>>0) >= 63744;
      if ($25) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $26
      var $27=$2;
      var $28=(($27)>>>0) <= 64255;
      if ($28) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $29
      $1=1;
      __label__ = 13; break;
    case 12: // $30
      $1=0;
      __label__ = 13; break;
    case 13: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20dummy_profiler_state6enableEb($this, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($state)&1);
  $2=$3;
  var $4=$1;
  ;
  return;
}


function __Z17ui_is_menu_activev() {
  ;
  var __label__;

  var $1=HEAP32[((__ZL19ui_handler_callback)>>2)];
  var $2=(($1)|0)==948;
  var $3=(($2)&1);
  ;
  return $3;
}


function __ZNK16render_container7managerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z15ui_set_show_fpsi($show) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$show;
      var $2=$1;
      HEAP32[((__ZL7showfps)>>2)]=$2;
      var $3=$1;
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      HEAP32[((__ZL7showfps)>>2)]=0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$3$0=((__ZL11showfps_end)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$0$0;
      var $st$3$1=((__ZL11showfps_end+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $6
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15ui_get_show_fpsv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=HEAP32[((__ZL7showfps)>>2)];
      var $2=(($1)|0)!=0;
      if ($2) { var $7 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $3
      var $st$0$0=((__ZL11showfps_end)|0);
      var $4$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=((__ZL11showfps_end+4)|0);
      var $4$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $5=$4$0 != $$emscripten$temp$0$0 || $4$1 != $$emscripten$temp$0$1;
      var $7 = $5;__label__ = 2; break;
    case 2: // $6
      var $7;
      var $8=(($7)&1);
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($container, $origs, $x, $y, $origwrapwidth, $justify, $wrap, $draw, $fgcolor, $bgcolor, $totalwidth, $totalheight) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      var $machine;
      var $lineheight;
      var $ends;
      var $wrapwidth;
      var $s;
      var $linestart;
      var $cury;
      var $maxwidth;
      var $lastbreak;
      var $line_justify;
      var $schar=__stackBase__;
      var $scharcount;
      var $lastbreak_width;
      var $curwidth;
      var $curx;
      var $chwidth;
      var $linechar=__stackBase__+4;
      var $linecharcount;
      $1=$container;
      $2=$origs;
      $3=$x;
      $4=$y;
      $5=$origwrapwidth;
      $6=$justify;
      $7=$wrap;
      $8=$draw;
      $9=$fgcolor;
      $10=$bgcolor;
      $11=$totalwidth;
      $12=$totalheight;
      var $13=$1;
      var $14=__ZNK16render_container7managerEv($13);
      var $15=__ZNK14render_manager7machineEv($14);
      $machine=$15;
      var $16=$machine;
      var $17=__Z18ui_get_line_heightR15running_machine($16);
      $lineheight=$17;
      var $18=$2;
      var $19=$2;
      var $20=_strlen($19);
      var $21=(($18+$20)|0);
      $ends=$21;
      var $22=$5;
      $wrapwidth=$22;
      var $23=$2;
      $s=$23;
      var $24=$4;
      $cury=$24;
      $maxwidth=0;
      var $25=$7;
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      $wrapwidth=1000000;
      __label__ = 2; break;
    case 2: // $28
      var $29=$wrapwidth;
      var $30=$29 <= 0;
      if ($30) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $31
      __label__ = 85; break;
    case 4: // $32
      __label__ = 5; break;
    case 5: // $33
      var $34=$s;
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 6; break; } else { __label__ = 81; break; }
    case 6: // $38
      $lastbreak=0;
      var $39=$6;
      $line_justify=$39;
      $lastbreak_width=0;
      $curwidth=0;
      var $40=$3;
      $curx=$40;
      var $41=$s;
      var $42=$ends;
      var $43=$s;
      var $44=$42;
      var $45=$43;
      var $46=(($44-$45)|0);
      var $47=__Z15uchar_from_utf8PjPKcj($schar, $41, $46);
      $scharcount=$47;
      var $48=$scharcount;
      var $49=(($48)|0)==-1;
      if ($49) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $50
      __label__ = 81; break;
    case 8: // $51
      var $52=HEAP32[(($schar)>>2)];
      var $53=(($52)|0)==9;
      if ($53) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $54
      var $55=$scharcount;
      var $56=$s;
      var $57=(($56+$55)|0);
      $s=$57;
      $line_justify=1;
      __label__ = 10; break;
    case 10: // $58
      var $59=$s;
      $linestart=$59;
      __label__ = 11; break;
    case 11: // $60
      var $61=$s;
      var $62=HEAP8[($61)];
      var $63=(($62 << 24) >> 24);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 12; break; } else { var $70 = 0;__label__ = 13; break; }
    case 12: // $65
      var $66=$curwidth;
      var $67=$wrapwidth;
      var $68=$66 <= $67;
      var $70 = $68;__label__ = 13; break;
    case 13: // $69
      var $70;
      if ($70) { __label__ = 14; break; } else { __label__ = 25; break; }
    case 14: // $71
      var $72=$s;
      var $73=$ends;
      var $74=$s;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=__Z15uchar_from_utf8PjPKcj($schar, $72, $77);
      $scharcount=$78;
      var $79=$scharcount;
      var $80=(($79)|0)==-1;
      if ($80) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $81
      __label__ = 25; break;
    case 16: // $82
      var $83=HEAP32[(($schar)>>2)];
      var $84=(($83)|0)==10;
      if ($84) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $85
      __label__ = 25; break;
    case 18: // $86
      var $87=$machine;
      var $88=HEAP32[(($schar)>>2)];
      var $89=__Z17ui_get_char_widthR15running_machinej($87, $88);
      $chwidth=$89;
      var $90=HEAP32[(($schar)>>2)];
      var $91=(($90)|0)==32;
      if ($91) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $92
      var $93=$s;
      $lastbreak=$93;
      var $94=$curwidth;
      $lastbreak_width=$94;
      __label__ = 20; break;
    case 20: // $95
      var $96=$chwidth;
      var $97=$curwidth;
      var $98=$97+$96;
      $curwidth=$98;
      var $99=$scharcount;
      var $100=$s;
      var $101=(($100+$99)|0);
      $s=$101;
      var $102=HEAP32[(($schar)>>2)];
      var $103=(($102)|0)!=32;
      if ($103) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $104
      var $105=HEAP32[(($schar)>>2)];
      var $106=__ZL17is_breakable_charj($105);
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $108
      var $109=$curwidth;
      var $110=$wrapwidth;
      var $111=$109 <= $110;
      if ($111) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $112
      var $113=$s;
      $lastbreak=$113;
      var $114=$curwidth;
      $lastbreak_width=$114;
      __label__ = 24; break;
    case 24: // $115
      __label__ = 11; break;
    case 25: // $116
      var $117=$curwidth;
      var $118=$wrapwidth;
      var $119=$117 > $118;
      if ($119) { __label__ = 26; break; } else { __label__ = 46; break; }
    case 26: // $120
      var $121=$7;
      var $122=(($121)|0)==2;
      if ($122) { __label__ = 27; break; } else { __label__ = 35; break; }
    case 27: // $123
      var $124=$lastbreak;
      var $125=(($124)|0)!=0;
      if ($125) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $126
      var $127=$lastbreak;
      $s=$127;
      var $128=$lastbreak_width;
      $curwidth=$128;
      __label__ = 34; break;
    case 29: // $129
      var $130=$s;
      var $131=$linestart;
      var $132=(($130)>>>0) > (($131)>>>0);
      if ($132) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $133
      var $134=$s;
      var $135=__Z18utf8_previous_charPKc($134);
      $s=$135;
      var $136=$s;
      var $137=$ends;
      var $138=$s;
      var $139=$137;
      var $140=$138;
      var $141=(($139-$140)|0);
      var $142=__Z15uchar_from_utf8PjPKcj($schar, $136, $141);
      $scharcount=$142;
      var $143=$scharcount;
      var $144=(($143)|0)==-1;
      if ($144) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $145
      __label__ = 81; break;
    case 32: // $146
      var $147=$machine;
      var $148=HEAP32[(($schar)>>2)];
      var $149=__Z17ui_get_char_widthR15running_machinej($147, $148);
      var $150=$curwidth;
      var $151=$150-$149;
      $curwidth=$151;
      __label__ = 33; break;
    case 33: // $152
      __label__ = 34; break;
    case 34: // $153
      __label__ = 45; break;
    case 35: // $154
      var $155=$7;
      var $156=(($155)|0)==1;
      if ($156) { __label__ = 36; break; } else { __label__ = 44; break; }
    case 36: // $157
      var $158=$machine;
      var $159=__Z17ui_get_char_widthR15running_machinej($158, 46);
      var $160=$159*3;
      var $161=$curwidth;
      var $162=$161+$160;
      $curwidth=$162;
      __label__ = 37; break;
    case 37: // $163
      var $164=$curwidth;
      var $165=$wrapwidth;
      var $166=$164 > $165;
      if ($166) { __label__ = 38; break; } else { var $172 = 0;__label__ = 39; break; }
    case 38: // $167
      var $168=$s;
      var $169=$linestart;
      var $170=(($168)>>>0) > (($169)>>>0);
      var $172 = $170;__label__ = 39; break;
    case 39: // $171
      var $172;
      if ($172) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $173
      var $174=$s;
      var $175=__Z18utf8_previous_charPKc($174);
      $s=$175;
      var $176=$s;
      var $177=$ends;
      var $178=$s;
      var $179=$177;
      var $180=$178;
      var $181=(($179-$180)|0);
      var $182=__Z15uchar_from_utf8PjPKcj($schar, $176, $181);
      $scharcount=$182;
      var $183=$scharcount;
      var $184=(($183)|0)==-1;
      if ($184) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $185
      __label__ = 43; break;
    case 42: // $186
      var $187=$machine;
      var $188=HEAP32[(($schar)>>2)];
      var $189=__Z17ui_get_char_widthR15running_machinej($187, $188);
      var $190=$curwidth;
      var $191=$190-$189;
      $curwidth=$191;
      __label__ = 37; break;
    case 43: // $192
      __label__ = 44; break;
    case 44: // $193
      __label__ = 45; break;
    case 45: // $194
      __label__ = 46; break;
    case 46: // $195
      var $196=$line_justify;
      var $197=(($196)|0)==1;
      if ($197) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $198
      var $199=$5;
      var $200=$curwidth;
      var $201=$199-$200;
      var $202=$201*0.5;
      var $203=$curx;
      var $204=$203+$202;
      $curx=$204;
      __label__ = 51; break;
    case 48: // $205
      var $206=$line_justify;
      var $207=(($206)|0)==2;
      if ($207) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $208
      var $209=$5;
      var $210=$curwidth;
      var $211=$209-$210;
      var $212=$curx;
      var $213=$212+$211;
      $curx=$213;
      __label__ = 50; break;
    case 50: // $214
      __label__ = 51; break;
    case 51: // $215
      var $216=$curwidth;
      var $217=$maxwidth;
      var $218=$216 > $217;
      if ($218) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $219
      var $220=$curwidth;
      $maxwidth=$220;
      __label__ = 53; break;
    case 53: // $221
      var $222=$8;
      var $223=(($222)|0)==2;
      if ($223) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $224
      var $225=$1;
      var $226=$curx;
      var $227=$cury;
      var $228=$curx;
      var $229=$curwidth;
      var $230=$228+$229;
      var $231=$cury;
      var $232=$lineheight;
      var $233=$231+$232;
      var $234=$10;
      __ZN16render_container8add_rectEffffjj($225, $226, $227, $230, $233, $234, 256);
      __label__ = 55; break;
    case 55: // $235
      __label__ = 56; break;
    case 56: // $236
      var $237=$linestart;
      var $238=$s;
      var $239=(($237)>>>0) < (($238)>>>0);
      if ($239) { __label__ = 57; break; } else { __label__ = 62; break; }
    case 57: // $240
      var $241=$linestart;
      var $242=$ends;
      var $243=$linestart;
      var $244=$242;
      var $245=$243;
      var $246=(($244-$245)|0);
      var $247=__Z15uchar_from_utf8PjPKcj($linechar, $241, $246);
      $linecharcount=$247;
      var $248=$linecharcount;
      var $249=(($248)|0)==-1;
      if ($249) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $250
      __label__ = 62; break;
    case 59: // $251
      var $252=$8;
      var $253=(($252)|0)!=0;
      if ($253) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $254
      var $255=$1;
      var $256=$curx;
      var $257=$cury;
      var $258=$lineheight;
      var $259=$machine;
      var $260=__ZNK15running_machine6renderEv($259);
      var $261=__ZN14render_manager9ui_aspectEv($260);
      var $262=$9;
      var $263=$machine;
      var $264=__Z11ui_get_fontR15running_machine($263);
      var $265=HEAP32[(($linechar)>>2)];
      var $266=(($265) & 65535);
      __ZN16render_container8add_charEffffjR11render_fontt($255, $256, $257, $258, $261, $262, $264, $266);
      var $267=$machine;
      var $268=HEAP32[(($linechar)>>2)];
      var $269=__Z17ui_get_char_widthR15running_machinej($267, $268);
      var $270=$curx;
      var $271=$270+$269;
      $curx=$271;
      __label__ = 61; break;
    case 61: // $272
      var $273=$linecharcount;
      var $274=$linestart;
      var $275=(($274+$273)|0);
      $linestart=$275;
      __label__ = 56; break;
    case 62: // $276
      var $277=$7;
      var $278=(($277)|0)==1;
      if ($278) { __label__ = 63; break; } else { __label__ = 66; break; }
    case 63: // $279
      var $280=$s;
      var $281=HEAP8[($280)];
      var $282=(($281 << 24) >> 24);
      var $283=(($282)|0)!=0;
      if ($283) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 64: // $284
      var $285=$8;
      var $286=(($285)|0)!=0;
      if ($286) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $287
      var $288=$1;
      var $289=$curx;
      var $290=$cury;
      var $291=$lineheight;
      var $292=$machine;
      var $293=__ZNK15running_machine6renderEv($292);
      var $294=__ZN14render_manager9ui_aspectEv($293);
      var $295=$9;
      var $296=$machine;
      var $297=__Z11ui_get_fontR15running_machine($296);
      __ZN16render_container8add_charEffffjR11render_fontt($288, $289, $290, $291, $294, $295, $297, 46);
      var $298=$machine;
      var $299=__Z17ui_get_char_widthR15running_machinej($298, 46);
      var $300=$curx;
      var $301=$300+$299;
      $curx=$301;
      var $302=$1;
      var $303=$curx;
      var $304=$cury;
      var $305=$lineheight;
      var $306=$machine;
      var $307=__ZNK15running_machine6renderEv($306);
      var $308=__ZN14render_manager9ui_aspectEv($307);
      var $309=$9;
      var $310=$machine;
      var $311=__Z11ui_get_fontR15running_machine($310);
      __ZN16render_container8add_charEffffjR11render_fontt($302, $303, $304, $305, $308, $309, $311, 46);
      var $312=$machine;
      var $313=__Z17ui_get_char_widthR15running_machinej($312, 46);
      var $314=$curx;
      var $315=$314+$313;
      $curx=$315;
      var $316=$1;
      var $317=$curx;
      var $318=$cury;
      var $319=$lineheight;
      var $320=$machine;
      var $321=__ZNK15running_machine6renderEv($320);
      var $322=__ZN14render_manager9ui_aspectEv($321);
      var $323=$9;
      var $324=$machine;
      var $325=__Z11ui_get_fontR15running_machine($324);
      __ZN16render_container8add_charEffffjR11render_fontt($316, $317, $318, $319, $322, $323, $325, 46);
      var $326=$machine;
      var $327=__Z17ui_get_char_widthR15running_machinej($326, 46);
      var $328=$curx;
      var $329=$328+$327;
      $curx=$329;
      __label__ = 66; break;
    case 66: // $330
      var $331=$7;
      var $332=(($331)|0)!=2;
      if ($332) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $333
      __label__ = 81; break;
    case 68: // $334
      var $335=$lineheight;
      var $336=$cury;
      var $337=$336+$335;
      $cury=$337;
      var $338=$s;
      var $339=$ends;
      var $340=$s;
      var $341=$339;
      var $342=$340;
      var $343=(($341-$342)|0);
      var $344=__Z15uchar_from_utf8PjPKcj($schar, $338, $343);
      $scharcount=$344;
      var $345=$scharcount;
      var $346=(($345)|0)==-1;
      if ($346) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $347
      __label__ = 81; break;
    case 70: // $348
      var $349=HEAP32[(($schar)>>2)];
      var $350=(($349)|0)==10;
      if ($350) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $351
      var $352=$scharcount;
      var $353=$s;
      var $354=(($353+$352)|0);
      $s=$354;
      __label__ = 80; break;
    case 72: // $355
      __label__ = 73; break;
    case 73: // $356
      var $357=$s;
      var $358=HEAP8[($357)];
      var $359=(($358 << 24) >> 24)!=0;
      if ($359) { __label__ = 74; break; } else { var $365 = 0;__label__ = 75; break; }
    case 74: // $360
      var $361=HEAP32[(($schar)>>2)];
      var $362=_isspace($361);
      var $363=(($362)|0)!=0;
      var $365 = $363;__label__ = 75; break;
    case 75: // $364
      var $365;
      if ($365) { __label__ = 76; break; } else { __label__ = 79; break; }
    case 76: // $366
      var $367=$scharcount;
      var $368=$s;
      var $369=(($368+$367)|0);
      $s=$369;
      var $370=$s;
      var $371=$ends;
      var $372=$s;
      var $373=$371;
      var $374=$372;
      var $375=(($373-$374)|0);
      var $376=__Z15uchar_from_utf8PjPKcj($schar, $370, $375);
      $scharcount=$376;
      var $377=$scharcount;
      var $378=(($377)|0)==-1;
      if ($378) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $379
      __label__ = 79; break;
    case 78: // $380
      __label__ = 73; break;
    case 79: // $381
      __label__ = 80; break;
    case 80: // $382
      __label__ = 5; break;
    case 81: // $383
      var $384=$11;
      var $385=(($384)|0)!=0;
      if ($385) { __label__ = 82; break; } else { __label__ = 83; break; }
    case 82: // $386
      var $387=$maxwidth;
      var $388=$11;
      HEAPF32[(($388)>>2)]=$387;
      __label__ = 83; break;
    case 83: // $389
      var $390=$12;
      var $391=(($390)|0)!=0;
      if ($391) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $392
      var $393=$cury;
      var $394=$4;
      var $395=$393-$394;
      var $396=$12;
      HEAPF32[(($396)>>2)]=$395;
      __label__ = 85; break;
    case 85: // $397
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_["X"]=1;

function __Z13ui_popup_timeiPKcz($seconds, $text) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $arg=__stackBase__;
  $1=$seconds;
  $2=$text;
  var $3=$arg;
  HEAP32[(($3)>>2)]=arguments[__Z13ui_popup_timeiPKcz.length];
  var $4=$2;
  var $5=HEAP32[(($arg)>>2)];
  var $6=__ZN7astring7vprintfEPKcPc(__ZL15messagebox_text, $4, $5);
  HEAP32[((__ZL20messagebox_backcolor)>>2)]=-284159952;
  var $7=$arg;
  ;
  var $8=_osd_ticks();
  var $8$0=$8[0];
  var $8$1=$8[1];
  var $9=_osd_ticks_per_second();
  var $9$0=$9[0];
  var $9$1=$9[1];
  var $10=$1;
  var $11$0=$10;
  var $11$1=(($10|0) < 0 ? -1 : 0);
  var $12$0 = ((($9$0)>>>0)+((($9$1)|0)*4294967296))*((($11$0)>>>0)+((($11$1)|0)*4294967296))>>>0; var $12$1 = Math.min(Math.floor((((($9$0)>>>0)+((($9$1)|0)*4294967296))*((($11$0)>>>0)+((($11$1)|0)*4294967296)))/4294967296), 4294967295);
  var $13$0 = ((($8$0)>>>0)+((($8$1)|0)*4294967296))+((($12$0)>>>0)+((($12$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($8$0)>>>0)+((($8$1)|0)*4294967296))+((($12$0)>>>0)+((($12$1)|0)*4294967296)))/4294967296), 4294967295);
  var $st$24$0=((__ZL14popup_text_end)|0);
  HEAP32[(($st$24$0)>>2)]=$13$0;
  var $st$24$1=((__ZL14popup_text_end+4)|0);
  HEAP32[(($st$24$1)>>2)]=$13$1;
  STACKTOP = __stackBase__;
  return;
}


function __Z16ui_show_fps_tempd($seconds) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$seconds;
      var $2=HEAP32[((__ZL7showfps)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=_osd_ticks();
      var $5$0=$5[0];
      var $5$1=$5[1];
      var $6=$5$0 + $5$1*4294967296;
      var $7=$1;
      var $8=_osd_ticks_per_second();
      var $8$0=$8[0];
      var $8$1=$8[1];
      var $9=$8$0 + $8$1*4294967296;
      var $10=$7*$9;
      var $11=$6+$10;
      var $12$0 = $11>>>0; var $12$1 = Math.min(Math.floor(($11)/4294967296), 4294967295);
      var $st$12$0=((__ZL11showfps_end)|0);
      HEAP32[(($st$12$0)>>2)]=$12$0;
      var $st$12$1=((__ZL11showfps_end+4)|0);
      HEAP32[(($st$12$1)>>2)]=$12$1;
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20ui_set_show_profileri($show) {
  ;
  var __label__;

  var $1;
  $1=$show;
  var $2=$1;
  HEAP32[((__ZL13show_profiler)>>2)]=$2;
  var $3=$1;
  var $4=(($3)|0)!=0;
  __ZN20dummy_profiler_state6enableEb(_g_profiler, $4);
  ;
  return;
}


function __Z12ui_show_menuv() {
  ;
  var __label__;

  var $1=__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj(948, 0);
  ;
  return;
}


function __ZL22slider_get_screen_descR13screen_device($screen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $scrcount;
      $1=$screen;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t7machineEv($3);
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=HEAP32[((_SCREEN)>>2)];
      var $7=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($5, $6);
      $scrcount=$7;
      var $8=$scrcount;
      var $9=(($8)|0) > 1;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$1;
      var $12=$11;
      var $13=__ZNK8device_t3tagEv($12);
      var $14=_sprintf(((__ZZL22slider_get_screen_descR13screen_deviceE7descbuf)|0), ((STRING_TABLE.__str153946)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$13,tempInt));
      __label__ = 3; break;
    case 2: // $15
      var $16=_strcpy(((__ZZL22slider_get_screen_descR13screen_deviceE7descbuf)|0), ((STRING_TABLE.__str163947)|0));
      __label__ = 3; break;
    case 3: // $17
      ;
      return ((__ZZL22slider_get_screen_descR13screen_deviceE7descbuf)|0);
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8ui_pasteR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $text;
      $1=$machine;
      var $2=_osd_get_clipboard_text();
      $text=$2;
      var $3=$text;
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$1;
      var $7=$text;
      __Z16inputx_post_utf8R15running_machinePKc($6, $7);
      var $8=$text;
      _osd_free($8);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z23ui_image_handler_ingameR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $image=__stackBase__;
      var $gotone;
      $1=$machine;
      HEAP32[(($image)>>2)]=0;
      var $2=$1;
      var $3=__ZNK15running_machine5phaseEv($2);
      var $4=(($3)|0)==3;
      if ($4) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $5
      var $6=$1;
      var $7=__ZNK15running_machine10devicelistEv($6);
      var $8=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($7, $image);
      var $9=(($8)&1);
      $gotone=$9;
      __label__ = 2; break;
    case 2: // $10
      var $11=$gotone;
      var $12=(($11) & 1);
      if ($12) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      var $14=HEAP32[(($image)>>2)];
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+76)|0);
      var $18=HEAP32[(($17)>>2)];
      FUNCTION_TABLE[$18]($14);
      __label__ = 4; break;
    case 4: // $19
      var $20=HEAP32[(($image)>>2)];
      var $21=$20;
      var $22=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($21, $image);
      var $23=(($22)&1);
      $gotone=$23;
      __label__ = 2; break;
    case 5: // $24
      __label__ = 6; break;
    case 6: // $25
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13screen_device6xscaleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+392)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device6yscaleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+396)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device7xoffsetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+384)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK13screen_device7yoffsetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+388)|0);
  var $4=HEAPF32[(($3)>>2)];
  ;
  return $4;
}


function __ZL13slider_volumeR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$4;
      var $6=(($5)|0)!=305419896;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine5soundEv($8);
      var $10=$4;
      __ZN13sound_manager15set_attenuationEi($9, $10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$3;
      var $16=$1;
      var $17=__ZNK15running_machine5soundEv($16);
      var $18=__ZNK13sound_manager11attenuationEv($17);
      var $19=__ZN7astring6printfEPKcz($15, ((STRING_TABLE.__str393970)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,tempInt));
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      var $22=__ZNK15running_machine5soundEv($21);
      var $23=__ZNK13sound_manager11attenuationEv($22);
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15slider_mixervolR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $info=__stackBase__;
      var $curval;
      $2=$machine;
      $3=$arg;
      $4=$string;
      $5=$newval;
      var $6=$2;
      var $7=__ZNK15running_machine5soundEv($6);
      var $8=$3;
      var $9=$8;
      var $10=__ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input($7, $9, $info);
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      $1=0;
      __label__ = 10; break;
    case 2: // $12
      var $13=$5;
      var $14=(($13)|0)!=305419896;
      if ($14) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $15
      var $16=(($info+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($info+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK12sound_stream10input_gainEi($17, $19);
      var $21=$20*1000;
      var $22=$21+0.5;
      var $23=$22;
      var $24=_floor($23);
      var $25=(($24)|0);
      $curval=$25;
      var $26=$5;
      var $27=$curval;
      var $28=(($26)|0) > (($27)|0);
      if ($28) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $29
      var $30=$5;
      var $31=$curval;
      var $32=(($30-$31)|0);
      var $33=(($32)|0) <= 4;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$5;
      var $36=(($35+4)|0);
      $5=$36;
      __label__ = 6; break;
    case 6: // $37
      var $38=(($info+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($info+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$5;
      var $43=(($42)|0);
      var $44=$43*0.0010000000474974513;
      __ZN12sound_stream14set_input_gainEif($39, $41, $44);
      __label__ = 7; break;
    case 7: // $45
      var $46=$4;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$4;
      var $50=(($info+4)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($info+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=__ZNK12sound_stream10input_gainEi($51, $53);
      var $55=$54;
      var $56=__ZN7astring6printfEPKcz($49, ((STRING_TABLE.__str383969)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$55,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 9; break;
    case 9: // $57
      var $58=(($info+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($info+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__ZNK12sound_stream10input_gainEi($59, $61);
      var $63=$62*1000;
      var $64=$63+0.5;
      var $65=$64;
      var $66=_floor($65);
      var $67=(($66)|0);
      $1=$67;
      __label__ = 10; break;
    case 10: // $68
      var $69=$1;
      STACKTOP = __stackBase__;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15slider_mixervolR15running_machinePvP7astringi["X"]=1;

function __ZL15slider_adjusterR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $field;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $field=$6;
      __ZN26_input_field_user_settingsC1Ev($settings);
      var $7=$field;
      __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($7, $settings);
      var $8=$4;
      var $9=(($8)|0)!=305419896;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      var $12=(($settings)|0);
      HEAP32[(($12)>>2)]=$11;
      var $13=$field;
      __Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings($13, $settings);
      __label__ = 2; break;
    case 2: // $14
      var $15=$3;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$3;
      var $19=(($settings)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZN7astring6printfEPKcz($18, ((STRING_TABLE.__str373968)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,tempInt));
      __label__ = 4; break;
    case 4: // $22
      var $23=(($settings)|0);
      var $24=HEAP32[(($23)>>2)];
      STACKTOP = __stackBase__;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16slider_overclockR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpu;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $cpu=$6;
      var $7=$4;
      var $8=(($7)|0)!=305419896;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$cpu;
      var $11=$4;
      var $12=(($11)|0);
      var $13=$12*0.0010000000474974513;
      var $14=$13;
      __ZN8device_t15set_clock_scaleEd($10, $14);
      __label__ = 2; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$3;
      var $20=$cpu;
      var $21=__ZNK8device_t11clock_scaleEv($20);
      var $22=$21*100;
      var $23=$22+0.5;
      var $24=_floor($23);
      var $25=__ZN7astring6printfEPKcz($19, ((STRING_TABLE.__str353966)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$24,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $26
      var $27=$cpu;
      var $28=__ZNK8device_t11clock_scaleEv($27);
      var $29=$28*1000;
      var $30=$29+0.5;
      var $31=_floor($30);
      var $32=(($31)|0);
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14slider_refreshR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $defrefresh;
      var $refresh;
      var $width;
      var $height;
      var $visarea;
      var $5=__stackBase__;
      var $6=__stackBase__+12;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $7=$2;
      var $8=$7;
      $screen=$8;
      var $9=$screen;
      var $10=__ZNK13screen_device19refresh_attosecondsEv($9);
      var $10$0=$10[0];
      var $10$1=$10[1];
      var $11=$10$0 + $10$1*4294967296;
      var $12=1000000000000000000/$11;
      $defrefresh=$12;
      var $13=$4;
      var $14=(($13)|0)!=305419896;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$screen;
      var $17=__ZNK13screen_device5widthEv($16);
      $width=$17;
      var $18=$screen;
      var $19=__ZNK13screen_device6heightEv($18);
      $height=$19;
      var $20=$screen;
      var $21=__ZNK13screen_device12visible_areaEv($20);
      $visarea=$21;
      var $22=$screen;
      var $23=$width;
      var $24=$height;
      var $25=$visarea;
      var $26=$defrefresh;
      var $27=$4;
      var $28=(($27)|0);
      var $29=$28*0.001;
      var $30=$26+$29;
      var $31=1000000000000000000/$30;
      var $32$0 = $31>>>0; var $32$1 = Math.min(Math.floor(($31)/4294967296), 4294967295);
      __ZN13screen_device9configureEiiRK10_rectanglex($22, $23, $24, $25, $32$0, $32$1);
      __label__ = 2; break;
    case 2: // $33
      var $34=$3;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $36
      var $37=$3;
      var $38=$1;
      var $39=(($38+560)|0);
      var $40=HEAP32[(($39)>>2)];
      __ZNK13screen_device12frame_periodEv($5, $40);
      var $41=(($5+4)|0);
      var $st$6$0=(($41)|0);
      var $42$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$6$1)>>2)];
      var $43=$42$0 + $42$1*4294967296;
      var $44=1000000000000000000/$43;
      var $45=__ZN7astring6printfEPKcz($37, ((STRING_TABLE.__str343965)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$44,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $46
      var $47=$1;
      var $48=(($47+560)|0);
      var $49=HEAP32[(($48)>>2)];
      __ZNK13screen_device12frame_periodEv($6, $49);
      var $50=(($6+4)|0);
      var $st$5$0=(($50)|0);
      var $51$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($50+4)|0);
      var $51$1=HEAP32[(($st$5$1)>>2)];
      var $52=$51$0 + $51$1*4294967296;
      var $53=1000000000000000000/$52;
      $refresh=$53;
      var $54=$refresh;
      var $55=$defrefresh;
      var $56=$54-$55;
      var $57=$56*1000;
      var $58=$57+0.5;
      var $59=_floor($58);
      var $60=(($59)|0);
      STACKTOP = __stackBase__;
      return $60;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14slider_refreshR15running_machinePvP7astringi["X"]=1;

function __ZL17slider_brightnessR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+4)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+4)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+4)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15slider_contrastR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+8)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+8)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+8)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12slider_gammaR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+12)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+12)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+12)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13slider_xscaleR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+16)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+16)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+16)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14slider_xoffsetR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+24)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+24)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+24)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13slider_yscaleR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+20)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+20)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+20)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14slider_yoffsetR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $screen;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $screen=$6;
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $7=$screen;
      var $8=__ZNK13screen_device9containerEv($7);
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($8, $settings);
      var $9=$4;
      var $10=(($9)|0)!=305419896;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=$13*0.0010000000474974513;
      var $15=(($settings+28)|0);
      HEAPF32[(($15)>>2)]=$14;
      var $16=$screen;
      var $17=__ZNK13screen_device9containerEv($16);
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($17, $settings);
      __label__ = 2; break;
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($settings+28)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=__ZN7astring6printfEPKcz($22, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$25,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $27
      var $28=(($settings+28)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$29*1000;
      var $31=$30+0.5;
      var $32=$31;
      var $33=_floor($32);
      var $34=(($33)|0);
      STACKTOP = __stackBase__;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL25slider_get_laserdisc_descP8device_t($laserdisc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ldcount;
      $1=$laserdisc;
      var $2=$1;
      var $3=__ZNK8device_t7machineEv($2);
      var $4=__ZNK15running_machine10devicelistEv($3);
      var $5=HEAP32[((_LASERDISC)>>2)];
      var $6=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($4, $5);
      $ldcount=$6;
      var $7=$ldcount;
      var $8=(($7)|0) > 1;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=__ZNK8device_t3tagEv($10);
      var $12=_sprintf(((__ZZL25slider_get_laserdisc_descP8device_tE7descbuf)|0), ((STRING_TABLE.__str323963)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$11,tempInt));
      __label__ = 3; break;
    case 2: // $13
      var $14=_strcpy(((__ZZL25slider_get_laserdisc_descP8device_tE7descbuf)|0), ((STRING_TABLE.__str333964)|0));
      __label__ = 3; break;
    case 3: // $15
      ;
      return ((__ZZL25slider_get_laserdisc_descP8device_tE7descbuf)|0);
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z27ui_set_use_natural_keyboardR15running_machinei($machine, $use_natural_keyboard) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $error=__stackBase__;
      var $3;
      var $4;
      $1=$machine;
      $2=$use_natural_keyboard;
      var $5=$2;
      HEAP32[((__ZL23ui_use_natural_keyboard)>>2)]=$5;
      __ZN7astringC1Ev($error);
      var $6=$1;
      var $7=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $8
      var $9=$7;
      var $10=$2;
      var $11=(function() { try { __THREW__ = false; return __ZN12core_options9set_valueEPKciiR7astring($9, ((STRING_TABLE.__str143945)|0), $10, 150, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $12
      __label__ = 3; break;
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      __label__ = 5; break;
    case 5: // $15
      FUNCTION_TABLE[__ZN7astringD1Ev]($error);
      STACKTOP = __stackBase__;
      return;
    case 6: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $3=$18;
      var $19=$17.f1;
      $4=$19;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $20
      __label__ = 8; break;
    case 8: // $21
      var $22=$3;
      var $23=$3;
      var $24=$4;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_($machine, $title, $minval, $defval, $maxval, $incval, $update, $arg) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $size;
      var $state;
      $7=$machine;
      $8=$title;
      $9=$minval;
      $10=$defval;
      $11=$maxval;
      $12=$incval;
      $13=$update;
      $14=$arg;
      var $15=$8;
      var $16=_strlen($15);
      var $17=(($16+32)|0);
      $size=$17;
      var $18=$7;
      var $19=__ZN15running_machine7respoolEv($18);
      var $20=$size;
      var $21=(($20)|0) < 0;
      var $22=$21 ? -1 : $20;
      var $23=$1;
      var $24=$2;
      var $25=$3;
      var $26=$4;
      var $27=$result_i;
      var $28=$5;
      var $29=$6;
      HEAP32[(($1)>>2)]=$22;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str403971)|0);
      HEAP32[(($3)>>2)]=1611;
      HEAP32[(($4)>>2)]=_zeromem;
      var $30=HEAP32[(($1)>>2)];
      var $31=HEAP32[(($2)>>2)];
      var $32=HEAP32[(($3)>>2)];
      var $33=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($30, $31, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $34
      HEAP32[(($result_i)>>2)]=$33;
      var $35=HEAP32[(($result_i)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $37
      var $38=___cxa_allocate_exception(4);
      var $39=$38;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($39);
      (function() { try { __THREW__ = false; return ___cxa_throw($38, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      HEAP32[(($5)>>2)]=$42;
      var $43=$41.f1;
      HEAP32[(($6)>>2)]=$43;
      var $44=HEAP32[(($6)>>2)];
      var $45=(($44)|0) < 0;
      if ($45) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $46
      var $47=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($47);
      throw "Reached an unreachable!"
    case 5: // $48
      var $49=HEAP32[(($5)>>2)];
      var $50=HEAP32[(($5)>>2)];
      var $51=HEAP32[(($6)>>2)];
      var $52=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $50, tempValue);
      var $53=($52.f1 = $51, $52);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $54
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKciRK9zeromem_t_exit
      var $55=HEAP32[(($result_i)>>2)];
      var $56=HEAP32[(($1)>>2)];
      _memset($55, 0, $56, 1);
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$1;
      var $59=$2;
      var $60=$3;
      var $61=$4;
      var $62=$result_i;
      var $63=$5;
      var $64=$6;
      var $65=$size;
      var $66=__ZN13resource_pool9add_arrayIhEEPT_S2_i($19, $57, $65);
      var $67=$66;
      $state=$67;
      var $68=$9;
      var $69=$state;
      var $70=(($69+12)|0);
      HEAP32[(($70)>>2)]=$68;
      var $71=$10;
      var $72=$state;
      var $73=(($72+16)|0);
      HEAP32[(($73)>>2)]=$71;
      var $74=$11;
      var $75=$state;
      var $76=(($75+20)|0);
      HEAP32[(($76)>>2)]=$74;
      var $77=$12;
      var $78=$state;
      var $79=(($78+24)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$13;
      var $81=$state;
      var $82=(($81+4)|0);
      HEAP32[(($82)>>2)]=$80;
      var $83=$14;
      var $84=$state;
      var $85=(($84+8)|0);
      HEAP32[(($85)>>2)]=$83;
      var $86=$state;
      var $87=(($86+28)|0);
      var $88=(($87)|0);
      var $89=$8;
      var $90=_strcpy($88, $89);
      var $91=$state;
      STACKTOP = __stackBase__;
      return $91;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_["X"]=1;

function __ZNK13screen_device19refresh_attosecondsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+364)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZNK8device_t11clock_scaleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+260)|0);
  var $4=(tempDoubleI32[0]=HEAP32[(($3)>>2)],tempDoubleI32[1]=HEAP32[(($3+4)>>2)],tempDoubleF64[0]);
  ;
  return $4;
}


function __ZNK13sound_manager11attenuationEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK15running_machine9ui_activeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1324)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN15running_machine13set_ui_activeEb($this, $active) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($active)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  var $7=(($4+1324)|0);
  var $8=(($6)&1);
  HEAP8[($7)]=$8;
  ;
  return;
}


function __ZNK13video_manager12is_recordingEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+152)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { var $11 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=(($2+156)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      var $11 = $9;__label__ = 2; break;
    case 2: // $10
      var $11;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13video_manager9frameskipEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+108)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $12 = -1;__label__ = 3; break;
    case 2: // $7
      var $8=(($2+117)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $12 = $10;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13video_manager13set_throttledEb($this, $throttled) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($throttled)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  var $7=(($4+100)|0);
  var $8=(($6)&1);
  HEAP8[($7)]=$8;
  ;
  return;
}


function __ZNK13video_manager9throttledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+100)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN13video_manager15set_fastforwardEb($this, $ffwd) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($ffwd)&1);
  $2=$3;
  var $4=$1;
  var $5=$2;
  var $6=(($5) & 1);
  var $7=(($4+101)|0);
  var $8=(($6)&1);
  HEAP8[($7)]=$8;
  ;
  return;
}


function __ZL17slider_overxscaleR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $laserdisc;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $laserdisc=$6;
      var $7=$laserdisc;
      __Z20laserdisc_get_configP8device_tP17_laserdisc_config($7, $settings);
      var $8=$4;
      var $9=(($8)|0)!=305419896;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      var $12=(($11)|0);
      var $13=$12*0.0010000000474974513;
      var $14=(($settings+60)|0);
      HEAPF32[(($14)>>2)]=$13;
      var $15=$laserdisc;
      __Z20laserdisc_set_configP8device_tPK17_laserdisc_config($15, $settings);
      __label__ = 2; break;
    case 2: // $16
      var $17=$3;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($settings+60)|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=$22;
      var $24=__ZN7astring6printfEPKcz($20, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$23,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $25
      var $26=(($settings+60)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27*1000;
      var $29=$28+0.5;
      var $30=$29;
      var $31=_floor($30);
      var $32=(($31)|0);
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18slider_overxoffsetR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $laserdisc;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $laserdisc=$6;
      var $7=$laserdisc;
      __Z20laserdisc_get_configP8device_tP17_laserdisc_config($7, $settings);
      var $8=$4;
      var $9=(($8)|0)!=305419896;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      var $12=(($11)|0);
      var $13=$12*0.0010000000474974513;
      var $14=(($settings+52)|0);
      HEAPF32[(($14)>>2)]=$13;
      var $15=$laserdisc;
      __Z20laserdisc_set_configP8device_tPK17_laserdisc_config($15, $settings);
      __label__ = 2; break;
    case 2: // $16
      var $17=$3;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($settings+52)|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=$22;
      var $24=__ZN7astring6printfEPKcz($20, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$23,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $25
      var $26=(($settings+52)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27*1000;
      var $29=$28+0.5;
      var $30=$29;
      var $31=_floor($30);
      var $32=(($31)|0);
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17slider_overyscaleR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $laserdisc;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $laserdisc=$6;
      var $7=$laserdisc;
      __Z20laserdisc_get_configP8device_tP17_laserdisc_config($7, $settings);
      var $8=$4;
      var $9=(($8)|0)!=305419896;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      var $12=(($11)|0);
      var $13=$12*0.0010000000474974513;
      var $14=(($settings+64)|0);
      HEAPF32[(($14)>>2)]=$13;
      var $15=$laserdisc;
      __Z20laserdisc_set_configP8device_tPK17_laserdisc_config($15, $settings);
      __label__ = 2; break;
    case 2: // $16
      var $17=$3;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($settings+64)|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=$22;
      var $24=__ZN7astring6printfEPKcz($20, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$23,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $25
      var $26=(($settings+64)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27*1000;
      var $29=$28+0.5;
      var $30=$29;
      var $31=_floor($30);
      var $32=(($31)|0);
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18slider_overyoffsetR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $laserdisc;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$2;
      var $6=$5;
      $laserdisc=$6;
      var $7=$laserdisc;
      __Z20laserdisc_get_configP8device_tP17_laserdisc_config($7, $settings);
      var $8=$4;
      var $9=(($8)|0)!=305419896;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      var $12=(($11)|0);
      var $13=$12*0.0010000000474974513;
      var $14=(($settings+56)|0);
      HEAPF32[(($14)>>2)]=$13;
      var $15=$laserdisc;
      __Z20laserdisc_set_configP8device_tPK17_laserdisc_config($15, $settings);
      __label__ = 2; break;
    case 2: // $16
      var $17=$3;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($settings+56)|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=$22;
      var $24=__ZN7astring6printfEPKcz($20, ((STRING_TABLE.__str313962)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$23,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $25
      var $26=(($settings+56)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27*1000;
      var $29=$28+0.5;
      var $30=$29;
      var $31=_floor($30);
      var $32=(($31)|0);
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14slider_flickerR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$4;
      var $6=(($5)|0)!=305419896;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      var $9=(($8)|0);
      var $10=$9*0.10000000149011612;
      __Z18vector_set_flickerf($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$3;
      var $16=__Z18vector_get_flickerv();
      var $17=$16;
      var $18=__ZN7astring6printfEPKcz($15, ((STRING_TABLE.__str303961)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$17,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $19
      var $20=__Z18vector_get_flickerv();
      var $21=$20*10;
      var $22=$21+0.5;
      var $23=$22;
      var $24=_floor($23);
      var $25=(($24)|0);
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11slider_beamR15running_machinePvP7astringi($machine, $arg, $string, $newval) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      $2=$arg;
      $3=$string;
      $4=$newval;
      var $5=$4;
      var $6=(($5)|0)!=305419896;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      var $9=(($8)|0);
      var $10=$9*0.009999999776482582;
      __Z15vector_set_beamf($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$3;
      var $16=__Z15vector_get_beamv();
      var $17=$16;
      var $18=__ZN7astring6printfEPKcz($15, ((STRING_TABLE.__str303961)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$17,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      __label__ = 4; break;
    case 4: // $19
      var $20=__Z15vector_get_beamv();
      var $21=$20*100;
      var $22=$21+0.5;
      var $23=$22;
      var $24=_floor($23);
      var $25=(($24)|0);
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20dummy_profiler_state4textER15running_machineR7astring($this, $machine, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$machine;
  $3=$string;
  var $4=$1;
  var $5=$3;
  var $6=__ZN7astring3cpyEPKc($5, ((__str623993)|0));
  var $7=__ZNK7astringcvPKcEv($6);
  ;
  return $7;
}


function __ZL24process_natural_keyboardR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $event=__stackBase__;
      var $i;
      var $pressed;
      var $itemid;
      var $code=__stackBase__+24;
      var $key_down_ptr;
      var $key_down_mask;
      var $2=__stackBase__+28;
      var $3=__stackBase__+32;
      $1=$machine;
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($code, 0, 0, 0, 0, 0);
      __label__ = 1; break;
    case 1: // $4
      var $5=$1;
      var $6=__Z18ui_input_pop_eventR15running_machineP9_ui_event($5, $event);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $8
      var $9=(($event)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==6;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$1;
      var $14=(($event+20)|0);
      var $15=HEAP32[(($14)>>2)];
      __Z12inputx_postcR15running_machinej($13, $15);
      __label__ = 4; break;
    case 4: // $16
      __label__ = 1; break;
    case 5: // $17
      $i=0;
      __label__ = 6; break;
    case 6: // $18
      var $19=$i;
      var $20=(($19)>>>0) < 39;
      if ($20) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $21
      var $22=$i;
      var $23=((__ZL13non_char_keys+($22<<2))|0);
      var $24=HEAP32[(($23)>>2)];
      $itemid=$24;
      var $25=$1;
      var $26=__ZNK15running_machine5inputEv($25);
      var $27=$itemid;
      __ZNK13input_manager16code_from_itemidE13input_item_id($2, $26, $27);
      var $28=$code;
      var $29=$2;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($28)>>2)]=HEAP32[(($29)>>2)];
      var $30=$1;
      var $31=__ZNK15running_machine5inputEv($30);
      __ZN10input_codeC1ERKS_($3, $code);
      var $32=__ZN13input_manager12code_pressedE10input_code($31, $3);
      var $33=(($32)&1);
      $pressed=$33;
      var $34=$i;
      var $35=(((($34)|0)/8)|0);
      var $36=((__ZL18non_char_keys_down+$35)|0);
      $key_down_ptr=$36;
      var $37=$i;
      var $38=(($37)|0)%8;
      var $39=1 << $38;
      var $40=(($39) & 255);
      $key_down_mask=$40;
      var $41=$pressed;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $43
      var $44=$key_down_ptr;
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$key_down_mask;
      var $48=(($47)&255);
      var $49=$46 & $48;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $51
      var $52=$key_down_mask;
      var $53=(($52)&255);
      var $54=$key_down_ptr;
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 | $53;
      var $58=(($57) & 255);
      HEAP8[($54)]=$58;
      var $59=$1;
      var $60=__ZNK10input_code7item_idEv($code);
      var $61=(($60+1048578)|0);
      __Z12inputx_postcR15running_machinej($59, $61);
      __label__ = 14; break;
    case 10: // $62
      var $63=$pressed;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 13; break; } else { __label__ = 11; break; }
    case 11: // $65
      var $66=$key_down_ptr;
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      var $69=$key_down_mask;
      var $70=(($69)&255);
      var $71=$68 & $70;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $73
      var $74=$key_down_mask;
      var $75=(($74)&255);
      var $76=$75 ^ -1;
      var $77=$key_down_ptr;
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $80=$79 & $76;
      var $81=(($80) & 255);
      HEAP8[($77)]=$81;
      __label__ = 13; break;
    case 13: // $82
      __label__ = 14; break;
    case 14: // $83
      __label__ = 15; break;
    case 15: // $84
      var $85=$i;
      var $86=(($85+1)|0);
      $i=$86;
      __label__ = 6; break;
    case 16: // $87
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24process_natural_keyboardR15running_machine["X"]=1;

function __ZNK11emu_options12confirm_quitEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str613992)|0));
  ;
  return $4;
}


function __ZL17handler_load_saveR15running_machineP16render_containerj($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $filename=__stackBase__;
      var $code=__stackBase__+20;
      var $file;
      var $id=__stackBase__+24;
      var $5=__stackBase__+28;
      var $id1=__stackBase__+32;
      var $6=__stackBase__+36;
      var $id2=__stackBase__+40;
      var $7=__stackBase__+44;
      $2=$machine;
      $3=$container;
      $4=$state;
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($code, 0, 0, 0, 0, 0);
      $file=0;
      var $8=$4;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=0;
      __label__ = 38; break;
    case 2: // $11
      var $12=$4;
      var $13=(($12)|0)==2;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$3;
      __Z16ui_draw_text_boxP16render_containerPKciffj($15, ((STRING_TABLE.__str513982)|0), 0, 0.5, 0.5, -284159952);
      __label__ = 5; break;
    case 4: // $16
      var $17=$3;
      __Z16ui_draw_text_boxP16render_containerPKciffj($17, ((STRING_TABLE.__str523983)|0), 0, 0.5, 0.5, -284159952);
      __label__ = 5; break;
    case 5: // $18
      var $19=$2;
      var $20=__Z16ui_input_pressedR15running_machinei($19, 183);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $22
      var $23=$4;
      var $24=(($23)|0)==2;
      if ($24) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $25
      __Z10popmessagePKcz(((STRING_TABLE.__str533984)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 8: // $26
      __Z10popmessagePKcz(((STRING_TABLE.__str543985)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $27
      var $28=$2;
      __ZN15running_machine6resumeEv($28);
      $1=-1;
      __label__ = 38; break;
    case 10: // $29
      HEAP32[(($id)>>2)]=1;
      __label__ = 11; break;
    case 11: // $30
      var $31=HEAP32[(($id)>>2)];
      var $32=(($31)|0) <= 26;
      if ($32) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $33
      var $34=$2;
      var $35=__ZNK15running_machine5inputEv($34);
      var $36=HEAP32[(($id)>>2)];
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 1, 0, 1, 0, $36);
      var $37=__ZN13input_manager17code_pressed_onceE10input_code($35, $5);
      if ($37) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $38
      var $39=HEAP32[(($id)>>2)];
      var $40=(($39-1)|0);
      var $41=(($40+97)|0);
      var $42=(($41) & 255);
      $file=$42;
      __label__ = 14; break;
    case 14: // $43
      __label__ = 15; break;
    case 15: // $44
      __ZppR13input_item_idi($id, 0);
      __label__ = 11; break;
    case 16: // $45
      var $46=$file;
      var $47=(($46 << 24) >> 24);
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 17; break; } else { __label__ = 24; break; }
    case 17: // $49
      HEAP32[(($id1)>>2)]=27;
      __label__ = 18; break;
    case 18: // $50
      var $51=HEAP32[(($id1)>>2)];
      var $52=(($51)|0) <= 36;
      if ($52) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $53
      var $54=$2;
      var $55=__ZNK15running_machine5inputEv($54);
      var $56=HEAP32[(($id1)>>2)];
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, $56);
      var $57=__ZN13input_manager17code_pressed_onceE10input_code($55, $6);
      if ($57) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $58
      var $59=HEAP32[(($id1)>>2)];
      var $60=(($59-27)|0);
      var $61=(($60+48)|0);
      var $62=(($61) & 255);
      $file=$62;
      __label__ = 21; break;
    case 21: // $63
      __label__ = 22; break;
    case 22: // $64
      __ZppR13input_item_idi($id1, 0);
      __label__ = 18; break;
    case 23: // $65
      __label__ = 24; break;
    case 24: // $66
      var $67=$file;
      var $68=(($67 << 24) >> 24);
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 25; break; } else { __label__ = 32; break; }
    case 25: // $70
      HEAP32[(($id2)>>2)]=79;
      __label__ = 26; break;
    case 26: // $71
      var $72=HEAP32[(($id2)>>2)];
      var $73=(($72)|0) <= 88;
      if ($73) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $74
      var $75=$2;
      var $76=__ZNK15running_machine5inputEv($75);
      var $77=HEAP32[(($id2)>>2)];
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, $77);
      var $78=__ZN13input_manager17code_pressed_onceE10input_code($76, $7);
      if ($78) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $79
      var $80=HEAP32[(($id2)>>2)];
      var $81=(($80-79)|0);
      var $82=(($81+48)|0);
      var $83=(($82) & 255);
      $file=$83;
      __label__ = 29; break;
    case 29: // $84
      __label__ = 30; break;
    case 30: // $85
      __ZppR13input_item_idi($id2, 0);
      __label__ = 26; break;
    case 31: // $86
      __label__ = 32; break;
    case 32: // $87
      var $88=$file;
      var $89=(($88 << 24) >> 24);
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $91
      var $92=$4;
      $1=$92;
      __label__ = 38; break;
    case 34: // $93
      var $94=(($filename)|0);
      var $95=$file;
      var $96=(($95 << 24) >> 24);
      var $97=_sprintf($94, ((STRING_TABLE.__str553986)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$96,tempInt));
      var $98=$4;
      var $99=(($98)|0)==2;
      if ($99) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $100
      var $101=$file;
      var $102=(($101 << 24) >> 24);
      __Z10popmessagePKcz(((STRING_TABLE.__str563987)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$102,tempInt));
      var $103=$2;
      var $104=(($filename)|0);
      __ZN15running_machine13schedule_saveEPKc($103, $104);
      __label__ = 37; break;
    case 36: // $105
      var $106=$file;
      var $107=(($106 << 24) >> 24);
      __Z10popmessagePKcz(((STRING_TABLE.__str573988)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$107,tempInt));
      var $108=$2;
      var $109=(($filename)|0);
      __ZN15running_machine13schedule_loadEPKc($108, $109);
      __label__ = 37; break;
    case 37: // $110
      var $111=$2;
      __ZN15running_machine6resumeEv($111);
      $1=-1;
      __label__ = 38; break;
    case 38: // $112
      var $113=$1;
      STACKTOP = __stackBase__;
      return $113;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17handler_load_saveR15running_machineP16render_containerj["X"]=1;

function __GLOBAL__I_a4036() {
  ;
  var __label__;

  ___cxx_global_var_init4019();
  ;
  return;
}


function __Z13watchdog_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$machine;
  var $3=$1;
  var $4=__ZN15running_machine9schedulerEv($3);
  var $5=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($4, 994, ((STRING_TABLE.__str4037)|0), 0);
  HEAP32[((__ZL14watchdog_timer)>>2)]=$5;
  var $6=$1;
  var $7=$1;
  __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 996, ((STRING_TABLE.__str14038)|0), $7);
  __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($6, 1, $2);
  var $8=$1;
  var $9=__ZN15running_machine4saveEv($8);
  __ZN12save_manager9save_itemIhEEvRT_PKci($9, __ZL16watchdog_enabled, ((STRING_TABLE.__str24039)|0), 0);
  var $10=$1;
  var $11=__ZN15running_machine4saveEv($10);
  __ZN12save_manager9save_itemIiEEvRT_PKci($11, __ZL16watchdog_counter, ((STRING_TABLE.__str34040)|0), 0);
  STACKTOP = __stackBase__;
  return;
}


function __ZL17watchdog_callbackR15running_machinePvi($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  __Z8logerrorPKcz(((STRING_TABLE.__str64043)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
  var $4=$1;
  __ZN15running_machine19schedule_soft_resetEv($4);
  STACKTOP = __stackBase__;
  return;
}


function __ZL23watchdog_internal_resetR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine6configEv($2);
      var $4=(($3+16)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { var $13 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine6configEv($8);
      var $10=(($9+20)|0);
      var $11=__ZneRK8attotimeS1_($10, __ZN8attotime4zeroE);
      var $13 = $11;__label__ = 2; break;
    case 2: // $12
      var $13;
      var $14=(($13)&1);
      HEAP8[(__ZL16watchdog_enabled)]=$14;
      var $15=$1;
      __Z14watchdog_resetR15running_machine($15);
      HEAP8[(__ZL16watchdog_enabled)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12save_manager9save_itemIhEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_($5, ((STRING_TABLE.__str54042)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZL20handler_confirm_quitR15running_machineP16render_containerj($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $quit_message=__stackBase__;
      var $5;
      var $6;
      var $7;
      $2=$machine;
      $3=$container;
      $4=$state;
      __ZN7astringC1EPKc($quit_message, ((STRING_TABLE.__str583989)|0));
      var $8=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($quit_message, ((STRING_TABLE.__str593990)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 9; break; };
    case 1: // $9
      var $10=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($quit_message, ((STRING_TABLE.__str603991)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 9; break; };
    case 2: // $11
      var $12=$3;
      var $13=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($quit_message) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 9; break; };
    case 3: // $14
      (function() { try { __THREW__ = false; return __Z16ui_draw_text_boxP16render_containerPKciffj($12, $13, 1, 0.5, 0.5, -262139888) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $15
      var $16=$2;
      (function() { try { __THREW__ = false; return __ZN15running_machine5pauseEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $17
      var $18=$2;
      var $19=(function() { try { __THREW__ = false; return __Z16ui_input_pressedR15running_machinei($18, 182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $20
      var $21=(($19)|0)!=0;
      if ($21) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $22
      var $23=$2;
      (function() { try { __THREW__ = false; return __ZN15running_machine13schedule_exitEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $24
      __label__ = 15; break;
    case 9: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $5=$27;
      var $28=$26.f1;
      $6=$28;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($quit_message) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 10: // $29
      var $30=$2;
      var $31=(function() { try { __THREW__ = false; return __Z16ui_input_pressedR15running_machinei($30, 183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $32
      var $33=(($31)|0)!=0;
      if ($33) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $34
      var $35=$2;
      (function() { try { __THREW__ = false; return __ZN15running_machine6resumeEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 9; break; }
    case 13: // $36
      $4=-1;
      __label__ = 14; break;
    case 14: // $37
      __label__ = 15; break;
    case 15: // $38
      var $39=$4;
      $1=$39;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($quit_message);
      var $40=$1;
      STACKTOP = __stackBase__;
      return $40;
    case 16: // $41
      __label__ = 17; break;
    case 17: // $42
      var $43=$5;
      var $44=$5;
      var $45=$6;
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20handler_confirm_quitR15running_machineP16render_containerj["X"]=1;

function __Z14watchdog_resetR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 96; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $5=__stackBase__+48;
      var $6=__stackBase__+60;
      var $7=__stackBase__+72;
      var $8=__stackBase__+84;
      $1=$machine;
      var $9=HEAP8[(__ZL16watchdog_enabled)];
      var $10=(($9 << 24) >> 24)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      var $12=HEAP32[((__ZL14watchdog_timer)>>2)];
      var $13=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($13+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($13+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $14=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($14)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($14+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($14+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($12, $2, 0, $3);
      __label__ = 11; break;
    case 2: // $15
      var $16=$1;
      var $17=__ZNK15running_machine6configEv($16);
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $21
      var $22=$1;
      var $23=__ZNK15running_machine6configEv($22);
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      HEAP32[((__ZL16watchdog_counter)>>2)]=$25;
      var $26=$1;
      var $27=(($26+560)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$1;
      var $32=(($31+560)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      __ZN8delegateIFvR13screen_devicebEEC1I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_($4, 1000, ((STRING_TABLE.__str44041)|0), $34);
      __ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE($33, $4);
      __label__ = 5; break;
    case 5: // $35
      __label__ = 10; break;
    case 6: // $36
      var $37=$1;
      var $38=__ZNK15running_machine6configEv($37);
      var $39=(($38+20)|0);
      var $40=__ZneRK8attotimeS1_($39, __ZN8attotime4zeroE);
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      var $42=HEAP32[((__ZL14watchdog_timer)>>2)];
      var $43=$1;
      var $44=__ZNK15running_machine6configEv($43);
      var $45=(($44+20)|0);
      var $46=$5;
      var $47=$45;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($46)>>2)]=HEAP32[(($47)>>2)];HEAP32[(($46+4)>>2)]=HEAP32[(($47+4)>>2)];HEAP32[(($46+8)>>2)]=HEAP32[(($47+8)>>2)];
      var $48=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($48)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($48+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($48+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($42, $5, 0, $6);
      __label__ = 9; break;
    case 8: // $49
      var $50=HEAP32[((__ZL14watchdog_timer)>>2)];
      __ZN8attotime12from_secondsEi($7, 3);
      var $51=$8;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($51)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($51+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($51+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($50, $7, 0, $8);
      __label__ = 9; break;
    case 9: // $52
      __label__ = 10; break;
    case 10: // $53
      __label__ = 11; break;
    case 11: // $54
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14watchdog_resetR15running_machine["X"]=1;

function __ZL9on_vblankR15running_machineR13screen_deviceb4048($machine, $screen, $vblank_state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$machine;
      $2=$screen;
      var $4=(($vblank_state)&1);
      $3=$4;
      var $5=$3;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $7
      var $8=HEAP8[(__ZL16watchdog_enabled)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$2;
      var $12=$11;
      var $13=__ZNK8device_t7machineEv($12);
      var $14=__ZNK15running_machine6configEv($13);
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $18
      var $19=HEAP32[((__ZL16watchdog_counter)>>2)];
      var $20=(($19-1)|0);
      HEAP32[((__ZL16watchdog_counter)>>2)]=$20;
      var $21=HEAP32[((__ZL16watchdog_counter)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$2;
      var $25=$24;
      var $26=__ZNK8device_t7machineEv($25);
      __ZL17watchdog_callbackR15running_machinePvi($26, 0, 0);
      __label__ = 5; break;
    case 5: // $27
      __label__ = 6; break;
    case 6: // $28
      __label__ = 7; break;
    case 7: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14crosshair_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 96; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $port;
      var $field;
      var $player;
      var $3=__stackBase__+24;
      var $4=__stackBase__+48;
      var $5=__stackBase__+72;
      $1=$machine;
      var $6=$1;
      var $7=$1;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 1002, ((STRING_TABLE.__str4049)|0), $7);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($6, 4, $2);
      _memset(((__ZL6global)|0), 0, 376, 1);
      HEAP16[((((__ZL6global+254)|0))>>1)]=15;
      var $8=$1;
      var $9=(($8+20)|0);
      var $10=__ZNK11tagged_listI17input_port_configE5firstEv($9);
      $port=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$port;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $14
      var $15=$port;
      var $16=__ZN17input_port_config9fieldlistEv($15);
      var $17=__ZNK11simple_listI18input_field_configE5firstEv($16);
      $field=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$field;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $21
      var $22=$field;
      var $23=(($22+320)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $27
      var $28=$field;
      var $29=(($28+28)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      $player=$31;
      __label__ = 6; break;
    case 6: // $32
      __label__ = 7; break;
    case 7: // $33
      HEAP8[(((__ZL6global)|0))]=1;
      var $34=$player;
      var $35=((((__ZL6global+1)|0)+$34)|0);
      HEAP8[($35)]=1;
      var $36=$player;
      var $37=((((__ZL6global+9)|0)+$36)|0);
      HEAP8[($37)]=2;
      var $38=$player;
      var $39=((((__ZL6global+17)|0)+$38)|0);
      HEAP8[($39)]=1;
      var $40=$1;
      var $41=(($40+560)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$42;
      var $44=$player;
      var $45=((((__ZL6global+92)|0)+($44<<2))|0);
      HEAP32[(($45)>>2)]=$43;
      var $46=$1;
      var $47=$player;
      __ZL13create_bitmapR15running_machinei($46, $47);
      __label__ = 8; break;
    case 8: // $48
      __label__ = 9; break;
    case 9: // $49
      var $50=$field;
      var $51=__ZNK18input_field_config4nextEv($50);
      $field=$51;
      __label__ = 3; break;
    case 10: // $52
      __label__ = 11; break;
    case 11: // $53
      var $54=$port;
      var $55=__ZNK17input_port_config4nextEv($54);
      $port=$55;
      __label__ = 1; break;
    case 12: // $56
      var $57=HEAP8[(((__ZL6global)|0))];
      var $58=(($57 << 24) >> 24)!=0;
      if ($58) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $59
      var $60=$1;
      var $61=$1;
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($3, 1004, ((STRING_TABLE.__str24051)|0), $61);
      var $62=$1;
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($4, 1006, ((STRING_TABLE.__str34052)|0), $62);
      __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($60, ((STRING_TABLE.__str14050)|0), $3, $4);
      __label__ = 14; break;
    case 14: // $63
      var $64=$1;
      var $65=(($64+560)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $68
      var $69=$1;
      var $70=(($69+560)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$1;
      __ZN8delegateIFvR13screen_devicebEEC1I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_($5, 1008, ((STRING_TABLE.__str44053)|0), $72);
      __ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE($71, $5);
      __label__ = 16; break;
    case 16: // $73
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14crosshair_initR15running_machine["X"]=1;

function __ZL14crosshair_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $player;
      $1=$machine;
      $player=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$player;
      var $4=(($3)|0) < 8;
      if ($4) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $5
      var $6=$1;
      var $7=__ZNK15running_machine6renderEv($6);
      var $8=$player;
      var $9=((((__ZL6global+60)|0)+($8<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($7, $10);
      var $11=$player;
      var $12=((((__ZL6global+60)|0)+($11<<2))|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$player;
      var $14=((((__ZL6global+28)|0)+($13<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$15;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $16);
      var $17=$player;
      var $18=((((__ZL6global+28)|0)+($17<<2))|0);
      HEAP32[(($18)>>2)]=0;
      __label__ = 3; break;
    case 3: // $19
      var $20=$player;
      var $21=(($20+1)|0);
      $player=$21;
      __label__ = 1; break;
    case 4: // $22
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14crosshair_loadR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $crosshairnode;
      var $auto_time;
      var $player;
      var $mode;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$2;
      var $5=(($4)|0)!=3;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 20; break;
    case 2: // $7
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      __label__ = 20; break;
    case 4: // $11
      var $12=$3;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z15xml_get_siblingP14_xml_data_nodePKc($14, ((STRING_TABLE.__str54054)|0));
      $crosshairnode=$15;
      __label__ = 5; break;
    case 5: // $16
      var $17=$crosshairnode;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $19
      var $20=$crosshairnode;
      var $21=__Z21xml_get_attribute_intP14_xml_data_nodePKci($20, ((STRING_TABLE.__str64055)|0), -1);
      $player=$21;
      var $22=$player;
      var $23=(($22)|0) >= 0;
      if ($23) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $24
      var $25=$player;
      var $26=(($25)|0) < 8;
      if ($26) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $27
      var $28=$player;
      var $29=((((__ZL6global+1)|0)+$28)|0);
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24)!=0;
      if ($31) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $32
      var $33=$crosshairnode;
      var $34=__Z21xml_get_attribute_intP14_xml_data_nodePKci($33, ((STRING_TABLE.__str74056)|0), 2);
      $mode=$34;
      var $35=$mode;
      var $36=(($35)|0) >= 0;
      if ($36) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $37
      var $38=$mode;
      var $39=(($38)|0) <= 2;
      if ($39) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $40
      var $41=$mode;
      var $42=(($41) & 255);
      var $43=$player;
      var $44=((((__ZL6global+9)|0)+$43)|0);
      HEAP8[($44)]=$42;
      var $45=$mode;
      var $46=(($45)|0)==1;
      var $47=$46 ? 1 : 0;
      var $48=(($47) & 255);
      var $49=$player;
      var $50=((((__ZL6global+17)|0)+$49)|0);
      HEAP8[($50)]=$48;
      __label__ = 12; break;
    case 12: // $51
      var $52=$player;
      var $53=((((__ZL6global+272)|0)+$52*13)|0);
      var $54=(($53)|0);
      var $55=$crosshairnode;
      var $56=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($55, ((STRING_TABLE.__str84057)|0), ((__str114060)|0));
      var $57=_strncpy($54, $56, 12);
      var $58=$1;
      var $59=$player;
      __ZL13create_bitmapR15running_machinei($58, $59);
      __label__ = 13; break;
    case 13: // $60
      __label__ = 14; break;
    case 14: // $61
      var $62=$crosshairnode;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=__Z15xml_get_siblingP14_xml_data_nodePKc($64, ((STRING_TABLE.__str54054)|0));
      $crosshairnode=$65;
      __label__ = 5; break;
    case 15: // $66
      var $67=$3;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=__Z15xml_get_siblingP14_xml_data_nodePKc($69, ((STRING_TABLE.__str94058)|0));
      $crosshairnode=$70;
      var $71=$crosshairnode;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $73
      var $74=$crosshairnode;
      var $75=__Z21xml_get_attribute_intP14_xml_data_nodePKci($74, ((STRING_TABLE.__str104059)|0), 15);
      $auto_time=$75;
      var $76=$auto_time;
      var $77=(($76)|0) >= 0;
      if ($77) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $78
      var $79=$auto_time;
      var $80=(($79)|0) <= 50;
      if ($80) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $81
      var $82=$auto_time;
      var $83=(($82) & 255);
      var $84=(($83)&255);
      HEAP16[((((__ZL6global+254)|0))>>1)]=$84;
      __label__ = 19; break;
    case 19: // $85
      __label__ = 20; break;
    case 20: // $86
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14crosshair_loadR15running_machineiP14_xml_data_node["X"]=1;

function __ZL13create_bitmapR15running_machinei($machine, $player) {
  var __stackBase__  = STACKTOP; STACKTOP += 316; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $x;
      var $y;
      var $filename=__stackBase__+36;
      var $color;
      var $crossfile=__stackBase__+56;
      var $11;
      var $12;
      var $dest0;
      var $dest1;
      $9=$machine;
      $10=$player;
      var $13=$10;
      var $14=((__ZL16crosshair_colors+($13<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $color=$15;
      var $16=$10;
      var $17=((((__ZL6global+28)|0)+($16<<2))|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $19);
      var $20=$9;
      var $21=__ZNK15running_machine6renderEv($20);
      var $22=$10;
      var $23=((((__ZL6global+60)|0)+($22<<2))|0);
      var $24=HEAP32[(($23)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($21, $24);
      var $25=$9;
      var $26=__ZNK15running_machine7optionsEv($25);
      var $27=__ZNK11emu_options14crosshair_pathEv($26);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($crossfile, $27, 1);
      var $28=$10;
      var $29=((((__ZL6global+272)|0)+$28*13)|0);
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24);
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $34
      var $35=(($filename)|0);
      var $36=$10;
      var $37=((((__ZL6global+272)|0)+$36*13)|0);
      var $38=(($37)|0);
      var $39=(function() { try { __THREW__ = false; return _sprintf($35, ((STRING_TABLE.__str124061)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$38,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $40
      var $41=(($filename)|0);
      var $42=(function() { try { __THREW__ = false; return __Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($crossfile, 0, $41, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $43
      var $44=$10;
      var $45=((((__ZL6global+28)|0)+($44<<2))|0);
      HEAP32[(($45)>>2)]=$42;
      __label__ = 13; break;
    case 4: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $47;__label__ = 5; break;
    case 5: // $_body
      var $eh_lpad_body;
      var $48=$eh_lpad_body.f0;
      $11=$48;
      var $49=$eh_lpad_body.f1;
      $12=$49;
      __label__ = 46; break;
    case 6: // $50
      var $51=(($filename)|0);
      var $52=$10;
      var $53=(($52+1)|0);
      var $54=(function() { try { __THREW__ = false; return _sprintf($51, ((STRING_TABLE.__str134062)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $55
      var $56=$9;
      var $57=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $58
      var $59=(($57+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($filename)|0);
      var $62=(function() { try { __THREW__ = false; return __Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($crossfile, $60, $61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; };
    case 9: // $63
      var $64=$10;
      var $65=((((__ZL6global+28)|0)+($64<<2))|0);
      HEAP32[(($65)>>2)]=$62;
      var $66=$10;
      var $67=((((__ZL6global+28)|0)+($66<<2))|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=(($filename)|0);
      var $72=(function() { try { __THREW__ = false; return __Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($crossfile, 0, $71, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $73
      var $74=$10;
      var $75=((((__ZL6global+28)|0)+($74<<2))|0);
      HEAP32[(($75)>>2)]=$72;
      __label__ = 12; break;
    case 12: // $76
      __label__ = 13; break;
    case 13: // $77
      var $78=$10;
      var $79=((((__ZL6global+28)|0)+($78<<2))|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 14; break; } else { __label__ = 42; break; }
    case 14: // $82
      var $83=$4;
      var $84=$5;
      var $85=$6;
      var $86=$result_i;
      var $87=$7;
      var $88=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str144063)|0);
      HEAP32[(($6)>>2)]=183;
      var $89=HEAP32[(($4)>>2)];
      var $90=HEAP32[(($5)>>2)];
      var $91=HEAP32[(($6)>>2)];
      var $92=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($89, $90, $91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $93
      HEAP32[(($result_i)>>2)]=$92;
      var $94=HEAP32[(($result_i)>>2)];
      var $95=(($94)|0)==0;
      if ($95) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $96
      var $97=___cxa_allocate_exception(4);
      var $98=$97;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($98);
      (function() { try { __THREW__ = false; return ___cxa_throw($97, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 17; break; }
    case 17: // $99
      var $100=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $101=$100.f0;
      HEAP32[(($7)>>2)]=$101;
      var $102=$100.f1;
      HEAP32[(($8)>>2)]=$102;
      var $103=HEAP32[(($8)>>2)];
      var $104=(($103)|0) < 0;
      if ($104) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $105
      var $106=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 4; break; }
    case 19: // $_noexc
      throw "Reached an unreachable!"
    case 20: // $107
      var $108=HEAP32[(($7)>>2)];
      var $109=HEAP32[(($7)>>2)];
      var $110=HEAP32[(($8)>>2)];
      var $111=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $109, tempValue);
      var $112=($111.f1 = $110, $111);
      var $eh_lpad_body = $112;__label__ = 5; break;
    case 21: // $113
      throw "Reached an unreachable!"
    case 22: // $_ZnwjPKci_exit
      var $114=HEAPU32[(($result_i)>>2)];
      var $115=$4;
      var $116=$5;
      var $117=$6;
      var $118=$result_i;
      var $119=$7;
      var $120=$8;
      __label__ = 23; break;
    case 23: // $121
      var $122=$114;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($122, 100, 100, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 32; break; }
    case 24: // $123
      var $124=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 4; break; };
    case 25: // $125
      var $126=$10;
      var $127=((((__ZL6global+28)|0)+($126<<2))|0);
      HEAP32[(($127)>>2)]=$124;
      var $128=$10;
      var $129=((((__ZL6global+28)|0)+($128<<2))|0);
      var $130=HEAP32[(($129)>>2)];
      (function() { try { __THREW__ = false; return __Z11bitmap_fillP8bitmap_tPK10_rectanglej($130, 0, 16777215) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 4; break; }
    case 26: // $131
      $y=0;
      __label__ = 27; break;
    case 27: // $132
      var $133=$y;
      var $134=(($133)|0) < 50;
      if ($134) { __label__ = 28; break; } else { __label__ = 41; break; }
    case 28: // $135
      var $136=$10;
      var $137=((((__ZL6global+28)|0)+($136<<2))|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$138;
      var $140=(($139+4)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$141;
      var $143=$y;
      var $144=$10;
      var $145=((((__ZL6global+28)|0)+($144<<2))|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$146;
      var $148=(($147+8)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($143*$149)|0);
      var $151=(($142+($150<<2))|0);
      var $152=(($151)|0);
      $dest0=$152;
      var $153=$10;
      var $154=((((__ZL6global+28)|0)+($153<<2))|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$155;
      var $157=(($156+4)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$158;
      var $160=$y;
      var $161=((99-$160)|0);
      var $162=$10;
      var $163=((((__ZL6global+28)|0)+($162<<2))|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164;
      var $166=(($165+8)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($161*$167)|0);
      var $169=(($159+($168<<2))|0);
      var $170=(($169)|0);
      $dest1=$170;
      $x=0;
      __label__ = 29; break;
    case 29: // $171
      var $172=$x;
      var $173=(($172)|0) < 100;
      if ($173) { __label__ = 30; break; } else { __label__ = 39; break; }
    case 30: // $174
      var $175=$y;
      var $176=(($175*13)|0);
      var $177=$x;
      var $178=(((($177)|0)/8)|0);
      var $179=(($176+$178)|0);
      var $180=((STRING_TABLE.__ZL17crosshair_raw_top+$179)|0);
      var $181=HEAPU8[($180)];
      var $182=(($181)&255);
      var $183=$x;
      var $184=(($183)|0)%8;
      var $185=$182 << $184;
      var $186=$185 & 128;
      var $187=(($186)|0)!=0;
      if ($187) { __label__ = 31; break; } else { __label__ = 37; break; }
    case 31: // $188
      var $189=$color;
      var $190=-16777216 | $189;
      var $191=$x;
      var $192=$dest1;
      var $193=(($192+($191<<2))|0);
      HEAP32[(($193)>>2)]=$190;
      var $194=$x;
      var $195=$dest0;
      var $196=(($195+($194<<2))|0);
      HEAP32[(($196)>>2)]=$190;
      __label__ = 37; break;
    case 32: // $197
      var $198=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $199=$198.f0;
      $11=$199;
      var $200=$198.f1;
      $12=$200;
      var $201=$1;
      var $202=$2;
      var $203=$3;
      HEAP32[(($1)>>2)]=$114;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str144063)|0);
      HEAP32[(($3)>>2)]=183;
      var $204=HEAP32[(($1)>>2)];
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $206
      var $207=HEAP32[(($1)>>2)];
      var $208=HEAP32[(($2)>>2)];
      var $209=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($207, $208, $209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 49; break; }
    case 34: // $_noexc1
      __label__ = 35; break;
    case 35: // $_ZdlPvPKci_exit
      var $210=$1;
      var $211=$2;
      var $212=$3;
      __label__ = 36; break;
    case 36: // $213
      __label__ = 46; break;
    case 37: // $214
      __label__ = 38; break;
    case 38: // $215
      var $216=$x;
      var $217=(($216+1)|0);
      $x=$217;
      __label__ = 29; break;
    case 39: // $218
      __label__ = 40; break;
    case 40: // $219
      var $220=$y;
      var $221=(($220+1)|0);
      $y=$221;
      __label__ = 27; break;
    case 41: // $222
      __label__ = 42; break;
    case 42: // $223
      var $224=$9;
      var $225=(function() { try { __THREW__ = false; return __ZNK15running_machine6renderEv($224) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 4; break; };
    case 43: // $226
      var $227=(function() { try { __THREW__ = false; return __ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($225, 998, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 4; break; };
    case 44: // $228
      var $229=$10;
      var $230=((((__ZL6global+60)|0)+($229<<2))|0);
      HEAP32[(($230)>>2)]=$227;
      var $231=$10;
      var $232=((((__ZL6global+60)|0)+($231<<2))|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$10;
      var $235=((((__ZL6global+28)|0)+($234<<2))|0);
      var $236=HEAP32[(($235)>>2)];
      (function() { try { __THREW__ = false; return __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($233, $236, 0, 5, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 4; break; }
    case 45: // $237
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($crossfile);
      STACKTOP = __stackBase__;
      return;
    case 46: // $238
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($crossfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 47: // $239
      __label__ = 48; break;
    case 48: // $240
      var $241=$11;
      var $242=$11;
      var $243=$12;
      var $244=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $242, tempValue);
      var $245=($244.f1 = $243, $244);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $246
      var $247=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13create_bitmapR15running_machinei["X"]=1;

function __Z19crosshair_get_usageR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=HEAPU8[(((__ZL6global)|0))];
  var $3=(($2)&255);
  ;
  return $3;
}


function __Z20multicart_error_text21_multicart_open_error($error) {
  ;
  var __label__;

  var $1;
  $1=$error;
  var $2=$1;
  var $3=((STRING_TABLE.__ZL10error_text+$2*30)|0);
  var $4=(($3)|0);
  ;
  return $4;
}


function __ZL14crosshair_saveR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $crosshairnode;
      var $player;
      var $changed;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$2;
      var $5=(($4)|0)!=3;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 20; break;
    case 2: // $7
      $player=0;
      __label__ = 3; break;
    case 3: // $8
      var $9=$player;
      var $10=(($9)|0) < 8;
      if ($10) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $11
      var $12=$player;
      var $13=((((__ZL6global+1)|0)+$12)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24)!=0;
      if ($15) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $16
      var $17=$3;
      var $18=__Z13xml_add_childP14_xml_data_nodePKcS2_($17, ((STRING_TABLE.__str54054)|0), 0);
      $crosshairnode=$18;
      var $19=$crosshairnode;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $21
      $changed=0;
      var $22=$crosshairnode;
      var $23=$player;
      var $24=__Z21xml_set_attribute_intP14_xml_data_nodePKci($22, ((STRING_TABLE.__str64055)|0), $23);
      var $25=$player;
      var $26=((((__ZL6global+17)|0)+$25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)!=2;
      if ($29) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $30
      var $31=$crosshairnode;
      var $32=$player;
      var $33=((((__ZL6global+9)|0)+$32)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=__Z21xml_set_attribute_intP14_xml_data_nodePKci($31, ((STRING_TABLE.__str74056)|0), $35);
      $changed=1;
      __label__ = 8; break;
    case 8: // $37
      var $38=$player;
      var $39=((((__ZL6global+272)|0)+$38*13)|0);
      var $40=(($39)|0);
      var $41=_strlen($40);
      var $42=(($41)>>>0) > 0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$crosshairnode;
      var $45=$player;
      var $46=((((__ZL6global+272)|0)+$45*13)|0);
      var $47=(($46)|0);
      var $48=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($44, ((STRING_TABLE.__str84057)|0), $47);
      $changed=1;
      __label__ = 10; break;
    case 10: // $49
      var $50=$changed;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $52
      var $53=$crosshairnode;
      __Z15xml_delete_nodeP14_xml_data_node($53);
      __label__ = 12; break;
    case 12: // $54
      __label__ = 13; break;
    case 13: // $55
      __label__ = 14; break;
    case 14: // $56
      __label__ = 15; break;
    case 15: // $57
      var $58=$player;
      var $59=(($58+1)|0);
      $player=$59;
      __label__ = 3; break;
    case 16: // $60
      var $61=HEAPU16[((((__ZL6global+254)|0))>>1)];
      var $62=(($61)&65535);
      var $63=(($62)|0)!=15;
      if ($63) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $64
      var $65=$3;
      var $66=__Z13xml_add_childP14_xml_data_nodePKcS2_($65, ((STRING_TABLE.__str94058)|0), 0);
      $crosshairnode=$66;
      var $67=$crosshairnode;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $69
      var $70=$crosshairnode;
      var $71=HEAPU16[((((__ZL6global+254)|0))>>1)];
      var $72=(($71)&65535);
      var $73=__Z21xml_set_attribute_intP14_xml_data_nodePKci($70, ((STRING_TABLE.__str104059)|0), $72);
      __label__ = 19; break;
    case 19: // $74
      __label__ = 20; break;
    case 20: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14crosshair_saveR15running_machineiP14_xml_data_node["X"]=1;

function __ZL7animateR15running_machineR13screen_deviceb($machine, $device, $vblank_state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $player;
      $1=$machine;
      $2=$device;
      var $4=(($vblank_state)&1);
      $3=$4;
      var $5=$3;
      var $6=(($5) & 1);
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      __label__ = 19; break;
    case 2: // $8
      var $9=HEAPU8[(((__ZL6global+253)|0))];
      var $10=(($9)&255);
      var $11=(($10+8)|0);
      var $12=(($11) & 255);
      HEAP8[(((__ZL6global+253)|0))]=$12;
      var $13=HEAPU8[(((__ZL6global+253)|0))];
      var $14=(($13)&255);
      var $15=(($14)|0) < 128;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=HEAPU8[(((__ZL6global+253)|0))];
      var $18=(($17)&255);
      var $19=$18 & 127;
      var $20=(($19*96)|0);
      var $21=(((($20)|0)/128)|0);
      var $22=(($21+160)|0);
      var $23=(($22) & 255);
      HEAP8[(((__ZL6global+252)|0))]=$23;
      __label__ = 5; break;
    case 4: // $24
      var $25=HEAPU8[(((__ZL6global+253)|0))];
      var $26=(($25)&255);
      var $27=$26 ^ -1;
      var $28=$27 & 127;
      var $29=(($28*96)|0);
      var $30=(((($29)|0)/128)|0);
      var $31=(($30+160)|0);
      var $32=(($31) & 255);
      HEAP8[(((__ZL6global+252)|0))]=$32;
      __label__ = 5; break;
    case 5: // $33
      $player=0;
      __label__ = 6; break;
    case 6: // $34
      var $35=$player;
      var $36=(($35)|0) < 8;
      if ($36) { __label__ = 7; break; } else { __label__ = 19; break; }
    case 7: // $37
      var $38=$player;
      var $39=((((__ZL6global+1)|0)+$38)|0);
      var $40=HEAP8[($39)];
      var $41=(($40 << 24) >> 24)!=0;
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$2;
      var $44=$43;
      var $45=__ZNK8device_t7machineEv($44);
      var $46=$player;
      var $47=$player;
      var $48=((((__ZL6global+124)|0)+($47<<2))|0);
      var $49=$player;
      var $50=((((__ZL6global+156)|0)+($49<<2))|0);
      var $51=__Z33input_port_get_crosshair_positionR15running_machineiPfS1_($45, $46, $48, $50);
      __label__ = 9; break;
    case 9: // $52
      var $53=$player;
      var $54=((((__ZL6global+9)|0)+$53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=(($56)|0)==2;
      if ($57) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $58
      var $59=$player;
      var $60=((((__ZL6global+124)|0)+($59<<2))|0);
      var $61=HEAPF32[(($60)>>2)];
      var $62=$player;
      var $63=((((__ZL6global+188)|0)+($62<<2))|0);
      var $64=HEAPF32[(($63)>>2)];
      var $65=$61 != $64;
      if ($65) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $66
      var $67=$player;
      var $68=((((__ZL6global+156)|0)+($67<<2))|0);
      var $69=HEAPF32[(($68)>>2)];
      var $70=$player;
      var $71=((((__ZL6global+220)|0)+($70<<2))|0);
      var $72=HEAPF32[(($71)>>2)];
      var $73=$69 != $72;
      if ($73) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $74
      var $75=$player;
      var $76=((((__ZL6global+17)|0)+$75)|0);
      HEAP8[($76)]=1;
      var $77=$player;
      var $78=((((__ZL6global+124)|0)+($77<<2))|0);
      var $79=HEAPF32[(($78)>>2)];
      var $80=$player;
      var $81=((((__ZL6global+188)|0)+($80<<2))|0);
      HEAPF32[(($81)>>2)]=$79;
      var $82=$player;
      var $83=((((__ZL6global+156)|0)+($82<<2))|0);
      var $84=HEAPF32[(($83)>>2)];
      var $85=$player;
      var $86=((((__ZL6global+220)|0)+($85<<2))|0);
      HEAPF32[(($86)>>2)]=$84;
      var $87=$player;
      var $88=((((__ZL6global+256)|0)+($87<<1))|0);
      HEAP16[(($88)>>1)]=0;
      __label__ = 16; break;
    case 13: // $89
      var $90=$player;
      var $91=((((__ZL6global+256)|0)+($90<<1))|0);
      var $92=HEAPU16[(($91)>>1)];
      var $93=(($92)&65535);
      var $94=HEAPU16[((((__ZL6global+254)|0))>>1)];
      var $95=(($94)&65535);
      var $96=(($95*12)|0);
      var $97=(($96+2)|0);
      var $98=(($93)|0) > (($97)|0);
      if ($98) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $99
      var $100=$player;
      var $101=((((__ZL6global+17)|0)+$100)|0);
      HEAP8[($101)]=0;
      __label__ = 15; break;
    case 15: // $102
      var $103=$player;
      var $104=((((__ZL6global+256)|0)+($103<<1))|0);
      var $105=HEAP16[(($104)>>1)];
      var $106=(($105+1)&65535);
      HEAP16[(($104)>>1)]=$106;
      __label__ = 16; break;
    case 16: // $107
      __label__ = 17; break;
    case 17: // $108
      __label__ = 18; break;
    case 18: // $109
      var $110=$player;
      var $111=(($110+1)|0);
      $player=$111;
      __label__ = 6; break;
    case 19: // $112
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7animateR15running_machineR13screen_deviceb["X"]=1;

function __Z27crosshair_get_user_settingsR15running_machinehP24_crosshair_user_settings($machine, $player, $settings) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$player;
  $3=$settings;
  var $4=HEAP16[((((__ZL6global+254)|0))>>1)];
  var $5=(($4) & 255);
  var $6=$3;
  var $7=(($6+2)|0);
  HEAP8[($7)]=$5;
  var $8=$2;
  var $9=(($8)&255);
  var $10=((((__ZL6global+1)|0)+$9)|0);
  var $11=HEAP8[($10)];
  var $12=$3;
  var $13=(($12)|0);
  HEAP8[($13)]=$11;
  var $14=$2;
  var $15=(($14)&255);
  var $16=((((__ZL6global+9)|0)+$15)|0);
  var $17=HEAP8[($16)];
  var $18=$3;
  var $19=(($18+1)|0);
  HEAP8[($19)]=$17;
  var $20=$3;
  var $21=(($20+3)|0);
  var $22=(($21)|0);
  var $23=$2;
  var $24=(($23)&255);
  var $25=((((__ZL6global+272)|0)+$24*13)|0);
  var $26=(($25)|0);
  var $27=_strcpy($22, $26);
  ;
  return;
}


function __Z27crosshair_set_user_settingsR15running_machinehP24_crosshair_user_settings($machine, $player, $settings) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $changed;
      $1=$machine;
      $2=$player;
      $3=$settings;
      $changed=0;
      var $4=$3;
      var $5=(($4+2)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      HEAP16[((((__ZL6global+254)|0))>>1)]=$7;
      var $8=$3;
      var $9=(($8)|0);
      var $10=HEAP8[($9)];
      var $11=$2;
      var $12=(($11)&255);
      var $13=((((__ZL6global+1)|0)+$12)|0);
      HEAP8[($13)]=$10;
      var $14=$3;
      var $15=(($14+1)|0);
      var $16=HEAP8[($15)];
      var $17=$2;
      var $18=(($17)&255);
      var $19=((((__ZL6global+9)|0)+$18)|0);
      HEAP8[($19)]=$16;
      var $20=$3;
      var $21=(($20+1)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=(($23)|0)==1;
      var $25=$24 ? 1 : 0;
      var $26=(($25) & 255);
      var $27=$2;
      var $28=(($27)&255);
      var $29=((((__ZL6global+17)|0)+$28)|0);
      HEAP8[($29)]=$26;
      var $30=$3;
      var $31=(($30+3)|0);
      var $32=(($31)|0);
      var $33=$2;
      var $34=(($33)&255);
      var $35=((((__ZL6global+272)|0)+$34*13)|0);
      var $36=(($35)|0);
      var $37=_strcmp($32, $36);
      $changed=$37;
      var $38=$2;
      var $39=(($38)&255);
      var $40=((((__ZL6global+272)|0)+$39*13)|0);
      var $41=(($40)|0);
      var $42=$3;
      var $43=(($42+3)|0);
      var $44=(($43)|0);
      var $45=_strcpy($41, $44);
      var $46=$changed;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $48
      var $49=$1;
      var $50=$2;
      var $51=(($50)&255);
      __ZL13create_bitmapR15running_machinei($49, $51);
      __label__ = 2; break;
    case 2: // $52
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z27crosshair_set_user_settingsR15running_machinehP24_crosshair_user_settings["X"]=1;

function __Z16crosshair_renderR13screen_device($screen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $player;
      $1=$screen;
      $player=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$player;
      var $4=(($3)|0) < 8;
      if ($4) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $5
      var $6=$player;
      var $7=((((__ZL6global+17)|0)+$6)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $10
      var $11=$player;
      var $12=((((__ZL6global+92)|0)+($11<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=$14;
      var $16=(($13)|0)==(($15)|0);
      if ($16) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $17
      var $18=$player;
      var $19=((((__ZL6global+92)|0)+($18<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==-1;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$1;
      var $24=__ZNK13screen_device9containerEv($23);
      var $25=$player;
      var $26=((((__ZL6global+124)|0)+($25<<2))|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27-0.029999999329447746;
      var $29=$player;
      var $30=((((__ZL6global+156)|0)+($29<<2))|0);
      var $31=HEAPF32[(($30)>>2)];
      var $32=$31-0.03999999910593033;
      var $33=$player;
      var $34=((((__ZL6global+124)|0)+($33<<2))|0);
      var $35=HEAPF32[(($34)>>2)];
      var $36=$35+0.029999999329447746;
      var $37=$player;
      var $38=((((__ZL6global+156)|0)+($37<<2))|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39+0.03999999910593033;
      var $41=HEAPU8[(((__ZL6global+252)|0))];
      var $42=(($41)&255);
      var $43=$42 & 255;
      var $44=$43 << 16;
      var $45=-1073741824 | $44;
      var $46=HEAPU8[(((__ZL6global+252)|0))];
      var $47=(($46)&255);
      var $48=$47 & 255;
      var $49=$48 << 8;
      var $50=$45 | $49;
      var $51=HEAPU8[(((__ZL6global+252)|0))];
      var $52=(($51)&255);
      var $53=$52 & 255;
      var $54=$50 | $53;
      var $55=$player;
      var $56=((((__ZL6global+60)|0)+($55<<2))|0);
      var $57=HEAP32[(($56)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($24, $28, $32, $36, $40, $54, $57, 256);
      __label__ = 6; break;
    case 6: // $58
      __label__ = 7; break;
    case 7: // $59
      var $60=$player;
      var $61=(($60+1)|0);
      $player=$61;
      __label__ = 1; break;
    case 8: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16crosshair_renderR13screen_device["X"]=1;

function __ZNK11emu_options14crosshair_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str154064)|0));
  ;
  return $4;
}


function __Z14multicart_openR11emu_optionsPKcS2_21_multicart_load_flagsPP12_multicart_t($options, $filename, $gamedrv, $load_flags, $cart) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $err;
      var $ziperr;
      var $pool;
      var $state=__stackBase__;
      var $header;
      var $pcb_type;
      var $layout_text;
      $1=$options;
      $2=$filename;
      $3=$gamedrv;
      $4=$load_flags;
      $5=$cart;
      var $6=$state;
      HEAP32[(($6)>>2)]=0; HEAP32[(($6+4)>>2)]=0; HEAP32[(($6+8)>>2)]=0; HEAP32[(($6+12)>>2)]=0; HEAP32[(($6+16)>>2)]=0; HEAP32[(($6+20)>>2)]=0; HEAP32[(($6+24)>>2)]=0;
      $layout_text=0;
      var $7=__Z14pool_alloc_libPFvPKcE(0);
      $pool=$7;
      var $8=$pool;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $err=3;
      __label__ = 29; break;
    case 2: // $11
      var $12=$pool;
      var $13=__Z21pool_malloc_file_lineP12_object_pooljPKci($12, 20, ((STRING_TABLE.__str4067)|0), 483);
      var $14=$13;
      var $15=(($state)|0);
      HEAP32[(($15)>>2)]=$14;
      var $16=(($state)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $err=3;
      __label__ = 29; break;
    case 4: // $20
      var $21=(($state)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      _memset($23, 0, 20, 1);
      var $24=$pool;
      var $25=__Z21pool_malloc_file_lineP12_object_pooljPKci($24, 8, ((STRING_TABLE.__str4067)|0), 492);
      var $26=$25;
      var $27=(($state)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+16)|0);
      HEAP32[(($29)>>2)]=$26;
      var $30=(($state)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+16)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $35
      $err=3;
      __label__ = 29; break;
    case 6: // $36
      var $37=(($state)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+16)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      HEAP8[($41)]=0; HEAP8[($41+1)]=0; HEAP8[($41+2)]=0; HEAP8[($41+3)]=0; HEAP8[($41+4)]=0; HEAP8[($41+5)]=0; HEAP8[($41+6)]=0; HEAP8[($41+7)]=0;
      var $42=$pool;
      var $43=(($state)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0);
      HEAP32[(($47)>>2)]=$42;
      $pool=0;
      var $48=$2;
      var $49=(($state+4)|0);
      var $50=__Z13zip_file_openPKcPP9_zip_file($48, $49);
      $ziperr=$50;
      var $51=$ziperr;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $53
      $err=1;
      __label__ = 29; break;
    case 8: // $54
      var $55=(($state+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__ZL9find_fileP9_zip_filePKc($56, ((STRING_TABLE.__str14068)|0));
      $header=$57;
      var $58=$header;
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $60
      $err=12;
      __label__ = 29; break;
    case 10: // $61
      var $62=$header;
      var $63=(($62+24)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+1)|0);
      var $66=__Z22malloc_array_file_linejPKci($65, ((STRING_TABLE.__str4067)|0), 519);
      $layout_text=$66;
      var $67=$layout_text;
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $69
      $err=3;
      __label__ = 29; break;
    case 12: // $70
      var $71=(($state+4)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$layout_text;
      var $74=$header;
      var $75=(($74+24)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=__Z19zip_file_decompressP9_zip_filePvj($72, $73, $76);
      $ziperr=$77;
      var $78=$ziperr;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $80
      $err=6;
      __label__ = 29; break;
    case 14: // $81
      var $82=$header;
      var $83=(($82+24)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$layout_text;
      var $86=(($85+$84)|0);
      HEAP8[($86)]=0;
      var $87=$layout_text;
      var $88=__Z15xml_string_readPKcP18_xml_parse_options($87, 0);
      var $89=(($state+8)|0);
      HEAP32[(($89)>>2)]=$88;
      var $90=(($state+8)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91)|0)==0;
      if ($92) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $93
      $err=4;
      __label__ = 29; break;
    case 16: // $94
      var $95=(($state+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($state+16)|0);
      var $98=(($state+12)|0);
      var $99=__ZL27find_pcb_and_resource_nodesP14_xml_data_nodePS0_S1_($96, $97, $98);
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $101
      $err=13;
      __label__ = 29; break;
    case 18: // $102
      var $103=(($state+16)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($104, ((STRING_TABLE.__str24069)|0), ((__str34070)|0));
      $pcb_type=$105;
      var $106=(($state)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107+16)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$pcb_type;
      var $113=__Z21pool_strdup_file_lineP12_object_poolPKcS2_i($111, $112, ((STRING_TABLE.__str4067)|0), 552);
      var $114=(($state)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115+8)|0);
      HEAP32[(($116)>>2)]=$113;
      var $117=(($state)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118+8)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120)|0)==0;
      if ($121) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $122
      $err=3;
      __label__ = 29; break;
    case 20: // $123
      var $124=(($state)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125+16)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$3;
      var $131=__Z21pool_strdup_file_lineP12_object_poolPKcS2_i($129, $130, ((STRING_TABLE.__str4067)|0), 559);
      var $132=(($state)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+12)|0);
      HEAP32[(($134)>>2)]=$131;
      var $135=(($state)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+12)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138)|0)==0;
      if ($139) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $140
      $err=3;
      __label__ = 29; break;
    case 22: // $141
      var $142=$4;
      var $143=$142 & 1;
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $145
      var $146=$1;
      var $147=__ZL18load_all_resourcesR11emu_optionsP21_multicart_load_state($146, $state);
      $err=$147;
      var $148=$err;
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $150
      __label__ = 29; break;
    case 25: // $151
      var $152=__ZL16load_all_socketsP21_multicart_load_state($state);
      $err=$152;
      var $153=$err;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $155
      __label__ = 29; break;
    case 27: // $156
      __label__ = 28; break;
    case 28: // $157
      $err=0;
      __label__ = 29; break;
    case 29: // $158
      var $159=$pool;
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $161
      var $162=$pool;
      __Z13pool_free_libP12_object_pool($162);
      __label__ = 31; break;
    case 31: // $163
      var $164=(($state+4)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $167
      var $168=(($state+4)|0);
      var $169=HEAP32[(($168)>>2)];
      __Z14zip_file_closeP9_zip_file($169);
      __label__ = 33; break;
    case 33: // $170
      var $171=$layout_text;
      var $172=(($171)|0)!=0;
      if ($172) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $173
      var $174=$layout_text;
      __Z14free_file_linePvPKci($174, ((STRING_TABLE.__str4067)|0), 586);
      __label__ = 35; break;
    case 35: // $175
      var $176=(($state+8)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177)|0)!=0;
      if ($178) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $179
      var $180=(($state+8)|0);
      var $181=HEAP32[(($180)>>2)];
      __Z13xml_file_freeP14_xml_data_node($181);
      __label__ = 37; break;
    case 37: // $182
      var $183=$err;
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $185
      var $186=(($state)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187)|0)!=0;
      if ($188) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $189
      var $190=$1;
      var $191=(($state)|0);
      var $192=HEAP32[(($191)>>2)];
      __Z15multicart_closeR11emu_optionsP12_multicart_t($190, $192);
      var $193=(($state)|0);
      HEAP32[(($193)>>2)]=0;
      __label__ = 40; break;
    case 40: // $194
      var $195=(($state)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=$5;
      HEAP32[(($197)>>2)]=$196;
      var $198=$err;
      STACKTOP = __stackBase__;
      return $198;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14multicart_openR11emu_optionsPKcS2_21_multicart_load_flagsPP12_multicart_t["X"]=1;

function __ZL9find_fileP9_zip_filePKc($zip, $filename) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $header;
      $2=$zip;
      $3=$filename;
      var $4=$2;
      var $5=__Z19zip_file_first_fileP9_zip_file($4);
      $header=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$header;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$header;
      var $11=(($10+48)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$3;
      var $14=__Z12core_stricmpPKcS0_($12, $13);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$header;
      $1=$17;
      __label__ = 7; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$2;
      var $21=__Z18zip_file_next_fileP9_zip_file($20);
      $header=$21;
      __label__ = 1; break;
    case 6: // $22
      $1=0;
      __label__ = 7; break;
    case 7: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL27find_pcb_and_resource_nodesP14_xml_data_nodePS0_S1_($layout_xml, $pcb_node, $resource_node) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $romset_node;
      var $configuration_node;
      $2=$layout_xml;
      $3=$pcb_node;
      $4=$resource_node;
      var $5=$3;
      HEAP32[(($5)>>2)]=0;
      var $6=$4;
      HEAP32[(($6)>>2)]=0;
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__Z15xml_get_siblingP14_xml_data_nodePKc($9, ((STRING_TABLE.__str154082)|0));
      $romset_node=$10;
      var $11=$romset_node;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=0;
      __label__ = 9; break;
    case 2: // $14
      var $15=$romset_node;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__Z15xml_get_siblingP14_xml_data_nodePKc($17, ((STRING_TABLE.__str164083)|0));
      $configuration_node=$18;
      var $19=$configuration_node;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      $1=0;
      __label__ = 9; break;
    case 4: // $22
      var $23=$configuration_node;
      var $24=(($23+8)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__Z15xml_get_siblingP14_xml_data_nodePKc($25, ((STRING_TABLE.__str174084)|0));
      var $27=$3;
      HEAP32[(($27)>>2)]=$26;
      var $28=$3;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      $1=0;
      __label__ = 9; break;
    case 6: // $32
      var $33=$romset_node;
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z15xml_get_siblingP14_xml_data_nodePKc($35, ((STRING_TABLE.__str184085)|0));
      var $37=$4;
      HEAP32[(($37)>>2)]=$36;
      var $38=$4;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      $1=0;
      __label__ = 9; break;
    case 8: // $42
      $1=1;
      __label__ = 9; break;
    case 9: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27find_pcb_and_resource_nodesP14_xml_data_nodePS0_S1_["X"]=1;

function __ZL18load_all_resourcesR11emu_optionsP21_multicart_load_state($options, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $err;
      var $resource_node;
      var $resource_type;
      $2=$options;
      $3=$state;
      var $4=$3;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      $resource_node=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$resource_node;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $12
      var $13=$resource_node;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZL17get_resource_typePKc($15);
      $resource_type=$16;
      var $17=$resource_type;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$2;
      var $21=$3;
      var $22=$resource_node;
      var $23=$resource_type;
      var $24=__ZL13load_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_node24_multicart_resource_type($20, $21, $22, $23);
      $err=$24;
      var $25=$err;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$err;
      $1=$28;
      __label__ = 9; break;
    case 5: // $29
      __label__ = 6; break;
    case 6: // $30
      __label__ = 7; break;
    case 7: // $31
      var $32=$resource_node;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      $resource_node=$34;
      __label__ = 1; break;
    case 8: // $35
      var $36=$3;
      var $37=(($36+20)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$3;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0);
      HEAP32[(($42)>>2)]=$38;
      $1=0;
      __label__ = 9; break;
    case 9: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18load_all_resourcesR11emu_optionsP21_multicart_load_state["X"]=1;

function __ZL16load_all_socketsP21_multicart_load_state($state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $err;
      var $socket_node;
      $2=$state;
      var $3=$2;
      var $4=(($3+16)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__Z15xml_get_siblingP14_xml_data_nodePKc($7, ((STRING_TABLE.__str44071)|0));
      $socket_node=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$socket_node;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$2;
      var $14=$socket_node;
      var $15=__ZL11load_socketP21_multicart_load_stateP14_xml_data_node($13, $14);
      $err=$15;
      var $16=$err;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$err;
      $1=$19;
      __label__ = 7; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$socket_node;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__Z15xml_get_siblingP14_xml_data_nodePKc($24, ((STRING_TABLE.__str44071)|0));
      $socket_node=$25;
      __label__ = 1; break;
    case 6: // $26
      var $27=$2;
      var $28=(($27+24)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+4)|0);
      HEAP32[(($33)>>2)]=$29;
      $1=0;
      __label__ = 7; break;
    case 7: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15multicart_closeR11emu_optionsP12_multicart_t($options, $cart) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$options;
  $2=$cart;
  var $3=$1;
  var $4=$2;
  var $5=__ZL18save_ram_resourcesR11emu_optionsP12_multicart_t($3, $4);
  var $6=$2;
  var $7=(($6+16)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0);
  var $10=HEAP32[(($9)>>2)];
  __Z13pool_free_libP12_object_pool($10);
  ;
  return;
}


function __ZL18save_ram_resourcesR11emu_optionsP12_multicart_t($options, $cart) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $resource;
      $1=$options;
      $2=$cart;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $resource=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$resource;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$resource;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)==2;
      if ($13) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      var $15=$resource;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$1;
      var $21=$resource;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$resource;
      var $25=(($24+20)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$resource;
      var $28=(($27+16)|0);
      var $29=HEAP32[(($28)>>2)];
      __Z26image_battery_save_by_nameR11emu_optionsPKcPKvi($20, $23, $26, $29);
      __label__ = 5; break;
    case 5: // $30
      __label__ = 6; break;
    case 6: // $31
      var $32=$resource;
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      $resource=$34;
      __label__ = 1; break;
    case 7: // $35
      ;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11load_socketP21_multicart_load_stateP14_xml_data_node($state, $socket_node) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $id;
      var $uses;
      var $resource;
      var $socket;
      var $next_socket;
      $2=$state;
      $3=$socket_node;
      var $4=$3;
      var $5=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($4, ((STRING_TABLE.__str54072)|0), 0);
      $id=$5;
      var $6=$3;
      var $7=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($6, ((STRING_TABLE.__str64073)|0), 0);
      $uses=$7;
      var $8=$id;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$uses;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      $1=4;
      __label__ = 25; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      $resource=$19;
      __label__ = 4; break;
    case 4: // $20
      var $21=$resource;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $23
      var $24=$uses;
      var $25=$resource;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=_strcmp($24, $27);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $30
      __label__ = 9; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      var $33=$resource;
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      $resource=$35;
      __label__ = 4; break;
    case 9: // $36
      var $37=$resource;
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $39
      $1=10;
      __label__ = 25; break;
    case 11: // $40
      var $41=$2;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+16)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=__Z21pool_malloc_file_lineP12_object_pooljPKci($47, 16, ((STRING_TABLE.__str4067)|0), 400);
      var $49=$48;
      $socket=$49;
      var $50=$socket;
      var $51=(($50)|0)==0;
      if ($51) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $52
      $1=3;
      __label__ = 25; break;
    case 13: // $53
      var $54=$socket;
      var $55=$54;
      for (var $$dest = $55, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $56=$resource;
      var $57=$socket;
      var $58=(($57+8)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=$resource;
      var $60=(($59+20)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$socket;
      var $63=(($62+12)|0);
      HEAP32[(($63)>>2)]=$61;
      var $64=$2;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+16)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$id;
      var $72=__Z21pool_strdup_file_lineP12_object_poolPKcS2_i($70, $71, ((STRING_TABLE.__str4067)|0), 408);
      var $73=$socket;
      var $74=(($73)|0);
      HEAP32[(($74)>>2)]=$72;
      var $75=$socket;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $79
      $1=3;
      __label__ = 25; break;
    case 15: // $80
      var $81=$resource;
      var $82=(($81+20)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $85
      var $86=$resource;
      var $87=(($86+20)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$socket;
      var $90=(($89+12)|0);
      HEAP32[(($90)>>2)]=$88;
      __label__ = 20; break;
    case 17: // $91
      var $92=$2;
      var $93=(($92)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94+16)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$resource;
      var $100=(($99+16)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=__Z21pool_malloc_file_lineP12_object_pooljPKci($98, $101, ((STRING_TABLE.__str4067)|0), 421);
      var $103=$socket;
      var $104=(($103+12)|0);
      HEAP32[(($104)>>2)]=$102;
      var $105=$socket;
      var $106=(($105+12)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $109
      $1=3;
      __label__ = 25; break;
    case 19: // $110
      var $111=$socket;
      var $112=(($111+12)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$resource;
      var $115=(($114+16)|0);
      var $116=HEAP32[(($115)>>2)];
      _memset($113, -51, $116, 1);
      __label__ = 20; break;
    case 20: // $117
      var $118=$2;
      var $119=(($118+24)|0);
      $next_socket=$119;
      __label__ = 21; break;
    case 21: // $120
      var $121=$next_socket;
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $124
      __label__ = 23; break;
    case 23: // $125
      var $126=$next_socket;
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+4)|0);
      $next_socket=$128;
      __label__ = 21; break;
    case 24: // $129
      var $130=$socket;
      var $131=$next_socket;
      HEAP32[(($131)>>2)]=$130;
      $1=0;
      __label__ = 25; break;
    case 25: // $132
      var $133=$1;
      ;
      return $133;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11load_socketP21_multicart_load_stateP14_xml_data_node["X"]=1;

function __ZL17get_resource_typePKc($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$s;
      var $2=$1;
      var $3=_strcmp($2, ((STRING_TABLE.__str134080)|0));
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      $result=1;
      __label__ = 6; break;
    case 2: // $6
      var $7=$1;
      var $8=_strcmp($7, ((STRING_TABLE.__str144081)|0));
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $10
      $result=2;
      __label__ = 5; break;
    case 4: // $11
      $result=0;
      __label__ = 5; break;
    case 5: // $12
      __label__ = 6; break;
    case 6: // $13
      var $14=$result;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13load_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_node24_multicart_resource_type($options, $state, $resource_node, $resource_type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $id;
      var $err;
      var $resource;
      var $next_resource;
      $2=$options;
      $3=$state;
      $4=$resource_node;
      $5=$resource_type;
      var $6=$4;
      var $7=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($6, ((STRING_TABLE.__str54072)|0), 0);
      $id=$7;
      var $8=$id;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=4;
      __label__ = 19; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__Z21pool_malloc_file_lineP12_object_pooljPKci($18, 24, ((STRING_TABLE.__str4067)|0), 289);
      var $20=$19;
      $resource=$20;
      var $21=$resource;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      $1=3;
      __label__ = 19; break;
    case 4: // $24
      var $25=$resource;
      var $26=$25;
      _memset($26, 0, 24, 1);
      var $27=$5;
      var $28=$resource;
      var $29=(($28+12)|0);
      HEAP32[(($29)>>2)]=$27;
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+16)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$id;
      var $38=__Z21pool_strdup_file_lineP12_object_poolPKcS2_i($36, $37, ((STRING_TABLE.__str4067)|0), 296);
      var $39=$resource;
      var $40=(($39)|0);
      HEAP32[(($40)>>2)]=$38;
      var $41=$resource;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      $1=3;
      __label__ = 19; break;
    case 6: // $46
      var $47=$resource;
      var $48=(($47+12)|0);
      var $49=HEAP32[(($48)>>2)];
      if ($49 == 1) {
        __label__ = 7; break;
      }
      else if ($49 == 2) {
        __label__ = 10; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 7: // $50
      var $51=$3;
      var $52=$4;
      var $53=$resource;
      var $54=__ZL17load_rom_resourceP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource($51, $52, $53);
      $err=$54;
      var $55=$err;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $57
      var $58=$err;
      $1=$58;
      __label__ = 19; break;
    case 9: // $59
      __label__ = 14; break;
    case 10: // $60
      var $61=$2;
      var $62=$3;
      var $63=$4;
      var $64=$resource;
      var $65=__ZL17load_ram_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource($61, $62, $63, $64);
      $err=$65;
      var $66=$err;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $68
      var $69=$err;
      $1=$69;
      __label__ = 19; break;
    case 12: // $70
      __label__ = 14; break;
    case 13: // $71
      $1=9;
      __label__ = 19; break;
    case 14: // $72
      var $73=$3;
      var $74=(($73+20)|0);
      $next_resource=$74;
      __label__ = 15; break;
    case 15: // $75
      var $76=$next_resource;
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $79
      __label__ = 17; break;
    case 17: // $80
      var $81=$next_resource;
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82+8)|0);
      $next_resource=$83;
      __label__ = 15; break;
    case 18: // $84
      var $85=$resource;
      var $86=$next_resource;
      HEAP32[(($86)>>2)]=$85;
      $1=0;
      __label__ = 19; break;
    case 19: // $87
      var $88=$1;
      ;
      return $88;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13load_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_node24_multicart_resource_type["X"]=1;

function __ZL17load_rom_resourceP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource($state, $resource_node, $resource) {
  var __stackBase__  = STACKTOP; STACKTOP += 168; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $file;
      var $crcstr;
      var $sha1;
      var $header;
      var $ziperr;
      var $crc;
      var $actual_hashes=__stackBase__;
      var $5;
      var $6;
      var $expected_hashes=__stackBase__+84;
      var $7;
      $2=$state;
      $3=$resource_node;
      $4=$resource;
      var $8=$3;
      var $9=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($8, ((STRING_TABLE.__str94076)|0), 0);
      $file=$9;
      var $10=$file;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $1=4;
      __label__ = 29; break;
    case 2: // $13
      var $14=$3;
      var $15=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($14, ((STRING_TABLE.__str114078)|0), 0);
      $crcstr=$15;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $17
      var $18=$2;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$file;
      var $22=__ZL9find_fileP9_zip_filePKc($20, $21);
      $header=$22;
      __label__ = 5; break;
    case 4: // $23
      var $24=$crcstr;
      var $25=_strtoul($24, 0, 16);
      $crc=$25;
      var $26=$2;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$file;
      var $30=$crc;
      var $31=__ZL13find_file_crcP9_zip_filePKcj($28, $29, $30);
      $header=$31;
      __label__ = 5; break;
    case 5: // $32
      var $33=$header;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      $1=5;
      __label__ = 29; break;
    case 7: // $36
      var $37=$header;
      var $38=(($37+24)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$4;
      var $41=(($40+16)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$2;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$4;
      var $50=(($49+16)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=__Z21pool_malloc_file_lineP12_object_pooljPKci($48, $51, ((STRING_TABLE.__str4067)|0), 184);
      var $53=$4;
      var $54=(($53+20)|0);
      HEAP32[(($54)>>2)]=$52;
      var $55=$4;
      var $56=(($55+20)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57)|0)==0;
      if ($58) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $59
      $1=3;
      __label__ = 29; break;
    case 9: // $60
      var $61=$2;
      var $62=(($61+4)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$4;
      var $65=(($64+20)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$4;
      var $68=(($67+16)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=__Z19zip_file_decompressP9_zip_filePvj($63, $66, $69);
      $ziperr=$70;
      var $71=$ziperr;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      $1=6;
      __label__ = 29; break;
    case 11: // $74
      var $75=$3;
      var $76=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($75, ((STRING_TABLE.__str124079)|0), 0);
      $sha1=$76;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 12; break; } else { __label__ = 28; break; }
    case 12: // $78
      FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($actual_hashes);
      var $79=$4;
      var $80=(($79+20)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$4;
      var $83=(($82+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[((__ZN15hash_collection19HASH_TYPES_CRC_SHA1E)>>2)];
      (function() { try { __THREW__ = false; return __ZN15hash_collection7computeEPKhjPKc($actual_hashes, $81, $84, $85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $86
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($expected_hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $87
      var $88=$sha1;
      var $89=$sha1;
      var $90=(function() { try { __THREW__ = false; return _strlen($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 20; break; };
    case 15: // $91
      var $92=(function() { try { __THREW__ = false; return __ZN15hash_collection15add_from_stringEcPKci($expected_hashes, 83, $88, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; };
    case 16: // $93
      var $94=(function() { try { __THREW__ = false; return __ZNK15hash_collectionneERKS_($actual_hashes, $expected_hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 20; break; };
    case 17: // $95
      if ($94) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $96
      $1=5;
      $7=1;
      __label__ = 22; break;
    case 19: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $99=$98.f0;
      $5=$99;
      var $100=$98.f1;
      $6=$100;
      __label__ = 26; break;
    case 20: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $103=$102.f0;
      $5=$103;
      var $104=$102.f1;
      $6=$104;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($expected_hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 31; break; }
    case 21: // $105
      $7=0;
      __label__ = 22; break;
    case 22: // $106
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($expected_hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 19; break; }
    case 23: // $107
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($actual_hashes);
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0) {
        __label__ = 24; break;
      }
      else if ($cleanup_dest == 1) {
        __label__ = 29; break;
      }
      else {
      __label__ = 32; break;
      }
      
    case 24: // $108
      __label__ = 28; break;
    case 25: // $109
      __label__ = 26; break;
    case 26: // $110
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($actual_hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $111
      __label__ = 30; break;
    case 28: // $112
      $1=0;
      __label__ = 29; break;
    case 29: // $113
      var $114=$1;
      STACKTOP = __stackBase__;
      return $114;
    case 30: // $115
      var $116=$5;
      var $117=$5;
      var $118=$6;
      var $119=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $117, tempValue);
      var $120=($119.f1 = $118, $119);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 31: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 32: // $123
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17load_rom_resourceP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource["X"]=1;

function __ZL28resample_argb_bitmap_averagePjjjjPKjjjjPK12render_colorjj($dest, $drowpixels, $dwidth, $dheight, $source, $srowpixels, $swidth, $sheight, $color, $dx, $dy) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $sumscale=__stackBase__;
      var $r;
      var $g;
      var $b;
      var $a;
      var $x;
      var $y;
      var $starty;
      var $sumr=__stackBase__+8;
      var $sumg=__stackBase__+16;
      var $sumb=__stackBase__+24;
      var $suma=__stackBase__+32;
      var $startx;
      var $xchunk;
      var $ychunk;
      var $curx;
      var $cury;
      var $yremaining;
      var $xremaining;
      var $factor;
      var $pix;
      var $dpix;
      $1=$dest;
      $2=$drowpixels;
      $3=$dwidth;
      $4=$dheight;
      $5=$source;
      $6=$srowpixels;
      $7=$swidth;
      $8=$sheight;
      $9=$color;
      $10=$dx;
      $11=$dy;
      var $12=$10;
      var $13$0=$12;
      var $13$1=0;
      var $14=$11;
      var $15$0=$14;
      var $15$1=0;
      var $16$0 = ((($13$0)>>>0)+((($13$1)|0)*4294967296))*((($15$0)>>>0)+((($15$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($13$0)>>>0)+((($13$1)|0)*4294967296))*((($15$0)>>>0)+((($15$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$51$0=(($sumscale)|0);
      HEAP32[(($st$51$0)>>2)]=$16$0;
      var $st$51$1=(($sumscale+4)|0);
      HEAP32[(($st$51$1)>>2)]=$16$1;
      var $17=$9;
      var $18=(($17+4)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=$9;
      var $21=(($20)|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=$19*$22;
      var $24=$23;
      var $25=$24*256;
      var $26=($25 >= 0 ? Math.floor($25) : Math.ceil($25));
      $r=$26;
      var $27=$9;
      var $28=(($27+8)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$9;
      var $31=(($30)|0);
      var $32=HEAPF32[(($31)>>2)];
      var $33=$29*$32;
      var $34=$33;
      var $35=$34*256;
      var $36=($35 >= 0 ? Math.floor($35) : Math.ceil($35));
      $g=$36;
      var $37=$9;
      var $38=(($37+12)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$9;
      var $41=(($40)|0);
      var $42=HEAPF32[(($41)>>2)];
      var $43=$39*$42;
      var $44=$43;
      var $45=$44*256;
      var $46=($45 >= 0 ? Math.floor($45) : Math.ceil($45));
      $b=$46;
      var $47=$9;
      var $48=(($47)|0);
      var $49=HEAPF32[(($48)>>2)];
      var $50=$49;
      var $51=$50*256;
      var $52=($51 >= 0 ? Math.floor($51) : Math.ceil($51));
      $a=$52;
      $y=0;
      __label__ = 1; break;
    case 1: // $53
      var $54=$y;
      var $55=$4;
      var $56=(($54)>>>0) < (($55)>>>0);
      if ($56) { __label__ = 2; break; } else { __label__ = 22; break; }
    case 2: // $57
      var $58=$y;
      var $59=$11;
      var $60=(($58*$59)|0);
      $starty=$60;
      $x=0;
      __label__ = 3; break;
    case 3: // $61
      var $62=$x;
      var $63=$3;
      var $64=(($62)>>>0) < (($63)>>>0);
      if ($64) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $65
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($sumr)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($sumr+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$8$0=(($sumg)|0);
      HEAP32[(($st$8$0)>>2)]=$$emscripten$temp$1$0;
      var $st$8$1=(($sumg+4)|0);
      HEAP32[(($st$8$1)>>2)]=$$emscripten$temp$1$1;
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$14$0=(($sumb)|0);
      HEAP32[(($st$14$0)>>2)]=$$emscripten$temp$2$0;
      var $st$14$1=(($sumb+4)|0);
      HEAP32[(($st$14$1)>>2)]=$$emscripten$temp$2$1;
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$20$0=(($suma)|0);
      HEAP32[(($st$20$0)>>2)]=$$emscripten$temp$3$0;
      var $st$20$1=(($suma+4)|0);
      HEAP32[(($st$20$1)>>2)]=$$emscripten$temp$3$1;
      var $66=$x;
      var $67=$10;
      var $68=(($66*$67)|0);
      $startx=$68;
      var $69=$11;
      $yremaining=$69;
      var $70=$starty;
      $cury=$70;
      __label__ = 5; break;
    case 5: // $71
      var $72=$yremaining;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 6; break; } else { __label__ = 16; break; }
    case 6: // $74
      var $75=$10;
      $xremaining=$75;
      var $76=$cury;
      var $77=$76 & 4095;
      var $78=((4096-$77)|0);
      $ychunk=$78;
      var $79=$ychunk;
      var $80=$yremaining;
      var $81=(($79)>>>0) > (($80)>>>0);
      if ($81) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $82
      var $83=$yremaining;
      $ychunk=$83;
      __label__ = 8; break;
    case 8: // $84
      var $85=$ychunk;
      var $86=$yremaining;
      var $87=(($86-$85)|0);
      $yremaining=$87;
      var $88=$startx;
      $curx=$88;
      __label__ = 9; break;
    case 9: // $89
      var $90=$xremaining;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $92
      var $93=$curx;
      var $94=$93 & 4095;
      var $95=((4096-$94)|0);
      $xchunk=$95;
      var $96=$xchunk;
      var $97=$xremaining;
      var $98=(($96)>>>0) > (($97)>>>0);
      if ($98) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $99
      var $100=$xremaining;
      $xchunk=$100;
      __label__ = 12; break;
    case 12: // $101
      var $102=$xchunk;
      var $103=$xremaining;
      var $104=(($103-$102)|0);
      $xremaining=$104;
      var $105=$xchunk;
      var $106=$ychunk;
      var $107=(($105*$106)|0);
      $factor=$107;
      var $108=$cury;
      var $109=$108 >>> 12;
      var $110=$6;
      var $111=(($109*$110)|0);
      var $112=$curx;
      var $113=$112 >>> 12;
      var $114=(($111+$113)|0);
      var $115=$5;
      var $116=(($115+($114<<2))|0);
      var $117=HEAP32[(($116)>>2)];
      $pix=$117;
      var $118=$factor;
      var $119=$pix;
      var $120=$119 >>> 16;
      var $121=$120 & 255;
      var $122=(($118*$121)|0);
      var $123$0=$122;
      var $123$1=0;
      var $st$26$0=(($sumr)|0);
      var $124$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($sumr+4)|0);
      var $124$1=HEAP32[(($st$26$1)>>2)];
      var $125$0 = ((($124$0)>>>0)+((($124$1)|0)*4294967296))+((($123$0)>>>0)+((($123$1)|0)*4294967296))>>>0; var $125$1 = Math.min(Math.floor((((($124$0)>>>0)+((($124$1)|0)*4294967296))+((($123$0)>>>0)+((($123$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$31$0=(($sumr)|0);
      HEAP32[(($st$31$0)>>2)]=$125$0;
      var $st$31$1=(($sumr+4)|0);
      HEAP32[(($st$31$1)>>2)]=$125$1;
      var $126=$factor;
      var $127=$pix;
      var $128=$127 >>> 8;
      var $129=$128 & 255;
      var $130=(($126*$129)|0);
      var $131$0=$130;
      var $131$1=0;
      var $st$42$0=(($sumg)|0);
      var $132$0=HEAP32[(($st$42$0)>>2)];
      var $st$42$1=(($sumg+4)|0);
      var $132$1=HEAP32[(($st$42$1)>>2)];
      var $133$0 = ((($132$0)>>>0)+((($132$1)|0)*4294967296))+((($131$0)>>>0)+((($131$1)|0)*4294967296))>>>0; var $133$1 = Math.min(Math.floor((((($132$0)>>>0)+((($132$1)|0)*4294967296))+((($131$0)>>>0)+((($131$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$47$0=(($sumg)|0);
      HEAP32[(($st$47$0)>>2)]=$133$0;
      var $st$47$1=(($sumg+4)|0);
      HEAP32[(($st$47$1)>>2)]=$133$1;
      var $134=$factor;
      var $135=$pix;
      var $136=$135 & 255;
      var $137=(($134*$136)|0);
      var $138$0=$137;
      var $138$1=0;
      var $st$57$0=(($sumb)|0);
      var $139$0=HEAP32[(($st$57$0)>>2)];
      var $st$57$1=(($sumb+4)|0);
      var $139$1=HEAP32[(($st$57$1)>>2)];
      var $140$0 = ((($139$0)>>>0)+((($139$1)|0)*4294967296))+((($138$0)>>>0)+((($138$1)|0)*4294967296))>>>0; var $140$1 = Math.min(Math.floor((((($139$0)>>>0)+((($139$1)|0)*4294967296))+((($138$0)>>>0)+((($138$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$62$0=(($sumb)|0);
      HEAP32[(($st$62$0)>>2)]=$140$0;
      var $st$62$1=(($sumb+4)|0);
      HEAP32[(($st$62$1)>>2)]=$140$1;
      var $141=$factor;
      var $142=$pix;
      var $143=$142 >>> 24;
      var $144=$143 & 255;
      var $145=(($141*$144)|0);
      var $146$0=$145;
      var $146$1=0;
      var $st$73$0=(($suma)|0);
      var $147$0=HEAP32[(($st$73$0)>>2)];
      var $st$73$1=(($suma+4)|0);
      var $147$1=HEAP32[(($st$73$1)>>2)];
      var $148$0 = ((($147$0)>>>0)+((($147$1)|0)*4294967296))+((($146$0)>>>0)+((($146$1)|0)*4294967296))>>>0; var $148$1 = Math.min(Math.floor((((($147$0)>>>0)+((($147$1)|0)*4294967296))+((($146$0)>>>0)+((($146$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$78$0=(($suma)|0);
      HEAP32[(($st$78$0)>>2)]=$148$0;
      var $st$78$1=(($suma+4)|0);
      HEAP32[(($st$78$1)>>2)]=$148$1;
      __label__ = 13; break;
    case 13: // $149
      var $150=$xchunk;
      var $151=$curx;
      var $152=(($151+$150)|0);
      $curx=$152;
      __label__ = 9; break;
    case 14: // $153
      __label__ = 15; break;
    case 15: // $154
      var $155=$ychunk;
      var $156=$cury;
      var $157=(($156+$155)|0);
      $cury=$157;
      __label__ = 5; break;
    case 16: // $158
      var $st$0$0=(($suma)|0);
      var $159$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($suma+4)|0);
      var $159$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($sumscale)|0);
      var $160$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($sumscale+4)|0);
      var $160$1=HEAP32[(($st$4$1)>>2)];
      var $161$0 = Math.floor(((($159$0)>>>0)+((($159$1)|0)*4294967296))/((($160$0)>>>0)+((($160$1)|0)*4294967296)))>>>0; var $161$1 = Math.min(Math.floor((Math.floor(((($159$0)>>>0)+((($159$1)|0)*4294967296))/((($160$0)>>>0)+((($160$1)|0)*4294967296))))/4294967296), 4294967295);
      var $162=$a;
      var $163$0=$162;
      var $163$1=0;
      var $164$0 = ((($161$0)>>>0)+((($161$1)|0)*4294967296))*((($163$0)>>>0)+((($163$1)|0)*4294967296))>>>0; var $164$1 = Math.min(Math.floor((((($161$0)>>>0)+((($161$1)|0)*4294967296))*((($163$0)>>>0)+((($163$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$4$0=256;
      var $$emscripten$temp$4$1=0;
      var $165$0 = Math.floor(((($164$0)>>>0)+((($164$1)|0)*4294967296))/((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))>>>0; var $165$1 = Math.min(Math.floor((Math.floor(((($164$0)>>>0)+((($164$1)|0)*4294967296))/((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$16$0=(($suma)|0);
      HEAP32[(($st$16$0)>>2)]=$165$0;
      var $st$16$1=(($suma+4)|0);
      HEAP32[(($st$16$1)>>2)]=$165$1;
      var $st$20$0=(($sumr)|0);
      var $166$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($sumr+4)|0);
      var $166$1=HEAP32[(($st$20$1)>>2)];
      var $st$24$0=(($sumscale)|0);
      var $167$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($sumscale+4)|0);
      var $167$1=HEAP32[(($st$24$1)>>2)];
      var $168$0 = Math.floor(((($166$0)>>>0)+((($166$1)|0)*4294967296))/((($167$0)>>>0)+((($167$1)|0)*4294967296)))>>>0; var $168$1 = Math.min(Math.floor((Math.floor(((($166$0)>>>0)+((($166$1)|0)*4294967296))/((($167$0)>>>0)+((($167$1)|0)*4294967296))))/4294967296), 4294967295);
      var $169=$r;
      var $170$0=$169;
      var $170$1=0;
      var $171$0 = ((($168$0)>>>0)+((($168$1)|0)*4294967296))*((($170$0)>>>0)+((($170$1)|0)*4294967296))>>>0; var $171$1 = Math.min(Math.floor((((($168$0)>>>0)+((($168$1)|0)*4294967296))*((($170$0)>>>0)+((($170$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$5$0=256;
      var $$emscripten$temp$5$1=0;
      var $172$0 = Math.floor(((($171$0)>>>0)+((($171$1)|0)*4294967296))/((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)))>>>0; var $172$1 = Math.min(Math.floor((Math.floor(((($171$0)>>>0)+((($171$1)|0)*4294967296))/((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$36$0=(($sumr)|0);
      HEAP32[(($st$36$0)>>2)]=$172$0;
      var $st$36$1=(($sumr+4)|0);
      HEAP32[(($st$36$1)>>2)]=$172$1;
      var $st$40$0=(($sumg)|0);
      var $173$0=HEAP32[(($st$40$0)>>2)];
      var $st$40$1=(($sumg+4)|0);
      var $173$1=HEAP32[(($st$40$1)>>2)];
      var $st$44$0=(($sumscale)|0);
      var $174$0=HEAP32[(($st$44$0)>>2)];
      var $st$44$1=(($sumscale+4)|0);
      var $174$1=HEAP32[(($st$44$1)>>2)];
      var $175$0 = Math.floor(((($173$0)>>>0)+((($173$1)|0)*4294967296))/((($174$0)>>>0)+((($174$1)|0)*4294967296)))>>>0; var $175$1 = Math.min(Math.floor((Math.floor(((($173$0)>>>0)+((($173$1)|0)*4294967296))/((($174$0)>>>0)+((($174$1)|0)*4294967296))))/4294967296), 4294967295);
      var $176=$g;
      var $177$0=$176;
      var $177$1=0;
      var $178$0 = ((($175$0)>>>0)+((($175$1)|0)*4294967296))*((($177$0)>>>0)+((($177$1)|0)*4294967296))>>>0; var $178$1 = Math.min(Math.floor((((($175$0)>>>0)+((($175$1)|0)*4294967296))*((($177$0)>>>0)+((($177$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$6$0=256;
      var $$emscripten$temp$6$1=0;
      var $179$0 = Math.floor(((($178$0)>>>0)+((($178$1)|0)*4294967296))/((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296)))>>>0; var $179$1 = Math.min(Math.floor((Math.floor(((($178$0)>>>0)+((($178$1)|0)*4294967296))/((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$56$0=(($sumg)|0);
      HEAP32[(($st$56$0)>>2)]=$179$0;
      var $st$56$1=(($sumg+4)|0);
      HEAP32[(($st$56$1)>>2)]=$179$1;
      var $st$60$0=(($sumb)|0);
      var $180$0=HEAP32[(($st$60$0)>>2)];
      var $st$60$1=(($sumb+4)|0);
      var $180$1=HEAP32[(($st$60$1)>>2)];
      var $st$64$0=(($sumscale)|0);
      var $181$0=HEAP32[(($st$64$0)>>2)];
      var $st$64$1=(($sumscale+4)|0);
      var $181$1=HEAP32[(($st$64$1)>>2)];
      var $182$0 = Math.floor(((($180$0)>>>0)+((($180$1)|0)*4294967296))/((($181$0)>>>0)+((($181$1)|0)*4294967296)))>>>0; var $182$1 = Math.min(Math.floor((Math.floor(((($180$0)>>>0)+((($180$1)|0)*4294967296))/((($181$0)>>>0)+((($181$1)|0)*4294967296))))/4294967296), 4294967295);
      var $183=$b;
      var $184$0=$183;
      var $184$1=0;
      var $185$0 = ((($182$0)>>>0)+((($182$1)|0)*4294967296))*((($184$0)>>>0)+((($184$1)|0)*4294967296))>>>0; var $185$1 = Math.min(Math.floor((((($182$0)>>>0)+((($182$1)|0)*4294967296))*((($184$0)>>>0)+((($184$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$7$0=256;
      var $$emscripten$temp$7$1=0;
      var $186$0 = Math.floor(((($185$0)>>>0)+((($185$1)|0)*4294967296))/((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296)))>>>0; var $186$1 = Math.min(Math.floor((Math.floor(((($185$0)>>>0)+((($185$1)|0)*4294967296))/((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296))))/4294967296), 4294967295);
      var $st$76$0=(($sumb)|0);
      HEAP32[(($st$76$0)>>2)]=$186$0;
      var $st$76$1=(($sumb+4)|0);
      HEAP32[(($st$76$1)>>2)]=$186$1;
      var $187=$a;
      var $188=(($187)>>>0) < 256;
      if ($188) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $189
      var $190=$y;
      var $191=$2;
      var $192=(($190*$191)|0);
      var $193=$x;
      var $194=(($192+$193)|0);
      var $195=$1;
      var $196=(($195+($194<<2))|0);
      var $197=HEAP32[(($196)>>2)];
      $dpix=$197;
      var $198=$dpix;
      var $199=$198 >>> 24;
      var $200=$199 & 255;
      var $201=$a;
      var $202=((256-$201)|0);
      var $203=(($200*$202)|0);
      var $204$0=$203;
      var $204$1=0;
      var $st$17$0=(($suma)|0);
      var $205$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($suma+4)|0);
      var $205$1=HEAP32[(($st$17$1)>>2)];
      var $206$0 = ((($205$0)>>>0)+((($205$1)|0)*4294967296))+((($204$0)>>>0)+((($204$1)|0)*4294967296))>>>0; var $206$1 = Math.min(Math.floor((((($205$0)>>>0)+((($205$1)|0)*4294967296))+((($204$0)>>>0)+((($204$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$22$0=(($suma)|0);
      HEAP32[(($st$22$0)>>2)]=$206$0;
      var $st$22$1=(($suma+4)|0);
      HEAP32[(($st$22$1)>>2)]=$206$1;
      var $207=$dpix;
      var $208=$207 >>> 16;
      var $209=$208 & 255;
      var $210=$a;
      var $211=((256-$210)|0);
      var $212=(($209*$211)|0);
      var $213$0=$212;
      var $213$1=0;
      var $st$34$0=(($sumr)|0);
      var $214$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($sumr+4)|0);
      var $214$1=HEAP32[(($st$34$1)>>2)];
      var $215$0 = ((($214$0)>>>0)+((($214$1)|0)*4294967296))+((($213$0)>>>0)+((($213$1)|0)*4294967296))>>>0; var $215$1 = Math.min(Math.floor((((($214$0)>>>0)+((($214$1)|0)*4294967296))+((($213$0)>>>0)+((($213$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$39$0=(($sumr)|0);
      HEAP32[(($st$39$0)>>2)]=$215$0;
      var $st$39$1=(($sumr+4)|0);
      HEAP32[(($st$39$1)>>2)]=$215$1;
      var $216=$dpix;
      var $217=$216 >>> 8;
      var $218=$217 & 255;
      var $219=$a;
      var $220=((256-$219)|0);
      var $221=(($218*$220)|0);
      var $222$0=$221;
      var $222$1=0;
      var $st$51$0=(($sumg)|0);
      var $223$0=HEAP32[(($st$51$0)>>2)];
      var $st$51$1=(($sumg+4)|0);
      var $223$1=HEAP32[(($st$51$1)>>2)];
      var $224$0 = ((($223$0)>>>0)+((($223$1)|0)*4294967296))+((($222$0)>>>0)+((($222$1)|0)*4294967296))>>>0; var $224$1 = Math.min(Math.floor((((($223$0)>>>0)+((($223$1)|0)*4294967296))+((($222$0)>>>0)+((($222$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$56$0=(($sumg)|0);
      HEAP32[(($st$56$0)>>2)]=$224$0;
      var $st$56$1=(($sumg+4)|0);
      HEAP32[(($st$56$1)>>2)]=$224$1;
      var $225=$dpix;
      var $226=$225 & 255;
      var $227=$a;
      var $228=((256-$227)|0);
      var $229=(($226*$228)|0);
      var $230$0=$229;
      var $230$1=0;
      var $st$67$0=(($sumb)|0);
      var $231$0=HEAP32[(($st$67$0)>>2)];
      var $st$67$1=(($sumb+4)|0);
      var $231$1=HEAP32[(($st$67$1)>>2)];
      var $232$0 = ((($231$0)>>>0)+((($231$1)|0)*4294967296))+((($230$0)>>>0)+((($230$1)|0)*4294967296))>>>0; var $232$1 = Math.min(Math.floor((((($231$0)>>>0)+((($231$1)|0)*4294967296))+((($230$0)>>>0)+((($230$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$72$0=(($sumb)|0);
      HEAP32[(($st$72$0)>>2)]=$232$0;
      var $st$72$1=(($sumb+4)|0);
      HEAP32[(($st$72$1)>>2)]=$232$1;
      __label__ = 18; break;
    case 18: // $233
      var $st$0$0=(($suma)|0);
      var $234$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($suma+4)|0);
      var $234$1=HEAP32[(($st$0$1)>>2)];
      var $235$0=$234$0;
      var $235=$235$0;
      var $236=$235 & 255;
      var $237=$236 << 24;
      var $st$8$0=(($sumr)|0);
      var $238$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($sumr+4)|0);
      var $238$1=HEAP32[(($st$8$1)>>2)];
      var $239$0=$238$0;
      var $239=$239$0;
      var $240=$239 & 255;
      var $241=$240 << 16;
      var $242=$237 | $241;
      var $st$17$0=(($sumg)|0);
      var $243$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($sumg+4)|0);
      var $243$1=HEAP32[(($st$17$1)>>2)];
      var $244$0=$243$0;
      var $244=$244$0;
      var $245=$244 & 255;
      var $246=$245 << 8;
      var $247=$242 | $246;
      var $st$26$0=(($sumb)|0);
      var $248$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($sumb+4)|0);
      var $248$1=HEAP32[(($st$26$1)>>2)];
      var $249$0=$248$0;
      var $249=$249$0;
      var $250=$249 & 255;
      var $251=$247 | $250;
      var $252=$y;
      var $253=$2;
      var $254=(($252*$253)|0);
      var $255=$x;
      var $256=(($254+$255)|0);
      var $257=$1;
      var $258=(($257+($256<<2))|0);
      HEAP32[(($258)>>2)]=$251;
      __label__ = 19; break;
    case 19: // $259
      var $260=$x;
      var $261=(($260+1)|0);
      $x=$261;
      __label__ = 3; break;
    case 20: // $262
      __label__ = 21; break;
    case 21: // $263
      var $264=$y;
      var $265=(($264+1)|0);
      $y=$265;
      __label__ = 1; break;
    case 22: // $266
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL28resample_argb_bitmap_averagePjjjjPKjjjjPK12render_colorjj["X"]=1;

function __ZL18astring_assemble_3P7astringPKcS2_S2_4092($dst, $src1, $src2, $src3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$dst;
  $2=$src1;
  $3=$src2;
  $4=$src3;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=__ZL18astring_assemble_2P7astringPKcS2_4094($5, $6, $7);
  var $9=$4;
  var $10=__ZL12astring_catcP7astringPKc4093($8, $9);
  ;
  return $10;
}


function __ZL12astring_catcP7astringPKc4093($dst, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__Z12astring_inscP7astringiPKc($3, -1, $4);
  ;
  return $5;
}


function __ZL18astring_assemble_2P7astringPKcS2_4094($dst, $src1, $src2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$dst;
  $2=$src1;
  $3=$src2;
  var $4=$1;
  var $5=$2;
  var $6=__Z12astring_cpycP7astringPKc($4, $5);
  var $7=$3;
  var $8=__ZL12astring_catcP7astringPKc4093($6, $7);
  ;
  return $8;
}


function __ZL13find_file_crcP9_zip_filePKcj($zip, $filename, $crc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $header;
      $2=$zip;
      $3=$filename;
      $4=$crc;
      var $5=$2;
      var $6=__Z19zip_file_first_fileP9_zip_file($5);
      $header=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$header;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $10
      var $11=$header;
      var $12=(($11+48)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=__Z12core_stricmpPKcS0_($13, $14);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $17
      var $18=$header;
      var $19=(($18+16)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$4;
      var $22=(($20)|0)==(($21)|0);
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$header;
      $1=$24;
      __label__ = 11; break;
    case 5: // $25
      var $26=$header;
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$4;
      var $30=(($28)|0)==(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $31
      var $32=$header;
      $1=$32;
      __label__ = 11; break;
    case 7: // $33
      __label__ = 8; break;
    case 8: // $34
      __label__ = 9; break;
    case 9: // $35
      var $36=$2;
      var $37=__Z18zip_file_next_fileP9_zip_file($36);
      $header=$37;
      __label__ = 1; break;
    case 10: // $38
      $1=0;
      __label__ = 11; break;
    case 11: // $39
      var $40=$1;
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13find_file_crcP9_zip_filePKcj["X"]=1;

function __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($dest, $drowpixels, $dwidth, $dheight, $source, $orig_sbounds, $color) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $swidth;
      var $sheight;
      var $sbase;
      var $sbounds=__stackBase__;
      var $dx;
      var $dy;
      $1=$dest;
      $2=$drowpixels;
      $3=$dwidth;
      $4=$dheight;
      $5=$source;
      $6=$orig_sbounds;
      $7=$color;
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$4;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      __label__ = 10; break;
    case 3: // $14
      var $15=$6;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$6;
      var $19=$sbounds;
      var $20=$18;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[(($20+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[(($20+8)>>2)];HEAP32[(($19+12)>>2)]=HEAP32[(($20+12)>>2)];
      __label__ = 6; break;
    case 5: // $21
      var $22=(($sbounds+8)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($sbounds)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=$5;
      var $25=$24;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($sbounds+4)|0);
      HEAP32[(($28)>>2)]=$27;
      var $29=$5;
      var $30=$29;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($sbounds+12)|0);
      HEAP32[(($33)>>2)]=$32;
      __label__ = 6; break;
    case 6: // $34
      var $35=$5;
      var $36=$35;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38;
      var $40=(($sbounds+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$5;
      var $43=$42;
      var $44=(($43+8)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($41*$45)|0);
      var $47=(($39+($46<<2))|0);
      var $48=(($sbounds)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($47+($49<<2))|0);
      $sbase=$50;
      var $51=(($sbounds+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($sbounds)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($52-$54)|0);
      $swidth=$55;
      var $56=(($sbounds+12)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($sbounds+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($57-$59)|0);
      $sheight=$60;
      var $61=$swidth;
      var $62=$61 << 12;
      var $63=$3;
      var $64=Math.floor((($62)>>>0)/(($63)>>>0));
      $dx=$64;
      var $65=$sheight;
      var $66=$65 << 12;
      var $67=$4;
      var $68=Math.floor((($66)>>>0)/(($67)>>>0));
      $dy=$68;
      var $69=$dx;
      var $70=(($69)>>>0) > 4096;
      if ($70) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $71
      var $72=$dy;
      var $73=(($72)>>>0) > 4096;
      if ($73) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $74
      var $75=$1;
      var $76=$75;
      var $77=$2;
      var $78=$3;
      var $79=$4;
      var $80=$sbase;
      var $81=$5;
      var $82=$81;
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$swidth;
      var $86=$sheight;
      var $87=$7;
      var $88=$dx;
      var $89=$dy;
      __ZL28resample_argb_bitmap_averagePjjjjPKjjjjPK12render_colorjj($76, $77, $78, $79, $80, $84, $85, $86, $87, $88, $89);
      __label__ = 10; break;
    case 9: // $90
      var $91=$1;
      var $92=$91;
      var $93=$2;
      var $94=$3;
      var $95=$4;
      var $96=$sbase;
      var $97=$5;
      var $98=$97;
      var $99=(($98+8)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$swidth;
      var $102=$sheight;
      var $103=$7;
      var $104=$dx;
      var $105=$dy;
      __ZL29resample_argb_bitmap_bilinearPjjjjPKjjjjPK12render_colorjj($92, $93, $94, $95, $96, $100, $101, $102, $103, $104, $105);
      __label__ = 10; break;
    case 10: // $106
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color["X"]=1;

function __ZL17load_ram_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource($options, $state, $resource_node, $resource) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $length_string;
      var $ram_type;
      var $ram_filename;
      var $ram_pathname;
      var $tmp=__stackBase__;
      var $6;
      var $7;
      var $8;
      $2=$options;
      $3=$state;
      $4=$resource_node;
      $5=$resource;
      var $9=$4;
      var $10=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($9, ((STRING_TABLE.__str74074)|0), 0);
      $length_string=$10;
      var $11=$length_string;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=7;
      __label__ = 24; break;
    case 2: // $14
      var $15=$length_string;
      var $16=__Z16ram_parse_stringPKc($15);
      var $17=$5;
      var $18=(($17+16)|0);
      HEAP32[(($18)>>2)]=$16;
      var $19=$5;
      var $20=(($19+16)|0);
      var $21=HEAPU32[(($20)>>2)];
      var $22=(($21)>>>0) <= 0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      $1=8;
      __label__ = 24; break;
    case 4: // $24
      var $25=$3;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$5;
      var $33=(($32+16)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__Z21pool_malloc_file_lineP12_object_pooljPKci($31, $34, ((STRING_TABLE.__str4067)|0), 236);
      var $36=$5;
      var $37=(($36+20)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$5;
      var $39=(($38+20)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      $1=3;
      __label__ = 24; break;
    case 6: // $43
      var $44=$4;
      var $45=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($44, ((STRING_TABLE.__str24069)|0), 0);
      $ram_type=$45;
      var $46=$ram_type;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 7; break; } else { __label__ = 23; break; }
    case 7: // $48
      var $49=$ram_type;
      var $50=_strcmp($49, ((STRING_TABLE.__str84075)|0));
      var $51=(($50)|0)==0;
      if ($51) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $52
      __ZN7astringC1Ev($tmp);
      var $53=$4;
      var $54=(function() { try { __THREW__ = false; return __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($53, ((STRING_TABLE.__str94076)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $55
      $ram_filename=$54;
      var $56=$ram_filename;
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $58
      $1=4;
      $8=1;
      __label__ = 19; break;
    case 11: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      $6=$61;
      var $62=$60.f1;
      $7=$62;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tmp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 12: // $63
      var $64=$3;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+12)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$ram_filename;
      var $70=(function() { try { __THREW__ = false; return __ZL18astring_assemble_3P7astringPKcS2_S2_4092($tmp, $68, ((STRING_TABLE.__str104077)|0), $69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 11; break; };
    case 13: // $71
      $ram_pathname=$70;
      var $72=$3;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+16)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$ram_pathname;
      var $80=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; };
    case 14: // $81
      var $82=(function() { try { __THREW__ = false; return __Z21pool_strdup_file_lineP12_object_poolPKcS2_i($78, $80, ((STRING_TABLE.__str4067)|0), 257) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $83
      var $84=$5;
      var $85=(($84+4)|0);
      HEAP32[(($85)>>2)]=$82;
      var $86=$5;
      var $87=(($86+4)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $90
      $1=3;
      $8=1;
      __label__ = 19; break;
    case 17: // $91
      var $92=$2;
      var $93=$5;
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$5;
      var $97=(($96+20)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$5;
      var $100=(($99+16)|0);
      var $101=HEAP32[(($100)>>2)];
      (function() { try { __THREW__ = false; return __Z26image_battery_load_by_nameR11emu_optionsPKcPvii($92, $95, $98, $101, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 11; break; }
    case 18: // $102
      $8=0;
      __label__ = 19; break;
    case 19: // $103
      FUNCTION_TABLE[__ZN7astringD1Ev]($tmp);
      var $cleanup_dest=$8;
      if ($cleanup_dest == 0) {
        __label__ = 20; break;
      }
      else if ($cleanup_dest == 1) {
        __label__ = 24; break;
      }
      else {
      __label__ = 27; break;
      }
      
    case 20: // $104
      __label__ = 22; break;
    case 21: // $105
      __label__ = 25; break;
    case 22: // $106
      __label__ = 23; break;
    case 23: // $107
      $1=0;
      __label__ = 24; break;
    case 24: // $108
      var $109=$1;
      STACKTOP = __stackBase__;
      return $109;
    case 25: // $110
      var $111=$6;
      var $112=$6;
      var $113=$7;
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 27: // $118
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17load_ram_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource["X"]=1;

function __ZL29resample_argb_bitmap_bilinearPjjjjPKjjjjPK12render_colorjj($dest, $drowpixels, $dwidth, $dheight, $source, $srowpixels, $swidth, $sheight, $color, $dx, $dy) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $maxx;
      var $maxy;
      var $r;
      var $g;
      var $b;
      var $a;
      var $x;
      var $y;
      var $starty;
      var $startx;
      var $pix0;
      var $pix1;
      var $pix2;
      var $pix3;
      var $sumr;
      var $sumg;
      var $sumb;
      var $suma;
      var $nextx;
      var $nexty;
      var $curx;
      var $cury;
      var $factor;
      var $dpix;
      $1=$dest;
      $2=$drowpixels;
      $3=$dwidth;
      $4=$dheight;
      $5=$source;
      $6=$srowpixels;
      $7=$swidth;
      $8=$sheight;
      $9=$color;
      $10=$dx;
      $11=$dy;
      var $12=$7;
      var $13=$12 << 12;
      $maxx=$13;
      var $14=$8;
      var $15=$14 << 12;
      $maxy=$15;
      var $16=$9;
      var $17=(($16+4)|0);
      var $18=HEAPF32[(($17)>>2)];
      var $19=$9;
      var $20=(($19)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$18*$21;
      var $23=$22;
      var $24=$23*256;
      var $25=($24 >= 0 ? Math.floor($24) : Math.ceil($24));
      $r=$25;
      var $26=$9;
      var $27=(($26+8)|0);
      var $28=HEAPF32[(($27)>>2)];
      var $29=$9;
      var $30=(($29)|0);
      var $31=HEAPF32[(($30)>>2)];
      var $32=$28*$31;
      var $33=$32;
      var $34=$33*256;
      var $35=($34 >= 0 ? Math.floor($34) : Math.ceil($34));
      $g=$35;
      var $36=$9;
      var $37=(($36+12)|0);
      var $38=HEAPF32[(($37)>>2)];
      var $39=$9;
      var $40=(($39)|0);
      var $41=HEAPF32[(($40)>>2)];
      var $42=$38*$41;
      var $43=$42;
      var $44=$43*256;
      var $45=($44 >= 0 ? Math.floor($44) : Math.ceil($44));
      $b=$45;
      var $46=$9;
      var $47=(($46)|0);
      var $48=HEAPF32[(($47)>>2)];
      var $49=$48;
      var $50=$49*256;
      var $51=($50 >= 0 ? Math.floor($50) : Math.ceil($50));
      $a=$51;
      $y=0;
      __label__ = 1; break;
    case 1: // $52
      var $53=$y;
      var $54=$4;
      var $55=(($53)>>>0) < (($54)>>>0);
      if ($55) { __label__ = 2; break; } else { __label__ = 30; break; }
    case 2: // $56
      var $57=$y;
      var $58=$11;
      var $59=(($57*$58)|0);
      $starty=$59;
      $x=0;
      __label__ = 3; break;
    case 3: // $60
      var $61=$x;
      var $62=$3;
      var $63=(($61)>>>0) < (($62)>>>0);
      if ($63) { __label__ = 4; break; } else { __label__ = 28; break; }
    case 4: // $64
      var $65=$x;
      var $66=$10;
      var $67=(($65*$66)|0);
      $startx=$67;
      var $68=$startx;
      var $69=$10;
      var $70=Math.floor((($69)>>>0)/2);
      var $71=(($68+$70)|0);
      var $72=(($71-2048)|0);
      $curx=$72;
      var $73=$starty;
      var $74=$11;
      var $75=Math.floor((($74)>>>0)/2);
      var $76=(($73+$75)|0);
      var $77=(($76-2048)|0);
      $cury=$77;
      var $78=$curx;
      var $79=(($78+4096)|0);
      $nextx=$79;
      var $80=$cury;
      var $81=(($80+4096)|0);
      $nexty=$81;
      $pix3=0;
      $pix2=0;
      $pix1=0;
      $pix0=0;
      var $82=$cury;
      var $83=(($82)|0) >= 0;
      if ($83) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $84
      var $85=$cury;
      var $86=$maxy;
      var $87=(($85)>>>0) < (($86)>>>0);
      if ($87) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $88
      var $89=$curx;
      var $90=(($89)|0) >= 0;
      if ($90) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $91
      var $92=$curx;
      var $93=$maxx;
      var $94=(($92)>>>0) < (($93)>>>0);
      if ($94) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $95
      var $96=$cury;
      var $97=$96 >>> 12;
      var $98=$6;
      var $99=(($97*$98)|0);
      var $100=$curx;
      var $101=$100 >>> 12;
      var $102=(($99+$101)|0);
      var $103=$5;
      var $104=(($103+($102<<2))|0);
      var $105=HEAP32[(($104)>>2)];
      $pix0=$105;
      __label__ = 9; break;
    case 9: // $106
      var $107=$cury;
      var $108=(($107)|0) >= 0;
      if ($108) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $109
      var $110=$cury;
      var $111=$maxy;
      var $112=(($110)>>>0) < (($111)>>>0);
      if ($112) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $113
      var $114=$nextx;
      var $115=(($114)|0) >= 0;
      if ($115) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $116
      var $117=$nextx;
      var $118=$maxx;
      var $119=(($117)>>>0) < (($118)>>>0);
      if ($119) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $120
      var $121=$cury;
      var $122=$121 >>> 12;
      var $123=$6;
      var $124=(($122*$123)|0);
      var $125=$nextx;
      var $126=$125 >>> 12;
      var $127=(($124+$126)|0);
      var $128=$5;
      var $129=(($128+($127<<2))|0);
      var $130=HEAP32[(($129)>>2)];
      $pix1=$130;
      __label__ = 14; break;
    case 14: // $131
      var $132=$nexty;
      var $133=(($132)|0) >= 0;
      if ($133) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $134
      var $135=$nexty;
      var $136=$maxy;
      var $137=(($135)>>>0) < (($136)>>>0);
      if ($137) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $138
      var $139=$curx;
      var $140=(($139)|0) >= 0;
      if ($140) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $141
      var $142=$curx;
      var $143=$maxx;
      var $144=(($142)>>>0) < (($143)>>>0);
      if ($144) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $145
      var $146=$nexty;
      var $147=$146 >>> 12;
      var $148=$6;
      var $149=(($147*$148)|0);
      var $150=$curx;
      var $151=$150 >>> 12;
      var $152=(($149+$151)|0);
      var $153=$5;
      var $154=(($153+($152<<2))|0);
      var $155=HEAP32[(($154)>>2)];
      $pix2=$155;
      __label__ = 19; break;
    case 19: // $156
      var $157=$nexty;
      var $158=(($157)|0) >= 0;
      if ($158) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $159
      var $160=$nexty;
      var $161=$maxy;
      var $162=(($160)>>>0) < (($161)>>>0);
      if ($162) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $163
      var $164=$nextx;
      var $165=(($164)|0) >= 0;
      if ($165) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $166
      var $167=$nextx;
      var $168=$maxx;
      var $169=(($167)>>>0) < (($168)>>>0);
      if ($169) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $170
      var $171=$nexty;
      var $172=$171 >>> 12;
      var $173=$6;
      var $174=(($172*$173)|0);
      var $175=$nextx;
      var $176=$175 >>> 12;
      var $177=(($174+$176)|0);
      var $178=$5;
      var $179=(($178+($177<<2))|0);
      var $180=HEAP32[(($179)>>2)];
      $pix3=$180;
      __label__ = 24; break;
    case 24: // $181
      var $182=$curx;
      var $183=$182 & 4095;
      $curx=$183;
      var $184=$cury;
      var $185=$184 & 4095;
      $cury=$185;
      var $186=$curx;
      var $187=((4096-$186)|0);
      var $188=$cury;
      var $189=((4096-$188)|0);
      var $190=(($187*$189)|0);
      $factor=$190;
      var $191=$factor;
      var $192=$pix0;
      var $193=$192 >>> 16;
      var $194=$193 & 255;
      var $195=(($191*$194)|0);
      $sumr=$195;
      var $196=$factor;
      var $197=$pix0;
      var $198=$197 >>> 8;
      var $199=$198 & 255;
      var $200=(($196*$199)|0);
      $sumg=$200;
      var $201=$factor;
      var $202=$pix0;
      var $203=$202 & 255;
      var $204=(($201*$203)|0);
      $sumb=$204;
      var $205=$factor;
      var $206=$pix0;
      var $207=$206 >>> 24;
      var $208=$207 & 255;
      var $209=(($205*$208)|0);
      $suma=$209;
      var $210=$curx;
      var $211=$cury;
      var $212=((4096-$211)|0);
      var $213=(($210*$212)|0);
      $factor=$213;
      var $214=$factor;
      var $215=$pix1;
      var $216=$215 >>> 16;
      var $217=$216 & 255;
      var $218=(($214*$217)|0);
      var $219=$sumr;
      var $220=(($219+$218)|0);
      $sumr=$220;
      var $221=$factor;
      var $222=$pix1;
      var $223=$222 >>> 8;
      var $224=$223 & 255;
      var $225=(($221*$224)|0);
      var $226=$sumg;
      var $227=(($226+$225)|0);
      $sumg=$227;
      var $228=$factor;
      var $229=$pix1;
      var $230=$229 & 255;
      var $231=(($228*$230)|0);
      var $232=$sumb;
      var $233=(($232+$231)|0);
      $sumb=$233;
      var $234=$factor;
      var $235=$pix1;
      var $236=$235 >>> 24;
      var $237=$236 & 255;
      var $238=(($234*$237)|0);
      var $239=$suma;
      var $240=(($239+$238)|0);
      $suma=$240;
      var $241=$curx;
      var $242=((4096-$241)|0);
      var $243=$cury;
      var $244=(($242*$243)|0);
      $factor=$244;
      var $245=$factor;
      var $246=$pix2;
      var $247=$246 >>> 16;
      var $248=$247 & 255;
      var $249=(($245*$248)|0);
      var $250=$sumr;
      var $251=(($250+$249)|0);
      $sumr=$251;
      var $252=$factor;
      var $253=$pix2;
      var $254=$253 >>> 8;
      var $255=$254 & 255;
      var $256=(($252*$255)|0);
      var $257=$sumg;
      var $258=(($257+$256)|0);
      $sumg=$258;
      var $259=$factor;
      var $260=$pix2;
      var $261=$260 & 255;
      var $262=(($259*$261)|0);
      var $263=$sumb;
      var $264=(($263+$262)|0);
      $sumb=$264;
      var $265=$factor;
      var $266=$pix2;
      var $267=$266 >>> 24;
      var $268=$267 & 255;
      var $269=(($265*$268)|0);
      var $270=$suma;
      var $271=(($270+$269)|0);
      $suma=$271;
      var $272=$curx;
      var $273=$cury;
      var $274=(($272*$273)|0);
      $factor=$274;
      var $275=$factor;
      var $276=$pix3;
      var $277=$276 >>> 16;
      var $278=$277 & 255;
      var $279=(($275*$278)|0);
      var $280=$sumr;
      var $281=(($280+$279)|0);
      $sumr=$281;
      var $282=$factor;
      var $283=$pix3;
      var $284=$283 >>> 8;
      var $285=$284 & 255;
      var $286=(($282*$285)|0);
      var $287=$sumg;
      var $288=(($287+$286)|0);
      $sumg=$288;
      var $289=$factor;
      var $290=$pix3;
      var $291=$290 & 255;
      var $292=(($289*$291)|0);
      var $293=$sumb;
      var $294=(($293+$292)|0);
      $sumb=$294;
      var $295=$factor;
      var $296=$pix3;
      var $297=$296 >>> 24;
      var $298=$297 & 255;
      var $299=(($295*$298)|0);
      var $300=$suma;
      var $301=(($300+$299)|0);
      $suma=$301;
      var $302=$suma;
      var $303=$302 >>> 24;
      var $304=$a;
      var $305=(($303*$304)|0);
      var $306=Math.floor((($305)>>>0)/256);
      $suma=$306;
      var $307=$sumr;
      var $308=$307 >>> 24;
      var $309=$r;
      var $310=(($308*$309)|0);
      var $311=Math.floor((($310)>>>0)/256);
      $sumr=$311;
      var $312=$sumg;
      var $313=$312 >>> 24;
      var $314=$g;
      var $315=(($313*$314)|0);
      var $316=Math.floor((($315)>>>0)/256);
      $sumg=$316;
      var $317=$sumb;
      var $318=$317 >>> 24;
      var $319=$b;
      var $320=(($318*$319)|0);
      var $321=Math.floor((($320)>>>0)/256);
      $sumb=$321;
      var $322=$a;
      var $323=(($322)>>>0) < 256;
      if ($323) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $324
      var $325=$y;
      var $326=$2;
      var $327=(($325*$326)|0);
      var $328=$x;
      var $329=(($327+$328)|0);
      var $330=$1;
      var $331=(($330+($329<<2))|0);
      var $332=HEAP32[(($331)>>2)];
      $dpix=$332;
      var $333=$dpix;
      var $334=$333 >>> 24;
      var $335=$334 & 255;
      var $336=$a;
      var $337=((256-$336)|0);
      var $338=(($335*$337)|0);
      var $339=$suma;
      var $340=(($339+$338)|0);
      $suma=$340;
      var $341=$dpix;
      var $342=$341 >>> 16;
      var $343=$342 & 255;
      var $344=$a;
      var $345=((256-$344)|0);
      var $346=(($343*$345)|0);
      var $347=$sumr;
      var $348=(($347+$346)|0);
      $sumr=$348;
      var $349=$dpix;
      var $350=$349 >>> 8;
      var $351=$350 & 255;
      var $352=$a;
      var $353=((256-$352)|0);
      var $354=(($351*$353)|0);
      var $355=$sumg;
      var $356=(($355+$354)|0);
      $sumg=$356;
      var $357=$dpix;
      var $358=$357 & 255;
      var $359=$a;
      var $360=((256-$359)|0);
      var $361=(($358*$360)|0);
      var $362=$sumb;
      var $363=(($362+$361)|0);
      $sumb=$363;
      __label__ = 26; break;
    case 26: // $364
      var $365=$suma;
      var $366=$365 & 255;
      var $367=$366 << 24;
      var $368=$sumr;
      var $369=$368 & 255;
      var $370=$369 << 16;
      var $371=$367 | $370;
      var $372=$sumg;
      var $373=$372 & 255;
      var $374=$373 << 8;
      var $375=$371 | $374;
      var $376=$sumb;
      var $377=$376 & 255;
      var $378=$375 | $377;
      var $379=$y;
      var $380=$2;
      var $381=(($379*$380)|0);
      var $382=$x;
      var $383=(($381+$382)|0);
      var $384=$1;
      var $385=(($384+($383<<2))|0);
      HEAP32[(($385)>>2)]=$378;
      __label__ = 27; break;
    case 27: // $386
      var $387=$x;
      var $388=(($387+1)|0);
      $x=$388;
      __label__ = 3; break;
    case 28: // $389
      __label__ = 29; break;
    case 29: // $390
      var $391=$y;
      var $392=(($391+1)|0);
      $y=$392;
      __label__ = 1; break;
    case 30: // $393
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29resample_argb_bitmap_bilinearPjjjjPKjjjjPK12render_colorjj["X"]=1;

function __Z16render_clip_lineP13render_boundsPKS_($bounds, $clip) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $code0;
      var $code1;
      var $thiscode;
      var $x;
      var $y;
      $2=$bounds;
      $3=$clip;
      __label__ = 1; break;
    case 1: // $4
      $code0=0;
      $code1=0;
      var $5=$2;
      var $6=(($5+4)|0);
      var $7=HEAPF32[(($6)>>2)];
      var $8=$3;
      var $9=(($8+12)|0);
      var $10=HEAPF32[(($9)>>2)];
      var $11=$7 > $10;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$code0;
      var $14=(($13)&255);
      var $15=$14 | 1;
      var $16=(($15) & 255);
      $code0=$16;
      __label__ = 3; break;
    case 3: // $17
      var $18=$2;
      var $19=(($18+4)|0);
      var $20=HEAPF32[(($19)>>2)];
      var $21=$3;
      var $22=(($21+4)|0);
      var $23=HEAPF32[(($22)>>2)];
      var $24=$20 < $23;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      var $26=$code0;
      var $27=(($26)&255);
      var $28=$27 | 2;
      var $29=(($28) & 255);
      $code0=$29;
      __label__ = 5; break;
    case 5: // $30
      var $31=$2;
      var $32=(($31)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$3;
      var $35=(($34+8)|0);
      var $36=HEAPF32[(($35)>>2)];
      var $37=$33 > $36;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      var $39=$code0;
      var $40=(($39)&255);
      var $41=$40 | 4;
      var $42=(($41) & 255);
      $code0=$42;
      __label__ = 7; break;
    case 7: // $43
      var $44=$2;
      var $45=(($44)|0);
      var $46=HEAPF32[(($45)>>2)];
      var $47=$3;
      var $48=(($47)|0);
      var $49=HEAPF32[(($48)>>2)];
      var $50=$46 < $49;
      if ($50) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $51
      var $52=$code0;
      var $53=(($52)&255);
      var $54=$53 | 8;
      var $55=(($54) & 255);
      $code0=$55;
      __label__ = 9; break;
    case 9: // $56
      var $57=$2;
      var $58=(($57+12)|0);
      var $59=HEAPF32[(($58)>>2)];
      var $60=$3;
      var $61=(($60+12)|0);
      var $62=HEAPF32[(($61)>>2)];
      var $63=$59 > $62;
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      var $65=$code1;
      var $66=(($65)&255);
      var $67=$66 | 1;
      var $68=(($67) & 255);
      $code1=$68;
      __label__ = 11; break;
    case 11: // $69
      var $70=$2;
      var $71=(($70+12)|0);
      var $72=HEAPF32[(($71)>>2)];
      var $73=$3;
      var $74=(($73+4)|0);
      var $75=HEAPF32[(($74)>>2)];
      var $76=$72 < $75;
      if ($76) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $77
      var $78=$code1;
      var $79=(($78)&255);
      var $80=$79 | 2;
      var $81=(($80) & 255);
      $code1=$81;
      __label__ = 13; break;
    case 13: // $82
      var $83=$2;
      var $84=(($83+8)|0);
      var $85=HEAPF32[(($84)>>2)];
      var $86=$3;
      var $87=(($86+8)|0);
      var $88=HEAPF32[(($87)>>2)];
      var $89=$85 > $88;
      if ($89) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $90
      var $91=$code1;
      var $92=(($91)&255);
      var $93=$92 | 4;
      var $94=(($93) & 255);
      $code1=$94;
      __label__ = 15; break;
    case 15: // $95
      var $96=$2;
      var $97=(($96+8)|0);
      var $98=HEAPF32[(($97)>>2)];
      var $99=$3;
      var $100=(($99)|0);
      var $101=HEAPF32[(($100)>>2)];
      var $102=$98 < $101;
      if ($102) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $103
      var $104=$code1;
      var $105=(($104)&255);
      var $106=$105 | 8;
      var $107=(($106) & 255);
      $code1=$107;
      __label__ = 17; break;
    case 17: // $108
      var $109=$code0;
      var $110=(($109)&255);
      var $111=$code1;
      var $112=(($111)&255);
      var $113=$110 | $112;
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $115
      $1=0;
      __label__ = 34; break;
    case 19: // $116
      var $117=$code0;
      var $118=(($117)&255);
      var $119=$code1;
      var $120=(($119)&255);
      var $121=$118 & $120;
      var $122=(($121)|0)!=0;
      if ($122) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $123
      $1=1;
      __label__ = 34; break;
    case 21: // $124
      var $125=$code0;
      var $126=(($125 << 24) >> 24)!=0;
      var $127=$code0;
      var $128=$code1;
      var $129=$126 ? $127 : $128;
      $thiscode=$129;
      var $130=$thiscode;
      var $131=(($130)&255);
      var $132=$131 & 1;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $134
      var $135=$2;
      var $136=(($135)|0);
      var $137=HEAPF32[(($136)>>2)];
      var $138=$2;
      var $139=(($138+8)|0);
      var $140=HEAPF32[(($139)>>2)];
      var $141=$2;
      var $142=(($141)|0);
      var $143=HEAPF32[(($142)>>2)];
      var $144=$140-$143;
      var $145=$3;
      var $146=(($145+12)|0);
      var $147=HEAPF32[(($146)>>2)];
      var $148=$2;
      var $149=(($148+4)|0);
      var $150=HEAPF32[(($149)>>2)];
      var $151=$147-$150;
      var $152=$144*$151;
      var $153=$2;
      var $154=(($153+12)|0);
      var $155=HEAPF32[(($154)>>2)];
      var $156=$2;
      var $157=(($156+4)|0);
      var $158=HEAPF32[(($157)>>2)];
      var $159=$155-$158;
      var $160=$152/$159;
      var $161=$137+$160;
      $x=$161;
      var $162=$3;
      var $163=(($162+12)|0);
      var $164=HEAPF32[(($163)>>2)];
      $y=$164;
      __label__ = 30; break;
    case 23: // $165
      var $166=$thiscode;
      var $167=(($166)&255);
      var $168=$167 & 2;
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $170
      var $171=$2;
      var $172=(($171)|0);
      var $173=HEAPF32[(($172)>>2)];
      var $174=$2;
      var $175=(($174+8)|0);
      var $176=HEAPF32[(($175)>>2)];
      var $177=$2;
      var $178=(($177)|0);
      var $179=HEAPF32[(($178)>>2)];
      var $180=$176-$179;
      var $181=$3;
      var $182=(($181+4)|0);
      var $183=HEAPF32[(($182)>>2)];
      var $184=$2;
      var $185=(($184+4)|0);
      var $186=HEAPF32[(($185)>>2)];
      var $187=$183-$186;
      var $188=$180*$187;
      var $189=$2;
      var $190=(($189+12)|0);
      var $191=HEAPF32[(($190)>>2)];
      var $192=$2;
      var $193=(($192+4)|0);
      var $194=HEAPF32[(($193)>>2)];
      var $195=$191-$194;
      var $196=$188/$195;
      var $197=$173+$196;
      $x=$197;
      var $198=$3;
      var $199=(($198+4)|0);
      var $200=HEAPF32[(($199)>>2)];
      $y=$200;
      __label__ = 29; break;
    case 25: // $201
      var $202=$thiscode;
      var $203=(($202)&255);
      var $204=$203 & 4;
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $206
      var $207=$2;
      var $208=(($207+4)|0);
      var $209=HEAPF32[(($208)>>2)];
      var $210=$2;
      var $211=(($210+12)|0);
      var $212=HEAPF32[(($211)>>2)];
      var $213=$2;
      var $214=(($213+4)|0);
      var $215=HEAPF32[(($214)>>2)];
      var $216=$212-$215;
      var $217=$3;
      var $218=(($217+8)|0);
      var $219=HEAPF32[(($218)>>2)];
      var $220=$2;
      var $221=(($220)|0);
      var $222=HEAPF32[(($221)>>2)];
      var $223=$219-$222;
      var $224=$216*$223;
      var $225=$2;
      var $226=(($225+8)|0);
      var $227=HEAPF32[(($226)>>2)];
      var $228=$2;
      var $229=(($228)|0);
      var $230=HEAPF32[(($229)>>2)];
      var $231=$227-$230;
      var $232=$224/$231;
      var $233=$209+$232;
      $y=$233;
      var $234=$3;
      var $235=(($234+8)|0);
      var $236=HEAPF32[(($235)>>2)];
      $x=$236;
      __label__ = 28; break;
    case 27: // $237
      var $238=$2;
      var $239=(($238+4)|0);
      var $240=HEAPF32[(($239)>>2)];
      var $241=$2;
      var $242=(($241+12)|0);
      var $243=HEAPF32[(($242)>>2)];
      var $244=$2;
      var $245=(($244+4)|0);
      var $246=HEAPF32[(($245)>>2)];
      var $247=$243-$246;
      var $248=$3;
      var $249=(($248)|0);
      var $250=HEAPF32[(($249)>>2)];
      var $251=$2;
      var $252=(($251)|0);
      var $253=HEAPF32[(($252)>>2)];
      var $254=$250-$253;
      var $255=$247*$254;
      var $256=$2;
      var $257=(($256+8)|0);
      var $258=HEAPF32[(($257)>>2)];
      var $259=$2;
      var $260=(($259)|0);
      var $261=HEAPF32[(($260)>>2)];
      var $262=$258-$261;
      var $263=$255/$262;
      var $264=$240+$263;
      $y=$264;
      var $265=$3;
      var $266=(($265)|0);
      var $267=HEAPF32[(($266)>>2)];
      $x=$267;
      __label__ = 28; break;
    case 28: // $268
      __label__ = 29; break;
    case 29: // $269
      __label__ = 30; break;
    case 30: // $270
      var $271=$thiscode;
      var $272=(($271)&255);
      var $273=$code0;
      var $274=(($273)&255);
      var $275=(($272)|0)==(($274)|0);
      if ($275) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $276
      var $277=$x;
      var $278=$2;
      var $279=(($278)|0);
      HEAPF32[(($279)>>2)]=$277;
      var $280=$y;
      var $281=$2;
      var $282=(($281+4)|0);
      HEAPF32[(($282)>>2)]=$280;
      __label__ = 33; break;
    case 32: // $283
      var $284=$x;
      var $285=$2;
      var $286=(($285+8)|0);
      HEAPF32[(($286)>>2)]=$284;
      var $287=$y;
      var $288=$2;
      var $289=(($288+12)|0);
      HEAPF32[(($289)>>2)]=$287;
      __label__ = 33; break;
    case 33: // $290
      __label__ = 1; break;
    case 34: // $291
      var $292=$1;
      ;
      return $292;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16render_clip_lineP13render_boundsPKS_["X"]=1;

function __Z16render_clip_quadP13render_boundsPKS_P17render_quad_texuv($bounds, $clip, $texcoords) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $frac;
      var $frac1;
      var $frac2;
      var $frac3;
      $2=$bounds;
      $3=$clip;
      $4=$texcoords;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      __label__ = 3; break;
    case 3: // $7
      __label__ = 4; break;
    case 4: // $8
      var $9=$2;
      var $10=(($9+12)|0);
      var $11=HEAPF32[(($10)>>2)];
      var $12=$3;
      var $13=(($12+4)|0);
      var $14=HEAPF32[(($13)>>2)];
      var $15=$11 < $14;
      if ($15) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $16
      $1=1;
      __label__ = 29; break;
    case 6: // $17
      var $18=$2;
      var $19=(($18+4)|0);
      var $20=HEAPF32[(($19)>>2)];
      var $21=$3;
      var $22=(($21+12)|0);
      var $23=HEAPF32[(($22)>>2)];
      var $24=$20 > $23;
      if ($24) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $25
      $1=1;
      __label__ = 29; break;
    case 8: // $26
      var $27=$2;
      var $28=(($27+8)|0);
      var $29=HEAPF32[(($28)>>2)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAPF32[(($31)>>2)];
      var $33=$29 < $32;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      $1=1;
      __label__ = 29; break;
    case 10: // $35
      var $36=$2;
      var $37=(($36)|0);
      var $38=HEAPF32[(($37)>>2)];
      var $39=$3;
      var $40=(($39+8)|0);
      var $41=HEAPF32[(($40)>>2)];
      var $42=$38 > $41;
      if ($42) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $43
      $1=1;
      __label__ = 29; break;
    case 12: // $44
      var $45=$2;
      var $46=(($45+4)|0);
      var $47=HEAPF32[(($46)>>2)];
      var $48=$3;
      var $49=(($48+4)|0);
      var $50=HEAPF32[(($49)>>2)];
      var $51=$47 < $50;
      if ($51) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $52
      var $53=$3;
      var $54=(($53+4)|0);
      var $55=HEAPF32[(($54)>>2)];
      var $56=$2;
      var $57=(($56+4)|0);
      var $58=HEAPF32[(($57)>>2)];
      var $59=$55-$58;
      var $60=$2;
      var $61=(($60+12)|0);
      var $62=HEAPF32[(($61)>>2)];
      var $63=$2;
      var $64=(($63+4)|0);
      var $65=HEAPF32[(($64)>>2)];
      var $66=$62-$65;
      var $67=$59/$66;
      $frac=$67;
      var $68=$3;
      var $69=(($68+4)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $71=$2;
      var $72=(($71+4)|0);
      HEAPF32[(($72)>>2)]=$70;
      var $73=$4;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $75
      var $76=$4;
      var $77=(($76+16)|0);
      var $78=(($77)|0);
      var $79=HEAPF32[(($78)>>2)];
      var $80=$4;
      var $81=(($80)|0);
      var $82=(($81)|0);
      var $83=HEAPF32[(($82)>>2)];
      var $84=$79-$83;
      var $85=$frac;
      var $86=$84*$85;
      var $87=$4;
      var $88=(($87)|0);
      var $89=(($88)|0);
      var $90=HEAPF32[(($89)>>2)];
      var $91=$90+$86;
      HEAPF32[(($89)>>2)]=$91;
      var $92=$4;
      var $93=(($92+16)|0);
      var $94=(($93+4)|0);
      var $95=HEAPF32[(($94)>>2)];
      var $96=$4;
      var $97=(($96)|0);
      var $98=(($97+4)|0);
      var $99=HEAPF32[(($98)>>2)];
      var $100=$95-$99;
      var $101=$frac;
      var $102=$100*$101;
      var $103=$4;
      var $104=(($103)|0);
      var $105=(($104+4)|0);
      var $106=HEAPF32[(($105)>>2)];
      var $107=$106+$102;
      HEAPF32[(($105)>>2)]=$107;
      var $108=$4;
      var $109=(($108+24)|0);
      var $110=(($109)|0);
      var $111=HEAPF32[(($110)>>2)];
      var $112=$4;
      var $113=(($112+8)|0);
      var $114=(($113)|0);
      var $115=HEAPF32[(($114)>>2)];
      var $116=$111-$115;
      var $117=$frac;
      var $118=$116*$117;
      var $119=$4;
      var $120=(($119+8)|0);
      var $121=(($120)|0);
      var $122=HEAPF32[(($121)>>2)];
      var $123=$122+$118;
      HEAPF32[(($121)>>2)]=$123;
      var $124=$4;
      var $125=(($124+24)|0);
      var $126=(($125+4)|0);
      var $127=HEAPF32[(($126)>>2)];
      var $128=$4;
      var $129=(($128+8)|0);
      var $130=(($129+4)|0);
      var $131=HEAPF32[(($130)>>2)];
      var $132=$127-$131;
      var $133=$frac;
      var $134=$132*$133;
      var $135=$4;
      var $136=(($135+8)|0);
      var $137=(($136+4)|0);
      var $138=HEAPF32[(($137)>>2)];
      var $139=$138+$134;
      HEAPF32[(($137)>>2)]=$139;
      __label__ = 15; break;
    case 15: // $140
      __label__ = 16; break;
    case 16: // $141
      var $142=$2;
      var $143=(($142+12)|0);
      var $144=HEAPF32[(($143)>>2)];
      var $145=$3;
      var $146=(($145+12)|0);
      var $147=HEAPF32[(($146)>>2)];
      var $148=$144 > $147;
      if ($148) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $149
      var $150=$2;
      var $151=(($150+12)|0);
      var $152=HEAPF32[(($151)>>2)];
      var $153=$3;
      var $154=(($153+12)|0);
      var $155=HEAPF32[(($154)>>2)];
      var $156=$152-$155;
      var $157=$2;
      var $158=(($157+12)|0);
      var $159=HEAPF32[(($158)>>2)];
      var $160=$2;
      var $161=(($160+4)|0);
      var $162=HEAPF32[(($161)>>2)];
      var $163=$159-$162;
      var $164=$156/$163;
      $frac1=$164;
      var $165=$3;
      var $166=(($165+12)|0);
      var $167=HEAPF32[(($166)>>2)];
      var $168=$2;
      var $169=(($168+12)|0);
      HEAPF32[(($169)>>2)]=$167;
      var $170=$4;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $172
      var $173=$4;
      var $174=(($173+16)|0);
      var $175=(($174)|0);
      var $176=HEAPF32[(($175)>>2)];
      var $177=$4;
      var $178=(($177)|0);
      var $179=(($178)|0);
      var $180=HEAPF32[(($179)>>2)];
      var $181=$176-$180;
      var $182=$frac1;
      var $183=$181*$182;
      var $184=$4;
      var $185=(($184+16)|0);
      var $186=(($185)|0);
      var $187=HEAPF32[(($186)>>2)];
      var $188=$187-$183;
      HEAPF32[(($186)>>2)]=$188;
      var $189=$4;
      var $190=(($189+16)|0);
      var $191=(($190+4)|0);
      var $192=HEAPF32[(($191)>>2)];
      var $193=$4;
      var $194=(($193)|0);
      var $195=(($194+4)|0);
      var $196=HEAPF32[(($195)>>2)];
      var $197=$192-$196;
      var $198=$frac1;
      var $199=$197*$198;
      var $200=$4;
      var $201=(($200+16)|0);
      var $202=(($201+4)|0);
      var $203=HEAPF32[(($202)>>2)];
      var $204=$203-$199;
      HEAPF32[(($202)>>2)]=$204;
      var $205=$4;
      var $206=(($205+24)|0);
      var $207=(($206)|0);
      var $208=HEAPF32[(($207)>>2)];
      var $209=$4;
      var $210=(($209+8)|0);
      var $211=(($210)|0);
      var $212=HEAPF32[(($211)>>2)];
      var $213=$208-$212;
      var $214=$frac1;
      var $215=$213*$214;
      var $216=$4;
      var $217=(($216+24)|0);
      var $218=(($217)|0);
      var $219=HEAPF32[(($218)>>2)];
      var $220=$219-$215;
      HEAPF32[(($218)>>2)]=$220;
      var $221=$4;
      var $222=(($221+24)|0);
      var $223=(($222+4)|0);
      var $224=HEAPF32[(($223)>>2)];
      var $225=$4;
      var $226=(($225+8)|0);
      var $227=(($226+4)|0);
      var $228=HEAPF32[(($227)>>2)];
      var $229=$224-$228;
      var $230=$frac1;
      var $231=$229*$230;
      var $232=$4;
      var $233=(($232+24)|0);
      var $234=(($233+4)|0);
      var $235=HEAPF32[(($234)>>2)];
      var $236=$235-$231;
      HEAPF32[(($234)>>2)]=$236;
      __label__ = 19; break;
    case 19: // $237
      __label__ = 20; break;
    case 20: // $238
      var $239=$2;
      var $240=(($239)|0);
      var $241=HEAPF32[(($240)>>2)];
      var $242=$3;
      var $243=(($242)|0);
      var $244=HEAPF32[(($243)>>2)];
      var $245=$241 < $244;
      if ($245) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $246
      var $247=$3;
      var $248=(($247)|0);
      var $249=HEAPF32[(($248)>>2)];
      var $250=$2;
      var $251=(($250)|0);
      var $252=HEAPF32[(($251)>>2)];
      var $253=$249-$252;
      var $254=$2;
      var $255=(($254+8)|0);
      var $256=HEAPF32[(($255)>>2)];
      var $257=$2;
      var $258=(($257)|0);
      var $259=HEAPF32[(($258)>>2)];
      var $260=$256-$259;
      var $261=$253/$260;
      $frac2=$261;
      var $262=$3;
      var $263=(($262)|0);
      var $264=HEAPF32[(($263)>>2)];
      var $265=$2;
      var $266=(($265)|0);
      HEAPF32[(($266)>>2)]=$264;
      var $267=$4;
      var $268=(($267)|0)!=0;
      if ($268) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $269
      var $270=$4;
      var $271=(($270+8)|0);
      var $272=(($271)|0);
      var $273=HEAPF32[(($272)>>2)];
      var $274=$4;
      var $275=(($274)|0);
      var $276=(($275)|0);
      var $277=HEAPF32[(($276)>>2)];
      var $278=$273-$277;
      var $279=$frac2;
      var $280=$278*$279;
      var $281=$4;
      var $282=(($281)|0);
      var $283=(($282)|0);
      var $284=HEAPF32[(($283)>>2)];
      var $285=$284+$280;
      HEAPF32[(($283)>>2)]=$285;
      var $286=$4;
      var $287=(($286+8)|0);
      var $288=(($287+4)|0);
      var $289=HEAPF32[(($288)>>2)];
      var $290=$4;
      var $291=(($290)|0);
      var $292=(($291+4)|0);
      var $293=HEAPF32[(($292)>>2)];
      var $294=$289-$293;
      var $295=$frac2;
      var $296=$294*$295;
      var $297=$4;
      var $298=(($297)|0);
      var $299=(($298+4)|0);
      var $300=HEAPF32[(($299)>>2)];
      var $301=$300+$296;
      HEAPF32[(($299)>>2)]=$301;
      var $302=$4;
      var $303=(($302+24)|0);
      var $304=(($303)|0);
      var $305=HEAPF32[(($304)>>2)];
      var $306=$4;
      var $307=(($306+16)|0);
      var $308=(($307)|0);
      var $309=HEAPF32[(($308)>>2)];
      var $310=$305-$309;
      var $311=$frac2;
      var $312=$310*$311;
      var $313=$4;
      var $314=(($313+16)|0);
      var $315=(($314)|0);
      var $316=HEAPF32[(($315)>>2)];
      var $317=$316+$312;
      HEAPF32[(($315)>>2)]=$317;
      var $318=$4;
      var $319=(($318+24)|0);
      var $320=(($319+4)|0);
      var $321=HEAPF32[(($320)>>2)];
      var $322=$4;
      var $323=(($322+16)|0);
      var $324=(($323+4)|0);
      var $325=HEAPF32[(($324)>>2)];
      var $326=$321-$325;
      var $327=$frac2;
      var $328=$326*$327;
      var $329=$4;
      var $330=(($329+16)|0);
      var $331=(($330+4)|0);
      var $332=HEAPF32[(($331)>>2)];
      var $333=$332+$328;
      HEAPF32[(($331)>>2)]=$333;
      __label__ = 23; break;
    case 23: // $334
      __label__ = 24; break;
    case 24: // $335
      var $336=$2;
      var $337=(($336+8)|0);
      var $338=HEAPF32[(($337)>>2)];
      var $339=$3;
      var $340=(($339+8)|0);
      var $341=HEAPF32[(($340)>>2)];
      var $342=$338 > $341;
      if ($342) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $343
      var $344=$2;
      var $345=(($344+8)|0);
      var $346=HEAPF32[(($345)>>2)];
      var $347=$3;
      var $348=(($347+8)|0);
      var $349=HEAPF32[(($348)>>2)];
      var $350=$346-$349;
      var $351=$2;
      var $352=(($351+8)|0);
      var $353=HEAPF32[(($352)>>2)];
      var $354=$2;
      var $355=(($354)|0);
      var $356=HEAPF32[(($355)>>2)];
      var $357=$353-$356;
      var $358=$350/$357;
      $frac3=$358;
      var $359=$3;
      var $360=(($359+8)|0);
      var $361=HEAPF32[(($360)>>2)];
      var $362=$2;
      var $363=(($362+8)|0);
      HEAPF32[(($363)>>2)]=$361;
      var $364=$4;
      var $365=(($364)|0)!=0;
      if ($365) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $366
      var $367=$4;
      var $368=(($367+8)|0);
      var $369=(($368)|0);
      var $370=HEAPF32[(($369)>>2)];
      var $371=$4;
      var $372=(($371)|0);
      var $373=(($372)|0);
      var $374=HEAPF32[(($373)>>2)];
      var $375=$370-$374;
      var $376=$frac3;
      var $377=$375*$376;
      var $378=$4;
      var $379=(($378+8)|0);
      var $380=(($379)|0);
      var $381=HEAPF32[(($380)>>2)];
      var $382=$381-$377;
      HEAPF32[(($380)>>2)]=$382;
      var $383=$4;
      var $384=(($383+8)|0);
      var $385=(($384+4)|0);
      var $386=HEAPF32[(($385)>>2)];
      var $387=$4;
      var $388=(($387)|0);
      var $389=(($388+4)|0);
      var $390=HEAPF32[(($389)>>2)];
      var $391=$386-$390;
      var $392=$frac3;
      var $393=$391*$392;
      var $394=$4;
      var $395=(($394+8)|0);
      var $396=(($395+4)|0);
      var $397=HEAPF32[(($396)>>2)];
      var $398=$397-$393;
      HEAPF32[(($396)>>2)]=$398;
      var $399=$4;
      var $400=(($399+24)|0);
      var $401=(($400)|0);
      var $402=HEAPF32[(($401)>>2)];
      var $403=$4;
      var $404=(($403+16)|0);
      var $405=(($404)|0);
      var $406=HEAPF32[(($405)>>2)];
      var $407=$402-$406;
      var $408=$frac3;
      var $409=$407*$408;
      var $410=$4;
      var $411=(($410+24)|0);
      var $412=(($411)|0);
      var $413=HEAPF32[(($412)>>2)];
      var $414=$413-$409;
      HEAPF32[(($412)>>2)]=$414;
      var $415=$4;
      var $416=(($415+24)|0);
      var $417=(($416+4)|0);
      var $418=HEAPF32[(($417)>>2)];
      var $419=$4;
      var $420=(($419+16)|0);
      var $421=(($420+4)|0);
      var $422=HEAPF32[(($421)>>2)];
      var $423=$418-$422;
      var $424=$frac3;
      var $425=$423*$424;
      var $426=$4;
      var $427=(($426+24)|0);
      var $428=(($427+4)|0);
      var $429=HEAPF32[(($428)>>2)];
      var $430=$429-$425;
      HEAPF32[(($428)>>2)]=$430;
      __label__ = 27; break;
    case 27: // $431
      __label__ = 28; break;
    case 28: // $432
      $1=0;
      __label__ = 29; break;
    case 29: // $433
      var $434=$1;
      ;
      return $434;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16render_clip_quadP13render_boundsPKS_P17render_quad_texuv["X"]=1;

function __Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($file, $dirname, $filename, $alphadest, $hasalpha) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $bitmap;
      var $png=__stackBase__+36;
      var $result;
      var $fname=__stackBase__+128;
      var $15;
      var $16;
      var $filerr;
      var $17;
      $10=$file;
      $11=$dirname;
      $12=$filename;
      $13=$alphadest;
      $14=$hasalpha;
      $bitmap=0;
      __ZN7astringC1Ev($fname);
      var $18=$11;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $20
      var $21=$12;
      var $22=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($fname, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $23
      __label__ = 9; break;
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $25;__label__ = 4; break;
    case 4: // $_body
      var $eh_lpad_body;
      var $26=$eh_lpad_body.f0;
      $15=$26;
      var $27=$eh_lpad_body.f1;
      $16=$27;
      __label__ = 63; break;
    case 5: // $28
      var $29=$11;
      var $30=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($fname, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; };
    case 6: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($30, ((STRING_TABLE.__str4095)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 3; break; };
    case 7: // $33
      var $34=$12;
      var $35=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($32, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 3; break; };
    case 8: // $36
      __label__ = 9; break;
    case 9: // $37
      var $38=$10;
      var $39=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 3; break; };
    case 10: // $40
      var $41=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($38, $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 3; break; };
    case 11: // $42
      $filerr=$41;
      var $43=$filerr;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $45
      $9=0;
      $17=1;
      __label__ = 62; break;
    case 13: // $46
      var $47=$10;
      var $48=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 3; break; };
    case 14: // $49
      var $50=(function() { try { __THREW__ = false; return __Z13png_read_fileP10_core_fileP9_png_info($48, $png) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 3; break; };
    case 15: // $51
      $result=$50;
      var $52=$10;
      (function() { try { __THREW__ = false; return __ZN8emu_file5closeEv($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 3; break; }
    case 16: // $53
      var $54=$result;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $56
      $9=0;
      $17=1;
      __label__ = 62; break;
    case 18: // $57
      var $58=(($png+64)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(($60)|0) > 8;
      if ($61) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $62
      var $63=$12;
      var $64=(($png+64)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      (function() { try { __THREW__ = false; return __Z8logerrorPKcz(((STRING_TABLE.__str14096)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$66,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 3; break; }
    case 20: // $67
      (function() { try { __THREW__ = false; return __Z8png_freeP9_png_info($png) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 3; break; }
    case 21: // $68
      $9=0;
      $17=1;
      __label__ = 62; break;
    case 22: // $69
      var $70=(($png+68)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $74
      var $75=$12;
      (function() { try { __THREW__ = false; return __Z8logerrorPKcz(((STRING_TABLE.__str24097)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$75,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 3; break; }
    case 24: // $76
      (function() { try { __THREW__ = false; return __Z8png_freeP9_png_info($png) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 3; break; }
    case 25: // $77
      $9=0;
      $17=1;
      __label__ = 62; break;
    case 26: // $78
      var $79=(($png+65)|0);
      var $80=HEAPU8[($79)];
      var $81=(($80)&255);
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 27; break; } else { __label__ = 33; break; }
    case 27: // $83
      var $84=(($png+65)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=(($86)|0)!=3;
      if ($87) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $88
      var $89=(($png+65)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $92=(($91)|0)!=2;
      if ($92) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $93
      var $94=(($png+65)|0);
      var $95=HEAPU8[($94)];
      var $96=(($95)&255);
      var $97=(($96)|0)!=6;
      if ($97) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $98
      var $99=$12;
      var $100=(($png+65)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      (function() { try { __THREW__ = false; return __Z8logerrorPKcz(((STRING_TABLE.__str34098)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$99,HEAP32[((tempInt+4)>>2)]=$102,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 3; break; }
    case 31: // $103
      (function() { try { __THREW__ = false; return __Z8png_freeP9_png_info($png) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 3; break; }
    case 32: // $104
      $9=0;
      $17=1;
      __label__ = 62; break;
    case 33: // $105
      var $106=(function() { try { __THREW__ = false; return __Z22png_expand_buffer_8bitP9_png_info($png) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 3; break; };
    case 34: // $107
      var $108=$13;
      var $109=(($108)|0)==0;
      if ($109) { __label__ = 35; break; } else { __label__ = 55; break; }
    case 35: // $110
      var $111=$4;
      var $112=$5;
      var $113=$6;
      var $114=$result_i;
      var $115=$7;
      var $116=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str44099)|0);
      HEAP32[(($6)>>2)]=611;
      var $117=HEAP32[(($4)>>2)];
      var $118=HEAP32[(($5)>>2)];
      var $119=HEAP32[(($6)>>2)];
      var $120=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($117, $118, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 38; break; };
    case 36: // $121
      HEAP32[(($result_i)>>2)]=$120;
      var $122=HEAP32[(($result_i)>>2)];
      var $123=(($122)|0)==0;
      if ($123) { __label__ = 37; break; } else { __label__ = 43; break; }
    case 37: // $124
      var $125=___cxa_allocate_exception(4);
      var $126=$125;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($126);
      (function() { try { __THREW__ = false; return ___cxa_throw($125, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 38; break; }
    case 38: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      HEAP32[(($7)>>2)]=$129;
      var $130=$128.f1;
      HEAP32[(($8)>>2)]=$130;
      var $131=HEAP32[(($8)>>2)];
      var $132=(($131)|0) < 0;
      if ($132) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $133
      var $134=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 3; break; }
    case 40: // $_noexc
      throw "Reached an unreachable!"
    case 41: // $135
      var $136=HEAP32[(($7)>>2)];
      var $137=HEAP32[(($7)>>2)];
      var $138=HEAP32[(($8)>>2)];
      var $139=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $137, tempValue);
      var $140=($139.f1 = $138, $139);
      var $eh_lpad_body = $140;__label__ = 4; break;
    case 42: // $141
      throw "Reached an unreachable!"
    case 43: // $_ZnwjPKci_exit
      var $142=HEAP32[(($result_i)>>2)];
      var $143=$4;
      var $144=$5;
      var $145=$6;
      var $146=$result_i;
      var $147=$7;
      var $148=$8;
      __label__ = 44; break;
    case 44: // $149
      var $150=$142;
      var $151=(($png+4)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($png+8)|0);
      var $154=HEAP32[(($153)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($150, $152, $154, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 49; break; }
    case 45: // $155
      var $156=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 3; break; };
    case 46: // $157
      $bitmap=$156;
      var $158=$bitmap;
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 47; break; } else { __label__ = 54; break; }
    case 47: // $160
      var $161=$bitmap;
      var $162=$14;
      (function() { try { __THREW__ = false; return __ZL18copy_png_to_bitmapP8bitmap_tPK9_png_infoPb($161, $png, $162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 3; break; }
    case 48: // $163
      __label__ = 54; break;
    case 49: // $164
      var $165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $166=$165.f0;
      $15=$166;
      var $167=$165.f1;
      $16=$167;
      var $168=$1;
      var $169=$2;
      var $170=$3;
      HEAP32[(($1)>>2)]=$142;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str44099)|0);
      HEAP32[(($3)>>2)]=611;
      var $171=HEAP32[(($1)>>2)];
      var $172=(($171)|0)!=0;
      if ($172) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $173
      var $174=HEAP32[(($1)>>2)];
      var $175=HEAP32[(($2)>>2)];
      var $176=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($174, $175, $176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 66; break; }
    case 51: // $_noexc1
      __label__ = 52; break;
    case 52: // $_ZdlPvPKci_exit
      var $177=$1;
      var $178=$2;
      var $179=$3;
      __label__ = 53; break;
    case 53: // $180
      __label__ = 63; break;
    case 54: // $181
      __label__ = 60; break;
    case 55: // $182
      var $183=(($png+4)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$13;
      var $186=$185;
      var $187=(($186+12)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($184)|0)==(($188)|0);
      if ($189) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $190
      var $191=(($png+8)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=$13;
      var $194=$193;
      var $195=(($194+16)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($192)|0)==(($196)|0);
      if ($197) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $198
      var $199=$13;
      $bitmap=$199;
      var $200=$bitmap;
      var $201=$14;
      (function() { try { __THREW__ = false; return __ZL24copy_png_alpha_to_bitmapP8bitmap_tPK9_png_infoPb($200, $png, $201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 3; break; }
    case 58: // $202
      __label__ = 59; break;
    case 59: // $203
      __label__ = 60; break;
    case 60: // $204
      (function() { try { __THREW__ = false; return __Z8png_freeP9_png_info($png) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 3; break; }
    case 61: // $205
      var $206=$bitmap;
      $9=$206;
      $17=1;
      __label__ = 62; break;
    case 62: // $207
      FUNCTION_TABLE[__ZN7astringD1Ev]($fname);
      var $208=$9;
      STACKTOP = __stackBase__;
      return $208;
    case 63: // $209
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 64: // $210
      __label__ = 65; break;
    case 65: // $211
      var $212=$15;
      var $213=$15;
      var $214=$16;
      var $215=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $213, tempValue);
      var $216=($215.f1 = $214, $215);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $217
      var $218=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb["X"]=1;

function __ZL18copy_png_to_bitmapP8bitmap_tPK9_png_infoPb($bitmap, $png, $hasalpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $accumalpha;
      var $src;
      var $x;
      var $y;
      var $alpha;
      $1=$bitmap;
      $2=$png;
      $3=$hasalpha;
      $accumalpha=-1;
      var $4=$2;
      var $5=(($4+65)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=(($7)|0)==3;
      if ($8) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      $src=$12;
      $y=0;
      __label__ = 2; break;
    case 2: // $13
      var $14=$y;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=(($14)>>>0) < (($17)>>>0);
      if ($18) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $19
      $x=0;
      __label__ = 4; break;
    case 4: // $20
      var $21=$x;
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAPU32[(($23)>>2)];
      var $25=(($21)>>>0) < (($24)>>>0);
      if ($25) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $26
      var $27=$src;
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=$2;
      var $31=(($30+84)|0);
      var $32=HEAPU32[(($31)>>2)];
      var $33=(($29)>>>0) < (($32)>>>0);
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=$src;
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$2;
      var $39=(($38+80)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+$37)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $46 = $43;__label__ = 8; break;
    case 7: // $44
      var $46 = 255;__label__ = 8; break;
    case 8: // $45
      var $46;
      var $47=(($46) & 255);
      $alpha=$47;
      var $48=$alpha;
      var $49=(($48)&255);
      var $50=$accumalpha;
      var $51=(($50)&255);
      var $52=$51 & $49;
      var $53=(($52) & 255);
      $accumalpha=$53;
      var $54=$alpha;
      var $55=(($54)&255);
      var $56=$55 & 255;
      var $57=$56 << 24;
      var $58=$src;
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(($60*3)|0);
      var $62=$2;
      var $63=(($62+72)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+$61)|0);
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$67 & 255;
      var $69=$68 << 16;
      var $70=$57 | $69;
      var $71=$src;
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($73*3)|0);
      var $75=(($74+1)|0);
      var $76=$2;
      var $77=(($76+72)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+$75)|0);
      var $80=HEAPU8[($79)];
      var $81=(($80)&255);
      var $82=$81 & 255;
      var $83=$82 << 8;
      var $84=$70 | $83;
      var $85=$src;
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=(($87*3)|0);
      var $89=(($88+2)|0);
      var $90=$2;
      var $91=(($90+72)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92+$89)|0);
      var $94=HEAPU8[($93)];
      var $95=(($94)&255);
      var $96=$95 & 255;
      var $97=$84 | $96;
      var $98=$1;
      var $99=$98;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$101;
      var $103=$y;
      var $104=$1;
      var $105=$104;
      var $106=(($105+8)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($103*$107)|0);
      var $109=(($102+($108<<2))|0);
      var $110=$x;
      var $111=(($109+($110<<2))|0);
      HEAP32[(($111)>>2)]=$97;
      __label__ = 9; break;
    case 9: // $112
      var $113=$x;
      var $114=(($113+1)|0);
      $x=$114;
      var $115=$src;
      var $116=(($115+1)|0);
      $src=$116;
      __label__ = 4; break;
    case 10: // $117
      __label__ = 11; break;
    case 11: // $118
      var $119=$y;
      var $120=(($119+1)|0);
      $y=$120;
      __label__ = 2; break;
    case 12: // $121
      __label__ = 44; break;
    case 13: // $122
      var $123=$2;
      var $124=(($123+65)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=(($126)|0)==0;
      if ($127) { __label__ = 14; break; } else { __label__ = 23; break; }
    case 14: // $128
      var $129=$2;
      var $130=(($129)|0);
      var $131=HEAP32[(($130)>>2)];
      $src=$131;
      $y=0;
      __label__ = 15; break;
    case 15: // $132
      var $133=$y;
      var $134=$2;
      var $135=(($134+8)|0);
      var $136=HEAPU32[(($135)>>2)];
      var $137=(($133)>>>0) < (($136)>>>0);
      if ($137) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $138
      $x=0;
      __label__ = 17; break;
    case 17: // $139
      var $140=$x;
      var $141=$2;
      var $142=(($141+4)|0);
      var $143=HEAPU32[(($142)>>2)];
      var $144=(($140)>>>0) < (($143)>>>0);
      if ($144) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $145
      var $146=$src;
      var $147=HEAPU8[($146)];
      var $148=(($147)&255);
      var $149=$148 & 255;
      var $150=$149 << 16;
      var $151=-16777216 | $150;
      var $152=$src;
      var $153=HEAPU8[($152)];
      var $154=(($153)&255);
      var $155=$154 & 255;
      var $156=$155 << 8;
      var $157=$151 | $156;
      var $158=$src;
      var $159=HEAPU8[($158)];
      var $160=(($159)&255);
      var $161=$160 & 255;
      var $162=$157 | $161;
      var $163=$1;
      var $164=$163;
      var $165=(($164+4)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$166;
      var $168=$y;
      var $169=$1;
      var $170=$169;
      var $171=(($170+8)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($168*$172)|0);
      var $174=(($167+($173<<2))|0);
      var $175=$x;
      var $176=(($174+($175<<2))|0);
      HEAP32[(($176)>>2)]=$162;
      __label__ = 19; break;
    case 19: // $177
      var $178=$x;
      var $179=(($178+1)|0);
      $x=$179;
      var $180=$src;
      var $181=(($180+1)|0);
      $src=$181;
      __label__ = 17; break;
    case 20: // $182
      __label__ = 21; break;
    case 21: // $183
      var $184=$y;
      var $185=(($184+1)|0);
      $y=$185;
      __label__ = 15; break;
    case 22: // $186
      __label__ = 43; break;
    case 23: // $187
      var $188=$2;
      var $189=(($188+65)|0);
      var $190=HEAPU8[($189)];
      var $191=(($190)&255);
      var $192=(($191)|0)==2;
      if ($192) { __label__ = 24; break; } else { __label__ = 33; break; }
    case 24: // $193
      var $194=$2;
      var $195=(($194)|0);
      var $196=HEAP32[(($195)>>2)];
      $src=$196;
      $y=0;
      __label__ = 25; break;
    case 25: // $197
      var $198=$y;
      var $199=$2;
      var $200=(($199+8)|0);
      var $201=HEAPU32[(($200)>>2)];
      var $202=(($198)>>>0) < (($201)>>>0);
      if ($202) { __label__ = 26; break; } else { __label__ = 32; break; }
    case 26: // $203
      $x=0;
      __label__ = 27; break;
    case 27: // $204
      var $205=$x;
      var $206=$2;
      var $207=(($206+4)|0);
      var $208=HEAPU32[(($207)>>2)];
      var $209=(($205)>>>0) < (($208)>>>0);
      if ($209) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $210
      var $211=$src;
      var $212=(($211)|0);
      var $213=HEAPU8[($212)];
      var $214=(($213)&255);
      var $215=$214 & 255;
      var $216=$215 << 16;
      var $217=-16777216 | $216;
      var $218=$src;
      var $219=(($218+1)|0);
      var $220=HEAPU8[($219)];
      var $221=(($220)&255);
      var $222=$221 & 255;
      var $223=$222 << 8;
      var $224=$217 | $223;
      var $225=$src;
      var $226=(($225+2)|0);
      var $227=HEAPU8[($226)];
      var $228=(($227)&255);
      var $229=$228 & 255;
      var $230=$224 | $229;
      var $231=$1;
      var $232=$231;
      var $233=(($232+4)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$234;
      var $236=$y;
      var $237=$1;
      var $238=$237;
      var $239=(($238+8)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=(($236*$240)|0);
      var $242=(($235+($241<<2))|0);
      var $243=$x;
      var $244=(($242+($243<<2))|0);
      HEAP32[(($244)>>2)]=$230;
      __label__ = 29; break;
    case 29: // $245
      var $246=$x;
      var $247=(($246+1)|0);
      $x=$247;
      var $248=$src;
      var $249=(($248+3)|0);
      $src=$249;
      __label__ = 27; break;
    case 30: // $250
      __label__ = 31; break;
    case 31: // $251
      var $252=$y;
      var $253=(($252+1)|0);
      $y=$253;
      __label__ = 25; break;
    case 32: // $254
      __label__ = 42; break;
    case 33: // $255
      var $256=$2;
      var $257=(($256)|0);
      var $258=HEAP32[(($257)>>2)];
      $src=$258;
      $y=0;
      __label__ = 34; break;
    case 34: // $259
      var $260=$y;
      var $261=$2;
      var $262=(($261+8)|0);
      var $263=HEAPU32[(($262)>>2)];
      var $264=(($260)>>>0) < (($263)>>>0);
      if ($264) { __label__ = 35; break; } else { __label__ = 41; break; }
    case 35: // $265
      $x=0;
      __label__ = 36; break;
    case 36: // $266
      var $267=$x;
      var $268=$2;
      var $269=(($268+4)|0);
      var $270=HEAPU32[(($269)>>2)];
      var $271=(($267)>>>0) < (($270)>>>0);
      if ($271) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $272
      var $273=$src;
      var $274=(($273+3)|0);
      var $275=HEAPU8[($274)];
      var $276=(($275)&255);
      var $277=$accumalpha;
      var $278=(($277)&255);
      var $279=$278 & $276;
      var $280=(($279) & 255);
      $accumalpha=$280;
      var $281=$src;
      var $282=(($281+3)|0);
      var $283=HEAPU8[($282)];
      var $284=(($283)&255);
      var $285=$284 & 255;
      var $286=$285 << 24;
      var $287=$src;
      var $288=(($287)|0);
      var $289=HEAPU8[($288)];
      var $290=(($289)&255);
      var $291=$290 & 255;
      var $292=$291 << 16;
      var $293=$286 | $292;
      var $294=$src;
      var $295=(($294+1)|0);
      var $296=HEAPU8[($295)];
      var $297=(($296)&255);
      var $298=$297 & 255;
      var $299=$298 << 8;
      var $300=$293 | $299;
      var $301=$src;
      var $302=(($301+2)|0);
      var $303=HEAPU8[($302)];
      var $304=(($303)&255);
      var $305=$304 & 255;
      var $306=$300 | $305;
      var $307=$1;
      var $308=$307;
      var $309=(($308+4)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=$310;
      var $312=$y;
      var $313=$1;
      var $314=$313;
      var $315=(($314+8)|0);
      var $316=HEAP32[(($315)>>2)];
      var $317=(($312*$316)|0);
      var $318=(($311+($317<<2))|0);
      var $319=$x;
      var $320=(($318+($319<<2))|0);
      HEAP32[(($320)>>2)]=$306;
      __label__ = 38; break;
    case 38: // $321
      var $322=$x;
      var $323=(($322+1)|0);
      $x=$323;
      var $324=$src;
      var $325=(($324+4)|0);
      $src=$325;
      __label__ = 36; break;
    case 39: // $326
      __label__ = 40; break;
    case 40: // $327
      var $328=$y;
      var $329=(($328+1)|0);
      $y=$329;
      __label__ = 34; break;
    case 41: // $330
      __label__ = 42; break;
    case 42: // $331
      __label__ = 43; break;
    case 43: // $332
      __label__ = 44; break;
    case 44: // $333
      var $334=$3;
      var $335=(($334)|0)!=0;
      if ($335) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $336
      var $337=$accumalpha;
      var $338=(($337)&255);
      var $339=(($338)|0)!=255;
      var $340=$3;
      var $341=(($339)&1);
      HEAP8[($340)]=$341;
      __label__ = 46; break;
    case 46: // $342
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18copy_png_to_bitmapP8bitmap_tPK9_png_infoPb["X"]=1;

function __ZL18compute_brightnessj($rgb) {
  ;
  var __label__;

  var $1;
  $1=$rgb;
  var $2=$1;
  var $3=$2 >>> 16;
  var $4=$3 & 255;
  var $5=(($4*222)|0);
  var $6=$1;
  var $7=$6 >>> 8;
  var $8=$7 & 255;
  var $9=(($8*707)|0);
  var $10=(($5+$9)|0);
  var $11=$1;
  var $12=$11 & 255;
  var $13=(($12*71)|0);
  var $14=(($10+$13)|0);
  var $15=Math.floor((($14)>>>0)/1000);
  var $16=(($15) & 255);
  ;
  return $16;
}


function __ZL24copy_png_alpha_to_bitmapP8bitmap_tPK9_png_infoPb($bitmap, $png, $hasalpha) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $accumalpha;
      var $src;
      var $x;
      var $y;
      var $pixel;
      var $alpha;
      var $pixel1;
      var $pixel2;
      var $alpha3;
      var $pixel4;
      var $alpha5;
      $1=$bitmap;
      $2=$png;
      $3=$hasalpha;
      $accumalpha=-1;
      var $4=$2;
      var $5=(($4+65)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=(($7)|0)==3;
      if ($8) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      $src=$12;
      $y=0;
      __label__ = 2; break;
    case 2: // $13
      var $14=$y;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=(($14)>>>0) < (($17)>>>0);
      if ($18) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $19
      $x=0;
      __label__ = 4; break;
    case 4: // $20
      var $21=$x;
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAPU32[(($23)>>2)];
      var $25=(($21)>>>0) < (($24)>>>0);
      if ($25) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $26
      var $27=$1;
      var $28=$27;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30;
      var $32=$y;
      var $33=$1;
      var $34=$33;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($32*$36)|0);
      var $38=(($31+($37<<2))|0);
      var $39=$x;
      var $40=(($38+($39<<2))|0);
      var $41=HEAP32[(($40)>>2)];
      $pixel=$41;
      var $42=$src;
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44*3)|0);
      var $46=$2;
      var $47=(($46+72)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+$45)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$51 & 255;
      var $53=$52 << 16;
      var $54=-16777216 | $53;
      var $55=$src;
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=(($57*3)|0);
      var $59=(($58+1)|0);
      var $60=$2;
      var $61=(($60+72)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+$59)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$65 & 255;
      var $67=$66 << 8;
      var $68=$54 | $67;
      var $69=$src;
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=(($71*3)|0);
      var $73=(($72+2)|0);
      var $74=$2;
      var $75=(($74+72)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76+$73)|0);
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $80=$79 & 255;
      var $81=$68 | $80;
      var $82=__ZL18compute_brightnessj($81);
      $alpha=$82;
      var $83=$alpha;
      var $84=(($83)&255);
      var $85=$accumalpha;
      var $86=(($85)&255);
      var $87=$86 & $84;
      var $88=(($87) & 255);
      $accumalpha=$88;
      var $89=$alpha;
      var $90=(($89)&255);
      var $91=$90 & 255;
      var $92=$91 << 24;
      var $93=$pixel;
      var $94=$93 >>> 16;
      var $95=$94 & 255;
      var $96=$95 & 255;
      var $97=$96 << 16;
      var $98=$92 | $97;
      var $99=$pixel;
      var $100=$99 >>> 8;
      var $101=$100 & 255;
      var $102=$101 & 255;
      var $103=$102 << 8;
      var $104=$98 | $103;
      var $105=$pixel;
      var $106=$105 & 255;
      var $107=$106 & 255;
      var $108=$104 | $107;
      var $109=$1;
      var $110=$109;
      var $111=(($110+4)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$112;
      var $114=$y;
      var $115=$1;
      var $116=$115;
      var $117=(($116+8)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($114*$118)|0);
      var $120=(($113+($119<<2))|0);
      var $121=$x;
      var $122=(($120+($121<<2))|0);
      HEAP32[(($122)>>2)]=$108;
      __label__ = 6; break;
    case 6: // $123
      var $124=$x;
      var $125=(($124+1)|0);
      $x=$125;
      var $126=$src;
      var $127=(($126+1)|0);
      $src=$127;
      __label__ = 4; break;
    case 7: // $128
      __label__ = 8; break;
    case 8: // $129
      var $130=$y;
      var $131=(($130+1)|0);
      $y=$131;
      __label__ = 2; break;
    case 9: // $132
      __label__ = 41; break;
    case 10: // $133
      var $134=$2;
      var $135=(($134+65)|0);
      var $136=HEAPU8[($135)];
      var $137=(($136)&255);
      var $138=(($137)|0)==0;
      if ($138) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $139
      var $140=$2;
      var $141=(($140)|0);
      var $142=HEAP32[(($141)>>2)];
      $src=$142;
      $y=0;
      __label__ = 12; break;
    case 12: // $143
      var $144=$y;
      var $145=$2;
      var $146=(($145+8)|0);
      var $147=HEAPU32[(($146)>>2)];
      var $148=(($144)>>>0) < (($147)>>>0);
      if ($148) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $149
      $x=0;
      __label__ = 14; break;
    case 14: // $150
      var $151=$x;
      var $152=$2;
      var $153=(($152+4)|0);
      var $154=HEAPU32[(($153)>>2)];
      var $155=(($151)>>>0) < (($154)>>>0);
      if ($155) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $156
      var $157=$1;
      var $158=$157;
      var $159=(($158+4)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=$160;
      var $162=$y;
      var $163=$1;
      var $164=$163;
      var $165=(($164+8)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($162*$166)|0);
      var $168=(($161+($167<<2))|0);
      var $169=$x;
      var $170=(($168+($169<<2))|0);
      var $171=HEAP32[(($170)>>2)];
      $pixel1=$171;
      var $172=$src;
      var $173=HEAPU8[($172)];
      var $174=(($173)&255);
      var $175=$accumalpha;
      var $176=(($175)&255);
      var $177=$176 & $174;
      var $178=(($177) & 255);
      $accumalpha=$178;
      var $179=$src;
      var $180=HEAPU8[($179)];
      var $181=(($180)&255);
      var $182=$181 & 255;
      var $183=$182 << 24;
      var $184=$pixel1;
      var $185=$184 >>> 16;
      var $186=$185 & 255;
      var $187=$186 & 255;
      var $188=$187 << 16;
      var $189=$183 | $188;
      var $190=$pixel1;
      var $191=$190 >>> 8;
      var $192=$191 & 255;
      var $193=$192 & 255;
      var $194=$193 << 8;
      var $195=$189 | $194;
      var $196=$pixel1;
      var $197=$196 & 255;
      var $198=$197 & 255;
      var $199=$195 | $198;
      var $200=$1;
      var $201=$200;
      var $202=(($201+4)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$203;
      var $205=$y;
      var $206=$1;
      var $207=$206;
      var $208=(($207+8)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=(($205*$209)|0);
      var $211=(($204+($210<<2))|0);
      var $212=$x;
      var $213=(($211+($212<<2))|0);
      HEAP32[(($213)>>2)]=$199;
      __label__ = 16; break;
    case 16: // $214
      var $215=$x;
      var $216=(($215+1)|0);
      $x=$216;
      var $217=$src;
      var $218=(($217+1)|0);
      $src=$218;
      __label__ = 14; break;
    case 17: // $219
      __label__ = 18; break;
    case 18: // $220
      var $221=$y;
      var $222=(($221+1)|0);
      $y=$222;
      __label__ = 12; break;
    case 19: // $223
      __label__ = 40; break;
    case 20: // $224
      var $225=$2;
      var $226=(($225+65)|0);
      var $227=HEAPU8[($226)];
      var $228=(($227)&255);
      var $229=(($228)|0)==2;
      if ($229) { __label__ = 21; break; } else { __label__ = 30; break; }
    case 21: // $230
      var $231=$2;
      var $232=(($231)|0);
      var $233=HEAP32[(($232)>>2)];
      $src=$233;
      $y=0;
      __label__ = 22; break;
    case 22: // $234
      var $235=$y;
      var $236=$2;
      var $237=(($236+8)|0);
      var $238=HEAPU32[(($237)>>2)];
      var $239=(($235)>>>0) < (($238)>>>0);
      if ($239) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $240
      $x=0;
      __label__ = 24; break;
    case 24: // $241
      var $242=$x;
      var $243=$2;
      var $244=(($243+4)|0);
      var $245=HEAPU32[(($244)>>2)];
      var $246=(($242)>>>0) < (($245)>>>0);
      if ($246) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $247
      var $248=$1;
      var $249=$248;
      var $250=(($249+4)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$251;
      var $253=$y;
      var $254=$1;
      var $255=$254;
      var $256=(($255+8)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($253*$257)|0);
      var $259=(($252+($258<<2))|0);
      var $260=$x;
      var $261=(($259+($260<<2))|0);
      var $262=HEAP32[(($261)>>2)];
      $pixel2=$262;
      var $263=$src;
      var $264=(($263)|0);
      var $265=HEAPU8[($264)];
      var $266=(($265)&255);
      var $267=$266 & 255;
      var $268=$267 << 16;
      var $269=-16777216 | $268;
      var $270=$src;
      var $271=(($270+1)|0);
      var $272=HEAPU8[($271)];
      var $273=(($272)&255);
      var $274=$273 & 255;
      var $275=$274 << 8;
      var $276=$269 | $275;
      var $277=$src;
      var $278=(($277+2)|0);
      var $279=HEAPU8[($278)];
      var $280=(($279)&255);
      var $281=$280 & 255;
      var $282=$276 | $281;
      var $283=__ZL18compute_brightnessj($282);
      $alpha3=$283;
      var $284=$alpha3;
      var $285=(($284)&255);
      var $286=$accumalpha;
      var $287=(($286)&255);
      var $288=$287 & $285;
      var $289=(($288) & 255);
      $accumalpha=$289;
      var $290=$alpha3;
      var $291=(($290)&255);
      var $292=$291 & 255;
      var $293=$292 << 24;
      var $294=$pixel2;
      var $295=$294 >>> 16;
      var $296=$295 & 255;
      var $297=$296 & 255;
      var $298=$297 << 16;
      var $299=$293 | $298;
      var $300=$pixel2;
      var $301=$300 >>> 8;
      var $302=$301 & 255;
      var $303=$302 & 255;
      var $304=$303 << 8;
      var $305=$299 | $304;
      var $306=$pixel2;
      var $307=$306 & 255;
      var $308=$307 & 255;
      var $309=$305 | $308;
      var $310=$1;
      var $311=$310;
      var $312=(($311+4)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=$313;
      var $315=$y;
      var $316=$1;
      var $317=$316;
      var $318=(($317+8)|0);
      var $319=HEAP32[(($318)>>2)];
      var $320=(($315*$319)|0);
      var $321=(($314+($320<<2))|0);
      var $322=$x;
      var $323=(($321+($322<<2))|0);
      HEAP32[(($323)>>2)]=$309;
      __label__ = 26; break;
    case 26: // $324
      var $325=$x;
      var $326=(($325+1)|0);
      $x=$326;
      var $327=$src;
      var $328=(($327+3)|0);
      $src=$328;
      __label__ = 24; break;
    case 27: // $329
      __label__ = 28; break;
    case 28: // $330
      var $331=$y;
      var $332=(($331+1)|0);
      $y=$332;
      __label__ = 22; break;
    case 29: // $333
      __label__ = 39; break;
    case 30: // $334
      var $335=$2;
      var $336=(($335)|0);
      var $337=HEAP32[(($336)>>2)];
      $src=$337;
      $y=0;
      __label__ = 31; break;
    case 31: // $338
      var $339=$y;
      var $340=$2;
      var $341=(($340+8)|0);
      var $342=HEAPU32[(($341)>>2)];
      var $343=(($339)>>>0) < (($342)>>>0);
      if ($343) { __label__ = 32; break; } else { __label__ = 38; break; }
    case 32: // $344
      $x=0;
      __label__ = 33; break;
    case 33: // $345
      var $346=$x;
      var $347=$2;
      var $348=(($347+4)|0);
      var $349=HEAPU32[(($348)>>2)];
      var $350=(($346)>>>0) < (($349)>>>0);
      if ($350) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $351
      var $352=$1;
      var $353=$352;
      var $354=(($353+4)|0);
      var $355=HEAP32[(($354)>>2)];
      var $356=$355;
      var $357=$y;
      var $358=$1;
      var $359=$358;
      var $360=(($359+8)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($357*$361)|0);
      var $363=(($356+($362<<2))|0);
      var $364=$x;
      var $365=(($363+($364<<2))|0);
      var $366=HEAP32[(($365)>>2)];
      $pixel4=$366;
      var $367=$src;
      var $368=(($367)|0);
      var $369=HEAPU8[($368)];
      var $370=(($369)&255);
      var $371=$370 & 255;
      var $372=$371 << 16;
      var $373=-16777216 | $372;
      var $374=$src;
      var $375=(($374+1)|0);
      var $376=HEAPU8[($375)];
      var $377=(($376)&255);
      var $378=$377 & 255;
      var $379=$378 << 8;
      var $380=$373 | $379;
      var $381=$src;
      var $382=(($381+2)|0);
      var $383=HEAPU8[($382)];
      var $384=(($383)&255);
      var $385=$384 & 255;
      var $386=$380 | $385;
      var $387=__ZL18compute_brightnessj($386);
      $alpha5=$387;
      var $388=$alpha5;
      var $389=(($388)&255);
      var $390=$accumalpha;
      var $391=(($390)&255);
      var $392=$391 & $389;
      var $393=(($392) & 255);
      $accumalpha=$393;
      var $394=$alpha5;
      var $395=(($394)&255);
      var $396=$395 & 255;
      var $397=$396 << 24;
      var $398=$pixel4;
      var $399=$398 >>> 16;
      var $400=$399 & 255;
      var $401=$400 & 255;
      var $402=$401 << 16;
      var $403=$397 | $402;
      var $404=$pixel4;
      var $405=$404 >>> 8;
      var $406=$405 & 255;
      var $407=$406 & 255;
      var $408=$407 << 8;
      var $409=$403 | $408;
      var $410=$pixel4;
      var $411=$410 & 255;
      var $412=$411 & 255;
      var $413=$409 | $412;
      var $414=$1;
      var $415=$414;
      var $416=(($415+4)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=$417;
      var $419=$y;
      var $420=$1;
      var $421=$420;
      var $422=(($421+8)|0);
      var $423=HEAP32[(($422)>>2)];
      var $424=(($419*$423)|0);
      var $425=(($418+($424<<2))|0);
      var $426=$x;
      var $427=(($425+($426<<2))|0);
      HEAP32[(($427)>>2)]=$413;
      __label__ = 35; break;
    case 35: // $428
      var $429=$x;
      var $430=(($429+1)|0);
      $x=$430;
      var $431=$src;
      var $432=(($431+4)|0);
      $src=$432;
      __label__ = 33; break;
    case 36: // $433
      __label__ = 37; break;
    case 37: // $434
      var $435=$y;
      var $436=(($435+1)|0);
      $y=$436;
      __label__ = 31; break;
    case 38: // $437
      __label__ = 39; break;
    case 39: // $438
      __label__ = 40; break;
    case 40: // $439
      __label__ = 41; break;
    case 41: // $440
      var $441=$3;
      var $442=(($441)|0)!=0;
      if ($442) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $443
      var $444=$accumalpha;
      var $445=(($444)&255);
      var $446=(($445)|0)!=255;
      var $447=$3;
      var $448=(($446)&1);
      HEAP8[($447)]=$448;
      __label__ = 43; break;
    case 43: // $449
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24copy_png_alpha_to_bitmapP8bitmap_tPK9_png_infoPb["X"]=1;

function __ZN12save_manager9save_itemIA4_tEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemItLj4EEEvPKcS2_iRAT0__T_S2_($5, ((STRING_TABLE.__str54113)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZN12save_manager9save_itemIA4_hEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$index;
  var $5=$1;
  var $6=$4;
  var $7=$2;
  var $8=$3;
  __ZN12save_manager9save_itemIhLj4EEEvPKcS2_iRAT0__T_S2_($5, ((STRING_TABLE.__str54113)|0), 0, $6, $7, $8);
  ;
  return;
}


function __ZN12save_manager9save_itemItLj4EEEvPKcS2_iRAT0__T_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=(($12)|0);
  var $14=$13;
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $14, 2, 4);
  ;
  return;
}


function __ZN20resource_pool_objectI22_generic_audio_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22_generic_audio_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22_generic_audio_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 14);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22_generic_audio_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22_generic_audio_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22_generic_audio_privateED2Ev($2);
  ;
  return;
}


function __Z18generic_sound_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $state;
      $7=$machine;
      var $8=$7;
      var $9=__ZN15running_machine7respoolEv($8);
      var $10=$1;
      var $11=$2;
      var $12=$3;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($1)>>2)]=14;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4108)|0);
      HEAP32[(($3)>>2)]=42;
      HEAP32[(($4)>>2)]=_zeromem;
      var $17=HEAP32[(($1)>>2)];
      var $18=HEAP32[(($2)>>2)];
      var $19=HEAP32[(($3)>>2)];
      var $20=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, $18, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $21
      HEAP32[(($result_i)>>2)]=$20;
      var $22=HEAP32[(($result_i)>>2)];
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $24
      var $25=___cxa_allocate_exception(4);
      var $26=$25;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($26);
      (function() { try { __THREW__ = false; return ___cxa_throw($25, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      HEAP32[(($5)>>2)]=$29;
      var $30=$28.f1;
      HEAP32[(($6)>>2)]=$30;
      var $31=HEAP32[(($6)>>2)];
      var $32=(($31)|0) < 0;
      if ($32) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $33
      var $34=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($34);
      throw "Reached an unreachable!"
    case 5: // $35
      var $36=HEAP32[(($5)>>2)];
      var $37=HEAP32[(($5)>>2)];
      var $38=HEAP32[(($6)>>2)];
      var $39=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37, tempValue);
      var $40=($39.f1 = $38, $39);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $41
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $42=HEAP32[(($result_i)>>2)];
      var $43=HEAP32[(($1)>>2)];
      _memset($42, 0, $43, 1);
      var $44=HEAP32[(($result_i)>>2)];
      var $45=$1;
      var $46=$2;
      var $47=$3;
      var $48=$4;
      var $49=$result_i;
      var $50=$5;
      var $51=$6;
      var $52=$44;
      var $53=__ZN13resource_pool10add_objectI22_generic_audio_privateEEPT_S3_($9, $52);
      var $54=$7;
      var $55=(($54+664)|0);
      HEAP32[(($55)>>2)]=$53;
      $state=$53;
      var $56=$7;
      var $57=__ZN15running_machine4saveEv($56);
      var $58=$state;
      var $59=(($58+2)|0);
      __ZN12save_manager9save_itemIA4_tEEvRT_PKci($57, $59, ((STRING_TABLE.__str14109)|0), 0);
      var $60=$7;
      var $61=__ZN15running_machine4saveEv($60);
      var $62=$state;
      var $63=(($62+10)|0);
      __ZN12save_manager9save_itemIA4_hEEvRT_PKci($61, $63, ((STRING_TABLE.__str24110)|0), 0);
      STACKTOP = __stackBase__;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18generic_sound_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI22_generic_audio_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22_generic_audio_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22_generic_audio_privateEEPT_S3_["X"]=1;

function __ZN12save_manager12save_pointerIhEEvPT_PKcji($this, $value, $valname, $count, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$value;
  $3=$valname;
  $4=$count;
  $5=$index;
  var $6=$1;
  var $7=$5;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  __ZN12save_manager12save_pointerIhEEvPKcS2_iPT_S2_j($6, ((STRING_TABLE.__str84127)|0), 0, $7, $8, $9, $10);
  ;
  return;
}


function __ZN20resource_pool_objectI22_generic_video_privateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI22_generic_video_privateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI22_generic_video_privateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI22_generic_video_privateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI22_generic_video_privateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI22_generic_video_privateED2Ev($2);
  ;
  return;
}


function __Z18debug_console_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$machine;
      var $3=__Z17text_buffer_allocjj(1048576, 52428);
      HEAP32[((__ZL15console_textbuf)>>2)]=$3;
      var $4=HEAP32[((__ZL15console_textbuf)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      __label__ = 5; break;
    case 2: // $7
      var $8=__Z17text_buffer_allocjj(1048576, 52428);
      HEAP32[((__ZL16errorlog_textbuf)>>2)]=$8;
      var $9=HEAP32[((__ZL16errorlog_textbuf)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $11
      __label__ = 5; break;
    case 4: // $12
      var $13=$1;
      __Z20debug_console_printfR15running_machinePKcz($13, ((STRING_TABLE.__str4133)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE._build_version)|0),tempInt));
      var $14=$1;
      var $15=$1;
      var $16=__ZNK15running_machine6systemEv($15);
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$1;
      var $20=__ZNK15running_machine6systemEv($19);
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($14, ((STRING_TABLE.__str14134)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,HEAP32[((tempInt+4)>>2)]=$22,tempInt));
      var $23=$1;
      var $24=$1;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 1010, ((STRING_TABLE.__str24135)|0), $24);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($23, 4, $2);
      __label__ = 5; break;
    case 5: // $25
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI22_generic_audio_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22_generic_audio_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22_generic_audio_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI22_generic_audio_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI22_generic_audio_privateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18generic_video_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i2=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i1=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $result_i=__stackBase__+64;
      var $15=__stackBase__+68;
      var $16=__stackBase__+72;
      var $17;
      var $state;
      var $18;
      var $19;
      $17=$machine;
      var $20=$17;
      var $21=__ZN15running_machine7respoolEv($20);
      var $22=$11;
      var $23=$12;
      var $24=$13;
      var $25=$14;
      var $26=$result_i;
      var $27=$15;
      var $28=$16;
      HEAP32[(($11)>>2)]=8;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str4118)|0);
      HEAP32[(($13)>>2)]=234;
      HEAP32[(($14)>>2)]=_zeromem;
      var $29=HEAP32[(($11)>>2)];
      var $30=HEAP32[(($12)>>2)];
      var $31=HEAP32[(($13)>>2)];
      var $32=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($29, $30, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $33
      HEAP32[(($result_i)>>2)]=$32;
      var $34=HEAP32[(($result_i)>>2)];
      var $35=(($34)|0)==0;
      if ($35) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $36
      var $37=___cxa_allocate_exception(4);
      var $38=$37;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38);
      (function() { try { __THREW__ = false; return ___cxa_throw($37, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      HEAP32[(($15)>>2)]=$41;
      var $42=$40.f1;
      HEAP32[(($16)>>2)]=$42;
      var $43=HEAP32[(($16)>>2)];
      var $44=(($43)|0) < 0;
      if ($44) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $45
      var $46=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 5: // $47
      var $48=HEAP32[(($15)>>2)];
      var $49=HEAP32[(($15)>>2)];
      var $50=HEAP32[(($16)>>2)];
      var $51=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $49, tempValue);
      var $52=($51.f1 = $50, $51);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $53
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $54=HEAP32[(($result_i)>>2)];
      var $55=HEAP32[(($11)>>2)];
      _memset($54, 0, $55, 1);
      var $56=HEAP32[(($result_i)>>2)];
      var $57=$11;
      var $58=$12;
      var $59=$13;
      var $60=$14;
      var $61=$result_i;
      var $62=$15;
      var $63=$16;
      var $64=$56;
      var $65=__ZN13resource_pool10add_objectI22_generic_video_privateEEPT_S3_($21, $64);
      var $66=$17;
      var $67=(($66+660)|0);
      HEAP32[(($67)>>2)]=$65;
      $state=$65;
      var $68=$17;
      var $69=__ZN15running_machine4saveEv($68);
      var $70=$state;
      var $71=(($70)|0);
      __ZN12save_manager9save_itemIiEEvRT_PKci($69, $71, ((STRING_TABLE.__str14119)|0), 0);
      var $72=$17;
      var $73=__ZN15running_machine4saveEv($72);
      var $74=$state;
      var $75=(($74+4)|0);
      __ZN12save_manager9save_itemIiEEvRT_PKci($73, $75, ((STRING_TABLE.__str24120)|0), 0);
      var $76=$17;
      var $77=__ZNK15running_machine6configEv($76);
      var $78=(($77+40)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$79 & 64;
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 8; break; } else { __label__ = 31; break; }
    case 8: // $82
      __label__ = 9; break;
    case 9: // $83
      var $84=$17;
      var $85=(($84+588)|0);
      var $86=(($85+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $89
      var $90=___cxa_allocate_exception(1032);
      var $91=$90;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($91, ((STRING_TABLE.__str34121)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str44122)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str4118)|0),HEAP32[((tempInt+8)>>2)]=242,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $92
      ___cxa_throw($90, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 12: // $93
      var $94=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $95=$94.f0;
      $18=$95;
      var $96=$94.f1;
      $19=$96;
      ___cxa_free_exception($90);
      __label__ = 32; break;
    case 13: // $97
      __label__ = 14; break;
    case 14: // $98
      var $99=$17;
      var $100=__ZN15running_machine7respoolEv($99);
      var $101=$17;
      var $102=(($101+588)|0);
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$6;
      var $106=$7;
      var $107=$8;
      var $108=$result_i1;
      var $109=$9;
      var $110=$10;
      HEAP32[(($6)>>2)]=$104;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str4118)|0);
      HEAP32[(($8)>>2)]=245;
      var $111=HEAP32[(($6)>>2)];
      var $112=HEAP32[(($7)>>2)];
      var $113=HEAP32[(($8)>>2)];
      var $114=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($111, $112, $113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $115
      HEAP32[(($result_i1)>>2)]=$114;
      var $116=HEAP32[(($result_i1)>>2)];
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $118
      var $119=___cxa_allocate_exception(4);
      var $120=$119;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($120);
      (function() { try { __THREW__ = false; return ___cxa_throw($119, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 17; break; }
    case 17: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $123=$122.f0;
      HEAP32[(($9)>>2)]=$123;
      var $124=$122.f1;
      HEAP32[(($10)>>2)]=$124;
      var $125=HEAP32[(($10)>>2)];
      var $126=(($125)|0) < 0;
      if ($126) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $127
      var $128=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($128);
      throw "Reached an unreachable!"
    case 19: // $129
      var $130=HEAP32[(($9)>>2)];
      var $131=HEAP32[(($9)>>2)];
      var $132=HEAP32[(($10)>>2)];
      var $133=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $131, tempValue);
      var $134=($133.f1 = $132, $133);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $135
      throw "Reached an unreachable!"
    case 21: // $_ZnajPKci_exit
      var $136=HEAP32[(($result_i1)>>2)];
      var $137=$6;
      var $138=$7;
      var $139=$8;
      var $140=$result_i1;
      var $141=$9;
      var $142=$10;
      var $143=$17;
      var $144=(($143+588)|0);
      var $145=(($144+4)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=__ZN13resource_pool9add_arrayIhEEPT_S2_i($100, $136, $146);
      var $148=$17;
      var $149=(($148+588)|0);
      var $150=(($149+16)|0);
      var $151=$150;
      HEAP32[(($151)>>2)]=$147;
      var $152=$17;
      var $153=__ZN15running_machine4saveEv($152);
      var $154=$17;
      var $155=(($154+588)|0);
      var $156=(($155+16)|0);
      var $157=$156;
      var $158=HEAP32[(($157)>>2)];
      var $159=$17;
      var $160=(($159+588)|0);
      var $161=(($160+4)|0);
      var $162=HEAP32[(($161)>>2)];
      __ZN12save_manager12save_pointerIhEEvPT_PKcji($153, $158, ((STRING_TABLE.__str54124)|0), $162, 0);
      var $163=$17;
      var $164=(($163+588)|0);
      var $165=(($164+12)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166)|0)!=0;
      if ($167) { __label__ = 22; break; } else { __label__ = 30; break; }
    case 22: // $168
      var $169=$17;
      var $170=__ZN15running_machine7respoolEv($169);
      var $171=$17;
      var $172=(($171+588)|0);
      var $173=(($172+12)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$1;
      var $176=$2;
      var $177=$3;
      var $178=$result_i2;
      var $179=$4;
      var $180=$5;
      HEAP32[(($1)>>2)]=$174;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4118)|0);
      HEAP32[(($3)>>2)]=254;
      var $181=HEAP32[(($1)>>2)];
      var $182=HEAP32[(($2)>>2)];
      var $183=HEAP32[(($3)>>2)];
      var $184=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($181, $182, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; };
    case 23: // $185
      HEAP32[(($result_i2)>>2)]=$184;
      var $186=HEAP32[(($result_i2)>>2)];
      var $187=(($186)|0)==0;
      if ($187) { __label__ = 24; break; } else { __label__ = 29; break; }
    case 24: // $188
      var $189=___cxa_allocate_exception(4);
      var $190=$189;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($190);
      (function() { try { __THREW__ = false; return ___cxa_throw($189, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 25; break; }
    case 25: // $191
      var $192=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $193=$192.f0;
      HEAP32[(($4)>>2)]=$193;
      var $194=$192.f1;
      HEAP32[(($5)>>2)]=$194;
      var $195=HEAP32[(($5)>>2)];
      var $196=(($195)|0) < 0;
      if ($196) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $197
      var $198=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($198);
      throw "Reached an unreachable!"
    case 27: // $199
      var $200=HEAP32[(($4)>>2)];
      var $201=HEAP32[(($4)>>2)];
      var $202=HEAP32[(($5)>>2)];
      var $203=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $201, tempValue);
      var $204=($203.f1 = $202, $203);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 28: // $205
      throw "Reached an unreachable!"
    case 29: // $_ZnajPKci_exit3
      var $206=HEAP32[(($result_i2)>>2)];
      var $207=$1;
      var $208=$2;
      var $209=$3;
      var $210=$result_i2;
      var $211=$4;
      var $212=$5;
      var $213=$17;
      var $214=(($213+588)|0);
      var $215=(($214+12)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=__ZN13resource_pool9add_arrayIhEEPT_S2_i($170, $206, $216);
      var $218=$17;
      var $219=(($218+588)|0);
      var $220=(($219+20)|0);
      var $221=$220;
      HEAP32[(($221)>>2)]=$217;
      var $222=$17;
      var $223=__ZN15running_machine4saveEv($222);
      var $224=$17;
      var $225=(($224+588)|0);
      var $226=(($225+20)|0);
      var $227=$226;
      var $228=HEAP32[(($227)>>2)];
      var $229=$17;
      var $230=(($229+588)|0);
      var $231=(($230+12)|0);
      var $232=HEAP32[(($231)>>2)];
      __ZN12save_manager12save_pointerIhEEvPT_PKcji($223, $228, ((STRING_TABLE.__str64125)|0), $232, 0);
      __label__ = 30; break;
    case 30: // $233
      __label__ = 31; break;
    case 31: // $234
      STACKTOP = __stackBase__;
      return;
    case 32: // $235
      var $236=$18;
      var $237=$18;
      var $238=$19;
      var $239=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $237, tempValue);
      var $240=($239.f1 = $238, $239);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18generic_video_initR15running_machine["X"]=1;

function __ZN13resource_pool10add_objectI22_generic_video_privateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22_generic_video_privateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI22_generic_video_privateEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI22_generic_video_privateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI22_generic_video_privateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI22_generic_video_privateED0Ev["X"]=1;

function __ZN20resource_pool_objectI22_generic_video_privateED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI22_generic_video_privateE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z22debug_cmderr_to_stringj($error) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$error;
      var $3=$2;
      var $4=$3 >>> 16;
      if ($4 == 1) {
        __label__ = 1; break;
      }
      else if ($4 == 2) {
        __label__ = 2; break;
      }
      else if ($4 == 3) {
        __label__ = 3; break;
      }
      else if ($4 == 4) {
        __label__ = 4; break;
      }
      else if ($4 == 5) {
        __label__ = 5; break;
      }
      else if ($4 == 6) {
        __label__ = 6; break;
      }
      else if ($4 == 7) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 1: // $5
      $1=((STRING_TABLE.__str114144)|0);
      __label__ = 9; break;
    case 2: // $6
      $1=((STRING_TABLE.__str124145)|0);
      __label__ = 9; break;
    case 3: // $7
      $1=((STRING_TABLE.__str134146)|0);
      __label__ = 9; break;
    case 4: // $8
      $1=((STRING_TABLE.__str144147)|0);
      __label__ = 9; break;
    case 5: // $9
      $1=((STRING_TABLE.__str154148)|0);
      __label__ = 9; break;
    case 6: // $10
      $1=((STRING_TABLE.__str164149)|0);
      __label__ = 9; break;
    case 7: // $11
      $1=((STRING_TABLE.__str174150)|0);
      __label__ = 9; break;
    case 8: // $12
      $1=((STRING_TABLE.__str184151)|0);
      __label__ = 9; break;
    case 9: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18debug_console_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=HEAP32[((__ZL15console_textbuf)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=HEAP32[((__ZL15console_textbuf)>>2)];
      __Z16text_buffer_freeP12_text_buffer($5);
      __label__ = 2; break;
    case 2: // $6
      HEAP32[((__ZL15console_textbuf)>>2)]=0;
      var $7=HEAP32[((__ZL16errorlog_textbuf)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      var $10=HEAP32[((__ZL16errorlog_textbuf)>>2)];
      __Z16text_buffer_freeP12_text_buffer($10);
      __label__ = 4; break;
    case 4: // $11
      HEAP32[((__ZL16errorlog_textbuf)>>2)]=0;
      HEAP32[((__ZL11commandlist)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z29debug_console_execute_commandR15running_machinePKci($machine, $command, $echo) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      $1=$machine;
      $2=$command;
      $3=$echo;
      var $4=$3;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=$2;
      __Z20debug_console_printfR15running_machinePKcz($7, ((STRING_TABLE.__str34136)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$8,tempInt));
      __label__ = 2; break;
    case 2: // $9
      var $10=$1;
      var $11=$2;
      var $12=__ZL22internal_parse_commandR15running_machinePKci($10, $11, 1);
      $result=$12;
      var $13=$result;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $15
      var $16=$3;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $18
      var $19=$1;
      var $20=$2;
      __Z20debug_console_printfR15running_machinePKcz($19, ((STRING_TABLE.__str34136)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,tempInt));
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      var $23=$result;
      var $24=$23 & 65535;
      __Z20debug_console_printfR15running_machinePKcz($22, ((STRING_TABLE.__str44137)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,HEAP32[((tempInt+4)>>2)]=((__str54138)|0),tempInt));
      var $25=$1;
      var $26=$result;
      var $27=__Z22debug_cmderr_to_stringj($26);
      __Z20debug_console_printfR15running_machinePKcz($25, ((STRING_TABLE.__str64139)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$27,tempInt));
      __label__ = 6; break;
    case 6: // $28
      var $29=$3;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$1;
      var $33=__ZNK15running_machine10debug_viewEv($32);
      __ZN18debug_view_manager10update_allE15debug_view_type($33, 0);
      var $34=$1;
      __Z24debugger_refresh_displayR15running_machine($34);
      __label__ = 8; break;
    case 8: // $35
      var $36=$result;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z30debug_console_validate_commandR15running_machinePKc($machine, $command) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$command;
  var $3=$1;
  var $4=$2;
  var $5=__ZL22internal_parse_commandR15running_machinePKci($3, $4, 0);
  ;
  return $5;
}


function __Z20debug_console_printfR15running_machinePKcz($machine, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $buffer=__stackBase__;
      var $arg=__stackBase__+64;
      var $3;
      var $4;
      $1=$machine;
      $2=$format;
      __ZN7astringC1Ev($buffer);
      var $5=$arg;
      HEAP32[(($5)>>2)]=arguments[__Z20debug_console_printfR15running_machinePKcz.length];
      var $6=$2;
      var $7=HEAP32[(($arg)>>2)];
      var $8=(function() { try { __THREW__ = false; return __ZN7astring7vprintfEPKcPc($buffer, $6, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $9
      var $10=$arg;
      ;
      var $11=HEAP32[((__ZL15console_textbuf)>>2)];
      var $12=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $13
      (function() { try { __THREW__ = false; return __Z17text_buffer_printP12_text_bufferPKc($11, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $14
      var $15=$1;
      var $16=(function() { try { __THREW__ = false; return __ZNK15running_machine10debug_viewEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $17
      (function() { try { __THREW__ = false; return __ZN18debug_view_manager10update_allE15debug_view_type($16, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $18
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 6: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $3=$21;
      var $22=$20.f1;
      $4=$22;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$3;
      var $26=$3;
      var $27=$4;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22internal_parse_commandR15running_machinePKci($machine, $original_command, $execute) {
  var __stackBase__  = STACKTOP; STACKTOP += 1720; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $command=__stackBase__;
      var $parens=__stackBase__+512;
      var $params=__stackBase__+1024;
      var $result;
      var $command_start;
      var $p;
      var $c;
      var $paramcount;
      var $foundend;
      var $instring;
      var $isexpr;
      var $parendex;
      var $expresult=__stackBase__+1088;
      var $expression=__stackBase__+1096;
      var $5;
      var $6;
      var $err;
      var $7;
      $2=$machine;
      $3=$original_command;
      $4=$execute;
      var $8=$params;
      for (var $$dest = $8>>2, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      $result=0;
      $c=0;
      var $9=(($command)|0);
      var $10=$3;
      var $11=_strcpy($9, $10);
      var $12=(($command)|0);
      $p=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$p;
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 76; break; }
    case 2: // $18
      $paramcount=0;
      $foundend=0;
      $instring=0;
      $isexpr=0;
      $parendex=0;
      var $19=$p;
      var $20=$paramcount;
      var $21=(($20+1)|0);
      $paramcount=$21;
      var $22=(($params+($20<<2))|0);
      HEAP32[(($22)>>2)]=$19;
      __label__ = 3; break;
    case 3: // $23
      var $24=$foundend;
      var $25=(($24)|0)!=0;
      var $26=$25 ^ 1;
      if ($26) { __label__ = 4; break; } else { __label__ = 49; break; }
    case 4: // $27
      var $28=$p;
      var $29=HEAP8[($28)];
      $c=$29;
      var $30=$instring;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $32
      var $33=$c;
      var $34=(($33 << 24) >> 24);
      var $35=(($34)|0)==34;
      if ($35) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=$p;
      var $38=(($37-1)|0);
      var $39=HEAP8[($38)];
      var $40=(($39 << 24) >> 24);
      var $41=(($40)|0)!=92;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      $instring=0;
      __label__ = 8; break;
    case 8: // $43
      __label__ = 47; break;
    case 9: // $44
      var $45=$c;
      var $46=(($45 << 24) >> 24);
      if ($46 == 34) {
        __label__ = 10; break;
      }
      else if ($46 == 40 || $46 == 91 || $46 == 123) {
        __label__ = 11; break;
      }
      else if ($46 == 41) {
        __label__ = 12; break;
      }
      else if ($46 == 93) {
        __label__ = 16; break;
      }
      else if ($46 == 125) {
        __label__ = 20; break;
      }
      else if ($46 == 44) {
        __label__ = 24; break;
      }
      else if ($46 == 59) {
        __label__ = 27; break;
      }
      else if ($46 == 45) {
        __label__ = 30; break;
      }
      else if ($46 == 43) {
        __label__ = 35; break;
      }
      else if ($46 == 61) {
        __label__ = 40; break;
      }
      else if ($46 == 0) {
        __label__ = 44; break;
      }
      else {
      __label__ = 45; break;
      }
      
    case 10: // $47
      $instring=1;
      __label__ = 46; break;
    case 11: // $48
      var $49=$c;
      var $50=$parendex;
      var $51=(($50+1)|0);
      $parendex=$51;
      var $52=(($parens+$50)|0);
      HEAP8[($52)]=$49;
      __label__ = 46; break;
    case 12: // $53
      var $54=$parendex;
      var $55=(($54)|0)==0;
      if ($55) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $56
      var $57=$parendex;
      var $58=(($57-1)|0);
      $parendex=$58;
      var $59=(($parens+$58)|0);
      var $60=HEAP8[($59)];
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)!=40;
      if ($62) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $63
      var $64=$p;
      var $65=(($command)|0);
      var $66=$64;
      var $67=$65;
      var $68=(($66-$67)|0);
      var $69=$68 & 65535;
      var $70=196608 | $69;
      $1=$70;
      __label__ = 77; break;
    case 15: // $71
      __label__ = 46; break;
    case 16: // $72
      var $73=$parendex;
      var $74=(($73)|0)==0;
      if ($74) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $75
      var $76=$parendex;
      var $77=(($76-1)|0);
      $parendex=$77;
      var $78=(($parens+$77)|0);
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24);
      var $81=(($80)|0)!=91;
      if ($81) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $82
      var $83=$p;
      var $84=(($command)|0);
      var $85=$83;
      var $86=$84;
      var $87=(($85-$86)|0);
      var $88=$87 & 65535;
      var $89=196608 | $88;
      $1=$89;
      __label__ = 77; break;
    case 19: // $90
      __label__ = 46; break;
    case 20: // $91
      var $92=$parendex;
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $94
      var $95=$parendex;
      var $96=(($95-1)|0);
      $parendex=$96;
      var $97=(($parens+$96)|0);
      var $98=HEAP8[($97)];
      var $99=(($98 << 24) >> 24);
      var $100=(($99)|0)!=123;
      if ($100) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $101
      var $102=$p;
      var $103=(($command)|0);
      var $104=$102;
      var $105=$103;
      var $106=(($104-$105)|0);
      var $107=$106 & 65535;
      var $108=196608 | $107;
      $1=$108;
      __label__ = 77; break;
    case 23: // $109
      __label__ = 46; break;
    case 24: // $110
      var $111=$parendex;
      var $112=(($111)|0)==0;
      if ($112) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $113
      var $114=$p;
      var $115=$paramcount;
      var $116=(($115+1)|0);
      $paramcount=$116;
      var $117=(($params+($115<<2))|0);
      HEAP32[(($117)>>2)]=$114;
      __label__ = 26; break;
    case 26: // $118
      __label__ = 46; break;
    case 27: // $119
      var $120=$parendex;
      var $121=(($120)|0)==0;
      if ($121) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $122
      $foundend=1;
      __label__ = 29; break;
    case 29: // $123
      __label__ = 46; break;
    case 30: // $124
      var $125=$parendex;
      var $126=(($125)|0)==0;
      if ($126) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $127
      var $128=$paramcount;
      var $129=(($128)|0)==1;
      if ($129) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $130
      var $131=$p;
      var $132=(($131+1)|0);
      var $133=HEAP8[($132)];
      var $134=(($133 << 24) >> 24);
      var $135=(($134)|0)==45;
      if ($135) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $136
      $isexpr=1;
      __label__ = 34; break;
    case 34: // $137
      var $138=$c;
      var $139=$p;
      HEAP8[($139)]=$138;
      __label__ = 46; break;
    case 35: // $140
      var $141=$parendex;
      var $142=(($141)|0)==0;
      if ($142) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $143
      var $144=$paramcount;
      var $145=(($144)|0)==1;
      if ($145) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $146
      var $147=$p;
      var $148=(($147+1)|0);
      var $149=HEAP8[($148)];
      var $150=(($149 << 24) >> 24);
      var $151=(($150)|0)==43;
      if ($151) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $152
      $isexpr=1;
      __label__ = 39; break;
    case 39: // $153
      var $154=$c;
      var $155=$p;
      HEAP8[($155)]=$154;
      __label__ = 46; break;
    case 40: // $156
      var $157=$parendex;
      var $158=(($157)|0)==0;
      if ($158) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $159
      var $160=$paramcount;
      var $161=(($160)|0)==1;
      if ($161) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $162
      $isexpr=1;
      __label__ = 43; break;
    case 43: // $163
      var $164=$c;
      var $165=$p;
      HEAP8[($165)]=$164;
      __label__ = 46; break;
    case 44: // $166
      $foundend=1;
      __label__ = 46; break;
    case 45: // $167
      var $168=$c;
      var $169=(($168)&255);
      var $170=_tolower($169);
      var $171=(($170) & 255);
      var $172=$p;
      HEAP8[($172)]=$171;
      __label__ = 46; break;
    case 46: // $173
      __label__ = 47; break;
    case 47: // $174
      __label__ = 48; break;
    case 48: // $175
      var $176=$p;
      var $177=(($176+1)|0);
      $p=$177;
      __label__ = 3; break;
    case 49: // $178
      var $179=$instring;
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $181
      var $182=$p;
      var $183=(($command)|0);
      var $184=$182;
      var $185=$183;
      var $186=(($184-$185)|0);
      var $187=$186 & 65535;
      var $188=262144 | $187;
      $1=$188;
      __label__ = 77; break;
    case 51: // $189
      var $190=$parendex;
      var $191=(($190)|0)!=0;
      if ($191) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $192
      var $193=$p;
      var $194=(($command)|0);
      var $195=$193;
      var $196=$194;
      var $197=(($195-$196)|0);
      var $198=$197 & 65535;
      var $199=196608 | $198;
      $1=$199;
      __label__ = 77; break;
    case 53: // $200
      var $201=$p;
      var $202=(($201-1)|0);
      $p=$202;
      var $203=$c;
      var $204=(($203 << 24) >> 24);
      var $205=(($204)|0)==59;
      if ($205) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $206
      var $207=$p;
      var $208=(($207+1)|0);
      $p=$208;
      HEAP8[($207)]=0;
      __label__ = 55; break;
    case 55: // $209
      var $210=(($params)|0);
      var $211=HEAP32[(($210)>>2)];
      $command_start=$211;
      var $212=$command_start;
      var $213=(($212)|0);
      var $214=HEAPU8[($213)];
      var $215=(($214)&255);
      var $216=(($215)|0)==100;
      var $217=(($216)&1);
      var $218=_tolower($217);
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $220
      var $221=$command_start;
      var $222=(($221+1)|0);
      var $223=HEAPU8[($222)];
      var $224=(($223)&255);
      var $225=(($224)|0)==111;
      var $226=(($225)&1);
      var $227=_tolower($226);
      var $228=(($227)|0)!=0;
      if ($228) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $229
      var $230=$command_start;
      var $231=(($230+2)|0);
      var $232=HEAPU8[($231)];
      var $233=(($232)&255);
      var $234=_isspace($233);
      var $235=(($234)|0)!=0;
      if ($235) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $236
      $isexpr=1;
      var $237=$command_start;
      var $238=(($237+3)|0);
      $command_start=$238;
      __label__ = 59; break;
    case 59: // $239
      var $240=$isexpr;
      var $241=(($240)|0)!=0;
      if ($241) { __label__ = 60; break; } else { __label__ = 72; break; }
    case 60: // $242
      var $243=$paramcount;
      var $244=(($243)|0)==1;
      if ($244) { __label__ = 61; break; } else { __label__ = 72; break; }
    case 61: // $245
      var $246=$2;
      var $247=(function() { try { __THREW__ = false; return __Z30debug_cpu_get_visible_symtableR15running_machine($246) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 65; break; };
    case 62: // $248
      var $249=$command_start;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($expression, $247, $249, $expresult) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 63: // $250
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($expression) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $251
      __label__ = 71; break;
    case 65: // $252
      var $253=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $254=$253.f0;
      $5=$254;
      var $255=$253.f1;
      $6=$255;
      __label__ = 66; break;
    case 66: // $256
      var $257=$6;
      var $258=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $259=(($257)|0)==(($258)|0);
      if ($259) { __label__ = 67; break; } else { __label__ = 78; break; }
    case 67: // $260
      var $261=$5;
      var $262=___cxa_begin_catch($261);
      var $263=$262;
      $err=$263;
      var $264=$err;
      var $265=(function() { try { __THREW__ = false; return __ZNK16expression_errorcvNS_10error_codeEEv($264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 69; break; };
    case 68: // $266
      var $267=$265 & 65535;
      var $268=458752 | $267;
      $1=$268;
      $7=1;
      ___cxa_end_catch();
      __label__ = 77; break;
    case 69: // $269
      var $270=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $271=$270.f0;
      $5=$271;
      var $272=$270.f1;
      $6=$272;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 79; break; }
    case 70: // $273
      __label__ = 78; break;
    case 71: // $274
      __label__ = 75; break;
    case 72: // $275
      var $276=$2;
      var $277=$4;
      var $278=$paramcount;
      var $279=(($params)|0);
      var $280=__ZL24internal_execute_commandR15running_machineiiPPc($276, $277, $278, $279);
      $result=$280;
      var $281=$result;
      var $282=(($281)|0)!=0;
      if ($282) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $283
      var $284=$result;
      var $285=$284 >>> 16;
      var $286=$285 << 16;
      var $287=$command_start;
      var $288=(($command)|0);
      var $289=$287;
      var $290=$288;
      var $291=(($289-$290)|0);
      var $292=$291 & 65535;
      var $293=$286 | $292;
      $1=$293;
      __label__ = 77; break;
    case 74: // $294
      __label__ = 75; break;
    case 75: // $295
      __label__ = 1; break;
    case 76: // $296
      $1=0;
      __label__ = 77; break;
    case 77: // $297
      var $298=$1;
      STACKTOP = __stackBase__;
      return $298;
    case 78: // $299
      var $300=$5;
      var $301=$5;
      var $302=$6;
      var $303=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $301, tempValue);
      var $304=($303.f1 = $302, $303);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 79: // $305
      var $306=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22internal_parse_commandR15running_machinePKci["X"]=1;

function __Z25debug_console_get_textbufv() {
  ;
  var __label__;

  var $1=HEAP32[((__ZL15console_textbuf)>>2)];
  ;
  return $1;
}


function __Z26debug_errorlog_get_textbufv() {
  ;
  var __label__;

  var $1=HEAP32[((__ZL16errorlog_textbuf)>>2)];
  ;
  return $1;
}


function __ZNK16expression_errorcvNS_10error_codeEEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z25debug_errorlog_write_lineR15running_machinePKc($machine, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$machine;
      $2=$line;
      var $3=HEAP32[((__ZL16errorlog_textbuf)>>2)];
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=HEAP32[((__ZL16errorlog_textbuf)>>2)];
      var $7=$2;
      __Z17text_buffer_printP12_text_bufferPKc($6, $7);
      __label__ = 2; break;
    case 2: // $8
      var $9=$1;
      var $10=__ZNK15running_machine10debug_viewEv($9);
      __ZN18debug_view_manager10update_allE15debug_view_type($10, 5);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI14_debug_commandEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14_debug_commandEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14_debug_commandEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 68);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14_debug_commandE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14_debug_commandED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14_debug_commandED2Ev($2);
  ;
  return;
}


function __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($machine, $command, $flags, $ref, $minparams, $maxparams, $handler) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $cmd;
      var $14;
      var $15;
      $7=$machine;
      $8=$command;
      $9=$flags;
      $10=$ref;
      $11=$minparams;
      $12=$maxparams;
      $13=$handler;
      __label__ = 1; break;
    case 1: // $16
      var $17=$7;
      var $18=__ZNK15running_machine5phaseEv($17);
      var $19=(($18)|0)==1;
      if ($19) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $20
      var $21=___cxa_allocate_exception(1032);
      var $22=$21;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($22, ((STRING_TABLE.__str74140)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str84141)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str94142)|0),HEAP32[((tempInt+8)>>2)]=417,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      ___cxa_throw($21, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $14=$26;
      var $27=$25.f1;
      $15=$27;
      ___cxa_free_exception($21);
      __label__ = 20; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=$7;
      var $32=(($31+584)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33 & 1;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $36
      var $37=___cxa_allocate_exception(1032);
      var $38=$37;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($38, ((STRING_TABLE.__str74140)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str104143)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str94142)|0),HEAP32[((tempInt+8)>>2)]=418,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      ___cxa_throw($37, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 10: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $14=$42;
      var $43=$41.f1;
      $15=$43;
      ___cxa_free_exception($37);
      __label__ = 20; break;
    case 11: // $44
      __label__ = 12; break;
    case 12: // $45
      var $46=$7;
      var $47=__ZN15running_machine7respoolEv($46);
      var $48=$1;
      var $49=$2;
      var $50=$3;
      var $51=$4;
      var $52=$result_i;
      var $53=$5;
      var $54=$6;
      HEAP32[(($1)>>2)]=68;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str94142)|0);
      HEAP32[(($3)>>2)]=420;
      HEAP32[(($4)>>2)]=_zeromem;
      var $55=HEAP32[(($1)>>2)];
      var $56=HEAP32[(($2)>>2)];
      var $57=HEAP32[(($3)>>2)];
      var $58=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $59
      HEAP32[(($result_i)>>2)]=$58;
      var $60=HEAP32[(($result_i)>>2)];
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $62
      var $63=___cxa_allocate_exception(4);
      var $64=$63;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($64);
      (function() { try { __THREW__ = false; return ___cxa_throw($63, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      HEAP32[(($5)>>2)]=$67;
      var $68=$66.f1;
      HEAP32[(($6)>>2)]=$68;
      var $69=HEAP32[(($6)>>2)];
      var $70=(($69)|0) < 0;
      if ($70) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $71
      var $72=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($72);
      throw "Reached an unreachable!"
    case 17: // $73
      var $74=HEAP32[(($5)>>2)];
      var $75=HEAP32[(($5)>>2)];
      var $76=HEAP32[(($6)>>2)];
      var $77=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $75, tempValue);
      var $78=($77.f1 = $76, $77);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $79
      throw "Reached an unreachable!"
    case 19: // $_ZnwjPKciRK9zeromem_t_exit
      var $80=HEAP32[(($result_i)>>2)];
      var $81=HEAP32[(($1)>>2)];
      _memset($80, 0, $81, 1);
      var $82=HEAP32[(($result_i)>>2)];
      var $83=$1;
      var $84=$2;
      var $85=$3;
      var $86=$4;
      var $87=$result_i;
      var $88=$5;
      var $89=$6;
      var $90=$82;
      var $91=__ZN13resource_pool10add_objectI14_debug_commandEEPT_S3_($47, $90);
      $cmd=$91;
      var $92=$cmd;
      var $93=(($92+4)|0);
      var $94=(($93)|0);
      var $95=$8;
      var $96=_strcpy($94, $95);
      var $97=$9;
      var $98=$cmd;
      var $99=(($98+52)|0);
      HEAP32[(($99)>>2)]=$97;
      var $100=$10;
      var $101=$cmd;
      var $102=(($101+56)|0);
      HEAP32[(($102)>>2)]=$100;
      var $103=$11;
      var $104=$cmd;
      var $105=(($104+60)|0);
      HEAP32[(($105)>>2)]=$103;
      var $106=$12;
      var $107=$cmd;
      var $108=(($107+64)|0);
      HEAP32[(($108)>>2)]=$106;
      var $109=$13;
      var $110=$cmd;
      var $111=(($110+44)|0);
      HEAP32[(($111)>>2)]=$109;
      var $112=HEAP32[((__ZL11commandlist)>>2)];
      var $113=$cmd;
      var $114=(($113)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=$cmd;
      HEAP32[((__ZL11commandlist)>>2)]=$115;
      STACKTOP = __stackBase__;
      return;
    case 20: // $116
      var $117=$14;
      var $118=$14;
      var $119=$15;
      var $120=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $118, tempValue);
      var $121=($120.f1 = $119, $120);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E["X"]=1;

function __ZN13resource_pool10add_objectI14_debug_commandEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14_debug_commandEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14_debug_commandEEPT_S3_["X"]=1;

function __Z21debug_console_vprintfR15running_machinePKcPc($machine, $format, $args) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buffer=__stackBase__;
      var $4;
      var $5;
      $1=$machine;
      $2=$format;
      $3=$args;
      __ZN7astringC1Ev($buffer);
      var $6=$2;
      var $7=$3;
      var $8=(function() { try { __THREW__ = false; return __ZN7astring7vprintfEPKcPc($buffer, $6, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $9
      var $10=HEAP32[((__ZL15console_textbuf)>>2)];
      var $11=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $12
      (function() { try { __THREW__ = false; return __Z17text_buffer_printP12_text_bufferPKc($10, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $13
      var $14=$1;
      var $15=(function() { try { __THREW__ = false; return __ZNK15running_machine10debug_viewEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $16
      (function() { try { __THREW__ = false; return __ZN18debug_view_manager10update_allE15debug_view_type($15, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 6: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $4=$20;
      var $21=$19.f1;
      $5=$21;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $22
      __label__ = 8; break;
    case 8: // $23
      var $24=$4;
      var $25=$4;
      var $26=$5;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z25debug_console_printf_wrapR15running_machineiPKcz($machine, $wrapcol, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buffer=__stackBase__;
      var $arg=__stackBase__+64;
      var $4;
      var $5;
      $1=$machine;
      $2=$wrapcol;
      $3=$format;
      __ZN7astringC1Ev($buffer);
      var $6=$arg;
      HEAP32[(($6)>>2)]=arguments[__Z25debug_console_printf_wrapR15running_machineiPKcz.length];
      var $7=$3;
      var $8=HEAP32[(($arg)>>2)];
      var $9=(function() { try { __THREW__ = false; return __ZN7astring7vprintfEPKcPc($buffer, $7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $10
      var $11=$arg;
      ;
      var $12=HEAP32[((__ZL15console_textbuf)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $14
      var $15=$2;
      (function() { try { __THREW__ = false; return __Z22text_buffer_print_wrapP12_text_bufferPKci($12, $13, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $16
      var $17=$1;
      var $18=(function() { try { __THREW__ = false; return __ZNK15running_machine10debug_viewEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $19
      (function() { try { __THREW__ = false; return __ZN18debug_view_manager10update_allE15debug_view_type($18, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $20
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 6: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=$4;
      var $28=$4;
      var $29=$5;
      var $30=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $28, tempValue);
      var $31=($30.f1 = $29, $30);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI14_debug_commandED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14_debug_commandED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14_debug_commandED0Ev["X"]=1;

function __ZN20resource_pool_objectI14_debug_commandED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI14_debug_commandE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL24internal_execute_commandR15running_machineiiPPc($machine, $execute, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $cmd;
      var $found;
      var $i;
      var $foundcount;
      var $p;
      var $command;
      var $len;
      $2=$machine;
      $3=$execute;
      $4=$params;
      $5=$param;
      $found=0;
      $foundcount=0;
      var $6=$4;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 53; break;
    case 2: // $9
      var $10=$5;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      $p=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$p;
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24)!=0;
      if ($16) { __label__ = 4; break; } else { var $24 = 0;__label__ = 5; break; }
    case 4: // $17
      var $18=$p;
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=_isspace($20);
      var $22=(($21)|0)!=0;
      var $24 = $22;__label__ = 5; break;
    case 5: // $23
      var $24;
      if ($24) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$p;
      var $28=(($27+1)|0);
      $p=$28;
      __label__ = 3; break;
    case 8: // $29
      var $30=$p;
      $command=$30;
      __label__ = 9; break;
    case 9: // $31
      var $32=$p;
      var $33=HEAP8[($32)];
      var $34=(($33 << 24) >> 24)!=0;
      if ($34) { __label__ = 10; break; } else { var $43 = 0;__label__ = 11; break; }
    case 10: // $35
      var $36=$p;
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=_isspace($38);
      var $40=(($39)|0)!=0;
      var $41=$40 ^ 1;
      var $43 = $41;__label__ = 11; break;
    case 11: // $42
      var $43;
      if ($43) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $44
      __label__ = 13; break;
    case 13: // $45
      var $46=$p;
      var $47=(($46+1)|0);
      $p=$47;
      __label__ = 9; break;
    case 14: // $48
      var $49=$p;
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24);
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 15; break; } else { __label__ = 25; break; }
    case 15: // $53
      var $54=$p;
      var $55=(($54+1)|0);
      $p=$55;
      HEAP8[($54)]=0;
      __label__ = 16; break;
    case 16: // $56
      var $57=$p;
      var $58=HEAP8[($57)];
      var $59=(($58 << 24) >> 24)!=0;
      if ($59) { __label__ = 17; break; } else { var $67 = 0;__label__ = 18; break; }
    case 17: // $60
      var $61=$p;
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=_isspace($63);
      var $65=(($64)|0)!=0;
      var $67 = $65;__label__ = 18; break;
    case 18: // $66
      var $67;
      if ($67) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $68
      __label__ = 20; break;
    case 20: // $69
      var $70=$p;
      var $71=(($70+1)|0);
      $p=$71;
      __label__ = 16; break;
    case 21: // $72
      var $73=$p;
      var $74=HEAP8[($73)];
      var $75=(($74 << 24) >> 24);
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $77
      var $78=$p;
      var $79=$5;
      var $80=(($79)|0);
      HEAP32[(($80)>>2)]=$78;
      __label__ = 24; break;
    case 23: // $81
      $4=0;
      __label__ = 24; break;
    case 24: // $82
      __label__ = 26; break;
    case 25: // $83
      $4=0;
      var $84=$5;
      var $85=(($84)|0);
      HEAP32[(($85)>>2)]=0;
      __label__ = 26; break;
    case 26: // $86
      var $87=$command;
      var $88=_strlen($87);
      $len=$88;
      var $89=HEAP32[((__ZL11commandlist)>>2)];
      $cmd=$89;
      __label__ = 27; break;
    case 27: // $90
      var $91=$cmd;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 28; break; } else { __label__ = 34; break; }
    case 28: // $93
      var $94=$command;
      var $95=$cmd;
      var $96=(($95+4)|0);
      var $97=(($96)|0);
      var $98=$len;
      var $99=_strncmp($94, $97, $98);
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 32; break; } else { __label__ = 29; break; }
    case 29: // $101
      var $102=$foundcount;
      var $103=(($102+1)|0);
      $foundcount=$103;
      var $104=$cmd;
      $found=$104;
      var $105=$cmd;
      var $106=(($105+4)|0);
      var $107=(($106)|0);
      var $108=_strlen($107);
      var $109=$len;
      var $110=(($108)|0)==(($109)|0);
      if ($110) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $111
      $foundcount=1;
      __label__ = 34; break;
    case 31: // $112
      __label__ = 32; break;
    case 32: // $113
      __label__ = 33; break;
    case 33: // $114
      var $115=$cmd;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      $cmd=$117;
      __label__ = 27; break;
    case 34: // $118
      var $119=$found;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $121
      $1=65536;
      __label__ = 53; break;
    case 36: // $122
      var $123=$foundcount;
      var $124=(($123)|0) > 1;
      if ($124) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $125
      $1=131072;
      __label__ = 53; break;
    case 38: // $126
      $i=1;
      __label__ = 39; break;
    case 39: // $127
      var $128=$i;
      var $129=$4;
      var $130=(($128)|0) < (($129)|0);
      if ($130) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $131
      var $132=$i;
      var $133=$5;
      var $134=(($133+($132<<2))|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+1)|0);
      HEAP32[(($134)>>2)]=$136;
      HEAP8[($135)]=0;
      __label__ = 41; break;
    case 41: // $137
      var $138=$i;
      var $139=(($138+1)|0);
      $i=$139;
      __label__ = 39; break;
    case 42: // $140
      $i=0;
      __label__ = 43; break;
    case 43: // $141
      var $142=$i;
      var $143=$4;
      var $144=(($142)|0) < (($143)|0);
      if ($144) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $145
      var $146=$i;
      var $147=$5;
      var $148=(($147+($146<<2))|0);
      var $149=$found;
      var $150=(($149+52)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$151 & 1;
      __ZL14trim_parameterPPci($148, $152);
      __label__ = 45; break;
    case 45: // $153
      var $154=$i;
      var $155=(($154+1)|0);
      $i=$155;
      __label__ = 43; break;
    case 46: // $156
      var $157=$4;
      var $158=$found;
      var $159=(($158+60)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($157)|0) < (($160)|0);
      if ($161) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $162
      $1=327680;
      __label__ = 53; break;
    case 48: // $163
      var $164=$4;
      var $165=$found;
      var $166=(($165+64)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($164)|0) > (($167)|0);
      if ($168) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $169
      $1=393216;
      __label__ = 53; break;
    case 50: // $170
      var $171=$3;
      var $172=(($171)|0)!=0;
      if ($172) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $173
      var $174=$found;
      var $175=(($174+44)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$2;
      var $178=$found;
      var $179=(($178+56)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$4;
      var $182=$5;
      FUNCTION_TABLE[$176]($177, $180, $181, $182);
      __label__ = 52; break;
    case 52: // $183
      $1=0;
      __label__ = 53; break;
    case 53: // $184
      var $185=$1;
      ;
      return $185;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24internal_execute_commandR15running_machineiiPPc["X"]=1;

function __ZL14trim_parameterPPci($paramptr, $keep_quotes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $param;
      var $len;
      var $repeat;
      $1=$paramptr;
      $2=$keep_quotes;
      var $3=$1;
      var $4=HEAP32[(($3)>>2)];
      $param=$4;
      var $5=$param;
      var $6=_strlen($5);
      $len=$6;
      __label__ = 1; break;
    case 1: // $7
      $repeat=0;
      var $8=$len;
      var $9=(($8)>>>0) >= 2;
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$param;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==34;
      if ($15) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $16
      var $17=$len;
      var $18=(($17-1)|0);
      var $19=$param;
      var $20=(($19+$18)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0)==34;
      if ($23) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $24
      var $25=$2;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $27
      var $28=$len;
      var $29=(($28-1)|0);
      var $30=$param;
      var $31=(($30+$29)|0);
      HEAP8[($31)]=0;
      var $32=$param;
      var $33=(($32+1)|0);
      $param=$33;
      var $34=$len;
      var $35=(($34-2)|0);
      $len=$35;
      __label__ = 6; break;
    case 6: // $36
      __label__ = 20; break;
    case 7: // $37
      var $38=$len;
      var $39=(($38)>>>0) >= 2;
      if ($39) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $40
      var $41=$param;
      var $42=(($41)|0);
      var $43=HEAP8[($42)];
      var $44=(($43 << 24) >> 24);
      var $45=(($44)|0)==123;
      if ($45) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $46
      var $47=$len;
      var $48=(($47-1)|0);
      var $49=$param;
      var $50=(($49+$48)|0);
      var $51=HEAP8[($50)];
      var $52=(($51 << 24) >> 24);
      var $53=(($52)|0)==125;
      if ($53) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $54
      var $55=$len;
      var $56=(($55-1)|0);
      var $57=$param;
      var $58=(($57+$56)|0);
      HEAP8[($58)]=0;
      var $59=$param;
      var $60=(($59+1)|0);
      $param=$60;
      var $61=$len;
      var $62=(($61-2)|0);
      $len=$62;
      $repeat=1;
      __label__ = 19; break;
    case 11: // $63
      var $64=$len;
      var $65=(($64)>>>0) >= 1;
      if ($65) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $66
      var $67=$param;
      var $68=(($67)|0);
      var $69=HEAP8[($68)];
      var $70=(($69 << 24) >> 24);
      var $71=(($70)|0)==32;
      if ($71) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $72
      var $73=$param;
      var $74=(($73+1)|0);
      $param=$74;
      var $75=$len;
      var $76=(($75-1)|0);
      $len=$76;
      $repeat=1;
      __label__ = 18; break;
    case 14: // $77
      var $78=$len;
      var $79=(($78)>>>0) >= 1;
      if ($79) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $80
      var $81=$len;
      var $82=(($81-1)|0);
      var $83=$param;
      var $84=(($83+$82)|0);
      var $85=HEAP8[($84)];
      var $86=(($85 << 24) >> 24);
      var $87=(($86)|0)==32;
      if ($87) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $88
      var $89=$len;
      var $90=(($89-1)|0);
      var $91=$param;
      var $92=(($91+$90)|0);
      HEAP8[($92)]=0;
      var $93=$len;
      var $94=(($93-1)|0);
      $len=$94;
      $repeat=1;
      __label__ = 17; break;
    case 17: // $95
      __label__ = 18; break;
    case 18: // $96
      __label__ = 19; break;
    case 19: // $97
      __label__ = 20; break;
    case 20: // $98
      __label__ = 21; break;
    case 21: // $99
      var $100=$repeat;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 1; break; } else { __label__ = 22; break; }
    case 22: // $102
      var $103=$param;
      var $104=$1;
      HEAP32[(($104)>>2)]=$103;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14trim_parameterPPci["X"]=1;

function __Z19ui_menu_stack_resetR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      __label__ = 1; break;
    case 1: // $2
      var $3=HEAP32[((__ZL10menu_stack)>>2)];
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $5
      var $6=$1;
      __Z17ui_menu_stack_popR15running_machine($6);
      __label__ = 1; break;
    case 3: // $7
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20menu_render_triangleR8bitmap_tRKS_RK10_rectanglePv($dest, $source, $sbounds, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $halfwidth;
      var $height;
      var $x;
      var $y;
      var $linewidth;
      var $target;
      var $pixels;
      var $dalpha;
      $1=$dest;
      $2=$source;
      $3=$sbounds;
      $4=$param;
      var $5=$1;
      var $6=$5;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(((($8)|0)/2)|0);
      $halfwidth=$9;
      var $10=$1;
      var $11=$10;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      $height=$13;
      var $14=$1;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($14, 0, 0);
      $y=0;
      __label__ = 1; break;
    case 1: // $15
      var $16=$y;
      var $17=$height;
      var $18=(($16)|0) < (($17)|0);
      if ($18) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $19
      var $20=$y;
      var $21=$halfwidth;
      var $22=(($21-1)|0);
      var $23=(($20*$22)|0);
      var $24=$height;
      var $25=(((($24)|0)/2)|0);
      var $26=(($23+$25)|0);
      var $27=(($26*255)|0);
      var $28=((($27<<1))|0);
      var $29=$height;
      var $30=(((($28)|0)/(($29)|0))|0);
      $linewidth=$30;
      var $31=$1;
      var $32=$31;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34;
      var $36=$y;
      var $37=$1;
      var $38=$37;
      var $39=(($38+8)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($36*$40)|0);
      var $42=(($35+($41<<2))|0);
      var $43=$halfwidth;
      var $44=(($42+($43<<2))|0);
      $target=$44;
      var $45=$1;
      var $46=$45;
      var $47=(($46+16)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0) < 12;
      if ($49) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $50
      var $51=$linewidth;
      var $52=(($51+254)|0);
      var $53=(((($52)|0)/255)|0);
      $pixels=$53;
      var $54=$pixels;
      var $55=(($54)|0)%2;
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $57
      var $58=$pixels;
      var $59=(($58+1)|0);
      $pixels=$59;
      __label__ = 5; break;
    case 5: // $60
      var $61=$pixels;
      var $62=(($61*255)|0);
      $linewidth=$62;
      __label__ = 6; break;
    case 6: // $63
      $x=0;
      __label__ = 7; break;
    case 7: // $64
      var $65=$linewidth;
      var $66=(($65)|0) > 0;
      if ($66) { __label__ = 8; break; } else { __label__ = 19; break; }
    case 8: // $67
      var $68=$x;
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $70
      var $71=$linewidth;
      var $72=255 < (($71)|0);
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $77 = 255;__label__ = 12; break;
    case 11: // $74
      var $75=$linewidth;
      var $77 = $75;__label__ = 12; break;
    case 12: // $76
      var $77;
      $dalpha=$77;
      var $78=$dalpha;
      var $79=$78 & 255;
      var $80=$79 << 24;
      var $81=$80 | 16711680;
      var $82=$81 | 65280;
      var $83=$82 | 255;
      var $84=$x;
      var $85=$target;
      var $86=(($85+($84<<2))|0);
      HEAP32[(($86)>>2)]=$83;
      __label__ = 17; break;
    case 13: // $87
      var $88=$linewidth;
      var $89=510 < (($88)|0);
      if ($89) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $90
      var $94 = 510;__label__ = 16; break;
    case 15: // $91
      var $92=$linewidth;
      var $94 = $92;__label__ = 16; break;
    case 16: // $93
      var $94;
      $dalpha=$94;
      var $95=$dalpha;
      var $96=(((($95)|0)/2)|0);
      var $97=$96 & 255;
      var $98=$97 << 24;
      var $99=$98 | 16711680;
      var $100=$99 | 65280;
      var $101=$100 | 255;
      var $102=$x;
      var $103=(((-$102))|0);
      var $104=$target;
      var $105=(($104+($103<<2))|0);
      HEAP32[(($105)>>2)]=$101;
      var $106=$x;
      var $107=$target;
      var $108=(($107+($106<<2))|0);
      HEAP32[(($108)>>2)]=$101;
      __label__ = 17; break;
    case 17: // $109
      var $110=$dalpha;
      var $111=$linewidth;
      var $112=(($111-$110)|0);
      $linewidth=$112;
      __label__ = 18; break;
    case 18: // $113
      var $114=$x;
      var $115=(($114+1)|0);
      $x=$115;
      __label__ = 7; break;
    case 19: // $116
      __label__ = 20; break;
    case 20: // $117
      var $118=$y;
      var $119=(($118+1)|0);
      $y=$119;
      __label__ = 1; break;
    case 21: // $120
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20menu_render_triangleR8bitmap_tRKS_RK10_rectanglePv["X"]=1;

function __ZL12ui_menu_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=$1;
      __Z19ui_menu_stack_resetR15running_machine($2);
      var $3=$1;
      __ZL23ui_menu_clear_free_listR15running_machine($3);
      var $4=$1;
      var $5=__ZNK15running_machine6renderEv($4);
      var $6=HEAP32[((__ZL15hilight_texture)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($5, $6);
      var $7=$1;
      var $8=__ZNK15running_machine6renderEv($7);
      var $9=HEAP32[((__ZL13arrow_texture)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($8, $9);
      var $10=HEAP32[((__ZL8drivlist)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=HEAP32[((__ZL8drivlist)>>2)];
      var $14=$13;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $14);
      HEAP32[((__ZL8drivlist)>>2)]=0;
      __label__ = 2; break;
    case 2: // $15
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z12ui_menu_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $x;
      var $10;
      var $11;
      var $alpha;
      var $12=__stackBase__+36;
      $9=$machine;
      var $13=$9;
      __Z19ui_menu_stack_resetR15running_machine($13);
      var $14=$9;
      var $15=__ZN15running_machine7respoolEv($14);
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($6)>>2)]=403;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, 256, 1, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $55
      var $56=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($15, $54);
      HEAP32[((__ZL14hilight_bitmap)>>2)]=$56;
      $x=0;
      __label__ = 9; break;
    case 9: // $57
      var $58=$x;
      var $59=(($58)|0) < 256;
      if ($59) { __label__ = 10; break; } else { __label__ = 21; break; }
    case 10: // $60
      $alpha=255;
      var $61=$x;
      var $62=(($61)|0) < 25;
      if ($62) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $63
      var $64=$x;
      var $65=(($64*255)|0);
      var $66=(((($65)|0)/25)|0);
      $alpha=$66;
      __label__ = 17; break;
    case 12: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $10=$69;
      var $70=$68.f1;
      $11=$70;
      var $71=$1;
      var $72=$2;
      var $73=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($3)>>2)]=403;
      var $74=HEAP32[(($1)>>2)];
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $76
      var $77=HEAP32[(($1)>>2)];
      var $78=HEAP32[(($2)>>2)];
      var $79=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($77, $78, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 23; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $80=$1;
      var $81=$2;
      var $82=$3;
      __label__ = 16; break;
    case 16: // $83
      __label__ = 22; break;
    case 17: // $84
      var $85=$x;
      var $86=(($85)|0) > 231;
      if ($86) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $87
      var $88=$x;
      var $89=((255-$88)|0);
      var $90=(($89*255)|0);
      var $91=(((($90)|0)/25)|0);
      $alpha=$91;
      __label__ = 19; break;
    case 19: // $92
      var $93=$alpha;
      var $94=$93 & 255;
      var $95=$94 << 24;
      var $96=$95 | 16711680;
      var $97=$96 | 65280;
      var $98=$97 | 255;
      var $99=HEAP32[((__ZL14hilight_bitmap)>>2)];
      var $100=$99;
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$102;
      var $104=HEAP32[((__ZL14hilight_bitmap)>>2)];
      var $105=$104;
      var $106=(($105+8)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=((0)|0);
      var $109=(($103+($108<<2))|0);
      var $110=$x;
      var $111=(($109+($110<<2))|0);
      HEAP32[(($111)>>2)]=$98;
      __label__ = 20; break;
    case 20: // $112
      var $113=$x;
      var $114=(($113+1)|0);
      $x=$114;
      __label__ = 9; break;
    case 21: // $115
      var $116=$9;
      var $117=__ZNK15running_machine6renderEv($116);
      var $118=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($117, 0, 0);
      HEAP32[((__ZL15hilight_texture)>>2)]=$118;
      var $119=HEAP32[((__ZL15hilight_texture)>>2)];
      var $120=HEAP32[((__ZL14hilight_bitmap)>>2)];
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($119, $120, 0, 5, 0);
      var $121=$9;
      var $122=__ZNK15running_machine6renderEv($121);
      var $123=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($122, 1012, 0);
      HEAP32[((__ZL13arrow_texture)>>2)]=$123;
      var $124=$9;
      var $125=$9;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($12, 1014, ((STRING_TABLE.__str14165)|0), $125);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($124, 4, $12);
      STACKTOP = __stackBase__;
      return;
    case 22: // $126
      var $127=$10;
      var $128=$10;
      var $129=$11;
      var $130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $128, tempValue);
      var $131=($130.f1 = $129, $130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12ui_menu_initR15running_machine["X"]=1;

function __ZNK7ui_menu7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z17ui_menu_populatedP7ui_menu($menu) {
  ;
  var __label__;

  var $1;
  $1=$menu;
  var $2=$1;
  var $3=(($2+56)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0) > 1;
  var $6=(($5)&1);
  ;
  return $6;
}


function __ZN7ui_menuC1ER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=$2;
  __ZN7ui_menuC2ER15running_machine($3, $4);
  ;
  return;
}


function __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($menu, $options) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $pool;
      $1=$menu;
      $2=$options;
      var $3=$1;
      var $4=(($3+36)|0);
      HEAP32[(($4)>>2)]=0;
      var $5=$1;
      var $6=(($5+40)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=$2;
      var $8=(($7)|0)==1;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+44)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$1;
      var $14=(($13+36)|0);
      HEAP32[(($14)>>2)]=$12;
      __label__ = 5; break;
    case 2: // $15
      var $16=$2;
      var $17=(($16)|0)==2;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$1;
      var $20=(($19+44)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$1;
      var $23=(($22+64)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+($21<<4))|0);
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$1;
      var $29=(($28+40)|0);
      HEAP32[(($29)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$1;
      var $33=(($32+80)|0);
      var $34=HEAP32[(($33)>>2)];
      $pool=$34;
      __label__ = 6; break;
    case 6: // $35
      var $36=$pool;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $38
      var $39=$pool;
      var $40=(($39+12)|0);
      var $41=$40;
      var $42=$pool;
      var $43=(($42+4)|0);
      HEAP32[(($43)>>2)]=$41;
      __label__ = 8; break;
    case 8: // $44
      var $45=$pool;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      $pool=$47;
      __label__ = 6; break;
    case 9: // $48
      var $49=$1;
      var $50=(($49+56)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=$1;
      var $52=(($51+52)|0);
      HEAP32[(($52)>>2)]=0;
      var $53=$1;
      var $54=(($53+44)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=$1;
      var $56=(($55+24)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57)|0)==0;
      if ($58) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $59
      var $60=$1;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($60, ((STRING_TABLE.__ZL8backtext)|0), 0, 0, 0);
      __label__ = 15; break;
    case 11: // $61
      var $62=$1;
      var $63=(($62+24)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)==1016;
      if ($67) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $68
      var $69=$1;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($69, ((STRING_TABLE.__ZL8exittext)|0), 0, 0, 0);
      __label__ = 14; break;
    case 13: // $70
      var $71=$1;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($71, ((STRING_TABLE.__ZL9priortext)|0), 0, 0, 0);
      __label__ = 14; break;
    case 14: // $72
      __label__ = 15; break;
    case 15: // $73
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options["X"]=1;

function __Z12ui_menu_freeP7ui_menu($menu) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $pool;
      $1=$menu;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+80)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=$1;
      var $9=(($8+80)|0);
      var $10=HEAP32[(($9)>>2)];
      $pool=$10;
      var $11=$pool;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14+80)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$1;
      var $17=__ZNK7ui_menu7machineEv($16);
      var $18=__ZN15running_machine7respoolEv($17);
      var $19=$pool;
      var $20=$19;
      __ZN13resource_pool6removeEPv($18, $20);
      __label__ = 1; break;
    case 3: // $21
      var $22=$1;
      var $23=(($22+64)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$1;
      var $28=__ZNK7ui_menu7machineEv($27);
      var $29=__ZN15running_machine7respoolEv($28);
      var $30=$1;
      var $31=(($30+64)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32;
      __ZN13resource_pool6removeEPv($29, $33);
      __label__ = 5; break;
    case 5: // $34
      var $35=$1;
      var $36=(($35+28)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $39
      var $40=$1;
      var $41=(($40+32)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $44
      var $45=$1;
      var $46=(($45+32)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$1;
      var $49=$1;
      var $50=(($49+28)|0);
      var $51=HEAP32[(($50)>>2)];
      FUNCTION_TABLE[$47]($48, $51);
      __label__ = 8; break;
    case 8: // $52
      var $53=$1;
      var $54=__ZNK7ui_menu7machineEv($53);
      var $55=__ZN15running_machine7respoolEv($54);
      var $56=$1;
      var $57=(($56+28)|0);
      var $58=HEAP32[(($57)>>2)];
      __ZN13resource_pool6removeEPv($55, $58);
      __label__ = 9; break;
    case 9: // $59
      var $60=$1;
      var $61=__ZNK7ui_menu7machineEv($60);
      var $62=__ZN15running_machine7respoolEv($61);
      var $63=$1;
      var $64=$63;
      __ZN13resource_pool6removeEPv($62, $64);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12ui_menu_freeP7ui_menu["X"]=1;

function __ZL14menu_quit_gameR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$menu;
  $3=$parameter;
  $4=$state;
  var $5=$1;
  __ZN15running_machine13schedule_exitEv($5);
  var $6=$1;
  __Z19ui_menu_stack_resetR15running_machine($6);
  ;
  return;
}


function __Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($machine, $container, $handler, $parameter) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $12;
      var $13;
      var $14;
      var $menu;
      var $15;
      var $16;
      $11=$machine;
      $12=$container;
      $13=$handler;
      $14=$parameter;
      var $17=$11;
      var $18=__ZN15running_machine7respoolEv($17);
      var $19=$5;
      var $20=$6;
      var $21=$7;
      var $22=$8;
      var $23=$result_i;
      var $24=$9;
      var $25=$10;
      HEAP32[(($5)>>2)]=88;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($7)>>2)]=458;
      HEAP32[(($8)>>2)]=_zeromem;
      var $26=HEAP32[(($5)>>2)];
      var $27=HEAP32[(($6)>>2)];
      var $28=HEAP32[(($7)>>2)];
      var $29=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $30
      HEAP32[(($result_i)>>2)]=$29;
      var $31=HEAP32[(($result_i)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $33
      var $34=___cxa_allocate_exception(4);
      var $35=$34;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35);
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($9)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($10)>>2)]=$39;
      var $40=HEAP32[(($10)>>2)];
      var $41=(($40)|0) < 0;
      if ($41) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $42
      var $43=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($43);
      throw "Reached an unreachable!"
    case 5: // $44
      var $45=HEAP32[(($9)>>2)];
      var $46=HEAP32[(($9)>>2)];
      var $47=HEAP32[(($10)>>2)];
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $50
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKciRK9zeromem_t_exit
      var $51=HEAP32[(($result_i)>>2)];
      var $52=HEAP32[(($5)>>2)];
      _memset($51, 0, $52, 1);
      var $53=HEAP32[(($result_i)>>2)];
      var $54=$5;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      var $58=$result_i;
      var $59=$9;
      var $60=$10;
      var $61=$53;
      var $62=$11;
      (function() { try { __THREW__ = false; return __ZN7ui_menuC1ER15running_machine($61, $62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $63
      var $64=__ZN13resource_pool10add_objectI7ui_menuEEPT_S3_($18, $61);
      $menu=$64;
      var $65=$12;
      var $66=$menu;
      var $67=(($66)|0);
      HEAP32[(($67)>>2)]=$65;
      var $68=$13;
      var $69=$menu;
      var $70=(($69+4)|0);
      HEAP32[(($70)>>2)]=$68;
      var $71=$14;
      var $72=$menu;
      var $73=(($72+8)|0);
      HEAP32[(($73)>>2)]=$71;
      var $74=$menu;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($74, 0);
      var $75=$menu;
      STACKTOP = __stackBase__;
      return $75;
    case 9: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $15=$78;
      var $79=$77.f1;
      $16=$79;
      var $80=$1;
      var $81=$2;
      var $82=$3;
      var $83=$4;
      HEAP32[(($1)>>2)]=$53;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($3)>>2)]=458;
      HEAP32[(($4)>>2)]=_zeromem;
      var $84=HEAP32[(($1)>>2)];
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $86
      var $87=HEAP32[(($1)>>2)];
      var $88=HEAP32[(($2)>>2)];
      var $89=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($87, $88, $89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKciRK9zeromem_t_exit
      var $90=$1;
      var $91=$2;
      var $92=$3;
      var $93=$4;
      __label__ = 13; break;
    case 13: // $94
      __label__ = 14; break;
    case 14: // $95
      var $96=$15;
      var $97=$15;
      var $98=$16;
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_["X"]=1;

function __ZN13resource_pool10add_objectI7ui_menuEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI7ui_menuEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI7ui_menuEEPT_S3_["X"]=1;

function __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($menu, $text, $subtext, $flags, $ref) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $item;
      var $index;
      var $olditems;
      var $newitems;
      var $itemnum;
      $6=$menu;
      $7=$text;
      $8=$subtext;
      $9=$flags;
      $10=$ref;
      var $11=$9;
      var $12=$11 & 8;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      __label__ = 3; break;
    case 3: // $16
      __label__ = 9; break;
    case 4: // $17
      var $18=$6;
      var $19=(($18+56)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0) >= 2;
      if ($21) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      __label__ = 7; break;
    case 7: // $24
      __label__ = 8; break;
    case 8: // $25
      __label__ = 9; break;
    case 9: // $26
      var $27=$6;
      var $28=(($27+56)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$6;
      var $31=(($30+60)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($29)|0) >= (($32)|0);
      if ($33) { __label__ = 10; break; } else { __label__ = 22; break; }
    case 10: // $34
      var $35=$6;
      var $36=(($35+60)|0);
      var $37=HEAP32[(($36)>>2)];
      $olditems=$37;
      var $38=$6;
      var $39=(($38+60)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+256)|0);
      HEAP32[(($39)>>2)]=$41;
      var $42=$6;
      var $43=__ZNK7ui_menu7machineEv($42);
      var $44=__ZN15running_machine7respoolEv($43);
      var $45=$6;
      var $46=(($45+60)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=_llvm_umul_with_overflow_i32($47, 16);
      var $49=$48.f1;
      var $50=$48.f0;
      var $51=$49 ? -1 : $50;
      var $52=$1;
      var $53=$2;
      var $54=$3;
      var $55=$result_i;
      var $56=$4;
      var $57=$5;
      HEAP32[(($1)>>2)]=$51;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($3)>>2)]=570;
      var $58=HEAP32[(($1)>>2)];
      var $59=HEAP32[(($2)>>2)];
      var $60=HEAP32[(($3)>>2)];
      var $61=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($58, $59, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $62
      HEAP32[(($result_i)>>2)]=$61;
      var $63=HEAP32[(($result_i)>>2)];
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $65
      var $66=___cxa_allocate_exception(4);
      var $67=$66;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($67);
      (function() { try { __THREW__ = false; return ___cxa_throw($66, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      HEAP32[(($4)>>2)]=$70;
      var $71=$69.f1;
      HEAP32[(($5)>>2)]=$71;
      var $72=HEAP32[(($5)>>2)];
      var $73=(($72)|0) < 0;
      if ($73) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $74
      var $75=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($75);
      throw "Reached an unreachable!"
    case 15: // $76
      var $77=HEAP32[(($4)>>2)];
      var $78=HEAP32[(($4)>>2)];
      var $79=HEAP32[(($5)>>2)];
      var $80=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $78, tempValue);
      var $81=($80.f1 = $79, $80);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $82
      throw "Reached an unreachable!"
    case 17: // $_ZnajPKci_exit
      var $83=HEAP32[(($result_i)>>2)];
      var $84=$1;
      var $85=$2;
      var $86=$3;
      var $87=$result_i;
      var $88=$4;
      var $89=$5;
      var $90=$83;
      var $91=$6;
      var $92=(($91+60)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=__ZN13resource_pool9add_arrayI13_ui_menu_itemEEPT_S3_i($44, $90, $93);
      $newitems=$94;
      $itemnum=0;
      __label__ = 18; break;
    case 18: // $95
      var $96=$itemnum;
      var $97=$olditems;
      var $98=(($96)|0) < (($97)|0);
      if ($98) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $99
      var $100=$itemnum;
      var $101=$newitems;
      var $102=(($101+($100<<4))|0);
      var $103=$itemnum;
      var $104=$6;
      var $105=(($104+64)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+($103<<4))|0);
      var $108=$102;
      var $109=$107;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($108)>>2)]=HEAP32[(($109)>>2)];HEAP32[(($108+4)>>2)]=HEAP32[(($109+4)>>2)];HEAP32[(($108+8)>>2)]=HEAP32[(($109+8)>>2)];HEAP32[(($108+12)>>2)]=HEAP32[(($109+12)>>2)];
      __label__ = 20; break;
    case 20: // $110
      var $111=$itemnum;
      var $112=(($111+1)|0);
      $itemnum=$112;
      __label__ = 18; break;
    case 21: // $113
      var $114=$6;
      var $115=__ZNK7ui_menu7machineEv($114);
      var $116=__ZN15running_machine7respoolEv($115);
      var $117=$6;
      var $118=(($117+64)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119;
      __ZN13resource_pool6removeEPv($116, $120);
      var $121=$newitems;
      var $122=$6;
      var $123=(($122+64)|0);
      HEAP32[(($123)>>2)]=$121;
      __label__ = 22; break;
    case 22: // $124
      var $125=$6;
      var $126=(($125+56)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+1)|0);
      HEAP32[(($126)>>2)]=$128;
      $index=$127;
      var $129=$index;
      var $130=(($129)|0)!=0;
      if ($130) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $131
      var $132=$index;
      var $133=(($132-1)|0);
      $index=$133;
      var $134=$index;
      var $135=(($134+1)|0);
      var $136=$6;
      var $137=(($136+64)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138+($135<<4))|0);
      var $140=$index;
      var $141=$6;
      var $142=(($141+64)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+($140<<4))|0);
      var $145=$139;
      var $146=$144;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($145)>>2)]=HEAP32[(($146)>>2)];HEAP32[(($145+4)>>2)]=HEAP32[(($146+4)>>2)];HEAP32[(($145+8)>>2)]=HEAP32[(($146+8)>>2)];HEAP32[(($145+12)>>2)]=HEAP32[(($146+12)>>2)];
      __label__ = 24; break;
    case 24: // $147
      var $148=$index;
      var $149=$6;
      var $150=(($149+64)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+($148<<4))|0);
      $item=$152;
      var $153=$7;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $155
      var $156=$6;
      var $157=$7;
      var $158=__Z19ui_menu_pool_strdupP7ui_menuPKc($156, $157);
      var $161 = $158;__label__ = 27; break;
    case 26: // $159
      var $161 = 0;__label__ = 27; break;
    case 27: // $160
      var $161;
      var $162=$item;
      var $163=(($162)|0);
      HEAP32[(($163)>>2)]=$161;
      var $164=$8;
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $166
      var $167=$6;
      var $168=$8;
      var $169=__Z19ui_menu_pool_strdupP7ui_menuPKc($167, $168);
      var $172 = $169;__label__ = 30; break;
    case 29: // $170
      var $172 = 0;__label__ = 30; break;
    case 30: // $171
      var $172;
      var $173=$item;
      var $174=(($173+4)|0);
      HEAP32[(($174)>>2)]=$172;
      var $175=$9;
      var $176=$item;
      var $177=(($176+8)|0);
      HEAP32[(($177)>>2)]=$175;
      var $178=$10;
      var $179=$item;
      var $180=(($179+12)|0);
      HEAP32[(($180)>>2)]=$178;
      var $181=$6;
      var $182=(($181+36)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$index;
      var $185=(($183)|0)==(($184)|0);
      if ($185) { __label__ = 33; break; } else { __label__ = 31; break; }
    case 31: // $186
      var $187=$6;
      var $188=(($187+40)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189)|0)!=0;
      if ($190) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $191
      var $192=$6;
      var $193=(($192+40)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=$10;
      var $196=(($194)|0)==(($195)|0);
      if ($196) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $197
      var $198=$index;
      var $199=$6;
      var $200=(($199+44)|0);
      HEAP32[(($200)>>2)]=$198;
      __label__ = 34; break;
    case 34: // $201
      var $202=$6;
      var $203=(($202+36)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$6;
      var $206=(($205+56)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207-1)|0);
      var $209=(($204)|0)==(($208)|0);
      if ($209) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $210
      var $211=$6;
      var $212=(($211+56)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213-1)|0);
      var $215=$6;
      var $216=(($215+44)|0);
      HEAP32[(($216)>>2)]=$214;
      __label__ = 36; break;
    case 36: // $217
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19ui_menu_item_appendP7ui_menuPKcS2_jPv["X"]=1;

function __Z19ui_menu_pool_strdupP7ui_menuPKc($menu, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$menu;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=_strlen($4);
  var $6=(($5+1)|0);
  var $7=__Z18ui_menu_pool_allocP7ui_menuj($3, $6);
  var $8=$2;
  var $9=_strcpy($7, $8);
  ;
  return $9;
}


function __Z15ui_menu_processR15running_machineP7ui_menuj($machine, $menu, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$machine;
      $3=$menu;
      $4=$flags;
      var $5=$3;
      var $6=(($5+12)|0);
      var $7=(($6+4)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=$3;
      __ZL26ui_menu_validate_selectionP7ui_menui($8, 1);
      var $9=$3;
      var $10=(($9+56)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0) > 1;
      if ($12) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $13
      var $14=$3;
      var $15=(($14+64)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0);
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 8;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $22
      var $23=$3;
      __ZL21ui_menu_draw_text_boxP7ui_menu($23);
      __label__ = 4; break;
    case 3: // $24
      var $25=$2;
      var $26=$3;
      var $27=$4;
      var $28=$27 & 4;
      var $29=(($28)|0)!=0;
      var $30=(($29)&1);
      __ZL12ui_menu_drawR15running_machineP7ui_menui($25, $26, $30);
      __label__ = 4; break;
    case 4: // $31
      var $32=$4;
      var $33=$32 & 1;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $35
      var $36=$3;
      __ZL21ui_menu_handle_eventsP7ui_menu($36);
      var $37=$3;
      var $38=(($37+12)|0);
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $42
      var $43=$3;
      var $44=$4;
      __ZL19ui_menu_handle_keysP7ui_menuj($43, $44);
      __label__ = 7; break;
    case 7: // $45
      __label__ = 8; break;
    case 8: // $46
      var $47=$3;
      var $48=(($47+12)|0);
      var $49=(($48+4)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $52
      var $53=$3;
      var $54=(($53+44)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0) >= 0;
      if ($56) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $57
      var $58=$3;
      var $59=(($58+44)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$3;
      var $62=(($61+56)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($60)|0) < (($63)|0);
      if ($64) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $65
      var $66=$3;
      var $67=(($66+44)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$3;
      var $70=(($69+64)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71+($68<<4))|0);
      var $73=(($72+12)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$3;
      var $76=(($75+12)|0);
      var $77=(($76)|0);
      HEAP32[(($77)>>2)]=$74;
      var $78=$3;
      var $79=(($78+12)|0);
      $1=$79;
      __label__ = 13; break;
    case 12: // $80
      $1=0;
      __label__ = 13; break;
    case 13: // $81
      var $82=$1;
      ;
      return $82;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15ui_menu_processR15running_machineP7ui_menuj["X"]=1;

function __ZL26ui_menu_validate_selectionP7ui_menui($menu, $scandir) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$menu;
      $2=$scandir;
      var $3=$1;
      var $4=(($3+44)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0) < 0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+44)|0);
      HEAP32[(($9)>>2)]=0;
      __label__ = 5; break;
    case 2: // $10
      var $11=$1;
      var $12=(($11+44)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14+56)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0) >= (($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$1;
      var $20=(($19+56)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21-1)|0);
      var $23=$1;
      var $24=(($23+44)|0);
      HEAP32[(($24)>>2)]=$22;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$1;
      var $29=(($28+44)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$1;
      var $32=(($31+64)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+($30<<4))|0);
      var $35=__ZL18item_is_selectablePK13_ui_menu_item($34);
      var $36=(($35)|0)!=0;
      var $37=$36 ^ 1;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      var $39=$1;
      var $40=(($39+44)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+56)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($41+$44)|0);
      var $46=$2;
      var $47=(($45+$46)|0);
      var $48=$1;
      var $49=(($48+56)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($47)|0)%(($50)|0);
      var $52=$1;
      var $53=(($52+44)|0);
      HEAP32[(($53)>>2)]=$51;
      __label__ = 6; break;
    case 8: // $54
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26ui_menu_validate_selectionP7ui_menui["X"]=1;

function __ZL21ui_menu_draw_text_boxP7ui_menu($menu) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $text;
      var $backtext;
      var $line_height;
      var $lr_arrow_width;
      var $gutter_width;
      var $target_width=__stackBase__;
      var $target_height=__stackBase__+4;
      var $prior_width;
      var $target_x;
      var $target_y;
      $1=$menu;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      $text=$7;
      var $8=$1;
      var $9=(($8+64)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+16)|0);
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      $backtext=$13;
      var $14=$1;
      var $15=__ZNK7ui_menu7machineEv($14);
      var $16=__Z18ui_get_line_heightR15running_machine($15);
      $line_height=$16;
      var $17=$line_height;
      var $18=$17*0.4000000059604645;
      var $19=$1;
      var $20=__ZNK7ui_menu7machineEv($19);
      var $21=__ZNK15running_machine6renderEv($20);
      var $22=__ZN14render_manager9ui_aspectEv($21);
      var $23=$18*$22;
      $lr_arrow_width=$23;
      var $24=$lr_arrow_width;
      $gutter_width=$24;
      var $25=$1;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$text;
      var $29=$gutter_width;
      var $30=$29*2;
      var $31=0.9800000190734863-$30;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($27, $28, 0, 0, $31, 0, 2, 0, -1, -16777216, $target_width, $target_height);
      var $32=$line_height;
      var $33=$32*2;
      var $34=HEAPF32[(($target_height)>>2)];
      var $35=$34+$33;
      HEAPF32[(($target_height)>>2)]=$35;
      var $36=HEAPF32[(($target_height)>>2)];
      var $37=$36 > 0.9800000190734863;
      if ($37) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      var $39=$line_height;
      var $40=0.9800000190734863/$39;
      var $41=$40;
      var $42=_floor($41);
      var $43=$line_height;
      var $44=$43;
      var $45=$42*$44;
      var $46=$45;
      HEAPF32[(($target_height)>>2)]=$46;
      __label__ = 2; break;
    case 2: // $47
      var $48=$1;
      var $49=__ZNK7ui_menu7machineEv($48);
      var $50=$backtext;
      var $51=__Z19ui_get_string_widthR15running_machinePKc($49, $50);
      var $52=$gutter_width;
      var $53=$52*2;
      var $54=$51+$53;
      $prior_width=$54;
      var $55=HEAPF32[(($target_width)>>2)];
      var $56=$prior_width;
      var $57=$55 > $56;
      var $58=HEAPF32[(($target_width)>>2)];
      var $59=$prior_width;
      var $60=$57 ? $58 : $59;
      HEAPF32[(($target_width)>>2)]=$60;
      var $61=HEAPF32[(($target_width)>>2)];
      var $62=$61*0.5;
      var $63=0.5-$62;
      $target_x=$63;
      var $64=HEAPF32[(($target_height)>>2)];
      var $65=$64*0.5;
      var $66=0.5-$65;
      $target_y=$66;
      var $67=$target_x;
      var $68=$gutter_width;
      var $69=$68+0.009999999776482582;
      var $70=$67 < $69;
      if ($70) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $71
      var $72=$gutter_width;
      var $73=$72+0.009999999776482582;
      $target_x=$73;
      __label__ = 4; break;
    case 4: // $74
      var $75=$target_x;
      var $76=HEAPF32[(($target_width)>>2)];
      var $77=$75+$76;
      var $78=$gutter_width;
      var $79=$77+$78;
      var $80=$79+0.009999999776482582;
      var $81=$80 > 1;
      if ($81) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $82
      var $83=$gutter_width;
      var $84=0.9900000095367432-$83;
      var $85=HEAPF32[(($target_width)>>2)];
      var $86=$84-$85;
      $target_x=$86;
      __label__ = 6; break;
    case 6: // $87
      var $88=$target_y;
      var $89=$88 < 0.009999999776482582;
      if ($89) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $90
      $target_y=0.009999999776482582;
      __label__ = 8; break;
    case 8: // $91
      var $92=$target_y;
      var $93=HEAPF32[(($target_height)>>2)];
      var $94=$92+$93;
      var $95=$94+0.009999999776482582;
      var $96=$95 > 1;
      if ($96) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $97
      var $98=HEAPF32[(($target_height)>>2)];
      var $99=0.9900000095367432-$98;
      $target_y=$99;
      __label__ = 10; break;
    case 10: // $100
      var $101=$1;
      var $102=(($101)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$target_x;
      var $105=$104-0.009999999776482582;
      var $106=$gutter_width;
      var $107=$105-$106;
      var $108=$target_y;
      var $109=$108-0.009999999776482582;
      var $110=$target_x;
      var $111=HEAPF32[(($target_width)>>2)];
      var $112=$110+$111;
      var $113=$gutter_width;
      var $114=$112+$113;
      var $115=$114+0.009999999776482582;
      var $116=$target_y;
      var $117=HEAPF32[(($target_height)>>2)];
      var $118=$116+$117;
      var $119=$118+0.009999999776482582;
      var $120=$1;
      var $121=(($120+64)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122)|0);
      var $124=(($123+8)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$125 & 16;
      var $127=(($126)|0)!=0;
      var $128=$127 ? -262139888 : -284159952;
      __Z20ui_draw_outlined_boxP16render_containerffffj($103, $107, $109, $115, $119, $128);
      var $129=$1;
      var $130=(($129)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$text;
      var $133=$target_x;
      var $134=$target_y;
      var $135=HEAPF32[(($target_width)>>2)];
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($131, $132, $133, $134, $135, 0, 2, 1, -1, -285212672, 0, 0);
      var $136=$1;
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$target_x;
      var $140=$139+0.0010000000474974513;
      var $141=$target_y;
      var $142=HEAPF32[(($target_height)>>2)];
      var $143=$141+$142;
      var $144=$line_height;
      var $145=$143-$144;
      var $146=$target_x;
      var $147=HEAPF32[(($target_width)>>2)];
      var $148=$146+$147;
      var $149=$148-0.0010000000474974513;
      var $150=$target_y;
      var $151=HEAPF32[(($target_height)>>2)];
      var $152=$150+$151;
      var $153=HEAP32[((__ZL15hilight_texture)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($138, $140, $145, $149, $152, -276791296, $153, 16640);
      var $154=$1;
      var $155=(($154)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$backtext;
      var $158=$target_x;
      var $159=$target_y;
      var $160=HEAPF32[(($target_height)>>2)];
      var $161=$159+$160;
      var $162=$line_height;
      var $163=$161-$162;
      var $164=HEAPF32[(($target_width)>>2)];
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($156, $157, $158, $163, $164, 1, 1, 1, -256, -276791296, 0, 0);
      var $165=$1;
      var $166=(($165+56)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167-1)|0);
      var $169=$1;
      var $170=(($169+48)|0);
      HEAP32[(($170)>>2)]=$168;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21ui_menu_draw_text_boxP7ui_menu["X"]=1;

function __ZN13resource_pool9add_arrayI13_ui_menu_itemEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI13_ui_menu_itemEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI13_ui_menu_itemEEPT_S3_i["X"]=1;

function __ZL12ui_menu_drawR15running_machineP7ui_menui($machine, $menu, $customonly) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $line_height;
      var $lr_arrow_width;
      var $ud_arrow_width;
      var $gutter_width;
      var $x1;
      var $y1;
      var $x2;
      var $y2;
      var $effective_width;
      var $effective_left;
      var $visible_width;
      var $visible_main_menu_height;
      var $visible_extra_menu_height;
      var $visible_top;
      var $visible_left;
      var $selected_subitem_too_big;
      var $visible_lines;
      var $top_line;
      var $itemnum;
      var $linenum;
      var $mouse_hit;
      var $mouse_button=__stackBase__;
      var $mouse_target;
      var $mouse_target_x=__stackBase__+4;
      var $mouse_target_y=__stackBase__+8;
      var $mouse_x=__stackBase__+12;
      var $mouse_y=__stackBase__+16;
      var $item;
      var $total_width;
      var $line_y;
      var $itemnum1;
      var $item2;
      var $itemtext;
      var $fgcolor;
      var $bgcolor;
      var $fgcolor2;
      var $fgcolor3;
      var $line_x0;
      var $line_y0;
      var $line_x1;
      var $line_y1;
      var $subitem_invert;
      var $subitem_text;
      var $item_width=__stackBase__+20;
      var $subitem_width=__stackBase__+24;
      var $item3;
      var $subitem_invert4;
      var $linenum5;
      var $line_y6;
      var $target_width=__stackBase__+28;
      var $target_height=__stackBase__+32;
      var $target_x;
      var $target_y;
      var $selectedref;
      $1=$machine;
      $2=$menu;
      $3=$customonly;
      var $4=$1;
      var $5=__Z18ui_get_line_heightR15running_machine($4);
      $line_height=$5;
      var $6=$line_height;
      var $7=$6*0.4000000059604645;
      var $8=$1;
      var $9=__ZNK15running_machine6renderEv($8);
      var $10=__ZN14render_manager9ui_aspectEv($9);
      var $11=$7*$10;
      $lr_arrow_width=$11;
      var $12=$line_height;
      var $13=$1;
      var $14=__ZNK15running_machine6renderEv($13);
      var $15=__ZN14render_manager9ui_aspectEv($14);
      var $16=$12*$15;
      $ud_arrow_width=$16;
      var $17=$lr_arrow_width;
      var $18=$17*1.2999999523162842;
      $gutter_width=$18;
      $visible_extra_menu_height=0;
      $selected_subitem_too_big=0;
      HEAPF32[(($mouse_x)>>2)]=-1;
      HEAPF32[(($mouse_y)>>2)]=-1;
      $visible_width=0;
      $visible_main_menu_height=0;
      $itemnum=0;
      __label__ = 1; break;
    case 1: // $19
      var $20=$itemnum;
      var $21=$2;
      var $22=(($21+56)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($20)|0) < (($23)|0);
      if ($24) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $25
      var $26=$itemnum;
      var $27=$2;
      var $28=(($27+64)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+($26<<4))|0);
      $item=$30;
      var $31=$gutter_width;
      var $32=$1;
      var $33=$item;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z19ui_get_string_widthR15running_machinePKc($32, $35);
      var $37=$31+$36;
      var $38=$gutter_width;
      var $39=$37+$38;
      $total_width=$39;
      var $40=$item;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $44
      var $45=$gutter_width;
      var $46=$45*2;
      var $47=$1;
      var $48=$item;
      var $49=(($48+4)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=__Z19ui_get_string_widthR15running_machinePKc($47, $50);
      var $52=$46+$51;
      var $53=$total_width;
      var $54=$53+$52;
      $total_width=$54;
      __label__ = 4; break;
    case 4: // $55
      var $56=$total_width;
      var $57=$visible_width;
      var $58=$56 > $57;
      if ($58) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $59
      var $60=$total_width;
      $visible_width=$60;
      __label__ = 6; break;
    case 6: // $61
      var $62=$line_height;
      var $63=$visible_main_menu_height;
      var $64=$63+$62;
      $visible_main_menu_height=$64;
      __label__ = 7; break;
    case 7: // $65
      var $66=$itemnum;
      var $67=(($66+1)|0);
      $itemnum=$67;
      __label__ = 1; break;
    case 8: // $68
      var $69=$2;
      var $70=(($69+72)|0);
      var $71=HEAPF32[(($70)>>2)];
      var $72=$2;
      var $73=(($72+76)|0);
      var $74=HEAPF32[(($73)>>2)];
      var $75=$71+$74;
      $visible_extra_menu_height=$75;
      var $76=$visible_width;
      var $77=$76+0.009999999776482582;
      $visible_width=$77;
      var $78=$visible_main_menu_height;
      var $79=$78+0.009999999776482582;
      $visible_main_menu_height=$79;
      var $80=$visible_width;
      var $81=$80+0.019999999552965164;
      var $82=$81 > 1;
      if ($82) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $83
      $visible_width=0.9800000190734863;
      __label__ = 10; break;
    case 10: // $84
      var $85=$visible_main_menu_height;
      var $86=$visible_extra_menu_height;
      var $87=$85+$86;
      var $88=$87+0.019999999552965164;
      var $89=$88 > 1;
      if ($89) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $90
      var $91=$visible_extra_menu_height;
      var $92=0.9800000190734863-$91;
      $visible_main_menu_height=$92;
      __label__ = 12; break;
    case 12: // $93
      var $94=$visible_main_menu_height;
      var $95=$line_height;
      var $96=$94/$95;
      var $97=$96;
      var $98=_floor($97);
      var $99=(($98)|0);
      $visible_lines=$99;
      var $100=$visible_lines;
      var $101=(($100)|0);
      var $102=$line_height;
      var $103=$101*$102;
      $visible_main_menu_height=$103;
      var $104=$visible_width;
      var $105=1-$104;
      var $106=$105*0.5;
      $visible_left=$106;
      var $107=$visible_main_menu_height;
      var $108=$visible_extra_menu_height;
      var $109=$107+$108;
      var $110=1-$109;
      var $111=$110*0.5;
      $visible_top=$111;
      var $112=$2;
      var $113=(($112+72)|0);
      var $114=HEAPF32[(($113)>>2)];
      var $115=$visible_top;
      var $116=$115+$114;
      $visible_top=$116;
      var $117=$visible_left;
      var $118=$117-0.009999999776482582;
      $x1=$118;
      var $119=$visible_top;
      var $120=$119-0.009999999776482582;
      $y1=$120;
      var $121=$visible_left;
      var $122=$visible_width;
      var $123=$121+$122;
      var $124=$123+0.009999999776482582;
      $x2=$124;
      var $125=$visible_top;
      var $126=$visible_main_menu_height;
      var $127=$125+$126;
      var $128=$127+0.009999999776482582;
      $y2=$128;
      var $129=$3;
      var $130=(($129)|0)!=0;
      if ($130) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $131
      var $132=$2;
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$x1;
      var $136=$y1;
      var $137=$x2;
      var $138=$y2;
      __Z20ui_draw_outlined_boxP16render_containerffffj($134, $135, $136, $137, $138, -284159952);
      __label__ = 14; break;
    case 14: // $139
      var $140=$2;
      var $141=(($140+44)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$visible_lines;
      var $144=(((($143)|0)/2)|0);
      var $145=(($142-$144)|0);
      $top_line=$145;
      var $146=$top_line;
      var $147=(($146)|0) < 0;
      if ($147) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $148
      $top_line=0;
      __label__ = 16; break;
    case 16: // $149
      var $150=$top_line;
      var $151=$visible_lines;
      var $152=(($150+$151)|0);
      var $153=$2;
      var $154=(($153+56)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($152)|0) >= (($155)|0);
      if ($156) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $157
      var $158=$2;
      var $159=(($158+56)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=$visible_lines;
      var $162=(($160-$161)|0);
      $top_line=$162;
      __label__ = 18; break;
    case 18: // $163
      var $164=$visible_width;
      var $165=$gutter_width;
      var $166=$165*2;
      var $167=$164-$166;
      $effective_width=$167;
      var $168=$visible_left;
      var $169=$gutter_width;
      var $170=$168+$169;
      $effective_left=$170;
      $mouse_hit=0;
      HEAP32[(($mouse_button)>>2)]=0;
      var $171=$3;
      var $172=(($171)|0)!=0;
      if ($172) { __label__ = 24; break; } else { __label__ = 19; break; }
    case 19: // $173
      var $174=$1;
      var $175=__Z19ui_input_find_mouseR15running_machinePiS1_S1_($174, $mouse_target_x, $mouse_target_y, $mouse_button);
      $mouse_target=$175;
      var $176=$mouse_target;
      var $177=(($176)|0)!=0;
      if ($177) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $178
      var $179=$mouse_target;
      var $180=HEAP32[(($mouse_target_x)>>2)];
      var $181=HEAP32[(($mouse_target_y)>>2)];
      var $182=$2;
      var $183=(($182)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=__ZN13render_target19map_point_containerEiiR16render_containerRfS2_($179, $180, $181, $184, $mouse_x, $mouse_y);
      if ($185) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $186
      $mouse_hit=1;
      __label__ = 22; break;
    case 22: // $187
      __label__ = 23; break;
    case 23: // $188
      __label__ = 24; break;
    case 24: // $189
      var $190=$2;
      var $191=(($190+56)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+1)|0);
      var $194=$2;
      var $195=(($194+48)|0);
      HEAP32[(($195)>>2)]=$193;
      var $196=$3;
      var $197=(($196)|0)!=0;
      if ($197) { __label__ = 72; break; } else { __label__ = 25; break; }
    case 25: // $198
      $linenum=0;
      __label__ = 26; break;
    case 26: // $199
      var $200=$linenum;
      var $201=$visible_lines;
      var $202=(($200)|0) < (($201)|0);
      if ($202) { __label__ = 27; break; } else { __label__ = 71; break; }
    case 27: // $203
      var $204=$visible_top;
      var $205=$linenum;
      var $206=(($205)|0);
      var $207=$line_height;
      var $208=$206*$207;
      var $209=$204+$208;
      $line_y=$209;
      var $210=$top_line;
      var $211=$linenum;
      var $212=(($210+$211)|0);
      $itemnum1=$212;
      var $213=$itemnum1;
      var $214=$2;
      var $215=(($214+64)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($216+($213<<4))|0);
      $item2=$217;
      var $218=$item2;
      var $219=(($218)|0);
      var $220=HEAP32[(($219)>>2)];
      $itemtext=$220;
      $fgcolor=-1;
      $bgcolor=-285212672;
      $fgcolor2=-1;
      $fgcolor3=-8355712;
      var $221=$x1;
      var $222=$221+0.0010000000474974513;
      $line_x0=$222;
      var $223=$line_y;
      $line_y0=$223;
      var $224=$x2;
      var $225=$224-0.0010000000474974513;
      $line_x1=$225;
      var $226=$line_y;
      var $227=$line_height;
      var $228=$226+$227;
      $line_y1=$228;
      var $229=$mouse_hit;
      var $230=(($229)|0)!=0;
      if ($230) { __label__ = 28; break; } else { __label__ = 34; break; }
    case 28: // $231
      var $232=$line_x0;
      var $233=HEAPF32[(($mouse_x)>>2)];
      var $234=$232 <= $233;
      if ($234) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $235
      var $236=$line_x1;
      var $237=HEAPF32[(($mouse_x)>>2)];
      var $238=$236 > $237;
      if ($238) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $239
      var $240=$line_y0;
      var $241=HEAPF32[(($mouse_y)>>2)];
      var $242=$240 <= $241;
      if ($242) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $243
      var $244=$line_y1;
      var $245=HEAPF32[(($mouse_y)>>2)];
      var $246=$244 > $245;
      if ($246) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $247
      var $248=$item2;
      var $249=__ZL18item_is_selectablePK13_ui_menu_item($248);
      var $250=(($249)|0)!=0;
      if ($250) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $251
      var $252=$itemnum1;
      var $253=$2;
      var $254=(($253+48)|0);
      HEAP32[(($254)>>2)]=$252;
      __label__ = 34; break;
    case 34: // $255
      var $256=$itemnum1;
      var $257=$2;
      var $258=(($257+44)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($256)|0)==(($259)|0);
      if ($260) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $261
      $fgcolor=-256;
      $bgcolor=-276791296;
      $fgcolor2=-256;
      $fgcolor3=-256;
      __label__ = 39; break;
    case 36: // $262
      var $263=$itemnum1;
      var $264=$2;
      var $265=(($264+48)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($263)|0)==(($266)|0);
      if ($267) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $268
      $fgcolor=-128;
      $bgcolor=1883258880;
      $fgcolor2=-128;
      $fgcolor3=-128;
      __label__ = 38; break;
    case 38: // $269
      __label__ = 39; break;
    case 39: // $270
      var $271=$bgcolor;
      var $272=(($271)|0)!=-285212672;
      if ($272) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $273
      var $274=$2;
      var $275=(($274)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$line_x0;
      var $278=$line_y0;
      var $279=$line_x1;
      var $280=$line_y1;
      var $281=$bgcolor;
      var $282=HEAP32[((__ZL15hilight_texture)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($276, $277, $278, $279, $280, $281, $282, 16640);
      __label__ = 41; break;
    case 41: // $283
      var $284=$linenum;
      var $285=(($284)|0)==0;
      if ($285) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $286
      var $287=$top_line;
      var $288=(($287)|0)!=0;
      if ($288) { __label__ = 43; break; } else { __label__ = 46; break; }
    case 43: // $289
      var $290=$2;
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=$x1;
      var $294=$x2;
      var $295=$293+$294;
      var $296=$295*0.5;
      var $297=$ud_arrow_width;
      var $298=$297*0.5;
      var $299=$296-$298;
      var $300=$line_y;
      var $301=$line_height;
      var $302=$301*0.25;
      var $303=$300+$302;
      var $304=$x1;
      var $305=$x2;
      var $306=$304+$305;
      var $307=$306*0.5;
      var $308=$ud_arrow_width;
      var $309=$308*0.5;
      var $310=$307+$309;
      var $311=$line_y;
      var $312=$line_height;
      var $313=$312*0.75;
      var $314=$311+$313;
      var $315=$fgcolor;
      var $316=HEAP32[((__ZL13arrow_texture)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($292, $299, $303, $310, $314, $315, $316, 256);
      var $317=$2;
      var $318=(($317+48)|0);
      var $319=HEAP32[(($318)>>2)];
      var $320=$itemnum1;
      var $321=(($319)|0)==(($320)|0);
      if ($321) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $322
      var $323=$2;
      var $324=(($323+48)|0);
      HEAP32[(($324)>>2)]=-2;
      __label__ = 45; break;
    case 45: // $325
      __label__ = 69; break;
    case 46: // $326
      var $327=$linenum;
      var $328=$visible_lines;
      var $329=(($328-1)|0);
      var $330=(($327)|0)==(($329)|0);
      if ($330) { __label__ = 47; break; } else { __label__ = 51; break; }
    case 47: // $331
      var $332=$itemnum1;
      var $333=$2;
      var $334=(($333+56)|0);
      var $335=HEAP32[(($334)>>2)];
      var $336=(($335-1)|0);
      var $337=(($332)|0)!=(($336)|0);
      if ($337) { __label__ = 48; break; } else { __label__ = 51; break; }
    case 48: // $338
      var $339=$2;
      var $340=(($339)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$x1;
      var $343=$x2;
      var $344=$342+$343;
      var $345=$344*0.5;
      var $346=$ud_arrow_width;
      var $347=$346*0.5;
      var $348=$345-$347;
      var $349=$line_y;
      var $350=$line_height;
      var $351=$350*0.25;
      var $352=$349+$351;
      var $353=$x1;
      var $354=$x2;
      var $355=$353+$354;
      var $356=$355*0.5;
      var $357=$ud_arrow_width;
      var $358=$357*0.5;
      var $359=$356+$358;
      var $360=$line_y;
      var $361=$line_height;
      var $362=$361*0.75;
      var $363=$360+$362;
      var $364=$fgcolor;
      var $365=HEAP32[((__ZL13arrow_texture)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($341, $348, $352, $359, $363, $364, $365, 258);
      var $366=$2;
      var $367=(($366+48)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=$itemnum1;
      var $370=(($368)|0)==(($369)|0);
      if ($370) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $371
      var $372=$2;
      var $373=(($372+48)|0);
      HEAP32[(($373)>>2)]=-1;
      __label__ = 50; break;
    case 50: // $374
      __label__ = 68; break;
    case 51: // $375
      var $376=$itemtext;
      var $377=_strcmp($376, ((STRING_TABLE.__str144178)|0));
      var $378=(($377)|0)==0;
      if ($378) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $379
      var $380=$2;
      var $381=(($380)|0);
      var $382=HEAP32[(($381)>>2)];
      var $383=$visible_left;
      var $384=$line_y;
      var $385=$line_height;
      var $386=$385*0.5;
      var $387=$384+$386;
      var $388=$visible_left;
      var $389=$visible_width;
      var $390=$388+$389;
      var $391=$line_y;
      var $392=$line_height;
      var $393=$392*0.5;
      var $394=$391+$393;
      __ZN16render_container8add_lineEfffffjj($382, $383, $387, $390, $394, 0.0020000000949949026, -1, 256);
      __label__ = 67; break;
    case 53: // $395
      var $396=$item2;
      var $397=(($396+4)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=(($398)|0)==0;
      if ($399) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $400
      var $401=$2;
      var $402=(($401)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=$itemtext;
      var $405=$effective_left;
      var $406=$line_y;
      var $407=$effective_width;
      var $408=$fgcolor;
      var $409=$bgcolor;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($403, $404, $405, $406, $407, 1, 1, 1, $408, $409, 0, 0);
      __label__ = 66; break;
    case 55: // $410
      var $411=$item2;
      var $412=(($411+8)|0);
      var $413=HEAP32[(($412)>>2)];
      var $414=$413 & 4;
      $subitem_invert=$414;
      var $415=$item2;
      var $416=(($415+4)|0);
      var $417=HEAP32[(($416)>>2)];
      $subitem_text=$417;
      var $418=$2;
      var $419=(($418)|0);
      var $420=HEAP32[(($419)>>2)];
      var $421=$itemtext;
      var $422=$effective_left;
      var $423=$line_y;
      var $424=$effective_width;
      var $425=$fgcolor;
      var $426=$bgcolor;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($420, $421, $422, $423, $424, 0, 1, 1, $425, $426, $item_width, 0);
      var $427=$gutter_width;
      var $428=$427*2;
      var $429=HEAPF32[(($item_width)>>2)];
      var $430=$429+$428;
      HEAPF32[(($item_width)>>2)]=$430;
      var $431=$1;
      var $432=$subitem_text;
      var $433=__Z19ui_get_string_widthR15running_machinePKc($431, $432);
      var $434=$effective_width;
      var $435=HEAPF32[(($item_width)>>2)];
      var $436=$434-$435;
      var $437=$433 > $436;
      if ($437) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $438
      $subitem_text=((STRING_TABLE.__str1084272)|0);
      var $439=$itemnum1;
      var $440=$2;
      var $441=(($440+44)|0);
      var $442=HEAP32[(($441)>>2)];
      var $443=(($439)|0)==(($442)|0);
      if ($443) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $444
      $selected_subitem_too_big=1;
      __label__ = 58; break;
    case 58: // $445
      __label__ = 59; break;
    case 59: // $446
      var $447=$2;
      var $448=(($447)|0);
      var $449=HEAP32[(($448)>>2)];
      var $450=$subitem_text;
      var $451=$effective_left;
      var $452=HEAPF32[(($item_width)>>2)];
      var $453=$451+$452;
      var $454=$line_y;
      var $455=$effective_width;
      var $456=HEAPF32[(($item_width)>>2)];
      var $457=$455-$456;
      var $458=$subitem_invert;
      var $459=(($458)|0)!=0;
      var $460=$fgcolor3;
      var $461=$fgcolor2;
      var $462=$459 ? $460 : $461;
      var $463=$bgcolor;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($449, $450, $453, $454, $457, 2, 1, 1, $462, $463, $subitem_width, 0);
      var $464=$itemnum1;
      var $465=$2;
      var $466=(($465+44)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=(($464)|0)==(($467)|0);
      if ($468) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $469
      var $470=$item2;
      var $471=(($470+8)|0);
      var $472=HEAP32[(($471)>>2)];
      var $473=$472 & 1;
      var $474=(($473)|0)!=0;
      if ($474) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $475
      var $476=$2;
      var $477=(($476)|0);
      var $478=HEAP32[(($477)>>2)];
      var $479=$effective_left;
      var $480=$effective_width;
      var $481=$479+$480;
      var $482=HEAPF32[(($subitem_width)>>2)];
      var $483=$481-$482;
      var $484=$gutter_width;
      var $485=$483-$484;
      var $486=$line_y;
      var $487=$line_height;
      var $488=$487*0.10000000149011612;
      var $489=$486+$488;
      var $490=$effective_left;
      var $491=$effective_width;
      var $492=$490+$491;
      var $493=HEAPF32[(($subitem_width)>>2)];
      var $494=$492-$493;
      var $495=$gutter_width;
      var $496=$494-$495;
      var $497=$lr_arrow_width;
      var $498=$496+$497;
      var $499=$line_y;
      var $500=$line_height;
      var $501=$500*0.8999999761581421;
      var $502=$499+$501;
      var $503=$fgcolor;
      var $504=HEAP32[((__ZL13arrow_texture)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($478, $485, $489, $498, $502, $503, $504, 260);
      __label__ = 62; break;
    case 62: // $505
      var $506=$itemnum1;
      var $507=$2;
      var $508=(($507+44)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=(($506)|0)==(($509)|0);
      if ($510) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 63: // $511
      var $512=$item2;
      var $513=(($512+8)|0);
      var $514=HEAP32[(($513)>>2)];
      var $515=$514 & 2;
      var $516=(($515)|0)!=0;
      if ($516) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $517
      var $518=$2;
      var $519=(($518)|0);
      var $520=HEAP32[(($519)>>2)];
      var $521=$effective_left;
      var $522=$effective_width;
      var $523=$521+$522;
      var $524=$gutter_width;
      var $525=$523+$524;
      var $526=$lr_arrow_width;
      var $527=$525-$526;
      var $528=$line_y;
      var $529=$line_height;
      var $530=$529*0.10000000149011612;
      var $531=$528+$530;
      var $532=$effective_left;
      var $533=$effective_width;
      var $534=$532+$533;
      var $535=$gutter_width;
      var $536=$534+$535;
      var $537=$line_y;
      var $538=$line_height;
      var $539=$538*0.8999999761581421;
      var $540=$537+$539;
      var $541=$fgcolor;
      var $542=HEAP32[((__ZL13arrow_texture)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($520, $527, $531, $536, $540, $541, $542, 261);
      __label__ = 65; break;
    case 65: // $543
      __label__ = 66; break;
    case 66: // $544
      __label__ = 67; break;
    case 67: // $545
      __label__ = 68; break;
    case 68: // $546
      __label__ = 69; break;
    case 69: // $547
      __label__ = 70; break;
    case 70: // $548
      var $549=$linenum;
      var $550=(($549+1)|0);
      $linenum=$550;
      __label__ = 26; break;
    case 71: // $551
      __label__ = 72; break;
    case 72: // $552
      var $553=$selected_subitem_too_big;
      var $554=(($553)|0)!=0;
      if ($554) { __label__ = 73; break; } else { __label__ = 76; break; }
    case 73: // $555
      var $556=$2;
      var $557=(($556+44)|0);
      var $558=HEAP32[(($557)>>2)];
      var $559=$2;
      var $560=(($559+64)|0);
      var $561=HEAP32[(($560)>>2)];
      var $562=(($561+($558<<4))|0);
      $item3=$562;
      var $563=$item3;
      var $564=(($563+8)|0);
      var $565=HEAP32[(($564)>>2)];
      var $566=$565 & 4;
      $subitem_invert4=$566;
      var $567=$2;
      var $568=(($567+44)|0);
      var $569=HEAP32[(($568)>>2)];
      var $570=$top_line;
      var $571=(($569-$570)|0);
      $linenum5=$571;
      var $572=$visible_top;
      var $573=$linenum5;
      var $574=(($573)|0);
      var $575=$line_height;
      var $576=$574*$575;
      var $577=$572+$576;
      $line_y6=$577;
      var $578=$2;
      var $579=(($578)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=$item3;
      var $582=(($581+4)|0);
      var $583=HEAP32[(($582)>>2)];
      var $584=$visible_width;
      var $585=$584*0.75;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($580, $583, 0, 0, $585, 2, 2, 0, -1, -16777216, $target_width, $target_height);
      var $586=$visible_left;
      var $587=$visible_width;
      var $588=$586+$587;
      var $589=HEAPF32[(($target_width)>>2)];
      var $590=$588-$589;
      var $591=$590-0.009999999776482582;
      $target_x=$591;
      var $592=$line_y6;
      var $593=$line_height;
      var $594=$592+$593;
      var $595=$594+0.009999999776482582;
      $target_y=$595;
      var $596=$target_y;
      var $597=HEAPF32[(($target_height)>>2)];
      var $598=$596+$597;
      var $599=$598+0.009999999776482582;
      var $600=$visible_main_menu_height;
      var $601=$599 > $600;
      if ($601) { __label__ = 74; break; } else { __label__ = 75; break; }
    case 74: // $602
      var $603=$line_y6;
      var $604=HEAPF32[(($target_height)>>2)];
      var $605=$603-$604;
      var $606=$605-0.009999999776482582;
      $target_y=$606;
      __label__ = 75; break;
    case 75: // $607
      var $608=$2;
      var $609=(($608)|0);
      var $610=HEAP32[(($609)>>2)];
      var $611=$target_x;
      var $612=$611-0.009999999776482582;
      var $613=$target_y;
      var $614=$613-0.009999999776482582;
      var $615=$target_x;
      var $616=HEAPF32[(($target_width)>>2)];
      var $617=$615+$616;
      var $618=$617+0.009999999776482582;
      var $619=$target_y;
      var $620=HEAPF32[(($target_height)>>2)];
      var $621=$619+$620;
      var $622=$621+0.009999999776482582;
      var $623=$subitem_invert4;
      var $624=(($623)|0)!=0;
      var $625=$624 ? -276791296 : -284159952;
      __Z20ui_draw_outlined_boxP16render_containerffffj($610, $612, $614, $618, $622, $625);
      var $626=$2;
      var $627=(($626)|0);
      var $628=HEAP32[(($627)>>2)];
      var $629=$item3;
      var $630=(($629+4)|0);
      var $631=HEAP32[(($630)>>2)];
      var $632=$target_x;
      var $633=$target_y;
      var $634=HEAPF32[(($target_width)>>2)];
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($628, $631, $632, $633, $634, 2, 2, 1, -256, -276791296, 0, 0);
      __label__ = 76; break;
    case 76: // $635
      var $636=$2;
      var $637=(($636+68)|0);
      var $638=HEAP32[(($637)>>2)];
      var $639=(($638)|0)!=0;
      if ($639) { __label__ = 77; break; } else { __label__ = 82; break; }
    case 77: // $640
      var $641=$2;
      var $642=(($641+44)|0);
      var $643=HEAP32[(($642)>>2)];
      var $644=(($643)|0) >= 0;
      if ($644) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $645
      var $646=$2;
      var $647=(($646+44)|0);
      var $648=HEAP32[(($647)>>2)];
      var $649=$2;
      var $650=(($649+56)|0);
      var $651=HEAP32[(($650)>>2)];
      var $652=(($648)|0) < (($651)|0);
      if ($652) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $653
      var $654=$2;
      var $655=(($654+44)|0);
      var $656=HEAP32[(($655)>>2)];
      var $657=$2;
      var $658=(($657+64)|0);
      var $659=HEAP32[(($658)>>2)];
      var $660=(($659+($656<<4))|0);
      var $661=(($660+12)|0);
      var $662=HEAP32[(($661)>>2)];
      var $665 = $662;__label__ = 81; break;
    case 80: // $663
      var $665 = 0;__label__ = 81; break;
    case 81: // $664
      var $665;
      $selectedref=$665;
      var $666=$2;
      var $667=(($666+68)|0);
      var $668=HEAP32[(($667)>>2)];
      var $669=$2;
      var $670=__ZNK7ui_menu7machineEv($669);
      var $671=$2;
      var $672=$2;
      var $673=(($672+28)|0);
      var $674=HEAP32[(($673)>>2)];
      var $675=$selectedref;
      var $676=$2;
      var $677=(($676+72)|0);
      var $678=HEAPF32[(($677)>>2)];
      var $679=$2;
      var $680=(($679+76)|0);
      var $681=HEAPF32[(($680)>>2)];
      var $682=$x1;
      var $683=$y1;
      var $684=$x2;
      var $685=$y2;
      FUNCTION_TABLE[$668]($670, $671, $674, $675, $678, $681, $682, $683, $684, $685);
      __label__ = 82; break;
    case 82: // $686
      var $687=$visible_lines;
      var $688=$top_line;
      var $689=(($688)|0)!=0;
      var $690=(($689)&1);
      var $691=(($687-$690)|0);
      var $692=$top_line;
      var $693=$visible_lines;
      var $694=(($692+$693)|0);
      var $695=$2;
      var $696=(($695+56)|0);
      var $697=HEAP32[(($696)>>2)];
      var $698=(($694)|0)!=(($697)|0);
      var $699=(($698)&1);
      var $700=(($691-$699)|0);
      var $701=$2;
      var $702=(($701+52)|0);
      HEAP32[(($702)>>2)]=$700;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12ui_menu_drawR15running_machineP7ui_menui["X"]=1;

function __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($menu, $custom, $top, $bottom) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$menu;
  $2=$custom;
  $3=$top;
  $4=$bottom;
  var $5=$2;
  var $6=$1;
  var $7=(($6+68)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=$3;
  var $9=$1;
  var $10=(($9+72)|0);
  HEAPF32[(($10)>>2)]=$8;
  var $11=$4;
  var $12=$1;
  var $13=(($12+76)|0);
  HEAPF32[(($13)>>2)]=$11;
  ;
  return;
}


function __Z21ui_menu_get_selectionP7ui_menu($menu) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$menu;
      var $2=$1;
      var $3=(($2+44)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0) >= 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+44)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+56)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($9)|0) < (($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$1;
      var $16=(($15+44)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+64)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+($17<<4))|0);
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $26 = $23;__label__ = 4; break;
    case 3: // $24
      var $26 = 0;__label__ = 4; break;
    case 4: // $25
      var $26;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21ui_menu_handle_eventsP7ui_menu($menu) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $stop;
      var $menu_event=__stackBase__;
      $1=$menu;
      $stop=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=__ZNK7ui_menu7machineEv($3);
      var $5=__Z18ui_input_pop_eventR15running_machineP9_ui_event($4, $menu_event);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { var $12 = 0;__label__ = 3; break; }
    case 2: // $7
      var $8=$stop;
      var $9=(($8)|0)!=0;
      var $10=$9 ^ 1;
      var $12 = $10;__label__ = 3; break;
    case 3: // $11
      var $12;
      if ($12) { __label__ = 4; break; } else { __label__ = 26; break; }
    case 4: // $13
      var $14=(($menu_event)|0);
      var $15=HEAP32[(($14)>>2)];
      if ($15 == 3) {
        __label__ = 5; break;
      }
      else if ($15 == 5) {
        __label__ = 15; break;
      }
      else if ($15 == 6) {
        __label__ = 23; break;
      }
      else {
      __label__ = 24; break;
      }
      
    case 5: // $16
      var $17=$1;
      var $18=(($17+48)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0) >= 0;
      if ($20) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $21
      var $22=$1;
      var $23=(($22+48)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$1;
      var $26=(($25+56)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($24)|0) < (($27)|0);
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$1;
      var $31=(($30+48)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+44)|0);
      HEAP32[(($34)>>2)]=$32;
      __label__ = 14; break;
    case 8: // $35
      var $36=$1;
      var $37=(($36+48)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==-2;
      if ($39) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $40
      var $41=$1;
      var $42=(($41+52)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43-1)|0);
      var $45=$1;
      var $46=(($45+44)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-$44)|0);
      HEAP32[(($46)>>2)]=$48;
      var $49=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($49, 1);
      __label__ = 13; break;
    case 10: // $50
      var $51=$1;
      var $52=(($51+48)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)==-1;
      if ($54) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $55
      var $56=$1;
      var $57=(($56+52)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58-1)|0);
      var $60=$1;
      var $61=(($60+44)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+$59)|0);
      HEAP32[(($61)>>2)]=$63;
      var $64=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($64, 1);
      __label__ = 12; break;
    case 12: // $65
      __label__ = 13; break;
    case 13: // $66
      __label__ = 14; break;
    case 14: // $67
      __label__ = 25; break;
    case 15: // $68
      var $69=$1;
      var $70=(($69+48)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0) >= 0;
      if ($72) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $73
      var $74=$1;
      var $75=(($74+48)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$1;
      var $78=(($77+56)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($76)|0) < (($79)|0);
      if ($80) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $81
      var $82=$1;
      var $83=(($82+48)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$1;
      var $86=(($85+44)|0);
      HEAP32[(($86)>>2)]=$84;
      var $87=(($menu_event)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)==5;
      if ($89) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $90
      var $91=$1;
      var $92=(($91+12)|0);
      var $93=(($92+4)|0);
      HEAP32[(($93)>>2)]=182;
      var $94=$1;
      var $95=(($94+44)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$1;
      var $98=(($97+56)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99-1)|0);
      var $101=(($96)|0)==(($100)|0);
      if ($101) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $102
      var $103=$1;
      var $104=(($103+12)|0);
      var $105=(($104+4)|0);
      HEAP32[(($105)>>2)]=183;
      var $106=$1;
      var $107=__ZNK7ui_menu7machineEv($106);
      __Z17ui_menu_stack_popR15running_machine($107);
      __label__ = 20; break;
    case 20: // $108
      __label__ = 21; break;
    case 21: // $109
      $stop=1;
      __label__ = 22; break;
    case 22: // $110
      __label__ = 25; break;
    case 23: // $111
      var $112=$1;
      var $113=(($112+12)|0);
      var $114=(($113+4)|0);
      HEAP32[(($114)>>2)]=214;
      var $115=(($menu_event+20)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$1;
      var $118=(($117+12)|0);
      var $119=(($118+8)|0);
      HEAP32[(($119)>>2)]=$116;
      $stop=1;
      __label__ = 25; break;
    case 24: // $120
      __label__ = 25; break;
    case 25: // $121
      __label__ = 1; break;
    case 26: // $122
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21ui_menu_handle_eventsP7ui_menu["X"]=1;

function __ZL19ui_menu_handle_keysP7ui_menuj($menu, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ignorepause;
      var $ignoreright;
      var $ignoreleft;
      var $code;
      $1=$menu;
      $2=$flags;
      var $3=__Z28ui_menu_is_force_game_selectv();
      $ignorepause=$3;
      $ignoreright=0;
      $ignoreleft=0;
      var $4=$1;
      var $5=(($4+56)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 50; break;
    case 2: // $9
      var $10=$1;
      var $11=__ZL23exclusive_input_pressedP7ui_menuii($10, 182, 0);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $13
      var $14=$1;
      var $15=(($14+44)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$1;
      var $18=(($17+56)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-1)|0);
      var $21=(($16)|0)==(($20)|0);
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=(($24+4)|0);
      HEAP32[(($25)>>2)]=183;
      var $26=$1;
      var $27=__ZNK7ui_menu7machineEv($26);
      __Z17ui_menu_stack_popR15running_machine($27);
      __label__ = 5; break;
    case 5: // $28
      __label__ = 50; break;
    case 6: // $29
      var $30=$1;
      var $31=__ZL23exclusive_input_pressedP7ui_menuii($30, 183, 0);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$1;
      var $35=__ZNK7ui_menu7machineEv($34);
      __Z17ui_menu_stack_popR15running_machine($35);
      __label__ = 50; break;
    case 8: // $36
      var $37=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($37, 1);
      var $38=$1;
      var $39=(($38+44)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$1;
      var $42=(($41+64)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+($40<<4))|0);
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$46 & 1;
      var $48=(($47)|0)==0;
      var $49=(($48)&1);
      $ignoreleft=$49;
      var $50=$1;
      var $51=(($50+44)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$1;
      var $54=(($53+64)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+($52<<4))|0);
      var $57=(($56+8)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58 & 2;
      var $60=(($59)|0)==0;
      var $61=(($60)&1);
      $ignoreright=$61;
      var $62=$ignoreleft;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $64
      var $65=$1;
      var $66=$2;
      var $67=$66 & 2;
      var $68=(($67)|0)!=0;
      var $69=$68 ? 6 : 0;
      var $70=__ZL23exclusive_input_pressedP7ui_menuii($65, 176, $69);
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      __label__ = 50; break;
    case 11: // $73
      var $74=$ignoreright;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 12: // $76
      var $77=$1;
      var $78=$2;
      var $79=$78 & 2;
      var $80=(($79)|0)!=0;
      var $81=$80 ? 6 : 0;
      var $82=__ZL23exclusive_input_pressedP7ui_menuii($77, 177, $81);
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $84
      __label__ = 50; break;
    case 14: // $85
      var $86=$1;
      var $87=__ZL23exclusive_input_pressedP7ui_menuii($86, 174, 6);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $89
      var $90=$1;
      var $91=(($90+44)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$1;
      var $94=(($93+56)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($92+$95)|0);
      var $97=(($96-1)|0);
      var $98=$1;
      var $99=(($98+56)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($97)|0)%(($100)|0);
      var $102=$1;
      var $103=(($102+44)|0);
      HEAP32[(($103)>>2)]=$101;
      var $104=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($104, -1);
      __label__ = 16; break;
    case 16: // $105
      var $106=$1;
      var $107=__ZL23exclusive_input_pressedP7ui_menuii($106, 175, 6);
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $109
      var $110=$1;
      var $111=(($110+44)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112+1)|0);
      var $114=$1;
      var $115=(($114+56)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($113)|0)%(($116)|0);
      var $118=$1;
      var $119=(($118+44)|0);
      HEAP32[(($119)>>2)]=$117;
      var $120=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($120, 1);
      __label__ = 18; break;
    case 18: // $121
      var $122=$1;
      var $123=__ZL23exclusive_input_pressedP7ui_menuii($122, 180, 6);
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $125
      var $126=$1;
      var $127=(($126+52)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128-1)|0);
      var $130=$1;
      var $131=(($130+44)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132-$129)|0);
      HEAP32[(($131)>>2)]=$133;
      var $134=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($134, 1);
      __label__ = 20; break;
    case 20: // $135
      var $136=$1;
      var $137=__ZL23exclusive_input_pressedP7ui_menuii($136, 181, 6);
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $139
      var $140=$1;
      var $141=(($140+52)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142-1)|0);
      var $144=$1;
      var $145=(($144+44)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($146+$143)|0);
      HEAP32[(($145)>>2)]=$147;
      var $148=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($148, -1);
      __label__ = 22; break;
    case 22: // $149
      var $150=$1;
      var $151=__ZL23exclusive_input_pressedP7ui_menuii($150, 178, 0);
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $153
      var $154=$1;
      var $155=(($154+44)|0);
      HEAP32[(($155)>>2)]=0;
      var $156=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($156, 1);
      __label__ = 24; break;
    case 24: // $157
      var $158=$1;
      var $159=__ZL23exclusive_input_pressedP7ui_menuii($158, 179, 0);
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $161
      var $162=$1;
      var $163=(($162+56)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164-1)|0);
      var $166=$1;
      var $167=(($166+44)|0);
      HEAP32[(($167)>>2)]=$165;
      var $168=$1;
      __ZL26ui_menu_validate_selectionP7ui_menui($168, -1);
      __label__ = 26; break;
    case 26: // $169
      var $170=$ignorepause;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 32; break; } else { __label__ = 27; break; }
    case 27: // $172
      var $173=$1;
      var $174=__ZL23exclusive_input_pressedP7ui_menuii($173, 162, 0);
      var $175=(($174)|0)!=0;
      if ($175) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $176
      var $177=$1;
      var $178=__ZNK7ui_menu7machineEv($177);
      var $179=__ZNK15running_machine6pausedEv($178);
      if ($179) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $180
      var $181=$1;
      var $182=__ZNK7ui_menu7machineEv($181);
      __ZN15running_machine6resumeEv($182);
      __label__ = 31; break;
    case 30: // $183
      var $184=$1;
      var $185=__ZNK7ui_menu7machineEv($184);
      __ZN15running_machine5pauseEv($185);
      __label__ = 31; break;
    case 31: // $186
      __label__ = 32; break;
    case 32: // $187
      var $188=$1;
      var $189=__ZNK7ui_menu7machineEv($188);
      var $190=__Z23ui_input_pressed_repeatR15running_machineii($189, 173, 0);
      var $191=(($190)|0)!=0;
      if ($191) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $192
      var $193=$1;
      var $194=__ZNK7ui_menu7machineEv($193);
      var $195=__ZNK15running_machine5cheatEv($194);
      var $196=$1;
      var $197=__ZNK7ui_menu7machineEv($196);
      var $198=__ZNK15running_machine5cheatEv($197);
      var $199=__ZNK13cheat_manager7enabledEv($198);
      var $200=$199 ^ 1;
      __ZN13cheat_manager10set_enableEb($195, $200);
      __label__ = 34; break;
    case 34: // $201
      var $202=$1;
      var $203=(($202+12)|0);
      var $204=(($203+4)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205)|0)==0;
      if ($206) { __label__ = 35; break; } else { __label__ = 50; break; }
    case 35: // $207
      $code=159;
      __label__ = 36; break;
    case 36: // $208
      var $209=$code;
      var $210=(($209)|0) <= 212;
      if ($210) { __label__ = 37; break; } else { __label__ = 49; break; }
    case 37: // $211
      var $212=$code;
      var $213=(($212)|0)==159;
      if ($213) { __label__ = 44; break; } else { __label__ = 38; break; }
    case 38: // $214
      var $215=$code;
      var $216=(($215)|0)==176;
      if ($216) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $217
      var $218=$ignoreleft;
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 44; break; } else { __label__ = 40; break; }
    case 40: // $220
      var $221=$code;
      var $222=(($221)|0)==177;
      if ($222) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $223
      var $224=$ignoreright;
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 44; break; } else { __label__ = 42; break; }
    case 42: // $226
      var $227=$code;
      var $228=(($227)|0)==162;
      if ($228) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $229
      var $230=$ignorepause;
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $232
      __label__ = 48; break;
    case 45: // $233
      var $234=$1;
      var $235=$code;
      var $236=__ZL23exclusive_input_pressedP7ui_menuii($234, $235, 0);
      var $237=(($236)|0)!=0;
      if ($237) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $238
      __label__ = 49; break;
    case 47: // $239
      __label__ = 48; break;
    case 48: // $240
      var $241=$code;
      var $242=(($241+1)|0);
      $code=$242;
      __label__ = 36; break;
    case 49: // $243
      __label__ = 50; break;
    case 50: // $244
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19ui_menu_handle_keysP7ui_menuj["X"]=1;

function __Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($menu, $size, $destroy_state) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      $7=$menu;
      $8=$size;
      $9=$destroy_state;
      var $10=$7;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $14
      var $15=$7;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      var $20=$7;
      var $21=(($20+32)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$7;
      var $24=$7;
      var $25=(($24+28)|0);
      var $26=HEAP32[(($25)>>2)];
      FUNCTION_TABLE[$22]($23, $26);
      __label__ = 3; break;
    case 3: // $27
      var $28=$7;
      var $29=__ZNK7ui_menu7machineEv($28);
      var $30=__ZN15running_machine7respoolEv($29);
      var $31=$7;
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      __ZN13resource_pool6removeEPv($30, $33);
      __label__ = 4; break;
    case 4: // $34
      var $35=$7;
      var $36=__ZNK7ui_menu7machineEv($35);
      var $37=__ZN15running_machine7respoolEv($36);
      var $38=$8;
      var $39=$1;
      var $40=$2;
      var $41=$3;
      var $42=$4;
      var $43=$result_i;
      var $44=$5;
      var $45=$6;
      HEAP32[(($1)>>2)]=$38;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($3)>>2)]=666;
      HEAP32[(($4)>>2)]=_zeromem;
      var $46=HEAP32[(($1)>>2)];
      var $47=HEAP32[(($2)>>2)];
      var $48=HEAP32[(($3)>>2)];
      var $49=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($46, $47, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $50
      HEAP32[(($result_i)>>2)]=$49;
      var $51=HEAP32[(($result_i)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $53
      var $54=___cxa_allocate_exception(4);
      var $55=$54;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($55);
      (function() { try { __THREW__ = false; return ___cxa_throw($54, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $58=$57.f0;
      HEAP32[(($5)>>2)]=$58;
      var $59=$57.f1;
      HEAP32[(($6)>>2)]=$59;
      var $60=HEAP32[(($6)>>2)];
      var $61=(($60)|0) < 0;
      if ($61) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $62
      var $63=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($63);
      throw "Reached an unreachable!"
    case 9: // $64
      var $65=HEAP32[(($5)>>2)];
      var $66=HEAP32[(($5)>>2)];
      var $67=HEAP32[(($6)>>2)];
      var $68=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $66, tempValue);
      var $69=($68.f1 = $67, $68);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $70
      throw "Reached an unreachable!"
    case 11: // $_ZnajPKciRK9zeromem_t_exit
      var $71=HEAP32[(($result_i)>>2)];
      var $72=HEAP32[(($1)>>2)];
      _memset($71, 0, $72, 1);
      var $73=HEAP32[(($result_i)>>2)];
      var $74=$1;
      var $75=$2;
      var $76=$3;
      var $77=$4;
      var $78=$result_i;
      var $79=$5;
      var $80=$6;
      var $81=$8;
      var $82=__ZN13resource_pool9add_arrayIhEEPT_S2_i($37, $73, $81);
      var $83=$7;
      var $84=(($83+28)|0);
      HEAP32[(($84)>>2)]=$82;
      var $85=$9;
      var $86=$7;
      var $87=(($86+32)|0);
      HEAP32[(($87)>>2)]=$85;
      var $88=$7;
      var $89=(($88+28)|0);
      var $90=HEAP32[(($89)>>2)];
      STACKTOP = __stackBase__;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE["X"]=1;

function __Z18ui_menu_pool_allocP7ui_menuj($menu, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $pool;
      var $result;
      $8=$menu;
      $9=$size;
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=$8;
      var $13=(($12+80)|0);
      var $14=HEAP32[(($13)>>2)];
      $pool=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$pool;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $18
      var $19=$pool;
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$pool;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$21;
      var $26=$24;
      var $27=(($25-$26)|0);
      var $28=$9;
      var $29=(($27)>>>0) >= (($28)>>>0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$pool;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      $result=$33;
      var $34=$9;
      var $35=$pool;
      var $36=(($35+4)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+$34)|0);
      HEAP32[(($36)>>2)]=$38;
      var $39=$result;
      $7=$39;
      __label__ = 16; break;
    case 6: // $40
      __label__ = 7; break;
    case 7: // $41
      var $42=$pool;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      $pool=$44;
      __label__ = 3; break;
    case 8: // $45
      var $46=$8;
      var $47=__ZNK7ui_menu7machineEv($46);
      var $48=__ZN15running_machine7respoolEv($47);
      var $49=$1;
      var $50=$2;
      var $51=$3;
      var $52=$4;
      var $53=$result_i;
      var $54=$5;
      var $55=$6;
      HEAP32[(($1)>>2)]=65548;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($3)>>2)]=694;
      HEAP32[(($4)>>2)]=_zeromem;
      var $56=HEAP32[(($1)>>2)];
      var $57=HEAP32[(($2)>>2)];
      var $58=HEAP32[(($3)>>2)];
      var $59=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($56, $57, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $60
      HEAP32[(($result_i)>>2)]=$59;
      var $61=HEAP32[(($result_i)>>2)];
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $63
      var $64=___cxa_allocate_exception(4);
      var $65=$64;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($65);
      (function() { try { __THREW__ = false; return ___cxa_throw($64, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      HEAP32[(($5)>>2)]=$68;
      var $69=$67.f1;
      HEAP32[(($6)>>2)]=$69;
      var $70=HEAP32[(($6)>>2)];
      var $71=(($70)|0) < 0;
      if ($71) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $72
      var $73=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($73);
      throw "Reached an unreachable!"
    case 13: // $74
      var $75=HEAP32[(($5)>>2)];
      var $76=HEAP32[(($5)>>2)];
      var $77=HEAP32[(($6)>>2)];
      var $78=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $76, tempValue);
      var $79=($78.f1 = $77, $78);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $80
      throw "Reached an unreachable!"
    case 15: // $_ZnajPKciRK9zeromem_t_exit
      var $81=HEAP32[(($result_i)>>2)];
      var $82=HEAP32[(($1)>>2)];
      _memset($81, 0, $82, 1);
      var $83=HEAP32[(($result_i)>>2)];
      var $84=$1;
      var $85=$2;
      var $86=$3;
      var $87=$4;
      var $88=$result_i;
      var $89=$5;
      var $90=$6;
      var $91=__ZN13resource_pool9add_arrayIhEEPT_S2_i($48, $83, 65548);
      var $92=$91;
      $pool=$92;
      var $93=$8;
      var $94=(($93+80)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$pool;
      var $97=(($96)|0);
      HEAP32[(($97)>>2)]=$95;
      var $98=$pool;
      var $99=$8;
      var $100=(($99+80)|0);
      HEAP32[(($100)>>2)]=$98;
      var $101=$pool;
      var $102=(($101+12)|0);
      var $103=$102;
      var $104=$pool;
      var $105=(($104+4)|0);
      HEAP32[(($105)>>2)]=$103;
      var $106=$pool;
      var $107=(($106+4)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+65536)|0);
      var $110=$pool;
      var $111=(($110+8)|0);
      HEAP32[(($111)>>2)]=$109;
      var $112=$8;
      var $113=$9;
      var $114=__Z18ui_menu_pool_allocP7ui_menuj($112, $113);
      $7=$114;
      __label__ = 16; break;
    case 16: // $115
      var $116=$7;
      STACKTOP = __stackBase__;
      return $116;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18ui_menu_pool_allocP7ui_menuj["X"]=1;

function __Z21ui_menu_set_selectionP7ui_menuPv($menu, $selected_itemref) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $itemnum;
      $1=$menu;
      $2=$selected_itemref;
      var $3=$1;
      var $4=(($3+44)|0);
      HEAP32[(($4)>>2)]=-1;
      $itemnum=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$itemnum;
      var $7=$1;
      var $8=(($7+56)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$itemnum;
      var $13=$1;
      var $14=(($13+64)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+($12<<4))|0);
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$itemnum;
      var $23=$1;
      var $24=(($23+44)|0);
      HEAP32[(($24)>>2)]=$22;
      __label__ = 6; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$itemnum;
      var $28=(($27+1)|0);
      $itemnum=$28;
      __label__ = 1; break;
    case 6: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z28ui_menu_is_force_game_selectv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $menu;
      var $2=HEAP32[((__ZL10menu_stack)>>2)];
      $menu=$2;
      __label__ = 1; break;
    case 1: // $3
      var $4=$menu;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $6
      var $7=$menu;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==1016;
      if ($10) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $11
      var $12=$menu;
      var $13=(($12+24)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      $1=1;
      __label__ = 8; break;
    case 5: // $17
      __label__ = 6; break;
    case 6: // $18
      var $19=$menu;
      var $20=(($19+24)|0);
      var $21=HEAP32[(($20)>>2)];
      $menu=$21;
      __label__ = 1; break;
    case 7: // $22
      $1=0;
      __label__ = 8; break;
    case 8: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17ui_menu_stack_popR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $menu;
      $1=$machine;
      var $2=HEAP32[((__ZL10menu_stack)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=HEAP32[((__ZL10menu_stack)>>2)];
      $menu=$5;
      var $6=$menu;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      HEAP32[((__ZL10menu_stack)>>2)]=$8;
      var $9=HEAP32[((__ZL9menu_free)>>2)];
      var $10=$menu;
      var $11=(($10+24)|0);
      HEAP32[(($11)>>2)]=$9;
      var $12=$menu;
      HEAP32[((__ZL9menu_free)>>2)]=$12;
      var $13=$1;
      __Z14ui_input_resetR15running_machine($13);
      __label__ = 2; break;
    case 2: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18ui_menu_stack_pushP7ui_menu($menu) {
  ;
  var __label__;

  var $1;
  $1=$menu;
  var $2=HEAP32[((__ZL10menu_stack)>>2)];
  var $3=$1;
  var $4=(($3+24)|0);
  HEAP32[(($4)>>2)]=$2;
  var $5=$1;
  HEAP32[((__ZL10menu_stack)>>2)]=$5;
  var $6=$1;
  __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($6, 0);
  var $7=$1;
  var $8=__ZNK7ui_menu7machineEv($7);
  __Z14ui_input_resetR15running_machine($8);
  ;
  return;
}


function __Z18ui_menu_ui_handlerR15running_machineP16render_containerj($machine, $container, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu;
      $2=$machine;
      $3=$container;
      $4=$state;
      var $5=HEAP32[((__ZL10menu_stack)>>2)];
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=$3;
      var $10=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($8, $9, 1020, 0);
      __Z18ui_menu_stack_pushP7ui_menu($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=HEAP32[((__ZL10menu_stack)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=HEAP32[((__ZL10menu_stack)>>2)];
      $menu=$15;
      var $16=$menu;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=$menu;
      var $21=$menu;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$menu;
      var $25=(($24+28)|0);
      var $26=HEAP32[(($25)>>2)];
      FUNCTION_TABLE[$18]($19, $20, $23, $26);
      __label__ = 4; break;
    case 4: // $27
      var $28=$2;
      __ZL23ui_menu_clear_free_listR15running_machine($28);
      var $29=$2;
      var $30=__Z16ui_input_pressedR15running_machinei($29, 159);
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      var $33=__Z28ui_menu_is_force_game_selectv();
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=HEAP32[((__ZL10menu_stack)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      $1=-1;
      __label__ = 9; break;
    case 8: // $39
      $1=0;
      __label__ = 9; break;
    case 9: // $40
      var $41=$1;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18ui_menu_ui_handlerR15running_machineP16render_containerj["X"]=1;

function __ZL9menu_mainR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$2;
      var $6=__Z17ui_menu_populatedP7ui_menu($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=$2;
      var $11=$4;
      __ZL18menu_main_populateR15running_machineP7ui_menuPv($9, $10, $11);
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=$2;
      var $15=__Z15ui_menu_processR15running_machineP7ui_menuj($13, $14, 0);
      $menu_event=$15;
      var $16=$menu_event;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      var $19=$menu_event;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==182;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$1;
      var $25=$2;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$menu_event;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30;
      var $32=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($24, $27, $31, 0);
      __Z18ui_menu_stack_pushP7ui_menu($32);
      __label__ = 5; break;
    case 5: // $33
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23ui_menu_clear_free_listR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $menu;
      $1=$machine;
      __label__ = 1; break;
    case 1: // $2
      var $3=HEAP32[((__ZL9menu_free)>>2)];
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $5
      var $6=HEAP32[((__ZL9menu_free)>>2)];
      $menu=$6;
      var $7=$menu;
      var $8=(($7+24)|0);
      var $9=HEAP32[(($8)>>2)];
      HEAP32[((__ZL9menu_free)>>2)]=$9;
      var $10=$menu;
      __Z12ui_menu_freeP7ui_menu($10);
      __label__ = 1; break;
    case 3: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20ui_slider_ui_handlerR15running_machineP16render_containerj($machine, $container, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      $1=$machine;
      $2=$container;
      $3=$state;
      var $4=$3;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=$2;
      var $9=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($7, $8, 1018, 1);
      __Z18ui_menu_stack_pushP7ui_menu($9);
      __label__ = 2; break;
    case 2: // $10
      var $11=$1;
      var $12=$2;
      var $13=$3;
      var $14=__Z18ui_menu_ui_handlerR15running_machineP16render_containerj($11, $12, $13);
      $result=$14;
      var $15=$result;
      var $16=(($15)|0)==-1;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$1;
      __Z17ui_menu_stack_popR15running_machine($18);
      __label__ = 4; break;
    case 4: // $19
      var $20=HEAP32[((__ZL10menu_stack)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { var $33 = 0;__label__ = 7; break; }
    case 5: // $22
      var $23=HEAP32[((__ZL10menu_stack)>>2)];
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)==1018;
      if ($26) { __label__ = 6; break; } else { var $33 = 0;__label__ = 7; break; }
    case 6: // $27
      var $28=HEAP32[((__ZL10menu_stack)>>2)];
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      var $33 = $31;__label__ = 7; break;
    case 7: // $32
      var $33;
      var $34=$33 ? 0 : -1;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12menu_slidersR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menuless_mode;
      var $menu_event;
      var $hidden;
      var $slider;
      var $curvalue;
      var $increment;
      var $5=__stackBase__;
      var $6=__stackBase__+4;
      var $7=__stackBase__+8;
      var $8=__stackBase__+12;
      var $9=__stackBase__+16;
      var $10=__stackBase__+20;
      var $11=__stackBase__+24;
      var $12=__stackBase__+28;
      var $13=__stackBase__+32;
      var $14=__stackBase__+36;
      var $15=__stackBase__+40;
      var $16=__stackBase__+44;
      var $newvalue;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $17=$3;
      var $18=(($17)|0)!=0;
      var $19=(($18)&1);
      $menuless_mode=$19;
      var $20=$4;
      $hidden=$20;
      var $21=$hidden;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $23
      var $24=$2;
      var $25=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($24, 1, 0);
      $hidden=$25;
      __label__ = 2; break;
    case 2: // $26
      var $27=$menuless_mode;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$hidden;
      HEAP8[($30)]=1;
      __label__ = 4; break;
    case 4: // $31
      var $32=$2;
      var $33=__Z17ui_menu_populatedP7ui_menu($32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $35
      var $36=$1;
      var $37=$2;
      var $38=$menuless_mode;
      __ZL21menu_sliders_populateR15running_machineP7ui_menui($36, $37, $38);
      __label__ = 6; break;
    case 6: // $39
      var $40=$1;
      var $41=$2;
      var $42=$hidden;
      var $43=HEAP8[($42)];
      var $44=(($43 << 24) >> 24)!=0;
      var $45=$44 ? 4 : 0;
      var $46=2 | $45;
      var $47=__Z15ui_menu_processR15running_machineP7ui_menuj($40, $41, $46);
      $menu_event=$47;
      var $48=$menu_event;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 7; break; } else { __label__ = 64; break; }
    case 7: // $50
      var $51=$menu_event;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 8; break; } else { __label__ = 53; break; }
    case 8: // $55
      var $56=$menu_event;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58;
      $slider=$59;
      var $60=$slider;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$1;
      var $64=$slider;
      var $65=(($64+8)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=FUNCTION_TABLE[$62]($63, $66, 0, 305419896);
      $curvalue=$67;
      $increment=0;
      var $68=$menu_event;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      if ($70 == 160) {
        __label__ = 9; break;
      }
      else if ($70 == 176) {
        __label__ = 13; break;
      }
      else if ($70 == 177) {
        __label__ = 29; break;
      }
      else if ($70 == 182) {
        __label__ = 45; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 9: // $71
      var $72=$menuless_mode;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $74
      var $75=$1;
      __Z17ui_menu_stack_popR15running_machine($75);
      __label__ = 12; break;
    case 11: // $76
      var $77=$hidden;
      var $78=HEAP8[($77)];
      var $79=(($78 << 24) >> 24)!=0;
      var $80=$79 ^ 1;
      var $81=(($80)&1);
      var $82=$hidden;
      HEAP8[($82)]=$81;
      __label__ = 12; break;
    case 12: // $83
      __label__ = 46; break;
    case 13: // $84
      var $85=$1;
      var $86=__ZNK15running_machine5inputEv($85);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 1, 0, 1, 0, 101);
      var $87=__ZN13input_manager12code_pressedE10input_code($86, $5);
      if ($87) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $88
      var $89=$1;
      var $90=__ZNK15running_machine5inputEv($89);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 102);
      var $91=__ZN13input_manager12code_pressedE10input_code($90, $6);
      if ($91) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $92
      $increment=-1;
      __label__ = 28; break;
    case 16: // $93
      var $94=$1;
      var $95=__ZNK15running_machine5inputEv($94);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($7, 1, 0, 1, 0, 97);
      var $96=__ZN13input_manager12code_pressedE10input_code($95, $7);
      if ($96) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $97
      var $98=$1;
      var $99=__ZNK15running_machine5inputEv($98);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($8, 1, 0, 1, 0, 98);
      var $100=__ZN13input_manager12code_pressedE10input_code($99, $8);
      if ($100) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $101
      var $102=$slider;
      var $103=(($102+24)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104)|0) > 10;
      if ($105) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $106
      var $107=$slider;
      var $108=(($107+24)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(((($109)|0)/10)|0);
      var $111=(((-$110))|0);
      var $114 = $111;__label__ = 21; break;
    case 20: // $112
      var $114 = -1;__label__ = 21; break;
    case 21: // $113
      var $114;
      $increment=$114;
      __label__ = 27; break;
    case 22: // $115
      var $116=$1;
      var $117=__ZNK15running_machine5inputEv($116);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($9, 1, 0, 1, 0, 99);
      var $118=__ZN13input_manager12code_pressedE10input_code($117, $9);
      if ($118) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $119
      var $120=$1;
      var $121=__ZNK15running_machine5inputEv($120);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($10, 1, 0, 1, 0, 100);
      var $122=__ZN13input_manager12code_pressedE10input_code($121, $10);
      if ($122) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $123
      var $124=$slider;
      var $125=(($124+24)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(((-$126))|0);
      var $128=(($127*10)|0);
      $increment=$128;
      __label__ = 26; break;
    case 25: // $129
      var $130=$slider;
      var $131=(($130+24)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(((-$132))|0);
      $increment=$133;
      __label__ = 26; break;
    case 26: // $134
      __label__ = 27; break;
    case 27: // $135
      __label__ = 28; break;
    case 28: // $136
      __label__ = 46; break;
    case 29: // $137
      var $138=$1;
      var $139=__ZNK15running_machine5inputEv($138);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($11, 1, 0, 1, 0, 101);
      var $140=__ZN13input_manager12code_pressedE10input_code($139, $11);
      if ($140) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $141
      var $142=$1;
      var $143=__ZNK15running_machine5inputEv($142);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($12, 1, 0, 1, 0, 102);
      var $144=__ZN13input_manager12code_pressedE10input_code($143, $12);
      if ($144) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $145
      $increment=1;
      __label__ = 44; break;
    case 32: // $146
      var $147=$1;
      var $148=__ZNK15running_machine5inputEv($147);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($13, 1, 0, 1, 0, 97);
      var $149=__ZN13input_manager12code_pressedE10input_code($148, $13);
      if ($149) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $150
      var $151=$1;
      var $152=__ZNK15running_machine5inputEv($151);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($14, 1, 0, 1, 0, 98);
      var $153=__ZN13input_manager12code_pressedE10input_code($152, $14);
      if ($153) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $154
      var $155=$slider;
      var $156=(($155+24)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0) > 10;
      if ($158) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $159
      var $160=$slider;
      var $161=(($160+24)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(((($162)|0)/10)|0);
      var $166 = $163;__label__ = 37; break;
    case 36: // $164
      var $166 = 1;__label__ = 37; break;
    case 37: // $165
      var $166;
      $increment=$166;
      __label__ = 43; break;
    case 38: // $167
      var $168=$1;
      var $169=__ZNK15running_machine5inputEv($168);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($15, 1, 0, 1, 0, 99);
      var $170=__ZN13input_manager12code_pressedE10input_code($169, $15);
      if ($170) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $171
      var $172=$1;
      var $173=__ZNK15running_machine5inputEv($172);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($16, 1, 0, 1, 0, 100);
      var $174=__ZN13input_manager12code_pressedE10input_code($173, $16);
      if ($174) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $175
      var $176=$slider;
      var $177=(($176+24)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=(($178*10)|0);
      $increment=$179;
      __label__ = 42; break;
    case 41: // $180
      var $181=$slider;
      var $182=(($181+24)|0);
      var $183=HEAP32[(($182)>>2)];
      $increment=$183;
      __label__ = 42; break;
    case 42: // $184
      __label__ = 43; break;
    case 43: // $185
      __label__ = 44; break;
    case 44: // $186
      __label__ = 46; break;
    case 45: // $187
      var $188=$slider;
      var $189=(($188+16)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$curvalue;
      var $192=(($190-$191)|0);
      $increment=$192;
      __label__ = 46; break;
    case 46: // $193
      var $194=$increment;
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 47; break; } else { __label__ = 52; break; }
    case 47: // $196
      var $197=$curvalue;
      var $198=$increment;
      var $199=(($197+$198)|0);
      $newvalue=$199;
      var $200=$newvalue;
      var $201=$slider;
      var $202=(($201+12)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(($200)|0) < (($203)|0);
      if ($204) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $205
      var $206=$slider;
      var $207=(($206+12)|0);
      var $208=HEAP32[(($207)>>2)];
      $newvalue=$208;
      __label__ = 49; break;
    case 49: // $209
      var $210=$newvalue;
      var $211=$slider;
      var $212=(($211+20)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($210)|0) > (($213)|0);
      if ($214) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $215
      var $216=$slider;
      var $217=(($216+20)|0);
      var $218=HEAP32[(($217)>>2)];
      $newvalue=$218;
      __label__ = 51; break;
    case 51: // $219
      var $220=$slider;
      var $221=(($220+4)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$1;
      var $224=$slider;
      var $225=(($224+8)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$newvalue;
      var $228=FUNCTION_TABLE[$222]($223, $226, 0, $227);
      var $229=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($229, 2);
      __label__ = 52; break;
    case 52: // $230
      __label__ = 63; break;
    case 53: // $231
      var $232=$hidden;
      var $233=HEAP8[($232)];
      var $234=(($233 << 24) >> 24)!=0;
      if ($234) { __label__ = 54; break; } else { __label__ = 62; break; }
    case 54: // $235
      var $236=$menu_event;
      var $237=(($236+4)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($238)|0)==174;
      if ($239) { __label__ = 56; break; } else { __label__ = 55; break; }
    case 55: // $240
      var $241=$menu_event;
      var $242=(($241+4)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243)|0)==180;
      if ($244) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $245
      var $246=$2;
      var $247=(($246+44)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=$2;
      var $250=(($249+56)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($248+$251)|0);
      var $253=(($252-1)|0);
      var $254=$2;
      var $255=(($254+56)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=(($253)|0)%(($256)|0);
      var $258=$2;
      var $259=(($258+44)|0);
      HEAP32[(($259)>>2)]=$257;
      var $260=$2;
      __ZL26ui_menu_validate_selectionP7ui_menui($260, -1);
      __label__ = 61; break;
    case 57: // $261
      var $262=$menu_event;
      var $263=(($262+4)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(($264)|0)==175;
      if ($265) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $266
      var $267=$menu_event;
      var $268=(($267+4)|0);
      var $269=HEAP32[(($268)>>2)];
      var $270=(($269)|0)==181;
      if ($270) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $271
      var $272=$2;
      var $273=(($272+44)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($274+1)|0);
      var $276=$2;
      var $277=(($276+56)|0);
      var $278=HEAP32[(($277)>>2)];
      var $279=(($275)|0)%(($278)|0);
      var $280=$2;
      var $281=(($280+44)|0);
      HEAP32[(($281)>>2)]=$279;
      var $282=$2;
      __ZL26ui_menu_validate_selectionP7ui_menui($282, 1);
      __label__ = 60; break;
    case 60: // $283
      __label__ = 61; break;
    case 61: // $284
      __label__ = 62; break;
    case 62: // $285
      __label__ = 63; break;
    case 63: // $286
      __label__ = 64; break;
    case 64: // $287
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12menu_slidersR15running_machineP7ui_menuPvS3_["X"]=1;

function __Z25ui_menu_force_game_selectR15running_machineP16render_container($machine, $container) {
  ;
  var __label__;

  var $1;
  var $2;
  var $gamename;
  $1=$machine;
  $2=$container;
  var $3=$1;
  var $4=__ZNK15running_machine7optionsEv($3);
  var $5=__ZNK11emu_options11system_nameEv($4);
  $gamename=$5;
  var $6=$1;
  __Z19ui_menu_stack_resetR15running_machine($6);
  var $7=$1;
  var $8=$2;
  var $9=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($7, $8, 1016, 0);
  __Z18ui_menu_stack_pushP7ui_menu($9);
  var $10=$1;
  var $11=$2;
  var $12=$gamename;
  var $13=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($10, $11, 1022, $12);
  __Z18ui_menu_stack_pushP7ui_menu($13);
  __Z12ui_show_menuv();
  var $14=$1;
  __ZN15running_machine5pauseEv($14);
  ;
  return;
}


function __Z25ui_slot_get_current_indexR15running_machineP21device_slot_interface($machine, $slot) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $current;
      var $intf;
      var $val;
      var $i;
      $1=$machine;
      $2=$slot;
      var $3=$1;
      var $4=__ZNK15running_machine7optionsEv($3);
      var $5=$4;
      var $6=$2;
      var $7=$6;
      var $8=__ZN16device_interface6deviceEv($7);
      var $9=__ZNK8device_t3tagEv($8);
      var $10=__ZNK12core_options5valueEPKc($5, $9);
      $current=$10;
      var $11=$2;
      var $12=__ZNK21device_slot_interface19get_slot_interfacesEv($11);
      $intf=$12;
      $val=-1;
      $i=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$i;
      var $15=$intf;
      var $16=(($15+($14<<3))|0);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $20
      var $21=$current;
      var $22=$i;
      var $23=$intf;
      var $24=(($23+($22<<3))|0);
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=_strcmp($21, $26);
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$i;
      $val=$30;
      __label__ = 4; break;
    case 4: // $31
      __label__ = 5; break;
    case 5: // $32
      var $33=$i;
      var $34=(($33+1)|0);
      $i=$34;
      __label__ = 1; break;
    case 6: // $35
      var $36=$val;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18ui_slot_get_lengthR15running_machineP21device_slot_interface($machine, $slot) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $intf;
      var $val;
      var $i;
      $1=$machine;
      $2=$slot;
      var $3=$2;
      var $4=__ZNK21device_slot_interface19get_slot_interfacesEv($3);
      $intf=$4;
      $val=0;
      $i=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$intf;
      var $8=(($7+($6<<3))|0);
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$val;
      var $14=(($13+1)|0);
      $val=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$i;
      var $17=(($16+1)|0);
      $i=$17;
      __label__ = 1; break;
    case 4: // $18
      var $19=$val;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16ui_slot_get_nextR15running_machineP21device_slot_interface($machine, $slot) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $idx;
      $2=$machine;
      $3=$slot;
      var $4=$2;
      var $5=$3;
      var $6=__Z25ui_slot_get_current_indexR15running_machineP21device_slot_interface($4, $5);
      var $7=(($6+1)|0);
      $idx=$7;
      var $8=$idx;
      var $9=$2;
      var $10=$3;
      var $11=__Z18ui_slot_get_lengthR15running_machineP21device_slot_interface($9, $10);
      var $12=(($8)|0)==(($11)|0);
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=((__str24166)|0);
      __label__ = 3; break;
    case 2: // $14
      var $15=$idx;
      var $16=$3;
      var $17=__ZNK21device_slot_interface19get_slot_interfacesEv($16);
      var $18=(($17+($15<<3))|0);
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $1=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16ui_slot_get_prevR15running_machineP21device_slot_interface($machine, $slot) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $idx;
      $2=$machine;
      $3=$slot;
      var $4=$2;
      var $5=$3;
      var $6=__Z25ui_slot_get_current_indexR15running_machineP21device_slot_interface($4, $5);
      var $7=(($6-1)|0);
      $idx=$7;
      var $8=$idx;
      var $9=(($8)|0)==-1;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=((__str24166)|0);
      __label__ = 5; break;
    case 2: // $11
      var $12=$idx;
      var $13=(($12)|0)==-2;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      var $16=$3;
      var $17=__Z18ui_slot_get_lengthR15running_machineP21device_slot_interface($15, $16);
      var $18=(($17-1)|0);
      $idx=$18;
      __label__ = 4; break;
    case 4: // $19
      var $20=$idx;
      var $21=$3;
      var $22=__ZNK21device_slot_interface19get_slot_interfacesEv($21);
      var $23=(($22+($20<<3))|0);
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      $1=$25;
      __label__ = 5; break;
    case 5: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18ui_get_slot_deviceR15running_machineP21device_slot_interface($machine, $slot) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$machine;
  $2=$slot;
  var $3=$1;
  var $4=__ZNK15running_machine7optionsEv($3);
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=__ZN16device_interface6deviceEv($7);
  var $9=__ZNK8device_t3tagEv($8);
  var $10=__ZNK12core_options5valueEPKc($5, $9);
  ;
  return $10;
}


function __ZN19resource_pool_arrayI13_ui_menu_itemEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI13_ui_menu_itemEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI13_ui_menu_itemEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<4))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI13_ui_menu_itemE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI13_ui_menu_itemED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI13_ui_menu_itemED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI7ui_menuEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI7ui_menuEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI7ui_menuEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 88);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI7ui_menuE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI7ui_menuED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI7ui_menuED2Ev($2);
  ;
  return;
}


function __ZL16menu_select_gameR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menustate;
      var $menu_event;
      var $driver;
      var $enumerator=__stackBase__;
      var $5;
      var $6;
      var $auditor=__stackBase__+40;
      var $summary;
      var $buflen;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $7=$4;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$2;
      var $11=__ZN11driver_list5totalEv();
      var $12=((($11<<2))|0);
      var $13=(($12+108)|0);
      var $14=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($10, $13, 0);
      $4=$14;
      var $15=$3;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$4;
      var $19=$18;
      var $20=(($19+2)|0);
      var $21=(($20)|0);
      var $22=$3;
      var $23=_strcpy($21, $22);
      __label__ = 3; break;
    case 3: // $24
      var $25=$4;
      var $26=$25;
      var $27=(($26+44)|0);
      var $28=(($27)|0);
      HEAP32[(($28)>>2)]=-1;
      __label__ = 4; break;
    case 4: // $29
      var $30=$4;
      var $31=$30;
      $menustate=$31;
      var $32=$2;
      var $33=__Z17ui_menu_populatedP7ui_menu($32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $35
      var $36=$1;
      var $37=$2;
      var $38=$menustate;
      __ZL25menu_select_game_populateR15running_machineP7ui_menuP18_select_game_state($36, $37, $38);
      __label__ = 6; break;
    case 6: // $39
      var $40=$1;
      var $41=__Z16ui_input_pressedR15running_machinei($40, 162);
      var $42=$1;
      var $43=$2;
      var $44=__Z15ui_menu_processR15running_machineP7ui_menuj($42, $43, 0);
      $menu_event=$44;
      var $45=$menu_event;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 7; break; } else { __label__ = 48; break; }
    case 7: // $47
      var $48=$menu_event;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 8; break; } else { __label__ = 48; break; }
    case 8: // $52
      var $53=$menustate;
      var $54=(($53)|0);
      var $55=HEAP8[($54)];
      var $56=(($55 << 24) >> 24)!=0;
      if ($56) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $57
      var $58=$menustate;
      var $59=(($58)|0);
      HEAP8[($59)]=0;
      __label__ = 47; break;
    case 10: // $60
      var $61=$menu_event;
      var $62=(($61+4)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==182;
      if ($64) { __label__ = 11; break; } else { __label__ = 31; break; }
    case 11: // $65
      var $66=$menu_event;
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$68;
      $driver=$69;
      var $70=$driver;
      var $71=$70;
      var $72=(($71)|0)==1;
      if ($72) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $73
      var $74=$2;
      var $75=__ZNK7ui_menu7machineEv($74);
      var $76=$2;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($75, $78, 1024, 0);
      __Z18ui_menu_stack_pushP7ui_menu($79);
      __label__ = 30; break;
    case 13: // $80
      var $81=$1;
      var $82=__ZNK15running_machine7optionsEv($81);
      var $83=$driver;
      FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_optionsRK11game_driver]($enumerator, $82, $83);
      var $84=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($enumerator) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 21; break; };
    case 14: // $85
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13media_auditorC1ERK17driver_enumerator]($auditor, $enumerator) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $86
      var $87=(function() { try { __THREW__ = false; return __ZN13media_auditor11audit_mediaEPKc($auditor, ((STRING_TABLE.__str34167)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 22; break; };
    case 16: // $88
      $summary=$87;
      var $89=$summary;
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $91
      var $92=$summary;
      var $93=(($92)|0)==2;
      if ($93) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $94
      var $95=$1;
      var $96=$driver;
      (function() { try { __THREW__ = false; return __ZN15running_machine19schedule_new_driverERK11game_driver($95, $96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $97
      var $98=$1;
      (function() { try { __THREW__ = false; return __Z19ui_menu_stack_resetR15running_machine($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $99
      __label__ = 25; break;
    case 21: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $5=$102;
      var $103=$101.f1;
      $6=$103;
      __label__ = 28; break;
    case 22: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $106=$105.f0;
      $5=$106;
      var $107=$105.f1;
      $6=$107;
      (function() { try { __THREW__ = false; return __ZN13media_auditorD1Ev($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 52; break; }
    case 23: // $108
      var $109=$2;
      (function() { try { __THREW__ = false; return __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($109, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 22; break; }
    case 24: // $110
      var $111=$menustate;
      var $112=(($111)|0);
      HEAP8[($112)]=1;
      __label__ = 25; break;
    case 25: // $113
      (function() { try { __THREW__ = false; return __ZN13media_auditorD1Ev($auditor) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 21; break; }
    case 26: // $114
      FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($enumerator);
      __label__ = 30; break;
    case 27: // $115
      __label__ = 28; break;
    case 28: // $116
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($enumerator) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 52; break; }
    case 29: // $117
      __label__ = 51; break;
    case 30: // $118
      __label__ = 46; break;
    case 31: // $119
      var $120=$menu_event;
      var $121=(($120+4)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122)|0)==183;
      if ($123) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $124
      var $125=$menustate;
      var $126=(($125+2)|0);
      var $127=(($126)|0);
      var $128=HEAP8[($127)];
      var $129=(($128 << 24) >> 24);
      var $130=(($129)|0)!=0;
      if ($130) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $131
      var $132=$2;
      var $133=__ZNK7ui_menu7machineEv($132);
      var $134=$2;
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($133, $136, 1022, 0);
      __Z18ui_menu_stack_pushP7ui_menu($137);
      __label__ = 45; break;
    case 34: // $138
      var $139=$menu_event;
      var $140=(($139+4)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141)|0)==214;
      if ($142) { __label__ = 35; break; } else { __label__ = 44; break; }
    case 35: // $143
      var $144=$menustate;
      var $145=(($144+2)|0);
      var $146=(($145)|0);
      var $147=_strlen($146);
      $buflen=$147;
      var $148=$menu_event;
      var $149=(($148+8)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150)|0)==8;
      if ($151) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $152
      var $153=$menu_event;
      var $154=(($153+8)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155)|0)==127;
      if ($156) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $157
      var $158=$buflen;
      var $159=(($158)|0) > 0;
      if ($159) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $160
      var $161=$buflen;
      var $162=$menustate;
      var $163=(($162+2)|0);
      var $164=(($163+$161)|0);
      var $165=__Z18utf8_previous_charPKc($164);
      HEAP8[($165)]=0;
      var $166=$menustate;
      var $167=(($166+1)|0);
      HEAP8[($167)]=1;
      var $168=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($168, 0);
      __label__ = 43; break;
    case 39: // $169
      var $170=$menu_event;
      var $171=(($170+8)|0);
      var $172=HEAPU32[(($171)>>2)];
      var $173=(($172)>>>0) >= 32;
      if ($173) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $174
      var $175=$menu_event;
      var $176=(($175+8)|0);
      var $177=HEAPU32[(($176)>>2)];
      var $178=(($177)>>>0) < 127;
      if ($178) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $179
      var $180=$buflen;
      var $181=$menustate;
      var $182=(($181+2)|0);
      var $183=(($182+$180)|0);
      var $184=$buflen;
      var $185=((40-$184)|0);
      var $186=$menu_event;
      var $187=(($186+8)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=__Z15utf8_from_ucharPcjj($183, $185, $188);
      var $190=$buflen;
      var $191=(($190+$189)|0);
      $buflen=$191;
      var $192=$buflen;
      var $193=$menustate;
      var $194=(($193+2)|0);
      var $195=(($194+$192)|0);
      HEAP8[($195)]=0;
      var $196=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($196, 0);
      __label__ = 42; break;
    case 42: // $197
      __label__ = 43; break;
    case 43: // $198
      __label__ = 44; break;
    case 44: // $199
      __label__ = 45; break;
    case 45: // $200
      __label__ = 46; break;
    case 46: // $201
      __label__ = 47; break;
    case 47: // $202
      __label__ = 48; break;
    case 48: // $203
      var $204=$menustate;
      var $205=(($204)|0);
      var $206=HEAP8[($205)];
      var $207=(($206 << 24) >> 24)!=0;
      if ($207) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $208
      var $209=$2;
      var $210=(($209)|0);
      var $211=HEAP32[(($210)>>2)];
      __Z16ui_draw_text_boxP16render_containerPKciffj($211, ((STRING_TABLE.__str44168)|0), 1, 0.5, 0.5, -262139888);
      __label__ = 50; break;
    case 50: // $212
      STACKTOP = __stackBase__;
      return;
    case 51: // $213
      var $214=$5;
      var $215=$5;
      var $216=$6;
      var $217=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $215, tempValue);
      var $218=($217.f1 = $216, $217);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 52: // $219
      var $220=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16menu_select_gameR15running_machineP7ui_menuPvS3_["X"]=1;

function __Z18ui_set_slot_deviceR15running_machineP21device_slot_interfacePKc($machine, $slot, $val) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error=__stackBase__;
      var $4;
      var $5;
      $1=$machine;
      $2=$slot;
      $3=$val;
      __ZN7astringC1Ev($error);
      var $6=$1;
      var $7=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $8
      var $9=$7;
      var $10=$2;
      var $11=$10;
      var $12=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $13
      var $14=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $15
      var $16=$3;
      var $17=(function() { try { __THREW__ = false; return __ZN12core_options9set_valueEPKcS1_iR7astring($9, $14, $16, 150, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      __label__ = 7; break;
    case 7: // $21
      FUNCTION_TABLE[__ZN7astringD1Ev]($error);
      STACKTOP = __stackBase__;
      return;
    case 8: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $4=$24;
      var $25=$23.f1;
      $5=$25;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $26
      __label__ = 10; break;
    case 10: // $27
      var $28=$4;
      var $29=$4;
      var $30=$5;
      var $31=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29, tempValue);
      var $32=($31.f1 = $30, $31);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayI13_ui_menu_itemED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI13_ui_menu_itemED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI13_ui_menu_itemED0Ev["X"]=1;

function __ZN19resource_pool_arrayI13_ui_menu_itemED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayI13_ui_menu_itemE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL25menu_select_game_populateR15running_machineP7ui_menuP18_select_game_state($machine, $menu, $menustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $matchcount;
      var $curitem;
      var $curmatch;
      var $cloneof;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      var $4=$3;
      var $5=(($4+104)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$3;
      __ZL34menu_select_game_build_driver_listP7ui_menuP18_select_game_state($10, $11);
      __label__ = 2; break;
    case 2: // $12
      $matchcount=0;
      $curitem=0;
      __label__ = 3; break;
    case 3: // $13
      var $14=$curitem;
      var $15=$3;
      var $16=(($15+104)|0);
      var $17=(($16+($14<<2))|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { var $24 = 0;__label__ = 5; break; }
    case 4: // $20
      var $21=$matchcount;
      var $22=(($21)|0) < 15;
      var $24 = $22;__label__ = 5; break;
    case 5: // $23
      var $24;
      if ($24) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $25
      var $26=$curitem;
      var $27=$3;
      var $28=(($27+104)|0);
      var $29=(($28+($26<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+44)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32 & 8192;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $35
      var $36=$matchcount;
      var $37=(($36+1)|0);
      $matchcount=$37;
      __label__ = 8; break;
    case 8: // $38
      __label__ = 9; break;
    case 9: // $39
      var $40=$curitem;
      var $41=(($40+1)|0);
      $curitem=$41;
      __label__ = 3; break;
    case 10: // $42
      var $43=$matchcount;
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $45
      var $46=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($46, ((STRING_TABLE.__str134177)|0), 0, 24, 0);
      __label__ = 27; break;
    case 12: // $47
      __label__ = 13; break;
    case 13: // $48
      __label__ = 14; break;
    case 14: // $49
      var $50=$3;
      var $51=(($50+2)|0);
      var $52=(($51)|0);
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24);
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 15: // $56
      var $57=$3;
      var $58=(($57+44)|0);
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0)==-1;
      if ($61) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $62
      var $63=$3;
      var $64=(($63+1)|0);
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24)!=0;
      if ($66) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $67
      var $68=HEAP32[((__ZL8drivlist)>>2)];
      var $69=$3;
      var $70=(($69+2)|0);
      var $71=(($70)|0);
      var $72=$matchcount;
      var $73=$3;
      var $74=(($73+44)|0);
      var $75=(($74)|0);
      __ZN17driver_enumerator24find_approximate_matchesEPKciPi($68, $71, $72, $75);
      __label__ = 18; break;
    case 18: // $76
      var $77=$3;
      var $78=(($77+1)|0);
      HEAP8[($78)]=0;
      $curitem=0;
      __label__ = 19; break;
    case 19: // $79
      var $80=$curitem;
      var $81=$matchcount;
      var $82=(($80)|0) < (($81)|0);
      if ($82) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $83
      var $84=$curitem;
      var $85=$3;
      var $86=(($85+44)|0);
      var $87=(($86+($84<<2))|0);
      var $88=HEAP32[(($87)>>2)];
      $curmatch=$88;
      var $89=$curmatch;
      var $90=(($89)|0)!=-1;
      if ($90) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $91
      var $92=HEAP32[((__ZL8drivlist)>>2)];
      var $93=$curmatch;
      var $94=__ZN11driver_list14non_bios_cloneEi($93);
      $cloneof=$94;
      var $95=$2;
      var $96=HEAP32[((__ZL8drivlist)>>2)];
      var $97=$curmatch;
      var $98=__ZN11driver_list6driverEi($97);
      var $99=(($98+8)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=HEAP32[((__ZL8drivlist)>>2)];
      var $102=$curmatch;
      var $103=__ZN11driver_list6driverEi($102);
      var $104=(($103+12)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$cloneof;
      var $107=(($106)|0)==-1;
      var $108=$107 ? 0 : 4;
      var $109=HEAP32[((__ZL8drivlist)>>2)];
      var $110=$curmatch;
      var $111=__ZN11driver_list6driverEi($110);
      var $112=$111;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($95, $100, $105, $108, $112);
      __label__ = 22; break;
    case 22: // $113
      __label__ = 23; break;
    case 23: // $114
      var $115=$curitem;
      var $116=(($115+1)|0);
      $curitem=$116;
      __label__ = 19; break;
    case 24: // $117
      var $118=__Z28ui_menu_is_force_game_selectv();
      var $119=(($118)|0)!=0;
      if ($119) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $120
      var $121=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($121, ((STRING_TABLE.__str144178)|0), 0, 0, 0);
      var $122=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($122, ((STRING_TABLE.__str154179)|0), 0, 0, 1);
      __label__ = 26; break;
    case 26: // $123
      var $124=$2;
      var $125=$1;
      var $126=__Z18ui_get_line_heightR15running_machine($125);
      var $127=$126+0.029999999329447746;
      var $128=$1;
      var $129=__Z18ui_get_line_heightR15running_machine($128);
      var $130=$129*4;
      var $131=$130+0.029999999329447746;
      __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($124, 1026, $127, $131);
      __label__ = 27; break;
    case 27: // $132
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25menu_select_game_populateR15running_machineP7ui_menuP18_select_game_state["X"]=1;

function __ZL17menu_input_groupsR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$2;
      var $6=__Z17ui_menu_populatedP7ui_menu($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=$2;
      var $11=$4;
      __ZL26menu_input_groups_populateR15running_machineP7ui_menuPv($9, $10, $11);
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=$2;
      var $15=__Z15ui_menu_processR15running_machineP7ui_menuj($13, $14, 0);
      $menu_event=$15;
      var $16=$menu_event;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      var $19=$menu_event;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==182;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$1;
      var $25=$2;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$menu_event;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($24, $27, 1028, $30);
      __Z18ui_menu_stack_pushP7ui_menu($31);
      __label__ = 5; break;
    case 5: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL26menu_input_groups_populateR15running_machineP7ui_menuPv($machine, $menu, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $player;
      var $buffer=__stackBase__;
      $1=$machine;
      $2=$menu;
      $3=$state;
      var $4=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($4, ((STRING_TABLE.__str104174)|0), 0, 0, 1);
      $player=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$player;
      var $7=(($6)|0) < 8;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($buffer)|0);
      var $10=$player;
      var $11=(($10+1)|0);
      var $12=_sprintf($9, ((STRING_TABLE.__str114175)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$11,tempInt));
      var $13=$2;
      var $14=(($buffer)|0);
      var $15=$player;
      var $16=(($15+1)|0);
      var $17=(($16+1)|0);
      var $18=$17;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($13, $14, 0, 0, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$player;
      var $21=(($20+1)|0);
      $player=$21;
      __label__ = 1; break;
    case 4: // $22
      var $23=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($23, ((STRING_TABLE.__str124176)|0), 0, 0, 10);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18menu_input_generalR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$menu;
  $3=$parameter;
  $4=$state;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZL17menu_input_commonR15running_machineP7ui_menuPvS3_($5, $6, $7, $8);
  ;
  return;
}


function __ZL17menu_input_commonR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 304; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $seqchangeditem;
      var $menustate;
      var $menu_event;
      var $invalidate;
      var $item;
      var $newseq=__stackBase__;
      var $5=__stackBase__+64;
      var $6=__stackBase__+68;
      var $7=__stackBase__+72;
      var $8=__stackBase__+76;
      var $9=__stackBase__+80;
      var $10=__stackBase__+84;
      var $11=__stackBase__+88;
      var $item1;
      var $entry;
      var $settings=__stackBase__+92;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      $seqchangeditem=0;
      $invalidate=0;
      var $12=$4;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$2;
      var $16=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($15, 80, 0);
      $4=$16;
      __label__ = 2; break;
    case 2: // $17
      var $18=$4;
      var $19=$18;
      $menustate=$19;
      var $20=$2;
      var $21=__Z17ui_menu_populatedP7ui_menu($20);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 7; break; } else { __label__ = 3; break; }
    case 3: // $23
      var $24=$3;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$1;
      var $28=$2;
      var $29=$menustate;
      var $30=$3;
      var $31=$30;
      var $32=(($31-1)|0);
      __ZL27menu_input_general_populateR15running_machineP7ui_menuP17_input_menu_statei($27, $28, $29, $32);
      __label__ = 6; break;
    case 5: // $33
      var $34=$1;
      var $35=$2;
      var $36=$menustate;
      __ZL28menu_input_specific_populateR15running_machineP7ui_menuP17_input_menu_state($34, $35, $36);
      __label__ = 6; break;
    case 6: // $37
      __label__ = 7; break;
    case 7: // $38
      var $39=$1;
      var $40=$2;
      var $41=$menustate;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)!=0;
      var $45=$44 ? 1 : 0;
      var $46=__Z15ui_menu_processR15running_machineP7ui_menuj($39, $40, $45);
      $menu_event=$46;
      var $47=$menustate;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $51
      var $52=$menustate;
      var $53=(($52+8)|0);
      var $54=HEAP32[(($53)>>2)];
      $item=$54;
      __ZN10input_codeC1ERKS_($5, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($6, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($7, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($8, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($9, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($10, __ZN9input_seq8end_codeE);
      __ZN10input_codeC1ERKS_($11, __ZN9input_seq8end_codeE);
      __ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_($newseq, $5, $6, $7, $8, $9, $10, $11);
      var $55=$1;
      var $56=__Z16ui_input_pressedR15running_machinei($55, 183);
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $58
      var $59=$menustate;
      var $60=(($59+8)|0);
      HEAP32[(($60)>>2)]=0;
      var $61=$menustate;
      var $62=(($61+12)|0);
      HEAP8[($62)]=0;
      var $63=$item;
      var $64=(($63+12)|0);
      var $65=$menustate;
      var $66=(($65+16)|0);
      var $67=$item;
      var $68=(($67+76)|0);
      var $69=HEAP32[(($68)>>2)];
      __ZL19toggle_none_defaultR9input_seqS0_RKS_($64, $66, $69);
      var $70=$item;
      $seqchangeditem=$70;
      __label__ = 10; break;
    case 10: // $71
      var $72=$1;
      var $73=__ZNK15running_machine5inputEv($72);
      var $74=__ZN13input_manager8seq_pollEv($73);
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      var $76=$menustate;
      var $77=(($76+8)|0);
      HEAP32[(($77)>>2)]=0;
      var $78=$menustate;
      var $79=(($78+12)|0);
      HEAP8[($79)]=1;
      var $80=$item;
      var $81=(($80+12)|0);
      var $82=$1;
      var $83=__ZNK15running_machine5inputEv($82);
      var $84=__ZNK13input_manager14seq_poll_finalEv($83);
      var $85=$81;
      var $86=$84;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $86>>2, $$dest = $85>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $87=$item;
      $seqchangeditem=$87;
      __label__ = 12; break;
    case 12: // $88
      __label__ = 25; break;
    case 13: // $89
      var $90=$menu_event;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $92
      var $93=$menu_event;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 15; break; } else { __label__ = 24; break; }
    case 15: // $97
      var $98=$menu_event;
      var $99=(($98)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100;
      $item1=$101;
      var $102=$menu_event;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      if ($104 == 182) {
        __label__ = 16; break;
      }
      else if ($104 == 185) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 16: // $105
      var $106=$item1;
      var $107=$menustate;
      var $108=(($107+8)|0);
      HEAP32[(($108)>>2)]=$106;
      var $109=$item1;
      var $110=(($109+84)|0);
      var $111=HEAP16[(($110)>>1)];
      var $112=$menustate;
      var $113=(($112)|0);
      HEAP16[(($113)>>1)]=$111;
      var $114=$menustate;
      var $115=(($114+16)|0);
      var $116=$item1;
      var $117=(($116+12)|0);
      var $118=$115;
      var $119=$117;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $119>>2, $$dest = $118>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $120=$1;
      var $121=__ZNK15running_machine5inputEv($120);
      var $122=$item1;
      var $123=(($122+86)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $126=(($125)|0)==1;
      var $127=$126 ? 2 : 1;
      var $128=$menustate;
      var $129=(($128+12)|0);
      var $130=HEAP8[($129)];
      var $131=(($130 << 24) >> 24)!=0;
      if ($131) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $132
      var $133=$item1;
      var $134=(($133+12)|0);
      var $137 = $134;__label__ = 19; break;
    case 18: // $135
      var $137 = 0;__label__ = 19; break;
    case 19: // $136
      var $137;
      __ZN13input_manager14seq_poll_startE16input_item_classPK9input_seq($121, $127, $137);
      $invalidate=1;
      __label__ = 21; break;
    case 20: // $138
      var $139=$item1;
      var $140=(($139+12)|0);
      var $141=$item1;
      var $142=(($141+12)|0);
      var $143=$item1;
      var $144=(($143+76)|0);
      var $145=HEAP32[(($144)>>2)];
      __ZL19toggle_none_defaultR9input_seqS0_RKS_($140, $142, $145);
      var $146=$menustate;
      var $147=(($146+12)|0);
      HEAP8[($147)]=0;
      var $148=$item1;
      $seqchangeditem=$148;
      __label__ = 21; break;
    case 21: // $149
      var $150=$item1;
      var $151=(($150+84)|0);
      var $152=HEAPU16[(($151)>>1)];
      var $153=(($152)&65535);
      var $154=$menustate;
      var $155=(($154)|0);
      var $156=HEAPU16[(($155)>>1)];
      var $157=(($156)&65535);
      var $158=(($153)|0)!=(($157)|0);
      if ($158) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $159
      var $160=$menustate;
      var $161=(($160+12)|0);
      HEAP8[($161)]=0;
      __label__ = 23; break;
    case 23: // $162
      var $163=$item1;
      var $164=(($163+84)|0);
      var $165=HEAP16[(($164)>>1)];
      var $166=$menustate;
      var $167=(($166)|0);
      HEAP16[(($167)>>1)]=$165;
      __label__ = 24; break;
    case 24: // $168
      __label__ = 25; break;
    case 25: // $169
      var $170=$seqchangeditem;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $172
      var $173=$3;
      var $174=(($173)|0)!=0;
      if ($174) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $175
      var $176=$seqchangeditem;
      var $177=(($176+4)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=$178;
      $entry=$179;
      var $180=$1;
      var $181=$entry;
      var $182=(($181)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$entry;
      var $185=(($184+8)|0);
      var $186=HEAPU8[($185)];
      var $187=(($186)&255);
      var $188=$seqchangeditem;
      var $189=(($188+8)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$seqchangeditem;
      var $192=(($191+12)|0);
      __Z18input_type_set_seqR15running_machineii15_input_seq_typePK9input_seq($180, $183, $187, $190, $192);
      __label__ = 29; break;
    case 28: // $193
      __ZN26_input_field_user_settingsC1Ev($settings);
      var $194=$seqchangeditem;
      var $195=(($194+4)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=$196;
      __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($197, $settings);
      var $198=$seqchangeditem;
      var $199=(($198+8)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($settings+4)|0);
      var $202=(($201+($200<<6))|0);
      var $203=$seqchangeditem;
      var $204=(($203+12)|0);
      var $205=$202;
      var $206=$204;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $206>>2, $$dest = $205>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $207=$seqchangeditem;
      var $208=(($207+4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$209;
      __Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings($210, $settings);
      __label__ = 29; break;
    case 29: // $211
      $invalidate=1;
      __label__ = 30; break;
    case 30: // $212
      var $213=$invalidate;
      var $214=(($213)|0)!=0;
      if ($214) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $215
      var $216=$menustate;
      var $217=(($216+4)|0);
      HEAP32[(($217)>>2)]=0;
      var $218=$menustate;
      var $219=(($218+8)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220)|0)!=0;
      if ($221) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $222
      var $223=$menustate;
      var $224=(($223+8)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=(($225+4)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$menustate;
      var $229=(($228+4)|0);
      HEAP32[(($229)>>2)]=$227;
      __label__ = 33; break;
    case 33: // $230
      var $231=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($231, 1);
      __label__ = 34; break;
    case 34: // $232
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17menu_input_commonR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZN20resource_pool_objectI7ui_menuED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI7ui_menuED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI7ui_menuED0Ev["X"]=1;

function __ZN20resource_pool_objectI7ui_menuED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectI7ui_menuE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZppR15_input_seq_typei($value, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$value;
  $3=$0;
  var $4=$2;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+1)|0);
  var $7=$2;
  HEAP32[(($7)>>2)]=$6;
  ;
  return;
}


function __ZNK13input_manager14seq_poll_finalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4428)|0);
  ;
  return $3;
}


function __ZL19toggle_none_defaultR9input_seqS0_RKS_($selected_seq, $original_seq, $selected_defseq) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$selected_seq;
      $2=$original_seq;
      $3=$selected_defseq;
      var $4=$2;
      var $5=__ZNK9input_seq6lengthEv($4);
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=$3;
      var $10=$8;
      var $11=$9;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $11>>2, $$dest = $10>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 3; break;
    case 2: // $12
      var $13=$1;
      __ZN9input_seq5resetEv($13);
      __label__ = 3; break;
    case 3: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21get_field_default_seqP18input_field_config15_input_seq_type($field, $seqtype) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$field;
      $3=$seqtype;
      var $4=$3;
      var $5=$2;
      var $6=(($5+44)|0);
      var $7=(($6+($4<<6))|0);
      var $8=__ZNK9input_seq10is_defaultEv($7);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=__ZNK18input_field_config7machineEv($10);
      var $12=$2;
      var $13=(($12+24)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$2;
      var $16=(($15+28)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$3;
      var $20=__Z14input_type_seqR15running_machineii15_input_seq_type($11, $14, $18, $19);
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      var $22=$3;
      var $23=$2;
      var $24=(($23+44)|0);
      var $25=(($24+($22<<6))|0);
      $1=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL27menu_input_general_populateR15running_machineP7ui_menuP17_input_menu_statei($machine, $menu, $menustate, $group) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $itemlist;
      var $suborder=__stackBase__;
      var $tempstring=__stackBase__+12;
      var $sortorder;
      var $entry;
      var $5;
      var $6;
      var $seqtype=__stackBase__+76;
      var $item;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      $4=$group;
      $itemlist=0;
      __ZN7astringC1Ev($tempstring);
      $sortorder=1;
      var $7=(($suborder)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=(($suborder+8)|0);
      HEAP32[(($8)>>2)]=1;
      var $9=(($suborder+4)|0);
      HEAP32[(($9)>>2)]=2;
      var $10=$1;
      var $11=(function() { try { __THREW__ = false; return __Z15input_type_listR15running_machine($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 17; break; };
    case 1: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK11simple_listI16input_type_entryE5firstEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 17; break; };
    case 2: // $14
      $entry=$13;
      __label__ = 3; break;
    case 3: // $15
      var $16=$entry;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 25; break; }
    case 4: // $18
      var $19=$entry;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$4;
      var $23=(($21)|0)==(($22)|0);
      if ($23) { __label__ = 5; break; } else { __label__ = 22; break; }
    case 5: // $24
      var $25=$entry;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 22; break; }
    case 6: // $29
      var $30=$entry;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 7; break; } else { __label__ = 22; break; }
    case 7: // $37
      var $38=$sortorder;
      var $39=(($38+1)|0);
      $sortorder=$39;
      HEAP32[(($seqtype)>>2)]=0;
      __label__ = 8; break;
    case 8: // $40
      var $41=HEAP32[(($seqtype)>>2)];
      var $42=(($41)|0) < 3;
      if ($42) { __label__ = 9; break; } else { __label__ = 21; break; }
    case 9: // $43
      var $44=$2;
      var $45=(function() { try { __THREW__ = false; return __Z18ui_menu_pool_allocP7ui_menuj($44, 88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; };
    case 10: // $46
      var $47=$45;
      $item=$47;
      var $48=$item;
      var $49=$48;
      _memset($49, 0, 88, 1);
      var $50=$entry;
      var $51=$50;
      var $52=$item;
      var $53=(($52+4)|0);
      HEAP32[(($53)>>2)]=$51;
      var $54=HEAP32[(($seqtype)>>2)];
      var $55=$item;
      var $56=(($55+8)|0);
      HEAP32[(($56)>>2)]=$54;
      var $57=$item;
      var $58=(($57+12)|0);
      var $59=$1;
      var $60=$entry;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$entry;
      var $64=(($63+8)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=HEAP32[(($seqtype)>>2)];
      var $68=(function() { try { __THREW__ = false; return __Z14input_type_seqR15running_machineii15_input_seq_type($59, $62, $66, $67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; };
    case 11: // $69
      var $70=$58;
      var $71=$68;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $71>>2, $$dest = $70>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $72=HEAP32[(($seqtype)>>2)];
      var $73=$entry;
      var $74=(($73+20)|0);
      var $75=(($74+($72<<6))|0);
      var $76=$item;
      var $77=(($76+76)|0);
      HEAP32[(($77)>>2)]=$75;
      var $78=$sortorder;
      var $79=((($78<<2))|0);
      var $80=HEAP32[(($seqtype)>>2)];
      var $81=(($suborder+($80<<2))|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($79+$82)|0);
      var $84=(($83) & 65535);
      var $85=$item;
      var $86=(($85+84)|0);
      HEAP16[(($86)>>1)]=$84;
      var $87=$entry;
      var $88=(($87)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(function() { try { __THREW__ = false; return __Z20input_type_is_analogi($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 17; break; };
    case 12: // $91
      var $92=(($90)|0)!=0;
      if ($92) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $93
      var $94=HEAP32[(($seqtype)>>2)];
      var $95=(($94+1)|0);
      var $98 = $95;__label__ = 15; break;
    case 14: // $96
      var $98 = 0;__label__ = 15; break;
    case 15: // $97
      var $98;
      var $99=(($98) & 255);
      var $100=$item;
      var $101=(($100+86)|0);
      HEAP8[($101)]=$99;
      var $102=$entry;
      var $103=(($102+16)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$item;
      var $106=(($105+80)|0);
      HEAP32[(($106)>>2)]=$104;
      var $107=$itemlist;
      var $108=$item;
      var $109=(($108)|0);
      HEAP32[(($109)>>2)]=$107;
      var $110=$item;
      $itemlist=$110;
      var $111=$item;
      var $112=(($111+86)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $116
      __label__ = 21; break;
    case 17: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      $5=$119;
      var $120=$118.f1;
      $6=$120;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 18: // $121
      __label__ = 19; break;
    case 19: // $122
      (function() { try { __THREW__ = false; return __ZppR15_input_seq_typei($seqtype, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 17; break; }
    case 20: // $123
      __label__ = 8; break;
    case 21: // $124
      __label__ = 22; break;
    case 22: // $125
      __label__ = 23; break;
    case 23: // $126
      var $127=$entry;
      var $128=(function() { try { __THREW__ = false; return __ZNK16input_type_entry4nextEv($127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 17; break; };
    case 24: // $129
      $entry=$128;
      __label__ = 3; break;
    case 25: // $130
      var $131=$1;
      var $132=$2;
      var $133=$itemlist;
      var $134=$3;
      (function() { try { __THREW__ = false; return __ZL28menu_input_populate_and_sortR15running_machineP7ui_menuP16_input_item_dataP17_input_menu_state($131, $132, $133, $134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 17; break; }
    case 26: // $135
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 27: // $136
      __label__ = 28; break;
    case 28: // $137
      var $138=$5;
      var $139=$5;
      var $140=$6;
      var $141=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $139, tempValue);
      var $142=($141.f1 = $140, $141);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $143
      var $144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27menu_input_general_populateR15running_machineP7ui_menuP17_input_menu_statei["X"]=1;

function __ZL28menu_input_specific_populateR15running_machineP7ui_menuP17_input_menu_state($machine, $menu, $menustate) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $itemlist;
      var $field;
      var $port;
      var $suborder=__stackBase__;
      var $tempstring=__stackBase__+12;
      var $4;
      var $5;
      var $name;
      var $seqtype=__stackBase__+76;
      var $sortorder;
      var $item;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      $itemlist=0;
      __ZN7astringC1Ev($tempstring);
      var $6=(($suborder)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=(($suborder+8)|0);
      HEAP32[(($7)>>2)]=1;
      var $8=(($suborder+4)|0);
      HEAP32[(($8)>>2)]=2;
      var $9=$1;
      var $10=(($9+20)|0);
      var $11=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 22; break; };
    case 1: // $12
      $port=$11;
      __label__ = 2; break;
    case 2: // $13
      var $14=$port;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 45; break; }
    case 3: // $16
      var $17=$port;
      var $18=(function() { try { __THREW__ = false; return __ZN17input_port_config9fieldlistEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 22; break; };
    case 4: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK11simple_listI18input_field_configE5firstEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 22; break; };
    case 5: // $21
      $field=$20;
      __label__ = 6; break;
    case 6: // $22
      var $23=$field;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 42; break; }
    case 7: // $25
      var $26=$field;
      var $27=(function() { try { __THREW__ = false; return __Z16input_field_namePK18input_field_config($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 22; break; };
    case 8: // $28
      $name=$27;
      var $29=$name;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 9; break; } else { __label__ = 39; break; }
    case 9: // $31
      var $32=$1;
      var $33=$field;
      var $34=(($33+8)|0);
      var $35=$port;
      var $36=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 22; break; };
    case 10: // $37
      var $38=(function() { try { __THREW__ = false; return __Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($32, $34, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 22; break; };
    case 11: // $39
      var $40=(($38)|0)!=0;
      if ($40) { __label__ = 12; break; } else { __label__ = 39; break; }
    case 12: // $41
      var $42=$field;
      var $43=(($42+30)|0);
      var $44=HEAPU16[(($43)>>1)];
      var $45=(($44)&65535);
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 15; break; } else { __label__ = 13; break; }
    case 13: // $47
      var $48=$1;
      var $49=$field;
      var $50=(($49+30)|0);
      var $51=HEAPU16[(($50)>>1)];
      var $52=(($51)&65535);
      var $53=(function() { try { __THREW__ = false; return __Z21input_category_activeR15running_machinei($48, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 22; break; };
    case 14: // $54
      var $55=(($53)|0)!=0;
      if ($55) { __label__ = 15; break; } else { __label__ = 39; break; }
    case 15: // $56
      var $57=$field;
      var $58=(($57+24)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)==213;
      if ($60) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $61
      var $62=$field;
      var $63=(($62+40)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 19; break; } else { __label__ = 17; break; }
    case 17: // $66
      var $67=$1;
      var $68=$field;
      var $69=(($68+24)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$field;
      var $72=(($71+28)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=(function() { try { __THREW__ = false; return __Z16input_type_groupR15running_machineii($67, $70, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 22; break; };
    case 18: // $76
      var $77=(($75)|0)!=11;
      if ($77) { __label__ = 19; break; } else { __label__ = 39; break; }
    case 19: // $78
      var $79=$field;
      var $80=(($79+24)|0);
      var $81=HEAPU32[(($80)>>2)];
      var $82=(($81)>>>0) >= 9;
      if ($82) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $83
      var $84=$field;
      var $85=(($84+24)|0);
      var $86=HEAPU32[(($85)>>2)];
      var $87=(($86)>>>0) <= 157;
      if ($87) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $88
      var $89=$field;
      var $90=(($89+24)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$91 << 2;
      var $93=$field;
      var $94=(($93+28)|0);
      var $95=HEAPU8[($94)];
      var $96=(($95)&255);
      var $97=$96 << 12;
      var $98=$92 | $97;
      var $99=(($98) & 65535);
      $sortorder=$99;
      __label__ = 24; break;
    case 22: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $4=$102;
      var $103=$101.f1;
      $5=$103;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; }
    case 23: // $104
      var $105=$field;
      var $106=(($105+24)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$107 | 61440;
      var $109=(($108) & 65535);
      $sortorder=$109;
      __label__ = 24; break;
    case 24: // $110
      HEAP32[(($seqtype)>>2)]=0;
      __label__ = 25; break;
    case 25: // $111
      var $112=HEAP32[(($seqtype)>>2)];
      var $113=(($112)|0) < 3;
      if ($113) { __label__ = 26; break; } else { __label__ = 38; break; }
    case 26: // $114
      var $115=$2;
      var $116=(function() { try { __THREW__ = false; return __Z18ui_menu_pool_allocP7ui_menuj($115, 88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 22; break; };
    case 27: // $117
      var $118=$116;
      $item=$118;
      var $119=$item;
      var $120=$119;
      _memset($120, 0, 88, 1);
      var $121=$field;
      var $122=$121;
      var $123=$item;
      var $124=(($123+4)|0);
      HEAP32[(($124)>>2)]=$122;
      var $125=HEAP32[(($seqtype)>>2)];
      var $126=$item;
      var $127=(($126+8)|0);
      HEAP32[(($127)>>2)]=$125;
      var $128=$item;
      var $129=(($128+12)|0);
      var $130=$field;
      var $131=HEAP32[(($seqtype)>>2)];
      var $132=(function() { try { __THREW__ = false; return __Z15input_field_seqPK18input_field_config15_input_seq_type($130, $131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 22; break; };
    case 28: // $133
      var $134=$129;
      var $135=$132;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $135>>2, $$dest = $134>>2, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $136=$field;
      var $137=HEAP32[(($seqtype)>>2)];
      var $138=(function() { try { __THREW__ = false; return __ZL21get_field_default_seqP18input_field_config15_input_seq_type($136, $137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 22; break; };
    case 29: // $139
      var $140=$item;
      var $141=(($140+76)|0);
      HEAP32[(($141)>>2)]=$138;
      var $142=$sortorder;
      var $143=(($142)&65535);
      var $144=HEAP32[(($seqtype)>>2)];
      var $145=(($suborder+($144<<2))|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($143+$146)|0);
      var $148=(($147) & 65535);
      var $149=$item;
      var $150=(($149+84)|0);
      HEAP16[(($150)>>1)]=$148;
      var $151=$field;
      var $152=(($151+24)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(function() { try { __THREW__ = false; return __Z20input_type_is_analogi($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 22; break; };
    case 30: // $155
      var $156=(($154)|0)!=0;
      if ($156) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $157
      var $158=HEAP32[(($seqtype)>>2)];
      var $159=(($158+1)|0);
      var $162 = $159;__label__ = 33; break;
    case 32: // $160
      var $162 = 0;__label__ = 33; break;
    case 33: // $161
      var $162;
      var $163=(($162) & 255);
      var $164=$item;
      var $165=(($164+86)|0);
      HEAP8[($165)]=$163;
      var $166=$name;
      var $167=$item;
      var $168=(($167+80)|0);
      HEAP32[(($168)>>2)]=$166;
      var $169=$itemlist;
      var $170=$item;
      var $171=(($170)|0);
      HEAP32[(($171)>>2)]=$169;
      var $172=$item;
      $itemlist=$172;
      var $173=$item;
      var $174=(($173+86)|0);
      var $175=HEAPU8[($174)];
      var $176=(($175)&255);
      var $177=(($176)|0)==0;
      if ($177) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $178
      __label__ = 38; break;
    case 35: // $179
      __label__ = 36; break;
    case 36: // $180
      (function() { try { __THREW__ = false; return __ZppR15_input_seq_typei($seqtype, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 22; break; }
    case 37: // $181
      __label__ = 25; break;
    case 38: // $182
      __label__ = 39; break;
    case 39: // $183
      __label__ = 40; break;
    case 40: // $184
      var $185=$field;
      var $186=(function() { try { __THREW__ = false; return __ZNK18input_field_config4nextEv($185) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 22; break; };
    case 41: // $187
      $field=$186;
      __label__ = 6; break;
    case 42: // $188
      __label__ = 43; break;
    case 43: // $189
      var $190=$port;
      var $191=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 22; break; };
    case 44: // $192
      $port=$191;
      __label__ = 2; break;
    case 45: // $193
      var $194=$1;
      var $195=$2;
      var $196=$itemlist;
      var $197=$3;
      (function() { try { __THREW__ = false; return __ZL28menu_input_populate_and_sortR15running_machineP7ui_menuP16_input_item_dataP17_input_menu_state($194, $195, $196, $197) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 22; break; }
    case 46: // $198
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 47: // $199
      __label__ = 48; break;
    case 48: // $200
      var $201=$4;
      var $202=$4;
      var $203=$5;
      var $204=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $202, tempValue);
      var $205=($204.f1 = $203, $204);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 49: // $206
      var $207=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL28menu_input_specific_populateR15running_machineP7ui_menuP17_input_menu_state["X"]=1;

function __ZL28menu_input_populate_and_sortR15running_machineP7ui_menuP16_input_item_dataP17_input_menu_state($machine, $menu, $itemlist, $menustate) {
  var __stackBase__  = STACKTOP; STACKTOP += 144; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $nameformat=__stackBase__;
      var $itemarray;
      var $item;
      var $numitems;
      var $curitem;
      var $subtext=__stackBase__+16;
      var $text=__stackBase__+80;
      var $5;
      var $6;
      var $flags;
      $1=$machine;
      $2=$menu;
      $3=$itemlist;
      $4=$menustate;
      var $7=$nameformat;
      HEAP32[(($7)>>2)]=0; HEAP32[(($7+4)>>2)]=0; HEAP32[(($7+8)>>2)]=0; HEAP32[(($7+12)>>2)]=0;
      $numitems=0;
      __ZN7astringC1Ev($subtext);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=(($nameformat)|0);
      HEAP32[(($9)>>2)]=((STRING_TABLE.__str54169)|0);
      var $10=(($nameformat+4)|0);
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str64170)|0);
      var $11=(($nameformat+8)|0);
      HEAP32[(($11)>>2)]=((STRING_TABLE.__str74171)|0);
      var $12=(($nameformat+12)|0);
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str84172)|0);
      var $13=$3;
      $item=$13;
      __label__ = 2; break;
    case 2: // $14
      var $15=$item;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $17
      var $18=$numitems;
      var $19=(($18+1)|0);
      $numitems=$19;
      __label__ = 4; break;
    case 4: // $20
      var $21=$item;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      $item=$23;
      __label__ = 2; break;
    case 5: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $5=$26;
      var $27=$25.f1;
      $6=$27;
      __label__ = 34; break;
    case 6: // $28
      var $29=$2;
      var $30=$numitems;
      var $31=((($30<<2))|0);
      var $32=(function() { try { __THREW__ = false; return __Z18ui_menu_pool_allocP7ui_menuj($29, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $33
      var $34=$32;
      $itemarray=$34;
      var $35=$3;
      $item=$35;
      $curitem=0;
      __label__ = 8; break;
    case 8: // $36
      var $37=$item;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $39
      var $40=$item;
      var $41=$curitem;
      var $42=(($41+1)|0);
      $curitem=$42;
      var $43=$itemarray;
      var $44=(($43+($41<<2))|0);
      HEAP32[(($44)>>2)]=$40;
      __label__ = 10; break;
    case 10: // $45
      var $46=$item;
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      $item=$48;
      __label__ = 8; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $5=$51;
      var $52=$50.f1;
      $6=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 37; break; }
    case 12: // $53
      var $54=$itemarray;
      var $55=$54;
      var $56=$numitems;
      (function() { try { __THREW__ = false; return _qsort($55, $56, 4, 1030) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 11; break; }
    case 13: // $57
      $curitem=0;
      __label__ = 14; break;
    case 14: // $58
      var $59=$curitem;
      var $60=$numitems;
      var $61=(($59)|0) < (($60)|0);
      if ($61) { __label__ = 15; break; } else { __label__ = 31; break; }
    case 15: // $62
      $flags=0;
      var $63=$curitem;
      var $64=$itemarray;
      var $65=(($64+($63<<2))|0);
      var $66=HEAP32[(($65)>>2)];
      $item=$66;
      __label__ = 16; break;
    case 16: // $67
      __label__ = 17; break;
    case 17: // $68
      __label__ = 18; break;
    case 18: // $69
      var $70=$item;
      var $71=(($70+86)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($nameformat+($73<<2))|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$item;
      var $77=(($76+80)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($text, $75, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$78,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 11; break; };
    case 19: // $80
      var $81=$4;
      var $82=(($81+4)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$item;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($83)|0)==(($86)|0);
      if ($87) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $88
      var $89=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($subtext, ((STRING_TABLE.__str94173)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $90
      var $91=$flags;
      var $92=$91 | 3;
      $flags=$92;
      __label__ = 26; break;
    case 22: // $93
      var $94=$1;
      var $95=(function() { try { __THREW__ = false; return __ZNK15running_machine5inputEv($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 11; break; };
    case 23: // $96
      var $97=$item;
      var $98=(($97+12)|0);
      var $99=(function() { try { __THREW__ = false; return __ZNK13input_manager8seq_nameER7astringRK9input_seq($95, $subtext, $98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 11; break; };
    case 24: // $100
      var $101=$item;
      var $102=(($101+12)|0);
      var $103=$item;
      var $104=(($103+76)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(function() { try { __THREW__ = false; return __ZNK9input_seqneERKS_($102, $105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 11; break; };
    case 25: // $107
      var $108=$106 ? 4 : 0;
      var $109=$flags;
      var $110=$109 | $108;
      $flags=$110;
      __label__ = 26; break;
    case 26: // $111
      var $112=$2;
      var $113=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 11; break; };
    case 27: // $114
      var $115=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 11; break; };
    case 28: // $116
      var $117=$flags;
      var $118=$item;
      var $119=$118;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($112, $113, $115, $117, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 11; break; }
    case 29: // $120
      __label__ = 30; break;
    case 30: // $121
      var $122=$curitem;
      var $123=(($122+1)|0);
      $curitem=$123;
      __label__ = 14; break;
    case 31: // $124
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 5; break; }
    case 32: // $125
      FUNCTION_TABLE[__ZN7astringD1Ev]($subtext);
      STACKTOP = __stackBase__;
      return;
    case 33: // $126
      __label__ = 34; break;
    case 34: // $127
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $128
      __label__ = 36; break;
    case 36: // $129
      var $130=$5;
      var $131=$5;
      var $132=$6;
      var $133=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $131, tempValue);
      var $134=($133.f1 = $132, $133);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $135
      var $136=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL28menu_input_populate_and_sortR15running_machineP7ui_menuP16_input_item_dataP17_input_menu_state["X"]=1;

function __ZL24menu_input_compare_itemsPKvS0_($i1, $i2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $data1;
      var $data2;
      $2=$i1;
      $3=$i2;
      var $4=$2;
      var $5=$4;
      $data1=$5;
      var $6=$3;
      var $7=$6;
      $data2=$7;
      var $8=$data1;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+84)|0);
      var $11=HEAPU16[(($10)>>1)];
      var $12=(($11)&65535);
      var $13=$data2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+84)|0);
      var $16=HEAPU16[(($15)>>1)];
      var $17=(($16)&65535);
      var $18=(($12)|0) < (($17)|0);
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      $1=-1;
      __label__ = 5; break;
    case 2: // $20
      var $21=$data1;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+84)|0);
      var $24=HEAPU16[(($23)>>1)];
      var $25=(($24)&65535);
      var $26=$data2;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+84)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($25)|0) > (($30)|0);
      if ($31) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $32
      $1=1;
      __label__ = 5; break;
    case 4: // $33
      $1=0;
      __label__ = 5; break;
    case 5: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL30menu_select_game_custom_renderR15running_machineP7ui_menuPvS3_ffffff($machine, $menu, $state, $selectedref, $top, $bottom, $origx1, $origy1, $origx2, $origy2) {
  var __stackBase__  = STACKTOP; STACKTOP += 1028; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $menustate;
      var $driver;
      var $width=__stackBase__;
      var $maxwidth;
      var $x1;
      var $y1;
      var $x2;
      var $y2;
      var $tempbuf=__stackBase__+4;
      var $color;
      var $line;
      var $gfxstat;
      var $soundstat;
      var $s;
      var $line1;
      var $col;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$selectedref;
      $5=$top;
      $6=$bottom;
      $7=$origx1;
      $8=$origy1;
      $9=$origx2;
      $10=$origy2;
      var $11=$3;
      var $12=$11;
      $menustate=$12;
      var $13=$menustate;
      var $14=(($13+2)|0);
      var $15=(($14)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=(($tempbuf)|0);
      var $21=(($20)|0);
      var $22=$menustate;
      var $23=(($22+2)|0);
      var $24=(($23)|0);
      var $25=_sprintf($21, ((STRING_TABLE.__str164180)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      __label__ = 3; break;
    case 2: // $26
      var $27=(($tempbuf)|0);
      var $28=(($27)|0);
      var $29=_sprintf($28, ((STRING_TABLE.__str174181)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 3; break;
    case 3: // $30
      var $31=$2;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($tempbuf)|0);
      var $35=(($34)|0);
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($33, $35, 0, 0, 1, 1, 1, 0, -1, -16777216, $width, 0);
      var $36=HEAPF32[(($width)>>2)];
      var $37=$36+0.019999999552965164;
      HEAPF32[(($width)>>2)]=$37;
      var $38=HEAPF32[(($width)>>2)];
      var $39=$9;
      var $40=$7;
      var $41=$39-$40;
      var $42=$38 > $41;
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      var $44=HEAPF32[(($width)>>2)];
      var $50 = $44;__label__ = 6; break;
    case 5: // $45
      var $46=$9;
      var $47=$7;
      var $48=$46-$47;
      var $50 = $48;__label__ = 6; break;
    case 6: // $49
      var $50;
      $maxwidth=$50;
      var $51=$maxwidth;
      var $52=$51*0.5;
      var $53=0.5-$52;
      $x1=$53;
      var $54=$x1;
      var $55=$maxwidth;
      var $56=$54+$55;
      $x2=$56;
      var $57=$8;
      var $58=$5;
      var $59=$57-$58;
      $y1=$59;
      var $60=$8;
      var $61=$60-0.009999999776482582;
      $y2=$61;
      var $62=$2;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$x1;
      var $66=$y1;
      var $67=$x2;
      var $68=$y2;
      __Z20ui_draw_outlined_boxP16render_containerffffj($64, $65, $66, $67, $68, -284159952);
      var $69=$x1;
      var $70=$69+0.009999999776482582;
      $x1=$70;
      var $71=$x2;
      var $72=$71-0.009999999776482582;
      $x2=$72;
      var $73=$y1;
      var $74=$73+0.009999999776482582;
      $y1=$74;
      var $75=$y2;
      var $76=$75-0.009999999776482582;
      $y2=$76;
      var $77=$2;
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($tempbuf)|0);
      var $81=(($80)|0);
      var $82=$x1;
      var $83=$y1;
      var $84=$x2;
      var $85=$x1;
      var $86=$84-$85;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($79, $81, $82, $83, $86, 1, 1, 1, -1, -285212672, 0, 0);
      var $87=$4;
      var $88=$87;
      var $89=(($88)>>>0) > 1;
      if ($89) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $90
      var $91=$4;
      var $92=$91;
      var $95 = $92;__label__ = 9; break;
    case 8: // $93
      var $95 = 0;__label__ = 9; break;
    case 9: // $94
      var $95;
      $driver=$95;
      var $96=$driver;
      var $97=$96;
      var $98=(($97)>>>0) > 1;
      if ($98) { __label__ = 10; break; } else { __label__ = 26; break; }
    case 10: // $99
      var $100=(($tempbuf)|0);
      var $101=(($100)|0);
      var $102=$driver;
      var $103=(($102+12)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=_sprintf($101, ((STRING_TABLE.__str184182)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$104,tempInt));
      var $106=(($tempbuf+256)|0);
      var $107=(($106)|0);
      var $108=$driver;
      var $109=(($108+16)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$driver;
      var $112=(($111+20)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=_sprintf($107, ((STRING_TABLE.__str194183)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$110,HEAP32[((tempInt+4)>>2)]=$113,tempInt));
      var $115=$driver;
      var $116=(($115+44)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$117 & 8;
      var $119=(($118)|0)!=0;
      if ($119) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $120
      var $121=(($tempbuf+512)|0);
      var $122=(($121)|0);
      var $123=_strcpy($122, ((STRING_TABLE.__str204184)|0));
      __label__ = 16; break;
    case 12: // $124
      var $125=$driver;
      var $126=(($125+44)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=$127 & 16;
      var $129=(($128)|0)!=0;
      if ($129) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $130
      var $131=(($tempbuf+512)|0);
      var $132=(($131)|0);
      var $133=_strcpy($132, ((STRING_TABLE.__str214185)|0));
      __label__ = 15; break;
    case 14: // $134
      var $135=(($tempbuf+512)|0);
      var $136=(($135)|0);
      var $137=_strcpy($136, ((STRING_TABLE.__str224186)|0));
      __label__ = 15; break;
    case 15: // $138
      __label__ = 16; break;
    case 16: // $139
      var $140=$driver;
      var $141=(($140+44)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$142 & 224;
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $145
      $gfxstat=((STRING_TABLE.__str234187)|0);
      __label__ = 19; break;
    case 18: // $146
      $gfxstat=((STRING_TABLE.__str244188)|0);
      __label__ = 19; break;
    case 19: // $147
      var $148=$driver;
      var $149=(($148+44)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$150 & 512;
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $153
      $soundstat=((STRING_TABLE.__str254189)|0);
      __label__ = 25; break;
    case 21: // $154
      var $155=$driver;
      var $156=(($155+44)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$157 & 1024;
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $160
      $soundstat=((STRING_TABLE.__str234187)|0);
      __label__ = 24; break;
    case 23: // $161
      $soundstat=((STRING_TABLE.__str244188)|0);
      __label__ = 24; break;
    case 24: // $162
      __label__ = 25; break;
    case 25: // $163
      var $164=(($tempbuf+768)|0);
      var $165=(($164)|0);
      var $166=$gfxstat;
      var $167=$soundstat;
      var $168=_sprintf($165, ((STRING_TABLE.__str264190)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$166,HEAP32[((tempInt+4)>>2)]=$167,tempInt));
      __label__ = 36; break;
    case 26: // $169
      $s=((STRING_TABLE.__str274191)|0);
      $line1=0;
      $col=0;
      var $170=$line1;
      var $171=(($170+1)|0);
      $line1=$171;
      var $172=(($tempbuf+($170<<8))|0);
      var $173=(($172)|0);
      var $174=_sprintf($173, ((STRING_TABLE.__str284192)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str294193)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE._build_version)|0),tempInt));
      __label__ = 27; break;
    case 27: // $175
      var $176=$line1;
      var $177=(($176)>>>0) < 4;
      if ($177) { __label__ = 28; break; } else { __label__ = 35; break; }
    case 28: // $178
      var $179=$s;
      var $180=HEAP8[($179)];
      var $181=(($180 << 24) >> 24);
      var $182=(($181)|0)==0;
      if ($182) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $183
      var $184=$s;
      var $185=HEAP8[($184)];
      var $186=(($185 << 24) >> 24);
      var $187=(($186)|0)==10;
      if ($187) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $188
      var $189=$col;
      var $190=$line1;
      var $191=(($190+1)|0);
      $line1=$191;
      var $192=(($tempbuf+($190<<8))|0);
      var $193=(($192+$189)|0);
      HEAP8[($193)]=0;
      $col=0;
      __label__ = 32; break;
    case 31: // $194
      var $195=$s;
      var $196=HEAP8[($195)];
      var $197=$col;
      var $198=(($197+1)|0);
      $col=$198;
      var $199=$line1;
      var $200=(($tempbuf+($199<<8))|0);
      var $201=(($200+$197)|0);
      HEAP8[($201)]=$196;
      __label__ = 32; break;
    case 32: // $202
      var $203=$s;
      var $204=HEAP8[($203)];
      var $205=(($204 << 24) >> 24);
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $207
      var $208=$s;
      var $209=(($208+1)|0);
      $s=$209;
      __label__ = 34; break;
    case 34: // $210
      __label__ = 27; break;
    case 35: // $211
      __label__ = 36; break;
    case 36: // $212
      var $213=$9;
      var $214=$7;
      var $215=$213-$214;
      $maxwidth=$215;
      $line=0;
      __label__ = 37; break;
    case 37: // $216
      var $217=$line;
      var $218=(($217)|0) < 4;
      if ($218) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $219
      var $220=$2;
      var $221=(($220)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$line;
      var $224=(($tempbuf+($223<<8))|0);
      var $225=(($224)|0);
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($222, $225, 0, 0, 1, 1, 1, 0, -1, -16777216, $width, 0);
      var $226=HEAPF32[(($width)>>2)];
      var $227=$226+0.019999999552965164;
      HEAPF32[(($width)>>2)]=$227;
      var $228=$maxwidth;
      var $229=HEAPF32[(($width)>>2)];
      var $230=$228 > $229;
      var $231=$maxwidth;
      var $232=HEAPF32[(($width)>>2)];
      var $233=$230 ? $231 : $232;
      $maxwidth=$233;
      __label__ = 39; break;
    case 39: // $234
      var $235=$line;
      var $236=(($235+1)|0);
      $line=$236;
      __label__ = 37; break;
    case 40: // $237
      var $238=$maxwidth;
      var $239=$238*0.5;
      var $240=0.5-$239;
      $x1=$240;
      var $241=$x1;
      var $242=$maxwidth;
      var $243=$241+$242;
      $x2=$243;
      var $244=$10;
      var $245=$244+0.009999999776482582;
      $y1=$245;
      var $246=$10;
      var $247=$6;
      var $248=$246+$247;
      $y2=$248;
      $color=-284159952;
      var $249=$driver;
      var $250=(($249)|0)!=0;
      if ($250) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $251
      $color=-284139504;
      __label__ = 42; break;
    case 42: // $252
      var $253=$driver;
      var $254=(($253)|0)!=0;
      if ($254) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $255
      var $256=$driver;
      var $257=(($256+44)|0);
      var $258=HEAP32[(($257)>>2)];
      var $259=$258 & 1760;
      var $260=(($259)|0)!=0;
      if ($260) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $261
      $color=-278896624;
      __label__ = 45; break;
    case 45: // $262
      var $263=$driver;
      var $264=(($263)|0)!=0;
      if ($264) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $265
      var $266=$driver;
      var $267=(($266+44)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=$268 & 24;
      var $270=(($269)|0)!=0;
      if ($270) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $271
      $color=-262139888;
      __label__ = 48; break;
    case 48: // $272
      var $273=$2;
      var $274=(($273)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=$x1;
      var $277=$y1;
      var $278=$x2;
      var $279=$y2;
      var $280=$color;
      __Z20ui_draw_outlined_boxP16render_containerffffj($275, $276, $277, $278, $279, $280);
      var $281=$x1;
      var $282=$281+0.009999999776482582;
      $x1=$282;
      var $283=$x2;
      var $284=$283-0.009999999776482582;
      $x2=$284;
      var $285=$y1;
      var $286=$285+0.009999999776482582;
      $y1=$286;
      var $287=$y2;
      var $288=$287-0.009999999776482582;
      $y2=$288;
      $line=0;
      __label__ = 49; break;
    case 49: // $289
      var $290=$line;
      var $291=(($290)|0) < 4;
      if ($291) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $292
      var $293=$2;
      var $294=(($293)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$line;
      var $297=(($tempbuf+($296<<8))|0);
      var $298=(($297)|0);
      var $299=$x1;
      var $300=$y1;
      var $301=$x2;
      var $302=$x1;
      var $303=$301-$302;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($295, $298, $299, $300, $303, 1, 1, 1, -1, -285212672, 0, 0);
      var $304=$1;
      var $305=__Z18ui_get_line_heightR15running_machine($304);
      var $306=$y1;
      var $307=$306+$305;
      $y1=$307;
      __label__ = 51; break;
    case 51: // $308
      var $309=$line;
      var $310=(($309+1)|0);
      $line=$310;
      __label__ = 49; break;
    case 52: // $311
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30menu_select_game_custom_renderR15running_machineP7ui_menuPvS3_ffffff["X"]=1;

function __ZL34menu_select_game_build_driver_listP7ui_menuP18_select_game_state($menu, $menustate) {
  var __stackBase__  = STACKTOP; STACKTOP += 172; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $path=__stackBase__+36;
      var $dir;
      var $drivername=__stackBase__+120;
      var $dst;
      var $src;
      var $drivnum;
      var $listnum;
      $9=$menu;
      $10=$menustate;
      var $13=HEAP32[((__ZL8drivlist)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $15
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=40;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($6)>>2)]=3766;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 6: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $46
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$9;
      var $56=(function() { try { __THREW__ = false; return __ZNK7ui_menu7machineEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; };
    case 9: // $57
      var $58=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $59
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorC1ER11emu_options]($54, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      var $61=__ZN13resource_pool10add_objectI17driver_enumeratorEEPT_S3_(_global_resource_pool, $54);
      HEAP32[((__ZL8drivlist)>>2)]=$61;
      __label__ = 17; break;
    case 12: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $11=$64;
      var $65=$63.f1;
      $12=$65;
      var $66=$1;
      var $67=$2;
      var $68=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4164)|0);
      HEAP32[(($3)>>2)]=3766;
      var $69=HEAP32[(($1)>>2)];
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $71
      var $72=HEAP32[(($1)>>2)];
      var $73=HEAP32[(($2)>>2)];
      var $74=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($72, $73, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 43; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $75=$1;
      var $76=$2;
      var $77=$3;
      __label__ = 16; break;
    case 16: // $78
      __label__ = 42; break;
    case 17: // $79
      var $80=HEAP32[((__ZL8drivlist)>>2)];
      __ZN17driver_enumerator11exclude_allEv($80);
      var $81=$9;
      var $82=__ZNK7ui_menu7machineEv($81);
      var $83=__ZNK15running_machine7optionsEv($82);
      var $84=__ZNK11emu_options10media_pathEv($83);
      FUNCTION_TABLE[__ZN15file_enumeratorC1EPKc]($path, $84);
      __label__ = 18; break;
    case 18: // $85
      var $86=(function() { try { __THREW__ = false; return __ZN15file_enumerator4nextEv($path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 28; break; };
    case 19: // $87
      $dir=$86;
      var $88=(($86)|0)!=0;
      if ($88) { __label__ = 20; break; } else { __label__ = 34; break; }
    case 20: // $89
      var $90=(($drivername)|0);
      $dst=$90;
      var $91=$dir;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      $src=$93;
      __label__ = 21; break;
    case 21: // $94
      var $95=$src;
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24);
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 22; break; } else { var $109 = 0;__label__ = 24; break; }
    case 22: // $99
      var $100=$src;
      var $101=HEAP8[($100)];
      var $102=(($101 << 24) >> 24);
      var $103=(($102)|0)!=46;
      if ($103) { __label__ = 23; break; } else { var $109 = 0;__label__ = 24; break; }
    case 23: // $104
      var $105=$dst;
      var $106=(($drivername+49)|0);
      var $107=(($105)>>>0) < (($106)>>>0);
      var $109 = $107;__label__ = 24; break;
    case 24: // $108
      var $109;
      if ($109) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $110
      var $111=$src;
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=(function() { try { __THREW__ = false; return _tolower($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 28; break; };
    case 26: // $115
      var $116=(($114) & 255);
      var $117=$dst;
      var $118=(($117+1)|0);
      $dst=$118;
      HEAP8[($117)]=$116;
      __label__ = 27; break;
    case 27: // $119
      var $120=$src;
      var $121=(($120+1)|0);
      $src=$121;
      __label__ = 21; break;
    case 28: // $122
      var $123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $124=$123.f0;
      $11=$124;
      var $125=$123.f1;
      $12=$125;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15file_enumeratorD1Ev]($path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 29: // $126
      var $127=$dst;
      HEAP8[($127)]=0;
      var $128=HEAP32[((__ZL8drivlist)>>2)];
      var $129=(($drivername)|0);
      var $130=(function() { try { __THREW__ = false; return __ZN11driver_list4findEPKc($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 28; break; };
    case 30: // $131
      $drivnum=$130;
      var $132=$drivnum;
      var $133=(($132)|0)!=-1;
      if ($133) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $134
      var $135=HEAP32[((__ZL8drivlist)>>2)];
      var $136=$drivnum;
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator7includeEi($135, $136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 28; break; }
    case 32: // $137
      __label__ = 33; break;
    case 33: // $138
      __label__ = 18; break;
    case 34: // $139
      var $140=HEAP32[((__ZL8drivlist)>>2)];
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator5resetEv($140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 28; break; }
    case 35: // $141
      $listnum=0;
      __label__ = 36; break;
    case 36: // $142
      var $143=HEAP32[((__ZL8drivlist)>>2)];
      var $144=(function() { try { __THREW__ = false; return __ZN17driver_enumerator4nextEv($143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 28; break; };
    case 37: // $145
      if ($144) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $146
      var $147=HEAP32[((__ZL8drivlist)>>2)];
      var $148=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 28; break; };
    case 39: // $149
      var $150=$listnum;
      var $151=(($150+1)|0);
      $listnum=$151;
      var $152=$10;
      var $153=(($152+104)|0);
      var $154=(($153+($150<<2))|0);
      HEAP32[(($154)>>2)]=$148;
      __label__ = 36; break;
    case 40: // $155
      var $156=$listnum;
      var $157=$10;
      var $158=(($157+104)|0);
      var $159=(($158+($156<<2))|0);
      HEAP32[(($159)>>2)]=0;
      FUNCTION_TABLE[__ZN15file_enumeratorD1Ev]($path);
      STACKTOP = __stackBase__;
      return;
    case 41: // $160
      __label__ = 42; break;
    case 42: // $161
      var $162=$11;
      var $163=$11;
      var $164=$12;
      var $165=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $163, tempValue);
      var $166=($165.f1 = $164, $165);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $167
      var $168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL34menu_select_game_build_driver_listP7ui_menuP18_select_game_state["X"]=1;

function __ZN20resource_pool_objectI17driver_enumeratorEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17driver_enumeratorEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17driver_enumeratorEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 40);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17driver_enumeratorE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17driver_enumeratorED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17driver_enumeratorED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectI17driver_enumeratorEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17driver_enumeratorEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17driver_enumeratorEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI17driver_enumeratorED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17driver_enumeratorED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17driver_enumeratorED0Ev["X"]=1;

function __ZN20resource_pool_objectI17driver_enumeratorED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI17driver_enumeratorE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumeratorD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17driver_enumeratorED2Ev["X"]=1;

function __ZL21menu_sliders_populateR15running_machineP7ui_menui($machine, $menu, $menuless_mode) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curslider;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $curval;
      var $flags;
      var $curval1;
      var $flags2;
      $1=$machine;
      $2=$menu;
      $3=$menuless_mode;
      __ZN7astringC1Ev($tempstring);
      var $6=(function() { try { __THREW__ = false; return __Z18ui_get_slider_listv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $7
      $curslider=$6;
      __label__ = 2; break;
    case 2: // $8
      var $9=$curslider;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $11
      var $12=$curslider;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$1;
      var $16=$curslider;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$14]($15, $18, $tempstring, 305419896) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $20
      $curval=$19;
      $flags=0;
      var $21=$curval;
      var $22=$curslider;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($21)|0) > (($24)|0);
      if ($25) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $26
      var $27=$flags;
      var $28=$27 | 1;
      $flags=$28;
      __label__ = 7; break;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $4=$31;
      var $32=$30.f1;
      $5=$32;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 7: // $33
      var $34=$curval;
      var $35=$curslider;
      var $36=(($35+20)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($34)|0) < (($37)|0);
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      var $40=$flags;
      var $41=$40 | 2;
      $flags=$41;
      __label__ = 9; break;
    case 9: // $42
      var $43=$2;
      var $44=$curslider;
      var $45=(($44+28)|0);
      var $46=(($45)|0);
      var $47=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; };
    case 10: // $48
      var $49=$flags;
      var $50=$curslider;
      var $51=$50;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($43, $46, $47, $49, $51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 6; break; }
    case 11: // $52
      var $53=$3;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $55
      __label__ = 15; break;
    case 13: // $56
      __label__ = 14; break;
    case 14: // $57
      var $58=$curslider;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      $curslider=$60;
      __label__ = 2; break;
    case 15: // $61
      var $62=$1;
      var $63=(function() { try { __THREW__ = false; return __ZNK15running_machine3osdEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 6; break; };
    case 16: // $64
      var $65=$63;
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+48)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$68]($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 6; break; };
    case 17: // $70
      var $71=$69;
      $curslider=$71;
      __label__ = 18; break;
    case 18: // $72
      var $73=$curslider;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 19; break; } else { __label__ = 28; break; }
    case 19: // $75
      var $76=$curslider;
      var $77=(($76+4)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$1;
      var $80=$curslider;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$78]($79, $82, $tempstring, 305419896) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 6; break; };
    case 20: // $84
      $curval1=$83;
      $flags2=0;
      var $85=$curval1;
      var $86=$curslider;
      var $87=(($86+12)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($85)|0) > (($88)|0);
      if ($89) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $90
      var $91=$flags2;
      var $92=$91 | 1;
      $flags2=$92;
      __label__ = 22; break;
    case 22: // $93
      var $94=$curval1;
      var $95=$curslider;
      var $96=(($95+20)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($94)|0) < (($97)|0);
      if ($98) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $99
      var $100=$flags2;
      var $101=$100 | 2;
      $flags2=$101;
      __label__ = 24; break;
    case 24: // $102
      var $103=$2;
      var $104=$curslider;
      var $105=(($104+28)|0);
      var $106=(($105)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 6; break; };
    case 25: // $108
      var $109=$flags2;
      var $110=$curslider;
      var $111=$110;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($103, $106, $107, $109, $111) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 6; break; }
    case 26: // $112
      __label__ = 27; break;
    case 27: // $113
      var $114=$curslider;
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      $curslider=$116;
      __label__ = 18; break;
    case 28: // $117
      var $118=$2;
      var $119=$1;
      var $120=(function() { try { __THREW__ = false; return __Z18ui_get_line_heightR15running_machine($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 6; break; };
    case 29: // $121
      var $122=$120*2;
      var $123=$122+0.019999999552965164;
      (function() { try { __THREW__ = false; return __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($118, 1032, 0, $123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 6; break; }
    case 30: // $124
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 31: // $125
      __label__ = 32; break;
    case 32: // $126
      var $127=$4;
      var $128=$4;
      var $129=$5;
      var $130=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $128, tempValue);
      var $131=($130.f1 = $129, $130);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $132
      var $133=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21menu_sliders_populateR15running_machineP7ui_menui["X"]=1;

function __ZL26menu_sliders_custom_renderR15running_machineP7ui_menuPvS3_ffffff($machine, $menu, $state, $selectedref, $top, $bottom, $x1, $y1, $x2, $y2) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $curslider;
      var $bar_left;
      var $bar_area_top;
      var $bar_width;
      var $bar_area_height;
      var $bar_top;
      var $bar_bottom;
      var $default_x;
      var $current_x;
      var $line_height;
      var $percentage;
      var $default_percentage;
      var $tempstring=__stackBase__;
      var $text_height=__stackBase__+64;
      var $curval;
      var $11;
      var $12;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$selectedref;
      $5=$top;
      $6=$bottom;
      $7=$x1;
      $8=$y1;
      $9=$x2;
      $10=$y2;
      var $13=$4;
      var $14=$13;
      $curslider=$14;
      var $15=$curslider;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $17
      var $18=$1;
      var $19=__Z18ui_get_line_heightR15running_machine($18);
      $line_height=$19;
      __ZN7astringC1Ev($tempstring);
      var $20=$curslider;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=$curslider;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$22]($23, $26, $tempstring, 305419896) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $28
      $curval=$27;
      var $29=$curval;
      var $30=$curslider;
      var $31=(($30+12)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($29-$32)|0);
      var $34=(($33)|0);
      var $35=$curslider;
      var $36=(($35+20)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$curslider;
      var $39=(($38+12)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($37-$40)|0);
      var $42=(($41)|0);
      var $43=$34/$42;
      $percentage=$43;
      var $44=$curslider;
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$curslider;
      var $48=(($47+12)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46-$49)|0);
      var $51=(($50)|0);
      var $52=$curslider;
      var $53=(($52+20)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$curslider;
      var $56=(($55+12)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($54-$57)|0);
      var $59=(($58)|0);
      var $60=$51/$59;
      $default_percentage=$60;
      var $61=(function() { try { __THREW__ = false; return __ZN7astring3insEiPKc($tempstring, 0, ((STRING_TABLE.__str314195)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 15; break; };
    case 3: // $62
      var $63=$curslider;
      var $64=(($63+28)|0);
      var $65=(($64)|0);
      var $66=(function() { try { __THREW__ = false; return __ZN7astring3insEiPKc($61, 0, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 15; break; };
    case 4: // $67
      $10=0.9900000095367432;
      var $68=$10;
      var $69=$6;
      var $70=$68-$69;
      $8=$70;
      $7=0.009999999776482582;
      $9=0.9900000095367432;
      var $71=$2;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$7;
      var $75=$8;
      var $76=$9;
      var $77=$10;
      (function() { try { __THREW__ = false; return __Z20ui_draw_outlined_boxP16render_containerffffj($73, $74, $75, $76, $77, -284159952) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $78
      var $79=$8;
      var $80=$79+0.009999999776482582;
      $8=$80;
      var $81=$2;
      var $82=(($81)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; };
    case 6: // $85
      var $86=$9;
      var $87=$7;
      var $88=$86-$87;
      var $89=$88-0.019999999552965164;
      (function() { try { __THREW__ = false; return __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($83, $84, 0, 0, $89, 1, 1, 0, -1, -16777216, 0, $text_height) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 15; break; }
    case 7: // $90
      var $91=$7;
      var $92=$91+0.009999999776482582;
      $bar_left=$92;
      var $93=$8;
      $bar_area_top=$93;
      var $94=$9;
      var $95=$7;
      var $96=$94-$95;
      var $97=$96-0.019999999552965164;
      $bar_width=$97;
      var $98=$line_height;
      $bar_area_height=$98;
      var $99=$bar_area_top;
      var $100=$bar_area_height;
      var $101=$100*0.125;
      var $102=$99+$101;
      $bar_top=$102;
      var $103=$bar_area_top;
      var $104=$bar_area_height;
      var $105=$104*0.875;
      var $106=$103+$105;
      $bar_bottom=$106;
      var $107=$bar_left;
      var $108=$bar_width;
      var $109=$default_percentage;
      var $110=$108*$109;
      var $111=$107+$110;
      $default_x=$111;
      var $112=$bar_left;
      var $113=$bar_width;
      var $114=$percentage;
      var $115=$113*$114;
      var $116=$112+$115;
      $current_x=$116;
      var $117=$2;
      var $118=(($117)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$bar_left;
      var $121=$bar_top;
      var $122=$current_x;
      var $123=$bar_bottom;
      (function() { try { __THREW__ = false; return __ZN16render_container8add_rectEffffjj($119, $120, $121, $122, $123, -1, 256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $124
      var $125=$2;
      var $126=(($125)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=$bar_left;
      var $129=$bar_top;
      var $130=$bar_left;
      var $131=$bar_width;
      var $132=$130+$131;
      var $133=$bar_top;
      (function() { try { __THREW__ = false; return __ZN16render_container8add_lineEfffffjj($127, $128, $129, $132, $133, 0.0020000000949949026, -1, 256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $134
      var $135=$2;
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$bar_left;
      var $139=$bar_bottom;
      var $140=$bar_left;
      var $141=$bar_width;
      var $142=$140+$141;
      var $143=$bar_bottom;
      (function() { try { __THREW__ = false; return __ZN16render_container8add_lineEfffffjj($137, $138, $139, $142, $143, 0.0020000000949949026, -1, 256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $144
      var $145=$2;
      var $146=(($145)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$default_x;
      var $149=$bar_area_top;
      var $150=$default_x;
      var $151=$bar_top;
      (function() { try { __THREW__ = false; return __ZN16render_container8add_lineEfffffjj($147, $148, $149, $150, $151, 0.0020000000949949026, -1, 256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $152
      var $153=$2;
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$default_x;
      var $157=$bar_bottom;
      var $158=$default_x;
      var $159=$bar_area_top;
      var $160=$bar_area_height;
      var $161=$159+$160;
      (function() { try { __THREW__ = false; return __ZN16render_container8add_lineEfffffjj($155, $156, $157, $158, $161, 0.0020000000949949026, -1, 256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $162
      var $163=$2;
      var $164=(($163)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $167
      var $168=$7;
      var $169=$168+0.009999999776482582;
      var $170=$8;
      var $171=$line_height;
      var $172=$170+$171;
      var $173=$9;
      var $174=$7;
      var $175=$173-$174;
      var $176=$175-0.019999999552965164;
      (function() { try { __THREW__ = false; return __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($165, $166, $169, $172, $176, 1, 2, 1, -1, -285212672, 0, $text_height) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $177
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      __label__ = 17; break;
    case 15: // $178
      var $179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $180=$179.f0;
      $11=$180;
      var $181=$179.f1;
      $12=$181;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $182
      __label__ = 18; break;
    case 17: // $183
      STACKTOP = __stackBase__;
      return;
    case 18: // $184
      var $185=$11;
      var $186=$11;
      var $187=$12;
      var $188=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $186, tempValue);
      var $189=($188.f1 = $187, $188);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $190
      var $191=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26menu_sliders_custom_renderR15running_machineP7ui_menuPvS3_ffffff["X"]=1;

function __ZL18menu_main_populateR15running_machineP7ui_menuPv($machine, $menu, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $field;
      var $port;
      var $has_categories;
      var $has_configs;
      var $has_analog;
      var $has_dips;
      var $image=__stackBase__;
      var $slot=__stackBase__+4;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $has_categories=0;
      $has_configs=0;
      $has_analog=0;
      $has_dips=0;
      var $4=$1;
      var $5=(($4+20)|0);
      var $6=__ZNK11tagged_listI17input_port_configE5firstEv($5);
      $port=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$port;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $10
      var $11=$port;
      var $12=__ZN17input_port_config9fieldlistEv($11);
      var $13=__ZNK11simple_listI18input_field_configE5firstEv($12);
      $field=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$field;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $17
      var $18=$field;
      var $19=(($18+24)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==5;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      $has_dips=1;
      __label__ = 6; break;
    case 6: // $23
      var $24=$field;
      var $25=(($24+24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==7;
      if ($27) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $28
      $has_configs=1;
      __label__ = 8; break;
    case 8: // $29
      var $30=$field;
      var $31=(($30+30)|0);
      var $32=HEAPU16[(($31)>>1)];
      var $33=(($32)&65535);
      var $34=(($33)|0) > 0;
      if ($34) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $35
      $has_categories=1;
      __label__ = 10; break;
    case 10: // $36
      var $37=$field;
      var $38=(($37+24)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=__Z20input_type_is_analogi($39);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $42
      $has_analog=1;
      __label__ = 12; break;
    case 12: // $43
      __label__ = 13; break;
    case 13: // $44
      var $45=$field;
      var $46=__ZNK18input_field_config4nextEv($45);
      $field=$46;
      __label__ = 3; break;
    case 14: // $47
      __label__ = 15; break;
    case 15: // $48
      var $49=$port;
      var $50=__ZNK17input_port_config4nextEv($49);
      $port=$50;
      __label__ = 1; break;
    case 16: // $51
      var $52=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($52, ((STRING_TABLE.__str324196)|0), 0, 0, 1024);
      var $53=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($53, ((STRING_TABLE.__str334197)|0), 0, 0, 1038);
      var $54=$has_dips;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $56
      var $57=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($57, ((STRING_TABLE.__str344198)|0), 0, 0, 1040);
      __label__ = 18; break;
    case 18: // $58
      var $59=$has_configs;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $61
      var $62=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($62, ((STRING_TABLE.__str354199)|0), 0, 0, 1042);
      __label__ = 20; break;
    case 20: // $63
      var $64=$has_categories;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $66
      var $67=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($67, ((STRING_TABLE.__str364200)|0), 0, 0, 1044);
      __label__ = 22; break;
    case 22: // $68
      var $69=$has_analog;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $71
      var $72=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($72, ((STRING_TABLE.__str374201)|0), 0, 0, 1046);
      __label__ = 24; break;
    case 24: // $73
      var $74=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($74, ((STRING_TABLE.__str384202)|0), 0, 0, 1048);
      var $75=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($75, ((STRING_TABLE.__str394203)|0), 0, 0, 1050);
      HEAP32[(($image)>>2)]=0;
      var $76=$1;
      var $77=__ZNK15running_machine10devicelistEv($76);
      var $78=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($77, $image);
      if ($78) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $79
      var $80=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($80, ((STRING_TABLE.__str404204)|0), 0, 0, 1052);
      var $81=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($81, ((STRING_TABLE.__str414205)|0), 0, 0, 1054);
      var $82=$1;
      var $83=__ZNK15running_machine10devicelistEv($82);
      var $84=HEAP32[((_CASSETTE)>>2)];
      var $85=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($83, $84);
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $87
      var $88=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($88, ((STRING_TABLE.__str424206)|0), 0, 0, 1056);
      __label__ = 27; break;
    case 27: // $89
      var $90=$1;
      var $91=__ZNK15running_machine10devicelistEv($90);
      var $92=HEAP32[((_BITBANGER)>>2)];
      var $93=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($91, $92);
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $95
      var $96=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($96, ((STRING_TABLE.__str434207)|0), 0, 0, 1058);
      __label__ = 29; break;
    case 29: // $97
      __label__ = 30; break;
    case 30: // $98
      HEAP32[(($slot)>>2)]=0;
      var $99=$1;
      var $100=__ZNK15running_machine10devicelistEv($99);
      var $101=__ZNK11device_list5firstI21device_slot_interfaceEEbRPT_($100, $slot);
      if ($101) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $102
      var $103=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($103, ((STRING_TABLE.__str444208)|0), 0, 0, 1060);
      __label__ = 32; break;
    case 32: // $104
      var $105=$1;
      var $106=__Z26input_machine_has_keyboardR15running_machine($105);
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $108
      var $109=$1;
      var $110=__Z15inputx_can_postR15running_machine($109);
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $112
      var $113=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($113, ((STRING_TABLE.__str454209)|0), 0, 0, 1062);
      __label__ = 35; break;
    case 35: // $114
      var $115=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($115, ((STRING_TABLE.__str464210)|0), 0, 0, 1018);
      var $116=$2;
      var $117=$1;
      var $118=__ZNK15running_machine6renderEv($117);
      var $119=__ZNK14render_manager15target_by_indexEi($118, 1);
      var $120=(($119)|0)!=0;
      var $121=$120 ? 1034 : 1036;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($116, ((STRING_TABLE.__str474211)|0), 0, 0, $121);
      var $122=$1;
      var $123=__Z19crosshair_get_usageR15running_machine($122);
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $125
      var $126=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($126, ((STRING_TABLE.__str484212)|0), 0, 0, 1064);
      __label__ = 37; break;
    case 37: // $127
      var $128=$1;
      var $129=__ZNK15running_machine7optionsEv($128);
      var $130=__ZNK11emu_options5cheatEv($129);
      if ($130) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $131
      var $132=$1;
      var $133=__ZNK15running_machine5cheatEv($132);
      var $134=__ZNK13cheat_manager5firstEv($133);
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $136
      var $137=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($137, ((STRING_TABLE.__str494213)|0), 0, 0, 1066);
      __label__ = 40; break;
    case 40: // $138
      var $139=$1;
      var $140=__ZNK15running_machine6configEv($139);
      var $141=(($140+36)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $144
      var $145=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($145, ((STRING_TABLE.__str504214)|0), 0, 0, 1068);
      __label__ = 42; break;
    case 42: // $146
      var $147=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($147, ((STRING_TABLE.__str514215)|0), 0, 0, 1022);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18menu_main_populateR15running_machineP7ui_menuPv["X"]=1;

function __ZL19menu_input_specificR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$menu;
  $3=$parameter;
  $4=$state;
  var $5=$1;
  var $6=$2;
  var $7=$4;
  __ZL17menu_input_commonR15running_machineP7ui_menuPvS3_($5, $6, 0, $7);
  ;
  return;
}


function __ZL26menu_settings_dip_switchesR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$menu;
  $3=$parameter;
  $4=$state;
  var $5=$1;
  var $6=$2;
  var $7=$4;
  __ZL20menu_settings_commonR15running_machineP7ui_menuPvj($5, $6, $7, 5);
  ;
  return;
}


function __ZL27menu_settings_driver_configR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$menu;
  $3=$parameter;
  $4=$state;
  var $5=$1;
  var $6=$2;
  var $7=$4;
  __ZL20menu_settings_commonR15running_machineP7ui_menuPvj($5, $6, $7, 7);
  ;
  return;
}


function __ZL24menu_settings_categoriesR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$menu;
  $3=$parameter;
  $4=$state;
  var $5=$1;
  var $6=$2;
  var $7=$4;
  __ZL20menu_settings_commonR15running_machineP7ui_menuPvj($5, $6, $7, 8);
  ;
  return;
}


function __ZL11menu_analogR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 220; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      var $data;
      var $newval;
      var $5=__stackBase__;
      var $6=__stackBase__+4;
      var $settings=__stackBase__+8;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      __ZL20menu_analog_populateR15running_machineP7ui_menu($11, $12);
      __label__ = 2; break;
    case 2: // $13
      var $14=$1;
      var $15=$2;
      var $16=__Z15ui_menu_processR15running_machineP7ui_menuj($14, $15, 2);
      $menu_event=$16;
      var $17=$menu_event;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $19
      var $20=$menu_event;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $24
      var $25=$menu_event;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      $data=$28;
      var $29=$data;
      var $30=(($29+16)|0);
      var $31=HEAP32[(($30)>>2)];
      $newval=$31;
      var $32=$menu_event;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      if ($34 == 182) {
        __label__ = 5; break;
      }
      else if ($34 == 176) {
        __label__ = 6; break;
      }
      else if ($34 == 177) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 5: // $35
      var $36=$data;
      var $37=(($36+20)|0);
      var $38=HEAP32[(($37)>>2)];
      $newval=$38;
      __label__ = 8; break;
    case 6: // $39
      var $40=$1;
      var $41=__ZNK15running_machine5inputEv($40);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 1, 0, 1, 0, 97);
      var $42=__ZN13input_manager12code_pressedE10input_code($41, $5);
      var $43=$42 ? 10 : 1;
      var $44=$newval;
      var $45=(($44-$43)|0);
      $newval=$45;
      __label__ = 8; break;
    case 7: // $46
      var $47=$1;
      var $48=__ZNK15running_machine5inputEv($47);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 97);
      var $49=__ZN13input_manager12code_pressedE10input_code($48, $6);
      var $50=$49 ? 10 : 1;
      var $51=$newval;
      var $52=(($51+$50)|0);
      $newval=$52;
      __label__ = 8; break;
    case 8: // $53
      var $54=$newval;
      var $55=$data;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($54)|0) < (($57)|0);
      if ($58) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $59
      var $60=$data;
      var $61=(($60+8)|0);
      var $62=HEAP32[(($61)>>2)];
      $newval=$62;
      __label__ = 10; break;
    case 10: // $63
      var $64=$newval;
      var $65=$data;
      var $66=(($65+12)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($64)|0) > (($67)|0);
      if ($68) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $69
      var $70=$data;
      var $71=(($70+12)|0);
      var $72=HEAP32[(($71)>>2)];
      $newval=$72;
      __label__ = 12; break;
    case 12: // $73
      var $74=$newval;
      var $75=$data;
      var $76=(($75+16)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($74)|0)!=(($77)|0);
      if ($78) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $79
      __ZN26_input_field_user_settingsC1Ev($settings);
      var $80=$data;
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($82, $settings);
      var $83=$data;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      if ($85 == 0) {
        __label__ = 14; break;
      }
      else if ($85 == 1) {
        __label__ = 15; break;
      }
      else if ($85 == 2) {
        __label__ = 16; break;
      }
      else if ($85 == 3) {
        __label__ = 17; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 14: // $86
      var $87=$newval;
      var $88=(($settings+200)|0);
      HEAP32[(($88)>>2)]=$87;
      __label__ = 18; break;
    case 15: // $89
      var $90=$newval;
      var $91=(($settings+204)|0);
      HEAP32[(($91)>>2)]=$90;
      __label__ = 18; break;
    case 16: // $92
      var $93=$newval;
      var $94=(($93) & 255);
      var $95=(($settings+208)|0);
      HEAP8[($95)]=$94;
      __label__ = 18; break;
    case 17: // $96
      var $97=$newval;
      var $98=(($settings+196)|0);
      HEAP32[(($98)>>2)]=$97;
      __label__ = 18; break;
    case 18: // $99
      var $100=$data;
      var $101=(($100)|0);
      var $102=HEAP32[(($101)>>2)];
      __Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings($102, $settings);
      var $103=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($103, 1);
      __label__ = 19; break;
    case 19: // $104
      __label__ = 20; break;
    case 20: // $105
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11menu_analogR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL16menu_bookkeepingR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $prevtime;
      var $curtime=__stackBase__;
      var $5=__stackBase__+12;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      __ZN8attotimeC1Ev($curtime);
      var $6=$4;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($9, 12, 0);
      $4=$10;
      __label__ = 2; break;
    case 2: // $11
      var $12=$4;
      var $13=$12;
      $prevtime=$13;
      var $14=$1;
      __ZNK15running_machine4timeEv($5, $14);
      var $15=$curtime;
      var $16=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($15)>>2)]=HEAP32[(($16)>>2)];HEAP32[(($15+4)>>2)]=HEAP32[(($16+4)>>2)];HEAP32[(($15+8)>>2)]=HEAP32[(($16+8)>>2)];
      var $17=$prevtime;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($curtime)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($19)|0)!=(($21)|0);
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($24, 0);
      var $25=$prevtime;
      var $26=$25;
      var $27=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[(($27)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[(($27+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[(($27+8)>>2)];
      var $28=$1;
      var $29=$2;
      var $30=$prevtime;
      __ZL25menu_bookkeeping_populateR15running_machineP7ui_menuP8attotime($28, $29, $30);
      __label__ = 4; break;
    case 4: // $31
      var $32=$1;
      var $33=$2;
      var $34=__Z15ui_menu_processR15running_machineP7ui_menuj($32, $33, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20ui_menu_slot_devicesR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      var $slot;
      var $val;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$2;
      var $6=__Z17ui_menu_populatedP7ui_menu($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=$2;
      var $11=$4;
      __ZL26menu_slot_devices_populateR15running_machineP7ui_menuPv($9, $10, $11);
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=$2;
      var $15=__Z15ui_menu_processR15running_machineP7ui_menuj($13, $14, 0);
      $menu_event=$15;
      var $16=$menu_event;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $18
      var $19=$menu_event;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $23
      var $24=$menu_event;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==176;
      if ($27) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $28
      var $29=$menu_event;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)==177;
      if ($32) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $33
      var $34=$menu_event;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36;
      $slot=$37;
      var $38=$menu_event;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==176;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      var $43=$1;
      var $44=$slot;
      var $45=__Z16ui_slot_get_prevR15running_machineP21device_slot_interface($43, $44);
      var $51 = $45;__label__ = 9; break;
    case 8: // $46
      var $47=$1;
      var $48=$slot;
      var $49=__Z16ui_slot_get_nextR15running_machineP21device_slot_interface($47, $48);
      var $51 = $49;__label__ = 9; break;
    case 9: // $50
      var $51;
      $val=$51;
      var $52=$1;
      var $53=$slot;
      var $54=$val;
      __Z18ui_set_slot_deviceR15running_machineP21device_slot_interfacePKc($52, $53, $54);
      var $55=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($55, 2);
      __label__ = 10; break;
    case 10: // $56
      __label__ = 15; break;
    case 11: // $57
      var $58=$menu_event;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $60
      var $61=$menu_event;
      var $62=(($61+4)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==182;
      if ($64) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $65
      var $66=$1;
      __ZN15running_machine19schedule_hard_resetEv($66);
      __label__ = 14; break;
    case 14: // $67
      __label__ = 15; break;
    case 15: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20ui_menu_slot_devicesR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL21ui_menu_keyboard_modeR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      var $natural;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$1;
      var $6=__Z27ui_get_use_natural_keyboardR15running_machine($5);
      $natural=$6;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$2;
      var $12=$natural;
      var $13=(($12)|0)!=0;
      var $14=$13 ? (((STRING_TABLE.__str934257)|0)) : (((STRING_TABLE.__str944258)|0));
      var $15=$natural;
      var $16=(($15)|0)!=0;
      var $17=$16 ? 1 : 2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($11, ((STRING_TABLE.__str924256)|0), $14, $17, 0);
      __label__ = 2; break;
    case 2: // $18
      var $19=$1;
      var $20=$2;
      var $21=__Z15ui_menu_processR15running_machineP7ui_menuj($19, $20, 0);
      $menu_event=$21;
      var $22=$menu_event;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $24
      var $25=$menu_event;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)==176;
      if ($28) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $29
      var $30=$menu_event;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==177;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$1;
      var $36=$natural;
      var $37=$36 ^ 1;
      __Z27ui_set_use_natural_keyboardR15running_machinei($35, $37);
      var $38=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($38, 2);
      __label__ = 6; break;
    case 6: // $39
      __label__ = 7; break;
    case 7: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21ui_menu_keyboard_modeR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL18menu_video_targetsR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$2;
      var $6=__Z17ui_menu_populatedP7ui_menu($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=$2;
      __ZL27menu_video_targets_populateR15running_machineP7ui_menu($9, $10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=$2;
      var $14=__Z15ui_menu_processR15running_machineP7ui_menuj($12, $13, 0);
      $menu_event=$14;
      var $15=$menu_event;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      var $18=$menu_event;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==182;
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      var $23=$1;
      var $24=$2;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$menu_event;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($23, $26, 1036, $29);
      __Z18ui_menu_stack_pushP7ui_menu($30);
      __label__ = 5; break;
    case 5: // $31
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14menu_game_infoR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $tempstring=__stackBase__;
      var $5;
      var $6;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $10
      __ZN7astringC1Ev($tempstring);
      var $11=$2;
      var $12=$1;
      var $13=(function() { try { __THREW__ = false; return __Z17game_info_astringR15running_machineR7astring($12, $tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; };
    case 2: // $14
      var $15=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $16
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($11, $15, 0, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      __label__ = 7; break;
    case 5: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $5=$20;
      var $21=$19.f1;
      $6=$21;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $22
      __label__ = 8; break;
    case 7: // $23
      var $24=$1;
      var $25=$2;
      var $26=__Z15ui_menu_processR15running_machineP7ui_menuj($24, $25, 0);
      STACKTOP = __stackBase__;
      return;
    case 8: // $27
      var $28=$5;
      var $29=$5;
      var $30=$6;
      var $31=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29, tempValue);
      var $32=($31.f1 = $30, $31);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL18menu_video_optionsR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $target;
      var $menu_event;
      var $changed;
      var $delta;
      var $settings=__stackBase__;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$3;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$3;
      var $9=$8;
      var $15 = $9;__label__ = 3; break;
    case 2: // $10
      var $11=$1;
      var $12=__ZNK15running_machine6renderEv($11);
      var $13=__ZNK14render_manager12first_targetEv($12);
      var $15 = $13;__label__ = 3; break;
    case 3: // $14
      var $15;
      $target=$15;
      $changed=0;
      var $16=$2;
      var $17=__Z17ui_menu_populatedP7ui_menu($16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $19
      var $20=$1;
      var $21=$2;
      var $22=$target;
      __ZL27menu_video_options_populateR15running_machineP7ui_menuP13render_target($20, $21, $22);
      __label__ = 5; break;
    case 5: // $23
      var $24=$1;
      var $25=$2;
      var $26=__Z15ui_menu_processR15running_machineP7ui_menuj($24, $25, 0);
      $menu_event=$26;
      var $27=$menu_event;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 43; break; }
    case 6: // $29
      var $30=$menu_event;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 43; break; }
    case 7: // $34
      var $35=$menu_event;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$37;
      if ($38 == -2147483648) {
        __label__ = 8; break;
      }
      else if ($38 == -2147483647) {
        __label__ = 14; break;
      }
      else if ($38 == -2147483646) {
        __label__ = 18; break;
      }
      else if ($38 == -2147483645) {
        __label__ = 22; break;
      }
      else if ($38 == -2147483644) {
        __label__ = 26; break;
      }
      else if ($38 == -2147483643) {
        __label__ = 30; break;
      }
      else if ($38 == -2147483642) {
        __label__ = 34; break;
      }
      else {
      __label__ = 38; break;
      }
      
    case 8: // $39
      var $40=$menu_event;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==176;
      if ($43) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $44
      var $45=$menu_event;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)==177;
      if ($48) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $49
      var $50=$menu_event;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==176;
      var $54=$53 ? 6 : 5;
      $delta=$54;
      var $55=$target;
      var $56=$delta;
      var $57=$target;
      var $58=__ZNK13render_target11orientationEv($57);
      var $59=__ZL15orientation_addii4283($56, $58);
      __ZN13render_target15set_orientationEi($55, $59);
      var $60=$target;
      var $61=__ZNK13render_target12is_ui_targetEv($60);
      if ($61) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($settings);
      var $63=$2;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($65, $settings);
      var $66=$delta;
      var $67=$66 ^ 3;
      var $68=(($settings)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=__ZL15orientation_addii4283($67, $69);
      var $71=(($settings)|0);
      HEAP32[(($71)>>2)]=$70;
      var $72=$2;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($74, $settings);
      __label__ = 12; break;
    case 12: // $75
      $changed=1;
      __label__ = 13; break;
    case 13: // $76
      __label__ = 42; break;
    case 14: // $77
      var $78=$menu_event;
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)==176;
      if ($81) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $82
      var $83=$menu_event;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)==177;
      if ($86) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $87
      var $88=$target;
      var $89=$target;
      var $90=__ZNK13render_target17backdrops_enabledEv($89);
      var $91=$90 ^ 1;
      __ZN13render_target21set_backdrops_enabledEb($88, $91);
      $changed=1;
      __label__ = 17; break;
    case 17: // $92
      __label__ = 42; break;
    case 18: // $93
      var $94=$menu_event;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)==176;
      if ($97) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $98
      var $99=$menu_event;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101)|0)==177;
      if ($102) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $103
      var $104=$target;
      var $105=$target;
      var $106=__ZNK13render_target16overlays_enabledEv($105);
      var $107=$106 ^ 1;
      __ZN13render_target20set_overlays_enabledEb($104, $107);
      $changed=1;
      __label__ = 21; break;
    case 21: // $108
      __label__ = 42; break;
    case 22: // $109
      var $110=$menu_event;
      var $111=(($110+4)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112)|0)==176;
      if ($113) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $114
      var $115=$menu_event;
      var $116=(($115+4)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117)|0)==177;
      if ($118) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $119
      var $120=$target;
      var $121=$target;
      var $122=__ZNK13render_target14bezels_enabledEv($121);
      var $123=$122 ^ 1;
      __ZN13render_target18set_bezels_enabledEb($120, $123);
      $changed=1;
      __label__ = 25; break;
    case 25: // $124
      __label__ = 42; break;
    case 26: // $125
      var $126=$menu_event;
      var $127=(($126+4)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128)|0)==176;
      if ($129) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $130
      var $131=$menu_event;
      var $132=(($131+4)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133)|0)==177;
      if ($134) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $135
      var $136=$target;
      var $137=$target;
      var $138=__ZNK13render_target15cpanels_enabledEv($137);
      var $139=$138 ^ 1;
      __ZN13render_target19set_cpanels_enabledEb($136, $139);
      $changed=1;
      __label__ = 29; break;
    case 29: // $140
      __label__ = 42; break;
    case 30: // $141
      var $142=$menu_event;
      var $143=(($142+4)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144)|0)==176;
      if ($145) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $146
      var $147=$menu_event;
      var $148=(($147+4)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149)|0)==177;
      if ($150) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $151
      var $152=$target;
      var $153=$target;
      var $154=__ZNK13render_target16marquees_enabledEv($153);
      var $155=$154 ^ 1;
      __ZN13render_target20set_marquees_enabledEb($152, $155);
      $changed=1;
      __label__ = 33; break;
    case 33: // $156
      __label__ = 42; break;
    case 34: // $157
      var $158=$menu_event;
      var $159=(($158+4)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160)|0)==176;
      if ($161) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $162
      var $163=$menu_event;
      var $164=(($163+4)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165)|0)==177;
      if ($166) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $167
      var $168=$target;
      var $169=$target;
      var $170=__ZNK13render_target14zoom_to_screenEv($169);
      var $171=$170 ^ 1;
      __ZN13render_target18set_zoom_to_screenEb($168, $171);
      $changed=1;
      __label__ = 37; break;
    case 37: // $172
      __label__ = 42; break;
    case 38: // $173
      var $174=$menu_event;
      var $175=(($174+4)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176)|0)==182;
      if ($177) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $178
      var $179=$menu_event;
      var $180=(($179)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=$181;
      var $183=(($182)>>>0) >= 2147483655;
      if ($183) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $184
      var $185=$target;
      var $186=$menu_event;
      var $187=(($186)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$188;
      var $190=(($189+2147483641)|0);
      __ZN13render_target8set_viewEi($185, $190);
      $changed=1;
      __label__ = 41; break;
    case 41: // $191
      __label__ = 42; break;
    case 42: // $192
      __label__ = 43; break;
    case 43: // $193
      var $194=$changed;
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $196
      var $197=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($197, 2);
      __label__ = 45; break;
    case 45: // $198
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18menu_video_optionsR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL14menu_crosshairR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      var $settings=__stackBase__;
      var $data;
      var $changed;
      var $newval;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      __ZL23menu_crosshair_populateR15running_machineP7ui_menu($11, $12);
      __label__ = 2; break;
    case 2: // $13
      var $14=$1;
      var $15=$2;
      var $16=__Z15ui_menu_processR15running_machineP7ui_menuj($14, $15, 2);
      $menu_event=$16;
      var $17=$menu_event;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 30; break; }
    case 3: // $19
      var $20=$menu_event;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 30; break; }
    case 4: // $24
      var $25=$menu_event;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      $data=$28;
      $changed=0;
      var $29=$data;
      var $30=(($29+4)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      $newval=$32;
      var $33=$1;
      var $34=$data;
      var $35=(($34+1)|0);
      var $36=HEAP8[($35)];
      __Z27crosshair_get_user_settingsR15running_machinehP24_crosshair_user_settings($33, $36, $settings);
      var $37=$menu_event;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      if ($39 == 182) {
        __label__ = 5; break;
      }
      else if ($39 == 176) {
        __label__ = 6; break;
      }
      else if ($39 == 177) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 5: // $40
      var $41=$data;
      var $42=(($41+5)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      $newval=$44;
      __label__ = 8; break;
    case 6: // $45
      var $46=$1;
      var $47=__ZNK15running_machine5inputEv($46);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 1, 0, 1, 0, 97);
      var $48=__ZN13input_manager12code_pressedE10input_code($47, $5);
      var $49=$48 ? 10 : 1;
      var $50=$newval;
      var $51=(($50-$49)|0);
      $newval=$51;
      __label__ = 8; break;
    case 7: // $52
      var $53=$1;
      var $54=__ZNK15running_machine5inputEv($53);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 97);
      var $55=__ZN13input_manager12code_pressedE10input_code($54, $6);
      var $56=$55 ? 10 : 1;
      var $57=$newval;
      var $58=(($57+$56)|0);
      $newval=$58;
      __label__ = 8; break;
    case 8: // $59
      var $60=$newval;
      var $61=$data;
      var $62=(($61+2)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=(($60)|0) < (($64)|0);
      if ($65) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $66
      var $67=$data;
      var $68=(($67+2)|0);
      var $69=HEAPU8[($68)];
      var $70=(($69)&255);
      $newval=$70;
      __label__ = 10; break;
    case 10: // $71
      var $72=$newval;
      var $73=$data;
      var $74=(($73+3)|0);
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=(($72)|0) > (($76)|0);
      if ($77) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $78
      var $79=$data;
      var $80=(($79+3)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      $newval=$82;
      __label__ = 12; break;
    case 12: // $83
      var $84=$newval;
      var $85=$data;
      var $86=(($85+4)|0);
      var $87=HEAPU8[($86)];
      var $88=(($87)&255);
      var $89=(($84)|0)!=(($88)|0);
      if ($89) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $90
      var $91=$data;
      var $92=(($91)|0);
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      if ($94 == 0) {
        __label__ = 14; break;
      }
      else if ($94 == 2) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 14: // $95
      var $96=$newval;
      var $97=(($96) & 255);
      var $98=(($settings+1)|0);
      HEAP8[($98)]=$97;
      $changed=1;
      __label__ = 16; break;
    case 15: // $99
      var $100=$newval;
      var $101=(($100) & 255);
      var $102=(($settings+2)|0);
      HEAP8[($102)]=$101;
      $changed=1;
      __label__ = 16; break;
    case 16: // $103
      __label__ = 17; break;
    case 17: // $104
      var $105=$data;
      var $106=(($105)|0);
      var $107=HEAPU8[($106)];
      var $108=(($107)&255);
      var $109=(($108)|0)==1;
      if ($109) { __label__ = 18; break; } else { __label__ = 27; break; }
    case 18: // $110
      var $111=$menu_event;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113)|0)==182;
      if ($114) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $115
      var $116=(($settings+3)|0);
      var $117=(($116)|0);
      HEAP8[($117)]=0;
      $changed=1;
      __label__ = 26; break;
    case 20: // $118
      var $119=$menu_event;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121)|0)==176;
      if ($122) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $123
      var $124=(($settings+3)|0);
      var $125=(($124)|0);
      var $126=$data;
      var $127=(($126+6)|0);
      var $128=(($127)|0);
      var $129=_strcpy($125, $128);
      $changed=1;
      __label__ = 25; break;
    case 22: // $130
      var $131=$menu_event;
      var $132=(($131+4)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133)|0)==177;
      if ($134) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $135
      var $136=(($settings+3)|0);
      var $137=(($136)|0);
      var $138=$data;
      var $139=(($138+19)|0);
      var $140=(($139)|0);
      var $141=_strcpy($137, $140);
      $changed=1;
      __label__ = 24; break;
    case 24: // $142
      __label__ = 25; break;
    case 25: // $143
      __label__ = 26; break;
    case 26: // $144
      __label__ = 27; break;
    case 27: // $145
      var $146=$changed;
      var $147=(($146)|0)!=0;
      if ($147) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $148
      var $149=$1;
      var $150=$data;
      var $151=(($150+1)|0);
      var $152=HEAP8[($151)];
      __Z27crosshair_set_user_settingsR15running_machinehP24_crosshair_user_settings($149, $152, $settings);
      var $153=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($153, 1);
      __label__ = 29; break;
    case 29: // $154
      __label__ = 30; break;
    case 30: // $155
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14menu_crosshairR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZNK13cheat_manager5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__ZNK11simple_listI11cheat_entryE5firstEv($3);
  ;
  return $4;
}


function __ZL10menu_cheatR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      var $changed;
      var $curcheat;
      var $curcheat1;
      var $string;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$2;
      var $6=__Z17ui_menu_populatedP7ui_menu($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=$2;
      __ZL19menu_cheat_populateR15running_machineP7ui_menu($9, $10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=$2;
      var $14=__Z15ui_menu_processR15running_machineP7ui_menuj($12, $13, 2);
      $menu_event=$14;
      var $15=$menu_event;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 31; break; }
    case 3: // $17
      var $18=$menu_event;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 4; break; } else { __label__ = 31; break; }
    case 4: // $22
      $changed=0;
      __Z10popmessagePKcz(0, (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $23=$menu_event;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25;
      var $27=(($26)>>>0) < 3;
      if ($27) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $28
      var $29=$menu_event;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)==182;
      if ($32) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $33
      var $34=$1;
      var $35=__ZNK15running_machine5cheatEv($34);
      var $36=__ZNK13cheat_manager5firstEv($35);
      $curcheat=$36;
      __label__ = 7; break;
    case 7: // $37
      var $38=$curcheat;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $40
      var $41=$curcheat;
      var $42=__ZN11cheat_entry20select_default_stateEv($41);
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      $changed=1;
      __label__ = 10; break;
    case 10: // $44
      __label__ = 11; break;
    case 11: // $45
      var $46=$curcheat;
      var $47=__ZNK11cheat_entry4nextEv($46);
      $curcheat=$47;
      __label__ = 7; break;
    case 12: // $48
      __label__ = 25; break;
    case 13: // $49
      var $50=$menu_event;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$52;
      var $54=(($53)>>>0) > 2;
      if ($54) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $55
      var $56=$menu_event;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58;
      $curcheat1=$59;
      var $60=$menu_event;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      if ($62 == 182) {
        __label__ = 15; break;
      }
      else if ($62 == 185) {
        __label__ = 16; break;
      }
      else if ($62 == 176) {
        __label__ = 17; break;
      }
      else if ($62 == 177) {
        __label__ = 18; break;
      }
      else if ($62 == 184 || $62 == 174 || $62 == 175) {
        __label__ = 19; break;
      }
      else {
      __label__ = 23; break;
      }
      
    case 15: // $63
      var $64=$curcheat1;
      var $65=__ZN11cheat_entry8activateEv($64);
      var $66=(($65)&1);
      $changed=$66;
      __label__ = 23; break;
    case 16: // $67
      var $68=$curcheat1;
      var $69=__ZN11cheat_entry20select_default_stateEv($68);
      var $70=(($69)&1);
      $changed=$70;
      __label__ = 23; break;
    case 17: // $71
      var $72=$curcheat1;
      var $73=__ZN11cheat_entry21select_previous_stateEv($72);
      var $74=(($73)&1);
      $changed=$74;
      __label__ = 23; break;
    case 18: // $75
      var $76=$curcheat1;
      var $77=__ZN11cheat_entry17select_next_stateEv($76);
      var $78=(($77)&1);
      $changed=$78;
      __label__ = 23; break;
    case 19: // $79
      var $80=$curcheat1;
      var $81=__ZNK11cheat_entry7commentEv($80);
      $string=$81;
      var $82=$string;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $84
      var $85=$string;
      var $86=(($85)|0);
      var $87=HEAP8[($86)];
      var $88=(($87 << 24) >> 24);
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $90
      var $91=$string;
      __Z10popmessagePKcz(((STRING_TABLE.__str624226)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$91,tempInt));
      __label__ = 22; break;
    case 22: // $92
      __label__ = 23; break;
    case 23: // $93
      __label__ = 24; break;
    case 24: // $94
      __label__ = 25; break;
    case 25: // $95
      var $96=$menu_event;
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$98;
      var $100=(($99)|0)==2;
      if ($100) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $101
      var $102=$menu_event;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104)|0)==182;
      if ($105) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $106
      var $107=$1;
      var $108=__ZNK15running_machine5cheatEv($107);
      __ZN13cheat_manager6reloadEv($108);
      var $109=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($109, 2);
      __Z10popmessagePKcz(((STRING_TABLE.__str634227)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 28; break;
    case 28: // $110
      var $111=$changed;
      var $112=(($111) & 1);
      if ($112) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $113
      var $114=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($114, 2);
      __label__ = 30; break;
    case 30: // $115
      __label__ = 31; break;
    case 31: // $116
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10menu_cheatR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL16menu_memory_cardR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menu_event;
      var $cardnum;
      var $item;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($8, 4, 0);
      $4=$9;
      __label__ = 2; break;
    case 2: // $10
      var $11=$4;
      var $12=$11;
      $cardnum=$12;
      var $13=$2;
      var $14=__Z17ui_menu_populatedP7ui_menu($13);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$1;
      var $18=$2;
      var $19=$cardnum;
      var $20=HEAP32[(($19)>>2)];
      __ZL25menu_memory_card_populateR15running_machineP7ui_menui($17, $18, $20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$1;
      var $23=$2;
      var $24=__Z15ui_menu_processR15running_machineP7ui_menuj($22, $23, 2);
      $menu_event=$24;
      var $25=$menu_event;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 25; break; }
    case 5: // $27
      var $28=$menu_event;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 25; break; }
    case 6: // $32
      var $33=$menu_event;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35;
      $item=$36;
      var $37=$menu_event;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==182;
      if ($40) { __label__ = 7; break; } else { __label__ = 18; break; }
    case 7: // $41
      var $42=$item;
      if ($42 == 2) {
        __label__ = 8; break;
      }
      else if ($42 == 3) {
        __label__ = 12; break;
      }
      else if ($42 == 4) {
        __label__ = 13; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 8: // $43
      var $44=$2;
      var $45=__ZNK7ui_menu7machineEv($44);
      var $46=$cardnum;
      var $47=HEAP32[(($46)>>2)];
      var $48=__Z14memcard_insertR15running_machinei($45, $47);
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $50
      __Z10popmessagePKcz(((STRING_TABLE.__str524216)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $51=$2;
      var $52=__ZNK7ui_menu7machineEv($51);
      __Z19ui_menu_stack_resetR15running_machine($52);
      __label__ = 11; break;
    case 10: // $53
      __Z10popmessagePKcz(((STRING_TABLE.__str534217)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 11; break;
    case 11: // $54
      __label__ = 17; break;
    case 12: // $55
      var $56=$2;
      var $57=__ZNK7ui_menu7machineEv($56);
      __Z13memcard_ejectR15running_machine($57);
      __Z10popmessagePKcz(((STRING_TABLE.__str544218)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 17; break;
    case 13: // $58
      var $59=$2;
      var $60=__ZNK7ui_menu7machineEv($59);
      var $61=$cardnum;
      var $62=HEAP32[(($61)>>2)];
      var $63=__Z14memcard_createR15running_machineii($60, $62, 0);
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $65
      __Z10popmessagePKcz(((STRING_TABLE.__str554219)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 15: // $66
      __Z10popmessagePKcz(((STRING_TABLE.__str564220)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 16: // $67
      __label__ = 17; break;
    case 17: // $68
      __label__ = 24; break;
    case 18: // $69
      var $70=$item;
      var $71=(($70)|0)==1;
      if ($71) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $72
      var $73=$menu_event;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      if ($75 == 176) {
        __label__ = 20; break;
      }
      else if ($75 == 177) {
        __label__ = 21; break;
      }
      else {
      __label__ = 22; break;
      }
      
    case 20: // $76
      var $77=$cardnum;
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78-1)|0);
      HEAP32[(($77)>>2)]=$79;
      var $80=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($80, 2);
      __label__ = 22; break;
    case 21: // $81
      var $82=$cardnum;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+1)|0);
      HEAP32[(($82)>>2)]=$84;
      var $85=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($85, 2);
      __label__ = 22; break;
    case 22: // $86
      __label__ = 23; break;
    case 23: // $87
      __label__ = 24; break;
    case 24: // $88
      __label__ = 25; break;
    case 25: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16menu_memory_cardR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL25menu_memory_card_populateR15running_machineP7ui_menui($machine, $menu, $cardnum) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tempstring=__stackBase__;
      var $flags;
      $1=$machine;
      $2=$menu;
      $3=$cardnum;
      $flags=0;
      var $4=(($tempstring)|0);
      var $5=$3;
      var $6=_sprintf($4, ((STRING_TABLE.__str574221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$5,tempInt));
      var $7=$3;
      var $8=(($7)|0) > 0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$flags;
      var $11=$10 | 1;
      $flags=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$3;
      var $14=(($13)|0) < 1000;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$flags;
      var $17=$16 | 2;
      $flags=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$2;
      var $20=(($tempstring)|0);
      var $21=$flags;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($19, ((STRING_TABLE.__str584222)|0), $20, $21, 1);
      var $22=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($22, ((STRING_TABLE.__str594223)|0), 0, 0, 2);
      var $23=$1;
      var $24=__Z15memcard_presentR15running_machine($23);
      var $25=(($24)|0)!=-1;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($27, ((STRING_TABLE.__str604224)|0), 0, 0, 3);
      __label__ = 6; break;
    case 6: // $28
      var $29=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($29, ((STRING_TABLE.__str614225)|0), 0, 0, 4);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11cheat_entry7commentEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+72)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK14render_manager12first_targetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__ZNK11simple_listI13render_targetE5firstEv($3);
  ;
  return $4;
}


function __ZL19menu_cheat_populateR15running_machineP7ui_menu($machine, $menu) {
  var __stackBase__  = STACKTOP; STACKTOP += 132; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $text=__stackBase__;
      var $subtext=__stackBase__+64;
      var $3;
      var $4;
      var $curcheat;
      var $flags=__stackBase__+128;
      $1=$machine;
      $2=$menu;
      __ZN7astringC1Ev($text);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $5
      var $6=$1;
      var $7=(function() { try { __THREW__ = false; return __ZNK15running_machine5cheatEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 13; break; };
    case 2: // $8
      var $9=(function() { try { __THREW__ = false; return __ZNK13cheat_manager5firstEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; };
    case 3: // $10
      $curcheat=$9;
      __label__ = 4; break;
    case 4: // $11
      var $12=$curcheat;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $14
      var $15=$curcheat;
      (function() { try { __THREW__ = false; return __ZN11cheat_entry9menu_textER7astringS1_Rj($15, $text, $subtext, $flags) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $16
      var $17=$2;
      var $18=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 13; break; };
    case 8: // $21
      var $22=HEAP32[(($flags)>>2)];
      var $23=$curcheat;
      var $24=$23;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($17, $18, $20, $22, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $25
      __label__ = 10; break;
    case 10: // $26
      var $27=$curcheat;
      var $28=(function() { try { __THREW__ = false; return __ZNK11cheat_entry4nextEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $29
      $curcheat=$28;
      __label__ = 4; break;
    case 12: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $3=$32;
      var $33=$31.f1;
      $4=$33;
      __label__ = 20; break;
    case 13: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $3=$36;
      var $37=$35.f1;
      $4=$37;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 14: // $38
      var $39=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($39, ((STRING_TABLE.__str144178)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 13; break; }
    case 15: // $40
      var $41=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($41, ((STRING_TABLE.__str644228)|0), 0, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 16: // $42
      var $43=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($43, ((STRING_TABLE.__str654229)|0), 0, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 13; break; }
    case 17: // $44
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 12; break; }
    case 18: // $45
      FUNCTION_TABLE[__ZN7astringD1Ev]($text);
      STACKTOP = __stackBase__;
      return;
    case 19: // $46
      __label__ = 20; break;
    case 20: // $47
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $48
      __label__ = 22; break;
    case 22: // $49
      var $50=$3;
      var $51=$3;
      var $52=$4;
      var $53=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $51, tempValue);
      var $54=($53.f1 = $52, $53);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19menu_cheat_populateR15running_machineP7ui_menu["X"]=1;

function __ZL23menu_crosshair_populateR15running_machineP7ui_menu($machine, $menu) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $settings=__stackBase__;
      var $data;
      var $temp_text=__stackBase__+16;
      var $player;
      var $use_auto;
      var $flags;
      var $path=__stackBase__+32;
      var $dir;
      var $using_default;
      var $finished;
      var $found;
      var $3;
      var $4;
      var $length;
      $1=$machine;
      $2=$menu;
      $use_auto=0;
      $flags=0;
      $player=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$player;
      var $7=(($6)|0) < 8;
      if ($7) { __label__ = 2; break; } else { __label__ = 56; break; }
    case 2: // $8
      var $9=$1;
      var $10=$player;
      var $11=(($10) & 255);
      __Z27crosshair_get_user_settingsR15running_machinehP24_crosshair_user_settings($9, $11, $settings);
      var $12=(($settings)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 54; break; }
    case 3: // $15
      var $16=(($settings+1)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($18)|0)==2;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      $use_auto=1;
      __label__ = 5; break;
    case 5: // $21
      var $22=$2;
      var $23=__Z18ui_menu_pool_allocP7ui_menuj($22, 32);
      var $24=$23;
      $data=$24;
      var $25=$data;
      var $26=(($25)|0);
      HEAP8[($26)]=0;
      var $27=$player;
      var $28=(($27) & 255);
      var $29=$data;
      var $30=(($29+1)|0);
      HEAP8[($30)]=$28;
      var $31=$data;
      var $32=(($31+2)|0);
      HEAP8[($32)]=0;
      var $33=$data;
      var $34=(($33+3)|0);
      HEAP8[($34)]=2;
      var $35=$data;
      var $36=(($35+5)|0);
      HEAP8[($36)]=2;
      var $37=(($settings+1)|0);
      var $38=HEAP8[($37)];
      var $39=$data;
      var $40=(($39+4)|0);
      HEAP8[($40)]=$38;
      var $41=$data;
      var $42=(($41+4)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$data;
      var $46=(($45+2)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=(($44)|0) > (($48)|0);
      if ($49) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $50
      var $51=$flags;
      var $52=$51 | 1;
      $flags=$52;
      __label__ = 7; break;
    case 7: // $53
      var $54=$data;
      var $55=(($54+4)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$data;
      var $59=(($58+3)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=(($57)|0) < (($61)|0);
      if ($62) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $63
      var $64=$flags;
      var $65=$64 | 2;
      $flags=$65;
      __label__ = 9; break;
    case 9: // $66
      var $67=(($temp_text)|0);
      var $68=$player;
      var $69=(($68+1)|0);
      var $70=_sprintf($67, ((STRING_TABLE.__str704234)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$69,tempInt));
      var $71=$2;
      var $72=(($temp_text)|0);
      var $73=(($settings+1)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=((__ZZL23menu_crosshair_populateR15running_machineP7ui_menuE8vis_text+($75<<2))|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$flags;
      var $79=$data;
      var $80=$79;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($71, $72, $77, $78, $80);
      var $81=$2;
      var $82=__Z18ui_menu_pool_allocP7ui_menuj($81, 32);
      var $83=$82;
      $data=$83;
      var $84=$data;
      var $85=(($84)|0);
      HEAP8[($85)]=1;
      var $86=$player;
      var $87=(($86) & 255);
      var $88=$data;
      var $89=(($88+1)|0);
      HEAP8[($89)]=$87;
      var $90=$data;
      var $91=(($90+6)|0);
      var $92=(($91)|0);
      HEAP8[($92)]=0;
      var $93=$1;
      var $94=__ZNK15running_machine7optionsEv($93);
      var $95=__ZNK11emu_options14crosshair_pathEv($94);
      FUNCTION_TABLE[__ZN15file_enumeratorC1EPKc]($path, $95);
      $using_default=0;
      $finished=0;
      $found=0;
      var $96=(($settings+3)|0);
      var $97=(($96)|0);
      var $98=(function() { try { __THREW__ = false; return _strlen($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $99
      var $100=(($98)|0)==0;
      if ($100) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $101
      $using_default=1;
      __label__ = 13; break;
    case 12: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $3=$104;
      var $105=$103.f1;
      $4=$105;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15file_enumeratorD1Ev]($path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 64; break; }
    case 13: // $106
      __label__ = 14; break;
    case 14: // $107
      var $108=(function() { try { __THREW__ = false; return __ZN15file_enumerator4nextEv($path) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; };
    case 15: // $109
      $dir=$108;
      var $110=(($108)|0)!=0;
      if ($110) { __label__ = 16; break; } else { var $116 = 0;__label__ = 17; break; }
    case 16: // $111
      var $112=$finished;
      var $113=(($112)|0)!=0;
      var $114=$113 ^ 1;
      var $116 = $114;__label__ = 17; break;
    case 17: // $115
      var $116;
      if ($116) { __label__ = 18; break; } else { __label__ = 40; break; }
    case 18: // $117
      var $118=$dir;
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(function() { try { __THREW__ = false; return _strlen($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 12; break; };
    case 19: // $122
      $length=$121;
      var $123=$length;
      var $124=(($123)|0) > 4;
      if ($124) { __label__ = 20; break; } else { __label__ = 39; break; }
    case 20: // $125
      var $126=$length;
      var $127=(($126)|0) <= 16;
      if ($127) { __label__ = 21; break; } else { __label__ = 39; break; }
    case 21: // $128
      var $129=$length;
      var $130=(($129-4)|0);
      var $131=$dir;
      var $132=(($131)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+$130)|0);
      var $135=HEAP8[($134)];
      var $136=(($135 << 24) >> 24);
      var $137=(($136)|0)==46;
      if ($137) { __label__ = 22; break; } else { __label__ = 39; break; }
    case 22: // $138
      var $139=$length;
      var $140=(($139-3)|0);
      var $141=$dir;
      var $142=(($141)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+$140)|0);
      var $145=HEAPU8[($144)];
      var $146=(($145)&255);
      var $147=(function() { try { __THREW__ = false; return _tolower($146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 12; break; };
    case 23: // $148
      var $149=(($147)|0)==112;
      if ($149) { __label__ = 24; break; } else { __label__ = 39; break; }
    case 24: // $150
      var $151=$length;
      var $152=(($151-2)|0);
      var $153=$dir;
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+$152)|0);
      var $157=HEAPU8[($156)];
      var $158=(($157)&255);
      var $159=(function() { try { __THREW__ = false; return _tolower($158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 12; break; };
    case 25: // $160
      var $161=(($159)|0)==110;
      if ($161) { __label__ = 26; break; } else { __label__ = 39; break; }
    case 26: // $162
      var $163=$length;
      var $164=(($163-1)|0);
      var $165=$dir;
      var $166=(($165)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167+$164)|0);
      var $169=HEAPU8[($168)];
      var $170=(($169)&255);
      var $171=(function() { try { __THREW__ = false; return _tolower($170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 12; break; };
    case 27: // $172
      var $173=(($171)|0)==103;
      if ($173) { __label__ = 28; break; } else { __label__ = 39; break; }
    case 28: // $174
      var $175=$length;
      var $176=(($175-4)|0);
      $length=$176;
      var $177=$found;
      var $178=(($177)|0)!=0;
      if ($178) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $179
      var $180=$using_default;
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $182
      var $183=$data;
      var $184=(($183+19)|0);
      var $185=(($184)|0);
      var $186=$dir;
      var $187=(($186)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$length;
      var $190=(function() { try { __THREW__ = false; return _strncpy($185, $188, $189) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 12; break; };
    case 31: // $191
      var $192=$length;
      var $193=$data;
      var $194=(($193+19)|0);
      var $195=(($194+$192)|0);
      HEAP8[($195)]=0;
      $finished=1;
      __label__ = 38; break;
    case 32: // $196
      var $197=$dir;
      var $198=(($197)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=(($settings+3)|0);
      var $201=(($200)|0);
      var $202=$length;
      var $203=(function() { try { __THREW__ = false; return _strncmp($199, $201, $202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 12; break; };
    case 33: // $204
      var $205=(($203)|0)!=0;
      if ($205) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $206
      $found=1;
      __label__ = 37; break;
    case 35: // $207
      var $208=$data;
      var $209=(($208+6)|0);
      var $210=(($209)|0);
      var $211=$dir;
      var $212=(($211)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=$length;
      var $215=(function() { try { __THREW__ = false; return _strncpy($210, $213, $214) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 12; break; };
    case 36: // $216
      var $217=$length;
      var $218=$data;
      var $219=(($218+6)|0);
      var $220=(($219+$217)|0);
      HEAP8[($220)]=0;
      __label__ = 37; break;
    case 37: // $221
      __label__ = 38; break;
    case 38: // $222
      __label__ = 39; break;
    case 39: // $223
      __label__ = 14; break;
    case 40: // $224
      var $225=$found;
      var $226=(($225)|0)!=0;
      if ($226) { __label__ = 43; break; } else { __label__ = 41; break; }
    case 41: // $227
      var $228=$using_default;
      var $229=(($228)|0)!=0;
      if ($229) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $230
      var $231=$data;
      var $232=(($231+19)|0);
      var $233=(($232)|0);
      HEAP8[($233)]=0;
      $finished=1;
      __label__ = 43; break;
    case 43: // $234
      $flags=0;
      var $235=$finished;
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $237
      var $238=$flags;
      var $239=$238 | 2;
      $flags=$239;
      __label__ = 45; break;
    case 45: // $240
      var $241=$found;
      var $242=(($241)|0)!=0;
      if ($242) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $243
      var $244=$flags;
      var $245=$244 | 1;
      $flags=$245;
      __label__ = 47; break;
    case 47: // $246
      var $247=(($temp_text)|0);
      var $248=$player;
      var $249=(($248+1)|0);
      var $250=(function() { try { __THREW__ = false; return _sprintf($247, ((STRING_TABLE.__str714235)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$249,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 12; break; };
    case 48: // $251
      var $252=$2;
      var $253=(($temp_text)|0);
      var $254=$using_default;
      var $255=(($254)|0)!=0;
      if ($255) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $256
      var $261 = ((STRING_TABLE.__str724236)|0);__label__ = 51; break;
    case 50: // $257
      var $258=(($settings+3)|0);
      var $259=(($258)|0);
      var $261 = $259;__label__ = 51; break;
    case 51: // $260
      var $261;
      var $262=$flags;
      var $263=$data;
      var $264=$263;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($252, $253, $261, $262, $264) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 12; break; }
    case 52: // $265
      FUNCTION_TABLE[__ZN15file_enumeratorD1Ev]($path);
      __label__ = 54; break;
    case 53: // $266
      __label__ = 63; break;
    case 54: // $267
      __label__ = 55; break;
    case 55: // $268
      var $269=$player;
      var $270=(($269+1)|0);
      $player=$270;
      __label__ = 1; break;
    case 56: // $271
      var $272=$use_auto;
      var $273=(($272 << 24) >> 24)!=0;
      if ($273) { __label__ = 57; break; } else { __label__ = 62; break; }
    case 57: // $274
      var $275=$1;
      __Z27crosshair_get_user_settingsR15running_machinehP24_crosshair_user_settings($275, 0, $settings);
      var $276=$2;
      var $277=__Z18ui_menu_pool_allocP7ui_menuj($276, 32);
      var $278=$277;
      $data=$278;
      var $279=$data;
      var $280=(($279)|0);
      HEAP8[($280)]=2;
      var $281=$data;
      var $282=(($281+2)|0);
      HEAP8[($282)]=0;
      var $283=$data;
      var $284=(($283+3)|0);
      HEAP8[($284)]=50;
      var $285=$data;
      var $286=(($285+5)|0);
      HEAP8[($286)]=15;
      var $287=(($settings+2)|0);
      var $288=HEAP8[($287)];
      var $289=$data;
      var $290=(($289+4)|0);
      HEAP8[($290)]=$288;
      var $291=$data;
      var $292=(($291+4)|0);
      var $293=HEAPU8[($292)];
      var $294=(($293)&255);
      var $295=$data;
      var $296=(($295+2)|0);
      var $297=HEAPU8[($296)];
      var $298=(($297)&255);
      var $299=(($294)|0) > (($298)|0);
      if ($299) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $300
      var $301=$flags;
      var $302=$301 | 1;
      $flags=$302;
      __label__ = 59; break;
    case 59: // $303
      var $304=$data;
      var $305=(($304+4)|0);
      var $306=HEAPU8[($305)];
      var $307=(($306)&255);
      var $308=$data;
      var $309=(($308+3)|0);
      var $310=HEAPU8[($309)];
      var $311=(($310)&255);
      var $312=(($307)|0) < (($311)|0);
      if ($312) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $313
      var $314=$flags;
      var $315=$314 | 2;
      $flags=$315;
      __label__ = 61; break;
    case 61: // $316
      var $317=(($temp_text)|0);
      var $318=(($settings+2)|0);
      var $319=HEAPU8[($318)];
      var $320=(($319)&255);
      var $321=_sprintf($317, ((STRING_TABLE.__str574221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$320,tempInt));
      var $322=$2;
      var $323=(($temp_text)|0);
      var $324=$flags;
      var $325=$data;
      var $326=$325;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($322, ((STRING_TABLE.__str734237)|0), $323, $324, $326);
      __label__ = 62; break;
    case 62: // $327
      STACKTOP = __stackBase__;
      return;
    case 63: // $328
      var $329=$3;
      var $330=$3;
      var $331=$4;
      var $332=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $330, tempValue);
      var $333=($332.f1 = $331, $332);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 64: // $334
      var $335=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23menu_crosshair_populateR15running_machineP7ui_menu["X"]=1;

function __ZL27menu_video_options_populateR15running_machineP7ui_menuP13render_target($machine, $menu, $target) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $subtext;
      var $tempstring=__stackBase__;
      var $viewnum;
      var $enabled;
      var $name;
      var $4;
      var $5;
      $1=$machine;
      $2=$menu;
      $3=$target;
      $subtext=((__str24166)|0);
      __ZN7astringC1Ev($tempstring);
      $viewnum=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$3;
      var $8=$viewnum;
      var $9=(function() { try { __THREW__ = false; return __ZN13render_target9view_nameEi($7, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $10
      $name=$9;
      var $11=$name;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 11; break;
    case 4: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $4=$16;
      var $17=$15.f1;
      $5=$17;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 5: // $18
      var $19=$name;
      var $20=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tempstring, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 4; break; };
    case 6: // $21
      var $22=(function() { try { __THREW__ = false; return __ZN7astring7replaceEiPKcS1_($20, 0, ((STRING_TABLE.__str754239)|0), ((STRING_TABLE.__str314195)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 7: // $23
      var $24=$2;
      var $25=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $26
      var $27=$viewnum;
      var $28=(($27-2147483641)|0);
      var $29=$28;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($24, $25, 0, 0, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; }
    case 9: // $30
      __label__ = 10; break;
    case 10: // $31
      var $32=$viewnum;
      var $33=(($32+1)|0);
      $viewnum=$33;
      __label__ = 1; break;
    case 11: // $34
      var $35=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($35, ((STRING_TABLE.__str144178)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 4; break; }
    case 12: // $36
      var $37=$3;
      var $38=(function() { try { __THREW__ = false; return __ZNK13render_target11orientationEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 4; break; };
    case 13: // $39
      if ($38 == 0) {
        __label__ = 14; break;
      }
      else if ($38 == 5) {
        __label__ = 15; break;
      }
      else if ($38 == 3) {
        __label__ = 16; break;
      }
      else if ($38 == 6) {
        __label__ = 17; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 14: // $40
      $subtext=((STRING_TABLE.__str764240)|0);
      __label__ = 18; break;
    case 15: // $41
      $subtext=((STRING_TABLE.__str774241)|0);
      __label__ = 18; break;
    case 16: // $42
      $subtext=((STRING_TABLE.__str784242)|0);
      __label__ = 18; break;
    case 17: // $43
      $subtext=((STRING_TABLE.__str794243)|0);
      __label__ = 18; break;
    case 18: // $44
      var $45=$2;
      var $46=$subtext;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($45, ((STRING_TABLE.__str804244)|0), $46, 3, -2147483648) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 4; break; }
    case 19: // $47
      var $48=$3;
      var $49=(function() { try { __THREW__ = false; return __ZNK13render_target17backdrops_enabledEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 4; break; };
    case 20: // $50
      var $51=(($49)&1);
      $enabled=$51;
      var $52=$2;
      var $53=$enabled;
      var $54=(($53)|0)!=0;
      var $55=$54 ? (((STRING_TABLE.__str824246)|0)) : (((STRING_TABLE.__str834247)|0));
      var $56=$enabled;
      var $57=(($56)|0)!=0;
      var $58=$57 ? 1 : 2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($52, ((STRING_TABLE.__str814245)|0), $55, $58, -2147483647) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 4; break; }
    case 21: // $59
      var $60=$3;
      var $61=(function() { try { __THREW__ = false; return __ZNK13render_target16overlays_enabledEv($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 4; break; };
    case 22: // $62
      var $63=(($61)&1);
      $enabled=$63;
      var $64=$2;
      var $65=$enabled;
      var $66=(($65)|0)!=0;
      var $67=$66 ? (((STRING_TABLE.__str824246)|0)) : (((STRING_TABLE.__str834247)|0));
      var $68=$enabled;
      var $69=(($68)|0)!=0;
      var $70=$69 ? 1 : 2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($64, ((STRING_TABLE.__str844248)|0), $67, $70, -2147483646) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 4; break; }
    case 23: // $71
      var $72=$3;
      var $73=(function() { try { __THREW__ = false; return __ZNK13render_target14bezels_enabledEv($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 4; break; };
    case 24: // $74
      var $75=(($73)&1);
      $enabled=$75;
      var $76=$2;
      var $77=$enabled;
      var $78=(($77)|0)!=0;
      var $79=$78 ? (((STRING_TABLE.__str824246)|0)) : (((STRING_TABLE.__str834247)|0));
      var $80=$enabled;
      var $81=(($80)|0)!=0;
      var $82=$81 ? 1 : 2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($76, ((STRING_TABLE.__str854249)|0), $79, $82, -2147483645) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 4; break; }
    case 25: // $83
      var $84=$3;
      var $85=(function() { try { __THREW__ = false; return __ZNK13render_target15cpanels_enabledEv($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 4; break; };
    case 26: // $86
      var $87=(($85)&1);
      $enabled=$87;
      var $88=$2;
      var $89=$enabled;
      var $90=(($89)|0)!=0;
      var $91=$90 ? (((STRING_TABLE.__str824246)|0)) : (((STRING_TABLE.__str834247)|0));
      var $92=$enabled;
      var $93=(($92)|0)!=0;
      var $94=$93 ? 1 : 2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($88, ((STRING_TABLE.__str864250)|0), $91, $94, -2147483644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 4; break; }
    case 27: // $95
      var $96=$3;
      var $97=(function() { try { __THREW__ = false; return __ZNK13render_target16marquees_enabledEv($96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 4; break; };
    case 28: // $98
      var $99=(($97)&1);
      $enabled=$99;
      var $100=$2;
      var $101=$enabled;
      var $102=(($101)|0)!=0;
      var $103=$102 ? (((STRING_TABLE.__str824246)|0)) : (((STRING_TABLE.__str834247)|0));
      var $104=$enabled;
      var $105=(($104)|0)!=0;
      var $106=$105 ? 1 : 2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($100, ((STRING_TABLE.__str874251)|0), $103, $106, -2147483643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 4; break; }
    case 29: // $107
      var $108=$3;
      var $109=(function() { try { __THREW__ = false; return __ZNK13render_target14zoom_to_screenEv($108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 4; break; };
    case 30: // $110
      var $111=(($109)&1);
      $enabled=$111;
      var $112=$2;
      var $113=$enabled;
      var $114=(($113)|0)!=0;
      var $115=$114 ? (((STRING_TABLE.__str894253)|0)) : (((STRING_TABLE.__str904254)|0));
      var $116=$enabled;
      var $117=(($116)|0)!=0;
      var $118=$117 ? 2 : 1;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($112, ((STRING_TABLE.__str884252)|0), $115, $118, -2147483642) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; }
    case 31: // $119
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 32: // $120
      __label__ = 33; break;
    case 33: // $121
      var $122=$4;
      var $123=$4;
      var $124=$5;
      var $125=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $123, tempValue);
      var $126=($125.f1 = $124, $125);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 34: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27menu_video_options_populateR15running_machineP7ui_menuP13render_target["X"]=1;

function __ZL22orientation_swap_flipsi4284($orientation) {
  ;
  var __label__;

  var $1;
  $1=$orientation;
  var $2=$1;
  var $3=$2 & 4;
  var $4=$1;
  var $5=$4 & 1;
  var $6=(($5)|0)!=0;
  var $7=$6 ? 2 : 0;
  var $8=$3 | $7;
  var $9=$1;
  var $10=$9 & 2;
  var $11=(($10)|0)!=0;
  var $12=$11 ? 1 : 0;
  var $13=$8 | $12;
  ;
  return $13;
}


function __ZL15orientation_addii4283($orientation1, $orientation2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$orientation1;
      $3=$orientation2;
      var $4=$3;
      var $5=$4 & 4;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=$3;
      var $10=$8 ^ $9;
      $1=$10;
      __label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $13=__ZL22orientation_swap_flipsi4284($12);
      var $14=$3;
      var $15=$13 ^ $14;
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13render_target17backdrops_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+312)|0);
  var $4=__ZNK19render_layer_config17backdrops_enabledEv($3);
  ;
  return $4;
}


function __ZNK13render_target16overlays_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+312)|0);
  var $4=__ZNK19render_layer_config16overlays_enabledEv($3);
  ;
  return $4;
}


function __ZNK13render_target14bezels_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+312)|0);
  var $4=__ZNK19render_layer_config14bezels_enabledEv($3);
  ;
  return $4;
}


function __ZNK13render_target15cpanels_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+312)|0);
  var $4=__ZNK19render_layer_config15cpanels_enabledEv($3);
  ;
  return $4;
}


function __ZNK13render_target16marquees_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+312)|0);
  var $4=__ZNK19render_layer_config16marquees_enabledEv($3);
  ;
  return $4;
}


function __ZNK13render_target14zoom_to_screenEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+312)|0);
  var $4=__ZNK19render_layer_config14zoom_to_screenEv($3);
  ;
  return $4;
}


function __ZL27menu_video_targets_populateR15running_machineP7ui_menu($machine, $menu) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $targetnum;
      var $target;
      var $buffer=__stackBase__;
      $1=$machine;
      $2=$menu;
      $targetnum=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      var $5=__ZNK15running_machine6renderEv($4);
      var $6=$targetnum;
      var $7=__ZNK14render_manager15target_by_indexEi($5, $6);
      $target=$7;
      var $8=$target;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      __label__ = 5; break;
    case 3: // $11
      var $12=(($buffer)|0);
      var $13=$targetnum;
      var $14=_sprintf($12, ((STRING_TABLE.__str914255)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$13,tempInt));
      var $15=$2;
      var $16=(($buffer)|0);
      var $17=$target;
      var $18=$17;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($15, $16, 0, 0, $18);
      __label__ = 4; break;
    case 4: // $19
      var $20=$targetnum;
      var $21=(($20+1)|0);
      $targetnum=$21;
      __label__ = 1; break;
    case 5: // $22
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL26menu_slot_devices_populateR15running_machineP7ui_menuPv($machine, $menu, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $slot=__stackBase__;
      var $gotone;
      var $title;
      $1=$machine;
      $2=$menu;
      $3=$state;
      HEAP32[(($slot)>>2)]=0;
      var $4=$1;
      var $5=__ZNK15running_machine10devicelistEv($4);
      var $6=__ZNK11device_list5firstI21device_slot_interfaceEEbRPT_($5, $slot);
      var $7=(($6)&1);
      $gotone=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$gotone;
      var $10=(($9) & 1);
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$1;
      var $13=HEAP32[(($slot)>>2)];
      var $14=__Z18ui_get_slot_deviceR15running_machineP21device_slot_interface($12, $13);
      $title=$14;
      var $15=$2;
      var $16=HEAP32[(($slot)>>2)];
      var $17=$16;
      var $18=__ZN16device_interface6deviceEv($17);
      var $19=__ZNK8device_t3tagEv($18);
      var $20=$title;
      var $21=_strcmp($20, ((__str24166)|0));
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $27 = ((STRING_TABLE.__str954259)|0);__label__ = 5; break;
    case 4: // $24
      var $25=$title;
      var $27 = $25;__label__ = 5; break;
    case 5: // $26
      var $27;
      var $28=HEAP32[(($slot)>>2)];
      var $29=$28;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($15, $19, $27, 3, $29);
      __label__ = 6; break;
    case 6: // $30
      var $31=HEAP32[(($slot)>>2)];
      var $32=$31;
      var $33=__ZNK16device_interface4nextI21device_slot_interfaceEEbRPT_($32, $slot);
      var $34=(($33)&1);
      $gotone=$34;
      __label__ = 1; break;
    case 7: // $35
      var $36=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($36, ((STRING_TABLE.__str144178)|0), 0, 0, 0);
      var $37=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($37, ((STRING_TABLE.__str964260)|0), 0, 0, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26menu_slot_devices_populateR15running_machineP7ui_menuPv["X"]=1;

function __ZL20menu_settings_commonR15running_machineP7ui_menuPvj($machine, $menu, $state, $type) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menustate;
      var $menu_event;
      var $field;
      var $settings=__stackBase__;
      var $changed;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$type;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($8, 4, 0);
      $3=$9;
      __label__ = 2; break;
    case 2: // $10
      var $11=$3;
      var $12=$11;
      $menustate=$12;
      var $13=$2;
      var $14=__Z17ui_menu_populatedP7ui_menu($13);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$1;
      var $18=$2;
      var $19=$menustate;
      var $20=$4;
      __ZL22menu_settings_populateR15running_machineP7ui_menuP20_settings_menu_statej($17, $18, $19, $20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$1;
      var $23=$2;
      var $24=__Z15ui_menu_processR15running_machineP7ui_menuj($22, $23, 0);
      $menu_event=$24;
      var $25=$menu_event;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $27
      var $28=$menu_event;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $32
      var $33=$menu_event;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35;
      $field=$36;
      __ZN26_input_field_user_settingsC1Ev($settings);
      $changed=0;
      var $37=$menu_event;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      if ($39 == 182) {
        __label__ = 7; break;
      }
      else if ($39 == 176) {
        __label__ = 8; break;
      }
      else if ($39 == 177) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 7: // $40
      var $41=$field;
      __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($41, $settings);
      var $42=$field;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($settings)|0);
      HEAP32[(($45)>>2)]=$44;
      var $46=$field;
      __Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings($46, $settings);
      $changed=1;
      __label__ = 10; break;
    case 8: // $47
      var $48=$field;
      __Z35input_field_select_previous_settingPK18input_field_config($48);
      $changed=1;
      __label__ = 10; break;
    case 9: // $49
      var $50=$field;
      __Z31input_field_select_next_settingPK18input_field_config($50);
      $changed=1;
      __label__ = 10; break;
    case 10: // $51
      var $52=$changed;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      var $55=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($55, 2);
      __label__ = 12; break;
    case 12: // $56
      __label__ = 13; break;
    case 13: // $57
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20menu_settings_commonR15running_machineP7ui_menuPvj["X"]=1;

function __ZL25menu_bookkeeping_populateR15running_machineP7ui_menuP8attotime($machine, $menu, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tickets;
      var $tempstring=__stackBase__;
      var $ctrnum;
      var $4;
      var $5;
      var $count;
      $1=$machine;
      $2=$menu;
      $3=$curtime;
      var $6=$1;
      var $7=__Z21get_dispensed_ticketsR15running_machine($6);
      $tickets=$7;
      __ZN7astringC1Ev($tempstring);
      var $8=$3;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0) >= 3600;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=$3;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(((($15)|0)/3600)|0);
      var $17=$3;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(((($19)|0)/60)|0);
      var $21=(($20)|0)%60;
      var $22=$3;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)%60;
      var $26=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($tempstring, ((STRING_TABLE.__str974261)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,HEAP32[((tempInt+4)>>2)]=$21,HEAP32[((tempInt+8)>>2)]=$25,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $27
      __label__ = 6; break;
    case 3: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $4=$30;
      var $31=$29.f1;
      $5=$31;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 4: // $32
      var $33=$3;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(((($35)|0)/60)|0);
      var $37=(($36)|0)%60;
      var $38=$3;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)%60;
      var $42=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($tempstring, ((STRING_TABLE.__str984262)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,HEAP32[((tempInt+4)>>2)]=$41,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 3; break; };
    case 5: // $43
      __label__ = 6; break;
    case 6: // $44
      var $45=$tickets;
      var $46=(($45)|0) > 0;
      if ($46) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $47
      var $48=$tickets;
      var $49=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($tempstring, ((STRING_TABLE.__str994263)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$48,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 3; break; };
    case 8: // $50
      __label__ = 9; break;
    case 9: // $51
      $ctrnum=0;
      __label__ = 10; break;
    case 10: // $52
      var $53=$ctrnum;
      var $54=(($53)|0) < 8;
      if ($54) { __label__ = 11; break; } else { __label__ = 25; break; }
    case 11: // $55
      var $56=$1;
      var $57=$ctrnum;
      var $58=(function() { try { __THREW__ = false; return __Z22coin_counter_get_countR15running_machinei($56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 3; break; };
    case 12: // $59
      $count=$58;
      var $60=$ctrnum;
      var $61=(($60+65)|0);
      var $62=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($tempstring, ((STRING_TABLE.__str1004264)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$61,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 3; break; };
    case 13: // $63
      var $64=$count;
      var $65=(($64)|0)==0;
      if ($65) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $66
      var $67=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tempstring, ((STRING_TABLE.__str1014265)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 3; break; };
    case 15: // $68
      __label__ = 18; break;
    case 16: // $69
      var $70=$count;
      var $71=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($tempstring, ((STRING_TABLE.__str574221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$70,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 3; break; };
    case 17: // $72
      __label__ = 18; break;
    case 18: // $73
      var $74=$1;
      var $75=$ctrnum;
      var $76=(function() { try { __THREW__ = false; return __Z22coin_lockout_get_stateR15running_machinei($74, $75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 3; break; };
    case 19: // $77
      var $78=(($76)|0)!=0;
      if ($78) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $79
      var $80=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tempstring, ((STRING_TABLE.__str1024266)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 3; break; };
    case 21: // $81
      __label__ = 22; break;
    case 22: // $82
      var $83=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tempstring, ((STRING_TABLE.__str1034267)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 3; break; };
    case 23: // $84
      __label__ = 24; break;
    case 24: // $85
      var $86=$ctrnum;
      var $87=(($86+1)|0);
      $ctrnum=$87;
      __label__ = 10; break;
    case 25: // $88
      var $89=$2;
      var $90=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 3; break; };
    case 26: // $91
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($89, $90, 0, 8, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 3; break; }
    case 27: // $92
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 28: // $93
      __label__ = 29; break;
    case 29: // $94
      var $95=$4;
      var $96=$4;
      var $97=$5;
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25menu_bookkeeping_populateR15running_machineP7ui_menuP8attotime["X"]=1;

function __ZL20menu_analog_populateR15running_machineP7ui_menu($machine, $menu) {
  var __stackBase__  = STACKTOP; STACKTOP += 340; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $field;
      var $port;
      var $subtext=__stackBase__;
      var $text=__stackBase__+64;
      var $3;
      var $4;
      var $settings=__stackBase__+128;
      var $use_autocenter;
      var $type;
      var $data;
      var $flags;
      $1=$machine;
      $2=$menu;
      __ZN7astringC1Ev($subtext);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6+20)|0);
      var $8=(function() { try { __THREW__ = false; return __ZNK11tagged_listI17input_port_configE5firstEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 16; break; };
    case 2: // $9
      $port=$8;
      __label__ = 3; break;
    case 3: // $10
      var $11=$port;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 62; break; }
    case 4: // $13
      var $14=$port;
      var $15=(function() { try { __THREW__ = false; return __ZN17input_port_config9fieldlistEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 16; break; };
    case 5: // $16
      var $17=(function() { try { __THREW__ = false; return __ZNK11simple_listI18input_field_configE5firstEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 16; break; };
    case 6: // $18
      $field=$17;
      __label__ = 7; break;
    case 7: // $19
      var $20=$field;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 8; break; } else { __label__ = 59; break; }
    case 8: // $22
      var $23=$field;
      var $24=(($23+24)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(function() { try { __THREW__ = false; return __Z20input_type_is_analogi($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 16; break; };
    case 9: // $27
      var $28=(($26)|0)!=0;
      if ($28) { __label__ = 10; break; } else { __label__ = 56; break; }
    case 10: // $29
      var $30=$1;
      var $31=$field;
      var $32=(($31+8)|0);
      var $33=$port;
      var $34=(function() { try { __THREW__ = false; return __ZNK17input_port_config5ownerEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $35
      var $36=(function() { try { __THREW__ = false; return __Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($30, $32, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; };
    case 12: // $37
      var $38=(($36)|0)!=0;
      if ($38) { __label__ = 13; break; } else { __label__ = 56; break; }
    case 13: // $39
      (function() { try { __THREW__ = false; return __ZN26_input_field_user_settingsC1Ev($settings) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $40
      $use_autocenter=0;
      var $41=$field;
      var $42=(($41+24)|0);
      var $43=HEAP32[(($42)>>2)];
      if ($43 == 150 || $43 == 151) {
        __label__ = 17; break;
      }
      else if ($43 == 147 || $43 == 148 || $43 == 149 || $43 == 140 || $43 == 141 || $43 == 142 || $43 == 143 || $43 == 144) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 15: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $3=$46;
      var $47=$45.f1;
      $4=$47;
      __label__ = 65; break;
    case 16: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      $3=$50;
      var $51=$49.f1;
      $4=$51;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 17: // $52
      var $53=$field;
      var $54=(($53+32)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55 & 64;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $58
      __label__ = 21; break;
    case 19: // $59
      __label__ = 20; break;
    case 20: // $60
      $use_autocenter=1;
      __label__ = 21; break;
    case 21: // $61
      var $62=$field;
      (function() { try { __THREW__ = false; return __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($62, $settings) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 16; break; }
    case 22: // $63
      $type=0;
      __label__ = 23; break;
    case 23: // $64
      var $65=$type;
      var $66=(($65)|0) < 4;
      if ($66) { __label__ = 24; break; } else { __label__ = 55; break; }
    case 24: // $67
      var $68=$type;
      var $69=(($68)|0)!=1;
      if ($69) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $70
      var $71=$use_autocenter;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 26; break; } else { __label__ = 53; break; }
    case 26: // $73
      $flags=0;
      var $74=$2;
      var $75=(function() { try { __THREW__ = false; return __Z18ui_menu_pool_allocP7ui_menuj($74, 24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 16; break; };
    case 27: // $76
      var $77=$75;
      $data=$77;
      var $78=$field;
      var $79=$data;
      var $80=(($79)|0);
      HEAP32[(($80)>>2)]=$78;
      var $81=$type;
      var $82=$data;
      var $83=(($82+4)|0);
      HEAP32[(($83)>>2)]=$81;
      var $84=$type;
      if ($84 == 0) {
        __label__ = 29; break;
      }
      else if ($84 == 1) {
        __label__ = 33; break;
      }
      else if ($84 == 2) {
        __label__ = 37; break;
      }
      else if ($84 == 3) {
        __label__ = 41; break;
      }
      else {
      __label__ = 28; break;
      }
      
    case 28: // $85
      __label__ = 29; break;
    case 29: // $86
      var $87=$field;
      var $88=(function() { try { __THREW__ = false; return __Z16input_field_namePK18input_field_config($87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 16; break; };
    case 30: // $89
      var $90=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($text, ((STRING_TABLE.__str1044268)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$88,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 16; break; };
    case 31: // $91
      var $92=(($settings+200)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($subtext, ((STRING_TABLE.__str574221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$93,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 16; break; };
    case 32: // $95
      var $96=$data;
      var $97=(($96+8)|0);
      HEAP32[(($97)>>2)]=0;
      var $98=$data;
      var $99=(($98+12)|0);
      HEAP32[(($99)>>2)]=255;
      var $100=(($settings+200)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$data;
      var $103=(($102+16)|0);
      HEAP32[(($103)>>2)]=$101;
      var $104=$field;
      var $105=(($104+312)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$data;
      var $108=(($107+20)|0);
      HEAP32[(($108)>>2)]=$106;
      __label__ = 45; break;
    case 33: // $109
      var $110=$field;
      var $111=(function() { try { __THREW__ = false; return __Z16input_field_namePK18input_field_config($110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 16; break; };
    case 34: // $112
      var $113=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($text, ((STRING_TABLE.__str1054269)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$111,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 16; break; };
    case 35: // $114
      var $115=(($settings+204)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($subtext, ((STRING_TABLE.__str574221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$116,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 16; break; };
    case 36: // $118
      var $119=$data;
      var $120=(($119+8)|0);
      HEAP32[(($120)>>2)]=0;
      var $121=$data;
      var $122=(($121+12)|0);
      HEAP32[(($122)>>2)]=255;
      var $123=(($settings+204)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$data;
      var $126=(($125+16)|0);
      HEAP32[(($126)>>2)]=$124;
      var $127=$field;
      var $128=(($127+316)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$data;
      var $131=(($130+20)|0);
      HEAP32[(($131)>>2)]=$129;
      __label__ = 45; break;
    case 37: // $132
      var $133=$field;
      var $134=(function() { try { __THREW__ = false; return __Z16input_field_namePK18input_field_config($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 16; break; };
    case 38: // $135
      var $136=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($text, ((STRING_TABLE.__str1064270)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 16; break; };
    case 39: // $137
      var $138=(($settings+208)|0);
      var $139=HEAP8[($138)];
      var $140=(($139 << 24) >> 24)!=0;
      var $141=$140 ? (((STRING_TABLE.__str684232)|0)) : (((STRING_TABLE.__str674231)|0));
      var $142=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($subtext, $141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 16; break; };
    case 40: // $143
      var $144=$data;
      var $145=(($144+8)|0);
      HEAP32[(($145)>>2)]=0;
      var $146=$data;
      var $147=(($146+12)|0);
      HEAP32[(($147)>>2)]=1;
      var $148=(($settings+208)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$data;
      var $152=(($151+16)|0);
      HEAP32[(($152)>>2)]=$150;
      var $153=$field;
      var $154=(($153+32)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$155 & 16;
      var $157=(($156)|0)!=0;
      var $158=(($157)&1);
      var $159=$data;
      var $160=(($159+20)|0);
      HEAP32[(($160)>>2)]=$158;
      __label__ = 45; break;
    case 41: // $161
      var $162=$field;
      var $163=(function() { try { __THREW__ = false; return __Z16input_field_namePK18input_field_config($162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 16; break; };
    case 42: // $164
      var $165=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($text, ((STRING_TABLE.__str1074271)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$163,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 16; break; };
    case 43: // $166
      var $167=(($settings+196)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($subtext, ((STRING_TABLE.__str574221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$168,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 16; break; };
    case 44: // $170
      var $171=$data;
      var $172=(($171+8)|0);
      HEAP32[(($172)>>2)]=1;
      var $173=$data;
      var $174=(($173+12)|0);
      HEAP32[(($174)>>2)]=255;
      var $175=(($settings+196)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$data;
      var $178=(($177+16)|0);
      HEAP32[(($178)>>2)]=$176;
      var $179=$field;
      var $180=(($179+308)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=$data;
      var $183=(($182+20)|0);
      HEAP32[(($183)>>2)]=$181;
      __label__ = 45; break;
    case 45: // $184
      var $185=$data;
      var $186=(($185+16)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=$data;
      var $189=(($188+8)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=(($187)|0) > (($190)|0);
      if ($191) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $192
      var $193=$flags;
      var $194=$193 | 1;
      $flags=$194;
      __label__ = 47; break;
    case 47: // $195
      var $196=$data;
      var $197=(($196+16)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=$data;
      var $200=(($199+12)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=(($198)|0) < (($201)|0);
      if ($202) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $203
      var $204=$flags;
      var $205=$204 | 2;
      $flags=$205;
      __label__ = 49; break;
    case 49: // $206
      var $207=$2;
      var $208=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 16; break; };
    case 50: // $209
      var $210=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 16; break; };
    case 51: // $211
      var $212=$flags;
      var $213=$data;
      var $214=$213;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($207, $208, $210, $212, $214) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 16; break; }
    case 52: // $215
      __label__ = 53; break;
    case 53: // $216
      __label__ = 54; break;
    case 54: // $217
      var $218=$type;
      var $219=(($218+1)|0);
      $type=$219;
      __label__ = 23; break;
    case 55: // $220
      __label__ = 56; break;
    case 56: // $221
      __label__ = 57; break;
    case 57: // $222
      var $223=$field;
      var $224=(function() { try { __THREW__ = false; return __ZNK18input_field_config4nextEv($223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 16; break; };
    case 58: // $225
      $field=$224;
      __label__ = 7; break;
    case 59: // $226
      __label__ = 60; break;
    case 60: // $227
      var $228=$port;
      var $229=(function() { try { __THREW__ = false; return __ZNK17input_port_config4nextEv($228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 16; break; };
    case 61: // $230
      $port=$229;
      __label__ = 3; break;
    case 62: // $231
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 15; break; }
    case 63: // $232
      FUNCTION_TABLE[__ZN7astringD1Ev]($subtext);
      STACKTOP = __stackBase__;
      return;
    case 64: // $233
      __label__ = 65; break;
    case 65: // $234
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($subtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $235
      __label__ = 67; break;
    case 67: // $236
      var $237=$3;
      var $238=$3;
      var $239=$4;
      var $240=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $238, tempValue);
      var $241=($240.f1 = $239, $240);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20menu_analog_populateR15running_machineP7ui_menu["X"]=1;

function __ZL19count_leading_zerosj4285($val) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $count;
      $1=$val;
      $count=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3)|0) >= 0;
      if ($4) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $5
      var $6=$1;
      var $7=$6 << 1;
      $1=$7;
      __label__ = 3; break;
    case 3: // $8
      var $9=$count;
      var $10=(($9+1)&255);
      $count=$10;
      __label__ = 1; break;
    case 4: // $11
      var $12=$count;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listI23input_field_diplocationE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI23input_field_diplocationE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK23input_field_diplocation4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+68)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN7ui_menuC2ER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=(($3+12)|0);
  var $5=(($3+84)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  ;
  return;
}


function __ZL22menu_settings_populateR15running_machineP7ui_menuP20_settings_menu_statej($machine, $menu, $menustate, $type) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $field;
      var $port;
      var $diplist_tailptr;
      var $dipcount;
      var $flags;
      var $diploc;
      var $settings=__stackBase__;
      var $accummask;
      var $mask;
      var $dip;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      $4=$type;
      $dipcount=0;
      var $5=$3;
      var $6=(($5)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=$3;
      var $8=(($7)|0);
      $diplist_tailptr=$8;
      var $9=$1;
      var $10=(($9+20)|0);
      var $11=__ZNK11tagged_listI17input_port_configE5firstEv($10);
      $port=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$port;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 35; break; }
    case 2: // $15
      var $16=$port;
      var $17=__ZN17input_port_config9fieldlistEv($16);
      var $18=__ZNK11simple_listI18input_field_configE5firstEv($17);
      $field=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$field;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 4; break; } else { __label__ = 33; break; }
    case 4: // $22
      var $23=$field;
      var $24=(($23+24)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$4;
      var $27=(($25)|0)==(($26)|0);
      if ($27) { __label__ = 5; break; } else { __label__ = 31; break; }
    case 5: // $28
      var $29=$1;
      var $30=$field;
      var $31=(($30+8)|0);
      var $32=$port;
      var $33=__ZNK17input_port_config5ownerEv($32);
      var $34=__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t($29, $31, $33);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 31; break; }
    case 6: // $36
      $flags=0;
      var $37=$field;
      var $38=__Z32input_field_has_previous_settingPK18input_field_config($37);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      var $41=$flags;
      var $42=$41 | 1;
      $flags=$42;
      __label__ = 8; break;
    case 8: // $43
      var $44=$field;
      var $45=__Z28input_field_has_next_settingPK18input_field_config($44);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $47
      var $48=$flags;
      var $49=$48 | 2;
      $flags=$49;
      __label__ = 10; break;
    case 10: // $50
      var $51=$2;
      var $52=$field;
      var $53=__Z16input_field_namePK18input_field_config($52);
      var $54=$field;
      var $55=__Z24input_field_setting_namePK18input_field_config($54);
      var $56=$flags;
      var $57=$field;
      var $58=$57;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($51, $53, $55, $56, $58);
      var $59=$4;
      var $60=(($59)|0)==5;
      if ($60) { __label__ = 11; break; } else { __label__ = 30; break; }
    case 11: // $61
      var $62=$field;
      var $63=__ZN18input_field_config10diploclistEv($62);
      var $64=__ZNK11simple_listI23input_field_diplocationE5countEv($63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 12; break; } else { __label__ = 30; break; }
    case 12: // $66
      __ZN26_input_field_user_settingsC1Ev($settings);
      var $67=$field;
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      $accummask=$69;
      var $70=$field;
      __Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings($70, $settings);
      var $71=$field;
      var $72=__ZN18input_field_config10diploclistEv($71);
      var $73=__ZNK11simple_listI23input_field_diplocationE5firstEv($72);
      $diploc=$73;
      __label__ = 13; break;
    case 13: // $74
      var $75=$diploc;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 14; break; } else { __label__ = 29; break; }
    case 14: // $77
      var $78=$accummask;
      var $79=$accummask;
      var $80=(($79-1)|0);
      var $81=$80 ^ -1;
      var $82=$78 & $81;
      $mask=$82;
      var $83=$3;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      $dip=$85;
      __label__ = 15; break;
    case 15: // $86
      var $87=$dip;
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $89
      var $90=$dip;
      var $91=(($90+4)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$diploc;
      var $94=(($93)|0);
      var $95=__ZNK7astringcvPKcEv($94);
      var $96=_strcmp($92, $95);
      var $97=(($96)|0)==0;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      __label__ = 20; break;
    case 18: // $99
      __label__ = 19; break;
    case 19: // $100
      var $101=$dip;
      var $102=(($101)|0);
      var $103=HEAP32[(($102)>>2)];
      $dip=$103;
      __label__ = 15; break;
    case 20: // $104
      var $105=$dip;
      var $106=(($105)|0)==0;
      if ($106) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $107
      var $108=$2;
      var $109=__Z18ui_menu_pool_allocP7ui_menuj($108, 16);
      var $110=$109;
      $dip=$110;
      var $111=$dip;
      var $112=(($111)|0);
      HEAP32[(($112)>>2)]=0;
      var $113=$diploc;
      var $114=(($113)|0);
      var $115=__ZNK7astringcvPKcEv($114);
      var $116=$dip;
      var $117=(($116+4)|0);
      HEAP32[(($117)>>2)]=$115;
      var $118=$dip;
      var $119=(($118+12)|0);
      HEAP32[(($119)>>2)]=0;
      var $120=$dip;
      var $121=(($120+8)|0);
      HEAP32[(($121)>>2)]=0;
      var $122=$dip;
      var $123=$diplist_tailptr;
      HEAP32[(($123)>>2)]=$122;
      var $124=$dip;
      var $125=(($124)|0);
      $diplist_tailptr=$125;
      var $126=$dipcount;
      var $127=(($126+1)|0);
      $dipcount=$127;
      __label__ = 22; break;
    case 22: // $128
      var $129=$diploc;
      var $130=(($129+64)|0);
      var $131=HEAPU8[($130)];
      var $132=(($131)&255);
      var $133=(($132-1)|0);
      var $134=1 << $133;
      var $135=$dip;
      var $136=(($135+8)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$137 | $134;
      HEAP32[(($136)>>2)]=$138;
      var $139=(($settings)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=$mask;
      var $142=$140 & $141;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $144
      var $145=$diploc;
      var $146=(($145+65)|0);
      var $147=HEAP8[($146)];
      var $148=(($147) & 1);
      if ($148) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $149
      var $150=(($settings)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$mask;
      var $153=$151 & $152;
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $155
      var $156=$diploc;
      var $157=(($156+65)|0);
      var $158=HEAP8[($157)];
      var $159=(($158) & 1);
      if ($159) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $160
      var $161=$diploc;
      var $162=(($161+64)|0);
      var $163=HEAPU8[($162)];
      var $164=(($163)&255);
      var $165=(($164-1)|0);
      var $166=1 << $165;
      var $167=$dip;
      var $168=(($167+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=$169 | $166;
      HEAP32[(($168)>>2)]=$170;
      __label__ = 27; break;
    case 27: // $171
      var $172=$mask;
      var $173=$172 ^ -1;
      var $174=$accummask;
      var $175=$174 & $173;
      $accummask=$175;
      __label__ = 28; break;
    case 28: // $176
      var $177=$diploc;
      var $178=__ZNK23input_field_diplocation4nextEv($177);
      $diploc=$178;
      __label__ = 13; break;
    case 29: // $179
      __label__ = 30; break;
    case 30: // $180
      __label__ = 31; break;
    case 31: // $181
      __label__ = 32; break;
    case 32: // $182
      var $183=$field;
      var $184=__ZNK18input_field_config4nextEv($183);
      $field=$184;
      __label__ = 3; break;
    case 33: // $185
      __label__ = 34; break;
    case 34: // $186
      var $187=$port;
      var $188=__ZNK17input_port_config4nextEv($187);
      $port=$188;
      __label__ = 1; break;
    case 35: // $189
      var $190=$4;
      var $191=(($190)|0)==5;
      if ($191) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $192
      var $193=$3;
      var $194=(($193)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $197
      var $198=$2;
      var $199=$dipcount;
      var $200=(($199)|0);
      var $201=$200*0.06000000074505806;
      var $202=$201+0.01;
      var $203=$202;
      __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($198, 1070, 0, $203);
      __label__ = 38; break;
    case 38: // $204
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22menu_settings_populateR15running_machineP7ui_menuP20_settings_menu_statej["X"]=1;

function __ZL27menu_settings_custom_renderR15running_machineP7ui_menuPvS3_ffffff($machine, $menu, $state, $selectedref, $top, $bottom, $x1, $y1, $x2, $y2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $field;
      var $menustate;
      var $dip;
      var $diploc;
      var $selectedmask;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$selectedref;
      $5=$top;
      $6=$bottom;
      $7=$x1;
      $8=$y1;
      $9=$x2;
      $10=$y2;
      var $11=$4;
      var $12=$11;
      $field=$12;
      var $13=$3;
      var $14=$13;
      $menustate=$14;
      var $15=$10;
      var $16=$15+0.009999999776482582;
      $8=$16;
      var $17=$8;
      var $18=$6;
      var $19=$17+$18;
      $10=$19;
      var $20=$2;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$7;
      var $24=$8;
      var $25=$9;
      var $26=$10;
      __Z20ui_draw_outlined_boxP16render_containerffffj($22, $23, $24, $25, $26, -284159952);
      var $27=$8;
      var $28=$27+0.009999999776482582;
      $8=$28;
      var $29=$menustate;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      $dip=$31;
      __label__ = 1; break;
    case 1: // $32
      var $33=$dip;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $35
      $selectedmask=0;
      var $36=$field;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $38
      var $39=$field;
      var $40=__ZN18input_field_config10diploclistEv($39);
      var $41=__ZNK11simple_listI23input_field_diplocationE5firstEv($40);
      $diploc=$41;
      __label__ = 4; break;
    case 4: // $42
      var $43=$diploc;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $45
      var $46=$dip;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$diploc;
      var $50=(($49)|0);
      var $51=__ZNK7astringcvPKcEv($50);
      var $52=_strcmp($48, $51);
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $54
      var $55=$diploc;
      var $56=(($55+64)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=(($58-1)|0);
      var $60=1 << $59;
      var $61=$selectedmask;
      var $62=$61 | $60;
      $selectedmask=$62;
      __label__ = 7; break;
    case 7: // $63
      __label__ = 8; break;
    case 8: // $64
      var $65=$diploc;
      var $66=__ZNK23input_field_diplocation4nextEv($65);
      $diploc=$66;
      __label__ = 4; break;
    case 9: // $67
      __label__ = 10; break;
    case 10: // $68
      var $69=$2;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$7;
      var $73=$8;
      var $74=$9;
      var $75=$8;
      var $76=$75+0.05000000074505806;
      var $77=$dip;
      var $78=$selectedmask;
      __ZL31menu_settings_custom_render_oneP16render_containerffffPK15_dip_descriptorj($71, $72, $73, $74, $76, $77, $78);
      var $79=$8;
      var $80=$79+0.06000000238418579;
      $8=$80;
      __label__ = 11; break;
    case 11: // $81
      var $82=$dip;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      $dip=$84;
      __label__ = 1; break;
    case 12: // $85
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27menu_settings_custom_renderR15running_machineP7ui_menuPvS3_ffffff["X"]=1;

function __ZL31menu_settings_custom_render_oneP16render_containerffffPK15_dip_descriptorj($container, $x1, $y1, $x2, $y2, $dip, $selectedmask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $switch_field_width;
      var $switch_width;
      var $numtoggles;
      var $toggle;
      var $switch_toggle_gap;
      var $y1_off;
      var $y1_on;
      var $innerx1;
      var $innery1;
      $1=$container;
      $2=$x1;
      $3=$y1;
      $4=$x2;
      $5=$y2;
      $6=$dip;
      $7=$selectedmask;
      var $8=$1;
      var $9=__ZNK16render_container7managerEv($8);
      var $10=__ZN14render_manager9ui_aspectEv($9);
      var $11=$10*0.02500000037252903;
      $switch_field_width=$11;
      var $12=$1;
      var $13=__ZNK16render_container7managerEv($12);
      var $14=__ZN14render_manager9ui_aspectEv($13);
      var $15=$14*0.019999999552965164;
      $switch_width=$15;
      var $16=$6;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZL19count_leading_zerosj4285($18);
      var $20=(($19)&255);
      var $21=((32-$20)|0);
      $numtoggles=$21;
      var $22=$4;
      var $23=$2;
      var $24=$22-$23;
      var $25=$numtoggles;
      var $26=(($25)|0);
      var $27=$switch_field_width;
      var $28=$26*$27;
      var $29=$24-$28;
      var $30=$29/2;
      var $31=$2;
      var $32=$31+$30;
      $2=$32;
      var $33=$1;
      var $34=$6;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$3;
      var $38=$37+0.005000000819563866;
      var $39=$2;
      var $40=$1;
      var $41=__ZNK16render_container7managerEv($40);
      var $42=__ZNK14render_manager7machineEv($41);
      var $43=__Z19ui_get_string_widthR15running_machinePKc($42, ((STRING_TABLE.__str314195)|0));
      var $44=$39-$43;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($33, $36, 0, $38, $44, 2, 0, 1, -1, 256, 0, 0);
      $switch_toggle_gap=0.002499999478459358;
      var $45=$3;
      var $46=$45+0.0020000000949949026;
      var $47=$switch_toggle_gap;
      var $48=$46+$47;
      $y1_off=$48;
      var $49=$3;
      var $50=$49+0.02500000037252903;
      var $51=$switch_toggle_gap;
      var $52=$50+$51;
      $y1_on=$52;
      $toggle=0;
      __label__ = 1; break;
    case 1: // $53
      var $54=$toggle;
      var $55=$numtoggles;
      var $56=(($54)|0) < (($55)|0);
      if ($56) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $57
      var $58=$1;
      var $59=$2;
      var $60=$3;
      var $61=$2;
      var $62=$switch_field_width;
      var $63=$61+$62;
      var $64=$5;
      __Z20ui_draw_outlined_boxP16render_containerffffj($58, $59, $60, $63, $64, -284159952);
      var $65=$2;
      var $66=$switch_field_width;
      var $67=$switch_width;
      var $68=$66-$67;
      var $69=$68/2;
      var $70=$65+$69;
      $innerx1=$70;
      var $71=$6;
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$toggle;
      var $75=1 << $74;
      var $76=$73 & $75;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $78
      var $79=$6;
      var $80=(($79+12)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$toggle;
      var $83=1 << $82;
      var $84=$81 & $83;
      var $85=(($84)|0)!=0;
      var $86=$y1_on;
      var $87=$y1_off;
      var $88=$85 ? $86 : $87;
      $innery1=$88;
      var $89=$1;
      var $90=$innerx1;
      var $91=$innery1;
      var $92=$innerx1;
      var $93=$switch_width;
      var $94=$92+$93;
      var $95=$innery1;
      var $96=$95+0.020000001415610313;
      var $97=$7;
      var $98=$toggle;
      var $99=1 << $98;
      var $100=$97 & $99;
      var $101=(($100)|0)!=0;
      var $102=$101 ? -256 : -1;
      __ZN16render_container8add_rectEffffjj($89, $90, $91, $94, $96, $102, 256);
      __label__ = 5; break;
    case 4: // $103
      var $104=$1;
      var $105=$innerx1;
      var $106=$y1_off;
      var $107=$innerx1;
      var $108=$switch_width;
      var $109=$107+$108;
      var $110=$y1_on;
      var $111=$110+0.020000001415610313;
      __ZN16render_container8add_rectEffffjj($104, $105, $106, $109, $111, -12566464, 256);
      __label__ = 5; break;
    case 5: // $112
      var $113=$switch_field_width;
      var $114=$2;
      var $115=$114+$113;
      $2=$115;
      __label__ = 6; break;
    case 6: // $116
      var $117=$toggle;
      var $118=(($117+1)|0);
      $toggle=$118;
      __label__ = 1; break;
    case 7: // $119
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL31menu_settings_custom_render_oneP16render_containerffffPK15_dip_descriptorj["X"]=1;

function __ZL18item_is_selectablePK13_ui_menu_item($item) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$item;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4 & 40;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { var $14 = 0;__label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=_strcmp($10, ((STRING_TABLE.__str144178)|0));
      var $12=(($11)|0)!=0;
      var $14 = $12;__label__ = 2; break;
    case 2: // $13
      var $14;
      var $15=(($14)&1);
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23exclusive_input_pressedP7ui_menuii($menu, $key, $repeat) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$menu;
      $3=$key;
      $4=$repeat;
      var $5=$2;
      var $6=(($5+12)|0);
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$2;
      var $12=__ZNK7ui_menu7machineEv($11);
      var $13=$3;
      var $14=$4;
      var $15=__Z23ui_input_pressed_repeatR15running_machineii($12, $13, $14);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$3;
      var $19=$2;
      var $20=(($19+12)|0);
      var $21=(($20+4)|0);
      HEAP32[(($21)>>2)]=$18;
      $1=1;
      __label__ = 4; break;
    case 3: // $22
      $1=0;
      __label__ = 4; break;
    case 4: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13debugint_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ch;
      var $chw;
      var $2=__stackBase__;
      $1=$machine;
      var $3=$1;
      var $4=__ZNK15running_machine6renderEv($3);
      var $5=__ZN14render_manager10font_allocEPKc($4, ((STRING_TABLE.__str4286)|0));
      HEAP32[((__ZL10debug_font)>>2)]=$5;
      HEAP32[((__ZL16debug_font_width)>>2)]=0;
      HEAP32[((__ZL17debug_font_height)>>2)]=15;
      HEAP32[((__ZL4menu)>>2)]=0;
      HEAP32[((__ZL10cur_editor)>>2)]=0;
      HEAP32[((__ZL4list)>>2)]=0;
      HEAP32[((__ZL10focus_view)>>2)]=0;
      var $6=$1;
      var $7=__ZNK15running_machine6renderEv($6);
      var $8=__ZN14render_manager9ui_aspectEv($7);
      HEAPF32[((__ZL17debug_font_aspect)>>2)]=$8;
      $ch=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$ch;
      var $11=(($10)>>>0) <= 127;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=HEAP32[((__ZL10debug_font)>>2)];
      var $14=HEAP32[((__ZL17debug_font_height)>>2)];
      var $15=(($14)|0);
      var $16=HEAPF32[((__ZL17debug_font_aspect)>>2)];
      var $17=$ch;
      var $18=__ZN11render_font10char_widthEffj($13, $15, $16, $17);
      var $19=(($18)|0);
      $chw=$19;
      var $20=$chw;
      var $21=HEAP32[((__ZL16debug_font_width)>>2)];
      var $22=(($20)|0) > (($21)|0);
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$chw;
      HEAP32[((__ZL16debug_font_width)>>2)]=$24;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$ch;
      var $28=(($27+1)|0);
      $ch=$28;
      __label__ = 1; break;
    case 6: // $29
      var $30=HEAP32[((__ZL16debug_font_width)>>2)];
      var $31=(($30+1)|0);
      HEAP32[((__ZL16debug_font_width)>>2)]=$31;
      HEAP32[((__ZL16debug_font_width)>>2)]=10;
      var $32=$1;
      var $33=$1;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 1072, ((STRING_TABLE.__str14287)|0), $33);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($32, 4, $2);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13debugint_initR15running_machine["X"]=1;

function __ZL13debugint_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ndv;
      var $temp;
      $1=$machine;
      var $2=HEAP32[((__ZL4list)>>2)];
      $ndv=$2;
      __label__ = 1; break;
    case 1: // $3
      var $4=$ndv;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $6
      var $7=$ndv;
      $temp=$7;
      var $8=$ndv;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      $ndv=$10;
      var $11=$temp;
      __ZL10dview_freeP5DView($11);
      __label__ = 1; break;
    case 3: // $12
      var $13=HEAP32[((__ZL10debug_font)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $15
      var $16=$1;
      var $17=__ZNK15running_machine6renderEv($16);
      var $18=HEAP32[((__ZL10debug_font)>>2)];
      __ZN14render_manager9font_freeEP11render_font($17, $18);
      HEAP32[((__ZL10debug_font)>>2)]=0;
      __label__ = 5; break;
    case 5: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z26debugint_wait_for_debuggerR8device_tb($device, $firststop) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dv;
      var $target;
      var $3=__stackBase__;
      var $4;
      var $5;
      $1=$device;
      var $6=(($firststop)&1);
      $2=$6;
      var $7=$2;
      var $8=(($7) & 1);
      if ($8) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $9
      var $10=HEAP32[((__ZL4list)>>2)];
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$1;
      var $14=__ZNK8device_t7machineEv($13);
      var $15=__ZNK15running_machine6renderEv($14);
      var $16=__ZNK14render_manager9ui_targetEv($15);
      $target=$16;
      var $17=$target;
      var $18=$1;
      var $19=__ZNK8device_t7machineEv($18);
      var $20=__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei($17, $19, 3, 16);
      $dv=$20;
      var $21=$dv;
      var $22=(($21+188)|0);
      var $23=(($22)|0);
      HEAP32[(($23)>>2)]=1;
      var $24=$1;
      var $25=__ZNK8device_t7machineEv($24);
      var $26=__ZNK15running_machine6renderEv($25);
      var $27=__ZNK14render_manager12ui_containerEv($26);
      var $28=$dv;
      var $29=(($28+188)|0);
      var $30=(($29+4)|0);
      HEAP32[(($30)>>2)]=$27;
      var $31=$target;
      var $32=$1;
      var $33=__ZNK8device_t7machineEv($32);
      var $34=__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei($31, $33, 2, 16);
      $dv=$34;
      var $35=$target;
      var $36=$1;
      var $37=__ZNK8device_t7machineEv($36);
      var $38=__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei($35, $37, 1, 16);
      $dv=$38;
      var $39=$dv;
      __ZN7astringC1EPKc($3, ((STRING_TABLE.__str24288)|0));
      (function() { try { __THREW__ = false; return __ZL15dview_set_titleP5DView7astring($39, $3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $40
      FUNCTION_TABLE[__ZN7astringD1Ev]($3);
      var $41=$dv;
      var $42=(($41+188)|0);
      var $43=(($42)|0);
      HEAP32[(($43)>>2)]=1;
      var $44=$1;
      var $45=__ZNK8device_t7machineEv($44);
      var $46=__ZNK15running_machine6renderEv($45);
      var $47=__ZNK14render_manager12ui_containerEv($46);
      var $48=$dv;
      var $49=(($48+188)|0);
      var $50=(($49+4)|0);
      HEAP32[(($50)>>2)]=$47;
      var $51=$dv;
      __ZL14set_focus_viewP5DView($51);
      __label__ = 6; break;
    case 4: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $4=$54;
      var $55=$53.f1;
      $5=$55;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $56
      __label__ = 7; break;
    case 6: // $57
      var $58=$1;
      __ZL17followers_set_cpuP8device_t($58);
      __ZL12update_viewsv();
      var $59=$1;
      var $60=__ZNK8device_t7machineEv($59);
      var $61=__ZNK15running_machine3osdEv($60);
      var $62=$61;
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+12)|0);
      var $65=HEAP32[(($64)>>2)];
      FUNCTION_TABLE[$65]($61, 0);
      var $66=$1;
      var $67=__ZNK8device_t7machineEv($66);
      __ZL12handle_menusR15running_machine($67);
      var $68=$1;
      var $69=__ZNK8device_t7machineEv($68);
      __ZL12handle_mouseR15running_machine($69);
      STACKTOP = __stackBase__;
      return;
    case 7: // $70
      var $71=$4;
      var $72=$4;
      var $73=$5;
      var $74=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $72, tempValue);
      var $75=($74.f1 = $73, $74);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26debugint_wait_for_debuggerR8device_tb["X"]=1;

function __ZL15dview_set_titleP5DView7astring($dv, $title) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$dv;
      var $2=$1;
      var $3=(($2+52)|0);
      var $4=__ZNK7astring3cmpERKS_($3, $title);
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+52)|0);
      var $9=__ZN7astringaSERKS_($8, $title);
      var $10=$1;
      __ZL15dview_set_stateP5DViewii($10, 8, 1);
      __label__ = 2; break;
    case 2: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14set_focus_viewP5DView($dv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $_hlp;
      $1=$dv;
      var $2=HEAP32[((__ZL10focus_view)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=HEAP32[((__ZL10focus_view)>>2)];
      __ZL15dview_set_stateP5DViewii($5, 8, 1);
      __label__ = 2; break;
    case 2: // $6
      var $7=$1;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      var $10=$1;
      __ZL15dview_set_stateP5DViewii($10, 8, 1);
      __label__ = 4; break;
    case 4: // $11
      var $12=HEAP32[((__ZL10focus_view)>>2)];
      var $13=$1;
      var $14=(($12)|0)!=(($13)|0);
      if ($14) { __label__ = 5; break; } else { __label__ = 23; break; }
    case 5: // $15
      var $16=$1;
      HEAP32[((__ZL10focus_view)>>2)]=$16;
      __label__ = 6; break;
    case 6: // $17
      __label__ = 7; break;
    case 7: // $18
      $_hlp=0;
      var $19=HEAP32[((__ZL4list)>>2)];
      var $20=$1;
      var $21=(($19)|0)!=(($20)|0);
      if ($21) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $22
      var $23=HEAP32[((__ZL4list)>>2)];
      $_hlp=$23;
      __label__ = 9; break;
    case 9: // $24
      var $25=$_hlp;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $27
      var $28=$_hlp;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$1;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $33
      __label__ = 14; break;
    case 12: // $34
      __label__ = 13; break;
    case 13: // $35
      var $36=$_hlp;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      $_hlp=$38;
      __label__ = 9; break;
    case 14: // $39
      __label__ = 15; break;
    case 15: // $40
      __label__ = 16; break;
    case 16: // $41
      var $42=$_hlp;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $44
      var $45=$1;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$_hlp;
      var $49=(($48)|0);
      HEAP32[(($49)>>2)]=$47;
      __label__ = 19; break;
    case 18: // $50
      var $51=$1;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      HEAP32[((__ZL4list)>>2)]=$53;
      __label__ = 19; break;
    case 19: // $54
      __label__ = 20; break;
    case 20: // $55
      __label__ = 21; break;
    case 21: // $56
      var $57=HEAP32[((__ZL4list)>>2)];
      var $58=$1;
      var $59=(($58)|0);
      HEAP32[(($59)>>2)]=$57;
      var $60=$1;
      HEAP32[((__ZL4list)>>2)]=$60;
      __label__ = 22; break;
    case 22: // $61
      var $62=$1;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$1;
      var $66=(($65+12)|0);
      var $67=HEAP32[(($66)>>2)];
      __ZN13render_target9debug_topER16render_container($64, $67);
      __label__ = 23; break;
    case 23: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14set_focus_viewP5DView["X"]=1;

function __ZL12update_viewsv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $dv;
      var $prev;
      __label__ = 1; break;
    case 1: // $1
      var $2=HEAP32[((__ZL4list)>>2)];
      $dv=$2;
      __label__ = 2; break;
    case 2: // $3
      var $4=$dv;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $6
      var $7=$dv;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $11
      __label__ = 7; break;
    case 5: // $12
      __label__ = 6; break;
    case 6: // $13
      var $14=$dv;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      $dv=$16;
      __label__ = 2; break;
    case 7: // $17
      __label__ = 8; break;
    case 8: // $18
      __label__ = 9; break;
    case 9: // $19
      var $20=$dv;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 10; break; } else { __label__ = 21; break; }
    case 10: // $22
      var $23=$dv;
      __ZL17dview_update_viewP5DView($23);
      __label__ = 11; break;
    case 11: // $24
      $prev=0;
      var $25=HEAP32[((__ZL4list)>>2)];
      var $26=$dv;
      var $27=(($25)|0)!=(($26)|0);
      if ($27) { __label__ = 12; break; } else { __label__ = 19; break; }
    case 12: // $28
      var $29=HEAP32[((__ZL4list)>>2)];
      $prev=$29;
      __label__ = 13; break;
    case 13: // $30
      var $31=$prev;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $33
      var $34=$prev;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$dv;
      var $38=(($36)|0)==(($37)|0);
      if ($38) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $39
      __label__ = 18; break;
    case 16: // $40
      __label__ = 17; break;
    case 17: // $41
      var $42=$prev;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      $prev=$44;
      __label__ = 13; break;
    case 18: // $45
      __label__ = 19; break;
    case 19: // $46
      __label__ = 20; break;
    case 20: // $47
      var $48=$prev;
      $dv=$48;
      __label__ = 9; break;
    case 21: // $49
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12update_viewsv["X"]=1;

function __ZL12handle_menusR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $event;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine6renderEv($2);
      var $4=__ZNK14render_manager12ui_containerEv($3);
      __ZN16render_container5emptyEv($4);
      var $5=$1;
      __Z21ui_input_frame_updateR15running_machine($5);
      var $6=HEAP32[((__ZL4menu)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $8
      var $9=$1;
      var $10=HEAP32[((__ZL4menu)>>2)];
      var $11=__Z15ui_menu_processR15running_machineP7ui_menuj($9, $10, 0);
      $event=$11;
      var $12=$event;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $14
      var $15=$event;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==182;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      var $20=$event;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==177;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=$event;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      var $29=HEAP32[((__ZL10focus_view)>>2)];
      var $30=$event;
      FUNCTION_TABLE[$28]($29, $30);
      var $31=$1;
      __ZL14CreateMainMenuR15running_machine($31);
      __label__ = 8; break;
    case 5: // $32
      var $33=$1;
      var $34=__Z16ui_input_pressedR15running_machinei($33, 159);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $36
      var $37=HEAP32[((__ZL4menu)>>2)];
      __Z12ui_menu_freeP7ui_menu($37);
      HEAP32[((__ZL4menu)>>2)]=0;
      __label__ = 7; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      __label__ = 12; break;
    case 9: // $40
      var $41=$1;
      var $42=__Z16ui_input_pressedR15running_machinei($41, 159);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $44
      var $45=$1;
      __ZL14CreateMainMenuR15running_machine($45);
      __label__ = 11; break;
    case 11: // $46
      var $47=$1;
      __ZL13handle_editorR15running_machine($47);
      __label__ = 12; break;
    case 12: // $48
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12handle_menusR15running_machine["X"]=1;

function __ZL12handle_mouseR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $mouse_target;
      var $x=__stackBase__;
      var $y=__stackBase__+4;
      var $button=__stackBase__+8;
      var $dv;
      $1=$machine;
      var $2=HEAP32[((__ZL4menu)>>2)];
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 12; break;
    case 2: // $5
      var $6=$1;
      var $7=__Z19ui_input_find_mouseR15running_machinePiS1_S1_($6, $x, $y, $button);
      $mouse_target=$7;
      var $8=$mouse_target;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      __label__ = 12; break;
    case 4: // $11
      var $12=HEAP32[((__ZL4list)>>2)];
      $dv=$12;
      __label__ = 5; break;
    case 5: // $13
      var $14=$dv;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $16
      var $17=$mouse_target;
      var $18=$dv;
      var $19=(($18+16)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17)|0)==(($20)|0);
      if ($21) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $22
      var $23=$dv;
      var $24=HEAP32[(($x)>>2)];
      var $25=HEAP32[(($y)>>2)];
      var $26=HEAP32[(($button)>>2)];
      var $27=__ZL14dview_on_mouseP5DViewiii($23, $24, $25, $26);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $29
      __label__ = 12; break;
    case 9: // $30
      __label__ = 10; break;
    case 10: // $31
      __label__ = 11; break;
    case 11: // $32
      var $33=$dv;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      $dv=$35;
      __label__ = 5; break;
    case 12: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z27debugint_update_during_gameR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$machine;
      var $2=$1;
      var $3=__Z20debug_cpu_is_stoppedR15running_machine($2);
      var $4=(($3)|0)!=0;
      if ($4) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=__ZNK15running_machine5phaseEv($6);
      var $8=(($7)|0)==3;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      __ZL12update_viewsv();
      __label__ = 3; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11dview_allocP13render_targetR15running_machine15debug_view_typei($target, $machine, $type, $flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $dv;
      var $13;
      var $14;
      var $_hlp;
      $9=$target;
      $10=$machine;
      $11=$type;
      $12=$flags;
      var $15=$10;
      var $16=__ZN15running_machine7respoolEv($15);
      var $17=$4;
      var $18=$5;
      var $19=$6;
      var $20=$result_i;
      var $21=$7;
      var $22=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str54291)|0);
      HEAP32[(($6)>>2)]=308;
      var $23=HEAP32[(($4)>>2)];
      var $24=HEAP32[(($5)>>2)];
      var $25=HEAP32[(($6)>>2)];
      var $26=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23, $24, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $27
      HEAP32[(($result_i)>>2)]=$26;
      var $28=HEAP32[(($result_i)>>2)];
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $30
      var $31=___cxa_allocate_exception(4);
      var $32=$31;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32);
      (function() { try { __THREW__ = false; return ___cxa_throw($31, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      HEAP32[(($7)>>2)]=$35;
      var $36=$34.f1;
      HEAP32[(($8)>>2)]=$36;
      var $37=HEAP32[(($8)>>2)];
      var $38=(($37)|0) < 0;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($40);
      throw "Reached an unreachable!"
    case 5: // $41
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($8)>>2)];
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $47
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $48=HEAP32[(($result_i)>>2)];
      var $49=$4;
      var $50=$5;
      var $51=$6;
      var $52=$result_i;
      var $53=$7;
      var $54=$8;
      var $55=$48;
      var $56=$9;
      var $57=$10;
      var $58=$11;
      var $59=$12;
      (function() { try { __THREW__ = false; return __ZN5DViewC1EP13render_targetR15running_machine15debug_view_typei($55, $56, $57, $58, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $60
      var $61=__ZN13resource_pool10add_objectI5DViewEEPT_S3_($16, $55);
      $dv=$61;
      __label__ = 9; break;
    case 9: // $62
      __label__ = 10; break;
    case 10: // $63
      var $64=HEAP32[((__ZL4list)>>2)];
      $_hlp=$64;
      __label__ = 11; break;
    case 11: // $65
      var $66=$_hlp;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 12; break; } else { __label__ = 21; break; }
    case 12: // $68
      var $69=$_hlp;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $73
      __label__ = 21; break;
    case 14: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $13=$76;
      var $77=$75.f1;
      $14=$77;
      var $78=$1;
      var $79=$2;
      var $80=$3;
      HEAP32[(($1)>>2)]=$48;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str54291)|0);
      HEAP32[(($3)>>2)]=308;
      var $81=HEAP32[(($1)>>2)];
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $83
      var $84=HEAP32[(($1)>>2)];
      var $85=HEAP32[(($2)>>2)];
      var $86=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 28; break; }
    case 16: // $_noexc
      __label__ = 17; break;
    case 17: // $_ZdlPvPKci_exit
      var $87=$1;
      var $88=$2;
      var $89=$3;
      __label__ = 18; break;
    case 18: // $90
      __label__ = 27; break;
    case 19: // $91
      __label__ = 20; break;
    case 20: // $92
      var $93=$_hlp;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      $_hlp=$95;
      __label__ = 11; break;
    case 21: // $96
      __label__ = 22; break;
    case 22: // $97
      var $98=$_hlp;
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $100
      var $101=$dv;
      var $102=$_hlp;
      var $103=(($102)|0);
      HEAP32[(($103)>>2)]=$101;
      __label__ = 25; break;
    case 24: // $104
      var $105=$dv;
      HEAP32[((__ZL4list)>>2)]=$105;
      __label__ = 25; break;
    case 25: // $106
      __label__ = 26; break;
    case 26: // $107
      var $108=$dv;
      STACKTOP = __stackBase__;
      return $108;
    case 27: // $109
      var $110=$13;
      var $111=$13;
      var $112=$14;
      var $113=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $111, tempValue);
      var $114=($113.f1 = $112, $113);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 28: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei["X"]=1;

function __ZL17followers_set_cpuP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $title=__stackBase__;
      var $dv;
      var $2;
      var $3;
      var $source;
      var $4=__stackBase__+64;
      $1=$device;
      __ZN7astringC1Ev($title);
      var $5=HEAP32[((__ZL4list)>>2)];
      $dv=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$dv;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $9
      var $10=$dv;
      var $11=(function() { try { __THREW__ = false; return __ZL14dview_is_stateP5DViewi($10, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $12
      var $13=(($11)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $14
      var $15=$dv;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(function() { try { __THREW__ = false; return __ZNK10debug_view11source_listEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $19
      var $20=$1;
      var $21=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list12match_deviceEP8device_t($18, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $22
      $source=$21;
      var $23=$dv;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      if ($25 == 3 || $25 == 2) {
        __label__ = 8; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 7: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      __label__ = 21; break;
    case 8: // $30
      var $31=$dv;
      var $32=(($31+8)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$source;
      (function() { try { __THREW__ = false; return __ZN10debug_view10set_sourceERK17debug_view_source($33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 9: // $35
      var $36=$source;
      var $37=(function() { try { __THREW__ = false; return __ZNK17debug_view_source4nameEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; };
    case 10: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($title, ((STRING_TABLE.__str344320)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 7; break; };
    case 11: // $40
      var $41=$dv;
      (function() { try { __THREW__ = false; return __ZN7astringC1ERKS_($4, $title) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; }
    case 12: // $42
      (function() { try { __THREW__ = false; return __ZL15dview_set_titleP5DView7astring($41, $4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $43
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 7; break; }
    case 14: // $44
      __label__ = 17; break;
    case 15: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $2=$47;
      var $48=$46.f1;
      $3=$48;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $49
      __label__ = 21; break;
    case 17: // $50
      __label__ = 18; break;
    case 18: // $51
      __label__ = 19; break;
    case 19: // $52
      var $53=$dv;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      $dv=$55;
      __label__ = 1; break;
    case 20: // $56
      FUNCTION_TABLE[__ZN7astringD1Ev]($title);
      STACKTOP = __stackBase__;
      return;
    case 21: // $57
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($title) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $58
      __label__ = 23; break;
    case 23: // $59
      var $60=$2;
      var $61=$2;
      var $62=$3;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17followers_set_cpuP8device_t["X"]=1;

function __ZL14dview_is_stateP5DViewi($dv, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$state;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=$5 & $6;
  var $8=(($7)|0)!=0;
  var $9=$8 ? 1 : 0;
  ;
  return $9;
}


function __ZL18dview_is_state_allP5DViewi($dv, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$state;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=$5 & $6;
  var $8=$2;
  var $9=(($7)|0)==(($8)|0);
  var $10=$9 ? 1 : 0;
  ;
  return $10;
}


function __ZL15dview_set_stateP5DViewii($dv, $state, $onoff) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$dv;
      $2=$state;
      $3=$onoff;
      var $4=$3;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=$1;
      var $9=(($8+24)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 | $7;
      HEAP32[(($9)>>2)]=$11;
      __label__ = 3; break;
    case 2: // $12
      var $13=$2;
      var $14=$13 ^ -1;
      var $15=$1;
      var $16=(($15+24)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$17 & $14;
      HEAP32[(($16)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14dview_on_mouseP5DViewiii($dv, $mx, $my, $button) {
  var __stackBase__  = STACKTOP; STACKTOP += 112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $clicked;
      var $handled;
      var $x=__stackBase__;
      var $y=__stackBase__+4;
      var $dx;
      var $dy;
      var $dx1;
      var $dy2;
      var $pos=__stackBase__+8;
      var $sb;
      var $r=__stackBase__+16;
      var $xt;
      var $6=__stackBase__+32;
      var $7=__stackBase__+40;
      var $pos3=__stackBase__+48;
      var $sb4;
      var $r5=__stackBase__+56;
      var $yt;
      var $8=__stackBase__+72;
      var $9=__stackBase__+80;
      var $topleft=__stackBase__+88;
      var $newpos=__stackBase__+96;
      var $10=__stackBase__+104;
      $2=$dv;
      $3=$mx;
      $4=$my;
      $5=$button;
      var $11=$5;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { var $19 = 0;__label__ = 2; break; }
    case 1: // $13
      var $14=$2;
      var $15=__ZL14dview_is_stateP5DViewi($14, 1);
      var $16=(($15)|0)!=0;
      var $17=$16 ^ 1;
      var $19 = $17;__label__ = 2; break;
    case 2: // $18
      var $19;
      var $20=(($19)&1);
      $clicked=$20;
      $handled=1;
      var $21=$5;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $23
      var $24=$2;
      var $25=__ZL18dview_is_state_allP5DViewi($24, 3);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$3;
      var $29=$2;
      var $30=(($29+116)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28-$31)|0);
      $dx=$32;
      var $33=$4;
      var $34=$2;
      var $35=(($34+120)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($33-$36)|0);
      $dy=$37;
      var $38=$dx;
      var $39=$2;
      var $40=(($39+44)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+$38)|0);
      HEAP32[(($40)>>2)]=$42;
      var $43=$dy;
      var $44=$2;
      var $45=(($44+48)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+$43)|0);
      HEAP32[(($45)>>2)]=$47;
      var $48=$3;
      var $49=$2;
      var $50=(($49+116)|0);
      HEAP32[(($50)>>2)]=$48;
      var $51=$4;
      var $52=$2;
      var $53=(($52+120)|0);
      HEAP32[(($53)>>2)]=$51;
      var $54=$2;
      __ZL15dview_set_stateP5DViewii($54, 8, 1);
      $1=1;
      __label__ = 76; break;
    case 5: // $55
      var $56=$5;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $58
      var $59=$2;
      var $60=__ZL18dview_is_state_allP5DViewi($59, 5);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $62
      var $63=$3;
      var $64=$2;
      var $65=(($64+116)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($63-$66)|0);
      $dx1=$67;
      var $68=$4;
      var $69=$2;
      var $70=(($69+120)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($68-$71)|0);
      $dy2=$72;
      var $73=$dx1;
      var $74=$2;
      var $75=(($74+28)|0);
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+$73)|0);
      HEAP32[(($76)>>2)]=$78;
      var $79=$dy2;
      var $80=$2;
      var $81=(($80+28)|0);
      var $82=(($81+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+$79)|0);
      HEAP32[(($82)>>2)]=$84;
      var $85=$3;
      var $86=$2;
      var $87=(($86+116)|0);
      HEAP32[(($87)>>2)]=$85;
      var $88=$4;
      var $89=$2;
      var $90=(($89+120)|0);
      HEAP32[(($90)>>2)]=$88;
      var $91=$2;
      __ZL15dview_set_stateP5DViewii($91, 8, 1);
      $1=1;
      __label__ = 76; break;
    case 8: // $92
      var $93=$2;
      __ZL15dview_set_stateP5DViewii($93, 6, 0);
      __label__ = 9; break;
    case 9: // $94
      __label__ = 10; break;
    case 10: // $95
      var $96=$2;
      var $97=$3;
      var $98=$4;
      var $99=__ZL9map_pointP5DViewiiPiS1_($96, $97, $98, $x, $y);
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $101
      $1=0;
      __label__ = 76; break;
    case 12: // $102
      var $103=$2;
      var $104=HEAP32[(($x)>>2)];
      var $105=HEAP32[(($y)>>2)];
      var $106=__ZL16dview_xy_in_rectP5DViewiii($103, 2, $104, $105);
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $108
      var $109=$clicked;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $111
      var $112=$3;
      var $113=$2;
      var $114=(($113+116)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=$4;
      var $116=$2;
      var $117=(($116+120)|0);
      HEAP32[(($117)>>2)]=$115;
      var $118=$2;
      __ZL14set_focus_viewP5DView($118);
      var $119=$2;
      __ZL15dview_set_stateP5DViewii($119, 2, 1);
      __label__ = 15; break;
    case 15: // $120
      __label__ = 75; break;
    case 16: // $121
      var $122=$2;
      var $123=HEAP32[(($x)>>2)];
      var $124=HEAP32[(($y)>>2)];
      var $125=__ZL16dview_xy_in_rectP5DViewiii($122, 3, $123, $124);
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 17; break; } else { __label__ = 37; break; }
    case 17: // $127
      __ZN13debug_view_xyC1Eii($pos, 0, 0);
      var $128=$2;
      var $129=(($128+124)|0);
      $sb=$129;
      var $130=$clicked;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 18; break; } else { __label__ = 34; break; }
    case 18: // $132
      var $133=$2;
      __ZL14dview_get_rectP5DViewiP10_rectangle($133, 3, $r);
      var $134=(($r)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=HEAP32[(($x)>>2)];
      var $137=(($136-$135)|0);
      HEAP32[(($x)>>2)]=$137;
      var $138=HEAP32[(($x)>>2)];
      var $139=(($138-20)|0);
      var $140=$sb;
      var $141=(($140+8)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$sb;
      var $144=(($143+4)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($142-$145)|0);
      var $147=(($139*$146)|0);
      var $148=__ZL14rect_get_widthP10_rectangle($r);
      var $149=$2;
      var $150=(($149+152)|0);
      var $151=(($150)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=((($152<<1))|0);
      var $154=(($153*20)|0);
      var $155=(($148-$154)|0);
      var $156=(((($147)|0)/(($155)|0))|0);
      var $157=$sb;
      var $158=(($157+4)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($156+$159)|0);
      $xt=$160;
      var $161=HEAP32[(($x)>>2)];
      var $162=(($161)|0) < 20;
      if ($162) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $163
      var $164=$sb;
      var $165=(($164+16)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$sb;
      var $168=(($167+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169-$166)|0);
      HEAP32[(($168)>>2)]=$170;
      __label__ = 29; break;
    case 20: // $171
      var $172=HEAP32[(($x)>>2)];
      var $173=__ZL14rect_get_widthP10_rectangle($r);
      var $174=(($173-20)|0);
      var $175=(($172)|0) > (($174)|0);
      if ($175) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $176
      var $177=$sb;
      var $178=(($177+16)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$sb;
      var $181=(($180+12)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=(($182+$179)|0);
      HEAP32[(($181)>>2)]=$183;
      __label__ = 28; break;
    case 22: // $184
      var $185=$xt;
      var $186=$sb;
      var $187=(($186+12)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($185)|0) < (($188)|0);
      if ($189) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $190
      var $191=$sb;
      var $192=(($191+20)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$sb;
      var $195=(($194+12)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196-$193)|0);
      HEAP32[(($195)>>2)]=$197;
      __label__ = 27; break;
    case 24: // $198
      var $199=$xt;
      var $200=$sb;
      var $201=(($200+12)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($199)|0) > (($202)|0);
      if ($203) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $204
      var $205=$sb;
      var $206=(($205+20)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$sb;
      var $209=(($208+12)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=(($210+$207)|0);
      HEAP32[(($209)>>2)]=$211;
      __label__ = 26; break;
    case 26: // $212
      __label__ = 27; break;
    case 27: // $213
      __label__ = 28; break;
    case 28: // $214
      __label__ = 29; break;
    case 29: // $215
      var $216=$sb;
      var $217=(($216+12)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$sb;
      var $220=(($219+4)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($218)|0) < (($221)|0);
      if ($222) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $223
      var $224=$sb;
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$sb;
      var $228=(($227+12)|0);
      HEAP32[(($228)>>2)]=$226;
      __label__ = 31; break;
    case 31: // $229
      var $230=$sb;
      var $231=(($230+12)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=$sb;
      var $234=(($233+8)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($232)|0) > (($235)|0);
      if ($236) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $237
      var $238=$sb;
      var $239=(($238+8)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$sb;
      var $242=(($241+12)|0);
      HEAP32[(($242)>>2)]=$240;
      __label__ = 33; break;
    case 33: // $243
      __label__ = 34; break;
    case 34: // $244
      var $245=$2;
      var $246=(($245+8)|0);
      var $247=HEAP32[(($246)>>2)];
      __ZN10debug_view16visible_positionEv($6, $247);
      var $248=$pos;
      var $249=$6;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($248)>>2)]=HEAP32[(($249)>>2)];HEAP32[(($248+4)>>2)]=HEAP32[(($249+4)>>2)];
      var $250=$sb;
      var $251=(($250+12)|0);
      var $252=HEAP32[(($251)>>2)];
      var $253=(($pos)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($252)|0)!=(($254)|0);
      if ($255) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $256
      var $257=$sb;
      var $258=(($257+12)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($pos)|0);
      HEAP32[(($260)>>2)]=$259;
      var $261=$2;
      var $262=(($261+8)|0);
      var $263=HEAP32[(($262)>>2)];
      var $264=$7;
      var $265=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($264)>>2)]=HEAP32[(($265)>>2)];HEAP32[(($264+4)>>2)]=HEAP32[(($265+4)>>2)];
      __ZN10debug_view20set_visible_positionE13debug_view_xy($263, $7);
      var $266=$2;
      __ZL15dview_set_stateP5DViewii($266, 8, 1);
      __label__ = 36; break;
    case 36: // $267
      __label__ = 74; break;
    case 37: // $268
      var $269=$2;
      var $270=HEAP32[(($x)>>2)];
      var $271=HEAP32[(($y)>>2)];
      var $272=__ZL16dview_xy_in_rectP5DViewiii($269, 4, $270, $271);
      var $273=(($272)|0)!=0;
      if ($273) { __label__ = 38; break; } else { __label__ = 58; break; }
    case 38: // $274
      __ZN13debug_view_xyC1Eii($pos3, 0, 0);
      var $275=$2;
      var $276=(($275+152)|0);
      $sb4=$276;
      var $277=$clicked;
      var $278=(($277)|0)!=0;
      if ($278) { __label__ = 39; break; } else { __label__ = 55; break; }
    case 39: // $279
      var $280=$2;
      __ZL14dview_get_rectP5DViewiP10_rectangle($280, 4, $r5);
      var $281=(($r5+8)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=HEAP32[(($y)>>2)];
      var $284=(($283-$282)|0);
      HEAP32[(($y)>>2)]=$284;
      var $285=HEAP32[(($y)>>2)];
      var $286=(($285-20)|0);
      var $287=$sb4;
      var $288=(($287+8)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=$sb4;
      var $291=(($290+4)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($289-$292)|0);
      var $294=(($286*$293)|0);
      var $295=__ZL15rect_get_heightP10_rectangle($r5);
      var $296=(($295-40)|0);
      var $297=(((($294)|0)/(($296)|0))|0);
      var $298=$sb4;
      var $299=(($298+4)|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=(($297+$300)|0);
      $yt=$301;
      var $302=HEAP32[(($y)>>2)];
      var $303=(($302)|0) < 20;
      if ($303) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $304
      var $305=$sb4;
      var $306=(($305+16)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=$sb4;
      var $309=(($308+12)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=(($310-$307)|0);
      HEAP32[(($309)>>2)]=$311;
      __label__ = 50; break;
    case 41: // $312
      var $313=HEAP32[(($y)>>2)];
      var $314=__ZL15rect_get_heightP10_rectangle($r5);
      var $315=(($314-20)|0);
      var $316=(($313)|0) > (($315)|0);
      if ($316) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $317
      var $318=$sb4;
      var $319=(($318+16)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$sb4;
      var $322=(($321+12)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=(($323+$320)|0);
      HEAP32[(($322)>>2)]=$324;
      __label__ = 49; break;
    case 43: // $325
      var $326=$yt;
      var $327=$sb4;
      var $328=(($327+12)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=(($326)|0) < (($329)|0);
      if ($330) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $331
      var $332=$sb4;
      var $333=(($332+20)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=$sb4;
      var $336=(($335+12)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=(($337-$334)|0);
      HEAP32[(($336)>>2)]=$338;
      __label__ = 48; break;
    case 45: // $339
      var $340=$yt;
      var $341=$sb4;
      var $342=(($341+12)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(($340)|0) > (($343)|0);
      if ($344) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $345
      var $346=$sb4;
      var $347=(($346+20)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$sb4;
      var $350=(($349+12)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=(($351+$348)|0);
      HEAP32[(($350)>>2)]=$352;
      __label__ = 47; break;
    case 47: // $353
      __label__ = 48; break;
    case 48: // $354
      __label__ = 49; break;
    case 49: // $355
      __label__ = 50; break;
    case 50: // $356
      var $357=$sb4;
      var $358=(($357+12)|0);
      var $359=HEAP32[(($358)>>2)];
      var $360=$sb4;
      var $361=(($360+4)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=(($359)|0) < (($362)|0);
      if ($363) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $364
      var $365=$sb4;
      var $366=(($365+4)|0);
      var $367=HEAP32[(($366)>>2)];
      var $368=$sb4;
      var $369=(($368+12)|0);
      HEAP32[(($369)>>2)]=$367;
      __label__ = 52; break;
    case 52: // $370
      var $371=$sb4;
      var $372=(($371+12)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=$sb4;
      var $375=(($374+8)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=(($373)|0) > (($376)|0);
      if ($377) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $378
      var $379=$sb4;
      var $380=(($379+8)|0);
      var $381=HEAP32[(($380)>>2)];
      var $382=$sb4;
      var $383=(($382+12)|0);
      HEAP32[(($383)>>2)]=$381;
      __label__ = 54; break;
    case 54: // $384
      __label__ = 55; break;
    case 55: // $385
      var $386=$2;
      var $387=(($386+8)|0);
      var $388=HEAP32[(($387)>>2)];
      __ZN10debug_view16visible_positionEv($8, $388);
      var $389=$pos3;
      var $390=$8;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($389)>>2)]=HEAP32[(($390)>>2)];HEAP32[(($389+4)>>2)]=HEAP32[(($390+4)>>2)];
      var $391=$sb4;
      var $392=(($391+12)|0);
      var $393=HEAP32[(($392)>>2)];
      var $394=(($pos3+4)|0);
      var $395=HEAP32[(($394)>>2)];
      var $396=(($393)|0)!=(($395)|0);
      if ($396) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $397
      var $398=$sb4;
      var $399=(($398+12)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=(($pos3+4)|0);
      HEAP32[(($401)>>2)]=$400;
      var $402=$2;
      var $403=(($402+8)|0);
      var $404=HEAP32[(($403)>>2)];
      var $405=$9;
      var $406=$pos3;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($405)>>2)]=HEAP32[(($406)>>2)];HEAP32[(($405+4)>>2)]=HEAP32[(($406+4)>>2)];
      __ZN10debug_view20set_visible_positionE13debug_view_xy($404, $9);
      var $407=$2;
      __ZL15dview_set_stateP5DViewii($407, 8, 1);
      __label__ = 57; break;
    case 57: // $408
      __label__ = 73; break;
    case 58: // $409
      var $410=$2;
      var $411=HEAP32[(($x)>>2)];
      var $412=HEAP32[(($y)>>2)];
      var $413=__ZL16dview_xy_in_rectP5DViewiii($410, 5, $411, $412);
      var $414=(($413)|0)!=0;
      if ($414) { __label__ = 59; break; } else { __label__ = 62; break; }
    case 59: // $415
      var $416=$clicked;
      var $417=(($416)|0)!=0;
      if ($417) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $418
      var $419=$3;
      var $420=$2;
      var $421=(($420+116)|0);
      HEAP32[(($421)>>2)]=$419;
      var $422=$4;
      var $423=$2;
      var $424=(($423+120)|0);
      HEAP32[(($424)>>2)]=$422;
      var $425=$2;
      __ZL14set_focus_viewP5DView($425);
      var $426=$2;
      __ZL15dview_set_stateP5DViewii($426, 4, 1);
      __label__ = 61; break;
    case 61: // $427
      __label__ = 72; break;
    case 62: // $428
      var $429=$2;
      var $430=HEAP32[(($x)>>2)];
      var $431=HEAP32[(($y)>>2)];
      var $432=__ZL16dview_xy_in_rectP5DViewiii($429, 1, $430, $431);
      var $433=(($432)|0)!=0;
      if ($433) { __label__ = 63; break; } else { __label__ = 70; break; }
    case 63: // $434
      var $435=HEAP32[(($y)>>2)];
      var $436=(($435-20)|0);
      HEAP32[(($y)>>2)]=$436;
      var $437=$2;
      var $438=(($437+8)|0);
      var $439=HEAP32[(($438)>>2)];
      var $440=__ZN10debug_view16cursor_supportedEv($439);
      if ($440) { __label__ = 64; break; } else { __label__ = 67; break; }
    case 64: // $441
      var $442=$clicked;
      var $443=(($442)|0)!=0;
      if ($443) { __label__ = 65; break; } else { __label__ = 67; break; }
    case 65: // $444
      var $445=HEAP32[(($y)>>2)];
      var $446=(($445)|0) >= 0;
      if ($446) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $447
      var $448=$2;
      var $449=(($448+8)|0);
      var $450=HEAP32[(($449)>>2)];
      __ZN10debug_view16visible_positionEv($topleft, $450);
      __ZN13debug_view_xyC1Eii($newpos, 0, 0);
      var $451=(($topleft)|0);
      var $452=HEAP32[(($451)>>2)];
      var $453=HEAP32[(($x)>>2)];
      var $454=HEAP32[((__ZL16debug_font_width)>>2)];
      var $455=(((($453)|0)/(($454)|0))|0);
      var $456=(($452+$455)|0);
      var $457=(($newpos)|0);
      HEAP32[(($457)>>2)]=$456;
      var $458=(($topleft+4)|0);
      var $459=HEAP32[(($458)>>2)];
      var $460=HEAP32[(($y)>>2)];
      var $461=HEAP32[((__ZL17debug_font_height)>>2)];
      var $462=(((($460)|0)/(($461)|0))|0);
      var $463=(($459+$462)|0);
      var $464=(($newpos+4)|0);
      HEAP32[(($464)>>2)]=$463;
      var $465=$2;
      var $466=(($465+8)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=$10;
      var $469=$newpos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($468)>>2)]=HEAP32[(($469)>>2)];HEAP32[(($468+4)>>2)]=HEAP32[(($469+4)>>2)];
      __ZN10debug_view19set_cursor_positionE13debug_view_xy($467, $10);
      var $470=$2;
      var $471=(($470+8)|0);
      var $472=HEAP32[(($471)>>2)];
      __ZN10debug_view18set_cursor_visibleEb($472, 1);
      __label__ = 67; break;
    case 67: // $473
      var $474=$clicked;
      var $475=(($474)|0)!=0;
      if ($475) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $476
      var $477=$2;
      __ZL14set_focus_viewP5DView($477);
      __label__ = 69; break;
    case 69: // $478
      __label__ = 71; break;
    case 70: // $479
      $handled=0;
      __label__ = 71; break;
    case 71: // $480
      __label__ = 72; break;
    case 72: // $481
      __label__ = 73; break;
    case 73: // $482
      __label__ = 74; break;
    case 74: // $483
      __label__ = 75; break;
    case 75: // $484
      var $485=$2;
      var $486=$5;
      __ZL15dview_set_stateP5DViewii($485, 1, $486);
      var $487=$handled;
      $1=$487;
      __label__ = 76; break;
    case 76: // $488
      var $489=$1;
      STACKTOP = __stackBase__;
      return $489;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14dview_on_mouseP5DViewiii["X"]=1;

function __ZL9map_pointP5DViewiiPiS1_($dv, $target_x, $target_y, $mapped_x, $mapped_y) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $pos=__stackBase__;
      $2=$dv;
      $3=$target_x;
      $4=$target_y;
      $5=$mapped_x;
      $6=$mapped_y;
      var $7=$5;
      HEAP32[(($7)>>2)]=-1;
      var $8=$6;
      HEAP32[(($8)>>2)]=-1;
      var $9=$2;
      var $10=(($9+28)|0);
      var $11=$pos;
      var $12=$10;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($11)>>2)]=HEAP32[(($12)>>2)];HEAP32[(($11+4)>>2)]=HEAP32[(($12+4)>>2)];HEAP32[(($11+8)>>2)]=HEAP32[(($12+8)>>2)];HEAP32[(($11+12)>>2)]=HEAP32[(($12+12)>>2)];
      var $13=$2;
      var $14=(($13+44)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($pos)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+$15)|0);
      HEAP32[(($16)>>2)]=$18;
      var $19=$2;
      var $20=(($19+44)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($pos+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+$21)|0);
      HEAP32[(($22)>>2)]=$24;
      var $25=$2;
      var $26=(($25+48)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($pos+8)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$27)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$2;
      var $32=(($31+48)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($pos+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+$33)|0);
      HEAP32[(($34)>>2)]=$36;
      var $37=$3;
      var $38=(($pos)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($37)|0) >= (($39)|0);
      if ($40) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $41
      var $42=$3;
      var $43=(($pos+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($42)|0) <= (($44)|0);
      if ($45) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $46
      var $47=$4;
      var $48=(($pos+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($47)|0) >= (($49)|0);
      if ($50) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $51
      var $52=$4;
      var $53=(($pos+12)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($52)|0) <= (($54)|0);
      if ($55) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $56
      var $57=$3;
      var $58=(($pos)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($57-$59)|0);
      var $61=$5;
      HEAP32[(($61)>>2)]=$60;
      var $62=$4;
      var $63=(($pos+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($62-$64)|0);
      var $66=$6;
      HEAP32[(($66)>>2)]=$65;
      $1=1;
      __label__ = 6; break;
    case 5: // $67
      $1=0;
      __label__ = 6; break;
    case 6: // $68
      var $69=$1;
      STACKTOP = __stackBase__;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9map_pointP5DViewiiPiS1_["X"]=1;

function __ZL16dview_xy_in_rectP5DViewiii($dv, $type, $x, $y) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $r=__stackBase__;
      $2=$dv;
      $3=$type;
      $4=$x;
      $5=$y;
      var $6=$2;
      var $7=$3;
      __ZL14dview_get_rectP5DViewiP10_rectangle($6, $7, $r);
      var $8=$4;
      var $9=(($r)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($8)|0) >= (($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $12
      var $13=$4;
      var $14=(($r+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($13)|0) <= (($15)|0);
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=$5;
      var $19=(($r+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($18)|0) >= (($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      var $23=$5;
      var $24=(($r+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($23)|0) <= (($25)|0);
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      $1=1;
      __label__ = 6; break;
    case 5: // $28
      $1=0;
      __label__ = 6; break;
    case 6: // $29
      var $30=$1;
      STACKTOP = __stackBase__;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13debug_view_xyC1Eii($this, $_x, $_y) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$_x;
  $3=$_y;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN13debug_view_xyC2Eii($4, $5, $6);
  ;
  return;
}

// WARNING: content after a branch in a label, line: 525235

function __Z8downcastIP17debug_view_disasm10debug_viewET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIP17debug_view_memory10debug_viewET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14rect_get_widthP10_rectangle($r) {
  ;
  var __label__;

  var $1;
  $1=$r;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($4-$7)|0);
  var $9=(($8+1)|0);
  ;
  return $9;
}


function __ZL15rect_get_heightP10_rectangle($r) {
  ;
  var __label__;

  var $1;
  $1=$r;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($4-$7)|0);
  var $9=(($8+1)|0);
  ;
  return $9;
}


function __ZN10debug_view12begin_updateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+75)|0);
  var $4=HEAP8[($3)];
  var $5=(($4+1)&255);
  HEAP8[($3)]=$5;
  ;
  return;
}


function __ZN13debug_view_xyC2Eii($this, $_x, $_y) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$_x;
  $3=$_y;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  ;
  return;
}


function __ZNK5DView7machineEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17debug_view_disasm12right_columnEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+92)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN10debug_view16visible_positionEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view13flush_updatesEv($2);
  var $3=(($2+56)|0);
  var $4=$agg_result;
  var $5=$3;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];
  ;
  return;
}


function __ZN10debug_view16cursor_supportedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view13flush_updatesEv($2);
  var $3=(($2+72)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN10debug_view13flush_updatesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view12begin_updateEv($2);
  __ZN10debug_view10end_updateEv($2);
  ;
  return;
}


function __ZL13handle_editorR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $event=__stackBase__;
      var $buf=__stackBase__+24;
      var $ret;
      $1=$machine;
      var $2=HEAP32[((__ZL10focus_view)>>2)];
      var $3=(($2+188)|0);
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 22; break; }
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=$1;
      var $10=__Z18ui_input_pop_eventR15running_machineP9_ui_event($9, $event);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $12
      var $13=(($event)|0);
      var $14=HEAP32[(($13)>>2)];
      if ($14 == 6) {
        __label__ = 4; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 4: // $15
      var $16=(($event+20)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==8;
      if ($18) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $19
      var $20=(($event+20)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==127;
      if ($22) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $23
      var $24=HEAP32[((__ZL10focus_view)>>2)];
      var $25=(($24+188)|0);
      var $26=(($25+8)|0);
      var $27=__ZNK7astring3lenEv($26);
      var $28=(($27)|0) > 0;
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=HEAP32[((__ZL10focus_view)>>2)];
      var $31=(($30+188)|0);
      HEAP32[((__ZL10cur_editor)>>2)]=$31;
      var $32=HEAP32[((__ZL10cur_editor)>>2)];
      var $33=(($32+8)|0);
      var $34=HEAP32[((__ZL10cur_editor)>>2)];
      var $35=(($34+8)|0);
      var $36=HEAP32[((__ZL10cur_editor)>>2)];
      var $37=(($36+8)|0);
      var $38=__ZNK7astring3lenEv($37);
      var $39=(($38-1)|0);
      var $40=__ZN7astring6substrEii($35, 0, $39);
      var $41=__ZN7astringaSERKS_($33, $40);
      __label__ = 12; break;
    case 8: // $42
      var $43=(($event+20)|0);
      var $44=HEAPU32[(($43)>>2)];
      var $45=(($44)>>>0) >= 32;
      if ($45) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $46
      var $47=(($event+20)|0);
      var $48=HEAPU32[(($47)>>2)];
      var $49=(($48)>>>0) < 127;
      if ($49) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $50
      var $51=HEAP32[((__ZL10focus_view)>>2)];
      var $52=(($51+188)|0);
      HEAP32[((__ZL10cur_editor)>>2)]=$52;
      var $53=(($buf)|0);
      var $54=(($event+20)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=__Z15utf8_from_ucharPcjj($53, 10, $55);
      $ret=$56;
      var $57=$ret;
      var $58=(($buf+$57)|0);
      HEAP8[($58)]=0;
      var $59=HEAP32[((__ZL10cur_editor)>>2)];
      var $60=(($59+8)|0);
      var $61=HEAP32[((__ZL10cur_editor)>>2)];
      var $62=(($61+8)|0);
      var $63=(($buf)|0);
      var $64=__ZN7astring3catEPKc($62, $63);
      var $65=__ZN7astringaSERKS_($60, $64);
      __label__ = 11; break;
    case 11: // $66
      __label__ = 12; break;
    case 12: // $67
      __label__ = 14; break;
    case 13: // $68
      __label__ = 14; break;
    case 14: // $69
      __label__ = 2; break;
    case 15: // $70
      var $71=HEAP32[((__ZL10cur_editor)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $73
      var $74=HEAP32[((__ZL10cur_editor)>>2)];
      __ZL13render_editorP10DView_edit($74);
      var $75=$1;
      var $76=__Z16ui_input_pressedR15running_machinei($75, 182);
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $78
      var $79=HEAP32[((__ZL10focus_view)>>2)];
      var $80=HEAP32[((__ZL10focus_view)>>2)];
      var $81=(($80+188)|0);
      var $82=(($81+8)|0);
      var $83=__ZNK7astringcvPKcEv($82);
      __ZL14process_stringP5DViewPKc($79, $83);
      var $84=HEAP32[((__ZL10focus_view)>>2)];
      var $85=(($84+188)|0);
      var $86=(($85+8)|0);
      var $87=__ZN7astringaSEPKc($86, ((__str64292)|0));
      HEAP32[((__ZL10cur_editor)>>2)]=0;
      __label__ = 18; break;
    case 18: // $88
      var $89=$1;
      var $90=__Z16ui_input_pressedR15running_machinei($89, 183);
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $92
      HEAP32[((__ZL10cur_editor)>>2)]=0;
      __label__ = 20; break;
    case 20: // $93
      __label__ = 21; break;
    case 21: // $94
      __label__ = 22; break;
    case 22: // $95
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13handle_editorR15running_machine["X"]=1;

function __ZL13render_editorP10DView_edit($editor) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $width=__stackBase__;
      var $maxwidth;
      var $x1;
      var $y1;
      var $x2;
      var $y2;
      $1=$editor;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      __ZN16render_container5emptyEv($4);
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$1;
      var $9=(($8+8)|0);
      var $10=__ZNK7astringcvPKcEv($9);
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($7, $10, 0, 0, 1, 1, 1, 0, -1, -16777216, $width, 0);
      var $11=HEAPF32[(($width)>>2)];
      var $12=$11+0.019999999552965164;
      HEAPF32[(($width)>>2)]=$12;
      var $13=HEAPF32[(($width)>>2)];
      var $14=$13;
      var $15=$14 > 0.5;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=HEAPF32[(($width)>>2)];
      var $18=$17;
      var $21 = $18;__label__ = 3; break;
    case 2: // $19
      var $21 = 0.5;__label__ = 3; break;
    case 3: // $20
      var $21;
      var $22=$21;
      $maxwidth=$22;
      var $23=$maxwidth;
      var $24=$23*0.5;
      var $25=0.5-$24;
      $x1=$25;
      var $26=$x1;
      var $27=$maxwidth;
      var $28=$26+$27;
      $x2=$28;
      $y1=0.25;
      $y2=0.4399999976158142;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$x1;
      var $33=$y1;
      var $34=$x2;
      var $35=$y2;
      __Z20ui_draw_outlined_boxP16render_containerffffj($31, $32, $33, $34, $35, -284159952);
      var $36=$x1;
      var $37=$36+0.009999999776482582;
      $x1=$37;
      var $38=$x2;
      var $39=$38-0.009999999776482582;
      $x2=$39;
      var $40=$y1;
      var $41=$40+0.009999999776482582;
      $y1=$41;
      var $42=$y2;
      var $43=$42-0.009999999776482582;
      $y2=$43;
      var $44=$1;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$1;
      var $48=(($47+8)|0);
      var $49=__ZNK7astringcvPKcEv($48);
      var $50=$x1;
      var $51=$y1;
      var $52=$x2;
      var $53=$x1;
      var $54=$52-$53;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($46, $49, $50, $51, $54, 1, 1, 1, -1, -285212672, 0, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13render_editorP10DView_edit["X"]=1;

function __ZL14process_stringP5DViewPKc($dv, $str) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$dv;
      $2=$str;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      if ($5 == 3) {
        __label__ = 1; break;
      }
      else if ($5 == 1) {
        __label__ = 2; break;
      }
      else if ($5 == 4) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $6
      var $7=$1;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__Z8downcastIP17debug_view_disasm10debug_viewET_PT0_($9);
      var $11=$2;
      __ZN17debug_view_disasm14set_expressionEPKc($10, $11);
      __label__ = 7; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13+188)|0);
      var $15=(($14+8)|0);
      var $16=__ZNK7astringcvPKcEv($15);
      var $17=(($16)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=$1;
      var $22=__ZNK5DView7machineEv($21);
      var $23=__Z25debug_cpu_get_visible_cpuR15running_machine($22);
      var $24=__ZNK8device_t5debugEv($23);
      __ZN12device_debug11single_stepEi($24, 1);
      __label__ = 5; break;
    case 4: // $25
      var $26=$1;
      var $27=__ZNK5DView7machineEv($26);
      var $28=$2;
      var $29=__Z29debug_console_execute_commandR15running_machinePKci($27, $28, 1);
      __label__ = 5; break;
    case 5: // $30
      __label__ = 7; break;
    case 6: // $31
      var $32=$1;
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__Z8downcastIP17debug_view_memory10debug_viewET_PT0_($34);
      var $36=$2;
      __ZN17debug_view_memory14set_expressionEPKc($35, $36);
      __label__ = 7; break;
    case 7: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14dview_get_rectP5DViewiP10_rectangle($dv, $type, $rect) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$dv;
      $2=$type;
      $3=$rect;
      var $6=$3;
      var $7=$1;
      var $8=(($7+28)|0);
      var $9=$6;
      var $10=$8;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[(($10+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[(($10+8)>>2)];HEAP32[(($9+12)>>2)]=HEAP32[(($10+12)>>2)];
      var $11=$2;
      if ($11 == 0) {
        __label__ = 10; break;
      }
      else if ($11 == 1) {
        __label__ = 1; break;
      }
      else if ($11 == 3) {
        __label__ = 2; break;
      }
      else if ($11 == 4) {
        __label__ = 3; break;
      }
      else if ($11 == 5) {
        __label__ = 4; break;
      }
      else if ($11 == 2) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 1: // $12
      var $13=$3;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1)|0);
      HEAP32[(($14)>>2)]=$16;
      var $17=$1;
      var $18=(($17+152)|0);
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20*20)|0);
      var $22=(($21+1)|0);
      var $23=$3;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25-$22)|0);
      HEAP32[(($24)>>2)]=$26;
      var $27=$3;
      var $28=(($27+8)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+22)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$1;
      var $32=(($31+124)|0);
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34*20)|0);
      var $36=(($35+1)|0);
      var $37=$3;
      var $38=(($37+12)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-$36)|0);
      HEAP32[(($38)>>2)]=$40;
      __label__ = 10; break;
    case 2: // $41
      var $42=$3;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0);
      HEAP32[(($43)>>2)]=$45;
      var $46=$3;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48-20)|0);
      HEAP32[(($47)>>2)]=$49;
      var $50=$1;
      var $51=(($50+28)|0);
      var $52=(($51+12)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53-20)|0);
      var $55=$3;
      var $56=(($55+8)|0);
      HEAP32[(($56)>>2)]=$54;
      var $57=$3;
      var $58=(($57+12)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0);
      HEAP32[(($58)>>2)]=$60;
      __label__ = 10; break;
    case 3: // $61
      var $62=$1;
      var $63=(($62+28)|0);
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65-20)|0);
      var $67=$3;
      var $68=(($67)|0);
      HEAP32[(($68)>>2)]=$66;
      var $69=$3;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0);
      HEAP32[(($70)>>2)]=$72;
      var $73=$3;
      var $74=(($73+8)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+20)|0);
      HEAP32[(($74)>>2)]=$76;
      var $77=$3;
      var $78=(($77+12)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79-20)|0);
      HEAP32[(($78)>>2)]=$80;
      __label__ = 10; break;
    case 4: // $81
      var $82=$1;
      var $83=(($82+28)|0);
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85-20)|0);
      var $87=$3;
      var $88=(($87)|0);
      HEAP32[(($88)>>2)]=$86;
      var $89=$3;
      var $90=(($89+4)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91)|0);
      HEAP32[(($90)>>2)]=$92;
      var $93=$1;
      var $94=(($93+28)|0);
      var $95=(($94+12)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96-20)|0);
      var $98=$3;
      var $99=(($98+8)|0);
      HEAP32[(($99)>>2)]=$97;
      var $100=$3;
      var $101=(($100+12)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102)|0);
      HEAP32[(($101)>>2)]=$103;
      __label__ = 10; break;
    case 5: // $104
      var $105=$3;
      var $106=(($105)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107)|0);
      HEAP32[(($106)>>2)]=$108;
      var $109=$3;
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111)|0);
      HEAP32[(($110)>>2)]=$112;
      var $113=$3;
      var $114=(($113+8)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115)|0);
      HEAP32[(($114)>>2)]=$116;
      var $117=$3;
      var $118=(($117+8)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+20)|0);
      var $121=(($120-1)|0);
      var $122=$3;
      var $123=(($122+12)|0);
      HEAP32[(($123)>>2)]=$121;
      __label__ = 10; break;
    case 6: // $124
      __label__ = 7; break;
    case 7: // $125
      var $126=___cxa_allocate_exception(1032);
      var $127=$126;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($127, ((STRING_TABLE.__str34289)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__str44290)|0),HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str54291)|0),HEAP32[((tempInt+8)>>2)]=362,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $128
      ___cxa_throw($126, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 9: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      $4=$131;
      var $132=$130.f1;
      $5=$132;
      ___cxa_free_exception($126);
      __label__ = 11; break;
    case 10: // $134
      ;
      return;
    case 11: // $135
      var $136=$4;
      var $137=$4;
      var $138=$5;
      var $139=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $137, tempValue);
      var $140=($139.f1 = $138, $139);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14dview_get_rectP5DViewiP10_rectangle["X"]=1;

function __ZL14CreateMainMenuR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $subtext;
      var $rc;
      var $title=__stackBase__;
      var $2;
      var $3;
      $1=$machine;
      $subtext=((__str64292)|0);
      __ZN7astringC1Ev($title);
      var $4=HEAP32[((__ZL4menu)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      var $7=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z12ui_menu_freeP7ui_menu($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $8
      __label__ = 4; break;
    case 3: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($title) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 4: // $13
      var $14=$1;
      var $15=$1;
      var $16=(function() { try { __THREW__ = false; return __ZNK15running_machine6renderEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 3; break; };
    case 5: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK14render_manager12ui_containerEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; };
    case 6: // $19
      var $20=(function() { try { __THREW__ = false; return __Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($14, $18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 3; break; };
    case 7: // $21
      HEAP32[((__ZL4menu)>>2)]=$20;
      var $22=HEAP32[((__ZL10focus_view)>>2)];
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      if ($24 == 3) {
        __label__ = 8; break;
      }
      else if ($24 == 1) {
        __label__ = 10; break;
      }
      else if ($24 == 5) {
        __label__ = 12; break;
      }
      else if ($24 == 4) {
        __label__ = 14; break;
      }
      else if ($24 == 2) {
        __label__ = 16; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 8: // $25
      var $26=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($title, ((STRING_TABLE.__str74293)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 3; break; };
    case 9: // $27
      __label__ = 18; break;
    case 10: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($title, ((STRING_TABLE.__str84294)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 3; break; };
    case 11: // $30
      __label__ = 18; break;
    case 12: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($title, ((STRING_TABLE.__str94295)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 3; break; };
    case 13: // $33
      __label__ = 18; break;
    case 14: // $34
      var $35=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($title, ((STRING_TABLE.__str104296)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 3; break; };
    case 15: // $36
      __label__ = 18; break;
    case 16: // $37
      var $38=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($title, ((STRING_TABLE.__str114297)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 3; break; };
    case 17: // $39
      __label__ = 18; break;
    case 18: // $40
      var $41=HEAP32[((__ZL4menu)>>2)];
      var $42=HEAP32[((__ZL10focus_view)>>2)];
      var $43=(($42+52)|0);
      var $44=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($title, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 3; break; };
    case 19: // $45
      var $46=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 3; break; };
    case 20: // $47
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($41, $46, 0, 32, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 3; break; }
    case 21: // $48
      var $49=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($49, ((STRING_TABLE.__str124298)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 3; break; }
    case 22: // $50
      var $51=HEAP32[((__ZL10focus_view)>>2)];
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      if ($53 == 3) {
        __label__ = 23; break;
      }
      else {
      __label__ = 39; break;
      }
      
    case 23: // $54
      var $55=HEAP32[((__ZL10focus_view)>>2)];
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(function() { try { __THREW__ = false; return __Z8downcastIP17debug_view_disasm10debug_viewET_PT0_($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 3; break; };
    case 24: // $59
      var $60=(function() { try { __THREW__ = false; return __ZNK17debug_view_disasm12right_columnEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 3; break; };
    case 25: // $61
      $rc=$60;
      var $62=$rc;
      if ($62 == 1) {
        __label__ = 26; break;
      }
      else if ($62 == 2) {
        __label__ = 27; break;
      }
      else if ($62 == 3) {
        __label__ = 28; break;
      }
      else {
      __label__ = 29; break;
      }
      
    case 26: // $63
      $subtext=((STRING_TABLE.__str134299)|0);
      __label__ = 29; break;
    case 27: // $64
      $subtext=((STRING_TABLE.__str144300)|0);
      __label__ = 29; break;
    case 28: // $65
      $subtext=((STRING_TABLE.__str154301)|0);
      __label__ = 29; break;
    case 29: // $66
      var $67=HEAP32[((__ZL4menu)>>2)];
      var $68=$subtext;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($67, ((STRING_TABLE.__str164302)|0), $68, 2, 1074) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 3; break; }
    case 30: // $69
      var $70=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($70, ((STRING_TABLE.__str174303)|0), 0, 0, 1076) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 3; break; }
    case 31: // $71
      var $72=HEAP32[((__ZL10focus_view)>>2)];
      var $73=(function() { try { __THREW__ = false; return __ZL14dview_is_stateP5DViewi($72, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 3; break; };
    case 32: // $74
      var $75=(($73)|0)!=0;
      if ($75) { __label__ = 37; break; } else { __label__ = 33; break; }
    case 33: // $76
      var $77=HEAP32[((__ZL4menu)>>2)];
      var $78=HEAP32[((__ZL10focus_view)>>2)];
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(function() { try { __THREW__ = false; return __ZNK10debug_view6sourceEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 3; break; };
    case 34: // $82
      var $83=(function() { try { __THREW__ = false; return __ZNK17debug_view_source4nameEv($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 3; break; };
    case 35: // $84
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($77, ((STRING_TABLE.__str184304)|0), $83, 2, 1078) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 3; break; }
    case 36: // $85
      __label__ = 37; break;
    case 37: // $86
      var $87=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($87, ((STRING_TABLE.__str124298)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 3; break; }
    case 38: // $88
      __label__ = 39; break;
    case 39: // $89
      var $90=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($90, ((STRING_TABLE.__str194305)|0), 0, 0, 1080) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 3; break; }
    case 40: // $91
      var $92=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($92, ((STRING_TABLE.__str204306)|0), 0, 0, 1082) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 3; break; }
    case 41: // $93
      var $94=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($94, ((STRING_TABLE.__str214307)|0), 0, 0, 1084) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 3; break; }
    case 42: // $95
      var $96=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($96, ((STRING_TABLE.__str124298)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 3; break; }
    case 43: // $97
      var $98=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($98, ((STRING_TABLE.__str224308)|0), 0, 0, 1086) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 3; break; }
    case 44: // $99
      var $100=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($100, ((STRING_TABLE.__str234309)|0), 0, 0, 1088) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 3; break; }
    case 45: // $101
      var $102=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($102, ((STRING_TABLE.__str244310)|0), 0, 0, 1090) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 3; break; }
    case 46: // $103
      var $104=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($104, ((STRING_TABLE.__str254311)|0), 0, 0, 1092) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 3; break; }
    case 47: // $105
      var $106=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($106, ((STRING_TABLE.__str124298)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 3; break; }
    case 48: // $107
      var $108=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($108, ((STRING_TABLE.__str264312)|0), 0, 0, 1094) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 3; break; }
    case 49: // $109
      var $110=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($110, ((STRING_TABLE.__str274313)|0), 0, 0, 1096) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 3; break; }
    case 50: // $111
      var $112=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($112, ((STRING_TABLE.__str124298)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 3; break; }
    case 51: // $113
      var $114=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($114, ((STRING_TABLE.__str284314)|0), 0, 0, 1098) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 3; break; }
    case 52: // $115
      var $116=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($116, ((STRING_TABLE.__str294315)|0), 0, 0, 1100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 3; break; }
    case 53: // $117
      var $118=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($118, ((STRING_TABLE.__str124298)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 3; break; }
    case 54: // $119
      var $120=HEAP32[((__ZL10focus_view)>>2)];
      var $121=(function() { try { __THREW__ = false; return __ZL14dview_is_stateP5DViewi($120, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 3; break; };
    case 55: // $122
      var $123=(($121)|0)!=0;
      if ($123) { __label__ = 58; break; } else { __label__ = 56; break; }
    case 56: // $124
      var $125=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($125, ((STRING_TABLE.__str304316)|0), 0, 0, 1102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 3; break; }
    case 57: // $126
      __label__ = 58; break;
    case 58: // $127
      var $128=HEAP32[((__ZL4menu)>>2)];
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($128, ((STRING_TABLE.__str314317)|0), 0, 0, 1104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 3; break; }
    case 59: // $129
      FUNCTION_TABLE[__ZN7astringD1Ev]($title);
      STACKTOP = __stackBase__;
      return;
    case 60: // $130
      __label__ = 61; break;
    case 61: // $131
      var $132=$2;
      var $133=$2;
      var $134=$3;
      var $135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $133, tempValue);
      var $136=($135.f1 = $134, $135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $137
      var $138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14CreateMainMenuR15running_machine["X"]=1;

function __ZL25on_memory_window_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  ;
  return;
}


function __ZNK10debug_view6sourceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17debug_view_source4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK10debug_view11source_listEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  ;
  return $3;
}


function __ZNK22debug_view_source_list4headEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17debug_view_source6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+72)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL24on_view_opcodes_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dasmview;
      var $rc;
      var $new_rc;
      $1=$dv;
      $2=$event;
      var $3=HEAP32[((__ZL10focus_view)>>2)];
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__Z8downcastIP17debug_view_disasm10debug_viewET_PT0_($5);
      $dasmview=$6;
      var $7=$dasmview;
      var $8=__ZNK17debug_view_disasm12right_columnEv($7);
      $rc=$8;
      $new_rc=0;
      var $9=$2;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==177;
      if ($12) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $13
      var $14=$rc;
      if ($14 == 1) {
        __label__ = 2; break;
      }
      else if ($14 == 2) {
        __label__ = 3; break;
      }
      else if ($14 == 3) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 2: // $15
      $new_rc=2;
      __label__ = 6; break;
    case 3: // $16
      $new_rc=3;
      __label__ = 6; break;
    case 4: // $17
      $new_rc=1;
      __label__ = 6; break;
    case 5: // $18
      __label__ = 6; break;
    case 6: // $19
      var $20=$dasmview;
      var $21=$new_rc;
      __ZN17debug_view_disasm16set_right_columnE19disasm_right_column($20, $21);
      var $22=$1;
      __ZL15dview_set_stateP5DViewii($22, 8, 1);
      __label__ = 7; break;
    case 7: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL25on_run_to_cursor_activateP5DViewPK14_ui_menu_event($dv, $event) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $command=__stackBase__;
      var $address;
      $1=$dv;
      $2=$event;
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZN10debug_view14cursor_visibleEv($5);
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK5DView7machineEv($8);
      var $10=__Z25debug_cpu_get_visible_cpuR15running_machine($9);
      var $11=$1;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZNK10debug_view6sourceEv($13);
      var $15=__ZNK17debug_view_source6deviceEv($14);
      var $16=(($10)|0)==(($15)|0);
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$1;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__Z8downcastIP17debug_view_disasm10debug_viewET_PT0_($20);
      var $22=__ZN17debug_view_disasm16selected_addressEv($21);
      $address=$22;
      var $23=(($command)|0);
      var $24=$address;
      var $25=_sprintf($23, ((STRING_TABLE.__str334319)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      var $26=$1;
      var $27=__ZNK5DView7machineEv($26);
      var $28=(($command)|0);
      var $29=__Z29debug_console_execute_commandR15running_machinePKci($27, $28, 1);
      __label__ = 3; break;
    case 3: // $30
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17debug_view_source4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZL15on_run_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  var $5=__Z25debug_cpu_get_visible_cpuR15running_machine($4);
  var $6=__ZNK8device_t5debugEv($5);
  __ZN12device_debug2goEj($6, -1);
  ;
  return;
}


function __ZL19on_run_cpu_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  var $5=__Z25debug_cpu_get_visible_cpuR15running_machine($4);
  var $6=__ZNK8device_t5debugEv($5);
  __ZN12device_debug14go_next_deviceEv($6);
  ;
  return;
}


function __ZL19on_run_irq_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  var $5=__Z25debug_cpu_get_visible_cpuR15running_machine($4);
  var $6=__ZNK8device_t5debugEv($5);
  __ZN12device_debug12go_interruptEi($6, -1);
  ;
  return;
}


function __ZL19on_run_vbl_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  var $5=__Z25debug_cpu_get_visible_cpuR15running_machine($4);
  var $6=__ZNK8device_t5debugEv($5);
  __ZN12device_debug9go_vblankEv($6);
  ;
  return;
}


function __ZL21on_step_into_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  var $5=__Z25debug_cpu_get_visible_cpuR15running_machine($4);
  var $6=__ZNK8device_t5debugEv($5);
  __ZN12device_debug11single_stepEi($6, 1);
  ;
  return;
}


function __ZL21on_step_over_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  var $5=__Z25debug_cpu_get_visible_cpuR15running_machine($4);
  var $6=__ZNK8device_t5debugEv($5);
  __ZN12device_debug16single_step_overEi($6, 1);
  ;
  return;
}


function __ZL22on_soft_reset_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  __ZN15running_machine19schedule_soft_resetEv($4);
  var $5=$1;
  var $6=__ZNK5DView7machineEv($5);
  var $7=__Z25debug_cpu_get_visible_cpuR15running_machine($6);
  var $8=__ZNK8device_t5debugEv($7);
  __ZN12device_debug2goEj($8, -1);
  ;
  return;
}


function __ZL22on_hard_reset_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  __ZN15running_machine19schedule_hard_resetEv($4);
  ;
  return;
}


function __ZL17on_close_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$dv;
      $2=$event;
      var $3=HEAP32[((__ZL10focus_view)>>2)];
      var $4=$1;
      var $5=(($3)|0)==(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZL14set_focus_viewP5DView($9);
      __label__ = 2; break;
    case 2: // $10
      var $11=$1;
      __ZL10dview_freeP5DView($11);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16on_exit_activateP5DViewPK14_ui_menu_event($dv, $event) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dv;
  $2=$event;
  var $3=$1;
  var $4=__ZNK5DView7machineEv($3);
  __ZN15running_machine13schedule_exitEv($4);
  ;
  return;
}


function __ZL10dview_freeP5DView($dv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $_hlp;
      $1=$dv;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      $_hlp=0;
      var $4=HEAP32[((__ZL4list)>>2)];
      var $5=$1;
      var $6=(($4)|0)!=(($5)|0);
      if ($6) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $7
      var $8=HEAP32[((__ZL4list)>>2)];
      $_hlp=$8;
      __label__ = 4; break;
    case 4: // $9
      var $10=$_hlp;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $12
      var $13=$_hlp;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$1;
      var $17=(($15)|0)==(($16)|0);
      if ($17) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $18
      __label__ = 9; break;
    case 7: // $19
      __label__ = 8; break;
    case 8: // $20
      var $21=$_hlp;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      $_hlp=$23;
      __label__ = 4; break;
    case 9: // $24
      __label__ = 10; break;
    case 10: // $25
      __label__ = 11; break;
    case 11: // $26
      var $27=$_hlp;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $29
      var $30=$1;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$_hlp;
      var $34=(($33)|0);
      HEAP32[(($34)>>2)]=$32;
      __label__ = 14; break;
    case 13: // $35
      var $36=$1;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      HEAP32[((__ZL4list)>>2)]=$38;
      __label__ = 14; break;
    case 14: // $39
      __label__ = 15; break;
    case 15: // $40
      var $41=$1;
      var $42=__ZNK5DView7machineEv($41);
      var $43=__ZN15running_machine7respoolEv($42);
      var $44=$1;
      var $45=$44;
      __ZN13resource_pool6removeEPv($43, $45);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10dview_freeP5DView["X"]=1;

function __ZN10debug_view14cursor_visibleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view13flush_updatesEv($2);
  var $3=(($2+73)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZL17dview_update_viewP5DView($dv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $old_rt_width;
      var $old_rt_height;
      $1=$dv;
      var $2=$1;
      var $3=(($2+180)|0);
      var $4=HEAP32[(($3)>>2)];
      $old_rt_width=$4;
      var $5=$1;
      var $6=(($5+184)|0);
      var $7=HEAP32[(($6)>>2)];
      $old_rt_height=$7;
      var $8=$1;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK13render_target5widthEv($10);
      var $12=$1;
      var $13=(($12+180)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$1;
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNK13render_target6heightEv($16);
      var $18=$1;
      var $19=(($18+184)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$1;
      var $21=__ZL14dview_is_stateP5DViewi($20, 8);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+180)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$old_rt_width;
      var $28=(($26)|0)!=(($27)|0);
      if ($28) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+184)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$old_rt_height;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$1;
      __ZL19dview_size_allocateP5DView($36);
      var $37=$1;
      __ZL10dview_drawP5DView($37);
      var $38=$1;
      __ZL15dview_set_stateP5DViewii($38, 8, 0);
      __label__ = 4; break;
    case 4: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17dview_update_viewP5DView["X"]=1;

function __ZL22on_disasm_cpu_activateP5DViewPK14_ui_menu_event($dv, $event) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $current;
      var $3=__stackBase__;
      var $4;
      var $5;
      $1=$dv;
      $2=$event;
      var $6=$1;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK10debug_view6sourceEv($8);
      $current=$9;
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)==177;
      if ($13) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $14
      var $15=$current;
      var $16=__ZNK17debug_view_source4nextEv($15);
      $current=$16;
      var $17=$current;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK10debug_view11source_listEv($22);
      var $24=__ZNK22debug_view_source_list4headEv($23);
      $current=$24;
      __label__ = 3; break;
    case 3: // $25
      var $26=$1;
      var $27=(($26+8)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$current;
      __ZN10debug_view10set_sourceERK17debug_view_source($28, $29);
      var $30=$1;
      __ZL15dview_set_stateP5DViewii($30, 8, 1);
      var $31=$1;
      var $32=$current;
      var $33=__ZNK17debug_view_source4nameEv($32);
      __ZN7astringC1EPKc($3, $33);
      (function() { try { __THREW__ = false; return __ZL15dview_set_titleP5DView7astring($31, $3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $34
      FUNCTION_TABLE[__ZN7astringD1Ev]($3);
      __label__ = 7; break;
    case 5: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $4=$37;
      var $38=$36.f1;
      $5=$38;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $39
      __label__ = 8; break;
    case 7: // $40
      STACKTOP = __stackBase__;
      return;
    case 8: // $41
      var $42=$4;
      var $43=$4;
      var $44=$5;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22on_disasm_cpu_activateP5DViewPK14_ui_menu_event["X"]=1;

function __ZL30on_disassembly_window_activateP5DViewPK14_ui_menu_event($dv, $event) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ndv;
      var $target;
      var $source;
      var $3=__stackBase__;
      var $4;
      var $5;
      $1=$dv;
      $2=$event;
      var $6=$1;
      var $7=__ZNK5DView7machineEv($6);
      var $8=__ZNK15running_machine6renderEv($7);
      var $9=__ZNK14render_manager9ui_targetEv($8);
      $target=$9;
      var $10=$target;
      var $11=$1;
      var $12=__ZNK5DView7machineEv($11);
      var $13=__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei($10, $12, 3, 0);
      $ndv=$13;
      var $14=$ndv;
      var $15=(($14+188)|0);
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=1;
      var $17=$1;
      var $18=__ZNK5DView7machineEv($17);
      var $19=__ZNK15running_machine6renderEv($18);
      var $20=__ZNK14render_manager12ui_containerEv($19);
      var $21=$ndv;
      var $22=(($21+188)|0);
      var $23=(($22+4)|0);
      HEAP32[(($23)>>2)]=$20;
      var $24=$ndv;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK10debug_view6sourceEv($26);
      $source=$27;
      var $28=$ndv;
      var $29=$source;
      var $30=__ZNK17debug_view_source4nameEv($29);
      __ZN7astringC1EPKc($3, $30);
      (function() { try { __THREW__ = false; return __ZL15dview_set_titleP5DView7astring($28, $3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $31
      FUNCTION_TABLE[__ZN7astringD1Ev]($3);
      var $32=$ndv;
      __ZL14set_focus_viewP5DView($32);
      STACKTOP = __stackBase__;
      return;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $4=$35;
      var $36=$34.f1;
      $5=$36;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$4;
      var $40=$4;
      var $41=$5;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30on_disassembly_window_activateP5DViewPK14_ui_menu_event["X"]=1;

function __ZL22on_log_window_activateP5DViewPK14_ui_menu_event($dv, $event) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ndv;
      var $target;
      var $3=__stackBase__;
      var $4;
      var $5;
      $1=$dv;
      $2=$event;
      var $6=$1;
      var $7=__ZNK5DView7machineEv($6);
      var $8=__ZNK15running_machine6renderEv($7);
      var $9=__ZNK14render_manager9ui_targetEv($8);
      $target=$9;
      var $10=$target;
      var $11=$1;
      var $12=__ZNK5DView7machineEv($11);
      var $13=__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei($10, $12, 5, 0);
      $ndv=$13;
      var $14=$ndv;
      __ZN7astringC1EPKc($3, ((STRING_TABLE.__str324318)|0));
      (function() { try { __THREW__ = false; return __ZL15dview_set_titleP5DView7astring($14, $3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      FUNCTION_TABLE[__ZN7astringD1Ev]($3);
      var $16=$ndv;
      __ZL14set_focus_viewP5DView($16);
      STACKTOP = __stackBase__;
      return;
    case 2: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $21
      __label__ = 4; break;
    case 4: // $22
      var $23=$4;
      var $24=$4;
      var $25=$5;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10debug_view8viewdataEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+80)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL19dview_size_allocateP5DView($dv) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $size=__stackBase__;
      var $pos=__stackBase__+8;
      var $col=__stackBase__+16;
      var $vsize=__stackBase__+24;
      var $rcus=__stackBase__+32;
      var $r=__stackBase__+64;
      var $2=__stackBase__+80;
      var $3=__stackBase__+88;
      var $4=__stackBase__+96;
      var $5=__stackBase__+104;
      var $span;
      var $6=__stackBase__+112;
      var $span1;
      var $7=__stackBase__+120;
      $1=$dv;
      __ZN13debug_view_xyC1Eii($size, 0, 0);
      __ZN13debug_view_xyC1Eii($pos, 0, 0);
      __ZN13debug_view_xyC1Eii($col, 0, 0);
      __ZN13debug_view_xyC1Eii($vsize, 0, 0);
      FUNCTION_TABLE[__ZN16render_container13user_settingsC1Ev]($rcus);
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      __ZNK16render_container17get_user_settingsERNS_13user_settingsE($10, $rcus);
      var $11=$1;
      var $12=(($11+44)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0);
      var $15=$1;
      var $16=(($15+180)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0);
      var $19=$14/$18;
      var $20=(($rcus+24)|0);
      HEAPF32[(($20)>>2)]=$19;
      var $21=$1;
      var $22=(($21+48)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0);
      var $25=$1;
      var $26=(($25+184)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=$24/$28;
      var $30=(($rcus+28)|0);
      HEAPF32[(($30)>>2)]=$29;
      var $31=(($rcus+16)|0);
      HEAPF32[(($31)>>2)]=1;
      var $32=(($rcus+20)|0);
      HEAPF32[(($32)>>2)]=1;
      var $33=$1;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      __ZN16render_container17set_user_settingsERKNS_13user_settingsE($35, $rcus);
      var $36=$1;
      var $37=(($36+8)|0);
      var $38=HEAP32[(($37)>>2)];
      __ZN10debug_view16visible_positionEv($2, $38);
      var $39=$pos;
      var $40=$2;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];HEAP32[(($39+4)>>2)]=HEAP32[(($40+4)>>2)];
      var $41=$1;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      __ZN10debug_view10total_sizeEv($3, $43);
      var $44=$size;
      var $45=$3;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($44)>>2)]=HEAP32[(($45)>>2)];HEAP32[(($44+4)>>2)]=HEAP32[(($45+4)>>2)];
      var $46=$1;
      var $47=(($46+124)|0);
      var $48=(($47)|0);
      HEAP32[(($48)>>2)]=0;
      var $49=$1;
      var $50=(($49+152)|0);
      var $51=(($50)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=$1;
      __ZL14dview_get_rectP5DViewiP10_rectangle($52, 1, $r);
      var $53=(($size)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=HEAP32[((__ZL16debug_font_width)>>2)];
      var $56=(($54*$55)|0);
      var $57=__ZL14rect_get_widthP10_rectangle($r);
      var $58=(($56)|0) > (($57)|0);
      var $59=$58 ? 1 : 0;
      var $60=$1;
      var $61=(($60+124)|0);
      var $62=(($61)|0);
      HEAP32[(($62)>>2)]=$59;
      var $63=(($size+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=HEAP32[((__ZL17debug_font_height)>>2)];
      var $66=(($64*$65)|0);
      var $67=__ZL15rect_get_heightP10_rectangle($r);
      var $68=(($66)|0) > (($67)|0);
      var $69=$68 ? 1 : 0;
      var $70=$1;
      var $71=(($70+152)|0);
      var $72=(($71)|0);
      HEAP32[(($72)>>2)]=$69;
      var $73=$1;
      __ZL14dview_get_rectP5DViewiP10_rectangle($73, 1, $r);
      var $74=(($size)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=HEAP32[((__ZL16debug_font_width)>>2)];
      var $77=(($75*$76)|0);
      var $78=__ZL14rect_get_widthP10_rectangle($r);
      var $79=(($77)|0) > (($78)|0);
      var $80=$79 ? 1 : 0;
      var $81=$1;
      var $82=(($81+124)|0);
      var $83=(($82)|0);
      HEAP32[(($83)>>2)]=$80;
      var $84=(($size+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=HEAP32[((__ZL17debug_font_height)>>2)];
      var $87=(($85*$86)|0);
      var $88=__ZL15rect_get_heightP10_rectangle($r);
      var $89=(($87)|0) > (($88)|0);
      var $90=$89 ? 1 : 0;
      var $91=$1;
      var $92=(($91+152)|0);
      var $93=(($92)|0);
      HEAP32[(($93)>>2)]=$90;
      var $94=$1;
      __ZL14dview_get_rectP5DViewiP10_rectangle($94, 1, $r);
      var $95=__ZL15rect_get_heightP10_rectangle($r);
      var $96=(($95-2)|0);
      var $97=HEAP32[((__ZL17debug_font_height)>>2)];
      var $98=(((($96)|0)/(($97)|0))|0);
      var $99=(($col+4)|0);
      HEAP32[(($99)>>2)]=$98;
      var $100=__ZL14rect_get_widthP10_rectangle($r);
      var $101=(($100-2)|0);
      var $102=HEAP32[((__ZL16debug_font_width)>>2)];
      var $103=(((($101)|0)/(($102)|0))|0);
      var $104=(($col)|0);
      HEAP32[(($104)>>2)]=$103;
      var $105=(($size+4)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($pos+4)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($106-$108)|0);
      var $110=(($vsize+4)|0);
      HEAP32[(($110)>>2)]=$109;
      var $111=(($size)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($pos)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($112-$114)|0);
      var $116=(($vsize)|0);
      HEAP32[(($116)>>2)]=$115;
      var $117=(($vsize+4)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($col+4)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($118)|0) > (($120)|0);
      if ($121) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $122
      var $123=(($col+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($vsize+4)|0);
      HEAP32[(($125)>>2)]=$124;
      __label__ = 7; break;
    case 2: // $126
      var $127=(($vsize+4)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($col+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0) < (($130)|0);
      if ($131) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $132
      var $133=(($size+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($col+4)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($134-$136)|0);
      var $138=(($pos+4)|0);
      HEAP32[(($138)>>2)]=$137;
      var $139=(($pos+4)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140)|0) < 0;
      if ($141) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $142
      var $143=(($pos+4)|0);
      HEAP32[(($143)>>2)]=0;
      __label__ = 5; break;
    case 5: // $144
      var $145=(($size+4)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($pos+4)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($146-$148)|0);
      var $150=(($vsize+4)|0);
      HEAP32[(($150)>>2)]=$149;
      __label__ = 6; break;
    case 6: // $151
      __label__ = 7; break;
    case 7: // $152
      var $153=(($vsize)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($col)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($154)|0) > (($156)|0);
      if ($157) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $158
      var $159=(($col)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($vsize)|0);
      HEAP32[(($161)>>2)]=$160;
      __label__ = 14; break;
    case 9: // $162
      var $163=(($vsize)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($col)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($164)|0) < (($166)|0);
      if ($167) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $168
      var $169=(($size)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($col)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($170-$172)|0);
      var $174=(($pos)|0);
      HEAP32[(($174)>>2)]=$173;
      var $175=(($pos)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176)|0) < 0;
      if ($177) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $178
      var $179=(($pos)|0);
      HEAP32[(($179)>>2)]=0;
      __label__ = 12; break;
    case 12: // $180
      var $181=(($size)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=(($pos)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($182-$184)|0);
      var $186=(($vsize)|0);
      HEAP32[(($186)>>2)]=$185;
      __label__ = 13; break;
    case 13: // $187
      __label__ = 14; break;
    case 14: // $188
      var $189=$1;
      var $190=(($189+8)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$4;
      var $193=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($192)>>2)]=HEAP32[(($193)>>2)];HEAP32[(($192+4)>>2)]=HEAP32[(($193+4)>>2)];
      __ZN10debug_view20set_visible_positionE13debug_view_xy($191, $4);
      var $194=$1;
      var $195=(($194+8)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=$5;
      var $198=$vsize;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($197)>>2)]=HEAP32[(($198)>>2)];HEAP32[(($197+4)>>2)]=HEAP32[(($198+4)>>2)];
      __ZN10debug_view16set_visible_sizeE13debug_view_xy($196, $5);
      var $199=$1;
      var $200=(($199+124)|0);
      var $201=(($200)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($202)|0)!=0;
      if ($203) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $204
      var $205=__ZL14rect_get_widthP10_rectangle($r);
      var $206=(($205-2)|0);
      var $207=HEAP32[((__ZL16debug_font_width)>>2)];
      var $208=(((($206)|0)/(($207)|0))|0);
      $span=$208;
      var $209=(($pos)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$span;
      var $212=(($210+$211)|0);
      var $213=(($size)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(($212)|0) > (($214)|0);
      if ($215) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $216
      var $217=(($size)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$span;
      var $220=(($218-$219)|0);
      var $221=(($pos)|0);
      HEAP32[(($221)>>2)]=$220;
      __label__ = 17; break;
    case 17: // $222
      var $223=(($pos)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224)|0) < 0;
      if ($225) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $226
      var $227=(($pos)|0);
      HEAP32[(($227)>>2)]=0;
      __label__ = 19; break;
    case 19: // $228
      var $229=$1;
      var $230=(($229+124)|0);
      var $231=(($230+4)|0);
      HEAP32[(($231)>>2)]=0;
      var $232=(($size)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$1;
      var $235=(($234+124)|0);
      var $236=(($235+8)|0);
      HEAP32[(($236)>>2)]=$233;
      var $237=(($pos)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$1;
      var $240=(($239+124)|0);
      var $241=(($240+12)|0);
      HEAP32[(($241)>>2)]=$238;
      var $242=$1;
      var $243=(($242+124)|0);
      var $244=(($243+16)|0);
      HEAP32[(($244)>>2)]=1;
      var $245=$span;
      var $246=$1;
      var $247=(($246+124)|0);
      var $248=(($247+20)|0);
      HEAP32[(($248)>>2)]=$245;
      var $249=$span;
      var $250=$1;
      var $251=(($250+124)|0);
      var $252=(($251+24)|0);
      HEAP32[(($252)>>2)]=$249;
      var $253=$1;
      var $254=(($253+8)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$6;
      var $257=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($256)>>2)]=HEAP32[(($257)>>2)];HEAP32[(($256+4)>>2)]=HEAP32[(($257+4)>>2)];
      __ZN10debug_view20set_visible_positionE13debug_view_xy($255, $6);
      __label__ = 20; break;
    case 20: // $258
      var $259=$1;
      var $260=(($259+152)|0);
      var $261=(($260)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(($262)|0)!=0;
      if ($263) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $264
      var $265=__ZL15rect_get_heightP10_rectangle($r);
      var $266=(($265-2)|0);
      var $267=HEAP32[((__ZL17debug_font_height)>>2)];
      var $268=(((($266)|0)/(($267)|0))|0);
      $span1=$268;
      var $269=(($pos+4)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=$span1;
      var $272=(($270+$271)|0);
      var $273=(($size+4)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($272)|0) > (($274)|0);
      if ($275) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $276
      var $277=(($size+4)|0);
      var $278=HEAP32[(($277)>>2)];
      var $279=$span1;
      var $280=(($278-$279)|0);
      var $281=(($pos+4)|0);
      HEAP32[(($281)>>2)]=$280;
      __label__ = 23; break;
    case 23: // $282
      var $283=(($pos+4)|0);
      var $284=HEAP32[(($283)>>2)];
      var $285=(($284)|0) < 0;
      if ($285) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $286
      var $287=(($pos+4)|0);
      HEAP32[(($287)>>2)]=0;
      __label__ = 25; break;
    case 25: // $288
      var $289=$1;
      var $290=(($289+152)|0);
      var $291=(($290+4)|0);
      HEAP32[(($291)>>2)]=0;
      var $292=(($size+4)|0);
      var $293=HEAP32[(($292)>>2)];
      var $294=$1;
      var $295=(($294+152)|0);
      var $296=(($295+8)|0);
      HEAP32[(($296)>>2)]=$293;
      var $297=(($pos+4)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=$1;
      var $300=(($299+152)|0);
      var $301=(($300+12)|0);
      HEAP32[(($301)>>2)]=$298;
      var $302=$1;
      var $303=(($302+152)|0);
      var $304=(($303+16)|0);
      HEAP32[(($304)>>2)]=1;
      var $305=$span1;
      var $306=$1;
      var $307=(($306+152)|0);
      var $308=(($307+20)|0);
      HEAP32[(($308)>>2)]=$305;
      var $309=$span1;
      var $310=$1;
      var $311=(($310+152)|0);
      var $312=(($311+24)|0);
      HEAP32[(($312)>>2)]=$309;
      var $313=$1;
      var $314=(($313+8)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=$7;
      var $317=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($316)>>2)]=HEAP32[(($317)>>2)];HEAP32[(($316+4)>>2)]=HEAP32[(($317+4)>>2)];
      __ZN10debug_view20set_visible_positionE13debug_view_xy($315, $7);
      __label__ = 26; break;
    case 26: // $318
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19dview_size_allocateP5DView["X"]=1;

function __ZL10dview_drawP5DView($dv) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $viewdata;
      var $vsize=__stackBase__;
      var $i;
      var $j;
      var $xx;
      var $yy;
      var $bg_base;
      var $bg=__stackBase__+8;
      var $fg=__stackBase__+12;
      var $r=__stackBase__+16;
      var $2=__stackBase__+32;
      var $s;
      var $v;
      $1=$dv;
      __ZN13debug_view_xyC1Eii($vsize, 0, 0);
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      __ZN10debug_view12visible_sizeEv($2, $5);
      var $6=$vsize;
      var $7=$2;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];
      $bg_base=-1;
      var $8=$1;
      __ZL11dview_clearP5DView($8);
      var $9=$1;
      __ZL16dview_draw_titleP5DView($9);
      var $10=$1;
      __ZL14dview_get_rectP5DViewiP10_rectangle($10, 1, $r);
      var $11=$1;
      var $12=__ZL14rect_get_widthP10_rectangle($r);
      var $13=__ZL15rect_get_heightP10_rectangle($r);
      var $14=$bg_base;
      __ZL23dview_draw_outlined_boxP5DViewiiiiij($11, 1, 0, 0, $12, $13, $14);
      var $15=$1;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZNK10debug_view8viewdataEv($17);
      $viewdata=$18;
      $yy=1;
      $j=0;
      __label__ = 1; break;
    case 1: // $19
      var $20=$j;
      var $21=(($vsize+4)|0);
      var $22=HEAPU32[(($21)>>2)];
      var $23=(($20)>>>0) < (($22)>>>0);
      if ($23) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $24
      $xx=1;
      $i=0;
      __label__ = 3; break;
    case 3: // $25
      var $26=$i;
      var $27=(($vsize)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=(($26)>>>0) < (($28)>>>0);
      if ($29) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $30
      var $31=$viewdata;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      __ZL17map_attr_to_fg_bghPjS_($33, $fg, $bg);
      var $34=HEAP32[(($bg)>>2)];
      var $35=$bg_base;
      var $36=(($34)|0)!=(($35)|0);
      if ($36) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $37
      var $38=$1;
      var $39=$xx;
      var $40=$yy;
      var $41=HEAP32[((__ZL16debug_font_width)>>2)];
      var $42=HEAP32[((__ZL17debug_font_height)>>2)];
      var $43=HEAP32[(($bg)>>2)];
      __ZL14dview_draw_boxP5DViewiiiiij($38, 1, $39, $40, $41, $42, $43);
      __label__ = 6; break;
    case 6: // $44
      var $45=HEAP32[((__ZL16debug_font_width)>>2)];
      var $46=$xx;
      var $47=(($46+$45)|0);
      $xx=$47;
      var $48=$viewdata;
      var $49=(($48+2)|0);
      $viewdata=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$i;
      var $52=(($51+1)|0);
      $i=$52;
      __label__ = 3; break;
    case 8: // $53
      var $54=HEAP32[((__ZL17debug_font_height)>>2)];
      var $55=$yy;
      var $56=(($55+$54)|0);
      $yy=$56;
      __label__ = 9; break;
    case 9: // $57
      var $58=$j;
      var $59=(($58+1)|0);
      $j=$59;
      __label__ = 1; break;
    case 10: // $60
      var $61=$1;
      var $62=(($61+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=__ZNK10debug_view8viewdataEv($63);
      $viewdata=$64;
      $yy=1;
      $j=0;
      __label__ = 11; break;
    case 11: // $65
      var $66=$j;
      var $67=(($vsize+4)|0);
      var $68=HEAPU32[(($67)>>2)];
      var $69=(($66)>>>0) < (($68)>>>0);
      if ($69) { __label__ = 12; break; } else { __label__ = 23; break; }
    case 12: // $70
      $xx=1;
      $i=0;
      __label__ = 13; break;
    case 13: // $71
      var $72=$i;
      var $73=(($vsize)|0);
      var $74=HEAPU32[(($73)>>2)];
      var $75=(($72)>>>0) < (($74)>>>0);
      if ($75) { __label__ = 14; break; } else { __label__ = 21; break; }
    case 14: // $76
      var $77=$viewdata;
      var $78=(($77)|0);
      var $79=HEAP8[($78)];
      $v=$79;
      var $80=$v;
      var $81=(($80)&255);
      var $82=(($81)|0)!=32;
      if ($82) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $83
      var $84=$v;
      var $85=(($84)&255);
      var $86=(($85)|0) < 128;
      if ($86) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $87
      var $88=$v;
      var $89=(($88)&255);
      $s=$89;
      __label__ = 18; break;
    case 17: // $90
      var $91=$v;
      var $92=(($91)&255);
      var $93=$92 >> 6;
      var $94=192 | $93;
      var $95=(($94) & 65535);
      $s=$95;
      var $96=$v;
      var $97=(($96)&255);
      var $98=$97 & 63;
      var $99=128 | $98;
      var $100=$s;
      var $101=(($100)&65535);
      var $102=$101 | $99;
      var $103=(($102) & 65535);
      $s=$103;
      __label__ = 18; break;
    case 18: // $104
      var $105=$viewdata;
      var $106=(($105+1)|0);
      var $107=HEAP8[($106)];
      __ZL17map_attr_to_fg_bghPjS_($107, $fg, $bg);
      var $108=$1;
      var $109=$xx;
      var $110=$yy;
      var $111=HEAP32[((__ZL17debug_font_height)>>2)];
      var $112=HEAP32[(($fg)>>2)];
      var $113=$s;
      __ZL15dview_draw_charP5DViewiiiijt($108, 1, $109, $110, $111, $112, $113);
      __label__ = 19; break;
    case 19: // $114
      var $115=HEAP32[((__ZL16debug_font_width)>>2)];
      var $116=$xx;
      var $117=(($116+$115)|0);
      $xx=$117;
      var $118=$viewdata;
      var $119=(($118+2)|0);
      $viewdata=$119;
      __label__ = 20; break;
    case 20: // $120
      var $121=$i;
      var $122=(($121+1)|0);
      $i=$122;
      __label__ = 13; break;
    case 21: // $123
      var $124=HEAP32[((__ZL17debug_font_height)>>2)];
      var $125=$yy;
      var $126=(($125+$124)|0);
      $yy=$126;
      __label__ = 22; break;
    case 22: // $127
      var $128=$j;
      var $129=(($128+1)|0);
      $j=$129;
      __label__ = 11; break;
    case 23: // $130
      var $131=$1;
      var $132=(($131+124)|0);
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $136
      var $137=$1;
      __ZL14dview_draw_hsbP5DView($137);
      __label__ = 25; break;
    case 25: // $138
      var $139=$1;
      var $140=(($139+152)|0);
      var $141=(($140)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $144
      var $145=$1;
      __ZL14dview_draw_vsbP5DView($145);
      __label__ = 27; break;
    case 27: // $146
      var $147=$1;
      __ZL15dview_draw_sizeP5DView($147);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10dview_drawP5DView["X"]=1;

function __ZN10debug_view12visible_sizeEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view13flush_updatesEv($2);
  var $3=(($2+40)|0);
  var $4=$agg_result;
  var $5=$3;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];
  ;
  return;
}


function __ZL11dview_clearP5DView($dv) {
  ;
  var __label__;

  var $1;
  $1=$dv;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  __ZN16render_container5emptyEv($4);
  ;
  return;
}


function __ZL16dview_draw_titleP5DView($dv) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      var $col;
      var $r=__stackBase__;
      $1=$dv;
      $col=-16776961;
      var $2=$1;
      __ZL14dview_get_rectP5DViewiP10_rectangle($2, 2, $r);
      var $3=$1;
      var $4=HEAP32[((__ZL10focus_view)>>2)];
      var $5=(($3)|0)==(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $col=-16744704;
      __label__ = 2; break;
    case 2: // $7
      var $8=$1;
      var $9=$1;
      var $10=(($9+28)|0);
      var $11=__ZL14rect_get_widthP10_rectangle($10);
      var $12=$col;
      __ZL23dview_draw_outlined_boxP5DViewiiiiij($8, 2, 0, 0, $11, 20, $12);
      var $13=$1;
      var $14=(($13+52)|0);
      var $15=__ZN7astringcvbEv($14);
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      __label__ = 8; break;
    case 4: // $17
      $i=0;
      __label__ = 5; break;
    case 5: // $18
      var $19=$i;
      var $20=$1;
      var $21=(($20+52)|0);
      var $22=__ZNK7astringcvPKcEv($21);
      var $23=_strlen($22);
      var $24=(($19)>>>0) < (($23)>>>0);
      if ($24) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $25
      var $26=$1;
      var $27=$i;
      var $28=HEAP32[((__ZL16debug_font_width)>>2)];
      var $29=(($27*$28)|0);
      var $30=(($29+1)|0);
      var $31=HEAP32[((__ZL17debug_font_height)>>2)];
      var $32=$i;
      var $33=$1;
      var $34=(($33+52)|0);
      var $35=__ZNK7astringcvPKcEv($34);
      var $36=(($35+$32)|0);
      var $37=HEAP8[($36)];
      var $38=(($37 << 24) >> 24);
      __ZL15dview_draw_charP5DViewiiiijt($26, 2, $30, 1, $31, -1, $38);
      __label__ = 7; break;
    case 7: // $39
      var $40=$i;
      var $41=(($40+1)|0);
      $i=$41;
      __label__ = 5; break;
    case 8: // $42
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16dview_draw_titleP5DView["X"]=1;

function __ZL23dview_draw_outlined_boxP5DViewiiiiij($dv, $rtype, $x, $y, $w, $h, $bg) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $r=__stackBase__;
  $1=$dv;
  $2=$rtype;
  $3=$x;
  $4=$y;
  $5=$w;
  $6=$h;
  $7=$bg;
  var $8=$1;
  var $9=$2;
  __ZL14dview_get_rectP5DViewiP10_rectangle($8, $9, $r);
  var $10=$1;
  var $11=(($10+12)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$3;
  var $14=(($r)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($13+$15)|0);
  var $17=(($16)|0);
  var $18=$1;
  var $19=(($18+180)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20)|0);
  var $22=$17/$21;
  var $23=$4;
  var $24=(($r+8)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($23+$25)|0);
  var $27=(($26)|0);
  var $28=$1;
  var $29=(($28+184)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30)|0);
  var $32=$27/$31;
  var $33=$3;
  var $34=(($r)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=(($33+$35)|0);
  var $37=$5;
  var $38=(($36+$37)|0);
  var $39=(($38)|0);
  var $40=$1;
  var $41=(($40+180)|0);
  var $42=HEAP32[(($41)>>2)];
  var $43=(($42)|0);
  var $44=$39/$43;
  var $45=$4;
  var $46=(($r+8)|0);
  var $47=HEAP32[(($46)>>2)];
  var $48=(($45+$47)|0);
  var $49=$6;
  var $50=(($48+$49)|0);
  var $51=(($50)|0);
  var $52=$1;
  var $53=(($52+184)|0);
  var $54=HEAP32[(($53)>>2)];
  var $55=(($54)|0);
  var $56=$51/$55;
  var $57=$7;
  __Z20ui_draw_outlined_boxP16render_containerffffj($12, $22, $32, $44, $56, $57);
  STACKTOP = __stackBase__;
  return;
}
__ZL23dview_draw_outlined_boxP5DViewiiiiij["X"]=1;

function __ZL17map_attr_to_fg_bghPjS_($attr, $fg, $bg) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$attr;
      $2=$fg;
      $3=$bg;
      var $4=$3;
      HEAP32[(($4)>>2)]=-1;
      var $5=$2;
      HEAP32[(($5)>>2)]=-16777216;
      var $6=$1;
      var $7=(($6)&255);
      var $8=$7 & 16;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$3;
      HEAP32[(($11)>>2)]=-2039584;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13)&255);
      var $15=$14 & 2;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$3;
      HEAP32[(($18)>>2)]=-32640;
      __label__ = 4; break;
    case 4: // $19
      var $20=$1;
      var $21=(($20)&255);
      var $22=$21 & 32;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$3;
      HEAP32[(($25)>>2)]=-256;
      __label__ = 6; break;
    case 6: // $26
      var $27=$1;
      var $28=(($27)&255);
      var $29=$28 & 1;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$2;
      HEAP32[(($32)>>2)]=-65536;
      __label__ = 8; break;
    case 8: // $33
      var $34=$1;
      var $35=(($34)&255);
      var $36=$35 & 4;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $38
      var $39=$2;
      HEAP32[(($39)>>2)]=-16776961;
      __label__ = 10; break;
    case 10: // $40
      var $41=$1;
      var $42=(($41)&255);
      var $43=$42 & 8;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $45
      var $46=$2;
      var $47=HEAPU32[(($46)>>2)];
      var $48=$47 >>> 24;
      var $49=$48 & 255;
      var $50=$49 & 255;
      var $51=$50 << 24;
      var $52=$2;
      var $53=HEAPU32[(($52)>>2)];
      var $54=$53 >>> 16;
      var $55=$54 & 255;
      var $56=$3;
      var $57=HEAPU32[(($56)>>2)];
      var $58=$57 >>> 16;
      var $59=$58 & 255;
      var $60=(($55+$59)|0);
      var $61=$60 >>> 1;
      var $62=$61 & 255;
      var $63=$62 << 16;
      var $64=$51 | $63;
      var $65=$2;
      var $66=HEAPU32[(($65)>>2)];
      var $67=$66 >>> 8;
      var $68=$67 & 255;
      var $69=$3;
      var $70=HEAPU32[(($69)>>2)];
      var $71=$70 >>> 8;
      var $72=$71 & 255;
      var $73=(($68+$72)|0);
      var $74=$73 >>> 1;
      var $75=$74 & 255;
      var $76=$75 << 8;
      var $77=$64 | $76;
      var $78=$2;
      var $79=HEAP32[(($78)>>2)];
      var $80=$79 & 255;
      var $81=$3;
      var $82=HEAP32[(($81)>>2)];
      var $83=$82 & 255;
      var $84=(($80+$83)|0);
      var $85=$84 >>> 1;
      var $86=$85 & 255;
      var $87=$77 | $86;
      var $88=$2;
      HEAP32[(($88)>>2)]=$87;
      __label__ = 12; break;
    case 12: // $89
      var $90=$1;
      var $91=(($90)&255);
      var $92=$91 & 64;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $94
      var $95=$2;
      HEAP32[(($95)>>2)]=-16744448;
      __label__ = 14; break;
    case 14: // $96
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17map_attr_to_fg_bghPjS_["X"]=1;

function __ZL14dview_draw_boxP5DViewiiiiij($dv, $rtype, $x, $y, $w, $h, $col) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $r=__stackBase__;
  $1=$dv;
  $2=$rtype;
  $3=$x;
  $4=$y;
  $5=$w;
  $6=$h;
  $7=$col;
  var $8=$1;
  var $9=$2;
  __ZL14dview_get_rectP5DViewiP10_rectangle($8, $9, $r);
  var $10=$1;
  var $11=(($10+12)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$3;
  var $14=(($r)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($13+$15)|0);
  var $17=(($16)|0);
  var $18=$1;
  var $19=(($18+180)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20)|0);
  var $22=$17/$21;
  var $23=$4;
  var $24=(($r+8)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($23+$25)|0);
  var $27=(($26)|0);
  var $28=$1;
  var $29=(($28+184)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30)|0);
  var $32=$27/$31;
  var $33=$3;
  var $34=(($r)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=(($33+$35)|0);
  var $37=$5;
  var $38=(($36+$37)|0);
  var $39=(($38)|0);
  var $40=$1;
  var $41=(($40+180)|0);
  var $42=HEAP32[(($41)>>2)];
  var $43=(($42)|0);
  var $44=$39/$43;
  var $45=$4;
  var $46=(($r+8)|0);
  var $47=HEAP32[(($46)>>2)];
  var $48=(($45+$47)|0);
  var $49=$6;
  var $50=(($48+$49)|0);
  var $51=(($50)|0);
  var $52=$1;
  var $53=(($52+184)|0);
  var $54=HEAP32[(($53)>>2)];
  var $55=(($54)|0);
  var $56=$51/$55;
  var $57=$7;
  __ZN16render_container8add_rectEffffjj($12, $22, $32, $44, $56, $57, 256);
  STACKTOP = __stackBase__;
  return;
}
__ZL14dview_draw_boxP5DViewiiiiij["X"]=1;

function __ZL15dview_draw_charP5DViewiiiijt($dv, $rtype, $x, $y, $h, $col, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $r=__stackBase__;
  $1=$dv;
  $2=$rtype;
  $3=$x;
  $4=$y;
  $5=$h;
  $6=$col;
  $7=$ch;
  var $8=$1;
  var $9=$2;
  __ZL14dview_get_rectP5DViewiP10_rectangle($8, $9, $r);
  var $10=$1;
  var $11=(($10+12)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$3;
  var $14=(($r)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($13+$15)|0);
  var $17=(($16)|0);
  var $18=$1;
  var $19=(($18+180)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20)|0);
  var $22=$17/$21;
  var $23=$4;
  var $24=(($r+8)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($23+$25)|0);
  var $27=(($26)|0);
  var $28=$1;
  var $29=(($28+184)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30)|0);
  var $32=$27/$31;
  var $33=$5;
  var $34=(($33)|0);
  var $35=$1;
  var $36=(($35+184)|0);
  var $37=HEAP32[(($36)>>2)];
  var $38=(($37)|0);
  var $39=$34/$38;
  var $40=HEAPF32[((__ZL17debug_font_aspect)>>2)];
  var $41=$6;
  var $42=HEAP32[((__ZL10debug_font)>>2)];
  var $43=$7;
  __ZN16render_container8add_charEffffjR11render_fontt($12, $22, $32, $39, $40, $41, $42, $43);
  STACKTOP = __stackBase__;
  return;
}
__ZL15dview_draw_charP5DViewiiiijt["X"]=1;

function __ZL14dview_draw_hsbP5DView($dv) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $vt;
  var $ts;
  var $sz;
  var $r=__stackBase__;
  var $sb;
  $1=$dv;
  var $2=$1;
  var $3=(($2+124)|0);
  $sb=$3;
  var $4=$1;
  __ZL14dview_get_rectP5DViewiP10_rectangle($4, 3, $r);
  var $5=$1;
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($5, 3, 0, 0, 20, 20, -65536);
  var $6=$1;
  var $7=__ZL14rect_get_widthP10_rectangle($r);
  var $8=(($7-20)|0);
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($6, 3, $8, 0, 20, 20, -65536);
  var $9=(($r+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=(($r)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($10-$12)|0);
  var $14=(($13+1)|0);
  var $15=(($14-40)|0);
  $ts=$15;
  var $16=$ts;
  var $17=$sb;
  var $18=(($17+24)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=(($16*$19)|0);
  var $21=$sb;
  var $22=(($21+8)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=$sb;
  var $25=(($24+4)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=(($23-$26)|0);
  var $28=(((($20)|0)/(($27)|0))|0);
  $sz=$28;
  var $29=$ts;
  var $30=$sz;
  var $31=(($29-$30)|0);
  $ts=$31;
  var $32=$ts;
  var $33=$sb;
  var $34=(($33+12)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$sb;
  var $37=(($36+4)|0);
  var $38=HEAP32[(($37)>>2)];
  var $39=(($35-$38)|0);
  var $40=(($32*$39)|0);
  var $41=$sb;
  var $42=(($41+8)|0);
  var $43=HEAP32[(($42)>>2)];
  var $44=$sb;
  var $45=(($44+4)|0);
  var $46=HEAP32[(($45)>>2)];
  var $47=(($43-$46)|0);
  var $48=$sb;
  var $49=(($48+24)|0);
  var $50=HEAP32[(($49)>>2)];
  var $51=(($47-$50)|0);
  var $52=(((($40)|0)/(($51)|0))|0);
  var $53=$sz;
  var $54=(((($53)|0)/2)|0);
  var $55=(($52+$54)|0);
  var $56=(($r)|0);
  var $57=HEAP32[(($56)>>2)];
  var $58=(($55+$57)|0);
  var $59=(($58+20)|0);
  $vt=$59;
  var $60=$1;
  var $61=$vt;
  var $62=$sz;
  var $63=(((($62)|0)/2)|0);
  var $64=(($61-$63)|0);
  var $65=$sz;
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($60, 3, $64, 0, $65, 20, -65536);
  STACKTOP = __stackBase__;
  return;
}
__ZL14dview_draw_hsbP5DView["X"]=1;

function __ZL14dview_draw_vsbP5DView($dv) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $vt;
  var $ts;
  var $sz;
  var $r=__stackBase__;
  var $sb;
  $1=$dv;
  var $2=$1;
  var $3=(($2+152)|0);
  $sb=$3;
  var $4=$1;
  __ZL14dview_get_rectP5DViewiP10_rectangle($4, 4, $r);
  var $5=$1;
  var $6=__ZL15rect_get_heightP10_rectangle($r);
  var $7=(($6-20)|0);
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($5, 4, 0, $7, 20, 20, -65536);
  var $8=$1;
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($8, 4, 0, 0, 20, 20, -65536);
  var $9=(($r+12)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=(($r+8)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($10-$12)|0);
  var $14=(($13+1)|0);
  var $15=(($14-40)|0);
  $ts=$15;
  var $16=$ts;
  var $17=$sb;
  var $18=(($17+24)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=(($16*$19)|0);
  var $21=$sb;
  var $22=(($21+8)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=$sb;
  var $25=(($24+4)|0);
  var $26=HEAP32[(($25)>>2)];
  var $27=(($23-$26)|0);
  var $28=(((($20)|0)/(($27)|0))|0);
  $sz=$28;
  var $29=$ts;
  var $30=$sz;
  var $31=(($29-$30)|0);
  $ts=$31;
  var $32=$ts;
  var $33=$sb;
  var $34=(($33+12)|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$sb;
  var $37=(($36+4)|0);
  var $38=HEAP32[(($37)>>2)];
  var $39=(($35-$38)|0);
  var $40=(($32*$39)|0);
  var $41=$sb;
  var $42=(($41+8)|0);
  var $43=HEAP32[(($42)>>2)];
  var $44=$sb;
  var $45=(($44+4)|0);
  var $46=HEAP32[(($45)>>2)];
  var $47=(($43-$46)|0);
  var $48=$sb;
  var $49=(($48+24)|0);
  var $50=HEAP32[(($49)>>2)];
  var $51=(($47-$50)|0);
  var $52=(((($40)|0)/(($51)|0))|0);
  var $53=$sz;
  var $54=(((($53)|0)/2)|0);
  var $55=(($52+$54)|0);
  var $56=(($55+20)|0);
  $vt=$56;
  var $57=$1;
  var $58=$vt;
  var $59=$sz;
  var $60=(((($59)|0)/2)|0);
  var $61=(($58-$60)|0);
  var $62=$sz;
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($57, 4, 0, $61, 20, $62, -65536);
  STACKTOP = __stackBase__;
  return;
}
__ZL14dview_draw_vsbP5DView["X"]=1;

function __ZL15dview_draw_sizeP5DView($dv) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $r=__stackBase__;
  $1=$dv;
  var $2=$1;
  __ZL14dview_get_rectP5DViewiP10_rectangle($2, 5, $r);
  var $3=$1;
  var $4=__ZL14rect_get_widthP10_rectangle($r);
  var $5=__ZL15rect_get_heightP10_rectangle($r);
  __ZL23dview_draw_outlined_boxP5DViewiiiiij($3, 5, 0, 0, $4, $5, -256);
  STACKTOP = __stackBase__;
  return;
}


function __ZN10debug_view10total_sizeEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view13flush_updatesEv($2);
  var $3=(($2+48)|0);
  var $4=$agg_result;
  var $5=$3;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];
  ;
  return;
}


function __ZN5DViewC1EP13render_targetR15running_machine15debug_view_typei($this, $target, $machine, $type, $flags) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$target;
  $3=$machine;
  $4=$type;
  $5=$flags;
  var $6=$1;
  var $7=$2;
  var $8=$4;
  var $9=$5;
  var $10=$3;
  __ZN5DViewC2EP13render_targetR15running_machine15debug_view_typei($6, $7, $10, $8, $9);
  ;
  return;
}


function __ZN10DView_editC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10DView_editC2Ev($2);
  ;
  return;
}


function __ZL12dview_updateR10debug_viewPv($dw, $osdprivate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $dv;
  $1=$dw;
  $2=$osdprivate;
  var $3=$2;
  var $4=$3;
  $dv=$4;
  var $5=$dv;
  __ZL15dview_set_stateP5DViewii($5, 8, 1);
  ;
  return;
}


function __ZN10DView_editD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10DView_editD2Ev($2);
  ;
  return;
}


function __ZN10DView_editD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN10DView_editC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  __ZN7astringC1Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI5DViewEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI5DViewEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI5DViewEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 260);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI5DViewE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI5DViewED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI5DViewED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectI5DViewEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI5DViewEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI5DViewEEPT_S3_["X"]=1;

function __ZN5DViewC2EP13render_targetR15running_machine15debug_view_typei($this, $target, $machine, $type, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$target;
      $3=$machine;
      $4=$type;
      $5=$flags;
      var $8=$1;
      var $9=(($8)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($8+4)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($8+24)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($8+28)|0);
      var $13=(($8+44)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($8+48)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($8+52)|0);
      __ZN7astringC1Ev($15);
      var $16=(($8+124)|0);
      var $17=(($8+152)|0);
      var $18=(($8+188)|0);
      (function() { try { __THREW__ = false; return __ZN10DView_editC1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $19
      var $20=$2;
      var $21=(($8+16)|0);
      HEAP32[(($21)>>2)]=$20;
      var $22=$2;
      var $23=(function() { try { __THREW__ = false; return __ZN13render_target11debug_allocEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $24
      var $25=(($8+12)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$3;
      var $27=(function() { try { __THREW__ = false; return __ZNK15running_machine10debug_viewEv($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $28
      var $29=$4;
      var $30=$8;
      var $31=(function() { try { __THREW__ = false; return __ZN18debug_view_manager10alloc_viewE15debug_view_typePFvR10debug_viewPvES3_($27, $29, 1106, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $32
      var $33=(($8+8)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$4;
      var $35=(($8+4)|0);
      HEAP32[(($35)>>2)]=$34;
      var $36=$3;
      var $37=(($8+20)|0);
      HEAP32[(($37)>>2)]=$36;
      var $38=$5;
      var $39=$38 | 8;
      var $40=(($8+24)|0);
      HEAP32[(($40)>>2)]=$39;
      var $41=(($8+28)|0);
      var $42=(($41)|0);
      HEAP32[(($42)>>2)]=0;
      var $43=(($8+28)|0);
      var $44=(($43+8)|0);
      HEAP32[(($44)>>2)]=0;
      var $45=(($8+28)|0);
      var $46=(($45+4)|0);
      HEAP32[(($46)>>2)]=300;
      var $47=(($8+28)|0);
      var $48=(($47+12)|0);
      HEAP32[(($48)>>2)]=300;
      var $49=$4;
      if ($49 == 3) {
        __label__ = 7; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 5: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      $6=$52;
      var $53=$51.f1;
      $7=$53;
      __label__ = 13; break;
    case 6: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      $6=$56;
      var $57=$55.f1;
      $7=$57;
      var $58=(($8+188)|0);
      (function() { try { __THREW__ = false; return __ZN10DView_editD1Ev($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 7: // $59
      var $60=(($8+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(function() { try { __THREW__ = false; return __Z8downcastIP17debug_view_disasm10debug_viewET_PT0_($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 6; break; };
    case 8: // $63
      (function() { try { __THREW__ = false; return __ZN17debug_view_disasm14set_expressionEPKc($62, ((STRING_TABLE.__str354321)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 9: // $64
      __label__ = 11; break;
    case 10: // $65
      __label__ = 11; break;
    case 11: // $66
      ;
      return;
    case 12: // $67
      __label__ = 13; break;
    case 13: // $68
      var $69=(($8+52)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $70
      __label__ = 15; break;
    case 15: // $71
      var $72=$6;
      var $73=$6;
      var $74=$7;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $77
      var $78=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN5DViewC2EP13render_targetR15running_machine15debug_view_typei["X"]=1;

function __ZN20resource_pool_objectI5DViewED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI5DViewED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI5DViewED0Ev["X"]=1;

function __ZN11driver_listC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN5DViewD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN5DViewD2Ev($2);
  ;
  return;
}


function __ZN11driver_list4findEPKc($name) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $driver=__stackBase__;
      var $driverptr=__stackBase__+52;
      var $result;
      $2=$name;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=-1;
      __label__ = 6; break;
    case 2: // $6
      var $7=$2;
      var $8=(($driver+8)|0);
      HEAP32[(($8)>>2)]=$7;
      HEAP32[(($driverptr)>>2)]=$driver;
      var $9=$driverptr;
      var $10=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $11=_bsearch($9, __ZN11driver_list16s_drivers_sortedE, $10, 4, 1108);
      var $12=$11;
      $result=$12;
      var $13=$result;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $22 = -1;__label__ = 5; break;
    case 4: // $16
      var $17=$result;
      var $18=$17;
      var $19=(($18-__ZN11driver_list16s_drivers_sortedE)|0);
      var $20=(((($19)|0)/4)|0);
      var $22 = $20;__label__ = 5; break;
    case 5: // $21
      var $22;
      $1=$22;
      __label__ = 6; break;
    case 6: // $23
      var $24=$1;
      STACKTOP = __stackBase__;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11driver_list20driver_sort_callbackEPKvS1_($elem1, $elem2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $item1;
  var $item2;
  $1=$elem1;
  $2=$elem2;
  var $3=$1;
  var $4=$3;
  $item1=$4;
  var $5=$2;
  var $6=$5;
  $item2=$6;
  var $7=$item1;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+8)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$item2;
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+8)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=__Z12core_stricmpPKcS0_($10, $14);
  ;
  return $15;
}


function __ZN11driver_list7matchesEPKcS1_($wildstring, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$wildstring;
      $3=$string;
      var $4=$3;
      var $5=(($4)|0);
      var $6=HEAP8[($5)];
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==95;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      var $13=$2;
      var $14=(($13)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)!=95;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      $1=0;
      __label__ = 7; break;
    case 4: // $19
      var $20=$2;
      var $21=(($20)|0)==0;
      if ($21) { var $28 = 1;__label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $22
      var $23=$2;
      var $24=$3;
      var $25=__Z15core_strwildcmpPKcS0_($23, $24);
      var $26=(($25)|0)==0;
      var $28 = $26;__label__ = 6; break;
    case 6: // $27
      var $28;
      $1=$28;
      __label__ = 7; break;
    case 7: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11driver_list15penalty_compareEPKcS1_($source, $target) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $gaps;
      var $last;
      var $match;
      $1=$source;
      $2=$target;
      $gaps=1;
      $last=1;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 2; break; } else { var $12 = 0;__label__ = 3; break; }
    case 2: // $7
      var $8=$2;
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24)!=0;
      var $12 = $10;__label__ = 3; break;
    case 3: // $11
      var $12;
      if ($12) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $13
      var $14=$1;
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=_tolower($16);
      var $18=$2;
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=_tolower($20);
      var $22=(($17)|0)==(($21)|0);
      var $23=(($22)&1);
      $match=$23;
      var $24=$match;
      var $25=(($24) & 1);
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$1;
      var $28=(($27+1)|0);
      $1=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$match;
      var $31=(($30) & 1);
      var $32=(($31)&1);
      var $33=$last;
      var $34=(($33) & 1);
      var $35=(($34)&1);
      var $36=(($32)|0)!=(($35)|0);
      if ($36) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $37
      var $38=$match;
      var $39=(($38) & 1);
      var $40=(($39)&1);
      $last=$40;
      var $41=$match;
      var $42=(($41) & 1);
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$gaps;
      var $45=(($44+1)|0);
      $gaps=$45;
      __label__ = 9; break;
    case 9: // $46
      __label__ = 10; break;
    case 10: // $47
      __label__ = 11; break;
    case 11: // $48
      var $49=$2;
      var $50=(($49+1)|0);
      $2=$50;
      __label__ = 1; break;
    case 12: // $51
      __label__ = 13; break;
    case 13: // $52
      var $53=$1;
      var $54=HEAP8[($53)];
      var $55=(($54 << 24) >> 24)!=0;
      if ($55) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $56
      var $57=$gaps;
      var $58=(($57+1)|0);
      $gaps=$58;
      __label__ = 15; break;
    case 15: // $59
      var $60=$1;
      var $61=(($60+1)|0);
      $1=$61;
      __label__ = 13; break;
    case 16: // $62
      var $63=$gaps;
      var $64=(($63)|0)==1;
      if ($64) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $65
      var $66=$1;
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24);
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $70
      var $71=$2;
      var $72=HEAP8[($71)];
      var $73=(($72 << 24) >> 24);
      var $74=(($73)|0)==0;
      if ($74) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $75
      $gaps=0;
      __label__ = 20; break;
    case 20: // $76
      var $77=$gaps;
      ;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11driver_list15penalty_compareEPKcS1_["X"]=1;

function __ZN11simple_listIN17driver_enumerator12config_entryEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN17driver_enumerator12config_entryEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN17driver_enumerator11include_allEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $empty;
      $1=$this;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $6=(($5)|0);
      _memset($4, 1, $6, 1);
      var $7=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $8=(($2+4)|0);
      HEAP32[(($8)>>2)]=$7;
      var $9=__ZN11driver_list4findEPKc(((STRING_TABLE.__str14327)|0));
      $empty=$9;
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=$empty;
      var $13=(($2+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+$12)|0);
      HEAP8[($15)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN17driver_enumerator12config_entryEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI5DViewED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI5DViewE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN5DViewD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI5DViewED2Ev["X"]=1;

function __ZN5DViewD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+16)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4+12)|0);
      var $8=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return __ZN13render_target10debug_freeER16render_container($6, $8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $9
      var $10=(function() { try { __THREW__ = false; return __ZNK5DView7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $11
      var $12=(function() { try { __THREW__ = false; return __ZNK15running_machine10debug_viewEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $13
      var $14=(($4+8)|0);
      var $15=HEAP32[(($14)>>2)];
      (function() { try { __THREW__ = false; return __ZN18debug_view_manager9free_viewER10debug_view($12, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $16
      var $17=(($4+188)|0);
      (function() { try { __THREW__ = false; return __ZN10DView_editD1Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $18
      var $19=(($4+52)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($19);
      ;
      return;
    case 6: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $2=$22;
      var $23=$21.f1;
      $3=$23;
      var $24=(($4+188)|0);
      (function() { try { __THREW__ = false; return __ZN10DView_editD1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 7: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $2=$27;
      var $28=$26.f1;
      $3=$28;
      __label__ = 9; break;
    case 8: // $29
      __label__ = 9; break;
    case 9: // $30
      var $31=(($4+52)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $32
      __label__ = 11; break;
    case 11: // $33
      var $34=$2;
      var $35=$2;
      var $36=$3;
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17driver_enumeratorC2ER11emu_options($this, $options) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $result_i=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12;
      var $13;
      var $14;
      var $15;
      $12=$this;
      $13=$options;
      var $16=$12;
      var $17=$16;
      __ZN11driver_listC2Ev($17);
      var $18=(($16)|0);
      HEAP32[(($18)>>2)]=-1;
      var $19=(($16+4)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($16+8)|0);
      var $21=$13;
      HEAP32[(($20)>>2)]=$21;
      var $22=(($16+12)|0);
      var $23=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $24=(($23)|0) < 0;
      var $25=$24 ? -1 : $23;
      var $26=$7;
      var $27=$8;
      var $28=$9;
      var $29=$result_i;
      var $30=$10;
      var $31=$11;
      HEAP32[(($7)>>2)]=$25;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($9)>>2)]=162;
      var $32=HEAP32[(($7)>>2)];
      var $33=HEAP32[(($8)>>2)];
      var $34=HEAP32[(($9)>>2)];
      var $35=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $36
      HEAP32[(($result_i)>>2)]=$35;
      var $37=HEAP32[(($result_i)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $39
      var $40=___cxa_allocate_exception(4);
      var $41=$40;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($41);
      (function() { try { __THREW__ = false; return ___cxa_throw($40, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($10)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($11)>>2)]=$45;
      var $46=HEAP32[(($11)>>2)];
      var $47=(($46)|0) < 0;
      if ($47) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $48
      var $49=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($49);
      throw "Reached an unreachable!"
    case 5: // $50
      var $51=HEAP32[(($10)>>2)];
      var $52=HEAP32[(($10)>>2)];
      var $53=HEAP32[(($11)>>2)];
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $56
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKci_exit
      var $57=HEAP32[(($result_i)>>2)];
      var $58=$7;
      var $59=$8;
      var $60=$9;
      var $61=$result_i;
      var $62=$10;
      var $63=$11;
      var $64=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $65=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $57, $64);
      HEAP32[(($22)>>2)]=$65;
      var $66=(($16+16)|0);
      var $67=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $68=_llvm_umul_with_overflow_i32($67, 4);
      var $69=$68.f1;
      var $70=$68.f0;
      var $71=$69 ? -1 : $70;
      var $72=$1;
      var $73=$2;
      var $74=$3;
      var $75=$4;
      var $76=$result_i1;
      var $77=$5;
      var $78=$6;
      HEAP32[(($1)>>2)]=$71;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($3)>>2)]=163;
      HEAP32[(($4)>>2)]=_zeromem;
      var $79=HEAP32[(($1)>>2)];
      var $80=HEAP32[(($2)>>2)];
      var $81=HEAP32[(($3)>>2)];
      var $82=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($79, $80, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $83
      HEAP32[(($result_i1)>>2)]=$82;
      var $84=HEAP32[(($result_i1)>>2)];
      var $85=(($84)|0)==0;
      if ($85) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $86
      var $87=___cxa_allocate_exception(4);
      var $88=$87;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($88);
      (function() { try { __THREW__ = false; return ___cxa_throw($87, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $89
      var $90=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $91=$90.f0;
      HEAP32[(($5)>>2)]=$91;
      var $92=$90.f1;
      HEAP32[(($6)>>2)]=$92;
      var $93=HEAP32[(($6)>>2)];
      var $94=(($93)|0) < 0;
      if ($94) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $95
      var $96=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($96);
      throw "Reached an unreachable!"
    case 12: // $97
      var $98=HEAP32[(($5)>>2)];
      var $99=HEAP32[(($5)>>2)];
      var $100=HEAP32[(($6)>>2)];
      var $101=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $99, tempValue);
      var $102=($101.f1 = $100, $101);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $103
      throw "Reached an unreachable!"
    case 14: // $_ZnajPKciRK9zeromem_t_exit
      var $104=HEAP32[(($result_i1)>>2)];
      var $105=HEAP32[(($1)>>2)];
      _memset($104, 0, $105, 1);
      var $106=HEAP32[(($result_i1)>>2)];
      var $107=$1;
      var $108=$2;
      var $109=$3;
      var $110=$4;
      var $111=$result_i1;
      var $112=$5;
      var $113=$6;
      var $114=$106;
      var $115=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $116=__ZN13resource_pool9add_arrayIP14machine_configEEPT_S4_i(_global_resource_pool, $114, $115);
      HEAP32[(($66)>>2)]=$116;
      var $117=(($16+20)|0);
      __ZN11simple_listIN17driver_enumerator12config_entryEEC1ER13resource_pool($117, _global_resource_pool);
      (function() { try { __THREW__ = false; return __ZN17driver_enumerator11include_allEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $118
      STACKTOP = __stackBase__;
      return;
    case 16: // $119
      var $120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $121=$120.f0;
      $14=$121;
      var $122=$120.f1;
      $15=$122;
      var $123=(($16+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $124
      __label__ = 18; break;
    case 18: // $125
      var $126=$14;
      var $127=$14;
      var $128=$15;
      var $129=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $127, tempValue);
      var $130=($129.f1 = $128, $129);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $131
      var $132=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17driver_enumeratorC2ER11emu_options["X"]=1;

function __ZN13resource_pool9add_arrayIP14machine_configEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIP14machine_configEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIP14machine_configEEPT_S4_i["X"]=1;

function __ZN17driver_enumerator6filterEPKc($this, $filterstring) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $index;
      $1=$this;
      $2=$filterstring;
      var $3=$1;
      __ZN17driver_enumerator11exclude_allEv($3);
      $index=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$index;
      var $6=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $7=(($5)|0) < (($6)|0);
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$2;
      var $10=$index;
      var $11=((__ZN11driver_list16s_drivers_sortedE+($10<<2))|0);
      var $12=((((HEAPU8[($11)])|(HEAPU8[($11+1)]<<8)|(HEAPU8[($11+2)]<<16)|(HEAPU8[($11+3)]<<24))|0));
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZN11driver_list7matchesEPKcS1_($9, $14);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$index;
      __ZN17driver_enumerator7includeEi($3, $17);
      __label__ = 4; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$index;
      var $21=(($20+1)|0);
      $index=$21;
      __label__ = 1; break;
    case 6: // $22
      var $23=(($3+4)|0);
      var $24=HEAP32[(($23)>>2)];
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17driver_enumerator6filterERK11game_driver($this, $driver) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $index;
      $1=$this;
      $2=$driver;
      var $3=$1;
      __ZN17driver_enumerator11exclude_allEv($3);
      $index=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$index;
      var $6=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $7=(($5)|0) < (($6)|0);
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$index;
      var $10=((__ZN11driver_list16s_drivers_sortedE+($9<<2))|0);
      var $11=((((HEAPU8[($10)])|(HEAPU8[($10+1)]<<8)|(HEAPU8[($10+2)]<<16)|(HEAPU8[($10+3)]<<24))|0));
      var $12=$2;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$index;
      __ZN17driver_enumerator7includeEi($3, $15);
      __label__ = 4; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$index;
      var $19=(($18+1)|0);
      $index=$19;
      __label__ = 1; break;
    case 6: // $20
      var $21=(($3+4)|0);
      var $22=HEAP32[(($21)>>2)];
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17driver_enumeratorC2ER11emu_optionsPKc($this, $options, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $result_i=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      $12=$this;
      $13=$options;
      $14=$string;
      var $17=$12;
      var $18=$17;
      __ZN11driver_listC2Ev($18);
      var $19=(($17)|0);
      HEAP32[(($19)>>2)]=-1;
      var $20=(($17+4)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($17+8)|0);
      var $22=$13;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($17+12)|0);
      var $24=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $25=(($24)|0) < 0;
      var $26=$25 ? -1 : $24;
      var $27=$7;
      var $28=$8;
      var $29=$9;
      var $30=$result_i;
      var $31=$10;
      var $32=$11;
      HEAP32[(($7)>>2)]=$26;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($9)>>2)]=173;
      var $33=HEAP32[(($7)>>2)];
      var $34=HEAP32[(($8)>>2)];
      var $35=HEAP32[(($9)>>2)];
      var $36=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($33, $34, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $37
      HEAP32[(($result_i)>>2)]=$36;
      var $38=HEAP32[(($result_i)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $40
      var $41=___cxa_allocate_exception(4);
      var $42=$41;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42);
      (function() { try { __THREW__ = false; return ___cxa_throw($41, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      HEAP32[(($10)>>2)]=$45;
      var $46=$44.f1;
      HEAP32[(($11)>>2)]=$46;
      var $47=HEAP32[(($11)>>2)];
      var $48=(($47)|0) < 0;
      if ($48) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $49
      var $50=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($50);
      throw "Reached an unreachable!"
    case 5: // $51
      var $52=HEAP32[(($10)>>2)];
      var $53=HEAP32[(($10)>>2)];
      var $54=HEAP32[(($11)>>2)];
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $57
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKci_exit
      var $58=HEAP32[(($result_i)>>2)];
      var $59=$7;
      var $60=$8;
      var $61=$9;
      var $62=$result_i;
      var $63=$10;
      var $64=$11;
      var $65=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $66=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $58, $65);
      HEAP32[(($23)>>2)]=$66;
      var $67=(($17+16)|0);
      var $68=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $69=_llvm_umul_with_overflow_i32($68, 4);
      var $70=$69.f1;
      var $71=$69.f0;
      var $72=$70 ? -1 : $71;
      var $73=$1;
      var $74=$2;
      var $75=$3;
      var $76=$4;
      var $77=$result_i1;
      var $78=$5;
      var $79=$6;
      HEAP32[(($1)>>2)]=$72;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($3)>>2)]=174;
      HEAP32[(($4)>>2)]=_zeromem;
      var $80=HEAP32[(($1)>>2)];
      var $81=HEAP32[(($2)>>2)];
      var $82=HEAP32[(($3)>>2)];
      var $83=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($80, $81, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $84
      HEAP32[(($result_i1)>>2)]=$83;
      var $85=HEAP32[(($result_i1)>>2)];
      var $86=(($85)|0)==0;
      if ($86) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $87
      var $88=___cxa_allocate_exception(4);
      var $89=$88;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($89);
      (function() { try { __THREW__ = false; return ___cxa_throw($88, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $92=$91.f0;
      HEAP32[(($5)>>2)]=$92;
      var $93=$91.f1;
      HEAP32[(($6)>>2)]=$93;
      var $94=HEAP32[(($6)>>2)];
      var $95=(($94)|0) < 0;
      if ($95) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $96
      var $97=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($97);
      throw "Reached an unreachable!"
    case 12: // $98
      var $99=HEAP32[(($5)>>2)];
      var $100=HEAP32[(($5)>>2)];
      var $101=HEAP32[(($6)>>2)];
      var $102=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $100, tempValue);
      var $103=($102.f1 = $101, $102);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $104
      throw "Reached an unreachable!"
    case 14: // $_ZnajPKciRK9zeromem_t_exit
      var $105=HEAP32[(($result_i1)>>2)];
      var $106=HEAP32[(($1)>>2)];
      _memset($105, 0, $106, 1);
      var $107=HEAP32[(($result_i1)>>2)];
      var $108=$1;
      var $109=$2;
      var $110=$3;
      var $111=$4;
      var $112=$result_i1;
      var $113=$5;
      var $114=$6;
      var $115=$107;
      var $116=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $117=__ZN13resource_pool9add_arrayIP14machine_configEEPT_S4_i(_global_resource_pool, $115, $116);
      HEAP32[(($67)>>2)]=$117;
      var $118=(($17+20)|0);
      __ZN11simple_listIN17driver_enumerator12config_entryEEC1ER13resource_pool($118, _global_resource_pool);
      var $119=$14;
      var $120=(function() { try { __THREW__ = false; return __ZN17driver_enumerator6filterEPKc($17, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; };
    case 15: // $121
      STACKTOP = __stackBase__;
      return;
    case 16: // $122
      var $123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $124=$123.f0;
      $15=$124;
      var $125=$123.f1;
      $16=$125;
      var $126=(($17+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $127
      __label__ = 18; break;
    case 18: // $128
      var $129=$15;
      var $130=$15;
      var $131=$16;
      var $132=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $130, tempValue);
      var $133=($132.f1 = $131, $132);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $134
      var $135=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17driver_enumeratorC2ER11emu_optionsPKc["X"]=1;

function __ZN17driver_enumeratorC2ER11emu_optionsRK11game_driver($this, $options, $driver) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $result_i=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      $12=$this;
      $13=$options;
      $14=$driver;
      var $17=$12;
      var $18=$17;
      __ZN11driver_listC2Ev($18);
      var $19=(($17)|0);
      HEAP32[(($19)>>2)]=-1;
      var $20=(($17+4)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($17+8)|0);
      var $22=$13;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($17+12)|0);
      var $24=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $25=(($24)|0) < 0;
      var $26=$25 ? -1 : $24;
      var $27=$7;
      var $28=$8;
      var $29=$9;
      var $30=$result_i;
      var $31=$10;
      var $32=$11;
      HEAP32[(($7)>>2)]=$26;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($9)>>2)]=184;
      var $33=HEAP32[(($7)>>2)];
      var $34=HEAP32[(($8)>>2)];
      var $35=HEAP32[(($9)>>2)];
      var $36=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($33, $34, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $37
      HEAP32[(($result_i)>>2)]=$36;
      var $38=HEAP32[(($result_i)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $40
      var $41=___cxa_allocate_exception(4);
      var $42=$41;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($42);
      (function() { try { __THREW__ = false; return ___cxa_throw($41, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      HEAP32[(($10)>>2)]=$45;
      var $46=$44.f1;
      HEAP32[(($11)>>2)]=$46;
      var $47=HEAP32[(($11)>>2)];
      var $48=(($47)|0) < 0;
      if ($48) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $49
      var $50=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($50);
      throw "Reached an unreachable!"
    case 5: // $51
      var $52=HEAP32[(($10)>>2)];
      var $53=HEAP32[(($10)>>2)];
      var $54=HEAP32[(($11)>>2)];
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $57
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKci_exit
      var $58=HEAP32[(($result_i)>>2)];
      var $59=$7;
      var $60=$8;
      var $61=$9;
      var $62=$result_i;
      var $63=$10;
      var $64=$11;
      var $65=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $66=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $58, $65);
      HEAP32[(($23)>>2)]=$66;
      var $67=(($17+16)|0);
      var $68=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $69=_llvm_umul_with_overflow_i32($68, 4);
      var $70=$69.f1;
      var $71=$69.f0;
      var $72=$70 ? -1 : $71;
      var $73=$1;
      var $74=$2;
      var $75=$3;
      var $76=$4;
      var $77=$result_i1;
      var $78=$5;
      var $79=$6;
      HEAP32[(($1)>>2)]=$72;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($3)>>2)]=185;
      HEAP32[(($4)>>2)]=_zeromem;
      var $80=HEAP32[(($1)>>2)];
      var $81=HEAP32[(($2)>>2)];
      var $82=HEAP32[(($3)>>2)];
      var $83=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($80, $81, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $84
      HEAP32[(($result_i1)>>2)]=$83;
      var $85=HEAP32[(($result_i1)>>2)];
      var $86=(($85)|0)==0;
      if ($86) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $87
      var $88=___cxa_allocate_exception(4);
      var $89=$88;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($89);
      (function() { try { __THREW__ = false; return ___cxa_throw($88, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $92=$91.f0;
      HEAP32[(($5)>>2)]=$92;
      var $93=$91.f1;
      HEAP32[(($6)>>2)]=$93;
      var $94=HEAP32[(($6)>>2)];
      var $95=(($94)|0) < 0;
      if ($95) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $96
      var $97=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($97);
      throw "Reached an unreachable!"
    case 12: // $98
      var $99=HEAP32[(($5)>>2)];
      var $100=HEAP32[(($5)>>2)];
      var $101=HEAP32[(($6)>>2)];
      var $102=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $100, tempValue);
      var $103=($102.f1 = $101, $102);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $104
      throw "Reached an unreachable!"
    case 14: // $_ZnajPKciRK9zeromem_t_exit
      var $105=HEAP32[(($result_i1)>>2)];
      var $106=HEAP32[(($1)>>2)];
      _memset($105, 0, $106, 1);
      var $107=HEAP32[(($result_i1)>>2)];
      var $108=$1;
      var $109=$2;
      var $110=$3;
      var $111=$4;
      var $112=$result_i1;
      var $113=$5;
      var $114=$6;
      var $115=$107;
      var $116=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $117=__ZN13resource_pool9add_arrayIP14machine_configEEPT_S4_i(_global_resource_pool, $115, $116);
      HEAP32[(($67)>>2)]=$117;
      var $118=(($17+20)|0);
      __ZN11simple_listIN17driver_enumerator12config_entryEEC1ER13resource_pool($118, _global_resource_pool);
      var $119=$14;
      var $120=(function() { try { __THREW__ = false; return __ZN17driver_enumerator6filterERK11game_driver($17, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; };
    case 15: // $121
      STACKTOP = __stackBase__;
      return;
    case 16: // $122
      var $123=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $124=$123.f0;
      $15=$124;
      var $125=$123.f1;
      $16=$125;
      var $126=(($17+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $127
      __label__ = 18; break;
    case 18: // $128
      var $129=$15;
      var $130=$15;
      var $131=$16;
      var $132=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $130, tempValue);
      var $133=($132.f1 = $131, $132);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $134
      var $135=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17driver_enumeratorC2ER11emu_optionsRK11game_driver["X"]=1;

function __ZN17driver_enumeratorD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $index;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      $index=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$index;
      var $7=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$index;
      var $11=(($4+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+($10<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      var $18=$index;
      var $19=(($18+1)|0);
      $index=$19;
      __label__ = 1; break;
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $2=$22;
      var $23=$21.f1;
      $3=$23;
      var $24=(($4+20)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 6: // $25
      var $26=(($4+12)|0);
      var $27=HEAP32[(($26)>>2)];
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 7: // $28
      var $29=(($4+16)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 8: // $32
      var $33=(($4+20)|0);
      __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($33);
      ;
      return;
    case 9: // $34
      __label__ = 10; break;
    case 10: // $35
      var $36=$2;
      var $37=$2;
      var $38=$3;
      var $39=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37, tempValue);
      var $40=($39.f1 = $38, $39);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17driver_enumeratorD2Ev["X"]=1;

function __ZNK11simple_listIN17driver_enumerator12config_entryEE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listIN17driver_enumerator12config_entryEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17driver_enumerator12config_entry5indexEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN17driver_enumerator12config_entryEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17driver_enumerator4nextEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+1)|0);
      HEAP32[(($3)>>2)]=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $10=(($8)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=(($2)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($2+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+$13)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=(($2)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+1)|0);
      HEAP32[(($21)>>2)]=$23;
      __label__ = 1; break;
    case 5: // $24
      var $25=(($2)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0) >= 0;
      if ($27) { __label__ = 6; break; } else { var $34 = 0;__label__ = 7; break; }
    case 6: // $28
      var $29=(($2)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $32=(($30)|0) < (($31)|0);
      var $34 = $32;__label__ = 7; break;
    case 7: // $33
      var $34;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17driver_enumerator13next_excludedEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+1)|0);
      HEAP32[(($3)>>2)]=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $10=(($8)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=(($2)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($2+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+$13)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=(($2)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+1)|0);
      HEAP32[(($21)>>2)]=$23;
      __label__ = 1; break;
    case 5: // $24
      var $25=(($2)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0) >= 0;
      if ($27) { __label__ = 6; break; } else { var $34 = 0;__label__ = 7; break; }
    case 6: // $28
      var $29=(($2)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $32=(($30)|0) < (($31)|0);
      var $34 = $32;__label__ = 7; break;
    case 7: // $33
      var $34;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17driver_enumerator12config_entryEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN17driver_enumerator12config_entryEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZNK17driver_enumerator6configEi($this, $index) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $result_i1=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $first;
      var $config;
      var $19;
      var $20;
      $17=$this;
      $18=$index;
      var $21=$17;
      __label__ = 1; break;
    case 1: // $22
      __label__ = 2; break;
    case 2: // $23
      var $24=$18;
      var $25=(($21+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+($24<<2))|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 3; break; } else { __label__ = 32; break; }
    case 3: // $30
      var $31=(($21+20)|0);
      var $32=__ZNK11simple_listIN17driver_enumerator12config_entryEE5countEv($31);
      var $33=(($32)|0)==100;
      if ($33) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $34
      var $35=(($21+20)|0);
      var $36=__ZNK11simple_listIN17driver_enumerator12config_entryEE5firstEv($35);
      $first=$36;
      var $37=$first;
      var $38=__ZNK17driver_enumerator12config_entry5indexEv($37);
      var $39=(($21+16)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+($38<<2))|0);
      HEAP32[(($41)>>2)]=0;
      var $42=(($21+20)|0);
      var $43=$first;
      __ZN11simple_listIN17driver_enumerator12config_entryEE6removeERS1_($42, $43);
      __label__ = 5; break;
    case 5: // $44
      var $45=$12;
      var $46=$13;
      var $47=$14;
      var $48=$result_i;
      var $49=$15;
      var $50=$16;
      HEAP32[(($12)>>2)]=476;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($14)>>2)]=228;
      var $51=HEAP32[(($12)>>2)];
      var $52=HEAP32[(($13)>>2)];
      var $53=HEAP32[(($14)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($51, $52, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $55
      HEAP32[(($result_i)>>2)]=$54;
      var $56=HEAP32[(($result_i)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $58
      var $59=___cxa_allocate_exception(4);
      var $60=$59;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($60);
      (function() { try { __THREW__ = false; return ___cxa_throw($59, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($15)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($16)>>2)]=$64;
      var $65=HEAP32[(($16)>>2)];
      var $66=(($65)|0) < 0;
      if ($66) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $67
      var $68=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($68);
      throw "Reached an unreachable!"
    case 10: // $69
      var $70=HEAP32[(($15)>>2)];
      var $71=HEAP32[(($15)>>2)];
      var $72=HEAP32[(($16)>>2)];
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $75
      throw "Reached an unreachable!"
    case 12: // $_ZnwjPKci_exit
      var $76=HEAP32[(($result_i)>>2)];
      var $77=$12;
      var $78=$13;
      var $79=$14;
      var $80=$result_i;
      var $81=$15;
      var $82=$16;
      var $83=$76;
      var $84=$18;
      var $85=((__ZN11driver_list16s_drivers_sortedE+($84<<2))|0);
      var $86=((((HEAPU8[($85)])|(HEAPU8[($85+1)]<<8)|(HEAPU8[($85+2)]<<16)|(HEAPU8[($85+3)]<<24))|0));
      var $87=(($21+8)|0);
      var $88=HEAP32[(($87)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($83, $86, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 22; break; }
    case 13: // $89
      var $90=__ZN13resource_pool10add_objectI14machine_configEEPT_S3_(_global_resource_pool, $83);
      var $91=$18;
      var $92=(($21+16)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+($91<<2))|0);
      HEAP32[(($94)>>2)]=$90;
      $config=$90;
      var $95=(($21+20)|0);
      var $96=$7;
      var $97=$8;
      var $98=$9;
      var $99=$result_i1;
      var $100=$10;
      var $101=$11;
      HEAP32[(($7)>>2)]=12;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($9)>>2)]=229;
      var $102=HEAP32[(($7)>>2)];
      var $103=HEAP32[(($8)>>2)];
      var $104=HEAP32[(($9)>>2)];
      var $105=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($102, $103, $104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $106
      HEAP32[(($result_i1)>>2)]=$105;
      var $107=HEAP32[(($result_i1)>>2)];
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $109
      var $110=___cxa_allocate_exception(4);
      var $111=$110;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($111);
      (function() { try { __THREW__ = false; return ___cxa_throw($110, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; }
    case 16: // $112
      var $113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $114=$113.f0;
      HEAP32[(($10)>>2)]=$114;
      var $115=$113.f1;
      HEAP32[(($11)>>2)]=$115;
      var $116=HEAP32[(($11)>>2)];
      var $117=(($116)|0) < 0;
      if ($117) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $118
      var $119=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($119);
      throw "Reached an unreachable!"
    case 18: // $120
      var $121=HEAP32[(($10)>>2)];
      var $122=HEAP32[(($10)>>2)];
      var $123=HEAP32[(($11)>>2)];
      var $124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $122, tempValue);
      var $125=($124.f1 = $123, $124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $126
      throw "Reached an unreachable!"
    case 20: // $_ZnwjPKci_exit2
      var $127=HEAP32[(($result_i1)>>2)];
      var $128=$7;
      var $129=$8;
      var $130=$9;
      var $131=$result_i1;
      var $132=$10;
      var $133=$11;
      var $134=$127;
      var $135=$config;
      var $136=$18;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumerator12config_entryC1ER14machine_configi]($134, $135, $136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 27; break; }
    case 21: // $137
      var $138=__ZN13resource_pool10add_objectIN17driver_enumerator12config_entryEEEPT_S4_(_global_resource_pool, $134);
      var $139=__ZN11simple_listIN17driver_enumerator12config_entryEE6appendERS1_($95, $138);
      __label__ = 32; break;
    case 22: // $140
      var $141=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $142=$141.f0;
      $19=$142;
      var $143=$141.f1;
      $20=$143;
      var $144=$4;
      var $145=$5;
      var $146=$6;
      HEAP32[(($4)>>2)]=$76;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($6)>>2)]=228;
      var $147=HEAP32[(($4)>>2)];
      var $148=(($147)|0)!=0;
      if ($148) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $149
      var $150=HEAP32[(($4)>>2)];
      var $151=HEAP32[(($5)>>2)];
      var $152=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($150, $151, $152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 34; break; }
    case 24: // $_noexc
      __label__ = 25; break;
    case 25: // $_ZdlPvPKci_exit
      var $153=$4;
      var $154=$5;
      var $155=$6;
      __label__ = 26; break;
    case 26: // $156
      __label__ = 33; break;
    case 27: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $159=$158.f0;
      $19=$159;
      var $160=$158.f1;
      $20=$160;
      var $161=$1;
      var $162=$2;
      var $163=$3;
      HEAP32[(($1)>>2)]=$127;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($3)>>2)]=229;
      var $164=HEAP32[(($1)>>2)];
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $166
      var $167=HEAP32[(($1)>>2)];
      var $168=HEAP32[(($2)>>2)];
      var $169=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($167, $168, $169) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $_noexc3
      __label__ = 30; break;
    case 30: // $_ZdlPvPKci_exit4
      var $170=$1;
      var $171=$2;
      var $172=$3;
      __label__ = 31; break;
    case 31: // $173
      __label__ = 33; break;
    case 32: // $174
      var $175=$18;
      var $176=(($21+16)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177+($175<<2))|0);
      var $179=HEAP32[(($178)>>2)];
      STACKTOP = __stackBase__;
      return $179;
    case 33: // $180
      var $181=$19;
      var $182=$19;
      var $183=$20;
      var $184=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $182, tempValue);
      var $185=($184.f1 = $183, $184);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 34: // $186
      var $187=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK17driver_enumerator6configEi["X"]=1;

function __ZN13resource_pool10add_objectI14machine_configEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14machine_configEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14machine_configEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectIN17driver_enumerator12config_entryEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN17driver_enumerator12config_entryEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN17driver_enumerator12config_entryEEEPT_S4_["X"]=1;

function __ZN17driver_enumerator12config_entryC2ER14machine_configi($this, $config, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$config;
  $3=$index;
  var $4=$1;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($4+4)|0);
  var $7=$2;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($4+8)|0);
  var $9=$3;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN17driver_enumerator12config_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  __ZN13resource_pool6removeEPv(_global_resource_pool, $5);
  ;
  return;
}


function __ZN20resource_pool_objectIN17driver_enumerator12config_entryEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN17driver_enumerator12config_entryEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN17driver_enumerator12config_entryEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 12);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN17driver_enumerator12config_entryEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN17driver_enumerator12config_entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN17driver_enumerator12config_entryEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI14machine_configEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14machine_configEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14machine_configEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 476);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14machine_configE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14machine_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14machine_configED2Ev($2);
  ;
  return;
}


function __ZN17driver_enumerator24find_approximate_matchesEPKciPi($this, $string, $count, $results) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i4=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $12;
      var $13;
      var $14;
      var $templist;
      var $arrayindex;
      var $index;
      var $shufnum;
      var $item1;
      var $item2;
      var $temp;
      var $matchnum;
      var $penalty;
      var $matchnum1;
      var $index2;
      var $curpenalty;
      var $tmp;
      var $matchnum3;
      $11=$this;
      $12=$string;
      $13=$count;
      $14=$results;
      var $15=$11;
      var $16=$12;
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$12;
      var $20=(($19)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 2; break; } else { __label__ = 26; break; }
    case 2: // $24
      var $25=_osd_ticks();
      var $25$0=$25[0];
      var $25$1=$25[1];
      var $26$0=$25$0;
      var $26=$26$0;
      _srand($26);
      var $27=(($15+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=_llvm_umul_with_overflow_i32($28, 4);
      var $30=$29.f1;
      var $31=$29.f0;
      var $32=$30 ? -1 : $31;
      var $33=$6;
      var $34=$7;
      var $35=$8;
      var $36=$result_i;
      var $37=$9;
      var $38=$10;
      HEAP32[(($6)>>2)]=$32;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($8)>>2)]=348;
      var $39=HEAP32[(($6)>>2)];
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($8)>>2)];
      var $42=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($39, $40, $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $43
      HEAP32[(($result_i)>>2)]=$42;
      var $44=HEAP32[(($result_i)>>2)];
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $46
      var $47=___cxa_allocate_exception(4);
      var $48=$47;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($48);
      (function() { try { __THREW__ = false; return ___cxa_throw($47, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($9)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($10)>>2)]=$52;
      var $53=HEAP32[(($10)>>2)];
      var $54=(($53)|0) < 0;
      if ($54) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $55
      var $56=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($56);
      throw "Reached an unreachable!"
    case 7: // $57
      var $58=HEAP32[(($9)>>2)];
      var $59=HEAP32[(($9)>>2)];
      var $60=HEAP32[(($10)>>2)];
      var $61=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $59, tempValue);
      var $62=($61.f1 = $60, $61);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $63
      throw "Reached an unreachable!"
    case 9: // $_ZnajPKci_exit
      var $64=HEAP32[(($result_i)>>2)];
      var $65=$6;
      var $66=$7;
      var $67=$8;
      var $68=$result_i;
      var $69=$9;
      var $70=$10;
      var $71=$64;
      var $72=(($15+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=__ZN13resource_pool9add_arrayIiEEPT_S2_i(_global_resource_pool, $71, $73);
      $templist=$74;
      $arrayindex=0;
      $index=0;
      __label__ = 10; break;
    case 10: // $75
      var $76=$index;
      var $77=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $78=(($76)|0) < (($77)|0);
      if ($78) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $79
      var $80=$index;
      var $81=(($15+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82+$80)|0);
      var $84=HEAP8[($83)];
      var $85=(($84 << 24) >> 24)!=0;
      if ($85) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $86
      var $87=$index;
      var $88=$arrayindex;
      var $89=(($88+1)|0);
      $arrayindex=$89;
      var $90=$templist;
      var $91=(($90+($88<<2))|0);
      HEAP32[(($91)>>2)]=$87;
      __label__ = 13; break;
    case 13: // $92
      __label__ = 14; break;
    case 14: // $93
      var $94=$index;
      var $95=(($94+1)|0);
      $index=$95;
      __label__ = 10; break;
    case 15: // $96
      __label__ = 16; break;
    case 16: // $97
      __label__ = 17; break;
    case 17: // $98
      $shufnum=0;
      __label__ = 18; break;
    case 18: // $99
      var $100=$shufnum;
      var $101=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $102=((($101<<2))|0);
      var $103=(($100)|0) < (($102)|0);
      if ($103) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $104
      var $105=_rand();
      var $106=(($15+4)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($105)|0)%(($107)|0);
      $item1=$108;
      var $109=_rand();
      var $110=(($15+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($109)|0)%(($111)|0);
      $item2=$112;
      var $113=$item1;
      var $114=$templist;
      var $115=(($114+($113<<2))|0);
      var $116=HEAP32[(($115)>>2)];
      $temp=$116;
      var $117=$item2;
      var $118=$templist;
      var $119=(($118+($117<<2))|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$item1;
      var $122=$templist;
      var $123=(($122+($121<<2))|0);
      HEAP32[(($123)>>2)]=$120;
      var $124=$temp;
      var $125=$item2;
      var $126=$templist;
      var $127=(($126+($125<<2))|0);
      HEAP32[(($127)>>2)]=$124;
      __label__ = 20; break;
    case 20: // $128
      var $129=$shufnum;
      var $130=(($129+1)|0);
      $shufnum=$130;
      __label__ = 18; break;
    case 21: // $131
      $matchnum=0;
      __label__ = 22; break;
    case 22: // $132
      var $133=$matchnum;
      var $134=$13;
      var $135=(($133)|0) < (($134)|0);
      if ($135) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $136
      var $137=$matchnum;
      var $138=(($15+4)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($137)|0)%(($139)|0);
      var $141=$templist;
      var $142=(($141+($140<<2))|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$matchnum;
      var $145=$14;
      var $146=(($145+($144<<2))|0);
      HEAP32[(($146)>>2)]=$143;
      __label__ = 24; break;
    case 24: // $147
      var $148=$matchnum;
      var $149=(($148+1)|0);
      $matchnum=$149;
      __label__ = 22; break;
    case 25: // $150
      var $151=$templist;
      var $152=$151;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $152);
      __label__ = 54; break;
    case 26: // $153
      var $154=$13;
      var $155=_llvm_umul_with_overflow_i32($154, 4);
      var $156=$155.f1;
      var $157=$155.f0;
      var $158=$156 ? -1 : $157;
      var $159=$1;
      var $160=$2;
      var $161=$3;
      var $162=$result_i4;
      var $163=$4;
      var $164=$5;
      HEAP32[(($1)>>2)]=$158;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str4326)|0);
      HEAP32[(($3)>>2)]=374;
      var $165=HEAP32[(($1)>>2)];
      var $166=HEAP32[(($2)>>2)];
      var $167=HEAP32[(($3)>>2)];
      var $168=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($165, $166, $167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $169
      HEAP32[(($result_i4)>>2)]=$168;
      var $170=HEAP32[(($result_i4)>>2)];
      var $171=(($170)|0)==0;
      if ($171) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $172
      var $173=___cxa_allocate_exception(4);
      var $174=$173;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($174);
      (function() { try { __THREW__ = false; return ___cxa_throw($173, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 29; break; }
    case 29: // $175
      var $176=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $177=$176.f0;
      HEAP32[(($4)>>2)]=$177;
      var $178=$176.f1;
      HEAP32[(($5)>>2)]=$178;
      var $179=HEAP32[(($5)>>2)];
      var $180=(($179)|0) < 0;
      if ($180) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $181
      var $182=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($182);
      throw "Reached an unreachable!"
    case 31: // $183
      var $184=HEAP32[(($4)>>2)];
      var $185=HEAP32[(($4)>>2)];
      var $186=HEAP32[(($5)>>2)];
      var $187=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $185, tempValue);
      var $188=($187.f1 = $186, $187);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 32: // $189
      throw "Reached an unreachable!"
    case 33: // $_ZnajPKci_exit5
      var $190=HEAP32[(($result_i4)>>2)];
      var $191=$1;
      var $192=$2;
      var $193=$3;
      var $194=$result_i4;
      var $195=$4;
      var $196=$5;
      var $197=$190;
      var $198=$13;
      var $199=__ZN13resource_pool9add_arrayIiEEPT_S2_i(_global_resource_pool, $197, $198);
      $penalty=$199;
      $matchnum1=0;
      __label__ = 34; break;
    case 34: // $200
      var $201=$matchnum1;
      var $202=$13;
      var $203=(($201)|0) < (($202)|0);
      if ($203) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $204
      var $205=$matchnum1;
      var $206=$penalty;
      var $207=(($206+($205<<2))|0);
      HEAP32[(($207)>>2)]=9999;
      var $208=$matchnum1;
      var $209=$14;
      var $210=(($209+($208<<2))|0);
      HEAP32[(($210)>>2)]=-1;
      __label__ = 36; break;
    case 36: // $211
      var $212=$matchnum1;
      var $213=(($212+1)|0);
      $matchnum1=$213;
      __label__ = 34; break;
    case 37: // $214
      $index2=0;
      __label__ = 38; break;
    case 38: // $215
      var $216=$index2;
      var $217=HEAP32[((__ZN11driver_list14s_driver_countE)>>2)];
      var $218=(($216)|0) < (($217)|0);
      if ($218) { __label__ = 39; break; } else { __label__ = 53; break; }
    case 39: // $219
      var $220=$index2;
      var $221=(($15+12)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($222+$220)|0);
      var $224=HEAP8[($223)];
      var $225=(($224 << 24) >> 24)!=0;
      if ($225) { __label__ = 40; break; } else { __label__ = 51; break; }
    case 40: // $226
      var $227=$index2;
      var $228=((__ZN11driver_list16s_drivers_sortedE+($227<<2))|0);
      var $229=((((HEAPU8[($228)])|(HEAPU8[($228+1)]<<8)|(HEAPU8[($228+2)]<<16)|(HEAPU8[($228+3)]<<24))|0));
      var $230=(($229+44)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=$231 & 8192;
      var $233=(($232)|0)!=0;
      if ($233) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $234
      __label__ = 52; break;
    case 42: // $235
      var $236=$12;
      var $237=$index2;
      var $238=((__ZN11driver_list16s_drivers_sortedE+($237<<2))|0);
      var $239=((((HEAPU8[($238)])|(HEAPU8[($238+1)]<<8)|(HEAPU8[($238+2)]<<16)|(HEAPU8[($238+3)]<<24))|0));
      var $240=(($239+12)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=__ZN11driver_list15penalty_compareEPKcS1_($236, $241);
      $curpenalty=$242;
      var $243=$12;
      var $244=$index2;
      var $245=((__ZN11driver_list16s_drivers_sortedE+($244<<2))|0);
      var $246=((((HEAPU8[($245)])|(HEAPU8[($245+1)]<<8)|(HEAPU8[($245+2)]<<16)|(HEAPU8[($245+3)]<<24))|0));
      var $247=(($246+8)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=__ZN11driver_list15penalty_compareEPKcS1_($243, $248);
      $tmp=$249;
      var $250=$curpenalty;
      var $251=$tmp;
      var $252=(($250)|0) < (($251)|0);
      var $253=$curpenalty;
      var $254=$tmp;
      var $255=$252 ? $253 : $254;
      $curpenalty=$255;
      var $256=$13;
      var $257=(($256-1)|0);
      $matchnum3=$257;
      __label__ = 43; break;
    case 43: // $258
      var $259=$matchnum3;
      var $260=(($259)|0) >= 0;
      if ($260) { __label__ = 44; break; } else { __label__ = 50; break; }
    case 44: // $261
      var $262=$curpenalty;
      var $263=$matchnum3;
      var $264=$penalty;
      var $265=(($264+($263<<2))|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($262)|0) >= (($266)|0);
      if ($267) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $268
      __label__ = 50; break;
    case 46: // $269
      var $270=$matchnum3;
      var $271=$13;
      var $272=(($271-1)|0);
      var $273=(($270)|0) < (($272)|0);
      if ($273) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $274
      var $275=$matchnum3;
      var $276=$penalty;
      var $277=(($276+($275<<2))|0);
      var $278=HEAP32[(($277)>>2)];
      var $279=$matchnum3;
      var $280=(($279+1)|0);
      var $281=$penalty;
      var $282=(($281+($280<<2))|0);
      HEAP32[(($282)>>2)]=$278;
      var $283=$matchnum3;
      var $284=$14;
      var $285=(($284+($283<<2))|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=$matchnum3;
      var $288=(($287+1)|0);
      var $289=$14;
      var $290=(($289+($288<<2))|0);
      HEAP32[(($290)>>2)]=$286;
      __label__ = 48; break;
    case 48: // $291
      var $292=$index2;
      var $293=$matchnum3;
      var $294=$14;
      var $295=(($294+($293<<2))|0);
      HEAP32[(($295)>>2)]=$292;
      var $296=$curpenalty;
      var $297=$matchnum3;
      var $298=$penalty;
      var $299=(($298+($297<<2))|0);
      HEAP32[(($299)>>2)]=$296;
      __label__ = 49; break;
    case 49: // $300
      var $301=$matchnum3;
      var $302=(($301-1)|0);
      $matchnum3=$302;
      __label__ = 43; break;
    case 50: // $303
      __label__ = 51; break;
    case 51: // $304
      __label__ = 52; break;
    case 52: // $305
      var $306=$index2;
      var $307=(($306+1)|0);
      $index2=$307;
      __label__ = 38; break;
    case 53: // $308
      var $309=$penalty;
      var $310=$309;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $310);
      __label__ = 54; break;
    case 54: // $311
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17driver_enumerator24find_approximate_matchesEPKciPi["X"]=1;

function __ZN20resource_pool_objectIN17driver_enumerator12config_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN17driver_enumerator12config_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN17driver_enumerator12config_entryEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN17driver_enumerator12config_entryEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17driver_enumerator12config_entryD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED2Ev["X"]=1;

function __ZN20resource_pool_objectI14machine_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14machine_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14machine_configED0Ev["X"]=1;

function __ZN11simple_listIN17driver_enumerator12config_entryEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN17driver_enumerator12config_entryEE6detachERS1_["X"]=1;

function __ZN11simple_listIN17driver_enumerator12config_entryEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN17driver_enumerator12config_entryEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN17driver_enumerator12config_entryEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN17driver_enumerator12config_entryEE+8)|0);
  __ZN11simple_listIN17driver_enumerator12config_entryEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN17driver_enumerator12config_entryEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN17driver_enumerator12config_entryEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayIP14machine_configEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIP14machine_configEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIP14machine_configEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<2))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIP14machine_configE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIP14machine_configED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIP14machine_configED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI14machine_configED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI14machine_configE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14machine_configED2Ev["X"]=1;

function __ZN11simple_listIN17driver_enumerator12config_entryEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17driver_enumerator12config_entryEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN17driver_enumerator12config_entryEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIP14machine_configED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIP14machine_configED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIP14machine_configED0Ev["X"]=1;

function __ZN19resource_pool_arrayIP14machine_configED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIP14machine_configE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12core_options5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12core_options5entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function ___cxx_global_var_init4595() {
  ;
  var __label__;

  var $1=__ZN12core_options9unadornedEi(0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE)|0))>>2)]=$1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+4)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+8)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+12)|0))>>2)]=0;
  var $2=__ZN12core_options9unadornedEi(1);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+16)|0))>>2)]=$2;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+20)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+24)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+28)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+32)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+36)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+40)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+44)|0))>>2)]=((STRING_TABLE.__str4348)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+48)|0))>>2)]=((STRING_TABLE.__str14349)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+52)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+56)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+60)|0))>>2)]=((STRING_TABLE.__str34351)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+64)|0))>>2)]=((STRING_TABLE.__str44352)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+68)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+72)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+76)|0))>>2)]=((STRING_TABLE.__str64354)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+80)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+84)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+88)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+92)|0))>>2)]=((STRING_TABLE.__str74355)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+96)|0))>>2)]=((STRING_TABLE.__str84356)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+100)|0))>>2)]=((STRING_TABLE.__str94357)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+104)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+108)|0))>>2)]=((STRING_TABLE.__str104358)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+112)|0))>>2)]=((STRING_TABLE.__str114359)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+116)|0))>>2)]=((STRING_TABLE.__str124360)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+120)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+124)|0))>>2)]=((STRING_TABLE.__str134361)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+128)|0))>>2)]=((STRING_TABLE.__str144362)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+132)|0))>>2)]=((STRING_TABLE.__str154363)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+136)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+140)|0))>>2)]=((STRING_TABLE.__str164364)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+144)|0))>>2)]=((STRING_TABLE.__str174365)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+148)|0))>>2)]=((STRING_TABLE.__str184366)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+152)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+156)|0))>>2)]=((STRING_TABLE.__str194367)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+160)|0))>>2)]=((STRING_TABLE.__str204368)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+164)|0))>>2)]=((STRING_TABLE.__str214369)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+168)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+172)|0))>>2)]=((STRING_TABLE.__str224370)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+176)|0))>>2)]=((STRING_TABLE.__str234371)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+180)|0))>>2)]=((STRING_TABLE.__str244372)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+184)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+188)|0))>>2)]=((STRING_TABLE.__str254373)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+192)|0))>>2)]=((STRING_TABLE.__str264374)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+196)|0))>>2)]=((STRING_TABLE.__str274375)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+200)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+204)|0))>>2)]=((STRING_TABLE.__str284376)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+208)|0))>>2)]=((STRING_TABLE.__str294377)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+212)|0))>>2)]=((STRING_TABLE.__str304378)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+216)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+220)|0))>>2)]=((STRING_TABLE.__str314379)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+224)|0))>>2)]=((STRING_TABLE.__str324380)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+228)|0))>>2)]=((STRING_TABLE.__str334381)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+232)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+236)|0))>>2)]=((STRING_TABLE.__str344382)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+240)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+244)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+248)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+252)|0))>>2)]=((STRING_TABLE.__str354383)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+256)|0))>>2)]=((STRING_TABLE.__str364384)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+260)|0))>>2)]=((STRING_TABLE.__str374385)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+264)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+268)|0))>>2)]=((STRING_TABLE.__str384386)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+272)|0))>>2)]=((STRING_TABLE.__str394387)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+276)|0))>>2)]=((STRING_TABLE.__str404388)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+280)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+284)|0))>>2)]=((STRING_TABLE.__str414389)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+288)|0))>>2)]=((STRING_TABLE.__str424390)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+292)|0))>>2)]=((STRING_TABLE.__str434391)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+296)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+300)|0))>>2)]=((STRING_TABLE.__str444392)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+304)|0))>>2)]=((STRING_TABLE.__str454393)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+308)|0))>>2)]=((STRING_TABLE.__str464394)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+312)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+316)|0))>>2)]=((STRING_TABLE.__str474395)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+320)|0))>>2)]=((STRING_TABLE.__str484396)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+324)|0))>>2)]=((STRING_TABLE.__str494397)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+328)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+332)|0))>>2)]=((STRING_TABLE.__str504398)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+336)|0))>>2)]=((STRING_TABLE.__str514399)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+340)|0))>>2)]=((STRING_TABLE.__str524400)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+344)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+348)|0))>>2)]=((STRING_TABLE.__str534401)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+352)|0))>>2)]=((STRING_TABLE.__str544402)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+356)|0))>>2)]=((STRING_TABLE.__str554403)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+360)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+364)|0))>>2)]=((STRING_TABLE.__str564404)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+368)|0))>>2)]=((STRING_TABLE.__str574405)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+372)|0))>>2)]=((STRING_TABLE.__str584406)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+376)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+380)|0))>>2)]=((STRING_TABLE.__str594407)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+384)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+388)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+392)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+396)|0))>>2)]=((STRING_TABLE.__str604408)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+400)|0))>>2)]=((STRING_TABLE.__str614409)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+404)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+408)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+412)|0))>>2)]=((STRING_TABLE.__str624410)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+416)|0))>>2)]=((STRING_TABLE.__str634411)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+420)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+424)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+428)|0))>>2)]=((STRING_TABLE.__str644412)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+432)|0))>>2)]=((STRING_TABLE.__str654413)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+436)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+440)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+444)|0))>>2)]=((STRING_TABLE.__str664414)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+448)|0))>>2)]=((STRING_TABLE.__str674415)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+452)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+456)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+460)|0))>>2)]=((STRING_TABLE.__str684416)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+464)|0))>>2)]=((STRING_TABLE.__str694417)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+468)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+472)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+476)|0))>>2)]=((STRING_TABLE.__str704418)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+480)|0))>>2)]=((STRING_TABLE.__str714419)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+484)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+488)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+492)|0))>>2)]=((STRING_TABLE.__str724420)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+496)|0))>>2)]=((STRING_TABLE.__str734421)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+500)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+504)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+508)|0))>>2)]=((STRING_TABLE.__str744422)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+512)|0))>>2)]=((STRING_TABLE.__str754423)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+516)|0))>>2)]=((STRING_TABLE.__str764424)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+520)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+524)|0))>>2)]=((STRING_TABLE.__str774425)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+528)|0))>>2)]=((STRING_TABLE.__str784426)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+532)|0))>>2)]=((STRING_TABLE.__str794427)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+536)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+540)|0))>>2)]=((STRING_TABLE.__str804428)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+544)|0))>>2)]=((STRING_TABLE.__str814429)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+548)|0))>>2)]=((STRING_TABLE.__str824430)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+552)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+556)|0))>>2)]=((STRING_TABLE.__str834431)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+560)|0))>>2)]=((STRING_TABLE.__str844432)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+564)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+568)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+572)|0))>>2)]=((STRING_TABLE.__str854433)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+576)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+580)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+584)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+588)|0))>>2)]=((STRING_TABLE.__str864434)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+592)|0))>>2)]=((STRING_TABLE.__str874435)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+596)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+600)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+604)|0))>>2)]=((STRING_TABLE.__str884436)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+608)|0))>>2)]=((STRING_TABLE.__str894437)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+612)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+616)|0))>>2)]=4;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+620)|0))>>2)]=((STRING_TABLE.__str904438)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+624)|0))>>2)]=((STRING_TABLE.__str914439)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+628)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+632)|0))>>2)]=4;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+636)|0))>>2)]=((STRING_TABLE.__str924440)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+640)|0))>>2)]=((STRING_TABLE.__str934441)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+644)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+648)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+652)|0))>>2)]=((STRING_TABLE.__str944442)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+656)|0))>>2)]=((STRING_TABLE.__str954443)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+660)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+664)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+668)|0))>>2)]=((STRING_TABLE.__str964444)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+672)|0))>>2)]=((STRING_TABLE.__str974445)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+676)|0))>>2)]=((STRING_TABLE.__str984446)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+680)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+684)|0))>>2)]=((STRING_TABLE.__str994447)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+688)|0))>>2)]=((STRING_TABLE.__str1004448)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+692)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+696)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+700)|0))>>2)]=((STRING_TABLE.__str1014449)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+704)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+708)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+712)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+716)|0))>>2)]=((STRING_TABLE.__str1024450)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+720)|0))>>2)]=((STRING_TABLE.__str1034451)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+724)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+728)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+732)|0))>>2)]=((STRING_TABLE.__str1044452)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+736)|0))>>2)]=((STRING_TABLE.__str1054453)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+740)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+744)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+748)|0))>>2)]=((STRING_TABLE.__str1064454)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+752)|0))>>2)]=((STRING_TABLE.__str1074455)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+756)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+760)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+764)|0))>>2)]=((STRING_TABLE.__str1084456)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+768)|0))>>2)]=((STRING_TABLE.__str1094457)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+772)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+776)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+780)|0))>>2)]=((STRING_TABLE.__str1104458)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+784)|0))>>2)]=((STRING_TABLE.__str1114459)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+788)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+792)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+796)|0))>>2)]=((STRING_TABLE.__str1124460)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+800)|0))>>2)]=((STRING_TABLE.__str1134461)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+804)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+808)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+812)|0))>>2)]=((STRING_TABLE.__str1144462)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+816)|0))>>2)]=((STRING_TABLE.__str1154463)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+820)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+824)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+828)|0))>>2)]=((STRING_TABLE.__str1164464)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+832)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+836)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+840)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+844)|0))>>2)]=((STRING_TABLE.__str1174465)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+848)|0))>>2)]=((STRING_TABLE.__str1184466)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+852)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+856)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+860)|0))>>2)]=((STRING_TABLE.__str1194467)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+864)|0))>>2)]=((STRING_TABLE.__str1204468)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+868)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+872)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+876)|0))>>2)]=((STRING_TABLE.__str1214469)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+880)|0))>>2)]=((STRING_TABLE.__str1224470)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+884)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+888)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+892)|0))>>2)]=((STRING_TABLE.__str1234471)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+896)|0))>>2)]=((STRING_TABLE.__str1244472)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+900)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+904)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+908)|0))>>2)]=((STRING_TABLE.__str1254473)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+912)|0))>>2)]=((STRING_TABLE.__str1264474)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+916)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+920)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+924)|0))>>2)]=((STRING_TABLE.__str1274475)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+928)|0))>>2)]=((STRING_TABLE.__str1284476)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+932)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+936)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+940)|0))>>2)]=((STRING_TABLE.__str1294477)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+944)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+948)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+952)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+956)|0))>>2)]=((STRING_TABLE.__str1304478)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+960)|0))>>2)]=((STRING_TABLE.__str1314479)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+964)|0))>>2)]=((STRING_TABLE.__str984446)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+968)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+972)|0))>>2)]=((STRING_TABLE.__str1324480)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+976)|0))>>2)]=((STRING_TABLE.__str1334481)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+980)|0))>>2)]=((STRING_TABLE.__str984446)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+984)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+988)|0))>>2)]=((STRING_TABLE.__str1344482)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+992)|0))>>2)]=((STRING_TABLE.__str1354483)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+996)|0))>>2)]=((STRING_TABLE.__str984446)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1000)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1004)|0))>>2)]=((STRING_TABLE.__str1364484)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1008)|0))>>2)]=((STRING_TABLE.__str1374485)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1012)|0))>>2)]=((STRING_TABLE.__str1384486)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1016)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1020)|0))>>2)]=((STRING_TABLE.__str1394487)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1024)|0))>>2)]=((STRING_TABLE.__str1404488)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1028)|0))>>2)]=((STRING_TABLE.__str1414489)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1032)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1036)|0))>>2)]=((STRING_TABLE.__str1424490)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1040)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1044)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1048)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1052)|0))>>2)]=((STRING_TABLE.__str1434491)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1056)|0))>>2)]=((STRING_TABLE.__str1444492)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1060)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1064)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1068)|0))>>2)]=((STRING_TABLE.__str1454493)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1072)|0))>>2)]=((STRING_TABLE.__str1464494)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1076)|0))>>2)]=((STRING_TABLE.__str984446)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1080)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1084)|0))>>2)]=((STRING_TABLE.__str1474495)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1088)|0))>>2)]=((STRING_TABLE.__str1484496)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1092)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1096)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1100)|0))>>2)]=((STRING_TABLE.__str1494497)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1104)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1108)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1112)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1116)|0))>>2)]=((STRING_TABLE.__str1504498)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1120)|0))>>2)]=((STRING_TABLE.__str1514499)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1124)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1128)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1132)|0))>>2)]=((STRING_TABLE.__str1524500)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1136)|0))>>2)]=((STRING_TABLE.__str1534501)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1140)|0))>>2)]=((STRING_TABLE.__str1544502)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1144)|0))>>2)]=4;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1148)|0))>>2)]=((STRING_TABLE.__str1554503)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1152)|0))>>2)]=((STRING_TABLE.__str154363)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1156)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1160)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1164)|0))>>2)]=((STRING_TABLE.__str1564504)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1168)|0))>>2)]=((STRING_TABLE.__str1574505)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1172)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1176)|0))>>2)]=4;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1180)|0))>>2)]=((STRING_TABLE.__str1584506)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1184)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1188)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1192)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1196)|0))>>2)]=((STRING_TABLE.__str1594507)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1200)|0))>>2)]=((STRING_TABLE.__str1604508)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1204)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1208)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1212)|0))>>2)]=((STRING_TABLE.__str1614509)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1216)|0))>>2)]=((STRING_TABLE.__str214369)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1220)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1224)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1228)|0))>>2)]=((STRING_TABLE.__str1624510)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1232)|0))>>2)]=((STRING_TABLE.__str1634511)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1236)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1240)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1244)|0))>>2)]=((STRING_TABLE.__str1644512)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1248)|0))>>2)]=((STRING_TABLE.__str1654513)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1252)|0))>>2)]=((STRING_TABLE.__str24350)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1256)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1260)|0))>>2)]=((STRING_TABLE.__str1664514)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1264)|0))>>2)]=((STRING_TABLE.__str1674515)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1268)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1272)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1276)|0))>>2)]=((STRING_TABLE.__str1684516)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1280)|0))>>2)]=((STRING_TABLE.__str1694517)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1284)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1288)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1292)|0))>>2)]=((STRING_TABLE.__str1704518)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1296)|0))>>2)]=((STRING_TABLE.__str1714519)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1300)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1304)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1308)|0))>>2)]=((STRING_TABLE.__str1724520)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1312)|0))>>2)]=((STRING_TABLE.__str1734521)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1316)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1320)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1324)|0))>>2)]=((STRING_TABLE.__str1744522)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1328)|0))>>2)]=((STRING_TABLE.__str1754523)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1332)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1336)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1340)|0))>>2)]=((STRING_TABLE.__str1764524)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1344)|0))>>2)]=((STRING_TABLE.__str1774525)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1348)|0))>>2)]=((STRING_TABLE.__str794427)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1352)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1356)|0))>>2)]=((STRING_TABLE.__str1784526)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1360)|0))>>2)]=((STRING_TABLE.__str1794527)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1364)|0))>>2)]=((STRING_TABLE.__str1804528)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1368)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1372)|0))>>2)]=((STRING_TABLE.__str1814529)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1376)|0))>>2)]=((STRING_TABLE.__str1824530)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1380)|0))>>2)]=((STRING_TABLE.__str1834531)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1384)|0))>>2)]=5;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1388)|0))>>2)]=((STRING_TABLE.__str1844532)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1392)|0))>>2)]=((STRING_TABLE.__str1854533)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1396)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1400)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1404)|0))>>2)]=((STRING_TABLE.__str1864534)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1408)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1412)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1416)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1420)|0))>>2)]=((STRING_TABLE.__str1874535)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1424)|0))>>2)]=((STRING_TABLE.__str1884536)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1428)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1432)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1436)|0))>>2)]=((STRING_TABLE.__str1904538)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1440)|0))>>2)]=((STRING_TABLE.__str1914539)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1444)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1448)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1452)|0))>>2)]=((STRING_TABLE.__str1924540)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1456)|0))>>2)]=((STRING_TABLE.__str1934541)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1460)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1464)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1468)|0))>>2)]=((STRING_TABLE.__str1944542)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1472)|0))>>2)]=((STRING_TABLE.__str1954543)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1476)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1480)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1484)|0))>>2)]=((STRING_TABLE.__str1964544)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1488)|0))>>2)]=((STRING_TABLE.__str1974545)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1492)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1496)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1500)|0))>>2)]=((STRING_TABLE.__str1984546)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1504)|0))>>2)]=((STRING_TABLE.__str1994547)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1508)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1512)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1516)|0))>>2)]=((STRING_TABLE.__str2004548)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1520)|0))>>2)]=((STRING_TABLE.__str2014549)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1524)|0))>>2)]=((STRING_TABLE.__str1894537)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1528)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1532)|0))>>2)]=((STRING_TABLE.__str2024550)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1536)|0))>>2)]=((STRING_TABLE.__str2034551)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1540)|0))>>2)]=((STRING_TABLE.__str1634511)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1544)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1548)|0))>>2)]=((STRING_TABLE.__str2044552)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1552)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1556)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1560)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1564)|0))>>2)]=((STRING_TABLE.__str2054553)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1568)|0))>>2)]=((STRING_TABLE.__str2064554)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1572)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1576)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1580)|0))>>2)]=((STRING_TABLE.__str2074555)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1584)|0))>>2)]=((STRING_TABLE.__str2084556)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1588)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1592)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1596)|0))>>2)]=((STRING_TABLE.__str2094557)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1600)|0))>>2)]=((STRING_TABLE.__str2104558)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1604)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1608)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1612)|0))>>2)]=((STRING_TABLE.__str2114559)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1616)|0))>>2)]=((STRING_TABLE.__str2124560)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1620)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1624)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1628)|0))>>2)]=((STRING_TABLE.__str2134561)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1632)|0))>>2)]=((STRING_TABLE.__str2144562)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1636)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1640)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1644)|0))>>2)]=((STRING_TABLE.__str2154563)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1648)|0))>>2)]=((STRING_TABLE.__str2164564)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1652)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1656)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1660)|0))>>2)]=((STRING_TABLE.__str2174565)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1664)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1668)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1672)|0))>>2)]=1;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1676)|0))>>2)]=((STRING_TABLE.__str2184566)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1680)|0))>>2)]=((STRING_TABLE.__str2194567)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1684)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1688)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1692)|0))>>2)]=((STRING_TABLE.__str2204568)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1696)|0))>>2)]=((STRING_TABLE.__str2214569)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1700)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1704)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1708)|0))>>2)]=((STRING_TABLE.__str2224570)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1712)|0))>>2)]=((STRING_TABLE.__str2234571)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1716)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1720)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1724)|0))>>2)]=((STRING_TABLE.__str2244572)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1728)|0))>>2)]=((STRING_TABLE.__str2254573)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1732)|0))>>2)]=((STRING_TABLE.__str2264574)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1736)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1740)|0))>>2)]=((STRING_TABLE.__str2274575)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1744)|0))>>2)]=((STRING_TABLE.__str2284576)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1748)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1752)|0))>>2)]=6;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1756)|0))>>2)]=((STRING_TABLE.__str2294577)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1760)|0))>>2)]=((STRING_TABLE.__str2304578)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1764)|0))>>2)]=((STRING_TABLE.__str54353)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1768)|0))>>2)]=3;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1772)|0))>>2)]=((STRING_TABLE.__str2314579)|0);
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1776)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1780)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1784)|0))>>2)]=0;
  HEAP32[((((__ZN11emu_options16s_option_entriesE+1788)|0))>>2)]=0;
  ;
  return;
}
___cxx_global_var_init4595["X"]=1;

function __ZN11emu_options21remove_device_optionsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $nextentry;
      var $curentry;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK12core_options5firstEv($3);
      $curentry=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$curentry;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$curentry;
      var $10=__ZNK12core_options5entry4nextEv($9);
      $nextentry=$10;
      var $11=$curentry;
      var $12=__ZNK12core_options5entry5flagsEv($11);
      var $13=$12 & -2147483648;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=$curentry;
      __ZN12core_options12remove_entryERNS_5entryE($16, $17);
      __label__ = 4; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$nextentry;
      $curentry=$20;
      __label__ = 1; break;
    case 6: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11emu_optionsC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      __ZN12core_optionsC2Ev($5);
      var $6=$4;
      HEAP32[(($6)>>2)]=((__ZTV11emu_options+8)|0);
      var $7=$4;
      (function() { try { __THREW__ = false; return __ZN12core_options11add_entriesEPK13options_entryb($7, ((__ZN11emu_options16s_option_entriesE)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN12core_optionsD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11emu_options18add_device_optionsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 1120; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cursystem;
      var $config=__stackBase__;
      var $entry=__stackBase__+476;
      var $first;
      var $slot=__stackBase__+508;
      var $gotone;
      var $2;
      var $3;
      var $option_name=__stackBase__+512;
      var $image=__stackBase__+576;
      var $slot_config=__stackBase__+580;
      var $gotone1;
      var $option_name2=__stackBase__+1056;
      $1=$this;
      var $4=$1;
      __ZN11emu_options21remove_device_optionsEv($4);
      var $5=__ZNK11emu_options6systemEv($4);
      $cursystem=$5;
      var $6=$cursystem;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 52; break;
    case 2: // $9
      var $10=$cursystem;
      FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($config, $10, $4);
      var $11=$entry;
      HEAP32[(($11)>>2)]=0; HEAP32[(($11+4)>>2)]=0; HEAP32[(($11+8)>>2)]=0; HEAP32[(($11+12)>>2)]=0; HEAP32[(($11+16)>>2)]=0; HEAP32[(($11+20)>>2)]=0; HEAP32[(($11+24)>>2)]=0; HEAP32[(($11+28)>>2)]=0;
      $first=1;
      HEAP32[(($slot)>>2)]=0;
      var $12=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 9; break; };
    case 3: // $13
      var $14=(function() { try { __THREW__ = false; return __ZNK11device_list5firstIK21device_slot_interfaceEEbRPT_($12, $slot) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; };
    case 4: // $15
      var $16=(($14)&1);
      $gotone=$16;
      __label__ = 5; break;
    case 5: // $17
      var $18=$gotone;
      var $19=(($18) & 1);
      if ($19) { __label__ = 6; break; } else { __label__ = 29; break; }
    case 6: // $20
      var $21=$first;
      var $22=(($21) & 1);
      if ($22) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $23
      $first=0;
      var $24=(($entry)|0);
      var $25=(($24)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($entry)|0);
      var $27=(($26+12)|0);
      HEAP32[(($27)>>2)]=((STRING_TABLE.__str2324580)|0);
      var $28=(($entry)|0);
      var $29=(($28+8)|0);
      HEAP32[(($29)>>2)]=-2147483647;
      var $30=(($entry)|0);
      var $31=(($30+4)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=$4;
      var $33=(($entry)|0);
      (function() { try { __THREW__ = false; return __ZN12core_options11add_entriesEPK13options_entryb($32, $33, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $34
      __label__ = 10; break;
    case 9: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $2=$37;
      var $38=$36.f1;
      $3=$38;
      __label__ = 55; break;
    case 10: // $39
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($option_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 11: // $40
      var $41=HEAP32[(($slot)>>2)];
      var $42=$41;
      var $43=(function() { try { __THREW__ = false; return __ZNK16device_interface6deviceEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 27; break; };
    case 12: // $44
      var $45=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 27; break; };
    case 13: // $46
      var $47=HEAP32[(($slot)>>2)];
      var $48=$47;
      var $49=(function() { try { __THREW__ = false; return __ZNK16device_interface6deviceEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 27; break; };
    case 14: // $50
      var $51=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 27; break; };
    case 15: // $52
      var $53=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($option_name, ((STRING_TABLE.__str2334581)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,HEAP32[((tempInt+4)>>2)]=$51,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 27; break; };
    case 16: // $54
      var $55=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($option_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 27; break; };
    case 17: // $56
      var $57=(($entry)|0);
      var $58=(($57)|0);
      HEAP32[(($58)>>2)]=$55;
      var $59=(($entry)|0);
      var $60=(($59+12)|0);
      HEAP32[(($60)>>2)]=0;
      var $61=(($entry)|0);
      var $62=(($61+8)|0);
      HEAP32[(($62)>>2)]=-2147483642;
      var $63=HEAP32[(($slot)>>2)];
      var $64=(function() { try { __THREW__ = false; return __ZNK21device_slot_interface19get_slot_interfacesEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 27; break; };
    case 18: // $65
      var $66=(($64)|0)!=0;
      if ($66) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $67
      var $68=HEAP32[(($slot)>>2)];
      var $69=(function() { try { __THREW__ = false; return __ZNK21device_slot_interface16get_default_cardEv($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 27; break; };
    case 20: // $70
      var $73 = $69;__label__ = 22; break;
    case 21: // $71
      var $73 = 0;__label__ = 22; break;
    case 22: // $72
      var $73;
      var $74=(($entry)|0);
      var $75=(($74+4)|0);
      HEAP32[(($75)>>2)]=$73;
      var $76=$4;
      var $77=(($entry)|0);
      (function() { try { __THREW__ = false; return __ZN12core_options11add_entriesEPK13options_entryb($76, $77, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $78
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 9; break; }
    case 24: // $79
      __label__ = 25; break;
    case 25: // $80
      var $81=HEAP32[(($slot)>>2)];
      var $82=$81;
      var $83=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextIK21device_slot_interfaceEEbRPT_($82, $slot) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 9; break; };
    case 26: // $84
      var $85=(($83)&1);
      $gotone=$85;
      __label__ = 5; break;
    case 27: // $86
      var $87=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $88=$87.f0;
      $2=$88;
      var $89=$87.f1;
      $3=$89;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 58; break; }
    case 28: // $90
      __label__ = 55; break;
    case 29: // $91
      HEAP32[(($image)>>2)]=0;
      var $92=$cursystem;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($slot_config, $92, $4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 9; break; }
    case 30: // $93
      $first=1;
      var $94=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($slot_config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 37; break; };
    case 31: // $95
      var $96=(function() { try { __THREW__ = false; return __ZNK11device_list5firstIK22device_image_interfaceEEbRPT_($94, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 37; break; };
    case 32: // $97
      var $98=(($96)&1);
      $gotone1=$98;
      __label__ = 33; break;
    case 33: // $99
      var $100=$gotone1;
      var $101=(($100) & 1);
      if ($101) { __label__ = 34; break; } else { __label__ = 50; break; }
    case 34: // $102
      var $103=$first;
      var $104=(($103) & 1);
      if ($104) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $105
      $first=0;
      var $106=(($entry)|0);
      var $107=(($106)|0);
      HEAP32[(($107)>>2)]=0;
      var $108=(($entry)|0);
      var $109=(($108+12)|0);
      HEAP32[(($109)>>2)]=((STRING_TABLE.__str2344582)|0);
      var $110=(($entry)|0);
      var $111=(($110+8)|0);
      HEAP32[(($111)>>2)]=-2147483647;
      var $112=(($entry)|0);
      var $113=(($112+4)|0);
      HEAP32[(($113)>>2)]=0;
      var $114=$4;
      var $115=(($entry)|0);
      (function() { try { __THREW__ = false; return __ZN12core_options11add_entriesEPK13options_entryb($114, $115, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $116
      __label__ = 38; break;
    case 37: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      $2=$119;
      var $120=$118.f1;
      $3=$120;
      __label__ = 53; break;
    case 38: // $121
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($option_name2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 37; break; }
    case 39: // $122
      var $123=HEAP32[(($image)>>2)];
      var $124=(function() { try { __THREW__ = false; return __ZNK22device_image_interface13instance_nameEv($123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 48; break; };
    case 40: // $125
      var $126=HEAP32[(($image)>>2)];
      var $127=(function() { try { __THREW__ = false; return __ZNK22device_image_interface19brief_instance_nameEv($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 48; break; };
    case 41: // $128
      var $129=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($option_name2, ((STRING_TABLE.__str2334581)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$124,HEAP32[((tempInt+4)>>2)]=$127,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 48; break; };
    case 42: // $130
      var $131=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($option_name2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 48; break; };
    case 43: // $132
      var $133=(($entry)|0);
      var $134=(($133)|0);
      HEAP32[(($134)>>2)]=$131;
      var $135=(($entry)|0);
      var $136=(($135+12)|0);
      HEAP32[(($136)>>2)]=0;
      var $137=(($entry)|0);
      var $138=(($137+8)|0);
      HEAP32[(($138)>>2)]=-2147483642;
      var $139=(($entry)|0);
      var $140=(($139+4)|0);
      HEAP32[(($140)>>2)]=0;
      var $141=$4;
      var $142=(($entry)|0);
      (function() { try { __THREW__ = false; return __ZN12core_options11add_entriesEPK13options_entryb($141, $142, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 48; break; }
    case 44: // $143
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_name2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 37; break; }
    case 45: // $144
      __label__ = 46; break;
    case 46: // $145
      var $146=HEAP32[(($image)>>2)];
      var $147=$146;
      var $148=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_($147, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 37; break; };
    case 47: // $149
      var $150=(($148)&1);
      $gotone1=$150;
      __label__ = 33; break;
    case 48: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      $2=$153;
      var $154=$152.f1;
      $3=$154;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option_name2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 58; break; }
    case 49: // $155
      __label__ = 53; break;
    case 50: // $156
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($slot_config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 9; break; }
    case 51: // $157
      FUNCTION_TABLE[__ZN14machine_configD1Ev]($config);
      __label__ = 52; break;
    case 52: // $158
      STACKTOP = __stackBase__;
      return;
    case 53: // $159
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($slot_config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 58; break; }
    case 54: // $160
      __label__ = 55; break;
    case 55: // $161
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 58; break; }
    case 56: // $162
      __label__ = 57; break;
    case 57: // $163
      var $164=$2;
      var $165=$2;
      var $166=$3;
      var $167=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $165, tempValue);
      var $168=($167.f1 = $166, $167);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 58: // $169
      var $170=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11emu_options18add_device_optionsEv["X"]=1;

function __ZNK11emu_options6systemEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tempstr=__stackBase__;
      var $index;
      var $3;
      var $4;
      var $5;
      $2=$this;
      var $6=$2;
      __ZN7astringC1Ev($tempstr);
      var $7=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 9; break; };
    case 1: // $8
      var $9=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($tempstr, $7, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 9; break; };
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 9; break; };
    case 3: // $12
      var $13=(function() { try { __THREW__ = false; return __ZN11driver_list4findEPKc($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; };
    case 4: // $14
      $index=$13;
      var $15=$index;
      var $16=(($15)|0)!=-1;
      if ($16) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $17
      var $18=$index;
      var $19=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $20
      var $23 = $19;__label__ = 8; break;
    case 7: // $21
      var $23 = 0;__label__ = 8; break;
    case 8: // $22
      var $23;
      $1=$23;
      $5=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      var $24=$1;
      STACKTOP = __stackBase__;
      return $24;
    case 9: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $3=$27;
      var $28=$26.f1;
      $4=$28;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $29
      __label__ = 11; break;
    case 11: // $30
      var $31=$3;
      var $32=$3;
      var $33=$4;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12core_options5entry5flagsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK7astringneEPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=$2;
  var $5=__ZNK7astring3cmpEPKc($3, $4);
  var $6=(($5)|0)!=0;
  ;
  return $6;
}


function __ZN11emu_options13device_optionER22device_image_interface($this, $image) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$image;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZNK22device_image_interface13instance_nameEv($5);
  var $7=__ZNK12core_options5valueEPKc($4, $6);
  ;
  return $7;
}


function __ZN11emu_optionsD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11emu_optionsD2Ev($2);
  ;
  return;
}


function __GLOBAL__I_a4608() {
  ;
  var __label__;

  ___cxx_global_var_init4595();
  ;
  return;
}


function ___cxx_global_var_init4692() {
  ;
  var __label__;

  __ZN18render_screen_listC1ER13resource_pool(__ZN13render_target19s_empty_screen_listE, _global_resource_pool);
  var $1=___cxa_atexit(1110, __ZN13render_target19s_empty_screen_listE, ___dso_handle);
  ;
  return;
}


function __ZN18render_screen_listC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN18render_screen_listC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN18render_screen_listD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18render_screen_listD2Ev($2);
  ;
  return;
}


function __ZN11emu_options18parse_command_lineEiPPcR7astring($this, $argc, $argv, $error_string) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $old_system_name=__stackBase__;
      var $result;
      var $6;
      var $7;
      var $8;
      $2=$this;
      $3=$argc;
      $4=$argv;
      $5=$error_string;
      var $9=$2;
      var $10=__ZNK11emu_options11system_nameEv($9);
      __ZN7astringC1EPKc($old_system_name, $10);
      var $11=$9;
      var $12=$3;
      var $13=$4;
      var $14=$5;
      var $15=(function() { try { __THREW__ = false; return __ZN12core_options18parse_command_lineEiPPciR7astring($11, $12, $13, 150, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $16
      var $17=(($15)&1);
      $result=$17;
      var $18=(function() { try { __THREW__ = false; return __ZNK11emu_options11system_nameEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK7astringneEPKc($old_system_name, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $21
      if ($20) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $22
      (function() { try { __THREW__ = false; return __ZN11emu_options18add_device_optionsEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $23
      var $24=$result;
      var $25=(($24) & 1);
      if ($25) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $26
      var $27=$9;
      var $28=$3;
      var $29=$4;
      var $30=$5;
      var $31=(function() { try { __THREW__ = false; return __ZN12core_options18parse_command_lineEiPPciR7astring($27, $28, $29, 150, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $32
      var $33=(($31)&1);
      $result=$33;
      __label__ = 9; break;
    case 8: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $6=$36;
      var $37=$35.f1;
      $7=$37;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($old_system_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 9: // $38
      __label__ = 10; break;
    case 10: // $39
      var $40=$result;
      var $41=(($40) & 1);
      $1=$41;
      $8=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($old_system_name);
      var $42=$1;
      STACKTOP = __stackBase__;
      return $42;
    case 11: // $43
      __label__ = 12; break;
    case 12: // $44
      var $45=$6;
      var $46=$6;
      var $47=$7;
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11emu_options18parse_command_lineEiPPcR7astring["X"]=1;

function __ZN11emu_options19parse_standard_inisER7astring($this, $error_string) {
  var __stackBase__  = STACKTOP; STACKTOP += 540; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $cursystem;
      var $config=__stackBase__;
      var $device;
      var $3;
      var $4;
      var $sourcename=__stackBase__+476;
      var $parent;
      var $gparent;
      $1=$this;
      $2=$error_string;
      var $5=$1;
      var $6=$2;
      var $7=__ZN7astring5resetEv($6);
      var $8=__ZN11emu_options13parse_one_iniEPKciP7astring($5, ((STRING_TABLE.__str2354583)|0), 101, 0);
      var $9=$2;
      var $10=__ZN11emu_options13parse_one_iniEPKciP7astring($5, ((STRING_TABLE.__str2354583)|0), 101, $9);
      var $11=__ZNK11emu_options5debugEv($5);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=__ZN11emu_options13parse_one_iniEPKciP7astring($5, ((STRING_TABLE.__str2364584)|0), 102, $13);
      __label__ = 2; break;
    case 2: // $15
      var $16=__ZNK11emu_options6systemEv($5);
      $cursystem=$16;
      var $17=$cursystem;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 44; break;
    case 4: // $20
      var $21=$cursystem;
      var $22=(($21+44)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23 & 4;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$2;
      var $28=__ZN11emu_options13parse_one_iniEPKciP7astring($5, ((STRING_TABLE.__str2374585)|0), 103, $27);
      __label__ = 7; break;
    case 6: // $29
      var $30=$2;
      var $31=__ZN11emu_options13parse_one_iniEPKciP7astring($5, ((STRING_TABLE.__str2384586)|0), 103, $30);
      __label__ = 7; break;
    case 7: // $32
      var $33=$cursystem;
      FUNCTION_TABLE[__ZN14machine_configC1ERK11game_driverR11emu_options]($config, $33, $5);
      var $34=(function() { try { __THREW__ = false; return __ZNK14machine_config12first_screenEv($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; };
    case 8: // $35
      $device=$34;
      __label__ = 9; break;
    case 9: // $36
      var $37=$device;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 10; break; } else { __label__ = 18; break; }
    case 10: // $39
      var $40=$device;
      var $41=(function() { try { __THREW__ = false; return __ZNK13screen_device11screen_typeEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $42
      var $43=(($41)|0)==2;
      if ($43) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $44
      var $45=$2;
      var $46=(function() { try { __THREW__ = false; return __ZN11emu_options13parse_one_iniEPKciP7astring($5, ((STRING_TABLE.__str2394587)|0), 104, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $47
      __label__ = 18; break;
    case 14: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      $3=$50;
      var $51=$49.f1;
      $4=$51;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14machine_configD1Ev]($config) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 47; break; }
    case 15: // $52
      __label__ = 16; break;
    case 16: // $53
      var $54=$device;
      var $55=(function() { try { __THREW__ = false; return __ZNK13screen_device11next_screenEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 14; break; };
    case 17: // $56
      $device=$55;
      __label__ = 9; break;
    case 18: // $57
      FUNCTION_TABLE[__ZN14machine_configD1Ev]($config);
      __ZN7astringC1Ev($sourcename);
      var $58=$cursystem;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($sourcename, $60, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 28; break; };
    case 19: // $62
      var $63=(function() { try { __THREW__ = false; return __ZN7astring3insEiPKc($61, 0, ((STRING_TABLE.__str2404588)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 28; break; };
    case 20: // $64
      var $65=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($sourcename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 28; break; };
    case 21: // $66
      var $67=$2;
      var $68=(function() { try { __THREW__ = false; return __ZN11emu_options13parse_one_iniEPKciP7astring($5, $65, 105, $67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 28; break; };
    case 22: // $69
      if ($68) { __label__ = 29; break; } else { __label__ = 23; break; }
    case 23: // $70
      var $71=$cursystem;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(function() { try { __THREW__ = false; return __Z26core_filename_extract_baseP7astringPKci($sourcename, $73, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 28; break; };
    case 24: // $75
      var $76=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($sourcename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 28; break; };
    case 25: // $77
      var $78=$2;
      var $79=(function() { try { __THREW__ = false; return __ZN11emu_options13parse_one_iniEPKciP7astring($5, $76, 105, $78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 28; break; };
    case 26: // $80
      __label__ = 29; break;
    case 27: // $81
      __label__ = 46; break;
    case 28: // $82
      var $83=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $84=$83.f0;
      $3=$84;
      var $85=$83.f1;
      $4=$85;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($sourcename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 29: // $86
      var $87=$cursystem;
      var $88=(function() { try { __THREW__ = false; return __ZN11driver_list5cloneERK11game_driver($87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 28; break; };
    case 30: // $89
      $parent=$88;
      var $90=$parent;
      var $91=(($90)|0)!=-1;
      if ($91) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $92
      var $93=$parent;
      var $94=(function() { try { __THREW__ = false; return __ZN11driver_list5cloneEi($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 28; break; };
    case 32: // $95
      var $98 = $94;__label__ = 34; break;
    case 33: // $96
      var $98 = -1;__label__ = 34; break;
    case 34: // $97
      var $98;
      $gparent=$98;
      var $99=$gparent;
      var $100=(($99)|0)!=-1;
      if ($100) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $101
      var $102=$gparent;
      var $103=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 28; break; };
    case 36: // $104
      var $105=(($103+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$2;
      var $108=(function() { try { __THREW__ = false; return __ZN11emu_options13parse_one_iniEPKciP7astring($5, $106, 106, $107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 28; break; };
    case 37: // $109
      __label__ = 38; break;
    case 38: // $110
      var $111=$parent;
      var $112=(($111)|0)!=-1;
      if ($112) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $113
      var $114=$parent;
      var $115=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 28; break; };
    case 40: // $116
      var $117=(($115+8)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$2;
      var $120=(function() { try { __THREW__ = false; return __ZN11emu_options13parse_one_iniEPKciP7astring($5, $118, 107, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 28; break; };
    case 41: // $121
      __label__ = 42; break;
    case 42: // $122
      var $123=$cursystem;
      var $124=(($123+8)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$2;
      var $127=(function() { try { __THREW__ = false; return __ZN11emu_options13parse_one_iniEPKciP7astring($5, $125, 108, $126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 28; break; };
    case 43: // $128
      FUNCTION_TABLE[__ZN7astringD1Ev]($sourcename);
      __label__ = 44; break;
    case 44: // $129
      STACKTOP = __stackBase__;
      return;
    case 45: // $130
      __label__ = 46; break;
    case 46: // $131
      var $132=$3;
      var $133=$3;
      var $134=$4;
      var $135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $133, tempValue);
      var $136=($135.f1 = $134, $135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 47: // $137
      var $138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11emu_options19parse_standard_inisER7astring["X"]=1;

function __ZN11emu_options13parse_one_iniEPKciP7astring($this, $basename, $priority, $error_string) {
  var __stackBase__  = STACKTOP; STACKTOP += 324; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $file=__stackBase__;
      var $filerr;
      var $6;
      var $7;
      var $8;
      var $error=__stackBase__+260;
      var $result;
      $2=$this;
      $3=$basename;
      $4=$priority;
      $5=$error_string;
      var $9=$2;
      var $10=__ZNK11emu_options11read_configEv($9);
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      $1=0;
      __label__ = 24; break;
    case 2: // $12
      var $13=__ZNK11emu_options8ini_pathEv($9);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $13, 1);
      var $14=$3;
      var $15=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $14, ((STRING_TABLE.__str2414589)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $16
      $filerr=$15;
      var $17=$filerr;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $19
      $1=0;
      $8=1;
      __label__ = 21; break;
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $6=$22;
      var $23=$21.f1;
      $7=$23;
      __label__ = 22; break;
    case 6: // $24
      var $25=$3;
      (function() { try { __THREW__ = false; return __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str2424590)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$25,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 7: // $26
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 8: // $27
      var $28=$9;
      var $29=(function() { try { __THREW__ = false; return __ZN8emu_filecvR10_core_fileEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 17; break; };
    case 9: // $30
      var $31=$4;
      var $32=(function() { try { __THREW__ = false; return __ZN12core_options14parse_ini_fileER10_core_fileiiR7astring($28, $29, $31, 108, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 17; break; };
    case 10: // $33
      var $34=(($32)&1);
      $result=$34;
      var $35=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 17; break; };
    case 11: // $36
      if ($35) { __label__ = 12; break; } else { __label__ = 18; break; }
    case 12: // $37
      var $38=$5;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $40
      var $41=$5;
      var $42=(function() { try { __THREW__ = false; return __ZNK8emu_file8fullpathEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 17; break; };
    case 14: // $43
      var $44=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $45
      var $46=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($41, ((STRING_TABLE.__str2434591)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,HEAP32[((tempInt+4)>>2)]=$44,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; };
    case 16: // $47
      __label__ = 18; break;
    case 17: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      $6=$50;
      var $51=$49.f1;
      $7=$51;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 18: // $52
      var $53=$result;
      var $54=(($53) & 1);
      $1=$54;
      $8=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 5; break; }
    case 19: // $55
      __label__ = 21; break;
    case 20: // $56
      __label__ = 22; break;
    case 21: // $57
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 24; break;
    case 22: // $58
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $59
      __label__ = 25; break;
    case 24: // $60
      var $61=$1;
      STACKTOP = __stackBase__;
      return $61;
    case 25: // $62
      var $63=$6;
      var $64=$6;
      var $65=$7;
      var $66=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $64, tempValue);
      var $67=($66.f1 = $65, $66);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11emu_options13parse_one_iniEPKciP7astring["X"]=1;

function __ZN11emu_options15set_system_nameEPKc($this, $name) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $old_system_name=__stackBase__;
      var $3;
      var $4;
      var $error=__stackBase__+64;
      $1=$this;
      $2=$name;
      var $5=$1;
      var $6=__ZNK11emu_options11system_nameEv($5);
      __ZN7astringC1EPKc($old_system_name, $6);
      var $7=$2;
      var $8=(function() { try { __THREW__ = false; return __ZNK7astringneEPKc($old_system_name, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 11; break; };
    case 1: // $9
      if ($8) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $10
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $11
      var $12=$5;
      var $13=(function() { try { __THREW__ = false; return __ZN12core_options9unadornedEi(0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; };
    case 4: // $14
      var $15=$2;
      var $16=(function() { try { __THREW__ = false; return __ZN12core_options9set_valueEPKcS1_iR7astring($12, $13, $15, 150, $error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; };
    case 5: // $17
      __label__ = 6; break;
    case 6: // $18
      __label__ = 7; break;
    case 7: // $19
      __label__ = 8; break;
    case 8: // $20
      (function() { try { __THREW__ = false; return __ZN11emu_options18add_device_optionsEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $21
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $22
      __label__ = 14; break;
    case 11: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $3=$25;
      var $26=$24.f1;
      $4=$26;
      __label__ = 15; break;
    case 12: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $3=$29;
      var $30=$28.f1;
      $4=$30;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($error) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $31
      __label__ = 15; break;
    case 14: // $32
      FUNCTION_TABLE[__ZN7astringD1Ev]($old_system_name);
      STACKTOP = __stackBase__;
      return;
    case 15: // $33
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($old_system_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $34
      __label__ = 17; break;
    case 17: // $35
      var $36=$3;
      var $37=$3;
      var $38=$4;
      var $39=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $37, tempValue);
      var $40=($39.f1 = $38, $39);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11emu_options15set_system_nameEPKc["X"]=1;

function __ZN11emu_optionsD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11emu_optionsD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11emu_optionsD0Ev["X"]=1;

function __Z12parse_boundsR15running_machineP14_xml_data_nodeR13render_bounds($machine, $boundsnode, $bounds) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$machine;
      $2=$boundsnode;
      $3=$bounds;
      var $6=$2;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9+4)|0);
      HEAPF32[(($10)>>2)]=0;
      var $11=$3;
      var $12=(($11)|0);
      HEAPF32[(($12)>>2)]=0;
      var $13=$3;
      var $14=(($13+12)|0);
      HEAPF32[(($14)>>2)]=1;
      var $15=$3;
      var $16=(($15+8)|0);
      HEAPF32[(($16)>>2)]=1;
      __label__ = 15; break;
    case 2: // $17
      var $18=$2;
      var $19=__Z17xml_get_attributeP14_xml_data_nodePKc($18, ((STRING_TABLE.__str4615)|0));
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$1;
      var $23=$2;
      var $24=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($22, $23, ((STRING_TABLE.__str4615)|0), 0);
      var $25=$3;
      var $26=(($25)|0);
      HEAPF32[(($26)>>2)]=$24;
      var $27=$1;
      var $28=$2;
      var $29=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($27, $28, ((STRING_TABLE.__str14616)|0), 1);
      var $30=$3;
      var $31=(($30+8)|0);
      HEAPF32[(($31)>>2)]=$29;
      var $32=$1;
      var $33=$2;
      var $34=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($32, $33, ((STRING_TABLE.__str24617)|0), 0);
      var $35=$3;
      var $36=(($35+4)|0);
      HEAPF32[(($36)>>2)]=$34;
      var $37=$1;
      var $38=$2;
      var $39=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($37, $38, ((STRING_TABLE.__str34618)|0), 1);
      var $40=$3;
      var $41=(($40+12)|0);
      HEAPF32[(($41)>>2)]=$39;
      __label__ = 10; break;
    case 4: // $42
      var $43=$2;
      var $44=__Z17xml_get_attributeP14_xml_data_nodePKc($43, ((STRING_TABLE.__str44619)|0));
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$1;
      var $48=$2;
      var $49=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($47, $48, ((STRING_TABLE.__str44619)|0), 0);
      var $50=$3;
      var $51=(($50)|0);
      HEAPF32[(($51)>>2)]=$49;
      var $52=$3;
      var $53=(($52)|0);
      var $54=HEAPF32[(($53)>>2)];
      var $55=$1;
      var $56=$2;
      var $57=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($55, $56, ((STRING_TABLE.__str54620)|0), 1);
      var $58=$54+$57;
      var $59=$3;
      var $60=(($59+8)|0);
      HEAPF32[(($60)>>2)]=$58;
      var $61=$1;
      var $62=$2;
      var $63=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($61, $62, ((STRING_TABLE.__str64621)|0), 0);
      var $64=$3;
      var $65=(($64+4)|0);
      HEAPF32[(($65)>>2)]=$63;
      var $66=$3;
      var $67=(($66+4)|0);
      var $68=HEAPF32[(($67)>>2)];
      var $69=$1;
      var $70=$2;
      var $71=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($69, $70, ((STRING_TABLE.__str74622)|0), 1);
      var $72=$68+$71;
      var $73=$3;
      var $74=(($73+12)|0);
      HEAPF32[(($74)>>2)]=$72;
      __label__ = 9; break;
    case 6: // $75
      var $76=___cxa_allocate_exception(1032);
      var $77=$76;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($77, ((STRING_TABLE.__str84623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $78
      ___cxa_throw($76, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 8: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $81=$80.f0;
      $4=$81;
      var $82=$80.f1;
      $5=$82;
      ___cxa_free_exception($76);
      __label__ = 16; break;
    case 9: // $83
      __label__ = 10; break;
    case 10: // $84
      var $85=$3;
      var $86=(($85)|0);
      var $87=HEAPF32[(($86)>>2)];
      var $88=$3;
      var $89=(($88+8)|0);
      var $90=HEAPF32[(($89)>>2)];
      var $91=$87 > $90;
      if ($91) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $92
      var $93=$3;
      var $94=(($93+4)|0);
      var $95=HEAPF32[(($94)>>2)];
      var $96=$3;
      var $97=(($96+12)|0);
      var $98=HEAPF32[(($97)>>2)];
      var $99=$95 > $98;
      if ($99) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $100
      var $101=___cxa_allocate_exception(1032);
      var $102=$101;
      var $103=$3;
      var $104=(($103)|0);
      var $105=HEAPF32[(($104)>>2)];
      var $106=$105;
      var $107=$3;
      var $108=(($107+8)|0);
      var $109=HEAPF32[(($108)>>2)];
      var $110=$109;
      var $111=$3;
      var $112=(($111+4)|0);
      var $113=HEAPF32[(($112)>>2)];
      var $114=$113;
      var $115=$3;
      var $116=(($115+12)|0);
      var $117=HEAPF32[(($116)>>2)];
      var $118=$117;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($102, ((STRING_TABLE.__str94624)|0), (tempInt=STACKTOP,STACKTOP += 32,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$106,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$110,HEAP32[((tempInt+8)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+8+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$114,HEAP32[((tempInt+16)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+16+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$118,HEAP32[((tempInt+24)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+24+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $119
      ___cxa_throw($101, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 14: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $122=$121.f0;
      $4=$122;
      var $123=$121.f1;
      $5=$123;
      ___cxa_free_exception($101);
      __label__ = 16; break;
    case 15: // $124
      ;
      return;
    case 16: // $125
      var $126=$4;
      var $127=$4;
      var $128=$5;
      var $129=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $127, tempValue);
      var $130=($129.f1 = $128, $129);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12parse_boundsR15running_machineP14_xml_data_nodeR13render_bounds["X"]=1;

function __ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($machine, $node, $attribute, $defvalue) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $string;
      var $value=__stackBase__;
      $2=$machine;
      $3=$node;
      $4=$attribute;
      $5=$defvalue;
      var $6=$2;
      var $7=$3;
      var $8=$4;
      var $9=__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($6, $7, $8, 0);
      $string=$9;
      var $10=$string;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      var $13=$string;
      var $14=_sscanf($13, ((STRING_TABLE.__str754690)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $15=(($14)|0)!=1;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$5;
      $1=$17;
      __label__ = 4; break;
    case 3: // $18
      var $19=HEAPF32[(($value)>>2)];
      $1=$19;
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      STACKTOP = __stackBase__;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN14layout_element9componentEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN14layout_element9componentEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __Z11parse_colorR15running_machineP14_xml_data_nodeR12render_color($machine, $colornode, $color) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$machine;
      $2=$colornode;
      $3=$color;
      var $6=$2;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0);
      HEAPF32[(($10)>>2)]=1;
      var $11=$3;
      var $12=(($11+12)|0);
      HEAPF32[(($12)>>2)]=1;
      var $13=$3;
      var $14=(($13+8)|0);
      HEAPF32[(($14)>>2)]=1;
      var $15=$3;
      var $16=(($15+4)|0);
      HEAPF32[(($16)>>2)]=1;
      __label__ = 13; break;
    case 2: // $17
      var $18=$1;
      var $19=$2;
      var $20=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($18, $19, ((STRING_TABLE.__str104625)|0), 1);
      var $21=$3;
      var $22=(($21+4)|0);
      HEAPF32[(($22)>>2)]=$20;
      var $23=$1;
      var $24=$2;
      var $25=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($23, $24, ((STRING_TABLE.__str114626)|0), 1);
      var $26=$3;
      var $27=(($26+8)|0);
      HEAPF32[(($27)>>2)]=$25;
      var $28=$1;
      var $29=$2;
      var $30=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($28, $29, ((STRING_TABLE.__str124627)|0), 1);
      var $31=$3;
      var $32=(($31+12)|0);
      HEAPF32[(($32)>>2)]=$30;
      var $33=$1;
      var $34=$2;
      var $35=__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf($33, $34, ((STRING_TABLE.__str134628)|0), 1);
      var $36=$3;
      var $37=(($36)|0);
      HEAPF32[(($37)>>2)]=$35;
      var $38=$3;
      var $39=(($38+4)|0);
      var $40=HEAPF32[(($39)>>2)];
      var $41=$40;
      var $42=$41 < 0;
      if ($42) { __label__ = 10; break; } else { __label__ = 3; break; }
    case 3: // $43
      var $44=$3;
      var $45=(($44+4)|0);
      var $46=HEAPF32[(($45)>>2)];
      var $47=$46;
      var $48=$47 > 1;
      if ($48) { __label__ = 10; break; } else { __label__ = 4; break; }
    case 4: // $49
      var $50=$3;
      var $51=(($50+8)|0);
      var $52=HEAPF32[(($51)>>2)];
      var $53=$52;
      var $54=$53 < 0;
      if ($54) { __label__ = 10; break; } else { __label__ = 5; break; }
    case 5: // $55
      var $56=$3;
      var $57=(($56+8)|0);
      var $58=HEAPF32[(($57)>>2)];
      var $59=$58;
      var $60=$59 > 1;
      if ($60) { __label__ = 10; break; } else { __label__ = 6; break; }
    case 6: // $61
      var $62=$3;
      var $63=(($62+12)|0);
      var $64=HEAPF32[(($63)>>2)];
      var $65=$64;
      var $66=$65 < 0;
      if ($66) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $67
      var $68=$3;
      var $69=(($68+12)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $71=$70;
      var $72=$71 > 1;
      if ($72) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $73
      var $74=$3;
      var $75=(($74)|0);
      var $76=HEAPF32[(($75)>>2)];
      var $77=$76;
      var $78=$77 < 0;
      if ($78) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $79
      var $80=$3;
      var $81=(($80)|0);
      var $82=HEAPF32[(($81)>>2)];
      var $83=$82;
      var $84=$83 > 1;
      if ($84) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $85
      var $86=___cxa_allocate_exception(1032);
      var $87=$86;
      var $88=$3;
      var $89=(($88+4)|0);
      var $90=HEAPF32[(($89)>>2)];
      var $91=$90;
      var $92=$3;
      var $93=(($92+8)|0);
      var $94=HEAPF32[(($93)>>2)];
      var $95=$94;
      var $96=$3;
      var $97=(($96+12)|0);
      var $98=HEAPF32[(($97)>>2)];
      var $99=$98;
      var $100=$3;
      var $101=(($100)|0);
      var $102=HEAPF32[(($101)>>2)];
      var $103=$102;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($87, ((STRING_TABLE.__str144629)|0), (tempInt=STACKTOP,STACKTOP += 32,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$91,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$95,HEAP32[((tempInt+8)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+8+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$99,HEAP32[((tempInt+16)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+16+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$103,HEAP32[((tempInt+24)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+24+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $104
      ___cxa_throw($86, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 12: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $107=$106.f0;
      $4=$107;
      var $108=$106.f1;
      $5=$108;
      ___cxa_free_exception($86);
      __label__ = 14; break;
    case 13: // $109
      ;
      return;
    case 14: // $110
      var $111=$4;
      var $112=$4;
      var $113=$5;
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11parse_colorR15running_machineP14_xml_data_nodeR12render_color["X"]=1;

function __ZN14layout_elementC2ER15running_machineR14_xml_data_nodePKc($this, $machine, $elemnode, $dirname) {
  var __stackBase__  = STACKTOP; STACKTOP += 88; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $name;
      var $first;
      var $bounds=__stackBase__+72;
      var $compnode;
      var $newcomp;
      var $xoffs;
      var $yoffs;
      var $xscale;
      var $yscale;
      var $curcomp;
      $17=$this;
      $18=$machine;
      $19=$elemnode;
      $20=$dirname;
      var $23=$17;
      var $24=$23;
      HEAP32[(($24)>>2)]=((__ZTV14layout_element+8)|0);
      var $25=(($23+4)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($23+8)|0);
      var $27=$18;
      HEAP32[(($26)>>2)]=$27;
      var $28=(($23+12)|0);
      __ZN7astringC1Ev($28);
      var $29=(($23+76)|0);
      var $30=$18;
      var $31=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $32
      (function() { try { __THREW__ = false; return __ZN11simple_listIN14layout_element9componentEEC1ER13resource_pool($29, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $33
      var $34=(($23+96)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=(($23+100)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=(($23+104)|0);
      HEAP32[(($36)>>2)]=0;
      var $37=$18;
      var $38=$19;
      var $39=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($37, $38, ((STRING_TABLE.__str154630)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $40
      $name=$39;
      var $41=$name;
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $43
      var $44=___cxa_allocate_exception(1032);
      var $45=$44;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($45, ((STRING_TABLE.__str164631)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $46
      (function() { try { __THREW__ = false; return ___cxa_throw($44, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 7; break; }
    case 6: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $21=$49;
      var $50=$48.f1;
      $22=$50;
      __label__ = 84; break;
    case 7: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body5 = $52;__label__ = 8; break;
    case 8: // $_body4
      var $eh_lpad_body5;
      var $eh_lpad_body = $eh_lpad_body5;__label__ = 9; break;
    case 9: // $_body
      var $eh_lpad_body;
      var $53=$eh_lpad_body.f0;
      $21=$53;
      var $54=$eh_lpad_body.f1;
      $22=$54;
      __label__ = 82; break;
    case 10: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $21=$57;
      var $58=$56.f1;
      $22=$58;
      ___cxa_free_exception($44);
      __label__ = 82; break;
    case 11: // $59
      var $60=(($23+12)|0);
      var $61=$name;
      var $62=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($60, $61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; };
    case 12: // $63
      var $64=$18;
      var $65=$19;
      var $66=(function() { try { __THREW__ = false; return __ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci($64, $65, ((STRING_TABLE.__str174632)|0), -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 7; break; };
    case 13: // $67
      var $68=(($23+96)|0);
      HEAP32[(($68)>>2)]=$66;
      $first=1;
      var $69=$bounds;
      HEAP32[(($69)>>2)]=0; HEAP32[(($69+4)>>2)]=0; HEAP32[(($69+8)>>2)]=0; HEAP32[(($69+12)>>2)]=0;
      var $70=$19;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      $compnode=$72;
      __label__ = 14; break;
    case 14: // $73
      var $74=$compnode;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 15; break; } else { __label__ = 52; break; }
    case 15: // $76
      var $77=(($23+76)|0);
      var $78=$18;
      var $79=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 7; break; };
    case 16: // $80
      var $81=$12;
      var $82=$13;
      var $83=$14;
      var $84=$result_i;
      var $85=$15;
      var $86=$16;
      HEAP32[(($12)>>2)]=312;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($14)>>2)]=461;
      var $87=HEAP32[(($12)>>2)];
      var $88=HEAP32[(($13)>>2)];
      var $89=HEAP32[(($14)>>2)];
      var $90=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($87, $88, $89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $91
      HEAP32[(($result_i)>>2)]=$90;
      var $92=HEAP32[(($result_i)>>2)];
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $94
      var $95=___cxa_allocate_exception(4);
      var $96=$95;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($96);
      (function() { try { __THREW__ = false; return ___cxa_throw($95, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 19; break; }
    case 19: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $99=$98.f0;
      HEAP32[(($15)>>2)]=$99;
      var $100=$98.f1;
      HEAP32[(($16)>>2)]=$100;
      var $101=HEAP32[(($16)>>2)];
      var $102=(($101)|0) < 0;
      if ($102) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $103
      var $104=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 7; break; }
    case 21: // $_noexc
      throw "Reached an unreachable!"
    case 22: // $105
      var $106=HEAP32[(($15)>>2)];
      var $107=HEAP32[(($15)>>2)];
      var $108=HEAP32[(($16)>>2)];
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      var $eh_lpad_body = $110;__label__ = 9; break;
    case 23: // $111
      throw "Reached an unreachable!"
    case 24: // $_ZnwjPKci_exit
      var $112=HEAP32[(($result_i)>>2)];
      var $113=$12;
      var $114=$13;
      var $115=$14;
      var $116=$result_i;
      var $117=$15;
      var $118=$16;
      __label__ = 25; break;
    case 25: // $119
      var $120=$112;
      var $121=$18;
      var $122=$compnode;
      var $123=$20;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_element9componentC1ER15running_machineR14_xml_data_nodePKc]($120, $121, $122, $123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $124
      var $125=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN14layout_element9componentEEEPT_S4_($79, $120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 7; break; };
    case 27: // $126
      var $127=(function() { try { __THREW__ = false; return __ZN11simple_listIN14layout_element9componentEE6appendERS1_($77, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 7; break; };
    case 28: // $128
      $newcomp=$127;
      var $129=$first;
      var $130=(($129) & 1);
      if ($130) { __label__ = 29; break; } else { __label__ = 35; break; }
    case 29: // $131
      var $132=$newcomp;
      var $133=(($132+12)|0);
      var $134=$bounds;
      var $135=$133;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($134)>>2)]=HEAP32[(($135)>>2)];HEAP32[(($134+4)>>2)]=HEAP32[(($135+4)>>2)];HEAP32[(($134+8)>>2)]=HEAP32[(($135+8)>>2)];HEAP32[(($134+12)>>2)]=HEAP32[(($135+12)>>2)];
      __label__ = 37; break;
    case 30: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      $21=$138;
      var $139=$137.f1;
      $22=$139;
      var $140=$9;
      var $141=$10;
      var $142=$11;
      HEAP32[(($9)>>2)]=$112;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($11)>>2)]=461;
      var $143=HEAP32[(($9)>>2)];
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $145
      var $146=HEAP32[(($9)>>2)];
      var $147=HEAP32[(($10)>>2)];
      var $148=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($146, $147, $148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 87; break; }
    case 32: // $_noexc1
      __label__ = 33; break;
    case 33: // $_ZdlPvPKci_exit
      var $149=$9;
      var $150=$10;
      var $151=$11;
      __label__ = 34; break;
    case 34: // $152
      __label__ = 82; break;
    case 35: // $153
      var $154=$newcomp;
      var $155=(($154+12)|0);
      (function() { try { __THREW__ = false; return __ZL19union_render_boundsP13render_boundsPKS_($bounds, $155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 7; break; }
    case 36: // $156
      __label__ = 37; break;
    case 37: // $157
      $first=0;
      var $158=$newcomp;
      var $159=(($158+8)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($23+100)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($160)|0) > (($162)|0);
      if ($163) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $164
      var $165=$newcomp;
      var $166=(($165+8)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($23+100)|0);
      HEAP32[(($168)>>2)]=$167;
      __label__ = 39; break;
    case 39: // $169
      var $170=$newcomp;
      var $171=(($170+4)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172)|0)==5;
      if ($173) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $174
      var $175=(($23+100)|0);
      HEAP32[(($175)>>2)]=255;
      __label__ = 41; break;
    case 41: // $176
      var $177=$newcomp;
      var $178=(($177+4)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179)|0)==6;
      if ($180) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $181
      var $182=(($23+100)|0);
      HEAP32[(($182)>>2)]=16383;
      __label__ = 43; break;
    case 43: // $183
      var $184=$newcomp;
      var $185=(($184+4)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($186)|0)==8;
      if ($187) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $188
      var $189=$newcomp;
      var $190=(($189+4)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=(($191)|0)==7;
      if ($192) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $193
      var $194=(($23+100)|0);
      HEAP32[(($194)>>2)]=65535;
      __label__ = 46; break;
    case 46: // $195
      var $196=$newcomp;
      var $197=(($196+4)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198)|0)==9;
      if ($199) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $200
      var $201=(($23+100)|0);
      HEAP32[(($201)>>2)]=262143;
      __label__ = 48; break;
    case 48: // $202
      var $203=$newcomp;
      var $204=(($203+4)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205)|0)==10;
      if ($206) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $207
      var $208=(($23+100)|0);
      HEAP32[(($208)>>2)]=255;
      __label__ = 50; break;
    case 50: // $209
      __label__ = 51; break;
    case 51: // $210
      var $211=$compnode;
      var $212=(($211)|0);
      var $213=HEAP32[(($212)>>2)];
      $compnode=$213;
      __label__ = 14; break;
    case 52: // $214
      var $215=(($bounds)|0);
      var $216=HEAPF32[(($215)>>2)];
      $xoffs=$216;
      var $217=(($bounds+4)|0);
      var $218=HEAPF32[(($217)>>2)];
      $yoffs=$218;
      var $219=(($bounds+8)|0);
      var $220=HEAPF32[(($219)>>2)];
      var $221=(($bounds)|0);
      var $222=HEAPF32[(($221)>>2)];
      var $223=$220-$222;
      var $224=1/$223;
      $xscale=$224;
      var $225=(($bounds+12)|0);
      var $226=HEAPF32[(($225)>>2)];
      var $227=(($bounds+4)|0);
      var $228=HEAPF32[(($227)>>2)];
      var $229=$226-$228;
      var $230=1/$229;
      $yscale=$230;
      var $231=(($23+76)|0);
      var $232=(function() { try { __THREW__ = false; return __ZNK11simple_listIN14layout_element9componentEE5firstEv($231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 7; break; };
    case 53: // $233
      $curcomp=$232;
      __label__ = 54; break;
    case 54: // $234
      var $235=$curcomp;
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 55; break; } else { __label__ = 58; break; }
    case 55: // $237
      var $238=$curcomp;
      var $239=(($238+12)|0);
      var $240=(($239)|0);
      var $241=HEAPF32[(($240)>>2)];
      var $242=$xoffs;
      var $243=$241-$242;
      var $244=$xscale;
      var $245=$243*$244;
      var $246=$curcomp;
      var $247=(($246+12)|0);
      var $248=(($247)|0);
      HEAPF32[(($248)>>2)]=$245;
      var $249=$curcomp;
      var $250=(($249+12)|0);
      var $251=(($250+8)|0);
      var $252=HEAPF32[(($251)>>2)];
      var $253=$xoffs;
      var $254=$252-$253;
      var $255=$xscale;
      var $256=$254*$255;
      var $257=$curcomp;
      var $258=(($257+12)|0);
      var $259=(($258+8)|0);
      HEAPF32[(($259)>>2)]=$256;
      var $260=$curcomp;
      var $261=(($260+12)|0);
      var $262=(($261+4)|0);
      var $263=HEAPF32[(($262)>>2)];
      var $264=$yoffs;
      var $265=$263-$264;
      var $266=$yscale;
      var $267=$265*$266;
      var $268=$curcomp;
      var $269=(($268+12)|0);
      var $270=(($269+4)|0);
      HEAPF32[(($270)>>2)]=$267;
      var $271=$curcomp;
      var $272=(($271+12)|0);
      var $273=(($272+12)|0);
      var $274=HEAPF32[(($273)>>2)];
      var $275=$yoffs;
      var $276=$274-$275;
      var $277=$yscale;
      var $278=$276*$277;
      var $279=$curcomp;
      var $280=(($279+12)|0);
      var $281=(($280+12)|0);
      HEAPF32[(($281)>>2)]=$278;
      __label__ = 56; break;
    case 56: // $282
      var $283=$curcomp;
      var $284=(function() { try { __THREW__ = false; return __ZNK14layout_element9component4nextEv($283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 7; break; };
    case 57: // $285
      $curcomp=$284;
      __label__ = 54; break;
    case 58: // $286
      var $287=$18;
      var $288=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($287) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 7; break; };
    case 59: // $289
      var $290=(($23+100)|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=(($291+1)|0);
      var $293=_llvm_umul_with_overflow_i32($292, 12);
      var $294=$293.f1;
      var $295=$293.f0;
      var $296=_llvm_uadd_with_overflow_i32($295, 4);
      var $297=$296.f1;
      var $298=$294 | $297;
      var $299=$296.f0;
      var $300=$298 ? -1 : $299;
      var $301=$4;
      var $302=$5;
      var $303=$6;
      var $304=$result_i2;
      var $305=$7;
      var $306=$8;
      HEAP32[(($4)>>2)]=$300;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=501;
      var $307=HEAP32[(($4)>>2)];
      var $308=HEAP32[(($5)>>2)];
      var $309=HEAP32[(($6)>>2)];
      var $310=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($307, $308, $309) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 62; break; };
    case 60: // $311
      HEAP32[(($result_i2)>>2)]=$310;
      var $312=HEAP32[(($result_i2)>>2)];
      var $313=(($312)|0)==0;
      if ($313) { __label__ = 61; break; } else { __label__ = 67; break; }
    case 61: // $314
      var $315=___cxa_allocate_exception(4);
      var $316=$315;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($316);
      (function() { try { __THREW__ = false; return ___cxa_throw($315, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 62; break; }
    case 62: // $317
      var $318=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $319=$318.f0;
      HEAP32[(($7)>>2)]=$319;
      var $320=$318.f1;
      HEAP32[(($8)>>2)]=$320;
      var $321=HEAP32[(($8)>>2)];
      var $322=(($321)|0) < 0;
      if ($322) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 63: // $323
      var $324=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($324) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 7; break; }
    case 64: // $_noexc3
      throw "Reached an unreachable!"
    case 65: // $325
      var $326=HEAP32[(($7)>>2)];
      var $327=HEAP32[(($7)>>2)];
      var $328=HEAP32[(($8)>>2)];
      var $329=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $327, tempValue);
      var $330=($329.f1 = $328, $329);
      var $eh_lpad_body5 = $330;__label__ = 8; break;
    case 66: // $331
      throw "Reached an unreachable!"
    case 67: // $_ZnajPKci_exit
      var $332=HEAP32[(($result_i2)>>2)];
      var $333=$4;
      var $334=$5;
      var $335=$6;
      var $336=$result_i2;
      var $337=$7;
      var $338=$8;
      __label__ = 68; break;
    case 68: // $339
      var $340=$332;
      HEAP32[(($340)>>2)]=$292;
      var $341=(($332+4)|0);
      var $342=$341;
      var $343=(($292)|0)==0;
      if ($343) { __label__ = 72; break; } else { __label__ = 69; break; }
    case 69: // $344
      var $345=(($342+$292*12)|0);
      var $347 = $342;__label__ = 70; break;
    case 70: // $346
      var $347;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_element7textureC1Ev]($347) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 74; break; }
    case 71: // $348
      var $349=(($347+12)|0);
      var $350=(($349)|0)==(($345)|0);
      if ($350) { __label__ = 72; break; } else { var $347 = $349;__label__ = 70; break; }
    case 72: // $351
      var $352=(($23+100)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($353+1)|0);
      var $355=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIN14layout_element7textureEEEPT_S4_i($288, $342, $354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 7; break; };
    case 73: // $356
      var $357=(($23+104)|0);
      HEAP32[(($357)>>2)]=$355;
      STACKTOP = __stackBase__;
      return;
    case 74: // $358
      var $359=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $360=$359.f0;
      $21=$360;
      var $361=$359.f1;
      $22=$361;
      var $362=(($342)|0)==(($347)|0);
      if ($362) { __label__ = 77; break; } else { var $364 = $347;__label__ = 75; break; }
    case 75: // $363
      var $364;
      var $365=(($364-12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_element7textureD1Ev]($365) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 87; break; }
    case 76: // $366
      var $367=(($365)|0)==(($342)|0);
      if ($367) { __label__ = 77; break; } else { var $364 = $365;__label__ = 75; break; }
    case 77: // $368
      var $369=$1;
      var $370=$2;
      var $371=$3;
      HEAP32[(($1)>>2)]=$332;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=501;
      var $372=HEAP32[(($1)>>2)];
      var $373=(($372)|0)!=0;
      if ($373) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $374
      var $375=HEAP32[(($1)>>2)];
      var $376=HEAP32[(($2)>>2)];
      var $377=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($375, $376, $377) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 87; break; }
    case 79: // $_noexc6
      __label__ = 80; break;
    case 80: // $_ZdaPvPKci_exit
      var $378=$1;
      var $379=$2;
      var $380=$3;
      __label__ = 81; break;
    case 81: // $381
      __label__ = 82; break;
    case 82: // $382
      var $383=(($23+76)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN14layout_element9componentEED1Ev($383) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 87; break; }
    case 83: // $384
      __label__ = 84; break;
    case 84: // $385
      var $386=(($23+12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($386) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 87; break; }
    case 85: // $387
      __label__ = 86; break;
    case 86: // $388
      var $389=$21;
      var $390=$21;
      var $391=$22;
      var $392=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $390, tempValue);
      var $393=($392.f1 = $391, $392);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 87: // $394
      var $395=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 88: // $396
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_elementC2ER15running_machineR14_xml_data_nodePKc["X"]=1;

function __ZN11simple_listIN14layout_element9componentEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19union_render_boundsP13render_boundsPKS_($dest, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$dest;
      $2=$src;
      var $3=$1;
      var $4=(($3)|0);
      var $5=HEAPF32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAPF32[(($7)>>2)];
      var $9=$5 < $8;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAPF32[(($12)>>2)];
      var $19 = $13;__label__ = 3; break;
    case 2: // $14
      var $15=$2;
      var $16=(($15)|0);
      var $17=HEAPF32[(($16)>>2)];
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      var $20=$1;
      var $21=(($20)|0);
      HEAPF32[(($21)>>2)]=$19;
      var $22=$1;
      var $23=(($22+8)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$2;
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$24 > $27;
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $29
      var $30=$1;
      var $31=(($30+8)|0);
      var $32=HEAPF32[(($31)>>2)];
      var $38 = $32;__label__ = 6; break;
    case 5: // $33
      var $34=$2;
      var $35=(($34+8)|0);
      var $36=HEAPF32[(($35)>>2)];
      var $38 = $36;__label__ = 6; break;
    case 6: // $37
      var $38;
      var $39=$1;
      var $40=(($39+8)|0);
      HEAPF32[(($40)>>2)]=$38;
      var $41=$1;
      var $42=(($41+4)|0);
      var $43=HEAPF32[(($42)>>2)];
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=HEAPF32[(($45)>>2)];
      var $47=$43 < $46;
      if ($47) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $48
      var $49=$1;
      var $50=(($49+4)|0);
      var $51=HEAPF32[(($50)>>2)];
      var $57 = $51;__label__ = 9; break;
    case 8: // $52
      var $53=$2;
      var $54=(($53+4)|0);
      var $55=HEAPF32[(($54)>>2)];
      var $57 = $55;__label__ = 9; break;
    case 9: // $56
      var $57;
      var $58=$1;
      var $59=(($58+4)|0);
      HEAPF32[(($59)>>2)]=$57;
      var $60=$1;
      var $61=(($60+12)|0);
      var $62=HEAPF32[(($61)>>2)];
      var $63=$2;
      var $64=(($63+12)|0);
      var $65=HEAPF32[(($64)>>2)];
      var $66=$62 > $65;
      if ($66) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $67
      var $68=$1;
      var $69=(($68+12)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $76 = $70;__label__ = 12; break;
    case 11: // $71
      var $72=$2;
      var $73=(($72+12)|0);
      var $74=HEAPF32[(($73)>>2)];
      var $76 = $74;__label__ = 12; break;
    case 12: // $75
      var $76;
      var $77=$1;
      var $78=(($77+12)|0);
      HEAPF32[(($78)>>2)]=$76;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19union_render_boundsP13render_boundsPKS_["X"]=1;

function __ZNK11simple_listIN14layout_element9componentEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK14layout_element9component4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK14layout_element7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($machine, $node, $attribute, $defvalue) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $str;
      var $s;
      var $d=__stackBase__;
      $2=$machine;
      $3=$node;
      $4=$attribute;
      $5=$defvalue;
      var $6=$3;
      var $7=$4;
      var $8=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($6, $7, 0);
      $str=$8;
      var $9=$str;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$5;
      $1=$12;
      __label__ = 11; break;
    case 2: // $13
      var $14=$str;
      var $15=_strchr($14, 126);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$str;
      $1=$18;
      __label__ = 11; break;
    case 4: // $19
      var $20=$str;
      $s=$20;
      HEAP32[(($d)>>2)]=((__ZZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_E6buffer)|0);
      __label__ = 5; break;
    case 5: // $21
      var $22=$s;
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $26
      var $27=$s;
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)!=126;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$s;
      var $33=(($32+1)|0);
      $s=$33;
      var $34=HEAP8[($32)];
      var $35=HEAP32[(($d)>>2)];
      var $36=(($35+1)|0);
      HEAP32[(($d)>>2)]=$36;
      HEAP8[($35)]=$34;
      __label__ = 9; break;
    case 8: // $37
      var $38=$2;
      var $39=$s;
      var $40=__ZL18get_variable_valueR15running_machinePKcPPc($38, $39, $d);
      var $41=$s;
      var $42=(($41+$40)|0);
      $s=$42;
      __label__ = 9; break;
    case 9: // $43
      __label__ = 5; break;
    case 10: // $44
      var $45=HEAP32[(($d)>>2)];
      HEAP8[($45)]=0;
      $1=((__ZZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_E6buffer)|0);
      __label__ = 11; break;
    case 11: // $46
      var $47=$1;
      STACKTOP = __stackBase__;
      return $47;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_["X"]=1;

function __ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci($machine, $node, $attribute, $defvalue) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $string;
      var $value=__stackBase__;
      $2=$machine;
      $3=$node;
      $4=$attribute;
      $5=$defvalue;
      var $6=$2;
      var $7=$3;
      var $8=$4;
      var $9=__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($6, $7, $8, 0);
      $string=$9;
      var $10=$string;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$5;
      $1=$13;
      __label__ = 10; break;
    case 2: // $14
      var $15=$string;
      var $16=(($15)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0)==36;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$string;
      var $22=(($21+1)|0);
      var $23=_sscanf($22, ((STRING_TABLE.__str694684)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $24=(($23)|0)==1;
      var $25=HEAP32[(($value)>>2)];
      var $26=$5;
      var $27=$24 ? $25 : $26;
      $1=$27;
      __label__ = 10; break;
    case 4: // $28
      var $29=$string;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24);
      var $33=(($32)|0)==48;
      if ($33) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $34
      var $35=$string;
      var $36=(($35+1)|0);
      var $37=HEAP8[($36)];
      var $38=(($37 << 24) >> 24);
      var $39=(($38)|0)==120;
      if ($39) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $40
      var $41=$string;
      var $42=(($41+2)|0);
      var $43=_sscanf($42, ((STRING_TABLE.__str694684)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $44=(($43)|0)==1;
      var $45=HEAP32[(($value)>>2)];
      var $46=$5;
      var $47=$44 ? $45 : $46;
      $1=$47;
      __label__ = 10; break;
    case 7: // $48
      var $49=$string;
      var $50=(($49)|0);
      var $51=HEAP8[($50)];
      var $52=(($51 << 24) >> 24);
      var $53=(($52)|0)==35;
      if ($53) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $54
      var $55=$string;
      var $56=(($55+1)|0);
      var $57=_sscanf($56, ((STRING_TABLE.__str704685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $58=(($57)|0)==1;
      var $59=HEAP32[(($value)>>2)];
      var $60=$5;
      var $61=$58 ? $59 : $60;
      $1=$61;
      __label__ = 10; break;
    case 9: // $62
      var $63=$string;
      var $64=(($63)|0);
      var $65=_sscanf($64, ((STRING_TABLE.__str704685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $66=(($65)|0)==1;
      var $67=HEAP32[(($value)>>2)];
      var $68=$5;
      var $69=$66 ? $67 : $68;
      $1=$69;
      __label__ = 10; break;
    case 10: // $70
      var $71=$1;
      STACKTOP = __stackBase__;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci["X"]=1;

function __ZN11simple_listIN14layout_element9componentEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN14layout_element9componentEED2Ev($2);
  ;
  return;
}


function __ZN14layout_element13state_textureEi($this, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$state;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+104)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$6*12)|0);
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$2;
      var $15=(($3+104)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14*12)|0);
      var $18=(($17)|0);
      HEAP32[(($18)>>2)]=$3;
      var $19=$2;
      var $20=$2;
      var $21=(($3+104)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+$20*12)|0);
      var $24=(($23+8)|0);
      HEAP32[(($24)>>2)]=$19;
      var $25=__ZNK14layout_element7machineEv($3);
      var $26=__ZNK15running_machine6renderEv($25);
      var $27=$2;
      var $28=(($3+104)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$27*12)|0);
      var $31=$30;
      var $32=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($26, 1112, $31);
      var $33=$2;
      var $34=(($3+104)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+$33*12)|0);
      var $37=(($36+4)|0);
      HEAP32[(($37)>>2)]=$32;
      __label__ = 4; break;
    case 4: // $38
      var $39=$2;
      var $40=(($3+104)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+$39*12)|0);
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element13state_textureEi["X"]=1;

function __ZN13resource_pool10add_objectIN14layout_element9componentEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN14layout_element9componentEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN14layout_element9componentEEEPT_S4_["X"]=1;

function __ZN13resource_pool9add_arrayIN14layout_element7textureEEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN14layout_element7textureEEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIN14layout_element7textureEEEPT_S4_i["X"]=1;

function __ZN14layout_elementD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_elementD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_elementD0Ev["X"]=1;

function __ZN14layout_elementD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV14layout_element+8)|0);
      var $6=(function() { try { __THREW__ = false; return __ZNK14layout_element7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $7
      var $8=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; };
    case 2: // $9
      var $10=(($4+104)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($8, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      var $14=(($4+76)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN14layout_element9componentEED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $15
      var $16=(($4+12)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($16);
      ;
      return;
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=(($4+76)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN14layout_element9componentEED1Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 6: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      __label__ = 8; break;
    case 7: // $26
      __label__ = 8; break;
    case 8: // $27
      var $28=(($4+12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $29
      __label__ = 10; break;
    case 10: // $30
      var $31=$2;
      var $32=$2;
      var $33=$3;
      var $34=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $32, tempValue);
      var $35=($34.f1 = $33, $34);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK14layout_element9component6boundsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  ;
  return $3;
}


function __ZN14layout_element7textureC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  ;
  return;
}


function __ZN14layout_element13element_scaleER8bitmap_tRKS0_RK10_rectanglePv($dest, $source, $sbounds, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $elemtex;
      var $curcomp;
      var $bounds=__stackBase__;
      $1=$dest;
      $2=$source;
      $3=$sbounds;
      $4=$param;
      var $5=$4;
      var $6=$5;
      $elemtex=$6;
      var $7=$elemtex;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+76)|0);
      var $11=__ZNK11simple_listIN14layout_element9componentEE5firstEv($10);
      $curcomp=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$curcomp;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $15
      var $16=$curcomp;
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)==-1;
      if ($19) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=$curcomp;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$elemtex;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($23)|0)==(($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$curcomp;
      var $30=__ZNK14layout_element9component6boundsEv($29);
      var $31=(($30)|0);
      var $32=HEAPF32[(($31)>>2)];
      var $33=$1;
      var $34=$33;
      var $35=(($34+12)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0);
      var $38=$32*$37;
      var $39=__ZL20render_round_nearestf4695($38);
      var $40=(($39)|0);
      var $41=(($bounds)|0);
      HEAP32[(($41)>>2)]=$40;
      var $42=$curcomp;
      var $43=__ZNK14layout_element9component6boundsEv($42);
      var $44=(($43+4)|0);
      var $45=HEAPF32[(($44)>>2)];
      var $46=$1;
      var $47=$46;
      var $48=(($47+16)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0);
      var $51=$45*$50;
      var $52=__ZL20render_round_nearestf4695($51);
      var $53=(($52)|0);
      var $54=(($bounds+8)|0);
      HEAP32[(($54)>>2)]=$53;
      var $55=$curcomp;
      var $56=__ZNK14layout_element9component6boundsEv($55);
      var $57=(($56+8)|0);
      var $58=HEAPF32[(($57)>>2)];
      var $59=$1;
      var $60=$59;
      var $61=(($60+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0);
      var $64=$58*$63;
      var $65=__ZL20render_round_nearestf4695($64);
      var $66=(($65)|0);
      var $67=(($bounds+4)|0);
      HEAP32[(($67)>>2)]=$66;
      var $68=$curcomp;
      var $69=__ZNK14layout_element9component6boundsEv($68);
      var $70=(($69+12)|0);
      var $71=HEAPF32[(($70)>>2)];
      var $72=$1;
      var $73=$72;
      var $74=(($73+16)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0);
      var $77=$71*$76;
      var $78=__ZL20render_round_nearestf4695($77);
      var $79=(($78)|0);
      var $80=(($bounds+12)|0);
      HEAP32[(($80)>>2)]=$79;
      var $81=$curcomp;
      var $82=$elemtex;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=__ZNK14layout_element7machineEv($84);
      var $86=$1;
      var $87=$elemtex;
      var $88=(($87+8)|0);
      var $89=HEAP32[(($88)>>2)];
      __ZN14layout_element9component4drawER15running_machineR8bitmap_tRK10_rectanglei($81, $85, $86, $bounds, $89);
      __label__ = 5; break;
    case 5: // $90
      __label__ = 6; break;
    case 6: // $91
      var $92=$curcomp;
      var $93=__ZNK14layout_element9component4nextEv($92);
      $curcomp=$93;
      __label__ = 1; break;
    case 7: // $94
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element13element_scaleER8bitmap_tRKS0_RK10_rectanglePv["X"]=1;

function __ZL20render_round_nearestf4695($f) {
  ;
  var __label__;

  var $1;
  $1=$f;
  var $2=$1;
  var $3=$2+0.5;
  var $4=$3;
  var $5=_floor($4);
  var $6=$5;
  ;
  return $6;
}


function __ZN14layout_element7textureD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__ZNK14layout_element7machineEv($8);
      var $10=__ZNK15running_machine6renderEv($9);
      var $11=(($2+4)|0);
      var $12=HEAP32[(($11)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($10, $12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14layout_element9component4drawER15running_machineR8bitmap_tRK10_rectanglei($this, $machine, $dest, $bounds, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$machine;
      $3=$dest;
      $4=$bounds;
      $5=$state;
      var $8=$1;
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      if ($10 == 1) {
        __label__ = 1; break;
      }
      else if ($10 == 2) {
        __label__ = 4; break;
      }
      else if ($10 == 3) {
        __label__ = 5; break;
      }
      else if ($10 == 4) {
        __label__ = 6; break;
      }
      else if ($10 == 5) {
        __label__ = 7; break;
      }
      else if ($10 == 6) {
        __label__ = 8; break;
      }
      else if ($10 == 7) {
        __label__ = 9; break;
      }
      else if ($10 == 8) {
        __label__ = 10; break;
      }
      else if ($10 == 9) {
        __label__ = 11; break;
      }
      else if ($10 == 10) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 1: // $11
      var $12=(($8+108)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=__ZN14layout_element9component11load_bitmapEv($8);
      var $17=(($8+108)|0);
      HEAP32[(($17)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $18
      var $19=$3;
      var $20=$19;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22;
      var $24=$4;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=$27;
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($26*$30)|0);
      var $32=(($23+($31<<2))|0);
      var $33=$4;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32+($35<<2))|0);
      var $37=$36;
      var $38=$3;
      var $39=$38;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$4;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$4;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44-$47)|0);
      var $49=$4;
      var $50=(($49+12)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$4;
      var $53=(($52+8)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($51-$54)|0);
      var $56=(($8+108)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($8+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($37, $41, $48, $55, $57, 0, $58);
      __label__ = 16; break;
    case 4: // $59
      var $60=$3;
      var $61=$4;
      __ZN14layout_element9component9draw_rectER8bitmap_tRK10_rectangle($8, $60, $61);
      __label__ = 16; break;
    case 5: // $62
      var $63=$3;
      var $64=$4;
      __ZN14layout_element9component9draw_diskER8bitmap_tRK10_rectangle($8, $63, $64);
      __label__ = 16; break;
    case 6: // $65
      var $66=$2;
      var $67=$3;
      var $68=$4;
      __ZN14layout_element9component9draw_textER15running_machineR8bitmap_tRK10_rectangle($8, $66, $67, $68);
      __label__ = 16; break;
    case 7: // $69
      var $70=$3;
      var $71=$4;
      var $72=$5;
      __ZN14layout_element9component12draw_led7segER8bitmap_tRK10_rectanglei($8, $70, $71, $72);
      __label__ = 16; break;
    case 8: // $73
      var $74=$3;
      var $75=$4;
      var $76=$5;
      __ZN14layout_element9component13draw_led14segER8bitmap_tRK10_rectanglei($8, $74, $75, $76);
      __label__ = 16; break;
    case 9: // $77
      var $78=$3;
      var $79=$4;
      var $80=$5;
      __ZN14layout_element9component13draw_led16segER8bitmap_tRK10_rectanglei($8, $78, $79, $80);
      __label__ = 16; break;
    case 10: // $81
      var $82=$3;
      var $83=$4;
      var $84=$5;
      __ZN14layout_element9component15draw_led14segscER8bitmap_tRK10_rectanglei($8, $82, $83, $84);
      __label__ = 16; break;
    case 11: // $85
      var $86=$3;
      var $87=$4;
      var $88=$5;
      __ZN14layout_element9component15draw_led16segscER8bitmap_tRK10_rectanglei($8, $86, $87, $88);
      __label__ = 16; break;
    case 12: // $89
      var $90=$3;
      var $91=$4;
      var $92=$5;
      __ZN14layout_element9component14draw_dotmatrixER8bitmap_tRK10_rectanglei($8, $90, $91, $92);
      __label__ = 16; break;
    case 13: // $93
      var $94=___cxa_allocate_exception(1032);
      var $95=$94;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($95, ((STRING_TABLE.__str374652)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $96
      ___cxa_throw($94, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 15: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $99=$98.f0;
      $6=$99;
      var $100=$98.f1;
      $7=$100;
      ___cxa_free_exception($94);
      __label__ = 17; break;
    case 16: // $101
      ;
      return;
    case 17: // $102
      var $103=$6;
      var $104=$6;
      var $105=$7;
      var $106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $104, tempValue);
      var $107=($106.f1 = $105, $106);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component4drawER15running_machineR8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9componentC2ER15running_machineR14_xml_data_nodePKc($this, $machine, $compnode, $dirname) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$this;
      $10=$machine;
      $11=$compnode;
      $12=$dirname;
      var $15=$9;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($15+4)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($15+8)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($15+12)|0);
      var $20=(($15+28)|0);
      var $21=(($15+44)|0);
      __ZN7astringC1Ev($21);
      var $22=(($15+108)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($15+112)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 29; break; }
    case 1: // $24
      var $25=(($15+176)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($15+180)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 30; break; }
    case 2: // $27
      var $28=(($15+244)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 31; break; }
    case 3: // $29
      var $30=(($15+308)|0);
      HEAP8[($30)]=0;
      var $31=$10;
      var $32=$11;
      var $33=(function() { try { __THREW__ = false; return __ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci($31, $32, ((STRING_TABLE.__str194634)|0), -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 32; break; };
    case 4: // $34
      var $35=(($15+8)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$10;
      var $37=$11;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($39, ((STRING_TABLE.__str204635)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 32; break; };
    case 5: // $41
      var $42=(($15+12)|0);
      (function() { try { __THREW__ = false; return __Z12parse_boundsR15running_machineP14_xml_data_nodeR13render_bounds($36, $40, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 32; break; }
    case 6: // $43
      var $44=$10;
      var $45=$11;
      var $46=(($45+8)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($47, ((STRING_TABLE.__str214636)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 32; break; };
    case 7: // $49
      var $50=(($15+28)|0);
      (function() { try { __THREW__ = false; return __Z11parse_colorR15running_machineP14_xml_data_nodeR12render_color($44, $48, $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 32; break; }
    case 8: // $51
      var $52=$11;
      var $53=(($52+12)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(function() { try { __THREW__ = false; return _strcmp($54, ((STRING_TABLE.__str224637)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 32; break; };
    case 9: // $56
      var $57=(($55)|0)==0;
      if ($57) { __label__ = 10; break; } else { __label__ = 39; break; }
    case 10: // $58
      var $59=(($15+4)|0);
      HEAP32[(($59)>>2)]=1;
      var $60=(($15+112)|0);
      var $61=$12;
      var $62=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($60, $61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 32; break; };
    case 11: // $63
      var $64=(($15+180)|0);
      var $65=$10;
      var $66=$11;
      var $67=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($65, $66, ((STRING_TABLE.__str234638)|0), ((__str244639)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 32; break; };
    case 12: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($64, $67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 32; break; };
    case 13: // $70
      var $71=(($15+244)|0);
      var $72=$10;
      var $73=$11;
      var $74=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($72, $73, ((STRING_TABLE.__str254640)|0), ((__str244639)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 32; break; };
    case 14: // $75
      var $76=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($71, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 32; break; };
    case 15: // $77
      var $78=$4;
      var $79=$5;
      var $80=$6;
      var $81=$result_i;
      var $82=$7;
      var $83=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=618;
      var $84=HEAP32[(($4)>>2)];
      var $85=HEAP32[(($5)>>2)];
      var $86=HEAP32[(($6)>>2)];
      var $87=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; };
    case 16: // $88
      HEAP32[(($result_i)>>2)]=$87;
      var $89=HEAP32[(($result_i)>>2)];
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $91
      var $92=___cxa_allocate_exception(4);
      var $93=$92;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($93);
      (function() { try { __THREW__ = false; return ___cxa_throw($92, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 18; break; }
    case 18: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      HEAP32[(($7)>>2)]=$96;
      var $97=$95.f1;
      HEAP32[(($8)>>2)]=$97;
      var $98=HEAP32[(($8)>>2)];
      var $99=(($98)|0) < 0;
      if ($99) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $100
      var $101=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 32; break; }
    case 20: // $_noexc
      throw "Reached an unreachable!"
    case 21: // $102
      var $103=HEAP32[(($7)>>2)];
      var $104=HEAP32[(($7)>>2)];
      var $105=HEAP32[(($8)>>2)];
      var $106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $104, tempValue);
      var $107=($106.f1 = $105, $106);
      var $eh_lpad_body = $107;__label__ = 33; break;
    case 22: // $108
      throw "Reached an unreachable!"
    case 23: // $_ZnwjPKci_exit
      var $109=HEAP32[(($result_i)>>2)];
      var $110=$4;
      var $111=$5;
      var $112=$6;
      var $113=$result_i;
      var $114=$7;
      var $115=$8;
      __label__ = 24; break;
    case 24: // $116
      var $117=$109;
      var $118=$10;
      var $119=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 34; break; };
    case 25: // $120
      var $121=(function() { try { __THREW__ = false; return __ZNK11emu_options8art_pathEv($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 34; break; };
    case 26: // $122
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($117, $121, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 34; break; }
    case 27: // $123
      var $124=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI8emu_fileEEPT_S3_(_global_resource_pool, $117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 32; break; };
    case 28: // $125
      var $126=(($15+176)|0);
      HEAP32[(($126)>>2)]=$124;
      __label__ = 80; break;
    case 29: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      $13=$129;
      var $130=$128.f1;
      $14=$130;
      __label__ = 87; break;
    case 30: // $131
      var $132=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $133=$132.f0;
      $13=$133;
      var $134=$132.f1;
      $14=$134;
      __label__ = 85; break;
    case 31: // $135
      var $136=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $137=$136.f0;
      $13=$137;
      var $138=$136.f1;
      $14=$138;
      __label__ = 83; break;
    case 32: // $139
      var $140=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $140;__label__ = 33; break;
    case 33: // $_body
      var $eh_lpad_body;
      var $141=$eh_lpad_body.f0;
      $13=$141;
      var $142=$eh_lpad_body.f1;
      $14=$142;
      __label__ = 81; break;
    case 34: // $143
      var $144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $145=$144.f0;
      $13=$145;
      var $146=$144.f1;
      $14=$146;
      var $147=$1;
      var $148=$2;
      var $149=$3;
      HEAP32[(($1)>>2)]=$109;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=618;
      var $150=HEAP32[(($1)>>2)];
      var $151=(($150)|0)!=0;
      if ($151) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $152
      var $153=HEAP32[(($1)>>2)];
      var $154=HEAP32[(($2)>>2)];
      var $155=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($153, $154, $155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 90; break; }
    case 36: // $_noexc1
      __label__ = 37; break;
    case 37: // $_ZdlPvPKci_exit
      var $156=$1;
      var $157=$2;
      var $158=$3;
      __label__ = 38; break;
    case 38: // $159
      __label__ = 81; break;
    case 39: // $160
      var $161=$11;
      var $162=(($161+12)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(function() { try { __THREW__ = false; return _strcmp($163, ((STRING_TABLE.__str264641)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 32; break; };
    case 40: // $165
      var $166=(($164)|0)==0;
      if ($166) { __label__ = 41; break; } else { __label__ = 44; break; }
    case 41: // $167
      var $168=(($15+4)|0);
      HEAP32[(($168)>>2)]=4;
      var $169=(($15+44)|0);
      var $170=$10;
      var $171=$11;
      var $172=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($170, $171, ((STRING_TABLE.__str274642)|0), ((__str244639)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 32; break; };
    case 42: // $173
      var $174=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($169, $172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 32; break; };
    case 43: // $175
      __label__ = 79; break;
    case 44: // $176
      var $177=$11;
      var $178=(($177+12)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(function() { try { __THREW__ = false; return _strcmp($179, ((STRING_TABLE.__str284643)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 32; break; };
    case 45: // $181
      var $182=(($180)|0)==0;
      if ($182) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $183
      var $184=(($15+4)|0);
      HEAP32[(($184)>>2)]=10;
      __label__ = 78; break;
    case 47: // $185
      var $186=$11;
      var $187=(($186+12)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(function() { try { __THREW__ = false; return _strcmp($188, ((STRING_TABLE.__str294644)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 32; break; };
    case 48: // $190
      var $191=(($189)|0)==0;
      if ($191) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $192
      var $193=(($15+4)|0);
      HEAP32[(($193)>>2)]=5;
      __label__ = 77; break;
    case 50: // $194
      var $195=$11;
      var $196=(($195+12)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(function() { try { __THREW__ = false; return _strcmp($197, ((STRING_TABLE.__str304645)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 32; break; };
    case 51: // $199
      var $200=(($198)|0)==0;
      if ($200) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $201
      var $202=(($15+4)|0);
      HEAP32[(($202)>>2)]=6;
      __label__ = 76; break;
    case 53: // $203
      var $204=$11;
      var $205=(($204+12)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(function() { try { __THREW__ = false; return _strcmp($206, ((STRING_TABLE.__str314646)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 32; break; };
    case 54: // $208
      var $209=(($207)|0)==0;
      if ($209) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $210
      var $211=(($15+4)|0);
      HEAP32[(($211)>>2)]=8;
      __label__ = 75; break;
    case 56: // $212
      var $213=$11;
      var $214=(($213+12)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(function() { try { __THREW__ = false; return _strcmp($215, ((STRING_TABLE.__str324647)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 32; break; };
    case 57: // $217
      var $218=(($216)|0)==0;
      if ($218) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $219
      var $220=(($15+4)|0);
      HEAP32[(($220)>>2)]=7;
      __label__ = 74; break;
    case 59: // $221
      var $222=$11;
      var $223=(($222+12)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(function() { try { __THREW__ = false; return _strcmp($224, ((STRING_TABLE.__str334648)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 32; break; };
    case 60: // $226
      var $227=(($225)|0)==0;
      if ($227) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $228
      var $229=(($15+4)|0);
      HEAP32[(($229)>>2)]=9;
      __label__ = 73; break;
    case 62: // $230
      var $231=$11;
      var $232=(($231+12)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(function() { try { __THREW__ = false; return _strcmp($233, ((STRING_TABLE.__str344649)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 32; break; };
    case 63: // $235
      var $236=(($234)|0)==0;
      if ($236) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $237
      var $238=(($15+4)|0);
      HEAP32[(($238)>>2)]=2;
      __label__ = 72; break;
    case 65: // $239
      var $240=$11;
      var $241=(($240+12)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(function() { try { __THREW__ = false; return _strcmp($242, ((STRING_TABLE.__str354650)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 32; break; };
    case 66: // $244
      var $245=(($243)|0)==0;
      if ($245) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $246
      var $247=(($15+4)|0);
      HEAP32[(($247)>>2)]=3;
      __label__ = 71; break;
    case 68: // $248
      var $249=___cxa_allocate_exception(1032);
      var $250=$249;
      var $251=$11;
      var $252=(($251+12)|0);
      var $253=HEAP32[(($252)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($250, ((STRING_TABLE.__str364651)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$253,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $254
      (function() { try { __THREW__ = false; return ___cxa_throw($249, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 32; break; }
    case 70: // $255
      var $256=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $257=$256.f0;
      $13=$257;
      var $258=$256.f1;
      $14=$258;
      ___cxa_free_exception($249);
      __label__ = 81; break;
    case 71: // $259
      __label__ = 72; break;
    case 72: // $260
      __label__ = 73; break;
    case 73: // $261
      __label__ = 74; break;
    case 74: // $262
      __label__ = 75; break;
    case 75: // $263
      __label__ = 76; break;
    case 76: // $264
      __label__ = 77; break;
    case 77: // $265
      __label__ = 78; break;
    case 78: // $266
      __label__ = 79; break;
    case 79: // $267
      __label__ = 80; break;
    case 80: // $268
      STACKTOP = __stackBase__;
      return;
    case 81: // $269
      var $270=(($15+244)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($270) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 90; break; }
    case 82: // $271
      __label__ = 83; break;
    case 83: // $272
      var $273=(($15+180)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($273) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 90; break; }
    case 84: // $274
      __label__ = 85; break;
    case 85: // $275
      var $276=(($15+112)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 90; break; }
    case 86: // $277
      __label__ = 87; break;
    case 87: // $278
      var $279=(($15+44)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 90; break; }
    case 88: // $280
      __label__ = 89; break;
    case 89: // $281
      var $282=$13;
      var $283=$13;
      var $284=$14;
      var $285=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $283, tempValue);
      var $286=($285.f1 = $284, $285);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 90: // $287
      var $288=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 91: // $289
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9componentC2ER15running_machineR14_xml_data_nodePKc["X"]=1;

function __ZN14layout_element9component9draw_rectER8bitmap_tRK10_rectangle($this, $dest, $bounds) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $r;
      var $g;
      var $b;
      var $inva;
      var $y;
      var $x;
      var $finalr;
      var $finalg;
      var $finalb;
      var $dpix;
      $1=$this;
      $2=$dest;
      $3=$bounds;
      var $4=$1;
      var $5=(($4+28)|0);
      var $6=(($5+4)|0);
      var $7=HEAPF32[(($6)>>2)];
      var $8=(($4+28)|0);
      var $9=(($8)|0);
      var $10=HEAPF32[(($9)>>2)];
      var $11=$7*$10;
      var $12=$11;
      var $13=$12*255;
      var $14=($13 >= 0 ? Math.floor($13) : Math.ceil($13));
      $r=$14;
      var $15=(($4+28)|0);
      var $16=(($15+8)|0);
      var $17=HEAPF32[(($16)>>2)];
      var $18=(($4+28)|0);
      var $19=(($18)|0);
      var $20=HEAPF32[(($19)>>2)];
      var $21=$17*$20;
      var $22=$21;
      var $23=$22*255;
      var $24=($23 >= 0 ? Math.floor($23) : Math.ceil($23));
      $g=$24;
      var $25=(($4+28)|0);
      var $26=(($25+12)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=(($4+28)|0);
      var $29=(($28)|0);
      var $30=HEAPF32[(($29)>>2)];
      var $31=$27*$30;
      var $32=$31;
      var $33=$32*255;
      var $34=($33 >= 0 ? Math.floor($33) : Math.ceil($33));
      $b=$34;
      var $35=(($4+28)|0);
      var $36=(($35)|0);
      var $37=HEAPF32[(($36)>>2)];
      var $38=1-$37;
      var $39=$38;
      var $40=$39*255;
      var $41=($40 >= 0 ? Math.floor($40) : Math.ceil($40));
      $inva=$41;
      var $42=$3;
      var $43=(($42+8)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 1; break;
    case 1: // $45
      var $46=$y;
      var $47=$3;
      var $48=(($47+12)|0);
      var $49=HEAPU32[(($48)>>2)];
      var $50=(($46)>>>0) < (($49)>>>0);
      if ($50) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $51
      var $52=$3;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      $x=$54;
      __label__ = 3; break;
    case 3: // $55
      var $56=$x;
      var $57=$3;
      var $58=(($57+4)|0);
      var $59=HEAPU32[(($58)>>2)];
      var $60=(($56)>>>0) < (($59)>>>0);
      if ($60) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $61
      var $62=$r;
      $finalr=$62;
      var $63=$g;
      $finalg=$63;
      var $64=$b;
      $finalb=$64;
      var $65=$inva;
      var $66=(($65)>>>0) > 0;
      if ($66) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $67
      var $68=$2;
      var $69=$68;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71;
      var $73=$y;
      var $74=$2;
      var $75=$74;
      var $76=(($75+8)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($73*$77)|0);
      var $79=(($72+($78<<2))|0);
      var $80=$x;
      var $81=(($79+($80<<2))|0);
      var $82=HEAP32[(($81)>>2)];
      $dpix=$82;
      var $83=$dpix;
      var $84=$83 >>> 16;
      var $85=$84 & 255;
      var $86=$inva;
      var $87=(($85*$86)|0);
      var $88=$87 >>> 8;
      var $89=$finalr;
      var $90=(($89+$88)|0);
      $finalr=$90;
      var $91=$dpix;
      var $92=$91 >>> 8;
      var $93=$92 & 255;
      var $94=$inva;
      var $95=(($93*$94)|0);
      var $96=$95 >>> 8;
      var $97=$finalg;
      var $98=(($97+$96)|0);
      $finalg=$98;
      var $99=$dpix;
      var $100=$99 & 255;
      var $101=$inva;
      var $102=(($100*$101)|0);
      var $103=$102 >>> 8;
      var $104=$finalb;
      var $105=(($104+$103)|0);
      $finalb=$105;
      __label__ = 6; break;
    case 6: // $106
      var $107=$finalr;
      var $108=$107 & 255;
      var $109=$108 << 16;
      var $110=-16777216 | $109;
      var $111=$finalg;
      var $112=$111 & 255;
      var $113=$112 << 8;
      var $114=$110 | $113;
      var $115=$finalb;
      var $116=$115 & 255;
      var $117=$114 | $116;
      var $118=$2;
      var $119=$118;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121;
      var $123=$y;
      var $124=$2;
      var $125=$124;
      var $126=(($125+8)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($123*$127)|0);
      var $129=(($122+($128<<2))|0);
      var $130=$x;
      var $131=(($129+($130<<2))|0);
      HEAP32[(($131)>>2)]=$117;
      __label__ = 7; break;
    case 7: // $132
      var $133=$x;
      var $134=(($133+1)|0);
      $x=$134;
      __label__ = 3; break;
    case 8: // $135
      __label__ = 9; break;
    case 9: // $136
      var $137=$y;
      var $138=(($137+1)|0);
      $y=$138;
      __label__ = 1; break;
    case 10: // $139
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component9draw_rectER8bitmap_tRK10_rectangle["X"]=1;

function __ZN14layout_element9component9draw_diskER8bitmap_tRK10_rectangle($this, $dest, $bounds) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $r;
      var $g;
      var $b;
      var $inva;
      var $xcenter;
      var $ycenter;
      var $xradius;
      var $yradius;
      var $ooyradius2;
      var $y;
      var $ycoord;
      var $xval;
      var $left;
      var $right;
      var $x;
      var $finalr;
      var $finalg;
      var $finalb;
      var $dpix;
      $1=$this;
      $2=$dest;
      $3=$bounds;
      var $4=$1;
      var $5=(($4+28)|0);
      var $6=(($5+4)|0);
      var $7=HEAPF32[(($6)>>2)];
      var $8=(($4+28)|0);
      var $9=(($8)|0);
      var $10=HEAPF32[(($9)>>2)];
      var $11=$7*$10;
      var $12=$11;
      var $13=$12*255;
      var $14=($13 >= 0 ? Math.floor($13) : Math.ceil($13));
      $r=$14;
      var $15=(($4+28)|0);
      var $16=(($15+8)|0);
      var $17=HEAPF32[(($16)>>2)];
      var $18=(($4+28)|0);
      var $19=(($18)|0);
      var $20=HEAPF32[(($19)>>2)];
      var $21=$17*$20;
      var $22=$21;
      var $23=$22*255;
      var $24=($23 >= 0 ? Math.floor($23) : Math.ceil($23));
      $g=$24;
      var $25=(($4+28)|0);
      var $26=(($25+12)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=(($4+28)|0);
      var $29=(($28)|0);
      var $30=HEAPF32[(($29)>>2)];
      var $31=$27*$30;
      var $32=$31;
      var $33=$32*255;
      var $34=($33 >= 0 ? Math.floor($33) : Math.ceil($33));
      $b=$34;
      var $35=(($4+28)|0);
      var $36=(($35)|0);
      var $37=HEAPF32[(($36)>>2)];
      var $38=1-$37;
      var $39=$38;
      var $40=$39*255;
      var $41=($40 >= 0 ? Math.floor($40) : Math.ceil($40));
      $inva=$41;
      var $42=$3;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$3;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44+$47)|0);
      var $49=(($48)|0);
      var $50=$49*0.5;
      $xcenter=$50;
      var $51=$3;
      var $52=(($51+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54+12)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($53+$56)|0);
      var $58=(($57)|0);
      var $59=$58*0.5;
      $ycenter=$59;
      var $60=$3;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$3;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($62-$65)|0);
      var $67=(($66)|0);
      var $68=$67*0.5;
      $xradius=$68;
      var $69=$3;
      var $70=(($69+12)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$3;
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($71-$74)|0);
      var $76=(($75)|0);
      var $77=$76*0.5;
      $yradius=$77;
      var $78=$yradius;
      var $79=$yradius;
      var $80=$78*$79;
      var $81=1/$80;
      $ooyradius2=$81;
      var $82=$3;
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      $y=$84;
      __label__ = 1; break;
    case 1: // $85
      var $86=$y;
      var $87=$3;
      var $88=(($87+12)|0);
      var $89=HEAPU32[(($88)>>2)];
      var $90=(($86)>>>0) < (($89)>>>0);
      if ($90) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $91
      var $92=$ycenter;
      var $93=$y;
      var $94=(($93)>>>0);
      var $95=$94+0.5;
      var $96=$92-$95;
      $ycoord=$96;
      var $97=$xradius;
      var $98=$97;
      var $99=$ycoord;
      var $100=$ycoord;
      var $101=$99*$100;
      var $102=$ooyradius2;
      var $103=$101*$102;
      var $104=1-$103;
      var $105=$104;
      var $106=_sqrt($105);
      var $107=$98*$106;
      var $108=$107;
      $xval=$108;
      var $109=$xcenter;
      var $110=$xval;
      var $111=$109-$110;
      var $112=$111+0.5;
      var $113=(($112)|0);
      $left=$113;
      var $114=$xcenter;
      var $115=$xval;
      var $116=$114+$115;
      var $117=$116+0.5;
      var $118=(($117)|0);
      $right=$118;
      var $119=$left;
      $x=$119;
      __label__ = 3; break;
    case 3: // $120
      var $121=$x;
      var $122=$right;
      var $123=(($121)>>>0) < (($122)>>>0);
      if ($123) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $124
      var $125=$r;
      $finalr=$125;
      var $126=$g;
      $finalg=$126;
      var $127=$b;
      $finalb=$127;
      var $128=$inva;
      var $129=(($128)>>>0) > 0;
      if ($129) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $130
      var $131=$2;
      var $132=$131;
      var $133=(($132+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$134;
      var $136=$y;
      var $137=$2;
      var $138=$137;
      var $139=(($138+8)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($136*$140)|0);
      var $142=(($135+($141<<2))|0);
      var $143=$x;
      var $144=(($142+($143<<2))|0);
      var $145=HEAP32[(($144)>>2)];
      $dpix=$145;
      var $146=$dpix;
      var $147=$146 >>> 16;
      var $148=$147 & 255;
      var $149=$inva;
      var $150=(($148*$149)|0);
      var $151=$150 >>> 8;
      var $152=$finalr;
      var $153=(($152+$151)|0);
      $finalr=$153;
      var $154=$dpix;
      var $155=$154 >>> 8;
      var $156=$155 & 255;
      var $157=$inva;
      var $158=(($156*$157)|0);
      var $159=$158 >>> 8;
      var $160=$finalg;
      var $161=(($160+$159)|0);
      $finalg=$161;
      var $162=$dpix;
      var $163=$162 & 255;
      var $164=$inva;
      var $165=(($163*$164)|0);
      var $166=$165 >>> 8;
      var $167=$finalb;
      var $168=(($167+$166)|0);
      $finalb=$168;
      __label__ = 6; break;
    case 6: // $169
      var $170=$finalr;
      var $171=$170 & 255;
      var $172=$171 << 16;
      var $173=-16777216 | $172;
      var $174=$finalg;
      var $175=$174 & 255;
      var $176=$175 << 8;
      var $177=$173 | $176;
      var $178=$finalb;
      var $179=$178 & 255;
      var $180=$177 | $179;
      var $181=$2;
      var $182=$181;
      var $183=(($182+4)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$184;
      var $186=$y;
      var $187=$2;
      var $188=$187;
      var $189=(($188+8)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=(($186*$190)|0);
      var $192=(($185+($191<<2))|0);
      var $193=$x;
      var $194=(($192+($193<<2))|0);
      HEAP32[(($194)>>2)]=$180;
      __label__ = 7; break;
    case 7: // $195
      var $196=$x;
      var $197=(($196+1)|0);
      $x=$197;
      __label__ = 3; break;
    case 8: // $198
      __label__ = 9; break;
    case 9: // $199
      var $200=$y;
      var $201=(($200+1)|0);
      $y=$201;
      __label__ = 1; break;
    case 10: // $202
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component9draw_diskER8bitmap_tRK10_rectangle["X"]=1;

function __ZN14layout_element9componentD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+176)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $8
      var $9=(($4+108)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=(($4+244)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $14
      var $15=(($4+180)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=(($4+112)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $18
      var $19=(($4+44)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($19);
      ;
      return;
    case 6: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $2=$22;
      var $23=$21.f1;
      $3=$23;
      var $24=(($4+244)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 7: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $2=$27;
      var $28=$26.f1;
      $3=$28;
      __label__ = 10; break;
    case 8: // $29
      __label__ = 10; break;
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $2=$32;
      var $33=$31.f1;
      $3=$33;
      __label__ = 13; break;
    case 10: // $34
      var $35=(($4+180)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $36
      __label__ = 13; break;
    case 12: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $2=$39;
      var $40=$38.f1;
      $3=$40;
      __label__ = 15; break;
    case 13: // $41
      var $42=(($4+112)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $43
      __label__ = 15; break;
    case 15: // $44
      var $45=(($4+44)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $46
      __label__ = 17; break;
    case 17: // $47
      var $48=$2;
      var $49=$2;
      var $50=$3;
      var $51=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $49, tempValue);
      var $52=($51.f1 = $50, $51);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9componentD2Ev["X"]=1;

function __ZN14layout_element9component11load_bitmapEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $bitmap;
      var $10;
      var $11;
      var $step;
      var $line;
      $9=$this;
      var $12=$9;
      __label__ = 1; break;
    case 1: // $13
      __label__ = 2; break;
    case 2: // $14
      var $15=(($12+176)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($12+112)|0);
      var $18=__ZNK7astringcvPKcEv($17);
      var $19=(($12+180)|0);
      var $20=__ZNK7astringcvPKcEv($19);
      var $21=(($12+308)|0);
      var $22=__Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($16, $18, $20, 0, $21);
      $bitmap=$22;
      var $23=$bitmap;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $25
      var $26=(($12+244)|0);
      var $27=__ZN7astringcvbEv($26);
      if ($27) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $28
      var $29=(($12+176)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($12+112)|0);
      var $32=__ZNK7astringcvPKcEv($31);
      var $33=(($12+244)|0);
      var $34=__ZNK7astringcvPKcEv($33);
      var $35=$bitmap;
      var $36=(($12+308)|0);
      var $37=__Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb($30, $32, $34, $35, $36);
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$bitmap;
      var $41=$40;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $41);
      $bitmap=0;
      __label__ = 6; break;
    case 6: // $42
      __label__ = 7; break;
    case 7: // $43
      var $44=$bitmap;
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 8; break; } else { __label__ = 33; break; }
    case 8: // $46
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=923;
      var $53=HEAP32[(($4)>>2)];
      var $54=HEAP32[(($5)>>2)];
      var $55=HEAP32[(($6)>>2)];
      var $56=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($53, $54, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $57
      HEAP32[(($result_i)>>2)]=$56;
      var $58=HEAP32[(($result_i)>>2)];
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $60
      var $61=___cxa_allocate_exception(4);
      var $62=$61;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($62);
      (function() { try { __THREW__ = false; return ___cxa_throw($61, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($7)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($8)>>2)]=$66;
      var $67=HEAP32[(($8)>>2)];
      var $68=(($67)|0) < 0;
      if ($68) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $69
      var $70=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($70);
      throw "Reached an unreachable!"
    case 13: // $71
      var $72=HEAP32[(($7)>>2)];
      var $73=HEAP32[(($7)>>2)];
      var $74=HEAP32[(($8)>>2)];
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $77
      throw "Reached an unreachable!"
    case 15: // $_ZnwjPKci_exit
      var $78=HEAP32[(($result_i)>>2)];
      var $79=$4;
      var $80=$5;
      var $81=$6;
      var $82=$result_i;
      var $83=$7;
      var $84=$8;
      var $85=$78;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($85, 100, 100, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $86
      var $87=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $85);
      $bitmap=$87;
      var $88=$bitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($88, 0, 0);
      $step=0;
      __label__ = 17; break;
    case 17: // $89
      var $90=$step;
      var $91=(($90)|0) < 100;
      if ($91) { __label__ = 18; break; } else { __label__ = 29; break; }
    case 18: // $92
      $line=0;
      __label__ = 19; break;
    case 19: // $93
      var $94=$line;
      var $95=(($94)|0) < 100;
      if ($95) { __label__ = 20; break; } else { __label__ = 27; break; }
    case 20: // $96
      var $97=$bitmap;
      var $98=$97;
      var $99=(($98+4)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100;
      var $102=$step;
      var $103=$line;
      var $104=(($102+$103)|0);
      var $105=(($104)|0)%100;
      var $106=$bitmap;
      var $107=$106;
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($105*$109)|0);
      var $111=(($101+($110<<2))|0);
      var $112=$line;
      var $113=(($112)|0)%100;
      var $114=(($111+($113<<2))|0);
      HEAP32[(($114)>>2)]=-1;
      __label__ = 21; break;
    case 21: // $115
      var $116=$line;
      var $117=(($116+1)|0);
      $line=$117;
      __label__ = 19; break;
    case 22: // $118
      var $119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $120=$119.f0;
      $10=$120;
      var $121=$119.f1;
      $11=$121;
      var $122=$1;
      var $123=$2;
      var $124=$3;
      HEAP32[(($1)>>2)]=$78;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=923;
      var $125=HEAP32[(($1)>>2)];
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $127
      var $128=HEAP32[(($1)>>2)];
      var $129=HEAP32[(($2)>>2)];
      var $130=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($128, $129, $130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 35; break; }
    case 24: // $_noexc
      __label__ = 25; break;
    case 25: // $_ZdlPvPKci_exit
      var $131=$1;
      var $132=$2;
      var $133=$3;
      __label__ = 26; break;
    case 26: // $134
      __label__ = 34; break;
    case 27: // $135
      __label__ = 28; break;
    case 28: // $136
      var $137=$step;
      var $138=(($137+25)|0);
      $step=$138;
      __label__ = 17; break;
    case 29: // $139
      var $140=(($12+244)|0);
      var $141=__ZN7astringcvbEv($140);
      if ($141) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $142
      var $143=(($12+180)|0);
      var $144=__ZNK7astring4cstrEv($143);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str394654)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$144,tempInt));
      __label__ = 32; break;
    case 31: // $145
      var $146=(($12+180)|0);
      var $147=__ZNK7astring4cstrEv($146);
      var $148=(($12+244)|0);
      var $149=__ZNK7astring4cstrEv($148);
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str404655)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$147,HEAP32[((tempInt+4)>>2)]=$149,tempInt));
      __label__ = 32; break;
    case 32: // $150
      __label__ = 33; break;
    case 33: // $151
      var $152=$bitmap;
      STACKTOP = __stackBase__;
      return $152;
    case 34: // $153
      var $154=$10;
      var $155=$10;
      var $156=$11;
      var $157=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $155, tempValue);
      var $158=($157.f1 = $156, $157);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $159
      var $160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component11load_bitmapEv["X"]=1;

function __ZN14layout_element9component9draw_textER15running_machineR8bitmap_tRK10_rectangle($this, $machine, $dest, $bounds) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $r;
      var $g;
      var $b;
      var $a;
      var $font;
      var $aspect;
      var $width;
      var $curx;
      var $tempbitmap;
      var $13;
      var $14;
      var $s;
      var $chbounds=__stackBase__+36;
      var $y;
      var $effy;
      var $src;
      var $d;
      var $x;
      var $effx;
      var $spix;
      var $dpix;
      var $ta;
      var $tr;
      var $tg;
      var $tb;
      $9=$this;
      $10=$machine;
      $11=$dest;
      $12=$bounds;
      var $15=$9;
      var $16=(($15+28)|0);
      var $17=(($16+4)|0);
      var $18=HEAPF32[(($17)>>2)];
      var $19=$18;
      var $20=$19*255;
      var $21=($20 >= 0 ? Math.floor($20) : Math.ceil($20));
      $r=$21;
      var $22=(($15+28)|0);
      var $23=(($22+8)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$24;
      var $26=$25*255;
      var $27=($26 >= 0 ? Math.floor($26) : Math.ceil($26));
      $g=$27;
      var $28=(($15+28)|0);
      var $29=(($28+12)|0);
      var $30=HEAPF32[(($29)>>2)];
      var $31=$30;
      var $32=$31*255;
      var $33=($32 >= 0 ? Math.floor($32) : Math.ceil($32));
      $b=$33;
      var $34=(($15+28)|0);
      var $35=(($34)|0);
      var $36=HEAPF32[(($35)>>2)];
      var $37=$36;
      var $38=$37*255;
      var $39=($38 >= 0 ? Math.floor($38) : Math.ceil($38));
      $a=$39;
      var $40=$10;
      var $41=__ZNK15running_machine6renderEv($40);
      var $42=__ZN14render_manager10font_allocEPKc($41, ((STRING_TABLE.__str384653)|0));
      $font=$42;
      $aspect=1;
      __label__ = 1; break;
    case 1: // $43
      var $44=$font;
      var $45=$12;
      var $46=(($45+12)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$12;
      var $49=(($48+8)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($47-$50)|0);
      var $52=(($51)|0);
      var $53=$aspect;
      var $54=(($15+44)|0);
      var $55=__ZNK7astringcvPKcEv($54);
      var $56=__ZN11render_font12string_widthEffPKc($44, $52, $53, $55);
      var $57=(($56)|0);
      $width=$57;
      var $58=$width;
      var $59=$12;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$12;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($61-$64)|0);
      var $66=(($58)|0) < (($65)|0);
      if ($66) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $67
      __label__ = 4; break;
    case 3: // $68
      var $69=$aspect;
      var $70=$69*0.8999999761581421;
      $aspect=$70;
      __label__ = 1; break;
    case 4: // $71
      var $72=$12;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$12;
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$12;
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($77-$80)|0);
      var $82=$width;
      var $83=(($81-$82)|0);
      var $84=(((($83)|0)/2)|0);
      var $85=(($74+$84)|0);
      $curx=$85;
      var $86=$4;
      var $87=$5;
      var $88=$6;
      var $89=$result_i;
      var $90=$7;
      var $91=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=853;
      var $92=HEAP32[(($4)>>2)];
      var $93=HEAP32[(($5)>>2)];
      var $94=HEAP32[(($6)>>2)];
      var $95=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($92, $93, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $96
      HEAP32[(($result_i)>>2)]=$95;
      var $97=HEAP32[(($result_i)>>2)];
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $99
      var $100=___cxa_allocate_exception(4);
      var $101=$100;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($101);
      (function() { try { __THREW__ = false; return ___cxa_throw($100, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      HEAP32[(($7)>>2)]=$104;
      var $105=$103.f1;
      HEAP32[(($8)>>2)]=$105;
      var $106=HEAP32[(($8)>>2)];
      var $107=(($106)|0) < 0;
      if ($107) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $108
      var $109=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($109);
      throw "Reached an unreachable!"
    case 9: // $110
      var $111=HEAP32[(($7)>>2)];
      var $112=HEAP32[(($7)>>2)];
      var $113=HEAP32[(($8)>>2)];
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $116
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKci_exit
      var $117=HEAPU32[(($result_i)>>2)];
      var $118=$4;
      var $119=$5;
      var $120=$6;
      var $121=$result_i;
      var $122=$7;
      var $123=$8;
      var $124=$117;
      var $125=$11;
      var $126=$125;
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$11;
      var $130=$129;
      var $131=(($130+16)|0);
      var $132=HEAP32[(($131)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($124, $128, $132, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 24; break; }
    case 12: // $133
      var $134=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $124);
      $tempbitmap=$134;
      var $135=(($15+44)|0);
      var $136=__ZNK7astringcvPKcEv($135);
      $s=$136;
      __label__ = 13; break;
    case 13: // $137
      var $138=$s;
      var $139=HEAP8[($138)];
      var $140=(($139 << 24) >> 24);
      var $141=(($140)|0)!=0;
      if ($141) { __label__ = 14; break; } else { __label__ = 37; break; }
    case 14: // $142
      var $143=$font;
      var $144=$tempbitmap;
      var $145=$12;
      var $146=(($145+12)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$12;
      var $149=(($148+8)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($147-$150)|0);
      var $152=(($151)|0);
      var $153=$aspect;
      var $154=$s;
      var $155=HEAP8[($154)];
      var $156=(($155 << 24) >> 24);
      __ZN11render_font28get_scaled_bitmap_and_boundsER8bitmap_tffjR10_rectangle($143, $144, $152, $153, $156, $chbounds);
      $y=0;
      __label__ = 15; break;
    case 15: // $157
      var $158=$y;
      var $159=(($chbounds+12)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($chbounds+8)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($160-$162)|0);
      var $164=(($158)|0) < (($163)|0);
      if ($164) { __label__ = 16; break; } else { __label__ = 35; break; }
    case 16: // $165
      var $166=$12;
      var $167=(($166+8)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$y;
      var $170=(($168+$169)|0);
      $effy=$170;
      var $171=$effy;
      var $172=$12;
      var $173=(($172+8)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=(($171)|0) >= (($174)|0);
      if ($175) { __label__ = 17; break; } else { __label__ = 33; break; }
    case 17: // $176
      var $177=$effy;
      var $178=$12;
      var $179=(($178+12)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($177)|0) <= (($180)|0);
      if ($181) { __label__ = 18; break; } else { __label__ = 33; break; }
    case 18: // $182
      var $183=$tempbitmap;
      var $184=$183;
      var $185=(($184+4)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$186;
      var $188=$y;
      var $189=$tempbitmap;
      var $190=$189;
      var $191=(($190+8)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($188*$192)|0);
      var $194=(($187+($193<<2))|0);
      var $195=(($194)|0);
      $src=$195;
      var $196=$11;
      var $197=$196;
      var $198=(($197+4)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=$199;
      var $201=$effy;
      var $202=$11;
      var $203=$202;
      var $204=(($203+8)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($201*$205)|0);
      var $207=(($200+($206<<2))|0);
      var $208=(($207)|0);
      $d=$208;
      $x=0;
      __label__ = 19; break;
    case 19: // $209
      var $210=$x;
      var $211=(($chbounds+4)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=(($chbounds)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(($212-$214)|0);
      var $216=(($210)|0) < (($215)|0);
      if ($216) { __label__ = 20; break; } else { __label__ = 32; break; }
    case 20: // $217
      var $218=$curx;
      var $219=$x;
      var $220=(($218+$219)|0);
      var $221=(($chbounds)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($220+$222)|0);
      $effx=$223;
      var $224=$effx;
      var $225=$12;
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($224)|0) >= (($227)|0);
      if ($228) { __label__ = 21; break; } else { __label__ = 30; break; }
    case 21: // $229
      var $230=$effx;
      var $231=$12;
      var $232=(($231+4)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($230)|0) <= (($233)|0);
      if ($234) { __label__ = 22; break; } else { __label__ = 30; break; }
    case 22: // $235
      var $236=$x;
      var $237=$src;
      var $238=(($237+($236<<2))|0);
      var $239=HEAPU32[(($238)>>2)];
      var $240=$239 >>> 24;
      var $241=$240 & 255;
      $spix=$241;
      var $242=$spix;
      var $243=(($242)|0)!=0;
      if ($243) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $244
      var $245=$effx;
      var $246=$d;
      var $247=(($246+($245<<2))|0);
      var $248=HEAP32[(($247)>>2)];
      $dpix=$248;
      var $249=$a;
      var $250=$spix;
      var $251=(($250+1)|0);
      var $252=(($249*$251)|0);
      var $253=$252 >>> 8;
      $ta=$253;
      var $254=$r;
      var $255=$ta;
      var $256=(($254*$255)|0);
      var $257=$dpix;
      var $258=$257 >>> 16;
      var $259=$258 & 255;
      var $260=$ta;
      var $261=((256-$260)|0);
      var $262=(($259*$261)|0);
      var $263=(($256+$262)|0);
      var $264=$263 >>> 8;
      $tr=$264;
      var $265=$g;
      var $266=$ta;
      var $267=(($265*$266)|0);
      var $268=$dpix;
      var $269=$268 >>> 8;
      var $270=$269 & 255;
      var $271=$ta;
      var $272=((256-$271)|0);
      var $273=(($270*$272)|0);
      var $274=(($267+$273)|0);
      var $275=$274 >>> 8;
      $tg=$275;
      var $276=$b;
      var $277=$ta;
      var $278=(($276*$277)|0);
      var $279=$dpix;
      var $280=$279 & 255;
      var $281=$ta;
      var $282=((256-$281)|0);
      var $283=(($280*$282)|0);
      var $284=(($278+$283)|0);
      var $285=$284 >>> 8;
      $tb=$285;
      var $286=$tr;
      var $287=$286 & 255;
      var $288=$287 << 16;
      var $289=-16777216 | $288;
      var $290=$tg;
      var $291=$290 & 255;
      var $292=$291 << 8;
      var $293=$289 | $292;
      var $294=$tb;
      var $295=$294 & 255;
      var $296=$293 | $295;
      var $297=$effx;
      var $298=$d;
      var $299=(($298+($297<<2))|0);
      HEAP32[(($299)>>2)]=$296;
      __label__ = 29; break;
    case 24: // $300
      var $301=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $302=$301.f0;
      $13=$302;
      var $303=$301.f1;
      $14=$303;
      var $304=$1;
      var $305=$2;
      var $306=$3;
      HEAP32[(($1)>>2)]=$117;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=853;
      var $307=HEAP32[(($1)>>2)];
      var $308=(($307)|0)!=0;
      if ($308) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $309
      var $310=HEAP32[(($1)>>2)];
      var $311=HEAP32[(($2)>>2)];
      var $312=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($310, $311, $312) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 39; break; }
    case 26: // $_noexc
      __label__ = 27; break;
    case 27: // $_ZdlPvPKci_exit
      var $313=$1;
      var $314=$2;
      var $315=$3;
      __label__ = 28; break;
    case 28: // $316
      __label__ = 38; break;
    case 29: // $317
      __label__ = 30; break;
    case 30: // $318
      __label__ = 31; break;
    case 31: // $319
      var $320=$x;
      var $321=(($320+1)|0);
      $x=$321;
      __label__ = 19; break;
    case 32: // $322
      __label__ = 33; break;
    case 33: // $323
      __label__ = 34; break;
    case 34: // $324
      var $325=$y;
      var $326=(($325+1)|0);
      $y=$326;
      __label__ = 15; break;
    case 35: // $327
      var $328=$font;
      var $329=$12;
      var $330=(($329+12)|0);
      var $331=HEAP32[(($330)>>2)];
      var $332=$12;
      var $333=(($332+8)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($331-$334)|0);
      var $336=(($335)|0);
      var $337=$aspect;
      var $338=$s;
      var $339=HEAP8[($338)];
      var $340=(($339 << 24) >> 24);
      var $341=__ZN11render_font10char_widthEffj($328, $336, $337, $340);
      var $342=$curx;
      var $343=(($342)|0);
      var $344=$343+$341;
      var $345=(($344)|0);
      $curx=$345;
      __label__ = 36; break;
    case 36: // $346
      var $347=$s;
      var $348=(($347+1)|0);
      $s=$348;
      __label__ = 13; break;
    case 37: // $349
      var $350=$tempbitmap;
      var $351=$350;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $351);
      var $352=$10;
      var $353=__ZNK15running_machine6renderEv($352);
      var $354=$font;
      __ZN14render_manager9font_freeEP11render_font($353, $354);
      STACKTOP = __stackBase__;
      return;
    case 38: // $355
      var $356=$13;
      var $357=$13;
      var $358=$14;
      var $359=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $357, tempValue);
      var $360=($359.f1 = $358, $359);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 39: // $361
      var $362=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component9draw_textER15running_machineR8bitmap_tRK10_rectangle["X"]=1;

function __ZN14layout_element9component12draw_led7segER8bitmap_tRK10_rectanglei($this, $dest, $bounds, $pattern) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $onpen;
      var $offpen;
      var $bmwidth;
      var $bmheight;
      var $segwidth;
      var $skewwidth;
      var $tempbitmap;
      var $13;
      var $14;
      $9=$this;
      $10=$dest;
      $11=$bounds;
      $12=$pattern;
      var $15=$9;
      $onpen=-1;
      $offpen=-14671840;
      $bmwidth=250;
      $bmheight=400;
      $segwidth=40;
      $skewwidth=40;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=956;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$bmwidth;
      var $56=$skewwidth;
      var $57=(($55+$56)|0);
      var $58=$bmheight;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, $57, $58, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $59
      var $60=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $54);
      $tempbitmap=$60;
      var $61=$tempbitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($61, 0, -16777216);
      var $62=$tempbitmap;
      var $63=$segwidth;
      var $64=((($63<<1))|0);
      var $65=(((($64)|0)/3)|0);
      var $66=(($65)|0);
      var $67=$bmwidth;
      var $68=$segwidth;
      var $69=((($68<<1))|0);
      var $70=(((($69)|0)/3)|0);
      var $71=(($67-$70)|0);
      var $72=$segwidth;
      var $73=(((($72)|0)/2)|0);
      var $74=(($73)|0);
      var $75=$segwidth;
      var $76=$12;
      var $77=$76 & 1;
      var $78=(($77)|0)!=0;
      var $79=$78 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $62, $66, $71, $74, $75, $79);
      var $80=$tempbitmap;
      var $81=$segwidth;
      var $82=((($81<<1))|0);
      var $83=(((($82)|0)/3)|0);
      var $84=(($83)|0);
      var $85=$bmheight;
      var $86=(((($85)|0)/2)|0);
      var $87=$segwidth;
      var $88=(((($87)|0)/3)|0);
      var $89=(($86-$88)|0);
      var $90=$bmwidth;
      var $91=$segwidth;
      var $92=(((($91)|0)/2)|0);
      var $93=(($90-$92)|0);
      var $94=$segwidth;
      var $95=$12;
      var $96=$95 & 2;
      var $97=(($96)|0)!=0;
      var $98=$97 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $80, $84, $89, $93, $94, $98);
      var $99=$tempbitmap;
      var $100=$bmheight;
      var $101=(((($100)|0)/2)|0);
      var $102=$segwidth;
      var $103=(((($102)|0)/3)|0);
      var $104=(($101+$103)|0);
      var $105=$bmheight;
      var $106=$segwidth;
      var $107=((($106<<1))|0);
      var $108=(((($107)|0)/3)|0);
      var $109=(($105-$108)|0);
      var $110=$bmwidth;
      var $111=$segwidth;
      var $112=(((($111)|0)/2)|0);
      var $113=(($110-$112)|0);
      var $114=$segwidth;
      var $115=$12;
      var $116=$115 & 4;
      var $117=(($116)|0)!=0;
      var $118=$117 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $99, $104, $109, $113, $114, $118);
      var $119=$tempbitmap;
      var $120=$segwidth;
      var $121=((($120<<1))|0);
      var $122=(((($121)|0)/3)|0);
      var $123=(($122)|0);
      var $124=$bmwidth;
      var $125=$segwidth;
      var $126=((($125<<1))|0);
      var $127=(((($126)|0)/3)|0);
      var $128=(($124-$127)|0);
      var $129=$bmheight;
      var $130=$segwidth;
      var $131=(((($130)|0)/2)|0);
      var $132=(($129-$131)|0);
      var $133=$segwidth;
      var $134=$12;
      var $135=$134 & 8;
      var $136=(($135)|0)!=0;
      var $137=$136 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $119, $123, $128, $132, $133, $137);
      var $138=$tempbitmap;
      var $139=$bmheight;
      var $140=(((($139)|0)/2)|0);
      var $141=$segwidth;
      var $142=(((($141)|0)/3)|0);
      var $143=(($140+$142)|0);
      var $144=$bmheight;
      var $145=$segwidth;
      var $146=((($145<<1))|0);
      var $147=(((($146)|0)/3)|0);
      var $148=(($144-$147)|0);
      var $149=$segwidth;
      var $150=(((($149)|0)/2)|0);
      var $151=(($150)|0);
      var $152=$segwidth;
      var $153=$12;
      var $154=$153 & 16;
      var $155=(($154)|0)!=0;
      var $156=$155 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $138, $143, $148, $151, $152, $156);
      var $157=$tempbitmap;
      var $158=$segwidth;
      var $159=((($158<<1))|0);
      var $160=(((($159)|0)/3)|0);
      var $161=(($160)|0);
      var $162=$bmheight;
      var $163=(((($162)|0)/2)|0);
      var $164=$segwidth;
      var $165=(((($164)|0)/3)|0);
      var $166=(($163-$165)|0);
      var $167=$segwidth;
      var $168=(((($167)|0)/2)|0);
      var $169=(($168)|0);
      var $170=$segwidth;
      var $171=$12;
      var $172=$171 & 32;
      var $173=(($172)|0)!=0;
      var $174=$173 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $157, $161, $166, $169, $170, $174);
      var $175=$tempbitmap;
      var $176=$segwidth;
      var $177=((($176<<1))|0);
      var $178=(((($177)|0)/3)|0);
      var $179=(($178)|0);
      var $180=$bmwidth;
      var $181=$segwidth;
      var $182=((($181<<1))|0);
      var $183=(((($182)|0)/3)|0);
      var $184=(($180-$183)|0);
      var $185=$bmheight;
      var $186=(((($185)|0)/2)|0);
      var $187=$segwidth;
      var $188=$12;
      var $189=$188 & 64;
      var $190=(($189)|0)!=0;
      var $191=$190 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $175, $179, $184, $186, $187, $191);
      var $192=$tempbitmap;
      __ZN14layout_element9component10apply_skewER8bitmap_ti($15, $192, 40);
      var $193=$tempbitmap;
      var $194=$bmwidth;
      var $195=$segwidth;
      var $196=(((($195)|0)/2)|0);
      var $197=(($194+$196)|0);
      var $198=$bmheight;
      var $199=$segwidth;
      var $200=(((($199)|0)/2)|0);
      var $201=(($198-$200)|0);
      var $202=$segwidth;
      var $203=$12;
      var $204=$203 & 128;
      var $205=(($204)|0)!=0;
      var $206=$205 ? -1 : -14671840;
      __ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij($15, $193, $197, $201, $202, $206);
      var $207=$10;
      var $208=$207;
      var $209=(($208+4)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$10;
      var $212=$211;
      var $213=(($212+8)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=$10;
      var $216=$215;
      var $217=(($216+12)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$10;
      var $220=$219;
      var $221=(($220+16)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$tempbitmap;
      var $224=(($15+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($210, $214, $218, $222, $223, 0, $224);
      var $225=$tempbitmap;
      var $226=$225;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $226);
      STACKTOP = __stackBase__;
      return;
    case 9: // $227
      var $228=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $229=$228.f0;
      $13=$229;
      var $230=$228.f1;
      $14=$230;
      var $231=$1;
      var $232=$2;
      var $233=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=956;
      var $234=HEAP32[(($1)>>2)];
      var $235=(($234)|0)!=0;
      if ($235) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $236
      var $237=HEAP32[(($1)>>2)];
      var $238=HEAP32[(($2)>>2)];
      var $239=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($237, $238, $239) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $240=$1;
      var $241=$2;
      var $242=$3;
      __label__ = 13; break;
    case 13: // $243
      __label__ = 14; break;
    case 14: // $244
      var $245=$13;
      var $246=$13;
      var $247=$14;
      var $248=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $246, tempValue);
      var $249=($248.f1 = $247, $248);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $250
      var $251=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component12draw_led7segER8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9component13draw_led14segER8bitmap_tRK10_rectanglei($this, $dest, $bounds, $pattern) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $onpen;
      var $offpen;
      var $bmwidth;
      var $bmheight;
      var $segwidth;
      var $skewwidth;
      var $tempbitmap;
      var $13;
      var $14;
      $9=$this;
      $10=$dest;
      $11=$bounds;
      $12=$pattern;
      var $15=$9;
      $onpen=-1;
      $offpen=-14671840;
      $bmwidth=250;
      $bmheight=400;
      $segwidth=40;
      $skewwidth=40;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1009;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$bmwidth;
      var $56=$skewwidth;
      var $57=(($55+$56)|0);
      var $58=$bmheight;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, $57, $58, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $59
      var $60=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $54);
      $tempbitmap=$60;
      var $61=$tempbitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($61, 0, -16777216);
      var $62=$tempbitmap;
      var $63=$segwidth;
      var $64=((($63<<1))|0);
      var $65=(((($64)|0)/3)|0);
      var $66=(($65)|0);
      var $67=$bmwidth;
      var $68=$segwidth;
      var $69=((($68<<1))|0);
      var $70=(((($69)|0)/3)|0);
      var $71=(($67-$70)|0);
      var $72=$segwidth;
      var $73=(((($72)|0)/2)|0);
      var $74=(($73)|0);
      var $75=$segwidth;
      var $76=$12;
      var $77=$76 & 1;
      var $78=(($77)|0)!=0;
      var $79=$78 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $62, $66, $71, $74, $75, $79);
      var $80=$tempbitmap;
      var $81=$segwidth;
      var $82=((($81<<1))|0);
      var $83=(((($82)|0)/3)|0);
      var $84=(($83)|0);
      var $85=$bmheight;
      var $86=(((($85)|0)/2)|0);
      var $87=$segwidth;
      var $88=(((($87)|0)/3)|0);
      var $89=(($86-$88)|0);
      var $90=$bmwidth;
      var $91=$segwidth;
      var $92=(((($91)|0)/2)|0);
      var $93=(($90-$92)|0);
      var $94=$segwidth;
      var $95=$12;
      var $96=$95 & 2;
      var $97=(($96)|0)!=0;
      var $98=$97 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $80, $84, $89, $93, $94, $98);
      var $99=$tempbitmap;
      var $100=$bmheight;
      var $101=(((($100)|0)/2)|0);
      var $102=$segwidth;
      var $103=(((($102)|0)/3)|0);
      var $104=(($101+$103)|0);
      var $105=$bmheight;
      var $106=$segwidth;
      var $107=((($106<<1))|0);
      var $108=(((($107)|0)/3)|0);
      var $109=(($105-$108)|0);
      var $110=$bmwidth;
      var $111=$segwidth;
      var $112=(((($111)|0)/2)|0);
      var $113=(($110-$112)|0);
      var $114=$segwidth;
      var $115=$12;
      var $116=$115 & 4;
      var $117=(($116)|0)!=0;
      var $118=$117 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $99, $104, $109, $113, $114, $118);
      var $119=$tempbitmap;
      var $120=$segwidth;
      var $121=((($120<<1))|0);
      var $122=(((($121)|0)/3)|0);
      var $123=(($122)|0);
      var $124=$bmwidth;
      var $125=$segwidth;
      var $126=((($125<<1))|0);
      var $127=(((($126)|0)/3)|0);
      var $128=(($124-$127)|0);
      var $129=$bmheight;
      var $130=$segwidth;
      var $131=(((($130)|0)/2)|0);
      var $132=(($129-$131)|0);
      var $133=$segwidth;
      var $134=$12;
      var $135=$134 & 8;
      var $136=(($135)|0)!=0;
      var $137=$136 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $119, $123, $128, $132, $133, $137);
      var $138=$tempbitmap;
      var $139=$bmheight;
      var $140=(((($139)|0)/2)|0);
      var $141=$segwidth;
      var $142=(((($141)|0)/3)|0);
      var $143=(($140+$142)|0);
      var $144=$bmheight;
      var $145=$segwidth;
      var $146=((($145<<1))|0);
      var $147=(((($146)|0)/3)|0);
      var $148=(($144-$147)|0);
      var $149=$segwidth;
      var $150=(((($149)|0)/2)|0);
      var $151=(($150)|0);
      var $152=$segwidth;
      var $153=$12;
      var $154=$153 & 16;
      var $155=(($154)|0)!=0;
      var $156=$155 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $138, $143, $148, $151, $152, $156);
      var $157=$tempbitmap;
      var $158=$segwidth;
      var $159=((($158<<1))|0);
      var $160=(((($159)|0)/3)|0);
      var $161=(($160)|0);
      var $162=$bmheight;
      var $163=(((($162)|0)/2)|0);
      var $164=$segwidth;
      var $165=(((($164)|0)/3)|0);
      var $166=(($163-$165)|0);
      var $167=$segwidth;
      var $168=(((($167)|0)/2)|0);
      var $169=(($168)|0);
      var $170=$segwidth;
      var $171=$12;
      var $172=$171 & 32;
      var $173=(($172)|0)!=0;
      var $174=$173 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $157, $161, $166, $169, $170, $174);
      var $175=$tempbitmap;
      var $176=$segwidth;
      var $177=((($176<<1))|0);
      var $178=(((($177)|0)/3)|0);
      var $179=(($178)|0);
      var $180=$bmwidth;
      var $181=(((($180)|0)/2)|0);
      var $182=$segwidth;
      var $183=(((($182)|0)/10)|0);
      var $184=(($181-$183)|0);
      var $185=$bmheight;
      var $186=(((($185)|0)/2)|0);
      var $187=$segwidth;
      var $188=$12;
      var $189=$188 & 64;
      var $190=(($189)|0)!=0;
      var $191=$190 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $175, $179, $184, $186, $187, 1, $191);
      var $192=$tempbitmap;
      var $193=$bmwidth;
      var $194=(((($193)|0)/2)|0);
      var $195=(($194)|0);
      var $196=$segwidth;
      var $197=(((($196)|0)/10)|0);
      var $198=(($195+$197)|0);
      var $199=$bmwidth;
      var $200=$segwidth;
      var $201=((($200<<1))|0);
      var $202=(((($201)|0)/3)|0);
      var $203=(($199-$202)|0);
      var $204=$bmheight;
      var $205=(((($204)|0)/2)|0);
      var $206=$segwidth;
      var $207=$12;
      var $208=$207 & 128;
      var $209=(($208)|0)!=0;
      var $210=$209 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $192, $198, $203, $205, $206, 2, $210);
      var $211=$tempbitmap;
      var $212=$segwidth;
      var $213=(($212)|0);
      var $214=$segwidth;
      var $215=(((($214)|0)/3)|0);
      var $216=(($213+$215)|0);
      var $217=$bmheight;
      var $218=(((($217)|0)/2)|0);
      var $219=$segwidth;
      var $220=(((($219)|0)/2)|0);
      var $221=(($218-$220)|0);
      var $222=$segwidth;
      var $223=(((($222)|0)/3)|0);
      var $224=(($221-$223)|0);
      var $225=$bmwidth;
      var $226=(((($225)|0)/2)|0);
      var $227=$segwidth;
      var $228=$12;
      var $229=$228 & 256;
      var $230=(($229)|0)!=0;
      var $231=$230 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $211, $216, $224, $226, $227, 0, $231);
      var $232=$tempbitmap;
      var $233=$bmheight;
      var $234=(((($233)|0)/2)|0);
      var $235=$segwidth;
      var $236=(((($235)|0)/2)|0);
      var $237=(($234+$236)|0);
      var $238=$segwidth;
      var $239=(((($238)|0)/3)|0);
      var $240=(($237+$239)|0);
      var $241=$bmheight;
      var $242=$segwidth;
      var $243=(($241-$242)|0);
      var $244=$segwidth;
      var $245=(((($244)|0)/3)|0);
      var $246=(($243-$245)|0);
      var $247=$bmwidth;
      var $248=(((($247)|0)/2)|0);
      var $249=$segwidth;
      var $250=$12;
      var $251=$250 & 512;
      var $252=(($251)|0)!=0;
      var $253=$252 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $232, $240, $246, $248, $249, 0, $253);
      var $254=$tempbitmap;
      var $255=$segwidth;
      var $256=(($255)|0);
      var $257=$segwidth;
      var $258=(((($257)|0)/5)|0);
      var $259=(($256+$258)|0);
      var $260=$bmwidth;
      var $261=(((($260)|0)/2)|0);
      var $262=$segwidth;
      var $263=(((($262)|0)/2)|0);
      var $264=(($261-$263)|0);
      var $265=$segwidth;
      var $266=(((($265)|0)/5)|0);
      var $267=(($264-$266)|0);
      var $268=$bmheight;
      var $269=(((($268)|0)/2)|0);
      var $270=$segwidth;
      var $271=(((($270)|0)/2)|0);
      var $272=(($269+$271)|0);
      var $273=$segwidth;
      var $274=(((($273)|0)/3)|0);
      var $275=(($272+$274)|0);
      var $276=$bmheight;
      var $277=$segwidth;
      var $278=(($276-$277)|0);
      var $279=$segwidth;
      var $280=(((($279)|0)/3)|0);
      var $281=(($278-$280)|0);
      var $282=$segwidth;
      var $283=$12;
      var $284=$283 & 1024;
      var $285=(($284)|0)!=0;
      var $286=$285 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $254, $259, $267, $275, $281, $282, $286);
      var $287=$tempbitmap;
      var $288=$segwidth;
      var $289=(($288)|0);
      var $290=$segwidth;
      var $291=(((($290)|0)/5)|0);
      var $292=(($289+$291)|0);
      var $293=$bmwidth;
      var $294=(((($293)|0)/2)|0);
      var $295=$segwidth;
      var $296=(((($295)|0)/2)|0);
      var $297=(($294-$296)|0);
      var $298=$segwidth;
      var $299=(((($298)|0)/5)|0);
      var $300=(($297-$299)|0);
      var $301=$segwidth;
      var $302=(($301)|0);
      var $303=$segwidth;
      var $304=(((($303)|0)/3)|0);
      var $305=(($302+$304)|0);
      var $306=$bmheight;
      var $307=(((($306)|0)/2)|0);
      var $308=$segwidth;
      var $309=(((($308)|0)/2)|0);
      var $310=(($307-$309)|0);
      var $311=$segwidth;
      var $312=(((($311)|0)/3)|0);
      var $313=(($310-$312)|0);
      var $314=$segwidth;
      var $315=$12;
      var $316=$315 & 2048;
      var $317=(($316)|0)!=0;
      var $318=$317 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $287, $292, $300, $305, $313, $314, $318);
      var $319=$tempbitmap;
      var $320=$bmwidth;
      var $321=(((($320)|0)/2)|0);
      var $322=$segwidth;
      var $323=(((($322)|0)/2)|0);
      var $324=(($321+$323)|0);
      var $325=$segwidth;
      var $326=(((($325)|0)/5)|0);
      var $327=(($324+$326)|0);
      var $328=$bmwidth;
      var $329=$segwidth;
      var $330=(($328-$329)|0);
      var $331=$segwidth;
      var $332=(((($331)|0)/5)|0);
      var $333=(($330-$332)|0);
      var $334=$segwidth;
      var $335=(($334)|0);
      var $336=$segwidth;
      var $337=(((($336)|0)/3)|0);
      var $338=(($335+$337)|0);
      var $339=$bmheight;
      var $340=(((($339)|0)/2)|0);
      var $341=$segwidth;
      var $342=(((($341)|0)/2)|0);
      var $343=(($340-$342)|0);
      var $344=$segwidth;
      var $345=(((($344)|0)/3)|0);
      var $346=(($343-$345)|0);
      var $347=$segwidth;
      var $348=$12;
      var $349=$348 & 4096;
      var $350=(($349)|0)!=0;
      var $351=$350 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $319, $327, $333, $338, $346, $347, $351);
      var $352=$tempbitmap;
      var $353=$bmwidth;
      var $354=(((($353)|0)/2)|0);
      var $355=$segwidth;
      var $356=(((($355)|0)/2)|0);
      var $357=(($354+$356)|0);
      var $358=$segwidth;
      var $359=(((($358)|0)/5)|0);
      var $360=(($357+$359)|0);
      var $361=$bmwidth;
      var $362=$segwidth;
      var $363=(($361-$362)|0);
      var $364=$segwidth;
      var $365=(((($364)|0)/5)|0);
      var $366=(($363-$365)|0);
      var $367=$bmheight;
      var $368=(((($367)|0)/2)|0);
      var $369=$segwidth;
      var $370=(((($369)|0)/2)|0);
      var $371=(($368+$370)|0);
      var $372=$segwidth;
      var $373=(((($372)|0)/3)|0);
      var $374=(($371+$373)|0);
      var $375=$bmheight;
      var $376=$segwidth;
      var $377=(($375-$376)|0);
      var $378=$segwidth;
      var $379=(((($378)|0)/3)|0);
      var $380=(($377-$379)|0);
      var $381=$segwidth;
      var $382=$12;
      var $383=$382 & 8192;
      var $384=(($383)|0)!=0;
      var $385=$384 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $352, $360, $366, $374, $380, $381, $385);
      var $386=$tempbitmap;
      __ZN14layout_element9component10apply_skewER8bitmap_ti($15, $386, 40);
      var $387=$10;
      var $388=$387;
      var $389=(($388+4)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=$10;
      var $392=$391;
      var $393=(($392+8)|0);
      var $394=HEAP32[(($393)>>2)];
      var $395=$10;
      var $396=$395;
      var $397=(($396+12)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=$10;
      var $400=$399;
      var $401=(($400+16)|0);
      var $402=HEAP32[(($401)>>2)];
      var $403=$tempbitmap;
      var $404=(($15+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($390, $394, $398, $402, $403, 0, $404);
      var $405=$tempbitmap;
      var $406=$405;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $406);
      STACKTOP = __stackBase__;
      return;
    case 9: // $407
      var $408=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $409=$408.f0;
      $13=$409;
      var $410=$408.f1;
      $14=$410;
      var $411=$1;
      var $412=$2;
      var $413=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1009;
      var $414=HEAP32[(($1)>>2)];
      var $415=(($414)|0)!=0;
      if ($415) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $416
      var $417=HEAP32[(($1)>>2)];
      var $418=HEAP32[(($2)>>2)];
      var $419=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($417, $418, $419) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $420=$1;
      var $421=$2;
      var $422=$3;
      __label__ = 13; break;
    case 13: // $423
      __label__ = 14; break;
    case 14: // $424
      var $425=$13;
      var $426=$13;
      var $427=$14;
      var $428=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $426, tempValue);
      var $429=($428.f1 = $427, $428);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $430
      var $431=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component13draw_led14segER8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9component13draw_led16segER8bitmap_tRK10_rectanglei($this, $dest, $bounds, $pattern) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $onpen;
      var $offpen;
      var $bmwidth;
      var $bmheight;
      var $segwidth;
      var $skewwidth;
      var $tempbitmap;
      var $13;
      var $14;
      $9=$this;
      $10=$dest;
      $11=$bounds;
      $12=$pattern;
      var $15=$9;
      $onpen=-1;
      $offpen=-14671840;
      $bmwidth=250;
      $bmheight=400;
      $segwidth=40;
      $skewwidth=40;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1225;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$bmwidth;
      var $56=$skewwidth;
      var $57=(($55+$56)|0);
      var $58=$bmheight;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, $57, $58, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $59
      var $60=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $54);
      $tempbitmap=$60;
      var $61=$tempbitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($61, 0, -16777216);
      var $62=$tempbitmap;
      var $63=$segwidth;
      var $64=((($63<<1))|0);
      var $65=(((($64)|0)/3)|0);
      var $66=(($65)|0);
      var $67=$bmwidth;
      var $68=(((($67)|0)/2)|0);
      var $69=$segwidth;
      var $70=(((($69)|0)/10)|0);
      var $71=(($68-$70)|0);
      var $72=$segwidth;
      var $73=(((($72)|0)/2)|0);
      var $74=(($73)|0);
      var $75=$segwidth;
      var $76=$12;
      var $77=$76 & 1;
      var $78=(($77)|0)!=0;
      var $79=$78 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $62, $66, $71, $74, $75, 1, $79);
      var $80=$tempbitmap;
      var $81=$bmwidth;
      var $82=(((($81)|0)/2)|0);
      var $83=(($82)|0);
      var $84=$segwidth;
      var $85=(((($84)|0)/10)|0);
      var $86=(($83+$85)|0);
      var $87=$bmwidth;
      var $88=$segwidth;
      var $89=((($88<<1))|0);
      var $90=(((($89)|0)/3)|0);
      var $91=(($87-$90)|0);
      var $92=$segwidth;
      var $93=(((($92)|0)/2)|0);
      var $94=(($93)|0);
      var $95=$segwidth;
      var $96=$12;
      var $97=$96 & 2;
      var $98=(($97)|0)!=0;
      var $99=$98 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $80, $86, $91, $94, $95, 2, $99);
      var $100=$tempbitmap;
      var $101=$segwidth;
      var $102=((($101<<1))|0);
      var $103=(((($102)|0)/3)|0);
      var $104=(($103)|0);
      var $105=$bmheight;
      var $106=(((($105)|0)/2)|0);
      var $107=$segwidth;
      var $108=(((($107)|0)/3)|0);
      var $109=(($106-$108)|0);
      var $110=$bmwidth;
      var $111=$segwidth;
      var $112=(((($111)|0)/2)|0);
      var $113=(($110-$112)|0);
      var $114=$segwidth;
      var $115=$12;
      var $116=$115 & 4;
      var $117=(($116)|0)!=0;
      var $118=$117 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $100, $104, $109, $113, $114, $118);
      var $119=$tempbitmap;
      var $120=$bmheight;
      var $121=(((($120)|0)/2)|0);
      var $122=$segwidth;
      var $123=(((($122)|0)/3)|0);
      var $124=(($121+$123)|0);
      var $125=$bmheight;
      var $126=$segwidth;
      var $127=((($126<<1))|0);
      var $128=(((($127)|0)/3)|0);
      var $129=(($125-$128)|0);
      var $130=$bmwidth;
      var $131=$segwidth;
      var $132=(((($131)|0)/2)|0);
      var $133=(($130-$132)|0);
      var $134=$segwidth;
      var $135=$12;
      var $136=$135 & 8;
      var $137=(($136)|0)!=0;
      var $138=$137 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $119, $124, $129, $133, $134, $138);
      var $139=$tempbitmap;
      var $140=$bmwidth;
      var $141=(((($140)|0)/2)|0);
      var $142=(($141)|0);
      var $143=$segwidth;
      var $144=(((($143)|0)/10)|0);
      var $145=(($142+$144)|0);
      var $146=$bmwidth;
      var $147=$segwidth;
      var $148=((($147<<1))|0);
      var $149=(((($148)|0)/3)|0);
      var $150=(($146-$149)|0);
      var $151=$bmheight;
      var $152=$segwidth;
      var $153=(((($152)|0)/2)|0);
      var $154=(($151-$153)|0);
      var $155=$segwidth;
      var $156=$12;
      var $157=$156 & 16;
      var $158=(($157)|0)!=0;
      var $159=$158 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $139, $145, $150, $154, $155, 2, $159);
      var $160=$tempbitmap;
      var $161=$segwidth;
      var $162=((($161<<1))|0);
      var $163=(((($162)|0)/3)|0);
      var $164=(($163)|0);
      var $165=$bmwidth;
      var $166=(((($165)|0)/2)|0);
      var $167=$segwidth;
      var $168=(((($167)|0)/10)|0);
      var $169=(($166-$168)|0);
      var $170=$bmheight;
      var $171=$segwidth;
      var $172=(((($171)|0)/2)|0);
      var $173=(($170-$172)|0);
      var $174=$segwidth;
      var $175=$12;
      var $176=$175 & 32;
      var $177=(($176)|0)!=0;
      var $178=$177 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $160, $164, $169, $173, $174, 1, $178);
      var $179=$tempbitmap;
      var $180=$bmheight;
      var $181=(((($180)|0)/2)|0);
      var $182=$segwidth;
      var $183=(((($182)|0)/3)|0);
      var $184=(($181+$183)|0);
      var $185=$bmheight;
      var $186=$segwidth;
      var $187=((($186<<1))|0);
      var $188=(((($187)|0)/3)|0);
      var $189=(($185-$188)|0);
      var $190=$segwidth;
      var $191=(((($190)|0)/2)|0);
      var $192=(($191)|0);
      var $193=$segwidth;
      var $194=$12;
      var $195=$194 & 64;
      var $196=(($195)|0)!=0;
      var $197=$196 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $179, $184, $189, $192, $193, $197);
      var $198=$tempbitmap;
      var $199=$segwidth;
      var $200=((($199<<1))|0);
      var $201=(((($200)|0)/3)|0);
      var $202=(($201)|0);
      var $203=$bmheight;
      var $204=(((($203)|0)/2)|0);
      var $205=$segwidth;
      var $206=(((($205)|0)/3)|0);
      var $207=(($204-$206)|0);
      var $208=$segwidth;
      var $209=(((($208)|0)/2)|0);
      var $210=(($209)|0);
      var $211=$segwidth;
      var $212=$12;
      var $213=$212 & 128;
      var $214=(($213)|0)!=0;
      var $215=$214 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $198, $202, $207, $210, $211, $215);
      var $216=$tempbitmap;
      var $217=$segwidth;
      var $218=((($217<<1))|0);
      var $219=(((($218)|0)/3)|0);
      var $220=(($219)|0);
      var $221=$bmwidth;
      var $222=(((($221)|0)/2)|0);
      var $223=$segwidth;
      var $224=(((($223)|0)/10)|0);
      var $225=(($222-$224)|0);
      var $226=$bmheight;
      var $227=(((($226)|0)/2)|0);
      var $228=$segwidth;
      var $229=$12;
      var $230=$229 & 256;
      var $231=(($230)|0)!=0;
      var $232=$231 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $216, $220, $225, $227, $228, 1, $232);
      var $233=$tempbitmap;
      var $234=$bmwidth;
      var $235=(((($234)|0)/2)|0);
      var $236=(($235)|0);
      var $237=$segwidth;
      var $238=(((($237)|0)/10)|0);
      var $239=(($236+$238)|0);
      var $240=$bmwidth;
      var $241=$segwidth;
      var $242=((($241<<1))|0);
      var $243=(((($242)|0)/3)|0);
      var $244=(($240-$243)|0);
      var $245=$bmheight;
      var $246=(((($245)|0)/2)|0);
      var $247=$segwidth;
      var $248=$12;
      var $249=$248 & 512;
      var $250=(($249)|0)!=0;
      var $251=$250 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $233, $239, $244, $246, $247, 2, $251);
      var $252=$tempbitmap;
      var $253=$segwidth;
      var $254=(($253)|0);
      var $255=$segwidth;
      var $256=(((($255)|0)/3)|0);
      var $257=(($254+$256)|0);
      var $258=$bmheight;
      var $259=(((($258)|0)/2)|0);
      var $260=$segwidth;
      var $261=(((($260)|0)/2)|0);
      var $262=(($259-$261)|0);
      var $263=$segwidth;
      var $264=(((($263)|0)/3)|0);
      var $265=(($262-$264)|0);
      var $266=$bmwidth;
      var $267=(((($266)|0)/2)|0);
      var $268=$segwidth;
      var $269=$12;
      var $270=$269 & 1024;
      var $271=(($270)|0)!=0;
      var $272=$271 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $252, $257, $265, $267, $268, 0, $272);
      var $273=$tempbitmap;
      var $274=$bmheight;
      var $275=(((($274)|0)/2)|0);
      var $276=$segwidth;
      var $277=(((($276)|0)/2)|0);
      var $278=(($275+$277)|0);
      var $279=$segwidth;
      var $280=(((($279)|0)/3)|0);
      var $281=(($278+$280)|0);
      var $282=$bmheight;
      var $283=$segwidth;
      var $284=(($282-$283)|0);
      var $285=$segwidth;
      var $286=(((($285)|0)/3)|0);
      var $287=(($284-$286)|0);
      var $288=$bmwidth;
      var $289=(((($288)|0)/2)|0);
      var $290=$segwidth;
      var $291=$12;
      var $292=$291 & 2048;
      var $293=(($292)|0)!=0;
      var $294=$293 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $273, $281, $287, $289, $290, 0, $294);
      var $295=$tempbitmap;
      var $296=$segwidth;
      var $297=(($296)|0);
      var $298=$segwidth;
      var $299=(((($298)|0)/5)|0);
      var $300=(($297+$299)|0);
      var $301=$bmwidth;
      var $302=(((($301)|0)/2)|0);
      var $303=$segwidth;
      var $304=(((($303)|0)/2)|0);
      var $305=(($302-$304)|0);
      var $306=$segwidth;
      var $307=(((($306)|0)/5)|0);
      var $308=(($305-$307)|0);
      var $309=$bmheight;
      var $310=(((($309)|0)/2)|0);
      var $311=$segwidth;
      var $312=(((($311)|0)/2)|0);
      var $313=(($310+$312)|0);
      var $314=$segwidth;
      var $315=(((($314)|0)/3)|0);
      var $316=(($313+$315)|0);
      var $317=$bmheight;
      var $318=$segwidth;
      var $319=(($317-$318)|0);
      var $320=$segwidth;
      var $321=(((($320)|0)/3)|0);
      var $322=(($319-$321)|0);
      var $323=$segwidth;
      var $324=$12;
      var $325=$324 & 4096;
      var $326=(($325)|0)!=0;
      var $327=$326 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $295, $300, $308, $316, $322, $323, $327);
      var $328=$tempbitmap;
      var $329=$segwidth;
      var $330=(($329)|0);
      var $331=$segwidth;
      var $332=(((($331)|0)/5)|0);
      var $333=(($330+$332)|0);
      var $334=$bmwidth;
      var $335=(((($334)|0)/2)|0);
      var $336=$segwidth;
      var $337=(((($336)|0)/2)|0);
      var $338=(($335-$337)|0);
      var $339=$segwidth;
      var $340=(((($339)|0)/5)|0);
      var $341=(($338-$340)|0);
      var $342=$segwidth;
      var $343=(($342)|0);
      var $344=$segwidth;
      var $345=(((($344)|0)/3)|0);
      var $346=(($343+$345)|0);
      var $347=$bmheight;
      var $348=(((($347)|0)/2)|0);
      var $349=$segwidth;
      var $350=(((($349)|0)/2)|0);
      var $351=(($348-$350)|0);
      var $352=$segwidth;
      var $353=(((($352)|0)/3)|0);
      var $354=(($351-$353)|0);
      var $355=$segwidth;
      var $356=$12;
      var $357=$356 & 8192;
      var $358=(($357)|0)!=0;
      var $359=$358 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $328, $333, $341, $346, $354, $355, $359);
      var $360=$tempbitmap;
      var $361=$bmwidth;
      var $362=(((($361)|0)/2)|0);
      var $363=$segwidth;
      var $364=(((($363)|0)/2)|0);
      var $365=(($362+$364)|0);
      var $366=$segwidth;
      var $367=(((($366)|0)/5)|0);
      var $368=(($365+$367)|0);
      var $369=$bmwidth;
      var $370=$segwidth;
      var $371=(($369-$370)|0);
      var $372=$segwidth;
      var $373=(((($372)|0)/5)|0);
      var $374=(($371-$373)|0);
      var $375=$segwidth;
      var $376=(($375)|0);
      var $377=$segwidth;
      var $378=(((($377)|0)/3)|0);
      var $379=(($376+$378)|0);
      var $380=$bmheight;
      var $381=(((($380)|0)/2)|0);
      var $382=$segwidth;
      var $383=(((($382)|0)/2)|0);
      var $384=(($381-$383)|0);
      var $385=$segwidth;
      var $386=(((($385)|0)/3)|0);
      var $387=(($384-$386)|0);
      var $388=$segwidth;
      var $389=$12;
      var $390=$389 & 16384;
      var $391=(($390)|0)!=0;
      var $392=$391 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $360, $368, $374, $379, $387, $388, $392);
      var $393=$tempbitmap;
      var $394=$bmwidth;
      var $395=(((($394)|0)/2)|0);
      var $396=$segwidth;
      var $397=(((($396)|0)/2)|0);
      var $398=(($395+$397)|0);
      var $399=$segwidth;
      var $400=(((($399)|0)/5)|0);
      var $401=(($398+$400)|0);
      var $402=$bmwidth;
      var $403=$segwidth;
      var $404=(($402-$403)|0);
      var $405=$segwidth;
      var $406=(((($405)|0)/5)|0);
      var $407=(($404-$406)|0);
      var $408=$bmheight;
      var $409=(((($408)|0)/2)|0);
      var $410=$segwidth;
      var $411=(((($410)|0)/2)|0);
      var $412=(($409+$411)|0);
      var $413=$segwidth;
      var $414=(((($413)|0)/3)|0);
      var $415=(($412+$414)|0);
      var $416=$bmheight;
      var $417=$segwidth;
      var $418=(($416-$417)|0);
      var $419=$segwidth;
      var $420=(((($419)|0)/3)|0);
      var $421=(($418-$420)|0);
      var $422=$segwidth;
      var $423=$12;
      var $424=$423 & 32768;
      var $425=(($424)|0)!=0;
      var $426=$425 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $393, $401, $407, $415, $421, $422, $426);
      var $427=$tempbitmap;
      __ZN14layout_element9component10apply_skewER8bitmap_ti($15, $427, 40);
      var $428=$10;
      var $429=$428;
      var $430=(($429+4)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=$10;
      var $433=$432;
      var $434=(($433+8)|0);
      var $435=HEAP32[(($434)>>2)];
      var $436=$10;
      var $437=$436;
      var $438=(($437+12)|0);
      var $439=HEAP32[(($438)>>2)];
      var $440=$10;
      var $441=$440;
      var $442=(($441+16)|0);
      var $443=HEAP32[(($442)>>2)];
      var $444=$tempbitmap;
      var $445=(($15+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($431, $435, $439, $443, $444, 0, $445);
      var $446=$tempbitmap;
      var $447=$446;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $447);
      STACKTOP = __stackBase__;
      return;
    case 9: // $448
      var $449=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $450=$449.f0;
      $13=$450;
      var $451=$449.f1;
      $14=$451;
      var $452=$1;
      var $453=$2;
      var $454=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1225;
      var $455=HEAP32[(($1)>>2)];
      var $456=(($455)|0)!=0;
      if ($456) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $457
      var $458=HEAP32[(($1)>>2)];
      var $459=HEAP32[(($2)>>2)];
      var $460=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($458, $459, $460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $461=$1;
      var $462=$2;
      var $463=$3;
      __label__ = 13; break;
    case 13: // $464
      __label__ = 14; break;
    case 14: // $465
      var $466=$13;
      var $467=$13;
      var $468=$14;
      var $469=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $467, tempValue);
      var $470=($469.f1 = $468, $469);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $471
      var $472=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component13draw_led16segER8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9component15draw_led14segscER8bitmap_tRK10_rectanglei($this, $dest, $bounds, $pattern) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $onpen;
      var $offpen;
      var $bmwidth;
      var $bmheight;
      var $segwidth;
      var $skewwidth;
      var $tempbitmap;
      var $13;
      var $14;
      $9=$this;
      $10=$dest;
      $11=$bounds;
      $12=$pattern;
      var $15=$9;
      $onpen=-1;
      $offpen=-14671840;
      $bmwidth=250;
      $bmheight=400;
      $segwidth=40;
      $skewwidth=40;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1113;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$bmwidth;
      var $56=$skewwidth;
      var $57=(($55+$56)|0);
      var $58=$bmheight;
      var $59=$segwidth;
      var $60=(($58+$59)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, $57, $60, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $61
      var $62=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $54);
      $tempbitmap=$62;
      var $63=$tempbitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($63, 0, -16777216);
      var $64=$tempbitmap;
      var $65=$segwidth;
      var $66=((($65<<1))|0);
      var $67=(((($66)|0)/3)|0);
      var $68=(($67)|0);
      var $69=$bmwidth;
      var $70=$segwidth;
      var $71=((($70<<1))|0);
      var $72=(((($71)|0)/3)|0);
      var $73=(($69-$72)|0);
      var $74=$segwidth;
      var $75=(((($74)|0)/2)|0);
      var $76=(($75)|0);
      var $77=$segwidth;
      var $78=$12;
      var $79=$78 & 1;
      var $80=(($79)|0)!=0;
      var $81=$80 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $64, $68, $73, $76, $77, $81);
      var $82=$tempbitmap;
      var $83=$segwidth;
      var $84=((($83<<1))|0);
      var $85=(((($84)|0)/3)|0);
      var $86=(($85)|0);
      var $87=$bmheight;
      var $88=(((($87)|0)/2)|0);
      var $89=$segwidth;
      var $90=(((($89)|0)/3)|0);
      var $91=(($88-$90)|0);
      var $92=$bmwidth;
      var $93=$segwidth;
      var $94=(((($93)|0)/2)|0);
      var $95=(($92-$94)|0);
      var $96=$segwidth;
      var $97=$12;
      var $98=$97 & 2;
      var $99=(($98)|0)!=0;
      var $100=$99 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $82, $86, $91, $95, $96, $100);
      var $101=$tempbitmap;
      var $102=$bmheight;
      var $103=(((($102)|0)/2)|0);
      var $104=$segwidth;
      var $105=(((($104)|0)/3)|0);
      var $106=(($103+$105)|0);
      var $107=$bmheight;
      var $108=$segwidth;
      var $109=((($108<<1))|0);
      var $110=(((($109)|0)/3)|0);
      var $111=(($107-$110)|0);
      var $112=$bmwidth;
      var $113=$segwidth;
      var $114=(((($113)|0)/2)|0);
      var $115=(($112-$114)|0);
      var $116=$segwidth;
      var $117=$12;
      var $118=$117 & 4;
      var $119=(($118)|0)!=0;
      var $120=$119 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $101, $106, $111, $115, $116, $120);
      var $121=$tempbitmap;
      var $122=$segwidth;
      var $123=((($122<<1))|0);
      var $124=(((($123)|0)/3)|0);
      var $125=(($124)|0);
      var $126=$bmwidth;
      var $127=$segwidth;
      var $128=((($127<<1))|0);
      var $129=(((($128)|0)/3)|0);
      var $130=(($126-$129)|0);
      var $131=$bmheight;
      var $132=$segwidth;
      var $133=(((($132)|0)/2)|0);
      var $134=(($131-$133)|0);
      var $135=$segwidth;
      var $136=$12;
      var $137=$136 & 8;
      var $138=(($137)|0)!=0;
      var $139=$138 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($15, $121, $125, $130, $134, $135, $139);
      var $140=$tempbitmap;
      var $141=$bmheight;
      var $142=(((($141)|0)/2)|0);
      var $143=$segwidth;
      var $144=(((($143)|0)/3)|0);
      var $145=(($142+$144)|0);
      var $146=$bmheight;
      var $147=$segwidth;
      var $148=((($147<<1))|0);
      var $149=(((($148)|0)/3)|0);
      var $150=(($146-$149)|0);
      var $151=$segwidth;
      var $152=(((($151)|0)/2)|0);
      var $153=(($152)|0);
      var $154=$segwidth;
      var $155=$12;
      var $156=$155 & 16;
      var $157=(($156)|0)!=0;
      var $158=$157 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $140, $145, $150, $153, $154, $158);
      var $159=$tempbitmap;
      var $160=$segwidth;
      var $161=((($160<<1))|0);
      var $162=(((($161)|0)/3)|0);
      var $163=(($162)|0);
      var $164=$bmheight;
      var $165=(((($164)|0)/2)|0);
      var $166=$segwidth;
      var $167=(((($166)|0)/3)|0);
      var $168=(($165-$167)|0);
      var $169=$segwidth;
      var $170=(((($169)|0)/2)|0);
      var $171=(($170)|0);
      var $172=$segwidth;
      var $173=$12;
      var $174=$173 & 32;
      var $175=(($174)|0)!=0;
      var $176=$175 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $159, $163, $168, $171, $172, $176);
      var $177=$tempbitmap;
      var $178=$segwidth;
      var $179=((($178<<1))|0);
      var $180=(((($179)|0)/3)|0);
      var $181=(($180)|0);
      var $182=$bmwidth;
      var $183=(((($182)|0)/2)|0);
      var $184=$segwidth;
      var $185=(((($184)|0)/10)|0);
      var $186=(($183-$185)|0);
      var $187=$bmheight;
      var $188=(((($187)|0)/2)|0);
      var $189=$segwidth;
      var $190=$12;
      var $191=$190 & 64;
      var $192=(($191)|0)!=0;
      var $193=$192 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $177, $181, $186, $188, $189, 1, $193);
      var $194=$tempbitmap;
      var $195=$bmwidth;
      var $196=(((($195)|0)/2)|0);
      var $197=(($196)|0);
      var $198=$segwidth;
      var $199=(((($198)|0)/10)|0);
      var $200=(($197+$199)|0);
      var $201=$bmwidth;
      var $202=$segwidth;
      var $203=((($202<<1))|0);
      var $204=(((($203)|0)/3)|0);
      var $205=(($201-$204)|0);
      var $206=$bmheight;
      var $207=(((($206)|0)/2)|0);
      var $208=$segwidth;
      var $209=$12;
      var $210=$209 & 128;
      var $211=(($210)|0)!=0;
      var $212=$211 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $194, $200, $205, $207, $208, 2, $212);
      var $213=$tempbitmap;
      var $214=$segwidth;
      var $215=(($214)|0);
      var $216=$segwidth;
      var $217=(((($216)|0)/3)|0);
      var $218=(($215+$217)|0);
      var $219=$bmheight;
      var $220=(((($219)|0)/2)|0);
      var $221=$segwidth;
      var $222=(((($221)|0)/2)|0);
      var $223=(($220-$222)|0);
      var $224=$segwidth;
      var $225=(((($224)|0)/3)|0);
      var $226=(($223-$225)|0);
      var $227=$bmwidth;
      var $228=(((($227)|0)/2)|0);
      var $229=$segwidth;
      var $230=$12;
      var $231=$230 & 256;
      var $232=(($231)|0)!=0;
      var $233=$232 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $213, $218, $226, $228, $229, 0, $233);
      var $234=$tempbitmap;
      var $235=$bmheight;
      var $236=(((($235)|0)/2)|0);
      var $237=$segwidth;
      var $238=(((($237)|0)/2)|0);
      var $239=(($236+$238)|0);
      var $240=$segwidth;
      var $241=(((($240)|0)/3)|0);
      var $242=(($239+$241)|0);
      var $243=$bmheight;
      var $244=$segwidth;
      var $245=(($243-$244)|0);
      var $246=$segwidth;
      var $247=(((($246)|0)/3)|0);
      var $248=(($245-$247)|0);
      var $249=$bmwidth;
      var $250=(((($249)|0)/2)|0);
      var $251=$segwidth;
      var $252=$12;
      var $253=$252 & 512;
      var $254=(($253)|0)!=0;
      var $255=$254 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $234, $242, $248, $250, $251, 0, $255);
      var $256=$tempbitmap;
      var $257=$segwidth;
      var $258=(($257)|0);
      var $259=$segwidth;
      var $260=(((($259)|0)/5)|0);
      var $261=(($258+$260)|0);
      var $262=$bmwidth;
      var $263=(((($262)|0)/2)|0);
      var $264=$segwidth;
      var $265=(((($264)|0)/2)|0);
      var $266=(($263-$265)|0);
      var $267=$segwidth;
      var $268=(((($267)|0)/5)|0);
      var $269=(($266-$268)|0);
      var $270=$bmheight;
      var $271=(((($270)|0)/2)|0);
      var $272=$segwidth;
      var $273=(((($272)|0)/2)|0);
      var $274=(($271+$273)|0);
      var $275=$segwidth;
      var $276=(((($275)|0)/3)|0);
      var $277=(($274+$276)|0);
      var $278=$bmheight;
      var $279=$segwidth;
      var $280=(($278-$279)|0);
      var $281=$segwidth;
      var $282=(((($281)|0)/3)|0);
      var $283=(($280-$282)|0);
      var $284=$segwidth;
      var $285=$12;
      var $286=$285 & 1024;
      var $287=(($286)|0)!=0;
      var $288=$287 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $256, $261, $269, $277, $283, $284, $288);
      var $289=$tempbitmap;
      var $290=$segwidth;
      var $291=(($290)|0);
      var $292=$segwidth;
      var $293=(((($292)|0)/5)|0);
      var $294=(($291+$293)|0);
      var $295=$bmwidth;
      var $296=(((($295)|0)/2)|0);
      var $297=$segwidth;
      var $298=(((($297)|0)/2)|0);
      var $299=(($296-$298)|0);
      var $300=$segwidth;
      var $301=(((($300)|0)/5)|0);
      var $302=(($299-$301)|0);
      var $303=$segwidth;
      var $304=(($303)|0);
      var $305=$segwidth;
      var $306=(((($305)|0)/3)|0);
      var $307=(($304+$306)|0);
      var $308=$bmheight;
      var $309=(((($308)|0)/2)|0);
      var $310=$segwidth;
      var $311=(((($310)|0)/2)|0);
      var $312=(($309-$311)|0);
      var $313=$segwidth;
      var $314=(((($313)|0)/3)|0);
      var $315=(($312-$314)|0);
      var $316=$segwidth;
      var $317=$12;
      var $318=$317 & 2048;
      var $319=(($318)|0)!=0;
      var $320=$319 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $289, $294, $302, $307, $315, $316, $320);
      var $321=$tempbitmap;
      var $322=$bmwidth;
      var $323=(((($322)|0)/2)|0);
      var $324=$segwidth;
      var $325=(((($324)|0)/2)|0);
      var $326=(($323+$325)|0);
      var $327=$segwidth;
      var $328=(((($327)|0)/5)|0);
      var $329=(($326+$328)|0);
      var $330=$bmwidth;
      var $331=$segwidth;
      var $332=(($330-$331)|0);
      var $333=$segwidth;
      var $334=(((($333)|0)/5)|0);
      var $335=(($332-$334)|0);
      var $336=$segwidth;
      var $337=(($336)|0);
      var $338=$segwidth;
      var $339=(((($338)|0)/3)|0);
      var $340=(($337+$339)|0);
      var $341=$bmheight;
      var $342=(((($341)|0)/2)|0);
      var $343=$segwidth;
      var $344=(((($343)|0)/2)|0);
      var $345=(($342-$344)|0);
      var $346=$segwidth;
      var $347=(((($346)|0)/3)|0);
      var $348=(($345-$347)|0);
      var $349=$segwidth;
      var $350=$12;
      var $351=$350 & 4096;
      var $352=(($351)|0)!=0;
      var $353=$352 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $321, $329, $335, $340, $348, $349, $353);
      var $354=$tempbitmap;
      var $355=$bmwidth;
      var $356=(((($355)|0)/2)|0);
      var $357=$segwidth;
      var $358=(((($357)|0)/2)|0);
      var $359=(($356+$358)|0);
      var $360=$segwidth;
      var $361=(((($360)|0)/5)|0);
      var $362=(($359+$361)|0);
      var $363=$bmwidth;
      var $364=$segwidth;
      var $365=(($363-$364)|0);
      var $366=$segwidth;
      var $367=(((($366)|0)/5)|0);
      var $368=(($365-$367)|0);
      var $369=$bmheight;
      var $370=(((($369)|0)/2)|0);
      var $371=$segwidth;
      var $372=(((($371)|0)/2)|0);
      var $373=(($370+$372)|0);
      var $374=$segwidth;
      var $375=(((($374)|0)/3)|0);
      var $376=(($373+$375)|0);
      var $377=$bmheight;
      var $378=$segwidth;
      var $379=(($377-$378)|0);
      var $380=$segwidth;
      var $381=(((($380)|0)/3)|0);
      var $382=(($379-$381)|0);
      var $383=$segwidth;
      var $384=$12;
      var $385=$384 & 8192;
      var $386=(($385)|0)!=0;
      var $387=$386 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $354, $362, $368, $376, $382, $383, $387);
      var $388=$tempbitmap;
      __ZN14layout_element9component10apply_skewER8bitmap_ti($15, $388, 40);
      var $389=$tempbitmap;
      var $390=$bmwidth;
      var $391=$segwidth;
      var $392=(((($391)|0)/2)|0);
      var $393=(($390+$392)|0);
      var $394=$bmheight;
      var $395=$segwidth;
      var $396=(((($395)|0)/2)|0);
      var $397=(($394-$396)|0);
      var $398=$segwidth;
      var $399=$12;
      var $400=$399 & 16384;
      var $401=(($400)|0)!=0;
      var $402=$401 ? -1 : -14671840;
      __ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij($15, $389, $393, $397, $398, $402);
      var $403=$tempbitmap;
      var $404=$bmwidth;
      var $405=$segwidth;
      var $406=(((($405)|0)/2)|0);
      var $407=(($404-$406)|0);
      var $408=$bmwidth;
      var $409=$segwidth;
      var $410=(($408+$409)|0);
      var $411=$bmheight;
      var $412=$segwidth;
      var $413=(($411-$412)|0);
      var $414=$bmheight;
      var $415=(($414)|0);
      var $416=$segwidth;
      var $417=(($416)|0);
      var $418=$417*1.5;
      var $419=$415+$418;
      var $420=(($419)|0);
      var $421=$segwidth;
      var $422=(((($421)|0)/2)|0);
      var $423=$12;
      var $424=$423 & 32768;
      var $425=(($424)|0)!=0;
      var $426=$425 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $403, $407, $410, $413, $420, $422, $426);
      var $427=$10;
      var $428=$427;
      var $429=(($428+4)|0);
      var $430=HEAP32[(($429)>>2)];
      var $431=$10;
      var $432=$431;
      var $433=(($432+8)|0);
      var $434=HEAP32[(($433)>>2)];
      var $435=$10;
      var $436=$435;
      var $437=(($436+12)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=$10;
      var $440=$439;
      var $441=(($440+16)|0);
      var $442=HEAP32[(($441)>>2)];
      var $443=$tempbitmap;
      var $444=(($15+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($430, $434, $438, $442, $443, 0, $444);
      var $445=$tempbitmap;
      var $446=$445;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $446);
      STACKTOP = __stackBase__;
      return;
    case 9: // $447
      var $448=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $449=$448.f0;
      $13=$449;
      var $450=$448.f1;
      $14=$450;
      var $451=$1;
      var $452=$2;
      var $453=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1113;
      var $454=HEAP32[(($1)>>2)];
      var $455=(($454)|0)!=0;
      if ($455) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $456
      var $457=HEAP32[(($1)>>2)];
      var $458=HEAP32[(($2)>>2)];
      var $459=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($457, $458, $459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $460=$1;
      var $461=$2;
      var $462=$3;
      __label__ = 13; break;
    case 13: // $463
      __label__ = 14; break;
    case 14: // $464
      var $465=$13;
      var $466=$13;
      var $467=$14;
      var $468=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $466, tempValue);
      var $469=($468.f1 = $467, $468);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $470
      var $471=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component15draw_led14segscER8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij($this, $dest, $minx, $maxx, $midy, $width, $color) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$dest;
  $3=$minx;
  $4=$maxx;
  $5=$midy;
  $6=$width;
  $7=$color;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  var $14=$7;
  __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($8, $9, $10, $11, $12, $13, 3, $14);
  ;
  return;
}


function __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($this, $dest, $miny, $maxy, $midx, $width, $color) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$dest;
  $3=$miny;
  $4=$maxy;
  $5=$midx;
  $6=$width;
  $7=$color;
  var $8=$1;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  var $14=$7;
  __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($8, $9, $10, $11, $12, $13, 3, $14);
  ;
  return;
}


function __ZN14layout_element9component15draw_led16segscER8bitmap_tRK10_rectanglei($this, $dest, $bounds, $pattern) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $onpen;
      var $offpen;
      var $bmwidth;
      var $bmheight;
      var $segwidth;
      var $skewwidth;
      var $tempbitmap;
      var $13;
      var $14;
      $9=$this;
      $10=$dest;
      $11=$bounds;
      $12=$pattern;
      var $15=$9;
      $onpen=-1;
      $offpen=-14671840;
      $bmwidth=250;
      $bmheight=400;
      $segwidth=40;
      $skewwidth=40;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1339;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$bmwidth;
      var $56=$skewwidth;
      var $57=(($55+$56)|0);
      var $58=$bmheight;
      var $59=$segwidth;
      var $60=(($58+$59)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, $57, $60, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $61
      var $62=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $54);
      $tempbitmap=$62;
      var $63=$tempbitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($63, 0, -16777216);
      var $64=$tempbitmap;
      var $65=$segwidth;
      var $66=((($65<<1))|0);
      var $67=(((($66)|0)/3)|0);
      var $68=(($67)|0);
      var $69=$bmwidth;
      var $70=(((($69)|0)/2)|0);
      var $71=$segwidth;
      var $72=(((($71)|0)/10)|0);
      var $73=(($70-$72)|0);
      var $74=$segwidth;
      var $75=(((($74)|0)/2)|0);
      var $76=(($75)|0);
      var $77=$segwidth;
      var $78=$12;
      var $79=$78 & 1;
      var $80=(($79)|0)!=0;
      var $81=$80 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $64, $68, $73, $76, $77, 1, $81);
      var $82=$tempbitmap;
      var $83=$bmwidth;
      var $84=(((($83)|0)/2)|0);
      var $85=(($84)|0);
      var $86=$segwidth;
      var $87=(((($86)|0)/10)|0);
      var $88=(($85+$87)|0);
      var $89=$bmwidth;
      var $90=$segwidth;
      var $91=((($90<<1))|0);
      var $92=(((($91)|0)/3)|0);
      var $93=(($89-$92)|0);
      var $94=$segwidth;
      var $95=(((($94)|0)/2)|0);
      var $96=(($95)|0);
      var $97=$segwidth;
      var $98=$12;
      var $99=$98 & 2;
      var $100=(($99)|0)!=0;
      var $101=$100 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $82, $88, $93, $96, $97, 2, $101);
      var $102=$tempbitmap;
      var $103=$segwidth;
      var $104=((($103<<1))|0);
      var $105=(((($104)|0)/3)|0);
      var $106=(($105)|0);
      var $107=$bmheight;
      var $108=(((($107)|0)/2)|0);
      var $109=$segwidth;
      var $110=(((($109)|0)/3)|0);
      var $111=(($108-$110)|0);
      var $112=$bmwidth;
      var $113=$segwidth;
      var $114=(((($113)|0)/2)|0);
      var $115=(($112-$114)|0);
      var $116=$segwidth;
      var $117=$12;
      var $118=$117 & 4;
      var $119=(($118)|0)!=0;
      var $120=$119 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $102, $106, $111, $115, $116, $120);
      var $121=$tempbitmap;
      var $122=$bmheight;
      var $123=(((($122)|0)/2)|0);
      var $124=$segwidth;
      var $125=(((($124)|0)/3)|0);
      var $126=(($123+$125)|0);
      var $127=$bmheight;
      var $128=$segwidth;
      var $129=((($128<<1))|0);
      var $130=(((($129)|0)/3)|0);
      var $131=(($127-$130)|0);
      var $132=$bmwidth;
      var $133=$segwidth;
      var $134=(((($133)|0)/2)|0);
      var $135=(($132-$134)|0);
      var $136=$segwidth;
      var $137=$12;
      var $138=$137 & 8;
      var $139=(($138)|0)!=0;
      var $140=$139 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $121, $126, $131, $135, $136, $140);
      var $141=$tempbitmap;
      var $142=$bmwidth;
      var $143=(((($142)|0)/2)|0);
      var $144=(($143)|0);
      var $145=$segwidth;
      var $146=(((($145)|0)/10)|0);
      var $147=(($144+$146)|0);
      var $148=$bmwidth;
      var $149=$segwidth;
      var $150=((($149<<1))|0);
      var $151=(((($150)|0)/3)|0);
      var $152=(($148-$151)|0);
      var $153=$bmheight;
      var $154=$segwidth;
      var $155=(((($154)|0)/2)|0);
      var $156=(($153-$155)|0);
      var $157=$segwidth;
      var $158=$12;
      var $159=$158 & 16;
      var $160=(($159)|0)!=0;
      var $161=$160 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $141, $147, $152, $156, $157, 2, $161);
      var $162=$tempbitmap;
      var $163=$segwidth;
      var $164=((($163<<1))|0);
      var $165=(((($164)|0)/3)|0);
      var $166=(($165)|0);
      var $167=$bmwidth;
      var $168=(((($167)|0)/2)|0);
      var $169=$segwidth;
      var $170=(((($169)|0)/10)|0);
      var $171=(($168-$170)|0);
      var $172=$bmheight;
      var $173=$segwidth;
      var $174=(((($173)|0)/2)|0);
      var $175=(($172-$174)|0);
      var $176=$segwidth;
      var $177=$12;
      var $178=$177 & 32;
      var $179=(($178)|0)!=0;
      var $180=$179 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $162, $166, $171, $175, $176, 1, $180);
      var $181=$tempbitmap;
      var $182=$bmheight;
      var $183=(((($182)|0)/2)|0);
      var $184=$segwidth;
      var $185=(((($184)|0)/3)|0);
      var $186=(($183+$185)|0);
      var $187=$bmheight;
      var $188=$segwidth;
      var $189=((($188<<1))|0);
      var $190=(((($189)|0)/3)|0);
      var $191=(($187-$190)|0);
      var $192=$segwidth;
      var $193=(((($192)|0)/2)|0);
      var $194=(($193)|0);
      var $195=$segwidth;
      var $196=$12;
      var $197=$196 & 64;
      var $198=(($197)|0)!=0;
      var $199=$198 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $181, $186, $191, $194, $195, $199);
      var $200=$tempbitmap;
      var $201=$segwidth;
      var $202=((($201<<1))|0);
      var $203=(((($202)|0)/3)|0);
      var $204=(($203)|0);
      var $205=$bmheight;
      var $206=(((($205)|0)/2)|0);
      var $207=$segwidth;
      var $208=(((($207)|0)/3)|0);
      var $209=(($206-$208)|0);
      var $210=$segwidth;
      var $211=(((($210)|0)/2)|0);
      var $212=(($211)|0);
      var $213=$segwidth;
      var $214=$12;
      var $215=$214 & 128;
      var $216=(($215)|0)!=0;
      var $217=$216 ? -1 : -14671840;
      __ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij($15, $200, $204, $209, $212, $213, $217);
      var $218=$tempbitmap;
      var $219=$segwidth;
      var $220=((($219<<1))|0);
      var $221=(((($220)|0)/3)|0);
      var $222=(($221)|0);
      var $223=$bmwidth;
      var $224=(((($223)|0)/2)|0);
      var $225=$segwidth;
      var $226=(((($225)|0)/10)|0);
      var $227=(($224-$226)|0);
      var $228=$bmheight;
      var $229=(((($228)|0)/2)|0);
      var $230=$segwidth;
      var $231=$12;
      var $232=$231 & 256;
      var $233=(($232)|0)!=0;
      var $234=$233 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $218, $222, $227, $229, $230, 1, $234);
      var $235=$tempbitmap;
      var $236=$bmwidth;
      var $237=(((($236)|0)/2)|0);
      var $238=(($237)|0);
      var $239=$segwidth;
      var $240=(((($239)|0)/10)|0);
      var $241=(($238+$240)|0);
      var $242=$bmwidth;
      var $243=$segwidth;
      var $244=((($243<<1))|0);
      var $245=(((($244)|0)/3)|0);
      var $246=(($242-$245)|0);
      var $247=$bmheight;
      var $248=(((($247)|0)/2)|0);
      var $249=$segwidth;
      var $250=$12;
      var $251=$250 & 512;
      var $252=(($251)|0)!=0;
      var $253=$252 ? -1 : -14671840;
      __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($15, $235, $241, $246, $248, $249, 2, $253);
      var $254=$tempbitmap;
      var $255=$segwidth;
      var $256=(($255)|0);
      var $257=$segwidth;
      var $258=(((($257)|0)/3)|0);
      var $259=(($256+$258)|0);
      var $260=$bmheight;
      var $261=(((($260)|0)/2)|0);
      var $262=$segwidth;
      var $263=(((($262)|0)/2)|0);
      var $264=(($261-$263)|0);
      var $265=$segwidth;
      var $266=(((($265)|0)/3)|0);
      var $267=(($264-$266)|0);
      var $268=$bmwidth;
      var $269=(((($268)|0)/2)|0);
      var $270=$segwidth;
      var $271=$12;
      var $272=$271 & 1024;
      var $273=(($272)|0)!=0;
      var $274=$273 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $254, $259, $267, $269, $270, 0, $274);
      var $275=$tempbitmap;
      var $276=$bmheight;
      var $277=(((($276)|0)/2)|0);
      var $278=$segwidth;
      var $279=(((($278)|0)/2)|0);
      var $280=(($277+$279)|0);
      var $281=$segwidth;
      var $282=(((($281)|0)/3)|0);
      var $283=(($280+$282)|0);
      var $284=$bmheight;
      var $285=$segwidth;
      var $286=(($284-$285)|0);
      var $287=$segwidth;
      var $288=(((($287)|0)/3)|0);
      var $289=(($286-$288)|0);
      var $290=$bmwidth;
      var $291=(((($290)|0)/2)|0);
      var $292=$segwidth;
      var $293=$12;
      var $294=$293 & 2048;
      var $295=(($294)|0)!=0;
      var $296=$295 ? -1 : -14671840;
      __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($15, $275, $283, $289, $291, $292, 0, $296);
      var $297=$tempbitmap;
      var $298=$segwidth;
      var $299=(($298)|0);
      var $300=$segwidth;
      var $301=(((($300)|0)/5)|0);
      var $302=(($299+$301)|0);
      var $303=$bmwidth;
      var $304=(((($303)|0)/2)|0);
      var $305=$segwidth;
      var $306=(((($305)|0)/2)|0);
      var $307=(($304-$306)|0);
      var $308=$segwidth;
      var $309=(((($308)|0)/5)|0);
      var $310=(($307-$309)|0);
      var $311=$bmheight;
      var $312=(((($311)|0)/2)|0);
      var $313=$segwidth;
      var $314=(((($313)|0)/2)|0);
      var $315=(($312+$314)|0);
      var $316=$segwidth;
      var $317=(((($316)|0)/3)|0);
      var $318=(($315+$317)|0);
      var $319=$bmheight;
      var $320=$segwidth;
      var $321=(($319-$320)|0);
      var $322=$segwidth;
      var $323=(((($322)|0)/3)|0);
      var $324=(($321-$323)|0);
      var $325=$segwidth;
      var $326=$12;
      var $327=$326 & 4096;
      var $328=(($327)|0)!=0;
      var $329=$328 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $297, $302, $310, $318, $324, $325, $329);
      var $330=$tempbitmap;
      var $331=$segwidth;
      var $332=(($331)|0);
      var $333=$segwidth;
      var $334=(((($333)|0)/5)|0);
      var $335=(($332+$334)|0);
      var $336=$bmwidth;
      var $337=(((($336)|0)/2)|0);
      var $338=$segwidth;
      var $339=(((($338)|0)/2)|0);
      var $340=(($337-$339)|0);
      var $341=$segwidth;
      var $342=(((($341)|0)/5)|0);
      var $343=(($340-$342)|0);
      var $344=$segwidth;
      var $345=(($344)|0);
      var $346=$segwidth;
      var $347=(((($346)|0)/3)|0);
      var $348=(($345+$347)|0);
      var $349=$bmheight;
      var $350=(((($349)|0)/2)|0);
      var $351=$segwidth;
      var $352=(((($351)|0)/2)|0);
      var $353=(($350-$352)|0);
      var $354=$segwidth;
      var $355=(((($354)|0)/3)|0);
      var $356=(($353-$355)|0);
      var $357=$segwidth;
      var $358=$12;
      var $359=$358 & 8192;
      var $360=(($359)|0)!=0;
      var $361=$360 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $330, $335, $343, $348, $356, $357, $361);
      var $362=$tempbitmap;
      var $363=$bmwidth;
      var $364=(((($363)|0)/2)|0);
      var $365=$segwidth;
      var $366=(((($365)|0)/2)|0);
      var $367=(($364+$366)|0);
      var $368=$segwidth;
      var $369=(((($368)|0)/5)|0);
      var $370=(($367+$369)|0);
      var $371=$bmwidth;
      var $372=$segwidth;
      var $373=(($371-$372)|0);
      var $374=$segwidth;
      var $375=(((($374)|0)/5)|0);
      var $376=(($373-$375)|0);
      var $377=$segwidth;
      var $378=(($377)|0);
      var $379=$segwidth;
      var $380=(((($379)|0)/3)|0);
      var $381=(($378+$380)|0);
      var $382=$bmheight;
      var $383=(((($382)|0)/2)|0);
      var $384=$segwidth;
      var $385=(((($384)|0)/2)|0);
      var $386=(($383-$385)|0);
      var $387=$segwidth;
      var $388=(((($387)|0)/3)|0);
      var $389=(($386-$388)|0);
      var $390=$segwidth;
      var $391=$12;
      var $392=$391 & 16384;
      var $393=(($392)|0)!=0;
      var $394=$393 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $362, $370, $376, $381, $389, $390, $394);
      var $395=$tempbitmap;
      var $396=$bmwidth;
      var $397=(((($396)|0)/2)|0);
      var $398=$segwidth;
      var $399=(((($398)|0)/2)|0);
      var $400=(($397+$399)|0);
      var $401=$segwidth;
      var $402=(((($401)|0)/5)|0);
      var $403=(($400+$402)|0);
      var $404=$bmwidth;
      var $405=$segwidth;
      var $406=(($404-$405)|0);
      var $407=$segwidth;
      var $408=(((($407)|0)/5)|0);
      var $409=(($406-$408)|0);
      var $410=$bmheight;
      var $411=(((($410)|0)/2)|0);
      var $412=$segwidth;
      var $413=(((($412)|0)/2)|0);
      var $414=(($411+$413)|0);
      var $415=$segwidth;
      var $416=(((($415)|0)/3)|0);
      var $417=(($414+$416)|0);
      var $418=$bmheight;
      var $419=$segwidth;
      var $420=(($418-$419)|0);
      var $421=$segwidth;
      var $422=(((($421)|0)/3)|0);
      var $423=(($420-$422)|0);
      var $424=$segwidth;
      var $425=$12;
      var $426=$425 & 32768;
      var $427=(($426)|0)!=0;
      var $428=$427 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($15, $395, $403, $409, $417, $423, $424, $428);
      var $429=$tempbitmap;
      var $430=$bmwidth;
      var $431=$segwidth;
      var $432=(((($431)|0)/2)|0);
      var $433=(($430+$432)|0);
      var $434=$bmheight;
      var $435=$segwidth;
      var $436=(((($435)|0)/2)|0);
      var $437=(($434-$436)|0);
      var $438=$segwidth;
      var $439=$12;
      var $440=$439 & 65536;
      var $441=(($440)|0)!=0;
      var $442=$441 ? -1 : -14671840;
      __ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij($15, $429, $433, $437, $438, $442);
      var $443=$tempbitmap;
      var $444=$bmwidth;
      var $445=$segwidth;
      var $446=(((($445)|0)/2)|0);
      var $447=(($444-$446)|0);
      var $448=$bmwidth;
      var $449=$segwidth;
      var $450=(($448+$449)|0);
      var $451=$bmheight;
      var $452=$segwidth;
      var $453=(($451-$452)|0);
      var $454=$bmheight;
      var $455=(($454)|0);
      var $456=$segwidth;
      var $457=(($456)|0);
      var $458=$457*1.5;
      var $459=$455+$458;
      var $460=(($459)|0);
      var $461=$segwidth;
      var $462=(((($461)|0)/2)|0);
      var $463=$12;
      var $464=$463 & 131072;
      var $465=(($464)|0)!=0;
      var $466=$465 ? -1 : -14671840;
      __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($15, $443, $447, $450, $453, $460, $462, $466);
      var $467=$tempbitmap;
      __ZN14layout_element9component10apply_skewER8bitmap_ti($15, $467, 40);
      var $468=$10;
      var $469=$468;
      var $470=(($469+4)|0);
      var $471=HEAP32[(($470)>>2)];
      var $472=$10;
      var $473=$472;
      var $474=(($473+8)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=$10;
      var $477=$476;
      var $478=(($477+12)|0);
      var $479=HEAP32[(($478)>>2)];
      var $480=$10;
      var $481=$480;
      var $482=(($481+16)|0);
      var $483=HEAP32[(($482)>>2)];
      var $484=$tempbitmap;
      var $485=(($15+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($471, $475, $479, $483, $484, 0, $485);
      var $486=$tempbitmap;
      var $487=$486;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $487);
      STACKTOP = __stackBase__;
      return;
    case 9: // $488
      var $489=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $490=$489.f0;
      $13=$490;
      var $491=$489.f1;
      $14=$491;
      var $492=$1;
      var $493=$2;
      var $494=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1339;
      var $495=HEAP32[(($1)>>2)];
      var $496=(($495)|0)!=0;
      if ($496) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $497
      var $498=HEAP32[(($1)>>2)];
      var $499=HEAP32[(($2)>>2)];
      var $500=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($498, $499, $500) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $501=$1;
      var $502=$2;
      var $503=$3;
      __label__ = 13; break;
    case 13: // $504
      __label__ = 14; break;
    case 14: // $505
      var $506=$13;
      var $507=$13;
      var $508=$14;
      var $509=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $507, tempValue);
      var $510=($509.f1 = $508, $509);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $511
      var $512=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component15draw_led16segscER8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9component14draw_dotmatrixER8bitmap_tRK10_rectanglei($this, $dest, $bounds, $pattern) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $onpen;
      var $offpen;
      var $bmwidth;
      var $bmheight;
      var $dotwidth;
      var $tempbitmap;
      var $13;
      var $14;
      var $i;
      $9=$this;
      $10=$dest;
      $11=$bounds;
      $12=$pattern;
      var $15=$9;
      $onpen=-1;
      $offpen=-14671840;
      $bmwidth=2000;
      $bmheight=300;
      $dotwidth=250;
      var $16=$4;
      var $17=$5;
      var $18=$6;
      var $19=$result_i;
      var $20=$7;
      var $21=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1461;
      var $22=HEAP32[(($4)>>2)];
      var $23=HEAP32[(($5)>>2)];
      var $24=HEAP32[(($6)>>2)];
      var $25=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($22, $23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      HEAP32[(($result_i)>>2)]=$25;
      var $27=HEAP32[(($result_i)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $29
      var $30=___cxa_allocate_exception(4);
      var $31=$30;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($31);
      (function() { try { __THREW__ = false; return ___cxa_throw($30, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      HEAP32[(($7)>>2)]=$34;
      var $35=$33.f1;
      HEAP32[(($8)>>2)]=$35;
      var $36=HEAP32[(($8)>>2)];
      var $37=(($36)|0) < 0;
      if ($37) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $38
      var $39=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($39);
      throw "Reached an unreachable!"
    case 5: // $40
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($8)>>2)];
      var $44=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $42, tempValue);
      var $45=($44.f1 = $43, $44);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $46
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $47=HEAP32[(($result_i)>>2)];
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      var $54=$47;
      var $55=$bmwidth;
      var $56=$bmheight;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($54, $55, $56, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $57
      var $58=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $54);
      $tempbitmap=$58;
      var $59=$tempbitmap;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($59, 0, -16777216);
      $i=0;
      __label__ = 9; break;
    case 9: // $60
      var $61=$i;
      var $62=(($61)|0) < 8;
      if ($62) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $63
      var $64=$tempbitmap;
      var $65=$dotwidth;
      var $66=(((($65)|0)/2)|0);
      var $67=$i;
      var $68=$dotwidth;
      var $69=(($67*$68)|0);
      var $70=(($66+$69)|0);
      var $71=$bmheight;
      var $72=(((($71)|0)/2)|0);
      var $73=$dotwidth;
      var $74=$12;
      var $75=$i;
      var $76=1 << $75;
      var $77=$74 & $76;
      var $78=(($77)|0)!=0;
      var $79=$78 ? -1 : -14671840;
      __ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij($15, $64, $70, $72, $73, $79);
      __label__ = 11; break;
    case 11: // $80
      var $81=$i;
      var $82=(($81+1)|0);
      $i=$82;
      __label__ = 9; break;
    case 12: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $13=$85;
      var $86=$84.f1;
      $14=$86;
      var $87=$1;
      var $88=$2;
      var $89=$3;
      HEAP32[(($1)>>2)]=$47;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1461;
      var $90=HEAP32[(($1)>>2)];
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $92
      var $93=HEAP32[(($1)>>2)];
      var $94=HEAP32[(($2)>>2)];
      var $95=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($93, $94, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKci_exit
      var $96=$1;
      var $97=$2;
      var $98=$3;
      __label__ = 16; break;
    case 16: // $99
      __label__ = 18; break;
    case 17: // $100
      var $101=$10;
      var $102=$101;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$10;
      var $106=$105;
      var $107=(($106+8)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$10;
      var $110=$109;
      var $111=(($110+12)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$10;
      var $114=$113;
      var $115=(($114+16)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$tempbitmap;
      var $118=(($15+28)|0);
      __Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color($104, $108, $112, $116, $117, 0, $118);
      var $119=$tempbitmap;
      var $120=$119;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $120);
      STACKTOP = __stackBase__;
      return;
    case 18: // $121
      var $122=$13;
      var $123=$13;
      var $124=$14;
      var $125=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $123, tempValue);
      var $126=($125.f1 = $124, $125);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component14draw_dotmatrixER8bitmap_tRK10_rectanglei["X"]=1;

function __ZN14layout_element9component10apply_skewER8bitmap_ti($this, $dest, $skewwidth) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $y;
      var $destrow;
      var $offs;
      var $x;
      var $x1;
      $1=$this;
      $2=$dest;
      $3=$skewwidth;
      var $4=$1;
      $y=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$y;
      var $7=$2;
      var $8=$7;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($6)|0) < (($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $12
      var $13=$2;
      var $14=$13;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16;
      var $18=$y;
      var $19=$2;
      var $20=$19;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($18*$22)|0);
      var $24=(($17+($23<<2))|0);
      var $25=(($24)|0);
      $destrow=$25;
      var $26=$3;
      var $27=$2;
      var $28=$27;
      var $29=(($28+16)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$y;
      var $32=(($30-$31)|0);
      var $33=(($26*$32)|0);
      var $34=$2;
      var $35=$34;
      var $36=(($35+16)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(((($33)|0)/(($37)|0))|0);
      $offs=$38;
      var $39=$2;
      var $40=$39;
      var $41=(($40+12)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$3;
      var $44=(($42-$43)|0);
      var $45=(($44-1)|0);
      $x=$45;
      __label__ = 3; break;
    case 3: // $46
      var $47=$x;
      var $48=(($47)|0) >= 0;
      if ($48) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $49
      var $50=$x;
      var $51=$destrow;
      var $52=(($51+($50<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$x;
      var $55=$offs;
      var $56=(($54+$55)|0);
      var $57=$destrow;
      var $58=(($57+($56<<2))|0);
      HEAP32[(($58)>>2)]=$53;
      __label__ = 5; break;
    case 5: // $59
      var $60=$x;
      var $61=(($60-1)|0);
      $x=$61;
      __label__ = 3; break;
    case 6: // $62
      $x1=0;
      __label__ = 7; break;
    case 7: // $63
      var $64=$x1;
      var $65=$offs;
      var $66=(($64)|0) < (($65)|0);
      if ($66) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $67
      var $68=$x1;
      var $69=$destrow;
      var $70=(($69+($68<<2))|0);
      HEAP32[(($70)>>2)]=0;
      __label__ = 9; break;
    case 9: // $71
      var $72=$x1;
      var $73=(($72+1)|0);
      $x1=$73;
      __label__ = 7; break;
    case 10: // $74
      __label__ = 11; break;
    case 11: // $75
      var $76=$y;
      var $77=(($76+1)|0);
      $y=$77;
      __label__ = 1; break;
    case 12: // $78
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component10apply_skewER8bitmap_ti["X"]=1;

function __ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij($this, $dest, $minx, $maxx, $midy, $width, $caps, $color) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $y;
      var $d0;
      var $d1;
      var $ty;
      var $x;
      $1=$this;
      $2=$dest;
      $3=$minx;
      $4=$maxx;
      $5=$midy;
      $6=$width;
      $7=$caps;
      $8=$color;
      var $9=$1;
      $y=0;
      __label__ = 1; break;
    case 1: // $10
      var $11=$y;
      var $12=$6;
      var $13=(((($12)|0)/2)|0);
      var $14=(($11)|0) < (($13)|0);
      if ($14) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $15
      var $16=$2;
      var $17=$16;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      var $21=$5;
      var $22=$y;
      var $23=(($21-$22)|0);
      var $24=$2;
      var $25=$24;
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($23*$27)|0);
      var $29=(($20+($28<<2))|0);
      var $30=(($29)|0);
      $d0=$30;
      var $31=$2;
      var $32=$31;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34;
      var $36=$5;
      var $37=$y;
      var $38=(($36+$37)|0);
      var $39=$2;
      var $40=$39;
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($38*$42)|0);
      var $44=(($35+($43<<2))|0);
      var $45=(($44)|0);
      $d1=$45;
      var $46=$y;
      var $47=$6;
      var $48=(((($47)|0)/8)|0);
      var $49=(($46)|0) < (($48)|0);
      if ($49) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $50
      var $51=$6;
      var $52=(((($51)|0)/8)|0);
      var $56 = $52;__label__ = 5; break;
    case 4: // $53
      var $54=$y;
      var $56 = $54;__label__ = 5; break;
    case 5: // $55
      var $56;
      $ty=$56;
      var $57=$3;
      var $58=$7;
      var $59=$58 & 1;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $61
      var $62=$ty;
      var $65 = $62;__label__ = 8; break;
    case 7: // $63
      var $65 = 0;__label__ = 8; break;
    case 8: // $64
      var $65;
      var $66=(($57+$65)|0);
      $x=$66;
      __label__ = 9; break;
    case 9: // $67
      var $68=$x;
      var $69=$4;
      var $70=$7;
      var $71=$70 & 2;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$ty;
      var $77 = $74;__label__ = 12; break;
    case 11: // $75
      var $77 = 0;__label__ = 12; break;
    case 12: // $76
      var $77;
      var $78=(($69-$77)|0);
      var $79=(($68)|0) < (($78)|0);
      if ($79) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $80
      var $81=$8;
      var $82=$x;
      var $83=$d1;
      var $84=(($83+($82<<2))|0);
      HEAP32[(($84)>>2)]=$81;
      var $85=$x;
      var $86=$d0;
      var $87=(($86+($85<<2))|0);
      HEAP32[(($87)>>2)]=$81;
      __label__ = 14; break;
    case 14: // $88
      var $89=$x;
      var $90=(($89+1)|0);
      $x=$90;
      __label__ = 9; break;
    case 15: // $91
      __label__ = 16; break;
    case 16: // $92
      var $93=$y;
      var $94=(($93+1)|0);
      $y=$94;
      __label__ = 1; break;
    case 17: // $95
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij["X"]=1;

function __ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij($this, $dest, $miny, $maxy, $midx, $width, $caps, $color) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $x;
      var $d0;
      var $d1;
      var $tx;
      var $y;
      $1=$this;
      $2=$dest;
      $3=$miny;
      $4=$maxy;
      $5=$midx;
      $6=$width;
      $7=$caps;
      $8=$color;
      var $9=$1;
      $x=0;
      __label__ = 1; break;
    case 1: // $10
      var $11=$x;
      var $12=$6;
      var $13=(((($12)|0)/2)|0);
      var $14=(($11)|0) < (($13)|0);
      if ($14) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $15
      var $16=$2;
      var $17=$16;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      var $21=$2;
      var $22=$21;
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=((0)|0);
      var $26=(($20+($25<<2))|0);
      var $27=$5;
      var $28=$x;
      var $29=(($27-$28)|0);
      var $30=(($26+($29<<2))|0);
      $d0=$30;
      var $31=$2;
      var $32=$31;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34;
      var $36=$2;
      var $37=$36;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=((0)|0);
      var $41=(($35+($40<<2))|0);
      var $42=$5;
      var $43=$x;
      var $44=(($42+$43)|0);
      var $45=(($41+($44<<2))|0);
      $d1=$45;
      var $46=$x;
      var $47=$6;
      var $48=(((($47)|0)/8)|0);
      var $49=(($46)|0) < (($48)|0);
      if ($49) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $50
      var $51=$6;
      var $52=(((($51)|0)/8)|0);
      var $56 = $52;__label__ = 5; break;
    case 4: // $53
      var $54=$x;
      var $56 = $54;__label__ = 5; break;
    case 5: // $55
      var $56;
      $tx=$56;
      var $57=$3;
      var $58=$7;
      var $59=$58 & 1;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $61
      var $62=$tx;
      var $65 = $62;__label__ = 8; break;
    case 7: // $63
      var $65 = 0;__label__ = 8; break;
    case 8: // $64
      var $65;
      var $66=(($57+$65)|0);
      $y=$66;
      __label__ = 9; break;
    case 9: // $67
      var $68=$y;
      var $69=$4;
      var $70=$7;
      var $71=$70 & 2;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$tx;
      var $77 = $74;__label__ = 12; break;
    case 11: // $75
      var $77 = 0;__label__ = 12; break;
    case 12: // $76
      var $77;
      var $78=(($69-$77)|0);
      var $79=(($68)|0) < (($78)|0);
      if ($79) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $80
      var $81=$8;
      var $82=$y;
      var $83=$2;
      var $84=$83;
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($82*$86)|0);
      var $88=$d1;
      var $89=(($88+($87<<2))|0);
      HEAP32[(($89)>>2)]=$81;
      var $90=$y;
      var $91=$2;
      var $92=$91;
      var $93=(($92+8)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($90*$94)|0);
      var $96=$d0;
      var $97=(($96+($95<<2))|0);
      HEAP32[(($97)>>2)]=$81;
      __label__ = 14; break;
    case 14: // $98
      var $99=$y;
      var $100=(($99+1)|0);
      $y=$100;
      __label__ = 9; break;
    case 15: // $101
      __label__ = 16; break;
    case 16: // $102
      var $103=$x;
      var $104=(($103+1)|0);
      $x=$104;
      __label__ = 1; break;
    case 17: // $105
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij["X"]=1;

function __ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij($this, $dest, $minx, $maxx, $miny, $maxy, $width, $color) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $ratio;
      var $x;
      var $d;
      var $step;
      var $y;
      $1=$this;
      $2=$dest;
      $3=$minx;
      $4=$maxx;
      $5=$miny;
      $6=$maxy;
      $7=$width;
      $8=$color;
      var $9=$1;
      var $10=$7;
      var $11=(($10)|0);
      var $12=$11*1.5;
      var $13=(($12)|0);
      $7=$13;
      var $14=$6;
      var $15=$5;
      var $16=(($14-$15)|0);
      var $17=$7;
      var $18=(($16-$17)|0);
      var $19=(($18)|0);
      var $20=$4;
      var $21=$3;
      var $22=(($20-$21)|0);
      var $23=(($22)|0);
      var $24=$19/$23;
      $ratio=$24;
      var $25=$3;
      $x=$25;
      __label__ = 1; break;
    case 1: // $26
      var $27=$x;
      var $28=$4;
      var $29=(($27)|0) < (($28)|0);
      if ($29) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $30
      var $31=$x;
      var $32=(($31)|0) >= 0;
      if ($32) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $33
      var $34=$x;
      var $35=$2;
      var $36=$35;
      var $37=(($36+12)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($34)|0) < (($38)|0);
      if ($39) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $40
      var $41=$2;
      var $42=$41;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44;
      var $46=$2;
      var $47=$46;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=((0)|0);
      var $51=(($45+($50<<2))|0);
      var $52=$x;
      var $53=(($51+($52<<2))|0);
      $d=$53;
      var $54=$x;
      var $55=$3;
      var $56=(($54-$55)|0);
      var $57=(($56)|0);
      var $58=$ratio;
      var $59=$57*$58;
      var $60=(($59)|0);
      $step=$60;
      var $61=$6;
      var $62=$7;
      var $63=(($61-$62)|0);
      var $64=$step;
      var $65=(($63-$64)|0);
      $y=$65;
      __label__ = 5; break;
    case 5: // $66
      var $67=$y;
      var $68=$6;
      var $69=$step;
      var $70=(($68-$69)|0);
      var $71=(($67)|0) < (($70)|0);
      if ($71) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $72
      var $73=$y;
      var $74=(($73)|0) >= 0;
      if ($74) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $75
      var $76=$y;
      var $77=$2;
      var $78=$77;
      var $79=(($78+16)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($76)|0) < (($80)|0);
      if ($81) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $82
      var $83=$8;
      var $84=$y;
      var $85=$2;
      var $86=$85;
      var $87=(($86+8)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($84*$88)|0);
      var $90=$d;
      var $91=(($90+($89<<2))|0);
      HEAP32[(($91)>>2)]=$83;
      __label__ = 9; break;
    case 9: // $92
      __label__ = 10; break;
    case 10: // $93
      var $94=$y;
      var $95=(($94+1)|0);
      $y=$95;
      __label__ = 5; break;
    case 11: // $96
      __label__ = 12; break;
    case 12: // $97
      __label__ = 13; break;
    case 13: // $98
      var $99=$x;
      var $100=(($99+1)|0);
      $x=$100;
      __label__ = 1; break;
    case 14: // $101
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij["X"]=1;

function __ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij($this, $dest, $minx, $maxx, $miny, $maxy, $width, $color) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $ratio;
      var $x;
      var $d;
      var $step;
      var $y;
      $1=$this;
      $2=$dest;
      $3=$minx;
      $4=$maxx;
      $5=$miny;
      $6=$maxy;
      $7=$width;
      $8=$color;
      var $9=$1;
      var $10=$7;
      var $11=(($10)|0);
      var $12=$11*1.5;
      var $13=(($12)|0);
      $7=$13;
      var $14=$6;
      var $15=$5;
      var $16=(($14-$15)|0);
      var $17=$7;
      var $18=(($16-$17)|0);
      var $19=(($18)|0);
      var $20=$4;
      var $21=$3;
      var $22=(($20-$21)|0);
      var $23=(($22)|0);
      var $24=$19/$23;
      $ratio=$24;
      var $25=$3;
      $x=$25;
      __label__ = 1; break;
    case 1: // $26
      var $27=$x;
      var $28=$4;
      var $29=(($27)|0) < (($28)|0);
      if ($29) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $30
      var $31=$x;
      var $32=(($31)|0) >= 0;
      if ($32) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $33
      var $34=$x;
      var $35=$2;
      var $36=$35;
      var $37=(($36+12)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($34)|0) < (($38)|0);
      if ($39) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $40
      var $41=$2;
      var $42=$41;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44;
      var $46=$2;
      var $47=$46;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=((0)|0);
      var $51=(($45+($50<<2))|0);
      var $52=$x;
      var $53=(($51+($52<<2))|0);
      $d=$53;
      var $54=$x;
      var $55=$3;
      var $56=(($54-$55)|0);
      var $57=(($56)|0);
      var $58=$ratio;
      var $59=$57*$58;
      var $60=(($59)|0);
      $step=$60;
      var $61=$5;
      var $62=$step;
      var $63=(($61+$62)|0);
      $y=$63;
      __label__ = 5; break;
    case 5: // $64
      var $65=$y;
      var $66=$5;
      var $67=$step;
      var $68=(($66+$67)|0);
      var $69=$7;
      var $70=(($68+$69)|0);
      var $71=(($65)|0) < (($70)|0);
      if ($71) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $72
      var $73=$y;
      var $74=(($73)|0) >= 0;
      if ($74) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $75
      var $76=$y;
      var $77=$2;
      var $78=$77;
      var $79=(($78+16)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($76)|0) < (($80)|0);
      if ($81) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $82
      var $83=$8;
      var $84=$y;
      var $85=$2;
      var $86=$85;
      var $87=(($86+8)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($84*$88)|0);
      var $90=$d;
      var $91=(($90+($89<<2))|0);
      HEAP32[(($91)>>2)]=$83;
      __label__ = 9; break;
    case 9: // $92
      __label__ = 10; break;
    case 10: // $93
      var $94=$y;
      var $95=(($94+1)|0);
      $y=$95;
      __label__ = 5; break;
    case 11: // $96
      __label__ = 12; break;
    case 12: // $97
      __label__ = 13; break;
    case 13: // $98
      var $99=$x;
      var $100=(($99+1)|0);
      $x=$100;
      __label__ = 1; break;
    case 14: // $101
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij["X"]=1;

function __ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij($this, $dest, $midx, $midy, $width, $color) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $ooradius2;
      var $y;
      var $d0;
      var $d1;
      var $xval;
      var $left;
      var $right;
      var $x;
      $1=$this;
      $2=$dest;
      $3=$midx;
      $4=$midy;
      $5=$width;
      $6=$color;
      var $7=$1;
      var $8=$5;
      var $9=(((($8)|0)/2)|0);
      $5=$9;
      var $10=$5;
      var $11=$5;
      var $12=(($10*$11)|0);
      var $13=(($12)|0);
      var $14=1/$13;
      $ooradius2=$14;
      $y=0;
      __label__ = 1; break;
    case 1: // $15
      var $16=$y;
      var $17=$5;
      var $18=(($16)>>>0) <= (($17)>>>0);
      if ($18) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $19
      var $20=$2;
      var $21=$20;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      var $25=$4;
      var $26=$y;
      var $27=(($25-$26)|0);
      var $28=$2;
      var $29=$28;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($27*$31)|0);
      var $33=(($24+($32<<2))|0);
      var $34=(($33)|0);
      $d0=$34;
      var $35=$2;
      var $36=$35;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38;
      var $40=$4;
      var $41=$y;
      var $42=(($40+$41)|0);
      var $43=$2;
      var $44=$43;
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($42*$46)|0);
      var $48=(($39+($47<<2))|0);
      var $49=(($48)|0);
      $d1=$49;
      var $50=$5;
      var $51=(($50)|0);
      var $52=$y;
      var $53=$y;
      var $54=(($52*$53)|0);
      var $55=(($54)>>>0);
      var $56=$ooradius2;
      var $57=$55*$56;
      var $58=1-$57;
      var $59=$58;
      var $60=_sqrt($59);
      var $61=$51*$60;
      var $62=$61;
      $xval=$62;
      var $63=$3;
      var $64=$xval;
      var $65=$64+0.5;
      var $66=(($65)|0);
      var $67=(($63-$66)|0);
      $left=$67;
      var $68=$3;
      var $69=$xval;
      var $70=$69+0.5;
      var $71=(($70)|0);
      var $72=(($68+$71)|0);
      $right=$72;
      var $73=$left;
      $x=$73;
      __label__ = 3; break;
    case 3: // $74
      var $75=$x;
      var $76=$right;
      var $77=(($75)>>>0) < (($76)>>>0);
      if ($77) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $78
      var $79=$6;
      var $80=$x;
      var $81=$d1;
      var $82=(($81+($80<<2))|0);
      HEAP32[(($82)>>2)]=$79;
      var $83=$x;
      var $84=$d0;
      var $85=(($84+($83<<2))|0);
      HEAP32[(($85)>>2)]=$79;
      __label__ = 5; break;
    case 5: // $86
      var $87=$x;
      var $88=(($87+1)|0);
      $x=$88;
      __label__ = 3; break;
    case 6: // $89
      __label__ = 7; break;
    case 7: // $90
      var $91=$y;
      var $92=(($91+1)|0);
      $y=$92;
      __label__ = 1; break;
    case 8: // $93
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij["X"]=1;

function __ZN11layout_viewC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE($this, $machine, $viewnode, $elemlist) {
  var __stackBase__  = STACKTOP; STACKTOP += 220; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i35=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i28=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i21=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25=__stackBase__+108;
      var $26=__stackBase__+112;
      var $27=__stackBase__+116;
      var $28=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $result_i14=__stackBase__+132;
      var $31=__stackBase__+136;
      var $32=__stackBase__+140;
      var $33=__stackBase__+144;
      var $34=__stackBase__+148;
      var $35=__stackBase__+152;
      var $36=__stackBase__+156;
      var $37=__stackBase__+160;
      var $38=__stackBase__+164;
      var $result_i7=__stackBase__+168;
      var $39=__stackBase__+172;
      var $40=__stackBase__+176;
      var $41=__stackBase__+180;
      var $42=__stackBase__+184;
      var $43=__stackBase__+188;
      var $44=__stackBase__+192;
      var $45=__stackBase__+196;
      var $46=__stackBase__+200;
      var $result_i=__stackBase__+204;
      var $47=__stackBase__+208;
      var $48=__stackBase__+212;
      var $49;
      var $50;
      var $51;
      var $52;
      var $53;
      var $54;
      var $boundsnode;
      var $itemnode;
      var $itemnode1;
      var $itemnode2;
      var $itemnode3;
      var $itemnode4;
      var $itemnode5;
      var $55=__stackBase__+216;
      $49=$this;
      $50=$machine;
      $51=$viewnode;
      $52=$elemlist;
      var $56=$49;
      var $57=$56;
      HEAP32[(($57)>>2)]=((__ZTV11layout_view+8)|0);
      var $58=(($56+4)|0);
      HEAP32[(($58)>>2)]=0;
      var $59=(($56+8)|0);
      __ZN7astringC1Ev($59);
      var $60=(($56+72)|0);
      HEAPF32[(($60)>>2)]=1;
      var $61=(($56+76)|0);
      HEAPF32[(($61)>>2)]=1;
      var $62=(($56+80)|0);
      var $63=$50;
      var $64=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 21; break; };
    case 1: // $65
      (function() { try { __THREW__ = false; return __ZN18render_screen_listC1ER13resource_pool($62, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $66
      var $67=(($56+100)|0);
      var $68=(($56+116)|0);
      var $69=(($56+132)|0);
      var $70=(($56+156)|0);
      var $71=$50;
      var $72=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 22; break; };
    case 3: // $73
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($70, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 22; break; }
    case 4: // $74
      var $75=(($56+176)|0);
      var $76=$50;
      var $77=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 23; break; };
    case 5: // $78
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($75, $77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 23; break; }
    case 6: // $79
      var $80=(($56+196)|0);
      var $81=$50;
      var $82=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 24; break; };
    case 7: // $83
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($80, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 24; break; }
    case 8: // $84
      var $85=(($56+216)|0);
      var $86=$50;
      var $87=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 25; break; };
    case 9: // $88
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($85, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 25; break; }
    case 10: // $89
      var $90=(($56+236)|0);
      var $91=$50;
      var $92=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 26; break; };
    case 11: // $93
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($90, $92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 26; break; }
    case 12: // $94
      var $95=(($56+256)|0);
      var $96=$50;
      var $97=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 27; break; };
    case 13: // $98
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($95, $97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 27; break; }
    case 14: // $99
      var $100=(($56+8)|0);
      var $101=$50;
      var $102=$51;
      var $103=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($101, $102, ((STRING_TABLE.__str154630)|0), ((__str244639)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 28; break; };
    case 15: // $104
      var $105=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($100, $103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 28; break; };
    case 16: // $106
      var $107=$51;
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($109, ((STRING_TABLE.__str204635)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 28; break; };
    case 17: // $111
      $boundsnode=$110;
      var $112=(($56+132)|0);
      var $113=(($112+12)|0);
      HEAPF32[(($113)>>2)]=0;
      var $114=(($56+132)|0);
      var $115=(($114+8)|0);
      HEAPF32[(($115)>>2)]=0;
      var $116=(($56+132)|0);
      var $117=(($116+4)|0);
      HEAPF32[(($117)>>2)]=0;
      var $118=(($56+132)|0);
      var $119=(($118)|0);
      HEAPF32[(($119)>>2)]=0;
      var $120=$boundsnode;
      var $121=(($120)|0)!=0;
      if ($121) { __label__ = 18; break; } else { __label__ = 35; break; }
    case 18: // $122
      var $123=$50;
      var $124=$boundsnode;
      var $125=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($124, ((STRING_TABLE.__str204635)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 28; break; };
    case 19: // $126
      var $127=(($56+132)|0);
      (function() { try { __THREW__ = false; return __Z12parse_boundsR15running_machineP14_xml_data_nodeR13render_bounds($123, $125, $127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 28; break; }
    case 20: // $128
      __label__ = 35; break;
    case 21: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      $53=$131;
      var $132=$130.f1;
      $54=$132;
      __label__ = 196; break;
    case 22: // $133
      var $134=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $135=$134.f0;
      $53=$135;
      var $136=$134.f1;
      $54=$136;
      __label__ = 194; break;
    case 23: // $137
      var $138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $139=$138.f0;
      $53=$139;
      var $140=$138.f1;
      $54=$140;
      __label__ = 192; break;
    case 24: // $141
      var $142=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $143=$142.f0;
      $53=$143;
      var $144=$142.f1;
      $54=$144;
      __label__ = 190; break;
    case 25: // $145
      var $146=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $147=$146.f0;
      $53=$147;
      var $148=$146.f1;
      $54=$148;
      __label__ = 188; break;
    case 26: // $149
      var $150=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $151=$150.f0;
      $53=$151;
      var $152=$150.f1;
      $54=$152;
      __label__ = 186; break;
    case 27: // $153
      var $154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $155=$154.f0;
      $53=$155;
      var $156=$154.f1;
      $54=$156;
      __label__ = 184; break;
    case 28: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body38 = $158;__label__ = 29; break;
    case 29: // $_body37
      var $eh_lpad_body38;
      var $eh_lpad_body31 = $eh_lpad_body38;__label__ = 30; break;
    case 30: // $_body30
      var $eh_lpad_body31;
      var $eh_lpad_body24 = $eh_lpad_body31;__label__ = 31; break;
    case 31: // $_body23
      var $eh_lpad_body24;
      var $eh_lpad_body17 = $eh_lpad_body24;__label__ = 32; break;
    case 32: // $_body16
      var $eh_lpad_body17;
      var $eh_lpad_body10 = $eh_lpad_body17;__label__ = 33; break;
    case 33: // $_body9
      var $eh_lpad_body10;
      var $eh_lpad_body = $eh_lpad_body10;__label__ = 34; break;
    case 34: // $_body
      var $eh_lpad_body;
      var $159=$eh_lpad_body.f0;
      $53=$159;
      var $160=$eh_lpad_body.f1;
      $54=$160;
      __label__ = 182; break;
    case 35: // $161
      var $162=$51;
      var $163=(($162+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($164, ((STRING_TABLE.__str414656)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 28; break; };
    case 36: // $166
      $itemnode=$165;
      __label__ = 37; break;
    case 37: // $167
      var $168=$itemnode;
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 38; break; } else { __label__ = 59; break; }
    case 38: // $170
      var $171=(($56+156)|0);
      var $172=$50;
      var $173=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 28; break; };
    case 39: // $174
      var $175=$44;
      var $176=$45;
      var $177=$46;
      var $178=$result_i;
      var $179=$47;
      var $180=$48;
      HEAP32[(($44)>>2)]=200;
      HEAP32[(($45)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($46)>>2)]=1691;
      var $181=HEAP32[(($44)>>2)];
      var $182=HEAP32[(($45)>>2)];
      var $183=HEAP32[(($46)>>2)];
      var $184=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($181, $182, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; };
    case 40: // $185
      HEAP32[(($result_i)>>2)]=$184;
      var $186=HEAP32[(($result_i)>>2)];
      var $187=(($186)|0)==0;
      if ($187) { __label__ = 41; break; } else { __label__ = 47; break; }
    case 41: // $188
      var $189=___cxa_allocate_exception(4);
      var $190=$189;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($190);
      (function() { try { __THREW__ = false; return ___cxa_throw($189, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 42; break; }
    case 42: // $191
      var $192=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $193=$192.f0;
      HEAP32[(($47)>>2)]=$193;
      var $194=$192.f1;
      HEAP32[(($48)>>2)]=$194;
      var $195=HEAP32[(($48)>>2)];
      var $196=(($195)|0) < 0;
      if ($196) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $197
      var $198=HEAP32[(($47)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 28; break; }
    case 44: // $_noexc
      throw "Reached an unreachable!"
    case 45: // $199
      var $200=HEAP32[(($47)>>2)];
      var $201=HEAP32[(($47)>>2)];
      var $202=HEAP32[(($48)>>2)];
      var $203=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $201, tempValue);
      var $204=($203.f1 = $202, $203);
      var $eh_lpad_body = $204;__label__ = 34; break;
    case 46: // $205
      throw "Reached an unreachable!"
    case 47: // $_ZnwjPKci_exit
      var $206=HEAP32[(($result_i)>>2)];
      var $207=$44;
      var $208=$45;
      var $209=$46;
      var $210=$result_i;
      var $211=$47;
      var $212=$48;
      __label__ = 48; break;
    case 48: // $213
      var $214=$206;
      var $215=$50;
      var $216=$itemnode;
      var $217=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($214, $215, $216, $217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 54; break; }
    case 49: // $218
      var $219=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($173, $214) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 28; break; };
    case 50: // $220
      var $221=(function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEE6appendERS1_($171, $219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 28; break; };
    case 51: // $222
      __label__ = 52; break;
    case 52: // $223
      var $224=$itemnode;
      var $225=(($224)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($226, ((STRING_TABLE.__str414656)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 28; break; };
    case 53: // $228
      $itemnode=$227;
      __label__ = 37; break;
    case 54: // $229
      var $230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $231=$230.f0;
      $53=$231;
      var $232=$230.f1;
      $54=$232;
      var $233=$41;
      var $234=$42;
      var $235=$43;
      HEAP32[(($41)>>2)]=$206;
      HEAP32[(($42)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($43)>>2)]=1691;
      var $236=HEAP32[(($41)>>2)];
      var $237=(($236)|0)!=0;
      if ($237) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $238
      var $239=HEAP32[(($41)>>2)];
      var $240=HEAP32[(($42)>>2)];
      var $241=HEAP32[(($43)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($239, $240, $241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 199; break; }
    case 56: // $_noexc6
      __label__ = 57; break;
    case 57: // $_ZdlPvPKci_exit
      var $242=$41;
      var $243=$42;
      var $244=$43;
      __label__ = 58; break;
    case 58: // $245
      __label__ = 182; break;
    case 59: // $246
      var $247=$51;
      var $248=(($247+8)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($249, ((STRING_TABLE.__str424657)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 28; break; };
    case 60: // $251
      $itemnode1=$250;
      __label__ = 61; break;
    case 61: // $252
      var $253=$itemnode1;
      var $254=(($253)|0)!=0;
      if ($254) { __label__ = 62; break; } else { __label__ = 83; break; }
    case 62: // $255
      var $256=(($56+176)|0);
      var $257=$50;
      var $258=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($257) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 28; break; };
    case 63: // $259
      var $260=$36;
      var $261=$37;
      var $262=$38;
      var $263=$result_i7;
      var $264=$39;
      var $265=$40;
      HEAP32[(($36)>>2)]=200;
      HEAP32[(($37)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($38)>>2)]=1695;
      var $266=HEAP32[(($36)>>2)];
      var $267=HEAP32[(($37)>>2)];
      var $268=HEAP32[(($38)>>2)];
      var $269=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($266, $267, $268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 66; break; };
    case 64: // $270
      HEAP32[(($result_i7)>>2)]=$269;
      var $271=HEAP32[(($result_i7)>>2)];
      var $272=(($271)|0)==0;
      if ($272) { __label__ = 65; break; } else { __label__ = 71; break; }
    case 65: // $273
      var $274=___cxa_allocate_exception(4);
      var $275=$274;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($275);
      (function() { try { __THREW__ = false; return ___cxa_throw($274, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 66; break; }
    case 66: // $276
      var $277=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $278=$277.f0;
      HEAP32[(($39)>>2)]=$278;
      var $279=$277.f1;
      HEAP32[(($40)>>2)]=$279;
      var $280=HEAP32[(($40)>>2)];
      var $281=(($280)|0) < 0;
      if ($281) { __label__ = 67; break; } else { __label__ = 69; break; }
    case 67: // $282
      var $283=HEAP32[(($39)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($283) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 28; break; }
    case 68: // $_noexc8
      throw "Reached an unreachable!"
    case 69: // $284
      var $285=HEAP32[(($39)>>2)];
      var $286=HEAP32[(($39)>>2)];
      var $287=HEAP32[(($40)>>2)];
      var $288=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $286, tempValue);
      var $289=($288.f1 = $287, $288);
      var $eh_lpad_body10 = $289;__label__ = 33; break;
    case 70: // $290
      throw "Reached an unreachable!"
    case 71: // $_ZnwjPKci_exit11
      var $291=HEAP32[(($result_i7)>>2)];
      var $292=$36;
      var $293=$37;
      var $294=$38;
      var $295=$result_i7;
      var $296=$39;
      var $297=$40;
      __label__ = 72; break;
    case 72: // $298
      var $299=$291;
      var $300=$50;
      var $301=$itemnode1;
      var $302=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($299, $300, $301, $302) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 78; break; }
    case 73: // $303
      var $304=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($258, $299) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 28; break; };
    case 74: // $305
      var $306=(function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEE6appendERS1_($256, $304) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 28; break; };
    case 75: // $307
      __label__ = 76; break;
    case 76: // $308
      var $309=$itemnode1;
      var $310=(($309)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($311, ((STRING_TABLE.__str424657)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 28; break; };
    case 77: // $313
      $itemnode1=$312;
      __label__ = 61; break;
    case 78: // $314
      var $315=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $316=$315.f0;
      $53=$316;
      var $317=$315.f1;
      $54=$317;
      var $318=$33;
      var $319=$34;
      var $320=$35;
      HEAP32[(($33)>>2)]=$291;
      HEAP32[(($34)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($35)>>2)]=1695;
      var $321=HEAP32[(($33)>>2)];
      var $322=(($321)|0)!=0;
      if ($322) { __label__ = 79; break; } else { __label__ = 81; break; }
    case 79: // $323
      var $324=HEAP32[(($33)>>2)];
      var $325=HEAP32[(($34)>>2)];
      var $326=HEAP32[(($35)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($324, $325, $326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 199; break; }
    case 80: // $_noexc12
      __label__ = 81; break;
    case 81: // $_ZdlPvPKci_exit13
      var $327=$33;
      var $328=$34;
      var $329=$35;
      __label__ = 82; break;
    case 82: // $330
      __label__ = 182; break;
    case 83: // $331
      var $332=$51;
      var $333=(($332+8)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($334, ((STRING_TABLE.__str434658)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 28; break; };
    case 84: // $336
      $itemnode2=$335;
      __label__ = 85; break;
    case 85: // $337
      var $338=$itemnode2;
      var $339=(($338)|0)!=0;
      if ($339) { __label__ = 86; break; } else { __label__ = 107; break; }
    case 86: // $340
      var $341=(($56+196)|0);
      var $342=$50;
      var $343=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($342) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 28; break; };
    case 87: // $344
      var $345=$28;
      var $346=$29;
      var $347=$30;
      var $348=$result_i14;
      var $349=$31;
      var $350=$32;
      HEAP32[(($28)>>2)]=200;
      HEAP32[(($29)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($30)>>2)]=1699;
      var $351=HEAP32[(($28)>>2)];
      var $352=HEAP32[(($29)>>2)];
      var $353=HEAP32[(($30)>>2)];
      var $354=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($351, $352, $353) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 90; break; };
    case 88: // $355
      HEAP32[(($result_i14)>>2)]=$354;
      var $356=HEAP32[(($result_i14)>>2)];
      var $357=(($356)|0)==0;
      if ($357) { __label__ = 89; break; } else { __label__ = 95; break; }
    case 89: // $358
      var $359=___cxa_allocate_exception(4);
      var $360=$359;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($360);
      (function() { try { __THREW__ = false; return ___cxa_throw($359, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 90; break; }
    case 90: // $361
      var $362=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $363=$362.f0;
      HEAP32[(($31)>>2)]=$363;
      var $364=$362.f1;
      HEAP32[(($32)>>2)]=$364;
      var $365=HEAP32[(($32)>>2)];
      var $366=(($365)|0) < 0;
      if ($366) { __label__ = 91; break; } else { __label__ = 93; break; }
    case 91: // $367
      var $368=HEAP32[(($31)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($368) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 28; break; }
    case 92: // $_noexc15
      throw "Reached an unreachable!"
    case 93: // $369
      var $370=HEAP32[(($31)>>2)];
      var $371=HEAP32[(($31)>>2)];
      var $372=HEAP32[(($32)>>2)];
      var $373=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $371, tempValue);
      var $374=($373.f1 = $372, $373);
      var $eh_lpad_body17 = $374;__label__ = 32; break;
    case 94: // $375
      throw "Reached an unreachable!"
    case 95: // $_ZnwjPKci_exit18
      var $376=HEAP32[(($result_i14)>>2)];
      var $377=$28;
      var $378=$29;
      var $379=$30;
      var $380=$result_i14;
      var $381=$31;
      var $382=$32;
      __label__ = 96; break;
    case 96: // $383
      var $384=$376;
      var $385=$50;
      var $386=$itemnode2;
      var $387=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($384, $385, $386, $387) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 102; break; }
    case 97: // $388
      var $389=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($343, $384) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 28; break; };
    case 98: // $390
      var $391=(function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEE6appendERS1_($341, $389) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 28; break; };
    case 99: // $392
      __label__ = 100; break;
    case 100: // $393
      var $394=$itemnode2;
      var $395=(($394)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($396, ((STRING_TABLE.__str434658)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 101; break; } else { __label__ = 28; break; };
    case 101: // $398
      $itemnode2=$397;
      __label__ = 85; break;
    case 102: // $399
      var $400=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $401=$400.f0;
      $53=$401;
      var $402=$400.f1;
      $54=$402;
      var $403=$25;
      var $404=$26;
      var $405=$27;
      HEAP32[(($25)>>2)]=$376;
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($27)>>2)]=1699;
      var $406=HEAP32[(($25)>>2)];
      var $407=(($406)|0)!=0;
      if ($407) { __label__ = 103; break; } else { __label__ = 105; break; }
    case 103: // $408
      var $409=HEAP32[(($25)>>2)];
      var $410=HEAP32[(($26)>>2)];
      var $411=HEAP32[(($27)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($409, $410, $411) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 199; break; }
    case 104: // $_noexc19
      __label__ = 105; break;
    case 105: // $_ZdlPvPKci_exit20
      var $412=$25;
      var $413=$26;
      var $414=$27;
      __label__ = 106; break;
    case 106: // $415
      __label__ = 182; break;
    case 107: // $416
      var $417=$51;
      var $418=(($417+8)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($419, ((STRING_TABLE.__str444659)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 28; break; };
    case 108: // $421
      $itemnode3=$420;
      __label__ = 109; break;
    case 109: // $422
      var $423=$itemnode3;
      var $424=(($423)|0)!=0;
      if ($424) { __label__ = 110; break; } else { __label__ = 131; break; }
    case 110: // $425
      var $426=(($56+216)|0);
      var $427=$50;
      var $428=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 28; break; };
    case 111: // $429
      var $430=$20;
      var $431=$21;
      var $432=$22;
      var $433=$result_i21;
      var $434=$23;
      var $435=$24;
      HEAP32[(($20)>>2)]=200;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($22)>>2)]=1703;
      var $436=HEAP32[(($20)>>2)];
      var $437=HEAP32[(($21)>>2)];
      var $438=HEAP32[(($22)>>2)];
      var $439=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($436, $437, $438) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 114; break; };
    case 112: // $440
      HEAP32[(($result_i21)>>2)]=$439;
      var $441=HEAP32[(($result_i21)>>2)];
      var $442=(($441)|0)==0;
      if ($442) { __label__ = 113; break; } else { __label__ = 119; break; }
    case 113: // $443
      var $444=___cxa_allocate_exception(4);
      var $445=$444;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($445);
      (function() { try { __THREW__ = false; return ___cxa_throw($444, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 114; break; }
    case 114: // $446
      var $447=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $448=$447.f0;
      HEAP32[(($23)>>2)]=$448;
      var $449=$447.f1;
      HEAP32[(($24)>>2)]=$449;
      var $450=HEAP32[(($24)>>2)];
      var $451=(($450)|0) < 0;
      if ($451) { __label__ = 115; break; } else { __label__ = 117; break; }
    case 115: // $452
      var $453=HEAP32[(($23)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($453) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 28; break; }
    case 116: // $_noexc22
      throw "Reached an unreachable!"
    case 117: // $454
      var $455=HEAP32[(($23)>>2)];
      var $456=HEAP32[(($23)>>2)];
      var $457=HEAP32[(($24)>>2)];
      var $458=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $456, tempValue);
      var $459=($458.f1 = $457, $458);
      var $eh_lpad_body24 = $459;__label__ = 31; break;
    case 118: // $460
      throw "Reached an unreachable!"
    case 119: // $_ZnwjPKci_exit25
      var $461=HEAP32[(($result_i21)>>2)];
      var $462=$20;
      var $463=$21;
      var $464=$22;
      var $465=$result_i21;
      var $466=$23;
      var $467=$24;
      __label__ = 120; break;
    case 120: // $468
      var $469=$461;
      var $470=$50;
      var $471=$itemnode3;
      var $472=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($469, $470, $471, $472) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 126; break; }
    case 121: // $473
      var $474=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($428, $469) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 28; break; };
    case 122: // $475
      var $476=(function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEE6appendERS1_($426, $474) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 123; break; } else { __label__ = 28; break; };
    case 123: // $477
      __label__ = 124; break;
    case 124: // $478
      var $479=$itemnode3;
      var $480=(($479)|0);
      var $481=HEAP32[(($480)>>2)];
      var $482=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($481, ((STRING_TABLE.__str444659)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 125; break; } else { __label__ = 28; break; };
    case 125: // $483
      $itemnode3=$482;
      __label__ = 109; break;
    case 126: // $484
      var $485=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $486=$485.f0;
      $53=$486;
      var $487=$485.f1;
      $54=$487;
      var $488=$17;
      var $489=$18;
      var $490=$19;
      HEAP32[(($17)>>2)]=$461;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($19)>>2)]=1703;
      var $491=HEAP32[(($17)>>2)];
      var $492=(($491)|0)!=0;
      if ($492) { __label__ = 127; break; } else { __label__ = 129; break; }
    case 127: // $493
      var $494=HEAP32[(($17)>>2)];
      var $495=HEAP32[(($18)>>2)];
      var $496=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($494, $495, $496) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 128; break; } else { __label__ = 199; break; }
    case 128: // $_noexc26
      __label__ = 129; break;
    case 129: // $_ZdlPvPKci_exit27
      var $497=$17;
      var $498=$18;
      var $499=$19;
      __label__ = 130; break;
    case 130: // $500
      __label__ = 182; break;
    case 131: // $501
      var $502=$51;
      var $503=(($502+8)|0);
      var $504=HEAP32[(($503)>>2)];
      var $505=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($504, ((STRING_TABLE.__str454660)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 132; break; } else { __label__ = 28; break; };
    case 132: // $506
      $itemnode4=$505;
      __label__ = 133; break;
    case 133: // $507
      var $508=$itemnode4;
      var $509=(($508)|0)!=0;
      if ($509) { __label__ = 134; break; } else { __label__ = 155; break; }
    case 134: // $510
      var $511=(($56+236)|0);
      var $512=$50;
      var $513=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($512) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 135; break; } else { __label__ = 28; break; };
    case 135: // $514
      var $515=$12;
      var $516=$13;
      var $517=$14;
      var $518=$result_i28;
      var $519=$15;
      var $520=$16;
      HEAP32[(($12)>>2)]=200;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($14)>>2)]=1707;
      var $521=HEAP32[(($12)>>2)];
      var $522=HEAP32[(($13)>>2)];
      var $523=HEAP32[(($14)>>2)];
      var $524=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($521, $522, $523) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 138; break; };
    case 136: // $525
      HEAP32[(($result_i28)>>2)]=$524;
      var $526=HEAP32[(($result_i28)>>2)];
      var $527=(($526)|0)==0;
      if ($527) { __label__ = 137; break; } else { __label__ = 143; break; }
    case 137: // $528
      var $529=___cxa_allocate_exception(4);
      var $530=$529;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($530);
      (function() { try { __THREW__ = false; return ___cxa_throw($529, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 138; break; }
    case 138: // $531
      var $532=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $533=$532.f0;
      HEAP32[(($15)>>2)]=$533;
      var $534=$532.f1;
      HEAP32[(($16)>>2)]=$534;
      var $535=HEAP32[(($16)>>2)];
      var $536=(($535)|0) < 0;
      if ($536) { __label__ = 139; break; } else { __label__ = 141; break; }
    case 139: // $537
      var $538=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($538) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 140; break; } else { __label__ = 28; break; }
    case 140: // $_noexc29
      throw "Reached an unreachable!"
    case 141: // $539
      var $540=HEAP32[(($15)>>2)];
      var $541=HEAP32[(($15)>>2)];
      var $542=HEAP32[(($16)>>2)];
      var $543=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $541, tempValue);
      var $544=($543.f1 = $542, $543);
      var $eh_lpad_body31 = $544;__label__ = 30; break;
    case 142: // $545
      throw "Reached an unreachable!"
    case 143: // $_ZnwjPKci_exit32
      var $546=HEAP32[(($result_i28)>>2)];
      var $547=$12;
      var $548=$13;
      var $549=$14;
      var $550=$result_i28;
      var $551=$15;
      var $552=$16;
      __label__ = 144; break;
    case 144: // $553
      var $554=$546;
      var $555=$50;
      var $556=$itemnode4;
      var $557=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($554, $555, $556, $557) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 145; break; } else { __label__ = 150; break; }
    case 145: // $558
      var $559=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($513, $554) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 146; break; } else { __label__ = 28; break; };
    case 146: // $560
      var $561=(function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEE6appendERS1_($511, $559) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 147; break; } else { __label__ = 28; break; };
    case 147: // $562
      __label__ = 148; break;
    case 148: // $563
      var $564=$itemnode4;
      var $565=(($564)|0);
      var $566=HEAP32[(($565)>>2)];
      var $567=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($566, ((STRING_TABLE.__str454660)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 149; break; } else { __label__ = 28; break; };
    case 149: // $568
      $itemnode4=$567;
      __label__ = 133; break;
    case 150: // $569
      var $570=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $571=$570.f0;
      $53=$571;
      var $572=$570.f1;
      $54=$572;
      var $573=$9;
      var $574=$10;
      var $575=$11;
      HEAP32[(($9)>>2)]=$546;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($11)>>2)]=1707;
      var $576=HEAP32[(($9)>>2)];
      var $577=(($576)|0)!=0;
      if ($577) { __label__ = 151; break; } else { __label__ = 153; break; }
    case 151: // $578
      var $579=HEAP32[(($9)>>2)];
      var $580=HEAP32[(($10)>>2)];
      var $581=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($579, $580, $581) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 199; break; }
    case 152: // $_noexc33
      __label__ = 153; break;
    case 153: // $_ZdlPvPKci_exit34
      var $582=$9;
      var $583=$10;
      var $584=$11;
      __label__ = 154; break;
    case 154: // $585
      __label__ = 182; break;
    case 155: // $586
      var $587=$51;
      var $588=(($587+8)|0);
      var $589=HEAP32[(($588)>>2)];
      var $590=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($589, ((STRING_TABLE.__str464661)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 156; break; } else { __label__ = 28; break; };
    case 156: // $591
      $itemnode5=$590;
      __label__ = 157; break;
    case 157: // $592
      var $593=$itemnode5;
      var $594=(($593)|0)!=0;
      if ($594) { __label__ = 158; break; } else { __label__ = 179; break; }
    case 158: // $595
      var $596=(($56+256)|0);
      var $597=$50;
      var $598=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($597) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 159; break; } else { __label__ = 28; break; };
    case 159: // $599
      var $600=$4;
      var $601=$5;
      var $602=$6;
      var $603=$result_i35;
      var $604=$7;
      var $605=$8;
      HEAP32[(($4)>>2)]=200;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1711;
      var $606=HEAP32[(($4)>>2)];
      var $607=HEAP32[(($5)>>2)];
      var $608=HEAP32[(($6)>>2)];
      var $609=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($606, $607, $608) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 160; break; } else { __label__ = 162; break; };
    case 160: // $610
      HEAP32[(($result_i35)>>2)]=$609;
      var $611=HEAP32[(($result_i35)>>2)];
      var $612=(($611)|0)==0;
      if ($612) { __label__ = 161; break; } else { __label__ = 167; break; }
    case 161: // $613
      var $614=___cxa_allocate_exception(4);
      var $615=$614;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($615);
      (function() { try { __THREW__ = false; return ___cxa_throw($614, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 166; break; } else { __label__ = 162; break; }
    case 162: // $616
      var $617=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $618=$617.f0;
      HEAP32[(($7)>>2)]=$618;
      var $619=$617.f1;
      HEAP32[(($8)>>2)]=$619;
      var $620=HEAP32[(($8)>>2)];
      var $621=(($620)|0) < 0;
      if ($621) { __label__ = 163; break; } else { __label__ = 165; break; }
    case 163: // $622
      var $623=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($623) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 164; break; } else { __label__ = 28; break; }
    case 164: // $_noexc36
      throw "Reached an unreachable!"
    case 165: // $624
      var $625=HEAP32[(($7)>>2)];
      var $626=HEAP32[(($7)>>2)];
      var $627=HEAP32[(($8)>>2)];
      var $628=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $626, tempValue);
      var $629=($628.f1 = $627, $628);
      var $eh_lpad_body38 = $629;__label__ = 29; break;
    case 166: // $630
      throw "Reached an unreachable!"
    case 167: // $_ZnwjPKci_exit39
      var $631=HEAP32[(($result_i35)>>2)];
      var $632=$4;
      var $633=$5;
      var $634=$6;
      var $635=$result_i35;
      var $636=$7;
      var $637=$8;
      __label__ = 168; break;
    case 168: // $638
      var $639=$631;
      var $640=$50;
      var $641=$itemnode5;
      var $642=$52;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($639, $640, $641, $642) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 169; break; } else { __label__ = 174; break; }
    case 169: // $643
      var $644=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($598, $639) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 170; break; } else { __label__ = 28; break; };
    case 170: // $645
      var $646=(function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEE6appendERS1_($596, $644) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 171; break; } else { __label__ = 28; break; };
    case 171: // $647
      __label__ = 172; break;
    case 172: // $648
      var $649=$itemnode5;
      var $650=(($649)|0);
      var $651=HEAP32[(($650)>>2)];
      var $652=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($651, ((STRING_TABLE.__str464661)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 173; break; } else { __label__ = 28; break; };
    case 173: // $653
      $itemnode5=$652;
      __label__ = 157; break;
    case 174: // $654
      var $655=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $656=$655.f0;
      $53=$656;
      var $657=$655.f1;
      $54=$657;
      var $658=$1;
      var $659=$2;
      var $660=$3;
      HEAP32[(($1)>>2)]=$631;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1711;
      var $661=HEAP32[(($1)>>2)];
      var $662=(($661)|0)!=0;
      if ($662) { __label__ = 175; break; } else { __label__ = 177; break; }
    case 175: // $663
      var $664=HEAP32[(($1)>>2)];
      var $665=HEAP32[(($2)>>2)];
      var $666=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($664, $665, $666) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 176; break; } else { __label__ = 199; break; }
    case 176: // $_noexc40
      __label__ = 177; break;
    case 177: // $_ZdlPvPKci_exit41
      var $667=$1;
      var $668=$2;
      var $669=$3;
      __label__ = 178; break;
    case 178: // $670
      __label__ = 182; break;
    case 179: // $671
      (function() { try { __THREW__ = false; return __ZN19render_layer_configC1Ev($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 180; break; } else { __label__ = 28; break; }
    case 180: // $672
      (function() { try { __THREW__ = false; return __ZN11layout_view9recomputeE19render_layer_config($56, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 181; break; } else { __label__ = 28; break; }
    case 181: // $673
      STACKTOP = __stackBase__;
      return;
    case 182: // $674
      var $675=(($56+256)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($675) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 183; break; } else { __label__ = 199; break; }
    case 183: // $676
      __label__ = 184; break;
    case 184: // $677
      var $678=(($56+236)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($678) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 185; break; } else { __label__ = 199; break; }
    case 185: // $679
      __label__ = 186; break;
    case 186: // $680
      var $681=(($56+216)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($681) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 187; break; } else { __label__ = 199; break; }
    case 187: // $682
      __label__ = 188; break;
    case 188: // $683
      var $684=(($56+196)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($684) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 189; break; } else { __label__ = 199; break; }
    case 189: // $685
      __label__ = 190; break;
    case 190: // $686
      var $687=(($56+176)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($687) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 191; break; } else { __label__ = 199; break; }
    case 191: // $688
      __label__ = 192; break;
    case 192: // $689
      var $690=(($56+156)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($690) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 193; break; } else { __label__ = 199; break; }
    case 193: // $691
      __label__ = 194; break;
    case 194: // $692
      var $693=(($56+80)|0);
      (function() { try { __THREW__ = false; return __ZN18render_screen_listD1Ev($693) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 195; break; } else { __label__ = 199; break; }
    case 195: // $694
      __label__ = 196; break;
    case 196: // $695
      var $696=(($56+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($696) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 197; break; } else { __label__ = 199; break; }
    case 197: // $697
      __label__ = 198; break;
    case 198: // $698
      var $699=$53;
      var $700=$53;
      var $701=$54;
      var $702=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $700, tempValue);
      var $703=($702.f1 = $701, $702);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 199: // $704
      var $705=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_viewC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE["X"]=1;

function __ZN11simple_listIN11layout_view4itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN11layout_view4itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11layout_view9recomputeE19render_layer_config($this, $layerconfig) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $layerconfig; $layerconfig = STACKTOP;STACKTOP += 1;STACKTOP = ((((STACKTOP)+3)>>2)<<2);assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");;;HEAP8[($layerconfig)]=HEAP8[(tempParam)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $first;
      var $scrfirst;
      var $layer=__stackBase__;
      var $curitem;
      var $target_bounds=__stackBase__+4;
      var $targwidth;
      var $targheight;
      var $xoffs;
      var $yoffs;
      var $xscale;
      var $yscale;
      var $layer1=__stackBase__+20;
      var $curitem2;
      $1=$this;
      var $2=$1;
      var $3=(($2+100)|0);
      var $4=(($3+12)|0);
      HEAPF32[(($4)>>2)]=0;
      var $5=(($2+100)|0);
      var $6=(($5+8)|0);
      HEAPF32[(($6)>>2)]=0;
      var $7=(($2+100)|0);
      var $8=(($7+4)|0);
      HEAPF32[(($8)>>2)]=0;
      var $9=(($2+100)|0);
      var $10=(($9)|0);
      HEAPF32[(($10)>>2)]=0;
      var $11=(($2+116)|0);
      var $12=(($11+12)|0);
      HEAPF32[(($12)>>2)]=0;
      var $13=(($2+116)|0);
      var $14=(($13+8)|0);
      HEAPF32[(($14)>>2)]=0;
      var $15=(($2+116)|0);
      var $16=(($15+4)|0);
      HEAPF32[(($16)>>2)]=0;
      var $17=(($2+116)|0);
      var $18=(($17)|0);
      HEAPF32[(($18)>>2)]=0;
      var $19=(($2+80)|0);
      __ZN18render_screen_list5resetEv($19);
      $first=1;
      $scrfirst=1;
      HEAP32[(($layer)>>2)]=0;
      __label__ = 1; break;
    case 1: // $20
      var $21=HEAP32[(($layer)>>2)];
      var $22=(($21)|0) < 6;
      if ($22) { __label__ = 2; break; } else { __label__ = 25; break; }
    case 2: // $23
      var $24=HEAP32[(($layer)>>2)];
      if ($24 == 0) {
        __label__ = 3; break;
      }
      else if ($24 == 2) {
        __label__ = 4; break;
      }
      else if ($24 == 3) {
        __label__ = 5; break;
      }
      else if ($24 == 4) {
        __label__ = 6; break;
      }
      else if ($24 == 5) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 3: // $25
      var $26=__ZNK19render_layer_config17backdrops_enabledEv($layerconfig);
      var $27=HEAP32[(($layer)>>2)];
      var $28=(($2+148)|0);
      var $29=(($28+$27)|0);
      var $30=(($26)&1);
      HEAP8[($29)]=$30;
      __label__ = 9; break;
    case 4: // $31
      var $32=__ZNK19render_layer_config16overlays_enabledEv($layerconfig);
      var $33=HEAP32[(($layer)>>2)];
      var $34=(($2+148)|0);
      var $35=(($34+$33)|0);
      var $36=(($32)&1);
      HEAP8[($35)]=$36;
      __label__ = 9; break;
    case 5: // $37
      var $38=__ZNK19render_layer_config14bezels_enabledEv($layerconfig);
      var $39=HEAP32[(($layer)>>2)];
      var $40=(($2+148)|0);
      var $41=(($40+$39)|0);
      var $42=(($38)&1);
      HEAP8[($41)]=$42;
      __label__ = 9; break;
    case 6: // $43
      var $44=__ZNK19render_layer_config15cpanels_enabledEv($layerconfig);
      var $45=HEAP32[(($layer)>>2)];
      var $46=(($2+148)|0);
      var $47=(($46+$45)|0);
      var $48=(($44)&1);
      HEAP8[($47)]=$48;
      __label__ = 9; break;
    case 7: // $49
      var $50=__ZNK19render_layer_config16marquees_enabledEv($layerconfig);
      var $51=HEAP32[(($layer)>>2)];
      var $52=(($2+148)|0);
      var $53=(($52+$51)|0);
      var $54=(($50)&1);
      HEAP8[($53)]=$54;
      __label__ = 9; break;
    case 8: // $55
      var $56=HEAP32[(($layer)>>2)];
      var $57=(($2+148)|0);
      var $58=(($57+$56)|0);
      HEAP8[($58)]=1;
      __label__ = 9; break;
    case 9: // $59
      var $60=HEAP32[(($layer)>>2)];
      var $61=(($2+148)|0);
      var $62=(($61+$60)|0);
      var $63=HEAP8[($62)];
      var $64=(($63) & 1);
      if ($64) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $65
      var $66=HEAP32[(($layer)>>2)];
      var $67=__ZNK11layout_view10first_itemE10item_layer($2, $66);
      $curitem=$67;
      __label__ = 11; break;
    case 11: // $68
      var $69=$curitem;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 12; break; } else { __label__ = 22; break; }
    case 12: // $71
      var $72=$first;
      var $73=(($72) & 1);
      if ($73) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $74
      var $75=(($2+100)|0);
      var $76=$curitem;
      var $77=(($76+168)|0);
      var $78=$75;
      var $79=$77;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($78)>>2)]=HEAP32[(($79)>>2)];HEAP32[(($78+4)>>2)]=HEAP32[(($79+4)>>2)];HEAP32[(($78+8)>>2)]=HEAP32[(($79+8)>>2)];HEAP32[(($78+12)>>2)]=HEAP32[(($79+12)>>2)];
      __label__ = 15; break;
    case 14: // $80
      var $81=(($2+100)|0);
      var $82=$curitem;
      var $83=(($82+168)|0);
      __ZL19union_render_boundsP13render_boundsPKS_($81, $83);
      __label__ = 15; break;
    case 15: // $84
      $first=0;
      var $85=$curitem;
      var $86=(($85+144)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $89
      var $90=$scrfirst;
      var $91=(($90) & 1);
      if ($91) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $92
      var $93=(($2+116)|0);
      var $94=$curitem;
      var $95=(($94+168)|0);
      var $96=$93;
      var $97=$95;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($96)>>2)]=HEAP32[(($97)>>2)];HEAP32[(($96+4)>>2)]=HEAP32[(($97+4)>>2)];HEAP32[(($96+8)>>2)]=HEAP32[(($97+8)>>2)];HEAP32[(($96+12)>>2)]=HEAP32[(($97+12)>>2)];
      __label__ = 19; break;
    case 18: // $98
      var $99=(($2+116)|0);
      var $100=$curitem;
      var $101=(($100+168)|0);
      __ZL19union_render_boundsP13render_boundsPKS_($99, $101);
      __label__ = 19; break;
    case 19: // $102
      $scrfirst=0;
      var $103=(($2+80)|0);
      var $104=$curitem;
      var $105=(($104+144)|0);
      var $106=HEAP32[(($105)>>2)];
      __ZN18render_screen_list3addER13screen_device($103, $106);
      __label__ = 20; break;
    case 20: // $107
      __label__ = 21; break;
    case 21: // $108
      var $109=$curitem;
      var $110=__ZNK11layout_view4item4nextEv($109);
      $curitem=$110;
      __label__ = 11; break;
    case 22: // $111
      __label__ = 23; break;
    case 23: // $112
      __label__ = 24; break;
    case 24: // $113
      __ZppR10item_layeri($layer, 0);
      __label__ = 1; break;
    case 25: // $114
      var $115=(($2+132)|0);
      var $116=(($115+8)|0);
      var $117=HEAPF32[(($116)>>2)];
      var $118=(($2+132)|0);
      var $119=(($118)|0);
      var $120=HEAPF32[(($119)>>2)];
      var $121=$117 > $120;
      if ($121) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $122
      var $123=(($2+100)|0);
      var $124=(($2+132)|0);
      var $125=$123;
      var $126=$124;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($125)>>2)]=HEAP32[(($126)>>2)];HEAP32[(($125+4)>>2)]=HEAP32[(($126+4)>>2)];HEAP32[(($125+8)>>2)]=HEAP32[(($126+8)>>2)];HEAP32[(($125+12)>>2)]=HEAP32[(($126+12)>>2)];
      __label__ = 27; break;
    case 27: // $127
      var $128=(($2+100)|0);
      var $129=(($128+8)|0);
      var $130=HEAPF32[(($129)>>2)];
      var $131=(($2+100)|0);
      var $132=(($131)|0);
      var $133=HEAPF32[(($132)>>2)];
      var $134=$130-$133;
      var $135=(($2+100)|0);
      var $136=(($135+12)|0);
      var $137=HEAPF32[(($136)>>2)];
      var $138=(($2+100)|0);
      var $139=(($138+4)|0);
      var $140=HEAPF32[(($139)>>2)];
      var $141=$137-$140;
      var $142=$134/$141;
      var $143=(($2+72)|0);
      HEAPF32[(($143)>>2)]=$142;
      var $144=(($2+116)|0);
      var $145=(($144+8)|0);
      var $146=HEAPF32[(($145)>>2)];
      var $147=(($2+116)|0);
      var $148=(($147)|0);
      var $149=HEAPF32[(($148)>>2)];
      var $150=$146-$149;
      var $151=(($2+116)|0);
      var $152=(($151+12)|0);
      var $153=HEAPF32[(($152)>>2)];
      var $154=(($2+116)|0);
      var $155=(($154+4)|0);
      var $156=HEAPF32[(($155)>>2)];
      var $157=$153-$156;
      var $158=$150/$157;
      var $159=(($2+76)|0);
      HEAPF32[(($159)>>2)]=$158;
      var $160=__ZNK19render_layer_config14zoom_to_screenEv($layerconfig);
      if ($160) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $161
      var $162=(($2+80)|0);
      var $163=__ZNK18render_screen_list5countEv($162);
      var $164=(($163)|0)==0;
      if ($164) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $165
      var $166=(($target_bounds+4)|0);
      HEAPF32[(($166)>>2)]=0;
      var $167=(($target_bounds)|0);
      HEAPF32[(($167)>>2)]=0;
      var $168=(($target_bounds+12)|0);
      HEAPF32[(($168)>>2)]=1;
      var $169=(($target_bounds+8)|0);
      HEAPF32[(($169)>>2)]=1;
      __label__ = 31; break;
    case 30: // $170
      var $171=(($2+100)|0);
      var $172=(($171+8)|0);
      var $173=HEAPF32[(($172)>>2)];
      var $174=(($2+100)|0);
      var $175=(($174)|0);
      var $176=HEAPF32[(($175)>>2)];
      var $177=$173-$176;
      var $178=(($2+116)|0);
      var $179=(($178+8)|0);
      var $180=HEAPF32[(($179)>>2)];
      var $181=(($2+116)|0);
      var $182=(($181)|0);
      var $183=HEAPF32[(($182)>>2)];
      var $184=$180-$183;
      var $185=$177/$184;
      $targwidth=$185;
      var $186=(($2+100)|0);
      var $187=(($186+12)|0);
      var $188=HEAPF32[(($187)>>2)];
      var $189=(($2+100)|0);
      var $190=(($189+4)|0);
      var $191=HEAPF32[(($190)>>2)];
      var $192=$188-$191;
      var $193=(($2+116)|0);
      var $194=(($193+12)|0);
      var $195=HEAPF32[(($194)>>2)];
      var $196=(($2+116)|0);
      var $197=(($196+4)|0);
      var $198=HEAPF32[(($197)>>2)];
      var $199=$195-$198;
      var $200=$192/$199;
      $targheight=$200;
      var $201=(($2+100)|0);
      var $202=(($201)|0);
      var $203=HEAPF32[(($202)>>2)];
      var $204=(($2+116)|0);
      var $205=(($204)|0);
      var $206=HEAPF32[(($205)>>2)];
      var $207=$203-$206;
      var $208=(($2+100)|0);
      var $209=(($208+8)|0);
      var $210=HEAPF32[(($209)>>2)];
      var $211=(($2+100)|0);
      var $212=(($211)|0);
      var $213=HEAPF32[(($212)>>2)];
      var $214=$210-$213;
      var $215=$207/$214;
      var $216=$targwidth;
      var $217=$215*$216;
      var $218=(($target_bounds)|0);
      HEAPF32[(($218)>>2)]=$217;
      var $219=(($2+100)|0);
      var $220=(($219+4)|0);
      var $221=HEAPF32[(($220)>>2)];
      var $222=(($2+116)|0);
      var $223=(($222+4)|0);
      var $224=HEAPF32[(($223)>>2)];
      var $225=$221-$224;
      var $226=(($2+100)|0);
      var $227=(($226+12)|0);
      var $228=HEAPF32[(($227)>>2)];
      var $229=(($2+100)|0);
      var $230=(($229+4)|0);
      var $231=HEAPF32[(($230)>>2)];
      var $232=$228-$231;
      var $233=$225/$232;
      var $234=$targheight;
      var $235=$233*$234;
      var $236=(($target_bounds+4)|0);
      HEAPF32[(($236)>>2)]=$235;
      var $237=(($target_bounds)|0);
      var $238=HEAPF32[(($237)>>2)];
      var $239=$targwidth;
      var $240=$238+$239;
      var $241=(($target_bounds+8)|0);
      HEAPF32[(($241)>>2)]=$240;
      var $242=(($target_bounds+4)|0);
      var $243=HEAPF32[(($242)>>2)];
      var $244=$targheight;
      var $245=$243+$244;
      var $246=(($target_bounds+12)|0);
      HEAPF32[(($246)>>2)]=$245;
      __label__ = 31; break;
    case 31: // $247
      var $248=(($2+100)|0);
      var $249=(($248)|0);
      var $250=HEAPF32[(($249)>>2)];
      $xoffs=$250;
      var $251=(($2+100)|0);
      var $252=(($251+4)|0);
      var $253=HEAPF32[(($252)>>2)];
      $yoffs=$253;
      var $254=(($target_bounds+8)|0);
      var $255=HEAPF32[(($254)>>2)];
      var $256=(($target_bounds)|0);
      var $257=HEAPF32[(($256)>>2)];
      var $258=$255-$257;
      var $259=(($2+100)|0);
      var $260=(($259+8)|0);
      var $261=HEAPF32[(($260)>>2)];
      var $262=(($2+100)|0);
      var $263=(($262)|0);
      var $264=HEAPF32[(($263)>>2)];
      var $265=$261-$264;
      var $266=$258/$265;
      $xscale=$266;
      var $267=(($target_bounds+12)|0);
      var $268=HEAPF32[(($267)>>2)];
      var $269=(($target_bounds+4)|0);
      var $270=HEAPF32[(($269)>>2)];
      var $271=$268-$270;
      var $272=(($2+100)|0);
      var $273=(($272+12)|0);
      var $274=HEAPF32[(($273)>>2)];
      var $275=(($2+100)|0);
      var $276=(($275+4)|0);
      var $277=HEAPF32[(($276)>>2)];
      var $278=$274-$277;
      var $279=$271/$278;
      $yscale=$279;
      HEAP32[(($layer1)>>2)]=0;
      __label__ = 32; break;
    case 32: // $280
      var $281=HEAP32[(($layer1)>>2)];
      var $282=(($281)|0) < 6;
      if ($282) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $283
      var $284=HEAP32[(($layer1)>>2)];
      var $285=__ZNK11layout_view10first_itemE10item_layer($2, $284);
      $curitem2=$285;
      __label__ = 34; break;
    case 34: // $286
      var $287=$curitem2;
      var $288=(($287)|0)!=0;
      if ($288) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $289
      var $290=(($target_bounds)|0);
      var $291=HEAPF32[(($290)>>2)];
      var $292=$curitem2;
      var $293=(($292+168)|0);
      var $294=(($293)|0);
      var $295=HEAPF32[(($294)>>2)];
      var $296=$xoffs;
      var $297=$295-$296;
      var $298=$xscale;
      var $299=$297*$298;
      var $300=$291+$299;
      var $301=$curitem2;
      var $302=(($301+152)|0);
      var $303=(($302)|0);
      HEAPF32[(($303)>>2)]=$300;
      var $304=(($target_bounds)|0);
      var $305=HEAPF32[(($304)>>2)];
      var $306=$curitem2;
      var $307=(($306+168)|0);
      var $308=(($307+8)|0);
      var $309=HEAPF32[(($308)>>2)];
      var $310=$xoffs;
      var $311=$309-$310;
      var $312=$xscale;
      var $313=$311*$312;
      var $314=$305+$313;
      var $315=$curitem2;
      var $316=(($315+152)|0);
      var $317=(($316+8)|0);
      HEAPF32[(($317)>>2)]=$314;
      var $318=(($target_bounds+4)|0);
      var $319=HEAPF32[(($318)>>2)];
      var $320=$curitem2;
      var $321=(($320+168)|0);
      var $322=(($321+4)|0);
      var $323=HEAPF32[(($322)>>2)];
      var $324=$yoffs;
      var $325=$323-$324;
      var $326=$yscale;
      var $327=$325*$326;
      var $328=$319+$327;
      var $329=$curitem2;
      var $330=(($329+152)|0);
      var $331=(($330+4)|0);
      HEAPF32[(($331)>>2)]=$328;
      var $332=(($target_bounds+4)|0);
      var $333=HEAPF32[(($332)>>2)];
      var $334=$curitem2;
      var $335=(($334+168)|0);
      var $336=(($335+12)|0);
      var $337=HEAPF32[(($336)>>2)];
      var $338=$yoffs;
      var $339=$337-$338;
      var $340=$yscale;
      var $341=$339*$340;
      var $342=$333+$341;
      var $343=$curitem2;
      var $344=(($343+152)|0);
      var $345=(($344+12)|0);
      HEAPF32[(($345)>>2)]=$342;
      __label__ = 36; break;
    case 36: // $346
      var $347=$curitem2;
      var $348=__ZNK11layout_view4item4nextEv($347);
      $curitem2=$348;
      __label__ = 34; break;
    case 37: // $349
      __label__ = 38; break;
    case 38: // $350
      __ZppR10item_layeri($layer1, 0);
      __label__ = 32; break;
    case 39: // $351
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_view9recomputeE19render_layer_config["X"]=1;

function __ZN11simple_listIN11layout_view4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN11layout_view4itemEED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN11layout_view4itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_["X"]=1;

function __ZN11layout_viewD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_viewD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_viewD0Ev["X"]=1;

function __ZN11layout_viewD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV11layout_view+8)|0);
      var $6=(($4+256)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $7
      var $8=(($4+236)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $9
      var $10=(($4+216)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $11
      var $12=(($4+196)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $13
      var $14=(($4+176)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 17; break; }
    case 5: // $15
      var $16=(($4+156)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 20; break; }
    case 6: // $17
      var $18=(($4+80)|0);
      (function() { try { __THREW__ = false; return __ZN18render_screen_listD1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 23; break; }
    case 7: // $19
      var $20=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($20);
      ;
      return;
    case 8: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $2=$23;
      var $24=$22.f1;
      $3=$24;
      var $25=(($4+236)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 29; break; }
    case 9: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      __label__ = 12; break;
    case 10: // $30
      __label__ = 12; break;
    case 11: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $2=$33;
      var $34=$32.f1;
      $3=$34;
      __label__ = 15; break;
    case 12: // $35
      var $36=(($4+216)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 29; break; }
    case 13: // $37
      __label__ = 15; break;
    case 14: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $2=$40;
      var $41=$39.f1;
      $3=$41;
      __label__ = 18; break;
    case 15: // $42
      var $43=(($4+196)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 29; break; }
    case 16: // $44
      __label__ = 18; break;
    case 17: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $2=$47;
      var $48=$46.f1;
      $3=$48;
      __label__ = 21; break;
    case 18: // $49
      var $50=(($4+176)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 29; break; }
    case 19: // $51
      __label__ = 21; break;
    case 20: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $2=$54;
      var $55=$53.f1;
      $3=$55;
      __label__ = 24; break;
    case 21: // $56
      var $57=(($4+156)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $58
      __label__ = 24; break;
    case 23: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      $2=$61;
      var $62=$60.f1;
      $3=$62;
      __label__ = 26; break;
    case 24: // $63
      var $64=(($4+80)|0);
      (function() { try { __THREW__ = false; return __ZN18render_screen_listD1Ev($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $65
      __label__ = 26; break;
    case 26: // $66
      var $67=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $68
      __label__ = 28; break;
    case 28: // $69
      var $70=$2;
      var $71=$2;
      var $72=$3;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_viewD2Ev["X"]=1;

function __ZNK11simple_listIN11layout_view4itemEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI14layout_elementE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK14layout_element4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK14layout_element13default_stateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+96)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11layout_view10first_itemE10item_layer($this, $layer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$layer;
      var $4=$2;
      var $5=$3;
      if ($5 == 0) {
        __label__ = 1; break;
      }
      else if ($5 == 1) {
        __label__ = 2; break;
      }
      else if ($5 == 2) {
        __label__ = 3; break;
      }
      else if ($5 == 3) {
        __label__ = 4; break;
      }
      else if ($5 == 4) {
        __label__ = 5; break;
      }
      else if ($5 == 5) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $6
      var $7=(($4+156)|0);
      var $8=__ZNK11simple_listIN11layout_view4itemEE5firstEv($7);
      $1=$8;
      __label__ = 8; break;
    case 2: // $9
      var $10=(($4+176)|0);
      var $11=__ZNK11simple_listIN11layout_view4itemEE5firstEv($10);
      $1=$11;
      __label__ = 8; break;
    case 3: // $12
      var $13=(($4+196)|0);
      var $14=__ZNK11simple_listIN11layout_view4itemEE5firstEv($13);
      $1=$14;
      __label__ = 8; break;
    case 4: // $15
      var $16=(($4+216)|0);
      var $17=__ZNK11simple_listIN11layout_view4itemEE5firstEv($16);
      $1=$17;
      __label__ = 8; break;
    case 5: // $18
      var $19=(($4+236)|0);
      var $20=__ZNK11simple_listIN11layout_view4itemEE5firstEv($19);
      $1=$20;
      __label__ = 8; break;
    case 6: // $21
      var $22=(($4+256)|0);
      var $23=__ZNK11simple_listIN11layout_view4itemEE5firstEv($22);
      $1=$23;
      __label__ = 8; break;
    case 7: // $24
      $1=0;
      __label__ = 8; break;
    case 8: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18render_screen_list5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listIN18render_screen_list4itemEE5resetEv($3);
  ;
  return;
}


function __ZNK14layout_element4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN18render_screen_list3addER13screen_device($this, $screen) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      $9=$this;
      $10=$screen;
      var $13=$9;
      var $14=(($13)|0);
      var $15=(($13)|0);
      var $16=__ZNK11simple_listIN18render_screen_list4itemEE4poolEv($15);
      var $17=$4;
      var $18=$5;
      var $19=$6;
      var $20=$result_i;
      var $21=$7;
      var $22=$8;
      HEAP32[(($4)>>2)]=8;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str674682)|0);
      HEAP32[(($6)>>2)]=268;
      var $23=HEAP32[(($4)>>2)];
      var $24=HEAP32[(($5)>>2)];
      var $25=HEAP32[(($6)>>2)];
      var $26=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23, $24, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $27
      HEAP32[(($result_i)>>2)]=$26;
      var $28=HEAP32[(($result_i)>>2)];
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $30
      var $31=___cxa_allocate_exception(4);
      var $32=$31;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32);
      (function() { try { __THREW__ = false; return ___cxa_throw($31, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      HEAP32[(($7)>>2)]=$35;
      var $36=$34.f1;
      HEAP32[(($8)>>2)]=$36;
      var $37=HEAP32[(($8)>>2)];
      var $38=(($37)|0) < 0;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($40);
      throw "Reached an unreachable!"
    case 5: // $41
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($8)>>2)];
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $47
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $48=HEAP32[(($result_i)>>2)];
      var $49=$4;
      var $50=$5;
      var $51=$6;
      var $52=$result_i;
      var $53=$7;
      var $54=$8;
      var $55=$48;
      var $56=$10;
      (function() { try { __THREW__ = false; return __ZN18render_screen_list4itemC1ER13screen_device($55, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $57
      var $58=__ZN13resource_pool10add_objectIN18render_screen_list4itemEEEPT_S4_($16, $55);
      var $59=__ZN11simple_listIN18render_screen_list4itemEE6appendERS1_($14, $58);
      STACKTOP = __stackBase__;
      return;
    case 9: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $11=$62;
      var $63=$61.f1;
      $12=$63;
      var $64=$1;
      var $65=$2;
      var $66=$3;
      HEAP32[(($1)>>2)]=$48;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str674682)|0);
      HEAP32[(($3)>>2)]=268;
      var $67=HEAP32[(($1)>>2)];
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $69
      var $70=HEAP32[(($1)>>2)];
      var $71=HEAP32[(($2)>>2)];
      var $72=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($70, $71, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $73=$1;
      var $74=$2;
      var $75=$3;
      __label__ = 13; break;
    case 13: // $76
      __label__ = 14; break;
    case 14: // $77
      var $78=$11;
      var $79=$11;
      var $80=$12;
      var $81=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $79, tempValue);
      var $82=($81.f1 = $80, $81);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18render_screen_list3addER13screen_device["X"]=1;

function __ZN11layout_view4itemC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE($this, $machine, $itemnode, $elemlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $name;
      var $index;
      $1=$this;
      $2=$machine;
      $3=$itemnode;
      $4=$elemlist;
      var $7=$1;
      var $8=$7;
      HEAP32[(($8)>>2)]=((__ZTVN11layout_view4itemE+8)|0);
      var $9=(($7+4)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=(($7+8)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($7+12)|0);
      __ZN7astringC1Ev($11);
      var $12=(($7+76)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $13
      var $14=(($7+140)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($7+144)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($7+148)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($7+152)|0);
      var $18=(($7+168)|0);
      var $19=(($7+184)|0);
      var $20=(($7+12)|0);
      var $21=$2;
      var $22=$3;
      var $23=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($21, $22, ((STRING_TABLE.__str154630)|0), ((__str244639)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $24
      var $25=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($20, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 15; break; };
    case 3: // $26
      var $27=(($7+76)|0);
      var $28=$2;
      var $29=$3;
      var $30=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($28, $29, ((STRING_TABLE.__str474662)|0), ((__str244639)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 15; break; };
    case 4: // $31
      var $32=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($27, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; };
    case 5: // $33
      var $34=$2;
      var $35=$3;
      var $36=(function() { try { __THREW__ = false; return __ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($34, $35, ((STRING_TABLE.__str484663)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; };
    case 6: // $37
      $name=$36;
      var $38=$name;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 7; break; } else { __label__ = 24; break; }
    case 7: // $40
      var $41=$4;
      var $42=(function() { try { __THREW__ = false; return __ZNK11simple_listI14layout_elementE5firstEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; };
    case 8: // $43
      var $44=(($7+8)|0);
      HEAP32[(($44)>>2)]=$42;
      __label__ = 9; break;
    case 9: // $45
      var $46=(($7+8)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $49
      var $50=$name;
      var $51=(($7+8)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(function() { try { __THREW__ = false; return __ZNK14layout_element4nameEv($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $54
      var $55=(function() { try { __THREW__ = false; return _strcmp($50, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $56
      var $57=(($55)|0)==0;
      if ($57) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $58
      __label__ = 19; break;
    case 14: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      $5=$61;
      var $62=$60.f1;
      $6=$62;
      __label__ = 59; break;
    case 15: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      $5=$65;
      var $66=$64.f1;
      $6=$66;
      __label__ = 57; break;
    case 16: // $67
      __label__ = 17; break;
    case 17: // $68
      var $69=(($7+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(function() { try { __THREW__ = false; return __ZNK14layout_element4nextEv($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; };
    case 18: // $72
      var $73=(($7+8)|0);
      HEAP32[(($73)>>2)]=$71;
      __label__ = 9; break;
    case 19: // $74
      var $75=(($7+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $78
      var $79=___cxa_allocate_exception(1032);
      var $80=$79;
      var $81=$name;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($80, ((STRING_TABLE.__str494664)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $82
      (function() { try { __THREW__ = false; return ___cxa_throw($79, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 15; break; }
    case 22: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $5=$85;
      var $86=$84.f1;
      $6=$86;
      ___cxa_free_exception($79);
      __label__ = 57; break;
    case 23: // $87
      __label__ = 24; break;
    case 24: // $88
      var $89=$2;
      var $90=$3;
      var $91=(function() { try { __THREW__ = false; return __ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci($89, $90, ((STRING_TABLE.__str504665)|0), -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $92
      $index=$91;
      var $93=$index;
      var $94=(($93)|0)!=-1;
      if ($94) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $95
      var $96=$2;
      var $97=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($96) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 15; break; };
    case 27: // $98
      var $99=HEAP32[((_SCREEN)>>2)];
      var $100=$index;
      var $101=(function() { try { __THREW__ = false; return __ZNK11device_list4findEPFP8device_tRK14machine_configPKcS1_jEi($97, $99, $100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 15; break; };
    case 28: // $102
      var $103=(function() { try { __THREW__ = false; return __Z8downcastIP13screen_device8device_tET_PT0_($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 15; break; };
    case 29: // $104
      var $105=(($7+144)|0);
      HEAP32[(($105)>>2)]=$103;
      __label__ = 30; break;
    case 30: // $106
      var $107=$2;
      var $108=$3;
      var $109=(function() { try { __THREW__ = false; return __ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci($107, $108, ((STRING_TABLE.__str514666)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 15; break; };
    case 31: // $110
      var $111=(($7+140)|0);
      HEAP32[(($111)>>2)]=$109;
      var $112=(($7+12)|0);
      var $113=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 15; break; };
    case 32: // $114
      var $115=(($113)|0);
      var $116=HEAP8[($115)];
      var $117=(($116 << 24) >> 24);
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 33; break; } else { __label__ = 38; break; }
    case 33: // $119
      var $120=(($7+8)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121)|0)!=0;
      if ($122) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $123
      var $124=(($7+12)|0);
      var $125=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 15; break; };
    case 35: // $126
      var $127=(($7+8)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(function() { try { __THREW__ = false; return __ZNK14layout_element13default_stateEv($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 15; break; };
    case 36: // $130
      (function() { try { __THREW__ = false; return __Z16output_set_valuePKci($125, $129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 15; break; }
    case 37: // $131
      __label__ = 38; break;
    case 38: // $132
      var $133=$2;
      var $134=$3;
      var $135=(($134+8)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($136, ((STRING_TABLE.__str204635)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 15; break; };
    case 39: // $138
      var $139=(($7+168)|0);
      (function() { try { __THREW__ = false; return __Z12parse_boundsR15running_machineP14_xml_data_nodeR13render_bounds($133, $137, $139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 15; break; }
    case 40: // $140
      var $141=$2;
      var $142=$3;
      var $143=(($142+8)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($144, ((STRING_TABLE.__str214636)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 15; break; };
    case 41: // $146
      var $147=(($7+184)|0);
      (function() { try { __THREW__ = false; return __Z11parse_colorR15running_machineP14_xml_data_nodeR12render_color($141, $145, $147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 15; break; }
    case 42: // $148
      var $149=$2;
      var $150=$3;
      var $151=(($150+8)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($152, ((STRING_TABLE.__str524667)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 15; break; };
    case 43: // $154
      var $155=(($7+148)|0);
      (function() { try { __THREW__ = false; return __ZL17parse_orientationR15running_machineP14_xml_data_nodeRi($149, $153, $155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 15; break; }
    case 44: // $156
      var $157=$3;
      var $158=(($157+12)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(function() { try { __THREW__ = false; return _strcmp($159, ((STRING_TABLE.__str424657)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 15; break; };
    case 45: // $161
      var $162=(($160)|0)==0;
      if ($162) { __label__ = 46; break; } else { __label__ = 51; break; }
    case 46: // $163
      var $164=(($7+144)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165)|0)==0;
      if ($166) { __label__ = 47; break; } else { __label__ = 50; break; }
    case 47: // $167
      var $168=___cxa_allocate_exception(1032);
      var $169=$168;
      var $170=$index;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($169, ((STRING_TABLE.__str534668)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$170,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $171
      (function() { try { __THREW__ = false; return ___cxa_throw($168, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 15; break; }
    case 49: // $172
      var $173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $174=$173.f0;
      $5=$174;
      var $175=$173.f1;
      $6=$175;
      ___cxa_free_exception($168);
      __label__ = 57; break;
    case 50: // $176
      __label__ = 56; break;
    case 51: // $177
      var $178=(($7+8)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179)|0)==0;
      if ($180) { __label__ = 52; break; } else { __label__ = 55; break; }
    case 52: // $181
      var $182=___cxa_allocate_exception(1032);
      var $183=$182;
      var $184=$3;
      var $185=(($184+12)|0);
      var $186=HEAP32[(($185)>>2)];
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($183, ((STRING_TABLE.__str544669)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$186,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $187
      (function() { try { __THREW__ = false; return ___cxa_throw($182, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 15; break; }
    case 54: // $188
      var $189=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $190=$189.f0;
      $5=$190;
      var $191=$189.f1;
      $6=$191;
      ___cxa_free_exception($182);
      __label__ = 57; break;
    case 55: // $192
      __label__ = 56; break;
    case 56: // $193
      ;
      return;
    case 57: // $194
      var $195=(($7+76)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 62; break; }
    case 58: // $196
      __label__ = 59; break;
    case 59: // $197
      var $198=(($7+12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $199
      __label__ = 61; break;
    case 61: // $200
      var $201=$5;
      var $202=$5;
      var $203=$6;
      var $204=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $202, tempValue);
      var $205=($204.f1 = $203, $204);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $206
      var $207=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 63: // $208
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_view4itemC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE["X"]=1;

function __ZL17parse_orientationR15running_machineP14_xml_data_nodeRi($machine, $orientnode, $orientation) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $rotate;
      var $4;
      var $5;
      $1=$machine;
      $2=$orientnode;
      $3=$orientation;
      var $6=$2;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      HEAP32[(($9)>>2)]=0;
      __label__ = 16; break;
    case 2: // $10
      var $11=$1;
      var $12=$2;
      var $13=__ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci($11, $12, ((STRING_TABLE.__str604675)|0), 0);
      $rotate=$13;
      var $14=$rotate;
      if ($14 == 0) {
        __label__ = 3; break;
      }
      else if ($14 == 90) {
        __label__ = 4; break;
      }
      else if ($14 == 180) {
        __label__ = 5; break;
      }
      else if ($14 == 270) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 3: // $15
      var $16=$3;
      HEAP32[(($16)>>2)]=0;
      __label__ = 10; break;
    case 4: // $17
      var $18=$3;
      HEAP32[(($18)>>2)]=5;
      __label__ = 10; break;
    case 5: // $19
      var $20=$3;
      HEAP32[(($20)>>2)]=3;
      __label__ = 10; break;
    case 6: // $21
      var $22=$3;
      HEAP32[(($22)>>2)]=6;
      __label__ = 10; break;
    case 7: // $23
      var $24=___cxa_allocate_exception(1032);
      var $25=$24;
      var $26=$rotate;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($25, ((STRING_TABLE.__str614676)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $27
      ___cxa_throw($24, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $30=$29.f0;
      $4=$30;
      var $31=$29.f1;
      $5=$31;
      ___cxa_free_exception($24);
      __label__ = 17; break;
    case 10: // $32
      var $33=$1;
      var $34=$2;
      var $35=__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($33, $34, ((STRING_TABLE.__str634678)|0), ((STRING_TABLE.__str644679)|0));
      var $36=_strcmp(((STRING_TABLE.__str624677)|0), $35);
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $38
      var $39=$3;
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 ^ 4;
      HEAP32[(($39)>>2)]=$41;
      __label__ = 12; break;
    case 12: // $42
      var $43=$1;
      var $44=$2;
      var $45=__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($43, $44, ((STRING_TABLE.__str654680)|0), ((STRING_TABLE.__str644679)|0));
      var $46=_strcmp(((STRING_TABLE.__str624677)|0), $45);
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $48
      var $49=$3;
      var $50=HEAP32[(($49)>>2)];
      var $51=$50 ^ 1;
      HEAP32[(($49)>>2)]=$51;
      __label__ = 14; break;
    case 14: // $52
      var $53=$1;
      var $54=$2;
      var $55=__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_($53, $54, ((STRING_TABLE.__str664681)|0), ((STRING_TABLE.__str644679)|0));
      var $56=_strcmp(((STRING_TABLE.__str624677)|0), $55);
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $58
      var $59=$3;
      var $60=HEAP32[(($59)>>2)];
      var $61=$60 ^ 2;
      HEAP32[(($59)>>2)]=$61;
      __label__ = 16; break;
    case 16: // $62
      ;
      return;
    case 17: // $63
      var $64=$4;
      var $65=$4;
      var $66=$5;
      var $67=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $65, tempValue);
      var $68=($67.f1 = $66, $67);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17parse_orientationR15running_machineP14_xml_data_nodeRi["X"]=1;

function __ZN11layout_view4itemD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_view4itemD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_view4itemD0Ev["X"]=1;

function __ZN11layout_view4itemD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTVN11layout_view4itemE+8)|0);
      var $6=(($4+76)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4+12)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=(($4+12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI14layout_elementE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11layout_viewE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11layout_view4item5stateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $state;
      var $field;
      $1=$this;
      var $2=$1;
      $state=0;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+12)|0);
      var $6=__ZNK7astringcvPKcEv($5);
      var $7=(($6)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=(($2+12)|0);
      var $13=__ZNK7astringcvPKcEv($12);
      var $14=__Z16output_get_valuePKc($13);
      $state=$14;
      __label__ = 9; break;
    case 4: // $15
      var $16=(($2+76)|0);
      var $17=__ZNK7astringcvPKcEv($16);
      var $18=(($17)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $22
      var $23=(($2+8)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK14layout_element7machineEv($24);
      var $26=(($25+20)|0);
      var $27=(($2+76)|0);
      var $28=__ZNK7astringcvPKcEv($27);
      var $29=(($2+140)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__Z27input_field_by_tag_and_maskRK11tagged_listI17input_port_configEPKcj($26, $28, $30);
      $field=$31;
      var $32=$field;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=(($2+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=__ZNK14layout_element7machineEv($36);
      var $38=(($2+76)|0);
      var $39=__ZNK7astringcvPKcEv($38);
      var $40=__Z20input_port_read_safeR15running_machinePKcj($37, $39, 0);
      var $41=$field;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$40 ^ $43;
      var $45=(($2+140)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$44 & $46;
      var $48=(($47)|0)!=0;
      var $49=$48 ? 1 : 0;
      $state=$49;
      __label__ = 7; break;
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      __label__ = 9; break;
    case 9: // $52
      var $53=$state;
      ;
      return $53;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK11layout_view4item5stateEv["X"]=1;

function __ZN11simple_listI14layout_elementEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI14layout_elementEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listI11layout_viewEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI11layout_viewEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11layout_fileC2ER15running_machineR14_xml_data_nodePKc($this, $machine, $rootnode, $dirname) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i2=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $mamelayoutnode;
      var $version;
      var $elemnode;
      var $viewnode;
      $17=$this;
      $18=$machine;
      $19=$rootnode;
      $20=$dirname;
      var $23=$17;
      var $24=$23;
      HEAP32[(($24)>>2)]=((__ZTV11layout_file+8)|0);
      var $25=(($23+4)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($23+8)|0);
      var $27=$18;
      var $28=__ZN15running_machine7respoolEv($27);
      __ZN11simple_listI14layout_elementEC1ER13resource_pool($26, $28);
      var $29=(($23+28)|0);
      var $30=$18;
      var $31=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $32
      (function() { try { __THREW__ = false; return __ZN11simple_listI11layout_viewEC1ER13resource_pool($29, $31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $33
      var $34=$19;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($36, ((STRING_TABLE.__str554670)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $38
      $mamelayoutnode=$37;
      var $39=$mamelayoutnode;
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $41
      var $42=___cxa_allocate_exception(1032);
      var $43=$42;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($43, ((STRING_TABLE.__str564671)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $44
      (function() { try { __THREW__ = false; return ___cxa_throw($42, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 7; break; }
    case 6: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $21=$47;
      var $48=$46.f1;
      $22=$48;
      __label__ = 67; break;
    case 7: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body5 = $50;__label__ = 8; break;
    case 8: // $_body4
      var $eh_lpad_body5;
      var $eh_lpad_body = $eh_lpad_body5;__label__ = 9; break;
    case 9: // $_body
      var $eh_lpad_body;
      var $51=$eh_lpad_body.f0;
      $21=$51;
      var $52=$eh_lpad_body.f1;
      $22=$52;
      __label__ = 65; break;
    case 10: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $21=$55;
      var $56=$54.f1;
      $22=$56;
      ___cxa_free_exception($42);
      __label__ = 65; break;
    case 11: // $57
      var $58=$mamelayoutnode;
      var $59=(function() { try { __THREW__ = false; return __Z21xml_get_attribute_intP14_xml_data_nodePKci($58, ((STRING_TABLE.__str574672)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; };
    case 12: // $60
      $version=$59;
      var $61=$version;
      var $62=(($61)|0)!=2;
      if ($62) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $63
      var $64=___cxa_allocate_exception(1032);
      var $65=$64;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($65, ((STRING_TABLE.__str584673)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $66
      (function() { try { __THREW__ = false; return ___cxa_throw($64, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 7; break; }
    case 15: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $21=$69;
      var $70=$68.f1;
      $22=$70;
      ___cxa_free_exception($64);
      __label__ = 65; break;
    case 16: // $71
      var $72=$mamelayoutnode;
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($74, ((STRING_TABLE.__str484663)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 7; break; };
    case 17: // $76
      $elemnode=$75;
      __label__ = 18; break;
    case 18: // $77
      var $78=$elemnode;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 19; break; } else { __label__ = 40; break; }
    case 19: // $80
      var $81=(($23+8)|0);
      var $82=$18;
      var $83=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 7; break; };
    case 20: // $84
      var $85=$12;
      var $86=$13;
      var $87=$14;
      var $88=$result_i;
      var $89=$15;
      var $90=$16;
      HEAP32[(($12)>>2)]=108;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($14)>>2)]=1967;
      var $91=HEAP32[(($12)>>2)];
      var $92=HEAP32[(($13)>>2)];
      var $93=HEAP32[(($14)>>2)];
      var $94=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($91, $92, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; };
    case 21: // $95
      HEAP32[(($result_i)>>2)]=$94;
      var $96=HEAP32[(($result_i)>>2)];
      var $97=(($96)|0)==0;
      if ($97) { __label__ = 22; break; } else { __label__ = 28; break; }
    case 22: // $98
      var $99=___cxa_allocate_exception(4);
      var $100=$99;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($100);
      (function() { try { __THREW__ = false; return ___cxa_throw($99, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 23; break; }
    case 23: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $103=$102.f0;
      HEAP32[(($15)>>2)]=$103;
      var $104=$102.f1;
      HEAP32[(($16)>>2)]=$104;
      var $105=HEAP32[(($16)>>2)];
      var $106=(($105)|0) < 0;
      if ($106) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $107
      var $108=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 7; break; }
    case 25: // $_noexc
      throw "Reached an unreachable!"
    case 26: // $109
      var $110=HEAP32[(($15)>>2)];
      var $111=HEAP32[(($15)>>2)];
      var $112=HEAP32[(($16)>>2)];
      var $113=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $111, tempValue);
      var $114=($113.f1 = $112, $113);
      var $eh_lpad_body = $114;__label__ = 9; break;
    case 27: // $115
      throw "Reached an unreachable!"
    case 28: // $_ZnwjPKci_exit
      var $116=HEAP32[(($result_i)>>2)];
      var $117=$12;
      var $118=$13;
      var $119=$14;
      var $120=$result_i;
      var $121=$15;
      var $122=$16;
      __label__ = 29; break;
    case 29: // $123
      var $124=$116;
      var $125=$18;
      var $126=$elemnode;
      var $127=$20;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_elementC1ER15running_machineR14_xml_data_nodePKc]($124, $125, $126, $127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $128
      var $129=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI14layout_elementEEPT_S3_($83, $124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 7; break; };
    case 31: // $130
      var $131=(function() { try { __THREW__ = false; return __ZN11simple_listI14layout_elementE6appendERS0_($81, $129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 7; break; };
    case 32: // $132
      __label__ = 33; break;
    case 33: // $133
      var $134=$elemnode;
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($136, ((STRING_TABLE.__str484663)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 7; break; };
    case 34: // $138
      $elemnode=$137;
      __label__ = 18; break;
    case 35: // $139
      var $140=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $141=$140.f0;
      $21=$141;
      var $142=$140.f1;
      $22=$142;
      var $143=$9;
      var $144=$10;
      var $145=$11;
      HEAP32[(($9)>>2)]=$116;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($11)>>2)]=1967;
      var $146=HEAP32[(($9)>>2)];
      var $147=(($146)|0)!=0;
      if ($147) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $148
      var $149=HEAP32[(($9)>>2)];
      var $150=HEAP32[(($10)>>2)];
      var $151=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($149, $150, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 70; break; }
    case 37: // $_noexc1
      __label__ = 38; break;
    case 38: // $_ZdlPvPKci_exit
      var $152=$9;
      var $153=$10;
      var $154=$11;
      __label__ = 39; break;
    case 39: // $155
      __label__ = 65; break;
    case 40: // $156
      var $157=$mamelayoutnode;
      var $158=(($157+8)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($159, ((STRING_TABLE.__str594674)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 7; break; };
    case 41: // $161
      $viewnode=$160;
      __label__ = 42; break;
    case 42: // $162
      var $163=$viewnode;
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 43; break; } else { __label__ = 64; break; }
    case 43: // $165
      var $166=(($23+28)|0);
      var $167=$18;
      var $168=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 7; break; };
    case 44: // $169
      var $170=$4;
      var $171=$5;
      var $172=$6;
      var $173=$result_i2;
      var $174=$7;
      var $175=$8;
      HEAP32[(($4)>>2)]=276;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($6)>>2)]=1971;
      var $176=HEAP32[(($4)>>2)];
      var $177=HEAP32[(($5)>>2)];
      var $178=HEAP32[(($6)>>2)];
      var $179=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($176, $177, $178) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; };
    case 45: // $180
      HEAP32[(($result_i2)>>2)]=$179;
      var $181=HEAP32[(($result_i2)>>2)];
      var $182=(($181)|0)==0;
      if ($182) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $183
      var $184=___cxa_allocate_exception(4);
      var $185=$184;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($185);
      (function() { try { __THREW__ = false; return ___cxa_throw($184, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 47; break; }
    case 47: // $186
      var $187=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $188=$187.f0;
      HEAP32[(($7)>>2)]=$188;
      var $189=$187.f1;
      HEAP32[(($8)>>2)]=$189;
      var $190=HEAP32[(($8)>>2)];
      var $191=(($190)|0) < 0;
      if ($191) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $192
      var $193=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 7; break; }
    case 49: // $_noexc3
      throw "Reached an unreachable!"
    case 50: // $194
      var $195=HEAP32[(($7)>>2)];
      var $196=HEAP32[(($7)>>2)];
      var $197=HEAP32[(($8)>>2)];
      var $198=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $196, tempValue);
      var $199=($198.f1 = $197, $198);
      var $eh_lpad_body5 = $199;__label__ = 8; break;
    case 51: // $200
      throw "Reached an unreachable!"
    case 52: // $_ZnwjPKci_exit6
      var $201=HEAP32[(($result_i2)>>2)];
      var $202=$4;
      var $203=$5;
      var $204=$6;
      var $205=$result_i2;
      var $206=$7;
      var $207=$8;
      __label__ = 53; break;
    case 53: // $208
      var $209=$201;
      var $210=$18;
      var $211=$viewnode;
      var $212=(($23+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_viewC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE]($209, $210, $211, $212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 59; break; }
    case 54: // $213
      var $214=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI11layout_viewEEPT_S3_($168, $209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 7; break; };
    case 55: // $215
      var $216=(function() { try { __THREW__ = false; return __ZN11simple_listI11layout_viewE6appendERS0_($166, $214) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 7; break; };
    case 56: // $217
      __label__ = 57; break;
    case 57: // $218
      var $219=$viewnode;
      var $220=(($219)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(function() { try { __THREW__ = false; return __Z15xml_get_siblingP14_xml_data_nodePKc($221, ((STRING_TABLE.__str594674)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 7; break; };
    case 58: // $223
      $viewnode=$222;
      __label__ = 42; break;
    case 59: // $224
      var $225=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $226=$225.f0;
      $21=$226;
      var $227=$225.f1;
      $22=$227;
      var $228=$1;
      var $229=$2;
      var $230=$3;
      HEAP32[(($1)>>2)]=$201;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str184633)|0);
      HEAP32[(($3)>>2)]=1971;
      var $231=HEAP32[(($1)>>2)];
      var $232=(($231)|0)!=0;
      if ($232) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $233
      var $234=HEAP32[(($1)>>2)];
      var $235=HEAP32[(($2)>>2)];
      var $236=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($234, $235, $236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 70; break; }
    case 61: // $_noexc7
      __label__ = 62; break;
    case 62: // $_ZdlPvPKci_exit8
      var $237=$1;
      var $238=$2;
      var $239=$3;
      __label__ = 63; break;
    case 63: // $240
      __label__ = 65; break;
    case 64: // $241
      STACKTOP = __stackBase__;
      return;
    case 65: // $242
      var $243=(($23+28)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11layout_viewED1Ev($243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 70; break; }
    case 66: // $244
      __label__ = 67; break;
    case 67: // $245
      var $246=(($23+8)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI14layout_elementED1Ev($246) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $247
      __label__ = 69; break;
    case 69: // $248
      var $249=$21;
      var $250=$21;
      var $251=$22;
      var $252=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $250, tempValue);
      var $253=($252.f1 = $251, $252);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 70: // $254
      var $255=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 71: // $256
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_fileC2ER15running_machineR14_xml_data_nodePKc["X"]=1;

function __ZN13resource_pool10add_objectI14layout_elementEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14layout_elementEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14layout_elementEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI11layout_viewEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11layout_viewEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI11layout_viewEEPT_S3_["X"]=1;

function __ZN11simple_listI11layout_viewE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11layout_viewE6detachERS0_["X"]=1;

function __ZN11simple_listI11layout_viewED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI11layout_viewED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI14layout_elementED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI14layout_elementED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI11layout_viewEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI11layout_viewEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI11layout_viewEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 276);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI11layout_viewE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI11layout_viewED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI11layout_viewED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI14layout_elementEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14layout_elementEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14layout_elementEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 108);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14layout_elementE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14layout_elementED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14layout_elementED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI11layout_viewED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI11layout_viewE+8)|0);
  __ZN11simple_listI11layout_viewE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI11layout_viewE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI11layout_viewE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11layout_viewE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI11layout_viewE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listI14layout_elementED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI14layout_elementE+8)|0);
  __ZN11simple_listI14layout_elementE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listI14layout_elementE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI14layout_elementE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI14layout_elementE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI14layout_elementE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11layout_fileD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11layout_fileD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11layout_fileD0Ev["X"]=1;

function __ZN11layout_fileD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV11layout_file+8)|0);
      var $6=(($4+28)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI11layout_viewED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4+8)|0);
      __ZN11simple_listI14layout_elementED1Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=(($4+8)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI14layout_elementED1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI11layout_viewED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI11layout_viewED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI11layout_viewED0Ev["X"]=1;

function __ZN20resource_pool_objectI11layout_viewED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI11layout_viewE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI14layout_elementED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14layout_elementED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14layout_elementED0Ev["X"]=1;

function __ZN20resource_pool_objectI14layout_elementED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI14layout_elementE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI11layout_viewED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI11layout_viewED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI11layout_viewED0Ev["X"]=1;

function __ZN11simple_listI14layout_elementED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI14layout_elementED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI14layout_elementED0Ev["X"]=1;

function __ZN11simple_listI14layout_elementE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI14layout_elementE6detachERS0_["X"]=1;

function __ZN11simple_listI11layout_viewEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI11layout_viewE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI14layout_elementEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI14layout_elementE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN11layout_view4itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN11layout_view4itemEE6detachERS1_["X"]=1;

function __ZN11simple_listIN11layout_view4itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN11layout_view4itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN20resource_pool_objectIN11layout_view4itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN11layout_view4itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN11layout_view4itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 200);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN11layout_view4itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN11layout_view4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN11layout_view4itemEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN11layout_view4itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN11layout_view4itemEE+8)|0);
  __ZN11simple_listIN11layout_view4itemEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN11layout_view4itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN11layout_view4itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11layout_view4itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN11layout_view4itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN19resource_pool_arrayIN14layout_element7textureEEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIN14layout_element7textureEEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIN14layout_element7textureEEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=(($8*12)|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIN14layout_element7textureEE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIN14layout_element7textureEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIN14layout_element7textureEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN14layout_element9componentEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN14layout_element9componentEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN14layout_element9componentEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 312);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN14layout_element9componentEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN14layout_element9componentEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN14layout_element9componentEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN11layout_view4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN11layout_view4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN11layout_view4itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN11layout_view4itemEED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectIN11layout_view4itemEE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN11layout_view4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN11layout_view4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN11layout_view4itemEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN14layout_element7textureEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN14layout_element7textureEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN14layout_element7textureEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN14layout_element7textureEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV19resource_pool_arrayIN14layout_element7textureEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 9; break; } else { __label__ = 1; break; }
    case 1: // $15
      var $16=$13;
      var $17=(($16-4)|0);
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($13+$19*12)|0);
      var $21=(($13)|0)==(($20)|0);
      if ($21) { __label__ = 4; break; } else { var $23 = $20;__label__ = 2; break; }
    case 2: // $22
      var $23;
      var $24=(($23-12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_element7textureD1Ev]($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $25
      var $26=(($24)|0)==(($13)|0);
      if ($26) { __label__ = 4; break; } else { var $23 = $24;__label__ = 2; break; }
    case 4: // $27
      var $28=$4;
      var $29=$5;
      var $30=$6;
      HEAP32[(($4)>>2)]=$17;
      var $31=HEAP32[(($4)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $33
      var $34=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($34, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      __label__ = 8; break;
    case 7: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($5)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($6)>>2)]=$39;
      var $40=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($40);
      throw "Reached an unreachable!"
    case 8: // $_ZdaPv_exit
      var $41=$4;
      var $42=$5;
      var $43=$6;
      __label__ = 9; break;
    case 9: // $44
      var $45=$10;
      __ZN18resource_pool_itemD2Ev($45);
      STACKTOP = __stackBase__;
      return;
    case 10: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $8=$48;
      var $49=$47.f1;
      $9=$49;
      var $50=(($13)|0)==(($24)|0);
      if ($50) { __label__ = 13; break; } else { var $52 = $24;__label__ = 11; break; }
    case 11: // $51
      var $52;
      var $53=(($52-12)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_element7textureD1Ev]($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $54
      var $55=(($53)|0)==(($13)|0);
      if ($55) { __label__ = 13; break; } else { var $52 = $53;__label__ = 11; break; }
    case 13: // $56
      var $57=$1;
      var $58=$2;
      var $59=$3;
      HEAP32[(($1)>>2)]=$17;
      var $60=HEAP32[(($1)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $62
      var $63=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($63, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $64
      __label__ = 17; break;
    case 16: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      HEAP32[(($2)>>2)]=$67;
      var $68=$66.f1;
      HEAP32[(($3)>>2)]=$68;
      var $69=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($69);
      throw "Reached an unreachable!"
    case 17: // $_ZdaPv_exit1
      var $70=$1;
      var $71=$2;
      var $72=$3;
      var $73=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $74
      __label__ = 19; break;
    case 19: // $75
      var $76=$8;
      var $77=$8;
      var $78=$9;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN14layout_element7textureEED2Ev["X"]=1;

function __ZN11simple_listIN14layout_element9componentEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN14layout_element9componentEE6detachERS1_["X"]=1;

function __ZN11simple_listIN14layout_element9componentEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN14layout_element9componentEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN18render_screen_list4itemEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN18render_screen_list4itemEE4poolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN18render_screen_list4itemC2ER13screen_device($this, $screen) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$screen;
  var $3=$1;
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($3+4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  ;
  return;
}


function __ZN11simple_listIN14layout_element9componentEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN14layout_element9componentEE+8)|0);
  __ZN11simple_listIN14layout_element9componentEE5resetEv($2);
  ;
  return;
}


function __ZN11simple_listIN14layout_element9componentEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN14layout_element9componentEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN14layout_element9componentEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN14layout_element9componentEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN18render_screen_list4itemC1ER13screen_device($this, $screen) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$screen;
  var $3=$1;
  var $4=$2;
  __ZN18render_screen_list4itemC2ER13screen_device($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN18render_screen_list4itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN18render_screen_list4itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN18render_screen_list4itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 8);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN18render_screen_list4itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN18render_screen_list4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN18render_screen_list4itemEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN18render_screen_list4itemEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN18render_screen_list4itemEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN18render_screen_list4itemEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN18render_screen_list4itemEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN20resource_pool_objectIN14layout_element9componentEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN14layout_element9componentEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN14layout_element9componentEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN14layout_element9componentEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN14layout_element9componentEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14layout_element9componentD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN14layout_element9componentEED2Ev["X"]=1;

function __ZN11simple_listIN14layout_element9componentEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN14layout_element9componentEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN14layout_element9componentEED0Ev["X"]=1;

function __ZN13resource_pool10add_objectIN18render_screen_list4itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN18render_screen_list4itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN18render_screen_list4itemEEEPT_S4_["X"]=1;

function __ZN20resource_pool_objectIN18render_screen_list4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN18render_screen_list4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN18render_screen_list4itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN18render_screen_list4itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN18render_screen_list4itemEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z3gcdii($a, $b) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $t;
      $1=$a;
      $2=$b;
      __label__ = 1; break;
    case 1: // $3
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $6
      var $7=$2;
      $t=$7;
      var $8=$1;
      var $9=$2;
      var $10=(($8)|0)%(($9)|0);
      $2=$10;
      var $11=$t;
      $1=$11;
      __label__ = 1; break;
    case 3: // $12
      var $13=$1;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN18render_screen_list4itemEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN18render_screen_list4itemEE6detachERS1_["X"]=1;

function __ZN11simple_listIN18render_screen_list4itemEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN18render_screen_list4itemEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZL18get_variable_valueR15running_machinePKcPPc($machine, $string, $outputptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $temp=__stackBase__;
      var $device;
      var $scrnum;
      var $num=__stackBase__+100;
      var $den=__stackBase__+104;
      var $num1=__stackBase__+108;
      var $den2=__stackBase__+112;
      $2=$machine;
      $3=$string;
      $4=$outputptr;
      var $5=$2;
      var $6=__ZNK15running_machine12first_screenEv($5);
      $device=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$device;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $10
      var $11=$2;
      var $12=__ZNK15running_machine10devicelistEv($11);
      var $13=HEAP32[((_SCREEN)>>2)];
      var $14=$device;
      var $15=$14;
      var $16=__ZNK8device_t3tagEv($15);
      var $17=__ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jES6_($12, $13, $16);
      $scrnum=$17;
      var $18=(($temp)|0);
      var $19=$scrnum;
      var $20=_sprintf($18, ((STRING_TABLE.__str714686)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt));
      var $21=$3;
      var $22=(($temp)|0);
      var $23=(($temp)|0);
      var $24=_strlen($23);
      var $25=_strncmp($21, $22, $24);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $27
      var $28=$device;
      var $29=__ZNK13screen_device12visible_areaEv($28);
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+1)|0);
      var $33=$device;
      var $34=__ZNK13screen_device12visible_areaEv($33);
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($32-$36)|0);
      HEAP32[(($num)>>2)]=$37;
      var $38=$device;
      var $39=__ZNK13screen_device12visible_areaEv($38);
      var $40=(($39+12)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+1)|0);
      var $43=$device;
      var $44=__ZNK13screen_device12visible_areaEv($43);
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($42-$46)|0);
      HEAP32[(($den)>>2)]=$47;
      __Z15reduce_fractionRiS_($num, $den);
      var $48=$4;
      var $49=HEAP32[(($48)>>2)];
      var $50=HEAP32[(($num)>>2)];
      var $51=_sprintf($49, ((STRING_TABLE.__str704685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$50,tempInt));
      var $52=$4;
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+$51)|0);
      HEAP32[(($52)>>2)]=$54;
      var $55=(($temp)|0);
      var $56=_strlen($55);
      $1=$56;
      __label__ = 13; break;
    case 4: // $57
      var $58=(($temp)|0);
      var $59=$scrnum;
      var $60=_sprintf($58, ((STRING_TABLE.__str724687)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$59,tempInt));
      var $61=$3;
      var $62=(($temp)|0);
      var $63=(($temp)|0);
      var $64=_strlen($63);
      var $65=_strncmp($61, $62, $64);
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $67
      var $68=$device;
      var $69=__ZNK13screen_device12visible_areaEv($68);
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71+1)|0);
      var $73=$device;
      var $74=__ZNK13screen_device12visible_areaEv($73);
      var $75=(($74)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($72-$76)|0);
      HEAP32[(($num1)>>2)]=$77;
      var $78=$device;
      var $79=__ZNK13screen_device12visible_areaEv($78);
      var $80=(($79+12)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+1)|0);
      var $83=$device;
      var $84=__ZNK13screen_device12visible_areaEv($83);
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($82-$86)|0);
      HEAP32[(($den2)>>2)]=$87;
      __Z15reduce_fractionRiS_($num1, $den2);
      var $88=$4;
      var $89=HEAP32[(($88)>>2)];
      var $90=HEAP32[(($den2)>>2)];
      var $91=_sprintf($89, ((STRING_TABLE.__str704685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$90,tempInt));
      var $92=$4;
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+$91)|0);
      HEAP32[(($92)>>2)]=$94;
      var $95=(($temp)|0);
      var $96=_strlen($95);
      $1=$96;
      __label__ = 13; break;
    case 6: // $97
      var $98=(($temp)|0);
      var $99=$scrnum;
      var $100=_sprintf($98, ((STRING_TABLE.__str734688)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$99,tempInt));
      var $101=$3;
      var $102=(($temp)|0);
      var $103=(($temp)|0);
      var $104=_strlen($103);
      var $105=_strncmp($101, $102, $104);
      var $106=(($105)|0)!=0;
      if ($106) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $107
      var $108=$4;
      var $109=HEAP32[(($108)>>2)];
      var $110=$device;
      var $111=__ZNK13screen_device12visible_areaEv($110);
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+1)|0);
      var $115=$device;
      var $116=__ZNK13screen_device12visible_areaEv($115);
      var $117=(($116)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($114-$118)|0);
      var $120=_sprintf($109, ((STRING_TABLE.__str704685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$119,tempInt));
      var $121=$4;
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122+$120)|0);
      HEAP32[(($121)>>2)]=$123;
      var $124=(($temp)|0);
      var $125=_strlen($124);
      $1=$125;
      __label__ = 13; break;
    case 8: // $126
      var $127=(($temp)|0);
      var $128=$scrnum;
      var $129=_sprintf($127, ((STRING_TABLE.__str744689)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$128,tempInt));
      var $130=$3;
      var $131=(($temp)|0);
      var $132=(($temp)|0);
      var $133=_strlen($132);
      var $134=_strncmp($130, $131, $133);
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $136
      var $137=$4;
      var $138=HEAP32[(($137)>>2)];
      var $139=$device;
      var $140=__ZNK13screen_device12visible_areaEv($139);
      var $141=(($140+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      var $144=$device;
      var $145=__ZNK13screen_device12visible_areaEv($144);
      var $146=(($145+8)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($143-$147)|0);
      var $149=_sprintf($138, ((STRING_TABLE.__str704685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$148,tempInt));
      var $150=$4;
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+$149)|0);
      HEAP32[(($150)>>2)]=$152;
      var $153=(($temp)|0);
      var $154=_strlen($153);
      $1=$154;
      __label__ = 13; break;
    case 10: // $155
      __label__ = 11; break;
    case 11: // $156
      var $157=$device;
      var $158=__ZNK13screen_device11next_screenEv($157);
      $device=$158;
      __label__ = 1; break;
    case 12: // $159
      var $160=$3;
      var $161=HEAP8[($160)];
      var $162=$4;
      var $163=HEAP32[(($162)>>2)];
      HEAP8[($163)]=$161;
      var $164=$4;
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165+1)|0);
      HEAP32[(($164)>>2)]=$166;
      $1=1;
      __label__ = 13; break;
    case 13: // $167
      var $168=$1;
      STACKTOP = __stackBase__;
      return $168;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18get_variable_valueR15running_machinePKcPPc["X"]=1;

function __Z15reduce_fractionRiS_($num, $den) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $div;
      $1=$num;
      $2=$den;
      var $3=$1;
      var $4=HEAP32[(($3)>>2)];
      var $5=$2;
      var $6=HEAP32[(($5)>>2)];
      var $7=__Z3gcdii($4, $6);
      $div=$7;
      var $8=$div;
      var $9=(($8)|0) > 1;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$div;
      var $12=$1;
      var $13=HEAP32[(($12)>>2)];
      var $14=(((($13)|0)/(($11)|0))|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=$div;
      var $16=$2;
      var $17=HEAP32[(($16)>>2)];
      var $18=(((($17)|0)/(($15)|0))|0);
      HEAP32[(($16)>>2)]=$18;
      __label__ = 2; break;
    case 2: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18render_screen_listD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  __ZN11simple_listIN18render_screen_list4itemEED1Ev($3);
  ;
  return;
}


function __ZN11simple_listIN18render_screen_list4itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN18render_screen_list4itemEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN18render_screen_list4itemEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN18render_screen_list4itemEE+8)|0);
  __ZN11simple_listIN18render_screen_list4itemEE5resetEv($2);
  ;
  return;
}


function __ZN18render_screen_listC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  __ZN11simple_listIN18render_screen_list4itemEEC1ER13resource_pool($4, $5);
  ;
  return;
}


function __ZN11simple_listIN18render_screen_list4itemEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN18render_screen_list4itemEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __GLOBAL__I_a4702() {
  ;
  var __label__;

  ___cxx_global_var_init4692();
  ;
  return;
}


function __ZN11simple_listIN18render_screen_list4itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN18render_screen_list4itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN18render_screen_list4itemEED0Ev["X"]=1;

function __ZN11render_fontC2ER14render_managerPKc($this, $manager, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 260; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ramfile=__stackBase__;
      var $filerr;
      var $4;
      var $5;
      $1=$this;
      $2=$manager;
      $3=$filename;
      var $6=$1;
      var $7=$6;
      HEAP32[(($7)>>2)]=((__ZTV11render_font+8)|0);
      var $8=(($6+4)|0);
      var $9=$2;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($6+8)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($6+12)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($6+16)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=(($6+20)|0);
      HEAPF32[(($13)>>2)]=1;
      var $14=(($6+1048)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($6+1052)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$29$0=(($15)|0);
      HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
      var $st$29$1=(($15+4)|0);
      HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
      var $16=(($6+1060)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($6+24)|0);
      var $18=(($17)|0);
      var $19=$18;
      _memset($19, 0, 1024, 1);
      var $20=$3;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $22
      var $23=$2;
      var $24=__ZNK14render_manager7machineEv($23);
      var $25=__ZNK15running_machine3osdEv($24);
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+36)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=(($6+12)|0);
      var $32=FUNCTION_TABLE[$29]($25, $30, $31);
      var $33=(($6+1060)|0);
      HEAP32[(($33)>>2)]=$32;
      var $34=(($6+1060)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $37
      var $38=(($6+12)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0);
      var $41=1/$40;
      var $42=(($6+20)|0);
      HEAPF32[(($42)>>2)]=$41;
      var $43=(($6+8)|0);
      HEAP32[(($43)>>2)]=3;
      __label__ = 16; break;
    case 3: // $44
      __label__ = 4; break;
    case 4: // $45
      var $46=$3;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $48
      var $49=$3;
      var $50=__Z12core_stricmpPKcS0_($49, ((STRING_TABLE.__str4705)|0));
      var $51=(($50)|0)==0;
      if ($51) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $52
      $3=((STRING_TABLE.__str14706)|0);
      __label__ = 7; break;
    case 7: // $53
      var $54=$3;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $56
      var $57=$3;
      var $58=__ZN11render_font15load_cached_bdfEPKc($6, $57);
      if ($58) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $59
      __label__ = 16; break;
    case 10: // $60
      FUNCTION_TABLE[__ZN8emu_fileC1Ej]($ramfile, 1);
      var $61=(function() { try { __THREW__ = false; return __ZN8emu_file8open_ramEPKvj($ramfile, ((STRING_TABLE._font_uismall)|0), 3772) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $62
      $filerr=$61;
      var $63=$filerr;
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $65
      var $66=(function() { try { __THREW__ = false; return __ZN11render_font11load_cachedER8emu_filej($6, $ramfile, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $67
      __label__ = 15; break;
    case 14: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $4=$70;
      var $71=$69.f1;
      $5=$71;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($ramfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 15: // $72
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($ramfile);
      __label__ = 16; break;
    case 16: // $73
      STACKTOP = __stackBase__;
      return;
    case 17: // $74
      __label__ = 18; break;
    case 18: // $75
      var $76=$4;
      var $77=$4;
      var $78=$5;
      var $79=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $77, tempValue);
      var $80=($79.f1 = $78, $79);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_fontC2ER14render_managerPKc["X"]=1;

function __ZN11render_font15load_cached_bdfEPKc($this, $filename) {
  var __stackBase__  = STACKTOP; STACKTOP += 612; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $file=__stackBase__+28;
      var $filerr;
      var $10;
      var $11;
      var $12;
      var $data;
      var $bytes;
      var $hash;
      var $cachedname=__stackBase__+288;
      var $cachefile=__stackBase__+352;
      var $result;
      var $read;
      var $result1;
      $8=$this;
      $9=$filename;
      var $13=$8;
      var $14=__ZNK11render_font7managerEv($13);
      var $15=__ZNK14render_manager7machineEv($14);
      var $16=__ZNK15running_machine7optionsEv($15);
      var $17=__ZNK11emu_options9font_pathEv($16);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $17, 1);
      var $18=$9;
      var $19=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $20
      $filerr=$19;
      var $21=$filerr;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $23
      $7=0;
      $12=1;
      __label__ = 71; break;
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $25;__label__ = 4; break;
    case 4: // $_body
      var $eh_lpad_body;
      var $26=$eh_lpad_body.f0;
      $10=$26;
      var $27=$eh_lpad_body.f1;
      $11=$27;
      __label__ = 72; break;
    case 5: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN8emu_file4sizeEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; };
      var $29$0=$29[0];
      var $29$1=$29[1];
    case 6: // $30
      var $31=(($13+1052)|0);
      var $st$1$0=(($31)|0);
      HEAP32[(($st$1$0)>>2)]=$29$0;
      var $st$1$1=(($31+4)|0);
      HEAP32[(($st$1$1)>>2)]=$29$1;
      var $32=(($13+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 3; break; };
    case 7: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 3; break; };
    case 8: // $37
      var $38=(($13+1052)|0);
      var $st$1$0=(($38)|0);
      var $39$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($38+4)|0);
      var $39$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $40$0 = ((($39$0)>>>0)+((($39$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $40$1 = Math.min(Math.floor((((($39$0)>>>0)+((($39$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=1;
      var $41=$40$1 >= $$emscripten$temp$1$1 && ($40$1 > $$emscripten$temp$1$1 || $40$0 >= $$emscripten$temp$1$0);
      var $42$0=$40$0;
      var $42=$42$0;
      var $43=$41 ? -1 : $42;
      var $44=$1;
      var $45=$2;
      var $46=$3;
      var $47=$4;
      var $48=$result_i;
      var $49=$5;
      var $50=$6;
      HEAP32[(($1)>>2)]=$43;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($3)>>2)]=422;
      HEAP32[(($4)>>2)]=_zeromem;
      var $51=HEAP32[(($1)>>2)];
      var $52=HEAP32[(($2)>>2)];
      var $53=HEAP32[(($3)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($51, $52, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $55
      HEAP32[(($result_i)>>2)]=$54;
      var $56=HEAP32[(($result_i)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $58
      var $59=___cxa_allocate_exception(4);
      var $60=$59;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($60);
      (function() { try { __THREW__ = false; return ___cxa_throw($59, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; }
    case 11: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($5)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($6)>>2)]=$64;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65)|0) < 0;
      if ($66) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $67
      var $68=HEAP32[(($5)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 3; break; }
    case 13: // $_noexc
      throw "Reached an unreachable!"
    case 14: // $69
      var $70=HEAP32[(($5)>>2)];
      var $71=HEAP32[(($5)>>2)];
      var $72=HEAP32[(($6)>>2)];
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      var $eh_lpad_body = $74;__label__ = 4; break;
    case 15: // $75
      throw "Reached an unreachable!"
    case 16: // $_ZnajPKciRK9zeromem_t_exit
      var $76=HEAP32[(($result_i)>>2)];
      var $77=HEAP32[(($1)>>2)];
      _memset($76, 0, $77, 1);
      var $78=HEAP32[(($result_i)>>2)];
      var $79=$1;
      var $80=$2;
      var $81=$3;
      var $82=$4;
      var $83=$result_i;
      var $84=$5;
      var $85=$6;
      __label__ = 17; break;
    case 17: // $86
      var $87=(($13+1052)|0);
      var $st$1$0=(($87)|0);
      var $88$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($87+4)|0);
      var $88$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $89$0 = ((($88$0)>>>0)+((($88$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $89$1 = Math.min(Math.floor((((($88$0)>>>0)+((($88$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $90$0=$89$0;
      var $90=$90$0;
      var $91=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIcEEPT_S2_i($36, $78, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 3; break; };
    case 18: // $92
      $data=$91;
      var $93=$data;
      var $94=(($13+1052)|0);
      var $st$3$0=(($94)|0);
      var $95$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($94+4)|0);
      var $95$1=HEAP32[(($st$3$1)>>2)];
      var $$emscripten$temp$3$0=1024;
      var $$emscripten$temp$3$1=0;
      var $96=$$emscripten$temp$3$1 < $95$1 || ($$emscripten$temp$3$1 == $95$1 && $$emscripten$temp$3$0 < $95$0);
      if ($96) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $97
      var $102$1 = 0;var $102$0 = 1024;__label__ = 21; break;
    case 20: // $98
      var $99=(($13+1052)|0);
      var $st$1$0=(($99)|0);
      var $100$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($99+4)|0);
      var $100$1=HEAP32[(($st$1$1)>>2)];
      var $102$1 = $100$1;var $102$0 = $100$0;__label__ = 21; break;
    case 21: // $101
      var $102$0;
      var $102$1;
      var $103$0=$102$0;
      var $103=$103$0;
      var $104=(function() { try { __THREW__ = false; return __ZN8emu_file4readEPvj($file, $93, $103) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 3; break; };
    case 22: // $105
      $bytes=$104;
      var $106=$bytes;
      var $107$0=$106;
      var $107$1=0;
      var $108=(($13+1052)|0);
      var $st$5$0=(($108)|0);
      var $109$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($108+4)|0);
      var $109$1=HEAP32[(($st$5$1)>>2)];
      var $$emscripten$temp$4$0=1024;
      var $$emscripten$temp$4$1=0;
      var $110=$$emscripten$temp$4$1 < $109$1 || ($$emscripten$temp$4$1 == $109$1 && $$emscripten$temp$4$0 < $109$0);
      if ($110) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $111
      var $116$1 = 0;var $116$0 = 1024;__label__ = 25; break;
    case 24: // $112
      var $113=(($13+1052)|0);
      var $st$1$0=(($113)|0);
      var $114$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($113+4)|0);
      var $114$1=HEAP32[(($st$1$1)>>2)];
      var $116$1 = $114$1;var $116$0 = $114$0;__label__ = 25; break;
    case 25: // $115
      var $116$0;
      var $116$1;
      var $117=$107$0 != $116$0 || $107$1 != $116$1;
      if ($117) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $118
      $7=0;
      $12=1;
      __label__ = 71; break;
    case 27: // $119
      var $120=$data;
      var $121=$bytes;
      var $122=(function() { try { __THREW__ = false; return _crc32(0, $120, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 3; break; };
    case 28: // $123
      var $124=(($13+1052)|0);
      var $st$1$0=(($124)|0);
      var $125$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($124+4)|0);
      var $125$1=HEAP32[(($st$1$1)>>2)];
      var $126$0=$125$0;
      var $126=$126$0;
      var $127=$122 ^ $126;
      $hash=$127;
      var $128=$9;
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($cachedname, $128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 3; break; }
    case 29: // $129
      var $130=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($cachedname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 46; break; };
    case 30: // $131
      var $132=(($130-3)|0);
      var $133=(function() { try { __THREW__ = false; return __ZN7astring3delEii($cachedname, $132, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 46; break; };
    case 31: // $134
      var $135=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($133, ((STRING_TABLE.__str34708)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 46; break; };
    case 32: // $136
      var $137=(function() { try { __THREW__ = false; return __ZNK11render_font7managerEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 46; break; };
    case 33: // $138
      var $139=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 46; break; };
    case 34: // $140
      var $141=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 46; break; };
    case 35: // $142
      var $143=(function() { try { __THREW__ = false; return __ZNK11emu_options9font_pathEv($141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 46; break; };
    case 36: // $144
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($cachefile, $143, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 46; break; }
    case 37: // $145
      var $146=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($cachedname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 47; break; };
    case 38: // $147
      var $148=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($cachefile, $146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 47; break; };
    case 39: // $149
      $filerr=$148;
      var $150=$filerr;
      var $151=(($150)|0)==0;
      if ($151) { __label__ = 40; break; } else { __label__ = 49; break; }
    case 40: // $152
      var $153=$hash;
      var $154=(function() { try { __THREW__ = false; return __ZN11render_font11load_cachedER8emu_filej($13, $cachefile, $153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 47; break; };
    case 41: // $155
      var $156=(($154)&1);
      $result=$156;
      var $157=$result;
      var $158=(($157) & 1);
      if ($158) { __label__ = 42; break; } else { __label__ = 48; break; }
    case 42: // $159
      var $160=(($13+4)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 47; break; };
    case 43: // $163
      var $164=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 47; break; };
    case 44: // $165
      var $166=$data;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($164, $166) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $167
      $7=1;
      $12=1;
      __label__ = 50; break;
    case 46: // $168
      var $169=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $170=$169.f0;
      $10=$170;
      var $171=$169.f1;
      $11=$171;
      __label__ = 69; break;
    case 47: // $172
      var $173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $174=$173.f0;
      $10=$174;
      var $175=$173.f1;
      $11=$175;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($cachefile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 75; break; }
    case 48: // $176
      __label__ = 49; break;
    case 49: // $177
      $12=0;
      __label__ = 50; break;
    case 50: // $178
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($cachefile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 46; break; }
    case 51: // $179
      var $cleanup_dest=$12;
      if ($cleanup_dest == 0) {
        __label__ = 52; break;
      }
      else {
      __label__ = 67; break;
      }
      
    case 52: // $180
      var $181=$bytes;
      var $182$0=$181;
      var $182$1=0;
      var $183=(($13+1052)|0);
      var $st$4$0=(($183)|0);
      var $184$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($183+4)|0);
      var $184$1=HEAP32[(($st$4$1)>>2)];
      var $185=$182$1 < $184$1 || ($182$1 == $184$1 && $182$0 < $184$0);
      if ($185) { __label__ = 53; break; } else { __label__ = 61; break; }
    case 53: // $186
      var $187=$data;
      var $188=$bytes;
      var $189=(($187+$188)|0);
      var $190=(($13+1052)|0);
      var $st$4$0=(($190)|0);
      var $191$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($190+4)|0);
      var $191$1=HEAP32[(($st$4$1)>>2)];
      var $192=$bytes;
      var $193$0=$192;
      var $193$1=0;
      var $194$0 = ((($191$0)>>>0)+((($191$1)|0)*4294967296))-((($193$0)>>>0)+((($193$1)|0)*4294967296))>>>0; var $194$1 = Math.min(Math.floor((((($191$0)>>>0)+((($191$1)|0)*4294967296))-((($193$0)>>>0)+((($193$1)|0)*4294967296)))/4294967296), 4294967295);
      var $195$0=$194$0;
      var $195=$195$0;
      var $196=(function() { try { __THREW__ = false; return __ZN8emu_file4readEPvj($file, $189, $195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 46; break; };
    case 54: // $197
      $read=$196;
      var $198=$read;
      var $199$0=$198;
      var $199$1=0;
      var $200=(($13+1052)|0);
      var $st$5$0=(($200)|0);
      var $201$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($200+4)|0);
      var $201$1=HEAP32[(($st$5$1)>>2)];
      var $202=$bytes;
      var $203$0=$202;
      var $203$1=0;
      var $204$0 = ((($201$0)>>>0)+((($201$1)|0)*4294967296))-((($203$0)>>>0)+((($203$1)|0)*4294967296))>>>0; var $204$1 = Math.min(Math.floor((((($201$0)>>>0)+((($201$1)|0)*4294967296))-((($203$0)>>>0)+((($203$1)|0)*4294967296)))/4294967296), 4294967295);
      var $205=$199$0 != $204$0 || $199$1 != $204$1;
      if ($205) { __label__ = 55; break; } else { __label__ = 60; break; }
    case 55: // $206
      var $207=(($13+4)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($208) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 46; break; };
    case 56: // $210
      var $211=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($209) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 46; break; };
    case 57: // $212
      var $213=$data;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($211, $213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 46; break; }
    case 58: // $214
      $7=0;
      $12=1;
      __label__ = 67; break;
    case 59: // $215
      __label__ = 69; break;
    case 60: // $216
      __label__ = 61; break;
    case 61: // $217
      var $218=(($13+1052)|0);
      var $st$1$0=(($218)|0);
      var $219$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($218+4)|0);
      var $219$1=HEAP32[(($st$1$1)>>2)];
      var $220$0=$219$0;
      var $220=$220$0;
      var $221=$data;
      var $222=(($221+$220)|0);
      HEAP8[($222)]=0;
      var $223=$data;
      var $224=(($13+1048)|0);
      HEAP32[(($224)>>2)]=$223;
      var $225=(function() { try { __THREW__ = false; return __ZN11render_font8load_bdfEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 46; break; };
    case 62: // $226
      var $227=(($225)&1);
      $result1=$227;
      var $228=$result1;
      var $229=(($228) & 1);
      if ($229) { __label__ = 63; break; } else { __label__ = 66; break; }
    case 63: // $230
      var $231=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($cachedname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 46; break; };
    case 64: // $232
      var $233=$hash;
      var $234=(function() { try { __THREW__ = false; return __ZN11render_font11save_cachedEPKcj($13, $231, $233) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 46; break; };
    case 65: // $235
      __label__ = 66; break;
    case 66: // $236
      var $237=$result1;
      var $238=(($237) & 1);
      $7=$238;
      $12=1;
      __label__ = 67; break;
    case 67: // $239
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($cachedname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 3; break; }
    case 68: // $240
      __label__ = 71; break;
    case 69: // $241
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($cachedname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 75; break; }
    case 70: // $242
      __label__ = 72; break;
    case 71: // $243
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $244=$7;
      STACKTOP = __stackBase__;
      return $244;
    case 72: // $245
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 75; break; }
    case 73: // $246
      __label__ = 74; break;
    case 74: // $247
      var $248=$10;
      var $249=$10;
      var $250=$11;
      var $251=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $249, tempValue);
      var $252=($251.f1 = $250, $251);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 75: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font15load_cached_bdfEPKc["X"]=1;

function __ZN11render_fontD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tablenum;
      var $charnum;
      var $gl;
      $1=$this;
      var $2=$1;
      var $3=$2;
      HEAP32[(($3)>>2)]=((__ZTV11render_font+8)|0);
      $tablenum=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$tablenum;
      var $6=(($5)|0) < 256;
      if ($6) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $7
      var $8=$tablenum;
      var $9=(($2+24)|0);
      var $10=(($9+($8<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $13
      $charnum=0;
      __label__ = 4; break;
    case 4: // $14
      var $15=$charnum;
      var $16=(($15)|0) < 256;
      if ($16) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $17
      var $18=$charnum;
      var $19=$tablenum;
      var $20=(($2+24)|0);
      var $21=(($20+($19<<2))|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+($18<<5))|0);
      $gl=$23;
      var $24=(($2+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$gl;
      var $27=(($26+28)|0);
      var $28=HEAP32[(($27)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($25, $28);
      var $29=(($2+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZNK14render_manager7machineEv($30);
      var $32=__ZN15running_machine7respoolEv($31);
      var $33=$gl;
      var $34=(($33+24)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35;
      __ZN13resource_pool6removeEPv($32, $36);
      __label__ = 6; break;
    case 6: // $37
      var $38=$charnum;
      var $39=(($38+1)|0);
      $charnum=$39;
      __label__ = 4; break;
    case 7: // $40
      var $41=(($2+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__ZNK14render_manager7machineEv($42);
      var $44=__ZN15running_machine7respoolEv($43);
      var $45=$tablenum;
      var $46=(($2+24)|0);
      var $47=(($46+($45<<2))|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48;
      __ZN13resource_pool6removeEPv($44, $49);
      __label__ = 8; break;
    case 8: // $50
      __label__ = 9; break;
    case 9: // $51
      var $52=$tablenum;
      var $53=(($52+1)|0);
      $tablenum=$53;
      __label__ = 1; break;
    case 10: // $54
      var $55=(($2+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__ZNK14render_manager7machineEv($56);
      var $58=__ZN15running_machine7respoolEv($57);
      var $59=(($2+1048)|0);
      var $60=HEAP32[(($59)>>2)];
      __ZN13resource_pool6removeEPKv($58, $60);
      var $61=(($2+1060)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $64
      var $65=(($2+4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=__ZNK14render_manager7machineEv($66);
      var $68=__ZNK15running_machine3osdEv($67);
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+40)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($2+1060)|0);
      var $74=HEAP32[(($73)>>2)];
      FUNCTION_TABLE[$72]($68, $74);
      __label__ = 12; break;
    case 12: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_fontD2Ev["X"]=1;

function __ZN11render_font11load_cachedER8emu_filej($this, $file, $hash) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $result_i=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12;
      var $13;
      var $14;
      var $15;
      var $filesize=__stackBase__+52;
      var $header=__stackBase__+60;
      var $bytes_read;
      var $numchars;
      var $data;
      var $offset=__stackBase__+76;
      var $chindex;
      var $info;
      var $chnum;
      var $gl;
      $13=$this;
      $14=$file;
      $15=$hash;
      var $16=$13;
      var $17=$14;
      var $18=__ZN8emu_file4sizeEv($17);
      var $18$0=$18[0];
      var $18$1=$18[1];
      var $st$35$0=(($filesize)|0);
      HEAP32[(($st$35$0)>>2)]=$18$0;
      var $st$35$1=(($filesize+4)|0);
      HEAP32[(($st$35$1)>>2)]=$18$1;
      var $19=$14;
      var $20=(($header)|0);
      var $21=__ZN8emu_file4readEPvj($19, $20, 16);
      $bytes_read=$21;
      var $22=$bytes_read;
      var $23=(($22)|0)!=16;
      if ($23) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      $12=0;
      __label__ = 39; break;
    case 2: // $25
      var $26=(($header)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)!=102;
      if ($29) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $30
      var $31=(($header+1)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=(($33)|0)!=111;
      if ($34) { __label__ = 6; break; } else { __label__ = 4; break; }
    case 4: // $35
      var $36=(($header+2)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=(($38)|0)!=110;
      if ($39) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $40
      var $41=(($header+3)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=(($43)|0)!=116;
      if ($44) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $45
      $12=0;
      __label__ = 39; break;
    case 7: // $46
      var $47=(($header+4)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$15;
      var $51=$50 >>> 24;
      var $52=(($51) & 255);
      var $53=(($52)&255);
      var $54=(($49)|0)!=(($53)|0);
      if ($54) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $55
      var $56=(($header+5)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=$15;
      var $60=$59 >>> 16;
      var $61=(($60) & 255);
      var $62=(($61)&255);
      var $63=(($58)|0)!=(($62)|0);
      if ($63) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $64
      var $65=(($header+6)|0);
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$15;
      var $69=$68 >>> 8;
      var $70=(($69) & 255);
      var $71=(($70)&255);
      var $72=(($67)|0)!=(($71)|0);
      if ($72) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $73
      var $74=(($header+7)|0);
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=$15;
      var $78=(($77) & 255);
      var $79=(($78)&255);
      var $80=(($76)|0)!=(($79)|0);
      if ($80) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $81
      $12=0;
      __label__ = 39; break;
    case 12: // $82
      var $83=(($header+8)|0);
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$85 << 8;
      var $87=(($header+9)|0);
      var $88=HEAPU8[($87)];
      var $89=(($88)&255);
      var $90=$86 | $89;
      var $91=(($16+12)|0);
      HEAP32[(($91)>>2)]=$90;
      var $92=(($16+12)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93)|0);
      var $95=1/$94;
      var $96=(($16+20)|0);
      HEAPF32[(($96)>>2)]=$95;
      var $97=(($header+10)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$99 << 8;
      var $101=(($header+11)|0);
      var $102=HEAPU8[($101)];
      var $103=(($102)&255);
      var $104=$100 | $103;
      var $105=(($104) & 65535);
      var $106=(($105 << 16) >> 16);
      var $107=(($16+16)|0);
      HEAP32[(($107)>>2)]=$106;
      var $108=(($header+12)|0);
      var $109=HEAPU8[($108)];
      var $110=(($109)&255);
      var $111=$110 << 24;
      var $112=(($header+13)|0);
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=$114 << 16;
      var $116=$111 | $115;
      var $117=(($header+14)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 << 8;
      var $121=$116 | $120;
      var $122=(($header+15)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=$121 | $124;
      $numchars=$125;
      var $st$47$0=(($filesize)|0);
      var $126$0=HEAP32[(($st$47$0)>>2)];
      var $st$47$1=(($filesize+4)|0);
      var $126$1=HEAP32[(($st$47$1)>>2)];
      var $$emscripten$temp$0$0=16;
      var $$emscripten$temp$0$1=0;
      var $127$0 = ((($126$0)>>>0)+((($126$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $127$1 = Math.min(Math.floor((((($126$0)>>>0)+((($126$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $128=$numchars;
      var $129=(($128*12)|0);
      var $130$0=$129;
      var $130$1=(($129|0) < 0 ? -1 : 0);
      var $131=$127$1 < $130$1 || ($127$1 == $130$1 && $127$0 < $130$0);
      if ($131) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $132
      $12=0;
      __label__ = 39; break;
    case 14: // $133
      var $134=(($16+4)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=__ZNK14render_manager7machineEv($135);
      var $137=__ZN15running_machine7respoolEv($136);
      var $st$4$0=(($filesize)|0);
      var $138$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($filesize+4)|0);
      var $138$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$1$0=16;
      var $$emscripten$temp$1$1=0;
      var $139$0 = ((($138$0)>>>0)+((($138$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $139$1 = Math.min(Math.floor((((($138$0)>>>0)+((($138$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=1;
      var $140=$139$1 >= $$emscripten$temp$2$1 && ($139$1 > $$emscripten$temp$2$1 || $139$0 >= $$emscripten$temp$2$0);
      var $141$0=$139$0;
      var $141=$141$0;
      var $142=$140 ? -1 : $141;
      var $143=$7;
      var $144=$8;
      var $145=$9;
      var $146=$result_i;
      var $147=$10;
      var $148=$11;
      HEAP32[(($7)>>2)]=$142;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($9)>>2)]=623;
      var $149=HEAP32[(($7)>>2)];
      var $150=HEAP32[(($8)>>2)];
      var $151=HEAP32[(($9)>>2)];
      var $152=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($149, $150, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $153
      HEAP32[(($result_i)>>2)]=$152;
      var $154=HEAP32[(($result_i)>>2)];
      var $155=(($154)|0)==0;
      if ($155) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $156
      var $157=___cxa_allocate_exception(4);
      var $158=$157;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($158);
      (function() { try { __THREW__ = false; return ___cxa_throw($157, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 17; break; }
    case 17: // $159
      var $160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $161=$160.f0;
      HEAP32[(($10)>>2)]=$161;
      var $162=$160.f1;
      HEAP32[(($11)>>2)]=$162;
      var $163=HEAP32[(($11)>>2)];
      var $164=(($163)|0) < 0;
      if ($164) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $165
      var $166=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($166);
      throw "Reached an unreachable!"
    case 19: // $167
      var $168=HEAP32[(($10)>>2)];
      var $169=HEAP32[(($10)>>2)];
      var $170=HEAP32[(($11)>>2)];
      var $171=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $169, tempValue);
      var $172=($171.f1 = $170, $171);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $173
      throw "Reached an unreachable!"
    case 21: // $_ZnajPKci_exit
      var $174=HEAP32[(($result_i)>>2)];
      var $175=$7;
      var $176=$8;
      var $177=$9;
      var $178=$result_i;
      var $179=$10;
      var $180=$11;
      var $st$7$0=(($filesize)|0);
      var $181$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($filesize+4)|0);
      var $181$1=HEAP32[(($st$7$1)>>2)];
      var $$emscripten$temp$3$0=16;
      var $$emscripten$temp$3$1=0;
      var $182$0 = ((($181$0)>>>0)+((($181$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $182$1 = Math.min(Math.floor((((($181$0)>>>0)+((($181$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $183$0=$182$0;
      var $183=$183$0;
      var $184=__ZN13resource_pool9add_arrayIhEEPT_S2_i($137, $174, $183);
      $data=$184;
      var $185=$14;
      var $186=$data;
      var $st$20$0=(($filesize)|0);
      var $187$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($filesize+4)|0);
      var $187$1=HEAP32[(($st$20$1)>>2)];
      var $$emscripten$temp$4$0=16;
      var $$emscripten$temp$4$1=0;
      var $188$0 = ((($187$0)>>>0)+((($187$1)|0)*4294967296))-((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $188$1 = Math.min(Math.floor((((($187$0)>>>0)+((($187$1)|0)*4294967296))-((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $189$0=$188$0;
      var $189=$189$0;
      var $190=__ZN8emu_file4readEPvj($185, $186, $189);
      $bytes_read=$190;
      var $191=$bytes_read;
      var $192$0=$191;
      var $192$1=0;
      var $st$34$0=(($filesize)|0);
      var $193$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($filesize+4)|0);
      var $193$1=HEAP32[(($st$34$1)>>2)];
      var $$emscripten$temp$5$0=16;
      var $$emscripten$temp$5$1=0;
      var $194$0 = ((($193$0)>>>0)+((($193$1)|0)*4294967296))-((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296))>>>0; var $194$1 = Math.min(Math.floor((((($193$0)>>>0)+((($193$1)|0)*4294967296))-((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)))/4294967296), 4294967295);
      var $195=$192$0 != $194$0 || $192$1 != $194$1;
      if ($195) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $196
      var $197=(($16+4)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=__ZNK14render_manager7machineEv($198);
      var $200=__ZN15running_machine7respoolEv($199);
      var $201=$data;
      __ZN13resource_pool6removeEPv($200, $201);
      $12=0;
      __label__ = 39; break;
    case 23: // $202
      var $203=$numchars;
      var $204=(($203*12)|0);
      var $205$0=$204;
      var $205$1=(($204|0) < 0 ? -1 : 0);
      var $st$4$0=(($offset)|0);
      HEAP32[(($st$4$0)>>2)]=$205$0;
      var $st$4$1=(($offset+4)|0);
      HEAP32[(($st$4$1)>>2)]=$205$1;
      $chindex=0;
      __label__ = 24; break;
    case 24: // $206
      var $207=$chindex;
      var $208=$numchars;
      var $209=(($207)|0) < (($208)|0);
      if ($209) { __label__ = 25; break; } else { __label__ = 38; break; }
    case 25: // $210
      var $211=$chindex;
      var $212=(($211*12)|0);
      var $213=$data;
      var $214=(($213+$212)|0);
      $info=$214;
      var $215=$info;
      var $216=(($215)|0);
      var $217=HEAPU8[($216)];
      var $218=(($217)&255);
      var $219=$218 << 8;
      var $220=$info;
      var $221=(($220+1)|0);
      var $222=HEAPU8[($221)];
      var $223=(($222)&255);
      var $224=$219 | $223;
      $chnum=$224;
      var $225=$chnum;
      var $226=(((($225)|0)/256)|0);
      var $227=(($16+24)|0);
      var $228=(($227+($226<<2))|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=(($229)|0)==0;
      if ($230) { __label__ = 26; break; } else { __label__ = 34; break; }
    case 26: // $231
      var $232=(($16+4)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=__ZNK14render_manager7machineEv($233);
      var $235=__ZN15running_machine7respoolEv($234);
      var $236=$1;
      var $237=$2;
      var $238=$3;
      var $239=$4;
      var $240=$result_i1;
      var $241=$5;
      var $242=$6;
      HEAP32[(($1)>>2)]=8192;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($3)>>2)]=640;
      HEAP32[(($4)>>2)]=_zeromem;
      var $243=HEAP32[(($1)>>2)];
      var $244=HEAP32[(($2)>>2)];
      var $245=HEAP32[(($3)>>2)];
      var $246=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($243, $244, $245) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $247
      HEAP32[(($result_i1)>>2)]=$246;
      var $248=HEAP32[(($result_i1)>>2)];
      var $249=(($248)|0)==0;
      if ($249) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $250
      var $251=___cxa_allocate_exception(4);
      var $252=$251;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($252);
      (function() { try { __THREW__ = false; return ___cxa_throw($251, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 29; break; }
    case 29: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $255=$254.f0;
      HEAP32[(($5)>>2)]=$255;
      var $256=$254.f1;
      HEAP32[(($6)>>2)]=$256;
      var $257=HEAP32[(($6)>>2)];
      var $258=(($257)|0) < 0;
      if ($258) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $259
      var $260=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($260);
      throw "Reached an unreachable!"
    case 31: // $261
      var $262=HEAP32[(($5)>>2)];
      var $263=HEAP32[(($5)>>2)];
      var $264=HEAP32[(($6)>>2)];
      var $265=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $263, tempValue);
      var $266=($265.f1 = $264, $265);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 32: // $267
      throw "Reached an unreachable!"
    case 33: // $_ZnajPKciRK9zeromem_t_exit
      var $268=HEAP32[(($result_i1)>>2)];
      var $269=HEAP32[(($1)>>2)];
      _memset($268, 0, $269, 1);
      var $270=HEAP32[(($result_i1)>>2)];
      var $271=$1;
      var $272=$2;
      var $273=$3;
      var $274=$4;
      var $275=$result_i1;
      var $276=$5;
      var $277=$6;
      var $278=$270;
      var $279=__ZN13resource_pool9add_arrayIN11render_font5glyphEEEPT_S4_i($235, $278, 256);
      var $280=$chnum;
      var $281=(((($280)|0)/256)|0);
      var $282=(($16+24)|0);
      var $283=(($282+($281<<2))|0);
      HEAP32[(($283)>>2)]=$279;
      __label__ = 34; break;
    case 34: // $284
      var $285=$chnum;
      var $286=(($285)|0)%256;
      var $287=$chnum;
      var $288=(((($287)|0)/256)|0);
      var $289=(($16+24)|0);
      var $290=(($289+($288<<2))|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=(($291+($286<<5))|0);
      $gl=$292;
      var $293=$info;
      var $294=(($293+2)|0);
      var $295=HEAPU8[($294)];
      var $296=(($295)&255);
      var $297=$296 << 8;
      var $298=$info;
      var $299=(($298+3)|0);
      var $300=HEAPU8[($299)];
      var $301=(($300)&255);
      var $302=$297 | $301;
      var $303=$gl;
      var $304=(($303)|0);
      HEAP32[(($304)>>2)]=$302;
      var $305=$info;
      var $306=(($305+4)|0);
      var $307=HEAPU8[($306)];
      var $308=(($307)&255);
      var $309=$308 << 8;
      var $310=$info;
      var $311=(($310+5)|0);
      var $312=HEAPU8[($311)];
      var $313=(($312)&255);
      var $314=$309 | $313;
      var $315=(($314) & 65535);
      var $316=(($315 << 16) >> 16);
      var $317=$gl;
      var $318=(($317+4)|0);
      HEAP32[(($318)>>2)]=$316;
      var $319=$info;
      var $320=(($319+6)|0);
      var $321=HEAPU8[($320)];
      var $322=(($321)&255);
      var $323=$322 << 8;
      var $324=$info;
      var $325=(($324+7)|0);
      var $326=HEAPU8[($325)];
      var $327=(($326)&255);
      var $328=$323 | $327;
      var $329=(($328) & 65535);
      var $330=(($329 << 16) >> 16);
      var $331=$gl;
      var $332=(($331+8)|0);
      HEAP32[(($332)>>2)]=$330;
      var $333=$info;
      var $334=(($333+8)|0);
      var $335=HEAPU8[($334)];
      var $336=(($335)&255);
      var $337=$336 << 8;
      var $338=$info;
      var $339=(($338+9)|0);
      var $340=HEAPU8[($339)];
      var $341=(($340)&255);
      var $342=$337 | $341;
      var $343=$gl;
      var $344=(($343+12)|0);
      HEAP32[(($344)>>2)]=$342;
      var $345=$info;
      var $346=(($345+10)|0);
      var $347=HEAPU8[($346)];
      var $348=(($347)&255);
      var $349=$348 << 8;
      var $350=$info;
      var $351=(($350+11)|0);
      var $352=HEAPU8[($351)];
      var $353=(($352)&255);
      var $354=$349 | $353;
      var $355=$gl;
      var $356=(($355+16)|0);
      HEAP32[(($356)>>2)]=$354;
      var $357=$data;
      var $st$79$0=(($offset)|0);
      var $358$0=HEAP32[(($st$79$0)>>2)];
      var $st$79$1=(($offset+4)|0);
      var $358$1=HEAP32[(($st$79$1)>>2)];
      var $359$0=$358$0;
      var $359=$359$0;
      var $360=(($357+$359)|0);
      var $361=$gl;
      var $362=(($361+20)|0);
      HEAP32[(($362)>>2)]=$360;
      var $363=$gl;
      var $364=(($363+12)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=$gl;
      var $367=(($366+16)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=(($365*$368)|0);
      var $370=(($369+7)|0);
      var $371=(((($370)|0)/8)|0);
      var $372$0=$371;
      var $372$1=(($371|0) < 0 ? -1 : 0);
      var $st$100$0=(($offset)|0);
      var $373$0=HEAP32[(($st$100$0)>>2)];
      var $st$100$1=(($offset+4)|0);
      var $373$1=HEAP32[(($st$100$1)>>2)];
      var $374$0 = ((($373$0)>>>0)+((($373$1)|0)*4294967296))+((($372$0)>>>0)+((($372$1)|0)*4294967296))>>>0; var $374$1 = Math.min(Math.floor((((($373$0)>>>0)+((($373$1)|0)*4294967296))+((($372$0)>>>0)+((($372$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$105$0=(($offset)|0);
      HEAP32[(($st$105$0)>>2)]=$374$0;
      var $st$105$1=(($offset+4)|0);
      HEAP32[(($st$105$1)>>2)]=$374$1;
      var $st$109$0=(($offset)|0);
      var $375$0=HEAP32[(($st$109$0)>>2)];
      var $st$109$1=(($offset+4)|0);
      var $375$1=HEAP32[(($st$109$1)>>2)];
      var $st$113$0=(($filesize)|0);
      var $376$0=HEAP32[(($st$113$0)>>2)];
      var $st$113$1=(($filesize+4)|0);
      var $376$1=HEAP32[(($st$113$1)>>2)];
      var $$emscripten$temp$6$0=16;
      var $$emscripten$temp$6$1=0;
      var $377$0 = ((($376$0)>>>0)+((($376$1)|0)*4294967296))-((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))>>>0; var $377$1 = Math.min(Math.floor((((($376$0)>>>0)+((($376$1)|0)*4294967296))-((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296)))/4294967296), 4294967295);
      var $378=$375$1 > $377$1 || ($375$1 == $377$1 && $375$0 > $377$0);
      if ($378) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $379
      var $380=(($16+4)|0);
      var $381=HEAP32[(($380)>>2)];
      var $382=__ZNK14render_manager7machineEv($381);
      var $383=__ZN15running_machine7respoolEv($382);
      var $384=$data;
      __ZN13resource_pool6removeEPv($383, $384);
      $12=0;
      __label__ = 39; break;
    case 36: // $385
      __label__ = 37; break;
    case 37: // $386
      var $387=$chindex;
      var $388=(($387+1)|0);
      $chindex=$388;
      __label__ = 24; break;
    case 38: // $389
      var $390=(($16+8)|0);
      HEAP32[(($390)>>2)]=2;
      var $391=$data;
      var $392=(($16+1048)|0);
      HEAP32[(($392)>>2)]=$391;
      $12=1;
      __label__ = 39; break;
    case 39: // $393
      var $394=$12;
      STACKTOP = __stackBase__;
      return $394;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font11load_cachedER8emu_filej["X"]=1;

function __ZN11render_fontD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN11render_fontD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_fontD0Ev["X"]=1;

function __Z9next_linePKc($ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$ptr;
      __label__ = 1; break;
    case 1: // $3
      var $4=$2;
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0)!=13;
      if ($7) { __label__ = 2; break; } else { var $19 = 0;__label__ = 4; break; }
    case 2: // $8
      var $9=$2;
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)!=10;
      if ($12) { __label__ = 3; break; } else { var $19 = 0;__label__ = 4; break; }
    case 3: // $13
      var $14=$2;
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)!=0;
      var $19 = $17;__label__ = 4; break;
    case 4: // $18
      var $19;
      if ($19) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $20
      var $21=$2;
      var $22=(($21+1)|0);
      $2=$22;
      __label__ = 1; break;
    case 6: // $23
      var $24=$2;
      var $25=HEAP8[($24)];
      var $26=(($25 << 24) >> 24);
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $28
      $1=0;
      __label__ = 11; break;
    case 8: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==10;
      if ($34) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $35
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      __label__ = 10; break;
    case 10: // $38
      var $39=$2;
      $1=$39;
      __label__ = 11; break;
    case 11: // $40
      var $41=$1;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11render_font27get_char_texture_and_boundsEffjR13render_bounds($this, $height, $aspect, $chnum, $bounds) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $gl;
  var $scale;
  $1=$this;
  $2=$height;
  $3=$aspect;
  $4=$chnum;
  $5=$bounds;
  var $6=$1;
  var $7=$4;
  var $8=__ZN11render_font8get_charEj($6, $7);
  $gl=$8;
  var $9=(($6+20)|0);
  var $10=HEAPF32[(($9)>>2)];
  var $11=$2;
  var $12=$10*$11;
  $scale=$12;
  var $13=$gl;
  var $14=(($13+4)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15)|0);
  var $17=$scale;
  var $18=$16*$17;
  var $19=$3;
  var $20=$18*$19;
  var $21=$5;
  var $22=(($21)|0);
  var $23=HEAPF32[(($22)>>2)];
  var $24=$23+$20;
  HEAPF32[(($22)>>2)]=$24;
  var $25=$5;
  var $26=(($25)|0);
  var $27=HEAPF32[(($26)>>2)];
  var $28=$gl;
  var $29=(($28+12)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=(($30)|0);
  var $32=$scale;
  var $33=$31*$32;
  var $34=$3;
  var $35=$33*$34;
  var $36=$27+$35;
  var $37=$5;
  var $38=(($37+8)|0);
  HEAPF32[(($38)>>2)]=$36;
  var $39=$5;
  var $40=(($39+4)|0);
  var $41=HEAPF32[(($40)>>2)];
  var $42=(($6+12)|0);
  var $43=HEAP32[(($42)>>2)];
  var $44=(($43)|0);
  var $45=$scale;
  var $46=$44*$45;
  var $47=$41+$46;
  var $48=$5;
  var $49=(($48+12)|0);
  HEAPF32[(($49)>>2)]=$47;
  var $50=$gl;
  var $51=(($50+28)|0);
  var $52=HEAP32[(($51)>>2)];
  ;
  return $52;
}
__ZN11render_font27get_char_texture_and_boundsEffjR13render_bounds["X"]=1;

function __ZN11render_font11char_expandEjRNS_5glyphE($this, $chnum, $gl) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $ptr;
      var $accum;
      var $accumbit;
      var $y;
      var $desty;
      var $dest;
      var $x;
      var $bits;
      var $x1;
      $9=$this;
      $10=$chnum;
      $11=$gl;
      var $14=$9;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==3;
      if ($17) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $18
      var $19=$11;
      var $20=(($19+12)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==-1;
      if ($22) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __label__ = 69; break;
    case 3: // $24
      var $25=(($14+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK14render_manager7machineEv($26);
      var $28=__ZNK15running_machine3osdEv($27);
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+44)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($14+1060)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$10;
      var $36=$11;
      var $37=(($36)|0);
      var $38=$11;
      var $39=(($38+4)|0);
      var $40=$11;
      var $41=(($40+8)|0);
      var $42=FUNCTION_TABLE[$32]($28, $34, $35, $37, $39, $41);
      var $43=$11;
      var $44=(($43+24)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$11;
      var $46=(($45+24)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $49
      var $50=$11;
      var $51=(($50+12)|0);
      HEAP32[(($51)>>2)]=-1;
      __label__ = 69; break;
    case 5: // $52
      var $53=$11;
      var $54=(($53+24)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55;
      var $57=(($56+12)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$11;
      var $60=(($59+12)|0);
      HEAP32[(($60)>>2)]=$58;
      var $61=$11;
      var $62=(($61+24)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$63;
      var $65=(($64+16)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$11;
      var $68=(($67+16)|0);
      HEAP32[(($68)>>2)]=$66;
      __label__ = 68; break;
    case 6: // $69
      var $70=$11;
      var $71=(($70+12)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 7: // $74
      var $75=$11;
      var $76=(($75+16)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $79
      var $80=$11;
      var $81=(($80+20)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $84
      __label__ = 69; break;
    case 10: // $85
      var $86=(($14+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=__ZNK14render_manager7machineEv($87);
      var $89=__ZN15running_machine7respoolEv($88);
      var $90=$4;
      var $91=$5;
      var $92=$6;
      var $93=$result_i;
      var $94=$7;
      var $95=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($6)>>2)]=215;
      var $96=HEAP32[(($4)>>2)];
      var $97=HEAP32[(($5)>>2)];
      var $98=HEAP32[(($6)>>2)];
      var $99=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($96, $97, $98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $100
      HEAP32[(($result_i)>>2)]=$99;
      var $101=HEAP32[(($result_i)>>2)];
      var $102=(($101)|0)==0;
      if ($102) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $103
      var $104=___cxa_allocate_exception(4);
      var $105=$104;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($105);
      (function() { try { __THREW__ = false; return ___cxa_throw($104, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $108=$107.f0;
      HEAP32[(($7)>>2)]=$108;
      var $109=$107.f1;
      HEAP32[(($8)>>2)]=$109;
      var $110=HEAP32[(($8)>>2)];
      var $111=(($110)|0) < 0;
      if ($111) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $112
      var $113=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($113);
      throw "Reached an unreachable!"
    case 15: // $114
      var $115=HEAP32[(($7)>>2)];
      var $116=HEAP32[(($7)>>2)];
      var $117=HEAP32[(($8)>>2)];
      var $118=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $116, tempValue);
      var $119=($118.f1 = $117, $118);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $120
      throw "Reached an unreachable!"
    case 17: // $_ZnwjPKci_exit
      var $121=HEAP32[(($result_i)>>2)];
      var $122=$4;
      var $123=$5;
      var $124=$6;
      var $125=$result_i;
      var $126=$7;
      var $127=$8;
      var $128=$121;
      var $129=$11;
      var $130=(($129+12)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($14+12)|0);
      var $133=HEAP32[(($132)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($128, $131, $133, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 34; break; }
    case 18: // $134
      var $135=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($89, $128);
      var $136=$11;
      var $137=(($136+24)|0);
      HEAP32[(($137)>>2)]=$135;
      var $138=$11;
      var $139=(($138+24)|0);
      var $140=HEAP32[(($139)>>2)];
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($140, 0, 0);
      var $141=$11;
      var $142=(($141+20)|0);
      var $143=HEAP32[(($142)>>2)];
      $ptr=$143;
      $accum=0;
      $accumbit=7;
      $y=0;
      __label__ = 19; break;
    case 19: // $144
      var $145=$y;
      var $146=$11;
      var $147=(($146+16)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($145)|0) < (($148)|0);
      if ($149) { __label__ = 20; break; } else { __label__ = 67; break; }
    case 20: // $150
      var $151=$y;
      var $152=(($14+12)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($151+$153)|0);
      var $155=(($14+16)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($154+$156)|0);
      var $158=$11;
      var $159=(($158+8)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($157-$160)|0);
      var $162=$11;
      var $163=(($162+16)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($161-$164)|0);
      $desty=$165;
      var $166=$desty;
      var $167=(($166)|0) >= 0;
      if ($167) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $168
      var $169=$desty;
      var $170=(($14+12)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($169)|0) < (($171)|0);
      if ($172) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $173
      var $174=$11;
      var $175=(($174+24)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$176;
      var $178=(($177+4)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$179;
      var $181=$desty;
      var $182=$11;
      var $183=(($182+24)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$184;
      var $186=(($185+8)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($181*$187)|0);
      var $189=(($180+($188<<2))|0);
      var $190=(($189)|0);
      var $193 = $190;__label__ = 24; break;
    case 23: // $191
      var $193 = 0;__label__ = 24; break;
    case 24: // $192
      var $193;
      $dest=$193;
      var $194=(($14+8)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195)|0)==1;
      if ($196) { __label__ = 25; break; } else { __label__ = 54; break; }
    case 25: // $197
      $x=0;
      __label__ = 26; break;
    case 26: // $198
      var $199=$x;
      var $200=$11;
      var $201=(($200+12)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($199)|0) < (($202)|0);
      if ($203) { __label__ = 27; break; } else { __label__ = 53; break; }
    case 27: // $204
      $bits=-1;
      __label__ = 28; break;
    case 28: // $205
      var $206=$ptr;
      var $207=HEAP8[($206)];
      var $208=(($207 << 24) >> 24);
      var $209=(($208)|0)!=13;
      if ($209) { __label__ = 29; break; } else { var $214 = 0;__label__ = 30; break; }
    case 29: // $210
      var $211=$bits;
      var $212=(($211)|0)==-1;
      var $214 = $212;__label__ = 30; break;
    case 30: // $213
      var $214;
      if ($214) { __label__ = 31; break; } else { __label__ = 49; break; }
    case 31: // $215
      var $216=$ptr;
      var $217=HEAP8[($216)];
      var $218=(($217 << 24) >> 24);
      var $219=(($218)|0) >= 48;
      if ($219) { __label__ = 32; break; } else { __label__ = 39; break; }
    case 32: // $220
      var $221=$ptr;
      var $222=HEAP8[($221)];
      var $223=(($222 << 24) >> 24);
      var $224=(($223)|0) <= 57;
      if ($224) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $225
      var $226=$ptr;
      var $227=(($226+1)|0);
      $ptr=$227;
      var $228=HEAP8[($226)];
      var $229=(($228 << 24) >> 24);
      var $230=(($229-48)|0);
      $bits=$230;
      __label__ = 48; break;
    case 34: // $231
      var $232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $233=$232.f0;
      $12=$233;
      var $234=$232.f1;
      $13=$234;
      var $235=$1;
      var $236=$2;
      var $237=$3;
      HEAP32[(($1)>>2)]=$121;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($3)>>2)]=215;
      var $238=HEAP32[(($1)>>2)];
      var $239=(($238)|0)!=0;
      if ($239) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $240
      var $241=HEAP32[(($1)>>2)];
      var $242=HEAP32[(($2)>>2)];
      var $243=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($241, $242, $243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 71; break; }
    case 36: // $_noexc
      __label__ = 37; break;
    case 37: // $_ZdlPvPKci_exit
      var $244=$1;
      var $245=$2;
      var $246=$3;
      __label__ = 38; break;
    case 38: // $247
      __label__ = 70; break;
    case 39: // $248
      var $249=$ptr;
      var $250=HEAP8[($249)];
      var $251=(($250 << 24) >> 24);
      var $252=(($251)|0) >= 65;
      if ($252) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $253
      var $254=$ptr;
      var $255=HEAP8[($254)];
      var $256=(($255 << 24) >> 24);
      var $257=(($256)|0) <= 70;
      if ($257) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $258
      var $259=$ptr;
      var $260=(($259+1)|0);
      $ptr=$260;
      var $261=HEAP8[($259)];
      var $262=(($261 << 24) >> 24);
      var $263=(($262-65)|0);
      var $264=(($263+10)|0);
      $bits=$264;
      __label__ = 47; break;
    case 42: // $265
      var $266=$ptr;
      var $267=HEAP8[($266)];
      var $268=(($267 << 24) >> 24);
      var $269=(($268)|0) >= 97;
      if ($269) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $270
      var $271=$ptr;
      var $272=HEAP8[($271)];
      var $273=(($272 << 24) >> 24);
      var $274=(($273)|0) <= 102;
      if ($274) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $275
      var $276=$ptr;
      var $277=(($276+1)|0);
      $ptr=$277;
      var $278=HEAP8[($276)];
      var $279=(($278 << 24) >> 24);
      var $280=(($279-97)|0);
      var $281=(($280+10)|0);
      $bits=$281;
      __label__ = 46; break;
    case 45: // $282
      var $283=$ptr;
      var $284=(($283+1)|0);
      $ptr=$284;
      __label__ = 46; break;
    case 46: // $285
      __label__ = 47; break;
    case 47: // $286
      __label__ = 48; break;
    case 48: // $287
      __label__ = 28; break;
    case 49: // $288
      var $289=$dest;
      var $290=(($289)|0)!=0;
      if ($290) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $291
      var $292=$bits;
      var $293=$292 & 8;
      var $294=(($293)|0)!=0;
      var $295=$294 ? -1 : 16777215;
      var $296=$dest;
      var $297=(($296+4)|0);
      $dest=$297;
      HEAP32[(($296)>>2)]=$295;
      var $298=$bits;
      var $299=$298 & 4;
      var $300=(($299)|0)!=0;
      var $301=$300 ? -1 : 16777215;
      var $302=$dest;
      var $303=(($302+4)|0);
      $dest=$303;
      HEAP32[(($302)>>2)]=$301;
      var $304=$bits;
      var $305=$304 & 2;
      var $306=(($305)|0)!=0;
      var $307=$306 ? -1 : 16777215;
      var $308=$dest;
      var $309=(($308+4)|0);
      $dest=$309;
      HEAP32[(($308)>>2)]=$307;
      var $310=$bits;
      var $311=$310 & 1;
      var $312=(($311)|0)!=0;
      var $313=$312 ? -1 : 16777215;
      var $314=$dest;
      var $315=(($314+4)|0);
      $dest=$315;
      HEAP32[(($314)>>2)]=$313;
      __label__ = 51; break;
    case 51: // $316
      __label__ = 52; break;
    case 52: // $317
      var $318=$x;
      var $319=(($318+4)|0);
      $x=$319;
      __label__ = 26; break;
    case 53: // $320
      var $321=$ptr;
      var $322=__Z9next_linePKc($321);
      $ptr=$322;
      __label__ = 65; break;
    case 54: // $323
      var $324=(($14+8)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($325)|0)==2;
      if ($326) { __label__ = 55; break; } else { __label__ = 64; break; }
    case 55: // $327
      $x1=0;
      __label__ = 56; break;
    case 56: // $328
      var $329=$x1;
      var $330=$11;
      var $331=(($330+12)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=(($329)|0) < (($332)|0);
      if ($333) { __label__ = 57; break; } else { __label__ = 63; break; }
    case 57: // $334
      var $335=$accumbit;
      var $336=(($335)&255);
      var $337=(($336)|0)==7;
      if ($337) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $338
      var $339=$ptr;
      var $340=(($339+1)|0);
      $ptr=$340;
      var $341=HEAP8[($339)];
      $accum=$341;
      __label__ = 59; break;
    case 59: // $342
      var $343=$dest;
      var $344=(($343)|0)!=0;
      if ($344) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $345
      var $346=$accum;
      var $347=(($346)&255);
      var $348=$accumbit;
      var $349=(($348)&255);
      var $350=1 << $349;
      var $351=$347 & $350;
      var $352=(($351)|0)!=0;
      var $353=$352 ? -1 : 16777215;
      var $354=$dest;
      var $355=(($354+4)|0);
      $dest=$355;
      HEAP32[(($354)>>2)]=$353;
      __label__ = 61; break;
    case 61: // $356
      var $357=$accumbit;
      var $358=(($357)&255);
      var $359=(($358-1)|0);
      var $360=$359 & 7;
      var $361=(($360) & 255);
      $accumbit=$361;
      __label__ = 62; break;
    case 62: // $362
      var $363=$x1;
      var $364=(($363+1)|0);
      $x1=$364;
      __label__ = 56; break;
    case 63: // $365
      __label__ = 64; break;
    case 64: // $366
      __label__ = 65; break;
    case 65: // $367
      __label__ = 66; break;
    case 66: // $368
      var $369=$y;
      var $370=(($369+1)|0);
      $y=$370;
      __label__ = 19; break;
    case 67: // $371
      __label__ = 68; break;
    case 68: // $372
      var $373=(($14+4)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($374, 998, 0);
      var $376=$11;
      var $377=(($376+28)|0);
      HEAP32[(($377)>>2)]=$375;
      var $378=$11;
      var $379=(($378+28)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=$11;
      var $382=(($381+24)|0);
      var $383=HEAP32[(($382)>>2)];
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($380, $383, 0, 5, 0);
      __label__ = 69; break;
    case 69: // $384
      STACKTOP = __stackBase__;
      return;
    case 70: // $385
      var $386=$12;
      var $387=$12;
      var $388=$13;
      var $389=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $387, tempValue);
      var $390=($389.f1 = $388, $389);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 71: // $391
      var $392=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font11char_expandEjRNS_5glyphE["X"]=1;

function __ZN11render_font8get_charEj($this, $chnum) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $glyphtable;
      var $gl;
      $8=$this;
      $9=$chnum;
      var $10=$8;
      var $11=$9;
      var $12=Math.floor((($11)>>>0)/256);
      var $13=(($10+24)|0);
      var $14=(($13+($12<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $glyphtable=$15;
      var $16=$glyphtable;
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $18
      var $19=(($10+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==3;
      if ($21) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $22
      var $23=(($10+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK14render_manager7machineEv($24);
      var $26=__ZN15running_machine7respoolEv($25);
      var $27=$1;
      var $28=$2;
      var $29=$3;
      var $30=$4;
      var $31=$result_i;
      var $32=$5;
      var $33=$6;
      HEAP32[(($1)>>2)]=8192;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($3)>>2)]=86;
      HEAP32[(($4)>>2)]=_zeromem;
      var $34=HEAP32[(($1)>>2)];
      var $35=HEAP32[(($2)>>2)];
      var $36=HEAP32[(($3)>>2)];
      var $37=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($34, $35, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $38
      HEAP32[(($result_i)>>2)]=$37;
      var $39=HEAP32[(($result_i)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $41
      var $42=___cxa_allocate_exception(4);
      var $43=$42;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($43);
      (function() { try { __THREW__ = false; return ___cxa_throw($42, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      HEAP32[(($5)>>2)]=$46;
      var $47=$45.f1;
      HEAP32[(($6)>>2)]=$47;
      var $48=HEAP32[(($6)>>2)];
      var $49=(($48)|0) < 0;
      if ($49) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $50
      var $51=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($51);
      throw "Reached an unreachable!"
    case 7: // $52
      var $53=HEAP32[(($5)>>2)];
      var $54=HEAP32[(($5)>>2)];
      var $55=HEAP32[(($6)>>2)];
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $58
      throw "Reached an unreachable!"
    case 9: // $_ZnajPKciRK9zeromem_t_exit
      var $59=HEAP32[(($result_i)>>2)];
      var $60=HEAP32[(($1)>>2)];
      _memset($59, 0, $60, 1);
      var $61=HEAP32[(($result_i)>>2)];
      var $62=$1;
      var $63=$2;
      var $64=$3;
      var $65=$4;
      var $66=$result_i;
      var $67=$5;
      var $68=$6;
      var $69=$61;
      var $70=__ZN13resource_pool9add_arrayIN11render_font5glyphEEEPT_S4_i($26, $69, 256);
      var $71=$9;
      var $72=Math.floor((($71)>>>0)/256);
      var $73=(($10+24)|0);
      var $74=(($73+($72<<2))|0);
      HEAP32[(($74)>>2)]=$70;
      $glyphtable=$70;
      __label__ = 10; break;
    case 10: // $75
      var $76=$glyphtable;
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $78
      $7=__ZZN11render_font8get_charEjE11dummy_glyph;
      __label__ = 15; break;
    case 12: // $79
      var $80=$9;
      var $81=(($80)>>>0)%256;
      var $82=$glyphtable;
      var $83=(($82+($81<<5))|0);
      $gl=$83;
      var $84=$gl;
      var $85=(($84+24)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $88
      var $89=$9;
      var $90=$gl;
      __ZN11render_font11char_expandEjRNS_5glyphE($10, $89, $90);
      __label__ = 14; break;
    case 14: // $91
      var $92=$gl;
      $7=$92;
      __label__ = 15; break;
    case 15: // $93
      var $94=$7;
      STACKTOP = __stackBase__;
      return $94;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font8get_charEj["X"]=1;

function __ZNK11render_font7managerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11render_font28get_scaled_bitmap_and_boundsER8bitmap_tffjR10_rectangle($this, $dest, $height, $aspect, $chnum, $bounds) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $gl;
      var $scale;
      var $origwidth;
      var $origheight;
      var $clip=__stackBase__;
      $1=$this;
      $2=$dest;
      $3=$height;
      $4=$aspect;
      $5=$chnum;
      $6=$bounds;
      var $7=$1;
      var $8=$5;
      var $9=__ZN11render_font8get_charEj($7, $8);
      $gl=$9;
      var $10=(($7+20)|0);
      var $11=HEAPF32[(($10)>>2)];
      var $12=$3;
      var $13=$11*$12;
      $scale=$13;
      var $14=$gl;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0);
      var $18=$scale;
      var $19=$17*$18;
      var $20=$4;
      var $21=$19*$20;
      var $22=(($21)|0);
      var $23=$6;
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=$22;
      var $25=$6;
      var $26=(($25+8)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=$6;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0);
      var $31=$gl;
      var $32=(($31+12)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0);
      var $35=$scale;
      var $36=$34*$35;
      var $37=$4;
      var $38=$36*$37;
      var $39=$30+$38;
      var $40=(($39)|0);
      var $41=$6;
      var $42=(($41+4)|0);
      HEAP32[(($42)>>2)]=$40;
      var $43=$6;
      var $44=(($43+8)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0);
      var $47=(($7+12)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0);
      var $50=$scale;
      var $51=$49*$50;
      var $52=$46+$51;
      var $53=(($52)|0);
      var $54=$6;
      var $55=(($54+12)|0);
      HEAP32[(($55)>>2)]=$53;
      var $56=$2;
      var $57=$56;
      var $58=(($57+12)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$6;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$6;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($62-$65)|0);
      var $67=(($59)|0) < (($66)|0);
      if ($67) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $68
      var $69=$2;
      var $70=$69;
      var $71=(($70+16)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$6;
      var $74=(($73+12)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$6;
      var $77=(($76+8)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($75-$78)|0);
      var $80=(($72)|0) < (($79)|0);
      if ($80) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $81
      __label__ = 6; break;
    case 3: // $82
      var $83=$gl;
      var $84=(($83+28)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)==0;
      if ($86) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $87
      var $88=$2;
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($88, 0, 0);
      __label__ = 6; break;
    case 5: // $89
      var $90=$2;
      var $91=$90;
      var $92=(($91+12)|0);
      var $93=HEAP32[(($92)>>2)];
      $origwidth=$93;
      var $94=$2;
      var $95=$94;
      var $96=(($95+16)|0);
      var $97=HEAP32[(($96)>>2)];
      $origheight=$97;
      var $98=$6;
      var $99=(($98+4)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$6;
      var $102=(($101)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($100-$103)|0);
      var $105=$2;
      var $106=$105;
      var $107=(($106+12)|0);
      HEAP32[(($107)>>2)]=$104;
      var $108=$6;
      var $109=(($108+12)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$6;
      var $112=(($111+8)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($110-$113)|0);
      var $115=$2;
      var $116=$115;
      var $117=(($116+16)|0);
      HEAP32[(($117)>>2)]=$114;
      var $118=(($clip+8)|0);
      HEAP32[(($118)>>2)]=0;
      var $119=(($clip)|0);
      HEAP32[(($119)>>2)]=0;
      var $120=$gl;
      var $121=(($120+24)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$122;
      var $124=(($123+12)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125-1)|0);
      var $127=(($clip+4)|0);
      HEAP32[(($127)>>2)]=$126;
      var $128=$gl;
      var $129=(($128+24)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$130;
      var $132=(($131+16)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133-1)|0);
      var $135=(($clip+12)|0);
      HEAP32[(($135)>>2)]=$134;
      var $136=$2;
      var $137=$gl;
      var $138=(($137+24)|0);
      var $139=HEAP32[(($138)>>2)];
      __ZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePv($136, $139, $clip, 0);
      var $140=$origwidth;
      var $141=$2;
      var $142=$141;
      var $143=(($142+12)|0);
      HEAP32[(($143)>>2)]=$140;
      var $144=$origheight;
      var $145=$2;
      var $146=$145;
      var $147=(($146+16)|0);
      HEAP32[(($147)>>2)]=$144;
      __label__ = 6; break;
    case 6: // $148
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font28get_scaled_bitmap_and_boundsER8bitmap_tffjR10_rectangle["X"]=1;

function __ZN11render_font10char_widthEffj($this, $height, $aspect, $ch) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$height;
  $3=$aspect;
  $4=$ch;
  var $5=$1;
  var $6=$4;
  var $7=__ZN11render_font8get_charEj($5, $6);
  var $8=(($7)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9)|0);
  var $11=(($5+20)|0);
  var $12=HEAPF32[(($11)>>2)];
  var $13=$10*$12;
  var $14=$2;
  var $15=$13*$14;
  var $16=$3;
  var $17=$15*$16;
  ;
  return $17;
}


function __ZN11render_font12string_widthEffPKc($this, $height, $aspect, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $totwidth;
      var $ptr;
      $1=$this;
      $2=$height;
      $3=$aspect;
      $4=$string;
      var $5=$1;
      $totwidth=0;
      var $6=$4;
      $ptr=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$ptr;
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$ptr;
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=__ZN11render_font8get_charEj($5, $15);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$totwidth;
      var $20=(($19+$18)|0);
      $totwidth=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$ptr;
      var $23=(($22+1)|0);
      $ptr=$23;
      __label__ = 1; break;
    case 4: // $24
      var $25=$totwidth;
      var $26=(($25)|0);
      var $27=(($5+20)|0);
      var $28=HEAPF32[(($27)>>2)];
      var $29=$26*$28;
      var $30=$2;
      var $31=$29*$30;
      var $32=$3;
      var $33=$31*$32;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11render_font16utf8string_widthEffPKc($this, $height, $aspect, $utf8string) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $length;
      var $count;
      var $totwidth;
      var $offset;
      var $uchar=__stackBase__;
      $1=$this;
      $2=$height;
      $3=$aspect;
      $4=$utf8string;
      var $5=$1;
      var $6=$4;
      var $7=_strlen($6);
      $length=$7;
      $totwidth=0;
      $offset=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$offset;
      var $10=$length;
      var $11=(($9)|0) < (($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $12
      var $13=$4;
      var $14=$offset;
      var $15=(($13+$14)|0);
      var $16=$length;
      var $17=$offset;
      var $18=(($16-$17)|0);
      var $19=__Z15uchar_from_utf8PjPKcj($uchar, $15, $18);
      $count=$19;
      var $20=$count;
      var $21=(($20)|0)==-1;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      __label__ = 8; break;
    case 4: // $23
      var $24=HEAPU32[(($uchar)>>2)];
      var $25=(($24)>>>0) < 65536;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=HEAP32[(($uchar)>>2)];
      var $28=__ZN11render_font8get_charEj($5, $27);
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$totwidth;
      var $32=(($31+$30)|0);
      $totwidth=$32;
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$count;
      var $36=$offset;
      var $37=(($36+$35)|0);
      $offset=$37;
      __label__ = 1; break;
    case 8: // $38
      var $39=$totwidth;
      var $40=(($39)|0);
      var $41=(($5+20)|0);
      var $42=HEAPF32[(($41)>>2)];
      var $43=$40*$42;
      var $44=$2;
      var $45=$43*$44;
      var $46=$3;
      var $47=$45*$46;
      STACKTOP = __stackBase__;
      return $47;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font16utf8string_widthEffPKc["X"]=1;

function __ZNK11emu_options9font_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str184723)|0));
  ;
  return $4;
}


function __ZN11render_font8load_bdfEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $ptr;
      var $dummy1=__stackBase__+28;
      var $dummy2=__stackBase__+32;
      var $charcount;
      var $bmwidth=__stackBase__+36;
      var $bmheight=__stackBase__+40;
      var $xoffs=__stackBase__+44;
      var $yoffs=__stackBase__+48;
      var $rawdata;
      var $charnum=__stackBase__+52;
      var $width=__stackBase__+56;
      var $dummy11=__stackBase__+60;
      var $gl;
      var $maxwidth;
      var $ch;
      var $ch2;
      $8=$this;
      var $9=$8;
      var $10=(($9+8)|0);
      HEAP32[(($10)>>2)]=1;
      var $11=(($9+1048)|0);
      var $12=HEAP32[(($11)>>2)];
      $ptr=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$ptr;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$ptr;
      var $18=_strncmp($17, ((STRING_TABLE.__str44709)|0), 16);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $20
      var $21=$ptr;
      var $22=(($21+16)|0);
      var $23=(($9+12)|0);
      var $24=(($9+16)|0);
      var $25=_sscanf($22, ((STRING_TABLE.__str54710)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$dummy1,HEAP32[((tempInt+4)>>2)]=$23,HEAP32[((tempInt+8)>>2)]=$dummy2,HEAP32[((tempInt+12)>>2)]=$24,tempInt));
      var $26=(($25)|0)!=4;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      $7=0;
      __label__ = 73; break;
    case 5: // $28
      __label__ = 8; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=$ptr;
      var $32=__Z9next_linePKc($31);
      $ptr=$32;
      __label__ = 1; break;
    case 8: // $33
      var $34=(($9+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0);
      var $37=1/$36;
      var $38=(($9+20)|0);
      HEAPF32[(($38)>>2)]=$37;
      $charcount=0;
      __label__ = 9; break;
    case 9: // $39
      var $40=$ptr;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 10; break; } else { __label__ = 60; break; }
    case 10: // $42
      var $43=$ptr;
      var $44=_strncmp($43, ((STRING_TABLE.__str64711)|0), 7);
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $46
      __label__ = 60; break;
    case 12: // $47
      var $48=$ptr;
      var $49=_strncmp($48, ((STRING_TABLE.__str74712)|0), 10);
      var $50=(($49)|0)==0;
      if ($50) { __label__ = 13; break; } else { __label__ = 58; break; }
    case 13: // $51
      HEAP32[(($bmwidth)>>2)]=-1;
      HEAP32[(($bmheight)>>2)]=-1;
      HEAP32[(($xoffs)>>2)]=-1;
      HEAP32[(($yoffs)>>2)]=-1;
      $rawdata=0;
      HEAP32[(($charnum)>>2)]=-1;
      HEAP32[(($width)>>2)]=-1;
      __label__ = 14; break;
    case 14: // $52
      var $53=$ptr;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 15; break; } else { __label__ = 40; break; }
    case 15: // $55
      var $56=$ptr;
      var $57=_strncmp($56, ((STRING_TABLE.__str84713)|0), 9);
      var $58=(($57)|0)==0;
      if ($58) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $59
      var $60=$ptr;
      var $61=(($60+9)|0);
      var $62=_sscanf($61, ((STRING_TABLE.__str94714)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$charnum,tempInt));
      var $63=(($62)|0)!=1;
      if ($63) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $64
      $7=1;
      __label__ = 73; break;
    case 18: // $65
      __label__ = 38; break;
    case 19: // $66
      var $67=$ptr;
      var $68=_strncmp($67, ((STRING_TABLE.__str104715)|0), 7);
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $70
      var $71=$ptr;
      var $72=(($71+7)|0);
      var $73=_sscanf($72, ((STRING_TABLE.__str114716)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$width,HEAP32[((tempInt+4)>>2)]=$dummy11,tempInt));
      var $74=(($73)|0)!=2;
      if ($74) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $75
      $7=1;
      __label__ = 73; break;
    case 22: // $76
      __label__ = 37; break;
    case 23: // $77
      var $78=$ptr;
      var $79=_strncmp($78, ((STRING_TABLE.__str124717)|0), 4);
      var $80=(($79)|0)==0;
      if ($80) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 24: // $81
      var $82=$ptr;
      var $83=(($82+4)|0);
      var $84=_sscanf($83, ((STRING_TABLE.__str54710)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$bmwidth,HEAP32[((tempInt+4)>>2)]=$bmheight,HEAP32[((tempInt+8)>>2)]=$xoffs,HEAP32[((tempInt+12)>>2)]=$yoffs,tempInt));
      var $85=(($84)|0)!=4;
      if ($85) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $86
      $7=1;
      __label__ = 73; break;
    case 26: // $87
      __label__ = 36; break;
    case 27: // $88
      var $89=$ptr;
      var $90=_strncmp($89, ((STRING_TABLE.__str134718)|0), 6);
      var $91=(($90)|0)==0;
      if ($91) { __label__ = 28; break; } else { __label__ = 35; break; }
    case 28: // $92
      var $93=$ptr;
      var $94=__Z9next_linePKc($93);
      $ptr=$94;
      $rawdata=$94;
      __label__ = 29; break;
    case 29: // $95
      var $96=$ptr;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 30; break; } else { var $103 = 0;__label__ = 31; break; }
    case 30: // $98
      var $99=$ptr;
      var $100=_strncmp($99, ((STRING_TABLE.__str144719)|0), 7);
      var $101=(($100)|0)!=0;
      var $103 = $101;__label__ = 31; break;
    case 31: // $102
      var $103;
      if ($103) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $104
      __label__ = 33; break;
    case 33: // $105
      var $106=$ptr;
      var $107=__Z9next_linePKc($106);
      $ptr=$107;
      __label__ = 29; break;
    case 34: // $108
      __label__ = 40; break;
    case 35: // $109
      __label__ = 36; break;
    case 36: // $110
      __label__ = 37; break;
    case 37: // $111
      __label__ = 38; break;
    case 38: // $112
      __label__ = 39; break;
    case 39: // $113
      var $114=$ptr;
      var $115=__Z9next_linePKc($114);
      $ptr=$115;
      __label__ = 14; break;
    case 40: // $116
      var $117=HEAP32[(($charnum)>>2)];
      var $118=(($117)|0) >= 0;
      if ($118) { __label__ = 41; break; } else { __label__ = 55; break; }
    case 41: // $119
      var $120=HEAP32[(($charnum)>>2)];
      var $121=(($120)|0) < 65536;
      if ($121) { __label__ = 42; break; } else { __label__ = 55; break; }
    case 42: // $122
      var $123=$rawdata;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 43; break; } else { __label__ = 55; break; }
    case 43: // $125
      var $126=HEAP32[(($bmwidth)>>2)];
      var $127=(($126)|0) >= 0;
      if ($127) { __label__ = 44; break; } else { __label__ = 55; break; }
    case 44: // $128
      var $129=HEAP32[(($bmheight)>>2)];
      var $130=(($129)|0) >= 0;
      if ($130) { __label__ = 45; break; } else { __label__ = 55; break; }
    case 45: // $131
      var $132=HEAP32[(($charnum)>>2)];
      var $133=(((($132)|0)/256)|0);
      var $134=(($9+24)|0);
      var $135=(($134+($133<<2))|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0)==0;
      if ($137) { __label__ = 46; break; } else { __label__ = 54; break; }
    case 46: // $138
      var $139=(($9+4)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=__ZNK14render_manager7machineEv($140);
      var $142=__ZN15running_machine7respoolEv($141);
      var $143=$1;
      var $144=$2;
      var $145=$3;
      var $146=$4;
      var $147=$result_i;
      var $148=$5;
      var $149=$6;
      HEAP32[(($1)>>2)]=8192;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($3)>>2)]=562;
      HEAP32[(($4)>>2)]=_zeromem;
      var $150=HEAP32[(($1)>>2)];
      var $151=HEAP32[(($2)>>2)];
      var $152=HEAP32[(($3)>>2)];
      var $153=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($150, $151, $152) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; };
    case 47: // $154
      HEAP32[(($result_i)>>2)]=$153;
      var $155=HEAP32[(($result_i)>>2)];
      var $156=(($155)|0)==0;
      if ($156) { __label__ = 48; break; } else { __label__ = 53; break; }
    case 48: // $157
      var $158=___cxa_allocate_exception(4);
      var $159=$158;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($159);
      (function() { try { __THREW__ = false; return ___cxa_throw($158, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 49; break; }
    case 49: // $160
      var $161=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $162=$161.f0;
      HEAP32[(($5)>>2)]=$162;
      var $163=$161.f1;
      HEAP32[(($6)>>2)]=$163;
      var $164=HEAP32[(($6)>>2)];
      var $165=(($164)|0) < 0;
      if ($165) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $166
      var $167=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($167);
      throw "Reached an unreachable!"
    case 51: // $168
      var $169=HEAP32[(($5)>>2)];
      var $170=HEAP32[(($5)>>2)];
      var $171=HEAP32[(($6)>>2)];
      var $172=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $170, tempValue);
      var $173=($172.f1 = $171, $172);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 52: // $174
      throw "Reached an unreachable!"
    case 53: // $_ZnajPKciRK9zeromem_t_exit
      var $175=HEAP32[(($result_i)>>2)];
      var $176=HEAP32[(($1)>>2)];
      _memset($175, 0, $176, 1);
      var $177=HEAP32[(($result_i)>>2)];
      var $178=$1;
      var $179=$2;
      var $180=$3;
      var $181=$4;
      var $182=$result_i;
      var $183=$5;
      var $184=$6;
      var $185=$177;
      var $186=__ZN13resource_pool9add_arrayIN11render_font5glyphEEEPT_S4_i($142, $185, 256);
      var $187=HEAP32[(($charnum)>>2)];
      var $188=(((($187)|0)/256)|0);
      var $189=(($9+24)|0);
      var $190=(($189+($188<<2))|0);
      HEAP32[(($190)>>2)]=$186;
      __label__ = 54; break;
    case 54: // $191
      var $192=HEAP32[(($charnum)>>2)];
      var $193=(($192)|0)%256;
      var $194=HEAP32[(($charnum)>>2)];
      var $195=(((($194)|0)/256)|0);
      var $196=(($9+24)|0);
      var $197=(($196+($195<<2))|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198+($193<<5))|0);
      $gl=$199;
      var $200=HEAP32[(($width)>>2)];
      var $201=$gl;
      var $202=(($201)|0);
      HEAP32[(($202)>>2)]=$200;
      var $203=HEAP32[(($bmwidth)>>2)];
      var $204=$gl;
      var $205=(($204+12)|0);
      HEAP32[(($205)>>2)]=$203;
      var $206=HEAP32[(($bmheight)>>2)];
      var $207=$gl;
      var $208=(($207+16)|0);
      HEAP32[(($208)>>2)]=$206;
      var $209=HEAP32[(($xoffs)>>2)];
      var $210=$gl;
      var $211=(($210+4)|0);
      HEAP32[(($211)>>2)]=$209;
      var $212=HEAP32[(($yoffs)>>2)];
      var $213=$gl;
      var $214=(($213+8)|0);
      HEAP32[(($214)>>2)]=$212;
      var $215=$rawdata;
      var $216=$gl;
      var $217=(($216+20)|0);
      HEAP32[(($217)>>2)]=$215;
      __label__ = 55; break;
    case 55: // $218
      var $219=$charcount;
      var $220=(($219+1)|0);
      $charcount=$220;
      var $221=(($220)|0)%256;
      var $222=(($221)|0)==0;
      if ($222) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $223
      var $224=$charcount;
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str154720)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$224,tempInt));
      __label__ = 57; break;
    case 57: // $225
      __label__ = 58; break;
    case 58: // $226
      __label__ = 59; break;
    case 59: // $227
      var $228=$ptr;
      var $229=__Z9next_linePKc($228);
      $ptr=$229;
      __label__ = 9; break;
    case 60: // $230
      var $231=(($9+24)|0);
      var $232=(($231)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($233)|0)!=0;
      if ($234) { __label__ = 61; break; } else { __label__ = 72; break; }
    case 61: // $235
      $maxwidth=0;
      $ch=48;
      __label__ = 62; break;
    case 62: // $236
      var $237=$ch;
      var $238=(($237)|0) <= 57;
      if ($238) { __label__ = 63; break; } else { __label__ = 67; break; }
    case 63: // $239
      var $240=$ch;
      var $241=(($9+24)|0);
      var $242=(($241)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243+($240<<5))|0);
      var $245=(($244+12)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=$maxwidth;
      var $248=(($246)|0) > (($247)|0);
      if ($248) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $249
      var $250=$ch;
      var $251=(($9+24)|0);
      var $252=(($251)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=(($253+($250<<5))|0);
      var $255=(($254)|0);
      var $256=HEAP32[(($255)>>2)];
      $maxwidth=$256;
      __label__ = 65; break;
    case 65: // $257
      __label__ = 66; break;
    case 66: // $258
      var $259=$ch;
      var $260=(($259+1)|0);
      $ch=$260;
      __label__ = 62; break;
    case 67: // $261
      $ch2=48;
      __label__ = 68; break;
    case 68: // $262
      var $263=$ch2;
      var $264=(($263)|0) <= 57;
      if ($264) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $265
      var $266=$maxwidth;
      var $267=$ch2;
      var $268=(($9+24)|0);
      var $269=(($268)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($270+($267<<5))|0);
      var $272=(($271)|0);
      HEAP32[(($272)>>2)]=$266;
      __label__ = 70; break;
    case 70: // $273
      var $274=$ch2;
      var $275=(($274+1)|0);
      $ch2=$275;
      __label__ = 68; break;
    case 71: // $276
      __label__ = 72; break;
    case 72: // $277
      $7=1;
      __label__ = 73; break;
    case 73: // $278
      var $279=$7;
      STACKTOP = __stackBase__;
      return $279;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font8load_bdfEv["X"]=1;
// WARNING: content after a branch in a label, line: 554953
// WARNING: content after a branch in a label, line: 554954

function __ZN11render_font11save_cachedEPKcj($this, $filename, $hash) {
  var __stackBase__  = STACKTOP; STACKTOP += 312; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i5=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $result_i=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12;
      var $13;
      var $14;
      var $15;
      var $file=__stackBase__+52;
      var $filerr;
      var $16;
      var $17;
      var $18;
      var $numchars;
      var $chnum;
      var $chtable;
      var $gl;
      var $chartable;
      var $tempbuffer;
      var $chartable1;
      var $tempbuffer2;
      var $dest;
      var $bytes_written;
      var $tableindex;
      var $chnum3;
      var $gl4;
      var $accum;
      var $accbit;
      var $y;
      var $desty;
      var $src;
      var $x;
      $13=$this;
      $14=$filename;
      $15=$hash;
      var $19=$13;
      __Z19mame_printf_warningPKcz(((STRING_TABLE.__str164721)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $20=__ZNK11render_font7managerEv($19);
      var $21=__ZNK14render_manager7machineEv($20);
      var $22=__ZNK15running_machine7optionsEv($21);
      var $23=__ZNK11emu_options9font_pathEv($22);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $23, 6);
      var $24=$14;
      var $25=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $26
      $filerr=$25;
      var $27=$filerr;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $29
      $12=0;
      $18=1;
      __label__ = 113; break;
    case 3: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $16=$32;
      var $33=$31.f1;
      $17=$33;
      __label__ = 115; break;
    case 4: // $34
      $numchars=0;
      $chnum=0;
      __label__ = 5; break;
    case 5: // $35
      var $36=$chnum;
      var $37=(($36)|0) < 65536;
      if ($37) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $38
      var $39=$chnum;
      var $40=(((($39)|0)/256)|0);
      var $41=(($19+24)|0);
      var $42=(($41+($40<<2))|0);
      var $43=HEAP32[(($42)>>2)];
      $chtable=$43;
      var $44=$chtable;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $46
      var $47=$chnum;
      var $48=(($47)|0)%256;
      var $49=$chtable;
      var $50=(($49+($48<<5))|0);
      $gl=$50;
      var $51=$gl;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0) > 0;
      if ($54) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $55
      var $56=$numchars;
      var $57=(($56+1)|0);
      $numchars=$57;
      __label__ = 9; break;
    case 9: // $58
      __label__ = 10; break;
    case 10: // $59
      __label__ = 11; break;
    case 11: // $60
      var $61=$chnum;
      var $62=(($61+1)|0);
      $chnum=$62;
      __label__ = 5; break;
    case 12: // $63
      $chartable=0;
      $tempbuffer=0;
      var $64=(($19+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 43; break; };
    case 13: // $67
      var $68=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 43; break; };
    case 14: // $69
      var $70=$numchars;
      var $71=(($70*12)|0);
      var $72=(($71)|0) < 0;
      var $73=$72 ? -1 : $71;
      var $74=$6;
      var $75=$7;
      var $76=$8;
      var $77=$9;
      var $78=$result_i;
      var $79=$10;
      var $80=$11;
      HEAP32[(($6)>>2)]=$73;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($8)>>2)]=699;
      HEAP32[(($9)>>2)]=_zeromem;
      var $81=HEAP32[(($6)>>2)];
      var $82=HEAP32[(($7)>>2)];
      var $83=HEAP32[(($8)>>2)];
      var $84=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($81, $82, $83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $85
      HEAP32[(($result_i)>>2)]=$84;
      var $86=HEAP32[(($result_i)>>2)];
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $88
      var $89=___cxa_allocate_exception(4);
      var $90=$89;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($90);
      (function() { try { __THREW__ = false; return ___cxa_throw($89, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 17; break; }
    case 17: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $93=$92.f0;
      HEAP32[(($10)>>2)]=$93;
      var $94=$92.f1;
      HEAP32[(($11)>>2)]=$94;
      var $95=HEAP32[(($11)>>2)];
      var $96=(($95)|0) < 0;
      if ($96) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $97
      var $98=HEAP32[(($10)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 43; break; }
    case 19: // $_noexc
      throw "Reached an unreachable!"
    case 20: // $99
      var $100=HEAP32[(($10)>>2)];
      var $101=HEAP32[(($10)>>2)];
      var $102=HEAP32[(($11)>>2)];
      var $103=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $101, tempValue);
      var $104=($103.f1 = $102, $103);
      var $eh_lpad_body = $104;__label__ = 45; break;
    case 21: // $105
      throw "Reached an unreachable!"
    case 22: // $_ZnajPKciRK9zeromem_t_exit
      var $106=HEAP32[(($result_i)>>2)];
      var $107=HEAP32[(($6)>>2)];
      _memset($106, 0, $107, 1);
      var $108=HEAP32[(($result_i)>>2)];
      var $109=$6;
      var $110=$7;
      var $111=$8;
      var $112=$9;
      var $113=$result_i;
      var $114=$10;
      var $115=$11;
      __label__ = 23; break;
    case 23: // $116
      var $117=$numchars;
      var $118=(($117*12)|0);
      var $119=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIhEEPT_S2_i($68, $108, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 43; break; };
    case 24: // $120
      $chartable1=$119;
      var $121=(($19+4)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 43; break; };
    case 25: // $124
      var $125=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 43; break; };
    case 26: // $126
      var $127=$1;
      var $128=$2;
      var $129=$3;
      var $130=$result_i5;
      var $131=$4;
      var $132=$5;
      HEAP32[(($1)>>2)]=65536;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str24707)|0);
      HEAP32[(($3)>>2)]=702;
      var $133=HEAP32[(($1)>>2)];
      var $134=HEAP32[(($2)>>2)];
      var $135=HEAP32[(($3)>>2)];
      var $136=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($133, $134, $135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $137
      HEAP32[(($result_i5)>>2)]=$136;
      var $138=HEAP32[(($result_i5)>>2)];
      var $139=(($138)|0)==0;
      if ($139) { __label__ = 28; break; } else { __label__ = 34; break; }
    case 28: // $140
      var $141=___cxa_allocate_exception(4);
      var $142=$141;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($142);
      (function() { try { __THREW__ = false; return ___cxa_throw($141, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 29; break; }
    case 29: // $143
      var $144=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $145=$144.f0;
      HEAP32[(($4)>>2)]=$145;
      var $146=$144.f1;
      HEAP32[(($5)>>2)]=$146;
      var $147=HEAP32[(($5)>>2)];
      var $148=(($147)|0) < 0;
      if ($148) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $149
      var $150=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 43; break; }
    case 31: // $_noexc6
      throw "Reached an unreachable!"
    case 32: // $151
      var $152=HEAP32[(($4)>>2)];
      var $153=HEAP32[(($4)>>2)];
      var $154=HEAP32[(($5)>>2)];
      var $155=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $153, tempValue);
      var $156=($155.f1 = $154, $155);
      var $eh_lpad_body8 = $156;__label__ = 44; break;
    case 33: // $157
      throw "Reached an unreachable!"
    case 34: // $_ZnajPKci_exit
      var $158=HEAP32[(($result_i5)>>2)];
      var $159=$1;
      var $160=$2;
      var $161=$3;
      var $162=$result_i5;
      var $163=$4;
      var $164=$5;
      __label__ = 35; break;
    case 35: // $165
      var $166=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayIhEEPT_S2_i($125, $158, 65536) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 43; break; };
    case 36: // $167
      $tempbuffer2=$166;
      var $168=$tempbuffer2;
      $dest=$168;
      var $169=$dest;
      var $170=(($169+1)|0);
      $dest=$170;
      HEAP8[($169)]=102;
      var $171=$dest;
      var $172=(($171+1)|0);
      $dest=$172;
      HEAP8[($171)]=111;
      var $173=$dest;
      var $174=(($173+1)|0);
      $dest=$174;
      HEAP8[($173)]=110;
      var $175=$dest;
      var $176=(($175+1)|0);
      $dest=$176;
      HEAP8[($175)]=116;
      var $177=$15;
      var $178=$177 >>> 24;
      var $179=(($178) & 255);
      var $180=$dest;
      var $181=(($180+1)|0);
      $dest=$181;
      HEAP8[($180)]=$179;
      var $182=$15;
      var $183=$182 >>> 16;
      var $184=(($183) & 255);
      var $185=$dest;
      var $186=(($185+1)|0);
      $dest=$186;
      HEAP8[($185)]=$184;
      var $187=$15;
      var $188=$187 >>> 8;
      var $189=(($188) & 255);
      var $190=$dest;
      var $191=(($190+1)|0);
      $dest=$191;
      HEAP8[($190)]=$189;
      var $192=$15;
      var $193=$192 & 255;
      var $194=(($193) & 255);
      var $195=$dest;
      var $196=(($195+1)|0);
      $dest=$196;
      HEAP8[($195)]=$194;
      var $197=(($19+12)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=$198 >> 8;
      var $200=(($199) & 255);
      var $201=$dest;
      var $202=(($201+1)|0);
      $dest=$202;
      HEAP8[($201)]=$200;
      var $203=(($19+12)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$204 & 255;
      var $206=(($205) & 255);
      var $207=$dest;
      var $208=(($207+1)|0);
      $dest=$208;
      HEAP8[($207)]=$206;
      var $209=(($19+16)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$210 >> 8;
      var $212=(($211) & 255);
      var $213=$dest;
      var $214=(($213+1)|0);
      $dest=$214;
      HEAP8[($213)]=$212;
      var $215=(($19+16)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=$216 & 255;
      var $218=(($217) & 255);
      var $219=$dest;
      var $220=(($219+1)|0);
      $dest=$220;
      HEAP8[($219)]=$218;
      var $221=$numchars;
      var $222=$221 >> 24;
      var $223=(($222) & 255);
      var $224=$dest;
      var $225=(($224+1)|0);
      $dest=$225;
      HEAP8[($224)]=$223;
      var $226=$numchars;
      var $227=$226 >> 16;
      var $228=(($227) & 255);
      var $229=$dest;
      var $230=(($229+1)|0);
      $dest=$230;
      HEAP8[($229)]=$228;
      var $231=$numchars;
      var $232=$231 >> 8;
      var $233=(($232) & 255);
      var $234=$dest;
      var $235=(($234+1)|0);
      $dest=$235;
      HEAP8[($234)]=$233;
      var $236=$numchars;
      var $237=$236 & 255;
      var $238=(($237) & 255);
      var $239=$dest;
      var $240=(($239+1)|0);
      $dest=$240;
      HEAP8[($239)]=$238;
      __label__ = 37; break;
    case 37: // $241
      __label__ = 38; break;
    case 38: // $242
      __label__ = 39; break;
    case 39: // $243
      var $244=$tempbuffer2;
      var $245=$dest;
      var $246=$tempbuffer2;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      var $250=(function() { try { __THREW__ = false; return __ZN8emu_file5writeEPKvj($file, $244, $249) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 43; break; };
    case 40: // $251
      $bytes_written=$250;
      var $252=$bytes_written;
      var $253=$dest;
      var $254=$tempbuffer2;
      var $255=$253;
      var $256=$254;
      var $257=(($255-$256)|0);
      var $258=(($252)|0)!=(($257)|0);
      if ($258) { __label__ = 41; break; } else { __label__ = 47; break; }
    case 41: // $259
      var $260=___cxa_allocate_exception(1032);
      var $261=$260;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($261, ((STRING_TABLE.__str174722)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $262
      (function() { try { __THREW__ = false; return ___cxa_throw($260, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 43; break; }
    case 43: // $263
      var $264=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $eh_lpad_body8 = $264;__label__ = 44; break;
    case 44: // $_body7
      var $eh_lpad_body8;
      var $eh_lpad_body = $eh_lpad_body8;__label__ = 45; break;
    case 45: // $_body
      var $eh_lpad_body;
      var $265=$eh_lpad_body.f0;
      $16=$265;
      var $266=$eh_lpad_body.f1;
      $17=$266;
      __label__ = 95; break;
    case 46: // $267
      var $268=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $269=$268.f0;
      $16=$269;
      var $270=$268.f1;
      $17=$270;
      ___cxa_free_exception($260);
      __label__ = 95; break;
    case 47: // $271
      var $272=$chartable1;
      var $273=$numchars;
      var $274=(($273*12)|0);
      var $275=(function() { try { __THREW__ = false; return __ZN8emu_file5writeEPKvj($file, $272, $274) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 43; break; };
    case 48: // $276
      $bytes_written=$275;
      var $277=$bytes_written;
      var $278=$numchars;
      var $279=(($278*12)|0);
      var $280=(($277)|0)!=(($279)|0);
      if ($280) { __label__ = 49; break; } else { __label__ = 52; break; }
    case 49: // $281
      var $282=___cxa_allocate_exception(1032);
      var $283=$282;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($283, ((STRING_TABLE.__str174722)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $284
      (function() { try { __THREW__ = false; return ___cxa_throw($282, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 43; break; }
    case 51: // $285
      var $286=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $287=$286.f0;
      $16=$287;
      var $288=$286.f1;
      $17=$288;
      ___cxa_free_exception($282);
      __label__ = 95; break;
    case 52: // $289
      $tableindex=0;
      $chnum3=0;
      __label__ = 53; break;
    case 53: // $290
      var $291=$chnum3;
      var $292=(($291)|0) < 65536;
      if ($292) { __label__ = 54; break; } else { __label__ = 89; break; }
    case 54: // $293
      var $294=$chnum3;
      var $295=(function() { try { __THREW__ = false; return __ZN11render_font8get_charEj($19, $294) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 43; break; };
    case 55: // $296
      $gl4=$295;
      var $297=$gl4;
      var $298=(($297)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=(($299)|0) > 0;
      if ($300) { __label__ = 56; break; } else { __label__ = 87; break; }
    case 56: // $301
      var $302=$gl4;
      var $303=(($302+24)|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=(($304)|0)!=0;
      if ($305) { __label__ = 57; break; } else { __label__ = 86; break; }
    case 57: // $306
      var $307=$tempbuffer2;
      $dest=$307;
      $accum=0;
      $accbit=7;
      $y=0;
      __label__ = 58; break;
    case 58: // $308
      var $309=$y;
      var $310=$gl4;
      var $311=(($310+16)|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=(($309)|0) < (($312)|0);
      if ($313) { __label__ = 59; break; } else { __label__ = 74; break; }
    case 59: // $314
      var $315=$y;
      var $316=(($19+12)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=(($315+$317)|0);
      var $319=(($19+16)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=(($318+$320)|0);
      var $322=$gl4;
      var $323=(($322+8)|0);
      var $324=HEAP32[(($323)>>2)];
      var $325=(($321-$324)|0);
      var $326=$gl4;
      var $327=(($326+16)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=(($325-$328)|0);
      $desty=$329;
      var $330=$desty;
      var $331=(($330)|0) >= 0;
      if ($331) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $332
      var $333=$desty;
      var $334=(($19+12)|0);
      var $335=HEAP32[(($334)>>2)];
      var $336=(($333)|0) < (($335)|0);
      if ($336) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $337
      var $338=$gl4;
      var $339=(($338+24)|0);
      var $340=HEAP32[(($339)>>2)];
      var $341=$340;
      var $342=(($341+4)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=$343;
      var $345=$desty;
      var $346=$gl4;
      var $347=(($346+24)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$348;
      var $350=(($349+8)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=(($345*$351)|0);
      var $353=(($344+($352<<2))|0);
      var $354=(($353)|0);
      var $357 = $354;__label__ = 63; break;
    case 62: // $355
      var $357 = 0;__label__ = 63; break;
    case 63: // $356
      var $357;
      $src=$357;
      $x=0;
      __label__ = 64; break;
    case 64: // $358
      var $359=$x;
      var $360=$gl4;
      var $361=(($360+12)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=(($359)|0) < (($362)|0);
      if ($363) { __label__ = 65; break; } else { __label__ = 72; break; }
    case 65: // $364
      var $365=$src;
      var $366=(($365)|0)!=0;
      if ($366) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $367
      var $368=$x;
      var $369=$src;
      var $370=(($369+($368<<2))|0);
      var $371=HEAPU32[(($370)>>2)];
      var $372=$371 >>> 24;
      var $373=$372 & 255;
      var $374=(($373)|0)!=0;
      if ($374) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $375
      var $376=$accbit;
      var $377=(($376)&255);
      var $378=1 << $377;
      var $379=$accum;
      var $380=(($379)&255);
      var $381=$380 | $378;
      var $382=(($381) & 255);
      $accum=$382;
      __label__ = 68; break;
    case 68: // $383
      var $384=$accbit;
      var $385=(($384-1)&255);
      $accbit=$385;
      var $386=(($384)&255);
      var $387=(($386)|0)==0;
      if ($387) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $388
      var $389=$accum;
      var $390=$dest;
      var $391=(($390+1)|0);
      $dest=$391;
      HEAP8[($390)]=$389;
      $accum=0;
      $accbit=7;
      __label__ = 70; break;
    case 70: // $392
      __label__ = 71; break;
    case 71: // $393
      var $394=$x;
      var $395=(($394+1)|0);
      $x=$395;
      __label__ = 64; break;
    case 72: // $396
      __label__ = 73; break;
    case 73: // $397
      var $398=$y;
      var $399=(($398+1)|0);
      $y=$399;
      __label__ = 58; break;
    case 74: // $400
      var $401=$accbit;
      var $402=(($401)&255);
      var $403=(($402)|0)!=7;
      if ($403) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $404
      var $405=$accum;
      var $406=$dest;
      var $407=(($406+1)|0);
      $dest=$407;
      HEAP8[($406)]=$405;
      __label__ = 76; break;
    case 76: // $408
      var $409=$tempbuffer2;
      var $410=$dest;
      var $411=$tempbuffer2;
      var $412=$410;
      var $413=$411;
      var $414=(($412-$413)|0);
      var $415=(function() { try { __THREW__ = false; return __ZN8emu_file5writeEPKvj($file, $409, $414) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 43; break; };
    case 77: // $416
      $bytes_written=$415;
      var $417=$bytes_written;
      var $418=$dest;
      var $419=$tempbuffer2;
      var $420=$418;
      var $421=$419;
      var $422=(($420-$421)|0);
      var $423=(($417)|0)!=(($422)|0);
      if ($423) { __label__ = 78; break; } else { __label__ = 81; break; }
    case 78: // $424
      var $425=___cxa_allocate_exception(1032);
      var $426=$425;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($426, ((STRING_TABLE.__str174722)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $427
      (function() { try { __THREW__ = false; return ___cxa_throw($425, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 43; break; }
    case 80: // $428
      var $429=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $430=$429.f0;
      $16=$430;
      var $431=$429.f1;
      $17=$431;
      ___cxa_free_exception($425);
      __label__ = 95; break;
    case 81: // $432
      var $433=(($19+4)|0);
      var $434=HEAP32[(($433)>>2)];
      var $435=$gl4;
      var $436=(($435+28)|0);
      var $437=HEAP32[(($436)>>2)];
      (function() { try { __THREW__ = false; return __ZN14render_manager12texture_freeEP14render_texture($434, $437) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 43; break; }
    case 82: // $438
      var $439=(($19+4)|0);
      var $440=HEAP32[(($439)>>2)];
      var $441=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($440) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 43; break; };
    case 83: // $442
      var $443=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($441) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 43; break; };
    case 84: // $444
      var $445=$gl4;
      var $446=(($445+24)|0);
      var $447=HEAP32[(($446)>>2)];
      var $448=$447;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($443, $448) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 43; break; }
    case 85: // $449
      var $450=$gl4;
      var $451=(($450+28)|0);
      HEAP32[(($451)>>2)]=0;
      var $452=$gl4;
      var $453=(($452+24)|0);
      HEAP32[(($453)>>2)]=0;
      __label__ = 86; break;
    case 86: // $454
      var $455=$tableindex;
      var $456=(($455+1)|0);
      $tableindex=$456;
      var $457=(($455*12)|0);
      var $458=$chartable1;
      var $459=(($458+$457)|0);
      $dest=$459;
      var $460=$chnum3;
      var $461=$460 >> 8;
      var $462=(($461) & 255);
      var $463=$dest;
      var $464=(($463+1)|0);
      $dest=$464;
      HEAP8[($463)]=$462;
      var $465=$chnum3;
      var $466=$465 & 255;
      var $467=(($466) & 255);
      var $468=$dest;
      var $469=(($468+1)|0);
      $dest=$469;
      HEAP8[($468)]=$467;
      var $470=$gl4;
      var $471=(($470)|0);
      var $472=HEAP32[(($471)>>2)];
      var $473=$472 >> 8;
      var $474=(($473) & 255);
      var $475=$dest;
      var $476=(($475+1)|0);
      $dest=$476;
      HEAP8[($475)]=$474;
      var $477=$gl4;
      var $478=(($477)|0);
      var $479=HEAP32[(($478)>>2)];
      var $480=$479 & 255;
      var $481=(($480) & 255);
      var $482=$dest;
      var $483=(($482+1)|0);
      $dest=$483;
      HEAP8[($482)]=$481;
      var $484=$gl4;
      var $485=(($484+4)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=$486 >> 8;
      var $488=(($487) & 255);
      var $489=$dest;
      var $490=(($489+1)|0);
      $dest=$490;
      HEAP8[($489)]=$488;
      var $491=$gl4;
      var $492=(($491+4)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=$493 & 255;
      var $495=(($494) & 255);
      var $496=$dest;
      var $497=(($496+1)|0);
      $dest=$497;
      HEAP8[($496)]=$495;
      var $498=$gl4;
      var $499=(($498+8)|0);
      var $500=HEAP32[(($499)>>2)];
      var $501=$500 >> 8;
      var $502=(($501) & 255);
      var $503=$dest;
      var $504=(($503+1)|0);
      $dest=$504;
      HEAP8[($503)]=$502;
      var $505=$gl4;
      var $506=(($505+8)|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=$507 & 255;
      var $509=(($508) & 255);
      var $510=$dest;
      var $511=(($510+1)|0);
      $dest=$511;
      HEAP8[($510)]=$509;
      var $512=$gl4;
      var $513=(($512+12)|0);
      var $514=HEAP32[(($513)>>2)];
      var $515=$514 >> 8;
      var $516=(($515) & 255);
      var $517=$dest;
      var $518=(($517+1)|0);
      $dest=$518;
      HEAP8[($517)]=$516;
      var $519=$gl4;
      var $520=(($519+12)|0);
      var $521=HEAP32[(($520)>>2)];
      var $522=$521 & 255;
      var $523=(($522) & 255);
      var $524=$dest;
      var $525=(($524+1)|0);
      $dest=$525;
      HEAP8[($524)]=$523;
      var $526=$gl4;
      var $527=(($526+16)|0);
      var $528=HEAP32[(($527)>>2)];
      var $529=$528 >> 8;
      var $530=(($529) & 255);
      var $531=$dest;
      var $532=(($531+1)|0);
      $dest=$532;
      HEAP8[($531)]=$530;
      var $533=$gl4;
      var $534=(($533+16)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$535 & 255;
      var $537=(($536) & 255);
      var $538=$dest;
      var $539=(($538+1)|0);
      $dest=$539;
      HEAP8[($538)]=$537;
      __label__ = 87; break;
    case 87: // $540
      __label__ = 88; break;
    case 88: // $541
      var $542=$chnum3;
      var $543=(($542+1)|0);
      $chnum3=$543;
      __label__ = 53; break;
    case 89: // $544
      var $$emscripten$temp$0$0=16;
      var $$emscripten$temp$0$1=0;
      var $545=(function() { try { __THREW__ = false; return __ZN8emu_file4seekExi($file, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 43; break; };
      var $545$0=$545[0];
    case 90: // $546
      var $547=$chartable1;
      var $548=$numchars;
      var $549=(($548*12)|0);
      var $550=(function() { try { __THREW__ = false; return __ZN8emu_file5writeEPKvj($file, $547, $549) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 43; break; };
    case 91: // $551
      $bytes_written=$550;
      var $552=$bytes_written;
      var $553=$numchars;
      var $554=(($553*12)|0);
      var $555=(($552)|0)!=(($554)|0);
      if ($555) { __label__ = 92; break; } else { __label__ = 103; break; }
    case 92: // $556
      var $557=___cxa_allocate_exception(1032);
      var $558=$557;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($558, ((STRING_TABLE.__str174722)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $559
      (function() { try { __THREW__ = false; return ___cxa_throw($557, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 43; break; }
    case 94: // $560
      var $561=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $562=$561.f0;
      $16=$562;
      var $563=$561.f1;
      $17=$563;
      ___cxa_free_exception($557);
      __label__ = 95; break;
    case 95: // $564
      var $565=$16;
      var $566=___cxa_begin_catch($565);
      (function() { try { __THREW__ = false; return __ZN8emu_file15remove_on_closeEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 110; break; }
    case 96: // $567
      var $568=(($19+4)|0);
      var $569=HEAP32[(($568)>>2)];
      var $570=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($569) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 110; break; };
    case 97: // $571
      var $572=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($570) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 110; break; };
    case 98: // $573
      var $574=$tempbuffer;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($572, $574) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 110; break; }
    case 99: // $575
      var $576=(($19+4)|0);
      var $577=HEAP32[(($576)>>2)];
      var $578=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($577) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 110; break; };
    case 100: // $579
      var $580=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($578) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 101; break; } else { __label__ = 110; break; };
    case 101: // $581
      var $582=$chartable;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($580, $582) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 110; break; }
    case 102: // $583
      $12=0;
      $18=1;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 3; break; }
    case 103: // $584
      var $585=(($19+4)|0);
      var $586=HEAP32[(($585)>>2)];
      var $587=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($586) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 43; break; };
    case 104: // $588
      var $589=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($587) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 43; break; };
    case 105: // $590
      var $591=$tempbuffer2;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($589, $591) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 43; break; }
    case 106: // $592
      var $593=(($19+4)|0);
      var $594=HEAP32[(($593)>>2)];
      var $595=(function() { try { __THREW__ = false; return __ZNK14render_manager7machineEv($594) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 43; break; };
    case 107: // $596
      var $597=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 43; break; };
    case 108: // $598
      var $599=$chartable1;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($597, $599) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 43; break; }
    case 109: // $600
      $12=1;
      $18=1;
      __label__ = 113; break;
    case 110: // $601
      var $602=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $603=$602.f0;
      $16=$603;
      var $604=$602.f1;
      $17=$604;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 118; break; }
    case 111: // $605
      __label__ = 113; break;
    case 112: // $606
      __label__ = 115; break;
    case 113: // $608
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $cleanup_dest=$18;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 114; break;
      }
      else {
      __label__ = 119; break;
      }
      
    case 114: // $609
      var $610=$12;
      STACKTOP = __stackBase__;
      return $610;
    case 115: // $611
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 118; break; }
    case 116: // $612
      __label__ = 117; break;
    case 117: // $613
      var $614=$16;
      var $615=$16;
      var $616=$17;
      var $617=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $615, tempValue);
      var $618=($617.f1 = $616, $617);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 118: // $619
      var $620=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 119: // $621
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11render_font11save_cachedEPKcj["X"]=1;
// WARNING: content after a branch in a label, line: 555898
// WARNING: content after a branch in a label, line: 555899
// WARNING: content after a branch in a label, line: 555943

function __ZNK21function_symbol_entry7is_lvalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK16expression_error11code_stringEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      if ($5 == 1) {
        __label__ = 1; break;
      }
      else if ($5 == 2) {
        __label__ = 2; break;
      }
      else if ($5 == 3) {
        __label__ = 3; break;
      }
      else if ($5 == 4) {
        __label__ = 4; break;
      }
      else if ($5 == 5) {
        __label__ = 5; break;
      }
      else if ($5 == 6) {
        __label__ = 6; break;
      }
      else if ($5 == 7) {
        __label__ = 7; break;
      }
      else if ($5 == 8) {
        __label__ = 8; break;
      }
      else if ($5 == 9) {
        __label__ = 9; break;
      }
      else if ($5 == 10) {
        __label__ = 10; break;
      }
      else if ($5 == 11) {
        __label__ = 11; break;
      }
      else if ($5 == 12) {
        __label__ = 12; break;
      }
      else if ($5 == 13) {
        __label__ = 13; break;
      }
      else if ($5 == 14) {
        __label__ = 14; break;
      }
      else if ($5 == 15) {
        __label__ = 15; break;
      }
      else if ($5 == 17) {
        __label__ = 16; break;
      }
      else if ($5 == 16) {
        __label__ = 17; break;
      }
      else if ($5 == 18) {
        __label__ = 18; break;
      }
      else if ($5 == 19) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 1: // $6
      $1=((STRING_TABLE.__str4736)|0);
      __label__ = 21; break;
    case 2: // $7
      $1=((STRING_TABLE.__str14737)|0);
      __label__ = 21; break;
    case 3: // $8
      $1=((STRING_TABLE.__str24738)|0);
      __label__ = 21; break;
    case 4: // $9
      $1=((STRING_TABLE.__str34739)|0);
      __label__ = 21; break;
    case 5: // $10
      $1=((STRING_TABLE.__str44740)|0);
      __label__ = 21; break;
    case 6: // $11
      $1=((STRING_TABLE.__str54741)|0);
      __label__ = 21; break;
    case 7: // $12
      $1=((STRING_TABLE.__str64742)|0);
      __label__ = 21; break;
    case 8: // $13
      $1=((STRING_TABLE.__str74743)|0);
      __label__ = 21; break;
    case 9: // $14
      $1=((STRING_TABLE.__str84744)|0);
      __label__ = 21; break;
    case 10: // $15
      $1=((STRING_TABLE.__str94745)|0);
      __label__ = 21; break;
    case 11: // $16
      $1=((STRING_TABLE.__str104746)|0);
      __label__ = 21; break;
    case 12: // $17
      $1=((STRING_TABLE.__str114747)|0);
      __label__ = 21; break;
    case 13: // $18
      $1=((STRING_TABLE.__str124748)|0);
      __label__ = 21; break;
    case 14: // $19
      $1=((STRING_TABLE.__str134749)|0);
      __label__ = 21; break;
    case 15: // $20
      $1=((STRING_TABLE.__str144750)|0);
      __label__ = 21; break;
    case 16: // $21
      $1=((STRING_TABLE.__str154751)|0);
      __label__ = 21; break;
    case 17: // $22
      $1=((STRING_TABLE.__str164752)|0);
      __label__ = 21; break;
    case 18: // $23
      $1=((STRING_TABLE.__str174753)|0);
      __label__ = 21; break;
    case 19: // $24
      $1=((STRING_TABLE.__str184754)|0);
      __label__ = 21; break;
    case 20: // $25
      $1=((STRING_TABLE.__str194755)|0);
      __label__ = 21; break;
    case 21: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20integer_symbol_entry15internal_getterER12symbol_tablePv($table, $symref) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$table;
  $2=$symref;
  var $3=$2;
  var $4=$3;
  var $st$6$0=(($4)|0);
  var $5$0=HEAP32[(($st$6$0)>>2)];
  var $st$6$1=(($4+4)|0);
  var $5$1=HEAP32[(($st$6$1)>>2)];
  ;
  return [$5$0,$5$1];
}


function __ZN20integer_symbol_entry15internal_setterER12symbol_tablePvy($table, $symref, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$table;
  $2=$symref;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$value$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$value$1;
  var $st$9$0=(($3)|0);
  var $4$0=HEAP32[(($st$9$0)>>2)];
  var $st$9$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$9$1)>>2)];
  var $5=$2;
  var $6=$5;
  var $st$15$0=(($6)|0);
  HEAP32[(($st$15$0)>>2)]=$4$0;
  var $st$15$1=(($6+4)|0);
  HEAP32[(($st$15$1)>>2)]=$4$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNK20integer_symbol_entry7is_lvalEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+88)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZN19resource_pool_arrayIN11render_font5glyphEEC1EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayIN11render_font5glyphEEC2EPS1_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayIN11render_font5glyphEEC2EPS1_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<5))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayIN11render_font5glyphEE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayIN11render_font5glyphEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayIN11render_font5glyphEED2Ev($2);
  ;
  return;
}


function __ZN12symbol_entryC2ER12symbol_tableNS_11symbol_typeEPKcPv($this, $table, $type, $name, $ref) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$table;
  $3=$type;
  $4=$name;
  $5=$ref;
  var $6=$1;
  var $7=$6;
  HEAP32[(($7)>>2)]=((__ZTV12symbol_entry+8)|0);
  var $8=(($6+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($6+8)|0);
  var $10=$2;
  HEAP32[(($9)>>2)]=$10;
  var $11=(($6+12)|0);
  var $12=$3;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($6+16)|0);
  var $14=$4;
  __ZN7astringC1EPKc($13, $14);
  var $15=(($6+80)|0);
  var $16=$5;
  HEAP32[(($15)>>2)]=$16;
  ;
  return;
}


function __ZN12symbol_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV12symbol_entry+8)|0);
  var $4=(($2+16)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($4);
  ;
  return;
}


function __ZN20integer_symbol_entryC2ER12symbol_tablePKcNS0_10read_writeEPy($this, $table, $name, $rw, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$table;
      $3=$name;
      $4=$rw;
      $5=$ptr;
      var $6=$1;
      var $7=$6;
      HEAP32[(($7)>>2)]=((__ZTV20integer_symbol_entry+8)|0);
      var $8=$6;
      var $9=$2;
      var $10=$3;
      var $11=$5;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($6+92)|0);
      var $18 = $14;__label__ = 3; break;
    case 2: // $15
      var $16=$5;
      var $18 = $16;__label__ = 3; break;
    case 3: // $17
      var $18;
      var $19=$18;
      __ZN12symbol_entryC2ER12symbol_tableNS_11symbol_typeEPKcPv($8, $9, 0, $10, $19);
      var $20=$6;
      HEAP32[(($20)>>2)]=((__ZTV20integer_symbol_entry+8)|0);
      var $21=(($6+84)|0);
      HEAP32[(($21)>>2)]=1114;
      var $22=(($6+88)|0);
      var $23=$4;
      var $24=(($23)|0)==0;
      var $25=$24 ? 0 : 1116;
      HEAP32[(($22)>>2)]=$25;
      var $26=(($6+92)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$15$0=(($26)|0);
      HEAP32[(($st$15$0)>>2)]=$$emscripten$temp$0$0;
      var $st$15$1=(($26+4)|0);
      HEAP32[(($st$15$1)>>2)]=$$emscripten$temp$0$1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20integer_symbol_entryC2ER12symbol_tablePKcPvPFyS1_S4_EPFvS1_S4_yE($this, $table, $name, $ref, $getter, $setter) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$table;
  $3=$name;
  $4=$ref;
  $5=$getter;
  $6=$setter;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  __ZN12symbol_entryC2ER12symbol_tableNS_11symbol_typeEPKcPv($8, $9, 0, $10, $11);
  var $12=$7;
  HEAP32[(($12)>>2)]=((__ZTV20integer_symbol_entry+8)|0);
  var $13=(($7+84)|0);
  var $14=$5;
  HEAP32[(($13)>>2)]=$14;
  var $15=(($7+88)|0);
  var $16=$6;
  HEAP32[(($15)>>2)]=$16;
  var $17=(($7+92)|0);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $st$29$0=(($17)|0);
  HEAP32[(($st$29$0)>>2)]=$$emscripten$temp$0$0;
  var $st$29$1=(($17+4)|0);
  HEAP32[(($st$29$1)>>2)]=$$emscripten$temp$0$1;
  ;
  return;
}


function __ZNK20integer_symbol_entry5valueEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+84)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$2;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=(($8+80)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=FUNCTION_TABLE[$4]($7, $10);
  var $11$0=$11[0];
  var $11$1=$11[1];
  ;
  return [$11$0,$11$1];
}


function __ZN21function_symbol_entryC2ER12symbol_tablePKcPviiPFyS1_S4_iPKyE($this, $table, $name, $ref, $minparams, $maxparams, $execute) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$table;
  $3=$name;
  $4=$ref;
  $5=$minparams;
  $6=$maxparams;
  $7=$execute;
  var $8=$1;
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  __ZN12symbol_entryC2ER12symbol_tableNS_11symbol_typeEPKcPv($9, $10, 1, $11, $12);
  var $13=$8;
  HEAP32[(($13)>>2)]=((__ZTV21function_symbol_entry+8)|0);
  var $14=(($8+84)|0);
  var $15=$5;
  var $16=(($15) & 65535);
  HEAP16[(($14)>>1)]=$16;
  var $17=(($8+86)|0);
  var $18=$6;
  var $19=(($18) & 65535);
  HEAP16[(($17)>>1)]=$19;
  var $20=(($8+88)|0);
  var $21=$7;
  HEAP32[(($20)>>2)]=$21;
  ;
  return;
}


function __ZN13resource_pool9add_arrayIN11render_font5glyphEEEPT_S4_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN11render_font5glyphEEC1EPS1_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayIN11render_font5glyphEEEPT_S4_i["X"]=1;

function __ZN19resource_pool_arrayIN11render_font5glyphEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayIN11render_font5glyphEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayIN11render_font5glyphEED0Ev["X"]=1;

function __ZN19resource_pool_arrayIN11render_font5glyphEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayIN11render_font5glyphEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12symbol_entryD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12symbol_entryD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12symbol_entryD0Ev["X"]=1;

function __ZN20integer_symbol_entry9set_valueEy($this, $newvalue$0, $newvalue$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      $1=$this;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$newvalue$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$newvalue$1;
      var $5=$1;
      var $6=(($5+88)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=(($5+88)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$5;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$5;
      var $16=(($15+80)|0);
      var $17=HEAP32[(($16)>>2)];
      var $st$8$0=(($2)|0);
      var $18$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($2+4)|0);
      var $18$1=HEAP32[(($st$8$1)>>2)];
      FUNCTION_TABLE[$11]($14, $17, $18$0, $18$1);
      __label__ = 6; break;
    case 2: // $19
      var $20=___cxa_allocate_exception(1032);
      var $21=$20;
      var $22=$5;
      var $23=(($22+16)|0);
      var $24=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $25
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($21, ((STRING_TABLE.__str204756)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      ___cxa_throw($20, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $3=$29;
      var $30=$28.f1;
      $4=$30;
      ___cxa_free_exception($20);
      __label__ = 7; break;
    case 6: // $31
      STACKTOP = __stackBase__;
      return;
    case 7: // $32
      var $33=$3;
      var $34=$3;
      var $35=$4;
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20integer_symbol_entry9set_valueEy["X"]=1;

function __ZNK21function_symbol_entry5valueEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      $2=$this;
      var $5=$2;
      var $6=___cxa_allocate_exception(1032);
      var $7=$6;
      var $8=$5;
      var $9=(($8+16)|0);
      var $10=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $11
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($7, ((STRING_TABLE.__str214757)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      ___cxa_throw($6, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $3=$15;
      var $16=$14.f1;
      $4=$16;
      ___cxa_free_exception($6);
      __label__ = 4; break;
    case 4: // $19
      var $20=$3;
      var $21=$3;
      var $22=$4;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21function_symbol_entry9set_valueEy($this, $newvalue$0, $newvalue$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      $1=$this;
      var $st$5$0=(($2)|0);
      HEAP32[(($st$5$0)>>2)]=$newvalue$0;
      var $st$5$1=(($2+4)|0);
      HEAP32[(($st$5$1)>>2)]=$newvalue$1;
      var $5=$1;
      var $6=___cxa_allocate_exception(1032);
      var $7=$6;
      var $8=$5;
      var $9=(($8+16)|0);
      var $10=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $11
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($7, ((STRING_TABLE.__str224758)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      ___cxa_throw($6, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $3=$15;
      var $16=$14.f1;
      $4=$16;
      ___cxa_free_exception($6);
      __label__ = 4; break;
    case 4: // $18
      var $19=$3;
      var $20=$3;
      var $21=$4;
      var $22=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20, tempValue);
      var $23=($22.f1 = $21, $22);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12symbol_table16configure_memoryEPvPFN16expression_error10error_codeES0_PKc16expression_spaceEPFyS0_S4_S5_jiEPFvS0_S4_S5_jiyE($this, $param, $valid, $read, $write) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$param;
  $3=$valid;
  $4=$read;
  $5=$write;
  var $6=$1;
  var $7=$2;
  var $8=(($6+416)|0);
  HEAP32[(($8)>>2)]=$7;
  var $9=$3;
  var $10=(($6+420)|0);
  HEAP32[(($10)>>2)]=$9;
  var $11=$4;
  var $12=(($6+424)|0);
  HEAP32[(($12)>>2)]=$11;
  var $13=$5;
  var $14=(($6+428)|0);
  HEAP32[(($14)>>2)]=$13;
  ;
  return;
}


function __ZN12symbol_tableC2EPvPS_($this, $globalref, $parent) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$globalref;
  $3=$parent;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$3;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($4+8)|0);
  __ZN11tagged_listI12symbol_entryEC1ER13resource_pool($9, _global_resource_pool);
  var $10=(($4+416)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($4+420)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($4+424)|0);
  HEAP32[(($12)>>2)]=0;
  var $13=(($4+428)|0);
  HEAP32[(($13)>>2)]=0;
  ;
  return;
}


function __ZN11tagged_listI12symbol_entryEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11tagged_listI12symbol_entryEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11tagged_listI12symbol_entryE6removeEPKc($this, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $object;
      $1=$this;
      $2=$tag;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11tagged_listI12symbol_entryE4findEPKc($3, $4);
      $object=$5;
      var $6=$object;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$object;
      __ZN11tagged_listI12symbol_entryE6removeERS0_($3, $9);
      __label__ = 2; break;
    case 2: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21function_symbol_entry7executeEiPKy($this, $numparams, $paramlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$numparams;
      $3=$paramlist;
      var $6=$1;
      var $7=$2;
      var $8=(($6+84)|0);
      var $9=HEAPU16[(($8)>>1)];
      var $10=(($9)&65535);
      var $11=(($7)|0) < (($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $12
      var $13=___cxa_allocate_exception(1032);
      var $14=$13;
      var $15=$6;
      var $16=(($15+16)|0);
      var $17=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $18
      var $19=(($6+84)|0);
      var $20=HEAPU16[(($19)>>1)];
      var $21=(($20)&65535);
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($14, ((STRING_TABLE.__str234759)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,HEAP32[((tempInt+4)>>2)]=$21,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      ___cxa_throw($13, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      ___cxa_free_exception($13);
      __label__ = 11; break;
    case 5: // $27
      var $28=$2;
      var $29=(($6+86)|0);
      var $30=HEAPU16[(($29)>>1)];
      var $31=(($30)&65535);
      var $32=(($28)|0) > (($31)|0);
      if ($32) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $33
      var $34=___cxa_allocate_exception(1032);
      var $35=$34;
      var $36=$6;
      var $37=(($36+16)|0);
      var $38=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $39
      var $40=(($6+86)|0);
      var $41=HEAPU16[(($40)>>1)];
      var $42=(($41)&65535);
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($35, ((STRING_TABLE.__str244760)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$38,HEAP32[((tempInt+4)>>2)]=$42,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $43
      ___cxa_throw($34, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 9: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $4=$46;
      var $47=$45.f1;
      $5=$47;
      ___cxa_free_exception($34);
      __label__ = 11; break;
    case 10: // $48
      var $49=(($6+88)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$6;
      var $52=(($51+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$6;
      var $55=(($54+80)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$2;
      var $58=$3;
      var $59=FUNCTION_TABLE[$50]($53, $56, $57, $58);
      var $59$0=$59[0];
      var $59$1=$59[1];
      ;
      return [$59$0,$59$1];
    case 11: // $60
      var $61=$4;
      var $62=$4;
      var $63=$5;
      var $64=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $62, tempValue);
      var $65=($64.f1 = $63, $64);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21function_symbol_entry7executeEiPKy["X"]=1;

function __ZN12symbol_table3addEPKcNS_10read_writeEPy($this, $name, $rw, $ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$this;
      $10=$name;
      $11=$rw;
      $12=$ptr;
      var $15=$9;
      var $16=(($15+8)|0);
      var $17=$10;
      __ZN11tagged_listI12symbol_entryE6removeEPKc($16, $17);
      var $18=(($15+8)|0);
      var $19=$10;
      var $20=$4;
      var $21=$5;
      var $22=$6;
      var $23=$result_i;
      var $24=$7;
      var $25=$8;
      HEAP32[(($4)>>2)]=100;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=448;
      var $26=HEAP32[(($4)>>2)];
      var $27=HEAP32[(($5)>>2)];
      var $28=HEAP32[(($6)>>2)];
      var $29=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $30
      HEAP32[(($result_i)>>2)]=$29;
      var $31=HEAP32[(($result_i)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $33
      var $34=___cxa_allocate_exception(4);
      var $35=$34;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35);
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($7)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($8)>>2)]=$39;
      var $40=HEAP32[(($8)>>2)];
      var $41=(($40)|0) < 0;
      if ($41) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $42
      var $43=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($43);
      throw "Reached an unreachable!"
    case 5: // $44
      var $45=HEAP32[(($7)>>2)];
      var $46=HEAP32[(($7)>>2)];
      var $47=HEAP32[(($8)>>2)];
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $50
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $51=HEAP32[(($result_i)>>2)];
      var $52=$4;
      var $53=$5;
      var $54=$6;
      var $55=$result_i;
      var $56=$7;
      var $57=$8;
      var $58=$51;
      var $59=$10;
      var $60=$11;
      var $61=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN20integer_symbol_entryC1ER12symbol_tablePKcNS0_10read_writeEPy]($58, $15, $59, $60, $61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $62
      var $63=__ZN13resource_pool10add_objectI20integer_symbol_entryEEPT_S3_(_global_resource_pool, $58);
      var $64=$63;
      var $65=__ZN11tagged_listI12symbol_entryE6appendEPKcRS0_($18, $19, $64);
      STACKTOP = __stackBase__;
      return;
    case 9: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      $13=$68;
      var $69=$67.f1;
      $14=$69;
      var $70=$1;
      var $71=$2;
      var $72=$3;
      HEAP32[(($1)>>2)]=$51;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=448;
      var $73=HEAP32[(($1)>>2)];
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $75
      var $76=HEAP32[(($1)>>2)];
      var $77=HEAP32[(($2)>>2)];
      var $78=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($76, $77, $78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $79=$1;
      var $80=$2;
      var $81=$3;
      __label__ = 13; break;
    case 13: // $82
      __label__ = 14; break;
    case 14: // $83
      var $84=$13;
      var $85=$13;
      var $86=$14;
      var $87=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $85, tempValue);
      var $88=($87.f1 = $86, $87);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $89
      var $90=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12symbol_table3addEPKcNS_10read_writeEPy["X"]=1;

function __ZN11tagged_listI12symbol_entryE6appendEPKcRS0_($this, $tag, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$tag;
      $3=$object;
      var $6=$1;
      var $7=(($6+20)|0);
      var $8=$2;
      var $9=$3;
      var $10=__ZN8tagmap_tIP12symbol_entryE15add_unique_hashEPKcS1_b($7, $8, $9, 0);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=___cxa_allocate_exception(1032);
      var $14=$13;
      var $15=$2;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($14, ((STRING_TABLE.__str474783)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      ___cxa_throw($13, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 3: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $4=$19;
      var $20=$18.f1;
      $5=$20;
      ___cxa_free_exception($13);
      __label__ = 5; break;
    case 4: // $21
      var $22=(($6)|0);
      var $23=$3;
      var $24=__ZN11simple_listI12symbol_entryE6appendERS0_($22, $23);
      ;
      return $24;
    case 5: // $25
      var $26=$4;
      var $27=$4;
      var $28=$5;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI20integer_symbol_entryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI20integer_symbol_entryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI20integer_symbol_entryEEPT_S3_["X"]=1;

function __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($this, $name, $ref, $getter, $setter) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      $9=$this;
      $10=$name;
      $11=$ref;
      $12=$getter;
      $13=$setter;
      var $16=$9;
      var $17=(($16+8)|0);
      var $18=$10;
      __ZN11tagged_listI12symbol_entryE6removeEPKc($17, $18);
      var $19=(($16+8)|0);
      var $20=$10;
      var $21=$4;
      var $22=$5;
      var $23=$6;
      var $24=$result_i;
      var $25=$7;
      var $26=$8;
      HEAP32[(($4)>>2)]=100;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=470;
      var $27=HEAP32[(($4)>>2)];
      var $28=HEAP32[(($5)>>2)];
      var $29=HEAP32[(($6)>>2)];
      var $30=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($27, $28, $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $31
      HEAP32[(($result_i)>>2)]=$30;
      var $32=HEAP32[(($result_i)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $34
      var $35=___cxa_allocate_exception(4);
      var $36=$35;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($36);
      (function() { try { __THREW__ = false; return ___cxa_throw($35, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      HEAP32[(($7)>>2)]=$39;
      var $40=$38.f1;
      HEAP32[(($8)>>2)]=$40;
      var $41=HEAP32[(($8)>>2)];
      var $42=(($41)|0) < 0;
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      var $44=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($44);
      throw "Reached an unreachable!"
    case 5: // $45
      var $46=HEAP32[(($7)>>2)];
      var $47=HEAP32[(($7)>>2)];
      var $48=HEAP32[(($8)>>2)];
      var $49=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $47, tempValue);
      var $50=($49.f1 = $48, $49);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $51
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $52=HEAP32[(($result_i)>>2)];
      var $53=$4;
      var $54=$5;
      var $55=$6;
      var $56=$result_i;
      var $57=$7;
      var $58=$8;
      var $59=$52;
      var $60=$10;
      var $61=$11;
      var $62=$12;
      var $63=$13;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN20integer_symbol_entryC1ER12symbol_tablePKcPvPFyS1_S4_EPFvS1_S4_yE]($59, $16, $60, $61, $62, $63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $64
      var $65=__ZN13resource_pool10add_objectI20integer_symbol_entryEEPT_S3_(_global_resource_pool, $59);
      var $66=$65;
      var $67=__ZN11tagged_listI12symbol_entryE6appendEPKcRS0_($19, $20, $66);
      STACKTOP = __stackBase__;
      return;
    case 9: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $14=$70;
      var $71=$69.f1;
      $15=$71;
      var $72=$1;
      var $73=$2;
      var $74=$3;
      HEAP32[(($1)>>2)]=$52;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=470;
      var $75=HEAP32[(($1)>>2)];
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $77
      var $78=HEAP32[(($1)>>2)];
      var $79=HEAP32[(($2)>>2)];
      var $80=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($78, $79, $80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $81=$1;
      var $82=$2;
      var $83=$3;
      __label__ = 13; break;
    case 13: // $84
      __label__ = 14; break;
    case 14: // $85
      var $86=$14;
      var $87=$14;
      var $88=$15;
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE["X"]=1;

function __ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE($this, $name, $ref, $minparams, $maxparams, $execute) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15;
      var $16;
      $9=$this;
      $10=$name;
      $11=$ref;
      $12=$minparams;
      $13=$maxparams;
      $14=$execute;
      var $17=$9;
      var $18=(($17+8)|0);
      var $19=$10;
      __ZN11tagged_listI12symbol_entryE6removeEPKc($18, $19);
      var $20=(($17+8)|0);
      var $21=$10;
      var $22=$4;
      var $23=$5;
      var $24=$6;
      var $25=$result_i;
      var $26=$7;
      var $27=$8;
      HEAP32[(($4)>>2)]=92;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=481;
      var $28=HEAP32[(($4)>>2)];
      var $29=HEAP32[(($5)>>2)];
      var $30=HEAP32[(($6)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($7)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($8)>>2)]=$41;
      var $42=HEAP32[(($8)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $44
      var $45=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 5: // $46
      var $47=HEAP32[(($7)>>2)];
      var $48=HEAP32[(($7)>>2)];
      var $49=HEAP32[(($8)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $52
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $53=HEAP32[(($result_i)>>2)];
      var $54=$4;
      var $55=$5;
      var $56=$6;
      var $57=$result_i;
      var $58=$7;
      var $59=$8;
      var $60=$53;
      var $61=$10;
      var $62=$11;
      var $63=$12;
      var $64=$13;
      var $65=$14;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21function_symbol_entryC1ER12symbol_tablePKcPviiPFyS1_S4_iPKyE]($60, $17, $61, $62, $63, $64, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $66
      var $67=__ZN13resource_pool10add_objectI21function_symbol_entryEEPT_S3_(_global_resource_pool, $60);
      var $68=$67;
      var $69=__ZN11tagged_listI12symbol_entryE6appendEPKcRS0_($20, $21, $68);
      STACKTOP = __stackBase__;
      return;
    case 9: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $15=$72;
      var $73=$71.f1;
      $16=$73;
      var $74=$1;
      var $75=$2;
      var $76=$3;
      HEAP32[(($1)>>2)]=$53;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=481;
      var $77=HEAP32[(($1)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $79
      var $80=HEAP32[(($1)>>2)];
      var $81=HEAP32[(($2)>>2)];
      var $82=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($80, $81, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $83=$1;
      var $84=$2;
      var $85=$3;
      __label__ = 13; break;
    case 13: // $86
      __label__ = 14; break;
    case 14: // $87
      var $88=$15;
      var $89=$15;
      var $90=$16;
      var $91=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $89, tempValue);
      var $92=($91.f1 = $90, $91);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $93
      var $94=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE["X"]=1;

function __ZN12symbol_table9find_deepEPKc($this, $symbol) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $symtable;
      var $entry;
      $2=$this;
      $3=$symbol;
      var $4=$2;
      $symtable=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$symtable;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$symtable;
      var $10=$3;
      var $11=__ZN12symbol_table4findEPKc($9, $10);
      $entry=$11;
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$entry;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$symtable;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $symtable=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12symbol_table12memory_validEPKc16expression_space($this, $name, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $symtable;
      var $err;
      $2=$this;
      $3=$name;
      $4=$space;
      var $5=$2;
      $symtable=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$symtable;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      var $10=$symtable;
      var $11=(($10+420)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $14
      var $15=$symtable;
      var $16=(($15+420)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$symtable;
      var $19=(($18+416)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$3;
      var $22=$4;
      var $23=FUNCTION_TABLE[$17]($20, $21, $22);
      $err=$23;
      var $24=$err;
      var $25=(($24)|0)!=17;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$err;
      $1=$27;
      __label__ = 9; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=$symtable;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      $symtable=$33;
      __label__ = 1; break;
    case 8: // $34
      $1=17;
      __label__ = 9; break;
    case 9: // $35
      var $36=$1;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12symbol_table12memory_valueEPKc16expression_spaceji($this, $name, $space, $offset, $size) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $symtable;
      var $err;
      $2=$this;
      $3=$name;
      $4=$space;
      $5=$offset;
      $6=$size;
      var $7=$2;
      $symtable=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$symtable;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $11
      var $12=$symtable;
      var $13=(($12+420)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $16
      var $17=$symtable;
      var $18=(($17+420)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$symtable;
      var $21=(($20+416)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$3;
      var $24=$4;
      var $25=FUNCTION_TABLE[$19]($22, $23, $24);
      $err=$25;
      var $26=$err;
      var $27=(($26)|0)!=17;
      if ($27) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $28
      var $29=$symtable;
      var $30=(($29+424)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$symtable;
      var $35=(($34+424)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$symtable;
      var $38=(($37+416)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$3;
      var $41=$4;
      var $42=$5;
      var $43=$6;
      var $44=FUNCTION_TABLE[$36]($39, $40, $41, $42, $43);
      var $44$0=$44[0];
      var $44$1=$44[1];
      var $st$13$0=(($1)|0);
      HEAP32[(($st$13$0)>>2)]=$44$0;
      var $st$13$1=(($1+4)|0);
      HEAP32[(($st$13$1)>>2)]=$44$1;
      __label__ = 10; break;
    case 6: // $45
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 10; break;
    case 7: // $46
      __label__ = 8; break;
    case 8: // $47
      var $48=$symtable;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      $symtable=$50;
      __label__ = 1; break;
    case 9: // $51
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$1$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 10; break;
    case 10: // $52
      var $st$0$0=(($1)|0);
      var $53$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $53$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$53$0,$53$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12symbol_table12memory_valueEPKc16expression_spaceji["X"]=1;

function __ZN12symbol_table16set_memory_valueEPKc16expression_spacejiy($this, $name, $space, $offset, $size, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6=__stackBase__;
      var $symtable;
      var $err;
      $1=$this;
      $2=$name;
      $3=$space;
      $4=$offset;
      $5=$size;
      var $st$13$0=(($6)|0);
      HEAP32[(($st$13$0)>>2)]=$value$0;
      var $st$13$1=(($6+4)|0);
      HEAP32[(($st$13$1)>>2)]=$value$1;
      var $7=$1;
      $symtable=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$symtable;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $11
      var $12=$symtable;
      var $13=(($12+420)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $16
      var $17=$symtable;
      var $18=(($17+420)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$symtable;
      var $21=(($20+416)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$2;
      var $24=$3;
      var $25=FUNCTION_TABLE[$19]($22, $23, $24);
      $err=$25;
      var $26=$err;
      var $27=(($26)|0)!=17;
      if ($27) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $28
      var $29=$symtable;
      var $30=(($29+428)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$symtable;
      var $35=(($34+428)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$symtable;
      var $38=(($37+416)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$2;
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $st$10$0=(($6)|0);
      var $44$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($6+4)|0);
      var $44$1=HEAP32[(($st$10$1)>>2)];
      FUNCTION_TABLE[$36]($39, $40, $41, $42, $43, $44$0, $44$1);
      __label__ = 6; break;
    case 6: // $45
      __label__ = 9; break;
    case 7: // $46
      __label__ = 8; break;
    case 8: // $47
      var $48=$symtable;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      $symtable=$50;
      __label__ = 1; break;
    case 9: // $51
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12symbol_table16set_memory_valueEPKc16expression_spacejiy["X"]=1;

function __ZN11simple_listIN17parsed_expression11parse_tokenEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN17parsed_expression11parse_tokenEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression17expression_stringEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN17parsed_expression17expression_stringEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN17parsed_expression5parseEPKc($this, $expression) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$expression;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=$2;
  var $6=__ZN7astring3cpyEPKc($4, $5);
  var $7=(($3+68)|0);
  __ZN11simple_listIN17parsed_expression11parse_tokenEE5resetEv($7);
  var $8=(($3+88)|0);
  __ZN11simple_listIN17parsed_expression17expression_stringEE5resetEv($8);
  __ZN17parsed_expression24parse_string_into_tokensEv($3);
  __ZN17parsed_expression16infix_to_postfixEv($3);
  ;
  return;
}


function __ZN13resource_pool10add_objectI21function_symbol_entryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI21function_symbol_entryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI21function_symbol_entryEEPT_S3_["X"]=1;

function __ZN17parsed_expressionC2EP12symbol_tablePKcPy($this, $symtable, $expression, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$symtable;
      $3=$expression;
      $4=$result;
      var $7=$1;
      var $8=(($7)|0);
      var $9=$2;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($7+4)|0);
      __ZN7astringC1Ev($10);
      var $11=(($7+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEEC1ER13resource_pool($11, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $12
      var $13=(($7+88)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression17expression_stringEEC1ER13resource_pool($13, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $14
      var $15=(($7+112)|0);
      var $16=(($15)|0);
      var $17=(($16+512)|0);
      var $19 = $16;__label__ = 3; break;
    case 3: // $18
      var $19;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($19, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $20
      var $21=(($19+32)|0);
      var $22=(($21)|0)==(($17)|0);
      if ($22) { __label__ = 5; break; } else { var $19 = $21;__label__ = 3; break; }
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $26
      var $27=$3;
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($7, $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $28
      __label__ = 11; break;
    case 8: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $5=$31;
      var $32=$30.f1;
      $6=$32;
      __label__ = 18; break;
    case 9: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $5=$35;
      var $36=$34.f1;
      $6=$36;
      __label__ = 16; break;
    case 10: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $5=$39;
      var $40=$38.f1;
      $6=$40;
      var $41=(($7+88)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression17expression_stringEED1Ev($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 11: // $42
      var $43=$4;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $45
      var $46=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; };
      var $46$0=$46[0];
      var $46$1=$46[1];
    case 13: // $47
      var $48=$4;
      var $st$1$0=(($48)|0);
      HEAP32[(($st$1$0)>>2)]=$46$0;
      var $st$1$1=(($48+4)|0);
      HEAP32[(($st$1$1)>>2)]=$46$1;
      __label__ = 14; break;
    case 14: // $49
      ;
      return;
    case 15: // $50
      __label__ = 16; break;
    case 16: // $51
      var $52=(($7+68)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $53
      __label__ = 18; break;
    case 18: // $54
      var $55=(($7+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $56
      __label__ = 20; break;
    case 20: // $57
      var $58=$5;
      var $59=$5;
      var $60=$6;
      var $61=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $59, tempValue);
      var $62=($61.f1 = $60, $61);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expressionC2EP12symbol_tablePKcPy["X"]=1;

function __ZN17parsed_expression24parse_string_into_tokensEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $stringstart;
      var $string=__stackBase__+36;
      var $token;
      var $10;
      var $11;
      $9=$this;
      var $12=$9;
      var $13=(($12+4)|0);
      var $14=__ZNK7astringcvPKcEv($13);
      $stringstart=$14;
      var $15=$stringstart;
      HEAP32[(($string)>>2)]=$15;
      __label__ = 1; break;
    case 1: // $16
      var $17=HEAP32[(($string)>>2)];
      var $18=(($17)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 105; break; }
    case 2: // $22
      __label__ = 3; break;
    case 3: // $23
      var $24=HEAP32[(($string)>>2)];
      var $25=(($24)|0);
      var $26=HEAP8[($25)];
      var $27=(($26 << 24) >> 24);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 4; break; } else { var $37 = 0;__label__ = 5; break; }
    case 4: // $29
      var $30=HEAP32[(($string)>>2)];
      var $31=(($30)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=_isspace($33);
      var $35=(($34)|0)!=0;
      var $37 = $35;__label__ = 5; break;
    case 5: // $36
      var $37;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      var $39=HEAP32[(($string)>>2)];
      var $40=(($39+1)|0);
      HEAP32[(($string)>>2)]=$40;
      __label__ = 3; break;
    case 7: // $41
      var $42=HEAP32[(($string)>>2)];
      var $43=(($42)|0);
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $47
      __label__ = 105; break;
    case 9: // $48
      var $49=(($12+68)|0);
      var $50=$4;
      var $51=$5;
      var $52=$6;
      var $53=$result_i;
      var $54=$7;
      var $55=$8;
      HEAP32[(($4)>>2)]=32;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=746;
      var $56=HEAP32[(($4)>>2)];
      var $57=HEAP32[(($5)>>2)];
      var $58=HEAP32[(($6)>>2)];
      var $59=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($56, $57, $58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $60
      HEAP32[(($result_i)>>2)]=$59;
      var $61=HEAP32[(($result_i)>>2)];
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $63
      var $64=___cxa_allocate_exception(4);
      var $65=$64;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($65);
      (function() { try { __THREW__ = false; return ___cxa_throw($64, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      HEAP32[(($7)>>2)]=$68;
      var $69=$67.f1;
      HEAP32[(($8)>>2)]=$69;
      var $70=HEAP32[(($8)>>2)];
      var $71=(($70)|0) < 0;
      if ($71) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $72
      var $73=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($73);
      throw "Reached an unreachable!"
    case 14: // $74
      var $75=HEAP32[(($7)>>2)];
      var $76=HEAP32[(($7)>>2)];
      var $77=HEAP32[(($8)>>2)];
      var $78=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $76, tempValue);
      var $79=($78.f1 = $77, $78);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $80
      throw "Reached an unreachable!"
    case 16: // $_ZnwjPKci_exit
      var $81=HEAPU32[(($result_i)>>2)];
      var $82=$4;
      var $83=$5;
      var $84=$6;
      var $85=$result_i;
      var $86=$7;
      var $87=$8;
      var $88=$81;
      var $89=HEAP32[(($string)>>2)];
      var $90=$stringstart;
      var $91=$89;
      var $92=$90;
      var $93=(($91-$92)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($88, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $94
      var $95=__ZN13resource_pool10add_objectIN17parsed_expression11parse_tokenEEEPT_S4_(_global_resource_pool, $88);
      var $96=__ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($49, $95);
      $token=$96;
      var $97=HEAP32[(($string)>>2)];
      var $98=(($97)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      var $101=_tolower($100);
      if ($101 == 40) {
        __label__ = 23; break;
      }
      else if ($101 == 41) {
        __label__ = 24; break;
      }
      else if ($101 == 126) {
        __label__ = 25; break;
      }
      else if ($101 == 44) {
        __label__ = 26; break;
      }
      else if ($101 == 43) {
        __label__ = 27; break;
      }
      else if ($101 == 45) {
        __label__ = 34; break;
      }
      else if ($101 == 42) {
        __label__ = 41; break;
      }
      else if ($101 == 47) {
        __label__ = 45; break;
      }
      else if ($101 == 37) {
        __label__ = 49; break;
      }
      else if ($101 == 60) {
        __label__ = 53; break;
      }
      else if ($101 == 62) {
        __label__ = 64; break;
      }
      else if ($101 == 61) {
        __label__ = 75; break;
      }
      else if ($101 == 33) {
        __label__ = 79; break;
      }
      else if ($101 == 38) {
        __label__ = 83; break;
      }
      else if ($101 == 124) {
        __label__ = 90; break;
      }
      else if ($101 == 94) {
        __label__ = 97; break;
      }
      else if ($101 == 34) {
        __label__ = 101; break;
      }
      else if ($101 == 39) {
        __label__ = 102; break;
      }
      else {
      __label__ = 103; break;
      }
      
    case 18: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $10=$104;
      var $105=$103.f1;
      $11=$105;
      var $106=$1;
      var $107=$2;
      var $108=$3;
      HEAP32[(($1)>>2)]=$81;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=746;
      var $109=HEAP32[(($1)>>2)];
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $111
      var $112=HEAP32[(($1)>>2)];
      var $113=HEAP32[(($2)>>2)];
      var $114=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($112, $113, $114) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 107; break; }
    case 20: // $_noexc
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $115=$1;
      var $116=$2;
      var $117=$3;
      __label__ = 22; break;
    case 22: // $118
      __label__ = 106; break;
    case 23: // $119
      var $120=HEAP32[(($string)>>2)];
      var $121=(($120+1)|0);
      HEAP32[(($string)>>2)]=$121;
      var $122=$token;
      var $123=__ZN17parsed_expression11parse_token18configure_operatorEhh($122, 0, 0);
      __label__ = 104; break;
    case 24: // $124
      var $125=HEAP32[(($string)>>2)];
      var $126=(($125+1)|0);
      HEAP32[(($string)>>2)]=$126;
      var $127=$token;
      var $128=__ZN17parsed_expression11parse_token18configure_operatorEhh($127, 1, 0);
      __label__ = 104; break;
    case 25: // $129
      var $130=HEAP32[(($string)>>2)];
      var $131=(($130+1)|0);
      HEAP32[(($string)>>2)]=$131;
      var $132=$token;
      var $133=__ZN17parsed_expression11parse_token18configure_operatorEhh($132, 9, 2);
      __label__ = 104; break;
    case 26: // $134
      var $135=HEAP32[(($string)>>2)];
      var $136=(($135+1)|0);
      HEAP32[(($string)>>2)]=$136;
      var $137=$token;
      var $138=__ZN17parsed_expression11parse_token18configure_operatorEhh($137, 41, 14);
      __label__ = 104; break;
    case 27: // $139
      var $140=HEAP32[(($string)>>2)];
      var $141=(($140+1)|0);
      var $142=HEAP8[($141)];
      var $143=(($142 << 24) >> 24);
      var $144=(($143)|0)==43;
      if ($144) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $145
      var $146=HEAP32[(($string)>>2)];
      var $147=(($146+2)|0);
      HEAP32[(($string)>>2)]=$147;
      var $148=$token;
      var $149=__ZN17parsed_expression11parse_token18configure_operatorEhh($148, 2, 1);
      __label__ = 33; break;
    case 29: // $150
      var $151=HEAP32[(($string)>>2)];
      var $152=(($151+1)|0);
      var $153=HEAP8[($152)];
      var $154=(($153 << 24) >> 24);
      var $155=(($154)|0)==61;
      if ($155) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $156
      var $157=HEAP32[(($string)>>2)];
      var $158=(($157+2)|0);
      HEAP32[(($string)>>2)]=$158;
      var $159=$token;
      var $160=__ZN17parsed_expression11parse_token18configure_operatorEhh($159, 34, 13);
      var $161=__ZN17parsed_expression11parse_token17set_right_to_leftEv($160);
      __label__ = 32; break;
    case 31: // $162
      var $163=HEAP32[(($string)>>2)];
      var $164=(($163+1)|0);
      HEAP32[(($string)>>2)]=$164;
      var $165=$token;
      var $166=__ZN17parsed_expression11parse_token18configure_operatorEhh($165, 15, 4);
      __label__ = 32; break;
    case 32: // $167
      __label__ = 33; break;
    case 33: // $168
      __label__ = 104; break;
    case 34: // $169
      var $170=HEAP32[(($string)>>2)];
      var $171=(($170+1)|0);
      var $172=HEAP8[($171)];
      var $173=(($172 << 24) >> 24);
      var $174=(($173)|0)==45;
      if ($174) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $175
      var $176=HEAP32[(($string)>>2)];
      var $177=(($176+2)|0);
      HEAP32[(($string)>>2)]=$177;
      var $178=$token;
      var $179=__ZN17parsed_expression11parse_token18configure_operatorEhh($178, 3, 1);
      __label__ = 40; break;
    case 36: // $180
      var $181=HEAP32[(($string)>>2)];
      var $182=(($181+1)|0);
      var $183=HEAP8[($182)];
      var $184=(($183 << 24) >> 24);
      var $185=(($184)|0)==61;
      if ($185) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $186
      var $187=HEAP32[(($string)>>2)];
      var $188=(($187+2)|0);
      HEAP32[(($string)>>2)]=$188;
      var $189=$token;
      var $190=__ZN17parsed_expression11parse_token18configure_operatorEhh($189, 35, 13);
      var $191=__ZN17parsed_expression11parse_token17set_right_to_leftEv($190);
      __label__ = 39; break;
    case 38: // $192
      var $193=HEAP32[(($string)>>2)];
      var $194=(($193+1)|0);
      HEAP32[(($string)>>2)]=$194;
      var $195=$token;
      var $196=__ZN17parsed_expression11parse_token18configure_operatorEhh($195, 16, 4);
      __label__ = 39; break;
    case 39: // $197
      __label__ = 40; break;
    case 40: // $198
      __label__ = 104; break;
    case 41: // $199
      var $200=HEAP32[(($string)>>2)];
      var $201=(($200+1)|0);
      var $202=HEAP8[($201)];
      var $203=(($202 << 24) >> 24);
      var $204=(($203)|0)==61;
      if ($204) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $205
      var $206=HEAP32[(($string)>>2)];
      var $207=(($206+2)|0);
      HEAP32[(($string)>>2)]=$207;
      var $208=$token;
      var $209=__ZN17parsed_expression11parse_token18configure_operatorEhh($208, 31, 13);
      var $210=__ZN17parsed_expression11parse_token17set_right_to_leftEv($209);
      __label__ = 44; break;
    case 43: // $211
      var $212=HEAP32[(($string)>>2)];
      var $213=(($212+1)|0);
      HEAP32[(($string)>>2)]=$213;
      var $214=$token;
      var $215=__ZN17parsed_expression11parse_token18configure_operatorEhh($214, 12, 3);
      __label__ = 44; break;
    case 44: // $216
      __label__ = 104; break;
    case 45: // $217
      var $218=HEAP32[(($string)>>2)];
      var $219=(($218+1)|0);
      var $220=HEAP8[($219)];
      var $221=(($220 << 24) >> 24);
      var $222=(($221)|0)==61;
      if ($222) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $223
      var $224=HEAP32[(($string)>>2)];
      var $225=(($224+2)|0);
      HEAP32[(($string)>>2)]=$225;
      var $226=$token;
      var $227=__ZN17parsed_expression11parse_token18configure_operatorEhh($226, 32, 13);
      var $228=__ZN17parsed_expression11parse_token17set_right_to_leftEv($227);
      __label__ = 48; break;
    case 47: // $229
      var $230=HEAP32[(($string)>>2)];
      var $231=(($230+1)|0);
      HEAP32[(($string)>>2)]=$231;
      var $232=$token;
      var $233=__ZN17parsed_expression11parse_token18configure_operatorEhh($232, 13, 3);
      __label__ = 48; break;
    case 48: // $234
      __label__ = 104; break;
    case 49: // $235
      var $236=HEAP32[(($string)>>2)];
      var $237=(($236+1)|0);
      var $238=HEAP8[($237)];
      var $239=(($238 << 24) >> 24);
      var $240=(($239)|0)==61;
      if ($240) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $241
      var $242=HEAP32[(($string)>>2)];
      var $243=(($242+2)|0);
      HEAP32[(($string)>>2)]=$243;
      var $244=$token;
      var $245=__ZN17parsed_expression11parse_token18configure_operatorEhh($244, 33, 13);
      var $246=__ZN17parsed_expression11parse_token17set_right_to_leftEv($245);
      __label__ = 52; break;
    case 51: // $247
      var $248=HEAP32[(($string)>>2)];
      var $249=(($248+1)|0);
      HEAP32[(($string)>>2)]=$249;
      var $250=$token;
      var $251=__ZN17parsed_expression11parse_token18configure_operatorEhh($250, 14, 3);
      __label__ = 52; break;
    case 52: // $252
      __label__ = 104; break;
    case 53: // $253
      var $254=HEAP32[(($string)>>2)];
      var $255=(($254+1)|0);
      var $256=HEAP8[($255)];
      var $257=(($256 << 24) >> 24);
      var $258=(($257)|0)==60;
      if ($258) { __label__ = 54; break; } else { __label__ = 56; break; }
    case 54: // $259
      var $260=HEAP32[(($string)>>2)];
      var $261=(($260+2)|0);
      var $262=HEAP8[($261)];
      var $263=(($262 << 24) >> 24);
      var $264=(($263)|0)==61;
      if ($264) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $265
      var $266=HEAP32[(($string)>>2)];
      var $267=(($266+3)|0);
      HEAP32[(($string)>>2)]=$267;
      var $268=$token;
      var $269=__ZN17parsed_expression11parse_token18configure_operatorEhh($268, 36, 13);
      var $270=__ZN17parsed_expression11parse_token17set_right_to_leftEv($269);
      __label__ = 63; break;
    case 56: // $271
      var $272=HEAP32[(($string)>>2)];
      var $273=(($272+1)|0);
      var $274=HEAP8[($273)];
      var $275=(($274 << 24) >> 24);
      var $276=(($275)|0)==60;
      if ($276) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $277
      var $278=HEAP32[(($string)>>2)];
      var $279=(($278+2)|0);
      HEAP32[(($string)>>2)]=$279;
      var $280=$token;
      var $281=__ZN17parsed_expression11parse_token18configure_operatorEhh($280, 17, 5);
      __label__ = 62; break;
    case 58: // $282
      var $283=HEAP32[(($string)>>2)];
      var $284=(($283+1)|0);
      var $285=HEAP8[($284)];
      var $286=(($285 << 24) >> 24);
      var $287=(($286)|0)==61;
      if ($287) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $288
      var $289=HEAP32[(($string)>>2)];
      var $290=(($289+2)|0);
      HEAP32[(($string)>>2)]=$290;
      var $291=$token;
      var $292=__ZN17parsed_expression11parse_token18configure_operatorEhh($291, 20, 6);
      __label__ = 61; break;
    case 60: // $293
      var $294=HEAP32[(($string)>>2)];
      var $295=(($294+1)|0);
      HEAP32[(($string)>>2)]=$295;
      var $296=$token;
      var $297=__ZN17parsed_expression11parse_token18configure_operatorEhh($296, 19, 6);
      __label__ = 61; break;
    case 61: // $298
      __label__ = 62; break;
    case 62: // $299
      __label__ = 63; break;
    case 63: // $300
      __label__ = 104; break;
    case 64: // $301
      var $302=HEAP32[(($string)>>2)];
      var $303=(($302+1)|0);
      var $304=HEAP8[($303)];
      var $305=(($304 << 24) >> 24);
      var $306=(($305)|0)==62;
      if ($306) { __label__ = 65; break; } else { __label__ = 67; break; }
    case 65: // $307
      var $308=HEAP32[(($string)>>2)];
      var $309=(($308+2)|0);
      var $310=HEAP8[($309)];
      var $311=(($310 << 24) >> 24);
      var $312=(($311)|0)==61;
      if ($312) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $313
      var $314=HEAP32[(($string)>>2)];
      var $315=(($314+3)|0);
      HEAP32[(($string)>>2)]=$315;
      var $316=$token;
      var $317=__ZN17parsed_expression11parse_token18configure_operatorEhh($316, 37, 13);
      var $318=__ZN17parsed_expression11parse_token17set_right_to_leftEv($317);
      __label__ = 74; break;
    case 67: // $319
      var $320=HEAP32[(($string)>>2)];
      var $321=(($320+1)|0);
      var $322=HEAP8[($321)];
      var $323=(($322 << 24) >> 24);
      var $324=(($323)|0)==62;
      if ($324) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $325
      var $326=HEAP32[(($string)>>2)];
      var $327=(($326+2)|0);
      HEAP32[(($string)>>2)]=$327;
      var $328=$token;
      var $329=__ZN17parsed_expression11parse_token18configure_operatorEhh($328, 18, 5);
      __label__ = 73; break;
    case 69: // $330
      var $331=HEAP32[(($string)>>2)];
      var $332=(($331+1)|0);
      var $333=HEAP8[($332)];
      var $334=(($333 << 24) >> 24);
      var $335=(($334)|0)==61;
      if ($335) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $336
      var $337=HEAP32[(($string)>>2)];
      var $338=(($337+2)|0);
      HEAP32[(($string)>>2)]=$338;
      var $339=$token;
      var $340=__ZN17parsed_expression11parse_token18configure_operatorEhh($339, 22, 6);
      __label__ = 72; break;
    case 71: // $341
      var $342=HEAP32[(($string)>>2)];
      var $343=(($342+1)|0);
      HEAP32[(($string)>>2)]=$343;
      var $344=$token;
      var $345=__ZN17parsed_expression11parse_token18configure_operatorEhh($344, 21, 6);
      __label__ = 72; break;
    case 72: // $346
      __label__ = 73; break;
    case 73: // $347
      __label__ = 74; break;
    case 74: // $348
      __label__ = 104; break;
    case 75: // $349
      var $350=HEAP32[(($string)>>2)];
      var $351=(($350+1)|0);
      var $352=HEAP8[($351)];
      var $353=(($352 << 24) >> 24);
      var $354=(($353)|0)==61;
      if ($354) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $355
      var $356=HEAP32[(($string)>>2)];
      var $357=(($356+2)|0);
      HEAP32[(($string)>>2)]=$357;
      var $358=$token;
      var $359=__ZN17parsed_expression11parse_token18configure_operatorEhh($358, 23, 7);
      __label__ = 78; break;
    case 77: // $360
      var $361=HEAP32[(($string)>>2)];
      var $362=(($361+1)|0);
      HEAP32[(($string)>>2)]=$362;
      var $363=$token;
      var $364=__ZN17parsed_expression11parse_token18configure_operatorEhh($363, 30, 13);
      var $365=__ZN17parsed_expression11parse_token17set_right_to_leftEv($364);
      __label__ = 78; break;
    case 78: // $366
      __label__ = 104; break;
    case 79: // $367
      var $368=HEAP32[(($string)>>2)];
      var $369=(($368+1)|0);
      var $370=HEAP8[($369)];
      var $371=(($370 << 24) >> 24);
      var $372=(($371)|0)==61;
      if ($372) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $373
      var $374=HEAP32[(($string)>>2)];
      var $375=(($374+2)|0);
      HEAP32[(($string)>>2)]=$375;
      var $376=$token;
      var $377=__ZN17parsed_expression11parse_token18configure_operatorEhh($376, 24, 7);
      __label__ = 82; break;
    case 81: // $378
      var $379=HEAP32[(($string)>>2)];
      var $380=(($379+2)|0);
      HEAP32[(($string)>>2)]=$380;
      var $381=$token;
      var $382=__ZN17parsed_expression11parse_token18configure_operatorEhh($381, 8, 2);
      __label__ = 82; break;
    case 82: // $383
      __label__ = 104; break;
    case 83: // $384
      var $385=HEAP32[(($string)>>2)];
      var $386=(($385+1)|0);
      var $387=HEAP8[($386)];
      var $388=(($387 << 24) >> 24);
      var $389=(($388)|0)==38;
      if ($389) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $390
      var $391=HEAP32[(($string)>>2)];
      var $392=(($391+2)|0);
      HEAP32[(($string)>>2)]=$392;
      var $393=$token;
      var $394=__ZN17parsed_expression11parse_token18configure_operatorEhh($393, 28, 11);
      __label__ = 89; break;
    case 85: // $395
      var $396=HEAP32[(($string)>>2)];
      var $397=(($396+1)|0);
      var $398=HEAP8[($397)];
      var $399=(($398 << 24) >> 24);
      var $400=(($399)|0)==61;
      if ($400) { __label__ = 86; break; } else { __label__ = 87; break; }
    case 86: // $401
      var $402=HEAP32[(($string)>>2)];
      var $403=(($402+2)|0);
      HEAP32[(($string)>>2)]=$403;
      var $404=$token;
      var $405=__ZN17parsed_expression11parse_token18configure_operatorEhh($404, 38, 13);
      var $406=__ZN17parsed_expression11parse_token17set_right_to_leftEv($405);
      __label__ = 88; break;
    case 87: // $407
      var $408=HEAP32[(($string)>>2)];
      var $409=(($408+1)|0);
      HEAP32[(($string)>>2)]=$409;
      var $410=$token;
      var $411=__ZN17parsed_expression11parse_token18configure_operatorEhh($410, 25, 8);
      __label__ = 88; break;
    case 88: // $412
      __label__ = 89; break;
    case 89: // $413
      __label__ = 104; break;
    case 90: // $414
      var $415=HEAP32[(($string)>>2)];
      var $416=(($415+1)|0);
      var $417=HEAP8[($416)];
      var $418=(($417 << 24) >> 24);
      var $419=(($418)|0)==124;
      if ($419) { __label__ = 91; break; } else { __label__ = 92; break; }
    case 91: // $420
      var $421=HEAP32[(($string)>>2)];
      var $422=(($421+2)|0);
      HEAP32[(($string)>>2)]=$422;
      var $423=$token;
      var $424=__ZN17parsed_expression11parse_token18configure_operatorEhh($423, 29, 12);
      __label__ = 96; break;
    case 92: // $425
      var $426=HEAP32[(($string)>>2)];
      var $427=(($426+1)|0);
      var $428=HEAP8[($427)];
      var $429=(($428 << 24) >> 24);
      var $430=(($429)|0)==61;
      if ($430) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $431
      var $432=HEAP32[(($string)>>2)];
      var $433=(($432+2)|0);
      HEAP32[(($string)>>2)]=$433;
      var $434=$token;
      var $435=__ZN17parsed_expression11parse_token18configure_operatorEhh($434, 40, 13);
      var $436=__ZN17parsed_expression11parse_token17set_right_to_leftEv($435);
      __label__ = 95; break;
    case 94: // $437
      var $438=HEAP32[(($string)>>2)];
      var $439=(($438+1)|0);
      HEAP32[(($string)>>2)]=$439;
      var $440=$token;
      var $441=__ZN17parsed_expression11parse_token18configure_operatorEhh($440, 27, 10);
      __label__ = 95; break;
    case 95: // $442
      __label__ = 96; break;
    case 96: // $443
      __label__ = 104; break;
    case 97: // $444
      var $445=HEAP32[(($string)>>2)];
      var $446=(($445+1)|0);
      var $447=HEAP8[($446)];
      var $448=(($447 << 24) >> 24);
      var $449=(($448)|0)==61;
      if ($449) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $450
      var $451=HEAP32[(($string)>>2)];
      var $452=(($451+2)|0);
      HEAP32[(($string)>>2)]=$452;
      var $453=$token;
      var $454=__ZN17parsed_expression11parse_token18configure_operatorEhh($453, 39, 13);
      var $455=__ZN17parsed_expression11parse_token17set_right_to_leftEv($454);
      __label__ = 100; break;
    case 99: // $456
      var $457=HEAP32[(($string)>>2)];
      var $458=(($457+1)|0);
      HEAP32[(($string)>>2)]=$458;
      var $459=$token;
      var $460=__ZN17parsed_expression11parse_token18configure_operatorEhh($459, 26, 9);
      __label__ = 100; break;
    case 100: // $461
      __label__ = 104; break;
    case 101: // $462
      var $463=$token;
      __ZN17parsed_expression19parse_quoted_stringERNS_11parse_tokenERPKc($12, $463, $string);
      __label__ = 104; break;
    case 102: // $464
      var $465=$token;
      __ZN17parsed_expression17parse_quoted_charERNS_11parse_tokenERPKc($12, $465, $string);
      __label__ = 104; break;
    case 103: // $466
      var $467=$token;
      __ZN17parsed_expression22parse_symbol_or_numberERNS_11parse_tokenERPKc($12, $467, $string);
      __label__ = 104; break;
    case 104: // $468
      __label__ = 1; break;
    case 105: // $469
      STACKTOP = __stackBase__;
      return;
    case 106: // $470
      var $471=$10;
      var $472=$10;
      var $473=$11;
      var $474=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $472, tempValue);
      var $475=($474.f1 = $473, $474);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 107: // $476
      var $477=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression24parse_string_into_tokensEv["X"]=1;

function __ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token18configure_operatorEhh($this, $optype, $precedence) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$optype;
  $3=$precedence;
  var $4=$1;
  var $5=(($4+4)|0);
  HEAP32[(($5)>>2)]=5;
  var $6=$2;
  var $7=(($6)&255);
  var $8=$7 << 0;
  var $9=$8 & 255;
  var $10=$3;
  var $11=(($10)&255);
  var $12=$11 << 24;
  var $13=$12 & -16777216;
  var $14=$9 | $13;
  var $15=(($4+20)|0);
  HEAP32[(($15)>>2)]=$14;
  ;
  return $4;
}


function __ZN17parsed_expression11parse_token17set_right_to_leftEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 | 65536;
      HEAP32[(($5)>>2)]=$7;
      ;
      return $2;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression16infix_to_postfixEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $stack=__stackBase__;
      var $prev;
      var $next;
      var $token;
      var $2;
      var $3;
      var $popped;
      var $our_precedence;
      var $peek;
      var $stack_precedence;
      var $popped1;
      $1=$this;
      var $4=$1;
      __ZN11simple_listIN17parsed_expression11parse_tokenEEC1ER13resource_pool($stack, _global_resource_pool);
      $prev=0;
      $next=0;
      var $5=(($4+68)|0);
      var $6=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE10detach_allEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 12; break; };
    case 1: // $7
      $token=$6;
      __label__ = 2; break;
    case 2: // $8
      var $9=$token;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 61; break; }
    case 3: // $11
      var $12=$token;
      var $13=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token4nextEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; };
    case 4: // $14
      $next=$13;
      var $15=$token;
      var $16=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token9is_numberEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; };
    case 5: // $17
      if ($16) { __label__ = 10; break; } else { __label__ = 6; break; }
    case 6: // $18
      var $19=$token;
      var $20=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token9is_symbolEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; };
    case 7: // $21
      if ($20) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $22
      var $23=$token;
      var $24=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token9is_stringEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; };
    case 9: // $25
      if ($24) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $26
      var $27=(($4+68)|0);
      var $28=$token;
      var $29=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; };
    case 11: // $30
      __label__ = 59; break;
    case 12: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $2=$33;
      var $34=$32.f1;
      $3=$34;
      __label__ = 73; break;
    case 13: // $35
      var $36=$token;
      var $37=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token11is_operatorEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; };
    case 14: // $38
      if ($37) { __label__ = 15; break; } else { __label__ = 58; break; }
    case 15: // $39
      var $40=$prev;
      var $41=$token;
      (function() { try { __THREW__ = false; return __ZN17parsed_expression18normalize_operatorEPNS_11parse_tokenERS0_($4, $40, $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 16: // $42
      var $43=$token;
      var $44=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token11is_operatorEh($43, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 12; break; };
    case 17: // $45
      if ($44) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $46
      var $47=$token;
      var $48=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE7prependERS1_($stack, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 12; break; };
    case 19: // $49
      __label__ = 57; break;
    case 20: // $50
      var $51=$token;
      var $52=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token11is_operatorEh($51, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 12; break; };
    case 21: // $53
      if ($52) { __label__ = 22; break; } else { __label__ = 38; break; }
    case 22: // $54
      __label__ = 23; break;
    case 23: // $55
      var $56=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE11detach_headEv($stack) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 12; break; };
    case 24: // $57
      $popped=$56;
      var $58=(($56)|0)!=0;
      if ($58) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $59
      var $60=$popped;
      var $61=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token11is_operatorEh($60, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 12; break; };
    case 26: // $62
      if ($61) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $63
      __label__ = 30; break;
    case 28: // $64
      var $65=(($4+68)|0);
      var $66=$popped;
      var $67=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($65, $66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 12; break; };
    case 29: // $68
      __label__ = 23; break;
    case 30: // $69
      var $70=$popped;
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 31: // $72
      var $73=___cxa_allocate_exception(8);
      var $74=$73;
      var $75=$token;
      var $76=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 34; break; };
    case 32: // $77
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($74, 9, $76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $78
      (function() { try { __THREW__ = false; return ___cxa_throw($73, __ZTI16expression_error, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 12; break; }
    case 34: // $79
      var $80=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $81=$80.f0;
      $2=$81;
      var $82=$80.f1;
      $3=$82;
      ___cxa_free_exception($73);
      __label__ = 73; break;
    case 35: // $83
      var $84=$token;
      var $85=$84;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 12; break; }
    case 36: // $86
      var $87=$popped;
      var $88=$87;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 12; break; }
    case 37: // $89
      __label__ = 56; break;
    case 38: // $90
      var $91=$token;
      var $92=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token10precedenceEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 12; break; };
    case 39: // $93
      var $94=(($92)&255);
      $our_precedence=$94;
      __label__ = 40; break;
    case 40: // $95
      var $96=(function() { try { __THREW__ = false; return __ZNK11simple_listIN17parsed_expression11parse_tokenEE5firstEv($stack) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 12; break; };
    case 41: // $97
      $peek=$96;
      var $98=(($96)|0)!=0;
      if ($98) { __label__ = 42; break; } else { __label__ = 54; break; }
    case 42: // $99
      var $100=$peek;
      var $101=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token11is_operatorEh($100, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 12; break; };
    case 43: // $102
      if ($101) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $103
      __label__ = 54; break;
    case 45: // $104
      var $105=$peek;
      var $106=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token10precedenceEv($105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 12; break; };
    case 46: // $107
      var $108=(($106)&255);
      $stack_precedence=$108;
      var $109=$stack_precedence;
      var $110=$our_precedence;
      var $111=(($109)|0) > (($110)|0);
      if ($111) { __label__ = 50; break; } else { __label__ = 47; break; }
    case 47: // $112
      var $113=$stack_precedence;
      var $114=$our_precedence;
      var $115=(($113)|0)==(($114)|0);
      if ($115) { __label__ = 48; break; } else { __label__ = 51; break; }
    case 48: // $116
      var $117=$peek;
      var $118=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token13right_to_leftEv($117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 12; break; };
    case 49: // $119
      if ($118) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $120
      __label__ = 54; break;
    case 51: // $121
      var $122=(($4+68)|0);
      var $123=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE11detach_headEv($stack) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 12; break; };
    case 52: // $124
      var $125=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($122, $123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 12; break; };
    case 53: // $126
      __label__ = 40; break;
    case 54: // $127
      var $128=$token;
      var $129=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE7prependERS1_($stack, $128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 12; break; };
    case 55: // $130
      __label__ = 56; break;
    case 56: // $131
      __label__ = 57; break;
    case 57: // $132
      __label__ = 58; break;
    case 58: // $133
      __label__ = 59; break;
    case 59: // $134
      __label__ = 60; break;
    case 60: // $135
      var $136=$token;
      $prev=$136;
      var $137=$next;
      $token=$137;
      __label__ = 2; break;
    case 61: // $138
      __label__ = 62; break;
    case 62: // $139
      var $140=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE11detach_headEv($stack) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 12; break; };
    case 63: // $141
      $popped1=$140;
      var $142=(($140)|0)!=0;
      if ($142) { __label__ = 64; break; } else { __label__ = 72; break; }
    case 64: // $143
      var $144=$popped1;
      var $145=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token11is_operatorEh($144, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 12; break; };
    case 65: // $146
      if ($145) { __label__ = 66; break; } else { __label__ = 70; break; }
    case 66: // $147
      var $148=___cxa_allocate_exception(8);
      var $149=$148;
      var $150=$popped1;
      var $151=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 69; break; };
    case 67: // $152
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($149, 9, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $153
      (function() { try { __THREW__ = false; return ___cxa_throw($148, __ZTI16expression_error, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 12; break; }
    case 69: // $154
      var $155=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $156=$155.f0;
      $2=$156;
      var $157=$155.f1;
      $3=$157;
      ___cxa_free_exception($148);
      __label__ = 73; break;
    case 70: // $158
      var $159=(($4+68)|0);
      var $160=$popped1;
      var $161=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($159, $160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 12; break; };
    case 71: // $162
      __label__ = 62; break;
    case 72: // $163
      __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($stack);
      STACKTOP = __stackBase__;
      return;
    case 73: // $164
      (function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev($stack) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 76; break; }
    case 74: // $165
      __label__ = 75; break;
    case 75: // $166
      var $167=$2;
      var $168=$2;
      var $169=$3;
      var $170=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $168, tempValue);
      var $171=($170.f1 = $169, $170);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 76: // $172
      var $173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 77: // $174
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression16infix_to_postfixEv["X"]=1;

function __ZN13resource_pool10add_objectIN17parsed_expression11parse_tokenEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN17parsed_expression11parse_tokenEEEPT_S4_["X"]=1;

function __ZN17parsed_expression19parse_quoted_stringERNS_11parse_tokenERPKc($this, $token, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $buffer=__stackBase__+36;
      var $12;
      var $13;
      $9=$this;
      $10=$token;
      $11=$string;
      var $14=$9;
      var $15=$11;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+1)|0);
      HEAP32[(($15)>>2)]=$17;
      __ZN7astringC1Ev($buffer);
      __label__ = 1; break;
    case 1: // $18
      var $19=$11;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0);
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $25
      var $26=$11;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==34;
      if ($31) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $32
      var $33=$11;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      var $36=HEAP8[($35)];
      var $37=(($36 << 24) >> 24);
      var $38=(($37)|0)!=34;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      __label__ = 10; break;
    case 5: // $40
      var $41=$11;
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+1)|0);
      HEAP32[(($41)>>2)]=$43;
      __label__ = 6; break;
    case 6: // $44
      var $45=$11;
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+1)|0);
      HEAP32[(($45)>>2)]=$47;
      var $48=(function() { try { __THREW__ = false; return __ZN7astring3catEPKci($buffer, $46, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $49
      __label__ = 1; break;
    case 8: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $51;__label__ = 9; break;
    case 9: // $_body
      var $eh_lpad_body;
      var $52=$eh_lpad_body.f0;
      $12=$52;
      var $53=$eh_lpad_body.f1;
      $13=$53;
      __label__ = 36; break;
    case 10: // $54
      var $55=$11;
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0);
      var $58=HEAP8[($57)];
      var $59=(($58 << 24) >> 24);
      var $60=(($59)|0)!=34;
      if ($60) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $61
      var $62=___cxa_allocate_exception(8);
      var $63=$62;
      var $64=$10;
      var $65=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $66
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($63, 13, $65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $67
      (function() { try { __THREW__ = false; return ___cxa_throw($62, __ZTI16expression_error, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 8; break; }
    case 14: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $12=$70;
      var $71=$69.f1;
      $13=$71;
      ___cxa_free_exception($62);
      __label__ = 36; break;
    case 15: // $72
      var $73=$11;
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+1)|0);
      HEAP32[(($73)>>2)]=$75;
      var $76=$10;
      var $77=(($14+88)|0);
      var $78=$4;
      var $79=$5;
      var $80=$6;
      var $81=$result_i;
      var $82=$7;
      var $83=$8;
      HEAP32[(($4)>>2)]=68;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=1084;
      var $84=HEAP32[(($4)>>2)];
      var $85=HEAP32[(($5)>>2)];
      var $86=HEAP32[(($6)>>2)];
      var $87=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; };
    case 16: // $88
      HEAP32[(($result_i)>>2)]=$87;
      var $89=HEAP32[(($result_i)>>2)];
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $91
      var $92=___cxa_allocate_exception(4);
      var $93=$92;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($93);
      (function() { try { __THREW__ = false; return ___cxa_throw($92, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 18; break; }
    case 18: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      HEAP32[(($7)>>2)]=$96;
      var $97=$95.f1;
      HEAP32[(($8)>>2)]=$97;
      var $98=HEAP32[(($8)>>2)];
      var $99=(($98)|0) < 0;
      if ($99) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $100
      var $101=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 8; break; }
    case 20: // $_noexc
      throw "Reached an unreachable!"
    case 21: // $102
      var $103=HEAP32[(($7)>>2)];
      var $104=HEAP32[(($7)>>2)];
      var $105=HEAP32[(($8)>>2)];
      var $106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $104, tempValue);
      var $107=($106.f1 = $105, $106);
      var $eh_lpad_body = $107;__label__ = 9; break;
    case 22: // $108
      throw "Reached an unreachable!"
    case 23: // $_ZnwjPKci_exit
      var $109=HEAP32[(($result_i)>>2)];
      var $110=$4;
      var $111=$5;
      var $112=$6;
      var $113=$result_i;
      var $114=$7;
      var $115=$8;
      __label__ = 24; break;
    case 24: // $116
      var $117=$109;
      var $118=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 31; break; };
    case 25: // $119
      (function() { try { __THREW__ = false; return __ZN17parsed_expression17expression_stringC1EPKci($117, $118, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $120
      var $121=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN17parsed_expression17expression_stringEEEPT_S4_(_global_resource_pool, $117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 8; break; };
    case 27: // $122
      var $123=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression17expression_stringEE6appendERS1_($77, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 8; break; };
    case 28: // $124
      var $125=(function() { try { __THREW__ = false; return __ZN17parsed_expression17expression_stringcvPKcEv($123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 8; break; };
    case 29: // $126
      var $127=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token16configure_stringEPKc($76, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 8; break; };
    case 30: // $128
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 31: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      $12=$131;
      var $132=$130.f1;
      $13=$132;
      var $133=$1;
      var $134=$2;
      var $135=$3;
      HEAP32[(($1)>>2)]=$109;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=1084;
      var $136=HEAP32[(($1)>>2)];
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $138
      var $139=HEAP32[(($1)>>2)];
      var $140=HEAP32[(($2)>>2)];
      var $141=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($139, $140, $141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $_noexc1
      __label__ = 34; break;
    case 34: // $_ZdlPvPKci_exit
      var $142=$1;
      var $143=$2;
      var $144=$3;
      __label__ = 35; break;
    case 35: // $145
      __label__ = 36; break;
    case 36: // $146
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $147
      __label__ = 38; break;
    case 38: // $148
      var $149=$12;
      var $150=$12;
      var $151=$13;
      var $152=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $150, tempValue);
      var $153=($152.f1 = $151, $152);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 39: // $154
      var $155=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 40: // $156
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression19parse_quoted_stringERNS_11parse_tokenERPKc["X"]=1;

function __ZN17parsed_expression17parse_quoted_charERNS_11parse_tokenERPKc($this, $token, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $value=__stackBase__;
      var $4;
      var $5;
      $1=$this;
      $2=$token;
      $3=$string;
      var $6=$1;
      var $7=$3;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+1)|0);
      HEAP32[(($7)>>2)]=$9;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$16$0=(($value)|0);
      HEAP32[(($st$16$0)>>2)]=$$emscripten$temp$0$0;
      var $st$16$1=(($value+4)|0);
      HEAP32[(($st$16$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 1; break;
    case 1: // $10
      var $11=$3;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $17
      var $18=$3;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0)==39;
      if ($23) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $24
      var $25=$3;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+1)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)!=39;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      __label__ = 7; break;
    case 5: // $32
      var $33=$3;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      HEAP32[(($33)>>2)]=$35;
      __label__ = 6; break;
    case 6: // $36
      var $st$0$0=(($value)|0);
      var $37$0=HEAPU32[(($st$0$0)>>2)];
      var $st$0$1=(($value+4)|0);
      var $37$1=HEAPU32[(($st$0$1)>>2)];
      var $38$0=($37$0 << 8) | (0 >>> 24);
      var $38$1=($37$1 << 8) | ($37$0 >>> 24);
      var $39=$3;
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($40+1)|0);
      HEAP32[(($39)>>2)]=$41;
      var $42=HEAP8[($40)];
      var $43$0=$42;
      var $43$1=0;
      var $44$0=$38$0 | $43$0;
      var $44$1=$38$1 | $43$1;
      var $st$15$0=(($value)|0);
      HEAP32[(($st$15$0)>>2)]=$44$0;
      var $st$15$1=(($value+4)|0);
      HEAP32[(($st$15$1)>>2)]=$44$1;
      __label__ = 1; break;
    case 7: // $45
      var $46=$3;
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0);
      var $49=HEAP8[($48)];
      var $50=(($49 << 24) >> 24);
      var $51=(($50)|0)!=39;
      if ($51) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $52
      var $53=___cxa_allocate_exception(8);
      var $54=$53;
      var $55=$2;
      var $56=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $57
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($54, 13, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $58
      ___cxa_throw($53, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 11: // $59
      var $60=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $61=$60.f0;
      $4=$61;
      var $62=$60.f1;
      $5=$62;
      ___cxa_free_exception($53);
      __label__ = 13; break;
    case 12: // $63
      var $64=$3;
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+1)|0);
      HEAP32[(($64)>>2)]=$66;
      var $67=$2;
      var $st$5$0=(($value)|0);
      var $68$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($value+4)|0);
      var $68$1=HEAP32[(($st$5$1)>>2)];
      var $69=__ZN17parsed_expression11parse_token16configure_numberEy($67, $68$0, $68$1);
      STACKTOP = __stackBase__;
      return;
    case 13: // $70
      var $71=$4;
      var $72=$4;
      var $73=$5;
      var $74=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $72, tempValue);
      var $75=($74.f1 = $73, $74);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression17parse_quoted_charERNS_11parse_tokenERPKc["X"]=1;

function __ZN17parsed_expression22parse_symbol_or_numberERNS_11parse_tokenERPKc($this, $token, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $stringstart;
      var $buffer=__stackBase__+36;
      var $val=__stackBase__+100;
      var $12;
      var $13;
      var $14;
      var $symbol;
      $9=$this;
      $10=$token;
      $11=$string;
      var $15=$9;
      var $16=$11;
      var $17=HEAP32[(($16)>>2)];
      $stringstart=$17;
      __ZN7astringC1Ev($buffer);
      __label__ = 1; break;
    case 1: // $18
      __label__ = 2; break;
    case 2: // $19
      var $20=$11;
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(function() { try { __THREW__ = false; return _tolower($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $26
      var $27=(($25) & 255);
      HEAP8[($val)]=$27;
      var $28=HEAP8[($val)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 6; break; } else { __label__ = 4; break; }
    case 4: // $31
      var $32=HEAP8[($val)];
      var $33=(($32 << 24) >> 24);
      var $34=(function() { try { __THREW__ = false; return _strchr(((STRING_TABLE.__ZZN17parsed_expression22parse_symbol_or_numberERNS_11parse_tokenERPKcE5valid)|0), $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $35
      var $36=(($34)|0)==0;
      if ($36) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $37
      __label__ = 11; break;
    case 7: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $39;__label__ = 8; break;
    case 8: // $_body
      var $eh_lpad_body;
      var $40=$eh_lpad_body.f0;
      $12=$40;
      var $41=$eh_lpad_body.f1;
      $13=$41;
      __label__ = 151; break;
    case 9: // $42
      var $43=(function() { try { __THREW__ = false; return __ZN7astring3catEPKci($buffer, $val, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; };
    case 10: // $44
      var $45=$11;
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+1)|0);
      HEAP32[(($45)>>2)]=$47;
      __label__ = 1; break;
    case 11: // $48
      var $49=$11;
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0);
      var $52=HEAP8[($51)];
      var $53=(($52 << 24) >> 24);
      var $54=(($53)|0)==64;
      if ($54) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $55
      var $56=$11;
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+1)|0);
      HEAP32[(($56)>>2)]=$58;
      var $59=$10;
      var $60=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 7; break; };
    case 13: // $61
      (function() { try { __THREW__ = false; return __ZN17parsed_expression21parse_memory_operatorERNS_11parse_tokenEPKc($15, $59, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 7; break; }
    case 14: // $62
      $14=1;
      __label__ = 149; break;
    case 15: // $63
      var $64=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 7; break; };
    case 16: // $65
      if ($64) { __label__ = 21; break; } else { __label__ = 17; break; }
    case 17: // $66
      var $67=___cxa_allocate_exception(8);
      var $68=$67;
      var $69=$10;
      var $70=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $71
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($68, 6, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $72
      (function() { try { __THREW__ = false; return ___cxa_throw($67, __ZTI16expression_error, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 155; break; } else { __label__ = 7; break; }
    case 20: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $75=$74.f0;
      $12=$75;
      var $76=$74.f1;
      $13=$76;
      ___cxa_free_exception($67);
      __label__ = 151; break;
    case 21: // $77
      var $78=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str264762)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 7; break; };
    case 22: // $79
      if ($78) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $80
      var $81=$10;
      var $82=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($81, 9, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 7; break; };
    case 24: // $83
      $14=1;
      __label__ = 149; break;
    case 25: // $84
      var $85=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str274763)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 7; break; };
    case 26: // $86
      if ($85) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $87
      var $88=$10;
      var $89=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($88, 15, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 7; break; };
    case 28: // $90
      $14=1;
      __label__ = 149; break;
    case 29: // $91
      var $92=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str284764)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 7; break; };
    case 30: // $93
      if ($92) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $94
      var $95=$10;
      var $96=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($95, 16, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 7; break; };
    case 32: // $97
      $14=1;
      __label__ = 149; break;
    case 33: // $98
      var $99=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str294765)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 7; break; };
    case 34: // $100
      if ($99) { __label__ = 37; break; } else { __label__ = 35; break; }
    case 35: // $101
      var $102=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str304766)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 7; break; };
    case 36: // $103
      if ($102) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $104
      var $105=$10;
      var $106=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($105, 12, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 7; break; };
    case 38: // $107
      $14=1;
      __label__ = 149; break;
    case 39: // $108
      var $109=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str314767)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 7; break; };
    case 40: // $110
      if ($109) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $111
      var $112=$10;
      var $113=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($112, 13, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 7; break; };
    case 42: // $114
      $14=1;
      __label__ = 149; break;
    case 43: // $115
      var $116=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str324768)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 7; break; };
    case 44: // $117
      if ($116) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $118
      var $119=$10;
      var $120=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($119, 14, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 7; break; };
    case 46: // $121
      $14=1;
      __label__ = 149; break;
    case 47: // $122
      var $123=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str334769)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 7; break; };
    case 48: // $124
      if ($123) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $125
      var $126=$10;
      var $127=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($126, 19, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 7; break; };
    case 50: // $128
      $14=1;
      __label__ = 149; break;
    case 51: // $129
      var $130=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str344770)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 7; break; };
    case 52: // $131
      if ($130) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $132
      var $133=$10;
      var $134=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($133, 20, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 7; break; };
    case 54: // $135
      $14=1;
      __label__ = 149; break;
    case 55: // $136
      var $137=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str354771)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 7; break; };
    case 56: // $138
      if ($137) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $139
      var $140=$10;
      var $141=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($140, 21, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 7; break; };
    case 58: // $142
      $14=1;
      __label__ = 149; break;
    case 59: // $143
      var $144=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str364772)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 7; break; };
    case 60: // $145
      if ($144) { __label__ = 61; break; } else { __label__ = 63; break; }
    case 61: // $146
      var $147=$10;
      var $148=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($147, 22, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 7; break; };
    case 62: // $149
      $14=1;
      __label__ = 149; break;
    case 63: // $150
      var $151=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str374773)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 7; break; };
    case 64: // $152
      if ($151) { __label__ = 65; break; } else { __label__ = 67; break; }
    case 65: // $153
      var $154=$10;
      var $155=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($154, 23, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 7; break; };
    case 66: // $156
      $14=1;
      __label__ = 149; break;
    case 67: // $157
      var $158=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str384774)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 7; break; };
    case 68: // $159
      if ($158) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $160
      var $161=$10;
      var $162=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($161, 24, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 7; break; };
    case 70: // $163
      $14=1;
      __label__ = 149; break;
    case 71: // $164
      var $165=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str394775)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 7; break; };
    case 72: // $166
      if ($165) { __label__ = 73; break; } else { __label__ = 75; break; }
    case 73: // $167
      var $168=$10;
      var $169=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($168, 8, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 7; break; };
    case 74: // $170
      $14=1;
      __label__ = 149; break;
    case 75: // $171
      var $172=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str404776)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 7; break; };
    case 76: // $173
      if ($172) { __label__ = 77; break; } else { __label__ = 79; break; }
    case 77: // $174
      var $175=$10;
      var $176=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($175, 28, 8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 7; break; };
    case 78: // $177
      $14=1;
      __label__ = 149; break;
    case 79: // $178
      var $179=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str414777)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 7; break; };
    case 80: // $180
      if ($179) { __label__ = 81; break; } else { __label__ = 83; break; }
    case 81: // $181
      var $182=$10;
      var $183=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($182, 25, 8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 7; break; };
    case 82: // $184
      $14=1;
      __label__ = 149; break;
    case 83: // $185
      var $186=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str424778)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 7; break; };
    case 84: // $187
      if ($186) { __label__ = 85; break; } else { __label__ = 87; break; }
    case 85: // $188
      var $189=$10;
      var $190=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($189, 29, 12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 7; break; };
    case 86: // $191
      $14=1;
      __label__ = 149; break;
    case 87: // $192
      var $193=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str434779)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 7; break; };
    case 88: // $194
      if ($193) { __label__ = 89; break; } else { __label__ = 91; break; }
    case 89: // $195
      var $196=$10;
      var $197=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($196, 27, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 7; break; };
    case 90: // $198
      $14=1;
      __label__ = 149; break;
    case 91: // $199
      var $200=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str444780)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 7; break; };
    case 92: // $201
      if ($200) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 93: // $202
      var $203=$10;
      var $204=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($203, 26, 9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 7; break; };
    case 94: // $205
      $14=1;
      __label__ = 149; break;
    case 95: // $206
      var $207=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str454781)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 7; break; };
    case 96: // $208
      if ($207) { __label__ = 97; break; } else { __label__ = 99; break; }
    case 97: // $209
      var $210=$10;
      var $211=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($210, 17, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 7; break; };
    case 98: // $212
      $14=1;
      __label__ = 149; break;
    case 99: // $213
      var $214=(function() { try { __THREW__ = false; return __ZNK7astringeqEPKc($buffer, ((STRING_TABLE.__str464782)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 7; break; };
    case 100: // $215
      if ($214) { __label__ = 101; break; } else { __label__ = 103; break; }
    case 101: // $216
      var $217=$10;
      var $218=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($217, 18, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 7; break; };
    case 102: // $219
      $14=1;
      __label__ = 149; break;
    case 103: // $220
      var $221=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 7; break; };
    case 104: // $222
      var $223=(($221)|0);
      var $224=HEAP8[($223)];
      var $225=(($224 << 24) >> 24);
      var $226=(($225)|0)==48;
      if ($226) { __label__ = 105; break; } else { __label__ = 110; break; }
    case 105: // $227
      var $228=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 7; break; };
    case 106: // $229
      var $230=(($228+1)|0);
      var $231=HEAP8[($230)];
      var $232=(($231 << 24) >> 24);
      var $233=(($232)|0)==120;
      if ($233) { __label__ = 107; break; } else { __label__ = 110; break; }
    case 107: // $234
      var $235=$10;
      var $236=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 7; break; };
    case 108: // $237
      var $238=(($236+2)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE($15, $235, $238, 16, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 109; break; } else { __label__ = 7; break; }
    case 109: // $239
      $14=1;
      __label__ = 149; break;
    case 110: // $240
      var $241=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 7; break; };
    case 111: // $242
      var $243=(($241)|0);
      var $244=HEAP8[($243)];
      var $245=(($244 << 24) >> 24);
      var $246=(($245)|0)==35;
      if ($246) { __label__ = 112; break; } else { __label__ = 115; break; }
    case 112: // $247
      var $248=$10;
      var $249=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 113; break; } else { __label__ = 7; break; };
    case 113: // $250
      var $251=(($249+1)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE($15, $248, $251, 10, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 7; break; }
    case 114: // $252
      $14=1;
      __label__ = 149; break;
    case 115: // $253
      var $254=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 7; break; };
    case 116: // $255
      var $256=(($254)|0);
      var $257=HEAP8[($256)];
      var $258=(($257 << 24) >> 24);
      var $259=(($258)|0)==36;
      if ($259) { __label__ = 117; break; } else { __label__ = 120; break; }
    case 117: // $260
      var $261=$10;
      var $262=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 118; break; } else { __label__ = 7; break; };
    case 118: // $263
      var $264=(($262+1)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE($15, $261, $264, 16, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 119; break; } else { __label__ = 7; break; }
    case 119: // $265
      $14=1;
      __label__ = 149; break;
    case 120: // $266
      var $267=(($15)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 121; break; } else { __label__ = 7; break; };
    case 121: // $270
      var $271=(function() { try { __THREW__ = false; return __ZN12symbol_table9find_deepEPKc($268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 7; break; };
    case 122: // $272
      $symbol=$271;
      var $273=$symbol;
      var $274=(($273)|0)!=0;
      if ($274) { __label__ = 123; break; } else { __label__ = 146; break; }
    case 123: // $275
      var $276=$10;
      var $277=$symbol;
      var $278=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token16configure_symbolER12symbol_entry($276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 124; break; } else { __label__ = 7; break; };
    case 124: // $279
      var $280=$symbol;
      var $281=(function() { try { __THREW__ = false; return __ZNK12symbol_entry11is_functionEv($280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 125; break; } else { __label__ = 7; break; };
    case 125: // $282
      if ($281) { __label__ = 126; break; } else { __label__ = 145; break; }
    case 126: // $283
      var $284=$10;
      var $285=(($15+68)|0);
      var $286=$4;
      var $287=$5;
      var $288=$6;
      var $289=$result_i;
      var $290=$7;
      var $291=$8;
      HEAP32[(($4)>>2)]=32;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=978;
      var $292=HEAP32[(($4)>>2)];
      var $293=HEAP32[(($5)>>2)];
      var $294=HEAP32[(($6)>>2)];
      var $295=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($292, $293, $294) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 127; break; } else { __label__ = 129; break; };
    case 127: // $296
      HEAP32[(($result_i)>>2)]=$295;
      var $297=HEAP32[(($result_i)>>2)];
      var $298=(($297)|0)==0;
      if ($298) { __label__ = 128; break; } else { __label__ = 134; break; }
    case 128: // $299
      var $300=___cxa_allocate_exception(4);
      var $301=$300;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($301);
      (function() { try { __THREW__ = false; return ___cxa_throw($300, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 133; break; } else { __label__ = 129; break; }
    case 129: // $302
      var $303=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $304=$303.f0;
      HEAP32[(($7)>>2)]=$304;
      var $305=$303.f1;
      HEAP32[(($8)>>2)]=$305;
      var $306=HEAP32[(($8)>>2)];
      var $307=(($306)|0) < 0;
      if ($307) { __label__ = 130; break; } else { __label__ = 132; break; }
    case 130: // $308
      var $309=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($309) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 131; break; } else { __label__ = 7; break; }
    case 131: // $_noexc
      throw "Reached an unreachable!"
    case 132: // $310
      var $311=HEAP32[(($7)>>2)];
      var $312=HEAP32[(($7)>>2)];
      var $313=HEAP32[(($8)>>2)];
      var $314=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $312, tempValue);
      var $315=($314.f1 = $313, $314);
      var $eh_lpad_body = $315;__label__ = 8; break;
    case 133: // $316
      throw "Reached an unreachable!"
    case 134: // $_ZnwjPKci_exit
      var $317=HEAP32[(($result_i)>>2)];
      var $318=$4;
      var $319=$5;
      var $320=$6;
      var $321=$result_i;
      var $322=$7;
      var $323=$8;
      __label__ = 135; break;
    case 135: // $324
      var $325=$317;
      var $326=$11;
      var $327=HEAP32[(($326)>>2)];
      var $328=$stringstart;
      var $329=$327;
      var $330=$328;
      var $331=(($329-$330)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($325, $331) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 136; break; } else { __label__ = 140; break; }
    case 136: // $332
      var $333=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectIN17parsed_expression11parse_tokenEEEPT_S4_(_global_resource_pool, $325) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 137; break; } else { __label__ = 7; break; };
    case 137: // $334
      var $335=(function() { try { __THREW__ = false; return __ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_($285, $333) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 138; break; } else { __label__ = 7; break; };
    case 138: // $336
      var $337=$284;
      var $338=$335;
      assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($337)>>2)]=HEAP32[(($338)>>2)];HEAP32[(($337+4)>>2)]=HEAP32[(($338+4)>>2)];HEAP32[(($337+8)>>2)]=HEAP32[(($338+8)>>2)];HEAP32[(($337+12)>>2)]=HEAP32[(($338+12)>>2)];HEAP32[(($337+16)>>2)]=HEAP32[(($338+16)>>2)];HEAP32[(($337+20)>>2)]=HEAP32[(($338+20)>>2)];HEAP32[(($337+24)>>2)]=HEAP32[(($338+24)>>2)];HEAP32[(($337+28)>>2)]=HEAP32[(($338+28)>>2)];
      var $339=$10;
      var $340=(function() { try { __THREW__ = false; return __ZN17parsed_expression11parse_token18configure_operatorEhh($339, 43, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 139; break; } else { __label__ = 7; break; };
    case 139: // $341
      __label__ = 145; break;
    case 140: // $342
      var $343=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $344=$343.f0;
      $12=$344;
      var $345=$343.f1;
      $13=$345;
      var $346=$1;
      var $347=$2;
      var $348=$3;
      HEAP32[(($1)>>2)]=$317;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=978;
      var $349=HEAP32[(($1)>>2)];
      var $350=(($349)|0)!=0;
      if ($350) { __label__ = 141; break; } else { __label__ = 143; break; }
    case 141: // $351
      var $352=HEAP32[(($1)>>2)];
      var $353=HEAP32[(($2)>>2)];
      var $354=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($352, $353, $354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 154; break; }
    case 142: // $_noexc1
      __label__ = 143; break;
    case 143: // $_ZdlPvPKci_exit
      var $355=$1;
      var $356=$2;
      var $357=$3;
      __label__ = 144; break;
    case 144: // $358
      __label__ = 151; break;
    case 145: // $359
      $14=1;
      __label__ = 149; break;
    case 146: // $360
      var $361=$10;
      var $362=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 147; break; } else { __label__ = 7; break; };
    case 147: // $363
      (function() { try { __THREW__ = false; return __ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE($15, $361, $362, 16, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 148; break; } else { __label__ = 7; break; }
    case 148: // $364
      $14=0;
      __label__ = 149; break;
    case 149: // $365
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      var $cleanup_dest=$14;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 150; break;
      }
      else {
      __label__ = 155; break;
      }
      
    case 150: // $366
      STACKTOP = __stackBase__;
      return;
    case 151: // $367
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 154; break; }
    case 152: // $368
      __label__ = 153; break;
    case 153: // $369
      var $370=$12;
      var $371=$12;
      var $372=$13;
      var $373=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $371, tempValue);
      var $374=($373.f1 = $372, $373);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 154: // $375
      var $376=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 155: // $377
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression22parse_symbol_or_numberERNS_11parse_tokenERPKc["X"]=1;

function __ZNK17parsed_expression11parse_token6offsetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN17parsed_expression11parse_token16configure_symbolER12symbol_entry($this, $symbol) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$symbol;
  var $3=$1;
  var $4=(($3+4)|0);
  HEAP32[(($4)>>2)]=4;
  var $5=$2;
  var $6=(($3+28)|0);
  HEAP32[(($6)>>2)]=$5;
  ;
  return $3;
}


function __ZNK12symbol_entry11is_functionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)==1;
  ;
  return $5;
}


function __ZN17parsed_expression11parse_token16configure_numberEy($this, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$value$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$value$1;
  var $3=$1;
  var $4=(($3+4)|0);
  HEAP32[(($4)>>2)]=1;
  var $st$10$0=(($2)|0);
  var $5$0=HEAP32[(($st$10$0)>>2)];
  var $st$10$1=(($2+4)|0);
  var $5$1=HEAP32[(($st$10$1)>>2)];
  var $6=(($3+12)|0);
  var $st$15$0=(($6)|0);
  HEAP32[(($st$15$0)>>2)]=$5$0;
  var $st$15$1=(($6+4)|0);
  HEAP32[(($st$15$1)>>2)]=$5$1;
  STACKTOP = __stackBase__;
  return $3;
}


function __ZN17parsed_expression11parse_token16configure_stringEPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=(($3+4)|0);
  HEAP32[(($4)>>2)]=2;
  var $5=$2;
  var $6=(($3+24)|0);
  HEAP32[(($6)>>2)]=$5;
  ;
  return $3;
}


function __ZN11simple_listIN17parsed_expression17expression_stringEE6appendERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16expression_errorC1ENS_10error_codeEi($this, $code, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$code;
  $3=$offset;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN16expression_errorC2ENS_10error_codeEi($4, $5, $6);
  ;
  return;
}


function __ZN17parsed_expression17expression_stringC1EPKci($this, $string, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$string;
  $3=$length;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN17parsed_expression17expression_stringC2EPKci($4, $5, $6);
  ;
  return;
}


function __ZN17parsed_expression17expression_stringcvPKcEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN17parsed_expression21parse_memory_operatorERNS_11parse_tokenEPKc($this, $token, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $startstring;
      var $namestring;
      var $dot;
      var $12;
      var $13;
      var $length;
      var $physical;
      var $space;
      var $size;
      var $memspace;
      var $memsize;
      var $err;
      $9=$this;
      $10=$token;
      $11=$string;
      var $14=$9;
      var $15=$11;
      $startstring=$15;
      $namestring=0;
      var $16=$11;
      var $17=_strrchr($16, 46);
      $dot=$17;
      var $18=$dot;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $20
      var $21=(($14+88)|0);
      var $22=$4;
      var $23=$5;
      var $24=$6;
      var $25=$result_i;
      var $26=$7;
      var $27=$8;
      HEAP32[(($4)>>2)]=68;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($6)>>2)]=1101;
      var $28=HEAP32[(($4)>>2)];
      var $29=HEAP32[(($5)>>2)];
      var $30=HEAP32[(($6)>>2)];
      var $31=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($28, $29, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $32
      HEAP32[(($result_i)>>2)]=$31;
      var $33=HEAP32[(($result_i)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $35
      var $36=___cxa_allocate_exception(4);
      var $37=$36;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($37);
      (function() { try { __THREW__ = false; return ___cxa_throw($36, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      HEAP32[(($7)>>2)]=$40;
      var $41=$39.f1;
      HEAP32[(($8)>>2)]=$41;
      var $42=HEAP32[(($8)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $44
      var $45=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($45);
      throw "Reached an unreachable!"
    case 6: // $46
      var $47=HEAP32[(($7)>>2)];
      var $48=HEAP32[(($7)>>2)];
      var $49=HEAP32[(($8)>>2)];
      var $50=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $48, tempValue);
      var $51=($50.f1 = $49, $50);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $52
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $53=HEAP32[(($result_i)>>2)];
      var $54=$4;
      var $55=$5;
      var $56=$6;
      var $57=$result_i;
      var $58=$7;
      var $59=$8;
      var $60=$53;
      var $61=$11;
      var $62=$dot;
      var $63=$11;
      var $64=$62;
      var $65=$63;
      var $66=(($64-$65)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expression17expression_stringC1EPKci($60, $61, $66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $67
      var $68=__ZN13resource_pool10add_objectIN17parsed_expression17expression_stringEEEPT_S4_(_global_resource_pool, $60);
      var $69=__ZN11simple_listIN17parsed_expression17expression_stringEE6appendERS1_($21, $68);
      var $70=__ZN17parsed_expression17expression_stringcvPKcEv($69);
      $namestring=$70;
      var $71=$dot;
      var $72=(($71+1)|0);
      $11=$72;
      __label__ = 15; break;
    case 10: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $75=$74.f0;
      $12=$75;
      var $76=$74.f1;
      $13=$76;
      var $77=$1;
      var $78=$2;
      var $79=$3;
      HEAP32[(($1)>>2)]=$53;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str254761)|0);
      HEAP32[(($3)>>2)]=1101;
      var $80=HEAP32[(($1)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $82
      var $83=HEAP32[(($1)>>2)];
      var $84=HEAP32[(($2)>>2)];
      var $85=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($83, $84, $85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 71; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $86=$1;
      var $87=$2;
      var $88=$3;
      __label__ = 14; break;
    case 14: // $89
      __label__ = 70; break;
    case 15: // $90
      var $91=$11;
      var $92=_strlen($91);
      $length=$92;
      $physical=0;
      $space=112;
      var $93=$length;
      var $94=(($93)|0)==3;
      if ($94) { __label__ = 16; break; } else { __label__ = 31; break; }
    case 16: // $95
      var $96=$11;
      var $97=(($96)|0);
      var $98=HEAP8[($97)];
      var $99=(($98 << 24) >> 24);
      var $100=(($99)|0)!=108;
      if ($100) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $101
      var $102=$11;
      var $103=(($102)|0);
      var $104=HEAP8[($103)];
      var $105=(($104 << 24) >> 24);
      var $106=(($105)|0)!=112;
      if ($106) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $107
      var $108=___cxa_allocate_exception(8);
      var $109=$108;
      var $110=$10;
      var $111=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 21; break; };
    case 19: // $112
      var $113=$11;
      var $114=$startstring;
      var $115=$113;
      var $116=$114;
      var $117=(($115-$116)|0);
      var $118=(($111+$117)|0);
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($109, 16, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $119
      ___cxa_throw($108, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 21: // $120
      var $121=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $122=$121.f0;
      $12=$122;
      var $123=$121.f1;
      $13=$123;
      ___cxa_free_exception($108);
      __label__ = 70; break;
    case 22: // $124
      var $125=$11;
      var $126=(($125+1)|0);
      var $127=HEAP8[($126)];
      var $128=(($127 << 24) >> 24);
      var $129=(($128)|0)!=112;
      if ($129) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $130
      var $131=$11;
      var $132=(($131+1)|0);
      var $133=HEAP8[($132)];
      var $134=(($133 << 24) >> 24);
      var $135=(($134)|0)!=100;
      if ($135) { __label__ = 24; break; } else { __label__ = 30; break; }
    case 24: // $136
      var $137=$11;
      var $138=(($137+1)|0);
      var $139=HEAP8[($138)];
      var $140=(($139 << 24) >> 24);
      var $141=(($140)|0)!=105;
      if ($141) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $142
      var $143=$11;
      var $144=(($143+1)|0);
      var $145=HEAP8[($144)];
      var $146=(($145 << 24) >> 24);
      var $147=(($146)|0)!=51;
      if ($147) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $148
      var $149=___cxa_allocate_exception(8);
      var $150=$149;
      var $151=$10;
      var $152=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $153
      var $154=$11;
      var $155=$startstring;
      var $156=$154;
      var $157=$155;
      var $158=(($156-$157)|0);
      var $159=(($152+$158)|0);
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($150, 16, $159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $160
      ___cxa_throw($149, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 29: // $161
      var $162=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $163=$162.f0;
      $12=$163;
      var $164=$162.f1;
      $13=$164;
      ___cxa_free_exception($149);
      __label__ = 70; break;
    case 30: // $165
      var $166=$11;
      var $167=(($166)|0);
      var $168=HEAP8[($167)];
      var $169=(($168 << 24) >> 24);
      var $170=(($169)|0)==112;
      var $171=(($170)&1);
      $physical=$171;
      var $172=$11;
      var $173=(($172+1)|0);
      var $174=HEAP8[($173)];
      var $175=(($174 << 24) >> 24);
      $space=$175;
      var $176=$11;
      var $177=(($176+2)|0);
      var $178=HEAP8[($177)];
      var $179=(($178 << 24) >> 24);
      $size=$179;
      __label__ = 41; break;
    case 31: // $180
      var $181=$length;
      var $182=(($181)|0)==2;
      if ($182) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $183
      var $184=$11;
      var $185=(($184)|0);
      var $186=HEAP8[($185)];
      var $187=(($186 << 24) >> 24);
      $space=$187;
      var $188=$11;
      var $189=(($188+1)|0);
      var $190=HEAP8[($189)];
      var $191=(($190 << 24) >> 24);
      $size=$191;
      __label__ = 40; break;
    case 33: // $192
      var $193=$length;
      var $194=(($193)|0)==1;
      if ($194) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $195
      var $196=$11;
      var $197=(($196)|0);
      var $198=HEAP8[($197)];
      var $199=(($198 << 24) >> 24);
      $size=$199;
      __label__ = 39; break;
    case 35: // $200
      var $201=___cxa_allocate_exception(8);
      var $202=$201;
      var $203=$10;
      var $204=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 38; break; };
    case 36: // $205
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($202, 6, $204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $206
      ___cxa_throw($201, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 38: // $207
      var $208=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $209=$208.f0;
      $12=$209;
      var $210=$208.f1;
      $13=$210;
      ___cxa_free_exception($201);
      __label__ = 70; break;
    case 39: // $211
      __label__ = 40; break;
    case 40: // $212
      __label__ = 41; break;
    case 41: // $213
      $memspace=0;
      var $214=$space;
      if ($214 == 112) {
        __label__ = 42; break;
      }
      else if ($214 == 100) {
        __label__ = 43; break;
      }
      else if ($214 == 105) {
        __label__ = 44; break;
      }
      else if ($214 == 51) {
        __label__ = 45; break;
      }
      else if ($214 == 111) {
        __label__ = 46; break;
      }
      else if ($214 == 114) {
        __label__ = 47; break;
      }
      else if ($214 == 109) {
        __label__ = 48; break;
      }
      else {
      __label__ = 49; break;
      }
      
    case 42: // $215
      var $216=$physical;
      var $217=(($216) & 1);
      var $218=$217 ? 5 : 1;
      $memspace=$218;
      __label__ = 53; break;
    case 43: // $219
      var $220=$physical;
      var $221=(($220) & 1);
      var $222=$221 ? 6 : 2;
      $memspace=$222;
      __label__ = 53; break;
    case 44: // $223
      var $224=$physical;
      var $225=(($224) & 1);
      var $226=$225 ? 7 : 3;
      $memspace=$226;
      __label__ = 53; break;
    case 45: // $227
      var $228=$physical;
      var $229=(($228) & 1);
      var $230=$229 ? 8 : 4;
      $memspace=$230;
      __label__ = 53; break;
    case 46: // $231
      $memspace=9;
      __label__ = 53; break;
    case 47: // $232
      $memspace=10;
      __label__ = 53; break;
    case 48: // $233
      $memspace=11;
      __label__ = 53; break;
    case 49: // $234
      var $235=___cxa_allocate_exception(8);
      var $236=$235;
      var $237=$10;
      var $238=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 52; break; };
    case 50: // $239
      var $240=$11;
      var $241=$startstring;
      var $242=$240;
      var $243=$241;
      var $244=(($242-$243)|0);
      var $245=(($238+$244)|0);
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($236, 16, $245) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $246
      ___cxa_throw($235, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 52: // $247
      var $248=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $249=$248.f0;
      $12=$249;
      var $250=$248.f1;
      $13=$250;
      ___cxa_free_exception($235);
      __label__ = 70; break;
    case 53: // $251
      var $252=$size;
      if ($252 == 98) {
        __label__ = 54; break;
      }
      else if ($252 == 119) {
        __label__ = 55; break;
      }
      else if ($252 == 100) {
        __label__ = 56; break;
      }
      else if ($252 == 113) {
        __label__ = 57; break;
      }
      else {
      __label__ = 58; break;
      }
      
    case 54: // $253
      $memsize=0;
      __label__ = 62; break;
    case 55: // $254
      $memsize=1;
      __label__ = 62; break;
    case 56: // $255
      $memsize=2;
      __label__ = 62; break;
    case 57: // $256
      $memsize=3;
      __label__ = 62; break;
    case 58: // $257
      var $258=___cxa_allocate_exception(8);
      var $259=$258;
      var $260=$10;
      var $261=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($260) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 61; break; };
    case 59: // $262
      var $263=$11;
      var $264=$startstring;
      var $265=$263;
      var $266=$264;
      var $267=(($265-$266)|0);
      var $268=(($261+$267)|0);
      var $269=$length;
      var $270=(($268+$269)|0);
      var $271=(($270-1)|0);
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($259, 15, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $272
      ___cxa_throw($258, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 61: // $273
      var $274=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $275=$274.f0;
      $12=$275;
      var $276=$274.f1;
      $13=$276;
      ___cxa_free_exception($258);
      __label__ = 70; break;
    case 62: // $277
      var $278=(($14)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=(($279)|0)!=0;
      if ($280) { __label__ = 63; break; } else { __label__ = 69; break; }
    case 63: // $281
      var $282=(($14)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=$namestring;
      var $285=$memspace;
      var $286=__ZN12symbol_table12memory_validEPKc16expression_space($283, $284, $285);
      $err=$286;
      var $287=$err;
      var $288=(($287)|0)!=0;
      if ($288) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $289
      var $290=___cxa_allocate_exception(8);
      var $291=$290;
      var $292=$err;
      var $293=$10;
      var $294=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($293) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 67; break; };
    case 65: // $295
      var $296=$11;
      var $297=$startstring;
      var $298=$296;
      var $299=$297;
      var $300=(($298-$299)|0);
      var $301=(($294+$300)|0);
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($291, $292, $301) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $302
      ___cxa_throw($290, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 67: // $303
      var $304=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $305=$304.f0;
      $12=$305;
      var $306=$304.f1;
      $13=$306;
      ___cxa_free_exception($290);
      __label__ = 70; break;
    case 68: // $307
      __label__ = 69; break;
    case 69: // $308
      var $309=$10;
      var $310=__ZN17parsed_expression11parse_token18configure_operatorEhh($309, 42, 2);
      var $311=$memsize;
      var $312=__ZN17parsed_expression11parse_token15set_memory_sizeEi($310, $311);
      var $313=$memspace;
      var $314=__ZN17parsed_expression11parse_token16set_memory_spaceE16expression_space($312, $313);
      var $315=$namestring;
      var $316=__ZN17parsed_expression11parse_token17set_memory_sourceEPKc($314, $315);
      STACKTOP = __stackBase__;
      return;
    case 70: // $317
      var $318=$12;
      var $319=$12;
      var $320=$13;
      var $321=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $319, tempValue);
      var $322=($321.f1 = $320, $321);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 71: // $323
      var $324=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression21parse_memory_operatorERNS_11parse_tokenEPKc["X"]=1;

function __ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE($this, $token, $string, $base, $errcode) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $value=__stackBase__;
      var $ptr;
      var $digit;
      var $6;
      var $7;
      $1=$this;
      $2=$token;
      $3=$string;
      $4=$base;
      $5=$errcode;
      var $8=$1;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$18$0=(($value)|0);
      HEAP32[(($st$18$0)>>2)]=$$emscripten$temp$0$0;
      var $st$18$1=(($value+4)|0);
      HEAP32[(($st$18$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 1; break;
    case 1: // $9
      var $10=$3;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $14
      var $15=$3;
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=_tolower($17);
      var $19=_strchr(((STRING_TABLE.__ZZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeEE7numbers)|0), $18);
      $ptr=$19;
      var $20=$ptr;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      __label__ = 7; break;
    case 4: // $23
      var $24=$ptr;
      var $25=$24;
      var $26=(($25-((STRING_TABLE.__ZZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeEE7numbers)))|0);
      $digit=$26;
      var $27=$digit;
      var $28=$4;
      var $29=(($27)|0) >= (($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      __label__ = 7; break;
    case 6: // $31
      var $st$0$0=(($value)|0);
      var $32$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($value+4)|0);
      var $32$1=HEAP32[(($st$0$1)>>2)];
      var $33=$4;
      var $34$0=$33;
      var $34$1=(($33|0) < 0 ? -1 : 0);
      var $35$0 = ((($32$0)>>>0)+((($32$1)|0)*4294967296))*((($34$0)>>>0)+((($34$1)|0)*4294967296))>>>0; var $35$1 = Math.min(Math.floor((((($32$0)>>>0)+((($32$1)|0)*4294967296))*((($34$0)>>>0)+((($34$1)|0)*4294967296)))/4294967296), 4294967295);
      var $36=$digit;
      var $37$0=$36;
      var $37$1=(($36|0) < 0 ? -1 : 0);
      var $38$0 = ((($35$0)>>>0)+((($35$1)|0)*4294967296))+((($37$0)>>>0)+((($37$1)|0)*4294967296))>>>0; var $38$1 = Math.min(Math.floor((((($35$0)>>>0)+((($35$1)|0)*4294967296))+((($37$0)>>>0)+((($37$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($value)|0);
      HEAP32[(($st$12$0)>>2)]=$38$0;
      var $st$12$1=(($value+4)|0);
      HEAP32[(($st$12$1)>>2)]=$38$1;
      var $39=$3;
      var $40=(($39+1)|0);
      $3=$40;
      __label__ = 1; break;
    case 7: // $41
      var $42=$3;
      var $43=HEAP8[($42)];
      var $44=(($43 << 24) >> 24);
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$2;
      var $st$1$0=(($value)|0);
      var $48$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($value+4)|0);
      var $48$1=HEAP32[(($st$1$1)>>2)];
      var $49=__ZN17parsed_expression11parse_token16configure_numberEy($47, $48$0, $48$1);
      __label__ = 13; break;
    case 9: // $50
      var $51=___cxa_allocate_exception(8);
      var $52=$51;
      var $53=$5;
      var $54=$2;
      var $55=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $56
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($52, $53, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $57
      ___cxa_throw($51, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 12: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $60=$59.f0;
      $6=$60;
      var $61=$59.f1;
      $7=$61;
      ___cxa_free_exception($51);
      __label__ = 14; break;
    case 13: // $62
      STACKTOP = __stackBase__;
      return;
    case 14: // $63
      var $64=$6;
      var $65=$6;
      var $66=$7;
      var $67=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $65, tempValue);
      var $68=($67.f1 = $66, $67);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE["X"]=1;

function __ZN13resource_pool10add_objectIN17parsed_expression17expression_stringEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN17parsed_expression17expression_stringEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN17parsed_expression17expression_stringEEEPT_S4_["X"]=1;

function __ZN17parsed_expression11parse_token15set_memory_sizeEi($this, $log2ofbits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$log2ofbits;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=(($3+20)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & -786433;
      var $9=$2;
      var $10=$9 << 18;
      var $11=$10 & 786432;
      var $12=$8 | $11;
      var $13=(($3+20)|0);
      HEAP32[(($13)>>2)]=$12;
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token16set_memory_spaceE16expression_space($this, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$space;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=(($3+20)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & -15728641;
      var $9=$2;
      var $10=$9 << 20;
      var $11=$10 & 15728640;
      var $12=$8 | $11;
      var $13=(($3+20)|0);
      HEAP32[(($13)>>2)]=$12;
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token17set_memory_sourceEPKc($this, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$string;
      var $3=$1;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$2;
      var $7=(($3+24)|0);
      HEAP32[(($7)>>2)]=$6;
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17parsed_expression11parse_token6optypeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 255;
      var $8=$7 >>> 0;
      var $9=(($8) & 255);
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token22set_function_separatorEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 | 131072;
      HEAP32[(($5)>>2)]=$7;
      ;
      return $2;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token9is_symbolEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)==4;
  ;
  return $5;
}


function __ZNK17parsed_expression11parse_token9is_numberEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)==1;
  ;
  return $5;
}


function __ZN17parsed_expression10peek_tokenEi($this, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$count;
      var $4=$2;
      var $5=(($4+108)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$3;
      var $8=(($6)|0) <= (($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=(($4+108)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$3;
      var $14=(($12-$13)|0);
      var $15=(($14-1)|0);
      var $16=(($4+112)|0);
      var $17=(($16+($15<<5))|0);
      $1=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token21is_function_separatorEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 131072;
      var $8=(($7)|0)!=0;
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEE10detach_allEv($this) {
  ;
  var __label__;

  var $1;
  var $result;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  $result=$4;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$result;
  ;
  return $8;
}


function __ZNK17parsed_expression11parse_token9is_stringEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)==2;
  ;
  return $5;
}


function __ZNK17parsed_expression11parse_token11is_operatorEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)==5;
  ;
  return $5;
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEE7prependERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=$5;
      var $8=$2;
      var $9=(($3+4)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($3+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($3+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($3+8)|0);
      HEAP32[(($16)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $17
      var $18=(($3+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEE11detach_headEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$result;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=$result;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($2+4)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($2+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      HEAP32[(($12)>>2)]=$14;
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$result;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token10precedenceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & -16777216;
      var $8=$7 >>> 24;
      var $9=(($8) & 255);
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11simple_listIN17parsed_expression11parse_tokenEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK17parsed_expression11parse_token13right_to_leftEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 65536;
      var $8=(($7)|0)!=0;
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token11is_operatorEh($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$type;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)==5;
      if ($6) { __label__ = 1; break; } else { var $14 = 0;__label__ = 2; break; }
    case 1: // $7
      var $8=__ZNK17parsed_expression11parse_token6optypeEv($3);
      var $9=(($8)&255);
      var $10=$2;
      var $11=(($10)&255);
      var $12=(($9)|0)==(($11)|0);
      var $14 = $12;__label__ = 2; break;
    case 2: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression18normalize_operatorEPNS_11parse_tokenERS0_($this, $prevtoken, $thistoken) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $nexttoken;
      var $4;
      var $5;
      var $lookback;
      var $peek;
      $1=$this;
      $2=$prevtoken;
      $3=$thistoken;
      var $6=$1;
      var $7=$3;
      var $8=__ZNK17parsed_expression11parse_token4nextEv($7);
      $nexttoken=$8;
      var $9=$3;
      var $10=__ZNK17parsed_expression11parse_token6optypeEv($9);
      var $11=(($10)&255);
      if ($11 == 0) {
        __label__ = 1; break;
      }
      else if ($11 == 2) {
        __label__ = 5; break;
      }
      else if ($11 == 3) {
        __label__ = 19; break;
      }
      else if ($11 == 15 || $11 == 16) {
        __label__ = 33; break;
      }
      else if ($11 == 41) {
        __label__ = 39; break;
      }
      else {
      __label__ = 50; break;
      }
      
    case 1: // $12
      var $13=$2;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $15
      var $16=$2;
      var $17=__ZNK17parsed_expression11parse_token11is_operatorEh($16, 43);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$3;
      var $20=__ZN17parsed_expression11parse_token22set_function_separatorEv($19);
      __label__ = 4; break;
    case 4: // $21
      __label__ = 50; break;
    case 5: // $22
      var $23=$nexttoken;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $25
      var $26=$nexttoken;
      var $27=__ZNK17parsed_expression11parse_token9is_symbolEv($26);
      if ($27) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $28
      var $29=$nexttoken;
      var $30=__ZNK17parsed_expression11parse_token11is_operatorEh($29, 42);
      if ($30) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $31
      var $32=$3;
      var $33=__ZN17parsed_expression11parse_token18configure_operatorEhh($32, 4, 2);
      __label__ = 18; break;
    case 9: // $34
      var $35=$2;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $37
      var $38=$2;
      var $39=__ZNK17parsed_expression11parse_token9is_symbolEv($38);
      if ($39) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $40
      var $41=$2;
      var $42=__ZNK17parsed_expression11parse_token11is_operatorEh($41, 42);
      if ($42) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $43
      var $44=$3;
      var $45=__ZN17parsed_expression11parse_token18configure_operatorEhh($44, 6, 1);
      __label__ = 17; break;
    case 13: // $46
      var $47=___cxa_allocate_exception(8);
      var $48=$47;
      var $49=$3;
      var $50=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $51
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($48, 3, $50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $52
      ___cxa_throw($47, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 16: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $4=$55;
      var $56=$54.f1;
      $5=$56;
      ___cxa_free_exception($47);
      __label__ = 51; break;
    case 17: // $57
      __label__ = 18; break;
    case 18: // $58
      __label__ = 50; break;
    case 19: // $59
      var $60=$nexttoken;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $62
      var $63=$nexttoken;
      var $64=__ZNK17parsed_expression11parse_token9is_symbolEv($63);
      if ($64) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $65
      var $66=$nexttoken;
      var $67=__ZNK17parsed_expression11parse_token11is_operatorEh($66, 42);
      if ($67) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $68
      var $69=$3;
      var $70=__ZN17parsed_expression11parse_token18configure_operatorEhh($69, 5, 2);
      __label__ = 32; break;
    case 23: // $71
      var $72=$2;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 24: // $74
      var $75=$2;
      var $76=__ZNK17parsed_expression11parse_token9is_symbolEv($75);
      if ($76) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $77
      var $78=$2;
      var $79=__ZNK17parsed_expression11parse_token11is_operatorEh($78, 42);
      if ($79) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $80
      var $81=$3;
      var $82=__ZN17parsed_expression11parse_token18configure_operatorEhh($81, 7, 1);
      __label__ = 31; break;
    case 27: // $83
      var $84=___cxa_allocate_exception(8);
      var $85=$84;
      var $86=$3;
      var $87=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 30; break; };
    case 28: // $88
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($85, 3, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $89
      ___cxa_throw($84, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 30: // $90
      var $91=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $92=$91.f0;
      $4=$92;
      var $93=$91.f1;
      $5=$93;
      ___cxa_free_exception($84);
      __label__ = 51; break;
    case 31: // $94
      __label__ = 32; break;
    case 32: // $95
      __label__ = 50; break;
    case 33: // $96
      var $97=$2;
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 37; break; } else { __label__ = 34; break; }
    case 34: // $99
      var $100=$2;
      var $101=__ZNK17parsed_expression11parse_token9is_symbolEv($100);
      if ($101) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $102
      var $103=$2;
      var $104=__ZNK17parsed_expression11parse_token9is_numberEv($103);
      if ($104) { __label__ = 38; break; } else { __label__ = 36; break; }
    case 36: // $105
      var $106=$2;
      var $107=__ZNK17parsed_expression11parse_token11is_operatorEh($106, 1);
      if ($107) { __label__ = 38; break; } else { __label__ = 37; break; }
    case 37: // $108
      var $109=$3;
      var $110=$3;
      var $111=__ZNK17parsed_expression11parse_token11is_operatorEh($110, 15);
      var $112=$111 ? 10 : 11;
      var $113=(($112) & 255);
      var $114=__ZN17parsed_expression11parse_token18configure_operatorEhh($109, $113, 2);
      __label__ = 38; break;
    case 38: // $115
      __label__ = 50; break;
    case 39: // $116
      $lookback=0;
      __label__ = 40; break;
    case 40: // $117
      var $118=$lookback;
      var $119=(($118)|0) < 16;
      if ($119) { __label__ = 41; break; } else { __label__ = 49; break; }
    case 41: // $120
      var $121=$lookback;
      var $122=__ZN17parsed_expression10peek_tokenEi($6, $121);
      $peek=$122;
      var $123=$peek;
      var $124=(($123)|0)==0;
      if ($124) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $125
      __label__ = 49; break;
    case 43: // $126
      var $127=$peek;
      var $128=__ZNK17parsed_expression11parse_token11is_operatorEh($127, 43);
      if ($128) { __label__ = 46; break; } else { __label__ = 44; break; }
    case 44: // $129
      var $130=$peek;
      var $131=__ZNK17parsed_expression11parse_token11is_operatorEh($130, 0);
      if ($131) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $132
      var $133=$peek;
      var $134=__ZNK17parsed_expression11parse_token21is_function_separatorEv($133);
      if ($134) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $135
      var $136=$3;
      var $137=__ZN17parsed_expression11parse_token22set_function_separatorEv($136);
      __label__ = 49; break;
    case 47: // $138
      __label__ = 48; break;
    case 48: // $139
      var $140=$lookback;
      var $141=(($140+1)|0);
      $lookback=$141;
      __label__ = 40; break;
    case 49: // $142
      __label__ = 50; break;
    case 50: // $143
      ;
      return;
    case 51: // $144
      var $145=$4;
      var $146=$4;
      var $147=$5;
      var $148=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $146, tempValue);
      var $149=($148.f1 = $147, $148);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression18normalize_operatorEPNS_11parse_tokenERS0_["X"]=1;

function __ZN17parsed_expression11parse_token10set_offsetERKS0_($this, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($3+8)|0);
  HEAP32[(($7)>>2)]=$6;
  ;
  return $3;
}


function __ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($this, $table) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      $2=$this;
      $3=$table;
      var $4=$2;
      var $5=__ZNK17parsed_expression11parse_token9is_symbolEv($4);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=FUNCTION_TABLE[$12]($8);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $st$9$0=(($1)|0);
      HEAP32[(($st$9$0)>>2)]=$13$0;
      var $st$9$1=(($1+4)|0);
      HEAP32[(($st$9$1)>>2)]=$13$1;
      __label__ = 7; break;
    case 2: // $14
      var $15=__ZNK17parsed_expression11parse_token9is_memoryEv($4);
      if ($15) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$3;
      var $21=(($4+24)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK17parsed_expression11parse_token12memory_spaceEv($4);
      var $24=__ZNK17parsed_expression11parse_token7addressEv($4);
      var $25=__ZNK17parsed_expression11parse_token11memory_sizeEv($4);
      var $26=1 << $25;
      var $27=__ZN12symbol_table12memory_valueEPKc16expression_spaceji($20, $22, $23, $24, $26);
      var $27$0=$27[0];
      var $27$1=$27[1];
      var $st$10$0=(($1)|0);
      HEAP32[(($st$10$0)>>2)]=$27$0;
      var $st$10$1=(($1+4)|0);
      HEAP32[(($st$10$1)>>2)]=$27$1;
      __label__ = 7; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 7; break;
    case 7: // $30
      var $st$0$0=(($1)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$31$0,$31$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table["X"]=1;

function __ZN17parsed_expression14execute_tokensEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 96; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $t1=__stackBase__;
      var $t2=__stackBase__+32;
      var $result=__stackBase__+64;
      var $token;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+108)|0);
      HEAP32[(($5)>>2)]=0;
      FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($t1, 0);
      FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($t2, 0);
      FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($result, 0);
      var $6=(($4+68)|0);
      var $7=__ZNK11simple_listIN17parsed_expression11parse_tokenEE5firstEv($6);
      $token=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$token;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 77; break; }
    case 2: // $11
      var $12=$token;
      var $13=__ZNK17parsed_expression11parse_token11is_operatorEv($12);
      if ($13) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $14
      var $15=$token;
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $15);
      __label__ = 76; break;
    case 4: // $16
      var $17=$token;
      var $18=__ZNK17parsed_expression11parse_token6optypeEv($17);
      var $19=(($18)&255);
      if ($19 == 4) {
        __label__ = 5; break;
      }
      else if ($19 == 5) {
        __label__ = 6; break;
      }
      else if ($19 == 6) {
        __label__ = 7; break;
      }
      else if ($19 == 7) {
        __label__ = 8; break;
      }
      else if ($19 == 8) {
        __label__ = 9; break;
      }
      else if ($19 == 9) {
        __label__ = 10; break;
      }
      else if ($19 == 10) {
        __label__ = 11; break;
      }
      else if ($19 == 11) {
        __label__ = 12; break;
      }
      else if ($19 == 12) {
        __label__ = 13; break;
      }
      else if ($19 == 13) {
        __label__ = 14; break;
      }
      else if ($19 == 14) {
        __label__ = 20; break;
      }
      else if ($19 == 15) {
        __label__ = 26; break;
      }
      else if ($19 == 16) {
        __label__ = 27; break;
      }
      else if ($19 == 17) {
        __label__ = 28; break;
      }
      else if ($19 == 18) {
        __label__ = 29; break;
      }
      else if ($19 == 19) {
        __label__ = 30; break;
      }
      else if ($19 == 20) {
        __label__ = 31; break;
      }
      else if ($19 == 21) {
        __label__ = 32; break;
      }
      else if ($19 == 22) {
        __label__ = 33; break;
      }
      else if ($19 == 23) {
        __label__ = 34; break;
      }
      else if ($19 == 24) {
        __label__ = 35; break;
      }
      else if ($19 == 25) {
        __label__ = 36; break;
      }
      else if ($19 == 26) {
        __label__ = 37; break;
      }
      else if ($19 == 27) {
        __label__ = 38; break;
      }
      else if ($19 == 28) {
        __label__ = 39; break;
      }
      else if ($19 == 29) {
        __label__ = 42; break;
      }
      else if ($19 == 30) {
        __label__ = 45; break;
      }
      else if ($19 == 31) {
        __label__ = 46; break;
      }
      else if ($19 == 32) {
        __label__ = 47; break;
      }
      else if ($19 == 33) {
        __label__ = 53; break;
      }
      else if ($19 == 34) {
        __label__ = 59; break;
      }
      else if ($19 == 35) {
        __label__ = 60; break;
      }
      else if ($19 == 36) {
        __label__ = 61; break;
      }
      else if ($19 == 37) {
        __label__ = 62; break;
      }
      else if ($19 == 38) {
        __label__ = 63; break;
      }
      else if ($19 == 39) {
        __label__ = 64; break;
      }
      else if ($19 == 40) {
        __label__ = 65; break;
      }
      else if ($19 == 41) {
        __label__ = 66; break;
      }
      else if ($19 == 42) {
        __label__ = 69; break;
      }
      else if ($19 == 43) {
        __label__ = 70; break;
      }
      else {
      __label__ = 71; break;
      }
      
    case 5: // $20
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $21=(($4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $24$0 = ((($23$0)>>>0)+((($23$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $24$1 = Math.min(Math.floor((((($23$0)>>>0)+((($23$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $25=__ZN17parsed_expression11parse_token16configure_numberEy($result, $24$0, $24$1);
      var $26=__ZN17parsed_expression11parse_token10set_offsetERKS0_($25, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $26);
      var $27=(($4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $29$0=$29[0];
      var $29$1=$29[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $28, $29$0, $29$1);
      __label__ = 75; break;
    case 6: // $30
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $31=(($4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $32);
      var $33$0=$33[0];
      var $33$1=$33[1];
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $34$0 = ((($33$0)>>>0)+((($33$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $34$1 = Math.min(Math.floor((((($33$0)>>>0)+((($33$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $35=__ZN17parsed_expression11parse_token16configure_numberEy($result, $34$0, $34$1);
      var $36=__ZN17parsed_expression11parse_token10set_offsetERKS0_($35, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $36);
      var $37=(($4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $39$0=$39[0];
      var $39$1=$39[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $38, $39$0, $39$1);
      __label__ = 75; break;
    case 7: // $40
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $41=(($4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $42);
      var $43$0=$43[0];
      var $43$1=$43[1];
      var $44=__ZN17parsed_expression11parse_token16configure_numberEy($result, $43$0, $43$1);
      var $45=__ZN17parsed_expression11parse_token10set_offsetERKS0_($44, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $45);
      var $46=(($4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $48$0=$48[0];
      var $48$1=$48[1];
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $49$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $49$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $47, $49$0, $49$1);
      __label__ = 75; break;
    case 8: // $50
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $51=(($4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $52);
      var $53$0=$53[0];
      var $53$1=$53[1];
      var $54=__ZN17parsed_expression11parse_token16configure_numberEy($result, $53$0, $53$1);
      var $55=__ZN17parsed_expression11parse_token10set_offsetERKS0_($54, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $55);
      var $56=(($4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $58$0=$58[0];
      var $58$1=$58[1];
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $59$0 = ((($58$0)>>>0)+((($58$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $59$1 = Math.min(Math.floor((((($58$0)>>>0)+((($58$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $57, $59$0, $59$1);
      __label__ = 75; break;
    case 9: // $60
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $61=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $61$0=$61[0];
      var $61$1=$61[1];
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $62=$61$0 != $$emscripten$temp$4$0 || $61$1 != $$emscripten$temp$4$1;
      var $63=$62 ^ 1;
      var $64$0=$63;
      var $64$1=0;
      var $65=__ZN17parsed_expression11parse_token16configure_numberEy($result, $64$0, $64$1);
      var $66=__ZN17parsed_expression11parse_token10set_offsetERKS0_($65, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $66);
      __label__ = 75; break;
    case 10: // $67
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $68=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $68$0=$68[0];
      var $68$1=$68[1];
      var $$emscripten$temp$5$0=-1;
      var $$emscripten$temp$5$1=-1;
      var $69$0=$68$0 ^ $$emscripten$temp$5$0;
      var $69$1=$68$1 ^ $$emscripten$temp$5$1;
      var $70=__ZN17parsed_expression11parse_token16configure_numberEy($result, $69$0, $69$1);
      var $71=__ZN17parsed_expression11parse_token10set_offsetERKS0_($70, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $71);
      __label__ = 75; break;
    case 11: // $72
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $73=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $73$0=$73[0];
      var $73$1=$73[1];
      var $74=__ZN17parsed_expression11parse_token16configure_numberEy($result, $73$0, $73$1);
      var $75=__ZN17parsed_expression11parse_token10set_offsetERKS0_($74, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $75);
      __label__ = 75; break;
    case 12: // $76
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $77=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $77$0=$77[0];
      var $77$1=$77[1];
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      var $78$0 = ((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))-((($77$0)>>>0)+((($77$1)|0)*4294967296))>>>0; var $78$1 = Math.min(Math.floor((((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))-((($77$0)>>>0)+((($77$1)|0)*4294967296)))/4294967296), 4294967295);
      var $79=__ZN17parsed_expression11parse_token16configure_numberEy($result, $78$0, $78$1);
      var $80=__ZN17parsed_expression11parse_token10set_offsetERKS0_($79, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $80);
      __label__ = 75; break;
    case 13: // $81
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $82=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $82$0=$82[0];
      var $82$1=$82[1];
      var $83=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $83$0=$83[0];
      var $83$1=$83[1];
      var $84$0 = ((($82$0)>>>0)+((($82$1)|0)*4294967296))*((($83$0)>>>0)+((($83$1)|0)*4294967296))>>>0; var $84$1 = Math.min(Math.floor((((($82$0)>>>0)+((($82$1)|0)*4294967296))*((($83$0)>>>0)+((($83$1)|0)*4294967296)))/4294967296), 4294967295);
      var $85=__ZN17parsed_expression11parse_token16configure_numberEy($result, $84$0, $84$1);
      var $86=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($85, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $86);
      __label__ = 75; break;
    case 14: // $87
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $88=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $88$0=$88[0];
      var $88$1=$88[1];
      var $$emscripten$temp$7$0=0;
      var $$emscripten$temp$7$1=0;
      var $89=$88$0 == $$emscripten$temp$7$0 && $88$1 == $$emscripten$temp$7$1;
      if ($89) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $90
      var $91=___cxa_allocate_exception(8);
      var $92=$91;
      var $93=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($t2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; };
    case 16: // $94
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($92, 10, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $95
      ___cxa_throw($91, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 18: // $96
      var $97=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $98=$97.f0;
      $2=$98;
      var $99=$97.f1;
      $3=$99;
      ___cxa_free_exception($91);
      __label__ = 82; break;
    case 19: // $100
      var $101=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $101$0=$101[0];
      var $101$1=$101[1];
      var $102=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $102$0=$102[0];
      var $102$1=$102[1];
      var $103$0 = Math.floor(((($101$0)>>>0)+((($101$1)|0)*4294967296))/((($102$0)>>>0)+((($102$1)|0)*4294967296)))>>>0; var $103$1 = Math.min(Math.floor((Math.floor(((($101$0)>>>0)+((($101$1)|0)*4294967296))/((($102$0)>>>0)+((($102$1)|0)*4294967296))))/4294967296), 4294967295);
      var $104=__ZN17parsed_expression11parse_token16configure_numberEy($result, $103$0, $103$1);
      var $105=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($104, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $105);
      __label__ = 75; break;
    case 20: // $106
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $107=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $107$0=$107[0];
      var $107$1=$107[1];
      var $$emscripten$temp$8$0=0;
      var $$emscripten$temp$8$1=0;
      var $108=$107$0 == $$emscripten$temp$8$0 && $107$1 == $$emscripten$temp$8$1;
      if ($108) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $109
      var $110=___cxa_allocate_exception(8);
      var $111=$110;
      var $112=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($t2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; };
    case 22: // $113
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($111, 10, $112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $114
      ___cxa_throw($110, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 24: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $117=$116.f0;
      $2=$117;
      var $118=$116.f1;
      $3=$118;
      ___cxa_free_exception($110);
      __label__ = 82; break;
    case 25: // $119
      var $120=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $120$0=$120[0];
      var $120$1=$120[1];
      var $121=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $121$0=$121[0];
      var $121$1=$121[1];
      var $122$0 = ((($120$0)>>>0)+((($120$1)|0)*4294967296))%((($121$0)>>>0)+((($121$1)|0)*4294967296))>>>0; var $122$1 = Math.min(Math.floor((((($120$0)>>>0)+((($120$1)|0)*4294967296))%((($121$0)>>>0)+((($121$1)|0)*4294967296)))/4294967296), 4294967295);
      var $123=__ZN17parsed_expression11parse_token16configure_numberEy($result, $122$0, $122$1);
      var $124=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($123, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $124);
      __label__ = 75; break;
    case 26: // $125
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $126=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $126$0=$126[0];
      var $126$1=$126[1];
      var $127=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $127$0=$127[0];
      var $127$1=$127[1];
      var $128$0 = ((($126$0)>>>0)+((($126$1)|0)*4294967296))+((($127$0)>>>0)+((($127$1)|0)*4294967296))>>>0; var $128$1 = Math.min(Math.floor((((($126$0)>>>0)+((($126$1)|0)*4294967296))+((($127$0)>>>0)+((($127$1)|0)*4294967296)))/4294967296), 4294967295);
      var $129=__ZN17parsed_expression11parse_token16configure_numberEy($result, $128$0, $128$1);
      var $130=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($129, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $130);
      __label__ = 75; break;
    case 27: // $131
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $132=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $132$0=$132[0];
      var $132$1=$132[1];
      var $133=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $133$0=$133[0];
      var $133$1=$133[1];
      var $134$0 = ((($132$0)>>>0)+((($132$1)|0)*4294967296))-((($133$0)>>>0)+((($133$1)|0)*4294967296))>>>0; var $134$1 = Math.min(Math.floor((((($132$0)>>>0)+((($132$1)|0)*4294967296))-((($133$0)>>>0)+((($133$1)|0)*4294967296)))/4294967296), 4294967295);
      var $135=__ZN17parsed_expression11parse_token16configure_numberEy($result, $134$0, $134$1);
      var $136=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($135, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $136);
      __label__ = 75; break;
    case 28: // $137
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $138=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $138$0=$138[0];
      var $138$1=$138[1];
      var $139=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $139$0=$139[0];
      var $139$1=$139[1];
      var $140=Runtime.bitshift64($138$0, $138$1,"shl",$139$0);var $140$0 = $140[0], $140$1 = $140[1];
      var $141=__ZN17parsed_expression11parse_token16configure_numberEy($result, $140$0, $140$1);
      var $142=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($141, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $142);
      __label__ = 75; break;
    case 29: // $143
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $144=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $144$0=$144[0];
      var $144$1=$144[1];
      var $145=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $145$0=$145[0];
      var $145$1=$145[1];
      var $146=Runtime.bitshift64($144$0, $144$1,"lshr",$145$0);var $146$0 = $146[0], $146$1 = $146[1];
      var $147=__ZN17parsed_expression11parse_token16configure_numberEy($result, $146$0, $146$1);
      var $148=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($147, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $148);
      __label__ = 75; break;
    case 30: // $149
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $150=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $150$0=$150[0];
      var $150$1=$150[1];
      var $151=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $151$0=$151[0];
      var $151$1=$151[1];
      var $152=$150$1 < $151$1 || ($150$1 == $151$1 && $150$0 < $151$0);
      var $153$0=$152;
      var $153$1=0;
      var $154=__ZN17parsed_expression11parse_token16configure_numberEy($result, $153$0, $153$1);
      var $155=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($154, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $155);
      __label__ = 75; break;
    case 31: // $156
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $157=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $157$0=$157[0];
      var $157$1=$157[1];
      var $158=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $158$0=$158[0];
      var $158$1=$158[1];
      var $159=$157$1 <= $158$1 && ($157$1 < $158$1 || $157$0 <= $158$0);
      var $160$0=$159;
      var $160$1=0;
      var $161=__ZN17parsed_expression11parse_token16configure_numberEy($result, $160$0, $160$1);
      var $162=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($161, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $162);
      __label__ = 75; break;
    case 32: // $163
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $164=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $164$0=$164[0];
      var $164$1=$164[1];
      var $165=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $165$0=$165[0];
      var $165$1=$165[1];
      var $166=$164$1 > $165$1 || ($164$1 == $165$1 && $164$0 > $165$0);
      var $167$0=$166;
      var $167$1=0;
      var $168=__ZN17parsed_expression11parse_token16configure_numberEy($result, $167$0, $167$1);
      var $169=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($168, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $169);
      __label__ = 75; break;
    case 33: // $170
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $171=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $171$0=$171[0];
      var $171$1=$171[1];
      var $172=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $172$0=$172[0];
      var $172$1=$172[1];
      var $173=$171$1 >= $172$1 && ($171$1 > $172$1 || $171$0 >= $172$0);
      var $174$0=$173;
      var $174$1=0;
      var $175=__ZN17parsed_expression11parse_token16configure_numberEy($result, $174$0, $174$1);
      var $176=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($175, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $176);
      __label__ = 75; break;
    case 34: // $177
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $178=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $178$0=$178[0];
      var $178$1=$178[1];
      var $179=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $179$0=$179[0];
      var $179$1=$179[1];
      var $180=$178$0 == $179$0 && $178$1 == $179$1;
      var $181$0=$180;
      var $181$1=0;
      var $182=__ZN17parsed_expression11parse_token16configure_numberEy($result, $181$0, $181$1);
      var $183=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($182, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $183);
      __label__ = 75; break;
    case 35: // $184
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $185=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $185$0=$185[0];
      var $185$1=$185[1];
      var $186=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $186$0=$186[0];
      var $186$1=$186[1];
      var $187=$185$0 != $186$0 || $185$1 != $186$1;
      var $188$0=$187;
      var $188$1=0;
      var $189=__ZN17parsed_expression11parse_token16configure_numberEy($result, $188$0, $188$1);
      var $190=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($189, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $190);
      __label__ = 75; break;
    case 36: // $191
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $192=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $192$0=$192[0];
      var $192$1=$192[1];
      var $193=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $193$0=$193[0];
      var $193$1=$193[1];
      var $194$0=$192$0 & $193$0;
      var $194$1=$192$1 & $193$1;
      var $195=__ZN17parsed_expression11parse_token16configure_numberEy($result, $194$0, $194$1);
      var $196=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($195, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $196);
      __label__ = 75; break;
    case 37: // $197
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $198=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $198$0=$198[0];
      var $198$1=$198[1];
      var $199=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $199$0=$199[0];
      var $199$1=$199[1];
      var $200$0=$198$0 ^ $199$0;
      var $200$1=$198$1 ^ $199$1;
      var $201=__ZN17parsed_expression11parse_token16configure_numberEy($result, $200$0, $200$1);
      var $202=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($201, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $202);
      __label__ = 75; break;
    case 38: // $203
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $204=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $204$0=$204[0];
      var $204$1=$204[1];
      var $205=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $205$0=$205[0];
      var $205$1=$205[1];
      var $206$0=$204$0 | $205$0;
      var $206$1=$204$1 | $205$1;
      var $207=__ZN17parsed_expression11parse_token16configure_numberEy($result, $206$0, $206$1);
      var $208=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($207, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $208);
      __label__ = 75; break;
    case 39: // $209
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $210=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $210$0=$210[0];
      var $210$1=$210[1];
      var $$emscripten$temp$9$0=0;
      var $$emscripten$temp$9$1=0;
      var $211=$210$0 != $$emscripten$temp$9$0 || $210$1 != $$emscripten$temp$9$1;
      if ($211) { __label__ = 40; break; } else { var $216 = 0;__label__ = 41; break; }
    case 40: // $212
      var $213=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $213$0=$213[0];
      var $213$1=$213[1];
      var $$emscripten$temp$10$0=0;
      var $$emscripten$temp$10$1=0;
      var $214=$213$0 != $$emscripten$temp$10$0 || $213$1 != $$emscripten$temp$10$1;
      var $216 = $214;__label__ = 41; break;
    case 41: // $215
      var $216;
      var $217$0=$216;
      var $217$1=0;
      var $218=__ZN17parsed_expression11parse_token16configure_numberEy($result, $217$0, $217$1);
      var $219=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($218, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $219);
      __label__ = 75; break;
    case 42: // $220
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $221=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $221$0=$221[0];
      var $221$1=$221[1];
      var $$emscripten$temp$11$0=0;
      var $$emscripten$temp$11$1=0;
      var $222=$221$0 != $$emscripten$temp$11$0 || $221$1 != $$emscripten$temp$11$1;
      if ($222) { var $227 = 1;__label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $223
      var $224=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $224$0=$224[0];
      var $224$1=$224[1];
      var $$emscripten$temp$12$0=0;
      var $$emscripten$temp$12$1=0;
      var $225=$224$0 != $$emscripten$temp$12$0 || $224$1 != $$emscripten$temp$12$1;
      var $227 = $225;__label__ = 44; break;
    case 44: // $226
      var $227;
      var $228$0=$227;
      var $228$1=0;
      var $229=__ZN17parsed_expression11parse_token16configure_numberEy($result, $228$0, $228$1);
      var $230=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($229, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $230);
      __label__ = 75; break;
    case 45: // $231
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $232=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $232$0=$232[0];
      var $232$1=$232[1];
      var $233=__ZN17parsed_expression11parse_token16configure_numberEy($result, $232$0, $232$1);
      var $234=__ZN17parsed_expression11parse_token10set_offsetERKS0_($233, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $234);
      var $235=(($4)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $237$0=$237[0];
      var $237$1=$237[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $236, $237$0, $237$1);
      __label__ = 75; break;
    case 46: // $238
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $239=(($4)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $240);
      var $241$0=$241[0];
      var $241$1=$241[1];
      var $242=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $242$0=$242[0];
      var $242$1=$242[1];
      var $243$0 = ((($241$0)>>>0)+((($241$1)|0)*4294967296))*((($242$0)>>>0)+((($242$1)|0)*4294967296))>>>0; var $243$1 = Math.min(Math.floor((((($241$0)>>>0)+((($241$1)|0)*4294967296))*((($242$0)>>>0)+((($242$1)|0)*4294967296)))/4294967296), 4294967295);
      var $244=__ZN17parsed_expression11parse_token16configure_numberEy($result, $243$0, $243$1);
      var $245=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($244, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $245);
      var $246=(($4)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $248$0=$248[0];
      var $248$1=$248[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $247, $248$0, $248$1);
      __label__ = 75; break;
    case 47: // $249
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $250=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $250$0=$250[0];
      var $250$1=$250[1];
      var $$emscripten$temp$13$0=0;
      var $$emscripten$temp$13$1=0;
      var $251=$250$0 == $$emscripten$temp$13$0 && $250$1 == $$emscripten$temp$13$1;
      if ($251) { __label__ = 48; break; } else { __label__ = 52; break; }
    case 48: // $252
      var $253=___cxa_allocate_exception(8);
      var $254=$253;
      var $255=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($t2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 51; break; };
    case 49: // $256
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($254, 10, $255) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $257
      ___cxa_throw($253, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 51: // $258
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $260=$259.f0;
      $2=$260;
      var $261=$259.f1;
      $3=$261;
      ___cxa_free_exception($253);
      __label__ = 82; break;
    case 52: // $262
      var $263=(($4)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $264);
      var $265$0=$265[0];
      var $265$1=$265[1];
      var $266=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $266$0=$266[0];
      var $266$1=$266[1];
      var $267$0 = Math.floor(((($265$0)>>>0)+((($265$1)|0)*4294967296))/((($266$0)>>>0)+((($266$1)|0)*4294967296)))>>>0; var $267$1 = Math.min(Math.floor((Math.floor(((($265$0)>>>0)+((($265$1)|0)*4294967296))/((($266$0)>>>0)+((($266$1)|0)*4294967296))))/4294967296), 4294967295);
      var $268=__ZN17parsed_expression11parse_token16configure_numberEy($result, $267$0, $267$1);
      var $269=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($268, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $269);
      var $270=(($4)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $272$0=$272[0];
      var $272$1=$272[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $271, $272$0, $272$1);
      __label__ = 75; break;
    case 53: // $273
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $274=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $274$0=$274[0];
      var $274$1=$274[1];
      var $$emscripten$temp$14$0=0;
      var $$emscripten$temp$14$1=0;
      var $275=$274$0 == $$emscripten$temp$14$0 && $274$1 == $$emscripten$temp$14$1;
      if ($275) { __label__ = 54; break; } else { __label__ = 58; break; }
    case 54: // $276
      var $277=___cxa_allocate_exception(8);
      var $278=$277;
      var $279=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($t2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 57; break; };
    case 55: // $280
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($278, 10, $279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $281
      ___cxa_throw($277, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 57: // $282
      var $283=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $284=$283.f0;
      $2=$284;
      var $285=$283.f1;
      $3=$285;
      ___cxa_free_exception($277);
      __label__ = 82; break;
    case 58: // $286
      var $287=(($4)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $288);
      var $289$0=$289[0];
      var $289$1=$289[1];
      var $290=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $290$0=$290[0];
      var $290$1=$290[1];
      var $291$0 = ((($289$0)>>>0)+((($289$1)|0)*4294967296))%((($290$0)>>>0)+((($290$1)|0)*4294967296))>>>0; var $291$1 = Math.min(Math.floor((((($289$0)>>>0)+((($289$1)|0)*4294967296))%((($290$0)>>>0)+((($290$1)|0)*4294967296)))/4294967296), 4294967295);
      var $292=__ZN17parsed_expression11parse_token16configure_numberEy($result, $291$0, $291$1);
      var $293=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($292, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $293);
      var $294=(($4)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $296$0=$296[0];
      var $296$1=$296[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $295, $296$0, $296$1);
      __label__ = 75; break;
    case 59: // $297
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $298=(($4)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $299);
      var $300$0=$300[0];
      var $300$1=$300[1];
      var $301=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $301$0=$301[0];
      var $301$1=$301[1];
      var $302$0 = ((($300$0)>>>0)+((($300$1)|0)*4294967296))+((($301$0)>>>0)+((($301$1)|0)*4294967296))>>>0; var $302$1 = Math.min(Math.floor((((($300$0)>>>0)+((($300$1)|0)*4294967296))+((($301$0)>>>0)+((($301$1)|0)*4294967296)))/4294967296), 4294967295);
      var $303=__ZN17parsed_expression11parse_token16configure_numberEy($result, $302$0, $302$1);
      var $304=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($303, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $304);
      var $305=(($4)|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $307$0=$307[0];
      var $307$1=$307[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $306, $307$0, $307$1);
      __label__ = 75; break;
    case 60: // $308
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $309=(($4)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $310);
      var $311$0=$311[0];
      var $311$1=$311[1];
      var $312=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $312$0=$312[0];
      var $312$1=$312[1];
      var $313$0 = ((($311$0)>>>0)+((($311$1)|0)*4294967296))-((($312$0)>>>0)+((($312$1)|0)*4294967296))>>>0; var $313$1 = Math.min(Math.floor((((($311$0)>>>0)+((($311$1)|0)*4294967296))-((($312$0)>>>0)+((($312$1)|0)*4294967296)))/4294967296), 4294967295);
      var $314=__ZN17parsed_expression11parse_token16configure_numberEy($result, $313$0, $313$1);
      var $315=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($314, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $315);
      var $316=(($4)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $318$0=$318[0];
      var $318$1=$318[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $317, $318$0, $318$1);
      __label__ = 75; break;
    case 61: // $319
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $320=(($4)|0);
      var $321=HEAP32[(($320)>>2)];
      var $322=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $321);
      var $322$0=$322[0];
      var $322$1=$322[1];
      var $323=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $323$0=$323[0];
      var $323$1=$323[1];
      var $324=Runtime.bitshift64($322$0, $322$1,"shl",$323$0);var $324$0 = $324[0], $324$1 = $324[1];
      var $325=__ZN17parsed_expression11parse_token16configure_numberEy($result, $324$0, $324$1);
      var $326=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($325, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $326);
      var $327=(($4)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $329$0=$329[0];
      var $329$1=$329[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $328, $329$0, $329$1);
      __label__ = 75; break;
    case 62: // $330
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $331=(($4)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $332);
      var $333$0=$333[0];
      var $333$1=$333[1];
      var $334=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $334$0=$334[0];
      var $334$1=$334[1];
      var $335=Runtime.bitshift64($333$0, $333$1,"lshr",$334$0);var $335$0 = $335[0], $335$1 = $335[1];
      var $336=__ZN17parsed_expression11parse_token16configure_numberEy($result, $335$0, $335$1);
      var $337=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($336, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $337);
      var $338=(($4)|0);
      var $339=HEAP32[(($338)>>2)];
      var $340=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $340$0=$340[0];
      var $340$1=$340[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $339, $340$0, $340$1);
      __label__ = 75; break;
    case 63: // $341
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $342=(($4)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $343);
      var $344$0=$344[0];
      var $344$1=$344[1];
      var $345=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $345$0=$345[0];
      var $345$1=$345[1];
      var $346$0=$344$0 & $345$0;
      var $346$1=$344$1 & $345$1;
      var $347=__ZN17parsed_expression11parse_token16configure_numberEy($result, $346$0, $346$1);
      var $348=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($347, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $348);
      var $349=(($4)|0);
      var $350=HEAP32[(($349)>>2)];
      var $351=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $351$0=$351[0];
      var $351$1=$351[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $350, $351$0, $351$1);
      __label__ = 75; break;
    case 64: // $352
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $353=(($4)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $354);
      var $355$0=$355[0];
      var $355$1=$355[1];
      var $356=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $356$0=$356[0];
      var $356$1=$356[1];
      var $357$0=$355$0 ^ $356$0;
      var $357$1=$355$1 ^ $356$1;
      var $358=__ZN17parsed_expression11parse_token16configure_numberEy($result, $357$0, $357$1);
      var $359=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($358, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $359);
      var $360=(($4)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $362$0=$362[0];
      var $362$1=$362[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $361, $362$0, $362$1);
      __label__ = 75; break;
    case 65: // $363
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($4, $t1);
      var $364=(($4)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($t1, $365);
      var $366$0=$366[0];
      var $366$1=$366[1];
      var $367=__ZNK17parsed_expression11parse_token5valueEv($t2);
      var $367$0=$367[0];
      var $367$1=$367[1];
      var $368$0=$366$0 | $367$0;
      var $368$1=$366$1 | $367$1;
      var $369=__ZN17parsed_expression11parse_token16configure_numberEy($result, $368$0, $368$1);
      var $370=__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($369, $t1, $t2);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $370);
      var $371=(($4)|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $373$0=$373[0];
      var $373$1=$373[1];
      __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($t1, $372, $373$0, $373$1);
      __label__ = 75; break;
    case 66: // $374
      var $375=$token;
      var $376=__ZNK17parsed_expression11parse_token21is_function_separatorEv($375);
      if ($376) { __label__ = 68; break; } else { __label__ = 67; break; }
    case 67: // $377
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t2);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $t2);
      __label__ = 68; break;
    case 68: // $378
      __label__ = 75; break;
    case 69: // $379
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $t1);
      var $380=__ZNK17parsed_expression11parse_token5valueEv($t1);
      var $380$0=$380[0];
      var $380$1=$380[1];
      var $381$0=$380$0;
      var $381=$381$0;
      var $382=$token;
      var $383=__ZN17parsed_expression11parse_token16configure_memoryEjRS0_($result, $381, $382);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($4, $383);
      __label__ = 75; break;
    case 70: // $384
      var $385=$token;
      __ZN17parsed_expression16execute_functionERNS_11parse_tokenE($4, $385);
      __label__ = 75; break;
    case 71: // $386
      var $387=___cxa_allocate_exception(8);
      var $388=$387;
      var $389=$token;
      var $390=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($389) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 74; break; };
    case 72: // $391
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($388, 3, $390) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $392
      ___cxa_throw($387, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 74: // $393
      var $394=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $395=$394.f0;
      $2=$395;
      var $396=$394.f1;
      $3=$396;
      ___cxa_free_exception($387);
      __label__ = 82; break;
    case 75: // $397
      __label__ = 76; break;
    case 76: // $398
      var $399=$token;
      var $400=__ZNK17parsed_expression11parse_token4nextEv($399);
      $token=$400;
      __label__ = 1; break;
    case 77: // $401
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($4, $result);
      var $402=__ZN17parsed_expression10peek_tokenEi($4, 0);
      var $403=(($402)|0)!=0;
      if ($403) { __label__ = 78; break; } else { __label__ = 81; break; }
    case 78: // $404
      var $405=___cxa_allocate_exception(8);
      var $406=$405;
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($406, 3, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $407
      ___cxa_throw($405, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 80: // $408
      var $409=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $410=$409.f0;
      $2=$410;
      var $411=$409.f1;
      $3=$411;
      ___cxa_free_exception($405);
      __label__ = 82; break;
    case 81: // $412
      var $413=__ZNK17parsed_expression11parse_token5valueEv($result);
      var $413$0=$413[0];
      var $413$1=$413[1];
      STACKTOP = __stackBase__;
      return [$413$0,$413$1];
    case 82: // $414
      var $415=$2;
      var $416=$2;
      var $417=$3;
      var $418=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $416, tempValue);
      var $419=($418.f1 = $417, $418);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression14execute_tokensEv["X"]=1;

function __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($this, $token) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$token;
      var $5=$1;
      var $6=(($5+108)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0) >= 16;
      if ($8) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(8);
      var $11=$10;
      var $12=$2;
      var $13=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $14
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($11, 7, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      ___cxa_throw($10, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $3=$18;
      var $19=$17.f1;
      $4=$19;
      ___cxa_free_exception($10);
      __label__ = 6; break;
    case 5: // $20
      var $21=(($5+108)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+1)|0);
      HEAP32[(($21)>>2)]=$23;
      var $24=(($5+112)|0);
      var $25=(($24+($22<<5))|0);
      var $26=$2;
      var $27=$25;
      var $28=$26;
      assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];HEAP32[(($27+12)>>2)]=HEAP32[(($28+12)>>2)];HEAP32[(($27+16)>>2)]=HEAP32[(($28+16)>>2)];HEAP32[(($27+20)>>2)]=HEAP32[(($28+20)>>2)];HEAP32[(($27+24)>>2)]=HEAP32[(($28+24)>>2)];HEAP32[(($27+28)>>2)]=HEAP32[(($28+28)>>2)];
      ;
      return;
    case 6: // $29
      var $30=$3;
      var $31=$3;
      var $32=$4;
      var $33=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31, tempValue);
      var $34=($33.f1 = $32, $33);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE($this, $token) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$token;
      var $5=$1;
      var $6=$2;
      __ZN17parsed_expression9pop_tokenERNS_11parse_tokenE($5, $6);
      var $7=$2;
      var $8=__ZNK17parsed_expression11parse_token7is_lvalEv($7);
      if ($8) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(8);
      var $11=$10;
      var $12=$2;
      var $13=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $14
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($11, 1, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      ___cxa_throw($10, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $3=$18;
      var $19=$17.f1;
      $4=$19;
      ___cxa_free_exception($10);
      __label__ = 6; break;
    case 5: // $20
      ;
      return;
    case 6: // $21
      var $22=$3;
      var $23=$3;
      var $24=$4;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIP21function_symbol_entry12symbol_entryET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token5valueEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+12)|0);
      var $st$1$0=(($5)|0);
      var $6$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($5+4)|0);
      var $6$1=HEAP32[(($st$1$1)>>2)];
      ;
      return [$6$0,$6$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token10set_offsetERKS0_S2_($this, $src1, $src2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$src1;
      $3=$src2;
      var $4=$1;
      var $5=$2;
      var $6=(($5+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$3;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($7)|0) < (($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $21 = $15;__label__ = 3; break;
    case 2: // $16
      var $17=$3;
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $21 = $19;__label__ = 3; break;
    case 3: // $20
      var $21;
      var $22=(($4+8)|0);
      HEAP32[(($22)>>2)]=$21;
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token16configure_memoryEjRS0_($this, $address, $memoryat) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$memoryat;
  var $4=$1;
  var $5=(($4+4)|0);
  HEAP32[(($5)>>2)]=3;
  var $6=$2;
  var $7$0=$6;
  var $7$1=0;
  var $8=(($4+12)|0);
  var $st$13$0=(($8)|0);
  HEAP32[(($st$13$0)>>2)]=$7$0;
  var $st$13$1=(($8+4)|0);
  HEAP32[(($st$13$1)>>2)]=$7$1;
  var $9=$3;
  var $10=(($9+20)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($4+20)|0);
  HEAP32[(($12)>>2)]=$11;
  var $13=$3;
  var $14=(($13+24)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($4+24)|0);
  HEAP32[(($16)>>2)]=$15;
  ;
  return $4;
}


function __ZN17parsed_expression11parse_tokenC2Ei($this, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$offset;
  var $3=$1;
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  var $7=$2;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($3+12)|0);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $st$15$0=(($8)|0);
  HEAP32[(($st$15$0)>>2)]=$$emscripten$temp$0$0;
  var $st$15$1=(($8+4)|0);
  HEAP32[(($st$15$1)>>2)]=$$emscripten$temp$0$1;
  var $9=(($3+20)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=(($3+24)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($3+28)|0);
  HEAP32[(($11)>>2)]=0;
  ;
  return;
}


function __ZNK17parsed_expression11parse_token9is_memoryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)==3;
  ;
  return $5;
}


function __ZNK17parsed_expression11parse_token12memory_spaceEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 15728640;
      var $8=$7 >>> 20;
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token7addressEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+12)|0);
      var $st$1$0=(($5)|0);
      var $6$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($5+4)|0);
      var $6$1=HEAP32[(($st$1$1)>>2)];
      var $7$0=$6$0;
      var $7=$7$0;
      ;
      return $7;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token11memory_sizeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+20)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 786432;
      var $8=$7 >>> 18;
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK17parsed_expression11parse_token6symbolEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=(($2+28)|0);
      var $6=HEAP32[(($5)>>2)];
      ;
      return $6;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley($this, $table, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      $1=$this;
      $2=$table;
      var $st$5$0=(($3)|0);
      HEAP32[(($st$5$0)>>2)]=$value$0;
      var $st$5$1=(($3+4)|0);
      HEAP32[(($st$5$1)>>2)]=$value$1;
      var $4=$1;
      var $5=__ZNK17parsed_expression11parse_token9is_symbolEv($4);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $st$6$0=(($3)|0);
      var $13$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$6$1)>>2)];
      FUNCTION_TABLE[$12]($8, $13$0, $13$1);
      __label__ = 6; break;
    case 2: // $14
      var $15=__ZNK17parsed_expression11parse_token9is_memoryEv($4);
      if ($15) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      var $17=$2;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$2;
      var $21=(($4+24)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK17parsed_expression11parse_token12memory_spaceEv($4);
      var $24=__ZNK17parsed_expression11parse_token7addressEv($4);
      var $25=__ZNK17parsed_expression11parse_token11memory_sizeEv($4);
      var $26=1 << $25;
      var $st$7$0=(($3)|0);
      var $27$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($3+4)|0);
      var $27$1=HEAP32[(($st$7$1)>>2)];
      __ZN12symbol_table16set_memory_valueEPKc16expression_spacejiy($20, $22, $23, $24, $26, $27$0, $27$1);
      __label__ = 5; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20integer_symbol_entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20integer_symbol_entryD2Ev($2);
  ;
  return;
}


function __ZN21function_symbol_entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN21function_symbol_entryD2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression17expression_stringEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN17parsed_expression17expression_stringEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression17expression_stringEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 68);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN17parsed_expression17expression_stringEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression17expression_stringEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN17parsed_expression17expression_stringEED2Ev($2);
  ;
  return;
}


function __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($this, $token) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$token;
      var $5=$1;
      var $6=$2;
      __ZN17parsed_expression9pop_tokenERNS_11parse_tokenE($5, $6);
      var $7=$2;
      var $8=__ZNK17parsed_expression11parse_token9is_symbolEv($7);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=__ZNK17parsed_expression11parse_token9is_memoryEv($10);
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$2;
      var $14=$2;
      var $15=(($5)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table($14, $16);
      var $17$0=$17[0];
      var $17$1=$17[1];
      var $18=__ZN17parsed_expression11parse_token16configure_numberEy($13, $17$0, $17$1);
      __label__ = 3; break;
    case 3: // $19
      var $20=$2;
      var $21=__ZNK17parsed_expression11parse_token9is_numberEv($20);
      if ($21) { __label__ = 8; break; } else { __label__ = 4; break; }
    case 4: // $22
      var $23=___cxa_allocate_exception(8);
      var $24=$23;
      var $25=$2;
      var $26=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $27
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($24, 2, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $28
      ___cxa_throw($23, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $3=$31;
      var $32=$30.f1;
      $4=$32;
      ___cxa_free_exception($23);
      __label__ = 9; break;
    case 8: // $33
      ;
      return;
    case 9: // $34
      var $35=$3;
      var $36=$3;
      var $37=$4;
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue);
      var $39=($38.f1 = $37, $38);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression16execute_functionERNS_11parse_tokenE($this, $token) {
  var __stackBase__  = STACKTOP; STACKTOP += 224; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $funcparams=__stackBase__;
      var $symbol;
      var $paramcount;
      var $peek;
      var $3;
      var $4;
      var $t1=__stackBase__+128;
      var $t11=__stackBase__+160;
      var $function;
      var $result=__stackBase__+192;
      $1=$this;
      $2=$token;
      var $5=$1;
      $symbol=0;
      $paramcount=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$paramcount;
      var $8=(($7)|0) < 16;
      if ($8) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $9
      var $10=__ZN17parsed_expression10peek_tokenEi($5, 0);
      $peek=$10;
      var $11=$peek;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $13
      var $14=___cxa_allocate_exception(8);
      var $15=$14;
      var $16=$2;
      var $17=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $18
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($15, 12, $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $19
      ___cxa_throw($14, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 6: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $3=$22;
      var $23=$21.f1;
      $4=$23;
      ___cxa_free_exception($14);
      __label__ = 18; break;
    case 7: // $24
      var $25=$peek;
      var $26=__ZNK17parsed_expression11parse_token9is_symbolEv($25);
      if ($26) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $27
      var $28=$peek;
      var $29=__ZNK17parsed_expression11parse_token6symbolEv($28);
      $symbol=$29;
      var $30=$symbol;
      var $31=__ZNK12symbol_entry11is_functionEv($30);
      if ($31) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $32
      FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($t1, 0);
      __ZN17parsed_expression9pop_tokenERNS_11parse_tokenE($5, $t1);
      __label__ = 12; break;
    case 10: // $33
      __label__ = 11; break;
    case 11: // $34
      FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($t11, 0);
      __ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE($5, $t11);
      var $35=__ZNK17parsed_expression11parse_token5valueEv($t11);
      var $35$0=$35[0];
      var $35$1=$35[1];
      var $36=$paramcount;
      var $37=(($36+1)|0);
      $paramcount=$37;
      var $38=((16-$37)|0);
      var $39=(($funcparams+($38<<3))|0);
      var $st$10$0=(($39)|0);
      HEAP32[(($st$10$0)>>2)]=$35$0;
      var $st$10$1=(($39+4)|0);
      HEAP32[(($st$10$1)>>2)]=$35$1;
      __label__ = 1; break;
    case 12: // $40
      var $41=$paramcount;
      var $42=(($41)|0)==16;
      if ($42) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $43
      var $44=___cxa_allocate_exception(8);
      var $45=$44;
      var $46=$2;
      var $47=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $48
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($45, 12, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $49
      ___cxa_throw($44, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 16: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      $3=$52;
      var $53=$51.f1;
      $4=$53;
      ___cxa_free_exception($44);
      __label__ = 18; break;
    case 17: // $54
      var $55=$symbol;
      var $56=__Z8downcastIP21function_symbol_entry12symbol_entryET_PT0_($55);
      $function=$56;
      var $57=$2;
      var $58=__ZNK17parsed_expression11parse_token6offsetEv($57);
      FUNCTION_TABLE[__ZN17parsed_expression11parse_tokenC1Ei]($result, $58);
      var $59=$function;
      var $60=$59;
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+20)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$paramcount;
      var $65=$paramcount;
      var $66=((16-$65)|0);
      var $67=(($funcparams+($66<<3))|0);
      var $68=FUNCTION_TABLE[$63]($59, $64, $67);
      var $68$0=$68[0];
      var $68$1=$68[1];
      var $69=__ZN17parsed_expression11parse_token16configure_numberEy($result, $68$0, $68$1);
      __ZN17parsed_expression10push_tokenERNS_11parse_tokenE($5, $result);
      STACKTOP = __stackBase__;
      return;
    case 18: // $70
      var $71=$3;
      var $72=$3;
      var $73=$4;
      var $74=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $72, tempValue);
      var $75=($74.f1 = $73, $74);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17parsed_expression16execute_functionERNS_11parse_tokenE["X"]=1;

function __ZN17parsed_expression9pop_tokenERNS_11parse_tokenE($this, $token) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$token;
      var $5=$1;
      var $6=(($5+108)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $9
      var $10=___cxa_allocate_exception(8);
      var $11=$10;
      var $12=$2;
      var $13=(function() { try { __THREW__ = false; return __ZNK17parsed_expression11parse_token6offsetEv($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $14
      (function() { try { __THREW__ = false; return __ZN16expression_errorC1ENS_10error_codeEi($11, 8, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      ___cxa_throw($10, __ZTI16expression_error, 0);
      throw "Reached an unreachable!"
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $3=$18;
      var $19=$17.f1;
      $4=$19;
      ___cxa_free_exception($10);
      __label__ = 6; break;
    case 5: // $20
      var $21=$2;
      var $22=(($5+108)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      HEAP32[(($22)>>2)]=$24;
      var $25=(($5+112)|0);
      var $26=(($25+($24<<5))|0);
      var $27=$21;
      var $28=$26;
      assert(32 % 1 === 0, 'memcpy given ' + 32 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];HEAP32[(($27+12)>>2)]=HEAP32[(($28+12)>>2)];HEAP32[(($27+16)>>2)]=HEAP32[(($28+16)>>2)];HEAP32[(($27+20)>>2)]=HEAP32[(($28+20)>>2)];HEAP32[(($27+24)>>2)]=HEAP32[(($28+24)>>2)];HEAP32[(($27+28)>>2)]=HEAP32[(($28+28)>>2)];
      ;
      return;
    case 6: // $29
      var $30=$3;
      var $31=$3;
      var $32=$4;
      var $33=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31, tempValue);
      var $34=($33.f1 = $32, $33);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20integer_symbol_entryD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20integer_symbol_entryD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20integer_symbol_entryD0Ev["X"]=1;

function __ZN21function_symbol_entryD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN21function_symbol_entryD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21function_symbol_entryD0Ev["X"]=1;

function __ZN20resource_pool_objectIN17parsed_expression17expression_stringEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN17parsed_expression17expression_stringEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED0Ev["X"]=1;

function __ZN11simple_listI12symbol_entryE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI12symbol_entryEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI12symbol_entryE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression17expression_stringEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN17parsed_expression17expression_stringEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listIN17parsed_expression11parse_tokenEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN17parsed_expression11parse_tokenEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN17parsed_expression17expression_stringD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN17parsed_expression17expression_stringD2Ev($2);
  ;
  return;
}


function __ZN17parsed_expression17expression_stringD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 32);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN17parsed_expression11parse_tokenEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI21function_symbol_entryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI21function_symbol_entryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI21function_symbol_entryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 92);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI21function_symbol_entryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI21function_symbol_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI21function_symbol_entryED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI20integer_symbol_entryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI20integer_symbol_entryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI20integer_symbol_entryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 100);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI20integer_symbol_entryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI20integer_symbol_entryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI20integer_symbol_entryED2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryE15add_unique_hashEPKcS1_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z22tagmap_add_unique_hashP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN11tagged_listI12symbol_entryE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=(($3+20)|0);
  var $5=$2;
  __ZN8tagmap_tIP12symbol_entryE6removeES1_($4, $5);
  var $6=(($3)|0);
  var $7=$2;
  __ZN11simple_listI12symbol_entryE6removeERS0_($6, $7);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryE6removeES1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __Z20tagmap_remove_objectP7_tagmapPv($4, $6);
  ;
  return;
}


function __ZN11simple_listI12symbol_entryEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI12symbol_entryEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIP12symbol_entryEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIP12symbol_entryEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZN21function_symbol_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN12symbol_entryD2Ev($3);
  ;
  return;
}


function __ZN20integer_symbol_entryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN12symbol_entryD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectIN17parsed_expression17expression_stringEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN17parsed_expression17expression_stringEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN17parsed_expression17expression_stringD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED2Ev["X"]=1;

function __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV20resource_pool_objectIN17parsed_expression11parse_tokenEE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI21function_symbol_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI21function_symbol_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI21function_symbol_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI21function_symbol_entryED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI21function_symbol_entryE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI20integer_symbol_entryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI20integer_symbol_entryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI20integer_symbol_entryED0Ev["X"]=1;

function __ZN20resource_pool_objectI20integer_symbol_entryED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI20integer_symbol_entryE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11tagged_listI12symbol_entryEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$pool;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      __ZN11simple_listI12symbol_entryEC1ER13resource_pool($6, $7);
      var $8=(($5+20)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIP12symbol_entryEC1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $3=$12;
      var $13=$11.f1;
      $4=$13;
      var $14=(($5)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI12symbol_entryED1Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$3;
      var $18=$3;
      var $19=$4;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16expression_errorC2ENS_10error_codeEi($this, $code, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$code;
  $3=$offset;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$3;
  HEAP32[(($7)>>2)]=$8;
  ;
  return;
}


function __ZNK17parsed_expression11parse_token7is_lvalEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==4;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=FUNCTION_TABLE[$12]($8);
      if ($13) { var $19 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=(($2+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==3;
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression17expression_stringC2EPKci($this, $string, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$string;
      $3=$length;
      var $4=$1;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($4+4)|0);
      var $7=$2;
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=_strlen($11);
      var $16 = $12;__label__ = 3; break;
    case 2: // $13
      var $14=$3;
      var $16 = $14;__label__ = 3; break;
    case 3: // $15
      var $16;
      __ZN7astringC1EPKci($6, $7, $16);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astringC1EPKci($this, $string, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$string;
  $3=$length;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN7astringC2EPKci($4, $5, $6);
  ;
  return;
}


function __ZN7astringC2EPKci($this, $string, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$string;
  $3=$length;
  var $4=$1;
  var $5=$4;
  var $6=__ZN7astring4initEv($4);
  var $7=$2;
  var $8=$3;
  var $9=__ZN7astring3cpyEPKci($6, $7, $8);
  ;
  return;
}


function __ZN13media_auditorC2ERK17driver_enumerator($this, $enumerator) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$enumerator;
  var $3=$1;
  var $4=(($3)|0);
  __ZN11simple_listI12audit_recordEC1ER13resource_pool($4, _global_resource_pool);
  var $5=(($3+20)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($3+24)|0);
  HEAP32[(($7)>>2)]=((STRING_TABLE.__str4804)|0);
  var $8=(($3+28)|0);
  HEAP32[(($8)>>2)]=0;
  ;
  return;
}


function __ZN11simple_listI12audit_recordEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI12audit_recordEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZNK8device_t10searchpathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+180)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN13media_auditor11audit_mediaEPKc($this, $validation) {
  var __stackBase__  = STACKTOP; STACKTOP += 148; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $driverpath;
      var $found;
      var $required;
      var $sharedFound;
      var $sharedRequired;
      var $source;
      var $source_is_gamedrv;
      var $region;
      var $combinedpath=__stackBase__;
      var $3;
      var $4;
      var $rom;
      var $hashes=__stackBase__+64;
      var $shared;
      var $record;
      var $5;
      $1=$this;
      $2=$validation;
      var $6=$1;
      var $7=(($6)|0);
      __ZN11simple_listI12audit_recordE5resetEv($7);
      var $8=$2;
      var $9=(($6+24)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=(($6+20)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=__ZNK17driver_enumerator6configEv($11);
      var $13=__ZNK14machine_config10devicelistEv($12);
      var $14=$13;
      var $15=__ZNK11tagged_listI8device_tE4findEPKc($14, ((STRING_TABLE.__str14805)|0));
      var $16=__ZNK8device_t10searchpathEv($15);
      $driverpath=$16;
      $found=0;
      $required=0;
      $sharedFound=0;
      $sharedRequired=0;
      var $17=(($6+20)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZNK17driver_enumerator6configEv($18);
      var $20=__Z16rom_first_sourceRK14machine_config($19);
      $source=$20;
      __label__ = 1; break;
    case 1: // $21
      var $22=$source;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 2; break; } else { __label__ = 54; break; }
    case 2: // $24
      var $25=$source;
      var $26=__ZNK8device_t10searchpathEv($25);
      var $27=(($6+28)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=$source;
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $30
      var $31=$28;
      var $32=___dynamic_cast($31, __ZTI8device_t, __ZTI13driver_device, -1);
      var $33=$32;
      var $36 = $33;__label__ = 5; break;
    case 4: // $34
      var $36 = 0;__label__ = 5; break;
    case 5: // $35
      var $36;
      var $37=(($36)|0)!=0;
      var $38=(($37)&1);
      $source_is_gamedrv=$38;
      var $39=$source;
      var $40=__Z16rom_first_regionRK8device_t($39);
      $region=$40;
      __label__ = 6; break;
    case 6: // $41
      var $42=$region;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 7; break; } else { __label__ = 52; break; }
    case 7: // $44
      var $45=$source;
      var $46=__ZNK8device_t10searchpathEv($45);
      var $47=$driverpath;
      __ZN7astringC1EPKcS1_S1_($combinedpath, $46, ((STRING_TABLE.__str24806)|0), $47);
      var $48=$region;
      var $49=(($48+16)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$50 & 32768;
      var $52=(($51)|0)==32768;
      if ($52) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $53
      var $54=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($combinedpath, ((STRING_TABLE.__str24806)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $55
      var $56=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($combinedpath, $54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; };
    case 10: // $57
      var $58=$region;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($combinedpath, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $62
      var $63=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($combinedpath, $61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; };
    case 12: // $64
      __label__ = 14; break;
    case 13: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      $3=$67;
      var $68=$66.f1;
      $4=$68;
      __label__ = 50; break;
    case 14: // $69
      var $70=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($combinedpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 13; break; };
    case 15: // $71
      var $72=(($6+28)|0);
      HEAP32[(($72)>>2)]=$70;
      var $73=$region;
      var $74=(function() { try { __THREW__ = false; return __Z14rom_first_filePK9rom_entry($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; };
    case 16: // $75
      $rom=$74;
      __label__ = 17; break;
    case 17: // $76
      var $77=$rom;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 18; break; } else { __label__ = 48; break; }
    case 18: // $79
      var $80=$rom;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($hashes, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 13; break; }
    case 19: // $83
      var $84=(function() { try { __THREW__ = false; return __ZN13media_auditor19also_used_by_parentERK15hash_collection($6, $hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; };
    case 20: // $85
      var $86=(($84)|0) >= 0;
      var $87=(($86)&1);
      $shared=$87;
      var $88=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 24; break; };
    case 21: // $89
      if ($88) { __label__ = 26; break; } else { __label__ = 22; break; }
    case 22: // $90
      var $91=$required;
      var $92=(($91+1)|0);
      $required=$92;
      var $93=$shared;
      var $94=(($93) & 1);
      if ($94) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $95
      var $96=$sharedRequired;
      var $97=(($96+1)|0);
      $sharedRequired=$97;
      __label__ = 25; break;
    case 24: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $100=$99.f0;
      $3=$100;
      var $101=$99.f1;
      $4=$101;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 61; break; }
    case 25: // $102
      __label__ = 26; break;
    case 26: // $103
      $record=0;
      var $104=$region;
      var $105=(($104+16)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$106 & 16384;
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $109
      var $110=$rom;
      var $111=(function() { try { __THREW__ = false; return __ZN13media_auditor13audit_one_romEPK9rom_entry($6, $110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 24; break; };
    case 28: // $112
      $record=$111;
      __label__ = 33; break;
    case 29: // $113
      var $114=$region;
      var $115=(($114+16)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$116 & 16384;
      var $118=(($117)|0)==16384;
      if ($118) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $119
      var $120=$rom;
      var $121=(function() { try { __THREW__ = false; return __ZN13media_auditor14audit_one_diskEPK9rom_entry($6, $120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 24; break; };
    case 31: // $122
      $record=$121;
      __label__ = 32; break;
    case 32: // $123
      __label__ = 33; break;
    case 33: // $124
      var $125=$record;
      var $126=(($125)|0)==0;
      if ($126) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $127
      $5=10;
      __label__ = 42; break;
    case 35: // $128
      var $129=$record;
      var $130=(function() { try { __THREW__ = false; return __ZNK12audit_record6statusEv($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 24; break; };
    case 36: // $131
      var $132=(($130)|0)!=2;
      if ($132) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $133
      var $134=$source_is_gamedrv;
      var $135=(($134) & 1);
      if ($135) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $136
      var $137=$found;
      var $138=(($137+1)|0);
      $found=$138;
      var $139=$shared;
      var $140=(($139) & 1);
      if ($140) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $141
      var $142=$sharedFound;
      var $143=(($142+1)|0);
      $sharedFound=$143;
      __label__ = 40; break;
    case 40: // $144
      __label__ = 41; break;
    case 41: // $145
      $5=0;
      __label__ = 42; break;
    case 42: // $146
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 13; break; }
    case 43: // $147
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0) {
        __label__ = 44; break;
      }
      else if ($cleanup_dest == 10) {
        __label__ = 45; break;
      }
      else {
      __label__ = 62; break;
      }
      
    case 44: // $148
      __label__ = 45; break;
    case 45: // $149
      var $150=$rom;
      var $151=(function() { try { __THREW__ = false; return __Z13rom_next_filePK9rom_entry($150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 13; break; };
    case 46: // $152
      $rom=$151;
      __label__ = 17; break;
    case 47: // $153
      __label__ = 50; break;
    case 48: // $154
      FUNCTION_TABLE[__ZN7astringD1Ev]($combinedpath);
      __label__ = 49; break;
    case 49: // $155
      var $156=$region;
      var $157=__Z15rom_next_regionPK9rom_entry($156);
      $region=$157;
      __label__ = 6; break;
    case 50: // $158
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($combinedpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 61; break; }
    case 51: // $159
      __label__ = 60; break;
    case 52: // $160
      __label__ = 53; break;
    case 53: // $161
      var $162=$source;
      var $163=__Z15rom_next_sourceRK8device_t($162);
      $source=$163;
      __label__ = 1; break;
    case 54: // $164
      var $165=$found;
      var $166=$sharedFound;
      var $167=(($165)|0)==(($166)|0);
      if ($167) { __label__ = 55; break; } else { __label__ = 59; break; }
    case 55: // $168
      var $169=$required;
      var $170=(($169)|0) > 0;
      if ($170) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $171
      var $172=$required;
      var $173=$sharedRequired;
      var $174=(($172)|0)!=(($173)|0);
      if ($174) { __label__ = 58; break; } else { __label__ = 57; break; }
    case 57: // $175
      var $176=$sharedFound;
      var $177=(($176)|0)==0;
      if ($177) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $178
      var $179=(($6)|0);
      __ZN11simple_listI12audit_recordE5resetEv($179);
      __label__ = 59; break;
    case 59: // $180
      var $181=__ZN13media_auditor9summarizeEP7astring($6, 0);
      STACKTOP = __stackBase__;
      return $181;
    case 60: // $182
      var $183=$3;
      var $184=$3;
      var $185=$4;
      var $186=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $184, tempValue);
      var $187=($186.f1 = $185, $186);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 61: // $188
      var $189=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 62: // $190
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor11audit_mediaEPKc["X"]=1;

function __ZN13media_auditor19also_used_by_parentERK15hash_collection($this, $romhashes) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $drvindex;
      var $source;
      var $region;
      var $rom;
      var $hashes=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$romhashes;
      var $7=$2;
      var $8=(($7+20)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($7+20)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=__ZNK17driver_enumerator6driverEv($11);
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZN11driver_list4findEPKc($14);
      $drvindex=$15;
      __label__ = 1; break;
    case 1: // $16
      var $17=$drvindex;
      var $18=(($17)|0)!=-1;
      if ($18) { __label__ = 2; break; } else { __label__ = 25; break; }
    case 2: // $19
      var $20=(($7+20)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$drvindex;
      var $23=__ZNK17driver_enumerator6configEi($21, $22);
      var $24=__Z16rom_first_sourceRK14machine_config($23);
      $source=$24;
      __label__ = 3; break;
    case 3: // $25
      var $26=$source;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 4; break; } else { __label__ = 23; break; }
    case 4: // $28
      var $29=$source;
      var $30=__Z16rom_first_regionRK8device_t($29);
      $region=$30;
      __label__ = 5; break;
    case 5: // $31
      var $32=$region;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 6; break; } else { __label__ = 21; break; }
    case 6: // $34
      var $35=$region;
      var $36=__Z14rom_first_filePK9rom_entry($35);
      $rom=$36;
      __label__ = 7; break;
    case 7: // $37
      var $38=$rom;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 8; break; } else { __label__ = 19; break; }
    case 8: // $40
      var $41=$rom;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($hashes, $43);
      var $44=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $45
      if ($44) { __label__ = 14; break; } else { __label__ = 10; break; }
    case 10: // $46
      var $47=$3;
      var $48=(function() { try { __THREW__ = false; return __ZNK15hash_collectioneqERKS_($hashes, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $49
      if ($48) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $50
      var $51=$drvindex;
      $1=$51;
      $6=1;
      __label__ = 15; break;
    case 13: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $4=$54;
      var $55=$53.f1;
      $5=$55;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 28; break; }
    case 14: // $56
      $6=0;
      __label__ = 15; break;
    case 15: // $57
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes);
      var $cleanup_dest=$6;
      if ($cleanup_dest == 0) {
        __label__ = 16; break;
      }
      else if ($cleanup_dest == 1) {
        __label__ = 26; break;
      }
      else {
      __label__ = 29; break;
      }
      
    case 16: // $58
      __label__ = 17; break;
    case 17: // $59
      var $60=$rom;
      var $61=__Z13rom_next_filePK9rom_entry($60);
      $rom=$61;
      __label__ = 7; break;
    case 18: // $62
      __label__ = 27; break;
    case 19: // $63
      __label__ = 20; break;
    case 20: // $64
      var $65=$region;
      var $66=__Z15rom_next_regionPK9rom_entry($65);
      $region=$66;
      __label__ = 5; break;
    case 21: // $67
      __label__ = 22; break;
    case 22: // $68
      var $69=$source;
      var $70=__Z15rom_next_sourceRK8device_t($69);
      $source=$70;
      __label__ = 3; break;
    case 23: // $71
      __label__ = 24; break;
    case 24: // $72
      var $73=(($7+20)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($7+20)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$drvindex;
      var $78=__ZN11driver_list6driverEi($77);
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=__ZN11driver_list4findEPKc($80);
      $drvindex=$81;
      __label__ = 1; break;
    case 25: // $82
      $1=-1;
      __label__ = 26; break;
    case 26: // $83
      var $84=$1;
      STACKTOP = __stackBase__;
      return $84;
    case 27: // $85
      var $86=$4;
      var $87=$4;
      var $88=$5;
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 28: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 29: // $93
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor19also_used_by_parentERK15hash_collection["X"]=1;

function __ZNK12audit_record6statusEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13media_auditor13audit_one_romEPK9rom_entry($this, $rom) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $record;
      var $12;
      var $13;
      var $crc=__stackBase__+36;
      var $has_crc;
      var $file=__stackBase__+40;
      var $path=__stackBase__+300;
      var $curpath=__stackBase__+312;
      var $filerr;
      var $14;
      $10=$this;
      $11=$rom;
      var $15=$10;
      var $16=(($15)|0);
      var $17=$4;
      var $18=$5;
      var $19=$6;
      var $20=$result_i;
      var $21=$7;
      var $22=$8;
      HEAP32[(($4)>>2)]=204;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str34807)|0);
      HEAP32[(($6)>>2)]=308;
      var $23=HEAP32[(($4)>>2)];
      var $24=HEAP32[(($5)>>2)];
      var $25=HEAP32[(($6)>>2)];
      var $26=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($23, $24, $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $27
      HEAP32[(($result_i)>>2)]=$26;
      var $28=HEAP32[(($result_i)>>2)];
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $30
      var $31=___cxa_allocate_exception(4);
      var $32=$31;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($32);
      (function() { try { __THREW__ = false; return ___cxa_throw($31, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      HEAP32[(($7)>>2)]=$35;
      var $36=$34.f1;
      HEAP32[(($8)>>2)]=$36;
      var $37=HEAP32[(($8)>>2)];
      var $38=(($37)|0) < 0;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($40);
      throw "Reached an unreachable!"
    case 5: // $41
      var $42=HEAP32[(($7)>>2)];
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($8)>>2)];
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $47
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $48=HEAPU32[(($result_i)>>2)];
      var $49=$4;
      var $50=$5;
      var $51=$6;
      var $52=$result_i;
      var $53=$7;
      var $54=$8;
      var $55=$48;
      var $56=$11;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12audit_recordC1ERK9rom_entryNS_10media_typeE]($55, $56, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 8: // $57
      var $58=__ZN13resource_pool10add_objectI12audit_recordEEPT_S3_(_global_resource_pool, $55);
      var $59=__ZN11simple_listI12audit_recordE6appendERS0_($16, $58);
      $record=$59;
      HEAP32[(($crc)>>2)]=0;
      var $60=$record;
      var $61=__ZNK12audit_record15expected_hashesEv($60);
      var $62=__ZNK15hash_collection3crcERj($61, $crc);
      var $63=(($62)&1);
      $has_crc=$63;
      var $64=(($15+20)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=__ZNK17driver_enumerator7optionsEv($65);
      var $67=__ZNK11emu_options10media_pathEv($66);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $67, 17);
      var $68=(($15+28)|0);
      var $69=HEAP32[(($68)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13path_iteratorC1EPKc]($path, $69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 23; break; }
    case 9: // $70
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $71
      __label__ = 11; break;
    case 11: // $72
      var $73=$record;
      var $74=(function() { try { __THREW__ = false; return __ZNK12audit_record4nameEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 24; break; };
    case 12: // $75
      var $76=(function() { try { __THREW__ = false; return __ZN13path_iterator4nextER7astringPKc($path, $curpath, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 24; break; };
    case 13: // $77
      if ($76) { __label__ = 14; break; } else { __label__ = 34; break; }
    case 14: // $78
      var $79=$has_crc;
      var $80=(($79) & 1);
      if ($80) { __label__ = 15; break; } else { __label__ = 25; break; }
    case 15: // $81
      var $82=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 24; break; };
    case 16: // $83
      var $84=HEAP32[(($crc)>>2)];
      var $85=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcj($file, $82, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 24; break; };
    case 17: // $86
      $filerr=$85;
      __label__ = 28; break;
    case 18: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      $12=$89;
      var $90=$88.f1;
      $13=$90;
      var $91=$1;
      var $92=$2;
      var $93=$3;
      HEAP32[(($1)>>2)]=$48;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str34807)|0);
      HEAP32[(($3)>>2)]=308;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $96
      var $97=HEAP32[(($1)>>2)];
      var $98=HEAP32[(($2)>>2)];
      var $99=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($97, $98, $99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 42; break; }
    case 20: // $_noexc
      __label__ = 21; break;
    case 21: // $_ZdlPvPKci_exit
      var $100=$1;
      var $101=$2;
      var $102=$3;
      __label__ = 22; break;
    case 22: // $103
      __label__ = 41; break;
    case 23: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $106=$105.f0;
      $12=$106;
      var $107=$105.f1;
      $13=$107;
      __label__ = 39; break;
    case 24: // $108
      var $109=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $110=$109.f0;
      $12=$110;
      var $111=$109.f1;
      $13=$111;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 25: // $112
      var $113=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 24; break; };
    case 26: // $114
      var $115=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 24; break; };
    case 27: // $116
      $filerr=$115;
      __label__ = 28; break;
    case 28: // $117
      var $118=$filerr;
      var $119=(($118)|0)==0;
      if ($119) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $120
      var $121=$record;
      var $122=(($15+24)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(function() { try { __THREW__ = false; return __ZN8emu_file6hashesEPKc($file, $123) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 24; break; };
    case 30: // $125
      var $126=(function() { try { __THREW__ = false; return __ZN8emu_file4sizeEv($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 24; break; };
      var $126$0=$126[0];
      var $126$1=$126[1];
    case 31: // $127
      (function() { try { __THREW__ = false; return __ZN12audit_record10set_actualERK15hash_collectiony($121, $124, $126$0, $126$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 24; break; }
    case 32: // $128
      __label__ = 34; break;
    case 33: // $129
      __label__ = 11; break;
    case 34: // $130
      var $131=$record;
      var $132=$11;
      var $133=$record;
      var $134=(function() { try { __THREW__ = false; return __ZNK12audit_record13actual_lengthEv($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 24; break; };
      var $134$0=$134[0];
      var $134$1=$134[1];
    case 35: // $135
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $136=$134$0 != $$emscripten$temp$0$0 || $134$1 != $$emscripten$temp$0$1;
      (function() { try { __THREW__ = false; return __ZN13media_auditor14compute_statusER12audit_recordPK9rom_entryb($15, $131, $132, $136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 24; break; }
    case 36: // $137
      var $138=$record;
      $9=$138;
      $14=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 23; break; }
    case 37: // $139
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      var $140=$9;
      STACKTOP = __stackBase__;
      return $140;
    case 38: // $141
      __label__ = 39; break;
    case 39: // $142
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $143
      __label__ = 41; break;
    case 41: // $144
      var $145=$12;
      var $146=$12;
      var $147=$13;
      var $148=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $146, tempValue);
      var $149=($148.f1 = $147, $148);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $150
      var $151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor13audit_one_romEPK9rom_entry["X"]=1;

function __ZN13media_auditor14audit_one_diskEPK9rom_entry($this, $rom) {
  var __stackBase__  = STACKTOP; STACKTOP += 276; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $record;
      var $11;
      var $12;
      var $source_file=__stackBase__+36;
      var $source=__stackBase__+40;
      var $err;
      var $header=__stackBase__+44;
      var $hashes=__stackBase__+192;
      $9=$this;
      $10=$rom;
      var $13=$9;
      var $14=(($13)|0);
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=204;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str34807)|0);
      HEAP32[(($6)>>2)]=348;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$10;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12audit_recordC1ERK9rom_entryNS_10media_typeE]($53, $54, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $55
      var $56=__ZN13resource_pool10add_objectI12audit_recordEEPT_S3_(_global_resource_pool, $53);
      var $57=__ZN11simple_listI12audit_recordE6appendERS0_($14, $56);
      $record=$57;
      var $58=(($13+20)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=__ZNK17driver_enumerator7optionsEv($59);
      var $61=(($13+20)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__ZNK17driver_enumerator6driverEv($62);
      var $64=$10;
      var $65=__Z15open_disk_imageR11emu_optionsPK11game_driverPK9rom_entryPP8emu_filePP9_chd_filePKc($60, $63, $64, $source_file, $source, 0);
      $err=$65;
      var $66=$err;
      var $67=(($66)|0)==0;
      if ($67) { __label__ = 9; break; } else { __label__ = 28; break; }
    case 9: // $68
      var $69=HEAP32[(($source)>>2)];
      var $70=__Z14chd_get_headerP9_chd_file($69);
      var $71=$header;
      var $72=$70;
      assert(148 % 1 === 0, 'memcpy given ' + 148 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $72>>2, $$dest = $71>>2, $$stop = $$src + 37; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($hashes);
      var $73=(($header+40)|0);
      var $74=(($73)|0);
      var $75=(function() { try { __THREW__ = false; return _memcmp(((__ZZN13media_auditor14audit_one_diskEPK9rom_entryE8nullhash)|0), $74, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 18; break; };
    case 10: // $76
      var $77=(($75)|0)!=0;
      if ($77) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $78
      var $79=(($header+40)|0);
      var $80=(($79)|0);
      var $81=(function() { try { __THREW__ = false; return __ZN15hash_collection15add_from_bufferEcPKhi($hashes, 77, $80, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 18; break; };
    case 12: // $82
      __label__ = 19; break;
    case 13: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $85=$84.f0;
      $11=$85;
      var $86=$84.f1;
      $12=$86;
      var $87=$1;
      var $88=$2;
      var $89=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str34807)|0);
      HEAP32[(($3)>>2)]=348;
      var $90=HEAP32[(($1)>>2)];
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $92
      var $93=HEAP32[(($1)>>2)];
      var $94=HEAP32[(($2)>>2)];
      var $95=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($93, $94, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 30; break; }
    case 15: // $_noexc
      __label__ = 16; break;
    case 16: // $_ZdlPvPKci_exit
      var $96=$1;
      var $97=$2;
      var $98=$3;
      __label__ = 17; break;
    case 17: // $99
      __label__ = 29; break;
    case 18: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $11=$102;
      var $103=$101.f1;
      $12=$103;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 19: // $104
      var $105=(($header+72)|0);
      var $106=(($105)|0);
      var $107=(function() { try { __THREW__ = false; return _memcmp(((__ZZN13media_auditor14audit_one_diskEPK9rom_entryE8nullhash)|0), $106, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 18; break; };
    case 20: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $110
      var $111=(($header+72)|0);
      var $112=(($111)|0);
      var $113=(function() { try { __THREW__ = false; return __ZN15hash_collection15add_from_bufferEcPKhi($hashes, 83, $112, 20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 18; break; };
    case 22: // $114
      __label__ = 23; break;
    case 23: // $115
      var $116=$record;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      (function() { try { __THREW__ = false; return __ZN12audit_record10set_actualERK15hash_collectiony($116, $hashes, $$emscripten$temp$0$0, $$emscripten$temp$0$1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 18; break; }
    case 24: // $117
      var $118=HEAP32[(($source)>>2)];
      (function() { try { __THREW__ = false; return __Z9chd_closeP9_chd_file($118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 18; break; }
    case 25: // $119
      var $120=HEAP32[(($source_file)>>2)];
      var $121=$120;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv(_global_resource_pool, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 18; break; }
    case 26: // $122
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes);
      __label__ = 28; break;
    case 27: // $123
      __label__ = 29; break;
    case 28: // $124
      var $125=$record;
      var $126=$10;
      var $127=$err;
      var $128=(($127)|0)==0;
      __ZN13media_auditor14compute_statusER12audit_recordPK9rom_entryb($13, $125, $126, $128);
      var $129=$record;
      STACKTOP = __stackBase__;
      return $129;
    case 29: // $130
      var $131=$11;
      var $132=$11;
      var $133=$12;
      var $134=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $132, tempValue);
      var $135=($134.f1 = $133, $134);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor14audit_one_diskEPK9rom_entry["X"]=1;

function __ZN13media_auditor9summarizeEP7astring($this, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $overall_status;
      var $record;
      var $best_new_status;
      var $tempstr=__stackBase__;
      var $4;
      var $5;
      $2=$this;
      $3=$string;
      var $6=$2;
      var $7=(($6)|0);
      var $8=__ZNK11simple_listI12audit_recordE5countEv($7);
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=4;
      __label__ = 53; break;
    case 2: // $11
      $overall_status=0;
      var $12=(($6)|0);
      var $13=__ZNK11simple_listI12audit_recordE5firstEv($12);
      $record=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$record;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 52; break; }
    case 4: // $17
      $best_new_status=3;
      var $18=$record;
      var $19=__ZNK12audit_record9substatusEv($18);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      __label__ = 51; break;
    case 6: // $22
      var $23=$3;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $25
      var $26=$3;
      var $27=(($6+20)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=__ZNK17driver_enumerator6driverEv($28);
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$record;
      var $33=__ZNK12audit_record4nameEv($32);
      var $34=__ZN7astring9catprintfEPKcz($26, ((STRING_TABLE.__str44808)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$33,tempInt));
      var $35=$record;
      var $36=__ZNK12audit_record15expected_lengthEv($35);
      var $36$0=$36[0];
      var $36$1=$36[1];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $37=$36$1 > $$emscripten$temp$0$1 || ($36$1 == $$emscripten$temp$0$1 && $36$0 > $$emscripten$temp$0$0);
      if ($37) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $38
      var $39=$3;
      var $40=$record;
      var $41=__ZNK12audit_record15expected_lengthEv($40);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $$emscripten$temp$1=((STRING_TABLE.__str54809)|0);
      var $42=__ZN7astring9catprintfEPKcz($39, $$emscripten$temp$1, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$41$0,HEAP32[((tempInt+4)>>2)]=$41$1,tempInt));
      __label__ = 9; break;
    case 9: // $43
      var $44=$3;
      var $45=__ZN7astring9catprintfEPKcz($44, ((STRING_TABLE.__str64810)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 10; break;
    case 10: // $46
      var $47=$record;
      var $48=__ZNK12audit_record9substatusEv($47);
      if ($48 == 1) {
        __label__ = 11; break;
      }
      else if ($48 == 2) {
        __label__ = 14; break;
      }
      else if ($48 == 3) {
        __label__ = 17; break;
      }
      else if ($48 == 4) {
        __label__ = 29; break;
      }
      else if ($48 == 5) {
        __label__ = 32; break;
      }
      else if ($48 == 6) {
        __label__ = 35; break;
      }
      else if ($48 == 7) {
        __label__ = 38; break;
      }
      else if ($48 == 8) {
        __label__ = 41; break;
      }
      else if ($48 == 9) {
        __label__ = 44; break;
      }
      else {
      __label__ = 47; break;
      }
      
    case 11: // $49
      var $50=$3;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $52
      var $53=$3;
      var $54=__ZN7astring9catprintfEPKcz($53, ((STRING_TABLE.__str74811)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 13; break;
    case 13: // $55
      $best_new_status=2;
      __label__ = 50; break;
    case 14: // $56
      var $57=$3;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $59
      var $60=$3;
      var $61=__ZN7astring9catprintfEPKcz($60, ((STRING_TABLE.__str84812)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 16: // $62
      $best_new_status=2;
      __label__ = 50; break;
    case 17: // $63
      var $64=$3;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 18; break; } else { __label__ = 28; break; }
    case 18: // $66
      __ZN7astringC1Ev($tempstr);
      var $67=$3;
      var $68=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($67, ((STRING_TABLE.__str94813)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 26; break; };
    case 19: // $69
      var $70=$3;
      var $71=$record;
      var $72=(function() { try { __THREW__ = false; return __ZNK12audit_record15expected_hashesEv($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 26; break; };
    case 20: // $73
      var $74=(function() { try { __THREW__ = false; return __ZNK15hash_collection12macro_stringER7astring($72, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 26; break; };
    case 21: // $75
      var $76=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($70, ((STRING_TABLE.__str104814)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 26; break; };
    case 22: // $77
      var $78=$3;
      var $79=$record;
      var $80=(function() { try { __THREW__ = false; return __ZNK12audit_record13actual_hashesEv($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 26; break; };
    case 23: // $81
      var $82=(function() { try { __THREW__ = false; return __ZNK15hash_collection12macro_stringER7astring($80, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; };
    case 24: // $83
      var $84=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($78, ((STRING_TABLE.__str114815)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 26; break; };
    case 25: // $85
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      __label__ = 28; break;
    case 26: // $86
      var $87=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $88=$87.f0;
      $4=$88;
      var $89=$87.f1;
      $5=$89;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 55; break; }
    case 27: // $90
      __label__ = 54; break;
    case 28: // $91
      __label__ = 50; break;
    case 29: // $92
      var $93=$3;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $95
      var $96=$3;
      var $97=$record;
      var $98=__ZNK12audit_record13actual_lengthEv($97);
      var $98$0=$98[0];
      var $98$1=$98[1];
      var $$emscripten$temp$2=((STRING_TABLE.__str124816)|0);
      var $99=__ZN7astring9catprintfEPKcz($96, $$emscripten$temp$2, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$98$0,HEAP32[((tempInt+4)>>2)]=$98$1,tempInt));
      __label__ = 31; break;
    case 31: // $100
      __label__ = 50; break;
    case 32: // $101
      var $102=$3;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $104
      var $105=$3;
      var $106=__ZN7astring9catprintfEPKcz($105, ((STRING_TABLE.__str134817)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 34; break;
    case 34: // $107
      __label__ = 50; break;
    case 35: // $108
      var $109=$3;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $111
      var $112=$3;
      var $113=__ZN7astring9catprintfEPKcz($112, ((STRING_TABLE.__str144818)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 37; break;
    case 37: // $114
      $best_new_status=2;
      __label__ = 50; break;
    case 38: // $115
      var $116=$3;
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $118
      var $119=$3;
      var $120=__ZN7astring9catprintfEPKcz($119, ((STRING_TABLE.__str154819)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 40; break;
    case 40: // $121
      $best_new_status=2;
      __label__ = 50; break;
    case 41: // $122
      var $123=$3;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $125
      var $126=$3;
      var $127=__ZN7astring9catprintfEPKcz($126, ((STRING_TABLE.__str164820)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 43; break;
    case 43: // $128
      __label__ = 50; break;
    case 44: // $129
      var $130=$3;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $132
      var $133=$3;
      var $134=__ZN7astring9catprintfEPKcz($133, ((STRING_TABLE.__str174821)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 46; break;
    case 46: // $135
      __label__ = 50; break;
    case 47: // $136
      __label__ = 48; break;
    case 48: // $137
      __label__ = 49; break;
    case 49: // $138
      __label__ = 50; break;
    case 50: // $139
      var $140=$overall_status;
      var $141=$best_new_status;
      var $142=(($140)|0) > (($141)|0);
      var $143=$overall_status;
      var $144=$best_new_status;
      var $145=$142 ? $143 : $144;
      $overall_status=$145;
      __label__ = 51; break;
    case 51: // $146
      var $147=$record;
      var $148=__ZNK12audit_record4nextEv($147);
      $record=$148;
      __label__ = 3; break;
    case 52: // $149
      var $150=$overall_status;
      $1=$150;
      __label__ = 53; break;
    case 53: // $151
      var $152=$1;
      STACKTOP = __stackBase__;
      return $152;
    case 54: // $153
      var $154=$4;
      var $155=$4;
      var $156=$5;
      var $157=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $155, tempValue);
      var $158=($157.f1 = $156, $157);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 55: // $159
      var $160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor9summarizeEP7astring["X"]=1;

function __ZN11simple_listI12audit_recordE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($this, $status, $substatus) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$status;
  $3=$substatus;
  var $4=$1;
  var $5=$2;
  var $6=(($4+8)|0);
  HEAP32[(($6)>>2)]=$5;
  var $7=$3;
  var $8=(($4+12)|0);
  HEAP32[(($8)>>2)]=$7;
  ;
  return;
}


function __ZNK11simple_listI12audit_recordE5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI12audit_recordE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12audit_record9substatusEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12audit_record4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12audit_record15expected_lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZNK12audit_record15expected_hashesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+36)|0);
  ;
  return $3;
}


function __ZNK12audit_record13actual_hashesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+120)|0);
  ;
  return $3;
}


function __ZNK12audit_record13actual_lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZNK12audit_record4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11emu_options11sample_pathEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str194823)|0));
  ;
  return $4;
}


function __ZN12audit_record10set_actualERK15hash_collectiony($this, $hashes, $length$0, $length$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  $1=$this;
  $2=$hashes;
  var $st$5$0=(($3)|0);
  HEAP32[(($st$5$0)>>2)]=$length$0;
  var $st$5$1=(($3+4)|0);
  HEAP32[(($st$5$1)>>2)]=$length$1;
  var $4=$1;
  var $5=(($4+120)|0);
  var $6=$2;
  var $7=__ZN15hash_collectionaSERKS_($5, $6);
  var $st$13$0=(($3)|0);
  var $8$0=HEAP32[(($st$13$0)>>2)];
  var $st$13$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$13$1)>>2)];
  var $9=(($4+28)|0);
  var $st$18$0=(($9)|0);
  HEAP32[(($st$18$0)>>2)]=$8$0;
  var $st$18$1=(($9+4)|0);
  HEAP32[(($st$18$1)>>2)]=$8$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZN13media_auditor14compute_statusER12audit_recordPK9rom_entryb($this, $record, $rom, $found) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $parent;
      $1=$this;
      $2=$record;
      $3=$rom;
      var $5=(($found)&1);
      $4=$5;
      var $6=$1;
      var $7=$4;
      var $8=(($7) & 1);
      if ($8) { __label__ = 14; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=__ZNK12audit_record15expected_hashesEv($10);
      var $12=__ZNK15hash_collection4flagEc($11, 33);
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($14, 2, 6);
      __label__ = 13; break;
    case 3: // $15
      var $16=$3;
      var $17=(($16+16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18 & 32;
      var $20=(($19)|0)==32;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      var $22=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($22, 2, 7);
      __label__ = 12; break;
    case 5: // $23
      var $24=$2;
      var $25=__ZNK12audit_record15expected_hashesEv($24);
      var $26=__ZN13media_auditor19also_used_by_parentERK15hash_collection($6, $25);
      $parent=$26;
      var $27=(($26)|0)!=-1;
      if ($27) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $28
      var $29=(($6+20)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$parent;
      var $32=__ZN11driver_list6driverEi($31);
      var $33=(($32+44)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34 & 4096;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $37
      var $38=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($38, 2, 9);
      __label__ = 9; break;
    case 8: // $39
      var $40=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($40, 2, 8);
      __label__ = 9; break;
    case 9: // $41
      __label__ = 11; break;
    case 10: // $42
      var $43=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($43, 2, 5);
      __label__ = 11; break;
    case 11: // $44
      __label__ = 12; break;
    case 12: // $45
      __label__ = 13; break;
    case 13: // $46
      __label__ = 27; break;
    case 14: // $47
      var $48=$2;
      var $49=__ZNK12audit_record15expected_lengthEv($48);
      var $49$0=$49[0];
      var $49$1=$49[1];
      var $50=$2;
      var $51=__ZNK12audit_record13actual_lengthEv($50);
      var $51$0=$51[0];
      var $51$1=$51[1];
      var $52=$49$0 != $51$0 || $49$1 != $51$1;
      if ($52) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $53
      var $54=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($54, 1, 4);
      __label__ = 26; break;
    case 16: // $55
      var $56=$2;
      var $57=__ZNK12audit_record15expected_hashesEv($56);
      var $58=__ZNK15hash_collection4flagEc($57, 33);
      if ($58) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $59
      var $60=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($60, 0, 2);
      __label__ = 25; break;
    case 18: // $61
      var $62=$2;
      var $63=__ZNK12audit_record15expected_hashesEv($62);
      var $64=$2;
      var $65=__ZNK12audit_record13actual_hashesEv($64);
      var $66=__ZNK15hash_collectionneERKS_($63, $65);
      if ($66) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $67
      var $68=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($68, 1, 3);
      __label__ = 24; break;
    case 20: // $69
      var $70=$2;
      var $71=__ZNK12audit_record15expected_hashesEv($70);
      var $72=__ZNK15hash_collection4flagEc($71, 94);
      if ($72) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $73
      var $74=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($74, 0, 1);
      __label__ = 23; break;
    case 22: // $75
      var $76=$2;
      __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($76, 0, 0);
      __label__ = 23; break;
    case 23: // $77
      __label__ = 24; break;
    case 24: // $78
      __label__ = 25; break;
    case 25: // $79
      __label__ = 26; break;
    case 26: // $80
      __label__ = 27; break;
    case 27: // $81
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor14compute_statusER12audit_recordPK9rom_entryb["X"]=1;

function __ZN13media_auditor13audit_samplesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 436; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $device;
      var $intf;
      var $searchpath=__stackBase__+36;
      var $sampnum;
      var $10;
      var $11;
      var $record;
      var $file=__stackBase__+100;
      var $path=__stackBase__+360;
      var $curpath=__stackBase__+372;
      var $filerr;
      $9=$this;
      var $12=$9;
      var $13=(($12)|0);
      __ZN11simple_listI12audit_recordE5resetEv($13);
      var $14=(($12+20)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNK17driver_enumerator6configEv($15);
      var $17=__ZNK14machine_config12first_deviceEv($16);
      $device=$17;
      __label__ = 1; break;
    case 1: // $18
      var $19=$device;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 61; break; }
    case 2: // $21
      var $22=$device;
      var $23=__ZNK8device_t4typeEv($22);
      var $24=HEAP32[((_SAMPLES)>>2)];
      var $25=(($23)|0)==(($24)|0);
      if ($25) { __label__ = 3; break; } else { __label__ = 59; break; }
    case 3: // $26
      var $27=$device;
      var $28=__ZNK8device_t13static_configEv($27);
      var $29=$28;
      $intf=$29;
      var $30=$intf;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 4; break; } else { __label__ = 58; break; }
    case 4: // $34
      var $35=(($12+20)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=__ZNK17driver_enumerator6driverEv($36);
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      __ZN7astringC1EPKc($searchpath, $39);
      $sampnum=0;
      __label__ = 5; break;
    case 5: // $40
      var $41=$sampnum;
      var $42=$intf;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+($41<<2))|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 6; break; } else { __label__ = 55; break; }
    case 6: // $48
      var $49=$sampnum;
      var $50=$intf;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+($49<<2))|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0);
      var $56=HEAP8[($55)];
      var $57=(($56 << 24) >> 24);
      var $58=(($57)|0)==42;
      if ($58) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $59
      var $60=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($searchpath, ((STRING_TABLE.__str24806)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $61
      var $62=$sampnum;
      var $63=$intf;
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+($62<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+1)|0);
      var $69=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($60, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; };
    case 9: // $70
      __label__ = 51; break;
    case 10: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $72;__label__ = 11; break;
    case 11: // $_body
      var $eh_lpad_body;
      var $73=$eh_lpad_body.f0;
      $10=$73;
      var $74=$eh_lpad_body.f1;
      $11=$74;
      __label__ = 56; break;
    case 12: // $75
      var $76=(($12)|0);
      var $77=$4;
      var $78=$5;
      var $79=$6;
      var $80=$result_i;
      var $81=$7;
      var $82=$8;
      HEAP32[(($4)>>2)]=204;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str34807)|0);
      HEAP32[(($6)>>2)]=187;
      var $83=HEAP32[(($4)>>2)];
      var $84=HEAP32[(($5)>>2)];
      var $85=HEAP32[(($6)>>2)];
      var $86=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($83, $84, $85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $87
      HEAP32[(($result_i)>>2)]=$86;
      var $88=HEAP32[(($result_i)>>2)];
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $90
      var $91=___cxa_allocate_exception(4);
      var $92=$91;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($92);
      (function() { try { __THREW__ = false; return ___cxa_throw($91, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; }
    case 15: // $93
      var $94=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $95=$94.f0;
      HEAP32[(($7)>>2)]=$95;
      var $96=$94.f1;
      HEAP32[(($8)>>2)]=$96;
      var $97=HEAP32[(($8)>>2)];
      var $98=(($97)|0) < 0;
      if ($98) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $99
      var $100=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 10; break; }
    case 17: // $_noexc
      throw "Reached an unreachable!"
    case 18: // $101
      var $102=HEAP32[(($7)>>2)];
      var $103=HEAP32[(($7)>>2)];
      var $104=HEAP32[(($8)>>2)];
      var $105=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $103, tempValue);
      var $106=($105.f1 = $104, $105);
      var $eh_lpad_body = $106;__label__ = 11; break;
    case 19: // $107
      throw "Reached an unreachable!"
    case 20: // $_ZnwjPKci_exit
      var $108=HEAP32[(($result_i)>>2)];
      var $109=$4;
      var $110=$5;
      var $111=$6;
      var $112=$result_i;
      var $113=$7;
      var $114=$8;
      __label__ = 21; break;
    case 21: // $115
      var $116=$108;
      var $117=$sampnum;
      var $118=$intf;
      var $119=(($118+4)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+($117<<2))|0);
      var $122=HEAP32[(($121)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12audit_recordC1EPKcNS_10media_typeE]($116, $122, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 38; break; }
    case 22: // $123
      var $124=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI12audit_recordEEPT_S3_(_global_resource_pool, $116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 10; break; };
    case 23: // $125
      var $126=(function() { try { __THREW__ = false; return __ZN11simple_listI12audit_recordE6appendERS0_($76, $124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 10; break; };
    case 24: // $127
      $record=$126;
      var $128=(($12+20)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator7optionsEv($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 10; break; };
    case 25: // $131
      var $132=(function() { try { __THREW__ = false; return __ZNK11emu_options11sample_pathEv($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 10; break; };
    case 26: // $133
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $132, 17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 10; break; }
    case 27: // $134
      var $135=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($searchpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 43; break; };
    case 28: // $136
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13path_iteratorC1EPKc]($path, $135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 43; break; }
    case 29: // $137
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 43; break; }
    case 30: // $138
      __label__ = 31; break;
    case 31: // $139
      var $140=$sampnum;
      var $141=$intf;
      var $142=(($141+4)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+($140<<2))|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(function() { try { __THREW__ = false; return __ZN13path_iterator4nextER7astringPKc($path, $curpath, $145) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 44; break; };
    case 32: // $147
      if ($146) { __label__ = 33; break; } else { __label__ = 48; break; }
    case 33: // $148
      var $149=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 44; break; };
    case 34: // $150
      var $151=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 44; break; };
    case 35: // $152
      $filerr=$151;
      var $153=$filerr;
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 36; break; } else { __label__ = 45; break; }
    case 36: // $155
      var $156=$record;
      (function() { try { __THREW__ = false; return __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($156, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 44; break; }
    case 37: // $157
      __label__ = 47; break;
    case 38: // $158
      var $159=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $160=$159.f0;
      $10=$160;
      var $161=$159.f1;
      $11=$161;
      var $162=$1;
      var $163=$2;
      var $164=$3;
      HEAP32[(($1)>>2)]=$108;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str34807)|0);
      HEAP32[(($3)>>2)]=187;
      var $165=HEAP32[(($1)>>2)];
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $167
      var $168=HEAP32[(($1)>>2)];
      var $169=HEAP32[(($2)>>2)];
      var $170=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($168, $169, $170) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 63; break; }
    case 40: // $_noexc1
      __label__ = 41; break;
    case 41: // $_ZdlPvPKci_exit
      var $171=$1;
      var $172=$2;
      var $173=$3;
      __label__ = 42; break;
    case 42: // $174
      __label__ = 56; break;
    case 43: // $175
      var $176=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $177=$176.f0;
      $10=$177;
      var $178=$176.f1;
      $11=$178;
      __label__ = 53; break;
    case 44: // $179
      var $180=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $181=$180.f0;
      $10=$181;
      var $182=$180.f1;
      $11=$182;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 63; break; }
    case 45: // $183
      var $184=$record;
      (function() { try { __THREW__ = false; return __ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE($184, 2, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 44; break; }
    case 46: // $185
      __label__ = 47; break;
    case 47: // $186
      __label__ = 31; break;
    case 48: // $187
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($curpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 43; break; }
    case 49: // $188
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 10; break; }
    case 50: // $189
      __label__ = 51; break;
    case 51: // $190
      var $191=$sampnum;
      var $192=(($191+1)|0);
      $sampnum=$192;
      __label__ = 5; break;
    case 52: // $193
      __label__ = 53; break;
    case 53: // $194
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 63; break; }
    case 54: // $195
      __label__ = 56; break;
    case 55: // $196
      FUNCTION_TABLE[__ZN7astringD1Ev]($searchpath);
      __label__ = 58; break;
    case 56: // $197
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($searchpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 63; break; }
    case 57: // $198
      __label__ = 62; break;
    case 58: // $199
      __label__ = 59; break;
    case 59: // $200
      __label__ = 60; break;
    case 60: // $201
      var $202=$device;
      var $203=__ZNK8device_t4nextEv($202);
      $device=$203;
      __label__ = 1; break;
    case 61: // $204
      var $205=__ZN13media_auditor9summarizeEP7astring($12, 0);
      STACKTOP = __stackBase__;
      return $205;
    case 62: // $206
      var $207=$10;
      var $208=$10;
      var $209=$11;
      var $210=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $208, tempValue);
      var $211=($210.f1 = $209, $210);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 63: // $212
      var $213=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13media_auditor13audit_samplesEv["X"]=1;

function __ZN13resource_pool10add_objectI12audit_recordEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12audit_recordEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12audit_recordEEPT_S3_["X"]=1;

function __ZN12audit_recordC2ERK9rom_entryNS_10media_typeE($this, $media, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$media;
      $3=$type;
      var $6=$1;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=(($6+4)|0);
      var $9=$3;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($6+8)|0);
      HEAP32[(($10)>>2)]=3;
      var $11=(($6+12)|0);
      HEAP32[(($11)>>2)]=100;
      var $12=(($6+16)|0);
      var $13=$2;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      HEAP32[(($12)>>2)]=$15;
      var $16=(($6+20)|0);
      var $17=$2;
      var $18=__Z13rom_file_sizePK9rom_entry($17);
      var $19$0=$18;
      var $19$1=0;
      var $st$28$0=(($16)|0);
      HEAP32[(($st$28$0)>>2)]=$19$0;
      var $st$28$1=(($16+4)|0);
      HEAP32[(($st$28$1)>>2)]=$19$1;
      var $20=(($6+28)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$35$0=(($20)|0);
      HEAP32[(($st$35$0)>>2)]=$$emscripten$temp$0$0;
      var $st$35$1=(($20+4)|0);
      HEAP32[(($st$35$1)>>2)]=$$emscripten$temp$0$1;
      var $21=(($6+36)|0);
      FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($21);
      var $22=(($6+120)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $23
      var $24=(($6+36)|0);
      var $25=$2;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(function() { try { __THREW__ = false; return __ZN15hash_collection20from_internal_stringEPKc($24, $27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $29
      ;
      return;
    case 3: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $4=$32;
      var $33=$31.f1;
      $5=$33;
      __label__ = 6; break;
    case 4: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $36=$35.f0;
      $4=$36;
      var $37=$35.f1;
      $5=$37;
      var $38=(($6+120)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $39
      __label__ = 6; break;
    case 6: // $40
      var $41=(($6+36)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      var $44=$4;
      var $45=$4;
      var $46=$5;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12audit_recordC2ERK9rom_entryNS_10media_typeE["X"]=1;

function __ZN11simple_listI12audit_recordEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI12audit_recordE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN20resource_pool_objectI12audit_recordEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12audit_recordEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12audit_recordEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 204);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12audit_recordE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12audit_recordED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12audit_recordED2Ev($2);
  ;
  return;
}


function __ZN12audit_recordD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12audit_recordD2Ev($2);
  ;
  return;
}


function __ZN13video_managerC2ER15running_machine($this, $machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 120; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+24;
      var $5=__stackBase__+32;
      var $6=__stackBase__+56;
      var $viewname;
      var $filename;
      var $7=__stackBase__+64;
      var $8=__stackBase__+88;
      var $9=__stackBase__+96;
      var $10=__stackBase__+108;
      $1=$this;
      $2=$machine;
      var $11=$1;
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($11+4)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=(($11+8)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$23$0=(($15)|0);
      HEAP32[(($st$23$0)>>2)]=$$emscripten$temp$0$0;
      var $st$23$1=(($15+4)|0);
      HEAP32[(($st$23$1)>>2)]=$$emscripten$temp$0$1;
      var $16=(($11+16)|0);
      var $17=$16;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($17+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($17+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $18=(($11+28)|0);
      var $19=$18;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $20=(($11+40)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($11+44)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$38$0=(($21)|0);
      HEAP32[(($st$38$0)>>2)]=$$emscripten$temp$1$0;
      var $st$38$1=(($21+4)|0);
      HEAP32[(($st$38$1)>>2)]=$$emscripten$temp$1$1;
      var $22=(($11+52)|0);
      var $23=$22;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($23)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($23+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($23+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $24=(($11+64)|0);
      (tempDoubleF64[0]=1,HEAP32[(($24)>>2)]=tempDoubleI32[0],HEAP32[(($24+4)>>2)]=tempDoubleI32[1]);
      var $25=(($11+72)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=(($11+76)|0);
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$52$0=(($26)|0);
      HEAP32[(($st$52$0)>>2)]=$$emscripten$temp$2$0;
      var $st$52$1=(($26+4)|0);
      HEAP32[(($st$52$1)>>2)]=$$emscripten$temp$2$1;
      var $27=(($11+84)|0);
      var $28=$27;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($28)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($28+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($28+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $29=(($11+96)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($11+100)|0);
      var $31=$2;
      var $32=__ZNK15running_machine7optionsEv($31);
      var $33=__ZNK11emu_options8throttleEv($32);
      var $34=(($33)&1);
      HEAP8[($30)]=$34;
      var $35=(($11+101)|0);
      HEAP8[($35)]=0;
      var $36=(($11+104)|0);
      var $37=$2;
      var $38=__ZNK15running_machine7optionsEv($37);
      var $39=__ZNK11emu_options14seconds_to_runEv($38);
      HEAP32[(($36)>>2)]=$39;
      var $40=(($11+108)|0);
      var $41=$2;
      var $42=__ZNK15running_machine7optionsEv($41);
      var $43=__ZNK11emu_options14auto_frameskipEv($42);
      var $44=(($43)&1);
      HEAP8[($40)]=$44;
      var $45=(($11+112)|0);
      var $46=__ZNK13video_manager22original_speed_settingEv($11);
      HEAP32[(($45)>>2)]=$46;
      var $47=(($11+116)|0);
      HEAP8[($47)]=0;
      var $48=(($11+117)|0);
      var $49=$2;
      var $50=__ZNK15running_machine7optionsEv($49);
      var $51=__ZNK11emu_options9frameskipEv($50);
      var $52=(($51) & 255);
      HEAP8[($48)]=$52;
      var $53=(($11+118)|0);
      HEAP8[($53)]=0;
      var $54=(($11+119)|0);
      HEAP8[($54)]=0;
      var $55=(($11+120)|0);
      HEAP8[($55)]=0;
      var $56=(($11+124)|0);
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $st$100$0=(($56)|0);
      HEAP32[(($st$100$0)>>2)]=$$emscripten$temp$3$0;
      var $st$100$1=(($56+4)|0);
      HEAP32[(($st$100$1)>>2)]=$$emscripten$temp$3$1;
      var $57=(($11+132)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=(($11+136)|0);
      HEAP32[(($58)>>2)]=0;
      var $59=(($11+140)|0);
      HEAP8[($59)]=1;
      var $60=(($11+144)|0);
      HEAP32[(($60)>>2)]=0;
      var $61=(($11+148)|0);
      HEAP32[(($61)>>2)]=0;
      var $62=(($11+152)|0);
      HEAP32[(($62)>>2)]=0;
      var $63=(($11+156)|0);
      HEAP32[(($63)>>2)]=0;
      var $64=(($11+160)|0);
      var $65=$64;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($65)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($65+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($65+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $66=(($11+172)|0);
      var $67=$66;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($67)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($67+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($67+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $68=(($11+184)|0);
      HEAP32[(($68)>>2)]=0;
      var $69=$2;
      HEAP32[(($4)>>2)]={ f0: 1118, f1: 0 }.f0; HEAP32[(($4+4)>>2)]={ f0: 1118, f1: 0 }.f1;
      __ZN8delegateIFvvEEC1I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($3, $4, ((STRING_TABLE.__str4834)|0), $11);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($69, 4, $3);
      var $70=$2;
      var $71=__ZN15running_machine4saveEv($70);
      HEAP32[(($6)>>2)]={ f0: 1120, f1: 0 }.f0; HEAP32[(($6+4)>>2)]={ f0: 1120, f1: 0 }.f1;
      __ZN8delegateIFvvEEC1I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($5, $6, ((STRING_TABLE.__str14835)|0), $11);
      __ZN12save_manager17register_postloadE8delegateIFvvEE($71, $5);
      __ZN13video_manager20update_refresh_speedEv($11);
      var $72=$2;
      var $73=__ZNK15running_machine7optionsEv($72);
      var $74=__ZNK11emu_options9snap_viewEv($73);
      $viewname=$74;
      var $75=$2;
      var $76=(($75+560)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 1; break; } else { var $92 = 0;__label__ = 4; break; }
    case 1: // $79
      var $80=$viewname;
      var $81=(($80)|0);
      var $82=HEAP8[($81)];
      var $83=(($82 << 24) >> 24);
      var $84=(($83)|0)==0;
      if ($84) { var $90 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $85
      var $86=$viewname;
      var $87=_strcmp($86, ((STRING_TABLE.__str24836)|0));
      var $88=(($87)|0)==0;
      var $90 = $88;__label__ = 3; break;
    case 3: // $89
      var $90;
      var $92 = $90;__label__ = 4; break;
    case 4: // $91
      var $92;
      var $93=(($11+140)|0);
      var $94=(($92)&1);
      HEAP8[($93)]=$94;
      var $95=(($11+140)|0);
      var $96=HEAP8[($95)];
      var $97=(($96) & 1);
      if ($97) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $98
      var $99=$2;
      var $100=__ZNK15running_machine6renderEv($99);
      var $101=__ZN14render_manager12target_allocEPKcj($100, ((STRING_TABLE._layout_snap)|0), 6);
      var $102=(($11+132)|0);
      HEAP32[(($102)>>2)]=$101;
      var $103=(($11+132)|0);
      var $104=HEAP32[(($103)>>2)];
      __ZN13render_target21set_backdrops_enabledEb($104, 0);
      var $105=(($11+132)|0);
      var $106=HEAP32[(($105)>>2)];
      __ZN13render_target20set_overlays_enabledEb($106, 0);
      var $107=(($11+132)|0);
      var $108=HEAP32[(($107)>>2)];
      __ZN13render_target18set_bezels_enabledEb($108, 0);
      var $109=(($11+132)|0);
      var $110=HEAP32[(($109)>>2)];
      __ZN13render_target19set_cpanels_enabledEb($110, 0);
      var $111=(($11+132)|0);
      var $112=HEAP32[(($111)>>2)];
      __ZN13render_target20set_marquees_enabledEb($112, 0);
      var $113=(($11+132)|0);
      var $114=HEAP32[(($113)>>2)];
      __ZN13render_target26set_screen_overlay_enabledEb($114, 0);
      var $115=(($11+132)|0);
      var $116=HEAP32[(($115)>>2)];
      __ZN13render_target18set_zoom_to_screenEb($116, 0);
      __label__ = 7; break;
    case 6: // $117
      var $118=$2;
      var $119=__ZNK15running_machine6renderEv($118);
      var $120=__ZN14render_manager12target_allocEPKcj($119, 0, 4);
      var $121=(($11+132)|0);
      HEAP32[(($121)>>2)]=$120;
      var $122=(($11+132)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($11+132)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$viewname;
      var $127=__ZN13render_target15configured_viewEPKcii($125, $126, 0, 1);
      __ZN13render_target8set_viewEi($123, $127);
      var $128=(($11+132)|0);
      var $129=HEAP32[(($128)>>2)];
      __ZN13render_target26set_screen_overlay_enabledEb($129, 0);
      __label__ = 7; break;
    case 7: // $130
      var $131=$2;
      var $132=__ZNK15running_machine7optionsEv($131);
      var $133=__ZNK11emu_options9snap_sizeEv($132);
      var $134=(($11+144)|0);
      var $135=(($11+148)|0);
      var $136=_sscanf($133, ((STRING_TABLE.__str34837)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,HEAP32[((tempInt+4)>>2)]=$135,tempInt));
      var $137=(($136)|0)!=2;
      if ($137) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $138
      var $139=(($11+148)|0);
      HEAP32[(($139)>>2)]=0;
      var $140=(($11+144)|0);
      HEAP32[(($140)>>2)]=0;
      __label__ = 9; break;
    case 9: // $141
      var $142=$2;
      var $143=__ZNK15running_machine7optionsEv($142);
      var $144=__ZNK11emu_options9mng_writeEv($143);
      $filename=$144;
      var $145=$filename;
      var $146=(($145)|0);
      var $147=HEAP8[($146)];
      var $148=(($147 << 24) >> 24);
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $150
      var $151=$filename;
      __ZN13video_manager15begin_recordingEPKcNS_12movie_formatE($11, $151, 0);
      __label__ = 11; break;
    case 11: // $152
      var $153=$2;
      var $154=__ZNK15running_machine7optionsEv($153);
      var $155=__ZNK11emu_options9avi_writeEv($154);
      $filename=$155;
      var $156=$filename;
      var $157=(($156)|0);
      var $158=HEAP8[($157)];
      var $159=(($158 << 24) >> 24);
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $161
      var $162=$filename;
      __ZN13video_manager15begin_recordingEPKcNS_12movie_formatE($11, $162, 1);
      __label__ = 13; break;
    case 13: // $163
      var $164=$2;
      var $165=(($164+560)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166)|0)==0;
      if ($167) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $168
      var $169=$2;
      var $170=__ZN15running_machine9schedulerEv($169);
      HEAP32[(($8)>>2)]={ f0: 1122, f1: 0 }.f0; HEAP32[(($8+4)>>2)]={ f0: 1122, f1: 0 }.f1;
      __ZN8delegateIFvPviEEC1I13video_managerEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($7, $8, ((STRING_TABLE.__str44838)|0), $11);
      var $171=__ZN16device_scheduler11timer_allocE8delegateIFvPviEES1_($170, $7, 0);
      var $172=(($11+4)|0);
      HEAP32[(($172)>>2)]=$171;
      var $173=(($11+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$9;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($175)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE)>>2)];HEAP32[(($175+4)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE+4)>>2)];HEAP32[(($175+8)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE+8)>>2)];
      var $176=$10;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($176)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE)>>2)];HEAP32[(($176+4)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE+4)>>2)];HEAP32[(($176+8)>>2)]=HEAP32[((__ZN13screen_device20DEFAULT_FRAME_PERIODE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($174, $9, 0, $10);
      __label__ = 15; break;
    case 15: // $177
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_managerC2ER15running_machine["X"]=1;

function __ZNK11emu_options8throttleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str504884)|0));
  ;
  return $4;
}


function __ZNK11emu_options14auto_frameskipEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str484882)|0));
  ;
  return $4;
}


function __ZNK13video_manager22original_speed_settingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK13video_manager7machineEv($2);
  var $4=__ZNK15running_machine7optionsEv($3);
  var $5=__ZNK11emu_options5speedEv($4);
  var $6=$5;
  var $7=$6*100;
  var $8=$7+0.5;
  var $9=(($8)|0);
  ;
  return $9;
}


function __ZNK11emu_options9frameskipEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options9int_valueEPKc($3, ((STRING_TABLE.__str474881)|0));
  ;
  return $4;
}


function __ZN8delegateIFvvEEC1I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvvEEC2I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13video_manager4exitEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      var $tps=__stackBase__;
      var $final_real_time;
      var $final_emu_time;
      var $2=__stackBase__+8;
      var $3=__stackBase__+20;
      $1=$this;
      var $4=$1;
      __ZN13video_manager13end_recordingEv($4);
      $i=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=(($6)|0) < 32;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$i;
      var $10=__ZNK13video_manager7machineEv($4);
      var $11=(($10+432)|0);
      var $12=(($11+($9<<2))|0);
      var $13=HEAP32[(($12)>>2)];
      __Z16gfx_element_freeP11gfx_element($13);
      __label__ = 3; break;
    case 3: // $14
      var $15=$i;
      var $16=(($15+1)|0);
      $i=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=__ZNK13video_manager7machineEv($4);
      var $19=__ZNK15running_machine6renderEv($18);
      var $20=(($4+132)|0);
      var $21=HEAP32[(($20)>>2)];
      __ZN14render_manager11target_freeEP13render_target($19, $21);
      var $22=(($4+136)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=(($4+136)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $28);
      __label__ = 6; break;
    case 6: // $29
      var $30=(($4+84)|0);
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0) >= 5;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=_osd_ticks_per_second();
      var $35$0=$35[0];
      var $35$1=$35[1];
      var $st$3$0=(($tps)|0);
      HEAP32[(($st$3$0)>>2)]=$35$0;
      var $st$3$1=(($tps+4)|0);
      HEAP32[(($st$3$1)>>2)]=$35$1;
      var $36=(($4+72)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=(($37)>>>0);
      var $39=(($4+76)|0);
      var $st$11$0=(($39)|0);
      var $40$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$11$1)>>2)];
      var $41=$40$0 + $40$1*4294967296;
      var $st$16$0=(($tps)|0);
      var $42$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($tps+4)|0);
      var $42$1=HEAP32[(($st$16$1)>>2)];
      var $43=$42$0 + $42$1*4294967296;
      var $44=$41/$43;
      var $45=$38+$44;
      $final_real_time=$45;
      var $46=(($4+84)|0);
      var $47=__ZNK8attotime9as_doubleEv($46);
      $final_emu_time=$47;
      var $48=$final_emu_time;
      var $49=$48*100;
      var $50=$final_real_time;
      var $51=$49/$50;
      var $52=(($4+84)|0);
      var $$emscripten$temp$0$0=-743309312;
      var $$emscripten$temp$0$1=116415321;
      __ZN8attotimeC1Eix($2, 0, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __ZplRK8attotimeS1_($3, $52, $2);
      var $53=(($3)|0);
      var $54=HEAP32[(($53)>>2)];
      __Z16mame_printf_infoPKcz(((STRING_TABLE.__str224856)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$51,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),HEAP32[((tempInt+8)>>2)]=$54,tempInt));
      __label__ = 8; break;
    case 8: // $55
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager4exitEv["X"]=1;

function __ZN13video_manager8postloadEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  var $3=$1;
  var $4=(($3+172)|0);
  var $5=__ZNK13video_manager7machineEv($3);
  __ZNK15running_machine4timeEv($2, $5);
  var $6=$4;
  var $7=$2;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[(($7+8)>>2)];
  STACKTOP = __stackBase__;
  return;
}


function __ZN13video_manager20update_refresh_speedEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $minrefresh;
      var $min_frame_period=__stackBase__;
      var $screen;
      var $period=__stackBase__+8;
      var $2=__stackBase__+16;
      var $target_speed;
      var $original_speed;
      $1=$this;
      var $3=$1;
      var $4=__ZNK13video_manager7machineEv($3);
      var $5=__ZNK15running_machine7optionsEv($4);
      var $6=__ZNK11emu_options13refresh_speedEv($5);
      if ($6) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $7
      var $8=__ZNK13video_manager7machineEv($3);
      var $9=__ZNK15running_machine6renderEv($8);
      var $10=__ZNK14render_manager15max_update_rateEv($9);
      $minrefresh=$10;
      var $11=$minrefresh;
      var $12=$11 != 0;
      if ($12) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $13
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $st$2$0=(($min_frame_period)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($min_frame_period+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      var $14=__ZNK13video_manager7machineEv($3);
      var $15=__ZNK15running_machine12first_screenEv($14);
      $screen=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$screen;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $19
      var $20=$screen;
      __ZNK13screen_device12frame_periodEv($2, $20);
      var $21=(($2+4)|0);
      var $st$3$0=(($21)|0);
      var $22$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($21+4)|0);
      var $22$1=HEAP32[(($st$3$1)>>2)];
      var $st$7$0=(($period)|0);
      HEAP32[(($st$7$0)>>2)]=$22$0;
      var $st$7$1=(($period+4)|0);
      HEAP32[(($st$7$1)>>2)]=$22$1;
      var $st$11$0=(($period)|0);
      var $23$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($period+4)|0);
      var $23$1=HEAP32[(($st$11$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $24=$23$0 != $$emscripten$temp$1$0 || $23$1 != $$emscripten$temp$1$1;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $st$0$0=(($min_frame_period)|0);
      var $26$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($min_frame_period+4)|0);
      var $26$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($period)|0);
      var $27$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($period+4)|0);
      var $27$1=HEAP32[(($st$4$1)>>2)];
      var $28=($26$1|0) < ($27$1|0) || (($26$1|0) == ($27$1|0) && ($26$0|0) <  ($27$0|0));
      var $st$9$0=(($min_frame_period)|0);
      var $29$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($min_frame_period+4)|0);
      var $29$1=HEAP32[(($st$9$1)>>2)];
      var $st$13$0=(($period)|0);
      var $30$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($period+4)|0);
      var $30$1=HEAP32[(($st$13$1)>>2)];
      var $31$0=$28 ? $29$0 : $30$0;
      var $31$1=$28 ? $29$1 : $30$1;
      var $st$19$0=(($min_frame_period)|0);
      HEAP32[(($st$19$0)>>2)]=$31$0;
      var $st$19$1=(($min_frame_period+4)|0);
      HEAP32[(($st$19$1)>>2)]=$31$1;
      __label__ = 6; break;
    case 6: // $32
      __label__ = 7; break;
    case 7: // $33
      var $34=$screen;
      var $35=__ZNK13screen_device11next_screenEv($34);
      $screen=$35;
      __label__ = 3; break;
    case 8: // $36
      var $37=$minrefresh;
      var $38=$37-0.25;
      var $39=$38;
      var $40=$39*100;
      var $st$4$0=(($min_frame_period)|0);
      var $41$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($min_frame_period+4)|0);
      var $41$1=HEAP32[(($st$4$1)>>2)];
      var $42=$41$0 + $41$1*4294967296;
      var $43=1000000000000000000/$42;
      var $44=$40/$43;
      var $45=_floor($44);
      var $46=($45 >= 0 ? Math.floor($45) : Math.ceil($45));
      $target_speed=$46;
      var $47=__ZNK13video_manager22original_speed_settingEv($3);
      $original_speed=$47;
      var $48=$target_speed;
      var $49=$original_speed;
      var $50=(($48)>>>0) < (($49)>>>0);
      var $51=$target_speed;
      var $52=$original_speed;
      var $53=$50 ? $51 : $52;
      $target_speed=$53;
      var $54=$target_speed;
      var $55=(($3+112)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($54)|0)!=(($56)|0);
      if ($57) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $58
      var $59=$target_speed;
      var $60=$minrefresh;
      var $61=$60;
      var $st$3$0=(($min_frame_period)|0);
      var $62$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($min_frame_period+4)|0);
      var $62$1=HEAP32[(($st$3$1)>>2)];
      var $63=$62$0 + $62$1*4294967296;
      var $64=1000000000000000000/$63;
      var $st$9$0=(($min_frame_period)|0);
      var $65$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($min_frame_period+4)|0);
      var $65$1=HEAP32[(($st$9$1)>>2)];
      var $$emscripten$temp$2$0=100;
      var $$emscripten$temp$2$1=0;
      var $66$0 = ((($65$0)>>>0)+((($65$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $66$1 = Math.min(Math.floor((((($65$0)>>>0)+((($65$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $67=$target_speed;
      var $68$0=$67;
      var $68$1=0;
      var $69$0 = (tempBigIntR=((($66$0)>>>0)+((($66$1)|0)*4294967296))/((($68$0)>>>0)+((($68$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $69$1 = Math.min(Math.floor(((tempBigIntR=((($66$0)>>>0)+((($66$1)|0)*4294967296))/((($68$0)>>>0)+((($68$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $70=$69$0 + $69$1*4294967296;
      var $71=1000000000000000000/$70;
      __Z19mame_printf_verbosePKcz(((STRING_TABLE.__str234857)|0), (tempInt=STACKTOP,STACKTOP += 28,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$59,(tempDoubleF64[0]=$61,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$64,HEAP32[((tempInt+12)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+12+4)>>2)]=tempDoubleI32[1]),(tempDoubleF64[0]=$71,HEAP32[((tempInt+20)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+20+4)>>2)]=tempDoubleI32[1]),tempInt));
      var $72=$target_speed;
      var $73=(($3+112)|0);
      HEAP32[(($73)>>2)]=$72;
      __label__ = 10; break;
    case 10: // $74
      __label__ = 11; break;
    case 11: // $75
      __label__ = 12; break;
    case 12: // $76
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager20update_refresh_speedEv["X"]=1;

function __ZNK11emu_options9snap_viewEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str464880)|0));
  ;
  return $4;
}


function __ZN13render_target26set_screen_overlay_enabledEb($this, $enable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  var $3=(($enable)&1);
  $2=$3;
  var $4=$1;
  var $5=(($4+312)|0);
  var $6=$2;
  var $7=(($6) & 1);
  var $8=__ZN19render_layer_config26set_screen_overlay_enabledEb($5, $7);
  __ZN13render_target19update_layer_configEv($4);
  ;
  return;
}


function __ZN12audit_recordC2EPKcNS_10media_typeE($this, $name, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$name;
      $3=$type;
      var $6=$1;
      var $7=(($6)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=(($6+4)|0);
      var $9=$3;
      HEAP32[(($8)>>2)]=$9;
      var $10=(($6+8)|0);
      HEAP32[(($10)>>2)]=3;
      var $11=(($6+12)|0);
      HEAP32[(($11)>>2)]=100;
      var $12=(($6+16)|0);
      var $13=$2;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($6+20)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$24$0=(($14)|0);
      HEAP32[(($st$24$0)>>2)]=$$emscripten$temp$0$0;
      var $st$24$1=(($14+4)|0);
      HEAP32[(($st$24$1)>>2)]=$$emscripten$temp$0$1;
      var $15=(($6+28)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$31$0=(($15)|0);
      HEAP32[(($st$31$0)>>2)]=$$emscripten$temp$1$0;
      var $st$31$1=(($15+4)|0);
      HEAP32[(($st$31$1)>>2)]=$$emscripten$temp$1$1;
      var $16=(($6+36)|0);
      FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($16);
      var $17=(($6+120)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      ;
      return;
    case 2: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $4=$21;
      var $22=$20.f1;
      $5=$22;
      var $23=(($6+36)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $24
      __label__ = 4; break;
    case 4: // $25
      var $26=$4;
      var $27=$4;
      var $28=$5;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12audit_recordC2EPKcNS_10media_typeE["X"]=1;

function __ZN20resource_pool_objectI12audit_recordED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12audit_recordED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12audit_recordED0Ev["X"]=1;

function __ZN20resource_pool_objectI12audit_recordED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12audit_recordE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12audit_recordD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12audit_recordED2Ev["X"]=1;

function __ZN12audit_recordD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+120)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+36)|0);
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+36)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13video_manager13set_frameskipEi($this, $frameskip) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$frameskip;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==-1;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($3+108)|0);
      HEAP8[($7)]=1;
      var $8=(($3+117)|0);
      HEAP8[($8)]=0;
      __label__ = 6; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0) >= 0;
      if ($11) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0) <= 10;
      if ($14) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $15
      var $16=(($3+108)|0);
      HEAP8[($16)]=0;
      var $17=$2;
      var $18=(($17) & 255);
      var $19=(($3+117)|0);
      HEAP8[($19)]=$18;
      __label__ = 5; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13video_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11emu_options9mng_writeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str444878)|0));
  ;
  return $4;
}


function __ZN8delegateIFvPviEEC1I13video_managerEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvPviEEC2I13video_managerEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13video_manager26screenless_update_callbackEPvi($this, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$ptr;
  $3=$param;
  var $4=$1;
  __ZN13video_manager12frame_updateEb($4, 0);
  ;
  return;
}


function __ZN13video_manager12frame_updateEb($this, $debug) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $phase;
      var $skipped_it;
      var $anything_changed;
      var $current_time=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $screen;
      $1=$this;
      var $5=(($debug)&1);
      $2=$5;
      var $6=$1;
      var $7=__ZNK13video_manager7machineEv($6);
      var $8=__ZNK15running_machine5phaseEv($7);
      $phase=$8;
      var $9=(($6+120)|0);
      var $10=HEAP8[($9)];
      var $11=(($10) & 1);
      var $12=(($11)&1);
      $skipped_it=$12;
      var $13=$phase;
      var $14=(($13)|0)==3;
      if ($14) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $15
      var $16=__ZNK13video_manager7machineEv($6);
      var $17=__ZNK15running_machine6pausedEv($16);
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=__ZNK13video_manager7machineEv($6);
      var $20=__ZNK15running_machine7optionsEv($19);
      var $21=__ZNK11emu_options15update_in_pauseEv($20);
      if ($21) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $22
      var $23=__ZN13video_manager21finish_screen_updatesEv($6);
      var $24=(($23)&1);
      $anything_changed=$24;
      var $25=$anything_changed;
      var $26=(($25) & 1);
      if ($26) { __label__ = 8; break; } else { __label__ = 4; break; }
    case 4: // $27
      var $28=(($6+108)|0);
      var $29=HEAP8[($28)];
      var $30=(($29) & 1);
      if ($30) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $31
      var $32=(($6+117)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=(($34)|0)==0;
      if ($35) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=(($6+116)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38+1)&255);
      HEAP8[($37)]=$39;
      var $40=(($38)&255);
      var $41=(($40)|0) < 3;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      $skipped_it=1;
      __label__ = 9; break;
    case 8: // $43
      var $44=(($6+116)|0);
      HEAP8[($44)]=0;
      __label__ = 9; break;
    case 9: // $45
      __label__ = 10; break;
    case 10: // $46
      var $47=__ZNK13video_manager7machineEv($6);
      var $48=__ZNK13video_manager7machineEv($6);
      var $49=__ZNK15running_machine6renderEv($48);
      var $50=__ZNK14render_manager12ui_containerEv($49);
      __Z20ui_update_and_renderR15running_machineP16render_container($47, $50);
      var $51=__ZNK13video_manager7machineEv($6);
      __Z27debugint_update_during_gameR15running_machine($51);
      var $52=__ZNK13video_manager7machineEv($6);
      __ZNK15running_machine4timeEv($current_time, $52);
      var $53=$2;
      var $54=(($53) & 1);
      if ($54) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $55
      var $56=$skipped_it;
      var $57=(($56) & 1);
      if ($57) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 12: // $58
      var $59=__ZNK13video_manager18effective_throttleEv($6);
      if ($59) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $60
      var $61=$3;
      var $62=$current_time;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($61)>>2)]=HEAP32[(($62)>>2)];HEAP32[(($61+4)>>2)]=HEAP32[(($62+4)>>2)];HEAP32[(($61+8)>>2)]=HEAP32[(($62+8)>>2)];
      __ZN13video_manager15update_throttleE8attotime($6, $3);
      __label__ = 14; break;
    case 14: // $63
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 267);
      var $64=__ZNK13video_manager7machineEv($6);
      var $65=__ZNK15running_machine3osdEv($64);
      var $66=$65;
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+12)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$2;
      var $71=(($70) & 1);
      if ($71) { var $76 = 0;__label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $72
      var $73=$skipped_it;
      var $74=(($73) & 1);
      var $76 = $74;__label__ = 16; break;
    case 16: // $75
      var $76;
      FUNCTION_TABLE[$69]($65, $76);
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $77=$2;
      var $78=(($77) & 1);
      if ($78) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $79
      var $80=__ZNK13video_manager7machineEv($6);
      __ZN15running_machine14call_notifiersE20machine_notification($80, 0);
      __label__ = 18; break;
    case 18: // $81
      var $82=$2;
      var $83=(($82) & 1);
      if ($83) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $84
      __ZN13video_manager16update_frameskipEv($6);
      __label__ = 20; break;
    case 20: // $85
      var $86=$2;
      var $87=(($86) & 1);
      if ($87) { __label__ = 23; break; } else { __label__ = 21; break; }
    case 21: // $88
      var $89=$skipped_it;
      var $90=(($89) & 1);
      if ($90) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $91
      var $92=$4;
      var $93=$current_time;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($92)>>2)]=HEAP32[(($93)>>2)];HEAP32[(($92+4)>>2)]=HEAP32[(($93+4)>>2)];HEAP32[(($92+8)>>2)]=HEAP32[(($93+8)>>2)];
      __ZN13video_manager15recompute_speedE8attotime($6, $4);
      __label__ = 23; break;
    case 23: // $94
      var $95=$phase;
      var $96=(($95)|0)==3;
      if ($96) { __label__ = 24; break; } else { __label__ = 35; break; }
    case 24: // $97
      var $98=__ZNK13video_manager7machineEv($6);
      var $99=(($98+560)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $102
      var $103=__ZNK13video_manager7machineEv($6);
      var $104=__ZNK15running_machine6pausedEv($103);
      if ($104) { __label__ = 28; break; } else { __label__ = 26; break; }
    case 26: // $105
      var $106=$2;
      var $107=(($106) & 1);
      if ($107) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $108
      var $109=__ZNK13video_manager7machineEv($6);
      var $110=__ZL32debugger_within_instruction_hookR15running_machine($109);
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $112
      var $113=__ZNK13video_manager7machineEv($6);
      var $114=(($113+560)|0);
      var $115=HEAP32[(($114)>>2)];
      __ZN13screen_device18scanline0_callbackEv($115);
      __label__ = 34; break;
    case 29: // $116
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 261);
      var $117=__ZNK13video_manager7machineEv($6);
      var $118=__ZNK15running_machine12first_screenEv($117);
      $screen=$118;
      __label__ = 30; break;
    case 30: // $119
      var $120=$screen;
      var $121=(($120)|0)!=0;
      if ($121) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $122
      var $123=$screen;
      __ZN13screen_device10screen_eofEv($123);
      __label__ = 32; break;
    case 32: // $124
      var $125=$screen;
      var $126=__ZNK13screen_device11next_screenEv($125);
      $screen=$126;
      __label__ = 30; break;
    case 33: // $127
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 34; break;
    case 34: // $128
      __label__ = 35; break;
    case 35: // $129
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager12frame_updateEb["X"]=1;

function __ZNK11emu_options15update_in_pauseEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str424876)|0));
  ;
  return $4;
}


function __ZN13video_manager21finish_screen_updatesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $screen;
      var $anything_changed;
      var $screen1;
      var $screen2;
      var $screen3;
      $1=$this;
      var $2=$1;
      var $3=__ZNK13video_manager7machineEv($2);
      var $4=__ZNK15running_machine12first_screenEv($3);
      $screen=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$screen;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$screen;
      var $10=$screen;
      var $11=__ZNK13screen_device12visible_areaEv($10);
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZN13screen_device14update_partialEi($9, $13);
      __label__ = 3; break;
    case 3: // $15
      var $16=$screen;
      var $17=__ZNK13screen_device11next_screenEv($16);
      $screen=$17;
      __label__ = 1; break;
    case 4: // $18
      $anything_changed=0;
      var $19=__ZNK13video_manager7machineEv($2);
      var $20=__ZNK15running_machine12first_screenEv($19);
      $screen1=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$screen1;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $24
      var $25=$screen1;
      var $26=__ZN13screen_device12update_quadsEv($25);
      if ($26) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $27
      $anything_changed=1;
      __label__ = 8; break;
    case 8: // $28
      __label__ = 9; break;
    case 9: // $29
      var $30=$screen1;
      var $31=__ZNK13screen_device11next_screenEv($30);
      $screen1=$31;
      __label__ = 5; break;
    case 10: // $32
      var $33=__ZNK13video_manager7machineEv($2);
      var $34=__ZNK15running_machine6pausedEv($33);
      if ($34) { __label__ = 16; break; } else { __label__ = 11; break; }
    case 11: // $35
      __ZN13video_manager12record_frameEv($2);
      var $36=__ZNK13video_manager7machineEv($2);
      var $37=__ZNK15running_machine12first_screenEv($36);
      $screen2=$37;
      __label__ = 12; break;
    case 12: // $38
      var $39=$screen2;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $41
      var $42=$screen2;
      __ZN13screen_device13update_burninEv($42);
      __label__ = 14; break;
    case 14: // $43
      var $44=$screen2;
      var $45=__ZNK13screen_device11next_screenEv($44);
      $screen2=$45;
      __label__ = 12; break;
    case 15: // $46
      __label__ = 16; break;
    case 16: // $47
      var $48=__ZNK13video_manager7machineEv($2);
      var $49=__ZNK15running_machine12first_screenEv($48);
      $screen3=$49;
      __label__ = 17; break;
    case 17: // $50
      var $51=$screen3;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $53
      var $54=$screen3;
      __Z16crosshair_renderR13screen_device($54);
      __label__ = 19; break;
    case 19: // $55
      var $56=$screen3;
      var $57=__ZNK13screen_device11next_screenEv($56);
      $screen3=$57;
      __label__ = 17; break;
    case 20: // $58
      var $59=$anything_changed;
      var $60=(($59) & 1);
      ;
      return $60;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager21finish_screen_updatesEv["X"]=1;

function __ZNK13video_manager18effective_throttleEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=__ZNK13video_manager7machineEv($3);
      var $5=__ZNK15running_machine6pausedEv($4);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=__Z17ui_is_menu_activev();
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      $1=1;
      __label__ = 6; break;
    case 3: // $10
      var $11=(($3+101)|0);
      var $12=HEAP8[($11)];
      var $13=(($12) & 1);
      if ($13) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $14
      $1=0;
      __label__ = 6; break;
    case 5: // $15
      var $16=(($3+100)|0);
      var $17=HEAP8[($16)];
      var $18=(($17) & 1);
      $1=$18;
      __label__ = 6; break;
    case 6: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13video_manager15begin_recordingEPKcNS_12movie_formatE($this, $name, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 488; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12=__stackBase__+36;
      var $info=__stackBase__+48;
      var $13=__stackBase__+104;
      var $filerr;
      var $fullpath=__stackBase__+116;
      var $tempfile=__stackBase__+180;
      var $14;
      var $15;
      var $16=__stackBase__+440;
      var $17=__stackBase__+452;
      var $avierr;
      var $filerr1;
      var $rate;
      var $18=__stackBase__+464;
      var $pngerr;
      var $19=__stackBase__+476;
      $9=$this;
      $10=$name;
      $11=$format;
      var $20=$9;
      __ZN13video_manager13end_recordingEv($20);
      __ZN13video_manager22create_snapshot_bitmapEP8device_t($20, 0);
      var $21=(($20+184)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($20+172)|0);
      var $23=__ZNK13video_manager7machineEv($20);
      __ZNK15running_machine4timeEv($12, $23);
      var $24=$22;
      var $25=$12;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];HEAP32[(($24+4)>>2)]=HEAP32[(($25+4)>>2)];HEAP32[(($24+8)>>2)]=HEAP32[(($25+8)>>2)];
      var $26=$11;
      var $27=(($26)|0)==1;
      if ($27) { __label__ = 1; break; } else { __label__ = 34; break; }
    case 1: // $28
      var $29=(($info)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=__ZNK13video_manager7machineEv($20);
      var $31=(($30+560)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $34
      var $35=__ZNK13video_manager7machineEv($20);
      var $36=(($35+560)|0);
      var $37=HEAP32[(($36)>>2)];
      __ZNK13screen_device12frame_periodEv($13, $37);
      var $38=(($13+4)|0);
      var $st$5$0=(($38)|0);
      var $39$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($38+4)|0);
      var $39$1=HEAP32[(($st$5$1)>>2)];
      var $40=$39$0 + $39$1*4294967296;
      var $41=1000000000000000000/$40;
      var $44 = $41;__label__ = 4; break;
    case 3: // $42
      var $44 = 60;__label__ = 4; break;
    case 4: // $43
      var $44;
      var $45=$44*1000;
      var $46=($45 >= 0 ? Math.floor($45) : Math.ceil($45));
      var $47=(($info+4)|0);
      HEAP32[(($47)>>2)]=$46;
      var $48=(($info+8)|0);
      HEAP32[(($48)>>2)]=1000;
      var $49=(($info+12)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=(($20+136)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$51;
      var $53=(($52+12)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($info+16)|0);
      HEAP32[(($55)>>2)]=$54;
      var $56=(($20+136)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$57;
      var $59=(($58+16)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($info+20)|0);
      HEAP32[(($61)>>2)]=$60;
      var $62=(($info+24)|0);
      HEAP32[(($62)>>2)]=24;
      var $63=(($info+28)|0);
      HEAP32[(($63)>>2)]=0;
      var $64=__ZNK13video_manager7machineEv($20);
      var $65=__ZNK15running_machine11sample_rateEv($64);
      var $66=(($info+32)|0);
      HEAP32[(($66)>>2)]=$65;
      var $67=(($info+36)|0);
      HEAP32[(($67)>>2)]=1;
      var $68=(($info+40)|0);
      HEAP32[(($68)>>2)]=0;
      var $69=(($info+44)|0);
      HEAP32[(($69)>>2)]=2;
      var $70=(($info+48)|0);
      HEAP32[(($70)>>2)]=16;
      var $71=__ZNK13video_manager7machineEv($20);
      var $72=__ZNK15running_machine11sample_rateEv($71);
      var $73=(($info+52)|0);
      HEAP32[(($73)>>2)]=$72;
      __ZN7astringC1Ev($fullpath);
      var $74=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $75
      var $76=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 11; break; };
    case 6: // $77
      var $78=(function() { try { __THREW__ = false; return __ZNK11emu_options18snapshot_directoryEv($76) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $79
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($tempfile, $78, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $80
      var $81=$10;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $83
      var $84=$10;
      var $85=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($tempfile, $84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $86
      $filerr=$85;
      __label__ = 15; break;
    case 11: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $89=$88.f0;
      $14=$89;
      var $90=$88.f1;
      $15=$90;
      __label__ = 32; break;
    case 12: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $93=$92.f0;
      $14=$93;
      var $94=$92.f1;
      $15=$94;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($tempfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 66; break; }
    case 13: // $95
      var $96=(function() { try { __THREW__ = false; return __ZN13video_manager9open_nextER8emu_filePKc($20, $tempfile, ((STRING_TABLE.__str174851)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; };
    case 14: // $97
      $filerr=$96;
      __label__ = 15; break;
    case 15: // $98
      var $99=(($20+160)|0);
      (function() { try { __THREW__ = false; return __ZN8attotime12from_secondsEi($17, 1000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 16: // $100
      var $101=(($info+4)|0);
      var $102=HEAP32[(($101)>>2)];
      (function() { try { __THREW__ = false; return __ZdvRK8attotimej($16, $17, $102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 12; break; }
    case 17: // $103
      var $104=$99;
      var $105=$16;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($104)>>2)]=HEAP32[(($105)>>2)];HEAP32[(($104+4)>>2)]=HEAP32[(($105+4)>>2)];HEAP32[(($104+8)>>2)]=HEAP32[(($105+8)>>2)];
      var $106=$filerr;
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $108
      var $109=(function() { try { __THREW__ = false; return __ZNK8emu_file8fullpathEv($tempfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 12; break; };
    case 19: // $110
      var $111=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($fullpath, $109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 12; break; };
    case 20: // $112
      __label__ = 21; break;
    case 21: // $113
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($tempfile) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 11; break; }
    case 22: // $114
      var $115=$filerr;
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 23; break; } else { __label__ = 31; break; }
    case 23: // $117
      var $118=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fullpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 11; break; };
    case 24: // $119
      var $120=(($20+156)|0);
      var $121=(function() { try { __THREW__ = false; return __Z10avi_createPKcPK15_avi_movie_infoPP9_avi_file($118, $info, $120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 11; break; };
    case 25: // $122
      $avierr=$121;
      var $123=$avierr;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $125
      var $126=$avierr;
      var $127=(function() { try { __THREW__ = false; return __Z16avi_error_string10_avi_error($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 11; break; };
    case 27: // $128
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str184852)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$127,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 11; break; }
    case 28: // $129
      __label__ = 30; break;
    case 29: // $130
      __label__ = 32; break;
    case 30: // $131
      __label__ = 31; break;
    case 31: // $132
      FUNCTION_TABLE[__ZN7astringD1Ev]($fullpath);
      __label__ = 64; break;
    case 32: // $133
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fullpath) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 66; break; }
    case 33: // $134
      __label__ = 65; break;
    case 34: // $135
      var $136=$11;
      var $137=(($136)|0)==0;
      if ($137) { __label__ = 35; break; } else { __label__ = 63; break; }
    case 35: // $138
      var $139=__ZNK13video_manager7machineEv($20);
      var $140=__ZN15running_machine7respoolEv($139);
      var $141=$4;
      var $142=$5;
      var $143=$6;
      var $144=$result_i;
      var $145=$7;
      var $146=$8;
      HEAP32[(($4)>>2)]=260;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str194853)|0);
      HEAP32[(($6)>>2)]=457;
      var $147=HEAP32[(($4)>>2)];
      var $148=HEAP32[(($5)>>2)];
      var $149=HEAP32[(($6)>>2)];
      var $150=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($147, $148, $149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 38; break; };
    case 36: // $151
      HEAP32[(($result_i)>>2)]=$150;
      var $152=HEAP32[(($result_i)>>2)];
      var $153=(($152)|0)==0;
      if ($153) { __label__ = 37; break; } else { __label__ = 42; break; }
    case 37: // $154
      var $155=___cxa_allocate_exception(4);
      var $156=$155;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($156);
      (function() { try { __THREW__ = false; return ___cxa_throw($155, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 38; break; }
    case 38: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $159=$158.f0;
      HEAP32[(($7)>>2)]=$159;
      var $160=$158.f1;
      HEAP32[(($8)>>2)]=$160;
      var $161=HEAP32[(($8)>>2)];
      var $162=(($161)|0) < 0;
      if ($162) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $163
      var $164=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($164);
      throw "Reached an unreachable!"
    case 40: // $165
      var $166=HEAP32[(($7)>>2)];
      var $167=HEAP32[(($7)>>2)];
      var $168=HEAP32[(($8)>>2)];
      var $169=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $167, tempValue);
      var $170=($169.f1 = $168, $169);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 41: // $171
      throw "Reached an unreachable!"
    case 42: // $_ZnwjPKci_exit
      var $172=HEAP32[(($result_i)>>2)];
      var $173=$4;
      var $174=$5;
      var $175=$6;
      var $176=$result_i;
      var $177=$7;
      var $178=$8;
      var $179=$172;
      var $180=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 48; break; };
    case 43: // $181
      var $182=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 48; break; };
    case 44: // $183
      var $184=(function() { try { __THREW__ = false; return __ZNK11emu_options18snapshot_directoryEv($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 48; break; };
    case 45: // $185
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($179, $184, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $186
      var $187=__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_($140, $179);
      var $188=(($20+152)|0);
      HEAP32[(($188)>>2)]=$187;
      var $189=$10;
      var $190=(($189)|0)!=0;
      if ($190) { __label__ = 47; break; } else { __label__ = 53; break; }
    case 47: // $191
      var $192=(($20+152)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$10;
      var $195=__ZN8emu_file4openEPKc($193, $194);
      $filerr1=$195;
      __label__ = 54; break;
    case 48: // $196
      var $197=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $198=$197.f0;
      $14=$198;
      var $199=$197.f1;
      $15=$199;
      var $200=$1;
      var $201=$2;
      var $202=$3;
      HEAP32[(($1)>>2)]=$172;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str194853)|0);
      HEAP32[(($3)>>2)]=457;
      var $203=HEAP32[(($1)>>2)];
      var $204=(($203)|0)!=0;
      if ($204) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $205
      var $206=HEAP32[(($1)>>2)];
      var $207=HEAP32[(($2)>>2)];
      var $208=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($206, $207, $208) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 66; break; }
    case 50: // $_noexc
      __label__ = 51; break;
    case 51: // $_ZdlPvPKci_exit
      var $209=$1;
      var $210=$2;
      var $211=$3;
      __label__ = 52; break;
    case 52: // $212
      __label__ = 65; break;
    case 53: // $213
      var $214=(($20+152)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=__ZN13video_manager9open_nextER8emu_filePKc($20, $215, ((STRING_TABLE.__str204854)|0));
      $filerr1=$216;
      __label__ = 54; break;
    case 54: // $217
      var $218=$filerr1;
      var $219=(($218)|0)==0;
      if ($219) { __label__ = 55; break; } else { __label__ = 61; break; }
    case 55: // $220
      var $221=__ZNK13video_manager7machineEv($20);
      var $222=(($221+560)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $225
      var $226=__ZNK13video_manager7machineEv($20);
      var $227=(($226+560)|0);
      var $228=HEAP32[(($227)>>2)];
      __ZNK13screen_device12frame_periodEv($18, $228);
      var $229=(($18+4)|0);
      var $st$5$0=(($229)|0);
      var $230$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($229+4)|0);
      var $230$1=HEAP32[(($st$5$1)>>2)];
      var $231=$230$0 + $230$1*4294967296;
      var $232=1000000000000000000/$231;
      var $235 = $232;__label__ = 58; break;
    case 57: // $233
      var $235 = 60;__label__ = 58; break;
    case 58: // $234
      var $235;
      var $236=(($235)|0);
      $rate=$236;
      var $237=(($20+152)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=__ZN8emu_filecvP10_core_fileEv($238);
      var $240=(($20+136)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=$rate;
      var $243=(($242)|0);
      var $244=__Z17mng_capture_startP10_core_fileP8bitmap_td($239, $241, $243);
      $pngerr=$244;
      var $245=$pngerr;
      var $246=(($245)|0)!=0;
      if ($246) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $247
      __ZN13video_manager13end_recordingEv($20);
      __label__ = 64; break;
    case 60: // $248
      var $249=(($20+160)|0);
      var $250=$rate;
      var $251=(($250)|0);
      __ZN8attotime7from_hzEd($19, $251);
      var $252=$249;
      var $253=$19;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($252)>>2)]=HEAP32[(($253)>>2)];HEAP32[(($252+4)>>2)]=HEAP32[(($253+4)>>2)];HEAP32[(($252+8)>>2)]=HEAP32[(($253+8)>>2)];
      __label__ = 62; break;
    case 61: // $254
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str214855)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $255=(($20+152)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=$256;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $257);
      var $258=(($20+152)|0);
      HEAP32[(($258)>>2)]=0;
      __label__ = 62; break;
    case 62: // $259
      __label__ = 63; break;
    case 63: // $260
      __label__ = 64; break;
    case 64: // $261
      STACKTOP = __stackBase__;
      return;
    case 65: // $262
      var $263=$14;
      var $264=$14;
      var $265=$15;
      var $266=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $264, tempValue);
      var $267=($266.f1 = $265, $266);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $268
      var $269=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager15begin_recordingEPKcNS_12movie_formatE["X"]=1;

function __ZNK13video_manager19effective_frameskipEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+101)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=11;
      __label__ = 3; break;
    case 2: // $8
      var $9=(($3+117)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      $1=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13screen_device15partial_updatesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+556)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13video_manager15update_throttleE8attotime($this, $emutime) {
  var __stackBase__  = STACKTOP; STACKTOP += 152; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $emutime; $emutime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($emutime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($emutime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($emutime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      var $ticks_per_second=__stackBase__+24;
      var $attoseconds_per_tick=__stackBase__+32;
      var $4=__stackBase__+40;
      var $5=__stackBase__+52;
      var $emu_delta_attoseconds=__stackBase__+64;
      var $6=__stackBase__+72;
      var $diff_ticks=__stackBase__+84;
      var $real_delta_attoseconds=__stackBase__+92;
      var $7=__stackBase__+100;
      var $real_is_ahead_attoseconds=__stackBase__+112;
      var $8=__stackBase__+120;
      var $target_ticks=__stackBase__+132;
      var $9=__stackBase__+140;
      $1=$this;
      var $10=$1;
      __label__ = 1; break;
    case 1: // $11
      var $12=(($10+112)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $15
      var $16=(($10+112)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=100;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __ZmlRK8attotimej($3, $emutime, 100);
      var $20=(($10+112)|0);
      var $21=HEAP32[(($20)>>2)];
      __ZdvRK8attotimej($2, $3, $21);
      var $22=$emutime;
      var $23=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($22)>>2)]=HEAP32[(($23)>>2)];HEAP32[(($22+4)>>2)]=HEAP32[(($23+4)>>2)];HEAP32[(($22+8)>>2)]=HEAP32[(($23+8)>>2)];
      __label__ = 4; break;
    case 4: // $24
      var $25=_osd_ticks_per_second();
      var $25$0=$25[0];
      var $25$1=$25[1];
      var $st$3$0=(($ticks_per_second)|0);
      HEAP32[(($st$3$0)>>2)]=$25$0;
      var $st$3$1=(($ticks_per_second+4)|0);
      HEAP32[(($st$3$1)>>2)]=$25$1;
      var $st$7$0=(($ticks_per_second)|0);
      var $26$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($ticks_per_second+4)|0);
      var $26$1=HEAP32[(($st$7$1)>>2)];
      var $$emscripten$temp$0$0=-1486618624;
      var $$emscripten$temp$0$1=232830643;
      var $27$0 = (tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($26$0)>>>0)+((($26$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $27$1 = Math.min(Math.floor(((tempBigIntR=((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))/((($26$0)>>>0)+((($26$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$14$0=(($attoseconds_per_tick)|0);
      HEAP32[(($st$14$0)>>2)]=$27$0;
      var $st$14$1=(($attoseconds_per_tick+4)|0);
      HEAP32[(($st$14$1)>>2)]=$27$1;
      var $28=__ZNK13video_manager7machineEv($10);
      var $29=__ZNK15running_machine6pausedEv($28);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=(($10+28)|0);
      var $$emscripten$temp$1$0=1954764116;
      var $$emscripten$temp$1$1=7761021;
      __ZN8attotimeC1Eix($5, 0, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      __ZmiRK8attotimeS1_($4, $emutime, $5);
      var $32=$31;
      var $33=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($32)>>2)]=HEAP32[(($33)>>2)];HEAP32[(($32+4)>>2)]=HEAP32[(($33+4)>>2)];HEAP32[(($32+8)>>2)]=HEAP32[(($33+8)>>2)];
      var $34=(($10+16)|0);
      var $35=(($10+28)|0);
      var $36=$34;
      var $37=$35;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      __label__ = 6; break;
    case 6: // $38
      var $39=(($10+28)|0);
      __ZmiRK8attotimeS1_($6, $emutime, $39);
      var $40=__ZNK8attotime14as_attosecondsEv($6);
      var $40$0=$40[0];
      var $40$1=$40[1];
      var $st$5$0=(($emu_delta_attoseconds)|0);
      HEAP32[(($st$5$0)>>2)]=$40$0;
      var $st$5$1=(($emu_delta_attoseconds+4)|0);
      HEAP32[(($st$5$1)>>2)]=$40$1;
      var $st$9$0=(($emu_delta_attoseconds)|0);
      var $41$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($emu_delta_attoseconds+4)|0);
      var $41$1=HEAP32[(($st$9$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $42=($41$1|0) < ($$emscripten$temp$2$1|0) || (($41$1|0) == ($$emscripten$temp$2$1|0) && ($41$0|0) <  ($$emscripten$temp$2$0|0));
      if ($42) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $43
      var $st$0$0=(($emu_delta_attoseconds)|0);
      var $44$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($emu_delta_attoseconds+4)|0);
      var $44$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=1569325056;
      var $$emscripten$temp$3$1=23283064;
      var $45=($44$1|0) > ($$emscripten$temp$3$1|0) || (($44$1|0) == ($$emscripten$temp$3$1|0) && ($44$0|0) >  ($$emscripten$temp$3$0|0));
      if ($45) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      __label__ = 18; break;
    case 9: // $47
      var $48=_osd_ticks();
      var $48$0=$48[0];
      var $48$1=$48[1];
      var $49=(($10+8)|0);
      var $st$4$0=(($49)|0);
      var $50$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($49+4)|0);
      var $50$1=HEAP32[(($st$4$1)>>2)];
      var $51$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))-((($50$0)>>>0)+((($50$1)|0)*4294967296))>>>0; var $51$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))-((($50$0)>>>0)+((($50$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($diff_ticks)|0);
      HEAP32[(($st$9$0)>>2)]=$51$0;
      var $st$9$1=(($diff_ticks+4)|0);
      HEAP32[(($st$9$1)>>2)]=$51$1;
      var $st$13$0=(($diff_ticks)|0);
      var $52$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($diff_ticks+4)|0);
      var $52$1=HEAP32[(($st$13$1)>>2)];
      var $53=(($10+8)|0);
      var $st$18$0=(($53)|0);
      var $54$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($53+4)|0);
      var $54$1=HEAP32[(($st$18$1)>>2)];
      var $55$0 = ((($54$0)>>>0)+((($54$1)|0)*4294967296))+((($52$0)>>>0)+((($52$1)|0)*4294967296))>>>0; var $55$1 = Math.min(Math.floor((((($54$0)>>>0)+((($54$1)|0)*4294967296))+((($52$0)>>>0)+((($52$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$23$0=(($53)|0);
      HEAP32[(($st$23$0)>>2)]=$55$0;
      var $st$23$1=(($53+4)|0);
      HEAP32[(($st$23$1)>>2)]=$55$1;
      var $st$27$0=(($diff_ticks)|0);
      var $56$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($diff_ticks+4)|0);
      var $56$1=HEAP32[(($st$27$1)>>2)];
      var $st$31$0=(($ticks_per_second)|0);
      var $57$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($ticks_per_second+4)|0);
      var $57$1=HEAP32[(($st$31$1)>>2)];
      var $58=($56$1|0) >= ($57$1|0) && (($56$1|0) >  ($57$1|0) || ($56$0|0) >= ($57$0|0));
      if ($58) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $59
      __label__ = 18; break;
    case 11: // $60
      var $st$0$0=(($diff_ticks)|0);
      var $61$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($diff_ticks+4)|0);
      var $61$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($attoseconds_per_tick)|0);
      var $62$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($attoseconds_per_tick+4)|0);
      var $62$1=HEAP32[(($st$4$1)>>2)];
      var $63$0 = ((($61$0)>>>0)+((($61$1)|0)*4294967296))*((($62$0)>>>0)+((($62$1)|0)*4294967296))>>>0; var $63$1 = Math.min(Math.floor((((($61$0)>>>0)+((($61$1)|0)*4294967296))*((($62$0)>>>0)+((($62$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($real_delta_attoseconds)|0);
      HEAP32[(($st$9$0)>>2)]=$63$0;
      var $st$9$1=(($real_delta_attoseconds+4)|0);
      HEAP32[(($st$9$1)>>2)]=$63$1;
      var $64=(($10+28)|0);
      var $65=$64;
      var $66=$emutime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($65)>>2)]=HEAP32[(($66)>>2)];HEAP32[(($65+4)>>2)]=HEAP32[(($66+4)>>2)];HEAP32[(($65+8)>>2)]=HEAP32[(($66+8)>>2)];
      var $67=(($10+16)|0);
      var $st$18$0=(($real_delta_attoseconds)|0);
      var $68$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($real_delta_attoseconds+4)|0);
      var $68$1=HEAP32[(($st$18$1)>>2)];
      __ZN8attotimeC1Eix($7, 0, $68$0, $68$1);
      var $69=__ZN8attotimepLERKS_($67, $7);
      var $70=(($10+40)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71 << 1;
      var $st$27$0=(($emu_delta_attoseconds)|0);
      var $73$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($emu_delta_attoseconds+4)|0);
      var $73$1=HEAP32[(($st$27$1)>>2)];
      var $st$31$0=(($real_delta_attoseconds)|0);
      var $74$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($real_delta_attoseconds+4)|0);
      var $74$1=HEAP32[(($st$31$1)>>2)];
      var $75=($73$1|0) > ($74$1|0) || (($73$1|0) == ($74$1|0) && ($73$0|0) >  ($74$0|0));
      var $76=(($75)&1);
      var $77=$72 | $76;
      var $78=(($10+40)|0);
      HEAP32[(($78)>>2)]=$77;
      var $79=(($10+28)|0);
      var $80=(($10+16)|0);
      __ZmiRK8attotimeS1_($8, $79, $80);
      var $81=__ZNK8attotime14as_attosecondsEv($8);
      var $81$0=$81[0];
      var $81$1=$81[1];
      var $st$46$0=(($real_is_ahead_attoseconds)|0);
      HEAP32[(($st$46$0)>>2)]=$81$0;
      var $st$46$1=(($real_is_ahead_attoseconds+4)|0);
      HEAP32[(($st$46$1)>>2)]=$81$1;
      var $st$50$0=(($real_is_ahead_attoseconds)|0);
      var $82$0=HEAP32[(($st$50$0)>>2)];
      var $st$50$1=(($real_is_ahead_attoseconds+4)|0);
      var $82$1=HEAP32[(($st$50$1)>>2)];
      var $$emscripten$temp$4$0=-1569325056;
      var $$emscripten$temp$4$1=-23283065;
      var $83=($82$1|0) < ($$emscripten$temp$4$1|0) || (($82$1|0) == ($$emscripten$temp$4$1|0) && ($82$0|0) <  ($$emscripten$temp$4$0|0));
      if ($83) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 12: // $84
      var $st$0$0=(($real_is_ahead_attoseconds)|0);
      var $85$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($real_is_ahead_attoseconds+4)|0);
      var $85$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $86=($85$1|0) < ($$emscripten$temp$5$1|0) || (($85$1|0) == ($$emscripten$temp$5$1|0) && ($85$0|0) <  ($$emscripten$temp$5$0|0));
      if ($86) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $87
      var $88=(($10+40)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89 & 255;
      var $91=((STRING_TABLE.__ZZN13video_manager15update_throttleE8attotimeE8popcount+$90)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=(($93)|0) < 6;
      if ($94) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $95
      __label__ = 18; break;
    case 15: // $96
      var $st$0$0=(($real_is_ahead_attoseconds)|0);
      var $97$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($real_is_ahead_attoseconds+4)|0);
      var $97$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      var $98=($97$1|0) < ($$emscripten$temp$6$1|0) || (($97$1|0) == ($$emscripten$temp$6$1|0) && ($97$0|0) <  ($$emscripten$temp$6$0|0));
      if ($98) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $99
      __label__ = 19; break;
    case 17: // $100
      var $101=(($10+8)|0);
      var $st$1$0=(($101)|0);
      var $102$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($101+4)|0);
      var $102$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($real_is_ahead_attoseconds)|0);
      var $103$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($real_is_ahead_attoseconds+4)|0);
      var $103$1=HEAP32[(($st$5$1)>>2)];
      var $st$9$0=(($attoseconds_per_tick)|0);
      var $104$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($attoseconds_per_tick+4)|0);
      var $104$1=HEAP32[(($st$9$1)>>2)];
      var $105$0 = (tempBigIntR=((($103$0)>>>0)+((($103$1)|0)*4294967296))/((($104$0)>>>0)+((($104$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $105$1 = Math.min(Math.floor(((tempBigIntR=((($103$0)>>>0)+((($103$1)|0)*4294967296))/((($104$0)>>>0)+((($104$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $106$0 = ((($102$0)>>>0)+((($102$1)|0)*4294967296))+((($105$0)>>>0)+((($105$1)|0)*4294967296))>>>0; var $106$1 = Math.min(Math.floor((((($102$0)>>>0)+((($102$1)|0)*4294967296))+((($105$0)>>>0)+((($105$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$15$0=(($target_ticks)|0);
      HEAP32[(($st$15$0)>>2)]=$106$0;
      var $st$15$1=(($target_ticks+4)|0);
      HEAP32[(($st$15$1)>>2)]=$106$1;
      var $st$19$0=(($target_ticks)|0);
      var $107$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($target_ticks+4)|0);
      var $107$1=HEAP32[(($st$19$1)>>2)];
      var $108=__ZN13video_manager20throttle_until_ticksEx($10, $107$0, $107$1);
      var $108$0=$108[0];
      var $108$1=$108[1];
      var $109=(($10+8)|0);
      var $st$27$0=(($109)|0);
      var $110$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($109+4)|0);
      var $110$1=HEAP32[(($st$27$1)>>2)];
      var $111$0 = ((($108$0)>>>0)+((($108$1)|0)*4294967296))-((($110$0)>>>0)+((($110$1)|0)*4294967296))>>>0; var $111$1 = Math.min(Math.floor((((($108$0)>>>0)+((($108$1)|0)*4294967296))-((($110$0)>>>0)+((($110$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$32$0=(($diff_ticks)|0);
      HEAP32[(($st$32$0)>>2)]=$111$0;
      var $st$32$1=(($diff_ticks+4)|0);
      HEAP32[(($st$32$1)>>2)]=$111$1;
      var $st$36$0=(($diff_ticks)|0);
      var $112$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($diff_ticks+4)|0);
      var $112$1=HEAP32[(($st$36$1)>>2)];
      var $113=(($10+8)|0);
      var $st$41$0=(($113)|0);
      var $114$0=HEAP32[(($st$41$0)>>2)];
      var $st$41$1=(($113+4)|0);
      var $114$1=HEAP32[(($st$41$1)>>2)];
      var $115$0 = ((($114$0)>>>0)+((($114$1)|0)*4294967296))+((($112$0)>>>0)+((($112$1)|0)*4294967296))>>>0; var $115$1 = Math.min(Math.floor((((($114$0)>>>0)+((($114$1)|0)*4294967296))+((($112$0)>>>0)+((($112$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$46$0=(($113)|0);
      HEAP32[(($st$46$0)>>2)]=$115$0;
      var $st$46$1=(($113+4)|0);
      HEAP32[(($st$46$1)>>2)]=$115$1;
      var $116=(($10+16)|0);
      var $st$51$0=(($diff_ticks)|0);
      var $117$0=HEAP32[(($st$51$0)>>2)];
      var $st$51$1=(($diff_ticks+4)|0);
      var $117$1=HEAP32[(($st$51$1)>>2)];
      var $st$55$0=(($attoseconds_per_tick)|0);
      var $118$0=HEAP32[(($st$55$0)>>2)];
      var $st$55$1=(($attoseconds_per_tick+4)|0);
      var $118$1=HEAP32[(($st$55$1)>>2)];
      var $119$0 = ((($117$0)>>>0)+((($117$1)|0)*4294967296))*((($118$0)>>>0)+((($118$1)|0)*4294967296))>>>0; var $119$1 = Math.min(Math.floor((((($117$0)>>>0)+((($117$1)|0)*4294967296))*((($118$0)>>>0)+((($118$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($9, 0, $119$0, $119$1);
      var $120=__ZN8attotimepLERKS_($116, $9);
      __label__ = 19; break;
    case 18: // $121
      var $122=(($10+16)|0);
      var $123=(($10+28)|0);
      var $124=$123;
      var $125=$emutime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($124)>>2)]=HEAP32[(($125)>>2)];HEAP32[(($124+4)>>2)]=HEAP32[(($125+4)>>2)];HEAP32[(($124+8)>>2)]=HEAP32[(($125+8)>>2)];
      var $126=$122;
      var $127=$123;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($126)>>2)]=HEAP32[(($127)>>2)];HEAP32[(($126+4)>>2)]=HEAP32[(($127+4)>>2)];HEAP32[(($126+8)>>2)]=HEAP32[(($127+8)>>2)];
      __label__ = 19; break;
    case 19: // $128
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager15update_throttleE8attotime["X"]=1;

function __ZN13video_manager16update_frameskipEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $speed;
      $1=$this;
      var $2=$1;
      var $3=__ZNK13video_manager18effective_throttleEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 21; break; }
    case 1: // $4
      var $5=__ZNK13video_manager23effective_autoframeskipEv($2);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $7
      var $8=(($2+118)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 3; break; } else { __label__ = 21; break; }
    case 3: // $12
      var $13=(($2+112)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($14)>>>0);
      var $16=$15*0.01;
      $speed=$16;
      var $17=(($2+64)|0);
      var $18=(tempDoubleI32[0]=HEAP32[(($17)>>2)],tempDoubleI32[1]=HEAP32[(($17+4)>>2)],tempDoubleF64[0]);
      var $19=$speed;
      var $20=$19*0.995;
      var $21=$18 >= $20;
      if ($21) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $22
      var $23=(($2+119)|0);
      var $24=HEAP8[($23)];
      var $25=(($24+1)&255);
      HEAP8[($23)]=$25;
      var $26=(($25 << 24) >> 24);
      var $27=(($26)|0) >= 3;
      if ($27) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $28
      var $29=(($2+119)|0);
      HEAP8[($29)]=0;
      var $30=(($2+117)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=(($32)|0) > 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=(($2+117)|0);
      var $36=HEAP8[($35)];
      var $37=(($36-1)&255);
      HEAP8[($35)]=$37;
      __label__ = 7; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      __label__ = 20; break;
    case 9: // $40
      var $41=(($2+64)|0);
      var $42=(tempDoubleI32[0]=HEAP32[(($41)>>2)],tempDoubleI32[1]=HEAP32[(($41+4)>>2)],tempDoubleF64[0]);
      var $43=$speed;
      var $44=$43*0.8;
      var $45=$42 < $44;
      if ($45) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $46
      var $47=$speed;
      var $48=$47*0.9;
      var $49=(($2+64)|0);
      var $50=(tempDoubleI32[0]=HEAP32[(($49)>>2)],tempDoubleI32[1]=HEAP32[(($49+4)>>2)],tempDoubleF64[0]);
      var $51=$48-$50;
      var $52=$51/0.05;
      var $53=(($2+119)|0);
      var $54=HEAP8[($53)];
      var $55=(($54 << 24) >> 24);
      var $56=$55-$52;
      var $57=(($56)|0);
      HEAP8[($53)]=$57;
      __label__ = 14; break;
    case 11: // $58
      var $59=(($2+117)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=(($61)|0) < 8;
      if ($62) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $63
      var $64=(($2+119)|0);
      var $65=HEAP8[($64)];
      var $66=(($65-1)&255);
      HEAP8[($64)]=$66;
      __label__ = 13; break;
    case 13: // $67
      __label__ = 14; break;
    case 14: // $68
      __label__ = 15; break;
    case 15: // $69
      var $70=(($2+119)|0);
      var $71=HEAP8[($70)];
      var $72=(($71 << 24) >> 24);
      var $73=(($72)|0) <= -2;
      if ($73) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $74
      var $75=(($2+119)|0);
      var $76=HEAP8[($75)];
      var $77=(($76 << 24) >> 24);
      var $78=(($77+2)|0);
      var $79=(($78) & 255);
      HEAP8[($75)]=$79;
      var $80=(($2+117)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=(($82)|0) < 10;
      if ($83) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $84
      var $85=(($2+117)|0);
      var $86=HEAP8[($85)];
      var $87=(($86+1)&255);
      HEAP8[($85)]=$87;
      __label__ = 18; break;
    case 18: // $88
      __label__ = 15; break;
    case 19: // $89
      __label__ = 20; break;
    case 20: // $90
      __label__ = 21; break;
    case 21: // $91
      var $92=(($2+118)|0);
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=(($94+1)|0);
      var $96=(($95)|0)%12;
      var $97=(($96) & 255);
      var $98=(($2+118)|0);
      HEAP8[($98)]=$97;
      var $99=(($2+118)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=__ZNK13video_manager19effective_frameskipEv($2);
      var $103=((STRING_TABLE.__ZN13video_manager11s_skiptableE+$102*12)|0);
      var $104=(($103+$101)|0);
      var $105=HEAP8[($104)];
      var $106=(($105 << 24) >> 24)!=0;
      var $107=(($2+120)|0);
      var $108=(($106)&1);
      HEAP8[($107)]=$108;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager16update_frameskipEv["X"]=1;

function __ZL32debugger_within_instruction_hookR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$machine;
      var $3=$2;
      var $4=(($3+584)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5 & 1;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=__Z33debug_cpu_within_instruction_hookR15running_machine($9);
      $1=$10;
      __label__ = 3; break;
    case 2: // $11
      $1=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$1;
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13video_manager10speed_textER7astring($this, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $paused;
      var $partials;
      var $screen;
      $1=$this;
      $2=$string;
      var $3=$1;
      var $4=$2;
      var $5=__ZN7astring5resetEv($4);
      var $6=__ZNK13video_manager7machineEv($3);
      var $7=__ZNK15running_machine6pausedEv($6);
      var $8=(($7)&1);
      $paused=$8;
      var $9=$paused;
      var $10=(($9) & 1);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      var $13=__ZN7astring3catEPKc($12, ((STRING_TABLE.__str54839)|0));
      __label__ = 9; break;
    case 2: // $14
      var $15=(($3+101)|0);
      var $16=HEAP8[($15)];
      var $17=(($16) & 1);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=__ZN7astring3catEPKc($19, ((STRING_TABLE.__str64840)|0));
      __label__ = 8; break;
    case 4: // $21
      var $22=__ZNK13video_manager23effective_autoframeskipEv($3);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$2;
      var $26=__ZNK13video_manager19effective_frameskipEv($3);
      var $27=__ZN7astring9catprintfEPKcz($25, ((STRING_TABLE.__str74841)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=10,tempInt));
      __label__ = 7; break;
    case 6: // $28
      var $29=$2;
      var $30=__ZNK13video_manager19effective_frameskipEv($3);
      var $31=__ZN7astring9catprintfEPKcz($29, ((STRING_TABLE.__str84842)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$30,HEAP32[((tempInt+4)>>2)]=10,tempInt));
      __label__ = 7; break;
    case 7: // $32
      __label__ = 8; break;
    case 8: // $33
      __label__ = 9; break;
    case 9: // $34
      var $35=$paused;
      var $36=(($35) & 1);
      if ($36) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $37
      var $38=$2;
      var $39=(($3+64)|0);
      var $40=(tempDoubleI32[0]=HEAP32[(($39)>>2)],tempDoubleI32[1]=HEAP32[(($39+4)>>2)],tempDoubleF64[0]);
      var $41=$40*100;
      var $42=$41+0.5;
      var $43=(($42)|0);
      var $44=__ZN7astring9catprintfEPKcz($38, ((STRING_TABLE.__str94843)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$43,tempInt));
      __label__ = 11; break;
    case 11: // $45
      $partials=0;
      var $46=__ZNK13video_manager7machineEv($3);
      var $47=__ZNK15running_machine12first_screenEv($46);
      $screen=$47;
      __label__ = 12; break;
    case 12: // $48
      var $49=$screen;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $51
      var $52=$screen;
      var $53=__ZNK13screen_device15partial_updatesEv($52);
      var $54=$partials;
      var $55=(($54+$53)|0);
      $partials=$55;
      __label__ = 14; break;
    case 14: // $56
      var $57=$screen;
      var $58=__ZNK13screen_device11next_screenEv($57);
      $screen=$58;
      __label__ = 12; break;
    case 15: // $59
      var $60=$partials;
      var $61=(($60)|0) > 1;
      if ($61) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $62
      var $63=$2;
      var $64=$partials;
      var $65=__ZN7astring9catprintfEPKcz($63, ((STRING_TABLE.__str104844)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$64,tempInt));
      __label__ = 17; break;
    case 17: // $66
      var $67=$2;
      ;
      return $67;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager10speed_textER7astring["X"]=1;

function __ZNK13video_manager23effective_autoframeskipEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+101)|0);
      var $5=HEAP8[($4)];
      var $6=(($5) & 1);
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=__ZNK13video_manager7machineEv($3);
      var $9=__ZNK15running_machine6pausedEv($8);
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=0;
      __label__ = 4; break;
    case 3: // $11
      var $12=(($3+108)|0);
      var $13=HEAP8[($12)];
      var $14=(($13) & 1);
      var $15=(($14)&1);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13video_manager15recompute_speedE8attotime($this, $emutime) {
  var __stackBase__  = STACKTOP; STACKTOP += 308; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $emutime; $emutime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($emutime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($emutime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($emutime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $delta_emutime=__stackBase__;
      var $2=__stackBase__+12;
      var $realtime=__stackBase__+24;
      var $delta_realtime=__stackBase__+32;
      var $tps=__stackBase__+40;
      var $file=__stackBase__+48;
      var $filerr;
      var $3;
      var $4;
      $1=$this;
      var $5=$1;
      var $6=(($5+44)|0);
      var $st$13$0=(($6)|0);
      var $7$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $8=$7$0 == $$emscripten$temp$0$0 && $7$1 == $$emscripten$temp$0$1;
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=__ZNK13video_manager7machineEv($5);
      var $11=__ZNK15running_machine6pausedEv($10);
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=_osd_ticks();
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $14=(($5+44)|0);
      var $st$4$0=(($14)|0);
      HEAP32[(($st$4$0)>>2)]=$13$0;
      var $st$4$1=(($14+4)|0);
      HEAP32[(($st$4$1)>>2)]=$13$1;
      var $15=(($5+52)|0);
      var $16=$15;
      var $17=$emutime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[(($17)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[(($17+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[(($17+8)>>2)];
      __label__ = 3; break;
    case 3: // $18
      var $19=(($5+52)|0);
      __ZmiRK8attotimeS1_($delta_emutime, $emutime, $19);
      var $$emscripten$temp$1$0=-371654656;
      var $$emscripten$temp$1$1=58207660;
      __ZN8attotimeC1Eix($2, 0, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      var $20=__ZgtRK8attotimeS1_($delta_emutime, $2);
      if ($20) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $21
      var $22=_osd_ticks();
      var $22$0=$22[0];
      var $22$1=$22[1];
      var $st$3$0=(($realtime)|0);
      HEAP32[(($st$3$0)>>2)]=$22$0;
      var $st$3$1=(($realtime+4)|0);
      HEAP32[(($st$3$1)>>2)]=$22$1;
      var $st$7$0=(($realtime)|0);
      var $23$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($realtime+4)|0);
      var $23$1=HEAP32[(($st$7$1)>>2)];
      var $24=(($5+44)|0);
      var $st$12$0=(($24)|0);
      var $25$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$12$1)>>2)];
      var $26$0 = ((($23$0)>>>0)+((($23$1)|0)*4294967296))-((($25$0)>>>0)+((($25$1)|0)*4294967296))>>>0; var $26$1 = Math.min(Math.floor((((($23$0)>>>0)+((($23$1)|0)*4294967296))-((($25$0)>>>0)+((($25$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$17$0=(($delta_realtime)|0);
      HEAP32[(($st$17$0)>>2)]=$26$0;
      var $st$17$1=(($delta_realtime+4)|0);
      HEAP32[(($st$17$1)>>2)]=$26$1;
      var $27=_osd_ticks_per_second();
      var $27$0=$27[0];
      var $27$1=$27[1];
      var $st$24$0=(($tps)|0);
      HEAP32[(($st$24$0)>>2)]=$27$0;
      var $st$24$1=(($tps+4)|0);
      HEAP32[(($st$24$1)>>2)]=$27$1;
      var $28=__ZNK8attotime9as_doubleEv($delta_emutime);
      var $st$29$0=(($tps)|0);
      var $29$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($tps+4)|0);
      var $29$1=HEAP32[(($st$29$1)>>2)];
      var $30=$29$0 + $29$1*4294967296;
      var $31=$28*$30;
      var $st$35$0=(($delta_realtime)|0);
      var $32$0=HEAP32[(($st$35$0)>>2)];
      var $st$35$1=(($delta_realtime+4)|0);
      var $32$1=HEAP32[(($st$35$1)>>2)];
      var $33=$32$0 + $32$1*4294967296;
      var $34=$31/$33;
      var $35=(($5+64)|0);
      (tempDoubleF64[0]=$34,HEAP32[(($35)>>2)]=tempDoubleI32[0],HEAP32[(($35+4)>>2)]=tempDoubleI32[1]);
      var $st$43$0=(($realtime)|0);
      var $36$0=HEAP32[(($st$43$0)>>2)];
      var $st$43$1=(($realtime+4)|0);
      var $36$1=HEAP32[(($st$43$1)>>2)];
      var $37=(($5+44)|0);
      var $st$48$0=(($37)|0);
      HEAP32[(($st$48$0)>>2)]=$36$0;
      var $st$48$1=(($37+4)|0);
      HEAP32[(($st$48$1)>>2)]=$36$1;
      var $38=(($5+52)|0);
      var $39=$38;
      var $40=$emutime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];HEAP32[(($39+4)>>2)]=HEAP32[(($40+4)>>2)];HEAP32[(($39+8)>>2)]=HEAP32[(($40+8)>>2)];
      var $41=(($5+101)|0);
      var $42=HEAP8[($41)];
      var $43=(($42) & 1);
      if ($43) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $44
      var $45=(($5+96)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+1)|0);
      HEAP32[(($45)>>2)]=$47;
      __label__ = 7; break;
    case 6: // $48
      var $49=(($5+96)|0);
      HEAP32[(($49)>>2)]=0;
      __label__ = 7; break;
    case 7: // $50
      var $51=(($5+96)|0);
      var $52=HEAPU32[(($51)>>2)];
      var $53=(($52)>>>0) >= 4;
      if ($53) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $54
      var $st$0$0=(($delta_realtime)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta_realtime+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      var $56=(($5+76)|0);
      var $st$5$0=(($56)|0);
      var $57$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($56+4)|0);
      var $57$1=HEAP32[(($st$5$1)>>2)];
      var $58$0 = ((($57$0)>>>0)+((($57$1)|0)*4294967296))+((($55$0)>>>0)+((($55$1)|0)*4294967296))>>>0; var $58$1 = Math.min(Math.floor((((($57$0)>>>0)+((($57$1)|0)*4294967296))+((($55$0)>>>0)+((($55$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($56)|0);
      HEAP32[(($st$10$0)>>2)]=$58$0;
      var $st$10$1=(($56+4)|0);
      HEAP32[(($st$10$1)>>2)]=$58$1;
      __label__ = 9; break;
    case 9: // $59
      var $60=(($5+76)|0);
      var $st$1$0=(($60)|0);
      var $61$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($60+4)|0);
      var $61$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($tps)|0);
      var $62$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($tps+4)|0);
      var $62$1=HEAP32[(($st$5$1)>>2)];
      var $63=($61$1|0) >= ($62$1|0) && (($61$1|0) >  ($62$1|0) || ($61$0|0) >= ($62$0|0));
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      var $st$0$0=(($tps)|0);
      var $65$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($tps+4)|0);
      var $65$1=HEAP32[(($st$0$1)>>2)];
      var $66=(($5+76)|0);
      var $st$5$0=(($66)|0);
      var $67$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($66+4)|0);
      var $67$1=HEAP32[(($st$5$1)>>2)];
      var $68$0 = ((($67$0)>>>0)+((($67$1)|0)*4294967296))-((($65$0)>>>0)+((($65$1)|0)*4294967296))>>>0; var $68$1 = Math.min(Math.floor((((($67$0)>>>0)+((($67$1)|0)*4294967296))-((($65$0)>>>0)+((($65$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($66)|0);
      HEAP32[(($st$10$0)>>2)]=$68$0;
      var $st$10$1=(($66+4)|0);
      HEAP32[(($st$10$1)>>2)]=$68$1;
      var $69=(($5+72)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+1)|0);
      HEAP32[(($69)>>2)]=$71;
      __label__ = 9; break;
    case 11: // $72
      var $73=(($5+84)|0);
      var $74=__ZN8attotimepLERKS_($73, $delta_emutime);
      __label__ = 12; break;
    case 12: // $75
      __label__ = 13; break;
    case 13: // $76
      var $77=(($5+104)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 14; break; } else { __label__ = 27; break; }
    case 14: // $80
      var $81=(($emutime)|0);
      var $82=HEAPU32[(($81)>>2)];
      var $83=(($5+104)|0);
      var $84=HEAPU32[(($83)>>2)];
      var $85=(($82)>>>0) >= (($84)>>>0);
      if ($85) { __label__ = 15; break; } else { __label__ = 27; break; }
    case 15: // $86
      var $87=__ZNK13video_manager7machineEv($5);
      var $88=(($87+560)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 16; break; } else { __label__ = 26; break; }
    case 16: // $91
      var $92=__ZNK13video_manager7machineEv($5);
      var $93=__ZNK15running_machine7optionsEv($92);
      var $94=__ZNK11emu_options18snapshot_directoryEv($93);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $94, 14);
      var $95=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 23; break; };
    case 17: // $96
      var $97=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 23; break; };
    case 18: // $98
      var $99=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_($file, $97, ((STRING_TABLE.__str244858)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 23; break; };
    case 19: // $100
      $filerr=$99;
      var $101=$filerr;
      var $102=(($101)|0)==0;
      if ($102) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $103
      var $104=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 23; break; };
    case 21: // $105
      var $106=(($104+560)|0);
      var $107=HEAP32[(($106)>>2)];
      (function() { try { __THREW__ = false; return __ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file($5, $107, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $108
      __label__ = 24; break;
    case 23: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $3=$111;
      var $112=$110.f1;
      $4=$112;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 24: // $113
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 26; break;
    case 25: // $114
      __label__ = 28; break;
    case 26: // $115
      var $116=__ZNK13video_manager7machineEv($5);
      __ZN15running_machine13schedule_exitEv($116);
      __label__ = 27; break;
    case 27: // $117
      STACKTOP = __stackBase__;
      return;
    case 28: // $118
      var $119=$3;
      var $120=$3;
      var $121=$4;
      var $122=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $120, tempValue);
      var $123=($122.f1 = $121, $122);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $124
      var $125=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager15recompute_speedE8attotime["X"]=1;

function __ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file($this, $screen, $file) {
  var __stackBase__  = STACKTOP; STACKTOP += 220; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $text1=__stackBase__;
      var $text2=__stackBase__+64;
      var $4;
      var $5;
      var $pnginfo=__stackBase__+128;
      var $palette;
      var $error;
      $1=$this;
      $2=$screen;
      $3=$file;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=$2;
      var $10=$9;
      __ZN13video_manager22create_snapshot_bitmapEP8device_t($6, $10);
      __ZN7astringC1EPKcS1_S1_($text1, ((STRING_TABLE.__str114845)|0), ((STRING_TABLE.__str124846)|0), ((STRING_TABLE._build_version)|0));
      var $11=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 24; break; };
    case 3: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 24; break; };
    case 4: // $14
      var $15=(($13+20)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 24; break; };
    case 5: // $18
      var $19=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 24; break; };
    case 6: // $20
      var $21=(($19+12)|0);
      var $22=HEAP32[(($21)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKcS1_S1_($text2, $16, ((STRING_TABLE.__str124846)|0), $22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 24; break; }
    case 7: // $23
      var $24=$pnginfo;
      for (var $$dest = $24>>2, $$stop = $$dest + 23; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      var $25=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 25; break; };
    case 8: // $26
      var $27=(function() { try { __THREW__ = false; return __Z12png_add_textP9_png_infoPKcS2_($pnginfo, ((STRING_TABLE.__str134847)|0), $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 25; break; };
    case 9: // $28
      var $29=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 25; break; };
    case 10: // $30
      var $31=(function() { try { __THREW__ = false; return __Z12png_add_textP9_png_infoPKcS2_($pnginfo, ((STRING_TABLE.__str144848)|0), $29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 25; break; };
    case 11: // $32
      var $33=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 25; break; };
    case 12: // $34
      var $35=(($33+564)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $38
      var $39=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 25; break; };
    case 14: // $40
      var $41=(($39+564)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(function() { try { __THREW__ = false; return __Z27palette_entry_list_adjustedP10_palette_t($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 25; break; };
    case 15: // $44
      var $47 = $43;__label__ = 17; break;
    case 16: // $45
      var $47 = 0;__label__ = 17; break;
    case 17: // $46
      var $47;
      $palette=$47;
      var $48=$3;
      var $49=(function() { try { __THREW__ = false; return __ZN8emu_filecvP10_core_fileEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 25; break; };
    case 18: // $50
      var $51=(($6+136)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 25; break; };
    case 19: // $54
      var $55=(function() { try { __THREW__ = false; return __ZNK15running_machine12total_colorsEv($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 25; break; };
    case 20: // $56
      var $57=$palette;
      var $58=(function() { try { __THREW__ = false; return __Z16png_write_bitmapP10_core_fileP9_png_infoP8bitmap_tiPKj($49, $pnginfo, $52, $55, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 25; break; };
    case 21: // $59
      $error=$58;
      var $60=$error;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $62
      var $63=$error;
      (function() { try { __THREW__ = false; return __Z17mame_printf_errorPKcz(((STRING_TABLE.__str154849)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $64
      __label__ = 26; break;
    case 24: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $67=$66.f0;
      $4=$67;
      var $68=$66.f1;
      $5=$68;
      __label__ = 30; break;
    case 25: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $71=$70.f0;
      $4=$71;
      var $72=$70.f1;
      $5=$72;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 26: // $73
      (function() { try { __THREW__ = false; return __Z8png_freeP9_png_info($pnginfo) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 25; break; }
    case 27: // $74
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 24; break; }
    case 28: // $75
      FUNCTION_TABLE[__ZN7astringD1Ev]($text1);
      STACKTOP = __stackBase__;
      return;
    case 29: // $76
      __label__ = 30; break;
    case 30: // $77
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $78
      __label__ = 32; break;
    case 32: // $79
      var $80=$4;
      var $81=$4;
      var $82=$5;
      var $83=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $81, tempValue);
      var $84=($83.f1 = $82, $83);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file["X"]=1;

function __ZN13video_manager22create_snapshot_bitmapEP8device_t($this, $screen) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $view_index;
      var $width=__stackBase__+36;
      var $height=__stackBase__+40;
      var $11;
      var $12;
      var $primlist;
      $9=$this;
      $10=$screen;
      var $13=$9;
      var $14=(($13+140)|0);
      var $15=HEAP8[($14)];
      var $16=(($15) & 1);
      if ($16) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $17
      var $18=$10;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $20
      var $21=__ZNK13video_manager7machineEv($13);
      var $22=__ZNK15running_machine10devicelistEv($21);
      var $23=HEAP32[((_SCREEN)>>2)];
      var $24=$10;
      var $25=__ZNK8device_t3tagEv($24);
      var $26=__ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jES6_($22, $23, $25);
      $view_index=$26;
      __label__ = 3; break;
    case 3: // $27
      __label__ = 4; break;
    case 4: // $28
      var $29=(($13+132)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$view_index;
      __ZN13render_target8set_viewEi($30, $31);
      __label__ = 5; break;
    case 5: // $32
      var $33=(($13+144)|0);
      var $34=HEAP32[(($33)>>2)];
      HEAP32[(($width)>>2)]=$34;
      var $35=(($13+148)|0);
      var $36=HEAP32[(($35)>>2)];
      HEAP32[(($height)>>2)]=$36;
      var $37=HEAP32[(($width)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $39
      var $40=HEAP32[(($height)>>2)];
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      var $43=(($13+132)|0);
      var $44=HEAP32[(($43)>>2)];
      __ZN13render_target20compute_minimum_sizeERiS0_($44, $width, $height);
      __label__ = 8; break;
    case 8: // $45
      var $46=(($13+132)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=HEAP32[(($width)>>2)];
      var $49=HEAP32[(($height)>>2)];
      __ZN13render_target10set_boundsEiif($47, $48, $49, 0);
      var $50=(($13+136)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $53
      var $54=HEAP32[(($width)>>2)];
      var $55=(($13+136)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56;
      var $58=(($57+12)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($54)|0)!=(($59)|0);
      if ($60) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $61
      var $62=HEAP32[(($height)>>2)];
      var $63=(($13+136)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$64;
      var $66=(($65+16)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($62)|0)!=(($67)|0);
      if ($68) { __label__ = 11; break; } else { __label__ = 27; break; }
    case 11: // $69
      var $70=(($13+136)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $73
      var $74=__ZNK13video_manager7machineEv($13);
      var $75=__ZN15running_machine7respoolEv($74);
      var $76=(($13+136)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$77;
      __ZN13resource_pool6removeEPv($75, $78);
      __label__ = 13; break;
    case 13: // $79
      var $80=__ZNK13video_manager7machineEv($13);
      var $81=__ZN15running_machine7respoolEv($80);
      var $82=$4;
      var $83=$5;
      var $84=$6;
      var $85=$result_i;
      var $86=$7;
      var $87=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str194853)|0);
      HEAP32[(($6)>>2)]=1083;
      var $88=HEAP32[(($4)>>2)];
      var $89=HEAP32[(($5)>>2)];
      var $90=HEAP32[(($6)>>2)];
      var $91=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($88, $89, $90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $92
      HEAP32[(($result_i)>>2)]=$91;
      var $93=HEAP32[(($result_i)>>2)];
      var $94=(($93)|0)==0;
      if ($94) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $95
      var $96=___cxa_allocate_exception(4);
      var $97=$96;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($97);
      (function() { try { __THREW__ = false; return ___cxa_throw($96, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; }
    case 16: // $98
      var $99=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $100=$99.f0;
      HEAP32[(($7)>>2)]=$100;
      var $101=$99.f1;
      HEAP32[(($8)>>2)]=$101;
      var $102=HEAP32[(($8)>>2)];
      var $103=(($102)|0) < 0;
      if ($103) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $104
      var $105=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($105);
      throw "Reached an unreachable!"
    case 18: // $106
      var $107=HEAP32[(($7)>>2)];
      var $108=HEAP32[(($7)>>2)];
      var $109=HEAP32[(($8)>>2)];
      var $110=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $108, tempValue);
      var $111=($110.f1 = $109, $110);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $112
      throw "Reached an unreachable!"
    case 20: // $_ZnwjPKci_exit
      var $113=HEAP32[(($result_i)>>2)];
      var $114=$4;
      var $115=$5;
      var $116=$6;
      var $117=$result_i;
      var $118=$7;
      var $119=$8;
      var $120=$113;
      var $121=HEAP32[(($width)>>2)];
      var $122=HEAP32[(($height)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($120, $121, $122, 6, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $123
      var $124=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($81, $120);
      var $125=(($13+136)|0);
      HEAP32[(($125)>>2)]=$124;
      __label__ = 27; break;
    case 22: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $128=$127.f0;
      $11=$128;
      var $129=$127.f1;
      $12=$129;
      var $130=$1;
      var $131=$2;
      var $132=$3;
      HEAP32[(($1)>>2)]=$113;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str194853)|0);
      HEAP32[(($3)>>2)]=1083;
      var $133=HEAP32[(($1)>>2)];
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $135
      var $136=HEAP32[(($1)>>2)];
      var $137=HEAP32[(($2)>>2)];
      var $138=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($136, $137, $138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 29; break; }
    case 24: // $_noexc
      __label__ = 25; break;
    case 25: // $_ZdlPvPKci_exit
      var $139=$1;
      var $140=$2;
      var $141=$3;
      __label__ = 26; break;
    case 26: // $142
      __label__ = 28; break;
    case 27: // $143
      var $144=(($13+132)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=__ZN13render_target14get_primitivesEv($145);
      $primlist=$146;
      var $147=$primlist;
      __ZN21render_primitive_list12acquire_lockEv($147);
      var $148=$primlist;
      var $149=(($13+136)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$150;
      var $152=(($151+4)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=HEAP32[(($width)>>2)];
      var $155=HEAP32[(($height)>>2)];
      var $156=(($13+136)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$157;
      var $159=(($158+8)|0);
      var $160=HEAP32[(($159)>>2)];
      __ZL22rgb888_draw_primitivesRK21render_primitive_listPvjjj($148, $153, $154, $155, $160);
      var $161=$primlist;
      __ZN21render_primitive_list12release_lockEv($161);
      STACKTOP = __stackBase__;
      return;
    case 28: // $162
      var $163=$11;
      var $164=$11;
      var $165=$12;
      var $166=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $164, tempValue);
      var $167=($166.f1 = $165, $166);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $168
      var $169=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager22create_snapshot_bitmapEP8device_t["X"]=1;

function __ZN13video_manager28save_active_screen_snapshotsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 520; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $screen;
      var $file=__stackBase__;
      var $filerr;
      var $2;
      var $3;
      var $file1=__stackBase__+260;
      var $filerr2;
      $1=$this;
      var $4=$1;
      var $5=(($4+140)|0);
      var $6=HEAP8[($5)];
      var $7=(($6) & 1);
      if ($7) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $8
      var $9=__ZNK13video_manager7machineEv($4);
      var $10=__ZNK15running_machine12first_screenEv($9);
      $screen=$10;
      __label__ = 2; break;
    case 2: // $11
      var $12=$screen;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $14
      var $15=__ZNK13video_manager7machineEv($4);
      var $16=__ZNK15running_machine6renderEv($15);
      var $17=$screen;
      var $18=__ZNK14render_manager7is_liveER13screen_device($16, $17);
      if ($18) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $19
      var $20=__ZNK13video_manager7machineEv($4);
      var $21=__ZNK15running_machine7optionsEv($20);
      var $22=__ZNK11emu_options18snapshot_directoryEv($21);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $22, 14);
      var $23=(function() { try { __THREW__ = false; return __ZN13video_manager9open_nextER8emu_filePKc($4, $file, ((STRING_TABLE.__str164850)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $24
      $filerr=$23;
      var $25=$filerr;
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $27
      var $28=$screen;
      (function() { try { __THREW__ = false; return __ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file($4, $28, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      __label__ = 9; break;
    case 8: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $2=$32;
      var $33=$31.f1;
      $3=$33;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 9: // $34
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 11; break;
    case 10: // $35
      __label__ = 22; break;
    case 11: // $36
      __label__ = 12; break;
    case 12: // $37
      var $38=$screen;
      var $39=__ZNK13screen_device11next_screenEv($38);
      $screen=$39;
      __label__ = 2; break;
    case 13: // $40
      __label__ = 21; break;
    case 14: // $41
      var $42=__ZNK13video_manager7machineEv($4);
      var $43=__ZNK15running_machine7optionsEv($42);
      var $44=__ZNK11emu_options18snapshot_directoryEv($43);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file1, $44, 14);
      var $45=(function() { try { __THREW__ = false; return __ZN13video_manager9open_nextER8emu_filePKc($4, $file1, ((STRING_TABLE.__str164850)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 18; break; };
    case 15: // $46
      $filerr2=$45;
      var $47=$filerr2;
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $49
      (function() { try { __THREW__ = false; return __ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file($4, 0, $file1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $50
      __label__ = 19; break;
    case 18: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $2=$53;
      var $54=$52.f1;
      $3=$54;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 19: // $55
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file1);
      __label__ = 21; break;
    case 20: // $56
      __label__ = 22; break;
    case 21: // $57
      STACKTOP = __stackBase__;
      return;
    case 22: // $58
      var $59=$2;
      var $60=$2;
      var $61=$3;
      var $62=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $60, tempValue);
      var $63=($62.f1 = $61, $62);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 23: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager28save_active_screen_snapshotsEv["X"]=1;

function __ZN13video_manager13end_recordingEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+156)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+156)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z9avi_closeP9_avi_file($8);
      var $10=(($2+156)|0);
      HEAP32[(($10)>>2)]=0;
      __label__ = 2; break;
    case 2: // $11
      var $12=(($2+152)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=(($2+152)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZN8emu_filecvP10_core_fileEv($17);
      var $19=__Z16mng_capture_stopP10_core_file($18);
      var $20=__ZNK13video_manager7machineEv($2);
      var $21=__ZN15running_machine7respoolEv($20);
      var $22=(($2+152)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      __ZN13resource_pool6removeEPv($21, $24);
      var $25=(($2+152)|0);
      HEAP32[(($25)>>2)]=0;
      __label__ = 4; break;
    case 4: // $26
      var $27=(($2+184)|0);
      HEAP32[(($27)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13video_manager22add_sound_to_recordingEPKsi($this, $sound, $numsamples) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $avierr;
      $1=$this;
      $2=$sound;
      $3=$numsamples;
      var $4=$1;
      var $5=(($4+156)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $8
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 271);
      var $9=(($4+156)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=(($11)|0);
      var $13=$3;
      var $14=__Z24avi_append_sound_samplesP9_avi_fileiPKsjj($10, 0, $12, $13, 1);
      $avierr=$14;
      var $15=$avierr;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=(($4+156)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=(($20+2)|0);
      var $22=$3;
      var $23=__Z24avi_append_sound_samplesP9_avi_fileiPKsjj($19, 1, $21, $22, 1);
      $avierr=$23;
      __label__ = 3; break;
    case 3: // $24
      var $25=$avierr;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      __ZN13video_manager13end_recordingEv($4);
      __label__ = 5; break;
    case 5: // $28
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 6; break;
    case 6: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZmlRK8attotimej($agg_result, $left, $factor) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$left;
  $2=$factor;
  var $3=$1;
  var $4=$agg_result;
  var $5=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($4)>>2)]=HEAP32[(($5)>>2)];HEAP32[(($4+4)>>2)]=HEAP32[(($5+4)>>2)];HEAP32[(($4+8)>>2)]=HEAP32[(($5+8)>>2)];
  var $6=$2;
  var $7=__ZN8attotimemLEj($agg_result, $6);
  ;
  return;
}


function __ZN13video_manager9open_nextER8emu_filePKc($this, $file, $extension) {
  var __stackBase__  = STACKTOP; STACKTOP += 452; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $origflags;
      var $snapname;
      var $snapstr=__stackBase__;
      var $index;
      var $5;
      var $6;
      var $snapdev=__stackBase__+64;
      var $pos;
      var $name_found;
      var $end1;
      var $end2;
      var $end;
      var $snapdevname=__stackBase__+128;
      var $image=__stackBase__+192;
      var $gotone;
      var $tempdevname=__stackBase__+196;
      var $filename=__stackBase__+260;
      var $fname=__stackBase__+324;
      var $seqtext=__stackBase__+388;
      var $seq;
      var $filerr;
      var $7;
      $2=$this;
      $3=$file;
      $4=$extension;
      var $8=$2;
      var $9=$3;
      var $10=__ZNK8emu_file9openflagsEv($9);
      $origflags=$10;
      var $11=__ZNK13video_manager7machineEv($8);
      var $12=__ZNK15running_machine7optionsEv($11);
      var $13=__ZNK11emu_options9snap_nameEv($12);
      $snapname=$13;
      var $14=$snapname;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $16
      var $17=$snapname;
      var $18=(($17)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $22
      $snapname=((STRING_TABLE.__str254859)|0);
      __label__ = 3; break;
    case 3: // $23
      var $24=$snapname;
      __ZN7astringC1EPKc($snapstr, $24);
      var $25=(function() { try { __THREW__ = false; return __ZNK7astring4rchrEii($snapstr, 0, 46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $26
      $index=$25;
      var $27=$index;
      var $28=(($27)|0)!=-1;
      if ($28) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $29
      var $30=$index;
      var $31=(function() { try { __THREW__ = false; return __ZN7astring6substrEii($snapstr, 0, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $32
      __label__ = 8; break;
    case 7: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $5=$35;
      var $36=$34.f1;
      $6=$36;
      __label__ = 111; break;
    case 8: // $37
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($snapdev, ((STRING_TABLE.__str264860)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 9: // $38
      var $39=(function() { try { __THREW__ = false; return __ZNK7astring4findEiRKS_($snapstr, 0, $snapdev) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; };
    case 10: // $40
      $pos=$39;
      var $41=$pos;
      var $42=(($41)|0)!=-1;
      if ($42) { __label__ = 11; break; } else { __label__ = 72; break; }
    case 11: // $43
      var $44=$pos;
      var $45=(($44+3)|0);
      var $46=(function() { try { __THREW__ = false; return __ZNK7astring4findEiRKS_($snapstr, $45, $snapdev) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $47
      var $48=(($46)|0)!=-1;
      if ($48) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $49
      var $50=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($snapstr, ((STRING_TABLE.__str254859)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; };
    case 14: // $51
      __label__ = 71; break;
    case 15: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $5=$54;
      var $55=$53.f1;
      $6=$55;
      __label__ = 109; break;
    case 16: // $56
      $name_found=0;
      var $57=$pos;
      var $58=(($57+3)|0);
      var $59=(function() { try { __THREW__ = false; return __ZNK7astring4findEiPKc($snapstr, $58, ((STRING_TABLE.__str274861)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $60
      $end1=$59;
      var $61=$pos;
      var $62=(($61+3)|0);
      var $63=(function() { try { __THREW__ = false; return __ZNK7astring4findEiPKc($snapstr, $62, ((STRING_TABLE.__str284862)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; };
    case 18: // $64
      $end2=$63;
      $end=-1;
      var $65=$end1;
      var $66=(($65)|0)!=-1;
      if ($66) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $67
      var $68=$end2;
      var $69=(($68)|0)!=-1;
      if ($69) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $70
      var $71=$end1;
      var $72=$end2;
      var $73=(($71)|0) < (($72)|0);
      var $74=$end1;
      var $75=$end2;
      var $76=$73 ? $74 : $75;
      $end=$76;
      __label__ = 29; break;
    case 21: // $77
      var $78=$end1;
      var $79=(($78)|0)!=-1;
      if ($79) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $80
      var $81=$end1;
      $end=$81;
      __label__ = 28; break;
    case 23: // $82
      var $83=$end2;
      var $84=(($83)|0)!=-1;
      if ($84) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $85
      var $86=$end2;
      $end=$86;
      __label__ = 27; break;
    case 25: // $87
      var $88=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($snapstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 15; break; };
    case 26: // $89
      $end=$88;
      __label__ = 27; break;
    case 27: // $90
      __label__ = 28; break;
    case 28: // $91
      __label__ = 29; break;
    case 29: // $92
      var $93=$end;
      var $94=$pos;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 3;
      if ($96) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $97
      (function() { try { __THREW__ = false; return __Z10fatalerrorPKcz(((STRING_TABLE.__str294863)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 15; break; }
    case 31: // $98
      throw "Reached an unreachable!"
    case 32: // $99
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($snapdevname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 15; break; }
    case 33: // $100
      var $101=$pos;
      var $102=(($101+3)|0);
      var $103=$end;
      var $104=$pos;
      var $105=(($103-$104)|0);
      var $106=(($105-3)|0);
      var $107=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($snapdevname, $snapstr, $102, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 53; break; };
    case 34: // $108
      HEAP32[(($image)>>2)]=0;
      var $109=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 53; break; };
    case 35: // $110
      var $111=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 53; break; };
    case 36: // $112
      var $113=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI22device_image_interfaceEEbRPT_($111, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 53; break; };
    case 37: // $114
      var $115=(($113)&1);
      $gotone=$115;
      __label__ = 38; break;
    case 38: // $116
      var $117=$gotone;
      var $118=(($117) & 1);
      if ($118) { __label__ = 39; break; } else { __label__ = 64; break; }
    case 39: // $119
      var $120=HEAP32[(($image)>>2)];
      var $121=(function() { try { __THREW__ = false; return __ZNK22device_image_interface19brief_instance_nameEv($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 53; break; };
    case 40: // $122
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($tempdevname, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 53; break; }
    case 41: // $123
      var $124=(function() { try { __THREW__ = false; return __ZNK7astring3cmpERKS_($snapdevname, $tempdevname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 54; break; };
    case 42: // $125
      var $126=(($124)|0)==0;
      if ($126) { __label__ = 43; break; } else { __label__ = 58; break; }
    case 43: // $127
      var $128=HEAP32[(($image)>>2)];
      var $129=(function() { try { __THREW__ = false; return __ZN22device_image_interface8basenameEv($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 54; break; };
    case 44: // $130
      var $131=(($129)|0)!=0;
      if ($131) { __label__ = 45; break; } else { __label__ = 57; break; }
    case 45: // $132
      var $133=HEAP32[(($image)>>2)];
      var $134=(function() { try { __THREW__ = false; return __ZN22device_image_interface8basenameEv($133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 54; break; };
    case 46: // $135
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($filename, $134) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 54; break; }
    case 47: // $136
      var $137=(function() { try { __THREW__ = false; return __ZNK7astring4rchrEii($filename, 0, 46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 55; break; };
    case 48: // $138
      var $139=(function() { try { __THREW__ = false; return __ZN7astring6substrEii($filename, 0, $137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 55; break; };
    case 49: // $140
      var $141=(function() { try { __THREW__ = false; return __ZN7astring7replaceEiRKS_S1_($snapstr, 0, $snapdevname, $filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 55; break; };
    case 50: // $142
      var $143=$pos;
      var $144=(function() { try { __THREW__ = false; return __ZN7astring3delEii($snapstr, $143, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 55; break; };
    case 51: // $145
      $name_found=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $146
      __label__ = 57; break;
    case 53: // $147
      var $148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $149=$148.f0;
      $5=$149;
      var $150=$148.f1;
      $6=$150;
      __label__ = 69; break;
    case 54: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      $5=$153;
      var $154=$152.f1;
      $6=$154;
      __label__ = 62; break;
    case 55: // $155
      var $156=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $157=$156.f0;
      $5=$157;
      var $158=$156.f1;
      $6=$158;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 114; break; }
    case 56: // $159
      __label__ = 62; break;
    case 57: // $160
      __label__ = 58; break;
    case 58: // $161
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempdevname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 53; break; }
    case 59: // $162
      __label__ = 60; break;
    case 60: // $163
      var $164=HEAP32[(($image)>>2)];
      var $165=$164;
      var $166=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($165, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 53; break; };
    case 61: // $167
      var $168=(($166)&1);
      $gotone=$168;
      __label__ = 38; break;
    case 62: // $169
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempdevname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 114; break; }
    case 63: // $170
      __label__ = 69; break;
    case 64: // $171
      var $172=$name_found;
      var $173=(($172)|0)==0;
      if ($173) { __label__ = 65; break; } else { __label__ = 67; break; }
    case 65: // $174
      var $175=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($snapstr, ((STRING_TABLE.__str254859)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 53; break; };
    case 66: // $176
      __label__ = 67; break;
    case 67: // $177
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($snapdevname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 15; break; }
    case 68: // $178
      __label__ = 71; break;
    case 69: // $179
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($snapdevname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 114; break; }
    case 70: // $180
      __label__ = 109; break;
    case 71: // $181
      __label__ = 72; break;
    case 72: // $182
      var $183=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($snapstr, ((STRING_TABLE.__str304864)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 15; break; };
    case 73: // $184
      var $185=$4;
      var $186=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($183, $185) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 15; break; };
    case 74: // $187
      var $188=(function() { try { __THREW__ = false; return __ZN7astring7replaceEiPKcS1_($snapstr, 0, ((STRING_TABLE.__str274861)|0), ((STRING_TABLE.__str274861)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 15; break; };
    case 75: // $189
      var $190=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 15; break; };
    case 76: // $191
      var $192=(function() { try { __THREW__ = false; return __ZNK15running_machine8basenameEv($190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 15; break; };
    case 77: // $193
      var $194=(function() { try { __THREW__ = false; return __ZN7astring7replaceEiPKcS1_($snapstr, 0, ((STRING_TABLE.__str314865)|0), $192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 15; break; };
    case 78: // $195
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 15; break; }
    case 79: // $196
      var $197=(function() { try { __THREW__ = false; return __ZNK7astring4findEiPKc($snapstr, 0, ((STRING_TABLE.__str324866)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 83; break; };
    case 80: // $198
      var $199=(($197)|0)==-1;
      if ($199) { __label__ = 81; break; } else { __label__ = 84; break; }
    case 81: // $200
      var $201=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($fname, $snapstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 83; break; };
    case 82: // $202
      __label__ = 101; break;
    case 83: // $203
      var $204=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $205=$204.f0;
      $5=$205;
      var $206=$204.f1;
      $6=$206;
      __label__ = 106; break;
    case 84: // $207
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($seqtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 83; break; }
    case 85: // $208
      var $209=$3;
      (function() { try { __THREW__ = false; return __ZN8emu_file13set_openflagsEj($209, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 95; break; }
    case 86: // $210
      $seq=0;
      __label__ = 87; break;
    case 87: // $211
      var $212=(function() { try { __THREW__ = false; return __ZN7astring3cpyERKS_($fname, $snapstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 95; break; };
    case 88: // $213
      var $214=$seq;
      var $215=(function() { try { __THREW__ = false; return __ZN7astring6formatEPKcz($seqtext, ((STRING_TABLE.__str334867)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$214,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 95; break; };
    case 89: // $216
      var $217=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($215) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 95; break; };
    case 90: // $218
      var $219=(function() { try { __THREW__ = false; return __ZN7astring7replaceEiPKcS1_($212, 0, ((STRING_TABLE.__str324866)|0), $217) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 95; break; };
    case 91: // $220
      var $221=$3;
      var $222=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 95; break; };
    case 92: // $223
      var $224=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($221, $222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 95; break; };
    case 93: // $225
      $filerr=$224;
      var $226=$filerr;
      var $227=(($226)|0)!=0;
      if ($227) { __label__ = 94; break; } else { __label__ = 96; break; }
    case 94: // $228
      __label__ = 98; break;
    case 95: // $229
      var $230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $231=$230.f0;
      $5=$231;
      var $232=$230.f1;
      $6=$232;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($seqtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 114; break; }
    case 96: // $233
      __label__ = 97; break;
    case 97: // $234
      var $235=$seq;
      var $236=(($235+1)|0);
      $seq=$236;
      __label__ = 87; break;
    case 98: // $237
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($seqtext) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 83; break; }
    case 99: // $238
      __label__ = 101; break;
    case 100: // $239
      __label__ = 106; break;
    case 101: // $240
      var $241=$3;
      var $242=$origflags;
      (function() { try { __THREW__ = false; return __ZN8emu_file13set_openflagsEj($241, $242) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 83; break; }
    case 102: // $243
      var $244=$3;
      var $245=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 83; break; };
    case 103: // $246
      var $247=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($244, $245) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 104; break; } else { __label__ = 83; break; };
    case 104: // $248
      $1=$247;
      $7=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 15; break; }
    case 105: // $249
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($snapdev) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 108; break; } else { __label__ = 7; break; }
    case 106: // $250
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 107; break; } else { __label__ = 114; break; }
    case 107: // $251
      __label__ = 109; break;
    case 108: // $252
      FUNCTION_TABLE[__ZN7astringD1Ev]($snapstr);
      var $253=$1;
      STACKTOP = __stackBase__;
      return $253;
    case 109: // $254
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($snapdev) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 114; break; }
    case 110: // $255
      __label__ = 111; break;
    case 111: // $256
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($snapstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 114; break; }
    case 112: // $257
      __label__ = 113; break;
    case 113: // $258
      var $259=$5;
      var $260=$5;
      var $261=$6;
      var $262=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $260, tempValue);
      var $263=($262.f1 = $261, $262);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 114: // $264
      var $265=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager9open_nextER8emu_filePKc["X"]=1;

function __ZN13video_manager12record_frameEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 232; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curtime=__stackBase__;
      var $avierr;
      var $pnginfo=__stackBase__+12;
      var $text1=__stackBase__+104;
      var $text2=__stackBase__+168;
      var $2;
      var $3;
      var $palette;
      var $error;
      $1=$this;
      var $4=$1;
      var $5=(($4+152)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=(($4+156)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      __label__ = 35; break;
    case 3: // $13
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 271);
      var $14=__ZNK13video_manager7machineEv($4);
      __ZNK15running_machine4timeEv($curtime, $14);
      __ZN13video_manager22create_snapshot_bitmapEP8device_t($4, 0);
      __label__ = 4; break;
    case 4: // $15
      var $16=(($4+172)|0);
      var $17=__ZleRK8attotimeS1_($16, $curtime);
      if ($17) { __label__ = 5; break; } else { __label__ = 34; break; }
    case 5: // $18
      var $19=(($4+156)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $22
      var $23=(($4+156)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($4+136)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__Z28avi_append_video_frame_rgb32P9_avi_filePK8bitmap_t($24, $26);
      $avierr=$27;
      var $28=$avierr;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $30
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __ZN13video_manager13end_recordingEv($4);
      __label__ = 35; break;
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      var $33=(($4+152)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 10; break; } else { __label__ = 33; break; }
    case 10: // $36
      var $37=$pnginfo;
      for (var $$dest = $37>>2, $$stop = $$dest + 23; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      var $38=(($4+184)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 11; break; } else { __label__ = 27; break; }
    case 11: // $41
      __ZN7astringC1EPKcS1_S1_($text1, ((STRING_TABLE.__str114845)|0), ((STRING_TABLE.__str124846)|0), ((STRING_TABLE._build_version)|0));
      var $42=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 22; break; };
    case 12: // $43
      var $44=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 22; break; };
    case 13: // $45
      var $46=(($44+20)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(function() { try { __THREW__ = false; return __ZNK13video_manager7machineEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 22; break; };
    case 14: // $49
      var $50=(function() { try { __THREW__ = false; return __ZNK15running_machine6systemEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 22; break; };
    case 15: // $51
      var $52=(($50+12)|0);
      var $53=HEAP32[(($52)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKcS1_S1_($text2, $47, ((STRING_TABLE.__str124846)|0), $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $54
      var $55=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 23; break; };
    case 17: // $56
      var $57=(function() { try { __THREW__ = false; return __Z12png_add_textP9_png_infoPKcS2_($pnginfo, ((STRING_TABLE.__str134847)|0), $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 23; break; };
    case 18: // $58
      var $59=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($text2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 23; break; };
    case 19: // $60
      var $61=(function() { try { __THREW__ = false; return __Z12png_add_textP9_png_infoPKcS2_($pnginfo, ((STRING_TABLE.__str144848)|0), $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 23; break; };
    case 20: // $62
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $63
      FUNCTION_TABLE[__ZN7astringD1Ev]($text1);
      __label__ = 27; break;
    case 22: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      $2=$66;
      var $67=$65.f1;
      $3=$67;
      __label__ = 25; break;
    case 23: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $2=$70;
      var $71=$69.f1;
      $3=$71;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 37; break; }
    case 24: // $72
      __label__ = 25; break;
    case 25: // $73
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($text1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 37; break; }
    case 26: // $74
      __label__ = 36; break;
    case 27: // $75
      var $76=__ZNK13video_manager7machineEv($4);
      var $77=(($76+564)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $80
      var $81=__ZNK13video_manager7machineEv($4);
      var $82=(($81+564)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=__Z27palette_entry_list_adjustedP10_palette_t($83);
      var $87 = $84;__label__ = 30; break;
    case 29: // $85
      var $87 = 0;__label__ = 30; break;
    case 30: // $86
      var $87;
      $palette=$87;
      var $88=(($4+152)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=__ZN8emu_filecvP10_core_fileEv($89);
      var $91=(($4+136)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=__ZNK13video_manager7machineEv($4);
      var $94=__ZNK15running_machine12total_colorsEv($93);
      var $95=$palette;
      var $96=__Z17mng_capture_frameP10_core_fileP9_png_infoP8bitmap_tiPKj($90, $pnginfo, $92, $94, $95);
      $error=$96;
      __Z8png_freeP9_png_info($pnginfo);
      var $97=$error;
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $99
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __ZN13video_manager13end_recordingEv($4);
      __label__ = 35; break;
    case 32: // $100
      __label__ = 33; break;
    case 33: // $101
      var $102=(($4+172)|0);
      var $103=(($4+160)|0);
      var $104=__ZN8attotimepLERKS_($102, $103);
      var $105=(($4+184)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+1)|0);
      HEAP32[(($105)>>2)]=$107;
      __label__ = 4; break;
    case 34: // $108
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      __label__ = 35; break;
    case 35: // $109
      STACKTOP = __stackBase__;
      return;
    case 36: // $110
      var $111=$2;
      var $112=$2;
      var $113=$3;
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager12record_frameEv["X"]=1;

function __ZN21delegate_internal_mfpC2IM13video_managerFvPviEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM13video_managerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8emu_file9openflagsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+152)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13video_manager20throttle_until_ticksEx($this, $target_ticks$0, $target_ticks$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $allowed_to_sleep;
      var $minimum_sleep=__stackBase__+8;
      var $current_ticks=__stackBase__+16;
      var $delta=__stackBase__+24;
      var $slept;
      var $new_ticks=__stackBase__+32;
      var $actual_ticks=__stackBase__+40;
      var $oversleep_milliticks=__stackBase__+48;
      $1=$this;
      var $st$11$0=(($2)|0);
      HEAP32[(($st$11$0)>>2)]=$target_ticks$0;
      var $st$11$1=(($2+4)|0);
      HEAP32[(($st$11$1)>>2)]=$target_ticks$1;
      var $3=$1;
      $allowed_to_sleep=0;
      var $4=__ZNK13video_manager7machineEv($3);
      var $5=__ZNK15running_machine7optionsEv($4);
      var $6=__ZNK11emu_options5sleepEv($5);
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=__ZNK13video_manager23effective_autoframeskipEv($3);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=__ZNK13video_manager19effective_frameskipEv($3);
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $allowed_to_sleep=1;
      __label__ = 4; break;
    case 4: // $14
      var $15=__ZNK13video_manager7machineEv($3);
      var $16=__ZNK15running_machine6pausedEv($15);
      if ($16) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      $allowed_to_sleep=1;
      __label__ = 6; break;
    case 6: // $18
      __ZN20dummy_profiler_state5startE12profile_type(_g_profiler, 283);
      var $19=_osd_ticks_per_second();
      var $19$0=$19[0];
      var $19$1=$19[1];
      var $$emscripten$temp$0$0=1000;
      var $$emscripten$temp$0$1=0;
      var $20$0 = (tempBigIntR=((($19$0)>>>0)+((($19$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $20$1 = Math.min(Math.floor(((tempBigIntR=((($19$0)>>>0)+((($19$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$7$0=(($minimum_sleep)|0);
      HEAP32[(($st$7$0)>>2)]=$20$0;
      var $st$7$1=(($minimum_sleep+4)|0);
      HEAP32[(($st$7$1)>>2)]=$20$1;
      var $21=_osd_ticks();
      var $21$0=$21[0];
      var $21$1=$21[1];
      var $st$14$0=(($current_ticks)|0);
      HEAP32[(($st$14$0)>>2)]=$21$0;
      var $st$14$1=(($current_ticks+4)|0);
      HEAP32[(($st$14$1)>>2)]=$21$1;
      __label__ = 7; break;
    case 7: // $22
      var $st$0$0=(($current_ticks)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($current_ticks+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($2)|0);
      var $24$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($2+4)|0);
      var $24$1=HEAP32[(($st$4$1)>>2)];
      var $25=($23$1|0) < ($24$1|0) || (($23$1|0) == ($24$1|0) && ($23$0|0) <  ($24$0|0));
      if ($25) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $26
      var $st$0$0=(($2)|0);
      var $27$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $27$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($current_ticks)|0);
      var $28$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($current_ticks+4)|0);
      var $28$1=HEAP32[(($st$4$1)>>2)];
      var $29$0 = ((($27$0)>>>0)+((($27$1)|0)*4294967296))-((($28$0)>>>0)+((($28$1)|0)*4294967296))>>>0; var $29$1 = Math.min(Math.floor((((($27$0)>>>0)+((($27$1)|0)*4294967296))-((($28$0)>>>0)+((($28$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=1000;
      var $$emscripten$temp$1$1=0;
      var $30$0 = ((($29$0)>>>0)+((($29$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $30$1 = Math.min(Math.floor((((($29$0)>>>0)+((($29$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $31=(($3+124)|0);
      var $st$13$0=(($31)|0);
      var $32$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$13$1)>>2)];
      var $$emscripten$temp$2$0=1000;
      var $$emscripten$temp$2$1=0;
      var $33$0 = ((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))+((($32$0)>>>0)+((($32$1)|0)*4294967296))>>>0; var $33$1 = Math.min(Math.floor((((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))+((($32$0)>>>0)+((($32$1)|0)*4294967296)))/4294967296), 4294967295);
      var $34$0 = (tempBigIntR=((($30$0)>>>0)+((($30$1)|0)*4294967296))/((($33$0)>>>0)+((($33$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $34$1 = Math.min(Math.floor(((tempBigIntR=((($30$0)>>>0)+((($30$1)|0)*4294967296))/((($33$0)>>>0)+((($33$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$21$0=(($delta)|0);
      HEAP32[(($st$21$0)>>2)]=$34$0;
      var $st$21$1=(($delta+4)|0);
      HEAP32[(($st$21$1)>>2)]=$34$1;
      $slept=0;
      var $35=$allowed_to_sleep;
      var $36=(($35) & 1);
      if ($36) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $37
      var $st$0$0=(($delta)|0);
      var $38$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $38$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($minimum_sleep)|0);
      var $39$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($minimum_sleep+4)|0);
      var $39$1=HEAP32[(($st$4$1)>>2)];
      var $40=($38$1|0) >= ($39$1|0) && (($38$1|0) >  ($39$1|0) || ($38$0|0) >= ($39$0|0));
      if ($40) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $41
      var $st$0$0=(($delta)|0);
      var $42$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $42$1=HEAP32[(($st$0$1)>>2)];
      _osd_sleep($42$0, $42$1);
      $slept=1;
      __label__ = 11; break;
    case 11: // $43
      var $44=_osd_ticks();
      var $44$0=$44[0];
      var $44$1=$44[1];
      var $st$3$0=(($new_ticks)|0);
      HEAP32[(($st$3$0)>>2)]=$44$0;
      var $st$3$1=(($new_ticks+4)|0);
      HEAP32[(($st$3$1)>>2)]=$44$1;
      var $45=$slept;
      var $46=(($45) & 1);
      if ($46) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $47
      var $st$0$0=(($new_ticks)|0);
      var $48$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($new_ticks+4)|0);
      var $48$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($current_ticks)|0);
      var $49$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($current_ticks+4)|0);
      var $49$1=HEAP32[(($st$4$1)>>2)];
      var $50$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))-((($49$0)>>>0)+((($49$1)|0)*4294967296))>>>0; var $50$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))-((($49$0)>>>0)+((($49$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($actual_ticks)|0);
      HEAP32[(($st$9$0)>>2)]=$50$0;
      var $st$9$1=(($actual_ticks+4)|0);
      HEAP32[(($st$9$1)>>2)]=$50$1;
      var $st$13$0=(($actual_ticks)|0);
      var $51$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($actual_ticks+4)|0);
      var $51$1=HEAP32[(($st$13$1)>>2)];
      var $st$17$0=(($delta)|0);
      var $52$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($delta+4)|0);
      var $52$1=HEAP32[(($st$17$1)>>2)];
      var $53=($51$1|0) > ($52$1|0) || (($51$1|0) == ($52$1|0) && ($51$0|0) >  ($52$0|0));
      if ($53) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $54
      var $st$0$0=(($actual_ticks)|0);
      var $55$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($actual_ticks+4)|0);
      var $55$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($delta)|0);
      var $56$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($delta+4)|0);
      var $56$1=HEAP32[(($st$4$1)>>2)];
      var $57$0 = ((($55$0)>>>0)+((($55$1)|0)*4294967296))-((($56$0)>>>0)+((($56$1)|0)*4294967296))>>>0; var $57$1 = Math.min(Math.floor((((($55$0)>>>0)+((($55$1)|0)*4294967296))-((($56$0)>>>0)+((($56$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$3$0=1000;
      var $$emscripten$temp$3$1=0;
      var $58$0 = ((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))*((($57$0)>>>0)+((($57$1)|0)*4294967296))>>>0; var $58$1 = Math.min(Math.floor((((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))*((($57$0)>>>0)+((($57$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($delta)|0);
      var $59$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($delta+4)|0);
      var $59$1=HEAP32[(($st$12$1)>>2)];
      var $60$0 = (tempBigIntR=((($58$0)>>>0)+((($58$1)|0)*4294967296))/((($59$0)>>>0)+((($59$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $60$1 = Math.min(Math.floor(((tempBigIntR=((($58$0)>>>0)+((($58$1)|0)*4294967296))/((($59$0)>>>0)+((($59$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$17$0=(($oversleep_milliticks)|0);
      HEAP32[(($st$17$0)>>2)]=$60$0;
      var $st$17$1=(($oversleep_milliticks+4)|0);
      HEAP32[(($st$17$1)>>2)]=$60$1;
      var $61=(($3+124)|0);
      var $st$22$0=(($61)|0);
      var $62$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($61+4)|0);
      var $62$1=HEAP32[(($st$22$1)>>2)];
      var $$emscripten$temp$4$0=99;
      var $$emscripten$temp$4$1=0;
      var $63$0 = ((($62$0)>>>0)+((($62$1)|0)*4294967296))*((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $63$1 = Math.min(Math.floor((((($62$0)>>>0)+((($62$1)|0)*4294967296))*((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$29$0=(($oversleep_milliticks)|0);
      var $64$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($oversleep_milliticks+4)|0);
      var $64$1=HEAP32[(($st$29$1)>>2)];
      var $65$0 = ((($63$0)>>>0)+((($63$1)|0)*4294967296))+((($64$0)>>>0)+((($64$1)|0)*4294967296))>>>0; var $65$1 = Math.min(Math.floor((((($63$0)>>>0)+((($63$1)|0)*4294967296))+((($64$0)>>>0)+((($64$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$5$0=100;
      var $$emscripten$temp$5$1=0;
      var $66$0 = (tempBigIntR=((($65$0)>>>0)+((($65$1)|0)*4294967296))/((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $66$1 = Math.min(Math.floor(((tempBigIntR=((($65$0)>>>0)+((($65$1)|0)*4294967296))/((($$emscripten$temp$5$0)>>>0)+((($$emscripten$temp$5$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $67=(($3+124)|0);
      var $st$38$0=(($67)|0);
      HEAP32[(($st$38$0)>>2)]=$66$0;
      var $st$38$1=(($67+4)|0);
      HEAP32[(($st$38$1)>>2)]=$66$1;
      __label__ = 14; break;
    case 14: // $68
      __label__ = 15; break;
    case 15: // $69
      var $st$0$0=(($new_ticks)|0);
      var $70$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($new_ticks+4)|0);
      var $70$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($current_ticks)|0);
      HEAP32[(($st$4$0)>>2)]=$70$0;
      var $st$4$1=(($current_ticks+4)|0);
      HEAP32[(($st$4$1)>>2)]=$70$1;
      __label__ = 7; break;
    case 16: // $71
      __ZN20dummy_profiler_state4stopEv(_g_profiler);
      var $st$1$0=(($current_ticks)|0);
      var $72$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($current_ticks+4)|0);
      var $72$1=HEAP32[(($st$1$1)>>2)];
      STACKTOP = __stackBase__;
      return [$72$0,$72$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13video_manager20throttle_until_ticksEx["X"]=1;

function __ZNK11emu_options5sleepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str384872)|0));
  ;
  return $4;
}


function __ZNK11emu_options13refresh_speedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str374871)|0));
  ;
  return $4;
}


function __ZNK11emu_options9snap_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str364870)|0));
  ;
  return $4;
}


function __ZNK7astring4findEiRKS_($this, $start, $search) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$start;
  $3=$search;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z12astring_findPK7astringiS1_($4, $5, $6);
  ;
  return $7;
}


function __ZNK7astring4findEiPKc($this, $start, $search) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$start;
  $3=$search;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__Z13astring_findcPK7astringiPKc($4, $5, $6);
  ;
  return $7;
}


function __ZN7astring7replaceEiRKS_S1_($this, $start, $search, $replace) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$start;
  $3=$search;
  $4=$replace;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__Z15astring_replaceP7astringiPKS_S2_($5, $6, $7, $8);
  ;
  return $9;
}


function __ZN8delegateIFvPviEEC2I13video_managerEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvPvi8_noparamS1_EC2I13video_managerEEN15delegate_traitsIT_vS0_iS1_S1_E16member_func_typeEPKcPS6_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_EC2I13video_managerEEN15delegate_traitsIT_vS0_iS1_S1_E16member_func_typeEPKcPS6_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM13video_managerFvPviEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=1124;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvPvi8_noparamS1_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM13video_managerFvPviEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM13video_managerFvPviEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvPvi8_noparamS1_E16late_bind_helperI13video_managerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13video_manager, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvvEEC2I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13video_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13video_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM13video_managerFvvEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=1126;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM13video_managerFvvEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM13video_managerFvvEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13video_managerEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13video_manager, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22rgb888_draw_primitivesRK21render_primitive_listPvjjj($primlist, $dstdata, $width, $height, $pitch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $prim;
      var $6;
      var $7;
      $1=$primlist;
      $2=$dstdata;
      $3=$width;
      $4=$height;
      $5=$pitch;
      var $8=$1;
      var $9=__ZNK21render_primitive_list5firstEv($8);
      $prim=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$prim;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $13
      var $14=$prim;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      if ($16 == 1) {
        __label__ = 3; break;
      }
      else if ($16 == 2) {
        __label__ = 4; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 3: // $17
      var $18=$prim;
      var $19=$2;
      var $20=$3;
      var $21=$4;
      var $22=$5;
      __ZL16rgb888_draw_linePK16render_primitivePviij($18, $19, $20, $21, $22);
      __label__ = 11; break;
    case 4: // $23
      var $24=$prim;
      var $25=(($24+44)|0);
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $29
      var $30=$prim;
      var $31=$2;
      var $32=$3;
      var $33=$4;
      var $34=$5;
      __ZL16rgb888_draw_rectPK16render_primitivePviij($30, $31, $32, $33, $34);
      __label__ = 7; break;
    case 6: // $35
      var $36=$prim;
      var $37=$2;
      var $38=$3;
      var $39=$4;
      var $40=$5;
      __ZL35rgb888_setup_and_draw_textured_quadPK16render_primitivePviij($36, $37, $38, $39, $40);
      __label__ = 7; break;
    case 7: // $41
      __label__ = 11; break;
    case 8: // $42
      var $43=___cxa_allocate_exception(1032);
      var $44=$43;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($44, ((STRING_TABLE.__str344868)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $45
      ___cxa_throw($43, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 10: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $6=$48;
      var $49=$47.f1;
      $7=$49;
      ___cxa_free_exception($43);
      __label__ = 14; break;
    case 11: // $50
      __label__ = 12; break;
    case 12: // $51
      var $52=$prim;
      var $53=__ZNK16render_primitive4nextEv($52);
      $prim=$53;
      __label__ = 1; break;
    case 13: // $54
      ;
      return;
    case 14: // $55
      var $56=$6;
      var $57=$6;
      var $58=$7;
      var $59=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $57, tempValue);
      var $60=($59.f1 = $58, $59);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22rgb888_draw_primitivesRK21render_primitive_listPvjjj["X"]=1;

function __ZL16rgb888_draw_linePK16render_primitivePviij($prim, $dstdata, $width, $height, $pitch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $dx;
      var $dy;
      var $sx;
      var $sy;
      var $cx;
      var $cy;
      var $bwidth;
      var $a1;
      var $x1;
      var $x2;
      var $y1;
      var $y2;
      var $col;
      var $xx;
      var $yy;
      var $beam;
      var $entry;
      $1=$prim;
      $2=$dstdata;
      $3=$width;
      $4=$height;
      $5=$pitch;
      var $6=$1;
      var $7=(($6+4)|0);
      var $8=(($7)|0);
      var $9=HEAPF32[(($8)>>2)];
      var $10=$9*65536;
      var $11=(($10)|0);
      $x1=$11;
      var $12=$1;
      var $13=(($12+4)|0);
      var $14=(($13+4)|0);
      var $15=HEAPF32[(($14)>>2)];
      var $16=$15*65536;
      var $17=(($16)|0);
      $y1=$17;
      var $18=$1;
      var $19=(($18+4)|0);
      var $20=(($19+8)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21*65536;
      var $23=(($22)|0);
      $x2=$23;
      var $24=$1;
      var $25=(($24+4)|0);
      var $26=(($25+12)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27*65536;
      var $29=(($28)|0);
      $y2=$29;
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+4)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33*255;
      var $35=$1;
      var $36=(($35+20)|0);
      var $37=(($36)|0);
      var $38=HEAPF32[(($37)>>2)];
      var $39=$34*$38;
      var $40=(($39)|0);
      var $41=$40 & 255;
      var $42=$41 << 16;
      var $43=-16777216 | $42;
      var $44=$1;
      var $45=(($44+20)|0);
      var $46=(($45+8)|0);
      var $47=HEAPF32[(($46)>>2)];
      var $48=$47*255;
      var $49=$1;
      var $50=(($49+20)|0);
      var $51=(($50)|0);
      var $52=HEAPF32[(($51)>>2)];
      var $53=$48*$52;
      var $54=(($53)|0);
      var $55=$54 & 255;
      var $56=$55 << 8;
      var $57=$43 | $56;
      var $58=$1;
      var $59=(($58+20)|0);
      var $60=(($59+12)|0);
      var $61=HEAPF32[(($60)>>2)];
      var $62=$61*255;
      var $63=$1;
      var $64=(($63+20)|0);
      var $65=(($64)|0);
      var $66=HEAPF32[(($65)>>2)];
      var $67=$62*$66;
      var $68=(($67)|0);
      var $69=$68 & 255;
      var $70=$57 | $69;
      $col=$70;
      var $71=$1;
      var $72=(($71+36)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73 & 4096;
      var $75=$74 >>> 12;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 1; break; } else { __label__ = 61; break; }
    case 1: // $77
      var $78=HEAP32[((((__ZL12cosine_table)|0))>>2)];
      var $79=(($78)|0)==0;
      if ($79) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $80
      $entry=0;
      __label__ = 3; break;
    case 3: // $81
      var $82=$entry;
      var $83=(($82)|0) <= 2048;
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$entry;
      var $86=(($85)|0);
      var $87=$86/2048;
      var $88=_atan($87);
      var $89=_cos($88);
      var $90=1/$89;
      var $91=$90*268435456;
      var $92=$91+0.5;
      var $93=(($92)|0);
      var $94=$entry;
      var $95=((__ZL12cosine_table+($94<<2))|0);
      HEAP32[(($95)>>2)]=$93;
      __label__ = 5; break;
    case 5: // $96
      var $97=$entry;
      var $98=(($97+1)|0);
      $entry=$98;
      __label__ = 3; break;
    case 6: // $99
      __label__ = 7; break;
    case 7: // $100
      var $101=$1;
      var $102=(($101+40)|0);
      var $103=HEAPF32[(($102)>>2)];
      var $104=$103*65536;
      var $105=(($104)|0);
      $beam=$105;
      var $106=$beam;
      var $107=(($106)|0) < 65536;
      if ($107) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $108
      $beam=65536;
      __label__ = 9; break;
    case 9: // $109
      var $110=$x1;
      var $111=$x2;
      var $112=(($110-$111)|0);
      var $113=_abs($112);
      $dx=$113;
      var $114=$y1;
      var $115=$y2;
      var $116=(($114-$115)|0);
      var $117=_abs($116);
      $dy=$117;
      var $118=$dx;
      var $119=$dy;
      var $120=(($118)|0) >= (($119)|0);
      if ($120) { __label__ = 10; break; } else { __label__ = 35; break; }
    case 10: // $121
      var $122=$x1;
      var $123=$x2;
      var $124=(($122)|0) <= (($123)|0);
      var $125=$124 ? 1 : -1;
      $sx=$125;
      var $126=$dy;
      var $127=(($126)|0)==0;
      if ($127) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $128
      var $136 = 0;__label__ = 13; break;
    case 12: // $129
      var $130=$y2;
      var $131=$y1;
      var $132=(($130-$131)|0);
      var $133=$dx;
      var $134=__ZL15div_32x32_shiftiih4901($132, $133, 16);
      var $136 = $134;__label__ = 13; break;
    case 13: // $135
      var $136;
      $sy=$136;
      var $137=$sy;
      var $138=(($137)|0) < 0;
      if ($138) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $139
      var $140=$dy;
      var $141=(($140-1)|0);
      $dy=$141;
      __label__ = 15; break;
    case 15: // $142
      var $143=$x1;
      var $144=$143 >> 16;
      $x1=$144;
      var $145=$x2;
      var $146=$145 >> 16;
      $xx=$146;
      var $147=$beam;
      var $148=$147 << 4;
      var $149=$sy;
      var $150=_abs($149);
      var $151=$150 >> 5;
      var $152=((__ZL12cosine_table+($151<<2))|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=__ZL12mul_32x32_hiii4902($148, $153);
      $bwidth=$154;
      var $155=$bwidth;
      var $156=$155 >> 1;
      var $157=$y1;
      var $158=(($157-$156)|0);
      $y1=$158;
      __label__ = 16; break;
    case 16: // $159
      var $160=$x1;
      var $161=(($160)|0) >= 0;
      if ($161) { __label__ = 17; break; } else { __label__ = 31; break; }
    case 17: // $162
      var $163=$x1;
      var $164=$3;
      var $165=(($163)|0) < (($164)|0);
      if ($165) { __label__ = 18; break; } else { __label__ = 31; break; }
    case 18: // $166
      var $167=$bwidth;
      $dx=$167;
      var $168=$y1;
      var $169=$168 >> 16;
      $dy=$169;
      var $170=$dy;
      var $171=(($170)|0) >= 0;
      if ($171) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $172
      var $173=$dy;
      var $174=$4;
      var $175=(($173)|0) < (($174)|0);
      if ($175) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $176
      var $177=$2;
      var $178=$5;
      var $179=$x1;
      var $180=$dy;
      var $181=$col;
      var $182=$181 >>> 16;
      var $183=$182 & 255;
      var $184=$y1;
      var $185=$184 ^ -1;
      var $186=$185 >> 8;
      var $187=255 & $186;
      var $188=(($183*$187)|0);
      var $189=$188 >>> 8;
      var $190=$189 & 255;
      var $191=$190 << 16;
      var $192=-16777216 | $191;
      var $193=$col;
      var $194=$193 >>> 8;
      var $195=$194 & 255;
      var $196=$y1;
      var $197=$196 ^ -1;
      var $198=$197 >> 8;
      var $199=255 & $198;
      var $200=(($195*$199)|0);
      var $201=$200 >>> 8;
      var $202=$201 & 255;
      var $203=$202 << 8;
      var $204=$192 | $203;
      var $205=$col;
      var $206=$205 & 255;
      var $207=$y1;
      var $208=$207 ^ -1;
      var $209=$208 >> 8;
      var $210=255 & $209;
      var $211=(($206*$210)|0);
      var $212=$211 >>> 8;
      var $213=$212 & 255;
      var $214=$204 | $213;
      __ZL20rgb888_draw_aa_pixelPvjiij($177, $178, $179, $180, $214);
      __label__ = 21; break;
    case 21: // $215
      var $216=$dy;
      var $217=(($216+1)|0);
      $dy=$217;
      var $218=$y1;
      var $219=65535 & $218;
      var $220=((65536-$219)|0);
      var $221=$dx;
      var $222=(($221-$220)|0);
      $dx=$222;
      var $223=$dx;
      var $224=$223 >> 8;
      var $225=$224 & 255;
      var $226=(($225) & 255);
      $a1=$226;
      var $227=$dx;
      var $228=$227 >> 16;
      $dx=$228;
      __label__ = 22; break;
    case 22: // $229
      var $230=$dx;
      var $231=(($230-1)|0);
      $dx=$231;
      var $232=(($230)|0)!=0;
      if ($232) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $233
      var $234=$dy;
      var $235=(($234)|0) >= 0;
      if ($235) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $236
      var $237=$dy;
      var $238=$4;
      var $239=(($237)|0) < (($238)|0);
      if ($239) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $240
      var $241=$2;
      var $242=$5;
      var $243=$x1;
      var $244=$dy;
      var $245=$col;
      __ZL20rgb888_draw_aa_pixelPvjiij($241, $242, $243, $244, $245);
      __label__ = 26; break;
    case 26: // $246
      var $247=$dy;
      var $248=(($247+1)|0);
      $dy=$248;
      __label__ = 22; break;
    case 27: // $249
      var $250=$dy;
      var $251=(($250)|0) >= 0;
      if ($251) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $252
      var $253=$dy;
      var $254=$4;
      var $255=(($253)|0) < (($254)|0);
      if ($255) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $256
      var $257=$2;
      var $258=$5;
      var $259=$x1;
      var $260=$dy;
      var $261=$col;
      var $262=$261 >>> 16;
      var $263=$262 & 255;
      var $264=$a1;
      var $265=(($264)&255);
      var $266=(($263*$265)|0);
      var $267=$266 >>> 8;
      var $268=$267 & 255;
      var $269=$268 << 16;
      var $270=-16777216 | $269;
      var $271=$col;
      var $272=$271 >>> 8;
      var $273=$272 & 255;
      var $274=$a1;
      var $275=(($274)&255);
      var $276=(($273*$275)|0);
      var $277=$276 >>> 8;
      var $278=$277 & 255;
      var $279=$278 << 8;
      var $280=$270 | $279;
      var $281=$col;
      var $282=$281 & 255;
      var $283=$a1;
      var $284=(($283)&255);
      var $285=(($282*$284)|0);
      var $286=$285 >>> 8;
      var $287=$286 & 255;
      var $288=$280 | $287;
      __ZL20rgb888_draw_aa_pixelPvjiij($257, $258, $259, $260, $288);
      __label__ = 30; break;
    case 30: // $289
      __label__ = 31; break;
    case 31: // $290
      var $291=$x1;
      var $292=$xx;
      var $293=(($291)|0)==(($292)|0);
      if ($293) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $294
      __label__ = 34; break;
    case 33: // $295
      var $296=$sx;
      var $297=$x1;
      var $298=(($297+$296)|0);
      $x1=$298;
      var $299=$sy;
      var $300=$y1;
      var $301=(($300+$299)|0);
      $y1=$301;
      __label__ = 16; break;
    case 34: // $302
      __label__ = 60; break;
    case 35: // $303
      var $304=$y1;
      var $305=$y2;
      var $306=(($304)|0) <= (($305)|0);
      var $307=$306 ? 1 : -1;
      $sy=$307;
      var $308=$dx;
      var $309=(($308)|0)==0;
      if ($309) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $310
      var $318 = 0;__label__ = 38; break;
    case 37: // $311
      var $312=$x2;
      var $313=$x1;
      var $314=(($312-$313)|0);
      var $315=$dy;
      var $316=__ZL15div_32x32_shiftiih4901($314, $315, 16);
      var $318 = $316;__label__ = 38; break;
    case 38: // $317
      var $318;
      $sx=$318;
      var $319=$sx;
      var $320=(($319)|0) < 0;
      if ($320) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $321
      var $322=$dx;
      var $323=(($322-1)|0);
      $dx=$323;
      __label__ = 40; break;
    case 40: // $324
      var $325=$y1;
      var $326=$325 >> 16;
      $y1=$326;
      var $327=$y2;
      var $328=$327 >> 16;
      $yy=$328;
      var $329=$beam;
      var $330=$329 << 4;
      var $331=$sx;
      var $332=_abs($331);
      var $333=$332 >> 5;
      var $334=((__ZL12cosine_table+($333<<2))|0);
      var $335=HEAP32[(($334)>>2)];
      var $336=__ZL12mul_32x32_hiii4902($330, $335);
      $bwidth=$336;
      var $337=$bwidth;
      var $338=$337 >> 1;
      var $339=$x1;
      var $340=(($339-$338)|0);
      $x1=$340;
      __label__ = 41; break;
    case 41: // $341
      var $342=$y1;
      var $343=(($342)|0) >= 0;
      if ($343) { __label__ = 42; break; } else { __label__ = 56; break; }
    case 42: // $344
      var $345=$y1;
      var $346=$4;
      var $347=(($345)|0) < (($346)|0);
      if ($347) { __label__ = 43; break; } else { __label__ = 56; break; }
    case 43: // $348
      var $349=$bwidth;
      $dy=$349;
      var $350=$x1;
      var $351=$350 >> 16;
      $dx=$351;
      var $352=$dx;
      var $353=(($352)|0) >= 0;
      if ($353) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $354
      var $355=$dx;
      var $356=$3;
      var $357=(($355)|0) < (($356)|0);
      if ($357) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $358
      var $359=$2;
      var $360=$5;
      var $361=$dx;
      var $362=$y1;
      var $363=$col;
      var $364=$363 >>> 16;
      var $365=$364 & 255;
      var $366=$x1;
      var $367=$366 ^ -1;
      var $368=$367 >> 8;
      var $369=255 & $368;
      var $370=(($365*$369)|0);
      var $371=$370 >>> 8;
      var $372=$371 & 255;
      var $373=$372 << 16;
      var $374=-16777216 | $373;
      var $375=$col;
      var $376=$375 >>> 8;
      var $377=$376 & 255;
      var $378=$x1;
      var $379=$378 ^ -1;
      var $380=$379 >> 8;
      var $381=255 & $380;
      var $382=(($377*$381)|0);
      var $383=$382 >>> 8;
      var $384=$383 & 255;
      var $385=$384 << 8;
      var $386=$374 | $385;
      var $387=$col;
      var $388=$387 & 255;
      var $389=$x1;
      var $390=$389 ^ -1;
      var $391=$390 >> 8;
      var $392=255 & $391;
      var $393=(($388*$392)|0);
      var $394=$393 >>> 8;
      var $395=$394 & 255;
      var $396=$386 | $395;
      __ZL20rgb888_draw_aa_pixelPvjiij($359, $360, $361, $362, $396);
      __label__ = 46; break;
    case 46: // $397
      var $398=$dx;
      var $399=(($398+1)|0);
      $dx=$399;
      var $400=$x1;
      var $401=65535 & $400;
      var $402=((65536-$401)|0);
      var $403=$dy;
      var $404=(($403-$402)|0);
      $dy=$404;
      var $405=$dy;
      var $406=$405 >> 8;
      var $407=$406 & 255;
      var $408=(($407) & 255);
      $a1=$408;
      var $409=$dy;
      var $410=$409 >> 16;
      $dy=$410;
      __label__ = 47; break;
    case 47: // $411
      var $412=$dy;
      var $413=(($412-1)|0);
      $dy=$413;
      var $414=(($412)|0)!=0;
      if ($414) { __label__ = 48; break; } else { __label__ = 52; break; }
    case 48: // $415
      var $416=$dx;
      var $417=(($416)|0) >= 0;
      if ($417) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $418
      var $419=$dx;
      var $420=$3;
      var $421=(($419)|0) < (($420)|0);
      if ($421) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $422
      var $423=$2;
      var $424=$5;
      var $425=$dx;
      var $426=$y1;
      var $427=$col;
      __ZL20rgb888_draw_aa_pixelPvjiij($423, $424, $425, $426, $427);
      __label__ = 51; break;
    case 51: // $428
      var $429=$dx;
      var $430=(($429+1)|0);
      $dx=$430;
      __label__ = 47; break;
    case 52: // $431
      var $432=$dx;
      var $433=(($432)|0) >= 0;
      if ($433) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $434
      var $435=$dx;
      var $436=$3;
      var $437=(($435)|0) < (($436)|0);
      if ($437) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $438
      var $439=$2;
      var $440=$5;
      var $441=$dx;
      var $442=$y1;
      var $443=$col;
      var $444=$443 >>> 16;
      var $445=$444 & 255;
      var $446=$a1;
      var $447=(($446)&255);
      var $448=(($445*$447)|0);
      var $449=$448 >>> 8;
      var $450=$449 & 255;
      var $451=$450 << 16;
      var $452=-16777216 | $451;
      var $453=$col;
      var $454=$453 >>> 8;
      var $455=$454 & 255;
      var $456=$a1;
      var $457=(($456)&255);
      var $458=(($455*$457)|0);
      var $459=$458 >>> 8;
      var $460=$459 & 255;
      var $461=$460 << 8;
      var $462=$452 | $461;
      var $463=$col;
      var $464=$463 & 255;
      var $465=$a1;
      var $466=(($465)&255);
      var $467=(($464*$466)|0);
      var $468=$467 >>> 8;
      var $469=$468 & 255;
      var $470=$462 | $469;
      __ZL20rgb888_draw_aa_pixelPvjiij($439, $440, $441, $442, $470);
      __label__ = 55; break;
    case 55: // $471
      __label__ = 56; break;
    case 56: // $472
      var $473=$y1;
      var $474=$yy;
      var $475=(($473)|0)==(($474)|0);
      if ($475) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $476
      __label__ = 59; break;
    case 58: // $477
      var $478=$sy;
      var $479=$y1;
      var $480=(($479+$478)|0);
      $y1=$480;
      var $481=$sx;
      var $482=$x1;
      var $483=(($482+$481)|0);
      $x1=$483;
      __label__ = 41; break;
    case 59: // $484
      __label__ = 60; break;
    case 60: // $485
      __label__ = 87; break;
    case 61: // $486
      var $487=$x1;
      var $488=(($487+32768)|0);
      var $489=$488 >> 16;
      $x1=$489;
      var $490=$y1;
      var $491=(($490+32768)|0);
      var $492=$491 >> 16;
      $y1=$492;
      var $493=$x2;
      var $494=(($493+32768)|0);
      var $495=$494 >> 16;
      $x2=$495;
      var $496=$y2;
      var $497=(($496+32768)|0);
      var $498=$497 >> 16;
      $y2=$498;
      var $499=$x1;
      var $500=$x2;
      var $501=(($499-$500)|0);
      var $502=_abs($501);
      $dx=$502;
      var $503=$y1;
      var $504=$y2;
      var $505=(($503-$504)|0);
      var $506=_abs($505);
      $dy=$506;
      var $507=$x1;
      var $508=$x2;
      var $509=(($507)|0) <= (($508)|0);
      var $510=$509 ? 1 : -1;
      $sx=$510;
      var $511=$y1;
      var $512=$y2;
      var $513=(($511)|0) <= (($512)|0);
      var $514=$513 ? 1 : -1;
      $sy=$514;
      var $515=$dx;
      var $516=(((($515)|0)/2)|0);
      $cx=$516;
      var $517=$dy;
      var $518=(((($517)|0)/2)|0);
      $cy=$518;
      var $519=$dx;
      var $520=$dy;
      var $521=(($519)|0) >= (($520)|0);
      if ($521) { __label__ = 62; break; } else { __label__ = 74; break; }
    case 62: // $522
      __label__ = 63; break;
    case 63: // $523
      var $524=$x1;
      var $525=(($524)|0) >= 0;
      if ($525) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $526
      var $527=$x1;
      var $528=$3;
      var $529=(($527)|0) < (($528)|0);
      if ($529) { __label__ = 65; break; } else { __label__ = 68; break; }
    case 65: // $530
      var $531=$y1;
      var $532=(($531)|0) >= 0;
      if ($532) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $533
      var $534=$y1;
      var $535=$4;
      var $536=(($534)|0) < (($535)|0);
      if ($536) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $537
      var $538=$2;
      var $539=$5;
      var $540=$x1;
      var $541=$y1;
      var $542=$col;
      __ZL20rgb888_draw_aa_pixelPvjiij($538, $539, $540, $541, $542);
      __label__ = 68; break;
    case 68: // $543
      var $544=$x1;
      var $545=$x2;
      var $546=(($544)|0)==(($545)|0);
      if ($546) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $547
      __label__ = 73; break;
    case 70: // $548
      var $549=$sx;
      var $550=$x1;
      var $551=(($550+$549)|0);
      $x1=$551;
      var $552=$dy;
      var $553=$cx;
      var $554=(($553-$552)|0);
      $cx=$554;
      var $555=$cx;
      var $556=(($555)|0) < 0;
      if ($556) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $557
      var $558=$sy;
      var $559=$y1;
      var $560=(($559+$558)|0);
      $y1=$560;
      var $561=$dx;
      var $562=$cx;
      var $563=(($562+$561)|0);
      $cx=$563;
      __label__ = 72; break;
    case 72: // $564
      __label__ = 63; break;
    case 73: // $565
      __label__ = 86; break;
    case 74: // $566
      __label__ = 75; break;
    case 75: // $567
      var $568=$x1;
      var $569=(($568)|0) >= 0;
      if ($569) { __label__ = 76; break; } else { __label__ = 80; break; }
    case 76: // $570
      var $571=$x1;
      var $572=$3;
      var $573=(($571)|0) < (($572)|0);
      if ($573) { __label__ = 77; break; } else { __label__ = 80; break; }
    case 77: // $574
      var $575=$y1;
      var $576=(($575)|0) >= 0;
      if ($576) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $577
      var $578=$y1;
      var $579=$4;
      var $580=(($578)|0) < (($579)|0);
      if ($580) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $581
      var $582=$2;
      var $583=$5;
      var $584=$x1;
      var $585=$y1;
      var $586=$col;
      __ZL20rgb888_draw_aa_pixelPvjiij($582, $583, $584, $585, $586);
      __label__ = 80; break;
    case 80: // $587
      var $588=$y1;
      var $589=$y2;
      var $590=(($588)|0)==(($589)|0);
      if ($590) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $591
      __label__ = 85; break;
    case 82: // $592
      var $593=$sy;
      var $594=$y1;
      var $595=(($594+$593)|0);
      $y1=$595;
      var $596=$dx;
      var $597=$cy;
      var $598=(($597-$596)|0);
      $cy=$598;
      var $599=$cy;
      var $600=(($599)|0) < 0;
      if ($600) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $601
      var $602=$sx;
      var $603=$x1;
      var $604=(($603+$602)|0);
      $x1=$604;
      var $605=$dy;
      var $606=$cy;
      var $607=(($606+$605)|0);
      $cy=$607;
      __label__ = 84; break;
    case 84: // $608
      __label__ = 75; break;
    case 85: // $609
      __label__ = 86; break;
    case 86: // $610
      __label__ = 87; break;
    case 87: // $611
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16rgb888_draw_linePK16render_primitivePviij["X"]=1;

function __ZL16rgb888_draw_rectPK16render_primitivePviij($prim, $dstdata, $width, $height, $pitch) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $fpos=__stackBase__;
      var $startx;
      var $starty;
      var $endx;
      var $endy;
      var $x;
      var $y;
      var $r;
      var $g;
      var $b;
      var $pix;
      var $dest;
      var $rmask;
      var $gmask;
      var $bmask;
      var $r1;
      var $g2;
      var $b3;
      var $inva;
      var $dest4;
      var $dpix;
      var $dr;
      var $dg;
      var $db;
      $1=$prim;
      $2=$dstdata;
      $3=$width;
      $4=$height;
      $5=$pitch;
      var $6=$1;
      var $7=(($6+4)|0);
      var $8=$fpos;
      var $9=$7;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[(($9+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[(($9+8)>>2)];HEAP32[(($8+12)>>2)]=HEAP32[(($9+12)>>2)];
      __label__ = 1; break;
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      __label__ = 4; break;
    case 4: // $13
      var $14=(($fpos)|0);
      var $15=HEAPF32[(($14)>>2)];
      var $16=__ZL13round_nearestf($15);
      var $17=(($16)|0);
      $startx=$17;
      var $18=(($fpos+4)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=__ZL13round_nearestf($19);
      var $21=(($20)|0);
      $starty=$21;
      var $22=(($fpos+8)|0);
      var $23=HEAPF32[(($22)>>2)];
      var $24=__ZL13round_nearestf($23);
      var $25=(($24)|0);
      $endx=$25;
      var $26=(($fpos+12)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=__ZL13round_nearestf($27);
      var $29=(($28)|0);
      $endy=$29;
      var $30=$startx;
      var $31=(($30)|0) < 0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      $startx=0;
      __label__ = 6; break;
    case 6: // $33
      var $34=$startx;
      var $35=$3;
      var $36=(($34)|0) >= (($35)|0);
      if ($36) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $37
      var $38=$3;
      $startx=$38;
      __label__ = 8; break;
    case 8: // $39
      var $40=$endx;
      var $41=(($40)|0) < 0;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      $endx=0;
      __label__ = 10; break;
    case 10: // $43
      var $44=$endx;
      var $45=$3;
      var $46=(($44)|0) >= (($45)|0);
      if ($46) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $47
      var $48=$3;
      $endx=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$starty;
      var $51=(($50)|0) < 0;
      if ($51) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $52
      $starty=0;
      __label__ = 14; break;
    case 14: // $53
      var $54=$starty;
      var $55=$4;
      var $56=(($54)|0) >= (($55)|0);
      if ($56) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $57
      var $58=$4;
      $starty=$58;
      __label__ = 16; break;
    case 16: // $59
      var $60=$endy;
      var $61=(($60)|0) < 0;
      if ($61) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $62
      $endy=0;
      __label__ = 18; break;
    case 18: // $63
      var $64=$endy;
      var $65=$4;
      var $66=(($64)|0) >= (($65)|0);
      if ($66) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $67
      var $68=$4;
      $endy=$68;
      __label__ = 20; break;
    case 20: // $69
      var $70=(($fpos)|0);
      var $71=HEAPF32[(($70)>>2)];
      var $72=(($fpos+8)|0);
      var $73=HEAPF32[(($72)>>2)];
      var $74=$71 > $73;
      if ($74) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $75
      var $76=(($fpos+4)|0);
      var $77=HEAPF32[(($76)>>2)];
      var $78=(($fpos+12)|0);
      var $79=HEAPF32[(($78)>>2)];
      var $80=$77 > $79;
      if ($80) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $81
      __label__ = 82; break;
    case 23: // $82
      __label__ = 24; break;
    case 24: // $83
      __label__ = 25; break;
    case 25: // $84
      var $85=$1;
      var $86=(($85+36)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$87 & 3840;
      var $89=$88 >>> 8;
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $91
      var $92=$1;
      var $93=(($92+20)|0);
      var $94=(($93)|0);
      var $95=HEAPF32[(($94)>>2)];
      var $96=$95 >= 1;
      if ($96) { __label__ = 27; break; } else { __label__ = 51; break; }
    case 27: // $97
      var $98=$1;
      var $99=(($98+20)|0);
      var $100=(($99+4)|0);
      var $101=HEAPF32[(($100)>>2)];
      var $102=$101*256;
      var $103=($102 >= 0 ? Math.floor($102) : Math.ceil($102));
      $r=$103;
      var $104=$1;
      var $105=(($104+20)|0);
      var $106=(($105+8)|0);
      var $107=HEAPF32[(($106)>>2)];
      var $108=$107*256;
      var $109=($108 >= 0 ? Math.floor($108) : Math.ceil($108));
      $g=$109;
      var $110=$1;
      var $111=(($110+20)|0);
      var $112=(($111+12)|0);
      var $113=HEAPF32[(($112)>>2)];
      var $114=$113*256;
      var $115=($114 >= 0 ? Math.floor($114) : Math.ceil($114));
      $b=$115;
      var $116=$r;
      var $117=(($116)>>>0) > 255;
      if ($117) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $118
      var $119=$r;
      var $120=(($119)|0) < 0;
      if ($120) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $121
      $r=0;
      __label__ = 31; break;
    case 30: // $122
      $r=255;
      __label__ = 31; break;
    case 31: // $123
      __label__ = 32; break;
    case 32: // $124
      var $125=$g;
      var $126=(($125)>>>0) > 255;
      if ($126) { __label__ = 33; break; } else { __label__ = 37; break; }
    case 33: // $127
      var $128=$g;
      var $129=(($128)|0) < 0;
      if ($129) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $130
      $g=0;
      __label__ = 36; break;
    case 35: // $131
      $g=255;
      __label__ = 36; break;
    case 36: // $132
      __label__ = 37; break;
    case 37: // $133
      var $134=$b;
      var $135=(($134)>>>0) > 255;
      if ($135) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $136
      var $137=$b;
      var $138=(($137)|0) < 0;
      if ($138) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $139
      $b=0;
      __label__ = 41; break;
    case 40: // $140
      $b=255;
      __label__ = 41; break;
    case 41: // $141
      __label__ = 42; break;
    case 42: // $142
      var $143=$r;
      var $144=$143 >>> 0;
      var $145=$144 << 16;
      var $146=$g;
      var $147=$146 >>> 0;
      var $148=$147 << 8;
      var $149=$145 | $148;
      var $150=$b;
      var $151=$150 >>> 0;
      var $152=$151 << 0;
      var $153=$149 | $152;
      $pix=$153;
      var $154=$starty;
      $y=$154;
      __label__ = 43; break;
    case 43: // $155
      var $156=$y;
      var $157=$endy;
      var $158=(($156)|0) < (($157)|0);
      if ($158) { __label__ = 44; break; } else { __label__ = 50; break; }
    case 44: // $159
      var $160=$2;
      var $161=$160;
      var $162=$y;
      var $163=$5;
      var $164=(($162*$163)|0);
      var $165=(($161+($164<<2))|0);
      var $166=$startx;
      var $167=(($165+($166<<2))|0);
      $dest=$167;
      var $168=$startx;
      $x=$168;
      __label__ = 45; break;
    case 45: // $169
      var $170=$x;
      var $171=$endx;
      var $172=(($170)|0) < (($171)|0);
      if ($172) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $173
      var $174=$pix;
      var $175=$dest;
      var $176=(($175+4)|0);
      $dest=$176;
      HEAP32[(($175)>>2)]=$174;
      __label__ = 47; break;
    case 47: // $177
      var $178=$x;
      var $179=(($178+1)|0);
      $x=$179;
      __label__ = 45; break;
    case 48: // $180
      __label__ = 49; break;
    case 49: // $181
      var $182=$y;
      var $183=(($182+1)|0);
      $y=$183;
      __label__ = 43; break;
    case 50: // $184
      __label__ = 82; break;
    case 51: // $185
      var $186=$1;
      var $187=(($186+20)|0);
      var $188=(($187)|0);
      var $189=HEAPF32[(($188)>>2)];
      var $190=$189 < 0.00009999999747378752;
      if ($190) { __label__ = 81; break; } else { __label__ = 52; break; }
    case 52: // $191
      $rmask=16711680;
      $gmask=65280;
      $bmask=255;
      var $192=$1;
      var $193=(($192+20)|0);
      var $194=(($193+4)|0);
      var $195=HEAPF32[(($194)>>2)];
      var $196=$195*256;
      var $197=$1;
      var $198=(($197+20)|0);
      var $199=(($198)|0);
      var $200=HEAPF32[(($199)>>2)];
      var $201=$196*$200;
      var $202=($201 >= 0 ? Math.floor($201) : Math.ceil($201));
      $r1=$202;
      var $203=$1;
      var $204=(($203+20)|0);
      var $205=(($204+8)|0);
      var $206=HEAPF32[(($205)>>2)];
      var $207=$206*256;
      var $208=$1;
      var $209=(($208+20)|0);
      var $210=(($209)|0);
      var $211=HEAPF32[(($210)>>2)];
      var $212=$207*$211;
      var $213=($212 >= 0 ? Math.floor($212) : Math.ceil($212));
      $g2=$213;
      var $214=$1;
      var $215=(($214+20)|0);
      var $216=(($215+12)|0);
      var $217=HEAPF32[(($216)>>2)];
      var $218=$217*256;
      var $219=$1;
      var $220=(($219+20)|0);
      var $221=(($220)|0);
      var $222=HEAPF32[(($221)>>2)];
      var $223=$218*$222;
      var $224=($223 >= 0 ? Math.floor($223) : Math.ceil($223));
      $b3=$224;
      var $225=$1;
      var $226=(($225+20)|0);
      var $227=(($226)|0);
      var $228=HEAPF32[(($227)>>2)];
      var $229=1-$228;
      var $230=$229*256;
      var $231=($230 >= 0 ? Math.floor($230) : Math.ceil($230));
      $inva=$231;
      var $232=$r1;
      var $233=(($232)>>>0) > 255;
      if ($233) { __label__ = 53; break; } else { __label__ = 57; break; }
    case 53: // $234
      var $235=$r1;
      var $236=(($235)|0) < 0;
      if ($236) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $237
      $r1=0;
      __label__ = 56; break;
    case 55: // $238
      $r1=255;
      __label__ = 56; break;
    case 56: // $239
      __label__ = 57; break;
    case 57: // $240
      var $241=$g2;
      var $242=(($241)>>>0) > 255;
      if ($242) { __label__ = 58; break; } else { __label__ = 62; break; }
    case 58: // $243
      var $244=$g2;
      var $245=(($244)|0) < 0;
      if ($245) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $246
      $g2=0;
      __label__ = 61; break;
    case 60: // $247
      $g2=255;
      __label__ = 61; break;
    case 61: // $248
      __label__ = 62; break;
    case 62: // $249
      var $250=$b3;
      var $251=(($250)>>>0) > 255;
      if ($251) { __label__ = 63; break; } else { __label__ = 67; break; }
    case 63: // $252
      var $253=$b3;
      var $254=(($253)|0) < 0;
      if ($254) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $255
      $b3=0;
      __label__ = 66; break;
    case 65: // $256
      $b3=255;
      __label__ = 66; break;
    case 66: // $257
      __label__ = 67; break;
    case 67: // $258
      var $259=$inva;
      var $260=(($259)>>>0) > 256;
      if ($260) { __label__ = 68; break; } else { __label__ = 72; break; }
    case 68: // $261
      var $262=$inva;
      var $263=(($262)|0) < 0;
      if ($263) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $264
      $inva=0;
      __label__ = 71; break;
    case 70: // $265
      $inva=256;
      __label__ = 71; break;
    case 71: // $266
      __label__ = 72; break;
    case 72: // $267
      var $268=$r1;
      var $269=$268 >>> 0;
      var $270=$269 << 16;
      var $271=$270 << 8;
      $r1=$271;
      var $272=$g2;
      var $273=$272 >>> 0;
      var $274=$273 << 8;
      var $275=0 | $274;
      var $276=$275 << 8;
      $g2=$276;
      var $277=$b3;
      var $278=$277 >>> 0;
      var $279=$278 << 0;
      var $280=0 | $279;
      var $281=$280 << 8;
      $b3=$281;
      var $282=$starty;
      $y=$282;
      __label__ = 73; break;
    case 73: // $283
      var $284=$y;
      var $285=$endy;
      var $286=(($284)|0) < (($285)|0);
      if ($286) { __label__ = 74; break; } else { __label__ = 80; break; }
    case 74: // $287
      var $288=$2;
      var $289=$288;
      var $290=$y;
      var $291=$5;
      var $292=(($290*$291)|0);
      var $293=(($289+($292<<2))|0);
      var $294=$startx;
      var $295=(($293+($294<<2))|0);
      $dest4=$295;
      var $296=$startx;
      $x=$296;
      __label__ = 75; break;
    case 75: // $297
      var $298=$x;
      var $299=$endx;
      var $300=(($298)|0) < (($299)|0);
      if ($300) { __label__ = 76; break; } else { __label__ = 78; break; }
    case 76: // $301
      var $302=$dest4;
      var $303=HEAP32[(($302)>>2)];
      $dpix=$303;
      var $304=$r1;
      var $305=$dpix;
      var $306=$rmask;
      var $307=$305 & $306;
      var $308=$inva;
      var $309=(($307*$308)|0);
      var $310=(($304+$309)|0);
      var $311=$rmask;
      var $312=$311 << 8;
      var $313=$310 & $312;
      $dr=$313;
      var $314=$g2;
      var $315=$dpix;
      var $316=$gmask;
      var $317=$315 & $316;
      var $318=$inva;
      var $319=(($317*$318)|0);
      var $320=(($314+$319)|0);
      var $321=$gmask;
      var $322=$321 << 8;
      var $323=$320 & $322;
      $dg=$323;
      var $324=$b3;
      var $325=$dpix;
      var $326=$bmask;
      var $327=$325 & $326;
      var $328=$inva;
      var $329=(($327*$328)|0);
      var $330=(($324+$329)|0);
      var $331=$bmask;
      var $332=$331 << 8;
      var $333=$330 & $332;
      $db=$333;
      var $334=$dr;
      var $335=$dg;
      var $336=$334 | $335;
      var $337=$db;
      var $338=$336 | $337;
      var $339=$338 >>> 8;
      var $340=$dest4;
      var $341=(($340+4)|0);
      $dest4=$341;
      HEAP32[(($340)>>2)]=$339;
      __label__ = 77; break;
    case 77: // $342
      var $343=$x;
      var $344=(($343+1)|0);
      $x=$344;
      __label__ = 75; break;
    case 78: // $345
      __label__ = 79; break;
    case 79: // $346
      var $347=$y;
      var $348=(($347+1)|0);
      $y=$348;
      __label__ = 73; break;
    case 80: // $349
      __label__ = 81; break;
    case 81: // $350
      __label__ = 82; break;
    case 82: // $351
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16rgb888_draw_rectPK16render_primitivePviij["X"]=1;

function __ZL13round_nearestf($f) {
  ;
  var __label__;

  var $1;
  $1=$f;
  var $2=$1;
  var $3=$2+0.5;
  var $4=$3;
  var $5=_floor($4);
  var $6=$5;
  ;
  return $6;
}


function __ZL35rgb888_setup_and_draw_textured_quadPK16render_primitivePviij($prim, $dstdata, $width, $height, $pitch) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $fdudx;
      var $fdvdx;
      var $fdudy;
      var $fdvdy;
      var $setup=__stackBase__;
      $1=$prim;
      $2=$dstdata;
      $3=$width;
      $4=$height;
      $5=$pitch;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      __label__ = 3; break;
    case 3: // $8
      __label__ = 4; break;
    case 4: // $9
      var $10=$1;
      var $11=(($10+68)|0);
      var $12=(($11+8)|0);
      var $13=(($12)|0);
      var $14=HEAPF32[(($13)>>2)];
      var $15=$1;
      var $16=(($15+68)|0);
      var $17=(($16)|0);
      var $18=(($17)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=$14-$19;
      var $21=$1;
      var $22=(($21+4)|0);
      var $23=(($22+8)|0);
      var $24=HEAPF32[(($23)>>2)];
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=(($26)|0);
      var $28=HEAPF32[(($27)>>2)];
      var $29=$24-$28;
      var $30=$20/$29;
      $fdudx=$30;
      var $31=$1;
      var $32=(($31+68)|0);
      var $33=(($32+8)|0);
      var $34=(($33+4)|0);
      var $35=HEAPF32[(($34)>>2)];
      var $36=$1;
      var $37=(($36+68)|0);
      var $38=(($37)|0);
      var $39=(($38+4)|0);
      var $40=HEAPF32[(($39)>>2)];
      var $41=$35-$40;
      var $42=$1;
      var $43=(($42+4)|0);
      var $44=(($43+8)|0);
      var $45=HEAPF32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+4)|0);
      var $48=(($47)|0);
      var $49=HEAPF32[(($48)>>2)];
      var $50=$45-$49;
      var $51=$41/$50;
      $fdvdx=$51;
      var $52=$1;
      var $53=(($52+68)|0);
      var $54=(($53+16)|0);
      var $55=(($54)|0);
      var $56=HEAPF32[(($55)>>2)];
      var $57=$1;
      var $58=(($57+68)|0);
      var $59=(($58)|0);
      var $60=(($59)|0);
      var $61=HEAPF32[(($60)>>2)];
      var $62=$56-$61;
      var $63=$1;
      var $64=(($63+4)|0);
      var $65=(($64+12)|0);
      var $66=HEAPF32[(($65)>>2)];
      var $67=$1;
      var $68=(($67+4)|0);
      var $69=(($68+4)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $71=$66-$70;
      var $72=$62/$71;
      $fdudy=$72;
      var $73=$1;
      var $74=(($73+68)|0);
      var $75=(($74+16)|0);
      var $76=(($75+4)|0);
      var $77=HEAPF32[(($76)>>2)];
      var $78=$1;
      var $79=(($78+68)|0);
      var $80=(($79)|0);
      var $81=(($80+4)|0);
      var $82=HEAPF32[(($81)>>2)];
      var $83=$77-$82;
      var $84=$1;
      var $85=(($84+4)|0);
      var $86=(($85+12)|0);
      var $87=HEAPF32[(($86)>>2)];
      var $88=$1;
      var $89=(($88+4)|0);
      var $90=(($89+4)|0);
      var $91=HEAPF32[(($90)>>2)];
      var $92=$87-$91;
      var $93=$83/$92;
      $fdvdy=$93;
      var $94=$1;
      var $95=(($94+4)|0);
      var $96=(($95)|0);
      var $97=HEAPF32[(($96)>>2)];
      var $98=__ZL13round_nearestf($97);
      var $99=(($98)|0);
      var $100=(($setup+24)|0);
      HEAP32[(($100)>>2)]=$99;
      var $101=$1;
      var $102=(($101+4)|0);
      var $103=(($102+4)|0);
      var $104=HEAPF32[(($103)>>2)];
      var $105=__ZL13round_nearestf($104);
      var $106=(($105)|0);
      var $107=(($setup+28)|0);
      HEAP32[(($107)>>2)]=$106;
      var $108=$1;
      var $109=(($108+4)|0);
      var $110=(($109+8)|0);
      var $111=HEAPF32[(($110)>>2)];
      var $112=__ZL13round_nearestf($111);
      var $113=(($112)|0);
      var $114=(($setup+32)|0);
      HEAP32[(($114)>>2)]=$113;
      var $115=$1;
      var $116=(($115+4)|0);
      var $117=(($116+12)|0);
      var $118=HEAPF32[(($117)>>2)];
      var $119=__ZL13round_nearestf($118);
      var $120=(($119)|0);
      var $121=(($setup+36)|0);
      HEAP32[(($121)>>2)]=$120;
      var $122=(($setup+24)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123)|0) < 0;
      if ($124) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $125
      var $126=(($setup+24)|0);
      HEAP32[(($126)>>2)]=0;
      __label__ = 6; break;
    case 6: // $127
      var $128=(($setup+24)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$3;
      var $131=(($129)|0) >= (($130)|0);
      if ($131) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $132
      var $133=$3;
      var $134=(($setup+24)|0);
      HEAP32[(($134)>>2)]=$133;
      __label__ = 8; break;
    case 8: // $135
      var $136=(($setup+32)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137)|0) < 0;
      if ($138) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $139
      var $140=(($setup+32)|0);
      HEAP32[(($140)>>2)]=0;
      __label__ = 10; break;
    case 10: // $141
      var $142=(($setup+32)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$3;
      var $145=(($143)|0) >= (($144)|0);
      if ($145) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $146
      var $147=$3;
      var $148=(($setup+32)|0);
      HEAP32[(($148)>>2)]=$147;
      __label__ = 12; break;
    case 12: // $149
      var $150=(($setup+28)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151)|0) < 0;
      if ($152) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $153
      var $154=(($setup+28)|0);
      HEAP32[(($154)>>2)]=0;
      __label__ = 14; break;
    case 14: // $155
      var $156=(($setup+28)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$4;
      var $159=(($157)|0) >= (($158)|0);
      if ($159) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $160
      var $161=$4;
      var $162=(($setup+28)|0);
      HEAP32[(($162)>>2)]=$161;
      __label__ = 16; break;
    case 16: // $163
      var $164=(($setup+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165)|0) < 0;
      if ($166) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $167
      var $168=(($setup+36)|0);
      HEAP32[(($168)>>2)]=0;
      __label__ = 18; break;
    case 18: // $169
      var $170=(($setup+36)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$4;
      var $173=(($171)|0) >= (($172)|0);
      if ($173) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $174
      var $175=$4;
      var $176=(($setup+36)|0);
      HEAP32[(($176)>>2)]=$175;
      __label__ = 20; break;
    case 20: // $177
      var $178=$1;
      var $179=(($178+44)|0);
      var $180=(($179+8)|0);
      var $181=HEAPU32[(($180)>>2)];
      var $182=(($181)>>>0);
      var $183=$182*65536;
      var $184=$fdudx;
      var $185=$183*$184;
      var $186=__ZL13round_nearestf($185);
      var $187=(($186)|0);
      var $188=(($setup)|0);
      HEAP32[(($188)>>2)]=$187;
      var $189=$1;
      var $190=(($189+44)|0);
      var $191=(($190+12)|0);
      var $192=HEAPU32[(($191)>>2)];
      var $193=(($192)>>>0);
      var $194=$193*65536;
      var $195=$fdvdx;
      var $196=$194*$195;
      var $197=__ZL13round_nearestf($196);
      var $198=(($197)|0);
      var $199=(($setup+4)|0);
      HEAP32[(($199)>>2)]=$198;
      var $200=$1;
      var $201=(($200+44)|0);
      var $202=(($201+8)|0);
      var $203=HEAPU32[(($202)>>2)];
      var $204=(($203)>>>0);
      var $205=$204*65536;
      var $206=$fdudy;
      var $207=$205*$206;
      var $208=__ZL13round_nearestf($207);
      var $209=(($208)|0);
      var $210=(($setup+8)|0);
      HEAP32[(($210)>>2)]=$209;
      var $211=$1;
      var $212=(($211+44)|0);
      var $213=(($212+12)|0);
      var $214=HEAPU32[(($213)>>2)];
      var $215=(($214)>>>0);
      var $216=$215*65536;
      var $217=$fdvdy;
      var $218=$216*$217;
      var $219=__ZL13round_nearestf($218);
      var $220=(($219)|0);
      var $221=(($setup+12)|0);
      HEAP32[(($221)>>2)]=$220;
      var $222=$1;
      var $223=(($222+44)|0);
      var $224=(($223+8)|0);
      var $225=HEAPU32[(($224)>>2)];
      var $226=(($225)>>>0);
      var $227=$226*65536;
      var $228=$1;
      var $229=(($228+68)|0);
      var $230=(($229)|0);
      var $231=(($230)|0);
      var $232=HEAPF32[(($231)>>2)];
      var $233=$227*$232;
      var $234=__ZL13round_nearestf($233);
      var $235=(($234)|0);
      var $236=(($setup+16)|0);
      HEAP32[(($236)>>2)]=$235;
      var $237=$1;
      var $238=(($237+44)|0);
      var $239=(($238+12)|0);
      var $240=HEAPU32[(($239)>>2)];
      var $241=(($240)>>>0);
      var $242=$241*65536;
      var $243=$1;
      var $244=(($243+68)|0);
      var $245=(($244)|0);
      var $246=(($245+4)|0);
      var $247=HEAPF32[(($246)>>2)];
      var $248=$242*$247;
      var $249=__ZL13round_nearestf($248);
      var $250=(($249)|0);
      var $251=(($setup+20)|0);
      HEAP32[(($251)>>2)]=$250;
      var $252=(($setup)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=(($setup+8)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($253+$255)|0);
      var $257=(((($256)|0)/2)|0);
      var $258=(($setup+16)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($259+$257)|0);
      HEAP32[(($258)>>2)]=$260;
      var $261=(($setup+4)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(($setup+12)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(($262+$264)|0);
      var $266=(((($265)|0)/2)|0);
      var $267=(($setup+20)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(($268+$266)|0);
      HEAP32[(($267)>>2)]=$269;
      var $270=(($setup+16)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=(($271-32768)|0);
      HEAP32[(($270)>>2)]=$272;
      var $273=(($setup+20)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($274-32768)|0);
      HEAP32[(($273)>>2)]=$275;
      var $276=$1;
      var $277=(($276+36)|0);
      var $278=HEAP32[(($277)>>2)];
      var $279=$278 & 4080;
      if ($279 == 16 || $279 == 272) {
        __label__ = 21; break;
      }
      else if ($279 == 784) {
        __label__ = 22; break;
      }
      else if ($279 == 288) {
        __label__ = 23; break;
      }
      else if ($279 == 96) {
        __label__ = 24; break;
      }
      else if ($279 == 48 || $279 == 304) {
        __label__ = 25; break;
      }
      else if ($279 == 64 || $279 == 320 || $279 == 80) {
        __label__ = 26; break;
      }
      else if ($279 == 832) {
        __label__ = 27; break;
      }
      else if ($279 == 336) {
        __label__ = 28; break;
      }
      else if ($279 == 592) {
        __label__ = 29; break;
      }
      else if ($279 == 848) {
        __label__ = 30; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 21: // $280
      var $281=$1;
      var $282=$2;
      var $283=$5;
      __ZL31rgb888_draw_quad_palette16_nonePK16render_primitivePvjP16_quad_setup_data($281, $282, $283, $setup);
      __label__ = 32; break;
    case 22: // $284
      var $285=$1;
      var $286=$2;
      var $287=$5;
      __ZL30rgb888_draw_quad_palette16_addPK16render_primitivePvjP16_quad_setup_data($285, $286, $287, $setup);
      __label__ = 32; break;
    case 23: // $288
      var $289=$1;
      var $290=$2;
      var $291=$5;
      __ZL33rgb888_draw_quad_palettea16_alphaPK16render_primitivePvjP16_quad_setup_data($289, $290, $291, $setup);
      __label__ = 32; break;
    case 24: // $292
      var $293=$1;
      var $294=$2;
      var $295=$5;
      __ZL27rgb888_draw_quad_yuy16_nonePK16render_primitivePvjP16_quad_setup_data($293, $294, $295, $setup);
      __label__ = 32; break;
    case 25: // $296
      var $297=$1;
      var $298=$2;
      var $299=$5;
      __ZL22rgb888_draw_quad_rgb15PK16render_primitivePvjP16_quad_setup_data($297, $298, $299, $setup);
      __label__ = 32; break;
    case 26: // $300
      var $301=$1;
      var $302=$2;
      var $303=$5;
      __ZL22rgb888_draw_quad_rgb32PK16render_primitivePvjP16_quad_setup_data($301, $302, $303, $setup);
      __label__ = 32; break;
    case 27: // $304
      var $305=$1;
      var $306=$2;
      var $307=$5;
      __ZL26rgb888_draw_quad_rgb32_addPK16render_primitivePvjP16_quad_setup_data($305, $306, $307, $setup);
      __label__ = 32; break;
    case 28: // $308
      var $309=$1;
      var $310=$2;
      var $311=$5;
      __ZL29rgb888_draw_quad_argb32_alphaPK16render_primitivePvjP16_quad_setup_data($309, $310, $311, $setup);
      __label__ = 32; break;
    case 29: // $312
      var $313=$1;
      var $314=$2;
      var $315=$5;
      __ZL32rgb888_draw_quad_argb32_multiplyPK16render_primitivePvjP16_quad_setup_data($313, $314, $315, $setup);
      __label__ = 32; break;
    case 30: // $316
      var $317=$1;
      var $318=$2;
      var $319=$5;
      __ZL27rgb888_draw_quad_argb32_addPK16render_primitivePvjP16_quad_setup_data($317, $318, $319, $setup);
      __label__ = 32; break;
    case 31: // $320
      var $321=$1;
      var $322=(($321+36)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=$323 & 240;
      var $325=$324 >>> 4;
      var $326=$1;
      var $327=(($326+36)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=$328 & 3840;
      var $330=$329 >>> 8;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str354869)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$325,HEAP32[((tempInt+4)>>2)]=$330,tempInt));
      throw "Reached an unreachable!"
    case 32: // $331
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL35rgb888_setup_and_draw_textured_quadPK16render_primitivePviij["X"]=1;

function __ZL31rgb888_draw_quad_palette16_nonePK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $sr;
      var $sg;
      var $sb;
      var $dest1;
      var $curu2;
      var $curv3;
      var $pix4;
      var $r;
      var $g;
      var $b;
      var $sr5;
      var $sg6;
      var $sb7;
      var $invsa;
      var $dest8;
      var $curu9;
      var $curv10;
      var $pix11;
      var $dpix;
      var $r12;
      var $g13;
      var $b14;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      $dudx=$7;
      var $8=$4;
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      $dvdx=$10;
      var $11=$4;
      var $12=(($11+32)|0);
      var $13=HEAP32[(($12)>>2)];
      $endx=$13;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=$1;
      var $17=(($16+20)|0);
      var $18=(($17+4)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=$19 >= 1;
      if ($20) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $21
      var $22=$1;
      var $23=(($22+20)|0);
      var $24=(($23+8)|0);
      var $25=HEAPF32[(($24)>>2)];
      var $26=$25 >= 1;
      if ($26) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $27
      var $28=$1;
      var $29=(($28+20)|0);
      var $30=(($29+12)|0);
      var $31=HEAPF32[(($30)>>2)];
      var $32=$31 >= 1;
      if ($32) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $33
      var $34=$1;
      var $35=(($34+20)|0);
      var $36=(($35)|0);
      var $37=HEAPF32[(($36)>>2)];
      var $38=$37 >= 1;
      if ($38) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $39
      var $40=$4;
      var $41=(($40+28)|0);
      var $42=HEAP32[(($41)>>2)];
      $y=$42;
      __label__ = 7; break;
    case 7: // $43
      var $44=$y;
      var $45=$4;
      var $46=(($45+36)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44)|0) < (($47)|0);
      if ($48) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $49
      var $50=$2;
      var $51=$50;
      var $52=$y;
      var $53=$3;
      var $54=(($52*$53)|0);
      var $55=(($51+($54<<2))|0);
      var $56=$4;
      var $57=(($56+24)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($55+($58<<2))|0);
      $dest=$59;
      var $60=$4;
      var $61=(($60+16)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$y;
      var $64=$4;
      var $65=(($64+28)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($63-$66)|0);
      var $68=$4;
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($67*$70)|0);
      var $72=(($62+$71)|0);
      $curu=$72;
      var $73=$4;
      var $74=(($73+20)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$y;
      var $77=$4;
      var $78=(($77+28)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($76-$79)|0);
      var $81=$4;
      var $82=(($81+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($80*$83)|0);
      var $85=(($75+$84)|0);
      $curv=$85;
      var $86=$4;
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      $x=$88;
      __label__ = 9; break;
    case 9: // $89
      var $90=$x;
      var $91=$endx;
      var $92=(($90)|0) < (($91)|0);
      if ($92) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $93
      var $94=$1;
      var $95=(($94+44)|0);
      var $96=$curu;
      var $97=$curv;
      var $98=__ZL28get_texel_palette16_bilinearPK14render_texinfoii($95, $96, $97);
      $pix=$98;
      var $99=$pix;
      var $100=$dest;
      var $101=(($100+4)|0);
      $dest=$101;
      HEAP32[(($100)>>2)]=$99;
      var $102=$dudx;
      var $103=$curu;
      var $104=(($103+$102)|0);
      $curu=$104;
      var $105=$dvdx;
      var $106=$curv;
      var $107=(($106+$105)|0);
      $curv=$107;
      __label__ = 11; break;
    case 11: // $108
      var $109=$x;
      var $110=(($109+1)|0);
      $x=$110;
      __label__ = 9; break;
    case 12: // $111
      __label__ = 13; break;
    case 13: // $112
      var $113=$y;
      var $114=(($113+1)|0);
      $y=$114;
      __label__ = 7; break;
    case 14: // $115
      __label__ = 72; break;
    case 15: // $116
      var $117=$1;
      var $118=(($117+20)|0);
      var $119=(($118)|0);
      var $120=HEAPF32[(($119)>>2)];
      var $121=$120 >= 1;
      if ($121) { __label__ = 16; break; } else { __label__ = 40; break; }
    case 16: // $122
      var $123=$1;
      var $124=(($123+20)|0);
      var $125=(($124+4)|0);
      var $126=HEAPF32[(($125)>>2)];
      var $127=$126*256;
      var $128=($127 >= 0 ? Math.floor($127) : Math.ceil($127));
      $sr=$128;
      var $129=$1;
      var $130=(($129+20)|0);
      var $131=(($130+8)|0);
      var $132=HEAPF32[(($131)>>2)];
      var $133=$132*256;
      var $134=($133 >= 0 ? Math.floor($133) : Math.ceil($133));
      $sg=$134;
      var $135=$1;
      var $136=(($135+20)|0);
      var $137=(($136+12)|0);
      var $138=HEAPF32[(($137)>>2)];
      var $139=$138*256;
      var $140=($139 >= 0 ? Math.floor($139) : Math.ceil($139));
      $sb=$140;
      var $141=$sr;
      var $142=(($141)>>>0) > 256;
      if ($142) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $143
      var $144=$sr;
      var $145=(($144)|0) < 0;
      if ($145) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $146
      $sr=0;
      __label__ = 20; break;
    case 19: // $147
      $sr=256;
      __label__ = 20; break;
    case 20: // $148
      __label__ = 21; break;
    case 21: // $149
      var $150=$sg;
      var $151=(($150)>>>0) > 256;
      if ($151) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $152
      var $153=$sg;
      var $154=(($153)|0) < 0;
      if ($154) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $155
      $sg=0;
      __label__ = 25; break;
    case 24: // $156
      $sg=256;
      __label__ = 25; break;
    case 25: // $157
      __label__ = 26; break;
    case 26: // $158
      var $159=$sb;
      var $160=(($159)>>>0) > 256;
      if ($160) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $161
      var $162=$sb;
      var $163=(($162)|0) < 0;
      if ($163) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $164
      $sb=0;
      __label__ = 30; break;
    case 29: // $165
      $sb=256;
      __label__ = 30; break;
    case 30: // $166
      __label__ = 31; break;
    case 31: // $167
      var $168=$4;
      var $169=(($168+28)|0);
      var $170=HEAP32[(($169)>>2)];
      $y=$170;
      __label__ = 32; break;
    case 32: // $171
      var $172=$y;
      var $173=$4;
      var $174=(($173+36)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=(($172)|0) < (($175)|0);
      if ($176) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 33: // $177
      var $178=$2;
      var $179=$178;
      var $180=$y;
      var $181=$3;
      var $182=(($180*$181)|0);
      var $183=(($179+($182<<2))|0);
      var $184=$4;
      var $185=(($184+24)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($183+($186<<2))|0);
      $dest1=$187;
      var $188=$4;
      var $189=(($188+16)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$y;
      var $192=$4;
      var $193=(($192+28)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($191-$194)|0);
      var $196=$4;
      var $197=(($196+8)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($195*$198)|0);
      var $200=(($190+$199)|0);
      $curu2=$200;
      var $201=$4;
      var $202=(($201+20)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$y;
      var $205=$4;
      var $206=(($205+28)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($204-$207)|0);
      var $209=$4;
      var $210=(($209+12)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=(($208*$211)|0);
      var $213=(($203+$212)|0);
      $curv3=$213;
      var $214=$4;
      var $215=(($214+24)|0);
      var $216=HEAP32[(($215)>>2)];
      $x=$216;
      __label__ = 34; break;
    case 34: // $217
      var $218=$x;
      var $219=$endx;
      var $220=(($218)|0) < (($219)|0);
      if ($220) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $221
      var $222=$1;
      var $223=(($222+44)|0);
      var $224=$curu2;
      var $225=$curv3;
      var $226=__ZL28get_texel_palette16_bilinearPK14render_texinfoii($223, $224, $225);
      $pix4=$226;
      var $227=$pix4;
      var $228=$227 >>> 16;
      var $229=$228 & 255;
      var $230=$sr;
      var $231=(($229*$230)|0);
      var $232=$231 >>> 8;
      $r=$232;
      var $233=$pix4;
      var $234=$233 >>> 8;
      var $235=$234 & 255;
      var $236=$sg;
      var $237=(($235*$236)|0);
      var $238=$237 >>> 8;
      $g=$238;
      var $239=$pix4;
      var $240=$239 >>> 0;
      var $241=$240 & 255;
      var $242=$sb;
      var $243=(($241*$242)|0);
      var $244=$243 >>> 8;
      $b=$244;
      var $245=$r;
      var $246=$245 << 16;
      var $247=$g;
      var $248=$247 << 8;
      var $249=$246 | $248;
      var $250=$b;
      var $251=$250 << 0;
      var $252=$249 | $251;
      var $253=$dest1;
      var $254=(($253+4)|0);
      $dest1=$254;
      HEAP32[(($253)>>2)]=$252;
      var $255=$dudx;
      var $256=$curu2;
      var $257=(($256+$255)|0);
      $curu2=$257;
      var $258=$dvdx;
      var $259=$curv3;
      var $260=(($259+$258)|0);
      $curv3=$260;
      __label__ = 36; break;
    case 36: // $261
      var $262=$x;
      var $263=(($262+1)|0);
      $x=$263;
      __label__ = 34; break;
    case 37: // $264
      __label__ = 38; break;
    case 38: // $265
      var $266=$y;
      var $267=(($266+1)|0);
      $y=$267;
      __label__ = 32; break;
    case 39: // $268
      __label__ = 71; break;
    case 40: // $269
      var $270=$1;
      var $271=(($270+20)|0);
      var $272=(($271)|0);
      var $273=HEAPF32[(($272)>>2)];
      var $274=$273 < 0.00009999999747378752;
      if ($274) { __label__ = 70; break; } else { __label__ = 41; break; }
    case 41: // $275
      var $276=$1;
      var $277=(($276+20)|0);
      var $278=(($277+4)|0);
      var $279=HEAPF32[(($278)>>2)];
      var $280=$279*256;
      var $281=$1;
      var $282=(($281+20)|0);
      var $283=(($282)|0);
      var $284=HEAPF32[(($283)>>2)];
      var $285=$280*$284;
      var $286=($285 >= 0 ? Math.floor($285) : Math.ceil($285));
      $sr5=$286;
      var $287=$1;
      var $288=(($287+20)|0);
      var $289=(($288+8)|0);
      var $290=HEAPF32[(($289)>>2)];
      var $291=$290*256;
      var $292=$1;
      var $293=(($292+20)|0);
      var $294=(($293)|0);
      var $295=HEAPF32[(($294)>>2)];
      var $296=$291*$295;
      var $297=($296 >= 0 ? Math.floor($296) : Math.ceil($296));
      $sg6=$297;
      var $298=$1;
      var $299=(($298+20)|0);
      var $300=(($299+12)|0);
      var $301=HEAPF32[(($300)>>2)];
      var $302=$301*256;
      var $303=$1;
      var $304=(($303+20)|0);
      var $305=(($304)|0);
      var $306=HEAPF32[(($305)>>2)];
      var $307=$302*$306;
      var $308=($307 >= 0 ? Math.floor($307) : Math.ceil($307));
      $sb7=$308;
      var $309=$1;
      var $310=(($309+20)|0);
      var $311=(($310)|0);
      var $312=HEAPF32[(($311)>>2)];
      var $313=1-$312;
      var $314=$313*256;
      var $315=($314 >= 0 ? Math.floor($314) : Math.ceil($314));
      $invsa=$315;
      var $316=$sr5;
      var $317=(($316)>>>0) > 256;
      if ($317) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $318
      var $319=$sr5;
      var $320=(($319)|0) < 0;
      if ($320) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $321
      $sr5=0;
      __label__ = 45; break;
    case 44: // $322
      $sr5=256;
      __label__ = 45; break;
    case 45: // $323
      __label__ = 46; break;
    case 46: // $324
      var $325=$sg6;
      var $326=(($325)>>>0) > 256;
      if ($326) { __label__ = 47; break; } else { __label__ = 51; break; }
    case 47: // $327
      var $328=$sg6;
      var $329=(($328)|0) < 0;
      if ($329) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $330
      $sg6=0;
      __label__ = 50; break;
    case 49: // $331
      $sg6=256;
      __label__ = 50; break;
    case 50: // $332
      __label__ = 51; break;
    case 51: // $333
      var $334=$sb7;
      var $335=(($334)>>>0) > 256;
      if ($335) { __label__ = 52; break; } else { __label__ = 56; break; }
    case 52: // $336
      var $337=$sb7;
      var $338=(($337)|0) < 0;
      if ($338) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $339
      $sb7=0;
      __label__ = 55; break;
    case 54: // $340
      $sb7=256;
      __label__ = 55; break;
    case 55: // $341
      __label__ = 56; break;
    case 56: // $342
      var $343=$invsa;
      var $344=(($343)>>>0) > 256;
      if ($344) { __label__ = 57; break; } else { __label__ = 61; break; }
    case 57: // $345
      var $346=$invsa;
      var $347=(($346)|0) < 0;
      if ($347) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $348
      $invsa=0;
      __label__ = 60; break;
    case 59: // $349
      $invsa=256;
      __label__ = 60; break;
    case 60: // $350
      __label__ = 61; break;
    case 61: // $351
      var $352=$4;
      var $353=(($352+28)|0);
      var $354=HEAP32[(($353)>>2)];
      $y=$354;
      __label__ = 62; break;
    case 62: // $355
      var $356=$y;
      var $357=$4;
      var $358=(($357+36)|0);
      var $359=HEAP32[(($358)>>2)];
      var $360=(($356)|0) < (($359)|0);
      if ($360) { __label__ = 63; break; } else { __label__ = 69; break; }
    case 63: // $361
      var $362=$2;
      var $363=$362;
      var $364=$y;
      var $365=$3;
      var $366=(($364*$365)|0);
      var $367=(($363+($366<<2))|0);
      var $368=$4;
      var $369=(($368+24)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=(($367+($370<<2))|0);
      $dest8=$371;
      var $372=$4;
      var $373=(($372+16)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=$y;
      var $376=$4;
      var $377=(($376+28)|0);
      var $378=HEAP32[(($377)>>2)];
      var $379=(($375-$378)|0);
      var $380=$4;
      var $381=(($380+8)|0);
      var $382=HEAP32[(($381)>>2)];
      var $383=(($379*$382)|0);
      var $384=(($374+$383)|0);
      $curu9=$384;
      var $385=$4;
      var $386=(($385+20)|0);
      var $387=HEAP32[(($386)>>2)];
      var $388=$y;
      var $389=$4;
      var $390=(($389+28)|0);
      var $391=HEAP32[(($390)>>2)];
      var $392=(($388-$391)|0);
      var $393=$4;
      var $394=(($393+12)|0);
      var $395=HEAP32[(($394)>>2)];
      var $396=(($392*$395)|0);
      var $397=(($387+$396)|0);
      $curv10=$397;
      var $398=$4;
      var $399=(($398+24)|0);
      var $400=HEAP32[(($399)>>2)];
      $x=$400;
      __label__ = 64; break;
    case 64: // $401
      var $402=$x;
      var $403=$endx;
      var $404=(($402)|0) < (($403)|0);
      if ($404) { __label__ = 65; break; } else { __label__ = 67; break; }
    case 65: // $405
      var $406=$1;
      var $407=(($406+44)|0);
      var $408=$curu9;
      var $409=$curv10;
      var $410=__ZL28get_texel_palette16_bilinearPK14render_texinfoii($407, $408, $409);
      $pix11=$410;
      var $411=$dest8;
      var $412=HEAP32[(($411)>>2)];
      $dpix=$412;
      var $413=$pix11;
      var $414=$413 >>> 16;
      var $415=$414 & 255;
      var $416=$sr5;
      var $417=(($415*$416)|0);
      var $418=$dpix;
      var $419=$418 >>> 16;
      var $420=$419 & 255;
      var $421=$invsa;
      var $422=(($420*$421)|0);
      var $423=(($417+$422)|0);
      var $424=$423 >>> 8;
      $r12=$424;
      var $425=$pix11;
      var $426=$425 >>> 8;
      var $427=$426 & 255;
      var $428=$sg6;
      var $429=(($427*$428)|0);
      var $430=$dpix;
      var $431=$430 >>> 8;
      var $432=$431 & 255;
      var $433=$invsa;
      var $434=(($432*$433)|0);
      var $435=(($429+$434)|0);
      var $436=$435 >>> 8;
      $g13=$436;
      var $437=$pix11;
      var $438=$437 >>> 0;
      var $439=$438 & 255;
      var $440=$sb7;
      var $441=(($439*$440)|0);
      var $442=$dpix;
      var $443=$442 >>> 0;
      var $444=$443 & 255;
      var $445=$invsa;
      var $446=(($444*$445)|0);
      var $447=(($441+$446)|0);
      var $448=$447 >>> 8;
      $b14=$448;
      var $449=$r12;
      var $450=$449 << 16;
      var $451=$g13;
      var $452=$451 << 8;
      var $453=$450 | $452;
      var $454=$b14;
      var $455=$454 << 0;
      var $456=$453 | $455;
      var $457=$dest8;
      var $458=(($457+4)|0);
      $dest8=$458;
      HEAP32[(($457)>>2)]=$456;
      var $459=$dudx;
      var $460=$curu9;
      var $461=(($460+$459)|0);
      $curu9=$461;
      var $462=$dvdx;
      var $463=$curv10;
      var $464=(($463+$462)|0);
      $curv10=$464;
      __label__ = 66; break;
    case 66: // $465
      var $466=$x;
      var $467=(($466+1)|0);
      $x=$467;
      __label__ = 64; break;
    case 67: // $468
      __label__ = 68; break;
    case 68: // $469
      var $470=$y;
      var $471=(($470+1)|0);
      $y=$471;
      __label__ = 62; break;
    case 69: // $472
      __label__ = 70; break;
    case 70: // $473
      __label__ = 71; break;
    case 71: // $474
      __label__ = 72; break;
    case 72: // $475
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL31rgb888_draw_quad_palette16_nonePK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL30rgb888_draw_quad_palette16_addPK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $dpix;
      var $r;
      var $g;
      var $b;
      var $sr;
      var $sg;
      var $sb;
      var $dest1;
      var $curu2;
      var $curv3;
      var $pix4;
      var $dpix5;
      var $r6;
      var $g7;
      var $b8;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      $dudx=$7;
      var $8=$4;
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      $dvdx=$10;
      var $11=$4;
      var $12=(($11+32)|0);
      var $13=HEAP32[(($12)>>2)];
      $endx=$13;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=$1;
      var $17=(($16+20)|0);
      var $18=(($17+4)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=$19 >= 1;
      if ($20) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $21
      var $22=$1;
      var $23=(($22+20)|0);
      var $24=(($23+8)|0);
      var $25=HEAPF32[(($24)>>2)];
      var $26=$25 >= 1;
      if ($26) { __label__ = 4; break; } else { __label__ = 17; break; }
    case 4: // $27
      var $28=$1;
      var $29=(($28+20)|0);
      var $30=(($29+12)|0);
      var $31=HEAPF32[(($30)>>2)];
      var $32=$31 >= 1;
      if ($32) { __label__ = 5; break; } else { __label__ = 17; break; }
    case 5: // $33
      var $34=$1;
      var $35=(($34+20)|0);
      var $36=(($35)|0);
      var $37=HEAPF32[(($36)>>2)];
      var $38=$37 >= 1;
      if ($38) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $39
      var $40=$4;
      var $41=(($40+28)|0);
      var $42=HEAP32[(($41)>>2)];
      $y=$42;
      __label__ = 7; break;
    case 7: // $43
      var $44=$y;
      var $45=$4;
      var $46=(($45+36)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44)|0) < (($47)|0);
      if ($48) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $49
      var $50=$2;
      var $51=$50;
      var $52=$y;
      var $53=$3;
      var $54=(($52*$53)|0);
      var $55=(($51+($54<<2))|0);
      var $56=$4;
      var $57=(($56+24)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($55+($58<<2))|0);
      $dest=$59;
      var $60=$4;
      var $61=(($60+16)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$y;
      var $64=$4;
      var $65=(($64+28)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($63-$66)|0);
      var $68=$4;
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($67*$70)|0);
      var $72=(($62+$71)|0);
      $curu=$72;
      var $73=$4;
      var $74=(($73+20)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$y;
      var $77=$4;
      var $78=(($77+28)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($76-$79)|0);
      var $81=$4;
      var $82=(($81+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($80*$83)|0);
      var $85=(($75+$84)|0);
      $curv=$85;
      var $86=$4;
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      $x=$88;
      __label__ = 9; break;
    case 9: // $89
      var $90=$x;
      var $91=$endx;
      var $92=(($90)|0) < (($91)|0);
      if ($92) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $93
      var $94=$1;
      var $95=(($94+44)|0);
      var $96=$curu;
      var $97=$curv;
      var $98=__ZL28get_texel_palette16_bilinearPK14render_texinfoii($95, $96, $97);
      $pix=$98;
      var $99=$pix;
      var $100=$99 & 16777215;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $102
      var $103=$dest;
      var $104=HEAP32[(($103)>>2)];
      $dpix=$104;
      var $105=$pix;
      var $106=$105 >>> 16;
      var $107=$106 & 255;
      var $108=$dpix;
      var $109=$108 >>> 16;
      var $110=$109 & 255;
      var $111=(($107+$110)|0);
      $r=$111;
      var $112=$pix;
      var $113=$112 >>> 8;
      var $114=$113 & 255;
      var $115=$dpix;
      var $116=$115 >>> 8;
      var $117=$116 & 255;
      var $118=(($114+$117)|0);
      $g=$118;
      var $119=$pix;
      var $120=$119 >>> 0;
      var $121=$120 & 255;
      var $122=$dpix;
      var $123=$122 >>> 0;
      var $124=$123 & 255;
      var $125=(($121+$124)|0);
      $b=$125;
      var $126=$r;
      var $127=$r;
      var $128=$127 >>> 8;
      var $129=(((-$128))|0);
      var $130=$126 | $129;
      var $131=$130 & 255;
      $r=$131;
      var $132=$g;
      var $133=$g;
      var $134=$133 >>> 8;
      var $135=(((-$134))|0);
      var $136=$132 | $135;
      var $137=$136 & 255;
      $g=$137;
      var $138=$b;
      var $139=$b;
      var $140=$139 >>> 8;
      var $141=(((-$140))|0);
      var $142=$138 | $141;
      var $143=$142 & 255;
      $b=$143;
      var $144=$r;
      var $145=$144 << 16;
      var $146=$g;
      var $147=$146 << 8;
      var $148=$145 | $147;
      var $149=$b;
      var $150=$149 << 0;
      var $151=$148 | $150;
      var $152=$dest;
      HEAP32[(($152)>>2)]=$151;
      __label__ = 12; break;
    case 12: // $153
      var $154=$dest;
      var $155=(($154+4)|0);
      $dest=$155;
      var $156=$dudx;
      var $157=$curu;
      var $158=(($157+$156)|0);
      $curu=$158;
      var $159=$dvdx;
      var $160=$curv;
      var $161=(($160+$159)|0);
      $curv=$161;
      __label__ = 13; break;
    case 13: // $162
      var $163=$x;
      var $164=(($163+1)|0);
      $x=$164;
      __label__ = 9; break;
    case 14: // $165
      __label__ = 15; break;
    case 15: // $166
      var $167=$y;
      var $168=(($167+1)|0);
      $y=$168;
      __label__ = 7; break;
    case 16: // $169
      __label__ = 43; break;
    case 17: // $170
      var $171=$1;
      var $172=(($171+20)|0);
      var $173=(($172+4)|0);
      var $174=HEAPF32[(($173)>>2)];
      var $175=$174*256;
      var $176=$1;
      var $177=(($176+20)|0);
      var $178=(($177)|0);
      var $179=HEAPF32[(($178)>>2)];
      var $180=$175*$179;
      var $181=($180 >= 0 ? Math.floor($180) : Math.ceil($180));
      $sr=$181;
      var $182=$1;
      var $183=(($182+20)|0);
      var $184=(($183+8)|0);
      var $185=HEAPF32[(($184)>>2)];
      var $186=$185*256;
      var $187=$1;
      var $188=(($187+20)|0);
      var $189=(($188)|0);
      var $190=HEAPF32[(($189)>>2)];
      var $191=$186*$190;
      var $192=($191 >= 0 ? Math.floor($191) : Math.ceil($191));
      $sg=$192;
      var $193=$1;
      var $194=(($193+20)|0);
      var $195=(($194+12)|0);
      var $196=HEAPF32[(($195)>>2)];
      var $197=$196*256;
      var $198=$1;
      var $199=(($198+20)|0);
      var $200=(($199)|0);
      var $201=HEAPF32[(($200)>>2)];
      var $202=$197*$201;
      var $203=($202 >= 0 ? Math.floor($202) : Math.ceil($202));
      $sb=$203;
      var $204=$sr;
      var $205=(($204)>>>0) > 256;
      if ($205) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $206
      var $207=$sr;
      var $208=(($207)|0) < 0;
      if ($208) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $209
      $sr=0;
      __label__ = 21; break;
    case 20: // $210
      $sr=256;
      __label__ = 21; break;
    case 21: // $211
      __label__ = 22; break;
    case 22: // $212
      var $213=$sg;
      var $214=(($213)>>>0) > 256;
      if ($214) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $215
      var $216=$sg;
      var $217=(($216)|0) < 0;
      if ($217) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $218
      $sg=0;
      __label__ = 26; break;
    case 25: // $219
      $sg=256;
      __label__ = 26; break;
    case 26: // $220
      __label__ = 27; break;
    case 27: // $221
      var $222=$sb;
      var $223=(($222)>>>0) > 256;
      if ($223) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $224
      var $225=$sb;
      var $226=(($225)|0) < 0;
      if ($226) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $227
      $sb=0;
      __label__ = 31; break;
    case 30: // $228
      $sb=256;
      __label__ = 31; break;
    case 31: // $229
      __label__ = 32; break;
    case 32: // $230
      var $231=$4;
      var $232=(($231+28)|0);
      var $233=HEAP32[(($232)>>2)];
      $y=$233;
      __label__ = 33; break;
    case 33: // $234
      var $235=$y;
      var $236=$4;
      var $237=(($236+36)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($235)|0) < (($238)|0);
      if ($239) { __label__ = 34; break; } else { __label__ = 42; break; }
    case 34: // $240
      var $241=$2;
      var $242=$241;
      var $243=$y;
      var $244=$3;
      var $245=(($243*$244)|0);
      var $246=(($242+($245<<2))|0);
      var $247=$4;
      var $248=(($247+24)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(($246+($249<<2))|0);
      $dest1=$250;
      var $251=$4;
      var $252=(($251+16)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=$y;
      var $255=$4;
      var $256=(($255+28)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($254-$257)|0);
      var $259=$4;
      var $260=(($259+8)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=(($258*$261)|0);
      var $263=(($253+$262)|0);
      $curu2=$263;
      var $264=$4;
      var $265=(($264+20)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=$y;
      var $268=$4;
      var $269=(($268+28)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($267-$270)|0);
      var $272=$4;
      var $273=(($272+12)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($271*$274)|0);
      var $276=(($266+$275)|0);
      $curv3=$276;
      var $277=$4;
      var $278=(($277+24)|0);
      var $279=HEAP32[(($278)>>2)];
      $x=$279;
      __label__ = 35; break;
    case 35: // $280
      var $281=$x;
      var $282=$endx;
      var $283=(($281)|0) < (($282)|0);
      if ($283) { __label__ = 36; break; } else { __label__ = 40; break; }
    case 36: // $284
      var $285=$1;
      var $286=(($285+44)|0);
      var $287=$curu2;
      var $288=$curv3;
      var $289=__ZL28get_texel_palette16_bilinearPK14render_texinfoii($286, $287, $288);
      $pix4=$289;
      var $290=$pix4;
      var $291=$290 & 16777215;
      var $292=(($291)|0)!=0;
      if ($292) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $293
      var $294=$dest1;
      var $295=HEAP32[(($294)>>2)];
      $dpix5=$295;
      var $296=$pix4;
      var $297=$296 >>> 16;
      var $298=$297 & 255;
      var $299=$sr;
      var $300=(($298*$299)|0);
      var $301=$300 >>> 8;
      var $302=$dpix5;
      var $303=$302 >>> 16;
      var $304=$303 & 255;
      var $305=(($301+$304)|0);
      $r6=$305;
      var $306=$pix4;
      var $307=$306 >>> 8;
      var $308=$307 & 255;
      var $309=$sg;
      var $310=(($308*$309)|0);
      var $311=$310 >>> 8;
      var $312=$dpix5;
      var $313=$312 >>> 8;
      var $314=$313 & 255;
      var $315=(($311+$314)|0);
      $g7=$315;
      var $316=$pix4;
      var $317=$316 >>> 0;
      var $318=$317 & 255;
      var $319=$sb;
      var $320=(($318*$319)|0);
      var $321=$320 >>> 8;
      var $322=$dpix5;
      var $323=$322 >>> 0;
      var $324=$323 & 255;
      var $325=(($321+$324)|0);
      $b8=$325;
      var $326=$r6;
      var $327=$r6;
      var $328=$327 >>> 8;
      var $329=(((-$328))|0);
      var $330=$326 | $329;
      var $331=$330 & 255;
      $r6=$331;
      var $332=$g7;
      var $333=$g7;
      var $334=$333 >>> 8;
      var $335=(((-$334))|0);
      var $336=$332 | $335;
      var $337=$336 & 255;
      $g7=$337;
      var $338=$b8;
      var $339=$b8;
      var $340=$339 >>> 8;
      var $341=(((-$340))|0);
      var $342=$338 | $341;
      var $343=$342 & 255;
      $b8=$343;
      var $344=$r6;
      var $345=$344 << 16;
      var $346=$g7;
      var $347=$346 << 8;
      var $348=$345 | $347;
      var $349=$b8;
      var $350=$349 << 0;
      var $351=$348 | $350;
      var $352=$dest1;
      var $353=(($352+4)|0);
      $dest1=$353;
      HEAP32[(($352)>>2)]=$351;
      var $354=$dudx;
      var $355=$curu2;
      var $356=(($355+$354)|0);
      $curu2=$356;
      var $357=$dvdx;
      var $358=$curv3;
      var $359=(($358+$357)|0);
      $curv3=$359;
      __label__ = 38; break;
    case 38: // $360
      __label__ = 39; break;
    case 39: // $361
      var $362=$x;
      var $363=(($362+1)|0);
      $x=$363;
      __label__ = 35; break;
    case 40: // $364
      __label__ = 41; break;
    case 41: // $365
      var $366=$y;
      var $367=(($366+1)|0);
      $y=$367;
      __label__ = 33; break;
    case 42: // $368
      __label__ = 43; break;
    case 43: // $369
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30rgb888_draw_quad_palette16_addPK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL33rgb888_draw_quad_palettea16_alphaPK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $ta;
      var $dpix;
      var $invta;
      var $r;
      var $g;
      var $b;
      var $sr;
      var $sg;
      var $sb;
      var $sa;
      var $dest1;
      var $curu2;
      var $curv3;
      var $pix4;
      var $ta5;
      var $dpix6;
      var $invsta;
      var $r7;
      var $g8;
      var $b9;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      $dudx=$7;
      var $8=$4;
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      $dvdx=$10;
      var $11=$4;
      var $12=(($11+32)|0);
      var $13=HEAP32[(($12)>>2)];
      $endx=$13;
      __label__ = 1; break;
    case 1: // $14
      __label__ = 2; break;
    case 2: // $15
      var $16=$1;
      var $17=(($16+20)|0);
      var $18=(($17+4)|0);
      var $19=HEAPF32[(($18)>>2)];
      var $20=$19 >= 1;
      if ($20) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $21
      var $22=$1;
      var $23=(($22+20)|0);
      var $24=(($23+8)|0);
      var $25=HEAPF32[(($24)>>2)];
      var $26=$25 >= 1;
      if ($26) { __label__ = 4; break; } else { __label__ = 17; break; }
    case 4: // $27
      var $28=$1;
      var $29=(($28+20)|0);
      var $30=(($29+12)|0);
      var $31=HEAPF32[(($30)>>2)];
      var $32=$31 >= 1;
      if ($32) { __label__ = 5; break; } else { __label__ = 17; break; }
    case 5: // $33
      var $34=$1;
      var $35=(($34+20)|0);
      var $36=(($35)|0);
      var $37=HEAPF32[(($36)>>2)];
      var $38=$37 >= 1;
      if ($38) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $39
      var $40=$4;
      var $41=(($40+28)|0);
      var $42=HEAP32[(($41)>>2)];
      $y=$42;
      __label__ = 7; break;
    case 7: // $43
      var $44=$y;
      var $45=$4;
      var $46=(($45+36)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44)|0) < (($47)|0);
      if ($48) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $49
      var $50=$2;
      var $51=$50;
      var $52=$y;
      var $53=$3;
      var $54=(($52*$53)|0);
      var $55=(($51+($54<<2))|0);
      var $56=$4;
      var $57=(($56+24)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($55+($58<<2))|0);
      $dest=$59;
      var $60=$4;
      var $61=(($60+16)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$y;
      var $64=$4;
      var $65=(($64+28)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($63-$66)|0);
      var $68=$4;
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($67*$70)|0);
      var $72=(($62+$71)|0);
      $curu=$72;
      var $73=$4;
      var $74=(($73+20)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$y;
      var $77=$4;
      var $78=(($77+28)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($76-$79)|0);
      var $81=$4;
      var $82=(($81+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($80*$83)|0);
      var $85=(($75+$84)|0);
      $curv=$85;
      var $86=$4;
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      $x=$88;
      __label__ = 9; break;
    case 9: // $89
      var $90=$x;
      var $91=$endx;
      var $92=(($90)|0) < (($91)|0);
      if ($92) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $93
      var $94=$1;
      var $95=(($94+44)|0);
      var $96=$curu;
      var $97=$curv;
      var $98=__ZL29get_texel_palette16a_bilinearPK14render_texinfoii($95, $96, $97);
      $pix=$98;
      var $99=$pix;
      var $100=$99 >>> 24;
      $ta=$100;
      var $101=$ta;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $103
      var $104=$dest;
      var $105=HEAP32[(($104)>>2)];
      $dpix=$105;
      var $106=$ta;
      var $107=((256-$106)|0);
      $invta=$107;
      var $108=$pix;
      var $109=$108 >>> 16;
      var $110=$109 & 255;
      var $111=$ta;
      var $112=(($110*$111)|0);
      var $113=$dpix;
      var $114=$113 >>> 16;
      var $115=$114 & 255;
      var $116=$invta;
      var $117=(($115*$116)|0);
      var $118=(($112+$117)|0);
      var $119=$118 >>> 8;
      $r=$119;
      var $120=$pix;
      var $121=$120 >>> 8;
      var $122=$121 & 255;
      var $123=$ta;
      var $124=(($122*$123)|0);
      var $125=$dpix;
      var $126=$125 >>> 8;
      var $127=$126 & 255;
      var $128=$invta;
      var $129=(($127*$128)|0);
      var $130=(($124+$129)|0);
      var $131=$130 >>> 8;
      $g=$131;
      var $132=$pix;
      var $133=$132 >>> 0;
      var $134=$133 & 255;
      var $135=$ta;
      var $136=(($134*$135)|0);
      var $137=$dpix;
      var $138=$137 >>> 0;
      var $139=$138 & 255;
      var $140=$invta;
      var $141=(($139*$140)|0);
      var $142=(($136+$141)|0);
      var $143=$142 >>> 8;
      $b=$143;
      var $144=$r;
      var $145=$144 << 16;
      var $146=$g;
      var $147=$146 << 8;
      var $148=$145 | $147;
      var $149=$b;
      var $150=$149 << 0;
      var $151=$148 | $150;
      var $152=$dest;
      HEAP32[(($152)>>2)]=$151;
      __label__ = 12; break;
    case 12: // $153
      var $154=$dest;
      var $155=(($154+4)|0);
      $dest=$155;
      var $156=$dudx;
      var $157=$curu;
      var $158=(($157+$156)|0);
      $curu=$158;
      var $159=$dvdx;
      var $160=$curv;
      var $161=(($160+$159)|0);
      $curv=$161;
      __label__ = 13; break;
    case 13: // $162
      var $163=$x;
      var $164=(($163+1)|0);
      $x=$164;
      __label__ = 9; break;
    case 14: // $165
      __label__ = 15; break;
    case 15: // $166
      var $167=$y;
      var $168=(($167+1)|0);
      $y=$168;
      __label__ = 7; break;
    case 16: // $169
      __label__ = 48; break;
    case 17: // $170
      var $171=$1;
      var $172=(($171+20)|0);
      var $173=(($172+4)|0);
      var $174=HEAPF32[(($173)>>2)];
      var $175=$174*256;
      var $176=($175 >= 0 ? Math.floor($175) : Math.ceil($175));
      $sr=$176;
      var $177=$1;
      var $178=(($177+20)|0);
      var $179=(($178+8)|0);
      var $180=HEAPF32[(($179)>>2)];
      var $181=$180*256;
      var $182=($181 >= 0 ? Math.floor($181) : Math.ceil($181));
      $sg=$182;
      var $183=$1;
      var $184=(($183+20)|0);
      var $185=(($184+12)|0);
      var $186=HEAPF32[(($185)>>2)];
      var $187=$186*256;
      var $188=($187 >= 0 ? Math.floor($187) : Math.ceil($187));
      $sb=$188;
      var $189=$1;
      var $190=(($189+20)|0);
      var $191=(($190)|0);
      var $192=HEAPF32[(($191)>>2)];
      var $193=$192*256;
      var $194=($193 >= 0 ? Math.floor($193) : Math.ceil($193));
      $sa=$194;
      var $195=$sr;
      var $196=(($195)>>>0) > 256;
      if ($196) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $197
      var $198=$sr;
      var $199=(($198)|0) < 0;
      if ($199) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $200
      $sr=0;
      __label__ = 21; break;
    case 20: // $201
      $sr=256;
      __label__ = 21; break;
    case 21: // $202
      __label__ = 22; break;
    case 22: // $203
      var $204=$sg;
      var $205=(($204)>>>0) > 256;
      if ($205) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $206
      var $207=$sg;
      var $208=(($207)|0) < 0;
      if ($208) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $209
      $sg=0;
      __label__ = 26; break;
    case 25: // $210
      $sg=256;
      __label__ = 26; break;
    case 26: // $211
      __label__ = 27; break;
    case 27: // $212
      var $213=$sb;
      var $214=(($213)>>>0) > 256;
      if ($214) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $215
      var $216=$sb;
      var $217=(($216)|0) < 0;
      if ($217) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $218
      $sb=0;
      __label__ = 31; break;
    case 30: // $219
      $sb=256;
      __label__ = 31; break;
    case 31: // $220
      __label__ = 32; break;
    case 32: // $221
      var $222=$sa;
      var $223=(($222)>>>0) > 256;
      if ($223) { __label__ = 33; break; } else { __label__ = 37; break; }
    case 33: // $224
      var $225=$sa;
      var $226=(($225)|0) < 0;
      if ($226) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $227
      $sa=0;
      __label__ = 36; break;
    case 35: // $228
      $sa=256;
      __label__ = 36; break;
    case 36: // $229
      __label__ = 37; break;
    case 37: // $230
      var $231=$4;
      var $232=(($231+28)|0);
      var $233=HEAP32[(($232)>>2)];
      $y=$233;
      __label__ = 38; break;
    case 38: // $234
      var $235=$y;
      var $236=$4;
      var $237=(($236+36)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($235)|0) < (($238)|0);
      if ($239) { __label__ = 39; break; } else { __label__ = 47; break; }
    case 39: // $240
      var $241=$2;
      var $242=$241;
      var $243=$y;
      var $244=$3;
      var $245=(($243*$244)|0);
      var $246=(($242+($245<<2))|0);
      var $247=$4;
      var $248=(($247+24)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(($246+($249<<2))|0);
      $dest1=$250;
      var $251=$4;
      var $252=(($251+16)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=$y;
      var $255=$4;
      var $256=(($255+28)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($254-$257)|0);
      var $259=$4;
      var $260=(($259+8)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=(($258*$261)|0);
      var $263=(($253+$262)|0);
      $curu2=$263;
      var $264=$4;
      var $265=(($264+20)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=$y;
      var $268=$4;
      var $269=(($268+28)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($267-$270)|0);
      var $272=$4;
      var $273=(($272+12)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($271*$274)|0);
      var $276=(($266+$275)|0);
      $curv3=$276;
      var $277=$4;
      var $278=(($277+24)|0);
      var $279=HEAP32[(($278)>>2)];
      $x=$279;
      __label__ = 40; break;
    case 40: // $280
      var $281=$x;
      var $282=$endx;
      var $283=(($281)|0) < (($282)|0);
      if ($283) { __label__ = 41; break; } else { __label__ = 45; break; }
    case 41: // $284
      var $285=$1;
      var $286=(($285+44)|0);
      var $287=$curu2;
      var $288=$curv3;
      var $289=__ZL29get_texel_palette16a_bilinearPK14render_texinfoii($286, $287, $288);
      $pix4=$289;
      var $290=$pix4;
      var $291=$290 >>> 24;
      var $292=$sa;
      var $293=(($291*$292)|0);
      $ta5=$293;
      var $294=$ta5;
      var $295=(($294)|0)!=0;
      if ($295) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $296
      var $297=$dest1;
      var $298=HEAP32[(($297)>>2)];
      $dpix6=$298;
      var $299=$ta5;
      var $300=((65536-$299)|0);
      var $301=$300 << 8;
      $invsta=$301;
      var $302=$pix4;
      var $303=$302 >>> 16;
      var $304=$303 & 255;
      var $305=$sr;
      var $306=(($304*$305)|0);
      var $307=$ta5;
      var $308=(($306*$307)|0);
      var $309=$dpix6;
      var $310=$309 >>> 16;
      var $311=$310 & 255;
      var $312=$invsta;
      var $313=(($311*$312)|0);
      var $314=(($308+$313)|0);
      var $315=$314 >>> 24;
      $r7=$315;
      var $316=$pix4;
      var $317=$316 >>> 8;
      var $318=$317 & 255;
      var $319=$sg;
      var $320=(($318*$319)|0);
      var $321=$ta5;
      var $322=(($320*$321)|0);
      var $323=$dpix6;
      var $324=$323 >>> 8;
      var $325=$324 & 255;
      var $326=$invsta;
      var $327=(($325*$326)|0);
      var $328=(($322+$327)|0);
      var $329=$328 >>> 24;
      $g8=$329;
      var $330=$pix4;
      var $331=$330 >>> 0;
      var $332=$331 & 255;
      var $333=$sb;
      var $334=(($332*$333)|0);
      var $335=$ta5;
      var $336=(($334*$335)|0);
      var $337=$dpix6;
      var $338=$337 >>> 0;
      var $339=$338 & 255;
      var $340=$invsta;
      var $341=(($339*$340)|0);
      var $342=(($336+$341)|0);
      var $343=$342 >>> 24;
      $b9=$343;
      var $344=$r7;
      var $345=$344 << 16;
      var $346=$g8;
      var $347=$346 << 8;
      var $348=$345 | $347;
      var $349=$b9;
      var $350=$349 << 0;
      var $351=$348 | $350;
      var $352=$dest1;
      HEAP32[(($352)>>2)]=$351;
      __label__ = 43; break;
    case 43: // $353
      var $354=$dest1;
      var $355=(($354+4)|0);
      $dest1=$355;
      var $356=$dudx;
      var $357=$curu2;
      var $358=(($357+$356)|0);
      $curu2=$358;
      var $359=$dvdx;
      var $360=$curv3;
      var $361=(($360+$359)|0);
      $curv3=$361;
      __label__ = 44; break;
    case 44: // $362
      var $363=$x;
      var $364=(($363+1)|0);
      $x=$364;
      __label__ = 40; break;
    case 45: // $365
      __label__ = 46; break;
    case 46: // $366
      var $367=$y;
      var $368=(($367+1)|0);
      $y=$368;
      __label__ = 38; break;
    case 47: // $369
      __label__ = 48; break;
    case 48: // $370
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL33rgb888_draw_quad_palettea16_alphaPK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL27rgb888_draw_quad_yuy16_nonePK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $pix1;
      var $sr;
      var $sg;
      var $sb;
      var $dest2;
      var $curu3;
      var $curv4;
      var $pix5;
      var $r;
      var $g;
      var $b;
      var $pix6;
      var $r7;
      var $g8;
      var $b9;
      var $sr10;
      var $sg11;
      var $sb12;
      var $invsa;
      var $dest13;
      var $curu14;
      var $curv15;
      var $pix16;
      var $dpix;
      var $r17;
      var $g18;
      var $b19;
      var $pix20;
      var $dpix21;
      var $r22;
      var $g23;
      var $b24;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL24get_texel_yuy16_bilinearPK14render_texinfoii($100, $101, $102);
      var $104=__ZL10ycc_to_rgbj($103);
      $pix=$104;
      var $105=$pix;
      var $106=$dest;
      var $107=(($106+4)|0);
      $dest=$107;
      HEAP32[(($106)>>2)]=$105;
      var $108=$dudx;
      var $109=$curu;
      var $110=(($109+$108)|0);
      $curu=$110;
      var $111=$dvdx;
      var $112=$curv;
      var $113=(($112+$111)|0);
      $curv=$113;
      __label__ = 10; break;
    case 10: // $114
      var $115=$x;
      var $116=(($115+1)|0);
      $x=$116;
      __label__ = 8; break;
    case 11: // $117
      __label__ = 17; break;
    case 12: // $118
      var $119=$4;
      var $120=(($119+24)|0);
      var $121=HEAP32[(($120)>>2)];
      $x=$121;
      __label__ = 13; break;
    case 13: // $122
      var $123=$x;
      var $124=$endx;
      var $125=(($123)|0) < (($124)|0);
      if ($125) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $126
      var $127=$1;
      var $128=(($127+44)|0);
      var $129=$curu;
      var $130=$curv;
      var $131=__ZL24get_texel_yuy16_bilinearPK14render_texinfoii($128, $129, $130);
      var $132=__ZL10ycc_to_rgbj($131);
      $pix1=$132;
      var $133=$pix1;
      var $134=$dest;
      var $135=(($134+4)|0);
      $dest=$135;
      HEAP32[(($134)>>2)]=$133;
      var $136=$dudx;
      var $137=$curu;
      var $138=(($137+$136)|0);
      $curu=$138;
      var $139=$dvdx;
      var $140=$curv;
      var $141=(($140+$139)|0);
      $curv=$141;
      __label__ = 15; break;
    case 15: // $142
      var $143=$x;
      var $144=(($143+1)|0);
      $x=$144;
      __label__ = 13; break;
    case 16: // $145
      __label__ = 17; break;
    case 17: // $146
      __label__ = 18; break;
    case 18: // $147
      var $148=$y;
      var $149=(($148+1)|0);
      $y=$149;
      __label__ = 5; break;
    case 19: // $150
      __label__ = 91; break;
    case 20: // $151
      var $152=$1;
      var $153=(($152+20)|0);
      var $154=(($153)|0);
      var $155=HEAPF32[(($154)>>2)];
      var $156=$155 >= 1;
      if ($156) { __label__ = 21; break; } else { __label__ = 52; break; }
    case 21: // $157
      var $158=$1;
      var $159=(($158+20)|0);
      var $160=(($159+4)|0);
      var $161=HEAPF32[(($160)>>2)];
      var $162=$161*256;
      var $163=($162 >= 0 ? Math.floor($162) : Math.ceil($162));
      $sr=$163;
      var $164=$1;
      var $165=(($164+20)|0);
      var $166=(($165+8)|0);
      var $167=HEAPF32[(($166)>>2)];
      var $168=$167*256;
      var $169=($168 >= 0 ? Math.floor($168) : Math.ceil($168));
      $sg=$169;
      var $170=$1;
      var $171=(($170+20)|0);
      var $172=(($171+12)|0);
      var $173=HEAPF32[(($172)>>2)];
      var $174=$173*256;
      var $175=($174 >= 0 ? Math.floor($174) : Math.ceil($174));
      $sb=$175;
      var $176=$sr;
      var $177=(($176)>>>0) > 256;
      if ($177) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $178
      var $179=$sr;
      var $180=(($179)|0) < 0;
      if ($180) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $181
      $sr=0;
      __label__ = 25; break;
    case 24: // $182
      $sr=256;
      __label__ = 25; break;
    case 25: // $183
      __label__ = 26; break;
    case 26: // $184
      var $185=$sg;
      var $186=(($185)>>>0) > 256;
      if ($186) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $187
      var $188=$sg;
      var $189=(($188)|0) < 0;
      if ($189) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $190
      $sg=0;
      __label__ = 30; break;
    case 29: // $191
      $sg=256;
      __label__ = 30; break;
    case 30: // $192
      __label__ = 31; break;
    case 31: // $193
      var $194=$sb;
      var $195=(($194)>>>0) > 256;
      if ($195) { __label__ = 32; break; } else { __label__ = 36; break; }
    case 32: // $196
      var $197=$sb;
      var $198=(($197)|0) < 0;
      if ($198) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $199
      $sb=0;
      __label__ = 35; break;
    case 34: // $200
      $sb=256;
      __label__ = 35; break;
    case 35: // $201
      __label__ = 36; break;
    case 36: // $202
      var $203=$4;
      var $204=(($203+28)|0);
      var $205=HEAP32[(($204)>>2)];
      $y=$205;
      __label__ = 37; break;
    case 37: // $206
      var $207=$y;
      var $208=$4;
      var $209=(($208+36)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=(($207)|0) < (($210)|0);
      if ($211) { __label__ = 38; break; } else { __label__ = 51; break; }
    case 38: // $212
      var $213=$2;
      var $214=$213;
      var $215=$y;
      var $216=$3;
      var $217=(($215*$216)|0);
      var $218=(($214+($217<<2))|0);
      var $219=$4;
      var $220=(($219+24)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($218+($221<<2))|0);
      $dest2=$222;
      var $223=$4;
      var $224=(($223+16)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$y;
      var $227=$4;
      var $228=(($227+28)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=(($226-$229)|0);
      var $231=$4;
      var $232=(($231+8)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($230*$233)|0);
      var $235=(($225+$234)|0);
      $curu3=$235;
      var $236=$4;
      var $237=(($236+20)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$y;
      var $240=$4;
      var $241=(($240+28)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(($239-$242)|0);
      var $244=$4;
      var $245=(($244+12)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($243*$246)|0);
      var $248=(($238+$247)|0);
      $curv4=$248;
      var $249=$palbase;
      var $250=(($249)|0)==0;
      if ($250) { __label__ = 39; break; } else { __label__ = 44; break; }
    case 39: // $251
      var $252=$4;
      var $253=(($252+24)|0);
      var $254=HEAP32[(($253)>>2)];
      $x=$254;
      __label__ = 40; break;
    case 40: // $255
      var $256=$x;
      var $257=$endx;
      var $258=(($256)|0) < (($257)|0);
      if ($258) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $259
      var $260=$1;
      var $261=(($260+44)|0);
      var $262=$curu3;
      var $263=$curv4;
      var $264=__ZL24get_texel_yuy16_bilinearPK14render_texinfoii($261, $262, $263);
      var $265=__ZL10ycc_to_rgbj($264);
      $pix5=$265;
      var $266=$pix5;
      var $267=$266 >>> 16;
      var $268=$267 & 255;
      var $269=$sr;
      var $270=(($268*$269)|0);
      var $271=$270 >>> 8;
      $r=$271;
      var $272=$pix5;
      var $273=$272 >>> 8;
      var $274=$273 & 255;
      var $275=$sg;
      var $276=(($274*$275)|0);
      var $277=$276 >>> 8;
      $g=$277;
      var $278=$pix5;
      var $279=$278 >>> 0;
      var $280=$279 & 255;
      var $281=$sb;
      var $282=(($280*$281)|0);
      var $283=$282 >>> 8;
      $b=$283;
      var $284=$r;
      var $285=$284 << 16;
      var $286=$g;
      var $287=$286 << 8;
      var $288=$285 | $287;
      var $289=$b;
      var $290=$289 << 0;
      var $291=$288 | $290;
      var $292=$dest2;
      var $293=(($292+4)|0);
      $dest2=$293;
      HEAP32[(($292)>>2)]=$291;
      var $294=$dudx;
      var $295=$curu3;
      var $296=(($295+$294)|0);
      $curu3=$296;
      var $297=$dvdx;
      var $298=$curv4;
      var $299=(($298+$297)|0);
      $curv4=$299;
      __label__ = 42; break;
    case 42: // $300
      var $301=$x;
      var $302=(($301+1)|0);
      $x=$302;
      __label__ = 40; break;
    case 43: // $303
      __label__ = 49; break;
    case 44: // $304
      var $305=$4;
      var $306=(($305+24)|0);
      var $307=HEAP32[(($306)>>2)];
      $x=$307;
      __label__ = 45; break;
    case 45: // $308
      var $309=$x;
      var $310=$endx;
      var $311=(($309)|0) < (($310)|0);
      if ($311) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $312
      var $313=$1;
      var $314=(($313+44)|0);
      var $315=$curu3;
      var $316=$curv4;
      var $317=__ZL24get_texel_yuy16_bilinearPK14render_texinfoii($314, $315, $316);
      var $318=__ZL10ycc_to_rgbj($317);
      $pix6=$318;
      var $319=$pix6;
      var $320=$319 >>> 16;
      var $321=$320 & 255;
      var $322=$sr;
      var $323=(($321*$322)|0);
      var $324=$323 >>> 8;
      $r7=$324;
      var $325=$pix6;
      var $326=$325 >>> 8;
      var $327=$326 & 255;
      var $328=$sg;
      var $329=(($327*$328)|0);
      var $330=$329 >>> 8;
      $g8=$330;
      var $331=$pix6;
      var $332=$331 >>> 0;
      var $333=$332 & 255;
      var $334=$sb;
      var $335=(($333*$334)|0);
      var $336=$335 >>> 8;
      $b9=$336;
      var $337=$r7;
      var $338=$337 << 16;
      var $339=$g8;
      var $340=$339 << 8;
      var $341=$338 | $340;
      var $342=$b9;
      var $343=$342 << 0;
      var $344=$341 | $343;
      var $345=$dest2;
      var $346=(($345+4)|0);
      $dest2=$346;
      HEAP32[(($345)>>2)]=$344;
      var $347=$dudx;
      var $348=$curu3;
      var $349=(($348+$347)|0);
      $curu3=$349;
      var $350=$dvdx;
      var $351=$curv4;
      var $352=(($351+$350)|0);
      $curv4=$352;
      __label__ = 47; break;
    case 47: // $353
      var $354=$x;
      var $355=(($354+1)|0);
      $x=$355;
      __label__ = 45; break;
    case 48: // $356
      __label__ = 49; break;
    case 49: // $357
      __label__ = 50; break;
    case 50: // $358
      var $359=$y;
      var $360=(($359+1)|0);
      $y=$360;
      __label__ = 37; break;
    case 51: // $361
      __label__ = 90; break;
    case 52: // $362
      var $363=$1;
      var $364=(($363+20)|0);
      var $365=(($364)|0);
      var $366=HEAPF32[(($365)>>2)];
      var $367=$366 < 0.00009999999747378752;
      if ($367) { __label__ = 89; break; } else { __label__ = 53; break; }
    case 53: // $368
      var $369=$1;
      var $370=(($369+20)|0);
      var $371=(($370+4)|0);
      var $372=HEAPF32[(($371)>>2)];
      var $373=$372*256;
      var $374=$1;
      var $375=(($374+20)|0);
      var $376=(($375)|0);
      var $377=HEAPF32[(($376)>>2)];
      var $378=$373*$377;
      var $379=($378 >= 0 ? Math.floor($378) : Math.ceil($378));
      $sr10=$379;
      var $380=$1;
      var $381=(($380+20)|0);
      var $382=(($381+8)|0);
      var $383=HEAPF32[(($382)>>2)];
      var $384=$383*256;
      var $385=$1;
      var $386=(($385+20)|0);
      var $387=(($386)|0);
      var $388=HEAPF32[(($387)>>2)];
      var $389=$384*$388;
      var $390=($389 >= 0 ? Math.floor($389) : Math.ceil($389));
      $sg11=$390;
      var $391=$1;
      var $392=(($391+20)|0);
      var $393=(($392+12)|0);
      var $394=HEAPF32[(($393)>>2)];
      var $395=$394*256;
      var $396=$1;
      var $397=(($396+20)|0);
      var $398=(($397)|0);
      var $399=HEAPF32[(($398)>>2)];
      var $400=$395*$399;
      var $401=($400 >= 0 ? Math.floor($400) : Math.ceil($400));
      $sb12=$401;
      var $402=$1;
      var $403=(($402+20)|0);
      var $404=(($403)|0);
      var $405=HEAPF32[(($404)>>2)];
      var $406=1-$405;
      var $407=$406*256;
      var $408=($407 >= 0 ? Math.floor($407) : Math.ceil($407));
      $invsa=$408;
      var $409=$sr10;
      var $410=(($409)>>>0) > 256;
      if ($410) { __label__ = 54; break; } else { __label__ = 58; break; }
    case 54: // $411
      var $412=$sr10;
      var $413=(($412)|0) < 0;
      if ($413) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $414
      $sr10=0;
      __label__ = 57; break;
    case 56: // $415
      $sr10=256;
      __label__ = 57; break;
    case 57: // $416
      __label__ = 58; break;
    case 58: // $417
      var $418=$sg11;
      var $419=(($418)>>>0) > 256;
      if ($419) { __label__ = 59; break; } else { __label__ = 63; break; }
    case 59: // $420
      var $421=$sg11;
      var $422=(($421)|0) < 0;
      if ($422) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $423
      $sg11=0;
      __label__ = 62; break;
    case 61: // $424
      $sg11=256;
      __label__ = 62; break;
    case 62: // $425
      __label__ = 63; break;
    case 63: // $426
      var $427=$sb12;
      var $428=(($427)>>>0) > 256;
      if ($428) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $429
      var $430=$sb12;
      var $431=(($430)|0) < 0;
      if ($431) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $432
      $sb12=0;
      __label__ = 67; break;
    case 66: // $433
      $sb12=256;
      __label__ = 67; break;
    case 67: // $434
      __label__ = 68; break;
    case 68: // $435
      var $436=$invsa;
      var $437=(($436)>>>0) > 256;
      if ($437) { __label__ = 69; break; } else { __label__ = 73; break; }
    case 69: // $438
      var $439=$invsa;
      var $440=(($439)|0) < 0;
      if ($440) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $441
      $invsa=0;
      __label__ = 72; break;
    case 71: // $442
      $invsa=256;
      __label__ = 72; break;
    case 72: // $443
      __label__ = 73; break;
    case 73: // $444
      var $445=$4;
      var $446=(($445+28)|0);
      var $447=HEAP32[(($446)>>2)];
      $y=$447;
      __label__ = 74; break;
    case 74: // $448
      var $449=$y;
      var $450=$4;
      var $451=(($450+36)|0);
      var $452=HEAP32[(($451)>>2)];
      var $453=(($449)|0) < (($452)|0);
      if ($453) { __label__ = 75; break; } else { __label__ = 88; break; }
    case 75: // $454
      var $455=$2;
      var $456=$455;
      var $457=$y;
      var $458=$3;
      var $459=(($457*$458)|0);
      var $460=(($456+($459<<2))|0);
      var $461=$4;
      var $462=(($461+24)|0);
      var $463=HEAP32[(($462)>>2)];
      var $464=(($460+($463<<2))|0);
      $dest13=$464;
      var $465=$4;
      var $466=(($465+16)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=$y;
      var $469=$4;
      var $470=(($469+28)|0);
      var $471=HEAP32[(($470)>>2)];
      var $472=(($468-$471)|0);
      var $473=$4;
      var $474=(($473+8)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=(($472*$475)|0);
      var $477=(($467+$476)|0);
      $curu14=$477;
      var $478=$4;
      var $479=(($478+20)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=$y;
      var $482=$4;
      var $483=(($482+28)|0);
      var $484=HEAP32[(($483)>>2)];
      var $485=(($481-$484)|0);
      var $486=$4;
      var $487=(($486+12)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=(($485*$488)|0);
      var $490=(($480+$489)|0);
      $curv15=$490;
      var $491=$palbase;
      var $492=(($491)|0)==0;
      if ($492) { __label__ = 76; break; } else { __label__ = 81; break; }
    case 76: // $493
      var $494=$4;
      var $495=(($494+24)|0);
      var $496=HEAP32[(($495)>>2)];
      $x=$496;
      __label__ = 77; break;
    case 77: // $497
      var $498=$x;
      var $499=$endx;
      var $500=(($498)|0) < (($499)|0);
      if ($500) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $501
      var $502=$1;
      var $503=(($502+44)|0);
      var $504=$curu14;
      var $505=$curv15;
      var $506=__ZL24get_texel_yuy16_bilinearPK14render_texinfoii($503, $504, $505);
      var $507=__ZL10ycc_to_rgbj($506);
      $pix16=$507;
      var $508=$dest13;
      var $509=HEAP32[(($508)>>2)];
      $dpix=$509;
      var $510=$pix16;
      var $511=$510 >>> 16;
      var $512=$511 & 255;
      var $513=$sr10;
      var $514=(($512*$513)|0);
      var $515=$dpix;
      var $516=$515 >>> 16;
      var $517=$516 & 255;
      var $518=$invsa;
      var $519=(($517*$518)|0);
      var $520=(($514+$519)|0);
      var $521=$520 >>> 8;
      $r17=$521;
      var $522=$pix16;
      var $523=$522 >>> 8;
      var $524=$523 & 255;
      var $525=$sg11;
      var $526=(($524*$525)|0);
      var $527=$dpix;
      var $528=$527 >>> 8;
      var $529=$528 & 255;
      var $530=$invsa;
      var $531=(($529*$530)|0);
      var $532=(($526+$531)|0);
      var $533=$532 >>> 8;
      $g18=$533;
      var $534=$pix16;
      var $535=$534 >>> 0;
      var $536=$535 & 255;
      var $537=$sb12;
      var $538=(($536*$537)|0);
      var $539=$dpix;
      var $540=$539 >>> 0;
      var $541=$540 & 255;
      var $542=$invsa;
      var $543=(($541*$542)|0);
      var $544=(($538+$543)|0);
      var $545=$544 >>> 8;
      $b19=$545;
      var $546=$r17;
      var $547=$546 << 16;
      var $548=$g18;
      var $549=$548 << 8;
      var $550=$547 | $549;
      var $551=$b19;
      var $552=$551 << 0;
      var $553=$550 | $552;
      var $554=$dest13;
      var $555=(($554+4)|0);
      $dest13=$555;
      HEAP32[(($554)>>2)]=$553;
      var $556=$dudx;
      var $557=$curu14;
      var $558=(($557+$556)|0);
      $curu14=$558;
      var $559=$dvdx;
      var $560=$curv15;
      var $561=(($560+$559)|0);
      $curv15=$561;
      __label__ = 79; break;
    case 79: // $562
      var $563=$x;
      var $564=(($563+1)|0);
      $x=$564;
      __label__ = 77; break;
    case 80: // $565
      __label__ = 86; break;
    case 81: // $566
      var $567=$4;
      var $568=(($567+24)|0);
      var $569=HEAP32[(($568)>>2)];
      $x=$569;
      __label__ = 82; break;
    case 82: // $570
      var $571=$x;
      var $572=$endx;
      var $573=(($571)|0) < (($572)|0);
      if ($573) { __label__ = 83; break; } else { __label__ = 85; break; }
    case 83: // $574
      var $575=$1;
      var $576=(($575+44)|0);
      var $577=$curu14;
      var $578=$curv15;
      var $579=__ZL24get_texel_yuy16_bilinearPK14render_texinfoii($576, $577, $578);
      var $580=__ZL10ycc_to_rgbj($579);
      $pix20=$580;
      var $581=$dest13;
      var $582=HEAP32[(($581)>>2)];
      $dpix21=$582;
      var $583=$pix20;
      var $584=$583 >>> 16;
      var $585=$584 & 255;
      var $586=$sr10;
      var $587=(($585*$586)|0);
      var $588=$dpix21;
      var $589=$588 >>> 16;
      var $590=$589 & 255;
      var $591=$invsa;
      var $592=(($590*$591)|0);
      var $593=(($587+$592)|0);
      var $594=$593 >>> 8;
      $r22=$594;
      var $595=$pix20;
      var $596=$595 >>> 8;
      var $597=$596 & 255;
      var $598=$sg11;
      var $599=(($597*$598)|0);
      var $600=$dpix21;
      var $601=$600 >>> 8;
      var $602=$601 & 255;
      var $603=$invsa;
      var $604=(($602*$603)|0);
      var $605=(($599+$604)|0);
      var $606=$605 >>> 8;
      $g23=$606;
      var $607=$pix20;
      var $608=$607 >>> 0;
      var $609=$608 & 255;
      var $610=$sb12;
      var $611=(($609*$610)|0);
      var $612=$dpix21;
      var $613=$612 >>> 0;
      var $614=$613 & 255;
      var $615=$invsa;
      var $616=(($614*$615)|0);
      var $617=(($611+$616)|0);
      var $618=$617 >>> 8;
      $b24=$618;
      var $619=$r22;
      var $620=$619 << 16;
      var $621=$g23;
      var $622=$621 << 8;
      var $623=$620 | $622;
      var $624=$b24;
      var $625=$624 << 0;
      var $626=$623 | $625;
      var $627=$dest13;
      var $628=(($627+4)|0);
      $dest13=$628;
      HEAP32[(($627)>>2)]=$626;
      var $629=$dudx;
      var $630=$curu14;
      var $631=(($630+$629)|0);
      $curu14=$631;
      var $632=$dvdx;
      var $633=$curv15;
      var $634=(($633+$632)|0);
      $curv15=$634;
      __label__ = 84; break;
    case 84: // $635
      var $636=$x;
      var $637=(($636+1)|0);
      $x=$637;
      __label__ = 82; break;
    case 85: // $638
      __label__ = 86; break;
    case 86: // $639
      __label__ = 87; break;
    case 87: // $640
      var $641=$y;
      var $642=(($641+1)|0);
      $y=$642;
      __label__ = 74; break;
    case 88: // $643
      __label__ = 89; break;
    case 89: // $644
      __label__ = 90; break;
    case 90: // $645
      __label__ = 91; break;
    case 91: // $646
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27rgb888_draw_quad_yuy16_nonePK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL22rgb888_draw_quad_rgb15PK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $pix1;
      var $r;
      var $g;
      var $b;
      var $sr;
      var $sg;
      var $sb;
      var $dest2;
      var $curu3;
      var $curv4;
      var $pix5;
      var $r6;
      var $g7;
      var $b8;
      var $pix9;
      var $r10;
      var $g11;
      var $b12;
      var $sr13;
      var $sg14;
      var $sb15;
      var $invsa;
      var $dest16;
      var $curu17;
      var $curv18;
      var $pix19;
      var $dpix;
      var $r20;
      var $g21;
      var $b22;
      var $pix23;
      var $dpix24;
      var $r25;
      var $g26;
      var $b27;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL24get_texel_rgb15_bilinearPK14render_texinfoii($100, $101, $102);
      $pix=$103;
      var $104=$pix;
      var $105=$104 >>> 7;
      var $106=$105 & 248;
      var $107=$106 << 16;
      var $108=$pix;
      var $109=$108 >>> 2;
      var $110=$109 & 248;
      var $111=$110 << 8;
      var $112=$107 | $111;
      var $113=$pix;
      var $114=$113 << 3;
      var $115=$114 & 248;
      var $116=$115 << 0;
      var $117=$112 | $116;
      var $118=$dest;
      var $119=(($118+4)|0);
      $dest=$119;
      HEAP32[(($118)>>2)]=$117;
      var $120=$dudx;
      var $121=$curu;
      var $122=(($121+$120)|0);
      $curu=$122;
      var $123=$dvdx;
      var $124=$curv;
      var $125=(($124+$123)|0);
      $curv=$125;
      __label__ = 10; break;
    case 10: // $126
      var $127=$x;
      var $128=(($127+1)|0);
      $x=$128;
      __label__ = 8; break;
    case 11: // $129
      __label__ = 17; break;
    case 12: // $130
      var $131=$4;
      var $132=(($131+24)|0);
      var $133=HEAP32[(($132)>>2)];
      $x=$133;
      __label__ = 13; break;
    case 13: // $134
      var $135=$x;
      var $136=$endx;
      var $137=(($135)|0) < (($136)|0);
      if ($137) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $138
      var $139=$1;
      var $140=(($139+44)|0);
      var $141=$curu;
      var $142=$curv;
      var $143=__ZL24get_texel_rgb15_bilinearPK14render_texinfoii($140, $141, $142);
      $pix1=$143;
      var $144=$pix1;
      var $145=$144 >>> 10;
      var $146=$145 & 31;
      var $147=$palbase;
      var $148=(($147+($146<<2))|0);
      var $149=HEAPU32[(($148)>>2)];
      var $150=$149 >>> 0;
      $r=$150;
      var $151=$pix1;
      var $152=$151 >>> 5;
      var $153=$152 & 31;
      var $154=$palbase;
      var $155=(($154+($153<<2))|0);
      var $156=HEAPU32[(($155)>>2)];
      var $157=$156 >>> 0;
      $g=$157;
      var $158=$pix1;
      var $159=$158 >>> 0;
      var $160=$159 & 31;
      var $161=$palbase;
      var $162=(($161+($160<<2))|0);
      var $163=HEAPU32[(($162)>>2)];
      var $164=$163 >>> 0;
      $b=$164;
      var $165=$r;
      var $166=$165 << 16;
      var $167=$g;
      var $168=$167 << 8;
      var $169=$166 | $168;
      var $170=$b;
      var $171=$170 << 0;
      var $172=$169 | $171;
      var $173=$dest;
      var $174=(($173+4)|0);
      $dest=$174;
      HEAP32[(($173)>>2)]=$172;
      var $175=$dudx;
      var $176=$curu;
      var $177=(($176+$175)|0);
      $curu=$177;
      var $178=$dvdx;
      var $179=$curv;
      var $180=(($179+$178)|0);
      $curv=$180;
      __label__ = 15; break;
    case 15: // $181
      var $182=$x;
      var $183=(($182+1)|0);
      $x=$183;
      __label__ = 13; break;
    case 16: // $184
      __label__ = 17; break;
    case 17: // $185
      __label__ = 18; break;
    case 18: // $186
      var $187=$y;
      var $188=(($187+1)|0);
      $y=$188;
      __label__ = 5; break;
    case 19: // $189
      __label__ = 91; break;
    case 20: // $190
      var $191=$1;
      var $192=(($191+20)|0);
      var $193=(($192)|0);
      var $194=HEAPF32[(($193)>>2)];
      var $195=$194 >= 1;
      if ($195) { __label__ = 21; break; } else { __label__ = 52; break; }
    case 21: // $196
      var $197=$1;
      var $198=(($197+20)|0);
      var $199=(($198+4)|0);
      var $200=HEAPF32[(($199)>>2)];
      var $201=$200*256;
      var $202=($201 >= 0 ? Math.floor($201) : Math.ceil($201));
      $sr=$202;
      var $203=$1;
      var $204=(($203+20)|0);
      var $205=(($204+8)|0);
      var $206=HEAPF32[(($205)>>2)];
      var $207=$206*256;
      var $208=($207 >= 0 ? Math.floor($207) : Math.ceil($207));
      $sg=$208;
      var $209=$1;
      var $210=(($209+20)|0);
      var $211=(($210+12)|0);
      var $212=HEAPF32[(($211)>>2)];
      var $213=$212*256;
      var $214=($213 >= 0 ? Math.floor($213) : Math.ceil($213));
      $sb=$214;
      var $215=$sr;
      var $216=(($215)>>>0) > 256;
      if ($216) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $217
      var $218=$sr;
      var $219=(($218)|0) < 0;
      if ($219) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $220
      $sr=0;
      __label__ = 25; break;
    case 24: // $221
      $sr=256;
      __label__ = 25; break;
    case 25: // $222
      __label__ = 26; break;
    case 26: // $223
      var $224=$sg;
      var $225=(($224)>>>0) > 256;
      if ($225) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $226
      var $227=$sg;
      var $228=(($227)|0) < 0;
      if ($228) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $229
      $sg=0;
      __label__ = 30; break;
    case 29: // $230
      $sg=256;
      __label__ = 30; break;
    case 30: // $231
      __label__ = 31; break;
    case 31: // $232
      var $233=$sb;
      var $234=(($233)>>>0) > 256;
      if ($234) { __label__ = 32; break; } else { __label__ = 36; break; }
    case 32: // $235
      var $236=$sb;
      var $237=(($236)|0) < 0;
      if ($237) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $238
      $sb=0;
      __label__ = 35; break;
    case 34: // $239
      $sb=256;
      __label__ = 35; break;
    case 35: // $240
      __label__ = 36; break;
    case 36: // $241
      var $242=$4;
      var $243=(($242+28)|0);
      var $244=HEAP32[(($243)>>2)];
      $y=$244;
      __label__ = 37; break;
    case 37: // $245
      var $246=$y;
      var $247=$4;
      var $248=(($247+36)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(($246)|0) < (($249)|0);
      if ($250) { __label__ = 38; break; } else { __label__ = 51; break; }
    case 38: // $251
      var $252=$2;
      var $253=$252;
      var $254=$y;
      var $255=$3;
      var $256=(($254*$255)|0);
      var $257=(($253+($256<<2))|0);
      var $258=$4;
      var $259=(($258+24)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=(($257+($260<<2))|0);
      $dest2=$261;
      var $262=$4;
      var $263=(($262+16)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$y;
      var $266=$4;
      var $267=(($266+28)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(($265-$268)|0);
      var $270=$4;
      var $271=(($270+8)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($269*$272)|0);
      var $274=(($264+$273)|0);
      $curu3=$274;
      var $275=$4;
      var $276=(($275+20)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$y;
      var $279=$4;
      var $280=(($279+28)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($278-$281)|0);
      var $283=$4;
      var $284=(($283+12)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($282*$285)|0);
      var $287=(($277+$286)|0);
      $curv4=$287;
      var $288=$palbase;
      var $289=(($288)|0)==0;
      if ($289) { __label__ = 39; break; } else { __label__ = 44; break; }
    case 39: // $290
      var $291=$4;
      var $292=(($291+24)|0);
      var $293=HEAP32[(($292)>>2)];
      $x=$293;
      __label__ = 40; break;
    case 40: // $294
      var $295=$x;
      var $296=$endx;
      var $297=(($295)|0) < (($296)|0);
      if ($297) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $298
      var $299=$1;
      var $300=(($299+44)|0);
      var $301=$curu3;
      var $302=$curv4;
      var $303=__ZL24get_texel_rgb15_bilinearPK14render_texinfoii($300, $301, $302);
      $pix5=$303;
      var $304=$pix5;
      var $305=$304 >>> 7;
      var $306=$305 & 248;
      var $307=$sr;
      var $308=(($306*$307)|0);
      var $309=$308 >>> 8;
      $r6=$309;
      var $310=$pix5;
      var $311=$310 >>> 2;
      var $312=$311 & 248;
      var $313=$sg;
      var $314=(($312*$313)|0);
      var $315=$314 >>> 8;
      $g7=$315;
      var $316=$pix5;
      var $317=$316 << 3;
      var $318=$317 & 248;
      var $319=$sb;
      var $320=(($318*$319)|0);
      var $321=$320 >>> 8;
      $b8=$321;
      var $322=$r6;
      var $323=$322 << 16;
      var $324=$g7;
      var $325=$324 << 8;
      var $326=$323 | $325;
      var $327=$b8;
      var $328=$327 << 0;
      var $329=$326 | $328;
      var $330=$dest2;
      var $331=(($330+4)|0);
      $dest2=$331;
      HEAP32[(($330)>>2)]=$329;
      var $332=$dudx;
      var $333=$curu3;
      var $334=(($333+$332)|0);
      $curu3=$334;
      var $335=$dvdx;
      var $336=$curv4;
      var $337=(($336+$335)|0);
      $curv4=$337;
      __label__ = 42; break;
    case 42: // $338
      var $339=$x;
      var $340=(($339+1)|0);
      $x=$340;
      __label__ = 40; break;
    case 43: // $341
      __label__ = 49; break;
    case 44: // $342
      var $343=$4;
      var $344=(($343+24)|0);
      var $345=HEAP32[(($344)>>2)];
      $x=$345;
      __label__ = 45; break;
    case 45: // $346
      var $347=$x;
      var $348=$endx;
      var $349=(($347)|0) < (($348)|0);
      if ($349) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $350
      var $351=$1;
      var $352=(($351+44)|0);
      var $353=$curu3;
      var $354=$curv4;
      var $355=__ZL24get_texel_rgb15_bilinearPK14render_texinfoii($352, $353, $354);
      $pix9=$355;
      var $356=$pix9;
      var $357=$356 >>> 10;
      var $358=$357 & 31;
      var $359=$palbase;
      var $360=(($359+($358<<2))|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=$sr;
      var $363=(($361*$362)|0);
      var $364=$363 >>> 8;
      $r10=$364;
      var $365=$pix9;
      var $366=$365 >>> 5;
      var $367=$366 & 31;
      var $368=$palbase;
      var $369=(($368+($367<<2))|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=$sg;
      var $372=(($370*$371)|0);
      var $373=$372 >>> 8;
      $g11=$373;
      var $374=$pix9;
      var $375=$374 >>> 0;
      var $376=$375 & 31;
      var $377=$palbase;
      var $378=(($377+($376<<2))|0);
      var $379=HEAP32[(($378)>>2)];
      var $380=$sb;
      var $381=(($379*$380)|0);
      var $382=$381 >>> 8;
      $b12=$382;
      var $383=$r10;
      var $384=$383 << 16;
      var $385=$g11;
      var $386=$385 << 8;
      var $387=$384 | $386;
      var $388=$b12;
      var $389=$388 << 0;
      var $390=$387 | $389;
      var $391=$dest2;
      var $392=(($391+4)|0);
      $dest2=$392;
      HEAP32[(($391)>>2)]=$390;
      var $393=$dudx;
      var $394=$curu3;
      var $395=(($394+$393)|0);
      $curu3=$395;
      var $396=$dvdx;
      var $397=$curv4;
      var $398=(($397+$396)|0);
      $curv4=$398;
      __label__ = 47; break;
    case 47: // $399
      var $400=$x;
      var $401=(($400+1)|0);
      $x=$401;
      __label__ = 45; break;
    case 48: // $402
      __label__ = 49; break;
    case 49: // $403
      __label__ = 50; break;
    case 50: // $404
      var $405=$y;
      var $406=(($405+1)|0);
      $y=$406;
      __label__ = 37; break;
    case 51: // $407
      __label__ = 90; break;
    case 52: // $408
      var $409=$1;
      var $410=(($409+20)|0);
      var $411=(($410)|0);
      var $412=HEAPF32[(($411)>>2)];
      var $413=$412 < 0.00009999999747378752;
      if ($413) { __label__ = 89; break; } else { __label__ = 53; break; }
    case 53: // $414
      var $415=$1;
      var $416=(($415+20)|0);
      var $417=(($416+4)|0);
      var $418=HEAPF32[(($417)>>2)];
      var $419=$418*256;
      var $420=$1;
      var $421=(($420+20)|0);
      var $422=(($421)|0);
      var $423=HEAPF32[(($422)>>2)];
      var $424=$419*$423;
      var $425=($424 >= 0 ? Math.floor($424) : Math.ceil($424));
      $sr13=$425;
      var $426=$1;
      var $427=(($426+20)|0);
      var $428=(($427+8)|0);
      var $429=HEAPF32[(($428)>>2)];
      var $430=$429*256;
      var $431=$1;
      var $432=(($431+20)|0);
      var $433=(($432)|0);
      var $434=HEAPF32[(($433)>>2)];
      var $435=$430*$434;
      var $436=($435 >= 0 ? Math.floor($435) : Math.ceil($435));
      $sg14=$436;
      var $437=$1;
      var $438=(($437+20)|0);
      var $439=(($438+12)|0);
      var $440=HEAPF32[(($439)>>2)];
      var $441=$440*256;
      var $442=$1;
      var $443=(($442+20)|0);
      var $444=(($443)|0);
      var $445=HEAPF32[(($444)>>2)];
      var $446=$441*$445;
      var $447=($446 >= 0 ? Math.floor($446) : Math.ceil($446));
      $sb15=$447;
      var $448=$1;
      var $449=(($448+20)|0);
      var $450=(($449)|0);
      var $451=HEAPF32[(($450)>>2)];
      var $452=1-$451;
      var $453=$452*256;
      var $454=($453 >= 0 ? Math.floor($453) : Math.ceil($453));
      $invsa=$454;
      var $455=$sr13;
      var $456=(($455)>>>0) > 256;
      if ($456) { __label__ = 54; break; } else { __label__ = 58; break; }
    case 54: // $457
      var $458=$sr13;
      var $459=(($458)|0) < 0;
      if ($459) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $460
      $sr13=0;
      __label__ = 57; break;
    case 56: // $461
      $sr13=256;
      __label__ = 57; break;
    case 57: // $462
      __label__ = 58; break;
    case 58: // $463
      var $464=$sg14;
      var $465=(($464)>>>0) > 256;
      if ($465) { __label__ = 59; break; } else { __label__ = 63; break; }
    case 59: // $466
      var $467=$sg14;
      var $468=(($467)|0) < 0;
      if ($468) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $469
      $sg14=0;
      __label__ = 62; break;
    case 61: // $470
      $sg14=256;
      __label__ = 62; break;
    case 62: // $471
      __label__ = 63; break;
    case 63: // $472
      var $473=$sb15;
      var $474=(($473)>>>0) > 256;
      if ($474) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $475
      var $476=$sb15;
      var $477=(($476)|0) < 0;
      if ($477) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $478
      $sb15=0;
      __label__ = 67; break;
    case 66: // $479
      $sb15=256;
      __label__ = 67; break;
    case 67: // $480
      __label__ = 68; break;
    case 68: // $481
      var $482=$invsa;
      var $483=(($482)>>>0) > 256;
      if ($483) { __label__ = 69; break; } else { __label__ = 73; break; }
    case 69: // $484
      var $485=$invsa;
      var $486=(($485)|0) < 0;
      if ($486) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $487
      $invsa=0;
      __label__ = 72; break;
    case 71: // $488
      $invsa=256;
      __label__ = 72; break;
    case 72: // $489
      __label__ = 73; break;
    case 73: // $490
      var $491=$4;
      var $492=(($491+28)|0);
      var $493=HEAP32[(($492)>>2)];
      $y=$493;
      __label__ = 74; break;
    case 74: // $494
      var $495=$y;
      var $496=$4;
      var $497=(($496+36)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=(($495)|0) < (($498)|0);
      if ($499) { __label__ = 75; break; } else { __label__ = 88; break; }
    case 75: // $500
      var $501=$2;
      var $502=$501;
      var $503=$y;
      var $504=$3;
      var $505=(($503*$504)|0);
      var $506=(($502+($505<<2))|0);
      var $507=$4;
      var $508=(($507+24)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=(($506+($509<<2))|0);
      $dest16=$510;
      var $511=$4;
      var $512=(($511+16)|0);
      var $513=HEAP32[(($512)>>2)];
      var $514=$y;
      var $515=$4;
      var $516=(($515+28)|0);
      var $517=HEAP32[(($516)>>2)];
      var $518=(($514-$517)|0);
      var $519=$4;
      var $520=(($519+8)|0);
      var $521=HEAP32[(($520)>>2)];
      var $522=(($518*$521)|0);
      var $523=(($513+$522)|0);
      $curu17=$523;
      var $524=$4;
      var $525=(($524+20)|0);
      var $526=HEAP32[(($525)>>2)];
      var $527=$y;
      var $528=$4;
      var $529=(($528+28)|0);
      var $530=HEAP32[(($529)>>2)];
      var $531=(($527-$530)|0);
      var $532=$4;
      var $533=(($532+12)|0);
      var $534=HEAP32[(($533)>>2)];
      var $535=(($531*$534)|0);
      var $536=(($526+$535)|0);
      $curv18=$536;
      var $537=$palbase;
      var $538=(($537)|0)==0;
      if ($538) { __label__ = 76; break; } else { __label__ = 81; break; }
    case 76: // $539
      var $540=$4;
      var $541=(($540+24)|0);
      var $542=HEAP32[(($541)>>2)];
      $x=$542;
      __label__ = 77; break;
    case 77: // $543
      var $544=$x;
      var $545=$endx;
      var $546=(($544)|0) < (($545)|0);
      if ($546) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $547
      var $548=$1;
      var $549=(($548+44)|0);
      var $550=$curu17;
      var $551=$curv18;
      var $552=__ZL24get_texel_rgb15_bilinearPK14render_texinfoii($549, $550, $551);
      $pix19=$552;
      var $553=$dest16;
      var $554=HEAP32[(($553)>>2)];
      $dpix=$554;
      var $555=$pix19;
      var $556=$555 >>> 7;
      var $557=$556 & 248;
      var $558=$sr13;
      var $559=(($557*$558)|0);
      var $560=$dpix;
      var $561=$560 >>> 16;
      var $562=$561 & 255;
      var $563=$invsa;
      var $564=(($562*$563)|0);
      var $565=(($559+$564)|0);
      var $566=$565 >>> 8;
      $r20=$566;
      var $567=$pix19;
      var $568=$567 >>> 2;
      var $569=$568 & 248;
      var $570=$sg14;
      var $571=(($569*$570)|0);
      var $572=$dpix;
      var $573=$572 >>> 8;
      var $574=$573 & 255;
      var $575=$invsa;
      var $576=(($574*$575)|0);
      var $577=(($571+$576)|0);
      var $578=$577 >>> 8;
      $g21=$578;
      var $579=$pix19;
      var $580=$579 << 3;
      var $581=$580 & 248;
      var $582=$sb15;
      var $583=(($581*$582)|0);
      var $584=$dpix;
      var $585=$584 >>> 0;
      var $586=$585 & 255;
      var $587=$invsa;
      var $588=(($586*$587)|0);
      var $589=(($583+$588)|0);
      var $590=$589 >>> 8;
      $b22=$590;
      var $591=$r20;
      var $592=$591 << 16;
      var $593=$g21;
      var $594=$593 << 8;
      var $595=$592 | $594;
      var $596=$b22;
      var $597=$596 << 0;
      var $598=$595 | $597;
      var $599=$dest16;
      var $600=(($599+4)|0);
      $dest16=$600;
      HEAP32[(($599)>>2)]=$598;
      var $601=$dudx;
      var $602=$curu17;
      var $603=(($602+$601)|0);
      $curu17=$603;
      var $604=$dvdx;
      var $605=$curv18;
      var $606=(($605+$604)|0);
      $curv18=$606;
      __label__ = 79; break;
    case 79: // $607
      var $608=$x;
      var $609=(($608+1)|0);
      $x=$609;
      __label__ = 77; break;
    case 80: // $610
      __label__ = 86; break;
    case 81: // $611
      var $612=$4;
      var $613=(($612+24)|0);
      var $614=HEAP32[(($613)>>2)];
      $x=$614;
      __label__ = 82; break;
    case 82: // $615
      var $616=$x;
      var $617=$endx;
      var $618=(($616)|0) < (($617)|0);
      if ($618) { __label__ = 83; break; } else { __label__ = 85; break; }
    case 83: // $619
      var $620=$1;
      var $621=(($620+44)|0);
      var $622=$curu17;
      var $623=$curv18;
      var $624=__ZL24get_texel_rgb15_bilinearPK14render_texinfoii($621, $622, $623);
      $pix23=$624;
      var $625=$dest16;
      var $626=HEAP32[(($625)>>2)];
      $dpix24=$626;
      var $627=$pix23;
      var $628=$627 >>> 10;
      var $629=$628 & 31;
      var $630=$palbase;
      var $631=(($630+($629<<2))|0);
      var $632=HEAPU32[(($631)>>2)];
      var $633=$632 >>> 0;
      var $634=$sr13;
      var $635=(($633*$634)|0);
      var $636=$dpix24;
      var $637=$636 >>> 16;
      var $638=$637 & 255;
      var $639=$invsa;
      var $640=(($638*$639)|0);
      var $641=(($635+$640)|0);
      var $642=$641 >>> 8;
      $r25=$642;
      var $643=$pix23;
      var $644=$643 >>> 5;
      var $645=$644 & 31;
      var $646=$palbase;
      var $647=(($646+($645<<2))|0);
      var $648=HEAPU32[(($647)>>2)];
      var $649=$648 >>> 0;
      var $650=$sg14;
      var $651=(($649*$650)|0);
      var $652=$dpix24;
      var $653=$652 >>> 8;
      var $654=$653 & 255;
      var $655=$invsa;
      var $656=(($654*$655)|0);
      var $657=(($651+$656)|0);
      var $658=$657 >>> 8;
      $g26=$658;
      var $659=$pix23;
      var $660=$659 >>> 0;
      var $661=$660 & 31;
      var $662=$palbase;
      var $663=(($662+($661<<2))|0);
      var $664=HEAPU32[(($663)>>2)];
      var $665=$664 >>> 0;
      var $666=$sb15;
      var $667=(($665*$666)|0);
      var $668=$dpix24;
      var $669=$668 >>> 0;
      var $670=$669 & 255;
      var $671=$invsa;
      var $672=(($670*$671)|0);
      var $673=(($667+$672)|0);
      var $674=$673 >>> 8;
      $b27=$674;
      var $675=$r25;
      var $676=$675 << 16;
      var $677=$g26;
      var $678=$677 << 8;
      var $679=$676 | $678;
      var $680=$b27;
      var $681=$680 << 0;
      var $682=$679 | $681;
      var $683=$dest16;
      var $684=(($683+4)|0);
      $dest16=$684;
      HEAP32[(($683)>>2)]=$682;
      var $685=$dudx;
      var $686=$curu17;
      var $687=(($686+$685)|0);
      $curu17=$687;
      var $688=$dvdx;
      var $689=$curv18;
      var $690=(($689+$688)|0);
      $curv18=$690;
      __label__ = 84; break;
    case 84: // $691
      var $692=$x;
      var $693=(($692+1)|0);
      $x=$693;
      __label__ = 82; break;
    case 85: // $694
      __label__ = 86; break;
    case 86: // $695
      __label__ = 87; break;
    case 87: // $696
      var $697=$y;
      var $698=(($697+1)|0);
      $y=$698;
      __label__ = 74; break;
    case 88: // $699
      __label__ = 89; break;
    case 89: // $700
      __label__ = 90; break;
    case 90: // $701
      __label__ = 91; break;
    case 91: // $702
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22rgb888_draw_quad_rgb15PK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL22rgb888_draw_quad_rgb32PK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $pix1;
      var $r;
      var $g;
      var $b;
      var $sr;
      var $sg;
      var $sb;
      var $dest2;
      var $curu3;
      var $curv4;
      var $pix5;
      var $r6;
      var $g7;
      var $b8;
      var $pix9;
      var $r10;
      var $g11;
      var $b12;
      var $sr13;
      var $sg14;
      var $sb15;
      var $invsa;
      var $dest16;
      var $curu17;
      var $curv18;
      var $pix19;
      var $dpix;
      var $r20;
      var $g21;
      var $b22;
      var $pix23;
      var $dpix24;
      var $r25;
      var $g26;
      var $b27;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL24get_texel_rgb32_bilinearPK14render_texinfoii($100, $101, $102);
      $pix=$103;
      var $104=$pix;
      var $105=$dest;
      var $106=(($105+4)|0);
      $dest=$106;
      HEAP32[(($105)>>2)]=$104;
      var $107=$dudx;
      var $108=$curu;
      var $109=(($108+$107)|0);
      $curu=$109;
      var $110=$dvdx;
      var $111=$curv;
      var $112=(($111+$110)|0);
      $curv=$112;
      __label__ = 10; break;
    case 10: // $113
      var $114=$x;
      var $115=(($114+1)|0);
      $x=$115;
      __label__ = 8; break;
    case 11: // $116
      __label__ = 17; break;
    case 12: // $117
      var $118=$4;
      var $119=(($118+24)|0);
      var $120=HEAP32[(($119)>>2)];
      $x=$120;
      __label__ = 13; break;
    case 13: // $121
      var $122=$x;
      var $123=$endx;
      var $124=(($122)|0) < (($123)|0);
      if ($124) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $125
      var $126=$1;
      var $127=(($126+44)|0);
      var $128=$curu;
      var $129=$curv;
      var $130=__ZL24get_texel_rgb32_bilinearPK14render_texinfoii($127, $128, $129);
      $pix1=$130;
      var $131=$pix1;
      var $132=$131 >>> 16;
      var $133=$132 & 255;
      var $134=$palbase;
      var $135=(($134+($133<<2))|0);
      var $136=HEAPU32[(($135)>>2)];
      var $137=$136 >>> 0;
      $r=$137;
      var $138=$pix1;
      var $139=$138 >>> 8;
      var $140=$139 & 255;
      var $141=$palbase;
      var $142=(($141+($140<<2))|0);
      var $143=HEAPU32[(($142)>>2)];
      var $144=$143 >>> 0;
      $g=$144;
      var $145=$pix1;
      var $146=$145 >>> 0;
      var $147=$146 & 255;
      var $148=$palbase;
      var $149=(($148+($147<<2))|0);
      var $150=HEAPU32[(($149)>>2)];
      var $151=$150 >>> 0;
      $b=$151;
      var $152=$r;
      var $153=$152 << 16;
      var $154=$g;
      var $155=$154 << 8;
      var $156=$153 | $155;
      var $157=$b;
      var $158=$157 << 0;
      var $159=$156 | $158;
      var $160=$dest;
      var $161=(($160+4)|0);
      $dest=$161;
      HEAP32[(($160)>>2)]=$159;
      var $162=$dudx;
      var $163=$curu;
      var $164=(($163+$162)|0);
      $curu=$164;
      var $165=$dvdx;
      var $166=$curv;
      var $167=(($166+$165)|0);
      $curv=$167;
      __label__ = 15; break;
    case 15: // $168
      var $169=$x;
      var $170=(($169+1)|0);
      $x=$170;
      __label__ = 13; break;
    case 16: // $171
      __label__ = 17; break;
    case 17: // $172
      __label__ = 18; break;
    case 18: // $173
      var $174=$y;
      var $175=(($174+1)|0);
      $y=$175;
      __label__ = 5; break;
    case 19: // $176
      __label__ = 91; break;
    case 20: // $177
      var $178=$1;
      var $179=(($178+20)|0);
      var $180=(($179)|0);
      var $181=HEAPF32[(($180)>>2)];
      var $182=$181 >= 1;
      if ($182) { __label__ = 21; break; } else { __label__ = 52; break; }
    case 21: // $183
      var $184=$1;
      var $185=(($184+20)|0);
      var $186=(($185+4)|0);
      var $187=HEAPF32[(($186)>>2)];
      var $188=$187*256;
      var $189=($188 >= 0 ? Math.floor($188) : Math.ceil($188));
      $sr=$189;
      var $190=$1;
      var $191=(($190+20)|0);
      var $192=(($191+8)|0);
      var $193=HEAPF32[(($192)>>2)];
      var $194=$193*256;
      var $195=($194 >= 0 ? Math.floor($194) : Math.ceil($194));
      $sg=$195;
      var $196=$1;
      var $197=(($196+20)|0);
      var $198=(($197+12)|0);
      var $199=HEAPF32[(($198)>>2)];
      var $200=$199*256;
      var $201=($200 >= 0 ? Math.floor($200) : Math.ceil($200));
      $sb=$201;
      var $202=$sr;
      var $203=(($202)>>>0) > 256;
      if ($203) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $204
      var $205=$sr;
      var $206=(($205)|0) < 0;
      if ($206) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $207
      $sr=0;
      __label__ = 25; break;
    case 24: // $208
      $sr=256;
      __label__ = 25; break;
    case 25: // $209
      __label__ = 26; break;
    case 26: // $210
      var $211=$sg;
      var $212=(($211)>>>0) > 256;
      if ($212) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $213
      var $214=$sg;
      var $215=(($214)|0) < 0;
      if ($215) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $216
      $sg=0;
      __label__ = 30; break;
    case 29: // $217
      $sg=256;
      __label__ = 30; break;
    case 30: // $218
      __label__ = 31; break;
    case 31: // $219
      var $220=$sb;
      var $221=(($220)>>>0) > 256;
      if ($221) { __label__ = 32; break; } else { __label__ = 36; break; }
    case 32: // $222
      var $223=$sb;
      var $224=(($223)|0) < 0;
      if ($224) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $225
      $sb=0;
      __label__ = 35; break;
    case 34: // $226
      $sb=256;
      __label__ = 35; break;
    case 35: // $227
      __label__ = 36; break;
    case 36: // $228
      var $229=$4;
      var $230=(($229+28)|0);
      var $231=HEAP32[(($230)>>2)];
      $y=$231;
      __label__ = 37; break;
    case 37: // $232
      var $233=$y;
      var $234=$4;
      var $235=(($234+36)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=(($233)|0) < (($236)|0);
      if ($237) { __label__ = 38; break; } else { __label__ = 51; break; }
    case 38: // $238
      var $239=$2;
      var $240=$239;
      var $241=$y;
      var $242=$3;
      var $243=(($241*$242)|0);
      var $244=(($240+($243<<2))|0);
      var $245=$4;
      var $246=(($245+24)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=(($244+($247<<2))|0);
      $dest2=$248;
      var $249=$4;
      var $250=(($249+16)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$y;
      var $253=$4;
      var $254=(($253+28)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($252-$255)|0);
      var $257=$4;
      var $258=(($257+8)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($256*$259)|0);
      var $261=(($251+$260)|0);
      $curu3=$261;
      var $262=$4;
      var $263=(($262+20)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$y;
      var $266=$4;
      var $267=(($266+28)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(($265-$268)|0);
      var $270=$4;
      var $271=(($270+12)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($269*$272)|0);
      var $274=(($264+$273)|0);
      $curv4=$274;
      var $275=$palbase;
      var $276=(($275)|0)==0;
      if ($276) { __label__ = 39; break; } else { __label__ = 44; break; }
    case 39: // $277
      var $278=$4;
      var $279=(($278+24)|0);
      var $280=HEAP32[(($279)>>2)];
      $x=$280;
      __label__ = 40; break;
    case 40: // $281
      var $282=$x;
      var $283=$endx;
      var $284=(($282)|0) < (($283)|0);
      if ($284) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $285
      var $286=$1;
      var $287=(($286+44)|0);
      var $288=$curu3;
      var $289=$curv4;
      var $290=__ZL24get_texel_rgb32_bilinearPK14render_texinfoii($287, $288, $289);
      $pix5=$290;
      var $291=$pix5;
      var $292=$291 >>> 16;
      var $293=$292 & 255;
      var $294=$sr;
      var $295=(($293*$294)|0);
      var $296=$295 >>> 8;
      $r6=$296;
      var $297=$pix5;
      var $298=$297 >>> 8;
      var $299=$298 & 255;
      var $300=$sg;
      var $301=(($299*$300)|0);
      var $302=$301 >>> 8;
      $g7=$302;
      var $303=$pix5;
      var $304=$303 >>> 0;
      var $305=$304 & 255;
      var $306=$sb;
      var $307=(($305*$306)|0);
      var $308=$307 >>> 8;
      $b8=$308;
      var $309=$r6;
      var $310=$309 << 16;
      var $311=$g7;
      var $312=$311 << 8;
      var $313=$310 | $312;
      var $314=$b8;
      var $315=$314 << 0;
      var $316=$313 | $315;
      var $317=$dest2;
      var $318=(($317+4)|0);
      $dest2=$318;
      HEAP32[(($317)>>2)]=$316;
      var $319=$dudx;
      var $320=$curu3;
      var $321=(($320+$319)|0);
      $curu3=$321;
      var $322=$dvdx;
      var $323=$curv4;
      var $324=(($323+$322)|0);
      $curv4=$324;
      __label__ = 42; break;
    case 42: // $325
      var $326=$x;
      var $327=(($326+1)|0);
      $x=$327;
      __label__ = 40; break;
    case 43: // $328
      __label__ = 49; break;
    case 44: // $329
      var $330=$4;
      var $331=(($330+24)|0);
      var $332=HEAP32[(($331)>>2)];
      $x=$332;
      __label__ = 45; break;
    case 45: // $333
      var $334=$x;
      var $335=$endx;
      var $336=(($334)|0) < (($335)|0);
      if ($336) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $337
      var $338=$1;
      var $339=(($338+44)|0);
      var $340=$curu3;
      var $341=$curv4;
      var $342=__ZL24get_texel_rgb32_bilinearPK14render_texinfoii($339, $340, $341);
      $pix9=$342;
      var $343=$pix9;
      var $344=$343 >>> 16;
      var $345=$344 & 255;
      var $346=$palbase;
      var $347=(($346+($345<<2))|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$sr;
      var $350=(($348*$349)|0);
      var $351=$350 >>> 8;
      $r10=$351;
      var $352=$pix9;
      var $353=$352 >>> 8;
      var $354=$353 & 255;
      var $355=$palbase;
      var $356=(($355+($354<<2))|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=$sg;
      var $359=(($357*$358)|0);
      var $360=$359 >>> 8;
      $g11=$360;
      var $361=$pix9;
      var $362=$361 >>> 0;
      var $363=$362 & 255;
      var $364=$palbase;
      var $365=(($364+($363<<2))|0);
      var $366=HEAP32[(($365)>>2)];
      var $367=$sb;
      var $368=(($366*$367)|0);
      var $369=$368 >>> 8;
      $b12=$369;
      var $370=$r10;
      var $371=$370 << 16;
      var $372=$g11;
      var $373=$372 << 8;
      var $374=$371 | $373;
      var $375=$b12;
      var $376=$375 << 0;
      var $377=$374 | $376;
      var $378=$dest2;
      var $379=(($378+4)|0);
      $dest2=$379;
      HEAP32[(($378)>>2)]=$377;
      var $380=$dudx;
      var $381=$curu3;
      var $382=(($381+$380)|0);
      $curu3=$382;
      var $383=$dvdx;
      var $384=$curv4;
      var $385=(($384+$383)|0);
      $curv4=$385;
      __label__ = 47; break;
    case 47: // $386
      var $387=$x;
      var $388=(($387+1)|0);
      $x=$388;
      __label__ = 45; break;
    case 48: // $389
      __label__ = 49; break;
    case 49: // $390
      __label__ = 50; break;
    case 50: // $391
      var $392=$y;
      var $393=(($392+1)|0);
      $y=$393;
      __label__ = 37; break;
    case 51: // $394
      __label__ = 90; break;
    case 52: // $395
      var $396=$1;
      var $397=(($396+20)|0);
      var $398=(($397)|0);
      var $399=HEAPF32[(($398)>>2)];
      var $400=$399 < 0.00009999999747378752;
      if ($400) { __label__ = 89; break; } else { __label__ = 53; break; }
    case 53: // $401
      var $402=$1;
      var $403=(($402+20)|0);
      var $404=(($403+4)|0);
      var $405=HEAPF32[(($404)>>2)];
      var $406=$405*256;
      var $407=$1;
      var $408=(($407+20)|0);
      var $409=(($408)|0);
      var $410=HEAPF32[(($409)>>2)];
      var $411=$406*$410;
      var $412=($411 >= 0 ? Math.floor($411) : Math.ceil($411));
      $sr13=$412;
      var $413=$1;
      var $414=(($413+20)|0);
      var $415=(($414+8)|0);
      var $416=HEAPF32[(($415)>>2)];
      var $417=$416*256;
      var $418=$1;
      var $419=(($418+20)|0);
      var $420=(($419)|0);
      var $421=HEAPF32[(($420)>>2)];
      var $422=$417*$421;
      var $423=($422 >= 0 ? Math.floor($422) : Math.ceil($422));
      $sg14=$423;
      var $424=$1;
      var $425=(($424+20)|0);
      var $426=(($425+12)|0);
      var $427=HEAPF32[(($426)>>2)];
      var $428=$427*256;
      var $429=$1;
      var $430=(($429+20)|0);
      var $431=(($430)|0);
      var $432=HEAPF32[(($431)>>2)];
      var $433=$428*$432;
      var $434=($433 >= 0 ? Math.floor($433) : Math.ceil($433));
      $sb15=$434;
      var $435=$1;
      var $436=(($435+20)|0);
      var $437=(($436)|0);
      var $438=HEAPF32[(($437)>>2)];
      var $439=1-$438;
      var $440=$439*256;
      var $441=($440 >= 0 ? Math.floor($440) : Math.ceil($440));
      $invsa=$441;
      var $442=$sr13;
      var $443=(($442)>>>0) > 256;
      if ($443) { __label__ = 54; break; } else { __label__ = 58; break; }
    case 54: // $444
      var $445=$sr13;
      var $446=(($445)|0) < 0;
      if ($446) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $447
      $sr13=0;
      __label__ = 57; break;
    case 56: // $448
      $sr13=256;
      __label__ = 57; break;
    case 57: // $449
      __label__ = 58; break;
    case 58: // $450
      var $451=$sg14;
      var $452=(($451)>>>0) > 256;
      if ($452) { __label__ = 59; break; } else { __label__ = 63; break; }
    case 59: // $453
      var $454=$sg14;
      var $455=(($454)|0) < 0;
      if ($455) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $456
      $sg14=0;
      __label__ = 62; break;
    case 61: // $457
      $sg14=256;
      __label__ = 62; break;
    case 62: // $458
      __label__ = 63; break;
    case 63: // $459
      var $460=$sb15;
      var $461=(($460)>>>0) > 256;
      if ($461) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $462
      var $463=$sb15;
      var $464=(($463)|0) < 0;
      if ($464) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $465
      $sb15=0;
      __label__ = 67; break;
    case 66: // $466
      $sb15=256;
      __label__ = 67; break;
    case 67: // $467
      __label__ = 68; break;
    case 68: // $468
      var $469=$invsa;
      var $470=(($469)>>>0) > 256;
      if ($470) { __label__ = 69; break; } else { __label__ = 73; break; }
    case 69: // $471
      var $472=$invsa;
      var $473=(($472)|0) < 0;
      if ($473) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $474
      $invsa=0;
      __label__ = 72; break;
    case 71: // $475
      $invsa=256;
      __label__ = 72; break;
    case 72: // $476
      __label__ = 73; break;
    case 73: // $477
      var $478=$4;
      var $479=(($478+28)|0);
      var $480=HEAP32[(($479)>>2)];
      $y=$480;
      __label__ = 74; break;
    case 74: // $481
      var $482=$y;
      var $483=$4;
      var $484=(($483+36)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=(($482)|0) < (($485)|0);
      if ($486) { __label__ = 75; break; } else { __label__ = 88; break; }
    case 75: // $487
      var $488=$2;
      var $489=$488;
      var $490=$y;
      var $491=$3;
      var $492=(($490*$491)|0);
      var $493=(($489+($492<<2))|0);
      var $494=$4;
      var $495=(($494+24)|0);
      var $496=HEAP32[(($495)>>2)];
      var $497=(($493+($496<<2))|0);
      $dest16=$497;
      var $498=$4;
      var $499=(($498+16)|0);
      var $500=HEAP32[(($499)>>2)];
      var $501=$y;
      var $502=$4;
      var $503=(($502+28)|0);
      var $504=HEAP32[(($503)>>2)];
      var $505=(($501-$504)|0);
      var $506=$4;
      var $507=(($506+8)|0);
      var $508=HEAP32[(($507)>>2)];
      var $509=(($505*$508)|0);
      var $510=(($500+$509)|0);
      $curu17=$510;
      var $511=$4;
      var $512=(($511+20)|0);
      var $513=HEAP32[(($512)>>2)];
      var $514=$y;
      var $515=$4;
      var $516=(($515+28)|0);
      var $517=HEAP32[(($516)>>2)];
      var $518=(($514-$517)|0);
      var $519=$4;
      var $520=(($519+12)|0);
      var $521=HEAP32[(($520)>>2)];
      var $522=(($518*$521)|0);
      var $523=(($513+$522)|0);
      $curv18=$523;
      var $524=$palbase;
      var $525=(($524)|0)==0;
      if ($525) { __label__ = 76; break; } else { __label__ = 81; break; }
    case 76: // $526
      var $527=$4;
      var $528=(($527+24)|0);
      var $529=HEAP32[(($528)>>2)];
      $x=$529;
      __label__ = 77; break;
    case 77: // $530
      var $531=$x;
      var $532=$endx;
      var $533=(($531)|0) < (($532)|0);
      if ($533) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $534
      var $535=$1;
      var $536=(($535+44)|0);
      var $537=$curu17;
      var $538=$curv18;
      var $539=__ZL24get_texel_rgb32_bilinearPK14render_texinfoii($536, $537, $538);
      $pix19=$539;
      var $540=$dest16;
      var $541=HEAP32[(($540)>>2)];
      $dpix=$541;
      var $542=$pix19;
      var $543=$542 >>> 16;
      var $544=$543 & 255;
      var $545=$sr13;
      var $546=(($544*$545)|0);
      var $547=$dpix;
      var $548=$547 >>> 16;
      var $549=$548 & 255;
      var $550=$invsa;
      var $551=(($549*$550)|0);
      var $552=(($546+$551)|0);
      var $553=$552 >>> 8;
      $r20=$553;
      var $554=$pix19;
      var $555=$554 >>> 8;
      var $556=$555 & 255;
      var $557=$sg14;
      var $558=(($556*$557)|0);
      var $559=$dpix;
      var $560=$559 >>> 8;
      var $561=$560 & 255;
      var $562=$invsa;
      var $563=(($561*$562)|0);
      var $564=(($558+$563)|0);
      var $565=$564 >>> 8;
      $g21=$565;
      var $566=$pix19;
      var $567=$566 >>> 0;
      var $568=$567 & 255;
      var $569=$sb15;
      var $570=(($568*$569)|0);
      var $571=$dpix;
      var $572=$571 >>> 0;
      var $573=$572 & 255;
      var $574=$invsa;
      var $575=(($573*$574)|0);
      var $576=(($570+$575)|0);
      var $577=$576 >>> 8;
      $b22=$577;
      var $578=$r20;
      var $579=$578 << 16;
      var $580=$g21;
      var $581=$580 << 8;
      var $582=$579 | $581;
      var $583=$b22;
      var $584=$583 << 0;
      var $585=$582 | $584;
      var $586=$dest16;
      var $587=(($586+4)|0);
      $dest16=$587;
      HEAP32[(($586)>>2)]=$585;
      var $588=$dudx;
      var $589=$curu17;
      var $590=(($589+$588)|0);
      $curu17=$590;
      var $591=$dvdx;
      var $592=$curv18;
      var $593=(($592+$591)|0);
      $curv18=$593;
      __label__ = 79; break;
    case 79: // $594
      var $595=$x;
      var $596=(($595+1)|0);
      $x=$596;
      __label__ = 77; break;
    case 80: // $597
      __label__ = 86; break;
    case 81: // $598
      var $599=$4;
      var $600=(($599+24)|0);
      var $601=HEAP32[(($600)>>2)];
      $x=$601;
      __label__ = 82; break;
    case 82: // $602
      var $603=$x;
      var $604=$endx;
      var $605=(($603)|0) < (($604)|0);
      if ($605) { __label__ = 83; break; } else { __label__ = 85; break; }
    case 83: // $606
      var $607=$1;
      var $608=(($607+44)|0);
      var $609=$curu17;
      var $610=$curv18;
      var $611=__ZL24get_texel_rgb32_bilinearPK14render_texinfoii($608, $609, $610);
      $pix23=$611;
      var $612=$dest16;
      var $613=HEAP32[(($612)>>2)];
      $dpix24=$613;
      var $614=$pix23;
      var $615=$614 >>> 16;
      var $616=$615 & 255;
      var $617=$palbase;
      var $618=(($617+($616<<2))|0);
      var $619=HEAPU32[(($618)>>2)];
      var $620=$619 >>> 0;
      var $621=$sr13;
      var $622=(($620*$621)|0);
      var $623=$dpix24;
      var $624=$623 >>> 16;
      var $625=$624 & 255;
      var $626=$invsa;
      var $627=(($625*$626)|0);
      var $628=(($622+$627)|0);
      var $629=$628 >>> 8;
      $r25=$629;
      var $630=$pix23;
      var $631=$630 >>> 8;
      var $632=$631 & 255;
      var $633=$palbase;
      var $634=(($633+($632<<2))|0);
      var $635=HEAPU32[(($634)>>2)];
      var $636=$635 >>> 0;
      var $637=$sg14;
      var $638=(($636*$637)|0);
      var $639=$dpix24;
      var $640=$639 >>> 8;
      var $641=$640 & 255;
      var $642=$invsa;
      var $643=(($641*$642)|0);
      var $644=(($638+$643)|0);
      var $645=$644 >>> 8;
      $g26=$645;
      var $646=$pix23;
      var $647=$646 >>> 0;
      var $648=$647 & 255;
      var $649=$palbase;
      var $650=(($649+($648<<2))|0);
      var $651=HEAPU32[(($650)>>2)];
      var $652=$651 >>> 0;
      var $653=$sb15;
      var $654=(($652*$653)|0);
      var $655=$dpix24;
      var $656=$655 >>> 0;
      var $657=$656 & 255;
      var $658=$invsa;
      var $659=(($657*$658)|0);
      var $660=(($654+$659)|0);
      var $661=$660 >>> 8;
      $b27=$661;
      var $662=$r25;
      var $663=$662 << 16;
      var $664=$g26;
      var $665=$664 << 8;
      var $666=$663 | $665;
      var $667=$b27;
      var $668=$667 << 0;
      var $669=$666 | $668;
      var $670=$dest16;
      var $671=(($670+4)|0);
      $dest16=$671;
      HEAP32[(($670)>>2)]=$669;
      var $672=$dudx;
      var $673=$curu17;
      var $674=(($673+$672)|0);
      $curu17=$674;
      var $675=$dvdx;
      var $676=$curv18;
      var $677=(($676+$675)|0);
      $curv18=$677;
      __label__ = 84; break;
    case 84: // $678
      var $679=$x;
      var $680=(($679+1)|0);
      $x=$680;
      __label__ = 82; break;
    case 85: // $681
      __label__ = 86; break;
    case 86: // $682
      __label__ = 87; break;
    case 87: // $683
      var $684=$y;
      var $685=(($684+1)|0);
      $y=$685;
      __label__ = 74; break;
    case 88: // $686
      __label__ = 89; break;
    case 89: // $687
      __label__ = 90; break;
    case 90: // $688
      __label__ = 91; break;
    case 91: // $689
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22rgb888_draw_quad_rgb32PK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL26rgb888_draw_quad_rgb32_addPK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $dpix;
      var $r;
      var $g;
      var $b;
      var $pix1;
      var $dpix2;
      var $r3;
      var $g4;
      var $b5;
      var $sr;
      var $sg;
      var $sb;
      var $sa;
      var $dest6;
      var $curu7;
      var $curv8;
      var $pix9;
      var $dpix10;
      var $r11;
      var $g12;
      var $b13;
      var $pix14;
      var $dpix15;
      var $r16;
      var $g17;
      var $b18;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($100, $101, $102);
      $pix=$103;
      var $104=$dest;
      var $105=HEAP32[(($104)>>2)];
      $dpix=$105;
      var $106=$pix;
      var $107=$106 >>> 16;
      var $108=$107 & 255;
      var $109=$dpix;
      var $110=$109 >>> 16;
      var $111=$110 & 255;
      var $112=(($108+$111)|0);
      $r=$112;
      var $113=$pix;
      var $114=$113 >>> 8;
      var $115=$114 & 255;
      var $116=$dpix;
      var $117=$116 >>> 8;
      var $118=$117 & 255;
      var $119=(($115+$118)|0);
      $g=$119;
      var $120=$pix;
      var $121=$120 >>> 0;
      var $122=$121 & 255;
      var $123=$dpix;
      var $124=$123 >>> 0;
      var $125=$124 & 255;
      var $126=(($122+$125)|0);
      $b=$126;
      var $127=$r;
      var $128=$r;
      var $129=$128 >>> 8;
      var $130=(((-$129))|0);
      var $131=$127 | $130;
      var $132=$131 & 255;
      $r=$132;
      var $133=$g;
      var $134=$g;
      var $135=$134 >>> 8;
      var $136=(((-$135))|0);
      var $137=$133 | $136;
      var $138=$137 & 255;
      $g=$138;
      var $139=$b;
      var $140=$b;
      var $141=$140 >>> 8;
      var $142=(((-$141))|0);
      var $143=$139 | $142;
      var $144=$143 & 255;
      $b=$144;
      var $145=$r;
      var $146=$145 << 16;
      var $147=$g;
      var $148=$147 << 8;
      var $149=$146 | $148;
      var $150=$b;
      var $151=$150 << 0;
      var $152=$149 | $151;
      var $153=$dest;
      var $154=(($153+4)|0);
      $dest=$154;
      HEAP32[(($153)>>2)]=$152;
      var $155=$dudx;
      var $156=$curu;
      var $157=(($156+$155)|0);
      $curu=$157;
      var $158=$dvdx;
      var $159=$curv;
      var $160=(($159+$158)|0);
      $curv=$160;
      __label__ = 10; break;
    case 10: // $161
      var $162=$x;
      var $163=(($162+1)|0);
      $x=$163;
      __label__ = 8; break;
    case 11: // $164
      __label__ = 17; break;
    case 12: // $165
      var $166=$4;
      var $167=(($166+24)|0);
      var $168=HEAP32[(($167)>>2)];
      $x=$168;
      __label__ = 13; break;
    case 13: // $169
      var $170=$x;
      var $171=$endx;
      var $172=(($170)|0) < (($171)|0);
      if ($172) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $173
      var $174=$1;
      var $175=(($174+44)|0);
      var $176=$curu;
      var $177=$curv;
      var $178=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($175, $176, $177);
      $pix1=$178;
      var $179=$dest;
      var $180=HEAP32[(($179)>>2)];
      $dpix2=$180;
      var $181=$pix1;
      var $182=$181 >>> 16;
      var $183=$182 & 255;
      var $184=$palbase;
      var $185=(($184+($183<<2))|0);
      var $186=HEAPU32[(($185)>>2)];
      var $187=$186 >>> 0;
      var $188=$dpix2;
      var $189=$188 >>> 16;
      var $190=$189 & 255;
      var $191=(($187+$190)|0);
      $r3=$191;
      var $192=$pix1;
      var $193=$192 >>> 8;
      var $194=$193 & 255;
      var $195=$palbase;
      var $196=(($195+($194<<2))|0);
      var $197=HEAPU32[(($196)>>2)];
      var $198=$197 >>> 0;
      var $199=$dpix2;
      var $200=$199 >>> 8;
      var $201=$200 & 255;
      var $202=(($198+$201)|0);
      $g4=$202;
      var $203=$pix1;
      var $204=$203 >>> 0;
      var $205=$204 & 255;
      var $206=$palbase;
      var $207=(($206+($205<<2))|0);
      var $208=HEAPU32[(($207)>>2)];
      var $209=$208 >>> 0;
      var $210=$dpix2;
      var $211=$210 >>> 0;
      var $212=$211 & 255;
      var $213=(($209+$212)|0);
      $b5=$213;
      var $214=$r3;
      var $215=$r3;
      var $216=$215 >>> 8;
      var $217=(((-$216))|0);
      var $218=$214 | $217;
      var $219=$218 & 255;
      $r3=$219;
      var $220=$g4;
      var $221=$g4;
      var $222=$221 >>> 8;
      var $223=(((-$222))|0);
      var $224=$220 | $223;
      var $225=$224 & 255;
      $g4=$225;
      var $226=$b5;
      var $227=$b5;
      var $228=$227 >>> 8;
      var $229=(((-$228))|0);
      var $230=$226 | $229;
      var $231=$230 & 255;
      $b5=$231;
      var $232=$r3;
      var $233=$232 << 16;
      var $234=$g4;
      var $235=$234 << 8;
      var $236=$233 | $235;
      var $237=$b5;
      var $238=$237 << 0;
      var $239=$236 | $238;
      var $240=$dest;
      var $241=(($240+4)|0);
      $dest=$241;
      HEAP32[(($240)>>2)]=$239;
      var $242=$dudx;
      var $243=$curu;
      var $244=(($243+$242)|0);
      $curu=$244;
      var $245=$dvdx;
      var $246=$curv;
      var $247=(($246+$245)|0);
      $curv=$247;
      __label__ = 15; break;
    case 15: // $248
      var $249=$x;
      var $250=(($249+1)|0);
      $x=$250;
      __label__ = 13; break;
    case 16: // $251
      __label__ = 17; break;
    case 17: // $252
      __label__ = 18; break;
    case 18: // $253
      var $254=$y;
      var $255=(($254+1)|0);
      $y=$255;
      __label__ = 5; break;
    case 19: // $256
      __label__ = 56; break;
    case 20: // $257
      var $258=$1;
      var $259=(($258+20)|0);
      var $260=(($259+4)|0);
      var $261=HEAPF32[(($260)>>2)];
      var $262=$261*256;
      var $263=($262 >= 0 ? Math.floor($262) : Math.ceil($262));
      $sr=$263;
      var $264=$1;
      var $265=(($264+20)|0);
      var $266=(($265+8)|0);
      var $267=HEAPF32[(($266)>>2)];
      var $268=$267*256;
      var $269=($268 >= 0 ? Math.floor($268) : Math.ceil($268));
      $sg=$269;
      var $270=$1;
      var $271=(($270+20)|0);
      var $272=(($271+12)|0);
      var $273=HEAPF32[(($272)>>2)];
      var $274=$273*256;
      var $275=($274 >= 0 ? Math.floor($274) : Math.ceil($274));
      $sb=$275;
      var $276=$1;
      var $277=(($276+20)|0);
      var $278=(($277)|0);
      var $279=HEAPF32[(($278)>>2)];
      var $280=$279*256;
      var $281=($280 >= 0 ? Math.floor($280) : Math.ceil($280));
      $sa=$281;
      var $282=$sr;
      var $283=(($282)>>>0) > 256;
      if ($283) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $284
      var $285=$sr;
      var $286=(($285)|0) < 0;
      if ($286) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $287
      $sr=0;
      __label__ = 24; break;
    case 23: // $288
      $sr=256;
      __label__ = 24; break;
    case 24: // $289
      __label__ = 25; break;
    case 25: // $290
      var $291=$sg;
      var $292=(($291)>>>0) > 256;
      if ($292) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $293
      var $294=$sg;
      var $295=(($294)|0) < 0;
      if ($295) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $296
      $sg=0;
      __label__ = 29; break;
    case 28: // $297
      $sg=256;
      __label__ = 29; break;
    case 29: // $298
      __label__ = 30; break;
    case 30: // $299
      var $300=$sb;
      var $301=(($300)>>>0) > 256;
      if ($301) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 31: // $302
      var $303=$sb;
      var $304=(($303)|0) < 0;
      if ($304) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $305
      $sb=0;
      __label__ = 34; break;
    case 33: // $306
      $sb=256;
      __label__ = 34; break;
    case 34: // $307
      __label__ = 35; break;
    case 35: // $308
      var $309=$sa;
      var $310=(($309)>>>0) > 256;
      if ($310) { __label__ = 36; break; } else { __label__ = 40; break; }
    case 36: // $311
      var $312=$sa;
      var $313=(($312)|0) < 0;
      if ($313) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $314
      $sa=0;
      __label__ = 39; break;
    case 38: // $315
      $sa=256;
      __label__ = 39; break;
    case 39: // $316
      __label__ = 40; break;
    case 40: // $317
      var $318=$4;
      var $319=(($318+28)|0);
      var $320=HEAP32[(($319)>>2)];
      $y=$320;
      __label__ = 41; break;
    case 41: // $321
      var $322=$y;
      var $323=$4;
      var $324=(($323+36)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($322)|0) < (($325)|0);
      if ($326) { __label__ = 42; break; } else { __label__ = 55; break; }
    case 42: // $327
      var $328=$2;
      var $329=$328;
      var $330=$y;
      var $331=$3;
      var $332=(($330*$331)|0);
      var $333=(($329+($332<<2))|0);
      var $334=$4;
      var $335=(($334+24)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=(($333+($336<<2))|0);
      $dest6=$337;
      var $338=$4;
      var $339=(($338+16)|0);
      var $340=HEAP32[(($339)>>2)];
      var $341=$y;
      var $342=$4;
      var $343=(($342+28)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=(($341-$344)|0);
      var $346=$4;
      var $347=(($346+8)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=(($345*$348)|0);
      var $350=(($340+$349)|0);
      $curu7=$350;
      var $351=$4;
      var $352=(($351+20)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=$y;
      var $355=$4;
      var $356=(($355+28)|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=(($354-$357)|0);
      var $359=$4;
      var $360=(($359+12)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($358*$361)|0);
      var $363=(($353+$362)|0);
      $curv8=$363;
      var $364=$palbase;
      var $365=(($364)|0)==0;
      if ($365) { __label__ = 43; break; } else { __label__ = 48; break; }
    case 43: // $366
      var $367=$4;
      var $368=(($367+24)|0);
      var $369=HEAP32[(($368)>>2)];
      $x=$369;
      __label__ = 44; break;
    case 44: // $370
      var $371=$x;
      var $372=$endx;
      var $373=(($371)|0) < (($372)|0);
      if ($373) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $374
      var $375=$1;
      var $376=(($375+44)|0);
      var $377=$curu7;
      var $378=$curv8;
      var $379=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($376, $377, $378);
      $pix9=$379;
      var $380=$dest6;
      var $381=HEAP32[(($380)>>2)];
      $dpix10=$381;
      var $382=$pix9;
      var $383=$382 >>> 16;
      var $384=$383 & 255;
      var $385=$sr;
      var $386=(($384*$385)|0);
      var $387=$sa;
      var $388=(($386*$387)|0);
      var $389=$388 >>> 16;
      var $390=$dpix10;
      var $391=$390 >>> 16;
      var $392=$391 & 255;
      var $393=(($389+$392)|0);
      $r11=$393;
      var $394=$pix9;
      var $395=$394 >>> 8;
      var $396=$395 & 255;
      var $397=$sg;
      var $398=(($396*$397)|0);
      var $399=$sa;
      var $400=(($398*$399)|0);
      var $401=$400 >>> 16;
      var $402=$dpix10;
      var $403=$402 >>> 8;
      var $404=$403 & 255;
      var $405=(($401+$404)|0);
      $g12=$405;
      var $406=$pix9;
      var $407=$406 >>> 0;
      var $408=$407 & 255;
      var $409=$sb;
      var $410=(($408*$409)|0);
      var $411=$sa;
      var $412=(($410*$411)|0);
      var $413=$412 >>> 16;
      var $414=$dpix10;
      var $415=$414 >>> 0;
      var $416=$415 & 255;
      var $417=(($413+$416)|0);
      $b13=$417;
      var $418=$r11;
      var $419=$r11;
      var $420=$419 >>> 8;
      var $421=(((-$420))|0);
      var $422=$418 | $421;
      var $423=$422 & 255;
      $r11=$423;
      var $424=$g12;
      var $425=$g12;
      var $426=$425 >>> 8;
      var $427=(((-$426))|0);
      var $428=$424 | $427;
      var $429=$428 & 255;
      $g12=$429;
      var $430=$b13;
      var $431=$b13;
      var $432=$431 >>> 8;
      var $433=(((-$432))|0);
      var $434=$430 | $433;
      var $435=$434 & 255;
      $b13=$435;
      var $436=$r11;
      var $437=$436 << 16;
      var $438=$g12;
      var $439=$438 << 8;
      var $440=$437 | $439;
      var $441=$b13;
      var $442=$441 << 0;
      var $443=$440 | $442;
      var $444=$dest6;
      var $445=(($444+4)|0);
      $dest6=$445;
      HEAP32[(($444)>>2)]=$443;
      var $446=$dudx;
      var $447=$curu7;
      var $448=(($447+$446)|0);
      $curu7=$448;
      var $449=$dvdx;
      var $450=$curv8;
      var $451=(($450+$449)|0);
      $curv8=$451;
      __label__ = 46; break;
    case 46: // $452
      var $453=$x;
      var $454=(($453+1)|0);
      $x=$454;
      __label__ = 44; break;
    case 47: // $455
      __label__ = 53; break;
    case 48: // $456
      var $457=$4;
      var $458=(($457+24)|0);
      var $459=HEAP32[(($458)>>2)];
      $x=$459;
      __label__ = 49; break;
    case 49: // $460
      var $461=$x;
      var $462=$endx;
      var $463=(($461)|0) < (($462)|0);
      if ($463) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $464
      var $465=$1;
      var $466=(($465+44)|0);
      var $467=$curu7;
      var $468=$curv8;
      var $469=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($466, $467, $468);
      $pix14=$469;
      var $470=$dest6;
      var $471=HEAP32[(($470)>>2)];
      $dpix15=$471;
      var $472=$pix14;
      var $473=$472 >>> 16;
      var $474=$473 & 255;
      var $475=$palbase;
      var $476=(($475+($474<<2))|0);
      var $477=HEAP32[(($476)>>2)];
      var $478=$sr;
      var $479=(($477*$478)|0);
      var $480=$sa;
      var $481=(($479*$480)|0);
      var $482=$481 >>> 16;
      var $483=$dpix15;
      var $484=$483 >>> 16;
      var $485=$484 & 255;
      var $486=(($482+$485)|0);
      $r16=$486;
      var $487=$pix14;
      var $488=$487 >>> 8;
      var $489=$488 & 255;
      var $490=$palbase;
      var $491=(($490+($489<<2))|0);
      var $492=HEAP32[(($491)>>2)];
      var $493=$sr;
      var $494=(($492*$493)|0);
      var $495=$sa;
      var $496=(($494*$495)|0);
      var $497=$496 >>> 16;
      var $498=$dpix15;
      var $499=$498 >>> 8;
      var $500=$499 & 255;
      var $501=(($497+$500)|0);
      $g17=$501;
      var $502=$pix14;
      var $503=$502 >>> 0;
      var $504=$503 & 255;
      var $505=$palbase;
      var $506=(($505+($504<<2))|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=$sr;
      var $509=(($507*$508)|0);
      var $510=$sa;
      var $511=(($509*$510)|0);
      var $512=$511 >>> 16;
      var $513=$dpix15;
      var $514=$513 >>> 0;
      var $515=$514 & 255;
      var $516=(($512+$515)|0);
      $b18=$516;
      var $517=$r16;
      var $518=$r16;
      var $519=$518 >>> 8;
      var $520=(((-$519))|0);
      var $521=$517 | $520;
      var $522=$521 & 255;
      $r16=$522;
      var $523=$g17;
      var $524=$g17;
      var $525=$524 >>> 8;
      var $526=(((-$525))|0);
      var $527=$523 | $526;
      var $528=$527 & 255;
      $g17=$528;
      var $529=$b18;
      var $530=$b18;
      var $531=$530 >>> 8;
      var $532=(((-$531))|0);
      var $533=$529 | $532;
      var $534=$533 & 255;
      $b18=$534;
      var $535=$r16;
      var $536=$535 << 16;
      var $537=$g17;
      var $538=$537 << 8;
      var $539=$536 | $538;
      var $540=$b18;
      var $541=$540 << 0;
      var $542=$539 | $541;
      var $543=$dest6;
      var $544=(($543+4)|0);
      $dest6=$544;
      HEAP32[(($543)>>2)]=$542;
      var $545=$dudx;
      var $546=$curu7;
      var $547=(($546+$545)|0);
      $curu7=$547;
      var $548=$dvdx;
      var $549=$curv8;
      var $550=(($549+$548)|0);
      $curv8=$550;
      __label__ = 51; break;
    case 51: // $551
      var $552=$x;
      var $553=(($552+1)|0);
      $x=$553;
      __label__ = 49; break;
    case 52: // $554
      __label__ = 53; break;
    case 53: // $555
      __label__ = 54; break;
    case 54: // $556
      var $557=$y;
      var $558=(($557+1)|0);
      $y=$558;
      __label__ = 41; break;
    case 55: // $559
      __label__ = 56; break;
    case 56: // $560
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26rgb888_draw_quad_rgb32_addPK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL29rgb888_draw_quad_argb32_alphaPK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $ta;
      var $dpix;
      var $invta;
      var $r;
      var $g;
      var $b;
      var $pix1;
      var $ta2;
      var $dpix3;
      var $invta4;
      var $r5;
      var $g6;
      var $b7;
      var $sr;
      var $sg;
      var $sb;
      var $sa;
      var $dest8;
      var $curu9;
      var $curv10;
      var $pix11;
      var $ta12;
      var $dpix13;
      var $invsta;
      var $r14;
      var $g15;
      var $b16;
      var $pix17;
      var $ta18;
      var $dpix19;
      var $invsta20;
      var $r21;
      var $g22;
      var $b23;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 24; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 24; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 24; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 24; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 23; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($100, $101, $102);
      $pix=$103;
      var $104=$pix;
      var $105=$104 >>> 24;
      $ta=$105;
      var $106=$ta;
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $108
      var $109=$dest;
      var $110=HEAP32[(($109)>>2)];
      $dpix=$110;
      var $111=$ta;
      var $112=((256-$111)|0);
      $invta=$112;
      var $113=$pix;
      var $114=$113 >>> 16;
      var $115=$114 & 255;
      var $116=$ta;
      var $117=(($115*$116)|0);
      var $118=$dpix;
      var $119=$118 >>> 16;
      var $120=$119 & 255;
      var $121=$invta;
      var $122=(($120*$121)|0);
      var $123=(($117+$122)|0);
      var $124=$123 >>> 8;
      $r=$124;
      var $125=$pix;
      var $126=$125 >>> 8;
      var $127=$126 & 255;
      var $128=$ta;
      var $129=(($127*$128)|0);
      var $130=$dpix;
      var $131=$130 >>> 8;
      var $132=$131 & 255;
      var $133=$invta;
      var $134=(($132*$133)|0);
      var $135=(($129+$134)|0);
      var $136=$135 >>> 8;
      $g=$136;
      var $137=$pix;
      var $138=$137 >>> 0;
      var $139=$138 & 255;
      var $140=$ta;
      var $141=(($139*$140)|0);
      var $142=$dpix;
      var $143=$142 >>> 0;
      var $144=$143 & 255;
      var $145=$invta;
      var $146=(($144*$145)|0);
      var $147=(($141+$146)|0);
      var $148=$147 >>> 8;
      $b=$148;
      var $149=$r;
      var $150=$149 << 16;
      var $151=$g;
      var $152=$151 << 8;
      var $153=$150 | $152;
      var $154=$b;
      var $155=$154 << 0;
      var $156=$153 | $155;
      var $157=$dest;
      HEAP32[(($157)>>2)]=$156;
      __label__ = 11; break;
    case 11: // $158
      var $159=$dest;
      var $160=(($159+4)|0);
      $dest=$160;
      var $161=$dudx;
      var $162=$curu;
      var $163=(($162+$161)|0);
      $curu=$163;
      var $164=$dvdx;
      var $165=$curv;
      var $166=(($165+$164)|0);
      $curv=$166;
      __label__ = 12; break;
    case 12: // $167
      var $168=$x;
      var $169=(($168+1)|0);
      $x=$169;
      __label__ = 8; break;
    case 13: // $170
      __label__ = 21; break;
    case 14: // $171
      var $172=$4;
      var $173=(($172+24)|0);
      var $174=HEAP32[(($173)>>2)];
      $x=$174;
      __label__ = 15; break;
    case 15: // $175
      var $176=$x;
      var $177=$endx;
      var $178=(($176)|0) < (($177)|0);
      if ($178) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $179
      var $180=$1;
      var $181=(($180+44)|0);
      var $182=$curu;
      var $183=$curv;
      var $184=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($181, $182, $183);
      $pix1=$184;
      var $185=$pix1;
      var $186=$185 >>> 24;
      $ta2=$186;
      var $187=$ta2;
      var $188=(($187)|0)!=0;
      if ($188) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $189
      var $190=$dest;
      var $191=HEAP32[(($190)>>2)];
      $dpix3=$191;
      var $192=$ta2;
      var $193=((256-$192)|0);
      $invta4=$193;
      var $194=$pix1;
      var $195=$194 >>> 16;
      var $196=$195 & 255;
      var $197=$palbase;
      var $198=(($197+($196<<2))|0);
      var $199=HEAPU32[(($198)>>2)];
      var $200=$199 >>> 0;
      var $201=$ta2;
      var $202=(($200*$201)|0);
      var $203=$dpix3;
      var $204=$203 >>> 16;
      var $205=$204 & 255;
      var $206=$invta4;
      var $207=(($205*$206)|0);
      var $208=(($202+$207)|0);
      var $209=$208 >>> 8;
      $r5=$209;
      var $210=$pix1;
      var $211=$210 >>> 8;
      var $212=$211 & 255;
      var $213=$palbase;
      var $214=(($213+($212<<2))|0);
      var $215=HEAPU32[(($214)>>2)];
      var $216=$215 >>> 0;
      var $217=$ta2;
      var $218=(($216*$217)|0);
      var $219=$dpix3;
      var $220=$219 >>> 8;
      var $221=$220 & 255;
      var $222=$invta4;
      var $223=(($221*$222)|0);
      var $224=(($218+$223)|0);
      var $225=$224 >>> 8;
      $g6=$225;
      var $226=$pix1;
      var $227=$226 >>> 0;
      var $228=$227 & 255;
      var $229=$palbase;
      var $230=(($229+($228<<2))|0);
      var $231=HEAPU32[(($230)>>2)];
      var $232=$231 >>> 0;
      var $233=$ta2;
      var $234=(($232*$233)|0);
      var $235=$dpix3;
      var $236=$235 >>> 0;
      var $237=$236 & 255;
      var $238=$invta4;
      var $239=(($237*$238)|0);
      var $240=(($234+$239)|0);
      var $241=$240 >>> 8;
      $b7=$241;
      var $242=$r5;
      var $243=$242 << 16;
      var $244=$g6;
      var $245=$244 << 8;
      var $246=$243 | $245;
      var $247=$b7;
      var $248=$247 << 0;
      var $249=$246 | $248;
      var $250=$dest;
      HEAP32[(($250)>>2)]=$249;
      __label__ = 18; break;
    case 18: // $251
      var $252=$dest;
      var $253=(($252+4)|0);
      $dest=$253;
      var $254=$dudx;
      var $255=$curu;
      var $256=(($255+$254)|0);
      $curu=$256;
      var $257=$dvdx;
      var $258=$curv;
      var $259=(($258+$257)|0);
      $curv=$259;
      __label__ = 19; break;
    case 19: // $260
      var $261=$x;
      var $262=(($261+1)|0);
      $x=$262;
      __label__ = 15; break;
    case 20: // $263
      __label__ = 21; break;
    case 21: // $264
      __label__ = 22; break;
    case 22: // $265
      var $266=$y;
      var $267=(($266+1)|0);
      $y=$267;
      __label__ = 5; break;
    case 23: // $268
      __label__ = 64; break;
    case 24: // $269
      var $270=$1;
      var $271=(($270+20)|0);
      var $272=(($271+4)|0);
      var $273=HEAPF32[(($272)>>2)];
      var $274=$273*256;
      var $275=($274 >= 0 ? Math.floor($274) : Math.ceil($274));
      $sr=$275;
      var $276=$1;
      var $277=(($276+20)|0);
      var $278=(($277+8)|0);
      var $279=HEAPF32[(($278)>>2)];
      var $280=$279*256;
      var $281=($280 >= 0 ? Math.floor($280) : Math.ceil($280));
      $sg=$281;
      var $282=$1;
      var $283=(($282+20)|0);
      var $284=(($283+12)|0);
      var $285=HEAPF32[(($284)>>2)];
      var $286=$285*256;
      var $287=($286 >= 0 ? Math.floor($286) : Math.ceil($286));
      $sb=$287;
      var $288=$1;
      var $289=(($288+20)|0);
      var $290=(($289)|0);
      var $291=HEAPF32[(($290)>>2)];
      var $292=$291*256;
      var $293=($292 >= 0 ? Math.floor($292) : Math.ceil($292));
      $sa=$293;
      var $294=$sr;
      var $295=(($294)>>>0) > 256;
      if ($295) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $296
      var $297=$sr;
      var $298=(($297)|0) < 0;
      if ($298) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $299
      $sr=0;
      __label__ = 28; break;
    case 27: // $300
      $sr=256;
      __label__ = 28; break;
    case 28: // $301
      __label__ = 29; break;
    case 29: // $302
      var $303=$sg;
      var $304=(($303)>>>0) > 256;
      if ($304) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $305
      var $306=$sg;
      var $307=(($306)|0) < 0;
      if ($307) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $308
      $sg=0;
      __label__ = 33; break;
    case 32: // $309
      $sg=256;
      __label__ = 33; break;
    case 33: // $310
      __label__ = 34; break;
    case 34: // $311
      var $312=$sb;
      var $313=(($312)>>>0) > 256;
      if ($313) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $314
      var $315=$sb;
      var $316=(($315)|0) < 0;
      if ($316) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $317
      $sb=0;
      __label__ = 38; break;
    case 37: // $318
      $sb=256;
      __label__ = 38; break;
    case 38: // $319
      __label__ = 39; break;
    case 39: // $320
      var $321=$sa;
      var $322=(($321)>>>0) > 256;
      if ($322) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $323
      var $324=$sa;
      var $325=(($324)|0) < 0;
      if ($325) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $326
      $sa=0;
      __label__ = 43; break;
    case 42: // $327
      $sa=256;
      __label__ = 43; break;
    case 43: // $328
      __label__ = 44; break;
    case 44: // $329
      var $330=$4;
      var $331=(($330+28)|0);
      var $332=HEAP32[(($331)>>2)];
      $y=$332;
      __label__ = 45; break;
    case 45: // $333
      var $334=$y;
      var $335=$4;
      var $336=(($335+36)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=(($334)|0) < (($337)|0);
      if ($338) { __label__ = 46; break; } else { __label__ = 63; break; }
    case 46: // $339
      var $340=$2;
      var $341=$340;
      var $342=$y;
      var $343=$3;
      var $344=(($342*$343)|0);
      var $345=(($341+($344<<2))|0);
      var $346=$4;
      var $347=(($346+24)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=(($345+($348<<2))|0);
      $dest8=$349;
      var $350=$4;
      var $351=(($350+16)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=$y;
      var $354=$4;
      var $355=(($354+28)|0);
      var $356=HEAP32[(($355)>>2)];
      var $357=(($353-$356)|0);
      var $358=$4;
      var $359=(($358+8)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=(($357*$360)|0);
      var $362=(($352+$361)|0);
      $curu9=$362;
      var $363=$4;
      var $364=(($363+20)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=$y;
      var $367=$4;
      var $368=(($367+28)|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=(($366-$369)|0);
      var $371=$4;
      var $372=(($371+12)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=(($370*$373)|0);
      var $375=(($365+$374)|0);
      $curv10=$375;
      var $376=$palbase;
      var $377=(($376)|0)==0;
      if ($377) { __label__ = 47; break; } else { __label__ = 54; break; }
    case 47: // $378
      var $379=$4;
      var $380=(($379+24)|0);
      var $381=HEAP32[(($380)>>2)];
      $x=$381;
      __label__ = 48; break;
    case 48: // $382
      var $383=$x;
      var $384=$endx;
      var $385=(($383)|0) < (($384)|0);
      if ($385) { __label__ = 49; break; } else { __label__ = 53; break; }
    case 49: // $386
      var $387=$1;
      var $388=(($387+44)|0);
      var $389=$curu9;
      var $390=$curv10;
      var $391=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($388, $389, $390);
      $pix11=$391;
      var $392=$pix11;
      var $393=$392 >>> 24;
      var $394=$sa;
      var $395=(($393*$394)|0);
      $ta12=$395;
      var $396=$ta12;
      var $397=(($396)|0)!=0;
      if ($397) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $398
      var $399=$dest8;
      var $400=HEAP32[(($399)>>2)];
      $dpix13=$400;
      var $401=$ta12;
      var $402=((65536-$401)|0);
      var $403=$402 << 8;
      $invsta=$403;
      var $404=$pix11;
      var $405=$404 >>> 16;
      var $406=$405 & 255;
      var $407=$sr;
      var $408=(($406*$407)|0);
      var $409=$ta12;
      var $410=(($408*$409)|0);
      var $411=$dpix13;
      var $412=$411 >>> 16;
      var $413=$412 & 255;
      var $414=$invsta;
      var $415=(($413*$414)|0);
      var $416=(($410+$415)|0);
      var $417=$416 >>> 24;
      $r14=$417;
      var $418=$pix11;
      var $419=$418 >>> 8;
      var $420=$419 & 255;
      var $421=$sg;
      var $422=(($420*$421)|0);
      var $423=$ta12;
      var $424=(($422*$423)|0);
      var $425=$dpix13;
      var $426=$425 >>> 8;
      var $427=$426 & 255;
      var $428=$invsta;
      var $429=(($427*$428)|0);
      var $430=(($424+$429)|0);
      var $431=$430 >>> 24;
      $g15=$431;
      var $432=$pix11;
      var $433=$432 >>> 0;
      var $434=$433 & 255;
      var $435=$sb;
      var $436=(($434*$435)|0);
      var $437=$ta12;
      var $438=(($436*$437)|0);
      var $439=$dpix13;
      var $440=$439 >>> 0;
      var $441=$440 & 255;
      var $442=$invsta;
      var $443=(($441*$442)|0);
      var $444=(($438+$443)|0);
      var $445=$444 >>> 24;
      $b16=$445;
      var $446=$r14;
      var $447=$446 << 16;
      var $448=$g15;
      var $449=$448 << 8;
      var $450=$447 | $449;
      var $451=$b16;
      var $452=$451 << 0;
      var $453=$450 | $452;
      var $454=$dest8;
      HEAP32[(($454)>>2)]=$453;
      __label__ = 51; break;
    case 51: // $455
      var $456=$dest8;
      var $457=(($456+4)|0);
      $dest8=$457;
      var $458=$dudx;
      var $459=$curu9;
      var $460=(($459+$458)|0);
      $curu9=$460;
      var $461=$dvdx;
      var $462=$curv10;
      var $463=(($462+$461)|0);
      $curv10=$463;
      __label__ = 52; break;
    case 52: // $464
      var $465=$x;
      var $466=(($465+1)|0);
      $x=$466;
      __label__ = 48; break;
    case 53: // $467
      __label__ = 61; break;
    case 54: // $468
      var $469=$4;
      var $470=(($469+24)|0);
      var $471=HEAP32[(($470)>>2)];
      $x=$471;
      __label__ = 55; break;
    case 55: // $472
      var $473=$x;
      var $474=$endx;
      var $475=(($473)|0) < (($474)|0);
      if ($475) { __label__ = 56; break; } else { __label__ = 60; break; }
    case 56: // $476
      var $477=$1;
      var $478=(($477+44)|0);
      var $479=$curu9;
      var $480=$curv10;
      var $481=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($478, $479, $480);
      $pix17=$481;
      var $482=$pix17;
      var $483=$482 >>> 24;
      var $484=$sa;
      var $485=(($483*$484)|0);
      $ta18=$485;
      var $486=$ta18;
      var $487=(($486)|0)!=0;
      if ($487) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $488
      var $489=$dest8;
      var $490=HEAP32[(($489)>>2)];
      $dpix19=$490;
      var $491=$ta18;
      var $492=((65536-$491)|0);
      var $493=$492 << 8;
      $invsta20=$493;
      var $494=$pix17;
      var $495=$494 >>> 16;
      var $496=$495 & 255;
      var $497=$palbase;
      var $498=(($497+($496<<2))|0);
      var $499=HEAPU32[(($498)>>2)];
      var $500=$499 >>> 0;
      var $501=$sr;
      var $502=(($500*$501)|0);
      var $503=$ta18;
      var $504=(($502*$503)|0);
      var $505=$dpix19;
      var $506=$505 >>> 16;
      var $507=$506 & 255;
      var $508=$invsta20;
      var $509=(($507*$508)|0);
      var $510=(($504+$509)|0);
      var $511=$510 >>> 24;
      $r21=$511;
      var $512=$pix17;
      var $513=$512 >>> 8;
      var $514=$513 & 255;
      var $515=$palbase;
      var $516=(($515+($514<<2))|0);
      var $517=HEAPU32[(($516)>>2)];
      var $518=$517 >>> 0;
      var $519=$sg;
      var $520=(($518*$519)|0);
      var $521=$ta18;
      var $522=(($520*$521)|0);
      var $523=$dpix19;
      var $524=$523 >>> 8;
      var $525=$524 & 255;
      var $526=$invsta20;
      var $527=(($525*$526)|0);
      var $528=(($522+$527)|0);
      var $529=$528 >>> 24;
      $g22=$529;
      var $530=$pix17;
      var $531=$530 >>> 0;
      var $532=$531 & 255;
      var $533=$palbase;
      var $534=(($533+($532<<2))|0);
      var $535=HEAPU32[(($534)>>2)];
      var $536=$535 >>> 0;
      var $537=$sb;
      var $538=(($536*$537)|0);
      var $539=$ta18;
      var $540=(($538*$539)|0);
      var $541=$dpix19;
      var $542=$541 >>> 0;
      var $543=$542 & 255;
      var $544=$invsta20;
      var $545=(($543*$544)|0);
      var $546=(($540+$545)|0);
      var $547=$546 >>> 24;
      $b23=$547;
      var $548=$r21;
      var $549=$548 << 16;
      var $550=$g22;
      var $551=$550 << 8;
      var $552=$549 | $551;
      var $553=$b23;
      var $554=$553 << 0;
      var $555=$552 | $554;
      var $556=$dest8;
      HEAP32[(($556)>>2)]=$555;
      __label__ = 58; break;
    case 58: // $557
      var $558=$dest8;
      var $559=(($558+4)|0);
      $dest8=$559;
      var $560=$dudx;
      var $561=$curu9;
      var $562=(($561+$560)|0);
      $curu9=$562;
      var $563=$dvdx;
      var $564=$curv10;
      var $565=(($564+$563)|0);
      $curv10=$565;
      __label__ = 59; break;
    case 59: // $566
      var $567=$x;
      var $568=(($567+1)|0);
      $x=$568;
      __label__ = 55; break;
    case 60: // $569
      __label__ = 61; break;
    case 61: // $570
      __label__ = 62; break;
    case 62: // $571
      var $572=$y;
      var $573=(($572+1)|0);
      $y=$573;
      __label__ = 45; break;
    case 63: // $574
      __label__ = 64; break;
    case 64: // $575
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29rgb888_draw_quad_argb32_alphaPK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL32rgb888_draw_quad_argb32_multiplyPK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $dpix;
      var $r;
      var $g;
      var $b;
      var $pix1;
      var $dpix2;
      var $r3;
      var $g4;
      var $b5;
      var $sr;
      var $sg;
      var $sb;
      var $dest6;
      var $curu7;
      var $curv8;
      var $pix9;
      var $dpix10;
      var $r11;
      var $g12;
      var $b13;
      var $pix14;
      var $dpix15;
      var $r16;
      var $g17;
      var $b18;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 19; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($100, $101, $102);
      $pix=$103;
      var $104=$dest;
      var $105=HEAP32[(($104)>>2)];
      $dpix=$105;
      var $106=$pix;
      var $107=$106 >>> 16;
      var $108=$107 & 255;
      var $109=$dpix;
      var $110=$109 >>> 16;
      var $111=$110 & 255;
      var $112=(($108*$111)|0);
      var $113=$112 >>> 8;
      $r=$113;
      var $114=$pix;
      var $115=$114 >>> 8;
      var $116=$115 & 255;
      var $117=$dpix;
      var $118=$117 >>> 8;
      var $119=$118 & 255;
      var $120=(($116*$119)|0);
      var $121=$120 >>> 8;
      $g=$121;
      var $122=$pix;
      var $123=$122 >>> 0;
      var $124=$123 & 255;
      var $125=$dpix;
      var $126=$125 >>> 0;
      var $127=$126 & 255;
      var $128=(($124*$127)|0);
      var $129=$128 >>> 8;
      $b=$129;
      var $130=$r;
      var $131=$130 << 16;
      var $132=$g;
      var $133=$132 << 8;
      var $134=$131 | $133;
      var $135=$b;
      var $136=$135 << 0;
      var $137=$134 | $136;
      var $138=$dest;
      var $139=(($138+4)|0);
      $dest=$139;
      HEAP32[(($138)>>2)]=$137;
      var $140=$dudx;
      var $141=$curu;
      var $142=(($141+$140)|0);
      $curu=$142;
      var $143=$dvdx;
      var $144=$curv;
      var $145=(($144+$143)|0);
      $curv=$145;
      __label__ = 10; break;
    case 10: // $146
      var $147=$x;
      var $148=(($147+1)|0);
      $x=$148;
      __label__ = 8; break;
    case 11: // $149
      __label__ = 17; break;
    case 12: // $150
      var $151=$4;
      var $152=(($151+24)|0);
      var $153=HEAP32[(($152)>>2)];
      $x=$153;
      __label__ = 13; break;
    case 13: // $154
      var $155=$x;
      var $156=$endx;
      var $157=(($155)|0) < (($156)|0);
      if ($157) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $158
      var $159=$1;
      var $160=(($159+44)|0);
      var $161=$curu;
      var $162=$curv;
      var $163=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($160, $161, $162);
      $pix1=$163;
      var $164=$dest;
      var $165=HEAP32[(($164)>>2)];
      $dpix2=$165;
      var $166=$pix1;
      var $167=$166 >>> 16;
      var $168=$167 & 255;
      var $169=$palbase;
      var $170=(($169+($168<<2))|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$dpix2;
      var $173=$172 >>> 16;
      var $174=$173 & 255;
      var $175=(($171*$174)|0);
      var $176=$175 >>> 8;
      $r3=$176;
      var $177=$pix1;
      var $178=$177 >>> 8;
      var $179=$178 & 255;
      var $180=$palbase;
      var $181=(($180+($179<<2))|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$dpix2;
      var $184=$183 >>> 8;
      var $185=$184 & 255;
      var $186=(($182*$185)|0);
      var $187=$186 >>> 8;
      $g4=$187;
      var $188=$pix1;
      var $189=$188 >>> 0;
      var $190=$189 & 255;
      var $191=$palbase;
      var $192=(($191+($190<<2))|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$dpix2;
      var $195=$194 >>> 0;
      var $196=$195 & 255;
      var $197=(($193*$196)|0);
      var $198=$197 >>> 8;
      $b5=$198;
      var $199=$r3;
      var $200=$199 << 16;
      var $201=$g4;
      var $202=$201 << 8;
      var $203=$200 | $202;
      var $204=$b5;
      var $205=$204 << 0;
      var $206=$203 | $205;
      var $207=$dest;
      var $208=(($207+4)|0);
      $dest=$208;
      HEAP32[(($207)>>2)]=$206;
      var $209=$dudx;
      var $210=$curu;
      var $211=(($210+$209)|0);
      $curu=$211;
      var $212=$dvdx;
      var $213=$curv;
      var $214=(($213+$212)|0);
      $curv=$214;
      __label__ = 15; break;
    case 15: // $215
      var $216=$x;
      var $217=(($216+1)|0);
      $x=$217;
      __label__ = 13; break;
    case 16: // $218
      __label__ = 17; break;
    case 17: // $219
      __label__ = 18; break;
    case 18: // $220
      var $221=$y;
      var $222=(($221+1)|0);
      $y=$222;
      __label__ = 5; break;
    case 19: // $223
      __label__ = 51; break;
    case 20: // $224
      var $225=$1;
      var $226=(($225+20)|0);
      var $227=(($226+4)|0);
      var $228=HEAPF32[(($227)>>2)];
      var $229=$228*256;
      var $230=$1;
      var $231=(($230+20)|0);
      var $232=(($231)|0);
      var $233=HEAPF32[(($232)>>2)];
      var $234=$229*$233;
      var $235=($234 >= 0 ? Math.floor($234) : Math.ceil($234));
      $sr=$235;
      var $236=$1;
      var $237=(($236+20)|0);
      var $238=(($237+8)|0);
      var $239=HEAPF32[(($238)>>2)];
      var $240=$239*256;
      var $241=$1;
      var $242=(($241+20)|0);
      var $243=(($242)|0);
      var $244=HEAPF32[(($243)>>2)];
      var $245=$240*$244;
      var $246=($245 >= 0 ? Math.floor($245) : Math.ceil($245));
      $sg=$246;
      var $247=$1;
      var $248=(($247+20)|0);
      var $249=(($248+12)|0);
      var $250=HEAPF32[(($249)>>2)];
      var $251=$250*256;
      var $252=$1;
      var $253=(($252+20)|0);
      var $254=(($253)|0);
      var $255=HEAPF32[(($254)>>2)];
      var $256=$251*$255;
      var $257=($256 >= 0 ? Math.floor($256) : Math.ceil($256));
      $sb=$257;
      var $258=$sr;
      var $259=(($258)>>>0) > 256;
      if ($259) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $260
      var $261=$sr;
      var $262=(($261)|0) < 0;
      if ($262) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $263
      $sr=0;
      __label__ = 24; break;
    case 23: // $264
      $sr=256;
      __label__ = 24; break;
    case 24: // $265
      __label__ = 25; break;
    case 25: // $266
      var $267=$sg;
      var $268=(($267)>>>0) > 256;
      if ($268) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $269
      var $270=$sg;
      var $271=(($270)|0) < 0;
      if ($271) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $272
      $sg=0;
      __label__ = 29; break;
    case 28: // $273
      $sg=256;
      __label__ = 29; break;
    case 29: // $274
      __label__ = 30; break;
    case 30: // $275
      var $276=$sb;
      var $277=(($276)>>>0) > 256;
      if ($277) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 31: // $278
      var $279=$sb;
      var $280=(($279)|0) < 0;
      if ($280) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $281
      $sb=0;
      __label__ = 34; break;
    case 33: // $282
      $sb=256;
      __label__ = 34; break;
    case 34: // $283
      __label__ = 35; break;
    case 35: // $284
      var $285=$4;
      var $286=(($285+28)|0);
      var $287=HEAP32[(($286)>>2)];
      $y=$287;
      __label__ = 36; break;
    case 36: // $288
      var $289=$y;
      var $290=$4;
      var $291=(($290+36)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($289)|0) < (($292)|0);
      if ($293) { __label__ = 37; break; } else { __label__ = 50; break; }
    case 37: // $294
      var $295=$2;
      var $296=$295;
      var $297=$y;
      var $298=$3;
      var $299=(($297*$298)|0);
      var $300=(($296+($299<<2))|0);
      var $301=$4;
      var $302=(($301+24)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(($300+($303<<2))|0);
      $dest6=$304;
      var $305=$4;
      var $306=(($305+16)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=$y;
      var $309=$4;
      var $310=(($309+28)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(($308-$311)|0);
      var $313=$4;
      var $314=(($313+8)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=(($312*$315)|0);
      var $317=(($307+$316)|0);
      $curu7=$317;
      var $318=$4;
      var $319=(($318+20)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$y;
      var $322=$4;
      var $323=(($322+28)|0);
      var $324=HEAP32[(($323)>>2)];
      var $325=(($321-$324)|0);
      var $326=$4;
      var $327=(($326+12)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=(($325*$328)|0);
      var $330=(($320+$329)|0);
      $curv8=$330;
      var $331=$palbase;
      var $332=(($331)|0)==0;
      if ($332) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $333
      var $334=$4;
      var $335=(($334+24)|0);
      var $336=HEAP32[(($335)>>2)];
      $x=$336;
      __label__ = 39; break;
    case 39: // $337
      var $338=$x;
      var $339=$endx;
      var $340=(($338)|0) < (($339)|0);
      if ($340) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $341
      var $342=$1;
      var $343=(($342+44)|0);
      var $344=$curu7;
      var $345=$curv8;
      var $346=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($343, $344, $345);
      $pix9=$346;
      var $347=$dest6;
      var $348=HEAP32[(($347)>>2)];
      $dpix10=$348;
      var $349=$pix9;
      var $350=$349 >>> 16;
      var $351=$350 & 255;
      var $352=$sr;
      var $353=(($351*$352)|0);
      var $354=$dpix10;
      var $355=$354 >>> 16;
      var $356=$355 & 255;
      var $357=(($353*$356)|0);
      var $358=$357 >>> 16;
      $r11=$358;
      var $359=$pix9;
      var $360=$359 >>> 8;
      var $361=$360 & 255;
      var $362=$sg;
      var $363=(($361*$362)|0);
      var $364=$dpix10;
      var $365=$364 >>> 8;
      var $366=$365 & 255;
      var $367=(($363*$366)|0);
      var $368=$367 >>> 16;
      $g12=$368;
      var $369=$pix9;
      var $370=$369 >>> 0;
      var $371=$370 & 255;
      var $372=$sb;
      var $373=(($371*$372)|0);
      var $374=$dpix10;
      var $375=$374 >>> 0;
      var $376=$375 & 255;
      var $377=(($373*$376)|0);
      var $378=$377 >>> 16;
      $b13=$378;
      var $379=$r11;
      var $380=$379 << 16;
      var $381=$g12;
      var $382=$381 << 8;
      var $383=$380 | $382;
      var $384=$b13;
      var $385=$384 << 0;
      var $386=$383 | $385;
      var $387=$dest6;
      var $388=(($387+4)|0);
      $dest6=$388;
      HEAP32[(($387)>>2)]=$386;
      var $389=$dudx;
      var $390=$curu7;
      var $391=(($390+$389)|0);
      $curu7=$391;
      var $392=$dvdx;
      var $393=$curv8;
      var $394=(($393+$392)|0);
      $curv8=$394;
      __label__ = 41; break;
    case 41: // $395
      var $396=$x;
      var $397=(($396+1)|0);
      $x=$397;
      __label__ = 39; break;
    case 42: // $398
      __label__ = 48; break;
    case 43: // $399
      var $400=$4;
      var $401=(($400+24)|0);
      var $402=HEAP32[(($401)>>2)];
      $x=$402;
      __label__ = 44; break;
    case 44: // $403
      var $404=$x;
      var $405=$endx;
      var $406=(($404)|0) < (($405)|0);
      if ($406) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $407
      var $408=$1;
      var $409=(($408+44)|0);
      var $410=$curu7;
      var $411=$curv8;
      var $412=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($409, $410, $411);
      $pix14=$412;
      var $413=$dest6;
      var $414=HEAP32[(($413)>>2)];
      $dpix15=$414;
      var $415=$pix14;
      var $416=$415 >>> 16;
      var $417=$416 & 255;
      var $418=$palbase;
      var $419=(($418+($417<<2))|0);
      var $420=HEAP32[(($419)>>2)];
      var $421=$sr;
      var $422=(($420*$421)|0);
      var $423=$dpix15;
      var $424=$423 >>> 16;
      var $425=$424 & 255;
      var $426=(($422*$425)|0);
      var $427=$426 >>> 16;
      $r16=$427;
      var $428=$pix14;
      var $429=$428 >>> 8;
      var $430=$429 & 255;
      var $431=$palbase;
      var $432=(($431+($430<<2))|0);
      var $433=HEAP32[(($432)>>2)];
      var $434=$sg;
      var $435=(($433*$434)|0);
      var $436=$dpix15;
      var $437=$436 >>> 8;
      var $438=$437 & 255;
      var $439=(($435*$438)|0);
      var $440=$439 >>> 16;
      $g17=$440;
      var $441=$pix14;
      var $442=$441 >>> 0;
      var $443=$442 & 255;
      var $444=$palbase;
      var $445=(($444+($443<<2))|0);
      var $446=HEAP32[(($445)>>2)];
      var $447=$sb;
      var $448=(($446*$447)|0);
      var $449=$dpix15;
      var $450=$449 >>> 0;
      var $451=$450 & 255;
      var $452=(($448*$451)|0);
      var $453=$452 >>> 16;
      $b18=$453;
      var $454=$r16;
      var $455=$454 << 16;
      var $456=$g17;
      var $457=$456 << 8;
      var $458=$455 | $457;
      var $459=$b18;
      var $460=$459 << 0;
      var $461=$458 | $460;
      var $462=$dest6;
      var $463=(($462+4)|0);
      $dest6=$463;
      HEAP32[(($462)>>2)]=$461;
      var $464=$dudx;
      var $465=$curu7;
      var $466=(($465+$464)|0);
      $curu7=$466;
      var $467=$dvdx;
      var $468=$curv8;
      var $469=(($468+$467)|0);
      $curv8=$469;
      __label__ = 46; break;
    case 46: // $470
      var $471=$x;
      var $472=(($471+1)|0);
      $x=$472;
      __label__ = 44; break;
    case 47: // $473
      __label__ = 48; break;
    case 48: // $474
      __label__ = 49; break;
    case 49: // $475
      var $476=$y;
      var $477=(($476+1)|0);
      $y=$477;
      __label__ = 36; break;
    case 50: // $478
      __label__ = 51; break;
    case 51: // $479
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32rgb888_draw_quad_argb32_multiplyPK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL27rgb888_draw_quad_argb32_addPK16render_primitivePvjP16_quad_setup_data($prim, $dstdata, $pitch, $setup) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $palbase;
      var $dudx;
      var $dvdx;
      var $endx;
      var $x;
      var $y;
      var $dest;
      var $curu;
      var $curv;
      var $pix;
      var $ta;
      var $dpix;
      var $r;
      var $g;
      var $b;
      var $pix1;
      var $ta2;
      var $dpix3;
      var $r4;
      var $g5;
      var $b6;
      var $sr;
      var $sg;
      var $sb;
      var $sa;
      var $dest7;
      var $curu8;
      var $curv9;
      var $pix10;
      var $ta11;
      var $dpix12;
      var $r13;
      var $g14;
      var $b15;
      var $pix16;
      var $ta17;
      var $dpix18;
      var $r19;
      var $g20;
      var $b21;
      $1=$prim;
      $2=$dstdata;
      $3=$pitch;
      $4=$setup;
      var $5=$1;
      var $6=(($5+44)|0);
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      $palbase=$8;
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $dudx=$11;
      var $12=$4;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $dvdx=$14;
      var $15=$4;
      var $16=(($15+32)|0);
      var $17=HEAP32[(($16)>>2)];
      $endx=$17;
      var $18=$1;
      var $19=(($18+20)|0);
      var $20=(($19+4)|0);
      var $21=HEAPF32[(($20)>>2)];
      var $22=$21 >= 1;
      if ($22) { __label__ = 1; break; } else { __label__ = 24; break; }
    case 1: // $23
      var $24=$1;
      var $25=(($24+20)|0);
      var $26=(($25+8)|0);
      var $27=HEAPF32[(($26)>>2)];
      var $28=$27 >= 1;
      if ($28) { __label__ = 2; break; } else { __label__ = 24; break; }
    case 2: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      var $32=(($31+12)|0);
      var $33=HEAPF32[(($32)>>2)];
      var $34=$33 >= 1;
      if ($34) { __label__ = 3; break; } else { __label__ = 24; break; }
    case 3: // $35
      var $36=$1;
      var $37=(($36+20)|0);
      var $38=(($37)|0);
      var $39=HEAPF32[(($38)>>2)];
      var $40=$39 >= 1;
      if ($40) { __label__ = 4; break; } else { __label__ = 24; break; }
    case 4: // $41
      var $42=$4;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      $y=$44;
      __label__ = 5; break;
    case 5: // $45
      var $46=$y;
      var $47=$4;
      var $48=(($47+36)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46)|0) < (($49)|0);
      if ($50) { __label__ = 6; break; } else { __label__ = 23; break; }
    case 6: // $51
      var $52=$2;
      var $53=$52;
      var $54=$y;
      var $55=$3;
      var $56=(($54*$55)|0);
      var $57=(($53+($56<<2))|0);
      var $58=$4;
      var $59=(($58+24)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57+($60<<2))|0);
      $dest=$61;
      var $62=$4;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$y;
      var $66=$4;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($65-$68)|0);
      var $70=$4;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($64+$73)|0);
      $curu=$74;
      var $75=$4;
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$y;
      var $79=$4;
      var $80=(($79+28)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78-$81)|0);
      var $83=$4;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=(($77+$86)|0);
      $curv=$87;
      var $88=$palbase;
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $90
      var $91=$4;
      var $92=(($91+24)|0);
      var $93=HEAP32[(($92)>>2)];
      $x=$93;
      __label__ = 8; break;
    case 8: // $94
      var $95=$x;
      var $96=$endx;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $98
      var $99=$1;
      var $100=(($99+44)|0);
      var $101=$curu;
      var $102=$curv;
      var $103=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($100, $101, $102);
      $pix=$103;
      var $104=$pix;
      var $105=$104 >>> 24;
      $ta=$105;
      var $106=$ta;
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $108
      var $109=$dest;
      var $110=HEAP32[(($109)>>2)];
      $dpix=$110;
      var $111=$pix;
      var $112=$111 >>> 16;
      var $113=$112 & 255;
      var $114=$ta;
      var $115=(($113*$114)|0);
      var $116=$115 >>> 8;
      var $117=$dpix;
      var $118=$117 >>> 16;
      var $119=$118 & 255;
      var $120=(($116+$119)|0);
      $r=$120;
      var $121=$pix;
      var $122=$121 >>> 8;
      var $123=$122 & 255;
      var $124=$ta;
      var $125=(($123*$124)|0);
      var $126=$125 >>> 8;
      var $127=$dpix;
      var $128=$127 >>> 8;
      var $129=$128 & 255;
      var $130=(($126+$129)|0);
      $g=$130;
      var $131=$pix;
      var $132=$131 >>> 0;
      var $133=$132 & 255;
      var $134=$ta;
      var $135=(($133*$134)|0);
      var $136=$135 >>> 8;
      var $137=$dpix;
      var $138=$137 >>> 0;
      var $139=$138 & 255;
      var $140=(($136+$139)|0);
      $b=$140;
      var $141=$r;
      var $142=$r;
      var $143=$142 >>> 8;
      var $144=(((-$143))|0);
      var $145=$141 | $144;
      var $146=$145 & 255;
      $r=$146;
      var $147=$g;
      var $148=$g;
      var $149=$148 >>> 8;
      var $150=(((-$149))|0);
      var $151=$147 | $150;
      var $152=$151 & 255;
      $g=$152;
      var $153=$b;
      var $154=$b;
      var $155=$154 >>> 8;
      var $156=(((-$155))|0);
      var $157=$153 | $156;
      var $158=$157 & 255;
      $b=$158;
      var $159=$r;
      var $160=$159 << 16;
      var $161=$g;
      var $162=$161 << 8;
      var $163=$160 | $162;
      var $164=$b;
      var $165=$164 << 0;
      var $166=$163 | $165;
      var $167=$dest;
      HEAP32[(($167)>>2)]=$166;
      __label__ = 11; break;
    case 11: // $168
      var $169=$dest;
      var $170=(($169+4)|0);
      $dest=$170;
      var $171=$dudx;
      var $172=$curu;
      var $173=(($172+$171)|0);
      $curu=$173;
      var $174=$dvdx;
      var $175=$curv;
      var $176=(($175+$174)|0);
      $curv=$176;
      __label__ = 12; break;
    case 12: // $177
      var $178=$x;
      var $179=(($178+1)|0);
      $x=$179;
      __label__ = 8; break;
    case 13: // $180
      __label__ = 21; break;
    case 14: // $181
      var $182=$4;
      var $183=(($182+24)|0);
      var $184=HEAP32[(($183)>>2)];
      $x=$184;
      __label__ = 15; break;
    case 15: // $185
      var $186=$x;
      var $187=$endx;
      var $188=(($186)|0) < (($187)|0);
      if ($188) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $189
      var $190=$1;
      var $191=(($190+44)|0);
      var $192=$curu;
      var $193=$curv;
      var $194=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($191, $192, $193);
      $pix1=$194;
      var $195=$pix1;
      var $196=$195 >>> 24;
      $ta2=$196;
      var $197=$ta2;
      var $198=(($197)|0)!=0;
      if ($198) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $199
      var $200=$dest;
      var $201=HEAP32[(($200)>>2)];
      $dpix3=$201;
      var $202=$pix1;
      var $203=$202 >>> 16;
      var $204=$203 & 255;
      var $205=$palbase;
      var $206=(($205+($204<<2))|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$ta2;
      var $209=(($207*$208)|0);
      var $210=$209 >>> 8;
      var $211=$dpix3;
      var $212=$211 >>> 16;
      var $213=$212 & 255;
      var $214=(($210+$213)|0);
      $r4=$214;
      var $215=$pix1;
      var $216=$215 >>> 8;
      var $217=$216 & 255;
      var $218=$palbase;
      var $219=(($218+($217<<2))|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$ta2;
      var $222=(($220*$221)|0);
      var $223=$222 >>> 8;
      var $224=$dpix3;
      var $225=$224 >>> 8;
      var $226=$225 & 255;
      var $227=(($223+$226)|0);
      $g5=$227;
      var $228=$pix1;
      var $229=$228 >>> 0;
      var $230=$229 & 255;
      var $231=$palbase;
      var $232=(($231+($230<<2))|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$ta2;
      var $235=(($233*$234)|0);
      var $236=$235 >>> 8;
      var $237=$dpix3;
      var $238=$237 >>> 0;
      var $239=$238 & 255;
      var $240=(($236+$239)|0);
      $b6=$240;
      var $241=$r4;
      var $242=$r4;
      var $243=$242 >>> 8;
      var $244=(((-$243))|0);
      var $245=$241 | $244;
      var $246=$245 & 255;
      $r4=$246;
      var $247=$g5;
      var $248=$g5;
      var $249=$248 >>> 8;
      var $250=(((-$249))|0);
      var $251=$247 | $250;
      var $252=$251 & 255;
      $g5=$252;
      var $253=$b6;
      var $254=$b6;
      var $255=$254 >>> 8;
      var $256=(((-$255))|0);
      var $257=$253 | $256;
      var $258=$257 & 255;
      $b6=$258;
      var $259=$r4;
      var $260=$259 << 16;
      var $261=$g5;
      var $262=$261 << 8;
      var $263=$260 | $262;
      var $264=$b6;
      var $265=$264 << 0;
      var $266=$263 | $265;
      var $267=$dest;
      HEAP32[(($267)>>2)]=$266;
      __label__ = 18; break;
    case 18: // $268
      var $269=$dest;
      var $270=(($269+4)|0);
      $dest=$270;
      var $271=$dudx;
      var $272=$curu;
      var $273=(($272+$271)|0);
      $curu=$273;
      var $274=$dvdx;
      var $275=$curv;
      var $276=(($275+$274)|0);
      $curv=$276;
      __label__ = 19; break;
    case 19: // $277
      var $278=$x;
      var $279=(($278+1)|0);
      $x=$279;
      __label__ = 15; break;
    case 20: // $280
      __label__ = 21; break;
    case 21: // $281
      __label__ = 22; break;
    case 22: // $282
      var $283=$y;
      var $284=(($283+1)|0);
      $y=$284;
      __label__ = 5; break;
    case 23: // $285
      __label__ = 64; break;
    case 24: // $286
      var $287=$1;
      var $288=(($287+20)|0);
      var $289=(($288+4)|0);
      var $290=HEAPF32[(($289)>>2)];
      var $291=$290*256;
      var $292=($291 >= 0 ? Math.floor($291) : Math.ceil($291));
      $sr=$292;
      var $293=$1;
      var $294=(($293+20)|0);
      var $295=(($294+8)|0);
      var $296=HEAPF32[(($295)>>2)];
      var $297=$296*256;
      var $298=($297 >= 0 ? Math.floor($297) : Math.ceil($297));
      $sg=$298;
      var $299=$1;
      var $300=(($299+20)|0);
      var $301=(($300+12)|0);
      var $302=HEAPF32[(($301)>>2)];
      var $303=$302*256;
      var $304=($303 >= 0 ? Math.floor($303) : Math.ceil($303));
      $sb=$304;
      var $305=$1;
      var $306=(($305+20)|0);
      var $307=(($306)|0);
      var $308=HEAPF32[(($307)>>2)];
      var $309=$308*256;
      var $310=($309 >= 0 ? Math.floor($309) : Math.ceil($309));
      $sa=$310;
      var $311=$sr;
      var $312=(($311)>>>0) > 256;
      if ($312) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $313
      var $314=$sr;
      var $315=(($314)|0) < 0;
      if ($315) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $316
      $sr=0;
      __label__ = 28; break;
    case 27: // $317
      $sr=256;
      __label__ = 28; break;
    case 28: // $318
      __label__ = 29; break;
    case 29: // $319
      var $320=$sg;
      var $321=(($320)>>>0) > 256;
      if ($321) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $322
      var $323=$sg;
      var $324=(($323)|0) < 0;
      if ($324) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $325
      $sg=0;
      __label__ = 33; break;
    case 32: // $326
      $sg=256;
      __label__ = 33; break;
    case 33: // $327
      __label__ = 34; break;
    case 34: // $328
      var $329=$sb;
      var $330=(($329)>>>0) > 256;
      if ($330) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $331
      var $332=$sb;
      var $333=(($332)|0) < 0;
      if ($333) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $334
      $sb=0;
      __label__ = 38; break;
    case 37: // $335
      $sb=256;
      __label__ = 38; break;
    case 38: // $336
      __label__ = 39; break;
    case 39: // $337
      var $338=$sa;
      var $339=(($338)>>>0) > 256;
      if ($339) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $340
      var $341=$sa;
      var $342=(($341)|0) < 0;
      if ($342) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $343
      $sa=0;
      __label__ = 43; break;
    case 42: // $344
      $sa=256;
      __label__ = 43; break;
    case 43: // $345
      __label__ = 44; break;
    case 44: // $346
      var $347=$4;
      var $348=(($347+28)|0);
      var $349=HEAP32[(($348)>>2)];
      $y=$349;
      __label__ = 45; break;
    case 45: // $350
      var $351=$y;
      var $352=$4;
      var $353=(($352+36)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=(($351)|0) < (($354)|0);
      if ($355) { __label__ = 46; break; } else { __label__ = 63; break; }
    case 46: // $356
      var $357=$2;
      var $358=$357;
      var $359=$y;
      var $360=$3;
      var $361=(($359*$360)|0);
      var $362=(($358+($361<<2))|0);
      var $363=$4;
      var $364=(($363+24)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=(($362+($365<<2))|0);
      $dest7=$366;
      var $367=$4;
      var $368=(($367+16)|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=$y;
      var $371=$4;
      var $372=(($371+28)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=(($370-$373)|0);
      var $375=$4;
      var $376=(($375+8)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=(($374*$377)|0);
      var $379=(($369+$378)|0);
      $curu8=$379;
      var $380=$4;
      var $381=(($380+20)|0);
      var $382=HEAP32[(($381)>>2)];
      var $383=$y;
      var $384=$4;
      var $385=(($384+28)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=(($383-$386)|0);
      var $388=$4;
      var $389=(($388+12)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=(($387*$390)|0);
      var $392=(($382+$391)|0);
      $curv9=$392;
      var $393=$palbase;
      var $394=(($393)|0)==0;
      if ($394) { __label__ = 47; break; } else { __label__ = 54; break; }
    case 47: // $395
      var $396=$4;
      var $397=(($396+24)|0);
      var $398=HEAP32[(($397)>>2)];
      $x=$398;
      __label__ = 48; break;
    case 48: // $399
      var $400=$x;
      var $401=$endx;
      var $402=(($400)|0) < (($401)|0);
      if ($402) { __label__ = 49; break; } else { __label__ = 53; break; }
    case 49: // $403
      var $404=$1;
      var $405=(($404+44)|0);
      var $406=$curu8;
      var $407=$curv9;
      var $408=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($405, $406, $407);
      $pix10=$408;
      var $409=$pix10;
      var $410=$409 >>> 24;
      var $411=$sa;
      var $412=(($410*$411)|0);
      $ta11=$412;
      var $413=$ta11;
      var $414=(($413)|0)!=0;
      if ($414) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $415
      var $416=$dest7;
      var $417=HEAP32[(($416)>>2)];
      $dpix12=$417;
      var $418=$pix10;
      var $419=$418 >>> 16;
      var $420=$419 & 255;
      var $421=$sr;
      var $422=(($420*$421)|0);
      var $423=$ta11;
      var $424=(($422*$423)|0);
      var $425=$424 >>> 24;
      var $426=$dpix12;
      var $427=$426 >>> 16;
      var $428=$427 & 255;
      var $429=(($425+$428)|0);
      $r13=$429;
      var $430=$pix10;
      var $431=$430 >>> 8;
      var $432=$431 & 255;
      var $433=$sg;
      var $434=(($432*$433)|0);
      var $435=$ta11;
      var $436=(($434*$435)|0);
      var $437=$436 >>> 24;
      var $438=$dpix12;
      var $439=$438 >>> 8;
      var $440=$439 & 255;
      var $441=(($437+$440)|0);
      $g14=$441;
      var $442=$pix10;
      var $443=$442 >>> 0;
      var $444=$443 & 255;
      var $445=$sb;
      var $446=(($444*$445)|0);
      var $447=$ta11;
      var $448=(($446*$447)|0);
      var $449=$448 >>> 24;
      var $450=$dpix12;
      var $451=$450 >>> 0;
      var $452=$451 & 255;
      var $453=(($449+$452)|0);
      $b15=$453;
      var $454=$r13;
      var $455=$r13;
      var $456=$455 >>> 8;
      var $457=(((-$456))|0);
      var $458=$454 | $457;
      var $459=$458 & 255;
      $r13=$459;
      var $460=$g14;
      var $461=$g14;
      var $462=$461 >>> 8;
      var $463=(((-$462))|0);
      var $464=$460 | $463;
      var $465=$464 & 255;
      $g14=$465;
      var $466=$b15;
      var $467=$b15;
      var $468=$467 >>> 8;
      var $469=(((-$468))|0);
      var $470=$466 | $469;
      var $471=$470 & 255;
      $b15=$471;
      var $472=$r13;
      var $473=$472 << 16;
      var $474=$g14;
      var $475=$474 << 8;
      var $476=$473 | $475;
      var $477=$b15;
      var $478=$477 << 0;
      var $479=$476 | $478;
      var $480=$dest7;
      HEAP32[(($480)>>2)]=$479;
      __label__ = 51; break;
    case 51: // $481
      var $482=$dest7;
      var $483=(($482+4)|0);
      $dest7=$483;
      var $484=$dudx;
      var $485=$curu8;
      var $486=(($485+$484)|0);
      $curu8=$486;
      var $487=$dvdx;
      var $488=$curv9;
      var $489=(($488+$487)|0);
      $curv9=$489;
      __label__ = 52; break;
    case 52: // $490
      var $491=$x;
      var $492=(($491+1)|0);
      $x=$492;
      __label__ = 48; break;
    case 53: // $493
      __label__ = 61; break;
    case 54: // $494
      var $495=$4;
      var $496=(($495+24)|0);
      var $497=HEAP32[(($496)>>2)];
      $x=$497;
      __label__ = 55; break;
    case 55: // $498
      var $499=$x;
      var $500=$endx;
      var $501=(($499)|0) < (($500)|0);
      if ($501) { __label__ = 56; break; } else { __label__ = 60; break; }
    case 56: // $502
      var $503=$1;
      var $504=(($503+44)|0);
      var $505=$curu8;
      var $506=$curv9;
      var $507=__ZL25get_texel_argb32_bilinearPK14render_texinfoii($504, $505, $506);
      $pix16=$507;
      var $508=$pix16;
      var $509=$508 >>> 24;
      var $510=$sa;
      var $511=(($509*$510)|0);
      $ta17=$511;
      var $512=$ta17;
      var $513=(($512)|0)!=0;
      if ($513) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $514
      var $515=$dest7;
      var $516=HEAP32[(($515)>>2)];
      $dpix18=$516;
      var $517=$pix16;
      var $518=$517 >>> 16;
      var $519=$518 & 255;
      var $520=$palbase;
      var $521=(($520+($519<<2))|0);
      var $522=HEAP32[(($521)>>2)];
      var $523=$sr;
      var $524=(($522*$523)|0);
      var $525=$ta17;
      var $526=(($524*$525)|0);
      var $527=$526 >>> 24;
      var $528=$dpix18;
      var $529=$528 >>> 16;
      var $530=$529 & 255;
      var $531=(($527+$530)|0);
      $r19=$531;
      var $532=$pix16;
      var $533=$532 >>> 8;
      var $534=$533 & 255;
      var $535=$palbase;
      var $536=(($535+($534<<2))|0);
      var $537=HEAP32[(($536)>>2)];
      var $538=$sr;
      var $539=(($537*$538)|0);
      var $540=$ta17;
      var $541=(($539*$540)|0);
      var $542=$541 >>> 24;
      var $543=$dpix18;
      var $544=$543 >>> 8;
      var $545=$544 & 255;
      var $546=(($542+$545)|0);
      $g20=$546;
      var $547=$pix16;
      var $548=$547 >>> 0;
      var $549=$548 & 255;
      var $550=$palbase;
      var $551=(($550+($549<<2))|0);
      var $552=HEAP32[(($551)>>2)];
      var $553=$sr;
      var $554=(($552*$553)|0);
      var $555=$ta17;
      var $556=(($554*$555)|0);
      var $557=$556 >>> 24;
      var $558=$dpix18;
      var $559=$558 >>> 0;
      var $560=$559 & 255;
      var $561=(($557+$560)|0);
      $b21=$561;
      var $562=$r19;
      var $563=$r19;
      var $564=$563 >>> 8;
      var $565=(((-$564))|0);
      var $566=$562 | $565;
      var $567=$566 & 255;
      $r19=$567;
      var $568=$g20;
      var $569=$g20;
      var $570=$569 >>> 8;
      var $571=(((-$570))|0);
      var $572=$568 | $571;
      var $573=$572 & 255;
      $g20=$573;
      var $574=$b21;
      var $575=$b21;
      var $576=$575 >>> 8;
      var $577=(((-$576))|0);
      var $578=$574 | $577;
      var $579=$578 & 255;
      $b21=$579;
      var $580=$r19;
      var $581=$580 << 16;
      var $582=$g20;
      var $583=$582 << 8;
      var $584=$581 | $583;
      var $585=$b21;
      var $586=$585 << 0;
      var $587=$584 | $586;
      var $588=$dest7;
      HEAP32[(($588)>>2)]=$587;
      __label__ = 58; break;
    case 58: // $589
      var $590=$dest7;
      var $591=(($590+4)|0);
      $dest7=$591;
      var $592=$dudx;
      var $593=$curu8;
      var $594=(($593+$592)|0);
      $curu8=$594;
      var $595=$dvdx;
      var $596=$curv9;
      var $597=(($596+$595)|0);
      $curv9=$597;
      __label__ = 59; break;
    case 59: // $598
      var $599=$x;
      var $600=(($599+1)|0);
      $x=$600;
      __label__ = 55; break;
    case 60: // $601
      __label__ = 61; break;
    case 61: // $602
      __label__ = 62; break;
    case 62: // $603
      var $604=$y;
      var $605=(($604+1)|0);
      $y=$605;
      __label__ = 45; break;
    case 63: // $606
      __label__ = 64; break;
    case 64: // $607
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27rgb888_draw_quad_argb32_addPK16render_primitivePvjP16_quad_setup_data["X"]=1;

function __ZL20rgba_bilinear_filterjjjjhh($rgb00, $rgb01, $rgb10, $rgb11, $u, $v) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $ag0;
  var $ag1;
  var $rb0;
  var $rb1;
  $1=$rgb00;
  $2=$rgb01;
  $3=$rgb10;
  $4=$rgb11;
  $5=$u;
  $6=$v;
  var $7=$1;
  var $8=$7 & 16711935;
  var $9=$2;
  var $10=$9 & 16711935;
  var $11=$1;
  var $12=$11 & 16711935;
  var $13=(($10-$12)|0);
  var $14=$5;
  var $15=(($14)&255);
  var $16=(($13*$15)|0);
  var $17=$16 >>> 8;
  var $18=(($8+$17)|0);
  $rb0=$18;
  var $19=$3;
  var $20=$19 & 16711935;
  var $21=$4;
  var $22=$21 & 16711935;
  var $23=$3;
  var $24=$23 & 16711935;
  var $25=(($22-$24)|0);
  var $26=$5;
  var $27=(($26)&255);
  var $28=(($25*$27)|0);
  var $29=$28 >>> 8;
  var $30=(($20+$29)|0);
  $rb1=$30;
  var $31=$1;
  var $32=$31 >>> 8;
  $1=$32;
  var $33=$2;
  var $34=$33 >>> 8;
  $2=$34;
  var $35=$3;
  var $36=$35 >>> 8;
  $3=$36;
  var $37=$4;
  var $38=$37 >>> 8;
  $4=$38;
  var $39=$1;
  var $40=$39 & 16711935;
  var $41=$2;
  var $42=$41 & 16711935;
  var $43=$1;
  var $44=$43 & 16711935;
  var $45=(($42-$44)|0);
  var $46=$5;
  var $47=(($46)&255);
  var $48=(($45*$47)|0);
  var $49=$48 >>> 8;
  var $50=(($40+$49)|0);
  $ag0=$50;
  var $51=$3;
  var $52=$51 & 16711935;
  var $53=$4;
  var $54=$53 & 16711935;
  var $55=$3;
  var $56=$55 & 16711935;
  var $57=(($54-$56)|0);
  var $58=$5;
  var $59=(($58)&255);
  var $60=(($57*$59)|0);
  var $61=$60 >>> 8;
  var $62=(($52+$61)|0);
  $ag1=$62;
  var $63=$rb0;
  var $64=$63 & 16711935;
  var $65=$rb1;
  var $66=$65 & 16711935;
  var $67=$rb0;
  var $68=$67 & 16711935;
  var $69=(($66-$68)|0);
  var $70=$6;
  var $71=(($70)&255);
  var $72=(($69*$71)|0);
  var $73=$72 >>> 8;
  var $74=(($64+$73)|0);
  $rb0=$74;
  var $75=$ag0;
  var $76=$75 & 16711935;
  var $77=$ag1;
  var $78=$77 & 16711935;
  var $79=$ag0;
  var $80=$79 & 16711935;
  var $81=(($78-$80)|0);
  var $82=$6;
  var $83=(($82)&255);
  var $84=(($81*$83)|0);
  var $85=$84 >>> 8;
  var $86=(($76+$85)|0);
  $ag0=$86;
  var $87=$ag0;
  var $88=$87 << 8;
  var $89=$88 & -16711936;
  var $90=$rb0;
  var $91=$90 & 16711935;
  var $92=$89 | $91;
  ;
  return $92;
}
__ZL20rgba_bilinear_filterjjjjhh["X"]=1;

function __ZL19rgb_bilinear_filterjjjjhh($rgb00, $rgb01, $rgb10, $rgb11, $u, $v) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $ag0;
  var $ag1;
  var $rb0;
  var $rb1;
  $1=$rgb00;
  $2=$rgb01;
  $3=$rgb10;
  $4=$rgb11;
  $5=$u;
  $6=$v;
  var $7=$1;
  var $8=$7 & 16711935;
  var $9=$2;
  var $10=$9 & 16711935;
  var $11=$1;
  var $12=$11 & 16711935;
  var $13=(($10-$12)|0);
  var $14=$5;
  var $15=(($14)&255);
  var $16=(($13*$15)|0);
  var $17=$16 >>> 8;
  var $18=(($8+$17)|0);
  $rb0=$18;
  var $19=$3;
  var $20=$19 & 16711935;
  var $21=$4;
  var $22=$21 & 16711935;
  var $23=$3;
  var $24=$23 & 16711935;
  var $25=(($22-$24)|0);
  var $26=$5;
  var $27=(($26)&255);
  var $28=(($25*$27)|0);
  var $29=$28 >>> 8;
  var $30=(($20+$29)|0);
  $rb1=$30;
  var $31=$1;
  var $32=$31 & 65280;
  var $33=$2;
  var $34=$33 & 65280;
  var $35=$1;
  var $36=$35 & 65280;
  var $37=(($34-$36)|0);
  var $38=$5;
  var $39=(($38)&255);
  var $40=(($37*$39)|0);
  var $41=$40 >>> 8;
  var $42=(($32+$41)|0);
  $ag0=$42;
  var $43=$3;
  var $44=$43 & 65280;
  var $45=$4;
  var $46=$45 & 65280;
  var $47=$3;
  var $48=$47 & 65280;
  var $49=(($46-$48)|0);
  var $50=$5;
  var $51=(($50)&255);
  var $52=(($49*$51)|0);
  var $53=$52 >>> 8;
  var $54=(($44+$53)|0);
  $ag1=$54;
  var $55=$rb0;
  var $56=$55 & 16711935;
  var $57=$rb1;
  var $58=$57 & 16711935;
  var $59=$rb0;
  var $60=$59 & 16711935;
  var $61=(($58-$60)|0);
  var $62=$6;
  var $63=(($62)&255);
  var $64=(($61*$63)|0);
  var $65=$64 >>> 8;
  var $66=(($56+$65)|0);
  $rb0=$66;
  var $67=$ag0;
  var $68=$67 & 65280;
  var $69=$ag1;
  var $70=$69 & 65280;
  var $71=$ag0;
  var $72=$71 & 65280;
  var $73=(($70-$72)|0);
  var $74=$6;
  var $75=(($74)&255);
  var $76=(($73*$75)|0);
  var $77=$76 >>> 8;
  var $78=(($68+$77)|0);
  $ag0=$78;
  var $79=$ag0;
  var $80=$79 & 65280;
  var $81=$rb0;
  var $82=$81 & 16711935;
  var $83=$80 | $82;
  ;
  return $83;
}
__ZL19rgb_bilinear_filterjjjjhh["X"]=1;

function __ZL25get_texel_argb32_bilinearPK14render_texinfoii($texture, $curu, $curv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $texbase;
      var $pix00;
      var $pix01;
      var $pix10;
      var $pix11;
      var $u0;
      var $u1;
      var $v0;
      var $v1;
      $1=$texture;
      $2=$curu;
      $3=$curv;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $texbase=$7;
      var $8=$2;
      var $9=$8 >> 16;
      $u0=$9;
      $u1=1;
      var $10=$u0;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $u1=0;
      $u0=0;
      __label__ = 5; break;
    case 2: // $13
      var $14=$u0;
      var $15=(($14+1)|0);
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($15)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      $u0=$24;
      $u1=0;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$27 >> 16;
      $v0=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $v1=$31;
      var $32=$v0;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $v1=0;
      $v0=0;
      __label__ = 10; break;
    case 7: // $35
      var $36=$v0;
      var $37=(($36+1)|0);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($37)>>>0) >= (($40)>>>0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      $v0=$46;
      $v1=0;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      var $49=$v0;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49*$52)|0);
      var $54=$u0;
      var $55=(($53+$54)|0);
      var $56=$texbase;
      var $57=(($56+($55<<2))|0);
      $texbase=$57;
      var $58=$texbase;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      $pix00=$60;
      var $61=$u1;
      var $62=$texbase;
      var $63=(($62+($61<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      $pix01=$64;
      var $65=$v1;
      var $66=$texbase;
      var $67=(($66+($65<<2))|0);
      var $68=HEAP32[(($67)>>2)];
      $pix10=$68;
      var $69=$u1;
      var $70=$v1;
      var $71=(($69+$70)|0);
      var $72=$texbase;
      var $73=(($72+($71<<2))|0);
      var $74=HEAP32[(($73)>>2)];
      $pix11=$74;
      var $75=$pix00;
      var $76=$pix01;
      var $77=$pix10;
      var $78=$pix11;
      var $79=$2;
      var $80=$79 >> 8;
      var $81=(($80) & 255);
      var $82=$3;
      var $83=$82 >> 8;
      var $84=(($83) & 255);
      var $85=__ZL20rgba_bilinear_filterjjjjhh($75, $76, $77, $78, $81, $84);
      ;
      return $85;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25get_texel_argb32_bilinearPK14render_texinfoii["X"]=1;

function __ZL24get_texel_rgb32_bilinearPK14render_texinfoii($texture, $curu, $curv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $texbase;
      var $pix00;
      var $pix01;
      var $pix10;
      var $pix11;
      var $u0;
      var $u1;
      var $v0;
      var $v1;
      $1=$texture;
      $2=$curu;
      $3=$curv;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $texbase=$7;
      var $8=$2;
      var $9=$8 >> 16;
      $u0=$9;
      $u1=1;
      var $10=$u0;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $u1=0;
      $u0=0;
      __label__ = 5; break;
    case 2: // $13
      var $14=$u0;
      var $15=(($14+1)|0);
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($15)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      $u0=$24;
      $u1=0;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$27 >> 16;
      $v0=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $v1=$31;
      var $32=$v0;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $v1=0;
      $v0=0;
      __label__ = 10; break;
    case 7: // $35
      var $36=$v0;
      var $37=(($36+1)|0);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($37)>>>0) >= (($40)>>>0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      $v0=$46;
      $v1=0;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      var $49=$v0;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49*$52)|0);
      var $54=$u0;
      var $55=(($53+$54)|0);
      var $56=$texbase;
      var $57=(($56+($55<<2))|0);
      $texbase=$57;
      var $58=$texbase;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      $pix00=$60;
      var $61=$u1;
      var $62=$texbase;
      var $63=(($62+($61<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      $pix01=$64;
      var $65=$v1;
      var $66=$texbase;
      var $67=(($66+($65<<2))|0);
      var $68=HEAP32[(($67)>>2)];
      $pix10=$68;
      var $69=$u1;
      var $70=$v1;
      var $71=(($69+$70)|0);
      var $72=$texbase;
      var $73=(($72+($71<<2))|0);
      var $74=HEAP32[(($73)>>2)];
      $pix11=$74;
      var $75=$pix00;
      var $76=$pix01;
      var $77=$pix10;
      var $78=$pix11;
      var $79=$2;
      var $80=$79 >> 8;
      var $81=(($80) & 255);
      var $82=$3;
      var $83=$82 >> 8;
      var $84=(($83) & 255);
      var $85=__ZL19rgb_bilinear_filterjjjjhh($75, $76, $77, $78, $81, $84);
      ;
      return $85;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24get_texel_rgb32_bilinearPK14render_texinfoii["X"]=1;

function __ZL24get_texel_rgb15_bilinearPK14render_texinfoii($texture, $curu, $curv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $texbase;
      var $pix00;
      var $pix01;
      var $pix10;
      var $pix11;
      var $filtered;
      var $u0;
      var $u1;
      var $v0;
      var $v1;
      $1=$texture;
      $2=$curu;
      $3=$curv;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $texbase=$7;
      var $8=$2;
      var $9=$8 >> 16;
      $u0=$9;
      $u1=1;
      var $10=$u0;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $u1=0;
      $u0=0;
      __label__ = 5; break;
    case 2: // $13
      var $14=$u0;
      var $15=(($14+1)|0);
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($15)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      $u0=$24;
      $u1=0;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$27 >> 16;
      $v0=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $v1=$31;
      var $32=$v0;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $v1=0;
      $v0=0;
      __label__ = 10; break;
    case 7: // $35
      var $36=$v0;
      var $37=(($36+1)|0);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($37)>>>0) >= (($40)>>>0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      $v0=$46;
      $v1=0;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      var $49=$v0;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49*$52)|0);
      var $54=$u0;
      var $55=(($53+$54)|0);
      var $56=$texbase;
      var $57=(($56+($55<<1))|0);
      $texbase=$57;
      var $58=$texbase;
      var $59=(($58)|0);
      var $60=HEAPU16[(($59)>>1)];
      var $61=(($60)&65535);
      $pix00=$61;
      var $62=$u1;
      var $63=$texbase;
      var $64=(($63+($62<<1))|0);
      var $65=HEAPU16[(($64)>>1)];
      var $66=(($65)&65535);
      $pix01=$66;
      var $67=$v1;
      var $68=$texbase;
      var $69=(($68+($67<<1))|0);
      var $70=HEAPU16[(($69)>>1)];
      var $71=(($70)&65535);
      $pix10=$71;
      var $72=$u1;
      var $73=$v1;
      var $74=(($72+$73)|0);
      var $75=$texbase;
      var $76=(($75+($74<<1))|0);
      var $77=HEAPU16[(($76)>>1)];
      var $78=(($77)&65535);
      $pix11=$78;
      var $79=$pix00;
      var $80=$79 & 32736;
      var $81=$80 << 6;
      var $82=$pix00;
      var $83=$82 & 31;
      var $84=$81 | $83;
      $pix00=$84;
      var $85=$pix01;
      var $86=$85 & 32736;
      var $87=$86 << 6;
      var $88=$pix01;
      var $89=$88 & 31;
      var $90=$87 | $89;
      $pix01=$90;
      var $91=$pix10;
      var $92=$91 & 32736;
      var $93=$92 << 6;
      var $94=$pix10;
      var $95=$94 & 31;
      var $96=$93 | $95;
      $pix10=$96;
      var $97=$pix11;
      var $98=$97 & 32736;
      var $99=$98 << 6;
      var $100=$pix11;
      var $101=$100 & 31;
      var $102=$99 | $101;
      $pix11=$102;
      var $103=$pix00;
      var $104=$pix01;
      var $105=$pix10;
      var $106=$pix11;
      var $107=$2;
      var $108=$107 >> 8;
      var $109=(($108) & 255);
      var $110=$3;
      var $111=$110 >> 8;
      var $112=(($111) & 255);
      var $113=__ZL19rgb_bilinear_filterjjjjhh($103, $104, $105, $106, $109, $112);
      $filtered=$113;
      var $114=$filtered;
      var $115=$114 & 31;
      var $116=$filtered;
      var $117=$116 & 2095104;
      var $118=$117 >>> 6;
      var $119=$115 | $118;
      ;
      return $119;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24get_texel_rgb15_bilinearPK14render_texinfoii["X"]=1;

function __ZL10ycc_to_rgbj($ycc) {
  ;
  var __label__;

  var $1;
  var $y;
  var $cb;
  var $cr;
  var $r;
  var $g;
  var $b;
  var $common;
  $1=$ycc;
  var $2=$1;
  var $3=(($2) & 255);
  $y=$3;
  var $4=$1;
  var $5=$4 >>> 8;
  var $6=(($5) & 255);
  $cb=$6;
  var $7=$1;
  var $8=$7 >>> 16;
  var $9=(($8) & 255);
  $cr=$9;
  var $10=$y;
  var $11=(($10)&255);
  var $12=(($11*298)|0);
  var $13=(($12-56992)|0);
  $common=$13;
  var $14=$common;
  var $15=$cr;
  var $16=(($15)&255);
  var $17=(($16*409)|0);
  var $18=(($14+$17)|0);
  $r=$18;
  var $19=$common;
  var $20=$cb;
  var $21=(($20)&255);
  var $22=(($21*100)|0);
  var $23=(($19-$22)|0);
  var $24=$cr;
  var $25=(($24)&255);
  var $26=(($25*208)|0);
  var $27=(($23-$26)|0);
  var $28=(($27+91776)|0);
  $g=$28;
  var $29=$common;
  var $30=$cb;
  var $31=(($30)&255);
  var $32=(($31*516)|0);
  var $33=(($29+$32)|0);
  var $34=(($33-13696)|0);
  $b=$34;
  var $35=$r;
  var $36=__ZL14clamp16_shift8j($35);
  var $37=(($36)&255);
  var $38=$37 & 255;
  var $39=$38 << 16;
  var $40=-16777216 | $39;
  var $41=$g;
  var $42=__ZL14clamp16_shift8j($41);
  var $43=(($42)&255);
  var $44=$43 & 255;
  var $45=$44 << 8;
  var $46=$40 | $45;
  var $47=$b;
  var $48=__ZL14clamp16_shift8j($47);
  var $49=(($48)&255);
  var $50=$49 & 255;
  var $51=$46 | $50;
  ;
  return $51;
}
__ZL10ycc_to_rgbj["X"]=1;

function __ZL14clamp16_shift8j($x) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$x;
      var $2=$1;
      var $3=(($2)|0) < 0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $15 = 0;__label__ = 6; break;
    case 2: // $5
      var $6=$1;
      var $7=(($6)>>>0) > 65535;
      if ($7) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $8
      var $13 = 255;__label__ = 5; break;
    case 4: // $9
      var $10=$1;
      var $11=$10 >>> 8;
      var $13 = $11;__label__ = 5; break;
    case 5: // $12
      var $13;
      var $15 = $13;__label__ = 6; break;
    case 6: // $14
      var $15;
      var $16=(($15) & 255);
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15div_32x32_shiftiih4901($a, $b, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$a;
  $2=$b;
  $3=$shift;
  var $4=$1;
  var $5$0=$4;
  var $5$1=(($4|0) < 0 ? -1 : 0);
  var $6=$3;
  var $7=(($6)&255);
  var $8$0=$7;
  var $8$1=0;
  var $9=Runtime.bitshift64($5$0, $5$1,"shl",$8$0);var $9$0 = $9[0], $9$1 = $9[1];
  var $10=$2;
  var $11$0=$10;
  var $11$1=(($10|0) < 0 ? -1 : 0);
  var $12$0 = (tempBigIntR=((($9$0)>>>0)+((($9$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $12$1 = Math.min(Math.floor(((tempBigIntR=((($9$0)>>>0)+((($9$1)|0)*4294967296))/((($11$0)>>>0)+((($11$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $13$0=$12$0;
  var $13=$13$0;
  ;
  return $13;
}


function __ZL12mul_32x32_hiii4902($a, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$a;
  $2=$b;
  var $3=$1;
  var $4$0=$3;
  var $4$1=(($3|0) < 0 ? -1 : 0);
  var $5=$2;
  var $6$0=$5;
  var $6$1=(($5|0) < 0 ? -1 : 0);
  var $7$0 = ((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($4$0)>>>0)+((($4$1)|0)*4294967296))*((($6$0)>>>0)+((($6$1)|0)*4294967296)))/4294967296), 4294967295);
  var $8$0=$7$1;
  var $8$1=(($7$1|0) < 0 ? -1 : 0);
  var $9$0=$8$0;
  var $9=$9$0;
  ;
  return $9;
}


function __ZN9hash_base7fromhexEc($this, $c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$c;
      var $4=$2;
      var $5=$3;
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0) >= 48;
      if ($7) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0) <= 57;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$3;
      var $14=(($13 << 24) >> 24);
      var $15=(($14-48)|0);
      $1=$15;
      __label__ = 10; break;
    case 3: // $16
      var $17=$3;
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0) >= 65;
      if ($19) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $20
      var $21=$3;
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0) <= 70;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$3;
      var $26=(($25 << 24) >> 24);
      var $27=(($26-65)|0);
      var $28=(($27+10)|0);
      $1=$28;
      __label__ = 10; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30 << 24) >> 24);
      var $32=(($31)|0) >= 97;
      if ($32) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $33
      var $34=$3;
      var $35=(($34 << 24) >> 24);
      var $36=(($35)|0) <= 102;
      if ($36) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $37
      var $38=$3;
      var $39=(($38 << 24) >> 24);
      var $40=(($39-97)|0);
      var $41=(($40+10)|0);
      $1=$41;
      __label__ = 10; break;
    case 9: // $42
      $1=-1;
      __label__ = 10; break;
    case 10: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9hash_base7fromhexEc["X"]=1;

function __ZL20rgb888_draw_aa_pixelPvjiij($dstdata, $pitch, $x, $y, $col) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $dpix;
  var $dr;
  var $dg;
  var $db;
  var $dest;
  $1=$dstdata;
  $2=$pitch;
  $3=$x;
  $4=$y;
  $5=$col;
  var $6=$1;
  var $7=$6;
  var $8=$4;
  var $9=$2;
  var $10=(($8*$9)|0);
  var $11=(($7+($10<<2))|0);
  var $12=$3;
  var $13=(($11+($12<<2))|0);
  $dest=$13;
  var $14=$dest;
  var $15=HEAP32[(($14)>>2)];
  $dpix=$15;
  var $16=$5;
  var $17=$16 >>> 16;
  var $18=$17 & 255;
  var $19=$dpix;
  var $20=$19 >>> 16;
  var $21=$20 & 255;
  var $22=(($18+$21)|0);
  $dr=$22;
  var $23=$5;
  var $24=$23 >>> 8;
  var $25=$24 & 255;
  var $26=$dpix;
  var $27=$26 >>> 8;
  var $28=$27 & 255;
  var $29=(($25+$28)|0);
  $dg=$29;
  var $30=$5;
  var $31=$30 >>> 0;
  var $32=$31 & 255;
  var $33=$dpix;
  var $34=$33 >>> 0;
  var $35=$34 & 255;
  var $36=(($32+$35)|0);
  $db=$36;
  var $37=$dr;
  var $38=$dr;
  var $39=$38 >>> 8;
  var $40=(((-$39))|0);
  var $41=$37 | $40;
  var $42=$41 & 255;
  $dr=$42;
  var $43=$dg;
  var $44=$dg;
  var $45=$44 >>> 8;
  var $46=(((-$45))|0);
  var $47=$43 | $46;
  var $48=$47 & 255;
  $dg=$48;
  var $49=$db;
  var $50=$db;
  var $51=$50 >>> 8;
  var $52=(((-$51))|0);
  var $53=$49 | $52;
  var $54=$53 & 255;
  $db=$54;
  var $55=$dr;
  var $56=$55 << 16;
  var $57=$dg;
  var $58=$57 << 8;
  var $59=$56 | $58;
  var $60=$db;
  var $61=$60 << 0;
  var $62=$59 | $61;
  var $63=$dest;
  HEAP32[(($63)>>2)]=$62;
  ;
  return;
}
__ZL20rgb888_draw_aa_pixelPvjiij["X"]=1;

function __ZN19render_layer_config26set_screen_overlay_enabledEb($this, $enable) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($enable)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($4)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 | 64;
      var $12=(($11) & 255);
      HEAP8[($8)]=$12;
      __label__ = 3; break;
    case 2: // $13
      var $14=(($4)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$16 & -65;
      var $18=(($17) & 255);
      HEAP8[($14)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return $4;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL24get_texel_yuy16_bilinearPK14render_texinfoii($texture, $curu, $curv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $texbase;
      var $pix00;
      var $pix01;
      var $pix10;
      var $pix11;
      var $u0;
      var $u1;
      var $v0;
      var $v1;
      var $cbcr;
      var $cbcr1;
      $1=$texture;
      $2=$curu;
      $3=$curv;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $texbase=$7;
      var $8=$2;
      var $9=$8 >> 16;
      $u0=$9;
      $u1=1;
      var $10=$u0;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $u1=0;
      $u0=0;
      __label__ = 5; break;
    case 2: // $13
      var $14=$u0;
      var $15=(($14+1)|0);
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($15)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      $u0=$24;
      $u1=0;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$27 >> 16;
      $v0=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $v1=$31;
      var $32=$v0;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $v1=0;
      $v0=0;
      __label__ = 10; break;
    case 7: // $35
      var $36=$v0;
      var $37=(($36+1)|0);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($37)>>>0) >= (($40)>>>0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      $v0=$46;
      $v1=0;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      var $49=$v0;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49*$52)|0);
      var $54=$u0;
      var $55=$54 & -2;
      var $56=(($53+$55)|0);
      var $57=$texbase;
      var $58=(($57+($56<<1))|0);
      $texbase=$58;
      var $59=$2;
      var $60=$59 & 65536;
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      var $63=$texbase;
      var $64=(($63)|0);
      var $65=HEAPU16[(($64)>>1)];
      var $66=(($65)&65535);
      var $67=$66 & 255;
      var $68=$67 << 8;
      var $69=$texbase;
      var $70=(($69+2)|0);
      var $71=HEAPU16[(($70)>>1)];
      var $72=(($71)&65535);
      var $73=$72 & 255;
      var $74=$73 << 16;
      var $75=$68 | $74;
      $cbcr=$75;
      var $76=$texbase;
      var $77=(($76)|0);
      var $78=HEAPU16[(($77)>>1)];
      var $79=(($78)&65535);
      var $80=$79 >> 8;
      var $81=$cbcr;
      var $82=$80 | $81;
      $pix00=$82;
      var $83=$u1;
      var $84=$texbase;
      var $85=(($84+($83<<1))|0);
      var $86=HEAPU16[(($85)>>1)];
      var $87=(($86)&65535);
      var $88=$87 >> 8;
      var $89=$cbcr;
      var $90=$88 | $89;
      $pix01=$90;
      var $91=$v1;
      var $92=(($91)|0);
      var $93=$texbase;
      var $94=(($93+($92<<1))|0);
      var $95=HEAPU16[(($94)>>1)];
      var $96=(($95)&65535);
      var $97=$96 & 255;
      var $98=$97 << 8;
      var $99=$v1;
      var $100=(($99+1)|0);
      var $101=$texbase;
      var $102=(($101+($100<<1))|0);
      var $103=HEAPU16[(($102)>>1)];
      var $104=(($103)&65535);
      var $105=$104 & 255;
      var $106=$105 << 16;
      var $107=$98 | $106;
      $cbcr=$107;
      var $108=$v1;
      var $109=(($108)|0);
      var $110=$texbase;
      var $111=(($110+($109<<1))|0);
      var $112=HEAPU16[(($111)>>1)];
      var $113=(($112)&65535);
      var $114=$113 >> 8;
      var $115=$cbcr;
      var $116=$114 | $115;
      $pix10=$116;
      var $117=$v1;
      var $118=$u1;
      var $119=(($117+$118)|0);
      var $120=$texbase;
      var $121=(($120+($119<<1))|0);
      var $122=HEAPU16[(($121)>>1)];
      var $123=(($122)&65535);
      var $124=$123 >> 8;
      var $125=$cbcr;
      var $126=$124 | $125;
      $pix11=$126;
      __label__ = 19; break;
    case 12: // $127
      var $128=$texbase;
      var $129=(($128)|0);
      var $130=HEAPU16[(($129)>>1)];
      var $131=(($130)&65535);
      var $132=$131 & 255;
      var $133=$132 << 8;
      var $134=$texbase;
      var $135=(($134+2)|0);
      var $136=HEAPU16[(($135)>>1)];
      var $137=(($136)&65535);
      var $138=$137 & 255;
      var $139=$138 << 16;
      var $140=$133 | $139;
      $cbcr1=$140;
      var $141=$texbase;
      var $142=(($141+2)|0);
      var $143=HEAPU16[(($142)>>1)];
      var $144=(($143)&65535);
      var $145=$144 >> 8;
      var $146=$cbcr1;
      var $147=$145 | $146;
      $pix00=$147;
      var $148=$u1;
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $150
      var $151=$texbase;
      var $152=(($151+4)|0);
      var $153=HEAPU16[(($152)>>1)];
      var $154=(($153)&65535);
      var $155=$154 & 255;
      var $156=$155 << 8;
      var $157=$texbase;
      var $158=(($157+6)|0);
      var $159=HEAPU16[(($158)>>1)];
      var $160=(($159)&65535);
      var $161=$160 & 255;
      var $162=$161 << 16;
      var $163=$156 | $162;
      $cbcr1=$163;
      var $164=$texbase;
      var $165=(($164+4)|0);
      var $166=HEAPU16[(($165)>>1)];
      var $167=(($166)&65535);
      var $168=$167 >> 8;
      var $169=$cbcr1;
      var $170=$168 | $169;
      $pix01=$170;
      __label__ = 15; break;
    case 14: // $171
      var $172=$pix00;
      $pix01=$172;
      __label__ = 15; break;
    case 15: // $173
      var $174=$v1;
      var $175=(($174)|0);
      var $176=$texbase;
      var $177=(($176+($175<<1))|0);
      var $178=HEAPU16[(($177)>>1)];
      var $179=(($178)&65535);
      var $180=$179 & 255;
      var $181=$180 << 8;
      var $182=$v1;
      var $183=(($182+1)|0);
      var $184=$texbase;
      var $185=(($184+($183<<1))|0);
      var $186=HEAPU16[(($185)>>1)];
      var $187=(($186)&65535);
      var $188=$187 & 255;
      var $189=$188 << 16;
      var $190=$181 | $189;
      $cbcr1=$190;
      var $191=$v1;
      var $192=(($191+1)|0);
      var $193=$texbase;
      var $194=(($193+($192<<1))|0);
      var $195=HEAPU16[(($194)>>1)];
      var $196=(($195)&65535);
      var $197=$196 >> 8;
      var $198=$cbcr1;
      var $199=$197 | $198;
      $pix10=$199;
      var $200=$u1;
      var $201=(($200)|0)!=0;
      if ($201) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $202
      var $203=$v1;
      var $204=(($203+2)|0);
      var $205=$texbase;
      var $206=(($205+($204<<1))|0);
      var $207=HEAPU16[(($206)>>1)];
      var $208=(($207)&65535);
      var $209=$208 & 255;
      var $210=$209 << 8;
      var $211=$v1;
      var $212=(($211+3)|0);
      var $213=$texbase;
      var $214=(($213+($212<<1))|0);
      var $215=HEAPU16[(($214)>>1)];
      var $216=(($215)&65535);
      var $217=$216 & 255;
      var $218=$217 << 16;
      var $219=$210 | $218;
      $cbcr1=$219;
      var $220=$v1;
      var $221=(($220+2)|0);
      var $222=$texbase;
      var $223=(($222+($221<<1))|0);
      var $224=HEAPU16[(($223)>>1)];
      var $225=(($224)&65535);
      var $226=$225 >> 8;
      var $227=$cbcr1;
      var $228=$226 | $227;
      $pix11=$228;
      __label__ = 18; break;
    case 17: // $229
      var $230=$pix10;
      $pix11=$230;
      __label__ = 18; break;
    case 18: // $231
      __label__ = 19; break;
    case 19: // $232
      var $233=$pix00;
      var $234=$pix01;
      var $235=$pix10;
      var $236=$pix11;
      var $237=$2;
      var $238=$237 >> 8;
      var $239=(($238) & 255);
      var $240=$3;
      var $241=$240 >> 8;
      var $242=(($241) & 255);
      var $243=__ZL19rgb_bilinear_filterjjjjhh($233, $234, $235, $236, $239, $242);
      ;
      return $243;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24get_texel_yuy16_bilinearPK14render_texinfoii["X"]=1;

function __ZL29get_texel_palette16a_bilinearPK14render_texinfoii($texture, $curu, $curv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $texbase;
      var $pix00;
      var $pix01;
      var $pix10;
      var $pix11;
      var $u0;
      var $u1;
      var $v0;
      var $v1;
      $1=$texture;
      $2=$curu;
      $3=$curv;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $texbase=$7;
      var $8=$2;
      var $9=$8 >> 16;
      $u0=$9;
      $u1=1;
      var $10=$u0;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $u1=0;
      $u0=0;
      __label__ = 5; break;
    case 2: // $13
      var $14=$u0;
      var $15=(($14+1)|0);
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($15)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      $u0=$24;
      $u1=0;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$27 >> 16;
      $v0=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $v1=$31;
      var $32=$v0;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $v1=0;
      $v0=0;
      __label__ = 10; break;
    case 7: // $35
      var $36=$v0;
      var $37=(($36+1)|0);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($37)>>>0) >= (($40)>>>0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      $v0=$46;
      $v1=0;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      var $49=$v0;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49*$52)|0);
      var $54=$u0;
      var $55=(($53+$54)|0);
      var $56=$texbase;
      var $57=(($56+($55<<1))|0);
      $texbase=$57;
      var $58=$texbase;
      var $59=(($58)|0);
      var $60=HEAPU16[(($59)>>1)];
      var $61=(($60)&65535);
      var $62=$1;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+($61<<2))|0);
      var $66=HEAP32[(($65)>>2)];
      $pix00=$66;
      var $67=$u1;
      var $68=$texbase;
      var $69=(($68+($67<<1))|0);
      var $70=HEAPU16[(($69)>>1)];
      var $71=(($70)&65535);
      var $72=$1;
      var $73=(($72+16)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+($71<<2))|0);
      var $76=HEAP32[(($75)>>2)];
      $pix01=$76;
      var $77=$v1;
      var $78=$texbase;
      var $79=(($78+($77<<1))|0);
      var $80=HEAPU16[(($79)>>1)];
      var $81=(($80)&65535);
      var $82=$1;
      var $83=(($82+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+($81<<2))|0);
      var $86=HEAP32[(($85)>>2)];
      $pix10=$86;
      var $87=$u1;
      var $88=$v1;
      var $89=(($87+$88)|0);
      var $90=$texbase;
      var $91=(($90+($89<<1))|0);
      var $92=HEAPU16[(($91)>>1)];
      var $93=(($92)&65535);
      var $94=$1;
      var $95=(($94+16)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+($93<<2))|0);
      var $98=HEAP32[(($97)>>2)];
      $pix11=$98;
      var $99=$pix00;
      var $100=$pix01;
      var $101=$pix10;
      var $102=$pix11;
      var $103=$2;
      var $104=$103 >> 8;
      var $105=(($104) & 255);
      var $106=$3;
      var $107=$106 >> 8;
      var $108=(($107) & 255);
      var $109=__ZL20rgba_bilinear_filterjjjjhh($99, $100, $101, $102, $105, $108);
      ;
      return $109;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29get_texel_palette16a_bilinearPK14render_texinfoii["X"]=1;

function __ZL28get_texel_palette16_bilinearPK14render_texinfoii($texture, $curu, $curv) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $texbase;
      var $pix00;
      var $pix01;
      var $pix10;
      var $pix11;
      var $u0;
      var $u1;
      var $v0;
      var $v1;
      $1=$texture;
      $2=$curu;
      $3=$curv;
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $texbase=$7;
      var $8=$2;
      var $9=$8 >> 16;
      $u0=$9;
      $u1=1;
      var $10=$u0;
      var $11=(($10)|0) < 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $u1=0;
      $u0=0;
      __label__ = 5; break;
    case 2: // $13
      var $14=$u0;
      var $15=(($14+1)|0);
      var $16=$1;
      var $17=(($16+8)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($15)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$1;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-1)|0);
      $u0=$24;
      $u1=0;
      __label__ = 4; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$27 >> 16;
      $v0=$28;
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      $v1=$31;
      var $32=$v0;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $v1=0;
      $v0=0;
      __label__ = 10; break;
    case 7: // $35
      var $36=$v0;
      var $37=(($36+1)|0);
      var $38=$1;
      var $39=(($38+12)|0);
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($37)>>>0) >= (($40)>>>0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      $v0=$46;
      $v1=0;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      var $49=$v0;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49*$52)|0);
      var $54=$u0;
      var $55=(($53+$54)|0);
      var $56=$texbase;
      var $57=(($56+($55<<1))|0);
      $texbase=$57;
      var $58=$texbase;
      var $59=(($58)|0);
      var $60=HEAPU16[(($59)>>1)];
      var $61=(($60)&65535);
      var $62=$1;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+($61<<2))|0);
      var $66=HEAP32[(($65)>>2)];
      $pix00=$66;
      var $67=$u1;
      var $68=$texbase;
      var $69=(($68+($67<<1))|0);
      var $70=HEAPU16[(($69)>>1)];
      var $71=(($70)&65535);
      var $72=$1;
      var $73=(($72+16)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+($71<<2))|0);
      var $76=HEAP32[(($75)>>2)];
      $pix01=$76;
      var $77=$v1;
      var $78=$texbase;
      var $79=(($78+($77<<1))|0);
      var $80=HEAPU16[(($79)>>1)];
      var $81=(($80)&65535);
      var $82=$1;
      var $83=(($82+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+($81<<2))|0);
      var $86=HEAP32[(($85)>>2)];
      $pix10=$86;
      var $87=$u1;
      var $88=$v1;
      var $89=(($87+$88)|0);
      var $90=$texbase;
      var $91=(($90+($89<<1))|0);
      var $92=HEAPU16[(($91)>>1)];
      var $93=(($92)&65535);
      var $94=$1;
      var $95=(($94+16)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+($93<<2))|0);
      var $98=HEAP32[(($97)>>2)];
      $pix11=$98;
      var $99=$pix00;
      var $100=$pix01;
      var $101=$pix10;
      var $102=$pix11;
      var $103=$2;
      var $104=$103 >> 8;
      var $105=(($104) & 255);
      var $106=$3;
      var $107=$106 >> 8;
      var $108=(($107) & 255);
      var $109=__ZL19rgb_bilinear_filterjjjjhh($99, $100, $101, $102, $105, $108);
      ;
      return $109;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL28get_texel_palette16_bilinearPK14render_texinfoii["X"]=1;

function __ZNK11emu_options5speedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options11float_valueEPKc($3, ((STRING_TABLE.__str394873)|0));
  ;
  return $4;
}


function __ZN9hash_baseC2EcPKchPh($this, $id, $name, $length, $bufptr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$id;
  $3=$name;
  $4=$length;
  $5=$bufptr;
  var $6=$1;
  var $7=$6;
  HEAP32[(($7)>>2)]=((__ZTV9hash_base+8)|0);
  var $8=(($6+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($6+8)|0);
  var $10=$3;
  HEAP32[(($9)>>2)]=$10;
  var $11=(($6+12)|0);
  HEAP8[($11)]=0;
  var $12=(($6+13)|0);
  HEAP8[($12)]=0;
  var $13=(($6+14)|0);
  var $14=$2;
  HEAP8[($13)]=$14;
  var $15=(($6+15)|0);
  var $16=$4;
  HEAP8[($15)]=$16;
  var $17=(($6+16)|0);
  var $18=$5;
  HEAP32[(($17)>>2)]=$18;
  var $19=(($6+16)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$4;
  var $22=(($21)&255);
  _memset($20, 0, $22, 1);
  ;
  return;
}


function __ZN9hash_base11from_bufferEPKhi($this, $buffer, $buflen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$buffer;
      $4=$buflen;
      var $5=$2;
      var $6=$4;
      var $7=(($5+15)|0);
      var $8=HEAPU8[($7)];
      var $9=(($8)&255);
      var $10=(($6)|0) < (($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=0;
      __label__ = 3; break;
    case 2: // $12
      var $13=(($5+16)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $16=(($5+15)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      assert($18 % 1 === 0, 'memcpy given ' + $18 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($14, $15, $18, 1);
      $1=1;
      __label__ = 3; break;
    case 3: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8hash_crccvjEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=(($3)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 << 24;
  var $8=(($2+20)|0);
  var $9=(($8+1)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 << 16;
  var $13=$7 | $12;
  var $14=(($2+20)|0);
  var $15=(($14+2)|0);
  var $16=HEAPU8[($15)];
  var $17=(($16)&255);
  var $18=$17 << 8;
  var $19=$13 | $18;
  var $20=(($2+20)|0);
  var $21=(($20+3)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$19 | $23;
  ;
  return $24;
}


function __ZN8hash_crc3endEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+12)|0);
  HEAP8[($4)]=0;
  ;
  return;
}


function __ZNK9hash_base2idEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+14)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZN9hash_base6stringER7astring($this, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $index;
      $1=$this;
      $2=$buffer;
      var $3=$1;
      var $4=$2;
      var $5=__ZN7astring5resetEv($4);
      $index=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$index;
      var $8=(($3+15)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($7)|0) < (($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$2;
      var $14=$index;
      var $15=(($3+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+$14)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=__ZN7astring9catprintfEPKcz($13, ((STRING_TABLE.__str34912)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt));
      __label__ = 3; break;
    case 3: // $21
      var $22=$index;
      var $23=(($22+1)|0);
      $index=$23;
      __label__ = 1; break;
    case 4: // $24
      var $25=$2;
      var $26=__ZNK7astringcvPKcEv($25);
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN9hash_base11from_stringERPKci($this, $string, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $index;
      var $upper;
      var $lower;
      $2=$this;
      $3=$string;
      $4=$length;
      var $5=$2;
      var $6=(($5+13)|0);
      HEAP8[($6)]=0;
      var $7=(($5+16)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5+15)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      _memset($8, 0, $11, 1);
      var $12=$3;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)==49;
      if ($17) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $18
      var $19=$3;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+1)|0);
      var $22=HEAP8[($21)];
      var $23=__ZN9hash_base7fromhexEc($5, $22);
      var $24=(($23)|0)==-1;
      if ($24) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $25
      var $26=$3;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+1)|0);
      HEAP32[(($26)>>2)]=$28;
      $1=1;
      __label__ = 14; break;
    case 3: // $29
      var $30=$4;
      var $31=(($5+15)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=((($33<<1))|0);
      var $35=(($30)|0) < (($34)|0);
      if ($35) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $36
      $1=0;
      __label__ = 14; break;
    case 5: // $37
      $index=0;
      __label__ = 6; break;
    case 6: // $38
      var $39=$index;
      var $40=(($5+15)|0);
      var $41=HEAPU8[($40)];
      var $42=(($41)&255);
      var $43=(($39)|0) < (($42)|0);
      if ($43) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $44
      var $45=$3;
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0);
      var $48=HEAP8[($47)];
      var $49=__ZN9hash_base7fromhexEc($5, $48);
      $upper=$49;
      var $50=$upper;
      var $51=(($50)|0)==-1;
      if ($51) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $52
      var $53=(($5+13)|0);
      HEAP8[($53)]=1;
      $1=0;
      __label__ = 14; break;
    case 9: // $54
      var $55=$3;
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+1)|0);
      var $58=HEAP8[($57)];
      var $59=__ZN9hash_base7fromhexEc($5, $58);
      $lower=$59;
      var $60=$lower;
      var $61=(($60)|0)==-1;
      if ($61) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $62
      var $63=(($5+13)|0);
      HEAP8[($63)]=1;
      $1=0;
      __label__ = 14; break;
    case 11: // $64
      var $65=$upper;
      var $66=$65 << 4;
      var $67=$lower;
      var $68=$66 | $67;
      var $69=(($68) & 255);
      var $70=$index;
      var $71=(($5+16)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+$70)|0);
      HEAP8[($73)]=$69;
      var $74=$3;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+2)|0);
      HEAP32[(($74)>>2)]=$76;
      __label__ = 12; break;
    case 12: // $77
      var $78=$index;
      var $79=(($78+1)|0);
      $index=$79;
      __label__ = 6; break;
    case 13: // $80
      $1=1;
      __label__ = 14; break;
    case 14: // $81
      var $82=$1;
      ;
      return $82;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9hash_base11from_stringERPKci["X"]=1;

function __ZN8hash_crcC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV8hash_crc+8)|0);
  var $4=$2;
  var $5=(($2+20)|0);
  var $6=(($5)|0);
  __ZN9hash_baseC2EcPKchPh($4, 82, ((STRING_TABLE.__str44913)|0), 4, $6);
  var $7=$2;
  HEAP32[(($7)>>2)]=((__ZTV8hash_crc+8)|0);
  ;
  return;
}


function __ZN8hash_crc5beginEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+12)|0);
  HEAP8[($4)]=1;
  var $5=(($2+20)|0);
  var $6=(($5)|0);
  HEAP8[($6)]=0; HEAP8[($6+1)]=0; HEAP8[($6+2)]=0; HEAP8[($6+3)]=0;
  ;
  return;
}


function __ZN8hash_crc6bufferEPKhj($this, $data, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $crc;
  $1=$this;
  $2=$data;
  $3=$length;
  var $4=$1;
  var $5=__ZNK8hash_crccvjEv($4);
  var $6=$2;
  var $7=$3;
  var $8=_crc32($5, $6, $7);
  $crc=$8;
  var $9=$crc;
  var $10=$9 >>> 24;
  var $11=(($10) & 255);
  var $12=(($4+20)|0);
  var $13=(($12)|0);
  HEAP8[($13)]=$11;
  var $14=$crc;
  var $15=$14 >>> 16;
  var $16=(($15) & 255);
  var $17=(($4+20)|0);
  var $18=(($17+1)|0);
  HEAP8[($18)]=$16;
  var $19=$crc;
  var $20=$19 >>> 8;
  var $21=(($20) & 255);
  var $22=(($4+20)|0);
  var $23=(($22+2)|0);
  HEAP8[($23)]=$21;
  var $24=$crc;
  var $25=$24 >>> 0;
  var $26=(($25) & 255);
  var $27=(($4+20)|0);
  var $28=(($27+3)|0);
  HEAP8[($28)]=$26;
  ;
  return;
}


function __ZN8hash_md5C2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV8hash_md5+8)|0);
  var $4=$2;
  var $5=(($2+20)|0);
  var $6=(($5)|0);
  __ZN9hash_baseC2EcPKchPh($4, 77, ((STRING_TABLE.__str54914)|0), 16, $6);
  var $7=$2;
  HEAP32[(($7)>>2)]=((__ZTV8hash_md5+8)|0);
  var $8=(($2+36)|0);
  ;
  return;
}


function __ZN8hash_md55beginEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+12)|0);
  HEAP8[($4)]=1;
  var $5=(($2+36)|0);
  __Z7MD5InitP10MD5Context($5);
  ;
  return;
}


function __ZN8hash_md56bufferEPKhj($this, $data, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$data;
  $3=$length;
  var $4=$1;
  var $5=(($4+36)|0);
  var $6=$2;
  var $7=$3;
  __Z9MD5UpdateP10MD5ContextPKhj($5, $6, $7);
  ;
  return;
}


function __ZN8hash_md53endEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=(($3)|0);
  var $5=(($2+36)|0);
  __Z8MD5FinalPhP10MD5Context($4, $5);
  var $6=$2;
  var $7=(($6+12)|0);
  HEAP8[($7)]=0;
  ;
  return;
}


function __ZN9hash_sha1C2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV9hash_sha1+8)|0);
  var $4=$2;
  var $5=(($2+20)|0);
  var $6=(($5)|0);
  __ZN9hash_baseC2EcPKchPh($4, 83, ((STRING_TABLE.__str64915)|0), 20, $6);
  var $7=$2;
  HEAP32[(($7)>>2)]=((__ZTV9hash_sha1+8)|0);
  var $8=(($2+40)|0);
  ;
  return;
}


function __ZN9hash_sha15beginEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+12)|0);
  HEAP8[($4)]=1;
  var $5=(($2+40)|0);
  __Z9sha1_initP8sha1_ctx($5);
  ;
  return;
}


function __ZN9hash_sha16bufferEPKhj($this, $data, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$data;
  $3=$length;
  var $4=$1;
  var $5=(($4+40)|0);
  var $6=$3;
  var $7=$2;
  __Z11sha1_updateP8sha1_ctxjPKh($5, $6, $7);
  ;
  return;
}


function __ZN9hash_sha13endEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+40)|0);
  __Z10sha1_finalP8sha1_ctx($3);
  var $4=(($2+40)|0);
  var $5=(($2+20)|0);
  var $6=(($5)|0);
  __Z11sha1_digestPK8sha1_ctxjPh($4, 20, $6);
  var $7=$2;
  var $8=(($7+12)|0);
  HEAP8[($8)]=0;
  ;
  return;
}


function __ZN11simple_listI9hash_baseEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listI9hash_baseEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN15hash_collection20from_internal_stringEPKc($this, $string) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $stringend;
      var $ptr=__stackBase__;
      var $errors;
      var $c;
      var $lc;
      var $hash;
      $1=$this;
      $2=$string;
      var $3=$1;
      __ZN15hash_collection5resetEv($3);
      var $4=$2;
      var $5=$2;
      var $6=_strlen($5);
      var $7=(($4+$6)|0);
      $stringend=$7;
      var $8=$2;
      HEAP32[(($ptr)>>2)]=$8;
      $errors=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=HEAPU32[(($ptr)>>2)];
      var $11=$stringend;
      var $12=(($10)>>>0) < (($11)>>>0);
      if ($12) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $13
      var $14=HEAPU32[(($ptr)>>2)];
      var $15=(($14+1)|0);
      HEAP32[(($ptr)>>2)]=$15;
      var $16=HEAP8[($14)];
      $c=$16;
      var $17=$c;
      var $18=(($17 << 24) >> 24);
      var $19=_tolower($18);
      var $20=(($19) & 255);
      $lc=$20;
      var $21=$lc;
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0) >= 103;
      if ($23) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $24
      var $25=$lc;
      var $26=(($25 << 24) >> 24);
      var $27=(($26)|0) <= 122;
      if ($27) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $28
      var $29=$c;
      var $30=__ZN15hash_collection11alloc_by_idEc($29);
      $hash=$30;
      var $31=$hash;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $33
      var $34=$hash;
      var $35=$stringend;
      var $36=HEAP32[(($ptr)>>2)];
      var $37=$35;
      var $38=$36;
      var $39=(($37-$38)|0);
      var $40=__ZN9hash_base11from_stringERPKci($34, $ptr, $39);
      if ($40) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $41
      $errors=1;
      __label__ = 7; break;
    case 7: // $42
      var $43=(($3+64)|0);
      var $44=$hash;
      var $45=__ZN11simple_listI9hash_baseE6appendERS0_($43, $44);
      __label__ = 9; break;
    case 8: // $46
      $errors=1;
      __label__ = 9; break;
    case 9: // $47
      __label__ = 17; break;
    case 10: // $48
      var $49=$lc;
      var $50=(($49 << 24) >> 24);
      var $51=(($50)|0) >= 48;
      if ($51) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $52
      var $53=$lc;
      var $54=(($53 << 24) >> 24);
      var $55=(($54)|0) <= 57;
      if ($55) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 12: // $56
      var $57=$lc;
      var $58=(($57 << 24) >> 24);
      var $59=(($58)|0) >= 97;
      if ($59) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $60
      var $61=$lc;
      var $62=(($61 << 24) >> 24);
      var $63=(($62)|0) <= 102;
      if ($63) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $64
      $errors=1;
      __label__ = 16; break;
    case 15: // $65
      var $66=(($3)|0);
      var $67=$c;
      var $68=__ZN7astring3catEc($66, $67);
      __label__ = 16; break;
    case 16: // $69
      __label__ = 17; break;
    case 17: // $70
      __label__ = 1; break;
    case 18: // $71
      var $72=$errors;
      var $73=(($72) & 1);
      var $74=$73 ^ 1;
      STACKTOP = __stackBase__;
      return $74;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15hash_collection20from_internal_stringEPKc["X"]=1;

function __ZN11simple_listI9hash_baseED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listI9hash_baseED2Ev($2);
  ;
  return;
}


function __ZN15hash_collection8copyfromERKS_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hash;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=(($3)|0);
      var $5=$2;
      var $6=(($5)|0);
      var $7=__ZN7astringaSERKS_($4, $6);
      var $8=(($3+64)|0);
      __ZN11simple_listI9hash_baseE5resetEv($8);
      var $9=$2;
      var $10=__ZNK15hash_collection5firstEv($9);
      $hash=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$hash;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      var $15=$hash;
      var $16=__ZNK9hash_base2idEv($15);
      var $17=$hash;
      var $18=__ZN9hash_base6bufferEv($17);
      var $19=$hash;
      var $20=__ZNK9hash_base6lengthEv($19);
      var $21=__ZN15hash_collection15add_from_bufferEcPKhi($3, $16, $18, $20);
      __label__ = 3; break;
    case 3: // $22
      var $23=$hash;
      var $24=__ZNK9hash_base4nextEv($23);
      $hash=$24;
      __label__ = 1; break;
    case 4: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collectionaSERKS_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      __ZN15hash_collection8copyfromERKS_($3, $7);
      __label__ = 2; break;
    case 2: // $8
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15hash_collectioneqERKS_($this, $rhs) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $matches;
      var $hash;
      var $rhs_hash;
      $2=$this;
      $3=$rhs;
      var $4=$2;
      $matches=0;
      var $5=(($4+64)|0);
      var $6=__ZNK11simple_listI9hash_baseE5firstEv($5);
      $hash=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$hash;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $10
      var $11=$3;
      var $12=$hash;
      var $13=__ZNK9hash_base2idEv($12);
      var $14=__ZNK15hash_collection4hashEc($11, $13);
      $rhs_hash=$14;
      var $15=$rhs_hash;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $17
      var $18=$hash;
      var $19=$rhs_hash;
      var $20=__ZNK9hash_baseneERKS_($18, $19);
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      $1=0;
      __label__ = 9; break;
    case 5: // $22
      var $23=$matches;
      var $24=(($23+1)|0);
      $matches=$24;
      __label__ = 6; break;
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$hash;
      var $28=__ZNK9hash_base4nextEv($27);
      $hash=$28;
      __label__ = 1; break;
    case 8: // $29
      var $30=$matches;
      var $31=(($30)|0) > 0;
      $1=$31;
      __label__ = 9; break;
    case 9: // $32
      var $33=$1;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15hash_collection4hashEc($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $hash;
      $2=$this;
      $3=$type;
      var $4=$2;
      var $5=(($4+64)|0);
      var $6=__ZNK11simple_listI9hash_baseE5firstEv($5);
      $hash=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$hash;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$hash;
      var $12=__ZNK9hash_base2idEv($11);
      var $13=(($12 << 24) >> 24);
      var $14=$3;
      var $15=(($14 << 24) >> 24);
      var $16=(($13)|0)==(($15)|0);
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$hash;
      $1=$18;
      __label__ = 7; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$hash;
      var $22=__ZNK9hash_base4nextEv($21);
      $hash=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=0;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK9hash_baseneERKS_($this, $rhs) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$rhs;
      var $3=$1;
      var $4=(($3+15)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$2;
      var $8=(($7+15)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($6)|0)!=(($10)|0);
      if ($11) { var $24 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      var $13=(($3+16)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$2;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+15)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=_memcmp($14, $17, $20);
      var $22=(($21)|0)!=0;
      var $24 = $22;__label__ = 2; break;
    case 2: // $23
      var $24;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15hash_collection10hash_typesER7astring($this, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hash;
      $1=$this;
      $2=$buffer;
      var $3=$1;
      var $4=$2;
      var $5=__ZN7astring5resetEv($4);
      var $6=(($3+64)|0);
      var $7=__ZNK11simple_listI9hash_baseE5firstEv($6);
      $hash=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$hash;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$2;
      var $13=$hash;
      var $14=__ZNK9hash_base2idEv($13);
      var $15=__ZN7astring3catEc($12, $14);
      __label__ = 3; break;
    case 3: // $16
      var $17=$hash;
      var $18=__ZNK9hash_base4nextEv($17);
      $hash=$18;
      __label__ = 1; break;
    case 4: // $19
      var $20=$2;
      var $21=__ZNK7astringcvPKcEv($20);
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring3catEc($this, $ch) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$this;
  HEAP8[($2)]=$ch;
  var $3=$1;
  var $4=__Z13astring_inschP7astringiPKci($3, -1, $2, 1);
  STACKTOP = __stackBase__;
  return $4;
}


function __ZN15hash_collection5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+64)|0);
  __ZN11simple_listI9hash_baseE5resetEv($3);
  var $4=(($2)|0);
  var $5=__ZN7astring5resetEv($4);
  ;
  return;
}


function __ZN11simple_listI9hash_baseE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listI9hash_baseE6removeERS0_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collectionC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      __ZN7astringC1Ev($5);
      var $6=(($4+64)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI9hash_baseEC1ER13resource_pool($6, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collectionC2EPKc($this, $string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$string;
      var $5=$1;
      var $6=(($5)|0);
      __ZN7astringC1Ev($6);
      var $7=(($5+64)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI9hash_baseEC1ER13resource_pool($7, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=$2;
      var $10=(function() { try { __THREW__ = false; return __ZN15hash_collection20from_internal_stringEPKc($5, $9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $11
      ;
      return;
    case 3: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $3=$14;
      var $15=$13.f1;
      $4=$15;
      __label__ = 6; break;
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $3=$18;
      var $19=$17.f1;
      $4=$19;
      var $20=(($5+64)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI9hash_baseED1Ev($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $21
      __label__ = 6; break;
    case 6: // $22
      var $23=(($5)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $24
      __label__ = 8; break;
    case 8: // $25
      var $26=$3;
      var $27=$3;
      var $28=$4;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collectionD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+64)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listI9hash_baseED1Ev($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIPK8hash_crc9hash_baseET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9hash_baseE6appendERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($3+4)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=(($3+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+1)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collection15add_from_bufferEcPKhi($this, $type, $buffer, $bufflen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $existing;
      var $newhash;
      $2=$this;
      $3=$type;
      $4=$buffer;
      $5=$bufflen;
      var $6=$2;
      var $7=$3;
      var $8=__ZNK15hash_collection4hashEc($6, $7);
      $existing=$8;
      var $9=$existing;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($6+64)|0);
      var $13=$existing;
      __ZN11simple_listI9hash_baseE6removeERS0_($12, $13);
      __label__ = 2; break;
    case 2: // $14
      var $15=$3;
      var $16=__ZN15hash_collection11alloc_by_idEc($15);
      $newhash=$16;
      var $17=$newhash;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $1=0;
      __label__ = 7; break;
    case 4: // $20
      var $21=$newhash;
      var $22=$4;
      var $23=$5;
      var $24=__ZN9hash_base11from_bufferEPKhi($21, $22, $23);
      if ($24) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $25
      var $26=$newhash;
      var $27=$26;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $27);
      $1=0;
      __label__ = 7; break;
    case 6: // $28
      var $29=(($6+64)|0);
      var $30=$newhash;
      var $31=__ZN11simple_listI9hash_baseE6appendERS0_($29, $30);
      $1=$31;
      __label__ = 7; break;
    case 7: // $32
      var $33=$1;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9hash_baseE6removeERS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listI9hash_baseE6detachERS0_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN15hash_collection15add_from_stringEcPKci($this, $type, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5;
      var $existing;
      var $newhash;
      $2=$this;
      $3=$type;
      HEAP32[(($4)>>2)]=$buffer;
      $5=$length;
      var $6=$2;
      var $7=$3;
      var $8=__ZNK15hash_collection4hashEc($6, $7);
      $existing=$8;
      var $9=$existing;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($6+64)|0);
      var $13=$existing;
      __ZN11simple_listI9hash_baseE6removeERS0_($12, $13);
      __label__ = 2; break;
    case 2: // $14
      var $15=$3;
      var $16=__ZN15hash_collection11alloc_by_idEc($15);
      $newhash=$16;
      var $17=$newhash;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $1=0;
      __label__ = 7; break;
    case 4: // $20
      var $21=$newhash;
      var $22=$5;
      var $23=__ZN9hash_base11from_stringERPKci($21, $4, $22);
      if ($23) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $24
      var $25=$newhash;
      var $26=$25;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $26);
      $1=0;
      __label__ = 7; break;
    case 6: // $27
      var $28=(($6+64)|0);
      var $29=$newhash;
      var $30=__ZN11simple_listI9hash_baseE6appendERS0_($28, $29);
      $1=$30;
      __label__ = 7; break;
    case 7: // $31
      var $32=$1;
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK15hash_collection3crcERj($this, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $crchash;
      $2=$this;
      $3=$result;
      var $4=$2;
      var $5=__ZNK15hash_collection4hashEc($4, 82);
      $crchash=$5;
      var $6=$crchash;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 3; break;
    case 2: // $9
      var $10=$crchash;
      var $11=__Z8downcastIPK8hash_crc9hash_baseET_PT0_($10);
      var $12=__ZNK8hash_crccvjEv($11);
      var $13=$3;
      HEAP32[(($13)>>2)]=$12;
      $1=1;
      __label__ = 3; break;
    case 3: // $14
      var $15=$1;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collection7add_crcEj($this, $crc) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $buffer=__stackBase__;
  $1=$this;
  $2=$crc;
  var $3=$1;
  var $4=$2;
  var $5=$4 >>> 24;
  var $6=(($5) & 255);
  var $7=(($buffer)|0);
  HEAP8[($7)]=$6;
  var $8=$2;
  var $9=$8 >>> 16;
  var $10=(($9) & 255);
  var $11=(($buffer+1)|0);
  HEAP8[($11)]=$10;
  var $12=$2;
  var $13=$12 >>> 8;
  var $14=(($13) & 255);
  var $15=(($buffer+2)|0);
  HEAP8[($15)]=$14;
  var $16=$2;
  var $17=$16 >>> 0;
  var $18=(($17) & 255);
  var $19=(($buffer+3)|0);
  HEAP8[($19)]=$18;
  var $20=(($buffer)|0);
  var $21=__ZN15hash_collection15add_from_bufferEcPKhi($3, 82, $20, 4);
  STACKTOP = __stackBase__;
  return $21;
}


function __ZN15hash_collection5beginEPKc($this, $types) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $scan;
      var $existing;
      $1=$this;
      $2=$types;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($3+64)|0);
      var $8=__ZN15hash_collection11alloc_by_idEc(82);
      var $9=__ZN11simple_listI9hash_baseE6appendERS0_($7, $8);
      var $10=$9;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      FUNCTION_TABLE[$13]($9);
      var $14=(($3+64)|0);
      var $15=__ZN15hash_collection11alloc_by_idEc(77);
      var $16=__ZN11simple_listI9hash_baseE6appendERS0_($14, $15);
      var $17=$16;
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      FUNCTION_TABLE[$20]($16);
      var $21=(($3+64)|0);
      var $22=__ZN15hash_collection11alloc_by_idEc(83);
      var $23=__ZN11simple_listI9hash_baseE6appendERS0_($21, $22);
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      FUNCTION_TABLE[$27]($23);
      __label__ = 9; break;
    case 2: // $28
      var $29=$2;
      $scan=$29;
      __label__ = 3; break;
    case 3: // $30
      var $31=$scan;
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $35
      var $36=$scan;
      var $37=HEAP8[($36)];
      var $38=__ZNK15hash_collection4hashEc($3, $37);
      $existing=$38;
      var $39=$existing;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=(($3+64)|0);
      var $43=$existing;
      __ZN11simple_listI9hash_baseE6removeERS0_($42, $43);
      __label__ = 6; break;
    case 6: // $44
      var $45=(($3+64)|0);
      var $46=$scan;
      var $47=HEAP8[($46)];
      var $48=__ZN15hash_collection11alloc_by_idEc($47);
      var $49=__ZN11simple_listI9hash_baseE6appendERS0_($45, $48);
      var $50=$49;
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+8)|0);
      var $53=HEAP32[(($52)>>2)];
      FUNCTION_TABLE[$53]($49);
      __label__ = 7; break;
    case 7: // $54
      var $55=$scan;
      var $56=(($55+1)|0);
      $scan=$56;
      __label__ = 3; break;
    case 8: // $57
      __label__ = 9; break;
    case 9: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15hash_collection5beginEPKc["X"]=1;

function __ZN15hash_collection6bufferEPKhj($this, $data, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $hash;
      $1=$this;
      $2=$data;
      $3=$length;
      var $4=$1;
      var $5=(($4+64)|0);
      var $6=__ZNK11simple_listI9hash_baseE5firstEv($5);
      $hash=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$hash;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$hash;
      var $12=__ZNK9hash_base11in_progressEv($11);
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$hash;
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=$3;
      FUNCTION_TABLE[$18]($14, $19, $20);
      __label__ = 4; break;
    case 4: // $21
      __label__ = 5; break;
    case 5: // $22
      var $23=$hash;
      var $24=__ZNK9hash_base4nextEv($23);
      $hash=$24;
      __label__ = 1; break;
    case 6: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15hash_collection11alloc_by_idEc($id) {
  var __stackBase__  = STACKTOP; STACKTOP += 108; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i5=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i1=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25;
      var $26;
      var $27;
      var $28;
      $26=$id;
      var $29=$26;
      var $30=(($29 << 24) >> 24);
      if ($30 == 82) {
        __label__ = 1; break;
      }
      else if ($30 == 77) {
        __label__ = 15; break;
      }
      else if ($30 == 83) {
        __label__ = 29; break;
      }
      else {
      __label__ = 43; break;
      }
      
    case 1: // $31
      var $32=$20;
      var $33=$21;
      var $34=$22;
      var $35=$result_i;
      var $36=$23;
      var $37=$24;
      HEAP32[(($20)>>2)]=24;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str114920)|0);
      HEAP32[(($22)>>2)]=787;
      var $38=HEAP32[(($20)>>2)];
      var $39=HEAP32[(($21)>>2)];
      var $40=HEAP32[(($22)>>2)];
      var $41=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($38, $39, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $42
      HEAP32[(($result_i)>>2)]=$41;
      var $43=HEAP32[(($result_i)>>2)];
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $45
      var $46=___cxa_allocate_exception(4);
      var $47=$46;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($47);
      (function() { try { __THREW__ = false; return ___cxa_throw($46, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $50=$49.f0;
      HEAP32[(($23)>>2)]=$50;
      var $51=$49.f1;
      HEAP32[(($24)>>2)]=$51;
      var $52=HEAP32[(($24)>>2)];
      var $53=(($52)|0) < 0;
      if ($53) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $54
      var $55=HEAP32[(($23)>>2)];
      ___cxa_call_unexpected($55);
      throw "Reached an unreachable!"
    case 6: // $56
      var $57=HEAP32[(($23)>>2)];
      var $58=HEAP32[(($23)>>2)];
      var $59=HEAP32[(($24)>>2)];
      var $60=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $58, tempValue);
      var $61=($60.f1 = $59, $60);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $62
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $63=HEAP32[(($result_i)>>2)];
      var $64=$20;
      var $65=$21;
      var $66=$22;
      var $67=$result_i;
      var $68=$23;
      var $69=$24;
      var $70=$63;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8hash_crcC1Ev]($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $71
      var $72=__ZN13resource_pool10add_objectI8hash_crcEEPT_S3_(_global_resource_pool, $70);
      var $73=$72;
      $25=$73;
      __label__ = 44; break;
    case 10: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      $27=$76;
      var $77=$75.f1;
      $28=$77;
      var $78=$17;
      var $79=$18;
      var $80=$19;
      HEAP32[(($17)>>2)]=$63;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str114920)|0);
      HEAP32[(($19)>>2)]=787;
      var $81=HEAP32[(($17)>>2)];
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $83
      var $84=HEAP32[(($17)>>2)];
      var $85=HEAP32[(($18)>>2)];
      var $86=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 46; break; }
    case 12: // $_noexc
      __label__ = 13; break;
    case 13: // $_ZdlPvPKci_exit
      var $87=$17;
      var $88=$18;
      var $89=$19;
      __label__ = 14; break;
    case 14: // $90
      __label__ = 45; break;
    case 15: // $91
      var $92=$12;
      var $93=$13;
      var $94=$14;
      var $95=$result_i1;
      var $96=$15;
      var $97=$16;
      HEAP32[(($12)>>2)]=124;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str114920)|0);
      HEAP32[(($14)>>2)]=788;
      var $98=HEAP32[(($12)>>2)];
      var $99=HEAP32[(($13)>>2)];
      var $100=HEAP32[(($14)>>2)];
      var $101=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($98, $99, $100) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 18; break; };
    case 16: // $102
      HEAP32[(($result_i1)>>2)]=$101;
      var $103=HEAP32[(($result_i1)>>2)];
      var $104=(($103)|0)==0;
      if ($104) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $105
      var $106=___cxa_allocate_exception(4);
      var $107=$106;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($107);
      (function() { try { __THREW__ = false; return ___cxa_throw($106, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 18; break; }
    case 18: // $108
      var $109=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $110=$109.f0;
      HEAP32[(($15)>>2)]=$110;
      var $111=$109.f1;
      HEAP32[(($16)>>2)]=$111;
      var $112=HEAP32[(($16)>>2)];
      var $113=(($112)|0) < 0;
      if ($113) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $114
      var $115=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($115);
      throw "Reached an unreachable!"
    case 20: // $116
      var $117=HEAP32[(($15)>>2)];
      var $118=HEAP32[(($15)>>2)];
      var $119=HEAP32[(($16)>>2)];
      var $120=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $118, tempValue);
      var $121=($120.f1 = $119, $120);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $122
      throw "Reached an unreachable!"
    case 22: // $_ZnwjPKci_exit2
      var $123=HEAP32[(($result_i1)>>2)];
      var $124=$12;
      var $125=$13;
      var $126=$14;
      var $127=$result_i1;
      var $128=$15;
      var $129=$16;
      var $130=$123;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8hash_md5C1Ev]($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $131
      var $132=__ZN13resource_pool10add_objectI8hash_md5EEPT_S3_(_global_resource_pool, $130);
      var $133=$132;
      $25=$133;
      __label__ = 44; break;
    case 24: // $134
      var $135=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $136=$135.f0;
      $27=$136;
      var $137=$135.f1;
      $28=$137;
      var $138=$9;
      var $139=$10;
      var $140=$11;
      HEAP32[(($9)>>2)]=$123;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str114920)|0);
      HEAP32[(($11)>>2)]=788;
      var $141=HEAP32[(($9)>>2)];
      var $142=(($141)|0)!=0;
      if ($142) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $143
      var $144=HEAP32[(($9)>>2)];
      var $145=HEAP32[(($10)>>2)];
      var $146=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($144, $145, $146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 46; break; }
    case 26: // $_noexc3
      __label__ = 27; break;
    case 27: // $_ZdlPvPKci_exit4
      var $147=$9;
      var $148=$10;
      var $149=$11;
      __label__ = 28; break;
    case 28: // $150
      __label__ = 45; break;
    case 29: // $151
      var $152=$4;
      var $153=$5;
      var $154=$6;
      var $155=$result_i5;
      var $156=$7;
      var $157=$8;
      HEAP32[(($4)>>2)]=136;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str114920)|0);
      HEAP32[(($6)>>2)]=789;
      var $158=HEAP32[(($4)>>2)];
      var $159=HEAP32[(($5)>>2)];
      var $160=HEAP32[(($6)>>2)];
      var $161=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($158, $159, $160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; };
    case 30: // $162
      HEAP32[(($result_i5)>>2)]=$161;
      var $163=HEAP32[(($result_i5)>>2)];
      var $164=(($163)|0)==0;
      if ($164) { __label__ = 31; break; } else { __label__ = 36; break; }
    case 31: // $165
      var $166=___cxa_allocate_exception(4);
      var $167=$166;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($167);
      (function() { try { __THREW__ = false; return ___cxa_throw($166, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 32; break; }
    case 32: // $168
      var $169=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $170=$169.f0;
      HEAP32[(($7)>>2)]=$170;
      var $171=$169.f1;
      HEAP32[(($8)>>2)]=$171;
      var $172=HEAP32[(($8)>>2)];
      var $173=(($172)|0) < 0;
      if ($173) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $174
      var $175=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($175);
      throw "Reached an unreachable!"
    case 34: // $176
      var $177=HEAP32[(($7)>>2)];
      var $178=HEAP32[(($7)>>2)];
      var $179=HEAP32[(($8)>>2)];
      var $180=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $178, tempValue);
      var $181=($180.f1 = $179, $180);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $182
      throw "Reached an unreachable!"
    case 36: // $_ZnwjPKci_exit6
      var $183=HEAP32[(($result_i5)>>2)];
      var $184=$4;
      var $185=$5;
      var $186=$6;
      var $187=$result_i5;
      var $188=$7;
      var $189=$8;
      var $190=$183;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN9hash_sha1C1Ev]($190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $191
      var $192=__ZN13resource_pool10add_objectI9hash_sha1EEPT_S3_(_global_resource_pool, $190);
      var $193=$192;
      $25=$193;
      __label__ = 44; break;
    case 38: // $194
      var $195=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $196=$195.f0;
      $27=$196;
      var $197=$195.f1;
      $28=$197;
      var $198=$1;
      var $199=$2;
      var $200=$3;
      HEAP32[(($1)>>2)]=$183;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str114920)|0);
      HEAP32[(($3)>>2)]=789;
      var $201=HEAP32[(($1)>>2)];
      var $202=(($201)|0)!=0;
      if ($202) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $203
      var $204=HEAP32[(($1)>>2)];
      var $205=HEAP32[(($2)>>2)];
      var $206=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($204, $205, $206) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 46; break; }
    case 40: // $_noexc7
      __label__ = 41; break;
    case 41: // $_ZdlPvPKci_exit8
      var $207=$1;
      var $208=$2;
      var $209=$3;
      __label__ = 42; break;
    case 42: // $210
      __label__ = 45; break;
    case 43: // $211
      $25=0;
      __label__ = 44; break;
    case 44: // $212
      var $213=$25;
      STACKTOP = __stackBase__;
      return $213;
    case 45: // $214
      var $215=$27;
      var $216=$27;
      var $217=$28;
      var $218=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $216, tempValue);
      var $219=($218.f1 = $217, $218);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $220
      var $221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN15hash_collection11alloc_by_idEc["X"]=1;

function __ZNK15hash_collection12macro_stringER7astring($this, $buffer) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $temp=__stackBase__;
      var $4;
      var $5;
      var $hash;
      var $6;
      $2=$this;
      $3=$buffer;
      var $7=$2;
      __ZN7astringC1Ev($temp);
      var $8=$3;
      var $9=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 15; break; };
    case 1: // $10
      var $11=(($7+64)|0);
      var $12=(function() { try { __THREW__ = false; return __ZNK11simple_listI9hash_baseE5firstEv($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $13
      $hash=$12;
      __label__ = 3; break;
    case 3: // $14
      var $15=$hash;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $17
      var $18=$3;
      var $19=$hash;
      var $20=(function() { try { __THREW__ = false; return __ZNK9hash_base4nameEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; };
    case 5: // $21
      var $22=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($temp, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; };
    case 6: // $23
      var $24=(function() { try { __THREW__ = false; return __ZN7astring7toupperEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 15; break; };
    case 7: // $25
      var $26=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($18, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; };
    case 8: // $27
      var $28=$3;
      var $29=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($28, ((STRING_TABLE.__str74916)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 15; break; };
    case 9: // $30
      var $31=$hash;
      var $32=(function() { try { __THREW__ = false; return __ZN9hash_base6stringER7astring($31, $temp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; };
    case 10: // $33
      var $34=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($29, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($34, ((STRING_TABLE.__str84917)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $37
      __label__ = 13; break;
    case 13: // $38
      var $39=$hash;
      var $40=(function() { try { __THREW__ = false; return __ZNK9hash_base4nextEv($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; };
    case 14: // $41
      $hash=$40;
      __label__ = 3; break;
    case 15: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      $4=$44;
      var $45=$43.f1;
      $5=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($temp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 16: // $46
      var $47=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($7, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $48
      if ($47) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $49
      var $50=$3;
      var $51=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($50, ((STRING_TABLE.__str94918)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; };
    case 19: // $52
      __label__ = 20; break;
    case 20: // $53
      var $54=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($7, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 15; break; };
    case 21: // $55
      if ($54) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $56
      var $57=$3;
      var $58=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($57, ((STRING_TABLE.__str104919)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; };
    case 23: // $59
      __label__ = 24; break;
    case 24: // $60
      var $61=$3;
      var $62=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $63
      var $64=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 15; break; };
    case 26: // $65
      $1=$64;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($temp);
      var $66=$1;
      STACKTOP = __stackBase__;
      return $66;
    case 27: // $67
      __label__ = 28; break;
    case 28: // $68
      var $69=$4;
      var $70=$4;
      var $71=$5;
      var $72=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $70, tempValue);
      var $73=($72.f1 = $71, $72);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK15hash_collection12macro_stringER7astring["X"]=1;

function __ZN9hash_baseD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNK9hash_base11in_progressEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN9hash_base6bufferEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK9hash_base6lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+15)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  ;
  return $5;
}


function __ZN15hash_collection3endEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      $1=$this;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=__ZNK11simple_listI9hash_baseE5firstEv($3);
      $hash=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$hash;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$hash;
      var $10=__ZNK9hash_base11in_progressEv($9);
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=$hash;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      FUNCTION_TABLE[$16]($12);
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$hash;
      var $20=__ZNK9hash_base4nextEv($19);
      $hash=$20;
      __label__ = 1; break;
    case 6: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8hash_crcD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8hash_crcD2Ev($2);
  ;
  return;
}


function __ZN8hash_md5D1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8hash_md5D2Ev($2);
  ;
  return;
}


function __ZN9hash_sha1D1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN9hash_sha1D2Ev($2);
  ;
  return;
}


function __ZN9hash_baseD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN9hash_baseD2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI9hash_sha1EC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI9hash_sha1EC2EPS0_($3, $4);
  ;
  return;
}


function __ZN13resource_pool10add_objectI8hash_crcEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8hash_crcEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI8hash_crcEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI8hash_md5EEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8hash_md5EC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI8hash_md5EEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI9hash_sha1EEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI9hash_sha1EC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI9hash_sha1EEPT_S3_["X"]=1;

function __ZN8hash_crcD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN8hash_crcD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8hash_crcD0Ev["X"]=1;

function __ZN8hash_md5D0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN8hash_md5D1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8hash_md5D0Ev["X"]=1;

function __ZN9hash_sha1D0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN9hash_sha1D1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9hash_sha1D0Ev["X"]=1;

function __ZN9hash_baseD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN9hash_baseD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN9hash_baseD0Ev["X"]=1;

function __ZN11simple_listI9hash_baseE6detachERS0_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI9hash_baseE6detachERS0_["X"]=1;

function __ZN11simple_listI9hash_baseEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listI9hash_baseE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN16info_xml_creatorC2ER17driver_enumerator($this, $drivlist) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$drivlist;
  var $3=$1;
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($3+4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  ;
  return;
}


function __ZN20resource_pool_objectI9hash_sha1EC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 136);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI9hash_sha1E+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI9hash_sha1ED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI9hash_sha1ED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI8hash_md5EC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI8hash_md5EC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI8hash_md5EC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 124);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI8hash_md5E+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI8hash_md5ED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI8hash_md5ED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI8hash_crcEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI8hash_crcEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI8hash_crcEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 24);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI8hash_crcE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI8hash_crcED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI8hash_crcED2Ev($2);
  ;
  return;
}


function __ZN11simple_listI9hash_baseED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listI9hash_baseE+8)|0);
  __ZN11simple_listI9hash_baseE5resetEv($2);
  ;
  return;
}


function __ZN9hash_sha1D2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN9hash_baseD2Ev($3);
  ;
  return;
}


function __ZN8hash_md5D2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN9hash_baseD2Ev($3);
  ;
  return;
}


function __ZN8hash_crcD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN9hash_baseD2Ev($3);
  ;
  return;
}


function __ZN16info_xml_creator6outputEP7__sFILE($this, $out) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$out;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=_fprintf($7, ((STRING_TABLE.__str4954)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $9=(($3)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=_fprintf($10, ((STRING_TABLE.__str14955)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=((STRING_TABLE.__ZN16info_xml_creator12s_dtd_stringE)|0),tempInt));
      var $12=(($3)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__Z20xml_normalize_stringPKc(((STRING_TABLE._build_version)|0));
      var $15=_fprintf($13, ((STRING_TABLE.__str24956)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,HEAP32[((tempInt+4)>>2)]=10,tempInt));
      __label__ = 1; break;
    case 1: // $16
      var $17=(($3+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__ZN17driver_enumerator4nextEv($18);
      if ($19) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $20
      __ZN16info_xml_creator10output_oneEv($3);
      __label__ = 1; break;
    case 3: // $21
      var $22=(($3)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=_fprintf($23, ((STRING_TABLE.__str34957)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI9hash_sha1ED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI9hash_sha1ED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI9hash_sha1ED0Ev["X"]=1;

function __ZN20resource_pool_objectI9hash_sha1ED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI9hash_sha1E+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI8hash_md5ED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8hash_md5ED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI8hash_md5ED0Ev["X"]=1;

function __ZN20resource_pool_objectI8hash_md5ED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI8hash_md5E+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI8hash_crcED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI8hash_crcED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI8hash_crcED0Ev["X"]=1;

function __ZN20resource_pool_objectI8hash_crcED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI8hash_crcE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listI9hash_baseED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listI9hash_baseED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listI9hash_baseED0Ev["X"]=1;
// WARNING: content after a branch in a label, line: 588434
// WARNING: content after a branch in a label, line: 588435
// WARNING: content after a branch in a label, line: 588436
// WARNING: content after a branch in a label, line: 588437

function __ZN16info_xml_creator15output_sampleofEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      var $samplenames;
      var $sampnum;
      var $cursampname;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=HEAP32[((_SAMPLES)>>2)];
      var $8=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($6, $7);
      $device=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$device;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $12
      var $13=$device;
      var $14=__ZNK8device_t13static_configEv($13);
      var $15=$14;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      $samplenames=$17;
      var $18=$samplenames;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $20
      $sampnum=0;
      __label__ = 4; break;
    case 4: // $21
      var $22=$sampnum;
      var $23=$samplenames;
      var $24=(($23+($22<<2))|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $27
      var $28=$sampnum;
      var $29=$samplenames;
      var $30=(($29+($28<<2))|0);
      var $31=HEAP32[(($30)>>2)];
      $cursampname=$31;
      var $32=$cursampname;
      var $33=(($32)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=(($35)|0)==42;
      if ($36) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $37
      var $38=$cursampname;
      var $39=(($38+1)|0);
      var $40=(($2+4)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=__ZNK17driver_enumerator6driverEv($41);
      var $43=(($42+8)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_strcmp($39, $44);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $47
      var $48=(($2)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$cursampname;
      var $51=(($50+1)|0);
      var $52=__Z20xml_normalize_stringPKc($51);
      var $53=_fprintf($49, ((STRING_TABLE.__str224976)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$52,tempInt));
      __label__ = 8; break;
    case 8: // $54
      __label__ = 12; break;
    case 9: // $58
      __label__ = 10; break;
    case 10: // $59
      __label__ = 11; break;
    case 11: // $60
      var $61=$device;
      var $62=__ZNK8device_t8typenextEv($61);
      $device=$62;
      __label__ = 1; break;
    case 12: // $63
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator15output_sampleofEv["X"]=1;

function __ZN16info_xml_creator11output_biosEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $rom;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6driverEv($4);
      var $6=(($5+36)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      __label__ = 10; break;
    case 2: // $10
      var $11=(($2+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__ZNK17driver_enumerator6driverEv($12);
      var $14=(($13+36)|0);
      var $15=HEAP32[(($14)>>2)];
      $rom=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$rom;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19 & 15;
      var $21=(($20)|0)==2;
      var $22=$21 ^ 1;
      if ($22) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $23
      var $24=$rom;
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 & 15;
      var $28=(($27)|0)==9;
      if ($28) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $29
      var $30=(($2)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=_fprintf($31, ((STRING_TABLE.__str234977)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $33=(($2)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$rom;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=__Z20xml_normalize_stringPKc($37);
      var $39=_fprintf($34, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$38,tempInt));
      var $40=(($2)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$rom;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=__Z20xml_normalize_stringPKc($44);
      var $46=_fprintf($41, ((STRING_TABLE.__str244978)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,tempInt));
      var $47=$rom;
      var $48=(($47+16)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$49 & -16777216;
      var $51=$50 >>> 24;
      var $52=(($51)|0)==1;
      if ($52) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $53
      var $54=(($2)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=_fprintf($55, ((STRING_TABLE.__str254979)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 7: // $57
      var $58=(($2)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=_fprintf($59, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 8; break;
    case 8: // $61
      __label__ = 9; break;
    case 9: // $62
      var $63=$rom;
      var $64=(($63+20)|0);
      $rom=$64;
      __label__ = 3; break;
    case 10: // $65
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator11output_biosEv["X"]=1;

function __ZN16info_xml_creator10output_oneEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 472; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $driver;
      var $config;
      var $portlist=__stackBase__;
      var $errors=__stackBase__+408;
      var $2;
      var $3;
      var $device;
      var $start;
      var $clone_of;
      $1=$this;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__ZNK17driver_enumerator6driverEv($6);
      $driver=$7;
      var $8=$driver;
      var $9=(($8+44)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 8192;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      __label__ = 82; break;
    case 2: // $14
      var $15=(($4+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNK17driver_enumerator6configEv($16);
      $config=$17;
      __ZN11tagged_listI17input_port_configEC1ER13resource_pool($portlist, _global_resource_pool);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $18
      var $19=$config;
      var $20=(function() { try { __THREW__ = false; return __ZNK14machine_config10devicelistEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 12; break; };
    case 4: // $21
      var $22=$20;
      var $23=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; };
    case 5: // $24
      $device=$23;
      __label__ = 6; break;
    case 6: // $25
      var $26=$device;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $28
      var $29=$device;
      (function() { try { __THREW__ = false; return __Z20input_port_list_initR8device_tR11tagged_listI17input_port_configER7astring($29, $portlist, $errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $30
      __label__ = 9; break;
    case 9: // $31
      var $32=$device;
      var $33=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $34
      $device=$33;
      __label__ = 6; break;
    case 11: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $2=$37;
      var $38=$36.f1;
      $3=$38;
      __label__ = 84; break;
    case 12: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $2=$41;
      var $42=$40.f1;
      $3=$42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 87; break; }
    case 13: // $43
      var $44=(($4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(function() { try { __THREW__ = false; return _fprintf($45, ((STRING_TABLE.__str44958)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; };
    case 14: // $47
      var $48=(($4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$driver;
      var $51=(($50+8)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; };
    case 15: // $54
      var $55=(function() { try { __THREW__ = false; return _fprintf($49, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; };
    case 16: // $56
      var $57=$driver;
      var $58=(($57)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(function() { try { __THREW__ = false; return _strrchr($59, 47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 12; break; };
    case 17: // $61
      $start=$60;
      var $62=$start;
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $64
      var $65=$driver;
      var $66=(($65)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(function() { try { __THREW__ = false; return _strrchr($67, 92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 12; break; };
    case 19: // $69
      $start=$68;
      __label__ = 20; break;
    case 20: // $70
      var $71=$start;
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $73
      var $74=$driver;
      var $75=(($74)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76-1)|0);
      $start=$77;
      __label__ = 22; break;
    case 22: // $78
      var $79=(($4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$start;
      var $82=(($81+1)|0);
      var $83=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 12; break; };
    case 23: // $84
      var $85=(function() { try { __THREW__ = false; return _fprintf($80, ((STRING_TABLE.__str64960)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$83,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 12; break; };
    case 24: // $86
      var $87=$driver;
      var $88=(($87+44)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89 & 4096;
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $92
      var $93=(($4)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(function() { try { __THREW__ = false; return _fprintf($94, ((STRING_TABLE.__str74961)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 12; break; };
    case 26: // $96
      __label__ = 27; break;
    case 27: // $97
      var $98=$driver;
      var $99=(($98+44)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100 & 8192;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $103
      var $104=(($4)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(function() { try { __THREW__ = false; return _fprintf($105, ((STRING_TABLE.__str84962)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 12; break; };
    case 29: // $107
      __label__ = 30; break;
    case 30: // $108
      var $109=$driver;
      var $110=(($109+44)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111 & 131072;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $114
      var $115=(($4)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(function() { try { __THREW__ = false; return _fprintf($116, ((STRING_TABLE.__str94963)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 12; break; };
    case 32: // $118
      __label__ = 33; break;
    case 33: // $119
      var $120=(($4+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$driver;
      var $123=(($122+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(function() { try { __THREW__ = false; return __ZN11driver_list4findEPKc($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 12; break; };
    case 34: // $126
      $clone_of=$125;
      var $127=$clone_of;
      var $128=(($127)|0)!=-1;
      if ($128) { __label__ = 35; break; } else { __label__ = 41; break; }
    case 35: // $129
      var $130=(($4+4)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$clone_of;
      var $133=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 12; break; };
    case 36: // $134
      var $135=(($133+44)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=$136 & 4096;
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 41; break; } else { __label__ = 37; break; }
    case 37: // $139
      var $140=(($4)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($4+4)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$clone_of;
      var $145=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 12; break; };
    case 38: // $146
      var $147=(($145+8)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 12; break; };
    case 39: // $150
      var $151=(function() { try { __THREW__ = false; return _fprintf($141, ((STRING_TABLE.__str104964)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 12; break; };
    case 40: // $152
      __label__ = 41; break;
    case 41: // $153
      var $154=$clone_of;
      var $155=(($154)|0)!=-1;
      if ($155) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $156
      var $157=(($4)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($4+4)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=$clone_of;
      var $162=(function() { try { __THREW__ = false; return __ZN11driver_list6driverEi($161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 12; break; };
    case 43: // $163
      var $164=(($162+8)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($165) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 12; break; };
    case 44: // $167
      var $168=(function() { try { __THREW__ = false; return _fprintf($158, ((STRING_TABLE.__str114965)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$166,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 12; break; };
    case 45: // $169
      __label__ = 46; break;
    case 46: // $170
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator15output_sampleofEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 12; break; }
    case 47: // $171
      var $172=(($4)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=(function() { try { __THREW__ = false; return _fprintf($173, ((STRING_TABLE.__str124966)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 12; break; };
    case 48: // $175
      var $176=$driver;
      var $177=(($176+12)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=(($178)|0)!=0;
      if ($179) { __label__ = 49; break; } else { __label__ = 52; break; }
    case 49: // $180
      var $181=(($4)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$driver;
      var $184=(($183+12)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($185) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 12; break; };
    case 50: // $187
      var $188=(function() { try { __THREW__ = false; return _fprintf($182, ((STRING_TABLE.__str134967)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$186,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 12; break; };
    case 51: // $189
      __label__ = 52; break;
    case 52: // $190
      var $191=$driver;
      var $192=(($191+16)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=(($193)|0)!=0;
      if ($194) { __label__ = 53; break; } else { __label__ = 59; break; }
    case 53: // $195
      var $196=$driver;
      var $197=(($196+16)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(function() { try { __THREW__ = false; return _strspn($198, ((STRING_TABLE.__str144968)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 12; break; };
    case 54: // $200
      var $201=$driver;
      var $202=(($201+16)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(function() { try { __THREW__ = false; return _strlen($203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 12; break; };
    case 55: // $205
      var $206=(($199)|0)==(($204)|0);
      if ($206) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $207
      var $208=(($4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$driver;
      var $211=(($210+16)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 12; break; };
    case 57: // $214
      var $215=(function() { try { __THREW__ = false; return _fprintf($209, ((STRING_TABLE.__str154969)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$213,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 12; break; };
    case 58: // $216
      __label__ = 59; break;
    case 59: // $217
      var $218=$driver;
      var $219=(($218+20)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220)|0)!=0;
      if ($221) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $222
      var $223=(($4)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=$driver;
      var $226=(($225+20)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 12; break; };
    case 61: // $229
      var $230=(function() { try { __THREW__ = false; return _fprintf($224, ((STRING_TABLE.__str164970)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$228,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 12; break; };
    case 62: // $231
      __label__ = 63; break;
    case 63: // $232
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator11output_biosEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 12; break; }
    case 64: // $233
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator10output_romEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 12; break; }
    case 65: // $234
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator13output_sampleEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 12; break; }
    case 66: // $235
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator12output_chipsEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 12; break; }
    case 67: // $236
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator14output_displayEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 12; break; }
    case 68: // $237
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator12output_soundEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 12; break; }
    case 69: // $238
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator12output_inputERK11tagged_listI17input_port_configE($4, $portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 12; break; }
    case 70: // $239
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator15output_switchesERK11tagged_listI17input_port_configEiPKcS6_($4, $portlist, 5, ((STRING_TABLE.__str174971)|0), ((STRING_TABLE.__str184972)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 12; break; }
    case 71: // $240
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator15output_switchesERK11tagged_listI17input_port_configEiPKcS6_($4, $portlist, 7, ((STRING_TABLE.__str194973)|0), ((STRING_TABLE.__str204974)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 12; break; }
    case 72: // $241
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator17output_categoriesERK11tagged_listI17input_port_configE($4, $portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 12; break; }
    case 73: // $242
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator16output_adjustersERK11tagged_listI17input_port_configE($4, $portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 12; break; }
    case 74: // $243
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator13output_driverEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 12; break; }
    case 75: // $244
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator13output_imagesEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 12; break; }
    case 76: // $245
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator12output_slotsEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 12; break; }
    case 77: // $246
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator20output_software_listEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 12; break; }
    case 78: // $247
      (function() { try { __THREW__ = false; return __ZN16info_xml_creator17output_ramoptionsEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 12; break; }
    case 79: // $248
      var $249=(($4)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=(function() { try { __THREW__ = false; return _fprintf($250, ((STRING_TABLE.__str214975)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 12; break; };
    case 80: // $252
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($errors) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 81; break; } else { __label__ = 11; break; }
    case 81: // $253
      __ZN11tagged_listI17input_port_configED1Ev($portlist);
      __label__ = 82; break;
    case 82: // $254
      STACKTOP = __stackBase__;
      return;
    case 83: // $255
      __label__ = 84; break;
    case 84: // $256
      (function() { try { __THREW__ = false; return __ZN11tagged_listI17input_port_configED1Ev($portlist) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 87; break; }
    case 85: // $257
      __label__ = 86; break;
    case 86: // $258
      var $259=$2;
      var $260=$2;
      var $261=$3;
      var $262=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $260, tempValue);
      var $263=($262.f1 = $261, $262);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 87: // $264
      var $265=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator10output_oneEv["X"]=1;

function __ZN16info_xml_creator13output_sampleEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      var $samplenames;
      var $sampnum;
      var $cursampname;
      var $dupnum;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=HEAP32[((_SAMPLES)>>2)];
      var $8=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($6, $7);
      $device=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$device;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $12
      var $13=$device;
      var $14=__ZNK8device_t13static_configEv($13);
      var $15=$14;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      $samplenames=$17;
      var $18=$samplenames;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 19; break; }
    case 3: // $20
      $sampnum=0;
      __label__ = 4; break;
    case 4: // $21
      var $22=$sampnum;
      var $23=$samplenames;
      var $24=(($23+($22<<2))|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 18; break; }
    case 5: // $27
      var $28=$sampnum;
      var $29=$samplenames;
      var $30=(($29+($28<<2))|0);
      var $31=HEAP32[(($30)>>2)];
      $cursampname=$31;
      var $32=$sampnum;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $34
      var $35=$cursampname;
      var $36=(($35)|0);
      var $37=HEAP8[($36)];
      var $38=(($37 << 24) >> 24);
      var $39=(($38)|0)==42;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      __label__ = 17; break;
    case 8: // $41
      $dupnum=0;
      __label__ = 9; break;
    case 9: // $42
      var $43=$dupnum;
      var $44=$sampnum;
      var $45=(($43)|0) < (($44)|0);
      if ($45) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $46
      var $47=$dupnum;
      var $48=$samplenames;
      var $49=(($48+($47<<2))|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$cursampname;
      var $52=_strcmp($50, $51);
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      __label__ = 14; break;
    case 12: // $55
      __label__ = 13; break;
    case 13: // $56
      var $57=$dupnum;
      var $58=(($57+1)|0);
      $dupnum=$58;
      __label__ = 9; break;
    case 14: // $59
      var $60=$dupnum;
      var $61=$sampnum;
      var $62=(($60)|0) < (($61)|0);
      if ($62) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $63
      __label__ = 17; break;
    case 16: // $64
      var $65=(($2)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$cursampname;
      var $68=__Z20xml_normalize_stringPKc($67);
      var $69=_fprintf($66, ((STRING_TABLE.__str424996)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$68,tempInt));
      __label__ = 17; break;
    case 17: // $70
      var $71=$sampnum;
      var $72=(($71+1)|0);
      $sampnum=$72;
      __label__ = 4; break;
    case 18: // $73
      __label__ = 19; break;
    case 19: // $74
      __label__ = 20; break;
    case 20: // $75
      var $76=$device;
      var $77=__ZNK8device_t8typenextEv($76);
      $device=$77;
      __label__ = 1; break;
    case 21: // $78
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator13output_sampleEv["X"]=1;

function __ZN16info_xml_creator12output_chipsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $exec=__stackBase__;
      var $gotone;
      var $sound=__stackBase__+4;
      var $gotone1;
      $1=$this;
      var $2=$1;
      HEAP32[(($exec)>>2)]=0;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($6, $exec);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=(($2)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=_fprintf($14, ((STRING_TABLE.__str434997)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $16=(($2)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=_fprintf($17, ((STRING_TABLE.__str444998)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $19=(($2)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=HEAP32[(($exec)>>2)];
      var $22=$21;
      var $23=__ZN16device_interface6deviceEv($22);
      var $24=__ZNK8device_t3tagEv($23);
      var $25=__Z20xml_normalize_stringPKc($24);
      var $26=_fprintf($20, ((STRING_TABLE.__str454999)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$25,tempInt));
      var $27=(($2)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=HEAP32[(($exec)>>2)];
      var $30=$29;
      var $31=__ZN16device_interface6deviceEv($30);
      var $32=__ZNK8device_t4nameEv($31);
      var $33=__Z20xml_normalize_stringPKc($32);
      var $34=_fprintf($28, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$33,tempInt));
      var $35=(($2)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=HEAP32[(($exec)>>2)];
      var $38=$37;
      var $39=__ZN16device_interface6deviceEv($38);
      var $40=__ZNK8device_t5clockEv($39);
      var $41=_fprintf($36, ((STRING_TABLE.__str465000)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,tempInt));
      var $42=(($2)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=_fprintf($43, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 3; break;
    case 3: // $45
      var $46=HEAP32[(($exec)>>2)];
      var $47=$46;
      var $48=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($47, $exec);
      var $49=(($48)&1);
      $gotone=$49;
      __label__ = 1; break;
    case 4: // $50
      HEAP32[(($sound)>>2)]=0;
      var $51=(($2+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=__ZNK17driver_enumerator6configEv($52);
      var $54=__ZNK14machine_config10devicelistEv($53);
      var $55=__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($54, $sound);
      var $56=(($55)&1);
      $gotone1=$56;
      __label__ = 5; break;
    case 5: // $57
      var $58=$gotone1;
      var $59=(($58) & 1);
      if ($59) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $60
      var $61=(($2)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=_fprintf($62, ((STRING_TABLE.__str434997)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $64=(($2)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=_fprintf($65, ((STRING_TABLE.__str475001)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $67=(($2)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=HEAP32[(($sound)>>2)];
      var $70=$69;
      var $71=__ZN16device_interface6deviceEv($70);
      var $72=__ZNK8device_t3tagEv($71);
      var $73=__Z20xml_normalize_stringPKc($72);
      var $74=_fprintf($68, ((STRING_TABLE.__str454999)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,tempInt));
      var $75=(($2)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=HEAP32[(($sound)>>2)];
      var $78=$77;
      var $79=__ZN16device_interface6deviceEv($78);
      var $80=__ZNK8device_t4nameEv($79);
      var $81=__Z20xml_normalize_stringPKc($80);
      var $82=_fprintf($76, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt));
      var $83=HEAP32[(($sound)>>2)];
      var $84=$83;
      var $85=__ZN16device_interface6deviceEv($84);
      var $86=__ZNK8device_t5clockEv($85);
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $88
      var $89=(($2)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=HEAP32[(($sound)>>2)];
      var $92=$91;
      var $93=__ZN16device_interface6deviceEv($92);
      var $94=__ZNK8device_t5clockEv($93);
      var $95=_fprintf($90, ((STRING_TABLE.__str465000)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$94,tempInt));
      __label__ = 8; break;
    case 8: // $96
      var $97=(($2)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=_fprintf($98, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $100
      var $101=HEAP32[(($sound)>>2)];
      var $102=$101;
      var $103=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($102, $sound);
      var $104=(($103)&1);
      $gotone1=$104;
      __label__ = 5; break;
    case 10: // $105
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator12output_chipsEv["X"]=1;

function __ZN16info_xml_creator10output_romEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 248; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $rom_type;
      var $source;
      var $region;
      var $is_disk;
      var $rom;
      var $is_bios;
      var $name;
      var $offset;
      var $merge_name;
      var $bios_name=__stackBase__;
      var $hashes=__stackBase__+100;
      var $2;
      var $3;
      var $brom;
      var $tempstr=__stackBase__+184;
      var $hash;
      $1=$this;
      var $4=$1;
      $rom_type=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$rom_type;
      var $7=(($6)|0) < 3;
      if ($7) { __label__ = 2; break; } else { __label__ = 104; break; }
    case 2: // $8
      var $9=(($4+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK17driver_enumerator6configEv($10);
      var $12=__Z16rom_first_sourceRK14machine_config($11);
      $source=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$source;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 102; break; }
    case 4: // $16
      var $17=$source;
      var $18=__Z16rom_first_regionRK8device_t($17);
      $region=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$region;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 100; break; }
    case 6: // $22
      var $23=$region;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25 & 16384;
      var $27=(($26)|0)==16384;
      var $28=(($27)&1);
      $is_disk=$28;
      var $29=$is_disk;
      var $30=(($29) & 1);
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$rom_type;
      var $33=(($32)|0)!=2;
      if ($33) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $34
      var $35=$is_disk;
      var $36=(($35) & 1);
      if ($36) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $37
      var $38=$rom_type;
      var $39=(($38)|0)==2;
      if ($39) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $40
      __label__ = 99; break;
    case 11: // $41
      var $42=$region;
      var $43=__Z14rom_first_filePK9rom_entry($42);
      $rom=$43;
      __label__ = 12; break;
    case 12: // $44
      var $45=$rom;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 13; break; } else { __label__ = 98; break; }
    case 13: // $47
      var $48=$rom;
      var $49=(($48+16)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$50 & -16777216;
      var $52=$51 >>> 24;
      var $53=(($52)|0)!=0;
      var $54=(($53)&1);
      $is_bios=$54;
      var $55=$rom;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      $name=$57;
      var $58=$rom;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      $offset=$60;
      $merge_name=0;
      var $61=$is_bios;
      var $62=(($61) & 1);
      if ($62) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $63
      var $64=$rom_type;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 15: // $66
      var $67=$is_bios;
      var $68=(($67) & 1);
      if ($68) { __label__ = 18; break; } else { __label__ = 16; break; }
    case 16: // $69
      var $70=$rom_type;
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $72
      __label__ = 95; break;
    case 18: // $73
      var $74=$rom;
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($hashes, $76);
      var $77=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 22; break; };
    case 19: // $78
      if ($77) { __label__ = 23; break; } else { __label__ = 20; break; }
    case 20: // $79
      var $80=(function() { try { __THREW__ = false; return __ZN16info_xml_creator14get_merge_nameERK15hash_collection($4, $hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; };
    case 21: // $81
      $merge_name=$80;
      __label__ = 23; break;
    case 22: // $82
      var $83=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $84=$83.f0;
      $2=$84;
      var $85=$83.f1;
      $3=$85;
      __label__ = 96; break;
    case 23: // $86
      var $87=(($bios_name)|0);
      HEAP8[($87)]=0;
      var $88=$is_disk;
      var $89=(($88) & 1);
      if ($89) { __label__ = 34; break; } else { __label__ = 24; break; }
    case 24: // $90
      var $91=$is_bios;
      var $92=(($91) & 1);
      if ($92) { __label__ = 25; break; } else { __label__ = 34; break; }
    case 25: // $93
      var $94=$rom;
      var $95=(($94-20)|0);
      $brom=$95;
      __label__ = 26; break;
    case 26: // $96
      var $97=$brom;
      var $98=(($4+4)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(function() { try { __THREW__ = false; return __ZNK17driver_enumerator6driverEv($99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 22; break; };
    case 27: // $101
      var $102=(($100+36)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($97)|0)!=(($103)|0);
      if ($104) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $105
      var $106=$brom;
      var $107=(($106+16)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=$108 & 15;
      var $110=(($109)|0)==9;
      if ($110) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $111
      var $112=(($bios_name)|0);
      var $113=$brom;
      var $114=(($113)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(function() { try { __THREW__ = false; return _strcpy($112, $115) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 22; break; };
    case 30: // $117
      __label__ = 33; break;
    case 31: // $118
      __label__ = 32; break;
    case 32: // $119
      var $120=$brom;
      var $121=(($120-20)|0);
      $brom=$121;
      __label__ = 26; break;
    case 33: // $122
      __label__ = 34; break;
    case 34: // $123
      var $124=$is_disk;
      var $125=(($124) & 1);
      if ($125) { __label__ = 37; break; } else { __label__ = 35; break; }
    case 35: // $126
      var $127=(($4)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(function() { try { __THREW__ = false; return _fprintf($128, ((STRING_TABLE.__str274981)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 22; break; };
    case 36: // $130
      __label__ = 39; break;
    case 37: // $131
      var $132=(($4)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(function() { try { __THREW__ = false; return _fprintf($133, ((STRING_TABLE.__str284982)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 22; break; };
    case 38: // $135
      __label__ = 39; break;
    case 39: // $136
      var $137=$name;
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $139
      var $140=$name;
      var $141=(($140)|0);
      var $142=HEAP8[($141)];
      var $143=(($142 << 24) >> 24);
      var $144=(($143)|0)!=0;
      if ($144) { __label__ = 41; break; } else { __label__ = 44; break; }
    case 41: // $145
      var $146=(($4)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$name;
      var $149=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 22; break; };
    case 42: // $150
      var $151=(function() { try { __THREW__ = false; return _fprintf($147, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 22; break; };
    case 43: // $152
      __label__ = 44; break;
    case 44: // $153
      var $154=$merge_name;
      var $155=(($154)|0)!=0;
      if ($155) { __label__ = 45; break; } else { __label__ = 48; break; }
    case 45: // $156
      var $157=(($4)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$merge_name;
      var $160=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 22; break; };
    case 46: // $161
      var $162=(function() { try { __THREW__ = false; return _fprintf($158, ((STRING_TABLE.__str294983)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$160,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 22; break; };
    case 47: // $163
      __label__ = 48; break;
    case 48: // $164
      var $165=(($bios_name)|0);
      var $166=HEAP8[($165)];
      var $167=(($166 << 24) >> 24);
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 49; break; } else { __label__ = 52; break; }
    case 49: // $169
      var $170=(($4)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($bios_name)|0);
      var $173=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 22; break; };
    case 50: // $174
      var $175=(function() { try { __THREW__ = false; return _fprintf($171, ((STRING_TABLE.__str304984)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$173,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 22; break; };
    case 51: // $176
      __label__ = 52; break;
    case 52: // $177
      var $178=$is_disk;
      var $179=(($178) & 1);
      if ($179) { __label__ = 56; break; } else { __label__ = 53; break; }
    case 53: // $180
      var $181=(($4)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$rom;
      var $184=(function() { try { __THREW__ = false; return __Z13rom_file_sizePK9rom_entry($183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 22; break; };
    case 54: // $185
      var $186=(function() { try { __THREW__ = false; return _fprintf($182, ((STRING_TABLE.__str314985)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$184,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 22; break; };
    case 55: // $187
      __label__ = 56; break;
    case 56: // $188
      var $189=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 22; break; };
    case 57: // $190
      if ($189) { __label__ = 72; break; } else { __label__ = 58; break; }
    case 58: // $191
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 22; break; }
    case 59: // $192
      var $193=(function() { try { __THREW__ = false; return __ZNK15hash_collection5firstEv($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 68; break; };
    case 60: // $194
      $hash=$193;
      __label__ = 61; break;
    case 61: // $195
      var $196=$hash;
      var $197=(($196)|0)!=0;
      if ($197) { __label__ = 62; break; } else { __label__ = 69; break; }
    case 62: // $198
      var $199=(($4)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=$hash;
      var $202=(function() { try { __THREW__ = false; return __ZNK9hash_base4nameEv($201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 68; break; };
    case 63: // $203
      var $204=$hash;
      var $205=(function() { try { __THREW__ = false; return __ZN9hash_base6stringER7astring($204, $tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 68; break; };
    case 64: // $206
      var $207=(function() { try { __THREW__ = false; return _fprintf($200, ((STRING_TABLE.__str324986)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$202,HEAP32[((tempInt+4)>>2)]=$205,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 68; break; };
    case 65: // $208
      __label__ = 66; break;
    case 66: // $209
      var $210=$hash;
      var $211=(function() { try { __THREW__ = false; return __ZNK9hash_base4nextEv($210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 68; break; };
    case 67: // $212
      $hash=$211;
      __label__ = 61; break;
    case 68: // $213
      var $214=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $215=$214.f0;
      $2=$215;
      var $216=$214.f1;
      $3=$216;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 71; break; } else { __label__ = 106; break; }
    case 69: // $217
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 22; break; }
    case 70: // $218
      __label__ = 72; break;
    case 71: // $219
      __label__ = 96; break;
    case 72: // $220
      var $221=(($4)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$region;
      var $224=(($223)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=(function() { try { __THREW__ = false; return _fprintf($222, ((STRING_TABLE.__str334987)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$225,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 22; break; };
    case 73: // $227
      var $228=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 22; break; };
    case 74: // $229
      if ($228) { __label__ = 75; break; } else { __label__ = 77; break; }
    case 75: // $230
      var $231=(($4)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=(function() { try { __THREW__ = false; return _fprintf($232, ((STRING_TABLE.__str344988)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 22; break; };
    case 76: // $234
      __label__ = 77; break;
    case 77: // $235
      var $236=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($hashes, 94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 22; break; };
    case 78: // $237
      if ($236) { __label__ = 79; break; } else { __label__ = 81; break; }
    case 79: // $238
      var $239=(($4)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=(function() { try { __THREW__ = false; return _fprintf($240, ((STRING_TABLE.__str354989)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 22; break; };
    case 80: // $242
      __label__ = 81; break;
    case 81: // $243
      var $244=$is_disk;
      var $245=(($244) & 1);
      if ($245) { __label__ = 84; break; } else { __label__ = 82; break; }
    case 82: // $246
      var $247=(($4)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=$offset;
      var $250=(function() { try { __THREW__ = false; return _fprintf($248, ((STRING_TABLE.__str364990)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$249,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 22; break; };
    case 83: // $251
      __label__ = 87; break;
    case 84: // $252
      var $253=(($4)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=$rom;
      var $256=(($255+8)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(function() { try { __THREW__ = false; return _fprintf($254, ((STRING_TABLE.__str374991)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$257,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 22; break; };
    case 85: // $259
      var $260=(($4)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$rom;
      var $263=(($262+16)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$264 & 16;
      var $266=(($265)|0)==16;
      var $267=$266 ? (((STRING_TABLE.__str394993)|0)) : (((STRING_TABLE.__str404994)|0));
      var $268=(function() { try { __THREW__ = false; return _fprintf($261, ((STRING_TABLE.__str384992)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$267,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 22; break; };
    case 86: // $269
      __label__ = 87; break;
    case 87: // $270
      var $271=$is_disk;
      var $272=(($271) & 1);
      if ($272) { __label__ = 89; break; } else { __label__ = 88; break; }
    case 88: // $273
      var $274=$rom;
      var $275=(($274+16)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$276 & 32;
      var $278=(($277)|0)==32;
      if ($278) { __label__ = 91; break; } else { __label__ = 89; break; }
    case 89: // $279
      var $280=$is_disk;
      var $281=(($280) & 1);
      if ($281) { __label__ = 90; break; } else { __label__ = 93; break; }
    case 90: // $282
      var $283=$rom;
      var $284=(($283+16)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=$285 & 32;
      var $287=(($286)|0)==32;
      if ($287) { __label__ = 91; break; } else { __label__ = 93; break; }
    case 91: // $288
      var $289=(($4)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(function() { try { __THREW__ = false; return _fprintf($290, ((STRING_TABLE.__str414995)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 22; break; };
    case 92: // $292
      __label__ = 93; break;
    case 93: // $293
      var $294=(($4)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=(function() { try { __THREW__ = false; return _fprintf($295, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 22; break; };
    case 94: // $297
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes);
      __label__ = 95; break;
    case 95: // $298
      var $299=$rom;
      var $300=__Z13rom_next_filePK9rom_entry($299);
      $rom=$300;
      __label__ = 12; break;
    case 96: // $301
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($hashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 106; break; }
    case 97: // $302
      __label__ = 105; break;
    case 98: // $303
      __label__ = 99; break;
    case 99: // $304
      var $305=$region;
      var $306=__Z15rom_next_regionPK9rom_entry($305);
      $region=$306;
      __label__ = 5; break;
    case 100: // $307
      __label__ = 101; break;
    case 101: // $308
      var $309=$source;
      var $310=__Z15rom_next_sourceRK8device_t($309);
      $source=$310;
      __label__ = 3; break;
    case 102: // $311
      __label__ = 103; break;
    case 103: // $312
      var $313=$rom_type;
      var $314=(($313+1)|0);
      $rom_type=$314;
      __label__ = 1; break;
    case 104: // $315
      STACKTOP = __stackBase__;
      return;
    case 105: // $316
      var $317=$2;
      var $318=$2;
      var $319=$3;
      var $320=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $318, tempValue);
      var $321=($320.f1 = $319, $320);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 106: // $322
      var $323=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator10output_romEv["X"]=1;

function __ZN16info_xml_creator14output_displayEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      var $visarea;
      var $pixclock;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config12first_screenEv($5);
      $device=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$device;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 23; break; }
    case 2: // $10
      var $11=(($2)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=_fprintf($12, ((STRING_TABLE.__str485002)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $14=$device;
      var $15=__ZNK13screen_device11screen_typeEv($14);
      if ($15 == 1) {
        __label__ = 3; break;
      }
      else if ($15 == 2) {
        __label__ = 4; break;
      }
      else if ($15 == 3) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 3: // $16
      var $17=(($2)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=_fprintf($18, ((STRING_TABLE.__str495003)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 4: // $20
      var $21=(($2)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=_fprintf($22, ((STRING_TABLE.__str505004)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 5: // $24
      var $25=(($2)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=_fprintf($26, ((STRING_TABLE.__str515005)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 6: // $28
      var $29=(($2)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=_fprintf($30, ((STRING_TABLE.__str525006)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 7: // $32
      var $33=(($2+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=__ZNK17driver_enumerator6driverEv($34);
      var $36=(($35+44)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$37 & 7;
      if ($38 == 1) {
        __label__ = 8; break;
      }
      else if ($38 == 2) {
        __label__ = 9; break;
      }
      else if ($38 == 3) {
        __label__ = 10; break;
      }
      else if ($38 == 4) {
        __label__ = 11; break;
      }
      else if ($38 == 5) {
        __label__ = 12; break;
      }
      else if ($38 == 6) {
        __label__ = 13; break;
      }
      else if ($38 == 7) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 8: // $39
      var $40=(($2)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=_fprintf($41, ((STRING_TABLE.__str535007)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 9: // $43
      var $44=(($2)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=_fprintf($45, ((STRING_TABLE.__str545008)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 10: // $47
      var $48=(($2)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=_fprintf($49, ((STRING_TABLE.__str555009)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 11: // $51
      var $52=(($2)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=_fprintf($53, ((STRING_TABLE.__str565010)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 12: // $55
      var $56=(($2)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=_fprintf($57, ((STRING_TABLE.__str575011)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 13: // $59
      var $60=(($2)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=_fprintf($61, ((STRING_TABLE.__str585012)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 14: // $63
      var $64=(($2)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=_fprintf($65, ((STRING_TABLE.__str595013)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 15: // $67
      var $68=(($2)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=_fprintf($69, ((STRING_TABLE.__str605014)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 16: // $71
      var $72=$device;
      var $73=__ZNK13screen_device11screen_typeEv($72);
      var $74=(($73)|0)!=2;
      if ($74) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $75
      var $76=$device;
      var $77=__ZNK13screen_device12visible_areaEv($76);
      $visarea=$77;
      var $78=(($2)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$visarea;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$visarea;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82-$85)|0);
      var $87=(($86+1)|0);
      var $88=_fprintf($79, ((STRING_TABLE.__str615015)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$87,tempInt));
      var $89=(($2)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$visarea;
      var $92=(($91+12)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$visarea;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($93-$96)|0);
      var $98=(($97+1)|0);
      var $99=_fprintf($90, ((STRING_TABLE.__str625016)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$98,tempInt));
      __label__ = 18; break;
    case 18: // $100
      var $101=(($2)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$device;
      var $104=__ZNK13screen_device19refresh_attosecondsEv($103);
      var $104$0=$104[0];
      var $104$1=$104[1];
      var $105=$104$0 + $104$1*4294967296;
      var $106=1000000000000000000/$105;
      var $107=_fprintf($102, ((STRING_TABLE.__str635017)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$106,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      var $108=$device;
      var $109=__ZNK13screen_device11screen_typeEv($108);
      var $110=(($109)|0)!=2;
      if ($110) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $111
      var $112=$device;
      var $113=__ZNK13screen_device24oldstyle_vblank_suppliedEv($112);
      if ($113) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $114
      var $115=$device;
      var $116=__ZNK13screen_device5widthEv($115);
      var $117=$device;
      var $118=__ZNK13screen_device6heightEv($117);
      var $119=(($116*$118)|0);
      var $120=(($119)|0);
      var $121=$device;
      var $122=__ZNK13screen_device19refresh_attosecondsEv($121);
      var $122$0=$122[0];
      var $122$1=$122[1];
      var $123=$122$0 + $122$1*4294967296;
      var $124=1000000000000000000/$123;
      var $125=$120*$124;
      var $126=(($125)|0);
      $pixclock=$126;
      var $127=(($2)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$pixclock;
      var $130=_fprintf($128, ((STRING_TABLE.__str645018)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$129,tempInt));
      var $131=(($2)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$device;
      var $134=__ZNK13screen_device5widthEv($133);
      var $135=_fprintf($132, ((STRING_TABLE.__str655019)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,tempInt));
      var $136=(($2)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$device;
      var $139=__ZNK13screen_device12visible_areaEv($138);
      var $140=(($139)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=_fprintf($137, ((STRING_TABLE.__str665020)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$141,tempInt));
      var $143=(($2)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$device;
      var $146=__ZNK13screen_device12visible_areaEv($145);
      var $147=(($146+4)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+1)|0);
      var $150=_fprintf($144, ((STRING_TABLE.__str675021)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,tempInt));
      var $151=(($2)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$device;
      var $154=__ZNK13screen_device6heightEv($153);
      var $155=_fprintf($152, ((STRING_TABLE.__str685022)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$154,tempInt));
      var $156=(($2)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$device;
      var $159=__ZNK13screen_device12visible_areaEv($158);
      var $160=(($159+8)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=_fprintf($157, ((STRING_TABLE.__str695023)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$161,tempInt));
      var $163=(($2)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$device;
      var $166=__ZNK13screen_device12visible_areaEv($165);
      var $167=(($166+12)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+1)|0);
      var $170=_fprintf($164, ((STRING_TABLE.__str705024)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$169,tempInt));
      __label__ = 21; break;
    case 21: // $171
      var $172=(($2)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=_fprintf($173, ((STRING_TABLE.__str715025)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 22; break;
    case 22: // $175
      var $176=$device;
      var $177=__ZNK13screen_device11next_screenEv($176);
      $device=$177;
      __label__ = 1; break;
    case 23: // $178
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator14output_displayEv["X"]=1;

function __ZN16info_xml_creator12output_soundEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $speakers;
      var $sound=__stackBase__;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=HEAP32[((_SPEAKER)>>2)];
      var $8=__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE($6, $7);
      $speakers=$8;
      HEAP32[(($sound)>>2)]=0;
      var $9=(($2+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK17driver_enumerator6configEv($10);
      var $12=__ZNK14machine_config10devicelistEv($11);
      var $13=__ZNK11device_list5firstIK22device_sound_interfaceEEbRPT_($12, $sound);
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      $speakers=0;
      __label__ = 2; break;
    case 2: // $15
      var $16=(($2)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$speakers;
      var $19=_fprintf($17, ((STRING_TABLE.__str725026)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,tempInt));
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16info_xml_creator12output_inputERK11tagged_listI17input_port_configE($this, $portlist) {
  var __stackBase__  = STACKTOP; STACKTOP += 168; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $DIR_LEFTRIGHT;
      var $DIR_UPDOWN;
      var $DIR_4WAY;
      var $DIR_DUAL;
      var $control_info=__stackBase__;
      var $nplayer;
      var $nbutton;
      var $ncoin;
      var $joytype;
      var $service;
      var $tilt;
      var $keypad;
      var $keyboard;
      var $port;
      var $field;
      var $analogtype;
      var $vertical;
      var $doubletype;
      var $way;
      var $type;
      $1=$this;
      $2=$portlist;
      var $3=$1;
      $DIR_LEFTRIGHT=1;
      $DIR_UPDOWN=2;
      $DIR_4WAY=4;
      $DIR_DUAL=8;
      var $4=$control_info;
      _memset($4, 0, 168, 1);
      $nplayer=0;
      $nbutton=0;
      $ncoin=0;
      $joytype=0;
      $service=0;
      $tilt=0;
      $keypad=0;
      $keyboard=0;
      var $5=$2;
      var $6=__ZNK11tagged_listI17input_port_configE5firstEv($5);
      $port=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$port;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 45; break; }
    case 2: // $10
      var $11=$port;
      var $12=__ZN17input_port_config9fieldlistEv($11);
      var $13=__ZNK11simple_listI18input_field_configE5firstEv($12);
      $field=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$field;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 43; break; }
    case 4: // $17
      $analogtype=-1;
      var $18=$nplayer;
      var $19=$field;
      var $20=(($19+28)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($22+1)|0);
      var $24=(($18)|0) < (($23)|0);
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=$field;
      var $27=(($26+28)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=(($29+1)|0);
      $nplayer=$30;
      __label__ = 6; break;
    case 6: // $31
      var $32=$field;
      var $33=(($32+24)|0);
      var $34=HEAP32[(($33)>>2)];
      if ($34 == 53 || $34 == 54 || $34 == 57 || $34 == 58) {
        __label__ = 7; break;
      }
      else if ($34 == 49 || $34 == 50) {
        __label__ = 8; break;
      }
      else if ($34 == 51 || $34 == 52 || $34 == 55 || $34 == 56) {
        __label__ = 9; break;
      }
      else if ($34 == 47 || $34 == 48) {
        __label__ = 10; break;
      }
      else if ($34 == 140) {
        __label__ = 11; break;
      }
      else if ($34 == 152) {
        __label__ = 12; break;
      }
      else if ($34 == 154 || $34 == 155) {
        __label__ = 13; break;
      }
      else if ($34 == 142 || $34 == 143) {
        __label__ = 14; break;
      }
      else if ($34 == 145 || $34 == 146) {
        __label__ = 15; break;
      }
      else if ($34 == 147 || $34 == 148 || $34 == 149) {
        __label__ = 16; break;
      }
      else if ($34 == 59 || $34 == 60 || $34 == 61 || $34 == 62 || $34 == 63 || $34 == 64 || $34 == 65 || $34 == 66 || $34 == 67 || $34 == 68 || $34 == 69 || $34 == 70 || $34 == 71 || $34 == 72 || $34 == 73 || $34 == 74) {
        __label__ = 17; break;
      }
      else if ($34 == 17 || $34 == 18 || $34 == 19 || $34 == 20 || $34 == 21 || $34 == 22 || $34 == 23 || $34 == 24) {
        __label__ = 21; break;
      }
      else if ($34 == 45) {
        __label__ = 25; break;
      }
      else if ($34 == 46) {
        __label__ = 26; break;
      }
      else if ($34 == 38) {
        __label__ = 27; break;
      }
      else if ($34 == 39) {
        __label__ = 28; break;
      }
      else {
      __label__ = 29; break;
      }
      
    case 7: // $35
      var $36=$joytype;
      var $37=(($36)&255);
      var $38=$37 | 8;
      var $39=(($38) & 255);
      $joytype=$39;
      __label__ = 8; break;
    case 8: // $40
      var $41=$field;
      var $42=(($41+384)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==4;
      var $46=$45 ? 4 : 0;
      var $47=1 | $46;
      var $48=$joytype;
      var $49=(($48)&255);
      var $50=$49 | $47;
      var $51=(($50) & 255);
      $joytype=$51;
      __label__ = 29; break;
    case 9: // $52
      var $53=$joytype;
      var $54=(($53)&255);
      var $55=$54 | 8;
      var $56=(($55) & 255);
      $joytype=$56;
      __label__ = 10; break;
    case 10: // $57
      var $58=$field;
      var $59=(($58+384)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $62=(($61)|0)==4;
      var $63=$62 ? 4 : 0;
      var $64=2 | $63;
      var $65=$joytype;
      var $66=(($65)&255);
      var $67=$66 | $64;
      var $68=(($67) & 255);
      $joytype=$68;
      __label__ = 29; break;
    case 11: // $69
      $analogtype=3;
      var $70=(($control_info+84)|0);
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=((STRING_TABLE.__str735027)|0);
      __label__ = 29; break;
    case 12: // $72
      $analogtype=1;
      var $73=(($control_info+28)|0);
      var $74=(($73)|0);
      HEAP32[(($74)>>2)]=((STRING_TABLE.__str745028)|0);
      $analogtype=1;
      __label__ = 29; break;
    case 13: // $75
      $analogtype=2;
      var $76=(($control_info+56)|0);
      var $77=(($76)|0);
      HEAP32[(($77)>>2)]=((STRING_TABLE.__str755029)|0);
      $analogtype=2;
      __label__ = 29; break;
    case 14: // $78
      $analogtype=0;
      var $79=(($control_info)|0);
      var $80=(($79)|0);
      HEAP32[(($80)>>2)]=((STRING_TABLE.__str765030)|0);
      __label__ = 29; break;
    case 15: // $81
      $analogtype=4;
      var $82=(($control_info+112)|0);
      var $83=(($82)|0);
      HEAP32[(($83)>>2)]=((STRING_TABLE.__str775031)|0);
      __label__ = 29; break;
    case 16: // $84
      $analogtype=5;
      var $85=(($control_info+140)|0);
      var $86=(($85)|0);
      HEAP32[(($86)>>2)]=((STRING_TABLE.__str785032)|0);
      __label__ = 29; break;
    case 17: // $87
      var $88=$nbutton;
      var $89=$field;
      var $90=(($89+24)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91-59)|0);
      var $93=(($92+1)|0);
      var $94=(($88)>>>0) > (($93)>>>0);
      if ($94) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $95
      var $96=$nbutton;
      var $104 = $96;__label__ = 20; break;
    case 19: // $97
      var $98=$field;
      var $99=(($98+24)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100-59)|0);
      var $102=(($101+1)|0);
      var $104 = $102;__label__ = 20; break;
    case 20: // $103
      var $104;
      $nbutton=$104;
      __label__ = 29; break;
    case 21: // $105
      var $106=$ncoin;
      var $107=$field;
      var $108=(($107+24)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109-17)|0);
      var $111=(($110+1)|0);
      var $112=(($106)>>>0) > (($111)>>>0);
      if ($112) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $113
      var $114=$ncoin;
      var $122 = $114;__label__ = 24; break;
    case 23: // $115
      var $116=$field;
      var $117=(($116+24)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118-17)|0);
      var $120=(($119+1)|0);
      var $122 = $120;__label__ = 24; break;
    case 24: // $121
      var $122;
      $ncoin=$122;
      __label__ = 29; break;
    case 25: // $123
      $keypad=1;
      __label__ = 29; break;
    case 26: // $124
      $keyboard=1;
      __label__ = 29; break;
    case 27: // $125
      $service=1;
      __label__ = 29; break;
    case 28: // $126
      $tilt=1;
      __label__ = 29; break;
    case 29: // $127
      var $128=$analogtype;
      var $129=(($128)|0)!=-1;
      if ($129) { __label__ = 30; break; } else { __label__ = 41; break; }
    case 30: // $130
      var $131=$field;
      var $132=(($131+300)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $135
      var $136=$field;
      var $137=(($136+300)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$analogtype;
      var $140=(($control_info+$139*28)|0);
      var $141=(($140+8)|0);
      HEAP32[(($141)>>2)]=$138;
      __label__ = 32; break;
    case 32: // $142
      var $143=$field;
      var $144=(($143+304)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145)|0)!=0;
      if ($146) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $147
      var $148=$field;
      var $149=(($148+304)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$analogtype;
      var $152=(($control_info+$151*28)|0);
      var $153=(($152+12)|0);
      HEAP32[(($153)>>2)]=$150;
      __label__ = 34; break;
    case 34: // $154
      var $155=$field;
      var $156=(($155+308)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $159
      var $160=$field;
      var $161=(($160+308)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$analogtype;
      var $164=(($control_info+$163*28)|0);
      var $165=(($164+16)|0);
      HEAP32[(($165)>>2)]=$162;
      __label__ = 36; break;
    case 36: // $166
      var $167=$field;
      var $168=(($167+312)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169)|0)!=0;
      if ($170) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $171
      var $172=$field;
      var $173=(($172+312)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$analogtype;
      var $176=(($control_info+$175*28)|0);
      var $177=(($176+20)|0);
      HEAP32[(($177)>>2)]=$174;
      __label__ = 38; break;
    case 38: // $178
      var $179=$field;
      var $180=(($179+32)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=$181 & 16;
      var $183=(($182)|0)!=0;
      if ($183) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $184
      var $185=$analogtype;
      var $186=(($control_info+$185*28)|0);
      var $187=(($186+24)|0);
      HEAP8[($187)]=1;
      __label__ = 40; break;
    case 40: // $188
      __label__ = 41; break;
    case 41: // $189
      __label__ = 42; break;
    case 42: // $190
      var $191=$field;
      var $192=__ZNK18input_field_config4nextEv($191);
      $field=$192;
      __label__ = 3; break;
    case 43: // $193
      __label__ = 44; break;
    case 44: // $194
      var $195=$port;
      var $196=__ZNK17input_port_config4nextEv($195);
      $port=$196;
      __label__ = 1; break;
    case 45: // $197
      var $198=(($3)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=_fprintf($199, ((STRING_TABLE.__str795033)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $201=(($3)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=$nplayer;
      var $204=_fprintf($202, ((STRING_TABLE.__str805034)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$203,tempInt));
      var $205=$nbutton;
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $207
      var $208=(($3)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$nbutton;
      var $211=_fprintf($209, ((STRING_TABLE.__str815035)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$210,tempInt));
      __label__ = 47; break;
    case 47: // $212
      var $213=$ncoin;
      var $214=(($213)|0)!=0;
      if ($214) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $215
      var $216=(($3)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=$ncoin;
      var $219=_fprintf($217, ((STRING_TABLE.__str825036)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$218,tempInt));
      __label__ = 49; break;
    case 49: // $220
      var $221=$service;
      var $222=(($221) & 1);
      if ($222) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $223
      var $224=(($3)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=_fprintf($225, ((STRING_TABLE.__str835037)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 51; break;
    case 51: // $227
      var $228=$tilt;
      var $229=(($228) & 1);
      if ($229) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $230
      var $231=(($3)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=_fprintf($232, ((STRING_TABLE.__str845038)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 53; break;
    case 53: // $234
      var $235=(($3)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=_fprintf($236, ((STRING_TABLE.__str124966)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $238=$joytype;
      var $239=(($238)&255);
      var $240=(($239)|0)!=0;
      if ($240) { __label__ = 54; break; } else { __label__ = 62; break; }
    case 54: // $241
      var $242=$joytype;
      var $243=(($242)&255);
      var $244=$243 & 1;
      var $245=(($244)|0)==0;
      var $246=$245 ? (((STRING_TABLE.__str855039)|0)) : (((__str865040)|0));
      $vertical=$246;
      var $247=$joytype;
      var $248=(($247)&255);
      var $249=$248 & 8;
      var $250=(($249)|0)!=0;
      var $251=$250 ? (((STRING_TABLE.__str875041)|0)) : (((STRING_TABLE.__str885042)|0));
      $doubletype=$251;
      var $252=$joytype;
      var $253=(($252)&255);
      var $254=$253 & 1;
      var $255=(($254)|0)==0;
      if ($255) { __label__ = 56; break; } else { __label__ = 55; break; }
    case 55: // $256
      var $257=$joytype;
      var $258=(($257)&255);
      var $259=$258 & 2;
      var $260=(($259)|0)==0;
      if ($260) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $261
      var $272 = STRING_TABLE.__str895043;__label__ = 61; break;
    case 57: // $262
      var $263=$joytype;
      var $264=(($263)&255);
      var $265=$264 & 4;
      var $266=(($265)|0)!=0;
      if ($266) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $267
      var $270 = STRING_TABLE.__str905044;__label__ = 60; break;
    case 59: // $268
      var $270 = STRING_TABLE.__str915045;__label__ = 60; break;
    case 60: // $269
      var $270;
      var $272 = $270;__label__ = 61; break;
    case 61: // $271
      var $272;
      var $273=(($272)|0);
      $way=$273;
      var $274=(($3)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=$vertical;
      var $277=$doubletype;
      var $278=$way;
      var $279=_fprintf($275, ((STRING_TABLE.__str925046)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$276,HEAP32[((tempInt+4)>>2)]=$277,HEAP32[((tempInt+8)>>2)]=$278,tempInt));
      __label__ = 62; break;
    case 62: // $280
      $type=0;
      __label__ = 63; break;
    case 63: // $281
      var $282=$type;
      var $283=(($282)|0) < 6;
      if ($283) { __label__ = 64; break; } else { __label__ = 77; break; }
    case 64: // $284
      var $285=$type;
      var $286=(($control_info+$285*28)|0);
      var $287=(($286)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=(($288)|0)!=0;
      if ($289) { __label__ = 65; break; } else { __label__ = 75; break; }
    case 65: // $290
      var $291=(($3)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=$type;
      var $294=(($control_info+$293*28)|0);
      var $295=(($294)|0);
      var $296=HEAP32[(($295)>>2)];
      var $297=__Z20xml_normalize_stringPKc($296);
      var $298=_fprintf($292, ((STRING_TABLE.__str935047)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$297,tempInt));
      var $299=$type;
      var $300=(($control_info+$299*28)|0);
      var $301=(($300+8)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=(($302)|0)!=0;
      if ($303) { __label__ = 67; break; } else { __label__ = 66; break; }
    case 66: // $304
      var $305=$type;
      var $306=(($control_info+$305*28)|0);
      var $307=(($306+12)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=(($308)|0)!=0;
      if ($309) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $310
      var $311=(($3)|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=$type;
      var $314=(($control_info+$313*28)|0);
      var $315=(($314+8)|0);
      var $316=HEAP32[(($315)>>2)];
      var $317=_fprintf($312, ((STRING_TABLE.__str945048)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$316,tempInt));
      var $318=(($3)|0);
      var $319=HEAP32[(($318)>>2)];
      var $320=$type;
      var $321=(($control_info+$320*28)|0);
      var $322=(($321+12)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=_fprintf($319, ((STRING_TABLE.__str955049)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$323,tempInt));
      __label__ = 68; break;
    case 68: // $325
      var $326=$type;
      var $327=(($control_info+$326*28)|0);
      var $328=(($327+16)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=(($329)|0)!=0;
      if ($330) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $331
      var $332=(($3)|0);
      var $333=HEAP32[(($332)>>2)];
      var $334=$type;
      var $335=(($control_info+$334*28)|0);
      var $336=(($335+16)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=_fprintf($333, ((STRING_TABLE.__str965050)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$337,tempInt));
      __label__ = 70; break;
    case 70: // $339
      var $340=$type;
      var $341=(($control_info+$340*28)|0);
      var $342=(($341+20)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(($343)|0)!=0;
      if ($344) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $345
      var $346=(($3)|0);
      var $347=HEAP32[(($346)>>2)];
      var $348=$type;
      var $349=(($control_info+$348*28)|0);
      var $350=(($349+20)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=_fprintf($347, ((STRING_TABLE.__str975051)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$351,tempInt));
      __label__ = 72; break;
    case 72: // $353
      var $354=$type;
      var $355=(($control_info+$354*28)|0);
      var $356=(($355+24)|0);
      var $357=HEAP8[($356)];
      var $358=(($357) & 1);
      if ($358) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $359
      var $360=(($3)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=_fprintf($361, ((STRING_TABLE.__str985052)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 74; break;
    case 74: // $363
      var $364=(($3)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=_fprintf($365, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 75; break;
    case 75: // $367
      __label__ = 76; break;
    case 76: // $368
      var $369=$type;
      var $370=(($369+1)|0);
      $type=$370;
      __label__ = 63; break;
    case 77: // $371
      var $372=$keypad;
      var $373=(($372) & 1);
      if ($373) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $374
      var $375=(($3)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=_fprintf($376, ((STRING_TABLE.__str995053)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 79; break;
    case 79: // $378
      var $379=$keyboard;
      var $380=(($379) & 1);
      if ($380) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $381
      var $382=(($3)|0);
      var $383=HEAP32[(($382)>>2)];
      var $384=_fprintf($383, ((STRING_TABLE.__str1005054)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 81; break;
    case 81: // $385
      var $386=(($3)|0);
      var $387=HEAP32[(($386)>>2)];
      var $388=_fprintf($387, ((STRING_TABLE.__str1015055)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator12output_inputERK11tagged_listI17input_port_configE["X"]=1;

function __ZN16info_xml_creator15output_switchesERK11tagged_listI17input_port_configEiPKcS6_($this, $portlist, $type, $outertag, $innertag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $port;
      var $field;
      var $setting;
      $1=$this;
      $2=$portlist;
      $3=$type;
      $4=$outertag;
      $5=$innertag;
      var $6=$1;
      var $7=$2;
      var $8=__ZNK11tagged_listI17input_port_configE5firstEv($7);
      $port=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$port;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $12
      var $13=$port;
      var $14=__ZN17input_port_config9fieldlistEv($13);
      var $15=__ZNK11simple_listI18input_field_configE5firstEv($14);
      $field=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$field;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $19
      var $20=$field;
      var $21=(($20+24)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$3;
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $25
      var $26=(($6)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$4;
      var $29=$field;
      var $30=__Z16input_field_namePK18input_field_config($29);
      var $31=__Z20xml_normalize_stringPKc($30);
      var $32=_fprintf($27, ((STRING_TABLE.__str1025056)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,HEAP32[((tempInt+4)>>2)]=$31,tempInt));
      var $33=(($6)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$field;
      var $36=__ZNK18input_field_config4portEv($35);
      var $37=__ZNK17input_port_config3tagEv($36);
      var $38=__Z20xml_normalize_stringPKc($37);
      var $39=_fprintf($34, ((STRING_TABLE.__str454999)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$38,tempInt));
      var $40=(($6)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$field;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_fprintf($41, ((STRING_TABLE.__str1035057)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$44,tempInt));
      var $46=(($6)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=_fprintf($47, ((STRING_TABLE.__str124966)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $49=$field;
      var $50=__ZN18input_field_config11settinglistEv($49);
      var $51=__ZNK11simple_listI20input_setting_configE5firstEv($50);
      $setting=$51;
      __label__ = 6; break;
    case 6: // $52
      var $53=$setting;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $55
      var $56=(($6)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$5;
      var $59=$setting;
      var $60=(($59+20)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__Z20xml_normalize_stringPKc($61);
      var $63=_fprintf($57, ((STRING_TABLE.__str1045058)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$58,HEAP32[((tempInt+4)>>2)]=$62,tempInt));
      var $64=(($6)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$setting;
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=_fprintf($65, ((STRING_TABLE.__str1055059)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$68,tempInt));
      var $70=$setting;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$field;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($72)|0)==(($75)|0);
      if ($76) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $77
      var $78=(($6)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=_fprintf($79, ((STRING_TABLE.__str254979)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $81
      var $82=(($6)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=_fprintf($83, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 10; break;
    case 10: // $85
      var $86=$setting;
      var $87=__ZNK20input_setting_config4nextEv($86);
      $setting=$87;
      __label__ = 6; break;
    case 11: // $88
      var $89=(($6)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$4;
      var $92=_fprintf($90, ((STRING_TABLE.__str1065060)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$91,tempInt));
      __label__ = 12; break;
    case 12: // $93
      __label__ = 13; break;
    case 13: // $94
      var $95=$field;
      var $96=__ZNK18input_field_config4nextEv($95);
      $field=$96;
      __label__ = 3; break;
    case 14: // $97
      __label__ = 15; break;
    case 15: // $98
      var $99=$port;
      var $100=__ZNK17input_port_config4nextEv($99);
      $port=$100;
      __label__ = 1; break;
    case 16: // $101
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator15output_switchesERK11tagged_listI17input_port_configEiPKcS6_["X"]=1;

function __ZN16info_xml_creator17output_categoriesERK11tagged_listI17input_port_configE($this, $portlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $port;
      var $field;
      var $setting;
      $1=$this;
      $2=$portlist;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11tagged_listI17input_port_configE5firstEv($4);
      $port=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$port;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $9
      var $10=$port;
      var $11=__ZN17input_port_config9fieldlistEv($10);
      var $12=__ZNK11simple_listI18input_field_configE5firstEv($11);
      $field=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$field;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $16
      var $17=$field;
      var $18=(($17+24)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==8;
      if ($20) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $21
      var $22=(($3)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$field;
      var $25=__Z16input_field_namePK18input_field_config($24);
      var $26=__Z20xml_normalize_stringPKc($25);
      var $27=_fprintf($23, ((STRING_TABLE.__str1275081)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,tempInt));
      var $28=$field;
      var $29=__ZN18input_field_config11settinglistEv($28);
      var $30=__ZNK11simple_listI20input_setting_configE5firstEv($29);
      $setting=$30;
      __label__ = 6; break;
    case 6: // $31
      var $32=$setting;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $34
      var $35=(($3)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$setting;
      var $38=(($37+20)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=__Z20xml_normalize_stringPKc($39);
      var $41=_fprintf($36, ((STRING_TABLE.__str1285082)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,tempInt));
      var $42=$setting;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$field;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($44)|0)==(($47)|0);
      if ($48) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $49
      var $50=(($3)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=_fprintf($51, ((STRING_TABLE.__str254979)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $53
      var $54=(($3)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=_fprintf($55, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 10; break;
    case 10: // $57
      var $58=$setting;
      var $59=__ZNK20input_setting_config4nextEv($58);
      $setting=$59;
      __label__ = 6; break;
    case 11: // $60
      var $61=(($3)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=_fprintf($62, ((STRING_TABLE.__str1295083)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 12; break;
    case 12: // $64
      __label__ = 13; break;
    case 13: // $65
      var $66=$field;
      var $67=__ZNK18input_field_config4nextEv($66);
      $field=$67;
      __label__ = 3; break;
    case 14: // $68
      __label__ = 15; break;
    case 15: // $69
      var $70=$port;
      var $71=__ZNK17input_port_config4nextEv($70);
      $port=$71;
      __label__ = 1; break;
    case 16: // $72
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator17output_categoriesERK11tagged_listI17input_port_configE["X"]=1;

function __ZN16info_xml_creator16output_adjustersERK11tagged_listI17input_port_configE($this, $portlist) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $port;
      var $field;
      $1=$this;
      $2=$portlist;
      var $3=$1;
      var $4=$2;
      var $5=__ZNK11tagged_listI17input_port_configE5firstEv($4);
      $port=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$port;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $9
      var $10=$port;
      var $11=__ZN17input_port_config9fieldlistEv($10);
      var $12=__ZNK11simple_listI18input_field_configE5firstEv($11);
      $field=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$field;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $16
      var $17=$field;
      var $18=(($17+24)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==158;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=(($3)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$field;
      var $25=__Z16input_field_namePK18input_field_config($24);
      var $26=__Z20xml_normalize_stringPKc($25);
      var $27=$field;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=_fprintf($23, ((STRING_TABLE.__str1075061)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=$29,tempInt));
      __label__ = 6; break;
    case 6: // $31
      __label__ = 7; break;
    case 7: // $32
      var $33=$field;
      var $34=__ZNK18input_field_config4nextEv($33);
      $field=$34;
      __label__ = 3; break;
    case 8: // $35
      __label__ = 9; break;
    case 9: // $36
      var $37=$port;
      var $38=__ZNK17input_port_config4nextEv($37);
      $port=$38;
      __label__ = 1; break;
    case 10: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16info_xml_creator13output_driverEv($this) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=_fprintf($4, ((STRING_TABLE.__str1085062)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $6=(($2+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__ZNK17driver_enumerator6driverEv($7);
      var $9=(($8+44)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 568;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=(($2)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=_fprintf($15, ((STRING_TABLE.__str1095063)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 2: // $17
      var $18=(($2+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK17driver_enumerator6driverEv($19);
      var $21=(($20+44)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$22 & 1216;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=(($2)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=_fprintf($27, ((STRING_TABLE.__str1105064)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 5; break;
    case 4: // $29
      var $30=(($2)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=_fprintf($31, ((STRING_TABLE.__str1115065)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 5; break;
    case 5: // $33
      __label__ = 6; break;
    case 6: // $34
      var $35=(($2+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=__ZNK17driver_enumerator6driverEv($36);
      var $38=(($37+44)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39 & 8;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      var $43=(($2)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_fprintf($44, ((STRING_TABLE.__str1125066)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 8: // $46
      var $47=(($2)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=_fprintf($48, ((STRING_TABLE.__str1135067)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $50
      var $51=(($2+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=__ZNK17driver_enumerator6driverEv($52);
      var $54=(($53+44)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55 & 32;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $58
      var $59=(($2)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=_fprintf($60, ((STRING_TABLE.__str1145068)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 15; break;
    case 11: // $62
      var $63=(($2+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=__ZNK17driver_enumerator6driverEv($64);
      var $66=(($65+44)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$67 & 64;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $70
      var $71=(($2)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=_fprintf($72, ((STRING_TABLE.__str1155069)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 14; break;
    case 13: // $74
      var $75=(($2)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=_fprintf($76, ((STRING_TABLE.__str1165070)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 14; break;
    case 14: // $78
      __label__ = 15; break;
    case 15: // $79
      var $80=(($2+4)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=__ZNK17driver_enumerator6driverEv($81);
      var $83=(($82+44)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$84 & 512;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $87
      var $88=(($2)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=_fprintf($89, ((STRING_TABLE.__str1175071)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 21; break;
    case 17: // $91
      var $92=(($2+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=__ZNK17driver_enumerator6driverEv($93);
      var $95=(($94+44)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$96 & 1024;
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $99
      var $100=(($2)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=_fprintf($101, ((STRING_TABLE.__str1185072)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 20; break;
    case 19: // $103
      var $104=(($2)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=_fprintf($105, ((STRING_TABLE.__str1195073)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 20; break;
    case 20: // $107
      __label__ = 21; break;
    case 21: // $108
      var $109=(($2+4)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=__ZNK17driver_enumerator6driverEv($110);
      var $112=(($111+44)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113 & 128;
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $116
      var $117=(($2)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=_fprintf($118, ((STRING_TABLE.__str1205074)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 24; break;
    case 23: // $120
      var $121=(($2)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=_fprintf($122, ((STRING_TABLE.__str1215075)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 24; break;
    case 24: // $124
      var $125=(($2+4)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=__ZNK17driver_enumerator6driverEv($126);
      var $128=(($127+44)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$129 & 256;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $132
      var $133=(($2)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=_fprintf($134, ((STRING_TABLE.__str1225076)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 26; break;
    case 26: // $136
      var $137=(($2+4)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=__ZNK17driver_enumerator6driverEv($138);
      var $140=(($139+44)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$141 & 16;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $144
      var $145=(($2)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=_fprintf($146, ((STRING_TABLE.__str1235077)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 28; break;
    case 28: // $148
      var $149=(($2+4)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=__ZNK17driver_enumerator6driverEv($150);
      var $152=(($151+44)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=$153 & 2048;
      var $155=(($154)|0)!=0;
      if ($155) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $156
      var $157=(($2)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=_fprintf($158, ((STRING_TABLE.__str1245078)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 31; break;
    case 30: // $160
      var $161=(($2)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=_fprintf($162, ((STRING_TABLE.__str1255079)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 31; break;
    case 31: // $164
      var $165=(($2)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($2+4)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=__ZNK17driver_enumerator6configEv($168);
      var $170=(($169+48)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=_fprintf($166, ((STRING_TABLE.__str1265080)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$171,tempInt));
      var $173=(($2)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=_fprintf($174, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator13output_driverEv["X"]=1;

function __ZN16info_xml_creator12output_slotsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $slot=__stackBase__;
      var $gotone;
      var $intf;
      var $i;
      $1=$this;
      var $2=$1;
      HEAP32[(($slot)>>2)]=0;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=__ZNK11device_list5firstIK21device_slot_interfaceEEbRPT_($6, $slot);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $12
      var $13=(($2)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=HEAP32[(($slot)>>2)];
      var $16=$15;
      var $17=__ZNK16device_interface6deviceEv($16);
      var $18=__ZNK8device_t3tagEv($17);
      var $19=__Z20xml_normalize_stringPKc($18);
      var $20=_fprintf($14, ((STRING_TABLE.__str1385092)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt));
      var $21=HEAP32[(($slot)>>2)];
      var $22=__ZNK21device_slot_interface19get_slot_interfacesEv($21);
      $intf=$22;
      $i=0;
      __label__ = 3; break;
    case 3: // $23
      var $24=$i;
      var $25=$intf;
      var $26=(($25+($24<<3))|0);
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $30
      var $31=(($2)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=_fprintf($32, ((STRING_TABLE.__str1395093)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $34=(($2)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$i;
      var $37=$intf;
      var $38=(($37+($36<<3))|0);
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=__Z20xml_normalize_stringPKc($40);
      var $42=_fprintf($35, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$41,tempInt));
      var $43=HEAP32[(($slot)>>2)];
      var $44=__ZNK21device_slot_interface16get_default_cardEv($43);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $46
      var $47=HEAP32[(($slot)>>2)];
      var $48=__ZNK21device_slot_interface16get_default_cardEv($47);
      var $49=$i;
      var $50=$intf;
      var $51=(($50+($49<<3))|0);
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($48)|0)==(($53)|0);
      if ($54) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $55
      var $56=(($2)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=_fprintf($57, ((STRING_TABLE.__str254979)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 7: // $59
      __label__ = 8; break;
    case 8: // $60
      var $61=(($2)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=_fprintf($62, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $64
      var $65=$i;
      var $66=(($65+1)|0);
      $i=$66;
      __label__ = 3; break;
    case 10: // $67
      var $68=(($2)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=_fprintf($69, ((STRING_TABLE.__str1405094)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 11; break;
    case 11: // $71
      var $72=HEAP32[(($slot)>>2)];
      var $73=$72;
      var $74=__ZNK16device_interface4nextIK21device_slot_interfaceEEbRPT_($73, $slot);
      var $75=(($74)&1);
      $gotone=$75;
      __label__ = 1; break;
    case 12: // $76
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator12output_slotsEv["X"]=1;

function __ZN16info_xml_creator13output_imagesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $dev=__stackBase__;
      var $gotone;
      var $name;
      var $shortname;
      var $extensions=__stackBase__+4;
      var $ext;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      HEAP32[(($dev)>>2)]=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__ZNK17driver_enumerator6configEv($6);
      var $8=__ZNK14machine_config10devicelistEv($7);
      var $9=__ZNK11device_list5firstIK22device_image_interfaceEEbRPT_($8, $dev);
      var $10=(($9)&1);
      $gotone=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$gotone;
      var $13=(($12) & 1);
      if ($13) { __label__ = 2; break; } else { __label__ = 24; break; }
    case 2: // $14
      var $15=(($4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=HEAP32[(($dev)>>2)];
      var $18=__ZNK22device_image_interface15image_type_nameEv($17);
      var $19=__Z20xml_normalize_stringPKc($18);
      var $20=_fprintf($16, ((STRING_TABLE.__str1305084)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt));
      var $21=HEAP32[(($dev)>>2)];
      var $22=$21;
      var $23=__ZNK16device_interface6deviceEv($22);
      var $24=__ZNK8device_t3tagEv($23);
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=(($4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=HEAP32[(($dev)>>2)];
      var $30=$29;
      var $31=__ZNK16device_interface6deviceEv($30);
      var $32=__ZNK8device_t3tagEv($31);
      var $33=__Z20xml_normalize_stringPKc($32);
      var $34=_fprintf($28, ((STRING_TABLE.__str454999)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$33,tempInt));
      __label__ = 4; break;
    case 4: // $35
      var $36=HEAP32[(($dev)>>2)];
      var $37=$36;
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+112)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=FUNCTION_TABLE[$40]($36);
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      var $43=(($4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_fprintf($44, ((STRING_TABLE.__str1315085)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 6: // $46
      var $47=HEAP32[(($dev)>>2)];
      var $48=$47;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+120)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=FUNCTION_TABLE[$51]($47);
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $54
      var $55=HEAP32[(($dev)>>2)];
      var $56=$55;
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+120)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=FUNCTION_TABLE[$59]($55);
      var $61=(($60)|0);
      var $62=HEAP8[($61)];
      var $63=(($62 << 24) >> 24)!=0;
      if ($63) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $64
      var $65=(($4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=HEAP32[(($dev)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+120)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=FUNCTION_TABLE[$71]($67);
      var $73=__Z20xml_normalize_stringPKc($72);
      var $74=_fprintf($66, ((STRING_TABLE.__str1325086)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,tempInt));
      __label__ = 9; break;
    case 9: // $75
      var $76=(($4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=_fprintf($77, ((STRING_TABLE.__str124966)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $79=HEAP32[(($dev)>>2)];
      var $80=__ZNK22device_image_interface13instance_nameEv($79);
      $name=$80;
      var $81=HEAP32[(($dev)>>2)];
      var $82=__ZNK22device_image_interface19brief_instance_nameEv($81);
      $shortname=$82;
      var $83=(($4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=_fprintf($84, ((STRING_TABLE.__str1335087)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $86=(($4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$name;
      var $89=__Z20xml_normalize_stringPKc($88);
      var $90=_fprintf($87, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$89,tempInt));
      var $91=(($4)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$shortname;
      var $94=__Z20xml_normalize_stringPKc($93);
      var $95=_fprintf($92, ((STRING_TABLE.__str1345088)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$94,tempInt));
      var $96=(($4)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=_fprintf($97, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $99=HEAP32[(($dev)>>2)];
      var $100=$99;
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101+124)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=FUNCTION_TABLE[$103]($99);
      __ZN7astringC1EPKc($extensions, $104);
      var $105=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($extensions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 19; break; };
    case 10: // $106
      var $107=(function() { try { __THREW__ = false; return _strtok($105, ((STRING_TABLE.__str1355089)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 19; break; };
    case 11: // $108
      $ext=$107;
      __label__ = 12; break;
    case 12: // $109
      var $110=$ext;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $112
      var $113=(($4)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(function() { try { __THREW__ = false; return _fprintf($114, ((STRING_TABLE.__str1365090)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 19; break; };
    case 14: // $116
      var $117=(($4)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$ext;
      var $120=(function() { try { __THREW__ = false; return __Z20xml_normalize_stringPKc($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; };
    case 15: // $121
      var $122=(function() { try { __THREW__ = false; return _fprintf($118, ((STRING_TABLE.__str54959)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$120,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; };
    case 16: // $123
      var $124=(($4)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(function() { try { __THREW__ = false; return _fprintf($125, ((STRING_TABLE.__str264980)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $127
      var $128=(function() { try { __THREW__ = false; return _strtok(0, ((STRING_TABLE.__str1355089)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; };
    case 18: // $129
      $ext=$128;
      __label__ = 12; break;
    case 19: // $130
      var $131=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $132=$131.f0;
      $2=$132;
      var $133=$131.f1;
      $3=$133;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($extensions) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 20: // $134
      var $135=(($4)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return _fprintf($136, ((STRING_TABLE.__str1375091)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 19; break; };
    case 21: // $138
      FUNCTION_TABLE[__ZN7astringD1Ev]($extensions);
      __label__ = 22; break;
    case 22: // $139
      var $140=HEAP32[(($dev)>>2)];
      var $141=$140;
      var $142=__ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_($141, $dev);
      var $143=(($142)&1);
      $gotone=$143;
      __label__ = 1; break;
    case 23: // $144
      __label__ = 25; break;
    case 24: // $145
      STACKTOP = __stackBase__;
      return;
    case 25: // $146
      var $147=$2;
      var $148=$2;
      var $149=$3;
      var $150=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $148, tempValue);
      var $151=($150.f1 = $149, $150);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $152
      var $153=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator13output_imagesEv["X"]=1;

function __ZNK13screen_device24oldstyle_vblank_suppliedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+360)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN22debug_view_source_listC2ER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  var $6=(($3+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+8)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($3+12)|0);
  HEAP32[(($8)>>2)]=0;
  ;
  return;
}


function __ZNK22debug_view_source_list7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN22debug_view_source_list6appendER17debug_view_source($this, $source) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$source;
      var $3=$1;
      var $4=$2;
      var $5=(($4+4)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=(($3+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($3+8)|0);
      HEAP32[(($11)>>2)]=$10;
      var $12=(($3+4)|0);
      HEAP32[(($12)>>2)]=$10;
      __label__ = 3; break;
    case 2: // $13
      var $14=$2;
      var $15=(($3+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+4)|0);
      HEAP32[(($17)>>2)]=$14;
      __label__ = 3; break;
    case 3: // $18
      var $19=$2;
      var $20=(($3+8)|0);
      HEAP32[(($20)>>2)]=$19;
      var $21=(($3+12)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+1)|0);
      HEAP32[(($21)>>2)]=$23;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22debug_view_source_list12match_deviceEP8device_t($this, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $source;
      $2=$this;
      $3=$device;
      var $4=$2;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $source=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$source;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$3;
      var $12=$source;
      var $13=(($12+72)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($11)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$source;
      $1=$17;
      __label__ = 7; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$source;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      $source=$22;
      __label__ = 1; break;
    case 6: // $23
      var $24=(($4+4)|0);
      var $25=HEAP32[(($24)>>2)];
      $1=$25;
      __label__ = 7; break;
    case 7: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16info_xml_creator20output_software_listEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $dev;
      var $swlist;
      var $i;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__ZNK17driver_enumerator6configEv($4);
      var $6=__ZNK14machine_config10devicelistEv($5);
      var $7=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $8=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($6, $7);
      $dev=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$dev;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $12
      var $13=$dev;
      var $14=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($13);
      var $15=__ZNK18legacy_device_base13inline_configEv($14);
      var $16=$15;
      $swlist=$16;
      $i=0;
      __label__ = 3; break;
    case 3: // $17
      var $18=$i;
      var $19=(($18)|0) < 9;
      if ($19) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $20
      var $21=$i;
      var $22=$swlist;
      var $23=(($22)|0);
      var $24=(($23+($21<<2))|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      var $28=(($2)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$i;
      var $31=$swlist;
      var $32=(($31)|0);
      var $33=(($32+($30<<2))|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=_fprintf($29, ((STRING_TABLE.__str1415095)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,tempInt));
      var $36=(($2)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$swlist;
      var $39=(($38+40)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==0;
      var $42=$41 ? (((STRING_TABLE.__str1435097)|0)) : (((STRING_TABLE.__str1445098)|0));
      var $43=_fprintf($37, ((STRING_TABLE.__str1425096)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,tempInt));
      __label__ = 6; break;
    case 6: // $44
      __label__ = 7; break;
    case 7: // $45
      var $46=$i;
      var $47=(($46+1)|0);
      $i=$47;
      __label__ = 3; break;
    case 8: // $48
      __label__ = 9; break;
    case 9: // $49
      var $50=$dev;
      var $51=__ZNK8device_t8typenextEv($50);
      $dev=$51;
      __label__ = 1; break;
    case 10: // $52
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator20output_software_listEv["X"]=1;

function __ZNK22device_image_interface15image_type_nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+96)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  var $8=__ZN22device_image_interface15device_typenameE10iodevice_t($7);
  ;
  return $8;
}


function __ZN17debug_view_sourceC2EPKcP8device_t($this, $name, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$name;
  $3=$device;
  var $4=$1;
  var $5=$4;
  HEAP32[(($5)>>2)]=((__ZTV17debug_view_source+8)|0);
  var $6=(($4+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($4+8)|0);
  var $8=$2;
  __ZN7astringC1EPKc($7, $8);
  var $9=(($4+72)|0);
  var $10=$3;
  HEAP32[(($9)>>2)]=$10;
  ;
  return;
}


function __ZN17debug_view_sourceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV17debug_view_source+8)|0);
  var $4=(($2+8)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($4);
  ;
  return;
}


function __ZN22debug_view_source_listD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN22debug_view_source_list5resetEv($2);
  ;
  return;
}


function __ZN22debug_view_source_list5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $source;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      $source=$9;
      var $10=$source;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($2+4)|0);
      HEAP32[(($13)>>2)]=$12;
      var $14=__ZNK22debug_view_source_list7machineEv($2);
      var $15=__ZN15running_machine7respoolEv($14);
      var $16=$source;
      var $17=$16;
      __ZN13resource_pool6removeEPv($15, $17);
      __label__ = 1; break;
    case 3: // $18
      var $19=(($2+8)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($2+12)|0);
      HEAP32[(($20)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16info_xml_creator17output_ramoptionsEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      var $ram;
      var $options=__stackBase__;
      var $start;
      var $end;
      var $2;
      var $3;
      var $option=__stackBase__+64;
      var $4;
      $1=$this;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__ZNK17driver_enumerator6configEv($7);
      var $9=__ZNK14machine_config10devicelistEv($8);
      var $10=HEAP32[((_RAM)>>2)];
      var $11=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($9, $10);
      $device=$11;
      __label__ = 1; break;
    case 1: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 29; break; }
    case 2: // $15
      var $16=$device;
      var $17=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($16);
      var $18=__ZNK18legacy_device_base13inline_configEv($17);
      var $19=$18;
      $ram=$19;
      var $20=(($5)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$ram;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__Z16ram_parse_stringPKc($24);
      var $26=_fprintf($21, ((STRING_TABLE.__str1455099)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$25,tempInt));
      var $27=$ram;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 3; break; } else { __label__ = 27; break; }
    case 3: // $31
      var $32=$ram;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      __ZN7astringC1EPKc($options, $34);
      $start=0;
      var $35=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($options, 0, 44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 15; break; };
    case 4: // $36
      $end=$35;
      __label__ = 5; break;
    case 5: // $37
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($option) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $38
      var $39=$start;
      var $40=$end;
      var $41=(($40)|0)==-1;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      var $48 = -1;__label__ = 9; break;
    case 8: // $43
      var $44=$end;
      var $45=$start;
      var $46=(($44-$45)|0);
      var $48 = $46;__label__ = 9; break;
    case 9: // $47
      var $48;
      var $49=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($option, $options, $39, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 16; break; };
    case 10: // $50
      var $51=(($5)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($option) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; };
    case 11: // $54
      var $55=(function() { try { __THREW__ = false; return __Z16ram_parse_stringPKc($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; };
    case 12: // $56
      var $57=(function() { try { __THREW__ = false; return _fprintf($52, ((STRING_TABLE.__str1465100)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; };
    case 13: // $58
      var $59=$end;
      var $60=(($59)|0)==-1;
      if ($60) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $61
      $4=5;
      __label__ = 18; break;
    case 15: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $2=$64;
      var $65=$63.f1;
      $3=$65;
      __label__ = 25; break;
    case 16: // $66
      var $67=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $68=$67.f0;
      $2=$68;
      var $69=$67.f1;
      $3=$69;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 31; break; }
    case 17: // $70
      $4=0;
      __label__ = 18; break;
    case 18: // $71
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($option) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; }
    case 19: // $72
      var $cleanup_dest=$4;
      if ($cleanup_dest == 0) {
        __label__ = 20; break;
      }
      else if ($cleanup_dest == 5) {
        __label__ = 24; break;
      }
      else {
      __label__ = 32; break;
      }
      
    case 20: // $73
      __label__ = 21; break;
    case 21: // $74
      var $75=$end;
      var $76=(($75+1)|0);
      $start=$76;
      var $77=$start;
      var $78=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($options, $77, 44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 15; break; };
    case 22: // $79
      $end=$78;
      __label__ = 5; break;
    case 23: // $80
      __label__ = 25; break;
    case 24: // $81
      FUNCTION_TABLE[__ZN7astringD1Ev]($options);
      __label__ = 27; break;
    case 25: // $82
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($options) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $83
      __label__ = 30; break;
    case 27: // $84
      __label__ = 28; break;
    case 28: // $85
      var $86=$device;
      var $87=__ZNK8device_t8typenextEv($86);
      $device=$87;
      __label__ = 1; break;
    case 29: // $88
      STACKTOP = __stackBase__;
      return;
    case 30: // $89
      var $90=$2;
      var $91=$2;
      var $92=$3;
      var $93=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $91, tempValue);
      var $94=($93.f1 = $92, $93);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 31: // $95
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 32: // $97
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator17output_ramoptionsEv["X"]=1;

function __ZN16info_xml_creator14get_merge_nameERK15hash_collection($this, $romhashes) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $merge_name;
      var $clone_of;
      var $psource;
      var $pregion;
      var $prom;
      var $phashes=__stackBase__;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$romhashes;
      var $6=$1;
      $merge_name=0;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($6+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK17driver_enumerator6driverEv($10);
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__ZN11driver_list4findEPKc($13);
      $clone_of=$14;
      __label__ = 1; break;
    case 1: // $15
      var $16=$clone_of;
      var $17=(($16)|0)!=-1;
      if ($17) { __label__ = 2; break; } else { __label__ = 25; break; }
    case 2: // $18
      var $19=(($6+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$clone_of;
      var $22=__ZNK17driver_enumerator6configEi($20, $21);
      var $23=__Z16rom_first_sourceRK14machine_config($22);
      $psource=$23;
      __label__ = 3; break;
    case 3: // $24
      var $25=$psource;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 23; break; }
    case 4: // $27
      var $28=$psource;
      var $29=__Z16rom_first_regionRK8device_t($28);
      $pregion=$29;
      __label__ = 5; break;
    case 5: // $30
      var $31=$pregion;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 21; break; }
    case 6: // $33
      var $34=$pregion;
      var $35=__Z14rom_first_filePK9rom_entry($34);
      $prom=$35;
      __label__ = 7; break;
    case 7: // $36
      var $37=$prom;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 8; break; } else { __label__ = 19; break; }
    case 8: // $39
      var $40=$prom;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      FUNCTION_TABLE[__ZN15hash_collectionC1EPKc]($phashes, $42);
      var $43=(function() { try { __THREW__ = false; return __ZNK15hash_collection4flagEc($phashes, 33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $44
      if ($43) { __label__ = 14; break; } else { __label__ = 10; break; }
    case 10: // $45
      var $46=$2;
      var $47=(function() { try { __THREW__ = false; return __ZNK15hash_collectioneqERKS_($46, $phashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $48
      if ($47) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $49
      var $50=$prom;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      $merge_name=$52;
      $5=11;
      __label__ = 15; break;
    case 13: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      $3=$55;
      var $56=$54.f1;
      $4=$56;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($phashes) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 27; break; }
    case 14: // $57
      $5=0;
      __label__ = 15; break;
    case 15: // $58
      FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($phashes);
      var $cleanup_dest=$5;
      if ($cleanup_dest == 0) {
        __label__ = 16; break;
      }
      else if ($cleanup_dest == 11) {
        __label__ = 19; break;
      }
      else {
      __label__ = 28; break;
      }
      
    case 16: // $59
      __label__ = 17; break;
    case 17: // $60
      var $61=$prom;
      var $62=__Z13rom_next_filePK9rom_entry($61);
      $prom=$62;
      __label__ = 7; break;
    case 18: // $63
      __label__ = 26; break;
    case 19: // $64
      __label__ = 20; break;
    case 20: // $65
      var $66=$pregion;
      var $67=__Z15rom_next_regionPK9rom_entry($66);
      $pregion=$67;
      __label__ = 5; break;
    case 21: // $68
      __label__ = 22; break;
    case 22: // $69
      var $70=$psource;
      var $71=__Z15rom_next_sourceRK8device_t($70);
      $psource=$71;
      __label__ = 3; break;
    case 23: // $72
      __label__ = 24; break;
    case 24: // $73
      var $74=(($6+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($6+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$clone_of;
      var $79=__ZN11driver_list6driverEi($78);
      var $80=(($79+4)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=__ZN11driver_list4findEPKc($81);
      $clone_of=$82;
      __label__ = 1; break;
    case 25: // $83
      var $84=$merge_name;
      STACKTOP = __stackBase__;
      return $84;
    case 26: // $85
      var $86=$3;
      var $87=$3;
      var $88=$4;
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 27: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 28: // $93
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16info_xml_creator14get_merge_nameERK15hash_collection["X"]=1;

function __ZN17debug_view_sourceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17debug_view_sourceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_sourceD0Ev["X"]=1;

function __ZN10debug_view11view_notifyE23debug_view_notification($this, $type) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$type;
  var $3=$1;
  ;
  return;
}


function __ZNK10debug_view7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+88)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN10debug_view27adjust_visible_x_for_cursorEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($2+56)|0);
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) < (($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($2+64)|0);
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($2+56)|0);
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$13;
      __label__ = 5; break;
    case 2: // $16
      var $17=(($2+64)|0);
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($2+56)|0);
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($2+40)|0);
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($22+$25)|0);
      var $27=(($26-1)|0);
      var $28=(($19)|0) >= (($27)|0);
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=(($2+64)|0);
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($2+40)|0);
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32-$35)|0);
      var $37=(($36+2)|0);
      var $38=(($2+56)|0);
      var $39=(($38)|0);
      HEAP32[(($39)>>2)]=$37;
      __label__ = 4; break;
    case 4: // $40
      __label__ = 5; break;
    case 5: // $41
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view27adjust_visible_y_for_cursorEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+64)|0);
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($2+56)|0);
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) < (($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=(($2+64)|0);
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($2+56)|0);
      var $15=(($14+4)|0);
      HEAP32[(($15)>>2)]=$13;
      __label__ = 5; break;
    case 2: // $16
      var $17=(($2+64)|0);
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($2+56)|0);
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($2+40)|0);
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($22+$25)|0);
      var $27=(($26-1)|0);
      var $28=(($19)|0) >= (($27)|0);
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=(($2+64)|0);
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($2+40)|0);
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32-$35)|0);
      var $37=(($36+2)|0);
      var $38=(($2+56)|0);
      var $39=(($38+4)|0);
      HEAP32[(($39)>>2)]=$37;
      __label__ = 4; break;
    case 4: // $40
      __label__ = 5; break;
    case 5: // $41
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_viewD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV10debug_view+8)|0);
  var $4=(($2+16)|0);
  FUNCTION_TABLE[__ZN22debug_view_source_listD1Ev]($4);
  ;
  return;
}


function __ZN10debug_view17flush_osd_updatesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+77)|0);
      var $4=HEAP8[($3)];
      var $5=(($4) & 1);
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=(($2+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=(($2+32)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($2+36)|0);
      var $14=HEAP32[(($13)>>2)];
      FUNCTION_TABLE[$12]($2, $14);
      __label__ = 3; break;
    case 3: // $15
      var $16=(($2+77)|0);
      HEAP8[($16)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view16set_visible_sizeE13debug_view_xy($this, $size) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $size; $size = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($size)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($size+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($size)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($2+40)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=(($size+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($2+40)|0);
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($11)|0)!=(($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      __ZN10debug_view12begin_updateEv($2);
      var $17=(($2+40)|0);
      var $18=$17;
      var $19=$size;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[(($19)>>2)];HEAP32[(($18+4)>>2)]=HEAP32[(($19+4)>>2)];
      var $20=(($2+76)|0);
      HEAP8[($20)]=1;
      var $21=$2;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      FUNCTION_TABLE[$24]($2, 1);
      __ZN10debug_view10end_updateEv($2);
      __label__ = 3; break;
    case 3: // $25
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view20set_visible_positionE13debug_view_xy($this, $pos) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $pos; $pos = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($pos)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($pos+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($pos)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($2+56)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=(($pos+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($2+56)|0);
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($11)|0)!=(($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      __ZN10debug_view12begin_updateEv($2);
      var $17=(($2+56)|0);
      var $18=$17;
      var $19=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[(($19)>>2)];HEAP32[(($18+4)>>2)]=HEAP32[(($19+4)>>2)];
      var $20=(($2+76)|0);
      HEAP8[($20)]=1;
      var $21=$2;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      FUNCTION_TABLE[$24]($2, 1);
      __ZN10debug_view10end_updateEv($2);
      __label__ = 3; break;
    case 3: // $25
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view19set_cursor_positionE13debug_view_xy($this, $pos) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $pos; $pos = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($pos)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($pos+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($pos)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($2+64)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=(($pos+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($2+64)|0);
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($11)|0)!=(($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      __ZN10debug_view12begin_updateEv($2);
      var $17=(($2+64)|0);
      var $18=$17;
      var $19=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($18)>>2)]=HEAP32[(($19)>>2)];HEAP32[(($18+4)>>2)]=HEAP32[(($19+4)>>2)];
      var $20=(($2+76)|0);
      HEAP8[($20)]=1;
      var $21=$2;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      FUNCTION_TABLE[$24]($2, 2);
      __ZN10debug_view10end_updateEv($2);
      __label__ = 3; break;
    case 3: // $25
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view18set_cursor_visibleEb($this, $visible) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      var $3=(($visible)&1);
      $2=$3;
      var $4=$1;
      var $5=$2;
      var $6=(($5) & 1);
      var $7=(($6)&1);
      var $8=(($4+73)|0);
      var $9=HEAP8[($8)];
      var $10=(($9) & 1);
      var $11=(($10)&1);
      var $12=(($7)|0)!=(($11)|0);
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      __ZN10debug_view12begin_updateEv($4);
      var $14=$2;
      var $15=(($14) & 1);
      var $16=(($4+73)|0);
      var $17=(($15)&1);
      HEAP8[($16)]=$17;
      var $18=(($4+76)|0);
      HEAP8[($18)]=1;
      var $19=$4;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      FUNCTION_TABLE[$22]($4, 2);
      __ZN10debug_view10end_updateEv($4);
      __label__ = 2; break;
    case 2: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view10set_sourceERK17debug_view_source($this, $source) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$source;
      var $3=$1;
      var $4=$2;
      var $5=(($3+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4)|0)!=(($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __ZN10debug_view12begin_updateEv($3);
      var $9=$2;
      var $10=(($3+12)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=(($3+76)|0);
      HEAP8[($11)]=1;
      var $12=$3;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      FUNCTION_TABLE[$15]($3, 3);
      __ZN10debug_view10end_updateEv($3);
      __label__ = 2; break;
    case 2: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_($this, $machine, $type, $osdupdate, $osdprivate) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      $6=$this;
      $7=$machine;
      $8=$type;
      $9=$osdupdate;
      $10=$osdprivate;
      var $13=$6;
      var $14=$13;
      HEAP32[(($14)>>2)]=((__ZTV10debug_view+8)|0);
      var $15=(($13+4)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($13+8)|0);
      var $17=$8;
      HEAP32[(($16)>>2)]=$17;
      var $18=(($13+12)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($13+16)|0);
      var $20=$7;
      FUNCTION_TABLE[__ZN22debug_view_source_listC1ER15running_machine]($19, $20);
      var $21=(($13+32)|0);
      var $22=$9;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($13+36)|0);
      var $24=$10;
      HEAP32[(($23)>>2)]=$24;
      var $25=(($13+40)|0);
      (function() { try { __THREW__ = false; return __ZN13debug_view_xyC1Eii($25, 10, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $26
      var $27=(($13+48)|0);
      (function() { try { __THREW__ = false; return __ZN13debug_view_xyC1Eii($27, 10, 10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $28
      var $29=(($13+56)|0);
      (function() { try { __THREW__ = false; return __ZN13debug_view_xyC1Eii($29, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 16; break; }
    case 3: // $30
      var $31=(($13+64)|0);
      (function() { try { __THREW__ = false; return __ZN13debug_view_xyC1Eii($31, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $32
      var $33=(($13+72)|0);
      HEAP8[($33)]=0;
      var $34=(($13+73)|0);
      HEAP8[($34)]=0;
      var $35=(($13+74)|0);
      HEAP8[($35)]=1;
      var $36=(($13+75)|0);
      HEAP8[($36)]=0;
      var $37=(($13+76)|0);
      HEAP8[($37)]=1;
      var $38=(($13+77)|0);
      HEAP8[($38)]=1;
      var $39=(($13+80)|0);
      HEAP32[(($39)>>2)]=0;
      var $40=(($13+84)|0);
      HEAP32[(($40)>>2)]=0;
      var $41=(($13+88)|0);
      var $42=$7;
      HEAP32[(($41)>>2)]=$42;
      var $43=(($13+40)|0);
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($13+40)|0);
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($45*$48)|0);
      var $50=(($13+84)|0);
      HEAP32[(($50)>>2)]=$49;
      var $51=$7;
      var $52=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 16; break; };
    case 5: // $53
      var $54=(($13+84)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=_llvm_umul_with_overflow_i32($55, 2);
      var $57=$56.f1;
      var $58=$56.f0;
      var $59=$57 ? -1 : $58;
      var $60=$1;
      var $61=$2;
      var $62=$3;
      var $63=$result_i;
      var $64=$4;
      var $65=$5;
      HEAP32[(($1)>>2)]=$59;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($3)>>2)]=225;
      var $66=HEAP32[(($1)>>2)];
      var $67=HEAP32[(($2)>>2)];
      var $68=HEAP32[(($3)>>2)];
      var $69=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($66, $67, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $70
      HEAP32[(($result_i)>>2)]=$69;
      var $71=HEAP32[(($result_i)>>2)];
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $73
      var $74=___cxa_allocate_exception(4);
      var $75=$74;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($75);
      (function() { try { __THREW__ = false; return ___cxa_throw($74, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      HEAP32[(($4)>>2)]=$78;
      var $79=$77.f1;
      HEAP32[(($5)>>2)]=$79;
      var $80=HEAP32[(($5)>>2)];
      var $81=(($80)|0) < 0;
      if ($81) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $82
      var $83=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $_noexc
      throw "Reached an unreachable!"
    case 11: // $84
      var $85=HEAP32[(($4)>>2)];
      var $86=HEAP32[(($4)>>2)];
      var $87=HEAP32[(($5)>>2)];
      var $88=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $86, tempValue);
      var $89=($88.f1 = $87, $88);
      var $eh_lpad_body = $89;__label__ = 17; break;
    case 12: // $90
      throw "Reached an unreachable!"
    case 13: // $_ZnajPKci_exit
      var $91=HEAP32[(($result_i)>>2)];
      var $92=$1;
      var $93=$2;
      var $94=$3;
      var $95=$result_i;
      var $96=$4;
      var $97=$5;
      __label__ = 14; break;
    case 14: // $98
      var $99=$91;
      var $100=(($13+84)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(function() { try { __THREW__ = false; return __ZN13resource_pool9add_arrayI15debug_view_charEEPT_S3_i($52, $99, $101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; };
    case 15: // $103
      var $104=(($13+80)|0);
      HEAP32[(($104)>>2)]=$102;
      STACKTOP = __stackBase__;
      return;
    case 16: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $106;__label__ = 17; break;
    case 17: // $_body
      var $eh_lpad_body;
      var $107=$eh_lpad_body.f0;
      $11=$107;
      var $108=$eh_lpad_body.f1;
      $12=$108;
      var $109=(($13+16)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN22debug_view_source_listD1Ev]($109) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $110
      __label__ = 19; break;
    case 19: // $111
      var $112=$11;
      var $113=$11;
      var $114=$12;
      var $115=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $113, tempValue);
      var $116=($115.f1 = $114, $115);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_["X"]=1;

function __ZN13resource_pool9add_arrayI15debug_view_charEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI15debug_view_charEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI15debug_view_charEEPT_S3_i["X"]=1;

function __ZN10debug_viewD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10debug_viewD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10debug_viewD0Ev["X"]=1;

function __ZN10debug_view10end_updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $size;
      $6=$this;
      var $7=$6;
      var $8=(($7+75)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($10)|0)==1;
      if ($11) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $12
      __label__ = 2; break;
    case 2: // $13
      var $14=(($7+76)|0);
      var $15=HEAP8[($14)];
      var $16=(($15) & 1);
      if ($16) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $17
      var $18=(($7+76)|0);
      HEAP8[($18)]=0;
      var $19=(($7+77)|0);
      HEAP8[($19)]=1;
      var $20=(($7+40)|0);
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($7+40)|0);
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($22*$25)|0);
      $size=$26;
      var $27=$size;
      var $28=(($7+84)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($27)|0) > (($29)|0);
      if ($30) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $31
      var $32=$size;
      var $33=(($7+84)|0);
      HEAP32[(($33)>>2)]=$32;
      var $34=__ZNK10debug_view7machineEv($7);
      var $35=__ZN15running_machine7respoolEv($34);
      var $36=(($7+80)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$37;
      __ZN13resource_pool6removeEPv($35, $38);
      var $39=__ZNK10debug_view7machineEv($7);
      var $40=__ZN15running_machine7respoolEv($39);
      var $41=(($7+84)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=_llvm_umul_with_overflow_i32($42, 2);
      var $44=$43.f1;
      var $45=$43.f0;
      var $46=$44 ? -1 : $45;
      var $47=$1;
      var $48=$2;
      var $49=$3;
      var $50=$result_i;
      var $51=$4;
      var $52=$5;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($3)>>2)]=260;
      var $53=HEAP32[(($1)>>2)];
      var $54=HEAP32[(($2)>>2)];
      var $55=HEAP32[(($3)>>2)];
      var $56=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($53, $54, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $57
      HEAP32[(($result_i)>>2)]=$56;
      var $58=HEAP32[(($result_i)>>2)];
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $60
      var $61=___cxa_allocate_exception(4);
      var $62=$61;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($62);
      (function() { try { __THREW__ = false; return ___cxa_throw($61, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($4)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($5)>>2)]=$66;
      var $67=HEAP32[(($5)>>2)];
      var $68=(($67)|0) < 0;
      if ($68) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $69
      var $70=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($70);
      throw "Reached an unreachable!"
    case 9: // $71
      var $72=HEAP32[(($4)>>2)];
      var $73=HEAP32[(($4)>>2)];
      var $74=HEAP32[(($5)>>2)];
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $77
      throw "Reached an unreachable!"
    case 11: // $_ZnajPKci_exit
      var $78=HEAP32[(($result_i)>>2)];
      var $79=$1;
      var $80=$2;
      var $81=$3;
      var $82=$result_i;
      var $83=$4;
      var $84=$5;
      var $85=$78;
      var $86=(($7+84)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=__ZN13resource_pool9add_arrayI15debug_view_charEEPT_S3_i($40, $85, $87);
      var $89=(($7+80)|0);
      HEAP32[(($89)>>2)]=$88;
      __label__ = 12; break;
    case 12: // $90
      var $91=$7;
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92+8)|0);
      var $94=HEAP32[(($93)>>2)];
      FUNCTION_TABLE[$94]($7);
      __label__ = 2; break;
    case 13: // $95
      __label__ = 14; break;
    case 14: // $96
      var $97=(($7+75)|0);
      var $98=HEAP8[($97)];
      var $99=(($98-1)&255);
      HEAP8[($97)]=$99;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10debug_view10end_updateEv["X"]=1;

function __ZN10debug_view9view_charEi($this, $chval) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$chval;
  var $3=$1;
  ;
  return;
}


function __ZN18debug_view_managerC2ER15running_machine($this, $machine) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$machine;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  var $6=(($3+4)|0);
  HEAP32[(($6)>>2)]=0;
  ;
  return;
}


function __ZNK18debug_view_manager7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN18debug_view_manager6appendEP10debug_view($this, $view) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $viewptr;
      $1=$this;
      $2=$view;
      var $3=$1;
      var $4=(($3+4)|0);
      $viewptr=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$viewptr;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      __label__ = 3; break;
    case 3: // $10
      var $11=$viewptr;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      $viewptr=$13;
      __label__ = 1; break;
    case 4: // $14
      var $15=$2;
      var $16=$viewptr;
      HEAP32[(($16)>>2)]=$15;
      var $17=$2;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18debug_view_managerD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $oldhead;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      $oldhead=$9;
      var $10=$oldhead;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($2+4)|0);
      HEAP32[(($13)>>2)]=$12;
      var $14=__ZNK18debug_view_manager7machineEv($2);
      var $15=__ZN15running_machine7respoolEv($14);
      var $16=$oldhead;
      var $17=$16;
      __ZN13resource_pool6removeEPv($15, $17);
      __label__ = 1; break;
    case 3: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18debug_view_manager10alloc_viewE15debug_view_typePFvR10debug_viewPvES3_($this, $type, $osdupdate, $osdprivate) {
  var __stackBase__  = STACKTOP; STACKTOP += 180; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i13=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i9=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i5=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25=__stackBase__+108;
      var $26=__stackBase__+112;
      var $27=__stackBase__+116;
      var $28=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $result_i1=__stackBase__+132;
      var $31=__stackBase__+136;
      var $32=__stackBase__+140;
      var $33=__stackBase__+144;
      var $34=__stackBase__+148;
      var $35=__stackBase__+152;
      var $36=__stackBase__+156;
      var $37=__stackBase__+160;
      var $38=__stackBase__+164;
      var $result_i=__stackBase__+168;
      var $39=__stackBase__+172;
      var $40=__stackBase__+176;
      var $41;
      var $42;
      var $43;
      var $44;
      var $45;
      var $46;
      var $47;
      $42=$this;
      $43=$type;
      $44=$osdupdate;
      $45=$osdprivate;
      var $48=$42;
      var $49=$43;
      if ($49 == 1) {
        __label__ = 1; break;
      }
      else if ($49 == 2) {
        __label__ = 16; break;
      }
      else if ($49 == 3) {
        __label__ = 31; break;
      }
      else if ($49 == 4) {
        __label__ = 46; break;
      }
      else if ($49 == 5) {
        __label__ = 61; break;
      }
      else if ($49 == 6 || $49 == 7) {
        __label__ = 76; break;
      }
      else {
      __label__ = 77; break;
      }
      
    case 1: // $50
      var $51=__ZNK18debug_view_manager7machineEv($48);
      var $52=__ZN15running_machine7respoolEv($51);
      var $53=$36;
      var $54=$37;
      var $55=$38;
      var $56=$result_i;
      var $57=$39;
      var $58=$40;
      HEAP32[(($36)>>2)]=104;
      HEAP32[(($37)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($38)>>2)]=467;
      var $59=HEAP32[(($36)>>2)];
      var $60=HEAP32[(($37)>>2)];
      var $61=HEAP32[(($38)>>2)];
      var $62=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($59, $60, $61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $63
      HEAP32[(($result_i)>>2)]=$62;
      var $64=HEAP32[(($result_i)>>2)];
      var $65=(($64)|0)==0;
      if ($65) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $66
      var $67=___cxa_allocate_exception(4);
      var $68=$67;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($68);
      (function() { try { __THREW__ = false; return ___cxa_throw($67, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $71=$70.f0;
      HEAP32[(($39)>>2)]=$71;
      var $72=$70.f1;
      HEAP32[(($40)>>2)]=$72;
      var $73=HEAP32[(($40)>>2)];
      var $74=(($73)|0) < 0;
      if ($74) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $75
      var $76=HEAP32[(($39)>>2)];
      ___cxa_call_unexpected($76);
      throw "Reached an unreachable!"
    case 6: // $77
      var $78=HEAP32[(($39)>>2)];
      var $79=HEAP32[(($39)>>2)];
      var $80=HEAP32[(($40)>>2)];
      var $81=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $79, tempValue);
      var $82=($81.f1 = $80, $81);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $83
      throw "Reached an unreachable!"
    case 8: // $_ZnwjPKci_exit
      var $84=HEAP32[(($result_i)>>2)];
      var $85=$36;
      var $86=$37;
      var $87=$38;
      var $88=$result_i;
      var $89=$39;
      var $90=$40;
      var $91=$84;
      var $92=(function() { try { __THREW__ = false; return __ZNK18debug_view_manager7machineEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $93
      var $94=$44;
      var $95=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18debug_view_consoleC1ER15running_machinePFvR10debug_viewPvES4_]($91, $92, $94, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $96
      var $97=__ZN13resource_pool10add_objectI18debug_view_consoleEEPT_S3_($52, $91);
      var $98=$97;
      var $99=__ZN18debug_view_manager6appendEP10debug_view($48, $98);
      $41=$99;
      __label__ = 78; break;
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $46=$102;
      var $103=$101.f1;
      $47=$103;
      var $104=$33;
      var $105=$34;
      var $106=$35;
      HEAP32[(($33)>>2)]=$84;
      HEAP32[(($34)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($35)>>2)]=467;
      var $107=HEAP32[(($33)>>2)];
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $109
      var $110=HEAP32[(($33)>>2)];
      var $111=HEAP32[(($34)>>2)];
      var $112=HEAP32[(($35)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($110, $111, $112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 80; break; }
    case 13: // $_noexc
      __label__ = 14; break;
    case 14: // $_ZdlPvPKci_exit
      var $113=$33;
      var $114=$34;
      var $115=$35;
      __label__ = 15; break;
    case 15: // $116
      __label__ = 79; break;
    case 16: // $117
      var $118=__ZNK18debug_view_manager7machineEv($48);
      var $119=__ZN15running_machine7respoolEv($118);
      var $120=$28;
      var $121=$29;
      var $122=$30;
      var $123=$result_i1;
      var $124=$31;
      var $125=$32;
      HEAP32[(($28)>>2)]=108;
      HEAP32[(($29)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($30)>>2)]=470;
      var $126=HEAP32[(($28)>>2)];
      var $127=HEAP32[(($29)>>2)];
      var $128=HEAP32[(($30)>>2)];
      var $129=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($126, $127, $128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $130
      HEAP32[(($result_i1)>>2)]=$129;
      var $131=HEAP32[(($result_i1)>>2)];
      var $132=(($131)|0)==0;
      if ($132) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $133
      var $134=___cxa_allocate_exception(4);
      var $135=$134;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($135);
      (function() { try { __THREW__ = false; return ___cxa_throw($134, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      HEAP32[(($31)>>2)]=$138;
      var $139=$137.f1;
      HEAP32[(($32)>>2)]=$139;
      var $140=HEAP32[(($32)>>2)];
      var $141=(($140)|0) < 0;
      if ($141) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $142
      var $143=HEAP32[(($31)>>2)];
      ___cxa_call_unexpected($143);
      throw "Reached an unreachable!"
    case 21: // $144
      var $145=HEAP32[(($31)>>2)];
      var $146=HEAP32[(($31)>>2)];
      var $147=HEAP32[(($32)>>2)];
      var $148=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $146, tempValue);
      var $149=($148.f1 = $147, $148);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $150
      throw "Reached an unreachable!"
    case 23: // $_ZnwjPKci_exit2
      var $151=HEAP32[(($result_i1)>>2)];
      var $152=$28;
      var $153=$29;
      var $154=$30;
      var $155=$result_i1;
      var $156=$31;
      var $157=$32;
      var $158=$151;
      var $159=(function() { try { __THREW__ = false; return __ZNK18debug_view_manager7machineEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 26; break; };
    case 24: // $160
      var $161=$44;
      var $162=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_stateC1ER15running_machinePFvR10debug_viewPvES4_]($158, $159, $161, $162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $163
      var $164=__ZN13resource_pool10add_objectI16debug_view_stateEEPT_S3_($119, $158);
      var $165=$164;
      var $166=__ZN18debug_view_manager6appendEP10debug_view($48, $165);
      $41=$166;
      __label__ = 78; break;
    case 26: // $167
      var $168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $169=$168.f0;
      $46=$169;
      var $170=$168.f1;
      $47=$170;
      var $171=$25;
      var $172=$26;
      var $173=$27;
      HEAP32[(($25)>>2)]=$151;
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($27)>>2)]=470;
      var $174=HEAP32[(($25)>>2)];
      var $175=(($174)|0)!=0;
      if ($175) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $176
      var $177=HEAP32[(($25)>>2)];
      var $178=HEAP32[(($26)>>2)];
      var $179=HEAP32[(($27)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($177, $178, $179) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 80; break; }
    case 28: // $_noexc3
      __label__ = 29; break;
    case 29: // $_ZdlPvPKci_exit4
      var $180=$25;
      var $181=$26;
      var $182=$27;
      __label__ = 30; break;
    case 30: // $183
      __label__ = 79; break;
    case 31: // $184
      var $185=__ZNK18debug_view_manager7machineEv($48);
      var $186=__ZN15running_machine7respoolEv($185);
      var $187=$20;
      var $188=$21;
      var $189=$22;
      var $190=$result_i5;
      var $191=$23;
      var $192=$24;
      HEAP32[(($20)>>2)]=852;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($22)>>2)]=473;
      var $193=HEAP32[(($20)>>2)];
      var $194=HEAP32[(($21)>>2)];
      var $195=HEAP32[(($22)>>2)];
      var $196=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($193, $194, $195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 34; break; };
    case 32: // $197
      HEAP32[(($result_i5)>>2)]=$196;
      var $198=HEAP32[(($result_i5)>>2)];
      var $199=(($198)|0)==0;
      if ($199) { __label__ = 33; break; } else { __label__ = 38; break; }
    case 33: // $200
      var $201=___cxa_allocate_exception(4);
      var $202=$201;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($202);
      (function() { try { __THREW__ = false; return ___cxa_throw($201, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 34; break; }
    case 34: // $203
      var $204=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $205=$204.f0;
      HEAP32[(($23)>>2)]=$205;
      var $206=$204.f1;
      HEAP32[(($24)>>2)]=$206;
      var $207=HEAP32[(($24)>>2)];
      var $208=(($207)|0) < 0;
      if ($208) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $209
      var $210=HEAP32[(($23)>>2)];
      ___cxa_call_unexpected($210);
      throw "Reached an unreachable!"
    case 36: // $211
      var $212=HEAP32[(($23)>>2)];
      var $213=HEAP32[(($23)>>2)];
      var $214=HEAP32[(($24)>>2)];
      var $215=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $213, tempValue);
      var $216=($215.f1 = $214, $215);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $217
      throw "Reached an unreachable!"
    case 38: // $_ZnwjPKci_exit6
      var $218=HEAP32[(($result_i5)>>2)];
      var $219=$20;
      var $220=$21;
      var $221=$22;
      var $222=$result_i5;
      var $223=$23;
      var $224=$24;
      var $225=$218;
      var $226=(function() { try { __THREW__ = false; return __ZNK18debug_view_manager7machineEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 41; break; };
    case 39: // $227
      var $228=$44;
      var $229=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17debug_view_disasmC1ER15running_machinePFvR10debug_viewPvES4_]($225, $226, $228, $229) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $230
      var $231=__ZN13resource_pool10add_objectI17debug_view_disasmEEPT_S3_($186, $225);
      var $232=$231;
      var $233=__ZN18debug_view_manager6appendEP10debug_view($48, $232);
      $41=$233;
      __label__ = 78; break;
    case 41: // $234
      var $235=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $236=$235.f0;
      $46=$236;
      var $237=$235.f1;
      $47=$237;
      var $238=$17;
      var $239=$18;
      var $240=$19;
      HEAP32[(($17)>>2)]=$218;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($19)>>2)]=473;
      var $241=HEAP32[(($17)>>2)];
      var $242=(($241)|0)!=0;
      if ($242) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $243
      var $244=HEAP32[(($17)>>2)];
      var $245=HEAP32[(($18)>>2)];
      var $246=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($244, $245, $246) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 80; break; }
    case 43: // $_noexc7
      __label__ = 44; break;
    case 44: // $_ZdlPvPKci_exit8
      var $247=$17;
      var $248=$18;
      var $249=$19;
      __label__ = 45; break;
    case 45: // $250
      __label__ = 79; break;
    case 46: // $251
      var $252=__ZNK18debug_view_manager7machineEv($48);
      var $253=__ZN15running_machine7respoolEv($252);
      var $254=$12;
      var $255=$13;
      var $256=$14;
      var $257=$result_i9;
      var $258=$15;
      var $259=$16;
      HEAP32[(($12)>>2)]=904;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($14)>>2)]=476;
      var $260=HEAP32[(($12)>>2)];
      var $261=HEAP32[(($13)>>2)];
      var $262=HEAP32[(($14)>>2)];
      var $263=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($260, $261, $262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 49; break; };
    case 47: // $264
      HEAP32[(($result_i9)>>2)]=$263;
      var $265=HEAP32[(($result_i9)>>2)];
      var $266=(($265)|0)==0;
      if ($266) { __label__ = 48; break; } else { __label__ = 53; break; }
    case 48: // $267
      var $268=___cxa_allocate_exception(4);
      var $269=$268;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($269);
      (function() { try { __THREW__ = false; return ___cxa_throw($268, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 49; break; }
    case 49: // $270
      var $271=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $272=$271.f0;
      HEAP32[(($15)>>2)]=$272;
      var $273=$271.f1;
      HEAP32[(($16)>>2)]=$273;
      var $274=HEAP32[(($16)>>2)];
      var $275=(($274)|0) < 0;
      if ($275) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $276
      var $277=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($277);
      throw "Reached an unreachable!"
    case 51: // $278
      var $279=HEAP32[(($15)>>2)];
      var $280=HEAP32[(($15)>>2)];
      var $281=HEAP32[(($16)>>2)];
      var $282=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $280, tempValue);
      var $283=($282.f1 = $281, $282);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 52: // $284
      throw "Reached an unreachable!"
    case 53: // $_ZnwjPKci_exit10
      var $285=HEAP32[(($result_i9)>>2)];
      var $286=$12;
      var $287=$13;
      var $288=$14;
      var $289=$result_i9;
      var $290=$15;
      var $291=$16;
      var $292=$285;
      var $293=(function() { try { __THREW__ = false; return __ZNK18debug_view_manager7machineEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 56; break; };
    case 54: // $294
      var $295=$44;
      var $296=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17debug_view_memoryC1ER15running_machinePFvR10debug_viewPvES4_]($292, $293, $295, $296) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $297
      var $298=__ZN13resource_pool10add_objectI17debug_view_memoryEEPT_S3_($253, $292);
      var $299=$298;
      var $300=__ZN18debug_view_manager6appendEP10debug_view($48, $299);
      $41=$300;
      __label__ = 78; break;
    case 56: // $301
      var $302=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $303=$302.f0;
      $46=$303;
      var $304=$302.f1;
      $47=$304;
      var $305=$9;
      var $306=$10;
      var $307=$11;
      HEAP32[(($9)>>2)]=$285;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($11)>>2)]=476;
      var $308=HEAP32[(($9)>>2)];
      var $309=(($308)|0)!=0;
      if ($309) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $310
      var $311=HEAP32[(($9)>>2)];
      var $312=HEAP32[(($10)>>2)];
      var $313=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($311, $312, $313) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 80; break; }
    case 58: // $_noexc11
      __label__ = 59; break;
    case 59: // $_ZdlPvPKci_exit12
      var $314=$9;
      var $315=$10;
      var $316=$11;
      __label__ = 60; break;
    case 60: // $317
      __label__ = 79; break;
    case 61: // $318
      var $319=__ZNK18debug_view_manager7machineEv($48);
      var $320=__ZN15running_machine7respoolEv($319);
      var $321=$4;
      var $322=$5;
      var $323=$6;
      var $324=$result_i13;
      var $325=$7;
      var $326=$8;
      HEAP32[(($4)>>2)]=104;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($6)>>2)]=479;
      var $327=HEAP32[(($4)>>2)];
      var $328=HEAP32[(($5)>>2)];
      var $329=HEAP32[(($6)>>2)];
      var $330=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($327, $328, $329) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 64; break; };
    case 62: // $331
      HEAP32[(($result_i13)>>2)]=$330;
      var $332=HEAP32[(($result_i13)>>2)];
      var $333=(($332)|0)==0;
      if ($333) { __label__ = 63; break; } else { __label__ = 68; break; }
    case 63: // $334
      var $335=___cxa_allocate_exception(4);
      var $336=$335;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($336);
      (function() { try { __THREW__ = false; return ___cxa_throw($335, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 64; break; }
    case 64: // $337
      var $338=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $339=$338.f0;
      HEAP32[(($7)>>2)]=$339;
      var $340=$338.f1;
      HEAP32[(($8)>>2)]=$340;
      var $341=HEAP32[(($8)>>2)];
      var $342=(($341)|0) < 0;
      if ($342) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $343
      var $344=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($344);
      throw "Reached an unreachable!"
    case 66: // $345
      var $346=HEAP32[(($7)>>2)];
      var $347=HEAP32[(($7)>>2)];
      var $348=HEAP32[(($8)>>2)];
      var $349=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $347, tempValue);
      var $350=($349.f1 = $348, $349);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 67: // $351
      throw "Reached an unreachable!"
    case 68: // $_ZnwjPKci_exit14
      var $352=HEAP32[(($result_i13)>>2)];
      var $353=$4;
      var $354=$5;
      var $355=$6;
      var $356=$result_i13;
      var $357=$7;
      var $358=$8;
      var $359=$352;
      var $360=(function() { try { __THREW__ = false; return __ZNK18debug_view_manager7machineEv($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 71; break; };
    case 69: // $361
      var $362=$44;
      var $363=$45;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14debug_view_logC1ER15running_machinePFvR10debug_viewPvES4_]($359, $360, $362, $363) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $364
      var $365=__ZN13resource_pool10add_objectI14debug_view_logEEPT_S3_($320, $359);
      var $366=$365;
      var $367=__ZN18debug_view_manager6appendEP10debug_view($48, $366);
      $41=$367;
      __label__ = 78; break;
    case 71: // $368
      var $369=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $370=$369.f0;
      $46=$370;
      var $371=$369.f1;
      $47=$371;
      var $372=$1;
      var $373=$2;
      var $374=$3;
      HEAP32[(($1)>>2)]=$352;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str5105)|0);
      HEAP32[(($3)>>2)]=479;
      var $375=HEAP32[(($1)>>2)];
      var $376=(($375)|0)!=0;
      if ($376) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $377
      var $378=HEAP32[(($1)>>2)];
      var $379=HEAP32[(($2)>>2)];
      var $380=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($378, $379, $380) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 80; break; }
    case 73: // $_noexc15
      __label__ = 74; break;
    case 74: // $_ZdlPvPKci_exit16
      var $381=$1;
      var $382=$2;
      var $383=$3;
      __label__ = 75; break;
    case 75: // $384
      __label__ = 79; break;
    case 76: // $385
      __label__ = 77; break;
    case 77: // $386
      var $387=$43;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str15106)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$387,tempInt));
      throw "Reached an unreachable!"
    case 78: // $388
      var $389=$41;
      STACKTOP = __stackBase__;
      return $389;
    case 79: // $390
      var $391=$46;
      var $392=$46;
      var $393=$47;
      var $394=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $392, tempValue);
      var $395=($394.f1 = $393, $394);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 80: // $396
      var $397=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18debug_view_manager10alloc_viewE15debug_view_typePFvR10debug_viewPvES3_["X"]=1;

function __ZNK10debug_view4typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK10debug_view4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN18debug_view_manager9free_viewER10debug_view($this, $view) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $viewptr;
      $1=$this;
      $2=$view;
      var $3=$1;
      var $4=(($3+4)|0);
      $viewptr=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$viewptr;
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$viewptr;
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$viewptr;
      HEAP32[(($18)>>2)]=$17;
      var $19=__ZNK18debug_view_manager7machineEv($3);
      var $20=__ZN15running_machine7respoolEv($19);
      var $21=$2;
      var $22=$21;
      __ZN13resource_pool6removeEPv($20, $22);
      __label__ = 6; break;
    case 4: // $23
      __label__ = 5; break;
    case 5: // $24
      var $25=$viewptr;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+4)|0);
      $viewptr=$27;
      __label__ = 1; break;
    case 6: // $28
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN18debug_view_manager10update_allE15debug_view_type($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $view;
      $1=$this;
      $2=$type;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      $view=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$view;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $12
      var $13=$2;
      var $14=$view;
      var $15=__ZNK10debug_view4typeEv($14);
      var $16=(($13)|0)==(($15)|0);
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$view;
      __ZN10debug_view12force_updateEv($18);
      __label__ = 5; break;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=$view;
      var $22=__ZNK10debug_view4nextEv($21);
      $view=$22;
      __label__ = 1; break;
    case 7: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10debug_view12force_updateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10debug_view12begin_updateEv($2);
  var $3=(($2+76)|0);
  HEAP8[($3)]=1;
  __ZN10debug_view10end_updateEv($2);
  ;
  return;
}


function __ZN18debug_view_manager17flush_osd_updatesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $view;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      $view=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$view;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$view;
      __ZN10debug_view17flush_osd_updatesEv($9);
      __label__ = 3; break;
    case 3: // $10
      var $11=$view;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      $view=$13;
      __label__ = 1; break;
    case 4: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21debug_view_expression11set_contextEP12symbol_table($this, $context) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$context;
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=$2;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $13 = $8;__label__ = 3; break;
    case 2: // $9
      var $10=__ZNK21debug_view_expression7machineEv($3);
      var $11=__Z29debug_cpu_get_global_symtableR15running_machine($10);
      var $13 = $11;__label__ = 3; break;
    case 3: // $12
      var $13;
      __ZN17parsed_expression11set_symbolsEP12symbol_table($4, $13);
      var $14=(($3+4)|0);
      HEAP8[($14)]=1;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI18debug_view_consoleEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18debug_view_consoleEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI18debug_view_consoleEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI16debug_view_stateEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16debug_view_stateEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16debug_view_stateEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI17debug_view_disasmEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17debug_view_disasmEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17debug_view_disasmEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI17debug_view_memoryEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17debug_view_memoryEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI17debug_view_memoryEEPT_S3_["X"]=1;

function __ZN13resource_pool10add_objectI14debug_view_logEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14debug_view_logEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14debug_view_logEEPT_S3_["X"]=1;

function __ZN21debug_view_expressionC2ER15running_machine($this, $machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$machine;
      var $5=$1;
      var $6=(($5)|0);
      var $7=$2;
      HEAP32[(($6)>>2)]=$7;
      var $8=(($5+4)|0);
      HEAP8[($8)]=1;
      var $9=(($5+8)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$15$0=(($9)|0);
      HEAP32[(($st$15$0)>>2)]=$$emscripten$temp$0$0;
      var $st$15$1=(($9+4)|0);
      HEAP32[(($st$15$1)>>2)]=$$emscripten$temp$0$1;
      var $10=(($5+16)|0);
      var $11=$2;
      var $12=__Z29debug_cpu_get_global_symtableR15running_machine($11);
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($10, $12, 0, 0);
      var $13=(($5+640)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($13, ((STRING_TABLE.__str25107)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      ;
      return;
    case 2: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $3=$17;
      var $18=$16.f1;
      $4=$18;
      var $19=(($5+16)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$3;
      var $23=$3;
      var $24=$4;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21debug_view_expressionD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+640)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($4+16)|0);
      __ZN17parsed_expressionD1Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=(($4+16)|0);
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17parsed_expression11set_symbolsEP12symbol_table($this, $symtable) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$symtable;
  var $3=$1;
  var $4=$2;
  var $5=(($3)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZNK21debug_view_expression7machineEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectI14debug_view_logEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14debug_view_logEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14debug_view_logEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 104);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14debug_view_logE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14debug_view_logED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14debug_view_logED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI17debug_view_memoryEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17debug_view_memoryEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17debug_view_memoryEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 904);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17debug_view_memoryE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17debug_view_memoryED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17debug_view_memoryED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI17debug_view_disasmEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI17debug_view_disasmEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI17debug_view_disasmEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 852);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI17debug_view_disasmE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI17debug_view_disasmED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI17debug_view_disasmED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI16debug_view_stateEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16debug_view_stateEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16debug_view_stateEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 108);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16debug_view_stateE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16debug_view_stateED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16debug_view_stateED2Ev($2);
  ;
  return;
}


function __ZN21debug_view_expression9recomputeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $changed;
      var $oldstring=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $newresult=__stackBase__+64;
      var $5;
      $1=$this;
      var $6=$1;
      var $7=(($6+4)|0);
      var $8=HEAP8[($7)];
      var $9=(($8) & 1);
      var $10=(($9)&1);
      $changed=$10;
      var $11=(($6+4)|0);
      var $12=HEAP8[($11)];
      var $13=(($12) & 1);
      if ($13) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $14
      var $15=(($6+16)|0);
      var $16=__ZNK17parsed_expression15original_stringEv($15);
      __ZN7astringC1EPKc($oldstring, $16);
      var $17=(($6+16)|0);
      var $18=(($6+640)|0);
      var $19=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $20
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($17, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      __label__ = 10; break;
    case 4: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $29=(($27)|0)==(($28)|0);
      if ($29) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $30
      var $31=$2;
      var $32=___cxa_begin_catch($31);
      var $33=$32;
      $4=$33;
      var $34=(($6+16)|0);
      var $35=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($oldstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $36
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($34, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $37
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $38
      __label__ = 10; break;
    case 10: // $39
      FUNCTION_TABLE[__ZN7astringD1Ev]($oldstring);
      __label__ = 16; break;
    case 11: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $2=$42;
      var $43=$41.f1;
      $3=$43;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 27; break; }
    case 12: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $2=$46;
      var $47=$45.f1;
      $3=$47;
      __label__ = 14; break;
    case 13: // $48
      __label__ = 14; break;
    case 14: // $49
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($oldstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 27; break; }
    case 15: // $50
      __label__ = 26; break;
    case 16: // $51
      var $52=(($6+16)|0);
      var $53=__ZNK17parsed_expression8is_emptyEv($52);
      if ($53) { __label__ = 25; break; } else { __label__ = 17; break; }
    case 17: // $54
      var $55=(($6+16)|0);
      var $56=(function() { try { __THREW__ = false; return __ZN17parsed_expression7executeEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
      var $56$0=$56[0];
      var $56$1=$56[1];
    case 18: // $57
      var $st$0$0=(($newresult)|0);
      HEAP32[(($st$0$0)>>2)]=$56$0;
      var $st$0$1=(($newresult+4)|0);
      HEAP32[(($st$0$1)>>2)]=$56$1;
      var $st$4$0=(($newresult)|0);
      var $58$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($newresult+4)|0);
      var $58$1=HEAP32[(($st$4$1)>>2)];
      var $59=(($6+8)|0);
      var $st$9$0=(($59)|0);
      var $60$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($59+4)|0);
      var $60$1=HEAP32[(($st$9$1)>>2)];
      var $61=$58$0 != $60$0 || $58$1 != $60$1;
      if ($61) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $62
      var $st$0$0=(($newresult)|0);
      var $63$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($newresult+4)|0);
      var $63$1=HEAP32[(($st$0$1)>>2)];
      var $64=(($6+8)|0);
      var $st$5$0=(($64)|0);
      HEAP32[(($st$5$0)>>2)]=$63$0;
      var $st$5$1=(($64+4)|0);
      HEAP32[(($st$5$1)>>2)]=$63$1;
      $changed=1;
      __label__ = 24; break;
    case 20: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $67=$66.f0;
      $2=$67;
      var $68=$66.f1;
      $3=$68;
      __label__ = 21; break;
    case 21: // $69
      var $70=$3;
      var $71=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $72=(($70)|0)==(($71)|0);
      if ($72) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $73
      var $74=$2;
      var $75=___cxa_begin_catch($74);
      var $76=$75;
      $5=$76;
      ___cxa_end_catch();
      __label__ = 23; break;
    case 23: // $77
      __label__ = 25; break;
    case 24: // $78
      __label__ = 23; break;
    case 25: // $79
      var $80=(($6+4)|0);
      HEAP8[($80)]=0;
      var $81=$changed;
      var $82=(($81) & 1);
      STACKTOP = __stackBase__;
      return $82;
    case 26: // $83
      var $84=$2;
      var $85=$2;
      var $86=$3;
      var $87=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $85, tempValue);
      var $88=($87.f1 = $86, $87);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 27: // $89
      var $90=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21debug_view_expression9recomputeEv["X"]=1;

function __ZN20resource_pool_objectI14debug_view_logED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14debug_view_logED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14debug_view_logED0Ev["X"]=1;

function __ZN20resource_pool_objectI14debug_view_logED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI14debug_view_logE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI17debug_view_memoryED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17debug_view_memoryED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17debug_view_memoryED0Ev["X"]=1;

function __ZN20resource_pool_objectI17debug_view_memoryED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI17debug_view_memoryE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI17debug_view_disasmED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI17debug_view_disasmED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI17debug_view_disasmED0Ev["X"]=1;

function __ZN20resource_pool_objectI17debug_view_disasmED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI17debug_view_disasmE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI16debug_view_stateED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16debug_view_stateED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16debug_view_stateED0Ev["X"]=1;

function __ZNK12sound_stream11input_countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12sound_stream12output_countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+44)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN20resource_pool_objectI18debug_view_consoleEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI18debug_view_consoleEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI18debug_view_consoleEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 104);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI18debug_view_consoleE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI18debug_view_consoleED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI18debug_view_consoleED2Ev($2);
  ;
  return;
}


function __ZN19resource_pool_arrayI15debug_view_charEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI15debug_view_charEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI15debug_view_charEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=((($8<<1))|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI15debug_view_charE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI15debug_view_charED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI15debug_view_charED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN22device_sound_interface11sound_routeEEC1ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$2;
  __ZN11simple_listIN22device_sound_interface11sound_routeEEC2ER13resource_pool($3, $4);
  ;
  return;
}


function __ZN11simple_listIN22device_sound_interface11sound_routeEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN11simple_listIN22device_sound_interface11sound_routeEED2Ev($2);
  ;
  return;
}


function __ZN11simple_listIN22device_sound_interface11sound_routeEE5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+4)|0);
      var $9=HEAP32[(($8)>>2)];
      __ZN11simple_listIN22device_sound_interface11sound_routeEE6removeERS1_($2, $9);
      __label__ = 1; break;
    case 3: // $10
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22device_sound_interface6inputsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $inputs;
      var $stream;
      $1=$this;
      var $2=$1;
      $inputs=0;
      var $3=$2;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=__ZNK15running_machine5soundEv($6);
      var $8=__ZNK13sound_manager12first_streamEv($7);
      $stream=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$stream;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$stream;
      var $14=__ZNK12sound_stream6deviceEv($13);
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($14)|0)==(($17)|0);
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$stream;
      var $21=__ZNK12sound_stream11input_countEv($20);
      var $22=$inputs;
      var $23=(($22+$21)|0);
      $inputs=$23;
      __label__ = 4; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$stream;
      var $27=__ZNK12sound_stream4nextEv($26);
      $stream=$27;
      __label__ = 1; break;
    case 6: // $28
      var $29=$inputs;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13sound_manager12first_streamEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+40)|0);
  var $4=__ZNK11simple_listI12sound_streamE5firstEv($3);
  ;
  return $4;
}


function __ZNK22device_sound_interface7outputsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $outputs;
      var $stream;
      $1=$this;
      var $2=$1;
      $outputs=0;
      var $3=$2;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=__ZNK15running_machine5soundEv($6);
      var $8=__ZNK13sound_manager12first_streamEv($7);
      $stream=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$stream;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$stream;
      var $14=__ZNK12sound_stream6deviceEv($13);
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($14)|0)==(($17)|0);
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$stream;
      var $21=__ZNK12sound_stream12output_countEv($20);
      var $22=$outputs;
      var $23=(($22+$21)|0);
      $outputs=$23;
      __label__ = 4; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$stream;
      var $27=__ZNK12sound_stream4nextEv($26);
      $stream=$27;
      __label__ = 1; break;
    case 6: // $28
      var $29=$outputs;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_sound_interface21input_to_stream_inputEiRi($this, $inputnum, $stream_inputnum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $stream;
      $2=$this;
      $3=$inputnum;
      $4=$stream_inputnum;
      var $5=$2;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=$5;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK8device_t7machineEv($10);
      var $12=__ZNK15running_machine5soundEv($11);
      var $13=__ZNK13sound_manager12first_streamEv($12);
      $stream=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$stream;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $17
      var $18=$stream;
      var $19=__ZNK12sound_stream6deviceEv($18);
      var $20=$5;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($19)|0)==(($22)|0);
      if ($23) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $24
      var $25=$3;
      var $26=$stream;
      var $27=__ZNK12sound_stream11input_countEv($26);
      var $28=(($25)|0) < (($27)|0);
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      var $30=$3;
      var $31=$4;
      HEAP32[(($31)>>2)]=$30;
      var $32=$stream;
      $1=$32;
      __label__ = 11; break;
    case 7: // $33
      var $34=$stream;
      var $35=__ZNK12sound_stream11input_countEv($34);
      var $36=$3;
      var $37=(($36-$35)|0);
      $3=$37;
      __label__ = 8; break;
    case 8: // $38
      __label__ = 9; break;
    case 9: // $39
      var $40=$stream;
      var $41=__ZNK12sound_stream4nextEv($40);
      $stream=$41;
      __label__ = 3; break;
    case 10: // $42
      $1=0;
      __label__ = 11; break;
    case 11: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_sound_interface21input_to_stream_inputEiRi["X"]=1;

function __ZN20resource_pool_objectI16debug_view_stateED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI16debug_view_stateE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI18debug_view_consoleED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI18debug_view_consoleED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI18debug_view_consoleED0Ev["X"]=1;

function __ZN20resource_pool_objectI18debug_view_consoleED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI18debug_view_consoleE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayI15debug_view_charED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI15debug_view_charED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI15debug_view_charED0Ev["X"]=1;

function __ZN19resource_pool_arrayI15debug_view_charED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayI15debug_view_charE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_sound_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$mconfig;
      $3=$device;
      var $6=$1;
      var $7=$6;
      var $8=$3;
      __ZN16device_interfaceC2ER8device_t($7, $8);
      var $9=$6;
      HEAP32[(($9)>>2)]=((__ZTV22device_sound_interface+8)|0);
      var $10=(($6+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN22device_sound_interface11sound_routeEEC1ER13resource_pool($10, _global_resource_pool) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($6+32)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=(($6+36)|0);
      HEAP32[(($13)>>2)]=0;
      ;
      return;
    case 2: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $4=$16;
      var $17=$15.f1;
      $5=$17;
      var $18=$6;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$4;
      var $22=$4;
      var $23=$5;
      var $24=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22, tempValue);
      var $25=($24.f1 = $23, $24);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_sound_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN22device_sound_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_sound_interfaceD0Ev["X"]=1;

function __ZN22device_sound_interfaceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV22device_sound_interface+8)|0);
      var $6=(($4+12)|0);
      (function() { try { __THREW__ = false; return __ZN11simple_listIN22device_sound_interface11sound_routeEED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      __ZN16device_interfaceD2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZN16device_interfaceD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK22device_sound_interface11sound_route4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN11simple_listIN22device_sound_interface11sound_routeEE6detachERS1_($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $prev;
      var $cur;
      $2=$this;
      $3=$object;
      var $4=$2;
      $prev=0;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $14
      var $15=$prev;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$prev;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 6; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+4)|0);
      HEAP32[(($27)>>2)]=$26;
      __label__ = 6; break;
    case 6: // $28
      var $29=(($4+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=(($30)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$prev;
      var $35=(($4+8)|0);
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      var $37=(($4+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38-1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$3;
      $1=$40;
      __label__ = 12; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$cur;
      $prev=$43;
      var $44=$cur;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      $cur=$46;
      __label__ = 1; break;
    case 11: // $47
      var $48=$3;
      $1=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN22device_sound_interface11sound_routeEE6detachERS1_["X"]=1;

function __ZN11simple_listIN22device_sound_interface11sound_routeEEC2ER13resource_pool($this, $pool) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$pool;
  var $3=$1;
  var $4=$3;
  HEAP32[(($4)>>2)]=((__ZTV11simple_listIN22device_sound_interface11sound_routeEE+8)|0);
  var $5=(($3+4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($3+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+12)|0);
  var $8=$2;
  HEAP32[(($7)>>2)]=$8;
  var $9=(($3+16)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZNK11simple_listIN22device_sound_interface11sound_routeEE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN22device_sound_interface23output_to_stream_outputEiRi($this, $outputnum, $stream_outputnum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $stream;
      $2=$this;
      $3=$outputnum;
      $4=$stream_outputnum;
      var $5=$2;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=$5;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK8device_t7machineEv($10);
      var $12=__ZNK15running_machine5soundEv($11);
      var $13=__ZNK13sound_manager12first_streamEv($12);
      $stream=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$stream;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $17
      var $18=$stream;
      var $19=__ZNK12sound_stream6deviceEv($18);
      var $20=$5;
      var $21=__ZN16device_interface6deviceEv($20);
      var $22=(($19)|0)==(($21)|0);
      if ($22) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $23
      var $24=$3;
      var $25=$stream;
      var $26=__ZNK12sound_stream12output_countEv($25);
      var $27=(($24)|0) < (($26)|0);
      if ($27) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $28
      var $29=$3;
      var $30=$4;
      HEAP32[(($30)>>2)]=$29;
      var $31=$stream;
      $1=$31;
      __label__ = 11; break;
    case 7: // $32
      var $33=$stream;
      var $34=__ZNK12sound_stream12output_countEv($33);
      var $35=$3;
      var $36=(($35-$34)|0);
      $3=$36;
      __label__ = 8; break;
    case 8: // $37
      __label__ = 9; break;
    case 9: // $38
      var $39=$stream;
      var $40=__ZNK12sound_stream4nextEv($39);
      $stream=$40;
      __label__ = 3; break;
    case 10: // $41
      $1=0;
      __label__ = 11; break;
    case 11: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_sound_interface23output_to_stream_outputEiRi["X"]=1;

function __ZNK22device_sound_interface24interface_validity_checkER11emu_optionsRK11game_driver($this, $options, $driver) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      var $route;
      var $target;
      var $sound=__stackBase__;
      $1=$this;
      $2=$options;
      $3=$driver;
      var $4=$1;
      $error=0;
      var $5=__ZNK22device_sound_interface11first_routeEv($4);
      $route=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$route;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $9
      var $10=$4;
      var $11=__ZNK16device_interface6deviceEv($10);
      var $12=__ZNK8device_t7mconfigEv($11);
      var $13=__ZNK14machine_config10devicelistEv($12);
      var $14=$13;
      var $15=$route;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZNK11tagged_listI8device_tE4findEPKc($14, $17);
      $target=$18;
      var $19=$target;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$3;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$3;
      var $26=(($25+8)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$route;
      var $29=(($28+16)|0);
      var $30=HEAP32[(($29)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str35143)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,HEAP32[((tempInt+4)>>2)]=$27,HEAP32[((tempInt+8)>>2)]=$30,tempInt));
      $error=1;
      __label__ = 4; break;
    case 4: // $31
      var $32=$target;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $34
      var $35=$target;
      var $36=__ZNK8device_t4typeEv($35);
      var $37=HEAP32[((_SPEAKER)>>2)];
      var $38=(($36)|0)!=(($37)|0);
      if ($38) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $39
      var $40=$target;
      var $41=__ZNK8device_t9interfaceIK22device_sound_interfaceEEbRPT_($40, $sound);
      if ($41) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $42
      var $43=$3;
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$3;
      var $47=(($46+8)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$route;
      var $50=(($49+16)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$target;
      var $53=__ZNK8device_t4nameEv($52);
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str45144)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,HEAP32[((tempInt+4)>>2)]=$48,HEAP32[((tempInt+8)>>2)]=$51,HEAP32[((tempInt+12)>>2)]=$53,tempInt));
      $error=1;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      var $56=$route;
      var $57=__ZNK22device_sound_interface11sound_route4nextEv($56);
      $route=$57;
      __label__ = 1; break;
    case 10: // $58
      var $59=$error;
      var $60=(($59) & 1);
      STACKTOP = __stackBase__;
      return $60;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK22device_sound_interface24interface_validity_checkER11emu_optionsRK11game_driver["X"]=1;

function __ZNK22device_sound_interface11first_routeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=__ZNK11simple_listIN22device_sound_interface11sound_routeEE5firstEv($3);
  ;
  return $4;
}


function __ZNK8device_t9interfaceIK22device_sound_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$intf;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_sound_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$2;
      HEAP32[(($12)>>2)]=$11;
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN22device_sound_interface19interface_pre_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $stream;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=__ZNK15running_machine5soundEv($6);
      var $8=__ZNK13sound_manager12first_streamEv($7);
      $stream=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$stream;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$stream;
      var $14=__ZNK12sound_stream6deviceEv($13);
      var $15=$2;
      var $16=__ZN16device_interface6deviceEv($15);
      var $17=(($14)|0)==(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$stream;
      __ZN12sound_stream6updateEv($19);
      __label__ = 4; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$stream;
      var $23=__ZNK12sound_stream4nextEv($22);
      $stream=$23;
      __label__ = 1; break;
    case 6: // $24
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN11simple_listIN22device_sound_interface11sound_routeEE6removeERS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  var $5=__ZN11simple_listIN22device_sound_interface11sound_routeEE6detachERS1_($3, $4);
  var $6=(($3+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=$8;
  __ZN13resource_pool6removeEPv($7, $9);
  ;
  return;
}


function __ZN11simple_listIN22device_sound_interface11sound_routeEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTV11simple_listIN22device_sound_interface11sound_routeEE+8)|0);
  __ZN11simple_listIN22device_sound_interface11sound_routeEE5resetEv($2);
  ;
  return;
}


function __ZN23device_disasm_interfaceC2ERK14machine_configR8device_t($this, $mconfig, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$mconfig;
  $3=$device;
  var $4=$1;
  var $5=$4;
  var $6=$3;
  __ZN16device_interfaceC2ER8device_t($5, $6);
  var $7=$4;
  HEAP32[(($7)>>2)]=((__ZTV23device_disasm_interface+8)|0);
  ;
  return;
}


function __ZN22device_sound_interface19interface_pre_startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $sound=__stackBase__;
      var $gotone;
      var $route;
      var $target_device;
      var $gotone1;
      var $route2;
      var $target_device3;
      $1=$this;
      var $2=$1;
      HEAP32[(($sound)>>2)]=0;
      var $3=$2;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=__ZNK15running_machine10devicelistEv($6);
      var $8=__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($7, $sound);
      var $9=(($8)&1);
      $gotone=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$gotone;
      var $12=(($11) & 1);
      if ($12) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $13
      var $14=HEAP32[(($sound)>>2)];
      var $15=__ZNK22device_sound_interface11first_routeEv($14);
      $route=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$route;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $19
      var $20=$2;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK8device_t7machineEv($22);
      var $24=$route;
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZN15running_machine6deviceEPKc($23, $26);
      $target_device=$27;
      var $28=$target_device;
      var $29=$2;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28)|0)==(($31)|0);
      if ($32) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $33
      var $34=HEAP32[(($sound)>>2)];
      var $35=$34;
      var $36=__ZN16device_interface6deviceEv($35);
      var $37=__ZNK8device_t7startedEv($36);
      if ($37) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $38
      var $39=___cxa_allocate_exception(4);
      var $40=$39;
      var $41=$40;
      HEAP32[(($41)>>2)]=0;
      __ZN27device_missing_dependenciesC1Ev($40);
      ___cxa_throw($39, __ZTI27device_missing_dependencies, 232);
      throw "Reached an unreachable!"
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      var $44=$route;
      var $45=__ZNK22device_sound_interface11sound_route4nextEv($44);
      $route=$45;
      __label__ = 3; break;
    case 9: // $46
      __label__ = 10; break;
    case 10: // $47
      var $48=HEAP32[(($sound)>>2)];
      var $49=$48;
      var $50=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($49, $sound);
      var $51=(($50)&1);
      $gotone=$51;
      __label__ = 1; break;
    case 11: // $52
      var $53=(($2+36)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$2;
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__ZNK8device_t7machineEv($56);
      var $58=__ZNK15running_machine10devicelistEv($57);
      var $59=__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($58, $sound);
      var $60=(($59)&1);
      $gotone1=$60;
      __label__ = 12; break;
    case 12: // $61
      var $62=$gotone1;
      var $63=(($62) & 1);
      if ($63) { __label__ = 13; break; } else { __label__ = 25; break; }
    case 13: // $64
      var $65=HEAP32[(($sound)>>2)];
      var $66=__ZNK22device_sound_interface11first_routeEv($65);
      $route2=$66;
      __label__ = 14; break;
    case 14: // $67
      var $68=$route2;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $70
      var $71=$2;
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=__ZNK8device_t7machineEv($73);
      var $75=$route2;
      var $76=(($75+16)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=__ZN15running_machine6deviceEPKc($74, $77);
      $target_device3=$78;
      var $79=$target_device3;
      var $80=$2;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($79)|0)==(($82)|0);
      if ($83) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $84
      var $85=$route2;
      var $86=(($85+8)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)==65535;
      if ($88) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $89
      var $90=(($2+36)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$route2;
      var $93=(($92+8)|0);
      HEAP32[(($93)>>2)]=$91;
      var $94=$route2;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)==65535;
      if ($97) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $98
      var $99=HEAP32[(($sound)>>2)];
      var $100=__ZNK22device_sound_interface7outputsEv($99);
      var $103 = $100;__label__ = 20; break;
    case 19: // $101
      var $103 = 1;__label__ = 20; break;
    case 20: // $102
      var $103;
      var $104=(($2+36)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+$103)|0);
      HEAP32[(($104)>>2)]=$106;
      __label__ = 21; break;
    case 21: // $107
      __label__ = 22; break;
    case 22: // $108
      var $109=$route2;
      var $110=__ZNK22device_sound_interface11sound_route4nextEv($109);
      $route2=$110;
      __label__ = 14; break;
    case 23: // $111
      __label__ = 24; break;
    case 24: // $112
      var $113=HEAP32[(($sound)>>2)];
      var $114=$113;
      var $115=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($114, $sound);
      var $116=(($115)&1);
      $gotone1=$116;
      __label__ = 12; break;
    case 25: // $117
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_sound_interface19interface_pre_startEv["X"]=1;

function __ZN22device_sound_interface20interface_post_startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $sound=__stackBase__;
      var $gotone;
      var $route;
      var $target_device;
      var $inputnum;
      var $numoutputs;
      var $outputnum;
      var $streamoutputnum=__stackBase__+4;
      var $outputstream;
      var $streaminputnum=__stackBase__+8;
      var $inputstream;
      $1=$this;
      var $2=$1;
      HEAP32[(($sound)>>2)]=0;
      var $3=$2;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZNK8device_t7machineEv($5);
      var $7=__ZNK15running_machine10devicelistEv($6);
      var $8=__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_($7, $sound);
      var $9=(($8)&1);
      $gotone=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$gotone;
      var $12=(($11) & 1);
      if ($12) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $13
      var $14=HEAP32[(($sound)>>2)];
      var $15=__ZNK22device_sound_interface11first_routeEv($14);
      $route=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$route;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 4: // $19
      var $20=$2;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK8device_t7machineEv($22);
      var $24=$route;
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZN15running_machine6deviceEPKc($23, $26);
      $target_device=$27;
      var $28=$target_device;
      var $29=$2;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28)|0)==(($31)|0);
      if ($32) { __label__ = 5; break; } else { __label__ = 17; break; }
    case 5: // $33
      var $34=$route;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      $inputnum=$36;
      var $37=HEAP32[(($sound)>>2)];
      var $38=__ZNK22device_sound_interface7outputsEv($37);
      $numoutputs=$38;
      $outputnum=0;
      __label__ = 6; break;
    case 6: // $39
      var $40=$outputnum;
      var $41=$numoutputs;
      var $42=(($40)|0) < (($41)|0);
      if ($42) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $43
      var $44=$route;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$outputnum;
      var $48=(($46)|0)==(($47)|0);
      if ($48) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $49
      var $50=$route;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==65535;
      if ($53) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $54
      var $55=HEAP32[(($sound)>>2)];
      var $56=$outputnum;
      var $57=__ZN22device_sound_interface23output_to_stream_outputEiRi($55, $56, $streamoutputnum);
      $outputstream=$57;
      var $58=$outputstream;
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $60
      var $61=$route;
      var $62=(($61+16)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$outputnum;
      __Z10fatalerrorPKcz(((STRING_TABLE.__str55145)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$64,tempInt));
      throw "Reached an unreachable!"
    case 11: // $65
      var $66=$inputnum;
      var $67=(($66+1)|0);
      $inputnum=$67;
      var $68=__ZN22device_sound_interface21input_to_stream_inputEiRi($2, $66, $streaminputnum);
      $inputstream=$68;
      var $69=$inputstream;
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $71
      var $72=$route;
      var $73=(($72+16)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$outputnum;
      var $76=$2;
      var $77=(($76+8)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=__ZNK8device_t3tagEv($78);
      var $80=$inputnum;
      var $81=(($80-1)|0);
      __Z10fatalerrorPKcz(((STRING_TABLE.__str65146)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,HEAP32[((tempInt+4)>>2)]=$75,HEAP32[((tempInt+8)>>2)]=$79,HEAP32[((tempInt+12)>>2)]=$81,tempInt));
      throw "Reached an unreachable!"
    case 13: // $82
      var $83=$inputstream;
      var $84=HEAP32[(($streaminputnum)>>2)];
      var $85=$outputstream;
      var $86=HEAP32[(($streamoutputnum)>>2)];
      var $87=$route;
      var $88=(($87+12)|0);
      var $89=HEAPF32[(($88)>>2)];
      __ZN12sound_stream9set_inputEiPS_if($83, $84, $85, $86, $89);
      __label__ = 14; break;
    case 14: // $90
      __label__ = 15; break;
    case 15: // $91
      var $92=$outputnum;
      var $93=(($92+1)|0);
      $outputnum=$93;
      __label__ = 6; break;
    case 16: // $94
      __label__ = 17; break;
    case 17: // $95
      __label__ = 18; break;
    case 18: // $96
      var $97=$route;
      var $98=__ZNK22device_sound_interface11sound_route4nextEv($97);
      $route=$98;
      __label__ = 3; break;
    case 19: // $99
      __label__ = 20; break;
    case 20: // $100
      var $101=HEAP32[(($sound)>>2)];
      var $102=$101;
      var $103=__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_($102, $sound);
      var $104=(($103)&1);
      $gotone=$104;
      __label__ = 1; break;
    case 21: // $105
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN22device_sound_interface20interface_post_startEv["X"]=1;

function __ZN11simple_listIN22device_sound_interface11sound_routeEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN11simple_listIN22device_sound_interface11sound_routeEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN11simple_listIN22device_sound_interface11sound_routeEED0Ev["X"]=1;

function __ZN23device_disasm_interfaceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN16device_interfaceD2Ev($3);
  ;
  return;
}


function __ZThn368_N24legacy_image_device_baseD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_image_device_baseD0Ev($5);
  ;
  return;
}


function __ZThn368_N24legacy_image_device_baseD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN24legacy_image_device_baseD1Ev]($5);
  ;
  return;
}


function __ZN19image_device_formatC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19image_device_formatC2Ev($2);
  ;
  return;
}


function __ZN24legacy_image_device_base9call_loadEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $func;
      $2=$this;
      var $3=$2;
      var $4=$3;
      var $5=__ZNK18legacy_device_base14get_legacy_fctEj($4, 159745);
      var $6=$5;
      $func=$6;
      var $7=$func;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$func;
      var $11=$3;
      var $12=(($11+368)|0);
      var $13=$12;
      var $14=FUNCTION_TABLE[$10]($13);
      var $15=(($14)|0)!=0;
      $1=$15;
      __label__ = 3; break;
    case 2: // $16
      $1=0;
      __label__ = 3; break;
    case 3: // $17
      var $18=$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_image_device_base9call_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZN24legacy_image_device_base9call_loadEv($5);
  ;
  return $6;
}


function __ZN24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry($this, $swlist, $swname, $start_entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $func;
      $2=$this;
      $3=$swlist;
      $4=$swname;
      $5=$start_entry;
      var $6=$2;
      var $7=$6;
      var $8=__ZNK18legacy_device_base14get_legacy_fctEj($7, 159752);
      var $9=$8;
      $func=$9;
      var $10=$func;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$func;
      var $14=$6;
      var $15=(($14+368)|0);
      var $16=$15;
      var $17=$3;
      var $18=$4;
      var $19=$5;
      var $20=FUNCTION_TABLE[$13]($16, $17, $18, $19);
      $1=$20;
      __label__ = 3; break;
    case 2: // $21
      $1=0;
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry($this, $swlist, $swname, $start_entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$swlist;
  $3=$swname;
  $4=$start_entry;
  var $5=$1;
  var $6=$5;
  var $7=(($6-368)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZN24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry($8, $9, $10, $11);
  ;
  return $12;
}


function __ZN24legacy_image_device_base11call_createEiP18_option_resolution($this, $format_type, $format_options) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $func;
      $2=$this;
      $3=$format_type;
      $4=$format_options;
      var $5=$2;
      var $6=$5;
      var $7=__ZNK18legacy_device_base14get_legacy_fctEj($6, 159746);
      var $8=$7;
      $func=$8;
      var $9=$func;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$func;
      var $13=$5;
      var $14=(($13+368)|0);
      var $15=$14;
      var $16=$3;
      var $17=$4;
      var $18=FUNCTION_TABLE[$12]($15, $16, $17);
      var $19=(($18)|0)!=0;
      $1=$19;
      __label__ = 3; break;
    case 2: // $20
      $1=0;
      __label__ = 3; break;
    case 3: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_image_device_base11call_createEiP18_option_resolution($this, $format_type, $format_options) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$format_type;
  $3=$format_options;
  var $4=$1;
  var $5=$4;
  var $6=(($5-368)|0);
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=__ZN24legacy_image_device_base11call_createEiP18_option_resolution($7, $8, $9);
  ;
  return $10;
}


function __ZN24legacy_image_device_base11call_unloadEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $func;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK18legacy_device_base14get_legacy_fctEj($3, 159747);
      var $5=$4;
      $func=$5;
      var $6=$func;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$func;
      var $10=$2;
      var $11=(($10+368)|0);
      var $12=$11;
      FUNCTION_TABLE[$9]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN23device_disasm_interfaceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN23device_disasm_interfaceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN23device_disasm_interfaceD0Ev["X"]=1;

function __ZN24legacy_image_device_baseD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24legacy_image_device_baseD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24legacy_image_device_baseD0Ev["X"]=1;

function __ZN24legacy_image_device_baseD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+368)|0);
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN22device_image_interfaceD2Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      __ZN18legacy_device_baseD2Ev($9);
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=$4;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_baseD2Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$2;
      var $19=$3;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24legacy_image_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($this, $mconfig, $type, $tag, $owner, $clock, $get_config) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $1=$this;
      $2=$mconfig;
      $3=$type;
      $4=$tag;
      $5=$owner;
      $6=$clock;
      $7=$get_config;
      var $10=$1;
      var $11=$10;
      var $12=$2;
      var $13=$3;
      var $14=$4;
      var $15=$5;
      var $16=$6;
      var $17=$7;
      __ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($11, $12, $13, $14, $15, $16, $17);
      var $18=$10;
      HEAP32[(($18)>>2)]=((__ZTV24legacy_image_device_base+8)|0);
      var $19=$10;
      var $20=(($19+368)|0);
      var $21=$20;
      HEAP32[(($21)>>2)]=((__ZTV24legacy_image_device_base+148)|0);
      var $22=$10;
      var $23=(($22+368)|0);
      var $24=$23;
      var $25=$2;
      var $26=$10;
      (function() { try { __THREW__ = false; return __ZN22device_image_interfaceC2ERK14machine_configR8device_t($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      var $28=$10;
      HEAP32[(($28)>>2)]=((__ZTV24legacy_image_device_base+8)|0);
      var $29=$10;
      var $30=(($29+368)|0);
      var $31=$30;
      HEAP32[(($31)>>2)]=((__ZTV24legacy_image_device_base+148)|0);
      ;
      return;
    case 2: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $8=$34;
      var $35=$33.f1;
      $9=$35;
      var $36=$10;
      (function() { try { __THREW__ = false; return __ZN18legacy_device_baseD2Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$8;
      var $40=$8;
      var $41=$9;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24legacy_image_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE["X"]=1;

function __ZN24legacy_image_device_base22device_config_completeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $result_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      var $formatptr;
      var $format;
      var $cnt;
      var $format_count;
      var $i;
      var $12;
      var $13;
      $11=$this;
      var $14=$11;
      var $15=$14;
      var $16=(($15+368)|0);
      var $17=$16;
      var $18=(($17+840)|0);
      $formatptr=$18;
      $cnt=0;
      var $19=$14;
      var $20=__ZNK18legacy_device_base14get_legacy_intEj($19, 28679);
      var $20$0=$20[0];
      var $20$1=$20[1];
      var $21$0=$20$0;
      var $21=$21$0;
      $format_count=$21;
      $i=0;
      __label__ = 1; break;
    case 1: // $22
      var $23=$i;
      var $24=$format_count;
      var $25=(($23)|0) < (($24)|0);
      if ($25) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $26
      var $27=$14;
      var $28=$i;
      var $29=(($28+94210)|0);
      var $30=__ZNK18legacy_device_base17get_legacy_stringEj($27, $29);
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 3; break; } else { __label__ = 17; break; }
    case 3: // $32
      var $33=$5;
      var $34=$6;
      var $35=$7;
      var $36=$8;
      var $37=$result_i;
      var $38=$9;
      var $39=$10;
      HEAP32[(($5)>>2)]=264;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str5178)|0);
      HEAP32[(($7)>>2)]=91;
      HEAP32[(($8)>>2)]=_zeromem;
      var $40=HEAP32[(($5)>>2)];
      var $41=HEAP32[(($6)>>2)];
      var $42=HEAP32[(($7)>>2)];
      var $43=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($40, $41, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $44
      HEAP32[(($result_i)>>2)]=$43;
      var $45=HEAP32[(($result_i)>>2)];
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $47
      var $48=___cxa_allocate_exception(4);
      var $49=$48;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($49);
      (function() { try { __THREW__ = false; return ___cxa_throw($48, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 6; break; }
    case 6: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      HEAP32[(($9)>>2)]=$52;
      var $53=$51.f1;
      HEAP32[(($10)>>2)]=$53;
      var $54=HEAP32[(($10)>>2)];
      var $55=(($54)|0) < 0;
      if ($55) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $56
      var $57=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($57);
      throw "Reached an unreachable!"
    case 8: // $58
      var $59=HEAP32[(($9)>>2)];
      var $60=HEAP32[(($9)>>2)];
      var $61=HEAP32[(($10)>>2)];
      var $62=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $60, tempValue);
      var $63=($62.f1 = $61, $62);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $64
      throw "Reached an unreachable!"
    case 10: // $_ZnwjPKciRK9zeromem_t_exit
      var $65=HEAP32[(($result_i)>>2)];
      var $66=HEAP32[(($5)>>2)];
      _memset($65, 0, $66, 1);
      var $67=HEAP32[(($result_i)>>2)];
      var $68=$5;
      var $69=$6;
      var $70=$7;
      var $71=$8;
      var $72=$result_i;
      var $73=$9;
      var $74=$10;
      var $75=$67;
      (function() { try { __THREW__ = false; return __ZN19image_device_formatC1Ev($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      var $77=__ZN13resource_pool10add_objectI19image_device_formatEEPT_S3_(_global_resource_pool, $75);
      $format=$77;
      var $78=$cnt;
      var $79=$format;
      var $80=(($79+4)|0);
      HEAP32[(($80)>>2)]=$78;
      var $81=$format;
      var $82=(($81+8)|0);
      var $83=$14;
      var $84=$i;
      var $85=(($84+225284)|0);
      var $86=__ZNK18legacy_device_base17get_legacy_stringEj($83, $85);
      var $87=__ZN7astringaSEPKc($82, $86);
      var $88=$format;
      var $89=(($88+72)|0);
      var $90=$14;
      var $91=$i;
      var $92=(($91+225316)|0);
      var $93=__ZNK18legacy_device_base17get_legacy_stringEj($90, $92);
      var $94=__ZN7astringaSEPKc($89, $93);
      var $95=$format;
      var $96=(($95+136)|0);
      var $97=$14;
      var $98=$i;
      var $99=(($98+225348)|0);
      var $100=__ZNK18legacy_device_base17get_legacy_stringEj($97, $99);
      var $101=__ZN7astringaSEPKc($96, $100);
      var $102=$format;
      var $103=(($102+200)|0);
      var $104=$14;
      var $105=$i;
      var $106=(($105+94210)|0);
      var $107=__ZNK18legacy_device_base17get_legacy_stringEj($104, $106);
      var $108=__ZN7astringaSEPKc($103, $107);
      var $109=$format;
      var $110=$formatptr;
      HEAP32[(($110)>>2)]=$109;
      var $111=$format;
      var $112=(($111)|0);
      $formatptr=$112;
      var $113=$cnt;
      var $114=(($113+1)|0);
      $cnt=$114;
      __label__ = 17; break;
    case 12: // $115
      var $116=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $117=$116.f0;
      $12=$117;
      var $118=$116.f1;
      $13=$118;
      var $119=$1;
      var $120=$2;
      var $121=$3;
      var $122=$4;
      HEAP32[(($1)>>2)]=$67;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str5178)|0);
      HEAP32[(($3)>>2)]=91;
      HEAP32[(($4)>>2)]=_zeromem;
      var $123=HEAP32[(($1)>>2)];
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $125
      var $126=HEAP32[(($1)>>2)];
      var $127=HEAP32[(($2)>>2)];
      var $128=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($126, $127, $128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 25; break; }
    case 14: // $_noexc
      __label__ = 15; break;
    case 15: // $_ZdlPvPKciRK9zeromem_t_exit
      var $129=$1;
      var $130=$2;
      var $131=$3;
      var $132=$4;
      __label__ = 16; break;
    case 16: // $133
      __label__ = 24; break;
    case 17: // $134
      __label__ = 18; break;
    case 18: // $135
      var $136=$i;
      var $137=(($136+1)|0);
      $i=$137;
      __label__ = 1; break;
    case 19: // $138
      var $139=$14;
      var $140=(($139+368)|0);
      var $141=$140;
      __ZN22device_image_interface12update_namesEv($141);
      var $142=$14;
      var $143=__ZNK18legacy_device_base17get_legacy_stringEj($142, 225282);
      var $144=_strlen($143);
      var $145=(($144)>>>0) > 0;
      if ($145) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $146
      var $147=$14;
      var $148=(($147+368)|0);
      var $149=$148;
      var $150=(($149+776)|0);
      var $151=$14;
      var $152=__ZNK18legacy_device_base17get_legacy_stringEj($151, 225282);
      var $153=__ZN7astringaSEPKc($150, $152);
      __label__ = 21; break;
    case 21: // $154
      var $155=$14;
      var $156=__ZNK18legacy_device_base17get_legacy_stringEj($155, 225283);
      var $157=_strlen($156);
      var $158=(($157)>>>0) > 0;
      if ($158) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $159
      var $160=$14;
      var $161=(($160+368)|0);
      var $162=$161;
      var $163=(($162+712)|0);
      var $164=$14;
      var $165=__ZNK18legacy_device_base17get_legacy_stringEj($164, 225283);
      var $166=__ZN7astringaSEPKc($163, $165);
      __label__ = 23; break;
    case 23: // $167
      STACKTOP = __stackBase__;
      return;
    case 24: // $168
      var $169=$12;
      var $170=$12;
      var $171=$13;
      var $172=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $170, tempValue);
      var $173=($172.f1 = $171, $172);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $174
      var $175=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24legacy_image_device_base22device_config_completeEv["X"]=1;

function __ZN13resource_pool10add_objectI19image_device_formatEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19image_device_formatEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI19image_device_formatEEPT_S3_["X"]=1;

function __ZN13path_iteratorC2EPKc($this, $rawsearchpath) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$rawsearchpath;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  HEAP32[(($4)>>2)]=$5;
  var $6=(($3+4)|0);
  var $7=(($3)|0);
  var $8=HEAP32[(($7)>>2)];
  HEAP32[(($6)>>2)]=$8;
  var $9=(($3+8)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZThn368_N24legacy_image_device_base11call_unloadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_image_device_base11call_unloadEv($5);
  ;
  return;
}


function __ZN24legacy_image_device_base12call_displayEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $func;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK18legacy_device_base14get_legacy_fctEj($3, 159748);
      var $5=$4;
      $func=$5;
      var $6=$func;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$func;
      var $10=$2;
      var $11=(($10+368)|0);
      var $12=$11;
      FUNCTION_TABLE[$9]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_image_device_base12call_displayEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_image_device_base12call_displayEv($5);
  ;
  return;
}


function __ZN24legacy_image_device_base17call_display_infoEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $func;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK18legacy_device_base14get_legacy_fctEj($3, 159750);
      var $5=$4;
      $func=$5;
      var $6=$func;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$func;
      var $10=$2;
      var $11=(($10+368)|0);
      var $12=$11;
      FUNCTION_TABLE[$9]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_image_device_base17call_display_infoEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_image_device_base17call_display_infoEv($5);
  ;
  return;
}


function __ZN24legacy_image_device_base16call_get_devicesEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $func;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK18legacy_device_base14get_legacy_fctEj($3, 159751);
      var $5=$4;
      $func=$5;
      var $6=$func;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$func;
      var $10=$2;
      var $11=(($10+368)|0);
      var $12=$11;
      FUNCTION_TABLE[$9]($12);
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn368_N24legacy_image_device_base16call_get_devicesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN24legacy_image_device_base16call_get_devicesEv($5);
  ;
  return;
}


function __ZNK24legacy_image_device_base16get_partial_hashEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_fctEj($3, 159749);
  var $5=$4;
  ;
  return $5;
}


function __ZThn368_NK24legacy_image_device_base16get_partial_hashEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZNK24legacy_image_device_base16get_partial_hashEv($5);
  ;
  return $6;
}


function __ZN24legacy_image_device_base24get_device_specific_callEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK18legacy_device_base14get_legacy_fctEj($3, 163840);
  var $5=$4;
  ;
  return $5;
}


function __ZThn368_N24legacy_image_device_base24get_device_specific_callEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  var $6=__ZN24legacy_image_device_base24get_device_specific_callEv($5);
  ;
  return $6;
}


function __ZN20resource_pool_objectI19image_device_formatEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI19image_device_formatEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI19image_device_formatEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 264);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI19image_device_formatE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI19image_device_formatED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI19image_device_formatED2Ev($2);
  ;
  return;
}


function __ZN19image_device_formatD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19image_device_formatD2Ev($2);
  ;
  return;
}


function __ZN13path_iterator4nextER7astringPKc($this, $buffer, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $semi;
      $2=$this;
      $3=$buffer;
      $4=$name;
      var $5=$2;
      var $6=(($5+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($5+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      $1=0;
      __label__ = 13; break;
    case 3: // $16
      var $17=(($5+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=_strchr($18, 59);
      $semi=$19;
      var $20=$semi;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      var $23=(($5+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($5+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=_strlen($26);
      var $28=(($24+$27)|0);
      $semi=$28;
      __label__ = 5; break;
    case 5: // $29
      var $30=$3;
      var $31=(($5+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$semi;
      var $34=(($5+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$33;
      var $37=$35;
      var $38=(($36-$37)|0);
      var $39=__ZN7astring3cpyEPKci($30, $32, $38);
      var $40=$semi;
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $43=(($42)|0)==0;
      if ($43) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $44
      var $45=$semi;
      var $50 = $45;__label__ = 8; break;
    case 7: // $46
      var $47=$semi;
      var $48=(($47+1)|0);
      var $50 = $48;__label__ = 8; break;
    case 8: // $49
      var $50;
      var $51=(($5+4)|0);
      HEAP32[(($51)>>2)]=$50;
      var $52=$4;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $54
      var $55=$3;
      var $56=__ZNK7astring3lenEv($55);
      var $57=(($56)|0) > 0;
      if ($57) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $58
      var $59=$3;
      var $60=__ZN7astring3catEPKc($59, ((STRING_TABLE.__str5223)|0));
      __label__ = 11; break;
    case 11: // $61
      var $62=$3;
      var $63=$4;
      var $64=__ZN7astring3catEPKc($62, $63);
      __label__ = 12; break;
    case 12: // $65
      var $66=(($5+8)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+1)|0);
      HEAP32[(($66)>>2)]=$68;
      $1=1;
      __label__ = 13; break;
    case 13: // $69
      var $70=$1;
      ;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13path_iterator4nextER7astringPKc["X"]=1;

function __ZN15file_enumeratorC2EPKc($this, $searchpath) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$searchpath;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  FUNCTION_TABLE[__ZN13path_iteratorC1EPKc]($4, $5);
  var $6=(($3+12)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($3+16)|0);
  __ZN7astringC1Ev($7);
  var $8=(($3+80)|0);
  HEAP32[(($8)>>2)]=0;
  ;
  return;
}


function __ZN15file_enumerator4nextEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      $2=$this;
      var $3=$2;
      __label__ = 1; break;
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=(($3+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $9
      var $10=(($3)|0);
      var $11=(($3+16)|0);
      var $12=__ZN13path_iterator4nextER7astringPKc($10, $11, 0);
      if ($12) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $13
      $1=0;
      __label__ = 9; break;
    case 5: // $14
      var $15=(($3+16)|0);
      var $16=__ZNK7astringcvPKcEv($15);
      var $17=_osd_opendir($16);
      var $18=(($3+12)|0);
      HEAP32[(($18)>>2)]=$17;
      __label__ = 2; break;
    case 6: // $19
      var $20=(($3+12)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=_osd_readdir($21);
      $result=$22;
      var $23=$result;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $25
      var $26=$result;
      $1=$26;
      __label__ = 9; break;
    case 8: // $27
      var $28=(($3+12)|0);
      var $29=HEAP32[(($28)>>2)];
      _osd_closedir($29);
      var $30=(($3+12)|0);
      HEAP32[(($30)>>2)]=0;
      __label__ = 1; break;
    case 9: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI19image_device_formatED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI19image_device_formatED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI19image_device_formatED0Ev["X"]=1;

function __ZN20resource_pool_objectI19image_device_formatED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI19image_device_formatE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN19image_device_formatD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI19image_device_formatED2Ev["X"]=1;

function __ZN19image_device_formatD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+200)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      var $7=(($4+136)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $8
      var $9=(($4+72)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $10
      var $11=(($4+8)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($11);
      ;
      return;
    case 4: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      var $16=(($4+136)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      __label__ = 8; break;
    case 6: // $21
      __label__ = 8; break;
    case 7: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      __label__ = 10; break;
    case 8: // $26
      var $27=(($4+72)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $28
      __label__ = 10; break;
    case 10: // $29
      var $30=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $31
      __label__ = 12; break;
    case 12: // $32
      var $33=$2;
      var $34=$2;
      var $35=$3;
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19image_device_formatC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+8)|0);
      __ZN7astringC1Ev($5);
      var $6=(($4+72)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=(($4+136)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $9
      var $10=(($4+200)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $11
      ;
      return;
    case 4: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      __label__ = 10; break;
    case 5: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 8; break;
    case 6: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $2=$22;
      var $23=$21.f1;
      $3=$23;
      var $24=(($4+136)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=(($4+72)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $28
      __label__ = 10; break;
    case 10: // $29
      var $30=(($4+8)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $31
      __label__ = 12; break;
    case 12: // $32
      var $33=$2;
      var $34=$2;
      var $35=$3;
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN15file_enumeratorD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=(($4+12)|0);
      var $10=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return _osd_closedir($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      __label__ = 4; break;
    case 3: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      var $16=(($4+16)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 4: // $17
      var $18=(($4+16)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($18);
      ;
      return;
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      var $21=$2;
      var $22=$2;
      var $23=$3;
      var $24=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $22, tempValue);
      var $25=($24.f1 = $23, $24);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file5closeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+240)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+240)|0);
      var $8=HEAP32[(($7)>>2)];
      __Z14zip_file_closeP9_zip_file($8);
      __label__ = 2; break;
    case 2: // $9
      var $10=(($2+240)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($2+132)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=(($2+132)|0);
      var $16=HEAP32[(($15)>>2)];
      __Z11core_fcloseP10_core_file($16);
      __label__ = 4; break;
    case 4: // $17
      var $18=(($2+132)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($2+244)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=(($2+244)|0);
      var $24=HEAP32[(($23)>>2)];
      __ZN13resource_pool6removeEPv(_global_resource_pool, $24);
      __label__ = 6; break;
    case 6: // $25
      var $26=(($2+244)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=(($2+256)|0);
      var $28=HEAP8[($27)];
      var $29=(($28) & 1);
      if ($29) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $30
      var $31=(($2+68)|0);
      var $32=__ZNK7astringcvPKcEv($31);
      var $33=_osd_rmfile($32);
      __label__ = 8; break;
    case 8: // $34
      var $35=(($2+256)|0);
      HEAP8[($35)]=0;
      var $36=(($2+156)|0);
      __ZN15hash_collection5resetEv($36);
      var $37=(($2+68)|0);
      var $38=__ZN7astring5resetEv($37);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_filecvP10_core_fileEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+240)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=__ZN8emu_file16load_zipped_fileEv($3);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=0;
      __label__ = 4; break;
    case 3: // $11
      var $12=(($3+132)|0);
      var $13=HEAP32[(($12)>>2)];
      $1=$13;
      __label__ = 4; break;
    case 4: // $14
      var $15=$1;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_fileC2Ej($this, $openflags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$openflags;
      var $5=$1;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV8emu_file+8)|0);
      var $7=(($5+4)|0);
      __ZN7astringC1Ev($7);
      var $8=(($5+68)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $9
      var $10=(($5+132)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($5+136)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13path_iteratorC1EPKc]($11, ((__str15224)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $12
      var $13=(($5+148)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($5+152)|0);
      var $15=$2;
      HEAP32[(($14)>>2)]=$15;
      var $16=(($5+156)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $17
      var $18=(($5+240)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($5+244)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($5+248)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$7$0=(($20)|0);
      HEAP32[(($st$7$0)>>2)]=$$emscripten$temp$0$0;
      var $st$7$1=(($20+4)|0);
      HEAP32[(($st$7$1)>>2)]=$$emscripten$temp$0$1;
      var $21=(($5+256)|0);
      HEAP8[($21)]=0;
      var $22=(($5+152)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23 & 65536;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $26
      var $27=(($5+152)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & 2;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $31
      var $32=___cxa_allocate_exception(1032);
      var $33=$32;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($33, ((STRING_TABLE.__str25225)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $34
      (function() { try { __THREW__ = false; return ___cxa_throw($32, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 10; break; }
    case 7: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $3=$37;
      var $38=$36.f1;
      $4=$38;
      __label__ = 16; break;
    case 8: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $3=$41;
      var $42=$40.f1;
      $4=$42;
      __label__ = 14; break;
    case 9: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $3=$45;
      var $46=$44.f1;
      $4=$46;
      ___cxa_free_exception($32);
      __label__ = 12; break;
    case 10: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $3=$49;
      var $50=$48.f1;
      $4=$50;
      __label__ = 12; break;
    case 11: // $51
      ;
      return;
    case 12: // $52
      var $53=(($5+156)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $54
      __label__ = 14; break;
    case 14: // $55
      var $56=(($5+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $57
      __label__ = 16; break;
    case 16: // $58
      var $59=(($5+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $60
      __label__ = 18; break;
    case 18: // $61
      var $62=$3;
      var $63=$3;
      var $64=$4;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 20: // $69
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_fileC2Ej["X"]=1;

function __ZN8emu_fileC2EPKcj($this, $searchpath, $openflags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$searchpath;
      $3=$openflags;
      var $6=$1;
      var $7=$6;
      HEAP32[(($7)>>2)]=((__ZTV8emu_file+8)|0);
      var $8=(($6+4)|0);
      __ZN7astringC1Ev($8);
      var $9=(($6+68)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $10
      var $11=(($6+132)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($6+136)|0);
      var $13=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13path_iteratorC1EPKc]($12, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $14
      var $15=(($6+148)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($6+152)|0);
      var $17=$3;
      HEAP32[(($16)>>2)]=$17;
      var $18=(($6+156)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionC1Ev]($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $19
      var $20=(($6+240)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($6+244)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($6+248)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$7$0=(($22)|0);
      HEAP32[(($st$7$0)>>2)]=$$emscripten$temp$0$0;
      var $st$7$1=(($22+4)|0);
      HEAP32[(($st$7$1)>>2)]=$$emscripten$temp$0$1;
      var $23=(($6+256)|0);
      HEAP8[($23)]=0;
      var $24=(($6+152)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25 & 65536;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $28
      var $29=(($6+152)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 & 2;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $33
      var $34=___cxa_allocate_exception(1032);
      var $35=$34;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($35, ((STRING_TABLE.__str25225)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $36
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTI14emu_fatalerror, 16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 10; break; }
    case 7: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $4=$39;
      var $40=$38.f1;
      $5=$40;
      __label__ = 16; break;
    case 8: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      $4=$43;
      var $44=$42.f1;
      $5=$44;
      __label__ = 14; break;
    case 9: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $4=$47;
      var $48=$46.f1;
      $5=$48;
      ___cxa_free_exception($34);
      __label__ = 12; break;
    case 10: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $4=$51;
      var $52=$50.f1;
      $5=$52;
      __label__ = 12; break;
    case 11: // $53
      ;
      return;
    case 12: // $54
      var $55=(($6+156)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 19; break; }
    case 13: // $56
      __label__ = 14; break;
    case 14: // $57
      var $58=(($6+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $59
      __label__ = 16; break;
    case 16: // $60
      var $61=(($6+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $62
      __label__ = 18; break;
    case 18: // $63
      var $64=$4;
      var $65=$4;
      var $66=$5;
      var $67=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $65, tempValue);
      var $68=($67.f1 = $66, $67);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 20: // $71
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_fileC2EPKcj["X"]=1;

function __ZN8emu_fileD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_fileD0Ev["X"]=1;

function __ZN8emu_fileD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV8emu_file+8)|0);
      (function() { try { __THREW__ = false; return __ZN8emu_file5closeEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      var $7=(($4+156)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $8
      var $9=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $10
      var $11=(($4+4)|0);
      FUNCTION_TABLE[__ZN7astringD1Ev]($11);
      ;
      return;
    case 4: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      var $16=(($4+156)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN15hash_collectionD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      __label__ = 8; break;
    case 6: // $21
      __label__ = 8; break;
    case 7: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      __label__ = 10; break;
    case 8: // $26
      var $27=(($4+68)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $28
      __label__ = 10; break;
    case 10: // $29
      var $30=(($4+4)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $31
      __label__ = 12; break;
    case 12: // $32
      var $33=$2;
      var $34=$2;
      var $35=$3;
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_fileD2Ev["X"]=1;

function __ZN8emu_file16load_zipped_fileEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $7;
      var $ziperr;
      var $filerr;
      $7=$this;
      var $8=$7;
      __label__ = 1; break;
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      __label__ = 3; break;
    case 3: // $11
      __label__ = 4; break;
    case 4: // $12
      __label__ = 5; break;
    case 5: // $13
      __label__ = 6; break;
    case 6: // $14
      var $15=(($8+248)|0);
      var $st$1$0=(($15)|0);
      var $16$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=1;
      var $17=$16$1 >= $$emscripten$temp$0$1 && ($16$1 > $$emscripten$temp$0$1 || $16$0 >= $$emscripten$temp$0$0);
      var $18$0=$16$0;
      var $18=$18$0;
      var $19=$17 ? -1 : $18;
      var $20=$1;
      var $21=$2;
      var $22=$3;
      var $23=$result_i;
      var $24=$4;
      var $25=$5;
      HEAP32[(($1)>>2)]=$19;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str65229)|0);
      HEAP32[(($3)>>2)]=721;
      var $26=HEAP32[(($1)>>2)];
      var $27=HEAP32[(($2)>>2)];
      var $28=HEAP32[(($3)>>2)];
      var $29=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($26, $27, $28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; };
    case 7: // $30
      HEAP32[(($result_i)>>2)]=$29;
      var $31=HEAP32[(($result_i)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $33
      var $34=___cxa_allocate_exception(4);
      var $35=$34;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35);
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      HEAP32[(($4)>>2)]=$38;
      var $39=$37.f1;
      HEAP32[(($5)>>2)]=$39;
      var $40=HEAP32[(($5)>>2)];
      var $41=(($40)|0) < 0;
      if ($41) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $42
      var $43=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($43);
      throw "Reached an unreachable!"
    case 11: // $44
      var $45=HEAP32[(($4)>>2)];
      var $46=HEAP32[(($4)>>2)];
      var $47=HEAP32[(($5)>>2)];
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $50
      throw "Reached an unreachable!"
    case 13: // $_ZnajPKci_exit
      var $51=HEAP32[(($result_i)>>2)];
      var $52=$1;
      var $53=$2;
      var $54=$3;
      var $55=$result_i;
      var $56=$4;
      var $57=$5;
      var $58=(($8+248)|0);
      var $st$8$0=(($58)|0);
      var $59$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($58+4)|0);
      var $59$1=HEAP32[(($st$8$1)>>2)];
      var $60$0=$59$0;
      var $60=$60$0;
      var $61=__ZN13resource_pool9add_arrayIhEEPT_S2_i(_global_resource_pool, $51, $60);
      var $62=(($8+244)|0);
      HEAP32[(($62)>>2)]=$61;
      var $63=(($8+240)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($8+244)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($8+248)|0);
      var $st$22$0=(($67)|0);
      var $68$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($67+4)|0);
      var $68$1=HEAP32[(($st$22$1)>>2)];
      var $69$0=$68$0;
      var $69=$69$0;
      var $70=__Z19zip_file_decompressP9_zip_filePvj($64, $66, $69);
      $ziperr=$70;
      var $71=$ziperr;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $73
      var $74=(($8+244)|0);
      var $75=HEAP32[(($74)>>2)];
      __ZN13resource_pool6removeEPv(_global_resource_pool, $75);
      var $76=(($8+244)|0);
      HEAP32[(($76)>>2)]=0;
      $6=1;
      __label__ = 18; break;
    case 15: // $77
      var $78=(($8+244)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($8+248)|0);
      var $st$3$0=(($80)|0);
      var $81$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($80+4)|0);
      var $81$1=HEAP32[(($st$3$1)>>2)];
      var $82$0=$81$0;
      var $82=$82$0;
      var $83=(($8+152)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($8+132)|0);
      var $86=__Z14core_fopen_ramPKvjjPP10_core_file($79, $82, $84, $85);
      $filerr=$86;
      var $87=$filerr;
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $89
      var $90=(($8+244)|0);
      var $91=HEAP32[(($90)>>2)];
      __ZN13resource_pool6removeEPv(_global_resource_pool, $91);
      var $92=(($8+244)|0);
      HEAP32[(($92)>>2)]=0;
      $6=1;
      __label__ = 18; break;
    case 17: // $93
      var $94=(($8+240)|0);
      var $95=HEAP32[(($94)>>2)];
      __Z14zip_file_closeP9_zip_file($95);
      var $96=(($8+240)|0);
      HEAP32[(($96)>>2)]=0;
      $6=0;
      __label__ = 18; break;
    case 18: // $97
      var $98=$6;
      STACKTOP = __stackBase__;
      return $98;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_file16load_zipped_fileEv["X"]=1;

function __ZN8emu_filecvR10_core_fileEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+240)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=__ZN8emu_file16load_zipped_fileEv($4);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=___cxa_allocate_exception(1032);
      var $13=$12;
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($13, ((STRING_TABLE.__str35226)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      ___cxa_throw($12, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ___cxa_free_exception($12);
      __label__ = 6; break;
    case 5: // $19
      var $20=(($4+132)|0);
      var $21=HEAP32[(($20)>>2)];
      ;
      return $21;
    case 6: // $22
      var $23=$2;
      var $24=$2;
      var $25=$3;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13path_iterator5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($2+4)|0);
  HEAP32[(($5)>>2)]=$4;
  var $6=(($2+8)|0);
  HEAP32[(($6)>>2)]=0;
  ;
  return;
}


function __ZN8emu_file4openEPKc($this, $name) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$name;
  var $3=$1;
  var $4=(($3+4)|0);
  var $5=$2;
  var $6=__ZN7astringaSEPKc($4, $5);
  var $7=(($3+148)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($3+152)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$9 & -65537;
  HEAP32[(($8)>>2)]=$10;
  var $11=(($3+136)|0);
  __ZN13path_iterator5resetEv($11);
  var $12=__ZN8emu_file9open_nextEv($3);
  ;
  return $12;
}


function __ZN8emu_file9open_nextEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $filerr;
      $1=$this;
      var $2=$1;
      var $3=(($2+132)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __ZN8emu_file5closeEv($2);
      __label__ = 2; break;
    case 2: // $7
      $filerr=3;
      __label__ = 3; break;
    case 3: // $8
      var $9=(($2+136)|0);
      var $10=(($2+68)|0);
      var $11=(($2+4)|0);
      var $12=__ZNK7astringcvPKcEv($11);
      var $13=__ZN13path_iterator4nextER7astringPKc($9, $10, $12);
      if ($13) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $14
      var $15=(($2+68)|0);
      var $16=__ZNK7astringcvPKcEv($15);
      var $17=(($2+152)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($2+132)|0);
      var $20=__Z10core_fopenPKcjPP10_core_file($16, $18, $19);
      $filerr=$20;
      var $21=$filerr;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      __label__ = 11; break;
    case 6: // $24
      var $25=(($2+152)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 & 3;
      var $28=(($27)|0)==1;
      if ($28) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $29
      var $30=__ZN8emu_file14attempt_zippedEv($2);
      $filerr=$30;
      var $31=$filerr;
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $33
      __label__ = 11; break;
    case 9: // $34
      __label__ = 10; break;
    case 10: // $35
      __label__ = 3; break;
    case 11: // $36
      var $37=$filerr;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astringC1EPKcS1_S1_S1_($this, $str1, $str2, $str3, $str4) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$str1;
  $3=$str2;
  $4=$str3;
  $5=$str4;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=$5;
  __ZN7astringC2EPKcS1_S1_S1_($6, $7, $8, $9, $10);
  ;
  return;
}


function __ZN8emu_file4openEPKcj($this, $name, $crc) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$name;
  $3=$crc;
  var $4=$1;
  var $5=(($4+4)|0);
  var $6=$2;
  var $7=__ZN7astringaSEPKc($5, $6);
  var $8=$3;
  var $9=(($4+148)|0);
  HEAP32[(($9)>>2)]=$8;
  var $10=(($4+152)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$11 | 65536;
  HEAP32[(($10)>>2)]=$12;
  var $13=(($4+136)|0);
  __ZN13path_iterator5resetEv($13);
  var $14=__ZN8emu_file9open_nextEv($4);
  ;
  return $14;
}


function __ZN8emu_file8open_ramEPKvj($this, $data, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$data;
  $3=$length;
  var $4=$1;
  var $5=(($4+4)|0);
  var $6=__ZN7astringaSEPKc($5, ((STRING_TABLE.__str45227)|0));
  var $7=(($4+148)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$2;
  var $9=$3;
  var $10=(($4+152)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($4+132)|0);
  var $13=__Z14core_fopen_ramPKvjjPP10_core_file($8, $9, $11, $12);
  ;
  return $13;
}


function __ZN8emu_file8compressEi($this, $level) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$level;
  var $3=$1;
  var $4=(($3+132)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__Z14core_fcompressP10_core_filei($5, $6);
  ;
  return $7;
}


function __ZN8emu_file6hashesEPKc($this, $types) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $needed=__stackBase__;
      var $scan;
      var $4;
      var $5;
      var $6;
      var $filedata;
      $2=$this;
      $3=$types;
      var $7=$2;
      __ZN7astringC1Ev($needed);
      var $8=$3;
      $scan=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$scan;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $14
      var $15=(($7+156)|0);
      var $16=$scan;
      var $17=HEAP8[($16)];
      var $18=(function() { try { __THREW__ = false; return __ZNK15hash_collection4hashEc($15, $17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $19
      var $20=(($18)|0)==0;
      if ($20) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $21
      var $22=$scan;
      var $23=HEAP8[($22)];
      var $24=(function() { try { __THREW__ = false; return __ZN7astring3catEc($needed, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; };
    case 5: // $25
      __label__ = 7; break;
    case 6: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $4=$28;
      var $29=$27.f1;
      $5=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($needed) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 7: // $30
      __label__ = 8; break;
    case 8: // $31
      var $32=$scan;
      var $33=(($32+1)|0);
      $scan=$33;
      __label__ = 1; break;
    case 9: // $34
      var $35=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($needed) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 6; break; };
    case 10: // $36
      if ($35) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $37
      var $38=(($7+156)|0);
      $1=$38;
      $6=1;
      __label__ = 29; break;
    case 12: // $39
      var $40=(($7+240)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $43
      var $44=(function() { try { __THREW__ = false; return __ZN8emu_file16load_zipped_fileEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 6; break; };
    case 14: // $45
      var $46=(($44)|0)!=0;
      if ($46) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $47
      var $48=(($7+156)|0);
      $1=$48;
      $6=1;
      __label__ = 29; break;
    case 16: // $49
      var $50=(($7+132)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $53
      var $54=(($7+156)|0);
      $1=$54;
      $6=1;
      __label__ = 29; break;
    case 18: // $55
      var $56=(($7+244)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $59
      var $60=(($7+156)|0);
      var $61=(($7+244)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($7+248)|0);
      var $st$4$0=(($63)|0);
      var $64$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($63+4)|0);
      var $64$1=HEAP32[(($st$4$1)>>2)];
      var $65$0=$64$0;
      var $65=$65$0;
      var $66=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($needed) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 6; break; };
    case 20: // $67
      (function() { try { __THREW__ = false; return __ZN15hash_collection7computeEPKhjPKc($60, $62, $65, $66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 6; break; }
    case 21: // $68
      var $69=(($7+156)|0);
      $1=$69;
      $6=1;
      __label__ = 29; break;
    case 22: // $70
      var $71=(($7+132)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(function() { try { __THREW__ = false; return __Z12core_fbufferP10_core_file($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 6; break; };
    case 23: // $74
      $filedata=$73;
      var $75=$filedata;
      var $76=(($75)|0)==0;
      if ($76) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $77
      var $78=(($7+156)|0);
      $1=$78;
      $6=1;
      __label__ = 29; break;
    case 25: // $79
      var $80=(($7+156)|0);
      var $81=$filedata;
      var $82=(($7+132)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(function() { try { __THREW__ = false; return __Z10core_fsizeP10_core_file($83) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 6; break; };
      var $84$0=$84[0];
      var $84$1=$84[1];
    case 26: // $85
      var $86$0=$84$0;
      var $86=$86$0;
      var $87=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($needed) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 6; break; };
    case 27: // $88
      (function() { try { __THREW__ = false; return __ZN15hash_collection7computeEPKhjPKc($80, $81, $86, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 6; break; }
    case 28: // $89
      var $90=(($7+156)|0);
      $1=$90;
      $6=1;
      __label__ = 29; break;
    case 29: // $91
      FUNCTION_TABLE[__ZN7astringD1Ev]($needed);
      var $92=$1;
      STACKTOP = __stackBase__;
      return $92;
    case 30: // $93
      __label__ = 31; break;
    case 31: // $94
      var $95=$4;
      var $96=$4;
      var $97=$5;
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 32: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_file6hashesEPKc["X"]=1;

function __ZN8emu_file4openEPKcS1_($this, $name1, $name2) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $name=__stackBase__;
      var $5;
      var $6;
      var $7;
      $2=$this;
      $3=$name1;
      $4=$name2;
      var $8=$2;
      var $9=$3;
      var $10=$4;
      __ZN7astringC1EPKcS1_($name, $9, $10);
      var $11=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $12
      var $13=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($8, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $14
      $1=$13;
      $7=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      var $15=$1;
      STACKTOP = __stackBase__;
      return $15;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $5=$18;
      var $19=$17.f1;
      $6=$19;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$5;
      var $23=$5;
      var $24=$6;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4openEPKcS1_S1_($this, $name1, $name2, $name3) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $name=__stackBase__;
      var $6;
      var $7;
      var $8;
      $2=$this;
      $3=$name1;
      $4=$name2;
      $5=$name3;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      var $12=$5;
      __ZN7astringC1EPKcS1_S1_($name, $10, $11, $12);
      var $13=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $14
      var $15=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($9, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $16
      $1=$15;
      $8=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      var $17=$1;
      STACKTOP = __stackBase__;
      return $17;
    case 3: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      $6=$20;
      var $21=$19.f1;
      $7=$21;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $22
      __label__ = 5; break;
    case 5: // $23
      var $24=$6;
      var $25=$6;
      var $26=$7;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4openEPKcS1_S1_S1_($this, $name1, $name2, $name3, $name4) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $name=__stackBase__;
      var $7;
      var $8;
      var $9;
      $2=$this;
      $3=$name1;
      $4=$name2;
      $5=$name3;
      $6=$name4;
      var $10=$2;
      var $11=$3;
      var $12=$4;
      var $13=$5;
      var $14=$6;
      __ZN7astringC1EPKcS1_S1_S1_($name, $11, $12, $13, $14);
      var $15=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $16
      var $17=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($10, $15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $18
      $1=$17;
      $9=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      var $19=$1;
      STACKTOP = __stackBase__;
      return $19;
    case 3: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $7=$22;
      var $23=$21.f1;
      $8=$23;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$7;
      var $27=$7;
      var $28=$8;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4openEPKcS1_S1_j($this, $name1, $name2, $name3, $crc) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $name=__stackBase__;
      var $7;
      var $8;
      var $9;
      $2=$this;
      $3=$name1;
      $4=$name2;
      $5=$name3;
      $6=$crc;
      var $10=$2;
      var $11=$3;
      var $12=$4;
      var $13=$5;
      __ZN7astringC1EPKcS1_S1_($name, $11, $12, $13);
      var $14=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $15
      var $16=$6;
      var $17=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcj($10, $14, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $18
      $1=$17;
      $9=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      var $19=$1;
      STACKTOP = __stackBase__;
      return $19;
    case 3: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $7=$22;
      var $23=$21.f1;
      $8=$23;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$7;
      var $27=$7;
      var $28=$8;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file14attempt_zippedEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $filename=__stackBase__;
      var $dirsep;
      var $3;
      var $4;
      var $5;
      var $zip=__stackBase__+64;
      var $ziperr;
      var $header;
      $2=$this;
      var $6=$2;
      __ZN7astringC1Ev($filename);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=(($6+68)|0);
      var $10=HEAP8[(((STRING_TABLE.__str5223)|0))];
      var $11=(($10 << 24) >> 24);
      var $12=(function() { try { __THREW__ = false; return __ZNK7astring4rchrEii($9, 0, $11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $13
      $dirsep=$12;
      var $14=$dirsep;
      var $15=(($14)|0)==-1;
      if ($15) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $16
      $1=3;
      $5=1;
      __label__ = 63; break;
    case 5: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $3=$19;
      var $20=$18.f1;
      $4=$20;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 66; break; }
    case 6: // $21
      var $22=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 5; break; };
    case 7: // $23
      var $24=(($22)|0) > 0;
      if ($24) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $25
      var $26=(function() { try { __THREW__ = false; return __ZN7astring3insEiPKc($filename, 0, ((STRING_TABLE.__str5223)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 5; break; };
    case 9: // $27
      __label__ = 10; break;
    case 10: // $28
      var $29=(($6+68)|0);
      var $30=$dirsep;
      var $31=(($30+1)|0);
      var $32=(function() { try { __THREW__ = false; return __ZN7astring9inssubstrEiRKS_ii($filename, 0, $29, $31, -1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 5; break; };
    case 11: // $33
      var $34=(($6+68)|0);
      var $35=$dirsep;
      var $36=(function() { try { __THREW__ = false; return __ZN7astring6substrEii($34, 0, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 5; break; };
    case 12: // $37
      var $38=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($36, ((STRING_TABLE.__str55228)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 5; break; };
    case 13: // $39
      var $40=(($6+68)|0);
      var $41=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 5; break; };
    case 14: // $42
      var $43=(function() { try { __THREW__ = false; return __Z13zip_file_openPKcPP9_zip_file($41, $zip) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 5; break; };
    case 15: // $44
      $ziperr=$43;
      var $45=(($6+68)|0);
      var $46=$dirsep;
      var $47=(function() { try { __THREW__ = false; return __ZN7astring6substrEii($45, 0, $46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 5; break; };
    case 16: // $48
      var $49=$ziperr;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $51
      __label__ = 1; break;
    case 18: // $52
      var $53=HEAP32[(($zip)>>2)];
      var $54=(function() { try { __THREW__ = false; return __Z19zip_file_first_fileP9_zip_file($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 5; break; };
    case 19: // $55
      $header=$54;
      __label__ = 20; break;
    case 20: // $56
      var $57=$header;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $59
      var $60=$header;
      var $61=(function() { try { __THREW__ = false; return __ZN8emu_file18zip_filename_matchERK16_zip_file_headerRK7astring($6, $60, $filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 5; break; };
    case 22: // $62
      if ($61) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $63
      var $64=(($6+152)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65 & 65536;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $68
      var $69=$header;
      var $70=(($69+16)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($6+148)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($71)|0)==(($73)|0);
      if ($74) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $75
      __label__ = 29; break;
    case 26: // $76
      __label__ = 27; break;
    case 27: // $77
      var $78=HEAP32[(($zip)>>2)];
      var $79=(function() { try { __THREW__ = false; return __Z18zip_file_next_fileP9_zip_file($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 5; break; };
    case 28: // $80
      $header=$79;
      __label__ = 20; break;
    case 29: // $81
      var $82=$header;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 30; break; } else { __label__ = 42; break; }
    case 30: // $84
      var $85=(($6+152)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86 & 65536;
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 31; break; } else { __label__ = 42; break; }
    case 31: // $89
      var $90=HEAP32[(($zip)>>2)];
      var $91=(function() { try { __THREW__ = false; return __Z19zip_file_first_fileP9_zip_file($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 5; break; };
    case 32: // $92
      $header=$91;
      __label__ = 33; break;
    case 33: // $93
      var $94=$header;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 34; break; } else { __label__ = 41; break; }
    case 34: // $96
      var $97=$header;
      var $98=(($97+16)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($6+148)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($99)|0)==(($101)|0);
      if ($102) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $103
      var $104=$header;
      var $105=(function() { try { __THREW__ = false; return __ZN8emu_file18zip_header_is_pathERK16_zip_file_header($6, $104) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 5; break; };
    case 36: // $106
      if ($105) { __label__ = 38; break; } else { __label__ = 37; break; }
    case 37: // $107
      __label__ = 41; break;
    case 38: // $108
      __label__ = 39; break;
    case 39: // $109
      var $110=HEAP32[(($zip)>>2)];
      var $111=(function() { try { __THREW__ = false; return __Z18zip_file_next_fileP9_zip_file($110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 5; break; };
    case 40: // $112
      $header=$111;
      __label__ = 33; break;
    case 41: // $113
      __label__ = 42; break;
    case 42: // $114
      var $115=$header;
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 43; break; } else { __label__ = 53; break; }
    case 43: // $117
      var $118=HEAP32[(($zip)>>2)];
      var $119=(function() { try { __THREW__ = false; return __Z19zip_file_first_fileP9_zip_file($118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 5; break; };
    case 44: // $120
      $header=$119;
      __label__ = 45; break;
    case 45: // $121
      var $122=$header;
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $124
      var $125=$header;
      var $126=(function() { try { __THREW__ = false; return __ZN8emu_file18zip_filename_matchERK16_zip_file_headerRK7astring($6, $125, $filename) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 5; break; };
    case 47: // $127
      if ($126) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $128
      __label__ = 52; break;
    case 49: // $129
      __label__ = 50; break;
    case 50: // $130
      var $131=HEAP32[(($zip)>>2)];
      var $132=(function() { try { __THREW__ = false; return __Z18zip_file_next_fileP9_zip_file($131) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 5; break; };
    case 51: // $133
      $header=$132;
      __label__ = 45; break;
    case 52: // $134
      __label__ = 53; break;
    case 53: // $135
      var $136=$header;
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 54; break; } else { __label__ = 61; break; }
    case 54: // $138
      var $139=HEAP32[(($zip)>>2)];
      var $140=(($6+240)|0);
      HEAP32[(($140)>>2)]=$139;
      var $141=$header;
      var $142=(($141+24)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144$0=$143;
      var $144$1=0;
      var $145=(($6+248)|0);
      var $st$9$0=(($145)|0);
      HEAP32[(($st$9$0)>>2)]=$144$0;
      var $st$9$1=(($145+4)|0);
      HEAP32[(($st$9$1)>>2)]=$144$1;
      var $146=(($6+156)|0);
      (function() { try { __THREW__ = false; return __ZN15hash_collection5resetEv($146) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 5; break; }
    case 55: // $147
      var $148=(($6+156)|0);
      var $149=$header;
      var $150=(($149+16)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(function() { try { __THREW__ = false; return __ZN15hash_collection7add_crcEj($148, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 5; break; };
    case 56: // $153
      var $154=(($6+152)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$155 & 16;
      var $157=(($156)|0)!=0;
      if ($157) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $158
      var $163 = 0;__label__ = 60; break;
    case 58: // $159
      var $160=(function() { try { __THREW__ = false; return __ZN8emu_file16load_zipped_fileEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 5; break; };
    case 59: // $161
      var $163 = $160;__label__ = 60; break;
    case 60: // $162
      var $163;
      $1=$163;
      $5=1;
      __label__ = 63; break;
    case 61: // $164
      var $165=HEAP32[(($zip)>>2)];
      (function() { try { __THREW__ = false; return __Z14zip_file_closeP9_zip_file($165) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 5; break; }
    case 62: // $166
      __label__ = 1; break;
    case 63: // $167
      FUNCTION_TABLE[__ZN7astringD1Ev]($filename);
      var $168=$1;
      STACKTOP = __stackBase__;
      return $168;
    case 64: // $169
      __label__ = 65; break;
    case 65: // $170
      var $171=$3;
      var $172=$3;
      var $173=$4;
      var $174=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $172, tempValue);
      var $175=($174.f1 = $173, $174);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8emu_file14attempt_zippedEv["X"]=1;

function __ZN20dummy_profiler_stateC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN8emu_file18zip_header_is_pathERK16_zip_file_header($this, $header) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $zipfile;
      $1=$this;
      $2=$header;
      var $3=$1;
      var $4=$2;
      var $5=(($4+48)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$2;
      var $8=(($7+28)|0);
      var $9=HEAPU16[(($8)>>1)];
      var $10=(($9)&65535);
      var $11=(($6+$10)|0);
      var $12=(($11-1)|0);
      $zipfile=$12;
      var $13=$zipfile;
      var $14=$2;
      var $15=(($14+48)|0);
      var $16=HEAPU32[(($15)>>2)];
      var $17=(($13)>>>0) >= (($16)>>>0);
      if ($17) { __label__ = 1; break; } else { var $25 = 0;__label__ = 2; break; }
    case 1: // $18
      var $19=$zipfile;
      var $20=(($19)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($22)|0)==47;
      var $25 = $23;__label__ = 2; break;
    case 2: // $24
      var $25;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4seekExi($this, $offset$0, $offset$1, $whence) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      $2=$this;
      var $st$5$0=(($3)|0);
      HEAP32[(($st$5$0)>>2)]=$offset$0;
      var $st$5$1=(($3+4)|0);
      HEAP32[(($st$5$1)>>2)]=$offset$1;
      $4=$whence;
      var $5=$2;
      var $6=(($5+240)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=__ZN8emu_file16load_zipped_fileEv($5);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $1=1;
      __label__ = 6; break;
    case 3: // $13
      var $14=(($5+132)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=(($5+132)|0);
      var $19=HEAP32[(($18)>>2)];
      var $st$2$0=(($3)|0);
      var $20$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($3+4)|0);
      var $20$1=HEAP32[(($st$2$1)>>2)];
      var $21=$4;
      var $22=__Z10core_fseekP10_core_filexi($19, $20$0, $20$1, $21);
      var $22$0=$22[0];
      $1=$22;
      __label__ = 6; break;
    case 5: // $23
      $1=1;
      __label__ = 6; break;
    case 6: // $24
      var $25=$1;
      STACKTOP = __stackBase__;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file3eofEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+240)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=__ZN8emu_file16load_zipped_fileEv($3);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=0;
      __label__ = 6; break;
    case 3: // $11
      var $12=(($3+132)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $15
      var $16=(($3+132)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__Z9core_feofP10_core_file($17);
      var $19=(($18)|0)!=0;
      $1=$19;
      __label__ = 6; break;
    case 5: // $20
      $1=0;
      __label__ = 6; break;
    case 6: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4sizeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+240)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=(($3+248)|0);
      var $st$1$0=(($8)|0);
      var $9$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($8+4)|0);
      var $9$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($1)|0);
      HEAP32[(($st$5$0)>>2)]=$9$0;
      var $st$5$1=(($1+4)|0);
      HEAP32[(($st$5$1)>>2)]=$9$1;
      __label__ = 5; break;
    case 2: // $10
      var $11=(($3+132)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=(($3+132)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z10core_fsizeP10_core_file($16);
      var $17$0=$17[0];
      var $17$1=$17[1];
      var $st$5$0=(($1)|0);
      HEAP32[(($st$5$0)>>2)]=$17$0;
      var $st$5$1=(($1+4)|0);
      HEAP32[(($st$5$1)>>2)]=$17$1;
      __label__ = 5; break;
    case 4: // $18
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 5; break;
    case 5: // $19
      var $st$0$0=(($1)|0);
      var $20$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $20$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$20$0,$20$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4readEPvj($this, $buffer, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$buffer;
      $4=$length;
      var $5=$2;
      var $6=(($5+240)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=__ZN8emu_file16load_zipped_fileEv($5);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $1=0;
      __label__ = 6; break;
    case 3: // $13
      var $14=(($5+132)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=(($5+132)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$3;
      var $21=$4;
      var $22=__Z10core_freadP10_core_filePvj($19, $20, $21);
      $1=$22;
      __label__ = 6; break;
    case 5: // $23
      $1=0;
      __label__ = 6; break;
    case 6: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file5writeEPKvj($this, $buffer, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$buffer;
      $4=$length;
      var $5=$2;
      var $6=(($5+132)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=(($5+132)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=__Z11core_fwriteP10_core_filePKvj($11, $12, $13);
      $1=$14;
      __label__ = 3; break;
    case 2: // $15
      $1=0;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file4putsEPKc($this, $s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$this;
      $3=$s;
      var $4=$2;
      var $5=(($4+132)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($4+132)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$3;
      var $12=__Z10core_fputsP10_core_filePKc($10, $11);
      $1=$12;
      __label__ = 3; break;
    case 2: // $13
      $1=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$1;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8emu_file6printfEPKcz($this, $fmt) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $rc;
  var $va=__stackBase__;
  $1=$this;
  $2=$fmt;
  var $3=$1;
  var $4=$va;
  HEAP32[(($4)>>2)]=arguments[__ZN8emu_file6printfEPKcz.length];
  var $5=$2;
  var $6=HEAP32[(($va)>>2)];
  var $7=__ZN8emu_file7vprintfEPKcPc($3, $5, $6);
  $rc=$7;
  var $8=$va;
  ;
  var $9=$rc;
  STACKTOP = __stackBase__;
  return $9;
}


function __ZN8emu_file7vprintfEPKcPc($this, $fmt, $va) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$fmt;
      $3=$va;
      var $4=$1;
      var $5=(($4+132)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($4+132)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=$3;
      var $13=__Z13core_vfprintfP10_core_filePKcPc($10, $11, $12);
      var $16 = $13;__label__ = 3; break;
    case 2: // $14
      var $16 = 0;__label__ = 3; break;
    case 3: // $15
      var $16;
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN7astring9inssubstrEiRKS_ii($this, $insbefore, $src, $start, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$insbefore;
  $3=$src;
  $4=$start;
  $5=$count;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=$5;
  var $11=__Z17astring_inssubstrP7astringiPKS_ii($6, $7, $8, $9, $10);
  ;
  return $11;
}


function __ZN8emu_file18zip_filename_matchERK16_zip_file_headerRK7astring($this, $header, $filename) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $zipfile;
      $1=$this;
      $2=$header;
      $3=$filename;
      var $4=$1;
      var $5=$2;
      var $6=(($5+48)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$2;
      var $9=(($8+28)|0);
      var $10=HEAPU16[(($9)>>1)];
      var $11=(($10)&65535);
      var $12=(($7+$11)|0);
      var $13=$3;
      var $14=__ZNK7astring3lenEv($13);
      var $15=(((-$14))|0);
      var $16=(($12+$15)|0);
      $zipfile=$16;
      var $17=$zipfile;
      var $18=$2;
      var $19=(($18+48)|0);
      var $20=HEAPU32[(($19)>>2)];
      var $21=(($17)>>>0) >= (($20)>>>0);
      if ($21) { __label__ = 1; break; } else { var $42 = 0;__label__ = 5; break; }
    case 1: // $22
      var $23=$3;
      var $24=$zipfile;
      var $25=__ZNK7astring4icmpEPKc($23, $24);
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 2; break; } else { var $42 = 0;__label__ = 5; break; }
    case 2: // $27
      var $28=$zipfile;
      var $29=$2;
      var $30=(($29+48)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28)|0)==(($31)|0);
      if ($32) { var $40 = 1;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $33
      var $34=$zipfile;
      var $35=(($34-1)|0);
      var $36=HEAP8[($35)];
      var $37=(($36 << 24) >> 24);
      var $38=(($37)|0)==47;
      var $40 = $38;__label__ = 4; break;
    case 4: // $39
      var $40;
      var $42 = $40;__label__ = 5; break;
    case 5: // $41
      var $42;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK7astring4icmpEPKc($this, $str2) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$str2;
  var $3=$1;
  var $4=$2;
  var $5=__Z13astring_icmpcPK7astringPKc($3, $4);
  ;
  return $5;
}


function __ZN7astringC2EPKcS1_S1_S1_($this, $str1, $str2, $str3, $str4) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$str1;
  $3=$str2;
  $4=$str3;
  $5=$str4;
  var $6=$1;
  var $7=$6;
  var $8=__ZN7astring4initEv($6);
  var $9=$2;
  var $10=__ZN7astring3cpyEPKc($8, $9);
  var $11=$3;
  var $12=__ZN7astring3catEPKc($10, $11);
  var $13=$4;
  var $14=__ZN7astring3catEPKc($12, $13);
  var $15=$5;
  var $16=__ZN7astring3catEPKc($14, $15);
  ;
  return;
}


function ___cxx_global_var_init5326() {
  ;
  var __label__;

  FUNCTION_TABLE[__ZN20dummy_profiler_stateC1Ev](_g_profiler);
  ;
  return;
}


function __GLOBAL__I_a5328() {
  ;
  var __label__;

  ___cxx_global_var_init5326();
  ;
  return;
}


function __Z16ram_parse_stringPKc($s) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ram=__stackBase__;
      var $suffix=__stackBase__+4;
      $1=$s;
      HEAP8[($suffix)]=0;
      var $2=$1;
      var $3=_sscanf($2, ((STRING_TABLE.__str5329)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$ram,HEAP32[((tempInt+4)>>2)]=$suffix,tempInt));
      var $4=$1;
      var $5=(($4+$3)|0);
      $1=$5;
      var $6=HEAP8[($suffix)];
      var $7=(($6 << 24) >> 24);
      var $8=_tolower($7);
      if ($8 == 107) {
        __label__ = 1; break;
      }
      else if ($8 == 109) {
        __label__ = 2; break;
      }
      else if ($8 == 0) {
        __label__ = 4; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $9
      var $10=HEAP32[(($ram)>>2)];
      var $11=((($10<<10))|0);
      HEAP32[(($ram)>>2)]=$11;
      __label__ = 4; break;
    case 2: // $12
      var $13=HEAP32[(($ram)>>2)];
      var $14=((($13<<20))|0);
      HEAP32[(($ram)>>2)]=$14;
      __label__ = 4; break;
    case 3: // $15
      HEAP32[(($ram)>>2)]=0;
      __label__ = 4; break;
    case 4: // $16
      var $17=HEAP32[(($ram)>>2)];
      STACKTOP = __stackBase__;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21device_get_config_ramPK8device_tjP10deviceinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$2;
      if ($4 == 0) {
        __label__ = 1; break;
      }
      else if ($4 == 1) {
        __label__ = 2; break;
      }
      else if ($4 == 131072) {
        __label__ = 3; break;
      }
      else if ($4 == 131073 || $4 == 131074) {
        __label__ = 10; break;
      }
      else if ($4 == 131077) {
        __label__ = 4; break;
      }
      else if ($4 == 196608) {
        __label__ = 5; break;
      }
      else if ($4 == 196610) {
        __label__ = 6; break;
      }
      else if ($4 == 196611) {
        __label__ = 7; break;
      }
      else if ($4 == 196612) {
        __label__ = 8; break;
      }
      else if ($4 == 196613) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 1: // $5
      var $6=$3;
      var $7=$6;
      var $$emscripten$temp$0$0=8;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($7)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($7+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 10; break;
    case 2: // $8
      var $9=$3;
      var $10=$9;
      var $$emscripten$temp$1$0=12;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($10)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($10+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 10; break;
    case 3: // $11
      var $12=$3;
      var $13=$12;
      HEAP32[(($13)>>2)]=1128;
      __label__ = 10; break;
    case 4: // $14
      var $15=$3;
      var $16=$15;
      HEAP32[(($16)>>2)]=1130;
      __label__ = 10; break;
    case 5: // $17
      var $18=$3;
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=_strcpy($20, ((STRING_TABLE.__str15330)|0));
      __label__ = 10; break;
    case 6: // $22
      var $23=$3;
      var $24=$23;
      var $25=HEAP32[(($24)>>2)];
      var $26=_strcpy($25, ((STRING_TABLE.__str15330)|0));
      __label__ = 10; break;
    case 7: // $27
      var $28=$3;
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=_strcpy($30, ((STRING_TABLE.__str25331)|0));
      __label__ = 10; break;
    case 8: // $32
      var $33=$3;
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=_strcpy($35, ((STRING_TABLE.__str35332)|0));
      __label__ = 10; break;
    case 9: // $37
      var $38=$3;
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=_strcpy($40, ((STRING_TABLE.__str45333)|0));
      __label__ = 10; break;
    case 10: // $42
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21device_get_config_ramPK8device_tjP10deviceinfo["X"]=1;

function __ZL16device_start_ramP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $ram;
      var $config;
      var $ramsize_string;
      $6=$device;
      var $7=$6;
      var $8=__ZL14get_safe_tokenP8device_t5350($7);
      $ram=$8;
      var $9=$6;
      var $10=__Z8downcastIPK18legacy_device_base8device_tET_PT0_($9);
      var $11=__ZNK18legacy_device_base13inline_configEv($10);
      var $12=$11;
      $config=$12;
      var $13=$6;
      var $14=__ZNK8device_t3tagEv($13);
      var $15=_strcmp($14, ((STRING_TABLE.__str75338)|0));
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $17
      var $18=$6;
      var $19=__ZNK8device_t7machineEv($18);
      var $20=__ZNK15running_machine7optionsEv($19);
      var $21=__ZNK11emu_options8ram_sizeEv($20);
      $ramsize_string=$21;
      var $22=$ramsize_string;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $24
      var $25=$ramsize_string;
      var $26=(($25)|0);
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $30
      var $31=$ramsize_string;
      var $32=__Z16ram_parse_stringPKc($31);
      var $33=$ram;
      var $34=(($33)|0);
      HEAP32[(($34)>>2)]=$32;
      __label__ = 4; break;
    case 4: // $35
      __label__ = 5; break;
    case 5: // $36
      var $37=$ram;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$config;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=__Z16ram_parse_stringPKc($44);
      var $46=$ram;
      var $47=(($46)|0);
      HEAP32[(($47)>>2)]=$45;
      __label__ = 7; break;
    case 7: // $48
      var $49=$6;
      var $50=__ZNK8device_t7machineEv($49);
      var $51=__ZN15running_machine7respoolEv($50);
      var $52=$ram;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$1;
      var $56=$2;
      var $57=$3;
      var $58=$result_i;
      var $59=$4;
      var $60=$5;
      HEAP32[(($1)>>2)]=$54;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str35332)|0);
      HEAP32[(($3)>>2)]=114;
      var $61=HEAP32[(($1)>>2)];
      var $62=HEAP32[(($2)>>2)];
      var $63=HEAP32[(($3)>>2)];
      var $64=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($61, $62, $63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $65
      HEAP32[(($result_i)>>2)]=$64;
      var $66=HEAP32[(($result_i)>>2)];
      var $67=(($66)|0)==0;
      if ($67) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $68
      var $69=___cxa_allocate_exception(4);
      var $70=$69;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($70);
      (function() { try { __THREW__ = false; return ___cxa_throw($69, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      HEAP32[(($4)>>2)]=$73;
      var $74=$72.f1;
      HEAP32[(($5)>>2)]=$74;
      var $75=HEAP32[(($5)>>2)];
      var $76=(($75)|0) < 0;
      if ($76) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $77
      var $78=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($78);
      throw "Reached an unreachable!"
    case 12: // $79
      var $80=HEAP32[(($4)>>2)];
      var $81=HEAP32[(($4)>>2)];
      var $82=HEAP32[(($5)>>2)];
      var $83=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $81, tempValue);
      var $84=($83.f1 = $82, $83);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $85
      throw "Reached an unreachable!"
    case 14: // $_ZnajPKci_exit
      var $86=HEAP32[(($result_i)>>2)];
      var $87=$1;
      var $88=$2;
      var $89=$3;
      var $90=$result_i;
      var $91=$4;
      var $92=$5;
      var $93=$ram;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=__ZN13resource_pool9add_arrayIhEEPT_S2_i($51, $86, $95);
      var $97=$ram;
      var $98=(($97+4)|0);
      HEAP32[(($98)>>2)]=$96;
      var $99=$ram;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$config;
      var $103=(($102+8)|0);
      var $104=HEAPU8[($103)];
      var $105=(($104)&255);
      var $106=(($105) & 255);
      var $107=$ram;
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      _memset($101, $106, $109, 1);
      var $110=$6;
      var $111=$ram;
      var $112=(($111)|0);
      __ZN8device_t9save_itemIjEEvRT_PKci($110, $112, ((STRING_TABLE.__str155346)|0), 0);
      var $113=$6;
      var $114=$ram;
      var $115=(($114+4)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$ram;
      var $118=(($117)|0);
      var $119=HEAP32[(($118)>>2)];
      __ZN8device_t12save_pointerIhEEvPT_PKcji($113, $116, ((STRING_TABLE.__str165347)|0), $119, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16device_start_ramP8device_t["X"]=1;

function __ZL25device_validity_check_ramPK11game_driverPK8device_tR11emu_options($driver, $device, $options) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $config;
      var $ramsize_string;
      var $is_valid;
      var $specified_ram;
      var $error;
      var $gamename_option;
      var $j;
      var $size;
      var $s;
      var $e;
      var $p;
      var $option_ram_size;
      $1=$driver;
      $2=$device;
      $3=$options;
      var $4=$2;
      var $5=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($4);
      var $6=__ZNK18legacy_device_base13inline_configEv($5);
      var $7=$6;
      $config=$7;
      $ramsize_string=0;
      $is_valid=0;
      $specified_ram=0;
      $error=0;
      $gamename_option=0;
      var $8=$config;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$config;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__Z16ram_parse_stringPKc($13);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$1;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$config;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str65337)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,HEAP32[((tempInt+4)>>2)]=$22,HEAP32[((tempInt+8)>>2)]=$25,tempInt));
      $error=1;
      __label__ = 3; break;
    case 3: // $26
      var $27=$2;
      var $28=__ZNK8device_t3tagEv($27);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 36; break; }
    case 4: // $30
      var $31=$2;
      var $32=__ZNK8device_t3tagEv($31);
      var $33=_strcmp($32, ((STRING_TABLE.__str75338)|0));
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 5; break; } else { __label__ = 36; break; }
    case 5: // $35
      var $36=$3;
      var $37=__ZNK11emu_options8ram_sizeEv($36);
      $ramsize_string=$37;
      var $38=$3;
      var $39=__ZNK11emu_options11system_nameEv($38);
      $gamename_option=$39;
      var $40=$ramsize_string;
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 6; break; } else { __label__ = 34; break; }
    case 6: // $42
      var $43=$ramsize_string;
      var $44=(($43)|0);
      var $45=HEAP8[($44)];
      var $46=(($45 << 24) >> 24);
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 7; break; } else { __label__ = 34; break; }
    case 7: // $48
      var $49=$ramsize_string;
      var $50=__Z16ram_parse_stringPKc($49);
      $specified_ram=$50;
      var $51=$specified_ram;
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $53
      var $54=$1;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$1;
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$ramsize_string;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str85339)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,HEAP32[((tempInt+4)>>2)]=$59,HEAP32[((tempInt+8)>>2)]=$60,tempInt));
      $error=1;
      __label__ = 9; break;
    case 9: // $61
      var $62=$gamename_option;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 10; break; } else { __label__ = 32; break; }
    case 10: // $64
      var $65=$gamename_option;
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 11; break; } else { __label__ = 32; break; }
    case 11: // $69
      var $70=$gamename_option;
      var $71=$1;
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=_strcmp($70, $73);
      var $75=(($74)|0)==0;
      if ($75) { __label__ = 12; break; } else { __label__ = 32; break; }
    case 12: // $76
      var $77=$config;
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=__Z16ram_parse_stringPKc($79);
      var $81=$specified_ram;
      var $82=(($80)|0)==(($81)|0);
      if ($82) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $83
      $is_valid=1;
      __label__ = 14; break;
    case 14: // $84
      var $85=$config;
      var $86=(($85+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 15; break; } else { __label__ = 31; break; }
    case 15: // $89
      var $90=$config;
      var $91=(($90+4)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=_strlen($92);
      $size=$93;
      var $94=$config;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=__Z11core_strdupPKc($96);
      $s=$97;
      var $98=$s;
      var $99=$size;
      var $100=(($98+$99)|0);
      $e=$100;
      var $101=$s;
      $p=$101;
      $j=0;
      __label__ = 16; break;
    case 16: // $102
      var $103=$j;
      var $104=$size;
      var $105=(($103)|0) < (($104)|0);
      if ($105) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $106
      var $107=$j;
      var $108=$p;
      var $109=(($108+$107)|0);
      var $110=HEAP8[($109)];
      var $111=(($110 << 24) >> 24);
      var $112=(($111)|0)==44;
      if ($112) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $113
      var $114=$j;
      var $115=$p;
      var $116=(($115+$114)|0);
      HEAP8[($116)]=0;
      __label__ = 19; break;
    case 19: // $117
      __label__ = 20; break;
    case 20: // $118
      var $119=$j;
      var $120=(($119+1)|0);
      $j=$120;
      __label__ = 16; break;
    case 21: // $121
      __label__ = 22; break;
    case 22: // $122
      var $123=$p;
      var $124=$e;
      var $125=(($123)>>>0) <= (($124)>>>0);
      if ($125) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $126
      var $127=$p;
      var $128=__Z16ram_parse_stringPKc($127);
      $option_ram_size=$128;
      var $129=$option_ram_size;
      var $130=(($129)|0)==0;
      if ($130) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $131
      var $132=$1;
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$1;
      var $136=(($135+8)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$p;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str95340)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,HEAP32[((tempInt+4)>>2)]=$137,HEAP32[((tempInt+8)>>2)]=$138,tempInt));
      $error=1;
      __label__ = 25; break;
    case 25: // $139
      var $140=$option_ram_size;
      var $141=$specified_ram;
      var $142=(($140)|0)==(($141)|0);
      if ($142) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $143
      $is_valid=1;
      __label__ = 27; break;
    case 27: // $144
      var $145=$p;
      var $146=_strlen($145);
      var $147=$p;
      var $148=(($147+$146)|0);
      $p=$148;
      var $149=$p;
      var $150=$e;
      var $151=(($149)|0)==(($150)|0);
      if ($151) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $152
      __label__ = 30; break;
    case 29: // $153
      var $154=$p;
      var $155=(($154+1)|0);
      $p=$155;
      __label__ = 22; break;
    case 30: // $156
      var $157=$s;
      _osd_free($157);
      __label__ = 31; break;
    case 31: // $158
      __label__ = 33; break;
    case 32: // $159
      $is_valid=1;
      __label__ = 33; break;
    case 33: // $160
      __label__ = 35; break;
    case 34: // $161
      $is_valid=1;
      __label__ = 35; break;
    case 35: // $162
      __label__ = 37; break;
    case 36: // $163
      $is_valid=1;
      __label__ = 37; break;
    case 37: // $164
      var $165=$is_valid;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 42; break; } else { __label__ = 38; break; }
    case 38: // $167
      var $168=$1;
      var $169=(($168)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$1;
      var $172=(($171+8)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=$ramsize_string;
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str105341)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$170,HEAP32[((tempInt+4)>>2)]=$173,HEAP32[((tempInt+8)>>2)]=$174,tempInt));
      var $175=$config;
      var $176=(($175)|0);
      var $177=HEAP32[(($176)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str115342)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$177,tempInt));
      var $178=$config;
      var $179=(($178+4)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $182
      var $183=$config;
      var $184=(($183+4)|0);
      var $185=HEAP32[(($184)>>2)];
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str125343)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,tempInt));
      __label__ = 41; break;
    case 40: // $186
      __Z17mame_printf_errorPKcz(((STRING_TABLE.__str135344)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 41; break;
    case 41: // $187
      $error=1;
      __label__ = 42; break;
    case 42: // $188
      var $189=$error;
      ;
      return $189;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25device_validity_check_ramPK11game_driverPK8device_tR11emu_options["X"]=1;

function __ZL14get_safe_tokenP8device_t5350($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP18legacy_device_base8device_tET_PT0_($6);
      var $8=__ZNK18legacy_device_base5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10ram_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($8, $9, $10, $11, $12, $13, 1134);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV10ram_device+8)|0);
  ;
  return;
}


function __ZN10ram_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN10ram_deviceD2Ev($2);
  ;
  return;
}


function __ZN10ram_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN18legacy_device_baseD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI10ram_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI10ram_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI10ram_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 368);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI10ram_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI10ram_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI10ram_deviceED2Ev($2);
  ;
  return;
}


function __Z21legacy_device_creatorI10ram_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=368;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str55336)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10ram_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 1132, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI10ram_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str55336)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI10ram_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN10ram_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN10ram_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN10ram_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI10ram_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI10ram_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI10ram_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI10ram_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI10ram_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI10ram_deviceED0Ev["X"]=1;

function __ZN14speaker_device19sound_stream_updateER12sound_streamPPiS3_i($this, $stream, $inputs, $outputs, $samples) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $pos;
      var $sample;
      var $inp;
      $1=$this;
      $2=$stream;
      $3=$inputs;
      $4=$outputs;
      $5=$samples;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      $pos=0;
      __label__ = 3; break;
    case 3: // $9
      var $10=$pos;
      var $11=$5;
      var $12=(($10)|0) < (($11)|0);
      if ($12) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $13
      var $14=$pos;
      var $15=$3;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+($14<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      $sample=$19;
      $inp=1;
      __label__ = 5; break;
    case 5: // $20
      var $21=$inp;
      var $22=$6;
      var $23=(($22+356)|0);
      var $24=$23;
      var $25=(($24+36)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($21)|0) < (($26)|0);
      if ($27) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $28
      var $29=$pos;
      var $30=$inp;
      var $31=$3;
      var $32=(($31+($30<<2))|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+($29<<2))|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$sample;
      var $37=(($36+$35)|0);
      $sample=$37;
      __label__ = 7; break;
    case 7: // $38
      var $39=$inp;
      var $40=(($39+1)|0);
      $inp=$40;
      __label__ = 5; break;
    case 8: // $41
      var $42=$sample;
      var $43=$pos;
      var $44=$4;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+($43<<2))|0);
      HEAP32[(($47)>>2)]=$42;
      __label__ = 9; break;
    case 9: // $48
      var $49=$pos;
      var $50=(($49+1)|0);
      $pos=$50;
      __label__ = 3; break;
    case 10: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14speaker_device19sound_stream_updateER12sound_streamPPiS3_i["X"]=1;

function __ZNK11emu_options8ram_sizeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str145345)|0));
  ;
  return $4;
}


function __ZN8device_t12save_pointerIhEEvPT_PKcji($this, $value, $valname, $count, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$count;
      $5=$index;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      var $9=(($6+284)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK8device_t4nameEv($6);
      var $12=__ZNK8device_t3tagEv($6);
      var $13=$5;
      var $14=$2;
      var $15=$3;
      var $16=$4;
      __ZN12save_manager12save_pointerIhEEvPKcS2_iPT_S2_j($10, $11, $12, $13, $14, $15, $16);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn356_N14speaker_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN14speaker_deviceD0Ev($5);
  ;
  return;
}


function __ZThn356_N14speaker_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN14speaker_deviceD1Ev]($5);
  ;
  return;
}


function __ZN14speaker_device12device_startEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+356)|0);
      var $5=$4;
      var $6=(($5+36)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=__ZNK8device_t3tagEv($10);
      __Z8logerrorPKcz(((STRING_TABLE.__str15354)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$11,tempInt));
      __label__ = 3; break;
    case 2: // $12
      var $13=$2;
      var $14=__ZNK8device_t7machineEv($13);
      var $15=__ZNK15running_machine5soundEv($14);
      var $16=$2;
      var $17=$2;
      var $18=(($17+356)|0);
      var $19=$18;
      var $20=(($19+36)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$2;
      var $23=__ZNK8device_t7machineEv($22);
      var $24=__ZNK15running_machine11sample_rateEv($23);
      var $25=__ZN13sound_manager12stream_allocER8device_tiiiPvPFvPS0_P12sound_streamS2_PPiS7_iE($15, $16, $21, 1, $24, 0, 0);
      var $26=(($2+420)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 3; break;
    case 3: // $27
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14speaker_device16device_post_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+420)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$2;
  var $6=__ZNK8device_t7machineEv($5);
  var $7=__ZNK15running_machine11sample_rateEv($6);
  __ZN12sound_stream15set_sample_rateEi($4, $7);
  ;
  return;
}


function __ZThn356_N14speaker_device19sound_stream_updateER12sound_streamPPiS3_i($this, $stream, $inputs, $outputs, $samples) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$stream;
  $3=$inputs;
  $4=$outputs;
  $5=$samples;
  var $6=$1;
  var $7=$6;
  var $8=(($7-356)|0);
  var $9=$8;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$2;
  __ZN14speaker_device19sound_stream_updateER12sound_streamPPiS3_i($9, $13, $10, $11, $12);
  ;
  return;
}


function __ZN14speaker_device3mixEPiS0_Rib($this, $leftmix, $rightmix, $samples_this_update, $suppress) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $numsamples=__stackBase__;
      var $stream_buf;
      var $sample;
      var $sample1;
      var $sample2;
      $1=$this;
      $2=$leftmix;
      $3=$rightmix;
      $4=$samples_this_update;
      var $6=(($suppress)&1);
      $5=$6;
      var $7=$1;
      var $8=(($7+420)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      __label__ = 26; break;
    case 2: // $12
      var $13=(($7+420)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZN12sound_stream24output_since_last_updateEiRi($14, 0, $numsamples);
      $stream_buf=$15;
      var $16=$4;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=HEAP32[(($numsamples)>>2)];
      var $21=$4;
      HEAP32[(($21)>>2)]=$20;
      var $22=$2;
      var $23=$22;
      var $24=$4;
      var $25=HEAP32[(($24)>>2)];
      var $26=((($25<<2))|0);
      _memset($23, 0, $26, 1);
      var $27=$3;
      var $28=$27;
      var $29=$4;
      var $30=HEAP32[(($29)>>2)];
      var $31=((($30<<2))|0);
      _memset($28, 0, $31, 1);
      __label__ = 4; break;
    case 4: // $32
      __label__ = 5; break;
    case 5: // $33
      __label__ = 6; break;
    case 6: // $34
      var $35=$5;
      var $36=(($35) & 1);
      if ($36) { __label__ = 26; break; } else { __label__ = 7; break; }
    case 7: // $37
      var $38=(($7+396)|0);
      var $39=(tempDoubleI32[0]=HEAP32[(($38)>>2)],tempDoubleI32[1]=HEAP32[(($38+4)>>2)],tempDoubleF64[0]);
      var $40=$39 == 0;
      if ($40) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $41
      $sample=0;
      __label__ = 9; break;
    case 9: // $42
      var $43=$sample;
      var $44=$4;
      var $45=HEAP32[(($44)>>2)];
      var $46=(($43)|0) < (($45)|0);
      if ($46) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $47
      var $48=$sample;
      var $49=$stream_buf;
      var $50=(($49+($48<<2))|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$sample;
      var $53=$2;
      var $54=(($53+($52<<2))|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+$51)|0);
      HEAP32[(($54)>>2)]=$56;
      var $57=$sample;
      var $58=$stream_buf;
      var $59=(($58+($57<<2))|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$sample;
      var $62=$3;
      var $63=(($62+($61<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+$60)|0);
      HEAP32[(($63)>>2)]=$65;
      __label__ = 11; break;
    case 11: // $66
      var $67=$sample;
      var $68=(($67+1)|0);
      $sample=$68;
      __label__ = 9; break;
    case 12: // $69
      __label__ = 25; break;
    case 13: // $70
      var $71=(($7+396)|0);
      var $72=(tempDoubleI32[0]=HEAP32[(($71)>>2)],tempDoubleI32[1]=HEAP32[(($71+4)>>2)],tempDoubleF64[0]);
      var $73=$72 < 0;
      if ($73) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $74
      $sample1=0;
      __label__ = 15; break;
    case 15: // $75
      var $76=$sample1;
      var $77=$4;
      var $78=HEAP32[(($77)>>2)];
      var $79=(($76)|0) < (($78)|0);
      if ($79) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $80
      var $81=$sample1;
      var $82=$stream_buf;
      var $83=(($82+($81<<2))|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$sample1;
      var $86=$2;
      var $87=(($86+($85<<2))|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+$84)|0);
      HEAP32[(($87)>>2)]=$89;
      __label__ = 17; break;
    case 17: // $90
      var $91=$sample1;
      var $92=(($91+1)|0);
      $sample1=$92;
      __label__ = 15; break;
    case 18: // $93
      __label__ = 24; break;
    case 19: // $94
      $sample2=0;
      __label__ = 20; break;
    case 20: // $95
      var $96=$sample2;
      var $97=$4;
      var $98=HEAP32[(($97)>>2)];
      var $99=(($96)|0) < (($98)|0);
      if ($99) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $100
      var $101=$sample2;
      var $102=$stream_buf;
      var $103=(($102+($101<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$sample2;
      var $106=$3;
      var $107=(($106+($105<<2))|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+$104)|0);
      HEAP32[(($107)>>2)]=$109;
      __label__ = 22; break;
    case 22: // $110
      var $111=$sample2;
      var $112=(($111+1)|0);
      $sample2=$112;
      __label__ = 20; break;
    case 23: // $113
      __label__ = 24; break;
    case 24: // $114
      __label__ = 25; break;
    case 25: // $115
      __label__ = 26; break;
    case 26: // $116
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14speaker_device3mixEPiS0_Rib["X"]=1;

function __ZN20resource_pool_objectI10ram_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI10ram_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14device_creatorI14speaker_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=424;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str25355)|0);
      HEAP32[(($6)>>2)]=111;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14speaker_deviceC1ERK14machine_configPKcP8device_tj]($53, $54, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI14speaker_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str25355)|0);
      HEAP32[(($3)>>2)]=111;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14device_creatorI14speaker_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN14speaker_deviceC2ERK14machine_configPKcP8device_tj($this, $mconfig, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$mconfig;
      $3=$tag;
      $4=$owner;
      $5=$clock;
      var $8=$1;
      var $9=$8;
      var $10=$2;
      var $11=HEAP32[((_SPEAKER)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=$5;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($9, $10, $11, ((STRING_TABLE.__str5353)|0), $12, $13, $14);
      var $15=$8;
      HEAP32[(($15)>>2)]=((__ZTV14speaker_device+8)|0);
      var $16=$8;
      var $17=(($16+356)|0);
      var $18=$17;
      HEAP32[(($18)>>2)]=((__ZTV14speaker_device+80)|0);
      var $19=$8;
      var $20=(($19+356)|0);
      var $21=$20;
      var $22=$2;
      var $23=$8;
      (function() { try { __THREW__ = false; return __ZN22device_sound_interfaceC2ERK14machine_configR8device_t($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $24
      var $25=$8;
      HEAP32[(($25)>>2)]=((__ZTV14speaker_device+8)|0);
      var $26=$8;
      var $27=(($26+356)|0);
      var $28=$27;
      HEAP32[(($28)>>2)]=((__ZTV14speaker_device+80)|0);
      var $29=(($8+396)|0);
      (tempDoubleF64[0]=0,HEAP32[(($29)>>2)]=tempDoubleI32[0],HEAP32[(($29+4)>>2)]=tempDoubleI32[1]);
      var $30=(($8+404)|0);
      (tempDoubleF64[0]=0,HEAP32[(($30)>>2)]=tempDoubleI32[0],HEAP32[(($30+4)>>2)]=tempDoubleI32[1]);
      var $31=(($8+412)|0);
      (tempDoubleF64[0]=0,HEAP32[(($31)>>2)]=tempDoubleI32[0],HEAP32[(($31+4)>>2)]=tempDoubleI32[1]);
      var $32=(($8+420)|0);
      HEAP32[(($32)>>2)]=0;
      ;
      return;
    case 2: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $35=$34.f0;
      $6=$35;
      var $36=$34.f1;
      $7=$36;
      var $37=$8;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $38
      __label__ = 4; break;
    case 4: // $39
      var $40=$6;
      var $41=$6;
      var $42=$7;
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14speaker_deviceC2ERK14machine_configPKcP8device_tj["X"]=1;

function __ZN14speaker_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14speaker_deviceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14speaker_deviceD0Ev["X"]=1;

function __ZN14speaker_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+356)|0);
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN22device_sound_interfaceD2Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      __ZN8device_tD2Ev($9);
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=$4;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$2;
      var $19=$3;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI14speaker_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14speaker_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14speaker_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 424);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14speaker_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14speaker_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14speaker_deviceED2Ev($2);
  ;
  return;
}


function __Z11ui_gfx_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $state;
      var $gfx;
      var $2=__stackBase__;
      $1=$machine;
      $state=__ZL6ui_gfx;
      var $3=$1;
      var $4=$1;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 1136, ((STRING_TABLE.__str5358)|0), $4);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($3, 4, $2);
      var $5=$state;
      var $6=$5;
      _memset($6, 0, 464, 1);
      var $7=$state;
      var $8=(($7+12)|0);
      var $9=(($8+8)|0);
      HEAP32[(($9)>>2)]=16;
      $gfx=0;
      __label__ = 1; break;
    case 1: // $10
      var $11=$gfx;
      var $12=(($11)|0) < 32;
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$1;
      var $15=__ZNK15running_machine6systemEv($14);
      var $16=(($15+44)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$17 & 7;
      var $19=(($18) & 255);
      var $20=$gfx;
      var $21=$state;
      var $22=(($21+24)|0);
      var $23=(($22+388)|0);
      var $24=(($23+$20)|0);
      HEAP8[($24)]=$19;
      var $25=$gfx;
      var $26=$state;
      var $27=(($26+24)|0);
      var $28=(($27+260)|0);
      var $29=(($28+($25<<2))|0);
      HEAP32[(($29)>>2)]=16;
      __label__ = 3; break;
    case 3: // $30
      var $31=$gfx;
      var $32=(($31+1)|0);
      $gfx=$32;
      __label__ = 1; break;
    case 4: // $33
      var $34=$1;
      var $35=__ZNK15running_machine6systemEv($34);
      var $36=(($35+44)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$37 & 7;
      var $39=(($38) & 255);
      var $40=$state;
      var $41=(($40+444)|0);
      var $42=(($41+16)|0);
      HEAP8[($42)]=$39;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11ui_gfx_initR15running_machine["X"]=1;

function __ZL11ui_gfx_exitR15running_machine($machine) {
  ;
  var __label__;

  var $1;
  $1=$machine;
  var $2=$1;
  var $3=__ZNK15running_machine6renderEv($2);
  var $4=HEAP32[((((__ZL6ui_gfx+8)|0))>>2)];
  __ZN14render_manager12texture_freeEP14render_texture($3, $4);
  HEAP32[((((__ZL6ui_gfx+8)|0))>>2)]=0;
  var $5=HEAP32[((((__ZL6ui_gfx+4)|0))>>2)];
  var $6=$5;
  __ZN13resource_pool6removeEPv(_global_resource_pool, $6);
  HEAP32[((((__ZL6ui_gfx+4)|0))>>2)]=0;
  ;
  return;
}


function __Z17ui_gfx_ui_handlerR15running_machineP16render_containerj($machine, $container, $uistate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $state;
      $2=$machine;
      $3=$container;
      $4=$uistate;
      $state=__ZL6ui_gfx;
      var $5=$2;
      var $6=__ZNK15running_machine12total_colorsEv($5);
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+572)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $13
      var $14=$2;
      var $15=(($14+432)|0);
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $19
      var $20=$2;
      var $21=__Z13tilemap_countR15running_machine($20);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      __label__ = 29; break;
    case 5: // $24
      var $25=$2;
      var $26=__ZNK15running_machine6pausedEv($25);
      if ($26) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $27
      var $28=$state;
      var $29=(($28+1)|0);
      HEAP8[($29)]=1;
      __label__ = 7; break;
    case 7: // $30
      __label__ = 8; break;
    case 8: // $31
      var $32=$state;
      var $33=(($32)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      if ($35 == 0) {
        __label__ = 9; break;
      }
      else if ($35 == 1) {
        __label__ = 12; break;
      }
      else if ($35 == 2) {
        __label__ = 15; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 9: // $36
      var $37=$2;
      var $38=__ZNK15running_machine12total_colorsEv($37);
      var $39=(($38)>>>0) > 0;
      if ($39) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $40
      var $41=$2;
      var $42=$3;
      var $43=$state;
      __ZL15palette_handlerR15running_machineP16render_containerP13_ui_gfx_state($41, $42, $43);
      __label__ = 18; break;
    case 11: // $44
      var $45=$state;
      var $46=(($45)|0);
      var $47=HEAP8[($46)];
      var $48=(($47+1)&255);
      HEAP8[($46)]=$48;
      __label__ = 12; break;
    case 12: // $49
      var $50=$2;
      var $51=(($50+432)|0);
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $55
      var $56=$2;
      var $57=$3;
      var $58=$state;
      __ZL14gfxset_handlerR15running_machineP16render_containerP13_ui_gfx_state($56, $57, $58);
      __label__ = 18; break;
    case 14: // $59
      var $60=$state;
      var $61=(($60)|0);
      var $62=HEAP8[($61)];
      var $63=(($62+1)&255);
      HEAP8[($61)]=$63;
      __label__ = 15; break;
    case 15: // $64
      var $65=$2;
      var $66=__Z13tilemap_countR15running_machine($65);
      var $67=(($66)|0) > 0;
      if ($67) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $68
      var $69=$2;
      var $70=$3;
      var $71=$state;
      __ZL15tilemap_handlerR15running_machineP16render_containerP13_ui_gfx_state($69, $70, $71);
      __label__ = 18; break;
    case 17: // $72
      var $73=$state;
      var $74=(($73)|0);
      HEAP8[($74)]=0;
      __label__ = 8; break;
    case 18: // $75
      var $76=$2;
      var $77=__Z16ui_input_pressedR15running_machinei($76, 182);
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $79
      var $80=$state;
      var $81=(($80)|0);
      var $82=HEAPU8[($81)];
      var $83=(($82)&255);
      var $84=(($83+1)|0);
      var $85=(($84)|0)%3;
      var $86=(($85) & 255);
      var $87=$state;
      var $88=(($87)|0);
      HEAP8[($88)]=$86;
      var $89=$state;
      var $90=(($89+1)|0);
      HEAP8[($90)]=1;
      __label__ = 20; break;
    case 20: // $91
      var $92=$2;
      var $93=__Z16ui_input_pressedR15running_machinei($92, 162);
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $95
      var $96=$2;
      var $97=__ZNK15running_machine6pausedEv($96);
      if ($97) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $98
      var $99=$2;
      __ZN15running_machine6resumeEv($99);
      __label__ = 24; break;
    case 23: // $100
      var $101=$2;
      __ZN15running_machine5pauseEv($101);
      __label__ = 24; break;
    case 24: // $102
      __label__ = 25; break;
    case 25: // $103
      var $104=$2;
      var $105=__Z16ui_input_pressedR15running_machinei($104, 183);
      var $106=(($105)|0)!=0;
      if ($106) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $107
      var $108=$2;
      var $109=__Z16ui_input_pressedR15running_machinei($108, 165);
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $111
      __label__ = 29; break;
    case 28: // $112
      var $113=$4;
      $1=$113;
      __label__ = 32; break;
    case 29: // $114
      var $115=$4;
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $117
      var $118=$2;
      __ZN15running_machine6resumeEv($118);
      __label__ = 31; break;
    case 31: // $119
      var $120=$state;
      var $121=(($120+1)|0);
      HEAP8[($121)]=1;
      $1=-1;
      __label__ = 32; break;
    case 32: // $122
      var $123=$1;
      ;
      return $123;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17ui_gfx_ui_handlerR15running_machineP16render_containerj["X"]=1;

function __ZN13resource_pool10add_objectI14speaker_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14speaker_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14speaker_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI14speaker_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14speaker_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14speaker_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI14speaker_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI14speaker_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15palette_handlerR15running_machineP16render_containerP13_ui_gfx_state($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $total;
      var $title;
      var $raw_color;
      var $ui_font;
      var $cellwidth;
      var $cellheight;
      var $chwidth;
      var $chheight;
      var $titlewidth;
      var $x0;
      var $y0;
      var $cellboxbounds=__stackBase__;
      var $boxbounds=__stackBase__+16;
      var $x;
      var $y;
      var $skip;
      var $buffer=__stackBase__+32;
      var $index;
      var $pen;
      $1=$machine;
      $2=$container;
      $3=$state;
      var $4=$3;
      var $5=(($4+12)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+572)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__Z27colortable_palette_get_sizeP12colortable_t($12);
      var $18 = $13;__label__ = 3; break;
    case 2: // $14
      var $15=$1;
      var $16=__ZNK15running_machine12total_colorsEv($15);
      var $18 = $16;__label__ = 3; break;
    case 3: // $17
      var $18;
      $total=$18;
      var $19=$3;
      var $20=(($19+12)|0);
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      var $24=$23 ? (((STRING_TABLE.__str95367)|0)) : (((STRING_TABLE.__str105368)|0));
      $title=$24;
      var $25=$1;
      var $26=(($25+564)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__Z22palette_entry_list_rawP10_palette_t($27);
      $raw_color=$28;
      var $29=$1;
      var $30=__Z11ui_get_fontR15running_machine($29);
      $ui_font=$30;
      var $31=$1;
      var $32=__Z18ui_get_line_heightR15running_machine($31);
      $chheight=$32;
      var $33=$ui_font;
      var $34=$chheight;
      var $35=$1;
      var $36=__ZNK15running_machine6renderEv($35);
      var $37=__ZN14render_manager9ui_aspectEv($36);
      var $38=__ZN11render_font10char_widthEffj($33, $34, $37, 48);
      $chwidth=$38;
      var $39=$chwidth;
      var $40=$39*0.5;
      var $41=$40;
      var $42=(($boxbounds)|0);
      HEAPF32[(($42)>>2)]=$41;
      var $43=$chwidth;
      var $44=$43*0.5;
      var $45=1-$44;
      var $46=(($boxbounds+8)|0);
      HEAPF32[(($46)>>2)]=$45;
      var $47=$chheight;
      var $48=$47*0.5;
      var $49=$48;
      var $50=(($boxbounds+4)|0);
      HEAPF32[(($50)>>2)]=$49;
      var $51=$chheight;
      var $52=$51*0.5;
      var $53=1-$52;
      var $54=(($boxbounds+12)|0);
      HEAPF32[(($54)>>2)]=$53;
      var $55=$cellboxbounds;
      var $56=$boxbounds;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($55)>>2)]=HEAP32[(($56)>>2)];HEAP32[(($55+4)>>2)]=HEAP32[(($56+4)>>2)];HEAP32[(($55+8)>>2)]=HEAP32[(($56+8)>>2)];HEAP32[(($55+12)>>2)]=HEAP32[(($56+12)>>2)];
      var $57=$chwidth;
      var $58=$57*0.5;
      var $59=(($cellboxbounds)|0);
      var $60=HEAPF32[(($59)>>2)];
      var $61=$60+$58;
      HEAPF32[(($59)>>2)]=$61;
      var $62=$chwidth;
      var $63=$62*0.5;
      var $64=(($cellboxbounds+8)|0);
      var $65=HEAPF32[(($64)>>2)];
      var $66=$65-$63;
      HEAPF32[(($64)>>2)]=$66;
      var $67=$chheight;
      var $68=$67*0.5;
      var $69=(($cellboxbounds+4)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $71=$70+$68;
      HEAPF32[(($69)>>2)]=$71;
      var $72=$chheight;
      var $73=$72*0.5;
      var $74=(($cellboxbounds+12)|0);
      var $75=HEAPF32[(($74)>>2)];
      var $76=$75-$73;
      HEAPF32[(($74)>>2)]=$76;
      var $77=$chwidth;
      var $78=$77*5.5;
      var $79=(($cellboxbounds)|0);
      var $80=HEAPF32[(($79)>>2)];
      var $81=$80+$78;
      HEAPF32[(($79)>>2)]=$81;
      var $82=$chheight;
      var $83=$82*3;
      var $84=(($cellboxbounds+4)|0);
      var $85=HEAPF32[(($84)>>2)];
      var $86=$85+$83;
      HEAPF32[(($84)>>2)]=$86;
      var $87=$ui_font;
      var $88=$chheight;
      var $89=$1;
      var $90=__ZNK15running_machine6renderEv($89);
      var $91=__ZN14render_manager9ui_aspectEv($90);
      var $92=$title;
      var $93=__ZN11render_font12string_widthEffPKc($87, $88, $91, $92);
      $titlewidth=$93;
      $x0=0;
      var $94=(($boxbounds+8)|0);
      var $95=HEAPF32[(($94)>>2)];
      var $96=(($boxbounds)|0);
      var $97=HEAPF32[(($96)>>2)];
      var $98=$95-$97;
      var $99=$titlewidth;
      var $100=$chwidth;
      var $101=$99+$100;
      var $102=$98 < $101;
      if ($102) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $103
      var $104=(($boxbounds)|0);
      var $105=HEAPF32[(($104)>>2)];
      var $106=$titlewidth;
      var $107=$chwidth;
      var $108=$106+$107;
      var $109=$108*0.5;
      var $110=0.5-$109;
      var $111=$105-$110;
      $x0=$111;
      __label__ = 5; break;
    case 5: // $112
      var $113=$2;
      var $114=(($boxbounds)|0);
      var $115=HEAPF32[(($114)>>2)];
      var $116=$x0;
      var $117=$115-$116;
      var $118=(($boxbounds+4)|0);
      var $119=HEAPF32[(($118)>>2)];
      var $120=(($boxbounds+8)|0);
      var $121=HEAPF32[(($120)>>2)];
      var $122=$x0;
      var $123=$121+$122;
      var $124=(($boxbounds+12)|0);
      var $125=HEAPF32[(($124)>>2)];
      __Z20ui_draw_outlined_boxP16render_containerffffj($113, $117, $119, $123, $125, -284159952);
      var $126=$titlewidth;
      var $127=$126*0.5;
      var $128=0.5-$127;
      $x0=$128;
      var $129=(($boxbounds+4)|0);
      var $130=HEAPF32[(($129)>>2)];
      var $131=$chheight;
      var $132=$131*0.5;
      var $133=$130+$132;
      $y0=$133;
      $x=0;
      __label__ = 6; break;
    case 6: // $134
      var $135=$x;
      var $136=$title;
      var $137=(($136+$135)|0);
      var $138=HEAP8[($137)];
      var $139=(($138 << 24) >> 24);
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $141
      var $142=$2;
      var $143=$x0;
      var $144=$y0;
      var $145=$chheight;
      var $146=$1;
      var $147=__ZNK15running_machine6renderEv($146);
      var $148=__ZN14render_manager9ui_aspectEv($147);
      var $149=$ui_font;
      var $150=$x;
      var $151=$title;
      var $152=(($151+$150)|0);
      var $153=HEAP8[($152)];
      var $154=(($153 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($142, $143, $144, $145, $148, -1, $149, $154);
      var $155=$ui_font;
      var $156=$chheight;
      var $157=$1;
      var $158=__ZNK15running_machine6renderEv($157);
      var $159=__ZN14render_manager9ui_aspectEv($158);
      var $160=$x;
      var $161=$title;
      var $162=(($161+$160)|0);
      var $163=HEAP8[($162)];
      var $164=(($163 << 24) >> 24);
      var $165=__ZN11render_font10char_widthEffj($155, $156, $159, $164);
      var $166=$x0;
      var $167=$166+$165;
      $x0=$167;
      __label__ = 8; break;
    case 8: // $168
      var $169=$x;
      var $170=(($169+1)|0);
      $x=$170;
      __label__ = 6; break;
    case 9: // $171
      var $172=(($cellboxbounds+8)|0);
      var $173=HEAPF32[(($172)>>2)];
      var $174=(($cellboxbounds)|0);
      var $175=HEAPF32[(($174)>>2)];
      var $176=$173-$175;
      var $177=$3;
      var $178=(($177+12)|0);
      var $179=(($178+8)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180)|0);
      var $182=$176/$181;
      $cellwidth=$182;
      var $183=(($cellboxbounds+12)|0);
      var $184=HEAPF32[(($183)>>2)];
      var $185=(($cellboxbounds+4)|0);
      var $186=HEAPF32[(($185)>>2)];
      var $187=$184-$186;
      var $188=$3;
      var $189=(($188+12)|0);
      var $190=(($189+8)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=(($191)|0);
      var $193=$187/$192;
      $cellheight=$193;
      var $194=$chwidth;
      var $195=$cellwidth;
      var $196=$194/$195;
      var $197=(($196)|0);
      $skip=$197;
      $x=0;
      __label__ = 10; break;
    case 10: // $198
      var $199=$x;
      var $200=$3;
      var $201=(($200+12)|0);
      var $202=(($201+8)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(($199)|0) < (($203)|0);
      if ($204) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $205
      var $206=(($boxbounds)|0);
      var $207=HEAPF32[(($206)>>2)];
      var $208=$chwidth;
      var $209=$208*6;
      var $210=$207+$209;
      var $211=$x;
      var $212=(($211)|0);
      var $213=$cellwidth;
      var $214=$212*$213;
      var $215=$210+$214;
      $x0=$215;
      var $216=(($boxbounds+4)|0);
      var $217=HEAPF32[(($216)>>2)];
      var $218=$chheight;
      var $219=$218*2;
      var $220=$217+$219;
      $y0=$220;
      var $221=$2;
      var $222=$x0;
      var $223=$cellwidth;
      var $224=$chwidth;
      var $225=$223-$224;
      var $226=$225*0.5;
      var $227=$222+$226;
      var $228=$y0;
      var $229=$chheight;
      var $230=$1;
      var $231=__ZNK15running_machine6renderEv($230);
      var $232=__ZN14render_manager9ui_aspectEv($231);
      var $233=$ui_font;
      var $234=$x;
      var $235=$234 & 15;
      var $236=((STRING_TABLE.__str75365+$235)|0);
      var $237=HEAP8[($236)];
      var $238=(($237 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($221, $227, $228, $229, $232, -1, $233, $238);
      var $239=$skip;
      var $240=(($239)|0)!=0;
      if ($240) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $241
      var $242=$2;
      var $243=$x0;
      var $244=$cellwidth;
      var $245=$244*0.5;
      var $246=$243+$245;
      var $247=$y0;
      var $248=$chheight;
      var $249=$247+$248;
      var $250=(($cellboxbounds+4)|0);
      var $251=HEAPF32[(($250)>>2)];
      var $252=$249+$251;
      var $253=$252*0.5;
      __ZN16render_container9add_pointEfffjj($242, $246, $253, 0.0020000000949949026, -1, 256);
      __label__ = 13; break;
    case 13: // $254
      __label__ = 14; break;
    case 14: // $255
      var $256=$skip;
      var $257=(($256+1)|0);
      var $258=$x;
      var $259=(($258+$257)|0);
      $x=$259;
      __label__ = 10; break;
    case 15: // $260
      var $261=$chheight;
      var $262=$cellheight;
      var $263=$261/$262;
      var $264=(($263)|0);
      $skip=$264;
      $y=0;
      __label__ = 16; break;
    case 16: // $265
      var $266=$y;
      var $267=$3;
      var $268=(($267+12)|0);
      var $269=(($268+8)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($266)|0) < (($270)|0);
      if ($271) { __label__ = 17; break; } else { __label__ = 27; break; }
    case 17: // $272
      var $273=$3;
      var $274=(($273+12)|0);
      var $275=(($274+4)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$y;
      var $278=$3;
      var $279=(($278+12)|0);
      var $280=(($279+8)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($277*$281)|0);
      var $283=(($276+$282)|0);
      var $284=$total;
      var $285=(($283)|0) < (($284)|0);
      if ($285) { __label__ = 18; break; } else { __label__ = 25; break; }
    case 18: // $286
      var $287=(($boxbounds)|0);
      var $288=HEAPF32[(($287)>>2)];
      var $289=$chwidth;
      var $290=$289*5.5;
      var $291=$288+$290;
      $x0=$291;
      var $292=(($boxbounds+4)|0);
      var $293=HEAPF32[(($292)>>2)];
      var $294=$chheight;
      var $295=$294*3.5;
      var $296=$293+$295;
      var $297=$y;
      var $298=(($297)|0);
      var $299=$cellheight;
      var $300=$298*$299;
      var $301=$296+$300;
      $y0=$301;
      var $302=$skip;
      var $303=(($302)|0)!=0;
      if ($303) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $304
      var $305=$2;
      var $306=$x0;
      var $307=(($cellboxbounds)|0);
      var $308=HEAPF32[(($307)>>2)];
      var $309=$306+$308;
      var $310=$309*0.5;
      var $311=$y0;
      var $312=$cellheight;
      var $313=$312*0.5;
      var $314=$311+$313;
      __ZN16render_container9add_pointEfffjj($305, $310, $314, 0.0020000000949949026, -1, 256);
      __label__ = 20; break;
    case 20: // $315
      var $316=(($buffer)|0);
      var $317=$3;
      var $318=(($317+12)|0);
      var $319=(($318+4)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$y;
      var $322=$3;
      var $323=(($322+12)|0);
      var $324=(($323+8)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($321*$325)|0);
      var $327=(($320+$326)|0);
      var $328=_sprintf($316, ((STRING_TABLE.__str85366)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$327,tempInt));
      $x=4;
      __label__ = 21; break;
    case 21: // $329
      var $330=$x;
      var $331=(($330)|0) >= 0;
      if ($331) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $332
      var $333=$ui_font;
      var $334=$chheight;
      var $335=$1;
      var $336=__ZNK15running_machine6renderEv($335);
      var $337=__ZN14render_manager9ui_aspectEv($336);
      var $338=$x;
      var $339=(($buffer+$338)|0);
      var $340=HEAP8[($339)];
      var $341=(($340 << 24) >> 24);
      var $342=__ZN11render_font10char_widthEffj($333, $334, $337, $341);
      var $343=$x0;
      var $344=$343-$342;
      $x0=$344;
      var $345=$2;
      var $346=$x0;
      var $347=$y0;
      var $348=$cellheight;
      var $349=$chheight;
      var $350=$348-$349;
      var $351=$350*0.5;
      var $352=$347+$351;
      var $353=$chheight;
      var $354=$1;
      var $355=__ZNK15running_machine6renderEv($354);
      var $356=__ZN14render_manager9ui_aspectEv($355);
      var $357=$ui_font;
      var $358=$x;
      var $359=(($buffer+$358)|0);
      var $360=HEAP8[($359)];
      var $361=(($360 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($345, $346, $352, $353, $356, -1, $357, $361);
      __label__ = 23; break;
    case 23: // $362
      var $363=$x;
      var $364=(($363-1)|0);
      $x=$364;
      __label__ = 21; break;
    case 24: // $365
      __label__ = 25; break;
    case 25: // $366
      __label__ = 26; break;
    case 26: // $367
      var $368=$skip;
      var $369=(($368+1)|0);
      var $370=$y;
      var $371=(($370+$369)|0);
      $y=$371;
      __label__ = 16; break;
    case 27: // $372
      $y=0;
      __label__ = 28; break;
    case 28: // $373
      var $374=$y;
      var $375=$3;
      var $376=(($375+12)|0);
      var $377=(($376+8)|0);
      var $378=HEAP32[(($377)>>2)];
      var $379=(($374)|0) < (($378)|0);
      if ($379) { __label__ = 29; break; } else { __label__ = 40; break; }
    case 29: // $380
      $x=0;
      __label__ = 30; break;
    case 30: // $381
      var $382=$x;
      var $383=$3;
      var $384=(($383+12)|0);
      var $385=(($384+8)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=(($382)|0) < (($386)|0);
      if ($387) { __label__ = 31; break; } else { __label__ = 38; break; }
    case 31: // $388
      var $389=$3;
      var $390=(($389+12)|0);
      var $391=(($390+4)|0);
      var $392=HEAP32[(($391)>>2)];
      var $393=$y;
      var $394=$3;
      var $395=(($394+12)|0);
      var $396=(($395+8)|0);
      var $397=HEAP32[(($396)>>2)];
      var $398=(($393*$397)|0);
      var $399=(($392+$398)|0);
      var $400=$x;
      var $401=(($399+$400)|0);
      $index=$401;
      var $402=$index;
      var $403=$total;
      var $404=(($402)|0) < (($403)|0);
      if ($404) { __label__ = 32; break; } else { __label__ = 36; break; }
    case 32: // $405
      var $406=$3;
      var $407=(($406+12)|0);
      var $408=(($407)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=(($409)|0)!=0;
      if ($410) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $411
      var $412=$1;
      var $413=(($412+572)|0);
      var $414=HEAP32[(($413)>>2)];
      var $415=$index;
      var $416=__Z28colortable_palette_get_colorP12colortable_tj($414, $415);
      var $423 = $416;__label__ = 35; break;
    case 34: // $417
      var $418=$index;
      var $419=$raw_color;
      var $420=(($419+($418<<2))|0);
      var $421=HEAP32[(($420)>>2)];
      var $423 = $421;__label__ = 35; break;
    case 35: // $422
      var $423;
      $pen=$423;
      var $424=$2;
      var $425=(($cellboxbounds)|0);
      var $426=HEAPF32[(($425)>>2)];
      var $427=$x;
      var $428=(($427)|0);
      var $429=$cellwidth;
      var $430=$428*$429;
      var $431=$426+$430;
      var $432=(($cellboxbounds+4)|0);
      var $433=HEAPF32[(($432)>>2)];
      var $434=$y;
      var $435=(($434)|0);
      var $436=$cellheight;
      var $437=$435*$436;
      var $438=$433+$437;
      var $439=(($cellboxbounds)|0);
      var $440=HEAPF32[(($439)>>2)];
      var $441=$x;
      var $442=(($441+1)|0);
      var $443=(($442)|0);
      var $444=$cellwidth;
      var $445=$443*$444;
      var $446=$440+$445;
      var $447=(($cellboxbounds+4)|0);
      var $448=HEAPF32[(($447)>>2)];
      var $449=$y;
      var $450=(($449+1)|0);
      var $451=(($450)|0);
      var $452=$cellheight;
      var $453=$451*$452;
      var $454=$448+$453;
      var $455=$pen;
      var $456=-16777216 | $455;
      __ZN16render_container8add_rectEffffjj($424, $431, $438, $446, $454, $456, 256);
      __label__ = 36; break;
    case 36: // $457
      __label__ = 37; break;
    case 37: // $458
      var $459=$x;
      var $460=(($459+1)|0);
      $x=$460;
      __label__ = 30; break;
    case 38: // $461
      __label__ = 39; break;
    case 39: // $462
      var $463=$y;
      var $464=(($463+1)|0);
      $y=$464;
      __label__ = 28; break;
    case 40: // $465
      var $466=$1;
      var $467=$3;
      __ZL19palette_handle_keysR15running_machineP13_ui_gfx_state($466, $467);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15palette_handlerR15running_machineP16render_containerP13_ui_gfx_state["X"]=1;

function __ZL14gfxset_handlerR15running_machineP16render_containerP13_ui_gfx_state($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 144; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ui_font;
      var $set;
      var $gfx;
      var $fullwidth;
      var $fullheight;
      var $cellwidth;
      var $cellheight;
      var $chwidth;
      var $chheight;
      var $titlewidth;
      var $x0;
      var $y0;
      var $cellboxbounds=__stackBase__;
      var $boxbounds=__stackBase__+16;
      var $cellboxwidth;
      var $cellboxheight;
      var $targwidth;
      var $targheight;
      var $cellxpix;
      var $cellypix;
      var $xcells;
      var $ycells;
      var $pixelscale;
      var $x;
      var $y;
      var $skip;
      var $title=__stackBase__+32;
      var $buffer=__stackBase__+132;
      $1=$machine;
      $2=$container;
      $3=$state;
      var $4=$1;
      var $5=__Z11ui_get_fontR15running_machine($4);
      $ui_font=$5;
      var $6=$3;
      var $7=(($6+24)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      $set=$9;
      var $10=$set;
      var $11=$1;
      var $12=(($11+432)|0);
      var $13=(($12+($10<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      $gfx=$14;
      var $15=$1;
      var $16=__ZNK15running_machine6renderEv($15);
      var $17=__ZNK14render_manager9ui_targetEv($16);
      var $18=__ZNK13render_target5widthEv($17);
      $targwidth=$18;
      var $19=$1;
      var $20=__ZNK15running_machine6renderEv($19);
      var $21=__ZNK14render_manager9ui_targetEv($20);
      var $22=__ZNK13render_target6heightEv($21);
      $targheight=$22;
      $pixelscale=0;
      var $23=$1;
      var $24=__Z18ui_get_line_heightR15running_machine($23);
      $chheight=$24;
      var $25=$ui_font;
      var $26=$chheight;
      var $27=$1;
      var $28=__ZNK15running_machine6renderEv($27);
      var $29=__ZN14render_manager9ui_aspectEv($28);
      var $30=__ZN11render_font10char_widthEffj($25, $26, $29, 48);
      $chwidth=$30;
      var $31=$chwidth;
      var $32=$31*0.5;
      var $33=$32;
      var $34=(($boxbounds)|0);
      HEAPF32[(($34)>>2)]=$33;
      var $35=$chwidth;
      var $36=$35*0.5;
      var $37=1-$36;
      var $38=(($boxbounds+8)|0);
      HEAPF32[(($38)>>2)]=$37;
      var $39=$chheight;
      var $40=$39*0.5;
      var $41=$40;
      var $42=(($boxbounds+4)|0);
      HEAPF32[(($42)>>2)]=$41;
      var $43=$chheight;
      var $44=$43*0.5;
      var $45=1-$44;
      var $46=(($boxbounds+12)|0);
      HEAPF32[(($46)>>2)]=$45;
      var $47=$cellboxbounds;
      var $48=$boxbounds;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[(($48)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[(($48+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[(($48+8)>>2)];HEAP32[(($47+12)>>2)]=HEAP32[(($48+12)>>2)];
      var $49=$chwidth;
      var $50=$49*0.5;
      var $51=(($cellboxbounds)|0);
      var $52=HEAPF32[(($51)>>2)];
      var $53=$52+$50;
      HEAPF32[(($51)>>2)]=$53;
      var $54=$chwidth;
      var $55=$54*0.5;
      var $56=(($cellboxbounds+8)|0);
      var $57=HEAPF32[(($56)>>2)];
      var $58=$57-$55;
      HEAPF32[(($56)>>2)]=$58;
      var $59=$chheight;
      var $60=$59*0.5;
      var $61=(($cellboxbounds+4)|0);
      var $62=HEAPF32[(($61)>>2)];
      var $63=$62+$60;
      HEAPF32[(($61)>>2)]=$63;
      var $64=$chheight;
      var $65=$64*0.5;
      var $66=(($cellboxbounds+12)|0);
      var $67=HEAPF32[(($66)>>2)];
      var $68=$67-$65;
      HEAPF32[(($66)>>2)]=$68;
      var $69=$chwidth;
      var $70=$69*5.5;
      var $71=(($cellboxbounds)|0);
      var $72=HEAPF32[(($71)>>2)];
      var $73=$72+$70;
      HEAPF32[(($71)>>2)]=$73;
      var $74=$chheight;
      var $75=$74*3;
      var $76=(($cellboxbounds+4)|0);
      var $77=HEAPF32[(($76)>>2)];
      var $78=$77+$75;
      HEAPF32[(($76)>>2)]=$78;
      var $79=(($cellboxbounds+8)|0);
      var $80=HEAPF32[(($79)>>2)];
      var $81=(($cellboxbounds)|0);
      var $82=HEAPF32[(($81)>>2)];
      var $83=$80-$82;
      var $84=$targwidth;
      var $85=(($84)|0);
      var $86=$83*$85;
      var $87=(($86)|0);
      $cellboxwidth=$87;
      var $88=(($cellboxbounds+12)|0);
      var $89=HEAPF32[(($88)>>2)];
      var $90=(($cellboxbounds+4)|0);
      var $91=HEAPF32[(($90)>>2)];
      var $92=$89-$91;
      var $93=$targheight;
      var $94=(($93)|0);
      var $95=$92*$94;
      var $96=(($95)|0);
      $cellboxheight=$96;
      var $97=$3;
      var $98=(($97+24)|0);
      var $99=(($98)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$3;
      var $102=(($101+24)|0);
      var $103=(($102+388)|0);
      var $104=(($103+$100)|0);
      var $105=HEAPU8[($104)];
      var $106=(($105)&255);
      var $107=$106 & 4;
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $109
      var $110=$gfx;
      var $111=(($110+2)|0);
      var $112=HEAP16[(($111)>>1)];
      var $118 = $112;__label__ = 3; break;
    case 2: // $113
      var $114=$gfx;
      var $115=(($114)|0);
      var $116=HEAP16[(($115)>>1)];
      var $118 = $116;__label__ = 3; break;
    case 3: // $117
      var $118;
      var $119=(($118)&65535);
      var $120=(($119+1)|0);
      $cellxpix=$120;
      var $121=$3;
      var $122=(($121+24)|0);
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$3;
      var $126=(($125+24)|0);
      var $127=(($126+388)|0);
      var $128=(($127+$124)|0);
      var $129=HEAPU8[($128)];
      var $130=(($129)&255);
      var $131=$130 & 4;
      var $132=(($131)|0)!=0;
      if ($132) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $133
      var $134=$gfx;
      var $135=(($134)|0);
      var $136=HEAP16[(($135)>>1)];
      var $142 = $136;__label__ = 6; break;
    case 5: // $137
      var $138=$gfx;
      var $139=(($138+2)|0);
      var $140=HEAP16[(($139)>>1)];
      var $142 = $140;__label__ = 6; break;
    case 6: // $141
      var $142;
      var $143=(($142)&65535);
      var $144=(($143+1)|0);
      $cellypix=$144;
      var $145=$set;
      var $146=$3;
      var $147=(($146+24)|0);
      var $148=(($147+260)|0);
      var $149=(($148+($145<<2))|0);
      var $150=HEAP32[(($149)>>2)];
      $xcells=$150;
      __label__ = 7; break;
    case 7: // $151
      var $152=$xcells;
      var $153=(($152)|0) > 1;
      if ($153) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $154
      var $155=$cellboxwidth;
      var $156=$xcells;
      var $157=(((($155)|0)/(($156)|0))|0);
      var $158=$cellxpix;
      var $159=(((($157)|0)/(($158)|0))|0);
      $pixelscale=$159;
      var $160=$pixelscale;
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $162
      __label__ = 11; break;
    case 10: // $163
      var $164=$xcells;
      var $165=(($164-1)|0);
      $xcells=$165;
      __label__ = 7; break;
    case 11: // $166
      var $167=$pixelscale;
      var $168=1 > (($167)|0);
      if ($168) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $169
      var $173 = 1;__label__ = 14; break;
    case 13: // $170
      var $171=$pixelscale;
      var $173 = $171;__label__ = 14; break;
    case 14: // $172
      var $173;
      $pixelscale=$173;
      var $174=$cellboxheight;
      var $175=$pixelscale;
      var $176=$cellypix;
      var $177=(($175*$176)|0);
      var $178=(((($174)|0)/(($177)|0))|0);
      $ycells=$178;
      var $179=$cellboxwidth;
      var $180=$xcells;
      var $181=$pixelscale;
      var $182=(($180*$181)|0);
      var $183=$cellxpix;
      var $184=(($182*$183)|0);
      var $185=(($179)|0) < (($184)|0);
      if ($185) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $186
      var $187=$cellboxwidth;
      var $195 = $187;__label__ = 17; break;
    case 16: // $188
      var $189=$xcells;
      var $190=$pixelscale;
      var $191=(($189*$190)|0);
      var $192=$cellxpix;
      var $193=(($191*$192)|0);
      var $195 = $193;__label__ = 17; break;
    case 17: // $194
      var $195;
      $cellboxwidth=$195;
      var $196=$cellboxheight;
      var $197=$ycells;
      var $198=$pixelscale;
      var $199=(($197*$198)|0);
      var $200=$cellypix;
      var $201=(($199*$200)|0);
      var $202=(($196)|0) < (($201)|0);
      if ($202) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $203
      var $204=$cellboxheight;
      var $212 = $204;__label__ = 20; break;
    case 19: // $205
      var $206=$ycells;
      var $207=$pixelscale;
      var $208=(($206*$207)|0);
      var $209=$cellypix;
      var $210=(($208*$209)|0);
      var $212 = $210;__label__ = 20; break;
    case 20: // $211
      var $212;
      $cellboxheight=$212;
      var $213=$cellboxwidth;
      var $214=(($213)|0);
      var $215=$xcells;
      var $216=(($215)|0);
      var $217=$214/$216;
      var $218=$targwidth;
      var $219=(($218)|0);
      var $220=$217/$219;
      $cellwidth=$220;
      var $221=$cellboxheight;
      var $222=(($221)|0);
      var $223=$ycells;
      var $224=(($223)|0);
      var $225=$222/$224;
      var $226=$targheight;
      var $227=(($226)|0);
      var $228=$225/$227;
      $cellheight=$228;
      var $229=$cellboxwidth;
      var $230=(($229)|0);
      var $231=$targwidth;
      var $232=(($231)|0);
      var $233=$230/$232;
      var $234=$chwidth;
      var $235=$234*6.5;
      var $236=$233+$235;
      $fullwidth=$236;
      var $237=$cellboxheight;
      var $238=(($237)|0);
      var $239=$targheight;
      var $240=(($239)|0);
      var $241=$238/$240;
      var $242=$chheight;
      var $243=$242*4;
      var $244=$241+$243;
      $fullheight=$244;
      var $245=$fullwidth;
      var $246=1-$245;
      var $247=$246*0.5;
      var $248=(($boxbounds)|0);
      HEAPF32[(($248)>>2)]=$247;
      var $249=(($boxbounds)|0);
      var $250=HEAPF32[(($249)>>2)];
      var $251=$fullwidth;
      var $252=$250+$251;
      var $253=(($boxbounds+8)|0);
      HEAPF32[(($253)>>2)]=$252;
      var $254=$fullheight;
      var $255=1-$254;
      var $256=$255*0.5;
      var $257=(($boxbounds+4)|0);
      HEAPF32[(($257)>>2)]=$256;
      var $258=(($boxbounds+4)|0);
      var $259=HEAPF32[(($258)>>2)];
      var $260=$fullheight;
      var $261=$259+$260;
      var $262=(($boxbounds+12)|0);
      HEAPF32[(($262)>>2)]=$261;
      $x=0;
      __label__ = 21; break;
    case 21: // $263
      var $264=$x;
      var $265=(($264)|0) < 32;
      if ($265) { __label__ = 22; break; } else { var $274 = 0;__label__ = 23; break; }
    case 22: // $266
      var $267=$x;
      var $268=$1;
      var $269=(($268+432)|0);
      var $270=(($269+($267<<2))|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=(($271)|0)!=0;
      var $274 = $272;__label__ = 23; break;
    case 23: // $273
      var $274;
      if ($274) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $275
      __label__ = 25; break;
    case 25: // $276
      var $277=$x;
      var $278=(($277+1)|0);
      $x=$278;
      __label__ = 21; break;
    case 26: // $279
      var $280=(($title)|0);
      var $281=$3;
      var $282=(($281+24)|0);
      var $283=(($282)|0);
      var $284=HEAP32[(($283)>>2)];
      var $285=$x;
      var $286=(($285-1)|0);
      var $287=$gfx;
      var $288=(($287)|0);
      var $289=HEAPU16[(($288)>>1)];
      var $290=(($289)&65535);
      var $291=$gfx;
      var $292=(($291+2)|0);
      var $293=HEAPU16[(($292)>>1)];
      var $294=(($293)&65535);
      var $295=$set;
      var $296=$3;
      var $297=(($296+24)|0);
      var $298=(($297+132)|0);
      var $299=(($298+($295<<2))|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=_sprintf($280, ((STRING_TABLE.__str65364)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$284,HEAP32[((tempInt+4)>>2)]=$286,HEAP32[((tempInt+8)>>2)]=$290,HEAP32[((tempInt+12)>>2)]=$294,HEAP32[((tempInt+16)>>2)]=$300,tempInt));
      var $302=$ui_font;
      var $303=$chheight;
      var $304=$1;
      var $305=__ZNK15running_machine6renderEv($304);
      var $306=__ZN14render_manager9ui_aspectEv($305);
      var $307=(($title)|0);
      var $308=__ZN11render_font12string_widthEffPKc($302, $303, $306, $307);
      $titlewidth=$308;
      $x0=0;
      var $309=(($boxbounds+8)|0);
      var $310=HEAPF32[(($309)>>2)];
      var $311=(($boxbounds)|0);
      var $312=HEAPF32[(($311)>>2)];
      var $313=$310-$312;
      var $314=$titlewidth;
      var $315=$chwidth;
      var $316=$314+$315;
      var $317=$313 < $316;
      if ($317) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $318
      var $319=(($boxbounds)|0);
      var $320=HEAPF32[(($319)>>2)];
      var $321=$titlewidth;
      var $322=$chwidth;
      var $323=$321+$322;
      var $324=$323*0.5;
      var $325=0.5-$324;
      var $326=$320-$325;
      $x0=$326;
      __label__ = 28; break;
    case 28: // $327
      var $328=$2;
      var $329=(($boxbounds)|0);
      var $330=HEAPF32[(($329)>>2)];
      var $331=$x0;
      var $332=$330-$331;
      var $333=(($boxbounds+4)|0);
      var $334=HEAPF32[(($333)>>2)];
      var $335=(($boxbounds+8)|0);
      var $336=HEAPF32[(($335)>>2)];
      var $337=$x0;
      var $338=$336+$337;
      var $339=(($boxbounds+12)|0);
      var $340=HEAPF32[(($339)>>2)];
      __Z20ui_draw_outlined_boxP16render_containerffffj($328, $332, $334, $338, $340, -284159952);
      var $341=$titlewidth;
      var $342=$341*0.5;
      var $343=0.5-$342;
      $x0=$343;
      var $344=(($boxbounds+4)|0);
      var $345=HEAPF32[(($344)>>2)];
      var $346=$chheight;
      var $347=$346*0.5;
      var $348=$345+$347;
      $y0=$348;
      $x=0;
      __label__ = 29; break;
    case 29: // $349
      var $350=$x;
      var $351=(($title+$350)|0);
      var $352=HEAP8[($351)];
      var $353=(($352 << 24) >> 24);
      var $354=(($353)|0)!=0;
      if ($354) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $355
      var $356=$2;
      var $357=$x0;
      var $358=$y0;
      var $359=$chheight;
      var $360=$1;
      var $361=__ZNK15running_machine6renderEv($360);
      var $362=__ZN14render_manager9ui_aspectEv($361);
      var $363=$ui_font;
      var $364=$x;
      var $365=(($title+$364)|0);
      var $366=HEAP8[($365)];
      var $367=(($366 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($356, $357, $358, $359, $362, -1, $363, $367);
      var $368=$ui_font;
      var $369=$chheight;
      var $370=$1;
      var $371=__ZNK15running_machine6renderEv($370);
      var $372=__ZN14render_manager9ui_aspectEv($371);
      var $373=$x;
      var $374=(($title+$373)|0);
      var $375=HEAP8[($374)];
      var $376=(($375 << 24) >> 24);
      var $377=__ZN11render_font10char_widthEffj($368, $369, $372, $376);
      var $378=$x0;
      var $379=$378+$377;
      $x0=$379;
      __label__ = 31; break;
    case 31: // $380
      var $381=$x;
      var $382=(($381+1)|0);
      $x=$382;
      __label__ = 29; break;
    case 32: // $383
      var $384=$chwidth;
      var $385=$cellwidth;
      var $386=$384/$385;
      var $387=(($386)|0);
      $skip=$387;
      $x=0;
      __label__ = 33; break;
    case 33: // $388
      var $389=$x;
      var $390=$xcells;
      var $391=(($389)|0) < (($390)|0);
      if ($391) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $392
      var $393=(($boxbounds)|0);
      var $394=HEAPF32[(($393)>>2)];
      var $395=$chwidth;
      var $396=$395*6;
      var $397=$394+$396;
      var $398=$x;
      var $399=(($398)|0);
      var $400=$cellwidth;
      var $401=$399*$400;
      var $402=$397+$401;
      $x0=$402;
      var $403=(($boxbounds+4)|0);
      var $404=HEAPF32[(($403)>>2)];
      var $405=$chheight;
      var $406=$405*2;
      var $407=$404+$406;
      $y0=$407;
      var $408=$2;
      var $409=$x0;
      var $410=$cellwidth;
      var $411=$chwidth;
      var $412=$410-$411;
      var $413=$412*0.5;
      var $414=$409+$413;
      var $415=$y0;
      var $416=$chheight;
      var $417=$1;
      var $418=__ZNK15running_machine6renderEv($417);
      var $419=__ZN14render_manager9ui_aspectEv($418);
      var $420=$ui_font;
      var $421=$x;
      var $422=$421 & 15;
      var $423=((STRING_TABLE.__str75365+$422)|0);
      var $424=HEAP8[($423)];
      var $425=(($424 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($408, $414, $415, $416, $419, -1, $420, $425);
      var $426=$skip;
      var $427=(($426)|0)!=0;
      if ($427) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $428
      var $429=$2;
      var $430=$x0;
      var $431=$cellwidth;
      var $432=$431*0.5;
      var $433=$430+$432;
      var $434=$y0;
      var $435=$chheight;
      var $436=$434+$435;
      var $437=(($boxbounds+4)|0);
      var $438=HEAPF32[(($437)>>2)];
      var $439=$436+$438;
      var $440=$chheight;
      var $441=$440*3.5;
      var $442=$439+$441;
      var $443=$442*0.5;
      __ZN16render_container9add_pointEfffjj($429, $433, $443, 0.0020000000949949026, -1, 256);
      __label__ = 36; break;
    case 36: // $444
      __label__ = 37; break;
    case 37: // $445
      var $446=$skip;
      var $447=(($446+1)|0);
      var $448=$x;
      var $449=(($448+$447)|0);
      $x=$449;
      __label__ = 33; break;
    case 38: // $450
      var $451=$chheight;
      var $452=$cellheight;
      var $453=$451/$452;
      var $454=(($453)|0);
      $skip=$454;
      $y=0;
      __label__ = 39; break;
    case 39: // $455
      var $456=$y;
      var $457=$ycells;
      var $458=(($456)|0) < (($457)|0);
      if ($458) { __label__ = 40; break; } else { __label__ = 50; break; }
    case 40: // $459
      var $460=$set;
      var $461=$3;
      var $462=(($461+24)|0);
      var $463=(($462+4)|0);
      var $464=(($463+($460<<2))|0);
      var $465=HEAP32[(($464)>>2)];
      var $466=$y;
      var $467=$xcells;
      var $468=(($466*$467)|0);
      var $469=(($465+$468)|0);
      var $470=$gfx;
      var $471=(($470+16)|0);
      var $472=HEAPU32[(($471)>>2)];
      var $473=(($469)>>>0) < (($472)>>>0);
      if ($473) { __label__ = 41; break; } else { __label__ = 48; break; }
    case 41: // $474
      var $475=(($boxbounds)|0);
      var $476=HEAPF32[(($475)>>2)];
      var $477=$chwidth;
      var $478=$477*5.5;
      var $479=$476+$478;
      $x0=$479;
      var $480=(($boxbounds+4)|0);
      var $481=HEAPF32[(($480)>>2)];
      var $482=$chheight;
      var $483=$482*3.5;
      var $484=$481+$483;
      var $485=$y;
      var $486=(($485)|0);
      var $487=$cellheight;
      var $488=$486*$487;
      var $489=$484+$488;
      $y0=$489;
      var $490=$skip;
      var $491=(($490)|0)!=0;
      if ($491) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $492
      var $493=$2;
      var $494=$x0;
      var $495=(($boxbounds)|0);
      var $496=HEAPF32[(($495)>>2)];
      var $497=$494+$496;
      var $498=$chwidth;
      var $499=$498*6;
      var $500=$497+$499;
      var $501=$500*0.5;
      var $502=$y0;
      var $503=$cellheight;
      var $504=$503*0.5;
      var $505=$502+$504;
      __ZN16render_container9add_pointEfffjj($493, $501, $505, 0.0020000000949949026, -1, 256);
      __label__ = 43; break;
    case 43: // $506
      var $507=(($buffer)|0);
      var $508=$set;
      var $509=$3;
      var $510=(($509+24)|0);
      var $511=(($510+4)|0);
      var $512=(($511+($508<<2))|0);
      var $513=HEAP32[(($512)>>2)];
      var $514=$y;
      var $515=$xcells;
      var $516=(($514*$515)|0);
      var $517=(($513+$516)|0);
      var $518=_sprintf($507, ((STRING_TABLE.__str85366)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$517,tempInt));
      $x=4;
      __label__ = 44; break;
    case 44: // $519
      var $520=$x;
      var $521=(($520)|0) >= 0;
      if ($521) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $522
      var $523=$ui_font;
      var $524=$chheight;
      var $525=$1;
      var $526=__ZNK15running_machine6renderEv($525);
      var $527=__ZN14render_manager9ui_aspectEv($526);
      var $528=$x;
      var $529=(($buffer+$528)|0);
      var $530=HEAP8[($529)];
      var $531=(($530 << 24) >> 24);
      var $532=__ZN11render_font10char_widthEffj($523, $524, $527, $531);
      var $533=$x0;
      var $534=$533-$532;
      $x0=$534;
      var $535=$2;
      var $536=$x0;
      var $537=$y0;
      var $538=$cellheight;
      var $539=$chheight;
      var $540=$538-$539;
      var $541=$540*0.5;
      var $542=$537+$541;
      var $543=$chheight;
      var $544=$1;
      var $545=__ZNK15running_machine6renderEv($544);
      var $546=__ZN14render_manager9ui_aspectEv($545);
      var $547=$ui_font;
      var $548=$x;
      var $549=(($buffer+$548)|0);
      var $550=HEAP8[($549)];
      var $551=(($550 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($535, $536, $542, $543, $546, -1, $547, $551);
      __label__ = 46; break;
    case 46: // $552
      var $553=$x;
      var $554=(($553-1)|0);
      $x=$554;
      __label__ = 44; break;
    case 47: // $555
      __label__ = 48; break;
    case 48: // $556
      __label__ = 49; break;
    case 49: // $557
      var $558=$skip;
      var $559=(($558+1)|0);
      var $560=$y;
      var $561=(($560+$559)|0);
      $y=$561;
      __label__ = 39; break;
    case 50: // $562
      var $563=$1;
      var $564=$3;
      var $565=$xcells;
      var $566=$ycells;
      var $567=$gfx;
      __ZL20gfxset_update_bitmapR15running_machineP13_ui_gfx_stateiiP11gfx_element($563, $564, $565, $566, $567);
      var $568=$2;
      var $569=(($boxbounds)|0);
      var $570=HEAPF32[(($569)>>2)];
      var $571=$chwidth;
      var $572=$571*6;
      var $573=$570+$572;
      var $574=(($boxbounds+4)|0);
      var $575=HEAPF32[(($574)>>2)];
      var $576=$chheight;
      var $577=$576*3.5;
      var $578=$575+$577;
      var $579=(($boxbounds)|0);
      var $580=HEAPF32[(($579)>>2)];
      var $581=$chwidth;
      var $582=$581*6;
      var $583=$580+$582;
      var $584=$cellboxwidth;
      var $585=(($584)|0);
      var $586=$targwidth;
      var $587=(($586)|0);
      var $588=$585/$587;
      var $589=$583+$588;
      var $590=(($boxbounds+4)|0);
      var $591=HEAPF32[(($590)>>2)];
      var $592=$chheight;
      var $593=$592*3.5;
      var $594=$591+$593;
      var $595=$cellboxheight;
      var $596=(($595)|0);
      var $597=$targheight;
      var $598=(($597)|0);
      var $599=$596/$598;
      var $600=$594+$599;
      var $601=$3;
      var $602=(($601+8)|0);
      var $603=HEAP32[(($602)>>2)];
      __ZN16render_container8add_quadEffffjP14render_texturej($568, $573, $578, $589, $600, -1, $603, 256);
      var $604=$1;
      var $605=$3;
      var $606=$xcells;
      var $607=$ycells;
      __ZL18gfxset_handle_keysR15running_machineP13_ui_gfx_stateii($604, $605, $606, $607);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14gfxset_handlerR15running_machineP16render_containerP13_ui_gfx_state["X"]=1;

function __ZL15tilemap_handlerR15running_machineP16render_containerP13_ui_gfx_state($machine, $container, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 140; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ui_font;
      var $chwidth;
      var $chheight;
      var $mapboxbounds=__stackBase__;
      var $boxbounds=__stackBase__+16;
      var $targwidth;
      var $targheight;
      var $titlewidth;
      var $x0;
      var $y0;
      var $mapboxwidth;
      var $mapboxheight;
      var $maxxscale;
      var $maxyscale;
      var $mapwidth=__stackBase__+32;
      var $mapheight=__stackBase__+36;
      var $x;
      var $pixelscale;
      var $title=__stackBase__+40;
      var $temp;
      $1=$machine;
      $2=$container;
      $3=$state;
      var $4=$1;
      var $5=__Z11ui_get_fontR15running_machine($4);
      $ui_font=$5;
      var $6=$1;
      var $7=__ZNK15running_machine6renderEv($6);
      var $8=__ZNK14render_manager9ui_targetEv($7);
      var $9=__ZNK13render_target5widthEv($8);
      $targwidth=$9;
      var $10=$1;
      var $11=__ZNK15running_machine6renderEv($10);
      var $12=__ZNK14render_manager9ui_targetEv($11);
      var $13=__ZNK13render_target6heightEv($12);
      $targheight=$13;
      var $14=$1;
      var $15=$3;
      var $16=(($15+444)|0);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z21tilemap_size_by_indexR15running_machineiPjS1_($14, $18, $mapwidth, $mapheight);
      var $19=$3;
      var $20=(($19+444)|0);
      var $21=(($20+16)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 & 4;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $26
      var $27=HEAP32[(($mapwidth)>>2)];
      $temp=$27;
      var $28=HEAP32[(($mapheight)>>2)];
      HEAP32[(($mapwidth)>>2)]=$28;
      var $29=$temp;
      HEAP32[(($mapheight)>>2)]=$29;
      __label__ = 2; break;
    case 2: // $30
      var $31=$1;
      var $32=__Z18ui_get_line_heightR15running_machine($31);
      $chheight=$32;
      var $33=$ui_font;
      var $34=$chheight;
      var $35=$1;
      var $36=__ZNK15running_machine6renderEv($35);
      var $37=__ZN14render_manager9ui_aspectEv($36);
      var $38=__ZN11render_font10char_widthEffj($33, $34, $37, 48);
      $chwidth=$38;
      var $39=$chwidth;
      var $40=$39*0.5;
      var $41=$40;
      var $42=(($boxbounds)|0);
      HEAPF32[(($42)>>2)]=$41;
      var $43=$chwidth;
      var $44=$43*0.5;
      var $45=1-$44;
      var $46=(($boxbounds+8)|0);
      HEAPF32[(($46)>>2)]=$45;
      var $47=$chheight;
      var $48=$47*0.5;
      var $49=$48;
      var $50=(($boxbounds+4)|0);
      HEAPF32[(($50)>>2)]=$49;
      var $51=$chheight;
      var $52=$51*0.5;
      var $53=1-$52;
      var $54=(($boxbounds+12)|0);
      HEAPF32[(($54)>>2)]=$53;
      var $55=$mapboxbounds;
      var $56=$boxbounds;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($55)>>2)]=HEAP32[(($56)>>2)];HEAP32[(($55+4)>>2)]=HEAP32[(($56+4)>>2)];HEAP32[(($55+8)>>2)]=HEAP32[(($56+8)>>2)];HEAP32[(($55+12)>>2)]=HEAP32[(($56+12)>>2)];
      var $57=$chwidth;
      var $58=$57*0.5;
      var $59=(($mapboxbounds)|0);
      var $60=HEAPF32[(($59)>>2)];
      var $61=$60+$58;
      HEAPF32[(($59)>>2)]=$61;
      var $62=$chwidth;
      var $63=$62*0.5;
      var $64=(($mapboxbounds+8)|0);
      var $65=HEAPF32[(($64)>>2)];
      var $66=$65-$63;
      HEAPF32[(($64)>>2)]=$66;
      var $67=$chheight;
      var $68=$67*0.5;
      var $69=(($mapboxbounds+4)|0);
      var $70=HEAPF32[(($69)>>2)];
      var $71=$70+$68;
      HEAPF32[(($69)>>2)]=$71;
      var $72=$chheight;
      var $73=$72*0.5;
      var $74=(($mapboxbounds+12)|0);
      var $75=HEAPF32[(($74)>>2)];
      var $76=$75-$73;
      HEAPF32[(($74)>>2)]=$76;
      var $77=$chheight;
      var $78=$77*1.5;
      var $79=(($mapboxbounds+4)|0);
      var $80=HEAPF32[(($79)>>2)];
      var $81=$80+$78;
      HEAPF32[(($79)>>2)]=$81;
      var $82=(($mapboxbounds+8)|0);
      var $83=HEAPF32[(($82)>>2)];
      var $84=(($mapboxbounds)|0);
      var $85=HEAPF32[(($84)>>2)];
      var $86=$83-$85;
      var $87=$targwidth;
      var $88=(($87)|0);
      var $89=$86*$88;
      var $90=(($89)|0);
      $mapboxwidth=$90;
      var $91=(($mapboxbounds+12)|0);
      var $92=HEAPF32[(($91)>>2)];
      var $93=(($mapboxbounds+4)|0);
      var $94=HEAPF32[(($93)>>2)];
      var $95=$92-$94;
      var $96=$targheight;
      var $97=(($96)|0);
      var $98=$95*$97;
      var $99=(($98)|0);
      $mapboxheight=$99;
      var $100=$3;
      var $101=(($100+444)|0);
      var $102=(($101+12)|0);
      var $103=HEAP32[(($102)>>2)];
      $pixelscale=$103;
      var $104=$pixelscale;
      var $105=(($104)|0)==0;
      if ($105) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $106
      $maxxscale=1;
      __label__ = 4; break;
    case 4: // $107
      var $108=HEAP32[(($mapwidth)>>2)];
      var $109=$maxxscale;
      var $110=(($109+1)|0);
      var $111=(($108*$110)|0);
      var $112=$mapboxwidth;
      var $113=(($111)>>>0) < (($112)>>>0);
      if ($113) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $114
      __label__ = 6; break;
    case 6: // $115
      var $116=$maxxscale;
      var $117=(($116+1)|0);
      $maxxscale=$117;
      __label__ = 4; break;
    case 7: // $118
      $maxyscale=1;
      __label__ = 8; break;
    case 8: // $119
      var $120=HEAP32[(($mapheight)>>2)];
      var $121=$maxyscale;
      var $122=(($121+1)|0);
      var $123=(($120*$122)|0);
      var $124=$mapboxheight;
      var $125=(($123)>>>0) < (($124)>>>0);
      if ($125) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $126
      __label__ = 10; break;
    case 10: // $127
      var $128=$maxyscale;
      var $129=(($128+1)|0);
      $maxyscale=$129;
      __label__ = 8; break;
    case 11: // $130
      var $131=$maxxscale;
      var $132=$maxyscale;
      var $133=(($131)|0) < (($132)|0);
      var $134=$maxxscale;
      var $135=$maxyscale;
      var $136=$133 ? $134 : $135;
      $pixelscale=$136;
      __label__ = 12; break;
    case 12: // $137
      var $138=$mapboxwidth;
      var $139=HEAP32[(($mapwidth)>>2)];
      var $140=$pixelscale;
      var $141=(($139*$140)|0);
      var $142=(($138)>>>0) < (($141)>>>0);
      if ($142) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $143
      var $144=$mapboxwidth;
      var $150 = $144;__label__ = 15; break;
    case 14: // $145
      var $146=HEAP32[(($mapwidth)>>2)];
      var $147=$pixelscale;
      var $148=(($146*$147)|0);
      var $150 = $148;__label__ = 15; break;
    case 15: // $149
      var $150;
      $mapboxwidth=$150;
      var $151=$mapboxheight;
      var $152=HEAP32[(($mapheight)>>2)];
      var $153=$pixelscale;
      var $154=(($152*$153)|0);
      var $155=(($151)>>>0) < (($154)>>>0);
      if ($155) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $156
      var $157=$mapboxheight;
      var $163 = $157;__label__ = 18; break;
    case 17: // $158
      var $159=HEAP32[(($mapheight)>>2)];
      var $160=$pixelscale;
      var $161=(($159*$160)|0);
      var $163 = $161;__label__ = 18; break;
    case 18: // $162
      var $163;
      $mapboxheight=$163;
      var $164=(($mapboxbounds+8)|0);
      var $165=HEAPF32[(($164)>>2)];
      var $166=(($mapboxbounds)|0);
      var $167=HEAPF32[(($166)>>2)];
      var $168=$165-$167;
      var $169=$mapboxwidth;
      var $170=(($169)|0);
      var $171=$targwidth;
      var $172=(($171)|0);
      var $173=$170/$172;
      var $174=$168-$173;
      var $175=$174*0.5;
      var $176=(($mapboxbounds)|0);
      var $177=HEAPF32[(($176)>>2)];
      var $178=$177+$175;
      HEAPF32[(($176)>>2)]=$178;
      var $179=(($mapboxbounds)|0);
      var $180=HEAPF32[(($179)>>2)];
      var $181=$mapboxwidth;
      var $182=(($181)|0);
      var $183=$targwidth;
      var $184=(($183)|0);
      var $185=$182/$184;
      var $186=$180+$185;
      var $187=(($mapboxbounds+8)|0);
      HEAPF32[(($187)>>2)]=$186;
      var $188=(($mapboxbounds+12)|0);
      var $189=HEAPF32[(($188)>>2)];
      var $190=(($mapboxbounds+4)|0);
      var $191=HEAPF32[(($190)>>2)];
      var $192=$189-$191;
      var $193=$mapboxheight;
      var $194=(($193)|0);
      var $195=$targheight;
      var $196=(($195)|0);
      var $197=$194/$196;
      var $198=$192-$197;
      var $199=$198*0.5;
      var $200=(($mapboxbounds+4)|0);
      var $201=HEAPF32[(($200)>>2)];
      var $202=$201+$199;
      HEAPF32[(($200)>>2)]=$202;
      var $203=(($mapboxbounds+4)|0);
      var $204=HEAPF32[(($203)>>2)];
      var $205=$mapboxheight;
      var $206=(($205)|0);
      var $207=$targheight;
      var $208=(($207)|0);
      var $209=$206/$208;
      var $210=$204+$209;
      var $211=(($mapboxbounds+12)|0);
      HEAPF32[(($211)>>2)]=$210;
      var $212=(($mapboxbounds)|0);
      var $213=HEAPF32[(($212)>>2)];
      var $214=$chwidth;
      var $215=$214*0.5;
      var $216=$213-$215;
      var $217=(($boxbounds)|0);
      HEAPF32[(($217)>>2)]=$216;
      var $218=(($mapboxbounds+8)|0);
      var $219=HEAPF32[(($218)>>2)];
      var $220=$chwidth;
      var $221=$220*0.5;
      var $222=$219+$221;
      var $223=(($boxbounds+8)|0);
      HEAPF32[(($223)>>2)]=$222;
      var $224=(($mapboxbounds+4)|0);
      var $225=HEAPF32[(($224)>>2)];
      var $226=$chheight;
      var $227=$226*2;
      var $228=$225-$227;
      var $229=(($boxbounds+4)|0);
      HEAPF32[(($229)>>2)]=$228;
      var $230=(($mapboxbounds+12)|0);
      var $231=HEAPF32[(($230)>>2)];
      var $232=$chheight;
      var $233=$232*0.5;
      var $234=$231+$233;
      var $235=(($boxbounds+12)|0);
      HEAPF32[(($235)>>2)]=$234;
      var $236=(($title)|0);
      var $237=$3;
      var $238=(($237+444)|0);
      var $239=(($238)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$1;
      var $242=__Z13tilemap_countR15running_machine($241);
      var $243=(($242-1)|0);
      var $244=HEAP32[(($mapwidth)>>2)];
      var $245=HEAP32[(($mapheight)>>2)];
      var $246=$3;
      var $247=(($246+444)|0);
      var $248=(($247+4)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=$3;
      var $251=(($250+444)|0);
      var $252=(($251+8)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=_sprintf($236, ((STRING_TABLE.__str15359)|0), (tempInt=STACKTOP,STACKTOP += 24,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$240,HEAP32[((tempInt+4)>>2)]=$243,HEAP32[((tempInt+8)>>2)]=$244,HEAP32[((tempInt+12)>>2)]=$245,HEAP32[((tempInt+16)>>2)]=$249,HEAP32[((tempInt+20)>>2)]=$253,tempInt));
      var $255=$ui_font;
      var $256=$chheight;
      var $257=$1;
      var $258=__ZNK15running_machine6renderEv($257);
      var $259=__ZN14render_manager9ui_aspectEv($258);
      var $260=(($title)|0);
      var $261=__ZN11render_font12string_widthEffPKc($255, $256, $259, $260);
      $titlewidth=$261;
      var $262=(($boxbounds+8)|0);
      var $263=HEAPF32[(($262)>>2)];
      var $264=(($boxbounds)|0);
      var $265=HEAPF32[(($264)>>2)];
      var $266=$263-$265;
      var $267=$titlewidth;
      var $268=$chwidth;
      var $269=$267+$268;
      var $270=$266 < $269;
      if ($270) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $271
      var $272=$titlewidth;
      var $273=$chwidth;
      var $274=$272+$273;
      var $275=$274*0.5;
      var $276=0.5-$275;
      var $277=(($boxbounds)|0);
      HEAPF32[(($277)>>2)]=$276;
      var $278=(($boxbounds)|0);
      var $279=HEAPF32[(($278)>>2)];
      var $280=$titlewidth;
      var $281=$279+$280;
      var $282=$chwidth;
      var $283=$281+$282;
      var $284=(($boxbounds+8)|0);
      HEAPF32[(($284)>>2)]=$283;
      __label__ = 20; break;
    case 20: // $285
      var $286=$2;
      var $287=(($boxbounds)|0);
      var $288=HEAPF32[(($287)>>2)];
      var $289=(($boxbounds+4)|0);
      var $290=HEAPF32[(($289)>>2)];
      var $291=(($boxbounds+8)|0);
      var $292=HEAPF32[(($291)>>2)];
      var $293=(($boxbounds+12)|0);
      var $294=HEAPF32[(($293)>>2)];
      __Z20ui_draw_outlined_boxP16render_containerffffj($286, $288, $290, $292, $294, -284159952);
      var $295=$titlewidth;
      var $296=$295*0.5;
      var $297=0.5-$296;
      $x0=$297;
      var $298=(($boxbounds+4)|0);
      var $299=HEAPF32[(($298)>>2)];
      var $300=$chheight;
      var $301=$300*0.5;
      var $302=$299+$301;
      $y0=$302;
      $x=0;
      __label__ = 21; break;
    case 21: // $303
      var $304=$x;
      var $305=(($title+$304)|0);
      var $306=HEAP8[($305)];
      var $307=(($306 << 24) >> 24);
      var $308=(($307)|0)!=0;
      if ($308) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $309
      var $310=$2;
      var $311=$x0;
      var $312=$y0;
      var $313=$chheight;
      var $314=$1;
      var $315=__ZNK15running_machine6renderEv($314);
      var $316=__ZN14render_manager9ui_aspectEv($315);
      var $317=$ui_font;
      var $318=$x;
      var $319=(($title+$318)|0);
      var $320=HEAP8[($319)];
      var $321=(($320 << 24) >> 24);
      __ZN16render_container8add_charEffffjR11render_fontt($310, $311, $312, $313, $316, -1, $317, $321);
      var $322=$ui_font;
      var $323=$chheight;
      var $324=$1;
      var $325=__ZNK15running_machine6renderEv($324);
      var $326=__ZN14render_manager9ui_aspectEv($325);
      var $327=$x;
      var $328=(($title+$327)|0);
      var $329=HEAP8[($328)];
      var $330=(($329 << 24) >> 24);
      var $331=__ZN11render_font10char_widthEffj($322, $323, $326, $330);
      var $332=$x0;
      var $333=$332+$331;
      $x0=$333;
      __label__ = 23; break;
    case 23: // $334
      var $335=$x;
      var $336=(($335+1)|0);
      $x=$336;
      __label__ = 21; break;
    case 24: // $337
      var $338=$1;
      var $339=$3;
      var $340=$mapboxwidth;
      var $341=$pixelscale;
      var $342=(((($340)|0)/(($341)|0))|0);
      var $343=$mapboxheight;
      var $344=$pixelscale;
      var $345=(((($343)|0)/(($344)|0))|0);
      __ZL21tilemap_update_bitmapR15running_machineP13_ui_gfx_stateii($338, $339, $342, $345);
      var $346=$2;
      var $347=(($mapboxbounds)|0);
      var $348=HEAPF32[(($347)>>2)];
      var $349=(($mapboxbounds+4)|0);
      var $350=HEAPF32[(($349)>>2)];
      var $351=(($mapboxbounds+8)|0);
      var $352=HEAPF32[(($351)>>2)];
      var $353=(($mapboxbounds+12)|0);
      var $354=HEAPF32[(($353)>>2)];
      var $355=$3;
      var $356=(($355+8)|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=$3;
      var $359=(($358+444)|0);
      var $360=(($359+16)|0);
      var $361=HEAPU8[($360)];
      var $362=(($361)&255);
      var $363=$362 << 0;
      var $364=256 | $363;
      __ZN16render_container8add_quadEffffjP14render_texturej($346, $348, $350, $352, $354, -1, $357, $364);
      var $365=$1;
      var $366=$3;
      var $367=$mapboxwidth;
      var $368=$mapboxheight;
      __ZL19tilemap_handle_keysR15running_machineP13_ui_gfx_stateii($365, $366, $367, $368);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15tilemap_handlerR15running_machineP16render_containerP13_ui_gfx_state["X"]=1;

function __ZL21tilemap_update_bitmapR15running_machineP13_ui_gfx_stateii($machine, $state, $width, $height) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $screen_format;
      var $palette;
      var $screen_texformat;
      var $temp;
      var $13;
      var $14;
      $9=$machine;
      $10=$state;
      $11=$width;
      $12=$height;
      var $15=$9;
      var $16=(($15+560)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__ZNK13screen_device6formatEv($17);
      $screen_format=$18;
      $palette=0;
      var $19=$screen_format;
      if ($19 == 2) {
        __label__ = 1; break;
      }
      else if ($19 == 5) {
        __label__ = 2; break;
      }
      else if ($19 == 6) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $20
      $screen_texformat=1;
      var $21=$9;
      var $22=(($21+564)|0);
      var $23=HEAP32[(($22)>>2)];
      $palette=$23;
      __label__ = 5; break;
    case 2: // $24
      $screen_texformat=3;
      $palette=0;
      __label__ = 5; break;
    case 3: // $25
      $screen_texformat=4;
      $palette=0;
      __label__ = 5; break;
    case 4: // $26
      __Z10fatalerrorPKcz(((STRING_TABLE.__str45362)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 5: // $27
      var $28=$10;
      var $29=(($28+444)|0);
      var $30=(($29+16)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=$32 & 4;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=$11;
      $temp=$36;
      var $37=$12;
      $11=$37;
      var $38=$temp;
      $12=$38;
      __label__ = 7; break;
    case 7: // $39
      var $40=$10;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==0;
      if ($43) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $44
      var $45=$10;
      var $46=(($45+8)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $49
      var $50=$10;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$52;
      var $54=(($53+20)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$screen_format;
      var $57=(($55)|0)!=(($56)|0);
      if ($57) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $58
      var $59=$10;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=(($62+12)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$11;
      var $66=(($64)|0)!=(($65)|0);
      if ($66) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $67
      var $68=$10;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$70;
      var $72=(($71+16)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$12;
      var $75=(($73)|0)!=(($74)|0);
      if ($75) { __label__ = 12; break; } else { __label__ = 26; break; }
    case 12: // $76
      var $77=$9;
      var $78=__ZNK15running_machine6renderEv($77);
      var $79=$10;
      var $80=(($79+8)|0);
      var $81=HEAP32[(($80)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($78, $81);
      var $82=$10;
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$84;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $85);
      var $86=$4;
      var $87=$5;
      var $88=$6;
      var $89=$result_i;
      var $90=$7;
      var $91=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str55363)|0);
      HEAP32[(($6)>>2)]=1059;
      var $92=HEAP32[(($4)>>2)];
      var $93=HEAP32[(($5)>>2)];
      var $94=HEAP32[(($6)>>2)];
      var $95=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($92, $93, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $96
      HEAP32[(($result_i)>>2)]=$95;
      var $97=HEAP32[(($result_i)>>2)];
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $99
      var $100=___cxa_allocate_exception(4);
      var $101=$100;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($101);
      (function() { try { __THREW__ = false; return ___cxa_throw($100, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 15: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      HEAP32[(($7)>>2)]=$104;
      var $105=$103.f1;
      HEAP32[(($8)>>2)]=$105;
      var $106=HEAP32[(($8)>>2)];
      var $107=(($106)|0) < 0;
      if ($107) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $108
      var $109=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($109);
      throw "Reached an unreachable!"
    case 17: // $110
      var $111=HEAP32[(($7)>>2)];
      var $112=HEAP32[(($7)>>2)];
      var $113=HEAP32[(($8)>>2)];
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $116
      throw "Reached an unreachable!"
    case 19: // $_ZnwjPKci_exit
      var $117=HEAP32[(($result_i)>>2)];
      var $118=$4;
      var $119=$5;
      var $120=$6;
      var $121=$result_i;
      var $122=$7;
      var $123=$8;
      var $124=$117;
      var $125=$11;
      var $126=$12;
      var $127=$screen_format;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($124, $125, $126, $127, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $128
      var $129=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $124);
      var $130=$10;
      var $131=(($130+4)|0);
      HEAP32[(($131)>>2)]=$129;
      var $132=$9;
      var $133=__ZNK15running_machine6renderEv($132);
      var $134=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($133, 0, 0);
      var $135=$10;
      var $136=(($135+8)|0);
      HEAP32[(($136)>>2)]=$134;
      var $137=$10;
      var $138=(($137+8)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=$10;
      var $141=(($140+4)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$screen_texformat;
      var $144=$palette;
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($139, $142, 0, $143, $144);
      var $145=$10;
      var $146=(($145+1)|0);
      HEAP8[($146)]=1;
      __label__ = 26; break;
    case 21: // $147
      var $148=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $149=$148.f0;
      $13=$149;
      var $150=$148.f1;
      $14=$150;
      var $151=$1;
      var $152=$2;
      var $153=$3;
      HEAP32[(($1)>>2)]=$117;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str55363)|0);
      HEAP32[(($3)>>2)]=1059;
      var $154=HEAP32[(($1)>>2)];
      var $155=(($154)|0)!=0;
      if ($155) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $156
      var $157=HEAP32[(($1)>>2)];
      var $158=HEAP32[(($2)>>2)];
      var $159=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($157, $158, $159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $_noexc
      __label__ = 24; break;
    case 24: // $_ZdlPvPKci_exit
      var $160=$1;
      var $161=$2;
      var $162=$3;
      __label__ = 25; break;
    case 25: // $163
      __label__ = 29; break;
    case 26: // $164
      var $165=$10;
      var $166=(($165+1)|0);
      var $167=HEAP8[($166)];
      var $168=(($167 << 24) >> 24)!=0;
      if ($168) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $169
      var $170=$9;
      var $171=$10;
      var $172=(($171+4)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=$10;
      var $175=(($174+444)|0);
      var $176=(($175)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$10;
      var $179=(($178+444)|0);
      var $180=(($179+4)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=$10;
      var $183=(($182+444)|0);
      var $184=(($183+8)|0);
      var $185=HEAP32[(($184)>>2)];
      __Z21tilemap_draw_by_indexR15running_machineP8bitmap_tijj($170, $173, $177, $181, $185);
      var $186=$10;
      var $187=(($186+8)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$10;
      var $190=(($189+4)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$screen_texformat;
      var $193=$palette;
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($188, $191, 0, $192, $193);
      var $194=$10;
      var $195=(($194+1)|0);
      HEAP8[($195)]=0;
      __label__ = 28; break;
    case 28: // $196
      STACKTOP = __stackBase__;
      return;
    case 29: // $197
      var $198=$13;
      var $199=$13;
      var $200=$14;
      var $201=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $199, tempValue);
      var $202=($201.f1 = $200, $201);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $203
      var $204=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21tilemap_update_bitmapR15running_machineP13_ui_gfx_stateii["X"]=1;

function __ZL22orientation_swap_flipsi5374($orientation) {
  ;
  var __label__;

  var $1;
  $1=$orientation;
  var $2=$1;
  var $3=$2 & 4;
  var $4=$1;
  var $5=$4 & 1;
  var $6=(($5)|0)!=0;
  var $7=$6 ? 2 : 0;
  var $8=$3 | $7;
  var $9=$1;
  var $10=$9 & 2;
  var $11=(($10)|0)!=0;
  var $12=$11 ? 1 : 0;
  var $13=$8 | $12;
  ;
  return $13;
}


function __ZL19tilemap_handle_keysR15running_machineP13_ui_gfx_stateii($machine, $state, $viswidth, $visheight) {
  var __stackBase__  = STACKTOP; STACKTOP += 480; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $oldstate=__stackBase__;
      var $mapwidth=__stackBase__+464;
      var $mapheight=__stackBase__+468;
      var $step;
      var $5=__stackBase__+472;
      var $6=__stackBase__+476;
      $1=$machine;
      $2=$state;
      $3=$viswidth;
      $4=$visheight;
      var $7=$2;
      var $8=$oldstate;
      var $9=$7;
      assert(464 % 1 === 0, 'memcpy given ' + 464 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $9>>2, $$dest = $8>>2, $$stop = $$src + 116; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $10=$1;
      var $11=__Z16ui_input_pressedR15running_machinei($10, 188);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$2;
      var $15=(($14+444)|0);
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17-1)|0);
      HEAP32[(($16)>>2)]=$18;
      __label__ = 2; break;
    case 2: // $19
      var $20=$1;
      var $21=__Z16ui_input_pressedR15running_machinei($20, 189);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$2;
      var $25=(($24+444)|0);
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+1)|0);
      HEAP32[(($26)>>2)]=$28;
      __label__ = 4; break;
    case 4: // $29
      var $30=$2;
      var $31=(($30+444)|0);
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0) < 0;
      if ($34) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $35
      var $36=$2;
      var $37=(($36+444)|0);
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=0;
      __label__ = 6; break;
    case 6: // $39
      var $40=$2;
      var $41=(($40+444)|0);
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=__Z13tilemap_countR15running_machine($44);
      var $46=(($43)|0) >= (($45)|0);
      if ($46) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $47
      var $48=$1;
      var $49=__Z13tilemap_countR15running_machine($48);
      var $50=(($49-1)|0);
      var $51=$2;
      var $52=(($51+444)|0);
      var $53=(($52)|0);
      HEAP32[(($53)>>2)]=$50;
      __label__ = 8; break;
    case 8: // $54
      var $55=$1;
      var $56=$2;
      var $57=(($56+444)|0);
      var $58=(($57)|0);
      var $59=HEAP32[(($58)>>2)];
      __Z21tilemap_size_by_indexR15running_machineiPjS1_($55, $59, $mapwidth, $mapheight);
      var $60=$1;
      var $61=__Z16ui_input_pressedR15running_machinei($60, 187);
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $63
      var $64=$2;
      var $65=(($64+444)|0);
      var $66=(($65+12)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67-1)|0);
      HEAP32[(($66)>>2)]=$68;
      __label__ = 10; break;
    case 10: // $69
      var $70=$1;
      var $71=__Z16ui_input_pressedR15running_machinei($70, 186);
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $73
      var $74=$2;
      var $75=(($74+444)|0);
      var $76=(($75+12)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+1)|0);
      HEAP32[(($76)>>2)]=$78;
      __label__ = 12; break;
    case 12: // $79
      var $80=$2;
      var $81=(($80+444)|0);
      var $82=(($81+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0) < 0;
      if ($84) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $85
      var $86=$2;
      var $87=(($86+444)|0);
      var $88=(($87+12)|0);
      HEAP32[(($88)>>2)]=0;
      __label__ = 14; break;
    case 14: // $89
      var $90=$2;
      var $91=(($90+444)|0);
      var $92=(($91+12)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93)|0) > 8;
      if ($94) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $95
      var $96=$2;
      var $97=(($96+444)|0);
      var $98=(($97+12)|0);
      HEAP32[(($98)>>2)]=8;
      __label__ = 16; break;
    case 16: // $99
      var $100=$2;
      var $101=(($100+444)|0);
      var $102=(($101+12)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($oldstate+444)|0);
      var $105=(($104+12)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($103)|0)!=(($106)|0);
      if ($107) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $108
      var $109=$2;
      var $110=(($109+444)|0);
      var $111=(($110+12)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $114
      var $115=$2;
      var $116=(($115+444)|0);
      var $117=(($116+12)|0);
      var $118=HEAP32[(($117)>>2)];
      __Z10popmessagePKcz(((STRING_TABLE.__str25360)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$118,tempInt));
      __label__ = 20; break;
    case 19: // $119
      __Z10popmessagePKcz(((STRING_TABLE.__str35361)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 20; break;
    case 20: // $120
      __label__ = 21; break;
    case 21: // $121
      var $122=$1;
      var $123=__Z16ui_input_pressedR15running_machinei($122, 190);
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $125
      var $126=$2;
      var $127=(($126+444)|0);
      var $128=(($127+16)|0);
      var $129=HEAPU8[($128)];
      var $130=(($129)&255);
      var $131=__ZL15orientation_addii5373(5, $130);
      var $132=(($131) & 255);
      var $133=$2;
      var $134=(($133+444)|0);
      var $135=(($134+16)|0);
      HEAP8[($135)]=$132;
      __label__ = 23; break;
    case 23: // $136
      $step=8;
      var $137=$1;
      var $138=__ZNK15running_machine5inputEv($137);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($5, 1, 0, 1, 0, 97);
      var $139=__ZN13input_manager12code_pressedE10input_code($138, $5);
      if ($139) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $140
      $step=1;
      __label__ = 25; break;
    case 25: // $141
      var $142=$1;
      var $143=__ZNK15running_machine5inputEv($142);
      __ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id($6, 1, 0, 1, 0, 99);
      var $144=__ZN13input_manager12code_pressedE10input_code($143, $6);
      if ($144) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $145
      $step=64;
      __label__ = 27; break;
    case 27: // $146
      var $147=$1;
      var $148=__Z23ui_input_pressed_repeatR15running_machineii($147, 174, 4);
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $150
      var $151=$step;
      var $152=$2;
      var $153=(($152+444)|0);
      var $154=(($153+8)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155-$151)|0);
      HEAP32[(($154)>>2)]=$156;
      __label__ = 29; break;
    case 29: // $157
      var $158=$1;
      var $159=__Z23ui_input_pressed_repeatR15running_machineii($158, 175, 4);
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $161
      var $162=$step;
      var $163=$2;
      var $164=(($163+444)|0);
      var $165=(($164+8)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166+$162)|0);
      HEAP32[(($165)>>2)]=$167;
      __label__ = 31; break;
    case 31: // $168
      var $169=$1;
      var $170=__Z23ui_input_pressed_repeatR15running_machineii($169, 176, 6);
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $172
      var $173=$step;
      var $174=$2;
      var $175=(($174+444)|0);
      var $176=(($175+4)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177-$173)|0);
      HEAP32[(($176)>>2)]=$178;
      __label__ = 33; break;
    case 33: // $179
      var $180=$1;
      var $181=__Z23ui_input_pressed_repeatR15running_machineii($180, 177, 6);
      var $182=(($181)|0)!=0;
      if ($182) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $183
      var $184=$step;
      var $185=$2;
      var $186=(($185+444)|0);
      var $187=(($186+4)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($188+$184)|0);
      HEAP32[(($187)>>2)]=$189;
      __label__ = 35; break;
    case 35: // $190
      __label__ = 36; break;
    case 36: // $191
      var $192=$2;
      var $193=(($192+444)|0);
      var $194=(($193+4)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195)|0) < 0;
      if ($196) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $197
      var $198=HEAP32[(($mapwidth)>>2)];
      var $199=$2;
      var $200=(($199+444)|0);
      var $201=(($200+4)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=(($202+$198)|0);
      HEAP32[(($201)>>2)]=$203;
      __label__ = 36; break;
    case 38: // $204
      __label__ = 39; break;
    case 39: // $205
      var $206=$2;
      var $207=(($206+444)|0);
      var $208=(($207+4)|0);
      var $209=HEAPU32[(($208)>>2)];
      var $210=HEAPU32[(($mapwidth)>>2)];
      var $211=(($209)>>>0) >= (($210)>>>0);
      if ($211) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $212
      var $213=HEAP32[(($mapwidth)>>2)];
      var $214=$2;
      var $215=(($214+444)|0);
      var $216=(($215+4)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(($217-$213)|0);
      HEAP32[(($216)>>2)]=$218;
      __label__ = 39; break;
    case 41: // $219
      __label__ = 42; break;
    case 42: // $220
      var $221=$2;
      var $222=(($221+444)|0);
      var $223=(($222+8)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224)|0) < 0;
      if ($225) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $226
      var $227=HEAP32[(($mapheight)>>2)];
      var $228=$2;
      var $229=(($228+444)|0);
      var $230=(($229+8)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231+$227)|0);
      HEAP32[(($230)>>2)]=$232;
      __label__ = 42; break;
    case 44: // $233
      __label__ = 45; break;
    case 45: // $234
      var $235=$2;
      var $236=(($235+444)|0);
      var $237=(($236+8)|0);
      var $238=HEAPU32[(($237)>>2)];
      var $239=HEAPU32[(($mapheight)>>2)];
      var $240=(($238)>>>0) >= (($239)>>>0);
      if ($240) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $241
      var $242=HEAP32[(($mapheight)>>2)];
      var $243=$2;
      var $244=(($243+444)|0);
      var $245=(($244+8)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246-$242)|0);
      HEAP32[(($245)>>2)]=$247;
      __label__ = 45; break;
    case 47: // $248
      var $249=$2;
      var $250=(($249+444)|0);
      var $251=(($250)|0);
      var $252=HEAP32[(($251)>>2)];
      var $253=(($oldstate+444)|0);
      var $254=(($253)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($252)|0)!=(($255)|0);
      if ($256) { __label__ = 51; break; } else { __label__ = 48; break; }
    case 48: // $257
      var $258=$2;
      var $259=(($258+444)|0);
      var $260=(($259+4)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=(($oldstate+444)|0);
      var $263=(($262+4)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(($261)|0)!=(($264)|0);
      if ($265) { __label__ = 51; break; } else { __label__ = 49; break; }
    case 49: // $266
      var $267=$2;
      var $268=(($267+444)|0);
      var $269=(($268+8)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($oldstate+444)|0);
      var $272=(($271+8)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=(($270)|0)!=(($273)|0);
      if ($274) { __label__ = 51; break; } else { __label__ = 50; break; }
    case 50: // $275
      var $276=$2;
      var $277=(($276+444)|0);
      var $278=(($277+16)|0);
      var $279=HEAPU8[($278)];
      var $280=(($279)&255);
      var $281=(($oldstate+444)|0);
      var $282=(($281+16)|0);
      var $283=HEAPU8[($282)];
      var $284=(($283)&255);
      var $285=(($280)|0)!=(($284)|0);
      if ($285) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $286
      var $287=$2;
      var $288=(($287+1)|0);
      HEAP8[($288)]=1;
      __label__ = 52; break;
    case 52: // $289
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19tilemap_handle_keysR15running_machineP13_ui_gfx_stateii["X"]=1;

function __ZL15orientation_addii5373($orientation1, $orientation2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$orientation1;
      $3=$orientation2;
      var $4=$3;
      var $5=$4 & 4;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=$3;
      var $10=$8 ^ $9;
      $1=$10;
      __label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $13=__ZL22orientation_swap_flipsi5374($12);
      var $14=$3;
      var $15=$13 ^ $14;
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16render_container9add_pointEfffjj($this, $x0, $y0, $diameter, $argb, $flags) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$x0;
  $3=$y0;
  $4=$diameter;
  $5=$argb;
  $6=$flags;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $14=$6;
  __ZN16render_container8add_lineEfffffjj($7, $8, $9, $10, $11, $12, $13, $14);
  ;
  return;
}


function __ZL20gfxset_update_bitmapR15running_machineP13_ui_gfx_stateiiP11gfx_element($machine, $state, $xcells, $ycells, $gfx) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $set;
      var $cellxpix;
      var $cellypix;
      var $x;
      var $y;
      var $14;
      var $15;
      var $cellbounds=__stackBase__+36;
      var $index;
      $9=$machine;
      $10=$state;
      $11=$xcells;
      $12=$ycells;
      $13=$gfx;
      var $16=$10;
      var $17=(($16+24)|0);
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      $set=$19;
      var $20=$set;
      var $21=$10;
      var $22=(($21+24)|0);
      var $23=(($22+388)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & 4;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $29
      var $30=$13;
      var $31=(($30+2)|0);
      var $32=HEAP16[(($31)>>1)];
      var $38 = $32;__label__ = 3; break;
    case 2: // $33
      var $34=$13;
      var $35=(($34)|0);
      var $36=HEAP16[(($35)>>1)];
      var $38 = $36;__label__ = 3; break;
    case 3: // $37
      var $38;
      var $39=(($38)&65535);
      var $40=(($39+1)|0);
      $cellxpix=$40;
      var $41=$set;
      var $42=$10;
      var $43=(($42+24)|0);
      var $44=(($43+388)|0);
      var $45=(($44+$41)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=$47 & 4;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $50
      var $51=$13;
      var $52=(($51)|0);
      var $53=HEAP16[(($52)>>1)];
      var $59 = $53;__label__ = 6; break;
    case 5: // $54
      var $55=$13;
      var $56=(($55+2)|0);
      var $57=HEAP16[(($56)>>1)];
      var $59 = $57;__label__ = 6; break;
    case 6: // $58
      var $59;
      var $60=(($59)&65535);
      var $61=(($60+1)|0);
      $cellypix=$61;
      var $62=$10;
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)==0;
      if ($65) { __label__ = 11; break; } else { __label__ = 7; break; }
    case 7: // $66
      var $67=$10;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $71
      var $72=$10;
      var $73=(($72+4)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$74;
      var $76=(($75+24)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)!=32;
      if ($78) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $79
      var $80=$10;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$82;
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$cellxpix;
      var $87=$11;
      var $88=(($86*$87)|0);
      var $89=(($85)|0)!=(($88)|0);
      if ($89) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $90
      var $91=$10;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$93;
      var $95=(($94+16)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$cellypix;
      var $98=$12;
      var $99=(($97*$98)|0);
      var $100=(($96)|0)!=(($99)|0);
      if ($100) { __label__ = 11; break; } else { __label__ = 25; break; }
    case 11: // $101
      var $102=$9;
      var $103=__ZNK15running_machine6renderEv($102);
      var $104=$10;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($103, $106);
      var $107=$10;
      var $108=(($107+4)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=$109;
      __ZN13resource_pool6removeEPv(_global_resource_pool, $110);
      var $111=$4;
      var $112=$5;
      var $113=$6;
      var $114=$result_i;
      var $115=$7;
      var $116=$8;
      HEAP32[(($4)>>2)]=48;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str55363)|0);
      HEAP32[(($6)>>2)]=703;
      var $117=HEAP32[(($4)>>2)];
      var $118=HEAP32[(($5)>>2)];
      var $119=HEAP32[(($6)>>2)];
      var $120=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($117, $118, $119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $121
      HEAP32[(($result_i)>>2)]=$120;
      var $122=HEAP32[(($result_i)>>2)];
      var $123=(($122)|0)==0;
      if ($123) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $124
      var $125=___cxa_allocate_exception(4);
      var $126=$125;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($126);
      (function() { try { __THREW__ = false; return ___cxa_throw($125, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      HEAP32[(($7)>>2)]=$129;
      var $130=$128.f1;
      HEAP32[(($8)>>2)]=$130;
      var $131=HEAP32[(($8)>>2)];
      var $132=(($131)|0) < 0;
      if ($132) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $133
      var $134=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($134);
      throw "Reached an unreachable!"
    case 16: // $135
      var $136=HEAP32[(($7)>>2)];
      var $137=HEAP32[(($7)>>2)];
      var $138=HEAP32[(($8)>>2)];
      var $139=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $137, tempValue);
      var $140=($139.f1 = $138, $139);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $141
      throw "Reached an unreachable!"
    case 18: // $_ZnwjPKci_exit
      var $142=HEAP32[(($result_i)>>2)];
      var $143=$4;
      var $144=$5;
      var $145=$6;
      var $146=$result_i;
      var $147=$7;
      var $148=$8;
      var $149=$142;
      var $150=$cellxpix;
      var $151=$11;
      var $152=(($150*$151)|0);
      var $153=$cellypix;
      var $154=$12;
      var $155=(($153*$154)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($149, $152, $155, 7, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $156
      var $157=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_(_global_resource_pool, $149);
      var $158=$10;
      var $159=(($158+4)|0);
      HEAP32[(($159)>>2)]=$157;
      var $160=$9;
      var $161=__ZNK15running_machine6renderEv($160);
      var $162=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($161, 0, 0);
      var $163=$10;
      var $164=(($163+8)|0);
      HEAP32[(($164)>>2)]=$162;
      var $165=$10;
      var $166=(($165+8)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$10;
      var $169=(($168+4)|0);
      var $170=HEAP32[(($169)>>2)];
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($167, $170, 0, 5, 0);
      var $171=$10;
      var $172=(($171+1)|0);
      HEAP8[($172)]=1;
      __label__ = 25; break;
    case 20: // $173
      var $174=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $175=$174.f0;
      $14=$175;
      var $176=$174.f1;
      $15=$176;
      var $177=$1;
      var $178=$2;
      var $179=$3;
      HEAP32[(($1)>>2)]=$142;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str55363)|0);
      HEAP32[(($3)>>2)]=703;
      var $180=HEAP32[(($1)>>2)];
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $182
      var $183=HEAP32[(($1)>>2)];
      var $184=HEAP32[(($2)>>2)];
      var $185=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($183, $184, $185) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 43; break; }
    case 22: // $_noexc
      __label__ = 23; break;
    case 23: // $_ZdlPvPKci_exit
      var $186=$1;
      var $187=$2;
      var $188=$3;
      __label__ = 24; break;
    case 24: // $189
      __label__ = 42; break;
    case 25: // $190
      var $191=$10;
      var $192=(($191+1)|0);
      var $193=HEAP8[($192)];
      var $194=(($193 << 24) >> 24)!=0;
      if ($194) { __label__ = 26; break; } else { __label__ = 41; break; }
    case 26: // $195
      $y=0;
      __label__ = 27; break;
    case 27: // $196
      var $197=$y;
      var $198=$12;
      var $199=(($197)|0) < (($198)|0);
      if ($199) { __label__ = 28; break; } else { __label__ = 40; break; }
    case 28: // $200
      var $201=(($cellbounds)|0);
      HEAP32[(($201)>>2)]=0;
      var $202=$10;
      var $203=(($202+4)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$204;
      var $206=(($205+12)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207-1)|0);
      var $209=(($cellbounds+4)|0);
      HEAP32[(($209)>>2)]=$208;
      var $210=$y;
      var $211=$cellypix;
      var $212=(($210*$211)|0);
      var $213=(($cellbounds+8)|0);
      HEAP32[(($213)>>2)]=$212;
      var $214=$y;
      var $215=(($214+1)|0);
      var $216=$cellypix;
      var $217=(($215*$216)|0);
      var $218=(($217-1)|0);
      var $219=(($cellbounds+12)|0);
      HEAP32[(($219)>>2)]=$218;
      var $220=$set;
      var $221=$10;
      var $222=(($221+24)|0);
      var $223=(($222+4)|0);
      var $224=(($223+($220<<2))|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$y;
      var $227=$11;
      var $228=(($226*$227)|0);
      var $229=(($225+$228)|0);
      var $230=$13;
      var $231=(($230+16)|0);
      var $232=HEAPU32[(($231)>>2)];
      var $233=(($229)>>>0) < (($232)>>>0);
      if ($233) { __label__ = 29; break; } else { __label__ = 37; break; }
    case 29: // $234
      $x=0;
      __label__ = 30; break;
    case 30: // $235
      var $236=$x;
      var $237=$11;
      var $238=(($236)|0) < (($237)|0);
      if ($238) { __label__ = 31; break; } else { __label__ = 36; break; }
    case 31: // $239
      var $240=$set;
      var $241=$10;
      var $242=(($241+24)|0);
      var $243=(($242+4)|0);
      var $244=(($243+($240<<2))|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=$y;
      var $247=$11;
      var $248=(($246*$247)|0);
      var $249=(($245+$248)|0);
      var $250=$x;
      var $251=(($249+$250)|0);
      $index=$251;
      var $252=$x;
      var $253=$cellxpix;
      var $254=(($252*$253)|0);
      var $255=(($cellbounds)|0);
      HEAP32[(($255)>>2)]=$254;
      var $256=$x;
      var $257=(($256+1)|0);
      var $258=$cellxpix;
      var $259=(($257*$258)|0);
      var $260=(($259-1)|0);
      var $261=(($cellbounds+4)|0);
      HEAP32[(($261)>>2)]=$260;
      var $262=$index;
      var $263=$13;
      var $264=(($263+16)|0);
      var $265=HEAPU32[(($264)>>2)];
      var $266=(($262)>>>0) < (($265)>>>0);
      if ($266) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $267
      var $268=$9;
      var $269=$13;
      var $270=$index;
      var $271=$10;
      var $272=(($271+4)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=(($cellbounds)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=(($cellbounds+8)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$set;
      var $279=$10;
      var $280=(($279+24)|0);
      var $281=(($280+132)|0);
      var $282=(($281+($278<<2))|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=$set;
      var $285=$10;
      var $286=(($285+24)|0);
      var $287=(($286+388)|0);
      var $288=(($287+$284)|0);
      var $289=HEAPU8[($288)];
      var $290=(($289)&255);
      __ZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiii($268, $269, $270, $273, $275, $277, $283, $290);
      __label__ = 34; break;
    case 33: // $291
      var $292=$10;
      var $293=(($292+4)|0);
      var $294=HEAP32[(($293)>>2)];
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($294, $cellbounds, 0);
      __label__ = 34; break;
    case 34: // $295
      __label__ = 35; break;
    case 35: // $296
      var $297=$x;
      var $298=(($297+1)|0);
      $x=$298;
      __label__ = 30; break;
    case 36: // $299
      __label__ = 38; break;
    case 37: // $300
      var $301=$10;
      var $302=(($301+4)|0);
      var $303=HEAP32[(($302)>>2)];
      __Z11bitmap_fillP8bitmap_tPK10_rectanglej($303, $cellbounds, 0);
      __label__ = 38; break;
    case 38: // $304
      __label__ = 39; break;
    case 39: // $305
      var $306=$y;
      var $307=(($306+1)|0);
      $y=$307;
      __label__ = 27; break;
    case 40: // $308
      var $309=$10;
      var $310=(($309+8)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=$10;
      var $313=(($312+4)|0);
      var $314=HEAP32[(($313)>>2)];
      __ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t($311, $314, 0, 5, 0);
      var $315=$10;
      var $316=(($315+1)|0);
      HEAP8[($316)]=0;
      __label__ = 41; break;
    case 41: // $317
      STACKTOP = __stackBase__;
      return;
    case 42: // $318
      var $319=$14;
      var $320=$14;
      var $321=$15;
      var $322=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $320, tempValue);
      var $323=($322.f1 = $321, $322);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $324
      var $325=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20gfxset_update_bitmapR15running_machineP13_ui_gfx_stateiiP11gfx_element["X"]=1;

function __ZL18gfxset_handle_keysR15running_machineP13_ui_gfx_stateii($machine, $state, $xcells, $ycells) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $oldstate=__stackBase__;
      var $gfx;
      var $temp;
      var $set;
      $1=$machine;
      $2=$state;
      $3=$xcells;
      $4=$ycells;
      var $5=$2;
      var $6=$oldstate;
      var $7=$5;
      assert(464 % 1 === 0, 'memcpy given ' + 464 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $7>>2, $$dest = $6>>2, $$stop = $$src + 116; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $8=$1;
      var $9=__Z16ui_input_pressedR15running_machinei($8, 188);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $11
      var $12=$2;
      var $13=(($12+24)|0);
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15-1)|0);
      $temp=$16;
      __label__ = 2; break;
    case 2: // $17
      var $18=$temp;
      var $19=(($18)|0) >= 0;
      if ($19) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $20
      var $21=$temp;
      var $22=$1;
      var $23=(($22+432)|0);
      var $24=(($23+($21<<2))|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      __label__ = 7; break;
    case 5: // $28
      __label__ = 6; break;
    case 6: // $29
      var $30=$temp;
      var $31=(($30-1)|0);
      $temp=$31;
      __label__ = 2; break;
    case 7: // $32
      var $33=$temp;
      var $34=(($33)|0) >= 0;
      if ($34) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $35
      var $36=$temp;
      var $37=$2;
      var $38=(($37+24)|0);
      var $39=(($38)|0);
      HEAP32[(($39)>>2)]=$36;
      __label__ = 9; break;
    case 9: // $40
      __label__ = 10; break;
    case 10: // $41
      var $42=$1;
      var $43=__Z16ui_input_pressedR15running_machinei($42, 189);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $45
      var $46=$2;
      var $47=(($46+24)|0);
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+1)|0);
      $temp=$50;
      __label__ = 12; break;
    case 12: // $51
      var $52=$temp;
      var $53=(($52)|0) < 32;
      if ($53) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $54
      var $55=$temp;
      var $56=$1;
      var $57=(($56+432)|0);
      var $58=(($57+($55<<2))|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $61
      __label__ = 17; break;
    case 15: // $62
      __label__ = 16; break;
    case 16: // $63
      var $64=$temp;
      var $65=(($64+1)|0);
      $temp=$65;
      __label__ = 12; break;
    case 17: // $66
      var $67=$temp;
      var $68=(($67)|0) < 32;
      if ($68) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $69
      var $70=$temp;
      var $71=$2;
      var $72=(($71+24)|0);
      var $73=(($72)|0);
      HEAP32[(($73)>>2)]=$70;
      __label__ = 19; break;
    case 19: // $74
      __label__ = 20; break;
    case 20: // $75
      var $76=$2;
      var $77=(($76+24)|0);
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      $set=$79;
      var $80=$set;
      var $81=$1;
      var $82=(($81+432)|0);
      var $83=(($82+($80<<2))|0);
      var $84=HEAP32[(($83)>>2)];
      $gfx=$84;
      var $85=$1;
      var $86=__Z16ui_input_pressedR15running_machinei($85, 187);
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $88
      var $89=$3;
      var $90=(($89-1)|0);
      var $91=$set;
      var $92=$2;
      var $93=(($92+24)|0);
      var $94=(($93+260)|0);
      var $95=(($94+($91<<2))|0);
      HEAP32[(($95)>>2)]=$90;
      __label__ = 22; break;
    case 22: // $96
      var $97=$1;
      var $98=__Z16ui_input_pressedR15running_machinei($97, 186);
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $100
      var $101=$3;
      var $102=(($101+1)|0);
      var $103=$set;
      var $104=$2;
      var $105=(($104+24)|0);
      var $106=(($105+260)|0);
      var $107=(($106+($103<<2))|0);
      HEAP32[(($107)>>2)]=$102;
      __label__ = 24; break;
    case 24: // $108
      var $109=$set;
      var $110=$2;
      var $111=(($110+24)|0);
      var $112=(($111+260)|0);
      var $113=(($112+($109<<2))|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114)|0) < 2;
      if ($115) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $116
      var $117=$set;
      var $118=$2;
      var $119=(($118+24)|0);
      var $120=(($119+260)|0);
      var $121=(($120+($117<<2))|0);
      HEAP32[(($121)>>2)]=2;
      __label__ = 26; break;
    case 26: // $122
      var $123=$set;
      var $124=$2;
      var $125=(($124+24)|0);
      var $126=(($125+260)|0);
      var $127=(($126+($123<<2))|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128)|0) > 32;
      if ($129) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $130
      var $131=$set;
      var $132=$2;
      var $133=(($132+24)|0);
      var $134=(($133+260)|0);
      var $135=(($134+($131<<2))|0);
      HEAP32[(($135)>>2)]=32;
      __label__ = 28; break;
    case 28: // $136
      var $137=$1;
      var $138=__Z16ui_input_pressedR15running_machinei($137, 190);
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $140
      var $141=$set;
      var $142=$2;
      var $143=(($142+24)|0);
      var $144=(($143+388)|0);
      var $145=(($144+$141)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=__ZL15orientation_addii5373(5, $147);
      var $149=(($148) & 255);
      var $150=$set;
      var $151=$2;
      var $152=(($151+24)|0);
      var $153=(($152+388)|0);
      var $154=(($153+$150)|0);
      HEAP8[($154)]=$149;
      __label__ = 30; break;
    case 30: // $155
      var $156=$1;
      var $157=__Z23ui_input_pressed_repeatR15running_machineii($156, 174, 4);
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $159
      var $160=$3;
      var $161=$set;
      var $162=$2;
      var $163=(($162+24)|0);
      var $164=(($163+4)|0);
      var $165=(($164+($161<<2))|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166-$160)|0);
      HEAP32[(($165)>>2)]=$167;
      __label__ = 32; break;
    case 32: // $168
      var $169=$1;
      var $170=__Z23ui_input_pressed_repeatR15running_machineii($169, 175, 4);
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $172
      var $173=$3;
      var $174=$set;
      var $175=$2;
      var $176=(($175+24)|0);
      var $177=(($176+4)|0);
      var $178=(($177+($174<<2))|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+$173)|0);
      HEAP32[(($178)>>2)]=$180;
      __label__ = 34; break;
    case 34: // $181
      var $182=$1;
      var $183=__Z23ui_input_pressed_repeatR15running_machineii($182, 180, 6);
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $185
      var $186=$3;
      var $187=$4;
      var $188=(($186*$187)|0);
      var $189=$set;
      var $190=$2;
      var $191=(($190+24)|0);
      var $192=(($191+4)|0);
      var $193=(($192+($189<<2))|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194-$188)|0);
      HEAP32[(($193)>>2)]=$195;
      __label__ = 36; break;
    case 36: // $196
      var $197=$1;
      var $198=__Z23ui_input_pressed_repeatR15running_machineii($197, 181, 6);
      var $199=(($198)|0)!=0;
      if ($199) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $200
      var $201=$3;
      var $202=$4;
      var $203=(($201*$202)|0);
      var $204=$set;
      var $205=$2;
      var $206=(($205+24)|0);
      var $207=(($206+4)|0);
      var $208=(($207+($204<<2))|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=(($209+$203)|0);
      HEAP32[(($208)>>2)]=$210;
      __label__ = 38; break;
    case 38: // $211
      var $212=$1;
      var $213=__Z23ui_input_pressed_repeatR15running_machineii($212, 178, 4);
      var $214=(($213)|0)!=0;
      if ($214) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $215
      var $216=$set;
      var $217=$2;
      var $218=(($217+24)|0);
      var $219=(($218+4)|0);
      var $220=(($219+($216<<2))|0);
      HEAP32[(($220)>>2)]=0;
      __label__ = 40; break;
    case 40: // $221
      var $222=$1;
      var $223=__Z23ui_input_pressed_repeatR15running_machineii($222, 179, 4);
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $225
      var $226=$gfx;
      var $227=(($226+16)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$set;
      var $230=$2;
      var $231=(($230+24)|0);
      var $232=(($231+4)|0);
      var $233=(($232+($229<<2))|0);
      HEAP32[(($233)>>2)]=$228;
      __label__ = 42; break;
    case 42: // $234
      var $235=$set;
      var $236=$2;
      var $237=(($236+24)|0);
      var $238=(($237+4)|0);
      var $239=(($238+($235<<2))|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$3;
      var $242=$4;
      var $243=(($241*$242)|0);
      var $244=(($240+$243)|0);
      var $245=$gfx;
      var $246=(($245+16)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=$3;
      var $249=(($247+$248)|0);
      var $250=(($249-1)|0);
      var $251=$3;
      var $252=Math.floor((($250)>>>0)/(($251)>>>0));
      var $253=$3;
      var $254=(($252*$253)|0);
      var $255=(($244)>>>0) > (($254)>>>0);
      if ($255) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $256
      var $257=$gfx;
      var $258=(($257+16)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=$3;
      var $261=(($259+$260)|0);
      var $262=(($261-1)|0);
      var $263=$3;
      var $264=Math.floor((($262)>>>0)/(($263)>>>0));
      var $265=$3;
      var $266=(($264*$265)|0);
      var $267=$3;
      var $268=$4;
      var $269=(($267*$268)|0);
      var $270=(($266-$269)|0);
      var $271=$set;
      var $272=$2;
      var $273=(($272+24)|0);
      var $274=(($273+4)|0);
      var $275=(($274+($271<<2))|0);
      HEAP32[(($275)>>2)]=$270;
      __label__ = 44; break;
    case 44: // $276
      var $277=$set;
      var $278=$2;
      var $279=(($278+24)|0);
      var $280=(($279+4)|0);
      var $281=(($280+($277<<2))|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=(($282)|0) < 0;
      if ($283) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $284
      var $285=$set;
      var $286=$2;
      var $287=(($286+24)|0);
      var $288=(($287+4)|0);
      var $289=(($288+($285<<2))|0);
      HEAP32[(($289)>>2)]=0;
      __label__ = 46; break;
    case 46: // $290
      var $291=$1;
      var $292=__Z23ui_input_pressed_repeatR15running_machineii($291, 176, 4);
      var $293=(($292)|0)!=0;
      if ($293) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $294
      var $295=$set;
      var $296=$2;
      var $297=(($296+24)|0);
      var $298=(($297+132)|0);
      var $299=(($298+($295<<2))|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=(($300-1)|0);
      HEAP32[(($299)>>2)]=$301;
      __label__ = 48; break;
    case 48: // $302
      var $303=$1;
      var $304=__Z23ui_input_pressed_repeatR15running_machineii($303, 177, 4);
      var $305=(($304)|0)!=0;
      if ($305) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $306
      var $307=$set;
      var $308=$2;
      var $309=(($308+24)|0);
      var $310=(($309+132)|0);
      var $311=(($310+($307<<2))|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=(($312+1)|0);
      HEAP32[(($311)>>2)]=$313;
      __label__ = 50; break;
    case 50: // $314
      var $315=$set;
      var $316=$2;
      var $317=(($316+24)|0);
      var $318=(($317+132)|0);
      var $319=(($318+($315<<2))|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$gfx;
      var $322=(($321+28)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=(($320)|0) >= (($323)|0);
      if ($324) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $325
      var $326=$gfx;
      var $327=(($326+28)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=(($328-1)|0);
      var $330=$set;
      var $331=$2;
      var $332=(($331+24)|0);
      var $333=(($332+132)|0);
      var $334=(($333+($330<<2))|0);
      HEAP32[(($334)>>2)]=$329;
      __label__ = 52; break;
    case 52: // $335
      var $336=$set;
      var $337=$2;
      var $338=(($337+24)|0);
      var $339=(($338+132)|0);
      var $340=(($339+($336<<2))|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=(($341)|0) < 0;
      if ($342) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $343
      var $344=$set;
      var $345=$2;
      var $346=(($345+24)|0);
      var $347=(($346+132)|0);
      var $348=(($347+($344<<2))|0);
      HEAP32[(($348)>>2)]=0;
      __label__ = 54; break;
    case 54: // $349
      var $350=$2;
      var $351=(($350+24)|0);
      var $352=(($351)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($oldstate+24)|0);
      var $355=(($354)|0);
      var $356=HEAP32[(($355)>>2)];
      var $357=(($353)|0)!=(($356)|0);
      if ($357) { __label__ = 59; break; } else { __label__ = 55; break; }
    case 55: // $358
      var $359=$set;
      var $360=$2;
      var $361=(($360+24)|0);
      var $362=(($361+4)|0);
      var $363=(($362+($359<<2))|0);
      var $364=HEAP32[(($363)>>2)];
      var $365=$set;
      var $366=(($oldstate+24)|0);
      var $367=(($366+4)|0);
      var $368=(($367+($365<<2))|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=(($364)|0)!=(($369)|0);
      if ($370) { __label__ = 59; break; } else { __label__ = 56; break; }
    case 56: // $371
      var $372=$set;
      var $373=$2;
      var $374=(($373+24)|0);
      var $375=(($374+388)|0);
      var $376=(($375+$372)|0);
      var $377=HEAPU8[($376)];
      var $378=(($377)&255);
      var $379=$set;
      var $380=(($oldstate+24)|0);
      var $381=(($380+388)|0);
      var $382=(($381+$379)|0);
      var $383=HEAPU8[($382)];
      var $384=(($383)&255);
      var $385=(($378)|0)!=(($384)|0);
      if ($385) { __label__ = 59; break; } else { __label__ = 57; break; }
    case 57: // $386
      var $387=$set;
      var $388=$2;
      var $389=(($388+24)|0);
      var $390=(($389+132)|0);
      var $391=(($390+($387<<2))|0);
      var $392=HEAP32[(($391)>>2)];
      var $393=$set;
      var $394=(($oldstate+24)|0);
      var $395=(($394+132)|0);
      var $396=(($395+($393<<2))|0);
      var $397=HEAP32[(($396)>>2)];
      var $398=(($392)|0)!=(($397)|0);
      if ($398) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $399
      var $400=$set;
      var $401=$2;
      var $402=(($401+24)|0);
      var $403=(($402+260)|0);
      var $404=(($403+($400<<2))|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=$set;
      var $407=(($oldstate+24)|0);
      var $408=(($407+260)|0);
      var $409=(($408+($406<<2))|0);
      var $410=HEAP32[(($409)>>2)];
      var $411=(($405)|0)!=(($410)|0);
      if ($411) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $412
      var $413=$2;
      var $414=(($413+1)|0);
      HEAP8[($414)]=1;
      __label__ = 60; break;
    case 60: // $415
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18gfxset_handle_keysR15running_machineP13_ui_gfx_stateii["X"]=1;

function __ZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiii($machine, $gfx, $index, $bitmap, $dstx, $dsty, $color, $rotate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $width;
      var $height;
      var $palette;
      var $rowpixels;
      var $palette_mask;
      var $x;
      var $y;
      var $dest;
      var $src;
      var $effx;
      var $effy;
      var $pixel;
      var $s;
      var $temp;
      $1=$machine;
      $2=$gfx;
      $3=$index;
      $4=$bitmap;
      $5=$dstx;
      $6=$dsty;
      $7=$color;
      $8=$rotate;
      var $9=$8;
      var $10=$9 & 4;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=(($13+2)|0);
      var $15=HEAP16[(($14)>>1)];
      var $21 = $15;__label__ = 3; break;
    case 2: // $16
      var $17=$2;
      var $18=(($17)|0);
      var $19=HEAP16[(($18)>>1)];
      var $21 = $19;__label__ = 3; break;
    case 3: // $20
      var $21;
      var $22=(($21)&65535);
      $width=$22;
      var $23=$8;
      var $24=$23 & 4;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$2;
      var $28=(($27)|0);
      var $29=HEAP16[(($28)>>1)];
      var $35 = $29;__label__ = 6; break;
    case 5: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      var $33=HEAP16[(($32)>>1)];
      var $35 = $33;__label__ = 6; break;
    case 6: // $34
      var $35;
      var $36=(($35)&65535);
      $height=$36;
      var $37=$1;
      var $38=__ZNK15running_machine12total_colorsEv($37);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      var $41=$1;
      var $42=(($41+564)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=__Z22palette_entry_list_rawP10_palette_t($43);
      var $47 = $44;__label__ = 9; break;
    case 8: // $45
      var $47 = 0;__label__ = 9; break;
    case 9: // $46
      var $47;
      $palette=$47;
      var $48=$4;
      var $49=$48;
      var $50=(($49+8)|0);
      var $51=HEAP32[(($50)>>2)];
      $rowpixels=$51;
      $palette_mask=-1;
      var $52=$palette;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $54
      var $55=$2;
      var $56=(($55+20)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$7;
      var $59=$2;
      var $60=(($59+26)|0);
      var $61=HEAPU16[(($60)>>1)];
      var $62=(($61)&65535);
      var $63=(($58*$62)|0);
      var $64=(($57+$63)|0);
      var $65=$palette;
      var $66=(($65+($64<<2))|0);
      $palette=$66;
      __label__ = 12; break;
    case 11: // $67
      $palette=((__ZZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiiiE15default_palette)|0);
      $palette_mask=7;
      __label__ = 12; break;
    case 12: // $68
      $y=0;
      __label__ = 13; break;
    case 13: // $69
      var $70=$y;
      var $71=$height;
      var $72=(($70)|0) < (($71)|0);
      if ($72) { __label__ = 14; break; } else { __label__ = 34; break; }
    case 14: // $73
      var $74=$4;
      var $75=$74;
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$77;
      var $79=$6;
      var $80=$y;
      var $81=(($79+$80)|0);
      var $82=$rowpixels;
      var $83=(($81*$82)|0);
      var $84=(($78+($83<<2))|0);
      var $85=$5;
      var $86=(($84+($85<<2))|0);
      $dest=$86;
      var $87=$2;
      var $88=$3;
      var $89=__ZL20gfx_element_get_dataPK11gfx_elementj5375($87, $88);
      $src=$89;
      $x=0;
      __label__ = 15; break;
    case 15: // $90
      var $91=$x;
      var $92=$width;
      var $93=(($91)|0) < (($92)|0);
      if ($93) { __label__ = 16; break; } else { __label__ = 32; break; }
    case 16: // $94
      var $95=$x;
      $effx=$95;
      var $96=$y;
      $effy=$96;
      var $97=$8;
      var $98=$97 & 4;
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 22; break; } else { __label__ = 17; break; }
    case 17: // $100
      var $101=$8;
      var $102=$101 & 1;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $104
      var $105=$2;
      var $106=(($105)|0);
      var $107=HEAPU16[(($106)>>1)];
      var $108=(($107)&65535);
      var $109=(($108-1)|0);
      var $110=$effx;
      var $111=(($109-$110)|0);
      $effx=$111;
      __label__ = 19; break;
    case 19: // $112
      var $113=$8;
      var $114=$113 & 2;
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $116
      var $117=$2;
      var $118=(($117+2)|0);
      var $119=HEAPU16[(($118)>>1)];
      var $120=(($119)&65535);
      var $121=(($120-1)|0);
      var $122=$effy;
      var $123=(($121-$122)|0);
      $effy=$123;
      __label__ = 21; break;
    case 21: // $124
      __label__ = 27; break;
    case 22: // $125
      var $126=$8;
      var $127=$126 & 1;
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $129
      var $130=$2;
      var $131=(($130+2)|0);
      var $132=HEAPU16[(($131)>>1)];
      var $133=(($132)&65535);
      var $134=(($133-1)|0);
      var $135=$effx;
      var $136=(($134-$135)|0);
      $effx=$136;
      __label__ = 24; break;
    case 24: // $137
      var $138=$8;
      var $139=$138 & 2;
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $141
      var $142=$2;
      var $143=(($142)|0);
      var $144=HEAPU16[(($143)>>1)];
      var $145=(($144)&65535);
      var $146=(($145-1)|0);
      var $147=$effy;
      var $148=(($146-$147)|0);
      $effy=$148;
      __label__ = 26; break;
    case 26: // $149
      var $150=$effx;
      $temp=$150;
      var $151=$effy;
      $effx=$151;
      var $152=$temp;
      $effy=$152;
      __label__ = 27; break;
    case 27: // $153
      var $154=$src;
      var $155=$effy;
      var $156=$2;
      var $157=(($156+40)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($155*$158)|0);
      var $160=(($154+$159)|0);
      $s=$160;
      var $161=$2;
      var $162=(($161+12)|0);
      var $163=HEAPU8[($162)];
      var $164=(($163)&255);
      var $165=$164 & 1;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $167
      var $168=$effx;
      var $169=(((($168)|0)/2)|0);
      var $170=$s;
      var $171=(($170+$169)|0);
      var $172=HEAPU8[($171)];
      var $173=(($172)&255);
      var $174=$effx;
      var $175=$174 & 1;
      var $176=((($175<<2))|0);
      var $177=$173 >> (($176)|0);
      var $178=$177 & 15;
      $pixel=$178;
      __label__ = 30; break;
    case 29: // $179
      var $180=$effx;
      var $181=$s;
      var $182=(($181+$180)|0);
      var $183=HEAPU8[($182)];
      var $184=(($183)&255);
      $pixel=$184;
      __label__ = 30; break;
    case 30: // $185
      var $186=$pixel;
      var $187=$palette_mask;
      var $188=$186 & $187;
      var $189=$palette;
      var $190=(($189+($188<<2))|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=-16777216 | $191;
      var $193=$dest;
      var $194=(($193+4)|0);
      $dest=$194;
      HEAP32[(($193)>>2)]=$192;
      __label__ = 31; break;
    case 31: // $195
      var $196=$x;
      var $197=(($196+1)|0);
      $x=$197;
      __label__ = 15; break;
    case 32: // $198
      __label__ = 33; break;
    case 33: // $199
      var $200=$y;
      var $201=(($200+1)|0);
      $y=$201;
      __label__ = 13; break;
    case 34: // $202
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiii["X"]=1;

function __ZL20gfx_element_get_dataPK11gfx_elementj5375($gfx, $code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$gfx;
      $2=$code;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      var $5=$2;
      var $6=$1;
      var $7=(($6+52)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$5)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$1;
      var $14=$2;
      __Z18gfx_element_decodePK11gfx_elementj($13, $14);
      __label__ = 4; break;
    case 4: // $15
      var $16=$1;
      var $17=(($16+36)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=$1;
      var $21=(($20+44)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($19*$22)|0);
      var $24=(($18+$23)|0);
      var $25=$1;
      var $26=(($25+6)|0);
      var $27=HEAPU16[(($26)>>1)];
      var $28=(($27)&65535);
      var $29=$1;
      var $30=(($29+40)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28*$31)|0);
      var $33=(($24+$32)|0);
      var $34=$1;
      var $35=(($34+4)|0);
      var $36=HEAPU16[(($35)>>1)];
      var $37=(($36)&65535);
      var $38=(($33+$37)|0);
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21cassette_image_device11is_motor_onEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+1228)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5 & 3;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 5; break;
    case 2: // $9
      var $10=(($3+1228)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 4;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=0;
      __label__ = 5; break;
    case 4: // $15
      $1=1;
      __label__ = 5; break;
    case 5: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19palette_handle_keysR15running_machineP13_ui_gfx_state($machine, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $rowcount;
      var $screencount;
      var $total;
      $1=$machine;
      $2=$state;
      var $3=$1;
      var $4=__Z16ui_input_pressedR15running_machinei($3, 187);
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7+12)|0);
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(((($10)|0)/2)|0);
      HEAP32[(($9)>>2)]=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z16ui_input_pressedR15running_machinei($13, 186);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$2;
      var $18=(($17+12)|0);
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=((($20<<1))|0);
      HEAP32[(($19)>>2)]=$21;
      __label__ = 4; break;
    case 4: // $22
      var $23=$2;
      var $24=(($23+12)|0);
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0) <= 4;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      var $29=$2;
      var $30=(($29+12)|0);
      var $31=(($30+8)|0);
      HEAP32[(($31)>>2)]=4;
      __label__ = 6; break;
    case 6: // $32
      var $33=$2;
      var $34=(($33+12)|0);
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0) > 64;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      var $39=$2;
      var $40=(($39+12)|0);
      var $41=(($40+8)|0);
      HEAP32[(($41)>>2)]=64;
      __label__ = 8; break;
    case 8: // $42
      var $43=$1;
      var $44=__Z16ui_input_pressedR15running_machinei($43, 188);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $46
      var $47=$2;
      var $48=(($47+12)|0);
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50-1)|0);
      HEAP32[(($49)>>2)]=$51;
      __label__ = 10; break;
    case 10: // $52
      var $53=$1;
      var $54=__Z16ui_input_pressedR15running_machinei($53, 189);
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      var $57=$2;
      var $58=(($57+12)|0);
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+1)|0);
      HEAP32[(($59)>>2)]=$61;
      __label__ = 12; break;
    case 12: // $62
      var $63=$2;
      var $64=(($63+12)|0);
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0) < 0;
      if ($67) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $68
      var $69=$2;
      var $70=(($69+12)|0);
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=1;
      __label__ = 14; break;
    case 14: // $72
      var $73=$2;
      var $74=(($73+12)|0);
      var $75=(($74)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$1;
      var $78=(($77+572)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)!=0;
      var $81=(($80)&1);
      var $82=(($76)|0) > (($81)|0);
      if ($82) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $83
      var $84=$1;
      var $85=(($84+572)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0)!=0;
      var $88=(($87)&1);
      var $89=$2;
      var $90=(($89+12)|0);
      var $91=(($90)|0);
      HEAP32[(($91)>>2)]=$88;
      __label__ = 16; break;
    case 16: // $92
      var $93=$2;
      var $94=(($93+12)|0);
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      var $99=$1;
      var $100=(($99+572)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=__Z27colortable_palette_get_sizeP12colortable_t($101);
      var $107 = $102;__label__ = 19; break;
    case 18: // $103
      var $104=$1;
      var $105=__ZNK15running_machine12total_colorsEv($104);
      var $107 = $105;__label__ = 19; break;
    case 19: // $106
      var $107;
      $total=$107;
      var $108=$2;
      var $109=(($108+12)|0);
      var $110=(($109+8)|0);
      var $111=HEAP32[(($110)>>2)];
      $rowcount=$111;
      var $112=$rowcount;
      var $113=$rowcount;
      var $114=(($112*$113)|0);
      $screencount=$114;
      var $115=$1;
      var $116=__Z23ui_input_pressed_repeatR15running_machineii($115, 174, 4);
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $118
      var $119=$rowcount;
      var $120=$2;
      var $121=(($120+12)|0);
      var $122=(($121+4)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123-$119)|0);
      HEAP32[(($122)>>2)]=$124;
      __label__ = 21; break;
    case 21: // $125
      var $126=$1;
      var $127=__Z23ui_input_pressed_repeatR15running_machineii($126, 175, 4);
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $129
      var $130=$rowcount;
      var $131=$2;
      var $132=(($131+12)|0);
      var $133=(($132+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+$130)|0);
      HEAP32[(($133)>>2)]=$135;
      __label__ = 23; break;
    case 23: // $136
      var $137=$1;
      var $138=__Z23ui_input_pressed_repeatR15running_machineii($137, 180, 6);
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $140
      var $141=$screencount;
      var $142=$2;
      var $143=(($142+12)|0);
      var $144=(($143+4)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145-$141)|0);
      HEAP32[(($144)>>2)]=$146;
      __label__ = 25; break;
    case 25: // $147
      var $148=$1;
      var $149=__Z23ui_input_pressed_repeatR15running_machineii($148, 181, 6);
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $151
      var $152=$screencount;
      var $153=$2;
      var $154=(($153+12)|0);
      var $155=(($154+4)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($156+$152)|0);
      HEAP32[(($155)>>2)]=$157;
      __label__ = 27; break;
    case 27: // $158
      var $159=$1;
      var $160=__Z23ui_input_pressed_repeatR15running_machineii($159, 178, 4);
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $162
      var $163=$2;
      var $164=(($163+12)|0);
      var $165=(($164+4)|0);
      HEAP32[(($165)>>2)]=0;
      __label__ = 29; break;
    case 29: // $166
      var $167=$1;
      var $168=__Z23ui_input_pressed_repeatR15running_machineii($167, 179, 4);
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $170
      var $171=$total;
      var $172=$2;
      var $173=(($172+12)|0);
      var $174=(($173+4)|0);
      HEAP32[(($174)>>2)]=$171;
      __label__ = 31; break;
    case 31: // $175
      var $176=$2;
      var $177=(($176+12)|0);
      var $178=(($177+4)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$screencount;
      var $181=(($179+$180)|0);
      var $182=$total;
      var $183=$rowcount;
      var $184=(($182+$183)|0);
      var $185=(($184-1)|0);
      var $186=$rowcount;
      var $187=(((($185)|0)/(($186)|0))|0);
      var $188=$rowcount;
      var $189=(($187*$188)|0);
      var $190=(($181)|0) > (($189)|0);
      if ($190) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $191
      var $192=$total;
      var $193=$rowcount;
      var $194=(($192+$193)|0);
      var $195=(($194-1)|0);
      var $196=$rowcount;
      var $197=(((($195)|0)/(($196)|0))|0);
      var $198=$rowcount;
      var $199=(($197*$198)|0);
      var $200=$screencount;
      var $201=(($199-$200)|0);
      var $202=$2;
      var $203=(($202+12)|0);
      var $204=(($203+4)|0);
      HEAP32[(($204)>>2)]=$201;
      __label__ = 33; break;
    case 33: // $205
      var $206=$2;
      var $207=(($206+12)|0);
      var $208=(($207+4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=(($209)|0) < 0;
      if ($210) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $211
      var $212=$2;
      var $213=(($212+12)|0);
      var $214=(($213+4)|0);
      HEAP32[(($214)>>2)]=0;
      __label__ = 35; break;
    case 35: // $215
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19palette_handle_keysR15running_machineP13_ui_gfx_state["X"]=1;

function __ZThn376_N21cassette_image_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  __ZN21cassette_image_deviceD0Ev($5);
  ;
  return;
}


function __ZThn376_N21cassette_image_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  FUNCTION_TABLE[__ZN21cassette_image_deviceD1Ev]($5);
  ;
  return;
}


function __ZN21cassette_image_device22device_config_completeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      var $i;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t13static_configEv($3);
      var $5=$4;
      $intf=$5;
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+356)|0);
      var $11=$10;
      var $12=$intf;
      var $13=$11;
      var $14=$12;
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[(($14)>>2)];HEAP32[(($13+4)>>2)]=HEAP32[(($14+4)>>2)];HEAP32[(($13+8)>>2)]=HEAP32[(($14+8)>>2)];HEAP32[(($13+12)>>2)]=HEAP32[(($14+12)>>2)];HEAP32[(($13+16)>>2)]=HEAP32[(($14+16)>>2)];
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($16+356)|0);
      var $18=$17;
      var $19=(($18)|0);
      var $20=$19;
      HEAP8[($20)]=0; HEAP8[($20+1)]=0; HEAP8[($20+2)]=0; HEAP8[($20+3)]=0;
      var $21=$2;
      var $22=(($21+356)|0);
      var $23=$22;
      var $24=(($23+4)|0);
      var $25=$24;
      HEAP8[($25)]=0; HEAP8[($25+1)]=0; HEAP8[($25+2)]=0; HEAP8[($25+3)]=0;
      var $26=$2;
      var $27=(($26+356)|0);
      var $28=$27;
      var $29=(($28+8)|0);
      var $30=$29;
      HEAP8[($30)]=0; HEAP8[($30+1)]=0; HEAP8[($30+2)]=0; HEAP8[($30+3)]=0;
      var $31=$2;
      var $32=(($31+356)|0);
      var $33=$32;
      var $34=(($33+12)|0);
      var $35=$34;
      HEAP8[($35)]=0; HEAP8[($35+1)]=0; HEAP8[($35+2)]=0; HEAP8[($35+3)]=0;
      var $36=$2;
      var $37=(($36+356)|0);
      var $38=$37;
      var $39=(($38+16)|0);
      var $40=$39;
      HEAP8[($40)]=0; HEAP8[($40+1)]=0; HEAP8[($40+2)]=0; HEAP8[($40+3)]=0;
      __label__ = 3; break;
    case 3: // $41
      var $42=(($2+1252)|0);
      var $43=(($42)|0);
      HEAP8[($43)]=0;
      $i=0;
      __label__ = 4; break;
    case 4: // $44
      var $45=$i;
      var $46=$2;
      var $47=(($46+356)|0);
      var $48=$47;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+($45<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $54
      var $55=(($2+1252)|0);
      var $56=(($55)|0);
      var $57=$i;
      var $58=$2;
      var $59=(($58+356)|0);
      var $60=$59;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+($57<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      __Z23image_specify_extensionPcjPKc($56, 256, $66);
      __label__ = 6; break;
    case 6: // $67
      var $68=$i;
      var $69=(($68+1)|0);
      $i=$69;
      __label__ = 4; break;
    case 7: // $70
      var $71=$2;
      var $72=(($71+376)|0);
      var $73=$72;
      __ZN22device_image_interface12update_namesEv($73);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21cassette_image_device22device_config_completeEv["X"]=1;

function __ZN21cassette_image_device6updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cur_time;
      var $2=__stackBase__;
      var $new_position;
      var $length;
      $1=$this;
      var $3=$1;
      var $4=$3;
      var $5=(($4+376)|0);
      var $6=$5;
      var $7=__ZN16device_interface6deviceEv($6);
      var $8=__ZNK8device_t7machineEv($7);
      __ZNK15running_machine4timeEv($2, $8);
      var $9=__ZNK8attotime9as_doubleEv($2);
      $cur_time=$9;
      var $10=__ZN21cassette_image_device11is_motor_onEv($3);
      if ($10) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $11
      var $12=(($3+1232)|0);
      var $13=(tempDoubleI32[0]=HEAP32[(($12)>>2)],tempDoubleI32[1]=HEAP32[(($12+4)>>2)],tempDoubleF64[0]);
      var $14=$cur_time;
      var $15=(($3+1240)|0);
      var $16=(tempDoubleI32[0]=HEAP32[(($15)>>2)],tempDoubleI32[1]=HEAP32[(($15+4)>>2)],tempDoubleF64[0]);
      var $17=$14-$16;
      var $18=$13+$17;
      $new_position=$18;
      var $19=(($3+1228)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20 & 3;
      if ($21 == 2) {
        __label__ = 2; break;
      }
      else if ($21 == 1) {
        __label__ = 3; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 2: // $22
      var $23=(($3+1224)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($3+1232)|0);
      var $26=(tempDoubleI32[0]=HEAP32[(($25)>>2)],tempDoubleI32[1]=HEAP32[(($25+4)>>2)],tempDoubleF64[0]);
      var $27=$new_position;
      var $28=(($3+1232)|0);
      var $29=(tempDoubleI32[0]=HEAP32[(($28)>>2)],tempDoubleI32[1]=HEAP32[(($28+4)>>2)],tempDoubleF64[0]);
      var $30=$27-$29;
      var $31=(($3+1248)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__Z19cassette_put_sampleP15_cassette_imageiddi($24, 0, $26, $30, $32);
      __label__ = 8; break;
    case 3: // $34
      var $35=(($3+1224)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $38
      var $39=(($3+1224)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$new_position;
      var $42=(($3+1248)|0);
      var $43=__Z19cassette_get_sampleP15_cassette_imageiddPi($40, 0, $41, 0, $42);
      var $44=__ZN21cassette_image_device10get_lengthEv($3);
      $length=$44;
      var $45=$new_position;
      var $46=$length;
      var $47=$45 > $46;
      if ($47) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $48
      var $49=(($3+1228)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$50 & -4;
      var $52=(($3+1228)|0);
      HEAP32[(($52)>>2)]=$51;
      var $53=$length;
      $new_position=$53;
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      __label__ = 8; break;
    case 8: // $56
      var $57=$new_position;
      var $58=(($3+1232)|0);
      (tempDoubleF64[0]=$57,HEAP32[(($58)>>2)]=tempDoubleI32[0],HEAP32[(($58+4)>>2)]=tempDoubleI32[1]);
      __label__ = 9; break;
    case 9: // $59
      var $60=$cur_time;
      var $61=(($3+1240)|0);
      (tempDoubleF64[0]=$60,HEAP32[(($61)>>2)]=tempDoubleI32[0],HEAP32[(($61+4)>>2)]=tempDoubleI32[1]);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21cassette_image_device6updateEv["X"]=1;

function __ZN21cassette_image_device10get_lengthEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $info=__stackBase__;
  $1=$this;
  var $2=$1;
  var $3=(($2+1224)|0);
  var $4=HEAP32[(($3)>>2)];
  __Z17cassette_get_infoP15_cassette_imageP12CassetteInfo($4, $info);
  var $5=(($info+12)|0);
  var $6=HEAPU32[(($5)>>2)];
  var $7=(($6)>>>0);
  var $8=(($info+8)|0);
  var $9=HEAPU32[(($8)>>2)];
  var $10=(($9)>>>0);
  var $11=$7/$10;
  STACKTOP = __stackBase__;
  return $11;
}


function __Z14device_creatorI21cassette_image_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=1508;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str25380)|0);
      HEAP32[(($6)>>2)]=111;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21cassette_image_deviceC1ERK14machine_configPKcP8device_tj]($53, $54, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI21cassette_image_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str25380)|0);
      HEAP32[(($3)>>2)]=111;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14device_creatorI21cassette_image_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN21cassette_image_deviceC2ERK14machine_configPKcP8device_tj($this, $mconfig, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$mconfig;
      $3=$tag;
      $4=$owner;
      $5=$clock;
      var $8=$1;
      var $9=$8;
      var $10=$2;
      var $11=HEAP32[((_CASSETTE)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=$5;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($9, $10, $11, ((STRING_TABLE.__str5378)|0), $12, $13, $14);
      var $15=$8;
      var $16=(($15+356)|0);
      var $17=$16;
      var $18=$8;
      HEAP32[(($18)>>2)]=((__ZTV21cassette_image_device+8)|0);
      var $19=$8;
      var $20=(($19+376)|0);
      var $21=$20;
      HEAP32[(($21)>>2)]=((__ZTV21cassette_image_device+132)|0);
      var $22=$8;
      var $23=(($22+376)|0);
      var $24=$23;
      var $25=$2;
      var $26=$8;
      (function() { try { __THREW__ = false; return __ZN22device_image_interfaceC2ERK14machine_configR8device_t($24, $25, $26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      var $28=$8;
      HEAP32[(($28)>>2)]=((__ZTV21cassette_image_device+8)|0);
      var $29=$8;
      var $30=(($29+376)|0);
      var $31=$30;
      HEAP32[(($31)>>2)]=((__ZTV21cassette_image_device+132)|0);
      ;
      return;
    case 2: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $6=$34;
      var $35=$33.f1;
      $7=$35;
      var $36=$8;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $37
      __label__ = 4; break;
    case 4: // $38
      var $39=$6;
      var $40=$6;
      var $41=$7;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21cassette_image_deviceC2ERK14machine_configPKcP8device_tj["X"]=1;

function __ZN21cassette_image_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21cassette_image_deviceD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21cassette_image_deviceD0Ev["X"]=1;

function __ZN21cassette_image_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+376)|0);
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN22device_image_interfaceD2Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      __ZN8device_tD2Ev($9);
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=$4;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$2;
      var $19=$3;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK21cassette_image_device10image_typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 5;
}


function __ZNK21cassette_image_device11is_readableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNK21cassette_image_device12is_writeableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNK21cassette_image_device12is_creatableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNK21cassette_image_device14must_be_loadedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK21cassette_image_device16is_reset_on_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNK21cassette_image_device19create_option_guideEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZN21cassette_image_device12device_startEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1224)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=$2;
  var $5=(($4+356)|0);
  var $6=$5;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($2+1228)|0);
  HEAP32[(($9)>>2)]=$8;
  ;
  return;
}


function __ZN22device_image_interface11is_readonlyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+616)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZN22device_image_interface13make_readonlyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+616)|0);
  HEAP8[($3)]=1;
  ;
  return;
}


function __ZN21cassette_image_device9get_stateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1228)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK21cassette_image_device15image_interfaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+356)|0);
  var $5=$4;
  var $6=(($5+12)|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __ZNK21cassette_image_device15file_extensionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1252)|0);
  var $4=(($3)|0);
  ;
  return $4;
}


function __ZN21cassette_image_device12change_stateE15_cassette_stateS0_($this, $state, $mask) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $new_state;
      $1=$this;
      $2=$state;
      $3=$mask;
      var $4=$1;
      var $5=(($4+1228)|0);
      var $6=HEAP32[(($5)>>2)];
      $new_state=$6;
      var $7=$new_state;
      var $8=$3;
      var $9=$8 ^ -1;
      var $10=$7 & $9;
      $new_state=$10;
      var $11=$new_state;
      var $12=$2;
      var $13=$3;
      var $14=$12 & $13;
      var $15=$11 | $14;
      $new_state=$15;
      var $16=$new_state;
      var $17=(($4+1228)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($16)|0)!=(($18)|0);
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      __ZN21cassette_image_device6updateEv($4);
      var $21=$new_state;
      var $22=(($4+1228)|0);
      HEAP32[(($22)>>2)]=$21;
      __label__ = 2; break;
    case 2: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21cassette_image_device12get_positionEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $position;
      var $2=__stackBase__;
      $1=$this;
      var $3=$1;
      var $4=(($3+1232)|0);
      var $5=(tempDoubleI32[0]=HEAP32[(($4)>>2)],tempDoubleI32[1]=HEAP32[(($4+4)>>2)],tempDoubleF64[0]);
      $position=$5;
      var $6=__ZN21cassette_image_device11is_motor_onEv($3);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$3;
      var $9=(($8+376)|0);
      var $10=$9;
      var $11=__ZN16device_interface6deviceEv($10);
      var $12=__ZNK8device_t7machineEv($11);
      __ZNK15running_machine4timeEv($2, $12);
      var $13=__ZNK8attotime9as_doubleEv($2);
      var $14=(($3+1240)|0);
      var $15=(tempDoubleI32[0]=HEAP32[(($14)>>2)],tempDoubleI32[1]=HEAP32[(($14+4)>>2)],tempDoubleF64[0]);
      var $16=$13-$15;
      var $17=$position;
      var $18=$17+$16;
      $position=$18;
      __label__ = 2; break;
    case 2: // $19
      var $20=$position;
      STACKTOP = __stackBase__;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21cassette_image_device4seekEdi($this, $time, $origin) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $length;
      $1=$this;
      $2=$time;
      $3=$origin;
      var $4=$1;
      __ZN21cassette_image_device6updateEv($4);
      var $5=__ZN21cassette_image_device10get_lengthEv($4);
      $length=$5;
      var $6=$3;
      if ($6 == 0) {
        __label__ = 3; break;
      }
      else if ($6 == 2) {
        __label__ = 1; break;
      }
      else if ($6 == 1) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $7
      var $8=$length;
      var $9=$2;
      var $10=$9+$8;
      $2=$10;
      __label__ = 3; break;
    case 2: // $11
      var $12=__ZN21cassette_image_device12get_positionEv($4);
      var $13=$2;
      var $14=$13+$12;
      $2=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$2;
      var $17=$16 < 0;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      $2=0;
      __label__ = 8; break;
    case 5: // $19
      var $20=$2;
      var $21=$length;
      var $22=$20 > $21;
      if ($22) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $23
      var $24=$length;
      $2=$24;
      __label__ = 7; break;
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=$2;
      var $28=(($4+1232)|0);
      (tempDoubleF64[0]=$27,HEAP32[(($28)>>2)]=tempDoubleI32[0],HEAP32[(($28+4)>>2)]=tempDoubleI32[1]);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21cassette_image_device9call_loadEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $err;
      var $cassette_flags;
      var $extension;
      var $is_writable;
      var $image=__stackBase__;
      var $3=__stackBase__+4;
      $2=$this;
      var $4=$2;
      HEAP32[(($image)>>2)]=0;
      var $5=$4;
      var $6=__ZN8device_t9interfaceI22device_image_interfaceEEbRPT_($5, $image);
      var $7=$4;
      var $8=(($7+376)|0);
      var $9=$8;
      var $10=__ZN22device_image_interface16has_been_createdEv($9);
      if ($10) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $11
      var $12=HEAP32[(($image)>>2)];
      var $13=$12;
      var $14=$4;
      var $15=(($14+356)|0);
      var $16=$15;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($4+1224)|0);
      var $20=__Z15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_image($13, _image_ioprocs, _wavfile_format, $18, 2, $19);
      $err=$20;
      var $21=$err;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      __label__ = 16; break;
    case 3: // $24
      __label__ = 15; break;
    case 4: // $25
      __label__ = 5; break;
    case 5: // $26
      var $27=$4;
      var $28=(($27+376)|0);
      var $29=$28;
      var $30=__ZN22device_image_interface11is_readonlyEv($29);
      var $31=$30 ^ 1;
      var $32=(($31)&1);
      $is_writable=$32;
      var $33=$is_writable;
      var $34=(($33)|0)!=0;
      var $35=$34 ? 2 : 1;
      $cassette_flags=$35;
      var $36=$4;
      var $37=(($36+376)|0);
      var $38=$37;
      var $39=__ZN22device_image_interface8filetypeEv($38);
      $extension=$39;
      var $40=HEAP32[(($image)>>2)];
      var $41=$40;
      var $42=$extension;
      var $43=$4;
      var $44=(($43+356)|0);
      var $45=$44;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$cassette_flags;
      var $49=(($4+1224)|0);
      var $50=__Z21cassette_open_choicesPvPK8io_procsPKcPKPK14CassetteFormatiPP15_cassette_image($41, _image_ioprocs, $42, $47, $48, $49);
      $err=$50;
      var $51=$err;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $53
      var $54=$is_writable;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $56
      var $57=$4;
      var $58=(($57+376)|0);
      var $59=$58;
      __ZN22device_image_interface13make_readonlyEv($59);
      __label__ = 8; break;
    case 8: // $60
      __label__ = 9; break;
    case 9: // $61
      var $62=$err;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 10; break; } else { var $68 = 0;__label__ = 11; break; }
    case 10: // $64
      var $65=$is_writable;
      var $66=(($65)|0)!=0;
      var $68 = $66;__label__ = 11; break;
    case 11: // $67
      var $68;
      if ($68) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 12: // $69
      var $70=$err;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $72
      __label__ = 16; break;
    case 14: // $73
      __label__ = 15; break;
    case 15: // $74
      var $75=$4;
      var $76=(($75+356)|0);
      var $77=$76;
      var $78=(($77+8)|0);
      var $79=HEAP32[(($78)>>2)];
      __ZN21cassette_image_device12change_stateE15_cassette_stateS0_($4, $79, 3);
      var $80=(($4+1232)|0);
      (tempDoubleF64[0]=0,HEAP32[(($80)>>2)]=tempDoubleI32[0],HEAP32[(($80+4)>>2)]=tempDoubleI32[1]);
      var $81=$4;
      var $82=(($81+376)|0);
      var $83=$82;
      var $84=__ZN16device_interface6deviceEv($83);
      var $85=__ZNK8device_t7machineEv($84);
      __ZNK15running_machine4timeEv($3, $85);
      var $86=__ZNK8attotime9as_doubleEv($3);
      var $87=(($4+1240)|0);
      (tempDoubleF64[0]=$86,HEAP32[(($87)>>2)]=tempDoubleI32[0],HEAP32[(($87+4)>>2)]=tempDoubleI32[1]);
      $1=0;
      __label__ = 17; break;
    case 16: // $88
      $1=1;
      __label__ = 17; break;
    case 17: // $89
      var $90=$1;
      STACKTOP = __stackBase__;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21cassette_image_device9call_loadEv["X"]=1;

function __ZN22device_image_interface8filetypeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+280)|0);
      var $5=__ZN7astringcvbEv($4);
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      $1=0;
      __label__ = 3; break;
    case 2: // $7
      var $8=(($3+280)|0);
      var $9=__ZNK7astringcvPKcEv($8);
      $1=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$1;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn376_N21cassette_image_device9call_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZN21cassette_image_device9call_loadEv($5);
  ;
  return $6;
}


function __ZN21cassette_image_device11call_unloadEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+1228)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4 & 3;
      var $6=(($5)|0)==2;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __ZN21cassette_image_device6updateEv($2);
      __label__ = 2; break;
    case 2: // $8
      var $9=(($2+1224)|0);
      var $10=HEAP32[(($9)>>2)];
      __Z14cassette_closeP15_cassette_image($10);
      var $11=(($2+1224)|0);
      HEAP32[(($11)>>2)]=0;
      __ZN21cassette_image_device12change_stateE15_cassette_stateS0_($2, 0, 3);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn376_N21cassette_image_device11call_unloadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  __ZN21cassette_image_device11call_unloadEv($5);
  ;
  return;
}


function __ZN21cassette_image_device12call_displayEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $buf=__stackBase__;
      var $x;
      var $y;
      var $n;
      var $position;
      var $length;
      var $uistate;
      var $dev;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+376)|0);
      var $5=$4;
      var $6=__ZN22device_image_interface6existsEv($5);
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      __label__ = 10; break;
    case 2: // $8
      var $9=__ZN21cassette_image_device11is_motor_onEv($2);
      if ($9) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $10
      __label__ = 10; break;
    case 4: // $11
      var $12=__ZN21cassette_image_device12get_positionEv($2);
      $position=$12;
      var $13=__ZN21cassette_image_device10get_lengthEv($2);
      $length=$13;
      var $14=__ZN21cassette_image_device9get_stateEv($2);
      var $15=$14 & 3;
      $uistate=$15;
      $x=0.20000000298023224;
      $y=0.5;
      var $16=$2;
      var $17=(($16+376)|0);
      var $18=$17;
      var $19=__ZN16device_interface6deviceEv($18);
      var $20=__ZNK8device_t7machineEv($19);
      var $21=__ZNK15running_machine10devicelistEv($20);
      var $22=HEAP32[((_CASSETTE)>>2)];
      var $23=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($21, $22);
      $dev=$23;
      __label__ = 5; break;
    case 5: // $24
      var $25=$dev;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { var $38 = 0;__label__ = 7; break; }
    case 6: // $27
      var $28=$dev;
      var $29=__ZNK8device_t3tagEv($28);
      var $30=$2;
      var $31=(($30+376)|0);
      var $32=$31;
      var $33=__ZN16device_interface6deviceEv($32);
      var $34=__ZNK8device_t3tagEv($33);
      var $35=_strcmp($29, $34);
      var $36=(($35)|0)!=0;
      var $38 = $36;__label__ = 7; break;
    case 7: // $37
      var $38;
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      var $40=$y;
      var $41=$40+1;
      $y=$41;
      var $42=$dev;
      var $43=__ZNK8device_t8typenextEv($42);
      $dev=$43;
      __label__ = 5; break;
    case 9: // $44
      var $45=$2;
      var $46=(($45+376)|0);
      var $47=$46;
      var $48=__ZN16device_interface6deviceEv($47);
      var $49=__ZNK8device_t7machineEv($48);
      var $50=__Z18ui_get_line_heightR15running_machine($49);
      var $51=$50+0.019999999552965164;
      var $52=$y;
      var $53=$52*$51;
      $y=$53;
      var $54=$position;
      var $55=(($54)|0);
      var $56=(((($55)|0))|0);
      var $57=(($56)|0)%4;
      $n=$57;
      var $58=(($buf)|0);
      var $59=$n;
      var $60=((STRING_TABLE.__ZZN21cassette_image_device12call_displayEvE6shapes+$59)|0);
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=$n;
      var $64=$63 | 4;
      var $65=((STRING_TABLE.__ZZN21cassette_image_device12call_displayEvE6shapes+$64)|0);
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$uistate;
      var $69=(($68)|0)==1;
      var $70=$69 ? 80 : 82;
      var $71=$position;
      var $72=(($71)|0);
      var $73=(((($72)|0)/60)|0);
      var $74=$position;
      var $75=(($74)|0);
      var $76=(($75)|0)%60;
      var $77=$position;
      var $78=(($77)|0);
      var $79=$length;
      var $80=(($79)|0);
      var $81=(((($80)|0)/60)|0);
      var $82=$length;
      var $83=(($82)|0);
      var $84=(($83)|0)%60;
      var $85=$length;
      var $86=(($85)|0);
      var $87=_snprintf($58, 65, ((STRING_TABLE.__str15379)|0), (tempInt=STACKTOP,STACKTOP += 36,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$62,HEAP32[((tempInt+4)>>2)]=$67,HEAP32[((tempInt+8)>>2)]=$70,HEAP32[((tempInt+12)>>2)]=$73,HEAP32[((tempInt+16)>>2)]=$76,HEAP32[((tempInt+20)>>2)]=$78,HEAP32[((tempInt+24)>>2)]=$81,HEAP32[((tempInt+28)>>2)]=$84,HEAP32[((tempInt+32)>>2)]=$86,tempInt));
      var $88=$2;
      var $89=(($88+376)|0);
      var $90=$89;
      var $91=__ZN16device_interface6deviceEv($90);
      var $92=__ZNK8device_t7machineEv($91);
      var $93=__ZNK15running_machine6renderEv($92);
      var $94=__ZNK14render_manager12ui_containerEv($93);
      var $95=(($buf)|0);
      var $96=$x;
      var $97=$y;
      __Z16ui_draw_text_boxP16render_containerPKciffj($94, $95, 0, $96, $97, -284159952);
      __label__ = 10; break;
    case 10: // $98
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21cassette_image_device12call_displayEv["X"]=1;

function __ZThn376_N21cassette_image_device12call_displayEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  __ZN21cassette_image_device12call_displayEv($5);
  ;
  return;
}


function __ZN21cassette_image_device17call_display_infoEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+356)|0);
      var $5=$4;
      var $6=(($5+16)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10+356)|0);
      var $12=$11;
      var $13=(($12+16)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$2;
      var $16=(($15+376)|0);
      var $17=$16;
      FUNCTION_TABLE[$14]($17);
      __label__ = 2; break;
    case 2: // $18
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry($this, $swlist, $swname, $start_entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$swlist;
  $3=$swname;
  $4=$start_entry;
  var $5=$1;
  var $6=$5;
  var $7=(($6+376)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZN22device_image_interface13load_softwareEPcS0_P9rom_entry($8, $9, $10, $11);
  ;
  return $12;
}


function __ZThn376_N21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry($this, $swlist, $swname, $start_entry) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$swlist;
  $3=$swname;
  $4=$start_entry;
  var $5=$1;
  var $6=$5;
  var $7=(($6-376)|0);
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__ZN21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry($8, $9, $10, $11);
  ;
  return $12;
}


function __ZThn376_N21cassette_image_device17call_display_infoEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  __ZN21cassette_image_device17call_display_infoEv($5);
  ;
  return;
}


function __ZThn376_NK21cassette_image_device10image_typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device10image_typeEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device11is_readableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device11is_readableEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device12is_writeableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device12is_writeableEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device12is_creatableEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device12is_creatableEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device14must_be_loadedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device14must_be_loadedEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device16is_reset_on_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device16is_reset_on_loadEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device15image_interfaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device15image_interfaceEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device15file_extensionsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device15file_extensionsEv($5);
  ;
  return $6;
}


function __ZThn376_NK21cassette_image_device19create_option_guideEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-376)|0);
  var $5=$4;
  var $6=__ZNK21cassette_image_device19create_option_guideEv($5);
  ;
  return $6;
}


function __ZN20resource_pool_objectI21cassette_image_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI21cassette_image_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI21cassette_image_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1508);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI21cassette_image_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI21cassette_image_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI21cassette_image_deviceED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectI21cassette_image_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI21cassette_image_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI21cassette_image_deviceEEPT_S3_["X"]=1;
// Warning: Casting a function pointer type to another with a different number of arguments. See more info in the source (grep for this text). i32 (%class.device_image_interface.5682*)* ==> void ()*
// Warning: Casting a function pointer type to another with a different number of arguments. See more info in the source (grep for this text). void (%class.device_image_interface.5682*)* ==> void ()*

function __Z21bitbanger_mode_stringP8device_t($device) {
  ;
  var __label__;

  var $1;
  var $bi;
  $1=$device;
  var $2=$1;
  var $3=__ZL9get_tokenP8device_t5425($2);
  $bi=$3;
  var $4=$bi;
  var $5=(($4+52)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=((__ZZ21bitbanger_mode_stringP8device_tE5modes+($6<<2))|0);
  var $8=HEAP32[(($7)>>2)];
  ;
  return $8;
}


function __ZL9get_tokenP8device_t5425($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP18legacy_device_base8device_tET_PT0_($6);
      var $8=__ZNK18legacy_device_base5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18bitbanger_inc_modeP8device_tb($device, $test) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bi;
      var $adjust_mode;
      $2=$device;
      var $4=(($test)&1);
      $3=$4;
      var $5=$2;
      var $6=__ZL9get_tokenP8device_t5425($5);
      $bi=$6;
      var $7=$bi;
      var $8=(($7+52)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+1)|0);
      $adjust_mode=$10;
      var $11=$adjust_mode;
      var $12=(($11)|0) >= 2;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=0;
      __label__ = 5; break;
    case 2: // $14
      var $15=$3;
      var $16=(($15) & 1);
      if ($16) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $17
      var $18=$adjust_mode;
      var $19=$bi;
      var $20=(($19+52)|0);
      HEAP32[(($20)>>2)]=$18;
      __label__ = 4; break;
    case 4: // $21
      $1=1;
      __label__ = 5; break;
    case 5: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18bitbanger_dec_modeP8device_tb($device, $test) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bi;
      var $adjust_mode;
      $2=$device;
      var $4=(($test)&1);
      $3=$4;
      var $5=$2;
      var $6=__ZL9get_tokenP8device_t5425($5);
      $bi=$6;
      var $7=$bi;
      var $8=(($7+52)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9-1)|0);
      $adjust_mode=$10;
      var $11=$adjust_mode;
      var $12=(($11)|0) < 0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=0;
      __label__ = 5; break;
    case 2: // $14
      var $15=$3;
      var $16=(($15) & 1);
      if ($16) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $17
      var $18=$adjust_mode;
      var $19=$bi;
      var $20=(($19+52)|0);
      HEAP32[(($20)>>2)]=$18;
      __label__ = 4; break;
    case 4: // $21
      $1=1;
      __label__ = 5; break;
    case 5: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21bitbanger_tune_stringP8device_t($device) {
  ;
  var __label__;

  var $1;
  var $bi;
  $1=$device;
  var $2=$1;
  var $3=__ZL9get_tokenP8device_t5425($2);
  $bi=$3;
  var $4=$bi;
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=((__ZZ21bitbanger_tune_stringP8device_tE5tunes+($6<<2))|0);
  var $8=HEAP32[(($7)>>2)];
  ;
  return $8;
}


function __Z21bitbanger_baud_stringP8device_t($device) {
  ;
  var __label__;

  var $1;
  var $bi;
  $1=$device;
  var $2=$1;
  var $3=__ZL9get_tokenP8device_t5425($2);
  $bi=$3;
  var $4=$bi;
  var $5=(($4+56)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=((__ZZ21bitbanger_baud_stringP8device_tE5bauds+($6<<2))|0);
  var $8=HEAP32[(($7)>>2)];
  ;
  return $8;
}


function __Z18bitbanger_inc_baudP8device_tb($device, $test) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bi;
      var $adjust_baud;
      var $4=__stackBase__;
      $2=$device;
      var $5=(($test)&1);
      $3=$5;
      var $6=$2;
      var $7=__ZL9get_tokenP8device_t5425($6);
      $bi=$7;
      var $8=$bi;
      var $9=(($8+56)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+1)|0);
      $adjust_baud=$11;
      var $12=$adjust_baud;
      var $13=(($12)|0) >= 12;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      $1=0;
      __label__ = 5; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16) & 1);
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$adjust_baud;
      var $20=$bi;
      var $21=(($20+56)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$bi;
      var $23=(($22+32)|0);
      var $24=$2;
      var $25=__ZL20bitbanger_baud_valueP8device_t($24);
      var $26=(($25)>>>0);
      __ZN8attotime7from_hzEd($4, $26);
      var $27=$23;
      var $28=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];
      __label__ = 4; break;
    case 4: // $29
      $1=1;
      __label__ = 5; break;
    case 5: // $30
      var $31=$1;
      STACKTOP = __stackBase__;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20bitbanger_baud_valueP8device_t($device) {
  ;
  var __label__;

  var $1;
  var $bi;
  var $result;
  $1=$device;
  var $2=$1;
  var $3=__ZL9get_tokenP8device_t5425($2);
  $bi=$3;
  var $4=$1;
  var $5=__ZL20bitbanger_tune_valueP8device_t($4);
  var $6=$bi;
  var $7=(($6+56)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=((__ZZL20bitbanger_baud_valueP8device_tE5bauds+($8<<2))|0);
  var $10=HEAPF32[(($9)>>2)];
  var $11=$5*$10;
  $result=$11;
  var $12=$result;
  var $13=($12 >= 0 ? Math.floor($12) : Math.ceil($12));
  ;
  return $13;
}


function __Z18bitbanger_dec_baudP8device_tb($device, $test) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bi;
      var $adjust_baud;
      var $4=__stackBase__;
      $2=$device;
      var $5=(($test)&1);
      $3=$5;
      var $6=$2;
      var $7=__ZL9get_tokenP8device_t5425($6);
      $bi=$7;
      var $8=$bi;
      var $9=(($8+56)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10-1)|0);
      $adjust_baud=$11;
      var $12=$adjust_baud;
      var $13=(($12)|0) < 0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      $1=0;
      __label__ = 5; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16) & 1);
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$adjust_baud;
      var $20=$bi;
      var $21=(($20+56)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$bi;
      var $23=(($22+32)|0);
      var $24=$2;
      var $25=__ZL20bitbanger_baud_valueP8device_t($24);
      var $26=(($25)>>>0);
      __ZN8attotime7from_hzEd($4, $26);
      var $27=$23;
      var $28=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];
      __label__ = 4; break;
    case 4: // $29
      $1=1;
      __label__ = 5; break;
    case 5: // $30
      var $31=$1;
      STACKTOP = __stackBase__;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18bitbanger_inc_tuneP8device_tb($device, $test) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bi;
      var $adjust_tune;
      var $4=__stackBase__;
      $2=$device;
      var $5=(($test)&1);
      $3=$5;
      var $6=$2;
      var $7=__ZL9get_tokenP8device_t5425($6);
      $bi=$7;
      var $8=$bi;
      var $9=(($8+60)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+1)|0);
      $adjust_tune=$11;
      var $12=$adjust_tune;
      var $13=(($12)|0) >= 17;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      $1=0;
      __label__ = 5; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16) & 1);
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$adjust_tune;
      var $20=$bi;
      var $21=(($20+60)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$bi;
      var $23=(($22+32)|0);
      var $24=$2;
      var $25=__ZL20bitbanger_baud_valueP8device_t($24);
      var $26=(($25)>>>0);
      __ZN8attotime7from_hzEd($4, $26);
      var $27=$23;
      var $28=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];
      __label__ = 4; break;
    case 4: // $29
      $1=1;
      __label__ = 5; break;
    case 5: // $30
      var $31=$1;
      STACKTOP = __stackBase__;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18bitbanger_dec_tuneP8device_tb($device, $test) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bi;
      var $adjust_tune;
      var $4=__stackBase__;
      $2=$device;
      var $5=(($test)&1);
      $3=$5;
      var $6=$2;
      var $7=__ZL9get_tokenP8device_t5425($6);
      $bi=$7;
      var $8=$bi;
      var $9=(($8+60)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10-1)|0);
      $adjust_tune=$11;
      var $12=$adjust_tune;
      var $13=(($12)|0) < 0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      $1=0;
      __label__ = 5; break;
    case 2: // $15
      var $16=$3;
      var $17=(($16) & 1);
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$adjust_tune;
      var $20=$bi;
      var $21=(($20+60)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$bi;
      var $23=(($22+32)|0);
      var $24=$2;
      var $25=__ZL20bitbanger_baud_valueP8device_t($24);
      var $26=(($25)>>>0);
      __ZN8attotime7from_hzEd($4, $26);
      var $27=$23;
      var $28=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($27)>>2)]=HEAP32[(($28)>>2)];HEAP32[(($27+4)>>2)]=HEAP32[(($28+4)>>2)];HEAP32[(($27+8)>>2)]=HEAP32[(($28+8)>>2)];
      __label__ = 4; break;
    case 4: // $29
      $1=1;
      __label__ = 5; break;
    case 5: // $30
      var $31=$1;
      STACKTOP = __stackBase__;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z27device_get_config_bitbangerPK8device_tjP10deviceinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$2;
      if ($4 == 0) {
        __label__ = 1; break;
      }
      else if ($4 == 1) {
        __label__ = 2; break;
      }
      else if ($4 == 28673) {
        __label__ = 3; break;
      }
      else if ($4 == 28674) {
        __label__ = 4; break;
      }
      else if ($4 == 28675) {
        __label__ = 5; break;
      }
      else if ($4 == 28676) {
        __label__ = 6; break;
      }
      else if ($4 == 131072) {
        __label__ = 7; break;
      }
      else if ($4 == 159745) {
        __label__ = 8; break;
      }
      else if ($4 == 159747) {
        __label__ = 9; break;
      }
      else if ($4 == 196608) {
        __label__ = 10; break;
      }
      else if ($4 == 196610) {
        __label__ = 11; break;
      }
      else if ($4 == 196612) {
        __label__ = 12; break;
      }
      else if ($4 == 225281) {
        __label__ = 13; break;
      }
      else {
      __label__ = 14; break;
      }
      
    case 1: // $5
      var $6=$3;
      var $7=$6;
      var $$emscripten$temp$0$0=1064;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($7)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($7+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 14; break;
    case 2: // $8
      var $9=$3;
      var $10=$9;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($10)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($10+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 14; break;
    case 3: // $11
      var $12=$3;
      var $13=$12;
      var $$emscripten$temp$2$0=8;
      var $$emscripten$temp$2$1=0;
      var $st$4$0=(($13)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$2$0;
      var $st$4$1=(($13+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 14; break;
    case 4: // $14
      var $15=$3;
      var $16=$15;
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $st$4$0=(($16)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$3$0;
      var $st$4$1=(($16+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 14; break;
    case 5: // $17
      var $18=$3;
      var $19=$18;
      var $$emscripten$temp$4$0=1;
      var $$emscripten$temp$4$1=0;
      var $st$4$0=(($19)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$4$0;
      var $st$4$1=(($19+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 14; break;
    case 6: // $20
      var $21=$3;
      var $22=$21;
      var $$emscripten$temp$5$0=1;
      var $$emscripten$temp$5$1=0;
      var $st$4$0=(($22)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$5$0;
      var $st$4$1=(($22+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 14; break;
    case 7: // $23
      var $24=$3;
      var $25=$24;
      HEAP32[(($25)>>2)]=1138;
      __label__ = 14; break;
    case 8: // $26
      var $27=$3;
      var $28=$27;
      HEAP32[(($28)>>2)]=1140;
      __label__ = 14; break;
    case 9: // $29
      var $30=$3;
      var $31=$30;
      HEAP32[(($31)>>2)]=1142;
      __label__ = 14; break;
    case 10: // $32
      var $33=$3;
      var $34=$33;
      var $35=HEAP32[(($34)>>2)];
      var $36=_strcpy($35, ((STRING_TABLE.__str315412)|0));
      __label__ = 14; break;
    case 11: // $37
      var $38=$3;
      var $39=$38;
      var $40=HEAP32[(($39)>>2)];
      var $41=_strcpy($40, ((STRING_TABLE.__str315412)|0));
      __label__ = 14; break;
    case 12: // $42
      var $43=$3;
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=_strcpy($45, ((STRING_TABLE.__str325413)|0));
      __label__ = 14; break;
    case 13: // $47
      var $48=$3;
      var $49=$48;
      var $50=HEAP32[(($49)>>2)];
      var $51=_strcpy($50, ((STRING_TABLE.__str335414)|0));
      __label__ = 14; break;
    case 14: // $52
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z27device_get_config_bitbangerPK8device_tjP10deviceinfo["X"]=1;

function __ZL21device_load_bitbangerR22device_image_interface($image) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $device;
  var $bi;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  $1=$image;
  var $4=$1;
  var $5=$4;
  var $6=__ZN16device_interface6deviceEv($5);
  $device=$6;
  var $7=$device;
  var $8=__ZL9get_tokenP8device_t5425($7);
  $bi=$8;
  var $9=$bi;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=__ZN9emu_timer6enableEb($11, 1);
  var $13=$bi;
  var $14=(($13+4)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$2;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  __ZN8attotime12from_secondsEi($3, 1);
  __ZN9emu_timer6adjustE8attotimeiS0_($15, $2, 0, $3);
  STACKTOP = __stackBase__;
  return 0;
}


function __ZL23device_unload_bitbangerR22device_image_interface($image) {
  ;
  var __label__;

  var $1;
  var $device;
  var $bi;
  $1=$image;
  var $2=$1;
  var $3=$2;
  var $4=__ZN16device_interface6deviceEv($3);
  $device=$4;
  var $5=$device;
  var $6=__ZL9get_tokenP8device_t5425($5);
  $bi=$6;
  var $7=$bi;
  var $8=(($7+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__ZN9emu_timer6enableEb($9, 0);
  ;
  return;
}


function __ZN16bitbanger_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN24legacy_image_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($8, $9, $10, $11, $12, $13, 1150);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV16bitbanger_device+8)|0);
  var $15=$7;
  var $16=(($15+368)|0);
  var $17=$16;
  HEAP32[(($17)>>2)]=((__ZTV16bitbanger_device+148)|0);
  ;
  return;
}


function __ZN20resource_pool_objectI21cassette_image_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI21cassette_image_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI21cassette_image_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI21cassette_image_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI21cassette_image_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22device_start_bitbangerP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $bi;
      var $config;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      $1=$device;
      var $4=$1;
      var $5=__ZL10get_configP8device_t($4);
      $config=$5;
      var $6=$1;
      var $7=__ZL9get_tokenP8device_t5425($6);
      $bi=$7;
      var $8=$bi;
      var $9=(($8+12)|0);
      HEAP32[(($9)>>2)]=0;
      var $10=$1;
      var $11=__ZNK8device_t7machineEv($10);
      var $12=__ZN15running_machine9schedulerEv($11);
      var $13=$1;
      var $14=$13;
      var $15=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($12, 1146, ((STRING_TABLE.__str355418)|0), $14);
      var $16=$bi;
      var $17=(($16)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$1;
      var $19=__ZNK8device_t7machineEv($18);
      var $20=__ZN15running_machine9schedulerEv($19);
      var $21=$1;
      var $22=$21;
      var $23=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($20, 1148, ((STRING_TABLE.__str365419)|0), $22);
      var $24=$bi;
      var $25=(($24+4)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$bi;
      var $27=(($26+20)|0);
      __ZN8attotime12from_secondsEi($2, 1);
      var $28=$27;
      var $29=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($28)>>2)]=HEAP32[(($29)>>2)];HEAP32[(($28+4)>>2)]=HEAP32[(($29+4)>>2)];HEAP32[(($28+8)>>2)]=HEAP32[(($29+8)>>2)];
      var $30=$bi;
      var $31=(($30+44)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=$bi;
      var $33=(($32+48)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=$config;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$bi;
      var $38=(($37+52)|0);
      HEAP32[(($38)>>2)]=$36;
      var $39=$config;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$bi;
      var $43=(($42+56)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=$config;
      var $45=(($44+12)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$bi;
      var $48=(($47+60)|0);
      HEAP32[(($48)>>2)]=$46;
      var $49=$bi;
      var $50=(($49+32)|0);
      var $51=$1;
      var $52=__ZL20bitbanger_baud_valueP8device_t($51);
      var $53=(($52)>>>0);
      __ZN8attotime7from_hzEd($3, $53);
      var $54=$50;
      var $55=$3;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($54)>>2)]=HEAP32[(($55)>>2)];HEAP32[(($54+4)>>2)]=HEAP32[(($55+4)>>2)];HEAP32[(($54+8)>>2)]=HEAP32[(($55+8)>>2)];
      var $56=$config;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $60
      __Z10fatalerrorPKcz(((STRING_TABLE.__str375420)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 2: // $61
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22device_start_bitbangerP8device_t["X"]=1;

function __Z21legacy_device_creatorI16bitbanger_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=1216;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str345417)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16bitbanger_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 1144, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI16bitbanger_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str345417)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI16bitbanger_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN16bitbanger_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16bitbanger_deviceD2Ev($2);
  ;
  return;
}


function __ZThn368_N16bitbanger_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN16bitbanger_deviceD1Ev($5);
  ;
  return;
}


function __ZThn368_N16bitbanger_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN16bitbanger_deviceD0Ev($5);
  ;
  return;
}


function __ZN16bitbanger_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN24legacy_image_device_baseD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI16bitbanger_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16bitbanger_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16bitbanger_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 1216);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16bitbanger_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16bitbanger_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16bitbanger_deviceED2Ev($2);
  ;
  return;
}


function __ZL10get_configP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__ZNK8device_t13static_configEv($6);
      var $8=$7;
      ;
      return $8;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22bitbanger_output_timerR15running_machinePvi($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $bi;
      var $4=__stackBase__;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $5=$2;
      var $6=$5;
      $device=$6;
      var $7=$device;
      var $8=__ZL9get_tokenP8device_t5425($7);
      $bi=$8;
      var $9=$bi;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$bi;
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 | 512;
      HEAP32[(($15)>>2)]=$17;
      __label__ = 2; break;
    case 2: // $18
      var $19=$bi;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 >> 1;
      HEAP32[(($20)>>2)]=$22;
      var $23=$bi;
      var $24=(($23+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25-1)|0);
      HEAP32[(($24)>>2)]=$26;
      var $27=$bi;
      var $28=(($27+12)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $31
      var $32=$bi;
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)==1;
      if ($35) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $36
      var $37=$device;
      var $38=$bi;
      var $39=(($38+16)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40) & 255);
      __ZL13native_outputP8device_th($37, $41);
      __label__ = 6; break;
    case 5: // $42
      __Z8logerrorPKcz(((STRING_TABLE.__str415424)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 6; break;
    case 6: // $43
      var $44=$bi;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer5resetE8attotime($46, $4);
      __label__ = 7; break;
    case 7: // $48
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22bitbanger_output_timerR15running_machinePvi["X"]=1;

function __ZL21bitbanger_input_timerR15running_machinePvi($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 96; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $bi;
      var $config;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      var $6=__stackBase__+24;
      var $7=__stackBase__+36;
      var $8=__stackBase__+48;
      var $9=__stackBase__+60;
      var $10=__stackBase__+72;
      var $11=__stackBase__+84;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $12=$2;
      var $13=$12;
      $device=$13;
      var $14=$device;
      var $15=__ZL9get_tokenP8device_t5425($14);
      $bi=$15;
      var $16=$device;
      var $17=__ZL10get_configP8device_t($16);
      $config=$17;
      var $18=$bi;
      var $19=(($18+48)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$bi;
      var $22=(($21+44)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($20)|0)==(($23)|0);
      if ($24) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $25
      var $26=$device;
      __ZL27bitbanger_bytes_to_bits_81NP8device_t($26);
      var $27=$bi;
      var $28=(($27+44)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $31
      var $32=$bi;
      var $33=(($32+20)|0);
      var $34=$bi;
      var $35=(($34+20)|0);
      var $$emscripten$temp$0$0=100;
      var $$emscripten$temp$0$1=0;
      __ZN8attotime9from_msecEx($6, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __ZplRK8attotimeS1_($5, $35, $6);
      __ZN8attotime12from_secondsEi($7, 1);
      __Z3minRK8attotimeS1_($4, $5, $7);
      var $36=$33;
      var $37=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      var $38=$bi;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$bi;
      var $42=(($41+20)|0);
      var $43=$8;
      var $44=$42;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($43)>>2)]=HEAP32[(($44)>>2)];HEAP32[(($43+4)>>2)]=HEAP32[(($44+4)>>2)];HEAP32[(($43+8)>>2)]=HEAP32[(($44+8)>>2)];
      var $45=$9;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($45)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($45+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($45+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($40, $8, 0, $9);
      var $46=$bi;
      var $47=(($46+52)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)==1;
      if ($49) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $50
      var $51=$config;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$1;
      FUNCTION_TABLE[$53]($54, 1);
      __label__ = 5; break;
    case 4: // $55
      var $56=$config;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$1;
      FUNCTION_TABLE[$58]($59, 0);
      __label__ = 5; break;
    case 5: // $60
      __label__ = 9; break;
    case 6: // $61
      var $62=$bi;
      var $63=(($62+20)|0);
      var $64=$bi;
      var $65=(($64+32)|0);
      var $66=$63;
      var $67=$65;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($66)>>2)]=HEAP32[(($67)>>2)];HEAP32[(($66+4)>>2)]=HEAP32[(($67+4)>>2)];HEAP32[(($66+8)>>2)]=HEAP32[(($67+8)>>2)];
      var $68=$bi;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$bi;
      var $72=(($71+20)|0);
      var $73=$10;
      var $74=$72;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($73)>>2)]=HEAP32[(($74)>>2)];HEAP32[(($73+4)>>2)]=HEAP32[(($74+4)>>2)];HEAP32[(($73+8)>>2)]=HEAP32[(($74+8)>>2)];
      var $75=$bi;
      var $76=(($75+20)|0);
      var $77=$11;
      var $78=$76;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($77)>>2)]=HEAP32[(($78)>>2)];HEAP32[(($77+4)>>2)]=HEAP32[(($78+4)>>2)];HEAP32[(($77+8)>>2)]=HEAP32[(($78+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($70, $10, 0, $11);
      __label__ = 7; break;
    case 7: // $79
      __label__ = 8; break;
    case 8: // $80
      var $81=$config;
      var $82=(($81)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$1;
      var $85=$bi;
      var $86=(($85+48)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87+1)|0);
      HEAP32[(($86)>>2)]=$88;
      var $89=$bi;
      var $90=(($89+64)|0);
      var $91=(($90+$87)|0);
      var $92=HEAP8[($91)];
      FUNCTION_TABLE[$83]($84, $92);
      __label__ = 9; break;
    case 9: // $93
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21bitbanger_input_timerR15running_machinePvi["X"]=1;

function __ZL27bitbanger_bytes_to_bits_81NP8device_t($img) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $bi;
      var $byte_buffer=__stackBase__;
      var $byte_buffer_size;
      var $bit_buffer_size;
      var $i;
      var $j;
      $1=$img;
      var $2=$1;
      var $3=__ZL9get_tokenP8device_t5425($2);
      $bi=$3;
      $bit_buffer_size=0;
      var $4=$1;
      var $5=(($byte_buffer)|0);
      var $6=__ZL12native_inputP8device_tPvj($4, $5, 100);
      $byte_buffer_size=$6;
      $i=0;
      __label__ = 1; break;
    case 1: // $7
      var $8=$i;
      var $9=$byte_buffer_size;
      var $10=(($8)>>>0) < (($9)>>>0);
      if ($10) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $11
      var $12=$bit_buffer_size;
      var $13=(($12+1)|0);
      $bit_buffer_size=$13;
      var $14=$bi;
      var $15=(($14+64)|0);
      var $16=(($15+$12)|0);
      HEAP8[($16)]=0;
      $j=0;
      __label__ = 3; break;
    case 3: // $17
      var $18=$j;
      var $19=(($18)|0) < 8;
      if ($19) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $20
      var $21=$i;
      var $22=(($byte_buffer+$21)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$j;
      var $26=((STRING_TABLE.__ZZL27bitbanger_bytes_to_bits_81NP8device_tE7bitmask+$25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$24 & $28;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=$bit_buffer_size;
      var $33=(($32+1)|0);
      $bit_buffer_size=$33;
      var $34=$bi;
      var $35=(($34+64)|0);
      var $36=(($35+$32)|0);
      HEAP8[($36)]=1;
      __label__ = 7; break;
    case 6: // $37
      var $38=$bit_buffer_size;
      var $39=(($38+1)|0);
      $bit_buffer_size=$39;
      var $40=$bi;
      var $41=(($40+64)|0);
      var $42=(($41+$38)|0);
      HEAP8[($42)]=0;
      __label__ = 7; break;
    case 7: // $43
      __label__ = 8; break;
    case 8: // $44
      var $45=$j;
      var $46=(($45+1)|0);
      $j=$46;
      __label__ = 3; break;
    case 9: // $47
      var $48=$bit_buffer_size;
      var $49=(($48+1)|0);
      $bit_buffer_size=$49;
      var $50=$bi;
      var $51=(($50+64)|0);
      var $52=(($51+$48)|0);
      HEAP8[($52)]=1;
      __label__ = 10; break;
    case 10: // $53
      var $54=$i;
      var $55=(($54+1)|0);
      $i=$55;
      __label__ = 1; break;
    case 11: // $56
      var $57=$bit_buffer_size;
      var $58=$bi;
      var $59=(($58+44)|0);
      HEAP32[(($59)>>2)]=$57;
      var $60=$bi;
      var $61=(($60+48)|0);
      HEAP32[(($61)>>2)]=0;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27bitbanger_bytes_to_bits_81NP8device_t["X"]=1;

function __ZL12native_inputP8device_tPvj($bitbanger, $buffer, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $image;
      $2=$bitbanger;
      $3=$buffer;
      $4=$length;
      var $5=$2;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$5;
      var $9=___dynamic_cast($8, __ZTI8device_t, __ZTI22device_image_interface, -1);
      var $10=$9;
      var $13 = $10;__label__ = 3; break;
    case 2: // $11
      var $13 = 0;__label__ = 3; break;
    case 3: // $12
      var $13;
      $image=$13;
      var $14=$image;
      var $15=__ZN22device_image_interface6existsEv($14);
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      var $17=$image;
      var $18=$3;
      var $19=$4;
      var $20=__ZN22device_image_interface5freadEPvj($17, $18, $19);
      $1=$20;
      __label__ = 6; break;
    case 5: // $21
      $1=0;
      __label__ = 6; break;
    case 6: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13native_outputP8device_th($bitbanger, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $image;
      $1=$bitbanger;
      HEAP8[($2)]=$data;
      var $3=$1;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$3;
      var $7=___dynamic_cast($6, __ZTI8device_t, __ZTI22device_image_interface, -1);
      var $8=$7;
      var $11 = $8;__label__ = 3; break;
    case 2: // $9
      var $11 = 0;__label__ = 3; break;
    case 3: // $10
      var $11;
      $image=$11;
      var $12=$image;
      var $13=__ZN22device_image_interface6existsEv($12);
      if ($13) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $14
      var $15=$image;
      var $16=__ZN22device_image_interface6fwriteEPKvj($15, $2, 1);
      __label__ = 5; break;
    case 5: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN9emu_timer5resetE8attotime($this, $duration) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $duration; $duration = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($duration)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($duration+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($duration+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  $1=$this;
  var $4=$1;
  var $5=$2;
  var $6=$duration;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[(($6)>>2)];HEAP32[(($5+4)>>2)]=HEAP32[(($6+4)>>2)];HEAP32[(($5+8)>>2)]=HEAP32[(($6+8)>>2)];
  var $7=(($4+36)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($4+48)|0);
  var $10=$3;
  var $11=$9;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[(($11)>>2)];HEAP32[(($10+4)>>2)]=HEAP32[(($11+4)>>2)];HEAP32[(($10+8)>>2)]=HEAP32[(($11+8)>>2)];
  __ZN9emu_timer6adjustE8attotimeiS0_($4, $2, $8, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZL20bitbanger_tune_valueP8device_t($device) {
  ;
  var __label__;

  var $1;
  var $bi;
  $1=$device;
  var $2=$1;
  var $3=__ZL9get_tokenP8device_t5425($2);
  $bi=$3;
  var $4=$bi;
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=((__ZZL20bitbanger_tune_valueP8device_tE5tunes+($6<<2))|0);
  var $8=HEAPF32[(($7)>>2)];
  ;
  return $8;
}


function __ZL14get_safe_tokenP8device_t5459($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP18legacy_device_base8device_tET_PT0_($6);
      var $8=__ZNK18legacy_device_base5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16bitbanger_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN16bitbanger_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16bitbanger_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI16bitbanger_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16bitbanger_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16bitbanger_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI16bitbanger_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16bitbanger_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16bitbanger_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI16bitbanger_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI16bitbanger_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z24ldcore_set_video_squelchP16_laserdisc_stateh($ld, $squelch) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$ld;
  $2=$squelch;
  var $3=$2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+265)|0);
  HEAP8[($7)]=$3;
  ;
  return;
}


function __ZL19add_and_clamp_trackP12_ldcore_datai($ldcore, $delta) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$ldcore;
      $2=$delta;
      var $3=$2;
      var $4=$1;
      var $5=(($4+268)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+$3)|0);
      HEAP32[(($5)>>2)]=$7;
      var $8=$1;
      var $9=(($8+268)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0) > 1;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$1;
      var $14=(($13+268)|0);
      var $15=HEAP32[(($14)>>2)];
      var $18 = $15;__label__ = 3; break;
    case 2: // $16
      var $18 = 1;__label__ = 3; break;
    case 3: // $17
      var $18;
      var $19=$1;
      var $20=(($19+268)|0);
      HEAP32[(($20)>>2)]=$18;
      var $21=$1;
      var $22=(($21+268)|0);
      var $23=HEAPU32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+272)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26-1)|0);
      var $28=(($23)>>>0) < (($27)>>>0);
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $29
      var $30=$1;
      var $31=(($30+268)|0);
      var $32=HEAP32[(($31)>>2)];
      var $39 = $32;__label__ = 6; break;
    case 5: // $33
      var $34=$1;
      var $35=(($34+272)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36-1)|0);
      var $39 = $37;__label__ = 6; break;
    case 6: // $38
      var $39;
      var $40=$1;
      var $41=(($40+268)|0);
      HEAP32[(($41)>>2)]=$39;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z24laserdisc_get_field_codeP8device_tjh($device, $code, $zero_if_squelched) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $ld;
      var $ldcore;
      var $field;
      $2=$device;
      $3=$code;
      $4=$zero_if_squelched;
      var $5=$2;
      var $6=__ZL14get_safe_tokenP8device_t5459($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      $ldcore=$9;
      var $10=$ldcore;
      var $11=(($10+266)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      $field=$13;
      var $14=$4;
      var $15=(($14 << 24) >> 24)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $16
      var $17=$ldcore;
      var $18=(($17+265)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      $1=0;
      __label__ = 10; break;
    case 3: // $22
      var $23=$3;
      if ($23 == 11) {
        __label__ = 4; break;
      }
      else if ($23 == 16) {
        __label__ = 5; break;
      }
      else if ($23 == 17) {
        __label__ = 6; break;
      }
      else if ($23 == 18) {
        __label__ = 7; break;
      }
      else if ($23 == 1718) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 4: // $24
      var $25=$field;
      var $26=$ldcore;
      var $27=(($26+432)|0);
      var $28=(($27+$25*20)|0);
      var $29=(($28)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      $1=$31;
      __label__ = 10; break;
    case 5: // $32
      var $33=$field;
      var $34=$ldcore;
      var $35=(($34+432)|0);
      var $36=(($35+$33*20)|0);
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      $1=$38;
      __label__ = 10; break;
    case 6: // $39
      var $40=$field;
      var $41=$ldcore;
      var $42=(($41+432)|0);
      var $43=(($42+$40*20)|0);
      var $44=(($43+8)|0);
      var $45=HEAP32[(($44)>>2)];
      $1=$45;
      __label__ = 10; break;
    case 7: // $46
      var $47=$field;
      var $48=$ldcore;
      var $49=(($48+432)|0);
      var $50=(($49+$47*20)|0);
      var $51=(($50+12)|0);
      var $52=HEAP32[(($51)>>2)];
      $1=$52;
      __label__ = 10; break;
    case 8: // $53
      var $54=$field;
      var $55=$ldcore;
      var $56=(($55+432)|0);
      var $57=(($56+$54*20)|0);
      var $58=(($57+16)|0);
      var $59=HEAP32[(($58)>>2)];
      $1=$59;
      __label__ = 10; break;
    case 9: // $60
      $1=0;
      __label__ = 10; break;
    case 10: // $61
      var $62=$1;
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z24laserdisc_get_field_codeP8device_tjh["X"]=1;

function __Z21ldcore_get_safe_tokenP8device_t($device) {
  ;
  var __label__;

  var $1;
  $1=$device;
  var $2=$1;
  var $3=__ZL14get_safe_tokenP8device_t5459($2);
  ;
  return $3;
}


function __Z24ldcore_set_audio_squelchP16_laserdisc_statehh($ld, $squelchleft, $squelchright) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$ld;
  $2=$squelchleft;
  $3=$squelchright;
  var $4=$1;
  __ZL12update_audioP16_laserdisc_state($4);
  var $5=$2;
  var $6=(($5 << 24) >> 24)!=0;
  var $7=$6 ? 1 : 0;
  var $8=$3;
  var $9=(($8 << 24) >> 24)!=0;
  var $10=$9 ? 2 : 0;
  var $11=$7 | $10;
  var $12=(($11) & 255);
  var $13=$1;
  var $14=(($13+8)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+264)|0);
  HEAP8[($16)]=$12;
  ;
  return;
}


function __ZL12update_audioP16_laserdisc_state($ld) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ldcore;
      var $token;
      $1=$ld;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      $ldcore=$4;
      var $5=$ldcore;
      var $6=(($5+428)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$ldcore;
      var $11=(($10+428)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__Z8downcastIP18legacy_device_base8device_tET_PT0_($12);
      var $14=__ZNK18legacy_device_base5tokenEv($13);
      var $15=$14;
      $token=$15;
      var $16=$token;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      __ZN12sound_stream6updateEv($18);
      __label__ = 2; break;
    case 2: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z23ldcore_set_slider_speedP16_laserdisc_statei($ld, $tracks_per_vsync) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ldcore;
      var $vsyncperiod=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $5=__stackBase__+36;
      $1=$ld;
      $2=$tracks_per_vsync;
      var $6=$1;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      $ldcore=$8;
      var $9=$1;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      __ZNK13screen_device12frame_periodEv($vsyncperiod, $11);
      var $12=$ldcore;
      var $13=$1;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNK8device_t7machineEv($15);
      __ZNK15running_machine4timeEv($3, $16);
      __ZL17update_slider_posP12_ldcore_data8attotime($12, $3);
      var $17=$2;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$ldcore;
      var $21=(($20+276)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($21)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($21+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 6; break;
    case 2: // $22
      var $23=$2;
      var $24=(($23)|0) > 0;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$2;
      __ZdvRK8attotimej($4, $vsyncperiod, $26);
      var $27=__ZNK8attotime14as_attosecondsEv($4);
      var $27$0=$27[0];
      var $27$1=$27[1];
      var $28=$ldcore;
      var $29=(($28+276)|0);
      var $st$7$0=(($29)|0);
      HEAP32[(($st$7$0)>>2)]=$27$0;
      var $st$7$1=(($29+4)|0);
      HEAP32[(($st$7$1)>>2)]=$27$1;
      __label__ = 5; break;
    case 4: // $30
      var $31=$2;
      var $32=(((-$31))|0);
      __ZdvRK8attotimej($5, $vsyncperiod, $32);
      var $33=__ZNK8attotime14as_attosecondsEv($5);
      var $33$0=$33[0];
      var $33$1=$33[1];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $34$0 = ((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))-((($33$0)>>>0)+((($33$1)|0)*4294967296))>>>0; var $34$1 = Math.min(Math.floor((((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))-((($33$0)>>>0)+((($33$1)|0)*4294967296)))/4294967296), 4294967295);
      var $35=$ldcore;
      var $36=(($35+276)|0);
      var $st$11$0=(($36)|0);
      HEAP32[(($st$11$0)>>2)]=$34$0;
      var $st$11$1=(($36+4)|0);
      HEAP32[(($st$11$1)>>2)]=$34$1;
      __label__ = 5; break;
    case 5: // $37
      __label__ = 6; break;
    case 6: // $38
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z23ldcore_set_slider_speedP16_laserdisc_statei["X"]=1;

function __ZL17update_slider_posP12_ldcore_data8attotime($ldcore, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $delta=__stackBase__;
      var $2=__stackBase__+8;
      var $tracks_covered;
      var $3=__stackBase__+20;
      var $4=__stackBase__+32;
      $1=$ldcore;
      var $5=$1;
      var $6=(($5+276)|0);
      var $st$9$0=(($6)|0);
      var $7$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$9$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $8=$7$0 == $$emscripten$temp$0$0 && $7$1 == $$emscripten$temp$0$1;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+284)|0);
      var $12=$11;
      var $13=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
      __label__ = 10; break;
    case 2: // $14
      var $15=$1;
      var $16=(($15+284)|0);
      __ZmiRK8attotimeS1_($2, $curtime, $16);
      var $17=__ZNK8attotime14as_attosecondsEv($2);
      var $17$0=$17[0];
      var $17$1=$17[1];
      var $st$6$0=(($delta)|0);
      HEAP32[(($st$6$0)>>2)]=$17$0;
      var $st$6$1=(($delta+4)|0);
      HEAP32[(($st$6$1)>>2)]=$17$1;
      var $18=$1;
      var $19=(($18+276)|0);
      var $st$12$0=(($19)|0);
      var $20$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($19+4)|0);
      var $20$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $21=($20$1|0) >= ($$emscripten$temp$1$1|0) && (($20$1|0) >  ($$emscripten$temp$1$1|0) || ($20$0|0) >= ($$emscripten$temp$1$0|0));
      if ($21) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $22
      var $st$0$0=(($delta)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      var $24=$1;
      var $25=(($24+276)|0);
      var $st$6$0=(($25)|0);
      var $26$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$6$1)>>2)];
      var $27$0 = (tempBigIntR=((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($26$0)>>>0)+((($26$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $27$1 = Math.min(Math.floor(((tempBigIntR=((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($26$0)>>>0)+((($26$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $28$0=$27$0;
      var $28=$28$0;
      $tracks_covered=$28;
      var $29=$1;
      var $30=$tracks_covered;
      __ZL19add_and_clamp_trackP12_ldcore_datai($29, $30);
      var $31=$tracks_covered;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $33
      var $34=$1;
      var $35=(($34+284)|0);
      var $36=$tracks_covered;
      var $37$0=$36;
      var $37$1=(($36|0) < 0 ? -1 : 0);
      var $38=$1;
      var $39=(($38+276)|0);
      var $st$7$0=(($39)|0);
      var $40$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$7$1)>>2)];
      var $41$0 = ((($37$0)>>>0)+((($37$1)|0)*4294967296))*((($40$0)>>>0)+((($40$1)|0)*4294967296))>>>0; var $41$1 = Math.min(Math.floor((((($37$0)>>>0)+((($37$1)|0)*4294967296))*((($40$0)>>>0)+((($40$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($3, 0, $41$0, $41$1);
      var $42=__ZN8attotimepLERKS_($35, $3);
      __label__ = 5; break;
    case 5: // $43
      __label__ = 9; break;
    case 6: // $44
      var $st$0$0=(($delta)|0);
      var $45$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($delta+4)|0);
      var $45$1=HEAP32[(($st$0$1)>>2)];
      var $46=$1;
      var $47=(($46+276)|0);
      var $st$6$0=(($47)|0);
      var $48$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($47+4)|0);
      var $48$1=HEAP32[(($st$6$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $49$0 = ((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))-((($48$0)>>>0)+((($48$1)|0)*4294967296))>>>0; var $49$1 = Math.min(Math.floor((((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))-((($48$0)>>>0)+((($48$1)|0)*4294967296)))/4294967296), 4294967295);
      var $50$0 = (tempBigIntR=((($45$0)>>>0)+((($45$1)|0)*4294967296))/((($49$0)>>>0)+((($49$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $50$1 = Math.min(Math.floor(((tempBigIntR=((($45$0)>>>0)+((($45$1)|0)*4294967296))/((($49$0)>>>0)+((($49$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $51$0=$50$0;
      var $51=$51$0;
      $tracks_covered=$51;
      var $52=$1;
      var $53=$tracks_covered;
      var $54=(((-$53))|0);
      __ZL19add_and_clamp_trackP12_ldcore_datai($52, $54);
      var $55=$tracks_covered;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$1;
      var $59=(($58+284)|0);
      var $60=$tracks_covered;
      var $61$0=$60;
      var $61$1=(($60|0) < 0 ? -1 : 0);
      var $62=$1;
      var $63=(($62+276)|0);
      var $st$7$0=(($63)|0);
      var $64$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($63+4)|0);
      var $64$1=HEAP32[(($st$7$1)>>2)];
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $65$0 = ((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))-((($64$0)>>>0)+((($64$1)|0)*4294967296))>>>0; var $65$1 = Math.min(Math.floor((((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))-((($64$0)>>>0)+((($64$1)|0)*4294967296)))/4294967296), 4294967295);
      var $66$0 = ((($61$0)>>>0)+((($61$1)|0)*4294967296))*((($65$0)>>>0)+((($65$1)|0)*4294967296))>>>0; var $66$1 = Math.min(Math.floor((((($61$0)>>>0)+((($61$1)|0)*4294967296))*((($65$0)>>>0)+((($65$1)|0)*4294967296)))/4294967296), 4294967295);
      __ZN8attotimeC1Eix($4, 0, $66$0, $66$1);
      var $67=__ZN8attotimepLERKS_($59, $4);
      __label__ = 8; break;
    case 8: // $68
      __label__ = 9; break;
    case 9: // $69
      __label__ = 10; break;
    case 10: // $70
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17update_slider_posP12_ldcore_data8attotime["X"]=1;

function __Z21ldcore_advance_sliderP16_laserdisc_statei($ld, $numtracks) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $ldcore;
  var $3=__stackBase__;
  $1=$ld;
  $2=$numtracks;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  $ldcore=$6;
  var $7=$ldcore;
  var $8=$1;
  var $9=(($8)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=__ZNK8device_t7machineEv($10);
  __ZNK15running_machine4timeEv($3, $11);
  __ZL17update_slider_posP12_ldcore_data8attotime($7, $3);
  var $12=$ldcore;
  var $13=$2;
  __ZL19add_and_clamp_trackP12_ldcore_datai($12, $13);
  STACKTOP = __stackBase__;
  return;
}


function __Z26ldcore_get_slider_positionP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ldcore;
      var $3=__stackBase__;
      $2=$ld;
      var $4=$2;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      $ldcore=$6;
      var $7=$ldcore;
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__ZNK8device_t7machineEv($10);
      __ZNK15running_machine4timeEv($3, $11);
      __ZL17update_slider_posP12_ldcore_data8attotime($7, $3);
      var $12=$ldcore;
      var $13=(($12+268)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==1;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=0;
      __label__ = 11; break;
    case 2: // $17
      var $18=$ldcore;
      var $19=(($18+268)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0) < 900;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      $1=1;
      __label__ = 11; break;
    case 4: // $23
      var $24=$ldcore;
      var $25=(($24+268)|0);
      var $26=HEAPU32[(($25)>>2)];
      var $27=$ldcore;
      var $28=(($27+172)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+900)|0);
      var $31=(($26)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      $1=2;
      __label__ = 11; break;
    case 6: // $33
      var $34=$ldcore;
      var $35=(($34+268)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0) < 54900;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      $1=3;
      __label__ = 11; break;
    case 8: // $39
      var $40=$ldcore;
      var $41=(($40+268)|0);
      var $42=HEAPU32[(($41)>>2)];
      var $43=$ldcore;
      var $44=(($43+272)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-1)|0);
      var $47=(($42)>>>0) < (($46)>>>0);
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      $1=4;
      __label__ = 11; break;
    case 10: // $49
      $1=5;
      __label__ = 11; break;
    case 11: // $50
      var $51=$1;
      STACKTOP = __stackBase__;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26ldcore_get_slider_positionP16_laserdisc_state["X"]=1;

function __Z20laserdisc_get_configP8device_tP17_laserdisc_config($device, $config) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$device;
  $2=$config;
  var $3=$1;
  var $4=__ZL14get_safe_tokenP8device_t5459($3);
  $ld=$4;
  var $5=$2;
  var $6=$ld;
  var $7=(($6+8)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0);
  var $10=$5;
  var $11=$9;
  assert(68 % 1 === 0, 'memcpy given ' + 68 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $11>>2, $$dest = $10>>2, $$stop = $$src + 17; $$src < $$stop; $$src++, $$dest++) {
    HEAP32[$$dest] = HEAP32[$$src]
  };
  ;
  return;
}


function __Z20laserdisc_set_configP8device_tPK17_laserdisc_config($device, $config) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$device;
  $2=$config;
  var $3=$1;
  var $4=__ZL14get_safe_tokenP8device_t5459($3);
  $ld=$4;
  var $5=$ld;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7)|0);
  var $9=$2;
  var $10=$8;
  var $11=$9;
  assert(68 % 1 === 0, 'memcpy given ' + 68 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $11>>2, $$dest = $10>>2, $$stop = $$src + 17; $$src < $$stop; $$src++, $$dest++) {
    HEAP32[$$dest] = HEAP32[$$src]
  };
  ;
  return;
}


function __Z27device_get_config_laserdiscPK8device_tjP10deviceinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $intf;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$2;
      if ($4 == 0) {
        __label__ = 1; break;
      }
      else if ($4 == 1) {
        __label__ = 2; break;
      }
      else if ($4 == 65536) {
        __label__ = 3; break;
      }
      else if ($4 == 65537) {
        __label__ = 7; break;
      }
      else if ($4 == 131072) {
        __label__ = 11; break;
      }
      else if ($4 == 131073) {
        __label__ = 12; break;
      }
      else if ($4 == 131074) {
        __label__ = 13; break;
      }
      else if ($4 == 196608) {
        __label__ = 14; break;
      }
      else if ($4 == 196609) {
        __label__ = 18; break;
      }
      else if ($4 == 196610) {
        __label__ = 22; break;
      }
      else if ($4 == 196611) {
        __label__ = 23; break;
      }
      else if ($4 == 196612) {
        __label__ = 24; break;
      }
      else if ($4 == 196613) {
        __label__ = 25; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 1: // $5
      var $6=$3;
      var $7=$6;
      var $$emscripten$temp$0$0=64;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($7)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($7+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 26; break;
    case 2: // $8
      var $9=$3;
      var $10=$9;
      var $$emscripten$temp$1$0=68;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($10)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($10+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 26; break;
    case 3: // $11
      var $12=$1;
      var $13=__ZL13get_interfacePK8device_t($12);
      $intf=$13;
      var $14=$intf;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      var $17=$intf;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $22 = $19;__label__ = 6; break;
    case 5: // $20
      var $22 = 0;__label__ = 6; break;
    case 6: // $21
      var $22;
      var $23=$3;
      var $24=$23;
      HEAP32[(($24)>>2)]=$22;
      __label__ = 26; break;
    case 7: // $25
      var $26=$1;
      var $27=__ZL13get_interfacePK8device_t($26);
      $intf=$27;
      var $28=$intf;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $30
      var $31=$intf;
      var $32=(($31+20)|0);
      var $33=HEAP32[(($32)>>2)];
      var $36 = $33;__label__ = 10; break;
    case 9: // $34
      var $36 = 0;__label__ = 10; break;
    case 10: // $35
      var $36;
      var $37=$3;
      var $38=$37;
      HEAP32[(($38)>>2)]=$36;
      __label__ = 26; break;
    case 11: // $39
      var $40=$3;
      var $41=$40;
      HEAP32[(($41)>>2)]=1152;
      __label__ = 26; break;
    case 12: // $42
      var $43=$3;
      var $44=$43;
      HEAP32[(($44)>>2)]=1154;
      __label__ = 26; break;
    case 13: // $45
      var $46=$3;
      var $47=$46;
      HEAP32[(($47)>>2)]=1156;
      __label__ = 26; break;
    case 14: // $48
      var $49=$1;
      var $50=__ZL13get_interfacePK8device_t($49);
      $intf=$50;
      var $51=$3;
      var $52=$51;
      var $53=HEAP32[(($52)>>2)];
      var $54=$intf;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $56
      var $57=$intf;
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $62 = $59;__label__ = 17; break;
    case 16: // $60
      var $62 = ((STRING_TABLE.__str25430)|0);__label__ = 17; break;
    case 17: // $61
      var $62;
      var $63=_strcpy($53, $62);
      __label__ = 26; break;
    case 18: // $64
      var $65=$1;
      var $66=__ZL13get_interfacePK8device_t($65);
      $intf=$66;
      var $67=$3;
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=$intf;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $72
      var $73=$intf;
      var $74=(($73+12)|0);
      var $75=HEAP32[(($74)>>2)];
      var $78 = $75;__label__ = 21; break;
    case 20: // $76
      var $78 = ((STRING_TABLE.__str35431)|0);__label__ = 21; break;
    case 21: // $77
      var $78;
      var $79=_strcpy($69, $78);
      __label__ = 26; break;
    case 22: // $80
      var $81=$3;
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=_strcpy($83, ((STRING_TABLE.__str45432)|0));
      __label__ = 26; break;
    case 23: // $85
      var $86=$3;
      var $87=$86;
      var $88=HEAP32[(($87)>>2)];
      var $89=_strcpy($88, ((STRING_TABLE.__str55433)|0));
      __label__ = 26; break;
    case 24: // $90
      var $91=$3;
      var $92=$91;
      var $93=HEAP32[(($92)>>2)];
      var $94=_strcpy($93, ((STRING_TABLE.__str15427)|0));
      __label__ = 26; break;
    case 25: // $95
      var $96=$3;
      var $97=$96;
      var $98=HEAP32[(($97)>>2)];
      var $99=_strcpy($98, ((STRING_TABLE.__str65434)|0));
      __label__ = 26; break;
    case 26: // $100
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z27device_get_config_laserdiscPK8device_tjP10deviceinfo["X"]=1;

function __ZL13get_interfacePK8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $config;
      var $pltype;
      $2=$device;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 11; break;
    case 2: // $6
      var $7=$2;
      var $8=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($7);
      var $9=__ZNK18legacy_device_base13inline_configEv($8);
      var $10=$9;
      $config=$10;
      var $11=$config;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $1=0;
      __label__ = 11; break;
    case 4: // $14
      $pltype=0;
      __label__ = 5; break;
    case 5: // $15
      var $16=$pltype;
      var $17=(($16)>>>0) < 4;
      if ($17) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $18
      var $19=$pltype;
      var $20=((__ZL17player_interfaces+($19<<2))|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$config;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($23)|0)==(($26)|0);
      if ($27) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $28
      var $29=$pltype;
      var $30=((__ZL17player_interfaces+($29<<2))|0);
      var $31=HEAP32[(($30)>>2)];
      $1=$31;
      __label__ = 11; break;
    case 8: // $32
      __label__ = 9; break;
    case 9: // $33
      var $34=$pltype;
      var $35=(($34+1)|0);
      $pltype=$35;
      __label__ = 5; break;
    case 10: // $36
      $1=0;
      __label__ = 11; break;
    case 11: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21device_stop_laserdiscP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ld;
      var $ldcore;
      $1=$device;
      var $2=$1;
      var $3=__ZL14get_safe_tokenP8device_t5459($2);
      $ld=$3;
      var $4=$ld;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      $ldcore=$6;
      var $7=$ldcore;
      var $8=(($7+144)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$ldcore;
      var $13=(($12+144)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z18chd_async_completeP9_chd_file($14);
      __label__ = 2; break;
    case 2: // $16
      var $17=$1;
      var $18=__ZNK8device_t7machineEv($17);
      var $19=__ZNK15running_machine6renderEv($18);
      var $20=$ldcore;
      var $21=(($20+484)|0);
      var $22=HEAP32[(($21)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($19, $22);
      var $23=$ldcore;
      var $24=(($23+488)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      var $28=$ldcore;
      var $29=(($28+488)|0);
      var $30=HEAP32[(($29)>>2)];
      __Z13palette_derefP10_palette_t($30);
      __label__ = 4; break;
    case 4: // $31
      var $32=$1;
      var $33=__ZNK8device_t7machineEv($32);
      var $34=__ZNK15running_machine6renderEv($33);
      var $35=$ldcore;
      var $36=(($35+508)|0);
      var $37=HEAP32[(($36)>>2)];
      __ZN14render_manager12texture_freeEP14render_texture($34, $37);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16laserdisc_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($8, $9, $10, $11, $12, $13, 1164);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV16laserdisc_device+8)|0);
  ;
  return;
}


function __ZN16laserdisc_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16laserdisc_deviceD2Ev($2);
  ;
  return;
}


function __ZL22device_start_laserdiscP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 120; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i1=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17;
      var $config;
      var $ld;
      var $ldcore;
      var $statesize;
      var $index;
      var $18;
      var $19;
      var $20=__stackBase__+72;
      var $21=__stackBase__+96;
      $17=$device;
      var $22=$17;
      var $23=__Z8downcastIPK18legacy_device_base8device_tET_PT0_($22);
      var $24=__ZNK18legacy_device_base13inline_configEv($23);
      var $25=$24;
      $config=$25;
      var $26=$17;
      var $27=__ZL14get_safe_tokenP8device_t5459($26);
      $ld=$27;
      var $28=$17;
      var $29=__ZNK8device_t7machineEv($28);
      var $30=$config;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__ZN15running_machine6deviceEPKc($29, $32);
      var $34=__Z8downcastIP13screen_device8device_tET_PT0_($33);
      var $35=$ld;
      var $36=(($35+4)|0);
      HEAP32[(($36)>>2)]=$34;
      __label__ = 1; break;
    case 1: // $37
      __label__ = 2; break;
    case 2: // $38
      var $39=$ld;
      var $40=(($39+4)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$41;
      var $43=__ZNK8device_t7startedEv($42);
      if ($43) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $44
      var $45=___cxa_allocate_exception(4);
      var $46=$45;
      var $47=$46;
      HEAP32[(($47)>>2)]=0;
      __ZN27device_missing_dependenciesC1Ev($46);
      ___cxa_throw($45, __ZTI27device_missing_dependencies, 232);
      throw "Reached an unreachable!"
    case 4: // $48
      var $49=$17;
      var $50=$ld;
      var $51=(($50)|0);
      HEAP32[(($51)>>2)]=$49;
      var $52=$17;
      var $53=__ZNK8device_t7machineEv($52);
      var $54=__ZN15running_machine7respoolEv($53);
      var $55=$11;
      var $56=$12;
      var $57=$13;
      var $58=$14;
      var $59=$result_i;
      var $60=$15;
      var $61=$16;
      HEAP32[(($11)>>2)]=512;
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($13)>>2)]=1491;
      HEAP32[(($14)>>2)]=_zeromem;
      var $62=HEAP32[(($11)>>2)];
      var $63=HEAP32[(($12)>>2)];
      var $64=HEAP32[(($13)>>2)];
      var $65=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($62, $63, $64) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $66
      HEAP32[(($result_i)>>2)]=$65;
      var $67=HEAP32[(($result_i)>>2)];
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $69
      var $70=___cxa_allocate_exception(4);
      var $71=$70;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($71);
      (function() { try { __THREW__ = false; return ___cxa_throw($70, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $72
      var $73=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $74=$73.f0;
      HEAP32[(($15)>>2)]=$74;
      var $75=$73.f1;
      HEAP32[(($16)>>2)]=$75;
      var $76=HEAP32[(($16)>>2)];
      var $77=(($76)|0) < 0;
      if ($77) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $78
      var $79=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($79);
      throw "Reached an unreachable!"
    case 9: // $80
      var $81=HEAP32[(($15)>>2)];
      var $82=HEAP32[(($15)>>2)];
      var $83=HEAP32[(($16)>>2)];
      var $84=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $82, tempValue);
      var $85=($84.f1 = $83, $84);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $86
      throw "Reached an unreachable!"
    case 11: // $_ZnwjPKciRK9zeromem_t_exit
      var $87=HEAP32[(($result_i)>>2)];
      var $88=HEAP32[(($11)>>2)];
      _memset($87, 0, $88, 1);
      var $89=HEAPU32[(($result_i)>>2)];
      var $90=$11;
      var $91=$12;
      var $92=$13;
      var $93=$14;
      var $94=$result_i;
      var $95=$15;
      var $96=$16;
      var $97=$89;
      (function() { try { __THREW__ = false; return __ZN12_ldcore_dataC1Ev($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 19; break; }
    case 12: // $98
      var $99=__ZN13resource_pool10add_objectI12_ldcore_dataEEPT_S3_($54, $97);
      var $100=$ld;
      var $101=(($100+8)|0);
      HEAP32[(($101)>>2)]=$99;
      var $102=$ld;
      var $103=(($102+8)|0);
      var $104=HEAP32[(($103)>>2)];
      $ldcore=$104;
      $statesize=0;
      $index=0;
      __label__ = 13; break;
    case 13: // $105
      var $106=$index;
      var $107=(($106)>>>0) < 4;
      if ($107) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $108
      var $109=$statesize;
      var $110=$index;
      var $111=((__ZL17player_interfaces+($110<<2))|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112+4)|0);
      var $114=HEAPU32[(($113)>>2)];
      var $115=(($109)>>>0) > (($114)>>>0);
      if ($115) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $116
      var $117=$statesize;
      var $125 = $117;__label__ = 17; break;
    case 16: // $118
      var $119=$index;
      var $120=((__ZL17player_interfaces+($119<<2))|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+4)|0);
      var $123=HEAP32[(($122)>>2)];
      var $125 = $123;__label__ = 17; break;
    case 17: // $124
      var $125;
      $statesize=$125;
      __label__ = 18; break;
    case 18: // $126
      var $127=$index;
      var $128=(($127+1)|0);
      $index=$128;
      __label__ = 13; break;
    case 19: // $129
      var $130=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $131=$130.f0;
      $18=$131;
      var $132=$130.f1;
      $19=$132;
      var $133=$7;
      var $134=$8;
      var $135=$9;
      var $136=$10;
      HEAP32[(($7)>>2)]=$89;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($9)>>2)]=1491;
      HEAP32[(($10)>>2)]=_zeromem;
      var $137=HEAP32[(($7)>>2)];
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $139
      var $140=HEAP32[(($7)>>2)];
      var $141=HEAP32[(($8)>>2)];
      var $142=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($140, $141, $142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 40; break; }
    case 21: // $_noexc
      __label__ = 22; break;
    case 22: // $_ZdlPvPKciRK9zeromem_t_exit
      var $143=$7;
      var $144=$8;
      var $145=$9;
      var $146=$10;
      __label__ = 23; break;
    case 23: // $147
      __label__ = 39; break;
    case 24: // $148
      var $149=$17;
      var $150=__ZNK8device_t7machineEv($149);
      var $151=__ZN15running_machine7respoolEv($150);
      var $152=$statesize;
      var $153=(($152)|0) < 0;
      var $154=$153 ? -1 : $152;
      var $155=$1;
      var $156=$2;
      var $157=$3;
      var $158=$4;
      var $159=$result_i1;
      var $160=$5;
      var $161=$6;
      HEAP32[(($1)>>2)]=$154;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($3)>>2)]=1498;
      HEAP32[(($4)>>2)]=_zeromem;
      var $162=HEAP32[(($1)>>2)];
      var $163=HEAP32[(($2)>>2)];
      var $164=HEAP32[(($3)>>2)];
      var $165=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($162, $163, $164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 27; break; };
    case 25: // $166
      HEAP32[(($result_i1)>>2)]=$165;
      var $167=HEAP32[(($result_i1)>>2)];
      var $168=(($167)|0)==0;
      if ($168) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $169
      var $170=___cxa_allocate_exception(4);
      var $171=$170;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($171);
      (function() { try { __THREW__ = false; return ___cxa_throw($170, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 27; break; }
    case 27: // $172
      var $173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $174=$173.f0;
      HEAP32[(($5)>>2)]=$174;
      var $175=$173.f1;
      HEAP32[(($6)>>2)]=$175;
      var $176=HEAP32[(($6)>>2)];
      var $177=(($176)|0) < 0;
      if ($177) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $178
      var $179=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($179);
      throw "Reached an unreachable!"
    case 29: // $180
      var $181=HEAP32[(($5)>>2)];
      var $182=HEAP32[(($5)>>2)];
      var $183=HEAP32[(($6)>>2)];
      var $184=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $182, tempValue);
      var $185=($184.f1 = $183, $184);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $186
      throw "Reached an unreachable!"
    case 31: // $_ZnajPKciRK9zeromem_t_exit
      var $187=HEAP32[(($result_i1)>>2)];
      var $188=HEAP32[(($1)>>2)];
      _memset($187, 0, $188, 1);
      var $189=HEAP32[(($result_i1)>>2)];
      var $190=$1;
      var $191=$2;
      var $192=$3;
      var $193=$4;
      var $194=$result_i1;
      var $195=$5;
      var $196=$6;
      var $197=$statesize;
      var $198=__ZN13resource_pool9add_arrayIhEEPT_S2_i($151, $189, $197);
      var $199=$198;
      var $200=$ld;
      var $201=(($200+12)|0);
      HEAP32[(($201)>>2)]=$199;
      var $202=$ldcore;
      var $203=(($202)|0);
      var $204=$config;
      var $205=$203;
      var $206=$204;
      assert(68 % 1 === 0, 'memcpy given ' + 68 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $206>>2, $$dest = $205>>2, $$stop = $$src + 17; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $207=$ldcore;
      var $208=(($207)|0);
      var $209=(($208+36)|0);
      var $210=(($209+4)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=$ldcore;
      var $213=(($212)|0);
      var $214=(($213+36)|0);
      var $215=(($214)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($211)|0)==(($216)|0);
      if ($217) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $218
      var $219=$ldcore;
      var $220=(($219)|0);
      var $221=(($220+36)|0);
      var $222=(($221+12)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=$ldcore;
      var $225=(($224)|0);
      var $226=(($225+36)|0);
      var $227=(($226+8)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=(($223)|0)==(($228)|0);
      if ($229) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $230
      var $231=$ldcore;
      var $232=(($231)|0);
      var $233=(($232+36)|0);
      var $234=(($233+8)|0);
      HEAP32[(($234)>>2)]=0;
      var $235=$ldcore;
      var $236=(($235)|0);
      var $237=(($236+36)|0);
      var $238=(($237)|0);
      HEAP32[(($238)>>2)]=0;
      var $239=$ldcore;
      var $240=(($239)|0);
      var $241=(($240+24)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242-1)|0);
      var $244=$ldcore;
      var $245=(($244)|0);
      var $246=(($245+36)|0);
      var $247=(($246+4)|0);
      HEAP32[(($247)>>2)]=$243;
      var $248=$ldcore;
      var $249=(($248)|0);
      var $250=(($249+28)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($251-1)|0);
      var $253=$ldcore;
      var $254=(($253)|0);
      var $255=(($254+36)|0);
      var $256=(($255+12)|0);
      HEAP32[(($256)>>2)]=$252;
      __label__ = 34; break;
    case 34: // $257
      var $258=$ldcore;
      var $259=(($258)|0);
      var $260=(($259+60)|0);
      var $261=HEAPF32[(($260)>>2)];
      var $262=$261 == 0;
      if ($262) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $263
      var $264=$ldcore;
      var $265=(($264)|0);
      var $266=(($265+60)|0);
      HEAPF32[(($266)>>2)]=1;
      __label__ = 36; break;
    case 36: // $267
      var $268=$ldcore;
      var $269=(($268)|0);
      var $270=(($269+64)|0);
      var $271=HEAPF32[(($270)>>2)];
      var $272=$271 == 0;
      if ($272) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $273
      var $274=$ldcore;
      var $275=(($274)|0);
      var $276=(($275+64)|0);
      HEAPF32[(($276)>>2)]=1;
      __label__ = 38; break;
    case 38: // $277
      var $278=$17;
      __ZL9init_discP8device_t($278);
      var $279=$17;
      __ZL10init_videoP8device_t($279);
      var $280=$17;
      __ZL10init_audioP8device_t($280);
      var $281=$17;
      var $282=__ZNK8device_t7machineEv($281);
      var $283=$17;
      var $284=__ZNK8device_t7machineEv($283);
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($20, 1160, ((STRING_TABLE.__str105438)|0), $284);
      var $285=$17;
      var $286=__ZNK8device_t7machineEv($285);
      __ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_($21, 1162, ((STRING_TABLE.__str115439)|0), $286);
      __Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_($282, ((STRING_TABLE.__str95437)|0), $20, $21);
      STACKTOP = __stackBase__;
      return;
    case 39: // $287
      var $288=$18;
      var $289=$18;
      var $290=$19;
      var $291=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $289, tempValue);
      var $292=($291.f1 = $290, $291);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 40: // $293
      var $294=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22device_start_laserdiscP8device_t["X"]=1;

function __ZL22device_reset_laserdiscP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ld;
      var $curtime=__stackBase__;
      var $ldcore;
      var $pltype;
      var $line;
      var $token;
      $1=$device;
      var $2=$1;
      var $3=__ZL14get_safe_tokenP8device_t5459($2);
      $ld=$3;
      var $4=$1;
      var $5=__ZNK8device_t7machineEv($4);
      __ZNK15running_machine4timeEv($curtime, $5);
      var $6=$ld;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      $ldcore=$8;
      $pltype=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$pltype;
      var $11=(($10)>>>0) < 4;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$pltype;
      var $14=((__ZL17player_interfaces+($13<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$ldcore;
      var $19=(($18)|0);
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($17)|0)==(($21)|0);
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      __label__ = 6; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$pltype;
      var $27=(($26+1)|0);
      $pltype=$27;
      __label__ = 1; break;
    case 6: // $28
      var $29=$pltype;
      var $30=(($29)|0)==4;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$ldcore;
      var $33=(($32)|0);
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      __Z10fatalerrorPKcz(((STRING_TABLE.__str85436)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$35,tempInt));
      throw "Reached an unreachable!"
    case 8: // $36
      var $37=$ldcore;
      var $38=(($37+68)|0);
      var $39=$pltype;
      var $40=((__ZL17player_interfaces+($39<<2))|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$38;
      var $43=$41;
      assert(76 % 1 === 0, 'memcpy given ' + 76 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $43>>2, $$dest = $42>>2, $$stop = $$src + 19; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $44=$ldcore;
      var $45=(($44+428)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      var $49=$ldcore;
      var $50=(($49+428)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=__Z8downcastIP18legacy_device_base8device_tET_PT0_($51);
      var $53=__ZNK18legacy_device_base5tokenEv($52);
      var $54=$53;
      $token=$54;
      var $55=$ld;
      var $56=$token;
      var $57=(($56+4)|0);
      HEAP32[(($57)>>2)]=$55;
      var $58=$token;
      var $59=(($58)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$ldcore;
      var $62=(($61+164)|0);
      var $63=HEAP32[(($62)>>2)];
      __ZN12sound_stream15set_sample_rateEi($60, $63);
      __label__ = 10; break;
    case 10: // $64
      var $65=$ldcore;
      var $66=(($65+264)|0);
      HEAP8[($66)]=3;
      var $67=$ldcore;
      var $68=(($67+265)|0);
      HEAP8[($68)]=1;
      var $69=$ldcore;
      var $70=(($69+266)|0);
      HEAP8[($70)]=0;
      var $71=$ldcore;
      var $72=(($71+268)|0);
      HEAP32[(($72)>>2)]=1;
      var $73=$ldcore;
      var $74=(($73+276)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$16$0=(($74)|0);
      HEAP32[(($st$16$0)>>2)]=$$emscripten$temp$0$0;
      var $st$16$1=(($74+4)|0);
      HEAP32[(($st$16$1)>>2)]=$$emscripten$temp$0$1;
      var $75=$ldcore;
      var $76=(($75+284)|0);
      var $77=$76;
      var $78=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($77)>>2)]=HEAP32[(($78)>>2)];HEAP32[(($77+4)>>2)]=HEAP32[(($78+4)>>2)];HEAP32[(($77+8)>>2)]=HEAP32[(($78+8)>>2)];
      $line=0;
      __label__ = 11; break;
    case 11: // $79
      var $80=$line;
      var $81=(($80)|0) < 3;
      if ($81) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $82
      var $83=$line;
      var $84=$ldcore;
      var $85=(($84+473)|0);
      var $86=(($85+$83)|0);
      HEAP8[($86)]=0;
      __label__ = 13; break;
    case 13: // $87
      var $88=$line;
      var $89=(($88+1)|0);
      $line=$89;
      __label__ = 11; break;
    case 14: // $90
      $line=0;
      __label__ = 15; break;
    case 15: // $91
      var $92=$line;
      var $93=(($92)|0) < 4;
      if ($93) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $94
      var $95=$line;
      var $96=$ldcore;
      var $97=(($96+477)|0);
      var $98=(($97+$95)|0);
      HEAP8[($98)]=0;
      __label__ = 17; break;
    case 17: // $99
      var $100=$line;
      var $101=(($100+1)|0);
      $line=$101;
      __label__ = 15; break;
    case 18: // $102
      var $103=$ldcore;
      var $104=(($103+68)|0);
      var $105=(($104+24)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $108
      var $109=$ldcore;
      var $110=(($109+68)|0);
      var $111=(($110+24)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$ld;
      FUNCTION_TABLE[$112]($113);
      __label__ = 20; break;
    case 20: // $114
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22device_reset_laserdiscP8device_t["X"]=1;

function __Z21legacy_device_creatorI16laserdisc_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=368;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str75435)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16laserdisc_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 1158, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI16laserdisc_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str75435)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI16laserdisc_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN16laserdisc_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN18legacy_device_baseD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI16laserdisc_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI16laserdisc_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI16laserdisc_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 368);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI16laserdisc_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI16laserdisc_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI16laserdisc_deviceED2Ev($2);
  ;
  return;
}


function __ZN12_ldcore_dataC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12_ldcore_dataC2Ev($2);
  ;
  return;
}


function __ZN16laserdisc_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN16laserdisc_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16laserdisc_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI16laserdisc_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16laserdisc_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI16laserdisc_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI16laserdisc_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI16laserdisc_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI16laserdisc_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI16laserdisc_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI16laserdisc_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13resource_pool10add_objectI12_ldcore_dataEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12_ldcore_dataEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI12_ldcore_dataEEPT_S3_["X"]=1;

function __ZL9init_discP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 300; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $config;
      var $ld;
      var $ldcore;
      var $err;
      var $totalhunks;
      var $fps=__stackBase__+24;
      var $fpsfrac=__stackBase__+28;
      var $interlaced=__stackBase__+32;
      var $channels=__stackBase__+36;
      var $metadata=__stackBase__+40;
      var $vbilength=__stackBase__+296;
      $6=$device;
      var $7=$6;
      var $8=__Z8downcastIPK18legacy_device_base8device_tET_PT0_($7);
      var $9=__ZNK18legacy_device_base13inline_configEv($8);
      var $10=$9;
      $config=$10;
      var $11=$6;
      var $12=__ZL14get_safe_tokenP8device_t5459($11);
      $ld=$12;
      var $13=$ld;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      $ldcore=$15;
      var $16=$config;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$config;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$6;
      var $25=FUNCTION_TABLE[$23]($24);
      var $26=$ldcore;
      var $27=(($26+144)|0);
      HEAP32[(($27)>>2)]=$25;
      __label__ = 3; break;
    case 2: // $28
      var $29=$6;
      var $30=__ZNK8device_t7machineEv($29);
      var $31=$6;
      var $32=__ZNK8device_t3tagEv($31);
      var $33=__Z15get_disk_handleR15running_machinePKc($30, $32);
      var $34=$ldcore;
      var $35=(($34+144)|0);
      HEAP32[(($35)>>2)]=$33;
      __label__ = 3; break;
    case 3: // $36
      var $37=$ldcore;
      var $38=(($37+152)|0);
      HEAP32[(($38)>>2)]=720;
      var $39=$ldcore;
      var $40=(($39+156)|0);
      HEAP32[(($40)>>2)]=240;
      var $41=$ldcore;
      var $42=(($41+160)|0);
      HEAP32[(($42)>>2)]=59940000;
      var $43=$ldcore;
      var $44=(($43+164)|0);
      HEAP32[(($44)>>2)]=48000;
      var $45=$ldcore;
      var $46=(($45+172)|0);
      HEAP32[(($46)>>2)]=0;
      var $47=$ldcore;
      var $48=(($47+272)|0);
      HEAP32[(($48)>>2)]=56100;
      var $49=$ldcore;
      var $50=(($49+144)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 4; break; } else { __label__ = 24; break; }
    case 4: // $53
      var $54=$ldcore;
      var $55=(($54+144)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=__Z14chd_get_headerP9_chd_file($56);
      var $58=(($57+20)|0);
      var $59=HEAP32[(($58)>>2)];
      $totalhunks=$59;
      var $60=$ldcore;
      var $61=(($60+144)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=__Z14chd_get_headerP9_chd_file($62);
      var $64=(($63+12)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65)|0)!=3;
      if ($66) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $67
      __Z10fatalerrorPKcz(((STRING_TABLE.__str255453)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 6: // $68
      var $69=$ldcore;
      var $70=(($69+144)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($metadata)|0);
      var $73=__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph($71, 1096171862, 0, $72, 256, 0, 0, 0);
      $err=$73;
      var $74=$err;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $76
      __Z10fatalerrorPKcz(((STRING_TABLE.__str265454)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 8: // $77
      var $78=(($metadata)|0);
      var $79=$ldcore;
      var $80=(($79+152)|0);
      var $81=$ldcore;
      var $82=(($81+156)|0);
      var $83=$ldcore;
      var $84=(($83+164)|0);
      var $85=_sscanf($78, ((STRING_TABLE.__str275455)|0), (tempInt=STACKTOP,STACKTOP += 28,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$fps,HEAP32[((tempInt+4)>>2)]=$fpsfrac,HEAP32[((tempInt+8)>>2)]=$80,HEAP32[((tempInt+12)>>2)]=$82,HEAP32[((tempInt+16)>>2)]=$interlaced,HEAP32[((tempInt+20)>>2)]=$channels,HEAP32[((tempInt+24)>>2)]=$84,tempInt));
      var $86=(($85)|0)!=7;
      if ($86) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $87
      __Z10fatalerrorPKcz(((STRING_TABLE.__str285456)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 10: // $88
      var $89=HEAP32[(($fps)>>2)];
      var $90=(($89*1000000)|0);
      var $91=HEAP32[(($fpsfrac)>>2)];
      var $92=(($90+$91)|0);
      var $93=$ldcore;
      var $94=(($93+160)|0);
      HEAP32[(($94)>>2)]=$92;
      __label__ = 11; break;
    case 11: // $95
      var $96=HEAP32[(($interlaced)>>2)];
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $98
      __Z10fatalerrorPKcz(((STRING_TABLE.__str295457)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 13: // $99
      var $100=$totalhunks;
      var $101=Math.floor((($100)>>>0)/2);
      var $102=$ldcore;
      var $103=(($102+172)|0);
      HEAP32[(($103)>>2)]=$101;
      var $104=$6;
      var $105=__ZNK8device_t7machineEv($104);
      var $106=__ZN15running_machine7respoolEv($105);
      var $107=$totalhunks;
      var $108=((($107<<4))|0);
      var $109=$1;
      var $110=$2;
      var $111=$3;
      var $112=$result_i;
      var $113=$4;
      var $114=$5;
      HEAP32[(($1)>>2)]=$108;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($3)>>2)]=1374;
      var $115=HEAP32[(($1)>>2)];
      var $116=HEAP32[(($2)>>2)];
      var $117=HEAP32[(($3)>>2)];
      var $118=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($115, $116, $117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $119
      HEAP32[(($result_i)>>2)]=$118;
      var $120=HEAP32[(($result_i)>>2)];
      var $121=(($120)|0)==0;
      if ($121) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $122
      var $123=___cxa_allocate_exception(4);
      var $124=$123;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($124);
      (function() { try { __THREW__ = false; return ___cxa_throw($123, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; }
    case 16: // $125
      var $126=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $127=$126.f0;
      HEAP32[(($4)>>2)]=$127;
      var $128=$126.f1;
      HEAP32[(($5)>>2)]=$128;
      var $129=HEAP32[(($5)>>2)];
      var $130=(($129)|0) < 0;
      if ($130) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $131
      var $132=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($132);
      throw "Reached an unreachable!"
    case 18: // $133
      var $134=HEAP32[(($4)>>2)];
      var $135=HEAP32[(($4)>>2)];
      var $136=HEAP32[(($5)>>2)];
      var $137=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $135, tempValue);
      var $138=($137.f1 = $136, $137);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $139
      throw "Reached an unreachable!"
    case 20: // $_ZnajPKci_exit
      var $140=HEAP32[(($result_i)>>2)];
      var $141=$1;
      var $142=$2;
      var $143=$3;
      var $144=$result_i;
      var $145=$4;
      var $146=$5;
      var $147=$totalhunks;
      var $148=((($147<<4))|0);
      var $149=__ZN13resource_pool9add_arrayIhEEPT_S2_i($106, $140, $148);
      var $150=$ldcore;
      var $151=(($150+148)|0);
      HEAP32[(($151)>>2)]=$149;
      var $152=$ldcore;
      var $153=(($152+144)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$ldcore;
      var $156=(($155+148)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$totalhunks;
      var $159=((($158<<4))|0);
      var $160=__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph($154, 1096174660, 0, $157, $159, $vbilength, 0, 0);
      $err=$160;
      var $161=$err;
      var $162=(($161)|0)!=0;
      if ($162) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $163
      var $164=HEAP32[(($vbilength)>>2)];
      var $165=$totalhunks;
      var $166=((($165<<4))|0);
      var $167=(($164)|0)!=(($166)|0);
      if ($167) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $168
      __Z10fatalerrorPKcz(((STRING_TABLE.__str305458)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 23: // $169
      __label__ = 24; break;
    case 24: // $170
      var $171=$ldcore;
      var $172=(($171+272)|0);
      var $173=HEAPU32[(($172)>>2)];
      var $174=$ldcore;
      var $175=(($174+172)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176+2100)|0);
      var $178=(($173)>>>0) > (($177)>>>0);
      if ($178) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $179
      var $180=$ldcore;
      var $181=(($180+272)|0);
      var $182=HEAP32[(($181)>>2)];
      var $189 = $182;__label__ = 27; break;
    case 26: // $183
      var $184=$ldcore;
      var $185=(($184+172)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($186+2100)|0);
      var $189 = $187;__label__ = 27; break;
    case 27: // $188
      var $189;
      var $190=$ldcore;
      var $191=(($190+272)|0);
      HEAP32[(($191)>>2)]=$189;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9init_discP8device_t["X"]=1;

function __ZL10init_videoP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 204; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $result_i11=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i9=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i5=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25=__stackBase__+108;
      var $26=__stackBase__+112;
      var $27=__stackBase__+116;
      var $28=__stackBase__+120;
      var $29=__stackBase__+124;
      var $30=__stackBase__+128;
      var $31=__stackBase__+132;
      var $32=__stackBase__+136;
      var $33=__stackBase__+140;
      var $result_i1=__stackBase__+144;
      var $34=__stackBase__+148;
      var $35=__stackBase__+152;
      var $36=__stackBase__+156;
      var $37=__stackBase__+160;
      var $38=__stackBase__+164;
      var $result_i=__stackBase__+168;
      var $39=__stackBase__+172;
      var $40=__stackBase__+176;
      var $41;
      var $ld;
      var $ldcore;
      var $index;
      var $42=__stackBase__+180;
      var $frame;
      var $43;
      var $44;
      $41=$device;
      var $45=$41;
      var $46=__ZL14get_safe_tokenP8device_t5459($45);
      $ld=$46;
      var $47=$ld;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      $ldcore=$49;
      var $50=$ld;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$41;
      __ZN8delegateIFvR13screen_devicebEEC1I8device_tEEN15delegate_traitsIT_vS1_b8_noparamS8_E16static_func_typeEPKcPS7_($42, 1166, ((STRING_TABLE.__str205448)|0), $53);
      __ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE($52, $42);
      $index=0;
      __label__ = 1; break;
    case 1: // $54
      var $55=$index;
      var $56=(($55)>>>0) < 3;
      if ($56) { __label__ = 2; break; } else { __label__ = 30; break; }
    case 2: // $57
      var $58=$index;
      var $59=$ldcore;
      var $60=(($59+296)|0);
      var $61=(($60+($58<<4))|0);
      $frame=$61;
      var $62=$41;
      var $63=__ZNK8device_t7machineEv($62);
      var $64=__ZN15running_machine7respoolEv($63);
      var $65=$36;
      var $66=$37;
      var $67=$38;
      var $68=$result_i;
      var $69=$39;
      var $70=$40;
      HEAP32[(($36)>>2)]=48;
      HEAP32[(($37)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($38)>>2)]=1403;
      var $71=HEAP32[(($36)>>2)];
      var $72=HEAP32[(($37)>>2)];
      var $73=HEAP32[(($38)>>2)];
      var $74=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $75
      HEAP32[(($result_i)>>2)]=$74;
      var $76=HEAP32[(($result_i)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $78
      var $79=___cxa_allocate_exception(4);
      var $80=$79;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($80);
      (function() { try { __THREW__ = false; return ___cxa_throw($79, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      HEAP32[(($39)>>2)]=$83;
      var $84=$82.f1;
      HEAP32[(($40)>>2)]=$84;
      var $85=HEAP32[(($40)>>2)];
      var $86=(($85)|0) < 0;
      if ($86) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $87
      var $88=HEAP32[(($39)>>2)];
      ___cxa_call_unexpected($88);
      throw "Reached an unreachable!"
    case 7: // $89
      var $90=HEAP32[(($39)>>2)];
      var $91=HEAP32[(($39)>>2)];
      var $92=HEAP32[(($40)>>2)];
      var $93=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $91, tempValue);
      var $94=($93.f1 = $92, $93);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $95
      throw "Reached an unreachable!"
    case 9: // $_ZnwjPKci_exit
      var $96=HEAPU32[(($result_i)>>2)];
      var $97=$36;
      var $98=$37;
      var $99=$38;
      var $100=$result_i;
      var $101=$39;
      var $102=$40;
      var $103=$96;
      var $104=$ldcore;
      var $105=(($104+152)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$ldcore;
      var $108=(($107+156)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=((($109<<1))|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($103, $106, $110, 8, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 20; break; }
    case 10: // $111
      var $112=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($64, $103);
      var $113=$frame;
      var $114=(($113)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=$frame;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      __ZL16fillbitmap_yuy16P8bitmap_thhh($117, 40, 109, -16);
      var $118=$41;
      var $119=__ZNK8device_t7machineEv($118);
      var $120=__ZN15running_machine7respoolEv($119);
      var $121=$31;
      var $122=$32;
      var $123=$33;
      var $124=$result_i1;
      var $125=$34;
      var $126=$35;
      HEAP32[(($31)>>2)]=48;
      HEAP32[(($32)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($33)>>2)]=1410;
      var $127=HEAP32[(($31)>>2)];
      var $128=HEAP32[(($32)>>2)];
      var $129=HEAP32[(($33)>>2)];
      var $130=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($127, $128, $129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $131
      HEAP32[(($result_i1)>>2)]=$130;
      var $132=HEAP32[(($result_i1)>>2)];
      var $133=(($132)|0)==0;
      if ($133) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $134
      var $135=___cxa_allocate_exception(4);
      var $136=$135;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($136);
      (function() { try { __THREW__ = false; return ___cxa_throw($135, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 13; break; }
    case 13: // $137
      var $138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $139=$138.f0;
      HEAP32[(($34)>>2)]=$139;
      var $140=$138.f1;
      HEAP32[(($35)>>2)]=$140;
      var $141=HEAP32[(($35)>>2)];
      var $142=(($141)|0) < 0;
      if ($142) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $143
      var $144=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($144);
      throw "Reached an unreachable!"
    case 15: // $145
      var $146=HEAP32[(($34)>>2)];
      var $147=HEAP32[(($34)>>2)];
      var $148=HEAP32[(($35)>>2)];
      var $149=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $147, tempValue);
      var $150=($149.f1 = $148, $149);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $151
      throw "Reached an unreachable!"
    case 17: // $_ZnwjPKci_exit2
      var $152=HEAP32[(($result_i1)>>2)];
      var $153=$31;
      var $154=$32;
      var $155=$33;
      var $156=$result_i1;
      var $157=$34;
      var $158=$35;
      var $159=$152;
      var $160=$frame;
      var $161=(($160)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$162;
      var $164=(($163+4)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=$165;
      var $167=$frame;
      var $168=(($167)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=$169;
      var $171=(($170+8)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172*44)|0);
      var $174=(($166+($173<<1))|0);
      var $175=$frame;
      var $176=(($175)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$177;
      var $179=(($178+12)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=((($180<<3))|0);
      var $182=(((($181)|0)/720)|0);
      var $183=(($174+($182<<1))|0);
      var $184=$183;
      var $185=$frame;
      var $186=(($185)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=$187;
      var $189=(($188+12)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$frame;
      var $192=(($191)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$193;
      var $195=(($194+12)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=((($196<<1))|0);
      var $198=((($197<<3))|0);
      var $199=(((($198)|0)/720)|0);
      var $200=(($190-$199)|0);
      var $201=$frame;
      var $202=(($201)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$203;
      var $205=(($204+16)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206-44)|0);
      var $208=$frame;
      var $209=(($208)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$210;
      var $212=(($211+8)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=$frame;
      var $215=(($214)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=$216;
      var $218=(($217+20)|0);
      var $219=HEAP32[(($218)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1EPviii14_bitmap_format]($159, $184, $200, $207, $213, $219) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 25; break; }
    case 18: // $220
      var $221=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($120, $159);
      var $222=$frame;
      var $223=(($222+4)|0);
      HEAP32[(($223)>>2)]=$221;
      __label__ = 19; break;
    case 19: // $224
      var $225=$index;
      var $226=(($225+1)|0);
      $index=$226;
      __label__ = 1; break;
    case 20: // $227
      var $228=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $229=$228.f0;
      $43=$229;
      var $230=$228.f1;
      $44=$230;
      var $231=$28;
      var $232=$29;
      var $233=$30;
      HEAP32[(($28)>>2)]=$96;
      HEAP32[(($29)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($30)>>2)]=1403;
      var $234=HEAP32[(($28)>>2)];
      var $235=(($234)|0)!=0;
      if ($235) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $236
      var $237=HEAP32[(($28)>>2)];
      var $238=HEAP32[(($29)>>2)];
      var $239=HEAP32[(($30)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($237, $238, $239) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 85; break; }
    case 22: // $_noexc
      __label__ = 23; break;
    case 23: // $_ZdlPvPKci_exit
      var $240=$28;
      var $241=$29;
      var $242=$30;
      __label__ = 24; break;
    case 24: // $243
      __label__ = 84; break;
    case 25: // $244
      var $245=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $246=$245.f0;
      $43=$246;
      var $247=$245.f1;
      $44=$247;
      var $248=$25;
      var $249=$26;
      var $250=$27;
      HEAP32[(($25)>>2)]=$152;
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($27)>>2)]=1410;
      var $251=HEAP32[(($25)>>2)];
      var $252=(($251)|0)!=0;
      if ($252) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $253
      var $254=HEAP32[(($25)>>2)];
      var $255=HEAP32[(($26)>>2)];
      var $256=HEAP32[(($27)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($254, $255, $256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 85; break; }
    case 27: // $_noexc3
      __label__ = 28; break;
    case 28: // $_ZdlPvPKci_exit4
      var $257=$25;
      var $258=$26;
      var $259=$27;
      __label__ = 29; break;
    case 29: // $260
      __label__ = 84; break;
    case 30: // $261
      var $262=$41;
      var $263=__ZNK8device_t7machineEv($262);
      var $264=__ZN15running_machine7respoolEv($263);
      var $265=$20;
      var $266=$21;
      var $267=$22;
      var $268=$result_i5;
      var $269=$23;
      var $270=$24;
      HEAP32[(($20)>>2)]=48;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($22)>>2)]=1414;
      var $271=HEAP32[(($20)>>2)];
      var $272=HEAP32[(($21)>>2)];
      var $273=HEAP32[(($22)>>2)];
      var $274=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($271, $272, $273) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 33; break; };
    case 31: // $275
      HEAP32[(($result_i5)>>2)]=$274;
      var $276=HEAP32[(($result_i5)>>2)];
      var $277=(($276)|0)==0;
      if ($277) { __label__ = 32; break; } else { __label__ = 37; break; }
    case 32: // $278
      var $279=___cxa_allocate_exception(4);
      var $280=$279;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($280);
      (function() { try { __THREW__ = false; return ___cxa_throw($279, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 33; break; }
    case 33: // $281
      var $282=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $283=$282.f0;
      HEAP32[(($23)>>2)]=$283;
      var $284=$282.f1;
      HEAP32[(($24)>>2)]=$284;
      var $285=HEAP32[(($24)>>2)];
      var $286=(($285)|0) < 0;
      if ($286) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $287
      var $288=HEAP32[(($23)>>2)];
      ___cxa_call_unexpected($288);
      throw "Reached an unreachable!"
    case 35: // $289
      var $290=HEAP32[(($23)>>2)];
      var $291=HEAP32[(($23)>>2)];
      var $292=HEAP32[(($24)>>2)];
      var $293=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $291, tempValue);
      var $294=($293.f1 = $292, $293);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 36: // $295
      throw "Reached an unreachable!"
    case 37: // $_ZnwjPKci_exit6
      var $296=HEAP32[(($result_i5)>>2)];
      var $297=$20;
      var $298=$21;
      var $299=$22;
      var $300=$result_i5;
      var $301=$23;
      var $302=$24;
      var $303=$296;
      var $304=$ldcore;
      var $305=(($304+152)|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=$ldcore;
      var $308=(($307+156)|0);
      var $309=HEAP32[(($308)>>2)];
      var $310=((($309<<1))|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($303, $306, $310, 8, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $311
      var $312=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($264, $303);
      var $313=$ldcore;
      var $314=(($313+396)|0);
      HEAP32[(($314)>>2)]=$312;
      var $315=$ldcore;
      var $316=(($315+396)|0);
      var $317=HEAP32[(($316)>>2)];
      __ZL16fillbitmap_yuy16P8bitmap_thhh($317, 0, -128, -128);
      var $318=$ldcore;
      var $319=(($318+481)|0);
      HEAP8[($319)]=1;
      var $320=$41;
      var $321=__ZNK8device_t7machineEv($320);
      var $322=__ZNK15running_machine6renderEv($321);
      var $323=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($322, 0, 0);
      var $324=$ldcore;
      var $325=(($324+484)|0);
      HEAP32[(($325)>>2)]=$323;
      var $326=$ldcore;
      var $327=(($326+484)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=(($328)|0)==0;
      if ($329) { __label__ = 39; break; } else { __label__ = 45; break; }
    case 39: // $330
      __Z10fatalerrorPKcz(((STRING_TABLE.__str215449)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 40: // $331
      var $332=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $333=$332.f0;
      $43=$333;
      var $334=$332.f1;
      $44=$334;
      var $335=$17;
      var $336=$18;
      var $337=$19;
      HEAP32[(($17)>>2)]=$296;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($19)>>2)]=1414;
      var $338=HEAP32[(($17)>>2)];
      var $339=(($338)|0)!=0;
      if ($339) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $340
      var $341=HEAP32[(($17)>>2)];
      var $342=HEAP32[(($18)>>2)];
      var $343=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($341, $342, $343) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 85; break; }
    case 42: // $_noexc7
      __label__ = 43; break;
    case 43: // $_ZdlPvPKci_exit8
      var $344=$17;
      var $345=$18;
      var $346=$19;
      __label__ = 44; break;
    case 44: // $347
      __label__ = 84; break;
    case 45: // $348
      var $349=__Z13palette_allocjj(256, 1);
      var $350=$ldcore;
      var $351=(($350+488)|0);
      HEAP32[(($351)>>2)]=$349;
      var $352=$ldcore;
      var $353=(($352+488)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=(($354)|0)==0;
      if ($355) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $356
      __Z10fatalerrorPKcz(((STRING_TABLE.__str225450)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 47: // $357
      $index=0;
      __label__ = 48; break;
    case 48: // $358
      var $359=$index;
      var $360=(($359)|0) < 256;
      if ($360) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $361
      var $362=$ldcore;
      var $363=(($362+488)|0);
      var $364=HEAP32[(($363)>>2)];
      var $365=$index;
      var $366=$index;
      var $367=$366 & 255;
      var $368=$367 << 16;
      var $369=-16777216 | $368;
      var $370=$index;
      var $371=$370 & 255;
      var $372=$371 << 8;
      var $373=$369 | $372;
      var $374=$index;
      var $375=$374 & 255;
      var $376=$373 | $375;
      __Z23palette_entry_set_colorP10_palette_tjj($364, $365, $376);
      __label__ = 50; break;
    case 50: // $377
      var $378=$index;
      var $379=(($378+1)|0);
      $index=$379;
      __label__ = 48; break;
    case 51: // $380
      var $381=$ldcore;
      var $382=(($381)|0);
      var $383=(($382+24)|0);
      var $384=HEAPU32[(($383)>>2)];
      var $385=(($384)>>>0) > 0;
      if ($385) { __label__ = 52; break; } else { __label__ = 83; break; }
    case 52: // $386
      var $387=$ldcore;
      var $388=(($387)|0);
      var $389=(($388+28)|0);
      var $390=HEAPU32[(($389)>>2)];
      var $391=(($390)>>>0) > 0;
      if ($391) { __label__ = 53; break; } else { __label__ = 83; break; }
    case 53: // $392
      var $393=$ldcore;
      var $394=(($393)|0);
      var $395=(($394+20)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=(($396)|0)!=0;
      if ($397) { __label__ = 54; break; } else { __label__ = 83; break; }
    case 54: // $398
      var $399=$ldcore;
      var $400=(($399+492)|0);
      HEAP8[($400)]=1;
      var $401=$41;
      var $402=__ZNK8device_t7machineEv($401);
      var $403=__ZN15running_machine7respoolEv($402);
      var $404=$12;
      var $405=$13;
      var $406=$14;
      var $407=$result_i9;
      var $408=$15;
      var $409=$16;
      HEAP32[(($12)>>2)]=48;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($14)>>2)]=1434;
      var $410=HEAP32[(($12)>>2)];
      var $411=HEAP32[(($13)>>2)];
      var $412=HEAP32[(($14)>>2)];
      var $413=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($410, $411, $412) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 57; break; };
    case 55: // $414
      HEAP32[(($result_i9)>>2)]=$413;
      var $415=HEAP32[(($result_i9)>>2)];
      var $416=(($415)|0)==0;
      if ($416) { __label__ = 56; break; } else { __label__ = 61; break; }
    case 56: // $417
      var $418=___cxa_allocate_exception(4);
      var $419=$418;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($419);
      (function() { try { __THREW__ = false; return ___cxa_throw($418, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 57; break; }
    case 57: // $420
      var $421=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $422=$421.f0;
      HEAP32[(($15)>>2)]=$422;
      var $423=$421.f1;
      HEAP32[(($16)>>2)]=$423;
      var $424=HEAP32[(($16)>>2)];
      var $425=(($424)|0) < 0;
      if ($425) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $426
      var $427=HEAP32[(($15)>>2)];
      ___cxa_call_unexpected($427);
      throw "Reached an unreachable!"
    case 59: // $428
      var $429=HEAP32[(($15)>>2)];
      var $430=HEAP32[(($15)>>2)];
      var $431=HEAP32[(($16)>>2)];
      var $432=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $430, tempValue);
      var $433=($432.f1 = $431, $432);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 60: // $434
      throw "Reached an unreachable!"
    case 61: // $_ZnwjPKci_exit10
      var $435=HEAPU32[(($result_i9)>>2)];
      var $436=$12;
      var $437=$13;
      var $438=$14;
      var $439=$result_i9;
      var $440=$15;
      var $441=$16;
      var $442=$435;
      var $443=$ldcore;
      var $444=(($443)|0);
      var $445=(($444+24)|0);
      var $446=HEAP32[(($445)>>2)];
      var $447=$ldcore;
      var $448=(($447)|0);
      var $449=(($448+28)|0);
      var $450=HEAP32[(($449)>>2)];
      var $451=$ldcore;
      var $452=(($451)|0);
      var $453=(($452+32)|0);
      var $454=HEAP32[(($453)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($442, $446, $450, $454, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 72; break; }
    case 62: // $455
      var $456=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($403, $442);
      var $457=$ldcore;
      var $458=(($457+496)|0);
      var $459=(($458)|0);
      HEAP32[(($459)>>2)]=$456;
      var $460=$41;
      var $461=__ZNK8device_t7machineEv($460);
      var $462=__ZN15running_machine7respoolEv($461);
      var $463=$7;
      var $464=$8;
      var $465=$9;
      var $466=$result_i11;
      var $467=$10;
      var $468=$11;
      HEAP32[(($7)>>2)]=48;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($9)>>2)]=1435;
      var $469=HEAP32[(($7)>>2)];
      var $470=HEAP32[(($8)>>2)];
      var $471=HEAP32[(($9)>>2)];
      var $472=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($469, $470, $471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; };
    case 63: // $473
      HEAP32[(($result_i11)>>2)]=$472;
      var $474=HEAP32[(($result_i11)>>2)];
      var $475=(($474)|0)==0;
      if ($475) { __label__ = 64; break; } else { __label__ = 69; break; }
    case 64: // $476
      var $477=___cxa_allocate_exception(4);
      var $478=$477;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($478);
      (function() { try { __THREW__ = false; return ___cxa_throw($477, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 65; break; }
    case 65: // $479
      var $480=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $481=$480.f0;
      HEAP32[(($10)>>2)]=$481;
      var $482=$480.f1;
      HEAP32[(($11)>>2)]=$482;
      var $483=HEAP32[(($11)>>2)];
      var $484=(($483)|0) < 0;
      if ($484) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $485
      var $486=HEAP32[(($10)>>2)];
      ___cxa_call_unexpected($486);
      throw "Reached an unreachable!"
    case 67: // $487
      var $488=HEAP32[(($10)>>2)];
      var $489=HEAP32[(($10)>>2)];
      var $490=HEAP32[(($11)>>2)];
      var $491=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $489, tempValue);
      var $492=($491.f1 = $490, $491);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 68: // $493
      throw "Reached an unreachable!"
    case 69: // $_ZnwjPKci_exit12
      var $494=HEAP32[(($result_i11)>>2)];
      var $495=$7;
      var $496=$8;
      var $497=$9;
      var $498=$result_i11;
      var $499=$10;
      var $500=$11;
      var $501=$494;
      var $502=$ldcore;
      var $503=(($502)|0);
      var $504=(($503+24)|0);
      var $505=HEAP32[(($504)>>2)];
      var $506=$ldcore;
      var $507=(($506)|0);
      var $508=(($507+28)|0);
      var $509=HEAP32[(($508)>>2)];
      var $510=$ldcore;
      var $511=(($510)|0);
      var $512=(($511+32)|0);
      var $513=HEAP32[(($512)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8bitmap_tC1Eii14_bitmap_formatii]($501, $505, $509, $513, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 77; break; }
    case 70: // $514
      var $515=__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_($462, $501);
      var $516=$ldcore;
      var $517=(($516+496)|0);
      var $518=(($517+4)|0);
      HEAP32[(($518)>>2)]=$515;
      var $519=$41;
      var $520=__ZNK8device_t7machineEv($519);
      var $521=__ZNK15running_machine6renderEv($520);
      var $522=__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_($521, 0, 0);
      var $523=$ldcore;
      var $524=(($523+508)|0);
      HEAP32[(($524)>>2)]=$522;
      var $525=$ldcore;
      var $526=(($525+508)|0);
      var $527=HEAP32[(($526)>>2)];
      var $528=(($527)|0)==0;
      if ($528) { __label__ = 71; break; } else { __label__ = 82; break; }
    case 71: // $529
      __Z10fatalerrorPKcz(((STRING_TABLE.__str235451)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 72: // $530
      var $531=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $532=$531.f0;
      $43=$532;
      var $533=$531.f1;
      $44=$533;
      var $534=$4;
      var $535=$5;
      var $536=$6;
      HEAP32[(($4)>>2)]=$435;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($6)>>2)]=1434;
      var $537=HEAP32[(($4)>>2)];
      var $538=(($537)|0)!=0;
      if ($538) { __label__ = 73; break; } else { __label__ = 75; break; }
    case 73: // $539
      var $540=HEAP32[(($4)>>2)];
      var $541=HEAP32[(($5)>>2)];
      var $542=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($540, $541, $542) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 85; break; }
    case 74: // $_noexc13
      __label__ = 75; break;
    case 75: // $_ZdlPvPKci_exit14
      var $543=$4;
      var $544=$5;
      var $545=$6;
      __label__ = 76; break;
    case 76: // $546
      __label__ = 84; break;
    case 77: // $547
      var $548=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $549=$548.f0;
      $43=$549;
      var $550=$548.f1;
      $44=$550;
      var $551=$1;
      var $552=$2;
      var $553=$3;
      HEAP32[(($1)>>2)]=$494;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($3)>>2)]=1435;
      var $554=HEAP32[(($1)>>2)];
      var $555=(($554)|0)!=0;
      if ($555) { __label__ = 78; break; } else { __label__ = 80; break; }
    case 78: // $556
      var $557=HEAP32[(($1)>>2)];
      var $558=HEAP32[(($2)>>2)];
      var $559=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($557, $558, $559) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 85; break; }
    case 79: // $_noexc15
      __label__ = 80; break;
    case 80: // $_ZdlPvPKci_exit16
      var $560=$1;
      var $561=$2;
      var $562=$3;
      __label__ = 81; break;
    case 81: // $563
      __label__ = 84; break;
    case 82: // $564
      __label__ = 83; break;
    case 83: // $565
      STACKTOP = __stackBase__;
      return;
    case 84: // $566
      var $567=$43;
      var $568=$43;
      var $569=$44;
      var $570=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $568, tempValue);
      var $571=($570.f1 = $569, $570);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 85: // $572
      var $573=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10init_videoP8device_t["X"]=1;

function __ZL16fillbitmap_yuy16P8bitmap_thhh($bitmap, $yval, $cr, $cb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $color0;
      var $color1;
      var $x;
      var $y;
      var $dest;
      $1=$bitmap;
      $2=$yval;
      $3=$cr;
      $4=$cb;
      var $5=$2;
      var $6=(($5)&255);
      var $7=$6 << 8;
      var $8=$4;
      var $9=(($8)&255);
      var $10=$7 | $9;
      var $11=(($10) & 65535);
      $color0=$11;
      var $12=$2;
      var $13=(($12)&255);
      var $14=$13 << 8;
      var $15=$3;
      var $16=(($15)&255);
      var $17=$14 | $16;
      var $18=(($17) & 65535);
      $color1=$18;
      $y=0;
      __label__ = 1; break;
    case 1: // $19
      var $20=$y;
      var $21=$1;
      var $22=$21;
      var $23=(($22+16)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($20)|0) < (($24)|0);
      if ($25) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $26
      var $27=$1;
      var $28=$27;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30;
      var $32=$y;
      var $33=$1;
      var $34=$33;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($32*$36)|0);
      var $38=(($31+($37<<1))|0);
      $dest=$38;
      $x=0;
      __label__ = 3; break;
    case 3: // $39
      var $40=$x;
      var $41=$1;
      var $42=$41;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(((($44)|0)/2)|0);
      var $46=(($40)|0) < (($45)|0);
      if ($46) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $47
      var $48=$color0;
      var $49=$dest;
      var $50=(($49+2)|0);
      $dest=$50;
      HEAP16[(($49)>>1)]=$48;
      var $51=$color1;
      var $52=$dest;
      var $53=(($52+2)|0);
      $dest=$53;
      HEAP16[(($52)>>1)]=$51;
      __label__ = 5; break;
    case 5: // $54
      var $55=$x;
      var $56=(($55+1)|0);
      $x=$56;
      __label__ = 3; break;
    case 6: // $57
      __label__ = 7; break;
    case 7: // $58
      var $59=$y;
      var $60=(($59+1)|0);
      $y=$60;
      __label__ = 1; break;
    case 8: // $61
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16fillbitmap_yuy16P8bitmap_thhh["X"]=1;

function __ZL18configuration_loadR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $overnode;
      var $ldnode;
      var $devtag;
      var $device;
      var $ld;
      var $ldcore;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$2;
      var $5=(($4)|0)!=3;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 12; break;
    case 2: // $7
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      __label__ = 12; break;
    case 4: // $11
      var $12=$3;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z15xml_get_siblingP14_xml_data_nodePKc($14, ((STRING_TABLE.__str125440)|0));
      $ldnode=$15;
      __label__ = 5; break;
    case 5: // $16
      var $17=$ldnode;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $19
      var $20=$ldnode;
      var $21=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($20, ((STRING_TABLE.__str135441)|0), ((__str195447)|0));
      $devtag=$21;
      var $22=$1;
      var $23=$devtag;
      var $24=__ZN15running_machine6deviceEPKc($22, $23);
      $device=$24;
      var $25=$device;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $27
      var $28=$device;
      var $29=__ZL14get_safe_tokenP8device_t5459($28);
      $ld=$29;
      var $30=$ld;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      $ldcore=$32;
      var $33=$ldnode;
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z15xml_get_siblingP14_xml_data_nodePKc($35, ((STRING_TABLE.__str145442)|0));
      $overnode=$36;
      var $37=$overnode;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      var $40=$overnode;
      var $41=$ldcore;
      var $42=(($41)|0);
      var $43=(($42+52)|0);
      var $44=HEAPF32[(($43)>>2)];
      var $45=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($40, ((STRING_TABLE.__str155443)|0), $44);
      var $46=$ldcore;
      var $47=(($46)|0);
      var $48=(($47+52)|0);
      HEAPF32[(($48)>>2)]=$45;
      var $49=$overnode;
      var $50=$ldcore;
      var $51=(($50)|0);
      var $52=(($51+60)|0);
      var $53=HEAPF32[(($52)>>2)];
      var $54=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($49, ((STRING_TABLE.__str165444)|0), $53);
      var $55=$ldcore;
      var $56=(($55)|0);
      var $57=(($56+60)|0);
      HEAPF32[(($57)>>2)]=$54;
      var $58=$overnode;
      var $59=$ldcore;
      var $60=(($59)|0);
      var $61=(($60+56)|0);
      var $62=HEAPF32[(($61)>>2)];
      var $63=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($58, ((STRING_TABLE.__str175445)|0), $62);
      var $64=$ldcore;
      var $65=(($64)|0);
      var $66=(($65+56)|0);
      HEAPF32[(($66)>>2)]=$63;
      var $67=$overnode;
      var $68=$ldcore;
      var $69=(($68)|0);
      var $70=(($69+64)|0);
      var $71=HEAPF32[(($70)>>2)];
      var $72=__Z23xml_get_attribute_floatP14_xml_data_nodePKcf($67, ((STRING_TABLE.__str185446)|0), $71);
      var $73=$ldcore;
      var $74=(($73)|0);
      var $75=(($74+64)|0);
      HEAPF32[(($75)>>2)]=$72;
      __label__ = 9; break;
    case 9: // $76
      __label__ = 10; break;
    case 10: // $77
      __label__ = 11; break;
    case 11: // $78
      var $79=$ldnode;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=__Z15xml_get_siblingP14_xml_data_nodePKc($81, ((STRING_TABLE.__str125440)|0));
      $ldnode=$82;
      __label__ = 5; break;
    case 12: // $83
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18configuration_loadR15running_machineiP14_xml_data_node["X"]=1;

function __ZL18configuration_saveR15running_machineiP14_xml_data_node($machine, $config_type, $parentnode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $origconfig;
      var $ld;
      var $ldcore;
      var $overnode;
      var $ldnode;
      var $changed;
      $1=$machine;
      $2=$config_type;
      $3=$parentnode;
      var $4=$2;
      var $5=(($4)|0)!=3;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 20; break;
    case 2: // $7
      var $8=$1;
      var $9=__ZNK15running_machine10devicelistEv($8);
      var $10=HEAP32[((_LASERDISC)>>2)];
      var $11=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($9, $10);
      $device=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $15
      var $16=$device;
      var $17=__Z8downcastIPK18legacy_device_base8device_tET_PT0_($16);
      var $18=__ZNK18legacy_device_base13inline_configEv($17);
      var $19=$18;
      $origconfig=$19;
      var $20=$device;
      var $21=__ZL14get_safe_tokenP8device_t5459($20);
      $ld=$21;
      var $22=$ld;
      var $23=(($22+8)|0);
      var $24=HEAP32[(($23)>>2)];
      $ldcore=$24;
      var $25=$3;
      var $26=__Z13xml_add_childP14_xml_data_nodePKcS2_($25, ((STRING_TABLE.__str125440)|0), 0);
      $ldnode=$26;
      var $27=$ldnode;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 18; break; }
    case 5: // $29
      $changed=0;
      var $30=$ldnode;
      var $31=$device;
      var $32=__ZNK8device_t3tagEv($31);
      var $33=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($30, ((STRING_TABLE.__str135441)|0), $32);
      var $34=$ldnode;
      var $35=__Z13xml_add_childP14_xml_data_nodePKcS2_($34, ((STRING_TABLE.__str145442)|0), 0);
      $overnode=$35;
      var $36=$overnode;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $38
      var $39=$ldcore;
      var $40=(($39)|0);
      var $41=(($40+52)|0);
      var $42=HEAPF32[(($41)>>2)];
      var $43=$origconfig;
      var $44=(($43+52)|0);
      var $45=HEAPF32[(($44)>>2)];
      var $46=$42 != $45;
      if ($46) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $47
      var $48=$overnode;
      var $49=$ldcore;
      var $50=(($49)|0);
      var $51=(($50+52)|0);
      var $52=HEAPF32[(($51)>>2)];
      var $53=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($48, ((STRING_TABLE.__str155443)|0), $52);
      $changed=1;
      __label__ = 8; break;
    case 8: // $54
      var $55=$ldcore;
      var $56=(($55)|0);
      var $57=(($56+60)|0);
      var $58=HEAPF32[(($57)>>2)];
      var $59=$origconfig;
      var $60=(($59+60)|0);
      var $61=HEAPF32[(($60)>>2)];
      var $62=$58 != $61;
      if ($62) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $63
      var $64=$overnode;
      var $65=$ldcore;
      var $66=(($65)|0);
      var $67=(($66+60)|0);
      var $68=HEAPF32[(($67)>>2)];
      var $69=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($64, ((STRING_TABLE.__str165444)|0), $68);
      $changed=1;
      __label__ = 10; break;
    case 10: // $70
      var $71=$ldcore;
      var $72=(($71)|0);
      var $73=(($72+56)|0);
      var $74=HEAPF32[(($73)>>2)];
      var $75=$origconfig;
      var $76=(($75+56)|0);
      var $77=HEAPF32[(($76)>>2)];
      var $78=$74 != $77;
      if ($78) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $79
      var $80=$overnode;
      var $81=$ldcore;
      var $82=(($81)|0);
      var $83=(($82+56)|0);
      var $84=HEAPF32[(($83)>>2)];
      var $85=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($80, ((STRING_TABLE.__str175445)|0), $84);
      $changed=1;
      __label__ = 12; break;
    case 12: // $86
      var $87=$ldcore;
      var $88=(($87)|0);
      var $89=(($88+64)|0);
      var $90=HEAPF32[(($89)>>2)];
      var $91=$origconfig;
      var $92=(($91+64)|0);
      var $93=HEAPF32[(($92)>>2)];
      var $94=$90 != $93;
      if ($94) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $95
      var $96=$overnode;
      var $97=$ldcore;
      var $98=(($97)|0);
      var $99=(($98+64)|0);
      var $100=HEAPF32[(($99)>>2)];
      var $101=__Z23xml_set_attribute_floatP14_xml_data_nodePKcf($96, ((STRING_TABLE.__str185446)|0), $100);
      $changed=1;
      __label__ = 14; break;
    case 14: // $102
      __label__ = 15; break;
    case 15: // $103
      var $104=$changed;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $106
      var $107=$ldnode;
      __Z15xml_delete_nodeP14_xml_data_node($107);
      __label__ = 17; break;
    case 17: // $108
      __label__ = 18; break;
    case 18: // $109
      __label__ = 19; break;
    case 19: // $110
      var $111=$device;
      var $112=__ZNK8device_t8typenextEv($111);
      $device=$112;
      __label__ = 3; break;
    case 20: // $113
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18configuration_saveR15running_machineiP14_xml_data_node["X"]=1;

function __ZN8delegateIFvR13screen_devicebEEC1I8device_tEEN15delegate_traitsIT_vS1_b8_noparamS8_E16static_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvR13screen_devicebEEC2I8device_tEEN15delegate_traitsIT_vS1_b8_noparamS8_E16static_func_typeEPKcPS7_($5, $6, $7, $8);
  ;
  return;
}


function __ZL20vblank_state_changedP8device_tR13screen_deviceb($device, $screen, $vblank_state) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $ldcore;
      var $curtime=__stackBase__;
      var $4=__stackBase__+12;
      var $5=__stackBase__+24;
      var $6=__stackBase__+36;
      $1=$device;
      $2=$screen;
      var $7=(($vblank_state)&1);
      $3=$7;
      var $8=$1;
      var $9=__ZL14get_safe_tokenP8device_t5459($8);
      $ld=$9;
      var $10=$ld;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      $ldcore=$12;
      var $13=$2;
      var $14=$13;
      var $15=__ZNK8device_t7machineEv($14);
      __ZNK15running_machine4timeEv($curtime, $15);
      var $16=$ldcore;
      var $17=$4;
      var $18=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];HEAP32[(($17+4)>>2)]=HEAP32[(($18+4)>>2)];HEAP32[(($17+8)>>2)]=HEAP32[(($18+8)>>2)];
      __ZL17update_slider_posP12_ldcore_data8attotime($16, $4);
      var $19=$3;
      var $20=(($19) & 1);
      if ($20) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $21
      var $22=$ldcore;
      var $23=(($22+68)|0);
      var $24=(($23+28)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $27
      var $28=$ldcore;
      var $29=(($28+68)|0);
      var $30=(($29+28)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$ld;
      var $33=$ldcore;
      var $34=(($33+266)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$ldcore;
      var $38=(($37+432)|0);
      var $39=(($38+$36*20)|0);
      var $40=$ldcore;
      var $41=(($40+266)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$5;
      var $45=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($44)>>2)]=HEAP32[(($45)>>2)];HEAP32[(($44+4)>>2)]=HEAP32[(($45+4)>>2)];HEAP32[(($44+8)>>2)]=HEAP32[(($45+8)>>2)];
      FUNCTION_TABLE[$31]($32, $39, $43, $5);
      __label__ = 3; break;
    case 3: // $46
      var $47=$2;
      var $48=$47;
      var $49=__ZNK8device_t7machineEv($48);
      var $50=__ZN15running_machine9schedulerEv($49);
      var $51=$2;
      __ZNK13screen_device14time_until_posEii($6, $51, 32, 0);
      var $52=$ld;
      var $53=$52;
      __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($50, $6, 1168, ((STRING_TABLE.__str245452)|0), 0, $53);
      __label__ = 4; break;
    case 4: // $54
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20vblank_state_changedP8device_tR13screen_deviceb["X"]=1;

function __ZL21perform_player_updateR15running_machinePvi($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $ldcore;
      var $curtime=__stackBase__;
      var $4=__stackBase__+12;
      var $5=__stackBase__+24;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $6=$2;
      var $7=$6;
      $ld=$7;
      var $8=$ld;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      $ldcore=$10;
      var $11=$1;
      __ZNK15running_machine4timeEv($curtime, $11);
      var $12=$ld;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      __ZL18process_track_dataP8device_t($14);
      var $15=$ldcore;
      var $16=$4;
      var $17=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($16)>>2)]=HEAP32[(($17)>>2)];HEAP32[(($16+4)>>2)]=HEAP32[(($17+4)>>2)];HEAP32[(($16+8)>>2)]=HEAP32[(($17+8)>>2)];
      __ZL17update_slider_posP12_ldcore_data8attotime($15, $4);
      var $18=$ldcore;
      var $19=(($18+68)|0);
      var $20=(($19+32)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $23
      var $24=$ldcore;
      var $25=$ldcore;
      var $26=(($25+68)|0);
      var $27=(($26+32)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$ld;
      var $30=$ldcore;
      var $31=(($30+266)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$ldcore;
      var $35=(($34+432)|0);
      var $36=(($35+$33*20)|0);
      var $37=$ldcore;
      var $38=(($37+266)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=$5;
      var $42=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($41)>>2)]=HEAP32[(($42)>>2)];HEAP32[(($41+4)>>2)]=HEAP32[(($42+4)>>2)];HEAP32[(($41+8)>>2)]=HEAP32[(($42+8)>>2)];
      var $43=FUNCTION_TABLE[$28]($29, $36, $40, $5);
      __ZL19add_and_clamp_trackP12_ldcore_datai($24, $43);
      __label__ = 2; break;
    case 2: // $44
      var $45=$ld;
      __ZL12update_audioP16_laserdisc_state($45);
      var $46=$ldcore;
      var $47=(($46+266)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 ^ 1;
      var $51=(($50) & 255);
      HEAP8[($47)]=$51;
      var $52=$ld;
      __ZL15read_track_dataP16_laserdisc_state($52);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21perform_player_updateR15running_machinePvi["X"]=1;

function __ZL10init_audioP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i1=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $ld;
      var $ldcore;
      $11=$device;
      var $12=$11;
      var $13=__ZL14get_safe_tokenP8device_t5459($12);
      $ld=$13;
      var $14=$ld;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      $ldcore=$16;
      var $17=$11;
      var $18=__ZNK8device_t7machineEv($17);
      var $19=$ldcore;
      var $20=(($19)|0);
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZN15running_machine6deviceEPKc($18, $22);
      var $24=$ldcore;
      var $25=(($24+428)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$ldcore;
      var $27=(($26+164)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29$0=$28;
      var $29$1=(($28|0) < 0 ? -1 : 0);
      var $$emscripten$temp$0$0=1000000;
      var $$emscripten$temp$0$1=0;
      var $30$0 = ((($29$0)>>>0)+((($29$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $30$1 = Math.min(Math.floor((((($29$0)>>>0)+((($29$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $31=$ldcore;
      var $32=(($31+160)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34$0=$33;
      var $34$1=0;
      var $35$0 = ((($30$0)>>>0)+((($30$1)|0)*4294967296))+((($34$0)>>>0)+((($34$1)|0)*4294967296))>>>0; var $35$1 = Math.min(Math.floor((((($30$0)>>>0)+((($30$1)|0)*4294967296))+((($34$0)>>>0)+((($34$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $36$0 = ((($35$0)>>>0)+((($35$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $36$1 = Math.min(Math.floor((((($35$0)>>>0)+((($35$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $37=$ldcore;
      var $38=(($37+160)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40$0=$39;
      var $40$1=0;
      var $41$0 = Math.floor(((($36$0)>>>0)+((($36$1)|0)*4294967296))/((($40$0)>>>0)+((($40$1)|0)*4294967296)))>>>0; var $41$1 = Math.min(Math.floor((Math.floor(((($36$0)>>>0)+((($36$1)|0)*4294967296))/((($40$0)>>>0)+((($40$1)|0)*4294967296))))/4294967296), 4294967295);
      var $42$0=$41$0;
      var $42=$42$0;
      var $43=$ldcore;
      var $44=(($43+424)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$ldcore;
      var $46=(($45+424)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=((($47<<2))|0);
      var $49=$ldcore;
      var $50=(($49+408)|0);
      HEAP32[(($50)>>2)]=$48;
      var $51=$11;
      var $52=__ZNK8device_t7machineEv($51);
      var $53=__ZN15running_machine7respoolEv($52);
      var $54=$ldcore;
      var $55=(($54+408)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=_llvm_umul_with_overflow_i32($56, 2);
      var $58=$57.f1;
      var $59=$57.f0;
      var $60=$58 ? -1 : $59;
      var $61=$6;
      var $62=$7;
      var $63=$8;
      var $64=$result_i;
      var $65=$9;
      var $66=$10;
      HEAP32[(($6)>>2)]=$60;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($8)>>2)]=1459;
      var $67=HEAP32[(($6)>>2)];
      var $68=HEAP32[(($7)>>2)];
      var $69=HEAP32[(($8)>>2)];
      var $70=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($67, $68, $69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $71
      HEAP32[(($result_i)>>2)]=$70;
      var $72=HEAP32[(($result_i)>>2)];
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $74
      var $75=___cxa_allocate_exception(4);
      var $76=$75;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($76);
      (function() { try { __THREW__ = false; return ___cxa_throw($75, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $77
      var $78=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $79=$78.f0;
      HEAP32[(($9)>>2)]=$79;
      var $80=$78.f1;
      HEAP32[(($10)>>2)]=$80;
      var $81=HEAP32[(($10)>>2)];
      var $82=(($81)|0) < 0;
      if ($82) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $83
      var $84=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($84);
      throw "Reached an unreachable!"
    case 5: // $85
      var $86=HEAP32[(($9)>>2)];
      var $87=HEAP32[(($9)>>2)];
      var $88=HEAP32[(($10)>>2)];
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $91
      throw "Reached an unreachable!"
    case 7: // $_ZnajPKci_exit
      var $92=HEAP32[(($result_i)>>2)];
      var $93=$6;
      var $94=$7;
      var $95=$8;
      var $96=$result_i;
      var $97=$9;
      var $98=$10;
      var $99=$92;
      var $100=$ldcore;
      var $101=(($100+408)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=__ZN13resource_pool9add_arrayIsEEPT_S2_i($53, $99, $102);
      var $104=$ldcore;
      var $105=(($104+400)|0);
      var $106=(($105)|0);
      HEAP32[(($106)>>2)]=$103;
      var $107=$11;
      var $108=__ZNK8device_t7machineEv($107);
      var $109=__ZN15running_machine7respoolEv($108);
      var $110=$ldcore;
      var $111=(($110+408)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=_llvm_umul_with_overflow_i32($112, 2);
      var $114=$113.f1;
      var $115=$113.f0;
      var $116=$114 ? -1 : $115;
      var $117=$1;
      var $118=$2;
      var $119=$3;
      var $120=$result_i1;
      var $121=$4;
      var $122=$5;
      HEAP32[(($1)>>2)]=$116;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15427)|0);
      HEAP32[(($3)>>2)]=1460;
      var $123=HEAP32[(($1)>>2)];
      var $124=HEAP32[(($2)>>2)];
      var $125=HEAP32[(($3)>>2)];
      var $126=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($123, $124, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $127
      HEAP32[(($result_i1)>>2)]=$126;
      var $128=HEAP32[(($result_i1)>>2)];
      var $129=(($128)|0)==0;
      if ($129) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $130
      var $131=___cxa_allocate_exception(4);
      var $132=$131;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($132);
      (function() { try { __THREW__ = false; return ___cxa_throw($131, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 10; break; }
    case 10: // $133
      var $134=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $135=$134.f0;
      HEAP32[(($4)>>2)]=$135;
      var $136=$134.f1;
      HEAP32[(($5)>>2)]=$136;
      var $137=HEAP32[(($5)>>2)];
      var $138=(($137)|0) < 0;
      if ($138) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $139
      var $140=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($140);
      throw "Reached an unreachable!"
    case 12: // $141
      var $142=HEAP32[(($4)>>2)];
      var $143=HEAP32[(($4)>>2)];
      var $144=HEAP32[(($5)>>2)];
      var $145=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $143, tempValue);
      var $146=($145.f1 = $144, $145);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $147
      throw "Reached an unreachable!"
    case 14: // $_ZnajPKci_exit2
      var $148=HEAP32[(($result_i1)>>2)];
      var $149=$1;
      var $150=$2;
      var $151=$3;
      var $152=$result_i1;
      var $153=$4;
      var $154=$5;
      var $155=$148;
      var $156=$ldcore;
      var $157=(($156+408)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=__ZN13resource_pool9add_arrayIsEEPT_S2_i($109, $155, $158);
      var $160=$ldcore;
      var $161=(($160+400)|0);
      var $162=(($161+4)|0);
      HEAP32[(($162)>>2)]=$159;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10init_audioP8device_t["X"]=1;

function __ZL18process_track_dataP8device_t($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ld;
      var $ldcore;
      var $chnum;
      var $samplesleft;
      $1=$device;
      var $2=$1;
      var $3=__ZL14get_safe_tokenP8device_t5459($2);
      $ld=$3;
      var $4=$ld;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      $ldcore=$6;
      var $7=$ldcore;
      var $8=(($7+168)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==25;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$ldcore;
      var $13=(($12+144)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z18chd_async_completeP9_chd_file($14);
      var $16=$ldcore;
      var $17=(($16+168)|0);
      HEAP32[(($17)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $18
      var $19=$ldcore;
      var $20=(($19+168)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$ldcore;
      var $25=(($24+176)|0);
      var $26=(($25)|0);
      HEAP32[(($26)>>2)]=0;
      __label__ = 4; break;
    case 4: // $27
      var $28=$ldcore;
      var $29=(($28+176)|0);
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$ldcore;
      var $35=(($34+344)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$ldcore;
      var $39=(($38+296)|0);
      var $40=(($39+($37<<4))|0);
      var $41=(($40+8)|0);
      var $42=HEAP8[($41)];
      var $43=(($42+1)&255);
      HEAP8[($41)]=$43;
      __label__ = 6; break;
    case 6: // $44
      var $45=$ldcore;
      var $46=(($45+176)|0);
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $50
      var $51=$ldcore;
      var $52=(($51+68)|0);
      var $53=(($52+36)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $56
      var $57=$ldcore;
      var $58=(($57+68)|0);
      var $59=(($58+36)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$ld;
      var $62=$ldcore;
      var $63=(($62+176)|0);
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      FUNCTION_TABLE[$60]($61, $65);
      __label__ = 9; break;
    case 9: // $66
      var $67=$ldcore;
      var $68=(($67)|0);
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$ldcore;
      var $74=(($73)|0);
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$1;
      var $78=$ldcore;
      var $79=(($78+164)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$ldcore;
      var $82=(($81+420)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$ldcore;
      var $85=(($84+176)|0);
      var $86=(($85+12)|0);
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$ldcore;
      var $90=(($89+176)|0);
      var $91=(($90+12)|0);
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      FUNCTION_TABLE[$76]($77, $80, $83, $88, $93);
      __label__ = 11; break;
    case 11: // $94
      var $95=$ldcore;
      var $96=(($95+420)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 12; break; } else { __label__ = 25; break; }
    case 12: // $99
      var $100=$ldcore;
      var $101=(($100+412)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 13; break; } else { __label__ = 25; break; }
    case 13: // $104
      $chnum=0;
      __label__ = 14; break;
    case 14: // $105
      var $106=$chnum;
      var $107=(($106)|0) < 2;
      if ($107) { __label__ = 15; break; } else { __label__ = 24; break; }
    case 15: // $108
      var $109=$chnum;
      var $110=$ldcore;
      var $111=(($110+176)|0);
      var $112=(($111+12)|0);
      var $113=(($112+($109<<2))|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$chnum;
      var $116=$ldcore;
      var $117=(($116+400)|0);
      var $118=(($117+($115<<2))|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119)|0);
      var $121=(($114)|0)==(($120)|0);
      if ($121) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $122
      var $123=$ldcore;
      var $124=(($123+408)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$ldcore;
      var $127=(($126+412)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($125-$128)|0);
      $samplesleft=$129;
      var $130=$samplesleft;
      var $131=$ldcore;
      var $132=(($131+420)|0);
      var $133=HEAPU32[(($132)>>2)];
      var $134=(($130)>>>0) < (($133)>>>0);
      if ($134) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $135
      var $136=$samplesleft;
      var $142 = $136;__label__ = 19; break;
    case 18: // $137
      var $138=$ldcore;
      var $139=(($138+420)|0);
      var $140=HEAP32[(($139)>>2)];
      var $142 = $140;__label__ = 19; break;
    case 19: // $141
      var $142;
      $samplesleft=$142;
      var $143=$ldcore;
      var $144=(($143+412)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$chnum;
      var $147=$ldcore;
      var $148=(($147+400)|0);
      var $149=(($148+($146<<2))|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150+($145<<1))|0);
      var $152=$151;
      var $153=$chnum;
      var $154=$ldcore;
      var $155=(($154+400)|0);
      var $156=(($155+($153<<2))|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0);
      var $159=$158;
      var $160=$samplesleft;
      var $161=((($160<<1))|0);
      _llvm_memmove_p0i8_p0i8_i32($152, $159, $161, 1, 0);
      var $162=$samplesleft;
      var $163=$ldcore;
      var $164=(($163+420)|0);
      var $165=HEAPU32[(($164)>>2)];
      var $166=(($162)>>>0) < (($165)>>>0);
      if ($166) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $167
      var $168=$chnum;
      var $169=$ldcore;
      var $170=(($169+400)|0);
      var $171=(($170+($168<<2))|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172)|0);
      var $174=$173;
      var $175=$samplesleft;
      var $176=$chnum;
      var $177=$ldcore;
      var $178=(($177+400)|0);
      var $179=(($178+($176<<2))|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180+($175<<1))|0);
      var $182=$181;
      var $183=$ldcore;
      var $184=(($183+420)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$samplesleft;
      var $187=(($185-$186)|0);
      var $188=((($187<<1))|0);
      _llvm_memmove_p0i8_p0i8_i32($174, $182, $188, 1, 0);
      __label__ = 21; break;
    case 21: // $189
      __label__ = 22; break;
    case 22: // $190
      __label__ = 23; break;
    case 23: // $191
      var $192=$chnum;
      var $193=(($192+1)|0);
      $chnum=$193;
      __label__ = 14; break;
    case 24: // $194
      __label__ = 25; break;
    case 25: // $195
      var $196=$ldcore;
      var $197=(($196+412)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=$ldcore;
      var $200=(($199+420)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=(($198+$201)|0);
      var $203=$ldcore;
      var $204=(($203+408)|0);
      var $205=HEAPU32[(($204)>>2)];
      var $206=(($202)>>>0)%(($205)>>>0);
      var $207=$ldcore;
      var $208=(($207+412)|0);
      HEAP32[(($208)>>2)]=$206;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18process_track_dataP8device_t["X"]=1;

function __ZL15read_track_dataP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ldcore;
      var $tracknum;
      var $fieldnum;
      var $vbidata=__stackBase__;
      var $frame;
      var $vbiframe=__stackBase__+20;
      var $readhunk;
      var $chdtrack;
      $1=$ld;
      var $2=$1;
      var $3=(($2+8)|0);
      var $4=HEAP32[(($3)>>2)];
      $ldcore=$4;
      var $5=$ldcore;
      var $6=(($5+268)|0);
      var $7=HEAP32[(($6)>>2)];
      $tracknum=$7;
      var $8=$ldcore;
      var $9=(($8+266)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      $fieldnum=$11;
      var $12=$vbidata;
      HEAP32[(($12)>>2)]=0; HEAP32[(($12+4)>>2)]=0; HEAP32[(($12+8)>>2)]=0; HEAP32[(($12+12)>>2)]=0; HEAP32[(($12+16)>>2)]=0;
      var $13=$tracknum;
      var $14=(($13-1)|0);
      var $15=(($14-900)|0);
      $chdtrack=$15;
      var $16=$chdtrack;
      var $17=(($16)|0) > 0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$chdtrack;
      var $22 = $19;__label__ = 3; break;
    case 2: // $20
      var $22 = 0;__label__ = 3; break;
    case 3: // $21
      var $22;
      $chdtrack=$22;
      var $23=$chdtrack;
      var $24=$ldcore;
      var $25=(($24+172)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26-1)|0);
      var $28=(($23)>>>0) < (($27)>>>0);
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $29
      var $30=$chdtrack;
      var $37 = $30;__label__ = 6; break;
    case 5: // $31
      var $32=$ldcore;
      var $33=(($32+172)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34-1)|0);
      var $37 = $35;__label__ = 6; break;
    case 6: // $36
      var $37;
      $chdtrack=$37;
      var $38=$chdtrack;
      var $39=((($38<<1))|0);
      var $40=$fieldnum;
      var $41=(($39+$40)|0);
      $readhunk=$41;
      var $42=$ldcore;
      var $43=(($42+148)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      var $47=$readhunk;
      var $48=((($47<<4))|0);
      var $49=$ldcore;
      var $50=(($49+148)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$48)|0);
      __Z19vbi_metadata_unpackP13_vbi_metadataPjPKh($vbidata, 0, $52);
      __label__ = 8; break;
    case 8: // $53
      var $54=$tracknum;
      var $55=(($54-1)|0);
      var $56=(($55)>>>0) < 900;
      if ($56) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $57
      var $58=(($vbidata+4)|0);
      HEAP32[(($58)>>2)]=0;
      var $59=(($vbidata+16)|0);
      HEAP32[(($59)>>2)]=8978431;
      var $60=(($vbidata+12)|0);
      HEAP32[(($60)>>2)]=8978431;
      var $61=(($vbidata+8)|0);
      HEAP32[(($61)>>2)]=8978431;
      __label__ = 10; break;
    case 10: // $62
      var $63=$ldcore;
      var $64=(($63+344)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=$ldcore;
      var $68=(($67+296)|0);
      var $69=(($68+($66<<4))|0);
      $frame=$69;
      var $70=(($vbidata+16)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71 & 15728640;
      var $73=(($72)|0)==15728640;
      if ($73) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $74
      var $75=$frame;
      var $76=(($75+8)|0);
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $79=(($78)|0) >= 2;
      if ($79) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $80
      var $81=$ldcore;
      var $82=(($81+344)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=(($84+1)|0);
      var $86=(($85)>>>0)%3;
      var $87=(($86) & 255);
      var $88=$ldcore;
      var $89=(($88+344)|0);
      HEAP8[($89)]=$87;
      __label__ = 13; break;
    case 13: // $90
      var $91=$ldcore;
      var $92=(($91+344)|0);
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=$ldcore;
      var $96=(($95+296)|0);
      var $97=(($96+($94<<4))|0);
      $frame=$97;
      var $98=$frame;
      var $99=(($98+8)|0);
      HEAP8[($99)]=0;
      __label__ = 14; break;
    case 14: // $100
      var $101=$ldcore;
      var $102=(($101+265)|0);
      var $103=HEAP8[($102)];
      var $104=(($103 << 24) >> 24)!=0;
      if ($104) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $105
      var $106=$frame;
      var $107=(($106+8)|0);
      HEAP8[($107)]=0;
      __label__ = 16; break;
    case 16: // $108
      var $109=$tracknum;
      var $110=((($109<<1))|0);
      var $111=$fieldnum;
      var $112=(($110+$111)|0);
      var $113=$frame;
      var $114=(($113+12)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=$ldcore;
      var $116=(($115+348)|0);
      var $117=$116;
      var $118=(($117)|0);
      HEAP32[(($118)>>2)]=0;
      var $119=$frame;
      var $120=(($119)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121;
      var $123=(($122+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$124;
      var $126=$fieldnum;
      var $127=$frame;
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$129;
      var $131=(($130+8)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($126*$132)|0);
      var $134=(($125+($133<<1))|0);
      var $135=(($134)|0);
      var $136=$135;
      var $137=$ldcore;
      var $138=(($137+348)|0);
      var $139=$138;
      var $140=(($139+4)|0);
      HEAP32[(($140)>>2)]=$136;
      var $141=$frame;
      var $142=(($141)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$143;
      var $145=(($144+8)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=((($146<<1))|0);
      var $148=$ldcore;
      var $149=(($148+348)|0);
      var $150=$149;
      var $151=(($150+8)|0);
      HEAP32[(($151)>>2)]=$147;
      var $152=$frame;
      var $153=(($152)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$154;
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$ldcore;
      var $159=(($158+348)|0);
      var $160=$159;
      var $161=(($160+12)|0);
      HEAP32[(($161)>>2)]=$157;
      var $162=$frame;
      var $163=(($162)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164;
      var $166=(($165+16)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(((($167)|0)/2)|0);
      var $169=$ldcore;
      var $170=(($169+348)|0);
      var $171=$170;
      var $172=(($171+16)|0);
      HEAP32[(($172)>>2)]=$168;
      var $173=$frame;
      var $174=(($173)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=$175;
      var $177=(($176+20)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=$ldcore;
      var $180=(($179+348)|0);
      var $181=$180;
      var $182=(($181+20)|0);
      HEAP32[(($182)>>2)]=$178;
      var $183=$frame;
      var $184=(($183)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$185;
      var $187=(($186+24)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$ldcore;
      var $190=(($189+348)|0);
      var $191=$190;
      var $192=(($191+24)|0);
      HEAP32[(($192)>>2)]=$188;
      var $193=$frame;
      var $194=(($193)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=$195;
      var $197=(($196+28)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=$ldcore;
      var $200=(($199+348)|0);
      var $201=$200;
      var $202=(($201+28)|0);
      HEAP32[(($202)>>2)]=$198;
      var $203=$ldcore;
      var $204=(($203+348)|0);
      var $205=$204;
      var $206=(($205+32)|0);
      var $207=$frame;
      var $208=(($207)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$209;
      var $211=(($210+32)|0);
      var $212=$206;
      var $213=$211;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($212)>>2)]=HEAP32[(($213)>>2)];HEAP32[(($212+4)>>2)]=HEAP32[(($213+4)>>2)];HEAP32[(($212+8)>>2)]=HEAP32[(($213+8)>>2)];HEAP32[(($212+12)>>2)]=HEAP32[(($213+12)>>2)];
      var $214=$ldcore;
      var $215=(($214+348)|0);
      var $216=$ldcore;
      var $217=(($216+176)|0);
      var $218=(($217)|0);
      HEAP32[(($218)>>2)]=$215;
      var $219=$ldcore;
      var $220=(($219+412)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=$ldcore;
      var $223=(($222+424)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($221+$224)|0);
      var $226=$ldcore;
      var $227=(($226+408)|0);
      var $228=HEAPU32[(($227)>>2)];
      var $229=(($225)>>>0) <= (($228)>>>0);
      if ($229) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $230
      var $231=$ldcore;
      var $232=(($231+412)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$ldcore;
      var $235=(($234+400)|0);
      var $236=(($235)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=(($237+($233<<1))|0);
      var $239=$ldcore;
      var $240=(($239+176)|0);
      var $241=(($240+12)|0);
      var $242=(($241)|0);
      HEAP32[(($242)>>2)]=$238;
      var $243=$ldcore;
      var $244=(($243+412)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=$ldcore;
      var $247=(($246+400)|0);
      var $248=(($247+4)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(($249+($245<<1))|0);
      var $251=$ldcore;
      var $252=(($251+176)|0);
      var $253=(($252+12)|0);
      var $254=(($253+4)|0);
      HEAP32[(($254)>>2)]=$250;
      __label__ = 19; break;
    case 18: // $255
      var $256=$ldcore;
      var $257=(($256+400)|0);
      var $258=(($257)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($259)|0);
      var $261=$ldcore;
      var $262=(($261+176)|0);
      var $263=(($262+12)|0);
      var $264=(($263)|0);
      HEAP32[(($264)>>2)]=$260;
      var $265=$ldcore;
      var $266=(($265+400)|0);
      var $267=(($266+4)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(($268)|0);
      var $270=$ldcore;
      var $271=(($270+176)|0);
      var $272=(($271+12)|0);
      var $273=(($272+4)|0);
      HEAP32[(($273)>>2)]=$269;
      __label__ = 19; break;
    case 19: // $274
      var $275=$ldcore;
      var $276=(($275+424)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$ldcore;
      var $279=(($278+176)|0);
      var $280=(($279+4)|0);
      HEAP32[(($280)>>2)]=$277;
      var $281=$ldcore;
      var $282=(($281+420)|0);
      var $283=$ldcore;
      var $284=(($283+176)|0);
      var $285=(($284+8)|0);
      HEAP32[(($285)>>2)]=$282;
      var $286=$ldcore;
      var $287=(($286+420)|0);
      HEAP32[(($287)>>2)]=0;
      var $288=$ldcore;
      var $289=(($288+148)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)!=0;
      if ($291) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $292
      var $293=$fieldnum;
      var $294=$ldcore;
      var $295=(($294+432)|0);
      var $296=(($295+$293*20)|0);
      var $297=$readhunk;
      var $298=((($297<<4))|0);
      var $299=$ldcore;
      var $300=(($299+148)|0);
      var $301=HEAP32[(($300)>>2)];
      var $302=(($301+$298)|0);
      __Z19vbi_metadata_unpackP13_vbi_metadataPjPKh($296, $vbiframe, $302);
      __label__ = 21; break;
    case 21: // $303
      var $304=$tracknum;
      var $305=(($304-1)|0);
      var $306=(($305)>>>0) < 900;
      if ($306) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $307
      var $308=$fieldnum;
      var $309=$ldcore;
      var $310=(($309+432)|0);
      var $311=(($310+$308*20)|0);
      var $312=(($311+4)|0);
      HEAP32[(($312)>>2)]=0;
      var $313=$fieldnum;
      var $314=$ldcore;
      var $315=(($314+432)|0);
      var $316=(($315+$313*20)|0);
      var $317=(($316+16)|0);
      HEAP32[(($317)>>2)]=8978431;
      var $318=$fieldnum;
      var $319=$ldcore;
      var $320=(($319+432)|0);
      var $321=(($320+$318*20)|0);
      var $322=(($321+12)|0);
      HEAP32[(($322)>>2)]=8978431;
      var $323=$fieldnum;
      var $324=$ldcore;
      var $325=(($324+432)|0);
      var $326=(($325+$323*20)|0);
      var $327=(($326+8)|0);
      HEAP32[(($327)>>2)]=8978431;
      __label__ = 23; break;
    case 23: // $328
      var $329=$ldcore;
      var $330=(($329+168)|0);
      HEAP32[(($330)>>2)]=6;
      var $331=$ldcore;
      var $332=(($331+144)|0);
      var $333=HEAP32[(($332)>>2)];
      var $334=(($333)|0)!=0;
      if ($334) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $335
      var $336=$ldcore;
      var $337=(($336+265)|0);
      var $338=HEAP8[($337)];
      var $339=(($338 << 24) >> 24)!=0;
      if ($339) { __label__ = 28; break; } else { __label__ = 25; break; }
    case 25: // $340
      var $341=$ldcore;
      var $342=(($341+144)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=$ldcore;
      var $345=(($344+176)|0);
      var $346=$345;
      var $347=__Z16chd_codec_configP9_chd_fileiPv($343, 2, $346);
      var $348=$ldcore;
      var $349=(($348+168)|0);
      HEAP32[(($349)>>2)]=$347;
      var $350=$ldcore;
      var $351=(($350+168)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=(($352)|0)==0;
      if ($353) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $354
      var $355=$ldcore;
      var $356=(($355+144)|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=$readhunk;
      var $359=__Z14chd_read_asyncP9_chd_filejPv($357, $358, 0);
      var $360=$ldcore;
      var $361=(($360+168)|0);
      HEAP32[(($361)>>2)]=$359;
      __label__ = 27; break;
    case 27: // $362
      __label__ = 28; break;
    case 28: // $363
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15read_track_dataP16_laserdisc_state["X"]=1;

function __ZN8delegateIFvR13screen_devicebEEC2I8device_tEEN15delegate_traitsIT_vS1_b8_noparamS8_E16static_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I8device_tEEN15delegate_traitsIT_vS1_bS2_S2_E16static_func_typeEPKcPS7_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I8device_tEEN15delegate_traitsIT_vS1_bS2_S2_E16static_func_typeEPKcPS7_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1170;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI8device_t, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12_ldcore_dataC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=(($2+68)|0);
  var $5=(($2+176)|0);
  var $6=(($2+284)|0);
  __ZN8attotimeC1Ev($6);
  var $7=(($2+296)|0);
  var $8=(($2+348)|0);
  FUNCTION_TABLE[__ZN8bitmap_tC1Ev]($8);
  var $9=(($2+432)|0);
  ;
  return;
}


function __ZN20resource_pool_objectI12_ldcore_dataEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI12_ldcore_dataEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI12_ldcore_dataEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 512);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI12_ldcore_dataE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI12_ldcore_dataED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI12_ldcore_dataED2Ev($2);
  ;
  return;
}


function __ZN20resource_pool_objectI12_ldcore_dataED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI12_ldcore_dataED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12_ldcore_dataED0Ev["X"]=1;

function __Z18vector_get_flickerv() {
  ;
  var __label__;

  var $1=HEAPF32[((__ZL18flicker_correction)>>2)];
  ;
  return $1;
}


function __Z15vector_get_beamv() {
  ;
  var __label__;

  var $1=HEAPF32[((__ZL10beam_width)>>2)];
  ;
  return $1;
}


function __Z15vector_set_beamf($_beam) {
  ;
  var __label__;

  var $1;
  $1=$_beam;
  var $2=$1;
  HEAPF32[((__ZL10beam_width)>>2)]=$2;
  ;
  return;
}


function __Z18vector_set_flickerf($_flicker) {
  ;
  var __label__;

  var $1;
  $1=$_flicker;
  var $2=$1;
  HEAPF32[((__ZL18flicker_correction)>>2)]=$2;
  var $3=HEAPF32[((__ZL18flicker_correction)>>2)];
  var $4=$3;
  var $5=$4*2.55;
  var $6=(($5)|0);
  HEAP32[((__ZL7flicker)>>2)]=$6;
  ;
  return;
}


function __Z17text_buffer_clearP12_text_buffer($text) {
  ;
  var __label__;

  var $1;
  $1=$text;
  var $2=$1;
  var $3=(($2+12)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=$1;
  var $5=(($4+16)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=$1;
  var $7=(($6+24)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$1;
  var $9=(($8+28)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=$1;
  var $11=(($10+32)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=$1;
  var $13=(($12+36)|0);
  HEAP32[(($13)>>2)]=0;
  var $14=$1;
  var $15=(($14+4)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=(($16)|0);
  HEAP32[(($17)>>2)]=0;
  var $18=$1;
  var $19=(($18+4)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$1;
  var $24=(($23)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25+$22)|0);
  HEAP8[($26)]=0;
  ;
  return;
}


function __ZN12_ldcore_dataD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12_ldcore_dataD2Ev($2);
  ;
  return;
}


function __ZN12_ldcore_dataD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+348)|0);
  FUNCTION_TABLE[__ZN8bitmap_tD1Ev]($3);
  ;
  return;
}


function __Z8wav_openPKcii($filename, $sample_rate, $channels) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $wav;
      var $bps;
      var $temp32=__stackBase__;
      var $align;
      var $temp16=__stackBase__+4;
      $2=$filename;
      $3=$sample_rate;
      $4=$channels;
      var $5=_osd_malloc(12);
      var $6=$5;
      $wav=$6;
      var $7=$wav;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      $1=0;
      __label__ = 5; break;
    case 2: // $10
      var $11=$2;
      var $12=_fopen($11, ((STRING_TABLE.__str5479)|0));
      var $13=$wav;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=$12;
      var $15=$wav;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      var $20=$wav;
      var $21=$20;
      _osd_free($21);
      $1=0;
      __label__ = 5; break;
    case 4: // $22
      var $23=$wav;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=_fwrite(((STRING_TABLE.__str15480)|0), 1, 4, $25);
      HEAP32[(($temp32)>>2)]=0;
      var $27=$wav;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=_ftell($29);
      var $31=$wav;
      var $32=(($31+4)|0);
      HEAP32[(($32)>>2)]=$30;
      var $33=$temp32;
      var $34=$wav;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=_fwrite($33, 1, 4, $36);
      var $38=$wav;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=_fwrite(((STRING_TABLE.__str25481)|0), 1, 4, $40);
      var $42=$wav;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_fwrite(((STRING_TABLE.__str35482)|0), 1, 4, $44);
      HEAP32[(($temp32)>>2)]=16;
      var $46=$temp32;
      var $47=$wav;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=_fwrite($46, 1, 4, $49);
      HEAP16[(($temp16)>>1)]=1;
      var $51=$temp16;
      var $52=$wav;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=_fwrite($51, 1, 2, $54);
      var $56=$4;
      var $57=(($56) & 65535);
      HEAP16[(($temp16)>>1)]=$57;
      var $58=$temp16;
      var $59=$wav;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=_fwrite($58, 1, 2, $61);
      var $63=$3;
      HEAP32[(($temp32)>>2)]=$63;
      var $64=$temp32;
      var $65=$wav;
      var $66=(($65)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=_fwrite($64, 1, 4, $67);
      var $69=$3;
      var $70=((($69<<1))|0);
      var $71=$4;
      var $72=(($70*$71)|0);
      $bps=$72;
      var $73=$bps;
      HEAP32[(($temp32)>>2)]=$73;
      var $74=$temp32;
      var $75=$wav;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=_fwrite($74, 1, 4, $77);
      var $79=$4;
      var $80=((($79<<1))|0);
      var $81=(($80) & 65535);
      $align=$81;
      var $82=$align;
      HEAP16[(($temp16)>>1)]=$82;
      var $83=$temp16;
      var $84=$wav;
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=_fwrite($83, 1, 2, $86);
      HEAP16[(($temp16)>>1)]=16;
      var $88=$temp16;
      var $89=$wav;
      var $90=(($89)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=_fwrite($88, 1, 2, $91);
      var $93=$wav;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=_fwrite(((STRING_TABLE.__str45483)|0), 1, 4, $95);
      HEAP32[(($temp32)>>2)]=0;
      var $97=$wav;
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=_ftell($99);
      var $101=$wav;
      var $102=(($101+8)|0);
      HEAP32[(($102)>>2)]=$100;
      var $103=$temp32;
      var $104=$wav;
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=_fwrite($103, 1, 4, $106);
      var $108=$wav;
      $1=$108;
      __label__ = 5; break;
    case 5: // $109
      var $110=$1;
      STACKTOP = __stackBase__;
      return $110;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z8wav_openPKcii["X"]=1;

function __Z9wav_closeP9_wav_file($wav) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $total;
      var $temp32=__stackBase__;
      $1=$wav;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      __label__ = 3; break;
    case 2: // $5
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=_ftell($8);
      $total=$9;
      var $10=$1;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$1;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=_fseek($12, $15, 0);
      var $17=$total;
      var $18=$1;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+4)|0);
      var $22=(($17-$21)|0);
      HEAP32[(($temp32)>>2)]=$22;
      var $23=HEAP32[(($temp32)>>2)];
      HEAP32[(($temp32)>>2)]=$23;
      var $24=$temp32;
      var $25=$1;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=_fwrite($24, 1, 4, $27);
      var $29=$1;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$1;
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=_fseek($31, $34, 0);
      var $36=$total;
      var $37=$1;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+4)|0);
      var $41=(($36-$40)|0);
      HEAP32[(($temp32)>>2)]=$41;
      var $42=HEAP32[(($temp32)>>2)];
      HEAP32[(($temp32)>>2)]=$42;
      var $43=$temp32;
      var $44=$1;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=_fwrite($43, 1, 4, $46);
      var $48=$1;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=_fclose($50);
      var $52=$1;
      var $53=$52;
      _osd_free($53);
      __label__ = 3; break;
    case 3: // $54
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z9wav_closeP9_wav_file["X"]=1;

function __Z15wav_add_data_16P9_wav_filePsi($wav, $data, $samples) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$wav;
      $2=$data;
      $3=$samples;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      __label__ = 3; break;
    case 2: // $7
      var $8=$2;
      var $9=$8;
      var $10=$3;
      var $11=$1;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=_fwrite($9, 2, $10, $13);
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=_fflush($17);
      __label__ = 3; break;
    case 3: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17text_buffer_allocjj($bytes, $lines) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $text;
      $2=$bytes;
      $3=$lines;
      var $4=_osd_malloc(40);
      var $5=$4;
      $text=$5;
      var $6=$text;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      $1=0;
      __label__ = 7; break;
    case 2: // $9
      var $10=$2;
      var $11=_osd_malloc_array($10);
      var $12=$text;
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$text;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$text;
      var $20=$19;
      _osd_free($20);
      $1=0;
      __label__ = 7; break;
    case 4: // $21
      var $22=$3;
      var $23=((($22<<2))|0);
      var $24=_osd_malloc_array($23);
      var $25=$24;
      var $26=$text;
      var $27=(($26+4)|0);
      HEAP32[(($27)>>2)]=$25;
      var $28=$text;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $32
      var $33=$text;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      _osd_free($35);
      var $36=$text;
      var $37=$36;
      _osd_free($37);
      $1=0;
      __label__ = 7; break;
    case 6: // $38
      var $39=$2;
      var $40=$text;
      var $41=(($40+8)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$3;
      var $43=$text;
      var $44=(($43+20)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$text;
      __Z17text_buffer_clearP12_text_buffer($45);
      var $46=$text;
      $1=$46;
      __label__ = 7; break;
    case 7: // $47
      var $48=$1;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17text_buffer_allocjj["X"]=1;

function __Z16text_buffer_freeP12_text_buffer($text) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$text;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9;
      _osd_free($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      _osd_free($19);
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      var $22=$21;
      _osd_free($22);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17text_buffer_printP12_text_bufferPKc($text, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$text;
  $2=$data;
  var $3=$1;
  var $4=$2;
  __Z22text_buffer_print_wrapP12_text_bufferPKci($3, $4, 10000);
  ;
  return;
}


function __ZN20resource_pool_objectI12_ldcore_dataED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectI12_ldcore_dataE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN12_ldcore_dataD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI12_ldcore_dataED2Ev["X"]=1;

function __Z21text_buffer_max_widthP12_text_buffer($text) {
  ;
  var __label__;

  var $1;
  $1=$text;
  var $2=$1;
  var $3=(($2+36)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z21text_buffer_num_linesP12_text_buffer($text) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $lines;
      $1=$text;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+1)|0);
      var $6=$1;
      var $7=(($6+24)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5-$8)|0);
      $lines=$9;
      var $10=$lines;
      var $11=(($10)|0) <= 0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$1;
      var $14=(($13+20)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$lines;
      var $17=(($16+$15)|0);
      $lines=$17;
      __label__ = 2; break;
    case 2: // $18
      var $19=$lines;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z32text_buffer_line_index_to_seqnumP12_text_bufferj($text, $index) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$text;
  $2=$index;
  var $3=$1;
  var $4=(($3+32)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=(($5+$6)|0);
  ;
  return $7;
}


function __ZL11buffer_usedP12_text_buffer($text) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $used;
      $1=$text;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$1;
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4-$7)|0);
      $used=$8;
      var $9=$used;
      var $10=(($9)|0) < 0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$1;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$used;
      var $16=(($15+$14)|0);
      $used=$16;
      __label__ = 2; break;
    case 2: // $17
      var $18=$used;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11execute_minR12symbol_tablePviPKy($table, $ref, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$table;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$4;
      var $6=(($5)|0);
      var $st$10$0=(($6)|0);
      var $7$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$10$1)>>2)];
      var $8=$4;
      var $9=(($8+8)|0);
      var $st$16$0=(($9)|0);
      var $10$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$16$1)>>2)];
      var $11=$7$1 < $10$1 || ($7$1 == $10$1 && $7$0 < $10$0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$4;
      var $14=(($13)|0);
      var $st$2$0=(($14)|0);
      var $15$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$2$1)>>2)];
      var $21$1 = $15$1;var $21$0 = $15$0;__label__ = 3; break;
    case 2: // $16
      var $17=$4;
      var $18=(($17+8)|0);
      var $st$2$0=(($18)|0);
      var $19$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$2$1)>>2)];
      var $21$1 = $19$1;var $21$0 = $19$0;__label__ = 3; break;
    case 3: // $20
      var $21$0;
      var $21$1;
      ;
      return [$21$0,$21$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11execute_maxR12symbol_tablePviPKy($table, $ref, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$table;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$4;
      var $6=(($5)|0);
      var $st$10$0=(($6)|0);
      var $7$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$10$1)>>2)];
      var $8=$4;
      var $9=(($8+8)|0);
      var $st$16$0=(($9)|0);
      var $10$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($9+4)|0);
      var $10$1=HEAP32[(($st$16$1)>>2)];
      var $11=$7$1 > $10$1 || ($7$1 == $10$1 && $7$0 > $10$0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$4;
      var $14=(($13)|0);
      var $st$2$0=(($14)|0);
      var $15$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$2$1)>>2)];
      var $21$1 = $15$1;var $21$0 = $15$0;__label__ = 3; break;
    case 2: // $16
      var $17=$4;
      var $18=(($17+8)|0);
      var $st$2$0=(($18)|0);
      var $19$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$2$1)>>2)];
      var $21$1 = $19$1;var $21$0 = $19$0;__label__ = 3; break;
    case 3: // $20
      var $21$0;
      var $21$1;
      ;
      return [$21$0,$21$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10execute_ifR12symbol_tablePviPKy($table, $ref, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$table;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$4;
      var $6=(($5)|0);
      var $st$10$0=(($6)|0);
      var $7$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($6+4)|0);
      var $7$1=HEAP32[(($st$10$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $8=$7$0 != $$emscripten$temp$0$0 || $7$1 != $$emscripten$temp$0$1;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$4;
      var $11=(($10+8)|0);
      var $st$2$0=(($11)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $18$1 = $12$1;var $18$0 = $12$0;__label__ = 3; break;
    case 2: // $13
      var $14=$4;
      var $15=(($14+16)|0);
      var $st$2$0=(($15)|0);
      var $16$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$2$1)>>2)];
      var $18$1 = $16$1;var $18$0 = $16$0;__label__ = 3; break;
    case 3: // $17
      var $18$0;
      var $18$1;
      ;
      return [$18$0,$18$1];
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z22text_buffer_print_wrapP12_text_bufferPKci($text, $data, $wrapcol) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $stopcol;
      var $needed_space;
      var $ch;
      var $linelen;
      var $overflow;
      $1=$text;
      $2=$data;
      $3=$wrapcol;
      var $4=$3;
      var $5=(($4)|0) < 250;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$3;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 250;__label__ = 3; break;
    case 3: // $9
      var $10;
      $stopcol=$10;
      var $11=$2;
      var $12=_strlen($11);
      var $13=(($12+250)|0);
      $needed_space=$13;
      __label__ = 4; break;
    case 4: // $14
      var $15=$1;
      var $16=__ZL12buffer_spaceP12_text_buffer($15);
      var $17=$needed_space;
      var $18=(($16)|0) < (($17)|0);
      if ($18) { __label__ = 5; break; } else { var $28 = 0;__label__ = 6; break; }
    case 5: // $19
      var $20=$1;
      var $21=(($20+24)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=(($23+28)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($22)|0)!=(($25)|0);
      var $28 = $26;__label__ = 6; break;
    case 6: // $27
      var $28;
      if ($28) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $29
      var $30=$1;
      var $31=(($30+32)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+1)|0);
      HEAP32[(($31)>>2)]=$33;
      var $34=$1;
      var $35=(($34+24)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      HEAP32[(($35)>>2)]=$37;
      var $38=$1;
      var $39=(($38+20)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($37)|0) >= (($40)|0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$1;
      var $44=(($43+24)|0);
      HEAP32[(($44)>>2)]=0;
      __label__ = 9; break;
    case 9: // $45
      var $46=$1;
      var $47=(($46+24)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$1;
      var $50=(($49+4)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+($48<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$1;
      var $55=(($54+12)|0);
      HEAP32[(($55)>>2)]=$53;
      __label__ = 4; break;
    case 10: // $56
      __label__ = 11; break;
    case 11: // $57
      var $58=$2;
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24)!=0;
      if ($60) { __label__ = 12; break; } else { __label__ = 48; break; }
    case 12: // $61
      var $62=$2;
      var $63=HEAP8[($62)];
      var $64=(($63 << 24) >> 24);
      $ch=$64;
      var $65=$ch;
      var $66=(($65)|0)==13;
      if ($66) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $67
      var $68=$1;
      var $69=(($68+28)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$1;
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+($70<<2))|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$1;
      var $77=(($76+16)|0);
      HEAP32[(($77)>>2)]=$75;
      __label__ = 17; break;
    case 14: // $78
      var $79=$ch;
      var $80=(($79)|0)!=10;
      if ($80) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $81
      var $82=$ch;
      var $83=(($82) & 255);
      var $84=$1;
      var $85=(($84+16)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+1)|0);
      HEAP32[(($85)>>2)]=$87;
      var $88=$1;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+$86)|0);
      HEAP8[($91)]=$83;
      __label__ = 16; break;
    case 16: // $92
      __label__ = 17; break;
    case 17: // $93
      var $94=$1;
      var $95=(($94+16)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$1;
      var $98=(($97+28)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$1;
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+($99<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($96-$104)|0);
      $linelen=$105;
      var $106=$ch;
      var $107=(($106)|0)==10;
      if ($107) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $108
      var $109=$linelen;
      var $110=$stopcol;
      var $111=(($109)|0) >= (($110)|0);
      if ($111) { __label__ = 19; break; } else { __label__ = 46; break; }
    case 19: // $112
      $overflow=0;
      var $113=$linelen;
      var $114=$3;
      var $115=(($113)|0) >= (($114)|0);
      if ($115) { __label__ = 20; break; } else { __label__ = 29; break; }
    case 20: // $116
      $overflow=1;
      __label__ = 21; break;
    case 21: // $117
      var $118=$overflow;
      var $119=$linelen;
      var $120=(($118)|0) < (($119)|0);
      if ($120) { __label__ = 22; break; } else { var $135 = 0;__label__ = 23; break; }
    case 22: // $121
      var $122=$1;
      var $123=(($122+16)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$overflow;
      var $126=(($124-$125)|0);
      var $127=$1;
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+$126)|0);
      var $131=HEAP8[($130)];
      var $132=(($131 << 24) >> 24);
      var $133=(($132)|0)!=32;
      var $135 = $133;__label__ = 23; break;
    case 23: // $134
      var $135;
      if ($135) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $136
      var $137=$overflow;
      var $138=(($137+1)|0);
      $overflow=$138;
      __label__ = 21; break;
    case 25: // $139
      var $140=$overflow;
      var $141=$linelen;
      var $142=(($140)|0) < (($141)|0);
      if ($142) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $143
      var $144=$overflow;
      var $145=$linelen;
      var $146=(($145-$144)|0);
      $linelen=$146;
      __label__ = 28; break;
    case 27: // $147
      $overflow=0;
      __label__ = 28; break;
    case 28: // $148
      __label__ = 29; break;
    case 29: // $149
      var $150=$linelen;
      var $151=$1;
      var $152=(($151+36)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($150)|0) > (($153)|0);
      if ($154) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $155
      var $156=$linelen;
      var $157=$1;
      var $158=(($157+36)|0);
      HEAP32[(($158)>>2)]=$156;
      __label__ = 31; break;
    case 31: // $159
      var $160=$overflow;
      var $161=(($160)|0)==0;
      if ($161) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $162
      var $163=$1;
      var $164=(($163+16)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165+1)|0);
      HEAP32[(($164)>>2)]=$166;
      var $167=$1;
      var $168=(($167)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169+$165)|0);
      HEAP8[($170)]=0;
      __label__ = 34; break;
    case 33: // $171
      var $172=$1;
      var $173=(($172+16)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$overflow;
      var $176=(($174-$175)|0);
      var $177=$1;
      var $178=(($177)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+$176)|0);
      HEAP8[($180)]=0;
      __label__ = 34; break;
    case 34: // $181
      var $182=$1;
      var $183=(($182+28)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($184+1)|0);
      HEAP32[(($183)>>2)]=$185;
      var $186=$1;
      var $187=(($186+20)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($185)|0) >= (($188)|0);
      if ($189) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $190
      var $191=$1;
      var $192=(($191+28)|0);
      HEAP32[(($192)>>2)]=0;
      __label__ = 36; break;
    case 36: // $193
      var $194=$1;
      var $195=(($194+28)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=$1;
      var $198=(($197+24)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=(($196)|0)==(($199)|0);
      if ($200) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $201
      var $202=$1;
      var $203=(($202+32)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=(($204+1)|0);
      HEAP32[(($203)>>2)]=$205;
      var $206=$1;
      var $207=(($206+24)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208+1)|0);
      HEAP32[(($207)>>2)]=$209;
      var $210=$1;
      var $211=(($210+20)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=(($209)|0) >= (($212)|0);
      if ($213) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $214
      var $215=$1;
      var $216=(($215+24)|0);
      HEAP32[(($216)>>2)]=0;
      __label__ = 39; break;
    case 39: // $217
      var $218=$1;
      var $219=(($218+24)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$1;
      var $222=(($221+4)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(($223+($220<<2))|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$1;
      var $227=(($226+12)|0);
      HEAP32[(($227)>>2)]=$225;
      __label__ = 40; break;
    case 40: // $228
      var $229=$1;
      var $230=(($229+16)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231+250)|0);
      var $233=(($232+1)|0);
      var $234=$1;
      var $235=(($234+8)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=(($233)|0) >= (($236)|0);
      if ($237) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $238
      var $239=$1;
      var $240=(($239+16)|0);
      HEAP32[(($240)>>2)]=0;
      __label__ = 42; break;
    case 42: // $241
      var $242=$1;
      var $243=(($242+16)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$overflow;
      var $246=(($245)|0)!=0;
      if ($246) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $247
      var $248=$overflow;
      var $249=(($248-1)|0);
      var $252 = $249;__label__ = 45; break;
    case 44: // $250
      var $252 = 0;__label__ = 45; break;
    case 45: // $251
      var $252;
      var $253=(($244-$252)|0);
      var $254=$1;
      var $255=(($254+28)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=$1;
      var $258=(($257+4)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($259+($256<<2))|0);
      HEAP32[(($260)>>2)]=$253;
      __label__ = 46; break;
    case 46: // $261
      __label__ = 47; break;
    case 47: // $262
      var $263=$2;
      var $264=(($263+1)|0);
      $2=$264;
      __label__ = 11; break;
    case 48: // $265
      var $266=$1;
      var $267=(($266+16)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=$1;
      var $270=(($269)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=(($271+$268)|0);
      HEAP8[($272)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22text_buffer_print_wrapP12_text_bufferPKci["X"]=1;

function __ZL12buffer_spaceP12_text_buffer($text) {
  ;
  var __label__;

  var $1;
  $1=$text;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=__ZL11buffer_usedP12_text_buffer($5);
  var $7=(($4-$6)|0);
  ;
  return $7;
}


function __Z27text_buffer_get_seqnum_lineP12_text_bufferj($text, $seqnum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $numlines;
      var $index;
      $2=$text;
      $3=$seqnum;
      var $4=$2;
      var $5=__Z21text_buffer_num_linesP12_text_buffer($4);
      $numlines=$5;
      var $6=$3;
      var $7=$2;
      var $8=(($7+32)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6-$9)|0);
      $index=$10;
      var $11=$index;
      var $12=$numlines;
      var $13=(($11)>>>0) >= (($12)>>>0);
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      $1=0;
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($16+24)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$index;
      var $20=(($18+$19)|0);
      var $21=$2;
      var $22=(($21+20)|0);
      var $23=HEAPU32[(($22)>>2)];
      var $24=(($20)>>>0)%(($23)>>>0);
      var $25=$2;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+($24<<2))|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+$29)|0);
      $1=$33;
      __label__ = 3; break;
    case 3: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18debug_command_initR15running_machine($machine) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $symtable;
      var $name;
      var $itemnum;
      var $valsize=__stackBase__;
      var $valcount=__stackBase__+4;
      var $base=__stackBase__+8;
      var $symname=__stackBase__+12;
      var $2=__stackBase__+112;
      $1=$machine;
      var $3=$1;
      var $4=__Z29debug_cpu_get_global_symtableR15running_machine($3);
      $symtable=$4;
      var $5=$symtable;
      __ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE($5, ((STRING_TABLE.__str5498)|0), 0, 2, 2, 1172);
      var $6=$symtable;
      __ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE($6, ((STRING_TABLE.__str15499)|0), 0, 2, 2, 1174);
      var $7=$symtable;
      __ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE($7, ((STRING_TABLE.__str25500)|0), 0, 3, 3, 1176);
      $itemnum=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$itemnum;
      var $10=(($9)|0) < 1000;
      if ($10) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZN15running_machine4saveEv($12);
      var $14=$itemnum;
      var $15=__ZNK12save_manager12indexed_itemEiRPvRjS2_($13, $14, $base, $valsize, $valcount);
      $name=$15;
      var $16=$name;
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      __label__ = 9; break;
    case 4: // $19
      var $20=HEAP32[(($valcount)>>2)];
      var $21=(($20)|0)==1;
      if ($21) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      var $23=$name;
      var $24=_strstr($23, ((STRING_TABLE.__str35501)|0));
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=(($symname)|0);
      var $28=$name;
      var $29=_strrchr($28, 47);
      var $30=(($29+1)|0);
      var $31=_sprintf($27, ((STRING_TABLE.__str45502)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$30,tempInt));
      var $32=HEAP32[(($base)>>2)];
      var $33=$itemnum;
      var $34=((__ZL12global_array+($33<<3))|0);
      var $35=(($34)|0);
      HEAP32[(($35)>>2)]=$32;
      var $36=HEAP32[(($valsize)>>2)];
      var $37=$itemnum;
      var $38=((__ZL12global_array+($37<<3))|0);
      var $39=(($38+4)|0);
      HEAP32[(($39)>>2)]=$36;
      var $40=$symtable;
      var $41=(($symname)|0);
      __ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE($40, $41, __ZL12global_array, 1178, 1180);
      __label__ = 7; break;
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      var $44=$itemnum;
      var $45=(($44+1)|0);
      $itemnum=$45;
      __label__ = 1; break;
    case 9: // $46
      var $47=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($47, ((STRING_TABLE.__str55503)|0), 0, 0, 0, 1, 1182);
      var $48=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($48, ((STRING_TABLE.__str65504)|0), 0, 0, 1, 16, 1184);
      var $49=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($49, ((STRING_TABLE.__str75505)|0), 0, 0, 1, 16, 1186);
      var $50=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($50, ((STRING_TABLE.__str85506)|0), 0, 0, 1, 16, 1188);
      var $51=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($51, ((STRING_TABLE.__str95507)|0), 0, 0, 1, 16, 1190);
      var $52=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($52, ((STRING_TABLE.__str105508)|0), 0, 0, 0, 0, 1192);
      var $53=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($53, ((STRING_TABLE.__str115509)|0), 0, 0, 1, 1, 1194);
      var $54=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($54, ((STRING_TABLE.__str125510)|0), 0, 0, 0, 1, 1196);
      var $55=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($55, ((STRING_TABLE.__str135511)|0), 0, 0, 0, 1, 1196);
      var $56=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($56, ((STRING_TABLE.__str145512)|0), 0, 0, 0, 1, 1198);
      var $57=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($57, ((STRING_TABLE.__str155513)|0), 0, 0, 0, 1, 1198);
      var $58=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($58, ((STRING_TABLE.__str165514)|0), 0, 0, 0, 0, 1200);
      var $59=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($59, ((STRING_TABLE.__str175515)|0), 0, 0, 0, 1, 1202);
      var $60=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($60, ((STRING_TABLE.__str185516)|0), 0, 0, 0, 1, 1202);
      var $61=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($61, ((STRING_TABLE.__str195517)|0), 0, 0, 0, 0, 1204);
      var $62=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($62, ((STRING_TABLE.__str205518)|0), 0, 0, 0, 0, 1204);
      var $63=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($63, ((STRING_TABLE.__str215519)|0), 0, 0, 0, 1, 1206);
      var $64=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($64, ((STRING_TABLE.__str225520)|0), 0, 0, 0, 1, 1206);
      var $65=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($65, ((STRING_TABLE.__str235521)|0), 0, 0, 0, 1, 1208);
      var $66=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($66, ((STRING_TABLE.__str245522)|0), 0, 0, 0, 1, 1208);
      var $67=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($67, ((STRING_TABLE.__str255523)|0), 0, 0, 0, 0, 1210);
      var $68=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($68, ((STRING_TABLE.__str265524)|0), 0, 0, 0, 0, 1210);
      var $69=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($69, ((STRING_TABLE.__str275525)|0), 0, 0, 1, 1, 1212);
      var $70=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($70, ((STRING_TABLE.__str285526)|0), 0, 0, 0, 16, 1214);
      var $71=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($71, ((STRING_TABLE.__str295527)|0), 0, 0, 0, 16, 1216);
      var $72=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($72, ((STRING_TABLE.__str305528)|0), 0, 0, 1, 2, 1218);
      var $73=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($73, ((STRING_TABLE.__str315529)|0), 0, 0, 1, 2, 1218);
      var $74=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($74, ((STRING_TABLE.__str325530)|0), 0, 0, 1, 1, 1220);
      var $75=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($75, ((STRING_TABLE.__str335531)|0), 0, 0, 0, 0, 1222);
      var $76=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($76, ((STRING_TABLE.__str345532)|0), 0, 0, 1, 3, 1224);
      var $77=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($77, ((STRING_TABLE.__str355533)|0), 0, 0, 1, 3, 1224);
      var $78=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($78, ((STRING_TABLE.__str365534)|0), 0, 0, 0, 1, 1226);
      var $79=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($79, ((STRING_TABLE.__str375535)|0), 0, 0, 0, 1, 1228);
      var $80=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($80, ((STRING_TABLE.__str385536)|0), 0, 1, 0, 1, 1228);
      var $81=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($81, ((STRING_TABLE.__str395537)|0), 0, 0, 0, 0, 1230);
      var $82=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($82, ((STRING_TABLE.__str405538)|0), 0, 0, 3, 5, 1232);
      var $83=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($83, ((STRING_TABLE.__str415539)|0), 0, 0, 3, 5, 1232);
      var $84=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($84, ((STRING_TABLE.__str425540)|0), 0, 1, 3, 5, 1232);
      var $85=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($85, ((STRING_TABLE.__str435541)|0), 0, 1, 3, 5, 1232);
      var $86=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($86, ((STRING_TABLE.__str445542)|0), 0, 2, 3, 5, 1232);
      var $87=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($87, ((STRING_TABLE.__str455543)|0), 0, 2, 3, 5, 1232);
      var $88=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($88, ((STRING_TABLE.__str465544)|0), 0, 0, 0, 1, 1234);
      var $89=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($89, ((STRING_TABLE.__str475545)|0), 0, 0, 0, 1, 1236);
      var $90=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($90, ((STRING_TABLE.__str485546)|0), 0, 1, 0, 1, 1236);
      var $91=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($91, ((STRING_TABLE.__str495547)|0), 0, 0, 0, 0, 1238);
      var $92=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($92, ((STRING_TABLE.__str505548)|0), 0, 0, 0, 3, 1240);
      var $93=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($93, ((STRING_TABLE.__str515549)|0), 0, 0, 3, 4, 1242);
      var $94=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($94, ((STRING_TABLE.__str525550)|0), 0, 1, 3, 4, 1242);
      var $95=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($95, ((STRING_TABLE.__str535551)|0), 0, 2, 3, 4, 1242);
      var $96=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($96, ((STRING_TABLE.__str545552)|0), 0, 0, 3, 4, 1244);
      var $97=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($97, ((STRING_TABLE.__str555553)|0), 0, 1, 3, 4, 1244);
      var $98=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($98, ((STRING_TABLE.__str565554)|0), 0, 2, 3, 4, 1244);
      var $99=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($99, ((STRING_TABLE.__str575555)|0), 0, 0, 3, 6, 1246);
      var $100=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($100, ((STRING_TABLE.__str585556)|0), 0, 1, 3, 6, 1246);
      var $101=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($101, ((STRING_TABLE.__str595557)|0), 0, 2, 3, 6, 1246);
      var $102=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($102, ((STRING_TABLE.__str605558)|0), 0, 0, 0, 4, 1248);
      var $103=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($103, ((STRING_TABLE.__str615559)|0), 0, 0, 0, 4, 1248);
      var $104=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($104, ((STRING_TABLE.__str625560)|0), 0, 1, 2, 2, 1248);
      var $105=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($105, ((STRING_TABLE.__str635561)|0), 0, 1, 2, 2, 1248);
      var $106=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($106, ((STRING_TABLE.__str645562)|0), 0, 0, 1, 2, 1250);
      var $107=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($107, ((STRING_TABLE.__str655563)|0), 0, 0, 1, 2, 1250);
      var $108=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($108, ((STRING_TABLE.__str665564)|0), 0, 1, 1, 2, 1250);
      var $109=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($109, ((STRING_TABLE.__str675565)|0), 0, 1, 1, 2, 1250);
      var $110=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($110, ((STRING_TABLE.__str685566)|0), 0, 0, 0, 1, 1252);
      var $111=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($111, ((STRING_TABLE.__str695567)|0), 0, 0, 0, 1, 1252);
      var $112=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($112, ((STRING_TABLE.__str705568)|0), 0, 0, 0, 0, 1254);
      var $113=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($113, ((STRING_TABLE.__str715569)|0), 0, 0, 0, 0, 1254);
      var $114=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($114, ((STRING_TABLE.__str725570)|0), 1, 0, 3, 16, 1256);
      var $115=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($115, ((STRING_TABLE.__str735571)|0), 1, 0, 3, 16, 1256);
      var $116=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($116, ((STRING_TABLE.__str745572)|0), 1, 1, 3, 16, 1256);
      var $117=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($117, ((STRING_TABLE.__str755573)|0), 1, 1, 3, 16, 1256);
      var $118=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($118, ((STRING_TABLE.__str765574)|0), 1, 2, 3, 16, 1256);
      var $119=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($119, ((STRING_TABLE.__str775575)|0), 1, 2, 3, 16, 1256);
      var $120=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($120, ((STRING_TABLE.__str785576)|0), 0, 0, 3, 5, 1258);
      var $121=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($121, ((STRING_TABLE.__str795577)|0), 0, 0, 1, 3, 1260);
      var $122=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($122, ((STRING_TABLE.__str805578)|0), 0, 0, 1, 3, 1262);
      var $123=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($123, ((STRING_TABLE.__str815579)|0), 0, 0, 0, 0, 1264);
      var $124=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($124, ((STRING_TABLE.__str825580)|0), 0, 0, 0, 2, 1266);
      var $125=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($125, ((STRING_TABLE.__str835581)|0), 0, 0, 0, 1, 1268);
      var $126=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($126, ((STRING_TABLE.__str845582)|0), 0, 0, 1, 1, 1270);
      var $127=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($127, ((STRING_TABLE.__str855583)|0), 0, 0, 1, 1, 1272);
      var $128=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($128, ((STRING_TABLE.__str865584)|0), 0, 1, 1, 1, 1272);
      var $129=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($129, ((STRING_TABLE.__str875585)|0), 0, 2, 1, 1, 1272);
      var $130=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($130, ((STRING_TABLE.__str885586)|0), 0, 0, 0, 1, 1274);
      var $131=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($131, ((STRING_TABLE.__str895587)|0), 0, 0, 0, 1, 1276);
      var $132=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($132, ((STRING_TABLE.__str905588)|0), 0, 0, 0, 1, 1278);
      var $133=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($133, ((STRING_TABLE.__str915589)|0), 0, 0, 0, 1, 1280);
      var $134=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($134, ((STRING_TABLE.__str925590)|0), 0, 0, 0, 0, 1282);
      var $135=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($135, ((STRING_TABLE.__str935591)|0), 0, 0, 2, 2, 1284);
      var $136=$1;
      __Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E($136, ((STRING_TABLE.__str945592)|0), 0, 0, 1, 1, 1286);
      var $137=$1;
      var $138=$1;
      __ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_($2, 1288, ((STRING_TABLE.__str955593)|0), $138);
      __ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE($137, 4, $2);
      var $139=$1;
      var $140=__ZNK15running_machine7optionsEv($139);
      var $141=__ZNK11emu_options12debug_scriptEv($140);
      $name=$141;
      var $142=$name;
      var $143=(($142)|0);
      var $144=HEAP8[($143)];
      var $145=(($144 << 24) >> 24);
      var $146=(($145)|0)!=0;
      if ($146) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $147
      var $148=$1;
      var $149=$name;
      __Z23debug_cpu_source_scriptR15running_machinePKc($148, $149);
      __label__ = 11; break;
    case 11: // $150
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18debug_command_initR15running_machine["X"]=1;

function __ZL10global_getR12symbol_tablePv($table, $ref) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $global;
      $2=$table;
      $3=$ref;
      var $4=$3;
      var $5=$4;
      $global=$5;
      var $6=$global;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      if ($8 == 1) {
        __label__ = 1; break;
      }
      else if ($8 == 2) {
        __label__ = 2; break;
      }
      else if ($8 == 4) {
        __label__ = 3; break;
      }
      else if ($8 == 8) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $9
      var $10=$global;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=HEAP8[($12)];
      var $14$0=$13;
      var $14$1=0;
      var $st$6$0=(($1)|0);
      HEAP32[(($st$6$0)>>2)]=$14$0;
      var $st$6$1=(($1+4)|0);
      HEAP32[(($st$6$1)>>2)]=$14$1;
      __label__ = 6; break;
    case 2: // $15
      var $16=$global;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18;
      var $20=HEAP16[(($19)>>1)];
      var $21$0=$20;
      var $21$1=0;
      var $st$7$0=(($1)|0);
      HEAP32[(($st$7$0)>>2)]=$21$0;
      var $st$7$1=(($1+4)|0);
      HEAP32[(($st$7$1)>>2)]=$21$1;
      __label__ = 6; break;
    case 3: // $22
      var $23=$global;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      var $28$0=$27;
      var $28$1=0;
      var $st$7$0=(($1)|0);
      HEAP32[(($st$7$0)>>2)]=$28$0;
      var $st$7$1=(($1+4)|0);
      HEAP32[(($st$7$1)>>2)]=$28$1;
      __label__ = 6; break;
    case 4: // $29
      var $30=$global;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32;
      var $st$4$0=(($33)|0);
      var $34$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($33+4)|0);
      var $34$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($1)|0);
      HEAP32[(($st$8$0)>>2)]=$34$0;
      var $st$8$1=(($1+4)|0);
      HEAP32[(($st$8$1)>>2)]=$34$1;
      __label__ = 6; break;
    case 5: // $35
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 6; break;
    case 6: // $36
      var $st$0$0=(($1)|0);
      var $37$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $37$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$37$0,$37$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10global_getR12symbol_tablePv["X"]=1;

function __ZL10global_setR12symbol_tablePvy($table, $ref, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $global;
      $1=$table;
      $2=$ref;
      var $st$6$0=(($3)|0);
      HEAP32[(($st$6$0)>>2)]=$value$0;
      var $st$6$1=(($3+4)|0);
      HEAP32[(($st$6$1)>>2)]=$value$1;
      var $4=$2;
      var $5=$4;
      $global=$5;
      var $6=$global;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      if ($8 == 1) {
        __label__ = 1; break;
      }
      else if ($8 == 2) {
        __label__ = 2; break;
      }
      else if ($8 == 4) {
        __label__ = 3; break;
      }
      else if ($8 == 8) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $9
      var $st$0$0=(($3)|0);
      var $10$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$0$1)>>2)];
      var $11$0=$10$0;
      var $11=$11$0&255;
      var $12=$global;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      HEAP8[($14)]=$11;
      __label__ = 5; break;
    case 2: // $15
      var $st$0$0=(($3)|0);
      var $16$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $16$1=HEAP32[(($st$0$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0&65535;
      var $18=$global;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      HEAP16[(($21)>>1)]=$17;
      __label__ = 5; break;
    case 3: // $22
      var $st$0$0=(($3)|0);
      var $23$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $23$1=HEAP32[(($st$0$1)>>2)];
      var $24$0=$23$0;
      var $24=$24$0;
      var $25=$global;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$27;
      HEAP32[(($28)>>2)]=$24;
      __label__ = 5; break;
    case 4: // $29
      var $st$0$0=(($3)|0);
      var $30$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $30$1=HEAP32[(($st$0$1)>>2)];
      var $31=$global;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$33;
      var $st$8$0=(($34)|0);
      HEAP32[(($st$8$0)>>2)]=$30$0;
      var $st$8$1=(($34+4)|0);
      HEAP32[(($st$8$1)>>2)]=$30$1;
      __label__ = 5; break;
    case 5: // $35
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10global_setR12symbol_tablePvy["X"]=1;

function __ZL12execute_helpR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=__Z14debug_get_helpPKc(((__str985596)|0));
      __Z25debug_console_printf_wrapR15running_machineiPKcz($8, 80, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$9,tempInt));
      __label__ = 3; break;
    case 2: // $10
      var $11=$1;
      var $12=$4;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z14debug_get_helpPKc($14);
      __Z25debug_console_printf_wrapR15running_machineiPKcz($11, 80, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt));
      __label__ = 3; break;
    case 3: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13execute_printR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $values=__stackBase__;
      var $i;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $i=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$3;
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$1;
      var $11=$i;
      var $12=$4;
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$i;
      var $16=(($values+($15<<3))|0);
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($10, $14, $16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 11; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$i;
      var $23=(($22+1)|0);
      $i=$23;
      __label__ = 1; break;
    case 6: // $24
      $i=0;
      __label__ = 7; break;
    case 7: // $25
      var $26=$i;
      var $27=$3;
      var $28=(($26)|0) < (($27)|0);
      if ($28) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $29
      var $30=$1;
      var $31=$i;
      var $32=(($values+($31<<3))|0);
      var $st$3$0=(($32)|0);
      var $33$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($32+4)|0);
      var $33$1=HEAP32[(($st$3$1)>>2)];
      var $34=__Z19core_i64_hex_formatyh($33$0, $33$1, 0);
      __Z20debug_console_printfR15running_machinePKcz($30, ((STRING_TABLE.__str1415639)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$34,tempInt));
      __label__ = 9; break;
    case 9: // $35
      var $36=$i;
      var $37=(($36+1)|0);
      $i=$37;
      __label__ = 7; break;
    case 10: // $38
      var $39=$1;
      __Z20debug_console_printfR15running_machinePKcz($39, ((STRING_TABLE.__str1155613)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 11; break;
    case 11: // $40
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13execute_printR15running_machineiiPPKc["X"]=1;

function __ZL14execute_printfR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 1152; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $values=__stackBase__;
      var $buffer=__stackBase__+128;
      var $i;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $i=1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$3;
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$1;
      var $11=$i;
      var $12=$4;
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$i;
      var $16=(($values+($15<<3))|0);
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($10, $14, $16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 8; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$i;
      var $23=(($22+1)|0);
      $i=$23;
      __label__ = 1; break;
    case 6: // $24
      var $25=$1;
      var $26=(($buffer)|0);
      var $27=$4;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=(($30-1)|0);
      var $32=(($values+8)|0);
      var $33=__ZL11mini_printfR15running_machinePcPKciPy($25, $26, $29, $31, $32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$1;
      var $37=(($buffer)|0);
      __Z20debug_console_printfR15running_machinePKcz($36, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt));
      __label__ = 8; break;
    case 8: // $38
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16execute_logerrorR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 1152; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $values=__stackBase__;
      var $buffer=__stackBase__+128;
      var $i;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $i=1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$3;
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$1;
      var $11=$i;
      var $12=$4;
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$i;
      var $16=(($values+($15<<3))|0);
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($10, $14, $16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 8; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$i;
      var $23=(($22+1)|0);
      $i=$23;
      __label__ = 1; break;
    case 6: // $24
      var $25=$1;
      var $26=(($buffer)|0);
      var $27=$4;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=(($30-1)|0);
      var $32=(($values+8)|0);
      var $33=__ZL11mini_printfR15running_machinePcPKciPy($25, $26, $29, $31, $32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=(($buffer)|0);
      __Z8logerrorPKcz(((STRING_TABLE.__str1415639)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,tempInt));
      __label__ = 8; break;
    case 8: // $37
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16execute_tracelogR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 1152; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $values=__stackBase__;
      var $buffer=__stackBase__+128;
      var $i;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $i=1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$3;
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$1;
      var $11=$i;
      var $12=$4;
      var $13=(($12+($11<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$i;
      var $16=(($values+($15<<3))|0);
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($10, $14, $16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 8; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$i;
      var $23=(($22+1)|0);
      $i=$23;
      __label__ = 1; break;
    case 6: // $24
      var $25=$1;
      var $26=(($buffer)|0);
      var $27=$4;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=(($30-1)|0);
      var $32=(($values+8)|0);
      var $33=__ZL11mini_printfR15running_machinePcPKciPy($25, $26, $29, $31, $32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$1;
      var $37=__Z25debug_cpu_get_visible_cpuR15running_machine($36);
      var $38=__ZNK8device_t5debugEv($37);
      var $39=(($buffer)|0);
      __ZN12device_debug12trace_printfEPKcz($38, ((STRING_TABLE.__str1415639)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt));
      __label__ = 8; break;
    case 8: // $40
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16execute_tracelogR15running_machineiiPPKc["X"]=1;

function __ZL12execute_quitR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  __Z17mame_printf_errorPKcz(((STRING_TABLE.__str2455743)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
  var $5=$1;
  __ZN15running_machine13schedule_exitEv($5);
  STACKTOP = __stackBase__;
  return;
}


function __ZL10execute_doR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $dummy=__stackBase__;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=$4;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $dummy);
  STACKTOP = __stackBase__;
  return;
}


function __ZL12execute_stepR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $steps=__stackBase__;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$11$0=(($steps)|0);
      HEAP32[(($st$11$0)>>2)]=$$emscripten$temp$0$0;
      var $st$11$1=(($steps+4)|0);
      HEAP32[(($st$11$1)>>2)]=$$emscripten$temp$0$1;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $steps);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 3; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z25debug_cpu_get_visible_cpuR15running_machine($13);
      var $15=__ZNK8device_t5debugEv($14);
      var $st$3$0=(($steps)|0);
      var $16$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($steps+4)|0);
      var $16$1=HEAP32[(($st$3$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      __ZN12device_debug11single_stepEi($15, $17);
      __label__ = 3; break;
    case 3: // $18
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12execute_overR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $steps=__stackBase__;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$11$0=(($steps)|0);
      HEAP32[(($st$11$0)>>2)]=$$emscripten$temp$0$0;
      var $st$11$1=(($steps+4)|0);
      HEAP32[(($st$11$1)>>2)]=$$emscripten$temp$0$1;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $steps);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 3; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z25debug_cpu_get_visible_cpuR15running_machine($13);
      var $15=__ZNK8device_t5debugEv($14);
      var $st$3$0=(($steps)|0);
      var $16$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($steps+4)|0);
      var $16$1=HEAP32[(($st$3$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      __ZN12device_debug16single_step_overEi($15, $17);
      __label__ = 3; break;
    case 3: // $18
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11execute_outR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=__Z25debug_cpu_get_visible_cpuR15running_machine($5);
  var $7=__ZNK8device_t5debugEv($6);
  __ZN12device_debug15single_step_outEv($7);
  ;
  return;
}


function __ZL10execute_goR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $addr=__stackBase__;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$11$0=(($addr)|0);
      HEAP32[(($st$11$0)>>2)]=$$emscripten$temp$0$0;
      var $st$11$1=(($addr+4)|0);
      HEAP32[(($st$11$1)>>2)]=$$emscripten$temp$0$1;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $addr);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 3; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z25debug_cpu_get_visible_cpuR15running_machine($13);
      var $15=__ZNK8device_t5debugEv($14);
      var $st$3$0=(($addr)|0);
      var $16$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($addr+4)|0);
      var $16$1=HEAP32[(($st$3$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      __ZN12device_debug2goEj($15, $17);
      __label__ = 3; break;
    case 3: // $18
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17execute_go_vblankR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=__Z25debug_cpu_get_visible_cpuR15running_machine($5);
  var $7=__ZNK8device_t5debugEv($6);
  __ZN12device_debug9go_vblankEv($7);
  ;
  return;
}


function __ZL20execute_go_interruptR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $irqline=__stackBase__;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$11$0=(($irqline)|0);
      HEAP32[(($st$11$0)>>2)]=$$emscripten$temp$0$0;
      var $st$11$1=(($irqline+4)|0);
      HEAP32[(($st$11$1)>>2)]=$$emscripten$temp$0$1;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $irqline);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 3; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z25debug_cpu_get_visible_cpuR15running_machine($13);
      var $15=__ZNK8device_t5debugEv($14);
      var $st$3$0=(($irqline)|0);
      var $16$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($irqline+4)|0);
      var $16$1=HEAP32[(($st$3$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      __ZN12device_debug12go_interruptEi($15, $17);
      __label__ = 3; break;
    case 3: // $18
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15execute_go_timeR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $milliseconds=__stackBase__;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$11$0=(($milliseconds)|0);
      HEAP32[(($st$11$0)>>2)]=$$emscripten$temp$0$0;
      var $st$11$1=(($milliseconds+4)|0);
      HEAP32[(($st$11$1)>>2)]=$$emscripten$temp$0$1;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $milliseconds);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 3; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z25debug_cpu_get_visible_cpuR15running_machine($13);
      var $15=__ZNK8device_t5debugEv($14);
      var $st$3$0=(($milliseconds)|0);
      var $16$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($milliseconds+4)|0);
      var $16$1=HEAP32[(($st$3$1)>>2)];
      __ZN12device_debug15go_millisecondsEy($15, $16$0, $16$1);
      __label__ = 3; break;
    case 3: // $17
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12execute_nextR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=__Z25debug_cpu_get_visible_cpuR15running_machine($5);
  var $7=__ZNK8device_t5debugEv($6);
  __ZN12device_debug14go_next_deviceEv($7);
  ;
  return;
}


function __ZL13execute_focusR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpu=__stackBase__;
      var $exec=__stackBase__+4;
      var $gotone;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($5, $8, $cpu);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 9; break;
    case 2: // $12
      var $13=HEAP32[(($cpu)>>2)];
      var $14=__ZNK8device_t5debugEv($13);
      __ZN12device_debug6ignoreEb($14, 0);
      HEAP32[(($exec)>>2)]=0;
      var $15=$1;
      var $16=__ZNK15running_machine10devicelistEv($15);
      var $17=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($16, $exec);
      var $18=(($17)&1);
      $gotone=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$gotone;
      var $21=(($20) & 1);
      if ($21) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $22
      var $23=HEAP32[(($exec)>>2)];
      var $24=$23;
      var $25=__ZN16device_interface6deviceEv($24);
      var $26=HEAP32[(($cpu)>>2)];
      var $27=(($25)|0)!=(($26)|0);
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      var $29=HEAP32[(($exec)>>2)];
      var $30=$29;
      var $31=__ZN16device_interface6deviceEv($30);
      var $32=__ZNK8device_t5debugEv($31);
      __ZN12device_debug6ignoreEb($32, 1);
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=HEAP32[(($exec)>>2)];
      var $36=$35;
      var $37=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($36, $exec);
      var $38=(($37)&1);
      $gotone=$38;
      __label__ = 3; break;
    case 8: // $39
      var $40=$1;
      var $41=HEAP32[(($cpu)>>2)];
      var $42=__ZNK8device_t3tagEv($41);
      __Z20debug_console_printfR15running_machinePKcz($40, ((STRING_TABLE.__str2445742)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,tempInt));
      __label__ = 9; break;
    case 9: // $43
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13execute_focusR15running_machineiiPPKc["X"]=1;

function __ZL15execute_commentR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpu=__stackBase__;
      var $address=__stackBase__+4;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $address);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 7; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($13, 0, $cpu);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      __label__ = 7; break;
    case 4: // $17
      var $18=$4;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=_strlen($20);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$1;
      __Z20debug_console_printfR15running_machinePKcz($24, ((STRING_TABLE.__str2355733)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 7; break;
    case 6: // $25
      var $26=HEAP32[(($cpu)>>2)];
      var $27=__ZNK8device_t5debugEv($26);
      var $st$2$0=(($address)|0);
      var $28$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($address+4)|0);
      var $28$1=HEAP32[(($st$2$1)>>2)];
      var $29$0=$28$0;
      var $29=$29$0;
      var $30=$4;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      __ZN12device_debug11comment_addEjPKcj($27, $29, $32, 16711680);
      var $33=HEAP32[(($cpu)>>2)];
      var $34=__ZNK8device_t7machineEv($33);
      var $35=__ZNK15running_machine10debug_viewEv($34);
      __ZN18debug_view_manager10update_allE15debug_view_type($35, 3);
      __label__ = 7; break;
    case 7: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_commentR15running_machineiiPPKc["X"]=1;

function __ZL19execute_comment_delR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpu=__stackBase__;
      var $address=__stackBase__+4;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $address);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 5; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($13, 0, $cpu);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      __label__ = 5; break;
    case 4: // $17
      var $18=HEAP32[(($cpu)>>2)];
      var $19=__ZNK8device_t5debugEv($18);
      var $st$2$0=(($address)|0);
      var $20$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($address+4)|0);
      var $20$1=HEAP32[(($st$2$1)>>2)];
      var $21$0=$20$0;
      var $21=$21$0;
      var $22=__ZN12device_debug14comment_removeEj($19, $21);
      var $23=HEAP32[(($cpu)>>2)];
      var $24=__ZNK8device_t7machineEv($23);
      var $25=__ZNK15running_machine10debug_viewEv($24);
      __ZN18debug_view_manager10update_allE15debug_view_type($25, 3);
      __label__ = 5; break;
    case 5: // $26
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20execute_comment_saveR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=__Z18debug_comment_saveR15running_machine($5);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      __Z20debug_console_printfR15running_machinePKcz($8, ((STRING_TABLE.__str2345732)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15execute_bpclearR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $bpindex=__stackBase__;
      var $device;
      var $found;
      var $device1;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine10devicelistEv($8);
      var $10=$9;
      var $11=__ZNK11tagged_listI8device_tE5firstEv($10);
      $device=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$device;
      var $17=__ZNK8device_t5debugEv($16);
      __ZN12device_debug20breakpoint_clear_allEv($17);
      __label__ = 4; break;
    case 4: // $18
      var $19=$device;
      var $20=__ZNK8device_t4nextEv($19);
      $device=$20;
      __label__ = 2; break;
    case 5: // $21
      var $22=$1;
      __Z20debug_console_printfR15running_machinePKcz($22, ((STRING_TABLE.__str2315729)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 19; break;
    case 6: // $23
      var $24=$1;
      var $25=$4;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__Z30debug_command_parameter_numberR15running_machinePKcPy($24, $27, $bpindex);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $30
      __label__ = 19; break;
    case 8: // $31
      $found=0;
      var $32=$1;
      var $33=__ZNK15running_machine10devicelistEv($32);
      var $34=$33;
      var $35=__ZNK11tagged_listI8device_tE5firstEv($34);
      $device1=$35;
      __label__ = 9; break;
    case 9: // $36
      var $37=$device1;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $39
      var $40=$device1;
      var $41=__ZNK8device_t5debugEv($40);
      var $st$2$0=(($bpindex)|0);
      var $42$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($bpindex+4)|0);
      var $42$1=HEAP32[(($st$2$1)>>2)];
      var $43$0=$42$0;
      var $43=$43$0;
      var $44=__ZN12device_debug16breakpoint_clearEi($41, $43);
      if ($44) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $45
      $found=1;
      __label__ = 12; break;
    case 12: // $46
      __label__ = 13; break;
    case 13: // $47
      var $48=$device1;
      var $49=__ZNK8device_t4nextEv($48);
      $device1=$49;
      __label__ = 9; break;
    case 14: // $50
      var $51=$found;
      var $52=(($51) & 1);
      if ($52) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $53
      var $54=$1;
      var $st$1$0=(($bpindex)|0);
      var $55$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($bpindex+4)|0);
      var $55$1=HEAP32[(($st$1$1)>>2)];
      var $56$0=$55$0;
      var $56=$56$0;
      __Z20debug_console_printfR15running_machinePKcz($54, ((STRING_TABLE.__str2325730)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,tempInt));
      __label__ = 17; break;
    case 16: // $57
      var $58=$1;
      var $st$1$0=(($bpindex)|0);
      var $59$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($bpindex+4)|0);
      var $59$1=HEAP32[(($st$1$1)>>2)];
      var $60$0=$59$0;
      var $60=$60$0;
      __Z20debug_console_printfR15running_machinePKcz($58, ((STRING_TABLE.__str2305728)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$60,tempInt));
      __label__ = 17; break;
    case 17: // $61
      __label__ = 18; break;
    case 18: // $62
      __label__ = 19; break;
    case 19: // $63
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_bpclearR15running_machineiiPPKc["X"]=1;

function __ZL14execute_ignoreR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buffer=__stackBase__;
      var $exec=__stackBase__+64;
      var $gotone;
      var $5;
      var $6;
      var $devicelist=__stackBase__+68;
      var $paramnum;
      var $paramnum1;
      var $exec2=__stackBase__+132;
      var $gotone3;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $7=$3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 32; break; }
    case 1: // $9
      __ZN7astringC1Ev($buffer);
      HEAP32[(($exec)>>2)]=0;
      var $10=$1;
      var $11=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($11, $exec) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 15; break; };
    case 3: // $14
      var $15=(($13)&1);
      $gotone=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$gotone;
      var $18=(($17) & 1);
      if ($18) { __label__ = 5; break; } else { __label__ = 24; break; }
    case 5: // $19
      var $20=HEAP32[(($exec)>>2)];
      var $21=$20;
      var $22=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; };
    case 6: // $23
      var $24=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 15; break; };
    case 7: // $25
      var $26=(function() { try { __THREW__ = false; return __ZNK12device_debug9observingEv($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; };
    case 8: // $27
      if ($26) { __label__ = 21; break; } else { __label__ = 9; break; }
    case 9: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; };
    case 10: // $30
      if ($29) { __label__ = 16; break; } else { __label__ = 11; break; }
    case 11: // $31
      var $32=HEAP32[(($exec)>>2)];
      var $33=$32;
      var $34=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $35
      var $36=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $37
      var $38=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str2405738)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; };
    case 14: // $39
      __label__ = 20; break;
    case 15: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $5=$42;
      var $43=$41.f1;
      $6=$43;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 54; break; }
    case 16: // $44
      var $45=HEAP32[(($exec)>>2)];
      var $46=$45;
      var $47=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; };
    case 18: // $50
      var $51=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str2375735)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; };
    case 19: // $52
      __label__ = 20; break;
    case 20: // $53
      __label__ = 21; break;
    case 21: // $54
      __label__ = 22; break;
    case 22: // $55
      var $56=HEAP32[(($exec)>>2)];
      var $57=$56;
      var $58=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($57, $exec) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; };
    case 23: // $59
      var $60=(($58)&1);
      $gotone=$60;
      __label__ = 4; break;
    case 24: // $61
      var $62=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $63
      if ($62) { __label__ = 28; break; } else { __label__ = 26; break; }
    case 26: // $64
      var $65=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str2415739)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 15; break; };
    case 27: // $66
      __label__ = 28; break;
    case 28: // $67
      var $68=$1;
      var $69=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 15; break; };
    case 29: // $70
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($68, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$69,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 15; break; }
    case 30: // $71
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      __label__ = 52; break;
    case 31: // $72
      __label__ = 53; break;
    case 32: // $73
      $paramnum=0;
      __label__ = 33; break;
    case 33: // $74
      var $75=$paramnum;
      var $76=$3;
      var $77=(($75)|0) < (($76)|0);
      if ($77) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $78
      var $79=$1;
      var $80=$paramnum;
      var $81=$4;
      var $82=(($81+($80<<2))|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$paramnum;
      var $85=(($devicelist+($84<<2))|0);
      var $86=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($79, $83, $85);
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $88
      __label__ = 52; break;
    case 36: // $89
      __label__ = 37; break;
    case 37: // $90
      var $91=$paramnum;
      var $92=(($91+1)|0);
      $paramnum=$92;
      __label__ = 33; break;
    case 38: // $93
      $paramnum1=0;
      __label__ = 39; break;
    case 39: // $94
      var $95=$paramnum1;
      var $96=$3;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 40; break; } else { __label__ = 51; break; }
    case 40: // $98
      HEAP32[(($exec2)>>2)]=0;
      var $99=$1;
      var $100=__ZNK15running_machine10devicelistEv($99);
      var $101=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($100, $exec2);
      var $102=(($101)&1);
      $gotone3=$102;
      __label__ = 41; break;
    case 41: // $103
      var $104=$gotone3;
      var $105=(($104) & 1);
      if ($105) { __label__ = 42; break; } else { __label__ = 47; break; }
    case 42: // $106
      var $107=HEAP32[(($exec2)>>2)];
      var $108=$107;
      var $109=__ZN16device_interface6deviceEv($108);
      var $110=$paramnum1;
      var $111=(($devicelist+($110<<2))|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($109)|0)!=(($112)|0);
      if ($113) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $114
      var $115=HEAP32[(($exec2)>>2)];
      var $116=$115;
      var $117=__ZN16device_interface6deviceEv($116);
      var $118=__ZNK8device_t5debugEv($117);
      var $119=__ZNK12device_debug9observingEv($118);
      if ($119) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $120
      __label__ = 47; break;
    case 45: // $121
      __label__ = 46; break;
    case 46: // $122
      var $123=HEAP32[(($exec2)>>2)];
      var $124=$123;
      var $125=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($124, $exec2);
      var $126=(($125)&1);
      $gotone3=$126;
      __label__ = 41; break;
    case 47: // $127
      var $128=$gotone3;
      var $129=(($128) & 1);
      if ($129) { __label__ = 49; break; } else { __label__ = 48; break; }
    case 48: // $130
      var $131=$1;
      __Z20debug_console_printfR15running_machinePKcz($131, ((STRING_TABLE.__str2425740)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 52; break;
    case 49: // $132
      var $133=$paramnum1;
      var $134=(($devicelist+($133<<2))|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=__ZNK8device_t5debugEv($135);
      __ZN12device_debug6ignoreEb($136, 1);
      var $137=$1;
      var $138=$paramnum1;
      var $139=(($devicelist+($138<<2))|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=__ZNK8device_t3tagEv($140);
      __Z20debug_console_printfR15running_machinePKcz($137, ((STRING_TABLE.__str2435741)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$141,tempInt));
      __label__ = 50; break;
    case 50: // $142
      var $143=$paramnum1;
      var $144=(($143+1)|0);
      $paramnum1=$144;
      __label__ = 39; break;
    case 51: // $145
      __label__ = 52; break;
    case 52: // $146
      STACKTOP = __stackBase__;
      return;
    case 53: // $147
      var $148=$5;
      var $149=$5;
      var $150=$6;
      var $151=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $149, tempValue);
      var $152=($151.f1 = $150, $151);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 54: // $153
      var $154=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14execute_ignoreR15running_machineiiPPKc["X"]=1;

function __ZL15execute_observeR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 132; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buffer=__stackBase__;
      var $exec=__stackBase__+64;
      var $gotone;
      var $5;
      var $6;
      var $devicelist=__stackBase__+68;
      var $paramnum;
      var $paramnum1;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $7=$3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 32; break; }
    case 1: // $9
      __ZN7astringC1Ev($buffer);
      HEAP32[(($exec)>>2)]=0;
      var $10=$1;
      var $11=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $12
      var $13=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($11, $exec) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 15; break; };
    case 3: // $14
      var $15=(($13)&1);
      $gotone=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$gotone;
      var $18=(($17) & 1);
      if ($18) { __label__ = 5; break; } else { __label__ = 24; break; }
    case 5: // $19
      var $20=HEAP32[(($exec)>>2)];
      var $21=$20;
      var $22=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 15; break; };
    case 6: // $23
      var $24=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 15; break; };
    case 7: // $25
      var $26=(function() { try { __THREW__ = false; return __ZNK12device_debug9observingEv($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 15; break; };
    case 8: // $27
      if ($26) { __label__ = 9; break; } else { __label__ = 21; break; }
    case 9: // $28
      var $29=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 15; break; };
    case 10: // $30
      if ($29) { __label__ = 16; break; } else { __label__ = 11; break; }
    case 11: // $31
      var $32=HEAP32[(($exec)>>2)];
      var $33=$32;
      var $34=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $35
      var $36=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $37
      var $38=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str2365734)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$36,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; };
    case 14: // $39
      __label__ = 20; break;
    case 15: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $5=$42;
      var $43=$41.f1;
      $6=$43;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 45; break; }
    case 16: // $44
      var $45=HEAP32[(($exec)>>2)];
      var $46=$45;
      var $47=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $48
      var $49=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; };
    case 18: // $50
      var $51=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str2375735)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$49,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; };
    case 19: // $52
      __label__ = 20; break;
    case 20: // $53
      __label__ = 21; break;
    case 21: // $54
      __label__ = 22; break;
    case 22: // $55
      var $56=HEAP32[(($exec)>>2)];
      var $57=$56;
      var $58=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($57, $exec) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 15; break; };
    case 23: // $59
      var $60=(($58)&1);
      $gotone=$60;
      __label__ = 4; break;
    case 24: // $61
      var $62=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $63
      if ($62) { __label__ = 28; break; } else { __label__ = 26; break; }
    case 26: // $64
      var $65=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str2385736)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 15; break; };
    case 27: // $66
      __label__ = 28; break;
    case 28: // $67
      var $68=$1;
      var $69=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 15; break; };
    case 29: // $70
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($68, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$69,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 15; break; }
    case 30: // $71
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      __label__ = 43; break;
    case 31: // $72
      __label__ = 44; break;
    case 32: // $73
      $paramnum=0;
      __label__ = 33; break;
    case 33: // $74
      var $75=$paramnum;
      var $76=$3;
      var $77=(($75)|0) < (($76)|0);
      if ($77) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $78
      var $79=$1;
      var $80=$paramnum;
      var $81=$4;
      var $82=(($81+($80<<2))|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$paramnum;
      var $85=(($devicelist+($84<<2))|0);
      var $86=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($79, $83, $85);
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $88
      __label__ = 43; break;
    case 36: // $89
      __label__ = 37; break;
    case 37: // $90
      var $91=$paramnum;
      var $92=(($91+1)|0);
      $paramnum=$92;
      __label__ = 33; break;
    case 38: // $93
      $paramnum1=0;
      __label__ = 39; break;
    case 39: // $94
      var $95=$paramnum1;
      var $96=$3;
      var $97=(($95)|0) < (($96)|0);
      if ($97) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $98
      var $99=$paramnum1;
      var $100=(($devicelist+($99<<2))|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=__ZNK8device_t5debugEv($101);
      __ZN12device_debug6ignoreEb($102, 0);
      var $103=$1;
      var $104=$paramnum1;
      var $105=(($devicelist+($104<<2))|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=__ZNK8device_t3tagEv($106);
      __Z20debug_console_printfR15running_machinePKcz($103, ((STRING_TABLE.__str2395737)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$107,tempInt));
      __label__ = 41; break;
    case 41: // $108
      var $109=$paramnum1;
      var $110=(($109+1)|0);
      $paramnum1=$110;
      __label__ = 39; break;
    case 42: // $111
      __label__ = 43; break;
    case 43: // $112
      STACKTOP = __stackBase__;
      return;
    case 44: // $113
      var $114=$5;
      var $115=$5;
      var $116=$6;
      var $117=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $115, tempValue);
      var $118=($117.f1 = $116, $117);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 45: // $119
      var $120=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_observeR15running_machineiiPPKc["X"]=1;

function __ZL13execute_bpsetR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 636; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpu=__stackBase__;
      var $action;
      var $address=__stackBase__+4;
      var $bpnum;
      var $condition=__stackBase__+12;
      var $5;
      var $6;
      var $7;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $action=0;
      var $8=$1;
      var $9=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($8, 0, $cpu);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 21; break;
    case 2: // $12
      var $13=$1;
      var $14=$4;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($13, $16, $address);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 21; break;
    case 4: // $20
      var $21=HEAP32[(($cpu)>>2)];
      var $22=__ZNK8device_t5debugEv($21);
      var $23=__ZN12device_debug8symtableEv($22);
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($condition, $23, 0, 0);
      var $24=$1;
      var $25=$4;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(function() { try { __THREW__ = false; return __ZL34debug_command_parameter_expressionR15running_machinePKcR17parsed_expression($24, $27, $condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $29
      var $30=(($28)|0)!=0;
      if ($30) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $31
      $7=1;
      __label__ = 20; break;
    case 7: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $5=$34;
      var $35=$33.f1;
      $6=$35;
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 8: // $36
      var $37=$1;
      var $38=$4;
      var $39=(($38+8)|0);
      var $40=HEAP32[(($39)>>2)];
      $action=$40;
      var $41=(function() { try { __THREW__ = false; return __ZL31debug_command_parameter_commandR15running_machinePKc($37, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 7; break; };
    case 9: // $42
      var $43=(($41)|0)!=0;
      if ($43) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $44
      $7=1;
      __label__ = 20; break;
    case 11: // $45
      var $46=HEAP32[(($cpu)>>2)];
      var $47=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; };
    case 12: // $48
      var $st$0$0=(($address)|0);
      var $49$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($address+4)|0);
      var $49$1=HEAP32[(($st$0$1)>>2)];
      var $50$0=$49$0;
      var $50=$50$0;
      var $51=(function() { try { __THREW__ = false; return __ZNK17parsed_expression8is_emptyEv($condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 7; break; };
    case 13: // $52
      if ($51) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $53
      var $58 = 0;__label__ = 17; break;
    case 15: // $54
      var $55=(function() { try { __THREW__ = false; return __ZNK17parsed_expression15original_stringEv($condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 7; break; };
    case 16: // $56
      var $58 = $55;__label__ = 17; break;
    case 17: // $57
      var $58;
      var $59=$action;
      var $60=(function() { try { __THREW__ = false; return __ZN12device_debug14breakpoint_setEjPKcS1_($47, $50, $58, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 7; break; };
    case 18: // $61
      $bpnum=$60;
      var $62=$1;
      var $63=$bpnum;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($62, ((STRING_TABLE.__str2335731)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 7; break; }
    case 19: // $64
      $7=0;
      __label__ = 20; break;
    case 20: // $65
      __ZN17parsed_expressionD1Ev($condition);
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 21; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 21: // $66
      STACKTOP = __stackBase__;
      return;
    case 22: // $67
      __label__ = 23; break;
    case 23: // $68
      var $69=$5;
      var $70=$5;
      var $71=$6;
      var $72=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $70, tempValue);
      var $73=($72.f1 = $71, $72);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 25: // $76
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13execute_bpsetR15running_machineiiPPKc["X"]=1;

function __ZL19execute_bpdisenableR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $bpindex=__stackBase__;
      var $device;
      var $found;
      var $device1;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine10devicelistEv($8);
      var $10=$9;
      var $11=__ZNK11tagged_listI8device_tE5firstEv($10);
      $device=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$device;
      var $17=__ZNK8device_t5debugEv($16);
      var $18=$2;
      var $19=(($18)|0)!=0;
      __ZN12device_debug21breakpoint_enable_allEb($17, $19);
      __label__ = 4; break;
    case 4: // $20
      var $21=$device;
      var $22=__ZNK8device_t4nextEv($21);
      $device=$22;
      __label__ = 2; break;
    case 5: // $23
      var $24=$2;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$1;
      __Z20debug_console_printfR15running_machinePKcz($27, ((STRING_TABLE.__str2275725)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 8; break;
    case 7: // $28
      var $29=$1;
      __Z20debug_console_printfR15running_machinePKcz($29, ((STRING_TABLE.__str2285726)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 8; break;
    case 8: // $30
      __label__ = 22; break;
    case 9: // $31
      var $32=$1;
      var $33=$4;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z30debug_command_parameter_numberR15running_machinePKcPy($32, $35, $bpindex);
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $38
      __label__ = 22; break;
    case 11: // $39
      $found=0;
      var $40=$1;
      var $41=__ZNK15running_machine10devicelistEv($40);
      var $42=$41;
      var $43=__ZNK11tagged_listI8device_tE5firstEv($42);
      $device1=$43;
      __label__ = 12; break;
    case 12: // $44
      var $45=$device1;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $47
      var $48=$device1;
      var $49=__ZNK8device_t5debugEv($48);
      var $st$2$0=(($bpindex)|0);
      var $50$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($bpindex+4)|0);
      var $50$1=HEAP32[(($st$2$1)>>2)];
      var $51$0=$50$0;
      var $51=$51$0;
      var $52=$2;
      var $53=(($52)|0)!=0;
      var $54=__ZN12device_debug17breakpoint_enableEib($49, $51, $53);
      if ($54) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $55
      $found=1;
      __label__ = 15; break;
    case 15: // $56
      __label__ = 16; break;
    case 16: // $57
      var $58=$device1;
      var $59=__ZNK8device_t4nextEv($58);
      $device1=$59;
      __label__ = 12; break;
    case 17: // $60
      var $61=$found;
      var $62=(($61) & 1);
      if ($62) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $63
      var $64=$1;
      var $st$1$0=(($bpindex)|0);
      var $65$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($bpindex+4)|0);
      var $65$1=HEAP32[(($st$1$1)>>2)];
      var $66$0=$65$0;
      var $66=$66$0;
      var $67=$2;
      var $68=(($67)|0)!=0;
      var $69=$68 ? (((STRING_TABLE.__str2145712)|0)) : (((STRING_TABLE.__str2155713)|0));
      __Z20debug_console_printfR15running_machinePKcz($64, ((STRING_TABLE.__str2295727)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,HEAP32[((tempInt+4)>>2)]=$69,tempInt));
      __label__ = 20; break;
    case 19: // $70
      var $71=$1;
      var $st$1$0=(($bpindex)|0);
      var $72$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($bpindex+4)|0);
      var $72$1=HEAP32[(($st$1$1)>>2)];
      var $73$0=$72$0;
      var $73=$73$0;
      __Z20debug_console_printfR15running_machinePKcz($71, ((STRING_TABLE.__str2305728)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,tempInt));
      __label__ = 20; break;
    case 20: // $74
      __label__ = 21; break;
    case 21: // $75
      __label__ = 22; break;
    case 22: // $76
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19execute_bpdisenableR15running_machineiiPPKc["X"]=1;

function __ZL15execute_wpclearR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $wpindex=__stackBase__;
      var $device;
      var $found;
      var $device1;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine10devicelistEv($8);
      var $10=$9;
      var $11=__ZNK11tagged_listI8device_tE5firstEv($10);
      $device=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$device;
      var $17=__ZNK8device_t5debugEv($16);
      __ZN12device_debug20watchpoint_clear_allEv($17);
      __label__ = 4; break;
    case 4: // $18
      var $19=$device;
      var $20=__ZNK8device_t4nextEv($19);
      $device=$20;
      __label__ = 2; break;
    case 5: // $21
      var $22=$1;
      __Z20debug_console_printfR15running_machinePKcz($22, ((STRING_TABLE.__str2175715)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 19; break;
    case 6: // $23
      var $24=$1;
      var $25=$4;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__Z30debug_command_parameter_numberR15running_machinePKcPy($24, $27, $wpindex);
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $30
      __label__ = 19; break;
    case 8: // $31
      $found=0;
      var $32=$1;
      var $33=__ZNK15running_machine10devicelistEv($32);
      var $34=$33;
      var $35=__ZNK11tagged_listI8device_tE5firstEv($34);
      $device1=$35;
      __label__ = 9; break;
    case 9: // $36
      var $37=$device1;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $39
      var $40=$device1;
      var $41=__ZNK8device_t5debugEv($40);
      var $st$2$0=(($wpindex)|0);
      var $42$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($wpindex+4)|0);
      var $42$1=HEAP32[(($st$2$1)>>2)];
      var $43$0=$42$0;
      var $43=$43$0;
      var $44=__ZN12device_debug16watchpoint_clearEi($41, $43);
      if ($44) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $45
      $found=1;
      __label__ = 12; break;
    case 12: // $46
      __label__ = 13; break;
    case 13: // $47
      var $48=$device1;
      var $49=__ZNK8device_t4nextEv($48);
      $device1=$49;
      __label__ = 9; break;
    case 14: // $50
      var $51=$found;
      var $52=(($51) & 1);
      if ($52) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $53
      var $54=$1;
      var $st$1$0=(($wpindex)|0);
      var $55$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($wpindex+4)|0);
      var $55$1=HEAP32[(($st$1$1)>>2)];
      var $56$0=$55$0;
      var $56=$56$0;
      __Z20debug_console_printfR15running_machinePKcz($54, ((STRING_TABLE.__str2185716)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$56,tempInt));
      __label__ = 17; break;
    case 16: // $57
      var $58=$1;
      var $st$1$0=(($wpindex)|0);
      var $59$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($wpindex+4)|0);
      var $59$1=HEAP32[(($st$1$1)>>2)];
      var $60$0=$59$0;
      var $60=$60$0;
      __Z20debug_console_printfR15running_machinePKcz($58, ((STRING_TABLE.__str2165714)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$60,tempInt));
      __label__ = 17; break;
    case 17: // $61
      __label__ = 18; break;
    case 18: // $62
      __label__ = 19; break;
    case 19: // $63
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_wpclearR15running_machineiiPPKc["X"]=1;

function __ZL19execute_wpdisenableR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $wpindex=__stackBase__;
      var $device;
      var $found;
      var $device1;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $7
      var $8=$1;
      var $9=__ZNK15running_machine10devicelistEv($8);
      var $10=$9;
      var $11=__ZNK11tagged_listI8device_tE5firstEv($10);
      $device=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$device;
      var $17=__ZNK8device_t5debugEv($16);
      var $18=$2;
      var $19=(($18)|0)!=0;
      __ZN12device_debug21watchpoint_enable_allEb($17, $19);
      __label__ = 4; break;
    case 4: // $20
      var $21=$device;
      var $22=__ZNK8device_t4nextEv($21);
      $device=$22;
      __label__ = 2; break;
    case 5: // $23
      var $24=$2;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$1;
      __Z20debug_console_printfR15running_machinePKcz($27, ((STRING_TABLE.__str2115709)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 8; break;
    case 7: // $28
      var $29=$1;
      __Z20debug_console_printfR15running_machinePKcz($29, ((STRING_TABLE.__str2125710)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 8; break;
    case 8: // $30
      __label__ = 22; break;
    case 9: // $31
      var $32=$1;
      var $33=$4;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z30debug_command_parameter_numberR15running_machinePKcPy($32, $35, $wpindex);
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $38
      __label__ = 22; break;
    case 11: // $39
      $found=0;
      var $40=$1;
      var $41=__ZNK15running_machine10devicelistEv($40);
      var $42=$41;
      var $43=__ZNK11tagged_listI8device_tE5firstEv($42);
      $device1=$43;
      __label__ = 12; break;
    case 12: // $44
      var $45=$device1;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $47
      var $48=$device1;
      var $49=__ZNK8device_t5debugEv($48);
      var $st$2$0=(($wpindex)|0);
      var $50$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($wpindex+4)|0);
      var $50$1=HEAP32[(($st$2$1)>>2)];
      var $51$0=$50$0;
      var $51=$51$0;
      var $52=$2;
      var $53=(($52)|0)!=0;
      var $54=__ZN12device_debug17watchpoint_enableEib($49, $51, $53);
      if ($54) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $55
      $found=1;
      __label__ = 15; break;
    case 15: // $56
      __label__ = 16; break;
    case 16: // $57
      var $58=$device1;
      var $59=__ZNK8device_t4nextEv($58);
      $device1=$59;
      __label__ = 12; break;
    case 17: // $60
      var $61=$found;
      var $62=(($61) & 1);
      if ($62) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $63
      var $64=$1;
      var $st$1$0=(($wpindex)|0);
      var $65$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($wpindex+4)|0);
      var $65$1=HEAP32[(($st$1$1)>>2)];
      var $66$0=$65$0;
      var $66=$66$0;
      var $67=$2;
      var $68=(($67)|0)!=0;
      var $69=$68 ? (((STRING_TABLE.__str2145712)|0)) : (((STRING_TABLE.__str2155713)|0));
      __Z20debug_console_printfR15running_machinePKcz($64, ((STRING_TABLE.__str2135711)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,HEAP32[((tempInt+4)>>2)]=$69,tempInt));
      __label__ = 20; break;
    case 19: // $70
      var $71=$1;
      var $st$1$0=(($wpindex)|0);
      var $72$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($wpindex+4)|0);
      var $72$1=HEAP32[(($st$1$1)>>2)];
      var $73$0=$72$0;
      var $73=$73$0;
      __Z20debug_console_printfR15running_machinePKcz($71, ((STRING_TABLE.__str2165714)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,tempInt));
      __label__ = 20; break;
    case 20: // $74
      __label__ = 21; break;
    case 21: // $75
      __label__ = 22; break;
    case 22: // $76
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19execute_wpdisenableR15running_machineiiPPKc["X"]=1;

function __ZL14execute_bplistR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $printed;
      var $buffer=__stackBase__;
      var $device;
      var $5;
      var $6;
      var $bp;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $printed=0;
      __ZN7astringC1Ev($buffer);
      var $7=$1;
      var $8=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 25; break; };
    case 1: // $9
      var $10=$8;
      var $11=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 25; break; };
    case 2: // $12
      $device=$11;
      __label__ = 3; break;
    case 3: // $13
      var $14=$device;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 40; break; }
    case 4: // $16
      var $17=$device;
      var $18=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 25; break; };
    case 5: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK12device_debug16breakpoint_firstEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 25; break; };
    case 6: // $21
      var $22=(($20)|0)!=0;
      if ($22) { __label__ = 7; break; } else { __label__ = 37; break; }
    case 7: // $23
      var $24=$1;
      var $25=$device;
      var $26=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 25; break; };
    case 8: // $27
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($24, ((STRING_TABLE.__str2245722)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 25; break; }
    case 9: // $28
      var $29=$device;
      var $30=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 25; break; };
    case 10: // $31
      var $32=(function() { try { __THREW__ = false; return __ZNK12device_debug16breakpoint_firstEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 25; break; };
    case 11: // $33
      $bp=$32;
      __label__ = 12; break;
    case 12: // $34
      var $35=$bp;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 13; break; } else { __label__ = 36; break; }
    case 13: // $37
      var $38=$bp;
      var $39=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint7enabledEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 25; break; };
    case 14: // $40
      var $41=$39 ? 32 : 68;
      var $42=(($41 << 24) >> 24);
      var $43=$bp;
      var $44=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint5indexEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 25; break; };
    case 15: // $45
      var $46=$bp;
      var $47=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint7addressEv($46) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 25; break; };
    case 16: // $48
      var $49$0=$47;
      var $49$1=0;
      var $50=$device;
      var $51=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 25; break; };
    case 17: // $52
      var $53=(function() { try { __THREW__ = false; return __ZNK12device_debug12logaddrcharsE16address_spacenum($51, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 25; break; };
    case 18: // $54
      var $55=(($53) & 255);
      var $56=(function() { try { __THREW__ = false; return __Z19core_i64_hex_formatyh($49$0, $49$1, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 25; break; };
    case 19: // $57
      var $58=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str2255723)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$42,HEAP32[((tempInt+4)>>2)]=$44,HEAP32[((tempInt+8)>>2)]=$56,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 25; break; };
    case 20: // $59
      var $60=$bp;
      var $61=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint9conditionEv($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 25; break; };
    case 21: // $62
      var $63=(($61)|0)!=0;
      if ($63) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $64
      var $65=$bp;
      var $66=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint9conditionEv($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; };
    case 23: // $67
      var $68=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str2085706)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 25; break; };
    case 24: // $69
      __label__ = 26; break;
    case 25: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $5=$72;
      var $73=$71.f1;
      $6=$73;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 26: // $74
      var $75=$bp;
      var $76=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint6actionEv($75) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 25; break; };
    case 27: // $77
      var $78=(($76)|0)!=0;
      if ($78) { __label__ = 28; break; } else { __label__ = 31; break; }
    case 28: // $79
      var $80=$bp;
      var $81=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint6actionEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 25; break; };
    case 29: // $82
      var $83=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str2095707)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 25; break; };
    case 30: // $84
      __label__ = 31; break;
    case 31: // $85
      var $86=$1;
      var $87=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 25; break; };
    case 32: // $88
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($86, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$87,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 25; break; }
    case 33: // $89
      var $90=$printed;
      var $91=(($90+1)|0);
      $printed=$91;
      __label__ = 34; break;
    case 34: // $92
      var $93=$bp;
      var $94=(function() { try { __THREW__ = false; return __ZNK12device_debug10breakpoint4nextEv($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 25; break; };
    case 35: // $95
      $bp=$94;
      __label__ = 12; break;
    case 36: // $96
      __label__ = 37; break;
    case 37: // $97
      __label__ = 38; break;
    case 38: // $98
      var $99=$device;
      var $100=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 25; break; };
    case 39: // $101
      $device=$100;
      __label__ = 3; break;
    case 40: // $102
      var $103=$printed;
      var $104=(($103)|0)==0;
      if ($104) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $105
      var $106=$1;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($106, ((STRING_TABLE.__str2265724)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 25; break; }
    case 42: // $107
      __label__ = 43; break;
    case 43: // $108
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 44: // $109
      __label__ = 45; break;
    case 45: // $110
      var $111=$5;
      var $112=$5;
      var $113=$6;
      var $114=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $112, tempValue);
      var $115=($114.f1 = $113, $114);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14execute_bplistR15running_machineiiPPKc["X"]=1;

function __ZL13execute_wpsetR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 644; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $space=__stackBase__;
      var $action;
      var $address=__stackBase__+4;
      var $length=__stackBase__+12;
      var $type;
      var $wpnum;
      var $condition=__stackBase__+20;
      var $5;
      var $6;
      var $7;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $action=0;
      $type=0;
      var $8=$1;
      var $9=$2;
      var $10=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($8, 0, $9, $space);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      __label__ = 34; break;
    case 2: // $13
      var $14=$1;
      var $15=$4;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__Z30debug_command_parameter_numberR15running_machinePKcPy($14, $17, $address);
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      __label__ = 34; break;
    case 4: // $21
      var $22=$1;
      var $23=$4;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__Z30debug_command_parameter_numberR15running_machinePKcPy($22, $25, $length);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $28
      __label__ = 34; break;
    case 6: // $29
      var $30=$4;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=_strcmp($32, ((STRING_TABLE.__str2195717)|0));
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $35
      $type=1;
      __label__ = 16; break;
    case 8: // $36
      var $37=$4;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=_strcmp($39, ((STRING_TABLE.__str1185616)|0));
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $42
      $type=2;
      __label__ = 15; break;
    case 10: // $43
      var $44=$4;
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=_strcmp($46, ((STRING_TABLE.__str2205718)|0));
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $49
      var $50=$4;
      var $51=(($50+8)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=_strcmp($52, ((STRING_TABLE.__str2215719)|0));
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $55
      $type=3;
      __label__ = 14; break;
    case 13: // $56
      var $57=$1;
      __Z20debug_console_printfR15running_machinePKcz($57, ((STRING_TABLE.__str2225720)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 34; break;
    case 14: // $58
      __label__ = 15; break;
    case 15: // $59
      __label__ = 16; break;
    case 16: // $60
      var $61=HEAP32[(($space)>>2)];
      var $62=__ZNK13address_space6deviceEv($61);
      var $63=__ZNK8device_t5debugEv($62);
      var $64=__ZN12device_debug8symtableEv($63);
      FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($condition, $64, 0, 0);
      var $65=$1;
      var $66=$4;
      var $67=(($66+12)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(function() { try { __THREW__ = false; return __ZL34debug_command_parameter_expressionR15running_machinePKcR17parsed_expression($65, $68, $condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $70
      var $71=(($69)|0)!=0;
      if ($71) { __label__ = 20; break; } else { __label__ = 18; break; }
    case 18: // $72
      $7=1;
      __label__ = 33; break;
    case 19: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $75=$74.f0;
      $5=$75;
      var $76=$74.f1;
      $6=$76;
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 20: // $77
      var $78=$1;
      var $79=$4;
      var $80=(($79+16)|0);
      var $81=HEAP32[(($80)>>2)];
      $action=$81;
      var $82=(function() { try { __THREW__ = false; return __ZL31debug_command_parameter_commandR15running_machinePKc($78, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 19; break; };
    case 21: // $83
      var $84=(($82)|0)!=0;
      if ($84) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $85
      $7=1;
      __label__ = 33; break;
    case 23: // $86
      var $87=HEAP32[(($space)>>2)];
      var $88=(function() { try { __THREW__ = false; return __ZNK13address_space6deviceEv($87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 19; break; };
    case 24: // $89
      var $90=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 19; break; };
    case 25: // $91
      var $92=HEAP32[(($space)>>2)];
      var $93=$type;
      var $st$2$0=(($address)|0);
      var $94$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($address+4)|0);
      var $94$1=HEAP32[(($st$2$1)>>2)];
      var $95$0=$94$0;
      var $95=$95$0;
      var $st$8$0=(($length)|0);
      var $96$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($length+4)|0);
      var $96$1=HEAP32[(($st$8$1)>>2)];
      var $97$0=$96$0;
      var $97=$97$0;
      var $98=(function() { try { __THREW__ = false; return __ZNK17parsed_expression8is_emptyEv($condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 19; break; };
    case 26: // $99
      if ($98) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $100
      var $105 = 0;__label__ = 30; break;
    case 28: // $101
      var $102=(function() { try { __THREW__ = false; return __ZNK17parsed_expression15original_stringEv($condition) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 19; break; };
    case 29: // $103
      var $105 = $102;__label__ = 30; break;
    case 30: // $104
      var $105;
      var $106=$action;
      var $107=(function() { try { __THREW__ = false; return __ZN12device_debug14watchpoint_setER13address_spaceijjPKcS3_($90, $92, $93, $95, $97, $105, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 19; break; };
    case 31: // $108
      $wpnum=$107;
      var $109=$1;
      var $110=$wpnum;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($109, ((STRING_TABLE.__str2235721)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$110,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 19; break; }
    case 32: // $111
      $7=0;
      __label__ = 33; break;
    case 33: // $112
      __ZN17parsed_expressionD1Ev($condition);
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0 || $cleanup_dest == 1) {
        __label__ = 34; break;
      }
      else {
      __label__ = 38; break;
      }
      
    case 34: // $113
      STACKTOP = __stackBase__;
      return;
    case 35: // $114
      __label__ = 36; break;
    case 36: // $115
      var $116=$5;
      var $117=$5;
      var $118=$6;
      var $119=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $117, tempValue);
      var $120=($119.f1 = $118, $119);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 38: // $123
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13execute_wpsetR15running_machineiiPPKc["X"]=1;

function __ZL15execute_hotspotR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cleared;
      var $device;
      var $device1=__stackBase__;
      var $count=__stackBase__+4;
      var $threshhold=__stackBase__+12;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $7
      $cleared=0;
      var $8=$1;
      var $9=__ZNK15running_machine10devicelistEv($8);
      var $10=$9;
      var $11=__ZNK11tagged_listI8device_tE5firstEv($10);
      $device=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$device;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $15
      var $16=$device;
      var $17=__ZNK8device_t5debugEv($16);
      var $18=__ZNK12device_debug24hotspot_tracking_enabledEv($17);
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$device;
      var $21=__ZNK8device_t5debugEv($20);
      __ZN12device_debug13hotspot_trackEii($21, 0, 0);
      var $22=$1;
      var $23=$device;
      var $24=__ZNK8device_t3tagEv($23);
      __Z20debug_console_printfR15running_machinePKcz($22, ((STRING_TABLE.__str2005698)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      $cleared=1;
      __label__ = 5; break;
    case 5: // $25
      __label__ = 6; break;
    case 6: // $26
      var $27=$device;
      var $28=__ZNK8device_t4nextEv($27);
      $device=$28;
      __label__ = 2; break;
    case 7: // $29
      var $30=$cleared;
      var $31=(($30) & 1);
      if ($31) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $32
      __label__ = 20; break;
    case 9: // $33
      __label__ = 10; break;
    case 10: // $34
      HEAP32[(($device1)>>2)]=0;
      var $35=$1;
      var $36=$3;
      var $37=(($36)|0) > 0;
      if ($37) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $38
      var $39=$4;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $44 = $41;__label__ = 13; break;
    case 12: // $42
      var $44 = 0;__label__ = 13; break;
    case 13: // $43
      var $44;
      var $45=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($35, $44, $device1);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $47
      __label__ = 20; break;
    case 15: // $48
      var $$emscripten$temp$0$0=64;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($count)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($count+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      var $49=$1;
      var $50=$4;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=__Z30debug_command_parameter_numberR15running_machinePKcPy($49, $52, $count);
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $55
      __label__ = 20; break;
    case 17: // $56
      var $$emscripten$temp$1$0=250;
      var $$emscripten$temp$1$1=0;
      var $st$2$0=(($threshhold)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$1$0;
      var $st$2$1=(($threshhold+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$1$1;
      var $57=$1;
      var $58=$4;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=__Z30debug_command_parameter_numberR15running_machinePKcPy($57, $60, $threshhold);
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $63
      __label__ = 20; break;
    case 19: // $64
      var $65=HEAP32[(($device1)>>2)];
      var $66=__ZNK8device_t5debugEv($65);
      var $st$2$0=(($count)|0);
      var $67$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($count+4)|0);
      var $67$1=HEAP32[(($st$2$1)>>2)];
      var $68$0=$67$0;
      var $68=$68$0;
      var $st$8$0=(($threshhold)|0);
      var $69$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($threshhold+4)|0);
      var $69$1=HEAP32[(($st$8$1)>>2)];
      var $70$0=$69$0;
      var $70=$70$0;
      __ZN12device_debug13hotspot_trackEii($66, $68, $70);
      var $71=$1;
      var $72=HEAP32[(($device1)>>2)];
      var $73=__ZNK8device_t3tagEv($72);
      var $st$18$0=(($count)|0);
      var $74$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($count+4)|0);
      var $74$1=HEAP32[(($st$18$1)>>2)];
      var $75$0=$74$0;
      var $75=$75$0;
      var $st$24$0=(($threshhold)|0);
      var $76$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($threshhold+4)|0);
      var $76$1=HEAP32[(($st$24$1)>>2)];
      var $77$0=$76$0;
      var $77=$77$0;
      __Z20debug_console_printfR15running_machinePKcz($71, ((STRING_TABLE.__str2015699)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$73,HEAP32[((tempInt+4)>>2)]=$75,HEAP32[((tempInt+8)>>2)]=$77,tempInt));
      __label__ = 20; break;
    case 20: // $78
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_hotspotR15running_machineiiPPKc["X"]=1;

function __ZL12execute_saveR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset=__stackBase__;
      var $endoffset=__stackBase__+8;
      var $length=__stackBase__+16;
      var $space=__stackBase__+24;
      var $f;
      var $i=__stackBase__+28;
      var $byte=__stackBase__+36;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$4;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $offset);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 16; break;
    case 2: // $12
      var $13=$1;
      var $14=$4;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($13, $16, $length);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 16; break;
    case 4: // $20
      var $21=$1;
      var $22=$3;
      var $23=(($22)|0) > 3;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$4;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $30 = $27;__label__ = 7; break;
    case 6: // $28
      var $30 = 0;__label__ = 7; break;
    case 7: // $29
      var $30;
      var $31=$2;
      var $32=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($21, $30, $31, $space);
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $34
      __label__ = 16; break;
    case 9: // $35
      var $36=HEAP32[(($space)>>2)];
      var $st$1$0=(($offset)|0);
      var $37$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $37$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($length)|0);
      var $38$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($length+4)|0);
      var $38$1=HEAP32[(($st$5$1)>>2)];
      var $39$0 = ((($37$0)>>>0)+((($37$1)|0)*4294967296))+((($38$0)>>>0)+((($38$1)|0)*4294967296))>>>0; var $39$1 = Math.min(Math.floor((((($37$0)>>>0)+((($37$1)|0)*4294967296))+((($38$0)>>>0)+((($38$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $40$0 = ((($39$0)>>>0)+((($39$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $40$1 = Math.min(Math.floor((((($39$0)>>>0)+((($39$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $41$0=$40$0;
      var $41=$41$0;
      var $42=__ZNK13address_space15address_to_byteEj($36, $41);
      var $43=HEAP32[(($space)>>2)];
      var $44=__ZNK13address_space8bytemaskEv($43);
      var $45=$42 & $44;
      var $46$0=$45;
      var $46$1=0;
      var $st$21$0=(($endoffset)|0);
      HEAP32[(($st$21$0)>>2)]=$46$0;
      var $st$21$1=(($endoffset+4)|0);
      HEAP32[(($st$21$1)>>2)]=$46$1;
      var $47=HEAP32[(($space)>>2)];
      var $st$26$0=(($offset)|0);
      var $48$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($offset+4)|0);
      var $48$1=HEAP32[(($st$26$1)>>2)];
      var $49$0=$48$0;
      var $49=$49$0;
      var $50=__ZNK13address_space15address_to_byteEj($47, $49);
      var $51=HEAP32[(($space)>>2)];
      var $52=__ZNK13address_space8bytemaskEv($51);
      var $53=$50 & $52;
      var $54$0=$53;
      var $54$1=0;
      var $st$38$0=(($offset)|0);
      HEAP32[(($st$38$0)>>2)]=$54$0;
      var $st$38$1=(($offset+4)|0);
      HEAP32[(($st$38$1)>>2)]=$54$1;
      var $55=$4;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=_fopen($57, ((STRING_TABLE.__str1985696)|0));
      $f=$58;
      var $59=$f;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $61
      var $62=$1;
      var $63=$4;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($62, ((STRING_TABLE.__str1325630)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$65,tempInt));
      __label__ = 16; break;
    case 11: // $66
      var $st$0$0=(($offset)|0);
      var $67$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($offset+4)|0);
      var $67$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($i)|0);
      HEAP32[(($st$4$0)>>2)]=$67$0;
      var $st$4$1=(($i+4)|0);
      HEAP32[(($st$4$1)>>2)]=$67$1;
      __label__ = 12; break;
    case 12: // $68
      var $st$0$0=(($i)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $69$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($endoffset)|0);
      var $70$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($endoffset+4)|0);
      var $70$1=HEAP32[(($st$4$1)>>2)];
      var $71=$69$1 <= $70$1 && ($69$1 < $70$1 || $69$0 <= $70$0);
      if ($71) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $72
      var $73=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $74$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $74$1=HEAP32[(($st$1$1)>>2)];
      var $75$0=$74$0;
      var $75=$75$0;
      var $76=__Z15debug_read_byteP13address_spaceji($73, $75, 1);
      HEAP8[($byte)]=$76;
      var $77=$f;
      var $78=_fwrite($byte, 1, 1, $77);
      __label__ = 14; break;
    case 14: // $79
      var $st$0$0=(($i)|0);
      var $80$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $80$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $81$0 = ((($80$0)>>>0)+((($80$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $81$1 = Math.min(Math.floor((((($80$0)>>>0)+((($80$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($i)|0);
      HEAP32[(($st$7$0)>>2)]=$81$0;
      var $st$7$1=(($i+4)|0);
      HEAP32[(($st$7$1)>>2)]=$81$1;
      __label__ = 12; break;
    case 15: // $82
      var $83=$f;
      var $84=_fclose($83);
      var $85=$1;
      __Z20debug_console_printfR15running_machinePKcz($85, ((STRING_TABLE.__str1995697)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 16: // $86
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12execute_saveR15running_machineiiPPKc["X"]=1;

function __ZL12execute_loadR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset=__stackBase__;
      var $endoffset=__stackBase__+8;
      var $length=__stackBase__+16;
      var $space=__stackBase__+24;
      var $f;
      var $i=__stackBase__+28;
      var $byte=__stackBase__+36;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$4;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $offset);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 22; break;
    case 2: // $12
      var $13=$1;
      var $14=$4;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($13, $16, $length);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 22; break;
    case 4: // $20
      var $21=$1;
      var $22=$3;
      var $23=(($22)|0) > 3;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$4;
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $30 = $27;__label__ = 7; break;
    case 6: // $28
      var $30 = 0;__label__ = 7; break;
    case 7: // $29
      var $30;
      var $31=$2;
      var $32=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($21, $30, $31, $space);
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $34
      __label__ = 22; break;
    case 9: // $35
      var $36=HEAP32[(($space)>>2)];
      var $st$1$0=(($offset)|0);
      var $37$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $37$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($length)|0);
      var $38$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($length+4)|0);
      var $38$1=HEAP32[(($st$5$1)>>2)];
      var $39$0 = ((($37$0)>>>0)+((($37$1)|0)*4294967296))+((($38$0)>>>0)+((($38$1)|0)*4294967296))>>>0; var $39$1 = Math.min(Math.floor((((($37$0)>>>0)+((($37$1)|0)*4294967296))+((($38$0)>>>0)+((($38$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $40$0 = ((($39$0)>>>0)+((($39$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $40$1 = Math.min(Math.floor((((($39$0)>>>0)+((($39$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $41$0=$40$0;
      var $41=$41$0;
      var $42=__ZNK13address_space15address_to_byteEj($36, $41);
      var $43=HEAP32[(($space)>>2)];
      var $44=__ZNK13address_space8bytemaskEv($43);
      var $45=$42 & $44;
      var $46$0=$45;
      var $46$1=0;
      var $st$21$0=(($endoffset)|0);
      HEAP32[(($st$21$0)>>2)]=$46$0;
      var $st$21$1=(($endoffset+4)|0);
      HEAP32[(($st$21$1)>>2)]=$46$1;
      var $47=HEAP32[(($space)>>2)];
      var $st$26$0=(($offset)|0);
      var $48$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($offset+4)|0);
      var $48$1=HEAP32[(($st$26$1)>>2)];
      var $49$0=$48$0;
      var $49=$49$0;
      var $50=__ZNK13address_space15address_to_byteEj($47, $49);
      var $51=HEAP32[(($space)>>2)];
      var $52=__ZNK13address_space8bytemaskEv($51);
      var $53=$50 & $52;
      var $54$0=$53;
      var $54$1=0;
      var $st$38$0=(($offset)|0);
      HEAP32[(($st$38$0)>>2)]=$54$0;
      var $st$38$1=(($offset+4)|0);
      HEAP32[(($st$38$1)>>2)]=$54$1;
      var $55=$4;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=_fopen($57, ((STRING_TABLE.__str1955693)|0));
      $f=$58;
      var $59=$f;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $61
      var $62=$1;
      var $63=$4;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($62, ((STRING_TABLE.__str1325630)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$65,tempInt));
      __label__ = 22; break;
    case 11: // $66
      var $st$0$0=(($offset)|0);
      var $67$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($offset+4)|0);
      var $67$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($i)|0);
      HEAP32[(($st$4$0)>>2)]=$67$0;
      var $st$4$1=(($i+4)|0);
      HEAP32[(($st$4$1)>>2)]=$67$1;
      __label__ = 12; break;
    case 12: // $68
      var $st$0$0=(($i)|0);
      var $69$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $69$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($endoffset)|0);
      var $70$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($endoffset+4)|0);
      var $70$1=HEAP32[(($st$4$1)>>2)];
      var $71=$69$1 <= $70$1 && ($69$1 < $70$1 || $69$0 <= $70$0);
      if ($71) { var $78 = 1;__label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $72
      var $st$0$0=(($endoffset)|0);
      var $73$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($endoffset+4)|0);
      var $73$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($offset)|0);
      var $74$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($offset+4)|0);
      var $74$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $75$0 = ((($74$0)>>>0)+((($74$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $75$1 = Math.min(Math.floor((((($74$0)>>>0)+((($74$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $76=$73$0 == $75$0 && $73$1 == $75$1;
      var $78 = $76;__label__ = 14; break;
    case 14: // $77
      var $78;
      if ($78) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $79
      var $80=$f;
      var $81=_fread($byte, 1, 1, $80);
      var $82=$f;
      var $83=_feof($82);
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $85
      __label__ = 19; break;
    case 17: // $86
      var $87=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $88$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $88$1=HEAP32[(($st$1$1)>>2)];
      var $89$0=$88$0;
      var $89=$89$0;
      var $90=HEAP8[($byte)];
      __Z16debug_write_byteP13address_spacejhi($87, $89, $90, 1);
      __label__ = 18; break;
    case 18: // $91
      var $st$0$0=(($i)|0);
      var $92$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $92$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $93$0 = ((($92$0)>>>0)+((($92$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $93$1 = Math.min(Math.floor((((($92$0)>>>0)+((($92$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($i)|0);
      HEAP32[(($st$7$0)>>2)]=$93$0;
      var $st$7$1=(($i+4)|0);
      HEAP32[(($st$7$1)>>2)]=$93$1;
      __label__ = 12; break;
    case 19: // $94
      var $95=$f;
      var $96=_fclose($95);
      var $st$2$0=(($i)|0);
      var $97$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($i+4)|0);
      var $97$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($offset)|0);
      var $98$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($offset+4)|0);
      var $98$1=HEAP32[(($st$6$1)>>2)];
      var $99=$97$0 == $98$0 && $97$1 == $98$1;
      if ($99) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $100
      var $101=$1;
      __Z20debug_console_printfR15running_machinePKcz($101, ((STRING_TABLE.__str1965694)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 22; break;
    case 21: // $102
      var $103=$1;
      var $st$1$0=(($offset)|0);
      var $104$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $104$1=HEAP32[(($st$1$1)>>2)];
      var $105=__Z19core_i64_hex_formatyh($104$0, $104$1, 0);
      var $st$6$0=(($i)|0);
      var $106$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($i+4)|0);
      var $106$1=HEAP32[(($st$6$1)>>2)];
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $107$0 = ((($106$0)>>>0)+((($106$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $107$1 = Math.min(Math.floor((((($106$0)>>>0)+((($106$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $108=__Z19core_i64_hex_formatyh($107$0, $107$1, 0);
      __Z20debug_console_printfR15running_machinePKcz($103, ((STRING_TABLE.__str1975695)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$105,HEAP32[((tempInt+4)>>2)]=$108,tempInt));
      __label__ = 22; break;
    case 22: // $109
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12execute_loadR15running_machineiiPPKc["X"]=1;

function __ZL14execute_wplistR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $printed;
      var $buffer=__stackBase__;
      var $device;
      var $5;
      var $6;
      var $spacenum=__stackBase__+64;
      var $wp;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $printed=0;
      __ZN7astringC1Ev($buffer);
      var $7=$1;
      var $8=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 41; break; };
    case 1: // $9
      var $10=$8;
      var $11=(function() { try { __THREW__ = false; return __ZNK11tagged_listI8device_tE5firstEv($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 41; break; };
    case 2: // $12
      $device=$11;
      __label__ = 3; break;
    case 3: // $13
      var $14=$device;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 59; break; }
    case 4: // $16
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 5; break;
    case 5: // $17
      var $18=HEAP32[(($spacenum)>>2)];
      var $19=(($18)|0) < 4;
      if ($19) { __label__ = 6; break; } else { __label__ = 56; break; }
    case 6: // $20
      var $21=$device;
      var $22=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 41; break; };
    case 7: // $23
      var $24=HEAP32[(($spacenum)>>2)];
      var $25=(function() { try { __THREW__ = false; return __ZNK12device_debug16watchpoint_firstE16address_spacenum($22, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 41; break; };
    case 8: // $26
      var $27=(($25)|0)!=0;
      if ($27) { __label__ = 9; break; } else { __label__ = 53; break; }
    case 9: // $28
      var $29=$1;
      var $30=$device;
      var $31=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 41; break; };
    case 10: // $32
      var $33=$device;
      var $34=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 41; break; };
    case 11: // $35
      var $36=HEAP32[(($spacenum)>>2)];
      var $37=(function() { try { __THREW__ = false; return __ZNK12device_debug16watchpoint_firstE16address_spacenum($34, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 41; break; };
    case 12: // $38
      var $39=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint5spaceEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 41; break; };
    case 13: // $40
      var $41=(function() { try { __THREW__ = false; return __ZNK13address_space4nameEv($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 41; break; };
    case 14: // $42
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($29, ((STRING_TABLE.__str2065704)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$41,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 41; break; }
    case 15: // $43
      var $44=$device;
      var $45=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 41; break; };
    case 16: // $46
      var $47=HEAP32[(($spacenum)>>2)];
      var $48=(function() { try { __THREW__ = false; return __ZNK12device_debug16watchpoint_firstE16address_spacenum($45, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 41; break; };
    case 17: // $49
      $wp=$48;
      __label__ = 18; break;
    case 18: // $50
      var $51=$wp;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 19; break; } else { __label__ = 52; break; }
    case 19: // $53
      var $54=$wp;
      var $55=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint7enabledEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 41; break; };
    case 20: // $56
      var $57=$55 ? 32 : 68;
      var $58=(($57 << 24) >> 24);
      var $59=$wp;
      var $60=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint5indexEv($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 41; break; };
    case 21: // $61
      var $62=$wp;
      var $63=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint5spaceEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 41; break; };
    case 22: // $64
      var $65=$wp;
      var $66=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint7addressEv($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 41; break; };
    case 23: // $67
      var $68=(function() { try { __THREW__ = false; return __ZNK13address_space15byte_to_addressEj($63, $66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 41; break; };
    case 24: // $69
      var $70$0=$68;
      var $70$1=0;
      var $71=$wp;
      var $72=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint5spaceEv($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 41; break; };
    case 25: // $73
      var $74=(function() { try { __THREW__ = false; return __ZNK13address_space9addrcharsEv($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 41; break; };
    case 26: // $75
      var $76=(function() { try { __THREW__ = false; return __Z19core_i64_hex_formatyh($70$0, $70$1, $74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 41; break; };
    case 27: // $77
      var $78=$wp;
      var $79=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint5spaceEv($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 41; break; };
    case 28: // $80
      var $81=$wp;
      var $82=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint7addressEv($81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 41; break; };
    case 29: // $83
      var $84=$wp;
      var $85=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint6lengthEv($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 41; break; };
    case 30: // $86
      var $87=(($82+$85)|0);
      var $88=(function() { try { __THREW__ = false; return __ZNK13address_space19byte_to_address_endEj($79, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 41; break; };
    case 31: // $89
      var $90=(($88-1)|0);
      var $91$0=$90;
      var $91$1=0;
      var $92=$wp;
      var $93=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint5spaceEv($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 41; break; };
    case 32: // $94
      var $95=(function() { try { __THREW__ = false; return __ZNK13address_space9addrcharsEv($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 41; break; };
    case 33: // $96
      var $97=(function() { try { __THREW__ = false; return __Z19core_i64_hex_formatyh($91$0, $91$1, $95) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 41; break; };
    case 34: // $98
      var $99=$wp;
      var $100=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint4typeEv($99) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 41; break; };
    case 35: // $101
      var $102=$100 & 3;
      var $103=((__ZZL14execute_wplistR15running_machineiiPPKcE5types+($102<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($buffer, ((STRING_TABLE.__str2075705)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$58,HEAP32[((tempInt+4)>>2)]=$60,HEAP32[((tempInt+8)>>2)]=$76,HEAP32[((tempInt+12)>>2)]=$97,HEAP32[((tempInt+16)>>2)]=$104,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 41; break; };
    case 36: // $106
      var $107=$wp;
      var $108=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint9conditionEv($107) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 41; break; };
    case 37: // $109
      var $110=(($108)|0)!=0;
      if ($110) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $111
      var $112=$wp;
      var $113=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint9conditionEv($112) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 41; break; };
    case 39: // $114
      var $115=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str2085706)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$113,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; };
    case 40: // $116
      __label__ = 42; break;
    case 41: // $117
      var $118=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $119=$118.f0;
      $5=$119;
      var $120=$118.f1;
      $6=$120;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 42: // $121
      var $122=$wp;
      var $123=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint6actionEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 41; break; };
    case 43: // $124
      var $125=(($123)|0)!=0;
      if ($125) { __label__ = 44; break; } else { __label__ = 47; break; }
    case 44: // $126
      var $127=$wp;
      var $128=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint6actionEv($127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 41; break; };
    case 45: // $129
      var $130=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($buffer, ((STRING_TABLE.__str2095707)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$128,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 41; break; };
    case 46: // $131
      __label__ = 47; break;
    case 47: // $132
      var $133=$1;
      var $134=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 41; break; };
    case 48: // $135
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($133, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$134,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 41; break; }
    case 49: // $136
      var $137=$printed;
      var $138=(($137+1)|0);
      $printed=$138;
      __label__ = 50; break;
    case 50: // $139
      var $140=$wp;
      var $141=(function() { try { __THREW__ = false; return __ZNK12device_debug10watchpoint4nextEv($140) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 41; break; };
    case 51: // $142
      $wp=$141;
      __label__ = 18; break;
    case 52: // $143
      __label__ = 53; break;
    case 53: // $144
      __label__ = 54; break;
    case 54: // $145
      (function() { try { __THREW__ = false; return __ZppR16address_spacenumi($spacenum, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 41; break; }
    case 55: // $146
      __label__ = 5; break;
    case 56: // $147
      __label__ = 57; break;
    case 57: // $148
      var $149=$device;
      var $150=(function() { try { __THREW__ = false; return __ZNK8device_t4nextEv($149) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 41; break; };
    case 58: // $151
      $device=$150;
      __label__ = 3; break;
    case 59: // $152
      var $153=$printed;
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $155
      var $156=$1;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($156, ((STRING_TABLE.__str2105708)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 41; break; }
    case 61: // $157
      __label__ = 62; break;
    case 62: // $158
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 63: // $159
      __label__ = 64; break;
    case 64: // $160
      var $161=$5;
      var $162=$5;
      var $163=$6;
      var $164=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $162, tempValue);
      var $165=($164.f1 = $163, $164);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 65: // $166
      var $167=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14execute_wplistR15running_machineiiPPKc["X"]=1;

function __ZL12execute_dumpR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 276; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset=__stackBase__;
      var $endoffset=__stackBase__+8;
      var $length=__stackBase__+16;
      var $width=__stackBase__+24;
      var $ascii=__stackBase__+32;
      var $space=__stackBase__+40;
      var $f;
      var $i=__stackBase__+44;
      var $j=__stackBase__+52;
      var $output=__stackBase__+60;
      var $outdex;
      var $curaddr=__stackBase__+260;
      var $value=__stackBase__+264;
      var $curaddr1=__stackBase__+272;
      var $byte;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$25$0=(($width)|0);
      HEAP32[(($st$25$0)>>2)]=$$emscripten$temp$0$0;
      var $st$25$1=(($width+4)|0);
      HEAP32[(($st$25$1)>>2)]=$$emscripten$temp$0$1;
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $st$31$0=(($ascii)|0);
      HEAP32[(($st$31$0)>>2)]=$$emscripten$temp$1$0;
      var $st$31$1=(($ascii+4)|0);
      HEAP32[(($st$31$1)>>2)]=$$emscripten$temp$1$1;
      $f=0;
      var $5=$1;
      var $6=$4;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $offset);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 54; break;
    case 2: // $12
      var $13=$1;
      var $14=$4;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($13, $16, $length);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 54; break;
    case 4: // $20
      var $21=$1;
      var $22=$4;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__Z30debug_command_parameter_numberR15running_machinePKcPy($21, $24, $width);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $27
      __label__ = 54; break;
    case 6: // $28
      var $29=$1;
      var $30=$4;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=__Z30debug_command_parameter_numberR15running_machinePKcPy($29, $32, $ascii);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $35
      __label__ = 54; break;
    case 8: // $36
      var $37=$1;
      var $38=$3;
      var $39=(($38)|0) > 5;
      if ($39) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $40
      var $41=$4;
      var $42=(($41+20)|0);
      var $43=HEAP32[(($42)>>2)];
      var $46 = $43;__label__ = 11; break;
    case 10: // $44
      var $46 = 0;__label__ = 11; break;
    case 11: // $45
      var $46;
      var $47=$2;
      var $48=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($37, $46, $47, $space);
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $50
      __label__ = 54; break;
    case 13: // $51
      var $st$0$0=(($width)|0);
      var $52$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $52$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $53=$52$0 == $$emscripten$temp$2$0 && $52$1 == $$emscripten$temp$2$1;
      if ($53) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $54
      var $55=HEAP32[(($space)>>2)];
      var $56=__ZNK13address_space10data_widthEv($55);
      var $57=(((($56)|0)/8)|0);
      var $58$0=$57;
      var $58$1=(($57|0) < 0 ? -1 : 0);
      var $st$5$0=(($width)|0);
      HEAP32[(($st$5$0)>>2)]=$58$0;
      var $st$5$1=(($width+4)|0);
      HEAP32[(($st$5$1)>>2)]=$58$1;
      __label__ = 15; break;
    case 15: // $59
      var $st$0$0=(($width)|0);
      var $60$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $60$1=HEAP32[(($st$0$1)>>2)];
      var $61=HEAP32[(($space)>>2)];
      var $62=__ZNK13address_space15address_to_byteEj($61, 1);
      var $63$0=$62;
      var $63$1=0;
      var $64=$60$1 < $63$1 || ($60$1 == $63$1 && $60$0 < $63$0);
      if ($64) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $65
      var $66=HEAP32[(($space)>>2)];
      var $67=__ZNK13address_space15address_to_byteEj($66, 1);
      var $68$0=$67;
      var $68$1=0;
      var $st$4$0=(($width)|0);
      HEAP32[(($st$4$0)>>2)]=$68$0;
      var $st$4$1=(($width+4)|0);
      HEAP32[(($st$4$1)>>2)]=$68$1;
      __label__ = 17; break;
    case 17: // $69
      var $st$0$0=(($width)|0);
      var $70$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $70$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $71=$70$0 != $$emscripten$temp$3$0 || $70$1 != $$emscripten$temp$3$1;
      if ($71) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $72
      var $st$0$0=(($width)|0);
      var $73$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $73$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$4$0=2;
      var $$emscripten$temp$4$1=0;
      var $74=$73$0 != $$emscripten$temp$4$0 || $73$1 != $$emscripten$temp$4$1;
      if ($74) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $75
      var $st$0$0=(($width)|0);
      var $76$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $76$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$5$0=4;
      var $$emscripten$temp$5$1=0;
      var $77=$76$0 != $$emscripten$temp$5$0 || $76$1 != $$emscripten$temp$5$1;
      if ($77) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $78
      var $st$0$0=(($width)|0);
      var $79$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $79$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$6$0=8;
      var $$emscripten$temp$6$1=0;
      var $80=$79$0 != $$emscripten$temp$6$0 || $79$1 != $$emscripten$temp$6$1;
      if ($80) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $81
      var $82=$1;
      __Z20debug_console_printfR15running_machinePKcz($82, ((STRING_TABLE.__str1885686)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 54; break;
    case 22: // $83
      var $84=HEAP32[(($space)>>2)];
      var $st$1$0=(($offset)|0);
      var $85$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $85$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($length)|0);
      var $86$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($length+4)|0);
      var $86$1=HEAP32[(($st$5$1)>>2)];
      var $87$0 = ((($85$0)>>>0)+((($85$1)|0)*4294967296))+((($86$0)>>>0)+((($86$1)|0)*4294967296))>>>0; var $87$1 = Math.min(Math.floor((((($85$0)>>>0)+((($85$1)|0)*4294967296))+((($86$0)>>>0)+((($86$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$7$0=1;
      var $$emscripten$temp$7$1=0;
      var $88$0 = ((($87$0)>>>0)+((($87$1)|0)*4294967296))-((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296))>>>0; var $88$1 = Math.min(Math.floor((((($87$0)>>>0)+((($87$1)|0)*4294967296))-((($$emscripten$temp$7$0)>>>0)+((($$emscripten$temp$7$1)|0)*4294967296)))/4294967296), 4294967295);
      var $89$0=$88$0;
      var $89=$89$0;
      var $90=__ZNK13address_space15address_to_byteEj($84, $89);
      var $91=HEAP32[(($space)>>2)];
      var $92=__ZNK13address_space8bytemaskEv($91);
      var $93=$90 & $92;
      var $94$0=$93;
      var $94$1=0;
      var $st$21$0=(($endoffset)|0);
      HEAP32[(($st$21$0)>>2)]=$94$0;
      var $st$21$1=(($endoffset+4)|0);
      HEAP32[(($st$21$1)>>2)]=$94$1;
      var $95=HEAP32[(($space)>>2)];
      var $st$26$0=(($offset)|0);
      var $96$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($offset+4)|0);
      var $96$1=HEAP32[(($st$26$1)>>2)];
      var $97$0=$96$0;
      var $97=$97$0;
      var $98=__ZNK13address_space15address_to_byteEj($95, $97);
      var $99=HEAP32[(($space)>>2)];
      var $100=__ZNK13address_space8bytemaskEv($99);
      var $101=$98 & $100;
      var $102$0=$101;
      var $102$1=0;
      var $st$38$0=(($offset)|0);
      HEAP32[(($st$38$0)>>2)]=$102$0;
      var $st$38$1=(($offset+4)|0);
      HEAP32[(($st$38$1)>>2)]=$102$1;
      var $103=$4;
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=_fopen($105, ((STRING_TABLE.__str1185616)|0));
      $f=$106;
      var $107=$f;
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $109
      var $110=$1;
      var $111=$4;
      var $112=(($111)|0);
      var $113=HEAP32[(($112)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($110, ((STRING_TABLE.__str1325630)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$113,tempInt));
      __label__ = 54; break;
    case 24: // $114
      var $st$0$0=(($offset)|0);
      var $115$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($offset+4)|0);
      var $115$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($i)|0);
      HEAP32[(($st$4$0)>>2)]=$115$0;
      var $st$4$1=(($i+4)|0);
      HEAP32[(($st$4$1)>>2)]=$115$1;
      __label__ = 25; break;
    case 25: // $116
      var $st$0$0=(($i)|0);
      var $117$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $117$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($endoffset)|0);
      var $118$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($endoffset+4)|0);
      var $118$1=HEAP32[(($st$4$1)>>2)];
      var $119=$117$1 <= $118$1 && ($117$1 < $118$1 || $117$0 <= $118$0);
      if ($119) { __label__ = 26; break; } else { __label__ = 53; break; }
    case 26: // $120
      $outdex=0;
      var $121=$outdex;
      var $122=(($output+$121)|0);
      var $123=HEAP32[(($space)>>2)];
      var $st$4$0=(($i)|0);
      var $124$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($i+4)|0);
      var $124$1=HEAP32[(($st$4$1)>>2)];
      var $125$0=$124$0;
      var $125=$125$0;
      var $126=__ZNK13address_space15byte_to_addressEj($123, $125);
      var $127$0=$126;
      var $127$1=0;
      var $128=HEAP32[(($space)>>2)];
      var $129=__ZNK13address_space12logaddrcharsEv($128);
      var $130=__Z19core_i64_hex_formatyh($127$0, $127$1, $129);
      var $131=_sprintf($122, ((STRING_TABLE.__str1375635)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$130,tempInt));
      var $132=$outdex;
      var $133=(($132+$131)|0);
      $outdex=$133;
      var $$emscripten$temp$8$0=0;
      var $$emscripten$temp$8$1=0;
      var $st$22$0=(($j)|0);
      HEAP32[(($st$22$0)>>2)]=$$emscripten$temp$8$0;
      var $st$22$1=(($j+4)|0);
      HEAP32[(($st$22$1)>>2)]=$$emscripten$temp$8$1;
      __label__ = 27; break;
    case 27: // $134
      var $st$0$0=(($j)|0);
      var $135$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $135$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$9$0=16;
      var $$emscripten$temp$9$1=0;
      var $136=$135$1 < $$emscripten$temp$9$1 || ($135$1 == $$emscripten$temp$9$1 && $135$0 < $$emscripten$temp$9$0);
      if ($136) { __label__ = 28; break; } else { __label__ = 36; break; }
    case 28: // $137
      var $st$0$0=(($i)|0);
      var $138$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $138$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($j)|0);
      var $139$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($j+4)|0);
      var $139$1=HEAP32[(($st$4$1)>>2)];
      var $140$0 = ((($138$0)>>>0)+((($138$1)|0)*4294967296))+((($139$0)>>>0)+((($139$1)|0)*4294967296))>>>0; var $140$1 = Math.min(Math.floor((((($138$0)>>>0)+((($138$1)|0)*4294967296))+((($139$0)>>>0)+((($139$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($endoffset)|0);
      var $141$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($endoffset+4)|0);
      var $141$1=HEAP32[(($st$9$1)>>2)];
      var $142=$140$1 <= $141$1 && ($140$1 < $141$1 || $140$0 <= $141$0);
      if ($142) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $143
      var $st$0$0=(($i)|0);
      var $144$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $144$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($j)|0);
      var $145$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($j+4)|0);
      var $145$1=HEAP32[(($st$4$1)>>2)];
      var $146$0 = ((($144$0)>>>0)+((($144$1)|0)*4294967296))+((($145$0)>>>0)+((($145$1)|0)*4294967296))>>>0; var $146$1 = Math.min(Math.floor((((($144$0)>>>0)+((($144$1)|0)*4294967296))+((($145$0)>>>0)+((($145$1)|0)*4294967296)))/4294967296), 4294967295);
      var $147$0=$146$0;
      var $147=$147$0;
      HEAP32[(($curaddr)>>2)]=$147;
      var $148=HEAP32[(($space)>>2)];
      var $149=__Z19debug_cpu_translateP13address_spaceiPj($148, 8, $curaddr);
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $151
      var $152=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $153$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $153$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($j)|0);
      var $154$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($j+4)|0);
      var $154$1=HEAP32[(($st$5$1)>>2)];
      var $155$0 = ((($153$0)>>>0)+((($153$1)|0)*4294967296))+((($154$0)>>>0)+((($154$1)|0)*4294967296))>>>0; var $155$1 = Math.min(Math.floor((((($153$0)>>>0)+((($153$1)|0)*4294967296))+((($154$0)>>>0)+((($154$1)|0)*4294967296)))/4294967296), 4294967295);
      var $156$0=$155$0;
      var $156=$156$0;
      var $st$12$0=(($width)|0);
      var $157$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($width+4)|0);
      var $157$1=HEAP32[(($st$12$1)>>2)];
      var $158$0=$157$0;
      var $158=$158$0;
      var $159=__Z17debug_read_memoryP13address_spacejii($152, $156, $158, 1);
      var $159$0=$159[0];
      var $159$1=$159[1];
      var $st$21$0=(($value)|0);
      HEAP32[(($st$21$0)>>2)]=$159$0;
      var $st$21$1=(($value+4)|0);
      HEAP32[(($st$21$1)>>2)]=$159$1;
      var $160=$outdex;
      var $161=(($output+$160)|0);
      var $st$27$0=(($value)|0);
      var $162$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($value+4)|0);
      var $162$1=HEAP32[(($st$27$1)>>2)];
      var $st$31$0=(($width)|0);
      var $163$0=HEAP32[(($st$31$0)>>2)];
      var $st$31$1=(($width+4)|0);
      var $163$1=HEAP32[(($st$31$1)>>2)];
      var $$emscripten$temp$10$0=2;
      var $$emscripten$temp$10$1=0;
      var $164$0 = ((($163$0)>>>0)+((($163$1)|0)*4294967296))*((($$emscripten$temp$10$0)>>>0)+((($$emscripten$temp$10$1)|0)*4294967296))>>>0; var $164$1 = Math.min(Math.floor((((($163$0)>>>0)+((($163$1)|0)*4294967296))*((($$emscripten$temp$10$0)>>>0)+((($$emscripten$temp$10$1)|0)*4294967296)))/4294967296), 4294967295);
      var $165$0=$164$0;
      var $165=$165$0&255;
      var $166=__Z19core_i64_hex_formatyh($162$0, $162$1, $165);
      var $167=_sprintf($161, ((STRING_TABLE.__str1895687)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$166,tempInt));
      var $168=$outdex;
      var $169=(($168+$167)|0);
      $outdex=$169;
      __label__ = 32; break;
    case 31: // $170
      var $171=$outdex;
      var $172=(($output+$171)|0);
      var $st$2$0=(($width)|0);
      var $173$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($width+4)|0);
      var $173$1=HEAP32[(($st$2$1)>>2)];
      var $174$0=$173$0;
      var $174=$174$0;
      var $175=((($174<<1))|0);
      var $176=_sprintf($172, ((STRING_TABLE.__str1905688)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$175,HEAP32[((tempInt+4)>>2)]=((STRING_TABLE.__str1915689)|0),tempInt));
      var $177=$outdex;
      var $178=(($177+$176)|0);
      $outdex=$178;
      __label__ = 32; break;
    case 32: // $179
      __label__ = 34; break;
    case 33: // $180
      var $181=$outdex;
      var $182=(($output+$181)|0);
      var $st$2$0=(($width)|0);
      var $183$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($width+4)|0);
      var $183$1=HEAP32[(($st$2$1)>>2)];
      var $184$0=$183$0;
      var $184=$184$0;
      var $185=((($184<<1))|0);
      var $186=_sprintf($182, ((STRING_TABLE.__str1925690)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,HEAP32[((tempInt+4)>>2)]=((__str985596)|0),tempInt));
      var $187=$outdex;
      var $188=(($187+$186)|0);
      $outdex=$188;
      __label__ = 34; break;
    case 34: // $189
      __label__ = 35; break;
    case 35: // $190
      var $st$0$0=(($width)|0);
      var $191$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($width+4)|0);
      var $191$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($j)|0);
      var $192$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($j+4)|0);
      var $192$1=HEAP32[(($st$4$1)>>2)];
      var $193$0 = ((($192$0)>>>0)+((($192$1)|0)*4294967296))+((($191$0)>>>0)+((($191$1)|0)*4294967296))>>>0; var $193$1 = Math.min(Math.floor((((($192$0)>>>0)+((($192$1)|0)*4294967296))+((($191$0)>>>0)+((($191$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($j)|0);
      HEAP32[(($st$9$0)>>2)]=$193$0;
      var $st$9$1=(($j+4)|0);
      HEAP32[(($st$9$1)>>2)]=$193$1;
      __label__ = 27; break;
    case 36: // $194
      var $st$0$0=(($ascii)|0);
      var $195$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($ascii+4)|0);
      var $195$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$11$0=0;
      var $$emscripten$temp$11$1=0;
      var $196=$195$0 != $$emscripten$temp$11$0 || $195$1 != $$emscripten$temp$11$1;
      if ($196) { __label__ = 37; break; } else { __label__ = 51; break; }
    case 37: // $197
      var $198=$outdex;
      var $199=(($output+$198)|0);
      var $200=_sprintf($199, ((STRING_TABLE.__str1405638)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $201=$outdex;
      var $202=(($201+$200)|0);
      $outdex=$202;
      var $$emscripten$temp$12$0=0;
      var $$emscripten$temp$12$1=0;
      var $st$8$0=(($j)|0);
      HEAP32[(($st$8$0)>>2)]=$$emscripten$temp$12$0;
      var $st$8$1=(($j+4)|0);
      HEAP32[(($st$8$1)>>2)]=$$emscripten$temp$12$1;
      __label__ = 38; break;
    case 38: // $203
      var $st$0$0=(($j)|0);
      var $204$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $204$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$13$0=16;
      var $$emscripten$temp$13$1=0;
      var $205=$204$1 < $$emscripten$temp$13$1 || ($204$1 == $$emscripten$temp$13$1 && $204$0 < $$emscripten$temp$13$0);
      if ($205) { __label__ = 39; break; } else { var $213 = 0;__label__ = 40; break; }
    case 39: // $206
      var $st$0$0=(($i)|0);
      var $207$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $207$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($j)|0);
      var $208$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($j+4)|0);
      var $208$1=HEAP32[(($st$4$1)>>2)];
      var $209$0 = ((($207$0)>>>0)+((($207$1)|0)*4294967296))+((($208$0)>>>0)+((($208$1)|0)*4294967296))>>>0; var $209$1 = Math.min(Math.floor((((($207$0)>>>0)+((($207$1)|0)*4294967296))+((($208$0)>>>0)+((($208$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($endoffset)|0);
      var $210$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($endoffset+4)|0);
      var $210$1=HEAP32[(($st$9$1)>>2)];
      var $211=$209$1 <= $210$1 && ($209$1 < $210$1 || $209$0 <= $210$0);
      var $213 = $211;__label__ = 40; break;
    case 40: // $212
      var $213;
      if ($213) { __label__ = 41; break; } else { __label__ = 50; break; }
    case 41: // $214
      var $st$0$0=(($i)|0);
      var $215$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $215$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($j)|0);
      var $216$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($j+4)|0);
      var $216$1=HEAP32[(($st$4$1)>>2)];
      var $217$0 = ((($215$0)>>>0)+((($215$1)|0)*4294967296))+((($216$0)>>>0)+((($216$1)|0)*4294967296))>>>0; var $217$1 = Math.min(Math.floor((((($215$0)>>>0)+((($215$1)|0)*4294967296))+((($216$0)>>>0)+((($216$1)|0)*4294967296)))/4294967296), 4294967295);
      var $218$0=$217$0;
      var $218=$218$0;
      HEAP32[(($curaddr1)>>2)]=$218;
      var $219=HEAP32[(($space)>>2)];
      var $220=__Z19debug_cpu_translateP13address_spaceiPj($219, 8, $curaddr1);
      var $221=(($220)|0)!=0;
      if ($221) { __label__ = 42; break; } else { __label__ = 47; break; }
    case 42: // $222
      var $223=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $224$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $224$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($j)|0);
      var $225$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($j+4)|0);
      var $225$1=HEAP32[(($st$5$1)>>2)];
      var $226$0 = ((($224$0)>>>0)+((($224$1)|0)*4294967296))+((($225$0)>>>0)+((($225$1)|0)*4294967296))>>>0; var $226$1 = Math.min(Math.floor((((($224$0)>>>0)+((($224$1)|0)*4294967296))+((($225$0)>>>0)+((($225$1)|0)*4294967296)))/4294967296), 4294967295);
      var $227$0=$226$0;
      var $227=$227$0;
      var $228=__Z15debug_read_byteP13address_spaceji($223, $227, 1);
      $byte=$228;
      var $229=$outdex;
      var $230=(($output+$229)|0);
      var $231=$byte;
      var $232=(($231)&255);
      var $233=(($232)|0) >= 32;
      if ($233) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $234
      var $235=$byte;
      var $236=(($235)&255);
      var $237=(($236)|0) < 127;
      if ($237) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $238
      var $239=$byte;
      var $240=(($239)&255);
      var $243 = $240;__label__ = 46; break;
    case 45: // $241
      var $243 = 46;__label__ = 46; break;
    case 46: // $242
      var $243;
      var $244=_sprintf($230, ((STRING_TABLE.__str1935691)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$243,tempInt));
      var $245=$outdex;
      var $246=(($245+$244)|0);
      $outdex=$246;
      __label__ = 48; break;
    case 47: // $247
      var $248=$outdex;
      var $249=(($output+$248)|0);
      var $250=_sprintf($249, ((STRING_TABLE.__str1945692)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $251=$outdex;
      var $252=(($251+$250)|0);
      $outdex=$252;
      __label__ = 48; break;
    case 48: // $253
      __label__ = 49; break;
    case 49: // $254
      var $st$0$0=(($j)|0);
      var $255$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $255$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$14$0=1;
      var $$emscripten$temp$14$1=0;
      var $256$0 = ((($255$0)>>>0)+((($255$1)|0)*4294967296))+((($$emscripten$temp$14$0)>>>0)+((($$emscripten$temp$14$1)|0)*4294967296))>>>0; var $256$1 = Math.min(Math.floor((((($255$0)>>>0)+((($255$1)|0)*4294967296))+((($$emscripten$temp$14$0)>>>0)+((($$emscripten$temp$14$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($j)|0);
      HEAP32[(($st$7$0)>>2)]=$256$0;
      var $st$7$1=(($j+4)|0);
      HEAP32[(($st$7$1)>>2)]=$256$1;
      __label__ = 38; break;
    case 50: // $257
      __label__ = 51; break;
    case 51: // $258
      var $259=$f;
      var $260=(($output)|0);
      var $261=_fprintf($259, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$260,tempInt));
      __label__ = 52; break;
    case 52: // $262
      var $st$0$0=(($i)|0);
      var $263$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $263$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$15$0=16;
      var $$emscripten$temp$15$1=0;
      var $264$0 = ((($263$0)>>>0)+((($263$1)|0)*4294967296))+((($$emscripten$temp$15$0)>>>0)+((($$emscripten$temp$15$1)|0)*4294967296))>>>0; var $264$1 = Math.min(Math.floor((((($263$0)>>>0)+((($263$1)|0)*4294967296))+((($$emscripten$temp$15$0)>>>0)+((($$emscripten$temp$15$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($i)|0);
      HEAP32[(($st$7$0)>>2)]=$264$0;
      var $st$7$1=(($i+4)|0);
      HEAP32[(($st$7$1)>>2)]=$264$1;
      __label__ = 25; break;
    case 53: // $265
      var $266=$f;
      var $267=_fclose($266);
      var $268=$1;
      __Z20debug_console_printfR15running_machinePKcz($268, ((STRING_TABLE.__str1445642)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 54; break;
    case 54: // $269
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12execute_dumpR15running_machineiiPPKc["X"]=1;

function __ZL17execute_cheatinitR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 2484; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i1=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $12;
      var $13;
      var $14;
      var $offset=__stackBase__+48;
      var $length=__stackBase__+56;
      var $real_length=__stackBase__+64;
      var $space=__stackBase__+72;
      var $active_cheat;
      var $curaddr=__stackBase__+76;
      var $i;
      var $region_count;
      var $entry;
      var $cheat_region=__stackBase__+84;
      var $srtpnt;
      var $newmap;
      var $item;
      $11=$machine;
      $12=$ref;
      $13=$params;
      $14=$param;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$35$0=(($length)|0);
      HEAP32[(($st$35$0)>>2)]=$$emscripten$temp$0$0;
      var $st$35$1=(($length+4)|0);
      HEAP32[(($st$35$1)>>2)]=$$emscripten$temp$0$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$41$0=(($real_length)|0);
      HEAP32[(($st$41$0)>>2)]=$$emscripten$temp$1$0;
      var $st$41$1=(($real_length+4)|0);
      HEAP32[(($st$41$1)>>2)]=$$emscripten$temp$1$1;
      $active_cheat=0;
      $region_count=0;
      var $15=(($cheat_region)|0);
      var $16=$15;
      _memset($16, 0, 2400, 1);
      var $17=$11;
      var $18=$13;
      var $19=(($18)|0) > 3;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$14;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $26 = $23;__label__ = 3; break;
    case 2: // $24
      var $26 = 0;__label__ = 3; break;
    case 3: // $25
      var $26;
      var $27=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($17, $26, 0, $space);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $29
      __label__ = 108; break;
    case 5: // $30
      var $31=$12;
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 6; break; } else { __label__ = 30; break; }
    case 6: // $33
      HEAP8[(((__ZL5cheat+12)|0))]=1;
      HEAP8[(((__ZL5cheat+21)|0))]=0;
      HEAP8[(((__ZL5cheat+22)|0))]=0;
      var $34=$13;
      var $35=(($34)|0) > 0;
      if ($35) { __label__ = 7; break; } else { __label__ = 29; break; }
    case 7: // $36
      var $37=$14;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      $srtpnt=$39;
      var $40=$srtpnt;
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $43=(($42)|0)==115;
      if ($43) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $44
      HEAP8[(((__ZL5cheat+21)|0))]=1;
      __label__ = 13; break;
    case 9: // $45
      var $46=$srtpnt;
      var $47=HEAP8[($46)];
      var $48=(($47 << 24) >> 24);
      var $49=(($48)|0)==117;
      if ($49) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $50
      HEAP8[(((__ZL5cheat+21)|0))]=0;
      __label__ = 12; break;
    case 11: // $51
      var $52=$11;
      __Z20debug_console_printfR15running_machinePKcz($52, ((STRING_TABLE.__str1825680)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 108; break;
    case 12: // $53
      __label__ = 13; break;
    case 13: // $54
      var $55=$srtpnt;
      var $56=(($55+1)|0);
      $srtpnt=$56;
      var $57=HEAP8[($56)];
      var $58=(($57 << 24) >> 24);
      var $59=(($58)|0)==98;
      if ($59) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $60
      HEAP8[(((__ZL5cheat+12)|0))]=1;
      __label__ = 25; break;
    case 15: // $61
      var $62=$srtpnt;
      var $63=HEAP8[($62)];
      var $64=(($63 << 24) >> 24);
      var $65=(($64)|0)==119;
      if ($65) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $66
      HEAP8[(((__ZL5cheat+12)|0))]=2;
      __label__ = 24; break;
    case 17: // $67
      var $68=$srtpnt;
      var $69=HEAP8[($68)];
      var $70=(($69 << 24) >> 24);
      var $71=(($70)|0)==100;
      if ($71) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $72
      HEAP8[(((__ZL5cheat+12)|0))]=4;
      __label__ = 23; break;
    case 19: // $73
      var $74=$srtpnt;
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24);
      var $77=(($76)|0)==113;
      if ($77) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $78
      HEAP8[(((__ZL5cheat+12)|0))]=8;
      __label__ = 22; break;
    case 21: // $79
      var $80=$11;
      __Z20debug_console_printfR15running_machinePKcz($80, ((STRING_TABLE.__str1835681)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 108; break;
    case 22: // $81
      __label__ = 23; break;
    case 23: // $82
      __label__ = 24; break;
    case 24: // $83
      __label__ = 25; break;
    case 25: // $84
      var $85=$srtpnt;
      var $86=(($85+1)|0);
      $srtpnt=$86;
      var $87=HEAP8[($86)];
      var $88=(($87 << 24) >> 24);
      var $89=(($88)|0)==115;
      if ($89) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $90
      HEAP8[(((__ZL5cheat+22)|0))]=1;
      __label__ = 28; break;
    case 27: // $91
      HEAP8[(((__ZL5cheat+22)|0))]=0;
      __label__ = 28; break;
    case 28: // $92
      __label__ = 29; break;
    case 29: // $93
      __label__ = 30; break;
    case 30: // $94
      var $95=$13;
      var $96=(($95)|0) <= 1;
      if ($96) { __label__ = 31; break; } else { __label__ = 46; break; }
    case 31: // $97
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $st$2$0=(($offset)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$2$0;
      var $st$2$1=(($offset+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$2$1;
      var $98=HEAP32[(($space)>>2)];
      var $99=__ZNK13address_space8bytemaskEv($98);
      var $100=(($99+1)|0);
      var $101$0=$100;
      var $101$1=0;
      var $st$11$0=(($length)|0);
      HEAP32[(($st$11$0)>>2)]=$101$0;
      var $st$11$1=(($length+4)|0);
      HEAP32[(($st$11$1)>>2)]=$101$1;
      var $102=HEAP32[(($space)>>2)];
      var $103=__ZNK13address_space3mapEv($102);
      var $104=(($103+12)|0);
      var $105=__ZNK11simple_listI17address_map_entryE5firstEv($104);
      $entry=$105;
      __label__ = 32; break;
    case 32: // $106
      var $107=$entry;
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 33; break; } else { __label__ = 45; break; }
    case 33: // $109
      var $110=HEAP32[(($space)>>2)];
      var $111=$entry;
      var $112=(($111+72)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=__ZNK13address_space15address_to_byteEj($110, $113);
      var $115=HEAP32[(($space)>>2)];
      var $116=__ZNK13address_space8bytemaskEv($115);
      var $117=$114 & $116;
      var $118$0=$117;
      var $118$1=0;
      var $119=$region_count;
      var $120=(($119)&255);
      var $121=(($cheat_region+$120*24)|0);
      var $122=(($121)|0);
      var $st$14$0=(($122)|0);
      HEAP32[(($st$14$0)>>2)]=$118$0;
      var $st$14$1=(($122+4)|0);
      HEAP32[(($st$14$1)>>2)]=$118$1;
      var $123=HEAP32[(($space)>>2)];
      var $124=$entry;
      var $125=(($124+76)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=__ZNK13address_space15address_to_byteEj($123, $126);
      var $128=HEAP32[(($space)>>2)];
      var $129=__ZNK13address_space8bytemaskEv($128);
      var $130=$127 & $129;
      var $131$0=$130;
      var $131$1=0;
      var $132=$region_count;
      var $133=(($132)&255);
      var $134=(($cheat_region+$133*24)|0);
      var $135=(($134+8)|0);
      var $st$32$0=(($135)|0);
      HEAP32[(($st$32$0)>>2)]=$131$0;
      var $st$32$1=(($135+4)|0);
      HEAP32[(($st$32$1)>>2)]=$131$1;
      var $136=$entry;
      var $137=(($136+264)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$region_count;
      var $140=(($139)&255);
      var $141=(($cheat_region+$140*24)|0);
      var $142=(($141+16)|0);
      HEAP32[(($142)>>2)]=$138;
      var $143=$entry;
      var $144=(($143+176)|0);
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($146)|0)==1;
      var $148=$147 ? 0 : 1;
      var $149=(($148) & 255);
      var $150=$region_count;
      var $151=(($150)&255);
      var $152=(($cheat_region+$151*24)|0);
      var $153=(($152+20)|0);
      HEAP8[($153)]=$149;
      var $154=$entry;
      var $155=(($154+264)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($156)|0)!=0;
      if ($157) { __label__ = 34; break; } else { __label__ = 43; break; }
    case 34: // $158
      $i=0;
      __label__ = 35; break;
    case 35: // $159
      var $160=$i;
      var $161=(($160)&255);
      var $162=$region_count;
      var $163=(($162)&255);
      var $164=(($161)|0) < (($163)|0);
      if ($164) { __label__ = 36; break; } else { __label__ = 42; break; }
    case 36: // $165
      var $166=$i;
      var $167=(($166)&255);
      var $168=(($cheat_region+$167*24)|0);
      var $169=(($168+16)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $172
      var $173=$i;
      var $174=(($173)&255);
      var $175=(($cheat_region+$174*24)|0);
      var $176=(($175+16)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$entry;
      var $179=(($178+264)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=_strcmp($177, $180);
      var $182=(($181)|0)==0;
      if ($182) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $183
      var $184=$region_count;
      var $185=(($184)&255);
      var $186=(($cheat_region+$185*24)|0);
      var $187=(($186+20)|0);
      HEAP8[($187)]=1;
      __label__ = 39; break;
    case 39: // $188
      __label__ = 40; break;
    case 40: // $189
      __label__ = 41; break;
    case 41: // $190
      var $191=$i;
      var $192=(($191+1)&255);
      $i=$192;
      __label__ = 35; break;
    case 42: // $193
      __label__ = 43; break;
    case 43: // $194
      var $195=$region_count;
      var $196=(($195+1)&255);
      $region_count=$196;
      __label__ = 44; break;
    case 44: // $197
      var $198=$entry;
      var $199=__ZNK17address_map_entry4nextEv($198);
      $entry=$199;
      __label__ = 32; break;
    case 45: // $200
      __label__ = 51; break;
    case 46: // $201
      var $202=$11;
      var $203=$12;
      var $204=(($203)|0)==0;
      var $205=$204 ? 1 : 0;
      var $206=$14;
      var $207=(($206+($205<<2))|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=__Z30debug_command_parameter_numberR15running_machinePKcPy($202, $208, $offset);
      var $210=(($209)|0)!=0;
      if ($210) { __label__ = 48; break; } else { __label__ = 47; break; }
    case 47: // $211
      __label__ = 108; break;
    case 48: // $212
      var $213=$11;
      var $214=$12;
      var $215=(($214)|0)==0;
      var $216=$215 ? 2 : 1;
      var $217=$14;
      var $218=(($217+($216<<2))|0);
      var $219=HEAP32[(($218)>>2)];
      var $220=__Z30debug_command_parameter_numberR15running_machinePKcPy($213, $219, $length);
      var $221=(($220)|0)!=0;
      if ($221) { __label__ = 50; break; } else { __label__ = 49; break; }
    case 49: // $222
      __label__ = 108; break;
    case 50: // $223
      var $224=HEAP32[(($space)>>2)];
      var $st$1$0=(($offset)|0);
      var $225$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $225$1=HEAP32[(($st$1$1)>>2)];
      var $226$0=$225$0;
      var $226=$226$0;
      var $227=__ZNK13address_space15address_to_byteEj($224, $226);
      var $228=HEAP32[(($space)>>2)];
      var $229=__ZNK13address_space8bytemaskEv($228);
      var $230=$227 & $229;
      var $231$0=$230;
      var $231$1=0;
      var $232=$region_count;
      var $233=(($232)&255);
      var $234=(($cheat_region+$233*24)|0);
      var $235=(($234)|0);
      var $st$17$0=(($235)|0);
      HEAP32[(($st$17$0)>>2)]=$231$0;
      var $st$17$1=(($235+4)|0);
      HEAP32[(($st$17$1)>>2)]=$231$1;
      var $236=HEAP32[(($space)>>2)];
      var $st$22$0=(($offset)|0);
      var $237$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($offset+4)|0);
      var $237$1=HEAP32[(($st$22$1)>>2)];
      var $st$26$0=(($length)|0);
      var $238$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($length+4)|0);
      var $238$1=HEAP32[(($st$26$1)>>2)];
      var $239$0 = ((($237$0)>>>0)+((($237$1)|0)*4294967296))+((($238$0)>>>0)+((($238$1)|0)*4294967296))>>>0; var $239$1 = Math.min(Math.floor((((($237$0)>>>0)+((($237$1)|0)*4294967296))+((($238$0)>>>0)+((($238$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $240$0 = ((($239$0)>>>0)+((($239$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $240$1 = Math.min(Math.floor((((($239$0)>>>0)+((($239$1)|0)*4294967296))-((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $241$0=$240$0;
      var $241=$241$0;
      var $242=__ZNK13address_space15address_to_byteEj($236, $241);
      var $243=HEAP32[(($space)>>2)];
      var $244=__ZNK13address_space8bytemaskEv($243);
      var $245=$242 & $244;
      var $246$0=$245;
      var $246$1=0;
      var $247=$region_count;
      var $248=(($247)&255);
      var $249=(($cheat_region+$248*24)|0);
      var $250=(($249+8)|0);
      var $st$46$0=(($250)|0);
      HEAP32[(($st$46$0)>>2)]=$246$0;
      var $st$46$1=(($250+4)|0);
      HEAP32[(($st$46$1)>>2)]=$246$1;
      var $251=$region_count;
      var $252=(($251)&255);
      var $253=(($cheat_region+$252*24)|0);
      var $254=(($253+16)|0);
      HEAP32[(($254)>>2)]=0;
      var $255=$region_count;
      var $256=(($255)&255);
      var $257=(($cheat_region+$256*24)|0);
      var $258=(($257+20)|0);
      HEAP8[($258)]=0;
      var $259=$region_count;
      var $260=(($259+1)&255);
      $region_count=$260;
      __label__ = 51; break;
    case 51: // $261
      $i=0;
      __label__ = 52; break;
    case 52: // $262
      var $263=$i;
      var $264=(($263)&255);
      var $265=$region_count;
      var $266=(($265)&255);
      var $267=(($264)|0) <= (($266)|0);
      if ($267) { __label__ = 53; break; } else { __label__ = 63; break; }
    case 53: // $268
      var $269=$i;
      var $270=(($269)&255);
      var $271=(($cheat_region+$270*24)|0);
      var $272=(($271+20)|0);
      var $273=HEAP8[($272)];
      var $274=(($273 << 24) >> 24)!=0;
      if ($274) { __label__ = 61; break; } else { __label__ = 54; break; }
    case 54: // $275
      var $276=$i;
      var $277=(($276)&255);
      var $278=(($cheat_region+$277*24)|0);
      var $279=(($278)|0);
      var $st$4$0=(($279)|0);
      var $280$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($279+4)|0);
      var $280$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($curaddr)|0);
      HEAP32[(($st$8$0)>>2)]=$280$0;
      var $st$8$1=(($curaddr+4)|0);
      HEAP32[(($st$8$1)>>2)]=$280$1;
      __label__ = 55; break;
    case 55: // $281
      var $st$0$0=(($curaddr)|0);
      var $282$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($curaddr+4)|0);
      var $282$1=HEAP32[(($st$0$1)>>2)];
      var $283=$i;
      var $284=(($283)&255);
      var $285=(($cheat_region+$284*24)|0);
      var $286=(($285+8)|0);
      var $st$8$0=(($286)|0);
      var $287$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($286+4)|0);
      var $287$1=HEAP32[(($st$8$1)>>2)];
      var $288=$282$1 <= $287$1 && ($282$1 < $287$1 || $282$0 <= $287$0);
      if ($288) { __label__ = 56; break; } else { __label__ = 60; break; }
    case 56: // $289
      var $290=HEAP32[(($space)>>2)];
      var $st$1$0=(($curaddr)|0);
      var $291$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curaddr+4)|0);
      var $291$1=HEAP32[(($st$1$1)>>2)];
      var $292$0=$291$0;
      var $292=$292$0;
      var $293=__ZL22cheat_address_is_validP13address_spacej($290, $292);
      var $294=(($293)|0)!=0;
      if ($294) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $295
      var $st$0$0=(($real_length)|0);
      var $296$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($real_length+4)|0);
      var $296$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$4$0=1;
      var $$emscripten$temp$4$1=0;
      var $297$0 = ((($296$0)>>>0)+((($296$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $297$1 = Math.min(Math.floor((((($296$0)>>>0)+((($296$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($real_length)|0);
      HEAP32[(($st$7$0)>>2)]=$297$0;
      var $st$7$1=(($real_length+4)|0);
      HEAP32[(($st$7$1)>>2)]=$297$1;
      __label__ = 58; break;
    case 58: // $298
      __label__ = 59; break;
    case 59: // $299
      var $300=HEAP8[(((__ZL5cheat+12)|0))];
      var $301$0=$300;
      var $301$1=0;
      var $st$3$0=(($curaddr)|0);
      var $302$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($curaddr+4)|0);
      var $302$1=HEAP32[(($st$3$1)>>2)];
      var $303$0 = ((($302$0)>>>0)+((($302$1)|0)*4294967296))+((($301$0)>>>0)+((($301$1)|0)*4294967296))>>>0; var $303$1 = Math.min(Math.floor((((($302$0)>>>0)+((($302$1)|0)*4294967296))+((($301$0)>>>0)+((($301$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($curaddr)|0);
      HEAP32[(($st$8$0)>>2)]=$303$0;
      var $st$8$1=(($curaddr+4)|0);
      HEAP32[(($st$8$1)>>2)]=$303$1;
      __label__ = 55; break;
    case 60: // $304
      __label__ = 61; break;
    case 61: // $305
      __label__ = 62; break;
    case 62: // $306
      var $307=$i;
      var $308=(($307+1)&255);
      $i=$308;
      __label__ = 52; break;
    case 63: // $309
      var $st$0$0=(($real_length)|0);
      var $310$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($real_length+4)|0);
      var $310$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $311=$310$0 == $$emscripten$temp$5$0 && $310$1 == $$emscripten$temp$5$1;
      if ($311) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $312
      var $313=$11;
      __Z20debug_console_printfR15running_machinePKcz($313, ((STRING_TABLE.__str1845682)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 108; break;
    case 65: // $314
      var $315=$12;
      var $316=(($315)|0)==0;
      if ($316) { __label__ = 66; break; } else { __label__ = 79; break; }
    case 66: // $317
      var $318=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $319=(($318)|0)!=0;
      if ($319) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $320
      var $321=$11;
      var $322=__ZN15running_machine7respoolEv($321);
      var $323=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $324=$323;
      __ZN13resource_pool6removeEPv($322, $324);
      __label__ = 68; break;
    case 68: // $325
      var $326=$11;
      var $327=__ZN15running_machine7respoolEv($326);
      var $st$2$0=(($real_length)|0);
      var $328$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($real_length+4)|0);
      var $328$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=1;
      var $329=$328$1 >= $$emscripten$temp$6$1 && ($328$1 > $$emscripten$temp$6$1 || $328$0 >= $$emscripten$temp$6$0);
      var $330$0=$328$0;
      var $330=$330$0;
      var $331=_llvm_umul_with_overflow_i32($330, 28);
      var $332=$331.f1;
      var $333=$329 | $332;
      var $334=$331.f0;
      var $335=$333 ? -1 : $334;
      var $336=$6;
      var $337=$7;
      var $338=$8;
      var $339=$result_i;
      var $340=$9;
      var $341=$10;
      HEAP32[(($6)>>2)]=$335;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str1855683)|0);
      HEAP32[(($8)>>2)]=1826;
      var $342=HEAP32[(($6)>>2)];
      var $343=HEAP32[(($7)>>2)];
      var $344=HEAP32[(($8)>>2)];
      var $345=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($342, $343, $344) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 71; break; };
    case 69: // $346
      HEAP32[(($result_i)>>2)]=$345;
      var $347=HEAP32[(($result_i)>>2)];
      var $348=(($347)|0)==0;
      if ($348) { __label__ = 70; break; } else { __label__ = 75; break; }
    case 70: // $349
      var $350=___cxa_allocate_exception(4);
      var $351=$350;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($351);
      (function() { try { __THREW__ = false; return ___cxa_throw($350, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 71; break; }
    case 71: // $352
      var $353=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $354=$353.f0;
      HEAP32[(($9)>>2)]=$354;
      var $355=$353.f1;
      HEAP32[(($10)>>2)]=$355;
      var $356=HEAP32[(($10)>>2)];
      var $357=(($356)|0) < 0;
      if ($357) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $358
      var $359=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($359);
      throw "Reached an unreachable!"
    case 73: // $360
      var $361=HEAP32[(($9)>>2)];
      var $362=HEAP32[(($9)>>2)];
      var $363=HEAP32[(($10)>>2)];
      var $364=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $362, tempValue);
      var $365=($364.f1 = $363, $364);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 74: // $366
      throw "Reached an unreachable!"
    case 75: // $_ZnajPKci_exit
      var $367=HEAP32[(($result_i)>>2)];
      var $368=$6;
      var $369=$7;
      var $370=$8;
      var $371=$result_i;
      var $372=$9;
      var $373=$10;
      var $374=$367;
      var $st$8$0=(($real_length)|0);
      var $375$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($real_length+4)|0);
      var $375$1=HEAP32[(($st$8$1)>>2)];
      var $376$0=$375$0;
      var $376=$376$0;
      var $377=__ZN13resource_pool9add_arrayI10_cheat_mapEEPT_S3_i($327, $374, $376);
      HEAP32[((((__ZL5cheat+16)|0))>>2)]=$377;
      var $st$16$0=(($real_length)|0);
      var $378$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($real_length+4)|0);
      var $378$1=HEAP32[(($st$16$1)>>2)];
      var $$emscripten$temp$7=((__ZL5cheat+4)|0);
      var $st$21$0=(($$emscripten$temp$7)|0);
      HEAP32[(($st$21$0)>>2)]=$378$0;
      var $st$21$1=(($$emscripten$temp$7+4)|0);
      HEAP32[(($st$21$1)>>2)]=$378$1;
      HEAP8[(((__ZL5cheat+20)|0))]=0;
      var $379=$13;
      var $380=(($379)|0) > 3;
      if ($380) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $381
      var $382=$14;
      var $383=(($382+12)|0);
      var $384=HEAP32[(($383)>>2)];
      var $385=HEAP8[($384)];
      var $388 = $385;__label__ = 78; break;
    case 77: // $386
      var $388 = 48;__label__ = 78; break;
    case 78: // $387
      var $388;
      HEAP8[(((__ZL5cheat)|0))]=$388;
      __label__ = 95; break;
    case 79: // $389
      var $390=HEAP8[(((__ZL5cheat)|0))];
      var $391=(($390 << 24) >> 24);
      var $392=(($391)|0)==0;
      if ($392) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $393
      var $394=$11;
      __Z20debug_console_printfR15running_machinePKcz($394, ((STRING_TABLE.__str1865684)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 108; break;
    case 81: // $395
      var $396=$11;
      var $397=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($396, ((__ZL5cheat)|0), 0, $space);
      var $398=(($397)|0)!=0;
      if ($398) { __label__ = 83; break; } else { __label__ = 82; break; }
    case 82: // $399
      __label__ = 108; break;
    case 83: // $400
      var $401=$11;
      var $402=__ZN15running_machine7respoolEv($401);
      var $$emscripten$temp$8=((__ZL5cheat+4)|0);
      var $st$3$0=(($$emscripten$temp$8)|0);
      var $403$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($$emscripten$temp$8+4)|0);
      var $403$1=HEAP32[(($st$3$1)>>2)];
      var $st$7$0=(($real_length)|0);
      var $404$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($real_length+4)|0);
      var $404$1=HEAP32[(($st$7$1)>>2)];
      var $405$0 = ((($403$0)>>>0)+((($403$1)|0)*4294967296))+((($404$0)>>>0)+((($404$1)|0)*4294967296))>>>0; var $405$1 = Math.min(Math.floor((((($403$0)>>>0)+((($403$1)|0)*4294967296))+((($404$0)>>>0)+((($404$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$9$0=0;
      var $$emscripten$temp$9$1=1;
      var $406=$405$1 >= $$emscripten$temp$9$1 && ($405$1 > $$emscripten$temp$9$1 || $405$0 >= $$emscripten$temp$9$0);
      var $407$0=$405$0;
      var $407=$407$0;
      var $408=_llvm_umul_with_overflow_i32($407, 28);
      var $409=$408.f1;
      var $410=$406 | $409;
      var $411=$408.f0;
      var $412=$410 ? -1 : $411;
      var $413=$1;
      var $414=$2;
      var $415=$3;
      var $416=$result_i1;
      var $417=$4;
      var $418=$5;
      HEAP32[(($1)>>2)]=$412;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1855683)|0);
      HEAP32[(($3)>>2)]=1844;
      var $419=HEAP32[(($1)>>2)];
      var $420=HEAP32[(($2)>>2)];
      var $421=HEAP32[(($3)>>2)];
      var $422=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($419, $420, $421) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 86; break; };
    case 84: // $423
      HEAP32[(($result_i1)>>2)]=$422;
      var $424=HEAP32[(($result_i1)>>2)];
      var $425=(($424)|0)==0;
      if ($425) { __label__ = 85; break; } else { __label__ = 90; break; }
    case 85: // $426
      var $427=___cxa_allocate_exception(4);
      var $428=$427;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($428);
      (function() { try { __THREW__ = false; return ___cxa_throw($427, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 86; break; }
    case 86: // $429
      var $430=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $431=$430.f0;
      HEAP32[(($4)>>2)]=$431;
      var $432=$430.f1;
      HEAP32[(($5)>>2)]=$432;
      var $433=HEAP32[(($5)>>2)];
      var $434=(($433)|0) < 0;
      if ($434) { __label__ = 87; break; } else { __label__ = 88; break; }
    case 87: // $435
      var $436=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($436);
      throw "Reached an unreachable!"
    case 88: // $437
      var $438=HEAP32[(($4)>>2)];
      var $439=HEAP32[(($4)>>2)];
      var $440=HEAP32[(($5)>>2)];
      var $441=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $439, tempValue);
      var $442=($441.f1 = $440, $441);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 89: // $443
      throw "Reached an unreachable!"
    case 90: // $_ZnajPKci_exit2
      var $444=HEAP32[(($result_i1)>>2)];
      var $445=$1;
      var $446=$2;
      var $447=$3;
      var $448=$result_i1;
      var $449=$4;
      var $450=$5;
      var $451=$444;
      var $$emscripten$temp$10=((__ZL5cheat+4)|0);
      var $st$9$0=(($$emscripten$temp$10)|0);
      var $452$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($$emscripten$temp$10+4)|0);
      var $452$1=HEAP32[(($st$9$1)>>2)];
      var $st$13$0=(($real_length)|0);
      var $453$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($real_length+4)|0);
      var $453$1=HEAP32[(($st$13$1)>>2)];
      var $454$0 = ((($452$0)>>>0)+((($452$1)|0)*4294967296))+((($453$0)>>>0)+((($453$1)|0)*4294967296))>>>0; var $454$1 = Math.min(Math.floor((((($452$0)>>>0)+((($452$1)|0)*4294967296))+((($453$0)>>>0)+((($453$1)|0)*4294967296)))/4294967296), 4294967295);
      var $455$0=$454$0;
      var $455=$455$0;
      var $456=__ZN13resource_pool9add_arrayI10_cheat_mapEEPT_S3_i($402, $451, $455);
      $newmap=$456;
      $item=0;
      __label__ = 91; break;
    case 91: // $457
      var $458=$item;
      var $459$0=$458;
      var $459$1=(($458|0) < 0 ? -1 : 0);
      var $$emscripten$temp$11=((__ZL5cheat+4)|0);
      var $st$4$0=(($$emscripten$temp$11)|0);
      var $460$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($$emscripten$temp$11+4)|0);
      var $460$1=HEAP32[(($st$4$1)>>2)];
      var $461=$459$1 < $460$1 || ($459$1 == $460$1 && $459$0 < $460$0);
      if ($461) { __label__ = 92; break; } else { __label__ = 94; break; }
    case 92: // $462
      var $463=$item;
      var $464=$newmap;
      var $465=(($464+$463*28)|0);
      var $466=$item;
      var $467=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $468=(($467+$466*28)|0);
      var $469=$465;
      var $470=$468;
      assert(28 % 1 === 0, 'memcpy given ' + 28 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($469)>>2)]=HEAP32[(($470)>>2)];HEAP32[(($469+4)>>2)]=HEAP32[(($470+4)>>2)];HEAP32[(($469+8)>>2)]=HEAP32[(($470+8)>>2)];HEAP32[(($469+12)>>2)]=HEAP32[(($470+12)>>2)];HEAP32[(($469+16)>>2)]=HEAP32[(($470+16)>>2)];HEAP32[(($469+20)>>2)]=HEAP32[(($470+20)>>2)];HEAP32[(($469+24)>>2)]=HEAP32[(($470+24)>>2)];
      __label__ = 93; break;
    case 93: // $471
      var $472=$item;
      var $473=(($472+1)|0);
      $item=$473;
      __label__ = 91; break;
    case 94: // $474
      var $475=$11;
      var $476=__ZN15running_machine7respoolEv($475);
      var $477=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $478=$477;
      __ZN13resource_pool6removeEPv($476, $478);
      var $479=$newmap;
      HEAP32[((((__ZL5cheat+16)|0))>>2)]=$479;
      var $$emscripten$temp$12=((__ZL5cheat+4)|0);
      var $st$8$0=(($$emscripten$temp$12)|0);
      var $480$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($$emscripten$temp$12+4)|0);
      var $480$1=HEAP32[(($st$8$1)>>2)];
      var $481$0=$480$0;
      var $481=$481$0;
      $active_cheat=$481;
      var $st$15$0=(($real_length)|0);
      var $482$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($real_length+4)|0);
      var $482$1=HEAP32[(($st$15$1)>>2)];
      var $$emscripten$temp$13=((__ZL5cheat+4)|0);
      var $st$20$0=(($$emscripten$temp$13)|0);
      var $483$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($$emscripten$temp$13+4)|0);
      var $483$1=HEAP32[(($st$20$1)>>2)];
      var $484$0 = ((($483$0)>>>0)+((($483$1)|0)*4294967296))+((($482$0)>>>0)+((($482$1)|0)*4294967296))>>>0; var $484$1 = Math.min(Math.floor((((($483$0)>>>0)+((($483$1)|0)*4294967296))+((($482$0)>>>0)+((($482$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$14=((__ZL5cheat+4)|0);
      var $st$26$0=(($$emscripten$temp$14)|0);
      HEAP32[(($st$26$0)>>2)]=$484$0;
      var $st$26$1=(($$emscripten$temp$14+4)|0);
      HEAP32[(($st$26$1)>>2)]=$484$1;
      __label__ = 95; break;
    case 95: // $485
      $i=0;
      __label__ = 96; break;
    case 96: // $486
      var $487=$i;
      var $488=(($487)&255);
      var $489=$region_count;
      var $490=(($489)&255);
      var $491=(($488)|0) < (($490)|0);
      if ($491) { __label__ = 97; break; } else { __label__ = 107; break; }
    case 97: // $492
      var $493=$i;
      var $494=(($493)&255);
      var $495=(($cheat_region+$494*24)|0);
      var $496=(($495+20)|0);
      var $497=HEAP8[($496)];
      var $498=(($497 << 24) >> 24)!=0;
      if ($498) { __label__ = 105; break; } else { __label__ = 98; break; }
    case 98: // $499
      var $500=$i;
      var $501=(($500)&255);
      var $502=(($cheat_region+$501*24)|0);
      var $503=(($502)|0);
      var $st$4$0=(($503)|0);
      var $504$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($503+4)|0);
      var $504$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($curaddr)|0);
      HEAP32[(($st$8$0)>>2)]=$504$0;
      var $st$8$1=(($curaddr+4)|0);
      HEAP32[(($st$8$1)>>2)]=$504$1;
      __label__ = 99; break;
    case 99: // $505
      var $st$0$0=(($curaddr)|0);
      var $506$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($curaddr+4)|0);
      var $506$1=HEAP32[(($st$0$1)>>2)];
      var $507=$i;
      var $508=(($507)&255);
      var $509=(($cheat_region+$508*24)|0);
      var $510=(($509+8)|0);
      var $st$8$0=(($510)|0);
      var $511$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($510+4)|0);
      var $511$1=HEAP32[(($st$8$1)>>2)];
      var $512=$506$1 <= $511$1 && ($506$1 < $511$1 || $506$0 <= $511$0);
      if ($512) { __label__ = 100; break; } else { __label__ = 104; break; }
    case 100: // $513
      var $514=HEAP32[(($space)>>2)];
      var $st$1$0=(($curaddr)|0);
      var $515$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curaddr+4)|0);
      var $515$1=HEAP32[(($st$1$1)>>2)];
      var $516$0=$515$0;
      var $516=$516$0;
      var $517=__ZL22cheat_address_is_validP13address_spacej($514, $516);
      var $518=(($517)|0)!=0;
      if ($518) { __label__ = 101; break; } else { __label__ = 102; break; }
    case 101: // $519
      var $520=HEAP32[(($space)>>2)];
      var $st$1$0=(($curaddr)|0);
      var $521$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($curaddr+4)|0);
      var $521$1=HEAP32[(($st$1$1)>>2)];
      var $522$0=$521$0;
      var $522=$522$0;
      var $523=__ZL19cheat_read_extendedPK13_cheat_systemP13address_spacej(__ZL5cheat, $520, $522);
      var $523$0=$523[0];
      var $523$1=$523[1];
      var $524=$active_cheat;
      var $525=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $526=(($525+$524*28)|0);
      var $527=(($526+16)|0);
      var $st$14$0=(($527)|0);
      HEAP32[(($st$14$0)>>2)]=$523$0;
      var $st$14$1=(($527+4)|0);
      HEAP32[(($st$14$1)>>2)]=$523$1;
      var $528=$active_cheat;
      var $529=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $530=(($529+$528*28)|0);
      var $531=(($530+16)|0);
      var $st$22$0=(($531)|0);
      var $532$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($531+4)|0);
      var $532$1=HEAP32[(($st$22$1)>>2)];
      var $533=$active_cheat;
      var $534=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $535=(($534+$533*28)|0);
      var $536=(($535+8)|0);
      var $st$30$0=(($536)|0);
      HEAP32[(($st$30$0)>>2)]=$532$0;
      var $st$30$1=(($536+4)|0);
      HEAP32[(($st$30$1)>>2)]=$532$1;
      var $st$34$0=(($curaddr)|0);
      var $537$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($curaddr+4)|0);
      var $537$1=HEAP32[(($st$34$1)>>2)];
      var $538=$active_cheat;
      var $539=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $540=(($539+$538*28)|0);
      var $541=(($540)|0);
      var $st$42$0=(($541)|0);
      HEAP32[(($st$42$0)>>2)]=$537$0;
      var $st$42$1=(($541+4)|0);
      HEAP32[(($st$42$1)>>2)]=$537$1;
      var $542=$active_cheat;
      var $543=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $544=(($543+$542*28)|0);
      var $545=$544;
      var $546=(($545+24)|0);
      var $547=HEAP8[($546)];
      var $548=$547 & -2;
      var $549=$548 | 1;
      HEAP8[($546)]=$549;
      var $550=$active_cheat;
      var $551=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $552=(($551+$550*28)|0);
      var $553=$552;
      var $554=(($553+24)|0);
      var $555=HEAP8[($554)];
      var $556=$555 & 1;
      HEAP8[($554)]=$556;
      var $557=$active_cheat;
      var $558=(($557+1)|0);
      $active_cheat=$558;
      __label__ = 102; break;
    case 102: // $559
      __label__ = 103; break;
    case 103: // $560
      var $561=HEAP8[(((__ZL5cheat+12)|0))];
      var $562$0=$561;
      var $562$1=0;
      var $st$3$0=(($curaddr)|0);
      var $563$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($curaddr+4)|0);
      var $563$1=HEAP32[(($st$3$1)>>2)];
      var $564$0 = ((($563$0)>>>0)+((($563$1)|0)*4294967296))+((($562$0)>>>0)+((($562$1)|0)*4294967296))>>>0; var $564$1 = Math.min(Math.floor((((($563$0)>>>0)+((($563$1)|0)*4294967296))+((($562$0)>>>0)+((($562$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($curaddr)|0);
      HEAP32[(($st$8$0)>>2)]=$564$0;
      var $st$8$1=(($curaddr+4)|0);
      HEAP32[(($st$8$1)>>2)]=$564$1;
      __label__ = 99; break;
    case 104: // $565
      __label__ = 105; break;
    case 105: // $566
      __label__ = 106; break;
    case 106: // $567
      var $568=$i;
      var $569=(($568+1)&255);
      $i=$569;
      __label__ = 96; break;
    case 107: // $570
      var $571=$11;
      var $572=$active_cheat;
      __Z20debug_console_printfR15running_machinePKcz($571, ((STRING_TABLE.__str1875685)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$572,tempInt));
      __label__ = 108; break;
    case 108: // $573
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17execute_cheatinitR15running_machineiiPPKc["X"]=1;

function __ZL17execute_cheatnextR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $space=__stackBase__;
      var $cheatindex=__stackBase__+4;
      var $active_cheat;
      var $condition;
      var $comp_value=__stackBase__+12;
      var $cheat_value=__stackBase__+20;
      var $comp_byte=__stackBase__+28;
      var $disable_byte;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $active_cheat=0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=(($comp_value)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=(($comp_value+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      var $5=HEAP8[(((__ZL5cheat)|0))];
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$1;
      __Z20debug_console_printfR15running_machinePKcz($9, ((STRING_TABLE.__str1565654)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 101; break;
    case 2: // $10
      var $11=$1;
      var $12=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($11, ((__ZL5cheat)|0), 0, $space);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $14
      __label__ = 101; break;
    case 4: // $15
      var $16=$3;
      var $17=(($16)|0) > 1;
      if ($17) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $18
      var $19=$1;
      var $20=$4;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__Z30debug_command_parameter_numberR15running_machinePKcPy($19, $22, $comp_value);
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $25
      __label__ = 101; break;
    case 7: // $26
      var $st$0$0=(($comp_value)|0);
      var $27$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($comp_value+4)|0);
      var $27$1=HEAP32[(($st$0$1)>>2)];
      var $28=__ZL17cheat_sign_extendPK13_cheat_systemy(__ZL5cheat, $27$0, $27$1);
      var $28$0=$28[0];
      var $28$1=$28[1];
      var $st$7$0=(($comp_value)|0);
      HEAP32[(($st$7$0)>>2)]=$28$0;
      var $st$7$1=(($comp_value+4)|0);
      HEAP32[(($st$7$1)>>2)]=$28$1;
      var $29=$4;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=_strcmp($31, ((STRING_TABLE.__str1575655)|0));
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $34
      $condition=0;
      __label__ = 51; break;
    case 9: // $35
      var $36=$4;
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=_strcmp($38, ((STRING_TABLE.__str1585656)|0));
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $41
      var $42=$4;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_strcmp($44, ((STRING_TABLE.__str1595657)|0));
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $47
      var $48=$3;
      var $49=(($48)|0) > 1;
      var $50=$49 ? 3 : 1;
      var $51=(($50) & 255);
      $condition=$51;
      __label__ = 50; break;
    case 12: // $52
      var $53=$4;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=_strcmp($55, ((STRING_TABLE.__str1605658)|0));
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $58
      var $59=$4;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=_strcmp($61, ((STRING_TABLE.__str1615659)|0));
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $64
      var $65=$3;
      var $66=(($65)|0) > 1;
      var $67=$66 ? 4 : 2;
      var $68=(($67) & 255);
      $condition=$68;
      __label__ = 49; break;
    case 15: // $69
      var $70=$4;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=_strcmp($72, ((STRING_TABLE.__str1625660)|0));
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $75
      var $76=$4;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=_strcmp($78, ((STRING_TABLE.__str1635661)|0));
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $81
      var $82=$4;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=_strcmp($84, ((STRING_TABLE.__str1645662)|0));
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $87
      var $88=$3;
      var $89=(($88)|0) > 1;
      var $90=$89 ? 9 : 5;
      var $91=(($90) & 255);
      $condition=$91;
      __label__ = 48; break;
    case 19: // $92
      var $93=$4;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=_strcmp($95, ((STRING_TABLE.__str1655663)|0));
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $98
      var $99=$4;
      var $100=(($99)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=_strcmp($101, ((STRING_TABLE.__str1665664)|0));
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $104
      var $105=$4;
      var $106=(($105)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=_strcmp($107, ((STRING_TABLE.__str1675665)|0));
      var $109=(($108)|0)!=0;
      if ($109) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $110
      var $111=$3;
      var $112=(($111)|0) > 1;
      var $113=$112 ? 10 : 6;
      var $114=(($113) & 255);
      $condition=$114;
      __label__ = 47; break;
    case 23: // $115
      var $116=$4;
      var $117=(($116)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=_strcmp($118, ((STRING_TABLE.__str1685666)|0));
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $121
      var $122=$4;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=_strcmp($124, ((STRING_TABLE.__str1695667)|0));
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $127
      $condition=7;
      __label__ = 46; break;
    case 26: // $128
      var $129=$4;
      var $130=(($129)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=_strcmp($131, ((STRING_TABLE.__str1705668)|0));
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $134
      var $135=$4;
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=_strcmp($137, ((STRING_TABLE.__str1715669)|0));
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $140
      $condition=8;
      __label__ = 45; break;
    case 29: // $141
      var $142=$4;
      var $143=(($142)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=_strcmp($144, ((STRING_TABLE.__str1725670)|0));
      var $146=(($145)|0)!=0;
      if ($146) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $147
      var $148=$4;
      var $149=(($148)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=_strcmp($150, ((STRING_TABLE.__str1735671)|0));
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $153
      var $154=$4;
      var $155=(($154)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=_strcmp($156, ((STRING_TABLE.__str1745672)|0));
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $159
      $condition=11;
      __label__ = 44; break;
    case 33: // $160
      var $161=$4;
      var $162=(($161)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=_strcmp($163, ((STRING_TABLE.__str1755673)|0));
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $166
      var $167=$4;
      var $168=(($167)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=_strcmp($169, ((STRING_TABLE.__str245522)|0));
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $172
      var $173=$4;
      var $174=(($173)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=_strcmp($175, ((STRING_TABLE.__str1765674)|0));
      var $177=(($176)|0)!=0;
      if ($177) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $178
      $condition=12;
      __label__ = 43; break;
    case 37: // $179
      var $180=$4;
      var $181=(($180)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=_strcmp($182, ((STRING_TABLE.__str1775675)|0));
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $185
      var $186=$4;
      var $187=(($186)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=_strcmp($188, ((STRING_TABLE.__str1785676)|0));
      var $190=(($189)|0)!=0;
      if ($190) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $191
      var $192=$4;
      var $193=(($192)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=_strcmp($194, ((STRING_TABLE.__str1795677)|0));
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $197
      $condition=13;
      __label__ = 42; break;
    case 41: // $198
      var $199=$1;
      __Z20debug_console_printfR15running_machinePKcz($199, ((STRING_TABLE.__str1805678)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 101; break;
    case 42: // $200
      __label__ = 43; break;
    case 43: // $201
      __label__ = 44; break;
    case 44: // $202
      __label__ = 45; break;
    case 45: // $203
      __label__ = 46; break;
    case 46: // $204
      __label__ = 47; break;
    case 47: // $205
      __label__ = 48; break;
    case 48: // $206
      __label__ = 49; break;
    case 49: // $207
      __label__ = 50; break;
    case 50: // $208
      __label__ = 51; break;
    case 51: // $209
      var $210=HEAP8[(((__ZL5cheat+20)|0))];
      var $211=(($210+1)&255);
      HEAP8[(((__ZL5cheat+20)|0))]=$211;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$5$0=(($cheatindex)|0);
      HEAP32[(($st$5$0)>>2)]=$$emscripten$temp$1$0;
      var $st$5$1=(($cheatindex+4)|0);
      HEAP32[(($st$5$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 52; break;
    case 52: // $212
      var $st$0$0=(($cheatindex)|0);
      var $213$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $213$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2=((__ZL5cheat+4)|0);
      var $st$5$0=(($$emscripten$temp$2)|0);
      var $214$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($$emscripten$temp$2+4)|0);
      var $214$1=HEAP32[(($st$5$1)>>2)];
      var $215=$213$1 < $214$1 || ($213$1 == $214$1 && $213$0 < $214$0);
      if ($215) { __label__ = 53; break; } else { __label__ = 98; break; }
    case 53: // $216
      var $st$0$0=(($cheatindex)|0);
      var $217$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $217$1=HEAP32[(($st$0$1)>>2)];
      var $218$0=$217$0;
      var $218=$218$0;
      var $219=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $220=(($219+$218*28)|0);
      var $221=$220;
      var $222=(($221+24)|0);
      var $223=HEAP8[($222)];
      var $224=$223 & 1;
      var $225=(($224)&255);
      var $226=(($225)|0)==1;
      if ($226) { __label__ = 54; break; } else { __label__ = 96; break; }
    case 54: // $227
      var $228=HEAP32[(($space)>>2)];
      var $st$1$0=(($cheatindex)|0);
      var $229$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($cheatindex+4)|0);
      var $229$1=HEAP32[(($st$1$1)>>2)];
      var $230$0=$229$0;
      var $230=$230$0;
      var $231=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $232=(($231+$230*28)|0);
      var $233=(($232)|0);
      var $st$10$0=(($233)|0);
      var $234$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($233+4)|0);
      var $234$1=HEAP32[(($st$10$1)>>2)];
      var $235$0=$234$0;
      var $235=$235$0;
      var $236=__ZL19cheat_read_extendedPK13_cheat_systemP13address_spacej(__ZL5cheat, $228, $235);
      var $236$0=$236[0];
      var $236$1=$236[1];
      var $st$19$0=(($cheat_value)|0);
      HEAP32[(($st$19$0)>>2)]=$236$0;
      var $st$19$1=(($cheat_value+4)|0);
      HEAP32[(($st$19$1)>>2)]=$236$1;
      var $237=$2;
      var $238=(($237)|0)==0;
      if ($238) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $239
      var $st$0$0=(($cheatindex)|0);
      var $240$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $240$1=HEAP32[(($st$0$1)>>2)];
      var $241$0=$240$0;
      var $241=$241$0;
      var $242=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $243=(($242+$241*28)|0);
      var $244=(($243+16)|0);
      var $st$9$0=(($244)|0);
      var $245$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($244+4)|0);
      var $245$1=HEAP32[(($st$9$1)>>2)];
      var $254$1 = $245$1;var $254$0 = $245$0;__label__ = 57; break;
    case 56: // $246
      var $st$0$0=(($cheatindex)|0);
      var $247$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $247$1=HEAP32[(($st$0$1)>>2)];
      var $248$0=$247$0;
      var $248=$248$0;
      var $249=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $250=(($249+$248*28)|0);
      var $251=(($250+8)|0);
      var $st$9$0=(($251)|0);
      var $252$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($251+4)|0);
      var $252$1=HEAP32[(($st$9$1)>>2)];
      var $254$1 = $252$1;var $254$0 = $252$0;__label__ = 57; break;
    case 57: // $253
      var $254$0;
      var $254$1;
      var $st$2$0=(($comp_byte)|0);
      HEAP32[(($st$2$0)>>2)]=$254$0;
      var $st$2$1=(($comp_byte+4)|0);
      HEAP32[(($st$2$1)>>2)]=$254$1;
      $disable_byte=0;
      var $255=$condition;
      var $256=(($255)&255);
      if ($256 == 0) {
        __label__ = 92; break;
      }
      else if ($256 == 1) {
        __label__ = 58; break;
      }
      else if ($256 == 2) {
        __label__ = 59; break;
      }
      else if ($256 == 3) {
        __label__ = 60; break;
      }
      else if ($256 == 4) {
        __label__ = 61; break;
      }
      else if ($256 == 5) {
        __label__ = 62; break;
      }
      else if ($256 == 6) {
        __label__ = 66; break;
      }
      else if ($256 == 7) {
        __label__ = 70; break;
      }
      else if ($256 == 8) {
        __label__ = 74; break;
      }
      else if ($256 == 9) {
        __label__ = 78; break;
      }
      else if ($256 == 10) {
        __label__ = 79; break;
      }
      else if ($256 == 11) {
        __label__ = 80; break;
      }
      else if ($256 == 12) {
        __label__ = 84; break;
      }
      else if ($256 == 13) {
        __label__ = 88; break;
      }
      else {
      __label__ = 92; break;
      }
      
    case 58: // $257
      var $st$0$0=(($cheat_value)|0);
      var $258$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $258$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $259$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $259$1=HEAP32[(($st$4$1)>>2)];
      var $260=$258$0 != $259$0 || $258$1 != $259$1;
      var $261=(($260)&1);
      $disable_byte=$261;
      __label__ = 92; break;
    case 59: // $262
      var $st$0$0=(($cheat_value)|0);
      var $263$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $263$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $264$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $264$1=HEAP32[(($st$4$1)>>2)];
      var $265=$263$0 == $264$0 && $263$1 == $264$1;
      var $266=(($265)&1);
      $disable_byte=$266;
      __label__ = 92; break;
    case 60: // $267
      var $st$0$0=(($cheat_value)|0);
      var $268$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $268$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_value)|0);
      var $269$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_value+4)|0);
      var $269$1=HEAP32[(($st$4$1)>>2)];
      var $270=$268$0 != $269$0 || $268$1 != $269$1;
      var $271=(($270)&1);
      $disable_byte=$271;
      __label__ = 92; break;
    case 61: // $272
      var $st$0$0=(($cheat_value)|0);
      var $273$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $273$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_value)|0);
      var $274$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_value+4)|0);
      var $274$1=HEAP32[(($st$4$1)>>2)];
      var $275=$273$0 == $274$0 && $273$1 == $274$1;
      var $276=(($275)&1);
      $disable_byte=$276;
      __label__ = 92; break;
    case 62: // $277
      var $278=HEAP8[(((__ZL5cheat+21)|0))];
      var $279=(($278 << 24) >> 24)!=0;
      if ($279) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $280
      var $st$0$0=(($cheat_value)|0);
      var $281$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $281$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $282$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $282$1=HEAP32[(($st$4$1)>>2)];
      var $283=($281$1|0) >= ($282$1|0) && (($281$1|0) >  ($282$1|0) || ($281$0|0) >= ($282$0|0));
      var $284=(($283)&1);
      $disable_byte=$284;
      __label__ = 65; break;
    case 64: // $285
      var $st$0$0=(($cheat_value)|0);
      var $286$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $286$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $287$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $287$1=HEAP32[(($st$4$1)>>2)];
      var $288=$286$1 >= $287$1 && ($286$1 > $287$1 || $286$0 >= $287$0);
      var $289=(($288)&1);
      $disable_byte=$289;
      __label__ = 65; break;
    case 65: // $290
      __label__ = 92; break;
    case 66: // $291
      var $292=HEAP8[(((__ZL5cheat+21)|0))];
      var $293=(($292 << 24) >> 24)!=0;
      if ($293) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $294
      var $st$0$0=(($cheat_value)|0);
      var $295$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $295$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $296$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $296$1=HEAP32[(($st$4$1)>>2)];
      var $297=($295$1|0) <= ($296$1|0) && (($295$1|0) <  ($296$1|0) || ($295$0|0) <= ($296$0|0));
      var $298=(($297)&1);
      $disable_byte=$298;
      __label__ = 69; break;
    case 68: // $299
      var $st$0$0=(($cheat_value)|0);
      var $300$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $300$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $301$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $301$1=HEAP32[(($st$4$1)>>2)];
      var $302=$300$1 <= $301$1 && ($300$1 < $301$1 || $300$0 <= $301$0);
      var $303=(($302)&1);
      $disable_byte=$303;
      __label__ = 69; break;
    case 69: // $304
      __label__ = 92; break;
    case 70: // $305
      var $306=HEAP8[(((__ZL5cheat+21)|0))];
      var $307=(($306 << 24) >> 24)!=0;
      if ($307) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $308
      var $st$0$0=(($cheat_value)|0);
      var $309$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $309$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $310$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $310$1=HEAP32[(($st$4$1)>>2)];
      var $311=($309$1|0) > ($310$1|0) || (($309$1|0) == ($310$1|0) && ($309$0|0) >  ($310$0|0));
      var $312=(($311)&1);
      $disable_byte=$312;
      __label__ = 73; break;
    case 72: // $313
      var $st$0$0=(($cheat_value)|0);
      var $314$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $314$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $315$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $315$1=HEAP32[(($st$4$1)>>2)];
      var $316=$314$1 > $315$1 || ($314$1 == $315$1 && $314$0 > $315$0);
      var $317=(($316)&1);
      $disable_byte=$317;
      __label__ = 73; break;
    case 73: // $318
      __label__ = 92; break;
    case 74: // $319
      var $320=HEAP8[(((__ZL5cheat+21)|0))];
      var $321=(($320 << 24) >> 24)!=0;
      if ($321) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $322
      var $st$0$0=(($cheat_value)|0);
      var $323$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $323$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $324$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $324$1=HEAP32[(($st$4$1)>>2)];
      var $325=($323$1|0) < ($324$1|0) || (($323$1|0) == ($324$1|0) && ($323$0|0) <  ($324$0|0));
      var $326=(($325)&1);
      $disable_byte=$326;
      __label__ = 77; break;
    case 76: // $327
      var $st$0$0=(($cheat_value)|0);
      var $328$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $328$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $329$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $329$1=HEAP32[(($st$4$1)>>2)];
      var $330=$328$1 < $329$1 || ($328$1 == $329$1 && $328$0 < $329$0);
      var $331=(($330)&1);
      $disable_byte=$331;
      __label__ = 77; break;
    case 77: // $332
      __label__ = 92; break;
    case 78: // $333
      var $st$0$0=(($cheat_value)|0);
      var $334$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $334$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $335$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $335$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($comp_value)|0);
      var $336$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($comp_value+4)|0);
      var $336$1=HEAP32[(($st$8$1)>>2)];
      var $337$0 = ((($335$0)>>>0)+((($335$1)|0)*4294967296))-((($336$0)>>>0)+((($336$1)|0)*4294967296))>>>0; var $337$1 = Math.min(Math.floor((((($335$0)>>>0)+((($335$1)|0)*4294967296))-((($336$0)>>>0)+((($336$1)|0)*4294967296)))/4294967296), 4294967295);
      var $338=$334$0 != $337$0 || $334$1 != $337$1;
      var $339=(($338)&1);
      $disable_byte=$339;
      __label__ = 92; break;
    case 79: // $340
      var $st$0$0=(($cheat_value)|0);
      var $341$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $341$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $342$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $342$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($comp_value)|0);
      var $343$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($comp_value+4)|0);
      var $343$1=HEAP32[(($st$8$1)>>2)];
      var $344$0 = ((($342$0)>>>0)+((($342$1)|0)*4294967296))+((($343$0)>>>0)+((($343$1)|0)*4294967296))>>>0; var $344$1 = Math.min(Math.floor((((($342$0)>>>0)+((($342$1)|0)*4294967296))+((($343$0)>>>0)+((($343$1)|0)*4294967296)))/4294967296), 4294967295);
      var $345=$341$0 != $344$0 || $341$1 != $344$1;
      var $346=(($345)&1);
      $disable_byte=$346;
      __label__ = 92; break;
    case 80: // $347
      var $348=HEAP8[(((__ZL5cheat+21)|0))];
      var $349=(($348 << 24) >> 24)!=0;
      if ($349) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $350
      var $st$0$0=(($cheat_value)|0);
      var $351$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $351$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_value)|0);
      var $352$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_value+4)|0);
      var $352$1=HEAP32[(($st$4$1)>>2)];
      var $353=($351$1|0) >= ($352$1|0) && (($351$1|0) >  ($352$1|0) || ($351$0|0) >= ($352$0|0));
      var $354=(($353)&1);
      $disable_byte=$354;
      __label__ = 83; break;
    case 82: // $355
      var $st$0$0=(($cheat_value)|0);
      var $356$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $356$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_value)|0);
      var $357$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_value+4)|0);
      var $357$1=HEAP32[(($st$4$1)>>2)];
      var $358=$356$1 >= $357$1 && ($356$1 > $357$1 || $356$0 >= $357$0);
      var $359=(($358)&1);
      $disable_byte=$359;
      __label__ = 83; break;
    case 83: // $360
      __label__ = 92; break;
    case 84: // $361
      var $362=HEAP8[(((__ZL5cheat+21)|0))];
      var $363=(($362 << 24) >> 24)!=0;
      if ($363) { __label__ = 85; break; } else { __label__ = 86; break; }
    case 85: // $364
      var $st$0$0=(($cheat_value)|0);
      var $365$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $365$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_value)|0);
      var $366$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_value+4)|0);
      var $366$1=HEAP32[(($st$4$1)>>2)];
      var $367=($365$1|0) <= ($366$1|0) && (($365$1|0) <  ($366$1|0) || ($365$0|0) <= ($366$0|0));
      var $368=(($367)&1);
      $disable_byte=$368;
      __label__ = 87; break;
    case 86: // $369
      var $st$0$0=(($cheat_value)|0);
      var $370$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $370$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_value)|0);
      var $371$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_value+4)|0);
      var $371$1=HEAP32[(($st$4$1)>>2)];
      var $372=$370$1 <= $371$1 && ($370$1 < $371$1 || $370$0 <= $371$0);
      var $373=(($372)&1);
      $disable_byte=$373;
      __label__ = 87; break;
    case 87: // $374
      __label__ = 92; break;
    case 88: // $375
      var $st$0$0=(($cheat_value)|0);
      var $376$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $376$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $377$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $377$1=HEAP32[(($st$4$1)>>2)];
      var $378=$376$1 > $377$1 || ($376$1 == $377$1 && $376$0 > $377$0);
      if ($378) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $379
      var $st$0$0=(($cheat_value)|0);
      var $380$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $380$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $381$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $381$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($comp_value)|0);
      var $382$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($comp_value+4)|0);
      var $382$1=HEAP32[(($st$8$1)>>2)];
      var $383$0 = ((($381$0)>>>0)+((($381$1)|0)*4294967296))+((($382$0)>>>0)+((($382$1)|0)*4294967296))>>>0; var $383$1 = Math.min(Math.floor((((($381$0)>>>0)+((($381$1)|0)*4294967296))+((($382$0)>>>0)+((($382$1)|0)*4294967296)))/4294967296), 4294967295);
      var $384=$380$0 != $383$0 || $380$1 != $383$1;
      var $385=(($384)&1);
      $disable_byte=$385;
      __label__ = 91; break;
    case 90: // $386
      var $st$0$0=(($cheat_value)|0);
      var $387$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $387$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($comp_byte)|0);
      var $388$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($comp_byte+4)|0);
      var $388$1=HEAP32[(($st$4$1)>>2)];
      var $st$8$0=(($comp_value)|0);
      var $389$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($comp_value+4)|0);
      var $389$1=HEAP32[(($st$8$1)>>2)];
      var $390$0 = ((($388$0)>>>0)+((($388$1)|0)*4294967296))-((($389$0)>>>0)+((($389$1)|0)*4294967296))>>>0; var $390$1 = Math.min(Math.floor((((($388$0)>>>0)+((($388$1)|0)*4294967296))-((($389$0)>>>0)+((($389$1)|0)*4294967296)))/4294967296), 4294967295);
      var $391=$387$0 != $390$0 || $387$1 != $390$1;
      var $392=(($391)&1);
      $disable_byte=$392;
      __label__ = 91; break;
    case 91: // $393
      __label__ = 92; break;
    case 92: // $394
      var $395=$disable_byte;
      var $396=(($395 << 24) >> 24)!=0;
      if ($396) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $397
      var $st$0$0=(($cheatindex)|0);
      var $398$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $398$1=HEAP32[(($st$0$1)>>2)];
      var $399$0=$398$0;
      var $399=$399$0;
      var $400=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $401=(($400+$399*28)|0);
      var $402=$401;
      var $403=(($402+24)|0);
      var $404=HEAP8[($403)];
      var $405=$404 & -2;
      HEAP8[($403)]=$405;
      var $406=HEAP8[(((__ZL5cheat+20)|0))];
      var $st$14$0=(($cheatindex)|0);
      var $407$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($cheatindex+4)|0);
      var $407$1=HEAP32[(($st$14$1)>>2)];
      var $408$0=$407$0;
      var $408=$408$0;
      var $409=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $410=(($409+$408*28)|0);
      var $411=$406 & 127;
      var $412=$410;
      var $413=(($412+24)|0);
      var $414=$411 & 127;
      var $415=$414 << 1;
      var $416=HEAP8[($413)];
      var $417=$416 & 1;
      var $418=$417 | $415;
      HEAP8[($413)]=$418;
      __label__ = 95; break;
    case 94: // $419
      var $420=$active_cheat;
      var $421=(($420+1)|0);
      $active_cheat=$421;
      __label__ = 95; break;
    case 95: // $422
      var $st$0$0=(($cheat_value)|0);
      var $423$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheat_value+4)|0);
      var $423$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($cheatindex)|0);
      var $424$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($cheatindex+4)|0);
      var $424$1=HEAP32[(($st$4$1)>>2)];
      var $425$0=$424$0;
      var $425=$425$0;
      var $426=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $427=(($426+$425*28)|0);
      var $428=(($427+16)|0);
      var $st$13$0=(($428)|0);
      HEAP32[(($st$13$0)>>2)]=$423$0;
      var $st$13$1=(($428+4)|0);
      HEAP32[(($st$13$1)>>2)]=$423$1;
      __label__ = 96; break;
    case 96: // $429
      __label__ = 97; break;
    case 97: // $430
      var $st$0$0=(($cheatindex)|0);
      var $431$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $431$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $432$0 = ((($431$0)>>>0)+((($431$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $432$1 = Math.min(Math.floor((((($431$0)>>>0)+((($431$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($cheatindex)|0);
      HEAP32[(($st$7$0)>>2)]=$432$0;
      var $st$7$1=(($cheatindex+4)|0);
      HEAP32[(($st$7$1)>>2)]=$432$1;
      __label__ = 52; break;
    case 98: // $433
      var $434=$active_cheat;
      var $435=(($434)>>>0) <= 5;
      if ($435) { __label__ = 99; break; } else { __label__ = 100; break; }
    case 99: // $436
      var $437=$1;
      __ZL17execute_cheatlistR15running_machineiiPPKc($437, 0, 0, 0);
      __label__ = 100; break;
    case 100: // $438
      var $439=$1;
      var $440=$active_cheat;
      __Z20debug_console_printfR15running_machinePKcz($439, ((STRING_TABLE.__str1815679)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$440,tempInt));
      __label__ = 101; break;
    case 101: // $441
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17execute_cheatnextR15running_machineiiPPKc["X"]=1;

function __ZL17execute_cheatlistR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $spaceletter;
      var $sizeletter;
      var $space=__stackBase__;
      var $cpu=__stackBase__+4;
      var $active_cheat;
      var $cheatindex=__stackBase__+8;
      var $sizemask=__stackBase__+16;
      var $f;
      var $value=__stackBase__+24;
      var $address;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $active_cheat=0;
      $f=0;
      var $5=$1;
      var $6=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($5, ((__ZL5cheat)|0), 0, $space);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      __label__ = 28; break;
    case 2: // $9
      var $10=$1;
      var $11=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($10, ((__ZL5cheat)|0), $cpu);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      __label__ = 28; break;
    case 4: // $14
      var $15=$3;
      var $16=(($15)|0) > 0;
      if ($16) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      var $18=$4;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=_fopen($20, ((STRING_TABLE.__str1185616)|0));
      $f=$21;
      __label__ = 6; break;
    case 6: // $22
      var $23=HEAP32[(($space)>>2)];
      var $24=__ZNK13address_space8spacenumEv($23);
      if ($24 == 0) {
        __label__ = 8; break;
      }
      else if ($24 == 1) {
        __label__ = 9; break;
      }
      else if ($24 == 2) {
        __label__ = 10; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      $spaceletter=112;
      __label__ = 11; break;
    case 9: // $27
      $spaceletter=100;
      __label__ = 11; break;
    case 10: // $28
      $spaceletter=105;
      __label__ = 11; break;
    case 11: // $29
      var $30=HEAPU8[(((__ZL5cheat+12)|0))];
      var $31=(($30)&255);
      if ($31 == 1) {
        __label__ = 13; break;
      }
      else if ($31 == 2) {
        __label__ = 14; break;
      }
      else if ($31 == 4) {
        __label__ = 15; break;
      }
      else if ($31 == 8) {
        __label__ = 16; break;
      }
      else {
      __label__ = 12; break;
      }
      
    case 12: // $32
      __label__ = 13; break;
    case 13: // $33
      $sizeletter=98;
      var $$emscripten$temp$0$0=255;
      var $$emscripten$temp$0$1=0;
      var $st$3$0=(($sizemask)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$0$0;
      var $st$3$1=(($sizemask+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 17; break;
    case 14: // $34
      $sizeletter=119;
      var $$emscripten$temp$1$0=65535;
      var $$emscripten$temp$1$1=0;
      var $st$3$0=(($sizemask)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$1$0;
      var $st$3$1=(($sizemask+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 17; break;
    case 15: // $35
      $sizeletter=100;
      var $$emscripten$temp$2$0=-1;
      var $$emscripten$temp$2$1=0;
      var $st$3$0=(($sizemask)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$2$0;
      var $st$3$1=(($sizemask+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 17; break;
    case 16: // $36
      $sizeletter=113;
      var $$emscripten$temp$3$0=-1;
      var $$emscripten$temp$3$1=-1;
      var $st$3$0=(($sizemask)|0);
      HEAP32[(($st$3$0)>>2)]=$$emscripten$temp$3$0;
      var $st$3$1=(($sizemask+4)|0);
      HEAP32[(($st$3$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 17; break;
    case 17: // $37
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $st$2$0=(($cheatindex)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$4$0;
      var $st$2$1=(($cheatindex+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 18; break;
    case 18: // $38
      var $st$0$0=(($cheatindex)|0);
      var $39$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $39$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$5=((__ZL5cheat+4)|0);
      var $st$5$0=(($$emscripten$temp$5)|0);
      var $40$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($$emscripten$temp$5+4)|0);
      var $40$1=HEAP32[(($st$5$1)>>2)];
      var $41=$39$1 < $40$1 || ($39$1 == $40$1 && $39$0 < $40$0);
      if ($41) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $42
      var $st$0$0=(($cheatindex)|0);
      var $43$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $43$1=HEAP32[(($st$0$1)>>2)];
      var $44$0=$43$0;
      var $44=$44$0;
      var $45=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $46=(($45+$44*28)|0);
      var $47=$46;
      var $48=(($47+24)|0);
      var $49=HEAP8[($48)];
      var $50=$49 & 1;
      var $51=(($50)&255);
      var $52=(($51)|0)==1;
      if ($52) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $53
      var $54=HEAP32[(($space)>>2)];
      var $st$1$0=(($cheatindex)|0);
      var $55$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($cheatindex+4)|0);
      var $55$1=HEAP32[(($st$1$1)>>2)];
      var $56$0=$55$0;
      var $56=$56$0;
      var $57=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $58=(($57+$56*28)|0);
      var $59=(($58)|0);
      var $st$10$0=(($59)|0);
      var $60$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($59+4)|0);
      var $60$1=HEAP32[(($st$10$1)>>2)];
      var $61$0=$60$0;
      var $61=$61$0;
      var $62=__ZL19cheat_read_extendedPK13_cheat_systemP13address_spacej(__ZL5cheat, $54, $61);
      var $62$0=$62[0];
      var $62$1=$62[1];
      var $63=__ZL15cheat_byte_swapPK13_cheat_systemy(__ZL5cheat, $62$0, $62$1);
      var $63$0=$63[0];
      var $63$1=$63[1];
      var $st$22$0=(($sizemask)|0);
      var $64$0=HEAP32[(($st$22$0)>>2)];
      var $st$22$1=(($sizemask+4)|0);
      var $64$1=HEAP32[(($st$22$1)>>2)];
      var $65$0=$63$0 & $64$0;
      var $65$1=$63$1 & $64$1;
      var $st$28$0=(($value)|0);
      HEAP32[(($st$28$0)>>2)]=$65$0;
      var $st$28$1=(($value+4)|0);
      HEAP32[(($st$28$1)>>2)]=$65$1;
      var $66=HEAP32[(($space)>>2)];
      var $st$33$0=(($cheatindex)|0);
      var $67$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($cheatindex+4)|0);
      var $67$1=HEAP32[(($st$33$1)>>2)];
      var $68$0=$67$0;
      var $68=$68$0;
      var $69=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $70=(($69+$68*28)|0);
      var $71=(($70)|0);
      var $st$42$0=(($71)|0);
      var $72$0=HEAP32[(($st$42$0)>>2)];
      var $st$42$1=(($71+4)|0);
      var $72$1=HEAP32[(($st$42$1)>>2)];
      var $73$0=$72$0;
      var $73=$73$0;
      var $74=__ZNK13address_space15byte_to_addressEj($66, $73);
      $address=$74;
      var $75=$3;
      var $76=(($75)|0) > 0;
      if ($76) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $77
      var $78=$active_cheat;
      var $79=(($78+1)|0);
      $active_cheat=$79;
      var $80=$f;
      var $81=$active_cheat;
      var $82=$address;
      var $83$0=$82;
      var $83$1=0;
      var $84=HEAP32[(($space)>>2)];
      var $85=__ZNK13address_space12logaddrcharsEv($84);
      var $86=__Z19core_i64_hex_formatyh($83$0, $83$1, $85);
      var $st$11$0=(($value)|0);
      var $87$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($value+4)|0);
      var $87$1=HEAP32[(($st$11$1)>>2)];
      var $88=HEAPU8[(((__ZL5cheat+12)|0))];
      var $89=(($88)&255);
      var $90=((($89<<1))|0);
      var $91=(($90) & 255);
      var $92=__Z19core_i64_hex_formatyh($87$0, $87$1, $91);
      var $93=_fprintf($80, ((STRING_TABLE.__str1505648)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,HEAP32[((tempInt+4)>>2)]=$86,HEAP32[((tempInt+8)>>2)]=$92,tempInt));
      var $94=$f;
      var $95=_fprintf($94, ((STRING_TABLE.__str1515649)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $96=$f;
      var $97=HEAP32[(($cpu)>>2)];
      var $98=__ZNK8device_t3tagEv($97);
      var $99=$spaceletter;
      var $100=(($99 << 24) >> 24);
      var $101=$sizeletter;
      var $102=(($101 << 24) >> 24);
      var $103=$address;
      var $104$0=$103;
      var $104$1=0;
      var $105=HEAP32[(($space)>>2)];
      var $106=__ZNK13address_space12logaddrcharsEv($105);
      var $107=__Z19core_i64_hex_formatyh($104$0, $104$1, $106);
      var $st$36$0=(($cheatindex)|0);
      var $108$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($cheatindex+4)|0);
      var $108$1=HEAP32[(($st$36$1)>>2)];
      var $109$0=$108$0;
      var $109=$109$0;
      var $110=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $111=(($110+$109*28)|0);
      var $112=(($111+8)|0);
      var $st$45$0=(($112)|0);
      var $113$0=HEAP32[(($st$45$0)>>2)];
      var $st$45$1=(($112+4)|0);
      var $113$1=HEAP32[(($st$45$1)>>2)];
      var $114=__ZL15cheat_byte_swapPK13_cheat_systemy(__ZL5cheat, $113$0, $113$1);
      var $114$0=$114[0];
      var $114$1=$114[1];
      var $st$52$0=(($sizemask)|0);
      var $115$0=HEAP32[(($st$52$0)>>2)];
      var $st$52$1=(($sizemask+4)|0);
      var $115$1=HEAP32[(($st$52$1)>>2)];
      var $116$0=$114$0 & $115$0;
      var $116$1=$114$1 & $115$1;
      var $117=HEAPU8[(((__ZL5cheat+12)|0))];
      var $118=(($117)&255);
      var $119=((($118<<1))|0);
      var $120=(($119) & 255);
      var $121=__Z19core_i64_hex_formatyh($116$0, $116$1, $120);
      var $122=_fprintf($96, ((STRING_TABLE.__str1525650)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$98,HEAP32[((tempInt+4)>>2)]=$100,HEAP32[((tempInt+8)>>2)]=$102,HEAP32[((tempInt+12)>>2)]=$107,HEAP32[((tempInt+16)>>2)]=$121,tempInt));
      var $123=$f;
      var $124=_fprintf($123, ((STRING_TABLE.__str1535651)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $125=$f;
      var $126=_fprintf($125, ((STRING_TABLE.__str1545652)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 23; break;
    case 22: // $127
      var $128=$1;
      var $129=$address;
      var $130$0=$129;
      var $130$1=0;
      var $131=HEAP32[(($space)>>2)];
      var $132=__ZNK13address_space12logaddrcharsEv($131);
      var $133=__Z19core_i64_hex_formatyh($130$0, $130$1, $132);
      var $st$7$0=(($cheatindex)|0);
      var $134$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($cheatindex+4)|0);
      var $134$1=HEAP32[(($st$7$1)>>2)];
      var $135$0=$134$0;
      var $135=$135$0;
      var $136=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $137=(($136+$135*28)|0);
      var $138=(($137+8)|0);
      var $st$16$0=(($138)|0);
      var $139$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($138+4)|0);
      var $139$1=HEAP32[(($st$16$1)>>2)];
      var $140=__ZL15cheat_byte_swapPK13_cheat_systemy(__ZL5cheat, $139$0, $139$1);
      var $140$0=$140[0];
      var $140$1=$140[1];
      var $st$23$0=(($sizemask)|0);
      var $141$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($sizemask+4)|0);
      var $141$1=HEAP32[(($st$23$1)>>2)];
      var $142$0=$140$0 & $141$0;
      var $142$1=$140$1 & $141$1;
      var $143=HEAPU8[(((__ZL5cheat+12)|0))];
      var $144=(($143)&255);
      var $145=((($144<<1))|0);
      var $146=(($145) & 255);
      var $147=__Z19core_i64_hex_formatyh($142$0, $142$1, $146);
      var $st$34$0=(($value)|0);
      var $148$0=HEAP32[(($st$34$0)>>2)];
      var $st$34$1=(($value+4)|0);
      var $148$1=HEAP32[(($st$34$1)>>2)];
      var $149=HEAPU8[(((__ZL5cheat+12)|0))];
      var $150=(($149)&255);
      var $151=((($150<<1))|0);
      var $152=(($151) & 255);
      var $153=__Z19core_i64_hex_formatyh($148$0, $148$1, $152);
      __Z20debug_console_printfR15running_machinePKcz($128, ((STRING_TABLE.__str1555653)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$133,HEAP32[((tempInt+4)>>2)]=$147,HEAP32[((tempInt+8)>>2)]=$153,tempInt));
      __label__ = 23; break;
    case 23: // $154
      __label__ = 24; break;
    case 24: // $155
      __label__ = 25; break;
    case 25: // $156
      var $st$0$0=(($cheatindex)|0);
      var $157$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $157$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$6$0=1;
      var $$emscripten$temp$6$1=0;
      var $158$0 = ((($157$0)>>>0)+((($157$1)|0)*4294967296))+((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))>>>0; var $158$1 = Math.min(Math.floor((((($157$0)>>>0)+((($157$1)|0)*4294967296))+((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($cheatindex)|0);
      HEAP32[(($st$7$0)>>2)]=$158$0;
      var $st$7$1=(($cheatindex+4)|0);
      HEAP32[(($st$7$1)>>2)]=$158$1;
      __label__ = 18; break;
    case 26: // $159
      var $160=$3;
      var $161=(($160)|0) > 0;
      if ($161) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $162
      var $163=$f;
      var $164=_fclose($163);
      __label__ = 28; break;
    case 28: // $165
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17execute_cheatlistR15running_machineiiPPKc["X"]=1;

function __ZL17execute_cheatundoR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cheatindex=__stackBase__;
      var $undo_count;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $undo_count=0;
      var $5=HEAPU8[(((__ZL5cheat+20)|0))];
      var $6=(($5)&255);
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $8
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($cheatindex)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($cheatindex+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $9
      var $st$0$0=(($cheatindex)|0);
      var $10$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $10$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1=((__ZL5cheat+4)|0);
      var $st$5$0=(($$emscripten$temp$1)|0);
      var $11$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($$emscripten$temp$1+4)|0);
      var $11$1=HEAP32[(($st$5$1)>>2)];
      var $12=$10$1 < $11$1 || ($10$1 == $11$1 && $10$0 < $11$0);
      if ($12) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $13
      var $st$0$0=(($cheatindex)|0);
      var $14$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $14$1=HEAP32[(($st$0$1)>>2)];
      var $15$0=$14$0;
      var $15=$15$0;
      var $16=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $17=(($16+$15*28)|0);
      var $18=$17;
      var $19=(($18+24)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255) >>> 1;
      var $22=$21 & 127;
      var $23=(($22)&255);
      var $24=HEAPU8[(((__ZL5cheat+20)|0))];
      var $25=(($24)&255);
      var $26=(($23)|0)==(($25)|0);
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $st$0$0=(($cheatindex)|0);
      var $28$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $28$1=HEAP32[(($st$0$1)>>2)];
      var $29$0=$28$0;
      var $29=$29$0;
      var $30=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $31=(($30+$29*28)|0);
      var $32=$31;
      var $33=(($32+24)|0);
      var $34=HEAP8[($33)];
      var $35=$34 & -2;
      var $36=$35 | 1;
      HEAP8[($33)]=$36;
      var $st$14$0=(($cheatindex)|0);
      var $37$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($cheatindex+4)|0);
      var $37$1=HEAP32[(($st$14$1)>>2)];
      var $38$0=$37$0;
      var $38=$38$0;
      var $39=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $40=(($39+$38*28)|0);
      var $41=$40;
      var $42=(($41+24)|0);
      var $43=HEAP8[($42)];
      var $44=$43 & 1;
      HEAP8[($42)]=$44;
      var $45=$undo_count;
      var $46=(($45+1)|0);
      $undo_count=$46;
      __label__ = 5; break;
    case 5: // $47
      __label__ = 6; break;
    case 6: // $48
      var $st$0$0=(($cheatindex)|0);
      var $49$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cheatindex+4)|0);
      var $49$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $50$0 = ((($49$0)>>>0)+((($49$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $50$1 = Math.min(Math.floor((((($49$0)>>>0)+((($49$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($cheatindex)|0);
      HEAP32[(($st$7$0)>>2)]=$50$0;
      var $st$7$1=(($cheatindex+4)|0);
      HEAP32[(($st$7$1)>>2)]=$50$1;
      __label__ = 2; break;
    case 7: // $51
      var $52=HEAP8[(((__ZL5cheat+20)|0))];
      var $53=(($52-1)&255);
      HEAP8[(((__ZL5cheat+20)|0))]=$53;
      var $54=$1;
      var $55=$undo_count;
      __Z20debug_console_printfR15running_machinePKcz($54, ((STRING_TABLE.__str1485646)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,tempInt));
      __label__ = 9; break;
    case 8: // $56
      var $57=$1;
      __Z20debug_console_printfR15running_machinePKcz($57, ((STRING_TABLE.__str1495647)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $58
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17execute_cheatundoR15running_machineiiPPKc["X"]=1;

function __ZL12execute_findR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 2348; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset=__stackBase__;
      var $endoffset=__stackBase__+8;
      var $length=__stackBase__+16;
      var $space=__stackBase__+24;
      var $data_to_find=__stackBase__+28;
      var $data_size=__stackBase__+2076;
      var $cur_data_size;
      var $data_count;
      var $found;
      var $i=__stackBase__+2332;
      var $j=__stackBase__+2340;
      var $pdata;
      var $suboffset;
      var $match;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $data_count=0;
      $found=0;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $offset);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 57; break;
    case 2: // $12
      var $13=$1;
      var $14=$4;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($13, $16, $length);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 57; break;
    case 4: // $20
      var $21=$1;
      var $22=$2;
      var $23=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($21, 0, $22, $space);
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $25
      __label__ = 57; break;
    case 6: // $26
      var $27=HEAP32[(($space)>>2)];
      var $st$1$0=(($offset)|0);
      var $28$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $28$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($length)|0);
      var $29$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($length+4)|0);
      var $29$1=HEAP32[(($st$5$1)>>2)];
      var $30$0 = ((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($29$0)>>>0)+((($29$1)|0)*4294967296))>>>0; var $30$1 = Math.min(Math.floor((((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($29$0)>>>0)+((($29$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $31$0 = ((($30$0)>>>0)+((($30$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $31$1 = Math.min(Math.floor((((($30$0)>>>0)+((($30$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $32$0=$31$0;
      var $32=$32$0;
      var $33=__ZNK13address_space15address_to_byteEj($27, $32);
      var $34=HEAP32[(($space)>>2)];
      var $35=__ZNK13address_space8bytemaskEv($34);
      var $36=$33 & $35;
      var $37$0=$36;
      var $37$1=0;
      var $st$21$0=(($endoffset)|0);
      HEAP32[(($st$21$0)>>2)]=$37$0;
      var $st$21$1=(($endoffset+4)|0);
      HEAP32[(($st$21$1)>>2)]=$37$1;
      var $38=HEAP32[(($space)>>2)];
      var $st$26$0=(($offset)|0);
      var $39$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($offset+4)|0);
      var $39$1=HEAP32[(($st$26$1)>>2)];
      var $40$0=$39$0;
      var $40=$40$0;
      var $41=__ZNK13address_space15address_to_byteEj($38, $40);
      var $42=HEAP32[(($space)>>2)];
      var $43=__ZNK13address_space8bytemaskEv($42);
      var $44=$41 & $43;
      var $45$0=$44;
      var $45$1=0;
      var $st$38$0=(($offset)|0);
      HEAP32[(($st$38$0)>>2)]=$45$0;
      var $st$38$1=(($offset+4)|0);
      HEAP32[(($st$38$1)>>2)]=$45$1;
      var $46=HEAP32[(($space)>>2)];
      var $47=__ZNK13address_space15address_to_byteEj($46, 1);
      $cur_data_size=$47;
      var $48=$cur_data_size;
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $50
      $cur_data_size=1;
      __label__ = 8; break;
    case 8: // $51
      var $$emscripten$temp$1$0=2;
      var $$emscripten$temp$1$1=0;
      var $st$2$0=(($i)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$1$0;
      var $st$2$1=(($i+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 9; break;
    case 9: // $52
      var $st$0$0=(($i)|0);
      var $53$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $53$1=HEAP32[(($st$0$1)>>2)];
      var $54=$3;
      var $55$0=$54;
      var $55$1=(($54|0) < 0 ? -1 : 0);
      var $56=$53$1 < $55$1 || ($53$1 == $55$1 && $53$0 < $55$0);
      if ($56) { __label__ = 10; break; } else { __label__ = 37; break; }
    case 10: // $57
      var $st$0$0=(($i)|0);
      var $58$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $58$1=HEAP32[(($st$0$1)>>2)];
      var $59$0=$58$0;
      var $59=$59$0;
      var $60=$4;
      var $61=(($60+($59<<2))|0);
      var $62=HEAP32[(($61)>>2)];
      $pdata=$62;
      var $63=$pdata;
      var $64=(($63)|0);
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24);
      var $67=(($66)|0)==34;
      if ($67) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $68
      var $69=$pdata;
      var $70=_strlen($69);
      var $71=(($70-1)|0);
      var $72=$pdata;
      var $73=(($72+$71)|0);
      var $74=HEAP8[($73)];
      var $75=(($74 << 24) >> 24);
      var $76=(($75)|0)==34;
      if ($76) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $77
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $st$2$0=(($j)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$2$0;
      var $st$2$1=(($j+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 13; break;
    case 13: // $78
      var $st$0$0=(($j)|0);
      var $79$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $79$1=HEAP32[(($st$0$1)>>2)];
      var $80=$pdata;
      var $81=_strlen($80);
      var $82=(($81-1)|0);
      var $83$0=$82;
      var $83$1=0;
      var $84=$79$1 < $83$1 || ($79$1 == $83$1 && $79$0 < $83$0);
      if ($84) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $85
      var $st$0$0=(($j)|0);
      var $86$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $86$1=HEAP32[(($st$0$1)>>2)];
      var $87$0=$86$0;
      var $87=$87$0;
      var $88=$pdata;
      var $89=(($88+$87)|0);
      var $90=HEAP8[($89)];
      var $91$0=$90;
      var $91$1=(($90|0) < 0 ? -1 : 0);
      var $92=$data_count;
      var $93=(($data_to_find+($92<<3))|0);
      var $st$13$0=(($93)|0);
      HEAP32[(($st$13$0)>>2)]=$91$0;
      var $st$13$1=(($93+4)|0);
      HEAP32[(($st$13$1)>>2)]=$91$1;
      var $94=$data_count;
      var $95=(($94+1)|0);
      $data_count=$95;
      var $96=(($data_size+$94)|0);
      HEAP8[($96)]=1;
      __label__ = 15; break;
    case 15: // $97
      var $st$0$0=(($j)|0);
      var $98$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $98$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=1;
      var $$emscripten$temp$3$1=0;
      var $99$0 = ((($98$0)>>>0)+((($98$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $99$1 = Math.min(Math.floor((((($98$0)>>>0)+((($98$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($j)|0);
      HEAP32[(($st$7$0)>>2)]=$99$0;
      var $st$7$1=(($j+4)|0);
      HEAP32[(($st$7$1)>>2)]=$99$1;
      __label__ = 13; break;
    case 16: // $100
      __label__ = 35; break;
    case 17: // $101
      var $102=$cur_data_size;
      var $103=(($102) & 255);
      var $104=$data_count;
      var $105=(($data_size+$104)|0);
      HEAP8[($105)]=$103;
      var $106=$pdata;
      var $107=(($106)|0);
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      var $110=_tolower($109);
      var $111=(($110)|0)==98;
      if ($111) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $112
      var $113=$pdata;
      var $114=(($113+1)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24);
      var $117=(($116)|0)==46;
      if ($117) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $118
      $cur_data_size=1;
      var $119=$data_count;
      var $120=(($data_size+$119)|0);
      HEAP8[($120)]=1;
      var $121=$pdata;
      var $122=(($121+2)|0);
      $pdata=$122;
      __label__ = 20; break;
    case 20: // $123
      var $124=$pdata;
      var $125=(($124)|0);
      var $126=HEAPU8[($125)];
      var $127=(($126)&255);
      var $128=_tolower($127);
      var $129=(($128)|0)==119;
      if ($129) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $130
      var $131=$pdata;
      var $132=(($131+1)|0);
      var $133=HEAP8[($132)];
      var $134=(($133 << 24) >> 24);
      var $135=(($134)|0)==46;
      if ($135) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $136
      $cur_data_size=2;
      var $137=$data_count;
      var $138=(($data_size+$137)|0);
      HEAP8[($138)]=2;
      var $139=$pdata;
      var $140=(($139+2)|0);
      $pdata=$140;
      __label__ = 23; break;
    case 23: // $141
      var $142=$pdata;
      var $143=(($142)|0);
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=_tolower($145);
      var $147=(($146)|0)==100;
      if ($147) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $148
      var $149=$pdata;
      var $150=(($149+1)|0);
      var $151=HEAP8[($150)];
      var $152=(($151 << 24) >> 24);
      var $153=(($152)|0)==46;
      if ($153) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $154
      $cur_data_size=4;
      var $155=$data_count;
      var $156=(($data_size+$155)|0);
      HEAP8[($156)]=4;
      var $157=$pdata;
      var $158=(($157+2)|0);
      $pdata=$158;
      __label__ = 26; break;
    case 26: // $159
      var $160=$pdata;
      var $161=(($160)|0);
      var $162=HEAPU8[($161)];
      var $163=(($162)&255);
      var $164=_tolower($163);
      var $165=(($164)|0)==113;
      if ($165) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $166
      var $167=$pdata;
      var $168=(($167+1)|0);
      var $169=HEAP8[($168)];
      var $170=(($169 << 24) >> 24);
      var $171=(($170)|0)==46;
      if ($171) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $172
      $cur_data_size=8;
      var $173=$data_count;
      var $174=(($data_size+$173)|0);
      HEAP8[($174)]=8;
      var $175=$pdata;
      var $176=(($175+2)|0);
      $pdata=$176;
      __label__ = 29; break;
    case 29: // $177
      var $178=$pdata;
      var $179=_strcmp($178, ((STRING_TABLE.__str1455643)|0));
      var $180=(($179)|0)!=0;
      if ($180) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $181
      var $182=$data_count;
      var $183=(($182+1)|0);
      $data_count=$183;
      var $184=(($data_size+$182)|0);
      var $185=HEAPU8[($184)];
      var $186=(($185)&255);
      var $187=$186 | 16;
      var $188=(($187) & 255);
      HEAP8[($184)]=$188;
      __label__ = 34; break;
    case 31: // $189
      var $190=$1;
      var $191=$pdata;
      var $192=$data_count;
      var $193=(($192+1)|0);
      $data_count=$193;
      var $194=(($data_to_find+($192<<3))|0);
      var $195=__Z30debug_command_parameter_numberR15running_machinePKcPy($190, $191, $194);
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $197
      __label__ = 57; break;
    case 33: // $198
      __label__ = 34; break;
    case 34: // $199
      __label__ = 35; break;
    case 35: // $200
      __label__ = 36; break;
    case 36: // $201
      var $st$0$0=(($i)|0);
      var $202$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $202$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$4$0=1;
      var $$emscripten$temp$4$1=0;
      var $203$0 = ((($202$0)>>>0)+((($202$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $203$1 = Math.min(Math.floor((((($202$0)>>>0)+((($202$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($i)|0);
      HEAP32[(($st$7$0)>>2)]=$203$0;
      var $st$7$1=(($i+4)|0);
      HEAP32[(($st$7$1)>>2)]=$203$1;
      __label__ = 9; break;
    case 37: // $204
      var $st$0$0=(($offset)|0);
      var $205$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($offset+4)|0);
      var $205$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($i)|0);
      HEAP32[(($st$4$0)>>2)]=$205$0;
      var $st$4$1=(($i+4)|0);
      HEAP32[(($st$4$1)>>2)]=$205$1;
      __label__ = 38; break;
    case 38: // $206
      var $st$0$0=(($i)|0);
      var $207$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($i+4)|0);
      var $207$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($endoffset)|0);
      var $208$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($endoffset+4)|0);
      var $208$1=HEAP32[(($st$4$1)>>2)];
      var $209=$207$1 <= $208$1 && ($207$1 < $208$1 || $207$0 <= $208$0);
      if ($209) { __label__ = 39; break; } else { __label__ = 55; break; }
    case 39: // $210
      $suboffset=0;
      $match=1;
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=0;
      var $st$4$0=(($j)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$5$0;
      var $st$4$1=(($j+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 40; break;
    case 40: // $211
      var $st$0$0=(($j)|0);
      var $212$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $212$1=HEAP32[(($st$0$1)>>2)];
      var $213=$data_count;
      var $214$0=$213;
      var $214$1=(($213|0) < 0 ? -1 : 0);
      var $215=$212$1 < $214$1 || ($212$1 == $214$1 && $212$0 < $214$0);
      if ($215) { __label__ = 41; break; } else { var $220 = 0;__label__ = 42; break; }
    case 41: // $216
      var $217=$match;
      var $218=(($217)|0)!=0;
      var $220 = $218;__label__ = 42; break;
    case 42: // $219
      var $220;
      if ($220) { __label__ = 43; break; } else { __label__ = 51; break; }
    case 43: // $221
      var $st$0$0=(($j)|0);
      var $222$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $222$1=HEAP32[(($st$0$1)>>2)];
      var $223$0=$222$0;
      var $223=$223$0;
      var $224=(($data_size+$223)|0);
      var $225=HEAPU8[($224)];
      var $226=(($225)&255);
      if ($226 == 1) {
        __label__ = 44; break;
      }
      else if ($226 == 2) {
        __label__ = 45; break;
      }
      else if ($226 == 4) {
        __label__ = 46; break;
      }
      else if ($226 == 8) {
        __label__ = 47; break;
      }
      else {
      __label__ = 48; break;
      }
      
    case 44: // $227
      var $228=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $229$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $229$1=HEAP32[(($st$1$1)>>2)];
      var $230=$suboffset;
      var $231$0=$230;
      var $231$1=(($230|0) < 0 ? -1 : 0);
      var $232$0 = ((($229$0)>>>0)+((($229$1)|0)*4294967296))+((($231$0)>>>0)+((($231$1)|0)*4294967296))>>>0; var $232$1 = Math.min(Math.floor((((($229$0)>>>0)+((($229$1)|0)*4294967296))+((($231$0)>>>0)+((($231$1)|0)*4294967296)))/4294967296), 4294967295);
      var $233$0=$232$0;
      var $233=$233$0;
      var $234=__Z15debug_read_byteP13address_spaceji($228, $233, 1);
      var $235=(($234)&255);
      var $st$13$0=(($j)|0);
      var $236$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($j+4)|0);
      var $236$1=HEAP32[(($st$13$1)>>2)];
      var $237$0=$236$0;
      var $237=$237$0;
      var $238=(($data_to_find+($237<<3))|0);
      var $st$20$0=(($238)|0);
      var $239$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($238+4)|0);
      var $239$1=HEAP32[(($st$20$1)>>2)];
      var $240$0=$239$0;
      var $240=$240$0&255;
      var $241=(($240)&255);
      var $242=(($235)|0)==(($241)|0);
      var $243=(($242)&1);
      $match=$243;
      __label__ = 49; break;
    case 45: // $244
      var $245=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $246$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $246$1=HEAP32[(($st$1$1)>>2)];
      var $247=$suboffset;
      var $248$0=$247;
      var $248$1=(($247|0) < 0 ? -1 : 0);
      var $249$0 = ((($246$0)>>>0)+((($246$1)|0)*4294967296))+((($248$0)>>>0)+((($248$1)|0)*4294967296))>>>0; var $249$1 = Math.min(Math.floor((((($246$0)>>>0)+((($246$1)|0)*4294967296))+((($248$0)>>>0)+((($248$1)|0)*4294967296)))/4294967296), 4294967295);
      var $250$0=$249$0;
      var $250=$250$0;
      var $251=__Z15debug_read_wordP13address_spaceji($245, $250, 1);
      var $252=(($251)&65535);
      var $st$13$0=(($j)|0);
      var $253$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($j+4)|0);
      var $253$1=HEAP32[(($st$13$1)>>2)];
      var $254$0=$253$0;
      var $254=$254$0;
      var $255=(($data_to_find+($254<<3))|0);
      var $st$20$0=(($255)|0);
      var $256$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($255+4)|0);
      var $256$1=HEAP32[(($st$20$1)>>2)];
      var $257$0=$256$0;
      var $257=$257$0&65535;
      var $258=(($257)&65535);
      var $259=(($252)|0)==(($258)|0);
      var $260=(($259)&1);
      $match=$260;
      __label__ = 49; break;
    case 46: // $261
      var $262=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $263$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $263$1=HEAP32[(($st$1$1)>>2)];
      var $264=$suboffset;
      var $265$0=$264;
      var $265$1=(($264|0) < 0 ? -1 : 0);
      var $266$0 = ((($263$0)>>>0)+((($263$1)|0)*4294967296))+((($265$0)>>>0)+((($265$1)|0)*4294967296))>>>0; var $266$1 = Math.min(Math.floor((((($263$0)>>>0)+((($263$1)|0)*4294967296))+((($265$0)>>>0)+((($265$1)|0)*4294967296)))/4294967296), 4294967295);
      var $267$0=$266$0;
      var $267=$267$0;
      var $268=__Z16debug_read_dwordP13address_spaceji($262, $267, 1);
      var $st$12$0=(($j)|0);
      var $269$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($j+4)|0);
      var $269$1=HEAP32[(($st$12$1)>>2)];
      var $270$0=$269$0;
      var $270=$270$0;
      var $271=(($data_to_find+($270<<3))|0);
      var $st$19$0=(($271)|0);
      var $272$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($271+4)|0);
      var $272$1=HEAP32[(($st$19$1)>>2)];
      var $273$0=$272$0;
      var $273=$273$0;
      var $274=(($268)|0)==(($273)|0);
      var $275=(($274)&1);
      $match=$275;
      __label__ = 49; break;
    case 47: // $276
      var $277=HEAP32[(($space)>>2)];
      var $st$1$0=(($i)|0);
      var $278$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($i+4)|0);
      var $278$1=HEAP32[(($st$1$1)>>2)];
      var $279=$suboffset;
      var $280$0=$279;
      var $280$1=(($279|0) < 0 ? -1 : 0);
      var $281$0 = ((($278$0)>>>0)+((($278$1)|0)*4294967296))+((($280$0)>>>0)+((($280$1)|0)*4294967296))>>>0; var $281$1 = Math.min(Math.floor((((($278$0)>>>0)+((($278$1)|0)*4294967296))+((($280$0)>>>0)+((($280$1)|0)*4294967296)))/4294967296), 4294967295);
      var $282$0=$281$0;
      var $282=$282$0;
      var $283=__Z16debug_read_qwordP13address_spaceji($277, $282, 1);
      var $283$0=$283[0];
      var $283$1=$283[1];
      var $st$14$0=(($j)|0);
      var $284$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($j+4)|0);
      var $284$1=HEAP32[(($st$14$1)>>2)];
      var $285$0=$284$0;
      var $285=$285$0;
      var $286=(($data_to_find+($285<<3))|0);
      var $st$21$0=(($286)|0);
      var $287$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($286+4)|0);
      var $287$1=HEAP32[(($st$21$1)>>2)];
      var $288=$283$0 == $287$0 && $283$1 == $287$1;
      var $289=(($288)&1);
      $match=$289;
      __label__ = 49; break;
    case 48: // $290
      __label__ = 49; break;
    case 49: // $291
      var $st$0$0=(($j)|0);
      var $292$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $292$1=HEAP32[(($st$0$1)>>2)];
      var $293$0=$292$0;
      var $293=$293$0;
      var $294=(($data_size+$293)|0);
      var $295=HEAPU8[($294)];
      var $296=(($295)&255);
      var $297=$296 & 15;
      var $298=$suboffset;
      var $299=(($298+$297)|0);
      $suboffset=$299;
      __label__ = 50; break;
    case 50: // $300
      var $st$0$0=(($j)|0);
      var $301$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($j+4)|0);
      var $301$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$6$0=1;
      var $$emscripten$temp$6$1=0;
      var $302$0 = ((($301$0)>>>0)+((($301$1)|0)*4294967296))+((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296))>>>0; var $302$1 = Math.min(Math.floor((((($301$0)>>>0)+((($301$1)|0)*4294967296))+((($$emscripten$temp$6$0)>>>0)+((($$emscripten$temp$6$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($j)|0);
      HEAP32[(($st$7$0)>>2)]=$302$0;
      var $st$7$1=(($j+4)|0);
      HEAP32[(($st$7$1)>>2)]=$302$1;
      __label__ = 40; break;
    case 51: // $303
      var $304=$match;
      var $305=(($304)|0)!=0;
      if ($305) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $306
      var $307=$found;
      var $308=(($307+1)|0);
      $found=$308;
      var $309=$1;
      var $310=HEAP32[(($space)>>2)];
      var $st$5$0=(($i)|0);
      var $311$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($i+4)|0);
      var $311$1=HEAP32[(($st$5$1)>>2)];
      var $312$0=$311$0;
      var $312=$312$0;
      var $313=__ZNK13address_space15byte_to_addressEj($310, $312);
      var $314$0=$313;
      var $314$1=0;
      var $315=HEAP32[(($space)>>2)];
      var $316=__ZNK13address_space9addrcharsEv($315);
      var $317=__Z19core_i64_hex_formatyh($314$0, $314$1, $316);
      __Z20debug_console_printfR15running_machinePKcz($309, ((STRING_TABLE.__str1465644)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$317,tempInt));
      __label__ = 53; break;
    case 53: // $318
      __label__ = 54; break;
    case 54: // $319
      var $320=(($data_size)|0);
      var $321=HEAP8[($320)];
      var $322$0=$321;
      var $322$1=0;
      var $st$4$0=(($i)|0);
      var $323$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($i+4)|0);
      var $323$1=HEAP32[(($st$4$1)>>2)];
      var $324$0 = ((($323$0)>>>0)+((($323$1)|0)*4294967296))+((($322$0)>>>0)+((($322$1)|0)*4294967296))>>>0; var $324$1 = Math.min(Math.floor((((($323$0)>>>0)+((($323$1)|0)*4294967296))+((($322$0)>>>0)+((($322$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($i)|0);
      HEAP32[(($st$9$0)>>2)]=$324$0;
      var $st$9$1=(($i+4)|0);
      HEAP32[(($st$9$1)>>2)]=$324$1;
      __label__ = 38; break;
    case 55: // $325
      var $326=$found;
      var $327=(($326)|0)==0;
      if ($327) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $328
      var $329=$1;
      __Z20debug_console_printfR15running_machinePKcz($329, ((STRING_TABLE.__str1475645)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 57; break;
    case 57: // $330
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12execute_findR15running_machineiiPPKc["X"]=1;

function __ZL12execute_dasmR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 872; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset=__stackBase__;
      var $length=__stackBase__+8;
      var $bytes=__stackBase__+16;
      var $minbytes;
      var $maxbytes;
      var $byteswidth;
      var $space=__stackBase__+24;
      var $f;
      var $i;
      var $j;
      var $cpudevice;
      var $pcbyte;
      var $output=__stackBase__+28;
      var $disasm=__stackBase__+540;
      var $comment;
      var $tempaddr=__stackBase__+740;
      var $outdex;
      var $numbytes;
      var $opbuf=__stackBase__+744;
      var $argbuf=__stackBase__+808;
      var $startdex;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$31$0=(($bytes)|0);
      HEAP32[(($st$31$0)>>2)]=$$emscripten$temp$0$0;
      var $st$31$1=(($bytes+4)|0);
      HEAP32[(($st$31$1)>>2)]=$$emscripten$temp$0$1;
      $f=0;
      var $5=$1;
      var $6=$4;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $offset);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 42; break;
    case 2: // $12
      var $13=$1;
      var $14=$4;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z30debug_command_parameter_numberR15running_machinePKcPy($13, $16, $length);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      __label__ = 42; break;
    case 4: // $20
      var $21=$1;
      var $22=$4;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__Z30debug_command_parameter_numberR15running_machinePKcPy($21, $24, $bytes);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $27
      __label__ = 42; break;
    case 6: // $28
      var $29=$1;
      var $30=$3;
      var $31=(($30)|0) > 4;
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      var $33=$4;
      var $34=(($33+16)|0);
      var $35=HEAP32[(($34)>>2)];
      var $38 = $35;__label__ = 9; break;
    case 8: // $36
      var $38 = 0;__label__ = 9; break;
    case 9: // $37
      var $38;
      var $39=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($29, $38, 0, $space);
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $41
      __label__ = 42; break;
    case 11: // $42
      var $43=HEAP32[(($space)>>2)];
      var $44=__ZNK13address_space6deviceEv($43);
      var $45=__Z8downcastIP10cpu_device8device_tET_PT0_($44);
      $cpudevice=$45;
      var $46=$cpudevice;
      var $47=$46;
      var $48=(($47+7088)|0);
      var $49=$48;
      var $50=__ZNK23device_disasm_interface16min_opcode_bytesEv($49);
      $minbytes=$50;
      var $51=$cpudevice;
      var $52=$51;
      var $53=(($52+7088)|0);
      var $54=$53;
      var $55=__ZNK23device_disasm_interface16max_opcode_bytesEv($54);
      $maxbytes=$55;
      $byteswidth=0;
      var $st$17$0=(($bytes)|0);
      var $56$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($bytes+4)|0);
      var $56$1=HEAP32[(($st$17$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $57=$56$0 != $$emscripten$temp$1$0 || $56$1 != $$emscripten$temp$1$1;
      if ($57) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $58
      var $59=$maxbytes;
      var $60=$minbytes;
      var $61=(($60-1)|0);
      var $62=(($59+$61)|0);
      var $63=$minbytes;
      var $64=(((($62)|0)/(($63)|0))|0);
      $byteswidth=$64;
      var $65=$minbytes;
      var $66=((($65<<1))|0);
      var $67=(($66+1)|0);
      var $68=$byteswidth;
      var $69=(($68*$67)|0);
      $byteswidth=$69;
      __label__ = 13; break;
    case 13: // $70
      var $71=$4;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=_fopen($73, ((STRING_TABLE.__str1185616)|0));
      $f=$74;
      var $75=$f;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $77
      var $78=$1;
      var $79=$4;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($78, ((STRING_TABLE.__str1325630)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,tempInt));
      __label__ = 42; break;
    case 15: // $82
      $i=0;
      __label__ = 16; break;
    case 16: // $83
      var $84=$i;
      var $85$0=$84;
      var $85$1=(($84|0) < 0 ? -1 : 0);
      var $st$3$0=(($length)|0);
      var $86$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($length+4)|0);
      var $86$1=HEAP32[(($st$3$1)>>2)];
      var $87=$85$1 < $86$1 || ($85$1 == $86$1 && $85$0 < $86$0);
      if ($87) { __label__ = 17; break; } else { __label__ = 41; break; }
    case 17: // $88
      var $89=HEAP32[(($space)>>2)];
      var $st$1$0=(($offset)|0);
      var $90$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $90$1=HEAP32[(($st$1$1)>>2)];
      var $91=$i;
      var $92$0=$91;
      var $92$1=(($91|0) < 0 ? -1 : 0);
      var $93$0 = ((($90$0)>>>0)+((($90$1)|0)*4294967296))+((($92$0)>>>0)+((($92$1)|0)*4294967296))>>>0; var $93$1 = Math.min(Math.floor((((($90$0)>>>0)+((($90$1)|0)*4294967296))+((($92$0)>>>0)+((($92$1)|0)*4294967296)))/4294967296), 4294967295);
      var $94$0=$93$0;
      var $94=$94$0;
      var $95=__ZNK13address_space15address_to_byteEj($89, $94);
      var $96=HEAP32[(($space)>>2)];
      var $97=__ZNK13address_space8bytemaskEv($96);
      var $98=$95 & $97;
      $pcbyte=$98;
      $outdex=0;
      $numbytes=0;
      var $99=$outdex;
      var $100=(($output+$99)|0);
      var $101=HEAP32[(($space)>>2)];
      var $102=$pcbyte;
      var $103=__ZNK13address_space15byte_to_addressEj($101, $102);
      var $104$0=$103;
      var $104$1=0;
      var $105=HEAP32[(($space)>>2)];
      var $106=__ZNK13address_space12logaddrcharsEv($105);
      var $107=__Z19core_i64_hex_formatyh($104$0, $104$1, $106);
      var $108=_sprintf($100, ((STRING_TABLE.__str1375635)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$107,tempInt));
      var $109=$outdex;
      var $110=(($109+$108)|0);
      $outdex=$110;
      var $111=$pcbyte;
      HEAP32[(($tempaddr)>>2)]=$111;
      var $112=HEAP32[(($space)>>2)];
      var $113=__Z19debug_cpu_translateP13address_spaceiPj($112, 10, $tempaddr);
      var $114=(($113)|0)!=0;
      if ($114) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $115
      $numbytes=0;
      __label__ = 19; break;
    case 19: // $116
      var $117=$numbytes;
      var $118=$maxbytes;
      var $119=(($117)|0) < (($118)|0);
      if ($119) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $120
      var $121=HEAP32[(($space)>>2)];
      var $122=$pcbyte;
      var $123=$numbytes;
      var $124=(($122+$123)|0);
      var $125=__Z17debug_read_opcodeP13address_spacejii($121, $124, 1, 0);
      var $125$0=$125[0];
      var $125$1=$125[1];
      var $126$0=$125$0;
      var $126=$126$0&255;
      var $127=$numbytes;
      var $128=(($opbuf+$127)|0);
      HEAP8[($128)]=$126;
      var $129=HEAP32[(($space)>>2)];
      var $130=$pcbyte;
      var $131=$numbytes;
      var $132=(($130+$131)|0);
      var $133=__Z17debug_read_opcodeP13address_spacejii($129, $132, 1, 1);
      var $133$0=$133[0];
      var $133$1=$133[1];
      var $134$0=$133$0;
      var $134=$134$0&255;
      var $135=$numbytes;
      var $136=(($argbuf+$135)|0);
      HEAP8[($136)]=$134;
      __label__ = 21; break;
    case 21: // $137
      var $138=$numbytes;
      var $139=(($138+1)|0);
      $numbytes=$139;
      __label__ = 19; break;
    case 22: // $140
      var $141=HEAP32[(($space)>>2)];
      var $142=__ZNK13address_space6deviceEv($141);
      var $143=__ZNK8device_t5debugEv($142);
      var $144=(($disasm)|0);
      var $st$4$0=(($offset)|0);
      var $145$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($offset+4)|0);
      var $145$1=HEAP32[(($st$4$1)>>2)];
      var $146=$i;
      var $147$0=$146;
      var $147$1=(($146|0) < 0 ? -1 : 0);
      var $148$0 = ((($145$0)>>>0)+((($145$1)|0)*4294967296))+((($147$0)>>>0)+((($147$1)|0)*4294967296))>>>0; var $148$1 = Math.min(Math.floor((((($145$0)>>>0)+((($145$1)|0)*4294967296))+((($147$0)>>>0)+((($147$1)|0)*4294967296)))/4294967296), 4294967295);
      var $149$0=$148$0;
      var $149=$149$0;
      var $150=(($opbuf)|0);
      var $151=(($argbuf)|0);
      var $152=__ZNK12device_debug11disassembleEPcjPKhS2_($143, $144, $149, $150, $151);
      var $153=$152 & 65535;
      $numbytes=$153;
      var $154=$i;
      var $155=(($154+$153)|0);
      $i=$155;
      __label__ = 23; break;
    case 23: // $156
      var $st$0$0=(($bytes)|0);
      var $157$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($bytes+4)|0);
      var $157$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $158=$157$0 != $$emscripten$temp$2$0 || $157$1 != $$emscripten$temp$2$1;
      if ($158) { __label__ = 24; break; } else { __label__ = 31; break; }
    case 24: // $159
      var $160=$outdex;
      $startdex=$160;
      var $161=HEAP32[(($space)>>2)];
      var $162=$numbytes;
      var $163=__ZNK13address_space15address_to_byteEj($161, $162);
      $numbytes=$163;
      $j=0;
      __label__ = 25; break;
    case 25: // $164
      var $165=$j;
      var $166=$numbytes;
      var $167=(($165)|0) < (($166)|0);
      if ($167) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $168
      var $169=$outdex;
      var $170=(($output+$169)|0);
      var $171=HEAP32[(($space)>>2)];
      var $172=$pcbyte;
      var $173=$j;
      var $174=(($172+$173)|0);
      var $175=$minbytes;
      var $176=__Z17debug_read_opcodeP13address_spacejii($171, $174, $175, 0);
      var $176$0=$176[0];
      var $176$1=$176[1];
      var $177=$minbytes;
      var $178=((($177<<1))|0);
      var $179=(($178) & 255);
      var $180=__Z19core_i64_hex_formatyh($176$0, $176$1, $179);
      var $181=_sprintf($170, ((STRING_TABLE.__str1385636)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$180,tempInt));
      var $182=$outdex;
      var $183=(($182+$181)|0);
      $outdex=$183;
      __label__ = 27; break;
    case 27: // $184
      var $185=$minbytes;
      var $186=$j;
      var $187=(($186+$185)|0);
      $j=$187;
      __label__ = 25; break;
    case 28: // $188
      var $189=$outdex;
      var $190=$startdex;
      var $191=(($189-$190)|0);
      var $192=$byteswidth;
      var $193=(($191)|0) < (($192)|0);
      if ($193) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $194
      var $195=$outdex;
      var $196=(($output+$195)|0);
      var $197=$byteswidth;
      var $198=$outdex;
      var $199=$startdex;
      var $200=(($198-$199)|0);
      var $201=(($197-$200)|0);
      var $202=_sprintf($196, ((STRING_TABLE.__str1395637)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$201,HEAP32[((tempInt+4)>>2)]=((__str985596)|0),tempInt));
      var $203=$outdex;
      var $204=(($203+$202)|0);
      $outdex=$204;
      __label__ = 30; break;
    case 30: // $205
      var $206=$outdex;
      var $207=(($output+$206)|0);
      var $208=_sprintf($207, ((STRING_TABLE.__str1405638)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $209=$outdex;
      var $210=(($209+$208)|0);
      $outdex=$210;
      __label__ = 31; break;
    case 31: // $211
      var $212=$outdex;
      var $213=(($output+$212)|0);
      var $214=(($disasm)|0);
      var $215=_sprintf($213, ((STRING_TABLE.__str1415639)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$214,tempInt));
      var $216=HEAP32[(($space)>>2)];
      var $217=__ZNK13address_space6deviceEv($216);
      var $218=__ZNK8device_t5debugEv($217);
      var $219=HEAP32[(($tempaddr)>>2)];
      var $220=__ZNK12device_debug12comment_textEj($218, $219);
      $comment=$220;
      var $221=$comment;
      var $222=(($221)|0)!=0;
      if ($222) { __label__ = 32; break; } else { __label__ = 40; break; }
    case 32: // $223
      var $224=(($output)|0);
      var $225=_strlen($224);
      var $226=(($225)>>>0) < 60;
      if ($226) { __label__ = 33; break; } else { __label__ = 38; break; }
    case 33: // $227
      var $228=(($output)|0);
      var $229=_strlen($228);
      $outdex=$229;
      __label__ = 34; break;
    case 34: // $230
      var $231=$outdex;
      var $232=(($231)|0) < 60;
      if ($232) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $233
      var $234=$outdex;
      var $235=(($output+$234)|0);
      HEAP8[($235)]=32;
      __label__ = 36; break;
    case 36: // $236
      var $237=$outdex;
      var $238=(($237+1)|0);
      $outdex=$238;
      __label__ = 34; break;
    case 37: // $239
      var $240=$outdex;
      var $241=(($output+$240)|0);
      HEAP8[($241)]=0;
      var $242=(($output)|0);
      var $243=_strlen($242);
      var $244=(($output+$243)|0);
      var $245=$comment;
      var $246=_sprintf($244, ((STRING_TABLE.__str1425640)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$245,tempInt));
      __label__ = 39; break;
    case 38: // $247
      var $248=(($output)|0);
      var $249=_strlen($248);
      var $250=(($output+$249)|0);
      var $251=$comment;
      var $252=_sprintf($250, ((STRING_TABLE.__str1435641)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$251,tempInt));
      __label__ = 39; break;
    case 39: // $253
      __label__ = 40; break;
    case 40: // $254
      var $255=$f;
      var $256=(($output)|0);
      var $257=_fprintf($255, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$256,tempInt));
      __label__ = 16; break;
    case 41: // $258
      var $259=$f;
      var $260=_fclose($259);
      var $261=$1;
      __Z20debug_console_printfR15running_machinePKcz($261, ((STRING_TABLE.__str1445642)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 42; break;
    case 42: // $262
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12execute_dasmR15running_machineiiPPKc["X"]=1;

function __ZL13execute_traceR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZL22execute_trace_internalR15running_machineiiPPKci($5, $6, $7, $8, 0);
  ;
  return;
}


function __ZL17execute_traceoverR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZL22execute_trace_internalR15running_machineiiPPKci($5, $6, $7, $8, 1);
  ;
  return;
}


function __ZL18execute_traceflushR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  __Z22debug_cpu_flush_tracesR15running_machine($5);
  ;
  return;
}


function __ZL15execute_historyR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 340; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $space=__stackBase__;
      var $count=__stackBase__+4;
      var $debug;
      var $maxbytes;
      var $index;
      var $pc;
      var $pcbyte;
      var $opbuf=__stackBase__+12;
      var $argbuf=__stackBase__+76;
      var $numbytes;
      var $buffer=__stackBase__+140;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$3;
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      var $15=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($5, $14, 0, $space);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $17
      __label__ = 17; break;
    case 5: // $18
      var $$emscripten$temp$0$0=256;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($count)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($count+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      var $19=$1;
      var $20=$4;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__Z30debug_command_parameter_numberR15running_machinePKcPy($19, $22, $count);
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $25
      __label__ = 17; break;
    case 7: // $26
      var $st$0$0=(($count)|0);
      var $27$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($count+4)|0);
      var $27$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=256;
      var $$emscripten$temp$1$1=0;
      var $28=$27$1 > $$emscripten$temp$1$1 || ($27$1 == $$emscripten$temp$1$1 && $27$0 > $$emscripten$temp$1$0);
      if ($28) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $29
      var $$emscripten$temp$2$0=256;
      var $$emscripten$temp$2$1=0;
      var $st$2$0=(($count)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$2$0;
      var $st$2$1=(($count+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$2$1;
      __label__ = 9; break;
    case 9: // $30
      var $31=HEAP32[(($space)>>2)];
      var $32=__ZNK13address_space6deviceEv($31);
      var $33=__ZNK8device_t5debugEv($32);
      $debug=$33;
      var $34=$debug;
      var $35=__ZNK12device_debug16max_opcode_bytesEv($34);
      $maxbytes=$35;
      $index=0;
      __label__ = 10; break;
    case 10: // $36
      var $37=$index;
      var $38$0=$37;
      var $38$1=(($37|0) < 0 ? -1 : 0);
      var $st$3$0=(($count)|0);
      var $39$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($count+4)|0);
      var $39$1=HEAP32[(($st$3$1)>>2)];
      var $40=$38$1 < $39$1 || ($38$1 == $39$1 && $38$0 < $39$0);
      if ($40) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $41
      var $42=$debug;
      var $43=$index;
      var $44=(((-$43))|0);
      var $45=__ZNK12device_debug10history_pcEi($42, $44);
      $pc=$45;
      var $46=HEAP32[(($space)>>2)];
      var $47=$pc;
      var $48=__ZNK13address_space15address_to_byteEj($46, $47);
      var $49=HEAP32[(($space)>>2)];
      var $50=__ZNK13address_space8bytemaskEv($49);
      var $51=$48 & $50;
      $pcbyte=$51;
      $numbytes=0;
      __label__ = 12; break;
    case 12: // $52
      var $53=$numbytes;
      var $54=$maxbytes;
      var $55=(($53)|0) < (($54)|0);
      if ($55) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $56
      var $57=HEAP32[(($space)>>2)];
      var $58=$pcbyte;
      var $59=$numbytes;
      var $60=(($58+$59)|0);
      var $61=__Z17debug_read_opcodeP13address_spacejii($57, $60, 1, 0);
      var $61$0=$61[0];
      var $61$1=$61[1];
      var $62$0=$61$0;
      var $62=$62$0&255;
      var $63=$numbytes;
      var $64=(($opbuf+$63)|0);
      HEAP8[($64)]=$62;
      var $65=HEAP32[(($space)>>2)];
      var $66=$pcbyte;
      var $67=$numbytes;
      var $68=(($66+$67)|0);
      var $69=__Z17debug_read_opcodeP13address_spacejii($65, $68, 1, 1);
      var $69$0=$69[0];
      var $69$1=$69[1];
      var $70$0=$69$0;
      var $70=$70$0&255;
      var $71=$numbytes;
      var $72=(($argbuf+$71)|0);
      HEAP8[($72)]=$70;
      __label__ = 14; break;
    case 14: // $73
      var $74=$numbytes;
      var $75=(($74+1)|0);
      $numbytes=$75;
      __label__ = 12; break;
    case 15: // $76
      var $77=$debug;
      var $78=(($buffer)|0);
      var $79=$pc;
      var $80=(($opbuf)|0);
      var $81=(($argbuf)|0);
      var $82=__ZNK12device_debug11disassembleEPcjPKhS2_($77, $78, $79, $80, $81);
      var $83=$1;
      var $84=$pc;
      var $85$0=$84;
      var $85$1=0;
      var $86=HEAP32[(($space)>>2)];
      var $87=__ZNK13address_space12logaddrcharsEv($86);
      var $88=__Z19core_i64_hex_formatyh($85$0, $85$1, $87);
      var $89=(($buffer)|0);
      __Z20debug_console_printfR15running_machinePKcz($83, ((STRING_TABLE.__str1085606)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$88,HEAP32[((tempInt+4)>>2)]=$89,tempInt));
      __label__ = 16; break;
    case 16: // $90
      var $91=$index;
      var $92=(($91+1)|0);
      $index=$92;
      __label__ = 10; break;
    case 17: // $93
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_historyR15running_machineiiPPKc["X"]=1;

function __ZL14execute_sourceR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  var $6=$4;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  __Z23debug_cpu_source_scriptR15running_machinePKc($5, $8);
  ;
  return;
}


function __ZL11execute_mapR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $space=__stackBase__;
      var $taddress=__stackBase__+4;
      var $address=__stackBase__+8;
      var $intention;
      var $mapname;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$1;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z30debug_command_parameter_numberR15running_machinePKcPy($5, $8, $address);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      __label__ = 11; break;
    case 2: // $12
      var $13=$1;
      var $14=$2;
      var $15=__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($13, 0, $14, $space);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $17
      __label__ = 11; break;
    case 4: // $18
      $intention=8;
      __label__ = 5; break;
    case 5: // $19
      var $20=$intention;
      var $21=(($20)|0) <= 10;
      if ($21) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $22
      var $23=HEAP32[(($space)>>2)];
      var $st$1$0=(($address)|0);
      var $24$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($address+4)|0);
      var $24$1=HEAP32[(($st$1$1)>>2)];
      var $25$0=$24$0;
      var $25=$25$0;
      var $26=__ZNK13address_space15address_to_byteEj($23, $25);
      var $27=HEAP32[(($space)>>2)];
      var $28=__ZNK13address_space8bytemaskEv($27);
      var $29=$26 & $28;
      HEAP32[(($taddress)>>2)]=$29;
      var $30=HEAP32[(($space)>>2)];
      var $31=$intention;
      var $32=__Z19debug_cpu_translateP13address_spaceiPj($30, $31, $taddress);
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=HEAP32[(($space)>>2)];
      var $36=$intention;
      var $37=(($36)|0)==9;
      var $38=$37 ? 2 : 1;
      var $39=HEAP32[(($taddress)>>2)];
      var $40=__ZN13address_space18get_handler_stringE13read_or_writej($35, $38, $39);
      $mapname=$40;
      var $41=$1;
      var $42=$intention;
      var $43=$42 & 3;
      var $44=((__ZZL11execute_mapR15running_machineiiPPKcE8intnames+($43<<2))|0);
      var $45=HEAP32[(($44)>>2)];
      var $st$12$0=(($address)|0);
      var $46$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($address+4)|0);
      var $46$1=HEAP32[(($st$12$1)>>2)];
      var $47=HEAP32[(($space)>>2)];
      var $48=__ZNK13address_space12logaddrcharsEv($47);
      var $49=__Z19core_i64_hex_formatyh($46$0, $46$1, $48);
      var $50=HEAP32[(($space)>>2)];
      var $51=HEAP32[(($taddress)>>2)];
      var $52=__ZNK13address_space15byte_to_addressEj($50, $51);
      var $53$0=$52;
      var $53$1=0;
      var $54=HEAP32[(($space)>>2)];
      var $55=__ZNK13address_space9addrcharsEv($54);
      var $56=__Z19core_i64_hex_formatyh($53$0, $53$1, $55);
      var $57=$mapname;
      __Z20debug_console_printfR15running_machinePKcz($41, ((STRING_TABLE.__str1225620)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,HEAP32[((tempInt+4)>>2)]=$49,HEAP32[((tempInt+8)>>2)]=$56,HEAP32[((tempInt+12)>>2)]=$57,tempInt));
      __label__ = 9; break;
    case 8: // $58
      var $59=$1;
      var $60=$intention;
      var $61=$60 & 3;
      var $62=((__ZZL11execute_mapR15running_machineiiPPKcE8intnames+($61<<2))|0);
      var $63=HEAP32[(($62)>>2)];
      var $st$5$0=(($address)|0);
      var $64$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($address+4)|0);
      var $64$1=HEAP32[(($st$5$1)>>2)];
      var $65=HEAP32[(($space)>>2)];
      var $66=__ZNK13address_space12logaddrcharsEv($65);
      var $67=__Z19core_i64_hex_formatyh($64$0, $64$1, $66);
      __Z20debug_console_printfR15running_machinePKcz($59, ((STRING_TABLE.__str1235621)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,HEAP32[((tempInt+4)>>2)]=$67,tempInt));
      __label__ = 9; break;
    case 9: // $68
      __label__ = 10; break;
    case 10: // $69
      var $70=$intention;
      var $71=(($70+1)|0);
      $intention=$71;
      __label__ = 5; break;
    case 11: // $72
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11execute_mapR15running_machineiiPPKc["X"]=1;

function __ZL12execute_snapR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 324; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $filename;
      var $scrnum;
      var $screen;
      var $fname=__stackBase__;
      var $5;
      var $6;
      var $file=__stackBase__+64;
      var $filerr;
      var $7;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$1;
      var $12=__ZNK15running_machine5videoEv($11);
      __ZN13video_manager28save_active_screen_snapshotsEv($12);
      var $13=$1;
      __Z20debug_console_printfR15running_machinePKcz($13, ((STRING_TABLE.__str1245622)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 33; break;
    case 2: // $14
      var $15=$4;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      $filename=$17;
      var $18=$3;
      var $19=(($18)|0) > 1;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$4;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=_atoi($23);
      var $27 = $24;__label__ = 5; break;
    case 4: // $25
      var $27 = 0;__label__ = 5; break;
    case 5: // $26
      var $27;
      $scrnum=$27;
      var $28=$1;
      var $29=__ZNK15running_machine10devicelistEv($28);
      var $30=HEAP32[((_SCREEN)>>2)];
      var $31=$scrnum;
      var $32=__ZNK11device_list4findEPFP8device_tRK14machine_configPKcS1_jEi($29, $30, $31);
      var $33=__Z8downcastIP13screen_device8device_tET_PT0_($32);
      $screen=$33;
      var $34=$screen;
      var $35=(($34)|0)==0;
      if ($35) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $36
      var $37=$1;
      var $38=__ZNK15running_machine6renderEv($37);
      var $39=$screen;
      var $40=__ZNK14render_manager7is_liveER13screen_device($38, $39);
      if ($40) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $41
      var $42=$1;
      var $43=$scrnum;
      __Z20debug_console_printfR15running_machinePKcz($42, ((STRING_TABLE.__str1255623)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$43,tempInt));
      __label__ = 33; break;
    case 8: // $44
      var $45=$filename;
      __ZN7astringC1EPKc($fname, $45);
      var $46=(function() { try { __THREW__ = false; return __ZNK7astring4findEiPKc($fname, 0, ((STRING_TABLE.__str1265624)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; };
    case 9: // $47
      var $48=(($46)|0)==-1;
      if ($48) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $49
      var $50=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($fname, ((STRING_TABLE.__str1265624)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; };
    case 11: // $51
      __label__ = 13; break;
    case 12: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $5=$54;
      var $55=$53.f1;
      $6=$55;
      __label__ = 31; break;
    case 13: // $56
      var $57=$1;
      var $58=(function() { try { __THREW__ = false; return __ZNK15running_machine7optionsEv($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; };
    case 14: // $59
      var $60=(function() { try { __THREW__ = false; return __ZNK11emu_options18snapshot_directoryEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; };
    case 15: // $61
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $60, 14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 16: // $62
      var $63=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 21; break; };
    case 17: // $64
      var $65=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKc($file, $63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 21; break; };
    case 18: // $66
      $filerr=$65;
      var $67=$filerr;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $69
      var $70=$1;
      var $71=$filename;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($70, ((STRING_TABLE.__str1275625)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$71,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $72
      $7=1;
      __label__ = 27; break;
    case 21: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $75=$74.f0;
      $5=$75;
      var $76=$74.f1;
      $6=$76;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 22: // $77
      var $78=$screen;
      var $79=$78;
      var $80=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 21; break; };
    case 23: // $81
      var $82=(function() { try { __THREW__ = false; return __ZNK15running_machine5videoEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 21; break; };
    case 24: // $83
      var $84=$screen;
      (function() { try { __THREW__ = false; return __ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file($82, $84, $file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 21; break; }
    case 25: // $85
      var $86=$1;
      var $87=$scrnum;
      var $88=$filename;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($86, ((STRING_TABLE.__str1285626)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$87,HEAP32[((tempInt+4)>>2)]=$88,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 21; break; }
    case 26: // $89
      $7=0;
      __label__ = 27; break;
    case 27: // $90
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 12; break; }
    case 28: // $91
      FUNCTION_TABLE[__ZN7astringD1Ev]($fname);
      var $cleanup_dest=$7;
      if ($cleanup_dest == 0) {
        __label__ = 29; break;
      }
      else if ($cleanup_dest == 1) {
        __label__ = 33; break;
      }
      else {
      __label__ = 36; break;
      }
      
    case 29: // $92
      __label__ = 33; break;
    case 30: // $93
      __label__ = 31; break;
    case 31: // $94
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($fname) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $95
      __label__ = 34; break;
    case 33: // $96
      STACKTOP = __stackBase__;
      return;
    case 34: // $97
      var $98=$5;
      var $99=$5;
      var $100=$6;
      var $101=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $99, tempValue);
      var $102=($101.f1 = $100, $101);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $103
      var $104=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 36: // $105
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12execute_snapR15running_machineiiPPKc["X"]=1;

function __ZNK16expression_error6offsetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12symbol_entry4nextEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11simple_listI12symbol_entryE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL15execute_memdumpR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $file;
      var $filename;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $13 = ((STRING_TABLE.__str1165614)|0);__label__ = 3; break;
    case 2: // $8
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $13 = $11;__label__ = 3; break;
    case 3: // $12
      var $13;
      $filename=$13;
      var $14=$1;
      var $15=$filename;
      __Z20debug_console_printfR15running_machinePKcz($14, ((STRING_TABLE.__str1175615)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt));
      var $16=$filename;
      var $17=_fopen($16, ((STRING_TABLE.__str1185616)|0));
      $file=$17;
      var $18=$file;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      var $21=$1;
      var $22=$file;
      __Z11memory_dumpR15running_machineP7__sFILE($21, $22);
      var $23=$file;
      var $24=_fclose($23);
      __label__ = 5; break;
    case 5: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15execute_symlistR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 4012; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpu=__stackBase__;
      var $namelist=__stackBase__+4;
      var $symtable;
      var $symnum;
      var $count;
      var $entry;
      var $entry1;
      var $value=__stackBase__+4004;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      HEAP32[(($cpu)>>2)]=0;
      $count=0;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$1;
      var $11=$4;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($10, $13, $cpu);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      __label__ = 23; break;
    case 3: // $17
      var $18=HEAP32[(($cpu)>>2)];
      var $19=__ZNK8device_t5debugEv($18);
      var $20=__ZN12device_debug8symtableEv($19);
      $symtable=$20;
      var $21=$1;
      var $22=HEAP32[(($cpu)>>2)];
      var $23=__ZNK8device_t3tagEv($22);
      __Z20debug_console_printfR15running_machinePKcz($21, ((STRING_TABLE.__str1115609)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$23,tempInt));
      __label__ = 5; break;
    case 4: // $24
      var $25=$1;
      var $26=__Z29debug_cpu_get_global_symtableR15running_machine($25);
      $symtable=$26;
      var $27=$1;
      __Z20debug_console_printfR15running_machinePKcz($27, ((STRING_TABLE.__str1125610)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 5; break;
    case 5: // $28
      var $29=$symtable;
      var $30=__ZNK12symbol_table5firstEv($29);
      $entry=$30;
      __label__ = 6; break;
    case 6: // $31
      var $32=$entry;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $34
      var $35=$entry;
      var $36=__ZNK12symbol_entry11is_functionEv($35);
      if ($36) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $37
      var $38=$entry;
      var $39=__ZNK12symbol_entry4nameEv($38);
      var $40=$count;
      var $41=(($40+1)|0);
      $count=$41;
      var $42=(($namelist+($40<<2))|0);
      HEAP32[(($42)>>2)]=$39;
      var $43=$count;
      var $44=(($43)>>>0) >= 1000;
      if ($44) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $45
      __label__ = 13; break;
    case 10: // $46
      __label__ = 11; break;
    case 11: // $47
      __label__ = 12; break;
    case 12: // $48
      var $49=$entry;
      var $50=__ZNK12symbol_entry4nextEv($49);
      $entry=$50;
      __label__ = 6; break;
    case 13: // $51
      var $52=$count;
      var $53=(($52)|0) > 1;
      if ($53) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $54
      var $55=(($namelist)|0);
      var $56=$55;
      var $57=$count;
      _qsort($56, $57, 4, 1290);
      __label__ = 15; break;
    case 15: // $58
      $symnum=0;
      __label__ = 16; break;
    case 16: // $59
      var $60=$symnum;
      var $61=$count;
      var $62=(($60)|0) < (($61)|0);
      if ($62) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $63
      var $64=$symtable;
      var $65=$symnum;
      var $66=(($namelist+($65<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=__ZN12symbol_table4findEPKc($64, $67);
      $entry1=$68;
      __label__ = 18; break;
    case 18: // $69
      __label__ = 19; break;
    case 19: // $70
      var $71=$entry1;
      var $72=$71;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+12)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=FUNCTION_TABLE[$75]($71);
      var $76$0=$76[0];
      var $76$1=$76[1];
      var $st$8$0=(($value)|0);
      HEAP32[(($st$8$0)>>2)]=$76$0;
      var $st$8$1=(($value+4)|0);
      HEAP32[(($st$8$1)>>2)]=$76$1;
      var $77=$1;
      var $78=$symnum;
      var $79=(($namelist+($78<<2))|0);
      var $80=HEAP32[(($79)>>2)];
      var $st$16$0=(($value)|0);
      var $81$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($value+4)|0);
      var $81$1=HEAP32[(($st$16$1)>>2)];
      var $82=__Z19core_i64_hex_formatyh($81$0, $81$1, 0);
      __Z20debug_console_printfR15running_machinePKcz($77, ((STRING_TABLE.__str1135611)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$80,HEAP32[((tempInt+4)>>2)]=$82,tempInt));
      var $83=$entry1;
      var $84=$83;
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85+8)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=FUNCTION_TABLE[$87]($83);
      if ($88) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $89
      var $90=$1;
      __Z20debug_console_printfR15running_machinePKcz($90, ((STRING_TABLE.__str1145612)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 21; break;
    case 21: // $91
      var $92=$1;
      __Z20debug_console_printfR15running_machinePKcz($92, ((STRING_TABLE.__str1155613)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 22; break;
    case 22: // $93
      var $94=$symnum;
      var $95=(($94+1)|0);
      $symnum=$95;
      __label__ = 16; break;
    case 23: // $96
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_symlistR15running_machineiiPPKc["X"]=1;

function __ZL17execute_softresetR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  __ZN15running_machine19schedule_soft_resetEv($5);
  ;
  return;
}


function __ZL17execute_hardresetR15running_machineiiPPKc($machine, $ref, $params, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$machine;
  $2=$ref;
  $3=$params;
  $4=$param;
  var $5=$1;
  __ZN15running_machine19schedule_hard_resetEv($5);
  ;
  return;
}


function __ZL14execute_imagesR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $img=__stackBase__;
      var $gotone;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      HEAP32[(($img)>>2)]=0;
      var $5=$1;
      var $6=__ZNK15running_machine10devicelistEv($5);
      var $7=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($6, $img);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $12
      var $13=$1;
      var $14=HEAP32[(($img)>>2)];
      var $15=__ZNK22device_image_interface19brief_instance_nameEv($14);
      var $16=HEAP32[(($img)>>2)];
      var $17=__ZN22device_image_interface6existsEv($16);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=HEAP32[(($img)>>2)];
      var $20=__ZN22device_image_interface8filenameEv($19);
      var $23 = $20;__label__ = 5; break;
    case 4: // $21
      var $23 = ((STRING_TABLE.__str1095607)|0);__label__ = 5; break;
    case 5: // $22
      var $23;
      __Z20debug_console_printfR15running_machinePKcz($13, ((STRING_TABLE.__str1085606)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,HEAP32[((tempInt+4)>>2)]=$23,tempInt));
      __label__ = 6; break;
    case 6: // $24
      var $25=HEAP32[(($img)>>2)];
      var $26=$25;
      var $27=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($26, $img);
      var $28=(($27)&1);
      $gotone=$28;
      __label__ = 1; break;
    case 7: // $29
      var $30=$1;
      var $31=__ZNK15running_machine10devicelistEv($30);
      var $32=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($31, $img);
      if ($32) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $33
      var $34=$1;
      __Z20debug_console_printfR15running_machinePKcz($34, ((STRING_TABLE.__str1105608)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $35
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13execute_mountR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $img=__stackBase__;
      var $done;
      var $gotone;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      HEAP32[(($img)>>2)]=0;
      $done=0;
      var $5=$1;
      var $6=__ZNK15running_machine10devicelistEv($5);
      var $7=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($6, $img);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=HEAP32[(($img)>>2)];
      var $14=__ZNK22device_image_interface19brief_instance_nameEv($13);
      var $15=$4;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=_strcmp($14, $17);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $20
      var $21=HEAP32[(($img)>>2)];
      var $22=$4;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZN22device_image_interface4loadEPKc($21, $24);
      var $26=(($25)&1);
      var $27=(($26)|0)==1;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$1;
      var $30=$4;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$4;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($29, ((STRING_TABLE.__str1065604)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,HEAP32[((tempInt+4)>>2)]=$35,tempInt));
      __label__ = 6; break;
    case 5: // $36
      var $37=$1;
      var $38=$4;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$4;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($37, ((STRING_TABLE.__str1075605)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,HEAP32[((tempInt+4)>>2)]=$43,tempInt));
      __label__ = 6; break;
    case 6: // $44
      $done=1;
      __label__ = 9; break;
    case 7: // $45
      __label__ = 8; break;
    case 8: // $46
      var $47=HEAP32[(($img)>>2)];
      var $48=$47;
      var $49=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($48, $img);
      var $50=(($49)&1);
      $gotone=$50;
      __label__ = 1; break;
    case 9: // $51
      var $52=$done;
      var $53=(($52) & 1);
      if ($53) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $54
      var $55=$1;
      var $56=$4;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($55, ((STRING_TABLE.__str1055603)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$58,tempInt));
      __label__ = 11; break;
    case 11: // $59
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13execute_mountR15running_machineiiPPKc["X"]=1;

function __ZL15execute_unmountR15running_machineiiPPKc($machine, $ref, $params, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $img=__stackBase__;
      var $done;
      var $gotone;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      HEAP32[(($img)>>2)]=0;
      $done=0;
      var $5=$1;
      var $6=__ZNK15running_machine10devicelistEv($5);
      var $7=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($6, $img);
      var $8=(($7)&1);
      $gotone=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$gotone;
      var $11=(($10) & 1);
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=HEAP32[(($img)>>2)];
      var $14=__ZNK22device_image_interface19brief_instance_nameEv($13);
      var $15=$4;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=_strcmp($14, $17);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=HEAP32[(($img)>>2)];
      __ZN22device_image_interface6unloadEv($21);
      var $22=$1;
      var $23=$4;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($22, ((STRING_TABLE.__str1045602)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$25,tempInt));
      $done=1;
      __label__ = 6; break;
    case 4: // $26
      __label__ = 5; break;
    case 5: // $27
      var $28=HEAP32[(($img)>>2)];
      var $29=$28;
      var $30=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($29, $img);
      var $31=(($30)&1);
      $gotone=$31;
      __label__ = 1; break;
    case 6: // $32
      var $33=$done;
      var $34=(($33) & 1);
      if ($34) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $35
      var $36=$1;
      var $37=$4;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($36, ((STRING_TABLE.__str1055603)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt));
      __label__ = 8; break;
    case 8: // $40
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15execute_unmountR15running_machineiiPPKc["X"]=1;

function __ZL18debug_command_exitR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $device;
      $1=$machine;
      var $2=$1;
      var $3=__ZNK15running_machine10devicelistEv($2);
      var $4=$3;
      var $5=__ZNK11tagged_listI8device_tE5firstEv($4);
      $device=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$device;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$device;
      var $11=__ZNK8device_t5debugEv($10);
      __ZN12device_debug5traceEP7__sFILEbPKc($11, 0, 0, 0);
      __label__ = 3; break;
    case 3: // $12
      var $13=$device;
      var $14=__ZNK8device_t4nextEv($13);
      $device=$14;
      __label__ = 1; break;
    case 4: // $15
      var $$emscripten$temp$0=((__ZL5cheat+4)|0);
      var $st$1$0=(($$emscripten$temp$0)|0);
      var $16$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($$emscripten$temp$0+4)|0);
      var $16$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $17=$16$0 != $$emscripten$temp$1$0 || $16$1 != $$emscripten$temp$1$1;
      if ($17) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $18
      var $19=$1;
      var $20=__ZN15running_machine7respoolEv($19);
      var $21=HEAP32[((((__ZL5cheat+16)|0))>>2)];
      var $22=$21;
      __ZN13resource_pool6removeEPv($20, $22);
      __label__ = 6; break;
    case 6: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11emu_options12debug_scriptEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options5valueEPKc($3, ((STRING_TABLE.__str2515749)|0));
  ;
  return $4;
}


function __Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space($machine, $param, $spacenum, $result) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $cpu=__stackBase__;
      $2=$machine;
      $3=$param;
      $4=$spacenum;
      $5=$result;
      var $6=$2;
      var $7=$3;
      var $8=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($6, $7, $cpu);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      $1=0;
      __label__ = 5; break;
    case 2: // $11
      var $12=HEAP32[(($cpu)>>2)];
      var $13=__ZNK8device_t6memoryEv($12);
      var $14=$4;
      var $15=__ZNK23device_memory_interface5spaceEi($13, $14);
      var $16=$5;
      HEAP32[(($16)>>2)]=$15;
      var $17=$5;
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$2;
      var $22=HEAP32[(($cpu)>>2)];
      var $23=__ZNK8device_t3tagEv($22);
      __Z20debug_console_printfR15running_machinePKcz($21, ((STRING_TABLE.__str1035601)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$23,tempInt));
      $1=0;
      __label__ = 5; break;
    case 4: // $24
      $1=1;
      __label__ = 5; break;
    case 5: // $25
      var $26=$1;
      STACKTOP = __stackBase__;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12symbol_table5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=__ZNK11tagged_listI12symbol_entryE5firstEv($3);
  ;
  return $4;
}


function __ZNK12symbol_entry4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZL19symbol_sort_comparePKvS0_($item1, $item2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $str1;
  var $str2;
  $1=$item1;
  $2=$item2;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  $str1=$5;
  var $6=$2;
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  $str2=$8;
  var $9=$str1;
  var $10=$str2;
  var $11=_strcmp($9, $10);
  ;
  return $11;
}


function __ZNK11tagged_listI12symbol_entryE5firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=__ZNK11simple_listI12symbol_entryE5firstEv($3);
  ;
  return $4;
}


function __Z30debug_command_parameter_numberR15running_machinePKcPy($machine, $param, $result) {
  var __stackBase__  = STACKTOP; STACKTOP += 624; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $expression=__stackBase__;
      var $5;
      var $6;
      var $7;
      var $error;
      $2=$machine;
      $3=$param;
      $4=$result;
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=1;
      __label__ = 16; break;
    case 2: // $11
      var $12=$2;
      var $13=(function() { try { __THREW__ = false; return __Z30debug_cpu_get_visible_symtableR15running_machine($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $14
      var $15=$3;
      var $16=$4;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($expression, $13, $15, $16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      $1=1;
      $7=1;
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($expression) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 5; break; }
    case 5: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $20=$19.f0;
      $5=$20;
      var $21=$19.f1;
      $6=$21;
      __label__ = 6; break;
    case 6: // $22
      var $23=$6;
      var $24=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $25=(($23)|0)==(($24)|0);
      if ($25) { __label__ = 7; break; } else { __label__ = 17; break; }
    case 7: // $26
      var $27=$5;
      var $28=___cxa_begin_catch($27);
      var $29=$28;
      $error=$29;
      var $30=$2;
      var $31=$3;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($30, ((STRING_TABLE.__str965594)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $32
      var $33=$2;
      var $34=$error;
      var $35=(function() { try { __THREW__ = false; return __ZNK16expression_error6offsetEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 14; break; };
    case 9: // $36
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($33, ((STRING_TABLE.__str975595)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$35,HEAP32[((tempInt+4)>>2)]=((__str985596)|0),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $37
      var $38=$2;
      var $39=$error;
      var $40=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $41
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($38, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $42
      $1=0;
      $7=1;
      ___cxa_end_catch();
      __label__ = 16; break;
    case 13: // $43
      __label__ = 16; break;
    case 14: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $5=$46;
      var $47=$45.f1;
      $6=$47;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $48
      __label__ = 17; break;
    case 16: // $49
      var $50=$1;
      STACKTOP = __stackBase__;
      return $50;
    case 17: // $51
      var $52=$5;
      var $53=$5;
      var $54=$6;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z30debug_command_parameter_numberR15running_machinePKcPy["X"]=1;

function __Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($machine, $param, $result) {
  var __stackBase__  = STACKTOP; STACKTOP += 636; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cpunum=__stackBase__;
      var $expression=__stackBase__+8;
      var $5;
      var $6;
      var $7;
      var $8;
      var $exec=__stackBase__+632;
      var $gotone;
      $2=$machine;
      $3=$param;
      $4=$result;
      var $9=$3;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $11
      var $12=$2;
      var $13=__Z25debug_cpu_get_visible_cpuR15running_machine($12);
      var $14=$4;
      HEAP32[(($14)>>2)]=$13;
      var $15=$4;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$2;
      __Z20debug_console_printfR15running_machinePKcz($19, ((STRING_TABLE.__str1005598)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $1=0;
      __label__ = 23; break;
    case 3: // $20
      $1=1;
      __label__ = 23; break;
    case 4: // $21
      var $22=$2;
      var $23=$3;
      var $24=__ZN15running_machine6deviceEPKc($22, $23);
      var $25=$4;
      HEAP32[(($25)>>2)]=$24;
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      $1=1;
      __label__ = 23; break;
    case 6: // $30
      var $31=$2;
      var $32=(function() { try { __THREW__ = false; return __Z30debug_cpu_get_visible_symtableR15running_machine($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $33
      var $34=$3;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17parsed_expressionC1EP12symbol_tablePKcPy]($expression, $32, $34, $cpunum) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $35
      (function() { try { __THREW__ = false; return __ZN17parsed_expressionD1Ev($expression) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $36
      __label__ = 16; break;
    case 10: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $39=$38.f0;
      $5=$39;
      var $40=$38.f1;
      $6=$40;
      __label__ = 11; break;
    case 11: // $41
      var $42=$6;
      var $43=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $44=(($42)|0)==(($43)|0);
      if ($44) { __label__ = 12; break; } else { __label__ = 24; break; }
    case 12: // $45
      var $46=$5;
      var $47=___cxa_begin_catch($46);
      var $48=$47;
      $7=$48;
      var $49=$2;
      var $50=$3;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($49, ((STRING_TABLE.__str1015599)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$50,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $51
      $1=0;
      $8=1;
      ___cxa_end_catch();
      __label__ = 23; break;
    case 14: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $5=$54;
      var $55=$53.f1;
      $6=$55;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 25; break; }
    case 15: // $56
      __label__ = 24; break;
    case 16: // $57
      HEAP32[(($exec)>>2)]=0;
      var $58=$2;
      var $59=__ZNK15running_machine10devicelistEv($58);
      var $60=__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_($59, $exec);
      var $61=(($60)&1);
      $gotone=$61;
      __label__ = 17; break;
    case 17: // $62
      var $63=$gotone;
      var $64=(($63) & 1);
      if ($64) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $65
      var $st$0$0=(($cpunum)|0);
      var $66$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($cpunum+4)|0);
      var $66$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $67$0 = ((($66$0)>>>0)+((($66$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $67$1 = Math.min(Math.floor((((($66$0)>>>0)+((($66$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($cpunum)|0);
      HEAP32[(($st$7$0)>>2)]=$67$0;
      var $st$7$1=(($cpunum+4)|0);
      HEAP32[(($st$7$1)>>2)]=$67$1;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $68=$66$0 == $$emscripten$temp$1$0 && $66$1 == $$emscripten$temp$1$1;
      if ($68) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $69
      var $70=HEAP32[(($exec)>>2)];
      var $71=$70;
      var $72=__ZN16device_interface6deviceEv($71);
      var $73=$4;
      HEAP32[(($73)>>2)]=$72;
      $1=1;
      __label__ = 23; break;
    case 20: // $74
      __label__ = 21; break;
    case 21: // $75
      var $76=HEAP32[(($exec)>>2)];
      var $77=$76;
      var $78=__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_($77, $exec);
      var $79=(($78)&1);
      $gotone=$79;
      __label__ = 17; break;
    case 22: // $80
      var $81=$2;
      var $st$1$0=(($cpunum)|0);
      var $82$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($cpunum+4)|0);
      var $82$1=HEAP32[(($st$1$1)>>2)];
      var $83$0=$82$0;
      var $83=$83$0;
      __Z20debug_console_printfR15running_machinePKcz($81, ((STRING_TABLE.__str1025600)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$83,tempInt));
      $1=0;
      __label__ = 23; break;
    case 23: // $84
      var $85=$1;
      STACKTOP = __stackBase__;
      return $85;
    case 24: // $86
      var $87=$5;
      var $88=$5;
      var $89=$6;
      var $90=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $88, tempValue);
      var $91=($90.f1 = $89, $90);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $92
      var $93=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t["X"]=1;

function __ZL15cheat_byte_swapPK13_cheat_systemy($cheatsys, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$cheatsys;
      var $st$3$0=(($2)|0);
      HEAP32[(($st$3$0)>>2)]=$value$0;
      var $st$3$1=(($2+4)|0);
      HEAP32[(($st$3$1)>>2)]=$value$1;
      var $3=$1;
      var $4=(($3+22)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      if ($11 == 2) {
        __label__ = 2; break;
      }
      else if ($11 == 4) {
        __label__ = 3; break;
      }
      else if ($11 == 8) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 2: // $12
      var $st$0$0=(($2)|0);
      var $13$0=HEAPU32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $13$1=HEAPU32[(($st$0$1)>>2)];
      var $14$0=($13$0 >>> 8) | ($13$1 << 24);
      var $14$1=($13$1 >>> 8) | (0 << 24);
      var $$emscripten$temp$0$0=255;
      var $$emscripten$temp$0$1=0;
      var $15$0=$14$0 & $$emscripten$temp$0$0;
      var $15$1=$14$1 & $$emscripten$temp$0$1;
      var $st$10$0=(($2)|0);
      var $16$0=HEAPU32[(($st$10$0)>>2)];
      var $st$10$1=(($2+4)|0);
      var $16$1=HEAPU32[(($st$10$1)>>2)];
      var $17$0=($16$0 << 8) | (0 >>> 24);
      var $17$1=($16$1 << 8) | ($16$0 >>> 24);
      var $$emscripten$temp$1$0=65280;
      var $$emscripten$temp$1$1=0;
      var $18$0=$17$0 & $$emscripten$temp$1$0;
      var $18$1=$17$1 & $$emscripten$temp$1$1;
      var $19$0=$15$0 | $18$0;
      var $19$1=$15$1 | $18$1;
      var $st$22$0=(($2)|0);
      HEAP32[(($st$22$0)>>2)]=$19$0;
      var $st$22$1=(($2+4)|0);
      HEAP32[(($st$22$1)>>2)]=$19$1;
      __label__ = 5; break;
    case 3: // $20
      var $st$0$0=(($2)|0);
      var $21$0=HEAPU32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $21$1=HEAPU32[(($st$0$1)>>2)];
      var $22$0=($21$0 >>> 24) | ($21$1 << 8);
      var $22$1=($21$1 >>> 24) | (0 << 8);
      var $$emscripten$temp$2$0=255;
      var $$emscripten$temp$2$1=0;
      var $23$0=$22$0 & $$emscripten$temp$2$0;
      var $23$1=$22$1 & $$emscripten$temp$2$1;
      var $st$10$0=(($2)|0);
      var $24$0=HEAPU32[(($st$10$0)>>2)];
      var $st$10$1=(($2+4)|0);
      var $24$1=HEAPU32[(($st$10$1)>>2)];
      var $25$0=($24$0 >>> 8) | ($24$1 << 24);
      var $25$1=($24$1 >>> 8) | (0 << 24);
      var $$emscripten$temp$3$0=65280;
      var $$emscripten$temp$3$1=0;
      var $26$0=$25$0 & $$emscripten$temp$3$0;
      var $26$1=$25$1 & $$emscripten$temp$3$1;
      var $27$0=$23$0 | $26$0;
      var $27$1=$23$1 | $26$1;
      var $st$22$0=(($2)|0);
      var $28$0=HEAPU32[(($st$22$0)>>2)];
      var $st$22$1=(($2+4)|0);
      var $28$1=HEAPU32[(($st$22$1)>>2)];
      var $29$0=($28$0 << 8) | (0 >>> 24);
      var $29$1=($28$1 << 8) | ($28$0 >>> 24);
      var $$emscripten$temp$4$0=16711680;
      var $$emscripten$temp$4$1=0;
      var $30$0=$29$0 & $$emscripten$temp$4$0;
      var $30$1=$29$1 & $$emscripten$temp$4$1;
      var $31$0=$27$0 | $30$0;
      var $31$1=$27$1 | $30$1;
      var $st$34$0=(($2)|0);
      var $32$0=HEAPU32[(($st$34$0)>>2)];
      var $st$34$1=(($2+4)|0);
      var $32$1=HEAPU32[(($st$34$1)>>2)];
      var $33$0=($32$0 << 24) | (0 >>> 8);
      var $33$1=($32$1 << 24) | ($32$0 >>> 8);
      var $$emscripten$temp$5$0=-16777216;
      var $$emscripten$temp$5$1=0;
      var $34$0=$33$0 & $$emscripten$temp$5$0;
      var $34$1=$33$1 & $$emscripten$temp$5$1;
      var $35$0=$31$0 | $34$0;
      var $35$1=$31$1 | $34$1;
      var $st$46$0=(($2)|0);
      HEAP32[(($st$46$0)>>2)]=$35$0;
      var $st$46$1=(($2+4)|0);
      HEAP32[(($st$46$1)>>2)]=$35$1;
      __label__ = 5; break;
    case 4: // $36
      var $st$0$0=(($2)|0);
      var $37$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $37$1=HEAPU32[(($st$0$1)>>2)];
      var $38$0=($37$1 >>> 24) | (0 << 8);
      var $38$1=(0 >>> 24) | (0 << 8);
      var $$emscripten$temp$6$0=255;
      var $$emscripten$temp$6$1=0;
      var $39$0=$38$0 & $$emscripten$temp$6$0;
      var $39$1=$38$1 & $$emscripten$temp$6$1;
      var $st$10$0=(($2)|0);
      var $40$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($2+4)|0);
      var $40$1=HEAPU32[(($st$10$1)>>2)];
      var $41$0=($40$1 >>> 8) | (0 << 24);
      var $41$1=(0 >>> 8) | (0 << 24);
      var $$emscripten$temp$7$0=65280;
      var $$emscripten$temp$7$1=0;
      var $42$0=$41$0 & $$emscripten$temp$7$0;
      var $42$1=$41$1 & $$emscripten$temp$7$1;
      var $43$0=$39$0 | $42$0;
      var $43$1=$39$1 | $42$1;
      var $st$22$0=(($2)|0);
      var $44$0=HEAPU32[(($st$22$0)>>2)];
      var $st$22$1=(($2+4)|0);
      var $44$1=HEAPU32[(($st$22$1)>>2)];
      var $45$0=($44$0 >>> 24) | ($44$1 << 8);
      var $45$1=($44$1 >>> 24) | (0 << 8);
      var $$emscripten$temp$8$0=16711680;
      var $$emscripten$temp$8$1=0;
      var $46$0=$45$0 & $$emscripten$temp$8$0;
      var $46$1=$45$1 & $$emscripten$temp$8$1;
      var $47$0=$43$0 | $46$0;
      var $47$1=$43$1 | $46$1;
      var $st$34$0=(($2)|0);
      var $48$0=HEAPU32[(($st$34$0)>>2)];
      var $st$34$1=(($2+4)|0);
      var $48$1=HEAPU32[(($st$34$1)>>2)];
      var $49$0=($48$0 >>> 8) | ($48$1 << 24);
      var $49$1=($48$1 >>> 8) | (0 << 24);
      var $$emscripten$temp$9$0=-16777216;
      var $$emscripten$temp$9$1=0;
      var $50$0=$49$0 & $$emscripten$temp$9$0;
      var $50$1=$49$1 & $$emscripten$temp$9$1;
      var $51$0=$47$0 | $50$0;
      var $51$1=$47$1 | $50$1;
      var $st$46$0=(($2)|0);
      var $52$0=HEAPU32[(($st$46$0)>>2)];
      var $st$46$1=(($2+4)|0);
      var $52$1=HEAPU32[(($st$46$1)>>2)];
      var $53$0=($52$0 << 8) | (0 >>> 24);
      var $53$1=($52$1 << 8) | ($52$0 >>> 24);
      var $$emscripten$temp$10$0=0;
      var $$emscripten$temp$10$1=255;
      var $54$0=$53$0 & $$emscripten$temp$10$0;
      var $54$1=$53$1 & $$emscripten$temp$10$1;
      var $55$0=$51$0 | $54$0;
      var $55$1=$51$1 | $54$1;
      var $st$58$0=(($2)|0);
      var $56$0=HEAPU32[(($st$58$0)>>2)];
      var $st$58$1=(($2+4)|0);
      var $56$1=HEAPU32[(($st$58$1)>>2)];
      var $57$0=($56$0 << 24) | (0 >>> 8);
      var $57$1=($56$1 << 24) | ($56$0 >>> 8);
      var $$emscripten$temp$11$0=0;
      var $$emscripten$temp$11$1=65280;
      var $58$0=$57$0 & $$emscripten$temp$11$0;
      var $58$1=$57$1 & $$emscripten$temp$11$1;
      var $59$0=$55$0 | $58$0;
      var $59$1=$55$1 | $58$1;
      var $st$70$0=(($2)|0);
      var $60$0=HEAPU32[(($st$70$0)>>2)];
      var $st$70$1=(($2+4)|0);
      var $60$1=HEAP32[(($st$70$1)>>2)];
      var $61$0=(0 << 8) | (0 >>> 24);
      var $61$1=($60$0 << 8) | (0 >>> 24);
      var $$emscripten$temp$12$0=0;
      var $$emscripten$temp$12$1=16711680;
      var $62$0=$61$0 & $$emscripten$temp$12$0;
      var $62$1=$61$1 & $$emscripten$temp$12$1;
      var $63$0=$59$0 | $62$0;
      var $63$1=$59$1 | $62$1;
      var $st$82$0=(($2)|0);
      var $64$0=HEAPU32[(($st$82$0)>>2)];
      var $st$82$1=(($2+4)|0);
      var $64$1=HEAP32[(($st$82$1)>>2)];
      var $65$0=(0 << 24) | (0 >>> 8);
      var $65$1=($64$0 << 24) | (0 >>> 8);
      var $$emscripten$temp$13$0=0;
      var $$emscripten$temp$13$1=-16777216;
      var $66$0=$65$0 & $$emscripten$temp$13$0;
      var $66$1=$65$1 & $$emscripten$temp$13$1;
      var $67$0=$63$0 | $66$0;
      var $67$1=$63$1 | $66$1;
      var $st$94$0=(($2)|0);
      HEAP32[(($st$94$0)>>2)]=$67$0;
      var $st$94$1=(($2+4)|0);
      HEAP32[(($st$94$1)>>2)]=$67$1;
      __label__ = 5; break;
    case 5: // $68
      __label__ = 6; break;
    case 6: // $69
      var $st$0$0=(($2)|0);
      var $70$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $70$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$70$0,$70$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15cheat_byte_swapPK13_cheat_systemy["X"]=1;

function __ZL17cheat_sign_extendPK13_cheat_systemy($cheatsys, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$cheatsys;
      var $st$3$0=(($2)|0);
      HEAP32[(($st$3$0)>>2)]=$value$0;
      var $st$3$1=(($2+4)|0);
      HEAP32[(($st$3$1)>>2)]=$value$1;
      var $3=$1;
      var $4=(($3+21)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      if ($11 == 1) {
        __label__ = 2; break;
      }
      else if ($11 == 2) {
        __label__ = 3; break;
      }
      else if ($11 == 4) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 2: // $12
      var $st$0$0=(($2)|0);
      var $13$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $13$1=HEAP32[(($st$0$1)>>2)];
      var $14$0=$13$0;
      var $14=$14$0&255;
      var $15$0=$14;
      var $15$1=(($14|0) < 0 ? -1 : 0);
      var $st$8$0=(($2)|0);
      HEAP32[(($st$8$0)>>2)]=$15$0;
      var $st$8$1=(($2+4)|0);
      HEAP32[(($st$8$1)>>2)]=$15$1;
      __label__ = 5; break;
    case 3: // $16
      var $st$0$0=(($2)|0);
      var $17$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $17$1=HEAP32[(($st$0$1)>>2)];
      var $18$0=$17$0;
      var $18=$18$0&65535;
      var $19$0=$18;
      var $19$1=(($18|0) < 0 ? -1 : 0);
      var $st$8$0=(($2)|0);
      HEAP32[(($st$8$0)>>2)]=$19$0;
      var $st$8$1=(($2+4)|0);
      HEAP32[(($st$8$1)>>2)]=$19$1;
      __label__ = 5; break;
    case 4: // $20
      var $st$0$0=(($2)|0);
      var $21$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $21$1=HEAP32[(($st$0$1)>>2)];
      var $22$0=$21$0;
      var $22=$22$0;
      var $23$0=$22;
      var $23$1=(($22|0) < 0 ? -1 : 0);
      var $st$8$0=(($2)|0);
      HEAP32[(($st$8$0)>>2)]=$23$0;
      var $st$8$1=(($2+4)|0);
      HEAP32[(($st$8$1)>>2)]=$23$1;
      __label__ = 5; break;
    case 5: // $24
      __label__ = 6; break;
    case 6: // $25
      var $st$0$0=(($2)|0);
      var $26$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($2+4)|0);
      var $26$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$26$0,$26$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17cheat_sign_extendPK13_cheat_systemy["X"]=1;

function __ZNK13address_space3mapEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug24hotspot_tracking_enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1564)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  ;
  return $5;
}


function __ZNK12device_debug16watchpoint_firstE16address_spacenum($this, $spacenum) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$spacenum;
  var $3=$1;
  var $4=$2;
  var $5=(($3+1544)|0);
  var $6=(($5+($4<<2))|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __ZNK12device_debug10watchpoint5spaceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10watchpoint7enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK12device_debug10watchpoint7addressEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10watchpoint6lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10watchpoint4typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+13)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  ;
  return $5;
}


function __ZNK20address_space_config13byte2addr_endEj($this, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$address;
      var $3=$1;
      var $4=(($3+10)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($3+10)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=$9 << $12;
      var $14=(($3+10)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=1 << $16;
      var $18=(($17-1)|0);
      var $19=$13 | $18;
      var $28 = $19;__label__ = 3; break;
    case 2: // $20
      var $21=$2;
      var $22=(($3+10)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(((-$24))|0);
      var $26=$21 >>> (($25)>>>0);
      var $28 = $26;__label__ = 3; break;
    case 3: // $27
      var $28;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22execute_trace_internalR15running_machineiiPPKci($machine, $ref, $params, $param, $trace_over) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $action;
      var $filename;
      var $cpu=__stackBase__;
      var $f;
      var $mode;
      $1=$machine;
      $2=$ref;
      $3=$params;
      $4=$param;
      $5=$trace_over;
      $action=0;
      var $6=$4;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      $filename=$8;
      $f=0;
      var $9=$1;
      var $10=$3;
      var $11=(($10)|0) > 1;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$4;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $18 = $15;__label__ = 3; break;
    case 2: // $16
      var $18 = 0;__label__ = 3; break;
    case 3: // $17
      var $18;
      var $19=__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t($9, $18, $cpu);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $21
      __label__ = 19; break;
    case 5: // $22
      var $23=$1;
      var $24=$4;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      $action=$26;
      var $27=__ZL31debug_command_parameter_commandR15running_machinePKc($23, $26);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $29
      __label__ = 19; break;
    case 7: // $30
      var $31=$filename;
      var $32=__Z12core_stricmpPKcS0_($31, ((STRING_TABLE.__str1305628)|0));
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $34
      $filename=0;
      __label__ = 9; break;
    case 9: // $35
      var $36=$filename;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $38
      $mode=((STRING_TABLE.__str1185616)|0);
      var $39=$filename;
      var $40=(($39)|0);
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $43=(($42)|0)==62;
      if ($43) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $44
      var $45=$filename;
      var $46=(($45+1)|0);
      var $47=HEAP8[($46)];
      var $48=(($47 << 24) >> 24);
      var $49=(($48)|0)==62;
      if ($49) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $50
      $mode=((STRING_TABLE.__str1315629)|0);
      var $51=$filename;
      var $52=(($51+2)|0);
      $filename=$52;
      __label__ = 13; break;
    case 13: // $53
      var $54=$filename;
      var $55=$mode;
      var $56=_fopen($54, $55);
      $f=$56;
      var $57=$f;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $59
      var $60=$1;
      var $61=$4;
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      __Z20debug_console_printfR15running_machinePKcz($60, ((STRING_TABLE.__str1325630)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$63,tempInt));
      __label__ = 19; break;
    case 15: // $64
      __label__ = 16; break;
    case 16: // $65
      var $66=HEAP32[(($cpu)>>2)];
      var $67=__ZNK8device_t5debugEv($66);
      var $68=$f;
      var $69=$5;
      var $70=(($69)|0)!=0;
      var $71=$action;
      __ZN12device_debug5traceEP7__sFILEbPKc($67, $68, $70, $71);
      var $72=$f;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $74
      var $75=$1;
      var $76=HEAP32[(($cpu)>>2)];
      var $77=__ZNK8device_t3tagEv($76);
      var $78=$filename;
      __Z20debug_console_printfR15running_machinePKcz($75, ((STRING_TABLE.__str1335631)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$77,HEAP32[((tempInt+4)>>2)]=$78,tempInt));
      __label__ = 19; break;
    case 18: // $79
      var $80=$1;
      var $81=HEAP32[(($cpu)>>2)];
      var $82=__ZNK8device_t3tagEv($81);
      __Z20debug_console_printfR15running_machinePKcz($80, ((STRING_TABLE.__str1345632)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$82,tempInt));
      __label__ = 19; break;
    case 19: // $83
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22execute_trace_internalR15running_machineiiPPKci["X"]=1;

function __ZL31debug_command_parameter_commandR15running_machinePKc($machine, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $err;
      $2=$machine;
      $3=$param;
      var $4=$3;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=1;
      __label__ = 5; break;
    case 2: // $7
      var $8=$2;
      var $9=$3;
      var $10=__Z30debug_console_validate_commandR15running_machinePKc($8, $9);
      $err=$10;
      var $11=$err;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $1=1;
      __label__ = 5; break;
    case 4: // $14
      var $15=$2;
      var $16=$3;
      __Z20debug_console_printfR15running_machinePKcz($15, ((STRING_TABLE.__str1355633)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$16,tempInt));
      var $17=$2;
      var $18=$err;
      var $19=$18 & 65535;
      __Z20debug_console_printfR15running_machinePKcz($17, ((STRING_TABLE.__str1365634)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,HEAP32[((tempInt+4)>>2)]=((__str985596)|0),tempInt));
      var $20=$2;
      var $21=$err;
      var $22=__Z22debug_cmderr_to_stringj($21);
      __Z20debug_console_printfR15running_machinePKcz($20, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$22,tempInt));
      $1=0;
      __label__ = 5; break;
    case 5: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19cheat_read_extendedPK13_cheat_systemP13address_spacej($cheatsys, $space, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$cheatsys;
  $2=$space;
  $3=$address;
  var $4=$1;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$1;
  var $9=(($8+12)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=__Z17debug_read_memoryP13address_spacejii($6, $7, $11, 1);
  var $12$0=$12[0];
  var $12$1=$12[1];
  var $13=__ZL15cheat_byte_swapPK13_cheat_systemy($5, $12$0, $12$1);
  var $13$0=$13[0];
  var $13$1=$13[1];
  var $14=__ZL17cheat_sign_extendPK13_cheat_systemy($4, $13$0, $13$1);
  var $14$0=$14[0];
  var $14$1=$14[1];
  ;
  return [$14$0,$14$1];
}


function __ZL22cheat_address_is_validP13address_spacej($space, $address) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      $1=$space;
      HEAP32[(($2)>>2)]=$address;
      var $3=$1;
      var $4=__Z19debug_cpu_translateP13address_spaceiPj($3, 0, $2);
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { var $16 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=$7;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+24)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=HEAP32[(($2)>>2)];
      var $13=FUNCTION_TABLE[$11]($7, $12);
      var $14=(($13)|0)!=0;
      var $16 = $14;__label__ = 2; break;
    case 2: // $15
      var $16;
      var $17=(($16)&1);
      STACKTOP = __stackBase__;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayI10_cheat_mapEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI10_cheat_mapEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI10_cheat_mapEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=(($8*28)|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI10_cheat_mapE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI10_cheat_mapED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI10_cheat_mapED2Ev($2);
  ;
  return;
}


function __ZNK13address_space19byte_to_address_endEj($this, $address) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$address;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK20address_space_config13byte2addr_endEj($5, $6);
  ;
  return $7;
}


function __ZNK12device_debug10watchpoint9conditionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+24)|0);
  var $4=__ZNK17parsed_expression15original_stringEv($3);
  ;
  return $4;
}


function __ZNK12device_debug10watchpoint6actionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+648)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN13resource_pool9add_arrayI10_cheat_mapEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI10_cheat_mapEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI10_cheat_mapEEPT_S3_i["X"]=1;

function __ZN19resource_pool_arrayI10_cheat_mapED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI10_cheat_mapED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI10_cheat_mapED0Ev["X"]=1;

function __ZN19resource_pool_arrayI10_cheat_mapED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayI10_cheat_mapE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL34debug_command_parameter_expressionR15running_machinePKcR17parsed_expression($machine, $param, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $err;
      var $7;
      $2=$machine;
      $3=$param;
      $4=$result;
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=1;
      __label__ = 14; break;
    case 2: // $11
      var $12=$4;
      var $13=$3;
      (function() { try { __THREW__ = false; return __ZN17parsed_expression5parseEPKc($12, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 14; break;
    case 4: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[__ZTI16expression_error]);
      var $17=$16.f0;
      $5=$17;
      var $18=$16.f1;
      $6=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$6;
      var $21=_llvm_eh_typeid_for(__ZTI16expression_error);
      var $22=(($20)|0)==(($21)|0);
      if ($22) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $23
      var $24=$5;
      var $25=___cxa_begin_catch($24);
      var $26=$25;
      $err=$26;
      var $27=$2;
      var $28=$3;
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($27, ((STRING_TABLE.__str965594)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$28,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $29
      var $30=$2;
      var $31=$err;
      var $32=(function() { try { __THREW__ = false; return __ZNK16expression_error6offsetEv($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $33
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($30, ((STRING_TABLE.__str975595)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,HEAP32[((tempInt+4)>>2)]=((__str985596)|0),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $34
      var $35=$2;
      var $36=$err;
      var $37=(function() { try { __THREW__ = false; return __ZNK16expression_error11code_stringEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $38
      (function() { try { __THREW__ = false; return __Z20debug_console_printfR15running_machinePKcz($35, ((STRING_TABLE.__str995597)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $39
      $1=0;
      $7=1;
      ___cxa_end_catch();
      __label__ = 14; break;
    case 12: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $5=$42;
      var $43=$41.f1;
      $6=$43;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $44
      __label__ = 15; break;
    case 14: // $45
      var $46=$1;
      ;
      return $46;
    case 15: // $47
      var $48=$5;
      var $49=$5;
      var $50=$6;
      var $51=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $49, tempValue);
      var $52=($51.f1 = $50, $51);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL34debug_command_parameter_expressionR15running_machinePKcR17parsed_expression["X"]=1;

function __ZNK12device_debug16breakpoint_firstEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1540)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug10breakpoint7enabledEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP8[($3)];
  var $5=(($4 << 24) >> 24)!=0;
  ;
  return $5;
}


function __ZNK12device_debug10breakpoint7addressEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug9observingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4 & 1;
  var $6=(($5)|0)!=0;
  ;
  return $6;
}


function __ZNK12device_debug10breakpoint9conditionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  var $4=__ZNK17parsed_expression15original_stringEv($3);
  ;
  return $4;
}


function __ZNK12device_debug10breakpoint6actionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+640)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZL11mini_printfR15running_machinePcPKciPy($machine, $buffer, $format, $params, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $f;
      var $p;
      var $c;
      var $width;
      var $zerofill;
      $2=$machine;
      $3=$buffer;
      $4=$format;
      $5=$params;
      $6=$param;
      var $7=$4;
      $f=$7;
      var $8=$3;
      $p=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$f;
      var $11=(($10+1)|0);
      $f=$11;
      var $12=HEAP8[($10)];
      $c=$12;
      var $13=$c;
      var $14=(($13 << 24) >> 24)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      __label__ = 46; break;
    case 3: // $16
      var $17=$c;
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0)==92;
      if ($19) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $20
      var $21=$f;
      var $22=(($21+1)|0);
      $f=$22;
      var $23=HEAP8[($21)];
      $c=$23;
      var $24=$c;
      var $25=(($24 << 24) >> 24)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $26
      __label__ = 46; break;
    case 6: // $27
      var $28=$c;
      var $29=(($28 << 24) >> 24);
      if ($29 == 92) {
        __label__ = 7; break;
      }
      else if ($29 == 110) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 7: // $30
      var $31=$c;
      var $32=$p;
      var $33=(($32+1)|0);
      $p=$33;
      HEAP8[($32)]=$31;
      __label__ = 10; break;
    case 8: // $34
      var $35=$p;
      var $36=(($35+1)|0);
      $p=$36;
      HEAP8[($35)]=10;
      __label__ = 10; break;
    case 9: // $37
      __label__ = 10; break;
    case 10: // $38
      __label__ = 1; break;
    case 11: // $39
      var $40=$c;
      var $41=(($40 << 24) >> 24);
      var $42=(($41)|0)==37;
      if ($42) { __label__ = 12; break; } else { __label__ = 43; break; }
    case 12: // $43
      $width=0;
      $zerofill=0;
      __label__ = 13; break;
    case 13: // $44
      var $45=$f;
      var $46=(($45+1)|0);
      $f=$46;
      var $47=HEAP8[($45)];
      $c=$47;
      var $48=$c;
      var $49=(($48 << 24) >> 24)!=0;
      if ($49) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $50
      var $51=$c;
      var $52=(($51 << 24) >> 24);
      var $53=(($52)|0) < 48;
      if ($53) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $54
      var $55=$c;
      var $56=(($55 << 24) >> 24);
      var $57=(($56)|0) > 57;
      if ($57) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $58
      __label__ = 21; break;
    case 17: // $59
      var $60=$c;
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)==48;
      if ($62) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $63
      var $64=$width;
      var $65=(($64)|0)==0;
      if ($65) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $66
      $zerofill=1;
      __label__ = 20; break;
    case 20: // $67
      var $68=$width;
      var $69=(($68*10)|0);
      var $70=$c;
      var $71=(($70 << 24) >> 24);
      var $72=(($71-48)|0);
      var $73=(($69+$72)|0);
      $width=$73;
      __label__ = 13; break;
    case 21: // $74
      var $75=$c;
      var $76=(($75 << 24) >> 24)!=0;
      if ($76) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $77
      __label__ = 46; break;
    case 23: // $78
      var $79=$c;
      var $80=(($79 << 24) >> 24);
      if ($80 == 37) {
        __label__ = 24; break;
      }
      else if ($80 == 88 || $80 == 120) {
        __label__ = 25; break;
      }
      else if ($80 == 68 || $80 == 100) {
        __label__ = 39; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 24: // $81
      var $82=$c;
      var $83=$p;
      var $84=(($83+1)|0);
      $p=$84;
      HEAP8[($83)]=$82;
      __label__ = 42; break;
    case 25: // $85
      var $86=$5;
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $88
      var $89=$2;
      __Z20debug_console_printfR15running_machinePKcz($89, ((STRING_TABLE.__str2465744)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $1=0;
      __label__ = 47; break;
    case 27: // $90
      var $91=$6;
      var $st$1$0=(($91)|0);
      var $92$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($91+4)|0);
      var $92$1=HEAP32[(($st$1$1)>>2)];
      var $93$0=$92$1;
      var $93$1=0;
      var $94$0=$93$0;
      var $94=$94$0;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $96
      var $97=$p;
      var $98=$zerofill;
      var $99=(($98)|0)!=0;
      var $100=$99 ? (((STRING_TABLE.__str2475745)|0)) : (((STRING_TABLE.__str2485746)|0));
      var $101=$width;
      var $102=(($101)|0) <= 8;
      if ($102) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $103
      var $108 = 1;__label__ = 31; break;
    case 30: // $104
      var $105=$width;
      var $106=(($105-8)|0);
      var $108 = $106;__label__ = 31; break;
    case 31: // $107
      var $108;
      var $109=$6;
      var $st$2$0=(($109)|0);
      var $110$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($109+4)|0);
      var $110$1=HEAP32[(($st$2$1)>>2)];
      var $111$0=$110$1;
      var $111$1=0;
      var $112$0=$111$0;
      var $112=$112$0;
      var $113=_sprintf($97, $100, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$108,HEAP32[((tempInt+4)>>2)]=$112,tempInt));
      var $114=$p;
      var $115=(($114+$113)|0);
      $p=$115;
      __label__ = 35; break;
    case 32: // $116
      var $117=$width;
      var $118=(($117)|0) > 8;
      if ($118) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $119
      var $120=$p;
      var $121=$zerofill;
      var $122=(($121)|0)!=0;
      var $123=$122 ? (((STRING_TABLE.__str2475745)|0)) : (((STRING_TABLE.__str2485746)|0));
      var $124=$width;
      var $125=(($124-8)|0);
      var $126=_sprintf($120, $123, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$125,HEAP32[((tempInt+4)>>2)]=0,tempInt));
      var $127=$p;
      var $128=(($127+$126)|0);
      $p=$128;
      __label__ = 34; break;
    case 34: // $129
      __label__ = 35; break;
    case 35: // $130
      var $131=$p;
      var $132=$zerofill;
      var $133=(($132)|0)!=0;
      var $134=$133 ? (((STRING_TABLE.__str2475745)|0)) : (((STRING_TABLE.__str2485746)|0));
      var $135=$width;
      var $136=(($135)|0) < 8;
      if ($136) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $137
      var $138=$width;
      var $141 = $138;__label__ = 38; break;
    case 37: // $139
      var $141 = 8;__label__ = 38; break;
    case 38: // $140
      var $141;
      var $142=$6;
      var $st$2$0=(($142)|0);
      var $143$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($142+4)|0);
      var $143$1=HEAP32[(($st$2$1)>>2)];
      var $144$0=$143$0;
      var $144=$144$0;
      var $145=_sprintf($131, $134, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$141,HEAP32[((tempInt+4)>>2)]=$144,tempInt));
      var $146=$p;
      var $147=(($146+$145)|0);
      $p=$147;
      var $148=$6;
      var $149=(($148+8)|0);
      $6=$149;
      var $150=$5;
      var $151=(($150-1)|0);
      $5=$151;
      __label__ = 42; break;
    case 39: // $152
      var $153=$5;
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $155
      var $156=$2;
      __Z20debug_console_printfR15running_machinePKcz($156, ((STRING_TABLE.__str2465744)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $1=0;
      __label__ = 47; break;
    case 41: // $157
      var $158=$p;
      var $159=$zerofill;
      var $160=(($159)|0)!=0;
      var $161=$160 ? (((STRING_TABLE.__str2495747)|0)) : (((STRING_TABLE.__str2505748)|0));
      var $162=$width;
      var $163=$6;
      var $st$6$0=(($163)|0);
      var $164$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($163+4)|0);
      var $164$1=HEAP32[(($st$6$1)>>2)];
      var $165$0=$164$0;
      var $165=$165$0;
      var $166=_sprintf($158, $161, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$162,HEAP32[((tempInt+4)>>2)]=$165,tempInt));
      var $167=$p;
      var $168=(($167+$166)|0);
      $p=$168;
      var $169=$6;
      var $170=(($169+8)|0);
      $6=$170;
      var $171=$5;
      var $172=(($171-1)|0);
      $5=$172;
      __label__ = 42; break;
    case 42: // $173
      __label__ = 44; break;
    case 43: // $174
      var $175=$c;
      var $176=$p;
      var $177=(($176+1)|0);
      $p=$177;
      HEAP8[($176)]=$175;
      __label__ = 44; break;
    case 44: // $178
      __label__ = 45; break;
    case 45: // $179
      __label__ = 1; break;
    case 46: // $180
      var $181=$p;
      HEAP8[($181)]=0;
      $1=1;
      __label__ = 47; break;
    case 47: // $182
      var $183=$1;
      ;
      return $183;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11mini_printfR15running_machinePcPKciPy["X"]=1;

function __Z26ui_image_menu_file_managerR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $event;
      var $menustate;
      var $child_menu;
      var $child_menustate;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($8, 12, 1294);
      $4=$9;
      var $10=$4;
      var $11=$10;
      $menustate=$11;
      var $12=__Z13astring_allocv();
      var $13=$menustate;
      var $14=(($13+4)|0);
      HEAP32[(($14)>>2)]=$12;
      var $15=__Z13astring_allocv();
      var $16=$menustate;
      var $17=(($16+8)|0);
      HEAP32[(($17)>>2)]=$15;
      __label__ = 2; break;
    case 2: // $18
      var $19=$4;
      var $20=$19;
      $menustate=$20;
      var $21=$2;
      var $22=__Z17ui_menu_populatedP7ui_menu($21);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=$1;
      var $26=$2;
      var $27=$4;
      __ZL26menu_file_manager_populateR15running_machineP7ui_menuPv($25, $26, $27);
      __label__ = 4; break;
    case 4: // $28
      var $29=$2;
      var $30=__Z21ui_menu_get_selectionP7ui_menu($29);
      var $31=$30;
      var $32=$menustate;
      var $33=(($32)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$1;
      var $35=$2;
      var $36=__Z15ui_menu_processR15running_machineP7ui_menuj($34, $35, 0);
      $event=$36;
      var $37=$event;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $39
      var $40=$event;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==182;
      if ($43) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $44
      var $45=$event;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$47;
      var $49=$menustate;
      var $50=(($49)|0);
      HEAP32[(($50)>>2)]=$48;
      var $51=$menustate;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $55
      var $56=$menustate;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      __ZL21fix_working_directoryP22device_image_interface($58);
      var $59=$menustate;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$menustate;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=__ZN22device_image_interface17working_directoryEv($64);
      var $66=__Z12astring_cpycP7astringPKc($61, $65);
      var $67=$menustate;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$menustate;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=__ZN22device_image_interface6existsEv($72);
      if ($73) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $74
      var $75=$menustate;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=__ZN22device_image_interface8basenameEv($77);
      var $81 = $78;__label__ = 10; break;
    case 9: // $79
      var $81 = ((__str5754)|0);__label__ = 10; break;
    case 10: // $80
      var $81;
      var $82=__Z12astring_cpycP7astringPKc($69, $81);
      var $83=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($83, 1);
      var $84=$1;
      var $85=$1;
      var $86=__ZNK15running_machine6renderEv($85);
      var $87=__ZNK14render_manager12ui_containerEv($86);
      var $88=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($84, $87, 1296, 0);
      $child_menu=$88;
      var $89=$child_menu;
      var $90=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($89, 1032, 0);
      var $91=$90;
      $child_menustate=$91;
      var $92=$menustate;
      var $93=$child_menustate;
      var $94=(($93)|0);
      HEAP32[(($94)>>2)]=$92;
      var $95=$child_menu;
      __Z18ui_menu_stack_pushP7ui_menu($95);
      __label__ = 11; break;
    case 11: // $96
      __label__ = 12; break;
    case 12: // $97
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26ui_image_menu_file_managerR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL26file_manager_destroy_stateP7ui_menuPv($menu, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $menustate;
      $1=$menu;
      $2=$state;
      var $3=$2;
      var $4=$3;
      $menustate=$4;
      var $5=$menustate;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$menustate;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      __Z12astring_freeP7astring($12);
      __label__ = 2; break;
    case 2: // $13
      var $14=$menustate;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$menustate;
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      __Z12astring_freeP7astring($21);
      __label__ = 4; break;
    case 4: // $22
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21fix_working_directoryP22device_image_interface($image) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $astr;
      $1=$image;
      var $2=$1;
      var $3=__ZN22device_image_interface6existsEv($2);
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=__Z13astring_allocv();
      $astr=$5;
      var $6=$astr;
      var $7=$1;
      var $8=__ZN22device_image_interface8filenameEv($7);
      var $9=__Z14zippath_parentP7astringPKc($6, $8);
      var $10=$1;
      var $11=$astr;
      var $12=__Z9astring_cPK7astring($11);
      __ZN22device_image_interface21set_working_directoryEPKc($10, $12);
      var $13=$astr;
      __Z12astring_freeP7astring($13);
      __label__ = 2; break;
    case 2: // $14
      var $15=$1;
      var $16=__ZN22device_image_interface17working_directoryEv($15);
      var $17=__ZL10check_pathPKc($16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$1;
      __ZN22device_image_interface21set_working_directoryEPKc($20, ((__str5754)|0));
      __label__ = 4; break;
    case 4: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL26menu_file_manager_populateR15running_machineP7ui_menuPv($machine, $menu, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 2116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buffer=__stackBase__;
      var $image=__stackBase__+2048;
      var $tmp_name=__stackBase__+2052;
      var $gotone;
      var $4;
      var $5;
      var $tmp;
      $1=$machine;
      $2=$menu;
      $3=$state;
      HEAP32[(($image)>>2)]=0;
      __ZN7astringC1Ev($tmp_name);
      var $6=$1;
      var $7=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 24; break; };
    case 1: // $8
      var $9=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI22device_image_interfaceEEbRPT_($7, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 24; break; };
    case 2: // $10
      var $11=(($9)&1);
      $gotone=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$gotone;
      var $14=(($13) & 1);
      if ($14) { __label__ = 4; break; } else { __label__ = 36; break; }
    case 4: // $15
      var $16=(($buffer)|0);
      var $17=HEAP32[(($image)>>2)];
      var $18=$17;
      var $19=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 24; break; };
    case 5: // $20
      var $21=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 24; break; };
    case 6: // $22
      var $23=HEAP32[(($image)>>2)];
      var $24=(function() { try { __THREW__ = false; return __ZNK22device_image_interface19brief_instance_nameEv($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 24; break; };
    case 7: // $25
      var $26=(function() { try { __THREW__ = false; return _snprintf($16, 2048, ((STRING_TABLE.__str395793)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$21,HEAP32[((tempInt+4)>>2)]=$24,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 24; break; };
    case 8: // $27
      var $28=HEAP32[(($image)>>2)];
      var $29=(function() { try { __THREW__ = false; return __ZN22device_image_interface8basenameEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 24; break; };
    case 9: // $30
      var $31=(($29)|0)!=0;
      if ($31) { __label__ = 10; break; } else { __label__ = 29; break; }
    case 10: // $32
      var $33=HEAP32[(($image)>>2)];
      var $34=(function() { try { __THREW__ = false; return __ZN22device_image_interface8basenameEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 24; break; };
    case 11: // $35
      var $36=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tmp_name, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 24; break; };
    case 12: // $37
      var $38=HEAP32[(($image)>>2)];
      var $39=(function() { try { __THREW__ = false; return __ZN22device_image_interface10part_entryEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 24; break; };
    case 13: // $40
      var $41=(($39)|0)!=0;
      if ($41) { __label__ = 14; break; } else { __label__ = 28; break; }
    case 14: // $42
      var $43=HEAP32[(($image)>>2)];
      var $44=(function() { try { __THREW__ = false; return __ZN22device_image_interface10part_entryEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 24; break; };
    case 15: // $45
      $tmp=$44;
      var $46=$tmp;
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 16; break; } else { __label__ = 27; break; }
    case 16: // $50
      var $51=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tmp_name, ((STRING_TABLE.__str405794)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 24; break; };
    case 17: // $52
      var $53=$tmp;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tmp_name, $55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 24; break; };
    case 18: // $57
      var $58=HEAP32[(($image)>>2)];
      var $59=(function() { try { __THREW__ = false; return __ZN22device_image_interface11get_featureEPKc($58, ((STRING_TABLE.__str415795)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 24; break; };
    case 19: // $60
      var $61=(($59)|0)!=0;
      if ($61) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 20: // $62
      var $63=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tmp_name, ((STRING_TABLE.__str425796)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 24; break; };
    case 21: // $64
      var $65=HEAP32[(($image)>>2)];
      var $66=(function() { try { __THREW__ = false; return __ZN22device_image_interface11get_featureEPKc($65, ((STRING_TABLE.__str415795)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; };
    case 22: // $67
      var $68=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tmp_name, $66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; };
    case 23: // $69
      __label__ = 25; break;
    case 24: // $70
      var $71=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $72=$71.f0;
      $4=$72;
      var $73=$71.f1;
      $5=$73;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tmp_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 25: // $74
      var $75=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($tmp_name, ((STRING_TABLE.__str435797)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 24; break; };
    case 26: // $76
      __label__ = 27; break;
    case 27: // $77
      __label__ = 28; break;
    case 28: // $78
      __label__ = 31; break;
    case 29: // $79
      var $80=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tmp_name, ((STRING_TABLE.__str265780)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 24; break; };
    case 30: // $81
      __label__ = 31; break;
    case 31: // $82
      var $83=$2;
      var $84=(($buffer)|0);
      var $85=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tmp_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 24; break; };
    case 32: // $86
      var $87=HEAP32[(($image)>>2)];
      var $88=$87;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($83, $84, $85, 0, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 24; break; }
    case 33: // $89
      __label__ = 34; break;
    case 34: // $90
      var $91=HEAP32[(($image)>>2)];
      var $92=$91;
      var $93=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($92, $image) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 24; break; };
    case 35: // $94
      var $95=(($93)&1);
      $gotone=$95;
      __label__ = 3; break;
    case 36: // $96
      var $97=$2;
      var $98=$1;
      var $99=(function() { try { __THREW__ = false; return __Z18ui_get_line_heightR15running_machine($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 24; break; };
    case 37: // $100
      var $101=$99+0.029999999329447746;
      (function() { try { __THREW__ = false; return __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($97, 1292, 0, $101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 24; break; }
    case 38: // $102
      FUNCTION_TABLE[__ZN7astringD1Ev]($tmp_name);
      STACKTOP = __stackBase__;
      return;
    case 39: // $103
      __label__ = 40; break;
    case 40: // $104
      var $105=$4;
      var $106=$4;
      var $107=$5;
      var $108=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $106, tempValue);
      var $109=($108.f1 = $107, $108);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 41: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26menu_file_manager_populateR15running_machineP7ui_menuPv["X"]=1;

function __ZL18menu_file_selectorR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $err;
      var $event;
      var $child_menu;
      var $menustate;
      var $child_menustate;
      var $entry;
      var $selected_entry;
      var $bestmatch;
      var $buflen;
      var $update_selected;
      var $cur_selected;
      var $match;
      var $i;
      var $match1;
      var $i2;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      $selected_entry=0;
      $bestmatch=0;
      var $5=$4;
      var $6=$5;
      $menustate=$6;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      var $13=$menustate;
      var $14=__ZL27menu_file_selector_populateR15running_machineP7ui_menuP25_file_selector_menu_state($11, $12, $13);
      $err=$14;
      var $15=$err;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$1;
      __Z17ui_menu_stack_popR15running_machine($18);
      __label__ = 70; break;
    case 3: // $19
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      var $22=$2;
      var $23=__Z15ui_menu_processR15running_machineP7ui_menuj($21, $22, 0);
      $event=$23;
      var $24=$event;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 70; break; }
    case 5: // $26
      var $27=$event;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 6; break; } else { __label__ = 70; break; }
    case 6: // $31
      var $32=$event;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)==182;
      if ($35) { __label__ = 7; break; } else { __label__ = 18; break; }
    case 7: // $36
      var $37=$event;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      $entry=$40;
      var $41=$entry;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      if ($43 == 0) {
        __label__ = 8; break;
      }
      else if ($43 == 1) {
        __label__ = 9; break;
      }
      else if ($43 == 2) {
        __label__ = 10; break;
      }
      else if ($43 == 3 || $43 == 4) {
        __label__ = 11; break;
      }
      else if ($43 == 5) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 8: // $44
      var $45=$menustate;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      __ZN22device_image_interface6unloadEv($49);
      var $50=$1;
      __Z17ui_menu_stack_popR15running_machine($50);
      __label__ = 15; break;
    case 9: // $51
      var $52=$1;
      var $53=$1;
      var $54=__ZNK15running_machine6renderEv($53);
      var $55=__ZNK14render_manager12ui_containerEv($54);
      var $56=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($52, $55, 1298, 0);
      $child_menu=$56;
      var $57=$child_menu;
      var $58=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($57, 1036, 0);
      var $59=$58;
      $child_menustate=$59;
      var $60=$menustate;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$child_menustate;
      var $64=(($63)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=$child_menu;
      __Z18ui_menu_stack_pushP7ui_menu($65);
      __label__ = 15; break;
    case 10: // $66
      var $67=$1;
      var $68=$1;
      var $69=__ZNK15running_machine6renderEv($68);
      var $70=__ZNK14render_manager12ui_containerEv($69);
      var $71=$menustate;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$75;
      var $77=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($67, $70, 1300, $76);
      $child_menu=$77;
      var $78=$child_menu;
      __Z18ui_menu_stack_pushP7ui_menu($78);
      __label__ = 15; break;
    case 11: // $79
      var $80=$entry;
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=__ZL10check_pathPKc($82);
      $err=$83;
      var $84=$err;
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $86
      var $87=$entry;
      var $88=(($87+12)|0);
      var $89=HEAP32[(($88)>>2)];
      __Z13ui_popup_timeiPKcz(1, ((STRING_TABLE.__str195773)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$89,tempInt));
      __label__ = 15; break;
    case 13: // $90
      var $91=$menustate;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$entry;
      var $97=(($96+12)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=__Z12astring_cpycP7astringPKc($95, $98);
      var $100=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($100, 0);
      __label__ = 15; break;
    case 14: // $101
      var $102=$menustate;
      var $103=(($102)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$entry;
      var $108=(($107+12)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=__ZN22device_image_interface4loadEPKc($106, $109);
      var $111=$1;
      __Z17ui_menu_stack_popR15running_machine($111);
      __label__ = 15; break;
    case 15: // $112
      var $113=$menustate;
      var $114=(($113+8)|0);
      var $115=(($114)|0);
      var $116=HEAP8[($115)];
      var $117=(($116 << 24) >> 24);
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $119
      var $120=$menustate;
      var $121=(($120+8)|0);
      var $122=(($121)|0);
      _memset($122, 0, 1024, 1);
      __label__ = 17; break;
    case 17: // $123
      __label__ = 69; break;
    case 18: // $124
      var $125=$event;
      var $126=(($125+4)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0)==214;
      if ($128) { __label__ = 19; break; } else { __label__ = 63; break; }
    case 19: // $129
      var $130=$menustate;
      var $131=(($130+8)|0);
      var $132=(($131)|0);
      var $133=_strlen($132);
      $buflen=$133;
      $update_selected=0;
      var $134=$event;
      var $135=(($134+8)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0)==8;
      if ($137) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $138
      var $139=$event;
      var $140=(($139+8)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141)|0)==127;
      if ($142) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $143
      var $144=$buflen;
      var $145=(($144)|0) > 0;
      if ($145) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $146
      var $147=$buflen;
      var $148=$menustate;
      var $149=(($148+8)|0);
      var $150=(($149+$147)|0);
      var $151=__Z18utf8_previous_charPKc($150);
      HEAP8[($151)]=0;
      $update_selected=1;
      var $152=$menustate;
      var $153=(($152+8)|0);
      var $154=(($153)|0);
      __Z13ui_popup_timeiPKcz(5, ((STRING_TABLE.__str205774)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$154,tempInt));
      __label__ = 27; break;
    case 23: // $155
      var $156=$event;
      var $157=(($156+8)|0);
      var $158=HEAPU32[(($157)>>2)];
      var $159=(($158)>>>0) >= 32;
      if ($159) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $160
      var $161=$event;
      var $162=(($161+8)|0);
      var $163=HEAPU32[(($162)>>2)];
      var $164=(($163)>>>0) < 127;
      if ($164) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $165
      var $166=$buflen;
      var $167=$menustate;
      var $168=(($167+8)|0);
      var $169=(($168+$166)|0);
      var $170=$buflen;
      var $171=((1024-$170)|0);
      var $172=$event;
      var $173=(($172+8)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=__Z15utf8_from_ucharPcjj($169, $171, $174);
      var $176=$buflen;
      var $177=(($176+$175)|0);
      $buflen=$177;
      var $178=$buflen;
      var $179=$menustate;
      var $180=(($179+8)|0);
      var $181=(($180+$178)|0);
      HEAP8[($181)]=0;
      $update_selected=1;
      var $182=$menustate;
      var $183=(($182+8)|0);
      var $184=(($183)|0);
      __Z13ui_popup_timeiPKcz(5, ((STRING_TABLE.__str205774)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$184,tempInt));
      __label__ = 26; break;
    case 26: // $185
      __label__ = 27; break;
    case 27: // $186
      var $187=$update_selected;
      var $188=(($187) & 1);
      if ($188) { __label__ = 28; break; } else { __label__ = 62; break; }
    case 28: // $189
      var $190=$2;
      var $191=__Z21ui_menu_get_selectionP7ui_menu($190);
      var $192=$191;
      $cur_selected=$192;
      var $193=$cur_selected;
      $entry=$193;
      __label__ = 29; break;
    case 29: // $194
      var $195=$entry;
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 30; break; } else { __label__ = 43; break; }
    case 30: // $197
      var $198=$entry;
      var $199=(($198+8)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200)|0)!=0;
      if ($201) { __label__ = 31; break; } else { __label__ = 41; break; }
    case 31: // $202
      var $203=$menustate;
      var $204=(($203+8)|0);
      var $205=(($204)|0);
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 32; break; } else { __label__ = 41; break; }
    case 32: // $207
      $match=0;
      $i=0;
      __label__ = 33; break;
    case 33: // $208
      var $209=$i;
      var $210=(($209)>>>0) < 1024;
      if ($210) { __label__ = 34; break; } else { __label__ = 38; break; }
    case 34: // $211
      var $212=$entry;
      var $213=(($212+8)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=$menustate;
      var $216=(($215+8)|0);
      var $217=(($216)|0);
      var $218=$i;
      var $219=__Z13core_strnicmpPKcS0_j($214, $217, $218);
      var $220=(($219)|0)==0;
      if ($220) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $221
      var $222=$i;
      $match=$222;
      __label__ = 36; break;
    case 36: // $223
      __label__ = 37; break;
    case 37: // $224
      var $225=$i;
      var $226=(($225+1)|0);
      $i=$226;
      __label__ = 33; break;
    case 38: // $227
      var $228=$match;
      var $229=$bestmatch;
      var $230=(($228)|0) > (($229)|0);
      if ($230) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $231
      var $232=$match;
      $bestmatch=$232;
      var $233=$entry;
      $selected_entry=$233;
      __label__ = 40; break;
    case 40: // $234
      __label__ = 41; break;
    case 41: // $235
      __label__ = 42; break;
    case 42: // $236
      var $237=$entry;
      var $238=(($237)|0);
      var $239=HEAP32[(($238)>>2)];
      $entry=$239;
      __label__ = 29; break;
    case 43: // $240
      var $241=$menustate;
      var $242=(($241+4)|0);
      var $243=HEAP32[(($242)>>2)];
      $entry=$243;
      __label__ = 44; break;
    case 44: // $244
      var $245=$entry;
      var $246=$cur_selected;
      var $247=(($245)|0)!=(($246)|0);
      if ($247) { __label__ = 45; break; } else { __label__ = 58; break; }
    case 45: // $248
      var $249=$entry;
      var $250=(($249+8)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($251)|0)!=0;
      if ($252) { __label__ = 46; break; } else { __label__ = 56; break; }
    case 46: // $253
      var $254=$menustate;
      var $255=(($254+8)|0);
      var $256=(($255)|0);
      var $257=(($256)|0)!=0;
      if ($257) { __label__ = 47; break; } else { __label__ = 56; break; }
    case 47: // $258
      $match1=0;
      $i2=0;
      __label__ = 48; break;
    case 48: // $259
      var $260=$i2;
      var $261=(($260)>>>0) < 1024;
      if ($261) { __label__ = 49; break; } else { __label__ = 53; break; }
    case 49: // $262
      var $263=$entry;
      var $264=(($263+8)|0);
      var $265=HEAP32[(($264)>>2)];
      var $266=$menustate;
      var $267=(($266+8)|0);
      var $268=(($267)|0);
      var $269=$i2;
      var $270=__Z13core_strnicmpPKcS0_j($265, $268, $269);
      var $271=(($270)|0)==0;
      if ($271) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $272
      var $273=$i2;
      $match1=$273;
      __label__ = 51; break;
    case 51: // $274
      __label__ = 52; break;
    case 52: // $275
      var $276=$i2;
      var $277=(($276+1)|0);
      $i2=$277;
      __label__ = 48; break;
    case 53: // $278
      var $279=$match1;
      var $280=$bestmatch;
      var $281=(($279)|0) > (($280)|0);
      if ($281) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $282
      var $283=$match1;
      $bestmatch=$283;
      var $284=$entry;
      $selected_entry=$284;
      __label__ = 55; break;
    case 55: // $285
      __label__ = 56; break;
    case 56: // $286
      __label__ = 57; break;
    case 57: // $287
      var $288=$entry;
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      $entry=$290;
      __label__ = 44; break;
    case 58: // $291
      var $292=$selected_entry;
      var $293=(($292)|0)!=0;
      if ($293) { __label__ = 59; break; } else { __label__ = 61; break; }
    case 59: // $294
      var $295=$selected_entry;
      var $296=$cur_selected;
      var $297=(($295)|0)!=(($296)|0);
      if ($297) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $298
      var $299=$2;
      var $300=$selected_entry;
      var $301=$300;
      __Z21ui_menu_set_selectionP7ui_menuPv($299, $301);
      __label__ = 61; break;
    case 61: // $302
      __label__ = 62; break;
    case 62: // $303
      __label__ = 68; break;
    case 63: // $304
      var $305=$event;
      var $306=(($305+4)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=(($307)|0)==183;
      if ($308) { __label__ = 64; break; } else { __label__ = 67; break; }
    case 64: // $309
      var $310=$menustate;
      var $311=(($310+8)|0);
      var $312=(($311)|0);
      var $313=HEAP8[($312)];
      var $314=(($313 << 24) >> 24);
      var $315=(($314)|0)!=0;
      if ($315) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $316
      var $317=$menustate;
      var $318=(($317+8)|0);
      var $319=(($318)|0);
      _memset($319, 0, 1024, 1);
      __label__ = 66; break;
    case 66: // $320
      __label__ = 67; break;
    case 67: // $321
      __label__ = 68; break;
    case 68: // $322
      __label__ = 69; break;
    case 69: // $323
      __label__ = 70; break;
    case 70: // $324
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18menu_file_selectorR15running_machineP7ui_menuPvS3_["X"]=1;

function __Z24ui_image_menu_image_infoR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $tempstring;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$2;
      var $6=__Z17ui_menu_populatedP7ui_menu($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=__Z13astring_allocv();
      var $11=__Z18image_info_astringR15running_machineP7astring($9, $10);
      $tempstring=$11;
      var $12=$2;
      var $13=$tempstring;
      var $14=__Z9astring_cPK7astring($13);
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($12, $14, 0, 8, 0);
      var $15=$tempstring;
      __Z12astring_freeP7astring($15);
      __label__ = 2; break;
    case 2: // $16
      var $17=$1;
      var $18=$2;
      var $19=__Z15ui_menu_processR15running_machineP7ui_menuj($17, $18, 0);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19tapecontrol_gettimeP7astringP21cassette_image_devicePiS3_($dest, $cassette, $curpos, $endpos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $t0;
      var $t1;
      $1=$dest;
      $2=$cassette;
      $3=$curpos;
      $4=$endpos;
      var $5=$2;
      var $6=__ZN21cassette_image_device12get_positionEv($5);
      $t0=$6;
      var $7=$2;
      var $8=__ZN21cassette_image_device10get_lengthEv($7);
      $t1=$8;
      var $9=$t1;
      var $10=$9 != 0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$1;
      var $13=$t0;
      var $14=(($13)|0);
      var $15=$t1;
      var $16=(($15)|0);
      var $17=__Z14astring_printfP7astringPKcz($12, ((STRING_TABLE.__str15755)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,HEAP32[((tempInt+4)>>2)]=$16,tempInt));
      __label__ = 3; break;
    case 2: // $18
      var $19=$1;
      var $20=$t1;
      var $21=(($20)|0);
      var $22=__Z14astring_printfP7astringPKcz($19, ((STRING_TABLE.__str15755)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,HEAP32[((tempInt+4)>>2)]=$21,tempInt));
      __label__ = 3; break;
    case 3: // $23
      var $24=$3;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$t0;
      var $28=(($27)|0);
      var $29=$3;
      HEAP32[(($29)>>2)]=$28;
      __label__ = 5; break;
    case 5: // $30
      var $31=$4;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      var $34=$t1;
      var $35=(($34)|0);
      var $36=$4;
      HEAP32[(($36)>>2)]=$35;
      __label__ = 7; break;
    case 7: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z25ui_mess_menu_tape_controlR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menustate;
      var $event;
      var $index;
      var $device=__stackBase__;
      var $gotone;
      var $cassette;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($8, 8, 0);
      $4=$9;
      __label__ = 2; break;
    case 2: // $10
      var $11=$4;
      var $12=$11;
      $menustate=$12;
      var $13=$menustate;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $17
      var $18=$menustate;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $index=$20;
      HEAP32[(($device)>>2)]=0;
      var $21=$1;
      var $22=__ZNK15running_machine10devicelistEv($21);
      var $23=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($22, $device);
      var $24=(($23)&1);
      $gotone=$24;
      __label__ = 4; break;
    case 4: // $25
      var $26=$gotone;
      var $27=(($26) & 1);
      if ($27) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $28
      var $29=HEAP32[(($device)>>2)];
      var $30=$29;
      var $31=__ZN16device_interface6deviceEv($30);
      var $32=__ZNK8device_t4typeEv($31);
      var $33=HEAP32[((_CASSETTE)>>2)];
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $35
      var $36=$index;
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      __label__ = 11; break;
    case 8: // $39
      var $40=$index;
      var $41=(($40-1)|0);
      $index=$41;
      __label__ = 9; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      var $44=HEAP32[(($device)>>2)];
      var $45=$44;
      var $46=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($45, $device);
      var $47=(($46)&1);
      $gotone=$47;
      __label__ = 4; break;
    case 11: // $48
      var $49=HEAP32[(($device)>>2)];
      var $50=$menustate;
      var $51=(($50+4)|0);
      HEAP32[(($51)>>2)]=$49;
      var $52=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($52, 0);
      __label__ = 12; break;
    case 12: // $53
      var $54=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($54, 1);
      var $55=$1;
      var $56=$2;
      var $57=$4;
      var $58=$57;
      __ZL26menu_tape_control_populateR15running_machineP7ui_menuP24_tape_control_menu_state($55, $56, $58);
      var $59=$menustate;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=__ZN16device_interface6deviceEv($62);
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $65
      var $66=$63;
      var $67=___dynamic_cast($66, __ZTI8device_t, __ZTI21cassette_image_device, -1);
      var $68=$67;
      var $71 = $68;__label__ = 15; break;
    case 14: // $69
      var $71 = 0;__label__ = 15; break;
    case 15: // $70
      var $71;
      $cassette=$71;
      var $72=$1;
      var $73=$2;
      var $74=__Z15ui_menu_processR15running_machineP7ui_menuj($72, $73, 2);
      $event=$74;
      var $75=$event;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 16; break; } else { __label__ = 54; break; }
    case 16: // $77
      var $78=$event;
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      if ($80 == 176) {
        __label__ = 17; break;
      }
      else if ($80 == 177) {
        __label__ = 26; break;
      }
      else if ($80 == 182) {
        __label__ = 35; break;
      }
      else {
      __label__ = 53; break;
      }
      
    case 17: // $81
      var $82=$event;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84)|0)==6;
      if ($85) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $86
      var $87=$cassette;
      __ZN21cassette_image_device4seekEdi($87, -1, 1);
      __label__ = 25; break;
    case 19: // $88
      var $89=$event;
      var $90=(($89)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91)|0)==7;
      if ($92) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $93
      var $94=$menustate;
      var $95=(($94)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0) > 0;
      if ($97) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $98
      var $99=$menustate;
      var $100=(($99)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101-1)|0);
      HEAP32[(($100)>>2)]=$102;
      __label__ = 23; break;
    case 22: // $103
      var $104=$1;
      var $105=__ZL14cassette_countR15running_machine($104);
      var $106=(($105-1)|0);
      var $107=$menustate;
      var $108=(($107)|0);
      HEAP32[(($108)>>2)]=$106;
      __label__ = 23; break;
    case 23: // $109
      var $110=$menustate;
      var $111=(($110+4)|0);
      HEAP32[(($111)>>2)]=0;
      __label__ = 24; break;
    case 24: // $112
      __label__ = 25; break;
    case 25: // $113
      __label__ = 53; break;
    case 26: // $114
      var $115=$event;
      var $116=(($115)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117)|0)==6;
      if ($118) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $119
      var $120=$cassette;
      __ZN21cassette_image_device4seekEdi($120, 1, 1);
      __label__ = 34; break;
    case 28: // $121
      var $122=$event;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124)|0)==7;
      if ($125) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $126
      var $127=$menustate;
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$1;
      var $131=__ZL14cassette_countR15running_machine($130);
      var $132=(($131-1)|0);
      var $133=(($129)|0) < (($132)|0);
      if ($133) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $134
      var $135=$menustate;
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+1)|0);
      HEAP32[(($136)>>2)]=$138;
      __label__ = 32; break;
    case 31: // $139
      var $140=$menustate;
      var $141=(($140)|0);
      HEAP32[(($141)>>2)]=0;
      __label__ = 32; break;
    case 32: // $142
      var $143=$menustate;
      var $144=(($143+4)|0);
      HEAP32[(($144)>>2)]=0;
      __label__ = 33; break;
    case 33: // $145
      __label__ = 34; break;
    case 34: // $146
      __label__ = 53; break;
    case 35: // $147
      var $148=$event;
      var $149=(($148)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150)|0)==1;
      if ($151) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $152
      var $153=$cassette;
      __ZN21cassette_image_device12change_stateE15_cassette_stateS0_($153, 0, 3);
      __label__ = 52; break;
    case 37: // $154
      var $155=$event;
      var $156=(($155)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0)==2;
      if ($158) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $159
      var $160=$cassette;
      __ZN21cassette_image_device12change_stateE15_cassette_stateS0_($160, 1, 3);
      __label__ = 51; break;
    case 39: // $161
      var $162=$event;
      var $163=(($162)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164)|0)==3;
      if ($165) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $166
      var $167=$cassette;
      __ZN21cassette_image_device12change_stateE15_cassette_stateS0_($167, 2, 3);
      __label__ = 50; break;
    case 41: // $168
      var $169=$event;
      var $170=(($169)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171)|0)==4;
      if ($172) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $173
      var $174=$cassette;
      __ZN21cassette_image_device4seekEdi($174, -30, 1);
      __label__ = 49; break;
    case 43: // $175
      var $176=$event;
      var $177=(($176)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=(($178)|0)==5;
      if ($179) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $180
      var $181=$cassette;
      __ZN21cassette_image_device4seekEdi($181, 30, 1);
      __label__ = 48; break;
    case 45: // $182
      var $183=$event;
      var $184=(($183)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185)|0)==6;
      if ($186) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $187
      var $188=$cassette;
      __ZN21cassette_image_device4seekEdi($188, 0, 0);
      __label__ = 47; break;
    case 47: // $189
      __label__ = 48; break;
    case 48: // $190
      __label__ = 49; break;
    case 49: // $191
      __label__ = 50; break;
    case 50: // $192
      __label__ = 51; break;
    case 51: // $193
      __label__ = 52; break;
    case 52: // $194
      __label__ = 53; break;
    case 53: // $195
      __label__ = 54; break;
    case 54: // $196
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z25ui_mess_menu_tape_controlR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL14cassette_countR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $count;
      var $device;
      $1=$machine;
      $count=0;
      var $2=$1;
      var $3=__ZNK15running_machine10devicelistEv($2);
      var $4=HEAP32[((_CASSETTE)>>2)];
      var $5=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($3, $4);
      $device=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$device;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$count;
      var $11=(($10+1)|0);
      $count=$11;
      var $12=$device;
      var $13=__ZNK8device_t8typenextEv($12);
      $device=$13;
      __label__ = 1; break;
    case 3: // $14
      var $15=$count;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z30ui_mess_menu_bitbanger_controlR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $menustate;
      var $event;
      var $index;
      var $device=__stackBase__;
      var $gotone;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($8, 8, 0);
      $4=$9;
      __label__ = 2; break;
    case 2: // $10
      var $11=$4;
      var $12=$11;
      $menustate=$12;
      var $13=$menustate;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $17
      var $18=$menustate;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $index=$20;
      HEAP32[(($device)>>2)]=0;
      var $21=$1;
      var $22=__ZNK15running_machine10devicelistEv($21);
      var $23=__ZNK11device_list5firstI22device_image_interfaceEEbRPT_($22, $device);
      var $24=(($23)&1);
      $gotone=$24;
      __label__ = 4; break;
    case 4: // $25
      var $26=$gotone;
      var $27=(($26) & 1);
      if ($27) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $28
      var $29=HEAP32[(($device)>>2)];
      var $30=$29;
      var $31=__ZN16device_interface6deviceEv($30);
      var $32=__ZNK8device_t4typeEv($31);
      var $33=HEAP32[((_BITBANGER)>>2)];
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $35
      var $36=$index;
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      __label__ = 11; break;
    case 8: // $39
      var $40=$index;
      var $41=(($40-1)|0);
      $index=$41;
      __label__ = 9; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      var $44=HEAP32[(($device)>>2)];
      var $45=$44;
      var $46=__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_($45, $device);
      var $47=(($46)&1);
      $gotone=$47;
      __label__ = 4; break;
    case 11: // $48
      var $49=HEAP32[(($device)>>2)];
      var $50=$menustate;
      var $51=(($50+4)|0);
      HEAP32[(($51)>>2)]=$49;
      var $52=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($52, 0);
      __label__ = 12; break;
    case 12: // $53
      var $54=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($54, 1);
      var $55=$1;
      var $56=$2;
      var $57=$4;
      var $58=$57;
      __ZL31menu_bitbanger_control_populateR15running_machineP7ui_menuP29_bitbanger_control_menu_state($55, $56, $58);
      var $59=$1;
      var $60=$2;
      var $61=__Z15ui_menu_processR15running_machineP7ui_menuj($59, $60, 2);
      $event=$61;
      var $62=$event;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 13; break; } else { __label__ = 45; break; }
    case 13: // $64
      var $65=$event;
      var $66=(($65+4)|0);
      var $67=HEAP32[(($66)>>2)];
      if ($67 == 176) {
        __label__ = 14; break;
      }
      else if ($67 == 177) {
        __label__ = 29; break;
      }
      else {
      __label__ = 44; break;
      }
      
    case 14: // $68
      var $69=$event;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $73
      var $74=$menustate;
      var $75=(($74)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0) > 0;
      if ($77) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $78
      var $79=$menustate;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81-1)|0);
      HEAP32[(($80)>>2)]=$82;
      __label__ = 18; break;
    case 17: // $83
      var $84=$1;
      var $85=__ZL15bitbanger_countR15running_machine($84);
      var $86=(($85-1)|0);
      var $87=$menustate;
      var $88=(($87)|0);
      HEAP32[(($88)>>2)]=$86;
      __label__ = 18; break;
    case 18: // $89
      var $90=$menustate;
      var $91=(($90+4)|0);
      HEAP32[(($91)>>2)]=0;
      __label__ = 28; break;
    case 19: // $92
      var $93=$event;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0)==1;
      if ($96) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $97
      var $98=$menustate;
      var $99=(($98+4)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100;
      var $102=__ZN16device_interface6deviceEv($101);
      var $103=__Z18bitbanger_dec_modeP8device_tb($102, 0);
      __label__ = 27; break;
    case 21: // $104
      var $105=$event;
      var $106=(($105)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107)|0)==2;
      if ($108) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $109
      var $110=$menustate;
      var $111=(($110+4)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$112;
      var $114=__ZN16device_interface6deviceEv($113);
      var $115=__Z18bitbanger_dec_baudP8device_tb($114, 0);
      __label__ = 26; break;
    case 23: // $116
      var $117=$event;
      var $118=(($117)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119)|0)==3;
      if ($120) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $121
      var $122=$menustate;
      var $123=(($122+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$124;
      var $126=__ZN16device_interface6deviceEv($125);
      var $127=__Z18bitbanger_dec_tuneP8device_tb($126, 0);
      __label__ = 25; break;
    case 25: // $128
      __label__ = 26; break;
    case 26: // $129
      __label__ = 27; break;
    case 27: // $130
      __label__ = 28; break;
    case 28: // $131
      __label__ = 44; break;
    case 29: // $132
      var $133=$event;
      var $134=(($133)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135)|0)==0;
      if ($136) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $137
      var $138=$menustate;
      var $139=(($138)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=$1;
      var $142=__ZL15bitbanger_countR15running_machine($141);
      var $143=(($142-1)|0);
      var $144=(($140)|0) < (($143)|0);
      if ($144) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $145
      var $146=$menustate;
      var $147=(($146)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+1)|0);
      HEAP32[(($147)>>2)]=$149;
      __label__ = 33; break;
    case 32: // $150
      var $151=$menustate;
      var $152=(($151)|0);
      HEAP32[(($152)>>2)]=0;
      __label__ = 33; break;
    case 33: // $153
      var $154=$menustate;
      var $155=(($154+4)|0);
      HEAP32[(($155)>>2)]=0;
      __label__ = 43; break;
    case 34: // $156
      var $157=$event;
      var $158=(($157)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($159)|0)==1;
      if ($160) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $161
      var $162=$menustate;
      var $163=(($162+4)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164;
      var $166=__ZN16device_interface6deviceEv($165);
      var $167=__Z18bitbanger_inc_modeP8device_tb($166, 0);
      __label__ = 42; break;
    case 36: // $168
      var $169=$event;
      var $170=(($169)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171)|0)==2;
      if ($172) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $173
      var $174=$menustate;
      var $175=(($174+4)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$176;
      var $178=__ZN16device_interface6deviceEv($177);
      var $179=__Z18bitbanger_inc_baudP8device_tb($178, 0);
      __label__ = 41; break;
    case 38: // $180
      var $181=$event;
      var $182=(($181)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=(($183)|0)==3;
      if ($184) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $185
      var $186=$menustate;
      var $187=(($186+4)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$188;
      var $190=__ZN16device_interface6deviceEv($189);
      var $191=__Z18bitbanger_inc_tuneP8device_tb($190, 0);
      __label__ = 40; break;
    case 40: // $192
      __label__ = 41; break;
    case 41: // $193
      __label__ = 42; break;
    case 42: // $194
      __label__ = 43; break;
    case 43: // $195
      __label__ = 44; break;
    case 44: // $196
      __label__ = 45; break;
    case 45: // $197
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z30ui_mess_menu_bitbanger_controlR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL31menu_bitbanger_control_populateR15running_machineP7ui_menuP29_bitbanger_control_menu_state($machine, $menu, $menustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $count;
      var $flags;
      var $mode_flags;
      var $baud_flags;
      var $tune_flags;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      var $4=$1;
      var $5=__ZL15bitbanger_countR15running_machine($4);
      $count=$5;
      $flags=0;
      $mode_flags=0;
      $baud_flags=0;
      $tune_flags=0;
      var $6=$count;
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$count;
      var $13=(($12-1)|0);
      var $14=(($11)|0)==(($13)|0);
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$flags;
      var $17=$16 | 1;
      $flags=$17;
      __label__ = 4; break;
    case 3: // $18
      var $19=$flags;
      var $20=$19 | 2;
      $flags=$20;
      __label__ = 4; break;
    case 4: // $21
      __label__ = 5; break;
    case 5: // $22
      var $23=$3;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25;
      var $27=__ZN16device_interface6deviceEv($26);
      var $28=__Z18bitbanger_inc_modeP8device_tb($27, 1);
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      var $30=$mode_flags;
      var $31=$30 | 2;
      $mode_flags=$31;
      __label__ = 7; break;
    case 7: // $32
      var $33=$3;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35;
      var $37=__ZN16device_interface6deviceEv($36);
      var $38=__Z18bitbanger_dec_modeP8device_tb($37, 1);
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      var $40=$mode_flags;
      var $41=$40 | 1;
      $mode_flags=$41;
      __label__ = 9; break;
    case 9: // $42
      var $43=$3;
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$45;
      var $47=__ZN16device_interface6deviceEv($46);
      var $48=__Z18bitbanger_inc_baudP8device_tb($47, 1);
      if ($48) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $49
      var $50=$baud_flags;
      var $51=$50 | 2;
      $baud_flags=$51;
      __label__ = 11; break;
    case 11: // $52
      var $53=$3;
      var $54=(($53+4)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55;
      var $57=__ZN16device_interface6deviceEv($56);
      var $58=__Z18bitbanger_dec_baudP8device_tb($57, 1);
      if ($58) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $59
      var $60=$baud_flags;
      var $61=$60 | 1;
      $baud_flags=$61;
      __label__ = 13; break;
    case 13: // $62
      var $63=$3;
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65;
      var $67=__ZN16device_interface6deviceEv($66);
      var $68=__Z18bitbanger_inc_tuneP8device_tb($67, 1);
      if ($68) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $69
      var $70=$tune_flags;
      var $71=$70 | 2;
      $tune_flags=$71;
      __label__ = 15; break;
    case 15: // $72
      var $73=$3;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$75;
      var $77=__ZN16device_interface6deviceEv($76);
      var $78=__Z18bitbanger_dec_tuneP8device_tb($77, 1);
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      var $80=$tune_flags;
      var $81=$80 | 1;
      $tune_flags=$81;
      __label__ = 17; break;
    case 17: // $82
      var $83=$3;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=__ZN22device_image_interface6existsEv($85);
      if ($86) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $87
      var $88=$2;
      var $89=$3;
      var $90=(($89+4)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$91;
      var $93=__ZN16device_interface6deviceEv($92);
      var $94=__ZNK8device_t4nameEv($93);
      var $95=$3;
      var $96=(($95+4)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=__ZN22device_image_interface8filenameEv($97);
      var $99=$flags;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($88, $94, $98, $99, 0);
      var $100=$2;
      var $101=$3;
      var $102=(($101+4)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$103;
      var $105=__ZN16device_interface6deviceEv($104);
      var $106=__Z21bitbanger_mode_stringP8device_t($105);
      var $107=$mode_flags;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($100, ((STRING_TABLE.__str25756)|0), $106, $107, 1);
      var $108=$2;
      var $109=$3;
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$111;
      var $113=__ZN16device_interface6deviceEv($112);
      var $114=__Z21bitbanger_baud_stringP8device_t($113);
      var $115=$baud_flags;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($108, ((STRING_TABLE.__str35757)|0), $114, $115, 2);
      var $116=$2;
      var $117=$3;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$119;
      var $121=__ZN16device_interface6deviceEv($120);
      var $122=__Z21bitbanger_tune_stringP8device_t($121);
      var $123=$tune_flags;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($116, ((STRING_TABLE.__str45758)|0), $122, $123, 3);
      var $124=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($124, ((STRING_TABLE.__str55759)|0), ((STRING_TABLE.__str65760)|0), 0, 0);
      __label__ = 20; break;
    case 19: // $125
      var $126=$2;
      var $127=$flags;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($126, ((STRING_TABLE.__str75761)|0), 0, $127, 0);
      __label__ = 20; break;
    case 20: // $128
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL31menu_bitbanger_control_populateR15running_machineP7ui_menuP29_bitbanger_control_menu_state["X"]=1;

function __ZL15bitbanger_countR15running_machine($machine) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $count;
      var $device;
      $1=$machine;
      $count=0;
      var $2=$1;
      var $3=__ZNK15running_machine10devicelistEv($2);
      var $4=HEAP32[((_BITBANGER)>>2)];
      var $5=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($3, $4);
      $device=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$device;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$count;
      var $11=(($10+1)|0);
      $count=$11;
      var $12=$device;
      var $13=__ZNK8device_t8typenextEv($12);
      $device=$13;
      __label__ = 1; break;
    case 3: // $14
      var $15=$count;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL26menu_tape_control_populateR15running_machineP7ui_menuP24_tape_control_menu_state($machine, $menu, $menustate) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $timepos=__stackBase__;
      var $state;
      var $count;
      var $4;
      var $5;
      var $flags;
      var $t0;
      var $t1;
      var $tapeflags;
      var $cassette;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      __ZN7astringC1Ev($timepos);
      var $6=$1;
      var $7=(function() { try { __THREW__ = false; return __ZL14cassette_countR15running_machine($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $8
      $count=$7;
      $flags=0;
      var $9=$count;
      var $10=(($9)|0) > 0;
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$count;
      var $16=(($15-1)|0);
      var $17=(($14)|0)==(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      var $19=$flags;
      var $20=$19 | 1;
      $flags=$20;
      __label__ = 6; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $4=$23;
      var $24=$22.f1;
      $5=$24;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($timepos) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 5: // $25
      var $26=$flags;
      var $27=$26 | 2;
      $flags=$27;
      __label__ = 6; break;
    case 6: // $28
      __label__ = 7; break;
    case 7: // $29
      var $30=$3;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(function() { try { __THREW__ = false; return __ZN22device_image_interface6existsEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $34
      if ($33) { __label__ = 9; break; } else { __label__ = 41; break; }
    case 9: // $35
      $tapeflags=0;
      var $36=$3;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38;
      var $40=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; };
    case 10: // $41
      var $42=(($40)|0)==0;
      if ($42) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $43
      var $44=$40;
      var $45=___dynamic_cast($44, __ZTI8device_t, __ZTI21cassette_image_device, -1);
      var $46=$45;
      var $49 = $46;__label__ = 13; break;
    case 12: // $47
      var $49 = 0;__label__ = 13; break;
    case 13: // $48
      var $49;
      $cassette=$49;
      var $50=$cassette;
      var $51=(function() { try { __THREW__ = false; return __ZN21cassette_image_device12get_positionEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 4; break; };
    case 14: // $52
      $t0=$51;
      var $53=$cassette;
      var $54=(function() { try { __THREW__ = false; return __ZN21cassette_image_device10get_lengthEv($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 4; break; };
    case 15: // $55
      $t1=$54;
      var $56=$t1;
      var $57=$56 > 0;
      if ($57) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $58
      var $59=$t0;
      var $60=$59 > 0;
      if ($60) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $61
      var $62=$tapeflags;
      var $63=$62 | 1;
      $tapeflags=$63;
      __label__ = 18; break;
    case 18: // $64
      var $65=$t0;
      var $66=$t1;
      var $67=$65 < $66;
      if ($67) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $68
      var $69=$tapeflags;
      var $70=$69 | 2;
      $tapeflags=$70;
      __label__ = 20; break;
    case 20: // $71
      __label__ = 21; break;
    case 21: // $72
      var $73=$2;
      var $74=$3;
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$76;
      var $78=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 4; break; };
    case 22: // $79
      var $80=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 4; break; };
    case 23: // $81
      var $82=$3;
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(function() { try { __THREW__ = false; return __ZN22device_image_interface8filenameEv($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 4; break; };
    case 24: // $86
      var $87=$flags;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($73, $80, $85, $87, 7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 4; break; }
    case 25: // $88
      var $89=$cassette;
      var $90=(function() { try { __THREW__ = false; return __Z19tapecontrol_gettimeP7astringP21cassette_image_devicePiS3_($timepos, $89, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 4; break; };
    case 26: // $91
      var $92=$cassette;
      var $93=(function() { try { __THREW__ = false; return __ZN21cassette_image_device9get_stateEv($92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 4; break; };
    case 27: // $94
      $state=$93;
      var $95=$2;
      var $96=$state;
      var $97=$96 & 3;
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $99
      var $117 = ((STRING_TABLE.__str85762)|0);__label__ = 33; break;
    case 29: // $100
      var $101=$state;
      var $102=$101 & 3;
      var $103=(($102)|0)==1;
      if ($103) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $104
      var $105=$state;
      var $106=$105 & 4;
      var $107=(($106)|0)==0;
      var $108=$107 ? (((STRING_TABLE.__str95763)|0)) : (((STRING_TABLE.__str105764)|0));
      var $115 = $108;__label__ = 32; break;
    case 31: // $109
      var $110=$state;
      var $111=$110 & 4;
      var $112=(($111)|0)==0;
      var $113=$112 ? (((STRING_TABLE.__str115765)|0)) : (((STRING_TABLE.__str125766)|0));
      var $115 = $113;__label__ = 32; break;
    case 32: // $114
      var $115;
      var $117 = $115;__label__ = 33; break;
    case 33: // $116
      var $117;
      var $118=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($timepos) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 4; break; };
    case 34: // $119
      var $120=$tapeflags;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($95, $117, $118, $120, 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 4; break; }
    case 35: // $121
      var $122=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($122, ((STRING_TABLE.__str135767)|0), 0, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; }
    case 36: // $123
      var $124=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($124, ((STRING_TABLE.__str145768)|0), 0, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 4; break; }
    case 37: // $125
      var $126=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($126, ((STRING_TABLE.__str155769)|0), 0, 0, 3) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 4; break; }
    case 38: // $127
      var $128=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($128, ((STRING_TABLE.__str165770)|0), 0, 0, 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 4; break; }
    case 39: // $129
      var $130=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($130, ((STRING_TABLE.__str175771)|0), 0, 0, 5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 4; break; }
    case 40: // $131
      __label__ = 43; break;
    case 41: // $132
      var $133=$2;
      var $134=$flags;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($133, ((STRING_TABLE.__str185772)|0), 0, $134, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 4; break; }
    case 42: // $135
      __label__ = 43; break;
    case 43: // $136
      FUNCTION_TABLE[__ZN7astringD1Ev]($timepos);
      STACKTOP = __stackBase__;
      return;
    case 44: // $137
      __label__ = 45; break;
    case 45: // $138
      var $139=$4;
      var $140=$4;
      var $141=$5;
      var $142=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $140, tempValue);
      var $143=($142.f1 = $141, $142);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 46: // $144
      var $145=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26menu_tape_control_populateR15running_machineP7ui_menuP24_tape_control_menu_state["X"]=1;

function __ZL22is_valid_filename_charj($unichar) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$unichar;
      var $2=$1;
      var $3=(($2)>>>0) < 128;
      if ($3) { __label__ = 1; break; } else { var $10 = 0;__label__ = 2; break; }
    case 1: // $4
      var $5=$1;
      var $6=((STRING_TABLE.__ZZL22is_valid_filename_charjE19valid_filename_char+$5)|0);
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24)!=0;
      var $10 = $8;__label__ = 2; break;
    case 2: // $9
      var $10;
      var $11=(($10)&1);
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL27menu_file_selector_populateR15running_machineP7ui_menuP25_file_selector_menu_state($machine, $menu, $menustate) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $directory=__stackBase__;
      var $err;
      var $dirent;
      var $entry;
      var $selected_entry;
      var $i;
      var $volume_name;
      var $device;
      var $path;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      HEAP32[(($directory)>>2)]=0;
      $err=0;
      $selected_entry=0;
      var $4=$3;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      $device=$8;
      var $9=$3;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__Z9astring_cPK7astring($13);
      $path=$14;
      var $15=$path;
      var $16=__Z15zippath_opendirPKcPP18_zippath_directory($15, $directory);
      $err=$16;
      var $17=$err;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      __label__ = 25; break;
    case 2: // $20
      var $21=$3;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=$2;
      var $24=$3;
      var $25=__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_($23, $24, 0, 0, 0);
      var $26=$device;
      var $27=$26;
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+108)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=FUNCTION_TABLE[$30]($26);
      if ($31) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $32
      var $33=HEAP32[(($directory)>>2)];
      var $34=__Z14zippath_is_zipP18_zippath_directory($33);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $36
      var $37=$2;
      var $38=$3;
      var $39=__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_($37, $38, 1, 0, 0);
      __label__ = 5; break;
    case 5: // $40
      var $41=$2;
      var $42=$3;
      var $43=__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_($41, $42, 2, 0, 0);
      $i=0;
      __label__ = 6; break;
    case 6: // $44
      var $45=$i;
      var $46=_osd_get_volume_name($45);
      $volume_name=$46;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $48
      var $49=$2;
      var $50=$3;
      var $51=$volume_name;
      var $52=$volume_name;
      var $53=__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_($49, $50, 3, $51, $52);
      var $54=$i;
      var $55=(($54+1)|0);
      $i=$55;
      __label__ = 6; break;
    case 8: // $56
      __label__ = 9; break;
    case 9: // $57
      var $58=HEAP32[(($directory)>>2)];
      var $59=__Z15zippath_readdirP18_zippath_directory($58);
      $dirent=$59;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 10; break; } else { __label__ = 18; break; }
    case 10: // $61
      var $62=$2;
      var $63=$3;
      var $64=$dirent;
      var $65=__ZL33append_dirent_file_selector_entryP7ui_menuP25_file_selector_menu_statePK20_osd_directory_entry($62, $63, $64);
      $entry=$65;
      var $66=$entry;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $68
      var $69=$selected_entry;
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $71
      var $72=$dirent;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=_strcmp($74, ((STRING_TABLE.__str325786)|0));
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $77
      var $78=$entry;
      $selected_entry=$78;
      __label__ = 14; break;
    case 14: // $79
      var $80=$3;
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=__Z9astring_cPK7astring($84);
      var $86=$dirent;
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=__Z12core_stricmpPKcS0_($85, $88);
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $91
      var $92=$entry;
      $selected_entry=$92;
      __label__ = 16; break;
    case 16: // $93
      __label__ = 17; break;
    case 17: // $94
      __label__ = 9; break;
    case 18: // $95
      var $96=$3;
      var $97=(($96+4)|0);
      var $98=HEAP32[(($97)>>2)];
      $entry=$98;
      __label__ = 19; break;
    case 19: // $99
      var $100=$entry;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $102
      var $103=$2;
      var $104=$entry;
      __ZL36append_file_selector_entry_menu_itemP7ui_menuPK20_file_selector_entry($103, $104);
      __label__ = 21; break;
    case 21: // $105
      var $106=$entry;
      var $107=(($106)|0);
      var $108=HEAP32[(($107)>>2)];
      $entry=$108;
      __label__ = 19; break;
    case 22: // $109
      var $110=$selected_entry;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $112
      var $113=$2;
      var $114=$selected_entry;
      var $115=$114;
      __Z21ui_menu_set_selectionP7ui_menuPv($113, $115);
      __label__ = 24; break;
    case 24: // $116
      var $117=$2;
      var $118=$1;
      var $119=__Z18ui_get_line_heightR15running_machine($118);
      var $120=$119+0.029999999329447746;
      __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($117, 1304, $120, 0);
      __label__ = 25; break;
    case 25: // $121
      var $122=HEAP32[(($directory)>>2)];
      var $123=(($122)|0)!=0;
      if ($123) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $124
      var $125=HEAP32[(($directory)>>2)];
      __Z16zippath_closedirP18_zippath_directory($125);
      __label__ = 27; break;
    case 27: // $126
      var $127=$err;
      STACKTOP = __stackBase__;
      return $127;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27menu_file_selector_populateR15running_machineP7ui_menuP25_file_selector_menu_state["X"]=1;

function __ZL16menu_file_createR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $selection;
      var $event;
      var $fake_event=__stackBase__;
      var $menustate;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=$5;
      $menustate=$6;
      var $7=$2;
      var $8=__Z21ui_menu_get_selectionP7ui_menu($7);
      $selection=$8;
      var $9=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($9, 1);
      var $10=$1;
      var $11=$2;
      var $12=$4;
      var $13=$selection;
      __ZL25menu_file_create_populateR15running_machineP7ui_menuPvS3_($10, $11, $12, $13);
      var $14=$menustate;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$fake_event;
      for (var $$dest = $19, $$stop = $$dest + 12; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $20=(($fake_event+4)|0);
      HEAP32[(($20)>>2)]=182;
      var $21=(($fake_event)|0);
      HEAP32[(($21)>>2)]=2;
      $event=$fake_event;
      __label__ = 3; break;
    case 2: // $22
      var $23=$1;
      var $24=$2;
      var $25=__Z15ui_menu_processR15running_machineP7ui_menuj($23, $24, 0);
      $event=$25;
      __label__ = 3; break;
    case 3: // $26
      var $27=$event;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $29
      var $30=$event;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      if ($32 == 182) {
        __label__ = 5; break;
      }
      else if ($32 == 214) {
        __label__ = 11; break;
      }
      else {
      __label__ = 14; break;
      }
      
    case 5: // $33
      var $34=$event;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==2;
      if ($37) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $38
      var $39=$event;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)==1;
      if ($42) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $43
      var $44=$menustate;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$menustate;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=__Z9astring_cPK7astring($53);
      var $55=$menustate;
      var $56=(($55+12)|0);
      var $57=(($56)|0);
      var $58=$menustate;
      var $59=(($58+8)|0);
      var $60=__ZL16create_new_imageP22device_image_interfacePKcS2_Pi($48, $54, $57, $59);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $62
      var $63=$1;
      __Z17ui_menu_stack_popR15running_machine($63);
      var $64=$1;
      __Z17ui_menu_stack_popR15running_machine($64);
      __label__ = 9; break;
    case 9: // $65
      __label__ = 10; break;
    case 10: // $66
      __label__ = 14; break;
    case 11: // $67
      var $68=$2;
      var $69=__Z21ui_menu_get_selectionP7ui_menu($68);
      var $70=(($69)|0)==1;
      if ($70) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $71
      var $72=$menustate;
      var $73=(($72+12)|0);
      var $74=(($73)|0);
      var $75=$event;
      var $76=(($75+8)|0);
      var $77=HEAP32[(($76)>>2)];
      __ZL15input_characterPcjjPFijE($74, 1024, $77, 1306);
      __label__ = 13; break;
    case 13: // $78
      __label__ = 14; break;
    case 14: // $79
      __label__ = 15; break;
    case 15: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16menu_file_createR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL10check_pathPKc($path) {
  ;
  var __label__;

  var $1;
  $1=$path;
  var $2=$1;
  var $3=__Z15zippath_opendirPKcPP18_zippath_directory($2, 0);
  ;
  return $3;
}


function __ZL15input_characterPcjjPFijE($buffer, $buffer_length, $unichar, $filter) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buflen;
      $1=$buffer;
      $2=$buffer_length;
      $3=$unichar;
      $4=$filter;
      var $5=$1;
      var $6=_strlen($5);
      $buflen=$6;
      var $7=$3;
      var $8=(($7)|0)==8;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=$buflen;
      var $11=(($10)>>>0) > 0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$buflen;
      var $14=$1;
      var $15=(($14+$13)|0);
      var $16=__Z18utf8_previous_charPKc($15);
      HEAP8[($16)]=0;
      __label__ = 8; break;
    case 3: // $17
      var $18=$3;
      var $19=(($18)>>>0) > 32;
      if ($19) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $20
      var $21=$4;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $23
      var $24=$4;
      var $25=$3;
      var $26=FUNCTION_TABLE[$24]($25);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $28
      var $29=$buflen;
      var $30=$1;
      var $31=(($30+$29)|0);
      var $32=$2;
      var $33=$buflen;
      var $34=(($32-$33)|0);
      var $35=$3;
      var $36=__Z15utf8_from_ucharPcjj($31, $34, $35);
      var $37=$buflen;
      var $38=(($37+$36)|0);
      $buflen=$38;
      var $39=$buflen;
      var $40=$1;
      var $41=(($40+$39)|0);
      HEAP8[($41)]=0;
      __label__ = 7; break;
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15input_characterPcjjPFijE["X"]=1;

function __ZL20menu_confirm_save_asR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $event;
      var $menustate;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=$5;
      $menustate=$6;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      var $13=$4;
      __ZL29menu_confirm_save_as_populateR15running_machineP7ui_menuPv($11, $12, $13);
      __label__ = 2; break;
    case 2: // $14
      var $15=$1;
      var $16=$2;
      var $17=__Z15ui_menu_processR15running_machineP7ui_menuj($15, $16, 0);
      $event=$17;
      var $18=$event;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $20
      var $21=$event;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)==182;
      if ($24) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $25
      var $26=$event;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)==5;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$menustate;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      HEAP32[(($33)>>2)]=1;
      __label__ = 6; break;
    case 6: // $34
      var $35=$1;
      __Z17ui_menu_stack_popR15running_machine($35);
      __label__ = 7; break;
    case 7: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL29menu_confirm_save_as_populateR15running_machineP7ui_menuPv($machine, $menu, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$menu;
  $3=$state;
  var $4=$2;
  __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($4, ((STRING_TABLE.__str255779)|0), 0, 32, 0);
  var $5=$2;
  __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($5, ((STRING_TABLE.__str265780)|0), 0, 32, 0);
  var $6=$2;
  __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($6, ((STRING_TABLE.__str275781)|0), 0, 0, 4);
  var $7=$2;
  __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($7, ((STRING_TABLE.__str285782)|0), 0, 0, 5);
  ;
  return;
}


function __ZL18astring_assemble_2P7astringPKcS2_5806($dst, $src1, $src2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$dst;
  $2=$src1;
  $3=$src2;
  var $4=$1;
  var $5=$2;
  var $6=__Z12astring_cpycP7astringPKc($4, $5);
  var $7=$3;
  var $8=__ZL12astring_catcP7astringPKc5807($6, $7);
  ;
  return $8;
}


function __ZL24file_create_render_extraR15running_machineP7ui_menuPvS3_ffffff($machine, $menu, $state, $selectedref, $top, $bottom, $origx1, $origy1, $origx2, $origy2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $10;
  var $menustate;
  $1=$machine;
  $2=$menu;
  $3=$state;
  $4=$selectedref;
  $5=$top;
  $6=$bottom;
  $7=$origx1;
  $8=$origy1;
  $9=$origx2;
  $10=$origy2;
  var $11=$3;
  var $12=$11;
  $menustate=$12;
  var $13=$1;
  var $14=$2;
  var $15=$3;
  var $16=$4;
  var $17=$5;
  var $18=$6;
  var $19=$7;
  var $20=$8;
  var $21=$9;
  var $22=$10;
  var $23=$menustate;
  var $24=(($23)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25+4)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=__Z9astring_cPK7astring($27);
  __ZL17extra_text_renderR15running_machineP7ui_menuPvS3_ffffffPKcS5_($13, $14, $15, $16, $17, $18, $19, $20, $21, $22, $28, 0);
  ;
  return;
}


function __ZL17extra_text_renderR15running_machineP7ui_menuPvS3_ffffffPKcS5_($machine, $menu, $state, $selectedref, $top, $bottom, $origx1, $origy1, $origx2, $origy2, $header, $footer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$selectedref;
      $5=$top;
      $6=$bottom;
      $7=$origx1;
      $8=$origy1;
      $9=$origx2;
      $10=$origy2;
      $11=$header;
      $12=$footer;
      var $13=$11;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $15
      var $16=$11;
      var $17=(($16)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$11;
      var $25 = $22;__label__ = 4; break;
    case 3: // $23
      var $25 = 0;__label__ = 4; break;
    case 4: // $24
      var $25;
      $11=$25;
      var $26=$12;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $28
      var $29=$12;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24);
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=$12;
      var $38 = $35;__label__ = 8; break;
    case 7: // $36
      var $38 = 0;__label__ = 8; break;
    case 8: // $37
      var $38;
      $12=$38;
      var $39=$11;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $41
      var $42=$1;
      var $43=__ZNK15running_machine6renderEv($42);
      var $44=__ZNK14render_manager12ui_containerEv($43);
      var $45=$7;
      var $46=$9;
      var $47=$8;
      var $48=$5;
      var $49=$11;
      __ZL19extra_text_draw_boxR16render_containerffffPKci($44, $45, $46, $47, $48, $49, -1);
      __label__ = 10; break;
    case 10: // $50
      var $51=$12;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $53
      var $54=$1;
      var $55=__ZNK15running_machine6renderEv($54);
      var $56=__ZNK14render_manager12ui_containerEv($55);
      var $57=$7;
      var $58=$9;
      var $59=$10;
      var $60=$6;
      var $61=$12;
      __ZL19extra_text_draw_boxR16render_containerffffPKci($56, $57, $58, $59, $60, $61, 1);
      __label__ = 12; break;
    case 12: // $62
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17extra_text_renderR15running_machineP7ui_menuPvS3_ffffffPKcS5_["X"]=1;

function __ZL25menu_file_create_populateR15running_machineP7ui_menuPvS3_($machine, $menu, $state, $selection) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buffer=__stackBase__;
      var $menustate;
      var $device;
      var $format;
      var $new_image_name;
      var $5;
      var $6;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$selection;
      __ZN7astringC1Ev($buffer);
      var $7=$3;
      var $8=$7;
      $menustate=$8;
      var $9=$menustate;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      $device=$13;
      var $14=$4;
      var $15=(($14)|0)==1;
      if ($15) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $16
      var $17=$menustate;
      var $18=(($17+12)|0);
      var $19=(($18)|0);
      var $20=(function() { try { __THREW__ = false; return __ZL18astring_assemble_2P7astringPKcS2_5806($buffer, $19, ((STRING_TABLE.__str295783)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $21
      var $22=(function() { try { __THREW__ = false; return __Z9astring_cPK7astring($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $23
      $new_image_name=$22;
      __label__ = 6; break;
    case 4: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $5=$26;
      var $27=$25.f1;
      $6=$27;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($buffer) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 5: // $28
      var $29=$menustate;
      var $30=(($29+12)|0);
      var $31=(($30)|0);
      $new_image_name=$31;
      __label__ = 6; break;
    case 6: // $32
      var $33=$2;
      var $34=$new_image_name;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($33, ((STRING_TABLE.__str305784)|0), $34, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 7: // $35
      var $36=$device;
      var $37=(function() { try { __THREW__ = false; return __ZN22device_image_interface28device_get_creatable_formatsEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 4; break; };
    case 8: // $38
      $format=$37;
      var $39=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($39, ((STRING_TABLE.__str265780)|0), 0, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; }
    case 9: // $40
      var $41=$2;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($41, ((STRING_TABLE.__str315785)|0), 0, 0, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 4; break; }
    case 10: // $42
      var $43=$2;
      var $44=$1;
      var $45=(function() { try { __THREW__ = false; return __Z18ui_get_line_heightR15running_machine($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 4; break; };
    case 11: // $46
      var $47=$45+0.029999999329447746;
      (function() { try { __THREW__ = false; return __Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff($43, 1302, $47, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 4; break; }
    case 12: // $48
      FUNCTION_TABLE[__ZN7astringD1Ev]($buffer);
      STACKTOP = __stackBase__;
      return;
    case 13: // $49
      __label__ = 14; break;
    case 14: // $50
      var $51=$5;
      var $52=$5;
      var $53=$6;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $56
      var $57=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25menu_file_create_populateR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL16create_new_imageP22device_image_interfacePKcS2_Pi($image, $directory, $filename, $yes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $path;
      var $entry;
      var $file_type;
      var $do_create;
      var $err;
      var $result;
      var $child_menu;
      var $child_menustate;
      $1=$image;
      $2=$directory;
      $3=$filename;
      $4=$yes;
      $result=0;
      var $5=__Z13astring_allocv();
      var $6=$2;
      var $7=$3;
      var $8=__Z15zippath_combineP7astringPKcS2_($5, $6, $7);
      $path=$8;
      var $9=$path;
      var $10=__Z9astring_cPK7astring($9);
      var $11=_osd_stat($10);
      $entry=$11;
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$entry;
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $20 = $17;__label__ = 3; break;
    case 2: // $18
      var $20 = 0;__label__ = 3; break;
    case 3: // $19
      var $20;
      $file_type=$20;
      var $21=$entry;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$entry;
      var $25=$24;
      __Z14free_file_linePvPKci($25, ((STRING_TABLE.__str215775)|0), 371);
      __label__ = 5; break;
    case 5: // $26
      var $27=$file_type;
      var $28=(($27)|0)==1;
      if ($28) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $29
      var $30=$4;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      $file_type=0;
      __label__ = 8; break;
    case 8: // $34
      var $35=$file_type;
      if ($35 == 0) {
        __label__ = 9; break;
      }
      else if ($35 == 1) {
        __label__ = 10; break;
      }
      else if ($35 == 2) {
        __label__ = 11; break;
      }
      else {
      __label__ = 12; break;
      }
      
    case 9: // $36
      $do_create=1;
      __label__ = 13; break;
    case 10: // $37
      var $38=$1;
      var $39=$38;
      var $40=__ZN16device_interface6deviceEv($39);
      var $41=__ZNK8device_t7machineEv($40);
      var $42=$1;
      var $43=$42;
      var $44=__ZN16device_interface6deviceEv($43);
      var $45=__ZNK8device_t7machineEv($44);
      var $46=__ZNK15running_machine6renderEv($45);
      var $47=__ZNK14render_manager12ui_containerEv($46);
      var $48=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($41, $47, 1308, 0);
      $child_menu=$48;
      var $49=$child_menu;
      var $50=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($49, 4, 0);
      var $51=$50;
      $child_menustate=$51;
      var $52=$4;
      var $53=$child_menustate;
      var $54=(($53)|0);
      HEAP32[(($54)>>2)]=$52;
      var $55=$child_menu;
      __Z18ui_menu_stack_pushP7ui_menu($55);
      $do_create=0;
      __label__ = 13; break;
    case 11: // $56
      __Z13ui_popup_timeiPKcz(5, ((STRING_TABLE.__str225776)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $do_create=0;
      __label__ = 13; break;
    case 12: // $57
      __Z10fatalerrorPKcz(((STRING_TABLE.__str235777)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      throw "Reached an unreachable!"
    case 13: // $58
      var $59=$do_create;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $61
      var $62=$1;
      var $63=$path;
      var $64=__Z9astring_cPK7astring($63);
      var $65=__ZN22device_image_interface6createEPKcPK19image_device_formatP18_option_resolution($62, $64, 0, 0);
      var $66=(($65)&1);
      $err=$66;
      var $67=$err;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $69
      var $70=$1;
      var $71=__ZN22device_image_interface5errorEv($70);
      __Z10popmessagePKcz(((STRING_TABLE.__str245778)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$71,tempInt));
      __label__ = 17; break;
    case 16: // $72
      $result=1;
      __label__ = 17; break;
    case 17: // $73
      __label__ = 18; break;
    case 18: // $74
      var $75=$path;
      __Z12astring_freeP7astring($75);
      var $76=$result;
      ;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16create_new_imageP22device_image_interfacePKcS2_Pi["X"]=1;

function __ZN22device_image_interface10part_entryEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+416)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL19extra_text_draw_boxR16render_containerffffPKci($ui_container, $origx1, $origx2, $origy, $yspan, $text, $direction) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $text_width=__stackBase__;
      var $text_height=__stackBase__+4;
      var $width;
      var $maxwidth;
      var $x1;
      var $y1;
      var $x2;
      var $y2;
      var $temp;
      $1=$ui_container;
      $2=$origx1;
      $3=$origx2;
      $4=$origy;
      $5=$yspan;
      $6=$text;
      $7=$direction;
      var $8=$1;
      var $9=$6;
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($8, $9, 0, 0, 1, 0, 2, 0, -1, -16777216, $text_width, $text_height);
      var $10=HEAPF32[(($text_width)>>2)];
      var $11=$10+0.019999999552965164;
      $width=$11;
      var $12=$width;
      var $13=$3;
      var $14=$2;
      var $15=$13-$14;
      var $16=$12 > $15;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$width;
      var $24 = $18;__label__ = 3; break;
    case 2: // $19
      var $20=$3;
      var $21=$2;
      var $22=$20-$21;
      var $24 = $22;__label__ = 3; break;
    case 3: // $23
      var $24;
      $maxwidth=$24;
      var $25=$maxwidth;
      var $26=$25*0.5;
      var $27=0.5-$26;
      $x1=$27;
      var $28=$x1;
      var $29=$maxwidth;
      var $30=$28+$29;
      $x2=$30;
      var $31=$4;
      var $32=$5;
      var $33=$7;
      var $34=(($33)|0);
      var $35=$32*$34;
      var $36=$31+$35;
      $y1=$36;
      var $37=$4;
      var $38=$7;
      var $39=(($38)|0);
      var $40=$39*0.009999999776482582;
      var $41=$37+$40;
      $y2=$41;
      var $42=$y1;
      var $43=$y2;
      var $44=$42 > $43;
      if ($44) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $45
      var $46=$y1;
      $temp=$46;
      var $47=$y2;
      $y1=$47;
      var $48=$temp;
      $y2=$48;
      __label__ = 5; break;
    case 5: // $49
      var $50=$1;
      var $51=$x1;
      var $52=$y1;
      var $53=$x2;
      var $54=$y2;
      __Z20ui_draw_outlined_boxP16render_containerffffj($50, $51, $52, $53, $54, -284159952);
      var $55=$x1;
      var $56=$55+0.009999999776482582;
      $x1=$56;
      var $57=$x2;
      var $58=$57-0.009999999776482582;
      $x2=$58;
      var $59=$y1;
      var $60=$59+0.009999999776482582;
      $y1=$60;
      var $61=$y2;
      var $62=$61-0.009999999776482582;
      $y2=$62;
      var $63=$1;
      var $64=$6;
      var $65=$x1;
      var $66=$y1;
      var $67=HEAPF32[(($text_width)>>2)];
      __Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_($63, $64, $65, $66, $67, 0, 2, 1, -1, -16777216, 0, 0);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19extra_text_draw_boxR16render_containerffffPKci["X"]=1;

function __ZL12astring_catcP7astringPKc5807($dst, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__Z12astring_inscP7astringiPKc($3, -1, $4);
  ;
  return $5;
}


function __ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_($menu, $menustate, $entry_type, $entry_basename, $entry_fullpath) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $entry;
      var $entryptr;
      $1=$menu;
      $2=$menustate;
      $3=$entry_type;
      $4=$entry_basename;
      $5=$entry_fullpath;
      var $6=$1;
      var $7=__Z18ui_menu_pool_allocP7ui_menuj($6, 16);
      var $8=$7;
      $entry=$8;
      var $9=$entry;
      var $10=$9;
      for (var $$dest = $10, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $11=$3;
      var $12=$entry;
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$4;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$1;
      var $18=$4;
      var $19=__Z19ui_menu_pool_strdupP7ui_menuPKc($17, $18);
      var $23 = $19;__label__ = 3; break;
    case 2: // $20
      var $21=$4;
      var $23 = $21;__label__ = 3; break;
    case 3: // $22
      var $23;
      var $24=$entry;
      var $25=(($24+8)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$5;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$1;
      var $30=$5;
      var $31=__Z19ui_menu_pool_strdupP7ui_menuPKc($29, $30);
      var $35 = $31;__label__ = 6; break;
    case 5: // $32
      var $33=$5;
      var $35 = $33;__label__ = 6; break;
    case 6: // $34
      var $35;
      var $36=$entry;
      var $37=(($36+12)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$2;
      var $39=(($38+4)|0);
      $entryptr=$39;
      __label__ = 7; break;
    case 7: // $40
      var $41=$entryptr;
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 8; break; } else { var $51 = 0;__label__ = 9; break; }
    case 8: // $44
      var $45=$entry;
      var $46=$entryptr;
      var $47=HEAP32[(($46)>>2)];
      var $48=__ZL29compare_file_selector_entriesPK20_file_selector_entryS1_($45, $47);
      var $49=(($48)|0) >= 0;
      var $51 = $49;__label__ = 9; break;
    case 9: // $50
      var $51;
      if ($51) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $52
      var $53=$entryptr;
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0);
      $entryptr=$55;
      __label__ = 7; break;
    case 11: // $56
      var $57=$entryptr;
      var $58=HEAP32[(($57)>>2)];
      var $59=$entry;
      var $60=(($59)|0);
      HEAP32[(($60)>>2)]=$58;
      var $61=$entry;
      var $62=$entryptr;
      HEAP32[(($62)>>2)]=$61;
      var $63=$entry;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_["X"]=1;

function __ZL33append_dirent_file_selector_entryP7ui_menuP25_file_selector_menu_statePK20_osd_directory_entry($menu, $menustate, $dirent) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buffer;
      var $entry_type;
      var $entry;
      $2=$menu;
      $3=$menustate;
      $4=$dirent;
      var $5=$4;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      if ($7 == 1) {
        __label__ = 1; break;
      }
      else if ($7 == 2) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $entry_type=5;
      __label__ = 4; break;
    case 2: // $9
      $entry_type=4;
      __label__ = 4; break;
    case 3: // $10
      $1=0;
      __label__ = 5; break;
    case 4: // $11
      var $12=__Z13astring_allocv();
      var $13=$3;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=__Z9astring_cPK7astring($17);
      var $19=$4;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=__Z15zippath_combineP7astringPKcS2_($12, $18, $21);
      $buffer=$22;
      var $23=$2;
      var $24=$3;
      var $25=$entry_type;
      var $26=$4;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$buffer;
      var $30=__Z9astring_cPK7astring($29);
      var $31=__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_($23, $24, $25, $28, $30);
      $entry=$31;
      var $32=$buffer;
      __Z12astring_freeP7astring($32);
      var $33=$entry;
      $1=$33;
      __label__ = 5; break;
    case 5: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL36append_file_selector_entry_menu_itemP7ui_menuPK20_file_selector_entry($menu, $entry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $text;
      var $subtext;
      $1=$menu;
      $2=$entry;
      $text=0;
      $subtext=0;
      var $3=$2;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      if ($5 == 0) {
        __label__ = 1; break;
      }
      else if ($5 == 1) {
        __label__ = 2; break;
      }
      else if ($5 == 2) {
        __label__ = 3; break;
      }
      else if ($5 == 3) {
        __label__ = 4; break;
      }
      else if ($5 == 4) {
        __label__ = 5; break;
      }
      else if ($5 == 5) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $6
      $text=((STRING_TABLE.__str335787)|0);
      __label__ = 7; break;
    case 2: // $7
      $text=((STRING_TABLE.__str345788)|0);
      __label__ = 7; break;
    case 3: // $8
      $text=((STRING_TABLE.__str355789)|0);
      __label__ = 7; break;
    case 4: // $9
      var $10=$2;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      $text=$12;
      $subtext=((STRING_TABLE.__str365790)|0);
      __label__ = 7; break;
    case 5: // $13
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      $text=$16;
      $subtext=((STRING_TABLE.__str375791)|0);
      __label__ = 7; break;
    case 6: // $17
      var $18=$2;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      $text=$20;
      $subtext=((STRING_TABLE.__str385792)|0);
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      var $23=$text;
      var $24=$subtext;
      var $25=$2;
      var $26=$25;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($22, $23, $24, 0, $26);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL26file_selector_render_extraR15running_machineP7ui_menuPvS3_ffffff($machine, $menu, $state, $selectedref, $top, $bottom, $origx1, $origy1, $origx2, $origy2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $10;
  var $menustate;
  $1=$machine;
  $2=$menu;
  $3=$state;
  $4=$selectedref;
  $5=$top;
  $6=$bottom;
  $7=$origx1;
  $8=$origy1;
  $9=$origx2;
  $10=$origy2;
  var $11=$3;
  var $12=$11;
  $menustate=$12;
  var $13=$1;
  var $14=$2;
  var $15=$3;
  var $16=$4;
  var $17=$5;
  var $18=$6;
  var $19=$7;
  var $20=$8;
  var $21=$9;
  var $22=$10;
  var $23=$menustate;
  var $24=(($23)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=(($25+4)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=__Z9astring_cPK7astring($27);
  __ZL17extra_text_renderR15running_machineP7ui_menuPvS3_ffffffPKcS5_($13, $14, $15, $16, $17, $18, $19, $20, $21, $22, $28, 0);
  ;
  return;
}


function __ZL29compare_file_selector_entriesPK20_file_selector_entryS1_($e1, $e2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $e1_basename;
      var $e2_basename;
      $1=$e1;
      $2=$e2;
      var $3=$1;
      var $4=(($3+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $13 = $10;__label__ = 3; break;
    case 2: // $11
      var $13 = ((__str5754)|0);__label__ = 3; break;
    case 3: // $12
      var $13;
      $e1_basename=$13;
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$2;
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $24 = $21;__label__ = 6; break;
    case 5: // $22
      var $24 = ((__str5754)|0);__label__ = 6; break;
    case 6: // $23
      var $24;
      $e2_basename=$24;
      var $25=$1;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$2;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($27)|0) < (($30)|0);
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      $result=-1;
      __label__ = 21; break;
    case 8: // $33
      var $34=$1;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$2;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($36)|0) > (($39)|0);
      if ($40) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $41
      $result=1;
      __label__ = 20; break;
    case 10: // $42
      var $43=$e1_basename;
      var $44=$e2_basename;
      var $45=__Z12core_stricmpPKcS0_($43, $44);
      $result=$45;
      var $46=$result;
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $48
      var $49=$e1_basename;
      var $50=$e2_basename;
      var $51=_strcmp($49, $50);
      $result=$51;
      var $52=$result;
      var $53=(($52)|0)==0;
      if ($53) { __label__ = 12; break; } else { __label__ = 18; break; }
    case 12: // $54
      var $55=$1;
      var $56=$2;
      var $57=(($55)>>>0) < (($56)>>>0);
      if ($57) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $58
      $result=-1;
      __label__ = 17; break;
    case 14: // $59
      var $60=$1;
      var $61=$2;
      var $62=(($60)>>>0) > (($61)>>>0);
      if ($62) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $63
      $result=1;
      __label__ = 16; break;
    case 16: // $64
      __label__ = 17; break;
    case 17: // $65
      __label__ = 18; break;
    case 18: // $66
      __label__ = 19; break;
    case 19: // $67
      __label__ = 20; break;
    case 20: // $68
      __label__ = 21; break;
    case 21: // $69
      var $70=$result;
      ;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29compare_file_selector_entriesPK20_file_selector_entryS1_["X"]=1;

function __ZL25file_manager_render_extraR15running_machineP7ui_menuPvS3_ffffff($machine, $menu, $state, $selectedref, $top, $bottom, $origx1, $origy1, $origx2, $origy2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $menustate;
      var $path;
      $1=$machine;
      $2=$menu;
      $3=$state;
      $4=$selectedref;
      $5=$top;
      $6=$bottom;
      $7=$origx1;
      $8=$origy1;
      $9=$origx2;
      $10=$origy2;
      var $11=$3;
      var $12=$11;
      $menustate=$12;
      var $13=$menustate;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$menustate;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZN22device_image_interface8filenameEv($20);
      var $24 = $21;__label__ = 3; break;
    case 2: // $22
      var $24 = 0;__label__ = 3; break;
    case 3: // $23
      var $24;
      $path=$24;
      var $25=$1;
      var $26=$2;
      var $27=$3;
      var $28=$4;
      var $29=$5;
      var $30=$6;
      var $31=$7;
      var $32=$8;
      var $33=$9;
      var $34=$10;
      var $35=$path;
      __ZL17extra_text_renderR15running_machineP7ui_menuPvS3_ffffffPKcS5_($25, $26, $27, $28, $29, $30, $31, $32, $33, $34, 0, $35);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25file_manager_render_extraR15running_machineP7ui_menuPvS3_ffffff["X"]=1;

function __ZN18debug_view_textbufC2ER15running_machine15debug_view_typePFvR10debug_viewPvES5_R12_text_buffer($this, $machine, $type, $osdupdate, $osdprivate, $textbuf) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$machine;
  $3=$type;
  $4=$osdupdate;
  $5=$osdprivate;
  $6=$textbuf;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  __ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_($8, $9, $10, $11, $12);
  var $13=$7;
  HEAP32[(($13)>>2)]=((__ZTV18debug_view_textbuf+8)|0);
  var $14=(($7+92)|0);
  var $15=$6;
  HEAP32[(($14)>>2)]=$15;
  var $16=(($7+96)|0);
  HEAP8[($16)]=1;
  var $17=(($7+100)|0);
  HEAP32[(($17)>>2)]=0;
  ;
  return;
}


function __ZN18debug_view_textbufD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN10debug_viewD2Ev($3);
  ;
  return;
}


function __ZN18debug_view_textbuf11view_updateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curseq;
      var $dest;
      var $row;
      var $line;
      var $col;
      var $len;
      var $effcol;
      $1=$this;
      var $2=$1;
      var $3=(($2+92)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=__Z21text_buffer_max_widthP12_text_buffer($4);
      var $6=$2;
      var $7=(($6+48)|0);
      var $8=(($7)|0);
      HEAP32[(($8)>>2)]=$5;
      var $9=(($2+92)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=__Z21text_buffer_num_linesP12_text_buffer($10);
      var $12=$2;
      var $13=(($12+48)|0);
      var $14=(($13+4)|0);
      HEAP32[(($14)>>2)]=$11;
      var $15=$2;
      var $16=(($15+48)|0);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0) < 80;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$2;
      var $22=(($21+48)|0);
      var $23=(($22)|0);
      HEAP32[(($23)>>2)]=80;
      __label__ = 2; break;
    case 2: // $24
      $curseq=0;
      var $25=(($2+96)|0);
      var $26=HEAP8[($25)];
      var $27=(($26) & 1);
      if ($27) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $28
      var $29=(($2+100)|0);
      var $30=HEAP32[(($29)>>2)];
      $curseq=$30;
      var $31=(($2+92)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$curseq;
      var $34=__Z27text_buffer_get_seqnum_lineP12_text_bufferj($32, $33);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $36
      var $37=(($2+96)|0);
      HEAP8[($37)]=1;
      __label__ = 5; break;
    case 5: // $38
      __label__ = 6; break;
    case 6: // $39
      var $40=(($2+96)|0);
      var $41=HEAP8[($40)];
      var $42=(($41) & 1);
      if ($42) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $43
      var $44=(($2+92)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$2;
      var $47=(($46+48)|0);
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49-1)|0);
      var $51=__Z32text_buffer_line_index_to_seqnumP12_text_bufferj($45, $50);
      $curseq=$51;
      var $52=$2;
      var $53=(($52+48)|0);
      var $54=(($53+4)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$2;
      var $57=(($56+40)|0);
      var $58=(($57+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($55)|0) < (($59)|0);
      if ($60) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $61
      var $62=$2;
      var $63=(($62+48)|0);
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65-1)|0);
      var $67=$curseq;
      var $68=(($67-$66)|0);
      $curseq=$68;
      __label__ = 10; break;
    case 9: // $69
      var $70=$2;
      var $71=(($70+40)|0);
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73-1)|0);
      var $75=$curseq;
      var $76=(($75-$74)|0);
      $curseq=$76;
      __label__ = 10; break;
    case 10: // $77
      __label__ = 11; break;
    case 11: // $78
      var $79=$curseq;
      var $80=(($2+92)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=__Z32text_buffer_line_index_to_seqnumP12_text_bufferj($81, 0);
      var $83=(($79-$82)|0);
      var $84=$2;
      var $85=(($84+56)|0);
      var $86=(($85+4)|0);
      HEAP32[(($86)>>2)]=$83;
      var $87=$2;
      var $88=(($87+80)|0);
      var $89=HEAP32[(($88)>>2)];
      $dest=$89;
      $row=0;
      __label__ = 12; break;
    case 12: // $90
      var $91=$row;
      var $92=$2;
      var $93=(($92+40)|0);
      var $94=(($93+4)|0);
      var $95=HEAPU32[(($94)>>2)];
      var $96=(($91)>>>0) < (($95)>>>0);
      if ($96) { __label__ = 13; break; } else { __label__ = 25; break; }
    case 13: // $97
      var $98=(($2+92)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$curseq;
      var $101=(($100+1)|0);
      $curseq=$101;
      var $102=__Z27text_buffer_get_seqnum_lineP12_text_bufferj($99, $100);
      $line=$102;
      $col=0;
      var $103=$line;
      var $104=(($103)|0)!=0;
      if ($104) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $105
      var $106=$line;
      var $107=_strlen($106);
      $len=$107;
      var $108=$2;
      var $109=(($108+56)|0);
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      $effcol=$111;
      __label__ = 15; break;
    case 15: // $112
      var $113=$col;
      var $114=$2;
      var $115=(($114+40)|0);
      var $116=(($115)|0);
      var $117=HEAPU32[(($116)>>2)];
      var $118=(($113)>>>0) < (($117)>>>0);
      if ($118) { __label__ = 16; break; } else { var $124 = 0;__label__ = 17; break; }
    case 16: // $119
      var $120=$effcol;
      var $121=$len;
      var $122=(($120)>>>0) < (($121)>>>0);
      var $124 = $122;__label__ = 17; break;
    case 17: // $123
      var $124;
      if ($124) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $125
      var $126=$effcol;
      var $127=(($126+1)|0);
      $effcol=$127;
      var $128=$line;
      var $129=(($128+$126)|0);
      var $130=HEAP8[($129)];
      var $131=$dest;
      var $132=(($131)|0);
      HEAP8[($132)]=$130;
      var $133=$dest;
      var $134=(($133+1)|0);
      HEAP8[($134)]=0;
      var $135=$dest;
      var $136=(($135+2)|0);
      $dest=$136;
      var $137=$col;
      var $138=(($137+1)|0);
      $col=$138;
      __label__ = 15; break;
    case 19: // $139
      __label__ = 20; break;
    case 20: // $140
      __label__ = 21; break;
    case 21: // $141
      var $142=$col;
      var $143=$2;
      var $144=(($143+40)|0);
      var $145=(($144)|0);
      var $146=HEAPU32[(($145)>>2)];
      var $147=(($142)>>>0) < (($146)>>>0);
      if ($147) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $148
      var $149=$dest;
      var $150=(($149)|0);
      HEAP8[($150)]=32;
      var $151=$dest;
      var $152=(($151+1)|0);
      HEAP8[($152)]=0;
      var $153=$dest;
      var $154=(($153+2)|0);
      $dest=$154;
      var $155=$col;
      var $156=(($155+1)|0);
      $col=$156;
      __label__ = 21; break;
    case 23: // $157
      __label__ = 24; break;
    case 24: // $158
      var $159=$row;
      var $160=(($159+1)|0);
      $row=$160;
      __label__ = 12; break;
    case 25: // $161
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18debug_view_textbuf11view_updateEv["X"]=1;

function __ZN18debug_view_textbufD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN18debug_view_textbufD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18debug_view_textbufD0Ev["X"]=1;

function __ZNK22debug_view_source_list5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN18debug_view_textbuf11view_notifyE23debug_view_notification($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$type;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==1;
      if ($5) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $6
      var $7=$3;
      var $8=(($7+48)|0);
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$3;
      var $12=(($11+56)|0);
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($10)|0) >= (($14)|0);
      if ($15) { __label__ = 2; break; } else { var $32 = 0;__label__ = 3; break; }
    case 2: // $16
      var $17=$3;
      var $18=(($17+48)|0);
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$3;
      var $22=(($21+56)|0);
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$3;
      var $26=(($25+40)|0);
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($24+$28)|0);
      var $30=(($20)|0) <= (($29)|0);
      var $32 = $30;__label__ = 3; break;
    case 3: // $31
      var $32;
      var $33=(($3+96)|0);
      var $34=(($32)&1);
      HEAP8[($33)]=$34;
      var $35=(($3+96)|0);
      var $36=HEAP8[($35)];
      var $37=(($36) & 1);
      if ($37) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $38
      var $39=(($3+92)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$3;
      var $42=(($41+56)|0);
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=__Z32text_buffer_line_index_to_seqnumP12_text_bufferj($40, $44);
      var $46=(($3+100)|0);
      HEAP32[(($46)>>2)]=$45;
      __label__ = 5; break;
    case 5: // $47
      __label__ = 6; break;
    case 6: // $48
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18debug_view_textbuf11view_notifyE23debug_view_notification["X"]=1;

function __ZN18debug_view_consoleC2ER15running_machinePFvR10debug_viewPvES4_($this, $machine, $osdupdate, $osdprivate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$machine;
  $3=$osdupdate;
  $4=$osdprivate;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=__Z25debug_console_get_textbufv();
  __ZN18debug_view_textbufC2ER15running_machine15debug_view_typePFvR10debug_viewPvES5_R12_text_buffer($6, $7, 1, $8, $9, $10);
  var $11=$5;
  HEAP32[(($11)>>2)]=((__ZTV18debug_view_console+8)|0);
  ;
  return;
}


function __ZN14debug_view_logC2ER15running_machinePFvR10debug_viewPvES4_($this, $machine, $osdupdate, $osdprivate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$machine;
  $3=$osdupdate;
  $4=$osdprivate;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=__Z26debug_errorlog_get_textbufv();
  __ZN18debug_view_textbufC2ER15running_machine15debug_view_typePFvR10debug_viewPvES5_R12_text_buffer($6, $7, 5, $8, $9, $10);
  var $11=$5;
  HEAP32[(($11)>>2)]=((__ZTV14debug_view_log+8)|0);
  ;
  return;
}


function __ZN14debug_view_logD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN14debug_view_logD2Ev($2);
  ;
  return;
}


function __ZN18debug_view_consoleD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN18debug_view_consoleD2Ev($2);
  ;
  return;
}


function __ZN18debug_view_consoleD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN18debug_view_textbufD2Ev($3);
  ;
  return;
}


function __ZN14debug_view_logD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN18debug_view_textbufD2Ev($3);
  ;
  return;
}


function __ZN23debug_view_state_sourceC2EPKcR8device_t($this, $name, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$name;
      $3=$device;
      var $4=$1;
      var $5=$4;
      var $6=$2;
      var $7=$3;
      __ZN17debug_view_sourceC2EPKcP8device_t($5, $6, $7);
      var $8=$4;
      HEAP32[(($8)>>2)]=((__ZTV23debug_view_state_source+8)|0);
      var $9=(($4+76)|0);
      var $10=$3;
      HEAP32[(($9)>>2)]=$10;
      var $11=(($4+80)|0);
      var $12=$3;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      var $15=$12;
      var $16=___dynamic_cast($15, __ZTI8device_t, __ZTI22device_state_interface, -1);
      var $17=$16;
      var $20 = $17;__label__ = 3; break;
    case 2: // $18
      var $20 = 0;__label__ = 3; break;
    case 3: // $19
      var $20;
      HEAP32[(($11)>>2)]=$20;
      var $21=(($4+84)|0);
      var $22=$3;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $24
      var $25=$22;
      var $26=___dynamic_cast($25, __ZTI8device_t, __ZTI24device_execute_interface, -1);
      var $27=$26;
      var $30 = $27;__label__ = 6; break;
    case 5: // $28
      var $30 = 0;__label__ = 6; break;
    case 6: // $29
      var $30;
      HEAP32[(($21)>>2)]=$30;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16debug_view_state5resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $oldhead;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      var $4=(($2+104)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      var $8=(($2+104)|0);
      var $9=HEAP32[(($8)>>2)];
      $oldhead=$9;
      var $10=$oldhead;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($2+104)|0);
      HEAP32[(($13)>>2)]=$12;
      var $14=$2;
      var $15=__ZNK10debug_view7machineEv($14);
      var $16=__ZN15running_machine7respoolEv($15);
      var $17=$oldhead;
      var $18=$17;
      __ZN13resource_pool6removeEPv($16, $18);
      __label__ = 1; break;
    case 3: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14debug_view_logD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN14debug_view_logD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14debug_view_logD0Ev["X"]=1;

function __ZN18debug_view_consoleD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN18debug_view_consoleD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN18debug_view_consoleD0Ev["X"]=1;

function __ZN16debug_view_stateC2ER15running_machinePFvR10debug_viewPvES4_($this, $machine, $osdupdate, $osdprivate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$machine;
      $3=$osdupdate;
      $4=$osdprivate;
      var $7=$1;
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      __ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_($8, $9, 2, $10, $11);
      var $12=$7;
      HEAP32[(($12)>>2)]=((__ZTV16debug_view_state+8)|0);
      var $13=(($7+92)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($7+96)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$23$0=(($14)|0);
      HEAP32[(($st$23$0)>>2)]=$$emscripten$temp$0$0;
      var $st$23$1=(($14+4)|0);
      HEAP32[(($st$23$1)>>2)]=$$emscripten$temp$0$1;
      var $15=(($7+104)|0);
      HEAP32[(($15)>>2)]=0;
      (function() { try { __THREW__ = false; return __ZN16debug_view_state17enumerate_sourcesEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $16
      var $17=$7;
      var $18=(($17+16)|0);
      var $19=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list5countEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $20
      var $21=(($19)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 4; break; }
    case 4: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      $5=$27;
      var $28=$26.f1;
      $6=$28;
      var $29=$7;
      (function() { try { __THREW__ = false; return __ZN10debug_viewD2Ev($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 5: // $30
      ;
      return;
    case 6: // $31
      __label__ = 7; break;
    case 7: // $32
      var $33=$5;
      var $34=$5;
      var $35=$6;
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 9: // $40
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16debug_view_stateC2ER15running_machinePFvR10debug_viewPvES4_["X"]=1;

function __ZN16debug_view_state17enumerate_sourcesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $state=__stackBase__+36;
      var $name=__stackBase__+40;
      var $gotone;
      var $10;
      var $11;
      $9=$this;
      var $12=$9;
      var $13=$12;
      var $14=(($13+16)|0);
      __ZN22debug_view_source_list5resetEv($14);
      HEAP32[(($state)>>2)]=0;
      __ZN7astringC1Ev($name);
      var $15=$12;
      var $16=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 29; break; };
    case 1: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 29; break; };
    case 2: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI22device_state_interfaceEEbRPT_($18, $state) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 29; break; };
    case 3: // $21
      var $22=(($20)&1);
      $gotone=$22;
      __label__ = 4; break;
    case 4: // $23
      var $24=$gotone;
      var $25=(($24) & 1);
      if ($25) { __label__ = 5; break; } else { __label__ = 36; break; }
    case 5: // $26
      var $27=HEAP32[(($state)>>2)];
      var $28=$27;
      var $29=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 29; break; };
    case 6: // $30
      var $31=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 29; break; };
    case 7: // $32
      var $33=HEAP32[(($state)>>2)];
      var $34=$33;
      var $35=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 29; break; };
    case 8: // $36
      var $37=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 29; break; };
    case 9: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($name, ((STRING_TABLE.__str5812)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 29; break; };
    case 10: // $40
      var $41=$12;
      var $42=(($41+16)|0);
      var $43=$12;
      var $44=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 29; break; };
    case 11: // $45
      var $46=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 29; break; };
    case 12: // $47
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      HEAP32[(($4)>>2)]=88;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($6)>>2)]=111;
      var $54=HEAP32[(($4)>>2)];
      var $55=HEAP32[(($5)>>2)];
      var $56=HEAP32[(($6)>>2)];
      var $57=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($54, $55, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $58
      HEAP32[(($result_i)>>2)]=$57;
      var $59=HEAP32[(($result_i)>>2)];
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $61
      var $62=___cxa_allocate_exception(4);
      var $63=$62;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($63);
      (function() { try { __THREW__ = false; return ___cxa_throw($62, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; }
    case 15: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      HEAP32[(($7)>>2)]=$66;
      var $67=$65.f1;
      HEAP32[(($8)>>2)]=$67;
      var $68=HEAP32[(($8)>>2)];
      var $69=(($68)|0) < 0;
      if ($69) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $70
      var $71=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 29; break; }
    case 17: // $_noexc
      throw "Reached an unreachable!"
    case 18: // $72
      var $73=HEAP32[(($7)>>2)];
      var $74=HEAP32[(($7)>>2)];
      var $75=HEAP32[(($8)>>2)];
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      var $eh_lpad_body = $77;__label__ = 30; break;
    case 19: // $78
      throw "Reached an unreachable!"
    case 20: // $_ZnwjPKci_exit
      var $79=HEAPU32[(($result_i)>>2)];
      var $80=$4;
      var $81=$5;
      var $82=$6;
      var $83=$result_i;
      var $84=$7;
      var $85=$8;
      __label__ = 21; break;
    case 21: // $86
      var $87=$79;
      var $88=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 31; break; };
    case 22: // $89
      var $90=HEAP32[(($state)>>2)];
      var $91=$90;
      var $92=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 31; break; };
    case 23: // $93
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN23debug_view_state_sourceC1EPKcR8device_t]($87, $88, $92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 31; break; }
    case 24: // $94
      var $95=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI23debug_view_state_sourceEEPT_S3_($46, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 29; break; };
    case 25: // $96
      var $97=$95;
      (function() { try { __THREW__ = false; return __ZN22debug_view_source_list6appendER17debug_view_source($42, $97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $98
      __label__ = 27; break;
    case 27: // $99
      var $100=HEAP32[(($state)>>2)];
      var $101=$100;
      var $102=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI22device_state_interfaceEEbRPT_($101, $state) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 29; break; };
    case 28: // $103
      var $104=(($102)&1);
      $gotone=$104;
      __label__ = 4; break;
    case 29: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $106;__label__ = 30; break;
    case 30: // $_body
      var $eh_lpad_body;
      var $107=$eh_lpad_body.f0;
      $10=$107;
      var $108=$eh_lpad_body.f1;
      $11=$108;
      __label__ = 39; break;
    case 31: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $10=$111;
      var $112=$110.f1;
      $11=$112;
      var $113=$1;
      var $114=$2;
      var $115=$3;
      HEAP32[(($1)>>2)]=$79;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($3)>>2)]=111;
      var $116=HEAP32[(($1)>>2)];
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $118
      var $119=HEAP32[(($1)>>2)];
      var $120=HEAP32[(($2)>>2)];
      var $121=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($119, $120, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 42; break; }
    case 33: // $_noexc1
      __label__ = 34; break;
    case 34: // $_ZdlPvPKci_exit
      var $122=$1;
      var $123=$2;
      var $124=$3;
      __label__ = 35; break;
    case 35: // $125
      __label__ = 39; break;
    case 36: // $126
      var $127=$12;
      var $128=$12;
      var $129=(($128+16)|0);
      var $130=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list4headEv($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 29; break; };
    case 37: // $131
      (function() { try { __THREW__ = false; return __ZN10debug_view10set_sourceERK17debug_view_source($127, $130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 29; break; }
    case 38: // $132
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      STACKTOP = __stackBase__;
      return;
    case 39: // $133
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $134
      __label__ = 41; break;
    case 41: // $135
      var $136=$10;
      var $137=$10;
      var $138=$11;
      var $139=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $137, tempValue);
      var $140=($139.f1 = $138, $139);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $141
      var $142=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16debug_view_state17enumerate_sourcesEv["X"]=1;

function __ZN16debug_view_stateD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_stateD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16debug_view_stateD0Ev["X"]=1;

function __ZN16debug_view_stateD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV16debug_view_state+8)|0);
      (function() { try { __THREW__ = false; return __ZN16debug_view_state5resetEv($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$4;
      __ZN10debug_viewD2Ev($7);
      ;
      return;
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      var $12=$4;
      (function() { try { __THREW__ = false; return __ZN10debug_viewD2Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      var $15=$2;
      var $16=$2;
      var $17=$3;
      var $18=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $16, tempValue);
      var $19=($18.f1 = $17, $18);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK11device_list5firstI22device_state_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceERP22device_state_interface($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_interface4nextI22device_state_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI22device_state_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZN13resource_pool10add_objectI23debug_view_state_sourceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI23debug_view_state_sourceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI23debug_view_state_sourceEEPT_S3_["X"]=1;

function __ZN16debug_view_state9recomputeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 252; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $result_i11=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $result_i9=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $result_i7=__stackBase__+144;
      var $35=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $result_i5=__stackBase__+168;
      var $40=__stackBase__+172;
      var $41=__stackBase__+176;
      var $42=__stackBase__+180;
      var $43=__stackBase__+184;
      var $44=__stackBase__+188;
      var $result_i3=__stackBase__+192;
      var $45=__stackBase__+196;
      var $46=__stackBase__+200;
      var $47=__stackBase__+204;
      var $48=__stackBase__+208;
      var $49=__stackBase__+212;
      var $result_i1=__stackBase__+216;
      var $50=__stackBase__+220;
      var $51=__stackBase__+224;
      var $52=__stackBase__+228;
      var $53=__stackBase__+232;
      var $54=__stackBase__+236;
      var $result_i=__stackBase__+240;
      var $55=__stackBase__+244;
      var $56=__stackBase__+248;
      var $57;
      var $source;
      var $tailptr;
      var $58;
      var $59;
      var $entry;
      var $count;
      var $maxtaglen;
      var $maxvallen;
      var $item;
      $57=$this;
      var $60=$57;
      var $61=$60;
      var $62=(($61+12)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=__Z8downcastIRK23debug_view_state_sourceK17debug_view_sourceET_RT0_($63);
      $source=$64;
      __ZN16debug_view_state5resetEv($60);
      var $65=(($60+104)|0);
      $tailptr=$65;
      var $66=$60;
      var $67=__ZNK10debug_view7machineEv($66);
      var $68=__ZN15running_machine7respoolEv($67);
      var $69=$52;
      var $70=$53;
      var $71=$54;
      var $72=$result_i;
      var $73=$55;
      var $74=$56;
      HEAP32[(($52)>>2)]=92;
      HEAP32[(($53)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($54)>>2)]=149;
      var $75=HEAP32[(($52)>>2)];
      var $76=HEAP32[(($53)>>2)];
      var $77=HEAP32[(($54)>>2)];
      var $78=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($75, $76, $77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $79
      HEAP32[(($result_i)>>2)]=$78;
      var $80=HEAP32[(($result_i)>>2)];
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $82
      var $83=___cxa_allocate_exception(4);
      var $84=$83;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($84);
      (function() { try { __THREW__ = false; return ___cxa_throw($83, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $87=$86.f0;
      HEAP32[(($55)>>2)]=$87;
      var $88=$86.f1;
      HEAP32[(($56)>>2)]=$88;
      var $89=HEAP32[(($56)>>2)];
      var $90=(($89)|0) < 0;
      if ($90) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $91
      var $92=HEAP32[(($55)>>2)];
      ___cxa_call_unexpected($92);
      throw "Reached an unreachable!"
    case 5: // $93
      var $94=HEAP32[(($55)>>2)];
      var $95=HEAP32[(($55)>>2)];
      var $96=HEAP32[(($56)>>2)];
      var $97=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $95, tempValue);
      var $98=($97.f1 = $96, $97);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $99
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $100=HEAP32[(($result_i)>>2)];
      var $101=$52;
      var $102=$53;
      var $103=$54;
      var $104=$result_i;
      var $105=$55;
      var $106=$56;
      var $107=$100;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($107, -11, ((STRING_TABLE.__str25814)|0), 8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 65; break; }
    case 8: // $108
      var $109=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($68, $107);
      var $110=$tailptr;
      HEAP32[(($110)>>2)]=$109;
      var $111=$tailptr;
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112)|0);
      $tailptr=$113;
      var $114=$60;
      var $115=__ZNK10debug_view7machineEv($114);
      var $116=__ZN15running_machine7respoolEv($115);
      var $117=$47;
      var $118=$48;
      var $119=$49;
      var $120=$result_i1;
      var $121=$50;
      var $122=$51;
      HEAP32[(($47)>>2)]=92;
      HEAP32[(($48)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($49)>>2)]=153;
      var $123=HEAP32[(($47)>>2)];
      var $124=HEAP32[(($48)>>2)];
      var $125=HEAP32[(($49)>>2)];
      var $126=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($123, $124, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $127
      HEAP32[(($result_i1)>>2)]=$126;
      var $128=HEAP32[(($result_i1)>>2)];
      var $129=(($128)|0)==0;
      if ($129) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $130
      var $131=___cxa_allocate_exception(4);
      var $132=$131;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($132);
      (function() { try { __THREW__ = false; return ___cxa_throw($131, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $133
      var $134=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $135=$134.f0;
      HEAP32[(($50)>>2)]=$135;
      var $136=$134.f1;
      HEAP32[(($51)>>2)]=$136;
      var $137=HEAP32[(($51)>>2)];
      var $138=(($137)|0) < 0;
      if ($138) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $139
      var $140=HEAP32[(($50)>>2)];
      ___cxa_call_unexpected($140);
      throw "Reached an unreachable!"
    case 13: // $141
      var $142=HEAP32[(($50)>>2)];
      var $143=HEAP32[(($50)>>2)];
      var $144=HEAP32[(($51)>>2)];
      var $145=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $143, tempValue);
      var $146=($145.f1 = $144, $145);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $147
      throw "Reached an unreachable!"
    case 15: // $_ZnwjPKci_exit2
      var $148=HEAP32[(($result_i1)>>2)];
      var $149=$47;
      var $150=$48;
      var $151=$49;
      var $152=$result_i1;
      var $153=$50;
      var $154=$51;
      var $155=$148;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($155, -12, ((STRING_TABLE.__str35815)|0), 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 70; break; }
    case 16: // $156
      var $157=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($116, $155);
      var $158=$tailptr;
      HEAP32[(($158)>>2)]=$157;
      var $159=$tailptr;
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160)|0);
      $tailptr=$161;
      var $162=$60;
      var $163=__ZNK10debug_view7machineEv($162);
      var $164=__ZN15running_machine7respoolEv($163);
      var $165=$42;
      var $166=$43;
      var $167=$44;
      var $168=$result_i3;
      var $169=$45;
      var $170=$46;
      HEAP32[(($42)>>2)]=92;
      HEAP32[(($43)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($44)>>2)]=157;
      var $171=HEAP32[(($42)>>2)];
      var $172=HEAP32[(($43)>>2)];
      var $173=HEAP32[(($44)>>2)];
      var $174=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($171, $172, $173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; };
    case 17: // $175
      HEAP32[(($result_i3)>>2)]=$174;
      var $176=HEAP32[(($result_i3)>>2)];
      var $177=(($176)|0)==0;
      if ($177) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $178
      var $179=___cxa_allocate_exception(4);
      var $180=$179;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($180);
      (function() { try { __THREW__ = false; return ___cxa_throw($179, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $181
      var $182=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $183=$182.f0;
      HEAP32[(($45)>>2)]=$183;
      var $184=$182.f1;
      HEAP32[(($46)>>2)]=$184;
      var $185=HEAP32[(($46)>>2)];
      var $186=(($185)|0) < 0;
      if ($186) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $187
      var $188=HEAP32[(($45)>>2)];
      ___cxa_call_unexpected($188);
      throw "Reached an unreachable!"
    case 21: // $189
      var $190=HEAP32[(($45)>>2)];
      var $191=HEAP32[(($45)>>2)];
      var $192=HEAP32[(($46)>>2)];
      var $193=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $191, tempValue);
      var $194=($193.f1 = $192, $193);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 22: // $195
      throw "Reached an unreachable!"
    case 23: // $_ZnwjPKci_exit4
      var $196=HEAP32[(($result_i3)>>2)];
      var $197=$42;
      var $198=$43;
      var $199=$44;
      var $200=$result_i3;
      var $201=$45;
      var $202=$46;
      var $203=$196;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($203, -13, ((STRING_TABLE.__str45816)|0), 4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 75; break; }
    case 24: // $204
      var $205=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($164, $203);
      var $206=$tailptr;
      HEAP32[(($206)>>2)]=$205;
      var $207=$tailptr;
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208)|0);
      $tailptr=$209;
      var $210=$60;
      var $211=__ZNK10debug_view7machineEv($210);
      var $212=__ZN15running_machine7respoolEv($211);
      var $213=$37;
      var $214=$38;
      var $215=$39;
      var $216=$result_i5;
      var $217=$40;
      var $218=$41;
      HEAP32[(($37)>>2)]=92;
      HEAP32[(($38)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($39)>>2)]=161;
      var $219=HEAP32[(($37)>>2)];
      var $220=HEAP32[(($38)>>2)];
      var $221=HEAP32[(($39)>>2)];
      var $222=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($219, $220, $221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 27; break; };
    case 25: // $223
      HEAP32[(($result_i5)>>2)]=$222;
      var $224=HEAP32[(($result_i5)>>2)];
      var $225=(($224)|0)==0;
      if ($225) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $226
      var $227=___cxa_allocate_exception(4);
      var $228=$227;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($228);
      (function() { try { __THREW__ = false; return ___cxa_throw($227, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 27; break; }
    case 27: // $229
      var $230=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $231=$230.f0;
      HEAP32[(($40)>>2)]=$231;
      var $232=$230.f1;
      HEAP32[(($41)>>2)]=$232;
      var $233=HEAP32[(($41)>>2)];
      var $234=(($233)|0) < 0;
      if ($234) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $235
      var $236=HEAP32[(($40)>>2)];
      ___cxa_call_unexpected($236);
      throw "Reached an unreachable!"
    case 29: // $237
      var $238=HEAP32[(($40)>>2)];
      var $239=HEAP32[(($40)>>2)];
      var $240=HEAP32[(($41)>>2)];
      var $241=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $239, tempValue);
      var $242=($241.f1 = $240, $241);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 30: // $243
      throw "Reached an unreachable!"
    case 31: // $_ZnwjPKci_exit6
      var $244=HEAP32[(($result_i5)>>2)];
      var $245=$37;
      var $246=$38;
      var $247=$39;
      var $248=$result_i5;
      var $249=$40;
      var $250=$41;
      var $251=$244;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($251, -14, ((STRING_TABLE.__str55817)|0), 6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 80; break; }
    case 32: // $252
      var $253=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($212, $251);
      var $254=$tailptr;
      HEAP32[(($254)>>2)]=$253;
      var $255=$tailptr;
      var $256=HEAP32[(($255)>>2)];
      var $257=(($256)|0);
      $tailptr=$257;
      var $258=$60;
      var $259=__ZNK10debug_view7machineEv($258);
      var $260=__ZN15running_machine7respoolEv($259);
      var $261=$32;
      var $262=$33;
      var $263=$34;
      var $264=$result_i7;
      var $265=$35;
      var $266=$36;
      HEAP32[(($32)>>2)]=92;
      HEAP32[(($33)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($34)>>2)]=165;
      var $267=HEAP32[(($32)>>2)];
      var $268=HEAP32[(($33)>>2)];
      var $269=HEAP32[(($34)>>2)];
      var $270=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; };
    case 33: // $271
      HEAP32[(($result_i7)>>2)]=$270;
      var $272=HEAP32[(($result_i7)>>2)];
      var $273=(($272)|0)==0;
      if ($273) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $274
      var $275=___cxa_allocate_exception(4);
      var $276=$275;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($276);
      (function() { try { __THREW__ = false; return ___cxa_throw($275, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $277
      var $278=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $279=$278.f0;
      HEAP32[(($35)>>2)]=$279;
      var $280=$278.f1;
      HEAP32[(($36)>>2)]=$280;
      var $281=HEAP32[(($36)>>2)];
      var $282=(($281)|0) < 0;
      if ($282) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $283
      var $284=HEAP32[(($35)>>2)];
      ___cxa_call_unexpected($284);
      throw "Reached an unreachable!"
    case 37: // $285
      var $286=HEAP32[(($35)>>2)];
      var $287=HEAP32[(($35)>>2)];
      var $288=HEAP32[(($36)>>2)];
      var $289=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $287, tempValue);
      var $290=($289.f1 = $288, $289);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $291
      throw "Reached an unreachable!"
    case 39: // $_ZnwjPKci_exit8
      var $292=HEAP32[(($result_i7)>>2)];
      var $293=$32;
      var $294=$33;
      var $295=$34;
      var $296=$result_i7;
      var $297=$35;
      var $298=$36;
      var $299=$292;
      var $300=$source;
      var $301=(($300+80)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=(function() { try { __THREW__ = false; return __ZN22device_state_interface23state_string_max_lengthEi($302, -4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 85; break; };
    case 40: // $304
      var $305=(($303) & 255);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($299, -4, ((STRING_TABLE.__str65818)|0), $305) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 85; break; }
    case 41: // $306
      var $307=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($260, $299);
      var $308=$tailptr;
      HEAP32[(($308)>>2)]=$307;
      var $309=$tailptr;
      var $310=HEAP32[(($309)>>2)];
      var $311=(($310)|0);
      $tailptr=$311;
      var $312=$60;
      var $313=__ZNK10debug_view7machineEv($312);
      var $314=__ZN15running_machine7respoolEv($313);
      var $315=$27;
      var $316=$28;
      var $317=$29;
      var $318=$result_i9;
      var $319=$30;
      var $320=$31;
      HEAP32[(($27)>>2)]=92;
      HEAP32[(($28)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($29)>>2)]=169;
      var $321=HEAP32[(($27)>>2)];
      var $322=HEAP32[(($28)>>2)];
      var $323=HEAP32[(($29)>>2)];
      var $324=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($321, $322, $323) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 44; break; };
    case 42: // $325
      HEAP32[(($result_i9)>>2)]=$324;
      var $326=HEAP32[(($result_i9)>>2)];
      var $327=(($326)|0)==0;
      if ($327) { __label__ = 43; break; } else { __label__ = 48; break; }
    case 43: // $328
      var $329=___cxa_allocate_exception(4);
      var $330=$329;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($330);
      (function() { try { __THREW__ = false; return ___cxa_throw($329, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 44; break; }
    case 44: // $331
      var $332=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $333=$332.f0;
      HEAP32[(($30)>>2)]=$333;
      var $334=$332.f1;
      HEAP32[(($31)>>2)]=$334;
      var $335=HEAP32[(($31)>>2)];
      var $336=(($335)|0) < 0;
      if ($336) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $337
      var $338=HEAP32[(($30)>>2)];
      ___cxa_call_unexpected($338);
      throw "Reached an unreachable!"
    case 46: // $339
      var $340=HEAP32[(($30)>>2)];
      var $341=HEAP32[(($30)>>2)];
      var $342=HEAP32[(($31)>>2)];
      var $343=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $341, tempValue);
      var $344=($343.f1 = $342, $343);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 47: // $345
      throw "Reached an unreachable!"
    case 48: // $_ZnwjPKci_exit10
      var $346=HEAP32[(($result_i9)>>2)];
      var $347=$27;
      var $348=$28;
      var $349=$29;
      var $350=$result_i9;
      var $351=$30;
      var $352=$31;
      var $353=$346;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($353, -10, ((__str75819)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 90; break; }
    case 49: // $354
      var $355=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($314, $353);
      var $356=$tailptr;
      HEAP32[(($356)>>2)]=$355;
      var $357=$tailptr;
      var $358=HEAP32[(($357)>>2)];
      var $359=(($358)|0);
      $tailptr=$359;
      var $360=$source;
      var $361=(($360+80)|0);
      var $362=HEAP32[(($361)>>2)];
      var $363=__ZNK22device_state_interface11state_firstEv($362);
      $entry=$363;
      __label__ = 50; break;
    case 50: // $364
      var $365=$entry;
      var $366=(($365)|0)!=0;
      if ($366) { __label__ = 51; break; } else { __label__ = 102; break; }
    case 51: // $367
      var $368=$entry;
      var $369=__ZNK18device_state_entry7visibleEv($368);
      if ($369) { __label__ = 52; break; } else { __label__ = 100; break; }
    case 52: // $370
      var $371=$60;
      var $372=__ZNK10debug_view7machineEv($371);
      var $373=__ZN15running_machine7respoolEv($372);
      var $374=$22;
      var $375=$23;
      var $376=$24;
      var $377=$result_i11;
      var $378=$25;
      var $379=$26;
      HEAP32[(($22)>>2)]=92;
      HEAP32[(($23)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($24)>>2)]=176;
      var $380=HEAP32[(($22)>>2)];
      var $381=HEAP32[(($23)>>2)];
      var $382=HEAP32[(($24)>>2)];
      var $383=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($380, $381, $382) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 55; break; };
    case 53: // $384
      HEAP32[(($result_i11)>>2)]=$383;
      var $385=HEAP32[(($result_i11)>>2)];
      var $386=(($385)|0)==0;
      if ($386) { __label__ = 54; break; } else { __label__ = 59; break; }
    case 54: // $387
      var $388=___cxa_allocate_exception(4);
      var $389=$388;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($389);
      (function() { try { __THREW__ = false; return ___cxa_throw($388, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 55; break; }
    case 55: // $390
      var $391=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $392=$391.f0;
      HEAP32[(($25)>>2)]=$392;
      var $393=$391.f1;
      HEAP32[(($26)>>2)]=$393;
      var $394=HEAP32[(($26)>>2)];
      var $395=(($394)|0) < 0;
      if ($395) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $396
      var $397=HEAP32[(($25)>>2)];
      ___cxa_call_unexpected($397);
      throw "Reached an unreachable!"
    case 57: // $398
      var $399=HEAP32[(($25)>>2)];
      var $400=HEAP32[(($25)>>2)];
      var $401=HEAP32[(($26)>>2)];
      var $402=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $400, tempValue);
      var $403=($402.f1 = $401, $402);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 58: // $404
      throw "Reached an unreachable!"
    case 59: // $_ZnwjPKci_exit12
      var $405=HEAP32[(($result_i11)>>2)];
      var $406=$22;
      var $407=$23;
      var $408=$24;
      var $409=$result_i11;
      var $410=$25;
      var $411=$26;
      var $412=$405;
      var $413=$entry;
      var $414=(function() { try { __THREW__ = false; return __ZNK18device_state_entry5indexEv($413) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 95; break; };
    case 60: // $415
      var $416=$entry;
      var $417=(function() { try { __THREW__ = false; return __ZNK18device_state_entry6symbolEv($416) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 95; break; };
    case 61: // $418
      var $419=$source;
      var $420=(($419+80)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=$entry;
      var $423=(function() { try { __THREW__ = false; return __ZNK18device_state_entry5indexEv($422) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 95; break; };
    case 62: // $424
      var $425=(function() { try { __THREW__ = false; return __ZN22device_state_interface23state_string_max_lengthEi($421, $423) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 95; break; };
    case 63: // $426
      var $427=(($425) & 255);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN16debug_view_state10state_itemC1EiPKch]($412, $414, $417, $427) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 95; break; }
    case 64: // $428
      var $429=__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($373, $412);
      var $430=$tailptr;
      HEAP32[(($430)>>2)]=$429;
      var $431=$tailptr;
      var $432=HEAP32[(($431)>>2)];
      var $433=(($432)|0);
      $tailptr=$433;
      __label__ = 100; break;
    case 65: // $434
      var $435=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $436=$435.f0;
      $58=$436;
      var $437=$435.f1;
      $59=$437;
      var $438=$19;
      var $439=$20;
      var $440=$21;
      HEAP32[(($19)>>2)]=$100;
      HEAP32[(($20)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($21)>>2)]=149;
      var $441=HEAP32[(($19)>>2)];
      var $442=(($441)|0)!=0;
      if ($442) { __label__ = 66; break; } else { __label__ = 68; break; }
    case 66: // $443
      var $444=HEAP32[(($19)>>2)];
      var $445=HEAP32[(($20)>>2)];
      var $446=HEAP32[(($21)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($444, $445, $446) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 114; break; }
    case 67: // $_noexc
      __label__ = 68; break;
    case 68: // $_ZdlPvPKci_exit
      var $447=$19;
      var $448=$20;
      var $449=$21;
      __label__ = 69; break;
    case 69: // $450
      __label__ = 113; break;
    case 70: // $451
      var $452=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $453=$452.f0;
      $58=$453;
      var $454=$452.f1;
      $59=$454;
      var $455=$16;
      var $456=$17;
      var $457=$18;
      HEAP32[(($16)>>2)]=$148;
      HEAP32[(($17)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($18)>>2)]=153;
      var $458=HEAP32[(($16)>>2)];
      var $459=(($458)|0)!=0;
      if ($459) { __label__ = 71; break; } else { __label__ = 73; break; }
    case 71: // $460
      var $461=HEAP32[(($16)>>2)];
      var $462=HEAP32[(($17)>>2)];
      var $463=HEAP32[(($18)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($461, $462, $463) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 114; break; }
    case 72: // $_noexc13
      __label__ = 73; break;
    case 73: // $_ZdlPvPKci_exit14
      var $464=$16;
      var $465=$17;
      var $466=$18;
      __label__ = 74; break;
    case 74: // $467
      __label__ = 113; break;
    case 75: // $468
      var $469=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $470=$469.f0;
      $58=$470;
      var $471=$469.f1;
      $59=$471;
      var $472=$13;
      var $473=$14;
      var $474=$15;
      HEAP32[(($13)>>2)]=$196;
      HEAP32[(($14)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($15)>>2)]=157;
      var $475=HEAP32[(($13)>>2)];
      var $476=(($475)|0)!=0;
      if ($476) { __label__ = 76; break; } else { __label__ = 78; break; }
    case 76: // $477
      var $478=HEAP32[(($13)>>2)];
      var $479=HEAP32[(($14)>>2)];
      var $480=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($478, $479, $480) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 114; break; }
    case 77: // $_noexc15
      __label__ = 78; break;
    case 78: // $_ZdlPvPKci_exit16
      var $481=$13;
      var $482=$14;
      var $483=$15;
      __label__ = 79; break;
    case 79: // $484
      __label__ = 113; break;
    case 80: // $485
      var $486=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $487=$486.f0;
      $58=$487;
      var $488=$486.f1;
      $59=$488;
      var $489=$10;
      var $490=$11;
      var $491=$12;
      HEAP32[(($10)>>2)]=$244;
      HEAP32[(($11)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($12)>>2)]=161;
      var $492=HEAP32[(($10)>>2)];
      var $493=(($492)|0)!=0;
      if ($493) { __label__ = 81; break; } else { __label__ = 83; break; }
    case 81: // $494
      var $495=HEAP32[(($10)>>2)];
      var $496=HEAP32[(($11)>>2)];
      var $497=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($495, $496, $497) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 114; break; }
    case 82: // $_noexc17
      __label__ = 83; break;
    case 83: // $_ZdlPvPKci_exit18
      var $498=$10;
      var $499=$11;
      var $500=$12;
      __label__ = 84; break;
    case 84: // $501
      __label__ = 113; break;
    case 85: // $502
      var $503=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $504=$503.f0;
      $58=$504;
      var $505=$503.f1;
      $59=$505;
      var $506=$7;
      var $507=$8;
      var $508=$9;
      HEAP32[(($7)>>2)]=$292;
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($9)>>2)]=165;
      var $509=HEAP32[(($7)>>2)];
      var $510=(($509)|0)!=0;
      if ($510) { __label__ = 86; break; } else { __label__ = 88; break; }
    case 86: // $511
      var $512=HEAP32[(($7)>>2)];
      var $513=HEAP32[(($8)>>2)];
      var $514=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($512, $513, $514) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 114; break; }
    case 87: // $_noexc19
      __label__ = 88; break;
    case 88: // $_ZdlPvPKci_exit20
      var $515=$7;
      var $516=$8;
      var $517=$9;
      __label__ = 89; break;
    case 89: // $518
      __label__ = 113; break;
    case 90: // $519
      var $520=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $521=$520.f0;
      $58=$521;
      var $522=$520.f1;
      $59=$522;
      var $523=$4;
      var $524=$5;
      var $525=$6;
      HEAP32[(($4)>>2)]=$346;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($6)>>2)]=169;
      var $526=HEAP32[(($4)>>2)];
      var $527=(($526)|0)!=0;
      if ($527) { __label__ = 91; break; } else { __label__ = 93; break; }
    case 91: // $528
      var $529=HEAP32[(($4)>>2)];
      var $530=HEAP32[(($5)>>2)];
      var $531=HEAP32[(($6)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($529, $530, $531) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 114; break; }
    case 92: // $_noexc21
      __label__ = 93; break;
    case 93: // $_ZdlPvPKci_exit22
      var $532=$4;
      var $533=$5;
      var $534=$6;
      __label__ = 94; break;
    case 94: // $535
      __label__ = 113; break;
    case 95: // $536
      var $537=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $538=$537.f0;
      $58=$538;
      var $539=$537.f1;
      $59=$539;
      var $540=$1;
      var $541=$2;
      var $542=$3;
      HEAP32[(($1)>>2)]=$405;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15813)|0);
      HEAP32[(($3)>>2)]=176;
      var $543=HEAP32[(($1)>>2)];
      var $544=(($543)|0)!=0;
      if ($544) { __label__ = 96; break; } else { __label__ = 98; break; }
    case 96: // $545
      var $546=HEAP32[(($1)>>2)];
      var $547=HEAP32[(($2)>>2)];
      var $548=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($546, $547, $548) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 97; break; } else { __label__ = 114; break; }
    case 97: // $_noexc23
      __label__ = 98; break;
    case 98: // $_ZdlPvPKci_exit24
      var $549=$1;
      var $550=$2;
      var $551=$3;
      __label__ = 99; break;
    case 99: // $552
      __label__ = 113; break;
    case 100: // $553
      __label__ = 101; break;
    case 101: // $554
      var $555=$entry;
      var $556=__ZNK18device_state_entry4nextEv($555);
      $entry=$556;
      __label__ = 50; break;
    case 102: // $557
      $count=0;
      $maxtaglen=0;
      $maxvallen=0;
      var $558=(($60+104)|0);
      var $559=HEAP32[(($558)>>2)];
      $item=$559;
      __label__ = 103; break;
    case 103: // $560
      var $561=$item;
      var $562=(($561)|0)!=0;
      if ($562) { __label__ = 104; break; } else { __label__ = 112; break; }
    case 104: // $563
      var $564=$count;
      var $565=(($564+1)|0);
      $count=$565;
      var $566=$maxtaglen;
      var $567=$item;
      var $568=(($567+28)|0);
      var $569=__ZNK7astring3lenEv($568);
      var $570=(($566)|0) > (($569)|0);
      if ($570) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $571
      var $572=$maxtaglen;
      var $578 = $572;__label__ = 107; break;
    case 106: // $573
      var $574=$item;
      var $575=(($574+28)|0);
      var $576=__ZNK7astring3lenEv($575);
      var $578 = $576;__label__ = 107; break;
    case 107: // $577
      var $578;
      $maxtaglen=$578;
      var $579=$maxvallen;
      var $580=$item;
      var $581=(($580+24)|0);
      var $582=HEAPU8[($581)];
      var $583=(($582)&255);
      var $584=(($579)|0) > (($583)|0);
      if ($584) { __label__ = 108; break; } else { __label__ = 109; break; }
    case 108: // $585
      var $586=$maxvallen;
      var $593 = $586;__label__ = 110; break;
    case 109: // $587
      var $588=$item;
      var $589=(($588+24)|0);
      var $590=HEAPU8[($589)];
      var $591=(($590)&255);
      var $593 = $591;__label__ = 110; break;
    case 110: // $592
      var $593;
      $maxvallen=$593;
      __label__ = 111; break;
    case 111: // $594
      var $595=$item;
      var $596=(($595)|0);
      var $597=HEAP32[(($596)>>2)];
      $item=$597;
      __label__ = 103; break;
    case 112: // $598
      var $599=$maxtaglen;
      var $600=(($599+1)|0);
      var $601=(($600+1)|0);
      var $602=(($60+92)|0);
      HEAP32[(($602)>>2)]=$601;
      var $603=$maxtaglen;
      var $604=(($603+1)|0);
      var $605=(($604+2)|0);
      var $606=$maxvallen;
      var $607=(($605+$606)|0);
      var $608=(($607+1)|0);
      var $609=$60;
      var $610=(($609+48)|0);
      var $611=(($610)|0);
      HEAP32[(($611)>>2)]=$608;
      var $612=$count;
      var $613=$60;
      var $614=(($613+48)|0);
      var $615=(($614+4)|0);
      HEAP32[(($615)>>2)]=$612;
      var $616=$60;
      var $617=(($616+56)|0);
      var $618=(($617)|0);
      HEAP32[(($618)>>2)]=0;
      var $619=$60;
      var $620=(($619+56)|0);
      var $621=(($620+4)|0);
      HEAP32[(($621)>>2)]=0;
      var $622=$60;
      var $623=(($622+74)|0);
      HEAP8[($623)]=0;
      STACKTOP = __stackBase__;
      return;
    case 113: // $624
      var $625=$58;
      var $626=$58;
      var $627=$59;
      var $628=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $626, tempValue);
      var $629=($628.f1 = $627, $628);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 114: // $630
      var $631=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16debug_view_state9recomputeEv["X"]=1;

function __Z8downcastIRK23debug_view_state_sourceK17debug_view_sourceET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK18device_state_entry7visibleEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+21)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 & 1;
  var $7=(($6)|0)==0;
  ;
  return $7;
}


function __ZN16debug_view_state11view_notifyE23debug_view_notification($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$type;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==3;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$3;
      var $8=(($7+74)|0);
      HEAP8[($8)]=1;
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN16debug_view_state10state_itemC2EiPKch($this, $index, $name, $valuechars) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$index;
  $3=$name;
  $4=$valuechars;
  var $5=$1;
  var $6=(($5)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($5+4)|0);
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  var $st$14$0=(($7)|0);
  HEAP32[(($st$14$0)>>2)]=$$emscripten$temp$0$0;
  var $st$14$1=(($7+4)|0);
  HEAP32[(($st$14$1)>>2)]=$$emscripten$temp$0$1;
  var $8=(($5+12)|0);
  var $$emscripten$temp$1$0=0;
  var $$emscripten$temp$1$1=0;
  var $st$21$0=(($8)|0);
  HEAP32[(($st$21$0)>>2)]=$$emscripten$temp$1$0;
  var $st$21$1=(($8+4)|0);
  HEAP32[(($st$21$1)>>2)]=$$emscripten$temp$1$1;
  var $9=(($5+20)|0);
  var $10=$2;
  HEAP32[(($9)>>2)]=$10;
  var $11=(($5+24)|0);
  var $12=$4;
  HEAP8[($11)]=$12;
  var $13=(($5+28)|0);
  var $14=$3;
  __ZN7astringC1EPKc($13, $14);
  ;
  return;
}


function __ZN23debug_view_state_sourceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN23debug_view_state_sourceD2Ev($2);
  ;
  return;
}


function __ZN23debug_view_state_sourceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17debug_view_sourceD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectIN16debug_view_state10state_itemEEC1EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectIN16debug_view_state10state_itemEEC2EPS1_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectIN16debug_view_state10state_itemEEC2EPS1_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 92);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectIN16debug_view_state10state_itemEE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectIN16debug_view_state10state_itemEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectIN16debug_view_state10state_itemEED2Ev($2);
  ;
  return;
}


function __ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16debug_view_state10state_itemEEC1EPS1_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_["X"]=1;

function __ZN16debug_view_state11view_updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 328; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $source;
      var $total_cycles=__stackBase__;
      var $curitem;
      var $index;
      var $screen;
      var $dest;
      var $row;
      var $col;
      var $effcol;
      var $attrib;
      var $len;
      var $valstr=__stackBase__+8;
      var $2;
      var $3;
      var $i;
      var $temp=__stackBase__+72;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+74)|0);
      var $7=HEAP8[($6)];
      var $8=(($7) & 1);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      __ZN16debug_view_state9recomputeEv($4);
      __label__ = 2; break;
    case 2: // $10
      var $11=$4;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=__Z8downcastIRK23debug_view_state_sourceK17debug_view_sourceET_RT0_($13);
      $source=$14;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$7$0=(($total_cycles)|0);
      HEAP32[(($st$7$0)>>2)]=$$emscripten$temp$0$0;
      var $st$7$1=(($total_cycles+4)|0);
      HEAP32[(($st$7$1)>>2)]=$$emscripten$temp$0$1;
      var $15=$source;
      var $16=(($15+84)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$source;
      var $21=(($20+84)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK24device_execute_interface12total_cyclesEv($22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $st$6$0=(($total_cycles)|0);
      HEAP32[(($st$6$0)>>2)]=$23$0;
      var $st$6$1=(($total_cycles+4)|0);
      HEAP32[(($st$6$1)>>2)]=$23$1;
      __label__ = 4; break;
    case 4: // $24
      var $25=(($4+104)|0);
      var $26=HEAP32[(($25)>>2)];
      $curitem=$26;
      $index=0;
      __label__ = 5; break;
    case 5: // $27
      var $28=$curitem;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { var $38 = 0;__label__ = 7; break; }
    case 6: // $30
      var $31=$index;
      var $32=$4;
      var $33=(($32+56)|0);
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($31)|0) < (($35)|0);
      var $38 = $36;__label__ = 7; break;
    case 7: // $37
      var $38;
      if ($38) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $39
      var $40=$curitem;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      $curitem=$42;
      __label__ = 9; break;
    case 9: // $43
      var $44=$index;
      var $45=(($44+1)|0);
      $index=$45;
      __label__ = 5; break;
    case 10: // $46
      var $47=$4;
      var $48=__ZNK10debug_view7machineEv($47);
      var $49=(($48+560)|0);
      var $50=HEAP32[(($49)>>2)];
      $screen=$50;
      var $51=$4;
      var $52=(($51+80)|0);
      var $53=HEAP32[(($52)>>2)];
      $dest=$53;
      $row=0;
      __label__ = 11; break;
    case 11: // $54
      var $55=$row;
      var $56=$4;
      var $57=(($56+40)|0);
      var $58=(($57+4)|0);
      var $59=HEAPU32[(($58)>>2)];
      var $60=(($55)>>>0) < (($59)>>>0);
      if ($60) { __label__ = 12; break; } else { __label__ = 73; break; }
    case 12: // $61
      $col=0;
      var $62=$curitem;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 13; break; } else { __label__ = 68; break; }
    case 13: // $64
      var $65=$4;
      var $66=(($65+56)|0);
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      $effcol=$68;
      $attrib=0;
      $len=0;
      __ZN7astringC1Ev($valstr);
      var $69=$curitem;
      var $70=(($69+20)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0) >= -14;
      if ($72) { __label__ = 14; break; } else { __label__ = 45; break; }
    case 14: // $73
      var $74=$curitem;
      var $75=(($74+20)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0) <= -10;
      if ($77) { __label__ = 15; break; } else { __label__ = 45; break; }
    case 15: // $78
      var $79=$curitem;
      var $80=(($79+12)|0);
      var $st$2$0=(($80)|0);
      var $81$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($80+4)|0);
      var $81$1=HEAP32[(($st$2$1)>>2)];
      var $82=$curitem;
      var $83=(($82+4)|0);
      var $st$8$0=(($83)|0);
      HEAP32[(($st$8$0)>>2)]=$81$0;
      var $st$8$1=(($83+4)|0);
      HEAP32[(($st$8$1)>>2)]=$81$1;
      var $84=$curitem;
      var $85=(($84+20)|0);
      var $86=HEAP32[(($85)>>2)];
      if ($86 == -10) {
        __label__ = 16; break;
      }
      else if ($86 == -11) {
        __label__ = 24; break;
      }
      else if ($86 == -12) {
        __label__ = 29; break;
      }
      else if ($86 == -13) {
        __label__ = 34; break;
      }
      else if ($86 == -14) {
        __label__ = 39; break;
      }
      else {
      __label__ = 44; break;
      }
      
    case 16: // $87
      var $88=$curitem;
      var $89=(($88+24)|0);
      HEAP8[($89)]=0;
      var $90=$curitem;
      var $91=(($90+28)|0);
      var $92=(function() { try { __THREW__ = false; return __ZN7astring5resetEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 22; break; };
    case 17: // $93
      $i=0;
      __label__ = 18; break;
    case 18: // $94
      var $95=$i;
      var $96=$4;
      var $97=(($96+48)|0);
      var $98=(($97)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($95)|0) < (($99)|0);
      if ($100) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $101
      var $102=$curitem;
      var $103=(($102+28)|0);
      var $104=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($103, ((STRING_TABLE.__str85820)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; };
    case 20: // $105
      __label__ = 21; break;
    case 21: // $106
      var $107=$i;
      var $108=(($107+1)|0);
      $i=$108;
      __label__ = 18; break;
    case 22: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $2=$111;
      var $112=$110.f1;
      $3=$112;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($valstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 75; break; }
    case 23: // $113
      __label__ = 44; break;
    case 24: // $114
      var $115=$source;
      var $116=(($115+84)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $119
      var $120=$source;
      var $121=(($120+84)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(function() { try { __THREW__ = false; return __ZNK24device_execute_interface16cycles_remainingEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 22; break; };
    case 26: // $124
      var $125$0=$123;
      var $125$1=(($123|0) < 0 ? -1 : 0);
      var $126=$curitem;
      var $127=(($126+12)|0);
      var $st$4$0=(($127)|0);
      HEAP32[(($st$4$0)>>2)]=$125$0;
      var $st$4$1=(($127+4)|0);
      HEAP32[(($st$4$1)>>2)]=$125$1;
      var $128=$curitem;
      var $129=(($128+12)|0);
      var $st$10$0=(($129)|0);
      var $130$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($129+4)|0);
      var $130$1=HEAP32[(($st$10$1)>>2)];
      var $131$0=$130$0;
      var $131=$131$0;
      var $132=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($valstr, ((STRING_TABLE.__str95821)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$131,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 22; break; };
    case 27: // $133
      __label__ = 28; break;
    case 28: // $134
      __label__ = 44; break;
    case 29: // $135
      var $136=$screen;
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $138
      var $139=$screen;
      var $140=(function() { try { __THREW__ = false; return __ZNK13screen_device4hposEv($139) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 22; break; };
    case 31: // $141
      var $142$0=$140;
      var $142$1=(($140|0) < 0 ? -1 : 0);
      var $143=$curitem;
      var $144=(($143+12)|0);
      var $st$4$0=(($144)|0);
      HEAP32[(($st$4$0)>>2)]=$142$0;
      var $st$4$1=(($144+4)|0);
      HEAP32[(($st$4$1)>>2)]=$142$1;
      var $145=$curitem;
      var $146=(($145+12)|0);
      var $st$10$0=(($146)|0);
      var $147$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($146+4)|0);
      var $147$1=HEAP32[(($st$10$1)>>2)];
      var $148$0=$147$0;
      var $148=$148$0;
      var $149=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($valstr, ((STRING_TABLE.__str105822)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$148,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 22; break; };
    case 32: // $150
      __label__ = 33; break;
    case 33: // $151
      __label__ = 44; break;
    case 34: // $152
      var $153=$screen;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $155
      var $156=$screen;
      var $157=(function() { try { __THREW__ = false; return __ZNK13screen_device4vposEv($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 22; break; };
    case 36: // $158
      var $159$0=$157;
      var $159$1=(($157|0) < 0 ? -1 : 0);
      var $160=$curitem;
      var $161=(($160+12)|0);
      var $st$4$0=(($161)|0);
      HEAP32[(($st$4$0)>>2)]=$159$0;
      var $st$4$1=(($161+4)|0);
      HEAP32[(($st$4$1)>>2)]=$159$1;
      var $162=$curitem;
      var $163=(($162+12)|0);
      var $st$10$0=(($163)|0);
      var $164$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($163+4)|0);
      var $164$1=HEAP32[(($st$10$1)>>2)];
      var $165$0=$164$0;
      var $165=$165$0;
      var $166=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($valstr, ((STRING_TABLE.__str105822)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$165,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 22; break; };
    case 37: // $167
      __label__ = 38; break;
    case 38: // $168
      __label__ = 44; break;
    case 39: // $169
      var $170=$screen;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $172
      var $173=$screen;
      var $174=(function() { try { __THREW__ = false; return __ZNK13screen_device12frame_numberEv($173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 22; break; };
      var $174$0=$174[0];
      var $174$1=$174[1];
    case 41: // $175
      var $176=$curitem;
      var $177=(($176+12)|0);
      var $st$2$0=(($177)|0);
      HEAP32[(($st$2$0)>>2)]=$174$0;
      var $st$2$1=(($177+4)|0);
      HEAP32[(($st$2$1)>>2)]=$174$1;
      var $178=$curitem;
      var $179=(($178+12)|0);
      var $st$8$0=(($179)|0);
      var $180$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($179+4)|0);
      var $180$1=HEAP32[(($st$8$1)>>2)];
      var $181$0=$180$0;
      var $181=$181$0;
      var $182=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($valstr, ((STRING_TABLE.__str115823)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$181,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 22; break; };
    case 42: // $183
      __label__ = 43; break;
    case 43: // $184
      __label__ = 44; break;
    case 44: // $185
      __label__ = 50; break;
    case 45: // $186
      var $187=(($4+96)|0);
      var $st$1$0=(($187)|0);
      var $188$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($187+4)|0);
      var $188$1=HEAP32[(($st$1$1)>>2)];
      var $st$5$0=(($total_cycles)|0);
      var $189$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($total_cycles+4)|0);
      var $189$1=HEAP32[(($st$5$1)>>2)];
      var $190=$188$0 != $189$0 || $188$1 != $189$1;
      if ($190) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $191
      var $192=$curitem;
      var $193=(($192+12)|0);
      var $st$2$0=(($193)|0);
      var $194$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($193+4)|0);
      var $194$1=HEAP32[(($st$2$1)>>2)];
      var $195=$curitem;
      var $196=(($195+4)|0);
      var $st$8$0=(($196)|0);
      HEAP32[(($st$8$0)>>2)]=$194$0;
      var $st$8$1=(($196+4)|0);
      HEAP32[(($st$8$1)>>2)]=$194$1;
      __label__ = 47; break;
    case 47: // $197
      var $198=$source;
      var $199=(($198+80)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=$curitem;
      var $202=(($201+20)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(function() { try { __THREW__ = false; return __ZN22device_state_interface5stateEi($200, $203) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 22; break; };
      var $204$0=$204[0];
      var $204$1=$204[1];
    case 48: // $205
      var $206=$curitem;
      var $207=(($206+12)|0);
      var $st$2$0=(($207)|0);
      HEAP32[(($st$2$0)>>2)]=$204$0;
      var $st$2$1=(($207+4)|0);
      HEAP32[(($st$2$1)>>2)]=$204$1;
      var $208=$source;
      var $209=(($208+80)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$curitem;
      var $212=(($211+20)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(function() { try { __THREW__ = false; return __ZN22device_state_interface12state_stringEiR7astring($210, $213, $valstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 22; break; };
    case 49: // $215
      __label__ = 50; break;
    case 50: // $216
      var $217=$curitem;
      var $218=(($217+4)|0);
      var $st$2$0=(($218)|0);
      var $219$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($218+4)|0);
      var $219$1=HEAP32[(($st$2$1)>>2)];
      var $220=$curitem;
      var $221=(($220+12)|0);
      var $st$8$0=(($221)|0);
      var $222$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($221+4)|0);
      var $222$1=HEAP32[(($st$8$1)>>2)];
      var $223=$219$0 != $222$0 || $219$1 != $222$1;
      if ($223) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $224
      $attrib=1;
      __label__ = 52; break;
    case 52: // $225
      var $226=$curitem;
      var $227=(($226+28)|0);
      var $228=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($227) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 22; break; };
    case 53: // $229
      var $230=(($4+92)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231-1)|0);
      var $233=(($228)|0) < (($232)|0);
      if ($233) { __label__ = 54; break; } else { __label__ = 57; break; }
    case 54: // $234
      var $235=$len;
      var $236=(($temp+$235)|0);
      var $237=(($4+92)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($238-1)|0);
      var $240=$curitem;
      var $241=(($240+28)|0);
      var $242=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 22; break; };
    case 55: // $243
      var $244=(($239-$242)|0);
      _memset($236, 32, $244, 1);
      var $245=(($4+92)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246-1)|0);
      var $248=$curitem;
      var $249=(($248+28)|0);
      var $250=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($249) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 22; break; };
    case 56: // $251
      var $252=(($247-$250)|0);
      var $253=$len;
      var $254=(($253+$252)|0);
      $len=$254;
      __label__ = 57; break;
    case 57: // $255
      var $256=$len;
      var $257=(($temp+$256)|0);
      var $258=$curitem;
      var $259=(($258+28)|0);
      var $260=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($259) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 22; break; };
    case 58: // $261
      var $262=$curitem;
      var $263=(($262+28)|0);
      var $264=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($263) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 22; break; };
    case 59: // $265
      assert($264 % 1 === 0, 'memcpy given ' + $264 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($257, $260, $264, 1);
      var $266=$curitem;
      var $267=(($266+28)|0);
      var $268=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($267) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 22; break; };
    case 60: // $269
      var $270=$len;
      var $271=(($270+$268)|0);
      $len=$271;
      var $272=$len;
      var $273=(($272+1)|0);
      $len=$273;
      var $274=(($temp+$272)|0);
      HEAP8[($274)]=32;
      var $275=$len;
      var $276=(($275+1)|0);
      $len=$276;
      var $277=(($temp+$275)|0);
      HEAP8[($277)]=32;
      var $278=$len;
      var $279=(($temp+$278)|0);
      var $280=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($valstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 22; break; };
    case 61: // $281
      var $282=$curitem;
      var $283=(($282+24)|0);
      var $284=HEAPU8[($283)];
      var $285=(($284)&255);
      assert($285 % 1 === 0, 'memcpy given ' + $285 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($279, $280, $285, 1);
      var $286=$curitem;
      var $287=(($286+24)|0);
      var $288=HEAPU8[($287)];
      var $289=(($288)&255);
      var $290=$len;
      var $291=(($290+$289)|0);
      $len=$291;
      var $292=$len;
      var $293=(($292+1)|0);
      $len=$293;
      var $294=(($temp+$292)|0);
      HEAP8[($294)]=32;
      var $295=$len;
      var $296=(($temp+$295)|0);
      HEAP8[($296)]=0;
      __label__ = 62; break;
    case 62: // $297
      var $298=$col;
      var $299=$4;
      var $300=(($299+40)|0);
      var $301=(($300)|0);
      var $302=HEAPU32[(($301)>>2)];
      var $303=(($298)>>>0) < (($302)>>>0);
      if ($303) { __label__ = 63; break; } else { var $309 = 0;__label__ = 64; break; }
    case 63: // $304
      var $305=$effcol;
      var $306=$len;
      var $307=(($305)>>>0) < (($306)>>>0);
      var $309 = $307;__label__ = 64; break;
    case 64: // $308
      var $309;
      if ($309) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $310
      var $311=$effcol;
      var $312=(($311+1)|0);
      $effcol=$312;
      var $313=(($temp+$311)|0);
      var $314=HEAP8[($313)];
      var $315=$dest;
      var $316=(($315)|0);
      HEAP8[($316)]=$314;
      var $317=$attrib;
      var $318=(($317)&255);
      var $319=$effcol;
      var $320=(($4+92)|0);
      var $321=HEAPU32[(($320)>>2)];
      var $322=(($319)>>>0) <= (($321)>>>0);
      var $323=$322 ? 16 : 0;
      var $324=(($323)&255);
      var $325=$318 | $324;
      var $326=(($325) & 255);
      var $327=$dest;
      var $328=(($327+1)|0);
      HEAP8[($328)]=$326;
      var $329=$dest;
      var $330=(($329+2)|0);
      $dest=$330;
      var $331=$col;
      var $332=(($331+1)|0);
      $col=$332;
      __label__ = 62; break;
    case 66: // $333
      var $334=$curitem;
      var $335=(($334)|0);
      var $336=HEAP32[(($335)>>2)];
      $curitem=$336;
      FUNCTION_TABLE[__ZN7astringD1Ev]($valstr);
      __label__ = 68; break;
    case 67: // $337
      __label__ = 74; break;
    case 68: // $338
      __label__ = 69; break;
    case 69: // $339
      var $340=$col;
      var $341=$4;
      var $342=(($341+40)|0);
      var $343=(($342)|0);
      var $344=HEAPU32[(($343)>>2)];
      var $345=(($340)>>>0) < (($344)>>>0);
      if ($345) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $346
      var $347=$dest;
      var $348=(($347)|0);
      HEAP8[($348)]=32;
      var $349=$dest;
      var $350=(($349+1)|0);
      HEAP8[($350)]=0;
      var $351=$dest;
      var $352=(($351+2)|0);
      $dest=$352;
      var $353=$col;
      var $354=(($353+1)|0);
      $col=$354;
      __label__ = 69; break;
    case 71: // $355
      __label__ = 72; break;
    case 72: // $356
      var $357=$row;
      var $358=(($357+1)|0);
      $row=$358;
      __label__ = 11; break;
    case 73: // $359
      var $st$0$0=(($total_cycles)|0);
      var $360$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($total_cycles+4)|0);
      var $360$1=HEAP32[(($st$0$1)>>2)];
      var $361=(($4+96)|0);
      var $st$5$0=(($361)|0);
      HEAP32[(($st$5$0)>>2)]=$360$0;
      var $st$5$1=(($361+4)|0);
      HEAP32[(($st$5$1)>>2)]=$360$1;
      STACKTOP = __stackBase__;
      return;
    case 74: // $362
      var $363=$2;
      var $364=$2;
      var $365=$3;
      var $366=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $364, tempValue);
      var $367=($366.f1 = $365, $366);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 75: // $368
      var $369=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN16debug_view_state11view_updateEv["X"]=1;

function __ZN23debug_view_state_sourceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN23debug_view_state_sourceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN23debug_view_state_sourceD0Ev["X"]=1;

function __ZN16debug_view_state10state_itemD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN16debug_view_state10state_itemD2Ev($2);
  ;
  return;
}


function __ZN16debug_view_state10state_itemD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  FUNCTION_TABLE[__ZN7astringD1Ev]($3);
  ;
  return;
}


function __ZN20resource_pool_objectI23debug_view_state_sourceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI23debug_view_state_sourceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI23debug_view_state_sourceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 88);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI23debug_view_state_sourceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI23debug_view_state_sourceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI23debug_view_state_sourceED2Ev($2);
  ;
  return;
}


function __ZNK8device_t4nextI22device_state_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceERP22device_state_interface($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectIN16debug_view_state10state_itemEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectIN16debug_view_state10state_itemEED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN16debug_view_state10state_itemEED0Ev["X"]=1;

function __ZN20resource_pool_objectIN16debug_view_state10state_itemEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      var $11=$10;
      HEAP32[(($11)>>2)]=((__ZTV20resource_pool_objectIN16debug_view_state10state_itemEE+8)|0);
      var $12=(($10+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $15
      (function() { try { __THREW__ = false; return __ZN16debug_view_state10state_itemD1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$13;
      var $18=$4;
      var $19=$5;
      var $20=$6;
      HEAP32[(($4)>>2)]=$17;
      var $21=HEAP32[(($4)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($24, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 6; break;
    case 5: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      HEAP32[(($5)>>2)]=$28;
      var $29=$27.f1;
      HEAP32[(($6)>>2)]=$29;
      var $30=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($30);
      throw "Reached an unreachable!"
    case 6: // $_ZdlPv_exit
      var $31=$4;
      var $32=$5;
      var $33=$6;
      __label__ = 7; break;
    case 7: // $34
      var $35=$10;
      __ZN18resource_pool_itemD2Ev($35);
      STACKTOP = __stackBase__;
      return;
    case 8: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $8=$38;
      var $39=$37.f1;
      $9=$39;
      var $40=$13;
      var $41=$1;
      var $42=$2;
      var $43=$3;
      HEAP32[(($1)>>2)]=$40;
      var $44=HEAP32[(($1)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $46
      var $47=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($47, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $48
      __label__ = 12; break;
    case 11: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      HEAP32[(($2)>>2)]=$51;
      var $52=$50.f1;
      HEAP32[(($3)>>2)]=$52;
      var $53=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($53);
      throw "Reached an unreachable!"
    case 12: // $_ZdlPv_exit1
      var $54=$1;
      var $55=$2;
      var $56=$3;
      var $57=$10;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      var $60=$8;
      var $61=$8;
      var $62=$9;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectIN16debug_view_state10state_itemEED2Ev["X"]=1;

function __ZN20resource_pool_objectI23debug_view_state_sourceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI23debug_view_state_sourceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI23debug_view_state_sourceED0Ev["X"]=1;

function __ZN20resource_pool_objectI23debug_view_state_sourceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI23debug_view_state_sourceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24debug_view_disasm_sourceC2EPKcR8device_t($this, $name, $device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$name;
      $3=$device;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      __ZN17debug_view_sourceC2EPKcP8device_t($7, $8, $9);
      var $10=$6;
      HEAP32[(($10)>>2)]=((__ZTV24debug_view_disasm_source+8)|0);
      var $11=(($6+76)|0);
      var $12=$3;
      HEAP32[(($11)>>2)]=$12;
      var $13=(($6+80)|0);
      var $14=$3;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $16
      var $17=$14;
      var $18=___dynamic_cast($17, __ZTI8device_t, __ZTI23device_disasm_interface, -1);
      var $19=$18;
      var $22 = $19;__label__ = 3; break;
    case 2: // $20
      var $22 = 0;__label__ = 3; break;
    case 3: // $21
      var $22;
      HEAP32[(($13)>>2)]=$22;
      var $23=(($6+84)|0);
      var $24=$3;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $26
      var $27=$24;
      var $28=___dynamic_cast($27, __ZTI8device_t, __ZTI23device_memory_interface, -1);
      var $29=$28;
      var $32 = $29;__label__ = 6; break;
    case 5: // $30
      var $32 = 0;__label__ = 6; break;
    case 6: // $31
      var $32;
      var $33=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($32, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $34
      HEAP32[(($23)>>2)]=$33;
      ;
      return;
    case 8: // $35
      var $36=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $37=$36.f0;
      $4=$37;
      var $38=$36.f1;
      $5=$38;
      var $39=$6;
      (function() { try { __THREW__ = false; return __ZN17debug_view_sourceD2Ev($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $40
      __label__ = 10; break;
    case 10: // $41
      var $42=$4;
      var $43=$4;
      var $44=$5;
      var $45=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $43, tempValue);
      var $46=($45.f1 = $44, $45);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24debug_view_disasm_sourceC2EPKcR8device_t["X"]=1;

function __ZN17debug_view_disasmC2ER15running_machinePFvR10debug_viewPvES4_($this, $machine, $osdupdate, $osdprivate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $total_comments;
      var $source;
      var $dasmsource;
      $1=$this;
      $2=$machine;
      $3=$osdupdate;
      $4=$osdprivate;
      var $7=$1;
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      __ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_($8, $9, 3, $10, $11);
      var $12=$7;
      HEAP32[(($12)>>2)]=((__ZTV17debug_view_disasm+8)|0);
      var $13=(($7+92)|0);
      HEAP32[(($13)>>2)]=1;
      var $14=(($7+96)|0);
      HEAP32[(($14)>>2)]=3;
      var $15=(($7+100)|0);
      HEAP32[(($15)>>2)]=50;
      var $16=(($7+104)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($7+108)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($7+112)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($7+116)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($7+120)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($7+124)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($7+128)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($7+132)|0);
      var $24=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionC1ER15running_machine]($23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $25
      var $26=(($7+836)|0);
      (function() { try { __THREW__ = false; return __ZN13debug_view_xyC1Eii($26, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $27
      var $28=(($7+844)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($7+848)|0);
      HEAP32[(($29)>>2)]=0;
      (function() { try { __THREW__ = false; return __ZN17debug_view_disasm17enumerate_sourcesEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $30
      var $31=$7;
      var $32=(($31+16)|0);
      var $33=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list5countEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $34
      var $35=(($33)|0)==0;
      if ($35) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $36
      var $37=___cxa_allocate_exception(4);
      var $38=$37;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($38);
      (function() { try { __THREW__ = false; return ___cxa_throw($37, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 7; break; }
    case 6: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $5=$41;
      var $42=$40.f1;
      $6=$42;
      __label__ = 21; break;
    case 7: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $5=$45;
      var $46=$44.f1;
      $6=$46;
      var $47=(($7+132)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionD1Ev]($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 8: // $48
      $total_comments=0;
      var $49=$7;
      var $50=(($49+16)|0);
      var $51=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list4headEv($50) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 7; break; };
    case 9: // $52
      $source=$51;
      __label__ = 10; break;
    case 10: // $53
      var $54=$source;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 11; break; } else { __label__ = 17; break; }
    case 11: // $56
      var $57=$source;
      var $58=(function() { try { __THREW__ = false; return __Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 7; break; };
    case 12: // $59
      $dasmsource=$58;
      var $60=$dasmsource;
      var $61=(($60+76)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(function() { try { __THREW__ = false; return __ZNK8device_t5debugEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 7; break; };
    case 13: // $64
      var $65=(function() { try { __THREW__ = false; return __ZNK12device_debug13comment_countEv($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 7; break; };
    case 14: // $66
      var $67=$total_comments;
      var $68=(($67+$65)|0);
      $total_comments=$68;
      __label__ = 15; break;
    case 15: // $69
      var $70=$source;
      var $71=(function() { try { __THREW__ = false; return __ZNK17debug_view_source4nextEv($70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 7; break; };
    case 16: // $72
      $source=$71;
      __label__ = 10; break;
    case 17: // $73
      var $74=$total_comments;
      var $75=(($74)|0) > 0;
      if ($75) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $76
      var $77=(($7+92)|0);
      HEAP32[(($77)>>2)]=3;
      __label__ = 19; break;
    case 19: // $78
      var $79=$7;
      var $80=(($79+48)|0);
      var $81=(($80+4)|0);
      HEAP32[(($81)>>2)]=1000;
      var $82=$7;
      var $83=(($82+72)|0);
      HEAP8[($83)]=1;
      ;
      return;
    case 20: // $84
      __label__ = 21; break;
    case 21: // $85
      var $86=$7;
      (function() { try { __THREW__ = false; return __ZN10debug_viewD2Ev($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $87
      __label__ = 23; break;
    case 23: // $88
      var $89=$5;
      var $90=$5;
      var $91=$6;
      var $92=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $90, tempValue);
      var $93=($92.f1 = $91, $92);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 24: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 25: // $96
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasmC2ER15running_machinePFvR10debug_viewPvES4_["X"]=1;

function __Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8downcastIPK24debug_view_disasm_sourceK17debug_view_sourceET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK24debug_view_disasm_source6deviceEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+76)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK11device_list5firstI23device_disasm_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=$4;
      var $6=__ZNK11tagged_listI8device_tE5firstEv($5);
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI23device_disasm_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=__ZNK8device_t4nextEv($17);
      $cur=$18;
      __label__ = 1; break;
    case 6: // $19
      $1=0;
      __label__ = 7; break;
    case 7: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16device_interface4nextI23device_disasm_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$intf;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNK8device_t4nextI23device_disasm_interfaceEEbRPT_($5, $6);
  ;
  return $7;
}


function __ZN17debug_view_disasm11view_notifyE23debug_view_notification($this, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$type;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)==2;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$3;
      __ZN10debug_view27adjust_visible_y_for_cursorEv($7);
      __label__ = 5; break;
    case 2: // $8
      var $9=$2;
      var $10=(($9)|0)==3;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=(($3+132)|0);
      var $13=$3;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=__Z8downcastIPK24debug_view_disasm_sourceK17debug_view_sourceET_PT0_($15);
      var $17=__ZNK24debug_view_disasm_source6deviceEv($16);
      var $18=__ZNK8device_t5debugEv($17);
      var $19=__ZN12device_debug8symtableEv($18);
      __ZN21debug_view_expression11set_contextEP12symbol_table($12, $19);
      __label__ = 4; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17debug_view_disasm17enumerate_sourcesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $dasm=__stackBase__+36;
      var $name=__stackBase__+40;
      var $gotone;
      var $10;
      var $11;
      $9=$this;
      var $12=$9;
      var $13=$12;
      var $14=(($13+16)|0);
      __ZN22debug_view_source_list5resetEv($14);
      HEAP32[(($dasm)>>2)]=0;
      __ZN7astringC1Ev($name);
      var $15=$12;
      var $16=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 29; break; };
    case 1: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 29; break; };
    case 2: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI23device_disasm_interfaceEEbRPT_($18, $dasm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 29; break; };
    case 3: // $21
      var $22=(($20)&1);
      $gotone=$22;
      __label__ = 4; break;
    case 4: // $23
      var $24=$gotone;
      var $25=(($24) & 1);
      if ($25) { __label__ = 5; break; } else { __label__ = 36; break; }
    case 5: // $26
      var $27=HEAP32[(($dasm)>>2)];
      var $28=$27;
      var $29=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 29; break; };
    case 6: // $30
      var $31=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 29; break; };
    case 7: // $32
      var $33=HEAP32[(($dasm)>>2)];
      var $34=$33;
      var $35=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 29; break; };
    case 8: // $36
      var $37=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 29; break; };
    case 9: // $38
      var $39=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($name, ((STRING_TABLE.__str5826)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 29; break; };
    case 10: // $40
      var $41=$12;
      var $42=(($41+16)|0);
      var $43=$12;
      var $44=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 29; break; };
    case 11: // $45
      var $46=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 29; break; };
    case 12: // $47
      var $48=$4;
      var $49=$5;
      var $50=$6;
      var $51=$result_i;
      var $52=$7;
      var $53=$8;
      HEAP32[(($4)>>2)]=88;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str15827)|0);
      HEAP32[(($6)>>2)]=140;
      var $54=HEAP32[(($4)>>2)];
      var $55=HEAP32[(($5)>>2)];
      var $56=HEAP32[(($6)>>2)];
      var $57=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($54, $55, $56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $58
      HEAP32[(($result_i)>>2)]=$57;
      var $59=HEAP32[(($result_i)>>2)];
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 14; break; } else { __label__ = 20; break; }
    case 14: // $61
      var $62=___cxa_allocate_exception(4);
      var $63=$62;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($63);
      (function() { try { __THREW__ = false; return ___cxa_throw($62, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 15; break; }
    case 15: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      HEAP32[(($7)>>2)]=$66;
      var $67=$65.f1;
      HEAP32[(($8)>>2)]=$67;
      var $68=HEAP32[(($8)>>2)];
      var $69=(($68)|0) < 0;
      if ($69) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $70
      var $71=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 29; break; }
    case 17: // $_noexc
      throw "Reached an unreachable!"
    case 18: // $72
      var $73=HEAP32[(($7)>>2)];
      var $74=HEAP32[(($7)>>2)];
      var $75=HEAP32[(($8)>>2)];
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      var $eh_lpad_body = $77;__label__ = 30; break;
    case 19: // $78
      throw "Reached an unreachable!"
    case 20: // $_ZnwjPKci_exit
      var $79=HEAPU32[(($result_i)>>2)];
      var $80=$4;
      var $81=$5;
      var $82=$6;
      var $83=$result_i;
      var $84=$7;
      var $85=$8;
      __label__ = 21; break;
    case 21: // $86
      var $87=$79;
      var $88=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 31; break; };
    case 22: // $89
      var $90=HEAP32[(($dasm)>>2)];
      var $91=$90;
      var $92=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($91) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 31; break; };
    case 23: // $93
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24debug_view_disasm_sourceC1EPKcR8device_t]($87, $88, $92) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 31; break; }
    case 24: // $94
      var $95=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI24debug_view_disasm_sourceEEPT_S3_($46, $87) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 29; break; };
    case 25: // $96
      var $97=$95;
      (function() { try { __THREW__ = false; return __ZN22debug_view_source_list6appendER17debug_view_source($42, $97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $98
      __label__ = 27; break;
    case 27: // $99
      var $100=HEAP32[(($dasm)>>2)];
      var $101=$100;
      var $102=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI23device_disasm_interfaceEEbRPT_($101, $dasm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 29; break; };
    case 28: // $103
      var $104=(($102)&1);
      $gotone=$104;
      __label__ = 4; break;
    case 29: // $105
      var $106=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $106;__label__ = 30; break;
    case 30: // $_body
      var $eh_lpad_body;
      var $107=$eh_lpad_body.f0;
      $10=$107;
      var $108=$eh_lpad_body.f1;
      $11=$108;
      __label__ = 39; break;
    case 31: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $10=$111;
      var $112=$110.f1;
      $11=$112;
      var $113=$1;
      var $114=$2;
      var $115=$3;
      HEAP32[(($1)>>2)]=$79;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15827)|0);
      HEAP32[(($3)>>2)]=140;
      var $116=HEAP32[(($1)>>2)];
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $118
      var $119=HEAP32[(($1)>>2)];
      var $120=HEAP32[(($2)>>2)];
      var $121=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($119, $120, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 42; break; }
    case 33: // $_noexc1
      __label__ = 34; break;
    case 34: // $_ZdlPvPKci_exit
      var $122=$1;
      var $123=$2;
      var $124=$3;
      __label__ = 35; break;
    case 35: // $125
      __label__ = 39; break;
    case 36: // $126
      var $127=$12;
      var $128=$12;
      var $129=(($128+16)|0);
      var $130=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list4headEv($129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 29; break; };
    case 37: // $131
      (function() { try { __THREW__ = false; return __ZN10debug_view10set_sourceERK17debug_view_source($127, $130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 29; break; }
    case 38: // $132
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      STACKTOP = __stackBase__;
      return;
    case 39: // $133
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $134
      __label__ = 41; break;
    case 41: // $135
      var $136=$10;
      var $137=$10;
      var $138=$11;
      var $139=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $137, tempValue);
      var $140=($139.f1 = $138, $139);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $141
      var $142=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasm17enumerate_sourcesEv["X"]=1;

function __ZN17debug_view_disasmD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN17debug_view_disasmD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasmD0Ev["X"]=1;

function __ZN17debug_view_disasmD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV17debug_view_disasm+8)|0);
      var $6=$4;
      var $7=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $8
      var $9=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; };
    case 2: // $10
      var $11=(($4+844)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12;
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($9, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $14
      var $15=$4;
      var $16=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $17
      var $18=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; };
    case 5: // $19
      var $20=(($4+848)|0);
      var $21=HEAP32[(($20)>>2)];
      (function() { try { __THREW__ = false; return __ZN13resource_pool6removeEPv($18, $21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $22
      var $23=(($4+132)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionD1Ev]($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $24
      var $25=$4;
      __ZN10debug_viewD2Ev($25);
      ;
      return;
    case 8: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $2=$28;
      var $29=$27.f1;
      $3=$29;
      var $30=(($4+132)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionD1Ev]($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 9: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      $2=$33;
      var $34=$32.f1;
      $3=$34;
      __label__ = 11; break;
    case 10: // $35
      __label__ = 11; break;
    case 11: // $36
      var $37=$4;
      (function() { try { __THREW__ = false; return __ZN10debug_viewD2Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $38
      __label__ = 13; break;
    case 13: // $39
      var $40=$2;
      var $41=$2;
      var $42=$3;
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasmD2Ev["X"]=1;

function __ZN13resource_pool10add_objectI24debug_view_disasm_sourceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24debug_view_disasm_sourceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI24debug_view_disasm_sourceEEPT_S3_["X"]=1;

function __ZN17debug_view_disasm9view_charEi($this, $chval) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $origcursor=__stackBase__;
      var $end_buffer;
      var $temp;
      var $source;
      var $pc;
      var $curline;
      $1=$this;
      $2=$chval;
      var $3=$1;
      var $4=$3;
      var $5=(($4+64)|0);
      var $6=$origcursor;
      var $7=$5;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];
      $end_buffer=3;
      var $8=$2;
      if ($8 == 1) {
        __label__ = 1; break;
      }
      else if ($8 == 2) {
        __label__ = 4; break;
      }
      else if ($8 == 5) {
        __label__ = 7; break;
      }
      else if ($8 == 6) {
        __label__ = 11; break;
      }
      else if ($8 == 7) {
        __label__ = 15; break;
      }
      else if ($8 == 8) {
        __label__ = 22; break;
      }
      else if ($8 == 10) {
        __label__ = 23; break;
      }
      else {
      __label__ = 24; break;
      }
      
    case 1: // $9
      var $10=$3;
      var $11=(($10+64)|0);
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0) > 0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$3;
      var $17=(($16+64)|0);
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-1)|0);
      HEAP32[(($18)>>2)]=$20;
      __label__ = 3; break;
    case 3: // $21
      __label__ = 24; break;
    case 4: // $22
      var $23=$3;
      var $24=(($23+64)|0);
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$3;
      var $28=(($27+48)|0);
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30-1)|0);
      var $32=(($26)|0) < (($31)|0);
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$3;
      var $35=(($34+64)|0);
      var $36=(($35+4)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+1)|0);
      HEAP32[(($36)>>2)]=$38;
      __label__ = 6; break;
    case 6: // $39
      __label__ = 24; break;
    case 7: // $40
      var $41=$3;
      var $42=(($41+64)|0);
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$3;
      var $46=(($45+40)|0);
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$end_buffer;
      var $50=(($49)&255);
      var $51=(($48-$50)|0);
      var $52=(($44-$51)|0);
      $temp=$52;
      var $53=$temp;
      var $54=(($53)|0) < 0;
      if ($54) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $55
      var $56=$3;
      var $57=(($56+64)|0);
      var $58=(($57+4)|0);
      HEAP32[(($58)>>2)]=0;
      __label__ = 10; break;
    case 9: // $59
      var $60=$temp;
      var $61=$3;
      var $62=(($61+64)|0);
      var $63=(($62+4)|0);
      HEAP32[(($63)>>2)]=$60;
      __label__ = 10; break;
    case 10: // $64
      __label__ = 24; break;
    case 11: // $65
      var $66=$3;
      var $67=(($66+64)|0);
      var $68=(($67+4)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$3;
      var $71=(($70+40)|0);
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$end_buffer;
      var $75=(($74)&255);
      var $76=(($73-$75)|0);
      var $77=(($69+$76)|0);
      $temp=$77;
      var $78=$temp;
      var $79=$3;
      var $80=(($79+48)|0);
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82-1)|0);
      var $84=(($78)|0) > (($83)|0);
      if ($84) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $85
      var $86=$3;
      var $87=(($86+48)|0);
      var $88=(($87+4)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89-1)|0);
      var $91=$3;
      var $92=(($91+64)|0);
      var $93=(($92+4)|0);
      HEAP32[(($93)>>2)]=$90;
      __label__ = 14; break;
    case 13: // $94
      var $95=$temp;
      var $96=$3;
      var $97=(($96+64)|0);
      var $98=(($97+4)|0);
      HEAP32[(($98)>>2)]=$95;
      __label__ = 14; break;
    case 14: // $99
      __label__ = 24; break;
    case 15: // $100
      var $101=$3;
      var $102=(($101+12)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($103);
      $source=$104;
      var $105=$source;
      var $106=(($105+84)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$source;
      var $109=(($108+76)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=__Z12device_stateP8device_t($110);
      var $112=__ZN22device_state_interface5stateEi($111, -1);
      var $112$0=$112[0];
      var $112$1=$112[1];
      var $113$0=$112$0;
      var $113=$113$0;
      var $114=__ZNK13address_space15address_to_byteEj($107, $113);
      var $115=$source;
      var $116=(($115+84)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=__ZNK13address_space11logbytemaskEv($117);
      var $119=$114 & $118;
      $pc=$119;
      $curline=0;
      __label__ = 16; break;
    case 16: // $120
      var $121=$curline;
      var $122=(($3+836)|0);
      var $123=(($122+4)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($121)|0) < (($124)|0);
      if ($125) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $126
      var $127=$curline;
      var $128=(($3+844)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+($127<<2))|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$pc;
      var $133=(($131)|0)==(($132)|0);
      if ($133) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $134
      var $135=$curline;
      var $136=$3;
      var $137=(($136+64)|0);
      var $138=(($137+4)|0);
      HEAP32[(($138)>>2)]=$135;
      __label__ = 19; break;
    case 19: // $139
      __label__ = 20; break;
    case 20: // $140
      var $141=$curline;
      var $142=(($141+1)|0);
      $curline=$142;
      __label__ = 16; break;
    case 21: // $143
      __label__ = 24; break;
    case 22: // $144
      var $145=$3;
      var $146=(($145+64)|0);
      var $147=(($146+4)|0);
      HEAP32[(($147)>>2)]=0;
      __label__ = 24; break;
    case 23: // $148
      var $149=$3;
      var $150=(($149+48)|0);
      var $151=(($150+4)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152-1)|0);
      var $154=$3;
      var $155=(($154+64)|0);
      var $156=(($155+4)|0);
      HEAP32[(($156)>>2)]=$153;
      __label__ = 24; break;
    case 24: // $157
      var $158=$3;
      var $159=(($158+64)|0);
      var $160=(($159+4)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(($origcursor+4)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($161)|0)!=(($163)|0);
      if ($164) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $165
      var $166=$3;
      __ZN10debug_view12begin_updateEv($166);
      var $167=$3;
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+12)|0);
      var $170=HEAP32[(($169)>>2)];
      FUNCTION_TABLE[$170]($3, 2);
      var $171=$3;
      var $172=(($171+76)|0);
      HEAP8[($172)]=1;
      var $173=$3;
      __ZN10debug_view10end_updateEv($173);
      __label__ = 26; break;
    case 26: // $174
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasm9view_charEi["X"]=1;

function __ZN17debug_view_disasm17find_pc_backwardsEji($this, $targetpc, $numinstrs) {
  var __stackBase__  = STACKTOP; STACKTOP += 2152; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $source;
      var $minlen;
      var $maxlen;
      var $curpc;
      var $targetpcbyte;
      var $fillpcbyte;
      var $lastgoodpc;
      var $curpcbyte;
      var $opbuf=__stackBase__;
      var $argbuf=__stackBase__+1024;
      var $instcount;
      var $instlen;
      var $scanpc;
      var $scanpcbyte;
      var $physpcbyte=__stackBase__+2048;
      var $dasmbuffer=__stackBase__+2052;
      $1=$this;
      $2=$targetpc;
      $3=$numinstrs;
      var $4=$1;
      var $5=$4;
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($7);
      $source=$8;
      var $9=$source;
      var $10=(($9+84)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$source;
      var $13=(($12+80)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZNK23device_disasm_interface16min_opcode_bytesEv($14);
      var $16=__ZNK13address_space15byte_to_addressEj($11, $15);
      $minlen=$16;
      var $17=$minlen;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      $minlen=1;
      __label__ = 2; break;
    case 2: // $20
      var $21=$source;
      var $22=(($21+84)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$source;
      var $25=(($24+80)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK23device_disasm_interface16max_opcode_bytesEv($26);
      var $28=__ZNK13address_space15byte_to_addressEj($23, $27);
      $maxlen=$28;
      var $29=$maxlen;
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $31
      $maxlen=1;
      __label__ = 4; break;
    case 4: // $32
      var $33=$2;
      var $34=$minlen;
      var $35=$3;
      var $36=(($34*$35)|0);
      var $37=(($33-$36)|0);
      $curpc=$37;
      var $38=$curpc;
      var $39=$2;
      var $40=(($38)>>>0) > (($39)>>>0);
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      $curpc=0;
      __label__ = 6; break;
    case 6: // $42
      var $43=$source;
      var $44=(($43+84)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$2;
      var $47=__ZNK13address_space15address_to_byteEj($45, $46);
      var $48=$source;
      var $49=(($48+84)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=__ZNK13address_space11logbytemaskEv($50);
      var $52=$47 & $51;
      $targetpcbyte=$52;
      var $53=$targetpcbyte;
      $fillpcbyte=$53;
      var $54=$2;
      $lastgoodpc=$54;
      __label__ = 7; break;
    case 7: // $55
      var $56=$source;
      var $57=(($56+84)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$curpc;
      var $60=__ZNK13address_space15address_to_byteEj($58, $59);
      var $61=$source;
      var $62=(($61+84)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=__ZNK13address_space11logbytemaskEv($63);
      var $65=$60 & $64;
      $curpcbyte=$65;
      __label__ = 8; break;
    case 8: // $66
      var $67=$curpcbyte;
      var $68=$fillpcbyte;
      var $69=(($67)>>>0) < (($68)>>>0);
      if ($69) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $70
      var $71=$fillpcbyte;
      var $72=(($71-1)|0);
      $fillpcbyte=$72;
      var $73=$source;
      var $74=(($73+84)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$fillpcbyte;
      var $77=__Z17debug_read_opcodeP13address_spacejii($75, $76, 1, 0);
      var $77$0=$77[0];
      var $77$1=$77[1];
      var $78$0=$77$0;
      var $78=$78$0&255;
      var $79=$fillpcbyte;
      var $80=(($79+1000)|0);
      var $81=$targetpcbyte;
      var $82=(($80-$81)|0);
      var $83=(($opbuf+$82)|0);
      HEAP8[($83)]=$78;
      var $84=$source;
      var $85=(($84+84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$fillpcbyte;
      var $88=__Z17debug_read_opcodeP13address_spacejii($86, $87, 1, 1);
      var $88$0=$88[0];
      var $88$1=$88[1];
      var $89$0=$88$0;
      var $89=$89$0&255;
      var $90=$fillpcbyte;
      var $91=(($90+1000)|0);
      var $92=$targetpcbyte;
      var $93=(($91-$92)|0);
      var $94=(($argbuf+$93)|0);
      HEAP8[($94)]=$89;
      __label__ = 8; break;
    case 10: // $95
      $instcount=0;
      var $96=$curpc;
      $scanpc=$96;
      __label__ = 11; break;
    case 11: // $97
      var $98=$scanpc;
      var $99=$2;
      var $100=(($98)>>>0) < (($99)>>>0);
      if ($100) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $101
      var $102=$source;
      var $103=(($102+84)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$scanpc;
      var $106=__ZNK13address_space15address_to_byteEj($104, $105);
      var $107=$source;
      var $108=(($107+84)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=__ZNK13address_space11logbytemaskEv($109);
      var $111=$106 & $110;
      $scanpcbyte=$111;
      var $112=$scanpcbyte;
      HEAP32[(($physpcbyte)>>2)]=$112;
      $instlen=1;
      var $113=$source;
      var $114=(($113+84)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=__Z19debug_cpu_translateP13address_spaceiPj($115, 2, $physpcbyte);
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $118
      var $119=$source;
      var $120=(($119+76)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=__ZNK8device_t5debugEv($121);
      var $123=(($dasmbuffer)|0);
      var $124=$scanpc;
      var $125=$scanpcbyte;
      var $126=(($125+1000)|0);
      var $127=$targetpcbyte;
      var $128=(($126-$127)|0);
      var $129=(($opbuf+$128)|0);
      var $130=$scanpcbyte;
      var $131=(($130+1000)|0);
      var $132=$targetpcbyte;
      var $133=(($131-$132)|0);
      var $134=(($argbuf+$133)|0);
      var $135=__ZNK12device_debug11disassembleEPcjPKhS2_($122, $123, $124, $129, $134);
      var $136=$135 & 65535;
      $instlen=$136;
      __label__ = 14; break;
    case 14: // $137
      var $138=$instcount;
      var $139=(($138+1)|0);
      $instcount=$139;
      __label__ = 15; break;
    case 15: // $140
      var $141=$instlen;
      var $142=$scanpc;
      var $143=(($142+$141)|0);
      $scanpc=$143;
      __label__ = 11; break;
    case 16: // $144
      var $145=$scanpc;
      var $146=$2;
      var $147=(($145)|0)==(($146)|0);
      if ($147) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $148
      var $149=$instcount;
      var $150=$3;
      var $151=(($149)|0) <= (($150)|0);
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      var $153=$curpc;
      $lastgoodpc=$153;
      __label__ = 19; break;
    case 19: // $154
      var $155=$2;
      var $156=$curpc;
      var $157=(($155-$156)|0);
      var $158=$3;
      var $159=$maxlen;
      var $160=(($158*$159)|0);
      var $161=(($157)>>>0) >= (($160)>>>0);
      if ($161) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $162
      __label__ = 26; break;
    case 21: // $163
      var $164=$curpc;
      var $165=(($164)|0)==0;
      if ($165) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $166
      __label__ = 26; break;
    case 23: // $167
      var $168=$minlen;
      var $169=$curpc;
      var $170=(($169-$168)|0);
      $curpc=$170;
      var $171=$curpc;
      var $172=$2;
      var $173=(($171)>>>0) > (($172)>>>0);
      if ($173) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $174
      $curpc=0;
      __label__ = 25; break;
    case 25: // $175
      __label__ = 7; break;
    case 26: // $176
      var $177=$lastgoodpc;
      STACKTOP = __stackBase__;
      return $177;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasm17find_pc_backwardsEji["X"]=1;

function __ZN17debug_view_disasm14generate_bytesEjiiPcib($this, $pcbyte, $numbytes, $minbytes, $string, $maxchars, $encrypted) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $source;
      var $offset;
      var $byte;
      $1=$this;
      $2=$pcbyte;
      $3=$numbytes;
      $4=$minbytes;
      $5=$string;
      $6=$maxchars;
      var $8=(($encrypted)&1);
      $7=$8;
      var $9=$1;
      var $10=$9;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($12);
      $source=$13;
      $offset=0;
      var $14=$6;
      var $15=$4;
      var $16=((($15<<1))|0);
      var $17=(($14)|0) >= (($16)|0);
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$5;
      var $20=$source;
      var $21=(($20+84)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$2;
      var $24=$4;
      var $25=__Z17debug_read_opcodeP13address_spacejii($22, $23, $24, 0);
      var $25$0=$25[0];
      var $25$1=$25[1];
      var $26=$4;
      var $27=((($26<<1))|0);
      var $28=(($27) & 255);
      var $29=__Z19core_i64_hex_formatyh($25$0, $25$1, $28);
      var $30=_sprintf($19, ((STRING_TABLE.__str25828)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$29,tempInt));
      $offset=$30;
      __label__ = 2; break;
    case 2: // $31
      var $32=$4;
      $byte=$32;
      __label__ = 3; break;
    case 3: // $33
      var $34=$byte;
      var $35=$3;
      var $36=(($34)|0) < (($35)|0);
      if ($36) { __label__ = 4; break; } else { var $46 = 0;__label__ = 5; break; }
    case 4: // $37
      var $38=$offset;
      var $39=(($38+1)|0);
      var $40=$4;
      var $41=((($40<<1))|0);
      var $42=(($39+$41)|0);
      var $43=$6;
      var $44=(($42)|0) < (($43)|0);
      var $46 = $44;__label__ = 5; break;
    case 5: // $45
      var $46;
      if ($46) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $47
      var $48=$offset;
      var $49=$5;
      var $50=(($49+$48)|0);
      var $51=$source;
      var $52=(($51+84)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$2;
      var $55=$byte;
      var $56=(($54+$55)|0);
      var $57=$4;
      var $58=$7;
      var $59=(($58) & 1);
      var $60=(($59)&1);
      var $61=__Z17debug_read_opcodeP13address_spacejii($53, $56, $57, $60);
      var $61$0=$61[0];
      var $61$1=$61[1];
      var $62=$4;
      var $63=((($62<<1))|0);
      var $64=(($63) & 255);
      var $65=__Z19core_i64_hex_formatyh($61$0, $61$1, $64);
      var $66=_sprintf($50, ((STRING_TABLE.__str35829)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$65,tempInt));
      var $67=$offset;
      var $68=(($67+$66)|0);
      $offset=$68;
      __label__ = 7; break;
    case 7: // $69
      var $70=$4;
      var $71=$byte;
      var $72=(($71+$70)|0);
      $byte=$72;
      __label__ = 3; break;
    case 8: // $73
      var $74=$6;
      var $75=(($74-1)|0);
      var $76=$5;
      var $77=(($76+$75)|0);
      HEAP8[($77)]=0;
      var $78=$byte;
      var $79=$3;
      var $80=(($78)|0) < (($79)|0);
      if ($80) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $81
      var $82=$6;
      var $83=(($82)|0) > 3;
      if ($83) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $84
      var $85=$6;
      var $86=(($85-4)|0);
      var $87=$5;
      var $88=(($87+$86)|0);
      HEAP8[($88)]=46;
      var $89=$6;
      var $90=(($89-3)|0);
      var $91=$5;
      var $92=(($91+$90)|0);
      HEAP8[($92)]=46;
      var $93=$6;
      var $94=(($93-2)|0);
      var $95=$5;
      var $96=(($95+$94)|0);
      HEAP8[($96)]=46;
      __label__ = 11; break;
    case 11: // $97
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasm14generate_bytesEjiiPcib["X"]=1;

function __Z12device_stateP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf=__stackBase__;
      var $2;
      var $3;
      $1=$device;
      var $4=$1;
      var $5=__ZN8device_t9interfaceERP22device_state_interface($4, $intf);
      if ($5) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=___cxa_allocate_exception(1032);
      var $8=$7;
      var $9=$1;
      var $10=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $11
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($8, ((STRING_TABLE.__str85834)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$10,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      ___cxa_throw($7, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 4: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      ___cxa_free_exception($7);
      __label__ = 6; break;
    case 5: // $17
      var $18=HEAP32[(($intf)>>2)];
      STACKTOP = __stackBase__;
      return $18;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK16direct_read_data9decryptedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK16direct_read_data3rawEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12device_debug20comment_change_countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1596)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN17debug_view_disasm9recomputeEjii($this, $pc, $startline, $lines) {
  var __stackBase__  = STACKTOP; STACKTOP += 380; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i1=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $12;
      var $13;
      var $14;
      var $changed;
      var $source;
      var $minbytes;
      var $maxbytes;
      var $maxbytes_clamped;
      var $line;
      var $pcbyte;
      var $instr;
      var $destbuf;
      var $oldbuf=__stackBase__+48;
      var $buffer=__stackBase__+148;
      var $numbytes;
      var $physpcbyte=__stackBase__+248;
      var $opbuf=__stackBase__+252;
      var $argbuf=__stackBase__+316;
      var $comment_address;
      var $text;
      $11=$this;
      $12=$pc;
      $13=$startline;
      $14=$lines;
      var $15=$11;
      $changed=0;
      var $16=$15;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($18);
      $source=$19;
      var $20=$source;
      var $21=(($20+84)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=__ZNK13address_space12logaddrcharsEv($22);
      var $24=(($23)&255);
      var $25=(($24+1)|0);
      var $26=(($25+1)|0);
      var $27=(($15+120)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=(($15+120)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+1)|0);
      var $31=(($15+100)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($30+$32)|0);
      var $34=(($33+1)|0);
      var $35=(($15+124)|0);
      HEAP32[(($35)>>2)]=$34;
      var $36=$source;
      var $37=(($36+80)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=__ZNK23device_disasm_interface16min_opcode_bytesEv($38);
      $minbytes=$39;
      var $40=$source;
      var $41=(($40+80)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=__ZNK23device_disasm_interface16max_opcode_bytesEv($42);
      $maxbytes=$43;
      var $44=$source;
      var $45=(($44+84)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$minbytes;
      var $48=(($47-1)|0);
      var $49=__ZNK13address_space19byte_to_address_endEj($46, $48);
      var $50=$49 ^ -1;
      var $51=$12;
      var $52=$51 & $50;
      $12=$52;
      var $53=(($15+92)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)==1;
      if ($55) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $56
      var $57=(($15+92)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==2;
      if ($59) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $60
      var $61=$maxbytes;
      var $62=(($61)|0) < 16;
      if ($62) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $63
      var $64=$maxbytes;
      var $67 = $64;__label__ = 5; break;
    case 4: // $65
      var $67 = 16;__label__ = 5; break;
    case 5: // $66
      var $67;
      $maxbytes_clamped=$67;
      var $68=(($15+124)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+1)|0);
      var $71=$maxbytes_clamped;
      var $72=((($71<<1))|0);
      var $73=(($70+$72)|0);
      var $74=$maxbytes_clamped;
      var $75=$minbytes;
      var $76=(((($74)|0)/(($75)|0))|0);
      var $77=(($76-1)|0);
      var $78=(($73+$77)|0);
      var $79=(($78+1)|0);
      var $80=$15;
      var $81=(($80+48)|0);
      var $82=(($81)|0);
      HEAP32[(($82)>>2)]=$79;
      __label__ = 10; break;
    case 6: // $83
      var $84=(($15+92)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)==3;
      if ($86) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $87
      var $88=(($15+124)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+1)|0);
      var $91=(($90+50)|0);
      var $92=$15;
      var $93=(($92+48)|0);
      var $94=(($93)|0);
      HEAP32[(($94)>>2)]=$91;
      __label__ = 9; break;
    case 8: // $95
      var $96=(($15+124)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+1)|0);
      var $99=$15;
      var $100=(($99+48)|0);
      var $101=(($100)|0);
      HEAP32[(($101)>>2)]=$98;
      __label__ = 9; break;
    case 9: // $102
      __label__ = 10; break;
    case 10: // $103
      var $104=(($15+836)|0);
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$15;
      var $108=(($107+48)|0);
      var $109=(($108)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($106)|0) < (($110)|0);
      if ($111) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $112
      var $113=(($15+836)|0);
      var $114=(($113+4)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=$15;
      var $117=(($116+48)|0);
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($115)|0) < (($119)|0);
      if ($120) { __label__ = 12; break; } else { __label__ = 27; break; }
    case 12: // $121
      var $122=(($15+836)|0);
      var $123=$15;
      var $124=(($123+48)|0);
      var $125=$122;
      var $126=$124;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($125)>>2)]=HEAP32[(($126)>>2)];HEAP32[(($125+4)>>2)]=HEAP32[(($126+4)>>2)];
      var $127=$15;
      var $128=__ZNK10debug_view7machineEv($127);
      var $129=__ZN15running_machine7respoolEv($128);
      var $130=(($15+844)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$131;
      __ZN13resource_pool6removeEPv($129, $132);
      var $133=$15;
      var $134=__ZNK10debug_view7machineEv($133);
      var $135=__ZN15running_machine7respoolEv($134);
      var $136=(($15+836)|0);
      var $137=(($136+4)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=_llvm_umul_with_overflow_i32($138, 4);
      var $140=$139.f1;
      var $141=$139.f0;
      var $142=$140 ? -1 : $141;
      var $143=$6;
      var $144=$7;
      var $145=$8;
      var $146=$result_i;
      var $147=$9;
      var $148=$10;
      HEAP32[(($6)>>2)]=$142;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str15827)|0);
      HEAP32[(($8)>>2)]=381;
      var $149=HEAP32[(($6)>>2)];
      var $150=HEAP32[(($7)>>2)];
      var $151=HEAP32[(($8)>>2)];
      var $152=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($149, $150, $151) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $153
      HEAP32[(($result_i)>>2)]=$152;
      var $154=HEAP32[(($result_i)>>2)];
      var $155=(($154)|0)==0;
      if ($155) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $156
      var $157=___cxa_allocate_exception(4);
      var $158=$157;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($158);
      (function() { try { __THREW__ = false; return ___cxa_throw($157, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 15; break; }
    case 15: // $159
      var $160=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $161=$160.f0;
      HEAP32[(($9)>>2)]=$161;
      var $162=$160.f1;
      HEAP32[(($10)>>2)]=$162;
      var $163=HEAP32[(($10)>>2)];
      var $164=(($163)|0) < 0;
      if ($164) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $165
      var $166=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($166);
      throw "Reached an unreachable!"
    case 17: // $167
      var $168=HEAP32[(($9)>>2)];
      var $169=HEAP32[(($9)>>2)];
      var $170=HEAP32[(($10)>>2)];
      var $171=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $169, tempValue);
      var $172=($171.f1 = $170, $171);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 18: // $173
      throw "Reached an unreachable!"
    case 19: // $_ZnajPKci_exit
      var $174=HEAP32[(($result_i)>>2)];
      var $175=$6;
      var $176=$7;
      var $177=$8;
      var $178=$result_i;
      var $179=$9;
      var $180=$10;
      var $181=$174;
      var $182=(($15+836)|0);
      var $183=(($182+4)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=__ZN13resource_pool9add_arrayIjEEPT_S2_i($135, $181, $184);
      var $186=(($15+844)|0);
      HEAP32[(($186)>>2)]=$185;
      var $187=$15;
      var $188=__ZNK10debug_view7machineEv($187);
      var $189=__ZN15running_machine7respoolEv($188);
      var $190=(($15+848)|0);
      var $191=HEAP32[(($190)>>2)];
      __ZN13resource_pool6removeEPv($189, $191);
      var $192=$15;
      var $193=__ZNK10debug_view7machineEv($192);
      var $194=__ZN15running_machine7respoolEv($193);
      var $195=(($15+836)|0);
      var $196=(($195)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($15+836)|0);
      var $199=(($198+4)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($197*$200)|0);
      var $202=(($201)|0) < 0;
      var $203=$202 ? -1 : $201;
      var $204=$1;
      var $205=$2;
      var $206=$3;
      var $207=$result_i1;
      var $208=$4;
      var $209=$5;
      HEAP32[(($1)>>2)]=$203;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15827)|0);
      HEAP32[(($3)>>2)]=385;
      var $210=HEAP32[(($1)>>2)];
      var $211=HEAP32[(($2)>>2)];
      var $212=HEAP32[(($3)>>2)];
      var $213=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($210, $211, $212) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 22; break; };
    case 20: // $214
      HEAP32[(($result_i1)>>2)]=$213;
      var $215=HEAP32[(($result_i1)>>2)];
      var $216=(($215)|0)==0;
      if ($216) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $217
      var $218=___cxa_allocate_exception(4);
      var $219=$218;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($219);
      (function() { try { __THREW__ = false; return ___cxa_throw($218, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 22; break; }
    case 22: // $220
      var $221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $222=$221.f0;
      HEAP32[(($4)>>2)]=$222;
      var $223=$221.f1;
      HEAP32[(($5)>>2)]=$223;
      var $224=HEAP32[(($5)>>2)];
      var $225=(($224)|0) < 0;
      if ($225) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $226
      var $227=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($227);
      throw "Reached an unreachable!"
    case 24: // $228
      var $229=HEAP32[(($4)>>2)];
      var $230=HEAP32[(($4)>>2)];
      var $231=HEAP32[(($5)>>2)];
      var $232=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $230, tempValue);
      var $233=($232.f1 = $231, $232);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $234
      throw "Reached an unreachable!"
    case 26: // $_ZnajPKci_exit2
      var $235=HEAP32[(($result_i1)>>2)];
      var $236=$1;
      var $237=$2;
      var $238=$3;
      var $239=$result_i1;
      var $240=$4;
      var $241=$5;
      var $242=(($15+836)|0);
      var $243=(($242)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=(($15+836)|0);
      var $246=(($245+4)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=(($244*$247)|0);
      var $249=__ZN13resource_pool9add_arrayIcEEPT_S2_i($194, $235, $248);
      var $250=(($15+848)|0);
      HEAP32[(($250)>>2)]=$249;
      __label__ = 27; break;
    case 27: // $251
      $line=0;
      __label__ = 28; break;
    case 28: // $252
      var $253=$line;
      var $254=$14;
      var $255=(($253)|0) < (($254)|0);
      if ($255) { __label__ = 29; break; } else { __label__ = 57; break; }
    case 29: // $256
      var $257=$source;
      var $258=(($257+84)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=$12;
      var $261=__ZNK13address_space15address_to_byteEj($259, $260);
      var $262=$source;
      var $263=(($262+84)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=__ZNK13address_space11logbytemaskEv($264);
      var $266=$261 & $265;
      $pcbyte=$266;
      var $267=$13;
      var $268=$line;
      var $269=(($267+$268)|0);
      $instr=$269;
      var $270=$instr;
      var $271=(($15+836)|0);
      var $272=(($271)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=(($270*$273)|0);
      var $275=(($15+848)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=(($276+$274)|0);
      $destbuf=$277;
      var $278=$14;
      var $279=(($278)|0)==1;
      if ($279) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $280
      var $281=(($oldbuf)|0);
      var $282=$destbuf;
      var $283=(($15+836)|0);
      var $284=(($283)|0);
      var $285=HEAPU32[(($284)>>2)];
      var $286=100 < (($285)>>>0);
      if ($286) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $287
      var $293 = 100;__label__ = 33; break;
    case 32: // $288
      var $289=(($15+836)|0);
      var $290=(($289)|0);
      var $291=HEAP32[(($290)>>2)];
      var $293 = $291;__label__ = 33; break;
    case 33: // $292
      var $293;
      var $294=_strncpy($281, $282, $293);
      __label__ = 34; break;
    case 34: // $295
      var $296=$pcbyte;
      var $297=$instr;
      var $298=(($15+844)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=(($299+($297<<2))|0);
      HEAP32[(($300)>>2)]=$296;
      var $301=$destbuf;
      var $302=(($301)|0);
      var $303=$source;
      var $304=(($303+84)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=$pcbyte;
      var $307=__ZNK13address_space15byte_to_addressEj($305, $306);
      var $308$0=$307;
      var $308$1=0;
      var $309=$source;
      var $310=(($309+84)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=__ZNK13address_space12logaddrcharsEv($311);
      var $313=__Z19core_i64_hex_formatyh($308$0, $308$1, $312);
      var $314=_sprintf($302, ((STRING_TABLE.__str45830)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$313,tempInt));
      $numbytes=0;
      var $315=$pcbyte;
      HEAP32[(($physpcbyte)>>2)]=$315;
      var $316=$source;
      var $317=(($316+84)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=__Z19debug_cpu_translateP13address_spaceiPj($318, 10, $physpcbyte);
      var $320=(($319)|0)!=0;
      if ($320) { __label__ = 35; break; } else { __label__ = 40; break; }
    case 35: // $321
      $numbytes=0;
      __label__ = 36; break;
    case 36: // $322
      var $323=$numbytes;
      var $324=$maxbytes;
      var $325=(($323)|0) < (($324)|0);
      if ($325) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $326
      var $327=$source;
      var $328=(($327+84)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=$pcbyte;
      var $331=$numbytes;
      var $332=(($330+$331)|0);
      var $333=__Z17debug_read_opcodeP13address_spacejii($329, $332, 1, 0);
      var $333$0=$333[0];
      var $333$1=$333[1];
      var $334$0=$333$0;
      var $334=$334$0&255;
      var $335=$numbytes;
      var $336=(($opbuf+$335)|0);
      HEAP8[($336)]=$334;
      var $337=$source;
      var $338=(($337+84)|0);
      var $339=HEAP32[(($338)>>2)];
      var $340=$pcbyte;
      var $341=$numbytes;
      var $342=(($340+$341)|0);
      var $343=__Z17debug_read_opcodeP13address_spacejii($339, $342, 1, 1);
      var $343$0=$343[0];
      var $343$1=$343[1];
      var $344$0=$343$0;
      var $344=$344$0&255;
      var $345=$numbytes;
      var $346=(($argbuf+$345)|0);
      HEAP8[($346)]=$344;
      __label__ = 38; break;
    case 38: // $347
      var $348=$numbytes;
      var $349=(($348+1)|0);
      $numbytes=$349;
      __label__ = 36; break;
    case 39: // $350
      var $351=$source;
      var $352=(($351+76)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=__ZNK8device_t5debugEv($353);
      var $355=(($buffer)|0);
      var $356=$12;
      var $357=$source;
      var $358=(($357+84)|0);
      var $359=HEAP32[(($358)>>2)];
      var $360=__ZNK13address_space11logaddrmaskEv($359);
      var $361=$356 & $360;
      var $362=(($opbuf)|0);
      var $363=(($argbuf)|0);
      var $364=__ZNK12device_debug11disassembleEPcjPKhS2_($354, $355, $361, $362, $363);
      var $365=$364 & 65535;
      $numbytes=$365;
      var $366=$12;
      var $367=(($366+$365)|0);
      $12=$367;
      __label__ = 41; break;
    case 40: // $368
      var $369=(($buffer)|0);
      var $370=_strcpy($369, ((STRING_TABLE.__str55831)|0));
      __label__ = 41; break;
    case 41: // $371
      var $372=(($15+120)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=(($373+1)|0);
      var $375=$destbuf;
      var $376=(($375+$374)|0);
      var $377=(($15+100)|0);
      var $378=HEAP32[(($377)>>2)];
      var $379=(($buffer)|0);
      var $380=_sprintf($376, ((STRING_TABLE.__str65832)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$378,HEAP32[((tempInt+4)>>2)]=$379,tempInt));
      var $381=(($15+92)|0);
      var $382=HEAP32[(($381)>>2)];
      var $383=(($382)|0)==1;
      if ($383) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $384
      var $385=(($15+92)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=(($386)|0)==2;
      if ($387) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $388
      var $389=$source;
      var $390=(($389+84)|0);
      var $391=HEAP32[(($390)>>2)];
      var $392=$numbytes;
      var $393=__ZNK13address_space15address_to_byteEj($391, $392);
      var $394=$source;
      var $395=(($394+84)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=__ZNK13address_space11logbytemaskEv($396);
      var $398=$393 & $397;
      $numbytes=$398;
      var $399=$pcbyte;
      var $400=$numbytes;
      var $401=$minbytes;
      var $402=(($15+124)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=$destbuf;
      var $405=(($404+$403)|0);
      var $406=(($15+836)|0);
      var $407=(($406)|0);
      var $408=HEAP32[(($407)>>2)];
      var $409=(($15+124)|0);
      var $410=HEAP32[(($409)>>2)];
      var $411=(($408-$410)|0);
      var $412=(($15+92)|0);
      var $413=HEAP32[(($412)>>2)];
      var $414=(($413)|0)==2;
      __ZN17debug_view_disasm14generate_bytesEjiiPcib($15, $399, $400, $401, $405, $411, $414);
      __label__ = 49; break;
    case 44: // $415
      var $416=(($15+92)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=(($417)|0)==3;
      if ($418) { __label__ = 45; break; } else { __label__ = 48; break; }
    case 45: // $419
      var $420=$source;
      var $421=(($420+84)|0);
      var $422=HEAP32[(($421)>>2)];
      var $423=$instr;
      var $424=(($15+844)|0);
      var $425=HEAP32[(($424)>>2)];
      var $426=(($425+($423<<2))|0);
      var $427=HEAP32[(($426)>>2)];
      var $428=__ZNK13address_space15byte_to_addressEj($422, $427);
      $comment_address=$428;
      var $429=$source;
      var $430=(($429+76)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=__ZNK8device_t5debugEv($431);
      var $433=$comment_address;
      var $434=__ZNK12device_debug12comment_textEj($432, $433);
      $text=$434;
      var $435=$text;
      var $436=(($435)|0)!=0;
      if ($436) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $437
      var $438=(($15+124)|0);
      var $439=HEAP32[(($438)>>2)];
      var $440=$destbuf;
      var $441=(($440+$439)|0);
      var $442=(($15+836)|0);
      var $443=(($442)|0);
      var $444=HEAP32[(($443)>>2)];
      var $445=(($15+124)|0);
      var $446=HEAP32[(($445)>>2)];
      var $447=(($444-$446)|0);
      var $448=(($447-1)|0);
      var $449=$text;
      var $450=_sprintf($441, ((STRING_TABLE.__str75833)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$448,HEAP32[((tempInt+4)>>2)]=$449,tempInt));
      __label__ = 47; break;
    case 47: // $451
      __label__ = 48; break;
    case 48: // $452
      __label__ = 49; break;
    case 49: // $453
      var $454=$14;
      var $455=(($454)|0)==1;
      if ($455) { __label__ = 50; break; } else { __label__ = 55; break; }
    case 50: // $456
      var $457=(($oldbuf)|0);
      var $458=$destbuf;
      var $459=(($15+836)|0);
      var $460=(($459)|0);
      var $461=HEAPU32[(($460)>>2)];
      var $462=100 < (($461)>>>0);
      if ($462) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $463
      var $469 = 100;__label__ = 53; break;
    case 52: // $464
      var $465=(($15+836)|0);
      var $466=(($465)|0);
      var $467=HEAP32[(($466)>>2)];
      var $469 = $467;__label__ = 53; break;
    case 53: // $468
      var $469;
      var $470=_strncmp($457, $458, $469);
      var $471=(($470)|0)!=0;
      if ($471) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $472
      $changed=1;
      __label__ = 55; break;
    case 55: // $473
      __label__ = 56; break;
    case 56: // $474
      var $475=$line;
      var $476=(($475+1)|0);
      $line=$476;
      __label__ = 28; break;
    case 57: // $477
      var $478=$source;
      var $479=(($478+84)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=__ZNK13address_space6directEv($480);
      var $482=__ZNK16direct_read_data9decryptedEv($481);
      var $483=(($15+108)|0);
      HEAP32[(($483)>>2)]=$482;
      var $484=$source;
      var $485=(($484+84)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=__ZNK13address_space6directEv($486);
      var $488=__ZNK16direct_read_data3rawEv($487);
      var $489=(($15+104)|0);
      HEAP32[(($489)>>2)]=$488;
      var $490=$source;
      var $491=(($490+76)|0);
      var $492=HEAP32[(($491)>>2)];
      var $493=__ZNK8device_t5debugEv($492);
      var $494=__ZNK12device_debug20comment_change_countEv($493);
      var $495=(($15+112)|0);
      HEAP32[(($495)>>2)]=$494;
      var $496=$15;
      var $497=(($496+74)|0);
      HEAP8[($497)]=0;
      var $498=$changed;
      var $499=(($498) & 1);
      STACKTOP = __stackBase__;
      return $499;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasm9recomputeEjii["X"]=1;

function __ZNK21debug_view_expression5dirtyEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP8[($3)];
  var $5=(($4) & 1);
  ;
  return $5;
}


function __ZNK21debug_view_expression10last_valueEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZN17debug_view_disasm11view_updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $source;
      var $pc;
      var $pcbyte;
      var $previous=__stackBase__;
      var $result=__stackBase__+8;
      var $resultbyte;
      var $row;
      var $recomputed_this_time;
      var $backpc;
      var $row1;
      var $effrow;
      var $changed;
      var $dest;
      var $row2;
      var $effrow3;
      var $col;
      var $attrib;
      var $bp;
      var $data;
      var $len;
      var $effcol;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+12)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($5);
      $source=$6;
      var $7=$source;
      var $8=(($7+76)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__Z12device_stateP8device_t($9);
      var $11=__ZN22device_state_interface5stateEi($10, -1);
      var $11$0=$11[0];
      var $11$1=$11[1];
      var $12$0=$11$0;
      var $12=$12$0;
      $pc=$12;
      var $13=$source;
      var $14=(($13+84)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$pc;
      var $17=__ZNK13address_space15address_to_byteEj($15, $16);
      var $18=$source;
      var $19=(($18+84)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=__ZNK13address_space11logbytemaskEv($20);
      var $22=$17 & $21;
      $pcbyte=$22;
      var $23=(($2+132)|0);
      var $24=__ZNK21debug_view_expression5dirtyEv($23);
      if ($24) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $25
      var $26=$2;
      var $27=(($26+74)|0);
      HEAP8[($27)]=1;
      __label__ = 2; break;
    case 2: // $28
      var $29=(($2+132)|0);
      var $30=__ZNK21debug_view_expression10last_valueEv($29);
      var $30$0=$30[0];
      var $30$1=$30[1];
      var $st$4$0=(($previous)|0);
      HEAP32[(($st$4$0)>>2)]=$30$0;
      var $st$4$1=(($previous+4)|0);
      HEAP32[(($st$4$1)>>2)]=$30$1;
      var $31=(($2+132)|0);
      var $32=__ZN21debug_view_expression5valueEv($31);
      var $32$0=$32[0];
      var $32$1=$32[1];
      var $st$12$0=(($result)|0);
      HEAP32[(($st$12$0)>>2)]=$32$0;
      var $st$12$1=(($result+4)|0);
      HEAP32[(($st$12$1)>>2)]=$32$1;
      var $st$16$0=(($result)|0);
      var $33$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($result+4)|0);
      var $33$1=HEAP32[(($st$16$1)>>2)];
      var $st$20$0=(($previous)|0);
      var $34$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($previous+4)|0);
      var $34$1=HEAP32[(($st$20$1)>>2)];
      var $35=$33$0 != $34$0 || $33$1 != $34$1;
      if ($35) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $36
      var $37=$source;
      var $38=(($37+84)|0);
      var $39=HEAP32[(($38)>>2)];
      var $st$3$0=(($result)|0);
      var $40$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($result+4)|0);
      var $40$1=HEAP32[(($st$3$1)>>2)];
      var $41$0=$40$0;
      var $41=$41$0;
      var $42=__ZNK13address_space15address_to_byteEj($39, $41);
      var $43=$source;
      var $44=(($43+84)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=__ZNK13address_space11logbytemaskEv($45);
      var $47=$42 & $46;
      $resultbyte=$47;
      $row=0;
      __label__ = 4; break;
    case 4: // $48
      var $49=$row;
      var $50=(($2+836)|0);
      var $51=(($50+4)|0);
      var $52=HEAPU32[(($51)>>2)];
      var $53=(($49)>>>0) < (($52)>>>0);
      if ($53) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $54
      var $55=$row;
      var $56=(($2+844)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+($55<<2))|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$resultbyte;
      var $61=(($59)|0)==(($60)|0);
      if ($61) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $62
      __label__ = 9; break;
    case 7: // $63
      __label__ = 8; break;
    case 8: // $64
      var $65=$row;
      var $66=(($65+1)|0);
      $row=$66;
      __label__ = 4; break;
    case 9: // $67
      var $68=$row;
      var $69=(($2+836)|0);
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($68)|0)==(($71)|0);
      if ($72) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $73
      var $74=$row;
      var $75=$2;
      var $76=(($75+48)|0);
      var $77=(($76+4)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$2;
      var $80=(($79+40)|0);
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($78-$82)|0);
      var $84=(($74)>>>0) >= (($83)>>>0);
      if ($84) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $85
      var $86=$2;
      var $87=(($86+74)|0);
      HEAP8[($87)]=1;
      __label__ = 19; break;
    case 12: // $88
      var $89=$row;
      var $90=$2;
      var $91=(($90+56)|0);
      var $92=(($91+4)|0);
      var $93=HEAPU32[(($92)>>2)];
      var $94=(($89)>>>0) < (($93)>>>0);
      if ($94) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $95
      var $96=$row;
      var $97=$2;
      var $98=(($97+56)|0);
      var $99=(($98+4)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$2;
      var $102=(($101+40)|0);
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($100+$104)|0);
      var $106=(($105-2)|0);
      var $107=(($96)>>>0) >= (($106)>>>0);
      if ($107) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $108
      var $109=$row;
      var $110=(($109)>>>0) > 3;
      if ($110) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $111
      var $112=$row;
      var $113=(($112-3)|0);
      var $116 = $113;__label__ = 17; break;
    case 16: // $114
      var $116 = 0;__label__ = 17; break;
    case 17: // $115
      var $116;
      var $117=$2;
      var $118=(($117+56)|0);
      var $119=(($118+4)|0);
      HEAP32[(($119)>>2)]=$116;
      __label__ = 18; break;
    case 18: // $120
      __label__ = 19; break;
    case 19: // $121
      __label__ = 20; break;
    case 20: // $122
      var $123=$source;
      var $124=(($123+84)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=__ZNK13address_space6directEv($125);
      var $127=__ZNK16direct_read_data9decryptedEv($126);
      var $128=(($2+108)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($127)|0)!=(($129)|0);
      if ($130) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $131
      var $132=$source;
      var $133=(($132+84)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=__ZNK13address_space6directEv($134);
      var $136=__ZNK16direct_read_data3rawEv($135);
      var $137=(($2+104)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($136)|0)!=(($138)|0);
      if ($139) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $140
      var $141=$2;
      var $142=(($141+74)|0);
      HEAP8[($142)]=1;
      __label__ = 23; break;
    case 23: // $143
      var $144=(($2+112)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$source;
      var $147=(($146+76)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=__ZNK8device_t5debugEv($148);
      var $150=__ZNK12device_debug20comment_change_countEv($149);
      var $151=(($145)|0)!=(($150)|0);
      if ($151) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $152
      var $153=$2;
      var $154=(($153+74)|0);
      HEAP8[($154)]=1;
      __label__ = 25; break;
    case 25: // $155
      $recomputed_this_time=0;
      __label__ = 26; break;
    case 26: // $156
      var $157=$2;
      var $158=(($157+74)|0);
      var $159=HEAP8[($158)];
      var $160=(($159) & 1);
      if ($160) { __label__ = 27; break; } else { __label__ = 32; break; }
    case 27: // $161
      var $162=(($2+844)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $165
      var $166=(($2+112)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$source;
      var $169=(($168+76)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=__ZNK8device_t5debugEv($170);
      var $172=__ZNK12device_debug20comment_change_countEv($171);
      var $173=(($167)|0)!=(($172)|0);
      if ($173) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $174
      var $175=$2;
      var $176=(($175+56)|0);
      var $177=(($176)|0);
      HEAP32[(($177)>>2)]=0;
      var $178=$source;
      var $179=(($178+84)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($2+844)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=(($182)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=__ZNK13address_space15byte_to_addressEj($180, $184);
      var $186=$2;
      var $187=(($186+48)|0);
      var $188=(($187+4)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=__ZN17debug_view_disasm9recomputeEjii($2, $185, 0, $189);
      __label__ = 31; break;
    case 30: // $191
      var $192=(($2+132)|0);
      var $193=__ZN21debug_view_expression5valueEv($192);
      var $193$0=$193[0];
      var $193$1=$193[1];
      var $194$0=$193$0;
      var $194=$194$0;
      var $195=(($2+96)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=__ZN17debug_view_disasm17find_pc_backwardsEji($2, $194, $196);
      $backpc=$197;
      var $198=$2;
      var $199=(($198+56)|0);
      var $200=(($199+4)|0);
      HEAP32[(($200)>>2)]=0;
      var $201=$2;
      var $202=(($201+56)|0);
      var $203=(($202)|0);
      HEAP32[(($203)>>2)]=0;
      var $204=$backpc;
      var $205=$2;
      var $206=(($205+48)|0);
      var $207=(($206+4)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=__ZN17debug_view_disasm9recomputeEjii($2, $204, 0, $208);
      __label__ = 31; break;
    case 31: // $210
      $recomputed_this_time=1;
      __label__ = 32; break;
    case 32: // $211
      var $212=$pcbyte;
      var $213=(($2+116)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(($212)|0)!=(($214)|0);
      if ($215) { __label__ = 33; break; } else { __label__ = 45; break; }
    case 33: // $216
      $row1=0;
      __label__ = 34; break;
    case 34: // $217
      var $218=$row1;
      var $219=$2;
      var $220=(($219+40)|0);
      var $221=(($220+4)|0);
      var $222=HEAPU32[(($221)>>2)];
      var $223=(($218)>>>0) < (($222)>>>0);
      if ($223) { __label__ = 35; break; } else { __label__ = 44; break; }
    case 35: // $224
      var $225=$2;
      var $226=(($225+56)|0);
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$row1;
      var $230=(($228+$229)|0);
      $effrow=$230;
      var $231=$effrow;
      var $232=(($2+836)|0);
      var $233=(($232+4)|0);
      var $234=HEAPU32[(($233)>>2)];
      var $235=(($231)>>>0) >= (($234)>>>0);
      if ($235) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $236
      __label__ = 44; break;
    case 37: // $237
      var $238=$pcbyte;
      var $239=$effrow;
      var $240=(($2+844)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241+($239<<2))|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($238)|0)==(($243)|0);
      if ($244) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $245
      var $246=$pc;
      var $247=$effrow;
      var $248=__ZN17debug_view_disasm9recomputeEjii($2, $246, $247, 1);
      var $249=(($248)&1);
      $changed=$249;
      var $250=$changed;
      var $251=(($250) & 1);
      if ($251) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $252
      var $253=$recomputed_this_time;
      var $254=(($253) & 1);
      if ($254) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $255
      var $256=$2;
      var $257=(($256+74)|0);
      HEAP8[($257)]=1;
      __label__ = 26; break;
    case 41: // $258
      var $259=$effrow;
      var $260=$2;
      var $261=(($260+64)|0);
      var $262=(($261+4)|0);
      HEAP32[(($262)>>2)]=$259;
      var $263=$2;
      var $264=HEAP32[(($263)>>2)];
      var $265=(($264+12)|0);
      var $266=HEAP32[(($265)>>2)];
      FUNCTION_TABLE[$266]($2, 2);
      __label__ = 42; break;
    case 42: // $267
      __label__ = 43; break;
    case 43: // $268
      var $269=$row1;
      var $270=(($269+1)|0);
      $row1=$270;
      __label__ = 34; break;
    case 44: // $271
      var $272=$pcbyte;
      var $273=(($2+116)|0);
      HEAP32[(($273)>>2)]=$272;
      __label__ = 45; break;
    case 45: // $274
      var $275=$2;
      var $276=(($275+80)|0);
      var $277=HEAP32[(($276)>>2)];
      $dest=$277;
      $row2=0;
      __label__ = 46; break;
    case 46: // $278
      var $279=$row2;
      var $280=$2;
      var $281=(($280+40)|0);
      var $282=(($281+4)|0);
      var $283=HEAPU32[(($282)>>2)];
      var $284=(($279)>>>0) < (($283)>>>0);
      if ($284) { __label__ = 47; break; } else { __label__ = 81; break; }
    case 47: // $285
      var $286=$2;
      var $287=(($286+56)|0);
      var $288=(($287+4)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=$row2;
      var $291=(($289+$290)|0);
      $effrow3=$291;
      $col=0;
      $attrib=0;
      var $292=$effrow3;
      var $293=(($2+836)|0);
      var $294=(($293+4)|0);
      var $295=HEAPU32[(($294)>>2)];
      var $296=(($292)>>>0) < (($295)>>>0);
      if ($296) { __label__ = 48; break; } else { __label__ = 73; break; }
    case 48: // $297
      var $298=$pcbyte;
      var $299=$effrow3;
      var $300=(($2+844)|0);
      var $301=HEAP32[(($300)>>2)];
      var $302=(($301+($299<<2))|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(($298)|0)==(($303)|0);
      if ($304) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $305
      $attrib=32;
      __label__ = 57; break;
    case 50: // $306
      var $307=$source;
      var $308=(($307+76)|0);
      var $309=HEAP32[(($308)>>2)];
      var $310=__ZNK8device_t5debugEv($309);
      var $311=__ZNK12device_debug16breakpoint_firstEv($310);
      $bp=$311;
      __label__ = 51; break;
    case 51: // $312
      var $313=$bp;
      var $314=(($313)|0)!=0;
      if ($314) { __label__ = 52; break; } else { __label__ = 56; break; }
    case 52: // $315
      var $316=$effrow3;
      var $317=(($2+844)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=(($318+($316<<2))|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$source;
      var $322=(($321+84)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=$bp;
      var $325=__ZNK12device_debug10breakpoint7addressEv($324);
      var $326=__ZNK13address_space15address_to_byteEj($323, $325);
      var $327=$source;
      var $328=(($327+84)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=__ZNK13address_space11logbytemaskEv($329);
      var $331=$326 & $330;
      var $332=(($320)|0)==(($331)|0);
      if ($332) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $333
      $attrib=1;
      __label__ = 54; break;
    case 54: // $334
      __label__ = 55; break;
    case 55: // $335
      var $336=$bp;
      var $337=__ZNK12device_debug10breakpoint4nextEv($336);
      $bp=$337;
      __label__ = 51; break;
    case 56: // $338
      __label__ = 57; break;
    case 57: // $339
      var $340=$2;
      var $341=(($340+73)|0);
      var $342=HEAP8[($341)];
      var $343=(($342) & 1);
      if ($343) { __label__ = 58; break; } else { __label__ = 60; break; }
    case 58: // $344
      var $345=$effrow3;
      var $346=$2;
      var $347=(($346+64)|0);
      var $348=(($347+4)|0);
      var $349=HEAP32[(($348)>>2)];
      var $350=(($345)|0)==(($349)|0);
      if ($350) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $351
      var $352=$attrib;
      var $353=(($352)&255);
      var $354=$353 | 2;
      var $355=(($354) & 255);
      $attrib=$355;
      __label__ = 60; break;
    case 60: // $356
      var $357=$effrow3;
      var $358=(($2+836)|0);
      var $359=(($358)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=(($357*$360)|0);
      var $362=(($2+848)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=(($363+$361)|0);
      $data=$364;
      var $365=$data;
      var $366=_strlen($365);
      $len=$366;
      var $367=$2;
      var $368=(($367+56)|0);
      var $369=(($368)|0);
      var $370=HEAP32[(($369)>>2)];
      $effcol=$370;
      __label__ = 61; break;
    case 61: // $371
      var $372=$col;
      var $373=$2;
      var $374=(($373+40)|0);
      var $375=(($374)|0);
      var $376=HEAPU32[(($375)>>2)];
      var $377=(($372)>>>0) < (($376)>>>0);
      if ($377) { __label__ = 62; break; } else { var $383 = 0;__label__ = 63; break; }
    case 62: // $378
      var $379=$effcol;
      var $380=$len;
      var $381=(($379)>>>0) < (($380)>>>0);
      var $383 = $381;__label__ = 63; break;
    case 63: // $382
      var $383;
      if ($383) { __label__ = 64; break; } else { __label__ = 72; break; }
    case 64: // $384
      var $385=$effcol;
      var $386=(($385+1)|0);
      $effcol=$386;
      var $387=$data;
      var $388=(($387+$385)|0);
      var $389=HEAP8[($388)];
      var $390=$dest;
      var $391=(($390)|0);
      HEAP8[($391)]=$389;
      var $392=$effcol;
      var $393=(($2+120)|0);
      var $394=HEAPU32[(($393)>>2)];
      var $395=(($392)>>>0) <= (($394)>>>0);
      if ($395) { __label__ = 66; break; } else { __label__ = 65; break; }
    case 65: // $396
      var $397=$effcol;
      var $398=(($2+124)|0);
      var $399=HEAPU32[(($398)>>2)];
      var $400=(($397)>>>0) >= (($399)>>>0);
      if ($400) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $401
      var $402=$attrib;
      var $403=(($402)&255);
      var $404=$403 | 16;
      var $409 = $404;__label__ = 68; break;
    case 67: // $405
      var $406=$attrib;
      var $407=(($406)&255);
      var $409 = $407;__label__ = 68; break;
    case 68: // $408
      var $409;
      var $410=(($409) & 255);
      var $411=$dest;
      var $412=(($411+1)|0);
      HEAP8[($412)]=$410;
      var $413=$effcol;
      var $414=(($2+124)|0);
      var $415=HEAPU32[(($414)>>2)];
      var $416=(($413)>>>0) >= (($415)>>>0);
      if ($416) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $417
      var $418=(($2+92)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=(($419)|0)==3;
      if ($420) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $421
      var $422=$attrib;
      var $423=(($422)&255);
      var $424=$423 | 64;
      var $425=(($424) & 255);
      $attrib=$425;
      __label__ = 71; break;
    case 71: // $426
      var $427=$dest;
      var $428=(($427+2)|0);
      $dest=$428;
      var $429=$col;
      var $430=(($429+1)|0);
      $col=$430;
      __label__ = 61; break;
    case 72: // $431
      __label__ = 73; break;
    case 73: // $432
      __label__ = 74; break;
    case 74: // $433
      var $434=$col;
      var $435=$2;
      var $436=(($435+40)|0);
      var $437=(($436)|0);
      var $438=HEAPU32[(($437)>>2)];
      var $439=(($434)>>>0) < (($438)>>>0);
      if ($439) { __label__ = 75; break; } else { __label__ = 79; break; }
    case 75: // $440
      var $441=$dest;
      var $442=(($441)|0);
      HEAP8[($442)]=32;
      var $443=$effrow3;
      var $444=$2;
      var $445=(($444+48)|0);
      var $446=(($445+4)|0);
      var $447=HEAPU32[(($446)>>2)];
      var $448=(($443)>>>0) < (($447)>>>0);
      if ($448) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $449
      var $450=$attrib;
      var $451=(($450)&255);
      var $452=$451 | 16;
      var $457 = $452;__label__ = 78; break;
    case 77: // $453
      var $454=$attrib;
      var $455=(($454)&255);
      var $457 = $455;__label__ = 78; break;
    case 78: // $456
      var $457;
      var $458=(($457) & 255);
      var $459=$dest;
      var $460=(($459+1)|0);
      HEAP8[($460)]=$458;
      var $461=$dest;
      var $462=(($461+2)|0);
      $dest=$462;
      var $463=$col;
      var $464=(($463+1)|0);
      $col=$464;
      __label__ = 74; break;
    case 79: // $465
      __label__ = 80; break;
    case 80: // $466
      var $467=$row2;
      var $468=(($467+1)|0);
      $row2=$468;
      __label__ = 46; break;
    case 81: // $469
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_disasm11view_updateEv["X"]=1;

function __ZN21debug_view_expression5valueEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZN21debug_view_expression9recomputeEv($2);
  var $4=(($2+8)|0);
  var $st$5$0=(($4)|0);
  var $5$0=HEAP32[(($st$5$0)>>2)];
  var $st$5$1=(($4+4)|0);
  var $5$1=HEAP32[(($st$5$1)>>2)];
  ;
  return [$5$0,$5$1];
}


function __ZN17debug_view_disasm16selected_addressEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN10debug_view13flush_updatesEv($3);
  var $4=$2;
  var $5=(($4+12)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_($6);
  var $8=(($7+84)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=(($10+64)|0);
  var $12=(($11+4)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=(($2+844)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=(($15+($13<<2))|0);
  var $17=HEAP32[(($16)>>2)];
  var $18=__ZNK13address_space15byte_to_addressEj($9, $17);
  ;
  return $18;
}


function __ZN17debug_view_disasm14set_expressionEPKc($this, $expression) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$expression;
  var $3=$1;
  var $4=$3;
  __ZN10debug_view12begin_updateEv($4);
  var $5=(($3+132)|0);
  var $6=$2;
  __ZN21debug_view_expression10set_stringEPKc($5, $6);
  var $7=$3;
  var $8=(($7+76)|0);
  HEAP8[($8)]=1;
  var $9=$3;
  var $10=(($9+74)|0);
  HEAP8[($10)]=1;
  var $11=$3;
  __ZN10debug_view10end_updateEv($11);
  ;
  return;
}


function __ZN21debug_view_expression10set_stringEPKc($this, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$string;
  var $3=$1;
  var $4=(($3+640)|0);
  var $5=$2;
  var $6=__ZN7astring3cpyEPKc($4, $5);
  var $7=(($3+4)|0);
  HEAP8[($7)]=1;
  ;
  return;
}


function __ZN17debug_view_disasm16set_right_columnE19disasm_right_column($this, $contents) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$contents;
  var $3=$1;
  var $4=$3;
  __ZN10debug_view12begin_updateEv($4);
  var $5=$2;
  var $6=(($3+92)|0);
  HEAP32[(($6)>>2)]=$5;
  var $7=$3;
  var $8=(($7+76)|0);
  HEAP8[($8)]=1;
  var $9=$3;
  var $10=(($9+74)|0);
  HEAP8[($10)]=1;
  var $11=$3;
  __ZN10debug_view10end_updateEv($11);
  ;
  return;
}


function __ZN24debug_view_disasm_sourceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN24debug_view_disasm_sourceD2Ev($2);
  ;
  return;
}


function __ZN24debug_view_disasm_sourceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17debug_view_sourceD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI24debug_view_disasm_sourceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI24debug_view_disasm_sourceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI24debug_view_disasm_sourceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 88);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI24debug_view_disasm_sourceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI24debug_view_disasm_sourceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI24debug_view_disasm_sourceED2Ev($2);
  ;
  return;
}


function __ZN24debug_view_disasm_sourceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN24debug_view_disasm_sourceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24debug_view_disasm_sourceD0Ev["X"]=1;

function __ZNK13memory_regioncvPvEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=(($2+72)|0);
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      ;
      return $10;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8device_t4nextI23device_disasm_interfaceEEbRPT_($this, $intf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $cur;
      $2=$this;
      $3=$intf;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $cur=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$cur;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$cur;
      var $12=$3;
      var $13=__ZN8device_t9interfaceI23device_disasm_interfaceEEbRPT_($11, $12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 7; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cur;
      var $18=(($17+20)|0);
      var $19=HEAP32[(($18)>>2)];
      $cur=$19;
      __label__ = 1; break;
    case 6: // $20
      $1=0;
      __label__ = 7; break;
    case 7: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24debug_view_memory_sourceC2EPKcPvii($this, $name, $base, $element_size, $num_elements) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$name;
      $3=$base;
      $4=$element_size;
      $5=$num_elements;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      __ZN17debug_view_sourceC2EPKcP8device_t($7, $8, 0);
      var $9=$6;
      HEAP32[(($9)>>2)]=((__ZTV24debug_view_memory_source+8)|0);
      var $10=(($6+76)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($6+80)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($6+84)|0);
      var $13=$3;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($6+88)|0);
      var $15=$4;
      var $16=$5;
      var $17=(($15*$16)|0);
      HEAP32[(($14)>>2)]=$17;
      var $18=(($6+92)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($6+96)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($6+100)|0);
      var $21=$4;
      var $22=(($21)|0) < 8;
      if ($22) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $23
      var $24=$4;
      var $27 = $24;__label__ = 3; break;
    case 2: // $25
      var $27 = 8;__label__ = 3; break;
    case 3: // $26
      var $27;
      var $28=(($27) & 255);
      HEAP8[($20)]=$28;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN20resource_pool_objectI24debug_view_disasm_sourceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24debug_view_disasm_sourceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI24debug_view_disasm_sourceED0Ev["X"]=1;

function __ZN20resource_pool_objectI24debug_view_disasm_sourceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI24debug_view_disasm_sourceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN24debug_view_memory_sourceC2EPKcR13address_space($this, $name, $space) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$name;
      $3=$space;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=$3;
      var $10=__ZNK13address_space6deviceEv($9);
      __ZN17debug_view_sourceC2EPKcP8device_t($7, $8, $10);
      var $11=$6;
      HEAP32[(($11)>>2)]=((__ZTV24debug_view_memory_source+8)|0);
      var $12=(($6+76)|0);
      var $13=$3;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($6+80)|0);
      var $15=$3;
      var $16=(function() { try { __THREW__ = false; return __ZNK13address_space6deviceEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $17
      var $18=(($16)|0)==0;
      if ($18) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $19
      var $20=$16;
      var $21=___dynamic_cast($20, __ZTI8device_t, __ZTI23device_memory_interface, -1);
      var $22=$21;
      var $30 = $22;__label__ = 5; break;
    case 3: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      var $27=$6;
      (function() { try { __THREW__ = false; return __ZN17debug_view_sourceD2Ev($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 4: // $28
      var $30 = 0;__label__ = 5; break;
    case 5: // $29
      var $30;
      HEAP32[(($14)>>2)]=$30;
      var $31=(($6+84)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($6+88)|0);
      HEAP32[(($32)>>2)]=0;
      var $33=(($6+92)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=(($6+96)|0);
      var $35=$3;
      var $36=(function() { try { __THREW__ = false; return __ZNK13address_space10endiannessEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; };
    case 6: // $37
      HEAP32[(($34)>>2)]=$36;
      var $38=(($6+100)|0);
      var $39=$3;
      var $40=(function() { try { __THREW__ = false; return __ZNK13address_space10data_widthEv($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 3; break; };
    case 7: // $41
      var $42=(((($40)|0)/8)|0);
      var $43=(($42) & 255);
      HEAP8[($38)]=$43;
      ;
      return;
    case 8: // $44
      __label__ = 9; break;
    case 9: // $45
      var $46=$4;
      var $47=$4;
      var $48=$5;
      var $49=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $47, tempValue);
      var $50=($49.f1 = $48, $49);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24debug_view_memory_sourceC2EPKcR13address_space["X"]=1;

function __ZN24debug_view_memory_sourceC2EPKcRK13memory_region($this, $name, $region) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$name;
      $3=$region;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      __ZN17debug_view_sourceC2EPKcP8device_t($7, $8, 0);
      var $9=$6;
      HEAP32[(($9)>>2)]=((__ZTV24debug_view_memory_source+8)|0);
      var $10=(($6+76)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=(($6+80)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($6+84)|0);
      var $13=$3;
      var $14=(function() { try { __THREW__ = false; return __ZNK13memory_regioncvPvEv($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 10; break; };
    case 1: // $15
      HEAP32[(($12)>>2)]=$14;
      var $16=(($6+88)|0);
      var $17=$3;
      var $18=(function() { try { __THREW__ = false; return __ZNK13memory_region5bytesEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 10; break; };
    case 2: // $19
      HEAP32[(($16)>>2)]=$18;
      var $20=(($6+92)|0);
      var $21=$3;
      var $22=(function() { try { __THREW__ = false; return __ZNK13memory_region5widthEv($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 10; break; };
    case 3: // $23
      var $24=(($22)&255);
      var $25=(($24-1)|0);
      HEAP32[(($20)>>2)]=$25;
      var $26=(($6+96)|0);
      var $27=$3;
      var $28=(function() { try { __THREW__ = false; return __ZNK13memory_region10endiannessEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $29
      HEAP32[(($26)>>2)]=$28;
      var $30=(($6+100)|0);
      var $31=$3;
      var $32=(function() { try { __THREW__ = false; return __ZNK13memory_region5widthEv($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; };
    case 5: // $33
      var $34=(($32)&255);
      var $35=(($34)|0) < 8;
      if ($35) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=$3;
      var $38=(function() { try { __THREW__ = false; return __ZNK13memory_region5widthEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $39
      var $40=(($38)&255);
      var $43 = $40;__label__ = 9; break;
    case 8: // $41
      var $43 = 8;__label__ = 9; break;
    case 9: // $42
      var $43;
      var $44=(($43) & 255);
      HEAP8[($30)]=$44;
      ;
      return;
    case 10: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $4=$47;
      var $48=$46.f1;
      $5=$48;
      var $49=$6;
      (function() { try { __THREW__ = false; return __ZN17debug_view_sourceD2Ev($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $50
      __label__ = 12; break;
    case 12: // $51
      var $52=$4;
      var $53=$4;
      var $54=$5;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 13: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24debug_view_memory_sourceC2EPKcRK13memory_region["X"]=1;

function __ZN17debug_view_memoryC2ER15running_machinePFvR10debug_viewPvES4_($this, $machine, $osdupdate, $osdprivate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$machine;
      $3=$osdupdate;
      $4=$osdprivate;
      var $7=$1;
      var $8=$7;
      var $9=$2;
      var $10=$3;
      var $11=$4;
      __ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_($8, $9, 4, $10, $11);
      var $12=$7;
      HEAP32[(($12)>>2)]=((__ZTV17debug_view_memory+8)|0);
      var $13=(($7+92)|0);
      var $14=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionC1ER15running_machine]($13, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $15
      var $16=(($7+796)|0);
      HEAP32[(($16)>>2)]=16;
      var $17=(($7+800)|0);
      HEAP8[($17)]=1;
      var $18=(($7+801)|0);
      HEAP8[($18)]=0;
      var $19=(($7+802)|0);
      HEAP8[($19)]=1;
      var $20=(($7+803)|0);
      HEAP8[($20)]=0;
      var $21=(($7+804)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($7+808)|0);
      HEAP32[(($22)>>2)]=16;
      var $23=(($7+812)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=(($7+816)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $25
      var $26=(($7+880)|0);
      (function() { try { __THREW__ = false; return __ZN17debug_view_memory17enumerate_sourcesEv($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $27
      var $28=$7;
      var $29=(($28+16)|0);
      var $30=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list5countEv($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $31
      var $32=(($30)|0)==0;
      if ($32) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $33
      var $34=___cxa_allocate_exception(4);
      var $35=$34;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($35);
      (function() { try { __THREW__ = false; return ___cxa_throw($34, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $38=$37.f0;
      $5=$38;
      var $39=$37.f1;
      $6=$39;
      __label__ = 13; break;
    case 7: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $5=$42;
      var $43=$41.f1;
      $6=$43;
      __label__ = 11; break;
    case 8: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $46=$45.f0;
      $5=$46;
      var $47=$45.f1;
      $6=$47;
      var $48=(($7+816)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 9: // $49
      var $50=$7;
      var $51=(($50+72)|0);
      HEAP8[($51)]=1;
      ;
      return;
    case 10: // $52
      __label__ = 11; break;
    case 11: // $53
      var $54=(($7+92)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionD1Ev]($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $55
      __label__ = 13; break;
    case 13: // $56
      var $57=$7;
      (function() { try { __THREW__ = false; return __ZN10debug_viewD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $58
      __label__ = 15; break;
    case 15: // $59
      var $60=$5;
      var $61=$5;
      var $62=$6;
      var $63=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $61, tempValue);
      var $64=($63.f1 = $62, $63);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $65
      var $66=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 17: // $67
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memoryC2ER15running_machinePFvR10debug_viewPvES4_["X"]=1;

function __ZN17debug_view_memory11view_notifyE23debug_view_notification($this, $type) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $source;
      $1=$this;
      $2=$type;
      var $4=$1;
      var $5=$2;
      var $6=(($5)|0)==2;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __ZN17debug_view_memory14get_cursor_posEv($3, $4);
      __ZN17debug_view_memory14set_cursor_posENS_10cursor_posE($4, $3);
      __label__ = 8; break;
    case 2: // $8
      var $9=$2;
      var $10=(($9)|0)==3;
      if ($10) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $11
      var $12=$4;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($14);
      $source=$15;
      var $16=(($4+800)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($4+796)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($18*$20)|0);
      var $22=$source;
      var $23=(($22+100)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=Math.floor((($21)>>>0)/(($25)>>>0));
      var $27=(($4+796)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=$source;
      var $29=(($28+100)|0);
      var $30=HEAP8[($29)];
      var $31=(($4+800)|0);
      HEAP8[($31)]=$30;
      var $32=$source;
      var $33=(($32+76)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $36
      var $37=(($4+92)|0);
      var $38=$source;
      var $39=(($38+76)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=__ZNK13address_space6deviceEv($40);
      var $42=__ZNK8device_t5debugEv($41);
      var $43=__ZN12device_debug8symtableEv($42);
      __ZN21debug_view_expression11set_contextEP12symbol_table($37, $43);
      __label__ = 6; break;
    case 5: // $44
      var $45=(($4+92)|0);
      __ZN21debug_view_expression11set_contextEP12symbol_table($45, 0);
      __label__ = 6; break;
    case 6: // $46
      __label__ = 7; break;
    case 7: // $47
      __label__ = 8; break;
    case 8: // $48
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory11view_notifyE23debug_view_notification["X"]=1;

function __ZN17debug_view_memory17enumerate_sourcesEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i9=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $result_i2=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $result_i=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25;
      var $name=__stackBase__+108;
      var $memintf=__stackBase__+172;
      var $gotone;
      var $26;
      var $27;
      var $spacenum=__stackBase__+176;
      var $space;
      var $region;
      var $itemnum;
      var $valsize=__stackBase__+180;
      var $valcount=__stackBase__+184;
      var $base=__stackBase__+188;
      var $itemname;
      $25=$this;
      var $28=$25;
      var $29=$28;
      var $30=(($29+16)|0);
      __ZN22debug_view_source_list5resetEv($30);
      __ZN7astringC1Ev($name);
      HEAP32[(($memintf)>>2)]=0;
      var $31=$28;
      var $32=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 31; break; };
    case 1: // $33
      var $34=(function() { try { __THREW__ = false; return __ZNK15running_machine10devicelistEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 31; break; };
    case 2: // $35
      var $36=(function() { try { __THREW__ = false; return __ZNK11device_list5firstI23device_memory_interfaceEEbRPT_($34, $memintf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 31; break; };
    case 3: // $37
      var $38=(($36)&1);
      $gotone=$38;
      __label__ = 4; break;
    case 4: // $39
      var $40=$gotone;
      var $41=(($40) & 1);
      if ($41) { __label__ = 5; break; } else { __label__ = 46; break; }
    case 5: // $42
      HEAP32[(($spacenum)>>2)]=0;
      __label__ = 6; break;
    case 6: // $43
      var $44=HEAP32[(($spacenum)>>2)];
      var $45=(($44)|0) < 4;
      if ($45) { __label__ = 7; break; } else { __label__ = 43; break; }
    case 7: // $46
      var $47=HEAP32[(($memintf)>>2)];
      var $48=HEAP32[(($spacenum)>>2)];
      var $49=(function() { try { __THREW__ = false; return __ZNK23device_memory_interface5spaceE16address_spacenum($47, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 31; break; };
    case 8: // $50
      $space=$49;
      var $51=$space;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 9; break; } else { __label__ = 40; break; }
    case 9: // $53
      var $54=HEAP32[(($memintf)>>2)];
      var $55=$54;
      var $56=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 31; break; };
    case 10: // $57
      var $58=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($56) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 31; break; };
    case 11: // $59
      var $60=HEAP32[(($memintf)>>2)];
      var $61=$60;
      var $62=(function() { try { __THREW__ = false; return __ZN16device_interface6deviceEv($61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 31; break; };
    case 12: // $63
      var $64=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 31; break; };
    case 13: // $65
      var $66=$space;
      var $67=(function() { try { __THREW__ = false; return __ZNK13address_space4nameEv($66) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 31; break; };
    case 14: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($name, ((STRING_TABLE.__str5843)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$58,HEAP32[((tempInt+4)>>2)]=$64,HEAP32[((tempInt+8)>>2)]=$67,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 31; break; };
    case 15: // $70
      var $71=$28;
      var $72=(($71+16)|0);
      var $73=$28;
      var $74=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 31; break; };
    case 16: // $75
      var $76=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($74) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 31; break; };
    case 17: // $77
      var $78=$20;
      var $79=$21;
      var $80=$22;
      var $81=$result_i;
      var $82=$23;
      var $83=$24;
      HEAP32[(($20)>>2)]=104;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str15844)|0);
      HEAP32[(($22)>>2)]=163;
      var $84=HEAP32[(($20)>>2)];
      var $85=HEAP32[(($21)>>2)];
      var $86=HEAP32[(($22)>>2)];
      var $87=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($84, $85, $86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $88
      HEAP32[(($result_i)>>2)]=$87;
      var $89=HEAP32[(($result_i)>>2)];
      var $90=(($89)|0)==0;
      if ($90) { __label__ = 19; break; } else { __label__ = 25; break; }
    case 19: // $91
      var $92=___cxa_allocate_exception(4);
      var $93=$92;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($93);
      (function() { try { __THREW__ = false; return ___cxa_throw($92, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 20; break; }
    case 20: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      HEAP32[(($23)>>2)]=$96;
      var $97=$95.f1;
      HEAP32[(($24)>>2)]=$97;
      var $98=HEAP32[(($24)>>2)];
      var $99=(($98)|0) < 0;
      if ($99) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $100
      var $101=HEAP32[(($23)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($101) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 31; break; }
    case 22: // $_noexc
      throw "Reached an unreachable!"
    case 23: // $102
      var $103=HEAP32[(($23)>>2)];
      var $104=HEAP32[(($23)>>2)];
      var $105=HEAP32[(($24)>>2)];
      var $106=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $104, tempValue);
      var $107=($106.f1 = $105, $106);
      var $eh_lpad_body = $107;__label__ = 34; break;
    case 24: // $108
      throw "Reached an unreachable!"
    case 25: // $_ZnwjPKci_exit
      var $109=HEAP32[(($result_i)>>2)];
      var $110=$20;
      var $111=$21;
      var $112=$22;
      var $113=$result_i;
      var $114=$23;
      var $115=$24;
      __label__ = 26; break;
    case 26: // $116
      var $117=$109;
      var $118=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 35; break; };
    case 27: // $119
      var $120=$space;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24debug_view_memory_sourceC1EPKcR13address_space]($117, $118, $120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 35; break; }
    case 28: // $121
      var $122=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI24debug_view_memory_sourceEEPT_S3_($76, $117) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 31; break; };
    case 29: // $123
      var $124=$122;
      (function() { try { __THREW__ = false; return __ZN22debug_view_source_list6appendER17debug_view_source($72, $124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $125
      __label__ = 40; break;
    case 31: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body12 = $127;__label__ = 32; break;
    case 32: // $_body11
      var $eh_lpad_body12;
      var $eh_lpad_body5 = $eh_lpad_body12;__label__ = 33; break;
    case 33: // $_body4
      var $eh_lpad_body5;
      var $eh_lpad_body = $eh_lpad_body5;__label__ = 34; break;
    case 34: // $_body
      var $eh_lpad_body;
      var $128=$eh_lpad_body.f0;
      $26=$128;
      var $129=$eh_lpad_body.f1;
      $27=$129;
      __label__ = 113; break;
    case 35: // $130
      var $131=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $132=$131.f0;
      $26=$132;
      var $133=$131.f1;
      $27=$133;
      var $134=$17;
      var $135=$18;
      var $136=$19;
      HEAP32[(($17)>>2)]=$109;
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str15844)|0);
      HEAP32[(($19)>>2)]=163;
      var $137=HEAP32[(($17)>>2)];
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $139
      var $140=HEAP32[(($17)>>2)];
      var $141=HEAP32[(($18)>>2)];
      var $142=HEAP32[(($19)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($140, $141, $142) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 116; break; }
    case 37: // $_noexc1
      __label__ = 38; break;
    case 38: // $_ZdlPvPKci_exit
      var $143=$17;
      var $144=$18;
      var $145=$19;
      __label__ = 39; break;
    case 39: // $146
      __label__ = 113; break;
    case 40: // $147
      __label__ = 41; break;
    case 41: // $148
      (function() { try { __THREW__ = false; return __ZppR16address_spacenumi($spacenum, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 31; break; }
    case 42: // $149
      __label__ = 6; break;
    case 43: // $150
      __label__ = 44; break;
    case 44: // $151
      var $152=HEAP32[(($memintf)>>2)];
      var $153=$152;
      var $154=(function() { try { __THREW__ = false; return __ZNK16device_interface4nextI23device_memory_interfaceEEbRPT_($153, $memintf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 31; break; };
    case 45: // $155
      var $156=(($154)&1);
      $gotone=$156;
      __label__ = 4; break;
    case 46: // $157
      var $158=$28;
      var $159=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($158) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 31; break; };
    case 47: // $160
      var $161=(function() { try { __THREW__ = false; return __ZNK15running_machine12first_regionEv($159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 31; break; };
    case 48: // $162
      $region=$161;
      __label__ = 49; break;
    case 49: // $163
      var $164=$region;
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 50; break; } else { __label__ = 75; break; }
    case 50: // $166
      var $167=$region;
      var $168=(function() { try { __THREW__ = false; return __ZNK13memory_region4nameEv($167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 31; break; };
    case 51: // $169
      var $170=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($name, ((STRING_TABLE.__str25845)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$168,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 31; break; };
    case 52: // $171
      var $172=$28;
      var $173=(($172+16)|0);
      var $174=$28;
      var $175=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($174) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 31; break; };
    case 53: // $176
      var $177=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 31; break; };
    case 54: // $178
      var $179=$12;
      var $180=$13;
      var $181=$14;
      var $182=$result_i2;
      var $183=$15;
      var $184=$16;
      HEAP32[(($12)>>2)]=104;
      HEAP32[(($13)>>2)]=((STRING_TABLE.__str15844)|0);
      HEAP32[(($14)>>2)]=171;
      var $185=HEAP32[(($12)>>2)];
      var $186=HEAP32[(($13)>>2)];
      var $187=HEAP32[(($14)>>2)];
      var $188=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($185, $186, $187) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 57; break; };
    case 55: // $189
      HEAP32[(($result_i2)>>2)]=$188;
      var $190=HEAP32[(($result_i2)>>2)];
      var $191=(($190)|0)==0;
      if ($191) { __label__ = 56; break; } else { __label__ = 62; break; }
    case 56: // $192
      var $193=___cxa_allocate_exception(4);
      var $194=$193;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($194);
      (function() { try { __THREW__ = false; return ___cxa_throw($193, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 57; break; }
    case 57: // $195
      var $196=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $197=$196.f0;
      HEAP32[(($15)>>2)]=$197;
      var $198=$196.f1;
      HEAP32[(($16)>>2)]=$198;
      var $199=HEAP32[(($16)>>2)];
      var $200=(($199)|0) < 0;
      if ($200) { __label__ = 58; break; } else { __label__ = 60; break; }
    case 58: // $201
      var $202=HEAP32[(($15)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($202) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 31; break; }
    case 59: // $_noexc3
      throw "Reached an unreachable!"
    case 60: // $203
      var $204=HEAP32[(($15)>>2)];
      var $205=HEAP32[(($15)>>2)];
      var $206=HEAP32[(($16)>>2)];
      var $207=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $205, tempValue);
      var $208=($207.f1 = $206, $207);
      var $eh_lpad_body5 = $208;__label__ = 33; break;
    case 61: // $209
      throw "Reached an unreachable!"
    case 62: // $_ZnwjPKci_exit6
      var $210=HEAP32[(($result_i2)>>2)];
      var $211=$12;
      var $212=$13;
      var $213=$14;
      var $214=$result_i2;
      var $215=$15;
      var $216=$16;
      __label__ = 63; break;
    case 63: // $217
      var $218=$210;
      var $219=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 70; break; };
    case 64: // $220
      var $221=$region;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24debug_view_memory_sourceC1EPKcRK13memory_region]($218, $219, $221) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 70; break; }
    case 65: // $222
      var $223=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI24debug_view_memory_sourceEEPT_S3_($177, $218) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 31; break; };
    case 66: // $224
      var $225=$223;
      (function() { try { __THREW__ = false; return __ZN22debug_view_source_list6appendER17debug_view_source($173, $225) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 31; break; }
    case 67: // $226
      __label__ = 68; break;
    case 68: // $227
      var $228=$region;
      var $229=(function() { try { __THREW__ = false; return __ZNK13memory_region4nextEv($228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 31; break; };
    case 69: // $230
      $region=$229;
      __label__ = 49; break;
    case 70: // $231
      var $232=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $233=$232.f0;
      $26=$233;
      var $234=$232.f1;
      $27=$234;
      var $235=$9;
      var $236=$10;
      var $237=$11;
      HEAP32[(($9)>>2)]=$210;
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str15844)|0);
      HEAP32[(($11)>>2)]=171;
      var $238=HEAP32[(($9)>>2)];
      var $239=(($238)|0)!=0;
      if ($239) { __label__ = 71; break; } else { __label__ = 73; break; }
    case 71: // $240
      var $241=HEAP32[(($9)>>2)];
      var $242=HEAP32[(($10)>>2)];
      var $243=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($241, $242, $243) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 72; break; } else { __label__ = 116; break; }
    case 72: // $_noexc7
      __label__ = 73; break;
    case 73: // $_ZdlPvPKci_exit8
      var $244=$9;
      var $245=$10;
      var $246=$11;
      __label__ = 74; break;
    case 74: // $247
      __label__ = 113; break;
    case 75: // $248
      $itemnum=0;
      __label__ = 76; break;
    case 76: // $249
      var $250=$itemnum;
      var $251=(($250)|0) < 10000;
      if ($251) { __label__ = 77; break; } else { __label__ = 110; break; }
    case 77: // $252
      var $253=$28;
      var $254=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($253) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 31; break; };
    case 78: // $255
      var $256=(function() { try { __THREW__ = false; return __ZN15running_machine4saveEv($254) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 31; break; };
    case 79: // $257
      var $258=$itemnum;
      var $259=(function() { try { __THREW__ = false; return __ZNK12save_manager12indexed_itemEiRPvRjS2_($256, $258, $base, $valsize, $valcount) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 31; break; };
    case 80: // $260
      $itemname=$259;
      var $261=$itemname;
      var $262=(($261)|0)==0;
      if ($262) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $263
      __label__ = 110; break;
    case 82: // $264
      var $265=HEAPU32[(($valcount)>>2)];
      var $266=(($265)>>>0) > 1;
      if ($266) { __label__ = 83; break; } else { __label__ = 108; break; }
    case 83: // $267
      var $268=$itemname;
      var $269=(function() { try { __THREW__ = false; return _strstr($268, ((STRING_TABLE.__str35846)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 84; break; } else { __label__ = 31; break; };
    case 84: // $270
      var $271=(($269)|0)!=0;
      if ($271) { __label__ = 85; break; } else { __label__ = 108; break; }
    case 85: // $272
      var $273=$itemname;
      var $274=(function() { try { __THREW__ = false; return _strrchr($273, 47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 86; break; } else { __label__ = 31; break; };
    case 86: // $275
      var $276=(($274+1)|0);
      var $277=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($name, $276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 31; break; };
    case 87: // $278
      var $279=$28;
      var $280=(($279+16)|0);
      var $281=$28;
      var $282=(function() { try { __THREW__ = false; return __ZNK10debug_view7machineEv($281) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 31; break; };
    case 88: // $283
      var $284=(function() { try { __THREW__ = false; return __ZN15running_machine7respoolEv($282) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 31; break; };
    case 89: // $285
      var $286=$4;
      var $287=$5;
      var $288=$6;
      var $289=$result_i9;
      var $290=$7;
      var $291=$8;
      HEAP32[(($4)>>2)]=104;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str15844)|0);
      HEAP32[(($6)>>2)]=188;
      var $292=HEAP32[(($4)>>2)];
      var $293=HEAP32[(($5)>>2)];
      var $294=HEAP32[(($6)>>2)];
      var $295=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($292, $293, $294) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 92; break; };
    case 90: // $296
      HEAP32[(($result_i9)>>2)]=$295;
      var $297=HEAP32[(($result_i9)>>2)];
      var $298=(($297)|0)==0;
      if ($298) { __label__ = 91; break; } else { __label__ = 97; break; }
    case 91: // $299
      var $300=___cxa_allocate_exception(4);
      var $301=$300;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($301);
      (function() { try { __THREW__ = false; return ___cxa_throw($300, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 92; break; }
    case 92: // $302
      var $303=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $304=$303.f0;
      HEAP32[(($7)>>2)]=$304;
      var $305=$303.f1;
      HEAP32[(($8)>>2)]=$305;
      var $306=HEAP32[(($8)>>2)];
      var $307=(($306)|0) < 0;
      if ($307) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 93: // $308
      var $309=HEAP32[(($7)>>2)];
      (function() { try { __THREW__ = false; return ___cxa_call_unexpected($309) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 94; break; } else { __label__ = 31; break; }
    case 94: // $_noexc10
      throw "Reached an unreachable!"
    case 95: // $310
      var $311=HEAP32[(($7)>>2)];
      var $312=HEAP32[(($7)>>2)];
      var $313=HEAP32[(($8)>>2)];
      var $314=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $312, tempValue);
      var $315=($314.f1 = $313, $314);
      var $eh_lpad_body12 = $315;__label__ = 32; break;
    case 96: // $316
      throw "Reached an unreachable!"
    case 97: // $_ZnwjPKci_exit13
      var $317=HEAP32[(($result_i9)>>2)];
      var $318=$4;
      var $319=$5;
      var $320=$6;
      var $321=$result_i9;
      var $322=$7;
      var $323=$8;
      __label__ = 98; break;
    case 98: // $324
      var $325=$317;
      var $326=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 99; break; } else { __label__ = 103; break; };
    case 99: // $327
      var $328=HEAP32[(($base)>>2)];
      var $329=HEAP32[(($valsize)>>2)];
      var $330=HEAP32[(($valcount)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN24debug_view_memory_sourceC1EPKcPvii]($325, $326, $328, $329, $330) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 100; break; } else { __label__ = 103; break; }
    case 100: // $331
      var $332=(function() { try { __THREW__ = false; return __ZN13resource_pool10add_objectI24debug_view_memory_sourceEEPT_S3_($284, $325) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 101; break; } else { __label__ = 31; break; };
    case 101: // $333
      var $334=$332;
      (function() { try { __THREW__ = false; return __ZN22debug_view_source_list6appendER17debug_view_source($280, $334) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 31; break; }
    case 102: // $335
      __label__ = 108; break;
    case 103: // $336
      var $337=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $338=$337.f0;
      $26=$338;
      var $339=$337.f1;
      $27=$339;
      var $340=$1;
      var $341=$2;
      var $342=$3;
      HEAP32[(($1)>>2)]=$317;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str15844)|0);
      HEAP32[(($3)>>2)]=188;
      var $343=HEAP32[(($1)>>2)];
      var $344=(($343)|0)!=0;
      if ($344) { __label__ = 104; break; } else { __label__ = 106; break; }
    case 104: // $345
      var $346=HEAP32[(($1)>>2)];
      var $347=HEAP32[(($2)>>2)];
      var $348=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($346, $347, $348) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 116; break; }
    case 105: // $_noexc14
      __label__ = 106; break;
    case 106: // $_ZdlPvPKci_exit15
      var $349=$1;
      var $350=$2;
      var $351=$3;
      __label__ = 107; break;
    case 107: // $352
      __label__ = 113; break;
    case 108: // $353
      __label__ = 109; break;
    case 109: // $354
      var $355=$itemnum;
      var $356=(($355+1)|0);
      $itemnum=$356;
      __label__ = 76; break;
    case 110: // $357
      var $358=$28;
      var $359=$28;
      var $360=(($359+16)|0);
      var $361=(function() { try { __THREW__ = false; return __ZNK22debug_view_source_list4headEv($360) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 111; break; } else { __label__ = 31; break; };
    case 111: // $362
      (function() { try { __THREW__ = false; return __ZN10debug_view10set_sourceERK17debug_view_source($358, $361) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 112; break; } else { __label__ = 31; break; }
    case 112: // $363
      FUNCTION_TABLE[__ZN7astringD1Ev]($name);
      STACKTOP = __stackBase__;
      return;
    case 113: // $364
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 114; break; } else { __label__ = 116; break; }
    case 114: // $365
      __label__ = 115; break;
    case 115: // $366
      var $367=$26;
      var $368=$26;
      var $369=$27;
      var $370=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $368, tempValue);
      var $371=($370.f1 = $369, $370);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 116: // $372
      var $373=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory17enumerate_sourcesEv["X"]=1;

function __ZN13resource_pool10add_objectI24debug_view_memory_sourceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24debug_view_memory_sourceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI24debug_view_memory_sourceEEPT_S3_["X"]=1;

function __Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17debug_view_memory14set_cursor_posENS_10cursor_posE($this, $pos) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $pos; $pos = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($pos)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($pos+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $posdata;
      var $chunknum;
      $1=$this;
      var $2=$1;
      var $3=(($2+800)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=((__ZN17debug_view_memory18s_memory_pos_tableE+$5*25)|0);
      $posdata=$6;
      var $7=(($pos)|0);
      var $8=HEAPU32[(($7)>>2)];
      var $9=(($2+812)|0);
      var $10=HEAPU32[(($9)>>2)];
      var $11=(($8)>>>0) < (($10)>>>0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=(($2+812)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($pos)|0);
      HEAP32[(($15)>>2)]=$14;
      __label__ = 2; break;
    case 2: // $16
      var $17=(($2+812)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($pos)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20-$18)|0);
      HEAP32[(($19)>>2)]=$21;
      var $22=(($pos)|0);
      var $23=HEAPU32[(($22)>>2)];
      var $24=(($2+808)|0);
      var $25=HEAPU32[(($24)>>2)];
      var $26=Math.floor((($23)>>>0)/(($25)>>>0));
      var $27=$2;
      var $28=(($27+64)|0);
      var $29=(($28+4)|0);
      HEAP32[(($29)>>2)]=$26;
      var $30=(($pos)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=(($2+808)|0);
      var $33=HEAPU32[(($32)>>2)];
      var $34=(($31)>>>0)%(($33)>>>0);
      var $35=(($2+800)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=Math.floor((($34)>>>0)/(($37)>>>0));
      $chunknum=$38;
      var $39=(($2+801)|0);
      var $40=HEAP8[($39)];
      var $41=(($40) & 1);
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=(($2+796)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-1)|0);
      var $46=$chunknum;
      var $47=(($45-$46)|0);
      $chunknum=$47;
      __label__ = 4; break;
    case 4: // $48
      var $49=$2;
      var $50=(($49+64)|0);
      var $51=(($50)|0);
      HEAP32[(($51)>>2)]=0;
      __label__ = 5; break;
    case 5: // $52
      var $53=$2;
      var $54=(($53+64)|0);
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$posdata;
      var $58=(($57)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(($56)|0) < (($60)|0);
      if ($61) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $62
      var $63=$2;
      var $64=(($63+64)|0);
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$posdata;
      var $68=(($67+1)|0);
      var $69=(($68+$66)|0);
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=(($pos+4)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=(($71)|0)==(($74)|0);
      if ($75) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $76
      __label__ = 10; break;
    case 8: // $77
      __label__ = 9; break;
    case 9: // $78
      var $79=$2;
      var $80=(($79+64)|0);
      var $81=(($80)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82+1)|0);
      HEAP32[(($81)>>2)]=$83;
      __label__ = 5; break;
    case 10: // $84
      var $85=(($2+880)|0);
      var $86=(($85+8)|0);
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+1)|0);
      var $90=$posdata;
      var $91=(($90)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=$chunknum;
      var $95=(($93*$94)|0);
      var $96=(($89+$95)|0);
      var $97=$2;
      var $98=(($97+64)|0);
      var $99=(($98)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100+$96)|0);
      HEAP32[(($99)>>2)]=$101;
      var $102=$2;
      var $103=(($102+64)|0);
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$2;
      var $107=(($106+48)|0);
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($105)|0) < (($109)|0);
      if ($110) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $111
      var $112=$2;
      var $113=(($112+64)|0);
      var $114=(($113)|0);
      var $115=HEAP32[(($114)>>2)];
      var $122 = $115;__label__ = 13; break;
    case 12: // $116
      var $117=$2;
      var $118=(($117+48)|0);
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $122 = $120;__label__ = 13; break;
    case 13: // $121
      var $122;
      var $123=$2;
      var $124=(($123+64)|0);
      var $125=(($124)|0);
      HEAP32[(($125)>>2)]=$122;
      var $126=$2;
      var $127=(($126+64)|0);
      var $128=(($127+4)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$2;
      var $131=(($130+48)|0);
      var $132=(($131+4)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($129)|0) < (($133)|0);
      if ($134) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $135
      var $136=$2;
      var $137=(($136+64)|0);
      var $138=(($137+4)|0);
      var $139=HEAP32[(($138)>>2)];
      var $146 = $139;__label__ = 16; break;
    case 15: // $140
      var $141=$2;
      var $142=(($141+48)|0);
      var $143=(($142+4)|0);
      var $144=HEAP32[(($143)>>2)];
      var $146 = $144;__label__ = 16; break;
    case 16: // $145
      var $146;
      var $147=$2;
      var $148=(($147+64)|0);
      var $149=(($148+4)|0);
      HEAP32[(($149)>>2)]=$146;
      var $150=$2;
      __ZN10debug_view27adjust_visible_x_for_cursorEv($150);
      var $151=$2;
      __ZN10debug_view27adjust_visible_y_for_cursorEv($151);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory14set_cursor_posENS_10cursor_posE["X"]=1;

function __ZN17debug_view_memory14get_cursor_posEv($agg_result, $this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $posdata;
      var $xposition;
      var $chunknum;
      var $chunkoffs;
      $1=$this;
      var $2=$1;
      __ZN17debug_view_memory10cursor_posC1Ejh($agg_result, 0, 0);
      var $3=(($2+812)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$2;
      var $6=(($5+64)|0);
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($2+800)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=(($8*$11)|0);
      var $13=(($2+796)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($12*$14)|0);
      var $16=(($4+$15)|0);
      var $17=(($agg_result)|0);
      HEAP32[(($17)>>2)]=$16;
      var $18=(($2+800)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=((__ZN17debug_view_memory18s_memory_pos_tableE+$20*25)|0);
      $posdata=$21;
      var $22=$2;
      var $23=(($22+64)|0);
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($2+880)|0);
      var $27=(($26+8)|0);
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($25-$29)|0);
      var $31=(($30-1)|0);
      $xposition=$31;
      var $32=$xposition;
      var $33=(($32)|0) < 0;
      if ($33) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $34
      $xposition=0;
      __label__ = 5; break;
    case 2: // $35
      var $36=$xposition;
      var $37=$posdata;
      var $38=(($37)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=(($2+796)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($40*$42)|0);
      var $44=(($36)>>>0) >= (($43)>>>0);
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      var $46=$posdata;
      var $47=(($46)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=(($2+796)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($49*$51)|0);
      var $53=(($52-1)|0);
      $xposition=$53;
      __label__ = 4; break;
    case 4: // $54
      __label__ = 5; break;
    case 5: // $55
      var $56=$xposition;
      var $57=$posdata;
      var $58=(($57)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(((($56)|0)/(($60)|0))|0);
      $chunknum=$61;
      var $62=$xposition;
      var $63=$posdata;
      var $64=(($63)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=(($62)|0)%(($66)|0);
      $chunkoffs=$67;
      var $68=(($2+801)|0);
      var $69=HEAP8[($68)];
      var $70=(($69) & 1);
      if ($70) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $71
      var $72=(($2+796)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73-1)|0);
      var $75=$chunknum;
      var $76=(($74-$75)|0);
      $chunknum=$76;
      __label__ = 7; break;
    case 7: // $77
      var $78=$chunknum;
      var $79=(($2+800)|0);
      var $80=HEAPU8[($79)];
      var $81=(($80)&255);
      var $82=(($78*$81)|0);
      var $83=(($agg_result)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+$82)|0);
      HEAP32[(($83)>>2)]=$85;
      var $86=$chunkoffs;
      var $87=$posdata;
      var $88=(($87+1)|0);
      var $89=(($88+$86)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $92=$91 & 127;
      var $93=(($92) & 255);
      var $94=(($agg_result+4)|0);
      HEAP8[($94)]=$93;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory14get_cursor_posEv["X"]=1;

function __ZN17debug_view_memory11view_updateEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $source;
      var $posdata;
      var $row;
      var $destmin;
      var $destmax;
      var $destrow;
      var $effrow;
      var $dest;
      var $ch;
      var $effcol;
      var $addrbyte;
      var $address;
      var $addrtext=__stackBase__;
      var $ch1;
      var $chunknum;
      var $chunkindex;
      var $chunkdata=__stackBase__+20;
      var $ismapped;
      var $ch2;
      var $shift;
      var $ch3;
      var $chval=__stackBase__+28;
      var $ismapped4;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+12)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($5);
      $source=$6;
      var $7=__ZN17debug_view_memory15needs_recomputeEv($2);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __ZN17debug_view_memory9recomputeEv($2);
      __label__ = 2; break;
    case 2: // $9
      var $10=(($2+800)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=((__ZN17debug_view_memory18s_memory_pos_tableE+$12*25)|0);
      $posdata=$13;
      $row=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$row;
      var $16=$2;
      var $17=(($16+40)|0);
      var $18=(($17+4)|0);
      var $19=HEAPU32[(($18)>>2)];
      var $20=(($15)>>>0) < (($19)>>>0);
      if ($20) { __label__ = 4; break; } else { __label__ = 62; break; }
    case 4: // $21
      var $22=$2;
      var $23=(($22+80)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$row;
      var $26=$2;
      var $27=(($26+40)|0);
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($25*$29)|0);
      var $31=(($24+($30<<1))|0);
      $destmin=$31;
      var $32=$destmin;
      var $33=$2;
      var $34=(($33+40)|0);
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($32+($36<<1))|0);
      $destmax=$37;
      var $38=$destmin;
      var $39=$2;
      var $40=(($39+56)|0);
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(((-$42))|0);
      var $44=(($38+($43<<1))|0);
      $destrow=$44;
      var $45=$2;
      var $46=(($45+56)|0);
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$row;
      var $50=(($48+$49)|0);
      $effrow=$50;
      var $51=$destmin;
      $dest=$51;
      $ch=0;
      __label__ = 5; break;
    case 5: // $52
      var $53=$ch;
      var $54=$2;
      var $55=(($54+40)|0);
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($53)|0) < (($57)|0);
      if ($58) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $59
      var $60=$2;
      var $61=(($60+56)|0);
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$ch;
      var $65=(($63+$64)|0);
      $effcol=$65;
      var $66=$dest;
      var $67=(($66)|0);
      HEAP8[($67)]=32;
      var $68=$dest;
      var $69=(($68+1)|0);
      HEAP8[($69)]=16;
      var $70=(($2+880)|0);
      var $71=(($70+8)|0);
      var $72=$effcol;
      var $73=__ZNK17debug_view_memory7section8containsEi($71, $72);
      if ($73) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $74
      var $75=$dest;
      var $76=(($75+1)|0);
      HEAP8[($76)]=0;
      var $77=$2;
      var $78=(($77+73)|0);
      var $79=HEAP8[($78)];
      var $80=(($79) & 1);
      if ($80) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $81
      var $82=$effrow;
      var $83=$2;
      var $84=(($83+64)|0);
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($82)|0)==(($86)|0);
      if ($87) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $88
      var $89=$effcol;
      var $90=$2;
      var $91=(($90+64)|0);
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($89)|0)==(($93)|0);
      if ($94) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $95
      var $96=$dest;
      var $97=(($96+1)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$99 | 2;
      var $101=(($100) & 255);
      HEAP8[($97)]=$101;
      __label__ = 11; break;
    case 11: // $102
      __label__ = 12; break;
    case 12: // $103
      __label__ = 13; break;
    case 13: // $104
      var $105=$ch;
      var $106=(($105+1)|0);
      $ch=$106;
      var $107=$dest;
      var $108=(($107+2)|0);
      $dest=$108;
      __label__ = 5; break;
    case 14: // $109
      var $110=$effrow;
      var $111=$2;
      var $112=(($111+48)|0);
      var $113=(($112+4)|0);
      var $114=HEAPU32[(($113)>>2)];
      var $115=(($110)>>>0) < (($114)>>>0);
      if ($115) { __label__ = 15; break; } else { __label__ = 60; break; }
    case 15: // $116
      var $117=(($2+812)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$effrow;
      var $120=(($2+808)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($119*$121)|0);
      var $123=(($118+$122)|0);
      $addrbyte=$123;
      var $124=$source;
      var $125=(($124+76)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126)|0)!=0;
      if ($127) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $128
      var $129=$source;
      var $130=(($129+76)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$addrbyte;
      var $133=__ZNK13address_space15byte_to_addressEj($131, $132);
      var $137 = $133;__label__ = 18; break;
    case 17: // $134
      var $135=$addrbyte;
      var $137 = $135;__label__ = 18; break;
    case 18: // $136
      var $137;
      $address=$137;
      var $138=(($addrtext)|0);
      var $139=(($2+816)|0);
      var $140=__ZNK7astringcvPKcEv($139);
      var $141=$address;
      var $142=_sprintf($138, $140, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$141,tempInt));
      var $143=$destrow;
      var $144=(($2+880)|0);
      var $145=(($144)|0);
      var $146=(($145)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($143+($147<<1))|0);
      var $149=(($148+2)|0);
      $dest=$149;
      $ch1=0;
      __label__ = 19; break;
    case 19: // $150
      var $151=$ch1;
      var $152=(($addrtext+$151)|0);
      var $153=HEAP8[($152)];
      var $154=(($153 << 24) >> 24);
      var $155=(($154)|0)!=0;
      if ($155) { __label__ = 20; break; } else { var $165 = 0;__label__ = 21; break; }
    case 20: // $156
      var $157=$ch1;
      var $158=(($2+880)|0);
      var $159=(($158)|0);
      var $160=(($159+4)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161-1)|0);
      var $163=(($157)|0) < (($162)|0);
      var $165 = $163;__label__ = 21; break;
    case 21: // $164
      var $165;
      if ($165) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $166
      var $167=$dest;
      var $168=$destmin;
      var $169=(($167)>>>0) >= (($168)>>>0);
      if ($169) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $170
      var $171=$dest;
      var $172=$destmax;
      var $173=(($171)>>>0) < (($172)>>>0);
      if ($173) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $174
      var $175=$ch1;
      var $176=(($addrtext+$175)|0);
      var $177=HEAP8[($176)];
      var $178=$dest;
      var $179=(($178)|0);
      HEAP8[($179)]=$177;
      __label__ = 25; break;
    case 25: // $180
      __label__ = 26; break;
    case 26: // $181
      var $182=$ch1;
      var $183=(($182+1)|0);
      $ch1=$183;
      var $184=$dest;
      var $185=(($184+2)|0);
      $dest=$185;
      __label__ = 19; break;
    case 27: // $186
      $chunknum=0;
      __label__ = 28; break;
    case 28: // $187
      var $188=$chunknum;
      var $189=(($2+796)|0);
      var $190=HEAPU32[(($189)>>2)];
      var $191=(($188)>>>0) < (($190)>>>0);
      if ($191) { __label__ = 29; break; } else { __label__ = 46; break; }
    case 29: // $192
      var $193=(($2+801)|0);
      var $194=HEAP8[($193)];
      var $195=(($194) & 1);
      if ($195) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $196
      var $197=(($2+796)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198-1)|0);
      var $200=$chunknum;
      var $201=(($199-$200)|0);
      var $205 = $201;__label__ = 32; break;
    case 31: // $202
      var $203=$chunknum;
      var $205 = $203;__label__ = 32; break;
    case 32: // $204
      var $205;
      $chunkindex=$205;
      var $206=(($2+800)|0);
      var $207=HEAP8[($206)];
      var $208=$addrbyte;
      var $209=$chunknum;
      var $210=(($2+800)|0);
      var $211=HEAPU8[($210)];
      var $212=(($211)&255);
      var $213=(($209*$212)|0);
      var $214=(($208+$213)|0);
      var $215=__ZN17debug_view_memory4readEhjRy($2, $207, $214, $chunkdata);
      var $216=(($215)&1);
      $ismapped=$216;
      var $217=$destrow;
      var $218=(($2+880)|0);
      var $219=(($218+8)|0);
      var $220=(($219)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($217+($221<<1))|0);
      var $223=(($222+2)|0);
      var $224=$chunkindex;
      var $225=$posdata;
      var $226=(($225)|0);
      var $227=HEAPU8[($226)];
      var $228=(($227)&255);
      var $229=(($224*$228)|0);
      var $230=(($223+($229<<1))|0);
      $dest=$230;
      $ch2=0;
      __label__ = 33; break;
    case 33: // $231
      var $232=$ch2;
      var $233=$posdata;
      var $234=(($233)|0);
      var $235=HEAPU8[($234)];
      var $236=(($235)&255);
      var $237=(($232)|0) < (($236)|0);
      if ($237) { __label__ = 34; break; } else { __label__ = 44; break; }
    case 34: // $238
      var $239=$dest;
      var $240=$destmin;
      var $241=(($239)>>>0) >= (($240)>>>0);
      if ($241) { __label__ = 35; break; } else { __label__ = 42; break; }
    case 35: // $242
      var $243=$dest;
      var $244=$destmax;
      var $245=(($243)>>>0) < (($244)>>>0);
      if ($245) { __label__ = 36; break; } else { __label__ = 42; break; }
    case 36: // $246
      var $247=$ch2;
      var $248=$posdata;
      var $249=(($248+1)|0);
      var $250=(($249+$247)|0);
      var $251=HEAP8[($250)];
      $shift=$251;
      var $252=$shift;
      var $253=(($252)&255);
      var $254=(($253)|0) < 64;
      if ($254) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $255
      var $256=$ismapped;
      var $257=(($256) & 1);
      if ($257) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $258
      var $st$0$0=(($chunkdata)|0);
      var $259$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($chunkdata+4)|0);
      var $259$1=HEAP32[(($st$0$1)>>2)];
      var $260=$shift;
      var $261=(($260)&255);
      var $262$0=$261;
      var $262$1=0;
      var $263=Runtime.bitshift64($259$0, $259$1,"lshr",$262$0);var $263$0 = $263[0], $263$1 = $263[1];
      var $$emscripten$temp$0$0=15;
      var $$emscripten$temp$0$1=0;
      var $264$0=$263$0 & $$emscripten$temp$0$0;
      var $264$1=$263$1 & $$emscripten$temp$0$1;
      var $265$0=$264$0;
      var $265=$265$0;
      var $266=((STRING_TABLE.__str45847+$265)|0);
      var $267=HEAP8[($266)];
      var $270 = $267;__label__ = 40; break;
    case 39: // $268
      var $270 = 42;__label__ = 40; break;
    case 40: // $269
      var $270;
      var $271=$dest;
      var $272=(($271)|0);
      HEAP8[($272)]=$270;
      __label__ = 41; break;
    case 41: // $273
      __label__ = 42; break;
    case 42: // $274
      __label__ = 43; break;
    case 43: // $275
      var $276=$ch2;
      var $277=(($276+1)|0);
      $ch2=$277;
      var $278=$dest;
      var $279=(($278+2)|0);
      $dest=$279;
      __label__ = 33; break;
    case 44: // $280
      __label__ = 45; break;
    case 45: // $281
      var $282=$chunknum;
      var $283=(($282+1)|0);
      $chunknum=$283;
      __label__ = 28; break;
    case 46: // $284
      var $285=(($2+880)|0);
      var $286=(($285+16)|0);
      var $287=(($286+4)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=(($288)|0) > 0;
      if ($289) { __label__ = 47; break; } else { __label__ = 59; break; }
    case 47: // $290
      var $291=$destrow;
      var $292=(($2+880)|0);
      var $293=(($292+16)|0);
      var $294=(($293)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=(($291+($295<<1))|0);
      var $297=(($296+2)|0);
      $dest=$297;
      $ch3=0;
      __label__ = 48; break;
    case 48: // $298
      var $299=$ch3;
      var $300=(($2+808)|0);
      var $301=HEAPU32[(($300)>>2)];
      var $302=(($299)>>>0) < (($301)>>>0);
      if ($302) { __label__ = 49; break; } else { __label__ = 58; break; }
    case 49: // $303
      var $304=$dest;
      var $305=$destmin;
      var $306=(($304)>>>0) >= (($305)>>>0);
      if ($306) { __label__ = 50; break; } else { __label__ = 56; break; }
    case 50: // $307
      var $308=$dest;
      var $309=$destmax;
      var $310=(($308)>>>0) < (($309)>>>0);
      if ($310) { __label__ = 51; break; } else { __label__ = 56; break; }
    case 51: // $311
      var $312=$addrbyte;
      var $313=$ch3;
      var $314=(($312+$313)|0);
      var $315=__ZN17debug_view_memory4readEhjRy($2, 1, $314, $chval);
      var $316=(($315)&1);
      $ismapped4=$316;
      var $317=$ismapped4;
      var $318=(($317) & 1);
      if ($318) { __label__ = 52; break; } else { __label__ = 54; break; }
    case 52: // $319
      var $st$0$0=(($chval)|0);
      var $320$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($chval+4)|0);
      var $320$1=HEAP32[(($st$0$1)>>2)];
      var $321$0=$320$0;
      var $321=$321$0;
      var $322=_isprint($321);
      var $323=(($322)|0)!=0;
      if ($323) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $324
      var $st$0$0=(($chval)|0);
      var $325$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($chval+4)|0);
      var $325$1=HEAP32[(($st$0$1)>>2)];
      var $328$1 = $325$1;var $328$0 = $325$0;__label__ = 55; break;
    case 54: // $326
      var $328$1 = 0;var $328$0 = 46;__label__ = 55; break;
    case 55: // $327
      var $328$0;
      var $328$1;
      var $329$0=$328$0;
      var $329=$329$0&255;
      var $330=$dest;
      var $331=(($330)|0);
      HEAP8[($331)]=$329;
      __label__ = 56; break;
    case 56: // $332
      __label__ = 57; break;
    case 57: // $333
      var $334=$ch3;
      var $335=(($334+1)|0);
      $ch3=$335;
      var $336=$dest;
      var $337=(($336+2)|0);
      $dest=$337;
      __label__ = 48; break;
    case 58: // $338
      __label__ = 59; break;
    case 59: // $339
      __label__ = 60; break;
    case 60: // $340
      __label__ = 61; break;
    case 61: // $341
      var $342=$row;
      var $343=(($342+1)|0);
      $row=$343;
      __label__ = 3; break;
    case 62: // $344
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory11view_updateEv["X"]=1;

function __ZNK17debug_view_memory7section8containsEi($this, $x) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$x;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($4)|0) >= (($6)|0);
      if ($7) { __label__ = 1; break; } else { var $17 = 0;__label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($3)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($3+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($11+$13)|0);
      var $15=(($9)|0) < (($14)|0);
      var $17 = $15;__label__ = 2; break;
    case 2: // $16
      var $17;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17debug_view_memory15needs_recomputeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $recompute;
      var $source;
      var $resultbyte;
      var $2=__stackBase__;
      $1=$this;
      var $3=$1;
      var $4=$3;
      var $5=(($4+74)|0);
      var $6=HEAP8[($5)];
      var $7=(($6) & 1);
      var $8=(($7)&1);
      $recompute=$8;
      var $9=(($3+92)|0);
      var $10=__ZNK21debug_view_expression5dirtyEv($9);
      if ($10) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $11
      $recompute=1;
      var $12=(($3+92)|0);
      var $13=__ZN21debug_view_expression5valueEv($12);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $14=(($3+812)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16$0=$15;
      var $16$1=0;
      var $17$0 = ((($13$0)>>>0)+((($13$1)|0)*4294967296))-((($16$0)>>>0)+((($16$1)|0)*4294967296))>>>0; var $17$1 = Math.min(Math.floor((((($13$0)>>>0)+((($13$1)|0)*4294967296))-((($16$0)>>>0)+((($16$1)|0)*4294967296)))/4294967296), 4294967295);
      var $18=(($3+808)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20$0=$19;
      var $20$1=0;
      var $21$0 = Math.floor(((($17$0)>>>0)+((($17$1)|0)*4294967296))/((($20$0)>>>0)+((($20$1)|0)*4294967296)))>>>0; var $21$1 = Math.min(Math.floor((Math.floor(((($17$0)>>>0)+((($17$1)|0)*4294967296))/((($20$0)>>>0)+((($20$1)|0)*4294967296))))/4294967296), 4294967295);
      var $22$0=$21$0;
      var $22=$22$0;
      var $23=$3;
      var $24=(($23+56)|0);
      var $25=(($24+4)|0);
      HEAP32[(($25)>>2)]=$22;
      var $26=$3;
      var $27=(($26+56)|0);
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0) > 0;
      if ($30) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $31
      var $32=$3;
      var $33=(($32+56)|0);
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $38 = $35;__label__ = 4; break;
    case 3: // $36
      var $38 = 0;__label__ = 4; break;
    case 4: // $37
      var $38;
      var $39=$3;
      var $40=(($39+56)|0);
      var $41=(($40+4)|0);
      HEAP32[(($41)>>2)]=$38;
      var $42=$3;
      var $43=(($42+56)|0);
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$3;
      var $47=(($46+48)|0);
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49-1)|0);
      var $51=(($45)|0) < (($50)|0);
      if ($51) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $52
      var $53=$3;
      var $54=(($53+56)|0);
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $64 = $56;__label__ = 7; break;
    case 6: // $57
      var $58=$3;
      var $59=(($58+48)|0);
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61-1)|0);
      var $64 = $62;__label__ = 7; break;
    case 7: // $63
      var $64;
      var $65=$3;
      var $66=(($65+56)|0);
      var $67=(($66+4)|0);
      HEAP32[(($67)>>2)]=$64;
      var $68=$3;
      var $69=(($68+12)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($70);
      $source=$71;
      var $72=$source;
      var $73=(($72+76)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $76
      var $77=$source;
      var $78=(($77+76)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($3+92)|0);
      var $81=__ZN21debug_view_expression5valueEv($80);
      var $81$0=$81[0];
      var $81$1=$81[1];
      var $82$0=$81$0;
      var $82=$82$0;
      var $83=__ZNK13address_space15address_to_byteEj($79, $82);
      var $84=$source;
      var $85=(($84+76)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=__ZNK13address_space11logbytemaskEv($86);
      var $88=$83 & $87;
      $resultbyte=$88;
      __label__ = 10; break;
    case 9: // $89
      var $90=(($3+92)|0);
      var $91=__ZN21debug_view_expression5valueEv($90);
      var $91$0=$91[0];
      var $91$1=$91[1];
      var $92$0=$91$0;
      var $92=$92$0;
      $resultbyte=$92;
      __label__ = 10; break;
    case 10: // $93
      var $94=$resultbyte;
      var $95=(($3+800)|0);
      var $96=HEAPU8[($95)];
      var $97=(($96)&255);
      var $98=((($97<<3))|0);
      var $99=(($98-4)|0);
      var $100=(($99) & 255);
      __ZN17debug_view_memory10cursor_posC1Ejh($2, $94, $100);
      __ZN17debug_view_memory14set_cursor_posENS_10cursor_posE($3, $2);
      __label__ = 11; break;
    case 11: // $101
      var $102=$3;
      var $103=(($102+74)|0);
      HEAP8[($103)]=0;
      var $104=$recompute;
      var $105=(($104) & 1);
      STACKTOP = __stackBase__;
      return $105;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory15needs_recomputeEv["X"]=1;

function __ZN17debug_view_memory9recomputeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $source;
      var $pos=__stackBase__;
      var $addrchars;
      var $min_bytes_per_chunk;
      var $2=__stackBase__+8;
      $1=$this;
      var $3=$1;
      var $4=$3;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($6);
      $source=$7;
      __ZN17debug_view_memory14get_cursor_posEv($pos, $3);
      var $8=$source;
      var $9=(($8+76)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $12
      var $13=(($3+803)|0);
      var $14=HEAP8[($13)];
      var $15=(($14) & 1);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$source;
      var $18=(($17+76)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=__ZNK13address_space8bytemaskEv($19);
      var $27 = $20;__label__ = 4; break;
    case 3: // $21
      var $22=$source;
      var $23=(($22+76)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZNK13address_space11logbytemaskEv($24);
      var $27 = $25;__label__ = 4; break;
    case 4: // $26
      var $27;
      var $28=(($3+804)|0);
      HEAP32[(($28)>>2)]=$27;
      var $29=(($3+803)|0);
      var $30=HEAP8[($29)];
      var $31=(($30) & 1);
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      var $33=$source;
      var $34=(($33+76)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__ZNK13address_space9addrcharsEv($35);
      var $43 = $36;__label__ = 7; break;
    case 6: // $37
      var $38=$source;
      var $39=(($38+76)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=__ZNK13address_space12logaddrcharsEv($40);
      var $43 = $41;__label__ = 7; break;
    case 7: // $42
      var $43;
      var $44=(($43)&255);
      $addrchars=$44;
      __label__ = 9; break;
    case 8: // $45
      var $46=$source;
      var $47=(($46+88)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48-1)|0);
      var $50=(($3+804)|0);
      HEAP32[(($50)>>2)]=$49;
      var $51=(($3+816)|0);
      var $52=(($3+804)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=__ZN7astring6printfEPKcz($51, ((STRING_TABLE.__str55848)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,tempInt));
      $addrchars=$54;
      __label__ = 9; break;
    case 9: // $55
      var $56=(($3+801)|0);
      var $57=HEAP8[($56)];
      var $58=(($57) & 1);
      if ($58) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $59
      var $60=(($3+816)|0);
      var $61=$addrchars;
      var $62=((8-$61)|0);
      var $63=$addrchars;
      var $64=__ZN7astring6printfEPKcz($60, ((STRING_TABLE.__str65849)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$62,HEAP32[((tempInt+4)>>2)]=((__str75850)|0),HEAP32[((tempInt+8)>>2)]=$63,tempInt));
      __label__ = 12; break;
    case 11: // $65
      var $66=(($3+816)|0);
      var $67=$addrchars;
      var $68=$addrchars;
      var $69=((8-$68)|0);
      var $70=__ZN7astring6printfEPKcz($66, ((STRING_TABLE.__str85851)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$67,HEAP32[((tempInt+4)>>2)]=$69,HEAP32[((tempInt+8)>>2)]=((__str75850)|0),tempInt));
      __label__ = 12; break;
    case 12: // $71
      var $72=$source;
      var $73=(($72+76)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 13; break; } else { __label__ = 21; break; }
    case 13: // $76
      var $77=$source;
      var $78=(($77+76)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=__ZNK13address_space15byte_to_addressEj($79, 1);
      var $81=(($80)>>>0) > 1;
      if ($81) { __label__ = 14; break; } else { __label__ = 21; break; }
    case 14: // $82
      var $83=$source;
      var $84=(($83+76)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=__ZNK13address_space15byte_to_addressEj($85, 1);
      $min_bytes_per_chunk=$86;
      __label__ = 15; break;
    case 15: // $87
      var $88=(($3+800)|0);
      var $89=HEAPU8[($88)];
      var $90=(($89)&255);
      var $91=$min_bytes_per_chunk;
      var $92=(($90)>>>0) < (($91)>>>0);
      if ($92) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $93
      var $94=(($3+800)|0);
      var $95=HEAPU8[($94)];
      var $96=(($95)&255);
      var $97=((($96<<1))|0);
      var $98=(($97) & 255);
      HEAP8[($94)]=$98;
      var $99=(($3+796)|0);
      var $100=HEAPU32[(($99)>>2)];
      var $101=Math.floor((($100)>>>0)/2);
      HEAP32[(($99)>>2)]=$101;
      __label__ = 15; break;
    case 17: // $102
      var $103=(($3+796)|0);
      var $104=HEAPU32[(($103)>>2)];
      var $105=1 > (($104)>>>0);
      if ($105) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $106
      var $111 = 1;__label__ = 20; break;
    case 19: // $107
      var $108=(($3+796)|0);
      var $109=HEAP32[(($108)>>2)];
      var $111 = $109;__label__ = 20; break;
    case 20: // $110
      var $111;
      var $112=(($3+796)|0);
      HEAP32[(($112)>>2)]=$111;
      __label__ = 21; break;
    case 21: // $113
      var $114=(($3+800)|0);
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $117=(($3+796)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($116*$118)|0);
      var $120=(($3+808)|0);
      HEAP32[(($120)>>2)]=$119;
      var $121=(($3+92)|0);
      var $122=__ZN21debug_view_expression5valueEv($121);
      var $122$0=$122[0];
      var $122$1=$122[1];
      var $123=(($3+808)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125$0=$124;
      var $125$1=0;
      var $126$0 = ((($122$0)>>>0)+((($122$1)|0)*4294967296))%((($125$0)>>>0)+((($125$1)|0)*4294967296))>>>0; var $126$1 = Math.min(Math.floor((((($122$0)>>>0)+((($122$1)|0)*4294967296))%((($125$0)>>>0)+((($125$1)|0)*4294967296)))/4294967296), 4294967295);
      var $127$0=$126$0;
      var $127=$127$0;
      var $128=(($3+812)|0);
      HEAP32[(($128)>>2)]=$127;
      var $129=(($3+880)|0);
      var $130=(($129)|0);
      var $131=(($130+4)|0);
      HEAP32[(($131)>>2)]=10;
      var $132=(($3+808)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133*3)|0);
      var $135=(($134+1)|0);
      var $136=(($135+1)|0);
      var $137=(($3+880)|0);
      var $138=(($137+8)|0);
      var $139=(($138+4)|0);
      HEAP32[(($139)>>2)]=$136;
      var $140=(($3+802)|0);
      var $141=HEAP8[($140)];
      var $142=(($141) & 1);
      if ($142) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $143
      var $144=(($3+808)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145+1)|0);
      var $147=(($146+1)|0);
      var $150 = $147;__label__ = 24; break;
    case 23: // $148
      var $150 = 0;__label__ = 24; break;
    case 24: // $149
      var $150;
      var $151=(($3+880)|0);
      var $152=(($151+16)|0);
      var $153=(($152+4)|0);
      HEAP32[(($153)>>2)]=$150;
      var $154=(($3+801)|0);
      var $155=HEAP8[($154)];
      var $156=(($155) & 1);
      if ($156) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $157
      var $158=(($3+880)|0);
      var $159=(($158)|0);
      var $160=(($159)|0);
      HEAP32[(($160)>>2)]=0;
      var $161=(($3+880)|0);
      var $162=(($161)|0);
      var $163=(($162)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($3+880)|0);
      var $166=(($165)|0);
      var $167=(($166+4)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($164+$168)|0);
      var $170=(($3+880)|0);
      var $171=(($170+8)|0);
      var $172=(($171)|0);
      HEAP32[(($172)>>2)]=$169;
      var $173=(($3+880)|0);
      var $174=(($173+8)|0);
      var $175=(($174)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($3+880)|0);
      var $178=(($177+8)|0);
      var $179=(($178+4)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($176+$180)|0);
      var $182=(($3+880)|0);
      var $183=(($182+16)|0);
      var $184=(($183)|0);
      HEAP32[(($184)>>2)]=$181;
      var $185=(($3+880)|0);
      var $186=(($185+16)|0);
      var $187=(($186)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($3+880)|0);
      var $190=(($189+16)|0);
      var $191=(($190+4)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($188+$192)|0);
      var $194=$3;
      var $195=(($194+48)|0);
      var $196=(($195)|0);
      HEAP32[(($196)>>2)]=$193;
      __label__ = 27; break;
    case 26: // $197
      var $198=(($3+880)|0);
      var $199=(($198+16)|0);
      var $200=(($199)|0);
      HEAP32[(($200)>>2)]=0;
      var $201=(($3+880)|0);
      var $202=(($201+16)|0);
      var $203=(($202)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=(($3+880)|0);
      var $206=(($205+16)|0);
      var $207=(($206+4)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($204+$208)|0);
      var $210=(($3+880)|0);
      var $211=(($210+8)|0);
      var $212=(($211)|0);
      HEAP32[(($212)>>2)]=$209;
      var $213=(($3+880)|0);
      var $214=(($213+8)|0);
      var $215=(($214)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($3+880)|0);
      var $218=(($217+8)|0);
      var $219=(($218+4)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($216+$220)|0);
      var $222=(($3+880)|0);
      var $223=(($222)|0);
      var $224=(($223)|0);
      HEAP32[(($224)>>2)]=$221;
      var $225=(($3+880)|0);
      var $226=(($225)|0);
      var $227=(($226)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=(($3+880)|0);
      var $230=(($229)|0);
      var $231=(($230+4)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=(($228+$232)|0);
      var $234=$3;
      var $235=(($234+48)|0);
      var $236=(($235)|0);
      HEAP32[(($236)>>2)]=$233;
      __label__ = 27; break;
    case 27: // $237
      var $238=(($3+804)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240$0=$239;
      var $240$1=0;
      var $241=(($3+812)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243$0=$242;
      var $243$1=0;
      var $244$0 = ((($240$0)>>>0)+((($240$1)|0)*4294967296))-((($243$0)>>>0)+((($243$1)|0)*4294967296))>>>0; var $244$1 = Math.min(Math.floor((((($240$0)>>>0)+((($240$1)|0)*4294967296))-((($243$0)>>>0)+((($243$1)|0)*4294967296)))/4294967296), 4294967295);
      var $245=(($3+808)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247$0=$246;
      var $247$1=0;
      var $248$0 = ((($244$0)>>>0)+((($244$1)|0)*4294967296))+((($247$0)>>>0)+((($247$1)|0)*4294967296))>>>0; var $248$1 = Math.min(Math.floor((((($244$0)>>>0)+((($244$1)|0)*4294967296))+((($247$0)>>>0)+((($247$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $249$0 = ((($248$0)>>>0)+((($248$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $249$1 = Math.min(Math.floor((((($248$0)>>>0)+((($248$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $250=(($3+808)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252$0=$251;
      var $252$1=0;
      var $253$0 = Math.floor(((($249$0)>>>0)+((($249$1)|0)*4294967296))/((($252$0)>>>0)+((($252$1)|0)*4294967296)))>>>0; var $253$1 = Math.min(Math.floor((Math.floor(((($249$0)>>>0)+((($249$1)|0)*4294967296))/((($252$0)>>>0)+((($252$1)|0)*4294967296))))/4294967296), 4294967295);
      var $254$0=$253$0;
      var $254=$254$0;
      var $255=$3;
      var $256=(($255+48)|0);
      var $257=(($256+4)|0);
      HEAP32[(($257)>>2)]=$254;
      var $258=$2;
      var $259=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($258)>>2)]=HEAP32[(($259)>>2)];HEAP32[(($258+4)>>2)]=HEAP32[(($259+4)>>2)];
      __ZN17debug_view_memory14set_cursor_posENS_10cursor_posE($3, $2);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory9recomputeEv["X"]=1;

function __ZN17debug_view_memory4readEhjRy($this, $size, $offs, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $source;
      var $dummyaddr=__stackBase__;
      var $ismapped;
      var $data0=__stackBase__+4;
      var $data1=__stackBase__+12;
      var $ismapped1;
      $2=$this;
      $3=$size;
      $4=$offs;
      $5=$data;
      var $6=$2;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($9);
      $source=$10;
      var $11=$source;
      var $12=(($11+76)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $15
      var $16=$4;
      HEAP32[(($dummyaddr)>>2)]=$16;
      var $17=(($6+803)|0);
      var $18=HEAP8[($17)];
      var $19=(($18) & 1);
      if ($19) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $20
      var $31 = 1;__label__ = 4; break;
    case 3: // $21
      var $22=$source;
      var $23=(($22+80)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$source;
      var $26=(($25+76)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__ZNK13address_space8spacenumEv($27);
      var $29=__ZN23device_memory_interface9translateE16address_spacenumiRj($24, $28, 8, $dummyaddr);
      var $31 = $29;__label__ = 4; break;
    case 4: // $30
      var $31;
      var $32=(($31)&1);
      $ismapped=$32;
      var $33=$5;
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$6$0=(($33)|0);
      HEAP32[(($st$6$0)>>2)]=$$emscripten$temp$0$0;
      var $st$6$1=(($33+4)|0);
      HEAP32[(($st$6$1)>>2)]=$$emscripten$temp$0$1;
      var $34=$ismapped;
      var $35=(($34) & 1);
      if ($35) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $36
      var $37=$3;
      var $38=(($37)&255);
      if ($38 == 1) {
        __label__ = 6; break;
      }
      else if ($38 == 2) {
        __label__ = 7; break;
      }
      else if ($38 == 4) {
        __label__ = 8; break;
      }
      else if ($38 == 8) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 6: // $39
      var $40=$source;
      var $41=(($40+76)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$4;
      var $44=(($6+803)|0);
      var $45=HEAP8[($44)];
      var $46=(($45) & 1);
      var $47=$46 ^ 1;
      var $48=(($47)&1);
      var $49=__Z15debug_read_byteP13address_spaceji($42, $43, $48);
      var $50$0=$49;
      var $50$1=0;
      var $51=$5;
      var $st$13$0=(($51)|0);
      HEAP32[(($st$13$0)>>2)]=$50$0;
      var $st$13$1=(($51+4)|0);
      HEAP32[(($st$13$1)>>2)]=$50$1;
      __label__ = 10; break;
    case 7: // $52
      var $53=$source;
      var $54=(($53+76)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$4;
      var $57=(($6+803)|0);
      var $58=HEAP8[($57)];
      var $59=(($58) & 1);
      var $60=$59 ^ 1;
      var $61=(($60)&1);
      var $62=__Z15debug_read_wordP13address_spaceji($55, $56, $61);
      var $63$0=$62;
      var $63$1=0;
      var $64=$5;
      var $st$13$0=(($64)|0);
      HEAP32[(($st$13$0)>>2)]=$63$0;
      var $st$13$1=(($64+4)|0);
      HEAP32[(($st$13$1)>>2)]=$63$1;
      __label__ = 10; break;
    case 8: // $65
      var $66=$source;
      var $67=(($66+76)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$4;
      var $70=(($6+803)|0);
      var $71=HEAP8[($70)];
      var $72=(($71) & 1);
      var $73=$72 ^ 1;
      var $74=(($73)&1);
      var $75=__Z16debug_read_dwordP13address_spaceji($68, $69, $74);
      var $76$0=$75;
      var $76$1=0;
      var $77=$5;
      var $st$13$0=(($77)|0);
      HEAP32[(($st$13$0)>>2)]=$76$0;
      var $st$13$1=(($77+4)|0);
      HEAP32[(($st$13$1)>>2)]=$76$1;
      __label__ = 10; break;
    case 9: // $78
      var $79=$source;
      var $80=(($79+76)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$4;
      var $83=(($6+803)|0);
      var $84=HEAP8[($83)];
      var $85=(($84) & 1);
      var $86=$85 ^ 1;
      var $87=(($86)&1);
      var $88=__Z16debug_read_qwordP13address_spaceji($81, $82, $87);
      var $88$0=$88[0];
      var $88$1=$88[1];
      var $89=$5;
      var $st$13$0=(($89)|0);
      HEAP32[(($st$13$0)>>2)]=$88$0;
      var $st$13$1=(($89+4)|0);
      HEAP32[(($st$13$1)>>2)]=$88$1;
      __label__ = 10; break;
    case 10: // $90
      __label__ = 11; break;
    case 11: // $91
      var $92=$ismapped;
      var $93=(($92) & 1);
      $1=$93;
      __label__ = 20; break;
    case 12: // $94
      var $95=$3;
      var $96=(($95)&255);
      var $97=(($96)|0) > 1;
      if ($97) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $98
      var $99=$3;
      var $100=(($99)&255);
      var $101=(((($100)|0)/2)|0);
      var $102=(($101) & 255);
      $3=$102;
      var $103=$3;
      var $104=$4;
      var $105=$3;
      var $106=(($105)&255);
      var $107=((0)|0);
      var $108=(($104+$107)|0);
      var $109=__ZN17debug_view_memory4readEhjRy($6, $103, $108, $data0);
      var $110=(($109)&1);
      $ismapped1=$110;
      var $111=$3;
      var $112=$4;
      var $113=$3;
      var $114=(($113)&255);
      var $115=(($114)|0);
      var $116=(($112+$115)|0);
      var $117=__ZN17debug_view_memory4readEhjRy($6, $111, $116, $data1);
      var $118=(($117)&1);
      var $119=$ismapped1;
      var $120=(($119) & 1);
      var $121=(($120)&1);
      var $122=$121 | $118;
      var $123=(($122)|0)!=0;
      var $124=(($123)&1);
      $ismapped1=$124;
      var $125=$source;
      var $126=(($125+96)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0)==0;
      if ($128) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $129
      var $st$0$0=(($data0)|0);
      var $130$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($data0+4)|0);
      var $130$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($data1)|0);
      var $131$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($data1+4)|0);
      var $131$1=HEAP32[(($st$4$1)>>2)];
      var $132=$3;
      var $133=(($132)&255);
      var $134=((($133<<3))|0);
      var $135$0=$134;
      var $135$1=0;
      var $136=Runtime.bitshift64($131$0, $131$1,"shl",$135$0);var $136$0 = $136[0], $136$1 = $136[1];
      var $137$0=$130$0 | $136$0;
      var $137$1=$130$1 | $136$1;
      var $138=$5;
      var $st$17$0=(($138)|0);
      HEAP32[(($st$17$0)>>2)]=$137$0;
      var $st$17$1=(($138+4)|0);
      HEAP32[(($st$17$1)>>2)]=$137$1;
      __label__ = 16; break;
    case 15: // $139
      var $st$0$0=(($data1)|0);
      var $140$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($data1+4)|0);
      var $140$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($data0)|0);
      var $141$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($data0+4)|0);
      var $141$1=HEAP32[(($st$4$1)>>2)];
      var $142=$3;
      var $143=(($142)&255);
      var $144=((($143<<3))|0);
      var $145$0=$144;
      var $145$1=0;
      var $146=Runtime.bitshift64($141$0, $141$1,"shl",$145$0);var $146$0 = $146[0], $146$1 = $146[1];
      var $147$0=$140$0 | $146$0;
      var $147$1=$140$1 | $146$1;
      var $148=$5;
      var $st$17$0=(($148)|0);
      HEAP32[(($st$17$0)>>2)]=$147$0;
      var $st$17$1=(($148+4)|0);
      HEAP32[(($st$17$1)>>2)]=$147$1;
      __label__ = 16; break;
    case 16: // $149
      var $150=$ismapped1;
      var $151=(($150) & 1);
      $1=$151;
      __label__ = 20; break;
    case 17: // $152
      var $153=$source;
      var $154=(($153+92)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$4;
      var $157=$156 ^ $155;
      $4=$157;
      var $158=$4;
      var $159=$source;
      var $160=(($159+88)|0);
      var $161=HEAPU32[(($160)>>2)];
      var $162=(($158)>>>0) >= (($161)>>>0);
      if ($162) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $163
      $1=0;
      __label__ = 20; break;
    case 19: // $164
      var $165=$source;
      var $166=(($165+84)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$4;
      var $169=(($167+$168)|0);
      var $170=HEAP8[($169)];
      var $171$0=$170;
      var $171$1=0;
      var $172=$5;
      var $st$9$0=(($172)|0);
      HEAP32[(($st$9$0)>>2)]=$171$0;
      var $st$9$1=(($172+4)|0);
      HEAP32[(($st$9$1)>>2)]=$171$1;
      $1=1;
      __label__ = 20; break;
    case 20: // $173
      var $174=$1;
      STACKTOP = __stackBase__;
      return $174;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory4readEhjRy["X"]=1;

function __ZN17debug_view_memory9view_charEi($this, $chval) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $pos=__stackBase__;
      var $delta;
      var $delta1;
      var $hexchar;
      var $data=__stackBase__+8;
      var $ismapped;
      var $3=__stackBase__+16;
      $1=$this;
      $2=$chval;
      var $4=$1;
      __ZN17debug_view_memory14get_cursor_posEv($pos, $4);
      var $5=$2;
      if ($5 == 1) {
        __label__ = 1; break;
      }
      else if ($5 == 2) {
        __label__ = 4; break;
      }
      else if ($5 == 5) {
        __label__ = 7; break;
      }
      else if ($5 == 6) {
        __label__ = 14; break;
      }
      else if ($5 == 7) {
        __label__ = 21; break;
      }
      else if ($5 == 8) {
        __label__ = 22; break;
      }
      else if ($5 == 9) {
        __label__ = 23; break;
      }
      else if ($5 == 10) {
        __label__ = 24; break;
      }
      else if ($5 == 12) {
        __label__ = 25; break;
      }
      else if ($5 == 11) {
        __label__ = 28; break;
      }
      else if ($5 == 4) {
        __label__ = 36; break;
      }
      else if ($5 == 3) {
        __label__ = 41; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 1: // $6
      var $7=(($pos)|0);
      var $8=HEAPU32[(($7)>>2)];
      var $9=(($4+812)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($4+808)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($10+$12)|0);
      var $14=(($8)>>>0) >= (($13)>>>0);
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=(($4+808)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($pos)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-$17)|0);
      HEAP32[(($18)>>2)]=$20;
      __label__ = 3; break;
    case 3: // $21
      __label__ = 46; break;
    case 4: // $22
      var $23=(($pos)|0);
      var $24=HEAPU32[(($23)>>2)];
      var $25=(($4+804)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($4+808)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($26-$28)|0);
      var $30=(($24)>>>0) <= (($29)>>>0);
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=(($4+808)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($pos)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+$33)|0);
      HEAP32[(($34)>>2)]=$36;
      __label__ = 6; break;
    case 6: // $37
      __label__ = 46; break;
    case 7: // $38
      var $39=$4;
      var $40=(($39+40)|0);
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42-2)|0);
      var $44=(($4+808)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($43*$45)|0);
      $delta=$46;
      __label__ = 8; break;
    case 8: // $47
      var $48=$delta;
      var $49=(($48)>>>0) > 0;
      if ($49) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $50
      var $51=(($pos)|0);
      var $52=HEAPU32[(($51)>>2)];
      var $53=(($4+812)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$delta;
      var $56=(($54+$55)|0);
      var $57=(($52)>>>0) >= (($56)>>>0);
      if ($57) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $58
      var $59=$delta;
      var $60=(($pos)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61-$59)|0);
      HEAP32[(($60)>>2)]=$62;
      __label__ = 13; break;
    case 11: // $63
      __label__ = 12; break;
    case 12: // $64
      var $65=(($4+808)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$delta;
      var $68=(($67-$66)|0);
      $delta=$68;
      __label__ = 8; break;
    case 13: // $69
      __label__ = 46; break;
    case 14: // $70
      var $71=$4;
      var $72=(($71+40)|0);
      var $73=(($72+4)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74-2)|0);
      var $76=(($4+808)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($75*$77)|0);
      $delta1=$78;
      __label__ = 15; break;
    case 15: // $79
      var $80=$delta1;
      var $81=(($80)>>>0) > 0;
      if ($81) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $82
      var $83=(($pos)|0);
      var $84=HEAPU32[(($83)>>2)];
      var $85=(($4+804)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$delta1;
      var $88=(($86-$87)|0);
      var $89=(($84)>>>0) <= (($88)>>>0);
      if ($89) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $90
      var $91=$delta1;
      var $92=(($pos)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+$91)|0);
      HEAP32[(($92)>>2)]=$94;
      __label__ = 20; break;
    case 18: // $95
      __label__ = 19; break;
    case 19: // $96
      var $97=(($4+808)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$delta1;
      var $100=(($99-$98)|0);
      $delta1=$100;
      __label__ = 15; break;
    case 20: // $101
      __label__ = 46; break;
    case 21: // $102
      var $103=(($pos)|0);
      var $104=HEAPU32[(($103)>>2)];
      var $105=(($4+808)|0);
      var $106=HEAPU32[(($105)>>2)];
      var $107=(($104)>>>0)%(($106)>>>0);
      var $108=(($pos)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109-$107)|0);
      HEAP32[(($108)>>2)]=$110;
      var $111=(($4+800)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=((($113<<3))|0);
      var $115=(($114-4)|0);
      var $116=(($115) & 255);
      var $117=(($pos+4)|0);
      HEAP8[($117)]=$116;
      __label__ = 46; break;
    case 22: // $118
      var $119=(($4+812)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($pos)|0);
      HEAP32[(($121)>>2)]=$120;
      var $122=(($4+800)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=((($124<<3))|0);
      var $126=(($125-4)|0);
      var $127=(($126) & 255);
      var $128=(($pos+4)|0);
      HEAP8[($128)]=$127;
      __label__ = 46; break;
    case 23: // $129
      var $130=(($4+808)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($pos)|0);
      var $133=HEAPU32[(($132)>>2)];
      var $134=(($4+808)|0);
      var $135=HEAPU32[(($134)>>2)];
      var $136=(($133)>>>0)%(($135)>>>0);
      var $137=(($131-$136)|0);
      var $138=(($137-1)|0);
      var $139=(($pos)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+$138)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=(($pos+4)|0);
      HEAP8[($142)]=0;
      __label__ = 46; break;
    case 24: // $143
      var $144=(($4+804)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($pos)|0);
      HEAP32[(($146)>>2)]=$145;
      var $147=(($pos+4)|0);
      HEAP8[($147)]=0;
      __label__ = 46; break;
    case 25: // $148
      var $149=(($pos)|0);
      var $150=HEAPU32[(($149)>>2)];
      var $151=(($4+812)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($4+800)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $156=(($152+$155)|0);
      var $157=(($150)>>>0) >= (($156)>>>0);
      if ($157) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $158
      var $159=(($4+800)|0);
      var $160=HEAPU8[($159)];
      var $161=(($160)&255);
      var $162=(($pos)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163-$161)|0);
      HEAP32[(($162)>>2)]=$164;
      __label__ = 27; break;
    case 27: // $165
      __label__ = 46; break;
    case 28: // $166
      var $167=(($pos)|0);
      var $168=HEAPU32[(($167)>>2)];
      var $169=(($4+804)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($4+800)|0);
      var $172=HEAPU8[($171)];
      var $173=(($172)&255);
      var $174=(($170-$173)|0);
      var $175=(($168)>>>0) <= (($174)>>>0);
      if ($175) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $176
      var $177=(($4+800)|0);
      var $178=HEAPU8[($177)];
      var $179=(($178)&255);
      var $180=(($pos)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=(($181+$179)|0);
      HEAP32[(($180)>>2)]=$182;
      __label__ = 30; break;
    case 30: // $183
      __label__ = 46; break;
    case 31: // $184
      var $185=$2;
      var $186=_tolower($185);
      var $187=_strchr(((STRING_TABLE.__ZZN17debug_view_memory9view_charEiE7hexvals)|0), $186);
      $hexchar=$187;
      var $188=$hexchar;
      var $189=(($188)|0)==0;
      if ($189) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $190
      __label__ = 46; break;
    case 33: // $191
      var $192=(($4+800)|0);
      var $193=HEAP8[($192)];
      var $194=(($pos)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=__ZN17debug_view_memory4readEhjRy($4, $193, $195, $data);
      var $197=(($196)&1);
      $ismapped=$197;
      var $198=$ismapped;
      var $199=(($198) & 1);
      if ($199) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $200
      __label__ = 46; break;
    case 35: // $201
      var $202=(($pos+4)|0);
      var $203=HEAPU8[($202)];
      var $204=(($203)&255);
      var $205$0=$204;
      var $205$1=0;
      var $$emscripten$temp$0$0=15;
      var $$emscripten$temp$0$1=0;
      var $206=Runtime.bitshift64($$emscripten$temp$0$0, $$emscripten$temp$0$1,"shl",$205$0);var $206$0 = $206[0], $206$1 = $206[1];
      var $$emscripten$temp$1$0=-1;
      var $$emscripten$temp$1$1=-1;
      var $207$0=$206$0 ^ $$emscripten$temp$1$0;
      var $207$1=$206$1 ^ $$emscripten$temp$1$1;
      var $st$12$0=(($data)|0);
      var $208$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($data+4)|0);
      var $208$1=HEAP32[(($st$12$1)>>2)];
      var $209$0=$208$0 & $207$0;
      var $209$1=$208$1 & $207$1;
      var $st$18$0=(($data)|0);
      HEAP32[(($st$18$0)>>2)]=$209$0;
      var $st$18$1=(($data+4)|0);
      HEAP32[(($st$18$1)>>2)]=$209$1;
      var $210=$hexchar;
      var $211=$210;
      var $212=(($211-((STRING_TABLE.__ZZN17debug_view_memory9view_charEiE7hexvals)))|0);
      var $213$0=$212;
      var $213$1=(($212|0) < 0 ? -1 : 0);
      var $214=(($pos+4)|0);
      var $215=HEAPU8[($214)];
      var $216=(($215)&255);
      var $217$0=$216;
      var $217$1=0;
      var $218=Runtime.bitshift64($213$0, $213$1,"shl",$217$0);var $218$0 = $218[0], $218$1 = $218[1];
      var $st$33$0=(($data)|0);
      var $219$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($data+4)|0);
      var $219$1=HEAP32[(($st$33$1)>>2)];
      var $220$0=$219$0 | $218$0;
      var $220$1=$219$1 | $218$1;
      var $st$39$0=(($data)|0);
      HEAP32[(($st$39$0)>>2)]=$220$0;
      var $st$39$1=(($data+4)|0);
      HEAP32[(($st$39$1)>>2)]=$220$1;
      var $221=(($4+800)|0);
      var $222=HEAP8[($221)];
      var $223=(($pos)|0);
      var $224=HEAP32[(($223)>>2)];
      var $st$47$0=(($data)|0);
      var $225$0=HEAP32[(($st$47$0)>>2)];
      var $st$47$1=(($data+4)|0);
      var $225$1=HEAP32[(($st$47$1)>>2)];
      __ZN17debug_view_memory5writeEhjy($4, $222, $224, $225$0, $225$1);
      __label__ = 36; break;
    case 36: // $226
      var $227=(($pos+4)|0);
      var $228=HEAPU8[($227)];
      var $229=(($228)&255);
      var $230=(($229)|0)==0;
      if ($230) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $231
      var $232=(($pos)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($4+804)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($233)|0)!=(($235)|0);
      if ($236) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $237
      var $238=(($4+800)|0);
      var $239=HEAPU8[($238)];
      var $240=(($239)&255);
      var $241=((($240<<3))|0);
      var $242=(($241-4)|0);
      var $243=(($242) & 255);
      var $244=(($pos+4)|0);
      HEAP8[($244)]=$243;
      var $245=(($4+800)|0);
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=(($pos)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(($249+$247)|0);
      HEAP32[(($248)>>2)]=$250;
      __label__ = 40; break;
    case 39: // $251
      var $252=(($pos+4)|0);
      var $253=HEAPU8[($252)];
      var $254=(($253)&255);
      var $255=(($254-4)|0);
      var $256=(($255) & 255);
      HEAP8[($252)]=$256;
      __label__ = 40; break;
    case 40: // $257
      __label__ = 46; break;
    case 41: // $258
      var $259=(($pos+4)|0);
      var $260=HEAPU8[($259)];
      var $261=(($260)&255);
      var $262=(($4+800)|0);
      var $263=HEAPU8[($262)];
      var $264=(($263)&255);
      var $265=((($264<<3))|0);
      var $266=(($265-4)|0);
      var $267=(($261)|0)==(($266)|0);
      if ($267) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $268
      var $269=(($pos)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($4+812)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($270)|0)!=(($272)|0);
      if ($273) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $274
      var $275=(($pos+4)|0);
      HEAP8[($275)]=0;
      var $276=(($4+800)|0);
      var $277=HEAPU8[($276)];
      var $278=(($277)&255);
      var $279=(($pos)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=(($280-$278)|0);
      HEAP32[(($279)>>2)]=$281;
      __label__ = 45; break;
    case 44: // $282
      var $283=(($pos+4)|0);
      var $284=HEAPU8[($283)];
      var $285=(($284)&255);
      var $286=(($285+4)|0);
      var $287=(($286) & 255);
      HEAP8[($283)]=$287;
      __label__ = 45; break;
    case 45: // $288
      __label__ = 46; break;
    case 46: // $289
      var $290=$4;
      __ZN10debug_view12begin_updateEv($290);
      var $291=$3;
      var $292=$pos;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($291)>>2)]=HEAP32[(($292)>>2)];HEAP32[(($291+4)>>2)]=HEAP32[(($292+4)>>2)];
      __ZN17debug_view_memory14set_cursor_posENS_10cursor_posE($4, $3);
      var $293=$4;
      var $294=(($293+76)|0);
      HEAP8[($294)]=1;
      var $295=$4;
      __ZN10debug_view10end_updateEv($295);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory9view_charEi["X"]=1;

function __ZN17debug_view_memory5writeEhjy($this, $size, $offs, $data$0, $data$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $source;
      $1=$this;
      $2=$size;
      $3=$offs;
      var $st$8$0=(($4)|0);
      HEAP32[(($st$8$0)>>2)]=$data$0;
      var $st$8$1=(($4+4)|0);
      HEAP32[(($st$8$1)>>2)]=$data$1;
      var $5=$1;
      var $6=$5;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_($8);
      $source=$9;
      var $10=$source;
      var $11=(($10+76)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $14
      var $15=$2;
      var $16=(($15)&255);
      if ($16 == 1) {
        __label__ = 2; break;
      }
      else if ($16 == 2) {
        __label__ = 3; break;
      }
      else if ($16 == 4) {
        __label__ = 4; break;
      }
      else if ($16 == 8) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 2: // $17
      var $18=$source;
      var $19=(($18+76)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$3;
      var $st$4$0=(($4)|0);
      var $22$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($4+4)|0);
      var $22$1=HEAP32[(($st$4$1)>>2)];
      var $23$0=$22$0;
      var $23=$23$0&255;
      var $24=(($5+803)|0);
      var $25=HEAP8[($24)];
      var $26=(($25) & 1);
      var $27=$26 ^ 1;
      var $28=(($27)&1);
      __Z16debug_write_byteP13address_spacejhi($20, $21, $23, $28);
      __label__ = 6; break;
    case 3: // $29
      var $30=$source;
      var $31=(($30+76)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$3;
      var $st$4$0=(($4)|0);
      var $34$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($4+4)|0);
      var $34$1=HEAP32[(($st$4$1)>>2)];
      var $35$0=$34$0;
      var $35=$35$0&65535;
      var $36=(($5+803)|0);
      var $37=HEAP8[($36)];
      var $38=(($37) & 1);
      var $39=$38 ^ 1;
      var $40=(($39)&1);
      __Z16debug_write_wordP13address_spacejti($32, $33, $35, $40);
      __label__ = 6; break;
    case 4: // $41
      var $42=$source;
      var $43=(($42+76)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$3;
      var $st$4$0=(($4)|0);
      var $46$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($4+4)|0);
      var $46$1=HEAP32[(($st$4$1)>>2)];
      var $47$0=$46$0;
      var $47=$47$0;
      var $48=(($5+803)|0);
      var $49=HEAP8[($48)];
      var $50=(($49) & 1);
      var $51=$50 ^ 1;
      var $52=(($51)&1);
      __Z17debug_write_dwordP13address_spacejji($44, $45, $47, $52);
      __label__ = 6; break;
    case 5: // $53
      var $54=$source;
      var $55=(($54+76)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$3;
      var $st$4$0=(($4)|0);
      var $58$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($4+4)|0);
      var $58$1=HEAP32[(($st$4$1)>>2)];
      var $59=(($5+803)|0);
      var $60=HEAP8[($59)];
      var $61=(($60) & 1);
      var $62=$61 ^ 1;
      var $63=(($62)&1);
      __Z17debug_write_qwordP13address_spacejyi($56, $57, $58$0, $58$1, $63);
      __label__ = 6; break;
    case 6: // $64
      __label__ = 15; break;
    case 7: // $65
      var $66=$2;
      var $67=(($66)&255);
      var $68=(($67)|0) > 1;
      if ($68) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $69
      var $70=$2;
      var $71=(($70)&255);
      var $72=(((($71)|0)/2)|0);
      var $73=(($72) & 255);
      $2=$73;
      var $74=$source;
      var $75=(($74+96)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $78
      var $79=$2;
      var $80=$3;
      var $81=$2;
      var $82=(($81)&255);
      var $83=((0)|0);
      var $84=(($80+$83)|0);
      var $st$6$0=(($4)|0);
      var $85$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $85$1=HEAP32[(($st$6$1)>>2)];
      __ZN17debug_view_memory5writeEhjy($5, $79, $84, $85$0, $85$1);
      var $86=$2;
      var $87=$3;
      var $88=$2;
      var $89=(($88)&255);
      var $90=(($89)|0);
      var $91=(($87+$90)|0);
      var $st$17$0=(($4)|0);
      var $92$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($4+4)|0);
      var $92$1=HEAP32[(($st$17$1)>>2)];
      var $93=$2;
      var $94=(($93)&255);
      var $95=((($94<<3))|0);
      var $96$0=$95;
      var $96$1=0;
      var $97=Runtime.bitshift64($92$0, $92$1,"lshr",$96$0);var $97$0 = $97[0], $97$1 = $97[1];
      __ZN17debug_view_memory5writeEhjy($5, $86, $91, $97$0, $97$1);
      __label__ = 11; break;
    case 10: // $98
      var $99=$2;
      var $100=$3;
      var $101=$2;
      var $102=(($101)&255);
      var $103=(($102)|0);
      var $104=(($100+$103)|0);
      var $st$6$0=(($4)|0);
      var $105$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($4+4)|0);
      var $105$1=HEAP32[(($st$6$1)>>2)];
      __ZN17debug_view_memory5writeEhjy($5, $99, $104, $105$0, $105$1);
      var $106=$2;
      var $107=$3;
      var $108=$2;
      var $109=(($108)&255);
      var $110=((0)|0);
      var $111=(($107+$110)|0);
      var $st$17$0=(($4)|0);
      var $112$0=HEAP32[(($st$17$0)>>2)];
      var $st$17$1=(($4+4)|0);
      var $112$1=HEAP32[(($st$17$1)>>2)];
      var $113=$2;
      var $114=(($113)&255);
      var $115=((($114<<3))|0);
      var $116$0=$115;
      var $116$1=0;
      var $117=Runtime.bitshift64($112$0, $112$1,"lshr",$116$0);var $117$0 = $117[0], $117$1 = $117[1];
      __ZN17debug_view_memory5writeEhjy($5, $106, $111, $117$0, $117$1);
      __label__ = 11; break;
    case 11: // $118
      __label__ = 15; break;
    case 12: // $119
      var $120=$source;
      var $121=(($120+92)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$3;
      var $124=$123 ^ $122;
      $3=$124;
      var $125=$3;
      var $126=$source;
      var $127=(($126+88)|0);
      var $128=HEAPU32[(($127)>>2)];
      var $129=(($125)>>>0) >= (($128)>>>0);
      if ($129) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $130
      __label__ = 15; break;
    case 14: // $131
      var $st$0$0=(($4)|0);
      var $132$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $132$1=HEAP32[(($st$0$1)>>2)];
      var $133$0=$132$0;
      var $133=$133$0&255;
      var $134=$source;
      var $135=(($134+84)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=$3;
      var $138=(($136+$137)|0);
      HEAP8[($138)]=$133;
      __label__ = 15; break;
    case 15: // $139
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memory5writeEhjy["X"]=1;

function __ZN17debug_view_memory10cursor_posC1Ejh($this, $address, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$shift;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN17debug_view_memory10cursor_posC2Ejh($4, $5, $6);
  ;
  return;
}


function __ZN17debug_view_memory14set_expressionEPKc($this, $expression) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$expression;
  var $3=$1;
  var $4=$3;
  __ZN10debug_view12begin_updateEv($4);
  var $5=(($3+92)|0);
  var $6=$2;
  __ZN21debug_view_expression10set_stringEPKc($5, $6);
  var $7=$3;
  var $8=(($7+76)|0);
  HEAP8[($8)]=1;
  var $9=$3;
  var $10=(($9+74)|0);
  HEAP8[($10)]=1;
  var $11=$3;
  __ZN10debug_view10end_updateEv($11);
  ;
  return;
}


function __ZN17debug_view_memoryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN17debug_view_memoryD2Ev($2);
  ;
  return;
}


function __ZN24debug_view_memory_sourceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN24debug_view_memory_sourceD2Ev($2);
  ;
  return;
}


function __ZN24debug_view_memory_sourceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN17debug_view_sourceD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI24debug_view_memory_sourceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI24debug_view_memory_sourceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI24debug_view_memory_sourceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 104);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI24debug_view_memory_sourceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI24debug_view_memory_sourceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI24debug_view_memory_sourceED2Ev($2);
  ;
  return;
}


function __ZN17debug_view_memoryD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN17debug_view_memoryD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN17debug_view_memoryD0Ev["X"]=1;

function __ZN24debug_view_memory_sourceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN24debug_view_memory_sourceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN24debug_view_memory_sourceD0Ev["X"]=1;

function __ZN17debug_view_memory10cursor_posC2Ejh($this, $address, $shift) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$address;
  $3=$shift;
  var $4=$1;
  var $5=(($4)|0);
  var $6=$2;
  HEAP32[(($5)>>2)]=$6;
  var $7=(($4+4)|0);
  var $8=$3;
  HEAP8[($7)]=$8;
  ;
  return;
}


function __ZL12ppi0_portb_rP8device_tj($device, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$device;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK8device_t5ownerEv($3);
  var $5=__Z21ldcore_get_safe_tokenP8device_t($4);
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+16)|0);
  var $10=HEAP8[($9)];
  ;
  return $10;
}


function __ZL12ppi0_portc_rP8device_tj($device, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $result;
      $1=$device;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK8device_t5ownerEv($3);
      var $5=__Z21ldcore_get_safe_tokenP8device_t($4);
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      $result=0;
      var $9=$player;
      var $10=(($9+14)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$result;
      var $15=(($14)&255);
      var $16=$15 | 16;
      var $17=(($16) & 255);
      $result=$17;
      __label__ = 2; break;
    case 2: // $18
      var $19=$player;
      var $20=(($19+83)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $23
      var $24=$result;
      var $25=(($24)&255);
      var $26=$25 | 32;
      var $27=(($26) & 255);
      $result=$27;
      __label__ = 4; break;
    case 4: // $28
      var $29=$result;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12ppi0_porta_wP8device_tjh($device, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$device;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$3;
  var $8=$ld;
  var $9=(($8+12)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=(($10+15)|0);
  HEAP8[($11)]=$7;
  ;
  return;
}


function __ZL12ppi0_portc_wP8device_tjh($device, $offset, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $prev;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      $1=$device;
      $2=$offset;
      $3=$data;
      var $6=$1;
      var $7=__ZNK8device_t5ownerEv($6);
      var $8=__Z21ldcore_get_safe_tokenP8device_t($7);
      $ld=$8;
      var $9=$ld;
      var $10=(($9+12)|0);
      var $11=HEAP32[(($10)>>2)];
      $player=$11;
      var $12=$player;
      var $13=(($12+17)|0);
      var $14=HEAP8[($13)];
      $prev=$14;
      var $15=$3;
      var $16=$player;
      var $17=(($16+17)|0);
      HEAP8[($17)]=$15;
      var $18=$3;
      var $19=(($18)&255);
      var $20=$19 & 1;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $22
      var $23=$prev;
      var $24=(($23)&255);
      var $25=$24 & 1;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $27
      var $28=$player;
      var $29=(($28+15)|0);
      var $30=HEAP8[($29)];
      var $31=$player;
      var $32=(($31+16)|0);
      HEAP8[($32)]=$30;
      __label__ = 3; break;
    case 3: // $33
      var $34=$3;
      var $35=(($34)&255);
      var $36=$35 & 2;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 6; break; } else { __label__ = 4; break; }
    case 4: // $38
      var $39=$prev;
      var $40=(($39)&255);
      var $41=$40 & 2;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $43
      var $44=$player;
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $$emscripten$temp$0$0=50;
      var $$emscripten$temp$0$1=0;
      __ZN8attotime9from_usecEx($4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $47=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($47)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($47+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($47+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN12timer_device6adjustE8attotimeiS0_($46, $4, 0, $5);
      __label__ = 6; break;
    case 6: // $48
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12ppi0_portc_wP8device_tjh["X"]=1;

function __ZL12ppi1_porta_rP8device_tj($device, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $sliderpos;
      var $focus_on;
      var $spdl_on;
      var $result;
      $1=$device;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK8device_t5ownerEv($3);
      var $5=__Z21ldcore_get_safe_tokenP8device_t($4);
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      var $9=$ld;
      var $10=__Z26ldcore_get_slider_positionP16_laserdisc_state($9);
      $sliderpos=$10;
      var $11=$player;
      var $12=(($11+18)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & 1;
      var $16=(($15)|0)!=0;
      var $17=$16 ^ 1;
      var $18=(($17)&1);
      $focus_on=$18;
      var $19=$player;
      var $20=(($19+18)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$22 & 2;
      var $24=(($23)|0)!=0;
      var $25=$24 ^ 1;
      var $26=(($25)&1);
      $spdl_on=$26;
      $result=0;
      var $27=$focus_on;
      var $28=(($27 << 24) >> 24)!=0;
      if ($28) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $29
      var $30=$result;
      var $31=(($30)&255);
      var $32=$31 | 1;
      var $33=(($32) & 255);
      $result=$33;
      __label__ = 2; break;
    case 2: // $34
      var $35=$spdl_on;
      var $36=(($35 << 24) >> 24)!=0;
      if ($36) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $37
      var $38=$result;
      var $39=(($38)&255);
      var $40=$39 | 2;
      var $41=(($40) & 255);
      $result=$41;
      __label__ = 4; break;
    case 4: // $42
      var $43=$sliderpos;
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$result;
      var $47=(($46)&255);
      var $48=$47 | 4;
      var $49=(($48) & 255);
      $result=$49;
      __label__ = 6; break;
    case 6: // $50
      var $51=$sliderpos;
      var $52=(($51)|0)==5;
      if ($52) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $53
      var $54=$result;
      var $55=(($54)&255);
      var $56=$55 | 8;
      var $57=(($56) & 255);
      $result=$57;
      __label__ = 8; break;
    case 8: // $58
      var $59=$result;
      var $60=(($59)&255);
      var $61=$60 | 32;
      var $62=(($61) & 255);
      $result=$62;
      var $63=$result;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12ppi1_porta_rP8device_tj["X"]=1;

function __ZL12ppi1_portb_wP8device_tjh($device, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $prev;
      var $direction;
      var $delta;
      $1=$device;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      var $10=$player;
      var $11=(($10+18)|0);
      var $12=HEAP8[($11)];
      $prev=$12;
      var $13=$3;
      var $14=$player;
      var $15=(($14+18)|0);
      HEAP8[($15)]=$13;
      var $16=$3;
      var $17=(($16)&255);
      var $18=$17 & 32;
      var $19=(($18)|0)!=0;
      var $20=$19 ? 1 : -1;
      $direction=$20;
      var $21=$3;
      var $22=(($21)&255);
      var $23=$22 & 4;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $25
      var $26=$prev;
      var $27=(($26)&255);
      var $28=$27 & 4;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $30
      var $31=$ld;
      var $32=$direction;
      __Z21ldcore_advance_sliderP16_laserdisc_statei($31, $32);
      __label__ = 3; break;
    case 3: // $33
      var $34=$3;
      var $35=(($34)&255);
      var $36=$35 & 8;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $38
      var $39=$3;
      var $40=(($39)&255);
      var $41=$40 & 16;
      var $42=(($41)|0)!=0;
      var $43=$42 ? 66 : 133;
      $delta=$43;
      var $44=$ld;
      var $45=$delta;
      var $46=$direction;
      var $47=(($45*$46)|0);
      __Z23ldcore_set_slider_speedP16_laserdisc_statei($44, $47);
      __label__ = 6; break;
    case 5: // $48
      var $49=$ld;
      __Z23ldcore_set_slider_speedP16_laserdisc_statei($49, 0);
      __label__ = 6; break;
    case 6: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12ppi1_portb_wP8device_tjh["X"]=1;

function __ZL12ppi1_portc_wP8device_tjh($device, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $prev;
      $1=$device;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      var $10=$player;
      var $11=(($10+19)|0);
      var $12=HEAP8[($11)];
      $prev=$12;
      var $13=$3;
      var $14=$player;
      var $15=(($14+19)|0);
      HEAP8[($15)]=$13;
      var $16=$ld;
      var $17=$3;
      var $18=(($17)&255);
      var $19=$18 & 8;
      var $20=(($19)|0)==0;
      var $21=(($20)&1);
      __Z24ldcore_set_video_squelchP16_laserdisc_stateh($16, $21);
      var $22=$ld;
      var $23=$3;
      var $24=(($23)&255);
      var $25=$24 & 4;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 1; break; } else { var $34 = 1;__label__ = 2; break; }
    case 1: // $27
      var $28=$3;
      var $29=(($28)&255);
      var $30=$29 & 1;
      var $31=(($30)|0)!=0;
      var $32=$31 ^ 1;
      var $34 = $32;__label__ = 2; break;
    case 2: // $33
      var $34;
      var $35=(($34)&1);
      var $36=$3;
      var $37=(($36)&255);
      var $38=$37 & 4;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 3; break; } else { var $47 = 1;__label__ = 4; break; }
    case 3: // $40
      var $41=$3;
      var $42=(($41)&255);
      var $43=$42 & 2;
      var $44=(($43)|0)!=0;
      var $45=$44 ^ 1;
      var $47 = $45;__label__ = 4; break;
    case 4: // $46
      var $47;
      var $48=(($47)&1);
      __Z24ldcore_set_audio_squelchP16_laserdisc_statehh($22, $35, $48);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12ppi1_portc_wP8device_tjh["X"]=1;

function __ZL13ctc_interruptP8device_ti($device, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      $1=$device;
      $2=$state;
      var $3=$1;
      var $4=__ZNK8device_t5ownerEv($3);
      var $5=__Z21ldcore_get_safe_tokenP8device_t($4);
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$ld;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=(($18)|0)!=0;
      var $20=$19 ? 1 : 0;
      __Z21device_set_input_lineP8device_tii($17, 0, $20);
      __label__ = 2; break;
    case 2: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13ldv1000_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $sliderpos;
  var $player;
  var $4=__stackBase__;
  var $5=__stackBase__+12;
  var $6=__stackBase__+24;
  var $7=__stackBase__+36;
  var $8=__stackBase__+48;
  $1=$ld;
  $2=$vbi;
  $3=$fieldnum;
  var $9=$1;
  var $10=__Z26ldcore_get_slider_positionP16_laserdisc_state($9);
  $sliderpos=$10;
  var $11=$1;
  var $12=(($11+12)|0);
  var $13=HEAP32[(($12)>>2)];
  $player=$13;
  var $14=$player;
  var $15=(($14+4)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=$sliderpos;
  var $18=(($17)|0)==0;
  var $19=(($18)&1);
  __Z13z80ctc_trg1_wP8device_ti($16, $19);
  var $20=$player;
  var $21=(($20+4)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$sliderpos;
  var $24=(($23)|0)==5;
  var $25=(($24)&1);
  __Z13z80ctc_trg2_wP8device_ti($22, $25);
  var $26=$player;
  var $27=(($26+14)|0);
  HEAP8[($27)]=1;
  var $28=$1;
  var $29=(($28)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=__ZNK8device_t7machineEv($30);
  var $32=__ZN15running_machine9schedulerEv($31);
  var $33=$1;
  var $34=(($33+4)|0);
  var $35=HEAP32[(($34)>>2)];
  __ZNK13screen_device11scan_periodEv($5, $35);
  __ZmlRK8attotimej($4, $5, 4);
  var $36=$1;
  var $37=$36;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($32, $4, 1316, ((STRING_TABLE.__str145872)|0), 0, $37);
  var $38=$1;
  var $39=(($38)|0);
  var $40=HEAP32[(($39)>>2)];
  var $41=__ZNK8device_t7machineEv($40);
  var $42=__ZN15running_machine9schedulerEv($41);
  var $43=$1;
  var $44=(($43+4)|0);
  var $45=HEAP32[(($44)>>2)];
  __ZNK13screen_device14time_until_posEii($6, $45, 38, 0);
  var $46=$1;
  var $47=$46;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($42, $6, 1318, ((STRING_TABLE.__str155873)|0), 0, $47);
  var $48=$1;
  var $49=(($48)|0);
  var $50=HEAP32[(($49)>>2)];
  var $51=__ZNK8device_t7machineEv($50);
  var $52=__ZN15running_machine9schedulerEv($51);
  var $53=$7;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($53)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($53+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($53+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
  var $$emscripten$temp$0$0=1;
  var $$emscripten$temp$0$1=0;
  __ZN8attotime9from_msecEx($8, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  __ZN16device_scheduler16boost_interleaveE8attotimeS0_($52, $7, $8);
  STACKTOP = __stackBase__;
  return;
}
__ZL13ldv1000_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime["X"]=1;

function __ZN20resource_pool_objectI24debug_view_memory_sourceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI24debug_view_memory_sourceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI24debug_view_memory_sourceED0Ev["X"]=1;

function __ZN20resource_pool_objectI24debug_view_memory_sourceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI24debug_view_memory_sourceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN17debug_view_memoryD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV17debug_view_memory+8)|0);
      var $6=(($4+816)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=(($4+92)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionD1Ev]($8) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$4;
      __ZN10debug_viewD2Ev($10);
      ;
      return;
    case 3: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $2=$13;
      var $14=$12.f1;
      $3=$14;
      var $15=(($4+92)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21debug_view_expressionD1Ev]($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 4: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $2=$18;
      var $19=$17.f1;
      $3=$19;
      __label__ = 6; break;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$4;
      (function() { try { __THREW__ = false; return __ZN10debug_viewD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$2;
      var $26=$2;
      var $27=$3;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL32construct_machine_config_ldv1000R14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      var $10=$2;
      var $11=$3;
      var $12=HEAP32[((_Z80)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($10, $11, ((STRING_TABLE.__str95865)|0), $12, 2500000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 16; break; };
    case 4: // $14
      $device=$13;
      var $15=$device;
      (function() { try { __THREW__ = false; return __ZN8device_t24static_set_static_configERS_PKv($15, __ZL11daisy_chain) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 16; break; }
    case 5: // $16
      var $17=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($17, 0, 1310) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 16; break; }
    case 6: // $18
      var $19=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($19, 2, 1312) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $20
      var $21=$2;
      var $22=$3;
      var $23=HEAP32[((_Z80CTC)>>2)];
      var $24=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($21, $22, ((STRING_TABLE.__str85864)|0), $23, 2500000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 16; break; };
    case 8: // $25
      $device=$24;
      var $26=$device;
      (function() { try { __THREW__ = false; return __ZN8device_t24static_set_static_configERS_PKv($26, ((__ZL7ctcintf)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 16; break; }
    case 9: // $27
      var $28=$2;
      var $29=$3;
      var $30=HEAP32[((_PPI8255)>>2)];
      var $31=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($28, $29, ((STRING_TABLE.__str175875)|0), $30, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 16; break; };
    case 10: // $32
      $device=$31;
      var $33=$device;
      (function() { try { __THREW__ = false; return __ZN8device_t24static_set_static_configERS_PKv($33, __ZL8ppi0intf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $34
      var $35=$2;
      var $36=$3;
      var $37=HEAP32[((_PPI8255)>>2)];
      var $38=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($35, $36, ((STRING_TABLE.__str185876)|0), $37, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 16; break; };
    case 12: // $39
      $device=$38;
      var $40=$device;
      (function() { try { __THREW__ = false; return __ZN8device_t24static_set_static_configERS_PKv($40, __ZL8ppi1intf) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $41
      var $42=$2;
      var $43=$3;
      var $44=HEAP32[((_TIMER)>>2)];
      var $45=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($42, $43, ((STRING_TABLE.__str165874)|0), $44, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $46
      $device=$45;
      var $47=$device;
      (function() { try { __THREW__ = false; return __ZN12timer_device24static_configure_genericER8device_tPFvRS_PviE($47, 1314) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $48
      var $49=$3;
      $1=$49;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $50=$1;
      STACKTOP = __stackBase__;
      return $50;
    case 16: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $4=$53;
      var $54=$52.f1;
      $5=$54;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $55
      __label__ = 18; break;
    case 18: // $56
      var $57=$4;
      var $58=$4;
      var $59=$5;
      var $60=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $58, tempValue);
      var $61=($60.f1 = $59, $60);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL32construct_machine_config_ldv1000R14machine_configP8device_t["X"]=1;

function __ZL12ldv1000_initP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tempstring=__stackBase__;
      var $player;
      var $2;
      var $3;
      $1=$ld;
      __ZN7astringC1Ev($tempstring);
      var $4=$1;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      $player=$6;
      var $7=$player;
      var $8=$7;
      _memset($8, 0, 88, 1);
      var $9=$1;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($11, ((STRING_TABLE.__str95865)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $13
      var $14=$player;
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$12;
      var $16=$1;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($18, ((STRING_TABLE.__str85864)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $20
      var $21=$player;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$19;
      var $23=$1;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($25, ((STRING_TABLE.__str165874)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 6; break; };
    case 3: // $27
      var $28=(function() { try { __THREW__ = false; return __Z8downcastIP12timer_device8device_tET_PT0_($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $29
      var $30=$player;
      var $31=(($30+8)|0);
      HEAP32[(($31)>>2)]=$28;
      var $32=$player;
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$1;
      var $36=$35;
      (function() { try { __THREW__ = false; return __ZN12timer_device7set_ptrEPv($34, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $37
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 6: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $2=$40;
      var $41=$39.f1;
      $3=$41;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      var $44=$2;
      var $45=$2;
      var $46=$3;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12ldv1000_initP16_laserdisc_state["X"]=1;

function __ZL14ldv1000_updateP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$ld;
  $2=$vbi;
  $3=$fieldnum;
  var $4=$3;
  STACKTOP = __stackBase__;
  return $4;
}


function __Z8downcastIP12timer_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14ldv1000_data_wP16_laserdisc_statehh($ld, $prev, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$ld;
  $2=$prev;
  $3=$data;
  var $4=$3;
  var $5=$1;
  var $6=(($5+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+12)|0);
  HEAP8[($8)]=$4;
  ;
  return;
}


function __ZL16ldv1000_status_rP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+13)|0);
  var $6=HEAP8[($5)];
  ;
  return $6;
}


function __ZL23ldv1000_status_strobe_rP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+19)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$7 & 32;
  var $9=(($8)|0)!=0;
  var $10=$9 ? 1 : 0;
  var $11=(($10) & 255);
  ;
  return $11;
}


function __ZL24ldv1000_command_strobe_rP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+19)|0);
  var $6=HEAPU8[($5)];
  var $7=(($6)&255);
  var $8=$7 & 16;
  var $9=(($8)|0)!=0;
  var $10=$9 ? 1 : 0;
  var $11=(($10) & 255);
  ;
  return $11;
}


function __ZL9vsync_offR15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+14)|0);
  HEAP8[($9)]=0;
  ;
  return;
}


function __ZN12timer_device7set_ptrEPv($this, $ptr) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$ptr;
  var $3=$1;
  var $4=$2;
  var $5=(($3+364)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function __ZN8device_t24static_set_static_configERS_PKv($device, $config) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$config;
  var $3=$2;
  var $4=$1;
  var $5=(($4+44)|0);
  HEAP32[(($5)>>2)]=$3;
  ;
  return;
}


function __ZN12timer_device6adjustE8attotimeiS0_($this, $duration, $param, $period) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $duration; $duration = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($duration)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($duration+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($duration+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var tempParam = $period; $period = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($period)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($period+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($period+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+12;
      $1=$this;
      $2=$param;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+412)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$3;
      var $11=$duration;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[(($11)>>2)];HEAP32[(($10+4)>>2)]=HEAP32[(($11+4)>>2)];HEAP32[(($10+8)>>2)]=HEAP32[(($11+8)>>2)];
      var $12=$2;
      var $13=$4;
      var $14=$period;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($13)>>2)]=HEAP32[(($14)>>2)];HEAP32[(($13+4)>>2)]=HEAP32[(($14+4)>>2)];HEAP32[(($13+8)>>2)]=HEAP32[(($14+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($9, $3, $12, $4);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8attotime9from_usecEx($agg_result, $usec$0, $usec$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $st$1$0=(($1)|0);
  HEAP32[(($st$1$0)>>2)]=$usec$0;
  var $st$1$1=(($1+4)|0);
  HEAP32[(($st$1$1)>>2)]=$usec$1;
  var $st$5$0=(($1)|0);
  var $2$0=HEAP32[(($st$5$0)>>2)];
  var $st$5$1=(($1+4)|0);
  var $2$1=HEAP32[(($st$5$1)>>2)];
  var $$emscripten$temp$0$0=1000000;
  var $$emscripten$temp$0$1=0;
  var $3$0 = (tempBigIntR=((($2$0)>>>0)+((($2$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $3$1 = Math.min(Math.floor(((tempBigIntR=((($2$0)>>>0)+((($2$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $4$0=$3$0;
  var $4=$4$0;
  var $st$14$0=(($1)|0);
  var $5$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($1+4)|0);
  var $5$1=HEAP32[(($st$14$1)>>2)];
  var $$emscripten$temp$1$0=1000000;
  var $$emscripten$temp$1$1=0;
  var $6$0 = ((($5$0)>>>0)+((($5$1)|0)*4294967296))%((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $6$1 = Math.min(Math.floor((((($5$0)>>>0)+((($5$1)|0)*4294967296))%((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
  var $$emscripten$temp$2$0=-727379968;
  var $$emscripten$temp$2$1=232;
  var $7$0 = ((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
  __ZN8attotimeC1Eix($agg_result, $4, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZNK13screen_device11scan_periodEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+484)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  __ZN8attotimeC1Eix($agg_result, 0, $4$0, $4$1);
  ;
  return;
}


function __ZL14vbi_data_fetchR15running_machinePvi($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $focus_on;
      var $laser_on;
      var $lines=__stackBase__;
      var $line;
      var $dest;
      var $data;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $4=$2;
      var $5=$4;
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      var $9=$player;
      var $10=(($9+18)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 & 1;
      var $14=(($13)|0)!=0;
      var $15=$14 ^ 1;
      var $16=(($15)&1);
      $focus_on=$16;
      var $17=$player;
      var $18=(($17+18)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & 64;
      var $22=(($21) & 255);
      $laser_on=$22;
      var $23=$ld;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=__Z24laserdisc_get_field_codeP8device_tjh($25, 1718, 0);
      var $27=(($lines)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=$ld;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__Z24laserdisc_get_field_codeP8device_tjh($30, 17, 0);
      var $32=(($lines+4)|0);
      HEAP32[(($32)>>2)]=$31;
      var $33=$ld;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=__Z24laserdisc_get_field_codeP8device_tjh($35, 16, 0);
      var $37=(($lines+8)|0);
      HEAP32[(($37)>>2)]=$36;
      var $38=$player;
      var $39=(($38+62)|0);
      var $40=(($39)|0);
      _memset($40, 0, 21, 1);
      var $41=$focus_on;
      var $42=(($41 << 24) >> 24)!=0;
      if ($42) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $43
      var $44=$laser_on;
      var $45=(($44 << 24) >> 24)!=0;
      if ($45) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $46
      $line=0;
      __label__ = 3; break;
    case 3: // $47
      var $48=$line;
      var $49=(($48)|0) < 3;
      if ($49) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $50
      var $51=$line;
      var $52=(($51*7)|0);
      var $53=$player;
      var $54=(($53+62)|0);
      var $55=(($54+$52)|0);
      $dest=$55;
      var $56=$line;
      var $57=(($lines+($56<<2))|0);
      var $58=HEAP32[(($57)>>2)];
      $data=$58;
      var $59=$data;
      var $60=(($59)|0)==8978431;
      if ($60) { __label__ = 7; break; } else { __label__ = 5; break; }
    case 5: // $61
      var $62=$data;
      var $63=(($62)|0)==8449774;
      if ($63) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $64
      var $65=$data;
      var $66=$65 & 15728640;
      var $67=(($66)|0)==15728640;
      if ($67) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $68
      var $69=$data;
      var $70=$69 & 15728640;
      var $71=(($70)|0)==15728640;
      var $72=$71 ? 2 : 0;
      var $73=9 | $72;
      var $74=(($73) & 255);
      var $75=$dest;
      var $76=(($75+1)|0);
      $dest=$76;
      HEAP8[($75)]=$74;
      var $77=$dest;
      var $78=(($77+1)|0);
      $dest=$78;
      HEAP8[($77)]=8;
      var $79=$data;
      var $80=$79 >>> 16;
      var $81=$80 & 15;
      var $82=(($81) & 255);
      var $83=$dest;
      var $84=(($83+1)|0);
      $dest=$84;
      HEAP8[($83)]=$82;
      var $85=$data;
      var $86=$85 >>> 12;
      var $87=$86 & 15;
      var $88=(($87) & 255);
      var $89=$dest;
      var $90=(($89+1)|0);
      $dest=$90;
      HEAP8[($89)]=$88;
      var $91=$data;
      var $92=$91 >>> 8;
      var $93=$92 & 15;
      var $94=(($93) & 255);
      var $95=$dest;
      var $96=(($95+1)|0);
      $dest=$96;
      HEAP8[($95)]=$94;
      var $97=$data;
      var $98=$97 >>> 4;
      var $99=$98 & 15;
      var $100=(($99) & 255);
      var $101=$dest;
      var $102=(($101+1)|0);
      $dest=$102;
      HEAP8[($101)]=$100;
      var $103=$data;
      var $104=$103 >>> 0;
      var $105=$104 & 15;
      var $106=(($105) & 255);
      var $107=$dest;
      var $108=(($107+1)|0);
      $dest=$108;
      HEAP8[($107)]=$106;
      __label__ = 8; break;
    case 8: // $109
      __label__ = 9; break;
    case 9: // $110
      var $111=$line;
      var $112=(($111+1)|0);
      $line=$112;
      __label__ = 3; break;
    case 10: // $113
      __label__ = 11; break;
    case 11: // $114
      var $115=$player;
      var $116=(($115+83)|0);
      HEAP8[($116)]=1;
      var $117=$player;
      var $118=(($117+84)|0);
      HEAP8[($118)]=0;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14vbi_data_fetchR15running_machinePvi["X"]=1;

function __ZL33construct_address_map_ldv1000_mapR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 0, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 8191, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry10set_mirrorEj($8, 24576);
  var $9=$curentry;
  var $10=$9;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($10, 2);
  var $11=$1;
  var $12=$curentry;
  var $13=__ZN11address_map3addEjjP18address_map_entry8($11, 32768, 34815, $12);
  $curentry=$13;
  var $14=$curentry;
  var $15=$14;
  __ZN17address_map_entry10set_mirrorEj($15, 14336);
  var $16=$curentry;
  var $17=$16;
  __ZN17address_map_entry13set_read_typeE16map_handler_type($17, 1);
  var $18=$curentry;
  var $19=$18;
  __ZN17address_map_entry14set_write_typeE16map_handler_type($19, 1);
  var $20=$1;
  var $21=$curentry;
  var $22=__ZN11address_map3addEjjP18address_map_entry8($20, 49152, 49155, $21);
  $curentry=$22;
  var $23=$curentry;
  var $24=$23;
  __ZN17address_map_entry10set_mirrorEj($24, 40944);
  var $25=$curentry;
  var $26=$2;
  __ZN18address_map_entry811set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_($25, $26, ((STRING_TABLE.__str175875)|0), 1320, ((STRING_TABLE.__str255883)|0), 1322, ((STRING_TABLE.__str265884)|0));
  var $27=$1;
  var $28=$curentry;
  var $29=__ZN11address_map3addEjjP18address_map_entry8($27, 49156, 49159, $28);
  $curentry=$29;
  var $30=$curentry;
  var $31=$30;
  __ZN17address_map_entry10set_mirrorEj($31, 40944);
  var $32=$curentry;
  var $33=$2;
  __ZN18address_map_entry811set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_($32, $33, ((STRING_TABLE.__str185876)|0), 1320, ((STRING_TABLE.__str255883)|0), 1322, ((STRING_TABLE.__str265884)|0));
  ;
  return;
}
__ZL33construct_address_map_ldv1000_mapR11address_mapRK8device_t["X"]=1;

function __ZL37construct_address_map_ldv1000_portmapR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 2, 8);
  var $4=$1;
  __ZN11address_map15set_global_maskEj($4, 255);
  var $5=$1;
  var $6=$curentry;
  var $7=__ZN11address_map3addEjjP18address_map_entry8($5, 0, 7, $6);
  $curentry=$7;
  var $8=$curentry;
  var $9=$8;
  __ZN17address_map_entry10set_mirrorEj($9, 56);
  var $10=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($10, 1324, ((STRING_TABLE.__str195877)|0), 1326, ((STRING_TABLE.__str205878)|0));
  var $11=$1;
  var $12=$curentry;
  var $13=__ZN11address_map3addEjjP18address_map_entry8($11, 64, 64, $12);
  $curentry=$13;
  var $14=$curentry;
  var $15=$14;
  __ZN17address_map_entry10set_mirrorEj($15, 63);
  var $16=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($16, 1328, ((STRING_TABLE.__str215879)|0));
  var $17=$1;
  var $18=$curentry;
  var $19=__ZN11address_map3addEjjP18address_map_entry8($17, 128, 128, $18);
  $curentry=$19;
  var $20=$curentry;
  var $21=$20;
  __ZN17address_map_entry10set_mirrorEj($21, 63);
  var $22=$curentry;
  __ZN18address_map_entry811set_handlerEPFvP13address_spacejhEPKc($22, 1330, ((STRING_TABLE.__str225880)|0));
  var $23=$1;
  var $24=$curentry;
  var $25=__ZN11address_map3addEjjP18address_map_entry8($23, 192, 195, $24);
  $curentry=$25;
  var $26=$curentry;
  var $27=$26;
  __ZN17address_map_entry10set_mirrorEj($27, 60);
  var $28=$curentry;
  var $29=$2;
  __ZN18address_map_entry811set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_($28, $29, ((STRING_TABLE.__str85864)|0), 1332, ((STRING_TABLE.__str235881)|0), 1334, ((STRING_TABLE.__str245882)|0));
  ;
  return;
}


function __ZL15multijump_timerR12timer_devicePvi($timer, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $direction;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      $1=$timer;
      $2=$ptr;
      $3=$param;
      var $6=$2;
      var $7=$6;
      $ld=$7;
      var $8=$ld;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      $player=$10;
      var $11=$player;
      var $12=(($11+18)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & 32;
      var $16=(($15)|0)!=0;
      var $17=$16 ? 1 : -1;
      $direction=$17;
      var $18=$ld;
      var $19=$direction;
      __Z21ldcore_advance_sliderP16_laserdisc_statei($18, $19);
      var $20=$player;
      var $21=(($20+16)|0);
      var $22=HEAP8[($21)];
      var $23=(($22-1)&255);
      HEAP8[($21)]=$23;
      var $24=(($23)&255);
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $26
      var $27=$1;
      var $$emscripten$temp$0$0=50;
      var $$emscripten$temp$0$1=0;
      __ZN8attotime9from_usecEx($4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $28=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($28)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($28+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($28+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN12timer_device6adjustE8attotimeiS0_($27, $4, 0, $5);
      __label__ = 2; break;
    case 2: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22decoder_display_port_rP13address_spacej($space, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $result;
      $1=$space;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK13address_space6deviceEv($3);
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      $result=0;
      var $10=$2;
      var $11=(($10)|0)==3;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=$player;
      var $14=(($13+20)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=(($16)|0)==4;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$player;
      var $20=(($19+83)|0);
      HEAP8[($20)]=0;
      var $21=$player;
      var $22=(($21+84)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23+1)&255);
      HEAP8[($22)]=$24;
      var $25=(($23)&255);
      var $26=(($25)>>>0)%21;
      var $27=$player;
      var $28=(($27+62)|0);
      var $29=(($28+$26)|0);
      var $30=HEAP8[($29)];
      $result=$30;
      __label__ = 3; break;
    case 3: // $31
      __label__ = 4; break;
    case 4: // $32
      var $33=$result;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22decoder_display_port_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK13address_space6deviceEv($4);
      var $6=__ZNK8device_t5ownerEv($5);
      var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
      $ld=$7;
      var $8=$ld;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      $player=$10;
      var $11=$2;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$3;
      var $15=$player;
      var $16=(($15+20)|0);
      HEAP8[($16)]=$14;
      var $17=$player;
      var $18=(($17+61)|0);
      HEAP8[($18)]=0;
      __label__ = 7; break;
    case 2: // $19
      var $20=$2;
      var $21=(($20)|0)==2;
      if ($21) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $22
      var $23=$player;
      var $24=(($23+20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=(($26)|0) < 2;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$3;
      var $30=(($29)&255);
      var $31=$30 & 63;
      var $32=(($31) & 255);
      var $33=$player;
      var $34=(($33+61)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35+1)&255);
      HEAP8[($34)]=$36;
      var $37=(($35)&255);
      var $38=(($37)|0)%20;
      var $39=$player;
      var $40=(($39+20)|0);
      var $41=HEAPU8[($40)];
      var $42=(($41)&255);
      var $43=$player;
      var $44=(($43+21)|0);
      var $45=(($44+$42*20)|0);
      var $46=(($45+$38)|0);
      HEAP8[($46)]=$32;
      __label__ = 5; break;
    case 5: // $47
      __label__ = 6; break;
    case 6: // $48
      __label__ = 7; break;
    case 7: // $49
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22decoder_display_port_wP13address_spacejh["X"]=1;

function __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($this, $func, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$func;
  $3=$string;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcy($5, $6, $7, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function __ZL12controller_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  var $result;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+12)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 ^ 255;
  var $14=(($13) & 255);
  $result=$14;
  var $15=$ld;
  var $16=(($15+12)|0);
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17+12)|0);
  HEAP8[($18)]=-1;
  var $19=$result;
  ;
  return $19;
}


function __ZN18address_map_entry811set_handlerEPFvP13address_spacejhEPKc($this, $func, $string) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$func;
  $3=$string;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$3;
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN17address_map_entry20internal_set_handlerEPFvP13address_spacejhEPKcy($5, $6, $7, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function __ZL12controller_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$space;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=__ZNK13address_space6deviceEv($4);
  var $6=__ZNK8device_t5ownerEv($5);
  var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
  $ld=$7;
  var $8=$3;
  var $9=$ld;
  var $10=(($9+12)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+13)|0);
  HEAP8[($12)]=$8;
  ;
  return;
}


function __ZN18address_map_entry811set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_($this, $device, $tag, $rfunc, $rstring, $wfunc, $wstring) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $1=$this;
  $2=$device;
  $3=$tag;
  $4=$rfunc;
  $5=$rstring;
  $6=$wfunc;
  $7=$wstring;
  var $8=$1;
  var $9=$8;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $14=$6;
  var $15=$7;
  var $$emscripten$temp$0$0=0;
  var $$emscripten$temp$0$1=0;
  __ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_y($9, $10, $11, $12, $13, $14, $15, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
  ;
  return;
}


function __Z27ui_mess_menu_software_partsR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $event;
      var $sw_state;
      var $swlist;
      var $swinfo;
      var $interface;
      var $entry;
      var $temp_name=__stackBase__;
      var $5;
      var $6;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $7=$4;
      var $8=$7;
      $sw_state=$8;
      var $9=$sw_state;
      var $10=(($9+16)|0);
      var $11=HEAP32[(($10)>>2)];
      $swlist=$11;
      var $12=$sw_state;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      $swinfo=$14;
      var $15=$sw_state;
      var $16=(($15+12)|0);
      var $17=HEAP32[(($16)>>2)];
      $interface=$17;
      var $18=$2;
      var $19=__Z17ui_menu_populatedP7ui_menu($18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $21
      var $22=$sw_state;
      var $23=(($22+16)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $26
      var $27=$1;
      var $28=$2;
      var $29=$swlist;
      var $30=$swinfo;
      var $31=$interface;
      __ZL36ui_mess_menu_populate_software_partsR15running_machineP7ui_menuPKcS4_S4_($27, $28, $29, $30, $31);
      __label__ = 3; break;
    case 3: // $32
      __label__ = 4; break;
    case 4: // $33
      var $34=$1;
      var $35=$2;
      var $36=__Z15ui_menu_processR15running_machineP7ui_menuj($34, $35, 0);
      $event=$36;
      var $37=$event;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $39
      var $40=$event;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==182;
      if ($43) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $44
      var $45=$event;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $49
      var $50=$event;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$52;
      $entry=$53;
      var $54=$sw_state;
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      __ZN7astringC1EPKc($temp_name, $56);
      var $57=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($temp_name, ((STRING_TABLE.__str5885)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $58
      var $59=$entry;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($temp_name, $61) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; };
    case 9: // $63
      var $64=$sw_state;
      var $65=(($64+20)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($temp_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $68
      var $69=(function() { try { __THREW__ = false; return __ZN22device_image_interface4loadEPKc($66, $67) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; };
    case 11: // $70
      FUNCTION_TABLE[__ZN7astringD1Ev]($temp_name);
      __label__ = 14; break;
    case 12: // $71
      var $72=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $73=$72.f0;
      $5=$73;
      var $74=$72.f1;
      $6=$74;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($temp_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $75
      __label__ = 15; break;
    case 14: // $76
      STACKTOP = __stackBase__;
      return;
    case 15: // $77
      var $78=$5;
      var $79=$5;
      var $80=$6;
      var $81=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $79, tempValue);
      var $82=($81.f1 = $80, $81);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $83
      var $84=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z27ui_mess_menu_software_partsR15running_machineP7ui_menuPvS3_["X"]=1;

function __Z25swinfo_has_multiple_partsP13software_infoPKc($swinfo, $interface) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $swpart;
      $1=$swinfo;
      $2=$interface;
      $count=0;
      var $3=$1;
      var $4=__Z18software_find_partP13software_infoPKcS2_($3, 0, 0);
      $swpart=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$swpart;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $8
      var $9=$2;
      var $10=$swpart;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=_strcmp($9, $12);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$count;
      var $17=(($16+1)|0);
      $count=$17;
      __label__ = 4; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$swpart;
      var $21=__Z18software_part_nextP13software_part($20);
      $swpart=$21;
      __label__ = 1; break;
    case 6: // $22
      var $23=$count;
      var $24=(($23)|0) > 1;
      var $25=$24 ? 1 : 0;
      var $26=(($25)|0)!=0;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z26ui_mess_menu_software_listR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $event;
      var $sw_state;
      var $entry;
      var $selected_entry;
      var $bestmatch;
      var $image;
      var $entry1;
      var $tmp_list;
      var $tmp_info;
      var $child_menu;
      var $child_menustate;
      var $buflen;
      var $update_selected;
      var $cur_selected;
      var $compare_name;
      var $match;
      var $i;
      var $compare_name2;
      var $match3;
      var $i4;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$4;
      var $6=$5;
      $sw_state=$6;
      $selected_entry=0;
      $bestmatch=0;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$sw_state;
      var $12=(($11+1040)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $15
      var $16=$sw_state;
      var $17=(($16+1040)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=$sw_state;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$1;
      var $24=$2;
      var $25=$sw_state;
      __ZL38ui_mess_menu_populate_software_entriesR15running_machineP7ui_menuP20_software_menu_state($23, $24, $25);
      __label__ = 4; break;
    case 4: // $26
      __label__ = 5; break;
    case 5: // $27
      var $28=$1;
      var $29=$2;
      var $30=__Z15ui_menu_processR15running_machineP7ui_menuj($28, $29, 0);
      $event=$30;
      var $31=$event;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 82; break; }
    case 6: // $33
      var $34=$event;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 82; break; }
    case 7: // $38
      var $39=$event;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$41;
      var $43=(($42)|0)==1;
      if ($43) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $44
      var $45=$event;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)==182;
      if ($48) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $49
      var $50=$sw_state;
      var $51=(($50+1036)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$52 ^ 1;
      HEAP32[(($51)>>2)]=$53;
      var $54=$sw_state;
      var $55=(($54+1040)|0);
      HEAP32[(($55)>>2)]=1;
      var $56=$sw_state;
      var $57=(($56+8)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=$sw_state;
      var $59=(($58+12)|0);
      var $60=(($59)|0);
      _memset($60, 0, 1024, 1);
      var $61=$2;
      __Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options($61, 2);
      var $62=$sw_state;
      var $63=(($62+1036)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)!=0;
      var $66=$65 ? (((STRING_TABLE.__str25887)|0)) : (((STRING_TABLE.__str35888)|0));
      __Z10popmessagePKcz(((STRING_TABLE.__str15886)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,tempInt));
      __label__ = 81; break;
    case 10: // $67
      var $68=$event;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0)==182;
      if ($71) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $72
      var $73=$sw_state;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      $image=$75;
      var $76=$event;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$78;
      $entry1=$79;
      var $80=$1;
      var $81=__ZNK15running_machine7optionsEv($80);
      var $82=$sw_state;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=__Z18software_list_openR11emu_optionsPKciPFvS2_E($81, $84, 0, 0);
      $tmp_list=$85;
      var $86=$tmp_list;
      var $87=$entry1;
      var $88=(($87+4)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=__Z18software_list_findP14_software_listPKcP13software_info($86, $89, 0);
      $tmp_info=$90;
      var $91=$tmp_info;
      var $92=$image;
      var $93=$92;
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94+120)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=FUNCTION_TABLE[$96]($92);
      var $98=__Z25swinfo_has_multiple_partsP13software_infoPKc($91, $97);
      if ($98) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $99
      var $100=$1;
      var $101=$1;
      var $102=__ZNK15running_machine6renderEv($101);
      var $103=__ZNK14render_manager12ui_containerEv($102);
      var $104=$entry1;
      var $105=$104;
      var $106=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($100, $103, 1336, $105);
      $child_menu=$106;
      var $107=$child_menu;
      var $108=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($107, 24, 0);
      var $109=$108;
      $child_menustate=$109;
      var $110=$entry1;
      var $111=(($110+4)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$child_menustate;
      var $114=(($113+4)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=$image;
      var $116=$115;
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117+120)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=FUNCTION_TABLE[$119]($115);
      var $121=$child_menustate;
      var $122=(($121+12)|0);
      HEAP32[(($122)>>2)]=$120;
      var $123=$sw_state;
      var $124=(($123)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$child_menustate;
      var $127=(($126+16)|0);
      HEAP32[(($127)>>2)]=$125;
      var $128=$image;
      var $129=$child_menustate;
      var $130=(($129+20)|0);
      HEAP32[(($130)>>2)]=$128;
      var $131=$child_menu;
      __Z18ui_menu_stack_pushP7ui_menu($131);
      __label__ = 17; break;
    case 13: // $132
      var $133=$image;
      var $134=(($133)|0)!=0;
      if ($134) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $135
      var $136=$image;
      var $137=$entry1;
      var $138=(($137+4)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=__ZN22device_image_interface4loadEPKc($136, $139);
      __label__ = 16; break;
    case 15: // $141
      var $142=$entry1;
      var $143=(($142+12)|0);
      var $144=HEAP32[(($143)>>2)];
      __Z10popmessagePKcz(((STRING_TABLE.__str45889)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$144,tempInt));
      __label__ = 16; break;
    case 16: // $145
      __label__ = 17; break;
    case 17: // $146
      var $147=$tmp_list;
      __Z19software_list_closeP14_software_list($147);
      var $148=$sw_state;
      var $149=(($148+12)|0);
      var $150=(($149)|0);
      var $151=HEAP8[($150)];
      var $152=(($151 << 24) >> 24);
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $154
      var $155=$sw_state;
      var $156=(($155+12)|0);
      var $157=(($156)|0);
      _memset($157, 0, 1024, 1);
      __label__ = 19; break;
    case 19: // $158
      __label__ = 80; break;
    case 20: // $159
      var $160=$event;
      var $161=(($160+4)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162)|0)==214;
      if ($163) { __label__ = 21; break; } else { __label__ = 74; break; }
    case 21: // $164
      var $165=$sw_state;
      var $166=(($165+12)|0);
      var $167=(($166)|0);
      var $168=_strlen($167);
      $buflen=$168;
      $update_selected=0;
      var $169=$event;
      var $170=(($169+8)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171)|0)==8;
      if ($172) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $173
      var $174=$event;
      var $175=(($174+8)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176)|0)==127;
      if ($177) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $178
      var $179=$buflen;
      var $180=(($179)|0) > 0;
      if ($180) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $181
      var $182=$buflen;
      var $183=$sw_state;
      var $184=(($183+12)|0);
      var $185=(($184+$182)|0);
      var $186=__Z18utf8_previous_charPKc($185);
      HEAP8[($186)]=0;
      $update_selected=1;
      var $187=$sw_state;
      var $188=(($187+12)|0);
      var $189=(($188)|0);
      __Z13ui_popup_timeiPKcz(5, ((STRING_TABLE.__str55890)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$189,tempInt));
      __label__ = 29; break;
    case 25: // $190
      var $191=$event;
      var $192=(($191+8)|0);
      var $193=HEAPU32[(($192)>>2)];
      var $194=(($193)>>>0) >= 32;
      if ($194) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $195
      var $196=$event;
      var $197=(($196+8)|0);
      var $198=HEAPU32[(($197)>>2)];
      var $199=(($198)>>>0) < 127;
      if ($199) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $200
      var $201=$buflen;
      var $202=$sw_state;
      var $203=(($202+12)|0);
      var $204=(($203+$201)|0);
      var $205=$buflen;
      var $206=((1024-$205)|0);
      var $207=$event;
      var $208=(($207+8)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=__Z15utf8_from_ucharPcjj($204, $206, $209);
      var $211=$buflen;
      var $212=(($211+$210)|0);
      $buflen=$212;
      var $213=$buflen;
      var $214=$sw_state;
      var $215=(($214+12)|0);
      var $216=(($215+$213)|0);
      HEAP8[($216)]=0;
      $update_selected=1;
      var $217=$sw_state;
      var $218=(($217+12)|0);
      var $219=(($218)|0);
      __Z13ui_popup_timeiPKcz(5, ((STRING_TABLE.__str55890)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$219,tempInt));
      __label__ = 28; break;
    case 28: // $220
      __label__ = 29; break;
    case 29: // $221
      var $222=$update_selected;
      var $223=(($222) & 1);
      if ($223) { __label__ = 30; break; } else { __label__ = 73; break; }
    case 30: // $224
      var $225=$event;
      var $226=(($225)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$227;
      var $229=(($228)|0)!=1;
      if ($229) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $230
      var $231=$2;
      var $232=__Z21ui_menu_get_selectionP7ui_menu($231);
      var $233=$232;
      $cur_selected=$233;
      __label__ = 33; break;
    case 32: // $234
      var $235=$sw_state;
      var $236=(($235+8)|0);
      var $237=HEAP32[(($236)>>2)];
      $cur_selected=$237;
      __label__ = 33; break;
    case 33: // $238
      var $239=$cur_selected;
      $entry=$239;
      __label__ = 34; break;
    case 34: // $240
      var $241=$entry;
      var $242=(($241)|0)!=0;
      if ($242) { __label__ = 35; break; } else { __label__ = 51; break; }
    case 35: // $243
      var $244=$sw_state;
      var $245=(($244+1036)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246)|0)!=0;
      if ($247) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $248
      var $249=$entry;
      var $250=(($249+4)|0);
      var $251=HEAP32[(($250)>>2)];
      var $257 = $251;__label__ = 38; break;
    case 37: // $252
      var $253=$entry;
      var $254=(($253+8)|0);
      var $255=HEAP32[(($254)>>2)];
      var $257 = $255;__label__ = 38; break;
    case 38: // $256
      var $257;
      $compare_name=$257;
      var $258=$compare_name;
      var $259=(($258)|0)!=0;
      if ($259) { __label__ = 39; break; } else { __label__ = 49; break; }
    case 39: // $260
      var $261=$sw_state;
      var $262=(($261+12)|0);
      var $263=(($262)|0);
      var $264=(($263)|0)!=0;
      if ($264) { __label__ = 40; break; } else { __label__ = 49; break; }
    case 40: // $265
      $match=0;
      $i=0;
      __label__ = 41; break;
    case 41: // $266
      var $267=$i;
      var $268=(($267)>>>0) < 1024;
      if ($268) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $269
      var $270=$compare_name;
      var $271=$sw_state;
      var $272=(($271+12)|0);
      var $273=(($272)|0);
      var $274=$i;
      var $275=__Z13core_strnicmpPKcS0_j($270, $273, $274);
      var $276=(($275)|0)==0;
      if ($276) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $277
      var $278=$i;
      $match=$278;
      __label__ = 44; break;
    case 44: // $279
      __label__ = 45; break;
    case 45: // $280
      var $281=$i;
      var $282=(($281+1)|0);
      $i=$282;
      __label__ = 41; break;
    case 46: // $283
      var $284=$match;
      var $285=$bestmatch;
      var $286=(($284)|0) > (($285)|0);
      if ($286) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $287
      var $288=$match;
      $bestmatch=$288;
      var $289=$entry;
      $selected_entry=$289;
      __label__ = 48; break;
    case 48: // $290
      __label__ = 49; break;
    case 49: // $291
      __label__ = 50; break;
    case 50: // $292
      var $293=$entry;
      var $294=(($293)|0);
      var $295=HEAP32[(($294)>>2)];
      $entry=$295;
      __label__ = 34; break;
    case 51: // $296
      var $297=$sw_state;
      var $298=(($297+8)|0);
      var $299=HEAP32[(($298)>>2)];
      $entry=$299;
      __label__ = 52; break;
    case 52: // $300
      var $301=$entry;
      var $302=$cur_selected;
      var $303=(($301)|0)!=(($302)|0);
      if ($303) { __label__ = 53; break; } else { __label__ = 69; break; }
    case 53: // $304
      var $305=$sw_state;
      var $306=(($305+1036)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=(($307)|0)!=0;
      if ($308) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $309
      var $310=$entry;
      var $311=(($310+4)|0);
      var $312=HEAP32[(($311)>>2)];
      var $318 = $312;__label__ = 56; break;
    case 55: // $313
      var $314=$entry;
      var $315=(($314+8)|0);
      var $316=HEAP32[(($315)>>2)];
      var $318 = $316;__label__ = 56; break;
    case 56: // $317
      var $318;
      $compare_name2=$318;
      var $319=$compare_name2;
      var $320=(($319)|0)!=0;
      if ($320) { __label__ = 57; break; } else { __label__ = 67; break; }
    case 57: // $321
      var $322=$sw_state;
      var $323=(($322+12)|0);
      var $324=(($323)|0);
      var $325=(($324)|0)!=0;
      if ($325) { __label__ = 58; break; } else { __label__ = 67; break; }
    case 58: // $326
      $match3=0;
      $i4=0;
      __label__ = 59; break;
    case 59: // $327
      var $328=$i4;
      var $329=(($328)>>>0) < 1024;
      if ($329) { __label__ = 60; break; } else { __label__ = 64; break; }
    case 60: // $330
      var $331=$compare_name2;
      var $332=$sw_state;
      var $333=(($332+12)|0);
      var $334=(($333)|0);
      var $335=$i4;
      var $336=__Z13core_strnicmpPKcS0_j($331, $334, $335);
      var $337=(($336)|0)==0;
      if ($337) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $338
      var $339=$i4;
      $match3=$339;
      __label__ = 62; break;
    case 62: // $340
      __label__ = 63; break;
    case 63: // $341
      var $342=$i4;
      var $343=(($342+1)|0);
      $i4=$343;
      __label__ = 59; break;
    case 64: // $344
      var $345=$match3;
      var $346=$bestmatch;
      var $347=(($345)|0) > (($346)|0);
      if ($347) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $348
      var $349=$match3;
      $bestmatch=$349;
      var $350=$entry;
      $selected_entry=$350;
      __label__ = 66; break;
    case 66: // $351
      __label__ = 67; break;
    case 67: // $352
      __label__ = 68; break;
    case 68: // $353
      var $354=$entry;
      var $355=(($354)|0);
      var $356=HEAP32[(($355)>>2)];
      $entry=$356;
      __label__ = 52; break;
    case 69: // $357
      var $358=$selected_entry;
      var $359=(($358)|0)!=0;
      if ($359) { __label__ = 70; break; } else { __label__ = 72; break; }
    case 70: // $360
      var $361=$selected_entry;
      var $362=$cur_selected;
      var $363=(($361)|0)!=(($362)|0);
      if ($363) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $364
      var $365=$2;
      var $366=$selected_entry;
      var $367=$366;
      __Z21ui_menu_set_selectionP7ui_menuPv($365, $367);
      __label__ = 72; break;
    case 72: // $368
      __label__ = 73; break;
    case 73: // $369
      __label__ = 79; break;
    case 74: // $370
      var $371=$event;
      var $372=(($371+4)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=(($373)|0)==183;
      if ($374) { __label__ = 75; break; } else { __label__ = 78; break; }
    case 75: // $375
      var $376=$sw_state;
      var $377=(($376+12)|0);
      var $378=(($377)|0);
      var $379=HEAP8[($378)];
      var $380=(($379 << 24) >> 24);
      var $381=(($380)|0)!=0;
      if ($381) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $382
      var $383=$sw_state;
      var $384=(($383+12)|0);
      var $385=(($384)|0);
      _memset($385, 0, 1024, 1);
      __label__ = 77; break;
    case 77: // $386
      __label__ = 78; break;
    case 78: // $387
      __label__ = 79; break;
    case 79: // $388
      __label__ = 80; break;
    case 80: // $389
      __label__ = 81; break;
    case 81: // $390
      __label__ = 82; break;
    case 82: // $391
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z26ui_mess_menu_software_listR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL38ui_mess_menu_populate_software_entriesR15running_machineP7ui_menuP20_software_menu_state($machine, $menu, $menustate) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $list;
      var $swinfo;
      var $entry;
      $1=$machine;
      $2=$menu;
      $3=$menustate;
      var $4=$1;
      var $5=__ZNK15running_machine7optionsEv($4);
      var $6=$3;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z18software_list_openR11emu_optionsPKciPFvS2_E($5, $8, 0, 0);
      $list=$9;
      var $10=$list;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $12
      var $13=$list;
      var $14=__Z18software_list_findP14_software_listPKcP13software_info($13, ((STRING_TABLE.__str65891)|0), 0);
      $swinfo=$14;
      __label__ = 2; break;
    case 2: // $15
      var $16=$swinfo;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $18
      var $19=$2;
      var $20=$3;
      var $21=$swinfo;
      var $22=$3;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$3;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__ZL21append_software_entryP7ui_menuP20_software_menu_stateP13software_infoPcP22device_image_interface($19, $20, $21, $24, $27);
      __label__ = 4; break;
    case 4: // $29
      var $30=$list;
      var $31=$swinfo;
      var $32=__Z18software_list_findP14_software_listPKcP13software_info($30, ((STRING_TABLE.__str65891)|0), $31);
      $swinfo=$32;
      __label__ = 2; break;
    case 5: // $33
      var $34=$list;
      __Z19software_list_closeP14_software_list($34);
      __label__ = 6; break;
    case 6: // $35
      var $36=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($36, ((STRING_TABLE.__str85893)|0), 0, 0, 1);
      var $37=$3;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      $entry=$39;
      __label__ = 7; break;
    case 7: // $40
      var $41=$entry;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $43
      var $44=$2;
      var $45=$entry;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$entry;
      var $49=(($48+8)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$entry;
      var $52=$51;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($44, $47, $50, 0, $52);
      __label__ = 9; break;
    case 9: // $53
      var $54=$entry;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      $entry=$56;
      __label__ = 7; break;
    case 10: // $57
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL38ui_mess_menu_populate_software_entriesR15running_machineP7ui_menuP20_software_menu_state["X"]=1;

function __ZL36ui_mess_menu_populate_software_partsR15running_machineP7ui_menuPKcS4_S4_($machine, $menu, $swlist, $swinfo, $interface) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $list;
      var $info;
      var $swpart;
      var $entry;
      var $menu_part_name=__stackBase__;
      var $6;
      var $7;
      $1=$machine;
      $2=$menu;
      $3=$swlist;
      $4=$swinfo;
      $5=$interface;
      var $8=$1;
      var $9=__ZNK15running_machine7optionsEv($8);
      var $10=$3;
      var $11=__Z18software_list_openR11emu_optionsPKciPFvS2_E($9, $10, 0, 0);
      $list=$11;
      var $12=$list;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 23; break; }
    case 1: // $14
      var $15=$list;
      var $16=$4;
      var $17=__Z18software_list_findP14_software_listPKcP13software_info($15, $16, 0);
      $info=$17;
      var $18=$info;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 2; break; } else { __label__ = 22; break; }
    case 2: // $20
      var $21=$info;
      var $22=__Z18software_find_partP13software_infoPKcS2_($21, 0, 0);
      $swpart=$22;
      __label__ = 3; break;
    case 3: // $23
      var $24=$swpart;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 21; break; }
    case 4: // $26
      var $27=$5;
      var $28=$swpart;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=_strcmp($27, $30);
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 5; break; } else { __label__ = 19; break; }
    case 5: // $33
      var $34=$2;
      var $35=__Z18ui_menu_pool_allocP7ui_menuj($34, 8);
      var $36=$35;
      $entry=$36;
      var $37=$swpart;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      __ZN7astringC1EPKc($menu_part_name, $39);
      var $40=$swpart;
      var $41=(function() { try { __THREW__ = false; return __Z25software_part_get_featureP13software_partPKc($40, ((STRING_TABLE.__str105895)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 12; break; };
    case 6: // $42
      var $43=(($41)|0)!=0;
      if ($43) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $44
      var $45=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($menu_part_name, ((STRING_TABLE.__str115896)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; };
    case 8: // $46
      var $47=$swpart;
      var $48=(function() { try { __THREW__ = false; return __Z25software_part_get_featureP13software_partPKc($47, ((STRING_TABLE.__str105895)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 12; break; };
    case 9: // $49
      var $50=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($menu_part_name, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; };
    case 10: // $51
      var $52=(function() { try { __THREW__ = false; return __ZN7astring3catEPKc($menu_part_name, ((STRING_TABLE.__str125897)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; };
    case 11: // $53
      __label__ = 13; break;
    case 12: // $54
      var $55=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $56=$55.f0;
      $6=$56;
      var $57=$55.f1;
      $7=$57;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($menu_part_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 25; break; }
    case 13: // $58
      var $59=$2;
      var $60=$swpart;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(function() { try { __THREW__ = false; return __Z19ui_menu_pool_strdupP7ui_menuPKc($59, $62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 12; break; };
    case 14: // $64
      var $65=$entry;
      var $66=(($65)|0);
      HEAP32[(($66)>>2)]=$63;
      var $67=$2;
      var $68=$swpart;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(function() { try { __THREW__ = false; return __Z19ui_menu_pool_strdupP7ui_menuPKc($67, $70) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 12; break; };
    case 15: // $72
      var $73=$entry;
      var $74=(($73+4)|0);
      HEAP32[(($74)>>2)]=$71;
      var $75=$2;
      var $76=$info;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($menu_part_name) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; };
    case 16: // $80
      var $81=$entry;
      var $82=$81;
      (function() { try { __THREW__ = false; return __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($75, $78, $79, 0, $82) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 12; break; }
    case 17: // $83
      FUNCTION_TABLE[__ZN7astringD1Ev]($menu_part_name);
      __label__ = 19; break;
    case 18: // $84
      __label__ = 24; break;
    case 19: // $85
      __label__ = 20; break;
    case 20: // $86
      var $87=$swpart;
      var $88=__Z18software_part_nextP13software_part($87);
      $swpart=$88;
      __label__ = 3; break;
    case 21: // $89
      __label__ = 22; break;
    case 22: // $90
      var $91=$list;
      __Z19software_list_closeP14_software_list($91);
      __label__ = 23; break;
    case 23: // $92
      STACKTOP = __stackBase__;
      return;
    case 24: // $93
      var $94=$6;
      var $95=$6;
      var $96=$7;
      var $97=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $95, tempValue);
      var $98=($97.f1 = $96, $97);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $99
      var $100=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL36ui_mess_menu_populate_software_partsR15running_machineP7ui_menuPKcS4_S4_["X"]=1;

function __Z22ui_image_menu_softwareR15running_machineP7ui_menuPvS3_($machine, $menu, $parameter, $state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $event;
      var $image;
      var $child_menu;
      var $child_menustate;
      $1=$machine;
      $2=$menu;
      $3=$parameter;
      $4=$state;
      var $5=$3;
      var $6=$5;
      $image=$6;
      var $7=$2;
      var $8=__Z17ui_menu_populatedP7ui_menu($7);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$1;
      var $12=$2;
      var $13=$image;
      __ZL35ui_mess_menu_populate_software_listR15running_machineP7ui_menuP22device_image_interface($11, $12, $13);
      __label__ = 2; break;
    case 2: // $14
      var $15=$1;
      var $16=$2;
      var $17=__Z15ui_menu_processR15running_machineP7ui_menuj($15, $16, 0);
      $event=$17;
      var $18=$event;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=$event;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)==182;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      var $26=$1;
      var $27=$1;
      var $28=__ZNK15running_machine6renderEv($27);
      var $29=__ZNK14render_manager12ui_containerEv($28);
      var $30=__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_($26, $29, 1340, 0);
      $child_menu=$30;
      var $31=$child_menu;
      var $32=__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE($31, 1044, 0);
      var $33=$32;
      $child_menustate=$33;
      var $34=$event;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$child_menustate;
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=$36;
      var $39=$image;
      var $40=$child_menustate;
      var $41=(($40+4)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$child_menustate;
      var $43=(($42+8)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=$child_menustate;
      var $45=(($44+1036)|0);
      HEAP32[(($45)>>2)]=1;
      var $46=$child_menu;
      __Z18ui_menu_stack_pushP7ui_menu($46);
      __label__ = 5; break;
    case 5: // $47
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22ui_image_menu_softwareR15running_machineP7ui_menuPvS3_["X"]=1;

function __ZL35ui_mess_menu_populate_software_listR15running_machineP7ui_menuP22device_image_interface($machine, $menu, $image) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $haveCompatible;
      var $interface;
      var $dev;
      var $swlist;
      var $i;
      var $list;
      var $found;
      var $swinfo;
      var $part;
      var $dev1;
      var $swlist2;
      var $i3;
      var $list4;
      var $found5;
      var $swinfo6;
      var $part7;
      $1=$machine;
      $2=$menu;
      $3=$image;
      $haveCompatible=0;
      var $4=$3;
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+120)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=FUNCTION_TABLE[$8]($4);
      $interface=$9;
      var $10=$1;
      var $11=__ZNK15running_machine6configEv($10);
      var $12=__ZNK14machine_config10devicelistEv($11);
      var $13=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $14=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($12, $13);
      $dev=$14;
      __label__ = 1; break;
    case 1: // $15
      var $16=$dev;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $18
      var $19=$dev;
      var $20=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($19);
      var $21=__ZNK18legacy_device_base13inline_configEv($20);
      var $22=$21;
      $swlist=$22;
      $i=0;
      __label__ = 3; break;
    case 3: // $23
      var $24=$i;
      var $25=(($24)|0) < 9;
      if ($25) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 4: // $26
      var $27=$i;
      var $28=$swlist;
      var $29=(($28)|0);
      var $30=(($29+($27<<2))|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 17; break; }
    case 5: // $33
      var $34=$swlist;
      var $35=(($34+40)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $38
      var $39=$1;
      var $40=__ZNK15running_machine7optionsEv($39);
      var $41=$i;
      var $42=$swlist;
      var $43=(($42)|0);
      var $44=(($43+($41<<2))|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=__Z18software_list_openR11emu_optionsPKciPFvS2_E($40, $45, 0, 0);
      $list=$46;
      var $47=$list;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $49
      $found=0;
      var $50=$list;
      var $51=__Z18software_list_findP14_software_listPKcP13software_info($50, ((STRING_TABLE.__str65891)|0), 0);
      $swinfo=$51;
      __label__ = 8; break;
    case 8: // $52
      var $53=$swinfo;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $55
      var $56=$swinfo;
      var $57=__Z18software_find_partP13software_infoPKcS2_($56, 0, 0);
      $part=$57;
      var $58=$interface;
      var $59=$part;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=_strcmp($58, $61);
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      $found=1;
      __label__ = 11; break;
    case 11: // $65
      __label__ = 12; break;
    case 12: // $66
      var $67=$list;
      var $68=$swinfo;
      var $69=__Z18software_list_findP14_software_listPKcP13software_info($67, ((STRING_TABLE.__str65891)|0), $68);
      $swinfo=$69;
      __label__ = 8; break;
    case 13: // $70
      var $71=$found;
      var $72=(($71) & 1);
      if ($72) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $73
      var $74=$2;
      var $75=$list;
      var $76=(($75+32)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$i;
      var $79=$swlist;
      var $80=(($79)|0);
      var $81=(($80+($78<<2))|0);
      var $82=HEAP32[(($81)>>2)];
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($74, $77, 0, 0, $82);
      __label__ = 15; break;
    case 15: // $83
      var $84=$list;
      __Z19software_list_closeP14_software_list($84);
      __label__ = 16; break;
    case 16: // $85
      __label__ = 17; break;
    case 17: // $86
      __label__ = 18; break;
    case 18: // $87
      var $88=$i;
      var $89=(($88+1)|0);
      $i=$89;
      __label__ = 3; break;
    case 19: // $90
      __label__ = 20; break;
    case 20: // $91
      var $92=$dev;
      var $93=__ZNK8device_t8typenextEv($92);
      $dev=$93;
      __label__ = 1; break;
    case 21: // $94
      var $95=$1;
      var $96=__ZNK15running_machine6configEv($95);
      var $97=__ZNK14machine_config10devicelistEv($96);
      var $98=HEAP32[((_SOFTWARE_LIST)>>2)];
      var $99=__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE($97, $98);
      $dev1=$99;
      __label__ = 22; break;
    case 22: // $100
      var $101=$dev1;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 23; break; } else { __label__ = 44; break; }
    case 23: // $103
      var $104=$dev1;
      var $105=__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_($104);
      var $106=__ZNK18legacy_device_base13inline_configEv($105);
      var $107=$106;
      $swlist2=$107;
      $i3=0;
      __label__ = 24; break;
    case 24: // $108
      var $109=$i3;
      var $110=(($109)|0) < 9;
      if ($110) { __label__ = 25; break; } else { __label__ = 42; break; }
    case 25: // $111
      var $112=$i3;
      var $113=$swlist2;
      var $114=(($113)|0);
      var $115=(($114+($112<<2))|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 26; break; } else { __label__ = 40; break; }
    case 26: // $118
      var $119=$swlist2;
      var $120=(($119+40)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121)|0)==1;
      if ($122) { __label__ = 27; break; } else { __label__ = 40; break; }
    case 27: // $123
      var $124=$1;
      var $125=__ZNK15running_machine7optionsEv($124);
      var $126=$i3;
      var $127=$swlist2;
      var $128=(($127)|0);
      var $129=(($128+($126<<2))|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=__Z18software_list_openR11emu_optionsPKciPFvS2_E($125, $130, 0, 0);
      $list4=$131;
      var $132=$list4;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 28; break; } else { __label__ = 39; break; }
    case 28: // $134
      $found5=0;
      var $135=$list4;
      var $136=__Z18software_list_findP14_software_listPKcP13software_info($135, ((STRING_TABLE.__str65891)|0), 0);
      $swinfo6=$136;
      __label__ = 29; break;
    case 29: // $137
      var $138=$swinfo6;
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $140
      var $141=$swinfo6;
      var $142=__Z18software_find_partP13software_infoPKcS2_($141, 0, 0);
      $part7=$142;
      var $143=$interface;
      var $144=$part7;
      var $145=(($144+4)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=_strcmp($143, $146);
      var $148=(($147)|0)==0;
      if ($148) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $149
      $found5=1;
      __label__ = 32; break;
    case 32: // $150
      __label__ = 33; break;
    case 33: // $151
      var $152=$list4;
      var $153=$swinfo6;
      var $154=__Z18software_list_findP14_software_listPKcP13software_info($152, ((STRING_TABLE.__str65891)|0), $153);
      $swinfo6=$154;
      __label__ = 29; break;
    case 34: // $155
      var $156=$found5;
      var $157=(($156) & 1);
      if ($157) { __label__ = 35; break; } else { __label__ = 38; break; }
    case 35: // $158
      var $159=$haveCompatible;
      var $160=(($159) & 1);
      if ($160) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $161
      var $162=$2;
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($162, ((STRING_TABLE.__str75892)|0), 0, 32, 0);
      __label__ = 37; break;
    case 37: // $163
      var $164=$2;
      var $165=$list4;
      var $166=(($165+32)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$i3;
      var $169=$swlist2;
      var $170=(($169)|0);
      var $171=(($170+($168<<2))|0);
      var $172=HEAP32[(($171)>>2)];
      __Z19ui_menu_item_appendP7ui_menuPKcS2_jPv($164, $167, 0, 0, $172);
      __label__ = 38; break;
    case 38: // $173
      $haveCompatible=1;
      var $174=$list4;
      __Z19software_list_closeP14_software_list($174);
      __label__ = 39; break;
    case 39: // $175
      __label__ = 40; break;
    case 40: // $176
      __label__ = 41; break;
    case 41: // $177
      var $178=$i3;
      var $179=(($178+1)|0);
      $i3=$179;
      __label__ = 24; break;
    case 42: // $180
      __label__ = 43; break;
    case 43: // $181
      var $182=$dev1;
      var $183=__ZNK8device_t8typenextEv($182);
      $dev1=$183;
      __label__ = 22; break;
    case 44: // $184
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL35ui_mess_menu_populate_software_listR15running_machineP7ui_menuP22device_image_interface["X"]=1;

function __ZL21append_software_entryP7ui_menuP20_software_menu_stateP13software_infoPcP22device_image_interface($menu, $menustate, $swinfo, $list_name, $image) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $entry;
      var $entryptr;
      var $interface;
      var $swpart;
      $1=$menu;
      $2=$menustate;
      $3=$swinfo;
      $4=$list_name;
      $5=$image;
      $entry=0;
      var $6=$5;
      var $7=$6;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+120)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=FUNCTION_TABLE[$10]($6);
      $interface=$11;
      var $12=$3;
      var $13=__Z18software_find_partP13software_infoPKcS2_($12, 0, 0);
      $swpart=$13;
      __label__ = 1; break;
    case 1: // $14
      var $15=$swpart;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $17
      var $18=$interface;
      var $19=$swpart;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=_strcmp($18, $21);
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$1;
      var $26=__Z18ui_menu_pool_allocP7ui_menuj($25, 24);
      var $27=$26;
      $entry=$27;
      var $28=$entry;
      var $29=$28;
      _memset($29, 0, 24, 1);
      var $30=$1;
      var $31=$3;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__Z19ui_menu_pool_strdupP7ui_menuPKc($30, $33);
      var $35=$entry;
      var $36=(($35+4)|0);
      HEAP32[(($36)>>2)]=$34;
      var $37=$1;
      var $38=$3;
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=__Z19ui_menu_pool_strdupP7ui_menuPKc($37, $40);
      var $42=$entry;
      var $43=(($42+8)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=$4;
      var $45=$entry;
      var $46=(($45+16)|0);
      HEAP32[(($46)>>2)]=$44;
      var $47=$5;
      var $48=$entry;
      var $49=(($48+20)|0);
      HEAP32[(($49)>>2)]=$47;
      var $50=$1;
      var $51=$swpart;
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=__Z19ui_menu_pool_strdupP7ui_menuPKc($50, $53);
      var $55=$entry;
      var $56=(($55+12)|0);
      HEAP32[(($56)>>2)]=$54;
      __label__ = 6; break;
    case 4: // $57
      __label__ = 5; break;
    case 5: // $58
      var $59=$swpart;
      var $60=__Z18software_part_nextP13software_part($59);
      $swpart=$60;
      __label__ = 1; break;
    case 6: // $61
      var $62=$2;
      var $63=(($62+8)|0);
      $entryptr=$63;
      __label__ = 7; break;
    case 7: // $64
      var $65=$entryptr;
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 8; break; } else { var $78 = 0;__label__ = 9; break; }
    case 8: // $68
      var $69=$entry;
      var $70=$entryptr;
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(($72+1036)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=__ZL24compare_software_entriesPK21_software_entry_stateS1_i($69, $71, $74);
      var $76=(($75)|0) >= 0;
      var $78 = $76;__label__ = 9; break;
    case 9: // $77
      var $78;
      if ($78) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $79
      var $80=$entryptr;
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81)|0);
      $entryptr=$82;
      __label__ = 7; break;
    case 11: // $83
      var $84=$entryptr;
      var $85=HEAP32[(($84)>>2)];
      var $86=$entry;
      var $87=(($86)|0);
      HEAP32[(($87)>>2)]=$85;
      var $88=$entry;
      var $89=$entryptr;
      HEAP32[(($89)>>2)]=$88;
      var $90=$entry;
      ;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21append_software_entryP7ui_menuP20_software_menu_stateP13software_infoPcP22device_image_interface["X"]=1;

function __ZL24compare_software_entriesPK21_software_entry_stateS1_i($e1, $e2, $shortname) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $e1_basename;
      var $e2_basename;
      $1=$e1;
      $2=$e2;
      $3=$shortname;
      var $4=$3;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $17 = $14;__label__ = 4; break;
    case 3: // $15
      var $17 = ((__str95894)|0);__label__ = 4; break;
    case 4: // $16
      var $17;
      $e1_basename=$17;
      var $18=$2;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$2;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $28 = $25;__label__ = 7; break;
    case 6: // $26
      var $28 = ((__str95894)|0);__label__ = 7; break;
    case 7: // $27
      var $28;
      $e2_basename=$28;
      __label__ = 15; break;
    case 8: // $29
      var $30=$1;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=HEAP32[(($36)>>2)];
      var $40 = $37;__label__ = 11; break;
    case 10: // $38
      var $40 = ((__str95894)|0);__label__ = 11; break;
    case 11: // $39
      var $40;
      $e1_basename=$40;
      var $41=$2;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $45
      var $46=$2;
      var $47=(($46+8)|0);
      var $48=HEAP32[(($47)>>2)];
      var $51 = $48;__label__ = 14; break;
    case 13: // $49
      var $51 = ((__str95894)|0);__label__ = 14; break;
    case 14: // $50
      var $51;
      $e2_basename=$51;
      __label__ = 15; break;
    case 15: // $52
      var $53=$e1_basename;
      var $54=$e2_basename;
      var $55=__Z12core_stricmpPKcS0_($53, $54);
      $result=$55;
      var $56=$result;
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $58
      var $59=$e1_basename;
      var $60=$e2_basename;
      var $61=_strcmp($59, $60);
      $result=$61;
      var $62=$result;
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $64
      var $65=$1;
      var $66=$2;
      var $67=(($65)>>>0) < (($66)>>>0);
      if ($67) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $68
      $result=-1;
      __label__ = 22; break;
    case 19: // $69
      var $70=$1;
      var $71=$2;
      var $72=(($70)>>>0) > (($71)>>>0);
      if ($72) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $73
      $result=1;
      __label__ = 21; break;
    case 21: // $74
      __label__ = 22; break;
    case 22: // $75
      __label__ = 23; break;
    case 23: // $76
      __label__ = 24; break;
    case 24: // $77
      var $78=$result;
      ;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24compare_software_entriesPK21_software_entry_stateS1_i["X"]=1;

function __Z14debug_get_helpPKc($tag) {
  var __stackBase__  = STACKTOP; STACKTOP += 256; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $found;
      var $i;
      var $msglen;
      var $foundcount;
      var $taglen;
      var $tagcopy=__stackBase__;
      $2=$tag;
      $found=0;
      $foundcount=0;
      var $3=$2;
      var $4=_strlen($3);
      $taglen=$4;
      $i=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$taglen;
      var $8=(($6)|0) <= (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$i;
      var $11=$2;
      var $12=(($11+$10)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=_tolower($14);
      var $16=(($15) & 255);
      var $17=$i;
      var $18=(($tagcopy+$17)|0);
      HEAP8[($18)]=$16;
      __label__ = 3; break;
    case 3: // $19
      var $20=$i;
      var $21=(($20+1)|0);
      $i=$21;
      __label__ = 1; break;
    case 4: // $22
      $i=0;
      __label__ = 5; break;
    case 5: // $23
      var $24=$i;
      var $25=(($24)>>>0) < 65;
      if ($25) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $26
      var $27=$i;
      var $28=((__ZL16static_help_list+($27<<3))|0);
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($tagcopy)|0);
      var $32=$taglen;
      var $33=_strncmp($30, $31, $32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $35
      var $36=$foundcount;
      var $37=(($36+1)|0);
      $foundcount=$37;
      var $38=$i;
      var $39=((__ZL16static_help_list+($38<<3))|0);
      $found=$39;
      var $40=$found;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=_strlen($42);
      var $44=$taglen;
      var $45=(($43)|0)==(($44)|0);
      if ($45) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      $foundcount=1;
      __label__ = 12; break;
    case 9: // $47
      __label__ = 10; break;
    case 10: // $48
      __label__ = 11; break;
    case 11: // $49
      var $50=$i;
      var $51=(($50+1)|0);
      $i=$51;
      __label__ = 5; break;
    case 12: // $52
      var $53=$foundcount;
      var $54=(($53)|0)==1;
      if ($54) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $55
      var $56=$found;
      var $57=(($56+4)|0);
      var $58=HEAP32[(($57)>>2)];
      $1=$58;
      __label__ = 23; break;
    case 14: // $59
      var $60=$foundcount;
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $62
      var $63=HEAP32[((((__ZL16static_help_list+4)|0))>>2)];
      $1=$63;
      __label__ = 23; break;
    case 16: // $64
      var $65=_sprintf(((__ZZ14debug_get_helpPKcE13ambig_message)|0), ((STRING_TABLE.__str5900)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $msglen=$65;
      $i=0;
      __label__ = 17; break;
    case 17: // $66
      var $67=$i;
      var $68=(($67)>>>0) < 65;
      if ($68) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $69
      var $70=$i;
      var $71=((__ZL16static_help_list+($70<<3))|0);
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($tagcopy)|0);
      var $75=$taglen;
      var $76=_strncmp($73, $74, $75);
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $78
      var $79=$msglen;
      var $80=((__ZZ14debug_get_helpPKcE13ambig_message+$79)|0);
      var $81=$i;
      var $82=((__ZL16static_help_list+($81<<3))|0);
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=_sprintf($80, ((STRING_TABLE.__str15901)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$84,tempInt));
      var $86=$msglen;
      var $87=(($86+$85)|0);
      $msglen=$87;
      __label__ = 20; break;
    case 20: // $88
      __label__ = 21; break;
    case 21: // $89
      var $90=$i;
      var $91=(($90+1)|0);
      $i=$91;
      __label__ = 17; break;
    case 22: // $92
      $1=((__ZZ14debug_get_helpPKcE13ambig_message)|0);
      __label__ = 23; break;
    case 23: // $93
      var $94=$1;
      STACKTOP = __stackBase__;
      return $94;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14debug_get_helpPKc["X"]=1;

function __ZL31construct_machine_config_pr8210R14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      var $10=$2;
      var $11=$3;
      var $12=HEAP32[((_I8049)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($10, $11, ((STRING_TABLE.__str6034)|0), $12, 4410000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; };
    case 4: // $14
      $device=$13;
      var $15=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($15, 2, 1338) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $16
      var $17=$3;
      $1=$17;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $18=$1;
      STACKTOP = __stackBase__;
      return $18;
    case 6: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0;
      $4=$21;
      var $22=$20.f1;
      $5=$22;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      var $25=$4;
      var $26=$4;
      var $27=$5;
      var $28=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $26, tempValue);
      var $29=($28.f1 = $27, $28);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13pr8210_updateP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $player;
      var $spdl_on;
      $1=$ld;
      $2=$vbi;
      $3=$fieldnum;
      var $4=$1;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      $player=$6;
      var $7=$player;
      var $8=(($7+88)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 & 16;
      var $12=(($11)|0)!=0;
      var $13=$12 ^ 1;
      var $14=(($13)&1);
      $spdl_on=$14;
      var $15=$spdl_on;
      var $16=(($15 << 24) >> 24)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$3;
      var $21 = $18;__label__ = 3; break;
    case 2: // $19
      var $21 = 0;__label__ = 3; break;
    case 3: // $20
      var $21;
      STACKTOP = __stackBase__;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16simutrek_ready_rP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+92)|0);
  var $6=(($5+6)|0);
  var $7=HEAP8[($6)];
  var $8=(($7 << 24) >> 24)!=0;
  var $9=$8 ^ 1;
  var $10=(($9)&1);
  ;
  return $10;
}


function __ZL17simutrek_status_rP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+92)|0);
  var $6=(($5+7)|0);
  var $7=HEAPU8[($6)];
  var $8=(($7)&255);
  var $9=$8 & 3;
  var $10=(($9)|0)==3;
  var $11=$10 ? 1 : 0;
  var $12=(($11) & 255);
  ;
  return $12;
}


function __ZL23simutrek_latched_data_wR15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  var $player;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  $player=$8;
  var $9=$3;
  var $10=(($9) & 255);
  var $11=$player;
  var $12=(($11+92)|0);
  var $13=(($12+5)|0);
  HEAP8[($13)]=$10;
  var $14=$player;
  var $15=(($14+92)|0);
  var $16=(($15+6)|0);
  HEAP8[($16)]=1;
  ;
  return;
}


function __ZL12pr8210_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $player;
  var $4=__stackBase__;
  var $5=__stackBase__+12;
  var $6=__stackBase__+24;
  $1=$ld;
  $2=$vbi;
  $3=$fieldnum;
  var $7=$1;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  $player=$9;
  var $10=$player;
  var $11=(($10+87)|0);
  HEAP8[($11)]=1;
  var $12=$1;
  var $13=(($12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=__ZNK8device_t7machineEv($14);
  var $16=__ZN15running_machine9schedulerEv($15);
  var $17=$1;
  var $18=(($17+4)|0);
  var $19=HEAP32[(($18)>>2)];
  __ZNK13screen_device11scan_periodEv($5, $19);
  __ZmlRK8attotimej($4, $5, 4);
  var $20=$1;
  var $21=$20;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($16, $4, 1344, ((STRING_TABLE.__str166054)|0), 0, $21);
  var $22=$1;
  var $23=(($22)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=__ZNK8device_t7machineEv($24);
  var $26=__ZN15running_machine9schedulerEv($25);
  var $27=$1;
  var $28=(($27+4)|0);
  var $29=HEAP32[(($28)>>2)];
  __ZNK13screen_device14time_until_posEii($6, $29, 38, 0);
  var $30=$1;
  var $31=$30;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($26, $6, 1346, ((STRING_TABLE.__str176055)|0), 0, $31);
  STACKTOP = __stackBase__;
  return;
}


function __ZL14pr8210_overlayP16_laserdisc_stateP8bitmap_t($ld, $bitmap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $player;
      $1=$ld;
      $2=$bitmap;
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=HEAP32[(($4)>>2)];
      $player=$5;
      var $6=$player;
      var $7=(($6+56)|0);
      var $8=(($7+27)|0);
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      var $13=$player;
      var $14=(($13+56)|0);
      var $15=(($14+7)|0);
      var $16=(($15+2)|0);
      __ZL18overlay_draw_groupP8bitmap_tPKhif($12, $16, 5, 0.22499999403953552);
      var $17=$2;
      var $18=$player;
      var $19=(($18+56)|0);
      var $20=(($19+7)|0);
      var $21=(($20+7)|0);
      __ZL18overlay_draw_groupP8bitmap_tPKhif($17, $21, 5, 0.4472222328186035);
      var $22=$2;
      var $23=$player;
      var $24=(($23+56)|0);
      var $25=(($24+7)|0);
      var $26=(($25+12)|0);
      __ZL18overlay_draw_groupP8bitmap_tPKhif($22, $26, 5, 0.6708333492279053);
      __label__ = 7; break;
    case 2: // $27
      var $28=$player;
      var $29=(($28+56)|0);
      var $30=(($29+25)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=$32 & 2;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$2;
      var $37=$player;
      var $38=(($37+56)|0);
      var $39=(($38+7)|0);
      var $40=(($39+2)|0);
      __ZL18overlay_draw_groupP8bitmap_tPKhif($36, $40, 5, 0.22499999403953552);
      __label__ = 4; break;
    case 4: // $41
      var $42=$player;
      var $43=(($42+56)|0);
      var $44=(($43+25)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$46 & 1;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $49
      var $50=$2;
      var $51=$player;
      var $52=(($51+56)|0);
      var $53=(($52+7)|0);
      var $54=(($53)|0);
      __ZL18overlay_draw_groupP8bitmap_tPKhif($50, $54, 2, 0.11388888955116272);
      __label__ = 6; break;
    case 6: // $55
      __label__ = 7; break;
    case 7: // $56
      var $57=$player;
      var $58=(($57+56)|0);
      var $59=(($58+25)|0);
      HEAP8[($59)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14pr8210_overlayP16_laserdisc_stateP8bitmap_t["X"]=1;

function __ZL16pr8210_control_wP16_laserdisc_statehh($ld, $prev, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 156; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $player;
      var $curtime=__stackBase__;
      var $delta=__stackBase__+12;
      var $overalldelta=__stackBase__+24;
      var $longpulse;
      var $4=__stackBase__+36;
      var $5=__stackBase__+48;
      var $6=__stackBase__+60;
      var $7=__stackBase__+72;
      var $8=__stackBase__+84;
      var $newcommand;
      var $rejectuntil=__stackBase__+96;
      var $9=__stackBase__+108;
      var $10=__stackBase__+120;
      var $11=__stackBase__+132;
      var $12=__stackBase__+144;
      $1=$ld;
      $2=$prev;
      $3=$data;
      var $13=$1;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      $player=$15;
      var $16=$2;
      var $17=(($16)&255);
      var $18=(($17)|0)!=1;
      if ($18) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $19
      var $20=$3;
      var $21=(($20)&255);
      var $22=(($21)|0)==1;
      if ($22) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $23
      var $24=$1;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZNK8device_t7machineEv($26);
      __ZNK15running_machine4timeEv($curtime, $27);
      __ZN8attotimeC1Ev($delta);
      __ZN8attotimeC1Ev($overalldelta);
      var $28=$player;
      var $29=(($28+16)|0);
      __ZmiRK8attotimeS1_($4, $curtime, $29);
      var $30=$delta;
      var $31=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($30)>>2)]=HEAP32[(($31)>>2)];HEAP32[(($30+4)>>2)]=HEAP32[(($31+4)>>2)];HEAP32[(($30+8)>>2)]=HEAP32[(($31+8)>>2)];
      var $32=$player;
      var $33=(($32+16)|0);
      var $34=$33;
      var $35=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];HEAP32[(($34+4)>>2)]=HEAP32[(($35+4)>>2)];HEAP32[(($34+8)>>2)]=HEAP32[(($35+8)>>2)];
      var $36=$player;
      var $37=(($36+28)|0);
      __ZmiRK8attotimeS1_($5, $curtime, $37);
      var $38=$overalldelta;
      var $39=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($38)>>2)]=HEAP32[(($39)>>2)];HEAP32[(($38+4)>>2)]=HEAP32[(($39+4)>>2)];HEAP32[(($38+8)>>2)]=HEAP32[(($39+8)>>2)];
      __ZN8attotime7from_hzEd($6, 39.49652777777778);
      var $40=__ZgtRK8attotimeS1_($overalldelta, $6);
      if ($40) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $41
      __ZN8attotime7from_hzEd($7, 111.083984375);
      var $42=__ZgtRK8attotimeS1_($delta, $7);
      if ($42) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $43
      var $44=$player;
      var $45=(($44+28)|0);
      var $46=$45;
      var $47=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($46)>>2)]=HEAP32[(($47)>>2)];HEAP32[(($46+4)>>2)]=HEAP32[(($47+4)>>2)];HEAP32[(($46+8)>>2)]=HEAP32[(($47+8)>>2)];
      var $48=$player;
      var $49=(($48+2)|0);
      HEAP16[(($49)>>1)]=21845;
      __label__ = 5; break;
    case 5: // $50
      __ZN8attotime7from_hzEd($8, 758.3333333333334);
      var $51=__ZltRK8attotimeS1_($delta, $8);
      var $52=$51 ? 0 : 1;
      $longpulse=$52;
      var $53=$player;
      var $54=(($53+2)|0);
      var $55=HEAPU16[(($54)>>1)];
      var $56=(($55)&65535);
      var $57=$56 << 1;
      var $58=$longpulse;
      var $59=$57 | $58;
      var $60=(($59) & 65535);
      var $61=$player;
      var $62=(($61+2)|0);
      HEAP16[(($62)>>1)]=$60;
      var $63=$player;
      var $64=(($63+2)|0);
      var $65=HEAPU16[(($64)>>1)];
      var $66=(($65)&65535);
      var $67=$66 & 899;
      var $68=(($67)|0)==128;
      if ($68) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $69
      var $70=$player;
      var $71=(($70+2)|0);
      var $72=HEAPU16[(($71)>>1)];
      var $73=(($72)&65535);
      var $74=$73 >> 2;
      var $75=$74 & 31;
      var $76=(($75) & 255);
      $newcommand=$76;
      __ZN8attotimeC1Ev($rejectuntil);
      var $77=$newcommand;
      var $78=(($77)&255);
      var $79=$78 >> 0;
      var $80=$79 & 1;
      var $81=$80 << 7;
      var $82=$newcommand;
      var $83=(($82)&255);
      var $84=$83 >> 1;
      var $85=$84 & 1;
      var $86=$85 << 6;
      var $87=$81 | $86;
      var $88=$newcommand;
      var $89=(($88)&255);
      var $90=$89 >> 2;
      var $91=$90 & 1;
      var $92=$91 << 5;
      var $93=$87 | $92;
      var $94=$newcommand;
      var $95=(($94)&255);
      var $96=$95 >> 3;
      var $97=$96 & 1;
      var $98=$97 << 4;
      var $99=$93 | $98;
      var $100=$newcommand;
      var $101=(($100)&255);
      var $102=$101 >> 4;
      var $103=$102 & 1;
      var $104=$103 << 3;
      var $105=$99 | $104;
      var $106=$newcommand;
      var $107=(($106)&255);
      var $108=$107 >> 5;
      var $109=$108 & 1;
      var $110=$109 << 2;
      var $111=$105 | $110;
      var $112=$newcommand;
      var $113=(($112)&255);
      var $114=$113 >> 6;
      var $115=$114 & 1;
      var $116=$115 << 1;
      var $117=$111 | $116;
      var $118=$newcommand;
      var $119=(($118)&255);
      var $120=$119 >> 7;
      var $121=$120 & 1;
      var $122=$121 << 0;
      var $123=$117 | $122;
      var $124=(($123) & 255);
      var $125=$player;
      var $126=(($125+56)|0);
      var $127=(($126+28)|0);
      HEAP8[($127)]=$124;
      var $128=$player;
      var $129=(($128+4)|0);
      __ZN8attotime7from_hzEd($10, 9.874131944444445);
      __ZplRK8attotimeS1_($9, $129, $10);
      var $130=$rejectuntil;
      var $131=$9;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($130)>>2)]=HEAP32[(($131)>>2)];HEAP32[(($130+4)>>2)]=HEAP32[(($131+4)>>2)];HEAP32[(($130+8)>>2)]=HEAP32[(($131+8)>>2)];
      var $132=$player;
      var $133=(($132+4)|0);
      var $134=$133;
      var $135=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($134)>>2)]=HEAP32[(($135)>>2)];HEAP32[(($134+4)>>2)]=HEAP32[(($135+4)>>2)];HEAP32[(($134+8)>>2)]=HEAP32[(($135+8)>>2)];
      var $136=$player;
      var $137=(($136+56)|0);
      var $138=(($137+28)|0);
      var $139=HEAPU8[($138)];
      var $140=(($139)&255);
      var $141=$player;
      var $142=(($141)|0);
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=(($140)|0)==(($144)|0);
      if ($145) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $146
      var $147=__ZltRK8attotimeS1_($curtime, $rejectuntil);
      if ($147) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $148
      var $149=$player;
      var $150=(($149+56)|0);
      var $151=(($150+28)|0);
      HEAP8[($151)]=0;
      __label__ = 10; break;
    case 9: // $152
      var $153=$player;
      var $154=(($153+56)|0);
      var $155=(($154+28)|0);
      var $156=HEAP8[($155)];
      var $157=$player;
      var $158=(($157)|0);
      HEAP8[($158)]=$156;
      __label__ = 10; break;
    case 10: // $159
      var $160=$player;
      var $161=(($160+28)|0);
      __ZN8attotime7from_hzEd($12, 39.49652777777778);
      __ZmiRK8attotimeS1_($11, $curtime, $12);
      var $162=$161;
      var $163=$11;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($162)>>2)]=HEAP32[(($163)>>2)];HEAP32[(($162+4)>>2)]=HEAP32[(($163+4)>>2)];HEAP32[(($162+8)>>2)]=HEAP32[(($163+8)>>2)];
      __label__ = 11; break;
    case 11: // $164
      __label__ = 12; break;
    case 12: // $165
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16pr8210_control_wP16_laserdisc_statehh["X"]=1;

function __ZL14simutrek_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $player;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      $1=$ld;
      $2=$vbi;
      $3=$fieldnum;
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      var $9=$3;
      var $10=(($9)|0)==1;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$player;
      var $13=(($12+92)|0);
      var $14=(($13+8)|0);
      var $15=HEAP8[($14)];
      var $16=$player;
      var $17=(($16+92)|0);
      var $18=(($17+9)|0);
      HEAP8[($18)]=$15;
      var $19=$player;
      var $20=(($19+92)|0);
      var $21=(($20+8)|0);
      HEAP8[($21)]=0;
      __label__ = 2; break;
    case 2: // $22
      var $23=$1;
      var $24=$2;
      var $25=$3;
      var $26=$4;
      var $27=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($26)>>2)]=HEAP32[(($27)>>2)];HEAP32[(($26+4)>>2)]=HEAP32[(($27+4)>>2)];HEAP32[(($26+8)>>2)]=HEAP32[(($27+8)>>2)];
      __ZL12pr8210_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime($23, $24, $25, $4);
      var $28=$player;
      var $29=(($28+92)|0);
      var $30=(($29+6)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24)!=0;
      if ($32) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $33
      var $34=$player;
      var $35=(($34+92)|0);
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      __Z21device_set_input_lineP8device_tii($37, 0, 1);
      var $38=$1;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=__ZNK8device_t7machineEv($40);
      var $42=__ZN15running_machine9schedulerEv($41);
      var $43=$1;
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      __ZNK13screen_device11scan_periodEv($5, $45);
      var $46=$1;
      var $47=$46;
      __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($42, $5, 1348, ((STRING_TABLE.__str106048)|0), 0, $47);
      __label__ = 4; break;
    case 4: // $48
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14simutrek_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime["X"]=1;

function __ZL15simutrek_updateP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$ld;
  $2=$vbi;
  $3=$fieldnum;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=$curtime;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[(($9+4)>>2)];HEAP32[(($8+8)>>2)]=HEAP32[(($9+8)>>2)];
  var $10=__ZL13pr8210_updateP16_laserdisc_statePK13_vbi_metadatai8attotime($5, $6, $7, $4);
  STACKTOP = __stackBase__;
  return $10;
}


function __ZL15simutrek_data_wP16_laserdisc_statehh($ld, $prev, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$ld;
  $2=$prev;
  $3=$data;
  var $4=$1;
  var $5=(($4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=__ZNK8device_t7machineEv($6);
  var $8=__ZN15running_machine9schedulerEv($7);
  var $9=$3;
  var $10=(($9)&255);
  var $11=$1;
  var $12=$11;
  __ZN16device_scheduler11synchronizeEPFvR15running_machinePviEPKciS2_($8, 1350, ((STRING_TABLE.__str96047)|0), $10, $12);
  ;
  return;
}


function __ZL20update_audio_squelchP16_laserdisc_state($ld) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $player;
      $1=$ld;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      $player=$4;
      var $5=$player;
      var $6=(($5+92)|0);
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $10
      var $11=$1;
      var $12=$player;
      var $13=(($12+88)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 64;
      var $17=(($16)|0)!=0;
      if ($17) { var $28 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $18
      var $19=$player;
      var $20=(($19+56)|0);
      var $21=(($20+26)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 & 1;
      var $25=(($24)|0)!=0;
      var $26=$25 ^ 1;
      var $28 = $26;__label__ = 3; break;
    case 3: // $27
      var $28;
      var $29=(($28)&1);
      var $30=$player;
      var $31=(($30+88)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$33 & 64;
      var $35=(($34)|0)!=0;
      if ($35) { var $46 = 1;__label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $36
      var $37=$player;
      var $38=(($37+56)|0);
      var $39=(($38+26)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$41 & 2;
      var $43=(($42)|0)!=0;
      var $44=$43 ^ 1;
      var $46 = $44;__label__ = 5; break;
    case 5: // $45
      var $46;
      var $47=(($46)&1);
      __Z24ldcore_set_audio_squelchP16_laserdisc_statehh($11, $29, $47);
      __label__ = 7; break;
    case 6: // $48
      var $49=$1;
      var $50=$player;
      var $51=(($50+92)|0);
      var $52=(($51+4)|0);
      var $53=HEAP8[($52)];
      var $54=$player;
      var $55=(($54+92)|0);
      var $56=(($55+4)|0);
      var $57=HEAP8[($56)];
      __Z24ldcore_set_audio_squelchP16_laserdisc_statehh($49, $53, $57);
      __label__ = 7; break;
    case 7: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20update_audio_squelchP16_laserdisc_state["X"]=1;

function __ZL7irq_offR15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  var $player;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  $player=$8;
  var $9=$player;
  var $10=(($9+92)|0);
  var $11=(($10)|0);
  var $12=HEAP32[(($11)>>2)];
  __Z21device_set_input_lineP8device_tii($12, 0, 0);
  ;
  return;
}


function __ZL38construct_address_map_simutrek_portmapR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 2, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 255, $5);
  $curentry=$6;
  var $7=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($7, 1352, ((STRING_TABLE.__str126050)|0));
  var $8=$1;
  var $9=$curentry;
  var $10=__ZN11address_map3addEjjP18address_map_entry8($8, 258, 258, $9);
  $curentry=$10;
  var $11=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($11, 1354, ((STRING_TABLE.__str136051)|0), 1356, ((STRING_TABLE.__str146052)|0));
  var $12=$1;
  var $13=$curentry;
  var $14=__ZN11address_map3addEjjP18address_map_entry8($12, 272, 272, $13);
  $curentry=$14;
  var $15=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($15, 1358, ((STRING_TABLE.__str156053)|0));
  ;
  return;
}


function __ZL15simutrek_data_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  var $player;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  $player=$9;
  var $10=$player;
  var $11=(($10+92)|0);
  var $12=(($11+6)|0);
  HEAP8[($12)]=0;
  var $13=$player;
  var $14=(($13+92)|0);
  var $15=(($14+5)|0);
  var $16=HEAP8[($15)];
  ;
  return $16;
}


function __ZL16simutrek_port2_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  var $player;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  $player=$9;
  var $10=$player;
  var $11=(($10+88)|0);
  var $12=HEAPU8[($11)];
  var $13=(($12)&255);
  var $14=$13 & 32;
  var $15=(($14)|0)!=0;
  var $16=$15 ? 0 : 128;
  var $17=(($16) & 255);
  ;
  return $17;
}


function __ZL11pr8210_initP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tempstring=__stackBase__;
      var $curtime=__stackBase__+64;
      var $2;
      var $3;
      var $player;
      $1=$ld;
      __ZN7astringC1Ev($tempstring);
      var $4=$1;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(function() { try { __THREW__ = false; return __ZNK8device_t7machineEv($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 7; break; };
    case 1: // $8
      (function() { try { __THREW__ = false; return __ZNK15running_machine4timeEv($curtime, $7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      $player=$12;
      var $13=$player;
      var $14=$13;
      _memset($14, 0, 104, 1);
      var $15=$player;
      var $16=(($15+4)|0);
      var $17=$16;
      var $18=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];HEAP32[(($17+4)>>2)]=HEAP32[(($18+4)>>2)];HEAP32[(($17+8)>>2)]=HEAP32[(($18+8)>>2)];
      var $19=$player;
      var $20=(($19+28)|0);
      var $21=$20;
      var $22=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($21)>>2)]=HEAP32[(($22)>>2)];HEAP32[(($21+4)>>2)]=HEAP32[(($22+4)>>2)];HEAP32[(($21+8)>>2)]=HEAP32[(($22+8)>>2)];
      var $23=$player;
      var $24=(($23+16)|0);
      var $25=$24;
      var $26=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($25)>>2)]=HEAP32[(($26)>>2)];HEAP32[(($25+4)>>2)]=HEAP32[(($26+4)>>2)];HEAP32[(($25+8)>>2)]=HEAP32[(($26+8)>>2)];
      var $27=$player;
      var $28=(($27+44)|0);
      var $29=$28;
      var $30=$curtime;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($29)>>2)]=HEAP32[(($30)>>2)];HEAP32[(($29+4)>>2)]=HEAP32[(($30+4)>>2)];HEAP32[(($29+8)>>2)]=HEAP32[(($30+8)>>2)];
      var $31=$1;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($33, ((STRING_TABLE.__str6034)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $35
      var $36=$player;
      var $37=(($36+40)|0);
      HEAP32[(($37)>>2)]=$34;
      __label__ = 4; break;
    case 4: // $38
      __label__ = 5; break;
    case 5: // $39
      __label__ = 6; break;
    case 6: // $40
      var $41=$player;
      var $42=(($41+92)|0);
      var $43=(($42)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=$player;
      var $45=(($44+92)|0);
      var $46=(($45+4)|0);
      HEAP8[($46)]=0;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 7: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $2=$49;
      var $50=$48.f1;
      $3=$50;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $51
      __label__ = 9; break;
    case 9: // $52
      var $53=$2;
      var $54=$2;
      var $55=$3;
      var $56=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $54, tempValue);
      var $57=($56.f1 = $55, $56);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $58
      var $59=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11pr8210_initP16_laserdisc_state["X"]=1;

function __ZL33construct_machine_config_simutrekR14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      var $10=$2;
      var $11=$3;
      var $12=HEAP32[((_I8748)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($10, $11, ((STRING_TABLE.__str46040)|0), $12, 6000000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $14
      $device=$13;
      var $15=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($15, 2, 1342) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $16
      var $17=$2;
      var $18=$3;
      var $19=(function() { try { __THREW__ = false; return __ZL31construct_machine_config_pr8210R14machine_configP8device_t($17, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $20
      var $21=$3;
      $1=$21;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $22=$1;
      STACKTOP = __stackBase__;
      return $22;
    case 7: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $4=$25;
      var $26=$24.f1;
      $5=$26;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $27
      __label__ = 9; break;
    case 9: // $28
      var $29=$4;
      var $30=$4;
      var $31=$5;
      var $32=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30, tempValue);
      var $33=($32.f1 = $31, $32);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $34
      var $35=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13simutrek_initP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tempstring=__stackBase__;
      var $player;
      var $2;
      var $3;
      $1=$ld;
      __ZN7astringC1Ev($tempstring);
      var $4=$1;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      $player=$6;
      var $7=$1;
      (function() { try { __THREW__ = false; return __ZL11pr8210_initP16_laserdisc_state($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=$player;
      var $10=(($9+92)|0);
      var $11=(($10+6)|0);
      HEAP8[($11)]=1;
      var $12=$1;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($14, ((STRING_TABLE.__str46040)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; };
    case 2: // $16
      var $17=$player;
      var $18=(($17+92)|0);
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$15;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 3: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $2=$22;
      var $23=$21.f1;
      $3=$23;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$2;
      var $27=$2;
      var $28=$3;
      var $29=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $27, tempValue);
      var $30=($29.f1 = $28, $29);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13overlay_eraseP8bitmap_tff($bitmap, $xstart, $xend) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $xmin;
      var $xmax;
      var $x;
      var $y;
      var $dest;
      var $ymin;
      var $ymax;
      var $yres;
      $1=$bitmap;
      $2=$xstart;
      $3=$xend;
      var $4=$2;
      var $5=$4*256;
      var $6=$1;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0);
      var $11=$5*$10;
      var $12=($11 >= 0 ? Math.floor($11) : Math.ceil($11));
      $xmin=$12;
      var $13=$3;
      var $14=$13*256;
      var $15=$1;
      var $16=$15;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0);
      var $20=$14*$19;
      var $21=($20 >= 0 ? Math.floor($20) : Math.ceil($20));
      $xmax=$21;
      $y=52;
      __label__ = 1; break;
    case 1: // $22
      var $23=$y;
      var $24=(($23)>>>0) < 70;
      if ($24) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $25
      var $26=$1;
      var $27=$26;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=$y;
      var $32=$1;
      var $33=$32;
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($31*$35)|0);
      var $37=(($30+($36<<1))|0);
      var $38=$xmin;
      var $39=$38 >>> 8;
      var $40=(($37+($39<<1))|0);
      $dest=$40;
      var $41=$dest;
      var $42=HEAPU16[(($41)>>1)];
      var $43=(($42)&65535);
      var $44=$43 >> 8;
      var $45=(($44) & 65535);
      $ymax=$45;
      var $46=$ymax;
      var $47=(($46)&65535);
      var $48=(($47*3)|0);
      var $49=(((($48)|0)/8)|0);
      var $50=(($49) & 65535);
      $ymin=$50;
      var $51=$ymin;
      var $52=(($51)&65535);
      var $53=$ymax;
      var $54=(($53)&65535);
      var $55=$ymin;
      var $56=(($55)&65535);
      var $57=(($54-$56)|0);
      var $58=$xmin;
      var $59=$58 & 255;
      var $60=(($57*$59)|0);
      var $61=Math.floor((($60)>>>0)/256);
      var $62=(($52+$61)|0);
      var $63=(($62) & 65535);
      $yres=$63;
      var $64=$yres;
      var $65=(($64)&65535);
      var $66=$65 << 8;
      var $67=$dest;
      var $68=HEAPU16[(($67)>>1)];
      var $69=(($68)&65535);
      var $70=$69 & 255;
      var $71=$66 | $70;
      var $72=(($71) & 65535);
      var $73=$dest;
      HEAP16[(($73)>>1)]=$72;
      var $74=$dest;
      var $75=(($74+2)|0);
      $dest=$75;
      var $76=$xmin;
      var $77=$76 | 255;
      var $78=(($77+1)|0);
      $x=$78;
      __label__ = 3; break;
    case 3: // $79
      var $80=$x;
      var $81=$xmax;
      var $82=(($80)>>>0) < (($81)>>>0);
      if ($82) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $83
      var $84=$dest;
      var $85=HEAPU16[(($84)>>1)];
      var $86=(($85)&65535);
      var $87=$86 >> 8;
      var $88=(($87*3)|0);
      var $89=(((($88)|0)/8)|0);
      var $90=(($89) & 65535);
      $yres=$90;
      var $91=$yres;
      var $92=(($91)&65535);
      var $93=$92 << 8;
      var $94=$dest;
      var $95=HEAPU16[(($94)>>1)];
      var $96=(($95)&65535);
      var $97=$96 & 255;
      var $98=$93 | $97;
      var $99=(($98) & 65535);
      var $100=$dest;
      HEAP16[(($100)>>1)]=$99;
      var $101=$dest;
      var $102=(($101+2)|0);
      $dest=$102;
      __label__ = 5; break;
    case 5: // $103
      var $104=$x;
      var $105=(($104+256)|0);
      $x=$105;
      __label__ = 3; break;
    case 6: // $106
      var $107=$dest;
      var $108=HEAPU16[(($107)>>1)];
      var $109=(($108)&65535);
      var $110=$109 >> 8;
      var $111=(($110) & 65535);
      $ymax=$111;
      var $112=$ymax;
      var $113=(($112)&65535);
      var $114=(($113*3)|0);
      var $115=(((($114)|0)/8)|0);
      var $116=(($115) & 65535);
      $ymin=$116;
      var $117=$ymin;
      var $118=(($117)&65535);
      var $119=$ymax;
      var $120=(($119)&65535);
      var $121=$ymin;
      var $122=(($121)&65535);
      var $123=(($120-$122)|0);
      var $124=$xmax;
      var $125=$124 ^ -1;
      var $126=$125 & 255;
      var $127=(($123*$126)|0);
      var $128=Math.floor((($127)>>>0)/256);
      var $129=(($118+$128)|0);
      var $130=(($129) & 65535);
      $yres=$130;
      var $131=$yres;
      var $132=(($131)&65535);
      var $133=$132 << 8;
      var $134=$dest;
      var $135=HEAPU16[(($134)>>1)];
      var $136=(($135)&65535);
      var $137=$136 & 255;
      var $138=$133 | $137;
      var $139=(($138) & 65535);
      var $140=$dest;
      HEAP16[(($140)>>1)]=$139;
      var $141=$dest;
      var $142=(($141+2)|0);
      $dest=$142;
      __label__ = 7; break;
    case 7: // $143
      var $144=$y;
      var $145=(($144+1)|0);
      $y=$145;
      __label__ = 1; break;
    case 8: // $146
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13overlay_eraseP8bitmap_tff["X"]=1;

function __ZL17overlay_draw_charP8bitmap_thf($bitmap, $ch, $xstart) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $xminbase;
      var $xsize;
      var $chdataptr;
      var $x;
      var $y;
      var $xx;
      var $yy;
      var $chdata;
      var $xmin;
      var $xmax;
      var $dest;
      var $ymin;
      var $ymax;
      var $yres;
      $1=$bitmap;
      $2=$ch;
      $3=$xstart;
      var $4=$3;
      var $5=$4*256;
      var $6=$1;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0);
      var $11=$5*$10;
      var $12=($11 >= 0 ? Math.floor($11) : Math.ceil($11));
      $xminbase=$12;
      var $13=$1;
      var $14=$13;
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0);
      var $18=$17*1.600000023841858;
      var $19=($18 >= 0 ? Math.floor($18) : Math.ceil($18));
      $xsize=$19;
      var $20=$2;
      var $21=(($20)&255);
      var $22=$21 & 63;
      var $23=((STRING_TABLE.__ZL11text_bitmap+$22*7)|0);
      var $24=(($23)|0);
      $chdataptr=$24;
      $y=0;
      __label__ = 1; break;
    case 1: // $25
      var $26=$y;
      var $27=(($26)>>>0) < 7;
      if ($27) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $28
      var $29=$chdataptr;
      var $30=(($29+1)|0);
      $chdataptr=$30;
      var $31=HEAP8[($29)];
      $chdata=$31;
      $x=0;
      __label__ = 3; break;
    case 3: // $32
      var $33=$x;
      var $34=(($33)>>>0) < 5;
      if ($34) { __label__ = 4; break; } else { __label__ = 16; break; }
    case 4: // $35
      var $36=$chdata;
      var $37=(($36)&255);
      var $38=$37 & 128;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $40
      var $41=$xminbase;
      var $42=$x;
      var $43=$xsize;
      var $44=(($42*$43)|0);
      var $45=(($41+$44)|0);
      $xmin=$45;
      var $46=$xmin;
      var $47=$xsize;
      var $48=(($46+$47)|0);
      $xmax=$48;
      $yy=0;
      __label__ = 6; break;
    case 6: // $49
      var $50=$yy;
      var $51=(($50)>>>0) < 2;
      if ($51) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $52
      var $53=$1;
      var $54=$53;
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56;
      var $58=$y;
      var $59=(($58+1)|0);
      var $60=((($59<<1))|0);
      var $61=(($60+52)|0);
      var $62=$yy;
      var $63=(($61+$62)|0);
      var $64=$1;
      var $65=$64;
      var $66=(($65+8)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($63*$67)|0);
      var $69=(($57+($68<<1))|0);
      var $70=$xmin;
      var $71=$70 >>> 8;
      var $72=(($69+($71<<1))|0);
      $dest=$72;
      $ymax=255;
      var $73=$dest;
      var $74=HEAPU16[(($73)>>1)];
      var $75=(($74)&65535);
      var $76=$75 >> 8;
      var $77=(($76) & 65535);
      $ymin=$77;
      var $78=$ymin;
      var $79=(($78)&65535);
      var $80=$ymax;
      var $81=(($80)&65535);
      var $82=$ymin;
      var $83=(($82)&65535);
      var $84=(($81-$83)|0);
      var $85=$xmin;
      var $86=$85 ^ -1;
      var $87=$86 & 255;
      var $88=(($84*$87)|0);
      var $89=Math.floor((($88)>>>0)/256);
      var $90=(($79+$89)|0);
      var $91=(($90) & 65535);
      $yres=$91;
      var $92=$yres;
      var $93=(($92)&65535);
      var $94=$93 << 8;
      var $95=$dest;
      var $96=HEAPU16[(($95)>>1)];
      var $97=(($96)&65535);
      var $98=$97 & 255;
      var $99=$94 | $98;
      var $100=(($99) & 65535);
      var $101=$dest;
      HEAP16[(($101)>>1)]=$100;
      var $102=$dest;
      var $103=(($102+2)|0);
      $dest=$103;
      var $104=$xmin;
      var $105=$104 | 255;
      var $106=(($105+1)|0);
      $xx=$106;
      __label__ = 8; break;
    case 8: // $107
      var $108=$xx;
      var $109=$xmax;
      var $110=(($108)>>>0) < (($109)>>>0);
      if ($110) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $111
      var $112=$dest;
      var $113=(($112+2)|0);
      $dest=$113;
      HEAP16[(($112)>>1)]=-3968;
      __label__ = 10; break;
    case 10: // $114
      var $115=$xx;
      var $116=(($115+256)|0);
      $xx=$116;
      __label__ = 8; break;
    case 11: // $117
      $ymax=255;
      var $118=$dest;
      var $119=HEAPU16[(($118)>>1)];
      var $120=(($119)&65535);
      var $121=$120 >> 8;
      var $122=(($121) & 65535);
      $ymin=$122;
      var $123=$ymin;
      var $124=(($123)&65535);
      var $125=$ymax;
      var $126=(($125)&65535);
      var $127=$ymin;
      var $128=(($127)&65535);
      var $129=(($126-$128)|0);
      var $130=$xmax;
      var $131=$130 & 255;
      var $132=(($129*$131)|0);
      var $133=Math.floor((($132)>>>0)/256);
      var $134=(($124+$133)|0);
      var $135=(($134) & 65535);
      $yres=$135;
      var $136=$yres;
      var $137=(($136)&65535);
      var $138=$137 << 8;
      var $139=$dest;
      var $140=HEAPU16[(($139)>>1)];
      var $141=(($140)&65535);
      var $142=$141 & 255;
      var $143=$138 | $142;
      var $144=(($143) & 65535);
      var $145=$dest;
      HEAP16[(($145)>>1)]=$144;
      var $146=$dest;
      var $147=(($146+2)|0);
      $dest=$147;
      __label__ = 12; break;
    case 12: // $148
      var $149=$yy;
      var $150=(($149+1)|0);
      $yy=$150;
      __label__ = 6; break;
    case 13: // $151
      __label__ = 14; break;
    case 14: // $152
      __label__ = 15; break;
    case 15: // $153
      var $154=$x;
      var $155=(($154+1)|0);
      $x=$155;
      var $156=$chdata;
      var $157=(($156)&255);
      var $158=$157 << 1;
      var $159=(($158) & 255);
      $chdata=$159;
      __label__ = 3; break;
    case 16: // $160
      __label__ = 17; break;
    case 17: // $161
      var $162=$y;
      var $163=(($162+1)|0);
      $y=$163;
      __label__ = 1; break;
    case 18: // $164
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17overlay_draw_charP8bitmap_thf["X"]=1;

function __ZL9vsync_offR15running_machinePvi6076($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+87)|0);
  HEAP8[($9)]=0;
  ;
  return;
}


function __ZL16simutrek_port2_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $prev;
      var $direction;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK13address_space6deviceEv($4);
      var $6=__ZNK8device_t5ownerEv($5);
      var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
      $ld=$7;
      var $8=$ld;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      $player=$10;
      var $11=$player;
      var $12=(($11+92)|0);
      var $13=(($12+7)|0);
      var $14=HEAP8[($13)];
      $prev=$14;
      var $15=$3;
      var $16=$player;
      var $17=(($16+92)|0);
      var $18=(($17+7)|0);
      HEAP8[($18)]=$15;
      var $19=$3;
      var $20=(($19)&255);
      var $21=$prev;
      var $22=(($21)&255);
      var $23=$20 ^ $22;
      var $24=$23 & 32;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $26
      var $27=$ld;
      var $28=$3;
      var $29=(($28)&255);
      var $30=$29 & 32;
      var $31=(($30)|0)!=0;
      var $32=$31 ? 1 : 0;
      var $33=(($32) & 255);
      var $34=$3;
      var $35=(($34)&255);
      var $36=$35 & 32;
      var $37=(($36)|0)!=0;
      var $38=$37 ? 0 : 1;
      var $39=(($38) & 255);
      __ZL16pr8210_control_wP16_laserdisc_statehh($27, $33, $39);
      __label__ = 2; break;
    case 2: // $40
      var $41=$3;
      var $42=(($41)&255);
      var $43=$42 & 16;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $45
      var $46=$prev;
      var $47=(($46)&255);
      var $48=$47 & 16;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $50
      var $51=$3;
      var $52=(($51)&255);
      var $53=$52 & 8;
      var $54=(($53)|0)!=0;
      var $55=$54 ? 1 : -1;
      $direction=$55;
      var $56=$ld;
      var $57=$direction;
      __Z21ldcore_advance_sliderP16_laserdisc_statei($56, $57);
      __label__ = 5; break;
    case 5: // $58
      var $59=$3;
      var $60=(($59)&255);
      var $61=$60 ^ -1;
      var $62=$61 >> 2;
      var $63=$62 & 1;
      var $64=(($63) & 255);
      var $65=$player;
      var $66=(($65+92)|0);
      var $67=(($66+8)|0);
      HEAP8[($67)]=$64;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16simutrek_port2_wP13address_spacejh["X"]=1;

function __ZL13simutrek_t0_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+92)|0);
  var $11=(($10+6)|0);
  var $12=HEAP8[($11)];
  ;
  return $12;
}


function __ZL18overlay_draw_groupP8bitmap_tPKhif($bitmap, $text, $count, $xstart) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $skip;
      var $x;
      $1=$bitmap;
      $2=$text;
      $3=$count;
      $4=$xstart;
      $skip=1;
      var $5=$1;
      var $6=$4;
      var $7=$4;
      var $8=$3;
      var $9=(($8*6)|0);
      var $10=(($9+1)|0);
      var $11=(($10)|0);
      var $12=$11*0.0062500000931322575;
      var $13=$7+$12;
      __ZL13overlay_eraseP8bitmap_tff($5, $6, $13);
      $x=0;
      __label__ = 1; break;
    case 1: // $14
      var $15=$x;
      var $16=$3;
      var $17=(($15)|0) < (($16)|0);
      if ($17) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $18
      var $19=$skip;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $21
      var $22=$x;
      var $23=$3;
      var $24=(($23-1)|0);
      var $25=(($22)|0)==(($24)|0);
      if ($25) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $26
      var $27=$x;
      var $28=$2;
      var $29=(($28+$27)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $32=$31 & 63;
      var $33=(($32)|0)!=48;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      $skip=0;
      var $35=$1;
      var $36=$x;
      var $37=$2;
      var $38=(($37+$36)|0);
      var $39=HEAP8[($38)];
      var $40=$4;
      var $41=$x;
      var $42=(($41*6)|0);
      var $43=(($42+1)|0);
      var $44=(($43)|0);
      var $45=$44*0.0062500000931322575;
      var $46=$40+$45;
      __ZL17overlay_draw_charP8bitmap_thf($35, $39, $46);
      __label__ = 6; break;
    case 6: // $47
      __label__ = 7; break;
    case 7: // $48
      var $49=$x;
      var $50=(($49+1)|0);
      $x=$50;
      __label__ = 1; break;
    case 8: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18overlay_draw_groupP8bitmap_tPKhif["X"]=1;

function __ZL14vbi_data_fetchR15running_machinePvi6077($machine, $ptr, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $focus_on;
      var $laser_on;
      var $line16;
      var $line1718;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $4=$2;
      var $5=$4;
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      var $9=$player;
      var $10=(($9+88)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 & 8;
      var $14=(($13)|0)!=0;
      var $15=$14 ^ 1;
      var $16=(($15)&1);
      $focus_on=$16;
      var $17=$player;
      var $18=(($17+89)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & 1;
      var $22=(($21)|0)!=0;
      var $23=$22 ^ 1;
      var $24=(($23)&1);
      $laser_on=$24;
      var $25=$ld;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=__Z24laserdisc_get_field_codeP8device_tjh($27, 16, 0);
      $line16=$28;
      var $29=$ld;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=__Z24laserdisc_get_field_codeP8device_tjh($31, 1718, 0);
      $line1718=$32;
      var $33=$player;
      var $34=(($33+56)|0);
      var $35=(($34+29)|0);
      HEAP8[($35)]=-1;
      var $36=$player;
      var $37=(($36+56)|0);
      var $38=(($37+30)|0);
      HEAP8[($38)]=-1;
      var $39=$focus_on;
      var $40=(($39 << 24) >> 24)!=0;
      if ($40) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $41
      var $42=$laser_on;
      var $43=(($42 << 24) >> 24)!=0;
      if ($43) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $44
      var $45=$line1718;
      var $46=(($45)|0)==8978431;
      if ($46) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $47
      var $48=$player;
      var $49=(($48+56)|0);
      var $50=(($49+29)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=$52 & -2;
      var $54=(($53) & 255);
      HEAP8[($50)]=$54;
      __label__ = 4; break;
    case 4: // $55
      var $56=$line1718;
      var $57=(($56)|0)==8449774;
      if ($57) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $58
      var $59=$player;
      var $60=(($59+56)|0);
      var $61=(($60+29)|0);
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=$63 & -3;
      var $65=(($64) & 255);
      HEAP8[($61)]=$65;
      __label__ = 6; break;
    case 6: // $66
      var $67=$line16;
      var $68=(($67)|0)==8572927;
      if ($68) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $69
      var $70=$player;
      var $71=(($70+56)|0);
      var $72=(($71+29)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$74 & -5;
      var $76=(($75) & 255);
      HEAP8[($72)]=$76;
      __label__ = 8; break;
    case 8: // $77
      var $78=$line1718;
      var $79=$78 & 15728640;
      var $80=(($79)|0)==15728640;
      if ($80) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $81
      var $82=$player;
      var $83=(($82+56)|0);
      var $84=(($83+29)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$86 & -17;
      var $88=(($87) & 255);
      HEAP8[($84)]=$88;
      var $89=$line1718;
      var $90=$89 >>> 16;
      var $91=$90 & 7;
      var $92=240 | $91;
      var $93=(($92) & 255);
      var $94=$player;
      var $95=(($94+56)|0);
      var $96=(($95)|0);
      var $97=(($96+2)|0);
      HEAP8[($97)]=$93;
      var $98=$line1718;
      var $99=$98 >>> 12;
      var $100=$99 & 15;
      var $101=240 | $100;
      var $102=(($101) & 255);
      var $103=$player;
      var $104=(($103+56)|0);
      var $105=(($104)|0);
      var $106=(($105+3)|0);
      HEAP8[($106)]=$102;
      var $107=$line1718;
      var $108=$107 >>> 8;
      var $109=$108 & 15;
      var $110=240 | $109;
      var $111=(($110) & 255);
      var $112=$player;
      var $113=(($112+56)|0);
      var $114=(($113)|0);
      var $115=(($114+4)|0);
      HEAP8[($115)]=$111;
      var $116=$line1718;
      var $117=$116 >>> 4;
      var $118=$117 & 15;
      var $119=240 | $118;
      var $120=(($119) & 255);
      var $121=$player;
      var $122=(($121+56)|0);
      var $123=(($122)|0);
      var $124=(($123+5)|0);
      HEAP8[($124)]=$120;
      var $125=$line1718;
      var $126=$125 >>> 0;
      var $127=$126 & 15;
      var $128=240 | $127;
      var $129=(($128) & 255);
      var $130=$player;
      var $131=(($130+56)|0);
      var $132=(($131)|0);
      var $133=(($132+6)|0);
      HEAP8[($133)]=$129;
      __label__ = 10; break;
    case 10: // $134
      var $135=$line1718;
      var $136=$135 & 15732735;
      var $137=(($136)|0)==8392157;
      if ($137) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $138
      var $139=$player;
      var $140=(($139+56)|0);
      var $141=(($140+30)|0);
      var $142=HEAPU8[($141)];
      var $143=(($142)&255);
      var $144=$143 & -2;
      var $145=(($144) & 255);
      HEAP8[($141)]=$145;
      var $146=$line1718;
      var $147=$146 >>> 16;
      var $148=$147 & 7;
      var $149=240 | $148;
      var $150=(($149) & 255);
      var $151=$player;
      var $152=(($151+56)|0);
      var $153=(($152)|0);
      var $154=(($153)|0);
      HEAP8[($154)]=$150;
      var $155=$line1718;
      var $156=$155 >>> 12;
      var $157=$156 & 15;
      var $158=240 | $157;
      var $159=(($158) & 255);
      var $160=$player;
      var $161=(($160+56)|0);
      var $162=(($161)|0);
      var $163=(($162+1)|0);
      HEAP8[($163)]=$159;
      __label__ = 12; break;
    case 12: // $164
      __label__ = 13; break;
    case 13: // $165
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14vbi_data_fetchR15running_machinePvi6077["X"]=1;

function __ZL36construct_address_map_pr8210_portmapR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 2, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 255, $5);
  $curentry=$6;
  var $7=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($7, 1360, ((STRING_TABLE.__str186056)|0), 1362, ((STRING_TABLE.__str196057)|0));
  var $8=$1;
  var $9=$curentry;
  var $10=__ZN11address_map3addEjjP18address_map_entry8($8, 288, 288, $9);
  $curentry=$10;
  var $11=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($11, 1364, ((STRING_TABLE.__str206058)|0));
  var $12=$1;
  var $13=$curentry;
  var $14=__ZN11address_map3addEjjP18address_map_entry8($12, 257, 257, $13);
  $curentry=$14;
  var $15=$curentry;
  __ZN18address_map_entry811set_handlerEPFvP13address_spacejhEPKc($15, 1366, ((STRING_TABLE.__str216059)|0));
  var $16=$1;
  var $17=$curentry;
  var $18=__ZN11address_map3addEjjP18address_map_entry8($16, 258, 258, $17);
  $curentry=$18;
  var $19=$curentry;
  __ZN18address_map_entry811set_handlerEPFvP13address_spacejhEPKc($19, 1368, ((STRING_TABLE.__str226060)|0));
  var $20=$1;
  var $21=$curentry;
  var $22=__ZN11address_map3addEjjP18address_map_entry8($20, 272, 272, $21);
  $curentry=$22;
  var $23=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($23, 1370, ((STRING_TABLE.__str236061)|0));
  var $24=$1;
  var $25=$curentry;
  var $26=__ZN11address_map3addEjjP18address_map_entry8($24, 273, 273, $25);
  $curentry=$26;
  var $27=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($27, 1372, ((STRING_TABLE.__str246062)|0));
  ;
  return;
}


function __ZL11pr8210_t1_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$offset;
  ;
  return 1;
}


function __ZL11vp931_readyP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  var $player;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  $player=$4;
  var $5=$player;
  var $6=(($5+19)|0);
  var $7=HEAP8[($6)];
  var $8=(($7 << 24) >> 24)!=0;
  var $9=$8 ? 0 : 1;
  var $10=(($9) & 255);
  ;
  return $10;
}


function __ZL16vp931_data_readyP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  var $player;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  $player=$4;
  var $5=$player;
  var $6=(($5+21)|0);
  var $7=HEAP8[($6)];
  var $8=(($7 << 24) >> 24)!=0;
  var $9=$8 ? 1 : 0;
  var $10=(($9) & 255);
  ;
  return $10;
}


function __ZL12pr8210_pia_rP13address_spacej($space, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $result;
      $1=$space;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK13address_space6deviceEv($3);
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      $result=-1;
      var $10=$2;
      if ($10 == 32 || $10 == 33 || $10 == 34 || $10 == 35 || $10 == 36 || $10 == 37 || $10 == 38) {
        __label__ = 1; break;
      }
      else if ($10 == 29 || $10 == 30 || $10 == 31 || $10 == 39) {
        __label__ = 2; break;
      }
      else if ($10 == 160) {
        __label__ = 3; break;
      }
      else if ($10 == 192) {
        __label__ = 4; break;
      }
      else if ($10 == 224) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 1: // $11
      var $12=$2;
      var $13=(($12-32)|0);
      var $14=$player;
      var $15=(($14+56)|0);
      var $16=(($15)|0);
      var $17=(($16+$13)|0);
      var $18=HEAP8[($17)];
      $result=$18;
      __label__ = 7; break;
    case 2: // $19
      __label__ = 7; break;
    case 3: // $20
      var $21=$player;
      var $22=(($21+56)|0);
      var $23=(($22+28)|0);
      var $24=HEAP8[($23)];
      $result=$24;
      __label__ = 7; break;
    case 4: // $25
      var $26=$player;
      var $27=(($26+56)|0);
      var $28=(($27+29)|0);
      var $29=HEAP8[($28)];
      $result=$29;
      __label__ = 7; break;
    case 5: // $30
      var $31=$player;
      var $32=(($31+56)|0);
      var $33=(($32+30)|0);
      var $34=HEAP8[($33)];
      $result=$34;
      __label__ = 7; break;
    case 6: // $35
      var $36=$1;
      var $37=__ZNK13address_space6deviceEv($36);
      var $38=__Z12device_stateP8device_t($37);
      var $39=__ZN22device_state_interface5stateEi($38, -1);
      var $39$0=$39[0];
      var $39$1=$39[1];
      var $40$0=$39$0;
      var $40=$40$0;
      var $41=$2;
      __Z17mame_printf_debugPKcz(((STRING_TABLE.__str376075)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,HEAP32[((tempInt+4)>>2)]=$41,tempInt));
      __label__ = 7; break;
    case 7: // $42
      var $43=$result;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12pr8210_pia_rP13address_spacej["X"]=1;

function __ZL12pr8210_pia_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $value;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK13address_space6deviceEv($4);
      var $6=__ZNK8device_t5ownerEv($5);
      var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
      $ld=$7;
      var $8=$ld;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      $player=$10;
      var $11=$2;
      if ($11 == 32 || $11 == 33 || $11 == 34 || $11 == 35 || $11 == 36 || $11 == 37 || $11 == 38 || $11 == 39 || $11 == 40 || $11 == 41 || $11 == 42 || $11 == 43 || $11 == 44 || $11 == 45 || $11 == 46 || $11 == 47 || $11 == 48) {
        __label__ = 1; break;
      }
      else if ($11 == 64) {
        __label__ = 2; break;
      }
      else if ($11 == 96) {
        __label__ = 9; break;
      }
      else if ($11 == 128) {
        __label__ = 10; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 1: // $12
      var $13=$3;
      var $14=$2;
      var $15=(($14-32)|0);
      var $16=$player;
      var $17=(($16+56)|0);
      var $18=(($17+7)|0);
      var $19=(($18+$15)|0);
      HEAP8[($19)]=$13;
      __label__ = 12; break;
    case 2: // $20
      var $21=$3;
      var $22=(($21)&255);
      var $23=$22 & 1;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=$player;
      var $27=(($26+56)|0);
      var $28=(($27+24)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$30 & 1;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $33
      var $34=$player;
      var $35=(($34+56)|0);
      var $36=(($35+7)|0);
      var $37=(($36)|0);
      var $38=$player;
      var $39=(($38+56)|0);
      var $40=(($39)|0);
      var $41=(($40)|0);
      assert(2 % 1 === 0, 'memcpy given ' + 2 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($37)]=HEAP8[($41)];HEAP8[($37+1)]=HEAP8[($41+1)];
      var $42=$player;
      var $43=(($42+56)|0);
      var $44=(($43+25)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$46 | 1;
      var $48=(($47) & 255);
      HEAP8[($44)]=$48;
      __label__ = 5; break;
    case 5: // $49
      var $50=$3;
      var $51=(($50)&255);
      var $52=$51 & 2;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $54
      var $55=$player;
      var $56=(($55+56)|0);
      var $57=(($56+24)|0);
      var $58=HEAPU8[($57)];
      var $59=(($58)&255);
      var $60=$59 & 2;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $62
      var $63=$player;
      var $64=(($63+56)|0);
      var $65=(($64+7)|0);
      var $66=(($65+2)|0);
      var $67=$player;
      var $68=(($67+56)|0);
      var $69=(($68)|0);
      var $70=(($69+2)|0);
      assert(5 % 1 === 0, 'memcpy given ' + 5 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($66)]=HEAP8[($70)];HEAP8[($66+1)]=HEAP8[($70+1)];HEAP8[($66+2)]=HEAP8[($70+2)];HEAP8[($66+3)]=HEAP8[($70+3)];HEAP8[($66+4)]=HEAP8[($70+4)];
      var $71=$player;
      var $72=(($71+56)|0);
      var $73=(($72+25)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=$75 | 2;
      var $77=(($76) & 255);
      HEAP8[($73)]=$77;
      __label__ = 8; break;
    case 8: // $78
      var $79=$3;
      var $80=$player;
      var $81=(($80+56)|0);
      var $82=(($81+24)|0);
      HEAP8[($82)]=$79;
      __label__ = 12; break;
    case 9: // $83
      var $84=$3;
      var $85=(($84)&255);
      var $86=$85 & 1;
      var $87=(($86)|0)!=0;
      var $88=(($87)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str266064)|0), $88);
      var $89=$3;
      var $90=(($89)&255);
      var $91=$90 & 2;
      var $92=(($91)|0)!=0;
      var $93=(($92)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str276065)|0), $93);
      var $94=$3;
      var $95=(($94)&255);
      var $96=$95 & 4;
      var $97=(($96)|0)!=0;
      var $98=(($97)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str286066)|0), $98);
      var $99=$3;
      var $100=(($99)&255);
      var $101=$100 & 8;
      var $102=(($101)|0)!=0;
      var $103=(($102)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str296067)|0), $103);
      var $104=$3;
      var $105=(($104)&255);
      var $106=$105 & 64;
      var $107=$106 >> 6;
      var $108=$3;
      var $109=(($108)&255);
      var $110=$109 & 32;
      var $111=$110 >> 4;
      var $112=$107 | $111;
      var $113=$3;
      var $114=(($113)&255);
      var $115=$114 & 16;
      var $116=$115 >> 2;
      var $117=$112 | $116;
      var $118=(($117) & 255);
      $value=$118;
      var $119=$value;
      var $120=(($119)&255);
      var $121=(($120)|0)==0;
      var $122=(($121)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str306068)|0), $122);
      var $123=$value;
      var $124=(($123)&255);
      var $125=(($124)|0)==1;
      var $126=(($125)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str316069)|0), $126);
      var $127=$value;
      var $128=(($127)&255);
      var $129=(($128)|0)==2;
      var $130=(($129)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str326070)|0), $130);
      var $131=$value;
      var $132=(($131)&255);
      var $133=(($132)|0)==3;
      var $134=(($133)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str336071)|0), $134);
      var $135=$value;
      var $136=(($135)&255);
      var $137=(($136)|0)==4;
      var $138=(($137)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str346072)|0), $138);
      var $139=$3;
      var $140=$player;
      var $141=(($140+56)|0);
      var $142=(($141+26)|0);
      HEAP8[($142)]=$139;
      var $143=$ld;
      __ZL20update_audio_squelchP16_laserdisc_state($143);
      __label__ = 12; break;
    case 10: // $144
      var $145=$3;
      var $146=(($145)&255);
      var $147=$146 & 1;
      var $148=(($147) & 255);
      var $149=$player;
      var $150=(($149+56)|0);
      var $151=(($150+27)|0);
      HEAP8[($151)]=$148;
      __label__ = 12; break;
    case 11: // $152
      var $153=$1;
      var $154=__ZNK13address_space6deviceEv($153);
      var $155=__Z12device_stateP8device_t($154);
      var $156=__ZN22device_state_interface5stateEi($155, -1);
      var $156$0=$156[0];
      var $156$1=$156[1];
      var $157$0=$156$0;
      var $157=$157$0;
      var $158=$2;
      var $159=$3;
      var $160=(($159)&255);
      __Z17mame_printf_debugPKcz(((STRING_TABLE.__str356073)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$157,HEAP32[((tempInt+4)>>2)]=$158,HEAP32[((tempInt+8)>>2)]=$160,tempInt));
      __label__ = 12; break;
    case 12: // $161
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12pr8210_pia_wP13address_spacejh["X"]=1;

function __ZL12pr8210_bus_rP13address_spacej($space, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $sliderpos;
      var $focus_on;
      var $spdl_on;
      var $result;
      $1=$space;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK13address_space6deviceEv($3);
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      var $10=$ld;
      var $11=__Z26ldcore_get_slider_positionP16_laserdisc_state($10);
      $sliderpos=$11;
      var $12=$player;
      var $13=(($12+88)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 8;
      var $17=(($16)|0)!=0;
      var $18=$17 ^ 1;
      var $19=(($18)&1);
      $focus_on=$19;
      var $20=$player;
      var $21=(($20+88)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 & 16;
      var $25=(($24)|0)!=0;
      var $26=$25 ^ 1;
      var $27=(($26)&1);
      $spdl_on=$27;
      $result=0;
      var $28=$sliderpos;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $30
      var $31=$sliderpos;
      var $32=(($31)|0)!=5;
      if ($32) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $33
      var $34=$result;
      var $35=(($34)&255);
      var $36=$35 | 64;
      var $37=(($36) & 255);
      $result=$37;
      __label__ = 3; break;
    case 3: // $38
      var $39=$focus_on;
      var $40=(($39 << 24) >> 24)!=0;
      if ($40) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $41
      var $42=$result;
      var $43=(($42)&255);
      var $44=$43 | 16;
      var $45=(($44) & 255);
      $result=$45;
      __label__ = 5; break;
    case 5: // $46
      var $47=$spdl_on;
      var $48=(($47 << 24) >> 24)!=0;
      if ($48) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $49
      var $50=$result;
      var $51=(($50)&255);
      var $52=$51 | 8;
      var $53=(($52) & 255);
      $result=$53;
      __label__ = 7; break;
    case 7: // $54
      var $55=$spdl_on;
      var $56=(($55 << 24) >> 24)!=0;
      if ($56) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $57
      var $58=$result;
      var $59=(($58)&255);
      var $60=$59 | 2;
      var $61=(($60) & 255);
      $result=$61;
      __label__ = 9; break;
    case 9: // $62
      var $63=$result;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12pr8210_bus_rP13address_spacej["X"]=1;

function __ZL14pr8210_port1_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $prev;
      var $direction;
      var $delta;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK13address_space6deviceEv($4);
      var $6=__ZNK8device_t5ownerEv($5);
      var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
      $ld=$7;
      var $8=$ld;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      $player=$10;
      var $11=$player;
      var $12=(($11+88)|0);
      var $13=HEAP8[($12)];
      $prev=$13;
      var $14=$3;
      var $15=$player;
      var $16=(($15+88)|0);
      HEAP8[($16)]=$14;
      var $17=$3;
      var $18=(($17)&255);
      var $19=$18 & 128;
      var $20=(($19)|0)!=0;
      var $21=$20 ? 1 : -1;
      $direction=$21;
      var $22=$3;
      var $23=(($22)&255);
      var $24=$23 & 1;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 7; break; } else { __label__ = 1; break; }
    case 1: // $26
      var $27=$prev;
      var $28=(($27)&255);
      var $29=$28 & 1;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $31
      var $32=$player;
      var $33=(($32+92)|0);
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $37
      var $38=$player;
      var $39=(($38+92)|0);
      var $40=(($39+9)|0);
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $43
      var $44=$ld;
      var $45=$direction;
      __Z21ldcore_advance_sliderP16_laserdisc_statei($44, $45);
      __label__ = 6; break;
    case 5: // $46
      __label__ = 6; break;
    case 6: // $47
      __label__ = 7; break;
    case 7: // $48
      var $49=$3;
      var $50=(($49)&255);
      var $51=$50 & 2;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $53
      var $54=$3;
      var $55=(($54)&255);
      var $56=$55 & 4;
      var $57=(($56)|0)!=0;
      var $58=$57 ? 66 : 133;
      $delta=$58;
      var $59=$ld;
      var $60=$delta;
      var $61=$direction;
      var $62=(($60*$61)|0);
      __Z23ldcore_set_slider_speedP16_laserdisc_statei($59, $62);
      __label__ = 10; break;
    case 9: // $63
      var $64=$ld;
      __Z23ldcore_set_slider_speedP16_laserdisc_statei($64, 0);
      __label__ = 10; break;
    case 10: // $65
      var $66=$ld;
      __ZL20update_video_squelchP16_laserdisc_state($66);
      var $67=$ld;
      __ZL20update_audio_squelchP16_laserdisc_state($67);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14pr8210_port1_wP13address_spacejh["X"]=1;

function __ZL14pr8210_port2_wP13address_spacejh($space, $offset, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $prev;
      var $4=__stackBase__;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $5=$1;
      var $6=__ZNK13address_space6deviceEv($5);
      var $7=__ZNK8device_t5ownerEv($6);
      var $8=__Z21ldcore_get_safe_tokenP8device_t($7);
      $ld=$8;
      var $9=$ld;
      var $10=(($9+12)|0);
      var $11=HEAP32[(($10)>>2)];
      $player=$11;
      var $12=$player;
      var $13=(($12+89)|0);
      var $14=HEAP8[($13)];
      $prev=$14;
      var $15=$3;
      var $16=$player;
      var $17=(($16+89)|0);
      HEAP8[($17)]=$15;
      var $18=$3;
      var $19=(($18)&255);
      var $20=$19 & 32;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $22
      var $23=$prev;
      var $24=(($23)&255);
      var $25=$24 & 32;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $27
      var $28=$player;
      var $29=(($28+44)|0);
      var $30=$1;
      var $31=__ZNK13address_space7machineEv($30);
      __ZNK15running_machine4timeEv($4, $31);
      var $32=$29;
      var $33=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($32)>>2)]=HEAP32[(($33)>>2)];HEAP32[(($32+4)>>2)]=HEAP32[(($33+4)>>2)];HEAP32[(($32+8)>>2)]=HEAP32[(($33+8)>>2)];
      __label__ = 3; break;
    case 3: // $34
      var $35=$player;
      var $36=(($35+40)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=$player;
      var $41=(($40+40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$3;
      var $44=(($43)&255);
      var $45=$44 & 64;
      var $46=(($45)|0)!=0;
      var $47=$46 ? 0 : 1;
      __Z21device_set_input_lineP8device_tii($42, 0, $47);
      __label__ = 5; break;
    case 5: // $48
      var $49=$3;
      var $50=(($49)&255);
      var $51=$50 & 16;
      var $52=(($51)|0)!=0;
      var $53=(($52)&1);
      __Z16output_set_valuePKci(((STRING_TABLE.__str256063)|0), $53);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14pr8210_port2_wP13address_spacejh["X"]=1;

function __ZL11pr8210_t0_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+87)|0);
  var $11=HEAP8[($10)];
  var $12=(($11 << 24) >> 24)!=0;
  var $13=$12 ^ 1;
  var $14=(($13)&1);
  ;
  return $14;
}


function __ZL20update_video_squelchP16_laserdisc_state($ld) {
  ;
  var __label__;

  var $1;
  var $player;
  $1=$ld;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  $player=$4;
  var $5=$1;
  var $6=$player;
  var $7=(($6+88)|0);
  var $8=HEAPU8[($7)];
  var $9=(($8)&255);
  var $10=$9 & 32;
  var $11=(($10)|0)!=0;
  var $12=(($11)&1);
  __Z24ldcore_set_video_squelchP16_laserdisc_stateh($5, $12);
  ;
  return;
}


function __ZL11vp931_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$ld;
  $2=$vbi;
  $3=$fieldnum;
  var $5=$1;
  var $6=(($5+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+27)|0);
  HEAP8[($8)]=0;
  var $9=$1;
  var $10=(($9+12)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11+16)|0);
  HEAP8[($12)]=1;
  var $13=$1;
  var $14=(($13)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=__ZNK8device_t7machineEv($15);
  var $17=__ZN15running_machine9schedulerEv($16);
  var $18=$1;
  var $19=(($18+4)|0);
  var $20=HEAP32[(($19)>>2)];
  __ZNK13screen_device14time_until_posEii($4, $20, 30, 0);
  var $21=$1;
  var $22=$21;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($17, $4, 1378, ((STRING_TABLE.__str106090)|0), 0, $22);
  STACKTOP = __stackBase__;
  return;
}


function __ZL12vp931_updateP16_laserdisc_statePK13_vbi_metadatai8attotime($ld, $vbi, $fieldnum, $curtime) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $curtime; $curtime = STACKTOP;STACKTOP += 12;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($curtime)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($curtime+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($curtime+8)>>2)]=HEAP32[((tempParam+8)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$ld;
  $2=$vbi;
  $3=$fieldnum;
  var $5=$1;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__ZNK8device_t7machineEv($7);
  var $9=__ZN15running_machine9schedulerEv($8);
  var $10=$1;
  var $11=(($10+4)|0);
  var $12=HEAP32[(($11)>>2)];
  __ZNK13screen_device14time_until_posEii($4, $12, 32, 0);
  var $13=$1;
  var $14=$13;
  __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($9, $4, 1380, ((STRING_TABLE.__str66086)|0), 64, $14);
  var $15=$3;
  STACKTOP = __stackBase__;
  return $15;
}


function __ZL12vp931_data_wP16_laserdisc_statehh($ld, $prev, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$ld;
  $2=$prev;
  $3=$data;
  var $4=$1;
  var $5=(($4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=__ZNK8device_t7machineEv($6);
  var $8=__ZN15running_machine9schedulerEv($7);
  var $9=$3;
  var $10=(($9)&255);
  var $11=$1;
  var $12=$11;
  __ZN16device_scheduler11synchronizeEPFvR15running_machinePviEPKciS2_($8, 1382, ((STRING_TABLE.__str56085)|0), $10, $12);
  ;
  return;
}


function __ZL12vp931_data_rP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $player;
      var $2=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      $1=$ld;
      var $5=$1;
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      $player=$7;
      var $8=$player;
      var $9=(($8+21)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=$player;
      var $14=(($13+21)|0);
      HEAP8[($14)]=0;
      var $15=$player;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      var $20=$player;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      FUNCTION_TABLE[$22]($25, 0);
      __label__ = 3; break;
    case 3: // $26
      __label__ = 4; break;
    case 4: // $27
      var $28=$1;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__ZNK8device_t7machineEv($30);
      var $32=__ZN15running_machine9schedulerEv($31);
      var $33=$2;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($33)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($33+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($33+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $34=$1;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      __ZNK13screen_device11scan_periodEv($4, $36);
      __ZmlRK8attotimej($3, $4, 4);
      __ZN16device_scheduler16boost_interleaveE8attotimeS0_($32, $2, $3);
      var $37=$player;
      var $38=(($37+20)|0);
      var $39=HEAP8[($38)];
      STACKTOP = __stackBase__;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL30construct_machine_config_vp931R14machine_configP8device_t($config, $owner) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $device;
      var $tag;
      var $tempstring=__stackBase__;
      var $4;
      var $5;
      var $6;
      $2=$config;
      $3=$owner;
      $device=0;
      __ZN7astringC1Ev($tempstring);
      __label__ = 1; break;
    case 1: // $7
      __label__ = 2; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      var $10=$2;
      var $11=$3;
      var $12=HEAP32[((_I8049)>>2)];
      var $13=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($10, $11, ((STRING_TABLE.__str6078)|0), $12, 11000000) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $14
      $device=$13;
      var $15=$device;
      (function() { try { __THREW__ = false; return __ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E($15, 2, 1374) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $16
      var $17=$2;
      var $18=$3;
      var $19=HEAP32[((_TIMER)>>2)];
      var $20=(function() { try { __THREW__ = false; return __ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj($17, $18, ((STRING_TABLE.__str116091)|0), $19, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; };
    case 6: // $21
      $device=$20;
      var $22=$device;
      (function() { try { __THREW__ = false; return __ZN12timer_device24static_configure_genericER8device_tPFvRS_PviE($22, 1376) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $23
      var $24=$3;
      $1=$24;
      $6=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      var $25=$1;
      STACKTOP = __stackBase__;
      return $25;
    case 8: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $4=$28;
      var $29=$27.f1;
      $5=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $30
      __label__ = 10; break;
    case 10: // $31
      var $32=$4;
      var $33=$4;
      var $34=$5;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL30construct_machine_config_vp931R14machine_configP8device_t["X"]=1;

function __ZL10vp931_initP16_laserdisc_state($ld) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tempstring=__stackBase__;
      var $player;
      var $cbsave;
      var $2;
      var $3;
      $1=$ld;
      __ZN7astringC1Ev($tempstring);
      var $4=$1;
      var $5=(($4+12)|0);
      var $6=HEAP32[(($5)>>2)];
      $player=$6;
      var $7=$player;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      $cbsave=$9;
      var $10=$player;
      var $11=$10;
      _memset($11, 0, 32, 1);
      var $12=$cbsave;
      var $13=$player;
      var $14=(($13+8)|0);
      HEAP32[(($14)>>2)]=$12;
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($17, ((STRING_TABLE.__str6078)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $19
      var $20=$player;
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=$18;
      var $22=$1;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(function() { try { __THREW__ = false; return __ZNK8device_t9subdeviceEPKc($24, ((STRING_TABLE.__str116091)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; };
    case 2: // $26
      var $27=(function() { try { __THREW__ = false; return __Z8downcastIP12timer_device8device_tET_PT0_($25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $28
      var $29=$player;
      var $30=(($29+4)|0);
      HEAP32[(($30)>>2)]=$27;
      var $31=$player;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=$34;
      (function() { try { __THREW__ = false; return __ZN12timer_device7set_ptrEPv($33, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $36
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring);
      STACKTOP = __stackBase__;
      return;
    case 5: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $2=$39;
      var $40=$38.f1;
      $3=$40;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstring) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $41
      __label__ = 7; break;
    case 7: // $42
      var $43=$2;
      var $44=$2;
      var $45=$3;
      var $46=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $44, tempValue);
      var $47=($46.f1 = $45, $46);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $48
      var $49=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10vp931_initP16_laserdisc_state["X"]=1;

function __ZL8keypad_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$offset;
  ;
  return 0;
}


function __ZL9unknown_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$space;
  $2=$offset;
  ;
  return 0;
}


function __ZL5lcd_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$offset;
  $3=$data;
  ;
  return;
}


function __ZL7port2_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$space;
  $2=$offset;
  $3=$data;
  ;
  return;
}


function __ZL15deferred_data_wR15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $4=$2;
      var $5=$4;
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      var $9=$3;
      var $10=(($9) & 255);
      var $11=$player;
      var $12=(($11+18)|0);
      HEAP8[($12)]=$10;
      var $13=$player;
      var $14=(($13+19)|0);
      HEAP8[($14)]=1;
      var $15=$player;
      var $16=(($15+27)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($18)>>>0) < 3;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$3;
      var $22=(($21) & 255);
      var $23=$player;
      var $24=(($23+27)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25+1)&255);
      HEAP8[($24)]=$26;
      var $27=(($25)&255);
      var $28=(($27)|0)%3;
      var $29=$player;
      var $30=(($29+24)|0);
      var $31=(($30+$28)|0);
      HEAP8[($31)]=$22;
      __label__ = 2; break;
    case 2: // $32
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14datastrobe_offR15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+17)|0);
  HEAP8[($9)]=0;
  ;
  return;
}


function __ZL7erp_offR15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8+16)|0);
  HEAP8[($9)]=0;
  ;
  return;
}


function __ZL14vbi_data_fetchR15running_machinePvi6106($machine, $ptr, $param) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $which;
      var $line;
      var $code;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      var $6=__stackBase__+24;
      $1=$machine;
      $2=$ptr;
      $3=$param;
      var $7=$2;
      var $8=$7;
      $ld=$8;
      var $9=$ld;
      var $10=(($9+12)|0);
      var $11=HEAP32[(($10)>>2)];
      $player=$11;
      var $12=$3;
      var $13=$12 & 3;
      $which=$13;
      var $14=$3;
      var $15=$14 >> 2;
      $line=$15;
      $code=0;
      var $16=$line;
      var $17=(($16)|0) >= 16;
      if ($17) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $18
      var $19=$line;
      var $20=(($19)|0) <= 18;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$ld;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$line;
      var $26=__Z24laserdisc_get_field_codeP8device_tjh($24, $25, 0);
      $code=$26;
      __label__ = 3; break;
    case 3: // $27
      var $28=$which;
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$player;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      __Z21device_set_input_lineP8device_tii($33, 0, 1);
      var $34=$1;
      var $35=__ZN15running_machine9schedulerEv($34);
      var $$emscripten$temp$0$0=5580;
      var $$emscripten$temp$0$1=0;
      __ZN8attotime9from_nsecEx($4, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      var $36=$ld;
      var $37=$36;
      __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($35, $4, 1384, ((STRING_TABLE.__str76087)|0), 0, $37);
      __label__ = 8; break;
    case 5: // $38
      var $39=$code;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$code;
      var $43=$which;
      var $44=((3-$43)|0);
      var $45=((($44<<3))|0);
      var $46=$42 >>> (($45)>>>0);
      var $47=(($46) & 255);
      var $48=$player;
      var $49=(($48+15)|0);
      HEAP8[($49)]=$47;
      var $50=$player;
      var $51=(($50+17)|0);
      HEAP8[($51)]=1;
      var $52=$1;
      var $53=__ZN15running_machine9schedulerEv($52);
      var $$emscripten$temp$1$0=5000;
      var $$emscripten$temp$1$1=0;
      __ZN8attotime9from_nsecEx($5, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      var $54=$ld;
      var $55=$54;
      __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($53, $5, 1386, ((STRING_TABLE.__str86088)|0), 0, $55);
      __label__ = 7; break;
    case 7: // $56
      __label__ = 8; break;
    case 8: // $57
      var $58=$which;
      var $59=(($58+1)|0);
      $which=$59;
      var $60=(($59)|0)==4;
      if ($60) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $61
      $which=0;
      var $62=$line;
      var $63=(($62+1)|0);
      $line=$63;
      __label__ = 10; break;
    case 10: // $64
      var $65=$line;
      var $66=(($65)|0) <= 19;
      if ($66) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $67
      var $68=$1;
      var $69=__ZN15running_machine9schedulerEv($68);
      var $70=$ld;
      var $71=(($70+4)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$line;
      var $74=((($73<<1))|0);
      var $75=$which;
      var $76=((($75<<1))|0);
      var $77=$ld;
      var $78=(($77+4)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=__ZNK13screen_device5widthEv($79);
      var $81=(($76*$80)|0);
      var $82=(((($81)|0)/4)|0);
      __ZNK13screen_device14time_until_posEii($6, $72, $74, $82);
      var $83=$line;
      var $84=$83 << 2;
      var $85=$ld;
      var $86=$85;
      __ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_($69, $6, 1380, ((STRING_TABLE.__str66086)|0), $84, $86);
      __label__ = 12; break;
    case 12: // $87
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14vbi_data_fetchR15running_machinePvi6106["X"]=1;

function __ZN8attotime9from_nsecEx($agg_result, $nsec$0, $nsec$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $st$1$0=(($1)|0);
  HEAP32[(($st$1$0)>>2)]=$nsec$0;
  var $st$1$1=(($1+4)|0);
  HEAP32[(($st$1$1)>>2)]=$nsec$1;
  var $st$5$0=(($1)|0);
  var $2$0=HEAP32[(($st$5$0)>>2)];
  var $st$5$1=(($1+4)|0);
  var $2$1=HEAP32[(($st$5$1)>>2)];
  var $$emscripten$temp$0$0=1000000000;
  var $$emscripten$temp$0$1=0;
  var $3$0 = (tempBigIntR=((($2$0)>>>0)+((($2$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $3$1 = Math.min(Math.floor(((tempBigIntR=((($2$0)>>>0)+((($2$1)|0)*4294967296))/((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $4$0=$3$0;
  var $4=$4$0;
  var $st$14$0=(($1)|0);
  var $5$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($1+4)|0);
  var $5$1=HEAP32[(($st$14$1)>>2)];
  var $$emscripten$temp$1$0=1000000000;
  var $$emscripten$temp$1$1=0;
  var $6$0 = ((($5$0)>>>0)+((($5$1)|0)*4294967296))%((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $6$1 = Math.min(Math.floor((((($5$0)>>>0)+((($5$1)|0)*4294967296))%((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
  var $$emscripten$temp$2$0=1000000000;
  var $$emscripten$temp$2$1=0;
  var $7$0 = ((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $7$1 = Math.min(Math.floor((((($6$0)>>>0)+((($6$1)|0)*4294967296))*((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
  __ZN8attotimeC1Eix($agg_result, $4, $7$0, $7$1);
  STACKTOP = __stackBase__;
  return;
}


function __ZL7irq_offR15running_machinePvi6107($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  $ld=$5;
  var $6=$ld;
  var $7=(($6+12)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0);
  var $10=HEAP32[(($9)>>2)];
  __Z21device_set_input_lineP8device_tii($10, 0, 0);
  ;
  return;
}


function __ZL35construct_address_map_vp931_portmapR11address_mapRK8device_t($map, $device) {
  ;
  var __label__;

  var $1;
  var $2;
  var $curentry;
  $1=$map;
  $2=$device;
  $curentry=0;
  var $3=$1;
  __ZN11address_map9configureE16address_spacenumh($3, 2, 8);
  var $4=$1;
  var $5=$curentry;
  var $6=__ZN11address_map3addEjjP18address_map_entry8($4, 0, 0, $5);
  $curentry=$6;
  var $7=$curentry;
  var $8=$7;
  __ZN17address_map_entry10set_mirrorEj($8, 207);
  var $9=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($9, 1388, ((STRING_TABLE.__str126092)|0), 1390, ((STRING_TABLE.__str136093)|0));
  var $10=$1;
  var $11=$curentry;
  var $12=__ZN11address_map3addEjjP18address_map_entry8($10, 16, 16, $11);
  $curentry=$12;
  var $13=$curentry;
  var $14=$13;
  __ZN17address_map_entry10set_mirrorEj($14, 207);
  var $15=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($15, 1392, ((STRING_TABLE.__str146094)|0), 1394, ((STRING_TABLE.__str156095)|0));
  var $16=$1;
  var $17=$curentry;
  var $18=__ZN11address_map3addEjjP18address_map_entry8($16, 32, 32, $17);
  $curentry=$18;
  var $19=$curentry;
  var $20=$19;
  __ZN17address_map_entry10set_mirrorEj($20, 207);
  var $21=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($21, 1396, ((STRING_TABLE.__str166096)|0), 1398, ((STRING_TABLE.__str176097)|0));
  var $22=$1;
  var $23=$curentry;
  var $24=__ZN11address_map3addEjjP18address_map_entry8($22, 48, 48, $23);
  $curentry=$24;
  var $25=$curentry;
  var $26=$25;
  __ZN17address_map_entry10set_mirrorEj($26, 207);
  var $27=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($27, 1400, ((STRING_TABLE.__str186098)|0), 1402, ((STRING_TABLE.__str196099)|0));
  var $28=$1;
  var $29=$curentry;
  var $30=__ZN11address_map3addEjjP18address_map_entry8($28, 257, 257, $29);
  $curentry=$30;
  var $31=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($31, 1404, ((STRING_TABLE.__str206100)|0), 1406, ((STRING_TABLE.__str216101)|0));
  var $32=$1;
  var $33=$curentry;
  var $34=__ZN11address_map3addEjjP18address_map_entry8($32, 258, 258, $33);
  $curentry=$34;
  var $35=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_($35, 1408, ((STRING_TABLE.__str226102)|0), 1410, ((STRING_TABLE.__str236103)|0));
  var $36=$1;
  var $37=$curentry;
  var $38=__ZN11address_map3addEjjP18address_map_entry8($36, 272, 272, $37);
  $curentry=$38;
  var $39=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($39, 1412, ((STRING_TABLE.__str246104)|0));
  var $40=$1;
  var $41=$curentry;
  var $42=__ZN11address_map3addEjjP18address_map_entry8($40, 273, 273, $41);
  $curentry=$42;
  var $43=$curentry;
  __ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc($43, 1414, ((STRING_TABLE.__str256105)|0));
  ;
  return;
}
__ZL35construct_address_map_vp931_portmapR11address_mapRK8device_t["X"]=1;

function __ZL11track_timerR12timer_devicePvi($timer, $ptr, $param) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      $1=$timer;
      $2=$ptr;
      $3=$param;
      var $4=$2;
      var $5=$4;
      $ld=$5;
      var $6=$ld;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      $player=$8;
      var $9=$player;
      var $10=(($9+23)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 ^ 1;
      var $14=(($13) & 255);
      HEAP8[($10)]=$14;
      var $15=$player;
      var $16=(($15+22)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0) < 0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$player;
      var $22=(($21+23)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24)!=0;
      if ($24) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $25
      var $26=$player;
      var $27=(($26+22)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0) > 0;
      if ($30) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $31
      var $32=$player;
      var $33=(($32+23)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24)!=0;
      if ($35) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $36
      var $37=$ld;
      var $38=$player;
      var $39=(($38+22)|0);
      var $40=HEAP8[($39)];
      var $41=(($40 << 24) >> 24);
      __Z21ldcore_advance_sliderP16_laserdisc_statei($37, $41);
      var $42=$player;
      var $43=(($42+22)|0);
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      var $46=$player;
      var $47=(($46+28)|0);
      var $48=HEAP16[(($47)>>1)];
      var $49=(($48 << 16) >> 16);
      var $50=(($49+$45)|0);
      var $51=(($50) & 65535);
      HEAP16[(($47)>>1)]=$51;
      __label__ = 5; break;
    case 5: // $52
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11track_timerR12timer_devicePvi["X"]=1;

function __ZL9output0_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $ld;
  var $player;
  $1=$space;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=__ZNK13address_space6deviceEv($4);
  var $6=__ZNK8device_t5ownerEv($5);
  var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
  $ld=$7;
  var $8=$ld;
  var $9=(($8+12)|0);
  var $10=HEAP32[(($9)>>2)];
  $player=$10;
  var $11=$ld;
  var $12=$3;
  var $13=(($12)&255);
  var $14=$13 & 2;
  var $15=(($14)|0)!=0;
  var $16=$15 ^ 1;
  var $17=(($16)&1);
  var $18=$3;
  var $19=(($18)&255);
  var $20=$19 & 4;
  var $21=(($20)|0)!=0;
  var $22=$21 ^ 1;
  var $23=(($22)&1);
  __Z24ldcore_set_audio_squelchP16_laserdisc_statehh($11, $17, $23);
  var $24=$ld;
  var $25=$3;
  var $26=(($25)&255);
  var $27=$26 & 1;
  var $28=(($27)|0)!=0;
  var $29=$28 ^ 1;
  var $30=(($29)&1);
  __Z24ldcore_set_video_squelchP16_laserdisc_stateh($24, $30);
  ;
  return;
}


function __ZL9output1_wP13address_spacejh($space, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $speed;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=__ZNK13address_space6deviceEv($4);
      var $6=__ZNK8device_t5ownerEv($5);
      var $7=__Z21ldcore_get_safe_tokenP8device_t($6);
      $ld=$7;
      var $8=$ld;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      $player=$10;
      $speed=0;
      $speed=0;
      var $11=$3;
      var $12=(($11)&255);
      var $13=$12 & 2;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $15
      var $16=$3;
      var $17=(($16)&255);
      var $18=$17 & 4;
      var $19=(($18)|0)!=0;
      var $20=$19 ? 133 : 66;
      $speed=$20;
      var $21=$3;
      var $22=(($21)&255);
      var $23=$22 & 1;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $25
      var $26=$speed;
      var $27=(((-$26))|0);
      $speed=$27;
      __label__ = 3; break;
    case 3: // $28
      __label__ = 4; break;
    case 4: // $29
      var $30=$ld;
      var $31=$speed;
      __Z23ldcore_set_slider_speedP16_laserdisc_statei($30, $31);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7datic_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+15)|0);
  var $11=HEAP8[($10)];
  ;
  return $11;
}


function __ZL17from_controller_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  var $player;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  $player=$9;
  var $10=$player;
  var $11=(($10+19)|0);
  HEAP8[($11)]=0;
  var $12=$player;
  var $13=(($12+18)|0);
  var $14=HEAP8[($13)];
  ;
  return $14;
}


function __ZL15to_controller_wP13address_spacejh($space, $offset, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $4=__stackBase__;
      var $5=__stackBase__+12;
      var $6=__stackBase__+24;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $7=$1;
      var $8=__ZNK13address_space6deviceEv($7);
      var $9=__ZNK8device_t5ownerEv($8);
      var $10=__Z21ldcore_get_safe_tokenP8device_t($9);
      $ld=$10;
      var $11=$ld;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      $player=$13;
      var $14=$player;
      var $15=(($14+21)|0);
      HEAP8[($15)]=1;
      var $16=$3;
      var $17=$player;
      var $18=(($17+20)|0);
      HEAP8[($18)]=$16;
      var $19=$player;
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $23
      var $24=$player;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$ld;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      FUNCTION_TABLE[$26]($29, 1);
      __label__ = 2; break;
    case 2: // $30
      var $31=$ld;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=__ZNK8device_t7machineEv($33);
      var $35=__ZN15running_machine9schedulerEv($34);
      var $36=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      var $37=$ld;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      __ZNK13screen_device11scan_periodEv($6, $39);
      __ZmlRK8attotimej($5, $6, 4);
      __ZN16device_scheduler16boost_interleaveE8attotimeS0_($35, $4, $5);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15to_controller_wP13address_spacejh["X"]=1;

function __ZL7port1_rP13address_spacej($space, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $result;
      $1=$space;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK13address_space6deviceEv($3);
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      $result=0;
      var $10=$player;
      var $11=(($10+16)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      var $15=$result;
      var $16=(($15)&255);
      var $17=$16 | 64;
      var $18=(($17) & 255);
      $result=$18;
      __label__ = 2; break;
    case 2: // $19
      var $20=$result;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7port1_wP13address_spacejh($space, $offset, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ld;
      var $player;
      var $speed=__stackBase__;
      var $4=__stackBase__+12;
      var $5=__stackBase__+24;
      $1=$space;
      $2=$offset;
      $3=$data;
      var $6=$1;
      var $7=__ZNK13address_space6deviceEv($6);
      var $8=__ZNK8device_t5ownerEv($7);
      var $9=__Z21ldcore_get_safe_tokenP8device_t($8);
      $ld=$9;
      var $10=$ld;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      $player=$12;
      var $13=$3;
      var $14=(($13)&255);
      var $15=$14 & 1;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$player;
      var $19=(($18+22)|0);
      HEAP8[($19)]=0;
      __label__ = 10; break;
    case 2: // $20
      var $21=$player;
      var $22=(($21+22)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $26
      var $27=$player;
      var $28=(($27+28)|0);
      HEAP16[(($28)>>1)]=0;
      var $29=$3;
      var $30=(($29)&255);
      var $31=$30 & 4;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $33
      var $34=$player;
      var $35=(($34+22)|0);
      HEAP8[($35)]=-1;
      var $36=$player;
      var $37=(($36+23)|0);
      HEAP8[($37)]=1;
      __label__ = 8; break;
    case 5: // $38
      var $39=$3;
      var $40=(($39)&255);
      var $41=$40 & 2;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $43
      var $44=$player;
      var $45=(($44+22)|0);
      HEAP8[($45)]=1;
      var $46=$player;
      var $47=(($46+23)|0);
      HEAP8[($47)]=0;
      __label__ = 7; break;
    case 7: // $48
      __label__ = 8; break;
    case 8: // $49
      __label__ = 9; break;
    case 9: // $50
      __label__ = 10; break;
    case 10: // $51
      var $52=$player;
      var $53=(($52+4)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $56
      var $57=$player;
      var $58=(($57+22)|0);
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $62
      var $63=$player;
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      __ZN12timer_device5resetEv($65);
      __label__ = 19; break;
    case 13: // $66
      var $67=$player;
      var $68=(($67+14)|0);
      var $69=HEAPU8[($68)];
      var $70=(($69)&255);
      var $71=$3;
      var $72=(($71)&255);
      var $73=$70 ^ $72;
      var $74=$73 & 17;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $76
      var $77=$3;
      var $78=(($77)&255);
      var $79=$78 & 16;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $81
      var $$emscripten$temp$0$0=60;
      var $$emscripten$temp$0$1=0;
      __ZN8attotime9from_usecEx($speed, $$emscripten$temp$0$0, $$emscripten$temp$0$1);
      __label__ = 17; break;
    case 16: // $82
      var $$emscripten$temp$1$0=10;
      var $$emscripten$temp$1$1=0;
      __ZN8attotime9from_usecEx($speed, $$emscripten$temp$1$0, $$emscripten$temp$1$1);
      __label__ = 17; break;
    case 17: // $83
      var $84=$player;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $$emscripten$temp$2$0=100;
      var $$emscripten$temp$2$1=0;
      __ZN8attotime9from_usecEx($4, $$emscripten$temp$2$0, $$emscripten$temp$2$1);
      var $87=$5;
      var $88=$speed;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($87)>>2)]=HEAP32[(($88)>>2)];HEAP32[(($87+4)>>2)]=HEAP32[(($88+4)>>2)];HEAP32[(($87+8)>>2)]=HEAP32[(($88+8)>>2)];
      __ZN12timer_device6adjustE8attotimeiS0_($86, $4, 0, $5);
      __label__ = 18; break;
    case 18: // $89
      __label__ = 19; break;
    case 19: // $90
      __label__ = 20; break;
    case 20: // $91
      var $92=$3;
      var $93=$player;
      var $94=(($93+14)|0);
      HEAP8[($94)]=$92;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7port1_wP13address_spacejh["X"]=1;

function __ZL7port2_rP13address_spacej($space, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ld;
      var $player;
      var $result;
      $1=$space;
      $2=$offset;
      var $3=$1;
      var $4=__ZNK13address_space6deviceEv($3);
      var $5=__ZNK8device_t5ownerEv($4);
      var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
      $ld=$6;
      var $7=$ld;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      $player=$9;
      $result=0;
      var $10=$player;
      var $11=(($10+21)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $14
      var $15=$result;
      var $16=(($15)&255);
      var $17=$16 | 32;
      var $18=(($17) & 255);
      $result=$18;
      __label__ = 2; break;
    case 2: // $19
      var $20=$player;
      var $21=(($20+19)|0);
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=$result;
      var $26=(($25)&255);
      var $27=$26 | 16;
      var $28=(($27) & 255);
      $result=$28;
      __label__ = 4; break;
    case 4: // $29
      var $30=$result;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL4t0_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+17)|0);
  var $11=HEAP8[($10)];
  ;
  return $11;
}


function __ZL4t1_rP13address_spacej($space, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  var $ld;
  $1=$space;
  $2=$offset;
  var $3=$1;
  var $4=__ZNK13address_space6deviceEv($3);
  var $5=__ZNK8device_t5ownerEv($4);
  var $6=__Z21ldcore_get_safe_tokenP8device_t($5);
  $ld=$6;
  var $7=$ld;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=(($9+23)|0);
  var $11=HEAP8[($10)];
  ;
  return $11;
}


function __ZN12timer_device5resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  $1=$this;
  var $4=$1;
  var $5=$2;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($5)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($5+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($5+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  var $6=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  __ZN12timer_device6adjustE8attotimeiS0_($4, $2, 0, $3);
  STACKTOP = __stackBase__;
  return;
}


function __ZN14ppi8255_device22device_config_completeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t13static_configEv($3);
      var $5=$4;
      $intf=$5;
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+356)|0);
      var $11=$10;
      var $12=$intf;
      var $13=$11;
      var $14=$12;
      assert(144 % 1 === 0, 'memcpy given ' + 144 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $14>>2, $$dest = $13>>2, $$stop = $$src + 36; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($16+356)|0);
      var $18=$17;
      var $19=(($18)|0);
      var $20=$19;
      _memset($20, 0, 24, 1);
      var $21=$2;
      var $22=(($21+356)|0);
      var $23=$22;
      var $24=(($23+24)|0);
      var $25=$24;
      _memset($25, 0, 24, 1);
      var $26=$2;
      var $27=(($26+356)|0);
      var $28=$27;
      var $29=(($28+48)|0);
      var $30=$29;
      _memset($30, 0, 24, 1);
      var $31=$2;
      var $32=(($31+356)|0);
      var $33=$32;
      var $34=(($33+72)|0);
      var $35=$34;
      _memset($35, 0, 24, 1);
      var $36=$2;
      var $37=(($36+356)|0);
      var $38=$37;
      var $39=(($38+96)|0);
      var $40=$39;
      _memset($40, 0, 24, 1);
      var $41=$2;
      var $42=(($41+356)|0);
      var $43=$42;
      var $44=(($43+120)|0);
      var $45=$44;
      _memset($45, 0, 24, 1);
      __label__ = 3; break;
    case 3: // $46
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device22device_config_completeEv["X"]=1;

function __ZN14ppi8255_device12device_startEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+500)|0);
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5+356)|0);
  var $7=$6;
  var $8=(($7)|0);
  var $9=$2;
  __ZN20devcb_resolved_read87resolveERK11devcb_read8R8device_t($4, $8, $9);
  var $10=(($2+500)|0);
  var $11=(($10+32)|0);
  var $12=$2;
  var $13=(($12+356)|0);
  var $14=$13;
  var $15=(($14+24)|0);
  var $16=$2;
  __ZN20devcb_resolved_read87resolveERK11devcb_read8R8device_t($11, $15, $16);
  var $17=(($2+500)|0);
  var $18=(($17+64)|0);
  var $19=$2;
  var $20=(($19+356)|0);
  var $21=$20;
  var $22=(($21+48)|0);
  var $23=$2;
  __ZN20devcb_resolved_read87resolveERK11devcb_read8R8device_t($18, $22, $23);
  var $24=(($2+596)|0);
  var $25=(($24)|0);
  var $26=$2;
  var $27=(($26+356)|0);
  var $28=$27;
  var $29=(($28+72)|0);
  var $30=$2;
  __ZN21devcb_resolved_write87resolveERK12devcb_write8R8device_t($25, $29, $30);
  var $31=(($2+596)|0);
  var $32=(($31+32)|0);
  var $33=$2;
  var $34=(($33+356)|0);
  var $35=$34;
  var $36=(($35+96)|0);
  var $37=$2;
  __ZN21devcb_resolved_write87resolveERK12devcb_write8R8device_t($32, $36, $37);
  var $38=(($2+596)|0);
  var $39=(($38+64)|0);
  var $40=$2;
  var $41=(($40+356)|0);
  var $42=$41;
  var $43=(($42+120)|0);
  var $44=$2;
  __ZN21devcb_resolved_write87resolveERK12devcb_write8R8device_t($39, $43, $44);
  var $45=$2;
  var $46=(($2+692)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($45, $46, ((STRING_TABLE.__str16111)|0), 0);
  var $47=$2;
  var $48=(($2+693)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($47, $48, ((STRING_TABLE.__str26112)|0), 0);
  var $49=$2;
  var $50=(($2+694)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($49, $50, ((STRING_TABLE.__str36113)|0), 0);
  var $51=$2;
  var $52=(($2+695)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($51, $52, ((STRING_TABLE.__str46114)|0), 0);
  var $53=$2;
  var $54=(($2+696)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($53, $54, ((STRING_TABLE.__str56115)|0), 0);
  var $55=$2;
  var $56=(($2+697)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($55, $56, ((STRING_TABLE.__str66116)|0), 0);
  var $57=$2;
  var $58=(($2+698)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($57, $58, ((STRING_TABLE.__str76117)|0), 0);
  var $59=$2;
  var $60=(($2+699)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($59, $60, ((STRING_TABLE.__str86118)|0), 0);
  var $61=$2;
  var $62=(($2+700)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($61, $62, ((STRING_TABLE.__str96119)|0), 0);
  var $63=$2;
  var $64=(($2+701)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($63, $64, ((STRING_TABLE.__str106120)|0), 0);
  var $65=$2;
  var $66=(($2+702)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($65, $66, ((STRING_TABLE.__str116121)|0), 0);
  var $67=$2;
  var $68=(($2+703)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($67, $68, ((STRING_TABLE.__str126122)|0), 0);
  var $69=$2;
  var $70=(($2+704)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($69, $70, ((STRING_TABLE.__str136123)|0), 0);
  var $71=$2;
  var $72=(($2+705)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($71, $72, ((STRING_TABLE.__str146124)|0), 0);
  var $73=$2;
  var $74=(($2+706)|0);
  __ZN8device_t9save_itemIA3_hEEvRT_PKci($73, $74, ((STRING_TABLE.__str156125)|0), 0);
  var $75=$2;
  var $76=(($2+709)|0);
  __ZN8device_t9save_itemIA3_hEEvRT_PKci($75, $76, ((STRING_TABLE.__str166126)|0), 0);
  var $77=$2;
  var $78=(($2+712)|0);
  __ZN8device_t9save_itemIA3_hEEvRT_PKci($77, $78, ((STRING_TABLE.__str176127)|0), 0);
  var $79=$2;
  var $80=(($2+715)|0);
  __ZN8device_t9save_itemIA3_hEEvRT_PKci($79, $80, ((STRING_TABLE.__str186128)|0), 0);
  ;
  return;
}
__ZN14ppi8255_device12device_startEv["X"]=1;

function __ZN8device_t9save_itemIA3_hEEvRT_PKci($this, $value, $valname, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$value;
      $3=$valname;
      $4=$index;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=(($5+284)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZNK8device_t4nameEv($5);
      var $11=__ZNK8device_t3tagEv($5);
      var $12=$4;
      var $13=$2;
      var $14=$3;
      __ZN12save_manager9save_itemIhLj3EEEvPKcS2_iRAT0__T_S2_($9, $10, $11, $12, $13, $14);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14ppi8255_device12device_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      $1=$this;
      var $2=$1;
      var $3=(($2+692)|0);
      HEAP8[($3)]=0;
      var $4=(($2+693)|0);
      HEAP8[($4)]=0;
      var $5=(($2+694)|0);
      HEAP8[($5)]=0;
      var $6=(($2+695)|0);
      HEAP8[($6)]=0;
      var $7=(($2+696)|0);
      HEAP8[($7)]=0;
      var $8=(($2+697)|0);
      HEAP8[($8)]=0;
      var $9=(($2+700)|0);
      HEAP8[($9)]=0;
      var $10=(($2+698)|0);
      HEAP8[($10)]=0;
      var $11=(($2+701)|0);
      HEAP8[($11)]=0;
      var $12=(($2+699)|0);
      HEAP8[($12)]=0;
      var $13=(($2+705)|0);
      HEAP8[($13)]=0;
      var $14=(($2+704)|0);
      HEAP8[($14)]=0;
      var $15=(($2+703)|0);
      HEAP8[($15)]=0;
      var $16=(($2+702)|0);
      HEAP8[($16)]=0;
      $i=0;
      __label__ = 1; break;
    case 1: // $17
      var $18=$i;
      var $19=(($18)|0) < 3;
      if ($19) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $20
      var $21=$i;
      var $22=(($2+718)|0);
      var $23=(($22+$21)|0);
      HEAP8[($23)]=0;
      var $24=$i;
      var $25=(($2+715)|0);
      var $26=(($25+$24)|0);
      HEAP8[($26)]=0;
      var $27=$i;
      var $28=(($2+712)|0);
      var $29=(($28+$27)|0);
      HEAP8[($29)]=0;
      var $30=$i;
      var $31=(($2+709)|0);
      var $32=(($31+$30)|0);
      HEAP8[($32)]=0;
      var $33=$i;
      var $34=(($2+706)|0);
      var $35=(($34+$33)|0);
      HEAP8[($35)]=0;
      __label__ = 3; break;
    case 3: // $36
      var $37=$i;
      var $38=(($37+1)|0);
      $i=$38;
      __label__ = 1; break;
    case 4: // $39
      __ZN14ppi8255_device8set_modeEii($2, 155, 0);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device12device_resetEv["X"]=1;

function __ZN14ppi8255_device8set_modeEii($this, $data, $call_handlers) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $i;
      $1=$this;
      $2=$data;
      $3=$call_handlers;
      var $4=$1;
      var $5=$2;
      var $6=$5 >> 5;
      var $7=$6 & 3;
      var $8=(($7) & 255);
      var $9=(($4+692)|0);
      HEAP8[($9)]=$8;
      var $10=$2;
      var $11=$10 >> 2;
      var $12=$11 & 1;
      var $13=(($12) & 255);
      var $14=(($4+693)|0);
      HEAP8[($14)]=$13;
      var $15=$2;
      var $16=$15 >> 4;
      var $17=$16 & 1;
      var $18=(($17) & 255);
      var $19=(($4+694)|0);
      HEAP8[($19)]=$18;
      var $20=$2;
      var $21=$20 >> 1;
      var $22=$21 & 1;
      var $23=(($22) & 255);
      var $24=(($4+695)|0);
      HEAP8[($24)]=$23;
      var $25=$2;
      var $26=$25 >> 3;
      var $27=$26 & 1;
      var $28=(($27) & 255);
      var $29=(($4+696)|0);
      HEAP8[($29)]=$28;
      var $30=$2;
      var $31=$30 >> 0;
      var $32=$31 & 1;
      var $33=(($32) & 255);
      var $34=(($4+697)|0);
      HEAP8[($34)]=$33;
      var $35=(($4+692)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=(($37)|0)==3;
      if ($38) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $39
      var $40=(($4+692)|0);
      HEAP8[($40)]=2;
      __label__ = 2; break;
    case 2: // $41
      var $42=(($4+692)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==2;
      if ($45) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $46
      var $47=(($4+706)|0);
      var $48=(($47)|0);
      HEAP8[($48)]=-1;
      var $49=(($4+709)|0);
      var $50=(($49)|0);
      HEAP8[($50)]=-1;
      __label__ = 8; break;
    case 4: // $51
      var $52=(($4+694)|0);
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24)!=0;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=(($4+706)|0);
      var $57=(($56)|0);
      HEAP8[($57)]=-1;
      var $58=(($4+709)|0);
      var $59=(($58)|0);
      HEAP8[($59)]=0;
      __label__ = 7; break;
    case 6: // $60
      var $61=(($4+706)|0);
      var $62=(($61)|0);
      HEAP8[($62)]=0;
      var $63=(($4+709)|0);
      var $64=(($63)|0);
      HEAP8[($64)]=-1;
      __label__ = 7; break;
    case 7: // $65
      __label__ = 8; break;
    case 8: // $66
      var $67=(($4+695)|0);
      var $68=HEAP8[($67)];
      var $69=(($68 << 24) >> 24)!=0;
      if ($69) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $70
      var $71=(($4+706)|0);
      var $72=(($71+1)|0);
      HEAP8[($72)]=-1;
      var $73=(($4+709)|0);
      var $74=(($73+1)|0);
      HEAP8[($74)]=0;
      __label__ = 11; break;
    case 10: // $75
      var $76=(($4+706)|0);
      var $77=(($76+1)|0);
      HEAP8[($77)]=0;
      var $78=(($4+709)|0);
      var $79=(($78+1)|0);
      HEAP8[($79)]=-1;
      __label__ = 11; break;
    case 11: // $80
      var $81=(($4+696)|0);
      var $82=HEAP8[($81)];
      var $83=(($82 << 24) >> 24)!=0;
      if ($83) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $84
      var $85=(($4+706)|0);
      var $86=(($85+2)|0);
      HEAP8[($86)]=-16;
      var $87=(($4+709)|0);
      var $88=(($87+2)|0);
      HEAP8[($88)]=0;
      __label__ = 14; break;
    case 13: // $89
      var $90=(($4+706)|0);
      var $91=(($90+2)|0);
      HEAP8[($91)]=0;
      var $92=(($4+709)|0);
      var $93=(($92+2)|0);
      HEAP8[($93)]=-16;
      __label__ = 14; break;
    case 14: // $94
      var $95=(($4+697)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24)!=0;
      if ($97) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $98
      var $99=(($4+706)|0);
      var $100=(($99+2)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      var $103=$102 | 15;
      var $104=(($103) & 255);
      HEAP8[($100)]=$104;
      __label__ = 17; break;
    case 16: // $105
      var $106=(($4+709)|0);
      var $107=(($106+2)|0);
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      var $110=$109 | 15;
      var $111=(($110) & 255);
      HEAP8[($107)]=$111;
      __label__ = 17; break;
    case 17: // $112
      var $113=(($4+692)|0);
      var $114=HEAPU8[($113)];
      var $115=(($114)&255);
      if ($115 == 0) {
        __label__ = 20; break;
      }
      else if ($115 == 1) {
        __label__ = 18; break;
      }
      else if ($115 == 2) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 18: // $116
      var $117=(($4+706)|0);
      var $118=(($117+2)|0);
      var $119=HEAPU8[($118)];
      var $120=(($119)&255);
      var $121=$120 & -57;
      var $122=(($121) & 255);
      HEAP8[($118)]=$122;
      var $123=(($4+709)|0);
      var $124=(($123+2)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $127=$126 & -57;
      var $128=(($127) & 255);
      HEAP8[($124)]=$128;
      __label__ = 20; break;
    case 19: // $129
      var $130=(($4+706)|0);
      var $131=(($130+2)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=$133 & -249;
      var $135=(($134) & 255);
      HEAP8[($131)]=$135;
      var $136=(($4+709)|0);
      var $137=(($136+2)|0);
      var $138=HEAPU8[($137)];
      var $139=(($138)&255);
      var $140=$139 & -249;
      var $141=(($140) & 255);
      HEAP8[($137)]=$141;
      __label__ = 20; break;
    case 20: // $142
      var $143=(($4+693)|0);
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      if ($145 == 0) {
        __label__ = 22; break;
      }
      else if ($145 == 1) {
        __label__ = 21; break;
      }
      else {
      __label__ = 22; break;
      }
      
    case 21: // $146
      var $147=(($4+706)|0);
      var $148=(($147+2)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$150 & -8;
      var $152=(($151) & 255);
      HEAP8[($148)]=$152;
      var $153=(($4+709)|0);
      var $154=(($153+2)|0);
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$156 & -8;
      var $158=(($157) & 255);
      HEAP8[($154)]=$158;
      __label__ = 22; break;
    case 22: // $159
      var $160=(($4+715)|0);
      var $161=(($160+2)|0);
      HEAP8[($161)]=0;
      var $162=(($4+715)|0);
      var $163=(($162+1)|0);
      HEAP8[($163)]=0;
      var $164=(($4+715)|0);
      var $165=(($164)|0);
      HEAP8[($165)]=0;
      var $166=$3;
      var $167=(($166)|0)!=0;
      if ($167) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $168
      $i=0;
      __label__ = 24; break;
    case 24: // $169
      var $170=$i;
      var $171=(($170)|0) < 3;
      if ($171) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $172
      var $173=$i;
      __ZN14ppi8255_device18ppi8255_write_portEi($4, $173);
      __label__ = 26; break;
    case 26: // $174
      var $175=$i;
      var $176=(($175+1)|0);
      $i=$176;
      __label__ = 24; break;
    case 27: // $177
      __label__ = 28; break;
    case 28: // $178
      var $179=(($4+700)|0);
      HEAP8[($179)]=0;
      var $180=(($4+698)|0);
      HEAP8[($180)]=0;
      var $181=(($4+701)|0);
      HEAP8[($181)]=0;
      var $182=(($4+699)|0);
      HEAP8[($182)]=0;
      var $183=(($4+705)|0);
      HEAP8[($183)]=0;
      var $184=(($4+704)|0);
      HEAP8[($184)]=0;
      var $185=(($4+703)|0);
      HEAP8[($185)]=0;
      var $186=(($4+702)|0);
      HEAP8[($186)]=0;
      var $187=$2;
      var $188=(($187) & 255);
      var $189=(($4+721)|0);
      HEAP8[($189)]=$188;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device8set_modeEii["X"]=1;

function __Z14device_creatorI14ppi8255_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=724;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str196129)|0);
      HEAP32[(($6)>>2)]=111;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14ppi8255_deviceC1ERK14machine_configPKcP8device_tj]($53, $54, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI14ppi8255_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str196129)|0);
      HEAP32[(($3)>>2)]=111;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14device_creatorI14ppi8255_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN14ppi8255_deviceC2ERK14machine_configPKcP8device_tj($this, $mconfig, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$mconfig;
      $3=$tag;
      $4=$owner;
      $5=$clock;
      var $8=$1;
      var $9=$8;
      var $10=$2;
      var $11=HEAP32[((_PPI8255)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=$5;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($9, $10, $11, ((STRING_TABLE.__str6110)|0), $12, $13, $14);
      var $15=$8;
      var $16=(($15+356)|0);
      var $17=$16;
      var $18=$8;
      HEAP32[(($18)>>2)]=((__ZTV14ppi8255_device+8)|0);
      var $19=(($8+500)|0);
      var $20=(($19)|0);
      var $21=(($20+96)|0);
      var $23 = $20;__label__ = 1; break;
    case 1: // $22
      var $23;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN20devcb_resolved_read8C1Ev]($23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $24
      var $25=(($23+32)|0);
      var $26=(($25)|0)==(($21)|0);
      if ($26) { __label__ = 3; break; } else { var $23 = $25;__label__ = 1; break; }
    case 3: // $27
      var $28=(($8+596)|0);
      var $29=(($28)|0);
      var $30=(($29+96)|0);
      var $32 = $29;__label__ = 4; break;
    case 4: // $31
      var $32;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN21devcb_resolved_write8C1Ev]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $33
      var $34=(($32+32)|0);
      var $35=(($34)|0)==(($30)|0);
      if ($35) { __label__ = 6; break; } else { var $32 = $34;__label__ = 4; break; }
    case 6: // $36
      var $37=(($8+721)|0);
      HEAP8[($37)]=0;
      ;
      return;
    case 7: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $40=$39.f0;
      $6=$40;
      var $41=$39.f1;
      $7=$41;
      var $42=$8;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $43
      __label__ = 9; break;
    case 9: // $44
      var $45=$6;
      var $46=$6;
      var $47=$7;
      var $48=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $46, tempValue);
      var $49=($48.f1 = $47, $48);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_deviceC2ERK14machine_configPKcP8device_tj["X"]=1;

function __Z8downcastIP14ppi8255_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14ppi8255_device29ppi8255_get_handshake_signalsEiPh($this, $is_read, $result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $handshake;
      var $mask;
      $1=$this;
      $2=$is_read;
      $3=$result;
      var $4=$1;
      $handshake=0;
      $mask=0;
      var $5=(($4+692)|0);
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=(($7)|0)==1;
      if ($8) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $9
      var $10=(($4+694)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $13
      var $14=(($4+700)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24)!=0;
      var $17=$16 ? 32 : 0;
      var $18=$handshake;
      var $19=(($18)&255);
      var $20=$19 | $17;
      var $21=(($20) & 255);
      $handshake=$21;
      var $22=(($4+700)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24)!=0;
      if ($24) { __label__ = 3; break; } else { var $30 = 0;__label__ = 4; break; }
    case 3: // $25
      var $26=(($4+702)|0);
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24)!=0;
      var $30 = $28;__label__ = 4; break;
    case 4: // $29
      var $30;
      var $31=$30 ? 8 : 0;
      var $32=$handshake;
      var $33=(($32)&255);
      var $34=$33 | $31;
      var $35=(($34) & 255);
      $handshake=$35;
      var $36=$mask;
      var $37=(($36)&255);
      var $38=$37 | 40;
      var $39=(($38) & 255);
      $mask=$39;
      __label__ = 8; break;
    case 5: // $40
      var $41=(($4+698)|0);
      var $42=HEAP8[($41)];
      var $43=(($42 << 24) >> 24)!=0;
      var $44=$43 ? 0 : 128;
      var $45=$handshake;
      var $46=(($45)&255);
      var $47=$46 | $44;
      var $48=(($47) & 255);
      $handshake=$48;
      var $49=(($4+698)|0);
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24)!=0;
      if ($51) { __label__ = 6; break; } else { var $57 = 0;__label__ = 7; break; }
    case 6: // $52
      var $53=(($4+702)|0);
      var $54=HEAP8[($53)];
      var $55=(($54 << 24) >> 24)!=0;
      var $57 = $55;__label__ = 7; break;
    case 7: // $56
      var $57;
      var $58=$57 ? 8 : 0;
      var $59=$handshake;
      var $60=(($59)&255);
      var $61=$60 | $58;
      var $62=(($61) & 255);
      $handshake=$62;
      var $63=$mask;
      var $64=(($63)&255);
      var $65=$64 | 136;
      var $66=(($65) & 255);
      $mask=$66;
      __label__ = 8; break;
    case 8: // $67
      __label__ = 17; break;
    case 9: // $68
      var $69=(($4+692)|0);
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=(($71)|0)==2;
      if ($72) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $73
      var $74=(($4+698)|0);
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24)!=0;
      var $77=$76 ? 0 : 128;
      var $78=$handshake;
      var $79=(($78)&255);
      var $80=$79 | $77;
      var $81=(($80) & 255);
      $handshake=$81;
      var $82=(($4+700)|0);
      var $83=HEAP8[($82)];
      var $84=(($83 << 24) >> 24)!=0;
      var $85=$84 ? 32 : 0;
      var $86=$handshake;
      var $87=(($86)&255);
      var $88=$87 | $85;
      var $89=(($88) & 255);
      $handshake=$89;
      var $90=(($4+698)|0);
      var $91=HEAP8[($90)];
      var $92=(($91 << 24) >> 24)!=0;
      if ($92) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $93
      var $94=(($4+704)|0);
      var $95=HEAP8[($94)];
      var $96=(($95 << 24) >> 24)!=0;
      if ($96) { var $108 = 1;__label__ = 15; break; } else { __label__ = 12; break; }
    case 12: // $97
      var $98=(($4+700)|0);
      var $99=HEAP8[($98)];
      var $100=(($99 << 24) >> 24)!=0;
      if ($100) { __label__ = 13; break; } else { var $106 = 0;__label__ = 14; break; }
    case 13: // $101
      var $102=(($4+705)|0);
      var $103=HEAP8[($102)];
      var $104=(($103 << 24) >> 24)!=0;
      var $106 = $104;__label__ = 14; break;
    case 14: // $105
      var $106;
      var $108 = $106;__label__ = 15; break;
    case 15: // $107
      var $108;
      var $109=$108 ? 8 : 0;
      var $110=$handshake;
      var $111=(($110)&255);
      var $112=$111 | $109;
      var $113=(($112) & 255);
      $handshake=$113;
      var $114=$mask;
      var $115=(($114)&255);
      var $116=$115 | 168;
      var $117=(($116) & 255);
      $mask=$117;
      __label__ = 16; break;
    case 16: // $118
      __label__ = 17; break;
    case 17: // $119
      var $120=(($4+693)|0);
      var $121=HEAPU8[($120)];
      var $122=(($121)&255);
      var $123=(($122)|0)==1;
      if ($123) { __label__ = 18; break; } else { __label__ = 26; break; }
    case 18: // $124
      var $125=(($4+695)|0);
      var $126=HEAP8[($125)];
      var $127=(($126 << 24) >> 24)!=0;
      if ($127) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $128
      var $129=(($4+701)|0);
      var $130=HEAP8[($129)];
      var $131=(($130 << 24) >> 24)!=0;
      var $132=$131 ? 2 : 0;
      var $133=$handshake;
      var $134=(($133)&255);
      var $135=$134 | $132;
      var $136=(($135) & 255);
      $handshake=$136;
      var $137=(($4+701)|0);
      var $138=HEAP8[($137)];
      var $139=(($138 << 24) >> 24)!=0;
      if ($139) { __label__ = 20; break; } else { var $145 = 0;__label__ = 21; break; }
    case 20: // $140
      var $141=(($4+703)|0);
      var $142=HEAP8[($141)];
      var $143=(($142 << 24) >> 24)!=0;
      var $145 = $143;__label__ = 21; break;
    case 21: // $144
      var $145;
      var $146=$145 ? 1 : 0;
      var $147=$handshake;
      var $148=(($147)&255);
      var $149=$148 | $146;
      var $150=(($149) & 255);
      $handshake=$150;
      var $151=$mask;
      var $152=(($151)&255);
      var $153=$152 | 3;
      var $154=(($153) & 255);
      $mask=$154;
      __label__ = 25; break;
    case 22: // $155
      var $156=(($4+699)|0);
      var $157=HEAP8[($156)];
      var $158=(($157 << 24) >> 24)!=0;
      var $159=$158 ? 0 : 2;
      var $160=$handshake;
      var $161=(($160)&255);
      var $162=$161 | $159;
      var $163=(($162) & 255);
      $handshake=$163;
      var $164=(($4+699)|0);
      var $165=HEAP8[($164)];
      var $166=(($165 << 24) >> 24)!=0;
      if ($166) { __label__ = 23; break; } else { var $172 = 0;__label__ = 24; break; }
    case 23: // $167
      var $168=(($4+703)|0);
      var $169=HEAP8[($168)];
      var $170=(($169 << 24) >> 24)!=0;
      var $172 = $170;__label__ = 24; break;
    case 24: // $171
      var $172;
      var $173=$172 ? 1 : 0;
      var $174=$handshake;
      var $175=(($174)&255);
      var $176=$175 | $173;
      var $177=(($176) & 255);
      $handshake=$177;
      var $178=$mask;
      var $179=(($178)&255);
      var $180=$179 | 3;
      var $181=(($180) & 255);
      $mask=$181;
      __label__ = 25; break;
    case 25: // $182
      __label__ = 26; break;
    case 26: // $183
      var $184=$mask;
      var $185=(($184)&255);
      var $186=$185 ^ -1;
      var $187=$3;
      var $188=HEAPU8[($187)];
      var $189=(($188)&255);
      var $190=$189 & $186;
      var $191=(($190) & 255);
      HEAP8[($187)]=$191;
      var $192=$handshake;
      var $193=(($192)&255);
      var $194=$mask;
      var $195=(($194)&255);
      var $196=$193 & $195;
      var $197=$3;
      var $198=HEAPU8[($197)];
      var $199=(($198)&255);
      var $200=$199 | $196;
      var $201=(($200) & 255);
      HEAP8[($197)]=$201;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device29ppi8255_get_handshake_signalsEiPh["X"]=1;

function __ZN14ppi8255_device13ppi8255_inputEih($this, $port, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $changed;
      $1=$this;
      $2=$port;
      $3=$data;
      var $4=$1;
      $changed=0;
      var $5=$3;
      var $6=$2;
      var $7=(($4+712)|0);
      var $8=(($7+$6)|0);
      HEAP8[($8)]=$5;
      var $9=$2;
      var $10=(($9)|0)==2;
      if ($10) { __label__ = 1; break; } else { __label__ = 30; break; }
    case 1: // $11
      var $12=(($4+692)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=(($14)|0)==1;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=(($4+694)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $21
      var $22=(($4+692)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(($24)|0)==2;
      if ($25) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $26
      var $27=(($4+698)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $30
      var $31=$3;
      var $32=(($31)&255);
      var $33=$32 & 64;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $35
      var $36=(($4+698)|0);
      HEAP8[($36)]=0;
      $changed=1;
      __label__ = 7; break;
    case 7: // $37
      __label__ = 8; break;
    case 8: // $38
      var $39=(($4+692)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=(($41)|0)==1;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=(($4+694)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=(($46)|0)==1;
      if ($47) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $48
      var $49=(($4+692)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=(($51)|0)==2;
      if ($52) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $53
      var $54=(($4+700)|0);
      var $55=HEAP8[($54)];
      var $56=(($55 << 24) >> 24)!=0;
      if ($56) { __label__ = 14; break; } else { __label__ = 12; break; }
    case 12: // $57
      var $58=$3;
      var $59=(($58)&255);
      var $60=$59 & 16;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $62
      var $63=(($4+700)|0);
      HEAP8[($63)]=1;
      $changed=1;
      __label__ = 14; break;
    case 14: // $64
      __label__ = 15; break;
    case 15: // $65
      var $66=(($4+693)|0);
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      var $69=(($68)|0)==1;
      if ($69) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $70
      var $71=(($4+695)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($73)|0)==0;
      if ($74) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $75
      var $76=(($4+699)|0);
      var $77=HEAP8[($76)];
      var $78=(($77 << 24) >> 24)!=0;
      if ($78) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $79
      var $80=$3;
      var $81=(($80)&255);
      var $82=$81 & 4;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $84
      var $85=(($4+699)|0);
      HEAP8[($85)]=0;
      $changed=1;
      __label__ = 20; break;
    case 20: // $86
      __label__ = 21; break;
    case 21: // $87
      var $88=(($4+693)|0);
      var $89=HEAPU8[($88)];
      var $90=(($89)&255);
      var $91=(($90)|0)==1;
      if ($91) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $92
      var $93=(($4+695)|0);
      var $94=HEAPU8[($93)];
      var $95=(($94)&255);
      var $96=(($95)|0)==1;
      if ($96) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $97
      var $98=(($4+701)|0);
      var $99=HEAP8[($98)];
      var $100=(($99 << 24) >> 24)!=0;
      if ($100) { __label__ = 26; break; } else { __label__ = 24; break; }
    case 24: // $101
      var $102=$3;
      var $103=(($102)&255);
      var $104=$103 & 4;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $106
      var $107=(($4+701)|0);
      HEAP8[($107)]=1;
      $changed=1;
      __label__ = 26; break;
    case 26: // $108
      __label__ = 27; break;
    case 27: // $109
      var $110=$changed;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $112
      __ZN14ppi8255_device18ppi8255_write_portEi($4, 2);
      __label__ = 29; break;
    case 29: // $113
      __label__ = 30; break;
    case 30: // $114
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device13ppi8255_inputEih["X"]=1;

function __ZN14ppi8255_device18ppi8255_write_portEi($this, $port) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $write_data=__stackBase__;
      $1=$this;
      $2=$port;
      var $3=$1;
      var $4=$2;
      var $5=(($3+715)|0);
      var $6=(($5+$4)|0);
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$2;
      var $10=(($3+709)|0);
      var $11=(($10+$9)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$8 & $13;
      var $15=(($14) & 255);
      HEAP8[($write_data)]=$15;
      var $16=$2;
      var $17=(($3+709)|0);
      var $18=(($17+$16)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 ^ -1;
      var $22=255 & $21;
      var $23=HEAPU8[($write_data)];
      var $24=(($23)&255);
      var $25=$24 | $22;
      var $26=(($25) & 255);
      HEAP8[($write_data)]=$26;
      var $27=$2;
      var $28=(($27)|0)==2;
      if ($28) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $29
      __ZN14ppi8255_device29ppi8255_get_handshake_signalsEiPh($3, 0, $write_data);
      __label__ = 2; break;
    case 2: // $30
      var $31=HEAP8[($write_data)];
      var $32=$2;
      var $33=(($3+718)|0);
      var $34=(($33+$32)|0);
      HEAP8[($34)]=$31;
      var $35=$2;
      var $36=(($3+596)|0);
      var $37=(($36+($35<<5))|0);
      var $38=$37;
      var $39=HEAP8[($write_data)];
      __ZNK13delegate_baseIvjh8_noparamS0_EclEjh($38, 0, $39);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14ppi8255_device17ppi8255_read_portEi($this, $port) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result=__stackBase__;
      $1=$this;
      $2=$port;
      var $3=$1;
      HEAP8[($result)]=0;
      var $4=$2;
      var $5=(($3+706)|0);
      var $6=(($5+$4)|0);
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=$2;
      var $12=(($3+500)|0);
      var $13=(($12+($11<<5))|0);
      var $14=$13;
      var $15=__ZNK13delegate_baseIhj8_noparamS0_S0_EclEj($14, 0);
      __ZN14ppi8255_device13ppi8255_inputEih($3, $10, $15);
      var $16=$2;
      var $17=(($3+712)|0);
      var $18=(($17+$16)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=(($3+706)|0);
      var $23=(($22+$21)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$20 & $25;
      var $27=HEAPU8[($result)];
      var $28=(($27)&255);
      var $29=$28 | $26;
      var $30=(($29) & 255);
      HEAP8[($result)]=$30;
      __label__ = 2; break;
    case 2: // $31
      var $32=$2;
      var $33=(($3+715)|0);
      var $34=(($33+$32)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=$2;
      var $38=(($3+709)|0);
      var $39=(($38+$37)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$36 & $41;
      var $43=HEAPU8[($result)];
      var $44=(($43)&255);
      var $45=$44 | $42;
      var $46=(($45) & 255);
      HEAP8[($result)]=$46;
      var $47=$2;
      if ($47 == 0) {
        __label__ = 3; break;
      }
      else if ($47 == 1) {
        __label__ = 4; break;
      }
      else if ($47 == 2) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 3: // $48
      var $49=(($3+700)|0);
      HEAP8[($49)]=0;
      __label__ = 6; break;
    case 4: // $50
      var $51=(($3+701)|0);
      HEAP8[($51)]=0;
      __label__ = 6; break;
    case 5: // $52
      __ZN14ppi8255_device29ppi8255_get_handshake_signalsEiPh($3, 1, $result);
      __label__ = 6; break;
    case 6: // $53
      var $54=HEAP8[($result)];
      STACKTOP = __stackBase__;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device17ppi8255_read_portEi["X"]=1;

function __ZNK13delegate_baseIhj8_noparamS0_S0_EclEj($this, $p1) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$p1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($3+4)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=FUNCTION_TABLE[$5]($7, $8);
  ;
  return $9;
}


function __Z9ppi8255_rP8device_tj($device, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$offset;
  var $3=$1;
  var $4=__Z8downcastIP14ppi8255_device8device_tET_PT0_($3);
  var $5=$2;
  var $6=__ZN14ppi8255_device9ppi8255_rEj($4, $5);
  ;
  return $6;
}


function __ZN14ppi8255_device9ppi8255_rEj($this, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      $1=$this;
      $2=$offset;
      var $3=$1;
      $result=0;
      var $4=$2;
      var $5=(($4)>>>0)%4;
      $2=$5;
      var $6=$2;
      if ($6 == 0 || $6 == 1 || $6 == 2) {
        __label__ = 1; break;
      }
      else if ($6 == 3) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $7
      var $8=$2;
      var $9=__ZN14ppi8255_device17ppi8255_read_portEi($3, $8);
      $result=$9;
      __label__ = 3; break;
    case 2: // $10
      var $11=(($3+721)|0);
      var $12=HEAP8[($11)];
      $result=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$result;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK13delegate_baseIvjh8_noparamS0_EclEjh($this, $p1, $p2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$p1;
  $3=$p2;
  var $4=$1;
  var $5=(($4+8)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=(($4+4)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  var $10=$3;
  FUNCTION_TABLE[$6]($8, $9, $10);
  ;
  return;
}


function __Z9ppi8255_wP8device_tjh($device, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$device;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=__Z8downcastIP14ppi8255_device8device_tET_PT0_($4);
  var $6=$2;
  var $7=$3;
  __ZN14ppi8255_device9ppi8255_wEjh($5, $6, $7);
  ;
  return;
}


function __ZN14ppi8255_device9ppi8255_wEjh($this, $offset, $data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bit;
      $1=$this;
      $2=$offset;
      $3=$data;
      var $4=$1;
      var $5=$2;
      var $6=(($5)>>>0)%4;
      $2=$6;
      var $7=$2;
      if ($7 == 0 || $7 == 1 || $7 == 2) {
        __label__ = 1; break;
      }
      else if ($7 == 3) {
        __label__ = 11; break;
      }
      else {
      __label__ = 36; break;
      }
      
    case 1: // $8
      var $9=$3;
      var $10=$2;
      var $11=(($4+715)|0);
      var $12=(($11+$10)|0);
      HEAP8[($12)]=$9;
      var $13=$2;
      __ZN14ppi8255_device18ppi8255_write_portEi($4, $13);
      var $14=$2;
      if ($14 == 0) {
        __label__ = 2; break;
      }
      else if ($14 == 1) {
        __label__ = 6; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 2: // $15
      var $16=(($4+694)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24)!=0;
      if ($18) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $19
      var $20=(($4+692)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=(($4+698)|0);
      HEAP8[($25)]=1;
      __ZN14ppi8255_device18ppi8255_write_portEi($4, 2);
      __label__ = 5; break;
    case 5: // $26
      __label__ = 10; break;
    case 6: // $27
      var $28=(($4+695)|0);
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24)!=0;
      if ($30) { __label__ = 9; break; } else { __label__ = 7; break; }
    case 7: // $31
      var $32=(($4+693)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $36
      var $37=(($4+699)|0);
      HEAP8[($37)]=1;
      __ZN14ppi8255_device18ppi8255_write_portEi($4, 2);
      __label__ = 9; break;
    case 9: // $38
      __label__ = 10; break;
    case 10: // $39
      __label__ = 36; break;
    case 11: // $40
      var $41=$3;
      var $42=(($41)&255);
      var $43=$42 & 128;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $45
      var $46=$3;
      var $47=(($46)&255);
      var $48=$47 & 127;
      __ZN14ppi8255_device8set_modeEii($4, $48, 1);
      __label__ = 35; break;
    case 13: // $49
      var $50=$3;
      var $51=(($50)&255);
      var $52=$51 >> 1;
      var $53=$52 & 7;
      $bit=$53;
      var $54=$3;
      var $55=(($54)&255);
      var $56=$55 & 1;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $58
      var $59=$bit;
      var $60=1 << $59;
      var $61=(($4+715)|0);
      var $62=(($61+2)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=$64 | $60;
      var $66=(($65) & 255);
      HEAP8[($62)]=$66;
      __label__ = 16; break;
    case 15: // $67
      var $68=$bit;
      var $69=1 << $68;
      var $70=$69 ^ -1;
      var $71=(($4+715)|0);
      var $72=(($71+2)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$74 & $70;
      var $76=(($75) & 255);
      HEAP8[($72)]=$76;
      __label__ = 16; break;
    case 16: // $77
      var $78=(($4+693)|0);
      var $79=HEAPU8[($78)];
      var $80=(($79)&255);
      var $81=(($80)|0)==1;
      if ($81) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $82
      var $83=$bit;
      var $84=(($83)|0)==2;
      if ($84) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $85
      var $86=$3;
      var $87=(($86)&255);
      var $88=$87 & 1;
      var $89=(($88) & 255);
      var $90=(($4+703)|0);
      HEAP8[($90)]=$89;
      __label__ = 19; break;
    case 19: // $91
      __label__ = 20; break;
    case 20: // $92
      var $93=(($4+692)|0);
      var $94=HEAPU8[($93)];
      var $95=(($94)&255);
      var $96=(($95)|0)==1;
      if ($96) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $97
      var $98=$bit;
      var $99=(($98)|0)==4;
      if ($99) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $100
      var $101=(($4+694)|0);
      var $102=HEAP8[($101)];
      var $103=(($102 << 24) >> 24)!=0;
      if ($103) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $104
      var $105=$3;
      var $106=(($105)&255);
      var $107=$106 & 1;
      var $108=(($107) & 255);
      var $109=(($4+702)|0);
      HEAP8[($109)]=$108;
      __label__ = 24; break;
    case 24: // $110
      var $111=$bit;
      var $112=(($111)|0)==6;
      if ($112) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $113
      var $114=(($4+694)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24)!=0;
      if ($116) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $117
      var $118=$3;
      var $119=(($118)&255);
      var $120=$119 & 1;
      var $121=(($120) & 255);
      var $122=(($4+702)|0);
      HEAP8[($122)]=$121;
      __label__ = 27; break;
    case 27: // $123
      __label__ = 28; break;
    case 28: // $124
      var $125=(($4+692)|0);
      var $126=HEAPU8[($125)];
      var $127=(($126)&255);
      var $128=(($127)|0)==2;
      if ($128) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $129
      var $130=$bit;
      var $131=(($130)|0)==4;
      if ($131) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $132
      var $133=$3;
      var $134=(($133)&255);
      var $135=$134 & 1;
      var $136=(($135) & 255);
      var $137=(($4+705)|0);
      HEAP8[($137)]=$136;
      __label__ = 31; break;
    case 31: // $138
      var $139=$bit;
      var $140=(($139)|0)==6;
      if ($140) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $141
      var $142=$3;
      var $143=(($142)&255);
      var $144=$143 & 1;
      var $145=(($144) & 255);
      var $146=(($4+704)|0);
      HEAP8[($146)]=$145;
      __label__ = 33; break;
    case 33: // $147
      __label__ = 34; break;
    case 34: // $148
      __ZN14ppi8255_device18ppi8255_write_portEi($4, 2);
      __label__ = 35; break;
    case 35: // $149
      __label__ = 36; break;
    case 36: // $150
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_device9ppi8255_wEjh["X"]=1;

function __ZN14ppi8255_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN14ppi8255_deviceD2Ev($2);
  ;
  return;
}


function __ZN14ppi8255_device16device_post_loadEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN14ppi8255_device20device_clock_changedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZN12save_manager9save_itemIhLj3EEEvPKcS2_iRAT0__T_S2_($this, $module, $tag, $index, $value, $valname) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$module;
  $3=$tag;
  $4=$index;
  $5=$value;
  $6=$valname;
  var $7=$1;
  var $8=$2;
  var $9=$3;
  var $10=$4;
  var $11=$6;
  var $12=$5;
  var $13=(($12)|0);
  __ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj($7, $8, $9, $10, $11, $13, 1, 3);
  ;
  return;
}


function __ZN20resource_pool_objectI14ppi8255_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14ppi8255_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14ppi8255_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 724);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14ppi8255_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14ppi8255_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14ppi8255_deviceED2Ev($2);
  ;
  return;
}


function __ZN14ppi8255_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8device_tD2Ev($3);
  ;
  return;
}


function __ZN13z80ctc_device22device_config_completeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $intf;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=__ZNK8device_t13static_configEv($3);
      var $5=$4;
      $intf=$5;
      var $6=$intf;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+368)|0);
      var $11=$10;
      var $12=$intf;
      var $13=$11;
      var $14=$12;
      assert(100 % 1 === 0, 'memcpy given ' + 100 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $14>>2, $$dest = $13>>2, $$stop = $$src + 25; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      __label__ = 3; break;
    case 2: // $15
      var $16=$2;
      var $17=(($16+368)|0);
      var $18=$17;
      var $19=(($18)|0);
      HEAP8[($19)]=0;
      var $20=$2;
      var $21=(($20+368)|0);
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      _memset($24, 0, 24, 1);
      var $25=$2;
      var $26=(($25+368)|0);
      var $27=$26;
      var $28=(($27+28)|0);
      var $29=$28;
      _memset($29, 0, 24, 1);
      var $30=$2;
      var $31=(($30+368)|0);
      var $32=$31;
      var $33=(($32+52)|0);
      var $34=$33;
      _memset($34, 0, 24, 1);
      var $35=$2;
      var $36=(($35+368)|0);
      var $37=$36;
      var $38=(($37+76)|0);
      var $39=$38;
      _memset($39, 0, 24, 1);
      __label__ = 3; break;
    case 3: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13z80ctc_device22device_config_completeEv["X"]=1;

function __ZN13z80ctc_device12device_startEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  var $4=__stackBase__+24;
  var $5=__stackBase__+36;
  var $nullcb=__stackBase__+48;
  $1=$this;
  var $6=$1;
  var $7=(($6+504)|0);
  var $8=$6;
  var $9=(($8+248)|0);
  var $10=HEAPU32[(($9)>>2)];
  var $11=(($10)>>>0);
  __ZN8attotime7from_hzEd($3, $11);
  __ZmlRK8attotimej($2, $3, 16);
  var $12=$7;
  var $13=$2;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($12)>>2)]=HEAP32[(($13)>>2)];HEAP32[(($12+4)>>2)]=HEAP32[(($13+4)>>2)];HEAP32[(($12+8)>>2)]=HEAP32[(($13+8)>>2)];
  var $14=(($6+516)|0);
  var $15=$6;
  var $16=(($15+248)|0);
  var $17=HEAPU32[(($16)>>2)];
  var $18=(($17)>>>0);
  __ZN8attotime7from_hzEd($5, $18);
  __ZmlRK8attotimej($4, $5, 256);
  var $19=$14;
  var $20=$4;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[(($20)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[(($20+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[(($20+8)>>2)];
  var $21=(($6+468)|0);
  var $22=$6;
  var $23=(($22+368)|0);
  var $24=$23;
  var $25=(($24+4)|0);
  var $26=$6;
  __ZN25devcb_resolved_write_line7resolveERK16devcb_write_lineR8device_t($21, $25, $26);
  var $27=$nullcb;
  HEAP32[(($27)>>2)]=0; HEAP32[(($27+4)>>2)]=0; HEAP32[(($27+8)>>2)]=0; HEAP32[(($27+12)>>2)]=0; HEAP32[(($27+16)>>2)]=0; HEAP32[(($27+20)>>2)]=0;
  var $28=(($6+528)|0);
  var $29=(($28)|0);
  var $30=$6;
  var $31=(($30+368)|0);
  var $32=$31;
  var $33=(($32)|0);
  var $34=HEAPU8[($33)];
  var $35=(($34)&255);
  var $36=$35 & 1;
  var $37=(($36)|0)!=0;
  var $38=$6;
  var $39=(($38+368)|0);
  var $40=$39;
  var $41=(($40+28)|0);
  __ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line($29, $6, 0, $37, $41);
  var $42=(($6+528)|0);
  var $43=(($42+60)|0);
  var $44=$6;
  var $45=(($44+368)|0);
  var $46=$45;
  var $47=(($46)|0);
  var $48=HEAPU8[($47)];
  var $49=(($48)&255);
  var $50=$49 & 2;
  var $51=(($50)|0)!=0;
  var $52=$6;
  var $53=(($52+368)|0);
  var $54=$53;
  var $55=(($54+52)|0);
  __ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line($43, $6, 1, $51, $55);
  var $56=(($6+528)|0);
  var $57=(($56+120)|0);
  var $58=$6;
  var $59=(($58+368)|0);
  var $60=$59;
  var $61=(($60)|0);
  var $62=HEAPU8[($61)];
  var $63=(($62)&255);
  var $64=$63 & 4;
  var $65=(($64)|0)!=0;
  var $66=$6;
  var $67=(($66+368)|0);
  var $68=$67;
  var $69=(($68+76)|0);
  __ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line($57, $6, 2, $65, $69);
  var $70=(($6+528)|0);
  var $71=(($70+180)|0);
  var $72=$6;
  var $73=(($72+368)|0);
  var $74=$73;
  var $75=(($74)|0);
  var $76=HEAPU8[($75)];
  var $77=(($76)&255);
  var $78=$77 & 8;
  var $79=(($78)|0)!=0;
  __ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line($71, $6, 3, $79, $nullcb);
  var $80=$6;
  var $81=(($6+500)|0);
  __ZN8device_t9save_itemIhEEvRT_PKci($80, $81, ((STRING_TABLE.__str16137)|0), 0);
  STACKTOP = __stackBase__;
  return;
}
__ZN13z80ctc_device12device_startEv["X"]=1;

function __ZN14ppi8255_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN14ppi8255_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14ppi8255_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI14ppi8255_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14ppi8255_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14ppi8255_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI14ppi8255_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14ppi8255_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14ppi8255_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI14ppi8255_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI14ppi8255_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14device_creatorI13z80ctc_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=768;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str126148)|0);
      HEAP32[(($6)>>2)]=111;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13z80ctc_deviceC1ERK14machine_configPKcP8device_tj]($53, $54, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI13z80ctc_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str126148)|0);
      HEAP32[(($3)>>2)]=111;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14device_creatorI13z80ctc_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN13z80ctc_deviceC2ERK14machine_configPKcP8device_tj($this, $mconfig, $tag, $owner, $clock) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      $1=$this;
      $2=$mconfig;
      $3=$tag;
      $4=$owner;
      $5=$clock;
      var $8=$1;
      var $9=$8;
      var $10=$2;
      var $11=HEAP32[((_Z80CTC)>>2)];
      var $12=$3;
      var $13=$4;
      var $14=$5;
      __ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j($9, $10, $11, ((STRING_TABLE.__str6136)|0), $12, $13, $14);
      var $15=$8;
      HEAP32[(($15)>>2)]=((__ZTV13z80ctc_device+8)|0);
      var $16=$8;
      var $17=(($16+356)|0);
      var $18=$17;
      HEAP32[(($18)>>2)]=((__ZTV13z80ctc_device+88)|0);
      var $19=$8;
      var $20=(($19+356)|0);
      var $21=$20;
      var $22=$2;
      var $23=$8;
      (function() { try { __THREW__ = false; return __ZN25device_z80daisy_interfaceC2ERK14machine_configR8device_t($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $24
      var $25=$8;
      var $26=(($25+368)|0);
      var $27=$26;
      var $28=$8;
      HEAP32[(($28)>>2)]=((__ZTV13z80ctc_device+8)|0);
      var $29=$8;
      var $30=(($29+356)|0);
      var $31=$30;
      HEAP32[(($31)>>2)]=((__ZTV13z80ctc_device+88)|0);
      var $32=(($8+468)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN25devcb_resolved_write_lineC1Ev]($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $33
      var $34=(($8+504)|0);
      (function() { try { __THREW__ = false; return __ZN8attotimeC1Ev($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $35
      var $36=(($8+516)|0);
      (function() { try { __THREW__ = false; return __ZN8attotimeC1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $37
      var $38=(($8+528)|0);
      var $39=(($38)|0);
      var $40=(($39+240)|0);
      var $42 = $39;__label__ = 5; break;
    case 5: // $41
      var $42;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN13z80ctc_device11ctc_channelC1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $43
      var $44=(($42+60)|0);
      var $45=(($44)|0)==(($40)|0);
      if ($45) { __label__ = 7; break; } else { var $42 = $44;__label__ = 5; break; }
    case 7: // $46
      ;
      return;
    case 8: // $47
      var $48=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $49=$48.f0;
      $6=$49;
      var $50=$48.f1;
      $7=$50;
      __label__ = 11; break;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $6=$53;
      var $54=$52.f1;
      $7=$54;
      var $55=$8;
      var $56=(($55+356)|0);
      var $57=$56;
      (function() { try { __THREW__ = false; return __ZN25device_z80daisy_interfaceD2Ev($57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $58
      __label__ = 11; break;
    case 11: // $59
      var $60=$8;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $61
      __label__ = 13; break;
    case 13: // $62
      var $63=$6;
      var $64=$6;
      var $65=$7;
      var $66=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $64, tempValue);
      var $67=($66.f1 = $65, $66);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13z80ctc_deviceC2ERK14machine_configPKcP8device_tj["X"]=1;

function __Z8downcastIP13z80ctc_device8device_tET_PT0_($src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$src;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      var $4=$1;
      var $5=$4;
      ;
      return $5;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13z80ctc_device18z80daisy_irq_stateEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $state;
      var $ch;
      var $channel;
      $1=$this;
      var $2=$1;
      __label__ = 1; break;
    case 1: // $3
      __label__ = 2; break;
    case 2: // $4
      $state=0;
      $ch=0;
      __label__ = 3; break;
    case 3: // $5
      var $6=$ch;
      var $7=(($6)|0) < 4;
      if ($7) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $8
      var $9=$ch;
      var $10=(($2+528)|0);
      var $11=(($10+$9*60)|0);
      $channel=$11;
      var $12=$channel;
      var $13=(($12+56)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 & 2;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $18
      var $19=$state;
      var $20=$19 | 2;
      $state=$20;
      __label__ = 8; break;
    case 6: // $21
      var $22=$channel;
      var $23=(($22+56)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$state;
      var $27=$26 | $25;
      $state=$27;
      __label__ = 7; break;
    case 7: // $28
      var $29=$ch;
      var $30=(($29+1)|0);
      $ch=$30;
      __label__ = 3; break;
    case 8: // $31
      var $32=$state;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line($this, $device, $index, $notimer, $write_line) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$this;
  $2=$device;
  $3=$index;
  var $6=(($notimer)&1);
  $4=$6;
  $5=$write_line;
  var $7=$1;
  var $8=$2;
  var $9=(($7)|0);
  HEAP32[(($9)>>2)]=$8;
  var $10=$3;
  var $11=(($7+4)|0);
  HEAP32[(($11)>>2)]=$10;
  var $12=(($7+8)|0);
  var $13=$5;
  var $14=(($7)|0);
  var $15=HEAP32[(($14)>>2)];
  var $16=$15;
  __ZN25devcb_resolved_write_line7resolveERK16devcb_write_lineR8device_t($12, $13, $16);
  var $17=$4;
  var $18=(($17) & 1);
  var $19=(($7+40)|0);
  var $20=(($18)&1);
  HEAP8[($19)]=$20;
  var $21=(($7)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=$22;
  var $24=__ZNK8device_t7machineEv($23);
  var $25=__ZN15running_machine9schedulerEv($24);
  var $26=$7;
  var $27=__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_($25, 1416, ((STRING_TABLE.__str46140)|0), $26);
  var $28=(($7+52)|0);
  HEAP32[(($28)>>2)]=$27;
  var $29=(($7)|0);
  var $30=HEAP32[(($29)>>2)];
  var $31=$30;
  var $32=(($7+42)|0);
  var $33=(($7+4)|0);
  var $34=HEAP32[(($33)>>2)];
  __ZN8device_t9save_itemItEEvRT_PKci($31, $32, ((STRING_TABLE.__str56141)|0), $34);
  var $35=(($7)|0);
  var $36=HEAP32[(($35)>>2)];
  var $37=$36;
  var $38=(($7+44)|0);
  var $39=(($7+4)|0);
  var $40=HEAP32[(($39)>>2)];
  __ZN8device_t9save_itemItEEvRT_PKci($37, $38, ((STRING_TABLE.__str66142)|0), $40);
  var $41=(($7)|0);
  var $42=HEAP32[(($41)>>2)];
  var $43=$42;
  var $44=(($7+46)|0);
  var $45=(($7+4)|0);
  var $46=HEAP32[(($45)>>2)];
  __ZN8device_t9save_itemItEEvRT_PKci($43, $44, ((STRING_TABLE.__str76143)|0), $46);
  var $47=(($7)|0);
  var $48=HEAP32[(($47)>>2)];
  var $49=$48;
  var $50=(($7+48)|0);
  var $51=(($7+4)|0);
  var $52=HEAP32[(($51)>>2)];
  __ZN8device_t9save_itemIhEEvRT_PKci($49, $50, ((STRING_TABLE.__str86144)|0), $52);
  var $53=(($7)|0);
  var $54=HEAP32[(($53)>>2)];
  var $55=$54;
  var $56=(($7+56)|0);
  var $57=(($7+4)|0);
  var $58=HEAP32[(($57)>>2)];
  __ZN8device_t9save_itemIhEEvRT_PKci($55, $56, ((STRING_TABLE.__str96145)|0), $58);
  ;
  return;
}
__ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line["X"]=1;

function __ZN13z80ctc_device12device_resetEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+528)|0);
      var $4=(($3)|0);
      __ZN13z80ctc_device11ctc_channel5resetEv($4);
      var $5=(($2+528)|0);
      var $6=(($5+60)|0);
      __ZN13z80ctc_device11ctc_channel5resetEv($6);
      var $7=(($2+528)|0);
      var $8=(($7+120)|0);
      __ZN13z80ctc_device11ctc_channel5resetEv($8);
      var $9=(($2+528)|0);
      var $10=(($9+180)|0);
      __ZN13z80ctc_device11ctc_channel5resetEv($10);
      __ZN13z80ctc_device15interrupt_checkEv($2);
      __label__ = 1; break;
    case 1: // $11
      __label__ = 2; break;
    case 2: // $12
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13z80ctc_device11ctc_channel5resetEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+12;
  $1=$this;
  var $4=$1;
  var $5=(($4+42)|0);
  HEAP16[(($5)>>1)]=2;
  var $6=(($4+44)|0);
  HEAP16[(($6)>>1)]=256;
  var $7=(($4+52)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$2;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  var $10=$3;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($10+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($10+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
  __ZN9emu_timer6adjustE8attotimeiS0_($8, $2, 0, $3);
  var $11=(($4+56)|0);
  HEAP8[($11)]=0;
  STACKTOP = __stackBase__;
  return;
}


function __ZN13z80ctc_device15interrupt_checkEv($this) {
  ;
  var __label__;

  var $1;
  var $state;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+60)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=FUNCTION_TABLE[$6]($2);
  var $8=$7 & 1;
  var $9=(($8)|0)!=0;
  var $10=$9 ? 1 : 0;
  $state=$10;
  var $11=(($2+468)|0);
  var $12=$11;
  var $13=$state;
  __ZNK13delegate_baseIvi8_noparamS0_S0_EclEi($12, $13);
  ;
  return;
}


function __ZThn356_N13z80ctc_device18z80daisy_irq_stateEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  var $6=__ZN13z80ctc_device18z80daisy_irq_stateEv($5);
  ;
  return $6;
}


function __ZN13z80ctc_device16z80daisy_irq_ackEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $ch;
      var $channel;
      $2=$this;
      var $3=$2;
      $ch=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$ch;
      var $6=(($5)|0) < 4;
      if ($6) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $7
      var $8=$ch;
      var $9=(($3+528)|0);
      var $10=(($9+$8*60)|0);
      $channel=$10;
      var $11=$channel;
      var $12=(($11+56)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$14 & 1;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $17
      __label__ = 4; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$channel;
      var $21=(($20+56)|0);
      HEAP8[($21)]=2;
      __ZN13z80ctc_device15interrupt_checkEv($3);
      var $22=(($3+500)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$ch;
      var $26=((($25<<1))|0);
      var $27=(($24+$26)|0);
      $1=$27;
      __label__ = 9; break;
    case 6: // $28
      __label__ = 7; break;
    case 7: // $29
      var $30=$ch;
      var $31=(($30+1)|0);
      $ch=$31;
      __label__ = 1; break;
    case 8: // $32
      __Z8logerrorPKcz(((STRING_TABLE.__str26138)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $33=(($3+500)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      $1=$35;
      __label__ = 9; break;
    case 9: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn356_N13z80ctc_device16z80daisy_irq_ackEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  var $6=__ZN13z80ctc_device16z80daisy_irq_ackEv($5);
  ;
  return $6;
}


function __ZN13z80ctc_device17z80daisy_irq_retiEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ch;
      var $channel;
      $1=$this;
      var $2=$1;
      $ch=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$ch;
      var $5=(($4)|0) < 4;
      if ($5) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $6
      var $7=$ch;
      var $8=(($2+528)|0);
      var $9=(($8+$7*60)|0);
      $channel=$9;
      var $10=$channel;
      var $11=(($10+56)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$13 & 2;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$channel;
      var $20=(($19+56)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=$22 & -3;
      var $24=(($23) & 255);
      HEAP8[($20)]=$24;
      __ZN13z80ctc_device15interrupt_checkEv($2);
      __label__ = 9; break;
    case 6: // $25
      __label__ = 7; break;
    case 7: // $26
      var $27=$ch;
      var $28=(($27+1)|0);
      $ch=$28;
      __label__ = 1; break;
    case 8: // $29
      __Z8logerrorPKcz(((STRING_TABLE.__str36139)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 9; break;
    case 9: // $30
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZThn356_N13z80ctc_device17z80daisy_irq_retiEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN13z80ctc_device17z80daisy_irq_retiEv($5);
  ;
  return;
}


function __ZNK13delegate_baseIvi8_noparamS0_S0_EclEi($this, $p1) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$p1;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($3+4)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  FUNCTION_TABLE[$5]($7, $8);
  ;
  return;
}


function __ZN13z80ctc_device11ctc_channelC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  FUNCTION_TABLE[__ZN25devcb_resolved_write_lineC1Ev]($3);
  var $4=(($2+40)|0);
  HEAP8[($4)]=0;
  var $5=(($2+42)|0);
  HEAP16[(($5)>>1)]=0;
  var $6=(($2+44)|0);
  HEAP16[(($6)>>1)]=0;
  var $7=(($2+46)|0);
  HEAP16[(($7)>>1)]=0;
  var $8=(($2+48)|0);
  HEAP8[($8)]=0;
  var $9=(($2+52)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=(($2+56)|0);
  HEAP8[($10)]=0;
  var $11=(($2+8)|0);
  var $12=$11;
  _memset($12, 0, 32, 1);
  ;
  return;
}


function __ZN13z80ctc_device11ctc_channel21static_timer_callbackER15running_machinePvi($machine, $ptr, $param) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$machine;
  $2=$ptr;
  $3=$param;
  var $4=$2;
  var $5=$4;
  __ZN13z80ctc_device11ctc_channel14timer_callbackEv($5);
  ;
  return;
}


function __ZNK13z80ctc_device11ctc_channel6periodEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $period=__stackBase__;
      $1=$this;
      var $2=$1;
      var $3=(($2+42)|0);
      var $4=HEAPU16[(($3)>>1)];
      var $5=(($4)&65535);
      var $6=$5 & 2;
      var $7=(($6)|0)==2;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$agg_result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($9+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($9+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      __label__ = 8; break;
    case 2: // $10
      var $11=(($2+42)|0);
      var $12=HEAPU16[(($11)>>1)];
      var $13=(($12)&65535);
      var $14=$13 & 64;
      var $15=(($14)|0)==64;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($2+4)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z8logerrorPKcz(((STRING_TABLE.__str106146)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$18,tempInt));
      var $19=$agg_result;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($19)>>2)]=HEAP32[((__ZN8attotime4zeroE)>>2)];HEAP32[(($19+4)>>2)]=HEAP32[((__ZN8attotime4zeroE+4)>>2)];HEAP32[(($19+8)>>2)]=HEAP32[((__ZN8attotime4zeroE+8)>>2)];
      __label__ = 8; break;
    case 4: // $20
      var $21=(($2+42)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=$23 & 32;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=(($2)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+504)|0);
      var $35 = $29;__label__ = 7; break;
    case 6: // $30
      var $31=(($2)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+516)|0);
      var $35 = $33;__label__ = 7; break;
    case 7: // $34
      var $35;
      var $36=$period;
      var $37=$35;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      var $38=(($2+44)|0);
      var $39=HEAPU16[(($38)>>1)];
      var $40=(($39)&65535);
      __ZmlRK8attotimej($agg_result, $period, $40);
      __label__ = 8; break;
    case 8: // $41
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13z80ctc_device11ctc_channel4readEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $period=__stackBase__;
      var $3=__stackBase__+12;
      $2=$this;
      var $4=$2;
      var $5=(($4+42)|0);
      var $6=HEAPU16[(($5)>>1)];
      var $7=(($6)&65535);
      var $8=$7 & 64;
      var $9=(($8)|0)==64;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=(($4+42)|0);
      var $12=HEAPU16[(($11)>>1)];
      var $13=(($12)&65535);
      var $14=$13 & 256;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=(($4+46)|0);
      var $18=HEAP16[(($17)>>1)];
      var $19=(($18) & 255);
      $1=$19;
      __label__ = 11; break;
    case 3: // $20
      var $21=(($4+42)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=$23 & 32;
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=(($4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+504)|0);
      var $35 = $29;__label__ = 6; break;
    case 5: // $30
      var $31=(($4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+516)|0);
      var $35 = $33;__label__ = 6; break;
    case 6: // $34
      var $35;
      var $36=$period;
      var $37=$35;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      __label__ = 7; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      var $40=(($4+52)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=(($4+52)|0);
      var $45=HEAP32[(($44)>>2)];
      __ZNK9emu_timer9remainingEv($3, $45);
      var $46=__ZNK8attotime9as_doubleEv($3);
      var $47=__ZNK8attotime9as_doubleEv($period);
      var $48=$46/$47;
      var $49=(($48)|0);
      var $50=(($49+1)|0);
      var $51=$50 & 255;
      var $52=(($51) & 255);
      $1=$52;
      __label__ = 11; break;
    case 10: // $53
      $1=0;
      __label__ = 11; break;
    case 11: // $54
      var $55=$1;
      STACKTOP = __stackBase__;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13z80ctc_device11ctc_channel4readEv["X"]=1;

function __ZN13z80ctc_device11ctc_channel5writeEh($this, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curperiod=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $5=__stackBase__+36;
      var $6=__stackBase__+48;
      var $7=__stackBase__+60;
      var $8=__stackBase__+72;
      $1=$this;
      $2=$data;
      var $9=$1;
      var $10=(($9+42)|0);
      var $11=HEAPU16[(($10)>>1)];
      var $12=(($11)&65535);
      var $13=$12 & 4;
      var $14=(($13)|0)==4;
      if ($14) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $15
      __label__ = 2; break;
    case 2: // $16
      __label__ = 3; break;
    case 3: // $17
      var $18=$2;
      var $19=(($18 << 24) >> 24)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      var $21=$2;
      var $22=(($21)&255);
      var $25 = $22;__label__ = 6; break;
    case 5: // $23
      var $25 = 256;__label__ = 6; break;
    case 6: // $24
      var $25;
      var $26=(($25) & 65535);
      var $27=(($9+44)|0);
      HEAP16[(($27)>>1)]=$26;
      var $28=(($9+42)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=$30 & -5;
      var $32=(($31) & 65535);
      HEAP16[(($28)>>1)]=$32;
      var $33=(($9+42)|0);
      var $34=HEAPU16[(($33)>>1)];
      var $35=(($34)&65535);
      var $36=$35 & -3;
      var $37=(($36) & 65535);
      HEAP16[(($33)>>1)]=$37;
      var $38=(($9+42)|0);
      var $39=HEAPU16[(($38)>>1)];
      var $40=(($39)&65535);
      var $41=$40 & 64;
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $43
      var $44=(($9+42)|0);
      var $45=HEAPU16[(($44)>>1)];
      var $46=(($45)&65535);
      var $47=$46 & 8;
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $49
      var $50=(($9+40)|0);
      var $51=HEAP8[($50)];
      var $52=(($51) & 1);
      if ($52) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $53
      __ZNK13z80ctc_device11ctc_channel6periodEv($curperiod, $9);
      var $54=(($9+52)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$3;
      var $57=$curperiod;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($56)>>2)]=HEAP32[(($57)>>2)];HEAP32[(($56+4)>>2)]=HEAP32[(($57+4)>>2)];HEAP32[(($56+8)>>2)]=HEAP32[(($57+8)>>2)];
      var $58=(($9+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$4;
      var $61=$curperiod;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($60)>>2)]=HEAP32[(($61)>>2)];HEAP32[(($60+4)>>2)]=HEAP32[(($61+4)>>2)];HEAP32[(($60+8)>>2)]=HEAP32[(($61+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($55, $3, $59, $4);
      __label__ = 11; break;
    case 10: // $62
      var $63=(($9+52)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($65)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($65+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($65+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $66=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($66)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($66+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($66+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($64, $5, 0, $6);
      __label__ = 11; break;
    case 11: // $67
      __label__ = 13; break;
    case 12: // $68
      var $69=(($9+42)|0);
      var $70=HEAPU16[(($69)>>1)];
      var $71=(($70)&65535);
      var $72=$71 | 256;
      var $73=(($72) & 65535);
      HEAP16[(($69)>>1)]=$73;
      __label__ = 13; break;
    case 13: // $74
      __label__ = 14; break;
    case 14: // $75
      var $76=(($9+44)|0);
      var $77=HEAP16[(($76)>>1)];
      var $78=(($9+46)|0);
      HEAP16[(($78)>>1)]=$77;
      __label__ = 26; break;
    case 15: // $79
      var $80=$2;
      var $81=(($80)&255);
      var $82=$81 & 1;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $84
      var $85=(($9+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $88
      var $89=$2;
      var $90=(($89)&255);
      var $91=$90 & 248;
      var $92=(($91) & 255);
      var $93=(($9)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94+500)|0);
      HEAP8[($95)]=$92;
      var $96=(($9)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+500)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      __Z8logerrorPKcz(((STRING_TABLE.__str116147)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$100,tempInt));
      __label__ = 25; break;
    case 18: // $101
      var $102=$2;
      var $103=(($102)&255);
      var $104=$103 & 1;
      var $105=(($104)|0)==1;
      if ($105) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 19: // $106
      var $107=$2;
      var $108=(($107)&255);
      var $109=(($9+42)|0);
      HEAP16[(($109)>>1)]=$108;
      __label__ = 20; break;
    case 20: // $110
      __label__ = 21; break;
    case 21: // $111
      var $112=$2;
      var $113=(($112)&255);
      var $114=$113 & 2;
      var $115=(($114)|0)==2;
      if ($115) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $116
      var $117=(($9+52)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$7;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($119)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($119+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($119+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $120=$8;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($120)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($120+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($120+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($118, $7, 0, $8);
      __label__ = 23; break;
    case 23: // $121
      __label__ = 24; break;
    case 24: // $122
      __label__ = 25; break;
    case 25: // $123
      __label__ = 26; break;
    case 26: // $124
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13z80ctc_device11ctc_channel5writeEh["X"]=1;

function __ZN13z80ctc_device11ctc_channel7triggerEh($this, $data) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curperiod=__stackBase__;
      var $3=__stackBase__+12;
      var $4=__stackBase__+24;
      var $5=__stackBase__+36;
      var $6=__stackBase__+48;
      $1=$this;
      $2=$data;
      var $7=$1;
      var $8=$2;
      var $9=(($8 << 24) >> 24)!=0;
      var $10=$9 ? 1 : 0;
      var $11=(($10) & 255);
      $2=$11;
      var $12=$2;
      var $13=(($12)&255);
      var $14=(($7+48)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=(($13)|0)!=(($16)|0);
      if ($17) { __label__ = 1; break; } else { __label__ = 21; break; }
    case 1: // $18
      var $19=$2;
      var $20=(($7+48)|0);
      HEAP8[($20)]=$19;
      var $21=(($7+42)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=$23 & 16;
      var $25=(($24)|0)==16;
      if ($25) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $26
      var $27=$2;
      var $28=(($27 << 24) >> 24)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $29
      var $30=(($7+42)|0);
      var $31=HEAPU16[(($30)>>1)];
      var $32=(($31)&65535);
      var $33=$32 & 16;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $35
      var $36=$2;
      var $37=(($36 << 24) >> 24)!=0;
      if ($37) { __label__ = 20; break; } else { __label__ = 5; break; }
    case 5: // $38
      var $39=(($7+42)|0);
      var $40=HEAPU16[(($39)>>1)];
      var $41=(($40)&65535);
      var $42=$41 & 256;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $44
      var $45=(($7+42)|0);
      var $46=HEAPU16[(($45)>>1)];
      var $47=(($46)&65535);
      var $48=$47 & 64;
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 7; break; } else { __label__ = 15; break; }
    case 7: // $50
      var $51=(($7+40)|0);
      var $52=HEAP8[($51)];
      var $53=(($52) & 1);
      if ($53) { __label__ = 11; break; } else { __label__ = 8; break; }
    case 8: // $54
      __ZNK13z80ctc_device11ctc_channel6periodEv($curperiod, $7);
      __label__ = 9; break;
    case 9: // $55
      __label__ = 10; break;
    case 10: // $56
      var $57=(($7+52)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$3;
      var $60=$curperiod;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];HEAP32[(($59+4)>>2)]=HEAP32[(($60+4)>>2)];HEAP32[(($59+8)>>2)]=HEAP32[(($60+8)>>2)];
      var $61=(($7+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$4;
      var $64=$curperiod;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($63)>>2)]=HEAP32[(($64)>>2)];HEAP32[(($63+4)>>2)]=HEAP32[(($64+4)>>2)];HEAP32[(($63+8)>>2)]=HEAP32[(($64+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($58, $3, $62, $4);
      __label__ = 14; break;
    case 11: // $65
      __label__ = 12; break;
    case 12: // $66
      __label__ = 13; break;
    case 13: // $67
      var $68=(($7+52)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$5;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($70)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($70+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($70+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      var $71=$6;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($71)>>2)]=HEAP32[((__ZN8attotime5neverE)>>2)];HEAP32[(($71+4)>>2)]=HEAP32[((__ZN8attotime5neverE+4)>>2)];HEAP32[(($71+8)>>2)]=HEAP32[((__ZN8attotime5neverE+8)>>2)];
      __ZN9emu_timer6adjustE8attotimeiS0_($69, $5, 0, $6);
      __label__ = 14; break;
    case 14: // $72
      __label__ = 15; break;
    case 15: // $73
      var $74=(($7+42)|0);
      var $75=HEAPU16[(($74)>>1)];
      var $76=(($75)&65535);
      var $77=$76 & -257;
      var $78=(($77) & 65535);
      HEAP16[(($74)>>1)]=$78;
      var $79=(($7+42)|0);
      var $80=HEAPU16[(($79)>>1)];
      var $81=(($80)&65535);
      var $82=$81 & 64;
      var $83=(($82)|0)==64;
      if ($83) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $84
      var $85=(($7+46)|0);
      var $86=HEAP16[(($85)>>1)];
      var $87=(($86-1)&65535);
      HEAP16[(($85)>>1)]=$87;
      var $88=(($87)&65535);
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $90
      __ZN13z80ctc_device11ctc_channel14timer_callbackEv($7);
      __label__ = 18; break;
    case 18: // $91
      __label__ = 19; break;
    case 19: // $92
      __label__ = 20; break;
    case 20: // $93
      __label__ = 21; break;
    case 21: // $94
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13z80ctc_device11ctc_channel7triggerEh["X"]=1;

function __ZN13z80ctc_device11ctc_channel14timer_callbackEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+42)|0);
      var $4=HEAPU16[(($3)>>1)];
      var $5=(($4)&65535);
      var $6=$5 & 128;
      var $7=(($6)|0)==128;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=(($2+56)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=$11 | 1;
      var $13=(($12) & 255);
      HEAP8[($9)]=$13;
      __label__ = 2; break;
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=(($2)|0);
      var $17=HEAP32[(($16)>>2)];
      __ZN13z80ctc_device15interrupt_checkEv($17);
      __label__ = 4; break;
    case 4: // $18
      var $19=(($2+8)|0);
      var $20=$19;
      __ZNK13delegate_baseIvi8_noparamS0_S0_EclEi($20, 1);
      var $21=(($2+8)|0);
      var $22=$21;
      __ZNK13delegate_baseIvi8_noparamS0_S0_EclEi($22, 0);
      var $23=(($2+44)|0);
      var $24=HEAP16[(($23)>>1)];
      var $25=(($2+46)|0);
      HEAP16[(($25)>>1)]=$24;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8z80ctc_wP8device_tjh($device, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$device;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=__Z8downcastIP13z80ctc_device8device_tET_PT0_($4);
  var $6=$2;
  var $7=$6 & 3;
  var $8=$3;
  __ZN13z80ctc_device5writeEih($5, $7, $8);
  ;
  return;
}


function __ZNK15running_machine11driver_dataEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+1300)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZN13z80ctc_device5writeEih($this, $ch, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$ch;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=(($4+528)|0);
  var $7=(($6+$5*60)|0);
  var $8=$3;
  __ZN13z80ctc_device11ctc_channel5writeEh($7, $8);
  ;
  return;
}


function __Z8z80ctc_rP8device_tj($device, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$offset;
  var $3=$1;
  var $4=__Z8downcastIP13z80ctc_device8device_tET_PT0_($3);
  var $5=$2;
  var $6=$5 & 3;
  var $7=__ZN13z80ctc_device4readEi($4, $6);
  ;
  return $7;
}


function __ZN13z80ctc_device4readEi($this, $ch) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$ch;
  var $3=$1;
  var $4=$2;
  var $5=(($3+528)|0);
  var $6=(($5+$4*60)|0);
  var $7=__ZN13z80ctc_device11ctc_channel4readEv($6);
  ;
  return $7;
}


function __ZN13z80ctc_device7triggerEih($this, $ch, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$ch;
  $3=$data;
  var $4=$1;
  var $5=$2;
  var $6=(($4+528)|0);
  var $7=(($6+$5*60)|0);
  var $8=$3;
  __ZN13z80ctc_device11ctc_channel7triggerEh($7, $8);
  ;
  return;
}


function __Z13z80ctc_trg1_wP8device_ti($device, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$state;
  var $3=$1;
  var $4=__Z8downcastIP13z80ctc_device8device_tET_PT0_($3);
  var $5=$2;
  var $6=(($5) & 255);
  __ZN13z80ctc_device7triggerEih($4, 1, $6);
  ;
  return;
}


function __Z13z80ctc_trg2_wP8device_ti($device, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$device;
  $2=$state;
  var $3=$1;
  var $4=__Z8downcastIP13z80ctc_device8device_tET_PT0_($3);
  var $5=$2;
  var $6=(($5) & 255);
  __ZN13z80ctc_device7triggerEih($4, 2, $6);
  ;
  return;
}


function __ZN13z80ctc_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN13z80ctc_deviceD2Ev($2);
  ;
  return;
}


function __ZThn356_N13z80ctc_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN13z80ctc_deviceD1Ev($5);
  ;
  return;
}


function __ZThn356_N13z80ctc_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-356)|0);
  var $5=$4;
  __ZN13z80ctc_deviceD0Ev($5);
  ;
  return;
}


function __ZN20resource_pool_objectI13z80ctc_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI13z80ctc_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI13z80ctc_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 768);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI13z80ctc_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI13z80ctc_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI13z80ctc_deviceED2Ev($2);
  ;
  return;
}


function __ZN13z80ctc_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN13z80ctc_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13z80ctc_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI13z80ctc_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13z80ctc_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI13z80ctc_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI13z80ctc_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI13z80ctc_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI13z80ctc_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI13z80ctc_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI13z80ctc_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13z80ctc_deviceD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      var $6=(($5+356)|0);
      var $7=$6;
      (function() { try { __THREW__ = false; return __ZN25device_z80daisy_interfaceD2Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$4;
      __ZN8device_tD2Ev($9);
      ;
      return;
    case 2: // $10
      var $11=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $12=$11.f0;
      $2=$12;
      var $13=$11.f1;
      $3=$13;
      var $14=$4;
      (function() { try { __THREW__ = false; return __ZN8device_tD2Ev($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$2;
      var $19=$3;
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue);
      var $21=($20.f1 = $19, $20);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14devcb_resolver12resolve_portEPKcR8device_t($tag, $current) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $3;
      var $4;
      $1=$tag;
      $2=$current;
      var $5=$2;
      var $6=__ZNK8device_t7machineEv($5);
      var $7=$1;
      var $8=__ZN15running_machine4portEPKc($6, $7);
      $result=$8;
      var $9=$result;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=___cxa_allocate_exception(1032);
      var $13=$12;
      var $14=$1;
      var $15=$2;
      var $16=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; };
    case 2: // $17
      var $18=$2;
      var $19=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $20
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($13, ((STRING_TABLE.__str6157)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,HEAP32[((tempInt+4)>>2)]=$16,HEAP32[((tempInt+8)>>2)]=$19,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      ___cxa_throw($12, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $3=$24;
      var $25=$23.f1;
      $4=$25;
      ___cxa_free_exception($12);
      __label__ = 7; break;
    case 6: // $26
      var $27=$result;
      ;
      return $27;
    case 7: // $28
      var $29=$3;
      var $30=$3;
      var $31=$4;
      var $32=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $30, tempValue);
      var $33=($32.f1 = $31, $32);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN14devcb_resolver14resolve_deviceEiPKcR8device_t($index, $tag, $current) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $4;
      var $5;
      $1=$index;
      $2=$tag;
      $3=$current;
      $result=0;
      var $6=$1;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      $result=$9;
      __label__ = 9; break;
    case 2: // $10
      var $11=$1;
      var $12=(($11)|0)==1;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$3;
      var $15=__ZNK8device_t7machineEv($14);
      var $16=__ZNK15running_machine11driver_dataEv($15);
      var $17=$16;
      $result=$17;
      __label__ = 8; break;
    case 4: // $18
      var $19=$2;
      var $20=_strcmp($19, ((STRING_TABLE.__ZL17DEVICE_SELF_OWNER6158)|0));
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$3;
      var $24=__ZNK8device_t5ownerEv($23);
      $result=$24;
      __label__ = 7; break;
    case 6: // $25
      var $26=$3;
      var $27=$2;
      var $28=__ZNK8device_t13siblingdeviceEPKc($26, $27);
      $result=$28;
      __label__ = 7; break;
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      __label__ = 9; break;
    case 9: // $31
      var $32=$result;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $34
      var $35=___cxa_allocate_exception(1032);
      var $36=$35;
      var $37=$2;
      var $38=$3;
      var $39=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; };
    case 11: // $40
      var $41=$3;
      var $42=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; };
    case 12: // $43
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($36, ((STRING_TABLE.__str16159)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,HEAP32[((tempInt+4)>>2)]=$39,HEAP32[((tempInt+8)>>2)]=$42,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $44
      ___cxa_throw($35, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 14: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $4=$47;
      var $48=$46.f1;
      $5=$48;
      ___cxa_free_exception($35);
      __label__ = 16; break;
    case 15: // $49
      var $50=$result;
      ;
      return $50;
    case 16: // $51
      var $52=$4;
      var $53=$4;
      var $54=$5;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14devcb_resolver14resolve_deviceEiPKcR8device_t["X"]=1;

function __ZN14devcb_resolver25resolve_execute_interfaceEPKcR8device_t($tag, $current) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $targetdev;
      var $3;
      var $4;
      var $exec=__stackBase__;
      $1=$tag;
      $2=$current;
      var $5=$2;
      var $6=$1;
      var $7=__ZNK8device_t13siblingdeviceEPKc($5, $6);
      $targetdev=$7;
      var $8=$targetdev;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $10
      var $11=___cxa_allocate_exception(1032);
      var $12=$11;
      var $13=$1;
      var $14=$2;
      var $15=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; };
    case 2: // $16
      var $17=$2;
      var $18=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $19
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($12, ((STRING_TABLE.__str26160)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$13,HEAP32[((tempInt+4)>>2)]=$15,HEAP32[((tempInt+8)>>2)]=$18,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      ___cxa_throw($11, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      $3=$23;
      var $24=$22.f1;
      $4=$24;
      ___cxa_free_exception($11);
      __label__ = 13; break;
    case 6: // $25
      var $26=$targetdev;
      var $27=__ZN8device_t9interfaceERP24device_execute_interface($26, $exec);
      if ($27) { __label__ = 12; break; } else { __label__ = 7; break; }
    case 7: // $28
      var $29=___cxa_allocate_exception(1032);
      var $30=$29;
      var $31=$1;
      var $32=$2;
      var $33=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $34
      var $35=$2;
      var $36=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $37
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($30, ((STRING_TABLE.__str36161)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$31,HEAP32[((tempInt+4)>>2)]=$33,HEAP32[((tempInt+8)>>2)]=$36,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      ___cxa_throw($29, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 11: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $3=$41;
      var $42=$40.f1;
      $4=$42;
      ___cxa_free_exception($29);
      __label__ = 13; break;
    case 12: // $43
      var $44=HEAP32[(($exec)>>2)];
      STACKTOP = __stackBase__;
      return $44;
    case 13: // $45
      var $46=$3;
      var $47=$3;
      var $48=$4;
      var $49=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $47, tempValue);
      var $50=($49.f1 = $48, $49);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14devcb_resolver25resolve_execute_interfaceEPKcR8device_t["X"]=1;

function __ZN25devcb_resolved_write_line7to_nullEi($this, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$state;
  var $3=$1;
  ;
  return;
}


function __ZN21devcb_resolved_write87to_nullEjh($this, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$offset;
  $3=$data;
  var $4=$1;
  ;
  return;
}


function __ZN20devcb_resolved_read813from_constantEj($this, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$offset;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6) & 255);
  ;
  return $7;
}


function __ZN25devcb_resolved_write_lineC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8delegateIFviEEC2Ev($3);
  var $4=(($2+24)|0);
  var $5=(($2+28)|0);
  var $6=(($2+24)|0);
  var $7=$6;
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+28)|0);
  var $9=$8;
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFviEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvi8_noparamS0_S0_EC2Ev($3);
  ;
  return;
}


function __ZN25devcb_resolved_write_line7resolveERK16devcb_write_lineR8device_t($this, $desc, $device) {
  var __stackBase__  = STACKTOP; STACKTOP += 184; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+24;
      var $6=__stackBase__+32;
      var $7=__stackBase__+56;
      var $8=__stackBase__+64;
      var $9=__stackBase__+88;
      var $10=__stackBase__+112;
      var $11=__stackBase__+120;
      var $12=__stackBase__+144;
      var $13=__stackBase__+152;
      var $14=__stackBase__+176;
      $1=$this;
      $2=$desc;
      $3=$device;
      var $15=$1;
      var $16=$2;
      var $17=(($16)|0);
      var $18=HEAPU16[(($17)>>1)];
      var $19=(($18)&65535);
      if ($19 == 0) {
        __label__ = 2; break;
      }
      else if ($19 == 1) {
        __label__ = 3; break;
      }
      else if ($19 == 2) {
        __label__ = 4; break;
      }
      else if ($19 == 3) {
        __label__ = 8; break;
      }
      else if ($19 == 4) {
        __label__ = 9; break;
      }
      else {
      __label__ = 1; break;
      }
      
    case 1: // $20
      __label__ = 2; break;
    case 2: // $21
      var $22=(($15+28)|0);
      var $23=$22;
      HEAP32[(($23)>>2)]=__ZN25devcb_resolved_write_line6s_nullE;
      var $24=$15;
      HEAP32[(($5)>>2)]={ f0: 1418, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 1418, f1: 0 }.f1;
      __ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($4, $5, ((STRING_TABLE.__str66164)|0), $15);
      var $25=__ZN8delegateIFviEEaSERKS1_($24, $4);
      __label__ = 10; break;
    case 3: // $26
      var $27=$2;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$3;
      var $31=__ZN14devcb_resolver12resolve_portEPKcR8device_t($29, $30);
      var $32=(($15+24)|0);
      var $33=$32;
      HEAP32[(($33)>>2)]=$31;
      var $34=$15;
      var $35=$2;
      var $36=(($35+4)|0);
      var $37=HEAP32[(($36)>>2)];
      HEAP32[(($7)>>2)]={ f0: 1420, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 1420, f1: 0 }.f1;
      __ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($6, $7, $37, $15);
      var $38=__ZN8delegateIFviEEaSERKS1_($34, $6);
      __label__ = 10; break;
    case 4: // $39
      var $40=$2;
      var $41=(($40+2)|0);
      var $42=HEAPU16[(($41)>>1)];
      var $43=(($42)&65535);
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$3;
      var $48=__ZN14devcb_resolver14resolve_deviceEiPKcR8device_t($43, $46, $47);
      var $49=(($15+24)|0);
      var $50=$49;
      HEAP32[(($50)>>2)]=$48;
      var $51=$2;
      var $52=(($51+12)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      var $56=$15;
      var $57=$2;
      var $58=(($57+12)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$2;
      var $61=(($60+8)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($15+24)|0);
      var $64=$63;
      var $65=HEAP32[(($64)>>2)];
      __ZN8delegateIFviEEC1I8device_tEEN15delegate_traitsIT_vi8_noparamS6_S6_E16static_func_typeEPKcPS5_($8, $59, $62, $65);
      var $66=__ZN8delegateIFviEEaSERKS1_($56, $8);
      __label__ = 7; break;
    case 6: // $67
      var $68=$2;
      var $69=(($68+16)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($15+28)|0);
      var $72=$71;
      HEAP32[(($72)>>2)]=$70;
      var $73=$15;
      var $74=$2;
      var $75=(($74+8)|0);
      var $76=HEAP32[(($75)>>2)];
      HEAP32[(($10)>>2)]={ f0: 1422, f1: 0 }.f0; HEAP32[(($10+4)>>2)]={ f0: 1422, f1: 0 }.f1;
      __ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($9, $10, $76, $15);
      var $77=__ZN8delegateIFviEEaSERKS1_($73, $9);
      __label__ = 7; break;
    case 7: // $78
      __label__ = 10; break;
    case 8: // $79
      var $80=$2;
      var $81=(($80+2)|0);
      var $82=HEAPU16[(($81)>>1)];
      var $83=(($82)&65535);
      var $84=$2;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$3;
      var $88=__ZN14devcb_resolver13resolve_spaceEiPKcR8device_t($83, $86, $87);
      var $89=(($15+24)|0);
      var $90=$89;
      HEAP32[(($90)>>2)]=$88;
      var $91=$2;
      var $92=(($91+20)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($15+28)|0);
      var $95=$94;
      HEAP32[(($95)>>2)]=$93;
      var $96=$15;
      var $97=$2;
      var $98=(($97+8)|0);
      var $99=HEAP32[(($98)>>2)];
      HEAP32[(($12)>>2)]={ f0: 1422, f1: 0 }.f0; HEAP32[(($12+4)>>2)]={ f0: 1422, f1: 0 }.f1;
      __ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($11, $12, $99, $15);
      var $100=__ZN8delegateIFviEEaSERKS1_($96, $11);
      __label__ = 10; break;
    case 9: // $101
      var $102=$2;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$3;
      var $106=__ZN14devcb_resolver25resolve_execute_interfaceEPKcR8device_t($104, $105);
      var $107=(($15+24)|0);
      var $108=$107;
      HEAP32[(($108)>>2)]=$106;
      var $109=$2;
      var $110=(($109+2)|0);
      var $111=HEAPU16[(($110)>>1)];
      var $112=(($111)&65535);
      var $113=(($15+28)|0);
      var $114=$113;
      HEAP32[(($114)>>2)]=$112;
      var $115=$15;
      var $116=$2;
      var $117=(($116+4)|0);
      var $118=HEAP32[(($117)>>2)];
      HEAP32[(($14)>>2)]={ f0: 1424, f1: 0 }.f0; HEAP32[(($14+4)>>2)]={ f0: 1424, f1: 0 }.f1;
      __ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($13, $14, $118, $15);
      var $119=__ZN8delegateIFviEEaSERKS1_($115, $13);
      __label__ = 10; break;
    case 10: // $120
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN25devcb_resolved_write_line7resolveERK16devcb_write_lineR8device_t["X"]=1;

function __ZN8delegateIFviEEaSERKS1_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvi8_noparamS0_S0_EaSERKS1_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFviEEC2I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN25devcb_resolved_write_line7to_portEi($this, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=$2;
  __Z23input_port_write_directPK17input_port_configjj($6, $7, -1);
  ;
  return;
}


function __ZN8delegateIFviEEC1I8device_tEEN15delegate_traitsIT_vi8_noparamS6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFviEEC2I8device_tEEN15delegate_traitsIT_vi8_noparamS6_S6_E16static_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZN25devcb_resolved_write_line9to_write8Ei($this, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=(($3+28)|0);
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($3+24)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  var $11=(($10) & 255);
  FUNCTION_TABLE[$6]($9, 0, $11);
  ;
  return;
}


function __ZN25devcb_resolved_write_line8to_inputEi($this, $state) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$state;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($3+28)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=$2;
  __ZN24device_execute_interface14set_input_lineEii($6, $9, $10);
  ;
  return;
}


function __ZN20devcb_resolved_read8C2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8delegateIFhjEEC2Ev($3);
  var $4=(($2+24)|0);
  var $5=(($2+28)|0);
  var $6=(($2+24)|0);
  var $7=$6;
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+28)|0);
  var $9=$8;
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFhjEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIhj8_noparamS0_S0_EC2Ev($3);
  ;
  return;
}


function __ZN20devcb_resolved_read87resolveERK11devcb_read8R8device_t($this, $desc, $device) {
  var __stackBase__  = STACKTOP; STACKTOP += 176; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+24;
      var $6=__stackBase__+32;
      var $7=__stackBase__+56;
      var $8=__stackBase__+64;
      var $9=__stackBase__+88;
      var $10=__stackBase__+112;
      var $11=__stackBase__+120;
      var $12=__stackBase__+144;
      var $13=__stackBase__+168;
      $1=$this;
      $2=$desc;
      $3=$device;
      var $14=$1;
      var $15=$2;
      var $16=(($15)|0);
      var $17=HEAPU16[(($16)>>1)];
      var $18=(($17)&65535);
      if ($18 == 0) {
        __label__ = 2; break;
      }
      else if ($18 == 1) {
        __label__ = 3; break;
      }
      else if ($18 == 2) {
        __label__ = 4; break;
      }
      else if ($18 == 3) {
        __label__ = 8; break;
      }
      else if ($18 == 5) {
        __label__ = 9; break;
      }
      else {
      __label__ = 1; break;
      }
      
    case 1: // $19
      __label__ = 2; break;
    case 2: // $20
      var $21=(($14+24)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=0;
      var $23=(($14+28)|0);
      var $24=$23;
      HEAP32[(($24)>>2)]=__ZN20devcb_resolved_read86s_nullE;
      var $25=$14;
      HEAP32[(($5)>>2)]={ f0: 1426, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 1426, f1: 0 }.f1;
      __ZN8delegateIFhjEEC1I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($4, $5, ((STRING_TABLE.__str66164)|0), $14);
      var $26=__ZN8delegateIFhjEEaSERKS1_($25, $4);
      __label__ = 10; break;
    case 3: // $27
      var $28=$2;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$3;
      var $32=__ZN14devcb_resolver12resolve_portEPKcR8device_t($30, $31);
      var $33=(($14+24)|0);
      var $34=$33;
      HEAP32[(($34)>>2)]=$32;
      var $35=$14;
      var $36=$2;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      HEAP32[(($7)>>2)]={ f0: 1428, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 1428, f1: 0 }.f1;
      __ZN8delegateIFhjEEC1I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($6, $7, $38, $14);
      var $39=__ZN8delegateIFhjEEaSERKS1_($35, $6);
      __label__ = 10; break;
    case 4: // $40
      var $41=$2;
      var $42=(($41+2)|0);
      var $43=HEAPU16[(($42)>>1)];
      var $44=(($43)&65535);
      var $45=$2;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$3;
      var $49=__ZN14devcb_resolver14resolve_deviceEiPKcR8device_t($44, $47, $48);
      var $50=(($14+24)|0);
      var $51=$50;
      HEAP32[(($51)>>2)]=$49;
      var $52=$2;
      var $53=(($52+16)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $56
      var $57=$14;
      var $58=$2;
      var $59=(($58+16)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$2;
      var $62=(($61+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($14+24)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      __ZN8delegateIFhjEEC1I8device_tEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($8, $60, $63, $66);
      var $67=__ZN8delegateIFhjEEaSERKS1_($57, $8);
      __label__ = 7; break;
    case 6: // $68
      var $69=$2;
      var $70=(($69+12)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($14+28)|0);
      var $73=$72;
      HEAP32[(($73)>>2)]=$71;
      var $74=$14;
      var $75=$2;
      var $76=(($75+8)|0);
      var $77=HEAP32[(($76)>>2)];
      HEAP32[(($10)>>2)]={ f0: 1430, f1: 0 }.f0; HEAP32[(($10+4)>>2)]={ f0: 1430, f1: 0 }.f1;
      __ZN8delegateIFhjEEC1I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($9, $10, $77, $14);
      var $78=__ZN8delegateIFhjEEaSERKS1_($74, $9);
      __label__ = 7; break;
    case 7: // $79
      __label__ = 10; break;
    case 8: // $80
      var $81=$2;
      var $82=(($81+2)|0);
      var $83=HEAPU16[(($82)>>1)];
      var $84=(($83)&65535);
      var $85=$2;
      var $86=(($85+4)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$3;
      var $89=__ZN14devcb_resolver13resolve_spaceEiPKcR8device_t($84, $87, $88);
      var $90=(($14+24)|0);
      var $91=$90;
      HEAP32[(($91)>>2)]=$89;
      var $92=$14;
      var $93=$2;
      var $94=(($93+20)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      var $97=(($96+8)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($14+24)|0);
      var $100=$99;
      var $101=HEAP32[(($100)>>2)];
      __ZN8delegateIFhjEEC1I13address_spaceEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($11, $95, $98, $101);
      var $102=__ZN8delegateIFhjEEaSERKS1_($92, $11);
      __label__ = 10; break;
    case 9: // $103
      var $104=$2;
      var $105=(($104+2)|0);
      var $106=HEAPU16[(($105)>>1)];
      var $107=(($106)&65535);
      var $108=(($14+24)|0);
      var $109=$108;
      HEAP32[(($109)>>2)]=$107;
      var $110=$14;
      HEAP32[(($13)>>2)]={ f0: 1426, f1: 0 }.f0; HEAP32[(($13+4)>>2)]={ f0: 1426, f1: 0 }.f1;
      __ZN8delegateIFhjEEC1I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($12, $13, ((STRING_TABLE.__str76165)|0), $14);
      var $111=__ZN8delegateIFhjEEaSERKS1_($110, $12);
      __label__ = 10; break;
    case 10: // $112
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20devcb_resolved_read87resolveERK11devcb_read8R8device_t["X"]=1;

function __ZN8delegateIFhjEEaSERKS1_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIhj8_noparamS0_S0_EaSERKS1_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFhjEEC1I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFhjEEC2I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN20devcb_resolved_read89from_portEj($this, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$offset;
  var $3=$1;
  var $4=(($3+24)|0);
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=__Z22input_port_read_directPK17input_port_config($6);
  var $8=(($7) & 255);
  ;
  return $8;
}


function __ZN8delegateIFhjEEC1I8device_tEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFhjEEC2I8device_tEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZN20devcb_resolved_read813from_readlineEj($this, $offset) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$offset;
  var $3=$1;
  var $4=(($3+28)|0);
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($3+24)|0);
  var $8=$7;
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$6]($9);
  var $11=(($10) & 255);
  ;
  return $11;
}


function __ZN8delegateIFhjEEC1I13address_spaceEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFhjEEC2I13address_spaceEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZN21devcb_resolved_write8C2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN8delegateIFvjhEEC2Ev($3);
  var $4=(($2+24)|0);
  var $5=(($2+28)|0);
  var $6=(($2+24)|0);
  var $7=$6;
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+28)|0);
  var $9=$8;
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZN8delegateIFvjhEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN13delegate_baseIvjh8_noparamS0_EC2Ev($3);
  ;
  return;
}


function __ZN21devcb_resolved_write87resolveERK12devcb_write8R8device_t($this, $desc, $device) {
  var __stackBase__  = STACKTOP; STACKTOP += 176; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5=__stackBase__+24;
      var $6=__stackBase__+32;
      var $7=__stackBase__+56;
      var $8=__stackBase__+64;
      var $9=__stackBase__+88;
      var $10=__stackBase__+112;
      var $11=__stackBase__+120;
      var $12=__stackBase__+144;
      var $13=__stackBase__+168;
      $1=$this;
      $2=$desc;
      $3=$device;
      var $14=$1;
      var $15=$2;
      var $16=(($15)|0);
      var $17=HEAPU16[(($16)>>1)];
      var $18=(($17)&65535);
      if ($18 == 0) {
        __label__ = 2; break;
      }
      else if ($18 == 1) {
        __label__ = 3; break;
      }
      else if ($18 == 2) {
        __label__ = 4; break;
      }
      else if ($18 == 3) {
        __label__ = 8; break;
      }
      else if ($18 == 4) {
        __label__ = 9; break;
      }
      else {
      __label__ = 1; break;
      }
      
    case 1: // $19
      __label__ = 2; break;
    case 2: // $20
      var $21=(($14+28)|0);
      var $22=$21;
      HEAP32[(($22)>>2)]=__ZN21devcb_resolved_write86s_nullE;
      var $23=$14;
      HEAP32[(($5)>>2)]={ f0: 1432, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 1432, f1: 0 }.f1;
      __ZN8delegateIFvjhEEC1I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($4, $5, ((STRING_TABLE.__str66164)|0), $14);
      var $24=__ZN8delegateIFvjhEEaSERKS1_($23, $4);
      __label__ = 10; break;
    case 3: // $25
      var $26=$2;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=__ZN14devcb_resolver12resolve_portEPKcR8device_t($28, $29);
      var $31=(($14+24)|0);
      var $32=$31;
      HEAP32[(($32)>>2)]=$30;
      var $33=$14;
      var $34=$2;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      HEAP32[(($7)>>2)]={ f0: 1434, f1: 0 }.f0; HEAP32[(($7+4)>>2)]={ f0: 1434, f1: 0 }.f1;
      __ZN8delegateIFvjhEEC1I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($6, $7, $36, $14);
      var $37=__ZN8delegateIFvjhEEaSERKS1_($33, $6);
      __label__ = 10; break;
    case 4: // $38
      var $39=$2;
      var $40=(($39+2)|0);
      var $41=HEAPU16[(($40)>>1)];
      var $42=(($41)&65535);
      var $43=$2;
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$3;
      var $47=__ZN14devcb_resolver14resolve_deviceEiPKcR8device_t($42, $45, $46);
      var $48=(($14+24)|0);
      var $49=$48;
      HEAP32[(($49)>>2)]=$47;
      var $50=$2;
      var $51=(($50+16)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $54
      var $55=$14;
      var $56=$2;
      var $57=(($56+16)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$2;
      var $60=(($59+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($14+24)|0);
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      __ZN8delegateIFvjhEEC1I8device_tEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($8, $58, $61, $64);
      var $65=__ZN8delegateIFvjhEEaSERKS1_($55, $8);
      __label__ = 7; break;
    case 6: // $66
      var $67=$2;
      var $68=(($67+12)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($14+28)|0);
      var $71=$70;
      HEAP32[(($71)>>2)]=$69;
      var $72=$14;
      var $73=$2;
      var $74=(($73+8)|0);
      var $75=HEAP32[(($74)>>2)];
      HEAP32[(($10)>>2)]={ f0: 1436, f1: 0 }.f0; HEAP32[(($10+4)>>2)]={ f0: 1436, f1: 0 }.f1;
      __ZN8delegateIFvjhEEC1I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($9, $10, $75, $14);
      var $76=__ZN8delegateIFvjhEEaSERKS1_($72, $9);
      __label__ = 7; break;
    case 7: // $77
      __label__ = 10; break;
    case 8: // $78
      var $79=$2;
      var $80=(($79+2)|0);
      var $81=HEAPU16[(($80)>>1)];
      var $82=(($81)&65535);
      var $83=$2;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$3;
      var $87=__ZN14devcb_resolver13resolve_spaceEiPKcR8device_t($82, $85, $86);
      var $88=(($14+24)|0);
      var $89=$88;
      HEAP32[(($89)>>2)]=$87;
      var $90=$14;
      var $91=$2;
      var $92=(($91+20)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$2;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($14+24)|0);
      var $98=$97;
      var $99=HEAP32[(($98)>>2)];
      __ZN8delegateIFvjhEEC1I13address_spaceEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($11, $93, $96, $99);
      var $100=__ZN8delegateIFvjhEEaSERKS1_($90, $11);
      __label__ = 10; break;
    case 9: // $101
      var $102=$2;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$3;
      var $106=__ZN14devcb_resolver25resolve_execute_interfaceEPKcR8device_t($104, $105);
      var $107=(($14+24)|0);
      var $108=$107;
      HEAP32[(($108)>>2)]=$106;
      var $109=$2;
      var $110=(($109+2)|0);
      var $111=HEAPU16[(($110)>>1)];
      var $112=(($111)&65535);
      var $113=(($14+28)|0);
      var $114=$113;
      HEAP32[(($114)>>2)]=$112;
      var $115=$14;
      var $116=$2;
      var $117=(($116+4)|0);
      var $118=HEAP32[(($117)>>2)];
      HEAP32[(($13)>>2)]={ f0: 1438, f1: 0 }.f0; HEAP32[(($13+4)>>2)]={ f0: 1438, f1: 0 }.f1;
      __ZN8delegateIFvjhEEC1I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($12, $13, $118, $14);
      var $119=__ZN8delegateIFvjhEEaSERKS1_($115, $12);
      __label__ = 10; break;
    case 10: // $120
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN21devcb_resolved_write87resolveERK12devcb_write8R8device_t["X"]=1;

function __ZN8delegateIFvjhEEaSERKS1_($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  var $5=$4;
  var $6=$3;
  var $7=$6;
  var $8=__ZN13delegate_baseIvjh8_noparamS0_EaSERKS1_($5, $7);
  ;
  return $4;
}


function __ZN8delegateIFvjhEEC1I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $9=$4;
  var $10=$5;
  HEAP32[(($6)>>2)]=$8.f0; HEAP32[(($6+4)>>2)]=$8.f1;
  __ZN8delegateIFvjhEEC2I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($7, $6, $9, $10);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21devcb_resolved_write87to_portEjh($this, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=(($4+24)|0);
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=$3;
  var $9=(($8)&255);
  __Z23input_port_write_directPK17input_port_configjj($7, $9, 255);
  ;
  return;
}


function __ZN8delegateIFvjhEEC1I8device_tEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvjhEEC2I8device_tEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZN14devcb_resolver13resolve_spaceEiPKcR8device_t($index, $tag, $current) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $targetdev;
      var $4;
      var $5;
      var $memory=__stackBase__;
      var $result;
      $1=$index;
      $2=$tag;
      $3=$current;
      var $6=$3;
      var $7=$2;
      var $8=__ZNK8device_t13siblingdeviceEPKc($6, $7);
      $targetdev=$8;
      var $9=$targetdev;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=___cxa_allocate_exception(1032);
      var $13=$12;
      var $14=$2;
      var $15=$3;
      var $16=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; };
    case 2: // $17
      var $18=$3;
      var $19=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $20
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($13, ((STRING_TABLE.__str26160)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$14,HEAP32[((tempInt+4)>>2)]=$16,HEAP32[((tempInt+8)>>2)]=$19,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      ___cxa_throw($12, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 5: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $4=$24;
      var $25=$23.f1;
      $5=$25;
      ___cxa_free_exception($12);
      __label__ = 19; break;
    case 6: // $26
      var $27=$targetdev;
      var $28=__ZN8device_t9interfaceERP23device_memory_interface($27, $memory);
      if ($28) { __label__ = 12; break; } else { __label__ = 7; break; }
    case 7: // $29
      var $30=___cxa_allocate_exception(1032);
      var $31=$30;
      var $32=$2;
      var $33=$3;
      var $34=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 11; break; };
    case 8: // $35
      var $36=$3;
      var $37=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $38
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($31, ((STRING_TABLE.__str46162)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,HEAP32[((tempInt+4)>>2)]=$34,HEAP32[((tempInt+8)>>2)]=$37,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $39
      ___cxa_throw($30, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 11: // $40
      var $41=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $42=$41.f0;
      $4=$42;
      var $43=$41.f1;
      $5=$43;
      ___cxa_free_exception($30);
      __label__ = 19; break;
    case 12: // $44
      var $45=HEAP32[(($memory)>>2)];
      var $46=$1;
      var $47=__ZNK23device_memory_interface5spaceEi($45, $46);
      $result=$47;
      var $48=$result;
      var $49=(($48)|0)==0;
      if ($49) { __label__ = 13; break; } else { __label__ = 18; break; }
    case 13: // $50
      var $51=___cxa_allocate_exception(1032);
      var $52=$51;
      var $53=$2;
      var $54=$1;
      var $55=$3;
      var $56=(function() { try { __THREW__ = false; return __ZNK8device_t4nameEv($55) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 17; break; };
    case 14: // $57
      var $58=$3;
      var $59=(function() { try { __THREW__ = false; return __ZNK8device_t3tagEv($58) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 17; break; };
    case 15: // $60
      (function() { try { __THREW__ = false; return __ZN14emu_fatalerrorC1EPKcz($52, ((STRING_TABLE.__str56163)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,HEAP32[((tempInt+4)>>2)]=$54,HEAP32[((tempInt+8)>>2)]=$56,HEAP32[((tempInt+12)>>2)]=$59,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $61
      ___cxa_throw($51, __ZTI14emu_fatalerror, 16);
      throw "Reached an unreachable!"
    case 17: // $62
      var $63=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $64=$63.f0;
      $4=$64;
      var $65=$63.f1;
      $5=$65;
      ___cxa_free_exception($51);
      __label__ = 19; break;
    case 18: // $66
      var $67=$result;
      STACKTOP = __stackBase__;
      return $67;
    case 19: // $68
      var $69=$4;
      var $70=$4;
      var $71=$5;
      var $72=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $70, tempValue);
      var $73=($72.f1 = $71, $72);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14devcb_resolver13resolve_spaceEiPKcR8device_t["X"]=1;

function __ZN21delegate_internal_mfpC2IM21devcb_resolved_write8FvjhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM20devcb_resolved_read8FhjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21delegate_internal_mfpC2IM25devcb_resolved_write_lineFviEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3=__stackBase__;
      $2=$this;
      var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
      HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
      var $4=$2;
      __label__ = 1; break;
    case 1: // $5
      __label__ = 2; break;
    case 2: // $6
      var $7={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $8=$4;
      HEAP32[(($8)>>2)]=$7.f0; HEAP32[(($8+4)>>2)]=$7.f1;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN21devcb_resolved_write812to_writelineEjh($this, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=(($4+28)|0);
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($4+24)|0);
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=$3;
  var $12=(($11)&255);
  var $13=$12 & 1;
  var $14=(($13)|0)!=0;
  var $15=$14 ? 1 : 0;
  FUNCTION_TABLE[$7]($10, $15);
  ;
  return;
}


function __ZN8delegateIFvjhEEC1I13address_spaceEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvjhEEC2I13address_spaceEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZN21devcb_resolved_write88to_inputEjh($this, $offset, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$offset;
  $3=$data;
  var $4=$1;
  var $5=(($4+24)|0);
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($4+28)|0);
  var $9=$8;
  var $10=HEAP32[(($9)>>2)];
  var $11=$3;
  var $12=(($11)&255);
  var $13=$12 & 1;
  var $14=(($13)|0)!=0;
  var $15=$14 ? 1 : 0;
  __ZN24device_execute_interface14set_input_lineEii($7, $10, $15);
  ;
  return;
}


function __ZN8delegateIFvjhEEC2I13address_spaceEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIvjh8_noparamS0_EC2I13address_spaceEEN15delegate_traitsIT_vjhS0_S0_E16static_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_EC2I13address_spaceEEN15delegate_traitsIT_vjhS0_S0_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1440;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIvjh8_noparamS0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI13address_spaceEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13address_space, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvjh8_noparamS0_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvjhEEC2I8device_tEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIvjh8_noparamS0_EC2I8device_tEEN15delegate_traitsIT_vjhS0_S0_E16static_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_EC2I8device_tEEN15delegate_traitsIT_vjhS0_S0_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1442;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIvjh8_noparamS0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI8device_t, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFvjhEEC2I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvjh8_noparamS0_EC2I21devcb_resolved_write8EEN15delegate_traitsIT_vjhS0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_EC2I21devcb_resolved_write8EEN15delegate_traitsIT_vjhS0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM21devcb_resolved_write8FvjhEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=1444;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvjh8_noparamS0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM21devcb_resolved_write8FvjhEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM21devcb_resolved_write8FvjhEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI21devcb_resolved_write8EEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI21devcb_resolved_write8, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhjEEC2I13address_spaceEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIhj8_noparamS0_S0_EC2I13address_spaceEEN15delegate_traitsIT_hjS0_S0_S0_E16static_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_EC2I13address_spaceEEN15delegate_traitsIT_hjS0_S0_S0_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1446;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIhj8_noparamS0_S0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI13address_spaceEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13address_space, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIhj8_noparamS0_S0_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhjEEC2I8device_tEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIhj8_noparamS0_S0_EC2I8device_tEEN15delegate_traitsIT_hjS0_S0_S0_E16static_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_EC2I8device_tEEN15delegate_traitsIT_hjS0_S0_S0_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1448;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIhj8_noparamS0_S0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI8device_t, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFhjEEC2I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIhj8_noparamS0_S0_EC2I20devcb_resolved_read8EEN15delegate_traitsIT_hjS0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_EC2I20devcb_resolved_read8EEN15delegate_traitsIT_hjS0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM20devcb_resolved_read8FhjEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=1450;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIhj8_noparamS0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM20devcb_resolved_read8FhjEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM20devcb_resolved_read8FhjEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI20devcb_resolved_read8EEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI20devcb_resolved_read8, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFviEEC2I8device_tEEN15delegate_traitsIT_vi8_noparamS6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIvi8_noparamS0_S0_EC2I8device_tEEN15delegate_traitsIT_viS0_S0_S0_E16static_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIvi8_noparamS0_S0_EC2I8device_tEEN15delegate_traitsIT_viS0_S0_S0_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1452;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIvi8_noparamS0_S0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIvi8_noparamS0_S0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI8device_t, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvi8_noparamS0_S0_E4bindEP22delegate_generic_class($this, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$object;
      var $3=$1;
      var $4=$2;
      var $5=(($3+4)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=(($3+12)|0);
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=(($3+12)|0);
      var $16=(($3+4)|0);
      var $17=__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class($15, $16);
      var $18=$17;
      var $19=(($3+8)|0);
      HEAP32[(($19)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8delegateIFviEEC2I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=$7;
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  var $10=$4;
  var $11=$5;
  HEAP32[(($6)>>2)]=$9.f0; HEAP32[(($6+4)>>2)]=$9.f1;
  __ZN13delegate_baseIvi8_noparamS0_S0_EC2I25devcb_resolved_write_lineEEN15delegate_traitsIT_viS0_S0_S0_E16member_func_typeEPKcPS5_($8, $6, $10, $11);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvi8_noparamS0_S0_EC2I25devcb_resolved_write_lineEEN15delegate_traitsIT_viS0_S0_S0_E16member_func_typeEPKcPS5_($this, $0, $name, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  var $5;
  var $6=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  $4=$name;
  $5=$object;
  var $7=$2;
  var $8=(($7)|0);
  var $9=$4;
  HEAP32[(($8)>>2)]=$9;
  var $10=(($7+4)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=(($7+8)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=(($7+12)|0);
  var $13={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($6)>>2)]=$13.f0; HEAP32[(($6+4)>>2)]=$13.f1;
  __ZN21delegate_internal_mfpC1IM25devcb_resolved_write_lineFviEEET_($12, $6);
  var $14=(($7+20)|0);
  HEAP32[(($14)>>2)]=1454;
  var $15=$5;
  var $16=$15;
  __ZN13delegate_baseIvi8_noparamS0_S0_E4bindEP22delegate_generic_class($7, $16);
  STACKTOP = __stackBase__;
  return;
}


function __ZN21delegate_internal_mfpC1IM25devcb_resolved_write_lineFviEEET_($this, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+8;
  $2=$this;
  var $funcptr={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$funcptr.f0; HEAP32[(($3+4)>>2)]=$funcptr.f1;
  var $5=$2;
  var $6={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($4)>>2)]=$6.f0; HEAP32[(($4+4)>>2)]=$6.f1;
  __ZN21delegate_internal_mfpC2IM25devcb_resolved_write_lineFviEEET_($5, $4);
  STACKTOP = __stackBase__;
  return;
}


function __ZN13delegate_baseIvi8_noparamS0_S0_E16late_bind_helperI25devcb_resolved_write_lineEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI25devcb_resolved_write_line, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvjh8_noparamS0_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN13delegate_baseIhj8_noparamS0_S0_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN13delegate_baseIvi8_noparamS0_S0_EC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=(($2+4)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  __ZN21delegate_internal_mfpC1Ev($6);
  var $7=(($2+20)|0);
  HEAP32[(($7)>>2)]=0;
  ;
  return;
}


function __ZN13delegate_baseIvjh8_noparamS0_EaSERKS1_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIhj8_noparamS0_S0_EaSERKS1_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN13delegate_baseIvi8_noparamS0_S0_EaSERKS1_($this, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$src;
      var $3=$1;
      var $4=$2;
      var $5=(($3)|0)!=(($4)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($3)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($3+4)|0);
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($3+8)|0);
      HEAP32[(($18)>>2)]=$17;
      var $19=(($3+12)|0);
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=__ZN21delegate_internal_mfpaSERKS_($19, $21);
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+20)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 2; break;
    case 2: // $27
      ;
      return $3;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL4signa($offset) {
  ;
  var __label__;

  var $1;
  $1=$offset;
  var $2=$1;
  var $3=(($2 << 24) >> 24);
  var $4=(($3)|0) < 0;
  var $5=$4 ? 45 : 43;
  ;
  return $5;
}


function __ZL4offsa($offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$offset;
      var $3=$2;
      var $4=(($3 << 24) >> 24);
      var $5=(($4)|0) < 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7 << 24) >> 24);
      var $9=(((-$8))|0);
      $1=$9;
      __label__ = 3; break;
    case 2: // $10
      var $11=$2;
      var $12=(($11 << 24) >> 24);
      $1=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19cpu_disassemble_z80P17legacy_cpu_devicePcjPKhS3_i($device, $buffer, $pc, $oprom, $opram, $options) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $d;
      var $src;
      var $ixy;
      var $dst;
      var $offset;
      var $op;
      var $op1;
      var $ea;
      var $pos;
      $1=$device;
      $2=$buffer;
      $3=$pc;
      $4=$oprom;
      $5=$opram;
      $6=$options;
      $offset=0;
      $op1=0;
      $ea=0;
      $pos=0;
      $ixy=((STRING_TABLE.__str6180)|0);
      var $7=$2;
      $dst=$7;
      var $8=$pos;
      var $9=(($8+1)|0);
      $pos=$9;
      var $10=$4;
      var $11=(($10+$8)|0);
      var $12=HEAP8[($11)];
      $op=$12;
      var $13=$op;
      var $14=(($13)&255);
      if ($14 == 203) {
        __label__ = 1; break;
      }
      else if ($14 == 237) {
        __label__ = 2; break;
      }
      else if ($14 == 221) {
        __label__ = 3; break;
      }
      else if ($14 == 253) {
        __label__ = 7; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 1: // $15
      var $16=$pos;
      var $17=(($16+1)|0);
      $pos=$17;
      var $18=$4;
      var $19=(($18+$16)|0);
      var $20=HEAP8[($19)];
      $op=$20;
      var $21=$op;
      var $22=(($21)&255);
      var $23=((__ZL11mnemonic_cb+($22<<3))|0);
      $d=$23;
      __label__ = 12; break;
    case 2: // $24
      var $25=$pos;
      var $26=(($25+1)|0);
      $pos=$26;
      var $27=$4;
      var $28=(($27+$25)|0);
      var $29=HEAP8[($28)];
      $op1=$29;
      var $30=$op1;
      var $31=(($30)&255);
      var $32=((__ZL11mnemonic_ed+($31<<3))|0);
      $d=$32;
      __label__ = 12; break;
    case 3: // $33
      $ixy=((STRING_TABLE.__str16181)|0);
      var $34=$pos;
      var $35=(($34+1)|0);
      $pos=$35;
      var $36=$4;
      var $37=(($36+$34)|0);
      var $38=HEAP8[($37)];
      $op1=$38;
      var $39=$op1;
      var $40=(($39)&255);
      var $41=(($40)|0)==203;
      if ($41) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $42
      var $43=$pos;
      var $44=(($43+1)|0);
      $pos=$44;
      var $45=$5;
      var $46=(($45+$43)|0);
      var $47=HEAP8[($46)];
      $offset=$47;
      var $48=$pos;
      var $49=(($48+1)|0);
      $pos=$49;
      var $50=$5;
      var $51=(($50+$48)|0);
      var $52=HEAP8[($51)];
      $op1=$52;
      var $53=$op1;
      var $54=(($53)&255);
      var $55=((__ZL14mnemonic_xx_cb+($54<<3))|0);
      $d=$55;
      __label__ = 6; break;
    case 5: // $56
      var $57=$op1;
      var $58=(($57)&255);
      var $59=((__ZL11mnemonic_xx+($58<<3))|0);
      $d=$59;
      __label__ = 6; break;
    case 6: // $60
      __label__ = 12; break;
    case 7: // $61
      $ixy=((STRING_TABLE.__str26182)|0);
      var $62=$pos;
      var $63=(($62+1)|0);
      $pos=$63;
      var $64=$4;
      var $65=(($64+$62)|0);
      var $66=HEAP8[($65)];
      $op1=$66;
      var $67=$op1;
      var $68=(($67)&255);
      var $69=(($68)|0)==203;
      if ($69) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $70
      var $71=$pos;
      var $72=(($71+1)|0);
      $pos=$72;
      var $73=$5;
      var $74=(($73+$71)|0);
      var $75=HEAP8[($74)];
      $offset=$75;
      var $76=$pos;
      var $77=(($76+1)|0);
      $pos=$77;
      var $78=$5;
      var $79=(($78+$76)|0);
      var $80=HEAP8[($79)];
      $op1=$80;
      var $81=$op1;
      var $82=(($81)&255);
      var $83=((__ZL14mnemonic_xx_cb+($82<<3))|0);
      $d=$83;
      __label__ = 10; break;
    case 9: // $84
      var $85=$op1;
      var $86=(($85)&255);
      var $87=((__ZL11mnemonic_xx+($86<<3))|0);
      $d=$87;
      __label__ = 10; break;
    case 10: // $88
      __label__ = 12; break;
    case 11: // $89
      var $90=$op;
      var $91=(($90)&255);
      var $92=((__ZL13mnemonic_main+($91<<3))|0);
      $d=$92;
      __label__ = 12; break;
    case 12: // $93
      var $94=$d;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 13; break; } else { __label__ = 30; break; }
    case 13: // $98
      var $99=$dst;
      var $100=$d;
      var $101=(($100)|0);
      var $102=HEAPU8[($101)];
      var $103=(($102)&255);
      var $104=((__ZL10s_mnemonic+($103<<2))|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=_sprintf($99, ((STRING_TABLE.__str36183)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$105,tempInt));
      var $107=$dst;
      var $108=(($107+$106)|0);
      $dst=$108;
      var $109=$d;
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      $src=$111;
      __label__ = 14; break;
    case 14: // $112
      var $113=$src;
      var $114=HEAP8[($113)];
      var $115=(($114 << 24) >> 24)!=0;
      if ($115) { __label__ = 15; break; } else { __label__ = 29; break; }
    case 15: // $116
      var $117=$src;
      var $118=HEAP8[($117)];
      var $119=(($118 << 24) >> 24);
      if ($119 == 63) {
        __label__ = 16; break;
      }
      else if ($119 == 65) {
        __label__ = 17; break;
      }
      else if ($119 == 66) {
        __label__ = 18; break;
      }
      else if ($119 == 78) {
        __label__ = 19; break;
      }
      else if ($119 == 79) {
        __label__ = 20; break;
      }
      else if ($119 == 80) {
        __label__ = 21; break;
      }
      else if ($119 == 86) {
        __label__ = 22; break;
      }
      else if ($119 == 87) {
        __label__ = 23; break;
      }
      else if ($119 == 88) {
        __label__ = 24; break;
      }
      else if ($119 == 89) {
        __label__ = 25; break;
      }
      else if ($119 == 73) {
        __label__ = 26; break;
      }
      else {
      __label__ = 27; break;
      }
      
    case 16: // $120
      var $121=$dst;
      var $122=$op;
      var $123=(($122)&255);
      var $124=$op1;
      var $125=(($124)&255);
      var $126=_sprintf($121, ((STRING_TABLE.__str46184)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$123,HEAP32[((tempInt+4)>>2)]=$125,tempInt));
      var $127=$dst;
      var $128=(($127+$126)|0);
      $dst=$128;
      __label__ = 28; break;
    case 17: // $129
      var $130=$pos;
      var $131=(($130)|0);
      var $132=$5;
      var $133=(($132+$131)|0);
      var $134=HEAPU8[($133)];
      var $135=(($134)&255);
      var $136=$pos;
      var $137=(($136+1)|0);
      var $138=$5;
      var $139=(($138+$137)|0);
      var $140=HEAPU8[($139)];
      var $141=(($140)&255);
      var $142=$141 << 8;
      var $143=(($135+$142)|0);
      var $144=(($143) & 65535);
      $ea=$144;
      var $145=$pos;
      var $146=(($145+2)|0);
      $pos=$146;
      var $147=$dst;
      var $148=$ea;
      var $149=(($148)&65535);
      var $150=_sprintf($147, ((STRING_TABLE.__str56185)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,tempInt));
      var $151=$dst;
      var $152=(($151+$150)|0);
      $dst=$152;
      __label__ = 28; break;
    case 18: // $153
      var $154=$pos;
      var $155=(($154+1)|0);
      $pos=$155;
      var $156=$5;
      var $157=(($156+$154)|0);
      var $158=HEAPU8[($157)];
      var $159=(($158)&255);
      $ea=$159;
      var $160=$dst;
      var $161=$ea;
      var $162=(($161)&65535);
      var $163=_sprintf($160, ((STRING_TABLE.__str66186)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$162,tempInt));
      var $164=$dst;
      var $165=(($164+$163)|0);
      $dst=$165;
      __label__ = 28; break;
    case 19: // $166
      var $167=$pos;
      var $168=(($167)|0);
      var $169=$5;
      var $170=(($169+$168)|0);
      var $171=HEAPU8[($170)];
      var $172=(($171)&255);
      var $173=$pos;
      var $174=(($173+1)|0);
      var $175=$5;
      var $176=(($175+$174)|0);
      var $177=HEAPU8[($176)];
      var $178=(($177)&255);
      var $179=$178 << 8;
      var $180=(($172+$179)|0);
      var $181=(($180) & 65535);
      $ea=$181;
      var $182=$pos;
      var $183=(($182+2)|0);
      $pos=$183;
      var $184=$dst;
      var $185=$ea;
      var $186=(($185)&65535);
      var $187=_sprintf($184, ((STRING_TABLE.__str56185)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$186,tempInt));
      var $188=$dst;
      var $189=(($188+$187)|0);
      $dst=$189;
      __label__ = 28; break;
    case 20: // $190
      var $191=$pos;
      var $192=(($191+1)|0);
      $pos=$192;
      var $193=$5;
      var $194=(($193+$191)|0);
      var $195=HEAP8[($194)];
      $offset=$195;
      var $196=$dst;
      var $197=$3;
      var $198=$offset;
      var $199=(($198 << 24) >> 24);
      var $200=(($197+$199)|0);
      var $201=(($200+2)|0);
      var $202=$201 & 65535;
      var $203=_sprintf($196, ((STRING_TABLE.__str56185)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$202,tempInt));
      var $204=$dst;
      var $205=(($204+$203)|0);
      $dst=$205;
      __label__ = 28; break;
    case 21: // $206
      var $207=$pos;
      var $208=(($207+1)|0);
      $pos=$208;
      var $209=$5;
      var $210=(($209+$207)|0);
      var $211=HEAPU8[($210)];
      var $212=(($211)&255);
      $ea=$212;
      var $213=$dst;
      var $214=$ea;
      var $215=(($214)&65535);
      var $216=_sprintf($213, ((STRING_TABLE.__str66186)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$215,tempInt));
      var $217=$dst;
      var $218=(($217+$216)|0);
      $dst=$218;
      __label__ = 28; break;
    case 22: // $219
      var $220=$op;
      var $221=(($220)&255);
      var $222=$221 & 56;
      var $223=(($222) & 65535);
      $ea=$223;
      var $224=$dst;
      var $225=$ea;
      var $226=(($225)&65535);
      var $227=_sprintf($224, ((STRING_TABLE.__str66186)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$226,tempInt));
      var $228=$dst;
      var $229=(($228+$227)|0);
      $dst=$229;
      __label__ = 28; break;
    case 23: // $230
      var $231=$pos;
      var $232=(($231)|0);
      var $233=$5;
      var $234=(($233+$232)|0);
      var $235=HEAPU8[($234)];
      var $236=(($235)&255);
      var $237=$pos;
      var $238=(($237+1)|0);
      var $239=$5;
      var $240=(($239+$238)|0);
      var $241=HEAPU8[($240)];
      var $242=(($241)&255);
      var $243=$242 << 8;
      var $244=(($236+$243)|0);
      var $245=(($244) & 65535);
      $ea=$245;
      var $246=$pos;
      var $247=(($246+2)|0);
      $pos=$247;
      var $248=$dst;
      var $249=$ea;
      var $250=(($249)&65535);
      var $251=_sprintf($248, ((STRING_TABLE.__str56185)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$250,tempInt));
      var $252=$dst;
      var $253=(($252+$251)|0);
      $dst=$253;
      __label__ = 28; break;
    case 24: // $254
      var $255=$pos;
      var $256=(($255+1)|0);
      $pos=$256;
      var $257=$5;
      var $258=(($257+$255)|0);
      var $259=HEAP8[($258)];
      $offset=$259;
      __label__ = 25; break;
    case 25: // $260
      var $261=$dst;
      var $262=$ixy;
      var $263=$offset;
      var $264=__ZL4signa($263);
      var $265=(($264 << 24) >> 24);
      var $266=$offset;
      var $267=__ZL4offsa($266);
      var $268=_sprintf($261, ((STRING_TABLE.__str76187)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$262,HEAP32[((tempInt+4)>>2)]=$265,HEAP32[((tempInt+8)>>2)]=$267,tempInt));
      var $269=$dst;
      var $270=(($269+$268)|0);
      $dst=$270;
      __label__ = 28; break;
    case 26: // $271
      var $272=$dst;
      var $273=$ixy;
      var $274=_sprintf($272, ((STRING_TABLE.__str86188)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$273,tempInt));
      var $275=$dst;
      var $276=(($275+$274)|0);
      $dst=$276;
      __label__ = 28; break;
    case 27: // $277
      var $278=$src;
      var $279=HEAP8[($278)];
      var $280=$dst;
      var $281=(($280+1)|0);
      $dst=$281;
      HEAP8[($280)]=$279;
      __label__ = 28; break;
    case 28: // $282
      var $283=$src;
      var $284=(($283+1)|0);
      $src=$284;
      __label__ = 14; break;
    case 29: // $285
      var $286=$dst;
      HEAP8[($286)]=0;
      __label__ = 31; break;
    case 30: // $287
      var $288=$dst;
      var $289=$d;
      var $290=(($289)|0);
      var $291=HEAPU8[($290)];
      var $292=(($291)&255);
      var $293=((__ZL10s_mnemonic+($292<<2))|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=_sprintf($288, ((STRING_TABLE.__str86188)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$294,tempInt));
      var $296=$dst;
      var $297=(($296+$295)|0);
      $dst=$297;
      __label__ = 31; break;
    case 31: // $298
      var $299=$pos;
      var $300=$d;
      var $301=(($300)|0);
      var $302=HEAPU8[($301)];
      var $303=(($302)&255);
      var $304=((__ZL7s_flags+($303<<2))|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=$299 | $305;
      var $307=$306 | -2147483648;
      ;
      return $307;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19cpu_disassemble_z80P17legacy_cpu_devicePcjPKhS3_i["X"]=1;

function __Z21cpu_disassemble_mcs48P17legacy_cpu_devicePcjPKhS3_i($device, $buffer, $pc, $oprom, $opram, $options) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$device;
  $2=$buffer;
  $3=$pc;
  $4=$oprom;
  $5=$opram;
  $6=$options;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=__ZL11common_dasmP8device_tPcjPKhS3_i($8, $9, $10, $11, $12, 0);
  ;
  return $13;
}


function __ZL11common_dasmP8device_tPcjPKhS3_i($device, $buffer, $pc, $oprom, $opram, $upi41) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $startram;
      var $flags;
      $1=$device;
      $2=$buffer;
      $3=$pc;
      $4=$oprom;
      $5=$opram;
      $6=$upi41;
      var $7=$5;
      $startram=$7;
      $flags=0;
      var $8=$5;
      var $9=(($8+1)|0);
      $5=$9;
      var $10=$4;
      var $11=(($10+1)|0);
      $4=$11;
      var $12=HEAPU8[($10)];
      var $13=(($12)&255);
      if ($13 == 0) {
        __label__ = 1; break;
      }
      else if ($13 == 2) {
        __label__ = 2; break;
      }
      else if ($13 == 3) {
        __label__ = 6; break;
      }
      else if ($13 == 4) {
        __label__ = 7; break;
      }
      else if ($13 == 5) {
        __label__ = 8; break;
      }
      else if ($13 == 7) {
        __label__ = 9; break;
      }
      else if ($13 == 8) {
        __label__ = 10; break;
      }
      else if ($13 == 9) {
        __label__ = 14; break;
      }
      else if ($13 == 10) {
        __label__ = 15; break;
      }
      else if ($13 == 12) {
        __label__ = 16; break;
      }
      else if ($13 == 13) {
        __label__ = 17; break;
      }
      else if ($13 == 14) {
        __label__ = 18; break;
      }
      else if ($13 == 15) {
        __label__ = 19; break;
      }
      else if ($13 == 16) {
        __label__ = 20; break;
      }
      else if ($13 == 17) {
        __label__ = 21; break;
      }
      else if ($13 == 18) {
        __label__ = 22; break;
      }
      else if ($13 == 19) {
        __label__ = 23; break;
      }
      else if ($13 == 20) {
        __label__ = 24; break;
      }
      else if ($13 == 21) {
        __label__ = 25; break;
      }
      else if ($13 == 22) {
        __label__ = 26; break;
      }
      else if ($13 == 23) {
        __label__ = 27; break;
      }
      else if ($13 == 24) {
        __label__ = 28; break;
      }
      else if ($13 == 25) {
        __label__ = 29; break;
      }
      else if ($13 == 26) {
        __label__ = 30; break;
      }
      else if ($13 == 27) {
        __label__ = 31; break;
      }
      else if ($13 == 28) {
        __label__ = 32; break;
      }
      else if ($13 == 29) {
        __label__ = 33; break;
      }
      else if ($13 == 30) {
        __label__ = 34; break;
      }
      else if ($13 == 31) {
        __label__ = 35; break;
      }
      else if ($13 == 32) {
        __label__ = 36; break;
      }
      else if ($13 == 33) {
        __label__ = 37; break;
      }
      else if ($13 == 34) {
        __label__ = 38; break;
      }
      else if ($13 == 35) {
        __label__ = 42; break;
      }
      else if ($13 == 36) {
        __label__ = 43; break;
      }
      else if ($13 == 37) {
        __label__ = 44; break;
      }
      else if ($13 == 38) {
        __label__ = 45; break;
      }
      else if ($13 == 39) {
        __label__ = 46; break;
      }
      else if ($13 == 40) {
        __label__ = 47; break;
      }
      else if ($13 == 41) {
        __label__ = 48; break;
      }
      else if ($13 == 42) {
        __label__ = 49; break;
      }
      else if ($13 == 43) {
        __label__ = 50; break;
      }
      else if ($13 == 44) {
        __label__ = 51; break;
      }
      else if ($13 == 45) {
        __label__ = 52; break;
      }
      else if ($13 == 46) {
        __label__ = 53; break;
      }
      else if ($13 == 47) {
        __label__ = 54; break;
      }
      else if ($13 == 48) {
        __label__ = 55; break;
      }
      else if ($13 == 49) {
        __label__ = 56; break;
      }
      else if ($13 == 50) {
        __label__ = 57; break;
      }
      else if ($13 == 52) {
        __label__ = 58; break;
      }
      else if ($13 == 53) {
        __label__ = 59; break;
      }
      else if ($13 == 54) {
        __label__ = 60; break;
      }
      else if ($13 == 55) {
        __label__ = 61; break;
      }
      else if ($13 == 57) {
        __label__ = 62; break;
      }
      else if ($13 == 58) {
        __label__ = 63; break;
      }
      else if ($13 == 60) {
        __label__ = 64; break;
      }
      else if ($13 == 61) {
        __label__ = 65; break;
      }
      else if ($13 == 62) {
        __label__ = 66; break;
      }
      else if ($13 == 63) {
        __label__ = 67; break;
      }
      else if ($13 == 64) {
        __label__ = 68; break;
      }
      else if ($13 == 65) {
        __label__ = 69; break;
      }
      else if ($13 == 66) {
        __label__ = 70; break;
      }
      else if ($13 == 67) {
        __label__ = 71; break;
      }
      else if ($13 == 68) {
        __label__ = 72; break;
      }
      else if ($13 == 69) {
        __label__ = 73; break;
      }
      else if ($13 == 70) {
        __label__ = 74; break;
      }
      else if ($13 == 71) {
        __label__ = 75; break;
      }
      else if ($13 == 72) {
        __label__ = 76; break;
      }
      else if ($13 == 73) {
        __label__ = 77; break;
      }
      else if ($13 == 74) {
        __label__ = 78; break;
      }
      else if ($13 == 75) {
        __label__ = 79; break;
      }
      else if ($13 == 76) {
        __label__ = 80; break;
      }
      else if ($13 == 77) {
        __label__ = 81; break;
      }
      else if ($13 == 78) {
        __label__ = 82; break;
      }
      else if ($13 == 79) {
        __label__ = 83; break;
      }
      else if ($13 == 80) {
        __label__ = 84; break;
      }
      else if ($13 == 81) {
        __label__ = 85; break;
      }
      else if ($13 == 82) {
        __label__ = 86; break;
      }
      else if ($13 == 83) {
        __label__ = 87; break;
      }
      else if ($13 == 84) {
        __label__ = 88; break;
      }
      else if ($13 == 85) {
        __label__ = 89; break;
      }
      else if ($13 == 86) {
        __label__ = 90; break;
      }
      else if ($13 == 87) {
        __label__ = 91; break;
      }
      else if ($13 == 88) {
        __label__ = 92; break;
      }
      else if ($13 == 89) {
        __label__ = 93; break;
      }
      else if ($13 == 90) {
        __label__ = 94; break;
      }
      else if ($13 == 91) {
        __label__ = 95; break;
      }
      else if ($13 == 92) {
        __label__ = 96; break;
      }
      else if ($13 == 93) {
        __label__ = 97; break;
      }
      else if ($13 == 94) {
        __label__ = 98; break;
      }
      else if ($13 == 95) {
        __label__ = 99; break;
      }
      else if ($13 == 96) {
        __label__ = 100; break;
      }
      else if ($13 == 97) {
        __label__ = 101; break;
      }
      else if ($13 == 98) {
        __label__ = 102; break;
      }
      else if ($13 == 100) {
        __label__ = 103; break;
      }
      else if ($13 == 101) {
        __label__ = 104; break;
      }
      else if ($13 == 103) {
        __label__ = 105; break;
      }
      else if ($13 == 104) {
        __label__ = 106; break;
      }
      else if ($13 == 105) {
        __label__ = 107; break;
      }
      else if ($13 == 106) {
        __label__ = 108; break;
      }
      else if ($13 == 107) {
        __label__ = 109; break;
      }
      else if ($13 == 108) {
        __label__ = 110; break;
      }
      else if ($13 == 109) {
        __label__ = 111; break;
      }
      else if ($13 == 110) {
        __label__ = 112; break;
      }
      else if ($13 == 111) {
        __label__ = 113; break;
      }
      else if ($13 == 112) {
        __label__ = 114; break;
      }
      else if ($13 == 113) {
        __label__ = 115; break;
      }
      else if ($13 == 114) {
        __label__ = 116; break;
      }
      else if ($13 == 116) {
        __label__ = 117; break;
      }
      else if ($13 == 117) {
        __label__ = 118; break;
      }
      else if ($13 == 118) {
        __label__ = 122; break;
      }
      else if ($13 == 119) {
        __label__ = 123; break;
      }
      else if ($13 == 120) {
        __label__ = 124; break;
      }
      else if ($13 == 121) {
        __label__ = 125; break;
      }
      else if ($13 == 122) {
        __label__ = 126; break;
      }
      else if ($13 == 123) {
        __label__ = 127; break;
      }
      else if ($13 == 124) {
        __label__ = 128; break;
      }
      else if ($13 == 125) {
        __label__ = 129; break;
      }
      else if ($13 == 126) {
        __label__ = 130; break;
      }
      else if ($13 == 127) {
        __label__ = 131; break;
      }
      else if ($13 == 128) {
        __label__ = 132; break;
      }
      else if ($13 == 129) {
        __label__ = 136; break;
      }
      else if ($13 == 131) {
        __label__ = 140; break;
      }
      else if ($13 == 132) {
        __label__ = 141; break;
      }
      else if ($13 == 133) {
        __label__ = 142; break;
      }
      else if ($13 == 134) {
        __label__ = 143; break;
      }
      else if ($13 == 136) {
        __label__ = 147; break;
      }
      else if ($13 == 137) {
        __label__ = 151; break;
      }
      else if ($13 == 138) {
        __label__ = 152; break;
      }
      else if ($13 == 140) {
        __label__ = 153; break;
      }
      else if ($13 == 141) {
        __label__ = 154; break;
      }
      else if ($13 == 142) {
        __label__ = 155; break;
      }
      else if ($13 == 143) {
        __label__ = 156; break;
      }
      else if ($13 == 144) {
        __label__ = 157; break;
      }
      else if ($13 == 145) {
        __label__ = 161; break;
      }
      else if ($13 == 146) {
        __label__ = 165; break;
      }
      else if ($13 == 147) {
        __label__ = 166; break;
      }
      else if ($13 == 148) {
        __label__ = 167; break;
      }
      else if ($13 == 149) {
        __label__ = 168; break;
      }
      else if ($13 == 150) {
        __label__ = 169; break;
      }
      else if ($13 == 151) {
        __label__ = 170; break;
      }
      else if ($13 == 152) {
        __label__ = 171; break;
      }
      else if ($13 == 153) {
        __label__ = 175; break;
      }
      else if ($13 == 154) {
        __label__ = 176; break;
      }
      else if ($13 == 156) {
        __label__ = 177; break;
      }
      else if ($13 == 157) {
        __label__ = 178; break;
      }
      else if ($13 == 158) {
        __label__ = 179; break;
      }
      else if ($13 == 159) {
        __label__ = 180; break;
      }
      else if ($13 == 160) {
        __label__ = 181; break;
      }
      else if ($13 == 161) {
        __label__ = 182; break;
      }
      else if ($13 == 163) {
        __label__ = 183; break;
      }
      else if ($13 == 164) {
        __label__ = 184; break;
      }
      else if ($13 == 165) {
        __label__ = 185; break;
      }
      else if ($13 == 167) {
        __label__ = 186; break;
      }
      else if ($13 == 168) {
        __label__ = 187; break;
      }
      else if ($13 == 169) {
        __label__ = 188; break;
      }
      else if ($13 == 170) {
        __label__ = 189; break;
      }
      else if ($13 == 171) {
        __label__ = 190; break;
      }
      else if ($13 == 172) {
        __label__ = 191; break;
      }
      else if ($13 == 173) {
        __label__ = 192; break;
      }
      else if ($13 == 174) {
        __label__ = 193; break;
      }
      else if ($13 == 175) {
        __label__ = 194; break;
      }
      else if ($13 == 176) {
        __label__ = 195; break;
      }
      else if ($13 == 177) {
        __label__ = 196; break;
      }
      else if ($13 == 178) {
        __label__ = 197; break;
      }
      else if ($13 == 179) {
        __label__ = 198; break;
      }
      else if ($13 == 180) {
        __label__ = 199; break;
      }
      else if ($13 == 181) {
        __label__ = 200; break;
      }
      else if ($13 == 182) {
        __label__ = 201; break;
      }
      else if ($13 == 184) {
        __label__ = 202; break;
      }
      else if ($13 == 185) {
        __label__ = 203; break;
      }
      else if ($13 == 186) {
        __label__ = 204; break;
      }
      else if ($13 == 187) {
        __label__ = 205; break;
      }
      else if ($13 == 188) {
        __label__ = 206; break;
      }
      else if ($13 == 189) {
        __label__ = 207; break;
      }
      else if ($13 == 190) {
        __label__ = 208; break;
      }
      else if ($13 == 191) {
        __label__ = 209; break;
      }
      else if ($13 == 196) {
        __label__ = 210; break;
      }
      else if ($13 == 197) {
        __label__ = 211; break;
      }
      else if ($13 == 198) {
        __label__ = 212; break;
      }
      else if ($13 == 199) {
        __label__ = 213; break;
      }
      else if ($13 == 200) {
        __label__ = 214; break;
      }
      else if ($13 == 201) {
        __label__ = 215; break;
      }
      else if ($13 == 202) {
        __label__ = 216; break;
      }
      else if ($13 == 203) {
        __label__ = 217; break;
      }
      else if ($13 == 204) {
        __label__ = 218; break;
      }
      else if ($13 == 205) {
        __label__ = 219; break;
      }
      else if ($13 == 206) {
        __label__ = 220; break;
      }
      else if ($13 == 207) {
        __label__ = 221; break;
      }
      else if ($13 == 208) {
        __label__ = 222; break;
      }
      else if ($13 == 209) {
        __label__ = 223; break;
      }
      else if ($13 == 210) {
        __label__ = 224; break;
      }
      else if ($13 == 211) {
        __label__ = 225; break;
      }
      else if ($13 == 212) {
        __label__ = 226; break;
      }
      else if ($13 == 213) {
        __label__ = 227; break;
      }
      else if ($13 == 214) {
        __label__ = 228; break;
      }
      else if ($13 == 215) {
        __label__ = 232; break;
      }
      else if ($13 == 216) {
        __label__ = 233; break;
      }
      else if ($13 == 217) {
        __label__ = 234; break;
      }
      else if ($13 == 218) {
        __label__ = 235; break;
      }
      else if ($13 == 219) {
        __label__ = 236; break;
      }
      else if ($13 == 220) {
        __label__ = 237; break;
      }
      else if ($13 == 221) {
        __label__ = 238; break;
      }
      else if ($13 == 222) {
        __label__ = 239; break;
      }
      else if ($13 == 223) {
        __label__ = 240; break;
      }
      else if ($13 == 227) {
        __label__ = 241; break;
      }
      else if ($13 == 228) {
        __label__ = 242; break;
      }
      else if ($13 == 229) {
        __label__ = 243; break;
      }
      else if ($13 == 230) {
        __label__ = 247; break;
      }
      else if ($13 == 231) {
        __label__ = 248; break;
      }
      else if ($13 == 232) {
        __label__ = 249; break;
      }
      else if ($13 == 233) {
        __label__ = 250; break;
      }
      else if ($13 == 234) {
        __label__ = 251; break;
      }
      else if ($13 == 235) {
        __label__ = 252; break;
      }
      else if ($13 == 236) {
        __label__ = 253; break;
      }
      else if ($13 == 237) {
        __label__ = 254; break;
      }
      else if ($13 == 238) {
        __label__ = 255; break;
      }
      else if ($13 == 239) {
        __label__ = 256; break;
      }
      else if ($13 == 240) {
        __label__ = 257; break;
      }
      else if ($13 == 241) {
        __label__ = 258; break;
      }
      else if ($13 == 242) {
        __label__ = 259; break;
      }
      else if ($13 == 244) {
        __label__ = 260; break;
      }
      else if ($13 == 245) {
        __label__ = 261; break;
      }
      else if ($13 == 246) {
        __label__ = 265; break;
      }
      else if ($13 == 247) {
        __label__ = 266; break;
      }
      else if ($13 == 248) {
        __label__ = 267; break;
      }
      else if ($13 == 249) {
        __label__ = 268; break;
      }
      else if ($13 == 250) {
        __label__ = 269; break;
      }
      else if ($13 == 251) {
        __label__ = 270; break;
      }
      else if ($13 == 252) {
        __label__ = 271; break;
      }
      else if ($13 == 253) {
        __label__ = 272; break;
      }
      else if ($13 == 254) {
        __label__ = 273; break;
      }
      else if ($13 == 255) {
        __label__ = 274; break;
      }
      else {
      __label__ = 275; break;
      }
      
    case 1: // $14
      var $15=$2;
      var $16=_sprintf($15, ((STRING_TABLE.__str6615)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 2: // $17
      var $18=$6;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=$2;
      var $22=_sprintf($21, ((STRING_TABLE.__str16616)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 5; break;
    case 4: // $23
      var $24=$2;
      var $25=_sprintf($24, ((STRING_TABLE.__str26617)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 5; break;
    case 5: // $26
      __label__ = 275; break;
    case 6: // $27
      var $28=$2;
      var $29=$5;
      var $30=(($29+1)|0);
      $5=$30;
      var $31=HEAPU8[($29)];
      var $32=(($31)&255);
      var $33=_sprintf($28, ((STRING_TABLE.__str36618)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$32,tempInt));
      __label__ = 275; break;
    case 7: // $34
      var $35=$2;
      var $36=$5;
      var $37=(($36+1)|0);
      $5=$37;
      var $38=HEAPU8[($36)];
      var $39=(($38)&255);
      var $40=_sprintf($35, ((STRING_TABLE.__str46619)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$39,tempInt));
      __label__ = 275; break;
    case 8: // $41
      var $42=$2;
      var $43=_sprintf($42, ((STRING_TABLE.__str56620)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 9: // $44
      var $45=$2;
      var $46=_sprintf($45, ((STRING_TABLE.__str66621)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 10: // $47
      var $48=$6;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $50
      var $51=$2;
      var $52=_sprintf($51, ((STRING_TABLE.__str76622)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 13; break;
    case 12: // $53
      var $54=$2;
      var $55=_sprintf($54, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 13; break;
    case 13: // $56
      __label__ = 275; break;
    case 14: // $57
      var $58=$2;
      var $59=_sprintf($58, ((STRING_TABLE.__str96624)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 15: // $60
      var $61=$2;
      var $62=_sprintf($61, ((STRING_TABLE.__str106625)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 16: // $63
      var $64=$2;
      var $65=_sprintf($64, ((STRING_TABLE.__str116626)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 17: // $66
      var $67=$2;
      var $68=_sprintf($67, ((STRING_TABLE.__str126627)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 18: // $69
      var $70=$2;
      var $71=_sprintf($70, ((STRING_TABLE.__str136628)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 19: // $72
      var $73=$2;
      var $74=_sprintf($73, ((STRING_TABLE.__str146629)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 20: // $75
      var $76=$2;
      var $77=_sprintf($76, ((STRING_TABLE.__str156630)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 21: // $78
      var $79=$2;
      var $80=_sprintf($79, ((STRING_TABLE.__str166631)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 22: // $81
      var $82=$2;
      var $83=$3;
      var $84=$83 & 3840;
      var $85=$5;
      var $86=(($85+1)|0);
      $5=$86;
      var $87=HEAPU8[($85)];
      var $88=(($87)&255);
      var $89=$84 | $88;
      var $90=_sprintf($82, ((STRING_TABLE.__str176632)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$89,tempInt));
      __label__ = 275; break;
    case 23: // $91
      var $92=$2;
      var $93=$5;
      var $94=(($93+1)|0);
      $5=$94;
      var $95=HEAPU8[($93)];
      var $96=(($95)&255);
      var $97=_sprintf($92, ((STRING_TABLE.__str186633)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$96,tempInt));
      __label__ = 275; break;
    case 24: // $98
      var $99=$2;
      var $100=$5;
      var $101=(($100+1)|0);
      $5=$101;
      var $102=HEAPU8[($100)];
      var $103=(($102)&255);
      var $104=_sprintf($99, ((STRING_TABLE.__str196634)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$103,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 25: // $105
      var $106=$2;
      var $107=_sprintf($106, ((STRING_TABLE.__str206635)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 26: // $108
      var $109=$2;
      var $110=$3;
      var $111=$110 & 3840;
      var $112=$5;
      var $113=(($112+1)|0);
      $5=$113;
      var $114=HEAPU8[($112)];
      var $115=(($114)&255);
      var $116=$111 | $115;
      var $117=_sprintf($109, ((STRING_TABLE.__str216636)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$116,tempInt));
      __label__ = 275; break;
    case 27: // $118
      var $119=$2;
      var $120=_sprintf($119, ((STRING_TABLE.__str226637)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 28: // $121
      var $122=$2;
      var $123=_sprintf($122, ((STRING_TABLE.__str236638)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 29: // $124
      var $125=$2;
      var $126=_sprintf($125, ((STRING_TABLE.__str246639)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 30: // $127
      var $128=$2;
      var $129=_sprintf($128, ((STRING_TABLE.__str256640)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 31: // $130
      var $131=$2;
      var $132=_sprintf($131, ((STRING_TABLE.__str266641)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 32: // $133
      var $134=$2;
      var $135=_sprintf($134, ((STRING_TABLE.__str276642)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 33: // $136
      var $137=$2;
      var $138=_sprintf($137, ((STRING_TABLE.__str286643)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 34: // $139
      var $140=$2;
      var $141=_sprintf($140, ((STRING_TABLE.__str296644)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 35: // $142
      var $143=$2;
      var $144=_sprintf($143, ((STRING_TABLE.__str306645)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 36: // $145
      var $146=$2;
      var $147=_sprintf($146, ((STRING_TABLE.__str316646)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 37: // $148
      var $149=$2;
      var $150=_sprintf($149, ((STRING_TABLE.__str326647)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 38: // $151
      var $152=$6;
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $154
      var $155=$2;
      var $156=_sprintf($155, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 41; break;
    case 40: // $157
      var $158=$2;
      var $159=_sprintf($158, ((STRING_TABLE.__str336648)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 41; break;
    case 41: // $160
      __label__ = 275; break;
    case 42: // $161
      var $162=$2;
      var $163=$5;
      var $164=(($163+1)|0);
      $5=$164;
      var $165=HEAPU8[($163)];
      var $166=(($165)&255);
      var $167=_sprintf($162, ((STRING_TABLE.__str346649)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$166,tempInt));
      __label__ = 275; break;
    case 43: // $168
      var $169=$2;
      var $170=$5;
      var $171=(($170+1)|0);
      $5=$171;
      var $172=HEAPU8[($170)];
      var $173=(($172)&255);
      var $174=_sprintf($169, ((STRING_TABLE.__str356650)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$173,tempInt));
      __label__ = 275; break;
    case 44: // $175
      var $176=$2;
      var $177=_sprintf($176, ((STRING_TABLE.__str366651)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 45: // $178
      var $179=$2;
      var $180=$3;
      var $181=$180 & 3840;
      var $182=$5;
      var $183=(($182+1)|0);
      $5=$183;
      var $184=HEAPU8[($182)];
      var $185=(($184)&255);
      var $186=$181 | $185;
      var $187=_sprintf($179, ((STRING_TABLE.__str376652)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$186,tempInt));
      __label__ = 275; break;
    case 46: // $188
      var $189=$2;
      var $190=_sprintf($189, ((STRING_TABLE.__str386653)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 47: // $191
      var $192=$2;
      var $193=_sprintf($192, ((STRING_TABLE.__str396654)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 48: // $194
      var $195=$2;
      var $196=_sprintf($195, ((STRING_TABLE.__str406655)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 49: // $197
      var $198=$2;
      var $199=_sprintf($198, ((STRING_TABLE.__str416656)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 50: // $200
      var $201=$2;
      var $202=_sprintf($201, ((STRING_TABLE.__str426657)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 51: // $203
      var $204=$2;
      var $205=_sprintf($204, ((STRING_TABLE.__str436658)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 52: // $206
      var $207=$2;
      var $208=_sprintf($207, ((STRING_TABLE.__str446659)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 53: // $209
      var $210=$2;
      var $211=_sprintf($210, ((STRING_TABLE.__str456660)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 54: // $212
      var $213=$2;
      var $214=_sprintf($213, ((STRING_TABLE.__str466661)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 55: // $215
      var $216=$2;
      var $217=_sprintf($216, ((STRING_TABLE.__str476662)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 56: // $218
      var $219=$2;
      var $220=_sprintf($219, ((STRING_TABLE.__str486663)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 57: // $221
      var $222=$2;
      var $223=$3;
      var $224=$223 & 3840;
      var $225=$5;
      var $226=(($225+1)|0);
      $5=$226;
      var $227=HEAPU8[($225)];
      var $228=(($227)&255);
      var $229=$224 | $228;
      var $230=_sprintf($222, ((STRING_TABLE.__str496664)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$229,tempInt));
      __label__ = 275; break;
    case 58: // $231
      var $232=$2;
      var $233=$5;
      var $234=(($233+1)|0);
      $5=$234;
      var $235=HEAPU8[($233)];
      var $236=(($235)&255);
      var $237=_sprintf($232, ((STRING_TABLE.__str506665)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$236,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 59: // $238
      var $239=$2;
      var $240=_sprintf($239, ((STRING_TABLE.__str516666)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 60: // $241
      var $242=$2;
      var $243=$3;
      var $244=$243 & 3840;
      var $245=$5;
      var $246=(($245+1)|0);
      $5=$246;
      var $247=HEAPU8[($245)];
      var $248=(($247)&255);
      var $249=$244 | $248;
      var $250=_sprintf($242, ((STRING_TABLE.__str526667)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$249,tempInt));
      __label__ = 275; break;
    case 61: // $251
      var $252=$2;
      var $253=_sprintf($252, ((STRING_TABLE.__str536668)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 62: // $254
      var $255=$2;
      var $256=_sprintf($255, ((STRING_TABLE.__str546669)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 63: // $257
      var $258=$2;
      var $259=_sprintf($258, ((STRING_TABLE.__str556670)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 64: // $260
      var $261=$2;
      var $262=_sprintf($261, ((STRING_TABLE.__str566671)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 65: // $263
      var $264=$2;
      var $265=_sprintf($264, ((STRING_TABLE.__str576672)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 66: // $266
      var $267=$2;
      var $268=_sprintf($267, ((STRING_TABLE.__str586673)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 67: // $269
      var $270=$2;
      var $271=_sprintf($270, ((STRING_TABLE.__str596674)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 68: // $272
      var $273=$2;
      var $274=_sprintf($273, ((STRING_TABLE.__str606675)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 69: // $275
      var $276=$2;
      var $277=_sprintf($276, ((STRING_TABLE.__str616676)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 70: // $278
      var $279=$2;
      var $280=_sprintf($279, ((STRING_TABLE.__str626677)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 71: // $281
      var $282=$2;
      var $283=$5;
      var $284=(($283+1)|0);
      $5=$284;
      var $285=HEAPU8[($283)];
      var $286=(($285)&255);
      var $287=_sprintf($282, ((STRING_TABLE.__str636678)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$286,tempInt));
      __label__ = 275; break;
    case 72: // $288
      var $289=$2;
      var $290=$5;
      var $291=(($290+1)|0);
      $5=$291;
      var $292=HEAPU8[($290)];
      var $293=(($292)&255);
      var $294=_sprintf($289, ((STRING_TABLE.__str646679)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$293,tempInt));
      __label__ = 275; break;
    case 73: // $295
      var $296=$2;
      var $297=_sprintf($296, ((STRING_TABLE.__str656680)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 74: // $298
      var $299=$2;
      var $300=$3;
      var $301=$300 & 3840;
      var $302=$5;
      var $303=(($302+1)|0);
      $5=$303;
      var $304=HEAPU8[($302)];
      var $305=(($304)&255);
      var $306=$301 | $305;
      var $307=_sprintf($299, ((STRING_TABLE.__str666681)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$306,tempInt));
      __label__ = 275; break;
    case 75: // $308
      var $309=$2;
      var $310=_sprintf($309, ((STRING_TABLE.__str676682)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 76: // $311
      var $312=$2;
      var $313=_sprintf($312, ((STRING_TABLE.__str686683)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 77: // $314
      var $315=$2;
      var $316=_sprintf($315, ((STRING_TABLE.__str696684)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 78: // $317
      var $318=$2;
      var $319=_sprintf($318, ((STRING_TABLE.__str706685)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 79: // $320
      var $321=$2;
      var $322=_sprintf($321, ((STRING_TABLE.__str716686)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 80: // $323
      var $324=$2;
      var $325=_sprintf($324, ((STRING_TABLE.__str726687)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 81: // $326
      var $327=$2;
      var $328=_sprintf($327, ((STRING_TABLE.__str736688)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 82: // $329
      var $330=$2;
      var $331=_sprintf($330, ((STRING_TABLE.__str746689)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 83: // $332
      var $333=$2;
      var $334=_sprintf($333, ((STRING_TABLE.__str756690)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 84: // $335
      var $336=$2;
      var $337=_sprintf($336, ((STRING_TABLE.__str766691)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 85: // $338
      var $339=$2;
      var $340=_sprintf($339, ((STRING_TABLE.__str776692)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 86: // $341
      var $342=$2;
      var $343=$3;
      var $344=$343 & 3840;
      var $345=$5;
      var $346=(($345+1)|0);
      $5=$346;
      var $347=HEAPU8[($345)];
      var $348=(($347)&255);
      var $349=$344 | $348;
      var $350=_sprintf($342, ((STRING_TABLE.__str786693)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$349,tempInt));
      __label__ = 275; break;
    case 87: // $351
      var $352=$2;
      var $353=$5;
      var $354=(($353+1)|0);
      $5=$354;
      var $355=HEAPU8[($353)];
      var $356=(($355)&255);
      var $357=_sprintf($352, ((STRING_TABLE.__str796694)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$356,tempInt));
      __label__ = 275; break;
    case 88: // $358
      var $359=$2;
      var $360=$5;
      var $361=(($360+1)|0);
      $5=$361;
      var $362=HEAPU8[($360)];
      var $363=(($362)&255);
      var $364=_sprintf($359, ((STRING_TABLE.__str806695)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$363,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 89: // $365
      var $366=$2;
      var $367=_sprintf($366, ((STRING_TABLE.__str816696)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 90: // $368
      var $369=$2;
      var $370=$3;
      var $371=$370 & 3840;
      var $372=$5;
      var $373=(($372+1)|0);
      $5=$373;
      var $374=HEAPU8[($372)];
      var $375=(($374)&255);
      var $376=$371 | $375;
      var $377=_sprintf($369, ((STRING_TABLE.__str826697)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$376,tempInt));
      __label__ = 275; break;
    case 91: // $378
      var $379=$2;
      var $380=_sprintf($379, ((STRING_TABLE.__str836698)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 92: // $381
      var $382=$2;
      var $383=_sprintf($382, ((STRING_TABLE.__str846699)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 93: // $384
      var $385=$2;
      var $386=_sprintf($385, ((STRING_TABLE.__str856700)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 94: // $387
      var $388=$2;
      var $389=_sprintf($388, ((STRING_TABLE.__str866701)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 95: // $390
      var $391=$2;
      var $392=_sprintf($391, ((STRING_TABLE.__str876702)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 96: // $393
      var $394=$2;
      var $395=_sprintf($394, ((STRING_TABLE.__str886703)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 97: // $396
      var $397=$2;
      var $398=_sprintf($397, ((STRING_TABLE.__str896704)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 98: // $399
      var $400=$2;
      var $401=_sprintf($400, ((STRING_TABLE.__str906705)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 99: // $402
      var $403=$2;
      var $404=_sprintf($403, ((STRING_TABLE.__str916706)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 100: // $405
      var $406=$2;
      var $407=_sprintf($406, ((STRING_TABLE.__str926707)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 101: // $408
      var $409=$2;
      var $410=_sprintf($409, ((STRING_TABLE.__str936708)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 102: // $411
      var $412=$2;
      var $413=_sprintf($412, ((STRING_TABLE.__str946709)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 103: // $414
      var $415=$2;
      var $416=$5;
      var $417=(($416+1)|0);
      $5=$417;
      var $418=HEAPU8[($416)];
      var $419=(($418)&255);
      var $420=_sprintf($415, ((STRING_TABLE.__str956710)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$419,tempInt));
      __label__ = 275; break;
    case 104: // $421
      var $422=$2;
      var $423=_sprintf($422, ((STRING_TABLE.__str966711)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 105: // $424
      var $425=$2;
      var $426=_sprintf($425, ((STRING_TABLE.__str976712)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 106: // $427
      var $428=$2;
      var $429=_sprintf($428, ((STRING_TABLE.__str986713)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 107: // $430
      var $431=$2;
      var $432=_sprintf($431, ((STRING_TABLE.__str996714)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 108: // $433
      var $434=$2;
      var $435=_sprintf($434, ((STRING_TABLE.__str1006715)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 109: // $436
      var $437=$2;
      var $438=_sprintf($437, ((STRING_TABLE.__str1016716)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 110: // $439
      var $440=$2;
      var $441=_sprintf($440, ((STRING_TABLE.__str1026717)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 111: // $442
      var $443=$2;
      var $444=_sprintf($443, ((STRING_TABLE.__str1036718)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 112: // $445
      var $446=$2;
      var $447=_sprintf($446, ((STRING_TABLE.__str1046719)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 113: // $448
      var $449=$2;
      var $450=_sprintf($449, ((STRING_TABLE.__str1056720)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 114: // $451
      var $452=$2;
      var $453=_sprintf($452, ((STRING_TABLE.__str1066721)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 115: // $454
      var $455=$2;
      var $456=_sprintf($455, ((STRING_TABLE.__str1076722)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 116: // $457
      var $458=$2;
      var $459=$3;
      var $460=$459 & 3840;
      var $461=$5;
      var $462=(($461+1)|0);
      $5=$462;
      var $463=HEAPU8[($461)];
      var $464=(($463)&255);
      var $465=$460 | $464;
      var $466=_sprintf($458, ((STRING_TABLE.__str1086723)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$465,tempInt));
      __label__ = 275; break;
    case 117: // $467
      var $468=$2;
      var $469=$5;
      var $470=(($469+1)|0);
      $5=$470;
      var $471=HEAPU8[($469)];
      var $472=(($471)&255);
      var $473=_sprintf($468, ((STRING_TABLE.__str1096724)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$472,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 118: // $474
      var $475=$6;
      var $476=(($475)|0)!=0;
      if ($476) { __label__ = 120; break; } else { __label__ = 119; break; }
    case 119: // $477
      var $478=$2;
      var $479=_sprintf($478, ((STRING_TABLE.__str1106725)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 121; break;
    case 120: // $480
      var $481=$2;
      var $482=_sprintf($481, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 121; break;
    case 121: // $483
      __label__ = 275; break;
    case 122: // $484
      var $485=$2;
      var $486=$3;
      var $487=$486 & 3840;
      var $488=$5;
      var $489=(($488+1)|0);
      $5=$489;
      var $490=HEAPU8[($488)];
      var $491=(($490)&255);
      var $492=$487 | $491;
      var $493=_sprintf($485, ((STRING_TABLE.__str1116726)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$492,tempInt));
      __label__ = 275; break;
    case 123: // $494
      var $495=$2;
      var $496=_sprintf($495, ((STRING_TABLE.__str1126727)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 124: // $497
      var $498=$2;
      var $499=_sprintf($498, ((STRING_TABLE.__str1136728)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 125: // $500
      var $501=$2;
      var $502=_sprintf($501, ((STRING_TABLE.__str1146729)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 126: // $503
      var $504=$2;
      var $505=_sprintf($504, ((STRING_TABLE.__str1156730)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 127: // $506
      var $507=$2;
      var $508=_sprintf($507, ((STRING_TABLE.__str1166731)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 128: // $509
      var $510=$2;
      var $511=_sprintf($510, ((STRING_TABLE.__str1176732)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 129: // $512
      var $513=$2;
      var $514=_sprintf($513, ((STRING_TABLE.__str1186733)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 130: // $515
      var $516=$2;
      var $517=_sprintf($516, ((STRING_TABLE.__str1196734)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 131: // $518
      var $519=$2;
      var $520=_sprintf($519, ((STRING_TABLE.__str1206735)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 132: // $521
      var $522=$6;
      var $523=(($522)|0)!=0;
      if ($523) { __label__ = 134; break; } else { __label__ = 133; break; }
    case 133: // $524
      var $525=$2;
      var $526=_sprintf($525, ((STRING_TABLE.__str1216736)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 135; break;
    case 134: // $527
      var $528=$2;
      var $529=_sprintf($528, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 135; break;
    case 135: // $530
      __label__ = 275; break;
    case 136: // $531
      var $532=$6;
      var $533=(($532)|0)!=0;
      if ($533) { __label__ = 138; break; } else { __label__ = 137; break; }
    case 137: // $534
      var $535=$2;
      var $536=_sprintf($535, ((STRING_TABLE.__str1226737)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 139; break;
    case 138: // $537
      var $538=$2;
      var $539=_sprintf($538, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 139; break;
    case 139: // $540
      __label__ = 275; break;
    case 140: // $541
      var $542=$2;
      var $543=_sprintf($542, ((STRING_TABLE.__str1236738)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $flags=1073741824;
      __label__ = 275; break;
    case 141: // $544
      var $545=$2;
      var $546=$5;
      var $547=(($546+1)|0);
      $5=$547;
      var $548=HEAPU8[($546)];
      var $549=(($548)&255);
      var $550=_sprintf($545, ((STRING_TABLE.__str1246739)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$549,tempInt));
      __label__ = 275; break;
    case 142: // $551
      var $552=$2;
      var $553=_sprintf($552, ((STRING_TABLE.__str1256740)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 143: // $554
      var $555=$6;
      var $556=(($555)|0)!=0;
      if ($556) { __label__ = 145; break; } else { __label__ = 144; break; }
    case 144: // $557
      var $558=$2;
      var $559=$3;
      var $560=$559 & 3840;
      var $561=$5;
      var $562=(($561+1)|0);
      $5=$562;
      var $563=HEAPU8[($561)];
      var $564=(($563)&255);
      var $565=$560 | $564;
      var $566=_sprintf($558, ((STRING_TABLE.__str1266741)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$565,tempInt));
      __label__ = 146; break;
    case 145: // $567
      var $568=$2;
      var $569=$3;
      var $570=$569 & 3840;
      var $571=$5;
      var $572=(($571+1)|0);
      $5=$572;
      var $573=HEAPU8[($571)];
      var $574=(($573)&255);
      var $575=$570 | $574;
      var $576=_sprintf($568, ((STRING_TABLE.__str1276742)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$575,tempInt));
      __label__ = 146; break;
    case 146: // $577
      __label__ = 275; break;
    case 147: // $578
      var $579=$6;
      var $580=(($579)|0)!=0;
      if ($580) { __label__ = 149; break; } else { __label__ = 148; break; }
    case 148: // $581
      var $582=$2;
      var $583=$5;
      var $584=(($583+1)|0);
      $5=$584;
      var $585=HEAPU8[($583)];
      var $586=(($585)&255);
      var $587=_sprintf($582, ((STRING_TABLE.__str1286743)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$586,tempInt));
      __label__ = 150; break;
    case 149: // $588
      var $589=$2;
      var $590=_sprintf($589, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 150; break;
    case 150: // $591
      __label__ = 275; break;
    case 151: // $592
      var $593=$2;
      var $594=$5;
      var $595=(($594+1)|0);
      $5=$595;
      var $596=HEAPU8[($594)];
      var $597=(($596)&255);
      var $598=_sprintf($593, ((STRING_TABLE.__str1296744)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$597,tempInt));
      __label__ = 275; break;
    case 152: // $599
      var $600=$2;
      var $601=$5;
      var $602=(($601+1)|0);
      $5=$602;
      var $603=HEAPU8[($601)];
      var $604=(($603)&255);
      var $605=_sprintf($600, ((STRING_TABLE.__str1306745)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$604,tempInt));
      __label__ = 275; break;
    case 153: // $606
      var $607=$2;
      var $608=_sprintf($607, ((STRING_TABLE.__str1316746)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 154: // $609
      var $610=$2;
      var $611=_sprintf($610, ((STRING_TABLE.__str1326747)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 155: // $612
      var $613=$2;
      var $614=_sprintf($613, ((STRING_TABLE.__str1336748)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 156: // $615
      var $616=$2;
      var $617=_sprintf($616, ((STRING_TABLE.__str1346749)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 157: // $618
      var $619=$6;
      var $620=(($619)|0)!=0;
      if ($620) { __label__ = 159; break; } else { __label__ = 158; break; }
    case 158: // $621
      var $622=$2;
      var $623=_sprintf($622, ((STRING_TABLE.__str1356750)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 160; break;
    case 159: // $624
      var $625=$2;
      var $626=_sprintf($625, ((STRING_TABLE.__str1366751)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 160; break;
    case 160: // $627
      __label__ = 275; break;
    case 161: // $628
      var $629=$6;
      var $630=(($629)|0)!=0;
      if ($630) { __label__ = 163; break; } else { __label__ = 162; break; }
    case 162: // $631
      var $632=$2;
      var $633=_sprintf($632, ((STRING_TABLE.__str1376752)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 164; break;
    case 163: // $634
      var $635=$2;
      var $636=_sprintf($635, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 164; break;
    case 164: // $637
      __label__ = 275; break;
    case 165: // $638
      var $639=$2;
      var $640=$3;
      var $641=$640 & 3840;
      var $642=$5;
      var $643=(($642+1)|0);
      $5=$643;
      var $644=HEAPU8[($642)];
      var $645=(($644)&255);
      var $646=$641 | $645;
      var $647=_sprintf($639, ((STRING_TABLE.__str1386753)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$646,tempInt));
      __label__ = 275; break;
    case 166: // $648
      var $649=$2;
      var $650=_sprintf($649, ((STRING_TABLE.__str1396754)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      $flags=1073741824;
      __label__ = 275; break;
    case 167: // $651
      var $652=$2;
      var $653=$5;
      var $654=(($653+1)|0);
      $5=$654;
      var $655=HEAPU8[($653)];
      var $656=(($655)&255);
      var $657=_sprintf($652, ((STRING_TABLE.__str1406755)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$656,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 168: // $658
      var $659=$2;
      var $660=_sprintf($659, ((STRING_TABLE.__str1416756)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 169: // $661
      var $662=$2;
      var $663=$3;
      var $664=$663 & 3840;
      var $665=$5;
      var $666=(($665+1)|0);
      $5=$666;
      var $667=HEAPU8[($665)];
      var $668=(($667)&255);
      var $669=$664 | $668;
      var $670=_sprintf($662, ((STRING_TABLE.__str1426757)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$669,tempInt));
      __label__ = 275; break;
    case 170: // $671
      var $672=$2;
      var $673=_sprintf($672, ((STRING_TABLE.__str1436758)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 171: // $674
      var $675=$6;
      var $676=(($675)|0)!=0;
      if ($676) { __label__ = 173; break; } else { __label__ = 172; break; }
    case 172: // $677
      var $678=$2;
      var $679=$5;
      var $680=(($679+1)|0);
      $5=$680;
      var $681=HEAPU8[($679)];
      var $682=(($681)&255);
      var $683=_sprintf($678, ((STRING_TABLE.__str1446759)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$682,tempInt));
      __label__ = 174; break;
    case 173: // $684
      var $685=$2;
      var $686=_sprintf($685, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 174; break;
    case 174: // $687
      __label__ = 275; break;
    case 175: // $688
      var $689=$2;
      var $690=$5;
      var $691=(($690+1)|0);
      $5=$691;
      var $692=HEAPU8[($690)];
      var $693=(($692)&255);
      var $694=_sprintf($689, ((STRING_TABLE.__str1456760)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$693,tempInt));
      __label__ = 275; break;
    case 176: // $695
      var $696=$2;
      var $697=$5;
      var $698=(($697+1)|0);
      $5=$698;
      var $699=HEAPU8[($697)];
      var $700=(($699)&255);
      var $701=_sprintf($696, ((STRING_TABLE.__str1466761)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$700,tempInt));
      __label__ = 275; break;
    case 177: // $702
      var $703=$2;
      var $704=_sprintf($703, ((STRING_TABLE.__str1476762)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 178: // $705
      var $706=$2;
      var $707=_sprintf($706, ((STRING_TABLE.__str1486763)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 179: // $708
      var $709=$2;
      var $710=_sprintf($709, ((STRING_TABLE.__str1496764)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 180: // $711
      var $712=$2;
      var $713=_sprintf($712, ((STRING_TABLE.__str1506765)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 181: // $714
      var $715=$2;
      var $716=_sprintf($715, ((STRING_TABLE.__str1516766)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 182: // $717
      var $718=$2;
      var $719=_sprintf($718, ((STRING_TABLE.__str1526767)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 183: // $720
      var $721=$2;
      var $722=_sprintf($721, ((STRING_TABLE.__str1536768)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 184: // $723
      var $724=$2;
      var $725=$5;
      var $726=(($725+1)|0);
      $5=$726;
      var $727=HEAPU8[($725)];
      var $728=(($727)&255);
      var $729=_sprintf($724, ((STRING_TABLE.__str1546769)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$728,tempInt));
      __label__ = 275; break;
    case 185: // $730
      var $731=$2;
      var $732=_sprintf($731, ((STRING_TABLE.__str1556770)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 186: // $733
      var $734=$2;
      var $735=_sprintf($734, ((STRING_TABLE.__str1566771)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 187: // $736
      var $737=$2;
      var $738=_sprintf($737, ((STRING_TABLE.__str1576772)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 188: // $739
      var $740=$2;
      var $741=_sprintf($740, ((STRING_TABLE.__str1586773)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 189: // $742
      var $743=$2;
      var $744=_sprintf($743, ((STRING_TABLE.__str1596774)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 190: // $745
      var $746=$2;
      var $747=_sprintf($746, ((STRING_TABLE.__str1606775)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 191: // $748
      var $749=$2;
      var $750=_sprintf($749, ((STRING_TABLE.__str1616776)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 192: // $751
      var $752=$2;
      var $753=_sprintf($752, ((STRING_TABLE.__str1626777)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 193: // $754
      var $755=$2;
      var $756=_sprintf($755, ((STRING_TABLE.__str1636778)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 194: // $757
      var $758=$2;
      var $759=_sprintf($758, ((STRING_TABLE.__str1646779)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 195: // $760
      var $761=$2;
      var $762=$5;
      var $763=(($762+1)|0);
      $5=$763;
      var $764=HEAPU8[($762)];
      var $765=(($764)&255);
      var $766=_sprintf($761, ((STRING_TABLE.__str1656780)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$765,tempInt));
      __label__ = 275; break;
    case 196: // $767
      var $768=$2;
      var $769=$5;
      var $770=(($769+1)|0);
      $5=$770;
      var $771=HEAPU8[($769)];
      var $772=(($771)&255);
      var $773=_sprintf($768, ((STRING_TABLE.__str1666781)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$772,tempInt));
      __label__ = 275; break;
    case 197: // $774
      var $775=$2;
      var $776=$3;
      var $777=$776 & 3840;
      var $778=$5;
      var $779=(($778+1)|0);
      $5=$779;
      var $780=HEAPU8[($778)];
      var $781=(($780)&255);
      var $782=$777 | $781;
      var $783=_sprintf($775, ((STRING_TABLE.__str1676782)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$782,tempInt));
      __label__ = 275; break;
    case 198: // $784
      var $785=$2;
      var $786=_sprintf($785, ((STRING_TABLE.__str1686783)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 199: // $787
      var $788=$2;
      var $789=$5;
      var $790=(($789+1)|0);
      $5=$790;
      var $791=HEAPU8[($789)];
      var $792=(($791)&255);
      var $793=_sprintf($788, ((STRING_TABLE.__str1696784)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$792,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 200: // $794
      var $795=$2;
      var $796=_sprintf($795, ((STRING_TABLE.__str1706785)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 201: // $797
      var $798=$2;
      var $799=$3;
      var $800=$799 & 3840;
      var $801=$5;
      var $802=(($801+1)|0);
      $5=$802;
      var $803=HEAPU8[($801)];
      var $804=(($803)&255);
      var $805=$800 | $804;
      var $806=_sprintf($798, ((STRING_TABLE.__str1716786)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$805,tempInt));
      __label__ = 275; break;
    case 202: // $807
      var $808=$2;
      var $809=$5;
      var $810=(($809+1)|0);
      $5=$810;
      var $811=HEAPU8[($809)];
      var $812=(($811)&255);
      var $813=_sprintf($808, ((STRING_TABLE.__str1726787)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$812,tempInt));
      __label__ = 275; break;
    case 203: // $814
      var $815=$2;
      var $816=$5;
      var $817=(($816+1)|0);
      $5=$817;
      var $818=HEAPU8[($816)];
      var $819=(($818)&255);
      var $820=_sprintf($815, ((STRING_TABLE.__str1736788)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$819,tempInt));
      __label__ = 275; break;
    case 204: // $821
      var $822=$2;
      var $823=$5;
      var $824=(($823+1)|0);
      $5=$824;
      var $825=HEAPU8[($823)];
      var $826=(($825)&255);
      var $827=_sprintf($822, ((STRING_TABLE.__str1746789)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$826,tempInt));
      __label__ = 275; break;
    case 205: // $828
      var $829=$2;
      var $830=$5;
      var $831=(($830+1)|0);
      $5=$831;
      var $832=HEAPU8[($830)];
      var $833=(($832)&255);
      var $834=_sprintf($829, ((STRING_TABLE.__str1756790)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$833,tempInt));
      __label__ = 275; break;
    case 206: // $835
      var $836=$2;
      var $837=$5;
      var $838=(($837+1)|0);
      $5=$838;
      var $839=HEAPU8[($837)];
      var $840=(($839)&255);
      var $841=_sprintf($836, ((STRING_TABLE.__str1766791)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$840,tempInt));
      __label__ = 275; break;
    case 207: // $842
      var $843=$2;
      var $844=$5;
      var $845=(($844+1)|0);
      $5=$845;
      var $846=HEAPU8[($844)];
      var $847=(($846)&255);
      var $848=_sprintf($843, ((STRING_TABLE.__str1776792)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$847,tempInt));
      __label__ = 275; break;
    case 208: // $849
      var $850=$2;
      var $851=$5;
      var $852=(($851+1)|0);
      $5=$852;
      var $853=HEAPU8[($851)];
      var $854=(($853)&255);
      var $855=_sprintf($850, ((STRING_TABLE.__str1786793)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$854,tempInt));
      __label__ = 275; break;
    case 209: // $856
      var $857=$2;
      var $858=$5;
      var $859=(($858+1)|0);
      $5=$859;
      var $860=HEAPU8[($858)];
      var $861=(($860)&255);
      var $862=_sprintf($857, ((STRING_TABLE.__str1796794)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$861,tempInt));
      __label__ = 275; break;
    case 210: // $863
      var $864=$2;
      var $865=$5;
      var $866=(($865+1)|0);
      $5=$866;
      var $867=HEAPU8[($865)];
      var $868=(($867)&255);
      var $869=_sprintf($864, ((STRING_TABLE.__str1806795)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$868,tempInt));
      __label__ = 275; break;
    case 211: // $870
      var $871=$2;
      var $872=_sprintf($871, ((STRING_TABLE.__str1816796)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 212: // $873
      var $874=$2;
      var $875=$3;
      var $876=$875 & 3840;
      var $877=$5;
      var $878=(($877+1)|0);
      $5=$878;
      var $879=HEAPU8[($877)];
      var $880=(($879)&255);
      var $881=$876 | $880;
      var $882=_sprintf($874, ((STRING_TABLE.__str1826797)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$881,tempInt));
      __label__ = 275; break;
    case 213: // $883
      var $884=$2;
      var $885=_sprintf($884, ((STRING_TABLE.__str1836798)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 214: // $886
      var $887=$2;
      var $888=_sprintf($887, ((STRING_TABLE.__str1846799)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 215: // $889
      var $890=$2;
      var $891=_sprintf($890, ((STRING_TABLE.__str1856800)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 216: // $892
      var $893=$2;
      var $894=_sprintf($893, ((STRING_TABLE.__str1866801)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 217: // $895
      var $896=$2;
      var $897=_sprintf($896, ((STRING_TABLE.__str1876802)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 218: // $898
      var $899=$2;
      var $900=_sprintf($899, ((STRING_TABLE.__str1886803)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 219: // $901
      var $902=$2;
      var $903=_sprintf($902, ((STRING_TABLE.__str1896804)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 220: // $904
      var $905=$2;
      var $906=_sprintf($905, ((STRING_TABLE.__str1906805)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 221: // $907
      var $908=$2;
      var $909=_sprintf($908, ((STRING_TABLE.__str1916806)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 222: // $910
      var $911=$2;
      var $912=_sprintf($911, ((STRING_TABLE.__str1926807)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 223: // $913
      var $914=$2;
      var $915=_sprintf($914, ((STRING_TABLE.__str1936808)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 224: // $916
      var $917=$2;
      var $918=$3;
      var $919=$918 & 3840;
      var $920=$5;
      var $921=(($920+1)|0);
      $5=$921;
      var $922=HEAPU8[($920)];
      var $923=(($922)&255);
      var $924=$919 | $923;
      var $925=_sprintf($917, ((STRING_TABLE.__str1946809)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$924,tempInt));
      __label__ = 275; break;
    case 225: // $926
      var $927=$2;
      var $928=$5;
      var $929=(($928+1)|0);
      $5=$929;
      var $930=HEAPU8[($928)];
      var $931=(($930)&255);
      var $932=_sprintf($927, ((STRING_TABLE.__str1956810)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$931,tempInt));
      __label__ = 275; break;
    case 226: // $933
      var $934=$2;
      var $935=$5;
      var $936=(($935+1)|0);
      $5=$936;
      var $937=HEAPU8[($935)];
      var $938=(($937)&255);
      var $939=_sprintf($934, ((STRING_TABLE.__str1966811)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$938,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 227: // $940
      var $941=$2;
      var $942=_sprintf($941, ((STRING_TABLE.__str1976812)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 228: // $943
      var $944=$6;
      var $945=(($944)|0)!=0;
      if ($945) { __label__ = 230; break; } else { __label__ = 229; break; }
    case 229: // $946
      var $947=$2;
      var $948=_sprintf($947, ((STRING_TABLE.__str86623)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 231; break;
    case 230: // $949
      var $950=$2;
      var $951=$3;
      var $952=$951 & 3840;
      var $953=$5;
      var $954=(($953+1)|0);
      $5=$954;
      var $955=HEAPU8[($953)];
      var $956=(($955)&255);
      var $957=$952 | $956;
      var $958=_sprintf($950, ((STRING_TABLE.__str1986813)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$957,tempInt));
      __label__ = 231; break;
    case 231: // $959
      __label__ = 275; break;
    case 232: // $960
      var $961=$2;
      var $962=_sprintf($961, ((STRING_TABLE.__str1996814)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 233: // $963
      var $964=$2;
      var $965=_sprintf($964, ((STRING_TABLE.__str2006815)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 234: // $966
      var $967=$2;
      var $968=_sprintf($967, ((STRING_TABLE.__str2016816)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 235: // $969
      var $970=$2;
      var $971=_sprintf($970, ((STRING_TABLE.__str2026817)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 236: // $972
      var $973=$2;
      var $974=_sprintf($973, ((STRING_TABLE.__str2036818)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 237: // $975
      var $976=$2;
      var $977=_sprintf($976, ((STRING_TABLE.__str2046819)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 238: // $978
      var $979=$2;
      var $980=_sprintf($979, ((STRING_TABLE.__str2056820)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 239: // $981
      var $982=$2;
      var $983=_sprintf($982, ((STRING_TABLE.__str2066821)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 240: // $984
      var $985=$2;
      var $986=_sprintf($985, ((STRING_TABLE.__str2076822)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 241: // $987
      var $988=$2;
      var $989=_sprintf($988, ((STRING_TABLE.__str2086823)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 242: // $990
      var $991=$2;
      var $992=$5;
      var $993=(($992+1)|0);
      $5=$993;
      var $994=HEAPU8[($992)];
      var $995=(($994)&255);
      var $996=_sprintf($991, ((STRING_TABLE.__str2096824)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$995,tempInt));
      __label__ = 275; break;
    case 243: // $997
      var $998=$6;
      var $999=(($998)|0)!=0;
      if ($999) { __label__ = 245; break; } else { __label__ = 244; break; }
    case 244: // $1000
      var $1001=$2;
      var $1002=_sprintf($1001, ((STRING_TABLE.__str2106825)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 246; break;
    case 245: // $1003
      var $1004=$2;
      var $1005=_sprintf($1004, ((STRING_TABLE.__str2116826)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 246; break;
    case 246: // $1006
      __label__ = 275; break;
    case 247: // $1007
      var $1008=$2;
      var $1009=$3;
      var $1010=$1009 & 3840;
      var $1011=$5;
      var $1012=(($1011+1)|0);
      $5=$1012;
      var $1013=HEAPU8[($1011)];
      var $1014=(($1013)&255);
      var $1015=$1010 | $1014;
      var $1016=_sprintf($1008, ((STRING_TABLE.__str2126827)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1015,tempInt));
      __label__ = 275; break;
    case 248: // $1017
      var $1018=$2;
      var $1019=_sprintf($1018, ((STRING_TABLE.__str2136828)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 249: // $1020
      var $1021=$2;
      var $1022=$3;
      var $1023=$1022 & 3840;
      var $1024=$5;
      var $1025=(($1024+1)|0);
      $5=$1025;
      var $1026=HEAPU8[($1024)];
      var $1027=(($1026)&255);
      var $1028=$1023 | $1027;
      var $1029=_sprintf($1021, ((STRING_TABLE.__str2146829)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1028,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 250: // $1030
      var $1031=$2;
      var $1032=$3;
      var $1033=$1032 & 3840;
      var $1034=$5;
      var $1035=(($1034+1)|0);
      $5=$1035;
      var $1036=HEAPU8[($1034)];
      var $1037=(($1036)&255);
      var $1038=$1033 | $1037;
      var $1039=_sprintf($1031, ((STRING_TABLE.__str2156830)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1038,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 251: // $1040
      var $1041=$2;
      var $1042=$3;
      var $1043=$1042 & 3840;
      var $1044=$5;
      var $1045=(($1044+1)|0);
      $5=$1045;
      var $1046=HEAPU8[($1044)];
      var $1047=(($1046)&255);
      var $1048=$1043 | $1047;
      var $1049=_sprintf($1041, ((STRING_TABLE.__str2166831)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1048,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 252: // $1050
      var $1051=$2;
      var $1052=$3;
      var $1053=$1052 & 3840;
      var $1054=$5;
      var $1055=(($1054+1)|0);
      $5=$1055;
      var $1056=HEAPU8[($1054)];
      var $1057=(($1056)&255);
      var $1058=$1053 | $1057;
      var $1059=_sprintf($1051, ((STRING_TABLE.__str2176832)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1058,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 253: // $1060
      var $1061=$2;
      var $1062=$3;
      var $1063=$1062 & 3840;
      var $1064=$5;
      var $1065=(($1064+1)|0);
      $5=$1065;
      var $1066=HEAPU8[($1064)];
      var $1067=(($1066)&255);
      var $1068=$1063 | $1067;
      var $1069=_sprintf($1061, ((STRING_TABLE.__str2186833)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1068,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 254: // $1070
      var $1071=$2;
      var $1072=$3;
      var $1073=$1072 & 3840;
      var $1074=$5;
      var $1075=(($1074+1)|0);
      $5=$1075;
      var $1076=HEAPU8[($1074)];
      var $1077=(($1076)&255);
      var $1078=$1073 | $1077;
      var $1079=_sprintf($1071, ((STRING_TABLE.__str2196834)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1078,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 255: // $1080
      var $1081=$2;
      var $1082=$3;
      var $1083=$1082 & 3840;
      var $1084=$5;
      var $1085=(($1084+1)|0);
      $5=$1085;
      var $1086=HEAPU8[($1084)];
      var $1087=(($1086)&255);
      var $1088=$1083 | $1087;
      var $1089=_sprintf($1081, ((STRING_TABLE.__str2206835)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1088,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 256: // $1090
      var $1091=$2;
      var $1092=$3;
      var $1093=$1092 & 3840;
      var $1094=$5;
      var $1095=(($1094+1)|0);
      $5=$1095;
      var $1096=HEAPU8[($1094)];
      var $1097=(($1096)&255);
      var $1098=$1093 | $1097;
      var $1099=_sprintf($1091, ((STRING_TABLE.__str2216836)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1098,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 257: // $1100
      var $1101=$2;
      var $1102=_sprintf($1101, ((STRING_TABLE.__str2226837)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 258: // $1103
      var $1104=$2;
      var $1105=_sprintf($1104, ((STRING_TABLE.__str2236838)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 259: // $1106
      var $1107=$2;
      var $1108=$3;
      var $1109=$1108 & 3840;
      var $1110=$5;
      var $1111=(($1110+1)|0);
      $5=$1111;
      var $1112=HEAPU8[($1110)];
      var $1113=(($1112)&255);
      var $1114=$1109 | $1113;
      var $1115=_sprintf($1107, ((STRING_TABLE.__str2246839)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1114,tempInt));
      __label__ = 275; break;
    case 260: // $1116
      var $1117=$2;
      var $1118=$5;
      var $1119=(($1118+1)|0);
      $5=$1119;
      var $1120=HEAPU8[($1118)];
      var $1121=(($1120)&255);
      var $1122=_sprintf($1117, ((STRING_TABLE.__str2256840)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1121,tempInt));
      $flags=536870912;
      __label__ = 275; break;
    case 261: // $1123
      var $1124=$6;
      var $1125=(($1124)|0)!=0;
      if ($1125) { __label__ = 263; break; } else { __label__ = 262; break; }
    case 262: // $1126
      var $1127=$2;
      var $1128=_sprintf($1127, ((STRING_TABLE.__str2266841)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 264; break;
    case 263: // $1129
      var $1130=$2;
      var $1131=_sprintf($1130, ((STRING_TABLE.__str2276842)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 264; break;
    case 264: // $1132
      __label__ = 275; break;
    case 265: // $1133
      var $1134=$2;
      var $1135=$3;
      var $1136=$1135 & 3840;
      var $1137=$5;
      var $1138=(($1137+1)|0);
      $5=$1138;
      var $1139=HEAPU8[($1137)];
      var $1140=(($1139)&255);
      var $1141=$1136 | $1140;
      var $1142=_sprintf($1134, ((STRING_TABLE.__str2286843)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$1141,tempInt));
      __label__ = 275; break;
    case 266: // $1143
      var $1144=$2;
      var $1145=_sprintf($1144, ((STRING_TABLE.__str2296844)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 267: // $1146
      var $1147=$2;
      var $1148=_sprintf($1147, ((STRING_TABLE.__str2306845)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 268: // $1149
      var $1150=$2;
      var $1151=_sprintf($1150, ((STRING_TABLE.__str2316846)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 269: // $1152
      var $1153=$2;
      var $1154=_sprintf($1153, ((STRING_TABLE.__str2326847)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 270: // $1155
      var $1156=$2;
      var $1157=_sprintf($1156, ((STRING_TABLE.__str2336848)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 271: // $1158
      var $1159=$2;
      var $1160=_sprintf($1159, ((STRING_TABLE.__str2346849)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 272: // $1161
      var $1162=$2;
      var $1163=_sprintf($1162, ((STRING_TABLE.__str2356850)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 273: // $1164
      var $1165=$2;
      var $1166=_sprintf($1165, ((STRING_TABLE.__str2366851)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 274: // $1167
      var $1168=$2;
      var $1169=_sprintf($1168, ((STRING_TABLE.__str2376852)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 275; break;
    case 275: // $1170
      var $1171=$5;
      var $1172=$startram;
      var $1173=$1171;
      var $1174=$1172;
      var $1175=(($1173-$1174)|0);
      var $1176=$flags;
      var $1177=$1175 | $1176;
      var $1178=$1177 | -2147483648;
      ;
      return $1178;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11common_dasmP8device_tPcjPKhS3_i["X"]=1;

function __Z21cpu_disassemble_upi41P17legacy_cpu_devicePcjPKhS3_i($device, $buffer, $pc, $oprom, $opram, $options) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$device;
  $2=$buffer;
  $3=$pc;
  $4=$oprom;
  $5=$opram;
  $6=$options;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=__ZL11common_dasmP8device_tPcjPKhS3_i($8, $9, $10, $11, $12, 1);
  ;
  return $13;
}


function __ZNK11emu_options7samplesEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=__ZNK12core_options10bool_valueEPKc($3, ((STRING_TABLE.__str206916)|0));
  ;
  return $4;
}


function __ZL14get_safe_tokenP8device_t6917($device) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$device;
      __label__ = 1; break;
    case 1: // $2
      __label__ = 2; break;
    case 2: // $3
      __label__ = 3; break;
    case 3: // $4
      __label__ = 4; break;
    case 4: // $5
      var $6=$1;
      var $7=__Z8downcastIP18legacy_device_base8device_tET_PT0_($6);
      var $8=__ZNK18legacy_device_base5tokenEv($7);
      var $9=$8;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z25device_get_config_samplesPK8device_tjP10deviceinfo($device, $state, $info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$device;
      $2=$state;
      $3=$info;
      var $4=$2;
      if ($4 == 0) {
        __label__ = 1; break;
      }
      else if ($4 == 131072) {
        __label__ = 2; break;
      }
      else if ($4 == 131073 || $4 == 131074) {
        __label__ = 8; break;
      }
      else if ($4 == 196608) {
        __label__ = 3; break;
      }
      else if ($4 == 196610) {
        __label__ = 4; break;
      }
      else if ($4 == 196611) {
        __label__ = 5; break;
      }
      else if ($4 == 196612) {
        __label__ = 6; break;
      }
      else if ($4 == 196613) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 1: // $5
      var $6=$3;
      var $7=$6;
      var $$emscripten$temp$0$0=16;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($7)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($7+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 8; break;
    case 2: // $8
      var $9=$3;
      var $10=$9;
      HEAP32[(($10)>>2)]=1456;
      __label__ = 8; break;
    case 3: // $11
      var $12=$3;
      var $13=$12;
      var $14=HEAP32[(($13)>>2)];
      var $15=_strcpy($14, ((STRING_TABLE.__str26896)|0));
      __label__ = 8; break;
    case 4: // $16
      var $17=$3;
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=_strcpy($19, ((STRING_TABLE.__str36897)|0));
      __label__ = 8; break;
    case 5: // $21
      var $22=$3;
      var $23=$22;
      var $24=HEAP32[(($23)>>2)];
      var $25=_strcpy($24, ((STRING_TABLE.__str46898)|0));
      __label__ = 8; break;
    case 6: // $26
      var $27=$3;
      var $28=$27;
      var $29=HEAP32[(($28)>>2)];
      var $30=_strcpy($29, ((STRING_TABLE.__str6894)|0));
      __label__ = 8; break;
    case 7: // $31
      var $32=$3;
      var $33=$32;
      var $34=HEAP32[(($33)>>2)];
      var $35=_strcpy($34, ((STRING_TABLE.__str56899)|0));
      __label__ = 8; break;
    case 8: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z11readsamplesR15running_machinePKPKcS2_($machine, $samplenames, $basename) {
  var __stackBase__  = STACKTOP; STACKTOP += 288; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $samples;
      var $skipfirst;
      var $i;
      var $file=__stackBase__+28;
      var $filerr;
      var $11;
      var $12;
      $8=$machine;
      $9=$samplenames;
      $10=$basename;
      $skipfirst=0;
      var $13=$8;
      var $14=__ZNK15running_machine7optionsEv($13);
      var $15=__ZNK11emu_options7samplesEv($14);
      if ($15) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $16
      $7=0;
      __label__ = 37; break;
    case 2: // $17
      var $18=$9;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=$9;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)==0;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      $7=0;
      __label__ = 37; break;
    case 5: // $26
      var $27=$9;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24);
      var $33=(($32)|0)==42;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $skipfirst=1;
      __label__ = 7; break;
    case 7: // $35
      $i=0;
      __label__ = 8; break;
    case 8: // $36
      var $37=$i;
      var $38=$skipfirst;
      var $39=(($37+$38)|0);
      var $40=$9;
      var $41=(($40+($39<<2))|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $44
      __label__ = 10; break;
    case 10: // $45
      var $46=$i;
      var $47=(($46+1)|0);
      $i=$47;
      __label__ = 8; break;
    case 11: // $48
      var $49=$i;
      var $50=(($49)|0)==0;
      if ($50) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $51
      $7=0;
      __label__ = 37; break;
    case 13: // $52
      var $53=$8;
      var $54=__ZN15running_machine7respoolEv($53);
      var $55=$i;
      var $56=(($55-1)|0);
      var $57=(($56*12)|0);
      var $58=(($57+16)|0);
      var $59=$1;
      var $60=$2;
      var $61=$3;
      var $62=$4;
      var $63=$result_i;
      var $64=$5;
      var $65=$6;
      HEAP32[(($1)>>2)]=$58;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str6894)|0);
      HEAP32[(($3)>>2)]=202;
      HEAP32[(($4)>>2)]=_zeromem;
      var $66=HEAP32[(($1)>>2)];
      var $67=HEAP32[(($2)>>2)];
      var $68=HEAP32[(($3)>>2)];
      var $69=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($66, $67, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; };
    case 14: // $70
      HEAP32[(($result_i)>>2)]=$69;
      var $71=HEAP32[(($result_i)>>2)];
      var $72=(($71)|0)==0;
      if ($72) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $73
      var $74=___cxa_allocate_exception(4);
      var $75=$74;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($75);
      (function() { try { __THREW__ = false; return ___cxa_throw($74, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 16; break; }
    case 16: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      HEAP32[(($5)>>2)]=$78;
      var $79=$77.f1;
      HEAP32[(($6)>>2)]=$79;
      var $80=HEAP32[(($6)>>2)];
      var $81=(($80)|0) < 0;
      if ($81) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $82
      var $83=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($83);
      throw "Reached an unreachable!"
    case 18: // $84
      var $85=HEAP32[(($5)>>2)];
      var $86=HEAP32[(($5)>>2)];
      var $87=HEAP32[(($6)>>2)];
      var $88=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $86, tempValue);
      var $89=($88.f1 = $87, $88);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $90
      throw "Reached an unreachable!"
    case 20: // $_ZnajPKciRK9zeromem_t_exit
      var $91=HEAP32[(($result_i)>>2)];
      var $92=HEAP32[(($1)>>2)];
      _memset($91, 0, $92, 1);
      var $93=HEAP32[(($result_i)>>2)];
      var $94=$1;
      var $95=$2;
      var $96=$3;
      var $97=$4;
      var $98=$result_i;
      var $99=$5;
      var $100=$6;
      var $101=$i;
      var $102=(($101-1)|0);
      var $103=(($102*12)|0);
      var $104=(($103+16)|0);
      var $105=__ZN13resource_pool9add_arrayIhEEPT_S2_i($54, $93, $104);
      var $106=$105;
      $samples=$106;
      var $107=$i;
      var $108=$samples;
      var $109=(($108)|0);
      HEAP32[(($109)>>2)]=$107;
      $i=0;
      __label__ = 21; break;
    case 21: // $110
      var $111=$i;
      var $112=$samples;
      var $113=(($112)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($111)|0) < (($114)|0);
      if ($115) { __label__ = 22; break; } else { __label__ = 36; break; }
    case 22: // $116
      var $117=$i;
      var $118=$skipfirst;
      var $119=(($117+$118)|0);
      var $120=$9;
      var $121=(($120+($119<<2))|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122)|0);
      var $124=HEAP8[($123)];
      var $125=(($124 << 24) >> 24)!=0;
      if ($125) { __label__ = 23; break; } else { __label__ = 34; break; }
    case 23: // $126
      var $127=$8;
      var $128=__ZNK15running_machine7optionsEv($127);
      var $129=__ZNK11emu_options11sample_pathEv($128);
      FUNCTION_TABLE[__ZN8emu_fileC1EPKcj]($file, $129, 1);
      var $130=$10;
      var $131=$i;
      var $132=$skipfirst;
      var $133=(($131+$132)|0);
      var $134=$9;
      var $135=(($134+($133<<2))|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_S1_($file, $130, ((STRING_TABLE.__str16895)|0), $136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 28; break; };
    case 24: // $138
      $filerr=$137;
      var $139=$filerr;
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 25; break; } else { __label__ = 29; break; }
    case 25: // $141
      var $142=$skipfirst;
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $144
      var $145=$9;
      var $146=(($145)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+1)|0);
      var $149=$i;
      var $150=$skipfirst;
      var $151=(($149+$150)|0);
      var $152=$9;
      var $153=(($152+($151<<2))|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(function() { try { __THREW__ = false; return __ZN8emu_file4openEPKcS1_S1_($file, $148, ((STRING_TABLE.__str16895)|0), $154) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 28; break; };
    case 27: // $156
      $filerr=$155;
      __label__ = 29; break;
    case 28: // $157
      var $158=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $159=$158.f0;
      $11=$159;
      var $160=$158.f1;
      $12=$160;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 39; break; }
    case 29: // $161
      var $162=$filerr;
      var $163=(($162)|0)==0;
      if ($163) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $164
      var $165=$8;
      var $166=$i;
      var $167=$samples;
      var $168=(($167+4)|0);
      var $169=(($168+$166*12)|0);
      var $170=(function() { try { __THREW__ = false; return __ZL15read_wav_sampleR15running_machineR8emu_fileP14_loaded_sample($165, $file, $169) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 28; break; };
    case 31: // $171
      __label__ = 32; break;
    case 32: // $172
      FUNCTION_TABLE[__ZN8emu_fileD1Ev]($file);
      __label__ = 34; break;
    case 33: // $173
      __label__ = 38; break;
    case 34: // $174
      __label__ = 35; break;
    case 35: // $175
      var $176=$i;
      var $177=(($176+1)|0);
      $i=$177;
      __label__ = 21; break;
    case 36: // $178
      var $179=$samples;
      $7=$179;
      __label__ = 37; break;
    case 37: // $180
      var $181=$7;
      STACKTOP = __stackBase__;
      return $181;
    case 38: // $182
      var $183=$11;
      var $184=$11;
      var $185=$12;
      var $186=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $184, tempValue);
      var $187=($186.f1 = $185, $186);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 39: // $188
      var $189=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11readsamplesR15running_machinePKPKcS2_["X"]=1;

function __ZL15read_wav_sampleR15running_machineR8emu_fileP14_loaded_sample($machine, $file, $sample) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i2=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $result_i=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11;
      var $12;
      var $13;
      var $14;
      var $offset;
      var $length=__stackBase__+48;
      var $rate=__stackBase__+52;
      var $filesize=__stackBase__+56;
      var $bits=__stackBase__+60;
      var $temp16=__stackBase__+64;
      var $buf=__stackBase__+68;
      var $sindex;
      var $tempptr;
      var $sindex1;
      $12=$machine;
      $13=$file;
      $14=$sample;
      $offset=0;
      var $15=$13;
      var $16=(($buf)|0);
      var $17=__ZN8emu_file4readEPvj($15, $16, 4);
      var $18=$offset;
      var $19=(($18+$17)|0);
      $offset=$19;
      var $20=$offset;
      var $21=(($20)>>>0) < 4;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      $11=0;
      __label__ = 53; break;
    case 2: // $23
      var $24=(($buf)|0);
      var $25=_memcmp($24, ((STRING_TABLE.__str156911)|0), 4);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      $11=0;
      __label__ = 53; break;
    case 4: // $28
      var $29=$13;
      var $30=$filesize;
      var $31=__ZN8emu_file4readEPvj($29, $30, 4);
      var $32=$offset;
      var $33=(($32+$31)|0);
      $offset=$33;
      var $34=$offset;
      var $35=(($34)>>>0) < 8;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      $11=0;
      __label__ = 53; break;
    case 6: // $37
      var $38=HEAP32[(($filesize)>>2)];
      HEAP32[(($filesize)>>2)]=$38;
      var $39=$13;
      var $40=(($buf)|0);
      var $41=__ZN8emu_file4readEPvj($39, $40, 4);
      var $42=$offset;
      var $43=(($42+$41)|0);
      $offset=$43;
      var $44=$offset;
      var $45=(($44)>>>0) < 12;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      $11=0;
      __label__ = 53; break;
    case 8: // $47
      var $48=(($buf)|0);
      var $49=_memcmp($48, ((STRING_TABLE.__str166912)|0), 4);
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $51
      $11=0;
      __label__ = 53; break;
    case 10: // $52
      __label__ = 11; break;
    case 11: // $53
      var $54=$13;
      var $55=(($buf)|0);
      var $56=__ZN8emu_file4readEPvj($54, $55, 4);
      var $57=$offset;
      var $58=(($57+$56)|0);
      $offset=$58;
      var $59=$13;
      var $60=$length;
      var $61=__ZN8emu_file4readEPvj($59, $60, 4);
      var $62=$offset;
      var $63=(($62+$61)|0);
      $offset=$63;
      var $64=HEAP32[(($length)>>2)];
      HEAP32[(($length)>>2)]=$64;
      var $65=(($buf)|0);
      var $66=_memcmp($65, ((STRING_TABLE.__str176913)|0), 4);
      var $67=(($66)|0)==0;
      if ($67) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $68
      __label__ = 16; break;
    case 13: // $69
      var $70=$13;
      var $71=HEAP32[(($length)>>2)];
      var $72$0=$71;
      var $72$1=0;
      var $73=__ZN8emu_file4seekExi($70, $72$0, $72$1, 1);
      var $73$0=$73[0];
      var $74=HEAP32[(($length)>>2)];
      var $75=$offset;
      var $76=(($75+$74)|0);
      $offset=$76;
      var $77=$offset;
      var $78=HEAPU32[(($filesize)>>2)];
      var $79=(($77)>>>0) >= (($78)>>>0);
      if ($79) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $80
      $11=0;
      __label__ = 53; break;
    case 15: // $81
      __label__ = 11; break;
    case 16: // $82
      var $83=$13;
      var $84=$temp16;
      var $85=__ZN8emu_file4readEPvj($83, $84, 2);
      var $86=$offset;
      var $87=(($86+$85)|0);
      $offset=$87;
      var $88=HEAP16[(($temp16)>>1)];
      HEAP16[(($temp16)>>1)]=$88;
      var $89=HEAPU16[(($temp16)>>1)];
      var $90=(($89)&65535);
      var $91=(($90)|0)!=1;
      if ($91) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $92
      $11=0;
      __label__ = 53; break;
    case 18: // $93
      var $94=$13;
      var $95=$temp16;
      var $96=__ZN8emu_file4readEPvj($94, $95, 2);
      var $97=$offset;
      var $98=(($97+$96)|0);
      $offset=$98;
      var $99=HEAP16[(($temp16)>>1)];
      HEAP16[(($temp16)>>1)]=$99;
      var $100=HEAPU16[(($temp16)>>1)];
      var $101=(($100)&65535);
      var $102=(($101)|0)!=1;
      if ($102) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $103
      $11=0;
      __label__ = 53; break;
    case 20: // $104
      var $105=$13;
      var $106=$rate;
      var $107=__ZN8emu_file4readEPvj($105, $106, 4);
      var $108=$offset;
      var $109=(($108+$107)|0);
      $offset=$109;
      var $110=HEAP32[(($rate)>>2)];
      HEAP32[(($rate)>>2)]=$110;
      var $111=$13;
      var $112=(($buf)|0);
      var $113=__ZN8emu_file4readEPvj($111, $112, 6);
      var $114=$offset;
      var $115=(($114+$113)|0);
      $offset=$115;
      var $116=$13;
      var $117=$bits;
      var $118=__ZN8emu_file4readEPvj($116, $117, 2);
      var $119=$offset;
      var $120=(($119+$118)|0);
      $offset=$120;
      var $121=HEAP16[(($bits)>>1)];
      HEAP16[(($bits)>>1)]=$121;
      var $122=HEAPU16[(($bits)>>1)];
      var $123=(($122)&65535);
      var $124=(($123)|0)!=8;
      if ($124) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $125
      var $126=HEAPU16[(($bits)>>1)];
      var $127=(($126)&65535);
      var $128=(($127)|0)!=16;
      if ($128) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $129
      $11=0;
      __label__ = 53; break;
    case 23: // $130
      var $131=$13;
      var $132=HEAP32[(($length)>>2)];
      var $133=(($132-16)|0);
      var $134$0=$133;
      var $134$1=0;
      var $135=__ZN8emu_file4seekExi($131, $134$0, $134$1, 1);
      var $135$0=$135[0];
      var $136=HEAP32[(($length)>>2)];
      var $137=(($136-16)|0);
      var $138=$offset;
      var $139=(($138+$137)|0);
      $offset=$139;
      __label__ = 24; break;
    case 24: // $140
      var $141=$13;
      var $142=(($buf)|0);
      var $143=__ZN8emu_file4readEPvj($141, $142, 4);
      var $144=$offset;
      var $145=(($144+$143)|0);
      $offset=$145;
      var $146=$13;
      var $147=$length;
      var $148=__ZN8emu_file4readEPvj($146, $147, 4);
      var $149=$offset;
      var $150=(($149+$148)|0);
      $offset=$150;
      var $151=HEAP32[(($length)>>2)];
      HEAP32[(($length)>>2)]=$151;
      var $152=(($buf)|0);
      var $153=_memcmp($152, ((STRING_TABLE.__str186914)|0), 4);
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $155
      __label__ = 29; break;
    case 26: // $156
      var $157=$13;
      var $158=HEAP32[(($length)>>2)];
      var $159$0=$158;
      var $159$1=0;
      var $160=__ZN8emu_file4seekExi($157, $159$0, $159$1, 1);
      var $160$0=$160[0];
      var $161=HEAP32[(($length)>>2)];
      var $162=$offset;
      var $163=(($162+$161)|0);
      $offset=$163;
      var $164=$offset;
      var $165=HEAPU32[(($filesize)>>2)];
      var $166=(($164)>>>0) >= (($165)>>>0);
      if ($166) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $167
      $11=0;
      __label__ = 53; break;
    case 28: // $168
      __label__ = 24; break;
    case 29: // $169
      var $170=HEAP32[(($length)>>2)];
      var $171=(($170)|0)==0;
      if ($171) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $172
      $11=0;
      __label__ = 53; break;
    case 31: // $173
      var $174=HEAP32[(($length)>>2)];
      var $175=$14;
      var $176=(($175)|0);
      HEAP32[(($176)>>2)]=$174;
      var $177=HEAP32[(($rate)>>2)];
      var $178=$14;
      var $179=(($178+4)|0);
      HEAP32[(($179)>>2)]=$177;
      var $180=HEAPU16[(($bits)>>1)];
      var $181=(($180)&65535);
      var $182=(($181)|0)==8;
      if ($182) { __label__ = 32; break; } else { __label__ = 44; break; }
    case 32: // $183
      var $184=$12;
      var $185=__ZN15running_machine7respoolEv($184);
      var $186=HEAP32[(($length)>>2)];
      var $187=_llvm_umul_with_overflow_i32($186, 2);
      var $188=$187.f1;
      var $189=$187.f0;
      var $190=$188 ? -1 : $189;
      var $191=$6;
      var $192=$7;
      var $193=$8;
      var $194=$result_i;
      var $195=$9;
      var $196=$10;
      HEAP32[(($6)>>2)]=$190;
      HEAP32[(($7)>>2)]=((STRING_TABLE.__str6894)|0);
      HEAP32[(($8)>>2)]=154;
      var $197=HEAP32[(($6)>>2)];
      var $198=HEAP32[(($7)>>2)];
      var $199=HEAP32[(($8)>>2)];
      var $200=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($197, $198, $199) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 35; break; };
    case 33: // $201
      HEAP32[(($result_i)>>2)]=$200;
      var $202=HEAP32[(($result_i)>>2)];
      var $203=(($202)|0)==0;
      if ($203) { __label__ = 34; break; } else { __label__ = 39; break; }
    case 34: // $204
      var $205=___cxa_allocate_exception(4);
      var $206=$205;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($206);
      (function() { try { __THREW__ = false; return ___cxa_throw($205, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $207
      var $208=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $209=$208.f0;
      HEAP32[(($9)>>2)]=$209;
      var $210=$208.f1;
      HEAP32[(($10)>>2)]=$210;
      var $211=HEAP32[(($10)>>2)];
      var $212=(($211)|0) < 0;
      if ($212) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $213
      var $214=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($214);
      throw "Reached an unreachable!"
    case 37: // $215
      var $216=HEAP32[(($9)>>2)];
      var $217=HEAP32[(($9)>>2)];
      var $218=HEAP32[(($10)>>2)];
      var $219=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $217, tempValue);
      var $220=($219.f1 = $218, $219);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 38: // $221
      throw "Reached an unreachable!"
    case 39: // $_ZnajPKci_exit
      var $222=HEAP32[(($result_i)>>2)];
      var $223=$6;
      var $224=$7;
      var $225=$8;
      var $226=$result_i;
      var $227=$9;
      var $228=$10;
      var $229=$222;
      var $230=HEAP32[(($length)>>2)];
      var $231=__ZN13resource_pool9add_arrayIsEEPT_S2_i($185, $229, $230);
      var $232=$14;
      var $233=(($232+8)|0);
      HEAP32[(($233)>>2)]=$231;
      var $234=$13;
      var $235=$14;
      var $236=(($235+8)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=$237;
      var $239=HEAP32[(($length)>>2)];
      var $240=__ZN8emu_file4readEPvj($234, $238, $239);
      var $241=$14;
      var $242=(($241+8)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=$243;
      $tempptr=$244;
      var $245=HEAP32[(($length)>>2)];
      var $246=(($245-1)|0);
      $sindex1=$246;
      __label__ = 40; break;
    case 40: // $247
      var $248=$sindex1;
      var $249=(($248)|0) >= 0;
      if ($249) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $250
      var $251=$sindex1;
      var $252=$tempptr;
      var $253=(($252+$251)|0);
      var $254=HEAPU8[($253)];
      var $255=(($254)&255);
      var $256=$255 ^ 128;
      var $257=(($256) & 255);
      var $258=(($257 << 24) >> 24);
      var $259=((($258<<8))|0);
      var $260=(($259) & 65535);
      var $261=$sindex1;
      var $262=$14;
      var $263=(($262+8)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(($264+($261<<1))|0);
      HEAP16[(($265)>>1)]=$260;
      __label__ = 42; break;
    case 42: // $266
      var $267=$sindex1;
      var $268=(($267-1)|0);
      $sindex1=$268;
      __label__ = 40; break;
    case 43: // $269
      __label__ = 52; break;
    case 44: // $270
      var $271=$12;
      var $272=__ZN15running_machine7respoolEv($271);
      var $273=HEAPU32[(($length)>>2)];
      var $274=Math.floor((($273)>>>0)/2);
      var $275=_llvm_umul_with_overflow_i32($274, 2);
      var $276=$275.f1;
      var $277=$275.f0;
      var $278=$276 ? -1 : $277;
      var $279=$1;
      var $280=$2;
      var $281=$3;
      var $282=$result_i2;
      var $283=$4;
      var $284=$5;
      HEAP32[(($1)>>2)]=$278;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str6894)|0);
      HEAP32[(($3)>>2)]=165;
      var $285=HEAP32[(($1)>>2)];
      var $286=HEAP32[(($2)>>2)];
      var $287=HEAP32[(($3)>>2)];
      var $288=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($285, $286, $287) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 47; break; };
    case 45: // $289
      HEAP32[(($result_i2)>>2)]=$288;
      var $290=HEAP32[(($result_i2)>>2)];
      var $291=(($290)|0)==0;
      if ($291) { __label__ = 46; break; } else { __label__ = 51; break; }
    case 46: // $292
      var $293=___cxa_allocate_exception(4);
      var $294=$293;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($294);
      (function() { try { __THREW__ = false; return ___cxa_throw($293, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 47; break; }
    case 47: // $295
      var $296=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $297=$296.f0;
      HEAP32[(($4)>>2)]=$297;
      var $298=$296.f1;
      HEAP32[(($5)>>2)]=$298;
      var $299=HEAP32[(($5)>>2)];
      var $300=(($299)|0) < 0;
      if ($300) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $301
      var $302=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($302);
      throw "Reached an unreachable!"
    case 49: // $303
      var $304=HEAP32[(($4)>>2)];
      var $305=HEAP32[(($4)>>2)];
      var $306=HEAP32[(($5)>>2)];
      var $307=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $305, tempValue);
      var $308=($307.f1 = $306, $307);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $309
      throw "Reached an unreachable!"
    case 51: // $_ZnajPKci_exit3
      var $310=HEAP32[(($result_i2)>>2)];
      var $311=$1;
      var $312=$2;
      var $313=$3;
      var $314=$result_i2;
      var $315=$4;
      var $316=$5;
      var $317=$310;
      var $318=HEAPU32[(($length)>>2)];
      var $319=Math.floor((($318)>>>0)/2);
      var $320=__ZN13resource_pool9add_arrayIsEEPT_S2_i($272, $317, $319);
      var $321=$14;
      var $322=(($321+8)|0);
      HEAP32[(($322)>>2)]=$320;
      var $323=$13;
      var $324=$14;
      var $325=(($324+8)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=$326;
      var $328=HEAP32[(($length)>>2)];
      var $329=__ZN8emu_file4readEPvj($323, $327, $328);
      var $330=$14;
      var $331=(($330)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=(((($332)|0)/2)|0);
      HEAP32[(($331)>>2)]=$333;
      __label__ = 52; break;
    case 52: // $334
      $11=1;
      __label__ = 53; break;
    case 53: // $335
      var $336=$11;
      STACKTOP = __stackBase__;
      return $336;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15read_wav_sampleR15running_machineR8emu_fileP14_loaded_sample["X"]=1;

function __ZN14samples_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j($this, $mconfig, $type, $tag, $owner, $clock) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  $1=$this;
  $2=$mconfig;
  $3=$type;
  $4=$tag;
  $5=$owner;
  $6=$clock;
  var $7=$1;
  var $8=$7;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  __ZN24legacy_sound_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE($8, $9, $10, $11, $12, $13, 1464);
  var $14=$7;
  HEAP32[(($14)>>2)]=((__ZTV14samples_device+8)|0);
  var $15=$7;
  var $16=(($15+368)|0);
  var $17=$16;
  HEAP32[(($17)>>2)]=((__ZTV14samples_device+80)|0);
  ;
  return;
}


function __ZN14samples_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN14samples_deviceD2Ev($2);
  ;
  return;
}


function __ZThn368_N14samples_deviceD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN14samples_deviceD1Ev($5);
  ;
  return;
}


function __ZThn368_N14samples_deviceD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3-368)|0);
  var $5=$4;
  __ZN14samples_deviceD0Ev($5);
  ;
  return;
}


function __ZN14samples_deviceD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZN24legacy_sound_device_baseD2Ev($3);
  ;
  return;
}


function __ZN20resource_pool_objectI14samples_deviceEC1EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$2;
  __ZN20resource_pool_objectI14samples_deviceEC2EPS0_($3, $4);
  ;
  return;
}


function __ZN20resource_pool_objectI14samples_deviceEC2EPS0_($this, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$object;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=$5;
  __ZN18resource_pool_itemC2EPvj($4, $6, 408);
  var $7=$3;
  HEAP32[(($7)>>2)]=((__ZTV20resource_pool_objectI14samples_deviceE+8)|0);
  var $8=(($3+32)|0);
  var $9=$2;
  HEAP32[(($8)>>2)]=$9;
  ;
  return;
}


function __ZN20resource_pool_objectI14samples_deviceED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN20resource_pool_objectI14samples_deviceED2Ev($2);
  ;
  return;
}


function __ZL20device_start_samplesP8device_t($device) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $result_i=__stackBase__+12;
      var $4=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6;
      var $i;
      var $intf;
      var $info;
      var $7=__stackBase__+24;
      $6=$device;
      var $8=$6;
      var $9=__ZNK8device_t13static_configEv($8);
      var $10=$9;
      $intf=$10;
      var $11=$6;
      var $12=__ZL14get_safe_tokenP8device_t6917($11);
      $info=$12;
      var $13=$6;
      var $14=$info;
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$intf;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$6;
      var $22=__ZNK8device_t7machineEv($21);
      var $23=$intf;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$6;
      var $27=__ZNK8device_t7machineEv($26);
      var $28=__ZNK15running_machine6systemEv($27);
      var $29=(($28+8)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=__Z11readsamplesR15running_machinePKPKcS2_($22, $25, $30);
      var $32=$info;
      var $33=(($32+12)|0);
      HEAP32[(($33)>>2)]=$31;
      __label__ = 2; break;
    case 2: // $34
      var $35=$intf;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$info;
      var $39=(($38+4)|0);
      HEAP32[(($39)>>2)]=$37;
      __label__ = 3; break;
    case 3: // $40
      __label__ = 4; break;
    case 4: // $41
      var $42=$6;
      var $43=__ZNK8device_t7machineEv($42);
      var $44=__ZN15running_machine7respoolEv($43);
      var $45=$info;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=_llvm_umul_with_overflow_i32($47, 36);
      var $49=$48.f1;
      var $50=$48.f0;
      var $51=$49 ? -1 : $50;
      var $52=$1;
      var $53=$2;
      var $54=$3;
      var $55=$result_i;
      var $56=$4;
      var $57=$5;
      HEAP32[(($1)>>2)]=$51;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str6894)|0);
      HEAP32[(($3)>>2)]=475;
      var $58=HEAP32[(($1)>>2)];
      var $59=HEAP32[(($2)>>2)];
      var $60=HEAP32[(($3)>>2)];
      var $61=(function() { try { __THREW__ = false; return __Z22malloc_array_file_linejPKci($58, $59, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $62
      HEAP32[(($result_i)>>2)]=$61;
      var $63=HEAP32[(($result_i)>>2)];
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $65
      var $66=___cxa_allocate_exception(4);
      var $67=$66;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($67);
      (function() { try { __THREW__ = false; return ___cxa_throw($66, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      HEAP32[(($4)>>2)]=$70;
      var $71=$69.f1;
      HEAP32[(($5)>>2)]=$71;
      var $72=HEAP32[(($5)>>2)];
      var $73=(($72)|0) < 0;
      if ($73) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $74
      var $75=HEAP32[(($4)>>2)];
      ___cxa_call_unexpected($75);
      throw "Reached an unreachable!"
    case 9: // $76
      var $77=HEAP32[(($4)>>2)];
      var $78=HEAP32[(($4)>>2)];
      var $79=HEAP32[(($5)>>2)];
      var $80=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $78, tempValue);
      var $81=($80.f1 = $79, $80);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $82
      throw "Reached an unreachable!"
    case 11: // $_ZnajPKci_exit
      var $83=HEAP32[(($result_i)>>2)];
      var $84=$1;
      var $85=$2;
      var $86=$3;
      var $87=$result_i;
      var $88=$4;
      var $89=$5;
      var $90=$83;
      var $91=$info;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=__ZN13resource_pool9add_arrayI15_sample_channelEEPT_S3_i($44, $90, $93);
      var $95=$info;
      var $96=(($95+8)|0);
      HEAP32[(($96)>>2)]=$94;
      $i=0;
      __label__ = 12; break;
    case 12: // $97
      var $98=$i;
      var $99=$info;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($98)|0) < (($101)|0);
      if ($102) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $103
      var $104=$6;
      var $105=__ZNK8device_t7machineEv($104);
      var $106=__ZNK15running_machine5soundEv($105);
      var $107=$6;
      var $108=$6;
      var $109=__ZNK8device_t7machineEv($108);
      var $110=__ZNK15running_machine11sample_rateEv($109);
      var $111=$i;
      var $112=$info;
      var $113=(($112+8)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114+$111*36)|0);
      var $116=$115;
      var $117=__ZN13sound_manager12stream_allocER8device_tiiiPvPFvPS0_P12sound_streamS2_PPiS7_iE($106, $107, 0, 1, $110, $116, 1460);
      var $118=$i;
      var $119=$info;
      var $120=(($119+8)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+$118*36)|0);
      var $123=(($122)|0);
      HEAP32[(($123)>>2)]=$117;
      var $124=$i;
      var $125=$info;
      var $126=(($125+8)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+$124*36)|0);
      var $129=(($128+4)|0);
      HEAP32[(($129)>>2)]=0;
      var $130=$i;
      var $131=$info;
      var $132=(($131+8)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+$130*36)|0);
      var $135=(($134+12)|0);
      HEAP32[(($135)>>2)]=-1;
      var $136=$i;
      var $137=$info;
      var $138=(($137+8)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139+$136*36)|0);
      var $141=(($140+24)|0);
      HEAP32[(($141)>>2)]=0;
      var $142=$i;
      var $143=$info;
      var $144=(($143+8)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145+$142*36)|0);
      var $147=(($146+32)|0);
      HEAP8[($147)]=0;
      var $148=$i;
      var $149=$info;
      var $150=(($149+8)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+$148*36)|0);
      var $153=(($152+33)|0);
      HEAP8[($153)]=0;
      var $154=$6;
      var $155=$i;
      var $156=$info;
      var $157=(($156+8)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($158+$155*36)|0);
      var $160=(($159+8)|0);
      var $161=$i;
      __ZN8device_t9save_itemIiEEvRT_PKci($154, $160, ((STRING_TABLE.__str76903)|0), $161);
      var $162=$6;
      var $163=$i;
      var $164=$info;
      var $165=(($164+8)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166+$163*36)|0);
      var $168=(($167+12)|0);
      var $169=$i;
      __ZN8device_t9save_itemIiEEvRT_PKci($162, $168, ((STRING_TABLE.__str86904)|0), $169);
      var $170=$6;
      var $171=$i;
      var $172=$info;
      var $173=(($172+8)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=(($174+$171*36)|0);
      var $176=(($175+16)|0);
      var $177=$i;
      __ZN8device_t9save_itemIjEEvRT_PKci($170, $176, ((STRING_TABLE.__str96905)|0), $177);
      var $178=$6;
      var $179=$i;
      var $180=$info;
      var $181=(($180+8)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=(($182+$179*36)|0);
      var $184=(($183+20)|0);
      var $185=$i;
      __ZN8device_t9save_itemIjEEvRT_PKci($178, $184, ((STRING_TABLE.__str106906)|0), $185);
      var $186=$6;
      var $187=$i;
      var $188=$info;
      var $189=(($188+8)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190+$187*36)|0);
      var $192=(($191+24)|0);
      var $193=$i;
      __ZN8device_t9save_itemIjEEvRT_PKci($186, $192, ((STRING_TABLE.__str116907)|0), $193);
      var $194=$6;
      var $195=$i;
      var $196=$info;
      var $197=(($196+8)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198+$195*36)|0);
      var $200=(($199+32)|0);
      var $201=$i;
      __ZN8device_t9save_itemIhEEvRT_PKci($194, $200, ((STRING_TABLE.__str126908)|0), $201);
      var $202=$6;
      var $203=$i;
      var $204=$info;
      var $205=(($204+8)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206+$203*36)|0);
      var $208=(($207+33)|0);
      var $209=$i;
      __ZN8device_t9save_itemIhEEvRT_PKci($202, $208, ((STRING_TABLE.__str136909)|0), $209);
      __label__ = 14; break;
    case 14: // $210
      var $211=$i;
      var $212=(($211+1)|0);
      $i=$212;
      __label__ = 12; break;
    case 15: // $213
      var $214=$6;
      var $215=__ZNK8device_t7machineEv($214);
      var $216=__ZN15running_machine4saveEv($215);
      var $217=$info;
      __ZN8delegateIFvvEEC1I13_samples_infoEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16static_func_typeEPKcPS5_($7, 1462, ((STRING_TABLE.__str146910)|0), $217);
      __ZN12save_manager17register_postloadE8delegateIFvvEE($216, $7);
      var $218=$intf;
      var $219=(($218+8)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220)|0)!=0;
      if ($221) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $222
      var $223=$intf;
      var $224=(($223+8)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$6;
      FUNCTION_TABLE[$225]($226);
      __label__ = 17; break;
    case 17: // $227
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20device_start_samplesP8device_t["X"]=1;

function __Z21legacy_device_creatorI14samples_deviceEP8device_tRK14machine_configPKcS2_j($mconfig, $tag, $owner, $clock) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $result_i=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9;
      var $10;
      var $11;
      var $12;
      var $13;
      var $14;
      $9=$mconfig;
      $10=$tag;
      $11=$owner;
      $12=$clock;
      var $15=$4;
      var $16=$5;
      var $17=$6;
      var $18=$result_i;
      var $19=$7;
      var $20=$8;
      HEAP32[(($4)>>2)]=408;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__str66902)|0);
      HEAP32[(($6)>>2)]=211;
      var $21=HEAP32[(($4)>>2)];
      var $22=HEAP32[(($5)>>2)];
      var $23=HEAP32[(($6)>>2)];
      var $24=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($21, $22, $23) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $25
      HEAP32[(($result_i)>>2)]=$24;
      var $26=HEAP32[(($result_i)>>2)];
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $28
      var $29=___cxa_allocate_exception(4);
      var $30=$29;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30);
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $33=$32.f0;
      HEAP32[(($7)>>2)]=$33;
      var $34=$32.f1;
      HEAP32[(($8)>>2)]=$34;
      var $35=HEAP32[(($8)>>2)];
      var $36=(($35)|0) < 0;
      if ($36) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $37
      var $38=HEAP32[(($7)>>2)];
      ___cxa_call_unexpected($38);
      throw "Reached an unreachable!"
    case 5: // $39
      var $40=HEAP32[(($7)>>2)];
      var $41=HEAP32[(($7)>>2)];
      var $42=HEAP32[(($8)>>2)];
      var $43=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $41, tempValue);
      var $44=($43.f1 = $42, $43);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $45
      throw "Reached an unreachable!"
    case 7: // $_ZnwjPKci_exit
      var $46=HEAP32[(($result_i)>>2)];
      var $47=$4;
      var $48=$5;
      var $49=$6;
      var $50=$result_i;
      var $51=$7;
      var $52=$8;
      var $53=$46;
      var $54=$9;
      var $55=$10;
      var $56=$11;
      var $57=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN14samples_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j]($53, $54, 1458, $55, $56, $57) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $58
      var $59=__ZN13resource_pool10add_objectI14samples_deviceEEPT_S3_(_global_resource_pool, $53);
      var $60=$59;
      STACKTOP = __stackBase__;
      return $60;
    case 9: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      $13=$63;
      var $64=$62.f1;
      $14=$64;
      var $65=$1;
      var $66=$2;
      var $67=$3;
      HEAP32[(($1)>>2)]=$46;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str66902)|0);
      HEAP32[(($3)>>2)]=211;
      var $68=HEAP32[(($1)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $70
      var $71=HEAP32[(($1)>>2)];
      var $72=HEAP32[(($2)>>2)];
      var $73=HEAP32[(($3)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($71, $72, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $_noexc
      __label__ = 12; break;
    case 12: // $_ZdlPvPKci_exit
      var $74=$1;
      var $75=$2;
      var $76=$3;
      __label__ = 13; break;
    case 13: // $77
      __label__ = 14; break;
    case 14: // $78
      var $79=$13;
      var $80=$13;
      var $81=$14;
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21legacy_device_creatorI14samples_deviceEP8device_tRK14machine_configPKcS2_j["X"]=1;

function __ZN14samples_deviceD0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN14samples_deviceD1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN14samples_deviceD0Ev["X"]=1;

function __ZN13resource_pool10add_objectI14samples_deviceEEPT_S3_($this, $object) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      $7=$this;
      $8=$object;
      var $11=$7;
      var $12=$4;
      var $13=$result_i;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=36;
      var $16=HEAP32[(($4)>>2)];
      var $17=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($16, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $18
      HEAP32[(($result_i)>>2)]=$17;
      var $19=HEAP32[(($result_i)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $21
      var $22=___cxa_allocate_exception(4);
      var $23=$22;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($23);
      (function() { try { __THREW__ = false; return ___cxa_throw($22, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      HEAP32[(($5)>>2)]=$26;
      var $27=$25.f1;
      HEAP32[(($6)>>2)]=$27;
      var $28=HEAP32[(($6)>>2)];
      var $29=(($28)|0) < 0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($31);
      throw "Reached an unreachable!"
    case 5: // $32
      var $33=HEAP32[(($5)>>2)];
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($6)>>2)];
      var $36=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $34, tempValue);
      var $37=($36.f1 = $35, $36);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $38
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $39=HEAP32[(($result_i)>>2)];
      var $40=$4;
      var $41=$result_i;
      var $42=$5;
      var $43=$6;
      var $44=$39;
      var $45=$8;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14samples_deviceEC1EPS0_($44, $45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $46
      var $47=$44;
      __ZN13resource_pool3addER18resource_pool_item($11, $47);
      var $48=$8;
      STACKTOP = __stackBase__;
      return $48;
    case 9: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $51=$50.f0;
      $9=$51;
      var $52=$50.f1;
      $10=$52;
      var $53=$1;
      var $54=$2;
      var $55=$3;
      HEAP32[(($1)>>2)]=$39;
      var $56=HEAP32[(($1)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $58
      var $59=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($59, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      __label__ = 13; break;
    case 12: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $63=$62.f0;
      HEAP32[(($2)>>2)]=$63;
      var $64=$62.f1;
      HEAP32[(($3)>>2)]=$64;
      var $65=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($65);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $66=$1;
      var $67=$2;
      var $68=$3;
      __label__ = 14; break;
    case 14: // $69
      var $70=$9;
      var $71=$9;
      var $72=$10;
      var $73=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $71, tempValue);
      var $74=($73.f1 = $72, $73);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool10add_objectI14samples_deviceEEPT_S3_["X"]=1;

function __ZN20resource_pool_objectI14samples_deviceED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN20resource_pool_objectI14samples_deviceED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN20resource_pool_objectI14samples_deviceED0Ev["X"]=1;

function __ZN20resource_pool_objectI14samples_deviceED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV20resource_pool_objectI14samples_deviceE+8)|0);
      var $6=(($4+32)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$7;
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$13]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      __label__ = 3; break;
    case 3: // $15
      var $16=$4;
      __ZN18resource_pool_itemD2Ev($16);
      ;
      return;
    case 4: // $17
      var $18=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $19=$18.f0;
      $2=$19;
      var $20=$18.f1;
      $3=$20;
      var $21=$4;
      (function() { try { __THREW__ = false; return __ZN18resource_pool_itemD2Ev($21) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      var $24=$2;
      var $25=$2;
      var $26=$3;
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16samples_postloadP13_samples_info($info) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      var $chan;
      var $sample;
      $1=$info;
      $i=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$i;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($3)|0) < (($6)|0);
      if ($7) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $8
      var $9=$i;
      var $10=$1;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+$9*36)|0);
      $chan=$13;
      var $14=$chan;
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0) >= 0;
      if ($17) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $18
      var $19=$chan;
      var $20=(($19+12)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$1;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($21)|0) < (($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $28
      var $29=$chan;
      var $30=(($29+12)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$1;
      var $33=(($32+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+4)|0);
      var $36=(($35+$31*12)|0);
      $sample=$36;
      var $37=$sample;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$chan;
      var $41=(($40+4)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$sample;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$chan;
      var $46=(($45+8)|0);
      HEAP32[(($46)>>2)]=$44;
      var $47=$sample;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $51
      var $52=$chan;
      var $53=(($52+12)|0);
      HEAP32[(($53)>>2)]=-1;
      __label__ = 6; break;
    case 6: // $54
      __label__ = 7; break;
    case 7: // $55
      var $56=$chan;
      var $57=(($56+4)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $60
      var $61=$chan;
      var $62=(($61+16)|0);
      var $63=HEAPU32[(($62)>>2)];
      var $64=$chan;
      var $65=(($64+8)|0);
      var $66=HEAPU32[(($65)>>2)];
      var $67=(($63)>>>0) >= (($66)>>>0);
      if ($67) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $68
      var $69=$chan;
      var $70=(($69+32)|0);
      var $71=HEAP8[($70)];
      var $72=(($71 << 24) >> 24)!=0;
      if ($72) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $73
      var $74=$chan;
      var $75=(($74+8)|0);
      var $76=HEAPU32[(($75)>>2)];
      var $77=$chan;
      var $78=(($77+16)|0);
      var $79=HEAPU32[(($78)>>2)];
      var $80=(($79)>>>0)%(($76)>>>0);
      HEAP32[(($78)>>2)]=$80;
      __label__ = 12; break;
    case 11: // $81
      var $82=$chan;
      var $83=(($82+4)|0);
      HEAP32[(($83)>>2)]=0;
      var $84=$chan;
      var $85=(($84+12)|0);
      HEAP32[(($85)>>2)]=-1;
      __label__ = 12; break;
    case 12: // $86
      __label__ = 13; break;
    case 13: // $87
      __label__ = 14; break;
    case 14: // $88
      var $89=$i;
      var $90=(($89+1)|0);
      $i=$90;
      __label__ = 1; break;
    case 15: // $91
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16samples_postloadP13_samples_info["X"]=1;

function __ZL19sample_update_soundP8device_tP12sound_streamPvPPiS5_i($device, $stream, $param, $inputs, $outputs, $samples) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $chan;
      var $buffer;
      var $pos;
      var $frac;
      var $step;
      var $sample;
      var $sample_length;
      var $sample1;
      var $sample2;
      var $fracmult;
      $1=$device;
      $2=$stream;
      $3=$param;
      $4=$inputs;
      $5=$outputs;
      $6=$samples;
      var $7=$3;
      var $8=$7;
      $chan=$8;
      var $9=$5;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $buffer=$11;
      var $12=$chan;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $16
      var $17=$chan;
      var $18=(($17+33)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24)!=0;
      if ($20) { __label__ = 13; break; } else { __label__ = 2; break; }
    case 2: // $21
      var $22=$chan;
      var $23=(($22+16)|0);
      var $24=HEAP32[(($23)>>2)];
      $pos=$24;
      var $25=$chan;
      var $26=(($25+20)|0);
      var $27=HEAP32[(($26)>>2)];
      $frac=$27;
      var $28=$chan;
      var $29=(($28+24)|0);
      var $30=HEAP32[(($29)>>2)];
      $step=$30;
      var $31=$chan;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      $sample=$33;
      var $34=$chan;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      $sample_length=$36;
      __label__ = 3; break;
    case 3: // $37
      var $38=$6;
      var $39=(($38-1)|0);
      $6=$39;
      var $40=(($38)|0)!=0;
      if ($40) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $41
      var $42=$pos;
      var $43=$sample;
      var $44=(($43+($42<<1))|0);
      var $45=HEAP16[(($44)>>1)];
      var $46=(($45 << 16) >> 16);
      $sample1=$46;
      var $47=$pos;
      var $48=(($47+1)|0);
      var $49=$sample_length;
      var $50=(($48)>>>0)%(($49)>>>0);
      var $51=$sample;
      var $52=(($51+($50<<1))|0);
      var $53=HEAP16[(($52)>>1)];
      var $54=(($53 << 16) >> 16);
      $sample2=$54;
      var $55=$frac;
      var $56=$55 >>> 10;
      $fracmult=$56;
      var $57=$fracmult;
      var $58=((16384-$57)|0);
      var $59=$sample1;
      var $60=(($58*$59)|0);
      var $61=$fracmult;
      var $62=$sample2;
      var $63=(($61*$62)|0);
      var $64=(($60+$63)|0);
      var $65=$64 >> 14;
      var $66=$buffer;
      var $67=(($66+4)|0);
      $buffer=$67;
      HEAP32[(($66)>>2)]=$65;
      var $68=$step;
      var $69=$frac;
      var $70=(($69+$68)|0);
      $frac=$70;
      var $71=$frac;
      var $72=$71 >>> 24;
      var $73=$pos;
      var $74=(($73+$72)|0);
      $pos=$74;
      var $75=$frac;
      var $76=$75 & 16777215;
      $frac=$76;
      var $77=$pos;
      var $78=$sample_length;
      var $79=(($77)>>>0) >= (($78)>>>0);
      if ($79) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $80
      var $81=$chan;
      var $82=(($81+32)|0);
      var $83=HEAP8[($82)];
      var $84=(($83 << 24) >> 24)!=0;
      if ($84) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $85
      var $86=$sample_length;
      var $87=$pos;
      var $88=(($87)>>>0)%(($86)>>>0);
      $pos=$88;
      __label__ = 10; break;
    case 7: // $89
      var $90=$chan;
      var $91=(($90+4)|0);
      HEAP32[(($91)>>2)]=0;
      var $92=$chan;
      var $93=(($92+12)|0);
      HEAP32[(($93)>>2)]=-1;
      var $94=$6;
      var $95=(($94)|0) > 0;
      if ($95) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $96
      var $97=$buffer;
      var $98=$97;
      var $99=$6;
      var $100=((($99<<2))|0);
      _memset($98, 0, $100, 1);
      __label__ = 9; break;
    case 9: // $101
      __label__ = 12; break;
    case 10: // $102
      __label__ = 11; break;
    case 11: // $103
      __label__ = 3; break;
    case 12: // $104
      var $105=$pos;
      var $106=$chan;
      var $107=(($106+16)|0);
      HEAP32[(($107)>>2)]=$105;
      var $108=$frac;
      var $109=$chan;
      var $110=(($109+20)|0);
      HEAP32[(($110)>>2)]=$108;
      __label__ = 14; break;
    case 13: // $111
      var $112=$buffer;
      var $113=$112;
      var $114=$6;
      var $115=((($114<<2))|0);
      _memset($113, 0, $115, 1);
      __label__ = 14; break;
    case 14: // $116
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19sample_update_soundP8device_tP12sound_streamPvPPiS5_i["X"]=1;

function __ZN8delegateIFvvEEC1I13_samples_infoEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZN8delegateIFvvEEC2I13_samples_infoEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16static_func_typeEPKcPS5_($5, $6, $7, $8);
  ;
  return;
}


function __ZN8delegateIFvvEEC2I13_samples_infoEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13_samples_infoEEN15delegate_traitsIT_vS0_S0_S0_S0_E16static_func_typeEPKcPS5_($6, $7, $8, $9);
  ;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13_samples_infoEEN15delegate_traitsIT_vS0_S0_S0_S0_E16static_func_typeEPKcPS5_($this, $funcptr, $name, $object) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$funcptr;
  $3=$name;
  $4=$object;
  var $5=$1;
  var $6=(($5)|0);
  var $7=$3;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($5+8)|0);
  var $10=$2;
  var $11=$10;
  HEAP32[(($9)>>2)]=$11;
  var $12=(($5+12)|0);
  __ZN21delegate_internal_mfpC1Ev($12);
  var $13=(($5+20)|0);
  HEAP32[(($13)>>2)]=1466;
  var $14=$4;
  var $15=$14;
  __ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class($5, $15);
  ;
  return;
}


function __ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13_samples_infoEEP22delegate_generic_classR18delegate_late_bind($object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$object;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$2;
      var $6=___dynamic_cast($5, __ZTI18delegate_late_bind, __ZTI13_samples_info, -1);
      var $7=$6;
      var $10 = $7;__label__ = 3; break;
    case 2: // $8
      var $10 = 0;__label__ = 3; break;
    case 3: // $9
      var $10;
      var $11=$10;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN19resource_pool_arrayI15_sample_channelEC1EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  __ZN19resource_pool_arrayI15_sample_channelEC2EPS0_i($4, $5, $6);
  ;
  return;
}


function __ZN19resource_pool_arrayI15_sample_channelEC2EPS0_i($this, $array, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$this;
  $2=$array;
  $3=$count;
  var $4=$1;
  var $5=$4;
  var $6=$2;
  var $7=$6;
  var $8=$3;
  var $9=(($8*36)|0);
  __ZN18resource_pool_itemC2EPvj($5, $7, $9);
  var $10=$4;
  HEAP32[(($10)>>2)]=((__ZTV19resource_pool_arrayI15_sample_channelE+8)|0);
  var $11=(($4+32)|0);
  var $12=$2;
  HEAP32[(($11)>>2)]=$12;
  var $13=(($4+36)|0);
  var $14=$3;
  HEAP32[(($13)>>2)]=$14;
  ;
  return;
}


function __ZN19resource_pool_arrayI15_sample_channelED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN19resource_pool_arrayI15_sample_channelED2Ev($2);
  ;
  return;
}


function __Z8png_freeP9_png_info($pnginfo) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $temp;
      $1=$pnginfo;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+88)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $7
      var $8=$1;
      var $9=(($8+88)|0);
      var $10=HEAP32[(($9)>>2)];
      $temp=$10;
      var $11=$temp;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14+88)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$temp;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$temp;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      _free($23);
      __label__ = 4; break;
    case 4: // $24
      var $25=$temp;
      var $26=$25;
      _free($26);
      __label__ = 1; break;
    case 5: // $27
      var $28=$1;
      var $29=(($28+72)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      var $33=$1;
      var $34=(($33+72)|0);
      var $35=HEAP32[(($34)>>2)];
      _free($35);
      __label__ = 7; break;
    case 7: // $36
      var $37=$1;
      var $38=(($37+72)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=$1;
      var $40=(($39+80)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $43
      var $44=$1;
      var $45=(($44+80)|0);
      var $46=HEAP32[(($45)>>2)];
      _free($46);
      __label__ = 9; break;
    case 9: // $47
      var $48=$1;
      var $49=(($48+80)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=$1;
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $54
      var $55=$1;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      _free($57);
      __label__ = 11; break;
    case 11: // $58
      var $59=$1;
      var $60=(($59)|0);
      HEAP32[(($60)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z8png_freeP9_png_info["X"]=1;

function __ZN13resource_pool9add_arrayI15_sample_channelEEPT_S3_i($this, $array, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $result_i=__stackBase__+16;
      var $5=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $7=$this;
      $8=$array;
      $9=$count;
      var $12=$7;
      var $13=$4;
      var $14=$result_i;
      var $15=$5;
      var $16=$6;
      HEAP32[(($4)>>2)]=40;
      var $17=HEAP32[(($4)>>2)];
      var $18=(function() { try { __THREW__ = false; return __Z16malloc_file_linejPKci($17, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $19
      HEAP32[(($result_i)>>2)]=$18;
      var $20=HEAP32[(($result_i)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=___cxa_allocate_exception(4);
      var $24=$23;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($24);
      (function() { try { __THREW__ = false; return ___cxa_throw($23, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $25
      var $26=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $27=$26.f0;
      HEAP32[(($5)>>2)]=$27;
      var $28=$26.f1;
      HEAP32[(($6)>>2)]=$28;
      var $29=HEAP32[(($6)>>2)];
      var $30=(($29)|0) < 0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($32);
      throw "Reached an unreachable!"
    case 5: // $33
      var $34=HEAP32[(($5)>>2)];
      var $35=HEAP32[(($5)>>2)];
      var $36=HEAP32[(($6)>>2)];
      var $37=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $35, tempValue);
      var $38=($37.f1 = $36, $37);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $39
      throw "Reached an unreachable!"
    case 7: // $_Znwj_exit
      var $40=HEAP32[(($result_i)>>2)];
      var $41=$4;
      var $42=$result_i;
      var $43=$5;
      var $44=$6;
      var $45=$40;
      var $46=$8;
      var $47=$9;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI15_sample_channelEC1EPS0_i($45, $46, $47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$45;
      __ZN13resource_pool3addER18resource_pool_item($12, $49);
      var $50=$8;
      STACKTOP = __stackBase__;
      return $50;
    case 9: // $51
      var $52=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $53=$52.f0;
      $10=$53;
      var $54=$52.f1;
      $11=$54;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      HEAP32[(($1)>>2)]=$40;
      var $58=HEAP32[(($1)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $60
      var $61=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($61, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      __label__ = 13; break;
    case 12: // $63
      var $64=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $65=$64.f0;
      HEAP32[(($2)>>2)]=$65;
      var $66=$64.f1;
      HEAP32[(($3)>>2)]=$66;
      var $67=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($67);
      throw "Reached an unreachable!"
    case 13: // $_ZdlPv_exit
      var $68=$1;
      var $69=$2;
      var $70=$3;
      __label__ = 14; break;
    case 14: // $71
      var $72=$10;
      var $73=$10;
      var $74=$11;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN13resource_pool9add_arrayI15_sample_channelEEPT_S3_i["X"]=1;

function __ZN19resource_pool_arrayI15_sample_channelED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $9;
      $7=$this;
      var $10=$7;
      (function() { try { __THREW__ = false; return __ZN19resource_pool_arrayI15_sample_channelED1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $11
      var $12=$10;
      var $13=$4;
      var $14=$5;
      var $15=$6;
      HEAP32[(($4)>>2)]=$12;
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $18
      var $19=HEAP32[(($4)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($19, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      __label__ = 5; break;
    case 4: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $23=$22.f0;
      HEAP32[(($5)>>2)]=$23;
      var $24=$22.f1;
      HEAP32[(($6)>>2)]=$24;
      var $25=HEAP32[(($5)>>2)];
      ___cxa_call_unexpected($25);
      throw "Reached an unreachable!"
    case 5: // $_ZdlPv_exit
      var $26=$4;
      var $27=$5;
      var $28=$6;
      STACKTOP = __stackBase__;
      return;
    case 6: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $31=$30.f0;
      $8=$31;
      var $32=$30.f1;
      $9=$32;
      var $33=$10;
      var $34=$1;
      var $35=$2;
      var $36=$3;
      HEAP32[(($1)>>2)]=$33;
      var $37=HEAP32[(($1)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $39
      var $40=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($40, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 10; break;
    case 9: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      HEAP32[(($2)>>2)]=$44;
      var $45=$43.f1;
      HEAP32[(($3)>>2)]=$45;
      var $46=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($46);
      throw "Reached an unreachable!"
    case 10: // $_ZdlPv_exit1
      var $47=$1;
      var $48=$2;
      var $49=$3;
      __label__ = 11; break;
    case 11: // $50
      var $51=$8;
      var $52=$8;
      var $53=$9;
      var $54=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $52, tempValue);
      var $55=($54.f1 = $53, $54);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN19resource_pool_arrayI15_sample_channelED0Ev["X"]=1;

function __ZN19resource_pool_arrayI15_sample_channelED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$5;
      HEAP32[(($6)>>2)]=((__ZTV19resource_pool_arrayI15_sample_channelE+8)|0);
      var $7=(($5+32)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$8;
      var $12=$1;
      var $13=$2;
      var $14=$3;
      HEAP32[(($1)>>2)]=$11;
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $17
      var $18=HEAP32[(($1)>>2)];
      (function() { try { __THREW__ = false; return __Z14free_file_linePvPKci($18, 0, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 5; break;
    case 4: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      HEAP32[(($2)>>2)]=$22;
      var $23=$21.f1;
      HEAP32[(($3)>>2)]=$23;
      var $24=HEAP32[(($2)>>2)];
      ___cxa_call_unexpected($24);
      throw "Reached an unreachable!"
    case 5: // $_ZdaPv_exit
      var $25=$1;
      var $26=$2;
      var $27=$3;
      __label__ = 6; break;
    case 6: // $28
      var $29=$5;
      __ZN18resource_pool_itemD2Ev($29);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13png_read_fileP10_core_fileP9_png_info($fp, $pnginfo) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $chunk_data=__stackBase__;
      var $png=__stackBase__+4;
      var $error;
      var $chunk_type=__stackBase__+24;
      var $chunk_length=__stackBase__+28;
      var $keepmem=__stackBase__+32;
      var $next;
      $1=$fp;
      $2=$pnginfo;
      HEAP32[(($chunk_data)>>2)]=0;
      var $3=$png;
      _memset($3, 0, 20, 1);
      var $4=$2;
      var $5=$4;
      _memset($5, 0, 92, 1);
      var $6=$2;
      var $7=(($png)|0);
      HEAP32[(($7)>>2)]=$6;
      var $8=(($png+4)|0);
      var $9=(($png+8)|0);
      HEAP32[(($9)>>2)]=$8;
      var $10=$1;
      var $11=__ZL13verify_headerP10_core_file($10);
      $error=$11;
      var $12=$error;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      __label__ = 15; break;
    case 2: // $15
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      var $18=__ZL10read_chunkP10_core_filePPhPjS3_($17, $chunk_data, $chunk_type, $chunk_length);
      $error=$18;
      var $19=$error;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      __label__ = 15; break;
    case 5: // $22
      var $23=HEAP32[(($chunk_type)>>2)];
      var $24=(($23)|0)==1229278788;
      if ($24) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $25
      __label__ = 12; break;
    case 7: // $26
      var $27=HEAP32[(($chunk_data)>>2)];
      var $28=HEAP32[(($chunk_type)>>2)];
      var $29=HEAP32[(($chunk_length)>>2)];
      var $30=__ZL13process_chunkP12_png_privatePhjjPi($png, $27, $28, $29, $keepmem);
      $error=$30;
      var $31=$error;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $33
      __label__ = 15; break;
    case 9: // $34
      var $35=HEAP32[(($keepmem)>>2)];
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $37
      var $38=HEAP32[(($chunk_data)>>2)];
      _free($38);
      __label__ = 11; break;
    case 11: // $39
      HEAP32[(($chunk_data)>>2)]=0;
      __label__ = 3; break;
    case 12: // $40
      var $41=__ZL13process_imageP12_png_private($png);
      $error=$41;
      var $42=$error;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $44
      __label__ = 15; break;
    case 14: // $45
      __label__ = 15; break;
    case 15: // $46
      __label__ = 16; break;
    case 16: // $47
      var $48=(($png+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $51
      var $52=(($png+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      $next=$55;
      var $56=(($png+4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $61
      var $62=(($png+4)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+8)|0);
      var $65=HEAP32[(($64)>>2)];
      _free($65);
      __label__ = 19; break;
    case 19: // $66
      var $67=(($png+4)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$68;
      _free($69);
      var $70=$next;
      var $71=(($png+4)|0);
      HEAP32[(($71)>>2)]=$70;
      __label__ = 16; break;
    case 20: // $72
      var $73=HEAP32[(($chunk_data)>>2)];
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $75
      var $76=HEAP32[(($chunk_data)>>2)];
      _free($76);
      __label__ = 22; break;
    case 22: // $77
      var $78=$error;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $80
      var $81=$2;
      __Z8png_freeP9_png_info($81);
      var $82=$2;
      var $83=$82;
      _memset($83, 0, 92, 1);
      __label__ = 24; break;
    case 24: // $84
      var $85=$error;
      STACKTOP = __stackBase__;
      return $85;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13png_read_fileP10_core_fileP9_png_info["X"]=1;

function __ZL13verify_headerP10_core_file($fp) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $signature=__stackBase__;
      $2=$fp;
      var $3=$2;
      var $4=(($signature)|0);
      var $5=__Z10core_freadP10_core_filePvj($3, $4, 8);
      var $6=(($5)|0)!=8;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=6;
      __label__ = 5; break;
    case 2: // $8
      var $9=(($signature)|0);
      var $10=_memcmp($9, ((STRING_TABLE.__str6918)|0), 8);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      $1=4;
      __label__ = 5; break;
    case 4: // $13
      $1=0;
      __label__ = 5; break;
    case 5: // $14
      var $15=$1;
      STACKTOP = __stackBase__;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10read_chunkP10_core_filePPhPjS3_($fp, $data, $type, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $crc;
      var $chunk_crc;
      var $tempbuff=__stackBase__;
      $2=$fp;
      $3=$data;
      $4=$type;
      $5=$length;
      var $6=$2;
      var $7=(($tempbuff)|0);
      var $8=__Z10core_freadP10_core_filePvj($6, $7, 4);
      var $9=(($8)|0)!=4;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=6;
      __label__ = 17; break;
    case 2: // $11
      var $12=(($tempbuff)|0);
      var $13=__ZL11fetch_32bitPh($12);
      var $14=$5;
      HEAP32[(($14)>>2)]=$13;
      var $15=$2;
      var $16=(($tempbuff)|0);
      var $17=__Z10core_freadP10_core_filePvj($15, $16, 4);
      var $18=(($17)|0)!=4;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $1=6;
      __label__ = 17; break;
    case 4: // $20
      var $21=(($tempbuff)|0);
      var $22=__ZL11fetch_32bitPh($21);
      var $23=$4;
      HEAP32[(($23)>>2)]=$22;
      var $24=$4;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)==1229278788;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      $1=0;
      __label__ = 17; break;
    case 6: // $28
      var $29=(($tempbuff)|0);
      var $30=_crc32(0, $29, 4);
      $crc=$30;
      var $31=$3;
      HEAP32[(($31)>>2)]=0;
      var $32=$5;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $35
      var $36=$5;
      var $37=HEAP32[(($36)>>2)];
      var $38=_malloc($37);
      var $39=$3;
      HEAP32[(($39)>>2)]=$38;
      var $40=$3;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $43
      $1=1;
      __label__ = 17; break;
    case 9: // $44
      var $45=$2;
      var $46=$3;
      var $47=HEAP32[(($46)>>2)];
      var $48=$5;
      var $49=HEAP32[(($48)>>2)];
      var $50=__Z10core_freadP10_core_filePvj($45, $47, $49);
      var $51=$5;
      var $52=HEAP32[(($51)>>2)];
      var $53=(($50)|0)!=(($52)|0);
      if ($53) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $54
      var $55=$3;
      var $56=HEAP32[(($55)>>2)];
      _free($56);
      var $57=$3;
      HEAP32[(($57)>>2)]=0;
      $1=6;
      __label__ = 17; break;
    case 11: // $58
      var $59=$crc;
      var $60=$3;
      var $61=HEAP32[(($60)>>2)];
      var $62=$5;
      var $63=HEAP32[(($62)>>2)];
      var $64=_crc32($59, $61, $63);
      $crc=$64;
      __label__ = 12; break;
    case 12: // $65
      var $66=$2;
      var $67=(($tempbuff)|0);
      var $68=__Z10core_freadP10_core_filePvj($66, $67, 4);
      var $69=(($68)|0)!=4;
      if ($69) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $70
      var $71=$3;
      var $72=HEAP32[(($71)>>2)];
      _free($72);
      var $73=$3;
      HEAP32[(($73)>>2)]=0;
      $1=6;
      __label__ = 17; break;
    case 14: // $74
      var $75=(($tempbuff)|0);
      var $76=__ZL11fetch_32bitPh($75);
      $chunk_crc=$76;
      var $77=$crc;
      var $78=$chunk_crc;
      var $79=(($77)|0)!=(($78)|0);
      if ($79) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $80
      var $81=$3;
      var $82=HEAP32[(($81)>>2)];
      _free($82);
      var $83=$3;
      HEAP32[(($83)>>2)]=0;
      $1=7;
      __label__ = 17; break;
    case 16: // $84
      $1=0;
      __label__ = 17; break;
    case 17: // $85
      var $86=$1;
      STACKTOP = __stackBase__;
      return $86;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10read_chunkP10_core_filePPhPjS3_["X"]=1;

function __ZL13process_chunkP12_png_privatePhjjPi($png, $data, $type, $length, $keepmem) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $text;
      var $pt;
      var $ct;
      $2=$png;
      $3=$data;
      $4=$type;
      $5=$length;
      $6=$keepmem;
      var $7=$6;
      HEAP32[(($7)>>2)]=0;
      var $8=$4;
      if ($8 == 1229472850) {
        __label__ = 1; break;
      }
      else if ($8 == 1347179589) {
        __label__ = 2; break;
      }
      else if ($8 == 1951551059) {
        __label__ = 3; break;
      }
      else if ($8 == 1229209940) {
        __label__ = 4; break;
      }
      else if ($8 == 1732332865) {
        __label__ = 7; break;
      }
      else if ($8 == 1883789683) {
        __label__ = 8; break;
      }
      else if ($8 == 1950701684) {
        __label__ = 9; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 1: // $9
      var $10=$3;
      var $11=__ZL11fetch_32bitPh($10);
      var $12=$2;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+4)|0);
      HEAP32[(($15)>>2)]=$11;
      var $16=$3;
      var $17=(($16+4)|0);
      var $18=__ZL11fetch_32bitPh($17);
      var $19=$2;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+8)|0);
      HEAP32[(($22)>>2)]=$18;
      var $23=$3;
      var $24=(($23+8)|0);
      var $25=__ZL10fetch_8bitPh($24);
      var $26=$2;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+64)|0);
      HEAP8[($29)]=$25;
      var $30=$3;
      var $31=(($30+9)|0);
      var $32=__ZL10fetch_8bitPh($31);
      var $33=$2;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+65)|0);
      HEAP8[($36)]=$32;
      var $37=$3;
      var $38=(($37+10)|0);
      var $39=__ZL10fetch_8bitPh($38);
      var $40=$2;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42+66)|0);
      HEAP8[($43)]=$39;
      var $44=$3;
      var $45=(($44+11)|0);
      var $46=__ZL10fetch_8bitPh($45);
      var $47=$2;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+67)|0);
      HEAP8[($50)]=$46;
      var $51=$3;
      var $52=(($51+12)|0);
      var $53=__ZL10fetch_8bitPh($52);
      var $54=$2;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+68)|0);
      HEAP8[($57)]=$53;
      __label__ = 22; break;
    case 2: // $58
      var $59=$5;
      var $60=Math.floor((($59)>>>0)/3);
      var $61=$2;
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+76)|0);
      HEAP32[(($64)>>2)]=$60;
      var $65=$3;
      var $66=$2;
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+72)|0);
      HEAP32[(($69)>>2)]=$65;
      var $70=$6;
      HEAP32[(($70)>>2)]=1;
      __label__ = 22; break;
    case 3: // $71
      var $72=$5;
      var $73=$2;
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+84)|0);
      HEAP32[(($76)>>2)]=$72;
      var $77=$3;
      var $78=$2;
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+80)|0);
      HEAP32[(($81)>>2)]=$77;
      var $82=$6;
      HEAP32[(($82)>>2)]=1;
      __label__ = 22; break;
    case 4: // $83
      var $84=_malloc(12);
      var $85=$84;
      var $86=$2;
      var $87=(($86+8)|0);
      var $88=HEAP32[(($87)>>2)];
      HEAP32[(($88)>>2)]=$85;
      var $89=$2;
      var $90=(($89+8)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $94
      $1=1;
      __label__ = 23; break;
    case 6: // $95
      var $96=$2;
      var $97=(($96+8)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99)|0);
      HEAP32[(($100)>>2)]=0;
      var $101=$5;
      var $102=$2;
      var $103=(($102+8)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+4)|0);
      HEAP32[(($106)>>2)]=$101;
      var $107=$3;
      var $108=$2;
      var $109=(($108+8)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+8)|0);
      HEAP32[(($112)>>2)]=$107;
      var $113=$2;
      var $114=(($113+8)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116)|0);
      var $118=$2;
      var $119=(($118+8)|0);
      HEAP32[(($119)>>2)]=$117;
      var $120=$6;
      HEAP32[(($120)>>2)]=1;
      __label__ = 22; break;
    case 7: // $121
      var $122=$3;
      var $123=__ZL11fetch_32bitPh($122);
      var $124=(($123)>>>0);
      var $125=$124/100000;
      var $126=$2;
      var $127=(($126)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128+52)|0);
      (tempDoubleF64[0]=$125,HEAP32[(($129)>>2)]=tempDoubleI32[0],HEAP32[(($129+4)>>2)]=tempDoubleI32[1]);
      __label__ = 22; break;
    case 8: // $130
      var $131=$3;
      var $132=__ZL11fetch_32bitPh($131);
      var $133=$2;
      var $134=(($133)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+12)|0);
      HEAP32[(($136)>>2)]=$132;
      var $137=$3;
      var $138=(($137+4)|0);
      var $139=__ZL11fetch_32bitPh($138);
      var $140=$2;
      var $141=(($140)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+16)|0);
      HEAP32[(($143)>>2)]=$139;
      var $144=$3;
      var $145=(($144+8)|0);
      var $146=__ZL10fetch_8bitPh($145);
      var $147=(($146)&255);
      var $148=$2;
      var $149=(($148)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150+60)|0);
      HEAP32[(($151)>>2)]=$147;
      __label__ = 22; break;
    case 9: // $152
      var $153=_malloc(12);
      var $154=$153;
      $text=$154;
      var $155=$text;
      var $156=(($155)|0)==0;
      if ($156) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $157
      $1=1;
      __label__ = 23; break;
    case 11: // $158
      var $159=$3;
      var $160=$text;
      var $161=(($160+4)|0);
      HEAP32[(($161)>>2)]=$159;
      var $162=$text;
      var $163=(($162+4)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$text;
      var $166=(($165+4)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=_strlen($167);
      var $169=(($164+$168)|0);
      var $170=(($169+1)|0);
      var $171=$text;
      var $172=(($171+8)|0);
      HEAP32[(($172)>>2)]=$170;
      var $173=$text;
      var $174=(($173)|0);
      HEAP32[(($174)>>2)]=0;
      $pt=0;
      var $175=$2;
      var $176=(($175)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177+88)|0);
      var $179=HEAP32[(($178)>>2)];
      $ct=$179;
      __label__ = 12; break;
    case 12: // $180
      var $181=$ct;
      var $182=(($181)|0)!=0;
      if ($182) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $183
      __label__ = 14; break;
    case 14: // $184
      var $185=$ct;
      $pt=$185;
      var $186=$ct;
      var $187=(($186)|0);
      var $188=HEAP32[(($187)>>2)];
      $ct=$188;
      __label__ = 12; break;
    case 15: // $189
      var $190=$pt;
      var $191=(($190)|0)==0;
      if ($191) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $192
      var $193=$text;
      var $194=$2;
      var $195=(($194)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196+88)|0);
      HEAP32[(($197)>>2)]=$193;
      __label__ = 18; break;
    case 17: // $198
      var $199=$text;
      var $200=$pt;
      var $201=(($200)|0);
      HEAP32[(($201)>>2)]=$199;
      __label__ = 18; break;
    case 18: // $202
      var $203=$6;
      HEAP32[(($203)>>2)]=1;
      __label__ = 22; break;
    case 19: // $204
      var $205=$4;
      var $206=$205 & 536870912;
      var $207=(($206)|0)==0;
      if ($207) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $208
      $1=8;
      __label__ = 23; break;
    case 21: // $209
      __label__ = 22; break;
    case 22: // $210
      $1=0;
      __label__ = 23; break;
    case 23: // $211
      var $212=$1;
      ;
      return $212;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13process_chunkP12_png_privatePhjjPi["X"]=1;

function __ZL13process_imageP12_png_private($png) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $rowbytes;
      var $bpp;
      var $imagesize;
      var $error;
      var $idat;
      var $src;
      var $dst;
      var $stream=__stackBase__;
      var $zerr;
      var $y;
      var $filter;
      $2=$png;
      $error=0;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__ZL11compute_bppPK9_png_info($5);
      $bpp=$6;
      var $7=$2;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=__ZL16compute_rowbytesPK9_png_info($9);
      $rowbytes=$10;
      var $11=$2;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$rowbytes;
      var $17=(($16+1)|0);
      var $18=(($15*$17)|0);
      $imagesize=$18;
      var $19=$imagesize;
      var $20=_malloc($19);
      var $21=$2;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=$20;
      var $25=$2;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $31
      $1=1;
      __label__ = 27; break;
    case 2: // $32
      var $33=$stream;
      _memset($33, 0, 56, 1);
      var $34=$2;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($stream+12)|0);
      HEAP32[(($39)>>2)]=$38;
      var $40=$imagesize;
      var $41=(($stream+16)|0);
      HEAP32[(($41)>>2)]=$40;
      var $42=_inflateInit_($stream, ((STRING_TABLE.__str26920)|0), 56);
      $zerr=$42;
      var $43=$zerr;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      $error=5;
      __label__ = 24; break;
    case 4: // $46
      var $47=$2;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      $idat=$49;
      __label__ = 5; break;
    case 5: // $50
      var $51=$idat;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $53
      var $54=$idat;
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($stream)|0);
      HEAP32[(($57)>>2)]=$56;
      var $58=$idat;
      var $59=(($58+4)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($stream+4)|0);
      HEAP32[(($61)>>2)]=$60;
      var $62=_inflate($stream, 0);
      $zerr=$62;
      var $63=$zerr;
      var $64=(($63)|0)==1;
      if ($64) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $65
      __label__ = 12; break;
    case 8: // $66
      var $67=$zerr;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $69
      $error=5;
      __label__ = 24; break;
    case 10: // $70
      __label__ = 11; break;
    case 11: // $71
      var $72=$idat;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      $idat=$74;
      __label__ = 5; break;
    case 12: // $75
      var $76=_inflateEnd($stream);
      $zerr=$76;
      var $77=$zerr;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $79
      $error=5;
      __label__ = 24; break;
    case 14: // $80
      var $81=$2;
      var $82=(($81)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      $dst=$85;
      $src=$85;
      $y=0;
      __label__ = 15; break;
    case 15: // $86
      var $87=$y;
      var $88=$2;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+8)|0);
      var $92=HEAPU32[(($91)>>2)];
      var $93=(($87)>>>0) < (($92)>>>0);
      if ($93) { __label__ = 16; break; } else { var $98 = 0;__label__ = 17; break; }
    case 16: // $94
      var $95=$error;
      var $96=(($95)|0)==0;
      var $98 = $96;__label__ = 17; break;
    case 17: // $97
      var $98;
      if ($98) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $99
      var $100=$src;
      var $101=(($100+1)|0);
      $src=$101;
      var $102=HEAPU8[($100)];
      var $103=(($102)&255);
      $filter=$103;
      var $104=$filter;
      var $105=$src;
      var $106=$dst;
      var $107=$y;
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $109
      var $116 = 0;__label__ = 21; break;
    case 20: // $110
      var $111=$rowbytes;
      var $112=(((-$111))|0);
      var $113=$dst;
      var $114=(($113+$112)|0);
      var $116 = $114;__label__ = 21; break;
    case 21: // $115
      var $116;
      var $117=$bpp;
      var $118=$rowbytes;
      var $119=__ZL12unfilter_rowiPhS_S_ii($104, $105, $106, $116, $117, $118);
      $error=$119;
      var $120=$rowbytes;
      var $121=$src;
      var $122=(($121+$120)|0);
      $src=$122;
      var $123=$rowbytes;
      var $124=$dst;
      var $125=(($124+$123)|0);
      $dst=$125;
      __label__ = 22; break;
    case 22: // $126
      var $127=$y;
      var $128=(($127+1)|0);
      $y=$128;
      __label__ = 15; break;
    case 23: // $129
      __label__ = 24; break;
    case 24: // $130
      var $131=$error;
      var $132=(($131)|0)!=0;
      if ($132) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $133
      var $134=$2;
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      _free($138);
      var $139=$2;
      var $140=(($139)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141)|0);
      HEAP32[(($142)>>2)]=0;
      __label__ = 26; break;
    case 26: // $143
      var $144=$error;
      $1=$144;
      __label__ = 27; break;
    case 27: // $145
      var $146=$1;
      STACKTOP = __stackBase__;
      return $146;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13process_imageP12_png_private["X"]=1;

function __ZL9put_32bitPhj($v, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$v;
  $2=$data;
  var $3=$2;
  var $4=$3 << 24;
  var $5=$2;
  var $6=$5 >>> 24;
  var $7=$4 | $6;
  var $8=$2;
  var $9=$8 & 65280;
  var $10=$9 << 8;
  var $11=$7 | $10;
  var $12=$2;
  var $13=$12 & 16711680;
  var $14=$13 >>> 8;
  var $15=$11 | $14;
  var $16=$1;
  var $17=$16;
  HEAP32[(($17)>>2)]=$15;
  ;
  return;
}


function __Z22png_expand_buffer_8bitP9_png_info($pnginfo) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $i;
      var $j;
      var $k;
      var $inp;
      var $outp;
      var $outbuf;
      $2=$pnginfo;
      var $3=$2;
      var $4=(($3+64)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=(($6)|0) >= 8;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 23; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12*$15)|0);
      var $17=_malloc($16);
      $outbuf=$17;
      var $18=$outbuf;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      $1=1;
      __label__ = 23; break;
    case 4: // $21
      var $22=$2;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      $inp=$24;
      var $25=$outbuf;
      $outp=$25;
      $i=0;
      __label__ = 5; break;
    case 5: // $26
      var $27=$i;
      var $28=$2;
      var $29=(($28+8)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($27)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 6; break; } else { __label__ = 22; break; }
    case 6: // $32
      $j=0;
      __label__ = 7; break;
    case 7: // $33
      var $34=$j;
      var $35=$2;
      var $36=(($35+4)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=$2;
      var $39=(($38+64)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((8/(($41)|0))|0);
      var $43=Math.floor((($37)>>>0)/(($42)>>>0));
      var $44=(($34)>>>0) < (($43)>>>0);
      if ($44) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $45
      var $46=$2;
      var $47=(($46+64)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=((8/(($49)|0))|0);
      var $51=(($50-1)|0);
      $k=$51;
      __label__ = 9; break;
    case 9: // $52
      var $53=$k;
      var $54=(($53)|0) >= 0;
      if ($54) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $55
      var $56=$inp;
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=$k;
      var $60=$2;
      var $61=(($60+64)|0);
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=(($59*$63)|0);
      var $65=$58 >> (($64)|0);
      var $66=$2;
      var $67=(($66+64)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=((8-$69)|0);
      var $71=255 >> (($70)|0);
      var $72=$65 & $71;
      var $73=(($72) & 255);
      var $74=$outp;
      var $75=(($74+1)|0);
      $outp=$75;
      HEAP8[($74)]=$73;
      __label__ = 11; break;
    case 11: // $76
      var $77=$k;
      var $78=(($77-1)|0);
      $k=$78;
      __label__ = 9; break;
    case 12: // $79
      var $80=$inp;
      var $81=(($80+1)|0);
      $inp=$81;
      __label__ = 13; break;
    case 13: // $82
      var $83=$j;
      var $84=(($83+1)|0);
      $j=$84;
      __label__ = 7; break;
    case 14: // $85
      var $86=$2;
      var $87=(($86+4)|0);
      var $88=HEAPU32[(($87)>>2)];
      var $89=$2;
      var $90=(($89+64)|0);
      var $91=HEAPU8[($90)];
      var $92=(($91)&255);
      var $93=((8/(($92)|0))|0);
      var $94=(($88)>>>0)%(($93)>>>0);
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $96
      var $97=$2;
      var $98=(($97+4)|0);
      var $99=HEAPU32[(($98)>>2)];
      var $100=$2;
      var $101=(($100+64)|0);
      var $102=HEAPU8[($101)];
      var $103=(($102)&255);
      var $104=((8/(($103)|0))|0);
      var $105=(($99)>>>0)%(($104)>>>0);
      var $106=(($105-1)|0);
      $k=$106;
      __label__ = 16; break;
    case 16: // $107
      var $108=$k;
      var $109=(($108)|0) >= 0;
      if ($109) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $110
      var $111=$inp;
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=$k;
      var $115=$2;
      var $116=(($115+64)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=(($114*$118)|0);
      var $120=$113 >> (($119)|0);
      var $121=$2;
      var $122=(($121+64)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=((8-$124)|0);
      var $126=255 >> (($125)|0);
      var $127=$120 & $126;
      var $128=(($127) & 255);
      var $129=$outp;
      var $130=(($129+1)|0);
      $outp=$130;
      HEAP8[($129)]=$128;
      __label__ = 18; break;
    case 18: // $131
      var $132=$k;
      var $133=(($132-1)|0);
      $k=$133;
      __label__ = 16; break;
    case 19: // $134
      var $135=$inp;
      var $136=(($135+1)|0);
      $inp=$136;
      __label__ = 20; break;
    case 20: // $137
      __label__ = 21; break;
    case 21: // $138
      var $139=$i;
      var $140=(($139+1)|0);
      $i=$140;
      __label__ = 5; break;
    case 22: // $141
      var $142=$2;
      var $143=(($142)|0);
      var $144=HEAP32[(($143)>>2)];
      _free($144);
      var $145=$outbuf;
      var $146=$2;
      var $147=(($146)|0);
      HEAP32[(($147)>>2)]=$145;
      $1=0;
      __label__ = 23; break;
    case 23: // $148
      var $149=$1;
      ;
      return $149;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22png_expand_buffer_8bitP9_png_info["X"]=1;

function __Z12png_add_textP9_png_infoPKcS2_($pnginfo, $keyword, $text) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $newtext;
      var $pt;
      var $ct;
      var $textdata;
      var $keylen;
      $2=$pnginfo;
      $3=$keyword;
      $4=$text;
      var $5=_malloc(12);
      var $6=$5;
      $newtext=$6;
      var $7=$newtext;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=1;
      __label__ = 12; break;
    case 2: // $10
      var $11=$3;
      var $12=_strlen($11);
      $keylen=$12;
      var $13=$keylen;
      var $14=(($13+1)|0);
      var $15=$4;
      var $16=_strlen($15);
      var $17=(($14+$16)|0);
      var $18=(($17+1)|0);
      var $19=_malloc($18);
      $textdata=$19;
      var $20=$textdata;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$newtext;
      var $24=$23;
      _free($24);
      $1=1;
      __label__ = 12; break;
    case 4: // $25
      var $26=$textdata;
      var $27=$3;
      var $28=_strcpy($26, $27);
      var $29=$textdata;
      var $30=$keylen;
      var $31=(($29+$30)|0);
      var $32=(($31+1)|0);
      var $33=$4;
      var $34=_strcpy($32, $33);
      var $35=$textdata;
      var $36=$newtext;
      var $37=(($36+4)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$textdata;
      var $39=$keylen;
      var $40=(($38+$39)|0);
      var $41=(($40+1)|0);
      var $42=$newtext;
      var $43=(($42+8)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=$newtext;
      var $45=(($44)|0);
      HEAP32[(($45)>>2)]=0;
      $pt=0;
      var $46=$2;
      var $47=(($46+88)|0);
      var $48=HEAP32[(($47)>>2)];
      $ct=$48;
      __label__ = 5; break;
    case 5: // $49
      var $50=$ct;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $52
      __label__ = 7; break;
    case 7: // $53
      var $54=$ct;
      $pt=$54;
      var $55=$ct;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      $ct=$57;
      __label__ = 5; break;
    case 8: // $58
      var $59=$pt;
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $61
      var $62=$newtext;
      var $63=$2;
      var $64=(($63+88)|0);
      HEAP32[(($64)>>2)]=$62;
      __label__ = 11; break;
    case 10: // $65
      var $66=$newtext;
      var $67=$pt;
      var $68=(($67)|0);
      HEAP32[(($68)>>2)]=$66;
      __label__ = 11; break;
    case 11: // $69
      $1=0;
      __label__ = 12; break;
    case 12: // $70
      var $71=$1;
      ;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12png_add_textP9_png_infoPKcS2_["X"]=1;

function __Z16png_write_bitmapP10_core_fileP9_png_infoP8bitmap_tiPKj($fp, $info, $bitmap, $palette_length, $palette) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $pnginfo=__stackBase__;
      var $error;
      $2=$fp;
      $3=$info;
      $4=$bitmap;
      $5=$palette_length;
      $6=$palette;
      var $7=$3;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $3=$pnginfo;
      var $10=$pnginfo;
      _memset($10, 0, 92, 1);
      __label__ = 2; break;
    case 2: // $11
      var $12=$2;
      var $13=__Z11core_fwriteP10_core_filePKvj($12, ((STRING_TABLE.__str6918)|0), 8);
      var $14=(($13)|0)!=8;
      if ($14) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $15
      var $16=$3;
      var $17=(($16)|0)==(($pnginfo)|0);
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      __Z8png_freeP9_png_info($pnginfo);
      __label__ = 5; break;
    case 5: // $19
      $1=3;
      __label__ = 9; break;
    case 6: // $20
      var $21=$2;
      var $22=$3;
      var $23=$4;
      var $24=$5;
      var $25=$6;
      var $26=__ZL16write_png_streamP10_core_fileP9_png_infoPK8bitmap_tiPKj($21, $22, $23, $24, $25);
      $error=$26;
      var $27=$3;
      var $28=(($27)|0)==(($pnginfo)|0);
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      __Z8png_freeP9_png_info($pnginfo);
      __label__ = 8; break;
    case 8: // $30
      var $31=$error;
      $1=$31;
      __label__ = 9; break;
    case 9: // $32
      var $33=$1;
      STACKTOP = __stackBase__;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16write_png_streamP10_core_fileP9_png_infoPK8bitmap_tiPKj($fp, $pnginfo, $bitmap, $palette_length, $palette) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tempbuff=__stackBase__;
      var $text;
      var $error;
      $1=$fp;
      $2=$pnginfo;
      $3=$bitmap;
      $4=$palette_length;
      $5=$palette;
      var $6=$3;
      var $7=$6;
      var $8=(($7+20)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==2;
      if ($10) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0) <= 256;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$2;
      var $16=$3;
      var $17=$4;
      var $18=$5;
      var $19=__ZL31convert_bitmap_to_image_paletteP9_png_infoPK8bitmap_tiPKj($15, $16, $17, $18);
      $error=$19;
      __label__ = 4; break;
    case 3: // $20
      var $21=$2;
      var $22=$3;
      var $23=$4;
      var $24=$5;
      var $25=__ZL27convert_bitmap_to_image_rgbP9_png_infoPK8bitmap_tiPKj($21, $22, $23, $24);
      $error=$25;
      __label__ = 4; break;
    case 4: // $26
      var $27=$error;
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      __label__ = 21; break;
    case 6: // $30
      var $31=(($tempbuff)|0);
      var $32=(($31)|0);
      var $33=$2;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      __ZL9put_32bitPhj($32, $35);
      var $36=(($tempbuff)|0);
      var $37=(($36+4)|0);
      var $38=$2;
      var $39=(($38+8)|0);
      var $40=HEAP32[(($39)>>2)];
      __ZL9put_32bitPhj($37, $40);
      var $41=(($tempbuff)|0);
      var $42=(($41+8)|0);
      var $43=$2;
      var $44=(($43+64)|0);
      var $45=HEAP8[($44)];
      __ZL8put_8bitPhh($42, $45);
      var $46=(($tempbuff)|0);
      var $47=(($46+9)|0);
      var $48=$2;
      var $49=(($48+65)|0);
      var $50=HEAP8[($49)];
      __ZL8put_8bitPhh($47, $50);
      var $51=(($tempbuff)|0);
      var $52=(($51+10)|0);
      var $53=$2;
      var $54=(($53+66)|0);
      var $55=HEAP8[($54)];
      __ZL8put_8bitPhh($52, $55);
      var $56=(($tempbuff)|0);
      var $57=(($56+11)|0);
      var $58=$2;
      var $59=(($58+67)|0);
      var $60=HEAP8[($59)];
      __ZL8put_8bitPhh($57, $60);
      var $61=(($tempbuff)|0);
      var $62=(($61+12)|0);
      var $63=$2;
      var $64=(($63+68)|0);
      var $65=HEAP8[($64)];
      __ZL8put_8bitPhh($62, $65);
      var $66=$1;
      var $67=(($tempbuff)|0);
      var $68=__ZL11write_chunkP10_core_filePKhjj($66, $67, 1229472850, 13);
      $error=$68;
      var $69=$error;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $71
      __label__ = 21; break;
    case 8: // $72
      var $73=$2;
      var $74=(($73+76)|0);
      var $75=HEAPU32[(($74)>>2)];
      var $76=(($75)>>>0) > 0;
      if ($76) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $77
      var $78=$1;
      var $79=$2;
      var $80=(($79+72)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$2;
      var $83=(($82+76)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84*3)|0);
      var $86=__ZL11write_chunkP10_core_filePKhjj($78, $81, 1347179589, $85);
      $error=$86;
      __label__ = 10; break;
    case 10: // $87
      var $88=$error;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $90
      __label__ = 21; break;
    case 12: // $91
      var $92=$1;
      var $93=$2;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      var $97=(($96+8)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$2;
      var $100=__ZL16compute_rowbytesPK9_png_info($99);
      var $101=(($100+1)|0);
      var $102=(($98*$101)|0);
      var $103=__ZL20write_deflated_chunkP10_core_filePhjj($92, $95, 1229209940, $102);
      $error=$103;
      var $104=$error;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $106
      __label__ = 21; break;
    case 14: // $107
      var $108=$2;
      var $109=(($108+88)|0);
      var $110=HEAP32[(($109)>>2)];
      $text=$110;
      __label__ = 15; break;
    case 15: // $111
      var $112=$text;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $114
      var $115=$1;
      var $116=$text;
      var $117=(($116+4)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$text;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=_strlen($121);
      var $123=(($122+1)|0);
      var $124=$text;
      var $125=(($124+8)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=_strlen($126);
      var $128=(($123+$127)|0);
      var $129=__ZL11write_chunkP10_core_filePKhjj($115, $118, 1950701684, $128);
      $error=$129;
      var $130=$error;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $132
      __label__ = 21; break;
    case 18: // $133
      __label__ = 19; break;
    case 19: // $134
      var $135=$text;
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      $text=$137;
      __label__ = 15; break;
    case 20: // $138
      var $139=$1;
      var $140=__ZL11write_chunkP10_core_filePKhjj($139, 0, 1229278788, 0);
      $error=$140;
      __label__ = 21; break;
    case 21: // $141
      var $142=$error;
      STACKTOP = __stackBase__;
      return $142;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16write_png_streamP10_core_fileP9_png_infoPK8bitmap_tiPKj["X"]=1;

function __Z17mng_capture_startP10_core_fileP8bitmap_td($fp, $bitmap, $rate) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $mhdr=__stackBase__;
      var $error;
      $2=$fp;
      $3=$bitmap;
      $4=$rate;
      var $5=$2;
      var $6=__Z11core_fwriteP10_core_filePKvj($5, ((STRING_TABLE.__str16919)|0), 8);
      var $7=(($6)|0)!=8;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=3;
      __label__ = 5; break;
    case 2: // $9
      var $10=(($mhdr)|0);
      _memset($10, 0, 28, 1);
      var $11=(($mhdr)|0);
      var $12=(($11)|0);
      var $13=$3;
      var $14=$13;
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      __ZL9put_32bitPhj($12, $16);
      var $17=(($mhdr)|0);
      var $18=(($17+4)|0);
      var $19=$3;
      var $20=$19;
      var $21=(($20+16)|0);
      var $22=HEAP32[(($21)>>2)];
      __ZL9put_32bitPhj($18, $22);
      var $23=(($mhdr)|0);
      var $24=(($23+8)|0);
      var $25=$4;
      var $26=($25 >= 0 ? Math.floor($25) : Math.ceil($25));
      __ZL9put_32bitPhj($24, $26);
      var $27=(($mhdr)|0);
      var $28=(($27+24)|0);
      __ZL9put_32bitPhj($28, 65);
      var $29=$2;
      var $30=(($mhdr)|0);
      var $31=__ZL11write_chunkP10_core_filePKhjj($29, $30, 1296581714, 28);
      $error=$31;
      var $32=$error;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $34
      var $35=$error;
      $1=$35;
      __label__ = 5; break;
    case 4: // $36
      $1=0;
      __label__ = 5; break;
    case 5: // $37
      var $38=$1;
      STACKTOP = __stackBase__;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17mng_capture_startP10_core_fileP8bitmap_td["X"]=1;

function __ZL11write_chunkP10_core_filePKhjj($fp, $data, $type, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tempbuff=__stackBase__;
      var $crc;
      $2=$fp;
      $3=$data;
      $4=$type;
      $5=$length;
      var $6=(($tempbuff)|0);
      var $7=(($6)|0);
      var $8=$5;
      __ZL9put_32bitPhj($7, $8);
      var $9=(($tempbuff)|0);
      var $10=(($9+4)|0);
      var $11=$4;
      __ZL9put_32bitPhj($10, $11);
      var $12=(($tempbuff)|0);
      var $13=(($12+4)|0);
      var $14=_crc32(0, $13, 4);
      $crc=$14;
      var $15=$2;
      var $16=(($tempbuff)|0);
      var $17=__Z11core_fwriteP10_core_filePKvj($15, $16, 8);
      var $18=(($17)|0)!=8;
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      $1=3;
      __label__ = 9; break;
    case 2: // $20
      var $21=$5;
      var $22=(($21)>>>0) > 0;
      if ($22) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $23
      var $24=$2;
      var $25=$3;
      var $26=$5;
      var $27=__Z11core_fwriteP10_core_filePKvj($24, $25, $26);
      var $28=$5;
      var $29=(($27)|0)!=(($28)|0);
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      $1=3;
      __label__ = 9; break;
    case 5: // $31
      var $32=$crc;
      var $33=$3;
      var $34=$5;
      var $35=_crc32($32, $33, $34);
      $crc=$35;
      __label__ = 6; break;
    case 6: // $36
      var $37=(($tempbuff)|0);
      var $38=$crc;
      __ZL9put_32bitPhj($37, $38);
      var $39=$2;
      var $40=(($tempbuff)|0);
      var $41=__Z11core_fwriteP10_core_filePKvj($39, $40, 4);
      var $42=(($41)|0)!=4;
      if ($42) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $43
      $1=3;
      __label__ = 9; break;
    case 8: // $44
      $1=0;
      __label__ = 9; break;
    case 9: // $45
      var $46=$1;
      STACKTOP = __stackBase__;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11write_chunkP10_core_filePKhjj["X"]=1;

function __Z17mng_capture_frameP10_core_fileP9_png_infoP8bitmap_tiPKj($fp, $info, $bitmap, $palette_length, $palette) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$fp;
  $2=$info;
  $3=$bitmap;
  $4=$palette_length;
  $5=$palette;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=$5;
  var $11=__ZL16write_png_streamP10_core_fileP9_png_infoPK8bitmap_tiPKj($6, $7, $8, $9, $10);
  ;
  return $11;
}


function __Z16mng_capture_stopP10_core_file($fp) {
  ;
  var __label__;

  var $1;
  $1=$fp;
  var $2=$1;
  var $3=__ZL11write_chunkP10_core_filePKhjj($2, 0, 1296387652, 0);
  ;
  return $3;
}


function __ZL8put_8bitPhh($v, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$v;
  $2=$data;
  var $3=$2;
  var $4=$1;
  HEAP8[($4)]=$3;
  ;
  return;
}


function __ZL7pal5bith6937($bits) {
  ;
  var __label__;

  var $1;
  $1=$bits;
  var $2=$1;
  var $3=(($2)&255);
  var $4=$3 & 31;
  var $5=(($4) & 255);
  $1=$5;
  var $6=$1;
  var $7=(($6)&255);
  var $8=$7 << 3;
  var $9=$1;
  var $10=(($9)&255);
  var $11=$10 >> 2;
  var $12=$8 | $11;
  var $13=(($12) & 255);
  ;
  return $13;
}


function __ZL16compute_rowbytesPK9_png_info($pnginfo) {
  ;
  var __label__;

  var $1;
  $1=$pnginfo;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5+65)|0);
  var $7=HEAPU8[($6)];
  var $8=(($7)&255);
  var $9=((__ZL7samples+($8<<2))|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=(($4*$10)|0);
  var $12=$1;
  var $13=(($12+64)|0);
  var $14=HEAPU8[($13)];
  var $15=(($14)&255);
  var $16=(($11*$15)|0);
  var $17=(($16+7)|0);
  var $18=Math.floor((($17)>>>0)/8);
  ;
  return $18;
}


function __ZL11compute_bppPK9_png_info($pnginfo) {
  ;
  var __label__;

  var $1;
  $1=$pnginfo;
  var $2=$1;
  var $3=(($2+65)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=((__ZL7samples+($5<<2))|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$1;
  var $9=(($8+64)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=(($7*$11)|0);
  var $13=(((($12)|0)/8)|0);
  ;
  return $13;
}


function __ZL31convert_bitmap_to_image_paletteP9_png_infoPK8bitmap_tiPKj($pnginfo, $bitmap, $palette_length, $palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $rowbytes;
      var $x;
      var $y;
      var $color;
      var $src;
      var $dst;
      $2=$pnginfo;
      $3=$bitmap;
      $4=$palette_length;
      $5=$palette;
      var $6=$3;
      var $7=$6;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$2;
      var $11=(($10+4)|0);
      HEAP32[(($11)>>2)]=$9;
      var $12=$3;
      var $13=$12;
      var $14=(($13+16)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($16+8)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$2;
      var $19=(($18+64)|0);
      HEAP8[($19)]=8;
      var $20=$2;
      var $21=(($20+65)|0);
      HEAP8[($21)]=3;
      var $22=$2;
      var $23=(($22+76)|0);
      HEAP32[(($23)>>2)]=256;
      var $24=$2;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      $rowbytes=$26;
      var $27=_malloc(768);
      var $28=$2;
      var $29=(($28+72)|0);
      HEAP32[(($29)>>2)]=$27;
      var $30=$2;
      var $31=(($30+72)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $34
      $1=1;
      __label__ = 17; break;
    case 2: // $35
      var $36=$2;
      var $37=(($36+72)|0);
      var $38=HEAP32[(($37)>>2)];
      _memset($38, 0, 768, 1);
      $x=0;
      __label__ = 3; break;
    case 3: // $39
      var $40=$x;
      var $41=$4;
      var $42=(($40)|0) < (($41)|0);
      if ($42) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $43
      var $44=$x;
      var $45=$5;
      var $46=(($45+($44<<2))|0);
      var $47=HEAP32[(($46)>>2)];
      $color=$47;
      var $48=$color;
      var $49=$48 >>> 16;
      var $50=$49 & 255;
      var $51=(($50) & 255);
      var $52=$x;
      var $53=(($52*3)|0);
      var $54=(($53)|0);
      var $55=$2;
      var $56=(($55+72)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+$54)|0);
      HEAP8[($58)]=$51;
      var $59=$color;
      var $60=$59 >>> 8;
      var $61=$60 & 255;
      var $62=(($61) & 255);
      var $63=$x;
      var $64=(($63*3)|0);
      var $65=(($64+1)|0);
      var $66=$2;
      var $67=(($66+72)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+$65)|0);
      HEAP8[($69)]=$62;
      var $70=$color;
      var $71=$70 & 255;
      var $72=(($71) & 255);
      var $73=$x;
      var $74=(($73*3)|0);
      var $75=(($74+2)|0);
      var $76=$2;
      var $77=(($76+72)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+$75)|0);
      HEAP8[($79)]=$72;
      __label__ = 5; break;
    case 5: // $80
      var $81=$x;
      var $82=(($81+1)|0);
      $x=$82;
      __label__ = 3; break;
    case 6: // $83
      var $84=$2;
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$rowbytes;
      var $88=(($87+1)|0);
      var $89=(($86*$88)|0);
      var $90=_malloc($89);
      var $91=$2;
      var $92=(($91)|0);
      HEAP32[(($92)>>2)]=$90;
      var $93=$2;
      var $94=(($93)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $97
      var $98=$2;
      var $99=(($98+72)|0);
      var $100=HEAP32[(($99)>>2)];
      _free($100);
      $1=1;
      __label__ = 17; break;
    case 8: // $101
      $y=0;
      __label__ = 9; break;
    case 9: // $102
      var $103=$y;
      var $104=$2;
      var $105=(($104+8)|0);
      var $106=HEAPU32[(($105)>>2)];
      var $107=(($103)>>>0) < (($106)>>>0);
      if ($107) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $108
      var $109=$3;
      var $110=$109;
      var $111=(($110+4)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$112;
      var $114=$y;
      var $115=$3;
      var $116=$115;
      var $117=(($116+8)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($114*$118)|0);
      var $120=(($113+($119<<1))|0);
      $src=$120;
      var $121=$2;
      var $122=(($121)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$y;
      var $125=$rowbytes;
      var $126=(($125+1)|0);
      var $127=(($124*$126)|0);
      var $128=(($123+$127)|0);
      $dst=$128;
      var $129=$dst;
      var $130=(($129+1)|0);
      $dst=$130;
      HEAP8[($129)]=0;
      $x=0;
      __label__ = 11; break;
    case 11: // $131
      var $132=$x;
      var $133=$2;
      var $134=(($133+4)|0);
      var $135=HEAPU32[(($134)>>2)];
      var $136=(($132)>>>0) < (($135)>>>0);
      if ($136) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $137
      var $138=$src;
      var $139=(($138+2)|0);
      $src=$139;
      var $140=HEAP16[(($138)>>1)];
      var $141=(($140) & 255);
      var $142=$dst;
      var $143=(($142+1)|0);
      $dst=$143;
      HEAP8[($142)]=$141;
      __label__ = 13; break;
    case 13: // $144
      var $145=$x;
      var $146=(($145+1)|0);
      $x=$146;
      __label__ = 11; break;
    case 14: // $147
      __label__ = 15; break;
    case 15: // $148
      var $149=$y;
      var $150=(($149+1)|0);
      $y=$150;
      __label__ = 9; break;
    case 16: // $151
      $1=0;
      __label__ = 17; break;
    case 17: // $152
      var $153=$1;
      ;
      return $153;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL31convert_bitmap_to_image_paletteP9_png_infoPK8bitmap_tiPKj["X"]=1;

function __ZL27convert_bitmap_to_image_rgbP9_png_infoPK8bitmap_tiPKj($pnginfo, $bitmap, $palette_length, $palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $alpha;
      var $rowbytes;
      var $x;
      var $y;
      var $src32;
      var $src16;
      var $dst;
      var $color;
      var $raw;
      var $raw1;
      var $raw2;
      $2=$pnginfo;
      $3=$bitmap;
      $4=$palette_length;
      $5=$palette;
      var $6=$3;
      var $7=$6;
      var $8=(($7+20)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==7;
      var $11=(($10)&1);
      $alpha=$11;
      var $12=$3;
      var $13=$12;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($16+4)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$3;
      var $19=$18;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$2;
      var $23=(($22+8)|0);
      HEAP32[(($23)>>2)]=$21;
      var $24=$2;
      var $25=(($24+64)|0);
      HEAP8[($25)]=8;
      var $26=$alpha;
      var $27=(($26)|0)!=0;
      var $28=$27 ? 6 : 2;
      var $29=(($28) & 255);
      var $30=$2;
      var $31=(($30+65)|0);
      HEAP8[($31)]=$29;
      var $32=$2;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$alpha;
      var $36=(($35)|0)!=0;
      var $37=$36 ? 4 : 3;
      var $38=(($34*$37)|0);
      $rowbytes=$38;
      var $39=$2;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$rowbytes;
      var $43=(($42+1)|0);
      var $44=(($41*$43)|0);
      var $45=_malloc($44);
      var $46=$2;
      var $47=(($46)|0);
      HEAP32[(($47)>>2)]=$45;
      var $48=$2;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0)==0;
      if ($51) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $52
      $1=1;
      __label__ = 35; break;
    case 2: // $53
      $y=0;
      __label__ = 3; break;
    case 3: // $54
      var $55=$y;
      var $56=$2;
      var $57=(($56+8)|0);
      var $58=HEAPU32[(($57)>>2)];
      var $59=(($55)>>>0) < (($58)>>>0);
      if ($59) { __label__ = 4; break; } else { __label__ = 34; break; }
    case 4: // $60
      var $61=$3;
      var $62=$61;
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$64;
      var $66=$y;
      var $67=$3;
      var $68=$67;
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($66*$70)|0);
      var $72=(($65+($71<<2))|0);
      var $73=(($72)|0);
      $src32=$73;
      var $74=$3;
      var $75=$74;
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$77;
      var $79=$y;
      var $80=$3;
      var $81=$80;
      var $82=(($81+8)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($79*$83)|0);
      var $85=(($78+($84<<1))|0);
      var $86=(($85)|0);
      $src16=$86;
      var $87=$2;
      var $88=(($87)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$y;
      var $91=$rowbytes;
      var $92=(($91+1)|0);
      var $93=(($90*$92)|0);
      var $94=(($89+$93)|0);
      $dst=$94;
      var $95=$dst;
      var $96=(($95+1)|0);
      $dst=$96;
      HEAP8[($95)]=0;
      var $97=$3;
      var $98=$97;
      var $99=(($98+20)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0)==2;
      if ($101) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $102
      $x=0;
      __label__ = 6; break;
    case 6: // $103
      var $104=$x;
      var $105=$2;
      var $106=(($105+4)|0);
      var $107=HEAPU32[(($106)>>2)];
      var $108=(($104)>>>0) < (($107)>>>0);
      if ($108) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $109
      var $110=$src16;
      var $111=(($110+2)|0);
      $src16=$111;
      var $112=HEAPU16[(($110)>>1)];
      var $113=(($112)&65535);
      var $114=$5;
      var $115=(($114+($113<<2))|0);
      var $116=HEAP32[(($115)>>2)];
      $color=$116;
      var $117=$color;
      var $118=$117 >>> 16;
      var $119=$118 & 255;
      var $120=(($119) & 255);
      var $121=$dst;
      var $122=(($121+1)|0);
      $dst=$122;
      HEAP8[($121)]=$120;
      var $123=$color;
      var $124=$123 >>> 8;
      var $125=$124 & 255;
      var $126=(($125) & 255);
      var $127=$dst;
      var $128=(($127+1)|0);
      $dst=$128;
      HEAP8[($127)]=$126;
      var $129=$color;
      var $130=$129 & 255;
      var $131=(($130) & 255);
      var $132=$dst;
      var $133=(($132+1)|0);
      $dst=$133;
      HEAP8[($132)]=$131;
      __label__ = 8; break;
    case 8: // $134
      var $135=$x;
      var $136=(($135+1)|0);
      $x=$136;
      __label__ = 6; break;
    case 9: // $137
      __label__ = 32; break;
    case 10: // $138
      var $139=$3;
      var $140=$139;
      var $141=(($140+20)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)==5;
      if ($143) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $144
      $x=0;
      __label__ = 12; break;
    case 12: // $145
      var $146=$x;
      var $147=$2;
      var $148=(($147+4)|0);
      var $149=HEAPU32[(($148)>>2)];
      var $150=(($146)>>>0) < (($149)>>>0);
      if ($150) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $151
      var $152=$src16;
      var $153=(($152+2)|0);
      $src16=$153;
      var $154=HEAP16[(($152)>>1)];
      $raw=$154;
      var $155=$raw;
      var $156=(($155)&65535);
      var $157=$156 >> 10;
      var $158=(($157) & 255);
      var $159=__ZL7pal5bith6937($158);
      var $160=$dst;
      var $161=(($160+1)|0);
      $dst=$161;
      HEAP8[($160)]=$159;
      var $162=$raw;
      var $163=(($162)&65535);
      var $164=$163 >> 5;
      var $165=(($164) & 255);
      var $166=__ZL7pal5bith6937($165);
      var $167=$dst;
      var $168=(($167+1)|0);
      $dst=$168;
      HEAP8[($167)]=$166;
      var $169=$raw;
      var $170=(($169)&65535);
      var $171=$170 >> 0;
      var $172=(($171) & 255);
      var $173=__ZL7pal5bith6937($172);
      var $174=$dst;
      var $175=(($174+1)|0);
      $dst=$175;
      HEAP8[($174)]=$173;
      __label__ = 14; break;
    case 14: // $176
      var $177=$x;
      var $178=(($177+1)|0);
      $x=$178;
      __label__ = 12; break;
    case 15: // $179
      __label__ = 31; break;
    case 16: // $180
      var $181=$3;
      var $182=$181;
      var $183=(($182+20)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($184)|0)==6;
      if ($185) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $186
      $x=0;
      __label__ = 18; break;
    case 18: // $187
      var $188=$x;
      var $189=$2;
      var $190=(($189+4)|0);
      var $191=HEAPU32[(($190)>>2)];
      var $192=(($188)>>>0) < (($191)>>>0);
      if ($192) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $193
      var $194=$src32;
      var $195=(($194+4)|0);
      $src32=$195;
      var $196=HEAP32[(($194)>>2)];
      $raw1=$196;
      var $197=$raw1;
      var $198=$197 >>> 16;
      var $199=$198 & 255;
      var $200=(($199) & 255);
      var $201=$dst;
      var $202=(($201+1)|0);
      $dst=$202;
      HEAP8[($201)]=$200;
      var $203=$raw1;
      var $204=$203 >>> 8;
      var $205=$204 & 255;
      var $206=(($205) & 255);
      var $207=$dst;
      var $208=(($207+1)|0);
      $dst=$208;
      HEAP8[($207)]=$206;
      var $209=$raw1;
      var $210=$209 & 255;
      var $211=(($210) & 255);
      var $212=$dst;
      var $213=(($212+1)|0);
      $dst=$213;
      HEAP8[($212)]=$211;
      __label__ = 20; break;
    case 20: // $214
      var $215=$x;
      var $216=(($215+1)|0);
      $x=$216;
      __label__ = 18; break;
    case 21: // $217
      __label__ = 30; break;
    case 22: // $218
      var $219=$3;
      var $220=$219;
      var $221=(($220+20)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($222)|0)==7;
      if ($223) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $224
      $x=0;
      __label__ = 24; break;
    case 24: // $225
      var $226=$x;
      var $227=$2;
      var $228=(($227+4)|0);
      var $229=HEAPU32[(($228)>>2)];
      var $230=(($226)>>>0) < (($229)>>>0);
      if ($230) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $231
      var $232=$src32;
      var $233=(($232+4)|0);
      $src32=$233;
      var $234=HEAP32[(($232)>>2)];
      $raw2=$234;
      var $235=$raw2;
      var $236=$235 >>> 16;
      var $237=$236 & 255;
      var $238=(($237) & 255);
      var $239=$dst;
      var $240=(($239+1)|0);
      $dst=$240;
      HEAP8[($239)]=$238;
      var $241=$raw2;
      var $242=$241 >>> 8;
      var $243=$242 & 255;
      var $244=(($243) & 255);
      var $245=$dst;
      var $246=(($245+1)|0);
      $dst=$246;
      HEAP8[($245)]=$244;
      var $247=$raw2;
      var $248=$247 & 255;
      var $249=(($248) & 255);
      var $250=$dst;
      var $251=(($250+1)|0);
      $dst=$251;
      HEAP8[($250)]=$249;
      var $252=$raw2;
      var $253=$252 >>> 24;
      var $254=$253 & 255;
      var $255=(($254) & 255);
      var $256=$dst;
      var $257=(($256+1)|0);
      $dst=$257;
      HEAP8[($256)]=$255;
      __label__ = 26; break;
    case 26: // $258
      var $259=$x;
      var $260=(($259+1)|0);
      $x=$260;
      __label__ = 24; break;
    case 27: // $261
      __label__ = 29; break;
    case 28: // $262
      $1=10;
      __label__ = 35; break;
    case 29: // $263
      __label__ = 30; break;
    case 30: // $264
      __label__ = 31; break;
    case 31: // $265
      __label__ = 32; break;
    case 32: // $266
      __label__ = 33; break;
    case 33: // $267
      var $268=$y;
      var $269=(($268+1)|0);
      $y=$269;
      __label__ = 3; break;
    case 34: // $270
      $1=0;
      __label__ = 35; break;
    case 35: // $271
      var $272=$1;
      ;
      return $272;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27convert_bitmap_to_image_rgbP9_png_infoPK8bitmap_tiPKj["X"]=1;

function __ZL20write_deflated_chunkP10_core_filePhjj($fp, $data, $type, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8256; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $lengthpos=__stackBase__;
      var $tempbuff=__stackBase__+8;
      var $zlength;
      var $stream=__stackBase__+8200;
      var $crc;
      var $zerr;
      var $bytes;
      $2=$fp;
      $3=$data;
      $4=$type;
      $5=$length;
      var $6=$2;
      var $7=__Z10core_ftellP10_core_file($6);
      var $7$0=$7[0];
      var $7$1=$7[1];
      var $st$20$0=(($lengthpos)|0);
      HEAP32[(($st$20$0)>>2)]=$7$0;
      var $st$20$1=(($lengthpos+4)|0);
      HEAP32[(($st$20$1)>>2)]=$7$1;
      $zlength=0;
      var $8=(($tempbuff)|0);
      var $9=(($8)|0);
      var $10=$5;
      __ZL9put_32bitPhj($9, $10);
      var $11=(($tempbuff)|0);
      var $12=(($11+4)|0);
      var $13=$4;
      __ZL9put_32bitPhj($12, $13);
      var $14=(($tempbuff)|0);
      var $15=(($14+4)|0);
      var $16=_crc32(0, $15, 4);
      $crc=$16;
      var $17=$2;
      var $18=(($tempbuff)|0);
      var $19=__Z11core_fwriteP10_core_filePKvj($17, $18, 8);
      var $20=(($19)|0)!=8;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      $1=3;
      __label__ = 21; break;
    case 2: // $22
      var $23=$stream;
      _memset($23, 0, 56, 1);
      var $24=$3;
      var $25=(($stream)|0);
      HEAP32[(($25)>>2)]=$24;
      var $26=$5;
      var $27=(($stream+4)|0);
      HEAP32[(($27)>>2)]=$26;
      var $28=_deflateInit_($stream, -1, ((STRING_TABLE.__str26920)|0), 56);
      $zerr=$28;
      var $29=$zerr;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $31
      $1=9;
      __label__ = 21; break;
    case 4: // $32
      __label__ = 5; break;
    case 5: // $33
      var $34=(($tempbuff)|0);
      var $35=(($stream+12)|0);
      HEAP32[(($35)>>2)]=$34;
      var $36=(($stream+16)|0);
      HEAP32[(($36)>>2)]=8192;
      var $37=_deflate($stream, 4);
      $zerr=$37;
      var $38=(($stream+16)|0);
      var $39=HEAPU32[(($38)>>2)];
      var $40=(($39)>>>0) < 8192;
      if ($40) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $41
      var $42=(($stream+16)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=((8192-$43)|0);
      $bytes=$44;
      var $45=$2;
      var $46=(($tempbuff)|0);
      var $47=$bytes;
      var $48=__Z11core_fwriteP10_core_filePKvj($45, $46, $47);
      var $49=$bytes;
      var $50=(($48)|0)!=(($49)|0);
      if ($50) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $51
      var $52=_deflateEnd($stream);
      $1=3;
      __label__ = 21; break;
    case 8: // $53
      var $54=$crc;
      var $55=(($tempbuff)|0);
      var $56=$bytes;
      var $57=_crc32($54, $55, $56);
      $crc=$57;
      var $58=$bytes;
      var $59=$zlength;
      var $60=(($59+$58)|0);
      $zlength=$60;
      __label__ = 9; break;
    case 9: // $61
      var $62=$zerr;
      var $63=(($62)|0)==1;
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      __label__ = 14; break;
    case 11: // $65
      var $66=$zerr;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $68
      var $69=_deflateEnd($stream);
      $1=9;
      __label__ = 21; break;
    case 13: // $70
      __label__ = 5; break;
    case 14: // $71
      var $72=_deflateEnd($stream);
      $zerr=$72;
      var $73=$zerr;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $75
      $1=9;
      __label__ = 21; break;
    case 16: // $76
      var $77=(($tempbuff)|0);
      var $78=$crc;
      __ZL9put_32bitPhj($77, $78);
      var $79=$2;
      var $80=(($tempbuff)|0);
      var $81=__Z11core_fwriteP10_core_filePKvj($79, $80, 4);
      var $82=(($81)|0)!=4;
      if ($82) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $83
      $1=3;
      __label__ = 21; break;
    case 18: // $84
      var $85=$2;
      var $st$1$0=(($lengthpos)|0);
      var $86$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($lengthpos+4)|0);
      var $86$1=HEAP32[(($st$1$1)>>2)];
      var $87=__Z10core_fseekP10_core_filexi($85, $86$0, $86$1, 0);
      var $87$0=$87[0];
      var $88=(($tempbuff)|0);
      var $89=(($88)|0);
      var $90=$zlength;
      __ZL9put_32bitPhj($89, $90);
      var $91=$2;
      var $92=(($tempbuff)|0);
      var $93=__Z11core_fwriteP10_core_filePKvj($91, $92, 4);
      var $94=(($93)|0)!=4;
      if ($94) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $95
      $1=3;
      __label__ = 21; break;
    case 20: // $96
      var $97=$2;
      var $st$1$0=(($lengthpos)|0);
      var $98$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($lengthpos+4)|0);
      var $98$1=HEAP32[(($st$1$1)>>2)];
      var $$emscripten$temp$0$0=8;
      var $$emscripten$temp$0$1=0;
      var $99$0 = ((($98$0)>>>0)+((($98$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $99$1 = Math.min(Math.floor((((($98$0)>>>0)+((($98$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $100=$zlength;
      var $101$0=$100;
      var $101$1=0;
      var $102$0 = ((($99$0)>>>0)+((($99$1)|0)*4294967296))+((($101$0)>>>0)+((($101$1)|0)*4294967296))>>>0; var $102$1 = Math.min(Math.floor((((($99$0)>>>0)+((($99$1)|0)*4294967296))+((($101$0)>>>0)+((($101$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=4;
      var $$emscripten$temp$1$1=0;
      var $103$0 = ((($102$0)>>>0)+((($102$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $103$1 = Math.min(Math.floor((((($102$0)>>>0)+((($102$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $104=__Z10core_fseekP10_core_filexi($97, $103$0, $103$1, 0);
      var $104$0=$104[0];
      $1=0;
      __label__ = 21; break;
    case 21: // $105
      var $106=$1;
      STACKTOP = __stackBase__;
      return $106;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20write_deflated_chunkP10_core_filePhjj["X"]=1;

function __ZL10fetch_8bitPh($v) {
  ;
  var __label__;

  var $1;
  $1=$v;
  var $2=$1;
  var $3=HEAP8[($2)];
  ;
  return $3;
}


function __ZL12rgb_to_rgb15j6940($rgb) {
  ;
  var __label__;

  var $1;
  $1=$rgb;
  var $2=$1;
  var $3=$2 >>> 16;
  var $4=$3 & 255;
  var $5=$4 >>> 3;
  var $6=$5 << 10;
  var $7=$1;
  var $8=$7 >>> 8;
  var $9=$8 & 255;
  var $10=$9 >>> 3;
  var $11=$10 << 5;
  var $12=$6 | $11;
  var $13=$1;
  var $14=$13 & 255;
  var $15=$14 >>> 3;
  var $16=$15 << 0;
  var $17=$12 | $16;
  var $18=(($17) & 65535);
  ;
  return $18;
}


function __ZL11fetch_32bitPh($v) {
  ;
  var __label__;

  var $1;
  $1=$v;
  var $2=$1;
  var $3=$2;
  var $4=HEAP32[(($3)>>2)];
  var $5=$4 << 24;
  var $6=$1;
  var $7=$6;
  var $8=HEAPU32[(($7)>>2)];
  var $9=$8 >>> 24;
  var $10=$5 | $9;
  var $11=$1;
  var $12=$11;
  var $13=HEAP32[(($12)>>2)];
  var $14=$13 & 65280;
  var $15=$14 << 8;
  var $16=$10 | $15;
  var $17=$1;
  var $18=$17;
  var $19=HEAP32[(($18)>>2)];
  var $20=$19 & 16711680;
  var $21=$20 >>> 8;
  var $22=$16 | $21;
  ;
  return $22;
}


function __ZL12unfilter_rowiPhS_S_ii($type, $src, $dst, $dstprev, $bpp, $rowbytes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $x;
      var $pa;
      var $pc;
      var $pb;
      var $prediction;
      var $da;
      var $db;
      var $dc;
      $2=$type;
      $3=$src;
      $4=$dst;
      $5=$dstprev;
      $6=$bpp;
      $7=$rowbytes;
      var $8=$2;
      if ($8 == 0) {
        __label__ = 1; break;
      }
      else if ($8 == 1) {
        __label__ = 6; break;
      }
      else if ($8 == 2) {
        __label__ = 15; break;
      }
      else if ($8 == 3) {
        __label__ = 22; break;
      }
      else if ($8 == 4) {
        __label__ = 42; break;
      }
      else {
      __label__ = 64; break;
      }
      
    case 1: // $9
      $x=0;
      __label__ = 2; break;
    case 2: // $10
      var $11=$x;
      var $12=$7;
      var $13=(($11)|0) < (($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      var $15=$3;
      var $16=(($15+1)|0);
      $3=$16;
      var $17=HEAP8[($15)];
      var $18=$4;
      var $19=(($18+1)|0);
      $4=$19;
      HEAP8[($18)]=$17;
      __label__ = 4; break;
    case 4: // $20
      var $21=$x;
      var $22=(($21+1)|0);
      $x=$22;
      __label__ = 2; break;
    case 5: // $23
      __label__ = 65; break;
    case 6: // $24
      $x=0;
      __label__ = 7; break;
    case 7: // $25
      var $26=$x;
      var $27=$6;
      var $28=(($26)|0) < (($27)|0);
      if ($28) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $29
      var $30=$3;
      var $31=(($30+1)|0);
      $3=$31;
      var $32=HEAP8[($30)];
      var $33=$4;
      var $34=(($33+1)|0);
      $4=$34;
      HEAP8[($33)]=$32;
      __label__ = 9; break;
    case 9: // $35
      var $36=$x;
      var $37=(($36+1)|0);
      $x=$37;
      __label__ = 7; break;
    case 10: // $38
      var $39=$6;
      $x=$39;
      __label__ = 11; break;
    case 11: // $40
      var $41=$x;
      var $42=$7;
      var $43=(($41)|0) < (($42)|0);
      if ($43) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $44
      var $45=$3;
      var $46=(($45+1)|0);
      $3=$46;
      var $47=HEAPU8[($45)];
      var $48=(($47)&255);
      var $49=$6;
      var $50=(((-$49))|0);
      var $51=$4;
      var $52=(($51+$50)|0);
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=(($48+$54)|0);
      var $56=(($55) & 255);
      var $57=$4;
      HEAP8[($57)]=$56;
      __label__ = 13; break;
    case 13: // $58
      var $59=$x;
      var $60=(($59+1)|0);
      $x=$60;
      var $61=$4;
      var $62=(($61+1)|0);
      $4=$62;
      __label__ = 11; break;
    case 14: // $63
      __label__ = 65; break;
    case 15: // $64
      var $65=$5;
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $67
      var $68=$3;
      var $69=$4;
      var $70=$5;
      var $71=$6;
      var $72=$7;
      var $73=__ZL12unfilter_rowiPhS_S_ii(0, $68, $69, $70, $71, $72);
      $1=$73;
      __label__ = 66; break;
    case 17: // $74
      $x=0;
      __label__ = 18; break;
    case 18: // $75
      var $76=$x;
      var $77=$7;
      var $78=(($76)|0) < (($77)|0);
      if ($78) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $79
      var $80=$3;
      var $81=(($80+1)|0);
      $3=$81;
      var $82=HEAPU8[($80)];
      var $83=(($82)&255);
      var $84=$5;
      var $85=(($84+1)|0);
      $5=$85;
      var $86=HEAPU8[($84)];
      var $87=(($86)&255);
      var $88=(($83+$87)|0);
      var $89=(($88) & 255);
      var $90=$4;
      HEAP8[($90)]=$89;
      __label__ = 20; break;
    case 20: // $91
      var $92=$x;
      var $93=(($92+1)|0);
      $x=$93;
      var $94=$4;
      var $95=(($94+1)|0);
      $4=$95;
      __label__ = 18; break;
    case 21: // $96
      __label__ = 65; break;
    case 22: // $97
      var $98=$5;
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 23; break; } else { __label__ = 32; break; }
    case 23: // $100
      $x=0;
      __label__ = 24; break;
    case 24: // $101
      var $102=$x;
      var $103=$6;
      var $104=(($102)|0) < (($103)|0);
      if ($104) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $105
      var $106=$3;
      var $107=(($106+1)|0);
      $3=$107;
      var $108=HEAP8[($106)];
      var $109=$4;
      var $110=(($109+1)|0);
      $4=$110;
      HEAP8[($109)]=$108;
      __label__ = 26; break;
    case 26: // $111
      var $112=$x;
      var $113=(($112+1)|0);
      $x=$113;
      __label__ = 24; break;
    case 27: // $114
      var $115=$6;
      $x=$115;
      __label__ = 28; break;
    case 28: // $116
      var $117=$x;
      var $118=$7;
      var $119=(($117)|0) < (($118)|0);
      if ($119) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $120
      var $121=$3;
      var $122=(($121+1)|0);
      $3=$122;
      var $123=HEAPU8[($121)];
      var $124=(($123)&255);
      var $125=$6;
      var $126=(((-$125))|0);
      var $127=$4;
      var $128=(($127+$126)|0);
      var $129=HEAPU8[($128)];
      var $130=(($129)&255);
      var $131=(((($130)|0)/2)|0);
      var $132=(($124+$131)|0);
      var $133=(($132) & 255);
      var $134=$4;
      HEAP8[($134)]=$133;
      __label__ = 30; break;
    case 30: // $135
      var $136=$x;
      var $137=(($136+1)|0);
      $x=$137;
      var $138=$4;
      var $139=(($138+1)|0);
      $4=$139;
      __label__ = 28; break;
    case 31: // $140
      __label__ = 41; break;
    case 32: // $141
      $x=0;
      __label__ = 33; break;
    case 33: // $142
      var $143=$x;
      var $144=$6;
      var $145=(($143)|0) < (($144)|0);
      if ($145) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $146
      var $147=$3;
      var $148=(($147+1)|0);
      $3=$148;
      var $149=HEAPU8[($147)];
      var $150=(($149)&255);
      var $151=$5;
      var $152=(($151+1)|0);
      $5=$152;
      var $153=HEAPU8[($151)];
      var $154=(($153)&255);
      var $155=(((($154)|0)/2)|0);
      var $156=(($150+$155)|0);
      var $157=(($156) & 255);
      var $158=$4;
      HEAP8[($158)]=$157;
      __label__ = 35; break;
    case 35: // $159
      var $160=$x;
      var $161=(($160+1)|0);
      $x=$161;
      var $162=$4;
      var $163=(($162+1)|0);
      $4=$163;
      __label__ = 33; break;
    case 36: // $164
      var $165=$6;
      $x=$165;
      __label__ = 37; break;
    case 37: // $166
      var $167=$x;
      var $168=$7;
      var $169=(($167)|0) < (($168)|0);
      if ($169) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $170
      var $171=$3;
      var $172=(($171+1)|0);
      $3=$172;
      var $173=HEAPU8[($171)];
      var $174=(($173)&255);
      var $175=$5;
      var $176=(($175+1)|0);
      $5=$176;
      var $177=HEAPU8[($175)];
      var $178=(($177)&255);
      var $179=$6;
      var $180=(((-$179))|0);
      var $181=$4;
      var $182=(($181+$180)|0);
      var $183=HEAPU8[($182)];
      var $184=(($183)&255);
      var $185=(($178+$184)|0);
      var $186=(((($185)|0)/2)|0);
      var $187=(($174+$186)|0);
      var $188=(($187) & 255);
      var $189=$4;
      HEAP8[($189)]=$188;
      __label__ = 39; break;
    case 39: // $190
      var $191=$x;
      var $192=(($191+1)|0);
      $x=$192;
      var $193=$4;
      var $194=(($193+1)|0);
      $4=$194;
      __label__ = 37; break;
    case 40: // $195
      __label__ = 41; break;
    case 41: // $196
      __label__ = 65; break;
    case 42: // $197
      $x=0;
      __label__ = 43; break;
    case 43: // $198
      var $199=$x;
      var $200=$7;
      var $201=(($199)|0) < (($200)|0);
      if ($201) { __label__ = 44; break; } else { __label__ = 63; break; }
    case 44: // $202
      var $203=$x;
      var $204=$6;
      var $205=(($203)|0) < (($204)|0);
      if ($205) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $206
      var $215 = 0;__label__ = 47; break;
    case 46: // $207
      var $208=$6;
      var $209=(((-$208))|0);
      var $210=$4;
      var $211=(($210+$209)|0);
      var $212=HEAPU8[($211)];
      var $213=(($212)&255);
      var $215 = $213;__label__ = 47; break;
    case 47: // $214
      var $215;
      $pa=$215;
      var $216=$x;
      var $217=$6;
      var $218=(($216)|0) < (($217)|0);
      if ($218) { __label__ = 49; break; } else { __label__ = 48; break; }
    case 48: // $219
      var $220=$5;
      var $221=(($220)|0)==0;
      if ($221) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $222
      var $231 = 0;__label__ = 51; break;
    case 50: // $223
      var $224=$6;
      var $225=(((-$224))|0);
      var $226=$5;
      var $227=(($226+$225)|0);
      var $228=HEAPU8[($227)];
      var $229=(($228)&255);
      var $231 = $229;__label__ = 51; break;
    case 51: // $230
      var $231;
      $pc=$231;
      var $232=$5;
      var $233=(($232)|0)==0;
      if ($233) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $234
      var $241 = 0;__label__ = 54; break;
    case 53: // $235
      var $236=$5;
      var $237=(($236+1)|0);
      $5=$237;
      var $238=HEAPU8[($236)];
      var $239=(($238)&255);
      var $241 = $239;__label__ = 54; break;
    case 54: // $240
      var $241;
      $pb=$241;
      var $242=$pa;
      var $243=$pb;
      var $244=(($242+$243)|0);
      var $245=$pc;
      var $246=(($244-$245)|0);
      $prediction=$246;
      var $247=$prediction;
      var $248=$pa;
      var $249=(($247-$248)|0);
      var $250=_abs($249);
      $da=$250;
      var $251=$prediction;
      var $252=$pb;
      var $253=(($251-$252)|0);
      var $254=_abs($253);
      $db=$254;
      var $255=$prediction;
      var $256=$pc;
      var $257=(($255-$256)|0);
      var $258=_abs($257);
      $dc=$258;
      var $259=$da;
      var $260=$db;
      var $261=(($259)|0) <= (($260)|0);
      if ($261) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $262
      var $263=$da;
      var $264=$dc;
      var $265=(($263)|0) <= (($264)|0);
      if ($265) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $266
      var $267=$3;
      var $268=(($267+1)|0);
      $3=$268;
      var $269=HEAPU8[($267)];
      var $270=(($269)&255);
      var $271=$pa;
      var $272=(($270+$271)|0);
      var $273=(($272) & 255);
      var $274=$4;
      var $275=(($274+1)|0);
      $4=$275;
      HEAP8[($274)]=$273;
      __label__ = 61; break;
    case 57: // $276
      var $277=$db;
      var $278=$dc;
      var $279=(($277)|0) <= (($278)|0);
      if ($279) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $280
      var $281=$3;
      var $282=(($281+1)|0);
      $3=$282;
      var $283=HEAPU8[($281)];
      var $284=(($283)&255);
      var $285=$pb;
      var $286=(($284+$285)|0);
      var $287=(($286) & 255);
      var $288=$4;
      var $289=(($288+1)|0);
      $4=$289;
      HEAP8[($288)]=$287;
      __label__ = 60; break;
    case 59: // $290
      var $291=$3;
      var $292=(($291+1)|0);
      $3=$292;
      var $293=HEAPU8[($291)];
      var $294=(($293)&255);
      var $295=$pc;
      var $296=(($294+$295)|0);
      var $297=(($296) & 255);
      var $298=$4;
      var $299=(($298+1)|0);
      $4=$299;
      HEAP8[($298)]=$297;
      __label__ = 60; break;
    case 60: // $300
      __label__ = 61; break;
    case 61: // $301
      __label__ = 62; break;
    case 62: // $302
      var $303=$x;
      var $304=(($303+1)|0);
      $x=$304;
      __label__ = 43; break;
    case 63: // $305
      __label__ = 65; break;
    case 64: // $306
      $1=2;
      __label__ = 66; break;
    case 65: // $307
      $1=0;
      __label__ = 66; break;
    case 66: // $308
      var $309=$1;
      ;
      return $309;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12unfilter_rowiPhS_S_ii["X"]=1;

function __Z13palette_allocjj($numcolors, $numgroups) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $palette;
      var $index;
      $2=$numcolors;
      $3=$numgroups;
      var $4=_malloc(308);
      var $5=$4;
      $palette=$5;
      var $6=$palette;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      __label__ = 28; break;
    case 2: // $9
      var $10=$palette;
      var $11=$10;
      _memset($11, 0, 308, 1);
      var $12=$palette;
      var $13=(($12+12)|0);
      HEAPF32[(($13)>>2)]=0;
      var $14=$palette;
      var $15=(($14+16)|0);
      HEAPF32[(($15)>>2)]=1;
      var $16=$palette;
      var $17=(($16+20)|0);
      HEAPF32[(($17)>>2)]=1;
      $index=0;
      __label__ = 3; break;
    case 3: // $18
      var $19=$index;
      var $20=(($19)>>>0) < 256;
      if ($20) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $21
      var $22=$index;
      var $23=(($22) & 255);
      var $24=$index;
      var $25=$palette;
      var $26=(($25+24)|0);
      var $27=(($26+$24)|0);
      HEAP8[($27)]=$23;
      __label__ = 5; break;
    case 5: // $28
      var $29=$index;
      var $30=(($29+1)|0);
      $index=$30;
      __label__ = 3; break;
    case 6: // $31
      var $32=$2;
      var $33=((($32<<2))|0);
      var $34=_malloc($33);
      var $35=$34;
      var $36=$palette;
      var $37=(($36+280)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$2;
      var $39=((($38<<2))|0);
      var $40=_malloc($39);
      var $41=$40;
      var $42=$palette;
      var $43=(($42+284)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=$palette;
      var $45=(($44+280)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $48
      var $49=$palette;
      var $50=(($49+284)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $53
      __label__ = 28; break;
    case 9: // $54
      $index=0;
      __label__ = 10; break;
    case 10: // $55
      var $56=$index;
      var $57=$2;
      var $58=(($56)>>>0) < (($57)>>>0);
      if ($58) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $59
      var $60=$index;
      var $61=$palette;
      var $62=(($61+280)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+($60<<2))|0);
      HEAP32[(($64)>>2)]=-16777216;
      var $65=$index;
      var $66=$palette;
      var $67=(($66+284)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+($65<<2))|0);
      HEAPF32[(($69)>>2)]=1;
      __label__ = 12; break;
    case 12: // $70
      var $71=$index;
      var $72=(($71+1)|0);
      $index=$72;
      __label__ = 10; break;
    case 13: // $73
      var $74=$3;
      var $75=((($74<<2))|0);
      var $76=_malloc($75);
      var $77=$76;
      var $78=$palette;
      var $79=(($78+296)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$3;
      var $81=((($80<<2))|0);
      var $82=_malloc($81);
      var $83=$82;
      var $84=$palette;
      var $85=(($84+300)|0);
      HEAP32[(($85)>>2)]=$83;
      var $86=$palette;
      var $87=(($86+296)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $90
      var $91=$palette;
      var $92=(($91+300)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93)|0)==0;
      if ($94) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $95
      __label__ = 28; break;
    case 16: // $96
      $index=0;
      __label__ = 17; break;
    case 17: // $97
      var $98=$index;
      var $99=$3;
      var $100=(($98)>>>0) < (($99)>>>0);
      if ($100) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $101
      var $102=$index;
      var $103=$palette;
      var $104=(($103+296)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+($102<<2))|0);
      HEAPF32[(($106)>>2)]=0;
      var $107=$index;
      var $108=$palette;
      var $109=(($108+300)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+($107<<2))|0);
      HEAPF32[(($111)>>2)]=1;
      __label__ = 19; break;
    case 19: // $112
      var $113=$index;
      var $114=(($113+1)|0);
      $index=$114;
      __label__ = 17; break;
    case 20: // $115
      var $116=$2;
      var $117=$3;
      var $118=(($116*$117)|0);
      var $119=(($118+2)|0);
      var $120=((($119<<2))|0);
      var $121=_malloc($120);
      var $122=$121;
      var $123=$palette;
      var $124=(($123+288)|0);
      HEAP32[(($124)>>2)]=$122;
      var $125=$2;
      var $126=$3;
      var $127=(($125*$126)|0);
      var $128=(($127+2)|0);
      var $129=((($128<<2))|0);
      var $130=_malloc($129);
      var $131=$130;
      var $132=$palette;
      var $133=(($132+292)|0);
      HEAP32[(($133)>>2)]=$131;
      var $134=$palette;
      var $135=(($134+288)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0)==0;
      if ($137) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $138
      var $139=$palette;
      var $140=(($139+292)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141)|0)==0;
      if ($142) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $143
      __label__ = 28; break;
    case 23: // $144
      $index=0;
      __label__ = 24; break;
    case 24: // $145
      var $146=$index;
      var $147=$2;
      var $148=$3;
      var $149=(($147*$148)|0);
      var $150=(($146)>>>0) < (($149)>>>0);
      if ($150) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $151
      var $152=$index;
      var $153=$palette;
      var $154=(($153+288)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+($152<<2))|0);
      HEAP32[(($156)>>2)]=-16777216;
      var $157=__ZL12rgb_to_rgb15j6940(-16777216);
      var $158=(($157)&65535);
      var $159=$index;
      var $160=$palette;
      var $161=(($160+292)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+($159<<2))|0);
      HEAP32[(($163)>>2)]=$158;
      __label__ = 26; break;
    case 26: // $164
      var $165=$index;
      var $166=(($165+1)|0);
      $index=$166;
      __label__ = 24; break;
    case 27: // $167
      var $168=$index;
      var $169=$palette;
      var $170=(($169+288)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171+($168<<2))|0);
      HEAP32[(($172)>>2)]=-16777216;
      var $173=__ZL12rgb_to_rgb15j6940(-16777216);
      var $174=(($173)&65535);
      var $175=$index;
      var $176=(($175+1)|0);
      $index=$176;
      var $177=$palette;
      var $178=(($177+292)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+($175<<2))|0);
      HEAP32[(($180)>>2)]=$174;
      var $181=$index;
      var $182=$palette;
      var $183=(($182+288)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($184+($181<<2))|0);
      HEAP32[(($185)>>2)]=-1;
      var $186=__ZL12rgb_to_rgb15j6940(-1);
      var $187=(($186)&65535);
      var $188=$index;
      var $189=(($188+1)|0);
      $index=$189;
      var $190=$palette;
      var $191=(($190+292)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+($188<<2))|0);
      HEAP32[(($193)>>2)]=$187;
      var $194=$palette;
      var $195=(($194)|0);
      HEAP32[(($195)>>2)]=1;
      var $196=$2;
      var $197=$palette;
      var $198=(($197+4)|0);
      HEAP32[(($198)>>2)]=$196;
      var $199=$3;
      var $200=$palette;
      var $201=(($200+8)|0);
      HEAP32[(($201)>>2)]=$199;
      var $202=$palette;
      $1=$202;
      __label__ = 31; break;
    case 28: // $203
      var $204=$palette;
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $206
      var $207=$palette;
      __ZL21internal_palette_freeP10_palette_t($207);
      __label__ = 30; break;
    case 30: // $208
      $1=0;
      __label__ = 31; break;
    case 31: // $209
      var $210=$1;
      ;
      return $210;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13palette_allocjj["X"]=1;

function __ZL21internal_palette_freeP10_palette_t($palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$palette;
      var $2=$1;
      var $3=(($2+280)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+280)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9;
      _free($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=(($12+284)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17+284)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      _free($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$1;
      var $23=(($22+296)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$1;
      var $28=(($27+296)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      _free($30);
      __label__ = 6; break;
    case 6: // $31
      var $32=$1;
      var $33=(($32+300)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $36
      var $37=$1;
      var $38=(($37+300)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39;
      _free($40);
      __label__ = 8; break;
    case 8: // $41
      var $42=$1;
      var $43=(($42+288)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $46
      var $47=$1;
      var $48=(($47+288)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$49;
      _free($50);
      __label__ = 10; break;
    case 10: // $51
      var $52=$1;
      var $53=(($52+292)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      var $57=$1;
      var $58=(($57+292)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$59;
      _free($60);
      __label__ = 12; break;
    case 12: // $61
      var $62=$1;
      var $63=$62;
      _free($63);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21internal_palette_freeP10_palette_t["X"]=1;

function __ZL9rgb_clampi6971($value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$value;
      var $3=$2;
      var $4=(($3)|0) < 0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 5; break;
    case 2: // $6
      var $7=$2;
      var $8=(($7)|0) > 255;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      $1=-1;
      __label__ = 5; break;
    case 4: // $10
      var $11=$2;
      var $12=(($11) & 255);
      $1=$12;
      __label__ = 5; break;
    case 5: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z11palette_refP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+1)|0);
  HEAP32[(($3)>>2)]=$5;
  ;
  return;
}


function __Z22palette_get_num_colorsP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z22palette_get_num_groupsP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z23palette_get_black_entryP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($4*$7)|0);
  var $9=(($8)|0);
  ;
  return $9;
}


function __Z23palette_get_white_entryP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$1;
  var $6=(($5+8)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($4*$7)|0);
  var $9=(($8+1)|0);
  ;
  return $9;
}


function __Z26palette_client_get_paletteP15_palette_client($client) {
  ;
  var __label__;

  var $1;
  $1=$client;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z23palette_entry_get_colorP10_palette_tj($palette, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$palette;
      $2=$index;
      var $3=$2;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=(($3)>>>0) < (($6)>>>0);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=$1;
      var $11=(($10+280)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+($9<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $17 = $14;__label__ = 3; break;
    case 2: // $15
      var $17 = -16777216;__label__ = 3; break;
    case 3: // $16
      var $17;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z22palette_entry_list_rawP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+280)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z27palette_entry_list_adjustedP10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+288)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z33palette_entry_list_adjusted_rgb15P10_palette_t($palette) {
  ;
  var __label__;

  var $1;
  $1=$palette;
  var $2=$1;
  var $3=(($2+292)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __Z26palette_entry_get_contrastP10_palette_tj($palette, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$palette;
      $2=$index;
      var $3=$2;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=(($3)>>>0) < (($6)>>>0);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=$1;
      var $11=(($10+284)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+($9<<2))|0);
      var $14=HEAPF32[(($13)>>2)];
      var $17 = $14;__label__ = 3; break;
    case 2: // $15
      var $17 = 1;__label__ = 3; break;
    case 3: // $16
      var $17;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13palette_derefP10_palette_t($palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$palette;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4-1)|0);
      HEAP32[(($3)>>2)]=$5;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      __ZL21internal_palette_freeP10_palette_t($8);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20palette_client_allocP10_palette_t($palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $total_colors;
      var $dirty_dwords;
      var $client;
      $2=$palette;
      var $3=$2;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5*$8)|0);
      $total_colors=$9;
      var $10=$total_colors;
      var $11=(($10+31)|0);
      var $12=Math.floor((($11)>>>0)/32);
      $dirty_dwords=$12;
      var $13=_malloc(32);
      var $14=$13;
      $client=$14;
      var $15=$client;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      __label__ = 6; break;
    case 2: // $18
      var $19=$client;
      var $20=$19;
      _memset($20, 0, 32, 1);
      var $21=$dirty_dwords;
      var $22=((($21<<2))|0);
      var $23=_malloc($22);
      var $24=$23;
      var $25=$client;
      var $26=(($25+8)|0);
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=$24;
      var $28=$dirty_dwords;
      var $29=((($28<<2))|0);
      var $30=_malloc($29);
      var $31=$30;
      var $32=$client;
      var $33=(($32+20)|0);
      var $34=(($33)|0);
      HEAP32[(($34)>>2)]=$31;
      var $35=$client;
      var $36=(($35+8)|0);
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $40
      var $41=$client;
      var $42=(($41+20)|0);
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $46
      __label__ = 6; break;
    case 5: // $47
      var $48=$client;
      var $49=(($48+8)|0);
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$51;
      var $53=$dirty_dwords;
      var $54=((($53<<2))|0);
      _memset($52, -1, $54, 1);
      var $55=$client;
      var $56=(($55+20)|0);
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$58;
      var $60=$dirty_dwords;
      var $61=((($60<<2))|0);
      _memset($59, -1, $61, 1);
      var $62=$total_colors;
      var $63=(($62)>>>0)%32;
      var $64=1 << $63;
      var $65=(($64-1)|0);
      var $66=$dirty_dwords;
      var $67=(($66-1)|0);
      var $68=$client;
      var $69=(($68+8)|0);
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71+($67<<2))|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$73 & $65;
      HEAP32[(($72)>>2)]=$74;
      var $75=$total_colors;
      var $76=(($75)>>>0)%32;
      var $77=1 << $76;
      var $78=(($77-1)|0);
      var $79=$dirty_dwords;
      var $80=(($79-1)|0);
      var $81=$client;
      var $82=(($81+20)|0);
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+($80<<2))|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86 & $78;
      HEAP32[(($85)>>2)]=$87;
      var $88=$2;
      var $89=$client;
      var $90=(($89+4)|0);
      HEAP32[(($90)>>2)]=$88;
      var $91=$2;
      __Z11palette_refP10_palette_t($91);
      var $92=$client;
      var $93=(($92+8)|0);
      var $94=(($93+4)|0);
      HEAP32[(($94)>>2)]=0;
      var $95=$total_colors;
      var $96=(($95-1)|0);
      var $97=$client;
      var $98=(($97+8)|0);
      var $99=(($98+8)|0);
      HEAP32[(($99)>>2)]=$96;
      var $100=$2;
      var $101=(($100+304)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$client;
      var $104=(($103)|0);
      HEAP32[(($104)>>2)]=$102;
      var $105=$client;
      var $106=$2;
      var $107=(($106+304)|0);
      HEAP32[(($107)>>2)]=$105;
      var $108=$client;
      $1=$108;
      __label__ = 13; break;
    case 6: // $109
      var $110=$client;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $112
      var $113=$client;
      var $114=(($113+8)|0);
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $118
      var $119=$client;
      var $120=(($119+8)|0);
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$122;
      _free($123);
      __label__ = 9; break;
    case 9: // $124
      var $125=$client;
      var $126=(($125+20)|0);
      var $127=(($126)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128)|0)!=0;
      if ($129) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $130
      var $131=$client;
      var $132=(($131+20)|0);
      var $133=(($132)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$134;
      _free($135);
      __label__ = 11; break;
    case 11: // $136
      var $137=$client;
      var $138=$137;
      _free($138);
      __label__ = 12; break;
    case 12: // $139
      $1=0;
      __label__ = 13; break;
    case 13: // $140
      var $141=$1;
      ;
      return $141;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20palette_client_allocP10_palette_t["X"]=1;

function __Z19palette_client_freeP15_palette_client($client) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $curptr;
      $1=$client;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+304)|0);
      $curptr=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$curptr;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$curptr;
      var $12=HEAP32[(($11)>>2)];
      var $13=$1;
      var $14=(($12)|0)==(($13)|0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$curptr;
      HEAP32[(($19)>>2)]=$18;
      __label__ = 6; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$curptr;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0);
      $curptr=$24;
      __label__ = 1; break;
    case 6: // $25
      var $26=$1;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      __Z13palette_derefP10_palette_t($28);
      var $29=$1;
      var $30=(($29+8)|0);
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=(($36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$38;
      _free($39);
      __label__ = 8; break;
    case 8: // $40
      var $41=$1;
      var $42=(($41+20)|0);
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $46
      var $47=$1;
      var $48=(($47+20)|0);
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$50;
      _free($51);
      __label__ = 10; break;
    case 10: // $52
      var $53=$1;
      var $54=$53;
      _free($54);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19palette_client_freeP15_palette_client["X"]=1;

function __Z29palette_client_get_dirty_listP15_palette_clientPjS1_($client, $mindirty, $maxdirty) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $temp=__stackBase__;
      $2=$client;
      $3=$mindirty;
      $4=$maxdirty;
      var $5=$3;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      HEAP32[(($12)>>2)]=$11;
      __label__ = 2; break;
    case 2: // $13
      var $14=$4;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$2;
      var $18=(($17+8)|0);
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$4;
      HEAP32[(($21)>>2)]=$20;
      __label__ = 4; break;
    case 4: // $22
      var $23=$2;
      var $24=(($23+8)|0);
      var $25=(($24+4)|0);
      var $26=HEAPU32[(($25)>>2)];
      var $27=$2;
      var $28=(($27+8)|0);
      var $29=(($28+8)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($26)>>>0) > (($30)>>>0);
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      $1=0;
      __label__ = 9; break;
    case 6: // $33
      var $34=$2;
      var $35=(($34+8)|0);
      var $36=$temp;
      var $37=$35;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];HEAP32[(($36+4)>>2)]=HEAP32[(($37+4)>>2)];HEAP32[(($36+8)>>2)]=HEAP32[(($37+8)>>2)];
      var $38=$2;
      var $39=(($38+8)|0);
      var $40=$2;
      var $41=(($40+20)|0);
      var $42=$39;
      var $43=$41;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($42)>>2)]=HEAP32[(($43)>>2)];HEAP32[(($42+4)>>2)]=HEAP32[(($43+4)>>2)];HEAP32[(($42+8)>>2)]=HEAP32[(($43+8)>>2)];
      var $44=$2;
      var $45=(($44+20)|0);
      var $46=$45;
      var $47=$temp;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($46)>>2)]=HEAP32[(($47)>>2)];HEAP32[(($46+4)>>2)]=HEAP32[(($47+4)>>2)];HEAP32[(($46+8)>>2)]=HEAP32[(($47+8)>>2)];
      var $48=$2;
      var $49=(($48+8)|0);
      var $50=(($49+4)|0);
      var $51=HEAPU32[(($50)>>2)];
      var $52=$2;
      var $53=(($52+8)|0);
      var $54=(($53+8)|0);
      var $55=HEAPU32[(($54)>>2)];
      var $56=(($51)>>>0) <= (($55)>>>0);
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$2;
      var $59=(($58+8)|0);
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=$2;
      var $64=(($63+8)|0);
      var $65=(($64+4)|0);
      var $66=HEAPU32[(($65)>>2)];
      var $67=Math.floor((($66)>>>0)/8);
      var $68=(($67) & 255);
      var $69=$2;
      var $70=(($69+8)|0);
      var $71=(($70+8)|0);
      var $72=HEAPU32[(($71)>>2)];
      var $73=Math.floor((($72)>>>0)/8);
      var $74=(($73+1)|0);
      var $75=$2;
      var $76=(($75+8)|0);
      var $77=(($76+4)|0);
      var $78=HEAPU32[(($77)>>2)];
      var $79=Math.floor((($78)>>>0)/8);
      var $80=(($74-$79)|0);
      _memset($62, $68, $80, 1);
      __label__ = 8; break;
    case 8: // $81
      var $82=$2;
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$2;
      var $88=(($87+4)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+8)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($86*$91)|0);
      var $93=$2;
      var $94=(($93+8)|0);
      var $95=(($94+4)|0);
      HEAP32[(($95)>>2)]=$92;
      var $96=$2;
      var $97=(($96+8)|0);
      var $98=(($97+8)|0);
      HEAP32[(($98)>>2)]=0;
      var $99=$2;
      var $100=(($99+20)|0);
      var $101=(($100)|0);
      var $102=HEAP32[(($101)>>2)];
      $1=$102;
      __label__ = 9; break;
    case 9: // $103
      var $104=$1;
      STACKTOP = __stackBase__;
      return $104;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z29palette_client_get_dirty_listP15_palette_clientPjS1_["X"]=1;

function __Z23palette_entry_set_colorP10_palette_tjj($palette, $index, $rgb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $groupnum;
      $1=$palette;
      $2=$index;
      $3=$rgb;
      var $4=$2;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=(($4)>>>0) >= (($7)>>>0);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=$1;
      var $12=(($11+280)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+($10<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=(($15)|0)==(($16)|0);
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      __label__ = 7; break;
    case 3: // $19
      var $20=$3;
      var $21=$2;
      var $22=$1;
      var $23=(($22+280)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+($21<<2))|0);
      HEAP32[(($25)>>2)]=$20;
      $groupnum=0;
      __label__ = 4; break;
    case 4: // $26
      var $27=$groupnum;
      var $28=$1;
      var $29=(($28+8)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($27)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $32
      var $33=$1;
      var $34=$groupnum;
      var $35=$2;
      __ZL21update_adjusted_colorP10_palette_tjj($33, $34, $35);
      __label__ = 6; break;
    case 6: // $36
      var $37=$groupnum;
      var $38=(($37+1)|0);
      $groupnum=$38;
      __label__ = 4; break;
    case 7: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21update_adjusted_colorP10_palette_tjj($palette, $group, $index) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $finalindex;
      var $client;
      var $adjusted;
      $1=$palette;
      $2=$group;
      $3=$index;
      var $4=$2;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4*$7)|0);
      var $9=$3;
      var $10=(($8+$9)|0);
      $finalindex=$10;
      var $11=$3;
      var $12=$1;
      var $13=(($12+280)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+($11<<2))|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$2;
      var $18=$1;
      var $19=(($18+296)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+($17<<2))|0);
      var $22=HEAPF32[(($21)>>2)];
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=HEAPF32[(($24)>>2)];
      var $26=$22+$25;
      var $27=$2;
      var $28=$1;
      var $29=(($28+300)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+($27<<2))|0);
      var $32=HEAPF32[(($31)>>2)];
      var $33=$3;
      var $34=$1;
      var $35=(($34+284)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+($33<<2))|0);
      var $38=HEAPF32[(($37)>>2)];
      var $39=$32*$38;
      var $40=$1;
      var $41=(($40+16)|0);
      var $42=HEAPF32[(($41)>>2)];
      var $43=$39*$42;
      var $44=$1;
      var $45=(($44+24)|0);
      var $46=(($45)|0);
      var $47=__ZL20adjust_palette_entryjffPKh($16, $26, $43, $46);
      $adjusted=$47;
      var $48=$finalindex;
      var $49=$1;
      var $50=(($49+288)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+($48<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$adjusted;
      var $55=(($53)|0)==(($54)|0);
      if ($55) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $56
      __label__ = 12; break;
    case 2: // $57
      var $58=$adjusted;
      var $59=$finalindex;
      var $60=$1;
      var $61=(($60+288)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+($59<<2))|0);
      HEAP32[(($63)>>2)]=$58;
      var $64=$adjusted;
      var $65=__ZL12rgb_to_rgb15j6940($64);
      var $66=(($65)&65535);
      var $67=$finalindex;
      var $68=$1;
      var $69=(($68+292)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+($67<<2))|0);
      HEAP32[(($71)>>2)]=$66;
      var $72=$1;
      var $73=(($72+304)|0);
      var $74=HEAP32[(($73)>>2)];
      $client=$74;
      __label__ = 3; break;
    case 3: // $75
      var $76=$client;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $78
      var $79=$finalindex;
      var $80=(($79)>>>0)%32;
      var $81=1 << $80;
      var $82=$finalindex;
      var $83=Math.floor((($82)>>>0)/32);
      var $84=$client;
      var $85=(($84+8)|0);
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87+($83<<2))|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89 | $81;
      HEAP32[(($88)>>2)]=$90;
      var $91=$client;
      var $92=(($91+8)|0);
      var $93=(($92+4)|0);
      var $94=HEAPU32[(($93)>>2)];
      var $95=$finalindex;
      var $96=(($94)>>>0) < (($95)>>>0);
      if ($96) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $97
      var $98=$client;
      var $99=(($98+8)|0);
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $105 = $101;__label__ = 7; break;
    case 6: // $102
      var $103=$finalindex;
      var $105 = $103;__label__ = 7; break;
    case 7: // $104
      var $105;
      var $106=$client;
      var $107=(($106+8)|0);
      var $108=(($107+4)|0);
      HEAP32[(($108)>>2)]=$105;
      var $109=$client;
      var $110=(($109+8)|0);
      var $111=(($110+8)|0);
      var $112=HEAPU32[(($111)>>2)];
      var $113=$finalindex;
      var $114=(($112)>>>0) > (($113)>>>0);
      if ($114) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $115
      var $116=$client;
      var $117=(($116+8)|0);
      var $118=(($117+8)|0);
      var $119=HEAP32[(($118)>>2)];
      var $123 = $119;__label__ = 10; break;
    case 9: // $120
      var $121=$finalindex;
      var $123 = $121;__label__ = 10; break;
    case 10: // $122
      var $123;
      var $124=$client;
      var $125=(($124+8)|0);
      var $126=(($125+8)|0);
      HEAP32[(($126)>>2)]=$123;
      __label__ = 11; break;
    case 11: // $127
      var $128=$client;
      var $129=(($128)|0);
      var $130=HEAP32[(($129)>>2)];
      $client=$130;
      __label__ = 3; break;
    case 12: // $131
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21update_adjusted_colorP10_palette_tjj["X"]=1;

function __Z26palette_entry_set_contrastP10_palette_tjf($palette, $index, $contrast) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $groupnum;
      $1=$palette;
      $2=$index;
      $3=$contrast;
      var $4=$2;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=(($4)>>>0) >= (($7)>>>0);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=$1;
      var $12=(($11+284)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+($10<<2))|0);
      var $15=HEAPF32[(($14)>>2)];
      var $16=$3;
      var $17=$15 == $16;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      __label__ = 7; break;
    case 3: // $19
      var $20=$3;
      var $21=$2;
      var $22=$1;
      var $23=(($22+284)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+($21<<2))|0);
      HEAPF32[(($25)>>2)]=$20;
      $groupnum=0;
      __label__ = 4; break;
    case 4: // $26
      var $27=$groupnum;
      var $28=$1;
      var $29=(($28+8)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($27)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $32
      var $33=$1;
      var $34=$groupnum;
      var $35=$2;
      __ZL21update_adjusted_colorP10_palette_tjj($33, $34, $35);
      __label__ = 6; break;
    case 6: // $36
      var $37=$groupnum;
      var $38=(($37+1)|0);
      $groupnum=$38;
      __label__ = 4; break;
    case 7: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z26palette_group_set_contrastP10_palette_tjf($palette, $group, $contrast) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $index;
      $1=$palette;
      $2=$group;
      $3=$contrast;
      var $4=$2;
      var $5=$1;
      var $6=(($5+8)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=(($4)>>>0) >= (($7)>>>0);
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=$1;
      var $12=(($11+300)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+($10<<2))|0);
      var $15=HEAPF32[(($14)>>2)];
      var $16=$3;
      var $17=$15 == $16;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      __label__ = 7; break;
    case 3: // $19
      var $20=$3;
      var $21=$2;
      var $22=$1;
      var $23=(($22+300)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+($21<<2))|0);
      HEAPF32[(($25)>>2)]=$20;
      $index=0;
      __label__ = 4; break;
    case 4: // $26
      var $27=$index;
      var $28=$1;
      var $29=(($28+4)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($27)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $32
      var $33=$1;
      var $34=$2;
      var $35=$index;
      __ZL21update_adjusted_colorP10_palette_tjj($33, $34, $35);
      __label__ = 6; break;
    case 6: // $36
      var $37=$index;
      var $38=(($37+1)|0);
      $index=$38;
      __label__ = 4; break;
    case 7: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20bitmap_format_to_bpp14_bitmap_format($format) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$format;
      var $3=$2;
      if ($3 == 1) {
        __label__ = 1; break;
      }
      else if ($3 == 2 || $3 == 5 || $3 == 8) {
        __label__ = 2; break;
      }
      else if ($3 == 3 || $3 == 6 || $3 == 7) {
        __label__ = 3; break;
      }
      else if ($3 == 4) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $4
      $1=8;
      __label__ = 7; break;
    case 2: // $5
      $1=16;
      __label__ = 7; break;
    case 3: // $6
      $1=32;
      __label__ = 7; break;
    case 4: // $7
      $1=64;
      __label__ = 7; break;
    case 5: // $8
      __label__ = 6; break;
    case 6: // $9
      $1=0;
      __label__ = 7; break;
    case 7: // $10
      var $11=$1;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19vbi_metadata_unpackP13_vbi_metadataPjPKh($vbi, $framenum, $source) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$vbi;
      $2=$framenum;
      $3=$source;
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$3;
      var $8=(($7)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$10 << 16;
      var $12=$3;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$15 << 8;
      var $17=$11 | $16;
      var $18=$3;
      var $19=(($18+2)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$17 | $21;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 2; break;
    case 2: // $24
      var $25=$3;
      var $26=(($25+3)|0);
      var $27=HEAP8[($26)];
      var $28=$1;
      var $29=(($28)|0);
      HEAP8[($29)]=$27;
      var $30=$3;
      var $31=(($30+4)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$33 << 16;
      var $35=$3;
      var $36=(($35+5)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$38 << 8;
      var $40=$34 | $39;
      var $41=$3;
      var $42=(($41+6)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$40 | $44;
      var $46=$1;
      var $47=(($46+4)|0);
      HEAP32[(($47)>>2)]=$45;
      var $48=$3;
      var $49=(($48+7)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$51 << 16;
      var $53=$3;
      var $54=(($53+8)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 << 8;
      var $58=$52 | $57;
      var $59=$3;
      var $60=(($59+9)|0);
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=$58 | $62;
      var $64=$1;
      var $65=(($64+8)|0);
      HEAP32[(($65)>>2)]=$63;
      var $66=$3;
      var $67=(($66+10)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=$69 << 16;
      var $71=$3;
      var $72=(($71+11)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$74 << 8;
      var $76=$70 | $75;
      var $77=$3;
      var $78=(($77+12)|0);
      var $79=HEAPU8[($78)];
      var $80=(($79)&255);
      var $81=$76 | $80;
      var $82=$1;
      var $83=(($82+12)|0);
      HEAP32[(($83)>>2)]=$81;
      var $84=$3;
      var $85=(($84+13)|0);
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$87 << 16;
      var $89=$3;
      var $90=(($89+14)|0);
      var $91=HEAPU8[($90)];
      var $92=(($91)&255);
      var $93=$92 << 8;
      var $94=$88 | $93;
      var $95=$3;
      var $96=(($95+15)|0);
      var $97=HEAPU8[($96)];
      var $98=(($97)&255);
      var $99=$94 | $98;
      var $100=$1;
      var $101=(($100+16)|0);
      HEAP32[(($101)>>2)]=$99;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19vbi_metadata_unpackP13_vbi_metadataPjPKh["X"]=1;

function __ZN8bitmap_tC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=$2;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$2;
  var $9=(($8+8)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=$2;
  var $11=(($10+12)|0);
  HEAP32[(($11)>>2)]=0;
  var $12=$2;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=0;
  var $14=$2;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=0;
  var $16=$2;
  var $17=(($16+24)|0);
  HEAP32[(($17)>>2)]=0;
  var $18=$2;
  var $19=(($18+28)|0);
  HEAP32[(($19)>>2)]=0;
  var $20=$2;
  var $21=(($20+32)|0);
  var $22=(($21+8)|0);
  HEAP32[(($22)>>2)]=0;
  var $23=$2;
  var $24=(($23+32)|0);
  var $25=(($24)|0);
  HEAP32[(($25)>>2)]=0;
  var $26=$2;
  var $27=(($26+32)|0);
  var $28=(($27+12)|0);
  HEAP32[(($28)>>2)]=0;
  var $29=$2;
  var $30=(($29+32)|0);
  var $31=(($30+4)|0);
  HEAP32[(($31)>>2)]=0;
  ;
  return;
}


function __ZL20adjust_palette_entryjffPKh($entry, $brightness, $contrast, $gamma_map) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $r;
  var $g;
  var $b;
  var $a;
  $1=$entry;
  $2=$brightness;
  $3=$contrast;
  $4=$gamma_map;
  var $5=$1;
  var $6=$5 >>> 16;
  var $7=$6 & 255;
  var $8=$4;
  var $9=(($8+$7)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$3;
  var $13=$11*$12;
  var $14=$2;
  var $15=$13+$14;
  var $16=(($15)|0);
  var $17=__ZL9rgb_clampi6971($16);
  var $18=(($17)&255);
  $r=$18;
  var $19=$1;
  var $20=$19 >>> 8;
  var $21=$20 & 255;
  var $22=$4;
  var $23=(($22+$21)|0);
  var $24=HEAPU8[($23)];
  var $25=(($24)&255);
  var $26=$3;
  var $27=$25*$26;
  var $28=$2;
  var $29=$27+$28;
  var $30=(($29)|0);
  var $31=__ZL9rgb_clampi6971($30);
  var $32=(($31)&255);
  $g=$32;
  var $33=$1;
  var $34=$33 & 255;
  var $35=$4;
  var $36=(($35+$34)|0);
  var $37=HEAPU8[($36)];
  var $38=(($37)&255);
  var $39=$3;
  var $40=$38*$39;
  var $41=$2;
  var $42=$40+$41;
  var $43=(($42)|0);
  var $44=__ZL9rgb_clampi6971($43);
  var $45=(($44)&255);
  $b=$45;
  var $46=$1;
  var $47=$46 >>> 24;
  var $48=$47 & 255;
  $a=$48;
  var $49=$a;
  var $50=$49 & 255;
  var $51=$50 << 24;
  var $52=$r;
  var $53=$52 & 255;
  var $54=$53 << 16;
  var $55=$51 | $54;
  var $56=$g;
  var $57=$56 & 255;
  var $58=$57 << 8;
  var $59=$55 | $58;
  var $60=$b;
  var $61=$60 & 255;
  var $62=$59 | $61;
  ;
  return $62;
}
__ZL20adjust_palette_entryjffPKh["X"]=1;

function __ZN8bitmap_tD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3+28)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      __Z13palette_derefP10_palette_t($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$2;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      _free($19);
      __label__ = 4; break;
    case 4: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18bitmap_set_paletteP8bitmap_tP10_palette_t($bitmap, $palette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$bitmap;
      $2=$palette;
      var $3=$1;
      var $4=$3;
      var $5=(($4+28)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$1;
      var $10=$9;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      __Z13palette_derefP10_palette_t($12);
      var $13=$1;
      var $14=$13;
      var $15=(($14+28)|0);
      HEAP32[(($15)>>2)]=0;
      __label__ = 2; break;
    case 2: // $16
      var $17=$2;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$2;
      __Z11palette_refP10_palette_t($20);
      var $21=$2;
      var $22=$1;
      var $23=$22;
      var $24=(($23+28)|0);
      HEAP32[(($24)>>2)]=$21;
      __label__ = 4; break;
    case 4: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8bitmap_tC2Eii14_bitmap_formatii($this, $_width, $_height, $_format, $_xslop, $_yslop) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $allocbytes;
      $1=$this;
      $2=$_width;
      $3=$_height;
      $4=$_format;
      $5=$_xslop;
      $6=$_yslop;
      var $7=$1;
      var $8=$7;
      var $9=$7;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=$7;
      var $12=(($11+4)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$2;
      var $14=$5;
      var $15=((($14<<1))|0);
      var $16=(($13+$15)|0);
      var $17=(($16+7)|0);
      var $18=$17 & -8;
      var $19=$7;
      var $20=(($19+8)|0);
      HEAP32[(($20)>>2)]=$18;
      var $21=$2;
      var $22=$7;
      var $23=(($22+12)|0);
      HEAP32[(($23)>>2)]=$21;
      var $24=$3;
      var $25=$7;
      var $26=(($25+16)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$4;
      var $28=$7;
      var $29=(($28+20)|0);
      HEAP32[(($29)>>2)]=$27;
      var $30=$4;
      var $31=__Z20bitmap_format_to_bpp14_bitmap_format($30);
      var $32=$7;
      var $33=(($32+24)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$7;
      var $35=(($34+28)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=$7;
      var $37=(($36+32)|0);
      var $38=(($37+8)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=$7;
      var $40=(($39+32)|0);
      var $41=(($40)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=$7;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-1)|0);
      var $46=$7;
      var $47=(($46+32)|0);
      var $48=(($47+4)|0);
      HEAP32[(($48)>>2)]=$45;
      var $49=$7;
      var $50=(($49+16)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51-1)|0);
      var $53=$7;
      var $54=(($53+32)|0);
      var $55=(($54+12)|0);
      HEAP32[(($55)>>2)]=$52;
      var $56=$7;
      var $57=(($56+24)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $60
      var $61=___cxa_allocate_exception(4);
      var $62=$61;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($62);
      ___cxa_throw($61, __ZTISt9bad_alloc, 2);
      throw "Reached an unreachable!"
    case 2: // $63
      var $64=$7;
      var $65=(($64+8)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$7;
      var $68=(($67+16)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$6;
      var $71=((($70<<1))|0);
      var $72=(($69+$71)|0);
      var $73=(($66*$72)|0);
      var $74=$7;
      var $75=(($74+24)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($73*$76)|0);
      var $78=(((($77)|0)/8)|0);
      $allocbytes=$78;
      var $79=$allocbytes;
      var $80=_malloc($79);
      var $81=$7;
      var $82=(($81)|0);
      HEAP32[(($82)>>2)]=$80;
      var $83=$7;
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)==0;
      if ($86) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $87
      var $88=___cxa_allocate_exception(4);
      var $89=$88;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($89);
      ___cxa_throw($88, __ZTISt9bad_alloc, 2);
      throw "Reached an unreachable!"
    case 4: // $90
      var $91=$7;
      var $92=(($91)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$allocbytes;
      _memset($93, 0, $94, 1);
      var $95=$7;
      var $96=(($95)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$7;
      var $99=(($98+8)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$6;
      var $102=(($100*$101)|0);
      var $103=$5;
      var $104=(($102+$103)|0);
      var $105=$7;
      var $106=(($105+24)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(((($107)|0)/8)|0);
      var $109=(($104*$108)|0);
      var $110=(($97+$109)|0);
      var $111=$7;
      var $112=(($111+4)|0);
      HEAP32[(($112)>>2)]=$110;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8bitmap_tC2Eii14_bitmap_formatii["X"]=1;

function __ZN8bitmap_tC2EPviii14_bitmap_format($this, $_base, $_width, $_height, $_rowpixels, $_format) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $1=$this;
      $2=$_base;
      $3=$_width;
      $4=$_height;
      $5=$_rowpixels;
      $6=$_format;
      var $7=$1;
      var $8=$7;
      var $9=$7;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=$2;
      var $12=$7;
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$5;
      var $15=$7;
      var $16=(($15+8)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$3;
      var $18=$7;
      var $19=(($18+12)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$4;
      var $21=$7;
      var $22=(($21+16)|0);
      HEAP32[(($22)>>2)]=$20;
      var $23=$6;
      var $24=$7;
      var $25=(($24+20)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$6;
      var $27=__Z20bitmap_format_to_bpp14_bitmap_format($26);
      var $28=$7;
      var $29=(($28+24)|0);
      HEAP32[(($29)>>2)]=$27;
      var $30=$7;
      var $31=(($30+28)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=$7;
      var $33=(($32+32)|0);
      var $34=(($33+8)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=$7;
      var $36=(($35+32)|0);
      var $37=(($36)|0);
      HEAP32[(($37)>>2)]=0;
      var $38=$7;
      var $39=(($38+12)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40-1)|0);
      var $42=$7;
      var $43=(($42+32)|0);
      var $44=(($43+4)|0);
      HEAP32[(($44)>>2)]=$41;
      var $45=$7;
      var $46=(($45+16)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47-1)|0);
      var $49=$7;
      var $50=(($49+32)|0);
      var $51=(($50+12)|0);
      HEAP32[(($51)>>2)]=$48;
      var $52=$7;
      var $53=(($52+24)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)==0;
      if ($55) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $56
      var $57=___cxa_allocate_exception(4);
      var $58=$57;
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($58);
      ___cxa_throw($57, __ZTISt9bad_alloc, 2);
      throw "Reached an unreachable!"
    case 2: // $59
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN8bitmap_tC2EPviii14_bitmap_format["X"]=1;

function __ZL9sect_rectP10_rectanglePKS_6986($dst, $src) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$dst;
      $2=$src;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0) > (($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$1;
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$13;
      __label__ = 2; break;
    case 2: // $16
      var $17=$2;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($19)|0) < (($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$2;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$1;
      var $29=(($28+4)|0);
      HEAP32[(($29)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $30
      var $31=$2;
      var $32=(($31+8)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+8)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($33)|0) > (($36)|0);
      if ($37) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $38
      var $39=$2;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$1;
      var $43=(($42+8)|0);
      HEAP32[(($43)>>2)]=$41;
      __label__ = 6; break;
    case 6: // $44
      var $45=$2;
      var $46=(($45+12)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$1;
      var $49=(($48+12)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($47)|0) < (($50)|0);
      if ($51) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $52
      var $53=$2;
      var $54=(($53+12)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$1;
      var $57=(($56+12)|0);
      HEAP32[(($57)>>2)]=$55;
      __label__ = 8; break;
    case 8: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9sect_rectP10_rectanglePKS_6986["X"]=1;

function __Z11bitmap_fillP8bitmap_tPK10_rectanglej($dest, $cliprect, $color) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $fill=__stackBase__;
      var $x;
      var $y;
      var $destrow;
      var $destrow0;
      var $destrow1;
      var $destrow02;
      var $destrow3;
      var $destrow04;
      $1=$dest;
      $2=$cliprect;
      $3=$color;
      var $4=$1;
      var $5=$4;
      var $6=(($5+32)|0);
      var $7=$fill;
      var $8=$6;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($7)>>2)]=HEAP32[(($8)>>2)];HEAP32[(($7+4)>>2)]=HEAP32[(($8+4)>>2)];HEAP32[(($7+8)>>2)]=HEAP32[(($8+8)>>2)];HEAP32[(($7+12)>>2)]=HEAP32[(($8+12)>>2)];
      var $9=$2;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      __ZL9sect_rectP10_rectanglePKS_6986($fill, $12);
      __label__ = 2; break;
    case 2: // $13
      var $14=(($fill)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($fill+4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($15)|0) > (($17)|0);
      if ($18) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $19
      var $20=(($fill+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($fill+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($21)|0) > (($23)|0);
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      __label__ = 61; break;
    case 5: // $26
      var $27=$1;
      var $28=$27;
      var $29=(($28+24)|0);
      var $30=HEAP32[(($29)>>2)];
      if ($30 == 8) {
        __label__ = 6; break;
      }
      else if ($30 == 16) {
        __label__ = 11; break;
      }
      else if ($30 == 32) {
        __label__ = 27; break;
      }
      else if ($30 == 64) {
        __label__ = 44; break;
      }
      else {
      __label__ = 61; break;
      }
      
    case 6: // $31
      var $32=(($fill+8)|0);
      var $33=HEAP32[(($32)>>2)];
      $y=$33;
      __label__ = 7; break;
    case 7: // $34
      var $35=$y;
      var $36=(($fill+12)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($35)|0) <= (($37)|0);
      if ($38) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $39
      var $40=$1;
      var $41=$40;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$y;
      var $45=$1;
      var $46=$45;
      var $47=(($46+8)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($44*$48)|0);
      var $50=(($43+$49)|0);
      var $51=(($fill)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($50+$52)|0);
      var $54=$3;
      var $55=(($54) & 255);
      var $56=(($55)&255);
      var $57=(($56) & 255);
      var $58=(($fill+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+1)|0);
      var $61=(($fill)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($60-$62)|0);
      _memset($53, $57, $63, 1);
      __label__ = 9; break;
    case 9: // $64
      var $65=$y;
      var $66=(($65+1)|0);
      $y=$66;
      __label__ = 7; break;
    case 10: // $67
      __label__ = 61; break;
    case 11: // $68
      var $69=$3;
      var $70=$69 >>> 8;
      var $71=(($70) & 255);
      var $72=(($71)&255);
      var $73=$3;
      var $74=(($73) & 255);
      var $75=(($74)&255);
      var $76=(($72)|0)==(($75)|0);
      if ($76) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $77
      var $78=(($fill+8)|0);
      var $79=HEAP32[(($78)>>2)];
      $y=$79;
      __label__ = 13; break;
    case 13: // $80
      var $81=$y;
      var $82=(($fill+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($81)|0) <= (($83)|0);
      if ($84) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $85
      var $86=$1;
      var $87=$86;
      var $88=(($87+4)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89;
      var $91=$y;
      var $92=$1;
      var $93=$92;
      var $94=(($93+8)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($91*$95)|0);
      var $97=(($90+($96<<1))|0);
      var $98=(($fill)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($97+($99<<1))|0);
      var $101=$100;
      var $102=$3;
      var $103=(($102) & 255);
      var $104=(($103)&255);
      var $105=(($104) & 255);
      var $106=(($fill+4)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107+1)|0);
      var $109=(($fill)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($108-$110)|0);
      var $112=((($111<<1))|0);
      _memset($101, $105, $112, 1);
      __label__ = 15; break;
    case 15: // $113
      var $114=$y;
      var $115=(($114+1)|0);
      $y=$115;
      __label__ = 13; break;
    case 16: // $116
      __label__ = 26; break;
    case 17: // $117
      var $118=$1;
      var $119=$118;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$121;
      var $123=(($fill+8)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$1;
      var $126=$125;
      var $127=(($126+8)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($124*$128)|0);
      var $130=(($122+($129<<1))|0);
      var $131=(($130)|0);
      $destrow=$131;
      var $132=(($fill)|0);
      var $133=HEAP32[(($132)>>2)];
      $x=$133;
      __label__ = 18; break;
    case 18: // $134
      var $135=$x;
      var $136=(($fill+4)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($135)|0) <= (($137)|0);
      if ($138) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $139
      var $140=$3;
      var $141=(($140) & 65535);
      var $142=$x;
      var $143=$destrow;
      var $144=(($143+($142<<1))|0);
      HEAP16[(($144)>>1)]=$141;
      __label__ = 20; break;
    case 20: // $145
      var $146=$x;
      var $147=(($146+1)|0);
      $x=$147;
      __label__ = 18; break;
    case 21: // $148
      var $149=$1;
      var $150=$149;
      var $151=(($150+4)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$152;
      var $154=(($fill+8)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$1;
      var $157=$156;
      var $158=(($157+8)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($155*$159)|0);
      var $161=(($153+($160<<1))|0);
      var $162=(($fill)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($161+($163<<1))|0);
      $destrow0=$164;
      var $165=(($fill+8)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166+1)|0);
      $y=$167;
      __label__ = 22; break;
    case 22: // $168
      var $169=$y;
      var $170=(($fill+12)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($169)|0) <= (($171)|0);
      if ($172) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $173
      var $174=$1;
      var $175=$174;
      var $176=(($175+4)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$177;
      var $179=$y;
      var $180=$1;
      var $181=$180;
      var $182=(($181+8)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=(($179*$183)|0);
      var $185=(($178+($184<<1))|0);
      var $186=(($fill)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($185+($187<<1))|0);
      $destrow=$188;
      var $189=$destrow;
      var $190=$189;
      var $191=$destrow0;
      var $192=$191;
      var $193=(($fill+4)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194+1)|0);
      var $196=(($fill)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($195-$197)|0);
      var $199=((($198<<1))|0);
      assert($199 % 1 === 0, 'memcpy given ' + $199 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($190, $192, $199, 1);
      __label__ = 24; break;
    case 24: // $200
      var $201=$y;
      var $202=(($201+1)|0);
      $y=$202;
      __label__ = 22; break;
    case 25: // $203
      __label__ = 26; break;
    case 26: // $204
      __label__ = 61; break;
    case 27: // $205
      var $206=$3;
      var $207=$206 >>> 8;
      var $208=(($207) & 255);
      var $209=(($208)&255);
      var $210=$3;
      var $211=(($210) & 255);
      var $212=(($211)&255);
      var $213=(($209)|0)==(($212)|0);
      if ($213) { __label__ = 28; break; } else { __label__ = 34; break; }
    case 28: // $214
      var $215=$3;
      var $216=$215 >>> 16;
      var $217=(($216) & 65535);
      var $218=(($217)&65535);
      var $219=$3;
      var $220=(($219) & 65535);
      var $221=(($220)&65535);
      var $222=(($218)|0)==(($221)|0);
      if ($222) { __label__ = 29; break; } else { __label__ = 34; break; }
    case 29: // $223
      var $224=(($fill+8)|0);
      var $225=HEAP32[(($224)>>2)];
      $y=$225;
      __label__ = 30; break;
    case 30: // $226
      var $227=$y;
      var $228=(($fill+12)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=(($227)|0) <= (($229)|0);
      if ($230) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $231
      var $232=$1;
      var $233=$232;
      var $234=(($233+4)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=$235;
      var $237=$y;
      var $238=$1;
      var $239=$238;
      var $240=(($239+8)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($237*$241)|0);
      var $243=(($236+($242<<2))|0);
      var $244=(($fill)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=(($243+($245<<2))|0);
      var $247=$246;
      var $248=$3;
      var $249=(($248) & 255);
      var $250=(($249)&255);
      var $251=(($250) & 255);
      var $252=(($fill+4)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=(($253+1)|0);
      var $255=(($fill)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=(($254-$256)|0);
      var $258=((($257<<2))|0);
      _memset($247, $251, $258, 1);
      __label__ = 32; break;
    case 32: // $259
      var $260=$y;
      var $261=(($260+1)|0);
      $y=$261;
      __label__ = 30; break;
    case 33: // $262
      __label__ = 43; break;
    case 34: // $263
      var $264=$1;
      var $265=$264;
      var $266=(($265+4)|0);
      var $267=HEAP32[(($266)>>2)];
      var $268=$267;
      var $269=(($fill+8)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=$1;
      var $272=$271;
      var $273=(($272+8)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($270*$274)|0);
      var $276=(($268+($275<<2))|0);
      var $277=(($276)|0);
      $destrow1=$277;
      var $278=(($fill)|0);
      var $279=HEAP32[(($278)>>2)];
      $x=$279;
      __label__ = 35; break;
    case 35: // $280
      var $281=$x;
      var $282=(($fill+4)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=(($281)|0) <= (($283)|0);
      if ($284) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $285
      var $286=$3;
      var $287=$x;
      var $288=$destrow1;
      var $289=(($288+($287<<2))|0);
      HEAP32[(($289)>>2)]=$286;
      __label__ = 37; break;
    case 37: // $290
      var $291=$x;
      var $292=(($291+1)|0);
      $x=$292;
      __label__ = 35; break;
    case 38: // $293
      var $294=$1;
      var $295=$294;
      var $296=(($295+4)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$297;
      var $299=(($fill+8)|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=$1;
      var $302=$301;
      var $303=(($302+8)|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=(($300*$304)|0);
      var $306=(($298+($305<<2))|0);
      var $307=(($fill)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=(($306+($308<<2))|0);
      $destrow02=$309;
      var $310=(($fill+8)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(($311+1)|0);
      $y=$312;
      __label__ = 39; break;
    case 39: // $313
      var $314=$y;
      var $315=(($fill+12)|0);
      var $316=HEAP32[(($315)>>2)];
      var $317=(($314)|0) <= (($316)|0);
      if ($317) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $318
      var $319=$1;
      var $320=$319;
      var $321=(($320+4)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=$322;
      var $324=$y;
      var $325=$1;
      var $326=$325;
      var $327=(($326+8)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=(($324*$328)|0);
      var $330=(($323+($329<<2))|0);
      var $331=(($fill)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=(($330+($332<<2))|0);
      $destrow1=$333;
      var $334=$destrow1;
      var $335=$334;
      var $336=$destrow02;
      var $337=$336;
      var $338=(($fill+4)|0);
      var $339=HEAP32[(($338)>>2)];
      var $340=(($339+1)|0);
      var $341=(($fill)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=(($340-$342)|0);
      var $344=((($343<<2))|0);
      assert($344 % 1 === 0, 'memcpy given ' + $344 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($335, $337, $344, 1);
      __label__ = 41; break;
    case 41: // $345
      var $346=$y;
      var $347=(($346+1)|0);
      $y=$347;
      __label__ = 39; break;
    case 42: // $348
      __label__ = 43; break;
    case 43: // $349
      __label__ = 61; break;
    case 44: // $350
      var $351=$3;
      var $352=$351 >>> 8;
      var $353=(($352) & 255);
      var $354=(($353)&255);
      var $355=$3;
      var $356=(($355) & 255);
      var $357=(($356)&255);
      var $358=(($354)|0)==(($357)|0);
      if ($358) { __label__ = 45; break; } else { __label__ = 51; break; }
    case 45: // $359
      var $360=$3;
      var $361=$360 >>> 16;
      var $362=(($361) & 65535);
      var $363=(($362)&65535);
      var $364=$3;
      var $365=(($364) & 65535);
      var $366=(($365)&65535);
      var $367=(($363)|0)==(($366)|0);
      if ($367) { __label__ = 46; break; } else { __label__ = 51; break; }
    case 46: // $368
      var $369=(($fill+8)|0);
      var $370=HEAP32[(($369)>>2)];
      $y=$370;
      __label__ = 47; break;
    case 47: // $371
      var $372=$y;
      var $373=(($fill+12)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=(($372)|0) <= (($374)|0);
      if ($375) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $376
      var $377=$1;
      var $378=$377;
      var $379=(($378+4)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=$380;
      var $382=$y;
      var $383=$1;
      var $384=$383;
      var $385=(($384+8)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=(($382*$386)|0);
      var $388=(($381+($387<<3))|0);
      var $389=(($fill)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=(($388+($390<<3))|0);
      var $392=$391;
      var $393=$3;
      var $394=(($393) & 255);
      var $395=(($394)&255);
      var $396=(($395) & 255);
      var $397=(($fill+4)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=(($398+1)|0);
      var $400=(($fill)|0);
      var $401=HEAP32[(($400)>>2)];
      var $402=(($399-$401)|0);
      var $403=((($402<<2))|0);
      _memset($392, $396, $403, 1);
      __label__ = 49; break;
    case 49: // $404
      var $405=$y;
      var $406=(($405+1)|0);
      $y=$406;
      __label__ = 47; break;
    case 50: // $407
      __label__ = 60; break;
    case 51: // $408
      var $409=$1;
      var $410=$409;
      var $411=(($410+4)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=$412;
      var $414=(($fill+8)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=$1;
      var $417=$416;
      var $418=(($417+8)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=(($415*$419)|0);
      var $421=(($413+($420<<3))|0);
      var $422=(($421)|0);
      $destrow3=$422;
      var $423=(($fill)|0);
      var $424=HEAP32[(($423)>>2)];
      $x=$424;
      __label__ = 52; break;
    case 52: // $425
      var $426=$x;
      var $427=(($fill+4)|0);
      var $428=HEAP32[(($427)>>2)];
      var $429=(($426)|0) <= (($428)|0);
      if ($429) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $430
      var $431=$3;
      var $432$0=$431;
      var $432$1=0;
      var $433=$x;
      var $434=$destrow3;
      var $435=(($434+($433<<3))|0);
      var $st$6$0=(($435)|0);
      HEAP32[(($st$6$0)>>2)]=$432$0;
      var $st$6$1=(($435+4)|0);
      HEAP32[(($st$6$1)>>2)]=$432$1;
      __label__ = 54; break;
    case 54: // $436
      var $437=$x;
      var $438=(($437+1)|0);
      $x=$438;
      __label__ = 52; break;
    case 55: // $439
      var $440=$1;
      var $441=$440;
      var $442=(($441+4)|0);
      var $443=HEAP32[(($442)>>2)];
      var $444=$443;
      var $445=(($fill+8)|0);
      var $446=HEAP32[(($445)>>2)];
      var $447=$1;
      var $448=$447;
      var $449=(($448+8)|0);
      var $450=HEAP32[(($449)>>2)];
      var $451=(($446*$450)|0);
      var $452=(($444+($451<<3))|0);
      var $453=(($fill)|0);
      var $454=HEAP32[(($453)>>2)];
      var $455=(($452+($454<<3))|0);
      $destrow04=$455;
      var $456=(($fill+8)|0);
      var $457=HEAP32[(($456)>>2)];
      var $458=(($457+1)|0);
      $y=$458;
      __label__ = 56; break;
    case 56: // $459
      var $460=$y;
      var $461=(($fill+12)|0);
      var $462=HEAP32[(($461)>>2)];
      var $463=(($460)|0) <= (($462)|0);
      if ($463) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $464
      var $465=$1;
      var $466=$465;
      var $467=(($466+4)|0);
      var $468=HEAP32[(($467)>>2)];
      var $469=$468;
      var $470=$y;
      var $471=$1;
      var $472=$471;
      var $473=(($472+8)|0);
      var $474=HEAP32[(($473)>>2)];
      var $475=(($470*$474)|0);
      var $476=(($469+($475<<3))|0);
      var $477=(($fill)|0);
      var $478=HEAP32[(($477)>>2)];
      var $479=(($476+($478<<3))|0);
      $destrow3=$479;
      var $480=$destrow3;
      var $481=$480;
      var $482=$destrow04;
      var $483=$482;
      var $484=(($fill+4)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=(($485+1)|0);
      var $487=(($fill)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=(($486-$488)|0);
      var $490=((($489<<2))|0);
      assert($490 % 1 === 0, 'memcpy given ' + $490 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($481, $483, $490, 1);
      __label__ = 58; break;
    case 58: // $491
      var $492=$y;
      var $493=(($492+1)|0);
      $y=$493;
      __label__ = 56; break;
    case 59: // $494
      __label__ = 60; break;
    case 60: // $495
      __label__ = 61; break;
    case 61: // $496
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11bitmap_fillP8bitmap_tPK10_rectanglej["X"]=1;

function __Z10avi_createPKcPK15_avi_movie_infoPP9_avi_file($filename, $info, $file) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $newfile;
      var $filerr;
      var $stream;
      var $avierr;
      var $length=__stackBase__;
      $2=$filename;
      $3=$info;
      $4=$file;
      $newfile=0;
      var $5=$3;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=1498831189;
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      var $15=$3;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=1498765654;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=844715353;
      if ($23) { __label__ = 8; break; } else { __label__ = 4; break; }
    case 4: // $24
      var $25=$3;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 8; break; } else { __label__ = 5; break; }
    case 5: // $29
      var $30=$3;
      var $31=(($30+20)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $34
      var $35=$3;
      var $36=(($35+24)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $39
      var $40=$3;
      var $41=(($40+24)|0);
      var $42=HEAPU32[(($41)>>2)];
      var $43=(($42)>>>0)%8;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $45
      $1=14;
      __label__ = 31; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+28)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $51
      var $52=$3;
      var $53=(($52+44)|0);
      var $54=HEAPU32[(($53)>>2)];
      var $55=(($54)>>>0) > 2;
      if ($55) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $56
      var $57=$3;
      var $58=(($57+48)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)!=16;
      if ($60) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $61
      $1=15;
      __label__ = 31; break;
    case 13: // $62
      var $63=_malloc(356);
      var $64=$63;
      $newfile=$64;
      var $65=$newfile;
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $67
      $1=3;
      __label__ = 31; break;
    case 15: // $68
      var $69=$newfile;
      var $70=$69;
      _memset($70, 0, 356, 1);
      var $71=$newfile;
      var $72=(($71+4)|0);
      HEAP32[(($72)>>2)]=2;
      var $73=$2;
      var $74=$newfile;
      var $75=(($74)|0);
      var $76=_osd_open($73, 14, $75, $length);
      $filerr=$76;
      var $77=$filerr;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $avierr=8;
      __label__ = 24; break;
    case 17: // $80
      var $81=$newfile;
      var $82=(($81+8)|0);
      var $83=$3;
      var $84=$82;
      var $85=$83;
      assert(56 % 1 === 0, 'memcpy given ' + 56 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $85>>2, $$dest = $84>>2, $$stop = $$src + 14; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $86=$newfile;
      var $87=(($86+8)|0);
      var $88=(($87+12)|0);
      HEAP32[(($88)>>2)]=0;
      var $89=$newfile;
      var $90=(($89+8)|0);
      var $91=(($90+40)|0);
      HEAP32[(($91)>>2)]=0;
      var $92=_malloc(152);
      var $93=$92;
      var $94=$newfile;
      var $95=(($94+76)|0);
      HEAP32[(($95)>>2)]=$93;
      var $96=$newfile;
      var $97=(($96+76)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $100
      $avierr=3;
      __label__ = 24; break;
    case 19: // $101
      var $102=$newfile;
      var $103=(($102+76)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$104;
      _memset($105, 0, 152, 1);
      var $106=$newfile;
      var $107=(($106+72)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+1)|0);
      HEAP32[(($107)>>2)]=$109;
      var $110=$newfile;
      var $111=(($110+76)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112+$108*76)|0);
      $stream=$113;
      var $114=$stream;
      var $115=(($114)|0);
      HEAP32[(($115)>>2)]=1935960438;
      var $116=$newfile;
      var $117=(($116+8)|0);
      var $118=(($117)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$stream;
      var $121=(($120+4)|0);
      HEAP32[(($121)>>2)]=$119;
      var $122=$newfile;
      var $123=(($122+8)|0);
      var $124=(($123+4)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$stream;
      var $127=(($126+8)|0);
      HEAP32[(($127)>>2)]=$125;
      var $128=$newfile;
      var $129=(($128+8)|0);
      var $130=(($129+8)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$stream;
      var $133=(($132+12)|0);
      HEAP32[(($133)>>2)]=$131;
      var $134=$newfile;
      var $135=(($134+8)|0);
      var $136=(($135+16)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$stream;
      var $139=(($138+32)|0);
      HEAP32[(($139)>>2)]=$137;
      var $140=$newfile;
      var $141=(($140+8)|0);
      var $142=(($141+20)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$stream;
      var $145=(($144+36)|0);
      HEAP32[(($145)>>2)]=$143;
      var $146=$newfile;
      var $147=(($146+8)|0);
      var $148=(($147+24)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$stream;
      var $151=(($150+40)|0);
      HEAP32[(($151)>>2)]=$149;
      var $152=$newfile;
      var $153=(($152+8)|0);
      var $154=(($153+44)|0);
      var $155=HEAPU32[(($154)>>2)];
      var $156=(($155)>>>0) > 0;
      if ($156) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $157
      var $158=$newfile;
      var $159=(($158+72)|0);
      var $160=HEAPU32[(($159)>>2)];
      var $161=(($160+1)|0);
      HEAP32[(($159)>>2)]=$161;
      var $162=$newfile;
      var $163=(($162+76)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+$160*76)|0);
      $stream=$165;
      var $166=$stream;
      var $167=(($166)|0);
      HEAP32[(($167)>>2)]=1935963489;
      var $168=$newfile;
      var $169=(($168+8)|0);
      var $170=(($169+28)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$stream;
      var $173=(($172+4)|0);
      HEAP32[(($173)>>2)]=$171;
      var $174=$newfile;
      var $175=(($174+8)|0);
      var $176=(($175+32)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$stream;
      var $179=(($178+8)|0);
      HEAP32[(($179)>>2)]=$177;
      var $180=$newfile;
      var $181=(($180+8)|0);
      var $182=(($181+36)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$stream;
      var $185=(($184+12)|0);
      HEAP32[(($185)>>2)]=$183;
      var $186=$newfile;
      var $187=(($186+8)|0);
      var $188=(($187+44)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189) & 65535);
      var $191=$stream;
      var $192=(($191+52)|0);
      HEAP16[(($192)>>1)]=$190;
      var $193=$newfile;
      var $194=(($193+8)|0);
      var $195=(($194+48)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196) & 65535);
      var $198=$stream;
      var $199=(($198+54)|0);
      HEAP16[(($199)>>1)]=$197;
      var $200=$newfile;
      var $201=(($200+8)|0);
      var $202=(($201+52)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$stream;
      var $205=(($204+56)|0);
      HEAP32[(($205)>>2)]=$203;
      var $206=$newfile;
      var $207=__ZL19soundbuf_initializeP9_avi_file($206);
      $avierr=$207;
      var $208=$avierr;
      var $209=(($208)|0)!=0;
      if ($209) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $210
      __label__ = 24; break;
    case 22: // $211
      __label__ = 23; break;
    case 23: // $212
      var $213=$newfile;
      var $214=__ZL21write_initial_headersP9_avi_file($213);
      $avierr=$214;
      var $215=$newfile;
      var $216=$4;
      HEAP32[(($216)>>2)]=$215;
      $1=0;
      __label__ = 31; break;
    case 24: // $217
      var $218=$newfile;
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $220
      var $221=$newfile;
      var $222=(($221+76)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $225
      var $226=$newfile;
      var $227=(($226+76)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$228;
      _free($229);
      __label__ = 27; break;
    case 27: // $230
      var $231=$newfile;
      var $232=(($231)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($233)|0)!=0;
      if ($234) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $235
      var $236=$newfile;
      var $237=(($236)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=_osd_close($238);
      var $240=$2;
      var $241=_osd_rmfile($240);
      __label__ = 29; break;
    case 29: // $242
      var $243=$newfile;
      var $244=$243;
      _free($244);
      __label__ = 30; break;
    case 30: // $245
      var $246=$avierr;
      $1=$246;
      __label__ = 31; break;
    case 31: // $247
      var $248=$1;
      STACKTOP = __stackBase__;
      return $248;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10avi_createPKcPK15_avi_movie_infoPP9_avi_file["X"]=1;

function __ZL19soundbuf_initializeP9_avi_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $audio;
      var $video;
      $2=$file;
      var $3=$2;
      var $4=__ZL16get_audio_streamP9_avi_fileiPi($3, 0, 0);
      $audio=$4;
      var $5=$2;
      var $6=__ZL16get_video_streamP9_avi_file($5);
      $video=$6;
      var $7=$video;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=14;
      __label__ = 7; break;
    case 2: // $10
      var $11=$audio;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $1=0;
      __label__ = 7; break;
    case 4: // $14
      var $15=$2;
      var $16=(($15+8)|0);
      var $17=(($16+52)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18*2000)|0);
      var $20=Math.floor((($19)>>>0)/1000);
      var $21=$2;
      var $22=(($21+336)|0);
      HEAP32[(($22)>>2)]=$20;
      var $23=$2;
      var $24=(($23+336)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$2;
      var $27=(($26+8)|0);
      var $28=(($27+44)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($25*$29)|0);
      var $31=((($30<<1))|0);
      var $32=_malloc($31);
      var $33=$32;
      var $34=$2;
      var $35=(($34+332)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$2;
      var $37=(($36+332)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      $1=3;
      __label__ = 7; break;
    case 6: // $41
      var $42=$2;
      var $43=(($42+332)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44;
      var $46=$2;
      var $47=(($46+336)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$2;
      var $50=(($49+8)|0);
      var $51=(($50+44)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($48*$52)|0);
      var $54=((($53<<1))|0);
      _memset($45, 0, $54, 1);
      var $55=$video;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58$0=$57;
      var $58$1=0;
      var $$emscripten$temp$0$0=75;
      var $$emscripten$temp$0$1=0;
      var $59$0 = ((($58$0)>>>0)+((($58$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $59$1 = Math.min(Math.floor((((($58$0)>>>0)+((($58$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $60=$video;
      var $61=(($60+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63$0=$62;
      var $63$1=0;
      var $$emscripten$temp$1$0=100;
      var $$emscripten$temp$1$1=0;
      var $64$0 = ((($63$0)>>>0)+((($63$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $64$1 = Math.min(Math.floor((((($63$0)>>>0)+((($63$1)|0)*4294967296))*((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $65$0 = Math.floor(((($59$0)>>>0)+((($59$1)|0)*4294967296))/((($64$0)>>>0)+((($64$1)|0)*4294967296)))>>>0; var $65$1 = Math.min(Math.floor((Math.floor(((($59$0)>>>0)+((($59$1)|0)*4294967296))/((($64$0)>>>0)+((($64$1)|0)*4294967296))))/4294967296), 4294967295);
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $66$0 = ((($65$0)>>>0)+((($65$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $66$1 = Math.min(Math.floor((((($65$0)>>>0)+((($65$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $67$0=$66$0;
      var $67=$67$0;
      var $68=$2;
      var $69=(($68+352)|0);
      HEAP32[(($69)>>2)]=$67;
      $1=0;
      __label__ = 7; break;
    case 7: // $70
      var $71=$1;
      ;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19soundbuf_initializeP9_avi_file["X"]=1;

function __ZL21write_initial_headersP9_avi_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $avierr;
      var $strnum;
      $2=$file;
      var $3=$2;
      var $4=(($3+104)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$9$0=(($4)|0);
      HEAP32[(($st$9$0)>>2)]=$$emscripten$temp$0$0;
      var $st$9$1=(($4+4)|0);
      HEAP32[(($st$9$1)>>2)]=$$emscripten$temp$0$1;
      var $5=$2;
      var $6=__ZL10chunk_openP9_avi_filejjj($5, 1179011410, 541677121, 0);
      $avierr=$6;
      var $7=$avierr;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$avierr;
      $1=$10;
      __label__ = 25; break;
    case 2: // $11
      var $12=$2;
      var $13=__ZL10chunk_openP9_avi_filejjj($12, 1414744396, 1819436136, 0);
      $avierr=$13;
      var $14=$avierr;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$avierr;
      $1=$17;
      __label__ = 25; break;
    case 4: // $18
      var $19=$2;
      var $20=__ZL16write_avih_chunkP9_avi_filei($19, 1);
      $avierr=$20;
      var $21=$avierr;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$avierr;
      $1=$24;
      __label__ = 25; break;
    case 6: // $25
      $strnum=0;
      __label__ = 7; break;
    case 7: // $26
      var $27=$strnum;
      var $28=$2;
      var $29=(($28+72)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($27)|0) < (($30)|0);
      if ($31) { __label__ = 8; break; } else { __label__ = 20; break; }
    case 8: // $32
      var $33=$2;
      var $34=__ZL10chunk_openP9_avi_filejjj($33, 1414744396, 1819440243, 0);
      $avierr=$34;
      var $35=$avierr;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $37
      var $38=$avierr;
      $1=$38;
      __label__ = 25; break;
    case 10: // $39
      var $40=$2;
      var $41=$strnum;
      var $42=$2;
      var $43=(($42+76)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+$41*76)|0);
      var $46=__ZL16write_strh_chunkP9_avi_fileP11_avi_streami($40, $45, 1);
      $avierr=$46;
      var $47=$avierr;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $49
      var $50=$avierr;
      $1=$50;
      __label__ = 25; break;
    case 12: // $51
      var $52=$2;
      var $53=$strnum;
      var $54=$2;
      var $55=(($54+76)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+$53*76)|0);
      var $58=__ZL16write_strf_chunkP9_avi_fileP11_avi_stream($52, $57);
      $avierr=$58;
      var $59=$avierr;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $61
      var $62=$avierr;
      $1=$62;
      __label__ = 25; break;
    case 14: // $63
      var $64=$2;
      var $65=$strnum;
      var $66=$2;
      var $67=(($66+76)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+$65*76)|0);
      var $70=__ZL16write_indx_chunkP9_avi_fileP11_avi_streami($64, $69, 1);
      $avierr=$70;
      var $71=$avierr;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $73
      var $74=$avierr;
      $1=$74;
      __label__ = 25; break;
    case 16: // $75
      var $76=$2;
      var $77=__ZL11chunk_closeP9_avi_file($76);
      $avierr=$77;
      var $78=$avierr;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $80
      var $81=$avierr;
      $1=$81;
      __label__ = 25; break;
    case 18: // $82
      __label__ = 19; break;
    case 19: // $83
      var $84=$strnum;
      var $85=(($84+1)|0);
      $strnum=$85;
      __label__ = 7; break;
    case 20: // $86
      var $87=$2;
      var $88=__ZL11chunk_closeP9_avi_file($87);
      $avierr=$88;
      var $89=$avierr;
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $91
      var $92=$avierr;
      $1=$92;
      __label__ = 25; break;
    case 22: // $93
      var $94=$2;
      var $95=(($94+104)|0);
      var $st$2$0=(($95)|0);
      var $96$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($95+4)|0);
      var $96$1=HEAP32[(($st$2$1)>>2)];
      var $97=$2;
      var $98=(($97+316)|0);
      var $st$8$0=(($98)|0);
      HEAP32[(($st$8$0)>>2)]=$96$0;
      var $st$8$1=(($98+4)|0);
      HEAP32[(($st$8$1)>>2)]=$96$1;
      var $99=$2;
      var $100=__ZL10chunk_openP9_avi_filejjj($99, 1414744396, 1769369453, 0);
      $avierr=$100;
      var $101=$avierr;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $103
      var $104=$avierr;
      $1=$104;
      __label__ = 25; break;
    case 24: // $105
      var $106=$avierr;
      $1=$106;
      __label__ = 25; break;
    case 25: // $107
      var $108=$1;
      ;
      return $108;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21write_initial_headersP9_avi_file["X"]=1;

function __Z9avi_closeP9_avi_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $avierr;
      var $strnum;
      var $stream;
      var $huffyuv;
      var $table;
      $1=$file;
      $avierr=0;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==2;
      if ($5) { __label__ = 1; break; } else { __label__ = 19; break; }
    case 1: // $6
      var $7=$1;
      var $8=__ZL14soundbuf_flushP9_avi_filei($7, 0);
      $avierr=$8;
      var $9=$avierr;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=__ZL11chunk_closeP9_avi_file($12);
      $avierr=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$avierr;
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $17
      var $18=$1;
      var $19=(($18+112)|0);
      var $st$2$0=(($19)|0);
      var $20$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($19+4)|0);
      var $20$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $21=$20$0 == $$emscripten$temp$0$0 && $20$1 == $$emscripten$temp$0$1;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$1;
      var $24=__ZL16write_idx1_chunkP9_avi_file($23);
      $avierr=$24;
      __label__ = 6; break;
    case 6: // $25
      $strnum=0;
      __label__ = 7; break;
    case 7: // $26
      var $27=$strnum;
      var $28=$1;
      var $29=(($28+72)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($27)|0) < (($30)|0);
      if ($31) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $32
      var $33=$avierr;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $35
      var $36=$1;
      var $37=$strnum;
      var $38=$1;
      var $39=(($38+76)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+$37*76)|0);
      var $42=__ZL16write_strh_chunkP9_avi_fileP11_avi_streami($36, $41, 0);
      $avierr=$42;
      __label__ = 10; break;
    case 10: // $43
      var $44=$avierr;
      var $45=(($44)|0)==0;
      if ($45) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $46
      var $47=$1;
      var $48=$strnum;
      var $49=$1;
      var $50=(($49+76)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$48*76)|0);
      var $53=__ZL16write_indx_chunkP9_avi_fileP11_avi_streami($47, $52, 0);
      $avierr=$53;
      __label__ = 12; break;
    case 12: // $54
      __label__ = 13; break;
    case 13: // $55
      var $56=$strnum;
      var $57=(($56+1)|0);
      $strnum=$57;
      __label__ = 7; break;
    case 14: // $58
      var $59=$avierr;
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $61
      var $62=$1;
      var $63=__ZL16write_avih_chunkP9_avi_filei($62, 0);
      $avierr=$63;
      __label__ = 16; break;
    case 16: // $64
      var $65=$avierr;
      var $66=(($65)|0)==0;
      if ($66) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $67
      var $68=$1;
      var $69=__ZL11chunk_closeP9_avi_file($68);
      $avierr=$69;
      __label__ = 18; break;
    case 18: // $70
      __label__ = 19; break;
    case 19: // $71
      var $72=$1;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=_osd_close($74);
      $strnum=0;
      __label__ = 20; break;
    case 20: // $76
      var $77=$strnum;
      var $78=$1;
      var $79=(($78+72)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($77)|0) < (($80)|0);
      if ($81) { __label__ = 21; break; } else { __label__ = 33; break; }
    case 21: // $82
      var $83=$strnum;
      var $84=$1;
      var $85=(($84+76)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+$83*76)|0);
      $stream=$87;
      var $88=$stream;
      var $89=(($88+48)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90)|0)!=0;
      if ($91) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $92
      var $93=$stream;
      var $94=(($93+48)|0);
      var $95=HEAP32[(($94)>>2)];
      $huffyuv=$95;
      $table=0;
      __label__ = 23; break;
    case 23: // $96
      var $97=$table;
      var $98=(($97)>>>0) < 3;
      if ($98) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $99
      var $100=$table;
      var $101=$huffyuv;
      var $102=(($101+4)|0);
      var $103=(($102+$100*133380)|0);
      var $104=(($103+133376)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105)|0)!=0;
      if ($106) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $107
      var $108=$table;
      var $109=$huffyuv;
      var $110=(($109+4)|0);
      var $111=(($110+$108*133380)|0);
      var $112=(($111+133376)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113;
      _free($114);
      __label__ = 26; break;
    case 26: // $115
      __label__ = 27; break;
    case 27: // $116
      var $117=$table;
      var $118=(($117+1)|0);
      $table=$118;
      __label__ = 23; break;
    case 28: // $119
      var $120=$huffyuv;
      var $121=$120;
      _free($121);
      __label__ = 29; break;
    case 29: // $122
      var $123=$stream;
      var $124=(($123+20)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $127
      var $128=$stream;
      var $129=(($128+20)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$130;
      _free($131);
      __label__ = 31; break;
    case 31: // $132
      __label__ = 32; break;
    case 32: // $133
      var $134=$strnum;
      var $135=(($134+1)|0);
      $strnum=$135;
      __label__ = 20; break;
    case 33: // $136
      var $137=$1;
      var $138=(($137+332)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $141
      var $142=$1;
      var $143=(($142+332)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$144;
      _free($145);
      __label__ = 35; break;
    case 35: // $146
      var $147=$1;
      var $148=(($147+76)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $151
      var $152=$1;
      var $153=(($152+76)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$154;
      _free($155);
      __label__ = 37; break;
    case 37: // $156
      var $157=$1;
      var $158=(($157+64)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $161
      var $162=$1;
      var $163=(($162+64)|0);
      var $164=HEAP32[(($163)>>2)];
      _free($164);
      __label__ = 39; break;
    case 39: // $165
      var $166=$1;
      var $167=$166;
      _free($167);
      var $168=$avierr;
      ;
      return $168;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z9avi_closeP9_avi_file["X"]=1;

function __ZL14soundbuf_flushP9_avi_filei($file, $only_flush_full) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $stream;
      var $channelsamples;
      var $processedsamples;
      var $bytes_per_sample;
      var $finalchunks;
      var $avierr;
      var $chunknum;
      var $chunkid;
      var $channel;
      var $chunk;
      var $chunksamples;
      $2=$file;
      $3=$only_flush_full;
      var $4=$2;
      var $5=__ZL16get_audio_streamP9_avi_fileiPi($4, 0, 0);
      $stream=$5;
      var $6=$2;
      var $7=(($6+336)|0);
      var $8=HEAP32[(($7)>>2)];
      $channelsamples=$8;
      $processedsamples=0;
      var $9=$stream;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=0;
      __label__ = 43; break;
    case 2: // $12
      var $13=$2;
      var $14=$stream;
      var $15=__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream($13, $14);
      $chunkid=$15;
      var $16=$stream;
      var $17=(($16+52)|0);
      var $18=HEAPU16[(($17)>>1)];
      var $19=(($18)&65535);
      var $20=((($19<<1))|0);
      $bytes_per_sample=$20;
      var $21=$stream;
      var $22=(($21+24)|0);
      var $23=HEAP32[(($22)>>2)];
      $finalchunks=$23;
      $channel=0;
      __label__ = 3; break;
    case 3: // $24
      var $25=$channel;
      var $26=$stream;
      var $27=(($26+52)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=(($25)|0) < (($29)|0);
      if ($30) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $31
      var $32=$channelsamples;
      var $33=$channel;
      var $34=$2;
      var $35=(($34+340)|0);
      var $36=(($35+($33<<2))|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=(($32)>>>0) < (($37)>>>0);
      if ($38) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $39
      var $40=$channelsamples;
      var $48 = $40;__label__ = 7; break;
    case 6: // $41
      var $42=$channel;
      var $43=$2;
      var $44=(($43+340)|0);
      var $45=(($44+($42<<2))|0);
      var $46=HEAP32[(($45)>>2)];
      var $48 = $46;__label__ = 7; break;
    case 7: // $47
      var $48;
      $channelsamples=$48;
      __label__ = 8; break;
    case 8: // $49
      var $50=$channel;
      var $51=(($50+1)|0);
      $channel=$51;
      __label__ = 3; break;
    case 9: // $52
      var $53=$2;
      var $54=(($53+348)|0);
      var $55=HEAP32[(($54)>>2)];
      $chunknum=$55;
      __label__ = 10; break;
    case 10: // $56
      var $57=$chunknum;
      var $58=$stream;
      var $59=(($58+24)|0);
      var $60=HEAPU32[(($59)>>2)];
      var $61=(($57)>>>0) < (($60)>>>0);
      if ($61) { __label__ = 11; break; } else { __label__ = 34; break; }
    case 11: // $62
      var $63=$chunknum;
      var $64=$stream;
      var $65=(($64+20)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+$63*12)|0);
      $chunk=$67;
      var $68=$chunk;
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70-8)|0);
      var $72=$bytes_per_sample;
      var $73=Math.floor((($71)>>>0)/(($72)>>>0));
      $chunksamples=$73;
      var $74=$3;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $76
      var $77=$channelsamples;
      var $78=$chunksamples;
      var $79=(($77)>>>0) < (($78)>>>0);
      if ($79) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $80
      __label__ = 34; break;
    case 14: // $81
      var $82=$channelsamples;
      var $83=(($82)|0) > 0;
      if ($83) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $84
      var $85=$channelsamples;
      var $86=$chunksamples;
      var $87=(($85)>>>0) < (($86)>>>0);
      if ($87) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $88
      var $89=$processedsamples;
      var $90=$chunksamples;
      var $91=(($89+$90)|0);
      var $92=$2;
      var $93=(($92+336)|0);
      var $94=HEAPU32[(($93)>>2)];
      var $95=(($91)>>>0) > (($94)>>>0);
      if ($95) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $96
      $1=16;
      __label__ = 43; break;
    case 18: // $97
      var $98=$processedsamples;
      var $99=$channelsamples;
      var $100=(($98+$99)|0);
      var $101=$stream;
      var $102=(($101+52)|0);
      var $103=HEAPU16[(($102)>>1)];
      var $104=(($103)&65535);
      var $105=(($100*$104)|0);
      var $106=$2;
      var $107=(($106+332)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+($105<<1))|0);
      var $110=$109;
      var $111=$chunksamples;
      var $112=$channelsamples;
      var $113=(($111-$112)|0);
      var $114=$bytes_per_sample;
      var $115=(($113*$114)|0);
      _memset($110, 0, $115, 1);
      __label__ = 22; break;
    case 19: // $116
      var $117=$channelsamples;
      var $118=(($117)|0) <= 0;
      if ($118) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $119
      var $120=$2;
      var $121=(($120+336)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$chunksamples;
      var $124=(($122-$123)|0);
      $processedsamples=$124;
      var $125=$processedsamples;
      var $126=$stream;
      var $127=(($126+52)|0);
      var $128=HEAPU16[(($127)>>1)];
      var $129=(($128)&65535);
      var $130=(($125*$129)|0);
      var $131=$2;
      var $132=(($131+332)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+($130<<1))|0);
      var $135=$134;
      var $136=$chunksamples;
      var $137=$bytes_per_sample;
      var $138=(($136*$137)|0);
      _memset($135, 0, $138, 1);
      $chunkid=1263424842;
      var $139=$finalchunks;
      var $140=(($139-1)|0);
      $finalchunks=$140;
      __label__ = 21; break;
    case 21: // $141
      __label__ = 22; break;
    case 22: // $142
      var $143=$2;
      var $144=$chunkid;
      var $145=$processedsamples;
      var $146=$stream;
      var $147=(($146+52)|0);
      var $148=HEAPU16[(($147)>>1)];
      var $149=(($148)&65535);
      var $150=(($145*$149)|0);
      var $151=$2;
      var $152=(($151+332)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153+($150<<1))|0);
      var $155=$154;
      var $156=$chunk;
      var $157=(($156+8)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($158-8)|0);
      var $160=$chunk;
      var $161=(($160)|0);
      var $162=__ZL15chunk_overwriteP9_avi_filejPKvjPyi($143, $144, $155, $159, $161, 0);
      $avierr=$162;
      var $163=$avierr;
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $165
      var $166=$avierr;
      $1=$166;
      __label__ = 43; break;
    case 24: // $167
      var $168=$channelsamples;
      var $169=$chunksamples;
      var $170=(($168)>>>0) > (($169)>>>0);
      if ($170) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $171
      var $172=$chunksamples;
      var $173=$stream;
      var $174=(($173+16)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=(($175+$172)|0);
      HEAP32[(($174)>>2)]=$176;
      var $177=$2;
      var $178=(($177+8)|0);
      var $179=(($178+40)|0);
      HEAP32[(($179)>>2)]=$176;
      __label__ = 29; break;
    case 26: // $180
      var $181=$channelsamples;
      var $182=(($181)|0) > 0;
      if ($182) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $183
      var $184=$channelsamples;
      var $185=$stream;
      var $186=(($185+16)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187+$184)|0);
      HEAP32[(($186)>>2)]=$188;
      var $189=$2;
      var $190=(($189+8)|0);
      var $191=(($190+40)|0);
      HEAP32[(($191)>>2)]=$188;
      __label__ = 28; break;
    case 28: // $192
      __label__ = 29; break;
    case 29: // $193
      var $194=$chunksamples;
      var $195=$processedsamples;
      var $196=(($195+$194)|0);
      $processedsamples=$196;
      var $197=$chunksamples;
      var $198=$channelsamples;
      var $199=(($198-$197)|0);
      $channelsamples=$199;
      var $200=$channelsamples;
      var $201=0 > (($200)|0);
      if ($201) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $202
      var $206 = 0;__label__ = 32; break;
    case 31: // $203
      var $204=$channelsamples;
      var $206 = $204;__label__ = 32; break;
    case 32: // $205
      var $206;
      $channelsamples=$206;
      __label__ = 33; break;
    case 33: // $207
      var $208=$chunknum;
      var $209=(($208+1)|0);
      $chunknum=$209;
      __label__ = 10; break;
    case 34: // $210
      var $211=$processedsamples;
      var $212=(($211)|0) > 0;
      if ($212) { __label__ = 35; break; } else { __label__ = 40; break; }
    case 35: // $213
      var $214=$2;
      var $215=(($214+332)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($216)|0);
      var $218=$217;
      var $219=$processedsamples;
      var $220=$stream;
      var $221=(($220+52)|0);
      var $222=HEAPU16[(($221)>>1)];
      var $223=(($222)&65535);
      var $224=(($219*$223)|0);
      var $225=$2;
      var $226=(($225+332)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($227+($224<<1))|0);
      var $229=$228;
      var $230=$2;
      var $231=(($230+336)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=$processedsamples;
      var $234=(($232-$233)|0);
      var $235=$bytes_per_sample;
      var $236=(($234*$235)|0);
      _llvm_memmove_p0i8_p0i8_i32($218, $229, $236, 1, 0);
      $channel=0;
      __label__ = 36; break;
    case 36: // $237
      var $238=$channel;
      var $239=$stream;
      var $240=(($239+52)|0);
      var $241=HEAPU16[(($240)>>1)];
      var $242=(($241)&65535);
      var $243=(($238)|0) < (($242)|0);
      if ($243) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $244
      var $245=$processedsamples;
      var $246=$channel;
      var $247=$2;
      var $248=(($247+340)|0);
      var $249=(($248+($246<<2))|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=(($250-$245)|0);
      HEAP32[(($249)>>2)]=$251;
      __label__ = 38; break;
    case 38: // $252
      var $253=$channel;
      var $254=(($253+1)|0);
      $channel=$254;
      __label__ = 36; break;
    case 39: // $255
      __label__ = 40; break;
    case 40: // $256
      var $257=$3;
      var $258=(($257)|0)!=0;
      if ($258) { __label__ = 42; break; } else { __label__ = 41; break; }
    case 41: // $259
      var $260=$finalchunks;
      var $261=$stream;
      var $262=(($261+24)|0);
      HEAP32[(($262)>>2)]=$260;
      __label__ = 42; break;
    case 42: // $263
      var $264=$chunknum;
      var $265=$2;
      var $266=(($265+348)|0);
      HEAP32[(($266)>>2)]=$264;
      $1=0;
      __label__ = 43; break;
    case 43: // $267
      var $268=$1;
      ;
      return $268;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14soundbuf_flushP9_avi_filei["X"]=1;

function __ZL11chunk_closeP9_avi_file($file) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $chunk;
      var $chunksize=__stackBase__;
      var $written=__stackBase__+8;
      var $filerr;
      var $buffer=__stackBase__+12;
      $2=$file;
      var $3=$2;
      var $4=(($3+312)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5-1)|0);
      HEAP32[(($4)>>2)]=$6;
      var $7=$2;
      var $8=(($7+120)|0);
      var $9=(($8+$6*24)|0);
      $chunk=$9;
      var $10=$2;
      var $11=(($10+104)|0);
      var $st$19$0=(($11)|0);
      var $12$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$19$1)>>2)];
      var $13=$chunk;
      var $14=(($13)|0);
      var $st$25$0=(($14)|0);
      var $15$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$25$1)>>2)];
      var $$emscripten$temp$0$0=8;
      var $$emscripten$temp$0$1=0;
      var $16$0 = ((($15$0)>>>0)+((($15$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($15$0)>>>0)+((($15$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $17$0 = ((($12$0)>>>0)+((($12$1)|0)*4294967296))-((($16$0)>>>0)+((($16$1)|0)*4294967296))>>>0; var $17$1 = Math.min(Math.floor((((($12$0)>>>0)+((($12$1)|0)*4294967296))-((($16$0)>>>0)+((($16$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$33$0=(($chunksize)|0);
      HEAP32[(($st$33$0)>>2)]=$17$0;
      var $st$33$1=(($chunksize+4)|0);
      HEAP32[(($st$33$1)>>2)]=$17$1;
      var $st$37$0=(($chunksize)|0);
      var $18$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($chunksize+4)|0);
      var $18$1=HEAP32[(($st$37$1)>>2)];
      var $st$41$0=(($chunksize)|0);
      var $19$0=HEAP32[(($st$41$0)>>2)];
      var $st$41$1=(($chunksize+4)|0);
      var $19$1=HEAP32[(($st$41$1)>>2)];
      var $20$0=$19$0;
      var $20=$20$0;
      var $21$0=$20;
      var $21$1=0;
      var $22=$18$0 != $21$0 || $18$1 != $21$1;
      if ($22) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $23
      $1=2;
      __label__ = 8; break;
    case 2: // $24
      var $25=$chunk;
      var $26=(($25+8)|0);
      var $st$2$0=(($26)|0);
      var $27$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($chunksize)|0);
      var $28$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($chunksize+4)|0);
      var $28$1=HEAP32[(($st$6$1)>>2)];
      var $29=$27$0 != $28$0 || $27$1 != $28$1;
      if ($29) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $30
      var $31=(($buffer)|0);
      var $st$1$0=(($chunksize)|0);
      var $32$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($chunksize+4)|0);
      var $32$1=HEAP32[(($st$1$1)>>2)];
      var $33$0=$32$0;
      var $33=$33$0;
      __ZL10put_32bitsPhj($31, $33);
      var $34=$2;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($buffer)|0);
      var $38=$chunk;
      var $39=(($38)|0);
      var $st$14$0=(($39)|0);
      var $40$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$14$1)>>2)];
      var $$emscripten$temp$1$0=4;
      var $$emscripten$temp$1$1=0;
      var $41$0 = ((($40$0)>>>0)+((($40$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $41$1 = Math.min(Math.floor((((($40$0)>>>0)+((($40$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $42=_osd_write($36, $37, $41$0, $41$1, 4, $written);
      var $42$0=$42[0];
      $filerr=$42;
      var $43=$filerr;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $45
      var $46=HEAP32[(($written)>>2)];
      var $47=(($46)|0)!=4;
      if ($47) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $48
      $1=5;
      __label__ = 8; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      var $st$0$0=(($chunksize)|0);
      var $51$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($chunksize+4)|0);
      var $51$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=1;
      var $$emscripten$temp$2$1=0;
      var $52$0=$51$0 & $$emscripten$temp$2$0;
      var $52$1=$51$1 & $$emscripten$temp$2$1;
      var $53=$2;
      var $54=(($53+104)|0);
      var $st$10$0=(($54)|0);
      var $55$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($54+4)|0);
      var $55$1=HEAP32[(($st$10$1)>>2)];
      var $56$0 = ((($55$0)>>>0)+((($55$1)|0)*4294967296))+((($52$0)>>>0)+((($52$1)|0)*4294967296))>>>0; var $56$1 = Math.min(Math.floor((((($55$0)>>>0)+((($55$1)|0)*4294967296))+((($52$0)>>>0)+((($52$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$15$0=(($54)|0);
      HEAP32[(($st$15$0)>>2)]=$56$0;
      var $st$15$1=(($54+4)|0);
      HEAP32[(($st$15$1)>>2)]=$56$1;
      $1=0;
      __label__ = 8; break;
    case 8: // $57
      var $58=$1;
      STACKTOP = __stackBase__;
      return $58;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11chunk_closeP9_avi_file["X"]=1;

function __ZL16write_idx1_chunkP9_avi_file($file) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tempbuflength;
      var $curchunk=__stackBase__;
      var $curoffset;
      var $avierr;
      var $tempbuf;
      var $minoffset=__stackBase__+8;
      var $strnum;
      var $minstr;
      $2=$file;
      var $3=$2;
      var $4=__ZL17compute_idx1_sizeP9_avi_file($3);
      var $5=(($4-8)|0);
      $tempbuflength=$5;
      var $6=$curchunk;
      HEAP32[(($6)>>2)]=0; HEAP32[(($6+4)>>2)]=0;
      var $7=$tempbuflength;
      var $8=_malloc($7);
      $tempbuf=$8;
      var $9=$tempbuf;
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=3;
      __label__ = 14; break;
    case 2: // $12
      $curoffset=0;
      __label__ = 3; break;
    case 3: // $13
      var $14=$curoffset;
      var $15=$tempbuflength;
      var $16=(($14)>>>0) < (($15)>>>0);
      if ($16) { __label__ = 4; break; } else { __label__ = 13; break; }
    case 4: // $17
      var $$emscripten$temp$0$0=-1;
      var $$emscripten$temp$0$1=-1;
      var $st$2$0=(($minoffset)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($minoffset+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      $minstr=0;
      $strnum=0;
      __label__ = 5; break;
    case 5: // $18
      var $19=$strnum;
      var $20=$2;
      var $21=(($20+72)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($19)|0) < (($22)|0);
      if ($23) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $24
      var $25=$strnum;
      var $26=(($curchunk+($25<<2))|0);
      var $27=HEAPU32[(($26)>>2)];
      var $28=$strnum;
      var $29=$2;
      var $30=(($29+76)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+$28*76)|0);
      var $33=(($32+24)|0);
      var $34=HEAPU32[(($33)>>2)];
      var $35=(($27)>>>0) < (($34)>>>0);
      if ($35) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $36
      var $37=$strnum;
      var $38=(($curchunk+($37<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$strnum;
      var $41=$2;
      var $42=(($41+76)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+$40*76)|0);
      var $45=(($44+20)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+$39*12)|0);
      var $48=(($47)|0);
      var $st$12$0=(($48)|0);
      var $49$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($48+4)|0);
      var $49$1=HEAP32[(($st$12$1)>>2)];
      var $st$16$0=(($minoffset)|0);
      var $50$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($minoffset+4)|0);
      var $50$1=HEAP32[(($st$16$1)>>2)];
      var $51=$49$1 < $50$1 || ($49$1 == $50$1 && $49$0 < $50$0);
      if ($51) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $52
      var $53=$strnum;
      var $54=(($curchunk+($53<<2))|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$strnum;
      var $57=$2;
      var $58=(($57+76)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+$56*76)|0);
      var $61=(($60+20)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+$55*12)|0);
      var $64=(($63)|0);
      var $st$12$0=(($64)|0);
      var $65$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($64+4)|0);
      var $65$1=HEAP32[(($st$12$1)>>2)];
      var $st$16$0=(($minoffset)|0);
      HEAP32[(($st$16$0)>>2)]=$65$0;
      var $st$16$1=(($minoffset+4)|0);
      HEAP32[(($st$16$1)>>2)]=$65$1;
      var $66=$strnum;
      $minstr=$66;
      __label__ = 9; break;
    case 9: // $67
      __label__ = 10; break;
    case 10: // $68
      var $69=$strnum;
      var $70=(($69+1)|0);
      $strnum=$70;
      __label__ = 5; break;
    case 11: // $71
      var $72=$curoffset;
      var $73=(($72)|0);
      var $74=$tempbuf;
      var $75=(($74+$73)|0);
      var $76=$2;
      var $77=$minstr;
      var $78=$2;
      var $79=(($78+76)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+$77*76)|0);
      var $82=__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream($76, $81);
      __ZL10put_32bitsPhj($75, $82);
      var $83=$curoffset;
      var $84=(($83+4)|0);
      var $85=$tempbuf;
      var $86=(($85+$84)|0);
      __ZL10put_32bitsPhj($86, 16);
      var $87=$curoffset;
      var $88=(($87+8)|0);
      var $89=$tempbuf;
      var $90=(($89+$88)|0);
      var $st$21$0=(($minoffset)|0);
      var $91$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($minoffset+4)|0);
      var $91$1=HEAP32[(($st$21$1)>>2)];
      var $92=$2;
      var $93=(($92+316)|0);
      var $st$27$0=(($93)|0);
      var $94$0=HEAP32[(($st$27$0)>>2)];
      var $st$27$1=(($93+4)|0);
      var $94$1=HEAP32[(($st$27$1)>>2)];
      var $$emscripten$temp$1$0=8;
      var $$emscripten$temp$1$1=0;
      var $95$0 = ((($94$0)>>>0)+((($94$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $95$1 = Math.min(Math.floor((((($94$0)>>>0)+((($94$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $96$0 = ((($91$0)>>>0)+((($91$1)|0)*4294967296))-((($95$0)>>>0)+((($95$1)|0)*4294967296))>>>0; var $96$1 = Math.min(Math.floor((((($91$0)>>>0)+((($91$1)|0)*4294967296))-((($95$0)>>>0)+((($95$1)|0)*4294967296)))/4294967296), 4294967295);
      var $97$0=$96$0;
      var $97=$97$0;
      __ZL10put_32bitsPhj($90, $97);
      var $98=$curoffset;
      var $99=(($98+12)|0);
      var $100=$tempbuf;
      var $101=(($100+$99)|0);
      var $102=$minstr;
      var $103=(($curchunk+($102<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$minstr;
      var $106=$2;
      var $107=(($106+76)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+$105*76)|0);
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+$104*12)|0);
      var $113=(($112+8)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114-8)|0);
      __ZL10put_32bitsPhj($101, $115);
      var $116=$minstr;
      var $117=(($curchunk+($116<<2))|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118+1)|0);
      HEAP32[(($117)>>2)]=$119;
      __label__ = 12; break;
    case 12: // $120
      var $121=$curoffset;
      var $122=(($121+16)|0);
      $curoffset=$122;
      __label__ = 3; break;
    case 13: // $123
      var $124=$2;
      var $125=$tempbuf;
      var $126=$tempbuflength;
      var $127=__ZL11chunk_writeP9_avi_filejPKvj($124, 829973609, $125, $126);
      $avierr=$127;
      var $128=$tempbuf;
      _free($128);
      var $129=$avierr;
      $1=$129;
      __label__ = 14; break;
    case 14: // $130
      var $131=$1;
      STACKTOP = __stackBase__;
      return $131;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16write_idx1_chunkP9_avi_file["X"]=1;

function __ZL16write_strh_chunkP9_avi_fileP11_avi_streami($file, $stream, $initial_write) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buffer=__stackBase__;
      $1=$file;
      $2=$stream;
      $3=$initial_write;
      var $4=(($buffer)|0);
      _memset($4, 0, 56, 1);
      var $5=(($buffer)|0);
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      __ZL10put_32bitsPhj($5, $8);
      var $9=(($buffer+20)|0);
      var $10=$2;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      __ZL10put_32bitsPhj($9, $12);
      var $13=(($buffer+24)|0);
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      __ZL10put_32bitsPhj($13, $16);
      var $17=(($buffer+32)|0);
      var $18=$2;
      var $19=(($18+16)|0);
      var $20=HEAP32[(($19)>>2)];
      __ZL10put_32bitsPhj($17, $20);
      var $21=(($buffer+40)|0);
      __ZL10put_32bitsPhj($21, 10000);
      var $22=$2;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)==1935960438;
      if ($25) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $26
      var $27=(($buffer+4)|0);
      var $28=$2;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)==1431914056;
      var $32=$31 ? 1970890344 : 541215044;
      __ZL10put_32bitsPhj($27, $32);
      var $33=(($buffer+36)|0);
      var $34=$2;
      var $35=(($34+32)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$2;
      var $38=(($37+36)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($36*$39)|0);
      var $41=((($40<<2))|0);
      __ZL10put_32bitsPhj($33, $41);
      var $42=(($buffer+52)|0);
      var $43=$2;
      var $44=(($43+32)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45) & 65535);
      __ZL10put_16bitsPht($42, $46);
      var $47=(($buffer+54)|0);
      var $48=$2;
      var $49=(($48+36)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50) & 65535);
      __ZL10put_16bitsPht($47, $51);
      __label__ = 2; break;
    case 2: // $52
      var $53=$2;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)==1935963489;
      if ($56) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $57
      var $58=(($buffer+36)|0);
      var $59=$2;
      var $60=(($59+56)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=(($62+52)|0);
      var $64=HEAPU16[(($63)>>1)];
      var $65=(($64)&65535);
      var $66=(($61*$65)|0);
      var $67=$2;
      var $68=(($67+54)|0);
      var $69=HEAPU16[(($68)>>1)];
      var $70=(($69)&65535);
      var $71=(((($70)|0)/8)|0);
      var $72=(($66*$71)|0);
      __ZL10put_32bitsPhj($58, $72);
      var $73=(($buffer+44)|0);
      var $74=$2;
      var $75=(($74+52)|0);
      var $76=HEAPU16[(($75)>>1)];
      var $77=(($76)&65535);
      var $78=$2;
      var $79=(($78+54)|0);
      var $80=HEAPU16[(($79)>>1)];
      var $81=(($80)&65535);
      var $82=(((($81)|0)/8)|0);
      var $83=(($77*$82)|0);
      __ZL10put_32bitsPhj($73, $83);
      __label__ = 4; break;
    case 4: // $84
      var $85=$1;
      var $86=(($buffer)|0);
      var $87=$2;
      var $88=(($87+60)|0);
      var $89=$3;
      var $90=__ZL15chunk_overwriteP9_avi_filejPKvjPyi($85, 1752331379, $86, 56, $88, $89);
      STACKTOP = __stackBase__;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16write_strh_chunkP9_avi_fileP11_avi_streami["X"]=1;

function __Z16avi_error_string10_avi_error($err) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$err;
      var $3=$2;
      if ($3 == 0) {
        __label__ = 1; break;
      }
      else if ($3 == 1) {
        __label__ = 2; break;
      }
      else if ($3 == 2) {
        __label__ = 3; break;
      }
      else if ($3 == 3) {
        __label__ = 4; break;
      }
      else if ($3 == 4) {
        __label__ = 5; break;
      }
      else if ($3 == 5) {
        __label__ = 6; break;
      }
      else if ($3 == 6) {
        __label__ = 7; break;
      }
      else if ($3 == 7) {
        __label__ = 8; break;
      }
      else if ($3 == 8) {
        __label__ = 9; break;
      }
      else if ($3 == 9) {
        __label__ = 10; break;
      }
      else if ($3 == 10) {
        __label__ = 11; break;
      }
      else if ($3 == 11) {
        __label__ = 12; break;
      }
      else if ($3 == 12) {
        __label__ = 13; break;
      }
      else if ($3 == 13) {
        __label__ = 14; break;
      }
      else if ($3 == 14) {
        __label__ = 15; break;
      }
      else if ($3 == 15) {
        __label__ = 16; break;
      }
      else if ($3 == 16) {
        __label__ = 17; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 1: // $4
      $1=((STRING_TABLE.__str6995)|0);
      __label__ = 19; break;
    case 2: // $5
      $1=((STRING_TABLE.__str16996)|0);
      __label__ = 19; break;
    case 3: // $6
      $1=((STRING_TABLE.__str26997)|0);
      __label__ = 19; break;
    case 4: // $7
      $1=((STRING_TABLE.__str36998)|0);
      __label__ = 19; break;
    case 5: // $8
      $1=((STRING_TABLE.__str46999)|0);
      __label__ = 19; break;
    case 6: // $9
      $1=((STRING_TABLE.__str57000)|0);
      __label__ = 19; break;
    case 7: // $10
      $1=((STRING_TABLE.__str67001)|0);
      __label__ = 19; break;
    case 8: // $11
      $1=((STRING_TABLE.__str77002)|0);
      __label__ = 19; break;
    case 9: // $12
      $1=((STRING_TABLE.__str87003)|0);
      __label__ = 19; break;
    case 10: // $13
      $1=((STRING_TABLE.__str97004)|0);
      __label__ = 19; break;
    case 11: // $14
      $1=((STRING_TABLE.__str107005)|0);
      __label__ = 19; break;
    case 12: // $15
      $1=((STRING_TABLE.__str117006)|0);
      __label__ = 19; break;
    case 13: // $16
      $1=((STRING_TABLE.__str127007)|0);
      __label__ = 19; break;
    case 14: // $17
      $1=((STRING_TABLE.__str137008)|0);
      __label__ = 19; break;
    case 15: // $18
      $1=((STRING_TABLE.__str147009)|0);
      __label__ = 19; break;
    case 16: // $19
      $1=((STRING_TABLE.__str157010)|0);
      __label__ = 19; break;
    case 17: // $20
      $1=((STRING_TABLE.__str167011)|0);
      __label__ = 19; break;
    case 18: // $21
      $1=((STRING_TABLE.__str177012)|0);
      __label__ = 19; break;
    case 19: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21framenum_to_samplenumP9_avi_filej($file, $framenum) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$file;
  $2=$framenum;
  var $3=$1;
  var $4=(($3+8)|0);
  var $5=(($4+52)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7$0=$6;
  var $7$1=0;
  var $8=$2;
  var $9$0=$8;
  var $9$1=0;
  var $10$0 = ((($7$0)>>>0)+((($7$1)|0)*4294967296))*((($9$0)>>>0)+((($9$1)|0)*4294967296))>>>0; var $10$1 = Math.min(Math.floor((((($7$0)>>>0)+((($7$1)|0)*4294967296))*((($9$0)>>>0)+((($9$1)|0)*4294967296)))/4294967296), 4294967295);
  var $11=$1;
  var $12=(($11+8)|0);
  var $13=(($12+8)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15$0=$14;
  var $15$1=0;
  var $16$0 = ((($10$0)>>>0)+((($10$1)|0)*4294967296))*((($15$0)>>>0)+((($15$1)|0)*4294967296))>>>0; var $16$1 = Math.min(Math.floor((((($10$0)>>>0)+((($10$1)|0)*4294967296))*((($15$0)>>>0)+((($15$1)|0)*4294967296)))/4294967296), 4294967295);
  var $17=$1;
  var $18=(($17+8)|0);
  var $19=(($18+4)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21$0=$20;
  var $21$1=0;
  var $22$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296))>>>0; var $22$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296)))/4294967296), 4294967295);
  var $$emscripten$temp$0$0=1;
  var $$emscripten$temp$0$1=0;
  var $23$0 = ((($22$0)>>>0)+((($22$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $23$1 = Math.min(Math.floor((((($22$0)>>>0)+((($22$1)|0)*4294967296))-((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
  var $24=$1;
  var $25=(($24+8)|0);
  var $26=(($25+4)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28$0=$27;
  var $28$1=0;
  var $29$0 = Math.floor(((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($28$0)>>>0)+((($28$1)|0)*4294967296)))>>>0; var $29$1 = Math.min(Math.floor((Math.floor(((($23$0)>>>0)+((($23$1)|0)*4294967296))/((($28$0)>>>0)+((($28$1)|0)*4294967296))))/4294967296), 4294967295);
  var $30$0=$29$0;
  var $30=$30$0;
  ;
  return $30;
}


function __ZL16get_video_streamP9_avi_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $streamnum;
      $2=$file;
      $streamnum=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$streamnum;
      var $5=$2;
      var $6=(($5+72)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $9
      var $10=$streamnum;
      var $11=$2;
      var $12=(($11+76)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+$10*76)|0);
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==1935960438;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$streamnum;
      var $20=$2;
      var $21=(($20+76)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+$19*76)|0);
      $1=$23;
      __label__ = 7; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$streamnum;
      var $27=(($26+1)|0);
      $streamnum=$27;
      __label__ = 1; break;
    case 6: // $28
      $1=0;
      __label__ = 7; break;
    case 7: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream($file, $stream) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $chunkid;
      $1=$file;
      $2=$stream;
      var $3=$2;
      var $4=$1;
      var $5=(($4+76)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$3;
      var $8=$6;
      var $9=(($7-$8)|0);
      var $10=(((($9)|0)/76)|0);
      var $11=(((($10)|0)/10)|0);
      var $12=(($11+48)|0);
      var $13=$2;
      var $14=$1;
      var $15=(($14+76)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$13;
      var $18=$16;
      var $19=(($17-$18)|0);
      var $20=(((($19)|0)/76)|0);
      var $21=(($20)|0)%10;
      var $22=(($21+48)|0);
      var $23=$22 << 8;
      var $24=$12 | $23;
      $chunkid=$24;
      var $25=$2;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)==1935960438;
      if ($28) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $29
      var $30=$2;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==0;
      var $34=$33 ? 1650720768 : 1667497984;
      var $35=$chunkid;
      var $36=$35 | $34;
      $chunkid=$36;
      __label__ = 5; break;
    case 2: // $37
      var $38=$2;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==1935963489;
      if ($41) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $42
      var $43=$chunkid;
      var $44=$43 | 1651965952;
      $chunkid=$44;
      __label__ = 4; break;
    case 4: // $45
      __label__ = 5; break;
    case 5: // $46
      var $47=$chunkid;
      ;
      return $47;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream["X"]=1;

function __ZL16get_audio_streamP9_avi_fileiPi($file, $channel, $offset) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $streamnum;
      $2=$file;
      $3=$channel;
      $4=$offset;
      $streamnum=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$streamnum;
      var $7=$2;
      var $8=(($7+72)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $11
      var $12=$streamnum;
      var $13=$2;
      var $14=(($13+76)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+$12*76)|0);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)==1935963489;
      if ($19) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $20
      var $21=$3;
      var $22=$streamnum;
      var $23=$2;
      var $24=(($23+76)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+$22*76)|0);
      var $27=(($26+52)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=(($21)|0) < (($29)|0);
      if ($30) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $31
      var $32=$4;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$3;
      var $36=$4;
      HEAP32[(($36)>>2)]=$35;
      __label__ = 6; break;
    case 6: // $37
      var $38=$streamnum;
      var $39=$2;
      var $40=(($39+76)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+$38*76)|0);
      $1=$42;
      __label__ = 11; break;
    case 7: // $43
      var $44=$streamnum;
      var $45=$2;
      var $46=(($45+76)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+$44*76)|0);
      var $49=(($48+52)|0);
      var $50=HEAPU16[(($49)>>1)];
      var $51=(($50)&65535);
      var $52=$3;
      var $53=(($52-$51)|0);
      $3=$53;
      __label__ = 8; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      var $56=$streamnum;
      var $57=(($56+1)|0);
      $streamnum=$57;
      __label__ = 1; break;
    case 10: // $58
      $1=0;
      __label__ = 11; break;
    case 11: // $59
      var $60=$1;
      ;
      return $60;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16get_audio_streamP9_avi_fileiPi["X"]=1;

function __ZL16write_indx_chunkP9_avi_fileP11_avi_streami($file, $stream, $initial_write) {
  var __stackBase__  = STACKTOP; STACKTOP += 1064; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $buffer=__stackBase__;
      var $chunkid;
      var $indexchunkid;
      var $master_entries;
      var $currentbase=__stackBase__+1048;
      var $currentend=__stackBase__+1056;
      var $chunks_this_index;
      var $bytes_this_index;
      var $avierr;
      var $chunknum;
      var $tempbuf;
      $2=$file;
      $3=$stream;
      $4=$initial_write;
      $master_entries=0;
      var $5=(($buffer)|0);
      _memset($5, 0, 1048, 1);
      var $6=$2;
      var $7=$3;
      var $8=__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream($6, $7);
      $chunkid=$8;
      var $9=$3;
      var $10=$2;
      var $11=(($10+76)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$9;
      var $14=$12;
      var $15=(($13-$14)|0);
      var $16=(((($15)|0)/76)|0);
      var $17=(((($16)|0)/10)|0);
      var $18=(($17+48)|0);
      var $19=$18 << 16;
      var $20=30825 | $19;
      var $21=$3;
      var $22=$2;
      var $23=(($22+76)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$21;
      var $26=$24;
      var $27=(($25-$26)|0);
      var $28=(((($27)|0)/76)|0);
      var $29=(($28)|0)%10;
      var $30=(($29+48)|0);
      var $31=$30 << 24;
      var $32=$20 | $31;
      $indexchunkid=$32;
      var $33=$4;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 32; break; } else { __label__ = 1; break; }
    case 1: // $35
      var $36=$2;
      var $37=(($36+112)|0);
      var $st$2$0=(($37)|0);
      var $38$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($37+4)|0);
      var $38$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $39=$38$0 != $$emscripten$temp$0$0 || $38$1 != $$emscripten$temp$0$1;
      if ($39) { __label__ = 2; break; } else { __label__ = 32; break; }
    case 2: // $40
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$2$0=(($currentbase)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$1$0;
      var $st$2$1=(($currentbase+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 3; break;
    case 3: // $41
      var $st$0$0=(($currentbase)|0);
      var $42$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($currentbase+4)|0);
      var $42$1=HEAP32[(($st$0$1)>>2)];
      var $43=$2;
      var $44=(($43+104)|0);
      var $st$6$0=(($44)|0);
      var $45$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($44+4)|0);
      var $45$1=HEAP32[(($st$6$1)>>2)];
      var $46=$42$1 < $45$1 || ($42$1 == $45$1 && $42$0 < $45$0);
      if ($46) { __label__ = 4; break; } else { __label__ = 31; break; }
    case 4: // $47
      var $st$0$0=(($currentbase)|0);
      var $48$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($currentbase+4)|0);
      var $48$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=1;
      var $49$0 = ((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $49$1 = Math.min(Math.floor((((($48$0)>>>0)+((($48$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($currentend)|0);
      HEAP32[(($st$7$0)>>2)]=$49$0;
      var $st$7$1=(($currentend+4)|0);
      HEAP32[(($st$7$1)>>2)]=$49$1;
      $chunks_this_index=0;
      $bytes_this_index=0;
      $chunknum=0;
      __label__ = 5; break;
    case 5: // $50
      var $51=$chunknum;
      var $52=$3;
      var $53=(($52+24)|0);
      var $54=HEAPU32[(($53)>>2)];
      var $55=(($51)>>>0) < (($54)>>>0);
      if ($55) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $56
      var $57=$chunknum;
      var $58=$3;
      var $59=(($58+20)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+$57*12)|0);
      var $62=(($61)|0);
      var $st$6$0=(($62)|0);
      var $63$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($62+4)|0);
      var $63$1=HEAP32[(($st$6$1)>>2)];
      var $st$10$0=(($currentbase)|0);
      var $64$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($currentbase+4)|0);
      var $64$1=HEAP32[(($st$10$1)>>2)];
      var $65=$63$1 >= $64$1 && ($63$1 > $64$1 || $63$0 >= $64$0);
      if ($65) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $66
      var $67=$chunknum;
      var $68=$3;
      var $69=(($68+20)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+$67*12)|0);
      var $72=(($71)|0);
      var $st$6$0=(($72)|0);
      var $73$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($72+4)|0);
      var $73$1=HEAP32[(($st$6$1)>>2)];
      var $st$10$0=(($currentend)|0);
      var $74$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($currentend+4)|0);
      var $74$1=HEAP32[(($st$10$1)>>2)];
      var $75=$73$1 < $74$1 || ($73$1 == $74$1 && $73$0 < $74$0);
      if ($75) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $76
      var $77=$chunks_this_index;
      var $78=(($77+1)|0);
      $chunks_this_index=$78;
      __label__ = 9; break;
    case 9: // $79
      __label__ = 10; break;
    case 10: // $80
      var $81=$chunknum;
      var $82=(($81+1)|0);
      $chunknum=$82;
      __label__ = 5; break;
    case 11: // $83
      var $84=$chunks_this_index;
      var $85=(($84)|0)==0;
      if ($85) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $86
      __label__ = 30; break;
    case 13: // $87
      var $88=$chunks_this_index;
      var $89=((($88<<3))|0);
      var $90=(($89+24)|0);
      var $91=_malloc($90);
      $tempbuf=$91;
      var $92=$tempbuf;
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $94
      $1=3;
      __label__ = 35; break;
    case 15: // $95
      var $96=$tempbuf;
      var $97=$chunks_this_index;
      var $98=((($97<<3))|0);
      var $99=(($98+24)|0);
      _memset($96, 0, $99, 1);
      var $100=$tempbuf;
      var $101=(($100)|0);
      __ZL10put_16bitsPht($101, 2);
      var $102=$tempbuf;
      var $103=(($102+2)|0);
      HEAP8[($103)]=0;
      var $104=$tempbuf;
      var $105=(($104+3)|0);
      HEAP8[($105)]=1;
      var $106=$tempbuf;
      var $107=(($106+4)|0);
      var $108=$chunks_this_index;
      __ZL10put_32bitsPhj($107, $108);
      var $109=$tempbuf;
      var $110=(($109+8)|0);
      var $111=$chunkid;
      __ZL10put_32bitsPhj($110, $111);
      var $112=$tempbuf;
      var $113=(($112+12)|0);
      var $st$24$0=(($currentbase)|0);
      var $114$0=HEAP32[(($st$24$0)>>2)];
      var $st$24$1=(($currentbase+4)|0);
      var $114$1=HEAP32[(($st$24$1)>>2)];
      __ZL10put_64bitsPhy($113, $114$0, $114$1);
      $chunks_this_index=0;
      $chunknum=0;
      __label__ = 16; break;
    case 16: // $115
      var $116=$chunknum;
      var $117=$3;
      var $118=(($117+24)|0);
      var $119=HEAPU32[(($118)>>2)];
      var $120=(($116)>>>0) < (($119)>>>0);
      if ($120) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $121
      var $122=$chunknum;
      var $123=$3;
      var $124=(($123+20)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125+$122*12)|0);
      var $127=(($126)|0);
      var $st$6$0=(($127)|0);
      var $128$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($127+4)|0);
      var $128$1=HEAP32[(($st$6$1)>>2)];
      var $st$10$0=(($currentbase)|0);
      var $129$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($currentbase+4)|0);
      var $129$1=HEAP32[(($st$10$1)>>2)];
      var $130=$128$1 >= $129$1 && ($128$1 > $129$1 || $128$0 >= $129$0);
      if ($130) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $131
      var $132=$chunknum;
      var $133=$3;
      var $134=(($133+20)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+$132*12)|0);
      var $137=(($136)|0);
      var $st$6$0=(($137)|0);
      var $138$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($137+4)|0);
      var $138$1=HEAP32[(($st$6$1)>>2)];
      var $st$10$0=(($currentend)|0);
      var $139$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($currentend+4)|0);
      var $139$1=HEAP32[(($st$10$1)>>2)];
      var $140=$138$1 < $139$1 || ($138$1 == $139$1 && $138$0 < $139$0);
      if ($140) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $141
      var $142=$chunks_this_index;
      var $143=((($142<<3))|0);
      var $144=(($143+24)|0);
      var $145=(($144)|0);
      var $146=$tempbuf;
      var $147=(($146+$145)|0);
      var $148=$chunknum;
      var $149=$3;
      var $150=(($149+20)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+$148*12)|0);
      var $153=(($152)|0);
      var $st$12$0=(($153)|0);
      var $154$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($153+4)|0);
      var $154$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$3$0=8;
      var $$emscripten$temp$3$1=0;
      var $155$0 = ((($154$0)>>>0)+((($154$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296))>>>0; var $155$1 = Math.min(Math.floor((((($154$0)>>>0)+((($154$1)|0)*4294967296))+((($$emscripten$temp$3$0)>>>0)+((($$emscripten$temp$3$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$19$0=(($currentbase)|0);
      var $156$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($currentbase+4)|0);
      var $156$1=HEAP32[(($st$19$1)>>2)];
      var $157$0 = ((($155$0)>>>0)+((($155$1)|0)*4294967296))-((($156$0)>>>0)+((($156$1)|0)*4294967296))>>>0; var $157$1 = Math.min(Math.floor((((($155$0)>>>0)+((($155$1)|0)*4294967296))-((($156$0)>>>0)+((($156$1)|0)*4294967296)))/4294967296), 4294967295);
      var $158$0=$157$0;
      var $158=$158$0;
      __ZL10put_32bitsPhj($147, $158);
      var $159=$chunks_this_index;
      var $160=((($159<<3))|0);
      var $161=(($160+24)|0);
      var $162=(($161+4)|0);
      var $163=$tempbuf;
      var $164=(($163+$162)|0);
      var $165=$chunknum;
      var $166=$3;
      var $167=(($166+20)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+$165*12)|0);
      var $170=(($169+8)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171-8)|0);
      __ZL10put_32bitsPhj($164, $172);
      var $173=$chunknum;
      var $174=$3;
      var $175=(($174+20)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176+$173*12)|0);
      var $178=(($177+8)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$bytes_this_index;
      var $181=(($180+$179)|0);
      $bytes_this_index=$181;
      var $182=$chunks_this_index;
      var $183=(($182+1)|0);
      $chunks_this_index=$183;
      __label__ = 20; break;
    case 20: // $184
      __label__ = 21; break;
    case 21: // $185
      var $186=$chunknum;
      var $187=(($186+1)|0);
      $chunknum=$187;
      __label__ = 16; break;
    case 22: // $188
      var $189=$master_entries;
      var $190=((($189<<4))|0);
      var $191=(($190+24)|0);
      var $192=(($191)|0);
      var $193=(($buffer+$192)|0);
      var $194=$2;
      var $195=(($194+104)|0);
      var $st$7$0=(($195)|0);
      var $196$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($195+4)|0);
      var $196$1=HEAP32[(($st$7$1)>>2)];
      __ZL10put_64bitsPhy($193, $196$0, $196$1);
      var $197=$master_entries;
      var $198=((($197<<4))|0);
      var $199=(($198+24)|0);
      var $200=(($199+8)|0);
      var $201=(($buffer+$200)|0);
      var $202=$chunks_this_index;
      var $203=((($202<<3))|0);
      var $204=(($203+24)|0);
      var $205=(($204+8)|0);
      __ZL10put_32bitsPhj($201, $205);
      var $206=$3;
      var $207=(($206)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208)|0)==1935960438;
      if ($209) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $210
      var $211=$master_entries;
      var $212=((($211<<4))|0);
      var $213=(($212+24)|0);
      var $214=(($213+12)|0);
      var $215=(($buffer+$214)|0);
      var $216=$chunks_this_index;
      __ZL10put_32bitsPhj($215, $216);
      __label__ = 27; break;
    case 24: // $217
      var $218=$3;
      var $219=(($218)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220)|0)==1935963489;
      if ($221) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $222
      var $223=$master_entries;
      var $224=((($223<<4))|0);
      var $225=(($224+24)|0);
      var $226=(($225+12)|0);
      var $227=(($buffer+$226)|0);
      var $228=$bytes_this_index;
      var $229=$3;
      var $230=(($229+54)|0);
      var $231=HEAPU16[(($230)>>1)];
      var $232=(($231)&65535);
      var $233=(((($232)|0)/8)|0);
      var $234=$3;
      var $235=(($234+52)|0);
      var $236=HEAPU16[(($235)>>1)];
      var $237=(($236)&65535);
      var $238=(($233*$237)|0);
      var $239=Math.floor((($228)>>>0)/(($238)>>>0));
      __ZL10put_32bitsPhj($227, $239);
      __label__ = 26; break;
    case 26: // $240
      __label__ = 27; break;
    case 27: // $241
      var $242=$master_entries;
      var $243=(($242+1)|0);
      $master_entries=$243;
      var $244=$2;
      var $245=$indexchunkid;
      var $246=$tempbuf;
      var $247=$chunks_this_index;
      var $248=((($247<<3))|0);
      var $249=(($248+24)|0);
      var $250=__ZL11chunk_writeP9_avi_filejPKvj($244, $245, $246, $249);
      $avierr=$250;
      var $251=$tempbuf;
      _free($251);
      var $252=$avierr;
      var $253=(($252)|0)!=0;
      if ($253) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $254
      var $255=$avierr;
      $1=$255;
      __label__ = 35; break;
    case 29: // $256
      __label__ = 30; break;
    case 30: // $257
      var $st$0$0=(($currentbase)|0);
      var $258$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($currentbase+4)|0);
      var $258$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=1;
      var $259$0 = ((($258$0)>>>0)+((($258$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296))>>>0; var $259$1 = Math.min(Math.floor((((($258$0)>>>0)+((($258$1)|0)*4294967296))+((($$emscripten$temp$4$0)>>>0)+((($$emscripten$temp$4$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($currentbase)|0);
      HEAP32[(($st$7$0)>>2)]=$259$0;
      var $st$7$1=(($currentbase+4)|0);
      HEAP32[(($st$7$1)>>2)]=$259$1;
      __label__ = 3; break;
    case 31: // $260
      __label__ = 32; break;
    case 32: // $261
      var $262=$master_entries;
      var $263=(($262)|0)!=0;
      if ($263) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $264
      var $265=(($buffer)|0);
      __ZL10put_16bitsPht($265, 4);
      var $266=(($buffer+2)|0);
      HEAP8[($266)]=0;
      var $267=(($buffer+3)|0);
      HEAP8[($267)]=0;
      var $268=(($buffer+4)|0);
      var $269=$master_entries;
      __ZL10put_32bitsPhj($268, $269);
      var $270=(($buffer+8)|0);
      var $271=$chunkid;
      __ZL10put_32bitsPhj($270, $271);
      __label__ = 34; break;
    case 34: // $272
      var $273=$2;
      var $274=$master_entries;
      var $275=(($274)|0)==0;
      var $276=$275 ? 1263424842 : 2019847785;
      var $277=(($buffer)|0);
      var $278=$3;
      var $279=(($278+68)|0);
      var $280=$4;
      var $281=__ZL15chunk_overwriteP9_avi_filejPKvjPyi($273, $276, $277, 1048, $279, $280);
      $1=$281;
      __label__ = 35; break;
    case 35: // $282
      var $283=$1;
      STACKTOP = __stackBase__;
      return $283;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16write_indx_chunkP9_avi_fileP11_avi_streami["X"]=1;

function __ZL16write_avih_chunkP9_avi_filei($file, $initial_write) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $video;
  var $buffer=__stackBase__;
  $1=$file;
  $2=$initial_write;
  var $3=$1;
  var $4=__ZL16get_video_streamP9_avi_file($3);
  $video=$4;
  var $5=(($buffer)|0);
  _memset($5, 0, 56, 1);
  var $6=(($buffer)|0);
  var $7=$video;
  var $8=(($7+12)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10$0=$9;
  var $10$1=0;
  var $$emscripten$temp$0$0=1000000;
  var $$emscripten$temp$0$1=0;
  var $11$0 = ((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))*((($10$0)>>>0)+((($10$1)|0)*4294967296))>>>0; var $11$1 = Math.min(Math.floor((((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))*((($10$0)>>>0)+((($10$1)|0)*4294967296)))/4294967296), 4294967295);
  var $12=$video;
  var $13=(($12+8)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15$0=$14;
  var $15$1=0;
  var $16$0 = (tempBigIntR=((($11$0)>>>0)+((($11$1)|0)*4294967296))/((($15$0)>>>0)+((($15$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $16$1 = Math.min(Math.floor(((tempBigIntR=((($11$0)>>>0)+((($11$1)|0)*4294967296))/((($15$0)>>>0)+((($15$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
  var $17$0=$16$0;
  var $17=$17$0;
  __ZL10put_32bitsPhj($6, $17);
  var $18=(($buffer+12)|0);
  __ZL10put_32bitsPhj($18, 272);
  var $19=(($buffer+16)|0);
  var $20=$video;
  var $21=(($20+16)|0);
  var $22=HEAP32[(($21)>>2)];
  __ZL10put_32bitsPhj($19, $22);
  var $23=(($buffer+24)|0);
  var $24=$1;
  var $25=(($24+72)|0);
  var $26=HEAP32[(($25)>>2)];
  __ZL10put_32bitsPhj($23, $26);
  var $27=(($buffer+32)|0);
  var $28=$video;
  var $29=(($28+32)|0);
  var $30=HEAP32[(($29)>>2)];
  __ZL10put_32bitsPhj($27, $30);
  var $31=(($buffer+36)|0);
  var $32=$video;
  var $33=(($32+36)|0);
  var $34=HEAP32[(($33)>>2)];
  __ZL10put_32bitsPhj($31, $34);
  var $35=$1;
  var $36=(($buffer)|0);
  var $37=$1;
  var $38=(($37+324)|0);
  var $39=$2;
  var $40=__ZL15chunk_overwriteP9_avi_filejPKvjPyi($35, 1751742049, $36, 56, $38, $39);
  STACKTOP = __stackBase__;
  return $40;
}
__ZL16write_avih_chunkP9_avi_filei["X"]=1;

function __ZL17expand_tempbufferP9_avi_filej($file, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$file;
      $3=$length;
      var $4=$3;
      var $5=$2;
      var $6=(($5+68)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=(($4)>>>0) > (($7)>>>0);
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$3;
      var $11=((($10<<1))|0);
      var $12=$2;
      var $13=(($12+68)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$2;
      var $15=(($14+64)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$2;
      var $18=(($17+68)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=_realloc($16, $19);
      var $21=$2;
      var $22=(($21+64)|0);
      HEAP32[(($22)>>2)]=$20;
      var $23=$2;
      var $24=(($23+64)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $27
      $1=3;
      __label__ = 5; break;
    case 3: // $28
      __label__ = 4; break;
    case 4: // $29
      $1=0;
      __label__ = 5; break;
    case 5: // $30
      var $31=$1;
      ;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20soundbuf_write_chunkP9_avi_filej($file, $framenum) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $stream;
      var $avierr;
      var $chunknum;
      var $length;
      $2=$file;
      $3=$framenum;
      var $4=$2;
      var $5=__ZL16get_audio_streamP9_avi_fileiPi($4, 0, 0);
      $stream=$5;
      var $6=$stream;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=0;
      __label__ = 8; break;
    case 2: // $9
      var $10=$3;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=(($14+352)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZL21framenum_to_samplenumP9_avi_filej($13, $16);
      $length=$17;
      __label__ = 5; break;
    case 4: // $18
      var $19=$2;
      var $20=$3;
      var $21=(($20+1)|0);
      var $22=$2;
      var $23=(($22+352)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($21+$24)|0);
      var $26=__ZL21framenum_to_samplenumP9_avi_filej($19, $25);
      var $27=$2;
      var $28=$3;
      var $29=$2;
      var $30=(($29+352)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($28+$31)|0);
      var $33=__ZL21framenum_to_samplenumP9_avi_filej($27, $32);
      var $34=(($26-$33)|0);
      $length=$34;
      __label__ = 5; break;
    case 5: // $35
      var $36=$stream;
      var $37=(($36+52)|0);
      var $38=HEAPU16[(($37)>>1)];
      var $39=(($38)&65535);
      var $40=((($39<<1))|0);
      var $41=$length;
      var $42=(($41*$40)|0);
      $length=$42;
      var $43=$stream;
      var $44=(($43+24)|0);
      var $45=HEAP32[(($44)>>2)];
      $chunknum=$45;
      var $46=$stream;
      var $47=$chunknum;
      var $48=$2;
      var $49=(($48+104)|0);
      var $st$16$0=(($49)|0);
      var $50$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($49+4)|0);
      var $50$1=HEAP32[(($st$16$1)>>2)];
      var $51=$length;
      var $52=(($51+8)|0);
      var $53=__ZL21set_stream_chunk_infoP11_avi_streamjyj($46, $47, $50$0, $50$1, $52);
      var $53$0=$53[0];
      $avierr=$53;
      var $54=$avierr;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $56
      var $57=$avierr;
      $1=$57;
      __label__ = 8; break;
    case 7: // $58
      var $59=$2;
      var $60=$2;
      var $61=$stream;
      var $62=__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream($60, $61);
      var $63=$2;
      var $64=(($63+332)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$65;
      var $67=$length;
      var $68=$chunknum;
      var $69=$stream;
      var $70=(($69+20)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71+$68*12)|0);
      var $73=(($72)|0);
      var $74=__ZL15chunk_overwriteP9_avi_filejPKvjPyi($59, $62, $66, $67, $73, 1);
      $1=$74;
      __label__ = 8; break;
    case 8: // $75
      var $76=$1;
      ;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20soundbuf_write_chunkP9_avi_filej["X"]=1;

function __ZL21rgb32_compress_to_rgbP11_avi_streamPK8bitmap_tPhj($stream, $bitmap, $data, $numbytes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $height;
      var $width;
      var $dataend;
      var $x;
      var $y;
      var $source;
      var $dest;
      var $pix;
      var $dest1;
      $1=$stream;
      $2=$bitmap;
      $3=$data;
      $4=$numbytes;
      var $5=$1;
      var $6=(($5+36)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=$2;
      var $9=$8;
      var $10=(($9+16)|0);
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($7)>>>0) < (($11)>>>0);
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$1;
      var $15=(($14+36)|0);
      var $16=HEAP32[(($15)>>2)];
      var $23 = $16;__label__ = 3; break;
    case 2: // $17
      var $18=$2;
      var $19=$18;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $23 = $21;__label__ = 3; break;
    case 3: // $22
      var $23;
      $height=$23;
      var $24=$1;
      var $25=(($24+32)|0);
      var $26=HEAPU32[(($25)>>2)];
      var $27=$2;
      var $28=$27;
      var $29=(($28+12)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($26)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $32
      var $33=$1;
      var $34=(($33+32)|0);
      var $35=HEAP32[(($34)>>2)];
      var $42 = $35;__label__ = 6; break;
    case 5: // $36
      var $37=$2;
      var $38=$37;
      var $39=(($38+12)|0);
      var $40=HEAP32[(($39)>>2)];
      var $42 = $40;__label__ = 6; break;
    case 6: // $41
      var $42;
      $width=$42;
      var $43=$3;
      var $44=$4;
      var $45=(($43+$44)|0);
      $dataend=$45;
      $y=0;
      __label__ = 7; break;
    case 7: // $46
      var $47=$y;
      var $48=$height;
      var $49=(($47)|0) < (($48)|0);
      if ($49) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $50
      var $51=$2;
      var $52=$51;
      var $53=(($52+4)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$54;
      var $56=$y;
      var $57=$2;
      var $58=$57;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($56*$60)|0);
      var $62=(($55+($61<<2))|0);
      $source=$62;
      var $63=$3;
      var $64=$1;
      var $65=(($64+36)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66-1)|0);
      var $68=$y;
      var $69=(($67-$68)|0);
      var $70=$1;
      var $71=(($70+32)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69*$72)|0);
      var $74=(($73*3)|0);
      var $75=(($63+$74)|0);
      $dest=$75;
      $x=0;
      __label__ = 9; break;
    case 9: // $76
      var $77=$x;
      var $78=$width;
      var $79=(($77)|0) < (($78)|0);
      if ($79) { __label__ = 10; break; } else { var $85 = 0;__label__ = 11; break; }
    case 10: // $80
      var $81=$dest;
      var $82=$dataend;
      var $83=(($81)>>>0) < (($82)>>>0);
      var $85 = $83;__label__ = 11; break;
    case 11: // $84
      var $85;
      if ($85) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $86
      var $87=$source;
      var $88=(($87+4)|0);
      $source=$88;
      var $89=HEAP32[(($87)>>2)];
      $pix=$89;
      var $90=$pix;
      var $91=$90 & 255;
      var $92=(($91) & 255);
      var $93=$dest;
      var $94=(($93+1)|0);
      $dest=$94;
      HEAP8[($93)]=$92;
      var $95=$pix;
      var $96=$95 >>> 8;
      var $97=$96 & 255;
      var $98=(($97) & 255);
      var $99=$dest;
      var $100=(($99+1)|0);
      $dest=$100;
      HEAP8[($99)]=$98;
      var $101=$pix;
      var $102=$101 >>> 16;
      var $103=$102 & 255;
      var $104=(($103) & 255);
      var $105=$dest;
      var $106=(($105+1)|0);
      $dest=$106;
      HEAP8[($105)]=$104;
      __label__ = 13; break;
    case 13: // $107
      var $108=$x;
      var $109=(($108+1)|0);
      $x=$109;
      __label__ = 9; break;
    case 14: // $110
      __label__ = 15; break;
    case 15: // $111
      var $112=$x;
      var $113=$1;
      var $114=(($113+32)|0);
      var $115=HEAPU32[(($114)>>2)];
      var $116=(($112)>>>0) < (($115)>>>0);
      if ($116) { __label__ = 16; break; } else { var $122 = 0;__label__ = 17; break; }
    case 16: // $117
      var $118=$dest;
      var $119=$dataend;
      var $120=(($118)>>>0) < (($119)>>>0);
      var $122 = $120;__label__ = 17; break;
    case 17: // $121
      var $122;
      if ($122) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $123
      var $124=$dest;
      var $125=(($124+1)|0);
      $dest=$125;
      HEAP8[($124)]=0;
      var $126=$dest;
      var $127=(($126+1)|0);
      $dest=$127;
      HEAP8[($126)]=0;
      var $128=$dest;
      var $129=(($128+1)|0);
      $dest=$129;
      HEAP8[($128)]=0;
      __label__ = 19; break;
    case 19: // $130
      var $131=$x;
      var $132=(($131+1)|0);
      $x=$132;
      __label__ = 15; break;
    case 20: // $133
      __label__ = 21; break;
    case 21: // $134
      var $135=$y;
      var $136=(($135+1)|0);
      $y=$136;
      __label__ = 7; break;
    case 22: // $137
      __label__ = 23; break;
    case 23: // $138
      var $139=$y;
      var $140=$1;
      var $141=(($140+36)|0);
      var $142=HEAPU32[(($141)>>2)];
      var $143=(($139)>>>0) < (($142)>>>0);
      if ($143) { __label__ = 24; break; } else { __label__ = 32; break; }
    case 24: // $144
      var $145=$3;
      var $146=$1;
      var $147=(($146+36)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148-1)|0);
      var $150=$y;
      var $151=(($149-$150)|0);
      var $152=$1;
      var $153=(($152+32)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($151*$154)|0);
      var $156=(($155*3)|0);
      var $157=(($145+$156)|0);
      $dest1=$157;
      $x=0;
      __label__ = 25; break;
    case 25: // $158
      var $159=$x;
      var $160=$1;
      var $161=(($160+32)|0);
      var $162=HEAPU32[(($161)>>2)];
      var $163=(($159)>>>0) < (($162)>>>0);
      if ($163) { __label__ = 26; break; } else { var $169 = 0;__label__ = 27; break; }
    case 26: // $164
      var $165=$dest1;
      var $166=$dataend;
      var $167=(($165)>>>0) < (($166)>>>0);
      var $169 = $167;__label__ = 27; break;
    case 27: // $168
      var $169;
      if ($169) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $170
      var $171=$dest1;
      var $172=(($171+1)|0);
      $dest1=$172;
      HEAP8[($171)]=0;
      var $173=$dest1;
      var $174=(($173+1)|0);
      $dest1=$174;
      HEAP8[($173)]=0;
      var $175=$dest1;
      var $176=(($175+1)|0);
      $dest1=$176;
      HEAP8[($175)]=0;
      __label__ = 29; break;
    case 29: // $177
      var $178=$x;
      var $179=(($178+1)|0);
      $x=$179;
      __label__ = 25; break;
    case 30: // $180
      __label__ = 31; break;
    case 31: // $181
      var $182=$y;
      var $183=(($182+1)|0);
      $y=$183;
      __label__ = 23; break;
    case 32: // $184
      ;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21rgb32_compress_to_rgbP11_avi_streamPK8bitmap_tPhj["X"]=1;

function __ZL17compute_idx1_sizeP9_avi_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $chunks;
      var $strnum;
      $1=$file;
      $chunks=0;
      $strnum=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$strnum;
      var $4=$1;
      var $5=(($4+72)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($3)|0) < (($6)|0);
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$strnum;
      var $10=$1;
      var $11=(($10+76)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+$9*76)|0);
      var $14=(($13+24)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$chunks;
      var $17=(($16+$15)|0);
      $chunks=$17;
      __label__ = 3; break;
    case 3: // $18
      var $19=$strnum;
      var $20=(($19+1)|0);
      $strnum=$20;
      __label__ = 1; break;
    case 4: // $21
      var $22=$chunks;
      var $23=((($22<<4))|0);
      var $24=(($23+8)|0);
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21set_stream_chunk_infoP11_avi_streamjyj($stream, $index, $offset$0, $offset$1, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5;
      var $newcount;
      $2=$stream;
      $3=$index;
      var $st$8$0=(($4)|0);
      HEAP32[(($st$8$0)>>2)]=$offset$0;
      var $st$8$1=(($4+4)|0);
      HEAP32[(($st$8$1)>>2)]=$offset$1;
      $5=$length;
      var $6=$3;
      var $7=$2;
      var $8=(($7+28)|0);
      var $9=HEAPU32[(($8)>>2)];
      var $10=(($6)>>>0) >= (($9)>>>0);
      if ($10) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $11
      var $12=$3;
      var $13=$2;
      var $14=(($13+28)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+1000)|0);
      var $17=(($12)>>>0) > (($16)>>>0);
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$3;
      var $26 = $19;__label__ = 4; break;
    case 3: // $20
      var $21=$2;
      var $22=(($21+28)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+1000)|0);
      var $26 = $24;__label__ = 4; break;
    case 4: // $25
      var $26;
      $newcount=$26;
      var $27=$2;
      var $28=(($27+20)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$29;
      var $31=$newcount;
      var $32=(($31*12)|0);
      var $33=_realloc($30, $32);
      var $34=$33;
      var $35=$2;
      var $36=(($35+20)|0);
      HEAP32[(($36)>>2)]=$34;
      var $37=$2;
      var $38=(($37+20)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      $1=3;
      __label__ = 11; break;
    case 6: // $42
      var $43=$newcount;
      var $44=$2;
      var $45=(($44+28)|0);
      HEAP32[(($45)>>2)]=$43;
      __label__ = 7; break;
    case 7: // $46
      var $st$0$0=(($4)|0);
      var $47$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $47$1=HEAP32[(($st$0$1)>>2)];
      var $48=$3;
      var $49=$2;
      var $50=(($49+20)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$48*12)|0);
      var $53=(($52)|0);
      var $st$10$0=(($53)|0);
      HEAP32[(($st$10$0)>>2)]=$47$0;
      var $st$10$1=(($53+4)|0);
      HEAP32[(($st$10$1)>>2)]=$47$1;
      var $54=$5;
      var $55=$3;
      var $56=$2;
      var $57=(($56+20)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58+$55*12)|0);
      var $60=(($59+8)|0);
      HEAP32[(($60)>>2)]=$54;
      var $61=$2;
      var $62=(($61+24)|0);
      var $63=HEAPU32[(($62)>>2)];
      var $64=$3;
      var $65=(($64+1)|0);
      var $66=(($63)>>>0) > (($65)>>>0);
      if ($66) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $67
      var $68=$2;
      var $69=(($68+24)|0);
      var $70=HEAP32[(($69)>>2)];
      var $75 = $70;__label__ = 10; break;
    case 9: // $71
      var $72=$3;
      var $73=(($72+1)|0);
      var $75 = $73;__label__ = 10; break;
    case 10: // $74
      var $75;
      var $76=$2;
      var $77=(($76+24)|0);
      HEAP32[(($77)>>2)]=$75;
      $1=0;
      __label__ = 11; break;
    case 11: // $78
      var $79=$1;
      STACKTOP = __stackBase__;
      return $79;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21set_stream_chunk_infoP11_avi_streamjyj["X"]=1;

function __ZL11chunk_writeP9_avi_filejPKvj($file, $type, $data, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $filerr;
      var $avierr;
      var $idxreserve;
      var $written=__stackBase__;
      $2=$file;
      $3=$type;
      $4=$data;
      $5=$length;
      $idxreserve=0;
      var $6=$2;
      var $7=(($6+112)|0);
      var $st$16$0=(($7)|0);
      var $8$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($7+4)|0);
      var $8$1=HEAP32[(($st$16$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $9=$8$0 == $$emscripten$temp$0$0 && $8$1 == $$emscripten$temp$0$1;
      if ($9) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $10
      var $11=$3;
      var $12=(($11)|0)!=829973609;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$2;
      var $15=__ZL17compute_idx1_sizeP9_avi_file($14);
      $idxreserve=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$2;
      var $18=(($17+104)|0);
      var $st$2$0=(($18)|0);
      var $19$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$2$1)>>2)];
      var $20=$2;
      var $21=(($20+112)|0);
      var $st$8$0=(($21)|0);
      var $22$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($21+4)|0);
      var $22$1=HEAP32[(($st$8$1)>>2)];
      var $23=$19$1 >= $22$1 && ($19$1 > $22$1 || $19$0 >= $22$0);
      if ($23) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $24
      var $25=$2;
      var $26=(($25+104)|0);
      var $st$2$0=(($26)|0);
      var $27$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($26+4)|0);
      var $27$1=HEAP32[(($st$2$1)>>2)];
      var $28=$5;
      var $29$0=$28;
      var $29$1=0;
      var $30$0 = ((($27$0)>>>0)+((($27$1)|0)*4294967296))+((($29$0)>>>0)+((($29$1)|0)*4294967296))>>>0; var $30$1 = Math.min(Math.floor((((($27$0)>>>0)+((($27$1)|0)*4294967296))+((($29$0)>>>0)+((($29$1)|0)*4294967296)))/4294967296), 4294967295);
      var $31=$idxreserve;
      var $32$0=$31;
      var $32$1=0;
      var $33$0 = ((($30$0)>>>0)+((($30$1)|0)*4294967296))+((($32$0)>>>0)+((($32$1)|0)*4294967296))>>>0; var $33$1 = Math.min(Math.floor((((($30$0)>>>0)+((($30$1)|0)*4294967296))+((($32$0)>>>0)+((($32$1)|0)*4294967296)))/4294967296), 4294967295);
      var $34=$2;
      var $35=(($34+112)|0);
      var $st$16$0=(($35)|0);
      var $36$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($35+4)|0);
      var $36$1=HEAP32[(($st$16$1)>>2)];
      var $37$0 = ((($33$0)>>>0)+((($33$1)|0)*4294967296))-((($36$0)>>>0)+((($36$1)|0)*4294967296))>>>0; var $37$1 = Math.min(Math.floor((((($33$0)>>>0)+((($33$1)|0)*4294967296))-((($36$0)>>>0)+((($36$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=2147482624;
      var $$emscripten$temp$1$1=0;
      var $38=$37$1 >= $$emscripten$temp$1$1 && ($37$1 > $$emscripten$temp$1$1 || $37$0 >= $$emscripten$temp$1$0);
      if ($38) { __label__ = 5; break; } else { __label__ = 18; break; }
    case 5: // $39
      var $40=$2;
      var $41=__ZL11chunk_closeP9_avi_file($40);
      $avierr=$41;
      var $42=$avierr;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $44
      var $45=$avierr;
      $1=$45;
      __label__ = 24; break;
    case 7: // $46
      var $47=$2;
      var $48=(($47+112)|0);
      var $st$2$0=(($48)|0);
      var $49$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($48+4)|0);
      var $49$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $50=$49$0 == $$emscripten$temp$2$0 && $49$1 == $$emscripten$temp$2$1;
      if ($50) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $51
      var $52=$2;
      var $53=__ZL16write_idx1_chunkP9_avi_file($52);
      $avierr=$53;
      var $54=$avierr;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $56
      var $57=$avierr;
      $1=$57;
      __label__ = 24; break;
    case 10: // $58
      __label__ = 11; break;
    case 11: // $59
      var $60=$2;
      var $61=__ZL11chunk_closeP9_avi_file($60);
      $avierr=$61;
      var $62=$avierr;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      var $65=$avierr;
      $1=$65;
      __label__ = 24; break;
    case 13: // $66
      var $67=$2;
      var $68=(($67+104)|0);
      var $st$2$0=(($68)|0);
      var $69$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($68+4)|0);
      var $69$1=HEAP32[(($st$2$1)>>2)];
      var $70=$2;
      var $71=(($70+112)|0);
      var $st$8$0=(($71)|0);
      HEAP32[(($st$8$0)>>2)]=$69$0;
      var $st$8$1=(($71+4)|0);
      HEAP32[(($st$8$1)>>2)]=$69$1;
      var $72=$2;
      var $73=__ZL10chunk_openP9_avi_filejjj($72, 1179011410, 1481201217, 0);
      $avierr=$73;
      var $74=$avierr;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $76
      var $77=$avierr;
      $1=$77;
      __label__ = 24; break;
    case 15: // $78
      var $79=$2;
      var $80=(($79+104)|0);
      var $st$2$0=(($80)|0);
      var $81$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($80+4)|0);
      var $81$1=HEAP32[(($st$2$1)>>2)];
      var $82=$2;
      var $83=(($82+316)|0);
      var $st$8$0=(($83)|0);
      HEAP32[(($st$8$0)>>2)]=$81$0;
      var $st$8$1=(($83+4)|0);
      HEAP32[(($st$8$1)>>2)]=$81$1;
      var $84=$2;
      var $85=__ZL10chunk_openP9_avi_filejjj($84, 1414744396, 1769369453, 0);
      $avierr=$85;
      var $86=$avierr;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $88
      var $89=$avierr;
      $1=$89;
      __label__ = 24; break;
    case 17: // $90
      __label__ = 18; break;
    case 18: // $91
      var $92=$2;
      var $93=$3;
      var $94=$5;
      var $95=__ZL10chunk_openP9_avi_filejjj($92, $93, 0, $94);
      $avierr=$95;
      var $96=$avierr;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $98
      var $99=$avierr;
      $1=$99;
      __label__ = 24; break;
    case 20: // $100
      var $101=$2;
      var $102=(($101)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$4;
      var $105=$2;
      var $106=(($105+104)|0);
      var $st$6$0=(($106)|0);
      var $107$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($106+4)|0);
      var $107$1=HEAP32[(($st$6$1)>>2)];
      var $108=$5;
      var $109=_osd_write($103, $104, $107$0, $107$1, $108, $written);
      var $109$0=$109[0];
      $filerr=$109;
      var $110=$filerr;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $112
      var $113=HEAP32[(($written)>>2)];
      var $114=$5;
      var $115=(($113)|0)!=(($114)|0);
      if ($115) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $116
      $1=5;
      __label__ = 24; break;
    case 23: // $117
      var $118=HEAP32[(($written)>>2)];
      var $119$0=$118;
      var $119$1=0;
      var $120=$2;
      var $121=(($120+104)|0);
      var $st$5$0=(($121)|0);
      var $122$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($121+4)|0);
      var $122$1=HEAP32[(($st$5$1)>>2)];
      var $123$0 = ((($122$0)>>>0)+((($122$1)|0)*4294967296))+((($119$0)>>>0)+((($119$1)|0)*4294967296))>>>0; var $123$1 = Math.min(Math.floor((((($122$0)>>>0)+((($122$1)|0)*4294967296))+((($119$0)>>>0)+((($119$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($121)|0);
      HEAP32[(($st$10$0)>>2)]=$123$0;
      var $st$10$1=(($121+4)|0);
      HEAP32[(($st$10$1)>>2)]=$123$1;
      var $124=$2;
      var $125=__ZL11chunk_closeP9_avi_file($124);
      $1=$125;
      __label__ = 24; break;
    case 24: // $126
      var $127=$1;
      STACKTOP = __stackBase__;
      return $127;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11chunk_writeP9_avi_filejPKvj["X"]=1;

function __Z28avi_append_video_frame_rgb32P9_avi_filePK8bitmap_t($file, $bitmap) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $stream;
      var $avierr;
      var $maxlength;
      $2=$file;
      $3=$bitmap;
      var $4=$2;
      var $5=__ZL16get_video_streamP9_avi_file($4);
      $stream=$5;
      var $6=$stream;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=14;
      __label__ = 15; break;
    case 2: // $11
      var $12=$stream;
      var $13=(($12+40)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=24;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=14;
      __label__ = 15; break;
    case 4: // $17
      var $18=$3;
      var $19=$18;
      var $20=(($19+20)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=6;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      $1=13;
      __label__ = 15; break;
    case 6: // $24
      var $25=$2;
      var $26=$stream;
      var $27=(($26+24)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=__ZL20soundbuf_write_chunkP9_avi_filej($25, $28);
      $avierr=$29;
      var $30=$avierr;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      var $33=$avierr;
      $1=$33;
      __label__ = 15; break;
    case 8: // $34
      var $35=$stream;
      var $36=(($35+32)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37*3)|0);
      var $39=$stream;
      var $40=(($39+36)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($38*$41)|0);
      $maxlength=$42;
      var $43=$2;
      var $44=$maxlength;
      var $45=__ZL17expand_tempbufferP9_avi_filej($43, $44);
      $avierr=$45;
      var $46=$avierr;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      var $49=$avierr;
      $1=$49;
      __label__ = 15; break;
    case 10: // $50
      var $51=$stream;
      var $52=$3;
      var $53=$2;
      var $54=(($53+64)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$maxlength;
      var $57=__ZL21rgb32_compress_to_rgbP11_avi_streamPK8bitmap_tPhj($51, $52, $55, $56);
      $avierr=$57;
      var $58=$avierr;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      var $61=$avierr;
      $1=$61;
      __label__ = 15; break;
    case 12: // $62
      var $63=$stream;
      var $64=$stream;
      var $65=(($64+24)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$2;
      var $68=(($67+104)|0);
      var $st$6$0=(($68)|0);
      var $69$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($68+4)|0);
      var $69$1=HEAP32[(($st$6$1)>>2)];
      var $70=$maxlength;
      var $71=(($70+8)|0);
      var $72=__ZL21set_stream_chunk_infoP11_avi_streamjyj($63, $66, $69$0, $69$1, $71);
      var $72$0=$72[0];
      $avierr=$72;
      var $73=$avierr;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $75
      var $76=$avierr;
      $1=$76;
      __label__ = 15; break;
    case 14: // $77
      var $78=$stream;
      var $79=(($78+24)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$2;
      var $82=(($81+8)|0);
      var $83=(($82+12)|0);
      HEAP32[(($83)>>2)]=$80;
      var $84=$stream;
      var $85=(($84+16)|0);
      HEAP32[(($85)>>2)]=$80;
      var $86=$2;
      var $87=$2;
      var $88=$stream;
      var $89=__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream($87, $88);
      var $90=$2;
      var $91=(($90+64)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$maxlength;
      var $94=__ZL11chunk_writeP9_avi_filejPKvj($86, $89, $92, $93);
      $1=$94;
      __label__ = 15; break;
    case 15: // $95
      var $96=$1;
      ;
      return $96;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z28avi_append_video_frame_rgb32P9_avi_filePK8bitmap_t["X"]=1;

function __Z24avi_append_sound_samplesP9_avi_fileiPKsjj($file, $channel, $samples, $numsamples, $sampleskip) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $sampoffset;
      var $sampnum;
      var $data;
      $2=$file;
      $3=$channel;
      $4=$samples;
      $5=$numsamples;
      $6=$sampleskip;
      var $7=$3;
      var $8=$2;
      var $9=(($8+340)|0);
      var $10=(($9+($7<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $sampoffset=$11;
      var $12=$sampoffset;
      var $13=$5;
      var $14=(($12+$13)|0);
      var $15=$2;
      var $16=(($15+336)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=(($14)>>>0) > (($17)>>>0);
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      $1=16;
      __label__ = 7; break;
    case 2: // $20
      $sampnum=0;
      __label__ = 3; break;
    case 3: // $21
      var $22=$sampnum;
      var $23=$5;
      var $24=(($22)>>>0) < (($23)>>>0);
      if ($24) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $25
      var $26=$4;
      var $27=(($26+2)|0);
      $4=$27;
      var $28=HEAP16[(($26)>>1)];
      $data=$28;
      var $29=$6;
      var $30=$4;
      var $31=(($30+($29<<1))|0);
      $4=$31;
      var $32=$data;
      $data=$32;
      var $33=$data;
      var $34=$sampoffset;
      var $35=(($34+1)|0);
      $sampoffset=$35;
      var $36=$2;
      var $37=(($36+8)|0);
      var $38=(($37+44)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($34*$39)|0);
      var $41=$3;
      var $42=(($40+$41)|0);
      var $43=$2;
      var $44=(($43+332)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+($42<<1))|0);
      HEAP16[(($46)>>1)]=$33;
      __label__ = 5; break;
    case 5: // $47
      var $48=$sampnum;
      var $49=(($48+1)|0);
      $sampnum=$49;
      __label__ = 3; break;
    case 6: // $50
      var $51=$sampoffset;
      var $52=$3;
      var $53=$2;
      var $54=(($53+340)|0);
      var $55=(($54+($52<<2))|0);
      HEAP32[(($55)>>2)]=$51;
      var $56=$2;
      var $57=__ZL14soundbuf_flushP9_avi_filei($56, 1);
      $1=$57;
      __label__ = 7; break;
    case 7: // $58
      var $59=$1;
      ;
      return $59;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z24avi_append_sound_samplesP9_avi_fileiPKsjj["X"]=1;

function __ZL15chunk_overwriteP9_avi_filejPKvjPyi($file, $type, $data, $length, $offset, $initial_write) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $savedoffset=__stackBase__;
      var $avierr;
      $1=$file;
      $2=$type;
      $3=$data;
      $4=$length;
      $5=$offset;
      $6=$initial_write;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$16$0=(($savedoffset)|0);
      HEAP32[(($st$16$0)>>2)]=$$emscripten$temp$0$0;
      var $st$16$1=(($savedoffset+4)|0);
      HEAP32[(($st$16$1)>>2)]=$$emscripten$temp$0$1;
      var $7=$6;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+104)|0);
      var $st$2$0=(($11)|0);
      var $12$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$2$1)>>2)];
      var $13=$5;
      var $st$7$0=(($13)|0);
      HEAP32[(($st$7$0)>>2)]=$12$0;
      var $st$7$1=(($13+4)|0);
      HEAP32[(($st$7$1)>>2)]=$12$1;
      __label__ = 3; break;
    case 2: // $14
      var $15=$1;
      var $16=(($15+104)|0);
      var $st$2$0=(($16)|0);
      var $17$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($savedoffset)|0);
      HEAP32[(($st$6$0)>>2)]=$17$0;
      var $st$6$1=(($savedoffset+4)|0);
      HEAP32[(($st$6$1)>>2)]=$17$1;
      var $18=$5;
      var $st$11$0=(($18)|0);
      var $19$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($18+4)|0);
      var $19$1=HEAP32[(($st$11$1)>>2)];
      var $20=$1;
      var $21=(($20+104)|0);
      var $st$17$0=(($21)|0);
      HEAP32[(($st$17$0)>>2)]=$19$0;
      var $st$17$1=(($21+4)|0);
      HEAP32[(($st$17$1)>>2)]=$19$1;
      __label__ = 3; break;
    case 3: // $22
      var $23=$1;
      var $24=$2;
      var $25=$3;
      var $26=$4;
      var $27=__ZL11chunk_writeP9_avi_filejPKvj($23, $24, $25, $26);
      $avierr=$27;
      var $28=$6;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $30
      var $st$0$0=(($savedoffset)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($savedoffset+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      var $32=$1;
      var $33=(($32+104)|0);
      var $st$6$0=(($33)|0);
      HEAP32[(($st$6$0)>>2)]=$31$0;
      var $st$6$1=(($33+4)|0);
      HEAP32[(($st$6$1)>>2)]=$31$1;
      __label__ = 5; break;
    case 5: // $34
      var $35=$avierr;
      STACKTOP = __stackBase__;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15chunk_overwriteP9_avi_filejPKvjPyi["X"]=1;

function __Z17is_path_separatorc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0)==47;
      if ($4) { var $10 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==92;
      var $10 = $8;__label__ = 2; break;
    case 2: // $9
      var $10;
      var $11=(($10)&1);
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10put_32bitsPhj($data, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$data;
  $2=$value;
  var $3=$2;
  var $4=$3 >>> 0;
  var $5=(($4) & 255);
  var $6=$1;
  var $7=(($6)|0);
  HEAP8[($7)]=$5;
  var $8=$2;
  var $9=$8 >>> 8;
  var $10=(($9) & 255);
  var $11=$1;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$10;
  var $13=$2;
  var $14=$13 >>> 16;
  var $15=(($14) & 255);
  var $16=$1;
  var $17=(($16+2)|0);
  HEAP8[($17)]=$15;
  var $18=$2;
  var $19=$18 >>> 24;
  var $20=(($19) & 255);
  var $21=$1;
  var $22=(($21+3)|0);
  HEAP8[($22)]=$20;
  ;
  return;
}


function __ZL10put_16bitsPht($data, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$data;
  $2=$value;
  var $3=$2;
  var $4=(($3)&65535);
  var $5=$4 >> 0;
  var $6=(($5) & 255);
  var $7=$1;
  var $8=(($7)|0);
  HEAP8[($8)]=$6;
  var $9=$2;
  var $10=(($9)&65535);
  var $11=$10 >> 8;
  var $12=(($11) & 255);
  var $13=$1;
  var $14=(($13+1)|0);
  HEAP8[($14)]=$12;
  ;
  return;
}


function __ZL10put_64bitsPhy($data, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$data;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$value$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$value$1;
  var $st$7$0=(($2)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($2+4)|0);
  var $3$1=HEAP32[(($st$7$1)>>2)];
  var $4$0=$3$0;
  var $4$1=$3$1;
  var $5$0=$4$0;
  var $5=$5$0&255;
  var $6=$1;
  var $7=(($6)|0);
  HEAP8[($7)]=$5;
  var $st$18$0=(($2)|0);
  var $8$0=HEAPU32[(($st$18$0)>>2)];
  var $st$18$1=(($2+4)|0);
  var $8$1=HEAPU32[(($st$18$1)>>2)];
  var $9$0=($8$0 >>> 8) | ($8$1 << 24);
  var $9$1=($8$1 >>> 8) | (0 << 24);
  var $10$0=$9$0;
  var $10=$10$0&255;
  var $11=$1;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$10;
  var $st$29$0=(($2)|0);
  var $13$0=HEAPU32[(($st$29$0)>>2)];
  var $st$29$1=(($2+4)|0);
  var $13$1=HEAPU32[(($st$29$1)>>2)];
  var $14$0=($13$0 >>> 16) | ($13$1 << 16);
  var $14$1=($13$1 >>> 16) | (0 << 16);
  var $15$0=$14$0;
  var $15=$15$0&255;
  var $16=$1;
  var $17=(($16+2)|0);
  HEAP8[($17)]=$15;
  var $st$40$0=(($2)|0);
  var $18$0=HEAPU32[(($st$40$0)>>2)];
  var $st$40$1=(($2+4)|0);
  var $18$1=HEAPU32[(($st$40$1)>>2)];
  var $19$0=($18$0 >>> 24) | ($18$1 << 8);
  var $19$1=($18$1 >>> 24) | (0 << 8);
  var $20$0=$19$0;
  var $20=$20$0&255;
  var $21=$1;
  var $22=(($21+3)|0);
  HEAP8[($22)]=$20;
  var $st$51$0=(($2)|0);
  var $23$0=HEAP32[(($st$51$0)>>2)];
  var $st$51$1=(($2+4)|0);
  var $23$1=HEAP32[(($st$51$1)>>2)];
  var $24$0=$23$1;
  var $24$1=0;
  var $25$0=$24$0;
  var $25=$25$0&255;
  var $26=$1;
  var $27=(($26+4)|0);
  HEAP8[($27)]=$25;
  var $st$62$0=(($2)|0);
  var $28$0=HEAP32[(($st$62$0)>>2)];
  var $st$62$1=(($2+4)|0);
  var $28$1=HEAPU32[(($st$62$1)>>2)];
  var $29$0=($28$1 >>> 8) | (0 << 24);
  var $29$1=(0 >>> 8) | (0 << 24);
  var $30$0=$29$0;
  var $30=$30$0&255;
  var $31=$1;
  var $32=(($31+5)|0);
  HEAP8[($32)]=$30;
  var $st$73$0=(($2)|0);
  var $33$0=HEAP32[(($st$73$0)>>2)];
  var $st$73$1=(($2+4)|0);
  var $33$1=HEAPU32[(($st$73$1)>>2)];
  var $34$0=($33$1 >>> 16) | (0 << 16);
  var $34$1=(0 >>> 16) | (0 << 16);
  var $35$0=$34$0;
  var $35=$35$0&255;
  var $36=$1;
  var $37=(($36+6)|0);
  HEAP8[($37)]=$35;
  var $st$84$0=(($2)|0);
  var $38$0=HEAP32[(($st$84$0)>>2)];
  var $st$84$1=(($2+4)|0);
  var $38$1=HEAPU32[(($st$84$1)>>2)];
  var $39$0=($38$1 >>> 24) | (0 << 8);
  var $39$1=(0 >>> 24) | (0 << 8);
  var $40$0=$39$0;
  var $40=$40$0&255;
  var $41=$1;
  var $42=(($41+7)|0);
  HEAP8[($42)]=$40;
  STACKTOP = __stackBase__;
  return;
}
__ZL10put_64bitsPhy["X"]=1;

function __ZL10chunk_openP9_avi_filejjj($file, $type, $listtype, $estlength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $filerr;
      var $chunk;
      var $written=__stackBase__;
      var $buffer=__stackBase__+4;
      var $buffer1=__stackBase__+12;
      $2=$file;
      $3=$type;
      $4=$listtype;
      $5=$estlength;
      var $6=$2;
      var $7=(($6+312)|0);
      var $8=HEAPU32[(($7)>>2)];
      var $9=(($8)>>>0) >= 8;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=6;
      __label__ = 13; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12+312)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+1)|0);
      HEAP32[(($13)>>2)]=$15;
      var $16=$2;
      var $17=(($16+120)|0);
      var $18=(($17+$14*24)|0);
      $chunk=$18;
      var $19=$2;
      var $20=(($19+104)|0);
      var $st$11$0=(($20)|0);
      var $21$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$11$1)>>2)];
      var $22=$chunk;
      var $23=(($22)|0);
      var $st$17$0=(($23)|0);
      HEAP32[(($st$17$0)>>2)]=$21$0;
      var $st$17$1=(($23+4)|0);
      HEAP32[(($st$17$1)>>2)]=$21$1;
      var $24=$5;
      var $25$0=$24;
      var $25$1=0;
      var $26=$chunk;
      var $27=(($26+8)|0);
      var $st$26$0=(($27)|0);
      HEAP32[(($st$26$0)>>2)]=$25$0;
      var $st$26$1=(($27+4)|0);
      HEAP32[(($st$26$1)>>2)]=$25$1;
      var $28=$3;
      var $29=$chunk;
      var $30=(($29+16)|0);
      HEAP32[(($30)>>2)]=$28;
      var $31=$4;
      var $32=$chunk;
      var $33=(($32+20)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$3;
      var $35=(($34)|0)!=1179011410;
      if ($35) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $36
      var $37=$3;
      var $38=(($37)|0)!=1414744396;
      if ($38) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $39
      var $40=(($buffer)|0);
      var $41=$chunk;
      var $42=(($41+16)|0);
      var $43=HEAP32[(($42)>>2)];
      __ZL10put_32bitsPhj($40, $43);
      var $44=(($buffer+4)|0);
      var $45=$chunk;
      var $46=(($45+8)|0);
      var $st$8$0=(($46)|0);
      var $47$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($46+4)|0);
      var $47$1=HEAP32[(($st$8$1)>>2)];
      var $48$0=$47$0;
      var $48=$48$0;
      __ZL10put_32bitsPhj($44, $48);
      var $49=$2;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($buffer)|0);
      var $53=$2;
      var $54=(($53+104)|0);
      var $st$21$0=(($54)|0);
      var $55$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($54+4)|0);
      var $55$1=HEAP32[(($st$21$1)>>2)];
      var $56=_osd_write($51, $52, $55$0, $55$1, 8, $written);
      var $56$0=$56[0];
      $filerr=$56;
      var $57=$filerr;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $59
      var $60=HEAP32[(($written)>>2)];
      var $61=(($60)|0)!=8;
      if ($61) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $62
      $1=5;
      __label__ = 13; break;
    case 7: // $63
      var $64=HEAP32[(($written)>>2)];
      var $65$0=$64;
      var $65$1=0;
      var $66=$2;
      var $67=(($66+104)|0);
      var $st$5$0=(($67)|0);
      var $68$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($67+4)|0);
      var $68$1=HEAP32[(($st$5$1)>>2)];
      var $69$0 = ((($68$0)>>>0)+((($68$1)|0)*4294967296))+((($65$0)>>>0)+((($65$1)|0)*4294967296))>>>0; var $69$1 = Math.min(Math.floor((((($68$0)>>>0)+((($68$1)|0)*4294967296))+((($65$0)>>>0)+((($65$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($67)|0);
      HEAP32[(($st$10$0)>>2)]=$69$0;
      var $st$10$1=(($67+4)|0);
      HEAP32[(($st$10$1)>>2)]=$69$1;
      __label__ = 12; break;
    case 8: // $70
      var $71=(($buffer1)|0);
      var $72=$chunk;
      var $73=(($72+16)|0);
      var $74=HEAP32[(($73)>>2)];
      __ZL10put_32bitsPhj($71, $74);
      var $75=(($buffer1+4)|0);
      var $76=$chunk;
      var $77=(($76+8)|0);
      var $st$8$0=(($77)|0);
      var $78$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($77+4)|0);
      var $78$1=HEAP32[(($st$8$1)>>2)];
      var $79$0=$78$0;
      var $79=$79$0;
      __ZL10put_32bitsPhj($75, $79);
      var $80=(($buffer1+8)|0);
      var $81=$chunk;
      var $82=(($81+20)|0);
      var $83=HEAP32[(($82)>>2)];
      __ZL10put_32bitsPhj($80, $83);
      var $84=$2;
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($buffer1)|0);
      var $88=$2;
      var $89=(($88+104)|0);
      var $st$26$0=(($89)|0);
      var $90$0=HEAP32[(($st$26$0)>>2)];
      var $st$26$1=(($89+4)|0);
      var $90$1=HEAP32[(($st$26$1)>>2)];
      var $91=_osd_write($86, $87, $90$0, $90$1, 12, $written);
      var $91$0=$91[0];
      $filerr=$91;
      var $92=$filerr;
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $94
      var $95=HEAP32[(($written)>>2)];
      var $96=(($95)|0)!=12;
      if ($96) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $97
      $1=5;
      __label__ = 13; break;
    case 11: // $98
      var $99=HEAP32[(($written)>>2)];
      var $100$0=$99;
      var $100$1=0;
      var $101=$2;
      var $102=(($101+104)|0);
      var $st$5$0=(($102)|0);
      var $103$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($102+4)|0);
      var $103$1=HEAP32[(($st$5$1)>>2)];
      var $104$0 = ((($103$0)>>>0)+((($103$1)|0)*4294967296))+((($100$0)>>>0)+((($100$1)|0)*4294967296))>>>0; var $104$1 = Math.min(Math.floor((((($103$0)>>>0)+((($103$1)|0)*4294967296))+((($100$0)>>>0)+((($100$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($102)|0);
      HEAP32[(($st$10$0)>>2)]=$104$0;
      var $st$10$1=(($102+4)|0);
      HEAP32[(($st$10$1)>>2)]=$104$1;
      __label__ = 12; break;
    case 12: // $105
      $1=0;
      __label__ = 13; break;
    case 13: // $106
      var $107=$1;
      STACKTOP = __stackBase__;
      return $107;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10chunk_openP9_avi_filejjj["X"]=1;

function __ZL16write_strf_chunkP9_avi_fileP11_avi_stream($file, $stream) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buffer=__stackBase__;
      var $buffer1=__stackBase__+40;
      $2=$file;
      $3=$stream;
      var $4=$3;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==1935960438;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($buffer)|0);
      _memset($9, 0, 40, 1);
      var $10=(($buffer)|0);
      __ZL10put_32bitsPhj($10, 40);
      var $11=(($buffer+4)|0);
      var $12=$3;
      var $13=(($12+32)|0);
      var $14=HEAP32[(($13)>>2)];
      __ZL10put_32bitsPhj($11, $14);
      var $15=(($buffer+8)|0);
      var $16=$3;
      var $17=(($16+36)|0);
      var $18=HEAP32[(($17)>>2)];
      __ZL10put_32bitsPhj($15, $18);
      var $19=(($buffer+12)|0);
      __ZL10put_16bitsPht($19, 1);
      var $20=(($buffer+14)|0);
      var $21=$3;
      var $22=(($21+40)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23) & 65535);
      __ZL10put_16bitsPht($20, $24);
      var $25=(($buffer+16)|0);
      var $26=$3;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      __ZL10put_32bitsPhj($25, $28);
      var $29=(($buffer+20)|0);
      var $30=$3;
      var $31=(($30+32)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$3;
      var $34=(($33+36)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32*$35)|0);
      var $37=$3;
      var $38=(($37+40)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+7)|0);
      var $41=(($36*$40)|0);
      var $42=Math.floor((($41)>>>0)/8);
      __ZL10put_32bitsPhj($29, $42);
      var $43=$2;
      var $44=(($buffer)|0);
      var $45=__ZL11chunk_writeP9_avi_filejPKvj($43, 1718776947, $44, 40);
      $1=$45;
      __label__ = 5; break;
    case 2: // $46
      var $47=$3;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)==1935963489;
      if ($50) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $51
      var $52=(($buffer1)|0);
      for (var $$dest = $52, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $53=(($buffer1)|0);
      __ZL10put_16bitsPht($53, 1);
      var $54=(($buffer1+2)|0);
      var $55=$3;
      var $56=(($55+52)|0);
      var $57=HEAP16[(($56)>>1)];
      __ZL10put_16bitsPht($54, $57);
      var $58=(($buffer1+4)|0);
      var $59=$3;
      var $60=(($59+56)|0);
      var $61=HEAP32[(($60)>>2)];
      __ZL10put_32bitsPhj($58, $61);
      var $62=(($buffer1+8)|0);
      var $63=$3;
      var $64=(($63+56)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$3;
      var $67=(($66+52)|0);
      var $68=HEAPU16[(($67)>>1)];
      var $69=(($68)&65535);
      var $70=(($65*$69)|0);
      var $71=$3;
      var $72=(($71+54)|0);
      var $73=HEAPU16[(($72)>>1)];
      var $74=(($73)&65535);
      var $75=(((($74)|0)/8)|0);
      var $76=(($70*$75)|0);
      __ZL10put_32bitsPhj($62, $76);
      var $77=(($buffer1+12)|0);
      var $78=$3;
      var $79=(($78+52)|0);
      var $80=HEAPU16[(($79)>>1)];
      var $81=(($80)&65535);
      var $82=$3;
      var $83=(($82+54)|0);
      var $84=HEAPU16[(($83)>>1)];
      var $85=(($84)&65535);
      var $86=(((($85)|0)/8)|0);
      var $87=(($81*$86)|0);
      var $88=(($87) & 65535);
      __ZL10put_16bitsPht($77, $88);
      var $89=(($buffer1+14)|0);
      var $90=$3;
      var $91=(($90+54)|0);
      var $92=HEAP16[(($91)>>1)];
      __ZL10put_16bitsPht($89, $92);
      var $93=$2;
      var $94=(($buffer1)|0);
      var $95=__ZL11chunk_writeP9_avi_filejPKvj($93, 1718776947, $94, 16);
      $1=$95;
      __label__ = 5; break;
    case 4: // $96
      $1=2;
      __label__ = 5; break;
    case 5: // $97
      var $98=$1;
      STACKTOP = __stackBase__;
      return $98;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16write_strf_chunkP9_avi_fileP11_avi_stream["X"]=1;

function __Z14zippath_parentP7astringPKc($dst, $path) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $pos=__stackBase__;
      $1=$dst;
      $2=$path;
      var $3=$2;
      __ZL17parse_parent_pathPKcPiS1_($3, $pos, 0);
      var $4=HEAP32[(($pos)>>2)];
      var $5=(($4)|0) >= 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=$2;
      var $9=HEAP32[(($pos)>>2)];
      var $10=(($9+1)|0);
      var $11=__Z13astring_cpychP7astringPKci($7, $8, $10);
      var $16 = $11;__label__ = 3; break;
    case 2: // $12
      var $13=$1;
      var $14=__Z12astring_cpycP7astringPKc($13, ((__str7032)|0));
      var $16 = $14;__label__ = 3; break;
    case 3: // $15
      var $16;
      STACKTOP = __stackBase__;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17parse_parent_pathPKcPiS1_($path, $beginpos, $endpos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $length;
      var $pos;
      $1=$path;
      $2=$beginpos;
      $3=$endpos;
      var $4=$1;
      var $5=_strlen($4);
      $length=$5;
      var $6=$length;
      var $7=(($6-1)|0);
      $pos=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$pos;
      var $10=(($9)|0) > 0;
      if ($10) { __label__ = 2; break; } else { var $19 = 0;__label__ = 3; break; }
    case 2: // $11
      var $12=$pos;
      var $13=$1;
      var $14=(($13+$12)|0);
      var $15=HEAP8[($14)];
      var $16=__Z17is_path_separatorc($15);
      var $17=(($16)|0)!=0;
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      var $21=$pos;
      var $22=(($21-1)|0);
      $pos=$22;
      __label__ = 1; break;
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $26
      var $27=$pos;
      var $28=$3;
      HEAP32[(($28)>>2)]=$27;
      __label__ = 7; break;
    case 7: // $29
      __label__ = 8; break;
    case 8: // $30
      var $31=$pos;
      var $32=(($31)|0) >= 0;
      if ($32) { __label__ = 9; break; } else { var $42 = 0;__label__ = 10; break; }
    case 9: // $33
      var $34=$pos;
      var $35=$1;
      var $36=(($35+$34)|0);
      var $37=HEAP8[($36)];
      var $38=__Z17is_path_separatorc($37);
      var $39=(($38)|0)!=0;
      var $40=$39 ^ 1;
      var $42 = $40;__label__ = 10; break;
    case 10: // $41
      var $42;
      if ($42) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $43
      var $44=$pos;
      var $45=(($44-1)|0);
      $pos=$45;
      __label__ = 8; break;
    case 12: // $46
      var $47=$2;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $49
      var $50=$pos;
      var $51=$2;
      HEAP32[(($51)>>2)]=$50;
      __label__ = 14; break;
    case 14: // $52
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17parse_parent_pathPKcPiS1_["X"]=1;

function __Z15zippath_combineP7astringPKcS2_($dst, $path1, $path2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      $1=$dst;
      $2=$path1;
      $3=$path2;
      var $4=$3;
      var $5=_strcmp($4, ((STRING_TABLE.__str17033)|0));
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$1;
      var $9=$2;
      var $10=__Z12astring_cpycP7astringPKc($8, $9);
      $result=$10;
      __label__ = 13; break;
    case 2: // $11
      var $12=$3;
      var $13=_strcmp($12, ((STRING_TABLE.__str27034)|0));
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $15
      var $16=$1;
      var $17=$2;
      var $18=__Z14zippath_parentP7astringPKc($16, $17);
      $result=$18;
      __label__ = 12; break;
    case 4: // $19
      var $20=$3;
      var $21=_osd_is_absolute_path($20);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$1;
      var $25=$3;
      var $26=__Z12astring_cpycP7astringPKc($24, $25);
      $result=$26;
      __label__ = 11; break;
    case 6: // $27
      var $28=$2;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $33
      var $34=$2;
      var $35=_strlen($34);
      var $36=(($35-1)|0);
      var $37=$2;
      var $38=(($37+$36)|0);
      var $39=HEAP8[($38)];
      var $40=__Z17is_path_separatorc($39);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $42
      var $43=$1;
      var $44=$2;
      var $45=$3;
      var $46=__ZL18astring_assemble_3P7astringPKcS2_S2_7041($43, $44, ((STRING_TABLE.__str37035)|0), $45);
      $result=$46;
      __label__ = 10; break;
    case 9: // $47
      var $48=$1;
      var $49=$2;
      var $50=$3;
      var $51=__ZL18astring_assemble_2P7astringPKcS2_7042($48, $49, $50);
      $result=$51;
      __label__ = 10; break;
    case 10: // $52
      __label__ = 11; break;
    case 11: // $53
      __label__ = 12; break;
    case 12: // $54
      __label__ = 13; break;
    case 13: // $55
      var $56=$result;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15zippath_combineP7astringPKcS2_["X"]=1;

function __ZL18astring_assemble_3P7astringPKcS2_S2_7041($dst, $src1, $src2, $src3) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$dst;
  $2=$src1;
  $3=$src2;
  $4=$src3;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=__ZL18astring_assemble_2P7astringPKcS2_7042($5, $6, $7);
  var $9=$4;
  var $10=__ZL12astring_catcP7astringPKc7053($8, $9);
  ;
  return $10;
}


function __ZL18astring_assemble_2P7astringPKcS2_7042($dst, $src1, $src2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$dst;
  $2=$src1;
  $3=$src2;
  var $4=$1;
  var $5=$2;
  var $6=__Z12astring_cpycP7astringPKc($4, $5);
  var $7=$3;
  var $8=__ZL12astring_catcP7astringPKc7053($6, $7);
  ;
  return $8;
}


function __ZL21is_zip_file_separatorc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0)==47;
      if ($4) { var $10 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==92;
      var $10 = $8;__label__ = 2; break;
    case 2: // $9
      var $10;
      var $11=(($10)&1);
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13zippath_fopenPKcjPP10_core_fileP7astring($filename, $openflags, $file, $revised_path) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $filerr;
      var $ziperr;
      var $zip=__stackBase__;
      var $header;
      var $entry_type=__stackBase__+4;
      var $mainpath;
      var $subpath;
      var $temp;
      var $temp2;
      var $alloc_fullpath=__stackBase__+8;
      var $len;
      $1=$filename;
      $2=$openflags;
      $3=$file;
      $4=$revised_path;
      $filerr=3;
      HEAP32[(($zip)>>2)]=0;
      HEAP32[(($alloc_fullpath)>>2)]=0;
      var $5=__Z13astring_allocv();
      var $6=$1;
      var $7=__Z12astring_cpycP7astringPKc($5, $6);
      $mainpath=$7;
      var $8=__Z13astring_allocv();
      $subpath=$8;
      var $9=__Z13astring_allocv();
      $temp=$9;
      var $10=__Z13astring_allocv();
      $temp2=$10;
      var $11=$3;
      HEAP32[(($11)>>2)]=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$3;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { var $30 = 0;__label__ = 6; break; }
    case 2: // $16
      var $17=$mainpath;
      var $18=__Z11astring_lenPK7astring($17);
      var $19=(($18)|0) > 0;
      if ($19) { __label__ = 3; break; } else { var $30 = 0;__label__ = 6; break; }
    case 3: // $20
      var $21=$2;
      var $22=(($21)|0)==1;
      if ($22) { var $28 = 1;__label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $23
      var $24=$subpath;
      var $25=__Z11astring_lenPK7astring($24);
      var $26=(($25)|0)==0;
      var $28 = $26;__label__ = 5; break;
    case 5: // $27
      var $28;
      var $30 = $28;__label__ = 6; break;
    case 6: // $29
      var $30;
      if ($30) { __label__ = 7; break; } else { __label__ = 36; break; }
    case 7: // $31
      var $32=$mainpath;
      var $33=__Z9astring_cPK7astring($32);
      var $34=__ZL11is_zip_filePKc($33);
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 8; break; } else { __label__ = 22; break; }
    case 8: // $36
      var $37=$mainpath;
      var $38=__Z9astring_cPK7astring($37);
      var $39=__Z13zip_file_openPKcPP9_zip_file($38, $zip);
      $ziperr=$39;
      var $40=$ziperr;
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 9; break; } else { __label__ = 21; break; }
    case 9: // $42
      var $43=$2;
      var $44=(($43)|0)!=1;
      if ($44) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $45
      $filerr=4;
      __label__ = 37; break;
    case 11: // $46
      var $47=$subpath;
      var $48=__Z11astring_lenPK7astring($47);
      var $49=(($48)|0) > 0;
      if ($49) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $50
      var $51=HEAP32[(($zip)>>2)];
      var $52=$subpath;
      var $53=__Z9astring_cPK7astring($52);
      var $54=__ZL21zippath_find_sub_pathP9_zip_filePKcP19_osd_dir_entry_type($51, $53, $entry_type);
      $header=$54;
      __label__ = 14; break;
    case 13: // $55
      var $56=HEAP32[(($zip)>>2)];
      var $57=__Z19zip_file_first_fileP9_zip_file($56);
      $header=$57;
      __label__ = 14; break;
    case 14: // $58
      var $59=$header;
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $61
      $filerr=3;
      __label__ = 37; break;
    case 16: // $62
      var $63=HEAP32[(($zip)>>2)];
      var $64=$header;
      var $65=$3;
      var $66=__ZL25create_core_file_from_zipP9_zip_filePK16_zip_file_headerPP10_core_file($63, $64, $65);
      $filerr=$66;
      var $67=$filerr;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $69
      __label__ = 37; break;
    case 18: // $70
      var $71=$subpath;
      var $72=__Z11astring_lenPK7astring($71);
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $74
      var $75=$subpath;
      var $76=$header;
      var $77=(($76+48)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=__Z12astring_cpycP7astringPKc($75, $78);
      __label__ = 20; break;
    case 20: // $80
      __label__ = 37; break;
    case 21: // $81
      __label__ = 22; break;
    case 22: // $82
      var $83=$subpath;
      var $84=__Z11astring_lenPK7astring($83);
      var $85=(($84)|0)==0;
      if ($85) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $86
      var $87=$1;
      var $88=$2;
      var $89=$3;
      var $90=__Z10core_fopenPKcjPP10_core_file($87, $88, $89);
      $filerr=$90;
      __label__ = 25; break;
    case 24: // $91
      $filerr=3;
      __label__ = 25; break;
    case 25: // $92
      var $93=$filerr;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 26; break; } else { __label__ = 35; break; }
    case 26: // $95
      var $96=$temp;
      var $97=$mainpath;
      var $98=__Z9astring_cPK7astring($97);
      var $99=__Z14zippath_parentP7astringPKc($96, $98);
      var $100=$subpath;
      var $101=__Z11astring_lenPK7astring($100);
      var $102=(($101)|0) > 0;
      if ($102) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $103
      var $104=$temp2;
      var $105=$mainpath;
      var $106=__Z9astring_cPK7astring($105);
      var $107=$temp;
      var $108=__Z11astring_lenPK7astring($107);
      var $109=(($106+$108)|0);
      var $110=$subpath;
      var $111=__Z9astring_cPK7astring($110);
      var $112=__ZL18astring_assemble_3P7astringPKcS2_S2_7041($104, $109, ((STRING_TABLE.__str37035)|0), $111);
      var $113=$subpath;
      var $114=$temp2;
      var $115=__Z11astring_cpyP7astringPKS_($113, $114);
      __label__ = 29; break;
    case 28: // $116
      var $117=$subpath;
      var $118=$mainpath;
      var $119=__Z9astring_cPK7astring($118);
      var $120=$temp;
      var $121=__Z11astring_lenPK7astring($120);
      var $122=(($119+$121)|0);
      var $123=__Z12astring_cpycP7astringPKc($117, $122);
      __label__ = 29; break;
    case 29: // $124
      var $125=$temp;
      var $126=__Z11astring_lenPK7astring($125);
      $len=$126;
      __label__ = 30; break;
    case 30: // $127
      var $128=$len;
      var $129=(($128)|0) > 0;
      if ($129) { __label__ = 31; break; } else { var $140 = 0;__label__ = 32; break; }
    case 31: // $130
      var $131=$len;
      var $132=(($131-1)|0);
      var $133=$temp;
      var $134=__Z9astring_cPK7astring($133);
      var $135=(($134+$132)|0);
      var $136=HEAP8[($135)];
      var $137=__ZL21is_zip_file_separatorc($136);
      var $138=(($137)|0)!=0;
      var $140 = $138;__label__ = 32; break;
    case 32: // $139
      var $140;
      if ($140) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $141
      var $142=$len;
      var $143=(($142-1)|0);
      $len=$143;
      __label__ = 30; break;
    case 34: // $144
      var $145=$mainpath;
      var $146=$temp;
      var $147=__Z9astring_cPK7astring($146);
      var $148=$len;
      var $149=__Z13astring_cpychP7astringPKci($145, $147, $148);
      __label__ = 35; break;
    case 35: // $150
      __label__ = 1; break;
    case 36: // $151
      __label__ = 37; break;
    case 37: // $152
      var $153=$4;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 38; break; } else { __label__ = 46; break; }
    case 38: // $155
      var $156=$4;
      var $157=__Z12astring_cpycP7astringPKc($156, ((__str7032)|0));
      var $158=$filerr;
      var $159=(($158)|0)==0;
      if ($159) { __label__ = 39; break; } else { __label__ = 45; break; }
    case 39: // $160
      var $161=$mainpath;
      var $162=__Z9astring_cPK7astring($161);
      var $163=_osd_get_full_path($alloc_fullpath, $162);
      $filerr=$163;
      var $164=$filerr;
      var $165=(($164)|0)==0;
      if ($165) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $166
      var $167=$subpath;
      var $168=__Z11astring_lenPK7astring($167);
      var $169=(($168)|0) > 0;
      if ($169) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $170
      var $171=$4;
      var $172=HEAP32[(($alloc_fullpath)>>2)];
      var $173=$subpath;
      var $174=__Z9astring_cPK7astring($173);
      var $175=__ZL18astring_assemble_3P7astringPKcS2_S2_7041($171, $172, ((STRING_TABLE.__str37035)|0), $174);
      __label__ = 43; break;
    case 42: // $176
      var $177=$4;
      var $178=HEAP32[(($alloc_fullpath)>>2)];
      var $179=__Z12astring_cpycP7astringPKc($177, $178);
      __label__ = 43; break;
    case 43: // $180
      __label__ = 44; break;
    case 44: // $181
      __label__ = 45; break;
    case 45: // $182
      __label__ = 46; break;
    case 46: // $183
      var $184=HEAP32[(($zip)>>2)];
      var $185=(($184)|0)!=0;
      if ($185) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $186
      var $187=HEAP32[(($zip)>>2)];
      __Z14zip_file_closeP9_zip_file($187);
      __label__ = 48; break;
    case 48: // $188
      var $189=$mainpath;
      var $190=(($189)|0)!=0;
      if ($190) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $191
      var $192=$mainpath;
      __Z12astring_freeP7astring($192);
      __label__ = 50; break;
    case 50: // $193
      var $194=$subpath;
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $196
      var $197=$subpath;
      __Z12astring_freeP7astring($197);
      __label__ = 52; break;
    case 52: // $198
      var $199=$temp;
      var $200=(($199)|0)!=0;
      if ($200) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $201
      var $202=$temp;
      __Z12astring_freeP7astring($202);
      __label__ = 54; break;
    case 54: // $203
      var $204=$temp2;
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $206
      var $207=$temp2;
      __Z12astring_freeP7astring($207);
      __label__ = 56; break;
    case 56: // $208
      var $209=HEAP32[(($alloc_fullpath)>>2)];
      var $210=(($209)|0)!=0;
      if ($210) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $211
      var $212=HEAP32[(($alloc_fullpath)>>2)];
      _osd_free($212);
      __label__ = 58; break;
    case 58: // $213
      var $214=$filerr;
      STACKTOP = __stackBase__;
      return $214;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13zippath_fopenPKcjPP10_core_fileP7astring["X"]=1;

function __ZL11is_zip_filePKc($path) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $s;
      $1=$path;
      var $2=$1;
      var $3=_strrchr($2, 46);
      $s=$3;
      var $4=$s;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { var $12 = 0;__label__ = 2; break; }
    case 1: // $6
      var $7=$s;
      var $8=__Z12core_stricmpPKcS0_($7, ((STRING_TABLE.__str47036)|0));
      var $9=(($8)|0)!=0;
      var $10=$9 ^ 1;
      var $12 = $10;__label__ = 2; break;
    case 2: // $11
      var $12;
      var $13=(($12)&1);
      ;
      return $13;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21zippath_find_sub_pathP9_zip_filePKcP19_osd_dir_entry_type($zipfile, $subpath, $type) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $i=__stackBase__;
      var $j=__stackBase__+4;
      var $c1;
      var $c2;
      var $last_char;
      var $header;
      $2=$zipfile;
      $3=$subpath;
      $4=$type;
      var $5=$2;
      var $6=__Z19zip_file_first_fileP9_zip_file($5);
      $header=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$header;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 27; break; }
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $13
      var $14=$4;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      var $17=$4;
      HEAP32[(($17)>>2)]=1;
      __label__ = 5; break;
    case 5: // $18
      var $19=$header;
      $1=$19;
      __label__ = 30; break;
    case 6: // $20
      HEAP32[(($i)>>2)]=0;
      HEAP32[(($j)>>2)]=0;
      $last_char=47;
      __label__ = 7; break;
    case 7: // $21
      var $22=$header;
      var $23=(($22+48)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZL14next_path_charPKcPi($24, $i);
      $c1=$25;
      var $26=(($25 << 24) >> 24);
      var $27=$3;
      var $28=__ZL14next_path_charPKcPi($27, $j);
      $c2=$28;
      var $29=(($28 << 24) >> 24);
      var $30=(($26)|0)==(($29)|0);
      if ($30) { __label__ = 8; break; } else { var $42 = 0;__label__ = 11; break; }
    case 8: // $31
      var $32=$c1;
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 9; break; } else { var $40 = 0;__label__ = 10; break; }
    case 9: // $35
      var $36=$c2;
      var $37=(($36 << 24) >> 24);
      var $38=(($37)|0)!=0;
      var $40 = $38;__label__ = 10; break;
    case 10: // $39
      var $40;
      var $42 = $40;__label__ = 11; break;
    case 11: // $41
      var $42;
      if ($42) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $43
      var $44=$c2;
      $last_char=$44;
      __label__ = 7; break;
    case 13: // $45
      var $46=$c2;
      var $47=(($46 << 24) >> 24);
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 14; break; } else { __label__ = 25; break; }
    case 14: // $49
      var $50=$c1;
      var $51=(($50 << 24) >> 24);
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $53
      var $54=$4;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $56
      var $57=$4;
      HEAP32[(($57)>>2)]=1;
      __label__ = 17; break;
    case 17: // $58
      var $59=$header;
      $1=$59;
      __label__ = 30; break;
    case 18: // $60
      var $61=$last_char;
      var $62=(($61 << 24) >> 24);
      var $63=(($62)|0)==47;
      if ($63) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $64
      var $65=$c1;
      var $66=(($65 << 24) >> 24);
      var $67=(($66)|0)==47;
      if ($67) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $68
      var $69=$4;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $71
      var $72=$4;
      HEAP32[(($72)>>2)]=2;
      __label__ = 22; break;
    case 22: // $73
      var $74=$header;
      $1=$74;
      __label__ = 30; break;
    case 23: // $75
      __label__ = 24; break;
    case 24: // $76
      __label__ = 25; break;
    case 25: // $77
      __label__ = 26; break;
    case 26: // $78
      var $79=$2;
      var $80=__Z18zip_file_next_fileP9_zip_file($79);
      $header=$80;
      __label__ = 1; break;
    case 27: // $81
      var $82=$4;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $84
      var $85=$4;
      HEAP32[(($85)>>2)]=0;
      __label__ = 29; break;
    case 29: // $86
      $1=0;
      __label__ = 30; break;
    case 30: // $87
      var $88=$1;
      STACKTOP = __stackBase__;
      return $88;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21zippath_find_sub_pathP9_zip_filePKcP19_osd_dir_entry_type["X"]=1;

function __ZL25create_core_file_from_zipP9_zip_filePK16_zip_file_headerPP10_core_file($zip, $header, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $filerr;
      var $ziperr;
      var $ptr;
      $1=$zip;
      $2=$header;
      $3=$file;
      var $4=$2;
      var $5=(($4+24)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=_malloc($6);
      $ptr=$7;
      var $8=$ptr;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $filerr=2;
      __label__ = 7; break;
    case 2: // $11
      var $12=$1;
      var $13=$ptr;
      var $14=$2;
      var $15=(($14+24)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z19zip_file_decompressP9_zip_filePvj($12, $13, $16);
      $ziperr=$17;
      var $18=$ziperr;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$ziperr;
      var $22=__ZL25file_error_from_zip_error10_zip_error($21);
      $filerr=$22;
      __label__ = 7; break;
    case 4: // $23
      var $24=$ptr;
      var $25=$2;
      var $26=(($25+24)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=__Z19core_fopen_ram_copyPKvjjPP10_core_file($24, $27, 1, $28);
      $filerr=$29;
      var $30=$filerr;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      __label__ = 7; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$ptr;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $37
      var $38=$ptr;
      _free($38);
      __label__ = 9; break;
    case 9: // $39
      var $40=$filerr;
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25create_core_file_from_zipP9_zip_filePK16_zip_file_headerPP10_core_file["X"]=1;

function __Z15zippath_opendirPKcPP18_zippath_directory($path, $directory) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $err;
      var $entry_type=__stackBase__;
      var $newpath;
      var $result;
      $1=$path;
      $2=$directory;
      var $3=__Z13astring_allocv();
      $newpath=$3;
      var $4=_malloc(40);
      var $5=$4;
      $result=$5;
      var $6=$result;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $err=2;
      __label__ = 14; break;
    case 2: // $9
      var $10=$result;
      var $11=$10;
      _memset($11, 0, 40, 1);
      var $12=$1;
      var $13=$result;
      var $14=(($13+28)|0);
      var $15=$newpath;
      var $16=__ZL15zippath_resolvePKcP19_osd_dir_entry_typePP9_zip_fileP7astring($12, $entry_type, $14, $15);
      $err=$16;
      var $17=$err;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 14; break;
    case 4: // $20
      var $21=HEAP32[(($entry_type)>>2)];
      var $22=(($21)|0)!=2;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      $err=3;
      __label__ = 14; break;
    case 6: // $24
      var $25=$result;
      var $26=(($25+28)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$newpath;
      var $31=$result;
      var $32=(($31+32)|0);
      HEAP32[(($32)>>2)]=$30;
      $newpath=0;
      __label__ = 13; break;
    case 8: // $33
      var $34=$1;
      var $35=_osd_opendir($34);
      var $36=$result;
      var $37=(($36+20)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$result;
      var $39=(($38+20)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      $err=1;
      __label__ = 14; break;
    case 10: // $43
      var $44=$1;
      var $45=__ZL7is_rootPKc($44);
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $47
      var $48=$result;
      var $49=$48;
      var $50=HEAP32[(($49)>>2)];
      var $51=$50 & -2;
      var $52=$51 | 1;
      HEAP32[(($49)>>2)]=$52;
      __label__ = 12; break;
    case 12: // $53
      __label__ = 13; break;
    case 13: // $54
      __label__ = 14; break;
    case 14: // $55
      var $56=$2;
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $58
      var $59=$err;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $61
      var $62=$result;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $64
      var $65=$result;
      __Z16zippath_closedirP18_zippath_directory($65);
      $result=0;
      __label__ = 18; break;
    case 18: // $66
      var $67=$newpath;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $69
      var $70=$newpath;
      __Z12astring_freeP7astring($70);
      $newpath=0;
      __label__ = 20; break;
    case 20: // $71
      var $72=$2;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $74
      var $75=$result;
      var $76=$2;
      HEAP32[(($76)>>2)]=$75;
      __label__ = 22; break;
    case 22: // $77
      var $78=$err;
      STACKTOP = __stackBase__;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15zippath_opendirPKcPP18_zippath_directory["X"]=1;

function __Z14zippath_is_zipP18_zippath_directory($directory) {
  ;
  var __label__;

  var $1;
  $1=$directory;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4)|0)!=0;
  var $6=(($5)&1);
  ;
  return $6;
}


function __ZL15zippath_resolvePKcP19_osd_dir_entry_typePP9_zip_fileP7astring($path, $entry_type, $zipfile, $newpath) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $err;
      var $current_entry;
      var $current_entry_type=__stackBase__;
      var $apath;
      var $apath_trimmed;
      var $parent;
      var $went_up;
      var $i;
      $1=$path;
      $2=$entry_type;
      $3=$zipfile;
      $4=$newpath;
      $current_entry=0;
      var $5=__Z13astring_allocv();
      var $6=$1;
      var $7=__Z12astring_cpycP7astringPKc($5, $6);
      $apath=$7;
      var $8=__Z13astring_allocv();
      $apath_trimmed=$8;
      $parent=0;
      $went_up=0;
      var $9=$2;
      HEAP32[(($9)>>2)]=0;
      var $10=$3;
      HEAP32[(($10)>>2)]=0;
      __label__ = 1; break;
    case 1: // $11
      var $12=$apath;
      var $13=__Z11astring_lenPK7astring($12);
      $i=$13;
      __label__ = 2; break;
    case 2: // $14
      var $15=$i;
      var $16=(($15)|0) > 1;
      if ($16) { __label__ = 3; break; } else { var $27 = 0;__label__ = 4; break; }
    case 3: // $17
      var $18=$i;
      var $19=(($18-1)|0);
      var $20=$apath;
      var $21=__Z9astring_cPK7astring($20);
      var $22=(($21+$19)|0);
      var $23=HEAP8[($22)];
      var $24=__Z17is_path_separatorc($23);
      var $25=(($24)|0)!=0;
      var $27 = $25;__label__ = 4; break;
    case 4: // $26
      var $27;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      var $29=$i;
      var $30=(($29-1)|0);
      $i=$30;
      __label__ = 2; break;
    case 6: // $31
      var $32=$apath_trimmed;
      var $33=$apath;
      var $34=$i;
      var $35=__Z17astring_cpysubstrP7astringPKS_ii($32, $33, 0, $34);
      $apath_trimmed=$35;
      var $36=$apath_trimmed;
      var $37=__Z9astring_cPK7astring($36);
      var $38=_osd_stat($37);
      $current_entry=$38;
      var $39=$current_entry;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      var $42=$current_entry;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      HEAP32[(($current_entry_type)>>2)]=$44;
      var $45=$current_entry;
      var $46=$45;
      _free($46);
      $current_entry=0;
      __label__ = 9; break;
    case 8: // $47
      HEAP32[(($current_entry_type)>>2)]=0;
      $went_up=1;
      var $48=__Z13astring_allocv();
      var $49=$apath;
      var $50=__Z9astring_cPK7astring($49);
      var $51=__Z14zippath_parentP7astringPKc($48, $50);
      $parent=$51;
      var $52=$apath;
      __Z12astring_freeP7astring($52);
      var $53=$parent;
      $apath=$53;
      __label__ = 9; break;
    case 9: // $54
      __label__ = 10; break;
    case 10: // $55
      var $56=HEAP32[(($current_entry_type)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 11; break; } else { var $68 = 0;__label__ = 13; break; }
    case 11: // $58
      var $59=$apath;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 12; break; } else { var $68 = 0;__label__ = 13; break; }
    case 12: // $61
      var $62=$apath;
      var $63=__Z9astring_cPK7astring($62);
      var $64=__ZL7is_rootPKc($63);
      var $65=(($64)|0)!=0;
      var $66=$65 ^ 1;
      var $68 = $66;__label__ = 13; break;
    case 13: // $67
      var $68;
      if ($68) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 14: // $69
      var $70=HEAP32[(($current_entry_type)>>2)];
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $72
      $err=3;
      __label__ = 31; break;
    case 16: // $73
      var $74=HEAP32[(($current_entry_type)>>2)];
      var $75=(($74)|0)==1;
      if ($75) { __label__ = 17; break; } else { __label__ = 27; break; }
    case 17: // $76
      var $77=$apath_trimmed;
      var $78=__Z9astring_cPK7astring($77);
      var $79=__ZL11is_zip_filePKc($78);
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 18; break; } else { __label__ = 27; break; }
    case 18: // $81
      var $82=$apath_trimmed;
      var $83=__Z9astring_cPK7astring($82);
      var $84=$3;
      var $85=__Z13zip_file_openPKcPP9_zip_file($83, $84);
      var $86=(($85)|0)==0;
      if ($86) { __label__ = 19; break; } else { __label__ = 27; break; }
    case 19: // $87
      var $88=$1;
      var $89=$apath;
      var $90=__Z11astring_lenPK7astring($89);
      var $91=(($88+$90)|0);
      var $92=_strlen($91);
      $i=$92;
      __label__ = 20; break;
    case 20: // $93
      var $94=$i;
      var $95=(($94)|0) > 0;
      if ($95) { __label__ = 21; break; } else { var $108 = 0;__label__ = 22; break; }
    case 21: // $96
      var $97=$apath;
      var $98=__Z11astring_lenPK7astring($97);
      var $99=$i;
      var $100=(($98+$99)|0);
      var $101=(($100-1)|0);
      var $102=$1;
      var $103=(($102+$101)|0);
      var $104=HEAP8[($103)];
      var $105=__ZL21is_zip_path_separatorc($104);
      var $106=(($105)|0)!=0;
      var $108 = $106;__label__ = 22; break;
    case 22: // $107
      var $108;
      if ($108) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $109
      var $110=$i;
      var $111=(($110-1)|0);
      $i=$111;
      __label__ = 20; break;
    case 24: // $112
      var $113=$4;
      var $114=$1;
      var $115=$apath;
      var $116=__Z11astring_lenPK7astring($115);
      var $117=(($114+$116)|0);
      var $118=$i;
      var $119=__Z13astring_cpychP7astringPKci($113, $117, $118);
      var $120=$3;
      var $121=HEAP32[(($120)>>2)];
      var $122=$4;
      var $123=__Z9astring_cPK7astring($122);
      var $124=__ZL21zippath_find_sub_pathP9_zip_filePKcP19_osd_dir_entry_type($121, $123, $current_entry_type);
      var $125=HEAP32[(($current_entry_type)>>2)];
      var $126=(($125)|0)==0;
      if ($126) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $127
      $err=3;
      __label__ = 31; break;
    case 26: // $128
      __label__ = 30; break;
    case 27: // $129
      var $130=$went_up;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $132
      $err=3;
      __label__ = 31; break;
    case 29: // $133
      var $134=$4;
      var $135=$1;
      var $136=__Z12astring_cpycP7astringPKc($134, $135);
      __label__ = 30; break;
    case 30: // $137
      var $138=HEAP32[(($current_entry_type)>>2)];
      var $139=$2;
      HEAP32[(($139)>>2)]=$138;
      $err=0;
      __label__ = 31; break;
    case 31: // $140
      var $141=$apath;
      var $142=(($141)|0)!=0;
      if ($142) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $143
      var $144=$apath;
      __Z12astring_freeP7astring($144);
      __label__ = 33; break;
    case 33: // $145
      var $146=$apath_trimmed;
      var $147=(($146)|0)!=0;
      if ($147) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $148
      var $149=$apath_trimmed;
      __Z12astring_freeP7astring($149);
      __label__ = 35; break;
    case 35: // $150
      var $151=$err;
      STACKTOP = __stackBase__;
      return $151;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15zippath_resolvePKcP19_osd_dir_entry_typePP9_zip_fileP7astring["X"]=1;

function __ZL7is_rootPKc($path) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      $1=$path;
      $i=0;
      var $2=$i;
      var $3=$1;
      var $4=(($3+$2)|0);
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=_isalpha($6);
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=$i;
      var $11=(($10+1)|0);
      var $12=$1;
      var $13=(($12+$11)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==58;
      if ($16) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $17
      var $18=$i;
      var $19=(($18+2)|0);
      $i=$19;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$i;
      var $23=$1;
      var $24=(($23+$22)|0);
      var $25=HEAP8[($24)];
      var $26=__Z17is_path_separatorc($25);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      var $29=$i;
      var $30=(($29+1)|0);
      $i=$30;
      __label__ = 4; break;
    case 6: // $31
      var $32=$i;
      var $33=$1;
      var $34=(($33+$32)|0);
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)==0;
      var $38=(($37)&1);
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16zippath_closedirP18_zippath_directory($directory) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $dirlist;
      $1=$directory;
      var $2=$1;
      var $3=(($2+20)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+20)|0);
      var $9=HEAP32[(($8)>>2)];
      _osd_closedir($9);
      __label__ = 2; break;
    case 2: // $10
      var $11=$1;
      var $12=(($11+28)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16+28)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z14zip_file_closeP9_zip_file($18);
      __label__ = 4; break;
    case 4: // $19
      var $20=$1;
      var $21=(($20+32)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$1;
      var $26=(($25+32)|0);
      var $27=HEAP32[(($26)>>2)];
      __Z12astring_freeP7astring($27);
      __label__ = 6; break;
    case 6: // $28
      __label__ = 7; break;
    case 7: // $29
      var $30=$1;
      var $31=(($30+36)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $34
      var $35=$1;
      var $36=(($35+36)|0);
      var $37=HEAP32[(($36)>>2)];
      $dirlist=$37;
      var $38=$1;
      var $39=(($38+36)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$1;
      var $44=(($43+36)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$dirlist;
      var $46=$45;
      _free($46);
      __label__ = 7; break;
    case 9: // $47
      var $48=$1;
      var $49=$48;
      _free($49);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16zippath_closedirP18_zippath_directory["X"]=1;

function __Z15zippath_readdirP18_zippath_directory($directory) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      var $header;
      var $relpath;
      var $separator;
      var $s;
      var $rdent;
      $1=$directory;
      $result=0;
      var $2=$1;
      var $3=$2;
      var $4=HEAP32[(($3)>>2)];
      var $5=$4 & 1;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$1;
      var $9=$8;
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & -2;
      var $12=$11 | 1;
      HEAP32[(($9)>>2)]=$12;
      var $13=$1;
      var $14=(($13+4)|0);
      var $15=$14;
      for (var $$dest = $15, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $16=$1;
      var $17=(($16+4)|0);
      var $18=(($17)|0);
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str27034)|0);
      var $19=$1;
      var $20=(($19+4)|0);
      var $21=(($20+4)|0);
      HEAP32[(($21)>>2)]=2;
      var $22=$1;
      var $23=(($22+4)|0);
      $result=$23;
      __label__ = 53; break;
    case 2: // $24
      var $25=$1;
      var $26=(($25+20)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 3; break; } else { __label__ = 14; break; }
    case 3: // $29
      __label__ = 4; break;
    case 4: // $30
      var $31=$1;
      var $32=(($31+20)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=_osd_readdir($33);
      $result=$34;
      __label__ = 5; break;
    case 5: // $35
      var $36=$result;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 6; break; } else { var $54 = 0;__label__ = 9; break; }
    case 6: // $38
      var $39=$result;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=_strcmp($41, ((STRING_TABLE.__str17033)|0));
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 7; break; } else { var $52 = 1;__label__ = 8; break; }
    case 7: // $44
      var $45=$result;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=_strcmp($47, ((STRING_TABLE.__str27034)|0));
      var $49=(($48)|0)!=0;
      var $50=$49 ^ 1;
      var $52 = $50;__label__ = 8; break;
    case 8: // $51
      var $52;
      var $54 = $52;__label__ = 9; break;
    case 9: // $53
      var $54;
      if ($54) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 10: // $55
      var $56=$result;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $58
      var $59=$result;
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=__ZL11is_zip_filePKc($61);
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      var $65=$1;
      var $66=(($65+4)|0);
      var $67=$result;
      var $68=$66;
      var $69=$67;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($68)>>2)]=HEAP32[(($69)>>2)];HEAP32[(($68+4)>>2)]=HEAP32[(($69+4)>>2)];HEAP32[(($68+8)>>2)]=HEAP32[(($69+8)>>2)];HEAP32[(($68+12)>>2)]=HEAP32[(($69+12)>>2)];
      var $70=$1;
      var $71=(($70+4)|0);
      var $72=(($71+4)|0);
      HEAP32[(($72)>>2)]=2;
      var $73=$1;
      var $74=(($73+4)|0);
      $result=$74;
      __label__ = 13; break;
    case 13: // $75
      __label__ = 52; break;
    case 14: // $76
      var $77=$1;
      var $78=(($77+28)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 15; break; } else { __label__ = 51; break; }
    case 15: // $81
      __label__ = 16; break;
    case 16: // $82
      __label__ = 17; break;
    case 17: // $83
      var $84=$1;
      var $85=$84;
      var $86=(($85+24)|0);
      var $87=$86;
      var $88=HEAP32[(($87)>>2)];
      var $89=$88 & 1;
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $91
      var $92=$1;
      var $93=(($92+28)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=__Z19zip_file_first_fileP9_zip_file($94);
      $header=$95;
      __label__ = 20; break;
    case 19: // $96
      var $97=$1;
      var $98=(($97+28)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=__Z18zip_file_next_fileP9_zip_file($99);
      $header=$100;
      __label__ = 20; break;
    case 20: // $101
      var $102=$1;
      var $103=$102;
      var $104=(($103+24)|0);
      var $105=$104;
      var $106=HEAP32[(($105)>>2)];
      var $107=$106 & -2;
      var $108=$107 | 1;
      HEAP32[(($105)>>2)]=$108;
      $relpath=0;
      __label__ = 21; break;
    case 21: // $109
      var $110=$header;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 22; break; } else { var $118 = 0;__label__ = 23; break; }
    case 22: // $112
      var $113=$1;
      var $114=$header;
      var $115=__ZL17get_relative_pathP18_zippath_directoryPK16_zip_file_header($113, $114);
      $relpath=$115;
      var $116=(($115)|0)==0;
      var $118 = $116;__label__ = 23; break;
    case 23: // $117
      var $118;
      if ($118) { __label__ = 17; break; } else { __label__ = 24; break; }
    case 24: // $119
      var $120=$relpath;
      var $121=(($120)|0)!=0;
      if ($121) { __label__ = 25; break; } else { __label__ = 46; break; }
    case 25: // $122
      var $123=$relpath;
      $s=$123;
      __label__ = 26; break;
    case 26: // $124
      var $125=$s;
      var $126=HEAP8[($125)];
      var $127=(($126 << 24) >> 24)!=0;
      if ($127) { __label__ = 27; break; } else { var $135 = 0;__label__ = 28; break; }
    case 27: // $128
      var $129=$s;
      var $130=HEAP8[($129)];
      var $131=__ZL21is_zip_file_separatorc($130);
      var $132=(($131)|0)!=0;
      var $133=$132 ^ 1;
      var $135 = $133;__label__ = 28; break;
    case 28: // $134
      var $135;
      if ($135) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $136
      __label__ = 30; break;
    case 30: // $137
      var $138=$s;
      var $139=(($138+1)|0);
      $s=$139;
      __label__ = 26; break;
    case 31: // $140
      var $141=$s;
      var $142=HEAP8[($141)];
      var $143=(($142 << 24) >> 24)!=0;
      if ($143) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $144
      var $145=$s;
      var $148 = $145;__label__ = 34; break;
    case 33: // $146
      var $148 = 0;__label__ = 34; break;
    case 34: // $147
      var $148;
      $separator=$148;
      var $149=$separator;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 35; break; } else { __label__ = 44; break; }
    case 35: // $151
      var $152=$1;
      var $153=(($152+36)|0);
      var $154=HEAP32[(($153)>>2)];
      $rdent=$154;
      __label__ = 36; break;
    case 36: // $155
      var $156=$rdent;
      var $157=(($156)|0)!=0;
      if ($157) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $158
      var $159=$rdent;
      var $160=(($159+4)|0);
      var $161=(($160)|0);
      var $162=$relpath;
      var $163=$separator;
      var $164=$relpath;
      var $165=$163;
      var $166=$164;
      var $167=(($165-$166)|0);
      var $168=__Z13core_strnicmpPKcS0_j($161, $162, $167);
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 39; break; } else { __label__ = 38; break; }
    case 38: // $170
      __label__ = 41; break;
    case 39: // $171
      __label__ = 40; break;
    case 40: // $172
      var $173=$rdent;
      var $174=(($173)|0);
      var $175=HEAP32[(($174)>>2)];
      $rdent=$175;
      __label__ = 36; break;
    case 41: // $176
      var $177=$rdent;
      var $178=(($177)|0)==0;
      if ($178) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $179
      var $180=$separator;
      var $181=$relpath;
      var $182=$180;
      var $183=$181;
      var $184=(($182-$183)|0);
      var $185=(($184+8)|0);
      var $186=_malloc($185);
      var $187=$186;
      $rdent=$187;
      var $188=$1;
      var $189=(($188+36)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$rdent;
      var $192=(($191)|0);
      HEAP32[(($192)>>2)]=$190;
      var $193=$rdent;
      var $194=(($193+4)|0);
      var $195=(($194)|0);
      var $196=$relpath;
      var $197=$separator;
      var $198=$relpath;
      var $199=$197;
      var $200=$198;
      var $201=(($199-$200)|0);
      var $202=(($201)|0);
      assert($202 % 1 === 0, 'memcpy given ' + $202 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($195, $196, $202, 1);
      var $203=$separator;
      var $204=$relpath;
      var $205=$203;
      var $206=$204;
      var $207=(($205-$206)|0);
      var $208=$rdent;
      var $209=(($208+4)|0);
      var $210=(($209+$207)|0);
      HEAP8[($210)]=0;
      var $211=$rdent;
      var $212=$1;
      var $213=(($212+36)|0);
      HEAP32[(($213)>>2)]=$211;
      var $214=$1;
      var $215=(($214+4)|0);
      var $216=$215;
      for (var $$dest = $216, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $217=$rdent;
      var $218=(($217+4)|0);
      var $219=(($218)|0);
      var $220=$1;
      var $221=(($220+4)|0);
      var $222=(($221)|0);
      HEAP32[(($222)>>2)]=$219;
      var $223=$1;
      var $224=(($223+4)|0);
      var $225=(($224+4)|0);
      HEAP32[(($225)>>2)]=2;
      var $226=$1;
      var $227=(($226+4)|0);
      $result=$227;
      __label__ = 43; break;
    case 43: // $228
      __label__ = 45; break;
    case 44: // $229
      var $230=$1;
      var $231=(($230+4)|0);
      var $232=$231;
      for (var $$dest = $232, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $233=$relpath;
      var $234=$1;
      var $235=(($234+4)|0);
      var $236=(($235)|0);
      HEAP32[(($236)>>2)]=$233;
      var $237=$1;
      var $238=(($237+4)|0);
      var $239=(($238+4)|0);
      HEAP32[(($239)>>2)]=1;
      var $240=$header;
      var $241=(($240+24)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243$0=$242;
      var $243$1=0;
      var $244=$1;
      var $245=(($244+4)|0);
      var $246=(($245+8)|0);
      var $st$21$0=(($246)|0);
      HEAP32[(($st$21$0)>>2)]=$243$0;
      var $st$21$1=(($246+4)|0);
      HEAP32[(($st$21$1)>>2)]=$243$1;
      var $247=$1;
      var $248=(($247+4)|0);
      $result=$248;
      __label__ = 45; break;
    case 45: // $249
      __label__ = 46; break;
    case 46: // $250
      __label__ = 47; break;
    case 47: // $251
      var $252=$relpath;
      var $253=(($252)|0)!=0;
      if ($253) { __label__ = 48; break; } else { var $258 = 0;__label__ = 49; break; }
    case 48: // $254
      var $255=$result;
      var $256=(($255)|0)==0;
      var $258 = $256;__label__ = 49; break;
    case 49: // $257
      var $258;
      if ($258) { __label__ = 16; break; } else { __label__ = 50; break; }
    case 50: // $259
      __label__ = 51; break;
    case 51: // $260
      __label__ = 52; break;
    case 52: // $261
      __label__ = 53; break;
    case 53: // $262
      var $263=$result;
      ;
      return $263;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15zippath_readdirP18_zippath_directory["X"]=1;

function __ZL17get_relative_pathP18_zippath_directoryPK16_zip_file_header($directory, $header) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      var $len;
      $1=$directory;
      $2=$header;
      $result=0;
      var $3=$1;
      var $4=(($3+32)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=__Z11astring_lenPK7astring($5);
      $len=$6;
      var $7=$len;
      var $8=$2;
      var $9=(($8+48)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=_strlen($10);
      var $12=(($7)>>>0) <= (($11)>>>0);
      if ($12) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $13
      var $14=$1;
      var $15=(($14+32)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=__Z9astring_cPK7astring($16);
      var $18=$2;
      var $19=(($18+48)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$len;
      var $22=_strncmp($17, $20, $21);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 2; break; }
    case 2: // $24
      var $25=$len;
      var $26=$2;
      var $27=(($26+48)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+$25)|0);
      $result=$29;
      __label__ = 3; break;
    case 3: // $30
      var $31=$result;
      var $32=HEAP8[($31)];
      var $33=__ZL21is_zip_file_separatorc($32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $35
      var $36=$result;
      var $37=(($36+1)|0);
      $result=$37;
      __label__ = 3; break;
    case 5: // $38
      __label__ = 6; break;
    case 6: // $39
      var $40=$result;
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21is_zip_path_separatorc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=__ZL21is_zip_file_separatorc($2);
      var $4=(($3)|0)!=0;
      if ($4) { var $10 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=__Z17is_path_separatorc($6);
      var $8=(($7)|0)!=0;
      var $10 = $8;__label__ = 2; break;
    case 2: // $9
      var $10;
      var $11=(($10)&1);
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL25file_error_from_zip_error10_zip_error($ziperr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $filerr;
      $1=$ziperr;
      var $2=$1;
      if ($2 == 0) {
        __label__ = 1; break;
      }
      else if ($2 == 1) {
        __label__ = 2; break;
      }
      else if ($2 == 3 || $2 == 4 || $2 == 5 || $2 == 6 || $2 == 7 || $2 == 2) {
        __label__ = 3; break;
      }
      else if ($2 == 8) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $3
      $filerr=0;
      __label__ = 6; break;
    case 2: // $4
      $filerr=2;
      __label__ = 6; break;
    case 3: // $5
      $filerr=7;
      __label__ = 6; break;
    case 4: // $6
      __label__ = 5; break;
    case 5: // $7
      $filerr=1;
      __label__ = 6; break;
    case 6: // $8
      var $9=$filerr;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10core_fseekP10_core_filexi($file, $offset$0, $offset$1, $whence) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $err;
      $2=$file;
      var $st$6$0=(($3)|0);
      HEAP32[(($st$6$0)>>2)]=$offset$0;
      var $st$6$1=(($3+4)|0);
      HEAP32[(($st$6$1)>>2)]=$offset$1;
      $4=$whence;
      $err=0;
      var $5=$2;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=1;
      __label__ = 7; break;
    case 2: // $10
      var $11=$2;
      var $12=(($11+48)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$2;
      var $14=(($13+52)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=$4;
      if ($15 == 0) {
        __label__ = 3; break;
      }
      else if ($15 == 1) {
        __label__ = 4; break;
      }
      else if ($15 == 2) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 3: // $16
      var $st$0$0=(($3)|0);
      var $17$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $17$1=HEAP32[(($st$0$1)>>2)];
      var $18=$2;
      var $19=(($18+20)|0);
      var $st$6$0=(($19)|0);
      HEAP32[(($st$6$0)>>2)]=$17$0;
      var $st$6$1=(($19+4)|0);
      HEAP32[(($st$6$1)>>2)]=$17$1;
      __label__ = 6; break;
    case 4: // $20
      var $st$0$0=(($3)|0);
      var $21$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $21$1=HEAP32[(($st$0$1)>>2)];
      var $22=$2;
      var $23=(($22+20)|0);
      var $st$6$0=(($23)|0);
      var $24$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($23+4)|0);
      var $24$1=HEAP32[(($st$6$1)>>2)];
      var $25$0 = ((($24$0)>>>0)+((($24$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296))>>>0; var $25$1 = Math.min(Math.floor((((($24$0)>>>0)+((($24$1)|0)*4294967296))+((($21$0)>>>0)+((($21$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$11$0=(($23)|0);
      HEAP32[(($st$11$0)>>2)]=$25$0;
      var $st$11$1=(($23+4)|0);
      HEAP32[(($st$11$1)>>2)]=$25$1;
      __label__ = 6; break;
    case 5: // $26
      var $27=$2;
      var $28=(($27+28)|0);
      var $st$2$0=(($28)|0);
      var $29$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($3)|0);
      var $30$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $30$1=HEAP32[(($st$6$1)>>2)];
      var $31$0 = ((($29$0)>>>0)+((($29$1)|0)*4294967296))+((($30$0)>>>0)+((($30$1)|0)*4294967296))>>>0; var $31$1 = Math.min(Math.floor((((($29$0)>>>0)+((($29$1)|0)*4294967296))+((($30$0)>>>0)+((($30$1)|0)*4294967296)))/4294967296), 4294967295);
      var $32=$2;
      var $33=(($32+20)|0);
      var $st$13$0=(($33)|0);
      HEAP32[(($st$13$0)>>2)]=$31$0;
      var $st$13$1=(($33+4)|0);
      HEAP32[(($st$13$1)>>2)]=$31$1;
      __label__ = 6; break;
    case 6: // $34
      var $35=$err;
      $1=$35;
      __label__ = 7; break;
    case 7: // $36
      var $37=$1;
      STACKTOP = __stackBase__;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_fseekP10_core_filexi["X"]=1;

function __Z10core_ftellP10_core_file($file) {
  ;
  var __label__;

  var $1;
  $1=$file;
  var $2=$1;
  var $3=(($2+20)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __Z9core_feofP10_core_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$file;
      var $3=$2;
      var $4=(($3+48)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6+52)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)!=(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=0;
      __label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12+20)|0);
      var $st$2$0=(($13)|0);
      var $14$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($13+4)|0);
      var $14$1=HEAP32[(($st$2$1)>>2)];
      var $15=$2;
      var $16=(($15+28)|0);
      var $st$8$0=(($16)|0);
      var $17$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$8$1)>>2)];
      var $18=$14$1 >= $17$1 && ($14$1 > $17$1 || $14$0 >= $17$0);
      var $19=(($18)&1);
      $1=$19;
      __label__ = 3; break;
    case 3: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10core_fsizeP10_core_file($file) {
  ;
  var __label__;

  var $1;
  $1=$file;
  var $2=$1;
  var $3=(($2+28)|0);
  var $st$4$0=(($3)|0);
  var $4$0=HEAP32[(($st$4$0)>>2)];
  var $st$4$1=(($3+4)|0);
  var $4$1=HEAP32[(($st$4$1)>>2)];
  ;
  return [$4$0,$4$1];
}


function __ZL14next_path_charPKcPi($s, $pos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      $1=$s;
      $2=$pos;
      var $3=$2;
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      var $8=$2;
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+$9)|0);
      var $12=HEAP8[($11)];
      var $13=__ZL21is_zip_file_separatorc($12);
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+1)|0);
      HEAP32[(($16)>>2)]=$18;
      __label__ = 2; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$2;
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=(($23+$22)|0);
      var $25=HEAP8[($24)];
      var $26=__ZL21is_zip_file_separatorc($25);
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $28
      __label__ = 7; break;
    case 7: // $29
      var $30=$2;
      var $31=HEAP32[(($30)>>2)];
      var $32=$1;
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=__ZL21is_zip_file_separatorc($34);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $37
      var $38=$2;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+1)|0);
      HEAP32[(($38)>>2)]=$40;
      __label__ = 7; break;
    case 9: // $41
      $result=47;
      __label__ = 14; break;
    case 10: // $42
      var $43=$2;
      var $44=HEAP32[(($43)>>2)];
      var $45=$1;
      var $46=(($45+$44)|0);
      var $47=HEAP8[($46)];
      var $48=(($47 << 24) >> 24);
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $50
      var $51=$2;
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+1)|0);
      HEAP32[(($51)>>2)]=$53;
      var $54=$1;
      var $55=(($54+$52)|0);
      var $56=HEAP8[($55)];
      var $57=(($56 << 24) >> 24);
      var $58=_tolower($57);
      var $59=(($58) & 255);
      $result=$59;
      __label__ = 13; break;
    case 12: // $60
      $result=0;
      __label__ = 13; break;
    case 13: // $61
      __label__ = 14; break;
    case 14: // $62
      var $63=$result;
      ;
      return $63;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14next_path_charPKcPi["X"]=1;

function __ZL12astring_catcP7astringPKc7053($dst, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__Z12astring_inscP7astringiPKc($3, -1, $4);
  ;
  return $5;
}


function __Z10core_fopenPKcjPP10_core_file($filename, $openflags, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $filerr;
      $2=$filename;
      $3=$openflags;
      $4=$file;
      $filerr=3;
      var $5=_malloc(580);
      var $6=$5;
      var $7=$4;
      HEAP32[(($7)>>2)]=$6;
      var $8=$4;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=2;
      __label__ = 5; break;
    case 2: // $12
      var $13=$4;
      var $14=HEAP32[(($13)>>2)];
      var $15=$14;
      _memset($15, 0, 580, 1);
      var $16=$2;
      var $17=$3;
      var $18=$4;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0);
      var $21=$4;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+28)|0);
      var $24=_osd_open($16, $17, $20, $23);
      $filerr=$24;
      var $25=$3;
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+8)|0);
      HEAP32[(($28)>>2)]=$25;
      var $29=$filerr;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $31
      var $32=$4;
      var $33=HEAP32[(($32)>>2)];
      __Z11core_fcloseP10_core_file($33);
      var $34=$4;
      HEAP32[(($34)>>2)]=0;
      __label__ = 4; break;
    case 4: // $35
      var $36=$filerr;
      $1=$36;
      __label__ = 5; break;
    case 5: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_fopenPKcjPP10_core_file["X"]=1;

function __Z11core_fcloseP10_core_file($file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$file;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=__Z14core_fcompressP10_core_filei($7, 0);
      __label__ = 2; break;
    case 2: // $9
      var $10=$1;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=_osd_close($17);
      __label__ = 4; break;
    case 4: // $19
      var $20=$1;
      var $21=(($20+16)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $24
      var $25=$1;
      var $26=(($25+12)|0);
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      var $30=$1;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      _free($32);
      __label__ = 7; break;
    case 7: // $33
      var $34=$1;
      var $35=$34;
      _free($35);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14core_fopen_ramPKvjjPP10_core_file($data, $length, $openflags, $file) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$data;
  $2=$length;
  $3=$openflags;
  $4=$file;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL23core_fopen_ram_internalPKvjijPP10_core_file($5, $6, 0, $7, $8);
  ;
  return $9;
}


function __ZL23core_fopen_ram_internalPKvjijPP10_core_file($data, $length, $copy_buffer, $openflags, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $dest;
      $2=$data;
      $3=$length;
      $4=$copy_buffer;
      $5=$openflags;
      $6=$file;
      var $7=$5;
      var $8=$7 & 2;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=8;
      __label__ = 12; break;
    case 2: // $11
      var $12=$5;
      var $13=$12 & 4;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $1=8;
      __label__ = 12; break;
    case 4: // $16
      var $17=$4;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $19
      var $20=$3;
      var $23 = $20;__label__ = 7; break;
    case 6: // $21
      var $23 = 0;__label__ = 7; break;
    case 7: // $22
      var $23;
      var $24=(($23+580)|0);
      var $25=_malloc($24);
      var $26=$25;
      var $27=$6;
      HEAP32[(($27)>>2)]=$26;
      var $28=$6;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $31
      $1=2;
      __label__ = 12; break;
    case 9: // $32
      var $33=$6;
      var $34=HEAP32[(($33)>>2)];
      var $35=$34;
      _memset($35, 0, 580, 1);
      var $36=$4;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $38
      var $39=$6;
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      var $42=(($41+580)|0);
      $dest=$42;
      var $43=$dest;
      var $44=$2;
      var $45=$3;
      assert($45 % 1 === 0, 'memcpy given ' + $45 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($43, $44, $45, 1);
      var $46=$dest;
      $2=$46;
      __label__ = 11; break;
    case 11: // $47
      var $48=$2;
      var $49=$6;
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+16)|0);
      HEAP32[(($51)>>2)]=$48;
      var $52=$3;
      var $53$0=$52;
      var $53$1=0;
      var $54=$6;
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+28)|0);
      var $st$11$0=(($56)|0);
      HEAP32[(($st$11$0)>>2)]=$53$0;
      var $st$11$1=(($56+4)|0);
      HEAP32[(($st$11$1)>>2)]=$53$1;
      var $57=$5;
      var $58=$6;
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+8)|0);
      HEAP32[(($60)>>2)]=$57;
      $1=0;
      __label__ = 12; break;
    case 12: // $61
      var $62=$1;
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23core_fopen_ram_internalPKvjijPP10_core_file["X"]=1;

function __Z19core_fopen_ram_copyPKvjjPP10_core_file($data, $length, $openflags, $file) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$data;
  $2=$length;
  $3=$openflags;
  $4=$file;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL23core_fopen_ram_internalPKvjijPP10_core_file($5, $6, 1, $7, $8);
  ;
  return $9;
}


function __Z14core_fcompressP10_core_filei($file, $level) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $zerr;
      var $actualdata=__stackBase__;
      var $filerr;
      var $zerr1;
      $2=$file;
      $3=$level;
      $result=0;
      var $4=$2;
      var $5=(($4+8)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 2;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$12 & 1;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      $1=8;
      __label__ = 32; break;
    case 3: // $16
      var $17=$2;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 21; break; }
    case 4: // $21
      var $22=$3;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 5; break; } else { __label__ = 21; break; }
    case 5: // $24
      $zerr=0;
      __label__ = 6; break;
    case 6: // $25
      var $26=$2;
      var $27=(($26+8)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$28 & 2;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 7; break; } else { var $35 = 0;__label__ = 8; break; }
    case 7: // $31
      var $32=$zerr;
      var $33=(($32)|0)!=1;
      var $35 = $33;__label__ = 8; break;
    case 8: // $34
      var $35;
      if ($35) { __label__ = 9; break; } else { __label__ = 17; break; }
    case 9: // $36
      var $37=$2;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0);
      var $41=_deflate($40, 4);
      $zerr=$41;
      var $42=$zerr;
      var $43=(($42)|0)!=1;
      if ($43) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $44
      var $45=$zerr;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $47
      $result=7;
      __label__ = 17; break;
    case 12: // $48
      var $49=$2;
      var $50=(($49+4)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0);
      var $53=(($52+16)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=1024;
      if ($55) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $56
      var $57=$2;
      var $58=(($57)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$2;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+56)|0);
      var $64=(($63)|0);
      var $65=$2;
      var $66=(($65+4)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+1080)|0);
      var $st$12$0=(($68)|0);
      var $69$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($68+4)|0);
      var $69$1=HEAP32[(($st$12$1)>>2)];
      var $70=$2;
      var $71=(($70+4)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72)|0);
      var $74=(($73+16)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=((1024-$75)|0);
      var $77=_osd_write($59, $64, $69$0, $69$1, $76, $actualdata);
      var $77$0=$77[0];
      $filerr=$77;
      var $78=$filerr;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $80
      __label__ = 17; break;
    case 15: // $81
      var $82=HEAP32[(($actualdata)>>2)];
      var $83$0=$82;
      var $83$1=0;
      var $84=$2;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+1080)|0);
      var $st$7$0=(($87)|0);
      var $88$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($87+4)|0);
      var $88$1=HEAP32[(($st$7$1)>>2)];
      var $89$0 = ((($88$0)>>>0)+((($88$1)|0)*4294967296))+((($83$0)>>>0)+((($83$1)|0)*4294967296))>>>0; var $89$1 = Math.min(Math.floor((((($88$0)>>>0)+((($88$1)|0)*4294967296))+((($83$0)>>>0)+((($83$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($87)|0);
      HEAP32[(($st$12$0)>>2)]=$89$0;
      var $st$12$1=(($87+4)|0);
      HEAP32[(($st$12$1)>>2)]=$89$1;
      var $90=$2;
      var $91=(($90+4)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92+56)|0);
      var $94=(($93)|0);
      var $95=$2;
      var $96=(($95+4)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0);
      var $99=(($98+12)|0);
      HEAP32[(($99)>>2)]=$94;
      var $100=$2;
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102)|0);
      var $104=(($103+16)|0);
      HEAP32[(($104)>>2)]=1024;
      __label__ = 16; break;
    case 16: // $105
      __label__ = 6; break;
    case 17: // $106
      var $107=$2;
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=$109 & 2;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $112
      var $113=$2;
      var $114=(($113+4)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115)|0);
      var $117=_deflateEnd($116);
      __label__ = 20; break;
    case 19: // $118
      var $119=$2;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121)|0);
      var $123=_inflateEnd($122);
      __label__ = 20; break;
    case 20: // $124
      var $125=$2;
      var $126=(($125+4)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=$127;
      _free($128);
      var $129=$2;
      var $130=(($129+4)|0);
      HEAP32[(($130)>>2)]=0;
      __label__ = 21; break;
    case 21: // $131
      var $132=$2;
      var $133=(($132+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134)|0)==0;
      if ($135) { __label__ = 22; break; } else { __label__ = 31; break; }
    case 22: // $136
      var $137=$3;
      var $138=(($137)|0) > 0;
      if ($138) { __label__ = 23; break; } else { __label__ = 31; break; }
    case 23: // $139
      var $140=_malloc(1096);
      var $141=$140;
      var $142=$2;
      var $143=(($142+4)|0);
      HEAP32[(($143)>>2)]=$141;
      var $144=$2;
      var $145=(($144+4)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($146)|0)==0;
      if ($147) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $148
      $1=2;
      __label__ = 32; break;
    case 25: // $149
      var $150=$2;
      var $151=(($150+4)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$152;
      _memset($153, 0, 1096, 1);
      var $154=$2;
      var $155=(($154+8)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$156 & 2;
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $159
      var $160=$2;
      var $161=(($160+4)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+56)|0);
      var $164=(($163)|0);
      var $165=$2;
      var $166=(($165+4)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167)|0);
      var $169=(($168+12)|0);
      HEAP32[(($169)>>2)]=$164;
      var $170=$2;
      var $171=(($170+4)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172)|0);
      var $174=(($173+16)|0);
      HEAP32[(($174)>>2)]=1024;
      var $175=$2;
      var $176=(($175+4)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177)|0);
      var $179=$3;
      var $180=_deflateInit_($178, $179, ((STRING_TABLE.__str7054)|0), 56);
      $zerr1=$180;
      __label__ = 28; break;
    case 27: // $181
      var $182=$2;
      var $183=(($182+4)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($184)|0);
      var $186=_inflateInit_($185, ((STRING_TABLE.__str7054)|0), 56);
      $zerr1=$186;
      __label__ = 28; break;
    case 28: // $187
      var $188=$zerr1;
      var $189=(($188)|0)!=0;
      if ($189) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $190
      var $191=$2;
      var $192=(($191+4)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$193;
      _free($194);
      var $195=$2;
      var $196=(($195+4)|0);
      HEAP32[(($196)>>2)]=0;
      $1=2;
      __label__ = 32; break;
    case 30: // $197
      var $198=$2;
      var $199=(($198+64)|0);
      HEAP32[(($199)>>2)]=0;
      var $200=$2;
      var $201=(($200+20)|0);
      var $st$5$0=(($201)|0);
      var $202$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($201+4)|0);
      var $202$1=HEAP32[(($st$5$1)>>2)];
      var $203=$2;
      var $204=(($203+4)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205+1080)|0);
      var $st$13$0=(($206)|0);
      HEAP32[(($st$13$0)>>2)]=$202$0;
      var $st$13$1=(($206+4)|0);
      HEAP32[(($st$13$1)>>2)]=$202$1;
      var $207=$2;
      var $208=(($207+20)|0);
      var $st$19$0=(($208)|0);
      var $209$0=HEAP32[(($st$19$0)>>2)];
      var $st$19$1=(($208+4)|0);
      var $209$1=HEAP32[(($st$19$1)>>2)];
      var $210=$2;
      var $211=(($210+4)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=(($212+1088)|0);
      var $st$27$0=(($213)|0);
      HEAP32[(($st$27$0)>>2)]=$209$0;
      var $st$27$1=(($213+4)|0);
      HEAP32[(($st$27$1)>>2)]=$209$1;
      __label__ = 31; break;
    case 31: // $214
      var $215=$result;
      $1=$215;
      __label__ = 32; break;
    case 32: // $216
      var $217=$1;
      STACKTOP = __stackBase__;
      return $217;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14core_fcompressP10_core_filei["X"]=1;

function __Z11core_ungetciP10_core_file($c, $file) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$c;
  $2=$file;
  var $3=$1;
  var $4=(($3) & 255);
  var $5=$2;
  var $6=(($5+52)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+1)|0);
  HEAP32[(($6)>>2)]=$8;
  var $9=$2;
  var $10=(($9+40)|0);
  var $11=(($10+$7)|0);
  HEAP8[($11)]=$4;
  var $12=$2;
  var $13=(($12+52)|0);
  var $14=HEAPU32[(($13)>>2)];
  var $15=(($14)>>>0)%6;
  HEAP32[(($13)>>2)]=$15;
  var $16=$1;
  ;
  return $16;
}


function __Z10core_freadP10_core_filePvj($file, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bytes_read;
      var $new_bytes_read=__stackBase__;
      $1=$file;
      $2=$buffer;
      $3=$length;
      $bytes_read=0;
      var $4=$1;
      var $5=(($4+48)|0);
      HEAP32[(($5)>>2)]=0;
      var $6=$1;
      var $7=(($6+52)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=$1;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $12
      var $13=$1;
      var $14=(($13+20)|0);
      var $st$2$0=(($14)|0);
      var $15$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($14+4)|0);
      var $15$1=HEAP32[(($st$2$1)>>2)];
      var $16=$1;
      var $17=(($16+56)|0);
      var $st$8$0=(($17)|0);
      var $18$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($17+4)|0);
      var $18$1=HEAP32[(($st$8$1)>>2)];
      var $19=$15$1 >= $18$1 && ($15$1 > $18$1 || $15$0 >= $18$0);
      if ($19) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $20
      var $21=$1;
      var $22=(($21+20)|0);
      var $st$2$0=(($22)|0);
      var $23$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($22+4)|0);
      var $23$1=HEAP32[(($st$2$1)>>2)];
      var $24=$1;
      var $25=(($24+56)|0);
      var $st$8$0=(($25)|0);
      var $26$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$8$1)>>2)];
      var $27=$1;
      var $28=(($27+64)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30$0=$29;
      var $30$1=0;
      var $31$0 = ((($26$0)>>>0)+((($26$1)|0)*4294967296))+((($30$0)>>>0)+((($30$1)|0)*4294967296))>>>0; var $31$1 = Math.min(Math.floor((((($26$0)>>>0)+((($26$1)|0)*4294967296))+((($30$0)>>>0)+((($30$1)|0)*4294967296)))/4294967296), 4294967295);
      var $32=$23$1 < $31$1 || ($23$1 == $31$1 && $23$0 < $31$0);
      if ($32) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $33
      var $34=$1;
      var $35=(($34+68)|0);
      var $36=(($35)|0);
      var $37=$1;
      var $38=(($37+20)|0);
      var $st$5$0=(($38)|0);
      var $39$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($38+4)|0);
      var $39$1=HEAP32[(($st$5$1)>>2)];
      var $40=$1;
      var $41=(($40+56)|0);
      var $st$11$0=(($41)|0);
      var $42$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($41+4)|0);
      var $42$1=HEAP32[(($st$11$1)>>2)];
      var $43$0 = ((($39$0)>>>0)+((($39$1)|0)*4294967296))-((($42$0)>>>0)+((($42$1)|0)*4294967296))>>>0; var $43$1 = Math.min(Math.floor((((($39$0)>>>0)+((($39$1)|0)*4294967296))-((($42$0)>>>0)+((($42$1)|0)*4294967296)))/4294967296), 4294967295);
      var $44$0=$43$0;
      var $44=$44$0;
      var $45=$1;
      var $46=(($45+64)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$2;
      var $49=$bytes_read;
      var $50=$3;
      var $51=__ZL16safe_buffer_copyPKvjjPvjj($36, $44, $47, $48, $49, $50);
      var $52=$bytes_read;
      var $53=(($52+$51)|0);
      $bytes_read=$53;
      __label__ = 4; break;
    case 4: // $54
      var $55=$bytes_read;
      var $56=$3;
      var $57=(($55)>>>0) < (($56)>>>0);
      if ($57) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $58
      var $59=$3;
      var $60=$bytes_read;
      var $61=(($59-$60)|0);
      var $62=(($61)>>>0) < 256;
      if ($62) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $63
      var $64=$1;
      var $65=(($64+20)|0);
      var $st$2$0=(($65)|0);
      var $66$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($65+4)|0);
      var $66$1=HEAP32[(($st$2$1)>>2)];
      var $67=$bytes_read;
      var $68$0=$67;
      var $68$1=0;
      var $69$0 = ((($66$0)>>>0)+((($66$1)|0)*4294967296))+((($68$0)>>>0)+((($68$1)|0)*4294967296))>>>0; var $69$1 = Math.min(Math.floor((((($66$0)>>>0)+((($66$1)|0)*4294967296))+((($68$0)>>>0)+((($68$1)|0)*4294967296)))/4294967296), 4294967295);
      var $70=$1;
      var $71=(($70+56)|0);
      var $st$12$0=(($71)|0);
      HEAP32[(($st$12$0)>>2)]=$69$0;
      var $st$12$1=(($71+4)|0);
      HEAP32[(($st$12$1)>>2)]=$69$1;
      var $72=$1;
      var $73=(($72+64)|0);
      HEAP32[(($73)>>2)]=0;
      var $74=$1;
      var $75=$1;
      var $76=(($75+68)|0);
      var $77=(($76)|0);
      var $78=$1;
      var $79=(($78+56)|0);
      var $st$25$0=(($79)|0);
      var $80$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($79+4)|0);
      var $80$1=HEAP32[(($st$25$1)>>2)];
      var $81=$1;
      var $82=(($81+64)|0);
      var $83=__ZL16osd_or_zlib_readP10_core_filePvyjPj($74, $77, $80$0, $80$1, 512, $82);
      var $83$0=$83[0];
      var $84=$1;
      var $85=(($84+68)|0);
      var $86=(($85)|0);
      var $87=$1;
      var $88=(($87+64)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$2;
      var $91=$bytes_read;
      var $92=$3;
      var $93=__ZL16safe_buffer_copyPKvjjPvjj($86, 0, $89, $90, $91, $92);
      var $94=$bytes_read;
      var $95=(($94+$93)|0);
      $bytes_read=$95;
      __label__ = 8; break;
    case 7: // $96
      HEAP32[(($new_bytes_read)>>2)]=0;
      var $97=$1;
      var $98=$2;
      var $99=$bytes_read;
      var $100=(($98+$99)|0);
      var $101=$1;
      var $102=(($101+20)|0);
      var $st$7$0=(($102)|0);
      var $103$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($102+4)|0);
      var $103$1=HEAP32[(($st$7$1)>>2)];
      var $104=$bytes_read;
      var $105$0=$104;
      var $105$1=0;
      var $106$0 = ((($103$0)>>>0)+((($103$1)|0)*4294967296))+((($105$0)>>>0)+((($105$1)|0)*4294967296))>>>0; var $106$1 = Math.min(Math.floor((((($103$0)>>>0)+((($103$1)|0)*4294967296))+((($105$0)>>>0)+((($105$1)|0)*4294967296)))/4294967296), 4294967295);
      var $107=$3;
      var $108=$bytes_read;
      var $109=(($107-$108)|0);
      var $110=__ZL16osd_or_zlib_readP10_core_filePvyjPj($97, $100, $106$0, $106$1, $109, $new_bytes_read);
      var $110$0=$110[0];
      var $111=HEAP32[(($new_bytes_read)>>2)];
      var $112=$bytes_read;
      var $113=(($112+$111)|0);
      $bytes_read=$113;
      __label__ = 8; break;
    case 8: // $114
      __label__ = 9; break;
    case 9: // $115
      __label__ = 11; break;
    case 10: // $116
      var $117=$1;
      var $118=(($117+16)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$1;
      var $121=(($120+20)|0);
      var $st$5$0=(($121)|0);
      var $122$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($121+4)|0);
      var $122$1=HEAP32[(($st$5$1)>>2)];
      var $123$0=$122$0;
      var $123=$123$0;
      var $124=$1;
      var $125=(($124+28)|0);
      var $st$13$0=(($125)|0);
      var $126$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($125+4)|0);
      var $126$1=HEAP32[(($st$13$1)>>2)];
      var $127$0=$126$0;
      var $127=$127$0;
      var $128=$2;
      var $129=$bytes_read;
      var $130=$3;
      var $131=__ZL16safe_buffer_copyPKvjjPvjj($119, $123, $127, $128, $129, $130);
      var $132=$bytes_read;
      var $133=(($132+$131)|0);
      $bytes_read=$133;
      __label__ = 11; break;
    case 11: // $134
      var $135=$bytes_read;
      var $136$0=$135;
      var $136$1=0;
      var $137=$1;
      var $138=(($137+20)|0);
      var $st$5$0=(($138)|0);
      var $139$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($138+4)|0);
      var $139$1=HEAP32[(($st$5$1)>>2)];
      var $140$0 = ((($139$0)>>>0)+((($139$1)|0)*4294967296))+((($136$0)>>>0)+((($136$1)|0)*4294967296))>>>0; var $140$1 = Math.min(Math.floor((((($139$0)>>>0)+((($139$1)|0)*4294967296))+((($136$0)>>>0)+((($136$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($138)|0);
      HEAP32[(($st$10$0)>>2)]=$140$0;
      var $st$10$1=(($138+4)|0);
      HEAP32[(($st$10$1)>>2)]=$140$1;
      var $141=$bytes_read;
      STACKTOP = __stackBase__;
      return $141;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_freadP10_core_filePvj["X"]=1;

function __ZL16safe_buffer_copyPKvjjPvjj($source, $sourceoffs, $sourcelen, $dest, $destoffs, $destlen) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $sourceavail;
      var $destavail;
      var $bytes_to_copy;
      $1=$source;
      $2=$sourceoffs;
      $3=$sourcelen;
      $4=$dest;
      $5=$destoffs;
      $6=$destlen;
      var $7=$3;
      var $8=$2;
      var $9=(($7-$8)|0);
      $sourceavail=$9;
      var $10=$6;
      var $11=$5;
      var $12=(($10-$11)|0);
      $destavail=$12;
      var $13=$sourceavail;
      var $14=$destavail;
      var $15=(($13)>>>0) < (($14)>>>0);
      var $16=$sourceavail;
      var $17=$destavail;
      var $18=$15 ? $16 : $17;
      $bytes_to_copy=$18;
      var $19=$bytes_to_copy;
      var $20=(($19)>>>0) > 0;
      if ($20) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $21
      var $22=$4;
      var $23=$5;
      var $24=(($22+$23)|0);
      var $25=$1;
      var $26=$2;
      var $27=(($25+$26)|0);
      var $28=$bytes_to_copy;
      assert($28 % 1 === 0, 'memcpy given ' + $28 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($24, $27, $28, 1);
      __label__ = 2; break;
    case 2: // $29
      var $30=$bytes_to_copy;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16osd_or_zlib_readP10_core_filePvyjPj($file, $buffer, $offset$0, $offset$1, $length, $actual) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5;
      var $6;
      var $filerr;
      var $actualdata=__stackBase__+8;
      var $zerr;
      $2=$file;
      $3=$buffer;
      var $st$11$0=(($4)|0);
      HEAP32[(($st$11$0)>>2)]=$offset$0;
      var $st$11$1=(($4+4)|0);
      HEAP32[(($st$11$1)>>2)]=$offset$1;
      $5=$length;
      $6=$actual;
      var $7=$2;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $st$4$0=(($4)|0);
      var $16$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($4+4)|0);
      var $16$1=HEAP32[(($st$4$1)>>2)];
      var $17=$5;
      var $18=$6;
      var $19=_osd_read($14, $15, $16$0, $16$1, $17, $18);
      var $19$0=$19[0];
      $1=$19;
      __label__ = 16; break;
    case 2: // $20
      var $st$0$0=(($4)|0);
      var $21$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $21$1=HEAP32[(($st$0$1)>>2)];
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+1088)|0);
      var $st$8$0=(($25)|0);
      var $26$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$8$1)>>2)];
      var $27=$21$0 != $26$0 || $21$1 != $26$1;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      $1=8;
      __label__ = 16; break;
    case 4: // $29
      var $30=$3;
      var $31=$2;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0);
      var $35=(($34+12)|0);
      HEAP32[(($35)>>2)]=$30;
      var $36=$5;
      var $37=$2;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0);
      var $41=(($40+16)|0);
      HEAP32[(($41)>>2)]=$36;
      __label__ = 5; break;
    case 5: // $42
      var $43=$2;
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0);
      var $47=(($46+16)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $50
      $zerr=0;
      var $51=$2;
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0);
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $58
      var $59=$2;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0);
      var $63=_inflate($62, 2);
      $zerr=$63;
      __label__ = 8; break;
    case 8: // $64
      var $65=$zerr;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $67
      var $68=$5;
      var $69=$2;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0);
      var $73=(($72+16)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($68-$74)|0);
      var $76=$6;
      HEAP32[(($76)>>2)]=$75;
      var $77=$6;
      var $78=HEAP32[(($77)>>2)];
      var $79$0=$78;
      var $79$1=0;
      var $80=$2;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82+1088)|0);
      var $st$18$0=(($83)|0);
      var $84$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($83+4)|0);
      var $84$1=HEAP32[(($st$18$1)>>2)];
      var $85$0 = ((($84$0)>>>0)+((($84$1)|0)*4294967296))+((($79$0)>>>0)+((($79$1)|0)*4294967296))>>>0; var $85$1 = Math.min(Math.floor((((($84$0)>>>0)+((($84$1)|0)*4294967296))+((($79$0)>>>0)+((($79$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$23$0=(($83)|0);
      HEAP32[(($st$23$0)>>2)]=$85$0;
      var $st$23$1=(($83+4)|0);
      HEAP32[(($st$23$1)>>2)]=$85$1;
      var $86=$zerr;
      var $87=(($86)|0)==1;
      var $88=$87 ? 0 : 7;
      $1=$88;
      __label__ = 16; break;
    case 10: // $89
      var $90=$2;
      var $91=(($90+4)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92)|0);
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $97
      var $98=$2;
      var $99=(($98)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$2;
      var $102=(($101+4)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+56)|0);
      var $105=(($104)|0);
      var $106=$2;
      var $107=(($106+4)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+1080)|0);
      var $st$12$0=(($109)|0);
      var $110$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($109+4)|0);
      var $110$1=HEAP32[(($st$12$1)>>2)];
      var $111=_osd_read($100, $105, $110$0, $110$1, 1024, $actualdata);
      var $111$0=$111[0];
      $filerr=$111;
      var $112=$filerr;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $114
      var $115=$filerr;
      $1=$115;
      __label__ = 16; break;
    case 13: // $116
      var $117=HEAP32[(($actualdata)>>2)];
      var $118$0=$117;
      var $118$1=0;
      var $119=$2;
      var $120=(($119+4)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+1080)|0);
      var $st$7$0=(($122)|0);
      var $123$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($122+4)|0);
      var $123$1=HEAP32[(($st$7$1)>>2)];
      var $124$0 = ((($123$0)>>>0)+((($123$1)|0)*4294967296))+((($118$0)>>>0)+((($118$1)|0)*4294967296))>>>0; var $124$1 = Math.min(Math.floor((((($123$0)>>>0)+((($123$1)|0)*4294967296))+((($118$0)>>>0)+((($118$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($122)|0);
      HEAP32[(($st$12$0)>>2)]=$124$0;
      var $st$12$1=(($122+4)|0);
      HEAP32[(($st$12$1)>>2)]=$124$1;
      var $125=$2;
      var $126=(($125+4)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+56)|0);
      var $129=(($128)|0);
      var $130=$2;
      var $131=(($130+4)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132)|0);
      var $134=(($133)|0);
      HEAP32[(($134)>>2)]=$129;
      var $135=$2;
      var $136=(($135+4)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137)|0);
      var $139=(($138+4)|0);
      HEAP32[(($139)>>2)]=1024;
      __label__ = 14; break;
    case 14: // $140
      __label__ = 5; break;
    case 15: // $141
      var $142=$5;
      var $143=$6;
      HEAP32[(($143)>>2)]=$142;
      var $144=$6;
      var $145=HEAP32[(($144)>>2)];
      var $146$0=$145;
      var $146$1=0;
      var $147=$2;
      var $148=(($147+4)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+1088)|0);
      var $st$11$0=(($150)|0);
      var $151$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($150+4)|0);
      var $151$1=HEAP32[(($st$11$1)>>2)];
      var $152$0 = ((($151$0)>>>0)+((($151$1)|0)*4294967296))+((($146$0)>>>0)+((($146$1)|0)*4294967296))>>>0; var $152$1 = Math.min(Math.floor((((($151$0)>>>0)+((($151$1)|0)*4294967296))+((($146$0)>>>0)+((($146$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$16$0=(($150)|0);
      HEAP32[(($st$16$0)>>2)]=$152$0;
      var $st$16$1=(($150+4)|0);
      HEAP32[(($st$16$1)>>2)]=$152$1;
      $1=0;
      __label__ = 16; break;
    case 16: // $153
      var $154=$1;
      STACKTOP = __stackBase__;
      return $154;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16osd_or_zlib_readP10_core_filePvyjPj["X"]=1;

function __Z10core_fgetcP10_core_file($file) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      var $utf16_buffer=__stackBase__;
      var $utf8_buffer=__stackBase__+4;
      var $default_buffer=__stackBase__+12;
      var $uchar=__stackBase__+28;
      var $readlen;
      var $charlen;
      var $bom=__stackBase__+32;
      var $pos;
      $1=$file;
      var $2=$1;
      var $3=(($2+48)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$1;
      var $6=(($5+52)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($4)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 53; break; }
    case 1: // $9
      HEAP32[(($uchar)>>2)]=-1;
      var $10=$1;
      var $11=(($10+20)|0);
      var $st$3$0=(($11)|0);
      var $12$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($11+4)|0);
      var $12$1=HEAP32[(($st$3$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $13=$12$0 == $$emscripten$temp$0$0 && $12$1 == $$emscripten$temp$0$1;
      if ($13) { __label__ = 2; break; } else { __label__ = 30; break; }
    case 2: // $14
      $pos=0;
      var $15=$1;
      var $16=(($bom)|0);
      var $17=__Z10core_freadP10_core_filePvj($15, $16, 4);
      var $18=(($17)|0)==4;
      if ($18) { __label__ = 3; break; } else { __label__ = 29; break; }
    case 3: // $19
      var $20=(($bom)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($22)|0)==239;
      if ($23) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $24
      var $25=(($bom+1)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=(($27)|0)==187;
      if ($28) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $29
      var $30=(($bom+2)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=(($32)|0)==191;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=$1;
      var $36=(($35+36)|0);
      HEAP32[(($36)>>2)]=1;
      $pos=3;
      __label__ = 28; break;
    case 7: // $37
      var $38=(($bom)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=(($40)|0)==0;
      if ($41) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $42
      var $43=(($bom+1)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $47
      var $48=(($bom+2)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=(($50)|0)==254;
      if ($51) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $52
      var $53=(($bom+3)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=(($55)|0)==255;
      if ($56) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $57
      var $58=$1;
      var $59=(($58+36)|0);
      HEAP32[(($59)>>2)]=4;
      $pos=4;
      __label__ = 27; break;
    case 12: // $60
      var $61=(($bom)|0);
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=(($63)|0)==255;
      if ($64) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $65
      var $66=(($bom+1)|0);
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      var $69=(($68)|0)==254;
      if ($69) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $70
      var $71=(($bom+2)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=(($73)|0)==0;
      if ($74) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $75
      var $76=(($bom+3)|0);
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $79=(($78)|0)==0;
      if ($79) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $80
      var $81=$1;
      var $82=(($81+36)|0);
      HEAP32[(($82)>>2)]=5;
      $pos=4;
      __label__ = 26; break;
    case 17: // $83
      var $84=(($bom)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=(($86)|0)==254;
      if ($87) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $88
      var $89=(($bom+1)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $92=(($91)|0)==255;
      if ($92) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $93
      var $94=$1;
      var $95=(($94+36)|0);
      HEAP32[(($95)>>2)]=2;
      $pos=2;
      __label__ = 25; break;
    case 20: // $96
      var $97=(($bom)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=(($99)|0)==255;
      if ($100) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $101
      var $102=(($bom+1)|0);
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=(($104)|0)==254;
      if ($105) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $106
      var $107=$1;
      var $108=(($107+36)|0);
      HEAP32[(($108)>>2)]=3;
      $pos=2;
      __label__ = 24; break;
    case 23: // $109
      var $110=$1;
      var $111=(($110+36)|0);
      HEAP32[(($111)>>2)]=0;
      $pos=0;
      __label__ = 24; break;
    case 24: // $112
      __label__ = 25; break;
    case 25: // $113
      __label__ = 26; break;
    case 26: // $114
      __label__ = 27; break;
    case 27: // $115
      __label__ = 28; break;
    case 28: // $116
      __label__ = 29; break;
    case 29: // $117
      var $118=$1;
      var $119=$pos;
      var $120$0=$119;
      var $120$1=(($119|0) < 0 ? -1 : 0);
      var $121=__Z10core_fseekP10_core_filexi($118, $120$0, $120$1, 0);
      var $121$0=$121[0];
      __label__ = 30; break;
    case 30: // $122
      var $123=$1;
      var $124=(($123+36)|0);
      var $125=HEAP32[(($124)>>2)];
      if ($125 == 0) {
        __label__ = 32; break;
      }
      else if ($125 == 1) {
        __label__ = 35; break;
      }
      else if ($125 == 2) {
        __label__ = 38; break;
      }
      else if ($125 == 3) {
        __label__ = 41; break;
      }
      else if ($125 == 4) {
        __label__ = 44; break;
      }
      else if ($125 == 5) {
        __label__ = 47; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 31: // $126
      __label__ = 32; break;
    case 32: // $127
      var $128=$1;
      var $129=(($default_buffer)|0);
      var $130=__Z10core_freadP10_core_filePvj($128, $129, 16);
      $readlen=$130;
      var $131=$readlen;
      var $132=(($131)|0) > 0;
      if ($132) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $133
      var $134=(($default_buffer)|0);
      var $135=$readlen;
      var $136=Math.floor((($135)>>>0));
      var $137=_osd_uchar_from_osdchar($uchar, $134, $136);
      $charlen=$137;
      var $138=$1;
      var $139=$charlen;
      var $140=(($139)|0);
      var $141$0=$140;
      var $141$1=0;
      var $142=$readlen;
      var $143$0=$142;
      var $143$1=(($142|0) < 0 ? -1 : 0);
      var $144$0 = ((($141$0)>>>0)+((($141$1)|0)*4294967296))-((($143$0)>>>0)+((($143$1)|0)*4294967296))>>>0; var $144$1 = Math.min(Math.floor((((($141$0)>>>0)+((($141$1)|0)*4294967296))-((($143$0)>>>0)+((($143$1)|0)*4294967296)))/4294967296), 4294967295);
      var $145=__Z10core_fseekP10_core_filexi($138, $144$0, $144$1, 1);
      var $145$0=$145[0];
      __label__ = 34; break;
    case 34: // $146
      __label__ = 50; break;
    case 35: // $147
      var $148=$1;
      var $149=(($utf8_buffer)|0);
      var $150=__Z10core_freadP10_core_filePvj($148, $149, 6);
      $readlen=$150;
      var $151=$readlen;
      var $152=(($151)|0) > 0;
      if ($152) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $153
      var $154=(($utf8_buffer)|0);
      var $155=$readlen;
      var $156=Math.floor((($155)>>>0));
      var $157=__Z15uchar_from_utf8PjPKcj($uchar, $154, $156);
      $charlen=$157;
      var $158=$1;
      var $159=$charlen;
      var $160=(($159)|0);
      var $161$0=$160;
      var $161$1=0;
      var $162=$readlen;
      var $163$0=$162;
      var $163$1=(($162|0) < 0 ? -1 : 0);
      var $164$0 = ((($161$0)>>>0)+((($161$1)|0)*4294967296))-((($163$0)>>>0)+((($163$1)|0)*4294967296))>>>0; var $164$1 = Math.min(Math.floor((((($161$0)>>>0)+((($161$1)|0)*4294967296))-((($163$0)>>>0)+((($163$1)|0)*4294967296)))/4294967296), 4294967295);
      var $165=__Z10core_fseekP10_core_filexi($158, $164$0, $164$1, 1);
      var $165$0=$165[0];
      __label__ = 37; break;
    case 37: // $166
      __label__ = 50; break;
    case 38: // $167
      var $168=$1;
      var $169=(($utf16_buffer)|0);
      var $170=$169;
      var $171=__Z10core_freadP10_core_filePvj($168, $170, 4);
      $readlen=$171;
      var $172=$readlen;
      var $173=(($172)|0) > 0;
      if ($173) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $174
      var $175=(($utf16_buffer)|0);
      var $176=$readlen;
      var $177=Math.floor((($176)>>>0)/2);
      var $178=__Z17uchar_from_utf16fPjPKtj($uchar, $175, $177);
      $charlen=$178;
      var $179=$1;
      var $180=$charlen;
      var $181=((($180<<1))|0);
      var $182$0=$181;
      var $182$1=0;
      var $183=$readlen;
      var $184$0=$183;
      var $184$1=(($183|0) < 0 ? -1 : 0);
      var $185$0 = ((($182$0)>>>0)+((($182$1)|0)*4294967296))-((($184$0)>>>0)+((($184$1)|0)*4294967296))>>>0; var $185$1 = Math.min(Math.floor((((($182$0)>>>0)+((($182$1)|0)*4294967296))-((($184$0)>>>0)+((($184$1)|0)*4294967296)))/4294967296), 4294967295);
      var $186=__Z10core_fseekP10_core_filexi($179, $185$0, $185$1, 1);
      var $186$0=$186[0];
      __label__ = 40; break;
    case 40: // $187
      __label__ = 50; break;
    case 41: // $188
      var $189=$1;
      var $190=(($utf16_buffer)|0);
      var $191=$190;
      var $192=__Z10core_freadP10_core_filePvj($189, $191, 4);
      $readlen=$192;
      var $193=$readlen;
      var $194=(($193)|0) > 0;
      if ($194) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $195
      var $196=(($utf16_buffer)|0);
      var $197=$readlen;
      var $198=Math.floor((($197)>>>0)/2);
      var $199=__Z16uchar_from_utf16PjPKtj($uchar, $196, $198);
      $charlen=$199;
      var $200=$1;
      var $201=$charlen;
      var $202=((($201<<1))|0);
      var $203$0=$202;
      var $203$1=0;
      var $204=$readlen;
      var $205$0=$204;
      var $205$1=(($204|0) < 0 ? -1 : 0);
      var $206$0 = ((($203$0)>>>0)+((($203$1)|0)*4294967296))-((($205$0)>>>0)+((($205$1)|0)*4294967296))>>>0; var $206$1 = Math.min(Math.floor((((($203$0)>>>0)+((($203$1)|0)*4294967296))-((($205$0)>>>0)+((($205$1)|0)*4294967296)))/4294967296), 4294967295);
      var $207=__Z10core_fseekP10_core_filexi($200, $206$0, $206$1, 1);
      var $207$0=$207[0];
      __label__ = 43; break;
    case 43: // $208
      __label__ = 50; break;
    case 44: // $209
      var $210=$1;
      var $211=$uchar;
      var $212=__Z10core_freadP10_core_filePvj($210, $211, 4);
      var $213=(($212)|0)==4;
      if ($213) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $214
      var $215=HEAP32[(($uchar)>>2)];
      var $216=$215 << 24;
      var $217=HEAPU32[(($uchar)>>2)];
      var $218=$217 >>> 24;
      var $219=$216 | $218;
      var $220=HEAP32[(($uchar)>>2)];
      var $221=$220 & 65280;
      var $222=$221 << 8;
      var $223=$219 | $222;
      var $224=HEAP32[(($uchar)>>2)];
      var $225=$224 & 16711680;
      var $226=$225 >>> 8;
      var $227=$223 | $226;
      HEAP32[(($uchar)>>2)]=$227;
      __label__ = 46; break;
    case 46: // $228
      __label__ = 50; break;
    case 47: // $229
      var $230=$1;
      var $231=$uchar;
      var $232=__Z10core_freadP10_core_filePvj($230, $231, 4);
      var $233=(($232)|0)==4;
      if ($233) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $234
      var $235=HEAP32[(($uchar)>>2)];
      HEAP32[(($uchar)>>2)]=$235;
      __label__ = 49; break;
    case 49: // $236
      __label__ = 50; break;
    case 50: // $237
      var $238=HEAP32[(($uchar)>>2)];
      var $239=(($238)|0)!=-1;
      if ($239) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $240
      var $241=$1;
      var $242=(($241+48)|0);
      HEAP32[(($242)>>2)]=0;
      var $243=$1;
      var $244=(($243+40)|0);
      var $245=(($244)|0);
      var $246=HEAP32[(($uchar)>>2)];
      var $247=__Z15utf8_from_ucharPcjj($245, 6, $246);
      var $248=$1;
      var $249=(($248+52)|0);
      HEAP32[(($249)>>2)]=$247;
      __label__ = 52; break;
    case 52: // $250
      __label__ = 53; break;
    case 53: // $251
      var $252=$1;
      var $253=(($252+48)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=$1;
      var $256=(($255+52)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($254)|0)!=(($257)|0);
      if ($258) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $259
      var $260=$1;
      var $261=(($260+48)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(($262+1)|0);
      HEAP32[(($261)>>2)]=$263;
      var $264=$1;
      var $265=(($264+40)|0);
      var $266=(($265+$262)|0);
      var $267=HEAP8[($266)];
      var $268=(($267 << 24) >> 24);
      $result=$268;
      var $269=$1;
      var $270=(($269+48)|0);
      var $271=HEAPU32[(($270)>>2)];
      var $272=(($271)>>>0)%6;
      HEAP32[(($270)>>2)]=$272;
      __label__ = 56; break;
    case 55: // $273
      $result=-1;
      __label__ = 56; break;
    case 56: // $274
      var $275=$result;
      STACKTOP = __stackBase__;
      return $275;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_fgetcP10_core_file["X"]=1;

function __ZL22is_directory_separatorc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0)==92;
      if ($4) { var $14 = 1;__label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==47;
      if ($8) { var $14 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)==58;
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      var $15=(($14)&1);
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10core_fgetsPciP10_core_file($s, $n, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cur;
      var $c;
      var $c2;
      $2=$s;
      $3=$n;
      $4=$file;
      var $5=$2;
      $cur=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$3;
      var $8=(($7)|0) > 0;
      if ($8) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $9
      var $10=$4;
      var $11=__Z10core_fgetcP10_core_file($10);
      $c=$11;
      var $12=$c;
      var $13=(($12)|0)==-1;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      __label__ = 12; break;
    case 4: // $15
      var $16=$c;
      var $17=(($16)|0)==13;
      if ($17) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $18
      var $19=$4;
      var $20=__Z10core_fgetcP10_core_file($19);
      $c2=$20;
      var $21=$c2;
      var $22=(($21)|0)!=10;
      if ($22) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $23
      var $24=$c2;
      var $25=$4;
      var $26=__Z11core_ungetciP10_core_file($24, $25);
      __label__ = 7; break;
    case 7: // $27
      var $28=$cur;
      var $29=(($28+1)|0);
      $cur=$29;
      HEAP8[($28)]=13;
      var $30=$3;
      var $31=(($30-1)|0);
      $3=$31;
      __label__ = 12; break;
    case 8: // $32
      var $33=$c;
      var $34=(($33)|0)==10;
      if ($34) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $35
      var $36=$cur;
      var $37=(($36+1)|0);
      $cur=$37;
      HEAP8[($36)]=13;
      var $38=$3;
      var $39=(($38-1)|0);
      $3=$39;
      __label__ = 12; break;
    case 10: // $40
      __label__ = 11; break;
    case 11: // $41
      var $42=$c;
      var $43=(($42) & 255);
      var $44=$cur;
      var $45=(($44+1)|0);
      $cur=$45;
      HEAP8[($44)]=$43;
      var $46=$3;
      var $47=(($46-1)|0);
      $3=$47;
      __label__ = 1; break;
    case 12: // $48
      var $49=$cur;
      var $50=$2;
      var $51=(($49)|0)==(($50)|0);
      if ($51) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $52
      $1=0;
      __label__ = 17; break;
    case 14: // $53
      var $54=$3;
      var $55=(($54)|0) > 0;
      if ($55) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $56
      var $57=$cur;
      var $58=(($57+1)|0);
      $cur=$58;
      HEAP8[($57)]=0;
      __label__ = 16; break;
    case 16: // $59
      var $60=$2;
      $1=$60;
      __label__ = 17; break;
    case 17: // $61
      var $62=$1;
      ;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_fgetsPciP10_core_file["X"]=1;

function __Z12core_fbufferP10_core_file($file) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $filerr;
      var $read_length=__stackBase__;
      $2=$file;
      var $3=$2;
      var $4=(($3+16)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      $1=$10;
      __label__ = 8; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12+28)|0);
      var $st$2$0=(($13)|0);
      var $14$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($13+4)|0);
      var $14$1=HEAP32[(($st$2$1)>>2)];
      var $15$0=$14$0;
      var $15=$15$0;
      var $16=_malloc($15);
      var $17=$2;
      var $18=(($17+16)|0);
      HEAP32[(($18)>>2)]=$16;
      var $19=$2;
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      $1=0;
      __label__ = 8; break;
    case 4: // $24
      var $25=$2;
      var $26=(($25+12)|0);
      HEAP8[($26)]=1;
      var $27=$2;
      var $28=$2;
      var $29=(($28+16)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$2;
      var $32=(($31+28)|0);
      var $st$9$0=(($32)|0);
      var $33$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($32+4)|0);
      var $33$1=HEAP32[(($st$9$1)>>2)];
      var $34$0=$33$0;
      var $34=$34$0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $35=__ZL16osd_or_zlib_readP10_core_filePvyjPj($27, $30, $$emscripten$temp$0$0, $$emscripten$temp$0$1, $34, $read_length);
      var $35$0=$35[0];
      $filerr=$35;
      var $36=$filerr;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $38
      var $39=HEAP32[(($read_length)>>2)];
      var $40$0=$39;
      var $40$1=0;
      var $41=$2;
      var $42=(($41+28)|0);
      var $st$5$0=(($42)|0);
      var $43$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($42+4)|0);
      var $43$1=HEAP32[(($st$5$1)>>2)];
      var $44=$40$0 != $43$0 || $40$1 != $43$1;
      if ($44) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $45
      var $46=$2;
      var $47=(($46+16)|0);
      var $48=HEAP32[(($47)>>2)];
      _free($48);
      var $49=$2;
      var $50=(($49+16)|0);
      HEAP32[(($50)>>2)]=0;
      $1=0;
      __label__ = 8; break;
    case 7: // $51
      var $52=$2;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=_osd_close($54);
      var $56=$2;
      var $57=(($56)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=$2;
      var $59=(($58+16)|0);
      var $60=HEAP32[(($59)>>2)];
      $1=$60;
      __label__ = 8; break;
    case 8: // $61
      var $62=$1;
      STACKTOP = __stackBase__;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z12core_fbufferP10_core_file["X"]=1;

function __Z10core_floadPKcPPvPj($filename, $data, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $file=__stackBase__;
      var $err;
      var $size=__stackBase__+4;
      $2=$filename;
      $3=$data;
      $4=$length;
      HEAP32[(($file)>>2)]=0;
      var $5=$2;
      var $6=__Z10core_fopenPKcjPP10_core_file($5, 1, $file);
      $err=$6;
      var $7=$err;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$err;
      $1=$10;
      __label__ = 9; break;
    case 2: // $11
      var $12=HEAP32[(($file)>>2)];
      var $13=__Z10core_fsizeP10_core_file($12);
      var $13$0=$13[0];
      var $13$1=$13[1];
      var $st$4$0=(($size)|0);
      HEAP32[(($st$4$0)>>2)]=$13$0;
      var $st$4$1=(($size+4)|0);
      HEAP32[(($st$4$1)>>2)]=$13$1;
      var $st$8$0=(($size)|0);
      var $14$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($size+4)|0);
      var $14$1=HEAP32[(($st$8$1)>>2)];
      var $15$0=$14$0;
      var $15=$15$0;
      var $16$0=$15;
      var $16$1=0;
      var $st$16$0=(($size)|0);
      var $17$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($size+4)|0);
      var $17$1=HEAP32[(($st$16$1)>>2)];
      var $18=$16$0 != $17$0 || $16$1 != $17$1;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=HEAP32[(($file)>>2)];
      __Z11core_fcloseP10_core_file($20);
      $1=2;
      __label__ = 9; break;
    case 4: // $21
      var $st$0$0=(($size)|0);
      var $22$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($size+4)|0);
      var $22$1=HEAP32[(($st$0$1)>>2)];
      var $23$0=$22$0;
      var $23=$23$0;
      var $24=_malloc($23);
      var $25=$3;
      HEAP32[(($25)>>2)]=$24;
      var $26=$4;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      var $st$0$0=(($size)|0);
      var $29$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($size+4)|0);
      var $29$1=HEAP32[(($st$0$1)>>2)];
      var $30$0=$29$0;
      var $30=$30$0;
      var $31=$4;
      HEAP32[(($31)>>2)]=$30;
      __label__ = 6; break;
    case 6: // $32
      var $33=HEAP32[(($file)>>2)];
      var $34=$3;
      var $35=HEAP32[(($34)>>2)];
      var $st$3$0=(($size)|0);
      var $36$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($size+4)|0);
      var $36$1=HEAP32[(($st$3$1)>>2)];
      var $37$0=$36$0;
      var $37=$37$0;
      var $38=__Z10core_freadP10_core_filePvj($33, $35, $37);
      var $39$0=$38;
      var $39$1=0;
      var $st$12$0=(($size)|0);
      var $40$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($size+4)|0);
      var $40$1=HEAP32[(($st$12$1)>>2)];
      var $41=$39$0 != $40$0 || $39$1 != $40$1;
      if ($41) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $42
      var $43=HEAP32[(($file)>>2)];
      __Z11core_fcloseP10_core_file($43);
      var $44=$3;
      var $45=HEAP32[(($44)>>2)];
      _free($45);
      $1=1;
      __label__ = 9; break;
    case 8: // $46
      var $47=HEAP32[(($file)>>2)];
      __Z11core_fcloseP10_core_file($47);
      $1=0;
      __label__ = 9; break;
    case 9: // $48
      var $49=$1;
      STACKTOP = __stackBase__;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_floadPKcPPvPj["X"]=1;

function __Z11core_fwriteP10_core_filePKvj($file, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $bytes_written=__stackBase__;
      $2=$file;
      $3=$buffer;
      $4=$length;
      HEAP32[(($bytes_written)>>2)]=0;
      var $5=$2;
      var $6=(($5+16)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 6; break;
    case 2: // $10
      var $11=$2;
      var $12=(($11+48)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$2;
      var $14=(($13+52)|0);
      HEAP32[(($14)>>2)]=0;
      var $15=$2;
      var $16=(($15+64)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=$2;
      var $18=$3;
      var $19=$2;
      var $20=(($19+20)|0);
      var $st$13$0=(($20)|0);
      var $21$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($20+4)|0);
      var $21$1=HEAP32[(($st$13$1)>>2)];
      var $22=$4;
      var $23=__ZL17osd_or_zlib_writeP10_core_filePKvyjPj($17, $18, $21$0, $21$1, $22, $bytes_written);
      var $23$0=$23[0];
      var $24=HEAP32[(($bytes_written)>>2)];
      var $25$0=$24;
      var $25$1=0;
      var $26=$2;
      var $27=(($26+20)|0);
      var $st$25$0=(($27)|0);
      var $28$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($27+4)|0);
      var $28$1=HEAP32[(($st$25$1)>>2)];
      var $29$0 = ((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($25$0)>>>0)+((($25$1)|0)*4294967296))>>>0; var $29$1 = Math.min(Math.floor((((($28$0)>>>0)+((($28$1)|0)*4294967296))+((($25$0)>>>0)+((($25$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$30$0=(($27)|0);
      HEAP32[(($st$30$0)>>2)]=$29$0;
      var $st$30$1=(($27+4)|0);
      HEAP32[(($st$30$1)>>2)]=$29$1;
      var $30=$2;
      var $31=(($30+28)|0);
      var $st$36$0=(($31)|0);
      var $32$0=HEAP32[(($st$36$0)>>2)];
      var $st$36$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$36$1)>>2)];
      var $33=$2;
      var $34=(($33+20)|0);
      var $st$42$0=(($34)|0);
      var $35$0=HEAP32[(($st$42$0)>>2)];
      var $st$42$1=(($34+4)|0);
      var $35$1=HEAP32[(($st$42$1)>>2)];
      var $36=$32$1 > $35$1 || ($32$1 == $35$1 && $32$0 > $35$0);
      if ($36) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $37
      var $38=$2;
      var $39=(($38+28)|0);
      var $st$2$0=(($39)|0);
      var $40$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$2$1)>>2)];
      var $46$1 = $40$1;var $46$0 = $40$0;__label__ = 5; break;
    case 4: // $41
      var $42=$2;
      var $43=(($42+20)|0);
      var $st$2$0=(($43)|0);
      var $44$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($43+4)|0);
      var $44$1=HEAP32[(($st$2$1)>>2)];
      var $46$1 = $44$1;var $46$0 = $44$0;__label__ = 5; break;
    case 5: // $45
      var $46$0;
      var $46$1;
      var $47=$2;
      var $48=(($47+28)|0);
      var $st$4$0=(($48)|0);
      HEAP32[(($st$4$0)>>2)]=$46$0;
      var $st$4$1=(($48+4)|0);
      HEAP32[(($st$4$1)>>2)]=$46$1;
      var $49=HEAP32[(($bytes_written)>>2)];
      $1=$49;
      __label__ = 6; break;
    case 6: // $50
      var $51=$1;
      STACKTOP = __stackBase__;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11core_fwriteP10_core_filePKvj["X"]=1;

function __ZL17osd_or_zlib_writeP10_core_filePKvyjPj($file, $buffer, $offset$0, $offset$1, $length, $actual) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5;
      var $6;
      var $filerr;
      var $actualdata=__stackBase__+8;
      var $zerr;
      $2=$file;
      $3=$buffer;
      var $st$11$0=(($4)|0);
      HEAP32[(($st$11$0)>>2)]=$offset$0;
      var $st$11$1=(($4+4)|0);
      HEAP32[(($st$11$1)>>2)]=$offset$1;
      $5=$length;
      $6=$actual;
      var $7=$2;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$3;
      var $st$4$0=(($4)|0);
      var $16$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($4+4)|0);
      var $16$1=HEAP32[(($st$4$1)>>2)];
      var $17=$5;
      var $18=$6;
      var $19=_osd_write($14, $15, $16$0, $16$1, $17, $18);
      var $19$0=$19[0];
      $1=$19;
      __label__ = 14; break;
    case 2: // $20
      var $st$0$0=(($4)|0);
      var $21$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $21$1=HEAP32[(($st$0$1)>>2)];
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+1088)|0);
      var $st$8$0=(($25)|0);
      var $26$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($25+4)|0);
      var $26$1=HEAP32[(($st$8$1)>>2)];
      var $27=$21$0 != $26$0 || $21$1 != $26$1;
      if ($27) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $28
      $1=8;
      __label__ = 14; break;
    case 4: // $29
      var $30=$3;
      var $31=$2;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0);
      var $35=(($34)|0);
      HEAP32[(($35)>>2)]=$30;
      var $36=$5;
      var $37=$2;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0);
      var $41=(($40+4)|0);
      HEAP32[(($41)>>2)]=$36;
      __label__ = 5; break;
    case 5: // $42
      var $43=$2;
      var $44=(($43+4)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0);
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $50
      var $51=$2;
      var $52=(($51+4)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0);
      var $55=_deflate($54, 0);
      $zerr=$55;
      var $56=$zerr;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $58
      var $59=$5;
      var $60=$2;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0);
      var $64=(($63+4)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($59-$65)|0);
      var $67=$6;
      HEAP32[(($67)>>2)]=$66;
      var $68=$6;
      var $69=HEAP32[(($68)>>2)];
      var $70$0=$69;
      var $70$1=0;
      var $71=$2;
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+1088)|0);
      var $st$18$0=(($74)|0);
      var $75$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($74+4)|0);
      var $75$1=HEAP32[(($st$18$1)>>2)];
      var $76$0 = ((($75$0)>>>0)+((($75$1)|0)*4294967296))+((($70$0)>>>0)+((($70$1)|0)*4294967296))>>>0; var $76$1 = Math.min(Math.floor((((($75$0)>>>0)+((($75$1)|0)*4294967296))+((($70$0)>>>0)+((($70$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$23$0=(($74)|0);
      HEAP32[(($st$23$0)>>2)]=$76$0;
      var $st$23$1=(($74+4)|0);
      HEAP32[(($st$23$1)>>2)]=$76$1;
      $1=7;
      __label__ = 14; break;
    case 8: // $77
      var $78=$2;
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0);
      var $82=(($81+16)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)==0;
      if ($84) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $85
      var $86=$2;
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$2;
      var $90=(($89+4)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91+56)|0);
      var $93=(($92)|0);
      var $94=$2;
      var $95=(($94+4)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+1080)|0);
      var $st$12$0=(($97)|0);
      var $98$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($97+4)|0);
      var $98$1=HEAP32[(($st$12$1)>>2)];
      var $99=_osd_write($88, $93, $98$0, $98$1, 1024, $actualdata);
      var $99$0=$99[0];
      $filerr=$99;
      var $100=$filerr;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $102
      var $103=$filerr;
      $1=$103;
      __label__ = 14; break;
    case 11: // $104
      var $105=HEAP32[(($actualdata)>>2)];
      var $106$0=$105;
      var $106$1=0;
      var $107=$2;
      var $108=(($107+4)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+1080)|0);
      var $st$7$0=(($110)|0);
      var $111$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($110+4)|0);
      var $111$1=HEAP32[(($st$7$1)>>2)];
      var $112$0 = ((($111$0)>>>0)+((($111$1)|0)*4294967296))+((($106$0)>>>0)+((($106$1)|0)*4294967296))>>>0; var $112$1 = Math.min(Math.floor((((($111$0)>>>0)+((($111$1)|0)*4294967296))+((($106$0)>>>0)+((($106$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$12$0=(($110)|0);
      HEAP32[(($st$12$0)>>2)]=$112$0;
      var $st$12$1=(($110+4)|0);
      HEAP32[(($st$12$1)>>2)]=$112$1;
      var $113=$2;
      var $114=(($113+4)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115+56)|0);
      var $117=(($116)|0);
      var $118=$2;
      var $119=(($118+4)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120)|0);
      var $122=(($121+12)|0);
      HEAP32[(($122)>>2)]=$117;
      var $123=$2;
      var $124=(($123+4)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125)|0);
      var $127=(($126+16)|0);
      HEAP32[(($127)>>2)]=1024;
      __label__ = 12; break;
    case 12: // $128
      __label__ = 5; break;
    case 13: // $129
      var $130=$5;
      var $131=$6;
      HEAP32[(($131)>>2)]=$130;
      var $132=$6;
      var $133=HEAP32[(($132)>>2)];
      var $134$0=$133;
      var $134$1=0;
      var $135=$2;
      var $136=(($135+4)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+1088)|0);
      var $st$11$0=(($138)|0);
      var $139$0=HEAP32[(($st$11$0)>>2)];
      var $st$11$1=(($138+4)|0);
      var $139$1=HEAP32[(($st$11$1)>>2)];
      var $140$0 = ((($139$0)>>>0)+((($139$1)|0)*4294967296))+((($134$0)>>>0)+((($134$1)|0)*4294967296))>>>0; var $140$1 = Math.min(Math.floor((((($139$0)>>>0)+((($139$1)|0)*4294967296))+((($134$0)>>>0)+((($134$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$16$0=(($138)|0);
      HEAP32[(($st$16$0)>>2)]=$140$0;
      var $st$16$1=(($138+4)|0);
      HEAP32[(($st$16$1)>>2)]=$140$1;
      $1=0;
      __label__ = 14; break;
    case 14: // $141
      var $142=$1;
      STACKTOP = __stackBase__;
      return $142;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17osd_or_zlib_writeP10_core_filePKvyjPj["X"]=1;

function __Z10core_fputsP10_core_filePKc($f, $s) {
  var __stackBase__  = STACKTOP; STACKTOP += 1024; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $convbuf=__stackBase__;
      var $pconvbuf;
      var $count;
      $1=$f;
      $2=$s;
      var $3=(($convbuf)|0);
      $pconvbuf=$3;
      $count=0;
      var $4=$1;
      var $5=(($4+20)|0);
      var $st$12$0=(($5)|0);
      var $6$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($5+4)|0);
      var $6$1=HEAP32[(($st$12$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $7=$6$0 == $$emscripten$temp$0$0 && $6$1 == $$emscripten$temp$0$1;
      if ($7) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      var $9=$1;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 256;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=$pconvbuf;
      var $16=(($15+1)|0);
      $pconvbuf=$16;
      HEAP8[($15)]=-17;
      var $17=$pconvbuf;
      var $18=(($17+1)|0);
      $pconvbuf=$18;
      HEAP8[($17)]=-69;
      var $19=$pconvbuf;
      var $20=(($19+1)|0);
      $pconvbuf=$20;
      HEAP8[($19)]=-65;
      __label__ = 3; break;
    case 3: // $21
      __label__ = 4; break;
    case 4: // $22
      var $23=$2;
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24);
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $27
      var $28=$2;
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==10;
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      var $33=$pconvbuf;
      var $34=(($33+1)|0);
      $pconvbuf=$34;
      HEAP8[($33)]=10;
      __label__ = 8; break;
    case 7: // $35
      var $36=$2;
      var $37=HEAP8[($36)];
      var $38=$pconvbuf;
      var $39=(($38+1)|0);
      $pconvbuf=$39;
      HEAP8[($38)]=$37;
      __label__ = 8; break;
    case 8: // $40
      var $41=$2;
      var $42=(($41+1)|0);
      $2=$42;
      var $43=$pconvbuf;
      var $44=(($convbuf)|0);
      var $45=(($44+1024)|0);
      var $46=(($45-10)|0);
      var $47=(($43)>>>0) >= (($46)>>>0);
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      var $49=$1;
      var $50=(($convbuf)|0);
      var $51=$pconvbuf;
      var $52=(($convbuf)|0);
      var $53=$51;
      var $54=$52;
      var $55=(($53-$54)|0);
      var $56=__Z11core_fwriteP10_core_filePKvj($49, $50, $55);
      var $57=$count;
      var $58=(($57+$56)|0);
      $count=$58;
      var $59=(($convbuf)|0);
      $pconvbuf=$59;
      __label__ = 10; break;
    case 10: // $60
      __label__ = 4; break;
    case 11: // $61
      var $62=$pconvbuf;
      var $63=(($convbuf)|0);
      var $64=(($62)|0)!=(($63)|0);
      if ($64) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $65
      var $66=$1;
      var $67=(($convbuf)|0);
      var $68=$pconvbuf;
      var $69=(($convbuf)|0);
      var $70=$68;
      var $71=$69;
      var $72=(($70-$71)|0);
      var $73=__Z11core_fwriteP10_core_filePKvj($66, $67, $72);
      var $74=$count;
      var $75=(($74+$73)|0);
      $count=$75;
      __label__ = 13; break;
    case 13: // $76
      var $77=$count;
      STACKTOP = __stackBase__;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10core_fputsP10_core_filePKc["X"]=1;

function __Z13core_vfprintfP10_core_filePKcPc($f, $fmt, $va) {
  var __stackBase__  = STACKTOP; STACKTOP += 1024; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $buf=__stackBase__;
  $1=$f;
  $2=$fmt;
  $3=$va;
  var $4=(($buf)|0);
  var $5=$2;
  var $6=$3;
  var $7=_vsnprintf($4, 1024, $5, $6);
  var $8=$1;
  var $9=(($buf)|0);
  var $10=__Z10core_fputsP10_core_filePKc($8, $9);
  STACKTOP = __stackBase__;
  return $10;
}


function __Z12core_fprintfP10_core_filePKcz($f, $fmt) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $rc;
  var $va=__stackBase__;
  $1=$f;
  $2=$fmt;
  var $3=$va;
  HEAP32[(($3)>>2)]=arguments[__Z12core_fprintfP10_core_filePKcz.length];
  var $4=$1;
  var $5=$2;
  var $6=HEAP32[(($va)>>2)];
  var $7=__Z13core_vfprintfP10_core_filePKcPc($4, $5, $6);
  $rc=$7;
  var $8=$va;
  ;
  var $9=$rc;
  STACKTOP = __stackBase__;
  return $9;
}


function __Z26core_filename_extract_baseP7astringPKci($result, $name, $strip_extension) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $start;
      $1=$result;
      $2=$name;
      $3=$strip_extension;
      var $4=$2;
      var $5=$2;
      var $6=_strlen($5);
      var $7=(($4+$6)|0);
      $start=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$start;
      var $10=$2;
      var $11=(($9)>>>0) > (($10)>>>0);
      if ($11) { __label__ = 2; break; } else { var $20 = 0;__label__ = 3; break; }
    case 2: // $12
      var $13=$start;
      var $14=(($13-1)|0);
      var $15=HEAP8[($14)];
      var $16=__ZL22is_directory_separatorc($15);
      var $17=(($16)|0)!=0;
      var $18=$17 ^ 1;
      var $20 = $18;__label__ = 3; break;
    case 3: // $19
      var $20;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      var $22=$start;
      var $23=(($22-1)|0);
      $start=$23;
      __label__ = 1; break;
    case 5: // $24
      var $25=$1;
      var $26=$start;
      var $27=__Z12astring_cpycP7astringPKc($25, $26);
      var $28=$3;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=$1;
      var $32=$1;
      var $33=__Z12astring_rchrPK7astringii($32, 0, 46);
      var $34=__Z14astring_substrP7astringii($31, 0, $33);
      __label__ = 7; break;
    case 7: // $35
      var $36=$1;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z23core_filename_ends_withPKcS0_($filename, $extension) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $namelen;
      var $extlen;
      var $matches;
      $1=$filename;
      $2=$extension;
      var $3=$1;
      var $4=_strlen($3);
      $namelen=$4;
      var $5=$2;
      var $6=_strlen($5);
      $extlen=$6;
      $matches=1;
      __label__ = 1; break;
    case 1: // $7
      var $8=$extlen;
      var $9=(($8)|0) > 0;
      if ($9) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $10
      var $11=$namelen;
      var $12=(($11-1)|0);
      $namelen=$12;
      var $13=$1;
      var $14=(($13+$12)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=_tolower($16);
      var $18=$extlen;
      var $19=(($18-1)|0);
      $extlen=$19;
      var $20=$2;
      var $21=(($20+$19)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=_tolower($23);
      var $25=(($17)|0)!=(($24)|0);
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      $matches=0;
      __label__ = 5; break;
    case 4: // $27
      __label__ = 1; break;
    case 5: // $28
      var $29=$matches;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13zip_file_openPKcPP9_zip_file($filename, $zip) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $ziperr;
      var $filerr;
      var $read_length=__stackBase__;
      var $newzip;
      var $string;
      var $cachenum;
      var $cached;
      $2=$filename;
      $3=$zip;
      $ziperr=0;
      var $4=$3;
      HEAP32[(($4)>>2)]=0;
      $cachenum=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$cachenum;
      var $7=(($6)>>>0) < 8;
      if ($7) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $8
      var $9=$cachenum;
      var $10=((__ZL9zip_cache+($9<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $cached=$11;
      var $12=$cached;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $14
      var $15=$cached;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $19
      var $20=$2;
      var $21=$cached;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=_strcmp($20, $23);
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $27=$cached;
      var $28=$3;
      HEAP32[(($28)>>2)]=$27;
      var $29=$cachenum;
      var $30=((__ZL9zip_cache+($29<<2))|0);
      HEAP32[(($30)>>2)]=0;
      $1=0;
      __label__ = 26; break;
    case 6: // $31
      __label__ = 7; break;
    case 7: // $32
      var $33=$cachenum;
      var $34=(($33+1)|0);
      $cachenum=$34;
      __label__ = 1; break;
    case 8: // $35
      var $36=_malloc(16508);
      var $37=$36;
      $newzip=$37;
      var $38=$newzip;
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $40
      $1=1;
      __label__ = 26; break;
    case 10: // $41
      var $42=$newzip;
      var $43=$42;
      _memset($43, 0, 16508, 1);
      var $44=$2;
      var $45=$newzip;
      var $46=(($45+4)|0);
      var $47=$newzip;
      var $48=(($47+8)|0);
      var $49=_osd_open($44, 1, $46, $48);
      $filerr=$49;
      var $50=$filerr;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $52
      $ziperr=2;
      __label__ = 25; break;
    case 12: // $53
      var $54=$newzip;
      var $55=__ZL8read_ecdP9_zip_file($54);
      $ziperr=$55;
      var $56=$ziperr;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $58
      __label__ = 25; break;
    case 14: // $59
      var $60=$newzip;
      var $61=(($60+16)|0);
      var $62=(($61+4)|0);
      var $63=HEAPU16[(($62)>>1)];
      var $64=(($63)&65535);
      var $65=$newzip;
      var $66=(($65+16)|0);
      var $67=(($66+6)|0);
      var $68=HEAPU16[(($67)>>1)];
      var $69=(($68)&65535);
      var $70=(($64)|0)!=(($69)|0);
      if ($70) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $71
      var $72=$newzip;
      var $73=(($72+16)|0);
      var $74=(($73+8)|0);
      var $75=HEAPU16[(($74)>>1)];
      var $76=(($75)&65535);
      var $77=$newzip;
      var $78=(($77+16)|0);
      var $79=(($78+10)|0);
      var $80=HEAPU16[(($79)>>1)];
      var $81=(($80)&65535);
      var $82=(($76)|0)!=(($81)|0);
      if ($82) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $83
      $ziperr=7;
      __label__ = 25; break;
    case 17: // $84
      var $85=$newzip;
      var $86=(($85+16)|0);
      var $87=(($86+12)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+1)|0);
      var $90=_malloc($89);
      var $91=$newzip;
      var $92=(($91+52)|0);
      HEAP32[(($92)>>2)]=$90;
      var $93=$newzip;
      var $94=(($93+52)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $97
      $ziperr=1;
      __label__ = 25; break;
    case 19: // $98
      var $99=$newzip;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$newzip;
      var $103=(($102+52)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$newzip;
      var $106=(($105+16)|0);
      var $107=(($106+16)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109$0=$108;
      var $109$1=0;
      var $110=$newzip;
      var $111=(($110+16)|0);
      var $112=(($111+12)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=_osd_read($101, $104, $109$0, $109$1, $113, $read_length);
      var $114$0=$114[0];
      $filerr=$114;
      var $115=$filerr;
      var $116=(($115)|0)!=0;
      if ($116) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $117
      var $118=HEAP32[(($read_length)>>2)];
      var $119=$newzip;
      var $120=(($119+16)|0);
      var $121=(($120+12)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($118)|0)!=(($122)|0);
      if ($123) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $124
      var $125=$filerr;
      var $126=(($125)|0)==0;
      var $127=$126 ? 5 : 2;
      $ziperr=$127;
      __label__ = 25; break;
    case 22: // $128
      var $129=$2;
      var $130=_strlen($129);
      var $131=(($130+1)|0);
      var $132=_malloc($131);
      $string=$132;
      var $133=$string;
      var $134=(($133)|0)==0;
      if ($134) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $135
      $ziperr=1;
      __label__ = 25; break;
    case 24: // $136
      var $137=$string;
      var $138=$2;
      var $139=_strcpy($137, $138);
      var $140=$string;
      var $141=$newzip;
      var $142=(($141)|0);
      HEAP32[(($142)>>2)]=$140;
      var $143=$newzip;
      var $144=$3;
      HEAP32[(($144)>>2)]=$143;
      $1=0;
      __label__ = 26; break;
    case 25: // $145
      var $146=$newzip;
      __ZL13free_zip_fileP9_zip_file($146);
      var $147=$ziperr;
      $1=$147;
      __label__ = 26; break;
    case 26: // $148
      var $149=$1;
      STACKTOP = __stackBase__;
      return $149;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13zip_file_openPKcPP9_zip_file["X"]=1;

function __ZL8read_ecdP9_zip_file($zip) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $buflen;
      var $buffer;
      var $error;
      var $read_length=__stackBase__;
      var $offset;
      $2=$zip;
      $buflen=1024;
      __label__ = 1; break;
    case 1: // $3
      var $4=$buflen;
      var $5=(($4)>>>0) < 65536;
      if ($5) { __label__ = 2; break; } else { __label__ = 24; break; }
    case 2: // $6
      var $7=$buflen;
      var $8$0=$7;
      var $8$1=0;
      var $9=$2;
      var $10=(($9+8)|0);
      var $st$5$0=(($10)|0);
      var $11$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($10+4)|0);
      var $11$1=HEAP32[(($st$5$1)>>2)];
      var $12=$8$1 > $11$1 || ($8$1 == $11$1 && $8$0 > $11$0);
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$2;
      var $15=(($14+8)|0);
      var $st$2$0=(($15)|0);
      var $16$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($15+4)|0);
      var $16$1=HEAP32[(($st$2$1)>>2)];
      var $17$0=$16$0;
      var $17=$17$0;
      $buflen=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$buflen;
      var $20=(($19+1)|0);
      var $21=_malloc($20);
      $buffer=$21;
      var $22=$buffer;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      $1=1;
      __label__ = 25; break;
    case 6: // $25
      var $26=$2;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$buffer;
      var $30=$2;
      var $31=(($30+8)|0);
      var $st$6$0=(($31)|0);
      var $32$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($31+4)|0);
      var $32$1=HEAP32[(($st$6$1)>>2)];
      var $33=$buflen;
      var $34$0=$33;
      var $34$1=0;
      var $35$0 = ((($32$0)>>>0)+((($32$1)|0)*4294967296))-((($34$0)>>>0)+((($34$1)|0)*4294967296))>>>0; var $35$1 = Math.min(Math.floor((((($32$0)>>>0)+((($32$1)|0)*4294967296))-((($34$0)>>>0)+((($34$1)|0)*4294967296)))/4294967296), 4294967295);
      var $36=$buflen;
      var $37=_osd_read($28, $29, $35$0, $35$1, $36, $read_length);
      var $37$0=$37[0];
      $error=$37;
      var $38=$error;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $40
      var $41=HEAP32[(($read_length)>>2)];
      var $42=$buflen;
      var $43=(($41)|0)!=(($42)|0);
      if ($43) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $44
      var $45=$buffer;
      _free($45);
      $1=2;
      __label__ = 25; break;
    case 9: // $46
      var $47=$buflen;
      var $48=(($47-22)|0);
      $offset=$48;
      __label__ = 10; break;
    case 10: // $49
      var $50=$offset;
      var $51=(($50)|0) >= 0;
      if ($51) { __label__ = 11; break; } else { __label__ = 18; break; }
    case 11: // $52
      var $53=$offset;
      var $54=(($53)|0);
      var $55=$buffer;
      var $56=(($55+$54)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=(($58)|0)==80;
      if ($59) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $60
      var $61=$offset;
      var $62=(($61+1)|0);
      var $63=$buffer;
      var $64=(($63+$62)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=(($66)|0)==75;
      if ($67) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $68
      var $69=$offset;
      var $70=(($69+2)|0);
      var $71=$buffer;
      var $72=(($71+$70)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=(($74)|0)==5;
      if ($75) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $76
      var $77=$offset;
      var $78=(($77+3)|0);
      var $79=$buffer;
      var $80=(($79+$78)|0);
      var $81=HEAPU8[($80)];
      var $82=(($81)&255);
      var $83=(($82)|0)==6;
      if ($83) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $84
      __label__ = 18; break;
    case 16: // $85
      __label__ = 17; break;
    case 17: // $86
      var $87=$offset;
      var $88=(($87-1)|0);
      $offset=$88;
      __label__ = 10; break;
    case 18: // $89
      var $90=$offset;
      var $91=(($90)|0) >= 0;
      if ($91) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $92
      var $93=$buffer;
      var $94=$2;
      var $95=(($94+16)|0);
      var $96=(($95+28)|0);
      HEAP32[(($96)>>2)]=$93;
      var $97=$buflen;
      var $98=$offset;
      var $99=(($97-$98)|0);
      var $100=$2;
      var $101=(($100+16)|0);
      var $102=(($101+32)|0);
      HEAP32[(($102)>>2)]=$99;
      var $103=$buffer;
      var $104=(($103)|0);
      var $105=$offset;
      var $106=$buffer;
      var $107=(($106+$105)|0);
      var $108=$2;
      var $109=(($108+16)|0);
      var $110=(($109+32)|0);
      var $111=HEAP32[(($110)>>2)];
      _llvm_memmove_p0i8_p0i8_i32($104, $107, $111, 1, 0);
      var $112=$2;
      var $113=(($112+16)|0);
      var $114=(($113+32)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=$2;
      var $117=(($116+16)|0);
      var $118=(($117+28)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+$115)|0);
      HEAP8[($120)]=0;
      var $121=$2;
      var $122=(($121+16)|0);
      var $123=(($122+28)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124)|0);
      var $126=__ZL10read_dwordPh($125);
      var $127=$2;
      var $128=(($127+16)|0);
      var $129=(($128)|0);
      HEAP32[(($129)>>2)]=$126;
      var $130=$2;
      var $131=(($130+16)|0);
      var $132=(($131+28)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+4)|0);
      var $135=__ZL9read_wordPh($134);
      var $136=$2;
      var $137=(($136+16)|0);
      var $138=(($137+4)|0);
      HEAP16[(($138)>>1)]=$135;
      var $139=$2;
      var $140=(($139+16)|0);
      var $141=(($140+28)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+6)|0);
      var $144=__ZL9read_wordPh($143);
      var $145=$2;
      var $146=(($145+16)|0);
      var $147=(($146+6)|0);
      HEAP16[(($147)>>1)]=$144;
      var $148=$2;
      var $149=(($148+16)|0);
      var $150=(($149+28)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+8)|0);
      var $153=__ZL9read_wordPh($152);
      var $154=$2;
      var $155=(($154+16)|0);
      var $156=(($155+8)|0);
      HEAP16[(($156)>>1)]=$153;
      var $157=$2;
      var $158=(($157+16)|0);
      var $159=(($158+28)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160+10)|0);
      var $162=__ZL9read_wordPh($161);
      var $163=$2;
      var $164=(($163+16)|0);
      var $165=(($164+10)|0);
      HEAP16[(($165)>>1)]=$162;
      var $166=$2;
      var $167=(($166+16)|0);
      var $168=(($167+28)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169+12)|0);
      var $171=__ZL10read_dwordPh($170);
      var $172=$2;
      var $173=(($172+16)|0);
      var $174=(($173+12)|0);
      HEAP32[(($174)>>2)]=$171;
      var $175=$2;
      var $176=(($175+16)|0);
      var $177=(($176+28)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=(($178+16)|0);
      var $180=__ZL10read_dwordPh($179);
      var $181=$2;
      var $182=(($181+16)|0);
      var $183=(($182+16)|0);
      HEAP32[(($183)>>2)]=$180;
      var $184=$2;
      var $185=(($184+16)|0);
      var $186=(($185+28)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187+20)|0);
      var $189=__ZL9read_wordPh($188);
      var $190=$2;
      var $191=(($190+16)|0);
      var $192=(($191+20)|0);
      HEAP16[(($192)>>1)]=$189;
      var $193=$2;
      var $194=(($193+16)|0);
      var $195=(($194+28)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196+22)|0);
      var $198=$2;
      var $199=(($198+16)|0);
      var $200=(($199+24)|0);
      HEAP32[(($200)>>2)]=$197;
      $1=0;
      __label__ = 25; break;
    case 20: // $201
      var $202=$buffer;
      _free($202);
      var $203=$buflen;
      var $204$0=$203;
      var $204$1=0;
      var $205=$2;
      var $206=(($205+8)|0);
      var $st$7$0=(($206)|0);
      var $207$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($206+4)|0);
      var $207$1=HEAP32[(($st$7$1)>>2)];
      var $208=$204$1 < $207$1 || ($204$1 == $207$1 && $204$0 < $207$0);
      if ($208) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $209
      var $210=$buflen;
      var $211=((($210<<1))|0);
      $buflen=$211;
      __label__ = 23; break;
    case 22: // $212
      $1=3;
      __label__ = 25; break;
    case 23: // $213
      __label__ = 1; break;
    case 24: // $214
      $1=1;
      __label__ = 25; break;
    case 25: // $215
      var $216=$1;
      STACKTOP = __stackBase__;
      return $216;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8read_ecdP9_zip_file["X"]=1;

function __ZL13free_zip_fileP9_zip_file($zip) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$zip;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=_osd_close($12);
      __label__ = 3; break;
    case 3: // $14
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$1;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      _free($22);
      __label__ = 5; break;
    case 5: // $23
      var $24=$1;
      var $25=(($24+16)|0);
      var $26=(($25+28)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      var $30=$1;
      var $31=(($30+16)|0);
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      _free($33);
      __label__ = 7; break;
    case 7: // $34
      var $35=$1;
      var $36=(($35+52)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      var $40=$1;
      var $41=(($40+52)|0);
      var $42=HEAP32[(($41)>>2)];
      _free($42);
      __label__ = 9; break;
    case 9: // $43
      var $44=$1;
      var $45=$44;
      _free($45);
      __label__ = 10; break;
    case 10: // $46
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13free_zip_fileP9_zip_file["X"]=1;

function __Z14zip_file_closeP9_zip_file($zip) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cachenum;
      $1=$zip;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=_osd_close($9);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=(($12+4)|0);
      HEAP32[(($13)>>2)]=0;
      $cachenum=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$cachenum;
      var $16=(($15)>>>0) < 8;
      if ($16) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $17
      var $18=$cachenum;
      var $19=((__ZL9zip_cache+($18<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      __label__ = 8; break;
    case 6: // $23
      __label__ = 7; break;
    case 7: // $24
      var $25=$cachenum;
      var $26=(($25+1)|0);
      $cachenum=$26;
      __label__ = 3; break;
    case 8: // $27
      var $28=$cachenum;
      var $29=(($28)|0)==8;
      if ($29) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $30
      var $31=$cachenum;
      var $32=(($31-1)|0);
      $cachenum=$32;
      var $33=((__ZL9zip_cache+($32<<2))|0);
      var $34=HEAP32[(($33)>>2)];
      __ZL13free_zip_fileP9_zip_file($34);
      __label__ = 10; break;
    case 10: // $35
      var $36=$cachenum;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $38
      var $39=$cachenum;
      var $40=((($39<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32((((__ZL9zip_cache+4)|0)), __ZL9zip_cache, $40, 1, 0);
      __label__ = 12; break;
    case 12: // $41
      var $42=$1;
      HEAP32[((((__ZL9zip_cache)|0))>>2)]=$42;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14zip_file_closeP9_zip_file["X"]=1;

function __Z20zip_file_cache_clearv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $cachenum;
      $cachenum=0;
      __label__ = 1; break;
    case 1: // $1
      var $2=$cachenum;
      var $3=(($2)>>>0) < 8;
      if ($3) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $4
      var $5=$cachenum;
      var $6=((__ZL9zip_cache+($5<<2))|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      var $10=$cachenum;
      var $11=((__ZL9zip_cache+($10<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      __ZL13free_zip_fileP9_zip_file($12);
      var $13=$cachenum;
      var $14=((__ZL9zip_cache+($13<<2))|0);
      HEAP32[(($14)>>2)]=0;
      __label__ = 4; break;
    case 4: // $15
      __label__ = 5; break;
    case 5: // $16
      var $17=$cachenum;
      var $18=(($17+1)|0);
      $cachenum=$18;
      __label__ = 1; break;
    case 6: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19zip_file_first_fileP9_zip_file($zip) {
  ;
  var __label__;

  var $1;
  $1=$zip;
  var $2=$1;
  var $3=(($2+56)|0);
  HEAP32[(($3)>>2)]=0;
  var $4=$1;
  var $5=__Z18zip_file_next_fileP9_zip_file($4);
  ;
  return $5;
}


function __ZL10read_dwordPh($buf) {
  ;
  var __label__;

  var $1;
  $1=$buf;
  var $2=$1;
  var $3=(($2+3)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 24;
  var $7=$1;
  var $8=(($7+2)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 << 16;
  var $12=$6 | $11;
  var $13=$1;
  var $14=(($13+1)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 << 8;
  var $18=$12 | $17;
  var $19=$1;
  var $20=(($19)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=$18 | $22;
  ;
  return $23;
}


function __ZL9read_wordPh($buf) {
  ;
  var __label__;

  var $1;
  $1=$buf;
  var $2=$1;
  var $3=(($2+1)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 8;
  var $7=$1;
  var $8=(($7)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$6 | $10;
  var $12=(($11) & 65535);
  ;
  return $12;
}


function __ZN7astring4initEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=(($3+8)|0);
  var $5=(($4)|0);
  var $6=$2;
  var $7=(($6)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=$2;
  var $9=(($8+4)|0);
  HEAP32[(($9)>>2)]=56;
  var $10=$2;
  var $11=(($10+8)|0);
  var $12=(($11)|0);
  HEAP8[($12)]=0;
  ;
  return $2;
}


function __Z18zip_file_next_fileP9_zip_file($zip) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$zip;
      var $3=$2;
      var $4=(($3+60)|0);
      var $5=(($4+52)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9+60)|0);
      var $11=(($10+60)|0);
      var $12=HEAP8[($11)];
      var $13=$2;
      var $14=(($13+60)|0);
      var $15=(($14+28)|0);
      var $16=HEAPU16[(($15)>>1)];
      var $17=(($16)&65535);
      var $18=(($17+46)|0);
      var $19=$2;
      var $20=(($19+60)|0);
      var $21=(($20+52)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+$18)|0);
      HEAP8[($23)]=$12;
      var $24=$2;
      var $25=(($24+60)|0);
      var $26=(($25+52)|0);
      HEAP32[(($26)>>2)]=0;
      __label__ = 2; break;
    case 2: // $27
      var $28=$2;
      var $29=(($28+56)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=$2;
      var $32=(($31+16)|0);
      var $33=(($32+12)|0);
      var $34=HEAPU32[(($33)>>2)];
      var $35=(($30)>>>0) >= (($34)>>>0);
      if ($35) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $36
      $1=0;
      __label__ = 7; break;
    case 4: // $37
      var $38=$2;
      var $39=(($38+52)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$2;
      var $42=(($41+56)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($40+$43)|0);
      var $45=$2;
      var $46=(($45+60)|0);
      var $47=(($46+52)|0);
      HEAP32[(($47)>>2)]=$44;
      var $48=$2;
      var $49=(($48+60)|0);
      var $50=(($49+56)|0);
      HEAP32[(($50)>>2)]=46;
      var $51=$2;
      var $52=(($51+60)|0);
      var $53=(($52+52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0);
      var $56=__ZL10read_dwordPh($55);
      var $57=$2;
      var $58=(($57+60)|0);
      var $59=(($58)|0);
      HEAP32[(($59)>>2)]=$56;
      var $60=$2;
      var $61=(($60+60)|0);
      var $62=(($61+52)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+4)|0);
      var $65=__ZL9read_wordPh($64);
      var $66=$2;
      var $67=(($66+60)|0);
      var $68=(($67+4)|0);
      HEAP16[(($68)>>1)]=$65;
      var $69=$2;
      var $70=(($69+60)|0);
      var $71=(($70+52)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+6)|0);
      var $74=__ZL9read_wordPh($73);
      var $75=$2;
      var $76=(($75+60)|0);
      var $77=(($76+6)|0);
      HEAP16[(($77)>>1)]=$74;
      var $78=$2;
      var $79=(($78+60)|0);
      var $80=(($79+52)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+8)|0);
      var $83=__ZL9read_wordPh($82);
      var $84=$2;
      var $85=(($84+60)|0);
      var $86=(($85+8)|0);
      HEAP16[(($86)>>1)]=$83;
      var $87=$2;
      var $88=(($87+60)|0);
      var $89=(($88+52)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+10)|0);
      var $92=__ZL9read_wordPh($91);
      var $93=$2;
      var $94=(($93+60)|0);
      var $95=(($94+10)|0);
      HEAP16[(($95)>>1)]=$92;
      var $96=$2;
      var $97=(($96+60)|0);
      var $98=(($97+52)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99+12)|0);
      var $101=__ZL9read_wordPh($100);
      var $102=$2;
      var $103=(($102+60)|0);
      var $104=(($103+12)|0);
      HEAP16[(($104)>>1)]=$101;
      var $105=$2;
      var $106=(($105+60)|0);
      var $107=(($106+52)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+14)|0);
      var $110=__ZL9read_wordPh($109);
      var $111=$2;
      var $112=(($111+60)|0);
      var $113=(($112+14)|0);
      HEAP16[(($113)>>1)]=$110;
      var $114=$2;
      var $115=(($114+60)|0);
      var $116=(($115+52)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117+16)|0);
      var $119=__ZL10read_dwordPh($118);
      var $120=$2;
      var $121=(($120+60)|0);
      var $122=(($121+16)|0);
      HEAP32[(($122)>>2)]=$119;
      var $123=$2;
      var $124=(($123+60)|0);
      var $125=(($124+52)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+20)|0);
      var $128=__ZL10read_dwordPh($127);
      var $129=$2;
      var $130=(($129+60)|0);
      var $131=(($130+20)|0);
      HEAP32[(($131)>>2)]=$128;
      var $132=$2;
      var $133=(($132+60)|0);
      var $134=(($133+52)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+24)|0);
      var $137=__ZL10read_dwordPh($136);
      var $138=$2;
      var $139=(($138+60)|0);
      var $140=(($139+24)|0);
      HEAP32[(($140)>>2)]=$137;
      var $141=$2;
      var $142=(($141+60)|0);
      var $143=(($142+52)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+28)|0);
      var $146=__ZL9read_wordPh($145);
      var $147=$2;
      var $148=(($147+60)|0);
      var $149=(($148+28)|0);
      HEAP16[(($149)>>1)]=$146;
      var $150=$2;
      var $151=(($150+60)|0);
      var $152=(($151+52)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153+30)|0);
      var $155=__ZL9read_wordPh($154);
      var $156=$2;
      var $157=(($156+60)|0);
      var $158=(($157+30)|0);
      HEAP16[(($158)>>1)]=$155;
      var $159=$2;
      var $160=(($159+60)|0);
      var $161=(($160+52)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+32)|0);
      var $164=__ZL9read_wordPh($163);
      var $165=$2;
      var $166=(($165+60)|0);
      var $167=(($166+32)|0);
      HEAP16[(($167)>>1)]=$164;
      var $168=$2;
      var $169=(($168+60)|0);
      var $170=(($169+52)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171+34)|0);
      var $173=__ZL9read_wordPh($172);
      var $174=$2;
      var $175=(($174+60)|0);
      var $176=(($175+34)|0);
      HEAP16[(($176)>>1)]=$173;
      var $177=$2;
      var $178=(($177+60)|0);
      var $179=(($178+52)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180+36)|0);
      var $182=__ZL9read_wordPh($181);
      var $183=$2;
      var $184=(($183+60)|0);
      var $185=(($184+36)|0);
      HEAP16[(($185)>>1)]=$182;
      var $186=$2;
      var $187=(($186+60)|0);
      var $188=(($187+52)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189+38)|0);
      var $191=__ZL10read_dwordPh($190);
      var $192=$2;
      var $193=(($192+60)|0);
      var $194=(($193+40)|0);
      HEAP32[(($194)>>2)]=$191;
      var $195=$2;
      var $196=(($195+60)|0);
      var $197=(($196+52)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198+42)|0);
      var $200=__ZL10read_dwordPh($199);
      var $201=$2;
      var $202=(($201+60)|0);
      var $203=(($202+44)|0);
      HEAP32[(($203)>>2)]=$200;
      var $204=$2;
      var $205=(($204+60)|0);
      var $206=(($205+52)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207+46)|0);
      var $209=$2;
      var $210=(($209+60)|0);
      var $211=(($210+48)|0);
      HEAP32[(($211)>>2)]=$208;
      var $212=$2;
      var $213=(($212+60)|0);
      var $214=(($213+28)|0);
      var $215=HEAPU16[(($214)>>1)];
      var $216=(($215)&65535);
      var $217=$2;
      var $218=(($217+60)|0);
      var $219=(($218+56)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220+$216)|0);
      HEAP32[(($219)>>2)]=$221;
      var $222=$2;
      var $223=(($222+60)|0);
      var $224=(($223+30)|0);
      var $225=HEAPU16[(($224)>>1)];
      var $226=(($225)&65535);
      var $227=$2;
      var $228=(($227+60)|0);
      var $229=(($228+56)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=(($230+$226)|0);
      HEAP32[(($229)>>2)]=$231;
      var $232=$2;
      var $233=(($232+60)|0);
      var $234=(($233+32)|0);
      var $235=HEAPU16[(($234)>>1)];
      var $236=(($235)&65535);
      var $237=$2;
      var $238=(($237+60)|0);
      var $239=(($238+56)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=(($240+$236)|0);
      HEAP32[(($239)>>2)]=$241;
      var $242=$2;
      var $243=(($242+56)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$2;
      var $246=(($245+60)|0);
      var $247=(($246+56)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=(($244+$248)|0);
      var $250=$2;
      var $251=(($250+16)|0);
      var $252=(($251+12)|0);
      var $253=HEAPU32[(($252)>>2)];
      var $254=(($249)>>>0) > (($253)>>>0);
      if ($254) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $255
      $1=0;
      __label__ = 7; break;
    case 6: // $256
      var $257=$2;
      var $258=(($257+60)|0);
      var $259=(($258+28)|0);
      var $260=HEAPU16[(($259)>>1)];
      var $261=(($260)&65535);
      var $262=(($261+46)|0);
      var $263=$2;
      var $264=(($263+60)|0);
      var $265=(($264+52)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266+$262)|0);
      var $268=HEAP8[($267)];
      var $269=$2;
      var $270=(($269+60)|0);
      var $271=(($270+60)|0);
      HEAP8[($271)]=$268;
      var $272=$2;
      var $273=(($272+60)|0);
      var $274=(($273+28)|0);
      var $275=HEAPU16[(($274)>>1)];
      var $276=(($275)&65535);
      var $277=(($276+46)|0);
      var $278=$2;
      var $279=(($278+60)|0);
      var $280=(($279+52)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($281+$277)|0);
      HEAP8[($282)]=0;
      var $283=$2;
      var $284=(($283+60)|0);
      var $285=(($284+56)|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=$2;
      var $288=(($287+56)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=(($289+$286)|0);
      HEAP32[(($288)>>2)]=$290;
      var $291=$2;
      var $292=(($291+60)|0);
      $1=$292;
      __label__ = 7; break;
    case 7: // $293
      var $294=$1;
      ;
      return $294;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18zip_file_next_fileP9_zip_file["X"]=1;

function __Z19zip_file_decompressP9_zip_filePvj($zip, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $ziperr;
      var $offset=__stackBase__;
      $2=$zip;
      $3=$buffer;
      $4=$length;
      var $5=$4;
      var $6=$2;
      var $7=(($6+60)|0);
      var $8=(($7+24)|0);
      var $9=HEAPU32[(($8)>>2)];
      var $10=(($5)>>>0) < (($9)>>>0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=8;
      __label__ = 11; break;
    case 2: // $12
      var $13=$2;
      var $14=(($13+60)|0);
      var $15=(($14+34)|0);
      var $16=HEAPU16[(($15)>>1)];
      var $17=(($16)&65535);
      var $18=$2;
      var $19=(($18+16)|0);
      var $20=(($19+4)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=(($17)|0)!=(($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      $1=7;
      __label__ = 11; break;
    case 4: // $25
      var $26=$2;
      var $27=__ZL26get_compressed_data_offsetP9_zip_filePy($26, $offset);
      $ziperr=$27;
      var $28=$ziperr;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$ziperr;
      $1=$31;
      __label__ = 11; break;
    case 6: // $32
      var $33=$2;
      var $34=(($33+60)|0);
      var $35=(($34+10)|0);
      var $36=HEAPU16[(($35)>>1)];
      var $37=(($36)&65535);
      if ($37 == 0) {
        __label__ = 7; break;
      }
      else if ($37 == 8) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 7: // $38
      var $39=$2;
      var $st$1$0=(($offset)|0);
      var $40$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $40$1=HEAP32[(($st$1$1)>>2)];
      var $41=$3;
      var $42=$4;
      var $43=__ZL22decompress_data_type_0P9_zip_fileyPvj($39, $40$0, $40$1, $41, $42);
      var $43$0=$43[0];
      $ziperr=$43;
      __label__ = 10; break;
    case 8: // $44
      var $45=$2;
      var $st$1$0=(($offset)|0);
      var $46$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($offset+4)|0);
      var $46$1=HEAP32[(($st$1$1)>>2)];
      var $47=$3;
      var $48=$4;
      var $49=__ZL22decompress_data_type_8P9_zip_fileyPvj($45, $46$0, $46$1, $47, $48);
      var $49$0=$49[0];
      $ziperr=$49;
      __label__ = 10; break;
    case 9: // $50
      $ziperr=7;
      __label__ = 10; break;
    case 10: // $51
      var $52=$ziperr;
      $1=$52;
      __label__ = 11; break;
    case 11: // $53
      var $54=$1;
      STACKTOP = __stackBase__;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19zip_file_decompressP9_zip_filePvj["X"]=1;

function __ZL26get_compressed_data_offsetP9_zip_filePy($zip, $offset) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $error;
      var $read_length=__stackBase__;
      var $filerr;
      $2=$zip;
      $3=$offset;
      var $4=$2;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=(($12+4)|0);
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=_osd_open($11, 1, $13, $15);
      $filerr=$16;
      var $17=$filerr;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $19
      $1=2;
      __label__ = 8; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      var $26=(($25+124)|0);
      var $27=(($26)|0);
      var $28=$2;
      var $29=(($28+60)|0);
      var $30=(($29+44)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32$0=$31;
      var $32$1=0;
      var $33=_osd_read($24, $27, $32$0, $32$1, 30, $read_length);
      var $33$0=$33[0];
      $error=$33;
      var $34=$error;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $36
      var $37=HEAP32[(($read_length)>>2)];
      var $38=(($37)|0)!=30;
      if ($38) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $39
      var $40=$error;
      var $41=(($40)|0)==0;
      var $42=$41 ? 5 : 2;
      $1=$42;
      __label__ = 8; break;
    case 7: // $43
      var $44=$2;
      var $45=(($44+60)|0);
      var $46=(($45+44)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+30)|0);
      var $49$0=$48;
      var $49$1=0;
      var $50=$3;
      var $st$8$0=(($50)|0);
      HEAP32[(($st$8$0)>>2)]=$49$0;
      var $st$8$1=(($50+4)|0);
      HEAP32[(($st$8$1)>>2)]=$49$1;
      var $51=$2;
      var $52=(($51+124)|0);
      var $53=(($52)|0);
      var $54=(($53+26)|0);
      var $55=__ZL9read_wordPh($54);
      var $56$0=$55;
      var $56$1=0;
      var $57=$3;
      var $st$20$0=(($57)|0);
      var $58$0=HEAP32[(($st$20$0)>>2)];
      var $st$20$1=(($57+4)|0);
      var $58$1=HEAP32[(($st$20$1)>>2)];
      var $59$0 = ((($58$0)>>>0)+((($58$1)|0)*4294967296))+((($56$0)>>>0)+((($56$1)|0)*4294967296))>>>0; var $59$1 = Math.min(Math.floor((((($58$0)>>>0)+((($58$1)|0)*4294967296))+((($56$0)>>>0)+((($56$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$25$0=(($57)|0);
      HEAP32[(($st$25$0)>>2)]=$59$0;
      var $st$25$1=(($57+4)|0);
      HEAP32[(($st$25$1)>>2)]=$59$1;
      var $60=$2;
      var $61=(($60+124)|0);
      var $62=(($61)|0);
      var $63=(($62+28)|0);
      var $64=__ZL9read_wordPh($63);
      var $65$0=$64;
      var $65$1=0;
      var $66=$3;
      var $st$37$0=(($66)|0);
      var $67$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($66+4)|0);
      var $67$1=HEAP32[(($st$37$1)>>2)];
      var $68$0 = ((($67$0)>>>0)+((($67$1)|0)*4294967296))+((($65$0)>>>0)+((($65$1)|0)*4294967296))>>>0; var $68$1 = Math.min(Math.floor((((($67$0)>>>0)+((($67$1)|0)*4294967296))+((($65$0)>>>0)+((($65$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$42$0=(($66)|0);
      HEAP32[(($st$42$0)>>2)]=$68$0;
      var $st$42$1=(($66+4)|0);
      HEAP32[(($st$42$1)>>2)]=$68$1;
      $1=0;
      __label__ = 8; break;
    case 8: // $69
      var $70=$1;
      STACKTOP = __stackBase__;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26get_compressed_data_offsetP9_zip_filePy["X"]=1;

function __ZL22decompress_data_type_0P9_zip_fileyPvj($zip, $offset$0, $offset$1, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $filerr;
      var $read_length=__stackBase__+8;
      $2=$zip;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$offset$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$offset$1;
      $4=$buffer;
      $5=$length;
      var $6=$2;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$4;
      var $st$18$0=(($3)|0);
      var $10$0=HEAP32[(($st$18$0)>>2)];
      var $st$18$1=(($3+4)|0);
      var $10$1=HEAP32[(($st$18$1)>>2)];
      var $11=$2;
      var $12=(($11+60)|0);
      var $13=(($12+20)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=_osd_read($8, $9, $10$0, $10$1, $14, $read_length);
      var $15$0=$15[0];
      $filerr=$15;
      var $16=$filerr;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      $1=2;
      __label__ = 5; break;
    case 2: // $19
      var $20=HEAP32[(($read_length)>>2)];
      var $21=$2;
      var $22=(($21+60)|0);
      var $23=(($22+20)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($20)|0)!=(($24)|0);
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      $1=5;
      __label__ = 5; break;
    case 4: // $27
      $1=0;
      __label__ = 5; break;
    case 5: // $28
      var $29=$1;
      STACKTOP = __stackBase__;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL22decompress_data_type_8P9_zip_fileyPvj($zip, $offset$0, $offset$1, $buffer, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $input_remaining;
      var $read_length=__stackBase__+8;
      var $stream=__stackBase__+12;
      var $filerr;
      var $zerr;
      $2=$zip;
      var $st$11$0=(($3)|0);
      HEAP32[(($st$11$0)>>2)]=$offset$0;
      var $st$11$1=(($3+4)|0);
      HEAP32[(($st$11$1)>>2)]=$offset$1;
      $4=$buffer;
      $5=$length;
      var $6=$2;
      var $7=(($6+60)|0);
      var $8=(($7+20)|0);
      var $9=HEAP32[(($8)>>2)];
      $input_remaining=$9;
      var $10=$2;
      var $11=(($10+60)|0);
      var $12=(($11+6)|0);
      var $13=HEAPU16[(($12)>>1)];
      var $14=(($13)&65535);
      var $15=(($14)|0) > 20;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=7;
      __label__ = 26; break;
    case 2: // $17
      var $18=$stream;
      _memset($18, 0, 56, 1);
      var $19=$4;
      var $20=(($stream+12)|0);
      HEAP32[(($20)>>2)]=$19;
      var $21=$5;
      var $22=(($stream+16)|0);
      HEAP32[(($22)>>2)]=$21;
      var $23=_inflateInit2_($stream, -15, ((STRING_TABLE.__str7095)|0), 56);
      $zerr=$23;
      var $24=$zerr;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      $1=4;
      __label__ = 26; break;
    case 4: // $27
      __label__ = 5; break;
    case 5: // $28
      var $29=$2;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$2;
      var $33=(($32+124)|0);
      var $34=(($33)|0);
      var $st$6$0=(($3)|0);
      var $35$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($3+4)|0);
      var $35$1=HEAP32[(($st$6$1)>>2)];
      var $36=$input_remaining;
      var $37=(($36)>>>0) < 16384;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      var $39=$input_remaining;
      var $42 = $39;__label__ = 8; break;
    case 7: // $40
      var $42 = 16384;__label__ = 8; break;
    case 8: // $41
      var $42;
      var $43=_osd_read($31, $34, $35$0, $35$1, $42, $read_length);
      var $43$0=$43[0];
      $filerr=$43;
      var $44=$filerr;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $46
      var $47=_inflateEnd($stream);
      $1=2;
      __label__ = 26; break;
    case 10: // $48
      var $49=HEAP32[(($read_length)>>2)];
      var $50$0=$49;
      var $50$1=0;
      var $st$3$0=(($3)|0);
      var $51$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $51$1=HEAP32[(($st$3$1)>>2)];
      var $52$0 = ((($51$0)>>>0)+((($51$1)|0)*4294967296))+((($50$0)>>>0)+((($50$1)|0)*4294967296))>>>0; var $52$1 = Math.min(Math.floor((((($51$0)>>>0)+((($51$1)|0)*4294967296))+((($50$0)>>>0)+((($50$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$52$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$52$1;
      var $53=HEAP32[(($read_length)>>2)];
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $55
      var $56=$input_remaining;
      var $57=(($56)>>>0) > 0;
      if ($57) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $58
      var $59=_inflateEnd($stream);
      $1=5;
      __label__ = 26; break;
    case 13: // $60
      var $61=$2;
      var $62=(($61+124)|0);
      var $63=(($62)|0);
      var $64=(($stream)|0);
      HEAP32[(($64)>>2)]=$63;
      var $65=HEAP32[(($read_length)>>2)];
      var $66=(($stream+4)|0);
      HEAP32[(($66)>>2)]=$65;
      var $67=HEAP32[(($read_length)>>2)];
      var $68=$input_remaining;
      var $69=(($68-$67)|0);
      $input_remaining=$69;
      var $70=$input_remaining;
      var $71=(($70)|0)==0;
      if ($71) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $72
      var $73=(($stream+4)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+1)|0);
      HEAP32[(($73)>>2)]=$75;
      __label__ = 15; break;
    case 15: // $76
      var $77=_inflate($stream, 0);
      $zerr=$77;
      var $78=$zerr;
      var $79=(($78)|0)==1;
      if ($79) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $80
      __label__ = 20; break;
    case 17: // $81
      var $82=$zerr;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $84
      var $85=_inflateEnd($stream);
      $1=4;
      __label__ = 26; break;
    case 19: // $86
      __label__ = 5; break;
    case 20: // $87
      var $88=_inflateEnd($stream);
      $zerr=$88;
      var $89=$zerr;
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $91
      $1=4;
      __label__ = 26; break;
    case 22: // $92
      var $93=(($stream+16)|0);
      var $94=HEAPU32[(($93)>>2)];
      var $95=(($94)>>>0) > 0;
      if ($95) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $96
      var $97=$input_remaining;
      var $98=(($97)>>>0) > 0;
      if ($98) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $99
      $1=4;
      __label__ = 26; break;
    case 25: // $100
      $1=0;
      __label__ = 26; break;
    case 26: // $101
      var $102=$1;
      STACKTOP = __stackBase__;
      return $102;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22decompress_data_type_8P9_zip_fileyPvj["X"]=1;

function ___cxx_global_var_init7109() {
  ;
  var __label__;

  __ZN7astringC1Ev(__ZL13dummy_astring);
  var $1=___cxa_atexit(938, __ZL13dummy_astring, ___dso_handle);
  ;
  return;
}


function __ZN7astringD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($6+8)|0);
      var $8=(($7)|0);
      var $9=(($5)|0)!=(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      _free($13);
      __label__ = 2; break;
    case 2: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13astring_allocv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ptr;
      var $2=_malloc(64);
      $ptr=$2;
      var $3=$ptr;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 5; break;
    case 2: // $6
      var $7=$ptr;
      var $8=(($7)|0)==0;
      if ($8) { var $12 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $9
      var $10=$7;
      __ZN7astringC1Ev($10);
      var $12 = $10;__label__ = 4; break;
    case 4: // $11
      var $12;
      $1=$12;
      __label__ = 5; break;
    case 5: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z12astring_freeP7astring($str) {
  ;
  var __label__;

  var $1;
  $1=$str;
  var $2=$1;
  FUNCTION_TABLE[__ZN7astringD1Ev]($2);
  var $3=$1;
  var $4=$3;
  _free($4);
  ;
  return;
}


function __Z14astring_expandP7astringi($str, $length) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$str;
  $2=$length;
  var $3=$1;
  var $4=$2;
  var $5=__ZL11ensure_roomP7astringi($3, $4);
  ;
  return;
}


function __ZL16normalize_substrPiS_i($start, $count, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$start;
      $2=$count;
      $3=$length;
      var $4=$1;
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0) < 0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      HEAP32[(($8)>>2)]=0;
      __label__ = 5; break;
    case 2: // $9
      var $10=$1;
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=(($11)|0) > (($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$3;
      var $16=$1;
      HEAP32[(($16)>>2)]=$15;
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$2;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)==-1;
      if ($21) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $22
      var $23=$1;
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($24+$26)|0);
      var $28=$3;
      var $29=(($27)|0) > (($28)|0);
      if ($29) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $30
      var $31=$3;
      var $32=$1;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($31-$33)|0);
      var $35=$2;
      HEAP32[(($35)>>2)]=$34;
      __label__ = 8; break;
    case 8: // $36
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z9astring_cPK7astring($str) {
  ;
  var __label__;

  var $1;
  $1=$str;
  var $2=$1;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  ;
  return $5;
}


function __Z12astring_cmpcPK7astringPKc($str1, $str2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $s1;
      $1=$str1;
      $2=$str2;
      var $3=$1;
      var $4=$3;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      $s1=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$s1;
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { var $26 = 0;__label__ = 4; break; }
    case 2: // $12
      var $13=$2;
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { var $26 = 0;__label__ = 4; break; }
    case 3: // $17
      var $18=$s1;
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=$2;
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=(($20)|0)==(($23)|0);
      var $26 = $24;__label__ = 4; break;
    case 4: // $25
      var $26;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      var $28=$s1;
      var $29=(($28+1)|0);
      $s1=$29;
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      __label__ = 1; break;
    case 6: // $32
      var $33=$s1;
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=$2;
      var $37=HEAP8[($36)];
      var $38=(($37 << 24) >> 24);
      var $39=(($35-$38)|0);
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11ensure_roomP7astringi($str, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $newbuf;
      var $oldbuf;
      var $alloclen;
      $2=$str;
      $3=$length;
      var $4=$2;
      var $5=(($4)|0)==((__ZL13dummy_astring)|0);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=0;
      __label__ = 12; break;
    case 2: // $7
      var $8=$2;
      var $9=$8;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=(($12+1)|0);
      var $14=(($11)|0) >= (($13)|0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $1=1;
      __label__ = 12; break;
    case 4: // $16
      var $17=$3;
      var $18=(($17+256)|0);
      $alloclen=$18;
      var $19=$alloclen;
      var $20=_malloc($19);
      $newbuf=$20;
      var $21=$newbuf;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      $1=0;
      __label__ = 12; break;
    case 6: // $24
      var $25=$2;
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=$29;
      var $31=(($30+8)|0);
      var $32=(($31)|0);
      var $33=(($28)|0)==(($32)|0);
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $41 = 0;__label__ = 9; break;
    case 8: // $35
      var $36=$2;
      var $37=$36;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      var $41 = $39;__label__ = 9; break;
    case 9: // $40
      var $41;
      $oldbuf=$41;
      var $42=$newbuf;
      var $43=$2;
      var $44=$43;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=_strcpy($42, $46);
      var $48=$2;
      var $49=$48;
      var $50=(($49)|0);
      HEAP32[(($50)>>2)]=$47;
      var $51=$alloclen;
      var $52=$2;
      var $53=$52;
      var $54=(($53+4)|0);
      HEAP32[(($54)>>2)]=$51;
      var $55=$oldbuf;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $57
      var $58=$oldbuf;
      _free($58);
      __label__ = 11; break;
    case 11: // $59
      $1=1;
      __label__ = 12; break;
    case 12: // $60
      var $61=$1;
      ;
      return $61;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11ensure_roomP7astringi["X"]=1;

function __Z11astring_cpyP7astringPKS_($dst, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__Z12astring_cpycP7astringPKc($3, $7);
  ;
  return $8;
}


function __Z12astring_cpycP7astringPKc($dst, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=$2;
  var $6=_strlen($5);
  var $7=__Z13astring_cpychP7astringPKci($3, $4, $6);
  ;
  return $7;
}


function __Z13astring_cpychP7astringPKci($dst, $src, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$dst;
      $3=$src;
      $4=$count;
      var $5=$2;
      var $6=$4;
      var $7=__ZL11ensure_roomP7astringi($5, $6);
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      $1=$10;
      __label__ = 6; break;
    case 2: // $11
      var $12=$4;
      var $13=(($12)|0) > 0;
      if ($13) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      var $15=$2;
      var $16=$15;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$3;
      var $20=(($18)|0)!=(($19)|0);
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      var $22=$2;
      var $23=$22;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$3;
      var $27=$4;
      assert($27 % 1 === 0, 'memcpy given ' + $27 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($25, $26, $27, 1);
      __label__ = 5; break;
    case 5: // $28
      var $29=$4;
      var $30=$2;
      var $31=$30;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$29)|0);
      HEAP8[($34)]=0;
      var $35=$2;
      $1=$35;
      __label__ = 6; break;
    case 6: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17astring_cpysubstrP7astringPKS_ii($dst, $src, $start, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4=__stackBase__+4;
  $1=$dst;
  $2=$src;
  HEAP32[(($3)>>2)]=$start;
  HEAP32[(($4)>>2)]=$count;
  var $5=$2;
  var $6=$5;
  var $7=(($6)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=_strlen($8);
  __ZL16normalize_substrPiS_i($3, $4, $9);
  var $10=$1;
  var $11=$2;
  var $12=$11;
  var $13=(($12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=HEAP32[(($3)>>2)];
  var $16=(($14+$15)|0);
  var $17=HEAP32[(($4)>>2)];
  var $18=__Z13astring_cpychP7astringPKci($10, $16, $17);
  STACKTOP = __stackBase__;
  return $18;
}


function __Z11astring_insP7astringiPKS_($dst, $insbefore, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$dst;
  $2=$insbefore;
  $3=$src;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=$6;
  var $8=(($7)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__Z12astring_inscP7astringiPKc($4, $5, $9);
  ;
  return $10;
}


function __Z12astring_inscP7astringiPKc($dst, $insbefore, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$dst;
  $2=$insbefore;
  $3=$src;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=$3;
  var $8=_strlen($7);
  var $9=__Z13astring_inschP7astringiPKci($4, $5, $6, $8);
  ;
  return $9;
}


function __Z13astring_inschP7astringiPKci($dst, $insbefore, $src, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $dstlength;
      $2=$dst;
      $3=$insbefore;
      $4=$src;
      $5=$count;
      var $6=$2;
      var $7=$6;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=_strlen($9);
      $dstlength=$10;
      var $11=$2;
      var $12=$dstlength;
      var $13=$5;
      var $14=(($12+$13)|0);
      var $15=__ZL11ensure_roomP7astringi($11, $14);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $17
      var $18=$2;
      $1=$18;
      __label__ = 8; break;
    case 2: // $19
      var $20=$3;
      var $21=(($20)|0) < 0;
      if ($21) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $22
      var $23=$3;
      var $24=$dstlength;
      var $25=(($23)|0) > (($24)|0);
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$dstlength;
      $3=$27;
      __label__ = 5; break;
    case 5: // $28
      var $29=$3;
      var $30=$dstlength;
      var $31=(($29)|0) < (($30)|0);
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      var $33=$2;
      var $34=$33;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$3;
      var $38=(($36+$37)|0);
      var $39=$5;
      var $40=(($38+$39)|0);
      var $41=$2;
      var $42=$41;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$3;
      var $46=(($44+$45)|0);
      var $47=$dstlength;
      var $48=$3;
      var $49=(($47-$48)|0);
      _llvm_memmove_p0i8_p0i8_i32($40, $46, $49, 1, 0);
      __label__ = 7; break;
    case 7: // $50
      var $51=$2;
      var $52=$51;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$3;
      var $56=(($54+$55)|0);
      var $57=$4;
      var $58=$5;
      assert($58 % 1 === 0, 'memcpy given ' + $58 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($56, $57, $58, 1);
      var $59=$dstlength;
      var $60=$5;
      var $61=(($59+$60)|0);
      var $62=$2;
      var $63=$62;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+$61)|0);
      HEAP8[($66)]=0;
      var $67=$2;
      $1=$67;
      __label__ = 8; break;
    case 8: // $68
      var $69=$1;
      ;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13astring_inschP7astringiPKci["X"]=1;

function __Z17astring_inssubstrP7astringiPKS_ii($dst, $insbefore, $src, $start, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  var $5=__stackBase__+4;
  $1=$dst;
  $2=$insbefore;
  $3=$src;
  HEAP32[(($4)>>2)]=$start;
  HEAP32[(($5)>>2)]=$count;
  var $6=$3;
  var $7=$6;
  var $8=(($7)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=_strlen($9);
  __ZL16normalize_substrPiS_i($4, $5, $10);
  var $11=$1;
  var $12=$2;
  var $13=$3;
  var $14=$13;
  var $15=(($14)|0);
  var $16=HEAP32[(($15)>>2)];
  var $17=HEAP32[(($4)>>2)];
  var $18=(($16+$17)|0);
  var $19=HEAP32[(($5)>>2)];
  var $20=__Z13astring_inschP7astringiPKci($11, $12, $18, $19);
  STACKTOP = __stackBase__;
  return $20;
}


function __Z14astring_substrP7astringii($str, $start, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+4;
      $2=$str;
      HEAP32[(($3)>>2)]=$start;
      HEAP32[(($4)>>2)]=$count;
      var $5=$2;
      var $6=(($5)|0)==((__ZL13dummy_astring)|0);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      $1=$8;
      __label__ = 6; break;
    case 2: // $9
      var $10=$2;
      var $11=$10;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=_strlen($13);
      __ZL16normalize_substrPiS_i($3, $4, $14);
      var $15=HEAP32[(($4)>>2)];
      var $16=(($15)|0) > 0;
      if ($16) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      var $18=HEAP32[(($3)>>2)];
      var $19=(($18)|0) > 0;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      var $21=$2;
      var $22=$21;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=HEAP32[(($3)>>2)];
      var $30=(($28+$29)|0);
      var $31=HEAP32[(($4)>>2)];
      _llvm_memmove_p0i8_p0i8_i32($24, $30, $31, 1, 0);
      __label__ = 5; break;
    case 5: // $32
      var $33=HEAP32[(($4)>>2)];
      var $34=$2;
      var $35=$34;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+$33)|0);
      HEAP8[($38)]=0;
      var $39=$2;
      $1=$39;
      __label__ = 6; break;
    case 6: // $40
      var $41=$1;
      STACKTOP = __stackBase__;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14astring_substrP7astringii["X"]=1;

function __Z11astring_delP7astringii($str, $start, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+4;
      var $strlength;
      $2=$str;
      HEAP32[(($3)>>2)]=$start;
      HEAP32[(($4)>>2)]=$count;
      var $5=$2;
      var $6=$5;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=_strlen($8);
      $strlength=$9;
      var $10=$2;
      var $11=(($10)|0)==((__ZL13dummy_astring)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      $1=$13;
      __label__ = 5; break;
    case 2: // $14
      var $15=$strlength;
      __ZL16normalize_substrPiS_i($3, $4, $15);
      var $16=HEAP32[(($4)>>2)];
      var $17=(($16)|0) > 0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=$19;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=HEAP32[(($3)>>2)];
      var $24=(($22+$23)|0);
      var $25=$2;
      var $26=$25;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=HEAP32[(($3)>>2)];
      var $30=(($28+$29)|0);
      var $31=HEAP32[(($4)>>2)];
      var $32=(($30+$31)|0);
      var $33=$strlength;
      var $34=HEAP32[(($3)>>2)];
      var $35=HEAP32[(($4)>>2)];
      var $36=(($34+$35)|0);
      var $37=(($33-$36)|0);
      _llvm_memmove_p0i8_p0i8_i32($24, $32, $37, 1, 0);
      __label__ = 4; break;
    case 4: // $38
      var $39=$strlength;
      var $40=HEAP32[(($4)>>2)];
      var $41=(($39-$40)|0);
      var $42=$2;
      var $43=$42;
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+$41)|0);
      HEAP8[($46)]=0;
      var $47=$2;
      $1=$47;
      __label__ = 5; break;
    case 5: // $48
      var $49=$1;
      STACKTOP = __stackBase__;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11astring_delP7astringii["X"]=1;

function __Z14astring_printfP7astringPKcz($dst, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $tempbuf=__stackBase__;
  var $args=__stackBase__+4096;
  var $result;
  $1=$dst;
  $2=$format;
  var $3=$args;
  HEAP32[(($3)>>2)]=arguments[__Z14astring_printfP7astringPKcz.length];
  var $4=(($tempbuf)|0);
  var $5=$2;
  var $6=HEAP32[(($args)>>2)];
  var $7=_vsprintf($4, $5, $6);
  $result=$7;
  var $8=$args;
  ;
  var $9=$1;
  var $10=(($tempbuf)|0);
  var $11=__Z12astring_cpycP7astringPKc($9, $10);
  var $12=$result;
  STACKTOP = __stackBase__;
  return $12;
}


function __Z15astring_vprintfP7astringPKcPc($dst, $format, $args) {
  var __stackBase__  = STACKTOP; STACKTOP += 4096; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $tempbuf=__stackBase__;
  var $result;
  $1=$dst;
  $2=$format;
  $3=$args;
  var $4=(($tempbuf)|0);
  var $5=$2;
  var $6=$3;
  var $7=_vsprintf($4, $5, $6);
  $result=$7;
  var $8=$1;
  var $9=(($tempbuf)|0);
  var $10=__Z12astring_cpycP7astringPKc($8, $9);
  var $11=$result;
  STACKTOP = __stackBase__;
  return $11;
}


function __Z17astring_catprintfP7astringPKcz($dst, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 4100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $tempbuf=__stackBase__;
  var $args=__stackBase__+4096;
  var $result;
  $1=$dst;
  $2=$format;
  var $3=$args;
  HEAP32[(($3)>>2)]=arguments[__Z17astring_catprintfP7astringPKcz.length];
  var $4=(($tempbuf)|0);
  var $5=$2;
  var $6=HEAP32[(($args)>>2)];
  var $7=_vsprintf($4, $5, $6);
  $result=$7;
  var $8=$args;
  ;
  var $9=$1;
  var $10=(($tempbuf)|0);
  var $11=__ZL12astring_catcP7astringPKc7144($9, $10);
  var $12=$result;
  STACKTOP = __stackBase__;
  return $12;
}


function __ZL12astring_catcP7astringPKc7144($dst, $src) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$src;
  var $3=$1;
  var $4=$2;
  var $5=__Z12astring_inscP7astringiPKc($3, -1, $4);
  ;
  return $5;
}


function __Z18astring_catvprintfP7astringPKcPc($dst, $format, $args) {
  var __stackBase__  = STACKTOP; STACKTOP += 4096; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $tempbuf=__stackBase__;
  var $result;
  $1=$dst;
  $2=$format;
  $3=$args;
  var $4=(($tempbuf)|0);
  var $5=$2;
  var $6=$3;
  var $7=_vsprintf($4, $5, $6);
  $result=$7;
  var $8=$1;
  var $9=(($tempbuf)|0);
  var $10=__ZL12astring_catcP7astringPKc7144($8, $9);
  var $11=$result;
  STACKTOP = __stackBase__;
  return $11;
}


function __Z11astring_lenPK7astring($str) {
  ;
  var __label__;

  var $1;
  $1=$str;
  var $2=$1;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=_strlen($5);
  ;
  return $6;
}


function __Z11astring_cmpPK7astringS1_($str1, $str2) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$str1;
  $2=$str2;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=__Z12astring_cmpcPK7astringPKc($3, $7);
  ;
  return $8;
}


function __Z13astring_icmpcPK7astringPKc($str1, $str2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $s1;
      $1=$str1;
      $2=$str2;
      var $3=$1;
      var $4=$3;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      $s1=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$s1;
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { var $28 = 0;__label__ = 4; break; }
    case 2: // $12
      var $13=$2;
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { var $28 = 0;__label__ = 4; break; }
    case 3: // $17
      var $18=$s1;
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=_tolower($20);
      var $22=$2;
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=_tolower($24);
      var $26=(($21)|0)==(($25)|0);
      var $28 = $26;__label__ = 4; break;
    case 4: // $27
      var $28;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$s1;
      var $31=(($30+1)|0);
      $s1=$31;
      var $32=$2;
      var $33=(($32+1)|0);
      $2=$33;
      __label__ = 1; break;
    case 6: // $34
      var $35=$s1;
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=_tolower($37);
      var $39=$2;
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=_tolower($41);
      var $43=(($38-$42)|0);
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13astring_icmpcPK7astringPKc["X"]=1;

function __Z11astring_chrPK7astringii($str, $start, $ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      $1=$str;
      $2=$start;
      $3=$ch;
      var $4=$1;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$2;
      var $9=__ZL16safe_string_basePci($7, $8);
      var $10=$3;
      var $11=_strchr($9, $10);
      $result=$11;
      var $12=$result;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$result;
      var $16=$1;
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$15;
      var $21=$19;
      var $22=(($20-$21)|0);
      var $25 = $22;__label__ = 3; break;
    case 2: // $23
      var $25 = -1;__label__ = 3; break;
    case 3: // $24
      var $25;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16safe_string_basePci($base, $start) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $max;
      $1=$base;
      $2=$start;
      var $3=$1;
      var $4=_strlen($3);
      $max=$4;
      var $5=$2;
      var $6=(($5)|0) >= 0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$2;
      var $9=$max;
      var $10=(($8)|0) < (($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$1;
      var $13=$2;
      var $14=(($12+$13)|0);
      var $20 = $14;__label__ = 4; break;
    case 3: // $15
      var $16=$1;
      var $17=$max;
      var $18=(($16+$17)|0);
      var $20 = $18;__label__ = 4; break;
    case 4: // $19
      var $20;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z12astring_rchrPK7astringii($str, $start, $ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      $1=$str;
      $2=$start;
      $3=$ch;
      var $4=$1;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$2;
      var $9=__ZL16safe_string_basePci($7, $8);
      var $10=$3;
      var $11=_strrchr($9, $10);
      $result=$11;
      var $12=$result;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$result;
      var $16=$1;
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$15;
      var $21=$19;
      var $22=(($20-$21)|0);
      var $25 = $22;__label__ = 3; break;
    case 2: // $23
      var $25 = -1;__label__ = 3; break;
    case 3: // $24
      var $25;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z12astring_findPK7astringiS1_($str, $start, $search) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$str;
  $2=$start;
  $3=$search;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=$6;
  var $8=(($7)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=__Z13astring_findcPK7astringiPKc($4, $5, $9);
  ;
  return $10;
}


function __Z13astring_findcPK7astringiPKc($str, $start, $search) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      $1=$str;
      $2=$start;
      $3=$search;
      var $4=$1;
      var $5=$4;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$2;
      var $9=__ZL16safe_string_basePci($7, $8);
      var $10=$3;
      var $11=_strstr($9, $10);
      $result=$11;
      var $12=$result;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$result;
      var $16=$1;
      var $17=$16;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$15;
      var $21=$19;
      var $22=(($20-$21)|0);
      var $25 = $22;__label__ = 3; break;
    case 2: // $23
      var $25 = -1;__label__ = 3; break;
    case 3: // $24
      var $25;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14astring_delchrP7astringi($str, $ch) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $src;
      var $dst;
      $1=$str;
      $2=$ch;
      var $3=$1;
      var $4=$3;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      $dst=$6;
      $src=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$src;
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$src;
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=$2;
      var $17=(($15)|0)!=(($16)|0);
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$src;
      var $20=HEAP8[($19)];
      var $21=$dst;
      var $22=(($21+1)|0);
      $dst=$22;
      HEAP8[($21)]=$20;
      __label__ = 4; break;
    case 4: // $23
      __label__ = 5; break;
    case 5: // $24
      var $25=$src;
      var $26=(($25+1)|0);
      $src=$26;
      __label__ = 1; break;
    case 6: // $27
      var $28=$dst;
      HEAP8[($28)]=0;
      var $29=$1;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19core_i64_hex_formatyh($value$0, $value$1, $mindigits) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $bufbase;
      var $bufptr;
      var $curdigit;
      var $nibble;
      var $st$6$0=(($1)|0);
      HEAP32[(($st$6$0)>>2)]=$value$0;
      var $st$6$1=(($1+4)|0);
      HEAP32[(($st$6$1)>>2)]=$value$1;
      $2=$mindigits;
      var $3=HEAP32[((__ZZ19core_i64_hex_formatyhE5index)>>2)];
      var $4=(($3+1)|0);
      HEAP32[((__ZZ19core_i64_hex_formatyhE5index)>>2)]=$4;
      var $5=(($3)|0)%16;
      var $6=((__ZZ19core_i64_hex_formatyhE6buffer+($5<<6))|0);
      var $7=(($6)|0);
      $bufbase=$7;
      var $8=$bufbase;
      $bufptr=$8;
      $curdigit=15;
      __label__ = 1; break;
    case 1: // $9
      var $10=$curdigit;
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0) >= 0;
      if ($12) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $13
      var $st$0$0=(($1)|0);
      var $14$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $14$1=HEAP32[(($st$0$1)>>2)];
      var $15=$curdigit;
      var $16=(($15 << 24) >> 24);
      var $17=((($16<<2))|0);
      var $18$0=$17;
      var $18$1=0;
      var $19=Runtime.bitshift64($14$0, $14$1,"lshr",$18$0);var $19$0 = $19[0], $19$1 = $19[1];
      var $$emscripten$temp$0$0=15;
      var $$emscripten$temp$0$1=0;
      var $20$0=$19$0 & $$emscripten$temp$0$0;
      var $20$1=$19$1 & $$emscripten$temp$0$1;
      var $21$0=$20$0;
      var $21=$21$0;
      $nibble=$21;
      var $22=$nibble;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $24
      var $25=$curdigit;
      var $26=(($25 << 24) >> 24);
      var $27=$2;
      var $28=(($27)&255);
      var $29=(($26)|0) < (($28)|0);
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$curdigit;
      $2=$31;
      var $32=$nibble;
      var $33=((STRING_TABLE.__str17181+$32)|0);
      var $34=HEAP8[($33)];
      var $35=$bufptr;
      var $36=(($35+1)|0);
      $bufptr=$36;
      HEAP8[($35)]=$34;
      __label__ = 5; break;
    case 5: // $37
      __label__ = 6; break;
    case 6: // $38
      var $39=$curdigit;
      var $40=(($39-1)&255);
      $curdigit=$40;
      __label__ = 1; break;
    case 7: // $41
      var $42=$bufptr;
      var $43=$bufbase;
      var $44=(($42)|0)==(($43)|0);
      if ($44) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $45
      var $46=$bufptr;
      var $47=(($46+1)|0);
      $bufptr=$47;
      HEAP8[($46)]=48;
      __label__ = 9; break;
    case 9: // $48
      var $49=$bufptr;
      HEAP8[($49)]=0;
      var $50=$bufbase;
      STACKTOP = __stackBase__;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z19core_i64_hex_formatyh["X"]=1;

function __Z15astring_replaceP7astringiPKS_S2_($str, $start, $search, $replace) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$str;
  $2=$start;
  $3=$search;
  $4=$replace;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$7;
  var $9=(($8)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$4;
  var $12=$11;
  var $13=(($12)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=__Z16astring_replacecP7astringiPKcS2_($5, $6, $10, $14);
  ;
  return $15;
}


function __Z16astring_replacecP7astringiPKcS2_($str, $start, $search, $replace) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $searchlen;
      var $replacelen;
      var $matches;
      var $curindex;
      $1=$str;
      $2=$start;
      $3=$search;
      $4=$replace;
      var $5=$3;
      var $6=_strlen($5);
      $searchlen=$6;
      var $7=$4;
      var $8=_strlen($7);
      $replacelen=$8;
      $matches=0;
      var $9=$1;
      var $10=$2;
      var $11=$3;
      var $12=__Z13astring_findcPK7astringiPKc($9, $10, $11);
      $curindex=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$curindex;
      var $15=(($14)|0)!=-1;
      if ($15) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      var $17=$matches;
      var $18=(($17+1)|0);
      $matches=$18;
      var $19=$1;
      var $20=$curindex;
      var $21=$searchlen;
      var $22=__Z11astring_delP7astringii($19, $20, $21);
      var $23=$1;
      var $24=$curindex;
      var $25=$4;
      var $26=__Z12astring_inscP7astringiPKc($23, $24, $25);
      __label__ = 3; break;
    case 3: // $27
      var $28=$1;
      var $29=$curindex;
      var $30=$replacelen;
      var $31=(($29+$30)|0);
      var $32=$3;
      var $33=__Z13astring_findcPK7astringiPKc($28, $31, $32);
      $curindex=$33;
      __label__ = 1; break;
    case 4: // $34
      var $35=$matches;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16astring_replacecP7astringiPKcS2_["X"]=1;

function __Z15astring_toupperP7astring($str) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $text;
      $1=$str;
      var $2=$1;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $text=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$text;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$text;
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=_toupper($14);
      var $16=(($15) & 255);
      var $17=$text;
      HEAP8[($17)]=$16;
      __label__ = 3; break;
    case 3: // $18
      var $19=$text;
      var $20=(($19+1)|0);
      $text=$20;
      __label__ = 1; break;
    case 4: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15astring_tolowerP7astring($str) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $text;
      $1=$str;
      var $2=$1;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $text=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$text;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$text;
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=_tolower($14);
      var $16=(($15) & 255);
      var $17=$text;
      HEAP8[($17)]=$16;
      __label__ = 3; break;
    case 3: // $18
      var $19=$text;
      var $20=(($19+1)|0);
      $text=$20;
      __label__ = 1; break;
    case 4: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17astring_trimspaceP7astring($str) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $ptr;
      $1=$str;
      var $2=$1;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$1;
      var $7=$6;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=_strlen($9);
      var $11=(($5+$10)|0);
      var $12=(($11-1)|0);
      $ptr=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$ptr;
      var $15=$1;
      var $16=$15;
      var $17=(($16)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($14)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 2; break; } else { var $35 = 0;__label__ = 5; break; }
    case 2: // $20
      var $21=$ptr;
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=$23 & 128;
      var $25=(($24)|0)!=0;
      if ($25) { var $33 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $26
      var $27=$ptr;
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=_isspace($29);
      var $31=(($30)|0)!=0;
      var $33 = $31;__label__ = 4; break;
    case 4: // $32
      var $33;
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $36
      var $37=$ptr;
      HEAP8[($37)]=0;
      __label__ = 7; break;
    case 7: // $38
      var $39=$ptr;
      var $40=(($39-1)|0);
      $ptr=$40;
      __label__ = 1; break;
    case 8: // $41
      var $42=$1;
      var $43=$42;
      var $44=(($43)|0);
      var $45=HEAP32[(($44)>>2)];
      $ptr=$45;
      __label__ = 9; break;
    case 9: // $46
      var $47=$ptr;
      var $48=HEAP8[($47)];
      var $49=(($48 << 24) >> 24);
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 10; break; } else { var $66 = 0;__label__ = 13; break; }
    case 10: // $51
      var $52=$ptr;
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24);
      var $55=$54 & 128;
      var $56=(($55)|0)!=0;
      if ($56) { var $64 = 0;__label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $57
      var $58=$ptr;
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=_isspace($60);
      var $62=(($61)|0)!=0;
      var $64 = $62;__label__ = 12; break;
    case 12: // $63
      var $64;
      var $66 = $64;__label__ = 13; break;
    case 13: // $65
      var $66;
      if ($66) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $67
      __label__ = 15; break;
    case 15: // $68
      var $69=$ptr;
      var $70=(($69+1)|0);
      $ptr=$70;
      __label__ = 9; break;
    case 16: // $71
      var $72=$ptr;
      var $73=$1;
      var $74=$73;
      var $75=(($74)|0);
      var $76=HEAPU32[(($75)>>2)];
      var $77=(($72)>>>0) > (($76)>>>0);
      if ($77) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $78
      var $79=$1;
      var $80=$ptr;
      var $81=$1;
      var $82=$81;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$80;
      var $86=$84;
      var $87=(($85-$86)|0);
      var $88=__Z14astring_substrP7astringii($79, $87, -1);
      __label__ = 18; break;
    case 18: // $89
      var $90=$1;
      ;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17astring_trimspaceP7astring["X"]=1;

function __GLOBAL__I_a7177() {
  ;
  var __label__;

  ___cxx_global_var_init7109();
  ;
  return;
}


function __Z12core_stricmpPKcS0_($s1, $s2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $c1;
      var $c2;
      $1=$s1;
      $2=$s2;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      var $5=(($4+1)|0);
      $1=$5;
      var $6=HEAPU8[($4)];
      var $7=(($6)&255);
      var $8=_tolower($7);
      $c1=$8;
      var $9=$2;
      var $10=(($9+1)|0);
      $2=$10;
      var $11=HEAPU8[($9)];
      var $12=(($11)&255);
      var $13=_tolower($12);
      $c2=$13;
      var $14=$c1;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$c1;
      var $18=$c2;
      var $19=(($17)|0)!=(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$c1;
      var $22=$c2;
      var $23=(($21-$22)|0);
      ;
      return $23;
    case 4: // $24
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13core_strnicmpPKcS0_j($s1, $s2, $n) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $i;
      var $c1;
      var $c2;
      $2=$s1;
      $3=$s2;
      $4=$n;
      $i=0;
      __label__ = 1; break;
    case 1: // $5
      var $6=$i;
      var $7=$4;
      var $8=(($6)>>>0) < (($7)>>>0);
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($10+1)|0);
      $2=$11;
      var $12=HEAPU8[($10)];
      var $13=(($12)&255);
      var $14=_tolower($13);
      $c1=$14;
      var $15=$3;
      var $16=(($15+1)|0);
      $3=$16;
      var $17=HEAPU8[($15)];
      var $18=(($17)&255);
      var $19=_tolower($18);
      $c2=$19;
      var $20=$c1;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $22
      var $23=$c1;
      var $24=$c2;
      var $25=(($23)|0)!=(($24)|0);
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$c1;
      var $28=$c2;
      var $29=(($27-$28)|0);
      $1=$29;
      __label__ = 8; break;
    case 5: // $30
      __label__ = 6; break;
    case 6: // $31
      var $32=$i;
      var $33=(($32+1)|0);
      $i=$33;
      __label__ = 1; break;
    case 7: // $34
      $1=0;
      __label__ = 8; break;
    case 8: // $35
      var $36=$1;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13core_strnicmpPKcS0_j["X"]=1;

function __Z15core_strwildcmpPKcS0_($sp1, $sp2) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $s1=__stackBase__;
      var $s2=__stackBase__+20;
      var $i;
      var $l1;
      var $l2;
      var $p;
      $1=$sp1;
      $2=$sp2;
      var $3=(($s1)|0);
      var $4=$1;
      var $5=_strncpy($3, $4, 16);
      var $6=(($s1+16)|0);
      HEAP8[($6)]=0;
      var $7=(($s1)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=(($s1)|0);
      var $13=_strcpy($12, ((STRING_TABLE.__str7180)|0));
      __label__ = 2; break;
    case 2: // $14
      var $15=(($s2)|0);
      var $16=$2;
      var $17=_strncpy($15, $16, 16);
      var $18=(($s2+16)|0);
      HEAP8[($18)]=0;
      var $19=(($s2)|0);
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=(($s2)|0);
      var $25=_strcpy($24, ((STRING_TABLE.__str7180)|0));
      __label__ = 4; break;
    case 4: // $26
      var $27=(($s1)|0);
      var $28=_strchr($27, 42);
      $p=$28;
      var $29=$p;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $31
      var $32=$p;
      var $33=(($s1)|0);
      var $34=$32;
      var $35=$33;
      var $36=(($34-$35)|0);
      $i=$36;
      __label__ = 6; break;
    case 6: // $37
      var $38=$i;
      var $39=(($38)|0) < 16;
      if ($39) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $40
      var $41=$i;
      var $42=(($s1+$41)|0);
      HEAP8[($42)]=63;
      __label__ = 8; break;
    case 8: // $43
      var $44=$i;
      var $45=(($44+1)|0);
      $i=$45;
      __label__ = 6; break;
    case 9: // $46
      var $47=(($s1+16)|0);
      HEAP8[($47)]=0;
      __label__ = 10; break;
    case 10: // $48
      var $49=(($s2)|0);
      var $50=_strchr($49, 42);
      $p=$50;
      var $51=$p;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $53
      var $54=$p;
      var $55=(($s2)|0);
      var $56=$54;
      var $57=$55;
      var $58=(($56-$57)|0);
      $i=$58;
      __label__ = 12; break;
    case 12: // $59
      var $60=$i;
      var $61=(($60)|0) < 16;
      if ($61) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $62
      var $63=$i;
      var $64=(($s2+$63)|0);
      HEAP8[($64)]=63;
      __label__ = 14; break;
    case 14: // $65
      var $66=$i;
      var $67=(($66+1)|0);
      $i=$67;
      __label__ = 12; break;
    case 15: // $68
      var $69=(($s2+16)|0);
      HEAP8[($69)]=0;
      __label__ = 16; break;
    case 16: // $70
      var $71=(($s1)|0);
      var $72=_strlen($71);
      $l1=$72;
      var $73=$l1;
      var $74=(($73)|0) < 16;
      if ($74) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $75
      var $76=$l1;
      var $77=(($76+1)|0);
      $i=$77;
      __label__ = 18; break;
    case 18: // $78
      var $79=$i;
      var $80=(($79)|0) < 16;
      if ($80) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $81
      var $82=$i;
      var $83=(($s1+$82)|0);
      HEAP8[($83)]=32;
      __label__ = 20; break;
    case 20: // $84
      var $85=$i;
      var $86=(($85+1)|0);
      $i=$86;
      __label__ = 18; break;
    case 21: // $87
      var $88=(($s1+16)|0);
      HEAP8[($88)]=0;
      __label__ = 22; break;
    case 22: // $89
      var $90=(($s2)|0);
      var $91=_strlen($90);
      $l2=$91;
      var $92=$l2;
      var $93=(($92)|0) < 16;
      if ($93) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $94
      var $95=$l2;
      var $96=(($95+1)|0);
      $i=$96;
      __label__ = 24; break;
    case 24: // $97
      var $98=$i;
      var $99=(($98)|0) < 16;
      if ($99) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $100
      var $101=$i;
      var $102=(($s2+$101)|0);
      HEAP8[($102)]=32;
      __label__ = 26; break;
    case 26: // $103
      var $104=$i;
      var $105=(($104+1)|0);
      $i=$105;
      __label__ = 24; break;
    case 27: // $106
      var $107=(($s2+16)|0);
      HEAP8[($107)]=0;
      __label__ = 28; break;
    case 28: // $108
      $i=0;
      __label__ = 29; break;
    case 29: // $109
      var $110=$i;
      var $111=(($110)|0) < 16;
      if ($111) { __label__ = 30; break; } else { __label__ = 38; break; }
    case 30: // $112
      var $113=$i;
      var $114=(($s1+$113)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24);
      var $117=(($116)|0)==63;
      if ($117) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $118
      var $119=$i;
      var $120=(($s2+$119)|0);
      var $121=HEAP8[($120)];
      var $122=(($121 << 24) >> 24);
      var $123=(($122)|0)!=63;
      if ($123) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $124
      var $125=$i;
      var $126=(($s2+$125)|0);
      var $127=HEAP8[($126)];
      var $128=$i;
      var $129=(($s1+$128)|0);
      HEAP8[($129)]=$127;
      __label__ = 33; break;
    case 33: // $130
      var $131=$i;
      var $132=(($s2+$131)|0);
      var $133=HEAP8[($132)];
      var $134=(($133 << 24) >> 24);
      var $135=(($134)|0)==63;
      if ($135) { __label__ = 34; break; } else { __label__ = 36; break; }
    case 34: // $136
      var $137=$i;
      var $138=(($s1+$137)|0);
      var $139=HEAP8[($138)];
      var $140=(($139 << 24) >> 24);
      var $141=(($140)|0)!=63;
      if ($141) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $142
      var $143=$i;
      var $144=(($s1+$143)|0);
      var $145=HEAP8[($144)];
      var $146=$i;
      var $147=(($s2+$146)|0);
      HEAP8[($147)]=$145;
      __label__ = 36; break;
    case 36: // $148
      __label__ = 37; break;
    case 37: // $149
      var $150=$i;
      var $151=(($150+1)|0);
      $i=$151;
      __label__ = 29; break;
    case 38: // $152
      var $153=(($s1)|0);
      var $154=(($s2)|0);
      var $155=__Z12core_stricmpPKcS0_($153, $154);
      STACKTOP = __stackBase__;
      return $155;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15core_strwildcmpPKcS0_["X"]=1;

function __Z11core_strdupPKc($str) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $cpy;
      $1=$str;
      $cpy=0;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $4
      var $5=$1;
      var $6=_strlen($5);
      var $7=(($6+1)|0);
      var $8=_osd_malloc_array($7);
      $cpy=$8;
      var $9=$cpy;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$cpy;
      var $13=$1;
      var $14=_strcpy($12, $13);
      __label__ = 3; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$cpy;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5ishexc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0) >= 48;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0) <= 57;
      if ($8) { var $20 = 1;__label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0) >= 65;
      if ($12) { __label__ = 3; break; } else { var $18 = 0;__label__ = 4; break; }
    case 3: // $13
      var $14=$1;
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0) <= 70;
      var $18 = $16;__label__ = 4; break;
    case 4: // $17
      var $18;
      var $20 = $18;__label__ = 5; break;
    case 5: // $19
      var $20;
      var $21=(($20)&1);
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL6hexvalc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0) >= 48;
      if ($4) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0) <= 57;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10 << 24) >> 24);
      var $12=(($11-48)|0);
      var $19 = $12;__label__ = 4; break;
    case 3: // $13
      var $14=$1;
      var $15=(($14 << 24) >> 24);
      var $16=(($15+10)|0);
      var $17=(($16-65)|0);
      var $19 = $17;__label__ = 4; break;
    case 4: // $18
      var $19;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7isdelimc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0)==32;
      if ($4) { var $14 = 1;__label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==13;
      if ($8) { var $14 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=$1;
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)==10;
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      var $15=(($14)&1);
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12jed_set_fuseP9_jed_datajh($data, $fusenum, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$data;
      $2=$fusenum;
      $3=$value;
      var $4=$2;
      var $5=(($4)>>>0) < 65536;
      if ($5) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $6
      var $7=$3;
      var $8=(($7 << 24) >> 24)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($10)>>>0)%8;
      var $12=1 << $11;
      var $13=$2;
      var $14=Math.floor((($13)>>>0)/8);
      var $15=$1;
      var $16=(($15+4)|0);
      var $17=(($16+$14)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$19 | $12;
      var $21=(($20) & 255);
      HEAP8[($17)]=$21;
      __label__ = 4; break;
    case 3: // $22
      var $23=$2;
      var $24=(($23)>>>0)%8;
      var $25=1 << $24;
      var $26=$25 ^ -1;
      var $27=$2;
      var $28=Math.floor((($27)>>>0)/8);
      var $29=$1;
      var $30=(($29+4)|0);
      var $31=(($30+$28)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$33 & $26;
      var $35=(($34) & 255);
      HEAP8[($31)]=$35;
      __label__ = 4; break;
    case 4: // $36
      __label__ = 5; break;
    case 5: // $37
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z9jed_parsePKvjP9_jed_data($data, $length, $result) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cursrc;
      var $srcend;
      var $scan;
      var $pinfo=__stackBase__;
      var $checksum;
      var $i;
      var $dessum;
      $2=$data;
      $3=$length;
      $4=$result;
      var $5=$2;
      $cursrc=$5;
      var $6=$cursrc;
      var $7=$3;
      var $8=(($6+$7)|0);
      $srcend=$8;
      var $9=$4;
      var $10=$9;
      _memset($10, 0, 8196, 1);
      var $11=$pinfo;
      HEAP8[($11)]=0; HEAP8[($11+1)]=0; HEAP8[($11+2)]=0; HEAP8[($11+3)]=0; HEAP8[($11+4)]=0; HEAP8[($11+5)]=0; HEAP8[($11+6)]=0; HEAP8[($11+7)]=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$cursrc;
      var $14=$srcend;
      var $15=(($13)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 2; break; } else { var $22 = 0;__label__ = 3; break; }
    case 2: // $16
      var $17=$cursrc;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=(($19)|0)!=2;
      var $22 = $20;__label__ = 3; break;
    case 3: // $21
      var $22;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      var $24=$cursrc;
      var $25=(($24+1)|0);
      $cursrc=$25;
      __label__ = 1; break;
    case 5: // $26
      var $27=$cursrc;
      var $28=$srcend;
      var $29=(($27)>>>0) >= (($28)>>>0);
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      $1=1;
      __label__ = 57; break;
    case 7: // $31
      var $32=$cursrc;
      $scan=$32;
      $checksum=0;
      __label__ = 8; break;
    case 8: // $33
      var $34=$scan;
      var $35=$srcend;
      var $36=(($34)>>>0) < (($35)>>>0);
      if ($36) { __label__ = 9; break; } else { var $43 = 0;__label__ = 10; break; }
    case 9: // $37
      var $38=$scan;
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=(($40)|0)!=3;
      var $43 = $41;__label__ = 10; break;
    case 10: // $42
      var $43;
      if ($43) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $44
      var $45=$scan;
      var $46=(($45+1)|0);
      $scan=$46;
      var $47=HEAPU8[($45)];
      var $48=(($47)&255);
      var $49=$48 & 127;
      var $50=$checksum;
      var $51=(($50)&65535);
      var $52=(($51+$49)|0);
      var $53=(($52) & 65535);
      $checksum=$53;
      __label__ = 8; break;
    case 12: // $54
      var $55=$scan;
      var $56=$srcend;
      var $57=(($55)>>>0) >= (($56)>>>0);
      if ($57) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $58
      $1=1;
      __label__ = 57; break;
    case 14: // $59
      var $60=$scan;
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=$checksum;
      var $64=(($63)&65535);
      var $65=(($64+$62)|0);
      var $66=(($65) & 65535);
      $checksum=$66;
      var $67=$scan;
      var $68=(($67+4)|0);
      var $69=$srcend;
      var $70=(($68)>>>0) < (($69)>>>0);
      if ($70) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $71
      var $72=$scan;
      var $73=(($72+1)|0);
      var $74=HEAP8[($73)];
      var $75=__ZL5ishexc($74);
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 16; break; } else { __label__ = 23; break; }
    case 16: // $77
      var $78=$scan;
      var $79=(($78+2)|0);
      var $80=HEAP8[($79)];
      var $81=__ZL5ishexc($80);
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 17; break; } else { __label__ = 23; break; }
    case 17: // $83
      var $84=$scan;
      var $85=(($84+3)|0);
      var $86=HEAP8[($85)];
      var $87=__ZL5ishexc($86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $89
      var $90=$scan;
      var $91=(($90+4)|0);
      var $92=HEAP8[($91)];
      var $93=__ZL5ishexc($92);
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $95
      var $96=$scan;
      var $97=(($96+1)|0);
      var $98=HEAP8[($97)];
      var $99=__ZL6hexvalc($98);
      var $100=$99 << 12;
      var $101=$scan;
      var $102=(($101+2)|0);
      var $103=HEAP8[($102)];
      var $104=__ZL6hexvalc($103);
      var $105=$104 << 8;
      var $106=$100 | $105;
      var $107=$scan;
      var $108=(($107+3)|0);
      var $109=HEAP8[($108)];
      var $110=__ZL6hexvalc($109);
      var $111=$110 << 4;
      var $112=$106 | $111;
      var $113=$scan;
      var $114=(($113+4)|0);
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $117=$116 << 0;
      var $118=(($117) & 255);
      var $119=__ZL6hexvalc($118);
      var $120=$112 | $119;
      var $121=(($120) & 65535);
      $dessum=$121;
      var $122=$dessum;
      var $123=(($122)&65535);
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $125
      var $126=$dessum;
      var $127=(($126)&65535);
      var $128=$checksum;
      var $129=(($128)&65535);
      var $130=(($127)|0)!=(($129)|0);
      if ($130) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $131
      $1=2;
      __label__ = 57; break;
    case 22: // $132
      __label__ = 23; break;
    case 23: // $133
      var $134=$scan;
      $srcend=$134;
      var $135=$cursrc;
      var $136=(($135+1)|0);
      $cursrc=$136;
      __label__ = 24; break;
    case 24: // $137
      var $138=$cursrc;
      var $139=$srcend;
      var $140=(($138)>>>0) < (($139)>>>0);
      if ($140) { __label__ = 25; break; } else { var $147 = 0;__label__ = 26; break; }
    case 25: // $141
      var $142=$cursrc;
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=(($144)|0)!=42;
      var $147 = $145;__label__ = 26; break;
    case 26: // $146
      var $147;
      if ($147) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $148
      var $149=$cursrc;
      var $150=(($149+1)|0);
      $cursrc=$150;
      __label__ = 24; break;
    case 28: // $151
      var $152=$cursrc;
      var $153=(($152+1)|0);
      $cursrc=$153;
      __label__ = 29; break;
    case 29: // $154
      var $155=$cursrc;
      var $156=$srcend;
      var $157=(($155)>>>0) < (($156)>>>0);
      if ($157) { __label__ = 30; break; } else { __label__ = 45; break; }
    case 30: // $158
      __label__ = 31; break;
    case 31: // $159
      var $160=$cursrc;
      var $161=$srcend;
      var $162=(($160)>>>0) < (($161)>>>0);
      if ($162) { __label__ = 32; break; } else { var $169 = 0;__label__ = 33; break; }
    case 32: // $163
      var $164=$cursrc;
      var $165=HEAP8[($164)];
      var $166=__ZL7isdelimc($165);
      var $167=(($166)|0)!=0;
      var $169 = $167;__label__ = 33; break;
    case 33: // $168
      var $169;
      if ($169) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $170
      var $171=$cursrc;
      var $172=(($171+1)|0);
      $cursrc=$172;
      __label__ = 31; break;
    case 35: // $173
      var $174=$cursrc;
      var $175=$srcend;
      var $176=(($174)>>>0) >= (($175)>>>0);
      if ($176) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $177
      __label__ = 45; break;
    case 37: // $178
      var $179=$cursrc;
      $scan=$179;
      __label__ = 38; break;
    case 38: // $180
      var $181=$scan;
      var $182=$srcend;
      var $183=(($181)>>>0) < (($182)>>>0);
      if ($183) { __label__ = 39; break; } else { var $190 = 0;__label__ = 40; break; }
    case 39: // $184
      var $185=$scan;
      var $186=HEAPU8[($185)];
      var $187=(($186)&255);
      var $188=(($187)|0)!=42;
      var $190 = $188;__label__ = 40; break;
    case 40: // $189
      var $190;
      if ($190) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $191
      var $192=$scan;
      var $193=(($192+1)|0);
      $scan=$193;
      __label__ = 38; break;
    case 42: // $194
      var $195=$scan;
      var $196=$srcend;
      var $197=(($195)>>>0) >= (($196)>>>0);
      if ($197) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $198
      $1=1;
      __label__ = 57; break;
    case 44: // $199
      var $200=$4;
      var $201=$cursrc;
      var $202=$scan;
      __ZL13process_fieldP9_jed_dataPKhS2_P11_parse_info($200, $201, $202, $pinfo);
      var $203=$scan;
      var $204=(($203+1)|0);
      $cursrc=$204;
      __label__ = 29; break;
    case 45: // $205
      var $206=(($pinfo+4)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207)|0)!=0;
      if ($208) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $209
      var $210=(($pinfo+4)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=$4;
      var $213=(($212)|0);
      HEAP32[(($213)>>2)]=$211;
      __label__ = 47; break;
    case 47: // $214
      var $215=$4;
      var $216=(($215)|0);
      var $217=HEAPU32[(($216)>>2)];
      var $218=(($217)>>>0)%8;
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $220
      var $221=$4;
      var $222=(($221)|0);
      var $223=HEAPU32[(($222)>>2)];
      var $224=(($223)>>>0)%8;
      var $225=1 << $224;
      var $226=(($225-1)|0);
      var $227=$4;
      var $228=(($227)|0);
      var $229=HEAPU32[(($228)>>2)];
      var $230=Math.floor((($229)>>>0)/8);
      var $231=$4;
      var $232=(($231+4)|0);
      var $233=(($232+$230)|0);
      var $234=HEAPU8[($233)];
      var $235=(($234)&255);
      var $236=$235 & $226;
      var $237=(($236) & 255);
      HEAP8[($233)]=$237;
      __label__ = 49; break;
    case 49: // $238
      var $239=$4;
      var $240=(($239)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241+7)|0);
      var $243=Math.floor((($242)>>>0)/8);
      var $244=$4;
      var $245=(($244+4)|0);
      var $246=(($245+$243)|0);
      var $247=$4;
      var $248=(($247)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=(($249+7)|0);
      var $251=Math.floor((($250)>>>0)/8);
      var $252=((8192-$251)|0);
      _memset($246, 0, $252, 1);
      $checksum=0;
      $i=0;
      __label__ = 50; break;
    case 50: // $253
      var $254=$i;
      var $255=$4;
      var $256=(($255)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($257+7)|0);
      var $259=Math.floor((($258)>>>0)/8);
      var $260=(($254)>>>0) < (($259)>>>0);
      if ($260) { __label__ = 51; break; } else { __label__ = 53; break; }
    case 51: // $261
      var $262=$i;
      var $263=$4;
      var $264=(($263+4)|0);
      var $265=(($264+$262)|0);
      var $266=HEAPU8[($265)];
      var $267=(($266)&255);
      var $268=$checksum;
      var $269=(($268)&65535);
      var $270=(($269+$267)|0);
      var $271=(($270) & 65535);
      $checksum=$271;
      __label__ = 52; break;
    case 52: // $272
      var $273=$i;
      var $274=(($273+1)|0);
      $i=$274;
      __label__ = 50; break;
    case 53: // $275
      var $276=(($pinfo)|0);
      var $277=HEAPU16[(($276)>>1)];
      var $278=(($277)&65535);
      var $279=(($278)|0)!=0;
      if ($279) { __label__ = 54; break; } else { __label__ = 56; break; }
    case 54: // $280
      var $281=$checksum;
      var $282=(($281)&65535);
      var $283=(($pinfo)|0);
      var $284=HEAPU16[(($283)>>1)];
      var $285=(($284)&65535);
      var $286=(($282)|0)!=(($285)|0);
      if ($286) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $287
      $1=3;
      __label__ = 57; break;
    case 56: // $288
      $1=0;
      __label__ = 57; break;
    case 57: // $289
      var $290=$1;
      STACKTOP = __stackBase__;
      return $290;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z9jed_parsePKvjP9_jed_data["X"]=1;

function __ZL13process_fieldP9_jed_dataPKhS2_P11_parse_info($data, $cursrc, $srcend, $pinfo) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2=__stackBase__;
      var $3;
      var $4;
      var $curfuse;
      $1=$data;
      HEAP32[(($2)>>2)]=$cursrc;
      $3=$srcend;
      $4=$pinfo;
      var $5=HEAP32[(($2)>>2)];
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      if ($7 == 81) {
        __label__ = 1; break;
      }
      else if ($7 == 70) {
        __label__ = 4; break;
      }
      else if ($7 == 76) {
        __label__ = 8; break;
      }
      else if ($7 == 67) {
        __label__ = 18; break;
      }
      else {
      __label__ = 30; break;
      }
      
    case 1: // $8
      var $9=HEAP32[(($2)>>2)];
      var $10=(($9+1)|0);
      HEAP32[(($2)>>2)]=$10;
      var $11=HEAP32[(($2)>>2)];
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      if ($13 == 70) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 2: // $14
      var $15=HEAP32[(($2)>>2)];
      var $16=(($15+1)|0);
      HEAP32[(($2)>>2)]=$16;
      var $17=__ZL11suck_numberPPKh($2);
      var $18=$1;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$4;
      var $21=(($20+4)|0);
      HEAP32[(($21)>>2)]=$17;
      __label__ = 3; break;
    case 3: // $22
      __label__ = 30; break;
    case 4: // $23
      var $24=HEAP32[(($2)>>2)];
      var $25=(($24+1)|0);
      HEAP32[(($2)>>2)]=$25;
      var $26=HEAP32[(($2)>>2)];
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)==48;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$1;
      var $32=(($31+4)|0);
      var $33=(($32)|0);
      _memset($33, 0, 8192, 1);
      __label__ = 7; break;
    case 6: // $34
      var $35=$1;
      var $36=(($35+4)|0);
      var $37=(($36)|0);
      _memset($37, -1, 8192, 1);
      __label__ = 7; break;
    case 7: // $38
      __label__ = 30; break;
    case 8: // $39
      var $40=HEAP32[(($2)>>2)];
      var $41=(($40+1)|0);
      HEAP32[(($2)>>2)]=$41;
      var $42=__ZL11suck_numberPPKh($2);
      $curfuse=$42;
      __label__ = 9; break;
    case 9: // $43
      var $44=HEAPU32[(($2)>>2)];
      var $45=$3;
      var $46=(($44)>>>0) < (($45)>>>0);
      if ($46) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $47
      var $48=HEAP32[(($2)>>2)];
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=(($50)|0)==48;
      if ($51) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $52
      var $53=HEAP32[(($2)>>2)];
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=(($55)|0)==49;
      if ($56) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $57
      var $58=$1;
      var $59=$curfuse;
      var $60=HEAP32[(($2)>>2)];
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=(($62-48)|0);
      var $64=(($63) & 255);
      __ZL12jed_set_fuseP9_jed_datajh($58, $59, $64);
      var $65=$curfuse;
      var $66=$1;
      var $67=(($66)|0);
      var $68=HEAPU32[(($67)>>2)];
      var $69=(($65)>>>0) >= (($68)>>>0);
      if ($69) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $70
      var $71=$curfuse;
      var $72=(($71+1)|0);
      var $73=$1;
      var $74=(($73)|0);
      HEAP32[(($74)>>2)]=$72;
      __label__ = 14; break;
    case 14: // $75
      var $76=$curfuse;
      var $77=(($76+1)|0);
      $curfuse=$77;
      __label__ = 15; break;
    case 15: // $78
      __label__ = 16; break;
    case 16: // $79
      var $80=HEAP32[(($2)>>2)];
      var $81=(($80+1)|0);
      HEAP32[(($2)>>2)]=$81;
      __label__ = 9; break;
    case 17: // $82
      __label__ = 30; break;
    case 18: // $83
      var $84=HEAP32[(($2)>>2)];
      var $85=(($84+1)|0);
      HEAP32[(($2)>>2)]=$85;
      var $86=HEAPU32[(($2)>>2)];
      var $87=$3;
      var $88=(($87+4)|0);
      var $89=(($86)>>>0) < (($88)>>>0);
      if ($89) { __label__ = 19; break; } else { __label__ = 29; break; }
    case 19: // $90
      var $91=HEAP32[(($2)>>2)];
      var $92=(($91)|0);
      var $93=HEAP8[($92)];
      var $94=__ZL5ishexc($93);
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 20; break; } else { __label__ = 29; break; }
    case 20: // $96
      var $97=HEAP32[(($2)>>2)];
      var $98=(($97+1)|0);
      var $99=HEAP8[($98)];
      var $100=__ZL5ishexc($99);
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $102
      var $103=HEAP32[(($2)>>2)];
      var $104=(($103+2)|0);
      var $105=HEAP8[($104)];
      var $106=__ZL5ishexc($105);
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $108
      var $109=HEAP32[(($2)>>2)];
      var $110=(($109+3)|0);
      var $111=HEAP8[($110)];
      var $112=__ZL5ishexc($111);
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $114
      var $115=$4;
      var $116=(($115)|0);
      HEAP16[(($116)>>1)]=0;
      __label__ = 24; break;
    case 24: // $117
      var $118=HEAP32[(($2)>>2)];
      var $119=HEAP8[($118)];
      var $120=__ZL5ishexc($119);
      var $121=(($120)|0)!=0;
      if ($121) { __label__ = 25; break; } else { var $127 = 0;__label__ = 26; break; }
    case 25: // $122
      var $123=HEAPU32[(($2)>>2)];
      var $124=$3;
      var $125=(($123)>>>0) < (($124)>>>0);
      var $127 = $125;__label__ = 26; break;
    case 26: // $126
      var $127;
      if ($127) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $128
      var $129=$4;
      var $130=(($129)|0);
      var $131=HEAPU16[(($130)>>1)];
      var $132=(($131)&65535);
      var $133=$132 << 4;
      var $134=HEAPU32[(($2)>>2)];
      var $135=(($134+1)|0);
      HEAP32[(($2)>>2)]=$135;
      var $136=HEAP8[($134)];
      var $137=__ZL6hexvalc($136);
      var $138=$133 | $137;
      var $139=(($138) & 65535);
      var $140=$4;
      var $141=(($140)|0);
      HEAP16[(($141)>>1)]=$139;
      __label__ = 24; break;
    case 28: // $142
      __label__ = 29; break;
    case 29: // $143
      __label__ = 30; break;
    case 30: // $144
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13process_fieldP9_jed_dataPKhS2_P11_parse_info["X"]=1;

function __Z13jedbin_outputPK9_jed_dataPvj($data, $result, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $curdst;
      $1=$data;
      $2=$result;
      $3=$length;
      var $4=$2;
      $curdst=$4;
      var $5=$3;
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+7)|0);
      var $10=Math.floor((($9)>>>0)/8);
      var $11=(($10+4)|0);
      var $12=(($5)>>>0) >= (($11)>>>0);
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$1;
      var $15=(($14)|0);
      var $16=HEAPU32[(($15)>>2)];
      var $17=$16 >>> 24;
      var $18=(($17) & 255);
      var $19=$curdst;
      var $20=(($19+1)|0);
      $curdst=$20;
      HEAP8[($19)]=$18;
      var $21=$1;
      var $22=(($21)|0);
      var $23=HEAPU32[(($22)>>2)];
      var $24=$23 >>> 16;
      var $25=(($24) & 255);
      var $26=$curdst;
      var $27=(($26+1)|0);
      $curdst=$27;
      HEAP8[($26)]=$25;
      var $28=$1;
      var $29=(($28)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=$30 >>> 8;
      var $32=(($31) & 255);
      var $33=$curdst;
      var $34=(($33+1)|0);
      $curdst=$34;
      HEAP8[($33)]=$32;
      var $35=$1;
      var $36=(($35)|0);
      var $37=HEAPU32[(($36)>>2)];
      var $38=$37 >>> 0;
      var $39=(($38) & 255);
      var $40=$curdst;
      var $41=(($40+1)|0);
      $curdst=$41;
      HEAP8[($40)]=$39;
      var $42=$curdst;
      var $43=$1;
      var $44=(($43+4)|0);
      var $45=(($44)|0);
      var $46=$1;
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+7)|0);
      var $50=Math.floor((($49)>>>0)/8);
      assert($50 % 1 === 0, 'memcpy given ' + $50 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($42, $45, $50, 1);
      __label__ = 2; break;
    case 2: // $51
      var $52=$1;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+7)|0);
      var $56=Math.floor((($55)>>>0)/8);
      var $57=(($56+4)|0);
      ;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13jedbin_outputPK9_jed_dataPvj["X"]=1;

function __ZL11suck_numberPPKh($psrc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $src;
      var $value;
      $1=$psrc;
      var $2=$1;
      var $3=HEAP32[(($2)>>2)];
      $src=$3;
      $value=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$src;
      var $6=HEAP8[($5)];
      var $7=__ZL7isdelimc($6);
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$src;
      var $11=(($10+1)|0);
      $src=$11;
      __label__ = 1; break;
    case 3: // $12
      __label__ = 4; break;
    case 4: // $13
      var $14=$src;
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=_isdigit($16);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $19
      var $20=$value;
      var $21=(($20*10)|0);
      var $22=$src;
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(($21+$24)|0);
      var $26=(($25-48)|0);
      $value=$26;
      var $27=$src;
      var $28=(($27+1)|0);
      $src=$28;
      __label__ = 4; break;
    case 6: // $29
      var $30=$src;
      var $31=$1;
      HEAP32[(($31)>>2)]=$30;
      var $32=$value;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14pool_alloc_libPFvPKcE($fail) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $pool;
      $2=$fail;
      var $3=_malloc(15208);
      var $4=$3;
      $pool=$4;
      var $5=$pool;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 3; break;
    case 2: // $8
      var $9=$pool;
      var $10=$9;
      _memset($10, 0, 15208, 1);
      var $11=$2;
      var $12=$pool;
      var $13=(($12+15204)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$pool;
      __Z18pool_type_registerP12_object_pooljPKcPFvPvjE($14, 1835363695, ((STRING_TABLE.__str7203)|0), 1468);
      var $15=$pool;
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11hash_objectPv($object) {
  ;
  var __label__;

  var $1;
  $1=$object;
  var $2=$1;
  var $3=$2;
  var $4=$3 >>> 4;
  var $5=(($4)>>>0)%3797;
  ;
  return $5;
}


function __ZL15get_object_typeP12_object_poolj($pool, $type) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $entry;
      $2=$pool;
      $3=$type;
      var $4=$2;
      var $5=(($4+15200)|0);
      var $6=HEAP32[(($5)>>2)];
      $entry=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$entry;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$entry;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$entry;
      $1=$17;
      __label__ = 7; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$entry;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      $entry=$22;
      __label__ = 1; break;
    case 6: // $23
      $1=0;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z18pool_type_registerP12_object_pooljPKcPFvPvjE($pool, $type, $friendly, $destructor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $newtype;
      $1=$pool;
      $2=$type;
      $3=$friendly;
      $4=$destructor;
      var $5=$1;
      var $6=$2;
      var $7=__ZL15get_object_typeP12_object_poolj($5, $6);
      $newtype=$7;
      var $8=$newtype;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $10
      var $11=_malloc(16);
      var $12=$11;
      $newtype=$12;
      var $13=$newtype;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$1;
      var $17=$3;
      __ZL14report_failureP12_object_poolPKcz($16, ((STRING_TABLE.__str17204)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt));
      __label__ = 5; break;
    case 3: // $18
      var $19=$newtype;
      var $20=$19;
      for (var $$dest = $20, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $21=$1;
      var $22=(($21+15200)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$newtype;
      var $25=(($24)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$newtype;
      var $27=$1;
      var $28=(($27+15200)|0);
      HEAP32[(($28)>>2)]=$26;
      __label__ = 4; break;
    case 4: // $29
      var $30=$2;
      var $31=$newtype;
      var $32=(($31+4)|0);
      HEAP32[(($32)>>2)]=$30;
      var $33=$3;
      var $34=$newtype;
      var $35=(($34+8)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$4;
      var $37=$newtype;
      var $38=(($37+12)|0);
      HEAP32[(($38)>>2)]=$36;
      __label__ = 5; break;
    case 5: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18pool_type_registerP12_object_pooljPKcPFvPvjE["X"]=1;

function __ZL15memory_destructPvj($object, $size) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$object;
  $2=$size;
  var $3=$1;
  _free($3);
  ;
  return;
}


function __ZL14report_failureP12_object_poolPKcz($pool, $format) {
  var __stackBase__  = STACKTOP; STACKTOP += 1028; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $message=__stackBase__;
      var $argptr=__stackBase__+1024;
      $1=$pool;
      $2=$format;
      var $3=$1;
      var $4=(($3+15204)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$argptr;
      HEAP32[(($8)>>2)]=arguments[__ZL14report_failureP12_object_poolPKcz.length];
      var $9=(($message)|0);
      var $10=$2;
      var $11=HEAP32[(($argptr)>>2)];
      var $12=_vsprintf($9, $10, $11);
      var $13=$argptr;
      ;
      var $14=$1;
      var $15=(($14+15204)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($message)|0);
      FUNCTION_TABLE[$16]($17);
      __label__ = 2; break;
    case 2: // $18
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10pool_clearP12_object_pool($pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $entry;
      var $next;
      $1=$pool;
      var $2=$1;
      var $3=(($2+15188)|0);
      var $4=HEAP32[(($3)>>2)];
      $entry=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$entry;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$entry;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      $next=$11;
      var $12=$entry;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$entry;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$entry;
      var $21=(($20+20)|0);
      var $22=HEAP32[(($21)>>2)];
      FUNCTION_TABLE[$16]($19, $22);
      var $23=$1;
      var $24=(($23+15192)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$entry;
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=$25;
      var $28=$entry;
      var $29=(($28+8)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=$entry;
      var $31=(($30+4)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=$entry;
      var $33=$1;
      var $34=(($33+15192)|0);
      HEAP32[(($34)>>2)]=$32;
      __label__ = 3; break;
    case 3: // $35
      var $36=$next;
      $entry=$36;
      __label__ = 1; break;
    case 4: // $37
      var $38=$1;
      var $39=(($38)|0);
      var $40=(($39)|0);
      var $41=$40;
      _memset($41, 0, 15188, 1);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10pool_clearP12_object_pool["X"]=1;

function __Z13pool_free_libP12_object_pool($pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $block;
      var $nextblock;
      var $type;
      var $nexttype;
      $1=$pool;
      var $2=$1;
      __Z10pool_clearP12_object_pool($2);
      var $3=$1;
      var $4=(($3+15196)|0);
      var $5=HEAP32[(($4)>>2)];
      $block=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$block;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$block;
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      $nextblock=$12;
      var $13=$block;
      var $14=$13;
      _free($14);
      __label__ = 3; break;
    case 3: // $15
      var $16=$nextblock;
      $block=$16;
      __label__ = 1; break;
    case 4: // $17
      var $18=$1;
      var $19=(($18+15200)|0);
      var $20=HEAP32[(($19)>>2)];
      $type=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$type;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $24
      var $25=$type;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      $nexttype=$27;
      var $28=$type;
      var $29=$28;
      _free($29);
      __label__ = 7; break;
    case 7: // $30
      var $31=$nexttype;
      $type=$31;
      __label__ = 5; break;
    case 8: // $32
      var $33=$1;
      var $34=$33;
      _free($34);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13pool_free_libP12_object_pool["X"]=1;

function __Z25pool_object_add_file_lineP12_object_pooljPvjPKci($pool, $_type, $object, $size, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $type;
      var $hashnum;
      var $entry;
      var $block;
      var $entrynum;
      $2=$pool;
      $3=$_type;
      $4=$object;
      $5=$size;
      $6=$file;
      $7=$line;
      var $8=$2;
      var $9=$3;
      var $10=__ZL15get_object_typeP12_object_poolj($8, $9);
      $type=$10;
      var $11=$4;
      var $12=__ZL11hash_objectPv($11);
      $hashnum=$12;
      var $13=$type;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$2;
      var $17=$6;
      var $18=$7;
      var $19=$5;
      __ZL14report_failureP12_object_poolPKcz($16, ((STRING_TABLE.__str27205)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,HEAP32[((tempInt+4)>>2)]=$18,HEAP32[((tempInt+8)>>2)]=$19,tempInt));
      var $20=$4;
      $1=$20;
      __label__ = 15; break;
    case 2: // $21
      var $22=$4;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$2;
      var $26=$6;
      var $27=$7;
      var $28=$5;
      __ZL14report_failureP12_object_poolPKcz($25, ((STRING_TABLE.__str37206)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=$27,HEAP32[((tempInt+8)>>2)]=$28,tempInt));
      var $29=$4;
      $1=$29;
      __label__ = 15; break;
    case 4: // $30
      var $31=$2;
      var $32=(($31+15192)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $35
      var $36=_malloc(8196);
      var $37=$36;
      $block=$37;
      var $38=$block;
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $40
      $1=0;
      __label__ = 15; break;
    case 7: // $41
      var $42=$block;
      var $43=$42;
      _memset($43, 0, 8196, 1);
      var $44=$2;
      var $45=(($44+15196)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$block;
      var $48=(($47)|0);
      HEAP32[(($48)>>2)]=$46;
      var $49=$block;
      var $50=$2;
      var $51=(($50+15196)|0);
      HEAP32[(($51)>>2)]=$49;
      $entrynum=0;
      __label__ = 8; break;
    case 8: // $52
      var $53=$entrynum;
      var $54=(($53)>>>0) < 256;
      if ($54) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $55
      var $56=$2;
      var $57=(($56+15192)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$entrynum;
      var $60=$block;
      var $61=(($60+4)|0);
      var $62=(($61+($59<<5))|0);
      var $63=(($62)|0);
      HEAP32[(($63)>>2)]=$58;
      var $64=$entrynum;
      var $65=$block;
      var $66=(($65+4)|0);
      var $67=(($66+($64<<5))|0);
      var $68=$2;
      var $69=(($68+15192)|0);
      HEAP32[(($69)>>2)]=$67;
      __label__ = 10; break;
    case 10: // $70
      var $71=$entrynum;
      var $72=(($71+1)|0);
      $entrynum=$72;
      __label__ = 8; break;
    case 11: // $73
      __label__ = 12; break;
    case 12: // $74
      var $75=$2;
      var $76=(($75+15192)|0);
      var $77=HEAP32[(($76)>>2)];
      $entry=$77;
      var $78=$entry;
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$2;
      var $82=(($81+15192)|0);
      HEAP32[(($82)>>2)]=$80;
      var $83=$type;
      var $84=$entry;
      var $85=(($84+12)|0);
      HEAP32[(($85)>>2)]=$83;
      var $86=$4;
      var $87=$entry;
      var $88=(($87+16)|0);
      HEAP32[(($88)>>2)]=$86;
      var $89=$5;
      var $90=$entry;
      var $91=(($90+20)|0);
      HEAP32[(($91)>>2)]=$89;
      var $92=$6;
      var $93=$entry;
      var $94=(($93+24)|0);
      HEAP32[(($94)>>2)]=$92;
      var $95=$7;
      var $96=$entry;
      var $97=(($96+28)|0);
      HEAP32[(($97)>>2)]=$95;
      var $98=$2;
      var $99=(($98+15188)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $102
      var $103=$entry;
      var $104=$2;
      var $105=(($104+15188)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+8)|0);
      HEAP32[(($107)>>2)]=$103;
      __label__ = 14; break;
    case 14: // $108
      var $109=$entry;
      var $110=(($109+8)|0);
      HEAP32[(($110)>>2)]=0;
      var $111=$2;
      var $112=(($111+15188)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$entry;
      var $115=(($114+4)|0);
      HEAP32[(($115)>>2)]=$113;
      var $116=$entry;
      var $117=$2;
      var $118=(($117+15188)|0);
      HEAP32[(($118)>>2)]=$116;
      var $119=$hashnum;
      var $120=$2;
      var $121=(($120)|0);
      var $122=(($121+($119<<2))|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$entry;
      var $125=(($124)|0);
      HEAP32[(($125)>>2)]=$123;
      var $126=$entry;
      var $127=$hashnum;
      var $128=$2;
      var $129=(($128)|0);
      var $130=(($129+($127<<2))|0);
      HEAP32[(($130)>>2)]=$126;
      var $131=$4;
      $1=$131;
      __label__ = 15; break;
    case 15: // $132
      var $133=$1;
      ;
      return $133;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z25pool_object_add_file_lineP12_object_pooljPvjPKci["X"]=1;

function __Z18pool_object_removeP12_object_poolPvi($pool, $object, $destruct) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $hashnum;
      var $entryptr;
      var $entry;
      $1=$pool;
      $2=$object;
      $3=$destruct;
      var $4=$2;
      var $5=__ZL11hash_objectPv($4);
      $hashnum=$5;
      var $6=$hashnum;
      var $7=$1;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      $entryptr=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$entryptr;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 14; break; }
    case 2: // $14
      var $15=$entryptr;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$2;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $21
      var $22=$entryptr;
      var $23=HEAP32[(($22)>>2)];
      $entry=$23;
      var $24=$3;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$entry;
      var $28=(($27+12)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+12)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$entry;
      var $33=(($32+16)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$entry;
      var $36=(($35+20)|0);
      var $37=HEAP32[(($36)>>2)];
      FUNCTION_TABLE[$31]($34, $37);
      __label__ = 5; break;
    case 5: // $38
      var $39=$entry;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $43
      var $44=$entry;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$entry;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+4)|0);
      HEAP32[(($50)>>2)]=$46;
      __label__ = 7; break;
    case 7: // $51
      var $52=$entry;
      var $53=(($52+4)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $56
      var $57=$entry;
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$entry;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+8)|0);
      HEAP32[(($63)>>2)]=$59;
      __label__ = 9; break;
    case 9: // $64
      var $65=$1;
      var $66=(($65+15188)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$entry;
      var $69=(($67)|0)==(($68)|0);
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      var $71=$entry;
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$1;
      var $75=(($74+15188)|0);
      HEAP32[(($75)>>2)]=$73;
      __label__ = 11; break;
    case 11: // $76
      var $77=$entry;
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$entryptr;
      HEAP32[(($80)>>2)]=$79;
      var $81=$1;
      var $82=(($81+15192)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$entry;
      var $85=(($84)|0);
      HEAP32[(($85)>>2)]=$83;
      var $86=$entry;
      var $87=$1;
      var $88=(($87+15192)|0);
      HEAP32[(($88)>>2)]=$86;
      __label__ = 14; break;
    case 12: // $89
      __label__ = 13; break;
    case 13: // $90
      var $91=$entryptr;
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92)|0);
      $entryptr=$93;
      __label__ = 1; break;
    case 14: // $94
      ;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18pool_object_removeP12_object_poolPvi["X"]=1;

function __Z21pool_malloc_file_lineP12_object_pooljPKci($pool, $size, $file, $line) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $ptr;
  $1=$pool;
  $2=$size;
  $3=$file;
  $4=$line;
  var $5=$2;
  var $6=_malloc($5);
  $ptr=$6;
  var $7=$1;
  var $8=$ptr;
  var $9=$2;
  var $10=$3;
  var $11=$4;
  var $12=__Z25pool_object_add_file_lineP12_object_pooljPvjPKci($7, 1835363695, $8, $9, $10, $11);
  ;
  return $12;
}


function __Z22pool_realloc_file_lineP12_object_poolPvjPKci($pool, $ptr, $size, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$pool;
      $2=$ptr;
      $3=$size;
      $4=$file;
      $5=$line;
      var $6=$2;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$1;
      var $10=$2;
      var $11=__Z18pool_object_removeP12_object_poolPvi($9, $10, 0);
      __label__ = 2; break;
    case 2: // $12
      var $13=$2;
      var $14=$3;
      var $15=_realloc($13, $14);
      $2=$15;
      var $16=$3;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$1;
      var $20=$2;
      var $21=$3;
      var $22=$4;
      var $23=$5;
      var $24=__Z25pool_object_add_file_lineP12_object_pooljPvjPKci($19, 1835363695, $20, $21, $22, $23);
      __label__ = 4; break;
    case 4: // $25
      var $26=$2;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21pool_strdup_file_lineP12_object_poolPKcS2_i($pool, $str, $file, $line) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $ptr;
      $1=$pool;
      $2=$str;
      $3=$file;
      $4=$line;
      var $5=$1;
      var $6=$2;
      var $7=_strlen($6);
      var $8=(($7+1)|0);
      var $9=$3;
      var $10=$4;
      var $11=__Z21pool_malloc_file_lineP12_object_pooljPKci($5, $8, $9, $10);
      $ptr=$11;
      var $12=$ptr;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$ptr;
      var $16=$2;
      var $17=_strcpy($15, $16);
      __label__ = 2; break;
    case 2: // $18
      var $19=$ptr;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15xml_file_createv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $rootnode;
      var $2=_malloc(28);
      var $3=$2;
      $rootnode=$3;
      var $4=$rootnode;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=0;
      __label__ = 3; break;
    case 2: // $7
      var $8=$rootnode;
      var $9=$8;
      _memset($9, 0, 28, 1);
      var $10=$rootnode;
      $1=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$1;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13xml_file_readP10_core_fileP18_xml_parse_options($file, $opts) {
  var __stackBase__  = STACKTOP; STACKTOP += 4112; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $parse_info=__stackBase__;
      var $done;
      var $tempbuf=__stackBase__+16;
      var $bytes;
      $2=$file;
      $3=$opts;
      var $4=$3;
      var $5=__ZL18expat_setup_parserP15_xml_parse_infoP18_xml_parse_options($parse_info, $4);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      $1=0;
      __label__ = 11; break;
    case 2: // $8
      __label__ = 3; break;
    case 3: // $9
      var $10=$2;
      var $11=(($tempbuf)|0);
      var $12=__Z10core_freadP10_core_filePvj($10, $11, 4096);
      $bytes=$12;
      var $13=$2;
      var $14=__Z9core_feofP10_core_file($13);
      $done=$14;
      var $15=(($parse_info)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($tempbuf)|0);
      var $18=$bytes;
      var $19=$done;
      var $20=_XML_Parse($16, $17, $18, $19);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $22
      var $23=$3;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $25
      var $26=$3;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      var $31=(($parse_info)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=_XML_GetErrorCode($32);
      var $34=_XML_ErrorString($33);
      var $35=$3;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=$34;
      var $39=(($parse_info)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=_XML_GetCurrentLineNumber($40);
      var $42=$3;
      var $43=(($42)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+4)|0);
      HEAP32[(($45)>>2)]=$41;
      var $46=(($parse_info)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=_XML_GetCurrentColumnNumber($47);
      var $49=$3;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+8)|0);
      HEAP32[(($52)>>2)]=$48;
      __label__ = 7; break;
    case 7: // $53
      var $54=(($parse_info+4)|0);
      var $55=HEAP32[(($54)>>2)];
      __Z13xml_file_freeP14_xml_data_node($55);
      var $56=(($parse_info)|0);
      var $57=HEAP32[(($56)>>2)];
      _XML_ParserFree($57);
      $1=0;
      __label__ = 11; break;
    case 8: // $58
      __label__ = 9; break;
    case 9: // $59
      var $60=$done;
      var $61=(($60)|0)!=0;
      var $62=$61 ^ 1;
      if ($62) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 10: // $63
      var $64=(($parse_info)|0);
      var $65=HEAP32[(($64)>>2)];
      _XML_ParserFree($65);
      var $66=(($parse_info+4)|0);
      var $67=HEAP32[(($66)>>2)];
      $1=$67;
      __label__ = 11; break;
    case 11: // $68
      var $69=$1;
      STACKTOP = __stackBase__;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13xml_file_readP10_core_fileP18_xml_parse_options["X"]=1;

function __ZL18expat_setup_parserP15_xml_parse_infoP18_xml_parse_options($parse_info, $opts) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $memcallbacks=__stackBase__;
      $2=$parse_info;
      $3=$opts;
      var $4=$2;
      var $5=$4;
      for (var $$dest = $5, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $6=$3;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=(($12+12)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$3;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$3;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=$3;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+4)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=$3;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+8)|0);
      HEAP32[(($30)>>2)]=0;
      __label__ = 3; break;
    case 3: // $31
      __label__ = 4; break;
    case 4: // $32
      var $33=__Z15xml_file_createv();
      var $34=$2;
      var $35=(($34+4)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$2;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      $1=0;
      __label__ = 12; break;
    case 6: // $41
      var $42=$2;
      var $43=(($42+4)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$2;
      var $46=(($45+8)|0);
      HEAP32[(($46)>>2)]=$44;
      var $47=(($memcallbacks)|0);
      HEAP32[(($47)>>2)]=1470;
      var $48=(($memcallbacks+4)|0);
      HEAP32[(($48)>>2)]=1472;
      var $49=(($memcallbacks+8)|0);
      HEAP32[(($49)>>2)]=1474;
      var $50=_XML_ParserCreate_MM(0, $memcallbacks, 0);
      var $51=$2;
      var $52=(($51)|0);
      HEAP32[(($52)>>2)]=$50;
      var $53=$2;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$2;
      var $59=(($58+4)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$60;
      _free($61);
      $1=0;
      __label__ = 12; break;
    case 8: // $62
      var $63=$2;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      _XML_SetElementHandler($65, 1476, 1478);
      var $66=$2;
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      _XML_SetCharacterDataHandler($68, 1480);
      var $69=$2;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=$72;
      _XML_SetUserData($71, $73);
      var $74=$3;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $76
      var $77=$3;
      var $78=(($77+4)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $81
      var $82=$3;
      var $83=(($82+4)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      FUNCTION_TABLE[$84]($87);
      __label__ = 11; break;
    case 11: // $88
      $1=1;
      __label__ = 12; break;
    case 12: // $89
      var $90=$1;
      STACKTOP = __stackBase__;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18expat_setup_parserP15_xml_parse_infoP18_xml_parse_options["X"]=1;

function __Z13xml_file_freeP14_xml_data_node($node) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$node;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 3; break;
    case 2: // $7
      var $8=$1;
      __ZL19free_node_recursiveP14_xml_data_node($8);
      __label__ = 3; break;
    case 3: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15xml_string_readPKcP18_xml_parse_options($string, $opts) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $parse_info=__stackBase__;
      var $length;
      $2=$string;
      $3=$opts;
      var $4=$2;
      var $5=_strlen($4);
      $length=$5;
      var $6=$3;
      var $7=__ZL18expat_setup_parserP15_xml_parse_infoP18_xml_parse_options($parse_info, $6);
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $9
      $1=0;
      __label__ = 8; break;
    case 2: // $10
      var $11=(($parse_info)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$2;
      var $14=$length;
      var $15=_XML_Parse($12, $13, $14, 1);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $17
      var $18=$3;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $20
      var $21=$3;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=(($parse_info)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=_XML_GetErrorCode($27);
      var $29=_XML_ErrorString($28);
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0);
      HEAP32[(($33)>>2)]=$29;
      var $34=(($parse_info)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=_XML_GetCurrentLineNumber($35);
      var $37=$3;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+4)|0);
      HEAP32[(($40)>>2)]=$36;
      var $41=(($parse_info)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=_XML_GetCurrentColumnNumber($42);
      var $44=$3;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+8)|0);
      HEAP32[(($47)>>2)]=$43;
      __label__ = 6; break;
    case 6: // $48
      var $49=(($parse_info+4)|0);
      var $50=HEAP32[(($49)>>2)];
      __Z13xml_file_freeP14_xml_data_node($50);
      var $51=(($parse_info)|0);
      var $52=HEAP32[(($51)>>2)];
      _XML_ParserFree($52);
      $1=0;
      __label__ = 8; break;
    case 7: // $53
      var $54=(($parse_info)|0);
      var $55=HEAP32[(($54)>>2)];
      _XML_ParserFree($55);
      var $56=(($parse_info+4)|0);
      var $57=HEAP32[(($56)>>2)];
      $1=$57;
      __label__ = 8; break;
    case 8: // $58
      var $59=$1;
      STACKTOP = __stackBase__;
      return $59;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15xml_string_readPKcP18_xml_parse_options["X"]=1;

function __Z14xml_file_writeP14_xml_data_nodeP10_core_file($node, $file) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$node;
      $2=$file;
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      __label__ = 6; break;
    case 2: // $8
      var $9=$2;
      var $10=__Z12core_fprintfP10_core_filePKcz($9, ((STRING_TABLE.__str7219)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $11=$2;
      var $12=__Z12core_fprintfP10_core_filePKcz($11, ((STRING_TABLE.__str17220)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $13=$1;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      $1=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $19
      var $20=$1;
      var $21=$2;
      __ZL20write_node_recursiveP14_xml_data_nodeiP10_core_file($20, 0, $21);
      __label__ = 5; break;
    case 5: // $22
      var $23=$1;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      $1=$25;
      __label__ = 3; break;
    case 6: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20write_node_recursiveP14_xml_data_nodeiP10_core_file($node, $indent, $file) {
  var __stackBase__  = STACKTOP; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $anode;
      var $child;
      $1=$node;
      $2=$indent;
      $3=$file;
      var $4=$3;
      var $5=$2;
      var $6=$1;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=__Z12core_fprintfP10_core_filePKcz($4, ((STRING_TABLE.__str97228)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$5,HEAP32[((tempInt+4)>>2)]=((__str107229)|0),HEAP32[((tempInt+8)>>2)]=$8,tempInt));
      var $10=$1;
      var $11=(($10+20)|0);
      var $12=HEAP32[(($11)>>2)];
      $anode=$12;
      __label__ = 1; break;
    case 1: // $13
      var $14=$anode;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $16
      var $17=$3;
      var $18=$anode;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$anode;
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=__Z12core_fprintfP10_core_filePKcz($17, ((STRING_TABLE.__str117230)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$20,HEAP32[((tempInt+4)>>2)]=$23,tempInt));
      __label__ = 3; break;
    case 3: // $25
      var $26=$anode;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      $anode=$28;
      __label__ = 1; break;
    case 4: // $29
      var $30=$1;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $34
      var $35=$1;
      var $36=(($35+16)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $39
      var $40=$3;
      var $41=__Z12core_fprintfP10_core_filePKcz($40, ((STRING_TABLE.__str127231)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      __label__ = 16; break;
    case 7: // $42
      var $43=$3;
      var $44=__Z12core_fprintfP10_core_filePKcz($43, ((STRING_TABLE.__str137232)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $45=$1;
      var $46=(($45+16)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $49
      var $50=$3;
      var $51=$2;
      var $52=(($51+4)|0);
      var $53=$1;
      var $54=(($53+16)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=__Z12core_fprintfP10_core_filePKcz($50, ((STRING_TABLE.__str147233)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$52,HEAP32[((tempInt+4)>>2)]=((__str107229)|0),HEAP32[((tempInt+8)>>2)]=$55,tempInt));
      __label__ = 9; break;
    case 9: // $57
      var $58=$1;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $62
      var $63=$1;
      var $64=(($63+8)|0);
      var $65=HEAP32[(($64)>>2)];
      $child=$65;
      __label__ = 11; break;
    case 11: // $66
      var $67=$child;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $69
      var $70=$child;
      var $71=$2;
      var $72=(($71+4)|0);
      var $73=$3;
      __ZL20write_node_recursiveP14_xml_data_nodeiP10_core_file($70, $72, $73);
      __label__ = 13; break;
    case 13: // $74
      var $75=$child;
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      $child=$77;
      __label__ = 11; break;
    case 14: // $78
      __label__ = 15; break;
    case 15: // $79
      var $80=$3;
      var $81=$2;
      var $82=$1;
      var $83=(($82+12)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=__Z12core_fprintfP10_core_filePKcz($80, ((STRING_TABLE.__str157234)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$81,HEAP32[((tempInt+4)>>2)]=((__str107229)|0),HEAP32[((tempInt+8)>>2)]=$84,tempInt));
      __label__ = 16; break;
    case 16: // $86
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20write_node_recursiveP14_xml_data_nodeiP10_core_file["X"]=1;

function __ZL19free_node_recursiveP14_xml_data_node($node) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $anode;
      var $nanode;
      var $child;
      var $nchild;
      $1=$node;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      _free($9);
      __label__ = 2; break;
    case 2: // $10
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16+16)|0);
      var $18=HEAP32[(($17)>>2)];
      _free($18);
      __label__ = 4; break;
    case 4: // $19
      var $20=$1;
      var $21=(($20+20)|0);
      var $22=HEAP32[(($21)>>2)];
      $anode=$22;
      __label__ = 5; break;
    case 5: // $23
      var $24=$anode;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $26
      var $27=$anode;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$anode;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      _free($34);
      __label__ = 8; break;
    case 8: // $35
      var $36=$anode;
      var $37=(($36+8)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $40
      var $41=$anode;
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      _free($43);
      __label__ = 10; break;
    case 10: // $44
      var $45=$anode;
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      $nanode=$47;
      var $48=$anode;
      var $49=$48;
      _free($49);
      __label__ = 11; break;
    case 11: // $50
      var $51=$nanode;
      $anode=$51;
      __label__ = 5; break;
    case 12: // $52
      var $53=$1;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      $child=$55;
      __label__ = 13; break;
    case 13: // $56
      var $57=$child;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $59
      var $60=$child;
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      $nchild=$62;
      var $63=$child;
      __ZL19free_node_recursiveP14_xml_data_node($63);
      __label__ = 15; break;
    case 15: // $64
      var $65=$nchild;
      $child=$65;
      __label__ = 13; break;
    case 16: // $66
      var $67=$1;
      var $68=$67;
      _free($68);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19free_node_recursiveP14_xml_data_node["X"]=1;

function __Z15xml_get_siblingP14_xml_data_nodePKc($node, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$node;
      $3=$name;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $7
      var $8=$2;
      var $9=(($8+12)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$3;
      var $12=_strcmp($10, $11);
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      $1=$15;
      __label__ = 7; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$2;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      $2=$20;
      __label__ = 1; break;
    case 6: // $21
      $1=0;
      __label__ = 7; break;
    case 7: // $22
      var $23=$1;
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17xml_get_attributeP14_xml_data_nodePKc($node, $attribute) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $anode;
      $2=$node;
      $3=$attribute;
      var $4=$2;
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $anode=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$anode;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$anode;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$3;
      var $15=_strcmp($13, $14);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$anode;
      $1=$18;
      __label__ = 7; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$anode;
      var $22=(($21)|0);
      var $23=HEAP32[(($22)>>2)];
      $anode=$23;
      __label__ = 1; break;
    case 6: // $24
      $1=0;
      __label__ = 7; break;
    case 7: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z13xml_add_childP14_xml_data_nodePKcS2_($node, $name, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$node;
  $2=$name;
  $3=$value;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=__ZL9add_childP14_xml_data_nodePKcS2_($4, $5, $6);
  ;
  return $7;
}


function __ZL9add_childP14_xml_data_nodePKcS2_($parent, $name, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $pnode;
      var $node;
      $2=$parent;
      $3=$name;
      $4=$value;
      var $5=_malloc(28);
      var $6=$5;
      $node=$6;
      var $7=$node;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 12; break;
    case 2: // $10
      var $11=$node;
      var $12=(($11)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$2;
      var $14=$node;
      var $15=(($14+4)|0);
      HEAP32[(($15)>>2)]=$13;
      var $16=$node;
      var $17=(($16+8)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=$3;
      var $19=__ZL16copystring_lowerPKc($18);
      var $20=$node;
      var $21=(($20+12)|0);
      HEAP32[(($21)>>2)]=$19;
      var $22=$node;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      var $27=$node;
      var $28=$27;
      _free($28);
      $1=0;
      __label__ = 12; break;
    case 4: // $29
      var $30=$4;
      var $31=__ZL10copystringPKc($30);
      var $32=$node;
      var $33=(($32+16)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$node;
      var $35=(($34+16)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $38
      var $39=$4;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      var $42=$node;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      _free($44);
      var $45=$node;
      var $46=$45;
      _free($46);
      $1=0;
      __label__ = 12; break;
    case 7: // $47
      var $48=$node;
      var $49=(($48+20)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=$2;
      var $51=(($50+8)|0);
      $pnode=$51;
      __label__ = 8; break;
    case 8: // $52
      var $53=$pnode;
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $56
      __label__ = 10; break;
    case 10: // $57
      var $58=$pnode;
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0);
      $pnode=$60;
      __label__ = 8; break;
    case 11: // $61
      var $62=$node;
      var $63=$pnode;
      HEAP32[(($63)>>2)]=$62;
      var $64=$node;
      $1=$64;
      __label__ = 12; break;
    case 12: // $65
      var $66=$1;
      ;
      return $66;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9add_childP14_xml_data_nodePKcS2_["X"]=1;

function __Z15xml_delete_nodeP14_xml_data_node($node) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $pnode;
      $1=$node;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+8)|0);
      $pnode=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$pnode;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $10
      var $11=$pnode;
      var $12=HEAP32[(($11)>>2)];
      var $13=$1;
      var $14=(($12)|0)==(($13)|0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$pnode;
      HEAP32[(($19)>>2)]=$18;
      __label__ = 6; break;
    case 4: // $20
      __label__ = 5; break;
    case 5: // $21
      var $22=$pnode;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0);
      $pnode=$24;
      __label__ = 1; break;
    case 6: // $25
      var $26=$1;
      __ZL19free_node_recursiveP14_xml_data_node($26);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($node, $attribute, $defvalue) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $attr;
      $1=$node;
      $2=$attribute;
      $3=$defvalue;
      var $4=$1;
      var $5=$2;
      var $6=__Z17xml_get_attributeP14_xml_data_nodePKc($4, $5);
      $attr=$6;
      var $7=$attr;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$attr;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $16 = $12;__label__ = 3; break;
    case 2: // $13
      var $14=$3;
      var $16 = $14;__label__ = 3; break;
    case 3: // $15
      var $16;
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z21xml_get_attribute_intP14_xml_data_nodePKci($node, $attribute, $defvalue) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $string;
      var $value=__stackBase__;
      $2=$node;
      $3=$attribute;
      $4=$defvalue;
      var $5=$2;
      var $6=$3;
      var $7=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($5, $6, 0);
      $string=$7;
      var $8=$string;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      $1=$11;
      __label__ = 10; break;
    case 2: // $12
      var $13=$string;
      var $14=(($13)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)==36;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$string;
      var $20=(($19+1)|0);
      var $21=_sscanf($20, ((STRING_TABLE.__str27221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $22=(($21)|0)==1;
      var $23=HEAP32[(($value)>>2)];
      var $24=$4;
      var $25=$22 ? $23 : $24;
      $1=$25;
      __label__ = 10; break;
    case 4: // $26
      var $27=$string;
      var $28=(($27)|0);
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==48;
      if ($31) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $32
      var $33=$string;
      var $34=(($33+1)|0);
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)==120;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      var $39=$string;
      var $40=(($39+2)|0);
      var $41=_sscanf($40, ((STRING_TABLE.__str27221)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $42=(($41)|0)==1;
      var $43=HEAP32[(($value)>>2)];
      var $44=$4;
      var $45=$42 ? $43 : $44;
      $1=$45;
      __label__ = 10; break;
    case 7: // $46
      var $47=$string;
      var $48=(($47)|0);
      var $49=HEAP8[($48)];
      var $50=(($49 << 24) >> 24);
      var $51=(($50)|0)==35;
      if ($51) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $52
      var $53=$string;
      var $54=(($53+1)|0);
      var $55=_sscanf($54, ((STRING_TABLE.__str37222)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $56=(($55)|0)==1;
      var $57=HEAP32[(($value)>>2)];
      var $58=$4;
      var $59=$56 ? $57 : $58;
      $1=$59;
      __label__ = 10; break;
    case 9: // $60
      var $61=$string;
      var $62=(($61)|0);
      var $63=_sscanf($62, ((STRING_TABLE.__str37222)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $64=(($63)|0)==1;
      var $65=HEAP32[(($value)>>2)];
      var $66=$4;
      var $67=$64 ? $65 : $66;
      $1=$67;
      __label__ = 10; break;
    case 10: // $68
      var $69=$1;
      STACKTOP = __stackBase__;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21xml_get_attribute_intP14_xml_data_nodePKci["X"]=1;

function __Z28xml_get_attribute_int_formatP14_xml_data_nodePKc($node, $attribute) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $string;
      $2=$node;
      $3=$attribute;
      var $4=$2;
      var $5=$3;
      var $6=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($4, $5, 0);
      $string=$6;
      var $7=$string;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 10; break;
    case 2: // $10
      var $11=$string;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==36;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=2;
      __label__ = 10; break;
    case 4: // $17
      var $18=$string;
      var $19=(($18)|0);
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($21)|0)==48;
      if ($22) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $23
      var $24=$string;
      var $25=(($24+1)|0);
      var $26=HEAP8[($25)];
      var $27=(($26 << 24) >> 24);
      var $28=(($27)|0)==120;
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      $1=3;
      __label__ = 10; break;
    case 7: // $30
      var $31=$string;
      var $32=(($31)|0);
      var $33=HEAP8[($32)];
      var $34=(($33 << 24) >> 24);
      var $35=(($34)|0)==35;
      if ($35) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $36
      $1=1;
      __label__ = 10; break;
    case 9: // $37
      $1=0;
      __label__ = 10; break;
    case 10: // $38
      var $39=$1;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z23xml_get_attribute_floatP14_xml_data_nodePKcf($node, $attribute, $defvalue) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $string;
      var $value=__stackBase__;
      $2=$node;
      $3=$attribute;
      $4=$defvalue;
      var $5=$2;
      var $6=$3;
      var $7=__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_($5, $6, 0);
      $string=$7;
      var $8=$string;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$string;
      var $12=_sscanf($11, ((STRING_TABLE.__str47223)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$value,tempInt));
      var $13=(($12)|0)!=1;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$4;
      $1=$15;
      __label__ = 4; break;
    case 3: // $16
      var $17=HEAPF32[(($value)>>2)];
      $1=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$1;
      STACKTOP = __stackBase__;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z17xml_set_attributeP14_xml_data_nodePKcS2_($node, $name, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $anode;
      $1=$node;
      $2=$name;
      $3=$value;
      var $4=$1;
      var $5=$2;
      var $6=__Z17xml_get_attributeP14_xml_data_nodePKc($4, $5);
      $anode=$6;
      var $7=$anode;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=$anode;
      var $11=(($10+8)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$anode;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      _free($17);
      __label__ = 3; break;
    case 3: // $18
      var $19=$3;
      var $20=__ZL10copystringPKc($19);
      var $21=$anode;
      var $22=(($21+8)|0);
      HEAP32[(($22)>>2)]=$20;
      __label__ = 5; break;
    case 4: // $23
      var $24=$1;
      var $25=$2;
      var $26=$3;
      var $27=__ZL13add_attributeP14_xml_data_nodePKcS2_($24, $25, $26);
      $anode=$27;
      __label__ = 5; break;
    case 5: // $28
      var $29=$anode;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10copystringPKc($input) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $newstr;
      $2=$input;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 5; break;
    case 2: // $6
      var $7=$2;
      var $8=_strlen($7);
      var $9=(($8+1)|0);
      var $10=_malloc($9);
      $newstr=$10;
      var $11=$newstr;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$newstr;
      var $15=$2;
      var $16=_strcpy($14, $15);
      __label__ = 4; break;
    case 4: // $17
      var $18=$newstr;
      $1=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13add_attributeP14_xml_data_nodePKcS2_($node, $name, $value) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $anode;
      var $panode;
      $2=$node;
      $3=$name;
      $4=$value;
      var $5=_malloc(12);
      var $6=$5;
      $anode=$6;
      var $7=$anode;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 11; break;
    case 2: // $10
      var $11=$anode;
      var $12=(($11)|0);
      HEAP32[(($12)>>2)]=0;
      var $13=$3;
      var $14=__ZL16copystring_lowerPKc($13);
      var $15=$anode;
      var $16=(($15+4)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$anode;
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$anode;
      var $23=$22;
      _free($23);
      $1=0;
      __label__ = 11; break;
    case 4: // $24
      var $25=$4;
      var $26=__ZL10copystringPKc($25);
      var $27=$anode;
      var $28=(($27+8)|0);
      HEAP32[(($28)>>2)]=$26;
      var $29=$anode;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$anode;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      _free($36);
      var $37=$anode;
      var $38=$37;
      _free($38);
      $1=0;
      __label__ = 11; break;
    case 6: // $39
      var $40=$2;
      var $41=(($40+20)|0);
      $panode=$41;
      __label__ = 7; break;
    case 7: // $42
      var $43=$panode;
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $46
      __label__ = 9; break;
    case 9: // $47
      var $48=$panode;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0);
      $panode=$50;
      __label__ = 7; break;
    case 10: // $51
      var $52=$anode;
      var $53=$panode;
      HEAP32[(($53)>>2)]=$52;
      var $54=$anode;
      $1=$54;
      __label__ = 11; break;
    case 11: // $55
      var $56=$1;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13add_attributeP14_xml_data_nodePKcS2_["X"]=1;

function __Z21xml_set_attribute_intP14_xml_data_nodePKci($node, $name, $value) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $buffer=__stackBase__;
  $1=$node;
  $2=$name;
  $3=$value;
  var $4=(($buffer)|0);
  var $5=$3;
  var $6=_sprintf($4, ((STRING_TABLE.__str37222)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$5,tempInt));
  var $7=$1;
  var $8=$2;
  var $9=(($buffer)|0);
  var $10=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($7, $8, $9);
  STACKTOP = __stackBase__;
  return $10;
}


function __Z23xml_set_attribute_floatP14_xml_data_nodePKcf($node, $name, $value) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $buffer=__stackBase__;
  $1=$node;
  $2=$name;
  $3=$value;
  var $4=(($buffer)|0);
  var $5=$3;
  var $6=$5;
  var $7=_sprintf($4, ((STRING_TABLE.__str47223)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$6,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
  var $8=$1;
  var $9=$2;
  var $10=(($buffer)|0);
  var $11=__Z17xml_set_attributeP14_xml_data_nodePKcS2_($8, $9, $10);
  STACKTOP = __stackBase__;
  return $11;
}


function __Z20xml_normalize_stringPKc($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $d;
      $1=$string;
      $d=((__ZZ20xml_normalize_stringPKcE6buffer)|0);
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $4
      __label__ = 2; break;
    case 2: // $5
      var $6=$1;
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24)!=0;
      if ($8) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $9
      var $10=$1;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      if ($12 == 34) {
        __label__ = 4; break;
      }
      else if ($12 == 38) {
        __label__ = 5; break;
      }
      else if ($12 == 60) {
        __label__ = 6; break;
      }
      else if ($12 == 62) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 4: // $13
      var $14=$d;
      var $15=_sprintf($14, ((STRING_TABLE.__str57224)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $16=$d;
      var $17=(($16+$15)|0);
      $d=$17;
      __label__ = 9; break;
    case 5: // $18
      var $19=$d;
      var $20=_sprintf($19, ((STRING_TABLE.__str67225)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $21=$d;
      var $22=(($21+$20)|0);
      $d=$22;
      __label__ = 9; break;
    case 6: // $23
      var $24=$d;
      var $25=_sprintf($24, ((STRING_TABLE.__str77226)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $26=$d;
      var $27=(($26+$25)|0);
      $d=$27;
      __label__ = 9; break;
    case 7: // $28
      var $29=$d;
      var $30=_sprintf($29, ((STRING_TABLE.__str87227)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $31=$d;
      var $32=(($31+$30)|0);
      $d=$32;
      __label__ = 9; break;
    case 8: // $33
      var $34=$1;
      var $35=HEAP8[($34)];
      var $36=$d;
      var $37=(($36+1)|0);
      $d=$37;
      HEAP8[($36)]=$35;
      __label__ = 9; break;
    case 9: // $38
      var $39=$1;
      var $40=(($39+1)|0);
      $1=$40;
      __label__ = 2; break;
    case 10: // $41
      __label__ = 11; break;
    case 11: // $42
      var $43=$d;
      var $44=(($43+1)|0);
      $d=$44;
      HEAP8[($43)]=0;
      ;
      return ((__ZZ20xml_normalize_stringPKcE6buffer)|0);
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20xml_normalize_stringPKc["X"]=1;

function __ZL16copystring_lowerPKc($input) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $newstr;
      var $i;
      $2=$input;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=0;
      __label__ = 9; break;
    case 2: // $6
      var $7=$2;
      var $8=_strlen($7);
      var $9=(($8+1)|0);
      var $10=_malloc($9);
      $newstr=$10;
      var $11=$newstr;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $13
      $i=0;
      __label__ = 4; break;
    case 4: // $14
      var $15=$i;
      var $16=$2;
      var $17=(($16+$15)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $21
      var $22=$i;
      var $23=$2;
      var $24=(($23+$22)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=_tolower($26);
      var $28=(($27) & 255);
      var $29=$i;
      var $30=$newstr;
      var $31=(($30+$29)|0);
      HEAP8[($31)]=$28;
      __label__ = 6; break;
    case 6: // $32
      var $33=$i;
      var $34=(($33+1)|0);
      $i=$34;
      __label__ = 4; break;
    case 7: // $35
      var $36=$i;
      var $37=$newstr;
      var $38=(($37+$36)|0);
      HEAP8[($38)]=0;
      __label__ = 8; break;
    case 8: // $39
      var $40=$newstr;
      $1=$40;
      __label__ = 9; break;
    case 9: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16copystring_lowerPKc["X"]=1;

function __ZL12expat_mallocj7269($size) {
  ;
  var __label__;

  var $1;
  $1=$size;
  var $2=$1;
  var $3=_malloc($2);
  ;
  return $3;
}


function __ZL13expat_reallocPvj7270($ptr, $size) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$ptr;
  $2=$size;
  var $3=$1;
  var $4=$2;
  var $5=_realloc($3, $4);
  ;
  return $5;
}


function __ZL10expat_freePv7271($ptr) {
  ;
  var __label__;

  var $1;
  $1=$ptr;
  var $2=$1;
  _free($2);
  ;
  return;
}


function __ZL19expat_element_startPvPKcPS1_($data, $name, $attributes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $parse_info;
      var $curnode;
      var $newnode;
      var $attr;
      $1=$data;
      $2=$name;
      $3=$attributes;
      var $4=$1;
      var $5=$4;
      $parse_info=$5;
      var $6=$parse_info;
      var $7=(($6+8)|0);
      $curnode=$7;
      var $8=$curnode;
      var $9=HEAP32[(($8)>>2)];
      var $10=$2;
      var $11=__ZL9add_childP14_xml_data_nodePKcS2_($9, $10, 0);
      $newnode=$11;
      var $12=$newnode;
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      __label__ = 7; break;
    case 2: // $15
      var $16=$parse_info;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=_XML_GetCurrentLineNumber($18);
      var $20=$newnode;
      var $21=(($20+24)|0);
      HEAP32[(($21)>>2)]=$19;
      $attr=0;
      __label__ = 3; break;
    case 3: // $22
      var $23=$attr;
      var $24=$3;
      var $25=(($24+($23<<2))|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $28
      var $29=$newnode;
      var $30=$attr;
      var $31=(($30)|0);
      var $32=$3;
      var $33=(($32+($31<<2))|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$attr;
      var $36=(($35+1)|0);
      var $37=$3;
      var $38=(($37+($36<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=__ZL13add_attributeP14_xml_data_nodePKcS2_($29, $34, $39);
      __label__ = 5; break;
    case 5: // $41
      var $42=$attr;
      var $43=(($42+2)|0);
      $attr=$43;
      __label__ = 3; break;
    case 6: // $44
      var $45=$newnode;
      var $46=$curnode;
      HEAP32[(($46)>>2)]=$45;
      __label__ = 7; break;
    case 7: // $47
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19expat_element_startPvPKcPS1_["X"]=1;

function __ZL17expat_element_endPvPKc($data, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $parse_info;
      var $curnode;
      var $orig;
      var $start;
      var $end;
      $1=$data;
      $2=$name;
      var $3=$1;
      var $4=$3;
      $parse_info=$4;
      var $5=$parse_info;
      var $6=(($5+8)|0);
      $curnode=$6;
      var $7=$curnode;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      $orig=$10;
      var $11=$orig;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $13
      var $14=$parse_info;
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 16; break; } else { __label__ = 2; break; }
    case 2: // $19
      var $20=$orig;
      $start=$20;
      var $21=$start;
      var $22=$start;
      var $23=_strlen($22);
      var $24=(($21+$23)|0);
      $end=$24;
      __label__ = 3; break;
    case 3: // $25
      var $26=$start;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24)!=0;
      if ($28) { __label__ = 4; break; } else { var $36 = 0;__label__ = 5; break; }
    case 4: // $29
      var $30=$start;
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=_isspace($32);
      var $34=(($33)|0)!=0;
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$start;
      var $39=(($38+1)|0);
      $start=$39;
      __label__ = 3; break;
    case 7: // $40
      __label__ = 8; break;
    case 8: // $41
      var $42=$end;
      var $43=$start;
      var $44=(($42)>>>0) > (($43)>>>0);
      if ($44) { __label__ = 9; break; } else { var $53 = 0;__label__ = 10; break; }
    case 9: // $45
      var $46=$end;
      var $47=(($46-1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=_isspace($49);
      var $51=(($50)|0)!=0;
      var $53 = $51;__label__ = 10; break;
    case 10: // $52
      var $53;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      var $55=$end;
      var $56=(($55-1)|0);
      $end=$56;
      __label__ = 8; break;
    case 12: // $57
      var $58=$start;
      var $59=$end;
      var $60=(($58)|0)==(($59)|0);
      if ($60) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $61
      var $62=$orig;
      _free($62);
      var $63=$curnode;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+16)|0);
      HEAP32[(($65)>>2)]=0;
      __label__ = 15; break;
    case 14: // $66
      var $67=$orig;
      var $68=$start;
      var $69=$end;
      var $70=$start;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      _llvm_memmove_p0i8_p0i8_i32($67, $68, $73, 1, 0);
      var $74=$end;
      var $75=$start;
      var $76=$74;
      var $77=$75;
      var $78=(($76-$77)|0);
      var $79=$orig;
      var $80=(($79+$78)|0);
      HEAP8[($80)]=0;
      __label__ = 15; break;
    case 15: // $81
      __label__ = 16; break;
    case 16: // $82
      var $83=$curnode;
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$curnode;
      HEAP32[(($87)>>2)]=$86;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17expat_element_endPvPKc["X"]=1;

function __ZL10expat_dataPvPKci($data, $s, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $parse_info;
      var $curnode;
      var $oldlen;
      var $newdata;
      $1=$data;
      $2=$s;
      $3=$len;
      var $4=$1;
      var $5=$4;
      $parse_info=$5;
      var $6=$parse_info;
      var $7=(($6+8)|0);
      $curnode=$7;
      $oldlen=0;
      var $8=$3;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      __label__ = 7; break;
    case 2: // $11
      var $12=$curnode;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+16)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$curnode;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+16)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=_strlen($21);
      $oldlen=$22;
      __label__ = 4; break;
    case 4: // $23
      var $24=$curnode;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$oldlen;
      var $29=$3;
      var $30=(($28+$29)|0);
      var $31=(($30+1)|0);
      var $32=_realloc($27, $31);
      $newdata=$32;
      var $33=$newdata;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $35
      __label__ = 7; break;
    case 6: // $36
      var $37=$oldlen;
      var $38=$newdata;
      var $39=(($38+$37)|0);
      var $40=$2;
      var $41=$3;
      assert($41 % 1 === 0, 'memcpy given ' + $41 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($39, $40, $41, 1);
      var $42=$oldlen;
      var $43=$3;
      var $44=(($42+$43)|0);
      var $45=$newdata;
      var $46=(($45+$44)|0);
      HEAP8[($46)]=0;
      var $47=$newdata;
      var $48=$curnode;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+16)|0);
      HEAP32[(($50)>>2)]=$47;
      __label__ = 7; break;
    case 7: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10expat_dataPvPKci["X"]=1;

function __ZN12core_options5entry9set_valueEPKci($this, $newdata, $priority) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$newdata;
      $3=$priority;
      var $4=$1;
      var $5=$3;
      var $6=(($4+16)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($5)|0) < (($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      __label__ = 3; break;
    case 2: // $10
      var $11=(($4+280)|0);
      var $12=$2;
      var $13=__ZN7astringaSEPKc($11, $12);
      var $14=$3;
      var $15=(($4+16)|0);
      HEAP32[(($15)>>2)]=$14;
      var $16=(($4+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+1)|0);
      HEAP32[(($16)>>2)]=$18;
      __label__ = 3; break;
    case 3: // $19
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options5entry17set_default_valueEPKc($this, $defvalue) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$defvalue;
  var $3=$1;
  var $4=(($3+280)|0);
  var $5=$2;
  var $6=__ZN7astringaSEPKc($4, $5);
  var $7=(($3+344)|0);
  var $8=$2;
  var $9=__ZN7astringaSEPKc($7, $8);
  var $10=(($3+16)|0);
  HEAP32[(($10)>>2)]=0;
  ;
  return;
}


function __ZN12core_options5entry6revertEi($this, $priority) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$priority;
      var $3=$1;
      var $4=(($3+16)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$2;
      var $7=(($5)|0) <= (($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=(($3+280)|0);
      var $10=(($3+344)|0);
      var $11=__ZN7astringaSERKS_($9, $10);
      var $12=(($3+16)|0);
      HEAP32[(($12)>>2)]=0;
      __label__ = 2; break;
    case 2: // $13
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIPN12core_options5entryEEC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIPN12core_options5entryEEC2Ev($2);
  ;
  return;
}


function __ZN8tagmap_tIPN12core_options5entryEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIPN12core_options5entryEED2Ev($2);
  ;
  return;
}


function __ZN12core_options11add_entriesEPK13options_entryb($this, $entrylist, $override_existing) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $newentry;
      var $4;
      var $5;
      var $existing;
      $1=$this;
      $2=$entrylist;
      var $6=(($override_existing)&1);
      $3=$6;
      var $7=$1;
      __label__ = 1; break;
    case 1: // $8
      var $9=$2;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { var $20 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $13
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      var $20 = $18;__label__ = 3; break;
    case 3: // $19
      var $20;
      if ($20) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 4: // $21
      var $22=__Znwj(536);
      var $23=$22;
      var $24=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12core_options5entryC1ERK13options_entry]($23, $24) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $25
      $newentry=$23;
      var $26=$newentry;
      var $27=__ZNK12core_options5entry4nameEv($26);
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $29
      var $30=(($7+12)|0);
      var $31=$newentry;
      var $32=__ZNK12core_options5entry4nameEv($31);
      var $33=__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($30, $32);
      $existing=$33;
      var $34=$existing;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $36
      var $37=$3;
      var $38=(($37) & 1);
      if ($38) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $39
      var $40=$existing;
      __ZN12core_options12remove_entryERNS_5entryE($7, $40);
      __label__ = 15; break;
    case 9: // $41
      var $42=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $43=$42.f0;
      $4=$43;
      var $44=$42.f1;
      $5=$44;
      __ZdlPv($22);
      __label__ = 20; break;
    case 10: // $45
      var $46=$existing;
      var $47=$newentry;
      var $48=__ZNK12core_options5entry5valueEv($47);
      __ZN12core_options5entry17set_default_valueEPKc($46, $48);
      var $49=$newentry;
      var $50=(($49)|0)==0;
      if ($50) { __label__ = 13; break; } else { __label__ = 11; break; }
    case 11: // $51
      (function() { try { __THREW__ = false; return __ZN12core_options5entryD1Ev($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $52
      var $53=$49;
      __ZdlPv($53);
      __label__ = 13; break;
    case 13: // $54
      __label__ = 18; break;
    case 14: // $55
      var $56=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $57=$56.f0;
      $4=$57;
      var $58=$56.f1;
      $5=$58;
      var $59=$49;
      __ZdlPv($59);
      __label__ = 20; break;
    case 15: // $60
      __label__ = 16; break;
    case 16: // $61
      __label__ = 17; break;
    case 17: // $62
      var $63=$newentry;
      __ZN12core_options12append_entryERNS_5entryE($7, $63);
      __label__ = 18; break;
    case 18: // $64
      var $65=$2;
      var $66=(($65+16)|0);
      $2=$66;
      __label__ = 1; break;
    case 19: // $67
      ;
      return;
    case 20: // $68
      var $69=$4;
      var $70=$4;
      var $71=$5;
      var $72=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $70, tempValue);
      var $73=($72.f1 = $71, $72);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options11add_entriesEPK13options_entryb["X"]=1;

function __ZN12core_optionsD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12core_optionsD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options12remove_entryERNS_5entryE($this, $delentry) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $preventry;
      var $curentry;
      var $name;
      $1=$this;
      $2=$delentry;
      var $3=$1;
      $preventry=0;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      $curentry=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$curentry;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $9
      var $10=$curentry;
      var $11=$2;
      var $12=(($10)|0)==(($11)|0);
      if ($12) { __label__ = 3; break; } else { __label__ = 18; break; }
    case 3: // $13
      var $14=$preventry;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      var $17=$2;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$preventry;
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=$19;
      __label__ = 6; break;
    case 5: // $22
      var $23=$2;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($3+4)|0);
      HEAP32[(($26)>>2)]=$25;
      __label__ = 6; break;
    case 6: // $27
      var $28=$2;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $32
      var $33=$preventry;
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $35
      var $36=$preventry;
      var $37=(($36)|0);
      var $38=(($3+8)|0);
      HEAP32[(($38)>>2)]=$37;
      __label__ = 10; break;
    case 9: // $39
      var $40=(($3+4)|0);
      var $41=(($3+8)|0);
      HEAP32[(($41)>>2)]=$40;
      __label__ = 10; break;
    case 10: // $42
      __label__ = 11; break;
    case 11: // $43
      $name=0;
      __label__ = 12; break;
    case 12: // $44
      var $45=$name;
      var $46=(($45)>>>0) < 4;
      if ($46) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $47
      var $48=$name;
      var $49=$2;
      var $50=(($49+24)|0);
      var $51=(($50+($48<<6))|0);
      var $52=__ZN7astringcvbEv($51);
      if ($52) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $53
      var $54=(($3+12)|0);
      var $55=$name;
      var $56=$2;
      var $57=(($56+24)|0);
      var $58=(($57+($55<<6))|0);
      var $59=__ZNK7astringcvPKcEv($58);
      __ZN8tagmap_tIPN12core_options5entryEE6removeEPKc($54, $59);
      __label__ = 15; break;
    case 15: // $60
      __label__ = 16; break;
    case 16: // $61
      var $62=$name;
      var $63=(($62+1)|0);
      $name=$63;
      __label__ = 12; break;
    case 17: // $64
      __label__ = 20; break;
    case 18: // $65
      __label__ = 19; break;
    case 19: // $66
      var $67=$curentry;
      var $68=__ZNK12core_options5entry4nextEv($67);
      $curentry=$68;
      __label__ = 1; break;
    case 20: // $69
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options12remove_entryERNS_5entryE["X"]=1;

function __ZNK12core_options5entry9is_headerEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK12core_options5entry4typeEv($2);
  var $4=(($3)|0)==1;
  ;
  return $4;
}


function __ZNK12core_options5valueEPKc($this, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curentry;
      $1=$this;
      $2=$name;
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$2;
      var $6=__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($4, $5);
      $curentry=$6;
      var $7=$curentry;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$curentry;
      var $11=__ZNK12core_options5entry5valueEv($10);
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = ((__str287302)|0);__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12core_options5entry4nameEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+24)|0);
      var $4=(($3)|0);
      var $5=__ZNK7astringcvbEv($4);
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2+24)|0);
      var $8=(($7)|0);
      var $9=__ZNK7astring4cstrEv($8);
      var $12 = $9;__label__ = 3; break;
    case 2: // $10
      var $12 = 0;__label__ = 3; break;
    case 3: // $11
      var $12;
      ;
      return $12;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  var $6=__ZL11tagmap_findPK7_tagmapPKc7340($4, $5);
  var $7=$6;
  ;
  return $7;
}


function __ZNK12core_options5entry5valueEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+280)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZN12core_options5entryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN12core_options5entryD2Ev($2);
  ;
  return;
}


function __ZN12core_options5entryC2ERK13options_entry($this, $entrylist) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $namestr=__stackBase__;
      var $lparen;
      var $dash;
      var $rparen;
      var $semi;
      var $nameindex;
      $1=$this;
      $2=$entrylist;
      var $5=$1;
      var $6=(($5)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=(($5+4)|0);
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      HEAP32[(($7)>>2)]=$10;
      var $11=(($5+8)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($5+12)|0);
      HEAP8[($12)]=0;
      var $13=(($5+16)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($5+20)|0);
      var $15=$2;
      var $16=(($15+12)|0);
      var $17=HEAP32[(($16)>>2)];
      HEAP32[(($14)>>2)]=$17;
      var $18=(($5+24)|0);
      var $19=(($18)|0);
      var $20=(($19+256)|0);
      var $22 = $19;__label__ = 1; break;
    case 1: // $21
      var $22;
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 20; break; }
    case 2: // $23
      var $24=(($22+64)|0);
      var $25=(($24)|0)==(($20)|0);
      if ($25) { __label__ = 3; break; } else { var $22 = $24;__label__ = 1; break; }
    case 3: // $26
      var $27=(($5+280)|0);
      __ZN7astringC1Ev($27);
      var $28=(($5+344)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 24; break; }
    case 4: // $29
      var $30=(($5+408)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 25; break; }
    case 5: // $31
      var $32=(($5+472)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 26; break; }
    case 6: // $33
      var $34=$2;
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 43; break; }
    case 7: // $38
      var $39=$2;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      (function() { try { __THREW__ = false; return __ZN7astringC1EPKc($namestr, $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 27; break; }
    case 8: // $42
      var $43=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($namestr, 0, 40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 28; break; };
    case 9: // $44
      $lparen=$43;
      var $45=$lparen;
      var $46=(($45+1)|0);
      var $47=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($namestr, $46, 45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 28; break; };
    case 10: // $48
      $dash=$47;
      var $49=$dash;
      var $50=(($49+1)|0);
      var $51=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($namestr, $50, 41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 28; break; };
    case 11: // $52
      $rparen=$51;
      var $53=$lparen;
      var $54=(($53)|0)!=-1;
      if ($54) { __label__ = 12; break; } else { __label__ = 29; break; }
    case 12: // $55
      var $56=$dash;
      var $57=(($56)|0)!=-1;
      if ($57) { __label__ = 13; break; } else { __label__ = 29; break; }
    case 13: // $58
      var $59=$rparen;
      var $60=(($59)|0)!=-1;
      if ($60) { __label__ = 14; break; } else { __label__ = 29; break; }
    case 14: // $61
      var $62=(($5+408)|0);
      var $63=$lparen;
      var $64=(($63+1)|0);
      var $65=$dash;
      var $66=$lparen;
      var $67=(($66+1)|0);
      var $68=(($65-$67)|0);
      var $69=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($62, $namestr, $64, $68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 28; break; };
    case 15: // $70
      var $71=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 28; break; };
    case 16: // $72
      var $73=(($5+472)|0);
      var $74=$dash;
      var $75=(($74+1)|0);
      var $76=$rparen;
      var $77=$dash;
      var $78=(($77+1)|0);
      var $79=(($76-$78)|0);
      var $80=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($73, $namestr, $75, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 28; break; };
    case 17: // $81
      var $82=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 28; break; };
    case 18: // $83
      var $84=$lparen;
      var $85=$rparen;
      var $86=(($85+1)|0);
      var $87=$lparen;
      var $88=(($86-$87)|0);
      var $89=(function() { try { __THREW__ = false; return __ZN7astring3delEii($namestr, $84, $88) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 28; break; };
    case 19: // $90
      __label__ = 29; break;
    case 20: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $93=$92.f0;
      $3=$93;
      var $94=$92.f1;
      $4=$94;
      var $95=(($19)|0)==(($22)|0);
      if ($95) { __label__ = 23; break; } else { var $97 = $22;__label__ = 21; break; }
    case 21: // $96
      var $97;
      var $98=(($97-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 57; break; }
    case 22: // $99
      var $100=(($98)|0)==(($19)|0);
      if ($100) { __label__ = 23; break; } else { var $97 = $98;__label__ = 21; break; }
    case 23: // $101
      __label__ = 56; break;
    case 24: // $102
      var $103=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $104=$103.f0;
      $3=$104;
      var $105=$103.f1;
      $4=$105;
      __label__ = 54; break;
    case 25: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $108=$107.f0;
      $3=$108;
      var $109=$107.f1;
      $4=$109;
      __label__ = 52; break;
    case 26: // $110
      var $111=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $112=$111.f0;
      $3=$112;
      var $113=$111.f1;
      $4=$113;
      __label__ = 50; break;
    case 27: // $114
      var $115=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $116=$115.f0;
      $3=$116;
      var $117=$115.f1;
      $4=$117;
      __label__ = 48; break;
    case 28: // $118
      var $119=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $120=$119.f0;
      $3=$120;
      var $121=$119.f1;
      $4=$121;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($namestr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 57; break; }
    case 29: // $122
      $nameindex=0;
      __label__ = 30; break;
    case 30: // $123
      var $124=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($namestr, 0, 59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 28; break; };
    case 31: // $125
      $semi=$124;
      var $126=(($124)|0)!=-1;
      if ($126) { __label__ = 32; break; } else { var $131 = 0;__label__ = 33; break; }
    case 32: // $127
      var $128=$nameindex;
      var $129=(($128)>>>0) < 4;
      var $131 = $129;__label__ = 33; break;
    case 33: // $130
      var $131;
      if ($131) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 34: // $132
      var $133=$nameindex;
      var $134=(($133+1)|0);
      $nameindex=$134;
      var $135=(($5+24)|0);
      var $136=(($135+($133<<6))|0);
      var $137=$semi;
      var $138=(function() { try { __THREW__ = false; return __ZN7astring9cpysubstrERKS_ii($136, $namestr, 0, $137) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 28; break; };
    case 35: // $139
      var $140=$semi;
      var $141=(($140+1)|0);
      var $142=(function() { try { __THREW__ = false; return __ZN7astring3delEii($namestr, 0, $141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 28; break; };
    case 36: // $143
      __label__ = 30; break;
    case 37: // $144
      var $145=$nameindex;
      var $146=(($145)>>>0) < 4;
      if ($146) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $147
      var $148=$nameindex;
      var $149=(($148+1)|0);
      $nameindex=$149;
      var $150=(($5+24)|0);
      var $151=(($150+($148<<6))|0);
      var $152=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($151, $namestr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 28; break; };
    case 39: // $153
      __label__ = 40; break;
    case 40: // $154
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($namestr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 27; break; }
    case 41: // $155
      __label__ = 43; break;
    case 42: // $156
      __label__ = 48; break;
    case 43: // $157
      var $158=$2;
      var $159=(($158+4)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $162
      var $163=(($5+344)|0);
      var $164=$2;
      var $165=(($164+4)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return __ZN7astringaSEPKc($163, $166) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 27; break; };
    case 45: // $168
      __label__ = 46; break;
    case 46: // $169
      var $170=(($5+280)|0);
      var $171=(($5+344)|0);
      var $172=(function() { try { __THREW__ = false; return __ZN7astringaSERKS_($170, $171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 27; break; };
    case 47: // $173
      STACKTOP = __stackBase__;
      return;
    case 48: // $174
      var $175=(($5+472)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 57; break; }
    case 49: // $176
      __label__ = 50; break;
    case 50: // $177
      var $178=(($5+408)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($178) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 57; break; }
    case 51: // $179
      __label__ = 52; break;
    case 52: // $180
      var $181=(($5+344)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($181) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 57; break; }
    case 53: // $182
      __label__ = 54; break;
    case 54: // $183
      var $184=(($5+280)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $185
      __label__ = 56; break;
    case 56: // $186
      var $187=$3;
      var $188=$3;
      var $189=$4;
      var $190=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $188, tempValue);
      var $191=($190.f1 = $189, $190);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 57: // $192
      var $193=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options5entryC2ERK13options_entry["X"]=1;

function __ZN12core_optionsC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV12core_options+8)|0);
      var $6=(($4+4)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=(($4+8)|0);
      var $8=(($4+4)|0);
      HEAP32[(($7)>>2)]=$8;
      var $9=(($4+12)|0);
      __ZN8tagmap_tIPN12core_options5entryEEC1Ev($9);
      var $10=(($4+400)|0);
      (function() { try { __THREW__ = false; return __ZN7astringC1Ev($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      ;
      return;
    case 2: // $12
      var $13=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $14=$13.f0;
      $2=$14;
      var $15=$13.f1;
      $3=$15;
      var $16=(($4+12)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPN12core_options5entryEED1Ev($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $17
      __label__ = 4; break;
    case 4: // $18
      var $19=$2;
      var $20=$2;
      var $21=$3;
      var $22=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20, tempValue);
      var $23=($22.f1 = $21, $22);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_optionsD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTV12core_options+8)|0);
      __label__ = 1; break;
    case 1: // $6
      var $7=(($4+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $10
      var $11=(($4+4)|0);
      var $12=HEAP32[(($11)>>2)];
      (function() { try { __THREW__ = false; return __ZN12core_options12remove_entryERNS_5entryE($4, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      __label__ = 1; break;
    case 4: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $2=$16;
      var $17=$15.f1;
      $3=$17;
      var $18=(($4+400)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 5: // $19
      var $20=(($4+400)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $21
      var $22=(($4+12)|0);
      __ZN8tagmap_tIPN12core_options5entryEED1Ev($22);
      ;
      return;
    case 7: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $25=$24.f0;
      $2=$25;
      var $26=$24.f1;
      $3=$26;
      __label__ = 9; break;
    case 8: // $27
      __label__ = 9; break;
    case 9: // $28
      var $29=(($4+12)|0);
      (function() { try { __THREW__ = false; return __ZN8tagmap_tIPN12core_options5entryEED1Ev($29) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $30
      __label__ = 11; break;
    case 11: // $31
      var $32=$2;
      var $33=$2;
      var $34=$3;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12core_options5entry4typeEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4 & 7;
  ;
  return $5;
}


function __ZN12core_options18parse_command_lineEiPPciR7astring($this, $argc, $argv, $priority, $error_string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $unadorned_index;
      var $arg;
      var $curarg;
      var $is_unadorned;
      var $optionname;
      var $curentry;
      var $newdata;
      $2=$this;
      $3=$argc;
      $4=$argv;
      $5=$priority;
      $6=$error_string;
      var $7=$2;
      var $8=$6;
      var $9=__ZN7astring5resetEv($8);
      var $10=(($7+400)|0);
      var $11=__ZN7astring5resetEv($10);
      $unadorned_index=0;
      $arg=1;
      __label__ = 1; break;
    case 1: // $12
      var $13=$arg;
      var $14=$3;
      var $15=(($13)|0) < (($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 25; break; }
    case 2: // $16
      var $17=$arg;
      var $18=$4;
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      $curarg=$20;
      var $21=$curarg;
      var $22=(($21)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(($24)|0)!=45;
      var $26=(($25)&1);
      $is_unadorned=$26;
      var $27=$is_unadorned;
      var $28=(($27) & 1);
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$unadorned_index;
      var $31=(($30+1)|0);
      $unadorned_index=$31;
      var $32=__ZN12core_options9unadornedEi($30);
      var $37 = $32;__label__ = 5; break;
    case 4: // $33
      var $34=$curarg;
      var $35=(($34+1)|0);
      var $37 = $35;__label__ = 5; break;
    case 5: // $36
      var $37;
      $optionname=$37;
      var $38=(($7+12)|0);
      var $39=$optionname;
      var $40=__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($38, $39);
      $curentry=$40;
      var $41=$curentry;
      var $42=(($41)|0)==0;
      if ($42) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $43
      var $44=$6;
      var $45=$curarg;
      var $46=__ZN7astring9catprintfEPKcz($44, ((STRING_TABLE.__str167290)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$45,tempInt));
      $1=0;
      __label__ = 26; break;
    case 7: // $47
      var $48=$curentry;
      var $49=__ZNK12core_options5entry4typeEv($48);
      var $50=(($49)|0)==2;
      if ($50) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $51
      var $52=(($7+400)|0);
      var $53=__ZN7astringcvbEv($52);
      if ($53) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $54
      var $55=$6;
      var $56=(($7+400)|0);
      var $57=__ZNK7astring4cstrEv($56);
      var $58=$curarg;
      var $59=__ZN7astring9catprintfEPKcz($55, ((STRING_TABLE.__str177291)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$57,HEAP32[((tempInt+4)>>2)]=$58,tempInt));
      $1=0;
      __label__ = 26; break;
    case 10: // $60
      var $61=(($7+400)|0);
      var $62=$curentry;
      var $63=__ZNK12core_options5entry4nameEv($62);
      var $64=__ZN7astringaSEPKc($61, $63);
      __label__ = 24; break;
    case 11: // $65
      var $66=$curentry;
      var $67=__ZNK12core_options5entry4typeEv($66);
      var $68=(($67)|0)==3;
      if ($68) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $69
      var $70=$curarg;
      var $71=(($70+1)|0);
      var $72=_strncmp($71, ((STRING_TABLE.__str187292)|0), 2);
      var $73=(($72)|0)==0;
      if ($73) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $74
      var $77 = STRING_TABLE.__str197293;__label__ = 15; break;
    case 14: // $75
      var $77 = STRING_TABLE.__str207294;__label__ = 15; break;
    case 15: // $76
      var $77;
      var $78=(($77)|0);
      $newdata=$78;
      __label__ = 23; break;
    case 16: // $79
      var $80=$is_unadorned;
      var $81=(($80) & 1);
      if ($81) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $82
      var $83=$curarg;
      $newdata=$83;
      __label__ = 22; break;
    case 18: // $84
      var $85=$arg;
      var $86=(($85+1)|0);
      var $87=$3;
      var $88=(($86)|0) < (($87)|0);
      if ($88) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $89
      var $90=$arg;
      var $91=(($90+1)|0);
      $arg=$91;
      var $92=$4;
      var $93=(($92+($91<<2))|0);
      var $94=HEAP32[(($93)>>2)];
      $newdata=$94;
      __label__ = 21; break;
    case 20: // $95
      var $96=$6;
      var $97=$curarg;
      var $98=__ZN7astring9catprintfEPKcz($96, ((STRING_TABLE.__str217295)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$97,tempInt));
      $1=0;
      __label__ = 26; break;
    case 21: // $99
      __label__ = 22; break;
    case 22: // $100
      __label__ = 23; break;
    case 23: // $101
      var $102=$curentry;
      var $103=$newdata;
      var $104=$5;
      var $105=$6;
      var $106=__ZN12core_options21validate_and_set_dataERNS_5entryEPKciR7astring($7, $102, $103, $104, $105);
      __label__ = 24; break;
    case 24: // $107
      var $108=$arg;
      var $109=(($108+1)|0);
      $arg=$109;
      __label__ = 1; break;
    case 25: // $110
      $1=1;
      __label__ = 26; break;
    case 26: // $111
      var $112=$1;
      ;
      return $112;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options18parse_command_lineEiPPciR7astring["X"]=1;

function __ZN12core_options14parse_ini_fileER10_core_fileiiR7astring($this, $inifile, $priority, $ignore_priority, $error_string) {
  var __stackBase__  = STACKTOP; STACKTOP += 4096; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $buffer=__stackBase__;
      var $optionname;
      var $temp;
      var $optiondata;
      var $inquotes;
      var $curentry;
      $1=$this;
      $2=$inifile;
      $3=$priority;
      $4=$ignore_priority;
      $5=$error_string;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      var $8=(($buffer)|0);
      var $9=$2;
      var $10=__Z10core_fgetsPciP10_core_file($8, 4096, $9);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 33; break; }
    case 2: // $12
      var $13=(($buffer)|0);
      $optionname=$13;
      __label__ = 3; break;
    case 3: // $14
      var $15=$optionname;
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $19
      var $20=$optionname;
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=_isspace($22);
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $25
      __label__ = 8; break;
    case 6: // $26
      __label__ = 7; break;
    case 7: // $27
      var $28=$optionname;
      var $29=(($28+1)|0);
      $optionname=$29;
      __label__ = 3; break;
    case 8: // $30
      var $31=$optionname;
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $35
      var $36=$optionname;
      var $37=HEAP8[($36)];
      var $38=(($37 << 24) >> 24);
      var $39=(($38)|0)==35;
      if ($39) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $40
      __label__ = 1; break;
    case 11: // $41
      var $42=$optionname;
      $temp=$42;
      __label__ = 12; break;
    case 12: // $43
      var $44=$temp;
      var $45=HEAP8[($44)];
      var $46=(($45 << 24) >> 24);
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $48
      var $49=$temp;
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=_isspace($51);
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $54
      __label__ = 17; break;
    case 15: // $55
      __label__ = 16; break;
    case 16: // $56
      var $57=$temp;
      var $58=(($57+1)|0);
      $temp=$58;
      __label__ = 12; break;
    case 17: // $59
      var $60=$temp;
      var $61=HEAP8[($60)];
      var $62=(($61 << 24) >> 24);
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $64
      var $65=$5;
      var $66=(($buffer)|0);
      var $67=__ZN7astring9catprintfEPKcz($65, ((STRING_TABLE.__str227296)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$66,tempInt));
      __label__ = 1; break;
    case 19: // $68
      var $69=$temp;
      var $70=(($69+1)|0);
      $temp=$70;
      HEAP8[($69)]=0;
      var $71=$temp;
      $optiondata=$71;
      $inquotes=0;
      var $72=$optiondata;
      $temp=$72;
      __label__ = 20; break;
    case 20: // $73
      var $74=$temp;
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24);
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $78
      var $79=$temp;
      var $80=HEAP8[($79)];
      var $81=(($80 << 24) >> 24);
      var $82=(($81)|0)==34;
      if ($82) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $83
      var $84=$inquotes;
      var $85=(($84) & 1);
      var $86=$85 ^ 1;
      var $87=(($86)&1);
      $inquotes=$87;
      __label__ = 23; break;
    case 23: // $88
      var $89=$temp;
      var $90=HEAP8[($89)];
      var $91=(($90 << 24) >> 24);
      var $92=(($91)|0)==35;
      if ($92) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $93
      var $94=$inquotes;
      var $95=(($94) & 1);
      if ($95) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $96
      __label__ = 28; break;
    case 26: // $97
      __label__ = 27; break;
    case 27: // $98
      var $99=$temp;
      var $100=(($99+1)|0);
      $temp=$100;
      __label__ = 20; break;
    case 28: // $101
      var $102=$temp;
      HEAP8[($102)]=0;
      var $103=(($6+12)|0);
      var $104=$optionname;
      var $105=__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($103, $104);
      $curentry=$105;
      var $106=$curentry;
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 29; break; } else { __label__ = 32; break; }
    case 29: // $108
      var $109=$3;
      var $110=$4;
      var $111=(($109)|0) >= (($110)|0);
      if ($111) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $112
      var $113=$5;
      var $114=$optionname;
      var $115=__ZN7astring9catprintfEPKcz($113, ((STRING_TABLE.__str237297)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$114,tempInt));
      __label__ = 31; break;
    case 31: // $116
      __label__ = 1; break;
    case 32: // $117
      var $118=$curentry;
      var $119=$optiondata;
      var $120=$3;
      var $121=$5;
      var $122=__ZN12core_options21validate_and_set_dataERNS_5entryEPKciR7astring($6, $118, $119, $120, $121);
      __label__ = 1; break;
    case 33: // $123
      STACKTOP = __stackBase__;
      return 1;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options14parse_ini_fileER10_core_fileiiR7astring["X"]=1;

function __ZN12core_options6revertEi($this, $priority) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curentry;
      $1=$this;
      $2=$priority;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      $curentry=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$curentry;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $9
      var $10=$curentry;
      var $11=$2;
      __ZN12core_options5entry6revertEi($10, $11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$curentry;
      var $14=__ZNK12core_options5entry4nextEv($13);
      $curentry=$14;
      __label__ = 1; break;
    case 4: // $15
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options12append_entryERNS_5entryE($this, $newentry) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tempstr=__stackBase__;
      var $name;
      var $3;
      var $4;
      $1=$this;
      $2=$newentry;
      var $5=$1;
      var $6=$2;
      var $7=(($5+8)|0);
      var $8=HEAP32[(($7)>>2)];
      HEAP32[(($8)>>2)]=$6;
      var $9=$2;
      var $10=(($9)|0);
      var $11=(($5+8)|0);
      HEAP32[(($11)>>2)]=$10;
      __ZN7astringC1Ev($tempstr);
      $name=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$name;
      var $14=(($13)>>>0) < 4;
      if ($14) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $15
      var $16=$name;
      var $17=$2;
      var $18=(($17+24)|0);
      var $19=(($18+($16<<6))|0);
      var $20=(function() { try { __THREW__ = false; return __ZN7astringcvbEv($19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; };
    case 3: // $21
      if ($20) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $22
      var $23=(($5+12)|0);
      var $24=$name;
      var $25=$2;
      var $26=(($25+24)|0);
      var $27=(($26+($24<<6))|0);
      var $28=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($27) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 13; break; };
    case 5: // $29
      var $30=$2;
      var $31=(function() { try { __THREW__ = false; return __ZN8tagmap_tIPN12core_options5entryEE3addEPKcS2_b($23, $28, $30, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 13; break; };
    case 6: // $32
      var $33=$2;
      var $34=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4typeEv($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $35
      var $36=(($34)|0)==3;
      if ($36) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $37
      var $38=(($5+12)|0);
      var $39=(function() { try { __THREW__ = false; return __ZN7astring3cpyEPKc($tempstr, ((STRING_TABLE.__str187292)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $40
      var $41=$name;
      var $42=$2;
      var $43=(($42+24)|0);
      var $44=(($43+($41<<6))|0);
      var $45=(function() { try { __THREW__ = false; return __ZN7astring3catERKS_($39, $44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; };
    case 10: // $46
      var $47=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($45) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $48
      var $49=$2;
      var $50=(function() { try { __THREW__ = false; return __ZN8tagmap_tIPN12core_options5entryEE3addEPKcS2_b($38, $47, $49, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; };
    case 12: // $51
      __label__ = 14; break;
    case 13: // $52
      var $53=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $54=$53.f0;
      $3=$54;
      var $55=$53.f1;
      $4=$55;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 14: // $56
      __label__ = 15; break;
    case 15: // $57
      __label__ = 16; break;
    case 16: // $58
      var $59=$name;
      var $60=(($59+1)|0);
      $name=$60;
      __label__ = 1; break;
    case 17: // $61
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      STACKTOP = __stackBase__;
      return;
    case 18: // $62
      __label__ = 19; break;
    case 19: // $63
      var $64=$3;
      var $65=$3;
      var $66=$4;
      var $67=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $65, tempValue);
      var $68=($67.f1 = $66, $67);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $69
      var $70=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options12append_entryERNS_5entryE["X"]=1;

function __ZN12core_options21validate_and_set_dataERNS_5entryEPKciR7astring($this, $curentry, $newdata, $priority, $error_string) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $data=__stackBase__;
      var $7;
      var $8;
      var $fval=__stackBase__+64;
      var $ival=__stackBase__+68;
      var $9;
      $2=$this;
      $3=$curentry;
      $4=$newdata;
      $5=$priority;
      $6=$error_string;
      var $10=$2;
      var $11=$4;
      __ZN7astringC1EPKc($data, $11);
      var $12=(function() { try { __THREW__ = false; return __ZN7astring9trimspaceEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 10; break; };
    case 1: // $13
      var $14=(function() { try { __THREW__ = false; return __ZNK7astring3chrEii($data, 0, 34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 10; break; };
    case 2: // $15
      var $16=(($14)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $17
      var $18=(function() { try { __THREW__ = false; return __ZNK7astring4rchrEii($data, 0, 34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $19
      var $20=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; };
    case 5: // $21
      var $22=(($20-1)|0);
      var $23=(($18)|0)==(($22)|0);
      if ($23) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $24
      var $25=(function() { try { __THREW__ = false; return __ZN7astring3delEii($data, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $26
      var $27=(function() { try { __THREW__ = false; return __ZNK7astring3lenEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $28
      var $29=(($27-1)|0);
      var $30=(function() { try { __THREW__ = false; return __ZN7astring3delEii($data, $29, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; };
    case 9: // $31
      __label__ = 11; break;
    case 10: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $7=$34;
      var $35=$33.f1;
      $8=$35;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 82; break; }
    case 11: // $36
      var $37=$3;
      var $38=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4typeEv($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 10; break; };
    case 12: // $39
      if ($38 == 3) {
        __label__ = 13; break;
      }
      else if ($38 == 4) {
        __label__ = 24; break;
      }
      else if ($38 == 5) {
        __label__ = 48; break;
      }
      else if ($38 == 6) {
        __label__ = 76; break;
      }
      else if ($38 == 0 || $38 == 1) {
        __label__ = 72; break;
      }
      else {
      __label__ = 73; break;
      }
      
    case 13: // $40
      var $41=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 10; break; };
    case 14: // $42
      var $43=(function() { try { __THREW__ = false; return _sscanf($41, ((STRING_TABLE.__str307304)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$ival,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 10; break; };
    case 15: // $44
      var $45=(($43)|0)!=1;
      if ($45) { __label__ = 18; break; } else { __label__ = 16; break; }
    case 16: // $46
      var $47=HEAP32[(($ival)>>2)];
      var $48=(($47)|0) < 0;
      if ($48) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $49
      var $50=HEAP32[(($ival)>>2)];
      var $51=(($50)|0) > 1;
      if ($51) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $52
      var $53=$6;
      var $54=$3;
      var $55=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4nameEv($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 10; break; };
    case 19: // $56
      var $57=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 10; break; };
    case 20: // $58
      var $59=$3;
      var $60=(function() { try { __THREW__ = false; return __ZNK12core_options5entry5valueEv($59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 10; break; };
    case 21: // $61
      var $62=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($53, ((STRING_TABLE.__str327306)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$55,HEAP32[((tempInt+4)>>2)]=$57,HEAP32[((tempInt+8)>>2)]=$60,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 10; break; };
    case 22: // $63
      $1=0;
      $9=1;
      __label__ = 79; break;
    case 23: // $64
      __label__ = 76; break;
    case 24: // $65
      var $66=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 10; break; };
    case 25: // $67
      var $68=(function() { try { __THREW__ = false; return _sscanf($66, ((STRING_TABLE.__str307304)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$ival,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 10; break; };
    case 26: // $69
      var $70=(($68)|0)!=1;
      if ($70) { __label__ = 27; break; } else { __label__ = 32; break; }
    case 27: // $71
      var $72=$6;
      var $73=$3;
      var $74=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4nameEv($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 10; break; };
    case 28: // $75
      var $76=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 10; break; };
    case 29: // $77
      var $78=$3;
      var $79=(function() { try { __THREW__ = false; return __ZNK12core_options5entry5valueEv($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 10; break; };
    case 30: // $80
      var $81=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($72, ((STRING_TABLE.__str337307)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$74,HEAP32[((tempInt+4)>>2)]=$76,HEAP32[((tempInt+8)>>2)]=$79,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 10; break; };
    case 31: // $82
      $1=0;
      $9=1;
      __label__ = 79; break;
    case 32: // $83
      var $84=$3;
      var $85=(function() { try { __THREW__ = false; return __ZNK12core_options5entry9has_rangeEv($84) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 10; break; };
    case 33: // $86
      if ($85) { __label__ = 34; break; } else { __label__ = 47; break; }
    case 34: // $87
      var $88=HEAP32[(($ival)>>2)];
      var $89=$3;
      var $90=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7minimumEv($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 10; break; };
    case 35: // $91
      var $92=(function() { try { __THREW__ = false; return _atoi($90) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 10; break; };
    case 36: // $93
      var $94=(($88)|0) < (($92)|0);
      if ($94) { __label__ = 40; break; } else { __label__ = 37; break; }
    case 37: // $95
      var $96=HEAP32[(($ival)>>2)];
      var $97=$3;
      var $98=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7maximumEv($97) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 10; break; };
    case 38: // $99
      var $100=(function() { try { __THREW__ = false; return _atoi($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 10; break; };
    case 39: // $101
      var $102=(($96)|0) > (($100)|0);
      if ($102) { __label__ = 40; break; } else { __label__ = 47; break; }
    case 40: // $103
      var $104=$6;
      var $105=$3;
      var $106=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4nameEv($105) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 10; break; };
    case 41: // $107
      var $108=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 10; break; };
    case 42: // $109
      var $110=$3;
      var $111=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7minimumEv($110) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 10; break; };
    case 43: // $112
      var $113=$3;
      var $114=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7maximumEv($113) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 10; break; };
    case 44: // $115
      var $116=$3;
      var $117=(function() { try { __THREW__ = false; return __ZNK12core_options5entry5valueEv($116) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 10; break; };
    case 45: // $118
      var $119=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($104, ((STRING_TABLE.__str347308)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$106,HEAP32[((tempInt+4)>>2)]=$108,HEAP32[((tempInt+8)>>2)]=$111,HEAP32[((tempInt+12)>>2)]=$114,HEAP32[((tempInt+16)>>2)]=$117,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 10; break; };
    case 46: // $120
      $1=0;
      $9=1;
      __label__ = 79; break;
    case 47: // $121
      __label__ = 76; break;
    case 48: // $122
      var $123=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 10; break; };
    case 49: // $124
      var $125=(function() { try { __THREW__ = false; return _sscanf($123, ((STRING_TABLE.__str317305)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$fval,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 10; break; };
    case 50: // $126
      var $127=(($125)|0)!=1;
      if ($127) { __label__ = 51; break; } else { __label__ = 56; break; }
    case 51: // $128
      var $129=$6;
      var $130=$3;
      var $131=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4nameEv($130) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 10; break; };
    case 52: // $132
      var $133=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 10; break; };
    case 53: // $134
      var $135=$3;
      var $136=(function() { try { __THREW__ = false; return __ZNK12core_options5entry5valueEv($135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 10; break; };
    case 54: // $137
      var $138=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($129, ((STRING_TABLE.__str357309)|0), (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$131,HEAP32[((tempInt+4)>>2)]=$133,HEAP32[((tempInt+8)>>2)]=$136,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 10; break; };
    case 55: // $139
      $1=0;
      $9=1;
      __label__ = 79; break;
    case 56: // $140
      var $141=$3;
      var $142=(function() { try { __THREW__ = false; return __ZNK12core_options5entry9has_rangeEv($141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 10; break; };
    case 57: // $143
      if ($142) { __label__ = 58; break; } else { __label__ = 71; break; }
    case 58: // $144
      var $145=HEAPF32[(($fval)>>2)];
      var $146=$145;
      var $147=$3;
      var $148=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7minimumEv($147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 10; break; };
    case 59: // $149
      var $150=(function() { try { __THREW__ = false; return _atof($148) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 10; break; };
    case 60: // $151
      var $152=$146 < $150;
      if ($152) { __label__ = 64; break; } else { __label__ = 61; break; }
    case 61: // $153
      var $154=HEAPF32[(($fval)>>2)];
      var $155=$154;
      var $156=$3;
      var $157=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7maximumEv($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 10; break; };
    case 62: // $158
      var $159=(function() { try { __THREW__ = false; return _atof($157) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 10; break; };
    case 63: // $160
      var $161=$155 > $159;
      if ($161) { __label__ = 64; break; } else { __label__ = 71; break; }
    case 64: // $162
      var $163=$6;
      var $164=$3;
      var $165=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4nameEv($164) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 10; break; };
    case 65: // $166
      var $167=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 10; break; };
    case 66: // $168
      var $169=$3;
      var $170=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7minimumEv($169) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 67; break; } else { __label__ = 10; break; };
    case 67: // $171
      var $172=$3;
      var $173=(function() { try { __THREW__ = false; return __ZNK12core_options5entry7maximumEv($172) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 10; break; };
    case 68: // $174
      var $175=$3;
      var $176=(function() { try { __THREW__ = false; return __ZNK12core_options5entry5valueEv($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 10; break; };
    case 69: // $177
      var $178=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($163, ((STRING_TABLE.__str367310)|0), (tempInt=STACKTOP,STACKTOP += 20,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$165,HEAP32[((tempInt+4)>>2)]=$167,HEAP32[((tempInt+8)>>2)]=$170,HEAP32[((tempInt+12)>>2)]=$173,HEAP32[((tempInt+16)>>2)]=$176,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 10; break; };
    case 70: // $179
      $1=0;
      $9=1;
      __label__ = 79; break;
    case 71: // $180
      __label__ = 76; break;
    case 72: // $181
      __label__ = 73; break;
    case 73: // $182
      var $183=$6;
      var $184=$3;
      var $185=(function() { try { __THREW__ = false; return __ZNK12core_options5entry4nameEv($184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 10; break; };
    case 74: // $186
      var $187=(function() { try { __THREW__ = false; return __ZN7astring9catprintfEPKcz($183, ((STRING_TABLE.__str377311)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$185,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 10; break; };
    case 75: // $188
      $1=0;
      $9=1;
      __label__ = 79; break;
    case 76: // $189
      var $190=$3;
      var $191=(function() { try { __THREW__ = false; return __ZNK7astringcvPKcEv($data) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 10; break; };
    case 77: // $192
      var $193=$5;
      (function() { try { __THREW__ = false; return __ZN12core_options5entry9set_valueEPKci($190, $191, $193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 10; break; }
    case 78: // $194
      $1=1;
      $9=1;
      __label__ = 79; break;
    case 79: // $195
      FUNCTION_TABLE[__ZN7astringD1Ev]($data);
      var $196=$1;
      STACKTOP = __stackBase__;
      return $196;
    case 80: // $197
      __label__ = 81; break;
    case 81: // $198
      var $199=$7;
      var $200=$7;
      var $201=$8;
      var $202=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $200, tempValue);
      var $203=($202.f1 = $201, $202);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 82: // $204
      var $205=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options21validate_and_set_dataERNS_5entryEPKciR7astring["X"]=1;

function __ZNK12core_options5entry11descriptionEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+20)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12core_options5entry5seqidEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZL11tagmap_hashPKc7342($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options10output_iniER7astringPKS_($this, $buffer, $diff) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $last_header;
      var $curentry;
      var $name;
      var $value;
      $1=$this;
      $2=$buffer;
      $3=$diff;
      var $4=$1;
      var $5=$2;
      var $6=__ZN7astring5resetEv($5);
      $last_header=0;
      var $7=(($4+4)|0);
      var $8=HEAP32[(($7)>>2)];
      $curentry=$8;
      __label__ = 1; break;
    case 1: // $9
      var $10=$curentry;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 17; break; }
    case 2: // $12
      var $13=$curentry;
      var $14=__ZNK12core_options5entry9is_headerEv($13);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$curentry;
      var $17=__ZNK12core_options5entry11descriptionEv($16);
      $last_header=$17;
      __label__ = 15; break;
    case 4: // $18
      var $19=$curentry;
      var $20=__ZNK12core_options5entry10is_commandEv($19);
      if ($20) { __label__ = 14; break; } else { __label__ = 5; break; }
    case 5: // $21
      var $22=$curentry;
      var $23=__ZNK12core_options5entry4nameEv($22);
      $name=$23;
      var $24=$curentry;
      var $25=__ZNK12core_options5entry5valueEv($24);
      $value=$25;
      var $26=$3;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $28
      var $29=$value;
      var $30=$3;
      var $31=$name;
      var $32=__ZNK12core_options5valueEPKc($30, $31);
      var $33=_strcmp($29, $32);
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $35
      var $36=$last_header;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $38
      var $39=$2;
      var $40=$last_header;
      var $41=__ZN7astring9catprintfEPKcz($39, ((STRING_TABLE.__str247298)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$40,tempInt));
      $last_header=0;
      __label__ = 9; break;
    case 9: // $42
      var $43=$value;
      var $44=_strchr($43, 32);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $46
      var $47=$2;
      var $48=$name;
      var $49=$value;
      var $50=__ZN7astring9catprintfEPKcz($47, ((STRING_TABLE.__str257299)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$48,HEAP32[((tempInt+4)>>2)]=$49,tempInt));
      __label__ = 12; break;
    case 11: // $51
      var $52=$2;
      var $53=$name;
      var $54=$value;
      var $55=__ZN7astring9catprintfEPKcz($52, ((STRING_TABLE.__str267300)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$53,HEAP32[((tempInt+4)>>2)]=$54,tempInt));
      __label__ = 12; break;
    case 12: // $56
      __label__ = 13; break;
    case 13: // $57
      __label__ = 14; break;
    case 14: // $58
      __label__ = 15; break;
    case 15: // $59
      __label__ = 16; break;
    case 16: // $60
      var $61=$curentry;
      var $62=__ZNK12core_options5entry4nextEv($61);
      $curentry=$62;
      __label__ = 1; break;
    case 17: // $63
      var $64=$2;
      var $65=__ZNK7astringcvPKcEv($64);
      ;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options10output_iniER7astringPKS_["X"]=1;

function __ZNK12core_options5entry10is_commandEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNK12core_options5entry4typeEv($2);
  var $4=(($3)|0)==2;
  ;
  return $4;
}


function __ZN12core_options11output_helpER7astring($this, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curentry;
      $1=$this;
      $2=$buffer;
      var $3=$1;
      var $4=$2;
      var $5=__ZN7astring5resetEv($4);
      var $6=(($3+4)|0);
      var $7=HEAP32[(($6)>>2)];
      $curentry=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$curentry;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $11
      var $12=$curentry;
      var $13=__ZNK12core_options5entry9is_headerEv($12);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      var $16=$curentry;
      var $17=__ZNK12core_options5entry11descriptionEv($16);
      var $18=__ZN7astring9catprintfEPKcz($15, ((STRING_TABLE.__str247298)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$17,tempInt));
      __label__ = 7; break;
    case 4: // $19
      var $20=$curentry;
      var $21=__ZNK12core_options5entry11descriptionEv($20);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$2;
      var $25=$curentry;
      var $26=__ZNK12core_options5entry4nameEv($25);
      var $27=$curentry;
      var $28=__ZNK12core_options5entry11descriptionEv($27);
      var $29=__ZN7astring9catprintfEPKcz($24, ((STRING_TABLE.__str277301)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$26,HEAP32[((tempInt+4)>>2)]=$28,tempInt));
      __label__ = 6; break;
    case 6: // $30
      __label__ = 7; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      var $33=$curentry;
      var $34=__ZNK12core_options5entry4nextEv($33);
      $curentry=$34;
      __label__ = 1; break;
    case 9: // $35
      var $36=$2;
      var $37=__ZNK7astringcvPKcEv($36);
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12core_options5seqidEPKc($this, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $curentry;
      $1=$this;
      $2=$name;
      var $3=$1;
      var $4=(($3+12)|0);
      var $5=$2;
      var $6=__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($4, $5);
      $curentry=$6;
      var $7=$curentry;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$curentry;
      var $11=__ZNK12core_options5entry5seqidEv($10);
      var $14 = $11;__label__ = 3; break;
    case 2: // $12
      var $14 = 0;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options9set_valueEPKcS1_iR7astring($this, $name, $value, $priority, $error_string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $curentry;
      $2=$this;
      $3=$name;
      $4=$value;
      $5=$priority;
      $6=$error_string;
      var $7=$2;
      var $8=(($7+12)|0);
      var $9=$3;
      var $10=__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc($8, $9);
      $curentry=$10;
      var $11=$curentry;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$6;
      var $15=$3;
      var $16=__ZN7astring9catprintfEPKcz($14, ((STRING_TABLE.__str297303)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$15,tempInt));
      $1=0;
      __label__ = 3; break;
    case 2: // $17
      var $18=$curentry;
      var $19=$4;
      var $20=$5;
      var $21=$6;
      var $22=__ZN12core_options21validate_and_set_dataERNS_5entryEPKciR7astring($7, $18, $19, $20, $21);
      $1=$22;
      __label__ = 3; break;
    case 3: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIPN12core_options5entryEE5resetEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __Z12tagmap_resetP7_tagmap($3);
  ;
  return;
}


function __ZN8tagmap_tIPN12core_options5entryEE3addEPKcS2_b($this, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$tag;
  $3=$object;
  var $5=(($replace_if_duplicate)&1);
  $4=$5;
  var $6=$1;
  var $7=$6;
  var $8=$2;
  var $9=$3;
  var $10=$9;
  var $11=$4;
  var $12=(($11) & 1);
  var $13=(($12)&1);
  var $14=__Z10tagmap_addP7_tagmapPKcPvh($7, $8, $10, $13);
  ;
  return $14;
}


function __ZN8tagmap_tIPN12core_options5entryEE6removeEPKc($this, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$tag;
  var $3=$1;
  var $4=$3;
  var $5=$2;
  __Z13tagmap_removeP7_tagmapPKc($4, $5);
  ;
  return;
}


function __ZNK12core_options5entry9has_rangeEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+408)|0);
      var $4=__ZNK7astringcvbEv($3);
      if ($4) { __label__ = 1; break; } else { var $9 = 0;__label__ = 2; break; }
    case 1: // $5
      var $6=(($2+472)|0);
      var $7=__ZNK7astringcvbEv($6);
      var $9 = $7;__label__ = 2; break;
    case 2: // $8
      var $9;
      ;
      return $9;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK12core_options5entry7minimumEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+408)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZNK12core_options5entry7maximumEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+472)|0);
  var $4=__ZNK7astringcvPKcEv($3);
  ;
  return $4;
}


function __ZL11tagmap_findPK7_tagmapPKc7340($map, $tag) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$map;
  $2=$tag;
  var $3=$1;
  var $4=$2;
  var $5=$2;
  var $6=__ZL11tagmap_hashPKc7342($5);
  var $7=__ZL21tagmap_find_prehashedPK7_tagmapPKcj7341($3, $4, $6);
  ;
  return $7;
}


function __ZL21tagmap_find_prehashedPK7_tagmapPKcj7341($map, $tag, $fullhash) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $entry;
      $2=$map;
      $3=$tag;
      $4=$fullhash;
      var $5=$4;
      var $6=(($5)>>>0)%97;
      var $7=$2;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      $entry=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $14
      var $15=$entry;
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$4;
      var $19=(($17)|0)==(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $20
      var $21=$entry;
      var $22=(($21+12)|0);
      var $23=(($22)|0);
      var $24=$3;
      var $25=_strcmp($23, $24);
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      var $28=$entry;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      $1=$30;
      __label__ = 8; break;
    case 5: // $31
      __label__ = 6; break;
    case 6: // $32
      var $33=$entry;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      $entry=$35;
      __label__ = 1; break;
    case 7: // $36
      $1=0;
      __label__ = 8; break;
    case 8: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN8tagmap_tIPN12core_options5entryEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZN8tagmap_tIPN12core_options5entryEE5resetEv($2);
  ;
  return;
}


function __ZN8tagmap_tIPN12core_options5entryEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$2;
  var $5=(($4)|0);
  var $6=(($5)|0);
  var $7=$6;
  _memset($7, 0, 388, 1);
  ;
  return;
}


function __ZL15zlib_codec_initP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $data;
      var $err;
      var $zerr;
      $2=$chd;
      var $3=_malloc(368);
      var $4=$3;
      $data=$4;
      var $5=$data;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=2;
      __label__ = 14; break;
    case 2: // $8
      var $9=$data;
      var $10=$9;
      _memset($10, 0, 368, 1);
      var $11=$data;
      var $12=$11;
      var $13=$data;
      var $14=(($13)|0);
      var $15=(($14)|0);
      HEAP32[(($15)>>2)]=$12;
      var $16=$data;
      var $17=(($16)|0);
      var $18=(($17+4)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=$data;
      var $20=(($19)|0);
      var $21=(($20+32)|0);
      HEAP32[(($21)>>2)]=1482;
      var $22=$data;
      var $23=(($22)|0);
      var $24=(($23+36)|0);
      HEAP32[(($24)>>2)]=1484;
      var $25=$data;
      var $26=$25;
      var $27=$data;
      var $28=(($27)|0);
      var $29=(($28+40)|0);
      HEAP32[(($29)>>2)]=$26;
      var $30=$data;
      var $31=(($30)|0);
      var $32=_inflateInit2_($31, -15, ((STRING_TABLE.__str367379)|0), 56);
      $zerr=$32;
      var $33=$zerr;
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $35
      var $36=$data;
      var $37=$36;
      var $38=$data;
      var $39=(($38+56)|0);
      var $40=(($39)|0);
      HEAP32[(($40)>>2)]=$37;
      var $41=$data;
      var $42=(($41+56)|0);
      var $43=(($42+4)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=$data;
      var $45=(($44+56)|0);
      var $46=(($45+32)|0);
      HEAP32[(($46)>>2)]=1482;
      var $47=$data;
      var $48=(($47+56)|0);
      var $49=(($48+36)|0);
      HEAP32[(($49)>>2)]=1484;
      var $50=$data;
      var $51=$50;
      var $52=$data;
      var $53=(($52+56)|0);
      var $54=(($53+40)|0);
      HEAP32[(($54)>>2)]=$51;
      var $55=$data;
      var $56=(($55+56)|0);
      var $57=_deflateInit2_($56, 9, 8, -15, 8, 0, ((STRING_TABLE.__str367379)|0), 56);
      $zerr=$57;
      __label__ = 4; break;
    case 4: // $58
      var $59=$zerr;
      var $60=(($59)|0)==-4;
      if ($60) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $61
      $err=2;
      __label__ = 10; break;
    case 6: // $62
      var $63=$zerr;
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $65
      $err=11;
      __label__ = 9; break;
    case 8: // $66
      $err=0;
      __label__ = 9; break;
    case 9: // $67
      __label__ = 10; break;
    case 10: // $68
      var $69=$err;
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $71
      var $72=$data;
      var $73=$72;
      var $74=$2;
      var $75=(($74+192)|0);
      HEAP32[(($75)>>2)]=$73;
      __label__ = 13; break;
    case 12: // $76
      var $77=$data;
      var $78=$77;
      _free($78);
      __label__ = 13; break;
    case 13: // $79
      var $80=$err;
      $1=$80;
      __label__ = 14; break;
    case 14: // $81
      var $82=$1;
      ;
      return $82;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15zlib_codec_initP9_chd_file["X"]=1;

function __ZL15zlib_codec_freeP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $data;
      var $i;
      $1=$chd;
      var $2=$1;
      var $3=(($2+192)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4;
      $data=$5;
      var $6=$data;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $8
      var $9=$data;
      var $10=(($9)|0);
      var $11=_inflateEnd($10);
      var $12=$data;
      var $13=(($12+56)|0);
      var $14=_deflateEnd($13);
      $i=0;
      __label__ = 2; break;
    case 2: // $15
      var $16=$i;
      var $17=(($16)|0) < 64;
      if ($17) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $18
      var $19=$i;
      var $20=$data;
      var $21=(($20+112)|0);
      var $22=(($21+($19<<2))|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      var $26=$i;
      var $27=$data;
      var $28=(($27+112)|0);
      var $29=(($28+($26<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30;
      _free($31);
      __label__ = 5; break;
    case 5: // $32
      __label__ = 6; break;
    case 6: // $33
      var $34=$i;
      var $35=(($34+1)|0);
      $i=$35;
      __label__ = 2; break;
    case 7: // $36
      var $37=$data;
      var $38=$37;
      _free($38);
      __label__ = 8; break;
    case 8: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options9set_valueEPKciiR7astring($this, $name, $value, $priority, $error_string) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $tempstr=__stackBase__;
      var $7;
      var $8;
      var $9;
      $2=$this;
      $3=$name;
      $4=$value;
      $5=$priority;
      $6=$error_string;
      var $10=$2;
      __ZN7astringC1Ev($tempstr);
      var $11=$4;
      var $12=(function() { try { __THREW__ = false; return __ZN7astring6printfEPKcz($tempstr, ((STRING_TABLE.__str307304)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$11,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $13
      var $14=$3;
      var $15=(function() { try { __THREW__ = false; return __ZNK7astring4cstrEv($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; };
    case 2: // $16
      var $17=$5;
      var $18=$6;
      var $19=(function() { try { __THREW__ = false; return __ZN12core_options9set_valueEPKcS1_iR7astring($10, $14, $15, $17, $18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $20
      $1=$19;
      $9=1;
      FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr);
      var $21=$1;
      STACKTOP = __stackBase__;
      return $21;
    case 4: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $7=$24;
      var $25=$23.f1;
      $8=$25;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($tempstr) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $26
      __label__ = 6; break;
    case 6: // $27
      var $28=$7;
      var $29=$7;
      var $30=$8;
      var $31=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $29, tempValue);
      var $32=($31.f1 = $30, $31);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $33
      var $34=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12core_options5entryD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4+472)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($5) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $6
      var $7=(($4+408)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $8
      var $9=(($4+344)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($9) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $10
      var $11=(($4+280)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $12
      var $13=(($4+24)|0);
      var $14=(($13)|0);
      var $15=(($14+256)|0);
      var $17 = $15;__label__ = 5; break;
    case 5: // $16
      var $17;
      var $18=(($17-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $19
      var $20=(($18)|0)==(($14)|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      ;
      return;
    case 8: // $22
      var $23=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $24=$23.f0;
      $2=$24;
      var $25=$23.f1;
      $3=$25;
      var $26=(($4+408)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($26) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 26; break; }
    case 9: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $29=$28.f0;
      $2=$29;
      var $30=$28.f1;
      $3=$30;
      __label__ = 12; break;
    case 10: // $31
      __label__ = 12; break;
    case 11: // $32
      var $33=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $34=$33.f0;
      $2=$34;
      var $35=$33.f1;
      $3=$35;
      __label__ = 15; break;
    case 12: // $36
      var $37=(($4+344)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 26; break; }
    case 13: // $38
      __label__ = 15; break;
    case 14: // $39
      var $40=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $41=$40.f0;
      $2=$41;
      var $42=$40.f1;
      $3=$42;
      __label__ = 21; break;
    case 15: // $43
      var $44=(($4+280)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 26; break; }
    case 16: // $45
      __label__ = 21; break;
    case 17: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $2=$48;
      var $49=$47.f1;
      $3=$49;
      var $50=(($14)|0)==(($18)|0);
      if ($50) { __label__ = 20; break; } else { var $52 = $18;__label__ = 18; break; }
    case 18: // $51
      var $52;
      var $53=(($52-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $54
      var $55=(($53)|0)==(($14)|0);
      if ($55) { __label__ = 20; break; } else { var $52 = $53;__label__ = 18; break; }
    case 20: // $56
      __label__ = 25; break;
    case 21: // $57
      var $58=(($4+24)|0);
      var $59=(($58)|0);
      var $60=(($59+256)|0);
      var $62 = $60;__label__ = 22; break;
    case 22: // $61
      var $62;
      var $63=(($62-64)|0);
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN7astringD1Ev]($63) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $64
      var $65=(($63)|0)==(($59)|0);
      if ($65) { __label__ = 24; break; } else { var $62 = $63;__label__ = 22; break; }
    case 24: // $66
      __label__ = 25; break;
    case 25: // $67
      var $68=$2;
      var $69=$2;
      var $70=$3;
      var $71=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $69, tempValue);
      var $72=($71.f1 = $70, $71);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 26: // $73
      var $74=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZN12core_options5entryD2Ev["X"]=1;
// WARNING: content after a branch in a label, line: 691251
// WARNING: content after a branch in a label, line: 691275
// WARNING: content after a branch in a label, line: 691319
// WARNING: content after a branch in a label, line: 691359
// WARNING: content after a branch in a label, line: 691428
// WARNING: content after a branch in a label, line: 691444
// WARNING: content after a branch in a label, line: 691461
// WARNING: content after a branch in a label, line: 691483
// WARNING: content after a branch in a label, line: 691500

function __ZL19zlib_codec_compressP9_chd_filePKvPj($chd, $src, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $data;
      var $zerr;
      $2=$chd;
      $3=$src;
      $4=$length;
      var $5=$2;
      var $6=(($5+192)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      $data=$8;
      var $9=$3;
      var $10=$data;
      var $11=(($10+56)|0);
      var $12=(($11)|0);
      HEAP32[(($12)>>2)]=$9;
      var $13=$2;
      var $14=(($13+12)|0);
      var $15=(($14+16)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$data;
      var $18=(($17+56)|0);
      var $19=(($18+4)|0);
      HEAP32[(($19)>>2)]=$16;
      var $20=$data;
      var $21=(($20+56)|0);
      var $22=(($21+8)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=$2;
      var $24=(($23+184)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$data;
      var $27=(($26+56)|0);
      var $28=(($27+12)|0);
      HEAP32[(($28)>>2)]=$25;
      var $29=$2;
      var $30=(($29+12)|0);
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$data;
      var $34=(($33+56)|0);
      var $35=(($34+16)|0);
      HEAP32[(($35)>>2)]=$32;
      var $36=$data;
      var $37=(($36+56)|0);
      var $38=(($37+20)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=$data;
      var $40=(($39+56)|0);
      var $41=_deflateReset($40);
      $zerr=$41;
      var $42=$zerr;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $44
      $1=15;
      __label__ = 6; break;
    case 2: // $45
      var $46=$data;
      var $47=(($46+56)|0);
      var $48=_deflate($47, 4);
      $zerr=$48;
      var $49=$zerr;
      var $50=(($49)|0)!=1;
      if ($50) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $51
      var $52=$data;
      var $53=(($52+56)|0);
      var $54=(($53+20)|0);
      var $55=HEAPU32[(($54)>>2)];
      var $56=$2;
      var $57=(($56+12)|0);
      var $58=(($57+16)|0);
      var $59=HEAPU32[(($58)>>2)];
      var $60=(($55)>>>0) >= (($59)>>>0);
      if ($60) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $61
      $1=15;
      __label__ = 6; break;
    case 5: // $62
      var $63=$data;
      var $64=(($63+56)|0);
      var $65=(($64+20)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$4;
      HEAP32[(($67)>>2)]=$66;
      $1=0;
      __label__ = 6; break;
    case 6: // $68
      var $69=$1;
      ;
      return $69;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19zlib_codec_compressP9_chd_filePKvPj["X"]=1;

function __ZL21zlib_codec_decompressP9_chd_filejPv($chd, $srclength, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $data;
      var $zerr;
      $2=$chd;
      $3=$srclength;
      $4=$dest;
      var $5=$2;
      var $6=(($5+192)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      $data=$8;
      var $9=$2;
      var $10=(($9+184)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$data;
      var $13=(($12)|0);
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=$11;
      var $15=$3;
      var $16=$data;
      var $17=(($16)|0);
      var $18=(($17+4)|0);
      HEAP32[(($18)>>2)]=$15;
      var $19=$data;
      var $20=(($19)|0);
      var $21=(($20+8)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=$4;
      var $23=$data;
      var $24=(($23)|0);
      var $25=(($24+12)|0);
      HEAP32[(($25)>>2)]=$22;
      var $26=$2;
      var $27=(($26+12)|0);
      var $28=(($27+16)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$data;
      var $31=(($30)|0);
      var $32=(($31+16)|0);
      HEAP32[(($32)>>2)]=$29;
      var $33=$data;
      var $34=(($33)|0);
      var $35=(($34+20)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=$data;
      var $37=(($36)|0);
      var $38=_inflateReset($37);
      $zerr=$38;
      var $39=$zerr;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $41
      $1=14;
      __label__ = 5; break;
    case 2: // $42
      var $43=$data;
      var $44=(($43)|0);
      var $45=_inflate($44, 4);
      $zerr=$45;
      var $46=$data;
      var $47=(($46)|0);
      var $48=(($47+20)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$2;
      var $51=(($50+12)|0);
      var $52=(($51+16)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($49)|0)!=(($53)|0);
      if ($54) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $55
      $1=14;
      __label__ = 5; break;
    case 4: // $56
      $1=0;
      __label__ = 5; break;
    case 5: // $57
      var $58=$1;
      ;
      return $58;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21zlib_codec_decompressP9_chd_filejPv["X"]=1;

function __ZL13av_codec_initP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $data;
      $2=$chd;
      var $3=_malloc(176);
      var $4=$3;
      $data=$4;
      var $5=$data;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=2;
      __label__ = 3; break;
    case 2: // $8
      var $9=$data;
      var $10=$9;
      _memset($10, 0, 176, 1);
      var $11=$data;
      var $12=$11;
      var $13=$2;
      var $14=(($13+192)|0);
      HEAP32[(($14)>>2)]=$12;
      var $15=$2;
      var $16=__ZL17av_codec_postinitP9_chd_file($15);
      $1=0;
      __label__ = 3; break;
    case 3: // $17
      var $18=$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13av_codec_freeP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $data;
      $1=$chd;
      var $2=$1;
      var $3=(($2+192)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4;
      $data=$5;
      var $6=$data;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$data;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$data;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      __Z11avcomp_freeP13_avcomp_state($16);
      __label__ = 3; break;
    case 3: // $17
      var $18=$data;
      var $19=$18;
      _free($19);
      __label__ = 4; break;
    case 4: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17av_codec_compressP9_chd_filePKvPj($chd, $src, $length) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $data;
      var $averr;
      var $size;
      var $chderr;
      $2=$chd;
      $3=$src;
      $4=$length;
      var $5=$2;
      var $6=(($5+192)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      $data=$8;
      var $9=$data;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $13
      var $14=$2;
      var $15=__ZL17av_codec_postinitP9_chd_file($14);
      $chderr=$15;
      var $16=$chderr;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$chderr;
      $1=$19;
      __label__ = 15; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$3;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $24
      var $25=$3;
      var $26=__ZL16av_raw_data_sizePKh($25);
      $size=$26;
      __label__ = 6; break;
    case 6: // $27
      var $28=$size;
      var $29=$2;
      var $30=(($29+12)|0);
      var $31=(($30+16)|0);
      var $32=HEAPU32[(($31)>>2)];
      var $33=(($28)>>>0) < (($32)>>>0);
      if ($33) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $34
      var $35=$size;
      var $36=(($35+1)|0);
      $size=$36;
      var $37=$3;
      var $38=(($37+$35)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      $1=5;
      __label__ = 15; break;
    case 9: // $43
      __label__ = 6; break;
    case 10: // $44
      __label__ = 11; break;
    case 11: // $45
      var $46=$data;
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$3;
      var $50=$2;
      var $51=(($50+184)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$4;
      var $54=__Z18avcomp_encode_dataP13_avcomp_statePKhPhPj($48, $49, $52, $53);
      $averr=$54;
      var $55=$averr;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $57
      var $58=$4;
      var $59=HEAPU32[(($58)>>2)];
      var $60=$2;
      var $61=(($60+12)|0);
      var $62=(($61+16)|0);
      var $63=HEAPU32[(($62)>>2)];
      var $64=(($59)>>>0) > (($63)>>>0);
      if ($64) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $65
      $1=15;
      __label__ = 15; break;
    case 14: // $66
      $1=0;
      __label__ = 15; break;
    case 15: // $67
      var $68=$1;
      ;
      return $68;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17av_codec_compressP9_chd_filePKvPj["X"]=1;

function __ZL19av_codec_decompressP9_chd_filejPv($chd, $srclength, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $data;
      var $source;
      var $averr;
      var $size;
      var $chderr;
      $2=$chd;
      $3=$srclength;
      $4=$dest;
      var $5=$2;
      var $6=(($5+192)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      $data=$8;
      var $9=$data;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $13
      var $14=$2;
      var $15=__ZL17av_codec_postinitP9_chd_file($14);
      $chderr=$15;
      var $16=$chderr;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=$chderr;
      $1=$19;
      __label__ = 12; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      var $22=$2;
      var $23=(($22+184)|0);
      var $24=HEAP32[(($23)>>2)];
      $source=$24;
      var $25=$data;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$source;
      var $29=$3;
      var $30=$4;
      var $31=__Z18avcomp_decode_dataP13_avcomp_statePKhjPh($27, $28, $29, $30);
      $averr=$31;
      var $32=$averr;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      $1=14;
      __label__ = 12; break;
    case 6: // $35
      var $36=$4;
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $38
      var $39=$4;
      var $40=__ZL16av_raw_data_sizePKh($39);
      $size=$40;
      __label__ = 8; break;
    case 8: // $41
      var $42=$size;
      var $43=$2;
      var $44=(($43+12)|0);
      var $45=(($44+16)|0);
      var $46=HEAPU32[(($45)>>2)];
      var $47=(($42)>>>0) < (($46)>>>0);
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      var $49=$size;
      var $50=(($49+1)|0);
      $size=$50;
      var $51=$4;
      var $52=(($51+$49)|0);
      HEAP8[($52)]=0;
      __label__ = 8; break;
    case 10: // $53
      __label__ = 11; break;
    case 11: // $54
      $1=0;
      __label__ = 12; break;
    case 12: // $55
      var $56=$1;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19av_codec_decompressP9_chd_filejPv["X"]=1;

function __ZL15av_codec_configP9_chd_fileiPv($chd, $param, $config) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $data;
      $2=$chd;
      $3=$param;
      $4=$config;
      var $5=$2;
      var $6=(($5+192)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7;
      $data=$8;
      var $9=$3;
      var $10=(($9)|0)==1;
      if ($10) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $11
      var $12=$data;
      var $13=(($12+4)|0);
      var $14=$4;
      var $15=$14;
      var $16=$13;
      var $17=$15;
      assert(84 % 1 === 0, 'memcpy given ' + 84 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $17>>2, $$dest = $16>>2, $$stop = $$src + 21; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $18=$data;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $22
      var $23=$data;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$data;
      var $27=(($26+4)|0);
      __Z22avcomp_config_compressP13_avcomp_statePK25_av_codec_compress_config($25, $27);
      __label__ = 3; break;
    case 3: // $28
      $1=0;
      __label__ = 10; break;
    case 4: // $29
      var $30=$3;
      var $31=(($30)|0)==2;
      if ($31) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $32
      var $33=$data;
      var $34=(($33+88)|0);
      var $35=$4;
      var $36=$35;
      var $37=$34;
      var $38=$36;
      assert(88 % 1 === 0, 'memcpy given ' + 88 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $38>>2, $$dest = $37>>2, $$stop = $$src + 22; $$src < $$stop; $$src++, $$dest++) {
        HEAP32[$$dest] = HEAP32[$$src]
      };
      var $39=$data;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $43
      var $44=$data;
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$data;
      var $48=(($47+88)|0);
      __Z24avcomp_config_decompressP13_avcomp_statePK27_av_codec_decompress_config($46, $48);
      __label__ = 7; break;
    case 7: // $49
      $1=0;
      __label__ = 10; break;
    case 8: // $50
      __label__ = 9; break;
    case 9: // $51
      $1=4;
      __label__ = 10; break;
    case 10: // $52
      var $53=$1;
      ;
      return $53;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15av_codec_configP9_chd_fileiPv["X"]=1;

function __Z15chd_create_fileP10_core_fileyjjP9_chd_file($file, $logicalbytes$0, $logicalbytes$1, $hunkbytes, $compression, $parent) {
  var __stackBase__  = STACKTOP; STACKTOP += 160; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $6;
      var $newchd=__stackBase__+8;
      var $header=__stackBase__+12;
      var $err;
      var $intfnum;
      $2=$file;
      var $st$11$0=(($3)|0);
      HEAP32[(($st$11$0)>>2)]=$logicalbytes$0;
      var $st$11$1=(($3+4)|0);
      HEAP32[(($st$11$1)>>2)]=$logicalbytes$1;
      $4=$hunkbytes;
      $5=$compression;
      $6=$parent;
      HEAP32[(($newchd)>>2)]=0;
      var $7=$2;
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $9
      __label__ = 2; break;
    case 2: // $10
      $err=4;
      __label__ = 43; break;
    case 3: // $12
      var $13=$6;
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $15
      var $st$0$0=(($3)|0);
      var $16$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $16$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $17=$16$0 == $$emscripten$temp$0$0 && $16$1 == $$emscripten$temp$0$1;
      if ($17) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $18
      var $19=$4;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $21
      __label__ = 7; break;
    case 7: // $22
      $err=4;
      __label__ = 43; break;
    case 8: // $24
      $intfnum=0;
      __label__ = 9; break;
    case 9: // $25
      var $26=$intfnum;
      var $27=(($26)>>>0) < 4;
      if ($27) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $28
      var $29=$intfnum;
      var $30=((__ZL16codec_interfaces+($29<<5))|0);
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$5;
      var $34=(($32)|0)==(($33)|0);
      if ($34) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $35
      __label__ = 14; break;
    case 12: // $36
      __label__ = 13; break;
    case 13: // $37
      var $38=$intfnum;
      var $39=(($38+1)|0);
      $intfnum=$39;
      __label__ = 9; break;
    case 14: // $40
      var $41=$intfnum;
      var $42=(($41)|0)==4;
      if ($42) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $43
      __label__ = 16; break;
    case 16: // $44
      $err=4;
      __label__ = 43; break;
    case 17: // $46
      var $47=$6;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $49
      var $50=$6;
      var $51=(($50+12)|0);
      var $52=(($51+24)|0);
      var $st$3$0=(($52)|0);
      var $53$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($52+4)|0);
      var $53$1=HEAP32[(($st$3$1)>>2)];
      var $st$7$0=(($3)|0);
      HEAP32[(($st$7$0)>>2)]=$53$0;
      var $st$7$1=(($3+4)|0);
      HEAP32[(($st$7$1)>>2)]=$53$1;
      var $54=$6;
      var $55=(($54+12)|0);
      var $56=(($55+16)|0);
      var $57=HEAP32[(($56)>>2)];
      $4=$57;
      __label__ = 19; break;
    case 19: // $58
      var $59=$6;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $61
      var $62=$6;
      var $63=(($62+12)|0);
      var $64=(($63+4)|0);
      var $65=HEAPU32[(($64)>>2)];
      var $66=(($65)>>>0) < 3;
      if ($66) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $67
      __label__ = 22; break;
    case 22: // $68
      $err=21;
      __label__ = 43; break;
    case 23: // $70
      var $71=$header;
      _memset($71, 0, 148, 1);
      var $72=(($header)|0);
      HEAP32[(($72)>>2)]=108;
      var $73=(($header+4)|0);
      HEAP32[(($73)>>2)]=4;
      var $74=(($header+8)|0);
      HEAP32[(($74)>>2)]=2;
      var $75=$5;
      var $76=(($header+12)|0);
      HEAP32[(($76)>>2)]=$75;
      var $77=$4;
      var $78=(($header+16)|0);
      HEAP32[(($78)>>2)]=$77;
      var $st$14$0=(($3)|0);
      var $79$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($3+4)|0);
      var $79$1=HEAP32[(($st$14$1)>>2)];
      var $80=$4;
      var $81$0=$80;
      var $81$1=0;
      var $82$0 = ((($79$0)>>>0)+((($79$1)|0)*4294967296))+((($81$0)>>>0)+((($81$1)|0)*4294967296))>>>0; var $82$1 = Math.min(Math.floor((((($79$0)>>>0)+((($79$1)|0)*4294967296))+((($81$0)>>>0)+((($81$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $83$0 = ((($82$0)>>>0)+((($82$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $83$1 = Math.min(Math.floor((((($82$0)>>>0)+((($82$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $84=$4;
      var $85$0=$84;
      var $85$1=0;
      var $86$0 = Math.floor(((($83$0)>>>0)+((($83$1)|0)*4294967296))/((($85$0)>>>0)+((($85$1)|0)*4294967296)))>>>0; var $86$1 = Math.min(Math.floor((Math.floor(((($83$0)>>>0)+((($83$1)|0)*4294967296))/((($85$0)>>>0)+((($85$1)|0)*4294967296))))/4294967296), 4294967295);
      var $87$0=$86$0;
      var $87=$87$0;
      var $88=(($header+20)|0);
      HEAP32[(($88)>>2)]=$87;
      var $st$33$0=(($3)|0);
      var $89$0=HEAP32[(($st$33$0)>>2)];
      var $st$33$1=(($3+4)|0);
      var $89$1=HEAP32[(($st$33$1)>>2)];
      var $90=(($header+24)|0);
      var $st$38$0=(($90)|0);
      HEAP32[(($st$38$0)>>2)]=$89$0;
      var $st$38$1=(($90+4)|0);
      HEAP32[(($st$38$1)>>2)]=$89$1;
      var $91=$6;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $93
      var $94=(($header+8)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$95 | 1;
      HEAP32[(($94)>>2)]=$96;
      var $97=(($header+56)|0);
      var $98=(($97)|0);
      var $99=$6;
      var $100=(($99+12)|0);
      var $101=(($100+40)|0);
      var $102=(($101)|0);
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $102, $$dest = $98, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $103=(($header+112)|0);
      var $104=(($103)|0);
      var $105=$6;
      var $106=(($105+12)|0);
      var $107=(($106+72)|0);
      var $108=(($107)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($104, $108, 20, 1);
      __label__ = 25; break;
    case 25: // $109
      var $110=__ZL15header_validatePK11_chd_header($header);
      $err=$110;
      var $111=$err;
      var $112=(($111)|0)!=0;
      if ($112) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $113
      __label__ = 27; break;
    case 27: // $114
      __label__ = 43; break;
    case 28: // $116
      var $117=$2;
      var $118=__ZL12header_writeP10_core_filePK11_chd_header($117, $header);
      $err=$118;
      var $119=$err;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $121
      __label__ = 30; break;
    case 30: // $122
      __label__ = 43; break;
    case 31: // $124
      var $125=$2;
      var $126=$6;
      var $127=__ZL17map_write_initialP10_core_fileP9_chd_filePK11_chd_header($125, $126, $header);
      $err=$127;
      var $128=$err;
      var $129=(($128)|0)!=0;
      if ($129) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $130
      __label__ = 33; break;
    case 33: // $131
      __label__ = 43; break;
    case 34: // $133
      var $134=$6;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 35; break; } else { __label__ = 42; break; }
    case 35: // $136
      var $137=$2;
      var $138=$6;
      var $139=__Z13chd_open_fileP10_core_fileiP9_chd_filePS2_($137, 2, $138, $newchd);
      $err=$139;
      var $140=$err;
      var $141=(($140)|0)!=0;
      if ($141) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $142
      __label__ = 37; break;
    case 37: // $143
      __label__ = 43; break;
    case 38: // $145
      var $146=$6;
      var $147=HEAP32[(($newchd)>>2)];
      var $148=__Z18chd_clone_metadataP9_chd_fileS0_($146, $147);
      $err=$148;
      var $149=$err;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $151
      __label__ = 40; break;
    case 40: // $152
      __label__ = 43; break;
    case 41: // $154
      var $155=HEAP32[(($newchd)>>2)];
      __Z9chd_closeP9_chd_file($155);
      __label__ = 42; break;
    case 42: // $156
      $1=0;
      __label__ = 46; break;
    case 43: // $157
      var $158=HEAP32[(($newchd)>>2)];
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $160
      var $161=HEAP32[(($newchd)>>2)];
      __Z9chd_closeP9_chd_file($161);
      __label__ = 45; break;
    case 45: // $162
      var $163=$err;
      $1=$163;
      __label__ = 46; break;
    case 46: // $164
      var $165=$1;
      STACKTOP = __stackBase__;
      return $165;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15chd_create_fileP10_core_fileyjjP9_chd_file["X"]=1;

function __ZL15header_validatePK11_chd_header($header) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $intfnum;
      $2=$header;
      var $3=$2;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+4)|0);
      var $10=HEAPU32[(($9)>>2)];
      var $11=(($10)>>>0) > 4;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $1=21;
      __label__ = 44; break;
    case 3: // $13
      var $14=$2;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==1;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$2;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=76;
      if ($22) { __label__ = 11; break; } else { __label__ = 5; break; }
    case 5: // $23
      var $24=$2;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==2;
      if ($27) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $28
      var $29=$2;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=80;
      if ($32) { __label__ = 11; break; } else { __label__ = 7; break; }
    case 7: // $33
      var $34=$2;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==3;
      if ($37) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $38
      var $39=$2;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=120;
      if ($42) { __label__ = 11; break; } else { __label__ = 9; break; }
    case 9: // $43
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==4;
      if ($47) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $48
      var $49=$2;
      var $50=(($49)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)!=108;
      if ($52) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $53
      $1=4;
      __label__ = 44; break;
    case 12: // $54
      var $55=$2;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$57 & -4;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $60
      $1=4;
      __label__ = 44; break;
    case 14: // $61
      $intfnum=0;
      __label__ = 15; break;
    case 15: // $62
      var $63=$intfnum;
      var $64=(($63)>>>0) < 4;
      if ($64) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $65
      var $66=$intfnum;
      var $67=((__ZL16codec_interfaces+($66<<5))|0);
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$2;
      var $71=(($70+12)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($69)|0)==(($72)|0);
      if ($73) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $74
      __label__ = 20; break;
    case 18: // $75
      __label__ = 19; break;
    case 19: // $76
      var $77=$intfnum;
      var $78=(($77+1)|0);
      $intfnum=$78;
      __label__ = 15; break;
    case 20: // $79
      var $80=$intfnum;
      var $81=(($80)|0)==4;
      if ($81) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $82
      $1=4;
      __label__ = 44; break;
    case 22: // $83
      var $84=$2;
      var $85=(($84+16)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $88
      var $89=$2;
      var $90=(($89+16)|0);
      var $91=HEAPU32[(($90)>>2)];
      var $92=(($91)>>>0) >= 16777216;
      if ($92) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $93
      $1=4;
      __label__ = 44; break;
    case 25: // $94
      var $95=$2;
      var $96=(($95+20)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $99
      $1=4;
      __label__ = 44; break;
    case 27: // $100
      var $101=$2;
      var $102=(($101+8)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$103 & 1;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 28; break; } else { __label__ = 31; break; }
    case 28: // $106
      var $107=$2;
      var $108=(($107+56)|0);
      var $109=(($108)|0);
      var $110=_memcmp($109, ((__ZL7nullmd5)|0), 16);
      var $111=(($110)|0)==0;
      if ($111) { __label__ = 29; break; } else { __label__ = 31; break; }
    case 29: // $112
      var $113=$2;
      var $114=(($113+112)|0);
      var $115=(($114)|0);
      var $116=_memcmp($115, ((__ZL8nullsha1)|0), 20);
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $118
      $1=4;
      __label__ = 44; break;
    case 31: // $119
      var $120=$2;
      var $121=(($120+4)|0);
      var $122=HEAPU32[(($121)>>2)];
      var $123=(($122)>>>0) >= 3;
      if ($123) { __label__ = 32; break; } else { __label__ = 37; break; }
    case 32: // $124
      var $125=$2;
      var $126=(($125+132)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 36; break; } else { __label__ = 33; break; }
    case 33: // $129
      var $130=$2;
      var $131=(($130+136)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 36; break; } else { __label__ = 34; break; }
    case 34: // $134
      var $135=$2;
      var $136=(($135+140)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $139
      var $140=$2;
      var $141=(($140+144)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $144
      $1=4;
      __label__ = 44; break;
    case 37: // $145
      var $146=$2;
      var $147=(($146+4)|0);
      var $148=HEAPU32[(($147)>>2)];
      var $149=(($148)>>>0) < 3;
      if ($149) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $150
      var $151=$2;
      var $152=(($151+132)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 42; break; } else { __label__ = 39; break; }
    case 39: // $155
      var $156=$2;
      var $157=(($156+136)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($158)|0)==0;
      if ($159) { __label__ = 42; break; } else { __label__ = 40; break; }
    case 40: // $160
      var $161=$2;
      var $162=(($161+140)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163)|0)==0;
      if ($164) { __label__ = 42; break; } else { __label__ = 41; break; }
    case 41: // $165
      var $166=$2;
      var $167=(($166+144)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168)|0)==0;
      if ($169) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $170
      $1=4;
      __label__ = 44; break;
    case 43: // $171
      $1=0;
      __label__ = 44; break;
    case 44: // $172
      var $173=$1;
      ;
      return $173;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15header_validatePK11_chd_header["X"]=1;

function __ZL12header_writeP10_core_filePK11_chd_header($file, $header) {
  var __stackBase__  = STACKTOP; STACKTOP += 108; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $rawheader=__stackBase__;
      var $count;
      $2=$file;
      $3=$header;
      var $4=$3;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=4;
      __label__ = 9; break;
    case 2: // $7
      var $8=$2;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      $1=3;
      __label__ = 9; break;
    case 4: // $11
      var $12=$3;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=4;
      if ($15) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $16
      $1=4;
      __label__ = 9; break;
    case 6: // $17
      var $18=(($rawheader)|0);
      _memset($18, 0, 108, 1);
      var $19=(($rawheader)|0);
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($19)]=HEAP8[(((STRING_TABLE.__str387381)|0))];HEAP8[($19+1)]=HEAP8[(((STRING_TABLE.__str387381)|0)+1)];HEAP8[($19+2)]=HEAP8[(((STRING_TABLE.__str387381)|0)+2)];HEAP8[($19+3)]=HEAP8[(((STRING_TABLE.__str387381)|0)+3)];HEAP8[($19+4)]=HEAP8[(((STRING_TABLE.__str387381)|0)+4)];HEAP8[($19+5)]=HEAP8[(((STRING_TABLE.__str387381)|0)+5)];HEAP8[($19+6)]=HEAP8[(((STRING_TABLE.__str387381)|0)+6)];HEAP8[($19+7)]=HEAP8[(((STRING_TABLE.__str387381)|0)+7)];
      var $20=(($rawheader+8)|0);
      __ZL20put_bigendian_uint32Phj($20, 108);
      var $21=(($rawheader+12)|0);
      var $22=$3;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      __ZL20put_bigendian_uint32Phj($21, $24);
      var $25=(($rawheader+16)|0);
      var $26=$3;
      var $27=(($26+8)|0);
      var $28=HEAP32[(($27)>>2)];
      __ZL20put_bigendian_uint32Phj($25, $28);
      var $29=(($rawheader+20)|0);
      var $30=$3;
      var $31=(($30+12)|0);
      var $32=HEAP32[(($31)>>2)];
      __ZL20put_bigendian_uint32Phj($29, $32);
      var $33=(($rawheader+24)|0);
      var $34=$3;
      var $35=(($34+20)|0);
      var $36=HEAP32[(($35)>>2)];
      __ZL20put_bigendian_uint32Phj($33, $36);
      var $37=(($rawheader+28)|0);
      var $38=$3;
      var $39=(($38+24)|0);
      var $st$29$0=(($39)|0);
      var $40$0=HEAP32[(($st$29$0)>>2)];
      var $st$29$1=(($39+4)|0);
      var $40$1=HEAP32[(($st$29$1)>>2)];
      __ZL20put_bigendian_uint64Phy($37, $40$0, $40$1);
      var $41=(($rawheader+36)|0);
      var $42=$3;
      var $43=(($42+32)|0);
      var $st$37$0=(($43)|0);
      var $44$0=HEAP32[(($st$37$0)>>2)];
      var $st$37$1=(($43+4)|0);
      var $44$1=HEAP32[(($st$37$1)>>2)];
      __ZL20put_bigendian_uint64Phy($41, $44$0, $44$1);
      var $45=(($rawheader+44)|0);
      var $46=$3;
      var $47=(($46+16)|0);
      var $48=HEAP32[(($47)>>2)];
      __ZL20put_bigendian_uint32Phj($45, $48);
      var $49=(($rawheader+48)|0);
      var $50=$3;
      var $51=(($50+72)|0);
      var $52=(($51)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($49, $52, 20, 1);
      var $53=(($rawheader+68)|0);
      var $54=$3;
      var $55=(($54+112)|0);
      var $56=(($55)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($53, $56, 20, 1);
      var $57=(($rawheader+88)|0);
      var $58=$3;
      var $59=(($58+92)|0);
      var $60=(($59)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($57, $60, 20, 1);
      var $61=$2;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $62=__Z10core_fseekP10_core_filexi($61, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $62$0=$62[0];
      var $63=$2;
      var $64=(($rawheader)|0);
      var $65=__Z11core_fwriteP10_core_filePKvj($63, $64, 108);
      $count=$65;
      var $66=$count;
      var $67=(($66)|0)!=108;
      if ($67) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $68
      $1=10;
      __label__ = 9; break;
    case 8: // $69
      $1=0;
      __label__ = 9; break;
    case 9: // $70
      var $71=$1;
      STACKTOP = __stackBase__;
      return $71;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12header_writeP10_core_filePK11_chd_header["X"]=1;

function __ZL17map_write_initialP10_core_fileP9_chd_filePK11_chd_header($file, $parent, $header) {
  var __stackBase__  = STACKTOP; STACKTOP += 8220; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $blank_map_entries=__stackBase__;
      var $fullchunks;
      var $remainder;
      var $count;
      var $i;
      var $j;
      var $mapentry=__stackBase__+8192;
      var $fileoffset=__stackBase__+8212;
      $2=$file;
      $3=$parent;
      $4=$header;
      var $5=(($mapentry)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$18$0=(($5)|0);
      HEAP32[(($st$18$0)>>2)]=$$emscripten$temp$0$0;
      var $st$18$1=(($5+4)|0);
      HEAP32[(($st$18$1)>>2)]=$$emscripten$temp$0$1;
      var $6=(($mapentry+8)|0);
      HEAP32[(($6)>>2)]=0;
      var $7=(($mapentry+12)|0);
      HEAP32[(($7)>>2)]=0;
      var $8=(($mapentry+16)|0);
      HEAP8[($8)]=19;
      $i=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$i;
      var $11=(($10)|0) < 512;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$i;
      var $14=((($13<<4))|0);
      var $15=(($blank_map_entries+$14)|0);
      __ZL12map_assemblePhP10_map_entry($15, $mapentry);
      __label__ = 3; break;
    case 3: // $16
      var $17=$i;
      var $18=(($17+1)|0);
      $i=$18;
      __label__ = 1; break;
    case 4: // $19
      var $20=$4;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23$0=$22;
      var $23$1=0;
      var $st$5$0=(($fileoffset)|0);
      HEAP32[(($st$5$0)>>2)]=$23$0;
      var $st$5$1=(($fileoffset+4)|0);
      HEAP32[(($st$5$1)>>2)]=$23$1;
      var $24=$4;
      var $25=(($24+20)|0);
      var $26=HEAPU32[(($25)>>2)];
      var $27=Math.floor((($26)>>>0)/512);
      $fullchunks=$27;
      var $28=$4;
      var $29=(($28+20)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($30)>>>0)%512;
      $remainder=$31;
      $i=0;
      __label__ = 5; break;
    case 5: // $32
      var $33=$i;
      var $34=$fullchunks;
      var $35=(($33)|0) < (($34)|0);
      if ($35) { __label__ = 6; break; } else { __label__ = 16; break; }
    case 6: // $36
      var $37=$3;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $39
      $j=0;
      __label__ = 8; break;
    case 8: // $40
      var $41=$j;
      var $42=(($41)|0) < 512;
      if ($42) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $43
      var $44=$i;
      var $45=((($44<<9))|0);
      var $46=$j;
      var $47=(($45+$46)|0);
      var $48$0=$47;
      var $48$1=(($47|0) < 0 ? -1 : 0);
      var $49=(($mapentry)|0);
      var $st$7$0=(($49)|0);
      HEAP32[(($st$7$0)>>2)]=$48$0;
      var $st$7$1=(($49+4)|0);
      HEAP32[(($st$7$1)>>2)]=$48$1;
      var $50=$i;
      var $51=((($50<<9))|0);
      var $52=$j;
      var $53=(($51+$52)|0);
      var $54=$3;
      var $55=(($54+164)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+$53*20)|0);
      var $58=(($57+8)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($mapentry+8)|0);
      HEAP32[(($60)>>2)]=$59;
      var $61=(($mapentry+16)|0);
      HEAP8[($61)]=5;
      var $62=$j;
      var $63=((($62<<4))|0);
      var $64=(($blank_map_entries+$63)|0);
      __ZL12map_assemblePhP10_map_entry($64, $mapentry);
      __label__ = 10; break;
    case 10: // $65
      var $66=$j;
      var $67=(($66+1)|0);
      $j=$67;
      __label__ = 8; break;
    case 11: // $68
      __label__ = 12; break;
    case 12: // $69
      var $70=$2;
      var $st$1$0=(($fileoffset)|0);
      var $71$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($fileoffset+4)|0);
      var $71$1=HEAP32[(($st$1$1)>>2)];
      var $72=__Z10core_fseekP10_core_filexi($70, $71$0, $71$1, 0);
      var $72$0=$72[0];
      var $73=$2;
      var $74=(($blank_map_entries)|0);
      var $75=__Z11core_fwriteP10_core_filePKvj($73, $74, 8192);
      $count=$75;
      var $76=$count;
      var $77=(($76)|0)!=8192;
      if ($77) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $78
      $1=10;
      __label__ = 29; break;
    case 14: // $79
      var $st$0$0=(($fileoffset)|0);
      var $80$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($fileoffset+4)|0);
      var $80$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=8192;
      var $$emscripten$temp$1$1=0;
      var $81$0 = ((($80$0)>>>0)+((($80$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $81$1 = Math.min(Math.floor((((($80$0)>>>0)+((($80$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$7$0=(($fileoffset)|0);
      HEAP32[(($st$7$0)>>2)]=$81$0;
      var $st$7$1=(($fileoffset+4)|0);
      HEAP32[(($st$7$1)>>2)]=$81$1;
      __label__ = 15; break;
    case 15: // $82
      var $83=$i;
      var $84=(($83+1)|0);
      $i=$84;
      __label__ = 5; break;
    case 16: // $85
      var $86=$remainder;
      var $87=(($86)|0) > 0;
      if ($87) { __label__ = 17; break; } else { __label__ = 26; break; }
    case 17: // $88
      var $89=$3;
      var $90=(($89)|0)!=0;
      if ($90) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $91
      $j=0;
      __label__ = 19; break;
    case 19: // $92
      var $93=$j;
      var $94=$remainder;
      var $95=(($93)|0) < (($94)|0);
      if ($95) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $96
      var $97=$i;
      var $98=((($97<<9))|0);
      var $99=$j;
      var $100=(($98+$99)|0);
      var $101$0=$100;
      var $101$1=(($100|0) < 0 ? -1 : 0);
      var $102=(($mapentry)|0);
      var $st$7$0=(($102)|0);
      HEAP32[(($st$7$0)>>2)]=$101$0;
      var $st$7$1=(($102+4)|0);
      HEAP32[(($st$7$1)>>2)]=$101$1;
      var $103=$i;
      var $104=((($103<<9))|0);
      var $105=$j;
      var $106=(($104+$105)|0);
      var $107=$3;
      var $108=(($107+164)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+$106*20)|0);
      var $111=(($110+8)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($mapentry+8)|0);
      HEAP32[(($113)>>2)]=$112;
      var $114=(($mapentry+16)|0);
      HEAP8[($114)]=5;
      var $115=$j;
      var $116=((($115<<4))|0);
      var $117=(($blank_map_entries+$116)|0);
      __ZL12map_assemblePhP10_map_entry($117, $mapentry);
      __label__ = 21; break;
    case 21: // $118
      var $119=$j;
      var $120=(($119+1)|0);
      $j=$120;
      __label__ = 19; break;
    case 22: // $121
      __label__ = 23; break;
    case 23: // $122
      var $123=$2;
      var $st$1$0=(($fileoffset)|0);
      var $124$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($fileoffset+4)|0);
      var $124$1=HEAP32[(($st$1$1)>>2)];
      var $125=__Z10core_fseekP10_core_filexi($123, $124$0, $124$1, 0);
      var $125$0=$125[0];
      var $126=$2;
      var $127=(($blank_map_entries)|0);
      var $128=$remainder;
      var $129=((($128<<4))|0);
      var $130=__Z11core_fwriteP10_core_filePKvj($126, $127, $129);
      $count=$130;
      var $131=$count;
      var $132=$remainder;
      var $133=((($132<<4))|0);
      var $134=(($131)|0)!=(($133)|0);
      if ($134) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $135
      $1=10;
      __label__ = 29; break;
    case 25: // $136
      var $137=$remainder;
      var $138=((($137<<4))|0);
      var $139$0=$138;
      var $139$1=(($138|0) < 0 ? -1 : 0);
      var $st$4$0=(($fileoffset)|0);
      var $140$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($fileoffset+4)|0);
      var $140$1=HEAP32[(($st$4$1)>>2)];
      var $141$0 = ((($140$0)>>>0)+((($140$1)|0)*4294967296))+((($139$0)>>>0)+((($139$1)|0)*4294967296))>>>0; var $141$1 = Math.min(Math.floor((((($140$0)>>>0)+((($140$1)|0)*4294967296))+((($139$0)>>>0)+((($139$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($fileoffset)|0);
      HEAP32[(($st$9$0)>>2)]=$141$0;
      var $st$9$1=(($fileoffset+4)|0);
      HEAP32[(($st$9$1)>>2)]=$141$1;
      __label__ = 26; break;
    case 26: // $142
      var $143=(($blank_map_entries)|0);
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = ((STRING_TABLE.__str377380)|0), $$dest = $143, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $144=$2;
      var $st$3$0=(($fileoffset)|0);
      var $145$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($fileoffset+4)|0);
      var $145$1=HEAP32[(($st$3$1)>>2)];
      var $146=__Z10core_fseekP10_core_filexi($144, $145$0, $145$1, 0);
      var $146$0=$146[0];
      var $147=$2;
      var $148=(($blank_map_entries)|0);
      var $149=__Z11core_fwriteP10_core_filePKvj($147, $148, 16);
      $count=$149;
      var $150=$count;
      var $151=(($150)|0)!=16;
      if ($151) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $152
      $1=10;
      __label__ = 29; break;
    case 28: // $153
      $1=0;
      __label__ = 29; break;
    case 29: // $154
      var $155=$1;
      STACKTOP = __stackBase__;
      return $155;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17map_write_initialP10_core_fileP9_chd_filePK11_chd_header["X"]=1;
// WARNING: content after a branch in a label, line: 692213
// WARNING: content after a branch in a label, line: 692234
// WARNING: content after a branch in a label, line: 692251
// WARNING: content after a branch in a label, line: 692285
// WARNING: content after a branch in a label, line: 692302
// WARNING: content after a branch in a label, line: 692325
// WARNING: content after a branch in a label, line: 692347
// WARNING: content after a branch in a label, line: 692370
// WARNING: content after a branch in a label, line: 692419
// WARNING: content after a branch in a label, line: 692463
// WARNING: content after a branch in a label, line: 692482
// WARNING: content after a branch in a label, line: 692521
// WARNING: content after a branch in a label, line: 692551
// WARNING: content after a branch in a label, line: 692603
// WARNING: content after a branch in a label, line: 692636

function __Z13chd_open_fileP10_core_fileiP9_chd_filePS2_($file, $mode, $parent, $chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $newchd;
      var $err;
      var $intfnum;
      $2=$file;
      $3=$mode;
      $4=$parent;
      $5=$chd;
      $newchd=0;
      var $6=$2;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      $err=4;
      __label__ = 65; break;
    case 3: // $11
      var $12=$4;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $14
      var $15=$4;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=-1163005939;
      if ($18) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $19
      __label__ = 6; break;
    case 6: // $20
      $err=4;
      __label__ = 65; break;
    case 7: // $22
      var $23=_malloc(612);
      var $24=$23;
      $newchd=$24;
      var $25=$newchd;
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $27
      __label__ = 9; break;
    case 9: // $28
      $err=2;
      __label__ = 65; break;
    case 10: // $30
      var $31=$newchd;
      var $32=$31;
      _memset($32, 0, 612, 1);
      var $33=$newchd;
      var $34=(($33)|0);
      HEAP32[(($34)>>2)]=-1163005939;
      var $35=$4;
      var $36=$newchd;
      var $37=(($36+160)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$2;
      var $39=$newchd;
      var $40=(($39+4)|0);
      HEAP32[(($40)>>2)]=$38;
      var $41=$newchd;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$newchd;
      var $45=(($44+12)|0);
      var $46=__ZL11header_readP10_core_fileP11_chd_header($43, $45);
      $err=$46;
      var $47=$err;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $49
      __label__ = 12; break;
    case 12: // $50
      __label__ = 65; break;
    case 13: // $52
      var $53=$newchd;
      var $54=(($53+12)|0);
      var $55=__ZL15header_validatePK11_chd_header($54);
      $err=$55;
      var $56=$err;
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $58
      __label__ = 15; break;
    case 15: // $59
      __label__ = 65; break;
    case 16: // $61
      var $62=$3;
      var $63=(($62)|0)==2;
      if ($63) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $64
      var $65=$newchd;
      var $66=(($65+12)|0);
      var $67=(($66+8)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$68 & 2;
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 20; break; } else { __label__ = 18; break; }
    case 18: // $71
      __label__ = 19; break;
    case 19: // $72
      $err=8;
      __label__ = 65; break;
    case 20: // $74
      var $75=$3;
      var $76=(($75)|0)==2;
      if ($76) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $77
      var $78=$newchd;
      var $79=(($78+12)|0);
      var $80=(($79+4)|0);
      var $81=HEAPU32[(($80)>>2)];
      var $82=(($81)>>>0) < 4;
      if ($82) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $83
      __label__ = 23; break;
    case 23: // $84
      $err=21;
      __label__ = 65; break;
    case 24: // $86
      var $87=$4;
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $89
      var $90=$newchd;
      var $91=(($90+12)|0);
      var $92=(($91+8)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$93 & 1;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $96
      __label__ = 27; break;
    case 27: // $97
      $err=7;
      __label__ = 65; break;
    case 28: // $99
      var $100=$4;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 29; break; } else { __label__ = 40; break; }
    case 29: // $102
      var $103=$newchd;
      var $104=(($103+12)|0);
      var $105=(($104+56)|0);
      var $106=(($105)|0);
      var $107=_memcmp(((__ZL7nullmd5)|0), $106, 16);
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $109
      var $110=$newchd;
      var $111=(($110+160)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(($112+12)|0);
      var $114=(($113+40)|0);
      var $115=(($114)|0);
      var $116=_memcmp(((__ZL7nullmd5)|0), $115, 16);
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $118
      var $119=$newchd;
      var $120=(($119+160)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+12)|0);
      var $123=(($122+40)|0);
      var $124=(($123)|0);
      var $125=$newchd;
      var $126=(($125+12)|0);
      var $127=(($126+56)|0);
      var $128=(($127)|0);
      var $129=_memcmp($124, $128, 16);
      var $130=(($129)|0)!=0;
      if ($130) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $131
      __label__ = 33; break;
    case 33: // $132
      $err=12;
      __label__ = 65; break;
    case 34: // $134
      var $135=$newchd;
      var $136=(($135+12)|0);
      var $137=(($136+112)|0);
      var $138=(($137)|0);
      var $139=_memcmp(((__ZL8nullsha1)|0), $138, 20);
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $141
      var $142=$newchd;
      var $143=(($142+160)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+12)|0);
      var $146=(($145+72)|0);
      var $147=(($146)|0);
      var $148=_memcmp(((__ZL8nullsha1)|0), $147, 20);
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $150
      var $151=$newchd;
      var $152=(($151+160)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153+12)|0);
      var $155=(($154+72)|0);
      var $156=(($155)|0);
      var $157=$newchd;
      var $158=(($157+12)|0);
      var $159=(($158+112)|0);
      var $160=(($159)|0);
      var $161=_memcmp($156, $160, 20);
      var $162=(($161)|0)!=0;
      if ($162) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $163
      __label__ = 38; break;
    case 38: // $164
      $err=12;
      __label__ = 65; break;
    case 39: // $166
      __label__ = 40; break;
    case 40: // $167
      var $168=$newchd;
      var $169=__ZL8map_readP9_chd_file($168);
      $err=$169;
      var $170=$err;
      var $171=(($170)|0)!=0;
      if ($171) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $172
      __label__ = 42; break;
    case 42: // $173
      __label__ = 65; break;
    case 43: // $175
      var $176=$newchd;
      var $177=(($176+12)|0);
      var $178=(($177+16)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=_malloc($179);
      var $181=$newchd;
      var $182=(($181+168)|0);
      HEAP32[(($182)>>2)]=$180;
      var $183=$newchd;
      var $184=(($183+12)|0);
      var $185=(($184+16)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=_malloc($186);
      var $188=$newchd;
      var $189=(($188+176)|0);
      HEAP32[(($189)>>2)]=$187;
      var $190=$newchd;
      var $191=(($190+168)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192)|0)==0;
      if ($193) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $194
      var $195=$newchd;
      var $196=(($195+176)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($197)|0)==0;
      if ($198) { __label__ = 45; break; } else { __label__ = 47; break; }
    case 45: // $199
      __label__ = 46; break;
    case 46: // $200
      $err=2;
      __label__ = 65; break;
    case 47: // $202
      var $203=$newchd;
      var $204=(($203+172)|0);
      HEAP32[(($204)>>2)]=-1;
      var $205=$newchd;
      var $206=(($205+180)|0);
      HEAP32[(($206)>>2)]=-1;
      var $207=$newchd;
      var $208=(($207+12)|0);
      var $209=(($208+16)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=_malloc($210);
      var $212=$newchd;
      var $213=(($212+184)|0);
      HEAP32[(($213)>>2)]=$211;
      var $214=$newchd;
      var $215=(($214+184)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($216)|0)==0;
      if ($217) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $218
      __label__ = 49; break;
    case 49: // $219
      $err=2;
      __label__ = 65; break;
    case 50: // $221
      $intfnum=0;
      __label__ = 51; break;
    case 51: // $222
      var $223=$intfnum;
      var $224=(($223)>>>0) < 4;
      if ($224) { __label__ = 52; break; } else { __label__ = 56; break; }
    case 52: // $225
      var $226=$intfnum;
      var $227=((__ZL16codec_interfaces+($226<<5))|0);
      var $228=(($227)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=$newchd;
      var $231=(($230+12)|0);
      var $232=(($231+12)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=(($229)|0)==(($233)|0);
      if ($234) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $235
      var $236=$intfnum;
      var $237=((__ZL16codec_interfaces+($236<<5))|0);
      var $238=$newchd;
      var $239=(($238+188)|0);
      HEAP32[(($239)>>2)]=$237;
      __label__ = 56; break;
    case 54: // $240
      __label__ = 55; break;
    case 55: // $241
      var $242=$intfnum;
      var $243=(($242+1)|0);
      $intfnum=$243;
      __label__ = 51; break;
    case 56: // $244
      var $245=$intfnum;
      var $246=(($245)|0)==4;
      if ($246) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 57: // $247
      __label__ = 58; break;
    case 58: // $248
      $err=27;
      __label__ = 65; break;
    case 59: // $250
      var $251=$newchd;
      var $252=(($251+188)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=(($253+12)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($255)|0)!=0;
      if ($256) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $257
      var $258=$newchd;
      var $259=(($258+188)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=(($260+12)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$newchd;
      var $264=FUNCTION_TABLE[$262]($263);
      $err=$264;
      __label__ = 61; break;
    case 61: // $265
      var $266=$err;
      var $267=(($266)|0)!=0;
      if ($267) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $268
      __label__ = 63; break;
    case 63: // $269
      __label__ = 65; break;
    case 64: // $271
      var $272=$newchd;
      var $273=$5;
      HEAP32[(($273)>>2)]=$272;
      $1=0;
      __label__ = 68; break;
    case 65: // $274
      var $275=$newchd;
      var $276=(($275)|0)!=0;
      if ($276) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $277
      var $278=$newchd;
      __Z9chd_closeP9_chd_file($278);
      __label__ = 67; break;
    case 67: // $279
      var $280=$err;
      $1=$280;
      __label__ = 68; break;
    case 68: // $281
      var $282=$1;
      ;
      return $282;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13chd_open_fileP10_core_fileiP9_chd_filePS2_["X"]=1;

function __Z18chd_clone_metadataP9_chd_fileS0_($source, $dest) {
  var __stackBase__  = STACKTOP; STACKTOP += 1036; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $metatag=__stackBase__;
      var $metasize=__stackBase__+4;
      var $metaindex;
      var $metabuffer=__stackBase__+8;
      var $metaflags=__stackBase__+1032;
      var $err;
      var $allocbuffer;
      $1=$source;
      $2=$dest;
      $metaindex=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      var $5=$metaindex;
      var $6=(($metabuffer)|0);
      var $7=__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph($4, 0, $5, $6, 1024, $metasize, $metatag, $metaflags);
      $err=$7;
      var $8=$err;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $10
      var $11=$err;
      var $12=(($11)|0)==19;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $err=0;
      __label__ = 4; break;
    case 4: // $14
      __label__ = 18; break;
    case 5: // $15
      var $16=HEAPU32[(($metasize)>>2)];
      var $17=(($16)>>>0) <= 1024;
      if ($17) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $18
      var $19=$2;
      var $20=HEAP32[(($metatag)>>2)];
      var $21=(($metabuffer)|0);
      var $22=HEAP32[(($metasize)>>2)];
      var $23=HEAP8[($metaflags)];
      var $24=__Z16chd_set_metadataP9_chd_filejjPKvjh($19, $20, -1, $21, $22, $23);
      $err=$24;
      var $25=$err;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $27
      __label__ = 18; break;
    case 8: // $28
      __label__ = 16; break;
    case 9: // $29
      var $30=HEAP32[(($metasize)>>2)];
      var $31=_malloc($30);
      $allocbuffer=$31;
      var $32=$allocbuffer;
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $34
      $err=2;
      __label__ = 18; break;
    case 11: // $35
      var $36=$1;
      var $37=$metaindex;
      var $38=$allocbuffer;
      var $39=HEAP32[(($metasize)>>2)];
      var $40=__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph($36, 0, $37, $38, $39, $metasize, $metatag, $metaflags);
      $err=$40;
      var $41=$err;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $43
      var $44=$allocbuffer;
      _free($44);
      __label__ = 18; break;
    case 13: // $45
      var $46=$2;
      var $47=HEAP32[(($metatag)>>2)];
      var $48=$allocbuffer;
      var $49=HEAP32[(($metasize)>>2)];
      var $50=HEAP8[($metaflags)];
      var $51=__Z16chd_set_metadataP9_chd_filejjPKvjh($46, $47, -1, $48, $49, $50);
      $err=$51;
      var $52=$allocbuffer;
      _free($52);
      var $53=$err;
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $55
      __label__ = 18; break;
    case 15: // $56
      __label__ = 16; break;
    case 16: // $57
      __label__ = 17; break;
    case 17: // $58
      var $59=$metaindex;
      var $60=(($59+1)|0);
      $metaindex=$60;
      __label__ = 1; break;
    case 18: // $61
      var $62=$err;
      STACKTOP = __stackBase__;
      return $62;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18chd_clone_metadataP9_chd_fileS0_["X"]=1;

function __Z9chd_closeP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$chd;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=-1163005939;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      __label__ = 26; break;
    case 3: // $10
      var $11=$1;
      __ZL22wait_for_pending_asyncP9_chd_file($11);
      var $12=$1;
      var $13=(($12+600)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $16
      var $17=$1;
      var $18=(($17+600)|0);
      var $19=HEAP32[(($18)>>2)];
      _osd_work_item_release($19);
      __label__ = 5; break;
    case 5: // $20
      var $21=$1;
      var $22=(($21+596)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $25
      var $26=$1;
      var $27=(($26+596)|0);
      var $28=HEAP32[(($27)>>2)];
      _osd_work_queue_free($28);
      __label__ = 7; break;
    case 7: // $29
      var $30=$1;
      var $31=(($30+188)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $34
      var $35=$1;
      var $36=(($35+188)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+16)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $41
      var $42=$1;
      var $43=(($42+188)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$1;
      FUNCTION_TABLE[$46]($47);
      __label__ = 10; break;
    case 10: // $48
      var $49=$1;
      var $50=(($49+184)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $53
      var $54=$1;
      var $55=(($54+184)|0);
      var $56=HEAP32[(($55)>>2)];
      _free($56);
      __label__ = 12; break;
    case 12: // $57
      var $58=$1;
      var $59=(($58+176)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $62
      var $63=$1;
      var $64=(($63+176)|0);
      var $65=HEAP32[(($64)>>2)];
      _free($65);
      __label__ = 14; break;
    case 14: // $66
      var $67=$1;
      var $68=(($67+168)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $71
      var $72=$1;
      var $73=(($72+168)|0);
      var $74=HEAP32[(($73)>>2)];
      _free($74);
      __label__ = 16; break;
    case 16: // $75
      var $76=$1;
      var $77=(($76+164)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $80
      var $81=$1;
      var $82=(($81+164)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$83;
      _free($84);
      __label__ = 18; break;
    case 18: // $85
      var $86=$1;
      var $87=(($86+204)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $90
      var $91=$1;
      var $92=(($91+204)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$93;
      _free($94);
      __label__ = 20; break;
    case 20: // $95
      var $96=$1;
      var $97=(($96+196)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98)|0)!=0;
      if ($99) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $100
      var $101=$1;
      var $102=(($101+196)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$103;
      _free($104);
      __label__ = 22; break;
    case 22: // $105
      var $106=$1;
      var $107=(($106+8)|0);
      var $108=HEAP8[($107)];
      var $109=(($108 << 24) >> 24)!=0;
      if ($109) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $110
      var $111=$1;
      var $112=(($111+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113)|0)!=0;
      if ($114) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $115
      var $116=$1;
      var $117=(($116+4)|0);
      var $118=HEAP32[(($117)>>2)];
      __Z11core_fcloseP10_core_file($118);
      __label__ = 25; break;
    case 25: // $119
      var $120=$1;
      var $121=$120;
      _free($121);
      __label__ = 26; break;
    case 26: // $122
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z9chd_closeP9_chd_file["X"]=1;

function __Z16chd_error_string10_chd_error($err) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$err;
      var $3=$2;
      if ($3 == 0) {
        __label__ = 1; break;
      }
      else if ($3 == 1) {
        __label__ = 2; break;
      }
      else if ($3 == 2) {
        __label__ = 3; break;
      }
      else if ($3 == 3) {
        __label__ = 4; break;
      }
      else if ($3 == 4) {
        __label__ = 5; break;
      }
      else if ($3 == 5) {
        __label__ = 6; break;
      }
      else if ($3 == 6) {
        __label__ = 7; break;
      }
      else if ($3 == 7) {
        __label__ = 8; break;
      }
      else if ($3 == 8) {
        __label__ = 9; break;
      }
      else if ($3 == 9) {
        __label__ = 10; break;
      }
      else if ($3 == 10) {
        __label__ = 11; break;
      }
      else if ($3 == 11) {
        __label__ = 12; break;
      }
      else if ($3 == 12) {
        __label__ = 13; break;
      }
      else if ($3 == 13) {
        __label__ = 14; break;
      }
      else if ($3 == 14) {
        __label__ = 15; break;
      }
      else if ($3 == 15) {
        __label__ = 16; break;
      }
      else if ($3 == 16) {
        __label__ = 17; break;
      }
      else if ($3 == 17) {
        __label__ = 18; break;
      }
      else if ($3 == 18) {
        __label__ = 19; break;
      }
      else if ($3 == 19) {
        __label__ = 20; break;
      }
      else if ($3 == 20) {
        __label__ = 21; break;
      }
      else if ($3 == 21) {
        __label__ = 22; break;
      }
      else if ($3 == 22) {
        __label__ = 23; break;
      }
      else if ($3 == 23) {
        __label__ = 24; break;
      }
      else if ($3 == 24) {
        __label__ = 25; break;
      }
      else if ($3 == 25) {
        __label__ = 26; break;
      }
      else if ($3 == 26) {
        __label__ = 27; break;
      }
      else if ($3 == 27) {
        __label__ = 28; break;
      }
      else {
      __label__ = 29; break;
      }
      
    case 1: // $4
      $1=((STRING_TABLE.__str47347)|0);
      __label__ = 30; break;
    case 2: // $5
      $1=((STRING_TABLE.__str57348)|0);
      __label__ = 30; break;
    case 3: // $6
      $1=((STRING_TABLE.__str67349)|0);
      __label__ = 30; break;
    case 4: // $7
      $1=((STRING_TABLE.__str77350)|0);
      __label__ = 30; break;
    case 5: // $8
      $1=((STRING_TABLE.__str87351)|0);
      __label__ = 30; break;
    case 6: // $9
      $1=((STRING_TABLE.__str97352)|0);
      __label__ = 30; break;
    case 7: // $10
      $1=((STRING_TABLE.__str107353)|0);
      __label__ = 30; break;
    case 8: // $11
      $1=((STRING_TABLE.__str117354)|0);
      __label__ = 30; break;
    case 9: // $12
      $1=((STRING_TABLE.__str127355)|0);
      __label__ = 30; break;
    case 10: // $13
      $1=((STRING_TABLE.__str137356)|0);
      __label__ = 30; break;
    case 11: // $14
      $1=((STRING_TABLE.__str147357)|0);
      __label__ = 30; break;
    case 12: // $15
      $1=((STRING_TABLE.__str157358)|0);
      __label__ = 30; break;
    case 13: // $16
      $1=((STRING_TABLE.__str167359)|0);
      __label__ = 30; break;
    case 14: // $17
      $1=((STRING_TABLE.__str177360)|0);
      __label__ = 30; break;
    case 15: // $18
      $1=((STRING_TABLE.__str187361)|0);
      __label__ = 30; break;
    case 16: // $19
      $1=((STRING_TABLE.__str197362)|0);
      __label__ = 30; break;
    case 17: // $20
      $1=((STRING_TABLE.__str207363)|0);
      __label__ = 30; break;
    case 18: // $21
      $1=((STRING_TABLE.__str217364)|0);
      __label__ = 30; break;
    case 19: // $22
      $1=((STRING_TABLE.__str227365)|0);
      __label__ = 30; break;
    case 20: // $23
      $1=((STRING_TABLE.__str237366)|0);
      __label__ = 30; break;
    case 21: // $24
      $1=((STRING_TABLE.__str247367)|0);
      __label__ = 30; break;
    case 22: // $25
      $1=((STRING_TABLE.__str257368)|0);
      __label__ = 30; break;
    case 23: // $26
      $1=((STRING_TABLE.__str267369)|0);
      __label__ = 30; break;
    case 24: // $27
      $1=((STRING_TABLE.__str277370)|0);
      __label__ = 30; break;
    case 25: // $28
      $1=((STRING_TABLE.__str287371)|0);
      __label__ = 30; break;
    case 26: // $29
      $1=((STRING_TABLE.__str297372)|0);
      __label__ = 30; break;
    case 27: // $30
      $1=((STRING_TABLE.__str307373)|0);
      __label__ = 30; break;
    case 28: // $31
      $1=((STRING_TABLE.__str317374)|0);
      __label__ = 30; break;
    case 29: // $32
      $1=((STRING_TABLE.__str327375)|0);
      __label__ = 30; break;
    case 30: // $33
      var $34=$1;
      ;
      return $34;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16chd_error_string10_chd_error["X"]=1;

function __ZL11header_readP10_core_fileP11_chd_header($file, $header) {
  var __stackBase__  = STACKTOP; STACKTOP += 108; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $rawheader=__stackBase__;
      var $count;
      var $seclen;
      $2=$file;
      $3=$header;
      var $4=$3;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=4;
      __label__ = 30; break;
    case 2: // $7
      var $8=$2;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      $1=3;
      __label__ = 30; break;
    case 4: // $11
      var $12=$2;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $13=__Z10core_fseekP10_core_filexi($12, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 0);
      var $13$0=$13[0];
      var $14=$2;
      var $15=(($rawheader)|0);
      var $16=__Z10core_freadP10_core_filePvj($14, $15, 108);
      $count=$16;
      var $17=$count;
      var $18=(($17)|0)!=108;
      if ($18) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $19
      $1=9;
      __label__ = 30; break;
    case 6: // $20
      var $21=(($rawheader)|0);
      var $22=_strncmp($21, ((STRING_TABLE.__str387381)|0), 8);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $24
      $1=5;
      __label__ = 30; break;
    case 8: // $25
      var $26=$3;
      var $27=$26;
      _memset($27, 0, 148, 1);
      var $28=(($rawheader+8)|0);
      var $29=__ZL20get_bigendian_uint32PKh($28);
      var $30=$3;
      var $31=(($30)|0);
      HEAP32[(($31)>>2)]=$29;
      var $32=(($rawheader+12)|0);
      var $33=__ZL20get_bigendian_uint32PKh($32);
      var $34=$3;
      var $35=(($34+4)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$3;
      var $37=(($36+4)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==0;
      if ($39) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $40
      var $41=$3;
      var $42=(($41+4)|0);
      var $43=HEAPU32[(($42)>>2)];
      var $44=(($43)>>>0) > 4;
      if ($44) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $45
      $1=21;
      __label__ = 30; break;
    case 11: // $46
      var $47=$3;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)==1;
      if ($50) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $51
      var $52=$3;
      var $53=(($52)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=76;
      if ($55) { __label__ = 19; break; } else { __label__ = 13; break; }
    case 13: // $56
      var $57=$3;
      var $58=(($57+4)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59)|0)==2;
      if ($60) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $61
      var $62=$3;
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)!=80;
      if ($65) { __label__ = 19; break; } else { __label__ = 15; break; }
    case 15: // $66
      var $67=$3;
      var $68=(($67+4)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)==3;
      if ($70) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $71
      var $72=$3;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)!=120;
      if ($75) { __label__ = 19; break; } else { __label__ = 17; break; }
    case 17: // $76
      var $77=$3;
      var $78=(($77+4)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)==4;
      if ($80) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $81
      var $82=$3;
      var $83=(($82)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84)|0)!=108;
      if ($85) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $86
      $1=5;
      __label__ = 30; break;
    case 20: // $87
      var $88=(($rawheader+16)|0);
      var $89=__ZL20get_bigendian_uint32PKh($88);
      var $90=$3;
      var $91=(($90+8)|0);
      HEAP32[(($91)>>2)]=$89;
      var $92=(($rawheader+20)|0);
      var $93=__ZL20get_bigendian_uint32PKh($92);
      var $94=$3;
      var $95=(($94+12)|0);
      HEAP32[(($95)>>2)]=$93;
      var $96=$3;
      var $97=(($96+4)|0);
      var $98=HEAPU32[(($97)>>2)];
      var $99=(($98)>>>0) < 3;
      if ($99) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $100
      var $101=$3;
      var $102=(($101+4)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103)|0)==1;
      if ($104) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $105
      var $110 = 512;__label__ = 24; break;
    case 23: // $106
      var $107=(($rawheader+76)|0);
      var $108=__ZL20get_bigendian_uint32PKh($107);
      var $110 = $108;__label__ = 24; break;
    case 24: // $109
      var $110;
      $seclen=$110;
      var $111=(($rawheader+24)|0);
      var $112=__ZL20get_bigendian_uint32PKh($111);
      var $113=$3;
      var $114=(($113+144)|0);
      HEAP32[(($114)>>2)]=$112;
      var $115=(($rawheader+28)|0);
      var $116=__ZL20get_bigendian_uint32PKh($115);
      var $117=$3;
      var $118=(($117+20)|0);
      HEAP32[(($118)>>2)]=$116;
      var $119=(($rawheader+32)|0);
      var $120=__ZL20get_bigendian_uint32PKh($119);
      var $121=$3;
      var $122=(($121+132)|0);
      HEAP32[(($122)>>2)]=$120;
      var $123=(($rawheader+36)|0);
      var $124=__ZL20get_bigendian_uint32PKh($123);
      var $125=$3;
      var $126=(($125+140)|0);
      HEAP32[(($126)>>2)]=$124;
      var $127=(($rawheader+40)|0);
      var $128=__ZL20get_bigendian_uint32PKh($127);
      var $129=$3;
      var $130=(($129+136)|0);
      HEAP32[(($130)>>2)]=$128;
      var $131=$3;
      var $132=(($131+40)|0);
      var $133=(($132)|0);
      var $134=(($rawheader+44)|0);
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $134, $$dest = $133, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $135=$3;
      var $136=(($135+56)|0);
      var $137=(($136)|0);
      var $138=(($rawheader+60)|0);
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $138, $$dest = $137, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $139=$3;
      var $140=(($139+132)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142$0=$141;
      var $142$1=0;
      var $143=$3;
      var $144=(($143+140)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146$0=$145;
      var $146$1=0;
      var $147$0 = ((($142$0)>>>0)+((($142$1)|0)*4294967296))*((($146$0)>>>0)+((($146$1)|0)*4294967296))>>>0; var $147$1 = Math.min(Math.floor((((($142$0)>>>0)+((($142$1)|0)*4294967296))*((($146$0)>>>0)+((($146$1)|0)*4294967296)))/4294967296), 4294967295);
      var $148=$3;
      var $149=(($148+136)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151$0=$150;
      var $151$1=0;
      var $152$0 = ((($147$0)>>>0)+((($147$1)|0)*4294967296))*((($151$0)>>>0)+((($151$1)|0)*4294967296))>>>0; var $152$1 = Math.min(Math.floor((((($147$0)>>>0)+((($147$1)|0)*4294967296))*((($151$0)>>>0)+((($151$1)|0)*4294967296)))/4294967296), 4294967295);
      var $153=$seclen;
      var $154$0=$153;
      var $154$1=(($153|0) < 0 ? -1 : 0);
      var $155$0 = ((($152$0)>>>0)+((($152$1)|0)*4294967296))*((($154$0)>>>0)+((($154$1)|0)*4294967296))>>>0; var $155$1 = Math.min(Math.floor((((($152$0)>>>0)+((($152$1)|0)*4294967296))*((($154$0)>>>0)+((($154$1)|0)*4294967296)))/4294967296), 4294967295);
      var $156=$3;
      var $157=(($156+24)|0);
      var $st$60$0=(($157)|0);
      HEAP32[(($st$60$0)>>2)]=$155$0;
      var $st$60$1=(($157+4)|0);
      HEAP32[(($st$60$1)>>2)]=$155$1;
      var $158=$seclen;
      var $159=$3;
      var $160=(($159+144)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(($158*$161)|0);
      var $163=$3;
      var $164=(($163+16)|0);
      HEAP32[(($164)>>2)]=$162;
      var $165=$3;
      var $166=(($165+32)|0);
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$76$0=(($166)|0);
      HEAP32[(($st$76$0)>>2)]=$$emscripten$temp$1$0;
      var $st$76$1=(($166+4)|0);
      HEAP32[(($st$76$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 29; break;
    case 25: // $167
      var $168=$3;
      var $169=(($168+4)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($170)|0)==3;
      if ($171) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $172
      var $173=(($rawheader+24)|0);
      var $174=__ZL20get_bigendian_uint32PKh($173);
      var $175=$3;
      var $176=(($175+20)|0);
      HEAP32[(($176)>>2)]=$174;
      var $177=(($rawheader+28)|0);
      var $178=__ZL20get_bigendian_uint64PKh($177);
      var $178$0=$178[0];
      var $178$1=$178[1];
      var $179=$3;
      var $180=(($179+24)|0);
      var $st$11$0=(($180)|0);
      HEAP32[(($st$11$0)>>2)]=$178$0;
      var $st$11$1=(($180+4)|0);
      HEAP32[(($st$11$1)>>2)]=$178$1;
      var $181=(($rawheader+36)|0);
      var $182=__ZL20get_bigendian_uint64PKh($181);
      var $182$0=$182[0];
      var $182$1=$182[1];
      var $183=$3;
      var $184=(($183+32)|0);
      var $st$21$0=(($184)|0);
      HEAP32[(($st$21$0)>>2)]=$182$0;
      var $st$21$1=(($184+4)|0);
      HEAP32[(($st$21$1)>>2)]=$182$1;
      var $185=$3;
      var $186=(($185+40)|0);
      var $187=(($186)|0);
      var $188=(($rawheader+44)|0);
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $188, $$dest = $187, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $189=$3;
      var $190=(($189+56)|0);
      var $191=(($190)|0);
      var $192=(($rawheader+60)|0);
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $192, $$dest = $191, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $193=(($rawheader+76)|0);
      var $194=__ZL20get_bigendian_uint32PKh($193);
      var $195=$3;
      var $196=(($195+16)|0);
      HEAP32[(($196)>>2)]=$194;
      var $197=$3;
      var $198=(($197+72)|0);
      var $199=(($198)|0);
      var $200=(($rawheader+80)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($199, $200, 20, 1);
      var $201=$3;
      var $202=(($201+112)|0);
      var $203=(($202)|0);
      var $204=(($rawheader+100)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($203, $204, 20, 1);
      __label__ = 28; break;
    case 27: // $205
      var $206=(($rawheader+24)|0);
      var $207=__ZL20get_bigendian_uint32PKh($206);
      var $208=$3;
      var $209=(($208+20)|0);
      HEAP32[(($209)>>2)]=$207;
      var $210=(($rawheader+28)|0);
      var $211=__ZL20get_bigendian_uint64PKh($210);
      var $211$0=$211[0];
      var $211$1=$211[1];
      var $212=$3;
      var $213=(($212+24)|0);
      var $st$11$0=(($213)|0);
      HEAP32[(($st$11$0)>>2)]=$211$0;
      var $st$11$1=(($213+4)|0);
      HEAP32[(($st$11$1)>>2)]=$211$1;
      var $214=(($rawheader+36)|0);
      var $215=__ZL20get_bigendian_uint64PKh($214);
      var $215$0=$215[0];
      var $215$1=$215[1];
      var $216=$3;
      var $217=(($216+32)|0);
      var $st$21$0=(($217)|0);
      HEAP32[(($st$21$0)>>2)]=$215$0;
      var $st$21$1=(($217+4)|0);
      HEAP32[(($st$21$1)>>2)]=$215$1;
      var $218=(($rawheader+44)|0);
      var $219=__ZL20get_bigendian_uint32PKh($218);
      var $220=$3;
      var $221=(($220+16)|0);
      HEAP32[(($221)>>2)]=$219;
      var $222=$3;
      var $223=(($222+72)|0);
      var $224=(($223)|0);
      var $225=(($rawheader+48)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($224, $225, 20, 1);
      var $226=$3;
      var $227=(($226+112)|0);
      var $228=(($227)|0);
      var $229=(($rawheader+68)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($228, $229, 20, 1);
      var $230=$3;
      var $231=(($230+92)|0);
      var $232=(($231)|0);
      var $233=(($rawheader+88)|0);
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($232, $233, 20, 1);
      __label__ = 28; break;
    case 28: // $234
      __label__ = 29; break;
    case 29: // $235
      $1=0;
      __label__ = 30; break;
    case 30: // $236
      var $237=$1;
      STACKTOP = __stackBase__;
      return $237;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11header_readP10_core_fileP11_chd_header["X"]=1;

function __ZL8map_readP9_chd_file($chd) {
  var __stackBase__  = STACKTOP; STACKTOP += 8224; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $entrysize;
      var $raw_map_entries=__stackBase__;
      var $fileoffset=__stackBase__+8192;
      var $maxoffset=__stackBase__+8200;
      var $cookie=__stackBase__+8208;
      var $count;
      var $err;
      var $i;
      var $entries;
      var $j;
      $2=$chd;
      var $3=$2;
      var $4=(($3+12)|0);
      var $5=(($4+4)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=(($6)>>>0) < 3;
      var $8=$7 ? 8 : 16;
      $entrysize=$8;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$22$0=(($maxoffset)|0);
      HEAP32[(($st$22$0)>>2)]=$$emscripten$temp$0$0;
      var $st$22$1=(($maxoffset+4)|0);
      HEAP32[(($st$22$1)>>2)]=$$emscripten$temp$0$1;
      var $9=$2;
      var $10=(($9+12)|0);
      var $11=(($10+20)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12*20)|0);
      var $14=_malloc($13);
      var $15=$14;
      var $16=$2;
      var $17=(($16+164)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$2;
      var $19=(($18+164)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $22
      $1=2;
      __label__ = 40; break;
    case 2: // $23
      var $24=$2;
      var $25=(($24+12)|0);
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28$0=$27;
      var $28$1=0;
      var $st$6$0=(($fileoffset)|0);
      HEAP32[(($st$6$0)>>2)]=$28$0;
      var $st$6$1=(($fileoffset+4)|0);
      HEAP32[(($st$6$1)>>2)]=$28$1;
      $i=0;
      __label__ = 3; break;
    case 3: // $29
      var $30=$i;
      var $31=$2;
      var $32=(($31+12)|0);
      var $33=(($32+20)|0);
      var $34=HEAPU32[(($33)>>2)];
      var $35=(($30)>>>0) < (($34)>>>0);
      if ($35) { __label__ = 4; break; } else { __label__ = 31; break; }
    case 4: // $36
      var $37=$2;
      var $38=(($37+12)|0);
      var $39=(($38+20)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$i;
      var $42=(($40-$41)|0);
      $entries=$42;
      var $43=$entries;
      var $44=(($43)|0) > 512;
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      $entries=512;
      __label__ = 6; break;
    case 6: // $46
      var $47=$2;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $st$3$0=(($fileoffset)|0);
      var $50$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($fileoffset+4)|0);
      var $50$1=HEAP32[(($st$3$1)>>2)];
      var $51=__Z10core_fseekP10_core_filexi($49, $50$0, $50$1, 0);
      var $51$0=$51[0];
      var $52=$2;
      var $53=(($52+4)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($raw_map_entries)|0);
      var $56=$entries;
      var $57=$entrysize;
      var $58=(($56*$57)|0);
      var $59=__Z10core_freadP10_core_filePvj($54, $55, $58);
      $count=$59;
      var $60=$count;
      var $61=$entries;
      var $62=$entrysize;
      var $63=(($61*$62)|0);
      var $64=(($60)|0)!=(($63)|0);
      if ($64) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $65
      $err=9;
      __label__ = 37; break;
    case 8: // $66
      var $67=$entries;
      var $68=$entrysize;
      var $69=(($67*$68)|0);
      var $70$0=$69;
      var $70$1=0;
      var $st$5$0=(($fileoffset)|0);
      var $71$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($fileoffset+4)|0);
      var $71$1=HEAP32[(($st$5$1)>>2)];
      var $72$0 = ((($71$0)>>>0)+((($71$1)|0)*4294967296))+((($70$0)>>>0)+((($70$1)|0)*4294967296))>>>0; var $72$1 = Math.min(Math.floor((((($71$0)>>>0)+((($71$1)|0)*4294967296))+((($70$0)>>>0)+((($70$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($fileoffset)|0);
      HEAP32[(($st$10$0)>>2)]=$72$0;
      var $st$10$1=(($fileoffset+4)|0);
      HEAP32[(($st$10$1)>>2)]=$72$1;
      var $73=$entrysize;
      var $74=(($73)|0)==16;
      if ($74) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $75
      $j=0;
      __label__ = 10; break;
    case 10: // $76
      var $77=$j;
      var $78=$entries;
      var $79=(($77)|0) < (($78)|0);
      if ($79) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $80
      var $81=$j;
      var $82=((($81<<4))|0);
      var $83=(($raw_map_entries+$82)|0);
      var $84=$i;
      var $85=$j;
      var $86=(($84+$85)|0);
      var $87=$2;
      var $88=(($87+164)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+$86*20)|0);
      __ZL11map_extractPKhP10_map_entry($83, $90);
      __label__ = 12; break;
    case 12: // $91
      var $92=$j;
      var $93=(($92+1)|0);
      $j=$93;
      __label__ = 10; break;
    case 13: // $94
      __label__ = 19; break;
    case 14: // $95
      $j=0;
      __label__ = 15; break;
    case 15: // $96
      var $97=$j;
      var $98=$entries;
      var $99=(($97)|0) < (($98)|0);
      if ($99) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $100
      var $101=$j;
      var $102=((($101<<3))|0);
      var $103=(($raw_map_entries+$102)|0);
      var $104=$i;
      var $105=$j;
      var $106=(($104+$105)|0);
      var $107=$2;
      var $108=(($107+164)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+$106*20)|0);
      var $111=$2;
      var $112=(($111+12)|0);
      var $113=(($112+16)|0);
      var $114=HEAP32[(($113)>>2)];
      __ZL15map_extract_oldPKhP10_map_entryj($103, $110, $114);
      __label__ = 17; break;
    case 17: // $115
      var $116=$j;
      var $117=(($116+1)|0);
      $j=$117;
      __label__ = 15; break;
    case 18: // $118
      __label__ = 19; break;
    case 19: // $119
      $j=0;
      __label__ = 20; break;
    case 20: // $120
      var $121=$j;
      var $122=$entries;
      var $123=(($121)|0) < (($122)|0);
      if ($123) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $124
      var $125=$i;
      var $126=$j;
      var $127=(($125+$126)|0);
      var $128=$2;
      var $129=(($128+164)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+$127*20)|0);
      var $132=(($131+16)|0);
      var $133=HEAPU8[($132)];
      var $134=(($133)&255);
      var $135=$134 & 15;
      var $136=(($135)|0)==1;
      if ($136) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $137
      var $138=$i;
      var $139=$j;
      var $140=(($138+$139)|0);
      var $141=$2;
      var $142=(($141+164)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+$140*20)|0);
      var $145=(($144+16)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$147 & 15;
      var $149=(($148)|0)==2;
      if ($149) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $150
      var $st$0$0=(($maxoffset)|0);
      var $151$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($maxoffset+4)|0);
      var $151$1=HEAP32[(($st$0$1)>>2)];
      var $152=$i;
      var $153=$j;
      var $154=(($152+$153)|0);
      var $155=$2;
      var $156=(($155+164)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157+$154*20)|0);
      var $159=(($158)|0);
      var $st$12$0=(($159)|0);
      var $160$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($159+4)|0);
      var $160$1=HEAP32[(($st$12$1)>>2)];
      var $161=$i;
      var $162=$j;
      var $163=(($161+$162)|0);
      var $164=$2;
      var $165=(($164+164)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166+$163*20)|0);
      var $168=(($167+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170$0=$169;
      var $170$1=0;
      var $171$0 = ((($160$0)>>>0)+((($160$1)|0)*4294967296))+((($170$0)>>>0)+((($170$1)|0)*4294967296))>>>0; var $171$1 = Math.min(Math.floor((((($160$0)>>>0)+((($160$1)|0)*4294967296))+((($170$0)>>>0)+((($170$1)|0)*4294967296)))/4294967296), 4294967295);
      var $172=$151$1 > $171$1 || ($151$1 == $171$1 && $151$0 > $171$0);
      if ($172) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $173
      var $st$0$0=(($maxoffset)|0);
      var $174$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($maxoffset+4)|0);
      var $174$1=HEAP32[(($st$0$1)>>2)];
      var $197$1 = $174$1;var $197$0 = $174$0;__label__ = 26; break;
    case 25: // $175
      var $176=$i;
      var $177=$j;
      var $178=(($176+$177)|0);
      var $179=$2;
      var $180=(($179+164)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=(($181+$178*20)|0);
      var $183=(($182)|0);
      var $st$8$0=(($183)|0);
      var $184$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($183+4)|0);
      var $184$1=HEAP32[(($st$8$1)>>2)];
      var $185=$i;
      var $186=$j;
      var $187=(($185+$186)|0);
      var $188=$2;
      var $189=(($188+164)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190+$187*20)|0);
      var $192=(($191+12)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194$0=$193;
      var $194$1=0;
      var $195$0 = ((($184$0)>>>0)+((($184$1)|0)*4294967296))+((($194$0)>>>0)+((($194$1)|0)*4294967296))>>>0; var $195$1 = Math.min(Math.floor((((($184$0)>>>0)+((($184$1)|0)*4294967296))+((($194$0)>>>0)+((($194$1)|0)*4294967296)))/4294967296), 4294967295);
      var $197$1 = $195$1;var $197$0 = $195$0;__label__ = 26; break;
    case 26: // $196
      var $197$0;
      var $197$1;
      var $st$2$0=(($maxoffset)|0);
      HEAP32[(($st$2$0)>>2)]=$197$0;
      var $st$2$1=(($maxoffset+4)|0);
      HEAP32[(($st$2$1)>>2)]=$197$1;
      __label__ = 27; break;
    case 27: // $198
      __label__ = 28; break;
    case 28: // $199
      var $200=$j;
      var $201=(($200+1)|0);
      $j=$201;
      __label__ = 20; break;
    case 29: // $202
      __label__ = 30; break;
    case 30: // $203
      var $204=$i;
      var $205=(($204+512)|0);
      $i=$205;
      __label__ = 3; break;
    case 31: // $206
      var $207=$2;
      var $208=(($207+4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $st$3$0=(($fileoffset)|0);
      var $210$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($fileoffset+4)|0);
      var $210$1=HEAP32[(($st$3$1)>>2)];
      var $211=__Z10core_fseekP10_core_filexi($209, $210$0, $210$1, 0);
      var $211$0=$211[0];
      var $212=$2;
      var $213=(($212+4)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=$cookie;
      var $216=$entrysize;
      var $217=__Z10core_freadP10_core_filePvj($214, $215, $216);
      $count=$217;
      var $218=$count;
      var $219=$entrysize;
      var $220=(($218)|0)!=(($219)|0);
      if ($220) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $221
      var $222=$cookie;
      var $223=$entrysize;
      var $224=_memcmp($222, ((STRING_TABLE.__str377380)|0), $223);
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $226
      $err=3;
      __label__ = 37; break;
    case 34: // $227
      var $st$0$0=(($maxoffset)|0);
      var $228$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($maxoffset+4)|0);
      var $228$1=HEAP32[(($st$0$1)>>2)];
      var $229=$2;
      var $230=(($229+4)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=__Z10core_fsizeP10_core_file($231);
      var $232$0=$232[0];
      var $232$1=$232[1];
      var $233=$228$1 > $232$1 || ($228$1 == $232$1 && $228$0 > $232$0);
      if ($233) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $234
      $err=3;
      __label__ = 37; break;
    case 36: // $235
      $1=0;
      __label__ = 40; break;
    case 37: // $236
      var $237=$2;
      var $238=(($237+164)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(($239)|0)!=0;
      if ($240) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $241
      var $242=$2;
      var $243=(($242+164)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$244;
      _free($245);
      __label__ = 39; break;
    case 39: // $246
      var $247=$2;
      var $248=(($247+164)|0);
      HEAP32[(($248)>>2)]=0;
      var $249=$err;
      $1=$249;
      __label__ = 40; break;
    case 40: // $250
      var $251=$1;
      STACKTOP = __stackBase__;
      return $251;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8map_readP9_chd_file["X"]=1;

function __Z8chd_openPKciP9_chd_filePS2_($filename, $mode, $parent, $chd) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $err;
      var $filerr;
      var $file=__stackBase__;
      var $openflags;
      $1=$filename;
      $2=$mode;
      $3=$parent;
      $4=$chd;
      HEAP32[(($file)>>2)]=0;
      var $5=$2;
      if ($5 == 1) {
        __label__ = 1; break;
      }
      else if ($5 == 2) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $6
      $openflags=1;
      __label__ = 4; break;
    case 2: // $7
      $openflags=3;
      __label__ = 4; break;
    case 3: // $8
      $err=4;
      __label__ = 9; break;
    case 4: // $9
      var $10=$1;
      var $11=$openflags;
      var $12=__Z10core_fopenPKcjPP10_core_file($10, $11, $file);
      $filerr=$12;
      var $13=$filerr;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $15
      $err=6;
      __label__ = 9; break;
    case 6: // $16
      var $17=HEAP32[(($file)>>2)];
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=__Z13chd_open_fileP10_core_fileiP9_chd_filePS2_($17, $18, $19, $20);
      $err=$21;
      var $22=$err;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $24
      __label__ = 9; break;
    case 8: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+8)|0);
      HEAP8[($28)]=1;
      __label__ = 9; break;
    case 9: // $29
      var $30=$err;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $32
      var $33=HEAP32[(($file)>>2)];
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $35
      var $36=HEAP32[(($file)>>2)];
      __Z11core_fcloseP10_core_file($36);
      __label__ = 12; break;
    case 12: // $37
      var $38=$err;
      STACKTOP = __stackBase__;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z8chd_openPKciP9_chd_filePS2_["X"]=1;

function __ZL22wait_for_pending_asyncP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $wait_successful;
      $1=$chd;
      var $2=$1;
      var $3=(($2+600)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+600)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=_osd_ticks_per_second();
      var $10$0=$10[0];
      var $10$1=$10[1];
      var $$emscripten$temp$0$0=10;
      var $$emscripten$temp$0$1=0;
      var $11$0 = ((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))*((($10$0)>>>0)+((($10$1)|0)*4294967296))>>>0; var $11$1 = Math.min(Math.floor((((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))*((($10$0)>>>0)+((($10$1)|0)*4294967296)))/4294967296), 4294967295);
      var $12=_osd_work_item_wait($9, $11$0, $11$1);
      var $12$0=$12[0];
      $wait_successful=$12;
      var $13=$wait_successful;
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $15
      _osd_break_into_debugger(((STRING_TABLE.__str397382)|0));
      __label__ = 3; break;
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z14chd_get_headerP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$chd;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=-1163005939;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=0;
      __label__ = 4; break;
    case 3: // $11
      var $12=$2;
      var $13=(($12+12)|0);
      $1=$13;
      __label__ = 4; break;
    case 4: // $14
      var $15=$1;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8chd_readP9_chd_filejPv($chd, $hunknum, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$chd;
      $3=$hunknum;
      $4=$buffer;
      var $5=$2;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=-1163005939;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $1=4;
      __label__ = 6; break;
    case 3: // $13
      var $14=$3;
      var $15=$2;
      var $16=(($15+12)|0);
      var $17=(($16+20)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($14)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      $1=13;
      __label__ = 6; break;
    case 5: // $21
      var $22=$2;
      __ZL22wait_for_pending_asyncP9_chd_file($22);
      var $23=$2;
      var $24=$3;
      var $25=$4;
      var $26=__ZL21hunk_read_into_memoryP9_chd_filejPh($23, $24, $25);
      $1=$26;
      __label__ = 6; break;
    case 6: // $27
      var $28=$1;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21hunk_read_into_memoryP9_chd_filejPh($chd, $hunknum, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $entry;
      var $err;
      var $bytes;
      $2=$chd;
      $3=$hunknum;
      $4=$dest;
      var $5=$3;
      var $6=$2;
      var $7=(($6+164)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+$5*20)|0);
      $entry=$9;
      var $10=$3;
      var $11=$2;
      var $12=(($11+12)|0);
      var $13=(($12+20)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($10)>>>0) >= (($14)>>>0);
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=13;
      __label__ = 26; break;
    case 2: // $17
      var $18=$entry;
      var $19=(($18+16)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$21 & 15;
      if ($22 == 1) {
        __label__ = 3; break;
      }
      else if ($22 == 2) {
        __label__ = 10; break;
      }
      else if ($22 == 3) {
        __label__ = 13; break;
      }
      else if ($22 == 4) {
        __label__ = 18; break;
      }
      else if ($22 == 5) {
        __label__ = 22; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 3: // $23
      var $24=$2;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$entry;
      var $28=(($27)|0);
      var $st$5$0=(($28)|0);
      var $29$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($28+4)|0);
      var $29$1=HEAP32[(($st$5$1)>>2)];
      var $30=__Z10core_fseekP10_core_filexi($26, $29$0, $29$1, 0);
      var $30$0=$30[0];
      var $31=$2;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$2;
      var $35=(($34+184)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$entry;
      var $38=(($37+12)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=__Z10core_freadP10_core_filePvj($33, $36, $39);
      $bytes=$40;
      var $41=$bytes;
      var $42=$entry;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($41)|0)!=(($44)|0);
      if ($45) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $46
      $1=9;
      __label__ = 26; break;
    case 5: // $47
      $err=0;
      var $48=$2;
      var $49=(($48+188)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+24)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $54
      var $55=$2;
      var $56=(($55+188)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+24)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$2;
      var $61=$entry;
      var $62=(($61+12)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$4;
      var $65=FUNCTION_TABLE[$59]($60, $63, $64);
      $err=$65;
      __label__ = 7; break;
    case 7: // $66
      var $67=$err;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $69
      var $70=$err;
      $1=$70;
      __label__ = 26; break;
    case 9: // $71
      __label__ = 25; break;
    case 10: // $72
      var $73=$2;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$entry;
      var $77=(($76)|0);
      var $st$5$0=(($77)|0);
      var $78$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($77+4)|0);
      var $78$1=HEAP32[(($st$5$1)>>2)];
      var $79=__Z10core_fseekP10_core_filexi($75, $78$0, $78$1, 0);
      var $79$0=$79[0];
      var $80=$2;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$4;
      var $84=$2;
      var $85=(($84+12)|0);
      var $86=(($85+16)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=__Z10core_freadP10_core_filePvj($82, $83, $87);
      $bytes=$88;
      var $89=$bytes;
      var $90=$2;
      var $91=(($90+12)|0);
      var $92=(($91+16)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($89)|0)!=(($93)|0);
      if ($94) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $95
      $1=9;
      __label__ = 26; break;
    case 12: // $96
      __label__ = 25; break;
    case 13: // $97
      var $98=$4;
      var $99=(($98)|0);
      var $100=$entry;
      var $101=(($100)|0);
      var $st$4$0=(($101)|0);
      var $102$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($101+4)|0);
      var $102$1=HEAP32[(($st$4$1)>>2)];
      __ZL20put_bigendian_uint64Phy($99, $102$0, $102$1);
      $bytes=8;
      __label__ = 14; break;
    case 14: // $103
      var $104=$bytes;
      var $105=$2;
      var $106=(($105+12)|0);
      var $107=(($106+16)|0);
      var $108=HEAPU32[(($107)>>2)];
      var $109=(($104)>>>0) < (($108)>>>0);
      if ($109) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $110
      var $111=$bytes;
      var $112=(($111-8)|0);
      var $113=$4;
      var $114=(($113+$112)|0);
      var $115=HEAP8[($114)];
      var $116=$bytes;
      var $117=$4;
      var $118=(($117+$116)|0);
      HEAP8[($118)]=$115;
      __label__ = 16; break;
    case 16: // $119
      var $120=$bytes;
      var $121=(($120+1)|0);
      $bytes=$121;
      __label__ = 14; break;
    case 17: // $122
      __label__ = 25; break;
    case 18: // $123
      var $124=$2;
      var $125=(($124+172)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127$0=$126;
      var $127$1=0;
      var $128=$entry;
      var $129=(($128)|0);
      var $st$7$0=(($129)|0);
      var $130$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($129+4)|0);
      var $130$1=HEAP32[(($st$7$1)>>2)];
      var $131=$127$0 == $130$0 && $127$1 == $130$1;
      if ($131) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $132
      var $133=$4;
      var $134=$2;
      var $135=(($134+168)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($133)|0)==(($136)|0);
      if ($137) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $138
      __label__ = 25; break;
    case 21: // $139
      var $140=$2;
      var $141=$entry;
      var $142=(($141)|0);
      var $st$3$0=(($142)|0);
      var $143$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($142+4)|0);
      var $143$1=HEAP32[(($st$3$1)>>2)];
      var $144$0=$143$0;
      var $144=$144$0;
      var $145=$4;
      var $146=__ZL21hunk_read_into_memoryP9_chd_filejPh($140, $144, $145);
      $1=$146;
      __label__ = 26; break;
    case 22: // $147
      var $148=$2;
      var $149=(($148+160)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$entry;
      var $152=(($151)|0);
      var $st$5$0=(($152)|0);
      var $153$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($152+4)|0);
      var $153$1=HEAP32[(($st$5$1)>>2)];
      var $154$0=$153$0;
      var $154=$154$0;
      var $155=$4;
      var $156=__ZL21hunk_read_into_memoryP9_chd_filejPh($150, $154, $155);
      $err=$156;
      var $157=$err;
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $159
      var $160=$err;
      $1=$160;
      __label__ = 26; break;
    case 24: // $161
      __label__ = 25; break;
    case 25: // $162
      $1=0;
      __label__ = 26; break;
    case 26: // $163
      var $164=$1;
      ;
      return $164;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21hunk_read_into_memoryP9_chd_filejPh["X"]=1;

function __Z14chd_read_asyncP9_chd_filejPv($chd, $hunknum, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$chd;
      $3=$hunknum;
      $4=$buffer;
      var $5=$2;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=-1163005939;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      $1=4;
      __label__ = 8; break;
    case 3: // $13
      var $14=$3;
      var $15=$2;
      var $16=(($15+12)|0);
      var $17=(($16+20)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($14)>>>0) >= (($18)>>>0);
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      $1=13;
      __label__ = 8; break;
    case 5: // $21
      var $22=$2;
      __ZL22wait_for_pending_asyncP9_chd_file($22);
      var $23=$3;
      var $24=$2;
      var $25=(($24+604)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$4;
      var $27=$2;
      var $28=(($27+608)|0);
      HEAP32[(($28)>>2)]=$26;
      var $29=$2;
      var $30=__ZL21queue_async_operationP9_chd_filePFPvS1_iE($29, 1486);
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $32
      $1=25;
      __label__ = 8; break;
    case 7: // $33
      var $34=$2;
      var $35=$3;
      var $36=$4;
      var $37=__Z8chd_readP9_chd_filejPv($34, $35, $36);
      $1=$37;
      __label__ = 8; break;
    case 8: // $38
      var $39=$1;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z14chd_read_asyncP9_chd_filejPv["X"]=1;

function __ZL21queue_async_operationP9_chd_filePFPvS1_iE($chd, $callback) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$chd;
      $3=$callback;
      var $4=$2;
      var $5=(($4+596)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=_osd_work_queue_alloc(1);
      var $10=$2;
      var $11=(($10+596)|0);
      HEAP32[(($11)>>2)]=$9;
      var $12=$2;
      var $13=(($12+596)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      $1=0;
      __label__ = 9; break;
    case 3: // $17
      __label__ = 4; break;
    case 4: // $18
      var $19=$2;
      var $20=(($19+600)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      $1=0;
      __label__ = 9; break;
    case 6: // $24
      var $25=$2;
      var $26=(($25+596)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=$2;
      var $30=$29;
      var $31=_osd_work_item_queue($27, $28, $30, 0);
      var $32=$2;
      var $33=(($32+600)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$2;
      var $35=(($34+600)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      $1=0;
      __label__ = 9; break;
    case 8: // $39
      $1=1;
      __label__ = 9; break;
    case 9: // $40
      var $41=$1;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21queue_async_operationP9_chd_filePFPvS1_iE["X"]=1;

function __ZL19async_read_callbackPvi($param, $threadid) {
  ;
  var __label__;

  var $1;
  var $2;
  var $chd;
  var $err;
  $1=$param;
  $2=$threadid;
  var $3=$1;
  var $4=$3;
  $chd=$4;
  var $5=$chd;
  var $6=$chd;
  var $7=(($6+604)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$chd;
  var $10=(($9+608)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=__ZL21hunk_read_into_memoryP9_chd_filejPh($5, $8, $11);
  $err=$12;
  var $13=$err;
  var $14=$13;
  ;
  return $14;
}


function __Z18chd_async_completeP9_chd_file($chd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      $2=$chd;
      var $3=$2;
      var $4=(($3+600)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=26;
      __label__ = 3; break;
    case 2: // $8
      var $9=$2;
      __ZL22wait_for_pending_asyncP9_chd_file($9);
      var $10=$2;
      var $11=(($10+600)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=_osd_work_item_result($12);
      $result=$13;
      var $14=$2;
      var $15=(($14+600)|0);
      var $16=HEAP32[(($15)>>2)];
      _osd_work_item_release($16);
      var $17=$2;
      var $18=(($17+600)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=$result;
      var $20=$19;
      $1=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph($chd, $searchtag, $searchindex, $output, $outputlen, $resultlen, $resulttag, $resultflags) {
  var __stackBase__  = STACKTOP; STACKTOP += 292; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $metaentry=__stackBase__;
      var $err;
      var $count;
      var $faux_metadata=__stackBase__+36;
      var $faux_length;
      $2=$chd;
      $3=$searchtag;
      $4=$searchindex;
      $5=$output;
      $6=$outputlen;
      $7=$resultlen;
      $8=$resulttag;
      $9=$resultflags;
      var $10=$2;
      __ZL22wait_for_pending_asyncP9_chd_file($10);
      var $11=$2;
      var $12=$3;
      var $13=$4;
      var $14=__ZL19metadata_find_entryP9_chd_filejjP15_metadata_entry($11, $12, $13, $metaentry);
      $err=$14;
      var $15=$err;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $17
      var $18=$2;
      var $19=(($18+12)|0);
      var $20=(($19+4)|0);
      var $21=HEAPU32[(($20)>>2)];
      var $22=(($21)>>>0) < 3;
      if ($22) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $23
      var $24=$3;
      var $25=(($24)|0)==1195656260;
      if ($25) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $26
      var $27=$3;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $29
      var $30=$4;
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $32
      var $33=(($faux_metadata)|0);
      var $34=$2;
      var $35=(($34+12)|0);
      var $36=(($35+132)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$2;
      var $39=(($38+12)|0);
      var $40=(($39+140)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$2;
      var $43=(($42+12)|0);
      var $44=(($43+136)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$2;
      var $47=(($46+12)|0);
      var $48=(($47+16)|0);
      var $49=HEAPU32[(($48)>>2)];
      var $50=$2;
      var $51=(($50+12)|0);
      var $52=(($51+144)|0);
      var $53=HEAPU32[(($52)>>2)];
      var $54=Math.floor((($49)>>>0)/(($53)>>>0));
      var $55=_sprintf($33, ((STRING_TABLE.__str337376)|0), (tempInt=STACKTOP,STACKTOP += 16,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$37,HEAP32[((tempInt+4)>>2)]=$41,HEAP32[((tempInt+8)>>2)]=$45,HEAP32[((tempInt+12)>>2)]=$54,tempInt));
      var $56=(($faux_metadata)|0);
      var $57=_strlen($56);
      var $58=(($57+1)|0);
      $faux_length=$58;
      var $59=$5;
      var $60=(($faux_metadata)|0);
      var $61=$6;
      var $62=$faux_length;
      var $63=(($61)>>>0) < (($62)>>>0);
      var $64=$6;
      var $65=$faux_length;
      var $66=$63 ? $64 : $65;
      assert($66 % 1 === 0, 'memcpy given ' + $66 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($59, $60, $66, 1);
      var $67=$7;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $69
      var $70=$faux_length;
      var $71=$7;
      HEAP32[(($71)>>2)]=$70;
      __label__ = 7; break;
    case 7: // $72
      var $73=$8;
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $75
      var $76=$8;
      HEAP32[(($76)>>2)]=1195656260;
      __label__ = 9; break;
    case 9: // $77
      $1=0;
      __label__ = 23; break;
    case 10: // $78
      var $79=$err;
      $1=$79;
      __label__ = 23; break;
    case 11: // $80
      var $81=$6;
      var $82=(($metaentry+24)|0);
      var $83=HEAPU32[(($82)>>2)];
      var $84=(($81)>>>0) < (($83)>>>0);
      if ($84) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $85
      var $86=$6;
      var $91 = $86;__label__ = 14; break;
    case 13: // $87
      var $88=(($metaentry+24)|0);
      var $89=HEAP32[(($88)>>2)];
      var $91 = $89;__label__ = 14; break;
    case 14: // $90
      var $91;
      $6=$91;
      var $92=$2;
      var $93=(($92+4)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($metaentry)|0);
      var $st$6$0=(($95)|0);
      var $96$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($95+4)|0);
      var $96$1=HEAP32[(($st$6$1)>>2)];
      var $$emscripten$temp$0$0=16;
      var $$emscripten$temp$0$1=0;
      var $97$0 = ((($96$0)>>>0)+((($96$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $97$1 = Math.min(Math.floor((((($96$0)>>>0)+((($96$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $98=__Z10core_fseekP10_core_filexi($94, $97$0, $97$1, 0);
      var $98$0=$98[0];
      var $99=$2;
      var $100=(($99+4)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$5;
      var $103=$6;
      var $104=__Z10core_freadP10_core_filePvj($101, $102, $103);
      $count=$104;
      var $105=$count;
      var $106=$6;
      var $107=(($105)|0)!=(($106)|0);
      if ($107) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $108
      $1=9;
      __label__ = 23; break;
    case 16: // $109
      var $110=$7;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $112
      var $113=(($metaentry+24)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$7;
      HEAP32[(($115)>>2)]=$114;
      __label__ = 18; break;
    case 18: // $116
      var $117=$8;
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $119
      var $120=(($metaentry+28)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$8;
      HEAP32[(($122)>>2)]=$121;
      __label__ = 20; break;
    case 20: // $123
      var $124=$9;
      var $125=(($124)|0)!=0;
      if ($125) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $126
      var $127=(($metaentry+32)|0);
      var $128=HEAP8[($127)];
      var $129=$9;
      HEAP8[($129)]=$128;
      __label__ = 22; break;
    case 22: // $130
      $1=0;
      __label__ = 23; break;
    case 23: // $131
      var $132=$1;
      STACKTOP = __stackBase__;
      return $132;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph["X"]=1;

function __ZL19metadata_find_entryP9_chd_filejjP15_metadata_entry($chd, $metatag, $metaindex, $metaentry) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $raw_meta_header=__stackBase__;
      var $count;
      $2=$chd;
      $3=$metatag;
      $4=$metaindex;
      $5=$metaentry;
      var $6=$2;
      var $7=(($6+12)|0);
      var $8=(($7+32)|0);
      var $st$14$0=(($8)|0);
      var $9$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($8+4)|0);
      var $9$1=HEAP32[(($st$14$1)>>2)];
      var $10=$5;
      var $11=(($10)|0);
      var $st$20$0=(($11)|0);
      HEAP32[(($st$20$0)>>2)]=$9$0;
      var $st$20$1=(($11+4)|0);
      HEAP32[(($st$20$1)>>2)]=$9$1;
      var $12=$5;
      var $13=(($12+16)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$28$0=(($13)|0);
      HEAP32[(($st$28$0)>>2)]=$$emscripten$temp$0$0;
      var $st$28$1=(($13+4)|0);
      HEAP32[(($st$28$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 1; break;
    case 1: // $14
      var $15=$5;
      var $16=(($15)|0);
      var $st$2$0=(($16)|0);
      var $17$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $18=$17$0 != $$emscripten$temp$1$0 || $17$1 != $$emscripten$temp$1$1;
      if ($18) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $19
      var $20=$2;
      var $21=(($20+4)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$5;
      var $24=(($23)|0);
      var $st$5$0=(($24)|0);
      var $25$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($24+4)|0);
      var $25$1=HEAP32[(($st$5$1)>>2)];
      var $26=__Z10core_fseekP10_core_filexi($22, $25$0, $25$1, 0);
      var $26$0=$26[0];
      var $27=$2;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($raw_meta_header)|0);
      var $31=__Z10core_freadP10_core_filePvj($29, $30, 16);
      $count=$31;
      var $32=$count;
      var $33=(($32)|0)!=16;
      if ($33) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $34
      __label__ = 10; break;
    case 4: // $35
      var $36=(($raw_meta_header)|0);
      var $37=__ZL20get_bigendian_uint32PKh($36);
      var $38=$5;
      var $39=(($38+28)|0);
      HEAP32[(($39)>>2)]=$37;
      var $40=(($raw_meta_header+4)|0);
      var $41=__ZL20get_bigendian_uint32PKh($40);
      var $42=$5;
      var $43=(($42+24)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=(($raw_meta_header+8)|0);
      var $45=__ZL20get_bigendian_uint64PKh($44);
      var $45$0=$45[0];
      var $45$1=$45[1];
      var $46=$5;
      var $47=(($46+8)|0);
      var $st$16$0=(($47)|0);
      HEAP32[(($st$16$0)>>2)]=$45$0;
      var $st$16$1=(($47+4)|0);
      HEAP32[(($st$16$1)>>2)]=$45$1;
      var $48=$5;
      var $49=(($48+24)|0);
      var $50=HEAPU32[(($49)>>2)];
      var $51=$50 >>> 24;
      var $52=(($51) & 255);
      var $53=$5;
      var $54=(($53+32)|0);
      HEAP8[($54)]=$52;
      var $55=$5;
      var $56=(($55+24)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$57 & 16777215;
      HEAP32[(($56)>>2)]=$58;
      var $59=$3;
      var $60=(($59)|0)==0;
      if ($60) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $61
      var $62=$5;
      var $63=(($62+28)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$3;
      var $66=(($64)|0)==(($65)|0);
      if ($66) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $67
      var $68=$4;
      var $69=(($68-1)|0);
      $4=$69;
      var $70=(($68)|0)==0;
      if ($70) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $71
      $1=0;
      __label__ = 11; break;
    case 8: // $72
      __label__ = 9; break;
    case 9: // $73
      var $74=$5;
      var $75=(($74)|0);
      var $st$2$0=(($75)|0);
      var $76$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($75+4)|0);
      var $76$1=HEAP32[(($st$2$1)>>2)];
      var $77=$5;
      var $78=(($77+16)|0);
      var $st$8$0=(($78)|0);
      HEAP32[(($st$8$0)>>2)]=$76$0;
      var $st$8$1=(($78+4)|0);
      HEAP32[(($st$8$1)>>2)]=$76$1;
      var $79=$5;
      var $80=(($79+8)|0);
      var $st$14$0=(($80)|0);
      var $81$0=HEAP32[(($st$14$0)>>2)];
      var $st$14$1=(($80+4)|0);
      var $81$1=HEAP32[(($st$14$1)>>2)];
      var $82=$5;
      var $83=(($82)|0);
      var $st$20$0=(($83)|0);
      HEAP32[(($st$20$0)>>2)]=$81$0;
      var $st$20$1=(($83+4)|0);
      HEAP32[(($st$20$1)>>2)]=$81$1;
      __label__ = 1; break;
    case 10: // $84
      $1=19;
      __label__ = 11; break;
    case 11: // $85
      var $86=$1;
      STACKTOP = __stackBase__;
      return $86;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19metadata_find_entryP9_chd_filejjP15_metadata_entry["X"]=1;

function __ZL20put_bigendian_uint32Phj($base, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$base;
  $2=$value;
  var $3=$2;
  var $4=$3 >>> 24;
  var $5=(($4) & 255);
  var $6=$1;
  var $7=(($6)|0);
  HEAP8[($7)]=$5;
  var $8=$2;
  var $9=$8 >>> 16;
  var $10=(($9) & 255);
  var $11=$1;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$10;
  var $13=$2;
  var $14=$13 >>> 8;
  var $15=(($14) & 255);
  var $16=$1;
  var $17=(($16+2)|0);
  HEAP8[($17)]=$15;
  var $18=$2;
  var $19=(($18) & 255);
  var $20=$1;
  var $21=(($20+3)|0);
  HEAP8[($21)]=$19;
  ;
  return;
}


function __ZL20put_bigendian_uint64Phy($base, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$base;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$value$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$value$1;
  var $st$7$0=(($2)|0);
  var $3$0=HEAP32[(($st$7$0)>>2)];
  var $st$7$1=(($2+4)|0);
  var $3$1=HEAPU32[(($st$7$1)>>2)];
  var $4$0=($3$1 >>> 24) | (0 << 8);
  var $4$1=(0 >>> 24) | (0 << 8);
  var $5$0=$4$0;
  var $5=$5$0&255;
  var $6=$1;
  var $7=(($6)|0);
  HEAP8[($7)]=$5;
  var $st$18$0=(($2)|0);
  var $8$0=HEAP32[(($st$18$0)>>2)];
  var $st$18$1=(($2+4)|0);
  var $8$1=HEAPU32[(($st$18$1)>>2)];
  var $9$0=($8$1 >>> 16) | (0 << 16);
  var $9$1=(0 >>> 16) | (0 << 16);
  var $10$0=$9$0;
  var $10=$10$0&255;
  var $11=$1;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$10;
  var $st$29$0=(($2)|0);
  var $13$0=HEAP32[(($st$29$0)>>2)];
  var $st$29$1=(($2+4)|0);
  var $13$1=HEAPU32[(($st$29$1)>>2)];
  var $14$0=($13$1 >>> 8) | (0 << 24);
  var $14$1=(0 >>> 8) | (0 << 24);
  var $15$0=$14$0;
  var $15=$15$0&255;
  var $16=$1;
  var $17=(($16+2)|0);
  HEAP8[($17)]=$15;
  var $st$40$0=(($2)|0);
  var $18$0=HEAP32[(($st$40$0)>>2)];
  var $st$40$1=(($2+4)|0);
  var $18$1=HEAP32[(($st$40$1)>>2)];
  var $19$0=$18$1;
  var $19$1=0;
  var $20$0=$19$0;
  var $20=$20$0&255;
  var $21=$1;
  var $22=(($21+3)|0);
  HEAP8[($22)]=$20;
  var $st$51$0=(($2)|0);
  var $23$0=HEAPU32[(($st$51$0)>>2)];
  var $st$51$1=(($2+4)|0);
  var $23$1=HEAPU32[(($st$51$1)>>2)];
  var $24$0=($23$0 >>> 24) | ($23$1 << 8);
  var $24$1=($23$1 >>> 24) | (0 << 8);
  var $25$0=$24$0;
  var $25=$25$0&255;
  var $26=$1;
  var $27=(($26+4)|0);
  HEAP8[($27)]=$25;
  var $st$62$0=(($2)|0);
  var $28$0=HEAPU32[(($st$62$0)>>2)];
  var $st$62$1=(($2+4)|0);
  var $28$1=HEAPU32[(($st$62$1)>>2)];
  var $29$0=($28$0 >>> 16) | ($28$1 << 16);
  var $29$1=($28$1 >>> 16) | (0 << 16);
  var $30$0=$29$0;
  var $30=$30$0&255;
  var $31=$1;
  var $32=(($31+5)|0);
  HEAP8[($32)]=$30;
  var $st$73$0=(($2)|0);
  var $33$0=HEAPU32[(($st$73$0)>>2)];
  var $st$73$1=(($2+4)|0);
  var $33$1=HEAPU32[(($st$73$1)>>2)];
  var $34$0=($33$0 >>> 8) | ($33$1 << 24);
  var $34$1=($33$1 >>> 8) | (0 << 24);
  var $35$0=$34$0;
  var $35=$35$0&255;
  var $36=$1;
  var $37=(($36+6)|0);
  HEAP8[($37)]=$35;
  var $st$84$0=(($2)|0);
  var $38$0=HEAP32[(($st$84$0)>>2)];
  var $st$84$1=(($2+4)|0);
  var $38$1=HEAP32[(($st$84$1)>>2)];
  var $39$0=$38$0;
  var $39=$39$0&255;
  var $40=$1;
  var $41=(($40+7)|0);
  HEAP8[($41)]=$39;
  STACKTOP = __stackBase__;
  return;
}
__ZL20put_bigendian_uint64Phy["X"]=1;

function __Z16chd_set_metadataP9_chd_filejjPKvjh($chd, $metatag, $metaindex, $inputbuf, $inputlen, $flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $raw_meta_header=__stackBase__;
      var $metaentry=__stackBase__+16;
      var $err;
      var $offset=__stackBase__+52;
      var $count;
      $2=$chd;
      $3=$metatag;
      $4=$metaindex;
      $5=$inputbuf;
      $6=$inputlen;
      $7=$flags;
      var $8=$metaentry;
      for (var $$dest = $8>>2, $$stop = $$dest + 9; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      var $9=$8;
      var $10=(($9+33)|0);
      var $11=$2;
      var $12=(($11+12)|0);
      var $13=(($12+4)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($14)>>>0) < 3;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=18;
      __label__ = 30; break;
    case 2: // $17
      var $18=$2;
      var $19=(($18+12)|0);
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 & 2;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $24
      $1=8;
      __label__ = 30; break;
    case 4: // $25
      var $26=$6;
      var $27=(($26)>>>0) < 1;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      $1=4;
      __label__ = 30; break;
    case 6: // $29
      var $30=$6;
      var $31=(($30)>>>0) >= 16777216;
      if ($31) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $32
      $1=4;
      __label__ = 30; break;
    case 8: // $33
      var $34=$2;
      __ZL22wait_for_pending_asyncP9_chd_file($34);
      var $35=$2;
      var $36=$3;
      var $37=$4;
      var $38=__ZL19metadata_find_entryP9_chd_filejjP15_metadata_entry($35, $36, $37, $metaentry);
      $err=$38;
      var $39=$err;
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $41
      var $42=$6;
      var $43=(($metaentry+24)|0);
      var $44=HEAPU32[(($43)>>2)];
      var $45=(($42)>>>0) <= (($44)>>>0);
      if ($45) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $46
      var $47=$2;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($metaentry)|0);
      var $st$4$0=(($50)|0);
      var $51$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($50+4)|0);
      var $51$1=HEAP32[(($st$4$1)>>2)];
      var $$emscripten$temp$0$0=16;
      var $$emscripten$temp$0$1=0;
      var $52$0 = ((($51$0)>>>0)+((($51$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $52$1 = Math.min(Math.floor((((($51$0)>>>0)+((($51$1)|0)*4294967296))+((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $53=__Z10core_fseekP10_core_filexi($49, $52$0, $52$1, 0);
      var $53$0=$53[0];
      var $54=$2;
      var $55=(($54+4)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$5;
      var $58=$6;
      var $59=__Z11core_fwriteP10_core_filePKvj($56, $57, $58);
      $count=$59;
      var $60=$count;
      var $61=$6;
      var $62=(($60)|0)!=(($61)|0);
      if ($62) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $63
      $err=10;
      __label__ = 27; break;
    case 12: // $64
      var $65=$6;
      var $66=(($metaentry+24)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($65)|0)!=(($67)|0);
      if ($68) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $69
      var $70=$2;
      var $71=(($metaentry)|0);
      var $st$2$0=(($71)|0);
      var $72$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($71+4)|0);
      var $72$1=HEAP32[(($st$2$1)>>2)];
      var $73=$6;
      var $74=__ZL19metadata_set_lengthP9_chd_fileyj($70, $72$0, $72$1, $73);
      var $74$0=$74[0];
      $err=$74;
      __label__ = 14; break;
    case 14: // $75
      __label__ = 27; break;
    case 15: // $76
      var $77=$err;
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $79
      var $80=$2;
      var $81=(($metaentry+16)|0);
      var $st$2$0=(($81)|0);
      var $82$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($81+4)|0);
      var $82$1=HEAP32[(($st$2$1)>>2)];
      var $83=(($metaentry+8)|0);
      var $st$7$0=(($83)|0);
      var $84$0=HEAP32[(($st$7$0)>>2)];
      var $st$7$1=(($83+4)|0);
      var $84$1=HEAP32[(($st$7$1)>>2)];
      var $85=__ZL26metadata_set_previous_nextP9_chd_fileyy($80, $82$0, $82$1, $84$0, $84$1);
      var $85$0=$85[0];
      $err=$85;
      var $86=$err;
      var $87=(($86)|0)!=0;
      if ($87) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $88
      __label__ = 27; break;
    case 18: // $89
      __label__ = 19; break;
    case 19: // $90
      var $91=(($raw_meta_header)|0);
      var $92=$3;
      __ZL20put_bigendian_uint32Phj($91, $92);
      var $93=(($raw_meta_header+4)|0);
      var $94=$6;
      var $95=$94 & 16777215;
      var $96=$7;
      var $97=(($96)&255);
      var $98=$97 << 24;
      var $99=$95 | $98;
      __ZL20put_bigendian_uint32Phj($93, $99);
      var $100=(($raw_meta_header+8)|0);
      var $101=$err;
      var $102=(($101)|0)==0;
      if ($102) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $103
      var $104=(($metaentry+8)|0);
      var $st$1$0=(($104)|0);
      var $105$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($104+4)|0);
      var $105$1=HEAP32[(($st$1$1)>>2)];
      var $108$1 = $105$1;var $108$0 = $105$0;__label__ = 22; break;
    case 21: // $106
      var $108$1 = 0;var $108$0 = 0;__label__ = 22; break;
    case 22: // $107
      var $108$0;
      var $108$1;
      __ZL20put_bigendian_uint64Phy($100, $108$0, $108$1);
      var $109=$2;
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=__Z10core_fsizeP10_core_file($111);
      var $112$0=$112[0];
      var $112$1=$112[1];
      var $st$9$0=(($offset)|0);
      HEAP32[(($st$9$0)>>2)]=$112$0;
      var $st$9$1=(($offset+4)|0);
      HEAP32[(($st$9$1)>>2)]=$112$1;
      var $113=$2;
      var $114=(($113+4)|0);
      var $115=HEAP32[(($114)>>2)];
      var $st$16$0=(($offset)|0);
      var $116$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($offset+4)|0);
      var $116$1=HEAP32[(($st$16$1)>>2)];
      var $117=__Z10core_fseekP10_core_filexi($115, $116$0, $116$1, 0);
      var $117$0=$117[0];
      var $118=$2;
      var $119=(($118+4)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($raw_meta_header)|0);
      var $122=__Z11core_fwriteP10_core_filePKvj($120, $121, 16);
      $count=$122;
      var $123=$count;
      var $124=(($123)|0)!=16;
      if ($124) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $125
      $err=10;
      __label__ = 27; break;
    case 24: // $126
      var $127=$2;
      var $128=(($127+4)|0);
      var $129=HEAP32[(($128)>>2)];
      var $st$3$0=(($offset)|0);
      var $130$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($offset+4)|0);
      var $130$1=HEAP32[(($st$3$1)>>2)];
      var $$emscripten$temp$1$0=16;
      var $$emscripten$temp$1$1=0;
      var $131$0 = ((($130$0)>>>0)+((($130$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $131$1 = Math.min(Math.floor((((($130$0)>>>0)+((($130$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $132=__Z10core_fseekP10_core_filexi($129, $131$0, $131$1, 0);
      var $132$0=$132[0];
      var $133=$2;
      var $134=(($133+4)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$5;
      var $137=$6;
      var $138=__Z11core_fwriteP10_core_filePKvj($135, $136, $137);
      $count=$138;
      var $139=$count;
      var $140=$6;
      var $141=(($139)|0)!=(($140)|0);
      if ($141) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $142
      $err=10;
      __label__ = 27; break;
    case 26: // $143
      var $144=$2;
      var $145=(($metaentry+16)|0);
      var $st$2$0=(($145)|0);
      var $146$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($145+4)|0);
      var $146$1=HEAP32[(($st$2$1)>>2)];
      var $st$6$0=(($offset)|0);
      var $147$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($offset+4)|0);
      var $147$1=HEAP32[(($st$6$1)>>2)];
      var $148=__ZL26metadata_set_previous_nextP9_chd_fileyy($144, $146$0, $146$1, $147$0, $147$1);
      var $148$0=$148[0];
      $err=$148;
      __label__ = 27; break;
    case 27: // $149
      var $150=$2;
      var $151=$2;
      var $152=(($151+12)|0);
      var $153=(($152+92)|0);
      var $154=(($153)|0);
      var $155=$2;
      var $156=(($155+12)|0);
      var $157=(($156+72)|0);
      var $158=(($157)|0);
      var $159=__ZL21metadata_compute_hashP9_chd_filePKhPh($150, $154, $158);
      var $160=(($159)|0)==0;
      if ($160) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $161
      var $162=$2;
      var $163=(($162+4)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$2;
      var $166=(($165+12)|0);
      var $167=__ZL12header_writeP10_core_filePK11_chd_header($164, $166);
      $err=$167;
      __label__ = 29; break;
    case 29: // $168
      var $169=$err;
      $1=$169;
      __label__ = 30; break;
    case 30: // $170
      var $171=$1;
      STACKTOP = __stackBase__;
      return $171;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16chd_set_metadataP9_chd_filejjPKvjh["X"]=1;

function __ZL19metadata_set_lengthP9_chd_fileyj($chd, $offset$0, $offset$1, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $raw_meta_header=__stackBase__+8;
      var $oldlength;
      var $count;
      $2=$chd;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$offset$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$offset$1;
      $4=$length;
      var $5=$2;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $st$16$0=(($3)|0);
      var $8$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($3+4)|0);
      var $8$1=HEAP32[(($st$16$1)>>2)];
      var $9=__Z10core_fseekP10_core_filexi($7, $8$0, $8$1, 0);
      var $9$0=$9[0];
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($raw_meta_header)|0);
      var $14=__Z10core_freadP10_core_filePvj($12, $13, 16);
      $count=$14;
      var $15=$count;
      var $16=(($15)|0)!=16;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=9;
      __label__ = 5; break;
    case 2: // $18
      var $19=(($raw_meta_header+4)|0);
      var $20=__ZL20get_bigendian_uint32PKh($19);
      $oldlength=$20;
      var $21=$4;
      var $22=$21 & 16777215;
      var $23=$oldlength;
      var $24=$23 & -16777216;
      var $25=$22 | $24;
      $4=$25;
      var $26=(($raw_meta_header+4)|0);
      var $27=$4;
      __ZL20put_bigendian_uint32Phj($26, $27);
      var $28=$2;
      var $29=(($28+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $st$15$0=(($3)|0);
      var $31$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($3+4)|0);
      var $31$1=HEAP32[(($st$15$1)>>2)];
      var $32=__Z10core_fseekP10_core_filexi($30, $31$0, $31$1, 0);
      var $32$0=$32[0];
      var $33=$2;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($raw_meta_header)|0);
      var $37=__Z11core_fwriteP10_core_filePKvj($35, $36, 16);
      $count=$37;
      var $38=$count;
      var $39=(($38)|0)!=16;
      if ($39) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $40
      $1=10;
      __label__ = 5; break;
    case 4: // $41
      $1=0;
      __label__ = 5; break;
    case 5: // $42
      var $43=$1;
      STACKTOP = __stackBase__;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19metadata_set_lengthP9_chd_fileyj["X"]=1;

function __ZL26metadata_set_previous_nextP9_chd_fileyy($chd, $prevoffset$0, $prevoffset$1, $nextoffset$0, $nextoffset$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4=__stackBase__+8;
      var $raw_meta_header=__stackBase__+16;
      var $err;
      var $count;
      $2=$chd;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$prevoffset$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$prevoffset$1;
      var $st$12$0=(($4)|0);
      HEAP32[(($st$12$0)>>2)]=$nextoffset$0;
      var $st$12$1=(($4+4)|0);
      HEAP32[(($st$12$1)>>2)]=$nextoffset$1;
      var $st$16$0=(($3)|0);
      var $5$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($3+4)|0);
      var $5$1=HEAP32[(($st$16$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $6=$5$0 == $$emscripten$temp$0$0 && $5$1 == $$emscripten$temp$0$1;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $st$0$0=(($4)|0);
      var $8$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($4+4)|0);
      var $8$1=HEAP32[(($st$0$1)>>2)];
      var $9=$2;
      var $10=(($9+12)|0);
      var $11=(($10+32)|0);
      var $st$7$0=(($11)|0);
      HEAP32[(($st$7$0)>>2)]=$8$0;
      var $st$7$1=(($11+4)|0);
      HEAP32[(($st$7$1)>>2)]=$8$1;
      var $12=$2;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$2;
      var $16=(($15+12)|0);
      var $17=__ZL12header_writeP10_core_filePK11_chd_header($14, $16);
      $err=$17;
      var $18=$err;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $20
      var $21=$err;
      $1=$21;
      __label__ = 10; break;
    case 3: // $22
      __label__ = 9; break;
    case 4: // $23
      var $24=$2;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $st$3$0=(($3)|0);
      var $27$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($3+4)|0);
      var $27$1=HEAP32[(($st$3$1)>>2)];
      var $28=__Z10core_fseekP10_core_filexi($26, $27$0, $27$1, 0);
      var $28$0=$28[0];
      var $29=$2;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($raw_meta_header)|0);
      var $33=__Z10core_freadP10_core_filePvj($31, $32, 16);
      $count=$33;
      var $34=$count;
      var $35=(($34)|0)!=16;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      $1=9;
      __label__ = 10; break;
    case 6: // $37
      var $38=(($raw_meta_header+8)|0);
      var $st$1$0=(($4)|0);
      var $39$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($4+4)|0);
      var $39$1=HEAP32[(($st$1$1)>>2)];
      __ZL20put_bigendian_uint64Phy($38, $39$0, $39$1);
      var $40=$2;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $st$9$0=(($3)|0);
      var $43$0=HEAP32[(($st$9$0)>>2)];
      var $st$9$1=(($3+4)|0);
      var $43$1=HEAP32[(($st$9$1)>>2)];
      var $44=__Z10core_fseekP10_core_filexi($42, $43$0, $43$1, 0);
      var $44$0=$44[0];
      var $45=$2;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($raw_meta_header)|0);
      var $49=__Z11core_fwriteP10_core_filePKvj($47, $48, 16);
      $count=$49;
      var $50=$count;
      var $51=(($50)|0)!=16;
      if ($51) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $52
      $1=10;
      __label__ = 10; break;
    case 8: // $53
      __label__ = 9; break;
    case 9: // $54
      $1=0;
      __label__ = 10; break;
    case 10: // $55
      var $56=$1;
      STACKTOP = __stackBase__;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL26metadata_set_previous_nextP9_chd_fileyy["X"]=1;

function __ZL21metadata_compute_hashP9_chd_filePKhPh($chd, $rawsha1, $finalsha1) {
  var __stackBase__  = STACKTOP; STACKTOP += 128; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $hasharray;
      var $err;
      var $sha1=__stackBase__;
      var $hashindex;
      var $hashalloc;
      var $offset=__stackBase__+96;
      var $next=__stackBase__+104;
      var $raw_meta_header=__stackBase__+112;
      var $count;
      var $metalength;
      var $metatag;
      var $tempbuffer;
      var $metaflags;
      $2=$chd;
      $3=$rawsha1;
      $4=$finalsha1;
      $hasharray=0;
      $err=0;
      $hashindex=0;
      $hashalloc=0;
      var $5=$2;
      var $6=(($5+12)|0);
      var $7=(($6+4)|0);
      var $8=HEAPU32[(($7)>>2)];
      var $9=(($8)>>>0) < 4;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$4;
      var $12=$3;
      assert(20 % 1 === 0, 'memcpy given ' + 20 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($11, $12, 20, 1);
      $1=0;
      __label__ = 22; break;
    case 2: // $13
      var $14=$2;
      var $15=(($14+12)|0);
      var $16=(($15+32)|0);
      var $st$3$0=(($16)|0);
      var $17$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($16+4)|0);
      var $17$1=HEAP32[(($st$3$1)>>2)];
      var $st$7$0=(($offset)|0);
      HEAP32[(($st$7$0)>>2)]=$17$0;
      var $st$7$1=(($offset+4)|0);
      HEAP32[(($st$7$1)>>2)]=$17$1;
      __label__ = 3; break;
    case 3: // $18
      var $st$0$0=(($offset)|0);
      var $19$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($offset+4)|0);
      var $19$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $20=$19$0 != $$emscripten$temp$0$0 || $19$1 != $$emscripten$temp$0$1;
      if ($20) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $21
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $st$3$0=(($offset)|0);
      var $25$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($offset+4)|0);
      var $25$1=HEAP32[(($st$3$1)>>2)];
      var $26=__Z10core_fseekP10_core_filexi($24, $25$0, $25$1, 0);
      var $26$0=$26[0];
      var $27=$2;
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($raw_meta_header)|0);
      var $31=__Z10core_freadP10_core_filePvj($29, $30, 16);
      $count=$31;
      var $32=$count;
      var $33=(($32)|0)!=16;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      __label__ = 18; break;
    case 6: // $35
      var $36=(($raw_meta_header)|0);
      var $37=__ZL20get_bigendian_uint32PKh($36);
      $metatag=$37;
      var $38=(($raw_meta_header+4)|0);
      var $39=__ZL20get_bigendian_uint32PKh($38);
      $metalength=$39;
      var $40=(($raw_meta_header+8)|0);
      var $41=__ZL20get_bigendian_uint64PKh($40);
      var $41$0=$41[0];
      var $41$1=$41[1];
      var $st$10$0=(($next)|0);
      HEAP32[(($st$10$0)>>2)]=$41$0;
      var $st$10$1=(($next+4)|0);
      HEAP32[(($st$10$1)>>2)]=$41$1;
      var $42=$metalength;
      var $43=$42 >>> 24;
      var $44=(($43) & 255);
      $metaflags=$44;
      var $45=$metalength;
      var $46=$45 & 16777215;
      $metalength=$46;
      var $47=$metaflags;
      var $48=(($47)&255);
      var $49=$48 & 1;
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $51
      __label__ = 17; break;
    case 8: // $52
      var $53=$metalength;
      var $54=_malloc($53);
      $tempbuffer=$54;
      var $55=$tempbuffer;
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $57
      $err=2;
      __label__ = 19; break;
    case 10: // $58
      var $59=$2;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $st$3$0=(($offset)|0);
      var $62$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($offset+4)|0);
      var $62$1=HEAP32[(($st$3$1)>>2)];
      var $$emscripten$temp$1$0=16;
      var $$emscripten$temp$1$1=0;
      var $63$0 = ((($62$0)>>>0)+((($62$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $63$1 = Math.min(Math.floor((((($62$0)>>>0)+((($62$1)|0)*4294967296))+((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $64=__Z10core_fseekP10_core_filexi($61, $63$0, $63$1, 0);
      var $64$0=$64[0];
      var $65=$2;
      var $66=(($65+4)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$tempbuffer;
      var $69=$metalength;
      var $70=__Z10core_freadP10_core_filePvj($67, $68, $69);
      $count=$70;
      var $71=$count;
      var $72=$metalength;
      var $73=(($71)|0)!=(($72)|0);
      if ($73) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $74
      var $75=$tempbuffer;
      _free($75);
      $err=9;
      __label__ = 19; break;
    case 12: // $76
      __Z9sha1_initP8sha1_ctx($sha1);
      var $77=$metalength;
      var $78=$tempbuffer;
      __Z11sha1_updateP8sha1_ctxjPKh($sha1, $77, $78);
      __Z10sha1_finalP8sha1_ctx($sha1);
      var $79=$tempbuffer;
      _free($79);
      var $80=$hashindex;
      var $81=$hashalloc;
      var $82=(($80)>>>0) >= (($81)>>>0);
      if ($82) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $83
      var $84=$hashalloc;
      var $85=(($84+256)|0);
      $hashalloc=$85;
      var $86=$hasharray;
      var $87=$86;
      var $88=$hashalloc;
      var $89=(($88*24)|0);
      var $90=_realloc($87, $89);
      var $91=$90;
      $hasharray=$91;
      var $92=$hasharray;
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $94
      $err=2;
      __label__ = 19; break;
    case 15: // $95
      __label__ = 16; break;
    case 16: // $96
      var $97=$hashindex;
      var $98=$hasharray;
      var $99=(($98+$97*24)|0);
      var $100=(($99)|0);
      var $101=(($100)|0);
      var $102=$metatag;
      __ZL20put_bigendian_uint32Phj($101, $102);
      var $103=$hashindex;
      var $104=$hasharray;
      var $105=(($104+$103*24)|0);
      var $106=(($105+4)|0);
      var $107=(($106)|0);
      __Z11sha1_digestPK8sha1_ctxjPh($sha1, 20, $107);
      var $108=$hashindex;
      var $109=(($108+1)|0);
      $hashindex=$109;
      __label__ = 17; break;
    case 17: // $110
      var $st$0$0=(($next)|0);
      var $111$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($next+4)|0);
      var $111$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($offset)|0);
      HEAP32[(($st$4$0)>>2)]=$111$0;
      var $st$4$1=(($offset+4)|0);
      HEAP32[(($st$4$1)>>2)]=$111$1;
      __label__ = 3; break;
    case 18: // $112
      var $113=$hasharray;
      var $114=$113;
      var $115=$hashindex;
      _qsort($114, $115, 24, 1488);
      __Z9sha1_initP8sha1_ctx($sha1);
      var $116=$3;
      __Z11sha1_updateP8sha1_ctxjPKh($sha1, 20, $116);
      var $117=$hashindex;
      var $118=(($117*24)|0);
      var $119=$hasharray;
      var $120=$119;
      __Z11sha1_updateP8sha1_ctxjPKh($sha1, $118, $120);
      __Z10sha1_finalP8sha1_ctx($sha1);
      var $121=$4;
      __Z11sha1_digestPK8sha1_ctxjPh($sha1, 20, $121);
      __label__ = 19; break;
    case 19: // $122
      var $123=$hasharray;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $125
      var $126=$hasharray;
      var $127=$126;
      _free($127);
      __label__ = 21; break;
    case 21: // $128
      var $129=$err;
      $1=$129;
      __label__ = 22; break;
    case 22: // $130
      var $131=$1;
      STACKTOP = __stackBase__;
      return $131;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21metadata_compute_hashP9_chd_filePKhPh["X"]=1;

function __Z16chd_codec_configP9_chd_fileiPv($chd, $param, $config) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$chd;
      $3=$param;
      $4=$config;
      var $5=$2;
      __ZL22wait_for_pending_asyncP9_chd_file($5);
      var $6=$2;
      var $7=(($6+188)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+28)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$2;
      var $14=(($13+188)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+28)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=FUNCTION_TABLE[$17]($18, $19, $20);
      $1=$21;
      __label__ = 3; break;
    case 2: // $22
      $1=4;
      __label__ = 3; break;
    case 3: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17av_codec_postinitP9_chd_file($chd) {
  var __stackBase__  = STACKTOP; STACKTOP += 284; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $fps=__stackBase__;
      var $fpsfrac=__stackBase__+4;
      var $width=__stackBase__+8;
      var $height=__stackBase__+12;
      var $interlaced=__stackBase__+16;
      var $channels=__stackBase__+20;
      var $rate=__stackBase__+24;
      var $fps_times_1million;
      var $max_samples_per_frame;
      var $bytes_per_frame;
      var $data;
      var $metadata=__stackBase__+28;
      var $err;
      $2=$chd;
      var $3=$2;
      var $4=(($3+192)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5;
      $data=$6;
      var $7=$2;
      var $8=(($7+600)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=25;
      __label__ = 9; break;
    case 2: // $12
      var $13=$2;
      var $14=(($metadata)|0);
      var $15=__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph($13, 1096171862, 0, $14, 256, 0, 0, 0);
      $err=$15;
      var $16=$err;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$err;
      $1=$19;
      __label__ = 9; break;
    case 4: // $20
      var $21=(($metadata)|0);
      var $22=_sscanf($21, ((STRING_TABLE.__str357378)|0), (tempInt=STACKTOP,STACKTOP += 28,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$fps,HEAP32[((tempInt+4)>>2)]=$fpsfrac,HEAP32[((tempInt+8)>>2)]=$width,HEAP32[((tempInt+12)>>2)]=$height,HEAP32[((tempInt+16)>>2)]=$interlaced,HEAP32[((tempInt+20)>>2)]=$channels,HEAP32[((tempInt+24)>>2)]=$rate,tempInt));
      var $23=(($22)|0)!=7;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      $1=23;
      __label__ = 9; break;
    case 6: // $25
      var $26=HEAP32[(($fps)>>2)];
      var $27=(($26*1000000)|0);
      var $28=HEAP32[(($fpsfrac)>>2)];
      var $29=(($27+$28)|0);
      $fps_times_1million=$29;
      var $30=HEAP32[(($rate)>>2)];
      var $31$0=$30;
      var $31$1=(($30|0) < 0 ? -1 : 0);
      var $$emscripten$temp$0$0=1000000;
      var $$emscripten$temp$0$1=0;
      var $32$0 = ((($31$0)>>>0)+((($31$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296))>>>0; var $32$1 = Math.min(Math.floor((((($31$0)>>>0)+((($31$1)|0)*4294967296))*((($$emscripten$temp$0$0)>>>0)+((($$emscripten$temp$0$1)|0)*4294967296)))/4294967296), 4294967295);
      var $33=$fps_times_1million;
      var $34$0=$33;
      var $34$1=0;
      var $35$0 = ((($32$0)>>>0)+((($32$1)|0)*4294967296))+((($34$0)>>>0)+((($34$1)|0)*4294967296))>>>0; var $35$1 = Math.min(Math.floor((((($32$0)>>>0)+((($32$1)|0)*4294967296))+((($34$0)>>>0)+((($34$1)|0)*4294967296)))/4294967296), 4294967295);
      var $$emscripten$temp$1$0=1;
      var $$emscripten$temp$1$1=0;
      var $36$0 = ((($35$0)>>>0)+((($35$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296))>>>0; var $36$1 = Math.min(Math.floor((((($35$0)>>>0)+((($35$1)|0)*4294967296))-((($$emscripten$temp$1$0)>>>0)+((($$emscripten$temp$1$1)|0)*4294967296)))/4294967296), 4294967295);
      var $37=$fps_times_1million;
      var $38$0=$37;
      var $38$1=0;
      var $39$0 = Math.floor(((($36$0)>>>0)+((($36$1)|0)*4294967296))/((($38$0)>>>0)+((($38$1)|0)*4294967296)))>>>0; var $39$1 = Math.min(Math.floor((Math.floor(((($36$0)>>>0)+((($36$1)|0)*4294967296))/((($38$0)>>>0)+((($38$1)|0)*4294967296))))/4294967296), 4294967295);
      var $40$0=$39$0;
      var $40=$40$0;
      $max_samples_per_frame=$40;
      var $41=HEAP32[(($channels)>>2)];
      var $42=$max_samples_per_frame;
      var $43=(($41*$42)|0);
      var $44=((($43<<1))|0);
      var $45=(($44+12)|0);
      var $46=HEAP32[(($width)>>2)];
      var $47=HEAP32[(($height)>>2)];
      var $48=(($46*$47)|0);
      var $49=((($48<<1))|0);
      var $50=(($45+$49)|0);
      $bytes_per_frame=$50;
      var $51=$bytes_per_frame;
      var $52=$2;
      var $53=(($52+12)|0);
      var $54=(($53+16)|0);
      var $55=HEAPU32[(($54)>>2)];
      var $56=(($51)>>>0) > (($55)>>>0);
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      $1=23;
      __label__ = 9; break;
    case 8: // $58
      var $59=HEAP32[(($width)>>2)];
      var $60=HEAP32[(($height)>>2)];
      var $61=HEAP32[(($channels)>>2)];
      var $62=__Z11avcomp_initjjj($59, $60, $61);
      var $63=$data;
      var $64=(($63)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=$data;
      var $66=(($65)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$data;
      var $69=(($68+4)|0);
      __Z22avcomp_config_compressP13_avcomp_statePK25_av_codec_compress_config($67, $69);
      var $70=$data;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$data;
      var $74=(($73+88)|0);
      __Z24avcomp_config_decompressP13_avcomp_statePK27_av_codec_decompress_config($72, $74);
      $1=0;
      __label__ = 9; break;
    case 9: // $75
      var $76=$1;
      STACKTOP = __stackBase__;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17av_codec_postinitP9_chd_file["X"]=1;

function __Z13uchar_isvalidj($uchar) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$uchar;
      var $2=$1;
      var $3=(($2)>>>0) < 1114112;
      if ($3) { __label__ = 1; break; } else { var $14 = 0;__label__ = 4; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5)>>>0) >= 55296;
      if ($6) { __label__ = 2; break; } else { var $11 = 0;__label__ = 3; break; }
    case 2: // $7
      var $8=$1;
      var $9=(($8)>>>0) <= 57343;
      var $11 = $9;__label__ = 3; break;
    case 3: // $10
      var $11;
      var $12=$11 ^ 1;
      var $14 = $12;__label__ = 4; break;
    case 4: // $13
      var $14;
      var $15=(($14)&1);
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16av_raw_data_sizePKh($data) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $size;
      $1=$data;
      $size=0;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=(($5)|0)==99;
      if ($6) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+1)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=(($11)|0)==104;
      if ($12) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $13
      var $14=$1;
      var $15=(($14+2)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=(($17)|0)==97;
      if ($18) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $19
      var $20=$1;
      var $21=(($20+3)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=(($23)|0)==118;
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $25
      var $26=$1;
      var $27=(($26+4)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=(($29+12)|0);
      $size=$30;
      var $31=$1;
      var $32=(($31+5)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=((($34<<1))|0);
      var $36=$1;
      var $37=(($36+6)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$39 << 8;
      var $41=$1;
      var $42=(($41+7)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($40+$44)|0);
      var $46=(($35*$45)|0);
      var $47=$size;
      var $48=(($47+$46)|0);
      $size=$48;
      var $49=$1;
      var $50=(($49+8)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=$52 << 8;
      var $54=$1;
      var $55=(($54+9)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=(($53+$57)|0);
      var $59=((($58<<1))|0);
      var $60=$1;
      var $61=(($60+10)|0);
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=$63 << 8;
      var $65=$1;
      var $66=(($65+11)|0);
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      var $69=(($64+$68)|0);
      var $70=$69 & 32767;
      var $71=(($59*$70)|0);
      var $72=$size;
      var $73=(($72+$71)|0);
      $size=$73;
      __label__ = 5; break;
    case 5: // $74
      var $75=$size;
      ;
      return $75;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16av_raw_data_sizePKh["X"]=1;

function __ZL14zlib_fast_freePvS_($opaque, $address) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $data;
      var $ptr;
      var $i;
      $1=$opaque;
      $2=$address;
      var $3=$1;
      var $4=$3;
      $data=$4;
      var $5=$2;
      var $6=$5;
      var $7=(($6-4)|0);
      $ptr=$7;
      $i=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$i;
      var $10=(($9)|0) < 64;
      if ($10) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $11
      var $12=$ptr;
      var $13=$i;
      var $14=$data;
      var $15=(($14+112)|0);
      var $16=(($15+($13<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($12)|0)==(($17)|0);
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$ptr;
      var $21=HEAP32[(($20)>>2)];
      var $22=$21 & -2;
      HEAP32[(($20)>>2)]=$22;
      __label__ = 6; break;
    case 4: // $23
      __label__ = 5; break;
    case 5: // $24
      var $25=$i;
      var $26=(($25+1)|0);
      $i=$26;
      __label__ = 1; break;
    case 6: // $27
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL20get_bigendian_uint32PKh($base) {
  ;
  var __label__;

  var $1;
  $1=$base;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 24;
  var $7=$1;
  var $8=(($7+1)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 << 16;
  var $12=$6 | $11;
  var $13=$1;
  var $14=(($13+2)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 << 8;
  var $18=$12 | $17;
  var $19=$1;
  var $20=(($19+3)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=$18 | $22;
  ;
  return $23;
}


function __ZL20get_bigendian_uint64PKh($base) {
  ;
  var __label__;

  var $1;
  $1=$base;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP8[($3)];
  var $5$0=$4;
  var $5$1=0;
  var $6$0=(0 << 24) | (0 >>> 8);
  var $6$1=($5$0 << 24) | (0 >>> 8);
  var $7=$1;
  var $8=(($7+1)|0);
  var $9=HEAP8[($8)];
  var $10$0=$9;
  var $10$1=0;
  var $11$0=(0 << 16) | (0 >>> 16);
  var $11$1=($10$0 << 16) | (0 >>> 16);
  var $12$0=$6$0 | $11$0;
  var $12$1=$6$1 | $11$1;
  var $13=$1;
  var $14=(($13+2)|0);
  var $15=HEAP8[($14)];
  var $16$0=$15;
  var $16$1=0;
  var $17$0=(0 << 8) | (0 >>> 24);
  var $17$1=($16$0 << 8) | (0 >>> 24);
  var $18$0=$12$0 | $17$0;
  var $18$1=$12$1 | $17$1;
  var $19=$1;
  var $20=(($19+3)|0);
  var $21=HEAP8[($20)];
  var $22$0=$21;
  var $22$1=0;
  var $23$0=0;
  var $23$1=$22$0;
  var $24$0=$18$0 | $23$0;
  var $24$1=$18$1 | $23$1;
  var $25=$1;
  var $26=(($25+4)|0);
  var $27=HEAP8[($26)];
  var $28$0=$27;
  var $28$1=0;
  var $29$0=($28$0 << 24) | (0 >>> 8);
  var $29$1=($28$1 << 24) | ($28$0 >>> 8);
  var $30$0=$24$0 | $29$0;
  var $30$1=$24$1 | $29$1;
  var $31=$1;
  var $32=(($31+5)|0);
  var $33=HEAP8[($32)];
  var $34$0=$33;
  var $34$1=0;
  var $35$0=($34$0 << 16) | (0 >>> 16);
  var $35$1=($34$1 << 16) | ($34$0 >>> 16);
  var $36$0=$30$0 | $35$0;
  var $36$1=$30$1 | $35$1;
  var $37=$1;
  var $38=(($37+6)|0);
  var $39=HEAP8[($38)];
  var $40$0=$39;
  var $40$1=0;
  var $41$0=($40$0 << 8) | (0 >>> 24);
  var $41$1=($40$1 << 8) | ($40$0 >>> 24);
  var $42$0=$36$0 | $41$0;
  var $42$1=$36$1 | $41$1;
  var $43=$1;
  var $44=(($43+7)|0);
  var $45=HEAP8[($44)];
  var $46$0=$45;
  var $46$1=0;
  var $47$0=$42$0 | $46$0;
  var $47$1=$42$1 | $46$1;
  ;
  return [$47$0,$47$1];
}
__ZL20get_bigendian_uint64PKh["X"]=1;

function __ZL20get_bigendian_uint16PKh($base) {
  ;
  var __label__;

  var $1;
  $1=$base;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 8;
  var $7=$1;
  var $8=(($7+1)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$6 | $10;
  var $12=(($11) & 65535);
  ;
  return $12;
}


function __ZL20put_bigendian_uint16Pht($base, $value) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$base;
  $2=$value;
  var $3=$2;
  var $4=(($3)&65535);
  var $5=$4 >> 8;
  var $6=(($5) & 255);
  var $7=$1;
  var $8=(($7)|0);
  HEAP8[($8)]=$6;
  var $9=$2;
  var $10=(($9) & 255);
  var $11=$1;
  var $12=(($11+1)|0);
  HEAP8[($12)]=$10;
  ;
  return;
}


function __Z15uchar_from_utf8PjPKcj($uchar, $utf8char, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $c;
      var $minchar;
      var $auxlen;
      var $i;
      var $auxchar;
      $2=$uchar;
      $3=$utf8char;
      $4=$count;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$4;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=0;
      __label__ = 37; break;
    case 3: // $11
      var $12=$3;
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      $c=$14;
      var $15=$4;
      var $16=(($15-1)|0);
      $4=$16;
      var $17=$3;
      var $18=(($17+1)|0);
      $3=$18;
      var $19=$c;
      var $20=(($19)>>>0) < 128;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      var $22=$c;
      var $23=$22 & 127;
      $c=$23;
      $auxlen=0;
      $minchar=0;
      __label__ = 26; break;
    case 5: // $24
      var $25=$c;
      var $26=(($25)>>>0) >= 192;
      if ($26) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $27
      var $28=$c;
      var $29=(($28)>>>0) < 224;
      if ($29) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $30
      var $31=$c;
      var $32=$31 & 31;
      $c=$32;
      $auxlen=1;
      $minchar=128;
      __label__ = 25; break;
    case 8: // $33
      var $34=$c;
      var $35=(($34)>>>0) >= 224;
      if ($35) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $36
      var $37=$c;
      var $38=(($37)>>>0) < 240;
      if ($38) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $39
      var $40=$c;
      var $41=$40 & 15;
      $c=$41;
      $auxlen=2;
      $minchar=2048;
      __label__ = 24; break;
    case 11: // $42
      var $43=$c;
      var $44=(($43)>>>0) >= 240;
      if ($44) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $45
      var $46=$c;
      var $47=(($46)>>>0) < 248;
      if ($47) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $48
      var $49=$c;
      var $50=$49 & 7;
      $c=$50;
      $auxlen=3;
      $minchar=65536;
      __label__ = 23; break;
    case 14: // $51
      var $52=$c;
      var $53=(($52)>>>0) >= 248;
      if ($53) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $54
      var $55=$c;
      var $56=(($55)>>>0) < 252;
      if ($56) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $57
      var $58=$c;
      var $59=$58 & 3;
      $c=$59;
      $auxlen=4;
      $minchar=2097152;
      __label__ = 22; break;
    case 17: // $60
      var $61=$c;
      var $62=(($61)>>>0) >= 252;
      if ($62) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $63
      var $64=$c;
      var $65=(($64)>>>0) < 254;
      if ($65) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $66
      var $67=$c;
      var $68=$67 & 1;
      $c=$68;
      $auxlen=5;
      $minchar=67108864;
      __label__ = 21; break;
    case 20: // $69
      $1=-1;
      __label__ = 37; break;
    case 21: // $70
      __label__ = 22; break;
    case 22: // $71
      __label__ = 23; break;
    case 23: // $72
      __label__ = 24; break;
    case 24: // $73
      __label__ = 25; break;
    case 25: // $74
      __label__ = 26; break;
    case 26: // $75
      var $76=$auxlen;
      var $77=$4;
      var $78=(($76)>>>0) > (($77)>>>0);
      if ($78) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $79
      $1=-1;
      __label__ = 37; break;
    case 28: // $80
      $i=0;
      __label__ = 29; break;
    case 29: // $81
      var $82=$i;
      var $83=$auxlen;
      var $84=(($82)|0) < (($83)|0);
      if ($84) { __label__ = 30; break; } else { __label__ = 34; break; }
    case 30: // $85
      var $86=$i;
      var $87=$3;
      var $88=(($87+$86)|0);
      var $89=HEAP8[($88)];
      $auxchar=$89;
      var $90=$auxchar;
      var $91=(($90 << 24) >> 24);
      var $92=$91 & 192;
      var $93=(($92)|0)!=128;
      if ($93) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $94
      $1=-1;
      __label__ = 37; break;
    case 32: // $95
      var $96=$c;
      var $97=$96 << 6;
      $c=$97;
      var $98=$auxchar;
      var $99=(($98 << 24) >> 24);
      var $100=$99 & 63;
      var $101=$c;
      var $102=$101 | $100;
      $c=$102;
      __label__ = 33; break;
    case 33: // $103
      var $104=$i;
      var $105=(($104+1)|0);
      $i=$105;
      __label__ = 29; break;
    case 34: // $106
      var $107=$c;
      var $108=$minchar;
      var $109=(($107)>>>0) < (($108)>>>0);
      if ($109) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $110
      $1=-1;
      __label__ = 37; break;
    case 36: // $111
      var $112=$c;
      var $113=$2;
      HEAP32[(($113)>>2)]=$112;
      var $114=$auxlen;
      var $115=(($114+1)|0);
      $1=$115;
      __label__ = 37; break;
    case 37: // $116
      var $117=$1;
      ;
      return $117;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15uchar_from_utf8PjPKcj["X"]=1;

function __Z16uchar_from_utf16PjPKtj($uchar, $utf16char, $count) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $rc;
      $2=$uchar;
      $3=$utf16char;
      $4=$count;
      $rc=-1;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$4;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=0;
      __label__ = 15; break;
    case 3: // $11
      var $12=$3;
      var $13=(($12)|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($15)|0) >= 55296;
      if ($16) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAPU16[(($19)>>1)];
      var $21=(($20)&65535);
      var $22=(($21)|0) <= 56319;
      if ($22) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $23
      var $24=$4;
      var $25=(($24)>>>0) > 1;
      if ($25) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $26
      var $27=$3;
      var $28=(($27+2)|0);
      var $29=HEAPU16[(($28)>>1)];
      var $30=(($29)&65535);
      var $31=(($30)|0) >= 56320;
      if ($31) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $32
      var $33=$3;
      var $34=(($33+2)|0);
      var $35=HEAPU16[(($34)>>1)];
      var $36=(($35)&65535);
      var $37=(($36)|0) <= 57343;
      if ($37) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $38
      var $39=$3;
      var $40=(($39)|0);
      var $41=HEAPU16[(($40)>>1)];
      var $42=(($41)&65535);
      var $43=$42 & 1023;
      var $44=((($43<<10))|0);
      var $45=(($44+65536)|0);
      var $46=$3;
      var $47=(($46+2)|0);
      var $48=HEAPU16[(($47)>>1)];
      var $49=(($48)&65535);
      var $50=$49 & 1023;
      var $51=(($45+$50)|0);
      var $52=$2;
      HEAP32[(($52)>>2)]=$51;
      $rc=2;
      __label__ = 9; break;
    case 9: // $53
      __label__ = 14; break;
    case 10: // $54
      var $55=$3;
      var $56=(($55)|0);
      var $57=HEAPU16[(($56)>>1)];
      var $58=(($57)&65535);
      var $59=(($58)|0) < 56320;
      if ($59) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $60
      var $61=$3;
      var $62=(($61)|0);
      var $63=HEAPU16[(($62)>>1)];
      var $64=(($63)&65535);
      var $65=(($64)|0) > 57343;
      if ($65) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $66
      var $67=$3;
      var $68=(($67)|0);
      var $69=HEAPU16[(($68)>>1)];
      var $70=(($69)&65535);
      var $71=$2;
      HEAP32[(($71)>>2)]=$70;
      $rc=1;
      __label__ = 13; break;
    case 13: // $72
      __label__ = 14; break;
    case 14: // $73
      var $74=$rc;
      $1=$74;
      __label__ = 15; break;
    case 15: // $75
      var $76=$1;
      ;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16uchar_from_utf16PjPKtj["X"]=1;

function __ZL15zlib_fast_allocPvjj($opaque, $items, $size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $data;
      var $ptr;
      var $i;
      $2=$opaque;
      $3=$items;
      $4=$size;
      var $5=$2;
      var $6=$5;
      $data=$6;
      var $7=$4;
      var $8=$3;
      var $9=(($7*$8)|0);
      var $10=(($9+1023)|0);
      var $11=$10 & -1024;
      $4=$11;
      $i=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$i;
      var $14=(($13)|0) < 64;
      if ($14) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $15
      var $16=$i;
      var $17=$data;
      var $18=(($17+112)|0);
      var $19=(($18+($16<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      $ptr=$20;
      var $21=$ptr;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $23
      var $24=$4;
      var $25=$ptr;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($24)|0)==(($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$ptr;
      var $30=HEAP32[(($29)>>2)];
      var $31=$30 | 1;
      HEAP32[(($29)>>2)]=$31;
      var $32=$ptr;
      var $33=(($32+4)|0);
      var $34=$33;
      $1=$34;
      __label__ = 16; break;
    case 5: // $35
      __label__ = 6; break;
    case 6: // $36
      var $37=$i;
      var $38=(($37+1)|0);
      $i=$38;
      __label__ = 1; break;
    case 7: // $39
      var $40=$4;
      var $41=(($40+4)|0);
      var $42=_malloc($41);
      var $43=$42;
      $ptr=$43;
      var $44=$ptr;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $46
      $1=0;
      __label__ = 16; break;
    case 9: // $47
      $i=0;
      __label__ = 10; break;
    case 10: // $48
      var $49=$i;
      var $50=(($49)|0) < 64;
      if ($50) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $51
      var $52=$i;
      var $53=$data;
      var $54=(($53+112)|0);
      var $55=(($54+($52<<2))|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $58
      var $59=$ptr;
      var $60=$i;
      var $61=$data;
      var $62=(($61+112)|0);
      var $63=(($62+($60<<2))|0);
      HEAP32[(($63)>>2)]=$59;
      __label__ = 15; break;
    case 13: // $64
      __label__ = 14; break;
    case 14: // $65
      var $66=$i;
      var $67=(($66+1)|0);
      $i=$67;
      __label__ = 10; break;
    case 15: // $68
      var $69=$4;
      var $70=$69 | 1;
      var $71=$ptr;
      HEAP32[(($71)>>2)]=$70;
      var $72=$ptr;
      var $73=(($72+4)|0);
      var $74=$73;
      $1=$74;
      __label__ = 16; break;
    case 16: // $75
      var $76=$1;
      ;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15zlib_fast_allocPvjj["X"]=1;

function __ZL21metadata_hash_comparePKvS0_($elem1, $elem2) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$elem1;
  $2=$elem2;
  var $3=$1;
  var $4=$2;
  var $5=_memcmp($3, $4, 24);
  ;
  return $5;
}


function __ZL11map_extractPKhP10_map_entry($base, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$base;
  $2=$entry;
  var $3=$1;
  var $4=(($3)|0);
  var $5=__ZL20get_bigendian_uint64PKh($4);
  var $5$0=$5[0];
  var $5$1=$5[1];
  var $6=$2;
  var $7=(($6)|0);
  var $st$11$0=(($7)|0);
  HEAP32[(($st$11$0)>>2)]=$5$0;
  var $st$11$1=(($7+4)|0);
  HEAP32[(($st$11$1)>>2)]=$5$1;
  var $8=$1;
  var $9=(($8+8)|0);
  var $10=__ZL20get_bigendian_uint32PKh($9);
  var $11=$2;
  var $12=(($11+8)|0);
  HEAP32[(($12)>>2)]=$10;
  var $13=$1;
  var $14=(($13+12)|0);
  var $15=__ZL20get_bigendian_uint16PKh($14);
  var $16=(($15)&65535);
  var $17=$1;
  var $18=(($17+14)|0);
  var $19=HEAPU8[($18)];
  var $20=(($19)&255);
  var $21=$20 << 16;
  var $22=$16 | $21;
  var $23=$2;
  var $24=(($23+12)|0);
  HEAP32[(($24)>>2)]=$22;
  var $25=$1;
  var $26=(($25+15)|0);
  var $27=HEAP8[($26)];
  var $28=$2;
  var $29=(($28+16)|0);
  HEAP8[($29)]=$27;
  ;
  return;
}


function __ZL15map_extract_oldPKhP10_map_entryj($base, $entry, $hunkbytes) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$base;
  $2=$entry;
  $3=$hunkbytes;
  var $4=$1;
  var $5=(($4)|0);
  var $6=__ZL20get_bigendian_uint64PKh($5);
  var $6$0=$6[0];
  var $6$1=$6[1];
  var $7=$2;
  var $8=(($7)|0);
  var $st$13$0=(($8)|0);
  HEAP32[(($st$13$0)>>2)]=$6$0;
  var $st$13$1=(($8+4)|0);
  HEAP32[(($st$13$1)>>2)]=$6$1;
  var $9=$2;
  var $10=(($9+8)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=$2;
  var $12=(($11)|0);
  var $st$22$0=(($12)|0);
  var $13$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($12+4)|0);
  var $13$1=HEAPU32[(($st$22$1)>>2)];
  var $14$0=($13$1 >>> 12) | (0 << 20);
  var $14$1=(0 >>> 12) | (0 << 20);
  var $15$0=$14$0;
  var $15=$15$0;
  var $16=$2;
  var $17=(($16+12)|0);
  HEAP32[(($17)>>2)]=$15;
  var $18=$2;
  var $19=(($18+12)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=$3;
  var $22=(($20)|0)==(($21)|0);
  var $23=$22 ? 2 : 1;
  var $24=16 | $23;
  var $25=(($24) & 255);
  var $26=$2;
  var $27=(($26+16)|0);
  HEAP8[($27)]=$25;
  var $28=$2;
  var $29=(($28)|0);
  var $st$46$0=(($29)|0);
  var $30$0=HEAPU32[(($st$46$0)>>2)];
  var $st$46$1=(($29+4)|0);
  var $30$1=HEAPU32[(($st$46$1)>>2)];
  var $31$0=($30$0 << 20) | (0 >>> 12);
  var $31$1=($30$1 << 20) | ($30$0 >>> 12);
  var $32$0=($31$0 >>> 20) | ($31$1 << 12);
  var $32$1=($31$1 >>> 20) | (0 << 12);
  var $33=$2;
  var $34=(($33)|0);
  var $st$56$0=(($34)|0);
  HEAP32[(($st$56$0)>>2)]=$32$0;
  var $st$56$1=(($34+4)|0);
  HEAP32[(($st$56$1)>>2)]=$32$1;
  ;
  return;
}
__ZL15map_extract_oldPKhP10_map_entryj["X"]=1;

function __ZL12map_assemblePhP10_map_entry($base, $entry) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$base;
  $2=$entry;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $st$8$0=(($6)|0);
  var $7$0=HEAP32[(($st$8$0)>>2)];
  var $st$8$1=(($6+4)|0);
  var $7$1=HEAP32[(($st$8$1)>>2)];
  __ZL20put_bigendian_uint64Phy($4, $7$0, $7$1);
  var $8=$1;
  var $9=(($8+8)|0);
  var $10=$2;
  var $11=(($10+8)|0);
  var $12=HEAP32[(($11)>>2)];
  __ZL20put_bigendian_uint32Phj($9, $12);
  var $13=$1;
  var $14=(($13+12)|0);
  var $15=$2;
  var $16=(($15+12)|0);
  var $17=HEAP32[(($16)>>2)];
  var $18=(($17) & 65535);
  __ZL20put_bigendian_uint16Pht($14, $18);
  var $19=$2;
  var $20=(($19+12)|0);
  var $21=HEAPU32[(($20)>>2)];
  var $22=$21 >>> 16;
  var $23=(($22) & 255);
  var $24=$1;
  var $25=(($24+14)|0);
  HEAP8[($25)]=$23;
  var $26=$2;
  var $27=(($26+16)|0);
  var $28=HEAP8[($27)];
  var $29=$1;
  var $30=(($29+15)|0);
  HEAP8[($30)]=$28;
  ;
  return;
}


function _osd_work_item_queue($queue, $callback, $param, $flags) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$queue;
  $2=$callback;
  $3=$param;
  $4=$flags;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=_osd_work_item_queue_multiple($5, $6, 1, $7, 0, $8);
  ;
  return $9;
}


function __Z17uchar_from_utf16fPjPKtj($uchar, $utf16char, $count) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $buf=__stackBase__;
      $1=$uchar;
      $2=$utf16char;
      $3=$count;
      var $4=$buf;
      HEAP16[(($4)>>1)]=0; HEAP16[(($4+2)>>1)]=0;
      var $5=$3;
      var $6=(($5)>>>0) > 0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAPU16[(($9)>>1)];
      var $11=(($10)&65535);
      var $12=$11 >> 8;
      var $13=$2;
      var $14=(($13)|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      var $17=$16 << 8;
      var $18=$12 | $17;
      var $19=$18 & 65535;
      var $20=(($19) & 65535);
      var $21=(($buf)|0);
      HEAP16[(($21)>>1)]=$20;
      __label__ = 2; break;
    case 2: // $22
      var $23=$3;
      var $24=(($23)>>>0) > 1;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$2;
      var $27=(($26+2)|0);
      var $28=HEAPU16[(($27)>>1)];
      var $29=(($28)&65535);
      var $30=$29 >> 8;
      var $31=$2;
      var $32=(($31+2)|0);
      var $33=HEAPU16[(($32)>>1)];
      var $34=(($33)&65535);
      var $35=$34 << 8;
      var $36=$30 | $35;
      var $37=$36 & 65535;
      var $38=(($37) & 65535);
      var $39=(($buf+2)|0);
      HEAP16[(($39)>>1)]=$38;
      __label__ = 4; break;
    case 4: // $40
      var $41=$1;
      var $42=(($buf)|0);
      var $43=$3;
      var $44=__Z16uchar_from_utf16PjPKtj($41, $42, $43);
      STACKTOP = __stackBase__;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z17uchar_from_utf16fPjPKtj["X"]=1;

function __Z18utf8_previous_charPKc($utf8string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$utf8string;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3-1)|0);
      $1=$4;
      var $5=HEAP8[($4)];
      var $6=(($5 << 24) >> 24);
      var $7=$6 & 192;
      var $8=(($7)|0)==128;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      __label__ = 1; break;
    case 3: // $10
      var $11=$1;
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z9sha1_initP8sha1_ctx($ctx) {
  ;
  var __label__;

  var $1;
  $1=$ctx;
  var $2=$1;
  var $3=(($2)|0);
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=1732584193;
  var $5=$1;
  var $6=(($5)|0);
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=-271733879;
  var $8=$1;
  var $9=(($8)|0);
  var $10=(($9+8)|0);
  HEAP32[(($10)>>2)]=-1732584194;
  var $11=$1;
  var $12=(($11)|0);
  var $13=(($12+12)|0);
  HEAP32[(($13)>>2)]=271733878;
  var $14=$1;
  var $15=(($14)|0);
  var $16=(($15+16)|0);
  HEAP32[(($16)>>2)]=-1009589776;
  var $17=$1;
  var $18=(($17+24)|0);
  HEAP32[(($18)>>2)]=0;
  var $19=$1;
  var $20=(($19+20)|0);
  HEAP32[(($20)>>2)]=0;
  var $21=$1;
  var $22=(($21+92)|0);
  HEAP32[(($22)>>2)]=0;
  ;
  return;
}


function __ZL11READ_UINT32PKh($data) {
  ;
  var __label__;

  var $1;
  $1=$data;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAPU8[($3)];
  var $5=(($4)&255);
  var $6=$5 << 24;
  var $7=$1;
  var $8=(($7+1)|0);
  var $9=HEAPU8[($8)];
  var $10=(($9)&255);
  var $11=$10 << 16;
  var $12=$6 | $11;
  var $13=$1;
  var $14=(($13+2)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 << 8;
  var $18=$12 | $17;
  var $19=$1;
  var $20=(($19+3)|0);
  var $21=HEAPU8[($20)];
  var $22=(($21)&255);
  var $23=$18 | $22;
  ;
  return $23;
}


function __Z15utf8_from_ucharPcjj($utf8string, $count, $uchar) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $rc;
      $2=$utf8string;
      $3=$count;
      $4=$uchar;
      $rc=0;
      var $5=$4;
      var $6=__Z13uchar_isvalidj($5);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      $1=-1;
      __label__ = 33; break;
    case 2: // $9
      var $10=$4;
      var $11=(($10)>>>0) < 128;
      if ($11) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $12
      var $13=$3;
      var $14=(($13)>>>0) < 1;
      if ($14) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $15
      $1=-1;
      __label__ = 33; break;
    case 5: // $16
      var $17=$4;
      var $18=(($17) & 255);
      var $19=$rc;
      var $20=(($19+1)|0);
      $rc=$20;
      var $21=$2;
      var $22=(($21+$19)|0);
      HEAP8[($22)]=$18;
      __label__ = 32; break;
    case 6: // $23
      var $24=$4;
      var $25=(($24)>>>0) < 2048;
      if ($25) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $26
      var $27=$3;
      var $28=(($27)>>>0) < 2;
      if ($28) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $29
      $1=-1;
      __label__ = 33; break;
    case 9: // $30
      var $31=$4;
      var $32=$31 >>> 6;
      var $33=(($32) & 255);
      var $34=(($33 << 24) >> 24);
      var $35=$34 | 192;
      var $36=(($35) & 255);
      var $37=$rc;
      var $38=(($37+1)|0);
      $rc=$38;
      var $39=$2;
      var $40=(($39+$37)|0);
      HEAP8[($40)]=$36;
      var $41=$4;
      var $42=$41 >>> 0;
      var $43=$42 & 63;
      var $44=(($43) & 255);
      var $45=(($44 << 24) >> 24);
      var $46=$45 | 128;
      var $47=(($46) & 255);
      var $48=$rc;
      var $49=(($48+1)|0);
      $rc=$49;
      var $50=$2;
      var $51=(($50+$48)|0);
      HEAP8[($51)]=$47;
      __label__ = 31; break;
    case 10: // $52
      var $53=$4;
      var $54=(($53)>>>0) < 65536;
      if ($54) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $55
      var $56=$3;
      var $57=(($56)>>>0) < 3;
      if ($57) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $58
      $1=-1;
      __label__ = 33; break;
    case 13: // $59
      var $60=$4;
      var $61=$60 >>> 12;
      var $62=(($61) & 255);
      var $63=(($62 << 24) >> 24);
      var $64=$63 | 224;
      var $65=(($64) & 255);
      var $66=$rc;
      var $67=(($66+1)|0);
      $rc=$67;
      var $68=$2;
      var $69=(($68+$66)|0);
      HEAP8[($69)]=$65;
      var $70=$4;
      var $71=$70 >>> 6;
      var $72=$71 & 63;
      var $73=(($72) & 255);
      var $74=(($73 << 24) >> 24);
      var $75=$74 | 128;
      var $76=(($75) & 255);
      var $77=$rc;
      var $78=(($77+1)|0);
      $rc=$78;
      var $79=$2;
      var $80=(($79+$77)|0);
      HEAP8[($80)]=$76;
      var $81=$4;
      var $82=$81 >>> 0;
      var $83=$82 & 63;
      var $84=(($83) & 255);
      var $85=(($84 << 24) >> 24);
      var $86=$85 | 128;
      var $87=(($86) & 255);
      var $88=$rc;
      var $89=(($88+1)|0);
      $rc=$89;
      var $90=$2;
      var $91=(($90+$88)|0);
      HEAP8[($91)]=$87;
      __label__ = 30; break;
    case 14: // $92
      var $93=$4;
      var $94=(($93)>>>0) < 2097152;
      if ($94) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $95
      var $96=$3;
      var $97=(($96)>>>0) < 4;
      if ($97) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $98
      $1=-1;
      __label__ = 33; break;
    case 17: // $99
      var $100=$4;
      var $101=$100 >>> 18;
      var $102=(($101) & 255);
      var $103=(($102 << 24) >> 24);
      var $104=$103 | 240;
      var $105=(($104) & 255);
      var $106=$rc;
      var $107=(($106+1)|0);
      $rc=$107;
      var $108=$2;
      var $109=(($108+$106)|0);
      HEAP8[($109)]=$105;
      var $110=$4;
      var $111=$110 >>> 12;
      var $112=$111 & 63;
      var $113=(($112) & 255);
      var $114=(($113 << 24) >> 24);
      var $115=$114 | 128;
      var $116=(($115) & 255);
      var $117=$rc;
      var $118=(($117+1)|0);
      $rc=$118;
      var $119=$2;
      var $120=(($119+$117)|0);
      HEAP8[($120)]=$116;
      var $121=$4;
      var $122=$121 >>> 6;
      var $123=$122 & 63;
      var $124=(($123) & 255);
      var $125=(($124 << 24) >> 24);
      var $126=$125 | 128;
      var $127=(($126) & 255);
      var $128=$rc;
      var $129=(($128+1)|0);
      $rc=$129;
      var $130=$2;
      var $131=(($130+$128)|0);
      HEAP8[($131)]=$127;
      var $132=$4;
      var $133=$132 >>> 0;
      var $134=$133 & 63;
      var $135=(($134) & 255);
      var $136=(($135 << 24) >> 24);
      var $137=$136 | 128;
      var $138=(($137) & 255);
      var $139=$rc;
      var $140=(($139+1)|0);
      $rc=$140;
      var $141=$2;
      var $142=(($141+$139)|0);
      HEAP8[($142)]=$138;
      __label__ = 29; break;
    case 18: // $143
      var $144=$4;
      var $145=(($144)>>>0) < 67108864;
      if ($145) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $146
      var $147=$3;
      var $148=(($147)>>>0) < 5;
      if ($148) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $149
      $1=-1;
      __label__ = 33; break;
    case 21: // $150
      var $151=$4;
      var $152=$151 >>> 24;
      var $153=(($152) & 255);
      var $154=(($153 << 24) >> 24);
      var $155=$154 | 248;
      var $156=(($155) & 255);
      var $157=$rc;
      var $158=(($157+1)|0);
      $rc=$158;
      var $159=$2;
      var $160=(($159+$157)|0);
      HEAP8[($160)]=$156;
      var $161=$4;
      var $162=$161 >>> 18;
      var $163=$162 & 63;
      var $164=(($163) & 255);
      var $165=(($164 << 24) >> 24);
      var $166=$165 | 128;
      var $167=(($166) & 255);
      var $168=$rc;
      var $169=(($168+1)|0);
      $rc=$169;
      var $170=$2;
      var $171=(($170+$168)|0);
      HEAP8[($171)]=$167;
      var $172=$4;
      var $173=$172 >>> 12;
      var $174=$173 & 63;
      var $175=(($174) & 255);
      var $176=(($175 << 24) >> 24);
      var $177=$176 | 128;
      var $178=(($177) & 255);
      var $179=$rc;
      var $180=(($179+1)|0);
      $rc=$180;
      var $181=$2;
      var $182=(($181+$179)|0);
      HEAP8[($182)]=$178;
      var $183=$4;
      var $184=$183 >>> 6;
      var $185=$184 & 63;
      var $186=(($185) & 255);
      var $187=(($186 << 24) >> 24);
      var $188=$187 | 128;
      var $189=(($188) & 255);
      var $190=$rc;
      var $191=(($190+1)|0);
      $rc=$191;
      var $192=$2;
      var $193=(($192+$190)|0);
      HEAP8[($193)]=$189;
      var $194=$4;
      var $195=$194 >>> 0;
      var $196=$195 & 63;
      var $197=(($196) & 255);
      var $198=(($197 << 24) >> 24);
      var $199=$198 | 128;
      var $200=(($199) & 255);
      var $201=$rc;
      var $202=(($201+1)|0);
      $rc=$202;
      var $203=$2;
      var $204=(($203+$201)|0);
      HEAP8[($204)]=$200;
      __label__ = 28; break;
    case 22: // $205
      var $206=$4;
      var $207=(($206)>>>0) < 2147483648;
      if ($207) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $208
      var $209=$3;
      var $210=(($209)>>>0) < 6;
      if ($210) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $211
      $1=-1;
      __label__ = 33; break;
    case 25: // $212
      var $213=$4;
      var $214=$213 >>> 30;
      var $215=(($214) & 255);
      var $216=(($215 << 24) >> 24);
      var $217=$216 | 252;
      var $218=(($217) & 255);
      var $219=$rc;
      var $220=(($219+1)|0);
      $rc=$220;
      var $221=$2;
      var $222=(($221+$219)|0);
      HEAP8[($222)]=$218;
      var $223=$4;
      var $224=$223 >>> 24;
      var $225=$224 & 63;
      var $226=(($225) & 255);
      var $227=(($226 << 24) >> 24);
      var $228=$227 | 128;
      var $229=(($228) & 255);
      var $230=$rc;
      var $231=(($230+1)|0);
      $rc=$231;
      var $232=$2;
      var $233=(($232+$230)|0);
      HEAP8[($233)]=$229;
      var $234=$4;
      var $235=$234 >>> 18;
      var $236=$235 & 63;
      var $237=(($236) & 255);
      var $238=(($237 << 24) >> 24);
      var $239=$238 | 128;
      var $240=(($239) & 255);
      var $241=$rc;
      var $242=(($241+1)|0);
      $rc=$242;
      var $243=$2;
      var $244=(($243+$241)|0);
      HEAP8[($244)]=$240;
      var $245=$4;
      var $246=$245 >>> 12;
      var $247=$246 & 63;
      var $248=(($247) & 255);
      var $249=(($248 << 24) >> 24);
      var $250=$249 | 128;
      var $251=(($250) & 255);
      var $252=$rc;
      var $253=(($252+1)|0);
      $rc=$253;
      var $254=$2;
      var $255=(($254+$252)|0);
      HEAP8[($255)]=$251;
      var $256=$4;
      var $257=$256 >>> 6;
      var $258=$257 & 63;
      var $259=(($258) & 255);
      var $260=(($259 << 24) >> 24);
      var $261=$260 | 128;
      var $262=(($261) & 255);
      var $263=$rc;
      var $264=(($263+1)|0);
      $rc=$264;
      var $265=$2;
      var $266=(($265+$263)|0);
      HEAP8[($266)]=$262;
      var $267=$4;
      var $268=$267 >>> 0;
      var $269=$268 & 63;
      var $270=(($269) & 255);
      var $271=(($270 << 24) >> 24);
      var $272=$271 | 128;
      var $273=(($272) & 255);
      var $274=$rc;
      var $275=(($274+1)|0);
      $rc=$275;
      var $276=$2;
      var $277=(($276+$274)|0);
      HEAP8[($277)]=$273;
      __label__ = 27; break;
    case 26: // $278
      $rc=-1;
      __label__ = 27; break;
    case 27: // $279
      __label__ = 28; break;
    case 28: // $280
      __label__ = 29; break;
    case 29: // $281
      __label__ = 30; break;
    case 30: // $282
      __label__ = 31; break;
    case 31: // $283
      __label__ = 32; break;
    case 32: // $284
      var $285=$rc;
      $1=$285;
      __label__ = 33; break;
    case 33: // $286
      var $287=$1;
      ;
      return $287;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15utf8_from_ucharPcjj["X"]=1;

function __Z20utf8_is_valid_stringPKc($utf8string) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $remaining_length;
      var $uchar=__stackBase__;
      var $charlen;
      $2=$utf8string;
      var $3=$2;
      var $4=_strlen($3);
      $remaining_length=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      HEAP32[(($uchar)>>2)]=0;
      var $11=$2;
      var $12=$remaining_length;
      var $13=__Z15uchar_from_utf8PjPKcj($uchar, $11, $12);
      $charlen=$13;
      var $14=$charlen;
      var $15=(($14)|0) <= 0;
      if ($15) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=HEAP32[(($uchar)>>2)];
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $19
      var $20=HEAP32[(($uchar)>>2)];
      var $21=__Z13uchar_isvalidj($20);
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $23
      $1=0;
      __label__ = 8; break;
    case 6: // $24
      var $25=$charlen;
      var $26=$2;
      var $27=(($26+$25)|0);
      $2=$27;
      var $28=$charlen;
      var $29=$remaining_length;
      var $30=(($29-$28)|0);
      $remaining_length=$30;
      __label__ = 1; break;
    case 7: // $31
      $1=1;
      __label__ = 8; break;
    case 8: // $32
      var $33=$1;
      STACKTOP = __stackBase__;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z11sha1_updateP8sha1_ctxjPKh($ctx, $length, $buffer) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $left;
      $1=$ctx;
      $2=$length;
      $3=$buffer;
      var $4=$1;
      var $5=(($4+92)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $8
      var $9=$1;
      var $10=(($9+92)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=((64-$11)|0);
      $left=$12;
      var $13=$2;
      var $14=$left;
      var $15=(($13)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$1;
      var $18=(($17+28)|0);
      var $19=(($18)|0);
      var $20=$1;
      var $21=(($20+92)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($19+$22)|0);
      var $24=$3;
      var $25=$2;
      assert($25 % 1 === 0, 'memcpy given ' + $25 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($23, $24, $25, 1);
      var $26=$2;
      var $27=$1;
      var $28=(($27+92)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$26)|0);
      HEAP32[(($28)>>2)]=$30;
      __label__ = 10; break;
    case 3: // $31
      var $32=$1;
      var $33=(($32+28)|0);
      var $34=(($33)|0);
      var $35=$1;
      var $36=(($35+92)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($34+$37)|0);
      var $39=$3;
      var $40=$left;
      assert($40 % 1 === 0, 'memcpy given ' + $40 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($38, $39, $40, 1);
      var $41=$1;
      var $42=$1;
      var $43=(($42+28)|0);
      var $44=(($43)|0);
      __ZL10sha1_blockP8sha1_ctxPKh($41, $44);
      var $45=$left;
      var $46=$3;
      var $47=(($46+$45)|0);
      $3=$47;
      var $48=$left;
      var $49=$2;
      var $50=(($49-$48)|0);
      $2=$50;
      __label__ = 4; break;
    case 4: // $51
      __label__ = 5; break;
    case 5: // $52
      __label__ = 6; break;
    case 6: // $53
      var $54=$2;
      var $55=(($54)>>>0) >= 64;
      if ($55) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $56
      var $57=$1;
      var $58=$3;
      __ZL10sha1_blockP8sha1_ctxPKh($57, $58);
      var $59=$3;
      var $60=(($59+64)|0);
      $3=$60;
      var $61=$2;
      var $62=(($61-64)|0);
      $2=$62;
      __label__ = 6; break;
    case 8: // $63
      var $64=$2;
      var $65=$1;
      var $66=(($65+92)|0);
      HEAP32[(($66)>>2)]=$64;
      var $67=$2;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $69
      var $70=$1;
      var $71=(($70+28)|0);
      var $72=(($71)|0);
      var $73=$3;
      var $74=$2;
      assert($74 % 1 === 0, 'memcpy given ' + $74 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($72, $73, $74, 1);
      __label__ = 10; break;
    case 10: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11sha1_updateP8sha1_ctxjPKh["X"]=1;

function __ZL10sha1_blockP8sha1_ctxPKh($ctx, $block) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $data=__stackBase__;
      var $i;
      $1=$ctx;
      $2=$block;
      var $3=$1;
      var $4=(($3+20)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5+1)|0);
      HEAP32[(($4)>>2)]=$6;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$1;
      var $10=(($9+24)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+1)|0);
      HEAP32[(($10)>>2)]=$12;
      __label__ = 2; break;
    case 2: // $13
      $i=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$i;
      var $16=(($15)|0) < 16;
      if ($16) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $17
      var $18=$2;
      var $19=__ZL11READ_UINT32PKh($18);
      var $20=$i;
      var $21=(($data+($20<<2))|0);
      HEAP32[(($21)>>2)]=$19;
      __label__ = 5; break;
    case 5: // $22
      var $23=$i;
      var $24=(($23+1)|0);
      $i=$24;
      var $25=$2;
      var $26=(($25+4)|0);
      $2=$26;
      __label__ = 3; break;
    case 6: // $27
      var $28=$1;
      var $29=(($28)|0);
      var $30=(($29)|0);
      var $31=(($data)|0);
      __ZL14sha1_transformPjS_($30, $31);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10sha1_finalP8sha1_ctx($ctx) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $data=__stackBase__;
      var $i;
      var $words;
      $1=$ctx;
      var $2=$1;
      var $3=(($2+92)|0);
      var $4=HEAP32[(($3)>>2)];
      $i=$4;
      var $5=$i;
      var $6=(($5+1)|0);
      $i=$6;
      var $7=$1;
      var $8=(($7+28)|0);
      var $9=(($8+$5)|0);
      HEAP8[($9)]=-128;
      __label__ = 1; break;
    case 1: // $10
      var $11=$i;
      var $12=$11 & 3;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      var $15=$i;
      var $16=$1;
      var $17=(($16+28)|0);
      var $18=(($17+$15)|0);
      HEAP8[($18)]=0;
      __label__ = 3; break;
    case 3: // $19
      var $20=$i;
      var $21=(($20+1)|0);
      $i=$21;
      __label__ = 1; break;
    case 4: // $22
      var $23=$i;
      var $24=$23 >> 2;
      $words=$24;
      $i=0;
      __label__ = 5; break;
    case 5: // $25
      var $26=$i;
      var $27=$words;
      var $28=(($26)|0) < (($27)|0);
      if ($28) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $29
      var $30=$1;
      var $31=(($30+28)|0);
      var $32=(($31)|0);
      var $33=$i;
      var $34=((($33<<2))|0);
      var $35=(($32+$34)|0);
      var $36=__ZL11READ_UINT32PKh($35);
      var $37=$i;
      var $38=(($data+($37<<2))|0);
      HEAP32[(($38)>>2)]=$36;
      __label__ = 7; break;
    case 7: // $39
      var $40=$i;
      var $41=(($40+1)|0);
      $i=$41;
      __label__ = 5; break;
    case 8: // $42
      var $43=$words;
      var $44=(($43)|0) > 14;
      if ($44) { __label__ = 9; break; } else { __label__ = 18; break; }
    case 9: // $45
      var $46=$words;
      $i=$46;
      __label__ = 10; break;
    case 10: // $47
      var $48=$i;
      var $49=(($48)|0) < 16;
      if ($49) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $50
      var $51=$i;
      var $52=(($data+($51<<2))|0);
      HEAP32[(($52)>>2)]=0;
      __label__ = 12; break;
    case 12: // $53
      var $54=$i;
      var $55=(($54+1)|0);
      $i=$55;
      __label__ = 10; break;
    case 13: // $56
      var $57=$1;
      var $58=(($57)|0);
      var $59=(($58)|0);
      var $60=(($data)|0);
      __ZL14sha1_transformPjS_($59, $60);
      $i=0;
      __label__ = 14; break;
    case 14: // $61
      var $62=$i;
      var $63=(($62)|0) < 14;
      if ($63) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $64
      var $65=$i;
      var $66=(($data+($65<<2))|0);
      HEAP32[(($66)>>2)]=0;
      __label__ = 16; break;
    case 16: // $67
      var $68=$i;
      var $69=(($68+1)|0);
      $i=$69;
      __label__ = 14; break;
    case 17: // $70
      __label__ = 23; break;
    case 18: // $71
      var $72=$words;
      $i=$72;
      __label__ = 19; break;
    case 19: // $73
      var $74=$i;
      var $75=(($74)|0) < 14;
      if ($75) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $76
      var $77=$i;
      var $78=(($data+($77<<2))|0);
      HEAP32[(($78)>>2)]=0;
      __label__ = 21; break;
    case 21: // $79
      var $80=$i;
      var $81=(($80+1)|0);
      $i=$81;
      __label__ = 19; break;
    case 22: // $82
      __label__ = 23; break;
    case 23: // $83
      var $84=$1;
      var $85=(($84+24)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86 << 9;
      var $88=$1;
      var $89=(($88+20)|0);
      var $90=HEAPU32[(($89)>>2)];
      var $91=$90 >>> 23;
      var $92=$87 | $91;
      var $93=(($data+56)|0);
      HEAP32[(($93)>>2)]=$92;
      var $94=$1;
      var $95=(($94+20)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$96 << 9;
      var $98=$1;
      var $99=(($98+92)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100 << 3;
      var $102=$97 | $101;
      var $103=(($data+60)|0);
      HEAP32[(($103)>>2)]=$102;
      var $104=$1;
      var $105=(($104)|0);
      var $106=(($105)|0);
      var $107=(($data)|0);
      __ZL14sha1_transformPjS_($106, $107);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z10sha1_finalP8sha1_ctx["X"]=1;

function __ZL14sha1_transformPjS_($state, $data) {
  ;
  var __label__;

  var $1;
  var $2;
  var $A;
  var $B;
  var $C;
  var $D;
  var $E;
  $1=$state;
  $2=$data;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  $A=$5;
  var $6=$1;
  var $7=(($6+4)|0);
  var $8=HEAP32[(($7)>>2)];
  $B=$8;
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  $C=$11;
  var $12=$1;
  var $13=(($12+12)|0);
  var $14=HEAP32[(($13)>>2)];
  $D=$14;
  var $15=$1;
  var $16=(($15+16)|0);
  var $17=HEAP32[(($16)>>2)];
  $E=$17;
  var $18=$A;
  var $19=$18 << 5;
  var $20=$A;
  var $21=$20 >>> 27;
  var $22=$19 | $21;
  var $23=$D;
  var $24=$B;
  var $25=$C;
  var $26=$D;
  var $27=$25 ^ $26;
  var $28=$24 & $27;
  var $29=$23 ^ $28;
  var $30=(($22+$29)|0);
  var $31=(($30+1518500249)|0);
  var $32=$2;
  var $33=(($32)|0);
  var $34=HEAP32[(($33)>>2)];
  var $35=(($31+$34)|0);
  var $36=$E;
  var $37=(($36+$35)|0);
  $E=$37;
  var $38=$B;
  var $39=$38 << 30;
  var $40=$B;
  var $41=$40 >>> 2;
  var $42=$39 | $41;
  $B=$42;
  var $43=$E;
  var $44=$43 << 5;
  var $45=$E;
  var $46=$45 >>> 27;
  var $47=$44 | $46;
  var $48=$C;
  var $49=$A;
  var $50=$B;
  var $51=$C;
  var $52=$50 ^ $51;
  var $53=$49 & $52;
  var $54=$48 ^ $53;
  var $55=(($47+$54)|0);
  var $56=(($55+1518500249)|0);
  var $57=$2;
  var $58=(($57+4)|0);
  var $59=HEAP32[(($58)>>2)];
  var $60=(($56+$59)|0);
  var $61=$D;
  var $62=(($61+$60)|0);
  $D=$62;
  var $63=$A;
  var $64=$63 << 30;
  var $65=$A;
  var $66=$65 >>> 2;
  var $67=$64 | $66;
  $A=$67;
  var $68=$D;
  var $69=$68 << 5;
  var $70=$D;
  var $71=$70 >>> 27;
  var $72=$69 | $71;
  var $73=$B;
  var $74=$E;
  var $75=$A;
  var $76=$B;
  var $77=$75 ^ $76;
  var $78=$74 & $77;
  var $79=$73 ^ $78;
  var $80=(($72+$79)|0);
  var $81=(($80+1518500249)|0);
  var $82=$2;
  var $83=(($82+8)|0);
  var $84=HEAP32[(($83)>>2)];
  var $85=(($81+$84)|0);
  var $86=$C;
  var $87=(($86+$85)|0);
  $C=$87;
  var $88=$E;
  var $89=$88 << 30;
  var $90=$E;
  var $91=$90 >>> 2;
  var $92=$89 | $91;
  $E=$92;
  var $93=$C;
  var $94=$93 << 5;
  var $95=$C;
  var $96=$95 >>> 27;
  var $97=$94 | $96;
  var $98=$A;
  var $99=$D;
  var $100=$E;
  var $101=$A;
  var $102=$100 ^ $101;
  var $103=$99 & $102;
  var $104=$98 ^ $103;
  var $105=(($97+$104)|0);
  var $106=(($105+1518500249)|0);
  var $107=$2;
  var $108=(($107+12)|0);
  var $109=HEAP32[(($108)>>2)];
  var $110=(($106+$109)|0);
  var $111=$B;
  var $112=(($111+$110)|0);
  $B=$112;
  var $113=$D;
  var $114=$113 << 30;
  var $115=$D;
  var $116=$115 >>> 2;
  var $117=$114 | $116;
  $D=$117;
  var $118=$B;
  var $119=$118 << 5;
  var $120=$B;
  var $121=$120 >>> 27;
  var $122=$119 | $121;
  var $123=$E;
  var $124=$C;
  var $125=$D;
  var $126=$E;
  var $127=$125 ^ $126;
  var $128=$124 & $127;
  var $129=$123 ^ $128;
  var $130=(($122+$129)|0);
  var $131=(($130+1518500249)|0);
  var $132=$2;
  var $133=(($132+16)|0);
  var $134=HEAP32[(($133)>>2)];
  var $135=(($131+$134)|0);
  var $136=$A;
  var $137=(($136+$135)|0);
  $A=$137;
  var $138=$C;
  var $139=$138 << 30;
  var $140=$C;
  var $141=$140 >>> 2;
  var $142=$139 | $141;
  $C=$142;
  var $143=$A;
  var $144=$143 << 5;
  var $145=$A;
  var $146=$145 >>> 27;
  var $147=$144 | $146;
  var $148=$D;
  var $149=$B;
  var $150=$C;
  var $151=$D;
  var $152=$150 ^ $151;
  var $153=$149 & $152;
  var $154=$148 ^ $153;
  var $155=(($147+$154)|0);
  var $156=(($155+1518500249)|0);
  var $157=$2;
  var $158=(($157+20)|0);
  var $159=HEAP32[(($158)>>2)];
  var $160=(($156+$159)|0);
  var $161=$E;
  var $162=(($161+$160)|0);
  $E=$162;
  var $163=$B;
  var $164=$163 << 30;
  var $165=$B;
  var $166=$165 >>> 2;
  var $167=$164 | $166;
  $B=$167;
  var $168=$E;
  var $169=$168 << 5;
  var $170=$E;
  var $171=$170 >>> 27;
  var $172=$169 | $171;
  var $173=$C;
  var $174=$A;
  var $175=$B;
  var $176=$C;
  var $177=$175 ^ $176;
  var $178=$174 & $177;
  var $179=$173 ^ $178;
  var $180=(($172+$179)|0);
  var $181=(($180+1518500249)|0);
  var $182=$2;
  var $183=(($182+24)|0);
  var $184=HEAP32[(($183)>>2)];
  var $185=(($181+$184)|0);
  var $186=$D;
  var $187=(($186+$185)|0);
  $D=$187;
  var $188=$A;
  var $189=$188 << 30;
  var $190=$A;
  var $191=$190 >>> 2;
  var $192=$189 | $191;
  $A=$192;
  var $193=$D;
  var $194=$193 << 5;
  var $195=$D;
  var $196=$195 >>> 27;
  var $197=$194 | $196;
  var $198=$B;
  var $199=$E;
  var $200=$A;
  var $201=$B;
  var $202=$200 ^ $201;
  var $203=$199 & $202;
  var $204=$198 ^ $203;
  var $205=(($197+$204)|0);
  var $206=(($205+1518500249)|0);
  var $207=$2;
  var $208=(($207+28)|0);
  var $209=HEAP32[(($208)>>2)];
  var $210=(($206+$209)|0);
  var $211=$C;
  var $212=(($211+$210)|0);
  $C=$212;
  var $213=$E;
  var $214=$213 << 30;
  var $215=$E;
  var $216=$215 >>> 2;
  var $217=$214 | $216;
  $E=$217;
  var $218=$C;
  var $219=$218 << 5;
  var $220=$C;
  var $221=$220 >>> 27;
  var $222=$219 | $221;
  var $223=$A;
  var $224=$D;
  var $225=$E;
  var $226=$A;
  var $227=$225 ^ $226;
  var $228=$224 & $227;
  var $229=$223 ^ $228;
  var $230=(($222+$229)|0);
  var $231=(($230+1518500249)|0);
  var $232=$2;
  var $233=(($232+32)|0);
  var $234=HEAP32[(($233)>>2)];
  var $235=(($231+$234)|0);
  var $236=$B;
  var $237=(($236+$235)|0);
  $B=$237;
  var $238=$D;
  var $239=$238 << 30;
  var $240=$D;
  var $241=$240 >>> 2;
  var $242=$239 | $241;
  $D=$242;
  var $243=$B;
  var $244=$243 << 5;
  var $245=$B;
  var $246=$245 >>> 27;
  var $247=$244 | $246;
  var $248=$E;
  var $249=$C;
  var $250=$D;
  var $251=$E;
  var $252=$250 ^ $251;
  var $253=$249 & $252;
  var $254=$248 ^ $253;
  var $255=(($247+$254)|0);
  var $256=(($255+1518500249)|0);
  var $257=$2;
  var $258=(($257+36)|0);
  var $259=HEAP32[(($258)>>2)];
  var $260=(($256+$259)|0);
  var $261=$A;
  var $262=(($261+$260)|0);
  $A=$262;
  var $263=$C;
  var $264=$263 << 30;
  var $265=$C;
  var $266=$265 >>> 2;
  var $267=$264 | $266;
  $C=$267;
  var $268=$A;
  var $269=$268 << 5;
  var $270=$A;
  var $271=$270 >>> 27;
  var $272=$269 | $271;
  var $273=$D;
  var $274=$B;
  var $275=$C;
  var $276=$D;
  var $277=$275 ^ $276;
  var $278=$274 & $277;
  var $279=$273 ^ $278;
  var $280=(($272+$279)|0);
  var $281=(($280+1518500249)|0);
  var $282=$2;
  var $283=(($282+40)|0);
  var $284=HEAP32[(($283)>>2)];
  var $285=(($281+$284)|0);
  var $286=$E;
  var $287=(($286+$285)|0);
  $E=$287;
  var $288=$B;
  var $289=$288 << 30;
  var $290=$B;
  var $291=$290 >>> 2;
  var $292=$289 | $291;
  $B=$292;
  var $293=$E;
  var $294=$293 << 5;
  var $295=$E;
  var $296=$295 >>> 27;
  var $297=$294 | $296;
  var $298=$C;
  var $299=$A;
  var $300=$B;
  var $301=$C;
  var $302=$300 ^ $301;
  var $303=$299 & $302;
  var $304=$298 ^ $303;
  var $305=(($297+$304)|0);
  var $306=(($305+1518500249)|0);
  var $307=$2;
  var $308=(($307+44)|0);
  var $309=HEAP32[(($308)>>2)];
  var $310=(($306+$309)|0);
  var $311=$D;
  var $312=(($311+$310)|0);
  $D=$312;
  var $313=$A;
  var $314=$313 << 30;
  var $315=$A;
  var $316=$315 >>> 2;
  var $317=$314 | $316;
  $A=$317;
  var $318=$D;
  var $319=$318 << 5;
  var $320=$D;
  var $321=$320 >>> 27;
  var $322=$319 | $321;
  var $323=$B;
  var $324=$E;
  var $325=$A;
  var $326=$B;
  var $327=$325 ^ $326;
  var $328=$324 & $327;
  var $329=$323 ^ $328;
  var $330=(($322+$329)|0);
  var $331=(($330+1518500249)|0);
  var $332=$2;
  var $333=(($332+48)|0);
  var $334=HEAP32[(($333)>>2)];
  var $335=(($331+$334)|0);
  var $336=$C;
  var $337=(($336+$335)|0);
  $C=$337;
  var $338=$E;
  var $339=$338 << 30;
  var $340=$E;
  var $341=$340 >>> 2;
  var $342=$339 | $341;
  $E=$342;
  var $343=$C;
  var $344=$343 << 5;
  var $345=$C;
  var $346=$345 >>> 27;
  var $347=$344 | $346;
  var $348=$A;
  var $349=$D;
  var $350=$E;
  var $351=$A;
  var $352=$350 ^ $351;
  var $353=$349 & $352;
  var $354=$348 ^ $353;
  var $355=(($347+$354)|0);
  var $356=(($355+1518500249)|0);
  var $357=$2;
  var $358=(($357+52)|0);
  var $359=HEAP32[(($358)>>2)];
  var $360=(($356+$359)|0);
  var $361=$B;
  var $362=(($361+$360)|0);
  $B=$362;
  var $363=$D;
  var $364=$363 << 30;
  var $365=$D;
  var $366=$365 >>> 2;
  var $367=$364 | $366;
  $D=$367;
  var $368=$B;
  var $369=$368 << 5;
  var $370=$B;
  var $371=$370 >>> 27;
  var $372=$369 | $371;
  var $373=$E;
  var $374=$C;
  var $375=$D;
  var $376=$E;
  var $377=$375 ^ $376;
  var $378=$374 & $377;
  var $379=$373 ^ $378;
  var $380=(($372+$379)|0);
  var $381=(($380+1518500249)|0);
  var $382=$2;
  var $383=(($382+56)|0);
  var $384=HEAP32[(($383)>>2)];
  var $385=(($381+$384)|0);
  var $386=$A;
  var $387=(($386+$385)|0);
  $A=$387;
  var $388=$C;
  var $389=$388 << 30;
  var $390=$C;
  var $391=$390 >>> 2;
  var $392=$389 | $391;
  $C=$392;
  var $393=$A;
  var $394=$393 << 5;
  var $395=$A;
  var $396=$395 >>> 27;
  var $397=$394 | $396;
  var $398=$D;
  var $399=$B;
  var $400=$C;
  var $401=$D;
  var $402=$400 ^ $401;
  var $403=$399 & $402;
  var $404=$398 ^ $403;
  var $405=(($397+$404)|0);
  var $406=(($405+1518500249)|0);
  var $407=$2;
  var $408=(($407+60)|0);
  var $409=HEAP32[(($408)>>2)];
  var $410=(($406+$409)|0);
  var $411=$E;
  var $412=(($411+$410)|0);
  $E=$412;
  var $413=$B;
  var $414=$413 << 30;
  var $415=$B;
  var $416=$415 >>> 2;
  var $417=$414 | $416;
  $B=$417;
  var $418=$E;
  var $419=$418 << 5;
  var $420=$E;
  var $421=$420 >>> 27;
  var $422=$419 | $421;
  var $423=$C;
  var $424=$A;
  var $425=$B;
  var $426=$C;
  var $427=$425 ^ $426;
  var $428=$424 & $427;
  var $429=$423 ^ $428;
  var $430=(($422+$429)|0);
  var $431=(($430+1518500249)|0);
  var $432=$2;
  var $433=(($432)|0);
  var $434=HEAP32[(($433)>>2)];
  var $435=$2;
  var $436=(($435+8)|0);
  var $437=HEAP32[(($436)>>2)];
  var $438=$434 ^ $437;
  var $439=$2;
  var $440=(($439+32)|0);
  var $441=HEAP32[(($440)>>2)];
  var $442=$438 ^ $441;
  var $443=$2;
  var $444=(($443+52)|0);
  var $445=HEAP32[(($444)>>2)];
  var $446=$442 ^ $445;
  var $447=$446 << 1;
  var $448=$2;
  var $449=(($448)|0);
  var $450=HEAP32[(($449)>>2)];
  var $451=$2;
  var $452=(($451+8)|0);
  var $453=HEAP32[(($452)>>2)];
  var $454=$450 ^ $453;
  var $455=$2;
  var $456=(($455+32)|0);
  var $457=HEAP32[(($456)>>2)];
  var $458=$454 ^ $457;
  var $459=$2;
  var $460=(($459+52)|0);
  var $461=HEAP32[(($460)>>2)];
  var $462=$458 ^ $461;
  var $463=$462 >>> 31;
  var $464=$447 | $463;
  var $465=$2;
  var $466=(($465)|0);
  HEAP32[(($466)>>2)]=$464;
  var $467=(($431+$464)|0);
  var $468=$D;
  var $469=(($468+$467)|0);
  $D=$469;
  var $470=$A;
  var $471=$470 << 30;
  var $472=$A;
  var $473=$472 >>> 2;
  var $474=$471 | $473;
  $A=$474;
  var $475=$D;
  var $476=$475 << 5;
  var $477=$D;
  var $478=$477 >>> 27;
  var $479=$476 | $478;
  var $480=$B;
  var $481=$E;
  var $482=$A;
  var $483=$B;
  var $484=$482 ^ $483;
  var $485=$481 & $484;
  var $486=$480 ^ $485;
  var $487=(($479+$486)|0);
  var $488=(($487+1518500249)|0);
  var $489=$2;
  var $490=(($489+4)|0);
  var $491=HEAP32[(($490)>>2)];
  var $492=$2;
  var $493=(($492+12)|0);
  var $494=HEAP32[(($493)>>2)];
  var $495=$491 ^ $494;
  var $496=$2;
  var $497=(($496+36)|0);
  var $498=HEAP32[(($497)>>2)];
  var $499=$495 ^ $498;
  var $500=$2;
  var $501=(($500+56)|0);
  var $502=HEAP32[(($501)>>2)];
  var $503=$499 ^ $502;
  var $504=$503 << 1;
  var $505=$2;
  var $506=(($505+4)|0);
  var $507=HEAP32[(($506)>>2)];
  var $508=$2;
  var $509=(($508+12)|0);
  var $510=HEAP32[(($509)>>2)];
  var $511=$507 ^ $510;
  var $512=$2;
  var $513=(($512+36)|0);
  var $514=HEAP32[(($513)>>2)];
  var $515=$511 ^ $514;
  var $516=$2;
  var $517=(($516+56)|0);
  var $518=HEAP32[(($517)>>2)];
  var $519=$515 ^ $518;
  var $520=$519 >>> 31;
  var $521=$504 | $520;
  var $522=$2;
  var $523=(($522+4)|0);
  HEAP32[(($523)>>2)]=$521;
  var $524=(($488+$521)|0);
  var $525=$C;
  var $526=(($525+$524)|0);
  $C=$526;
  var $527=$E;
  var $528=$527 << 30;
  var $529=$E;
  var $530=$529 >>> 2;
  var $531=$528 | $530;
  $E=$531;
  var $532=$C;
  var $533=$532 << 5;
  var $534=$C;
  var $535=$534 >>> 27;
  var $536=$533 | $535;
  var $537=$A;
  var $538=$D;
  var $539=$E;
  var $540=$A;
  var $541=$539 ^ $540;
  var $542=$538 & $541;
  var $543=$537 ^ $542;
  var $544=(($536+$543)|0);
  var $545=(($544+1518500249)|0);
  var $546=$2;
  var $547=(($546+8)|0);
  var $548=HEAP32[(($547)>>2)];
  var $549=$2;
  var $550=(($549+16)|0);
  var $551=HEAP32[(($550)>>2)];
  var $552=$548 ^ $551;
  var $553=$2;
  var $554=(($553+40)|0);
  var $555=HEAP32[(($554)>>2)];
  var $556=$552 ^ $555;
  var $557=$2;
  var $558=(($557+60)|0);
  var $559=HEAP32[(($558)>>2)];
  var $560=$556 ^ $559;
  var $561=$560 << 1;
  var $562=$2;
  var $563=(($562+8)|0);
  var $564=HEAP32[(($563)>>2)];
  var $565=$2;
  var $566=(($565+16)|0);
  var $567=HEAP32[(($566)>>2)];
  var $568=$564 ^ $567;
  var $569=$2;
  var $570=(($569+40)|0);
  var $571=HEAP32[(($570)>>2)];
  var $572=$568 ^ $571;
  var $573=$2;
  var $574=(($573+60)|0);
  var $575=HEAP32[(($574)>>2)];
  var $576=$572 ^ $575;
  var $577=$576 >>> 31;
  var $578=$561 | $577;
  var $579=$2;
  var $580=(($579+8)|0);
  HEAP32[(($580)>>2)]=$578;
  var $581=(($545+$578)|0);
  var $582=$B;
  var $583=(($582+$581)|0);
  $B=$583;
  var $584=$D;
  var $585=$584 << 30;
  var $586=$D;
  var $587=$586 >>> 2;
  var $588=$585 | $587;
  $D=$588;
  var $589=$B;
  var $590=$589 << 5;
  var $591=$B;
  var $592=$591 >>> 27;
  var $593=$590 | $592;
  var $594=$E;
  var $595=$C;
  var $596=$D;
  var $597=$E;
  var $598=$596 ^ $597;
  var $599=$595 & $598;
  var $600=$594 ^ $599;
  var $601=(($593+$600)|0);
  var $602=(($601+1518500249)|0);
  var $603=$2;
  var $604=(($603+12)|0);
  var $605=HEAP32[(($604)>>2)];
  var $606=$2;
  var $607=(($606+20)|0);
  var $608=HEAP32[(($607)>>2)];
  var $609=$605 ^ $608;
  var $610=$2;
  var $611=(($610+44)|0);
  var $612=HEAP32[(($611)>>2)];
  var $613=$609 ^ $612;
  var $614=$2;
  var $615=(($614)|0);
  var $616=HEAP32[(($615)>>2)];
  var $617=$613 ^ $616;
  var $618=$617 << 1;
  var $619=$2;
  var $620=(($619+12)|0);
  var $621=HEAP32[(($620)>>2)];
  var $622=$2;
  var $623=(($622+20)|0);
  var $624=HEAP32[(($623)>>2)];
  var $625=$621 ^ $624;
  var $626=$2;
  var $627=(($626+44)|0);
  var $628=HEAP32[(($627)>>2)];
  var $629=$625 ^ $628;
  var $630=$2;
  var $631=(($630)|0);
  var $632=HEAP32[(($631)>>2)];
  var $633=$629 ^ $632;
  var $634=$633 >>> 31;
  var $635=$618 | $634;
  var $636=$2;
  var $637=(($636+12)|0);
  HEAP32[(($637)>>2)]=$635;
  var $638=(($602+$635)|0);
  var $639=$A;
  var $640=(($639+$638)|0);
  $A=$640;
  var $641=$C;
  var $642=$641 << 30;
  var $643=$C;
  var $644=$643 >>> 2;
  var $645=$642 | $644;
  $C=$645;
  var $646=$A;
  var $647=$646 << 5;
  var $648=$A;
  var $649=$648 >>> 27;
  var $650=$647 | $649;
  var $651=$B;
  var $652=$C;
  var $653=$651 ^ $652;
  var $654=$D;
  var $655=$653 ^ $654;
  var $656=(($650+$655)|0);
  var $657=(($656+1859775393)|0);
  var $658=$2;
  var $659=(($658+16)|0);
  var $660=HEAP32[(($659)>>2)];
  var $661=$2;
  var $662=(($661+24)|0);
  var $663=HEAP32[(($662)>>2)];
  var $664=$660 ^ $663;
  var $665=$2;
  var $666=(($665+48)|0);
  var $667=HEAP32[(($666)>>2)];
  var $668=$664 ^ $667;
  var $669=$2;
  var $670=(($669+4)|0);
  var $671=HEAP32[(($670)>>2)];
  var $672=$668 ^ $671;
  var $673=$672 << 1;
  var $674=$2;
  var $675=(($674+16)|0);
  var $676=HEAP32[(($675)>>2)];
  var $677=$2;
  var $678=(($677+24)|0);
  var $679=HEAP32[(($678)>>2)];
  var $680=$676 ^ $679;
  var $681=$2;
  var $682=(($681+48)|0);
  var $683=HEAP32[(($682)>>2)];
  var $684=$680 ^ $683;
  var $685=$2;
  var $686=(($685+4)|0);
  var $687=HEAP32[(($686)>>2)];
  var $688=$684 ^ $687;
  var $689=$688 >>> 31;
  var $690=$673 | $689;
  var $691=$2;
  var $692=(($691+16)|0);
  HEAP32[(($692)>>2)]=$690;
  var $693=(($657+$690)|0);
  var $694=$E;
  var $695=(($694+$693)|0);
  $E=$695;
  var $696=$B;
  var $697=$696 << 30;
  var $698=$B;
  var $699=$698 >>> 2;
  var $700=$697 | $699;
  $B=$700;
  var $701=$E;
  var $702=$701 << 5;
  var $703=$E;
  var $704=$703 >>> 27;
  var $705=$702 | $704;
  var $706=$A;
  var $707=$B;
  var $708=$706 ^ $707;
  var $709=$C;
  var $710=$708 ^ $709;
  var $711=(($705+$710)|0);
  var $712=(($711+1859775393)|0);
  var $713=$2;
  var $714=(($713+20)|0);
  var $715=HEAP32[(($714)>>2)];
  var $716=$2;
  var $717=(($716+28)|0);
  var $718=HEAP32[(($717)>>2)];
  var $719=$715 ^ $718;
  var $720=$2;
  var $721=(($720+52)|0);
  var $722=HEAP32[(($721)>>2)];
  var $723=$719 ^ $722;
  var $724=$2;
  var $725=(($724+8)|0);
  var $726=HEAP32[(($725)>>2)];
  var $727=$723 ^ $726;
  var $728=$727 << 1;
  var $729=$2;
  var $730=(($729+20)|0);
  var $731=HEAP32[(($730)>>2)];
  var $732=$2;
  var $733=(($732+28)|0);
  var $734=HEAP32[(($733)>>2)];
  var $735=$731 ^ $734;
  var $736=$2;
  var $737=(($736+52)|0);
  var $738=HEAP32[(($737)>>2)];
  var $739=$735 ^ $738;
  var $740=$2;
  var $741=(($740+8)|0);
  var $742=HEAP32[(($741)>>2)];
  var $743=$739 ^ $742;
  var $744=$743 >>> 31;
  var $745=$728 | $744;
  var $746=$2;
  var $747=(($746+20)|0);
  HEAP32[(($747)>>2)]=$745;
  var $748=(($712+$745)|0);
  var $749=$D;
  var $750=(($749+$748)|0);
  $D=$750;
  var $751=$A;
  var $752=$751 << 30;
  var $753=$A;
  var $754=$753 >>> 2;
  var $755=$752 | $754;
  $A=$755;
  var $756=$D;
  var $757=$756 << 5;
  var $758=$D;
  var $759=$758 >>> 27;
  var $760=$757 | $759;
  var $761=$E;
  var $762=$A;
  var $763=$761 ^ $762;
  var $764=$B;
  var $765=$763 ^ $764;
  var $766=(($760+$765)|0);
  var $767=(($766+1859775393)|0);
  var $768=$2;
  var $769=(($768+24)|0);
  var $770=HEAP32[(($769)>>2)];
  var $771=$2;
  var $772=(($771+32)|0);
  var $773=HEAP32[(($772)>>2)];
  var $774=$770 ^ $773;
  var $775=$2;
  var $776=(($775+56)|0);
  var $777=HEAP32[(($776)>>2)];
  var $778=$774 ^ $777;
  var $779=$2;
  var $780=(($779+12)|0);
  var $781=HEAP32[(($780)>>2)];
  var $782=$778 ^ $781;
  var $783=$782 << 1;
  var $784=$2;
  var $785=(($784+24)|0);
  var $786=HEAP32[(($785)>>2)];
  var $787=$2;
  var $788=(($787+32)|0);
  var $789=HEAP32[(($788)>>2)];
  var $790=$786 ^ $789;
  var $791=$2;
  var $792=(($791+56)|0);
  var $793=HEAP32[(($792)>>2)];
  var $794=$790 ^ $793;
  var $795=$2;
  var $796=(($795+12)|0);
  var $797=HEAP32[(($796)>>2)];
  var $798=$794 ^ $797;
  var $799=$798 >>> 31;
  var $800=$783 | $799;
  var $801=$2;
  var $802=(($801+24)|0);
  HEAP32[(($802)>>2)]=$800;
  var $803=(($767+$800)|0);
  var $804=$C;
  var $805=(($804+$803)|0);
  $C=$805;
  var $806=$E;
  var $807=$806 << 30;
  var $808=$E;
  var $809=$808 >>> 2;
  var $810=$807 | $809;
  $E=$810;
  var $811=$C;
  var $812=$811 << 5;
  var $813=$C;
  var $814=$813 >>> 27;
  var $815=$812 | $814;
  var $816=$D;
  var $817=$E;
  var $818=$816 ^ $817;
  var $819=$A;
  var $820=$818 ^ $819;
  var $821=(($815+$820)|0);
  var $822=(($821+1859775393)|0);
  var $823=$2;
  var $824=(($823+28)|0);
  var $825=HEAP32[(($824)>>2)];
  var $826=$2;
  var $827=(($826+36)|0);
  var $828=HEAP32[(($827)>>2)];
  var $829=$825 ^ $828;
  var $830=$2;
  var $831=(($830+60)|0);
  var $832=HEAP32[(($831)>>2)];
  var $833=$829 ^ $832;
  var $834=$2;
  var $835=(($834+16)|0);
  var $836=HEAP32[(($835)>>2)];
  var $837=$833 ^ $836;
  var $838=$837 << 1;
  var $839=$2;
  var $840=(($839+28)|0);
  var $841=HEAP32[(($840)>>2)];
  var $842=$2;
  var $843=(($842+36)|0);
  var $844=HEAP32[(($843)>>2)];
  var $845=$841 ^ $844;
  var $846=$2;
  var $847=(($846+60)|0);
  var $848=HEAP32[(($847)>>2)];
  var $849=$845 ^ $848;
  var $850=$2;
  var $851=(($850+16)|0);
  var $852=HEAP32[(($851)>>2)];
  var $853=$849 ^ $852;
  var $854=$853 >>> 31;
  var $855=$838 | $854;
  var $856=$2;
  var $857=(($856+28)|0);
  HEAP32[(($857)>>2)]=$855;
  var $858=(($822+$855)|0);
  var $859=$B;
  var $860=(($859+$858)|0);
  $B=$860;
  var $861=$D;
  var $862=$861 << 30;
  var $863=$D;
  var $864=$863 >>> 2;
  var $865=$862 | $864;
  $D=$865;
  var $866=$B;
  var $867=$866 << 5;
  var $868=$B;
  var $869=$868 >>> 27;
  var $870=$867 | $869;
  var $871=$C;
  var $872=$D;
  var $873=$871 ^ $872;
  var $874=$E;
  var $875=$873 ^ $874;
  var $876=(($870+$875)|0);
  var $877=(($876+1859775393)|0);
  var $878=$2;
  var $879=(($878+32)|0);
  var $880=HEAP32[(($879)>>2)];
  var $881=$2;
  var $882=(($881+40)|0);
  var $883=HEAP32[(($882)>>2)];
  var $884=$880 ^ $883;
  var $885=$2;
  var $886=(($885)|0);
  var $887=HEAP32[(($886)>>2)];
  var $888=$884 ^ $887;
  var $889=$2;
  var $890=(($889+20)|0);
  var $891=HEAP32[(($890)>>2)];
  var $892=$888 ^ $891;
  var $893=$892 << 1;
  var $894=$2;
  var $895=(($894+32)|0);
  var $896=HEAP32[(($895)>>2)];
  var $897=$2;
  var $898=(($897+40)|0);
  var $899=HEAP32[(($898)>>2)];
  var $900=$896 ^ $899;
  var $901=$2;
  var $902=(($901)|0);
  var $903=HEAP32[(($902)>>2)];
  var $904=$900 ^ $903;
  var $905=$2;
  var $906=(($905+20)|0);
  var $907=HEAP32[(($906)>>2)];
  var $908=$904 ^ $907;
  var $909=$908 >>> 31;
  var $910=$893 | $909;
  var $911=$2;
  var $912=(($911+32)|0);
  HEAP32[(($912)>>2)]=$910;
  var $913=(($877+$910)|0);
  var $914=$A;
  var $915=(($914+$913)|0);
  $A=$915;
  var $916=$C;
  var $917=$916 << 30;
  var $918=$C;
  var $919=$918 >>> 2;
  var $920=$917 | $919;
  $C=$920;
  var $921=$A;
  var $922=$921 << 5;
  var $923=$A;
  var $924=$923 >>> 27;
  var $925=$922 | $924;
  var $926=$B;
  var $927=$C;
  var $928=$926 ^ $927;
  var $929=$D;
  var $930=$928 ^ $929;
  var $931=(($925+$930)|0);
  var $932=(($931+1859775393)|0);
  var $933=$2;
  var $934=(($933+36)|0);
  var $935=HEAP32[(($934)>>2)];
  var $936=$2;
  var $937=(($936+44)|0);
  var $938=HEAP32[(($937)>>2)];
  var $939=$935 ^ $938;
  var $940=$2;
  var $941=(($940+4)|0);
  var $942=HEAP32[(($941)>>2)];
  var $943=$939 ^ $942;
  var $944=$2;
  var $945=(($944+24)|0);
  var $946=HEAP32[(($945)>>2)];
  var $947=$943 ^ $946;
  var $948=$947 << 1;
  var $949=$2;
  var $950=(($949+36)|0);
  var $951=HEAP32[(($950)>>2)];
  var $952=$2;
  var $953=(($952+44)|0);
  var $954=HEAP32[(($953)>>2)];
  var $955=$951 ^ $954;
  var $956=$2;
  var $957=(($956+4)|0);
  var $958=HEAP32[(($957)>>2)];
  var $959=$955 ^ $958;
  var $960=$2;
  var $961=(($960+24)|0);
  var $962=HEAP32[(($961)>>2)];
  var $963=$959 ^ $962;
  var $964=$963 >>> 31;
  var $965=$948 | $964;
  var $966=$2;
  var $967=(($966+36)|0);
  HEAP32[(($967)>>2)]=$965;
  var $968=(($932+$965)|0);
  var $969=$E;
  var $970=(($969+$968)|0);
  $E=$970;
  var $971=$B;
  var $972=$971 << 30;
  var $973=$B;
  var $974=$973 >>> 2;
  var $975=$972 | $974;
  $B=$975;
  var $976=$E;
  var $977=$976 << 5;
  var $978=$E;
  var $979=$978 >>> 27;
  var $980=$977 | $979;
  var $981=$A;
  var $982=$B;
  var $983=$981 ^ $982;
  var $984=$C;
  var $985=$983 ^ $984;
  var $986=(($980+$985)|0);
  var $987=(($986+1859775393)|0);
  var $988=$2;
  var $989=(($988+40)|0);
  var $990=HEAP32[(($989)>>2)];
  var $991=$2;
  var $992=(($991+48)|0);
  var $993=HEAP32[(($992)>>2)];
  var $994=$990 ^ $993;
  var $995=$2;
  var $996=(($995+8)|0);
  var $997=HEAP32[(($996)>>2)];
  var $998=$994 ^ $997;
  var $999=$2;
  var $1000=(($999+28)|0);
  var $1001=HEAP32[(($1000)>>2)];
  var $1002=$998 ^ $1001;
  var $1003=$1002 << 1;
  var $1004=$2;
  var $1005=(($1004+40)|0);
  var $1006=HEAP32[(($1005)>>2)];
  var $1007=$2;
  var $1008=(($1007+48)|0);
  var $1009=HEAP32[(($1008)>>2)];
  var $1010=$1006 ^ $1009;
  var $1011=$2;
  var $1012=(($1011+8)|0);
  var $1013=HEAP32[(($1012)>>2)];
  var $1014=$1010 ^ $1013;
  var $1015=$2;
  var $1016=(($1015+28)|0);
  var $1017=HEAP32[(($1016)>>2)];
  var $1018=$1014 ^ $1017;
  var $1019=$1018 >>> 31;
  var $1020=$1003 | $1019;
  var $1021=$2;
  var $1022=(($1021+40)|0);
  HEAP32[(($1022)>>2)]=$1020;
  var $1023=(($987+$1020)|0);
  var $1024=$D;
  var $1025=(($1024+$1023)|0);
  $D=$1025;
  var $1026=$A;
  var $1027=$1026 << 30;
  var $1028=$A;
  var $1029=$1028 >>> 2;
  var $1030=$1027 | $1029;
  $A=$1030;
  var $1031=$D;
  var $1032=$1031 << 5;
  var $1033=$D;
  var $1034=$1033 >>> 27;
  var $1035=$1032 | $1034;
  var $1036=$E;
  var $1037=$A;
  var $1038=$1036 ^ $1037;
  var $1039=$B;
  var $1040=$1038 ^ $1039;
  var $1041=(($1035+$1040)|0);
  var $1042=(($1041+1859775393)|0);
  var $1043=$2;
  var $1044=(($1043+44)|0);
  var $1045=HEAP32[(($1044)>>2)];
  var $1046=$2;
  var $1047=(($1046+52)|0);
  var $1048=HEAP32[(($1047)>>2)];
  var $1049=$1045 ^ $1048;
  var $1050=$2;
  var $1051=(($1050+12)|0);
  var $1052=HEAP32[(($1051)>>2)];
  var $1053=$1049 ^ $1052;
  var $1054=$2;
  var $1055=(($1054+32)|0);
  var $1056=HEAP32[(($1055)>>2)];
  var $1057=$1053 ^ $1056;
  var $1058=$1057 << 1;
  var $1059=$2;
  var $1060=(($1059+44)|0);
  var $1061=HEAP32[(($1060)>>2)];
  var $1062=$2;
  var $1063=(($1062+52)|0);
  var $1064=HEAP32[(($1063)>>2)];
  var $1065=$1061 ^ $1064;
  var $1066=$2;
  var $1067=(($1066+12)|0);
  var $1068=HEAP32[(($1067)>>2)];
  var $1069=$1065 ^ $1068;
  var $1070=$2;
  var $1071=(($1070+32)|0);
  var $1072=HEAP32[(($1071)>>2)];
  var $1073=$1069 ^ $1072;
  var $1074=$1073 >>> 31;
  var $1075=$1058 | $1074;
  var $1076=$2;
  var $1077=(($1076+44)|0);
  HEAP32[(($1077)>>2)]=$1075;
  var $1078=(($1042+$1075)|0);
  var $1079=$C;
  var $1080=(($1079+$1078)|0);
  $C=$1080;
  var $1081=$E;
  var $1082=$1081 << 30;
  var $1083=$E;
  var $1084=$1083 >>> 2;
  var $1085=$1082 | $1084;
  $E=$1085;
  var $1086=$C;
  var $1087=$1086 << 5;
  var $1088=$C;
  var $1089=$1088 >>> 27;
  var $1090=$1087 | $1089;
  var $1091=$D;
  var $1092=$E;
  var $1093=$1091 ^ $1092;
  var $1094=$A;
  var $1095=$1093 ^ $1094;
  var $1096=(($1090+$1095)|0);
  var $1097=(($1096+1859775393)|0);
  var $1098=$2;
  var $1099=(($1098+48)|0);
  var $1100=HEAP32[(($1099)>>2)];
  var $1101=$2;
  var $1102=(($1101+56)|0);
  var $1103=HEAP32[(($1102)>>2)];
  var $1104=$1100 ^ $1103;
  var $1105=$2;
  var $1106=(($1105+16)|0);
  var $1107=HEAP32[(($1106)>>2)];
  var $1108=$1104 ^ $1107;
  var $1109=$2;
  var $1110=(($1109+36)|0);
  var $1111=HEAP32[(($1110)>>2)];
  var $1112=$1108 ^ $1111;
  var $1113=$1112 << 1;
  var $1114=$2;
  var $1115=(($1114+48)|0);
  var $1116=HEAP32[(($1115)>>2)];
  var $1117=$2;
  var $1118=(($1117+56)|0);
  var $1119=HEAP32[(($1118)>>2)];
  var $1120=$1116 ^ $1119;
  var $1121=$2;
  var $1122=(($1121+16)|0);
  var $1123=HEAP32[(($1122)>>2)];
  var $1124=$1120 ^ $1123;
  var $1125=$2;
  var $1126=(($1125+36)|0);
  var $1127=HEAP32[(($1126)>>2)];
  var $1128=$1124 ^ $1127;
  var $1129=$1128 >>> 31;
  var $1130=$1113 | $1129;
  var $1131=$2;
  var $1132=(($1131+48)|0);
  HEAP32[(($1132)>>2)]=$1130;
  var $1133=(($1097+$1130)|0);
  var $1134=$B;
  var $1135=(($1134+$1133)|0);
  $B=$1135;
  var $1136=$D;
  var $1137=$1136 << 30;
  var $1138=$D;
  var $1139=$1138 >>> 2;
  var $1140=$1137 | $1139;
  $D=$1140;
  var $1141=$B;
  var $1142=$1141 << 5;
  var $1143=$B;
  var $1144=$1143 >>> 27;
  var $1145=$1142 | $1144;
  var $1146=$C;
  var $1147=$D;
  var $1148=$1146 ^ $1147;
  var $1149=$E;
  var $1150=$1148 ^ $1149;
  var $1151=(($1145+$1150)|0);
  var $1152=(($1151+1859775393)|0);
  var $1153=$2;
  var $1154=(($1153+52)|0);
  var $1155=HEAP32[(($1154)>>2)];
  var $1156=$2;
  var $1157=(($1156+60)|0);
  var $1158=HEAP32[(($1157)>>2)];
  var $1159=$1155 ^ $1158;
  var $1160=$2;
  var $1161=(($1160+20)|0);
  var $1162=HEAP32[(($1161)>>2)];
  var $1163=$1159 ^ $1162;
  var $1164=$2;
  var $1165=(($1164+40)|0);
  var $1166=HEAP32[(($1165)>>2)];
  var $1167=$1163 ^ $1166;
  var $1168=$1167 << 1;
  var $1169=$2;
  var $1170=(($1169+52)|0);
  var $1171=HEAP32[(($1170)>>2)];
  var $1172=$2;
  var $1173=(($1172+60)|0);
  var $1174=HEAP32[(($1173)>>2)];
  var $1175=$1171 ^ $1174;
  var $1176=$2;
  var $1177=(($1176+20)|0);
  var $1178=HEAP32[(($1177)>>2)];
  var $1179=$1175 ^ $1178;
  var $1180=$2;
  var $1181=(($1180+40)|0);
  var $1182=HEAP32[(($1181)>>2)];
  var $1183=$1179 ^ $1182;
  var $1184=$1183 >>> 31;
  var $1185=$1168 | $1184;
  var $1186=$2;
  var $1187=(($1186+52)|0);
  HEAP32[(($1187)>>2)]=$1185;
  var $1188=(($1152+$1185)|0);
  var $1189=$A;
  var $1190=(($1189+$1188)|0);
  $A=$1190;
  var $1191=$C;
  var $1192=$1191 << 30;
  var $1193=$C;
  var $1194=$1193 >>> 2;
  var $1195=$1192 | $1194;
  $C=$1195;
  var $1196=$A;
  var $1197=$1196 << 5;
  var $1198=$A;
  var $1199=$1198 >>> 27;
  var $1200=$1197 | $1199;
  var $1201=$B;
  var $1202=$C;
  var $1203=$1201 ^ $1202;
  var $1204=$D;
  var $1205=$1203 ^ $1204;
  var $1206=(($1200+$1205)|0);
  var $1207=(($1206+1859775393)|0);
  var $1208=$2;
  var $1209=(($1208+56)|0);
  var $1210=HEAP32[(($1209)>>2)];
  var $1211=$2;
  var $1212=(($1211)|0);
  var $1213=HEAP32[(($1212)>>2)];
  var $1214=$1210 ^ $1213;
  var $1215=$2;
  var $1216=(($1215+24)|0);
  var $1217=HEAP32[(($1216)>>2)];
  var $1218=$1214 ^ $1217;
  var $1219=$2;
  var $1220=(($1219+44)|0);
  var $1221=HEAP32[(($1220)>>2)];
  var $1222=$1218 ^ $1221;
  var $1223=$1222 << 1;
  var $1224=$2;
  var $1225=(($1224+56)|0);
  var $1226=HEAP32[(($1225)>>2)];
  var $1227=$2;
  var $1228=(($1227)|0);
  var $1229=HEAP32[(($1228)>>2)];
  var $1230=$1226 ^ $1229;
  var $1231=$2;
  var $1232=(($1231+24)|0);
  var $1233=HEAP32[(($1232)>>2)];
  var $1234=$1230 ^ $1233;
  var $1235=$2;
  var $1236=(($1235+44)|0);
  var $1237=HEAP32[(($1236)>>2)];
  var $1238=$1234 ^ $1237;
  var $1239=$1238 >>> 31;
  var $1240=$1223 | $1239;
  var $1241=$2;
  var $1242=(($1241+56)|0);
  HEAP32[(($1242)>>2)]=$1240;
  var $1243=(($1207+$1240)|0);
  var $1244=$E;
  var $1245=(($1244+$1243)|0);
  $E=$1245;
  var $1246=$B;
  var $1247=$1246 << 30;
  var $1248=$B;
  var $1249=$1248 >>> 2;
  var $1250=$1247 | $1249;
  $B=$1250;
  var $1251=$E;
  var $1252=$1251 << 5;
  var $1253=$E;
  var $1254=$1253 >>> 27;
  var $1255=$1252 | $1254;
  var $1256=$A;
  var $1257=$B;
  var $1258=$1256 ^ $1257;
  var $1259=$C;
  var $1260=$1258 ^ $1259;
  var $1261=(($1255+$1260)|0);
  var $1262=(($1261+1859775393)|0);
  var $1263=$2;
  var $1264=(($1263+60)|0);
  var $1265=HEAP32[(($1264)>>2)];
  var $1266=$2;
  var $1267=(($1266+4)|0);
  var $1268=HEAP32[(($1267)>>2)];
  var $1269=$1265 ^ $1268;
  var $1270=$2;
  var $1271=(($1270+28)|0);
  var $1272=HEAP32[(($1271)>>2)];
  var $1273=$1269 ^ $1272;
  var $1274=$2;
  var $1275=(($1274+48)|0);
  var $1276=HEAP32[(($1275)>>2)];
  var $1277=$1273 ^ $1276;
  var $1278=$1277 << 1;
  var $1279=$2;
  var $1280=(($1279+60)|0);
  var $1281=HEAP32[(($1280)>>2)];
  var $1282=$2;
  var $1283=(($1282+4)|0);
  var $1284=HEAP32[(($1283)>>2)];
  var $1285=$1281 ^ $1284;
  var $1286=$2;
  var $1287=(($1286+28)|0);
  var $1288=HEAP32[(($1287)>>2)];
  var $1289=$1285 ^ $1288;
  var $1290=$2;
  var $1291=(($1290+48)|0);
  var $1292=HEAP32[(($1291)>>2)];
  var $1293=$1289 ^ $1292;
  var $1294=$1293 >>> 31;
  var $1295=$1278 | $1294;
  var $1296=$2;
  var $1297=(($1296+60)|0);
  HEAP32[(($1297)>>2)]=$1295;
  var $1298=(($1262+$1295)|0);
  var $1299=$D;
  var $1300=(($1299+$1298)|0);
  $D=$1300;
  var $1301=$A;
  var $1302=$1301 << 30;
  var $1303=$A;
  var $1304=$1303 >>> 2;
  var $1305=$1302 | $1304;
  $A=$1305;
  var $1306=$D;
  var $1307=$1306 << 5;
  var $1308=$D;
  var $1309=$1308 >>> 27;
  var $1310=$1307 | $1309;
  var $1311=$E;
  var $1312=$A;
  var $1313=$1311 ^ $1312;
  var $1314=$B;
  var $1315=$1313 ^ $1314;
  var $1316=(($1310+$1315)|0);
  var $1317=(($1316+1859775393)|0);
  var $1318=$2;
  var $1319=(($1318)|0);
  var $1320=HEAP32[(($1319)>>2)];
  var $1321=$2;
  var $1322=(($1321+8)|0);
  var $1323=HEAP32[(($1322)>>2)];
  var $1324=$1320 ^ $1323;
  var $1325=$2;
  var $1326=(($1325+32)|0);
  var $1327=HEAP32[(($1326)>>2)];
  var $1328=$1324 ^ $1327;
  var $1329=$2;
  var $1330=(($1329+52)|0);
  var $1331=HEAP32[(($1330)>>2)];
  var $1332=$1328 ^ $1331;
  var $1333=$1332 << 1;
  var $1334=$2;
  var $1335=(($1334)|0);
  var $1336=HEAP32[(($1335)>>2)];
  var $1337=$2;
  var $1338=(($1337+8)|0);
  var $1339=HEAP32[(($1338)>>2)];
  var $1340=$1336 ^ $1339;
  var $1341=$2;
  var $1342=(($1341+32)|0);
  var $1343=HEAP32[(($1342)>>2)];
  var $1344=$1340 ^ $1343;
  var $1345=$2;
  var $1346=(($1345+52)|0);
  var $1347=HEAP32[(($1346)>>2)];
  var $1348=$1344 ^ $1347;
  var $1349=$1348 >>> 31;
  var $1350=$1333 | $1349;
  var $1351=$2;
  var $1352=(($1351)|0);
  HEAP32[(($1352)>>2)]=$1350;
  var $1353=(($1317+$1350)|0);
  var $1354=$C;
  var $1355=(($1354+$1353)|0);
  $C=$1355;
  var $1356=$E;
  var $1357=$1356 << 30;
  var $1358=$E;
  var $1359=$1358 >>> 2;
  var $1360=$1357 | $1359;
  $E=$1360;
  var $1361=$C;
  var $1362=$1361 << 5;
  var $1363=$C;
  var $1364=$1363 >>> 27;
  var $1365=$1362 | $1364;
  var $1366=$D;
  var $1367=$E;
  var $1368=$1366 ^ $1367;
  var $1369=$A;
  var $1370=$1368 ^ $1369;
  var $1371=(($1365+$1370)|0);
  var $1372=(($1371+1859775393)|0);
  var $1373=$2;
  var $1374=(($1373+4)|0);
  var $1375=HEAP32[(($1374)>>2)];
  var $1376=$2;
  var $1377=(($1376+12)|0);
  var $1378=HEAP32[(($1377)>>2)];
  var $1379=$1375 ^ $1378;
  var $1380=$2;
  var $1381=(($1380+36)|0);
  var $1382=HEAP32[(($1381)>>2)];
  var $1383=$1379 ^ $1382;
  var $1384=$2;
  var $1385=(($1384+56)|0);
  var $1386=HEAP32[(($1385)>>2)];
  var $1387=$1383 ^ $1386;
  var $1388=$1387 << 1;
  var $1389=$2;
  var $1390=(($1389+4)|0);
  var $1391=HEAP32[(($1390)>>2)];
  var $1392=$2;
  var $1393=(($1392+12)|0);
  var $1394=HEAP32[(($1393)>>2)];
  var $1395=$1391 ^ $1394;
  var $1396=$2;
  var $1397=(($1396+36)|0);
  var $1398=HEAP32[(($1397)>>2)];
  var $1399=$1395 ^ $1398;
  var $1400=$2;
  var $1401=(($1400+56)|0);
  var $1402=HEAP32[(($1401)>>2)];
  var $1403=$1399 ^ $1402;
  var $1404=$1403 >>> 31;
  var $1405=$1388 | $1404;
  var $1406=$2;
  var $1407=(($1406+4)|0);
  HEAP32[(($1407)>>2)]=$1405;
  var $1408=(($1372+$1405)|0);
  var $1409=$B;
  var $1410=(($1409+$1408)|0);
  $B=$1410;
  var $1411=$D;
  var $1412=$1411 << 30;
  var $1413=$D;
  var $1414=$1413 >>> 2;
  var $1415=$1412 | $1414;
  $D=$1415;
  var $1416=$B;
  var $1417=$1416 << 5;
  var $1418=$B;
  var $1419=$1418 >>> 27;
  var $1420=$1417 | $1419;
  var $1421=$C;
  var $1422=$D;
  var $1423=$1421 ^ $1422;
  var $1424=$E;
  var $1425=$1423 ^ $1424;
  var $1426=(($1420+$1425)|0);
  var $1427=(($1426+1859775393)|0);
  var $1428=$2;
  var $1429=(($1428+8)|0);
  var $1430=HEAP32[(($1429)>>2)];
  var $1431=$2;
  var $1432=(($1431+16)|0);
  var $1433=HEAP32[(($1432)>>2)];
  var $1434=$1430 ^ $1433;
  var $1435=$2;
  var $1436=(($1435+40)|0);
  var $1437=HEAP32[(($1436)>>2)];
  var $1438=$1434 ^ $1437;
  var $1439=$2;
  var $1440=(($1439+60)|0);
  var $1441=HEAP32[(($1440)>>2)];
  var $1442=$1438 ^ $1441;
  var $1443=$1442 << 1;
  var $1444=$2;
  var $1445=(($1444+8)|0);
  var $1446=HEAP32[(($1445)>>2)];
  var $1447=$2;
  var $1448=(($1447+16)|0);
  var $1449=HEAP32[(($1448)>>2)];
  var $1450=$1446 ^ $1449;
  var $1451=$2;
  var $1452=(($1451+40)|0);
  var $1453=HEAP32[(($1452)>>2)];
  var $1454=$1450 ^ $1453;
  var $1455=$2;
  var $1456=(($1455+60)|0);
  var $1457=HEAP32[(($1456)>>2)];
  var $1458=$1454 ^ $1457;
  var $1459=$1458 >>> 31;
  var $1460=$1443 | $1459;
  var $1461=$2;
  var $1462=(($1461+8)|0);
  HEAP32[(($1462)>>2)]=$1460;
  var $1463=(($1427+$1460)|0);
  var $1464=$A;
  var $1465=(($1464+$1463)|0);
  $A=$1465;
  var $1466=$C;
  var $1467=$1466 << 30;
  var $1468=$C;
  var $1469=$1468 >>> 2;
  var $1470=$1467 | $1469;
  $C=$1470;
  var $1471=$A;
  var $1472=$1471 << 5;
  var $1473=$A;
  var $1474=$1473 >>> 27;
  var $1475=$1472 | $1474;
  var $1476=$B;
  var $1477=$C;
  var $1478=$1476 ^ $1477;
  var $1479=$D;
  var $1480=$1478 ^ $1479;
  var $1481=(($1475+$1480)|0);
  var $1482=(($1481+1859775393)|0);
  var $1483=$2;
  var $1484=(($1483+12)|0);
  var $1485=HEAP32[(($1484)>>2)];
  var $1486=$2;
  var $1487=(($1486+20)|0);
  var $1488=HEAP32[(($1487)>>2)];
  var $1489=$1485 ^ $1488;
  var $1490=$2;
  var $1491=(($1490+44)|0);
  var $1492=HEAP32[(($1491)>>2)];
  var $1493=$1489 ^ $1492;
  var $1494=$2;
  var $1495=(($1494)|0);
  var $1496=HEAP32[(($1495)>>2)];
  var $1497=$1493 ^ $1496;
  var $1498=$1497 << 1;
  var $1499=$2;
  var $1500=(($1499+12)|0);
  var $1501=HEAP32[(($1500)>>2)];
  var $1502=$2;
  var $1503=(($1502+20)|0);
  var $1504=HEAP32[(($1503)>>2)];
  var $1505=$1501 ^ $1504;
  var $1506=$2;
  var $1507=(($1506+44)|0);
  var $1508=HEAP32[(($1507)>>2)];
  var $1509=$1505 ^ $1508;
  var $1510=$2;
  var $1511=(($1510)|0);
  var $1512=HEAP32[(($1511)>>2)];
  var $1513=$1509 ^ $1512;
  var $1514=$1513 >>> 31;
  var $1515=$1498 | $1514;
  var $1516=$2;
  var $1517=(($1516+12)|0);
  HEAP32[(($1517)>>2)]=$1515;
  var $1518=(($1482+$1515)|0);
  var $1519=$E;
  var $1520=(($1519+$1518)|0);
  $E=$1520;
  var $1521=$B;
  var $1522=$1521 << 30;
  var $1523=$B;
  var $1524=$1523 >>> 2;
  var $1525=$1522 | $1524;
  $B=$1525;
  var $1526=$E;
  var $1527=$1526 << 5;
  var $1528=$E;
  var $1529=$1528 >>> 27;
  var $1530=$1527 | $1529;
  var $1531=$A;
  var $1532=$B;
  var $1533=$1531 ^ $1532;
  var $1534=$C;
  var $1535=$1533 ^ $1534;
  var $1536=(($1530+$1535)|0);
  var $1537=(($1536+1859775393)|0);
  var $1538=$2;
  var $1539=(($1538+16)|0);
  var $1540=HEAP32[(($1539)>>2)];
  var $1541=$2;
  var $1542=(($1541+24)|0);
  var $1543=HEAP32[(($1542)>>2)];
  var $1544=$1540 ^ $1543;
  var $1545=$2;
  var $1546=(($1545+48)|0);
  var $1547=HEAP32[(($1546)>>2)];
  var $1548=$1544 ^ $1547;
  var $1549=$2;
  var $1550=(($1549+4)|0);
  var $1551=HEAP32[(($1550)>>2)];
  var $1552=$1548 ^ $1551;
  var $1553=$1552 << 1;
  var $1554=$2;
  var $1555=(($1554+16)|0);
  var $1556=HEAP32[(($1555)>>2)];
  var $1557=$2;
  var $1558=(($1557+24)|0);
  var $1559=HEAP32[(($1558)>>2)];
  var $1560=$1556 ^ $1559;
  var $1561=$2;
  var $1562=(($1561+48)|0);
  var $1563=HEAP32[(($1562)>>2)];
  var $1564=$1560 ^ $1563;
  var $1565=$2;
  var $1566=(($1565+4)|0);
  var $1567=HEAP32[(($1566)>>2)];
  var $1568=$1564 ^ $1567;
  var $1569=$1568 >>> 31;
  var $1570=$1553 | $1569;
  var $1571=$2;
  var $1572=(($1571+16)|0);
  HEAP32[(($1572)>>2)]=$1570;
  var $1573=(($1537+$1570)|0);
  var $1574=$D;
  var $1575=(($1574+$1573)|0);
  $D=$1575;
  var $1576=$A;
  var $1577=$1576 << 30;
  var $1578=$A;
  var $1579=$1578 >>> 2;
  var $1580=$1577 | $1579;
  $A=$1580;
  var $1581=$D;
  var $1582=$1581 << 5;
  var $1583=$D;
  var $1584=$1583 >>> 27;
  var $1585=$1582 | $1584;
  var $1586=$E;
  var $1587=$A;
  var $1588=$1586 ^ $1587;
  var $1589=$B;
  var $1590=$1588 ^ $1589;
  var $1591=(($1585+$1590)|0);
  var $1592=(($1591+1859775393)|0);
  var $1593=$2;
  var $1594=(($1593+20)|0);
  var $1595=HEAP32[(($1594)>>2)];
  var $1596=$2;
  var $1597=(($1596+28)|0);
  var $1598=HEAP32[(($1597)>>2)];
  var $1599=$1595 ^ $1598;
  var $1600=$2;
  var $1601=(($1600+52)|0);
  var $1602=HEAP32[(($1601)>>2)];
  var $1603=$1599 ^ $1602;
  var $1604=$2;
  var $1605=(($1604+8)|0);
  var $1606=HEAP32[(($1605)>>2)];
  var $1607=$1603 ^ $1606;
  var $1608=$1607 << 1;
  var $1609=$2;
  var $1610=(($1609+20)|0);
  var $1611=HEAP32[(($1610)>>2)];
  var $1612=$2;
  var $1613=(($1612+28)|0);
  var $1614=HEAP32[(($1613)>>2)];
  var $1615=$1611 ^ $1614;
  var $1616=$2;
  var $1617=(($1616+52)|0);
  var $1618=HEAP32[(($1617)>>2)];
  var $1619=$1615 ^ $1618;
  var $1620=$2;
  var $1621=(($1620+8)|0);
  var $1622=HEAP32[(($1621)>>2)];
  var $1623=$1619 ^ $1622;
  var $1624=$1623 >>> 31;
  var $1625=$1608 | $1624;
  var $1626=$2;
  var $1627=(($1626+20)|0);
  HEAP32[(($1627)>>2)]=$1625;
  var $1628=(($1592+$1625)|0);
  var $1629=$C;
  var $1630=(($1629+$1628)|0);
  $C=$1630;
  var $1631=$E;
  var $1632=$1631 << 30;
  var $1633=$E;
  var $1634=$1633 >>> 2;
  var $1635=$1632 | $1634;
  $E=$1635;
  var $1636=$C;
  var $1637=$1636 << 5;
  var $1638=$C;
  var $1639=$1638 >>> 27;
  var $1640=$1637 | $1639;
  var $1641=$D;
  var $1642=$E;
  var $1643=$1641 ^ $1642;
  var $1644=$A;
  var $1645=$1643 ^ $1644;
  var $1646=(($1640+$1645)|0);
  var $1647=(($1646+1859775393)|0);
  var $1648=$2;
  var $1649=(($1648+24)|0);
  var $1650=HEAP32[(($1649)>>2)];
  var $1651=$2;
  var $1652=(($1651+32)|0);
  var $1653=HEAP32[(($1652)>>2)];
  var $1654=$1650 ^ $1653;
  var $1655=$2;
  var $1656=(($1655+56)|0);
  var $1657=HEAP32[(($1656)>>2)];
  var $1658=$1654 ^ $1657;
  var $1659=$2;
  var $1660=(($1659+12)|0);
  var $1661=HEAP32[(($1660)>>2)];
  var $1662=$1658 ^ $1661;
  var $1663=$1662 << 1;
  var $1664=$2;
  var $1665=(($1664+24)|0);
  var $1666=HEAP32[(($1665)>>2)];
  var $1667=$2;
  var $1668=(($1667+32)|0);
  var $1669=HEAP32[(($1668)>>2)];
  var $1670=$1666 ^ $1669;
  var $1671=$2;
  var $1672=(($1671+56)|0);
  var $1673=HEAP32[(($1672)>>2)];
  var $1674=$1670 ^ $1673;
  var $1675=$2;
  var $1676=(($1675+12)|0);
  var $1677=HEAP32[(($1676)>>2)];
  var $1678=$1674 ^ $1677;
  var $1679=$1678 >>> 31;
  var $1680=$1663 | $1679;
  var $1681=$2;
  var $1682=(($1681+24)|0);
  HEAP32[(($1682)>>2)]=$1680;
  var $1683=(($1647+$1680)|0);
  var $1684=$B;
  var $1685=(($1684+$1683)|0);
  $B=$1685;
  var $1686=$D;
  var $1687=$1686 << 30;
  var $1688=$D;
  var $1689=$1688 >>> 2;
  var $1690=$1687 | $1689;
  $D=$1690;
  var $1691=$B;
  var $1692=$1691 << 5;
  var $1693=$B;
  var $1694=$1693 >>> 27;
  var $1695=$1692 | $1694;
  var $1696=$C;
  var $1697=$D;
  var $1698=$1696 ^ $1697;
  var $1699=$E;
  var $1700=$1698 ^ $1699;
  var $1701=(($1695+$1700)|0);
  var $1702=(($1701+1859775393)|0);
  var $1703=$2;
  var $1704=(($1703+28)|0);
  var $1705=HEAP32[(($1704)>>2)];
  var $1706=$2;
  var $1707=(($1706+36)|0);
  var $1708=HEAP32[(($1707)>>2)];
  var $1709=$1705 ^ $1708;
  var $1710=$2;
  var $1711=(($1710+60)|0);
  var $1712=HEAP32[(($1711)>>2)];
  var $1713=$1709 ^ $1712;
  var $1714=$2;
  var $1715=(($1714+16)|0);
  var $1716=HEAP32[(($1715)>>2)];
  var $1717=$1713 ^ $1716;
  var $1718=$1717 << 1;
  var $1719=$2;
  var $1720=(($1719+28)|0);
  var $1721=HEAP32[(($1720)>>2)];
  var $1722=$2;
  var $1723=(($1722+36)|0);
  var $1724=HEAP32[(($1723)>>2)];
  var $1725=$1721 ^ $1724;
  var $1726=$2;
  var $1727=(($1726+60)|0);
  var $1728=HEAP32[(($1727)>>2)];
  var $1729=$1725 ^ $1728;
  var $1730=$2;
  var $1731=(($1730+16)|0);
  var $1732=HEAP32[(($1731)>>2)];
  var $1733=$1729 ^ $1732;
  var $1734=$1733 >>> 31;
  var $1735=$1718 | $1734;
  var $1736=$2;
  var $1737=(($1736+28)|0);
  HEAP32[(($1737)>>2)]=$1735;
  var $1738=(($1702+$1735)|0);
  var $1739=$A;
  var $1740=(($1739+$1738)|0);
  $A=$1740;
  var $1741=$C;
  var $1742=$1741 << 30;
  var $1743=$C;
  var $1744=$1743 >>> 2;
  var $1745=$1742 | $1744;
  $C=$1745;
  var $1746=$A;
  var $1747=$1746 << 5;
  var $1748=$A;
  var $1749=$1748 >>> 27;
  var $1750=$1747 | $1749;
  var $1751=$B;
  var $1752=$C;
  var $1753=$1751 & $1752;
  var $1754=$D;
  var $1755=$B;
  var $1756=$C;
  var $1757=$1755 | $1756;
  var $1758=$1754 & $1757;
  var $1759=$1753 | $1758;
  var $1760=(($1750+$1759)|0);
  var $1761=(($1760-1894007588)|0);
  var $1762=$2;
  var $1763=(($1762+32)|0);
  var $1764=HEAP32[(($1763)>>2)];
  var $1765=$2;
  var $1766=(($1765+40)|0);
  var $1767=HEAP32[(($1766)>>2)];
  var $1768=$1764 ^ $1767;
  var $1769=$2;
  var $1770=(($1769)|0);
  var $1771=HEAP32[(($1770)>>2)];
  var $1772=$1768 ^ $1771;
  var $1773=$2;
  var $1774=(($1773+20)|0);
  var $1775=HEAP32[(($1774)>>2)];
  var $1776=$1772 ^ $1775;
  var $1777=$1776 << 1;
  var $1778=$2;
  var $1779=(($1778+32)|0);
  var $1780=HEAP32[(($1779)>>2)];
  var $1781=$2;
  var $1782=(($1781+40)|0);
  var $1783=HEAP32[(($1782)>>2)];
  var $1784=$1780 ^ $1783;
  var $1785=$2;
  var $1786=(($1785)|0);
  var $1787=HEAP32[(($1786)>>2)];
  var $1788=$1784 ^ $1787;
  var $1789=$2;
  var $1790=(($1789+20)|0);
  var $1791=HEAP32[(($1790)>>2)];
  var $1792=$1788 ^ $1791;
  var $1793=$1792 >>> 31;
  var $1794=$1777 | $1793;
  var $1795=$2;
  var $1796=(($1795+32)|0);
  HEAP32[(($1796)>>2)]=$1794;
  var $1797=(($1761+$1794)|0);
  var $1798=$E;
  var $1799=(($1798+$1797)|0);
  $E=$1799;
  var $1800=$B;
  var $1801=$1800 << 30;
  var $1802=$B;
  var $1803=$1802 >>> 2;
  var $1804=$1801 | $1803;
  $B=$1804;
  var $1805=$E;
  var $1806=$1805 << 5;
  var $1807=$E;
  var $1808=$1807 >>> 27;
  var $1809=$1806 | $1808;
  var $1810=$A;
  var $1811=$B;
  var $1812=$1810 & $1811;
  var $1813=$C;
  var $1814=$A;
  var $1815=$B;
  var $1816=$1814 | $1815;
  var $1817=$1813 & $1816;
  var $1818=$1812 | $1817;
  var $1819=(($1809+$1818)|0);
  var $1820=(($1819-1894007588)|0);
  var $1821=$2;
  var $1822=(($1821+36)|0);
  var $1823=HEAP32[(($1822)>>2)];
  var $1824=$2;
  var $1825=(($1824+44)|0);
  var $1826=HEAP32[(($1825)>>2)];
  var $1827=$1823 ^ $1826;
  var $1828=$2;
  var $1829=(($1828+4)|0);
  var $1830=HEAP32[(($1829)>>2)];
  var $1831=$1827 ^ $1830;
  var $1832=$2;
  var $1833=(($1832+24)|0);
  var $1834=HEAP32[(($1833)>>2)];
  var $1835=$1831 ^ $1834;
  var $1836=$1835 << 1;
  var $1837=$2;
  var $1838=(($1837+36)|0);
  var $1839=HEAP32[(($1838)>>2)];
  var $1840=$2;
  var $1841=(($1840+44)|0);
  var $1842=HEAP32[(($1841)>>2)];
  var $1843=$1839 ^ $1842;
  var $1844=$2;
  var $1845=(($1844+4)|0);
  var $1846=HEAP32[(($1845)>>2)];
  var $1847=$1843 ^ $1846;
  var $1848=$2;
  var $1849=(($1848+24)|0);
  var $1850=HEAP32[(($1849)>>2)];
  var $1851=$1847 ^ $1850;
  var $1852=$1851 >>> 31;
  var $1853=$1836 | $1852;
  var $1854=$2;
  var $1855=(($1854+36)|0);
  HEAP32[(($1855)>>2)]=$1853;
  var $1856=(($1820+$1853)|0);
  var $1857=$D;
  var $1858=(($1857+$1856)|0);
  $D=$1858;
  var $1859=$A;
  var $1860=$1859 << 30;
  var $1861=$A;
  var $1862=$1861 >>> 2;
  var $1863=$1860 | $1862;
  $A=$1863;
  var $1864=$D;
  var $1865=$1864 << 5;
  var $1866=$D;
  var $1867=$1866 >>> 27;
  var $1868=$1865 | $1867;
  var $1869=$E;
  var $1870=$A;
  var $1871=$1869 & $1870;
  var $1872=$B;
  var $1873=$E;
  var $1874=$A;
  var $1875=$1873 | $1874;
  var $1876=$1872 & $1875;
  var $1877=$1871 | $1876;
  var $1878=(($1868+$1877)|0);
  var $1879=(($1878-1894007588)|0);
  var $1880=$2;
  var $1881=(($1880+40)|0);
  var $1882=HEAP32[(($1881)>>2)];
  var $1883=$2;
  var $1884=(($1883+48)|0);
  var $1885=HEAP32[(($1884)>>2)];
  var $1886=$1882 ^ $1885;
  var $1887=$2;
  var $1888=(($1887+8)|0);
  var $1889=HEAP32[(($1888)>>2)];
  var $1890=$1886 ^ $1889;
  var $1891=$2;
  var $1892=(($1891+28)|0);
  var $1893=HEAP32[(($1892)>>2)];
  var $1894=$1890 ^ $1893;
  var $1895=$1894 << 1;
  var $1896=$2;
  var $1897=(($1896+40)|0);
  var $1898=HEAP32[(($1897)>>2)];
  var $1899=$2;
  var $1900=(($1899+48)|0);
  var $1901=HEAP32[(($1900)>>2)];
  var $1902=$1898 ^ $1901;
  var $1903=$2;
  var $1904=(($1903+8)|0);
  var $1905=HEAP32[(($1904)>>2)];
  var $1906=$1902 ^ $1905;
  var $1907=$2;
  var $1908=(($1907+28)|0);
  var $1909=HEAP32[(($1908)>>2)];
  var $1910=$1906 ^ $1909;
  var $1911=$1910 >>> 31;
  var $1912=$1895 | $1911;
  var $1913=$2;
  var $1914=(($1913+40)|0);
  HEAP32[(($1914)>>2)]=$1912;
  var $1915=(($1879+$1912)|0);
  var $1916=$C;
  var $1917=(($1916+$1915)|0);
  $C=$1917;
  var $1918=$E;
  var $1919=$1918 << 30;
  var $1920=$E;
  var $1921=$1920 >>> 2;
  var $1922=$1919 | $1921;
  $E=$1922;
  var $1923=$C;
  var $1924=$1923 << 5;
  var $1925=$C;
  var $1926=$1925 >>> 27;
  var $1927=$1924 | $1926;
  var $1928=$D;
  var $1929=$E;
  var $1930=$1928 & $1929;
  var $1931=$A;
  var $1932=$D;
  var $1933=$E;
  var $1934=$1932 | $1933;
  var $1935=$1931 & $1934;
  var $1936=$1930 | $1935;
  var $1937=(($1927+$1936)|0);
  var $1938=(($1937-1894007588)|0);
  var $1939=$2;
  var $1940=(($1939+44)|0);
  var $1941=HEAP32[(($1940)>>2)];
  var $1942=$2;
  var $1943=(($1942+52)|0);
  var $1944=HEAP32[(($1943)>>2)];
  var $1945=$1941 ^ $1944;
  var $1946=$2;
  var $1947=(($1946+12)|0);
  var $1948=HEAP32[(($1947)>>2)];
  var $1949=$1945 ^ $1948;
  var $1950=$2;
  var $1951=(($1950+32)|0);
  var $1952=HEAP32[(($1951)>>2)];
  var $1953=$1949 ^ $1952;
  var $1954=$1953 << 1;
  var $1955=$2;
  var $1956=(($1955+44)|0);
  var $1957=HEAP32[(($1956)>>2)];
  var $1958=$2;
  var $1959=(($1958+52)|0);
  var $1960=HEAP32[(($1959)>>2)];
  var $1961=$1957 ^ $1960;
  var $1962=$2;
  var $1963=(($1962+12)|0);
  var $1964=HEAP32[(($1963)>>2)];
  var $1965=$1961 ^ $1964;
  var $1966=$2;
  var $1967=(($1966+32)|0);
  var $1968=HEAP32[(($1967)>>2)];
  var $1969=$1965 ^ $1968;
  var $1970=$1969 >>> 31;
  var $1971=$1954 | $1970;
  var $1972=$2;
  var $1973=(($1972+44)|0);
  HEAP32[(($1973)>>2)]=$1971;
  var $1974=(($1938+$1971)|0);
  var $1975=$B;
  var $1976=(($1975+$1974)|0);
  $B=$1976;
  var $1977=$D;
  var $1978=$1977 << 30;
  var $1979=$D;
  var $1980=$1979 >>> 2;
  var $1981=$1978 | $1980;
  $D=$1981;
  var $1982=$B;
  var $1983=$1982 << 5;
  var $1984=$B;
  var $1985=$1984 >>> 27;
  var $1986=$1983 | $1985;
  var $1987=$C;
  var $1988=$D;
  var $1989=$1987 & $1988;
  var $1990=$E;
  var $1991=$C;
  var $1992=$D;
  var $1993=$1991 | $1992;
  var $1994=$1990 & $1993;
  var $1995=$1989 | $1994;
  var $1996=(($1986+$1995)|0);
  var $1997=(($1996-1894007588)|0);
  var $1998=$2;
  var $1999=(($1998+48)|0);
  var $2000=HEAP32[(($1999)>>2)];
  var $2001=$2;
  var $2002=(($2001+56)|0);
  var $2003=HEAP32[(($2002)>>2)];
  var $2004=$2000 ^ $2003;
  var $2005=$2;
  var $2006=(($2005+16)|0);
  var $2007=HEAP32[(($2006)>>2)];
  var $2008=$2004 ^ $2007;
  var $2009=$2;
  var $2010=(($2009+36)|0);
  var $2011=HEAP32[(($2010)>>2)];
  var $2012=$2008 ^ $2011;
  var $2013=$2012 << 1;
  var $2014=$2;
  var $2015=(($2014+48)|0);
  var $2016=HEAP32[(($2015)>>2)];
  var $2017=$2;
  var $2018=(($2017+56)|0);
  var $2019=HEAP32[(($2018)>>2)];
  var $2020=$2016 ^ $2019;
  var $2021=$2;
  var $2022=(($2021+16)|0);
  var $2023=HEAP32[(($2022)>>2)];
  var $2024=$2020 ^ $2023;
  var $2025=$2;
  var $2026=(($2025+36)|0);
  var $2027=HEAP32[(($2026)>>2)];
  var $2028=$2024 ^ $2027;
  var $2029=$2028 >>> 31;
  var $2030=$2013 | $2029;
  var $2031=$2;
  var $2032=(($2031+48)|0);
  HEAP32[(($2032)>>2)]=$2030;
  var $2033=(($1997+$2030)|0);
  var $2034=$A;
  var $2035=(($2034+$2033)|0);
  $A=$2035;
  var $2036=$C;
  var $2037=$2036 << 30;
  var $2038=$C;
  var $2039=$2038 >>> 2;
  var $2040=$2037 | $2039;
  $C=$2040;
  var $2041=$A;
  var $2042=$2041 << 5;
  var $2043=$A;
  var $2044=$2043 >>> 27;
  var $2045=$2042 | $2044;
  var $2046=$B;
  var $2047=$C;
  var $2048=$2046 & $2047;
  var $2049=$D;
  var $2050=$B;
  var $2051=$C;
  var $2052=$2050 | $2051;
  var $2053=$2049 & $2052;
  var $2054=$2048 | $2053;
  var $2055=(($2045+$2054)|0);
  var $2056=(($2055-1894007588)|0);
  var $2057=$2;
  var $2058=(($2057+52)|0);
  var $2059=HEAP32[(($2058)>>2)];
  var $2060=$2;
  var $2061=(($2060+60)|0);
  var $2062=HEAP32[(($2061)>>2)];
  var $2063=$2059 ^ $2062;
  var $2064=$2;
  var $2065=(($2064+20)|0);
  var $2066=HEAP32[(($2065)>>2)];
  var $2067=$2063 ^ $2066;
  var $2068=$2;
  var $2069=(($2068+40)|0);
  var $2070=HEAP32[(($2069)>>2)];
  var $2071=$2067 ^ $2070;
  var $2072=$2071 << 1;
  var $2073=$2;
  var $2074=(($2073+52)|0);
  var $2075=HEAP32[(($2074)>>2)];
  var $2076=$2;
  var $2077=(($2076+60)|0);
  var $2078=HEAP32[(($2077)>>2)];
  var $2079=$2075 ^ $2078;
  var $2080=$2;
  var $2081=(($2080+20)|0);
  var $2082=HEAP32[(($2081)>>2)];
  var $2083=$2079 ^ $2082;
  var $2084=$2;
  var $2085=(($2084+40)|0);
  var $2086=HEAP32[(($2085)>>2)];
  var $2087=$2083 ^ $2086;
  var $2088=$2087 >>> 31;
  var $2089=$2072 | $2088;
  var $2090=$2;
  var $2091=(($2090+52)|0);
  HEAP32[(($2091)>>2)]=$2089;
  var $2092=(($2056+$2089)|0);
  var $2093=$E;
  var $2094=(($2093+$2092)|0);
  $E=$2094;
  var $2095=$B;
  var $2096=$2095 << 30;
  var $2097=$B;
  var $2098=$2097 >>> 2;
  var $2099=$2096 | $2098;
  $B=$2099;
  var $2100=$E;
  var $2101=$2100 << 5;
  var $2102=$E;
  var $2103=$2102 >>> 27;
  var $2104=$2101 | $2103;
  var $2105=$A;
  var $2106=$B;
  var $2107=$2105 & $2106;
  var $2108=$C;
  var $2109=$A;
  var $2110=$B;
  var $2111=$2109 | $2110;
  var $2112=$2108 & $2111;
  var $2113=$2107 | $2112;
  var $2114=(($2104+$2113)|0);
  var $2115=(($2114-1894007588)|0);
  var $2116=$2;
  var $2117=(($2116+56)|0);
  var $2118=HEAP32[(($2117)>>2)];
  var $2119=$2;
  var $2120=(($2119)|0);
  var $2121=HEAP32[(($2120)>>2)];
  var $2122=$2118 ^ $2121;
  var $2123=$2;
  var $2124=(($2123+24)|0);
  var $2125=HEAP32[(($2124)>>2)];
  var $2126=$2122 ^ $2125;
  var $2127=$2;
  var $2128=(($2127+44)|0);
  var $2129=HEAP32[(($2128)>>2)];
  var $2130=$2126 ^ $2129;
  var $2131=$2130 << 1;
  var $2132=$2;
  var $2133=(($2132+56)|0);
  var $2134=HEAP32[(($2133)>>2)];
  var $2135=$2;
  var $2136=(($2135)|0);
  var $2137=HEAP32[(($2136)>>2)];
  var $2138=$2134 ^ $2137;
  var $2139=$2;
  var $2140=(($2139+24)|0);
  var $2141=HEAP32[(($2140)>>2)];
  var $2142=$2138 ^ $2141;
  var $2143=$2;
  var $2144=(($2143+44)|0);
  var $2145=HEAP32[(($2144)>>2)];
  var $2146=$2142 ^ $2145;
  var $2147=$2146 >>> 31;
  var $2148=$2131 | $2147;
  var $2149=$2;
  var $2150=(($2149+56)|0);
  HEAP32[(($2150)>>2)]=$2148;
  var $2151=(($2115+$2148)|0);
  var $2152=$D;
  var $2153=(($2152+$2151)|0);
  $D=$2153;
  var $2154=$A;
  var $2155=$2154 << 30;
  var $2156=$A;
  var $2157=$2156 >>> 2;
  var $2158=$2155 | $2157;
  $A=$2158;
  var $2159=$D;
  var $2160=$2159 << 5;
  var $2161=$D;
  var $2162=$2161 >>> 27;
  var $2163=$2160 | $2162;
  var $2164=$E;
  var $2165=$A;
  var $2166=$2164 & $2165;
  var $2167=$B;
  var $2168=$E;
  var $2169=$A;
  var $2170=$2168 | $2169;
  var $2171=$2167 & $2170;
  var $2172=$2166 | $2171;
  var $2173=(($2163+$2172)|0);
  var $2174=(($2173-1894007588)|0);
  var $2175=$2;
  var $2176=(($2175+60)|0);
  var $2177=HEAP32[(($2176)>>2)];
  var $2178=$2;
  var $2179=(($2178+4)|0);
  var $2180=HEAP32[(($2179)>>2)];
  var $2181=$2177 ^ $2180;
  var $2182=$2;
  var $2183=(($2182+28)|0);
  var $2184=HEAP32[(($2183)>>2)];
  var $2185=$2181 ^ $2184;
  var $2186=$2;
  var $2187=(($2186+48)|0);
  var $2188=HEAP32[(($2187)>>2)];
  var $2189=$2185 ^ $2188;
  var $2190=$2189 << 1;
  var $2191=$2;
  var $2192=(($2191+60)|0);
  var $2193=HEAP32[(($2192)>>2)];
  var $2194=$2;
  var $2195=(($2194+4)|0);
  var $2196=HEAP32[(($2195)>>2)];
  var $2197=$2193 ^ $2196;
  var $2198=$2;
  var $2199=(($2198+28)|0);
  var $2200=HEAP32[(($2199)>>2)];
  var $2201=$2197 ^ $2200;
  var $2202=$2;
  var $2203=(($2202+48)|0);
  var $2204=HEAP32[(($2203)>>2)];
  var $2205=$2201 ^ $2204;
  var $2206=$2205 >>> 31;
  var $2207=$2190 | $2206;
  var $2208=$2;
  var $2209=(($2208+60)|0);
  HEAP32[(($2209)>>2)]=$2207;
  var $2210=(($2174+$2207)|0);
  var $2211=$C;
  var $2212=(($2211+$2210)|0);
  $C=$2212;
  var $2213=$E;
  var $2214=$2213 << 30;
  var $2215=$E;
  var $2216=$2215 >>> 2;
  var $2217=$2214 | $2216;
  $E=$2217;
  var $2218=$C;
  var $2219=$2218 << 5;
  var $2220=$C;
  var $2221=$2220 >>> 27;
  var $2222=$2219 | $2221;
  var $2223=$D;
  var $2224=$E;
  var $2225=$2223 & $2224;
  var $2226=$A;
  var $2227=$D;
  var $2228=$E;
  var $2229=$2227 | $2228;
  var $2230=$2226 & $2229;
  var $2231=$2225 | $2230;
  var $2232=(($2222+$2231)|0);
  var $2233=(($2232-1894007588)|0);
  var $2234=$2;
  var $2235=(($2234)|0);
  var $2236=HEAP32[(($2235)>>2)];
  var $2237=$2;
  var $2238=(($2237+8)|0);
  var $2239=HEAP32[(($2238)>>2)];
  var $2240=$2236 ^ $2239;
  var $2241=$2;
  var $2242=(($2241+32)|0);
  var $2243=HEAP32[(($2242)>>2)];
  var $2244=$2240 ^ $2243;
  var $2245=$2;
  var $2246=(($2245+52)|0);
  var $2247=HEAP32[(($2246)>>2)];
  var $2248=$2244 ^ $2247;
  var $2249=$2248 << 1;
  var $2250=$2;
  var $2251=(($2250)|0);
  var $2252=HEAP32[(($2251)>>2)];
  var $2253=$2;
  var $2254=(($2253+8)|0);
  var $2255=HEAP32[(($2254)>>2)];
  var $2256=$2252 ^ $2255;
  var $2257=$2;
  var $2258=(($2257+32)|0);
  var $2259=HEAP32[(($2258)>>2)];
  var $2260=$2256 ^ $2259;
  var $2261=$2;
  var $2262=(($2261+52)|0);
  var $2263=HEAP32[(($2262)>>2)];
  var $2264=$2260 ^ $2263;
  var $2265=$2264 >>> 31;
  var $2266=$2249 | $2265;
  var $2267=$2;
  var $2268=(($2267)|0);
  HEAP32[(($2268)>>2)]=$2266;
  var $2269=(($2233+$2266)|0);
  var $2270=$B;
  var $2271=(($2270+$2269)|0);
  $B=$2271;
  var $2272=$D;
  var $2273=$2272 << 30;
  var $2274=$D;
  var $2275=$2274 >>> 2;
  var $2276=$2273 | $2275;
  $D=$2276;
  var $2277=$B;
  var $2278=$2277 << 5;
  var $2279=$B;
  var $2280=$2279 >>> 27;
  var $2281=$2278 | $2280;
  var $2282=$C;
  var $2283=$D;
  var $2284=$2282 & $2283;
  var $2285=$E;
  var $2286=$C;
  var $2287=$D;
  var $2288=$2286 | $2287;
  var $2289=$2285 & $2288;
  var $2290=$2284 | $2289;
  var $2291=(($2281+$2290)|0);
  var $2292=(($2291-1894007588)|0);
  var $2293=$2;
  var $2294=(($2293+4)|0);
  var $2295=HEAP32[(($2294)>>2)];
  var $2296=$2;
  var $2297=(($2296+12)|0);
  var $2298=HEAP32[(($2297)>>2)];
  var $2299=$2295 ^ $2298;
  var $2300=$2;
  var $2301=(($2300+36)|0);
  var $2302=HEAP32[(($2301)>>2)];
  var $2303=$2299 ^ $2302;
  var $2304=$2;
  var $2305=(($2304+56)|0);
  var $2306=HEAP32[(($2305)>>2)];
  var $2307=$2303 ^ $2306;
  var $2308=$2307 << 1;
  var $2309=$2;
  var $2310=(($2309+4)|0);
  var $2311=HEAP32[(($2310)>>2)];
  var $2312=$2;
  var $2313=(($2312+12)|0);
  var $2314=HEAP32[(($2313)>>2)];
  var $2315=$2311 ^ $2314;
  var $2316=$2;
  var $2317=(($2316+36)|0);
  var $2318=HEAP32[(($2317)>>2)];
  var $2319=$2315 ^ $2318;
  var $2320=$2;
  var $2321=(($2320+56)|0);
  var $2322=HEAP32[(($2321)>>2)];
  var $2323=$2319 ^ $2322;
  var $2324=$2323 >>> 31;
  var $2325=$2308 | $2324;
  var $2326=$2;
  var $2327=(($2326+4)|0);
  HEAP32[(($2327)>>2)]=$2325;
  var $2328=(($2292+$2325)|0);
  var $2329=$A;
  var $2330=(($2329+$2328)|0);
  $A=$2330;
  var $2331=$C;
  var $2332=$2331 << 30;
  var $2333=$C;
  var $2334=$2333 >>> 2;
  var $2335=$2332 | $2334;
  $C=$2335;
  var $2336=$A;
  var $2337=$2336 << 5;
  var $2338=$A;
  var $2339=$2338 >>> 27;
  var $2340=$2337 | $2339;
  var $2341=$B;
  var $2342=$C;
  var $2343=$2341 & $2342;
  var $2344=$D;
  var $2345=$B;
  var $2346=$C;
  var $2347=$2345 | $2346;
  var $2348=$2344 & $2347;
  var $2349=$2343 | $2348;
  var $2350=(($2340+$2349)|0);
  var $2351=(($2350-1894007588)|0);
  var $2352=$2;
  var $2353=(($2352+8)|0);
  var $2354=HEAP32[(($2353)>>2)];
  var $2355=$2;
  var $2356=(($2355+16)|0);
  var $2357=HEAP32[(($2356)>>2)];
  var $2358=$2354 ^ $2357;
  var $2359=$2;
  var $2360=(($2359+40)|0);
  var $2361=HEAP32[(($2360)>>2)];
  var $2362=$2358 ^ $2361;
  var $2363=$2;
  var $2364=(($2363+60)|0);
  var $2365=HEAP32[(($2364)>>2)];
  var $2366=$2362 ^ $2365;
  var $2367=$2366 << 1;
  var $2368=$2;
  var $2369=(($2368+8)|0);
  var $2370=HEAP32[(($2369)>>2)];
  var $2371=$2;
  var $2372=(($2371+16)|0);
  var $2373=HEAP32[(($2372)>>2)];
  var $2374=$2370 ^ $2373;
  var $2375=$2;
  var $2376=(($2375+40)|0);
  var $2377=HEAP32[(($2376)>>2)];
  var $2378=$2374 ^ $2377;
  var $2379=$2;
  var $2380=(($2379+60)|0);
  var $2381=HEAP32[(($2380)>>2)];
  var $2382=$2378 ^ $2381;
  var $2383=$2382 >>> 31;
  var $2384=$2367 | $2383;
  var $2385=$2;
  var $2386=(($2385+8)|0);
  HEAP32[(($2386)>>2)]=$2384;
  var $2387=(($2351+$2384)|0);
  var $2388=$E;
  var $2389=(($2388+$2387)|0);
  $E=$2389;
  var $2390=$B;
  var $2391=$2390 << 30;
  var $2392=$B;
  var $2393=$2392 >>> 2;
  var $2394=$2391 | $2393;
  $B=$2394;
  var $2395=$E;
  var $2396=$2395 << 5;
  var $2397=$E;
  var $2398=$2397 >>> 27;
  var $2399=$2396 | $2398;
  var $2400=$A;
  var $2401=$B;
  var $2402=$2400 & $2401;
  var $2403=$C;
  var $2404=$A;
  var $2405=$B;
  var $2406=$2404 | $2405;
  var $2407=$2403 & $2406;
  var $2408=$2402 | $2407;
  var $2409=(($2399+$2408)|0);
  var $2410=(($2409-1894007588)|0);
  var $2411=$2;
  var $2412=(($2411+12)|0);
  var $2413=HEAP32[(($2412)>>2)];
  var $2414=$2;
  var $2415=(($2414+20)|0);
  var $2416=HEAP32[(($2415)>>2)];
  var $2417=$2413 ^ $2416;
  var $2418=$2;
  var $2419=(($2418+44)|0);
  var $2420=HEAP32[(($2419)>>2)];
  var $2421=$2417 ^ $2420;
  var $2422=$2;
  var $2423=(($2422)|0);
  var $2424=HEAP32[(($2423)>>2)];
  var $2425=$2421 ^ $2424;
  var $2426=$2425 << 1;
  var $2427=$2;
  var $2428=(($2427+12)|0);
  var $2429=HEAP32[(($2428)>>2)];
  var $2430=$2;
  var $2431=(($2430+20)|0);
  var $2432=HEAP32[(($2431)>>2)];
  var $2433=$2429 ^ $2432;
  var $2434=$2;
  var $2435=(($2434+44)|0);
  var $2436=HEAP32[(($2435)>>2)];
  var $2437=$2433 ^ $2436;
  var $2438=$2;
  var $2439=(($2438)|0);
  var $2440=HEAP32[(($2439)>>2)];
  var $2441=$2437 ^ $2440;
  var $2442=$2441 >>> 31;
  var $2443=$2426 | $2442;
  var $2444=$2;
  var $2445=(($2444+12)|0);
  HEAP32[(($2445)>>2)]=$2443;
  var $2446=(($2410+$2443)|0);
  var $2447=$D;
  var $2448=(($2447+$2446)|0);
  $D=$2448;
  var $2449=$A;
  var $2450=$2449 << 30;
  var $2451=$A;
  var $2452=$2451 >>> 2;
  var $2453=$2450 | $2452;
  $A=$2453;
  var $2454=$D;
  var $2455=$2454 << 5;
  var $2456=$D;
  var $2457=$2456 >>> 27;
  var $2458=$2455 | $2457;
  var $2459=$E;
  var $2460=$A;
  var $2461=$2459 & $2460;
  var $2462=$B;
  var $2463=$E;
  var $2464=$A;
  var $2465=$2463 | $2464;
  var $2466=$2462 & $2465;
  var $2467=$2461 | $2466;
  var $2468=(($2458+$2467)|0);
  var $2469=(($2468-1894007588)|0);
  var $2470=$2;
  var $2471=(($2470+16)|0);
  var $2472=HEAP32[(($2471)>>2)];
  var $2473=$2;
  var $2474=(($2473+24)|0);
  var $2475=HEAP32[(($2474)>>2)];
  var $2476=$2472 ^ $2475;
  var $2477=$2;
  var $2478=(($2477+48)|0);
  var $2479=HEAP32[(($2478)>>2)];
  var $2480=$2476 ^ $2479;
  var $2481=$2;
  var $2482=(($2481+4)|0);
  var $2483=HEAP32[(($2482)>>2)];
  var $2484=$2480 ^ $2483;
  var $2485=$2484 << 1;
  var $2486=$2;
  var $2487=(($2486+16)|0);
  var $2488=HEAP32[(($2487)>>2)];
  var $2489=$2;
  var $2490=(($2489+24)|0);
  var $2491=HEAP32[(($2490)>>2)];
  var $2492=$2488 ^ $2491;
  var $2493=$2;
  var $2494=(($2493+48)|0);
  var $2495=HEAP32[(($2494)>>2)];
  var $2496=$2492 ^ $2495;
  var $2497=$2;
  var $2498=(($2497+4)|0);
  var $2499=HEAP32[(($2498)>>2)];
  var $2500=$2496 ^ $2499;
  var $2501=$2500 >>> 31;
  var $2502=$2485 | $2501;
  var $2503=$2;
  var $2504=(($2503+16)|0);
  HEAP32[(($2504)>>2)]=$2502;
  var $2505=(($2469+$2502)|0);
  var $2506=$C;
  var $2507=(($2506+$2505)|0);
  $C=$2507;
  var $2508=$E;
  var $2509=$2508 << 30;
  var $2510=$E;
  var $2511=$2510 >>> 2;
  var $2512=$2509 | $2511;
  $E=$2512;
  var $2513=$C;
  var $2514=$2513 << 5;
  var $2515=$C;
  var $2516=$2515 >>> 27;
  var $2517=$2514 | $2516;
  var $2518=$D;
  var $2519=$E;
  var $2520=$2518 & $2519;
  var $2521=$A;
  var $2522=$D;
  var $2523=$E;
  var $2524=$2522 | $2523;
  var $2525=$2521 & $2524;
  var $2526=$2520 | $2525;
  var $2527=(($2517+$2526)|0);
  var $2528=(($2527-1894007588)|0);
  var $2529=$2;
  var $2530=(($2529+20)|0);
  var $2531=HEAP32[(($2530)>>2)];
  var $2532=$2;
  var $2533=(($2532+28)|0);
  var $2534=HEAP32[(($2533)>>2)];
  var $2535=$2531 ^ $2534;
  var $2536=$2;
  var $2537=(($2536+52)|0);
  var $2538=HEAP32[(($2537)>>2)];
  var $2539=$2535 ^ $2538;
  var $2540=$2;
  var $2541=(($2540+8)|0);
  var $2542=HEAP32[(($2541)>>2)];
  var $2543=$2539 ^ $2542;
  var $2544=$2543 << 1;
  var $2545=$2;
  var $2546=(($2545+20)|0);
  var $2547=HEAP32[(($2546)>>2)];
  var $2548=$2;
  var $2549=(($2548+28)|0);
  var $2550=HEAP32[(($2549)>>2)];
  var $2551=$2547 ^ $2550;
  var $2552=$2;
  var $2553=(($2552+52)|0);
  var $2554=HEAP32[(($2553)>>2)];
  var $2555=$2551 ^ $2554;
  var $2556=$2;
  var $2557=(($2556+8)|0);
  var $2558=HEAP32[(($2557)>>2)];
  var $2559=$2555 ^ $2558;
  var $2560=$2559 >>> 31;
  var $2561=$2544 | $2560;
  var $2562=$2;
  var $2563=(($2562+20)|0);
  HEAP32[(($2563)>>2)]=$2561;
  var $2564=(($2528+$2561)|0);
  var $2565=$B;
  var $2566=(($2565+$2564)|0);
  $B=$2566;
  var $2567=$D;
  var $2568=$2567 << 30;
  var $2569=$D;
  var $2570=$2569 >>> 2;
  var $2571=$2568 | $2570;
  $D=$2571;
  var $2572=$B;
  var $2573=$2572 << 5;
  var $2574=$B;
  var $2575=$2574 >>> 27;
  var $2576=$2573 | $2575;
  var $2577=$C;
  var $2578=$D;
  var $2579=$2577 & $2578;
  var $2580=$E;
  var $2581=$C;
  var $2582=$D;
  var $2583=$2581 | $2582;
  var $2584=$2580 & $2583;
  var $2585=$2579 | $2584;
  var $2586=(($2576+$2585)|0);
  var $2587=(($2586-1894007588)|0);
  var $2588=$2;
  var $2589=(($2588+24)|0);
  var $2590=HEAP32[(($2589)>>2)];
  var $2591=$2;
  var $2592=(($2591+32)|0);
  var $2593=HEAP32[(($2592)>>2)];
  var $2594=$2590 ^ $2593;
  var $2595=$2;
  var $2596=(($2595+56)|0);
  var $2597=HEAP32[(($2596)>>2)];
  var $2598=$2594 ^ $2597;
  var $2599=$2;
  var $2600=(($2599+12)|0);
  var $2601=HEAP32[(($2600)>>2)];
  var $2602=$2598 ^ $2601;
  var $2603=$2602 << 1;
  var $2604=$2;
  var $2605=(($2604+24)|0);
  var $2606=HEAP32[(($2605)>>2)];
  var $2607=$2;
  var $2608=(($2607+32)|0);
  var $2609=HEAP32[(($2608)>>2)];
  var $2610=$2606 ^ $2609;
  var $2611=$2;
  var $2612=(($2611+56)|0);
  var $2613=HEAP32[(($2612)>>2)];
  var $2614=$2610 ^ $2613;
  var $2615=$2;
  var $2616=(($2615+12)|0);
  var $2617=HEAP32[(($2616)>>2)];
  var $2618=$2614 ^ $2617;
  var $2619=$2618 >>> 31;
  var $2620=$2603 | $2619;
  var $2621=$2;
  var $2622=(($2621+24)|0);
  HEAP32[(($2622)>>2)]=$2620;
  var $2623=(($2587+$2620)|0);
  var $2624=$A;
  var $2625=(($2624+$2623)|0);
  $A=$2625;
  var $2626=$C;
  var $2627=$2626 << 30;
  var $2628=$C;
  var $2629=$2628 >>> 2;
  var $2630=$2627 | $2629;
  $C=$2630;
  var $2631=$A;
  var $2632=$2631 << 5;
  var $2633=$A;
  var $2634=$2633 >>> 27;
  var $2635=$2632 | $2634;
  var $2636=$B;
  var $2637=$C;
  var $2638=$2636 & $2637;
  var $2639=$D;
  var $2640=$B;
  var $2641=$C;
  var $2642=$2640 | $2641;
  var $2643=$2639 & $2642;
  var $2644=$2638 | $2643;
  var $2645=(($2635+$2644)|0);
  var $2646=(($2645-1894007588)|0);
  var $2647=$2;
  var $2648=(($2647+28)|0);
  var $2649=HEAP32[(($2648)>>2)];
  var $2650=$2;
  var $2651=(($2650+36)|0);
  var $2652=HEAP32[(($2651)>>2)];
  var $2653=$2649 ^ $2652;
  var $2654=$2;
  var $2655=(($2654+60)|0);
  var $2656=HEAP32[(($2655)>>2)];
  var $2657=$2653 ^ $2656;
  var $2658=$2;
  var $2659=(($2658+16)|0);
  var $2660=HEAP32[(($2659)>>2)];
  var $2661=$2657 ^ $2660;
  var $2662=$2661 << 1;
  var $2663=$2;
  var $2664=(($2663+28)|0);
  var $2665=HEAP32[(($2664)>>2)];
  var $2666=$2;
  var $2667=(($2666+36)|0);
  var $2668=HEAP32[(($2667)>>2)];
  var $2669=$2665 ^ $2668;
  var $2670=$2;
  var $2671=(($2670+60)|0);
  var $2672=HEAP32[(($2671)>>2)];
  var $2673=$2669 ^ $2672;
  var $2674=$2;
  var $2675=(($2674+16)|0);
  var $2676=HEAP32[(($2675)>>2)];
  var $2677=$2673 ^ $2676;
  var $2678=$2677 >>> 31;
  var $2679=$2662 | $2678;
  var $2680=$2;
  var $2681=(($2680+28)|0);
  HEAP32[(($2681)>>2)]=$2679;
  var $2682=(($2646+$2679)|0);
  var $2683=$E;
  var $2684=(($2683+$2682)|0);
  $E=$2684;
  var $2685=$B;
  var $2686=$2685 << 30;
  var $2687=$B;
  var $2688=$2687 >>> 2;
  var $2689=$2686 | $2688;
  $B=$2689;
  var $2690=$E;
  var $2691=$2690 << 5;
  var $2692=$E;
  var $2693=$2692 >>> 27;
  var $2694=$2691 | $2693;
  var $2695=$A;
  var $2696=$B;
  var $2697=$2695 & $2696;
  var $2698=$C;
  var $2699=$A;
  var $2700=$B;
  var $2701=$2699 | $2700;
  var $2702=$2698 & $2701;
  var $2703=$2697 | $2702;
  var $2704=(($2694+$2703)|0);
  var $2705=(($2704-1894007588)|0);
  var $2706=$2;
  var $2707=(($2706+32)|0);
  var $2708=HEAP32[(($2707)>>2)];
  var $2709=$2;
  var $2710=(($2709+40)|0);
  var $2711=HEAP32[(($2710)>>2)];
  var $2712=$2708 ^ $2711;
  var $2713=$2;
  var $2714=(($2713)|0);
  var $2715=HEAP32[(($2714)>>2)];
  var $2716=$2712 ^ $2715;
  var $2717=$2;
  var $2718=(($2717+20)|0);
  var $2719=HEAP32[(($2718)>>2)];
  var $2720=$2716 ^ $2719;
  var $2721=$2720 << 1;
  var $2722=$2;
  var $2723=(($2722+32)|0);
  var $2724=HEAP32[(($2723)>>2)];
  var $2725=$2;
  var $2726=(($2725+40)|0);
  var $2727=HEAP32[(($2726)>>2)];
  var $2728=$2724 ^ $2727;
  var $2729=$2;
  var $2730=(($2729)|0);
  var $2731=HEAP32[(($2730)>>2)];
  var $2732=$2728 ^ $2731;
  var $2733=$2;
  var $2734=(($2733+20)|0);
  var $2735=HEAP32[(($2734)>>2)];
  var $2736=$2732 ^ $2735;
  var $2737=$2736 >>> 31;
  var $2738=$2721 | $2737;
  var $2739=$2;
  var $2740=(($2739+32)|0);
  HEAP32[(($2740)>>2)]=$2738;
  var $2741=(($2705+$2738)|0);
  var $2742=$D;
  var $2743=(($2742+$2741)|0);
  $D=$2743;
  var $2744=$A;
  var $2745=$2744 << 30;
  var $2746=$A;
  var $2747=$2746 >>> 2;
  var $2748=$2745 | $2747;
  $A=$2748;
  var $2749=$D;
  var $2750=$2749 << 5;
  var $2751=$D;
  var $2752=$2751 >>> 27;
  var $2753=$2750 | $2752;
  var $2754=$E;
  var $2755=$A;
  var $2756=$2754 & $2755;
  var $2757=$B;
  var $2758=$E;
  var $2759=$A;
  var $2760=$2758 | $2759;
  var $2761=$2757 & $2760;
  var $2762=$2756 | $2761;
  var $2763=(($2753+$2762)|0);
  var $2764=(($2763-1894007588)|0);
  var $2765=$2;
  var $2766=(($2765+36)|0);
  var $2767=HEAP32[(($2766)>>2)];
  var $2768=$2;
  var $2769=(($2768+44)|0);
  var $2770=HEAP32[(($2769)>>2)];
  var $2771=$2767 ^ $2770;
  var $2772=$2;
  var $2773=(($2772+4)|0);
  var $2774=HEAP32[(($2773)>>2)];
  var $2775=$2771 ^ $2774;
  var $2776=$2;
  var $2777=(($2776+24)|0);
  var $2778=HEAP32[(($2777)>>2)];
  var $2779=$2775 ^ $2778;
  var $2780=$2779 << 1;
  var $2781=$2;
  var $2782=(($2781+36)|0);
  var $2783=HEAP32[(($2782)>>2)];
  var $2784=$2;
  var $2785=(($2784+44)|0);
  var $2786=HEAP32[(($2785)>>2)];
  var $2787=$2783 ^ $2786;
  var $2788=$2;
  var $2789=(($2788+4)|0);
  var $2790=HEAP32[(($2789)>>2)];
  var $2791=$2787 ^ $2790;
  var $2792=$2;
  var $2793=(($2792+24)|0);
  var $2794=HEAP32[(($2793)>>2)];
  var $2795=$2791 ^ $2794;
  var $2796=$2795 >>> 31;
  var $2797=$2780 | $2796;
  var $2798=$2;
  var $2799=(($2798+36)|0);
  HEAP32[(($2799)>>2)]=$2797;
  var $2800=(($2764+$2797)|0);
  var $2801=$C;
  var $2802=(($2801+$2800)|0);
  $C=$2802;
  var $2803=$E;
  var $2804=$2803 << 30;
  var $2805=$E;
  var $2806=$2805 >>> 2;
  var $2807=$2804 | $2806;
  $E=$2807;
  var $2808=$C;
  var $2809=$2808 << 5;
  var $2810=$C;
  var $2811=$2810 >>> 27;
  var $2812=$2809 | $2811;
  var $2813=$D;
  var $2814=$E;
  var $2815=$2813 & $2814;
  var $2816=$A;
  var $2817=$D;
  var $2818=$E;
  var $2819=$2817 | $2818;
  var $2820=$2816 & $2819;
  var $2821=$2815 | $2820;
  var $2822=(($2812+$2821)|0);
  var $2823=(($2822-1894007588)|0);
  var $2824=$2;
  var $2825=(($2824+40)|0);
  var $2826=HEAP32[(($2825)>>2)];
  var $2827=$2;
  var $2828=(($2827+48)|0);
  var $2829=HEAP32[(($2828)>>2)];
  var $2830=$2826 ^ $2829;
  var $2831=$2;
  var $2832=(($2831+8)|0);
  var $2833=HEAP32[(($2832)>>2)];
  var $2834=$2830 ^ $2833;
  var $2835=$2;
  var $2836=(($2835+28)|0);
  var $2837=HEAP32[(($2836)>>2)];
  var $2838=$2834 ^ $2837;
  var $2839=$2838 << 1;
  var $2840=$2;
  var $2841=(($2840+40)|0);
  var $2842=HEAP32[(($2841)>>2)];
  var $2843=$2;
  var $2844=(($2843+48)|0);
  var $2845=HEAP32[(($2844)>>2)];
  var $2846=$2842 ^ $2845;
  var $2847=$2;
  var $2848=(($2847+8)|0);
  var $2849=HEAP32[(($2848)>>2)];
  var $2850=$2846 ^ $2849;
  var $2851=$2;
  var $2852=(($2851+28)|0);
  var $2853=HEAP32[(($2852)>>2)];
  var $2854=$2850 ^ $2853;
  var $2855=$2854 >>> 31;
  var $2856=$2839 | $2855;
  var $2857=$2;
  var $2858=(($2857+40)|0);
  HEAP32[(($2858)>>2)]=$2856;
  var $2859=(($2823+$2856)|0);
  var $2860=$B;
  var $2861=(($2860+$2859)|0);
  $B=$2861;
  var $2862=$D;
  var $2863=$2862 << 30;
  var $2864=$D;
  var $2865=$2864 >>> 2;
  var $2866=$2863 | $2865;
  $D=$2866;
  var $2867=$B;
  var $2868=$2867 << 5;
  var $2869=$B;
  var $2870=$2869 >>> 27;
  var $2871=$2868 | $2870;
  var $2872=$C;
  var $2873=$D;
  var $2874=$2872 & $2873;
  var $2875=$E;
  var $2876=$C;
  var $2877=$D;
  var $2878=$2876 | $2877;
  var $2879=$2875 & $2878;
  var $2880=$2874 | $2879;
  var $2881=(($2871+$2880)|0);
  var $2882=(($2881-1894007588)|0);
  var $2883=$2;
  var $2884=(($2883+44)|0);
  var $2885=HEAP32[(($2884)>>2)];
  var $2886=$2;
  var $2887=(($2886+52)|0);
  var $2888=HEAP32[(($2887)>>2)];
  var $2889=$2885 ^ $2888;
  var $2890=$2;
  var $2891=(($2890+12)|0);
  var $2892=HEAP32[(($2891)>>2)];
  var $2893=$2889 ^ $2892;
  var $2894=$2;
  var $2895=(($2894+32)|0);
  var $2896=HEAP32[(($2895)>>2)];
  var $2897=$2893 ^ $2896;
  var $2898=$2897 << 1;
  var $2899=$2;
  var $2900=(($2899+44)|0);
  var $2901=HEAP32[(($2900)>>2)];
  var $2902=$2;
  var $2903=(($2902+52)|0);
  var $2904=HEAP32[(($2903)>>2)];
  var $2905=$2901 ^ $2904;
  var $2906=$2;
  var $2907=(($2906+12)|0);
  var $2908=HEAP32[(($2907)>>2)];
  var $2909=$2905 ^ $2908;
  var $2910=$2;
  var $2911=(($2910+32)|0);
  var $2912=HEAP32[(($2911)>>2)];
  var $2913=$2909 ^ $2912;
  var $2914=$2913 >>> 31;
  var $2915=$2898 | $2914;
  var $2916=$2;
  var $2917=(($2916+44)|0);
  HEAP32[(($2917)>>2)]=$2915;
  var $2918=(($2882+$2915)|0);
  var $2919=$A;
  var $2920=(($2919+$2918)|0);
  $A=$2920;
  var $2921=$C;
  var $2922=$2921 << 30;
  var $2923=$C;
  var $2924=$2923 >>> 2;
  var $2925=$2922 | $2924;
  $C=$2925;
  var $2926=$A;
  var $2927=$2926 << 5;
  var $2928=$A;
  var $2929=$2928 >>> 27;
  var $2930=$2927 | $2929;
  var $2931=$B;
  var $2932=$C;
  var $2933=$2931 ^ $2932;
  var $2934=$D;
  var $2935=$2933 ^ $2934;
  var $2936=(($2930+$2935)|0);
  var $2937=(($2936-899497514)|0);
  var $2938=$2;
  var $2939=(($2938+48)|0);
  var $2940=HEAP32[(($2939)>>2)];
  var $2941=$2;
  var $2942=(($2941+56)|0);
  var $2943=HEAP32[(($2942)>>2)];
  var $2944=$2940 ^ $2943;
  var $2945=$2;
  var $2946=(($2945+16)|0);
  var $2947=HEAP32[(($2946)>>2)];
  var $2948=$2944 ^ $2947;
  var $2949=$2;
  var $2950=(($2949+36)|0);
  var $2951=HEAP32[(($2950)>>2)];
  var $2952=$2948 ^ $2951;
  var $2953=$2952 << 1;
  var $2954=$2;
  var $2955=(($2954+48)|0);
  var $2956=HEAP32[(($2955)>>2)];
  var $2957=$2;
  var $2958=(($2957+56)|0);
  var $2959=HEAP32[(($2958)>>2)];
  var $2960=$2956 ^ $2959;
  var $2961=$2;
  var $2962=(($2961+16)|0);
  var $2963=HEAP32[(($2962)>>2)];
  var $2964=$2960 ^ $2963;
  var $2965=$2;
  var $2966=(($2965+36)|0);
  var $2967=HEAP32[(($2966)>>2)];
  var $2968=$2964 ^ $2967;
  var $2969=$2968 >>> 31;
  var $2970=$2953 | $2969;
  var $2971=$2;
  var $2972=(($2971+48)|0);
  HEAP32[(($2972)>>2)]=$2970;
  var $2973=(($2937+$2970)|0);
  var $2974=$E;
  var $2975=(($2974+$2973)|0);
  $E=$2975;
  var $2976=$B;
  var $2977=$2976 << 30;
  var $2978=$B;
  var $2979=$2978 >>> 2;
  var $2980=$2977 | $2979;
  $B=$2980;
  var $2981=$E;
  var $2982=$2981 << 5;
  var $2983=$E;
  var $2984=$2983 >>> 27;
  var $2985=$2982 | $2984;
  var $2986=$A;
  var $2987=$B;
  var $2988=$2986 ^ $2987;
  var $2989=$C;
  var $2990=$2988 ^ $2989;
  var $2991=(($2985+$2990)|0);
  var $2992=(($2991-899497514)|0);
  var $2993=$2;
  var $2994=(($2993+52)|0);
  var $2995=HEAP32[(($2994)>>2)];
  var $2996=$2;
  var $2997=(($2996+60)|0);
  var $2998=HEAP32[(($2997)>>2)];
  var $2999=$2995 ^ $2998;
  var $3000=$2;
  var $3001=(($3000+20)|0);
  var $3002=HEAP32[(($3001)>>2)];
  var $3003=$2999 ^ $3002;
  var $3004=$2;
  var $3005=(($3004+40)|0);
  var $3006=HEAP32[(($3005)>>2)];
  var $3007=$3003 ^ $3006;
  var $3008=$3007 << 1;
  var $3009=$2;
  var $3010=(($3009+52)|0);
  var $3011=HEAP32[(($3010)>>2)];
  var $3012=$2;
  var $3013=(($3012+60)|0);
  var $3014=HEAP32[(($3013)>>2)];
  var $3015=$3011 ^ $3014;
  var $3016=$2;
  var $3017=(($3016+20)|0);
  var $3018=HEAP32[(($3017)>>2)];
  var $3019=$3015 ^ $3018;
  var $3020=$2;
  var $3021=(($3020+40)|0);
  var $3022=HEAP32[(($3021)>>2)];
  var $3023=$3019 ^ $3022;
  var $3024=$3023 >>> 31;
  var $3025=$3008 | $3024;
  var $3026=$2;
  var $3027=(($3026+52)|0);
  HEAP32[(($3027)>>2)]=$3025;
  var $3028=(($2992+$3025)|0);
  var $3029=$D;
  var $3030=(($3029+$3028)|0);
  $D=$3030;
  var $3031=$A;
  var $3032=$3031 << 30;
  var $3033=$A;
  var $3034=$3033 >>> 2;
  var $3035=$3032 | $3034;
  $A=$3035;
  var $3036=$D;
  var $3037=$3036 << 5;
  var $3038=$D;
  var $3039=$3038 >>> 27;
  var $3040=$3037 | $3039;
  var $3041=$E;
  var $3042=$A;
  var $3043=$3041 ^ $3042;
  var $3044=$B;
  var $3045=$3043 ^ $3044;
  var $3046=(($3040+$3045)|0);
  var $3047=(($3046-899497514)|0);
  var $3048=$2;
  var $3049=(($3048+56)|0);
  var $3050=HEAP32[(($3049)>>2)];
  var $3051=$2;
  var $3052=(($3051)|0);
  var $3053=HEAP32[(($3052)>>2)];
  var $3054=$3050 ^ $3053;
  var $3055=$2;
  var $3056=(($3055+24)|0);
  var $3057=HEAP32[(($3056)>>2)];
  var $3058=$3054 ^ $3057;
  var $3059=$2;
  var $3060=(($3059+44)|0);
  var $3061=HEAP32[(($3060)>>2)];
  var $3062=$3058 ^ $3061;
  var $3063=$3062 << 1;
  var $3064=$2;
  var $3065=(($3064+56)|0);
  var $3066=HEAP32[(($3065)>>2)];
  var $3067=$2;
  var $3068=(($3067)|0);
  var $3069=HEAP32[(($3068)>>2)];
  var $3070=$3066 ^ $3069;
  var $3071=$2;
  var $3072=(($3071+24)|0);
  var $3073=HEAP32[(($3072)>>2)];
  var $3074=$3070 ^ $3073;
  var $3075=$2;
  var $3076=(($3075+44)|0);
  var $3077=HEAP32[(($3076)>>2)];
  var $3078=$3074 ^ $3077;
  var $3079=$3078 >>> 31;
  var $3080=$3063 | $3079;
  var $3081=$2;
  var $3082=(($3081+56)|0);
  HEAP32[(($3082)>>2)]=$3080;
  var $3083=(($3047+$3080)|0);
  var $3084=$C;
  var $3085=(($3084+$3083)|0);
  $C=$3085;
  var $3086=$E;
  var $3087=$3086 << 30;
  var $3088=$E;
  var $3089=$3088 >>> 2;
  var $3090=$3087 | $3089;
  $E=$3090;
  var $3091=$C;
  var $3092=$3091 << 5;
  var $3093=$C;
  var $3094=$3093 >>> 27;
  var $3095=$3092 | $3094;
  var $3096=$D;
  var $3097=$E;
  var $3098=$3096 ^ $3097;
  var $3099=$A;
  var $3100=$3098 ^ $3099;
  var $3101=(($3095+$3100)|0);
  var $3102=(($3101-899497514)|0);
  var $3103=$2;
  var $3104=(($3103+60)|0);
  var $3105=HEAP32[(($3104)>>2)];
  var $3106=$2;
  var $3107=(($3106+4)|0);
  var $3108=HEAP32[(($3107)>>2)];
  var $3109=$3105 ^ $3108;
  var $3110=$2;
  var $3111=(($3110+28)|0);
  var $3112=HEAP32[(($3111)>>2)];
  var $3113=$3109 ^ $3112;
  var $3114=$2;
  var $3115=(($3114+48)|0);
  var $3116=HEAP32[(($3115)>>2)];
  var $3117=$3113 ^ $3116;
  var $3118=$3117 << 1;
  var $3119=$2;
  var $3120=(($3119+60)|0);
  var $3121=HEAP32[(($3120)>>2)];
  var $3122=$2;
  var $3123=(($3122+4)|0);
  var $3124=HEAP32[(($3123)>>2)];
  var $3125=$3121 ^ $3124;
  var $3126=$2;
  var $3127=(($3126+28)|0);
  var $3128=HEAP32[(($3127)>>2)];
  var $3129=$3125 ^ $3128;
  var $3130=$2;
  var $3131=(($3130+48)|0);
  var $3132=HEAP32[(($3131)>>2)];
  var $3133=$3129 ^ $3132;
  var $3134=$3133 >>> 31;
  var $3135=$3118 | $3134;
  var $3136=$2;
  var $3137=(($3136+60)|0);
  HEAP32[(($3137)>>2)]=$3135;
  var $3138=(($3102+$3135)|0);
  var $3139=$B;
  var $3140=(($3139+$3138)|0);
  $B=$3140;
  var $3141=$D;
  var $3142=$3141 << 30;
  var $3143=$D;
  var $3144=$3143 >>> 2;
  var $3145=$3142 | $3144;
  $D=$3145;
  var $3146=$B;
  var $3147=$3146 << 5;
  var $3148=$B;
  var $3149=$3148 >>> 27;
  var $3150=$3147 | $3149;
  var $3151=$C;
  var $3152=$D;
  var $3153=$3151 ^ $3152;
  var $3154=$E;
  var $3155=$3153 ^ $3154;
  var $3156=(($3150+$3155)|0);
  var $3157=(($3156-899497514)|0);
  var $3158=$2;
  var $3159=(($3158)|0);
  var $3160=HEAP32[(($3159)>>2)];
  var $3161=$2;
  var $3162=(($3161+8)|0);
  var $3163=HEAP32[(($3162)>>2)];
  var $3164=$3160 ^ $3163;
  var $3165=$2;
  var $3166=(($3165+32)|0);
  var $3167=HEAP32[(($3166)>>2)];
  var $3168=$3164 ^ $3167;
  var $3169=$2;
  var $3170=(($3169+52)|0);
  var $3171=HEAP32[(($3170)>>2)];
  var $3172=$3168 ^ $3171;
  var $3173=$3172 << 1;
  var $3174=$2;
  var $3175=(($3174)|0);
  var $3176=HEAP32[(($3175)>>2)];
  var $3177=$2;
  var $3178=(($3177+8)|0);
  var $3179=HEAP32[(($3178)>>2)];
  var $3180=$3176 ^ $3179;
  var $3181=$2;
  var $3182=(($3181+32)|0);
  var $3183=HEAP32[(($3182)>>2)];
  var $3184=$3180 ^ $3183;
  var $3185=$2;
  var $3186=(($3185+52)|0);
  var $3187=HEAP32[(($3186)>>2)];
  var $3188=$3184 ^ $3187;
  var $3189=$3188 >>> 31;
  var $3190=$3173 | $3189;
  var $3191=$2;
  var $3192=(($3191)|0);
  HEAP32[(($3192)>>2)]=$3190;
  var $3193=(($3157+$3190)|0);
  var $3194=$A;
  var $3195=(($3194+$3193)|0);
  $A=$3195;
  var $3196=$C;
  var $3197=$3196 << 30;
  var $3198=$C;
  var $3199=$3198 >>> 2;
  var $3200=$3197 | $3199;
  $C=$3200;
  var $3201=$A;
  var $3202=$3201 << 5;
  var $3203=$A;
  var $3204=$3203 >>> 27;
  var $3205=$3202 | $3204;
  var $3206=$B;
  var $3207=$C;
  var $3208=$3206 ^ $3207;
  var $3209=$D;
  var $3210=$3208 ^ $3209;
  var $3211=(($3205+$3210)|0);
  var $3212=(($3211-899497514)|0);
  var $3213=$2;
  var $3214=(($3213+4)|0);
  var $3215=HEAP32[(($3214)>>2)];
  var $3216=$2;
  var $3217=(($3216+12)|0);
  var $3218=HEAP32[(($3217)>>2)];
  var $3219=$3215 ^ $3218;
  var $3220=$2;
  var $3221=(($3220+36)|0);
  var $3222=HEAP32[(($3221)>>2)];
  var $3223=$3219 ^ $3222;
  var $3224=$2;
  var $3225=(($3224+56)|0);
  var $3226=HEAP32[(($3225)>>2)];
  var $3227=$3223 ^ $3226;
  var $3228=$3227 << 1;
  var $3229=$2;
  var $3230=(($3229+4)|0);
  var $3231=HEAP32[(($3230)>>2)];
  var $3232=$2;
  var $3233=(($3232+12)|0);
  var $3234=HEAP32[(($3233)>>2)];
  var $3235=$3231 ^ $3234;
  var $3236=$2;
  var $3237=(($3236+36)|0);
  var $3238=HEAP32[(($3237)>>2)];
  var $3239=$3235 ^ $3238;
  var $3240=$2;
  var $3241=(($3240+56)|0);
  var $3242=HEAP32[(($3241)>>2)];
  var $3243=$3239 ^ $3242;
  var $3244=$3243 >>> 31;
  var $3245=$3228 | $3244;
  var $3246=$2;
  var $3247=(($3246+4)|0);
  HEAP32[(($3247)>>2)]=$3245;
  var $3248=(($3212+$3245)|0);
  var $3249=$E;
  var $3250=(($3249+$3248)|0);
  $E=$3250;
  var $3251=$B;
  var $3252=$3251 << 30;
  var $3253=$B;
  var $3254=$3253 >>> 2;
  var $3255=$3252 | $3254;
  $B=$3255;
  var $3256=$E;
  var $3257=$3256 << 5;
  var $3258=$E;
  var $3259=$3258 >>> 27;
  var $3260=$3257 | $3259;
  var $3261=$A;
  var $3262=$B;
  var $3263=$3261 ^ $3262;
  var $3264=$C;
  var $3265=$3263 ^ $3264;
  var $3266=(($3260+$3265)|0);
  var $3267=(($3266-899497514)|0);
  var $3268=$2;
  var $3269=(($3268+8)|0);
  var $3270=HEAP32[(($3269)>>2)];
  var $3271=$2;
  var $3272=(($3271+16)|0);
  var $3273=HEAP32[(($3272)>>2)];
  var $3274=$3270 ^ $3273;
  var $3275=$2;
  var $3276=(($3275+40)|0);
  var $3277=HEAP32[(($3276)>>2)];
  var $3278=$3274 ^ $3277;
  var $3279=$2;
  var $3280=(($3279+60)|0);
  var $3281=HEAP32[(($3280)>>2)];
  var $3282=$3278 ^ $3281;
  var $3283=$3282 << 1;
  var $3284=$2;
  var $3285=(($3284+8)|0);
  var $3286=HEAP32[(($3285)>>2)];
  var $3287=$2;
  var $3288=(($3287+16)|0);
  var $3289=HEAP32[(($3288)>>2)];
  var $3290=$3286 ^ $3289;
  var $3291=$2;
  var $3292=(($3291+40)|0);
  var $3293=HEAP32[(($3292)>>2)];
  var $3294=$3290 ^ $3293;
  var $3295=$2;
  var $3296=(($3295+60)|0);
  var $3297=HEAP32[(($3296)>>2)];
  var $3298=$3294 ^ $3297;
  var $3299=$3298 >>> 31;
  var $3300=$3283 | $3299;
  var $3301=$2;
  var $3302=(($3301+8)|0);
  HEAP32[(($3302)>>2)]=$3300;
  var $3303=(($3267+$3300)|0);
  var $3304=$D;
  var $3305=(($3304+$3303)|0);
  $D=$3305;
  var $3306=$A;
  var $3307=$3306 << 30;
  var $3308=$A;
  var $3309=$3308 >>> 2;
  var $3310=$3307 | $3309;
  $A=$3310;
  var $3311=$D;
  var $3312=$3311 << 5;
  var $3313=$D;
  var $3314=$3313 >>> 27;
  var $3315=$3312 | $3314;
  var $3316=$E;
  var $3317=$A;
  var $3318=$3316 ^ $3317;
  var $3319=$B;
  var $3320=$3318 ^ $3319;
  var $3321=(($3315+$3320)|0);
  var $3322=(($3321-899497514)|0);
  var $3323=$2;
  var $3324=(($3323+12)|0);
  var $3325=HEAP32[(($3324)>>2)];
  var $3326=$2;
  var $3327=(($3326+20)|0);
  var $3328=HEAP32[(($3327)>>2)];
  var $3329=$3325 ^ $3328;
  var $3330=$2;
  var $3331=(($3330+44)|0);
  var $3332=HEAP32[(($3331)>>2)];
  var $3333=$3329 ^ $3332;
  var $3334=$2;
  var $3335=(($3334)|0);
  var $3336=HEAP32[(($3335)>>2)];
  var $3337=$3333 ^ $3336;
  var $3338=$3337 << 1;
  var $3339=$2;
  var $3340=(($3339+12)|0);
  var $3341=HEAP32[(($3340)>>2)];
  var $3342=$2;
  var $3343=(($3342+20)|0);
  var $3344=HEAP32[(($3343)>>2)];
  var $3345=$3341 ^ $3344;
  var $3346=$2;
  var $3347=(($3346+44)|0);
  var $3348=HEAP32[(($3347)>>2)];
  var $3349=$3345 ^ $3348;
  var $3350=$2;
  var $3351=(($3350)|0);
  var $3352=HEAP32[(($3351)>>2)];
  var $3353=$3349 ^ $3352;
  var $3354=$3353 >>> 31;
  var $3355=$3338 | $3354;
  var $3356=$2;
  var $3357=(($3356+12)|0);
  HEAP32[(($3357)>>2)]=$3355;
  var $3358=(($3322+$3355)|0);
  var $3359=$C;
  var $3360=(($3359+$3358)|0);
  $C=$3360;
  var $3361=$E;
  var $3362=$3361 << 30;
  var $3363=$E;
  var $3364=$3363 >>> 2;
  var $3365=$3362 | $3364;
  $E=$3365;
  var $3366=$C;
  var $3367=$3366 << 5;
  var $3368=$C;
  var $3369=$3368 >>> 27;
  var $3370=$3367 | $3369;
  var $3371=$D;
  var $3372=$E;
  var $3373=$3371 ^ $3372;
  var $3374=$A;
  var $3375=$3373 ^ $3374;
  var $3376=(($3370+$3375)|0);
  var $3377=(($3376-899497514)|0);
  var $3378=$2;
  var $3379=(($3378+16)|0);
  var $3380=HEAP32[(($3379)>>2)];
  var $3381=$2;
  var $3382=(($3381+24)|0);
  var $3383=HEAP32[(($3382)>>2)];
  var $3384=$3380 ^ $3383;
  var $3385=$2;
  var $3386=(($3385+48)|0);
  var $3387=HEAP32[(($3386)>>2)];
  var $3388=$3384 ^ $3387;
  var $3389=$2;
  var $3390=(($3389+4)|0);
  var $3391=HEAP32[(($3390)>>2)];
  var $3392=$3388 ^ $3391;
  var $3393=$3392 << 1;
  var $3394=$2;
  var $3395=(($3394+16)|0);
  var $3396=HEAP32[(($3395)>>2)];
  var $3397=$2;
  var $3398=(($3397+24)|0);
  var $3399=HEAP32[(($3398)>>2)];
  var $3400=$3396 ^ $3399;
  var $3401=$2;
  var $3402=(($3401+48)|0);
  var $3403=HEAP32[(($3402)>>2)];
  var $3404=$3400 ^ $3403;
  var $3405=$2;
  var $3406=(($3405+4)|0);
  var $3407=HEAP32[(($3406)>>2)];
  var $3408=$3404 ^ $3407;
  var $3409=$3408 >>> 31;
  var $3410=$3393 | $3409;
  var $3411=$2;
  var $3412=(($3411+16)|0);
  HEAP32[(($3412)>>2)]=$3410;
  var $3413=(($3377+$3410)|0);
  var $3414=$B;
  var $3415=(($3414+$3413)|0);
  $B=$3415;
  var $3416=$D;
  var $3417=$3416 << 30;
  var $3418=$D;
  var $3419=$3418 >>> 2;
  var $3420=$3417 | $3419;
  $D=$3420;
  var $3421=$B;
  var $3422=$3421 << 5;
  var $3423=$B;
  var $3424=$3423 >>> 27;
  var $3425=$3422 | $3424;
  var $3426=$C;
  var $3427=$D;
  var $3428=$3426 ^ $3427;
  var $3429=$E;
  var $3430=$3428 ^ $3429;
  var $3431=(($3425+$3430)|0);
  var $3432=(($3431-899497514)|0);
  var $3433=$2;
  var $3434=(($3433+20)|0);
  var $3435=HEAP32[(($3434)>>2)];
  var $3436=$2;
  var $3437=(($3436+28)|0);
  var $3438=HEAP32[(($3437)>>2)];
  var $3439=$3435 ^ $3438;
  var $3440=$2;
  var $3441=(($3440+52)|0);
  var $3442=HEAP32[(($3441)>>2)];
  var $3443=$3439 ^ $3442;
  var $3444=$2;
  var $3445=(($3444+8)|0);
  var $3446=HEAP32[(($3445)>>2)];
  var $3447=$3443 ^ $3446;
  var $3448=$3447 << 1;
  var $3449=$2;
  var $3450=(($3449+20)|0);
  var $3451=HEAP32[(($3450)>>2)];
  var $3452=$2;
  var $3453=(($3452+28)|0);
  var $3454=HEAP32[(($3453)>>2)];
  var $3455=$3451 ^ $3454;
  var $3456=$2;
  var $3457=(($3456+52)|0);
  var $3458=HEAP32[(($3457)>>2)];
  var $3459=$3455 ^ $3458;
  var $3460=$2;
  var $3461=(($3460+8)|0);
  var $3462=HEAP32[(($3461)>>2)];
  var $3463=$3459 ^ $3462;
  var $3464=$3463 >>> 31;
  var $3465=$3448 | $3464;
  var $3466=$2;
  var $3467=(($3466+20)|0);
  HEAP32[(($3467)>>2)]=$3465;
  var $3468=(($3432+$3465)|0);
  var $3469=$A;
  var $3470=(($3469+$3468)|0);
  $A=$3470;
  var $3471=$C;
  var $3472=$3471 << 30;
  var $3473=$C;
  var $3474=$3473 >>> 2;
  var $3475=$3472 | $3474;
  $C=$3475;
  var $3476=$A;
  var $3477=$3476 << 5;
  var $3478=$A;
  var $3479=$3478 >>> 27;
  var $3480=$3477 | $3479;
  var $3481=$B;
  var $3482=$C;
  var $3483=$3481 ^ $3482;
  var $3484=$D;
  var $3485=$3483 ^ $3484;
  var $3486=(($3480+$3485)|0);
  var $3487=(($3486-899497514)|0);
  var $3488=$2;
  var $3489=(($3488+24)|0);
  var $3490=HEAP32[(($3489)>>2)];
  var $3491=$2;
  var $3492=(($3491+32)|0);
  var $3493=HEAP32[(($3492)>>2)];
  var $3494=$3490 ^ $3493;
  var $3495=$2;
  var $3496=(($3495+56)|0);
  var $3497=HEAP32[(($3496)>>2)];
  var $3498=$3494 ^ $3497;
  var $3499=$2;
  var $3500=(($3499+12)|0);
  var $3501=HEAP32[(($3500)>>2)];
  var $3502=$3498 ^ $3501;
  var $3503=$3502 << 1;
  var $3504=$2;
  var $3505=(($3504+24)|0);
  var $3506=HEAP32[(($3505)>>2)];
  var $3507=$2;
  var $3508=(($3507+32)|0);
  var $3509=HEAP32[(($3508)>>2)];
  var $3510=$3506 ^ $3509;
  var $3511=$2;
  var $3512=(($3511+56)|0);
  var $3513=HEAP32[(($3512)>>2)];
  var $3514=$3510 ^ $3513;
  var $3515=$2;
  var $3516=(($3515+12)|0);
  var $3517=HEAP32[(($3516)>>2)];
  var $3518=$3514 ^ $3517;
  var $3519=$3518 >>> 31;
  var $3520=$3503 | $3519;
  var $3521=$2;
  var $3522=(($3521+24)|0);
  HEAP32[(($3522)>>2)]=$3520;
  var $3523=(($3487+$3520)|0);
  var $3524=$E;
  var $3525=(($3524+$3523)|0);
  $E=$3525;
  var $3526=$B;
  var $3527=$3526 << 30;
  var $3528=$B;
  var $3529=$3528 >>> 2;
  var $3530=$3527 | $3529;
  $B=$3530;
  var $3531=$E;
  var $3532=$3531 << 5;
  var $3533=$E;
  var $3534=$3533 >>> 27;
  var $3535=$3532 | $3534;
  var $3536=$A;
  var $3537=$B;
  var $3538=$3536 ^ $3537;
  var $3539=$C;
  var $3540=$3538 ^ $3539;
  var $3541=(($3535+$3540)|0);
  var $3542=(($3541-899497514)|0);
  var $3543=$2;
  var $3544=(($3543+28)|0);
  var $3545=HEAP32[(($3544)>>2)];
  var $3546=$2;
  var $3547=(($3546+36)|0);
  var $3548=HEAP32[(($3547)>>2)];
  var $3549=$3545 ^ $3548;
  var $3550=$2;
  var $3551=(($3550+60)|0);
  var $3552=HEAP32[(($3551)>>2)];
  var $3553=$3549 ^ $3552;
  var $3554=$2;
  var $3555=(($3554+16)|0);
  var $3556=HEAP32[(($3555)>>2)];
  var $3557=$3553 ^ $3556;
  var $3558=$3557 << 1;
  var $3559=$2;
  var $3560=(($3559+28)|0);
  var $3561=HEAP32[(($3560)>>2)];
  var $3562=$2;
  var $3563=(($3562+36)|0);
  var $3564=HEAP32[(($3563)>>2)];
  var $3565=$3561 ^ $3564;
  var $3566=$2;
  var $3567=(($3566+60)|0);
  var $3568=HEAP32[(($3567)>>2)];
  var $3569=$3565 ^ $3568;
  var $3570=$2;
  var $3571=(($3570+16)|0);
  var $3572=HEAP32[(($3571)>>2)];
  var $3573=$3569 ^ $3572;
  var $3574=$3573 >>> 31;
  var $3575=$3558 | $3574;
  var $3576=$2;
  var $3577=(($3576+28)|0);
  HEAP32[(($3577)>>2)]=$3575;
  var $3578=(($3542+$3575)|0);
  var $3579=$D;
  var $3580=(($3579+$3578)|0);
  $D=$3580;
  var $3581=$A;
  var $3582=$3581 << 30;
  var $3583=$A;
  var $3584=$3583 >>> 2;
  var $3585=$3582 | $3584;
  $A=$3585;
  var $3586=$D;
  var $3587=$3586 << 5;
  var $3588=$D;
  var $3589=$3588 >>> 27;
  var $3590=$3587 | $3589;
  var $3591=$E;
  var $3592=$A;
  var $3593=$3591 ^ $3592;
  var $3594=$B;
  var $3595=$3593 ^ $3594;
  var $3596=(($3590+$3595)|0);
  var $3597=(($3596-899497514)|0);
  var $3598=$2;
  var $3599=(($3598+32)|0);
  var $3600=HEAP32[(($3599)>>2)];
  var $3601=$2;
  var $3602=(($3601+40)|0);
  var $3603=HEAP32[(($3602)>>2)];
  var $3604=$3600 ^ $3603;
  var $3605=$2;
  var $3606=(($3605)|0);
  var $3607=HEAP32[(($3606)>>2)];
  var $3608=$3604 ^ $3607;
  var $3609=$2;
  var $3610=(($3609+20)|0);
  var $3611=HEAP32[(($3610)>>2)];
  var $3612=$3608 ^ $3611;
  var $3613=$3612 << 1;
  var $3614=$2;
  var $3615=(($3614+32)|0);
  var $3616=HEAP32[(($3615)>>2)];
  var $3617=$2;
  var $3618=(($3617+40)|0);
  var $3619=HEAP32[(($3618)>>2)];
  var $3620=$3616 ^ $3619;
  var $3621=$2;
  var $3622=(($3621)|0);
  var $3623=HEAP32[(($3622)>>2)];
  var $3624=$3620 ^ $3623;
  var $3625=$2;
  var $3626=(($3625+20)|0);
  var $3627=HEAP32[(($3626)>>2)];
  var $3628=$3624 ^ $3627;
  var $3629=$3628 >>> 31;
  var $3630=$3613 | $3629;
  var $3631=$2;
  var $3632=(($3631+32)|0);
  HEAP32[(($3632)>>2)]=$3630;
  var $3633=(($3597+$3630)|0);
  var $3634=$C;
  var $3635=(($3634+$3633)|0);
  $C=$3635;
  var $3636=$E;
  var $3637=$3636 << 30;
  var $3638=$E;
  var $3639=$3638 >>> 2;
  var $3640=$3637 | $3639;
  $E=$3640;
  var $3641=$C;
  var $3642=$3641 << 5;
  var $3643=$C;
  var $3644=$3643 >>> 27;
  var $3645=$3642 | $3644;
  var $3646=$D;
  var $3647=$E;
  var $3648=$3646 ^ $3647;
  var $3649=$A;
  var $3650=$3648 ^ $3649;
  var $3651=(($3645+$3650)|0);
  var $3652=(($3651-899497514)|0);
  var $3653=$2;
  var $3654=(($3653+36)|0);
  var $3655=HEAP32[(($3654)>>2)];
  var $3656=$2;
  var $3657=(($3656+44)|0);
  var $3658=HEAP32[(($3657)>>2)];
  var $3659=$3655 ^ $3658;
  var $3660=$2;
  var $3661=(($3660+4)|0);
  var $3662=HEAP32[(($3661)>>2)];
  var $3663=$3659 ^ $3662;
  var $3664=$2;
  var $3665=(($3664+24)|0);
  var $3666=HEAP32[(($3665)>>2)];
  var $3667=$3663 ^ $3666;
  var $3668=$3667 << 1;
  var $3669=$2;
  var $3670=(($3669+36)|0);
  var $3671=HEAP32[(($3670)>>2)];
  var $3672=$2;
  var $3673=(($3672+44)|0);
  var $3674=HEAP32[(($3673)>>2)];
  var $3675=$3671 ^ $3674;
  var $3676=$2;
  var $3677=(($3676+4)|0);
  var $3678=HEAP32[(($3677)>>2)];
  var $3679=$3675 ^ $3678;
  var $3680=$2;
  var $3681=(($3680+24)|0);
  var $3682=HEAP32[(($3681)>>2)];
  var $3683=$3679 ^ $3682;
  var $3684=$3683 >>> 31;
  var $3685=$3668 | $3684;
  var $3686=$2;
  var $3687=(($3686+36)|0);
  HEAP32[(($3687)>>2)]=$3685;
  var $3688=(($3652+$3685)|0);
  var $3689=$B;
  var $3690=(($3689+$3688)|0);
  $B=$3690;
  var $3691=$D;
  var $3692=$3691 << 30;
  var $3693=$D;
  var $3694=$3693 >>> 2;
  var $3695=$3692 | $3694;
  $D=$3695;
  var $3696=$B;
  var $3697=$3696 << 5;
  var $3698=$B;
  var $3699=$3698 >>> 27;
  var $3700=$3697 | $3699;
  var $3701=$C;
  var $3702=$D;
  var $3703=$3701 ^ $3702;
  var $3704=$E;
  var $3705=$3703 ^ $3704;
  var $3706=(($3700+$3705)|0);
  var $3707=(($3706-899497514)|0);
  var $3708=$2;
  var $3709=(($3708+40)|0);
  var $3710=HEAP32[(($3709)>>2)];
  var $3711=$2;
  var $3712=(($3711+48)|0);
  var $3713=HEAP32[(($3712)>>2)];
  var $3714=$3710 ^ $3713;
  var $3715=$2;
  var $3716=(($3715+8)|0);
  var $3717=HEAP32[(($3716)>>2)];
  var $3718=$3714 ^ $3717;
  var $3719=$2;
  var $3720=(($3719+28)|0);
  var $3721=HEAP32[(($3720)>>2)];
  var $3722=$3718 ^ $3721;
  var $3723=$3722 << 1;
  var $3724=$2;
  var $3725=(($3724+40)|0);
  var $3726=HEAP32[(($3725)>>2)];
  var $3727=$2;
  var $3728=(($3727+48)|0);
  var $3729=HEAP32[(($3728)>>2)];
  var $3730=$3726 ^ $3729;
  var $3731=$2;
  var $3732=(($3731+8)|0);
  var $3733=HEAP32[(($3732)>>2)];
  var $3734=$3730 ^ $3733;
  var $3735=$2;
  var $3736=(($3735+28)|0);
  var $3737=HEAP32[(($3736)>>2)];
  var $3738=$3734 ^ $3737;
  var $3739=$3738 >>> 31;
  var $3740=$3723 | $3739;
  var $3741=$2;
  var $3742=(($3741+40)|0);
  HEAP32[(($3742)>>2)]=$3740;
  var $3743=(($3707+$3740)|0);
  var $3744=$A;
  var $3745=(($3744+$3743)|0);
  $A=$3745;
  var $3746=$C;
  var $3747=$3746 << 30;
  var $3748=$C;
  var $3749=$3748 >>> 2;
  var $3750=$3747 | $3749;
  $C=$3750;
  var $3751=$A;
  var $3752=$3751 << 5;
  var $3753=$A;
  var $3754=$3753 >>> 27;
  var $3755=$3752 | $3754;
  var $3756=$B;
  var $3757=$C;
  var $3758=$3756 ^ $3757;
  var $3759=$D;
  var $3760=$3758 ^ $3759;
  var $3761=(($3755+$3760)|0);
  var $3762=(($3761-899497514)|0);
  var $3763=$2;
  var $3764=(($3763+44)|0);
  var $3765=HEAP32[(($3764)>>2)];
  var $3766=$2;
  var $3767=(($3766+52)|0);
  var $3768=HEAP32[(($3767)>>2)];
  var $3769=$3765 ^ $3768;
  var $3770=$2;
  var $3771=(($3770+12)|0);
  var $3772=HEAP32[(($3771)>>2)];
  var $3773=$3769 ^ $3772;
  var $3774=$2;
  var $3775=(($3774+32)|0);
  var $3776=HEAP32[(($3775)>>2)];
  var $3777=$3773 ^ $3776;
  var $3778=$3777 << 1;
  var $3779=$2;
  var $3780=(($3779+44)|0);
  var $3781=HEAP32[(($3780)>>2)];
  var $3782=$2;
  var $3783=(($3782+52)|0);
  var $3784=HEAP32[(($3783)>>2)];
  var $3785=$3781 ^ $3784;
  var $3786=$2;
  var $3787=(($3786+12)|0);
  var $3788=HEAP32[(($3787)>>2)];
  var $3789=$3785 ^ $3788;
  var $3790=$2;
  var $3791=(($3790+32)|0);
  var $3792=HEAP32[(($3791)>>2)];
  var $3793=$3789 ^ $3792;
  var $3794=$3793 >>> 31;
  var $3795=$3778 | $3794;
  var $3796=$2;
  var $3797=(($3796+44)|0);
  HEAP32[(($3797)>>2)]=$3795;
  var $3798=(($3762+$3795)|0);
  var $3799=$E;
  var $3800=(($3799+$3798)|0);
  $E=$3800;
  var $3801=$B;
  var $3802=$3801 << 30;
  var $3803=$B;
  var $3804=$3803 >>> 2;
  var $3805=$3802 | $3804;
  $B=$3805;
  var $3806=$E;
  var $3807=$3806 << 5;
  var $3808=$E;
  var $3809=$3808 >>> 27;
  var $3810=$3807 | $3809;
  var $3811=$A;
  var $3812=$B;
  var $3813=$3811 ^ $3812;
  var $3814=$C;
  var $3815=$3813 ^ $3814;
  var $3816=(($3810+$3815)|0);
  var $3817=(($3816-899497514)|0);
  var $3818=$2;
  var $3819=(($3818+48)|0);
  var $3820=HEAP32[(($3819)>>2)];
  var $3821=$2;
  var $3822=(($3821+56)|0);
  var $3823=HEAP32[(($3822)>>2)];
  var $3824=$3820 ^ $3823;
  var $3825=$2;
  var $3826=(($3825+16)|0);
  var $3827=HEAP32[(($3826)>>2)];
  var $3828=$3824 ^ $3827;
  var $3829=$2;
  var $3830=(($3829+36)|0);
  var $3831=HEAP32[(($3830)>>2)];
  var $3832=$3828 ^ $3831;
  var $3833=$3832 << 1;
  var $3834=$2;
  var $3835=(($3834+48)|0);
  var $3836=HEAP32[(($3835)>>2)];
  var $3837=$2;
  var $3838=(($3837+56)|0);
  var $3839=HEAP32[(($3838)>>2)];
  var $3840=$3836 ^ $3839;
  var $3841=$2;
  var $3842=(($3841+16)|0);
  var $3843=HEAP32[(($3842)>>2)];
  var $3844=$3840 ^ $3843;
  var $3845=$2;
  var $3846=(($3845+36)|0);
  var $3847=HEAP32[(($3846)>>2)];
  var $3848=$3844 ^ $3847;
  var $3849=$3848 >>> 31;
  var $3850=$3833 | $3849;
  var $3851=$2;
  var $3852=(($3851+48)|0);
  HEAP32[(($3852)>>2)]=$3850;
  var $3853=(($3817+$3850)|0);
  var $3854=$D;
  var $3855=(($3854+$3853)|0);
  $D=$3855;
  var $3856=$A;
  var $3857=$3856 << 30;
  var $3858=$A;
  var $3859=$3858 >>> 2;
  var $3860=$3857 | $3859;
  $A=$3860;
  var $3861=$D;
  var $3862=$3861 << 5;
  var $3863=$D;
  var $3864=$3863 >>> 27;
  var $3865=$3862 | $3864;
  var $3866=$E;
  var $3867=$A;
  var $3868=$3866 ^ $3867;
  var $3869=$B;
  var $3870=$3868 ^ $3869;
  var $3871=(($3865+$3870)|0);
  var $3872=(($3871-899497514)|0);
  var $3873=$2;
  var $3874=(($3873+52)|0);
  var $3875=HEAP32[(($3874)>>2)];
  var $3876=$2;
  var $3877=(($3876+60)|0);
  var $3878=HEAP32[(($3877)>>2)];
  var $3879=$3875 ^ $3878;
  var $3880=$2;
  var $3881=(($3880+20)|0);
  var $3882=HEAP32[(($3881)>>2)];
  var $3883=$3879 ^ $3882;
  var $3884=$2;
  var $3885=(($3884+40)|0);
  var $3886=HEAP32[(($3885)>>2)];
  var $3887=$3883 ^ $3886;
  var $3888=$3887 << 1;
  var $3889=$2;
  var $3890=(($3889+52)|0);
  var $3891=HEAP32[(($3890)>>2)];
  var $3892=$2;
  var $3893=(($3892+60)|0);
  var $3894=HEAP32[(($3893)>>2)];
  var $3895=$3891 ^ $3894;
  var $3896=$2;
  var $3897=(($3896+20)|0);
  var $3898=HEAP32[(($3897)>>2)];
  var $3899=$3895 ^ $3898;
  var $3900=$2;
  var $3901=(($3900+40)|0);
  var $3902=HEAP32[(($3901)>>2)];
  var $3903=$3899 ^ $3902;
  var $3904=$3903 >>> 31;
  var $3905=$3888 | $3904;
  var $3906=$2;
  var $3907=(($3906+52)|0);
  HEAP32[(($3907)>>2)]=$3905;
  var $3908=(($3872+$3905)|0);
  var $3909=$C;
  var $3910=(($3909+$3908)|0);
  $C=$3910;
  var $3911=$E;
  var $3912=$3911 << 30;
  var $3913=$E;
  var $3914=$3913 >>> 2;
  var $3915=$3912 | $3914;
  $E=$3915;
  var $3916=$C;
  var $3917=$3916 << 5;
  var $3918=$C;
  var $3919=$3918 >>> 27;
  var $3920=$3917 | $3919;
  var $3921=$D;
  var $3922=$E;
  var $3923=$3921 ^ $3922;
  var $3924=$A;
  var $3925=$3923 ^ $3924;
  var $3926=(($3920+$3925)|0);
  var $3927=(($3926-899497514)|0);
  var $3928=$2;
  var $3929=(($3928+56)|0);
  var $3930=HEAP32[(($3929)>>2)];
  var $3931=$2;
  var $3932=(($3931)|0);
  var $3933=HEAP32[(($3932)>>2)];
  var $3934=$3930 ^ $3933;
  var $3935=$2;
  var $3936=(($3935+24)|0);
  var $3937=HEAP32[(($3936)>>2)];
  var $3938=$3934 ^ $3937;
  var $3939=$2;
  var $3940=(($3939+44)|0);
  var $3941=HEAP32[(($3940)>>2)];
  var $3942=$3938 ^ $3941;
  var $3943=$3942 << 1;
  var $3944=$2;
  var $3945=(($3944+56)|0);
  var $3946=HEAP32[(($3945)>>2)];
  var $3947=$2;
  var $3948=(($3947)|0);
  var $3949=HEAP32[(($3948)>>2)];
  var $3950=$3946 ^ $3949;
  var $3951=$2;
  var $3952=(($3951+24)|0);
  var $3953=HEAP32[(($3952)>>2)];
  var $3954=$3950 ^ $3953;
  var $3955=$2;
  var $3956=(($3955+44)|0);
  var $3957=HEAP32[(($3956)>>2)];
  var $3958=$3954 ^ $3957;
  var $3959=$3958 >>> 31;
  var $3960=$3943 | $3959;
  var $3961=$2;
  var $3962=(($3961+56)|0);
  HEAP32[(($3962)>>2)]=$3960;
  var $3963=(($3927+$3960)|0);
  var $3964=$B;
  var $3965=(($3964+$3963)|0);
  $B=$3965;
  var $3966=$D;
  var $3967=$3966 << 30;
  var $3968=$D;
  var $3969=$3968 >>> 2;
  var $3970=$3967 | $3969;
  $D=$3970;
  var $3971=$B;
  var $3972=$3971 << 5;
  var $3973=$B;
  var $3974=$3973 >>> 27;
  var $3975=$3972 | $3974;
  var $3976=$C;
  var $3977=$D;
  var $3978=$3976 ^ $3977;
  var $3979=$E;
  var $3980=$3978 ^ $3979;
  var $3981=(($3975+$3980)|0);
  var $3982=(($3981-899497514)|0);
  var $3983=$2;
  var $3984=(($3983+60)|0);
  var $3985=HEAP32[(($3984)>>2)];
  var $3986=$2;
  var $3987=(($3986+4)|0);
  var $3988=HEAP32[(($3987)>>2)];
  var $3989=$3985 ^ $3988;
  var $3990=$2;
  var $3991=(($3990+28)|0);
  var $3992=HEAP32[(($3991)>>2)];
  var $3993=$3989 ^ $3992;
  var $3994=$2;
  var $3995=(($3994+48)|0);
  var $3996=HEAP32[(($3995)>>2)];
  var $3997=$3993 ^ $3996;
  var $3998=$3997 << 1;
  var $3999=$2;
  var $4000=(($3999+60)|0);
  var $4001=HEAP32[(($4000)>>2)];
  var $4002=$2;
  var $4003=(($4002+4)|0);
  var $4004=HEAP32[(($4003)>>2)];
  var $4005=$4001 ^ $4004;
  var $4006=$2;
  var $4007=(($4006+28)|0);
  var $4008=HEAP32[(($4007)>>2)];
  var $4009=$4005 ^ $4008;
  var $4010=$2;
  var $4011=(($4010+48)|0);
  var $4012=HEAP32[(($4011)>>2)];
  var $4013=$4009 ^ $4012;
  var $4014=$4013 >>> 31;
  var $4015=$3998 | $4014;
  var $4016=$2;
  var $4017=(($4016+60)|0);
  HEAP32[(($4017)>>2)]=$4015;
  var $4018=(($3982+$4015)|0);
  var $4019=$A;
  var $4020=(($4019+$4018)|0);
  $A=$4020;
  var $4021=$C;
  var $4022=$4021 << 30;
  var $4023=$C;
  var $4024=$4023 >>> 2;
  var $4025=$4022 | $4024;
  $C=$4025;
  var $4026=$A;
  var $4027=$1;
  var $4028=(($4027)|0);
  var $4029=HEAP32[(($4028)>>2)];
  var $4030=(($4029+$4026)|0);
  HEAP32[(($4028)>>2)]=$4030;
  var $4031=$B;
  var $4032=$1;
  var $4033=(($4032+4)|0);
  var $4034=HEAP32[(($4033)>>2)];
  var $4035=(($4034+$4031)|0);
  HEAP32[(($4033)>>2)]=$4035;
  var $4036=$C;
  var $4037=$1;
  var $4038=(($4037+8)|0);
  var $4039=HEAP32[(($4038)>>2)];
  var $4040=(($4039+$4036)|0);
  HEAP32[(($4038)>>2)]=$4040;
  var $4041=$D;
  var $4042=$1;
  var $4043=(($4042+12)|0);
  var $4044=HEAP32[(($4043)>>2)];
  var $4045=(($4044+$4041)|0);
  HEAP32[(($4043)>>2)]=$4045;
  var $4046=$E;
  var $4047=$1;
  var $4048=(($4047+16)|0);
  var $4049=HEAP32[(($4048)>>2)];
  var $4050=(($4049+$4046)|0);
  HEAP32[(($4048)>>2)]=$4050;
  ;
  return;
}
__ZL14sha1_transformPjS_["X"]=1;

function __ZL12WRITE_UINT32Phj($data, $val) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$data;
  $2=$val;
  var $3=$2;
  var $4=$3 >>> 24;
  var $5=$4 & 255;
  var $6=(($5) & 255);
  var $7=$1;
  var $8=(($7)|0);
  HEAP8[($8)]=$6;
  var $9=$2;
  var $10=$9 >>> 16;
  var $11=$10 & 255;
  var $12=(($11) & 255);
  var $13=$1;
  var $14=(($13+1)|0);
  HEAP8[($14)]=$12;
  var $15=$2;
  var $16=$15 >>> 8;
  var $17=$16 & 255;
  var $18=(($17) & 255);
  var $19=$1;
  var $20=(($19+2)|0);
  HEAP8[($20)]=$18;
  var $21=$2;
  var $22=$21 >>> 0;
  var $23=$22 & 255;
  var $24=(($23) & 255);
  var $25=$1;
  var $26=(($25+3)|0);
  HEAP8[($26)]=$24;
  ;
  return;
}


function __Z7MD5InitP10MD5Context($ctx) {
  ;
  var __label__;

  var $1;
  $1=$ctx;
  var $2=$1;
  var $3=(($2)|0);
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=1732584193;
  var $5=$1;
  var $6=(($5)|0);
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=-271733879;
  var $8=$1;
  var $9=(($8)|0);
  var $10=(($9+8)|0);
  HEAP32[(($10)>>2)]=-1732584194;
  var $11=$1;
  var $12=(($11)|0);
  var $13=(($12+12)|0);
  HEAP32[(($13)>>2)]=271733878;
  var $14=$1;
  var $15=(($14+16)|0);
  var $16=(($15)|0);
  HEAP32[(($16)>>2)]=0;
  var $17=$1;
  var $18=(($17+16)|0);
  var $19=(($18+4)|0);
  HEAP32[(($19)>>2)]=0;
  ;
  return;
}


function __Z11sha1_digestPK8sha1_ctxjPh($ctx, $length, $digest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $i;
      var $words;
      var $leftover;
      var $word;
      var $j;
      $1=$ctx;
      $2=$length;
      $3=$digest;
      var $4=$2;
      var $5=Math.floor((($4)>>>0)/4);
      $words=$5;
      var $6=$2;
      var $7=(($6)>>>0)%4;
      $leftover=$7;
      $i=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$i;
      var $10=$words;
      var $11=(($9)>>>0) < (($10)>>>0);
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$3;
      var $14=$i;
      var $15=$1;
      var $16=(($15)|0);
      var $17=(($16+($14<<2))|0);
      var $18=HEAP32[(($17)>>2)];
      __ZL12WRITE_UINT32Phj($13, $18);
      __label__ = 3; break;
    case 3: // $19
      var $20=$i;
      var $21=(($20+1)|0);
      $i=$21;
      var $22=$3;
      var $23=(($22+4)|0);
      $3=$23;
      __label__ = 1; break;
    case 4: // $24
      var $25=$leftover;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $27
      var $28=$leftover;
      $j=$28;
      var $29=$i;
      var $30=$1;
      var $31=(($30)|0);
      var $32=(($31+($29<<2))|0);
      var $33=HEAP32[(($32)>>2)];
      $word=$33;
      var $34=$leftover;
      if ($34 == 3) {
        __label__ = 7; break;
      }
      else if ($34 == 2) {
        __label__ = 8; break;
      }
      else if ($34 == 1) {
        __label__ = 9; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 6: // $35
      __label__ = 7; break;
    case 7: // $36
      var $37=$word;
      var $38=$37 >>> 8;
      var $39=$38 & 255;
      var $40=(($39) & 255);
      var $41=$j;
      var $42=(($41-1)|0);
      $j=$42;
      var $43=$3;
      var $44=(($43+$42)|0);
      HEAP8[($44)]=$40;
      __label__ = 8; break;
    case 8: // $45
      var $46=$word;
      var $47=$46 >>> 16;
      var $48=$47 & 255;
      var $49=(($48) & 255);
      var $50=$j;
      var $51=(($50-1)|0);
      $j=$51;
      var $52=$3;
      var $53=(($52+$51)|0);
      HEAP8[($53)]=$49;
      __label__ = 9; break;
    case 9: // $54
      var $55=$word;
      var $56=$55 >>> 24;
      var $57=$56 & 255;
      var $58=(($57) & 255);
      var $59=$j;
      var $60=(($59-1)|0);
      $j=$60;
      var $61=$3;
      var $62=(($61+$60)|0);
      HEAP8[($62)]=$58;
      __label__ = 10; break;
    case 10: // $63
      __label__ = 11; break;
    case 11: // $64
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11sha1_digestPK8sha1_ctxjPh["X"]=1;

function __Z9MD5UpdateP10MD5ContextPKhj($ctx, $buf, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $t;
      $1=$ctx;
      $2=$buf;
      $3=$len;
      var $4=$1;
      var $5=(($4+16)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      $t=$7;
      var $8=$t;
      var $9=$3;
      var $10=(($8+$9)|0);
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$10;
      var $14=$t;
      var $15=(($10)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$1;
      var $18=(($17+16)|0);
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+1)|0);
      HEAP32[(($19)>>2)]=$21;
      __label__ = 2; break;
    case 2: // $22
      var $23=$t;
      var $24=$23 & 63;
      var $25=((64-$24)|0);
      $t=$25;
      var $26=$t;
      var $27=$3;
      var $28=(($26)>>>0) > (($27)>>>0);
      if ($28) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $29
      var $30=$1;
      var $31=(($30+24)|0);
      var $32=(($31)|0);
      var $33=$32;
      var $34=(($33+64)|0);
      var $35=$t;
      var $36=(((-$35))|0);
      var $37=(($34+$36)|0);
      var $38=$2;
      var $39=$3;
      assert($39 % 1 === 0, 'memcpy given ' + $39 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($37, $38, $39, 1);
      __label__ = 8; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+24)|0);
      var $43=(($42)|0);
      var $44=$43;
      var $45=(($44+64)|0);
      var $46=$t;
      var $47=(((-$46))|0);
      var $48=(($45+$47)|0);
      var $49=$2;
      var $50=$t;
      assert($50 % 1 === 0, 'memcpy given ' + $50 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($48, $49, $50, 1);
      var $51=$1;
      var $52=(($51)|0);
      var $53=(($52)|0);
      var $54=$1;
      var $55=(($54+24)|0);
      var $56=(($55)|0);
      __Z12MD5TransformPjPKj($53, $56);
      var $57=$t;
      var $58=$2;
      var $59=(($58+$57)|0);
      $2=$59;
      var $60=$t;
      var $61=$3;
      var $62=(($61-$60)|0);
      $3=$62;
      __label__ = 5; break;
    case 5: // $63
      var $64=$3;
      var $65=(($64)>>>0) >= 64;
      if ($65) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $66
      var $67=$1;
      var $68=(($67+24)|0);
      var $69=(($68)|0);
      var $70=$69;
      var $71=$2;
      assert(64 % 1 === 0, 'memcpy given ' + 64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($70, $71, 64, 1);
      var $72=$1;
      var $73=(($72)|0);
      var $74=(($73)|0);
      var $75=$1;
      var $76=(($75+24)|0);
      var $77=(($76)|0);
      __Z12MD5TransformPjPKj($74, $77);
      var $78=$2;
      var $79=(($78+64)|0);
      $2=$79;
      var $80=$3;
      var $81=(($80-64)|0);
      $3=$81;
      __label__ = 5; break;
    case 7: // $82
      var $83=$1;
      var $84=(($83+24)|0);
      var $85=(($84)|0);
      var $86=$85;
      var $87=$2;
      var $88=$3;
      assert($88 % 1 === 0, 'memcpy given ' + $88 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($86, $87, $88, 1);
      __label__ = 8; break;
    case 8: // $89
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z9MD5UpdateP10MD5ContextPKhj["X"]=1;

function __Z12MD5TransformPjPKj($buf, $in) {
  ;
  var __label__;

  var $1;
  var $2;
  var $a;
  var $b;
  var $c;
  var $d;
  $1=$buf;
  $2=$in;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  $a=$5;
  var $6=$1;
  var $7=(($6+4)|0);
  var $8=HEAP32[(($7)>>2)];
  $b=$8;
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  $c=$11;
  var $12=$1;
  var $13=(($12+12)|0);
  var $14=HEAP32[(($13)>>2)];
  $d=$14;
  var $15=$d;
  var $16=$b;
  var $17=$c;
  var $18=$d;
  var $19=$17 ^ $18;
  var $20=$16 & $19;
  var $21=$15 ^ $20;
  var $22=$2;
  var $23=(($22)|0);
  var $24=HEAP32[(($23)>>2)];
  var $25=(($21+$24)|0);
  var $26=(($25-680876936)|0);
  var $27=$a;
  var $28=(($27+$26)|0);
  $a=$28;
  var $29=$a;
  var $30=$29 << 7;
  var $31=$a;
  var $32=$31 >>> 25;
  var $33=$30 | $32;
  var $34=$b;
  var $35=(($33+$34)|0);
  $a=$35;
  var $36=$c;
  var $37=$a;
  var $38=$b;
  var $39=$c;
  var $40=$38 ^ $39;
  var $41=$37 & $40;
  var $42=$36 ^ $41;
  var $43=$2;
  var $44=(($43+4)|0);
  var $45=HEAP32[(($44)>>2)];
  var $46=(($42+$45)|0);
  var $47=(($46-389564586)|0);
  var $48=$d;
  var $49=(($48+$47)|0);
  $d=$49;
  var $50=$d;
  var $51=$50 << 12;
  var $52=$d;
  var $53=$52 >>> 20;
  var $54=$51 | $53;
  var $55=$a;
  var $56=(($54+$55)|0);
  $d=$56;
  var $57=$b;
  var $58=$d;
  var $59=$a;
  var $60=$b;
  var $61=$59 ^ $60;
  var $62=$58 & $61;
  var $63=$57 ^ $62;
  var $64=$2;
  var $65=(($64+8)|0);
  var $66=HEAP32[(($65)>>2)];
  var $67=(($63+$66)|0);
  var $68=(($67+606105819)|0);
  var $69=$c;
  var $70=(($69+$68)|0);
  $c=$70;
  var $71=$c;
  var $72=$71 << 17;
  var $73=$c;
  var $74=$73 >>> 15;
  var $75=$72 | $74;
  var $76=$d;
  var $77=(($75+$76)|0);
  $c=$77;
  var $78=$a;
  var $79=$c;
  var $80=$d;
  var $81=$a;
  var $82=$80 ^ $81;
  var $83=$79 & $82;
  var $84=$78 ^ $83;
  var $85=$2;
  var $86=(($85+12)|0);
  var $87=HEAP32[(($86)>>2)];
  var $88=(($84+$87)|0);
  var $89=(($88-1044525330)|0);
  var $90=$b;
  var $91=(($90+$89)|0);
  $b=$91;
  var $92=$b;
  var $93=$92 << 22;
  var $94=$b;
  var $95=$94 >>> 10;
  var $96=$93 | $95;
  var $97=$c;
  var $98=(($96+$97)|0);
  $b=$98;
  var $99=$d;
  var $100=$b;
  var $101=$c;
  var $102=$d;
  var $103=$101 ^ $102;
  var $104=$100 & $103;
  var $105=$99 ^ $104;
  var $106=$2;
  var $107=(($106+16)|0);
  var $108=HEAP32[(($107)>>2)];
  var $109=(($105+$108)|0);
  var $110=(($109-176418897)|0);
  var $111=$a;
  var $112=(($111+$110)|0);
  $a=$112;
  var $113=$a;
  var $114=$113 << 7;
  var $115=$a;
  var $116=$115 >>> 25;
  var $117=$114 | $116;
  var $118=$b;
  var $119=(($117+$118)|0);
  $a=$119;
  var $120=$c;
  var $121=$a;
  var $122=$b;
  var $123=$c;
  var $124=$122 ^ $123;
  var $125=$121 & $124;
  var $126=$120 ^ $125;
  var $127=$2;
  var $128=(($127+20)|0);
  var $129=HEAP32[(($128)>>2)];
  var $130=(($126+$129)|0);
  var $131=(($130+1200080426)|0);
  var $132=$d;
  var $133=(($132+$131)|0);
  $d=$133;
  var $134=$d;
  var $135=$134 << 12;
  var $136=$d;
  var $137=$136 >>> 20;
  var $138=$135 | $137;
  var $139=$a;
  var $140=(($138+$139)|0);
  $d=$140;
  var $141=$b;
  var $142=$d;
  var $143=$a;
  var $144=$b;
  var $145=$143 ^ $144;
  var $146=$142 & $145;
  var $147=$141 ^ $146;
  var $148=$2;
  var $149=(($148+24)|0);
  var $150=HEAP32[(($149)>>2)];
  var $151=(($147+$150)|0);
  var $152=(($151-1473231341)|0);
  var $153=$c;
  var $154=(($153+$152)|0);
  $c=$154;
  var $155=$c;
  var $156=$155 << 17;
  var $157=$c;
  var $158=$157 >>> 15;
  var $159=$156 | $158;
  var $160=$d;
  var $161=(($159+$160)|0);
  $c=$161;
  var $162=$a;
  var $163=$c;
  var $164=$d;
  var $165=$a;
  var $166=$164 ^ $165;
  var $167=$163 & $166;
  var $168=$162 ^ $167;
  var $169=$2;
  var $170=(($169+28)|0);
  var $171=HEAP32[(($170)>>2)];
  var $172=(($168+$171)|0);
  var $173=(($172-45705983)|0);
  var $174=$b;
  var $175=(($174+$173)|0);
  $b=$175;
  var $176=$b;
  var $177=$176 << 22;
  var $178=$b;
  var $179=$178 >>> 10;
  var $180=$177 | $179;
  var $181=$c;
  var $182=(($180+$181)|0);
  $b=$182;
  var $183=$d;
  var $184=$b;
  var $185=$c;
  var $186=$d;
  var $187=$185 ^ $186;
  var $188=$184 & $187;
  var $189=$183 ^ $188;
  var $190=$2;
  var $191=(($190+32)|0);
  var $192=HEAP32[(($191)>>2)];
  var $193=(($189+$192)|0);
  var $194=(($193+1770035416)|0);
  var $195=$a;
  var $196=(($195+$194)|0);
  $a=$196;
  var $197=$a;
  var $198=$197 << 7;
  var $199=$a;
  var $200=$199 >>> 25;
  var $201=$198 | $200;
  var $202=$b;
  var $203=(($201+$202)|0);
  $a=$203;
  var $204=$c;
  var $205=$a;
  var $206=$b;
  var $207=$c;
  var $208=$206 ^ $207;
  var $209=$205 & $208;
  var $210=$204 ^ $209;
  var $211=$2;
  var $212=(($211+36)|0);
  var $213=HEAP32[(($212)>>2)];
  var $214=(($210+$213)|0);
  var $215=(($214-1958414417)|0);
  var $216=$d;
  var $217=(($216+$215)|0);
  $d=$217;
  var $218=$d;
  var $219=$218 << 12;
  var $220=$d;
  var $221=$220 >>> 20;
  var $222=$219 | $221;
  var $223=$a;
  var $224=(($222+$223)|0);
  $d=$224;
  var $225=$b;
  var $226=$d;
  var $227=$a;
  var $228=$b;
  var $229=$227 ^ $228;
  var $230=$226 & $229;
  var $231=$225 ^ $230;
  var $232=$2;
  var $233=(($232+40)|0);
  var $234=HEAP32[(($233)>>2)];
  var $235=(($231+$234)|0);
  var $236=(($235-42063)|0);
  var $237=$c;
  var $238=(($237+$236)|0);
  $c=$238;
  var $239=$c;
  var $240=$239 << 17;
  var $241=$c;
  var $242=$241 >>> 15;
  var $243=$240 | $242;
  var $244=$d;
  var $245=(($243+$244)|0);
  $c=$245;
  var $246=$a;
  var $247=$c;
  var $248=$d;
  var $249=$a;
  var $250=$248 ^ $249;
  var $251=$247 & $250;
  var $252=$246 ^ $251;
  var $253=$2;
  var $254=(($253+44)|0);
  var $255=HEAP32[(($254)>>2)];
  var $256=(($252+$255)|0);
  var $257=(($256-1990404162)|0);
  var $258=$b;
  var $259=(($258+$257)|0);
  $b=$259;
  var $260=$b;
  var $261=$260 << 22;
  var $262=$b;
  var $263=$262 >>> 10;
  var $264=$261 | $263;
  var $265=$c;
  var $266=(($264+$265)|0);
  $b=$266;
  var $267=$d;
  var $268=$b;
  var $269=$c;
  var $270=$d;
  var $271=$269 ^ $270;
  var $272=$268 & $271;
  var $273=$267 ^ $272;
  var $274=$2;
  var $275=(($274+48)|0);
  var $276=HEAP32[(($275)>>2)];
  var $277=(($273+$276)|0);
  var $278=(($277+1804603682)|0);
  var $279=$a;
  var $280=(($279+$278)|0);
  $a=$280;
  var $281=$a;
  var $282=$281 << 7;
  var $283=$a;
  var $284=$283 >>> 25;
  var $285=$282 | $284;
  var $286=$b;
  var $287=(($285+$286)|0);
  $a=$287;
  var $288=$c;
  var $289=$a;
  var $290=$b;
  var $291=$c;
  var $292=$290 ^ $291;
  var $293=$289 & $292;
  var $294=$288 ^ $293;
  var $295=$2;
  var $296=(($295+52)|0);
  var $297=HEAP32[(($296)>>2)];
  var $298=(($294+$297)|0);
  var $299=(($298-40341101)|0);
  var $300=$d;
  var $301=(($300+$299)|0);
  $d=$301;
  var $302=$d;
  var $303=$302 << 12;
  var $304=$d;
  var $305=$304 >>> 20;
  var $306=$303 | $305;
  var $307=$a;
  var $308=(($306+$307)|0);
  $d=$308;
  var $309=$b;
  var $310=$d;
  var $311=$a;
  var $312=$b;
  var $313=$311 ^ $312;
  var $314=$310 & $313;
  var $315=$309 ^ $314;
  var $316=$2;
  var $317=(($316+56)|0);
  var $318=HEAP32[(($317)>>2)];
  var $319=(($315+$318)|0);
  var $320=(($319-1502002290)|0);
  var $321=$c;
  var $322=(($321+$320)|0);
  $c=$322;
  var $323=$c;
  var $324=$323 << 17;
  var $325=$c;
  var $326=$325 >>> 15;
  var $327=$324 | $326;
  var $328=$d;
  var $329=(($327+$328)|0);
  $c=$329;
  var $330=$a;
  var $331=$c;
  var $332=$d;
  var $333=$a;
  var $334=$332 ^ $333;
  var $335=$331 & $334;
  var $336=$330 ^ $335;
  var $337=$2;
  var $338=(($337+60)|0);
  var $339=HEAP32[(($338)>>2)];
  var $340=(($336+$339)|0);
  var $341=(($340+1236535329)|0);
  var $342=$b;
  var $343=(($342+$341)|0);
  $b=$343;
  var $344=$b;
  var $345=$344 << 22;
  var $346=$b;
  var $347=$346 >>> 10;
  var $348=$345 | $347;
  var $349=$c;
  var $350=(($348+$349)|0);
  $b=$350;
  var $351=$c;
  var $352=$d;
  var $353=$b;
  var $354=$c;
  var $355=$353 ^ $354;
  var $356=$352 & $355;
  var $357=$351 ^ $356;
  var $358=$2;
  var $359=(($358+4)|0);
  var $360=HEAP32[(($359)>>2)];
  var $361=(($357+$360)|0);
  var $362=(($361-165796510)|0);
  var $363=$a;
  var $364=(($363+$362)|0);
  $a=$364;
  var $365=$a;
  var $366=$365 << 5;
  var $367=$a;
  var $368=$367 >>> 27;
  var $369=$366 | $368;
  var $370=$b;
  var $371=(($369+$370)|0);
  $a=$371;
  var $372=$b;
  var $373=$c;
  var $374=$a;
  var $375=$b;
  var $376=$374 ^ $375;
  var $377=$373 & $376;
  var $378=$372 ^ $377;
  var $379=$2;
  var $380=(($379+24)|0);
  var $381=HEAP32[(($380)>>2)];
  var $382=(($378+$381)|0);
  var $383=(($382-1069501632)|0);
  var $384=$d;
  var $385=(($384+$383)|0);
  $d=$385;
  var $386=$d;
  var $387=$386 << 9;
  var $388=$d;
  var $389=$388 >>> 23;
  var $390=$387 | $389;
  var $391=$a;
  var $392=(($390+$391)|0);
  $d=$392;
  var $393=$a;
  var $394=$b;
  var $395=$d;
  var $396=$a;
  var $397=$395 ^ $396;
  var $398=$394 & $397;
  var $399=$393 ^ $398;
  var $400=$2;
  var $401=(($400+44)|0);
  var $402=HEAP32[(($401)>>2)];
  var $403=(($399+$402)|0);
  var $404=(($403+643717713)|0);
  var $405=$c;
  var $406=(($405+$404)|0);
  $c=$406;
  var $407=$c;
  var $408=$407 << 14;
  var $409=$c;
  var $410=$409 >>> 18;
  var $411=$408 | $410;
  var $412=$d;
  var $413=(($411+$412)|0);
  $c=$413;
  var $414=$d;
  var $415=$a;
  var $416=$c;
  var $417=$d;
  var $418=$416 ^ $417;
  var $419=$415 & $418;
  var $420=$414 ^ $419;
  var $421=$2;
  var $422=(($421)|0);
  var $423=HEAP32[(($422)>>2)];
  var $424=(($420+$423)|0);
  var $425=(($424-373897302)|0);
  var $426=$b;
  var $427=(($426+$425)|0);
  $b=$427;
  var $428=$b;
  var $429=$428 << 20;
  var $430=$b;
  var $431=$430 >>> 12;
  var $432=$429 | $431;
  var $433=$c;
  var $434=(($432+$433)|0);
  $b=$434;
  var $435=$c;
  var $436=$d;
  var $437=$b;
  var $438=$c;
  var $439=$437 ^ $438;
  var $440=$436 & $439;
  var $441=$435 ^ $440;
  var $442=$2;
  var $443=(($442+20)|0);
  var $444=HEAP32[(($443)>>2)];
  var $445=(($441+$444)|0);
  var $446=(($445-701558691)|0);
  var $447=$a;
  var $448=(($447+$446)|0);
  $a=$448;
  var $449=$a;
  var $450=$449 << 5;
  var $451=$a;
  var $452=$451 >>> 27;
  var $453=$450 | $452;
  var $454=$b;
  var $455=(($453+$454)|0);
  $a=$455;
  var $456=$b;
  var $457=$c;
  var $458=$a;
  var $459=$b;
  var $460=$458 ^ $459;
  var $461=$457 & $460;
  var $462=$456 ^ $461;
  var $463=$2;
  var $464=(($463+40)|0);
  var $465=HEAP32[(($464)>>2)];
  var $466=(($462+$465)|0);
  var $467=(($466+38016083)|0);
  var $468=$d;
  var $469=(($468+$467)|0);
  $d=$469;
  var $470=$d;
  var $471=$470 << 9;
  var $472=$d;
  var $473=$472 >>> 23;
  var $474=$471 | $473;
  var $475=$a;
  var $476=(($474+$475)|0);
  $d=$476;
  var $477=$a;
  var $478=$b;
  var $479=$d;
  var $480=$a;
  var $481=$479 ^ $480;
  var $482=$478 & $481;
  var $483=$477 ^ $482;
  var $484=$2;
  var $485=(($484+60)|0);
  var $486=HEAP32[(($485)>>2)];
  var $487=(($483+$486)|0);
  var $488=(($487-660478335)|0);
  var $489=$c;
  var $490=(($489+$488)|0);
  $c=$490;
  var $491=$c;
  var $492=$491 << 14;
  var $493=$c;
  var $494=$493 >>> 18;
  var $495=$492 | $494;
  var $496=$d;
  var $497=(($495+$496)|0);
  $c=$497;
  var $498=$d;
  var $499=$a;
  var $500=$c;
  var $501=$d;
  var $502=$500 ^ $501;
  var $503=$499 & $502;
  var $504=$498 ^ $503;
  var $505=$2;
  var $506=(($505+16)|0);
  var $507=HEAP32[(($506)>>2)];
  var $508=(($504+$507)|0);
  var $509=(($508-405537848)|0);
  var $510=$b;
  var $511=(($510+$509)|0);
  $b=$511;
  var $512=$b;
  var $513=$512 << 20;
  var $514=$b;
  var $515=$514 >>> 12;
  var $516=$513 | $515;
  var $517=$c;
  var $518=(($516+$517)|0);
  $b=$518;
  var $519=$c;
  var $520=$d;
  var $521=$b;
  var $522=$c;
  var $523=$521 ^ $522;
  var $524=$520 & $523;
  var $525=$519 ^ $524;
  var $526=$2;
  var $527=(($526+36)|0);
  var $528=HEAP32[(($527)>>2)];
  var $529=(($525+$528)|0);
  var $530=(($529+568446438)|0);
  var $531=$a;
  var $532=(($531+$530)|0);
  $a=$532;
  var $533=$a;
  var $534=$533 << 5;
  var $535=$a;
  var $536=$535 >>> 27;
  var $537=$534 | $536;
  var $538=$b;
  var $539=(($537+$538)|0);
  $a=$539;
  var $540=$b;
  var $541=$c;
  var $542=$a;
  var $543=$b;
  var $544=$542 ^ $543;
  var $545=$541 & $544;
  var $546=$540 ^ $545;
  var $547=$2;
  var $548=(($547+56)|0);
  var $549=HEAP32[(($548)>>2)];
  var $550=(($546+$549)|0);
  var $551=(($550-1019803690)|0);
  var $552=$d;
  var $553=(($552+$551)|0);
  $d=$553;
  var $554=$d;
  var $555=$554 << 9;
  var $556=$d;
  var $557=$556 >>> 23;
  var $558=$555 | $557;
  var $559=$a;
  var $560=(($558+$559)|0);
  $d=$560;
  var $561=$a;
  var $562=$b;
  var $563=$d;
  var $564=$a;
  var $565=$563 ^ $564;
  var $566=$562 & $565;
  var $567=$561 ^ $566;
  var $568=$2;
  var $569=(($568+12)|0);
  var $570=HEAP32[(($569)>>2)];
  var $571=(($567+$570)|0);
  var $572=(($571-187363961)|0);
  var $573=$c;
  var $574=(($573+$572)|0);
  $c=$574;
  var $575=$c;
  var $576=$575 << 14;
  var $577=$c;
  var $578=$577 >>> 18;
  var $579=$576 | $578;
  var $580=$d;
  var $581=(($579+$580)|0);
  $c=$581;
  var $582=$d;
  var $583=$a;
  var $584=$c;
  var $585=$d;
  var $586=$584 ^ $585;
  var $587=$583 & $586;
  var $588=$582 ^ $587;
  var $589=$2;
  var $590=(($589+32)|0);
  var $591=HEAP32[(($590)>>2)];
  var $592=(($588+$591)|0);
  var $593=(($592+1163531501)|0);
  var $594=$b;
  var $595=(($594+$593)|0);
  $b=$595;
  var $596=$b;
  var $597=$596 << 20;
  var $598=$b;
  var $599=$598 >>> 12;
  var $600=$597 | $599;
  var $601=$c;
  var $602=(($600+$601)|0);
  $b=$602;
  var $603=$c;
  var $604=$d;
  var $605=$b;
  var $606=$c;
  var $607=$605 ^ $606;
  var $608=$604 & $607;
  var $609=$603 ^ $608;
  var $610=$2;
  var $611=(($610+52)|0);
  var $612=HEAP32[(($611)>>2)];
  var $613=(($609+$612)|0);
  var $614=(($613-1444681467)|0);
  var $615=$a;
  var $616=(($615+$614)|0);
  $a=$616;
  var $617=$a;
  var $618=$617 << 5;
  var $619=$a;
  var $620=$619 >>> 27;
  var $621=$618 | $620;
  var $622=$b;
  var $623=(($621+$622)|0);
  $a=$623;
  var $624=$b;
  var $625=$c;
  var $626=$a;
  var $627=$b;
  var $628=$626 ^ $627;
  var $629=$625 & $628;
  var $630=$624 ^ $629;
  var $631=$2;
  var $632=(($631+8)|0);
  var $633=HEAP32[(($632)>>2)];
  var $634=(($630+$633)|0);
  var $635=(($634-51403784)|0);
  var $636=$d;
  var $637=(($636+$635)|0);
  $d=$637;
  var $638=$d;
  var $639=$638 << 9;
  var $640=$d;
  var $641=$640 >>> 23;
  var $642=$639 | $641;
  var $643=$a;
  var $644=(($642+$643)|0);
  $d=$644;
  var $645=$a;
  var $646=$b;
  var $647=$d;
  var $648=$a;
  var $649=$647 ^ $648;
  var $650=$646 & $649;
  var $651=$645 ^ $650;
  var $652=$2;
  var $653=(($652+28)|0);
  var $654=HEAP32[(($653)>>2)];
  var $655=(($651+$654)|0);
  var $656=(($655+1735328473)|0);
  var $657=$c;
  var $658=(($657+$656)|0);
  $c=$658;
  var $659=$c;
  var $660=$659 << 14;
  var $661=$c;
  var $662=$661 >>> 18;
  var $663=$660 | $662;
  var $664=$d;
  var $665=(($663+$664)|0);
  $c=$665;
  var $666=$d;
  var $667=$a;
  var $668=$c;
  var $669=$d;
  var $670=$668 ^ $669;
  var $671=$667 & $670;
  var $672=$666 ^ $671;
  var $673=$2;
  var $674=(($673+48)|0);
  var $675=HEAP32[(($674)>>2)];
  var $676=(($672+$675)|0);
  var $677=(($676-1926607734)|0);
  var $678=$b;
  var $679=(($678+$677)|0);
  $b=$679;
  var $680=$b;
  var $681=$680 << 20;
  var $682=$b;
  var $683=$682 >>> 12;
  var $684=$681 | $683;
  var $685=$c;
  var $686=(($684+$685)|0);
  $b=$686;
  var $687=$b;
  var $688=$c;
  var $689=$687 ^ $688;
  var $690=$d;
  var $691=$689 ^ $690;
  var $692=$2;
  var $693=(($692+20)|0);
  var $694=HEAP32[(($693)>>2)];
  var $695=(($691+$694)|0);
  var $696=(($695-378558)|0);
  var $697=$a;
  var $698=(($697+$696)|0);
  $a=$698;
  var $699=$a;
  var $700=$699 << 4;
  var $701=$a;
  var $702=$701 >>> 28;
  var $703=$700 | $702;
  var $704=$b;
  var $705=(($703+$704)|0);
  $a=$705;
  var $706=$a;
  var $707=$b;
  var $708=$706 ^ $707;
  var $709=$c;
  var $710=$708 ^ $709;
  var $711=$2;
  var $712=(($711+32)|0);
  var $713=HEAP32[(($712)>>2)];
  var $714=(($710+$713)|0);
  var $715=(($714-2022574463)|0);
  var $716=$d;
  var $717=(($716+$715)|0);
  $d=$717;
  var $718=$d;
  var $719=$718 << 11;
  var $720=$d;
  var $721=$720 >>> 21;
  var $722=$719 | $721;
  var $723=$a;
  var $724=(($722+$723)|0);
  $d=$724;
  var $725=$d;
  var $726=$a;
  var $727=$725 ^ $726;
  var $728=$b;
  var $729=$727 ^ $728;
  var $730=$2;
  var $731=(($730+44)|0);
  var $732=HEAP32[(($731)>>2)];
  var $733=(($729+$732)|0);
  var $734=(($733+1839030562)|0);
  var $735=$c;
  var $736=(($735+$734)|0);
  $c=$736;
  var $737=$c;
  var $738=$737 << 16;
  var $739=$c;
  var $740=$739 >>> 16;
  var $741=$738 | $740;
  var $742=$d;
  var $743=(($741+$742)|0);
  $c=$743;
  var $744=$c;
  var $745=$d;
  var $746=$744 ^ $745;
  var $747=$a;
  var $748=$746 ^ $747;
  var $749=$2;
  var $750=(($749+56)|0);
  var $751=HEAP32[(($750)>>2)];
  var $752=(($748+$751)|0);
  var $753=(($752-35309556)|0);
  var $754=$b;
  var $755=(($754+$753)|0);
  $b=$755;
  var $756=$b;
  var $757=$756 << 23;
  var $758=$b;
  var $759=$758 >>> 9;
  var $760=$757 | $759;
  var $761=$c;
  var $762=(($760+$761)|0);
  $b=$762;
  var $763=$b;
  var $764=$c;
  var $765=$763 ^ $764;
  var $766=$d;
  var $767=$765 ^ $766;
  var $768=$2;
  var $769=(($768+4)|0);
  var $770=HEAP32[(($769)>>2)];
  var $771=(($767+$770)|0);
  var $772=(($771-1530992060)|0);
  var $773=$a;
  var $774=(($773+$772)|0);
  $a=$774;
  var $775=$a;
  var $776=$775 << 4;
  var $777=$a;
  var $778=$777 >>> 28;
  var $779=$776 | $778;
  var $780=$b;
  var $781=(($779+$780)|0);
  $a=$781;
  var $782=$a;
  var $783=$b;
  var $784=$782 ^ $783;
  var $785=$c;
  var $786=$784 ^ $785;
  var $787=$2;
  var $788=(($787+16)|0);
  var $789=HEAP32[(($788)>>2)];
  var $790=(($786+$789)|0);
  var $791=(($790+1272893353)|0);
  var $792=$d;
  var $793=(($792+$791)|0);
  $d=$793;
  var $794=$d;
  var $795=$794 << 11;
  var $796=$d;
  var $797=$796 >>> 21;
  var $798=$795 | $797;
  var $799=$a;
  var $800=(($798+$799)|0);
  $d=$800;
  var $801=$d;
  var $802=$a;
  var $803=$801 ^ $802;
  var $804=$b;
  var $805=$803 ^ $804;
  var $806=$2;
  var $807=(($806+28)|0);
  var $808=HEAP32[(($807)>>2)];
  var $809=(($805+$808)|0);
  var $810=(($809-155497632)|0);
  var $811=$c;
  var $812=(($811+$810)|0);
  $c=$812;
  var $813=$c;
  var $814=$813 << 16;
  var $815=$c;
  var $816=$815 >>> 16;
  var $817=$814 | $816;
  var $818=$d;
  var $819=(($817+$818)|0);
  $c=$819;
  var $820=$c;
  var $821=$d;
  var $822=$820 ^ $821;
  var $823=$a;
  var $824=$822 ^ $823;
  var $825=$2;
  var $826=(($825+40)|0);
  var $827=HEAP32[(($826)>>2)];
  var $828=(($824+$827)|0);
  var $829=(($828-1094730640)|0);
  var $830=$b;
  var $831=(($830+$829)|0);
  $b=$831;
  var $832=$b;
  var $833=$832 << 23;
  var $834=$b;
  var $835=$834 >>> 9;
  var $836=$833 | $835;
  var $837=$c;
  var $838=(($836+$837)|0);
  $b=$838;
  var $839=$b;
  var $840=$c;
  var $841=$839 ^ $840;
  var $842=$d;
  var $843=$841 ^ $842;
  var $844=$2;
  var $845=(($844+52)|0);
  var $846=HEAP32[(($845)>>2)];
  var $847=(($843+$846)|0);
  var $848=(($847+681279174)|0);
  var $849=$a;
  var $850=(($849+$848)|0);
  $a=$850;
  var $851=$a;
  var $852=$851 << 4;
  var $853=$a;
  var $854=$853 >>> 28;
  var $855=$852 | $854;
  var $856=$b;
  var $857=(($855+$856)|0);
  $a=$857;
  var $858=$a;
  var $859=$b;
  var $860=$858 ^ $859;
  var $861=$c;
  var $862=$860 ^ $861;
  var $863=$2;
  var $864=(($863)|0);
  var $865=HEAP32[(($864)>>2)];
  var $866=(($862+$865)|0);
  var $867=(($866-358537222)|0);
  var $868=$d;
  var $869=(($868+$867)|0);
  $d=$869;
  var $870=$d;
  var $871=$870 << 11;
  var $872=$d;
  var $873=$872 >>> 21;
  var $874=$871 | $873;
  var $875=$a;
  var $876=(($874+$875)|0);
  $d=$876;
  var $877=$d;
  var $878=$a;
  var $879=$877 ^ $878;
  var $880=$b;
  var $881=$879 ^ $880;
  var $882=$2;
  var $883=(($882+12)|0);
  var $884=HEAP32[(($883)>>2)];
  var $885=(($881+$884)|0);
  var $886=(($885-722521979)|0);
  var $887=$c;
  var $888=(($887+$886)|0);
  $c=$888;
  var $889=$c;
  var $890=$889 << 16;
  var $891=$c;
  var $892=$891 >>> 16;
  var $893=$890 | $892;
  var $894=$d;
  var $895=(($893+$894)|0);
  $c=$895;
  var $896=$c;
  var $897=$d;
  var $898=$896 ^ $897;
  var $899=$a;
  var $900=$898 ^ $899;
  var $901=$2;
  var $902=(($901+24)|0);
  var $903=HEAP32[(($902)>>2)];
  var $904=(($900+$903)|0);
  var $905=(($904+76029189)|0);
  var $906=$b;
  var $907=(($906+$905)|0);
  $b=$907;
  var $908=$b;
  var $909=$908 << 23;
  var $910=$b;
  var $911=$910 >>> 9;
  var $912=$909 | $911;
  var $913=$c;
  var $914=(($912+$913)|0);
  $b=$914;
  var $915=$b;
  var $916=$c;
  var $917=$915 ^ $916;
  var $918=$d;
  var $919=$917 ^ $918;
  var $920=$2;
  var $921=(($920+36)|0);
  var $922=HEAP32[(($921)>>2)];
  var $923=(($919+$922)|0);
  var $924=(($923-640364487)|0);
  var $925=$a;
  var $926=(($925+$924)|0);
  $a=$926;
  var $927=$a;
  var $928=$927 << 4;
  var $929=$a;
  var $930=$929 >>> 28;
  var $931=$928 | $930;
  var $932=$b;
  var $933=(($931+$932)|0);
  $a=$933;
  var $934=$a;
  var $935=$b;
  var $936=$934 ^ $935;
  var $937=$c;
  var $938=$936 ^ $937;
  var $939=$2;
  var $940=(($939+48)|0);
  var $941=HEAP32[(($940)>>2)];
  var $942=(($938+$941)|0);
  var $943=(($942-421815835)|0);
  var $944=$d;
  var $945=(($944+$943)|0);
  $d=$945;
  var $946=$d;
  var $947=$946 << 11;
  var $948=$d;
  var $949=$948 >>> 21;
  var $950=$947 | $949;
  var $951=$a;
  var $952=(($950+$951)|0);
  $d=$952;
  var $953=$d;
  var $954=$a;
  var $955=$953 ^ $954;
  var $956=$b;
  var $957=$955 ^ $956;
  var $958=$2;
  var $959=(($958+60)|0);
  var $960=HEAP32[(($959)>>2)];
  var $961=(($957+$960)|0);
  var $962=(($961+530742520)|0);
  var $963=$c;
  var $964=(($963+$962)|0);
  $c=$964;
  var $965=$c;
  var $966=$965 << 16;
  var $967=$c;
  var $968=$967 >>> 16;
  var $969=$966 | $968;
  var $970=$d;
  var $971=(($969+$970)|0);
  $c=$971;
  var $972=$c;
  var $973=$d;
  var $974=$972 ^ $973;
  var $975=$a;
  var $976=$974 ^ $975;
  var $977=$2;
  var $978=(($977+8)|0);
  var $979=HEAP32[(($978)>>2)];
  var $980=(($976+$979)|0);
  var $981=(($980-995338651)|0);
  var $982=$b;
  var $983=(($982+$981)|0);
  $b=$983;
  var $984=$b;
  var $985=$984 << 23;
  var $986=$b;
  var $987=$986 >>> 9;
  var $988=$985 | $987;
  var $989=$c;
  var $990=(($988+$989)|0);
  $b=$990;
  var $991=$c;
  var $992=$b;
  var $993=$d;
  var $994=$993 ^ -1;
  var $995=$992 | $994;
  var $996=$991 ^ $995;
  var $997=$2;
  var $998=(($997)|0);
  var $999=HEAP32[(($998)>>2)];
  var $1000=(($996+$999)|0);
  var $1001=(($1000-198630844)|0);
  var $1002=$a;
  var $1003=(($1002+$1001)|0);
  $a=$1003;
  var $1004=$a;
  var $1005=$1004 << 6;
  var $1006=$a;
  var $1007=$1006 >>> 26;
  var $1008=$1005 | $1007;
  var $1009=$b;
  var $1010=(($1008+$1009)|0);
  $a=$1010;
  var $1011=$b;
  var $1012=$a;
  var $1013=$c;
  var $1014=$1013 ^ -1;
  var $1015=$1012 | $1014;
  var $1016=$1011 ^ $1015;
  var $1017=$2;
  var $1018=(($1017+28)|0);
  var $1019=HEAP32[(($1018)>>2)];
  var $1020=(($1016+$1019)|0);
  var $1021=(($1020+1126891415)|0);
  var $1022=$d;
  var $1023=(($1022+$1021)|0);
  $d=$1023;
  var $1024=$d;
  var $1025=$1024 << 10;
  var $1026=$d;
  var $1027=$1026 >>> 22;
  var $1028=$1025 | $1027;
  var $1029=$a;
  var $1030=(($1028+$1029)|0);
  $d=$1030;
  var $1031=$a;
  var $1032=$d;
  var $1033=$b;
  var $1034=$1033 ^ -1;
  var $1035=$1032 | $1034;
  var $1036=$1031 ^ $1035;
  var $1037=$2;
  var $1038=(($1037+56)|0);
  var $1039=HEAP32[(($1038)>>2)];
  var $1040=(($1036+$1039)|0);
  var $1041=(($1040-1416354905)|0);
  var $1042=$c;
  var $1043=(($1042+$1041)|0);
  $c=$1043;
  var $1044=$c;
  var $1045=$1044 << 15;
  var $1046=$c;
  var $1047=$1046 >>> 17;
  var $1048=$1045 | $1047;
  var $1049=$d;
  var $1050=(($1048+$1049)|0);
  $c=$1050;
  var $1051=$d;
  var $1052=$c;
  var $1053=$a;
  var $1054=$1053 ^ -1;
  var $1055=$1052 | $1054;
  var $1056=$1051 ^ $1055;
  var $1057=$2;
  var $1058=(($1057+20)|0);
  var $1059=HEAP32[(($1058)>>2)];
  var $1060=(($1056+$1059)|0);
  var $1061=(($1060-57434055)|0);
  var $1062=$b;
  var $1063=(($1062+$1061)|0);
  $b=$1063;
  var $1064=$b;
  var $1065=$1064 << 21;
  var $1066=$b;
  var $1067=$1066 >>> 11;
  var $1068=$1065 | $1067;
  var $1069=$c;
  var $1070=(($1068+$1069)|0);
  $b=$1070;
  var $1071=$c;
  var $1072=$b;
  var $1073=$d;
  var $1074=$1073 ^ -1;
  var $1075=$1072 | $1074;
  var $1076=$1071 ^ $1075;
  var $1077=$2;
  var $1078=(($1077+48)|0);
  var $1079=HEAP32[(($1078)>>2)];
  var $1080=(($1076+$1079)|0);
  var $1081=(($1080+1700485571)|0);
  var $1082=$a;
  var $1083=(($1082+$1081)|0);
  $a=$1083;
  var $1084=$a;
  var $1085=$1084 << 6;
  var $1086=$a;
  var $1087=$1086 >>> 26;
  var $1088=$1085 | $1087;
  var $1089=$b;
  var $1090=(($1088+$1089)|0);
  $a=$1090;
  var $1091=$b;
  var $1092=$a;
  var $1093=$c;
  var $1094=$1093 ^ -1;
  var $1095=$1092 | $1094;
  var $1096=$1091 ^ $1095;
  var $1097=$2;
  var $1098=(($1097+12)|0);
  var $1099=HEAP32[(($1098)>>2)];
  var $1100=(($1096+$1099)|0);
  var $1101=(($1100-1894986606)|0);
  var $1102=$d;
  var $1103=(($1102+$1101)|0);
  $d=$1103;
  var $1104=$d;
  var $1105=$1104 << 10;
  var $1106=$d;
  var $1107=$1106 >>> 22;
  var $1108=$1105 | $1107;
  var $1109=$a;
  var $1110=(($1108+$1109)|0);
  $d=$1110;
  var $1111=$a;
  var $1112=$d;
  var $1113=$b;
  var $1114=$1113 ^ -1;
  var $1115=$1112 | $1114;
  var $1116=$1111 ^ $1115;
  var $1117=$2;
  var $1118=(($1117+40)|0);
  var $1119=HEAP32[(($1118)>>2)];
  var $1120=(($1116+$1119)|0);
  var $1121=(($1120-1051523)|0);
  var $1122=$c;
  var $1123=(($1122+$1121)|0);
  $c=$1123;
  var $1124=$c;
  var $1125=$1124 << 15;
  var $1126=$c;
  var $1127=$1126 >>> 17;
  var $1128=$1125 | $1127;
  var $1129=$d;
  var $1130=(($1128+$1129)|0);
  $c=$1130;
  var $1131=$d;
  var $1132=$c;
  var $1133=$a;
  var $1134=$1133 ^ -1;
  var $1135=$1132 | $1134;
  var $1136=$1131 ^ $1135;
  var $1137=$2;
  var $1138=(($1137+4)|0);
  var $1139=HEAP32[(($1138)>>2)];
  var $1140=(($1136+$1139)|0);
  var $1141=(($1140-2054922799)|0);
  var $1142=$b;
  var $1143=(($1142+$1141)|0);
  $b=$1143;
  var $1144=$b;
  var $1145=$1144 << 21;
  var $1146=$b;
  var $1147=$1146 >>> 11;
  var $1148=$1145 | $1147;
  var $1149=$c;
  var $1150=(($1148+$1149)|0);
  $b=$1150;
  var $1151=$c;
  var $1152=$b;
  var $1153=$d;
  var $1154=$1153 ^ -1;
  var $1155=$1152 | $1154;
  var $1156=$1151 ^ $1155;
  var $1157=$2;
  var $1158=(($1157+32)|0);
  var $1159=HEAP32[(($1158)>>2)];
  var $1160=(($1156+$1159)|0);
  var $1161=(($1160+1873313359)|0);
  var $1162=$a;
  var $1163=(($1162+$1161)|0);
  $a=$1163;
  var $1164=$a;
  var $1165=$1164 << 6;
  var $1166=$a;
  var $1167=$1166 >>> 26;
  var $1168=$1165 | $1167;
  var $1169=$b;
  var $1170=(($1168+$1169)|0);
  $a=$1170;
  var $1171=$b;
  var $1172=$a;
  var $1173=$c;
  var $1174=$1173 ^ -1;
  var $1175=$1172 | $1174;
  var $1176=$1171 ^ $1175;
  var $1177=$2;
  var $1178=(($1177+60)|0);
  var $1179=HEAP32[(($1178)>>2)];
  var $1180=(($1176+$1179)|0);
  var $1181=(($1180-30611744)|0);
  var $1182=$d;
  var $1183=(($1182+$1181)|0);
  $d=$1183;
  var $1184=$d;
  var $1185=$1184 << 10;
  var $1186=$d;
  var $1187=$1186 >>> 22;
  var $1188=$1185 | $1187;
  var $1189=$a;
  var $1190=(($1188+$1189)|0);
  $d=$1190;
  var $1191=$a;
  var $1192=$d;
  var $1193=$b;
  var $1194=$1193 ^ -1;
  var $1195=$1192 | $1194;
  var $1196=$1191 ^ $1195;
  var $1197=$2;
  var $1198=(($1197+24)|0);
  var $1199=HEAP32[(($1198)>>2)];
  var $1200=(($1196+$1199)|0);
  var $1201=(($1200-1560198380)|0);
  var $1202=$c;
  var $1203=(($1202+$1201)|0);
  $c=$1203;
  var $1204=$c;
  var $1205=$1204 << 15;
  var $1206=$c;
  var $1207=$1206 >>> 17;
  var $1208=$1205 | $1207;
  var $1209=$d;
  var $1210=(($1208+$1209)|0);
  $c=$1210;
  var $1211=$d;
  var $1212=$c;
  var $1213=$a;
  var $1214=$1213 ^ -1;
  var $1215=$1212 | $1214;
  var $1216=$1211 ^ $1215;
  var $1217=$2;
  var $1218=(($1217+52)|0);
  var $1219=HEAP32[(($1218)>>2)];
  var $1220=(($1216+$1219)|0);
  var $1221=(($1220+1309151649)|0);
  var $1222=$b;
  var $1223=(($1222+$1221)|0);
  $b=$1223;
  var $1224=$b;
  var $1225=$1224 << 21;
  var $1226=$b;
  var $1227=$1226 >>> 11;
  var $1228=$1225 | $1227;
  var $1229=$c;
  var $1230=(($1228+$1229)|0);
  $b=$1230;
  var $1231=$c;
  var $1232=$b;
  var $1233=$d;
  var $1234=$1233 ^ -1;
  var $1235=$1232 | $1234;
  var $1236=$1231 ^ $1235;
  var $1237=$2;
  var $1238=(($1237+16)|0);
  var $1239=HEAP32[(($1238)>>2)];
  var $1240=(($1236+$1239)|0);
  var $1241=(($1240-145523070)|0);
  var $1242=$a;
  var $1243=(($1242+$1241)|0);
  $a=$1243;
  var $1244=$a;
  var $1245=$1244 << 6;
  var $1246=$a;
  var $1247=$1246 >>> 26;
  var $1248=$1245 | $1247;
  var $1249=$b;
  var $1250=(($1248+$1249)|0);
  $a=$1250;
  var $1251=$b;
  var $1252=$a;
  var $1253=$c;
  var $1254=$1253 ^ -1;
  var $1255=$1252 | $1254;
  var $1256=$1251 ^ $1255;
  var $1257=$2;
  var $1258=(($1257+44)|0);
  var $1259=HEAP32[(($1258)>>2)];
  var $1260=(($1256+$1259)|0);
  var $1261=(($1260-1120210379)|0);
  var $1262=$d;
  var $1263=(($1262+$1261)|0);
  $d=$1263;
  var $1264=$d;
  var $1265=$1264 << 10;
  var $1266=$d;
  var $1267=$1266 >>> 22;
  var $1268=$1265 | $1267;
  var $1269=$a;
  var $1270=(($1268+$1269)|0);
  $d=$1270;
  var $1271=$a;
  var $1272=$d;
  var $1273=$b;
  var $1274=$1273 ^ -1;
  var $1275=$1272 | $1274;
  var $1276=$1271 ^ $1275;
  var $1277=$2;
  var $1278=(($1277+8)|0);
  var $1279=HEAP32[(($1278)>>2)];
  var $1280=(($1276+$1279)|0);
  var $1281=(($1280+718787259)|0);
  var $1282=$c;
  var $1283=(($1282+$1281)|0);
  $c=$1283;
  var $1284=$c;
  var $1285=$1284 << 15;
  var $1286=$c;
  var $1287=$1286 >>> 17;
  var $1288=$1285 | $1287;
  var $1289=$d;
  var $1290=(($1288+$1289)|0);
  $c=$1290;
  var $1291=$d;
  var $1292=$c;
  var $1293=$a;
  var $1294=$1293 ^ -1;
  var $1295=$1292 | $1294;
  var $1296=$1291 ^ $1295;
  var $1297=$2;
  var $1298=(($1297+36)|0);
  var $1299=HEAP32[(($1298)>>2)];
  var $1300=(($1296+$1299)|0);
  var $1301=(($1300-343485551)|0);
  var $1302=$b;
  var $1303=(($1302+$1301)|0);
  $b=$1303;
  var $1304=$b;
  var $1305=$1304 << 21;
  var $1306=$b;
  var $1307=$1306 >>> 11;
  var $1308=$1305 | $1307;
  var $1309=$c;
  var $1310=(($1308+$1309)|0);
  $b=$1310;
  var $1311=$a;
  var $1312=$1;
  var $1313=(($1312)|0);
  var $1314=HEAP32[(($1313)>>2)];
  var $1315=(($1314+$1311)|0);
  HEAP32[(($1313)>>2)]=$1315;
  var $1316=$b;
  var $1317=$1;
  var $1318=(($1317+4)|0);
  var $1319=HEAP32[(($1318)>>2)];
  var $1320=(($1319+$1316)|0);
  HEAP32[(($1318)>>2)]=$1320;
  var $1321=$c;
  var $1322=$1;
  var $1323=(($1322+8)|0);
  var $1324=HEAP32[(($1323)>>2)];
  var $1325=(($1324+$1321)|0);
  HEAP32[(($1323)>>2)]=$1325;
  var $1326=$d;
  var $1327=$1;
  var $1328=(($1327+12)|0);
  var $1329=HEAP32[(($1328)>>2)];
  var $1330=(($1329+$1326)|0);
  HEAP32[(($1328)>>2)]=$1330;
  ;
  return;
}
__Z12MD5TransformPjPKj["X"]=1;

function __ZL11tagmap_hashPKc7437($string) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hash;
      var $c;
      $1=$string;
      var $2=$1;
      var $3=(($2+1)|0);
      $1=$3;
      var $4=HEAP8[($2)];
      var $5=(($4 << 24) >> 24);
      $hash=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$1;
      var $8=(($7+1)|0);
      $1=$8;
      var $9=HEAP8[($7)];
      $c=$9;
      var $10=(($9 << 24) >> 24);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$hash;
      var $14=$13 << 5;
      var $15=$hash;
      var $16=$15 >>> 27;
      var $17=$14 | $16;
      var $18=$c;
      var $19=(($18 << 24) >> 24);
      var $20=(($17+$19)|0);
      $hash=$20;
      __label__ = 1; break;
    case 3: // $21
      var $22=$hash;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z8MD5FinalPhP10MD5Context($digest, $ctx) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $count;
      var $p;
      $1=$digest;
      $2=$ctx;
      var $3=$2;
      var $4=(($3+16)|0);
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6 & 63;
      $count=$7;
      var $8=$2;
      var $9=(($8+24)|0);
      var $10=(($9)|0);
      var $11=$10;
      var $12=$count;
      var $13=(($11+$12)|0);
      $p=$13;
      var $14=$p;
      var $15=(($14+1)|0);
      $p=$15;
      HEAP8[($14)]=-128;
      var $16=$count;
      var $17=((55-$16)|0);
      $count=$17;
      var $18=$count;
      var $19=(($18)|0) < 0;
      if ($19) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $20
      var $21=$p;
      var $22=$count;
      var $23=(($22+8)|0);
      _memset($21, 0, $23, 1);
      var $24=$2;
      var $25=(($24)|0);
      var $26=(($25)|0);
      var $27=$2;
      var $28=(($27+24)|0);
      var $29=(($28)|0);
      __Z12MD5TransformPjPKj($26, $29);
      var $30=$2;
      var $31=(($30+24)|0);
      var $32=(($31)|0);
      var $33=$32;
      $p=$33;
      $count=56;
      __label__ = 2; break;
    case 2: // $34
      var $35=$p;
      var $36=$count;
      _memset($35, 0, $36, 1);
      var $37=$2;
      var $38=(($37+16)|0);
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 << 3;
      var $42=$2;
      var $43=(($42+24)|0);
      var $44=(($43+56)|0);
      HEAP32[(($44)>>2)]=$41;
      var $45=$2;
      var $46=(($45+16)|0);
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48 << 3;
      var $50=$2;
      var $51=(($50+16)|0);
      var $52=(($51)|0);
      var $53=HEAPU32[(($52)>>2)];
      var $54=$53 >>> 29;
      var $55=$49 | $54;
      var $56=$2;
      var $57=(($56+24)|0);
      var $58=(($57+60)|0);
      HEAP32[(($58)>>2)]=$55;
      var $59=$2;
      var $60=(($59)|0);
      var $61=(($60)|0);
      var $62=$2;
      var $63=(($62+24)|0);
      var $64=(($63)|0);
      __Z12MD5TransformPjPKj($61, $64);
      var $65=$1;
      var $66=$2;
      var $67=(($66)|0);
      var $68=(($67)|0);
      var $69=$68;
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $69, $$dest = $65, $$stop = $$src + 16; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $70=$2;
      var $71=$70;
      HEAP8[($71)]=0; HEAP8[($71+1)]=0; HEAP8[($71+2)]=0; HEAP8[($71+3)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z8MD5FinalPhP10MD5Context["X"]=1;

function __Z12tagmap_resetP7_tagmap($map) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $hashindex;
      var $entry;
      var $next;
      $1=$map;
      $hashindex=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$hashindex;
      var $4=(($3)>>>0) < 97;
      if ($4) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $5
      var $6=$hashindex;
      var $7=$1;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      $entry=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$entry;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $14
      var $15=$entry;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      $next=$17;
      var $18=$entry;
      var $19=$18;
      _free($19);
      __label__ = 5; break;
    case 5: // $20
      var $21=$next;
      $entry=$21;
      __label__ = 3; break;
    case 6: // $22
      var $23=$hashindex;
      var $24=$1;
      var $25=(($24)|0);
      var $26=(($25+($23<<2))|0);
      HEAP32[(($26)>>2)]=0;
      __label__ = 7; break;
    case 7: // $27
      var $28=$hashindex;
      var $29=(($28+1)|0);
      $hashindex=$29;
      __label__ = 1; break;
    case 8: // $30
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z10tagmap_addP7_tagmapPKcPvh($map, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$map;
  $2=$tag;
  $3=$object;
  $4=$replace_if_duplicate;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL17tagmap_add_commonP7_tagmapPKcPvhh($5, $6, $7, $8, 0);
  ;
  return $9;
}


function __ZL17tagmap_add_commonP7_tagmapPKcPvhh($map, $tag, $object, $replace_if_duplicate, $unique_hash) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $fullhash;
      var $hashindex;
      var $entry;
      $2=$map;
      $3=$tag;
      $4=$object;
      $5=$replace_if_duplicate;
      $6=$unique_hash;
      var $7=$3;
      var $8=__ZL11tagmap_hashPKc7437($7);
      $fullhash=$8;
      var $9=$fullhash;
      var $10=(($9)>>>0)%97;
      $hashindex=$10;
      var $11=$hashindex;
      var $12=$2;
      var $13=(($12)|0);
      var $14=(($13+($11<<2))|0);
      var $15=HEAP32[(($14)>>2)];
      $entry=$15;
      __label__ = 1; break;
    case 1: // $16
      var $17=$entry;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $19
      var $20=$entry;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$fullhash;
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $25
      var $26=$6;
      var $27=(($26 << 24) >> 24)!=0;
      if ($27) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $28
      var $29=$3;
      var $30=$entry;
      var $31=(($30+12)|0);
      var $32=(($31)|0);
      var $33=_strcmp($29, $32);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $35
      var $36=$5;
      var $37=(($36 << 24) >> 24)!=0;
      if ($37) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $38
      var $39=$4;
      var $40=$entry;
      var $41=(($40+4)|0);
      HEAP32[(($41)>>2)]=$39;
      __label__ = 7; break;
    case 7: // $42
      $1=2;
      __label__ = 14; break;
    case 8: // $43
      __label__ = 9; break;
    case 9: // $44
      __label__ = 10; break;
    case 10: // $45
      var $46=$entry;
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      $entry=$48;
      __label__ = 1; break;
    case 11: // $49
      var $50=$3;
      var $51=_strlen($50);
      var $52=(($51+16)|0);
      var $53=_malloc($52);
      var $54=$53;
      $entry=$54;
      var $55=$entry;
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $57
      $1=1;
      __label__ = 14; break;
    case 13: // $58
      var $59=$4;
      var $60=$entry;
      var $61=(($60+4)|0);
      HEAP32[(($61)>>2)]=$59;
      var $62=$fullhash;
      var $63=$entry;
      var $64=(($63+8)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=$entry;
      var $66=(($65+12)|0);
      var $67=(($66)|0);
      var $68=$3;
      var $69=_strcpy($67, $68);
      var $70=$hashindex;
      var $71=$2;
      var $72=(($71)|0);
      var $73=(($72+($70<<2))|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$entry;
      var $76=(($75)|0);
      HEAP32[(($76)>>2)]=$74;
      var $77=$entry;
      var $78=$hashindex;
      var $79=$2;
      var $80=(($79)|0);
      var $81=(($80+($78<<2))|0);
      HEAP32[(($81)>>2)]=$77;
      $1=0;
      __label__ = 14; break;
    case 14: // $82
      var $83=$1;
      ;
      return $83;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17tagmap_add_commonP7_tagmapPKcPvhh["X"]=1;

function __Z22tagmap_add_unique_hashP7_tagmapPKcPvh($map, $tag, $object, $replace_if_duplicate) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$map;
  $2=$tag;
  $3=$object;
  $4=$replace_if_duplicate;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL17tagmap_add_commonP7_tagmapPKcPvhh($5, $6, $7, $8, 1);
  ;
  return $9;
}


function __Z13tagmap_removeP7_tagmapPKc($map, $tag) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $fullhash;
      var $entryptr;
      var $entry;
      $1=$map;
      $2=$tag;
      var $3=$2;
      var $4=__ZL11tagmap_hashPKc7437($3);
      $fullhash=$4;
      var $5=$fullhash;
      var $6=(($5)>>>0)%97;
      var $7=$1;
      var $8=(($7)|0);
      var $9=(($8+($6<<2))|0);
      $entryptr=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$entryptr;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $14
      var $15=$entryptr;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$fullhash;
      var $20=(($18)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $21
      var $22=$entryptr;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+12)|0);
      var $25=(($24)|0);
      var $26=$2;
      var $27=_strcmp($25, $26);
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $29
      var $30=$entryptr;
      var $31=HEAP32[(($30)>>2)];
      $entry=$31;
      var $32=$entry;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$entryptr;
      HEAP32[(($35)>>2)]=$34;
      var $36=$entry;
      var $37=$36;
      _free($37);
      __label__ = 7; break;
    case 5: // $38
      __label__ = 6; break;
    case 6: // $39
      var $40=$entryptr;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0);
      $entryptr=$42;
      __label__ = 1; break;
    case 7: // $43
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z13tagmap_removeP7_tagmapPKc["X"]=1;

function __Z20tagmap_remove_objectP7_tagmapPv($map, $object) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $hashindex;
      var $entryptr;
      var $entry;
      $1=$map;
      $2=$object;
      $hashindex=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$hashindex;
      var $5=(($4)>>>0) < 97;
      if ($5) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $6
      var $7=$hashindex;
      var $8=$1;
      var $9=(($8)|0);
      var $10=(($9+($7<<2))|0);
      $entryptr=$10;
      __label__ = 3; break;
    case 3: // $11
      var $12=$entryptr;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $15
      var $16=$entryptr;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=(($19)|0)==(($20)|0);
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$entryptr;
      var $24=HEAP32[(($23)>>2)];
      $entry=$24;
      var $25=$entry;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$entryptr;
      HEAP32[(($28)>>2)]=$27;
      var $29=$entry;
      var $30=$29;
      _free($30);
      __label__ = 10; break;
    case 6: // $31
      __label__ = 7; break;
    case 7: // $32
      var $33=$entryptr;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0);
      $entryptr=$35;
      __label__ = 3; break;
    case 8: // $36
      __label__ = 9; break;
    case 9: // $37
      var $38=$hashindex;
      var $39=(($38+1)|0);
      $hashindex=$39;
      __label__ = 1; break;
    case 10: // $40
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20tagmap_remove_objectP7_tagmapPv["X"]=1;

function __Z11avcomp_initjjj($maxwidth, $maxheight, $maxchannels) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $hufferr;
      var $state;
      $2=$maxwidth;
      $3=$maxheight;
      $4=$maxchannels;
      var $5=$4;
      var $6=(($5)>>>0) > 4;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 18; break;
    case 2: // $8
      var $9=_malloc(208);
      var $10=$9;
      $state=$10;
      var $11=$state;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      $1=0;
      __label__ = 18; break;
    case 4: // $14
      var $15=$state;
      var $16=$15;
      _memset($16, 0, 208, 1);
      var $17=$2;
      var $18=$state;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      var $20=$3;
      var $21=$state;
      var $22=(($21+4)|0);
      HEAP32[(($22)>>2)]=$20;
      var $23=$4;
      var $24=$state;
      var $25=(($24+8)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$state;
      var $27=(($26+8)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=((($28<<16))|0);
      var $30=((($29<<1))|0);
      var $31=_malloc($30);
      var $32=$state;
      var $33=(($32+12)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$state;
      var $35=(($34+12)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $38
      __label__ = 17; break;
    case 6: // $39
      var $40=$state;
      var $41=(($40+16)|0);
      var $42=__Z22huffman_create_contextPP16_huffman_contexti($41, 16);
      $hufferr=$42;
      var $43=$hufferr;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $45
      __label__ = 17; break;
    case 8: // $46
      var $47=$state;
      var $48=(($47+20)|0);
      var $49=__Z22huffman_create_contextPP16_huffman_contexti($48, 16);
      $hufferr=$49;
      var $50=$hufferr;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $52
      __label__ = 17; break;
    case 10: // $53
      var $54=$state;
      var $55=(($54+24)|0);
      var $56=__Z22huffman_create_contextPP16_huffman_contexti($55, 16);
      $hufferr=$56;
      var $57=$hufferr;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $59
      __label__ = 17; break;
    case 12: // $60
      var $61=$state;
      var $62=(($61+28)|0);
      var $63=__Z22huffman_create_contextPP16_huffman_contexti($62, 16);
      $hufferr=$63;
      var $64=$hufferr;
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $66
      __label__ = 17; break;
    case 14: // $67
      var $68=$state;
      var $69=(($68+32)|0);
      var $70=__Z22huffman_create_contextPP16_huffman_contexti($69, 16);
      $hufferr=$70;
      var $71=$hufferr;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $73
      __label__ = 17; break;
    case 16: // $74
      var $75=$state;
      $1=$75;
      __label__ = 18; break;
    case 17: // $76
      var $77=$state;
      __Z11avcomp_freeP13_avcomp_state($77);
      $1=0;
      __label__ = 18; break;
    case 18: // $78
      var $79=$1;
      ;
      return $79;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11avcomp_initjjj["X"]=1;

function __Z11avcomp_freeP13_avcomp_state($state) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$state;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+12)|0);
      var $9=HEAP32[(($8)>>2)];
      _free($9);
      __label__ = 2; break;
    case 2: // $10
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16+16)|0);
      var $18=HEAP32[(($17)>>2)];
      __Z20huffman_free_contextP16_huffman_context($18);
      __label__ = 4; break;
    case 4: // $19
      var $20=$1;
      var $21=(($20+20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$1;
      var $26=(($25+20)|0);
      var $27=HEAP32[(($26)>>2)];
      __Z20huffman_free_contextP16_huffman_context($27);
      __label__ = 6; break;
    case 6: // $28
      var $29=$1;
      var $30=(($29+24)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $33
      var $34=$1;
      var $35=(($34+24)|0);
      var $36=HEAP32[(($35)>>2)];
      __Z20huffman_free_contextP16_huffman_context($36);
      __label__ = 8; break;
    case 8: // $37
      var $38=$1;
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40)|0)!=0;
      if ($41) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $42
      var $43=$1;
      var $44=(($43+28)|0);
      var $45=HEAP32[(($44)>>2)];
      __Z20huffman_free_contextP16_huffman_context($45);
      __label__ = 10; break;
    case 10: // $46
      var $47=$1;
      var $48=(($47+32)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $51
      var $52=$1;
      var $53=(($52+32)|0);
      var $54=HEAP32[(($53)>>2)];
      __Z20huffman_free_contextP16_huffman_context($54);
      __label__ = 12; break;
    case 12: // $55
      var $56=$1;
      var $57=$56;
      _free($57);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z11avcomp_freeP13_avcomp_state["X"]=1;

function __Z22avcomp_config_compressP13_avcomp_statePK25_av_codec_compress_config($state, $config) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$state;
  $2=$config;
  var $3=$1;
  var $4=(($3+36)|0);
  var $5=$2;
  var $6=$4;
  var $7=$5;
  assert(84 % 1 === 0, 'memcpy given ' + 84 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $7>>2, $$dest = $6>>2, $$stop = $$src + 21; $$src < $$stop; $$src++, $$dest++) {
    HEAP32[$$dest] = HEAP32[$$src]
  };
  ;
  return;
}


function __Z24avcomp_config_decompressP13_avcomp_statePK27_av_codec_decompress_config($state, $config) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$state;
  $2=$config;
  var $3=$1;
  var $4=(($3+120)|0);
  var $5=$2;
  var $6=$4;
  var $7=$5;
  assert(88 % 1 === 0, 'memcpy given ' + 88 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $7>>2, $$dest = $6>>2, $$stop = $$src + 22; $$src < $$stop; $$src++, $$dest++) {
    HEAP32[$$dest] = HEAP32[$$src]
  };
  ;
  return;
}


function __Z18avcomp_encode_dataP13_avcomp_statePKhPhPj($state, $source, $dest, $complength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $metastart;
      var $videostart;
      var $audiostart=__stackBase__;
      var $metasize;
      var $channels;
      var $samples;
      var $width;
      var $height;
      var $audioxor;
      var $videoxor;
      var $videostride;
      var $err;
      var $dstoffs;
      var $chnum;
      var $betest=__stackBase__+16;
      var $vidlength=__stackBase__+20;
      $2=$state;
      $3=$source;
      $4=$dest;
      $5=$complength;
      var $6=$3;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 11; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($12)|0)!=99;
      if ($13) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=$3;
      var $16=(($15+1)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($18)|0)!=104;
      if ($19) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=$3;
      var $22=(($21+2)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(($24)|0)!=97;
      if ($25) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $26
      var $27=$3;
      var $28=(($27+3)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=(($30)|0)!=118;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      $1=1;
      __label__ = 44; break;
    case 6: // $33
      var $34=$3;
      var $35=(($34+4)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      $metasize=$37;
      var $38=$3;
      var $39=(($38+5)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      $channels=$41;
      var $42=$3;
      var $43=(($42+6)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$45 << 8;
      var $47=$3;
      var $48=(($47+7)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=(($46+$50)|0);
      $samples=$51;
      var $52=$3;
      var $53=(($52+8)|0);
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$55 << 8;
      var $57=$3;
      var $58=(($57+9)|0);
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(($56+$60)|0);
      $width=$61;
      var $62=$3;
      var $63=(($62+10)|0);
      var $64=HEAPU8[($63)];
      var $65=(($64)&255);
      var $66=$65 << 8;
      var $67=$3;
      var $68=(($67+11)|0);
      var $69=HEAPU8[($68)];
      var $70=(($69)&255);
      var $71=(($66+$70)|0);
      $height=$71;
      var $72=$3;
      var $73=(($72+12)|0);
      $3=$73;
      var $74=$3;
      $metastart=$74;
      var $75=$metasize;
      var $76=$3;
      var $77=(($76+$75)|0);
      $3=$77;
      $chnum=0;
      __label__ = 7; break;
    case 7: // $78
      var $79=$chnum;
      var $80=$channels;
      var $81=(($79)>>>0) < (($80)>>>0);
      if ($81) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $82
      var $83=$3;
      var $84=$chnum;
      var $85=(($audiostart+($84<<2))|0);
      HEAP32[(($85)>>2)]=$83;
      var $86=$samples;
      var $87=((($86<<1))|0);
      var $88=$3;
      var $89=(($88+$87)|0);
      $3=$89;
      __label__ = 9; break;
    case 9: // $90
      var $91=$chnum;
      var $92=(($91+1)|0);
      $chnum=$92;
      __label__ = 7; break;
    case 10: // $93
      var $94=$3;
      $videostart=$94;
      $videoxor=0;
      $audioxor=0;
      var $95=$width;
      var $96=((($95<<1))|0);
      $videostride=$96;
      __label__ = 23; break;
    case 11: // $97
      HEAP16[(($betest)>>1)]=0;
      var $98=$2;
      var $99=(($98+36)|0);
      var $100=(($99+80)|0);
      var $101=HEAP32[(($100)>>2)];
      $metastart=$101;
      var $102=$2;
      var $103=(($102+36)|0);
      var $104=(($103+76)|0);
      var $105=HEAP32[(($104)>>2)];
      $metasize=$105;
      var $106=$metastart;
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $108
      var $109=$metasize;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 15; break; } else { __label__ = 13; break; }
    case 13: // $111
      var $112=$metastart;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $114
      var $115=$metasize;
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $117
      $1=8;
      __label__ = 44; break;
    case 16: // $118
      var $119=$2;
      var $120=(($119+36)|0);
      var $121=(($120+4)|0);
      var $122=HEAP32[(($121)>>2)];
      $channels=$122;
      var $123=$2;
      var $124=(($123+36)|0);
      var $125=(($124+8)|0);
      var $126=HEAP32[(($125)>>2)];
      $samples=$126;
      $chnum=0;
      __label__ = 17; break;
    case 17: // $127
      var $128=$chnum;
      var $129=$channels;
      var $130=(($128)>>>0) < (($129)>>>0);
      if ($130) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $131
      var $132=$chnum;
      var $133=$2;
      var $134=(($133+36)|0);
      var $135=(($134+12)|0);
      var $136=(($135+($132<<2))|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$137;
      var $139=$chnum;
      var $140=(($audiostart+($139<<2))|0);
      HEAP32[(($140)>>2)]=$138;
      __label__ = 19; break;
    case 19: // $141
      var $142=$chnum;
      var $143=(($142+1)|0);
      $chnum=$143;
      __label__ = 17; break;
    case 20: // $144
      $videostart=0;
      $height=0;
      $width=0;
      $videostride=0;
      var $145=$2;
      var $146=(($145+36)|0);
      var $147=(($146)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $150
      var $151=$2;
      var $152=(($151+36)|0);
      var $153=(($152)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$154;
      var $156=(($155+4)|0);
      var $157=HEAP32[(($156)>>2)];
      $videostart=$157;
      var $158=$2;
      var $159=(($158+36)|0);
      var $160=(($159)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$161;
      var $163=(($162+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=((($164<<1))|0);
      $videostride=$165;
      var $166=$2;
      var $167=(($166+36)|0);
      var $168=(($167)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=$169;
      var $171=(($170+12)|0);
      var $172=HEAP32[(($171)>>2)];
      $width=$172;
      var $173=$2;
      var $174=(($173+36)|0);
      var $175=(($174)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$176;
      var $178=(($177+16)|0);
      var $179=HEAP32[(($178)>>2)];
      $height=$179;
      __label__ = 22; break;
    case 22: // $180
      var $181=$betest;
      HEAP8[($181)]=1;
      var $182=HEAPU16[(($betest)>>1)];
      var $183=(($182)&65535);
      var $184=(($183)|0)==1;
      var $185=$184 ? 1 : 0;
      $videoxor=$185;
      $audioxor=$185;
      __label__ = 23; break;
    case 23: // $186
      var $187=$width;
      var $188=$2;
      var $189=(($188)|0);
      var $190=HEAPU32[(($189)>>2)];
      var $191=(($187)>>>0) > (($190)>>>0);
      if ($191) { __label__ = 25; break; } else { __label__ = 24; break; }
    case 24: // $192
      var $193=$height;
      var $194=$2;
      var $195=(($194+4)|0);
      var $196=HEAPU32[(($195)>>2)];
      var $197=(($193)>>>0) > (($196)>>>0);
      if ($197) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $198
      $1=2;
      __label__ = 44; break;
    case 26: // $199
      var $200=$channels;
      var $201=$2;
      var $202=(($201+8)|0);
      var $203=HEAPU32[(($202)>>2)];
      var $204=(($200)>>>0) > (($203)>>>0);
      if ($204) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $205
      $1=3;
      __label__ = 44; break;
    case 28: // $206
      var $207=$metasize;
      var $208=(($207) & 255);
      var $209=$4;
      var $210=(($209)|0);
      HEAP8[($210)]=$208;
      var $211=$channels;
      var $212=(($211) & 255);
      var $213=$4;
      var $214=(($213+1)|0);
      HEAP8[($214)]=$212;
      var $215=$samples;
      var $216=$215 >>> 8;
      var $217=(($216) & 255);
      var $218=$4;
      var $219=(($218+2)|0);
      HEAP8[($219)]=$217;
      var $220=$samples;
      var $221=(($220) & 255);
      var $222=$4;
      var $223=(($222+3)|0);
      HEAP8[($223)]=$221;
      var $224=$width;
      var $225=$224 >>> 8;
      var $226=(($225) & 255);
      var $227=$4;
      var $228=(($227+4)|0);
      HEAP8[($228)]=$226;
      var $229=$width;
      var $230=(($229) & 255);
      var $231=$4;
      var $232=(($231+5)|0);
      HEAP8[($232)]=$230;
      var $233=$height;
      var $234=$233 >>> 8;
      var $235=(($234) & 255);
      var $236=$4;
      var $237=(($236+6)|0);
      HEAP8[($237)]=$235;
      var $238=$height;
      var $239=(($238) & 255);
      var $240=$4;
      var $241=(($240+7)|0);
      HEAP8[($241)]=$239;
      var $242=$channels;
      var $243=((($242<<1))|0);
      var $244=(($243+10)|0);
      $dstoffs=$244;
      var $245=$metasize;
      var $246=(($245)>>>0) > 0;
      if ($246) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $247
      var $248=$4;
      var $249=$dstoffs;
      var $250=(($248+$249)|0);
      var $251=$metastart;
      var $252=$metasize;
      assert($252 % 1 === 0, 'memcpy given ' + $252 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($250, $251, $252, 1);
      var $253=$metasize;
      var $254=$dstoffs;
      var $255=(($254+$253)|0);
      $dstoffs=$255;
      __label__ = 30; break;
    case 30: // $256
      var $257=$channels;
      var $258=(($257)>>>0) > 0;
      if ($258) { __label__ = 31; break; } else { __label__ = 38; break; }
    case 31: // $259
      var $260=$2;
      var $261=$channels;
      var $262=$samples;
      var $263=(($audiostart)|0);
      var $264=$audioxor;
      var $265=$4;
      var $266=$dstoffs;
      var $267=(($265+$266)|0);
      var $268=$4;
      var $269=(($268+8)|0);
      var $270=__ZL12encode_audioP13_avcomp_stateiiPPKhiPhS4_($260, $261, $262, $263, $264, $267, $269);
      $err=$270;
      var $271=$err;
      var $272=(($271)|0)!=0;
      if ($272) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $273
      var $274=$err;
      $1=$274;
      __label__ = 44; break;
    case 33: // $275
      var $276=$4;
      var $277=(($276+8)|0);
      var $278=HEAPU8[($277)];
      var $279=(($278)&255);
      var $280=$279 << 8;
      var $281=$4;
      var $282=(($281+9)|0);
      var $283=HEAPU8[($282)];
      var $284=(($283)&255);
      var $285=(($280+$284)|0);
      var $286=$dstoffs;
      var $287=(($286+$285)|0);
      $dstoffs=$287;
      $chnum=0;
      __label__ = 34; break;
    case 34: // $288
      var $289=$chnum;
      var $290=$channels;
      var $291=(($289)>>>0) < (($290)>>>0);
      if ($291) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $292
      var $293=$chnum;
      var $294=((($293<<1))|0);
      var $295=(($294+10)|0);
      var $296=$4;
      var $297=(($296+$295)|0);
      var $298=HEAPU8[($297)];
      var $299=(($298)&255);
      var $300=$299 << 8;
      var $301=$chnum;
      var $302=((($301<<1))|0);
      var $303=(($302+11)|0);
      var $304=$4;
      var $305=(($304+$303)|0);
      var $306=HEAPU8[($305)];
      var $307=(($306)&255);
      var $308=(($300+$307)|0);
      var $309=$dstoffs;
      var $310=(($309+$308)|0);
      $dstoffs=$310;
      __label__ = 36; break;
    case 36: // $311
      var $312=$chnum;
      var $313=(($312+1)|0);
      $chnum=$313;
      __label__ = 34; break;
    case 37: // $314
      __label__ = 38; break;
    case 38: // $315
      var $316=$width;
      var $317=(($316)>>>0) > 0;
      if ($317) { __label__ = 39; break; } else { __label__ = 43; break; }
    case 39: // $318
      var $319=$height;
      var $320=(($319)>>>0) > 0;
      if ($320) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $321
      HEAP32[(($vidlength)>>2)]=0;
      var $322=$2;
      var $323=$width;
      var $324=$height;
      var $325=$videostart;
      var $326=$videostride;
      var $327=$videoxor;
      var $328=$4;
      var $329=$dstoffs;
      var $330=(($328+$329)|0);
      var $331=__ZL12encode_videoP13_avcomp_stateiiPKhjjPhPj($322, $323, $324, $325, $326, $327, $330, $vidlength);
      $err=$331;
      var $332=$err;
      var $333=(($332)|0)!=0;
      if ($333) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $334
      var $335=$err;
      $1=$335;
      __label__ = 44; break;
    case 42: // $336
      var $337=HEAP32[(($vidlength)>>2)];
      var $338=$dstoffs;
      var $339=(($338+$337)|0);
      $dstoffs=$339;
      __label__ = 43; break;
    case 43: // $340
      var $341=$dstoffs;
      var $342=$5;
      HEAP32[(($342)>>2)]=$341;
      $1=0;
      __label__ = 44; break;
    case 44: // $343
      var $344=$1;
      STACKTOP = __stackBase__;
      return $344;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18avcomp_encode_dataP13_avcomp_statePKhPhPj["X"]=1;

function __ZL12encode_audioP13_avcomp_stateiiPPKhiPhS4_($state, $channels, $samples, $source, $sourcexor, $dest, $sizes) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $size=__stackBase__;
      var $huffsize;
      var $totalsize;
      var $contexts=__stackBase__+4;
      var $hufferr;
      var $output;
      var $chnum;
      var $sampnum;
      var $deltabuf;
      var $srcdata;
      var $prevsample;
      var $newsample;
      var $delta;
      var $input;
      $2=$state;
      $3=$channels;
      $4=$samples;
      $5=$source;
      $6=$sourcexor;
      $7=$dest;
      $8=$sizes;
      var $9=$7;
      $output=$9;
      var $10=$2;
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      $deltabuf=$12;
      $chnum=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$chnum;
      var $15=$3;
      var $16=(($14)|0) < (($15)|0);
      if ($16) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $17
      var $18=$chnum;
      var $19=$5;
      var $20=(($19+($18<<2))|0);
      var $21=HEAP32[(($20)>>2)];
      $srcdata=$21;
      $prevsample=0;
      $sampnum=0;
      __label__ = 3; break;
    case 3: // $22
      var $23=$sampnum;
      var $24=$4;
      var $25=(($23)|0) < (($24)|0);
      if ($25) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $26
      var $27=$6;
      var $28=0 ^ $27;
      var $29=$srcdata;
      var $30=(($29+$28)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=$32 << 8;
      var $34=$6;
      var $35=1 ^ $34;
      var $36=$srcdata;
      var $37=(($36+$35)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$33 | $39;
      var $41=(($40) & 65535);
      $newsample=$41;
      var $42=$newsample;
      var $43=(($42 << 16) >> 16);
      var $44=$prevsample;
      var $45=(($44 << 16) >> 16);
      var $46=(($43-$45)|0);
      var $47=(($46) & 65535);
      $delta=$47;
      var $48=$newsample;
      $prevsample=$48;
      var $49=$delta;
      var $50=(($49 << 16) >> 16);
      var $51=$50 >> 8;
      var $52=(($51) & 255);
      var $53=$deltabuf;
      var $54=(($53+1)|0);
      $deltabuf=$54;
      HEAP8[($53)]=$52;
      var $55=$delta;
      var $56=(($55) & 255);
      var $57=$deltabuf;
      var $58=(($57+1)|0);
      $deltabuf=$58;
      HEAP8[($57)]=$56;
      var $59=$srcdata;
      var $60=(($59+2)|0);
      $srcdata=$60;
      __label__ = 5; break;
    case 5: // $61
      var $62=$sampnum;
      var $63=(($62+1)|0);
      $sampnum=$63;
      __label__ = 3; break;
    case 6: // $64
      __label__ = 7; break;
    case 7: // $65
      var $66=$chnum;
      var $67=(($66+1)|0);
      $chnum=$67;
      __label__ = 1; break;
    case 8: // $68
      var $69=$2;
      var $70=(($69+28)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($contexts)|0);
      HEAP32[(($72)>>2)]=$71;
      var $73=$2;
      var $74=(($73+32)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($contexts+4)|0);
      HEAP32[(($76)>>2)]=$75;
      var $77=(($contexts)|0);
      var $78=$2;
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$4;
      var $82=((($81<<1))|0);
      var $83=$3;
      var $84=$4;
      var $85=((($84<<1))|0);
      var $86=__Z32huffman_compute_tree_interleavediPP16_huffman_contextPKhjjjj(2, $77, $80, $82, $83, $85, 0);
      $hufferr=$86;
      var $87=$hufferr;
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $89
      $1=6;
      __label__ = 29; break;
    case 10: // $90
      var $91=$2;
      var $92=(($91+28)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$output;
      var $95=__Z19huffman_export_treeP16_huffman_contextPhjPj($93, $94, 256, $size);
      $hufferr=$95;
      var $96=$hufferr;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $98
      $1=6;
      __label__ = 29; break;
    case 12: // $99
      var $100=HEAP32[(($size)>>2)];
      var $101=$output;
      var $102=(($101+$100)|0);
      $output=$102;
      var $103=$2;
      var $104=(($103+32)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$output;
      var $107=__Z19huffman_export_treeP16_huffman_contextPhjPj($105, $106, 256, $size);
      $hufferr=$107;
      var $108=$hufferr;
      var $109=(($108)|0)!=0;
      if ($109) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $110
      $1=6;
      __label__ = 29; break;
    case 14: // $111
      var $112=HEAP32[(($size)>>2)];
      var $113=$output;
      var $114=(($113+$112)|0);
      $output=$114;
      var $115=$output;
      var $116=$7;
      var $117=$115;
      var $118=$116;
      var $119=(($117-$118)|0);
      $huffsize=$119;
      var $120=$huffsize;
      var $121=$120 >>> 8;
      var $122=(($121) & 255);
      var $123=$8;
      var $124=(($123)|0);
      HEAP8[($124)]=$122;
      var $125=$huffsize;
      var $126=(($125) & 255);
      var $127=$8;
      var $128=(($127+1)|0);
      HEAP8[($128)]=$126;
      var $129=$huffsize;
      $totalsize=$129;
      $chnum=0;
      __label__ = 15; break;
    case 15: // $130
      var $131=$chnum;
      var $132=$3;
      var $133=(($131)|0) < (($132)|0);
      if ($133) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $134
      var $135=$2;
      var $136=(($135+12)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$chnum;
      var $139=$4;
      var $140=(($138*$139)|0);
      var $141=((($140<<1))|0);
      var $142=(($137+$141)|0);
      $input=$142;
      var $143=(($contexts)|0);
      var $144=$input;
      var $145=$4;
      var $146=((($145<<1))|0);
      var $147=$output;
      var $148=$4;
      var $149=((($148<<1))|0);
      var $150=__Z31huffman_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj(2, $143, $144, $146, 1, 0, 0, $147, $149, $size);
      $hufferr=$150;
      var $151=$hufferr;
      var $152=(($151)|0)!=0;
      if ($152) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $153
      $1=6;
      __label__ = 29; break;
    case 18: // $154
      var $155=HEAP32[(($size)>>2)];
      var $156=$output;
      var $157=(($156+$155)|0);
      $output=$157;
      var $158=HEAP32[(($size)>>2)];
      var $159=$totalsize;
      var $160=(($159+$158)|0);
      $totalsize=$160;
      var $161=$totalsize;
      var $162=$3;
      var $163=$4;
      var $164=(($162*$163)|0);
      var $165=((($164<<1))|0);
      var $166=(($161)>>>0) >= (($165)>>>0);
      if ($166) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $167
      __label__ = 22; break;
    case 20: // $168
      var $169=HEAPU32[(($size)>>2)];
      var $170=$169 >>> 8;
      var $171=(($170) & 255);
      var $172=$chnum;
      var $173=((($172<<1))|0);
      var $174=(($173+2)|0);
      var $175=$8;
      var $176=(($175+$174)|0);
      HEAP8[($176)]=$171;
      var $177=HEAP32[(($size)>>2)];
      var $178=(($177) & 255);
      var $179=$chnum;
      var $180=((($179<<1))|0);
      var $181=(($180+3)|0);
      var $182=$8;
      var $183=(($182+$181)|0);
      HEAP8[($183)]=$178;
      __label__ = 21; break;
    case 21: // $184
      var $185=$chnum;
      var $186=(($185+1)|0);
      $chnum=$186;
      __label__ = 15; break;
    case 22: // $187
      var $188=$chnum;
      var $189=$3;
      var $190=(($188)|0) < (($189)|0);
      if ($190) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $191
      var $192=$7;
      var $193=$2;
      var $194=(($193+12)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=$3;
      var $197=$4;
      var $198=(($196*$197)|0);
      var $199=((($198<<1))|0);
      assert($199 % 1 === 0, 'memcpy given ' + $199 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($192, $195, $199, 1);
      var $200=$4;
      var $201=((($200<<1))|0);
      HEAP32[(($size)>>2)]=$201;
      var $202=$8;
      var $203=(($202+1)|0);
      HEAP8[($203)]=0;
      var $204=$8;
      var $205=(($204)|0);
      HEAP8[($205)]=0;
      $chnum=0;
      __label__ = 24; break;
    case 24: // $206
      var $207=$chnum;
      var $208=$3;
      var $209=(($207)|0) < (($208)|0);
      if ($209) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $210
      var $211=HEAPU32[(($size)>>2)];
      var $212=$211 >>> 8;
      var $213=(($212) & 255);
      var $214=$chnum;
      var $215=((($214<<1))|0);
      var $216=(($215+2)|0);
      var $217=$8;
      var $218=(($217+$216)|0);
      HEAP8[($218)]=$213;
      var $219=HEAP32[(($size)>>2)];
      var $220=(($219) & 255);
      var $221=$chnum;
      var $222=((($221<<1))|0);
      var $223=(($222+3)|0);
      var $224=$8;
      var $225=(($224+$223)|0);
      HEAP8[($225)]=$220;
      __label__ = 26; break;
    case 26: // $226
      var $227=$chnum;
      var $228=(($227+1)|0);
      $chnum=$228;
      __label__ = 24; break;
    case 27: // $229
      __label__ = 28; break;
    case 28: // $230
      $1=0;
      __label__ = 29; break;
    case 29: // $231
      var $232=$1;
      STACKTOP = __stackBase__;
      return $232;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12encode_audioP13_avcomp_stateiiPPKhiPhS4_["X"]=1;

function __ZL12encode_videoP13_avcomp_stateiiPKhjjPhPj($state, $width, $height, $source, $sstride, $sxor, $dest, $complength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  $1=$state;
  $2=$width;
  $3=$height;
  $4=$source;
  $5=$sstride;
  $6=$sxor;
  $7=$dest;
  $8=$complength;
  var $9=$1;
  var $10=$2;
  var $11=$3;
  var $12=$4;
  var $13=$5;
  var $14=$6;
  var $15=$7;
  var $16=$8;
  var $17=__ZL21encode_video_losslessP13_avcomp_stateiiPKhjjPhPj($9, $10, $11, $12, $13, $14, $15, $16);
  ;
  return $17;
}


function __Z18avcomp_decode_dataP13_avcomp_statePKhjPh($state, $source, $complength, $dest) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $metastart;
      var $videostart;
      var $audiostart=__stackBase__;
      var $metasize;
      var $channels;
      var $samples;
      var $width;
      var $height;
      var $audioxor;
      var $videoxor;
      var $videostride;
      var $srcoffs;
      var $totalsize;
      var $err;
      var $chnum;
      var $betest=__stackBase__+16;
      $2=$state;
      $3=$source;
      $4=$complength;
      $5=$dest;
      var $6=$4;
      var $7=(($6)>>>0) < 8;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $1=1;
      __label__ = 69; break;
    case 2: // $9
      var $10=$3;
      var $11=(($10)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      $metasize=$13;
      var $14=$3;
      var $15=(($14+1)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      $channels=$17;
      var $18=$3;
      var $19=(($18+2)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$21 << 8;
      var $23=$3;
      var $24=(($23+3)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=(($22+$26)|0);
      $samples=$27;
      var $28=$3;
      var $29=(($28+4)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $32=$31 << 8;
      var $33=$3;
      var $34=(($33+5)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=(($32+$36)|0);
      $width=$37;
      var $38=$3;
      var $39=(($38+6)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$41 << 8;
      var $43=$3;
      var $44=(($43+7)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=(($42+$46)|0);
      $height=$47;
      var $48=$width;
      var $49=$2;
      var $50=(($49)|0);
      var $51=HEAPU32[(($50)>>2)];
      var $52=(($48)>>>0) > (($51)>>>0);
      if ($52) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $53
      var $54=$height;
      var $55=$2;
      var $56=(($55+4)|0);
      var $57=HEAPU32[(($56)>>2)];
      var $58=(($54)>>>0) > (($57)>>>0);
      if ($58) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $59
      $1=2;
      __label__ = 69; break;
    case 5: // $60
      var $61=$channels;
      var $62=$2;
      var $63=(($62+8)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=(($61)>>>0) > (($64)>>>0);
      if ($65) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $66
      $1=3;
      __label__ = 69; break;
    case 7: // $67
      var $68=$4;
      var $69=$channels;
      var $70=((($69<<1))|0);
      var $71=(($70+10)|0);
      var $72=(($68)>>>0) < (($71)>>>0);
      if ($72) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $73
      $1=1;
      __label__ = 69; break;
    case 9: // $74
      var $75=$channels;
      var $76=((($75<<1))|0);
      var $77=(($76+10)|0);
      $totalsize=$77;
      var $78=$3;
      var $79=(($78+8)|0);
      var $80=HEAPU8[($79)];
      var $81=(($80)&255);
      var $82=$81 << 8;
      var $83=$3;
      var $84=(($83+9)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$82 | $86;
      var $88=$totalsize;
      var $89=(($88+$87)|0);
      $totalsize=$89;
      $chnum=0;
      __label__ = 10; break;
    case 10: // $90
      var $91=$chnum;
      var $92=$channels;
      var $93=(($91)>>>0) < (($92)>>>0);
      if ($93) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $94
      var $95=$chnum;
      var $96=((($95<<1))|0);
      var $97=(($96+10)|0);
      var $98=$3;
      var $99=(($98+$97)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=$101 << 8;
      var $103=$chnum;
      var $104=((($103<<1))|0);
      var $105=(($104+11)|0);
      var $106=$3;
      var $107=(($106+$105)|0);
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      var $110=$102 | $109;
      var $111=$totalsize;
      var $112=(($111+$110)|0);
      $totalsize=$112;
      __label__ = 12; break;
    case 12: // $113
      var $114=$chnum;
      var $115=(($114+1)|0);
      $chnum=$115;
      __label__ = 10; break;
    case 13: // $116
      var $117=$totalsize;
      var $118=$4;
      var $119=(($117)>>>0) >= (($118)>>>0);
      if ($119) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $120
      $1=1;
      __label__ = 69; break;
    case 15: // $121
      var $122=$channels;
      var $123=((($122<<1))|0);
      var $124=(($123+10)|0);
      $srcoffs=$124;
      var $125=$5;
      var $126=(($125)|0)!=0;
      if ($126) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $127
      var $128=$5;
      var $129=(($128)|0);
      HEAP8[($129)]=99;
      var $130=$5;
      var $131=(($130+1)|0);
      HEAP8[($131)]=104;
      var $132=$5;
      var $133=(($132+2)|0);
      HEAP8[($133)]=97;
      var $134=$5;
      var $135=(($134+3)|0);
      HEAP8[($135)]=118;
      var $136=$metasize;
      var $137=(($136) & 255);
      var $138=$5;
      var $139=(($138+4)|0);
      HEAP8[($139)]=$137;
      var $140=$channels;
      var $141=(($140) & 255);
      var $142=$5;
      var $143=(($142+5)|0);
      HEAP8[($143)]=$141;
      var $144=$samples;
      var $145=$144 >>> 8;
      var $146=(($145) & 255);
      var $147=$5;
      var $148=(($147+6)|0);
      HEAP8[($148)]=$146;
      var $149=$samples;
      var $150=(($149) & 255);
      var $151=$5;
      var $152=(($151+7)|0);
      HEAP8[($152)]=$150;
      var $153=$width;
      var $154=$153 >>> 8;
      var $155=(($154) & 255);
      var $156=$5;
      var $157=(($156+8)|0);
      HEAP8[($157)]=$155;
      var $158=$width;
      var $159=(($158) & 255);
      var $160=$5;
      var $161=(($160+9)|0);
      HEAP8[($161)]=$159;
      var $162=$height;
      var $163=$162 >>> 8;
      var $164=(($163) & 255);
      var $165=$5;
      var $166=(($165+10)|0);
      HEAP8[($166)]=$164;
      var $167=$height;
      var $168=(($167) & 255);
      var $169=$5;
      var $170=(($169+11)|0);
      HEAP8[($170)]=$168;
      var $171=$5;
      var $172=(($171+12)|0);
      $5=$172;
      var $173=$5;
      $metastart=$173;
      var $174=$metasize;
      var $175=$5;
      var $176=(($175+$174)|0);
      $5=$176;
      $chnum=0;
      __label__ = 17; break;
    case 17: // $177
      var $178=$chnum;
      var $179=$channels;
      var $180=(($178)>>>0) < (($179)>>>0);
      if ($180) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 18: // $181
      var $182=$5;
      var $183=$chnum;
      var $184=(($audiostart+($183<<2))|0);
      HEAP32[(($184)>>2)]=$182;
      var $185=$samples;
      var $186=((($185<<1))|0);
      var $187=$5;
      var $188=(($187+$186)|0);
      $5=$188;
      __label__ = 19; break;
    case 19: // $189
      var $190=$chnum;
      var $191=(($190+1)|0);
      $chnum=$191;
      __label__ = 17; break;
    case 20: // $192
      var $193=$5;
      $videostart=$193;
      $videoxor=0;
      $audioxor=0;
      var $194=$width;
      var $195=((($194<<1))|0);
      $videostride=$195;
      __label__ = 50; break;
    case 21: // $196
      HEAP16[(($betest)>>1)]=0;
      var $197=$2;
      var $198=(($197+120)|0);
      var $199=(($198+84)|0);
      var $200=HEAP32[(($199)>>2)];
      $metastart=$200;
      $chnum=0;
      __label__ = 22; break;
    case 22: // $201
      var $202=$chnum;
      var $203=$channels;
      var $204=(($202)>>>0) < (($203)>>>0);
      if ($204) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $205
      var $206=$chnum;
      var $207=$2;
      var $208=(($207+120)|0);
      var $209=(($208+12)|0);
      var $210=(($209+($206<<2))|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=$211;
      var $213=$chnum;
      var $214=(($audiostart+($213<<2))|0);
      HEAP32[(($214)>>2)]=$212;
      __label__ = 24; break;
    case 24: // $215
      var $216=$chnum;
      var $217=(($216+1)|0);
      $chnum=$217;
      __label__ = 22; break;
    case 25: // $218
      var $219=$2;
      var $220=(($219+120)|0);
      var $221=(($220)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($222)|0)!=0;
      if ($223) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $224
      var $225=$2;
      var $226=(($225+120)|0);
      var $227=(($226)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$228;
      var $230=(($229+4)|0);
      var $231=HEAP32[(($230)>>2)];
      var $234 = $231;__label__ = 28; break;
    case 27: // $232
      var $234 = 0;__label__ = 28; break;
    case 28: // $233
      var $234;
      $videostart=$234;
      var $235=$2;
      var $236=(($235+120)|0);
      var $237=(($236)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($238)|0)!=0;
      if ($239) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $240
      var $241=$2;
      var $242=(($241+120)|0);
      var $243=(($242)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$244;
      var $246=(($245+8)|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=((($247<<1))|0);
      var $251 = $248;__label__ = 31; break;
    case 30: // $249
      var $251 = 0;__label__ = 31; break;
    case 31: // $250
      var $251;
      $videostride=$251;
      var $252=$betest;
      HEAP8[($252)]=1;
      var $253=HEAPU16[(($betest)>>1)];
      var $254=(($253)&65535);
      var $255=(($254)|0)==1;
      var $256=$255 ? 1 : 0;
      $videoxor=$256;
      $audioxor=$256;
      var $257=$2;
      var $258=(($257+120)|0);
      var $259=(($258)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=(($260)|0)!=0;
      if ($261) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $262
      var $263=$2;
      var $264=(($263+120)|0);
      var $265=(($264)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=$266;
      var $268=(($267+12)|0);
      var $269=HEAPU32[(($268)>>2)];
      var $270=$width;
      var $271=(($269)>>>0) < (($270)>>>0);
      if ($271) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $272
      var $273=$2;
      var $274=(($273+120)|0);
      var $275=(($274)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$276;
      var $278=(($277+16)|0);
      var $279=HEAPU32[(($278)>>2)];
      var $280=$height;
      var $281=(($279)>>>0) < (($280)>>>0);
      if ($281) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $282
      $1=2;
      __label__ = 69; break;
    case 35: // $283
      $chnum=0;
      __label__ = 36; break;
    case 36: // $284
      var $285=$chnum;
      var $286=$channels;
      var $287=(($285)>>>0) < (($286)>>>0);
      if ($287) { __label__ = 37; break; } else { __label__ = 42; break; }
    case 37: // $288
      var $289=$chnum;
      var $290=$2;
      var $291=(($290+120)|0);
      var $292=(($291+12)|0);
      var $293=(($292+($289<<2))|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294)|0)!=0;
      if ($295) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $296
      var $297=$2;
      var $298=(($297+120)|0);
      var $299=(($298+4)|0);
      var $300=HEAPU32[(($299)>>2)];
      var $301=$samples;
      var $302=(($300)>>>0) < (($301)>>>0);
      if ($302) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $303
      $1=3;
      __label__ = 69; break;
    case 40: // $304
      __label__ = 41; break;
    case 41: // $305
      var $306=$chnum;
      var $307=(($306+1)|0);
      $chnum=$307;
      __label__ = 36; break;
    case 42: // $308
      var $309=$2;
      var $310=(($309+120)|0);
      var $311=(($310+84)|0);
      var $312=HEAP32[(($311)>>2)];
      var $313=(($312)|0)!=0;
      if ($313) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $314
      var $315=$2;
      var $316=(($315+120)|0);
      var $317=(($316+76)|0);
      var $318=HEAPU32[(($317)>>2)];
      var $319=$metasize;
      var $320=(($318)>>>0) < (($319)>>>0);
      if ($320) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $321
      $1=4;
      __label__ = 69; break;
    case 45: // $322
      var $323=$2;
      var $324=(($323+120)|0);
      var $325=(($324+8)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=(($326)|0)!=0;
      if ($327) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $328
      var $329=$samples;
      var $330=$2;
      var $331=(($330+120)|0);
      var $332=(($331+8)|0);
      var $333=HEAP32[(($332)>>2)];
      HEAP32[(($333)>>2)]=$329;
      __label__ = 47; break;
    case 47: // $334
      var $335=$2;
      var $336=(($335+120)|0);
      var $337=(($336+80)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=(($338)|0)!=0;
      if ($339) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $340
      var $341=$metasize;
      var $342=$2;
      var $343=(($342+120)|0);
      var $344=(($343+80)|0);
      var $345=HEAP32[(($344)>>2)];
      HEAP32[(($345)>>2)]=$341;
      __label__ = 49; break;
    case 49: // $346
      __label__ = 50; break;
    case 50: // $347
      var $348=$metasize;
      var $349=(($348)>>>0) > 0;
      if ($349) { __label__ = 51; break; } else { __label__ = 54; break; }
    case 51: // $350
      var $351=$metastart;
      var $352=(($351)|0)!=0;
      if ($352) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $353
      var $354=$metastart;
      var $355=$3;
      var $356=$srcoffs;
      var $357=(($355+$356)|0);
      var $358=$metasize;
      assert($358 % 1 === 0, 'memcpy given ' + $358 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($354, $357, $358, 1);
      __label__ = 53; break;
    case 53: // $359
      var $360=$metasize;
      var $361=$srcoffs;
      var $362=(($361+$360)|0);
      $srcoffs=$362;
      __label__ = 54; break;
    case 54: // $363
      var $364=$channels;
      var $365=(($364)>>>0) > 0;
      if ($365) { __label__ = 55; break; } else { __label__ = 62; break; }
    case 55: // $366
      var $367=$2;
      var $368=$channels;
      var $369=$samples;
      var $370=$3;
      var $371=$srcoffs;
      var $372=(($370+$371)|0);
      var $373=(($audiostart)|0);
      var $374=$audioxor;
      var $375=$3;
      var $376=(($375+8)|0);
      var $377=__ZL12decode_audioP13_avcomp_stateiiPKhPPhjS2_($367, $368, $369, $372, $373, $374, $376);
      $err=$377;
      var $378=$err;
      var $379=(($378)|0)!=0;
      if ($379) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $380
      var $381=$err;
      $1=$381;
      __label__ = 69; break;
    case 57: // $382
      var $383=$3;
      var $384=(($383+8)|0);
      var $385=HEAPU8[($384)];
      var $386=(($385)&255);
      var $387=$386 << 8;
      var $388=$3;
      var $389=(($388+9)|0);
      var $390=HEAPU8[($389)];
      var $391=(($390)&255);
      var $392=(($387+$391)|0);
      var $393=$srcoffs;
      var $394=(($393+$392)|0);
      $srcoffs=$394;
      $chnum=0;
      __label__ = 58; break;
    case 58: // $395
      var $396=$chnum;
      var $397=$channels;
      var $398=(($396)>>>0) < (($397)>>>0);
      if ($398) { __label__ = 59; break; } else { __label__ = 61; break; }
    case 59: // $399
      var $400=$chnum;
      var $401=((($400<<1))|0);
      var $402=(($401+10)|0);
      var $403=$3;
      var $404=(($403+$402)|0);
      var $405=HEAPU8[($404)];
      var $406=(($405)&255);
      var $407=$406 << 8;
      var $408=$chnum;
      var $409=((($408<<1))|0);
      var $410=(($409+11)|0);
      var $411=$3;
      var $412=(($411+$410)|0);
      var $413=HEAPU8[($412)];
      var $414=(($413)&255);
      var $415=(($407+$414)|0);
      var $416=$srcoffs;
      var $417=(($416+$415)|0);
      $srcoffs=$417;
      __label__ = 60; break;
    case 60: // $418
      var $419=$chnum;
      var $420=(($419+1)|0);
      $chnum=$420;
      __label__ = 58; break;
    case 61: // $421
      __label__ = 62; break;
    case 62: // $422
      var $423=$width;
      var $424=(($423)>>>0) > 0;
      if ($424) { __label__ = 63; break; } else { __label__ = 68; break; }
    case 63: // $425
      var $426=$height;
      var $427=(($426)>>>0) > 0;
      if ($427) { __label__ = 64; break; } else { __label__ = 68; break; }
    case 64: // $428
      var $429=$videostart;
      var $430=(($429)|0)!=0;
      if ($430) { __label__ = 65; break; } else { __label__ = 68; break; }
    case 65: // $431
      var $432=$2;
      var $433=$width;
      var $434=$height;
      var $435=$3;
      var $436=$srcoffs;
      var $437=(($435+$436)|0);
      var $438=$4;
      var $439=$srcoffs;
      var $440=(($438-$439)|0);
      var $441=$videostart;
      var $442=$videostride;
      var $443=$videoxor;
      var $444=__ZL12decode_videoP13_avcomp_stateiiPKhjPhjj($432, $433, $434, $437, $440, $441, $442, $443);
      $err=$444;
      var $445=$err;
      var $446=(($445)|0)!=0;
      if ($446) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $447
      var $448=$err;
      $1=$448;
      __label__ = 69; break;
    case 67: // $449
      __label__ = 68; break;
    case 68: // $450
      $1=0;
      __label__ = 69; break;
    case 69: // $451
      var $452=$1;
      STACKTOP = __stackBase__;
      return $452;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z18avcomp_decode_dataP13_avcomp_statePKhjPh["X"]=1;

function __ZL12decode_audioP13_avcomp_stateiiPKhPPhjS2_($state, $channels, $samples, $source, $dest, $dxor, $sizes) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $contexts=__stackBase__;
      var $actsize=__stackBase__+8;
      var $huffsize;
      var $hufferr;
      var $chnum;
      var $sampnum;
      var $size;
      var $curdest;
      var $prevsample;
      var $delta;
      var $newsample;
      var $deltabuf;
      var $deltabuf1;
      var $curdest2;
      var $prevsample3;
      var $delta4;
      var $newsample5;
      $2=$state;
      $3=$channels;
      $4=$samples;
      $5=$source;
      $6=$dest;
      $7=$dxor;
      $8=$sizes;
      var $9=$8;
      var $10=(($9)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$12 << 8;
      var $14=$8;
      var $15=(($14+1)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$13 | $17;
      var $19=(($18) & 65535);
      $size=$19;
      var $20=$size;
      var $21=(($20)&65535);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $23
      $chnum=0;
      __label__ = 2; break;
    case 2: // $24
      var $25=$chnum;
      var $26=$3;
      var $27=(($25)|0) < (($26)|0);
      if ($27) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $28
      var $29=$chnum;
      var $30=$6;
      var $31=(($30+($29<<2))|0);
      var $32=HEAP32[(($31)>>2)];
      $curdest=$32;
      var $33=$chnum;
      var $34=((($33<<1))|0);
      var $35=(($34+2)|0);
      var $36=$8;
      var $37=(($36+$35)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$39 << 8;
      var $41=$chnum;
      var $42=((($41<<1))|0);
      var $43=(($42+3)|0);
      var $44=$8;
      var $45=(($44+$43)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $48=$40 | $47;
      var $49=(($48) & 65535);
      $size=$49;
      var $50=$chnum;
      var $51=$6;
      var $52=(($51+($50<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0)!=0;
      if ($54) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $55
      $prevsample=0;
      $sampnum=0;
      __label__ = 5; break;
    case 5: // $56
      var $57=$sampnum;
      var $58=$4;
      var $59=(($57)|0) < (($58)|0);
      if ($59) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $60
      var $61=$5;
      var $62=(($61)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=$64 << 8;
      var $66=$5;
      var $67=(($66+1)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=$65 | $69;
      var $71=(($70) & 65535);
      $delta=$71;
      var $72=$prevsample;
      var $73=(($72 << 16) >> 16);
      var $74=$delta;
      var $75=(($74 << 16) >> 16);
      var $76=(($73+$75)|0);
      var $77=(($76) & 65535);
      $newsample=$77;
      var $78=$newsample;
      $prevsample=$78;
      var $79=$newsample;
      var $80=(($79 << 16) >> 16);
      var $81=$80 >> 8;
      var $82=(($81) & 255);
      var $83=$7;
      var $84=0 ^ $83;
      var $85=$curdest;
      var $86=(($85+$84)|0);
      HEAP8[($86)]=$82;
      var $87=$newsample;
      var $88=(($87) & 255);
      var $89=$7;
      var $90=1 ^ $89;
      var $91=$curdest;
      var $92=(($91+$90)|0);
      HEAP8[($92)]=$88;
      var $93=$5;
      var $94=(($93+2)|0);
      $5=$94;
      var $95=$curdest;
      var $96=(($95+2)|0);
      $curdest=$96;
      __label__ = 7; break;
    case 7: // $97
      var $98=$sampnum;
      var $99=(($98+1)|0);
      $sampnum=$99;
      __label__ = 5; break;
    case 8: // $100
      __label__ = 10; break;
    case 9: // $101
      var $102=$size;
      var $103=(($102)&65535);
      var $104=$5;
      var $105=(($104+$103)|0);
      $5=$105;
      __label__ = 10; break;
    case 10: // $106
      __label__ = 11; break;
    case 11: // $107
      var $108=$chnum;
      var $109=(($108+1)|0);
      $chnum=$109;
      __label__ = 2; break;
    case 12: // $110
      $1=0;
      __label__ = 39; break;
    case 13: // $111
      var $112=$2;
      var $113=(($112+28)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$5;
      var $116=$size;
      var $117=(($116)&65535);
      var $118=__Z19huffman_import_treeP16_huffman_contextPKhjPj($114, $115, $117, $actsize);
      $hufferr=$118;
      var $119=$hufferr;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $121
      $1=1;
      __label__ = 39; break;
    case 15: // $122
      var $123=HEAP32[(($actsize)>>2)];
      var $124=$5;
      var $125=(($124+$123)|0);
      $5=$125;
      var $126=HEAP32[(($actsize)>>2)];
      $huffsize=$126;
      var $127=$2;
      var $128=(($127+32)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$5;
      var $131=$size;
      var $132=(($131)&65535);
      var $133=__Z19huffman_import_treeP16_huffman_contextPKhjPj($129, $130, $132, $actsize);
      $hufferr=$133;
      var $134=$hufferr;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $136
      $1=1;
      __label__ = 39; break;
    case 17: // $137
      var $138=HEAP32[(($actsize)>>2)];
      var $139=$5;
      var $140=(($139+$138)|0);
      $5=$140;
      var $141=HEAP32[(($actsize)>>2)];
      var $142=$huffsize;
      var $143=(($142+$141)|0);
      $huffsize=$143;
      var $144=$huffsize;
      var $145=$size;
      var $146=(($145)&65535);
      var $147=(($144)|0)!=(($146)|0);
      if ($147) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $148
      $1=1;
      __label__ = 39; break;
    case 19: // $149
      var $150=$2;
      var $151=(($150+28)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($contexts)|0);
      HEAP32[(($153)>>2)]=$152;
      var $154=$2;
      var $155=(($154+32)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($contexts+4)|0);
      HEAP32[(($157)>>2)]=$156;
      $chnum=0;
      __label__ = 20; break;
    case 20: // $158
      var $159=$chnum;
      var $160=$3;
      var $161=(($159)|0) < (($160)|0);
      if ($161) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $162
      var $163=$chnum;
      var $164=((($163<<1))|0);
      var $165=(($164+2)|0);
      var $166=$8;
      var $167=(($166+$165)|0);
      var $168=HEAPU8[($167)];
      var $169=(($168)&255);
      var $170=$169 << 8;
      var $171=$chnum;
      var $172=((($171<<1))|0);
      var $173=(($172+3)|0);
      var $174=$8;
      var $175=(($174+$173)|0);
      var $176=HEAPU8[($175)];
      var $177=(($176)&255);
      var $178=$170 | $177;
      var $179=(($178) & 65535);
      $size=$179;
      var $180=$chnum;
      var $181=$6;
      var $182=(($181+($180<<2))|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $185
      var $186=$2;
      var $187=(($186+12)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$chnum;
      var $190=$4;
      var $191=(($189*$190)|0);
      var $192=((($191<<1))|0);
      var $193=(($188+$192)|0);
      $deltabuf=$193;
      var $194=(($contexts)|0);
      var $195=$5;
      var $196=$size;
      var $197=(($196)&65535);
      var $198=$deltabuf;
      var $199=$4;
      var $200=((($199<<1))|0);
      var $201=__Z31huffman_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj(2, $194, $195, $197, $198, $200, 1, 0, 0, $actsize);
      $hufferr=$201;
      var $202=$hufferr;
      var $203=(($202)|0)!=0;
      if ($203) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $204
      var $205=HEAP32[(($actsize)>>2)];
      var $206=$size;
      var $207=(($206)&65535);
      var $208=(($205)|0)!=(($207)|0);
      if ($208) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $209
      $1=1;
      __label__ = 39; break;
    case 25: // $210
      __label__ = 26; break;
    case 26: // $211
      var $212=$size;
      var $213=(($212)&65535);
      var $214=$5;
      var $215=(($214+$213)|0);
      $5=$215;
      __label__ = 27; break;
    case 27: // $216
      var $217=$chnum;
      var $218=(($217+1)|0);
      $chnum=$218;
      __label__ = 20; break;
    case 28: // $219
      $chnum=0;
      __label__ = 29; break;
    case 29: // $220
      var $221=$chnum;
      var $222=$3;
      var $223=(($221)|0) < (($222)|0);
      if ($223) { __label__ = 30; break; } else { __label__ = 38; break; }
    case 30: // $224
      var $225=$chnum;
      var $226=$6;
      var $227=(($226+($225<<2))|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=(($228)|0)!=0;
      if ($229) { __label__ = 31; break; } else { __label__ = 36; break; }
    case 31: // $230
      var $231=$2;
      var $232=(($231+12)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$chnum;
      var $235=$4;
      var $236=(($234*$235)|0);
      var $237=((($236<<1))|0);
      var $238=(($233+$237)|0);
      $deltabuf1=$238;
      var $239=$chnum;
      var $240=$6;
      var $241=(($240+($239<<2))|0);
      var $242=HEAP32[(($241)>>2)];
      $curdest2=$242;
      $prevsample3=0;
      $sampnum=0;
      __label__ = 32; break;
    case 32: // $243
      var $244=$sampnum;
      var $245=$4;
      var $246=(($244)|0) < (($245)|0);
      if ($246) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $247
      var $248=$deltabuf1;
      var $249=(($248)|0);
      var $250=HEAPU8[($249)];
      var $251=(($250)&255);
      var $252=$251 << 8;
      var $253=$deltabuf1;
      var $254=(($253+1)|0);
      var $255=HEAPU8[($254)];
      var $256=(($255)&255);
      var $257=$252 | $256;
      var $258=(($257) & 65535);
      $delta4=$258;
      var $259=$prevsample3;
      var $260=(($259 << 16) >> 16);
      var $261=$delta4;
      var $262=(($261 << 16) >> 16);
      var $263=(($260+$262)|0);
      var $264=(($263) & 65535);
      $newsample5=$264;
      var $265=$newsample5;
      $prevsample3=$265;
      var $266=$newsample5;
      var $267=(($266 << 16) >> 16);
      var $268=$267 >> 8;
      var $269=(($268) & 255);
      var $270=$7;
      var $271=0 ^ $270;
      var $272=$curdest2;
      var $273=(($272+$271)|0);
      HEAP8[($273)]=$269;
      var $274=$newsample5;
      var $275=(($274) & 255);
      var $276=$7;
      var $277=1 ^ $276;
      var $278=$curdest2;
      var $279=(($278+$277)|0);
      HEAP8[($279)]=$275;
      var $280=$deltabuf1;
      var $281=(($280+2)|0);
      $deltabuf1=$281;
      var $282=$curdest2;
      var $283=(($282+2)|0);
      $curdest2=$283;
      __label__ = 34; break;
    case 34: // $284
      var $285=$sampnum;
      var $286=(($285+1)|0);
      $sampnum=$286;
      __label__ = 32; break;
    case 35: // $287
      __label__ = 36; break;
    case 36: // $288
      __label__ = 37; break;
    case 37: // $289
      var $290=$chnum;
      var $291=(($290+1)|0);
      $chnum=$291;
      __label__ = 29; break;
    case 38: // $292
      $1=0;
      __label__ = 39; break;
    case 39: // $293
      var $294=$1;
      STACKTOP = __stackBase__;
      return $294;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12decode_audioP13_avcomp_stateiiPKhPPhjS2_["X"]=1;

function __ZL12decode_videoP13_avcomp_stateiiPKhjPhjj($state, $width, $height, $source, $complength, $dest, $dstride, $dxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      $2=$state;
      $3=$width;
      $4=$height;
      $5=$source;
      $6=$complength;
      $7=$dest;
      $8=$dstride;
      $9=$dxor;
      var $10=$5;
      var $11=(($10)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$13 & 128;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      var $21=$6;
      var $22=$7;
      var $23=$8;
      var $24=$9;
      var $25=__ZL21decode_video_losslessP13_avcomp_stateiiPKhjPhjj($17, $18, $19, $20, $21, $22, $23, $24);
      $1=$25;
      __label__ = 3; break;
    case 2: // $26
      $1=1;
      __label__ = 3; break;
    case 3: // $27
      var $28=$1;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21decode_video_losslessP13_avcomp_stateiiPKhjPhjj($state, $width, $height, $source, $complength, $dest, $deststride, $destxor) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $sourceend;
      var $contexts=__stackBase__;
      var $hufferr;
      var $actsize=__stackBase__+16;
      $2=$state;
      $3=$width;
      $4=$height;
      $5=$source;
      $6=$complength;
      $7=$dest;
      $8=$deststride;
      $9=$destxor;
      var $10=$5;
      var $11=$6;
      var $12=(($10+$11)|0);
      $sourceend=$12;
      var $13=$5;
      var $14=(($13+1)|0);
      $5=$14;
      var $15=$2;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$5;
      var $19=$sourceend;
      var $20=$5;
      var $21=$19;
      var $22=$20;
      var $23=(($21-$22)|0);
      var $24=__Z28huffman_deltarle_import_treeP16_huffman_contextPKhjPj($17, $18, $23, $actsize);
      $hufferr=$24;
      var $25=$hufferr;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      $1=1;
      __label__ = 11; break;
    case 2: // $28
      var $29=HEAP32[(($actsize)>>2)];
      var $30=$5;
      var $31=(($30+$29)|0);
      $5=$31;
      var $32=$2;
      var $33=(($32+20)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$5;
      var $36=$sourceend;
      var $37=$5;
      var $38=$36;
      var $39=$37;
      var $40=(($38-$39)|0);
      var $41=__Z28huffman_deltarle_import_treeP16_huffman_contextPKhjPj($34, $35, $40, $actsize);
      $hufferr=$41;
      var $42=$hufferr;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $44
      $1=1;
      __label__ = 11; break;
    case 4: // $45
      var $46=HEAP32[(($actsize)>>2)];
      var $47=$5;
      var $48=(($47+$46)|0);
      $5=$48;
      var $49=$2;
      var $50=(($49+24)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$5;
      var $53=$sourceend;
      var $54=$5;
      var $55=$53;
      var $56=$54;
      var $57=(($55-$56)|0);
      var $58=__Z28huffman_deltarle_import_treeP16_huffman_contextPKhjPj($51, $52, $57, $actsize);
      $hufferr=$58;
      var $59=$hufferr;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $61
      $1=1;
      __label__ = 11; break;
    case 6: // $62
      var $63=HEAP32[(($actsize)>>2)];
      var $64=$5;
      var $65=(($64+$63)|0);
      $5=$65;
      var $66=$2;
      var $67=(($66+16)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($contexts)|0);
      HEAP32[(($69)>>2)]=$68;
      var $70=$2;
      var $71=(($70+20)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($contexts+4)|0);
      HEAP32[(($73)>>2)]=$72;
      var $74=$2;
      var $75=(($74+16)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($contexts+8)|0);
      HEAP32[(($77)>>2)]=$76;
      var $78=$2;
      var $79=(($78+24)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($contexts+12)|0);
      HEAP32[(($81)>>2)]=$80;
      var $82=(($contexts)|0);
      var $83=$5;
      var $84=$sourceend;
      var $85=$5;
      var $86=$84;
      var $87=$85;
      var $88=(($86-$87)|0);
      var $89=$7;
      var $90=$3;
      var $91=((($90<<1))|0);
      var $92=$4;
      var $93=$8;
      var $94=$9;
      var $95=__Z40huffman_deltarle_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj(4, $82, $83, $88, $89, $91, $92, $93, $94, $actsize);
      $hufferr=$95;
      var $96=$hufferr;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $98
      $1=1;
      __label__ = 11; break;
    case 8: // $99
      var $100=HEAP32[(($actsize)>>2)];
      var $101=$sourceend;
      var $102=$5;
      var $103=$101;
      var $104=$102;
      var $105=(($103-$104)|0);
      var $106=(($100)|0)!=(($105)|0);
      if ($106) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $107
      $1=1;
      __label__ = 11; break;
    case 10: // $108
      $1=0;
      __label__ = 11; break;
    case 11: // $109
      var $110=$1;
      STACKTOP = __stackBase__;
      return $110;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21decode_video_losslessP13_avcomp_stateiiPKhjPhjj["X"]=1;

function __ZL21encode_video_losslessP13_avcomp_stateiiPKhjjPhPj($state, $width, $height, $source, $sstride, $sxor, $dest, $complength) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $srcbytes;
      var $contexts=__stackBase__;
      var $hufferr;
      var $outbytes=__stackBase__+16;
      var $output;
      $2=$state;
      $3=$width;
      $4=$height;
      $5=$source;
      $6=$sstride;
      $7=$sxor;
      $8=$dest;
      $9=$complength;
      var $10=$3;
      var $11=$4;
      var $12=(($10*$11)|0);
      var $13=((($12<<1))|0);
      $srcbytes=$13;
      var $14=$8;
      $output=$14;
      var $15=$output;
      var $16=(($15+1)|0);
      $output=$16;
      HEAP8[($15)]=-128;
      var $17=$2;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($contexts)|0);
      HEAP32[(($20)>>2)]=$19;
      var $21=$2;
      var $22=(($21+20)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($contexts+4)|0);
      HEAP32[(($24)>>2)]=$23;
      var $25=$2;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($contexts+8)|0);
      HEAP32[(($28)>>2)]=$27;
      var $29=$2;
      var $30=(($29+24)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($contexts+12)|0);
      HEAP32[(($32)>>2)]=$31;
      var $33=(($contexts)|0);
      var $34=$5;
      var $35=$3;
      var $36=((($35<<1))|0);
      var $37=$4;
      var $38=$6;
      var $39=$7;
      var $40=__Z41huffman_deltarle_compute_tree_interleavediPP16_huffman_contextPKhjjjj(4, $33, $34, $36, $37, $38, $39);
      $hufferr=$40;
      var $41=$hufferr;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $43
      $1=6;
      __label__ = 11; break;
    case 2: // $44
      var $45=$2;
      var $46=(($45+16)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$output;
      var $49=__Z28huffman_deltarle_export_treeP16_huffman_contextPhjPj($47, $48, 256, $outbytes);
      $hufferr=$49;
      var $50=$hufferr;
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $52
      $1=6;
      __label__ = 11; break;
    case 4: // $53
      var $54=HEAP32[(($outbytes)>>2)];
      var $55=$output;
      var $56=(($55+$54)|0);
      $output=$56;
      var $57=$2;
      var $58=(($57+20)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$output;
      var $61=__Z28huffman_deltarle_export_treeP16_huffman_contextPhjPj($59, $60, 256, $outbytes);
      $hufferr=$61;
      var $62=$hufferr;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $64
      $1=6;
      __label__ = 11; break;
    case 6: // $65
      var $66=HEAP32[(($outbytes)>>2)];
      var $67=$output;
      var $68=(($67+$66)|0);
      $output=$68;
      var $69=$2;
      var $70=(($69+24)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$output;
      var $73=__Z28huffman_deltarle_export_treeP16_huffman_contextPhjPj($71, $72, 256, $outbytes);
      $hufferr=$73;
      var $74=$hufferr;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $76
      $1=6;
      __label__ = 11; break;
    case 8: // $77
      var $78=HEAP32[(($outbytes)>>2)];
      var $79=$output;
      var $80=(($79+$78)|0);
      $output=$80;
      var $81=(($contexts)|0);
      var $82=$5;
      var $83=$3;
      var $84=((($83<<1))|0);
      var $85=$4;
      var $86=$6;
      var $87=$7;
      var $88=$output;
      var $89=$srcbytes;
      var $90=__Z40huffman_deltarle_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj(4, $81, $82, $84, $85, $86, $87, $88, $89, $outbytes);
      $hufferr=$90;
      var $91=$hufferr;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $93
      $1=6;
      __label__ = 11; break;
    case 10: // $94
      var $95=HEAP32[(($outbytes)>>2)];
      var $96=$output;
      var $97=(($96+$95)|0);
      $output=$97;
      var $98=$output;
      var $99=$8;
      var $100=$98;
      var $101=$99;
      var $102=(($100-$101)|0);
      var $103=$9;
      HEAP32[(($103)>>2)]=$102;
      $1=0;
      __label__ = 11; break;
    case 11: // $104
      var $105=$1;
      STACKTOP = __stackBase__;
      return $105;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21encode_video_losslessP13_avcomp_stateiiPKhjjPhPj["X"]=1;

function __Z22huffman_create_contextPP16_huffman_contexti($context, $maxbits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$context;
      $3=$maxbits;
      var $4=$3;
      var $5=(($4)|0) > 24;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=2;
      __label__ = 5; break;
    case 2: // $7
      var $8=_malloc(11980);
      var $9=$8;
      var $10=$2;
      HEAP32[(($10)>>2)]=$9;
      var $11=$2;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)==0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=1;
      __label__ = 5; break;
    case 4: // $15
      var $16=$2;
      var $17=HEAP32[(($16)>>2)];
      var $18=$17;
      _memset($18, 0, 11980, 1);
      var $19=$3;
      var $20=(($19) & 255);
      var $21=$2;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0);
      HEAP8[($23)]=$20;
      var $24=$2;
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+1)|0);
      HEAP8[($26)]=1;
      $1=0;
      __label__ = 5; break;
    case 5: // $27
      var $28=$1;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z20huffman_free_contextP16_huffman_context($context) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$context;
      var $2=$1;
      var $3=(($2+11976)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+11976)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$9;
      _free($10);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=$12;
      _free($13);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19huffman_import_treeP16_huffman_contextPKhjPj($context, $source, $slength, $actlength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$context;
  $2=$source;
  $3=$slength;
  $4=$actlength;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL11import_treeP16_huffman_contextPKhjPjj($5, $6, $7, $8, 256);
  ;
  return $9;
}


function __ZL11import_treeP16_huffman_contextPKhjPjj($context, $source, $slength, $actlength, $numcodes) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $error;
      var $bitbuf=__stackBase__;
      var $curnode;
      var $numbits;
      var $nodebits;
      var $repcount;
      $2=$context;
      $3=$source;
      $4=$slength;
      $5=$actlength;
      $6=$numcodes;
      var $7=$3;
      var $8=$4;
      __ZL20bit_buffer_read_initP11_bit_bufferPKhj($bitbuf, $7, $8);
      var $9=$2;
      var $10=(($9)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($12)|0) >= 16;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      $numbits=5;
      __label__ = 6; break;
    case 2: // $15
      var $16=$2;
      var $17=(($16)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=(($19)|0) >= 8;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      $numbits=4;
      __label__ = 5; break;
    case 4: // $22
      $numbits=3;
      __label__ = 5; break;
    case 5: // $23
      __label__ = 6; break;
    case 6: // $24
      $curnode=0;
      __label__ = 7; break;
    case 7: // $25
      var $26=$curnode;
      var $27=$6;
      var $28=(($26)>>>0) < (($27)>>>0);
      if ($28) { __label__ = 8; break; } else { __label__ = 18; break; }
    case 8: // $29
      var $30=$numbits;
      var $31=__ZL15bit_buffer_readP11_bit_bufferi($bitbuf, $30);
      $nodebits=$31;
      var $32=$nodebits;
      var $33=(($32)|0)!=1;
      if ($33) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $34
      var $35=$nodebits;
      var $36=(($35) & 255);
      var $37=$curnode;
      var $38=(($37+1)|0);
      $curnode=$38;
      var $39=$2;
      var $40=(($39+1096)|0);
      var $41=(($40+$37*20)|0);
      var $42=(($41+16)|0);
      HEAP8[($42)]=$36;
      __label__ = 17; break;
    case 10: // $43
      var $44=$numbits;
      var $45=__ZL15bit_buffer_readP11_bit_bufferi($bitbuf, $44);
      $nodebits=$45;
      var $46=$nodebits;
      var $47=(($46)|0)==1;
      if ($47) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $48
      var $49=$nodebits;
      var $50=(($49) & 255);
      var $51=$curnode;
      var $52=(($51+1)|0);
      $curnode=$52;
      var $53=$2;
      var $54=(($53+1096)|0);
      var $55=(($54+$51*20)|0);
      var $56=(($55+16)|0);
      HEAP8[($56)]=$50;
      __label__ = 16; break;
    case 12: // $57
      var $58=$numbits;
      var $59=__ZL15bit_buffer_readP11_bit_bufferi($bitbuf, $58);
      var $60=(($59+3)|0);
      $repcount=$60;
      __label__ = 13; break;
    case 13: // $61
      var $62=$repcount;
      var $63=(($62-1)|0);
      $repcount=$63;
      var $64=(($62)|0)!=0;
      if ($64) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $65
      var $66=$nodebits;
      var $67=(($66) & 255);
      var $68=$curnode;
      var $69=(($68+1)|0);
      $curnode=$69;
      var $70=$2;
      var $71=(($70+1096)|0);
      var $72=(($71+$68*20)|0);
      var $73=(($72+16)|0);
      HEAP8[($73)]=$67;
      __label__ = 13; break;
    case 15: // $74
      __label__ = 16; break;
    case 16: // $75
      __label__ = 17; break;
    case 17: // $76
      __label__ = 7; break;
    case 18: // $77
      var $78=$2;
      var $79=$6;
      var $80=__ZL22assign_canonical_codesP16_huffman_contextj($78, $79);
      $error=$80;
      var $81=$error;
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $83
      var $84=$error;
      $1=$84;
      __label__ = 23; break;
    case 20: // $85
      var $86=$curnode;
      var $87=$6;
      var $88=(($86)|0)!=(($87)|0);
      if ($88) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $89
      $1=3;
      __label__ = 23; break;
    case 22: // $90
      var $91=__ZL22bit_buffer_read_offsetP11_bit_buffer($bitbuf);
      var $92=$5;
      HEAP32[(($92)>>2)]=$91;
      var $93=(($bitbuf+20)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94)|0)!=0;
      var $96=$95 ? 4 : 0;
      $1=$96;
      __label__ = 23; break;
    case 23: // $97
      var $98=$1;
      STACKTOP = __stackBase__;
      return $98;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11import_treeP16_huffman_contextPKhjPjj["X"]=1;

function __Z19huffman_export_treeP16_huffman_contextPhjPj($context, $dest, $dlength, $actlength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$context;
  $2=$dest;
  $3=$dlength;
  $4=$actlength;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL11export_treeP16_huffman_contextPhjPjj($5, $6, $7, $8, 256);
  ;
  return $9;
}


function __ZL11export_treeP16_huffman_contextPhjPjj($context, $dest, $dlength, $actlength, $numcodes) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $bitbuf=__stackBase__;
      var $repcount;
      var $lastval;
      var $numbits;
      var $i;
      var $newval;
      $1=$context;
      $2=$dest;
      $3=$dlength;
      $4=$actlength;
      $5=$numcodes;
      var $6=$2;
      var $7=$3;
      __ZL21bit_buffer_write_initP11_bit_bufferPhj($bitbuf, $6, $7);
      var $8=$1;
      var $9=(($8)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=(($11)|0) >= 16;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $numbits=5;
      __label__ = 6; break;
    case 2: // $14
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($18)|0) >= 8;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      $numbits=4;
      __label__ = 5; break;
    case 4: // $21
      $numbits=3;
      __label__ = 5; break;
    case 5: // $22
      __label__ = 6; break;
    case 6: // $23
      $lastval=-1;
      $repcount=0;
      $i=0;
      __label__ = 7; break;
    case 7: // $24
      var $25=$i;
      var $26=$5;
      var $27=(($25)>>>0) < (($26)>>>0);
      if ($27) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $28
      var $29=$i;
      var $30=$1;
      var $31=(($30+1096)|0);
      var $32=(($31+$29*20)|0);
      var $33=(($32+16)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      $newval=$35;
      var $36=$newval;
      var $37=$lastval;
      var $38=(($36)|0)==(($37)|0);
      if ($38) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      var $40=$repcount;
      var $41=(($40+1)|0);
      $repcount=$41;
      __label__ = 13; break;
    case 10: // $42
      var $43=$repcount;
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $45
      var $46=$lastval;
      var $47=$repcount;
      var $48=$numbits;
      __ZL19write_rle_tree_bitsP11_bit_bufferiii($bitbuf, $46, $47, $48);
      __label__ = 12; break;
    case 12: // $49
      var $50=$newval;
      $lastval=$50;
      $repcount=1;
      __label__ = 13; break;
    case 13: // $51
      __label__ = 14; break;
    case 14: // $52
      var $53=$i;
      var $54=(($53+1)|0);
      $i=$54;
      __label__ = 7; break;
    case 15: // $55
      var $56=$lastval;
      var $57=$repcount;
      var $58=$numbits;
      __ZL19write_rle_tree_bitsP11_bit_bufferiii($bitbuf, $56, $57, $58);
      var $59=__ZL16bit_buffer_flushP11_bit_buffer($bitbuf);
      var $60=$4;
      HEAP32[(($60)>>2)]=$59;
      var $61=(($bitbuf+20)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      var $64=$63 ? 5 : 0;
      STACKTOP = __stackBase__;
      return $64;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11export_treeP16_huffman_contextPhjPjj["X"]=1;

function __Z28huffman_deltarle_import_treeP16_huffman_contextPKhjPj($context, $source, $slength, $actlength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$context;
  $2=$source;
  $3=$slength;
  $4=$actlength;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL11import_treeP16_huffman_contextPKhjPjj($5, $6, $7, $8, 272);
  ;
  return $9;
}


function __Z28huffman_deltarle_export_treeP16_huffman_contextPhjPj($context, $dest, $dlength, $actlength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$context;
  $2=$dest;
  $3=$dlength;
  $4=$actlength;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=__ZL11export_treeP16_huffman_contextPhjPjj($5, $6, $7, $8, 272);
  ;
  return $9;
}


function __Z32huffman_compute_tree_interleavediPP16_huffman_contextPKhjjjj($numcontexts, $contexts, $source, $swidth, $sheight, $sstride, $sxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $sx;
      var $sy;
      var $ctxnum;
      var $error;
      var $context;
      var $context1;
      var $context2;
      $2=$numcontexts;
      $3=$contexts;
      $4=$source;
      $5=$swidth;
      $6=$sheight;
      $7=$sstride;
      $8=$sxor;
      $ctxnum=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$ctxnum;
      var $11=$2;
      var $12=(($10)>>>0) < (($11)>>>0);
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$ctxnum;
      var $15=$3;
      var $16=(($15+($14<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      $context=$17;
      var $18=$context;
      var $19=(($18+4)|0);
      var $20=(($19)|0);
      var $21=$20;
      _memset($21, 0, 1088, 1);
      __label__ = 3; break;
    case 3: // $22
      var $23=$ctxnum;
      var $24=(($23+1)|0);
      $ctxnum=$24;
      __label__ = 1; break;
    case 4: // $25
      $sy=0;
      __label__ = 5; break;
    case 5: // $26
      var $27=$sy;
      var $28=$6;
      var $29=(($27)>>>0) < (($28)>>>0);
      if ($29) { __label__ = 6; break; } else { __label__ = 15; break; }
    case 6: // $30
      $sx=0;
      __label__ = 7; break;
    case 7: // $31
      var $32=$sx;
      var $33=$5;
      var $34=(($32)>>>0) < (($33)>>>0);
      if ($34) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $35
      $ctxnum=0;
      __label__ = 9; break;
    case 9: // $36
      var $37=$ctxnum;
      var $38=$2;
      var $39=(($37)>>>0) < (($38)>>>0);
      if ($39) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $40
      var $41=$ctxnum;
      var $42=$3;
      var $43=(($42+($41<<2))|0);
      var $44=HEAP32[(($43)>>2)];
      $context1=$44;
      var $45=$sx;
      var $46=$8;
      var $47=$45 ^ $46;
      var $48=$4;
      var $49=(($48+$47)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      var $52=$context1;
      var $53=(($52+4)|0);
      var $54=(($53+($51<<2))|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+1)|0);
      HEAP32[(($54)>>2)]=$56;
      __label__ = 11; break;
    case 11: // $57
      var $58=$ctxnum;
      var $59=(($58+1)|0);
      $ctxnum=$59;
      var $60=$sx;
      var $61=(($60+1)|0);
      $sx=$61;
      __label__ = 9; break;
    case 12: // $62
      __label__ = 7; break;
    case 13: // $63
      var $64=$7;
      var $65=$4;
      var $66=(($65+$64)|0);
      $4=$66;
      __label__ = 14; break;
    case 14: // $67
      var $68=$sy;
      var $69=(($68+1)|0);
      $sy=$69;
      __label__ = 5; break;
    case 15: // $70
      $ctxnum=0;
      __label__ = 16; break;
    case 16: // $71
      var $72=$ctxnum;
      var $73=$2;
      var $74=(($72)>>>0) < (($73)>>>0);
      if ($74) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $75
      var $76=$ctxnum;
      var $77=$3;
      var $78=(($77+($76<<2))|0);
      var $79=HEAP32[(($78)>>2)];
      $context2=$79;
      var $80=$context2;
      var $81=$context2;
      var $82=(($81+4)|0);
      var $83=(($82)|0);
      var $84=__ZL20compute_optimal_treeP16_huffman_contextPKjj($80, $83, 256);
      $error=$84;
      var $85=$error;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $87
      var $88=$error;
      $1=$88;
      __label__ = 22; break;
    case 19: // $89
      __label__ = 20; break;
    case 20: // $90
      var $91=$ctxnum;
      var $92=(($91+1)|0);
      $ctxnum=$92;
      __label__ = 16; break;
    case 21: // $93
      $1=0;
      __label__ = 22; break;
    case 22: // $94
      var $95=$1;
      ;
      return $95;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z32huffman_compute_tree_interleavediPP16_huffman_contextPKhjjjj["X"]=1;

function __ZL20compute_optimal_treeP16_huffman_contextPKjj($context, $datahisto, $numcodes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $lowerweight;
      var $upperweight;
      var $sdatacount;
      var $i;
      var $curweight;
      var $curmaxbits;
      $1=$context;
      $2=$datahisto;
      $3=$numcodes;
      $sdatacount=0;
      $i=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$i;
      var $6=$3;
      var $7=(($5)>>>0) < (($6)>>>0);
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$i;
      var $10=$2;
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$sdatacount;
      var $14=(($13+$12)|0);
      $sdatacount=$14;
      __label__ = 3; break;
    case 3: // $15
      var $16=$i;
      var $17=(($16+1)|0);
      $i=$17;
      __label__ = 1; break;
    case 4: // $18
      $lowerweight=0;
      var $19=$sdatacount;
      var $20=((($19<<1))|0);
      $upperweight=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$upperweight;
      var $23=$lowerweight;
      var $24=(($22+$23)|0);
      var $25=Math.floor((($24)>>>0)/2);
      $curweight=$25;
      var $26=$1;
      var $27=$2;
      var $28=$sdatacount;
      var $29=$curweight;
      var $30=$3;
      var $31=__ZL18huffman_build_treeP16_huffman_contextPKjjjj($26, $27, $28, $29, $30);
      $curmaxbits=$31;
      var $32=$curmaxbits;
      var $33=$1;
      var $34=(($33)|0);
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=(($32)|0) <= (($36)|0);
      if ($37) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $38
      var $39=$curweight;
      $lowerweight=$39;
      var $40=$curweight;
      var $41=$sdatacount;
      var $42=(($40)|0)==(($41)|0);
      if ($42) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $43
      var $44=$upperweight;
      var $45=$lowerweight;
      var $46=(($44-$45)|0);
      var $47=(($46)>>>0) <= 1;
      if ($47) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      __label__ = 12; break;
    case 9: // $49
      __label__ = 11; break;
    case 10: // $50
      var $51=$curweight;
      $upperweight=$51;
      __label__ = 11; break;
    case 11: // $52
      __label__ = 5; break;
    case 12: // $53
      var $54=$1;
      var $55=$3;
      var $56=__ZL22assign_canonical_codesP16_huffman_contextj($54, $55);
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20compute_optimal_treeP16_huffman_contextPKjj["X"]=1;

function __Z41huffman_deltarle_compute_tree_interleavediPP16_huffman_contextPKhjjjj($numcontexts, $contexts, $source, $swidth, $sheight, $sstride, $sxor) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $sx;
      var $sy;
      var $ctxnum;
      var $error;
      var $context;
      var $context1;
      var $context2;
      var $newdata;
      var $delta;
      var $zerocount;
      var $rlecode;
      var $scan;
      var $context3;
      $2=$numcontexts;
      $3=$contexts;
      $4=$source;
      $5=$swidth;
      $6=$sheight;
      $7=$sstride;
      $8=$sxor;
      $ctxnum=0;
      __label__ = 1; break;
    case 1: // $9
      var $10=$ctxnum;
      var $11=$2;
      var $12=(($10)>>>0) < (($11)>>>0);
      if ($12) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $13
      var $14=$ctxnum;
      var $15=$3;
      var $16=(($15+($14<<2))|0);
      var $17=HEAP32[(($16)>>2)];
      $context=$17;
      var $18=$context;
      var $19=(($18+4)|0);
      var $20=(($19)|0);
      var $21=$20;
      _memset($21, 0, 1088, 1);
      var $22=$context;
      var $23=(($22+2)|0);
      HEAP8[($23)]=0;
      __label__ = 3; break;
    case 3: // $24
      var $25=$ctxnum;
      var $26=(($25+1)|0);
      $ctxnum=$26;
      __label__ = 1; break;
    case 4: // $27
      $sy=0;
      __label__ = 5; break;
    case 5: // $28
      var $29=$sy;
      var $30=$6;
      var $31=(($29)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 6; break; } else { __label__ = 36; break; }
    case 6: // $32
      $ctxnum=0;
      __label__ = 7; break;
    case 7: // $33
      var $34=$ctxnum;
      var $35=$2;
      var $36=(($34)>>>0) < (($35)>>>0);
      if ($36) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $37
      var $38=$ctxnum;
      var $39=$3;
      var $40=(($39+($38<<2))|0);
      var $41=HEAP32[(($40)>>2)];
      $context1=$41;
      var $42=$context1;
      var $43=(($42+1092)|0);
      HEAP32[(($43)>>2)]=0;
      __label__ = 9; break;
    case 9: // $44
      var $45=$ctxnum;
      var $46=(($45+1)|0);
      $ctxnum=$46;
      __label__ = 7; break;
    case 10: // $47
      $sx=0;
      __label__ = 11; break;
    case 11: // $48
      var $49=$sx;
      var $50=$5;
      var $51=(($49)>>>0) < (($50)>>>0);
      if ($51) { __label__ = 12; break; } else { __label__ = 34; break; }
    case 12: // $52
      $ctxnum=0;
      __label__ = 13; break;
    case 13: // $53
      var $54=$ctxnum;
      var $55=$2;
      var $56=(($54)>>>0) < (($55)>>>0);
      if ($56) { __label__ = 14; break; } else { __label__ = 33; break; }
    case 14: // $57
      var $58=$ctxnum;
      var $59=$3;
      var $60=(($59+($58<<2))|0);
      var $61=HEAP32[(($60)>>2)];
      $context2=$61;
      var $62=$context2;
      var $63=(($62+1092)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $66
      var $67=$context2;
      var $68=(($67+1092)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69-1)|0);
      HEAP32[(($68)>>2)]=$70;
      __label__ = 32; break;
    case 16: // $71
      var $72=$sx;
      var $73=$8;
      var $74=$72 ^ $73;
      var $75=$4;
      var $76=(($75+$74)|0);
      var $77=HEAP8[($76)];
      $newdata=$77;
      var $78=$newdata;
      var $79=(($78)&255);
      var $80=$context2;
      var $81=(($80+2)|0);
      var $82=HEAPU8[($81)];
      var $83=(($82)&255);
      var $84=(($79-$83)|0);
      var $85=(($84) & 255);
      $delta=$85;
      var $86=$newdata;
      var $87=$context2;
      var $88=(($87+2)|0);
      HEAP8[($88)]=$86;
      var $89=$delta;
      var $90=(($89)&255);
      var $91=(($90)|0)==0;
      if ($91) { __label__ = 17; break; } else { __label__ = 30; break; }
    case 17: // $92
      $zerocount=1;
      var $93=$sx;
      var $94=(($93+1)|0);
      $scan=$94;
      __label__ = 18; break;
    case 18: // $95
      var $96=$scan;
      var $97=$5;
      var $98=(($96)>>>0) < (($97)>>>0);
      if ($98) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $99
      var $100=$scan;
      var $101=$2;
      var $102=(($100)>>>0)%(($101)>>>0);
      var $103=$3;
      var $104=(($103+($102<<2))|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$context2;
      var $107=(($105)|0)==(($106)|0);
      if ($107) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $108
      var $109=$newdata;
      var $110=(($109)&255);
      var $111=$scan;
      var $112=$8;
      var $113=$111 ^ $112;
      var $114=$4;
      var $115=(($114+$113)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=(($110)|0)==(($117)|0);
      if ($118) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $119
      var $120=$zerocount;
      var $121=(($120+1)|0);
      $zerocount=$121;
      __label__ = 23; break;
    case 22: // $122
      __label__ = 26; break;
    case 23: // $123
      __label__ = 24; break;
    case 24: // $124
      __label__ = 25; break;
    case 25: // $125
      var $126=$scan;
      var $127=(($126+1)|0);
      $scan=$127;
      __label__ = 18; break;
    case 26: // $128
      var $129=$scan;
      var $130=$5;
      var $131=(($129)>>>0) >= (($130)>>>0);
      if ($131) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $132
      var $133=$zerocount;
      var $134=(($133)|0) >= 8;
      if ($134) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $135
      $zerocount=100000;
      __label__ = 29; break;
    case 29: // $136
      var $137=$zerocount;
      var $138=__ZL16rlecount_to_codei($137);
      $rlecode=$138;
      var $139=$rlecode;
      var $140=$context2;
      var $141=(($140+4)|0);
      var $142=(($141+($139<<2))|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+1)|0);
      HEAP32[(($142)>>2)]=$144;
      var $145=$rlecode;
      var $146=__ZL16code_to_rlecounti($145);
      var $147=(($146-1)|0);
      var $148=$context2;
      var $149=(($148+1092)|0);
      HEAP32[(($149)>>2)]=$147;
      __label__ = 31; break;
    case 30: // $150
      var $151=$delta;
      var $152=(($151)&255);
      var $153=$context2;
      var $154=(($153+4)|0);
      var $155=(($154+($152<<2))|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($156+1)|0);
      HEAP32[(($155)>>2)]=$157;
      __label__ = 31; break;
    case 31: // $158
      __label__ = 32; break;
    case 32: // $159
      var $160=$ctxnum;
      var $161=(($160+1)|0);
      $ctxnum=$161;
      var $162=$sx;
      var $163=(($162+1)|0);
      $sx=$163;
      __label__ = 13; break;
    case 33: // $164
      __label__ = 11; break;
    case 34: // $165
      var $166=$7;
      var $167=$4;
      var $168=(($167+$166)|0);
      $4=$168;
      __label__ = 35; break;
    case 35: // $169
      var $170=$sy;
      var $171=(($170+1)|0);
      $sy=$171;
      __label__ = 5; break;
    case 36: // $172
      $ctxnum=0;
      __label__ = 37; break;
    case 37: // $173
      var $174=$ctxnum;
      var $175=$2;
      var $176=(($174)>>>0) < (($175)>>>0);
      if ($176) { __label__ = 38; break; } else { __label__ = 42; break; }
    case 38: // $177
      var $178=$ctxnum;
      var $179=$3;
      var $180=(($179+($178<<2))|0);
      var $181=HEAP32[(($180)>>2)];
      $context3=$181;
      var $182=$context3;
      var $183=$context3;
      var $184=(($183+4)|0);
      var $185=(($184)|0);
      var $186=__ZL20compute_optimal_treeP16_huffman_contextPKjj($182, $185, 272);
      $error=$186;
      var $187=$error;
      var $188=(($187)|0)!=0;
      if ($188) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $189
      var $190=$error;
      $1=$190;
      __label__ = 43; break;
    case 40: // $191
      __label__ = 41; break;
    case 41: // $192
      var $193=$ctxnum;
      var $194=(($193+1)|0);
      $ctxnum=$194;
      __label__ = 37; break;
    case 42: // $195
      $1=0;
      __label__ = 43; break;
    case 43: // $196
      var $197=$1;
      ;
      return $197;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z41huffman_deltarle_compute_tree_interleavediPP16_huffman_contextPKhjjjj["X"]=1;

function __ZL16rlecount_to_codei($rlecount) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$rlecount;
      var $3=$2;
      var $4=(($3)|0) >= 2048;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=271;
      __label__ = 19; break;
    case 2: // $6
      var $7=$2;
      var $8=(($7)|0) >= 1024;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      $1=270;
      __label__ = 19; break;
    case 4: // $10
      var $11=$2;
      var $12=(($11)|0) >= 512;
      if ($12) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $13
      $1=269;
      __label__ = 19; break;
    case 6: // $14
      var $15=$2;
      var $16=(($15)|0) >= 256;
      if ($16) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $17
      $1=268;
      __label__ = 19; break;
    case 8: // $18
      var $19=$2;
      var $20=(($19)|0) >= 128;
      if ($20) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $21
      $1=267;
      __label__ = 19; break;
    case 10: // $22
      var $23=$2;
      var $24=(($23)|0) >= 64;
      if ($24) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $25
      $1=266;
      __label__ = 19; break;
    case 12: // $26
      var $27=$2;
      var $28=(($27)|0) >= 32;
      if ($28) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $29
      $1=265;
      __label__ = 19; break;
    case 14: // $30
      var $31=$2;
      var $32=(($31)|0) >= 16;
      if ($32) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $33
      $1=264;
      __label__ = 19; break;
    case 16: // $34
      var $35=$2;
      var $36=(($35)|0) >= 8;
      if ($36) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $37
      var $38=$2;
      var $39=(($38-8)|0);
      var $40=(($39+256)|0);
      $1=$40;
      __label__ = 19; break;
    case 18: // $41
      $1=0;
      __label__ = 19; break;
    case 19: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16rlecount_to_codei["X"]=1;

function __ZL16code_to_rlecounti($code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$code;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=1;
      __label__ = 5; break;
    case 2: // $6
      var $7=$2;
      var $8=(($7)|0) <= 263;
      if ($8) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $9
      var $10=$2;
      var $11=(($10-256)|0);
      var $12=(($11+8)|0);
      $1=$12;
      __label__ = 5; break;
    case 4: // $13
      var $14=$2;
      var $15=(($14-264)|0);
      var $16=16 << $15;
      $1=$16;
      __label__ = 5; break;
    case 5: // $17
      var $18=$1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21bit_buffer_write_initP11_bit_bufferPhj($bitbuf, $data, $dlength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$bitbuf;
  $2=$data;
  $3=$dlength;
  var $4=$1;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=$1;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$2;
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$8;
  var $12=$1;
  var $13=(($12+12)|0);
  HEAP32[(($13)>>2)]=0;
  var $14=$3;
  var $15=$1;
  var $16=(($15+16)|0);
  HEAP32[(($16)>>2)]=$14;
  var $17=$1;
  var $18=(($17+20)|0);
  HEAP32[(($18)>>2)]=0;
  ;
  return;
}


function __ZL16bit_buffer_writeP11_bit_bufferji($bitbuf, $newbits, $numbits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$bitbuf;
      $2=$newbits;
      $3=$numbits;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$3;
      var $8=(($6+$7)|0);
      var $9=(($8)|0) > 32;
      if ($9) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $10
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0) >= 8;
      if ($15) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=HEAPU32[(($18)>>2)];
      var $20=$1;
      var $21=(($20+16)|0);
      var $22=HEAPU32[(($21)>>2)];
      var $23=(($19)>>>0) < (($22)>>>0);
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=$1;
      var $26=(($25)|0);
      var $27=HEAPU32[(($26)>>2)];
      var $28=$27 >>> 24;
      var $29=(($28) & 255);
      var $30=$1;
      var $31=(($30+12)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=(($33+8)|0);
      var $35=$34;
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+$32)|0);
      HEAP8[($37)]=$29;
      __label__ = 6; break;
    case 5: // $38
      var $39=$1;
      var $40=(($39+20)|0);
      HEAP32[(($40)>>2)]=1;
      __label__ = 6; break;
    case 6: // $41
      var $42=$1;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+1)|0);
      HEAP32[(($43)>>2)]=$45;
      var $46=$1;
      var $47=(($46)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$48 << 8;
      HEAP32[(($47)>>2)]=$49;
      var $50=$1;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52-8)|0);
      HEAP32[(($51)>>2)]=$53;
      __label__ = 2; break;
    case 7: // $54
      __label__ = 8; break;
    case 8: // $55
      var $56=$3;
      var $57=((32-$56)|0);
      var $58=$2;
      var $59=$58 << $57;
      $2=$59;
      var $60=$2;
      var $61=$1;
      var $62=(($61+4)|0);
      var $63=HEAPU32[(($62)>>2)];
      var $64=$60 >>> (($63)>>>0);
      var $65=$1;
      var $66=(($65)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$67 | $64;
      HEAP32[(($66)>>2)]=$68;
      var $69=$3;
      var $70=$1;
      var $71=(($70+4)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+$69)|0);
      HEAP32[(($71)>>2)]=$73;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16bit_buffer_writeP11_bit_bufferji["X"]=1;

function __ZL16bit_buffer_flushP11_bit_buffer($bitbuf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$bitbuf;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0) > 0;
      if ($6) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $7
      var $8=$1;
      var $9=(($8+12)|0);
      var $10=HEAPU32[(($9)>>2)];
      var $11=$1;
      var $12=(($11+16)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($10)>>>0) < (($13)>>>0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$1;
      var $17=(($16)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=$18 >>> 24;
      var $20=(($19) & 255);
      var $21=$1;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+8)|0);
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+$23)|0);
      HEAP8[($28)]=$20;
      __label__ = 5; break;
    case 4: // $29
      var $30=$1;
      var $31=(($30+20)|0);
      HEAP32[(($31)>>2)]=1;
      __label__ = 5; break;
    case 5: // $32
      var $33=$1;
      var $34=(($33+12)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+1)|0);
      HEAP32[(($34)>>2)]=$36;
      var $37=$1;
      var $38=(($37)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$39 << 8;
      HEAP32[(($38)>>2)]=$40;
      var $41=$1;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43-8)|0);
      HEAP32[(($42)>>2)]=$44;
      __label__ = 1; break;
    case 6: // $45
      var $46=$1;
      var $47=(($46+12)|0);
      var $48=HEAP32[(($47)>>2)];
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16bit_buffer_flushP11_bit_buffer["X"]=1;

function __ZL20bit_buffer_read_initP11_bit_bufferPKhj($bitbuf, $data, $dlength) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$bitbuf;
  $2=$data;
  $3=$dlength;
  var $4=$1;
  var $5=(($4)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=$1;
  var $7=(($6+4)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$2;
  var $9=$1;
  var $10=(($9+8)|0);
  var $11=$10;
  HEAP32[(($11)>>2)]=$8;
  var $12=$1;
  var $13=(($12+12)|0);
  HEAP32[(($13)>>2)]=0;
  var $14=$3;
  var $15=$1;
  var $16=(($15+16)|0);
  HEAP32[(($16)>>2)]=$14;
  var $17=$1;
  var $18=(($17+20)|0);
  HEAP32[(($18)>>2)]=0;
  ;
  return;
}


function __Z31huffman_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj($numcontexts, $contexts, $source, $swidth, $sheight, $sstride, $sxor, $dest, $dlength, $actlength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $sx;
      var $sy;
      var $ctxnum;
      var $bitbuf=__stackBase__;
      var $context;
      var $node;
      $1=$numcontexts;
      $2=$contexts;
      $3=$source;
      $4=$swidth;
      $5=$sheight;
      $6=$sstride;
      $7=$sxor;
      $8=$dest;
      $9=$dlength;
      $10=$actlength;
      var $11=$8;
      var $12=$9;
      __ZL21bit_buffer_write_initP11_bit_bufferPhj($bitbuf, $11, $12);
      $sy=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$sy;
      var $15=$5;
      var $16=(($14)>>>0) < (($15)>>>0);
      if ($16) { __label__ = 2; break; } else { __label__ = 11; break; }
    case 2: // $17
      $sx=0;
      __label__ = 3; break;
    case 3: // $18
      var $19=$sx;
      var $20=$4;
      var $21=(($19)>>>0) < (($20)>>>0);
      if ($21) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $22
      $ctxnum=0;
      __label__ = 5; break;
    case 5: // $23
      var $24=$ctxnum;
      var $25=$1;
      var $26=(($24)>>>0) < (($25)>>>0);
      if ($26) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $27
      var $28=$ctxnum;
      var $29=$2;
      var $30=(($29+($28<<2))|0);
      var $31=HEAP32[(($30)>>2)];
      $context=$31;
      var $32=$sx;
      var $33=$7;
      var $34=$32 ^ $33;
      var $35=$3;
      var $36=(($35+$34)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$context;
      var $40=(($39+1096)|0);
      var $41=(($40+$38*20)|0);
      $node=$41;
      var $42=$node;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$node;
      var $46=(($45+16)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      __ZL16bit_buffer_writeP11_bit_bufferji($bitbuf, $44, $48);
      __label__ = 7; break;
    case 7: // $49
      var $50=$ctxnum;
      var $51=(($50+1)|0);
      $ctxnum=$51;
      var $52=$sx;
      var $53=(($52+1)|0);
      $sx=$53;
      __label__ = 5; break;
    case 8: // $54
      __label__ = 3; break;
    case 9: // $55
      var $56=$6;
      var $57=$3;
      var $58=(($57+$56)|0);
      $3=$58;
      __label__ = 10; break;
    case 10: // $59
      var $60=$sy;
      var $61=(($60+1)|0);
      $sy=$61;
      __label__ = 1; break;
    case 11: // $62
      var $63=__ZL16bit_buffer_flushP11_bit_buffer($bitbuf);
      var $64=$10;
      HEAP32[(($64)>>2)]=$63;
      var $65=(($bitbuf+20)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)!=0;
      var $68=$67 ? 5 : 0;
      STACKTOP = __stackBase__;
      return $68;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z31huffman_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj["X"]=1;

function __Z40huffman_deltarle_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj($numcontexts, $contexts, $source, $swidth, $sheight, $sstride, $sxor, $dest, $dlength, $actlength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $sx;
      var $sy;
      var $ctxnum;
      var $bitbuf=__stackBase__;
      var $context;
      var $context1;
      var $context2;
      var $newdata;
      var $delta;
      var $node;
      var $zerocount;
      var $rlecode;
      var $scan;
      $1=$numcontexts;
      $2=$contexts;
      $3=$source;
      $4=$swidth;
      $5=$sheight;
      $6=$sstride;
      $7=$sxor;
      $8=$dest;
      $9=$dlength;
      $10=$actlength;
      var $11=$8;
      var $12=$9;
      __ZL21bit_buffer_write_initP11_bit_bufferPhj($bitbuf, $11, $12);
      $ctxnum=0;
      __label__ = 1; break;
    case 1: // $13
      var $14=$ctxnum;
      var $15=$1;
      var $16=(($14)>>>0) < (($15)>>>0);
      if ($16) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $17
      var $18=$ctxnum;
      var $19=$2;
      var $20=(($19+($18<<2))|0);
      var $21=HEAP32[(($20)>>2)];
      $context=$21;
      var $22=$context;
      var $23=(($22+2)|0);
      HEAP8[($23)]=0;
      __label__ = 3; break;
    case 3: // $24
      var $25=$ctxnum;
      var $26=(($25+1)|0);
      $ctxnum=$26;
      __label__ = 1; break;
    case 4: // $27
      $sy=0;
      __label__ = 5; break;
    case 5: // $28
      var $29=$sy;
      var $30=$5;
      var $31=(($29)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 6; break; } else { __label__ = 36; break; }
    case 6: // $32
      $ctxnum=0;
      __label__ = 7; break;
    case 7: // $33
      var $34=$ctxnum;
      var $35=$1;
      var $36=(($34)>>>0) < (($35)>>>0);
      if ($36) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $37
      var $38=$ctxnum;
      var $39=$2;
      var $40=(($39+($38<<2))|0);
      var $41=HEAP32[(($40)>>2)];
      $context1=$41;
      var $42=$context1;
      var $43=(($42+1092)|0);
      HEAP32[(($43)>>2)]=0;
      __label__ = 9; break;
    case 9: // $44
      var $45=$ctxnum;
      var $46=(($45+1)|0);
      $ctxnum=$46;
      __label__ = 7; break;
    case 10: // $47
      $sx=0;
      __label__ = 11; break;
    case 11: // $48
      var $49=$sx;
      var $50=$4;
      var $51=(($49)>>>0) < (($50)>>>0);
      if ($51) { __label__ = 12; break; } else { __label__ = 34; break; }
    case 12: // $52
      $ctxnum=0;
      __label__ = 13; break;
    case 13: // $53
      var $54=$ctxnum;
      var $55=$1;
      var $56=(($54)>>>0) < (($55)>>>0);
      if ($56) { __label__ = 14; break; } else { __label__ = 33; break; }
    case 14: // $57
      var $58=$ctxnum;
      var $59=$2;
      var $60=(($59+($58<<2))|0);
      var $61=HEAP32[(($60)>>2)];
      $context2=$61;
      var $62=$context2;
      var $63=(($62+1092)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $66
      var $67=$context2;
      var $68=(($67+1092)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69-1)|0);
      HEAP32[(($68)>>2)]=$70;
      __label__ = 32; break;
    case 16: // $71
      var $72=$sx;
      var $73=$7;
      var $74=$72 ^ $73;
      var $75=$3;
      var $76=(($75+$74)|0);
      var $77=HEAP8[($76)];
      $newdata=$77;
      var $78=$newdata;
      var $79=(($78)&255);
      var $80=$context2;
      var $81=(($80+2)|0);
      var $82=HEAPU8[($81)];
      var $83=(($82)&255);
      var $84=(($79-$83)|0);
      var $85=(($84) & 255);
      $delta=$85;
      var $86=$newdata;
      var $87=$context2;
      var $88=(($87+2)|0);
      HEAP8[($88)]=$86;
      var $89=$delta;
      var $90=(($89)&255);
      var $91=(($90)|0)==0;
      if ($91) { __label__ = 17; break; } else { __label__ = 30; break; }
    case 17: // $92
      $zerocount=1;
      var $93=$sx;
      var $94=(($93+1)|0);
      $scan=$94;
      __label__ = 18; break;
    case 18: // $95
      var $96=$scan;
      var $97=$4;
      var $98=(($96)>>>0) < (($97)>>>0);
      if ($98) { __label__ = 19; break; } else { __label__ = 26; break; }
    case 19: // $99
      var $100=$scan;
      var $101=$1;
      var $102=(($100)>>>0)%(($101)>>>0);
      var $103=$2;
      var $104=(($103+($102<<2))|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$context2;
      var $107=(($105)|0)==(($106)|0);
      if ($107) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $108
      var $109=$newdata;
      var $110=(($109)&255);
      var $111=$scan;
      var $112=$7;
      var $113=$111 ^ $112;
      var $114=$3;
      var $115=(($114+$113)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=(($110)|0)==(($117)|0);
      if ($118) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $119
      var $120=$zerocount;
      var $121=(($120+1)|0);
      $zerocount=$121;
      __label__ = 23; break;
    case 22: // $122
      __label__ = 26; break;
    case 23: // $123
      __label__ = 24; break;
    case 24: // $124
      __label__ = 25; break;
    case 25: // $125
      var $126=$scan;
      var $127=(($126+1)|0);
      $scan=$127;
      __label__ = 18; break;
    case 26: // $128
      var $129=$scan;
      var $130=$4;
      var $131=(($129)>>>0) >= (($130)>>>0);
      if ($131) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $132
      var $133=$zerocount;
      var $134=(($133)|0) >= 8;
      if ($134) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $135
      $zerocount=100000;
      __label__ = 29; break;
    case 29: // $136
      var $137=$zerocount;
      var $138=__ZL16rlecount_to_codei($137);
      $rlecode=$138;
      var $139=$rlecode;
      var $140=$context2;
      var $141=(($140+1096)|0);
      var $142=(($141+$139*20)|0);
      $node=$142;
      var $143=$node;
      var $144=(($143+12)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$node;
      var $147=(($146+16)|0);
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      __ZL16bit_buffer_writeP11_bit_bufferji($bitbuf, $145, $149);
      var $150=$rlecode;
      var $151=__ZL16code_to_rlecounti($150);
      var $152=(($151-1)|0);
      var $153=$context2;
      var $154=(($153+1092)|0);
      HEAP32[(($154)>>2)]=$152;
      __label__ = 31; break;
    case 30: // $155
      var $156=$delta;
      var $157=(($156)&255);
      var $158=$context2;
      var $159=(($158+1096)|0);
      var $160=(($159+$157*20)|0);
      $node=$160;
      var $161=$node;
      var $162=(($161+12)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$node;
      var $165=(($164+16)|0);
      var $166=HEAPU8[($165)];
      var $167=(($166)&255);
      __ZL16bit_buffer_writeP11_bit_bufferji($bitbuf, $163, $167);
      __label__ = 31; break;
    case 31: // $168
      __label__ = 32; break;
    case 32: // $169
      var $170=$ctxnum;
      var $171=(($170+1)|0);
      $ctxnum=$171;
      var $172=$sx;
      var $173=(($172+1)|0);
      $sx=$173;
      __label__ = 13; break;
    case 33: // $174
      __label__ = 11; break;
    case 34: // $175
      var $176=$6;
      var $177=$3;
      var $178=(($177+$176)|0);
      $3=$178;
      __label__ = 35; break;
    case 35: // $179
      var $180=$sy;
      var $181=(($180+1)|0);
      $sy=$181;
      __label__ = 5; break;
    case 36: // $182
      var $183=__ZL16bit_buffer_flushP11_bit_buffer($bitbuf);
      var $184=$10;
      HEAP32[(($184)>>2)]=$183;
      var $185=(($bitbuf+20)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($186)|0)!=0;
      var $188=$187 ? 5 : 0;
      STACKTOP = __stackBase__;
      return $188;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z40huffman_deltarle_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj["X"]=1;

function __ZL18build_lookup_tableP16_huffman_contextj($context, $numcodes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $i;
      var $node;
      var $dest;
      var $destend;
      var $shift;
      var $start;
      var $end;
      var $value;
      $2=$context;
      $3=$numcodes;
      var $4=$2;
      var $5=(($4+11976)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$2;
      var $10=(($9)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=1 << $12;
      var $14=((($13<<1))|0);
      var $15=_malloc($14);
      var $16=$15;
      var $17=$2;
      var $18=(($17+11976)|0);
      HEAP32[(($18)>>2)]=$16;
      __label__ = 2; break;
    case 2: // $19
      var $20=$2;
      var $21=(($20+11976)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      $1=1;
      __label__ = 14; break;
    case 4: // $25
      $i=0;
      __label__ = 5; break;
    case 5: // $26
      var $27=$i;
      var $28=$3;
      var $29=(($27)>>>0) < (($28)>>>0);
      if ($29) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $30
      var $31=$i;
      var $32=$2;
      var $33=(($32+1096)|0);
      var $34=(($33+$31*20)|0);
      $node=$34;
      var $35=$node;
      var $36=(($35+16)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=(($38)|0) > 0;
      if ($39) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $40
      var $41=$2;
      var $42=(($41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$node;
      var $46=(($45+16)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=(($44-$48)|0);
      $shift=$49;
      var $50=$node;
      var $51=(($50+12)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$shift;
      var $54=$52 << $53;
      $start=$54;
      var $55=$node;
      var $56=(($55+12)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+1)|0);
      var $59=$shift;
      var $60=$58 << $59;
      var $61=(($60-1)|0);
      $end=$61;
      var $62=$i;
      var $63=$62 << 6;
      var $64=$node;
      var $65=(($64+16)|0);
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$63 | $67;
      var $69=(($68) & 65535);
      $value=$69;
      var $70=$start;
      var $71=$2;
      var $72=(($71+11976)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+($70<<1))|0);
      $dest=$74;
      var $75=$end;
      var $76=$2;
      var $77=(($76+11976)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+($75<<1))|0);
      $destend=$79;
      __label__ = 8; break;
    case 8: // $80
      var $81=$dest;
      var $82=$destend;
      var $83=(($81)>>>0) <= (($82)>>>0);
      if ($83) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $84
      var $85=$value;
      var $86=$dest;
      var $87=(($86+2)|0);
      $dest=$87;
      HEAP16[(($86)>>1)]=$85;
      __label__ = 8; break;
    case 10: // $88
      __label__ = 11; break;
    case 11: // $89
      __label__ = 12; break;
    case 12: // $90
      var $91=$i;
      var $92=(($91+1)|0);
      $i=$92;
      __label__ = 5; break;
    case 13: // $93
      var $94=$2;
      var $95=(($94+1)|0);
      HEAP8[($95)]=0;
      $1=0;
      __label__ = 14; break;
    case 14: // $96
      var $97=$1;
      ;
      return $97;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18build_lookup_tableP16_huffman_contextj["X"]=1;

function __ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $numbits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$bitbuf;
      $2=$numbits;
      var $3=$2;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($3)|0) > (($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$1;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0) <= 24;
      if ($13) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $14
      var $15=$1;
      var $16=(($15+12)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+16)|0);
      var $20=HEAPU32[(($19)>>2)];
      var $21=(($17)>>>0) < (($20)>>>0);
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$1;
      var $27=(($26+8)|0);
      var $28=$27;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$25)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=$1;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=((24-$35)|0);
      var $37=$32 << $36;
      var $38=$1;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 | $37;
      HEAP32[(($39)>>2)]=$41;
      __label__ = 5; break;
    case 5: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+1)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$1;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+8)|0);
      HEAP32[(($48)>>2)]=$50;
      __label__ = 2; break;
    case 6: // $51
      var $52=$2;
      var $53=$1;
      var $54=(($53+4)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($52)|0) > (($55)|0);
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$1;
      var $59=(($58+20)|0);
      HEAP32[(($59)>>2)]=1;
      __label__ = 8; break;
    case 8: // $60
      __label__ = 9; break;
    case 9: // $61
      var $62=$1;
      var $63=(($62)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=$2;
      var $66=((32-$65)|0);
      var $67=$64 >>> (($66)>>>0);
      ;
      return $67;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15bit_buffer_peekP11_bit_bufferi["X"]=1;

function __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $numbits) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$bitbuf;
  $2=$numbits;
  var $3=$2;
  var $4=$1;
  var $5=(($4)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$6 << $3;
  HEAP32[(($5)>>2)]=$7;
  var $8=$2;
  var $9=$1;
  var $10=(($9+4)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=(($11-$8)|0);
  HEAP32[(($10)>>2)]=$12;
  ;
  return;
}


function __ZL22bit_buffer_read_offsetP11_bit_buffer($bitbuf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      var $bits;
      $1=$bitbuf;
      var $2=$1;
      var $3=(($2+12)|0);
      var $4=HEAP32[(($3)>>2)];
      $result=$4;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      $bits=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$bits;
      var $10=(($9)|0) >= 8;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$result;
      var $13=(($12-1)|0);
      $result=$13;
      var $14=$bits;
      var $15=(($14-8)|0);
      $bits=$15;
      __label__ = 1; break;
    case 3: // $16
      var $17=$result;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z31huffman_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj($numcontexts, $contexts, $source, $slength, $dest, $dwidth, $dheight, $dstride, $dxor, $actlength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $dx;
      var $dy;
      var $ctxnum;
      var $error;
      var $bitbuf=__stackBase__;
      var $context;
      var $context1;
      var $lookup;
      var $bits;
      $2=$numcontexts;
      $3=$contexts;
      $4=$source;
      $5=$slength;
      $6=$dest;
      $7=$dwidth;
      $8=$dheight;
      $9=$dstride;
      $10=$dxor;
      $11=$actlength;
      $ctxnum=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$ctxnum;
      var $14=$2;
      var $15=(($13)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$ctxnum;
      var $18=$3;
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      $context=$20;
      var $21=$context;
      var $22=(($21+1)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24)!=0;
      if ($24) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $25
      var $26=$context;
      var $27=__ZL18build_lookup_tableP16_huffman_contextj($26, 256);
      $error=$27;
      var $28=$error;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$error;
      $1=$31;
      __label__ = 20; break;
    case 5: // $32
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$ctxnum;
      var $36=(($35+1)|0);
      $ctxnum=$36;
      __label__ = 1; break;
    case 8: // $37
      var $38=$4;
      var $39=$5;
      __ZL20bit_buffer_read_initP11_bit_bufferPKhj($bitbuf, $38, $39);
      $dy=0;
      __label__ = 9; break;
    case 9: // $40
      var $41=$dy;
      var $42=$8;
      var $43=(($41)>>>0) < (($42)>>>0);
      if ($43) { __label__ = 10; break; } else { __label__ = 19; break; }
    case 10: // $44
      $dx=0;
      __label__ = 11; break;
    case 11: // $45
      var $46=$dx;
      var $47=$7;
      var $48=(($46)>>>0) < (($47)>>>0);
      if ($48) { __label__ = 12; break; } else { __label__ = 17; break; }
    case 12: // $49
      $ctxnum=0;
      __label__ = 13; break;
    case 13: // $50
      var $51=$ctxnum;
      var $52=$2;
      var $53=(($51)>>>0) < (($52)>>>0);
      if ($53) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $54
      var $55=$ctxnum;
      var $56=$3;
      var $57=(($56+($55<<2))|0);
      var $58=HEAP32[(($57)>>2)];
      $context1=$58;
      var $59=$context1;
      var $60=(($59)|0);
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=__ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $62);
      $bits=$63;
      var $64=$bits;
      var $65=$context1;
      var $66=(($65+11976)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+($64<<1))|0);
      var $69=HEAP16[(($68)>>1)];
      $lookup=$69;
      var $70=$lookup;
      var $71=(($70)&65535);
      var $72=$71 & 31;
      __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $72);
      var $73=$lookup;
      var $74=(($73)&65535);
      var $75=$74 >> 6;
      var $76=(($75) & 255);
      var $77=$dx;
      var $78=$10;
      var $79=$77 ^ $78;
      var $80=$6;
      var $81=(($80+$79)|0);
      HEAP8[($81)]=$76;
      __label__ = 15; break;
    case 15: // $82
      var $83=$ctxnum;
      var $84=(($83+1)|0);
      $ctxnum=$84;
      var $85=$dx;
      var $86=(($85+1)|0);
      $dx=$86;
      __label__ = 13; break;
    case 16: // $87
      __label__ = 11; break;
    case 17: // $88
      var $89=$9;
      var $90=$6;
      var $91=(($90+$89)|0);
      $6=$91;
      __label__ = 18; break;
    case 18: // $92
      var $93=$dy;
      var $94=(($93+1)|0);
      $dy=$94;
      __label__ = 9; break;
    case 19: // $95
      var $96=__ZL22bit_buffer_read_offsetP11_bit_buffer($bitbuf);
      var $97=$11;
      HEAP32[(($97)>>2)]=$96;
      var $98=(($bitbuf+20)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99)|0)!=0;
      var $101=$100 ? 4 : 0;
      $1=$101;
      __label__ = 20; break;
    case 20: // $102
      var $103=$1;
      STACKTOP = __stackBase__;
      return $103;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z31huffman_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj["X"]=1;

function __Z40huffman_deltarle_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj($numcontexts, $contexts, $source, $slength, $dest, $dwidth, $dheight, $dstride, $dxor, $actlength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $dx;
      var $dy;
      var $ctxnum;
      var $error;
      var $bitbuf=__stackBase__;
      var $context;
      var $context1;
      var $context2;
      var $lookup;
      var $bits;
      var $data;
      $2=$numcontexts;
      $3=$contexts;
      $4=$source;
      $5=$slength;
      $6=$dest;
      $7=$dwidth;
      $8=$dheight;
      $9=$dstride;
      $10=$dxor;
      $11=$actlength;
      var $12=$2;
      var $13=(($12)|0)==4;
      if ($13) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $14
      var $15=$3;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$3;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17)|0)==(($20)|0);
      if ($21) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $22
      var $23=$3;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$3;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($25)|0)!=(($28)|0);
      if ($29) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $30
      var $31=$3;
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$3;
      var $35=(($34+12)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($33)|0)!=(($36)|0);
      if ($37) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $38
      var $39=$3;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$3;
      var $46=(($45+4)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=(($44)|0)==(($50)|0);
      if ($51) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $52
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=$3;
      var $60=(($59+12)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0);
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=(($58)|0)==(($64)|0);
      if ($65) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $66
      var $67=$3;
      var $68=$4;
      var $69=$5;
      var $70=$6;
      var $71=$7;
      var $72=$8;
      var $73=$9;
      var $74=$10;
      var $75=$11;
      var $76=__ZL45huffman_deltarle_decode_data_interleaved_0102PP16_huffman_contextPKhjPhjjjjPj($67, $68, $69, $70, $71, $72, $73, $74, $75);
      $1=$76;
      __label__ = 36; break;
    case 7: // $77
      $ctxnum=0;
      __label__ = 8; break;
    case 8: // $78
      var $79=$ctxnum;
      var $80=$2;
      var $81=(($79)>>>0) < (($80)>>>0);
      if ($81) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $82
      var $83=$ctxnum;
      var $84=$3;
      var $85=(($84+($83<<2))|0);
      var $86=HEAP32[(($85)>>2)];
      $context=$86;
      var $87=$context;
      var $88=(($87+1)|0);
      var $89=HEAP8[($88)];
      var $90=(($89 << 24) >> 24)!=0;
      if ($90) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $91
      var $92=$context;
      var $93=__ZL18build_lookup_tableP16_huffman_contextj($92, 272);
      $error=$93;
      var $94=$error;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $96
      var $97=$error;
      $1=$97;
      __label__ = 36; break;
    case 12: // $98
      __label__ = 13; break;
    case 13: // $99
      var $100=$context;
      var $101=(($100+2)|0);
      HEAP8[($101)]=0;
      __label__ = 14; break;
    case 14: // $102
      var $103=$ctxnum;
      var $104=(($103+1)|0);
      $ctxnum=$104;
      __label__ = 8; break;
    case 15: // $105
      var $106=$4;
      var $107=$5;
      __ZL20bit_buffer_read_initP11_bit_bufferPKhj($bitbuf, $106, $107);
      $dy=0;
      __label__ = 16; break;
    case 16: // $108
      var $109=$dy;
      var $110=$8;
      var $111=(($109)>>>0) < (($110)>>>0);
      if ($111) { __label__ = 17; break; } else { __label__ = 35; break; }
    case 17: // $112
      $ctxnum=0;
      __label__ = 18; break;
    case 18: // $113
      var $114=$ctxnum;
      var $115=$2;
      var $116=(($114)>>>0) < (($115)>>>0);
      if ($116) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $117
      var $118=$ctxnum;
      var $119=$3;
      var $120=(($119+($118<<2))|0);
      var $121=HEAP32[(($120)>>2)];
      $context1=$121;
      var $122=$context1;
      var $123=(($122+1092)|0);
      HEAP32[(($123)>>2)]=0;
      __label__ = 20; break;
    case 20: // $124
      var $125=$ctxnum;
      var $126=(($125+1)|0);
      $ctxnum=$126;
      __label__ = 18; break;
    case 21: // $127
      $dx=0;
      __label__ = 22; break;
    case 22: // $128
      var $129=$dx;
      var $130=$7;
      var $131=(($129)>>>0) < (($130)>>>0);
      if ($131) { __label__ = 23; break; } else { __label__ = 33; break; }
    case 23: // $132
      $ctxnum=0;
      __label__ = 24; break;
    case 24: // $133
      var $134=$ctxnum;
      var $135=$2;
      var $136=(($134)>>>0) < (($135)>>>0);
      if ($136) { __label__ = 25; break; } else { __label__ = 32; break; }
    case 25: // $137
      var $138=$ctxnum;
      var $139=$3;
      var $140=(($139+($138<<2))|0);
      var $141=HEAP32[(($140)>>2)];
      $context2=$141;
      var $142=$context2;
      var $143=(($142+1092)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $146
      var $147=$context2;
      var $148=(($147+1092)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149-1)|0);
      HEAP32[(($148)>>2)]=$150;
      var $151=$context2;
      var $152=(($151+2)|0);
      var $153=HEAP8[($152)];
      var $154=$dx;
      var $155=$10;
      var $156=$154 ^ $155;
      var $157=$6;
      var $158=(($157+$156)|0);
      HEAP8[($158)]=$153;
      __label__ = 31; break;
    case 27: // $159
      var $160=$context2;
      var $161=(($160)|0);
      var $162=HEAPU8[($161)];
      var $163=(($162)&255);
      var $164=__ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $163);
      $bits=$164;
      var $165=$bits;
      var $166=$context2;
      var $167=(($166+11976)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+($165<<1))|0);
      var $170=HEAP16[(($169)>>1)];
      $lookup=$170;
      var $171=$lookup;
      var $172=(($171)&65535);
      var $173=$172 & 31;
      __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $173);
      var $174=$lookup;
      var $175=(($174)&65535);
      var $176=$175 >> 6;
      $data=$176;
      var $177=$data;
      var $178=(($177)|0) < 256;
      if ($178) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $179
      var $180=$data;
      var $181=(($180) & 255);
      var $182=(($181)&255);
      var $183=$context2;
      var $184=(($183+2)|0);
      var $185=HEAPU8[($184)];
      var $186=(($185)&255);
      var $187=(($186+$182)|0);
      var $188=(($187) & 255);
      HEAP8[($184)]=$188;
      __label__ = 30; break;
    case 29: // $189
      var $190=$data;
      var $191=__ZL16code_to_rlecounti($190);
      var $192=(($191-1)|0);
      var $193=$context2;
      var $194=(($193+1092)|0);
      HEAP32[(($194)>>2)]=$192;
      __label__ = 30; break;
    case 30: // $195
      var $196=$context2;
      var $197=(($196+2)|0);
      var $198=HEAP8[($197)];
      var $199=$dx;
      var $200=$10;
      var $201=$199 ^ $200;
      var $202=$6;
      var $203=(($202+$201)|0);
      HEAP8[($203)]=$198;
      __label__ = 31; break;
    case 31: // $204
      var $205=$ctxnum;
      var $206=(($205+1)|0);
      $ctxnum=$206;
      var $207=$dx;
      var $208=(($207+1)|0);
      $dx=$208;
      __label__ = 24; break;
    case 32: // $209
      __label__ = 22; break;
    case 33: // $210
      var $211=$9;
      var $212=$6;
      var $213=(($212+$211)|0);
      $6=$213;
      __label__ = 34; break;
    case 34: // $214
      var $215=$dy;
      var $216=(($215+1)|0);
      $dy=$216;
      __label__ = 16; break;
    case 35: // $217
      var $218=__ZL22bit_buffer_read_offsetP11_bit_buffer($bitbuf);
      var $219=$11;
      HEAP32[(($219)>>2)]=$218;
      var $220=(($bitbuf+20)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221)|0)!=0;
      var $223=$222 ? 4 : 0;
      $1=$223;
      __label__ = 36; break;
    case 36: // $224
      var $225=$1;
      STACKTOP = __stackBase__;
      return $225;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z40huffman_deltarle_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj["X"]=1;

function __ZL17tree_node_comparePKvS0_($item1, $item2) {
  ;
  var __label__;

  var $1;
  var $2;
  var $node1;
  var $node2;
  $1=$item1;
  $2=$item2;
  var $3=$1;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  $node1=$5;
  var $6=$2;
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  $node2=$8;
  var $9=$node2;
  var $10=(($9+8)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$node1;
  var $13=(($12+8)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($11-$14)|0);
  ;
  return $15;
}


function __ZL45huffman_deltarle_decode_data_interleaved_0102PP16_huffman_contextPKhjPhjjjjPj($contexts, $source, $slength, $dest, $dwidth, $dheight, $dstride, $dxor, $actlength) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $table02;
      var $table1;
      var $table3;
      var $rleremaining02;
      var $rleremaining1;
      var $rleremaining3;
      var $prevdata02;
      var $prevdata1;
      var $prevdata3;
      var $maxbits;
      var $error;
      var $bitbuf=__stackBase__;
      var $dx;
      var $dy;
      var $lookup;
      var $bits;
      var $data;
      $2=$contexts;
      $3=$source;
      $4=$slength;
      $5=$dest;
      $6=$dwidth;
      $7=$dheight;
      $8=$dstride;
      $9=$dxor;
      $10=$actlength;
      $prevdata02=0;
      $prevdata1=0;
      $prevdata3=0;
      var $11=$2;
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      $maxbits=$16;
      var $17=$2;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24)!=0;
      if ($22) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $23
      var $24=$2;
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZL18build_lookup_tableP16_huffman_contextj($26, 272);
      $error=$27;
      var $28=$error;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $30
      var $31=$error;
      $1=$31;
      __label__ = 45; break;
    case 3: // $32
      __label__ = 4; break;
    case 4: // $33
      var $34=$2;
      var $35=(($34+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      var $38=HEAP8[($37)];
      var $39=(($38 << 24) >> 24)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $40
      var $41=$2;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=__ZL18build_lookup_tableP16_huffman_contextj($43, 272);
      $error=$44;
      var $45=$error;
      var $46=(($45)|0)!=0;
      if ($46) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $47
      var $48=$error;
      $1=$48;
      __label__ = 45; break;
    case 7: // $49
      __label__ = 8; break;
    case 8: // $50
      var $51=$2;
      var $52=(($51+12)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+1)|0);
      var $55=HEAP8[($54)];
      var $56=(($55 << 24) >> 24)!=0;
      if ($56) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $57
      var $58=$2;
      var $59=(($58+12)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=__ZL18build_lookup_tableP16_huffman_contextj($60, 272);
      $error=$61;
      var $62=$error;
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $64
      var $65=$error;
      $1=$65;
      __label__ = 45; break;
    case 11: // $66
      __label__ = 12; break;
    case 12: // $67
      var $68=$2;
      var $69=(($68)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+11976)|0);
      var $72=HEAP32[(($71)>>2)];
      $table02=$72;
      var $73=$2;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+11976)|0);
      var $77=HEAP32[(($76)>>2)];
      $table1=$77;
      var $78=$2;
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+11976)|0);
      var $82=HEAP32[(($81)>>2)];
      $table3=$82;
      var $83=$3;
      var $84=$4;
      __ZL20bit_buffer_read_initP11_bit_bufferPKhj($bitbuf, $83, $84);
      $dy=0;
      __label__ = 13; break;
    case 13: // $85
      var $86=$dy;
      var $87=$7;
      var $88=(($86)>>>0) < (($87)>>>0);
      if ($88) { __label__ = 14; break; } else { __label__ = 44; break; }
    case 14: // $89
      $rleremaining3=0;
      $rleremaining1=0;
      $rleremaining02=0;
      $dx=0;
      __label__ = 15; break;
    case 15: // $90
      var $91=$dx;
      var $92=$6;
      var $93=(($91)>>>0) < (($92)>>>0);
      if ($93) { __label__ = 16; break; } else { __label__ = 42; break; }
    case 16: // $94
      var $95=$rleremaining02;
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      var $98=$rleremaining02;
      var $99=(($98-1)|0);
      $rleremaining02=$99;
      __label__ = 22; break;
    case 18: // $100
      var $101=$maxbits;
      var $102=__ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $101);
      $bits=$102;
      var $103=$bits;
      var $104=$table02;
      var $105=(($104+($103<<1))|0);
      var $106=HEAP16[(($105)>>1)];
      $lookup=$106;
      var $107=$lookup;
      var $108=(($107)&65535);
      var $109=$108 & 31;
      __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $109);
      var $110=$lookup;
      var $111=(($110)&65535);
      var $112=$111 >> 6;
      $data=$112;
      var $113=$data;
      var $114=(($113)|0) < 256;
      if ($114) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $115
      var $116=$data;
      var $117=(($116) & 255);
      var $118=(($117)&255);
      var $119=$prevdata02;
      var $120=(($119)&255);
      var $121=(($120+$118)|0);
      var $122=(($121) & 255);
      $prevdata02=$122;
      __label__ = 21; break;
    case 20: // $123
      var $124=$data;
      var $125=__ZL16code_to_rlecounti($124);
      var $126=(($125-1)|0);
      $rleremaining02=$126;
      __label__ = 21; break;
    case 21: // $127
      __label__ = 22; break;
    case 22: // $128
      var $129=$prevdata02;
      var $130=$dx;
      var $131=(($130)|0);
      var $132=$9;
      var $133=$131 ^ $132;
      var $134=$5;
      var $135=(($134+$133)|0);
      HEAP8[($135)]=$129;
      var $136=$rleremaining1;
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $138
      var $139=$rleremaining1;
      var $140=(($139-1)|0);
      $rleremaining1=$140;
      __label__ = 28; break;
    case 24: // $141
      var $142=$maxbits;
      var $143=__ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $142);
      $bits=$143;
      var $144=$bits;
      var $145=$table1;
      var $146=(($145+($144<<1))|0);
      var $147=HEAP16[(($146)>>1)];
      $lookup=$147;
      var $148=$lookup;
      var $149=(($148)&65535);
      var $150=$149 & 31;
      __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $150);
      var $151=$lookup;
      var $152=(($151)&65535);
      var $153=$152 >> 6;
      $data=$153;
      var $154=$data;
      var $155=(($154)|0) < 256;
      if ($155) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $156
      var $157=$data;
      var $158=(($157) & 255);
      var $159=(($158)&255);
      var $160=$prevdata1;
      var $161=(($160)&255);
      var $162=(($161+$159)|0);
      var $163=(($162) & 255);
      $prevdata1=$163;
      __label__ = 27; break;
    case 26: // $164
      var $165=$data;
      var $166=__ZL16code_to_rlecounti($165);
      var $167=(($166-1)|0);
      $rleremaining1=$167;
      __label__ = 27; break;
    case 27: // $168
      __label__ = 28; break;
    case 28: // $169
      var $170=$prevdata1;
      var $171=$dx;
      var $172=(($171+1)|0);
      var $173=$9;
      var $174=$172 ^ $173;
      var $175=$5;
      var $176=(($175+$174)|0);
      HEAP8[($176)]=$170;
      var $177=$rleremaining02;
      var $178=(($177)|0)!=0;
      if ($178) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $179
      var $180=$rleremaining02;
      var $181=(($180-1)|0);
      $rleremaining02=$181;
      __label__ = 34; break;
    case 30: // $182
      var $183=$maxbits;
      var $184=__ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $183);
      $bits=$184;
      var $185=$bits;
      var $186=$table02;
      var $187=(($186+($185<<1))|0);
      var $188=HEAP16[(($187)>>1)];
      $lookup=$188;
      var $189=$lookup;
      var $190=(($189)&65535);
      var $191=$190 & 31;
      __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $191);
      var $192=$lookup;
      var $193=(($192)&65535);
      var $194=$193 >> 6;
      $data=$194;
      var $195=$data;
      var $196=(($195)|0) < 256;
      if ($196) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $197
      var $198=$data;
      var $199=(($198) & 255);
      var $200=(($199)&255);
      var $201=$prevdata02;
      var $202=(($201)&255);
      var $203=(($202+$200)|0);
      var $204=(($203) & 255);
      $prevdata02=$204;
      __label__ = 33; break;
    case 32: // $205
      var $206=$data;
      var $207=__ZL16code_to_rlecounti($206);
      var $208=(($207-1)|0);
      $rleremaining02=$208;
      __label__ = 33; break;
    case 33: // $209
      __label__ = 34; break;
    case 34: // $210
      var $211=$prevdata02;
      var $212=$dx;
      var $213=(($212+2)|0);
      var $214=$9;
      var $215=$213 ^ $214;
      var $216=$5;
      var $217=(($216+$215)|0);
      HEAP8[($217)]=$211;
      var $218=$rleremaining3;
      var $219=(($218)|0)!=0;
      if ($219) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $220
      var $221=$rleremaining3;
      var $222=(($221-1)|0);
      $rleremaining3=$222;
      __label__ = 40; break;
    case 36: // $223
      var $224=$maxbits;
      var $225=__ZL15bit_buffer_peekP11_bit_bufferi($bitbuf, $224);
      $bits=$225;
      var $226=$bits;
      var $227=$table3;
      var $228=(($227+($226<<1))|0);
      var $229=HEAP16[(($228)>>1)];
      $lookup=$229;
      var $230=$lookup;
      var $231=(($230)&65535);
      var $232=$231 & 31;
      __ZL17bit_buffer_removeP11_bit_bufferi($bitbuf, $232);
      var $233=$lookup;
      var $234=(($233)&65535);
      var $235=$234 >> 6;
      $data=$235;
      var $236=$data;
      var $237=(($236)|0) < 256;
      if ($237) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $238
      var $239=$data;
      var $240=(($239) & 255);
      var $241=(($240)&255);
      var $242=$prevdata3;
      var $243=(($242)&255);
      var $244=(($243+$241)|0);
      var $245=(($244) & 255);
      $prevdata3=$245;
      __label__ = 39; break;
    case 38: // $246
      var $247=$data;
      var $248=__ZL16code_to_rlecounti($247);
      var $249=(($248-1)|0);
      $rleremaining3=$249;
      __label__ = 39; break;
    case 39: // $250
      __label__ = 40; break;
    case 40: // $251
      var $252=$prevdata3;
      var $253=$dx;
      var $254=(($253+3)|0);
      var $255=$9;
      var $256=$254 ^ $255;
      var $257=$5;
      var $258=(($257+$256)|0);
      HEAP8[($258)]=$252;
      __label__ = 41; break;
    case 41: // $259
      var $260=$dx;
      var $261=(($260+4)|0);
      $dx=$261;
      __label__ = 15; break;
    case 42: // $262
      var $263=$8;
      var $264=$5;
      var $265=(($264+$263)|0);
      $5=$265;
      __label__ = 43; break;
    case 43: // $266
      var $267=$dy;
      var $268=(($267+1)|0);
      $dy=$268;
      __label__ = 13; break;
    case 44: // $269
      var $270=__ZL22bit_buffer_read_offsetP11_bit_buffer($bitbuf);
      var $271=$10;
      HEAP32[(($271)>>2)]=$270;
      var $272=(($bitbuf+20)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=(($273)|0)!=0;
      var $275=$274 ? 4 : 0;
      $1=$275;
      __label__ = 45; break;
    case 45: // $276
      var $277=$1;
      STACKTOP = __stackBase__;
      return $277;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL45huffman_deltarle_decode_data_interleaved_0102PP16_huffman_contextPKhjPhjjjjPj["X"]=1;

function __ZL18huffman_build_treeP16_huffman_contextPKjjjj($context, $datahisto, $totaldata, $totalweight, $numcodes) {
  var __stackBase__  = STACKTOP; STACKTOP += 1088; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $list=__stackBase__;
      var $listitems;
      var $nextalloc;
      var $maxbits;
      var $i;
      var $node0;
      var $node1;
      var $newnode;
      var $node;
      var $curnode;
      $1=$context;
      $2=$datahisto;
      $3=$totaldata;
      $4=$totalweight;
      $5=$numcodes;
      $listitems=0;
      var $6=$1;
      var $7=(($6+1096)|0);
      var $8=(($7)|0);
      var $9=$8;
      var $10=$5;
      var $11=(($10*20)|0);
      _memset($9, 0, $11, 1);
      $i=0;
      __label__ = 1; break;
    case 1: // $12
      var $13=$i;
      var $14=$5;
      var $15=(($13)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $16
      var $17=$i;
      var $18=$2;
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $22
      var $23=$i;
      var $24=$1;
      var $25=(($24+1096)|0);
      var $26=(($25+$23*20)|0);
      var $27=$listitems;
      var $28=(($27+1)|0);
      $listitems=$28;
      var $29=(($list+($27<<2))|0);
      HEAP32[(($29)>>2)]=$26;
      var $30=$i;
      var $31=$2;
      var $32=(($31+($30<<2))|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$i;
      var $35=$1;
      var $36=(($35+1096)|0);
      var $37=(($36+$34*20)|0);
      var $38=(($37+4)|0);
      HEAP32[(($38)>>2)]=$33;
      var $39=$i;
      var $40=$2;
      var $41=(($40+($39<<2))|0);
      var $42=HEAP32[(($41)>>2)];
      var $43$0=$42;
      var $43$1=0;
      var $44=$4;
      var $45$0=$44;
      var $45$1=0;
      var $46$0 = ((($43$0)>>>0)+((($43$1)|0)*4294967296))*((($45$0)>>>0)+((($45$1)|0)*4294967296))>>>0; var $46$1 = Math.min(Math.floor((((($43$0)>>>0)+((($43$1)|0)*4294967296))*((($45$0)>>>0)+((($45$1)|0)*4294967296)))/4294967296), 4294967295);
      var $47=$3;
      var $48$0=$47;
      var $48$1=0;
      var $49$0 = Math.floor(((($46$0)>>>0)+((($46$1)|0)*4294967296))/((($48$0)>>>0)+((($48$1)|0)*4294967296)))>>>0; var $49$1 = Math.min(Math.floor((Math.floor(((($46$0)>>>0)+((($46$1)|0)*4294967296))/((($48$0)>>>0)+((($48$1)|0)*4294967296))))/4294967296), 4294967295);
      var $50$0=$49$0;
      var $50=$50$0;
      var $51=$i;
      var $52=$1;
      var $53=(($52+1096)|0);
      var $54=(($53+$51*20)|0);
      var $55=(($54+8)|0);
      HEAP32[(($55)>>2)]=$50;
      var $56=$i;
      var $57=$1;
      var $58=(($57+1096)|0);
      var $59=(($58+$56*20)|0);
      var $60=(($59+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $63
      var $64=$i;
      var $65=$1;
      var $66=(($65+1096)|0);
      var $67=(($66+$64*20)|0);
      var $68=(($67+8)|0);
      HEAP32[(($68)>>2)]=1;
      __label__ = 5; break;
    case 5: // $69
      __label__ = 6; break;
    case 6: // $70
      __label__ = 7; break;
    case 7: // $71
      var $72=$i;
      var $73=(($72+1)|0);
      $i=$73;
      __label__ = 1; break;
    case 8: // $74
      var $75=(($list)|0);
      var $76=$75;
      var $77=$listitems;
      _qsort($76, $77, 4, 1490);
      $nextalloc=272;
      __label__ = 9; break;
    case 9: // $78
      var $79=$listitems;
      var $80=(($79)|0) > 1;
      if ($80) { __label__ = 10; break; } else { __label__ = 17; break; }
    case 10: // $81
      var $82=$listitems;
      var $83=(($82-1)|0);
      $listitems=$83;
      var $84=(($list+($83<<2))|0);
      var $85=HEAP32[(($84)>>2)];
      $node1=$85;
      var $86=$listitems;
      var $87=(($86-1)|0);
      $listitems=$87;
      var $88=(($list+($87<<2))|0);
      var $89=HEAP32[(($88)>>2)];
      $node0=$89;
      var $90=$nextalloc;
      var $91=(($90+1)|0);
      $nextalloc=$91;
      var $92=$1;
      var $93=(($92+1096)|0);
      var $94=(($93+$90*20)|0);
      $newnode=$94;
      var $95=$newnode;
      var $96=(($95)|0);
      HEAP32[(($96)>>2)]=0;
      var $97=$newnode;
      var $98=$node1;
      var $99=(($98)|0);
      HEAP32[(($99)>>2)]=$97;
      var $100=$node0;
      var $101=(($100)|0);
      HEAP32[(($101)>>2)]=$97;
      var $102=$node0;
      var $103=(($102+8)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$node1;
      var $106=(($105+8)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($104+$107)|0);
      var $109=$newnode;
      var $110=(($109+8)|0);
      HEAP32[(($110)>>2)]=$108;
      $i=0;
      __label__ = 11; break;
    case 11: // $111
      var $112=$i;
      var $113=$listitems;
      var $114=(($112)|0) < (($113)|0);
      if ($114) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $115
      var $116=$newnode;
      var $117=(($116+8)|0);
      var $118=HEAPU32[(($117)>>2)];
      var $119=$i;
      var $120=(($list+($119<<2))|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+8)|0);
      var $123=HEAPU32[(($122)>>2)];
      var $124=(($118)>>>0) > (($123)>>>0);
      if ($124) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $125
      var $126=$i;
      var $127=(($126+1)|0);
      var $128=(($list+($127<<2))|0);
      var $129=$128;
      var $130=$i;
      var $131=(($list+($130<<2))|0);
      var $132=$131;
      var $133=$listitems;
      var $134=$i;
      var $135=(($133-$134)|0);
      var $136=((($135<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32($129, $132, $136, 1, 0);
      __label__ = 16; break;
    case 14: // $137
      __label__ = 15; break;
    case 15: // $138
      var $139=$i;
      var $140=(($139+1)|0);
      $i=$140;
      __label__ = 11; break;
    case 16: // $141
      var $142=$newnode;
      var $143=$i;
      var $144=(($list+($143<<2))|0);
      HEAP32[(($144)>>2)]=$142;
      var $145=$listitems;
      var $146=(($145+1)|0);
      $listitems=$146;
      __label__ = 9; break;
    case 17: // $147
      $maxbits=0;
      $i=0;
      __label__ = 18; break;
    case 18: // $148
      var $149=$i;
      var $150=$5;
      var $151=(($149)>>>0) < (($150)>>>0);
      if ($151) { __label__ = 19; break; } else { __label__ = 32; break; }
    case 19: // $152
      var $153=$i;
      var $154=$1;
      var $155=(($154+1096)|0);
      var $156=(($155+$153*20)|0);
      $node=$156;
      var $157=$node;
      var $158=(($157+16)|0);
      HEAP8[($158)]=0;
      var $159=$node;
      var $160=(($159+8)|0);
      var $161=HEAPU32[(($160)>>2)];
      var $162=(($161)>>>0) > 0;
      if ($162) { __label__ = 20; break; } else { __label__ = 30; break; }
    case 20: // $163
      var $164=$node;
      $curnode=$164;
      __label__ = 21; break;
    case 21: // $165
      var $166=$curnode;
      var $167=(($166)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168)|0)!=0;
      if ($169) { __label__ = 22; break; } else { __label__ = 24; break; }
    case 22: // $170
      var $171=$node;
      var $172=(($171+16)|0);
      var $173=HEAP8[($172)];
      var $174=(($173+1)&255);
      HEAP8[($172)]=$174;
      __label__ = 23; break;
    case 23: // $175
      var $176=$curnode;
      var $177=(($176)|0);
      var $178=HEAP32[(($177)>>2)];
      $curnode=$178;
      __label__ = 21; break;
    case 24: // $179
      var $180=$node;
      var $181=(($180+16)|0);
      var $182=HEAPU8[($181)];
      var $183=(($182)&255);
      var $184=(($183)|0)==0;
      if ($184) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $185
      var $186=$node;
      var $187=(($186+16)|0);
      HEAP8[($187)]=1;
      __label__ = 26; break;
    case 26: // $188
      var $189=$maxbits;
      var $190=$node;
      var $191=(($190+16)|0);
      var $192=HEAPU8[($191)];
      var $193=(($192)&255);
      var $194=(($189)|0) > (($193)|0);
      if ($194) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $195
      var $196=$maxbits;
      var $203 = $196;__label__ = 29; break;
    case 28: // $197
      var $198=$node;
      var $199=(($198+16)|0);
      var $200=HEAPU8[($199)];
      var $201=(($200)&255);
      var $203 = $201;__label__ = 29; break;
    case 29: // $202
      var $203;
      $maxbits=$203;
      __label__ = 30; break;
    case 30: // $204
      __label__ = 31; break;
    case 31: // $205
      var $206=$i;
      var $207=(($206+1)|0);
      $i=$207;
      __label__ = 18; break;
    case 32: // $208
      var $209=$maxbits;
      STACKTOP = __stackBase__;
      return $209;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18huffman_build_treeP16_huffman_contextPKjjjj["X"]=1;

function __ZL22assign_canonical_codesP16_huffman_contextj($context, $numcodes) {
  var __stackBase__  = STACKTOP; STACKTOP += 132; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $bithisto=__stackBase__;
      var $curstart;
      var $i;
      var $node;
      var $nextstart;
      var $node1;
      $2=$context;
      $3=$numcodes;
      var $4=(($bithisto)|0);
      var $5=$4;
      _memset($5, 0, 132, 1);
      $i=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$i;
      var $8=$3;
      var $9=(($7)>>>0) < (($8)>>>0);
      if ($9) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $10
      var $11=$i;
      var $12=$2;
      var $13=(($12+1096)|0);
      var $14=(($13+$11*20)|0);
      $node=$14;
      var $15=$node;
      var $16=(($15+16)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$2;
      var $20=(($19)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($18)|0) > (($22)|0);
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      $1=6;
      __label__ = 22; break;
    case 4: // $25
      var $26=$node;
      var $27=(($26+16)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=(($29)|0) <= 32;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=$node;
      var $33=(($32+16)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=(($bithisto+($35<<2))|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+1)|0);
      HEAP32[(($36)>>2)]=$38;
      __label__ = 6; break;
    case 6: // $39
      __label__ = 7; break;
    case 7: // $40
      var $41=$i;
      var $42=(($41+1)|0);
      $i=$42;
      __label__ = 1; break;
    case 8: // $43
      $curstart=0;
      $i=32;
      __label__ = 9; break;
    case 9: // $44
      var $45=$i;
      var $46=(($45)|0) > 0;
      if ($46) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $47
      var $48=$curstart;
      var $49=$i;
      var $50=(($bithisto+($49<<2))|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($48+$51)|0);
      var $53=$52 >>> 1;
      $nextstart=$53;
      var $54=$i;
      var $55=(($54)|0)!=1;
      if ($55) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $56
      var $57=$nextstart;
      var $58=((($57<<1))|0);
      var $59=$curstart;
      var $60=$i;
      var $61=(($bithisto+($60<<2))|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($59+$62)|0);
      var $64=(($58)|0)!=(($63)|0);
      if ($64) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $65
      $1=6;
      __label__ = 22; break;
    case 13: // $66
      var $67=$curstart;
      var $68=$i;
      var $69=(($bithisto+($68<<2))|0);
      HEAP32[(($69)>>2)]=$67;
      var $70=$nextstart;
      $curstart=$70;
      __label__ = 14; break;
    case 14: // $71
      var $72=$i;
      var $73=(($72-1)|0);
      $i=$73;
      __label__ = 9; break;
    case 15: // $74
      $i=0;
      __label__ = 16; break;
    case 16: // $75
      var $76=$i;
      var $77=$3;
      var $78=(($76)>>>0) < (($77)>>>0);
      if ($78) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $79
      var $80=$i;
      var $81=$2;
      var $82=(($81+1096)|0);
      var $83=(($82+$80*20)|0);
      $node1=$83;
      var $84=$node1;
      var $85=(($84+16)|0);
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=(($87)|0) > 0;
      if ($88) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $89
      var $90=$node1;
      var $91=(($90+16)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=(($bithisto+($93<<2))|0);
      var $95=HEAPU32[(($94)>>2)];
      var $96=(($95+1)|0);
      HEAP32[(($94)>>2)]=$96;
      var $97=$node1;
      var $98=(($97+12)|0);
      HEAP32[(($98)>>2)]=$95;
      __label__ = 19; break;
    case 19: // $99
      __label__ = 20; break;
    case 20: // $100
      var $101=$i;
      var $102=(($101+1)|0);
      $i=$102;
      __label__ = 16; break;
    case 21: // $103
      var $104=$2;
      var $105=(($104+1)|0);
      HEAP8[($105)]=1;
      $1=0;
      __label__ = 22; break;
    case 22: // $106
      var $107=$1;
      STACKTOP = __stackBase__;
      return $107;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22assign_canonical_codesP16_huffman_contextj["X"]=1;

function __ZL15bit_buffer_readP11_bit_bufferi($bitbuf, $numbits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $result;
      $1=$bitbuf;
      $2=$numbits;
      var $3=$2;
      var $4=$1;
      var $5=(($4+4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($3)|0) > (($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$1;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0) <= 24;
      if ($13) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $14
      var $15=$1;
      var $16=(($15+12)|0);
      var $17=HEAPU32[(($16)>>2)];
      var $18=$1;
      var $19=(($18+16)|0);
      var $20=HEAPU32[(($19)>>2)];
      var $21=(($17)>>>0) < (($20)>>>0);
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      var $23=$1;
      var $24=(($23+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$1;
      var $27=(($26+8)|0);
      var $28=$27;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$25)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=$1;
      var $34=(($33+4)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=((24-$35)|0);
      var $37=$32 << $36;
      var $38=$1;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40 | $37;
      HEAP32[(($39)>>2)]=$41;
      __label__ = 5; break;
    case 5: // $42
      var $43=$1;
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+1)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$1;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+8)|0);
      HEAP32[(($48)>>2)]=$50;
      __label__ = 2; break;
    case 6: // $51
      var $52=$2;
      var $53=$1;
      var $54=(($53+4)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($52)|0) > (($55)|0);
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$1;
      var $59=(($58+20)|0);
      HEAP32[(($59)>>2)]=1;
      __label__ = 8; break;
    case 8: // $60
      __label__ = 9; break;
    case 9: // $61
      var $62=$1;
      var $63=(($62)|0);
      var $64=HEAPU32[(($63)>>2)];
      var $65=$2;
      var $66=((32-$65)|0);
      var $67=$64 >>> (($66)>>>0);
      $result=$67;
      var $68=$2;
      var $69=$1;
      var $70=(($69)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$71 << $68;
      HEAP32[(($70)>>2)]=$72;
      var $73=$2;
      var $74=$1;
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76-$73)|0);
      HEAP32[(($75)>>2)]=$77;
      var $78=$result;
      ;
      return $78;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15bit_buffer_readP11_bit_bufferi["X"]=1;

function __ZL19write_rle_tree_bitsP11_bit_bufferiii($bitbuf, $value, $repcount, $numbits) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $cur_reps;
      $1=$bitbuf;
      $2=$value;
      $3=$repcount;
      $4=$numbits;
      __label__ = 1; break;
    case 1: // $5
      var $6=$3;
      var $7=(($6)|0) > 0;
      if ($7) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $8
      var $9=$2;
      var $10=(($9)|0)==1;
      if ($10) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $11
      var $12=$1;
      var $13=$4;
      __ZL16bit_buffer_writeP11_bit_bufferji($12, 1, $13);
      var $14=$1;
      var $15=$4;
      __ZL16bit_buffer_writeP11_bit_bufferji($14, 1, $15);
      var $16=$3;
      var $17=(($16-1)|0);
      $3=$17;
      __label__ = 11; break;
    case 4: // $18
      var $19=$3;
      var $20=(($19)|0) <= 2;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=$1;
      var $23=$2;
      var $24=$4;
      __ZL16bit_buffer_writeP11_bit_bufferji($22, $23, $24);
      var $25=$3;
      var $26=(($25-1)|0);
      $3=$26;
      __label__ = 10; break;
    case 6: // $27
      var $28=$3;
      var $29=(($28-3)|0);
      var $30=$4;
      var $31=1 << $30;
      var $32=(($31-1)|0);
      var $33=(($29)|0) < (($32)|0);
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$3;
      var $36=(($35-3)|0);
      var $42 = $36;__label__ = 9; break;
    case 8: // $37
      var $38=$4;
      var $39=1 << $38;
      var $40=(($39-1)|0);
      var $42 = $40;__label__ = 9; break;
    case 9: // $41
      var $42;
      $cur_reps=$42;
      var $43=$1;
      var $44=$4;
      __ZL16bit_buffer_writeP11_bit_bufferji($43, 1, $44);
      var $45=$1;
      var $46=$2;
      var $47=$4;
      __ZL16bit_buffer_writeP11_bit_bufferji($45, $46, $47);
      var $48=$1;
      var $49=$cur_reps;
      var $50=$4;
      __ZL16bit_buffer_writeP11_bit_bufferji($48, $49, $50);
      var $51=$cur_reps;
      var $52=(($51+3)|0);
      var $53=$3;
      var $54=(($53-$52)|0);
      $3=$54;
      __label__ = 10; break;
    case 10: // $55
      __label__ = 11; break;
    case 11: // $56
      __label__ = 1; break;
    case 12: // $57
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19write_rle_tree_bitsP11_bit_bufferiii["X"]=1;

function _XML_ParserCreate_MM($encodingName, $memsuite, $nameSep) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $parser;
      $2=$encodingName;
      $3=$memsuite;
      $4=$nameSep;
      var $5=$2;
      var $6=$3;
      var $7=$4;
      var $8=__ZL12parserCreatePKcPK25XML_Memory_Handling_SuiteS0_P3DTD($5, $6, $7, 0);
      $parser=$8;
      var $9=$parser;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $11
      var $12=$parser;
      var $13=(($12+236)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $16
      var $17=$parser;
      var $18=__ZL10setContextP16XML_ParserStructPKc($17, ((STRING_TABLE.__ZL15implicitContext)|0));
      var $19=(($18 << 24) >> 24)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $20
      var $21=$parser;
      _XML_ParserFree($21);
      $1=0;
      __label__ = 6; break;
    case 4: // $22
      __label__ = 5; break;
    case 5: // $23
      var $24=$parser;
      $1=$24;
      __label__ = 6; break;
    case 6: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12parserCreatePKcPK25XML_Memory_Handling_SuiteS0_P3DTD($encodingName, $memsuite, $nameSep, $dtd) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $parser;
      var $mtemp;
      var $mtemp1;
      $2=$encodingName;
      $3=$memsuite;
      $4=$nameSep;
      $5=$dtd;
      var $6=$3;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=FUNCTION_TABLE[$11](496);
      var $13=$12;
      $parser=$13;
      var $14=$parser;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$parser;
      var $18=(($17+12)|0);
      $mtemp=$18;
      var $19=$3;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$mtemp;
      var $23=(($22)|0);
      HEAP32[(($23)>>2)]=$21;
      var $24=$3;
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$mtemp;
      var $28=(($27+4)|0);
      HEAP32[(($28)>>2)]=$26;
      var $29=$3;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$mtemp;
      var $33=(($32+8)|0);
      HEAP32[(($33)>>2)]=$31;
      __label__ = 3; break;
    case 3: // $34
      __label__ = 7; break;
    case 4: // $35
      var $36=_malloc(496);
      var $37=$36;
      $parser=$37;
      var $38=$parser;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$parser;
      var $42=(($41+12)|0);
      $mtemp1=$42;
      var $43=$mtemp1;
      var $44=(($43)|0);
      HEAP32[(($44)>>2)]=1492;
      var $45=$mtemp1;
      var $46=(($45+4)|0);
      HEAP32[(($46)>>2)]=1494;
      var $47=$mtemp1;
      var $48=(($47+8)|0);
      HEAP32[(($48)>>2)]=1496;
      __label__ = 6; break;
    case 6: // $49
      __label__ = 7; break;
    case 7: // $50
      var $51=$parser;
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $53
      var $54=$parser;
      $1=$54;
      __label__ = 25; break;
    case 9: // $55
      var $56=$parser;
      var $57=(($56+8)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=$parser;
      var $59=(($58+32)|0);
      HEAP32[(($59)>>2)]=0;
      var $60=$parser;
      var $61=(($60+380)|0);
      HEAP32[(($61)>>2)]=16;
      var $62=$parser;
      var $63=(($62+12)|0);
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$parser;
      var $67=(($66+380)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=((($68<<4))|0);
      var $70=FUNCTION_TABLE[$65]($69);
      var $71=$70;
      var $72=$parser;
      var $73=(($72+392)|0);
      HEAP32[(($73)>>2)]=$71;
      var $74=$parser;
      var $75=(($74+392)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $78
      var $79=$parser;
      var $80=(($79+12)|0);
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$parser;
      var $84=$83;
      FUNCTION_TABLE[$82]($84);
      $1=0;
      __label__ = 25; break;
    case 11: // $85
      var $86=$parser;
      var $87=(($86+12)|0);
      var $88=(($87)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=FUNCTION_TABLE[$89](1024);
      var $91=$parser;
      var $92=(($91+44)|0);
      HEAP32[(($92)>>2)]=$90;
      var $93=$parser;
      var $94=(($93+44)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $97
      var $98=$parser;
      var $99=(($98+12)|0);
      var $100=(($99+8)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$parser;
      var $103=(($102+392)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$104;
      FUNCTION_TABLE[$101]($105);
      var $106=$parser;
      var $107=(($106+12)|0);
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=$parser;
      var $111=$110;
      FUNCTION_TABLE[$109]($111);
      $1=0;
      __label__ = 25; break;
    case 13: // $112
      var $113=$parser;
      var $114=(($113+44)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115+1024)|0);
      var $117=$parser;
      var $118=(($117+48)|0);
      HEAP32[(($118)>>2)]=$116;
      var $119=$5;
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $121
      var $122=$5;
      var $123=$parser;
      var $124=(($123+356)|0);
      HEAP32[(($124)>>2)]=$122;
      __label__ = 18; break;
    case 15: // $125
      var $126=$parser;
      var $127=(($126+12)|0);
      var $128=__ZL9dtdCreatePK25XML_Memory_Handling_Suite($127);
      var $129=$parser;
      var $130=(($129+356)|0);
      HEAP32[(($130)>>2)]=$128;
      var $131=$parser;
      var $132=(($131+356)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133)|0)==0;
      if ($134) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $135
      var $136=$parser;
      var $137=(($136+12)|0);
      var $138=(($137+8)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=$parser;
      var $141=(($140+44)|0);
      var $142=HEAP32[(($141)>>2)];
      FUNCTION_TABLE[$139]($142);
      var $143=$parser;
      var $144=(($143+12)|0);
      var $145=(($144+8)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$parser;
      var $148=(($147+392)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$149;
      FUNCTION_TABLE[$146]($150);
      var $151=$parser;
      var $152=(($151+12)|0);
      var $153=(($152+8)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$parser;
      var $156=$155;
      FUNCTION_TABLE[$154]($156);
      $1=0;
      __label__ = 25; break;
    case 17: // $157
      __label__ = 18; break;
    case 18: // $158
      var $159=$parser;
      var $160=(($159+376)|0);
      HEAP32[(($160)>>2)]=0;
      var $161=$parser;
      var $162=(($161+368)|0);
      HEAP32[(($162)>>2)]=0;
      var $163=$parser;
      var $164=(($163+304)|0);
      HEAP32[(($164)>>2)]=0;
      var $165=$parser;
      var $166=(($165+468)|0);
      HEAP32[(($166)>>2)]=0;
      var $167=$parser;
      var $168=(($167+464)|0);
      HEAP32[(($168)>>2)]=0;
      var $169=$parser;
      var $170=(($169+124)|0);
      HEAP32[(($170)>>2)]=0;
      var $171=$parser;
      var $172=(($171+248)|0);
      HEAP32[(($172)>>2)]=0;
      var $173=$parser;
      var $174=(($173+472)|0);
      HEAP8[($174)]=33;
      var $175=$parser;
      var $176=(($175+236)|0);
      HEAP8[($176)]=0;
      var $177=$parser;
      var $178=(($177+237)|0);
      HEAP8[($178)]=0;
      var $179=$parser;
      var $180=(($179+396)|0);
      HEAP32[(($180)>>2)]=0;
      var $181=$parser;
      var $182=(($181+400)|0);
      HEAP32[(($182)>>2)]=0;
      var $183=$parser;
      var $184=(($183+404)|0);
      HEAP8[($184)]=0;
      var $185=$parser;
      var $186=(($185+416)|0);
      var $187=$parser;
      var $188=(($187+12)|0);
      __ZL8poolInitP11STRING_POOLPK25XML_Memory_Handling_Suite($186, $188);
      var $189=$parser;
      var $190=(($189+440)|0);
      var $191=$parser;
      var $192=(($191+12)|0);
      __ZL8poolInitP11STRING_POOLPK25XML_Memory_Handling_Suite($190, $192);
      var $193=$parser;
      var $194=$2;
      __ZL10parserInitP16XML_ParserStructPKc($193, $194);
      var $195=$2;
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $197
      var $198=$parser;
      var $199=(($198+232)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200)|0)!=0;
      if ($201) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $202
      var $203=$parser;
      _XML_ParserFree($203);
      $1=0;
      __label__ = 25; break;
    case 21: // $204
      var $205=$4;
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $207
      var $208=$parser;
      var $209=(($208+236)|0);
      HEAP8[($209)]=1;
      var $210=_XmlGetUtf8InternalEncodingNS();
      var $211=$parser;
      var $212=(($211+228)|0);
      HEAP32[(($212)>>2)]=$210;
      var $213=$4;
      var $214=HEAP8[($213)];
      var $215=$parser;
      var $216=(($215+472)|0);
      HEAP8[($216)]=$214;
      __label__ = 24; break;
    case 23: // $217
      var $218=_XmlGetUtf8InternalEncoding();
      var $219=$parser;
      var $220=(($219+228)|0);
      HEAP32[(($220)>>2)]=$218;
      __label__ = 24; break;
    case 24: // $221
      var $222=$parser;
      $1=$222;
      __label__ = 25; break;
    case 25: // $223
      var $224=$1;
      ;
      return $224;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12parserCreatePKcPK25XML_Memory_Handling_SuiteS0_P3DTD["X"]=1;

function __ZL9poolClearP11STRING_POOL($pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $p;
      var $tem;
      $1=$pool;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+4)|0);
      HEAP32[(($11)>>2)]=$9;
      __label__ = 6; break;
    case 2: // $12
      var $13=$1;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      $p=$15;
      __label__ = 3; break;
    case 3: // $16
      var $17=$p;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $20=$p;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      $tem=$22;
      var $23=$1;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$p;
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=$25;
      var $28=$p;
      var $29=$1;
      var $30=(($29+4)|0);
      HEAP32[(($30)>>2)]=$28;
      var $31=$tem;
      $p=$31;
      __label__ = 3; break;
    case 5: // $32
      __label__ = 6; break;
    case 6: // $33
      var $34=$1;
      var $35=(($34)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=$1;
      var $37=(($36+16)|0);
      HEAP32[(($37)>>2)]=0;
      var $38=$1;
      var $39=(($38+12)|0);
      HEAP32[(($39)>>2)]=0;
      var $40=$1;
      var $41=(($40+8)|0);
      HEAP32[(($41)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9poolClearP11STRING_POOL["X"]=1;

function __ZL10setContextP16XML_ParserStructPKc($parser, $context) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $dtd;
      var $s;
      var $e;
      var $prefix;
      $2=$parser;
      $3=$context;
      var $4=$2;
      var $5=(($4+356)|0);
      var $6=HEAP32[(($5)>>2)];
      $dtd=$6;
      var $7=$3;
      $s=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$3;
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 63; break; }
    case 2: // $13
      var $14=$s;
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)==12;
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      var $19=$s;
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 4: // $23
      var $24=$2;
      var $25=(($24+416)|0);
      var $26=(($25+12)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$2;
      var $29=(($28+416)|0);
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($27)|0)==(($31)|0);
      if ($32) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $33
      var $34=$2;
      var $35=(($34+416)|0);
      var $36=__ZL8poolGrowP11STRING_POOL($35);
      var $37=(($36 << 24) >> 24)!=0;
      if ($37) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $38
      var $46 = 0;__label__ = 8; break;
    case 7: // $39
      var $40=$2;
      var $41=(($40+416)|0);
      var $42=(($41+12)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+1)|0);
      HEAP32[(($42)>>2)]=$44;
      HEAP8[($43)]=0;
      var $46 = 1;__label__ = 8; break;
    case 8: // $45
      var $46;
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $48
      $1=0;
      __label__ = 64; break;
    case 10: // $49
      var $50=$dtd;
      var $51=(($50)|0);
      var $52=$2;
      var $53=(($52+416)|0);
      var $54=(($53+16)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=__ZL6lookupP10HASH_TABLEPKcj($51, $55, 0);
      var $57=$56;
      $e=$57;
      var $58=$e;
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      var $61=$e;
      var $62=(($61+32)|0);
      HEAP8[($62)]=1;
      __label__ = 12; break;
    case 12: // $63
      var $64=$s;
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24);
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $68
      var $69=$s;
      var $70=(($69+1)|0);
      $s=$70;
      __label__ = 14; break;
    case 14: // $71
      var $72=$s;
      $3=$72;
      var $73=$2;
      var $74=(($73+416)|0);
      var $75=(($74+16)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$2;
      var $78=(($77+416)|0);
      var $79=(($78+12)|0);
      HEAP32[(($79)>>2)]=$76;
      __label__ = 62; break;
    case 15: // $80
      var $81=$s;
      var $82=HEAP8[($81)];
      var $83=(($82 << 24) >> 24);
      var $84=(($83)|0)==61;
      if ($84) { __label__ = 16; break; } else { __label__ = 54; break; }
    case 16: // $85
      var $86=$2;
      var $87=(($86+416)|0);
      var $88=(($87+12)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$2;
      var $91=(($90+416)|0);
      var $92=(($91+16)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$89;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0)==0;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      var $99=$dtd;
      var $100=(($99+152)|0);
      $prefix=$100;
      __label__ = 31; break;
    case 18: // $101
      var $102=$2;
      var $103=(($102+416)|0);
      var $104=(($103+12)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$2;
      var $107=(($106+416)|0);
      var $108=(($107+8)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($105)|0)==(($109)|0);
      if ($110) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $111
      var $112=$2;
      var $113=(($112+416)|0);
      var $114=__ZL8poolGrowP11STRING_POOL($113);
      var $115=(($114 << 24) >> 24)!=0;
      if ($115) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $116
      var $124 = 0;__label__ = 22; break;
    case 21: // $117
      var $118=$2;
      var $119=(($118+416)|0);
      var $120=(($119+12)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+1)|0);
      HEAP32[(($120)>>2)]=$122;
      HEAP8[($121)]=0;
      var $124 = 1;__label__ = 22; break;
    case 22: // $123
      var $124;
      var $125=(($124)|0)!=0;
      if ($125) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $126
      $1=0;
      __label__ = 64; break;
    case 24: // $127
      var $128=$dtd;
      var $129=(($128+60)|0);
      var $130=$2;
      var $131=(($130+416)|0);
      var $132=(($131+16)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=__ZL6lookupP10HASH_TABLEPKcj($129, $133, 8);
      var $135=$134;
      $prefix=$135;
      var $136=$prefix;
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $138
      $1=0;
      __label__ = 64; break;
    case 26: // $139
      var $140=$prefix;
      var $141=(($140)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$2;
      var $144=(($143+416)|0);
      var $145=(($144+16)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($142)|0)==(($146)|0);
      if ($147) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 27: // $148
      var $149=$dtd;
      var $150=(($149+80)|0);
      var $151=$prefix;
      var $152=(($151)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=__ZL14poolCopyStringP11STRING_POOLPKc($150, $153);
      var $155=$prefix;
      var $156=(($155)|0);
      HEAP32[(($156)>>2)]=$154;
      var $157=$prefix;
      var $158=(($157)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $161
      $1=0;
      __label__ = 64; break;
    case 29: // $162
      __label__ = 30; break;
    case 30: // $163
      var $164=$2;
      var $165=(($164+416)|0);
      var $166=(($165+16)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$2;
      var $169=(($168+416)|0);
      var $170=(($169+12)|0);
      HEAP32[(($170)>>2)]=$167;
      __label__ = 31; break;
    case 31: // $171
      var $172=$s;
      var $173=(($172+1)|0);
      $3=$173;
      __label__ = 32; break;
    case 32: // $174
      var $175=$3;
      var $176=HEAP8[($175)];
      var $177=(($176 << 24) >> 24);
      var $178=(($177)|0)!=12;
      if ($178) { __label__ = 33; break; } else { var $185 = 0;__label__ = 34; break; }
    case 33: // $179
      var $180=$3;
      var $181=HEAP8[($180)];
      var $182=(($181 << 24) >> 24);
      var $183=(($182)|0)!=0;
      var $185 = $183;__label__ = 34; break;
    case 34: // $184
      var $185;
      if ($185) { __label__ = 35; break; } else { __label__ = 43; break; }
    case 35: // $186
      var $187=$2;
      var $188=(($187+416)|0);
      var $189=(($188+12)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$2;
      var $192=(($191+416)|0);
      var $193=(($192+8)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($190)|0)==(($194)|0);
      if ($195) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $196
      var $197=$2;
      var $198=(($197+416)|0);
      var $199=__ZL8poolGrowP11STRING_POOL($198);
      var $200=(($199 << 24) >> 24)!=0;
      if ($200) { __label__ = 38; break; } else { __label__ = 37; break; }
    case 37: // $201
      var $211 = 0;__label__ = 39; break;
    case 38: // $202
      var $203=$3;
      var $204=HEAP8[($203)];
      var $205=$2;
      var $206=(($205+416)|0);
      var $207=(($206+12)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208+1)|0);
      HEAP32[(($207)>>2)]=$209;
      HEAP8[($208)]=$204;
      var $211 = 1;__label__ = 39; break;
    case 39: // $210
      var $211;
      var $212=(($211)|0)!=0;
      if ($212) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $213
      $1=0;
      __label__ = 64; break;
    case 41: // $214
      __label__ = 42; break;
    case 42: // $215
      var $216=$3;
      var $217=(($216+1)|0);
      $3=$217;
      __label__ = 32; break;
    case 43: // $218
      var $219=$2;
      var $220=(($219+416)|0);
      var $221=(($220+12)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$2;
      var $224=(($223+416)|0);
      var $225=(($224+8)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=(($222)|0)==(($226)|0);
      if ($227) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $228
      var $229=$2;
      var $230=(($229+416)|0);
      var $231=__ZL8poolGrowP11STRING_POOL($230);
      var $232=(($231 << 24) >> 24)!=0;
      if ($232) { __label__ = 46; break; } else { __label__ = 45; break; }
    case 45: // $233
      var $241 = 0;__label__ = 47; break;
    case 46: // $234
      var $235=$2;
      var $236=(($235+416)|0);
      var $237=(($236+12)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($238+1)|0);
      HEAP32[(($237)>>2)]=$239;
      HEAP8[($238)]=0;
      var $241 = 1;__label__ = 47; break;
    case 47: // $240
      var $241;
      var $242=(($241)|0)!=0;
      if ($242) { __label__ = 49; break; } else { __label__ = 48; break; }
    case 48: // $243
      $1=0;
      __label__ = 64; break;
    case 49: // $244
      var $245=$2;
      var $246=$prefix;
      var $247=$2;
      var $248=(($247+416)|0);
      var $249=(($248+16)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=$2;
      var $252=(($251+372)|0);
      var $253=__ZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7binding($245, $246, 0, $250, $252);
      var $254=(($253)|0)!=0;
      if ($254) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $255
      $1=0;
      __label__ = 64; break;
    case 51: // $256
      var $257=$2;
      var $258=(($257+416)|0);
      var $259=(($258+16)|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=$2;
      var $262=(($261+416)|0);
      var $263=(($262+12)|0);
      HEAP32[(($263)>>2)]=$260;
      var $264=$3;
      var $265=HEAP8[($264)];
      var $266=(($265 << 24) >> 24);
      var $267=(($266)|0)!=0;
      if ($267) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $268
      var $269=$3;
      var $270=(($269+1)|0);
      $3=$270;
      __label__ = 53; break;
    case 53: // $271
      var $272=$3;
      $s=$272;
      __label__ = 61; break;
    case 54: // $273
      var $274=$2;
      var $275=(($274+416)|0);
      var $276=(($275+12)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$2;
      var $279=(($278+416)|0);
      var $280=(($279+8)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($277)|0)==(($281)|0);
      if ($282) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $283
      var $284=$2;
      var $285=(($284+416)|0);
      var $286=__ZL8poolGrowP11STRING_POOL($285);
      var $287=(($286 << 24) >> 24)!=0;
      if ($287) { __label__ = 57; break; } else { __label__ = 56; break; }
    case 56: // $288
      var $298 = 0;__label__ = 58; break;
    case 57: // $289
      var $290=$s;
      var $291=HEAP8[($290)];
      var $292=$2;
      var $293=(($292+416)|0);
      var $294=(($293+12)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=(($295+1)|0);
      HEAP32[(($294)>>2)]=$296;
      HEAP8[($295)]=$291;
      var $298 = 1;__label__ = 58; break;
    case 58: // $297
      var $298;
      var $299=(($298)|0)!=0;
      if ($299) { __label__ = 60; break; } else { __label__ = 59; break; }
    case 59: // $300
      $1=0;
      __label__ = 64; break;
    case 60: // $301
      var $302=$s;
      var $303=(($302+1)|0);
      $s=$303;
      __label__ = 61; break;
    case 61: // $304
      __label__ = 62; break;
    case 62: // $305
      __label__ = 1; break;
    case 63: // $306
      $1=1;
      __label__ = 64; break;
    case 64: // $307
      var $308=$1;
      ;
      return $308;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10setContextP16XML_ParserStructPKc["X"]=1;

function _XML_ParserFree($parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $tagList;
      var $entityList;
      var $p;
      var $openEntity;
      $1=$parser;
      var $2=$1;
      var $3=(($2)|0)==0;
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      __label__ = 20; break;
    case 2: // $5
      var $6=$1;
      var $7=(($6+364)|0);
      var $8=HEAP32[(($7)>>2)];
      $tagList=$8;
      __label__ = 3; break;
    case 3: // $9
      var $10=$tagList;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $12
      var $13=$1;
      var $14=(($13+368)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      __label__ = 8; break;
    case 6: // $18
      var $19=$1;
      var $20=(($19+368)|0);
      var $21=HEAP32[(($20)>>2)];
      $tagList=$21;
      var $22=$1;
      var $23=(($22+368)|0);
      HEAP32[(($23)>>2)]=0;
      __label__ = 7; break;
    case 7: // $24
      var $25=$tagList;
      $p=$25;
      var $26=$tagList;
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      $tagList=$28;
      var $29=$1;
      var $30=(($29+12)|0);
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$p;
      var $34=(($33+36)|0);
      var $35=HEAP32[(($34)>>2)];
      FUNCTION_TABLE[$32]($35);
      var $36=$p;
      var $37=(($36+44)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$1;
      __ZL15destroyBindingsP7bindingP16XML_ParserStruct($38, $39);
      var $40=$1;
      var $41=(($40+12)|0);
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$p;
      var $45=$44;
      FUNCTION_TABLE[$43]($45);
      __label__ = 3; break;
    case 8: // $46
      var $47=$1;
      var $48=(($47+300)|0);
      var $49=HEAP32[(($48)>>2)];
      $entityList=$49;
      __label__ = 9; break;
    case 9: // $50
      var $51=$entityList;
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $53
      var $54=$1;
      var $55=(($54+304)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $58
      __label__ = 14; break;
    case 12: // $59
      var $60=$1;
      var $61=(($60+304)|0);
      var $62=HEAP32[(($61)>>2)];
      $entityList=$62;
      var $63=$1;
      var $64=(($63+304)|0);
      HEAP32[(($64)>>2)]=0;
      __label__ = 13; break;
    case 13: // $65
      var $66=$entityList;
      $openEntity=$66;
      var $67=$entityList;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      $entityList=$69;
      var $70=$1;
      var $71=(($70+12)|0);
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$openEntity;
      var $75=$74;
      FUNCTION_TABLE[$73]($75);
      __label__ = 9; break;
    case 14: // $76
      var $77=$1;
      var $78=(($77+376)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$1;
      __ZL15destroyBindingsP7bindingP16XML_ParserStruct($79, $80);
      var $81=$1;
      var $82=(($81+372)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$1;
      __ZL15destroyBindingsP7bindingP16XML_ParserStruct($83, $84);
      var $85=$1;
      var $86=(($85+416)|0);
      __ZL11poolDestroyP11STRING_POOL($86);
      var $87=$1;
      var $88=(($87+440)|0);
      __ZL11poolDestroyP11STRING_POOL($88);
      var $89=$1;
      var $90=(($89+488)|0);
      var $91=HEAP8[($90)];
      var $92=(($91 << 24) >> 24)!=0;
      if ($92) { __label__ = 17; break; } else { __label__ = 15; break; }
    case 15: // $93
      var $94=$1;
      var $95=(($94+356)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $98
      var $99=$1;
      var $100=(($99+356)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$1;
      var $103=(($102+476)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104)|0)!=0;
      var $106=$105 ^ 1;
      var $107=(($106)&1);
      var $108=$1;
      var $109=(($108+12)|0);
      __ZL10dtdDestroyP3DTDhPK25XML_Memory_Handling_Suite($101, $107, $109);
      __label__ = 17; break;
    case 17: // $110
      var $111=$1;
      var $112=(($111+12)|0);
      var $113=(($112+8)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$1;
      var $116=(($115+392)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$117;
      FUNCTION_TABLE[$114]($118);
      var $119=$1;
      var $120=(($119+12)|0);
      var $121=(($120+8)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$1;
      var $124=(($123+464)|0);
      var $125=HEAP32[(($124)>>2)];
      FUNCTION_TABLE[$122]($125);
      var $126=$1;
      var $127=(($126+12)|0);
      var $128=(($127+8)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$1;
      var $131=(($130+8)|0);
      var $132=HEAP32[(($131)>>2)];
      FUNCTION_TABLE[$129]($132);
      var $133=$1;
      var $134=(($133+12)|0);
      var $135=(($134+8)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=$1;
      var $138=(($137+44)|0);
      var $139=HEAP32[(($138)>>2)];
      FUNCTION_TABLE[$136]($139);
      var $140=$1;
      var $141=(($140+12)|0);
      var $142=(($141+8)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=$1;
      var $145=(($144+396)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=$146;
      FUNCTION_TABLE[$143]($147);
      var $148=$1;
      var $149=(($148+12)|0);
      var $150=(($149+8)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$1;
      var $153=(($152+240)|0);
      var $154=HEAP32[(($153)>>2)];
      FUNCTION_TABLE[$151]($154);
      var $155=$1;
      var $156=(($155+252)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $159
      var $160=$1;
      var $161=(($160+252)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$1;
      var $164=(($163+244)|0);
      var $165=HEAP32[(($164)>>2)];
      FUNCTION_TABLE[$162]($165);
      __label__ = 19; break;
    case 19: // $166
      var $167=$1;
      var $168=(($167+12)|0);
      var $169=(($168+8)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$1;
      var $172=$171;
      FUNCTION_TABLE[$170]($172);
      __label__ = 20; break;
    case 20: // $173
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_XML_ParserFree["X"]=1;

function _XML_SetUserData($parser, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$parser;
      $2=$p;
      var $3=$1;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$1;
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=$1;
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$1;
      var $15=(($14+4)|0);
      HEAP32[(($15)>>2)]=$11;
      __label__ = 3; break;
    case 2: // $16
      var $17=$2;
      var $18=$1;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      __label__ = 3; break;
    case 3: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function _XML_SetElementHandler($parser, $start, $end) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$parser;
  $2=$start;
  $3=$end;
  var $4=$2;
  var $5=$1;
  var $6=(($5+52)|0);
  HEAP32[(($6)>>2)]=$4;
  var $7=$3;
  var $8=$1;
  var $9=(($8+56)|0);
  HEAP32[(($9)>>2)]=$7;
  ;
  return;
}


function _XML_SetCharacterDataHandler($parser, $handler) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$parser;
  $2=$handler;
  var $3=$2;
  var $4=$1;
  var $5=(($4+60)|0);
  HEAP32[(($5)>>2)]=$3;
  ;
  return;
}


function __ZL14errorProcessorP16XML_ParserStructPKcS2_PS2_($parser, $s, $end, $nextPtr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$parser;
  $2=$s;
  $3=$end;
  $4=$nextPtr;
  var $5=$1;
  var $6=(($5+284)|0);
  var $7=HEAP32[(($6)>>2)];
  ;
  return $7;
}


function __ZL10parserInitP16XML_ParserStructPKc($parser, $encodingName) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$parser;
      $2=$encodingName;
      var $3=$1;
      var $4=(($3+280)|0);
      HEAP32[(($4)>>2)]=1498;
      var $5=$1;
      var $6=(($5+256)|0);
      _XmlPrologStateInit($6);
      var $7=$2;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+416)|0);
      var $12=$2;
      var $13=__ZL14poolCopyStringP11STRING_POOLPKc($11, $12);
      var $16 = $13;__label__ = 3; break;
    case 2: // $14
      var $16 = 0;__label__ = 3; break;
    case 3: // $15
      var $16;
      var $17=$1;
      var $18=(($17+232)|0);
      HEAP32[(($18)>>2)]=$16;
      var $19=$1;
      var $20=(($19+360)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=$1;
      var $22=(($21+148)|0);
      var $23=$1;
      var $24=(($23+144)|0);
      var $25=_XmlInitEncoding($22, $24, 0);
      var $26=$1;
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=$1;
      var $29=(($28+4)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=$1;
      var $31=(($30+52)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=$1;
      var $33=(($32+56)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=$1;
      var $35=(($34+60)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=$1;
      var $37=(($36+64)|0);
      HEAP32[(($37)>>2)]=0;
      var $38=$1;
      var $39=(($38+68)|0);
      HEAP32[(($39)>>2)]=0;
      var $40=$1;
      var $41=(($40+72)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=$1;
      var $43=(($42+76)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=$1;
      var $45=(($44+80)|0);
      HEAP32[(($45)>>2)]=0;
      var $46=$1;
      var $47=(($46+84)|0);
      HEAP32[(($47)>>2)]=0;
      var $48=$1;
      var $49=(($48+88)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=$1;
      var $51=(($50+92)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=$1;
      var $53=(($52+96)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$1;
      var $55=(($54+100)|0);
      HEAP32[(($55)>>2)]=0;
      var $56=$1;
      var $57=(($56+104)|0);
      HEAP32[(($57)>>2)]=0;
      var $58=$1;
      var $59=(($58+108)|0);
      HEAP32[(($59)>>2)]=0;
      var $60=$1;
      var $61=(($60+112)|0);
      HEAP32[(($61)>>2)]=0;
      var $62=$1;
      var $63=$1;
      var $64=(($63+116)|0);
      HEAP32[(($64)>>2)]=$62;
      var $65=$1;
      var $66=(($65+120)|0);
      HEAP32[(($66)>>2)]=0;
      var $67=$1;
      var $68=(($67+128)|0);
      HEAP32[(($68)>>2)]=0;
      var $69=$1;
      var $70=(($69+132)|0);
      HEAP32[(($70)>>2)]=0;
      var $71=$1;
      var $72=(($71+136)|0);
      HEAP32[(($72)>>2)]=0;
      var $73=$1;
      var $74=(($73+140)|0);
      HEAP32[(($74)>>2)]=0;
      var $75=$1;
      var $76=(($75+8)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$1;
      var $79=(($78+24)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$1;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$1;
      var $84=(($83+28)|0);
      HEAP32[(($84)>>2)]=$82;
      var $85=$1;
      var $86=(($85+36)|0);
      HEAP32[(($86)>>2)]=0;
      var $87=$1;
      var $88=(($87+40)|0);
      HEAP32[(($88)>>2)]=0;
      var $89=$1;
      var $90=(($89+344)|0);
      HEAP32[(($90)>>2)]=0;
      var $91=$1;
      var $92=(($91+348)|0);
      HEAP32[(($92)>>2)]=0;
      var $93=$1;
      var $94=(($93+316)|0);
      HEAP32[(($94)>>2)]=0;
      var $95=$1;
      var $96=(($95+320)|0);
      HEAP32[(($96)>>2)]=0;
      var $97=$1;
      var $98=(($97+324)|0);
      HEAP32[(($98)>>2)]=0;
      var $99=$1;
      var $100=(($99+328)|0);
      HEAP32[(($100)>>2)]=0;
      var $101=$1;
      var $102=(($101+332)|0);
      HEAP32[(($102)>>2)]=0;
      var $103=$1;
      var $104=(($103+336)|0);
      HEAP32[(($104)>>2)]=0;
      var $105=$1;
      var $106=(($105+340)|0);
      HEAP32[(($106)>>2)]=0;
      var $107=$1;
      var $108=(($107+352)|0);
      HEAP8[($108)]=0;
      var $109=$1;
      var $110=(($109+353)|0);
      HEAP8[($110)]=0;
      var $111=$1;
      var $112=(($111+408)|0);
      var $113=$112;
      HEAP8[($113)]=0; HEAP8[($113+1)]=0; HEAP8[($113+2)]=0; HEAP8[($113+3)]=0; HEAP8[($113+4)]=0; HEAP8[($113+5)]=0; HEAP8[($113+6)]=0; HEAP8[($113+7)]=0;
      var $114=$1;
      var $115=(($114+284)|0);
      HEAP32[(($115)>>2)]=0;
      var $116=$1;
      var $117=(($116+288)|0);
      HEAP32[(($117)>>2)]=0;
      var $118=$1;
      var $119=(($118+292)|0);
      HEAP32[(($119)>>2)]=0;
      var $120=$1;
      var $121=(($120+296)|0);
      HEAP32[(($121)>>2)]=0;
      var $122=$1;
      var $123=(($122+300)|0);
      HEAP32[(($123)>>2)]=0;
      var $124=$1;
      var $125=(($124+308)|0);
      HEAP8[($125)]=1;
      var $126=$1;
      var $127=(($126+312)|0);
      HEAP32[(($127)>>2)]=0;
      var $128=$1;
      var $129=(($128+364)|0);
      HEAP32[(($129)>>2)]=0;
      var $130=$1;
      var $131=(($130+372)|0);
      HEAP32[(($131)>>2)]=0;
      var $132=$1;
      var $133=(($132+384)|0);
      HEAP32[(($133)>>2)]=0;
      var $134=$1;
      var $135=(($134+240)|0);
      HEAP32[(($135)>>2)]=0;
      var $136=$1;
      var $137=(($136+252)|0);
      HEAP32[(($137)>>2)]=0;
      var $138=$1;
      var $139=(($138+244)|0);
      HEAP32[(($139)>>2)]=0;
      var $140=$1;
      var $141=(($140+476)|0);
      HEAP32[(($141)>>2)]=0;
      var $142=$1;
      var $143=(($142+480)|0);
      var $144=(($143)|0);
      HEAP32[(($144)>>2)]=0;
      var $145=$1;
      var $146=(($145+488)|0);
      HEAP8[($146)]=0;
      var $147=$1;
      var $148=(($147+489)|0);
      HEAP8[($148)]=0;
      var $149=$1;
      var $150=(($149+492)|0);
      HEAP32[(($150)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10parserInitP16XML_ParserStructPKc["X"]=1;

function __ZL14poolCopyStringP11STRING_POOLPKc($pool, $s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$pool;
      $3=$s;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($7)|0)==(($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$2;
      var $14=__ZL8poolGrowP11STRING_POOL($13);
      var $15=(($14 << 24) >> 24)!=0;
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $25 = 0;__label__ = 5; break;
    case 4: // $17
      var $18=$3;
      var $19=HEAP8[($18)];
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+1)|0);
      HEAP32[(($21)>>2)]=$23;
      HEAP8[($22)]=$19;
      var $25 = 1;__label__ = 5; break;
    case 5: // $24
      var $25;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $27
      $1=0;
      __label__ = 10; break;
    case 7: // $28
      __label__ = 8; break;
    case 8: // $29
      var $30=$3;
      var $31=(($30+1)|0);
      $3=$31;
      var $32=HEAP8[($30)];
      var $33=(($32 << 24) >> 24)!=0;
      if ($33) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 9: // $34
      var $35=$2;
      var $36=(($35+16)|0);
      var $37=HEAP32[(($36)>>2)];
      $3=$37;
      var $38=$2;
      var $39=(($38+12)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$2;
      var $42=(($41+16)|0);
      HEAP32[(($42)>>2)]=$40;
      var $43=$3;
      $1=$43;
      __label__ = 10; break;
    case 10: // $44
      var $45=$1;
      ;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14poolCopyStringP11STRING_POOLPKc["X"]=1;

function __ZL15destroyBindingsP7bindingP16XML_ParserStruct($bindings, $parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $b;
      $1=$bindings;
      $2=$parser;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      $b=$4;
      var $5=$b;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $7
      __label__ = 4; break;
    case 3: // $8
      var $9=$b;
      var $10=(($9+4)|0);
      var $11=HEAP32[(($10)>>2)];
      $1=$11;
      var $12=$2;
      var $13=(($12+12)|0);
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$b;
      var $17=(($16+16)|0);
      var $18=HEAP32[(($17)>>2)];
      FUNCTION_TABLE[$15]($18);
      var $19=$2;
      var $20=(($19+12)|0);
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$b;
      var $24=$23;
      FUNCTION_TABLE[$22]($24);
      __label__ = 1; break;
    case 4: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11poolDestroyP11STRING_POOL($pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $p;
      var $tem;
      var $tem1;
      $1=$pool;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      $p=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$p;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $8
      var $9=$p;
      var $10=(($9)|0);
      var $11=HEAP32[(($10)>>2)];
      $tem=$11;
      var $12=$1;
      var $13=(($12+20)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$p;
      var $18=$17;
      FUNCTION_TABLE[$16]($18);
      var $19=$tem;
      $p=$19;
      __label__ = 1; break;
    case 3: // $20
      var $21=$1;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      $p=$23;
      __label__ = 4; break;
    case 4: // $24
      var $25=$p;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      var $28=$p;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      $tem1=$30;
      var $31=$1;
      var $32=(($31+20)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$p;
      var $37=$36;
      FUNCTION_TABLE[$35]($37);
      var $38=$tem1;
      $p=$38;
      __label__ = 4; break;
    case 6: // $39
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11poolDestroyP11STRING_POOL["X"]=1;

function __ZL10dtdDestroyP3DTDhPK25XML_Memory_Handling_Suite($p, $isDocEntity, $ms) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $iter=__stackBase__;
      var $e;
      $1=$p;
      $2=$isDocEntity;
      $3=$ms;
      var $4=$1;
      var $5=(($4+20)|0);
      __ZL17hashTableIterInitP15HASH_TABLE_ITERPK10HASH_TABLE($iter, $5);
      __label__ = 1; break;
    case 1: // $6
      var $7=__ZL17hashTableIterNextP15HASH_TABLE_ITER($iter);
      var $8=$7;
      $e=$8;
      var $9=$e;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $11
      __label__ = 6; break;
    case 3: // $12
      var $13=$e;
      var $14=(($13+16)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$e;
      var $22=(($21+20)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$23;
      FUNCTION_TABLE[$20]($24);
      __label__ = 5; break;
    case 5: // $25
      __label__ = 1; break;
    case 6: // $26
      var $27=$1;
      var $28=(($27)|0);
      __ZL16hashTableDestroyP10HASH_TABLE($28);
      var $29=$1;
      var $30=(($29+132)|0);
      __ZL16hashTableDestroyP10HASH_TABLE($30);
      var $31=$1;
      var $32=(($31+20)|0);
      __ZL16hashTableDestroyP10HASH_TABLE($32);
      var $33=$1;
      var $34=(($33+40)|0);
      __ZL16hashTableDestroyP10HASH_TABLE($34);
      var $35=$1;
      var $36=(($35+60)|0);
      __ZL16hashTableDestroyP10HASH_TABLE($36);
      var $37=$1;
      var $38=(($37+80)|0);
      __ZL11poolDestroyP11STRING_POOL($38);
      var $39=$1;
      var $40=(($39+104)|0);
      __ZL11poolDestroyP11STRING_POOL($40);
      var $41=$2;
      var $42=(($41 << 24) >> 24)!=0;
      if ($42) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $43
      var $44=$3;
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$1;
      var $48=(($47+184)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$49;
      FUNCTION_TABLE[$46]($50);
      var $51=$3;
      var $52=(($51+8)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$1;
      var $55=(($54+164)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$56;
      FUNCTION_TABLE[$53]($57);
      __label__ = 8; break;
    case 8: // $58
      var $59=$3;
      var $60=(($59+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$1;
      var $63=$62;
      FUNCTION_TABLE[$61]($63);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10dtdDestroyP3DTDhPK25XML_Memory_Handling_Suite["X"]=1;

function _XML_Parse($parser, $s, $len, $isFinal) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $buff;
      $2=$parser;
      $3=$s;
      $4=$len;
      $5=$isFinal;
      var $6=$2;
      var $7=(($6+480)|0);
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      if ($9 == 3) {
        __label__ = 1; break;
      }
      else if ($9 == 2) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $10
      var $11=$2;
      var $12=(($11+284)|0);
      HEAP32[(($12)>>2)]=33;
      $1=0;
      __label__ = 16; break;
    case 2: // $13
      var $14=$2;
      var $15=(($14+284)|0);
      HEAP32[(($15)>>2)]=36;
      $1=0;
      __label__ = 16; break;
    case 3: // $16
      var $17=$2;
      var $18=(($17+480)|0);
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=1;
      __label__ = 4; break;
    case 4: // $20
      var $21=$4;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $23
      var $24=$5;
      var $25=(($24) & 255);
      var $26=$2;
      var $27=(($26+480)|0);
      var $28=(($27+4)|0);
      HEAP8[($28)]=$25;
      var $29=$5;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $31
      $1=1;
      __label__ = 16; break;
    case 7: // $32
      var $33=$2;
      var $34=(($33+24)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$2;
      var $37=(($36+296)|0);
      HEAP32[(($37)>>2)]=$35;
      var $38=$2;
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$2;
      var $42=(($41+40)|0);
      HEAP32[(($42)>>2)]=$40;
      var $43=$2;
      var $44=(($43+280)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$2;
      var $47=$2;
      var $48=(($47+24)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$2;
      var $51=(($50+40)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$2;
      var $54=(($53+24)|0);
      var $55=FUNCTION_TABLE[$45]($46, $49, $52, $54);
      var $56=$2;
      var $57=(($56+284)|0);
      HEAP32[(($57)>>2)]=$55;
      var $58=$2;
      var $59=(($58+284)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 8; break; } else { __label__ = 12; break; }
    case 8: // $62
      var $63=$2;
      var $64=(($63+480)|0);
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      if ($66 == 3) {
        __label__ = 9; break;
      }
      else if ($66 == 0 || $66 == 1) {
        __label__ = 10; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 9: // $67
      var $68=$2;
      var $69=(($68+144)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+52)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$2;
      var $74=(($73+144)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$2;
      var $77=(($76+296)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$2;
      var $80=(($79+24)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$2;
      var $83=(($82+408)|0);
      FUNCTION_TABLE[$72]($75, $78, $81, $83);
      var $84=$2;
      var $85=(($84+24)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$2;
      var $88=(($87+296)|0);
      HEAP32[(($88)>>2)]=$86;
      $1=2;
      __label__ = 16; break;
    case 10: // $89
      var $90=$2;
      var $91=(($90+480)|0);
      var $92=(($91)|0);
      HEAP32[(($92)>>2)]=2;
      __label__ = 11; break;
    case 11: // $93
      $1=1;
      __label__ = 16; break;
    case 12: // $94
      var $95=$2;
      var $96=(($95+288)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$2;
      var $99=(($98+292)|0);
      HEAP32[(($99)>>2)]=$97;
      var $100=$2;
      var $101=(($100+280)|0);
      HEAP32[(($101)>>2)]=1500;
      $1=0;
      __label__ = 16; break;
    case 13: // $102
      var $103=$2;
      var $104=$4;
      var $105=_XML_GetBuffer($103, $104);
      $buff=$105;
      var $106=$buff;
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $108
      $1=0;
      __label__ = 16; break;
    case 15: // $109
      var $110=$buff;
      var $111=$3;
      var $112=$4;
      assert($112 % 1 === 0, 'memcpy given ' + $112 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($110, $111, $112, 1);
      var $113=$2;
      var $114=$4;
      var $115=$5;
      var $116=_XML_ParseBuffer($113, $114, $115);
      $1=$116;
      __label__ = 16; break;
    case 16: // $117
      var $118=$1;
      ;
      return $118;
    default: assert(0, "bad label: " + __label__);
  }
}
_XML_Parse["X"]=1;

function _XML_GetErrorCode($parser) {
  ;
  var __label__;

  var $1;
  $1=$parser;
  var $2=$1;
  var $3=(($2+284)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function _XML_ErrorString($code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$code;
      var $3=$2;
      var $4=(($3)|0) > 0;
      if ($4) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6)>>>0) < 41;
      if ($7) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $8
      var $9=$2;
      var $10=((__ZZ15XML_ErrorStringE7message+($9<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      $1=$11;
      __label__ = 4; break;
    case 3: // $12
      $1=0;
      __label__ = 4; break;
    case 4: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function _XML_GetBuffer($parser, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $neededSize;
      var $keep;
      var $offset;
      var $newBuf;
      var $bufferSize;
      var $keep1;
      $2=$parser;
      $3=$len;
      var $4=$2;
      var $5=(($4+480)|0);
      var $6=(($5)|0);
      var $7=HEAP32[(($6)>>2)];
      if ($7 == 3) {
        __label__ = 1; break;
      }
      else if ($7 == 2) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      var $9=$2;
      var $10=(($9+284)|0);
      HEAP32[(($10)>>2)]=33;
      $1=0;
      __label__ = 26; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12+284)|0);
      HEAP32[(($13)>>2)]=36;
      $1=0;
      __label__ = 26; break;
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$3;
      var $17=$2;
      var $18=(($17+32)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=(($20+28)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$19;
      var $24=$22;
      var $25=(($23-$24)|0);
      var $26=(($16)|0) > (($25)|0);
      if ($26) { __label__ = 5; break; } else { __label__ = 25; break; }
    case 5: // $27
      var $28=$3;
      var $29=$2;
      var $30=(($29+28)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$2;
      var $33=(($32+24)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$31;
      var $36=$34;
      var $37=(($35-$36)|0);
      var $38=(($28+$37)|0);
      $neededSize=$38;
      var $39=$2;
      var $40=(($39+24)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$2;
      var $43=(($42+8)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$41;
      var $46=$44;
      var $47=(($45-$46)|0);
      $keep=$47;
      var $48=$keep;
      var $49=(($48)|0) > 1024;
      if ($49) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $50
      $keep=1024;
      __label__ = 7; break;
    case 7: // $51
      var $52=$keep;
      var $53=$neededSize;
      var $54=(($53+$52)|0);
      $neededSize=$54;
      var $55=$neededSize;
      var $56=$2;
      var $57=(($56+32)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$2;
      var $60=(($59+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$58;
      var $63=$61;
      var $64=(($62-$63)|0);
      var $65=(($55)|0) <= (($64)|0);
      if ($65) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $66
      var $67=$keep;
      var $68=$2;
      var $69=(($68+24)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$2;
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$70;
      var $75=$73;
      var $76=(($74-$75)|0);
      var $77=(($67)|0) < (($76)|0);
      if ($77) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $78
      var $79=$2;
      var $80=(($79+24)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$2;
      var $83=(($82+8)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$81;
      var $86=$84;
      var $87=(($85-$86)|0);
      var $88=$keep;
      var $89=(($87-$88)|0);
      $offset=$89;
      var $90=$2;
      var $91=(($90+8)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$offset;
      var $94=$2;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96+$93)|0);
      var $98=$2;
      var $99=(($98+28)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$2;
      var $102=(($101+24)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$100;
      var $105=$103;
      var $106=(($104-$105)|0);
      var $107=$keep;
      var $108=(($106+$107)|0);
      _llvm_memmove_p0i8_p0i8_i32($92, $97, $108, 1, 0);
      var $109=$offset;
      var $110=$2;
      var $111=(($110+28)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(((-$109))|0);
      var $114=(($112+$113)|0);
      HEAP32[(($111)>>2)]=$114;
      var $115=$offset;
      var $116=$2;
      var $117=(($116+24)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(((-$115))|0);
      var $120=(($118+$119)|0);
      HEAP32[(($117)>>2)]=$120;
      __label__ = 10; break;
    case 10: // $121
      __label__ = 24; break;
    case 11: // $122
      var $123=$2;
      var $124=(($123+32)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$2;
      var $127=(($126+24)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$125;
      var $130=$128;
      var $131=(($129-$130)|0);
      $bufferSize=$131;
      var $132=$bufferSize;
      var $133=(($132)|0)==0;
      if ($133) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $134
      $bufferSize=1024;
      __label__ = 13; break;
    case 13: // $135
      __label__ = 14; break;
    case 14: // $136
      var $137=$bufferSize;
      var $138=((($137<<1))|0);
      $bufferSize=$138;
      __label__ = 15; break;
    case 15: // $139
      var $140=$bufferSize;
      var $141=$neededSize;
      var $142=(($140)|0) < (($141)|0);
      if ($142) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 16: // $143
      var $144=$2;
      var $145=(($144+12)|0);
      var $146=(($145)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$bufferSize;
      var $149=FUNCTION_TABLE[$147]($148);
      $newBuf=$149;
      var $150=$newBuf;
      var $151=(($150)|0)==0;
      if ($151) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $152
      var $153=$2;
      var $154=(($153+284)|0);
      HEAP32[(($154)>>2)]=1;
      $1=0;
      __label__ = 26; break;
    case 18: // $155
      var $156=$newBuf;
      var $157=$bufferSize;
      var $158=(($156+$157)|0);
      var $159=$2;
      var $160=(($159+32)|0);
      HEAP32[(($160)>>2)]=$158;
      var $161=$2;
      var $162=(($161+24)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $165
      var $166=$2;
      var $167=(($166+24)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$2;
      var $170=(($169+8)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$168;
      var $173=$171;
      var $174=(($172-$173)|0);
      $keep1=$174;
      var $175=$keep1;
      var $176=(($175)|0) > 1024;
      if ($176) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $177
      $keep1=1024;
      __label__ = 21; break;
    case 21: // $178
      var $179=$newBuf;
      var $180=$keep1;
      var $181=(((-$180))|0);
      var $182=$2;
      var $183=(($182+24)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($184+$181)|0);
      var $186=$2;
      var $187=(($186+28)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$2;
      var $190=(($189+24)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$188;
      var $193=$191;
      var $194=(($192-$193)|0);
      var $195=$keep1;
      var $196=(($194+$195)|0);
      assert($196 % 1 === 0, 'memcpy given ' + $196 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($179, $185, $196, 1);
      var $197=$2;
      var $198=(($197+12)|0);
      var $199=(($198+8)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=$2;
      var $202=(($201+8)|0);
      var $203=HEAP32[(($202)>>2)];
      FUNCTION_TABLE[$200]($203);
      var $204=$newBuf;
      var $205=$2;
      var $206=(($205+8)|0);
      HEAP32[(($206)>>2)]=$204;
      var $207=$2;
      var $208=(($207+8)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$2;
      var $211=(($210+28)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=$2;
      var $214=(($213+24)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=$212;
      var $217=$215;
      var $218=(($216-$217)|0);
      var $219=(($209+$218)|0);
      var $220=$keep1;
      var $221=(($219+$220)|0);
      var $222=$2;
      var $223=(($222+28)|0);
      HEAP32[(($223)>>2)]=$221;
      var $224=$2;
      var $225=(($224+8)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$keep1;
      var $228=(($226+$227)|0);
      var $229=$2;
      var $230=(($229+24)|0);
      HEAP32[(($230)>>2)]=$228;
      __label__ = 23; break;
    case 22: // $231
      var $232=$newBuf;
      var $233=$2;
      var $234=(($233+28)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=$2;
      var $237=(($236+24)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$235;
      var $240=$238;
      var $241=(($239-$240)|0);
      var $242=(($232+$241)|0);
      var $243=$2;
      var $244=(($243+28)|0);
      HEAP32[(($244)>>2)]=$242;
      var $245=$newBuf;
      var $246=$2;
      var $247=(($246+8)|0);
      HEAP32[(($247)>>2)]=$245;
      var $248=$2;
      var $249=(($248+24)|0);
      HEAP32[(($249)>>2)]=$245;
      __label__ = 23; break;
    case 23: // $250
      __label__ = 24; break;
    case 24: // $251
      __label__ = 25; break;
    case 25: // $252
      var $253=$2;
      var $254=(($253+28)|0);
      var $255=HEAP32[(($254)>>2)];
      $1=$255;
      __label__ = 26; break;
    case 26: // $256
      var $257=$1;
      ;
      return $257;
    default: assert(0, "bad label: " + __label__);
  }
}
_XML_GetBuffer["X"]=1;

function _XML_ParseBuffer($parser, $len, $isFinal) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $start;
      var $result;
      $2=$parser;
      $3=$len;
      $4=$isFinal;
      $result=1;
      var $5=$2;
      var $6=(($5+480)|0);
      var $7=(($6)|0);
      var $8=HEAP32[(($7)>>2)];
      if ($8 == 3) {
        __label__ = 1; break;
      }
      else if ($8 == 2) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $9
      var $10=$2;
      var $11=(($10+284)|0);
      HEAP32[(($11)>>2)]=33;
      $1=0;
      __label__ = 14; break;
    case 2: // $12
      var $13=$2;
      var $14=(($13+284)|0);
      HEAP32[(($14)>>2)]=36;
      $1=0;
      __label__ = 14; break;
    case 3: // $15
      var $16=$2;
      var $17=(($16+480)|0);
      var $18=(($17)|0);
      HEAP32[(($18)>>2)]=1;
      __label__ = 4; break;
    case 4: // $19
      var $20=$2;
      var $21=(($20+24)|0);
      var $22=HEAP32[(($21)>>2)];
      $start=$22;
      var $23=$start;
      var $24=$2;
      var $25=(($24+296)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$3;
      var $27=$2;
      var $28=(($27+28)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+$26)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$2;
      var $32=(($31+28)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$2;
      var $35=(($34+40)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$3;
      var $37=$2;
      var $38=(($37+36)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+$36)|0);
      HEAP32[(($38)>>2)]=$40;
      var $41=$4;
      var $42=(($41) & 255);
      var $43=$2;
      var $44=(($43+480)|0);
      var $45=(($44+4)|0);
      HEAP8[($45)]=$42;
      var $46=$2;
      var $47=(($46+280)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$2;
      var $50=$start;
      var $51=$2;
      var $52=(($51+40)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$2;
      var $55=(($54+24)|0);
      var $56=FUNCTION_TABLE[$48]($49, $50, $53, $55);
      var $57=$2;
      var $58=(($57+284)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=$2;
      var $60=(($59+284)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $63
      var $64=$2;
      var $65=(($64+288)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$2;
      var $68=(($67+292)|0);
      HEAP32[(($68)>>2)]=$66;
      var $69=$2;
      var $70=(($69+280)|0);
      HEAP32[(($70)>>2)]=1500;
      $1=0;
      __label__ = 14; break;
    case 6: // $71
      var $72=$2;
      var $73=(($72+480)|0);
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      if ($75 == 3) {
        __label__ = 7; break;
      }
      else if ($75 == 0 || $75 == 1) {
        __label__ = 8; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 7: // $76
      $result=2;
      __label__ = 12; break;
    case 8: // $77
      var $78=$4;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $80
      var $81=$2;
      var $82=(($81+480)|0);
      var $83=(($82)|0);
      HEAP32[(($83)>>2)]=2;
      var $84=$result;
      $1=$84;
      __label__ = 14; break;
    case 10: // $85
      __label__ = 11; break;
    case 11: // $86
      __label__ = 12; break;
    case 12: // $87
      __label__ = 13; break;
    case 13: // $88
      var $89=$2;
      var $90=(($89+144)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91+52)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$2;
      var $95=(($94+144)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$2;
      var $98=(($97+296)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$2;
      var $101=(($100+24)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$2;
      var $104=(($103+408)|0);
      FUNCTION_TABLE[$93]($96, $99, $102, $104);
      var $105=$2;
      var $106=(($105+24)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$2;
      var $109=(($108+296)|0);
      HEAP32[(($109)>>2)]=$107;
      var $110=$result;
      $1=$110;
      __label__ = 14; break;
    case 14: // $111
      var $112=$1;
      ;
      return $112;
    default: assert(0, "bad label: " + __label__);
  }
}
_XML_ParseBuffer["X"]=1;

function _XML_GetCurrentLineNumber($parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$parser;
      var $2=$1;
      var $3=(($2+288)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+288)|0);
      var $9=HEAPU32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+296)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($9)>>>0) >= (($12)>>>0);
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$1;
      var $16=(($15+144)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+52)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      var $21=(($20+144)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=(($23+296)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$1;
      var $27=(($26+288)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$1;
      var $30=(($29+408)|0);
      FUNCTION_TABLE[$19]($22, $25, $28, $30);
      var $31=$1;
      var $32=(($31+288)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+296)|0);
      HEAP32[(($35)>>2)]=$33;
      __label__ = 3; break;
    case 3: // $36
      var $37=$1;
      var $38=(($37+408)|0);
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+1)|0);
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}


function _XML_GetCurrentColumnNumber($parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$parser;
      var $2=$1;
      var $3=(($2+288)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+288)|0);
      var $9=HEAPU32[(($8)>>2)];
      var $10=$1;
      var $11=(($10+296)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($9)>>>0) >= (($12)>>>0);
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$1;
      var $16=(($15+144)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+52)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      var $21=(($20+144)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$1;
      var $24=(($23+296)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$1;
      var $27=(($26+288)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$1;
      var $30=(($29+408)|0);
      FUNCTION_TABLE[$19]($22, $25, $28, $30);
      var $31=$1;
      var $32=(($31+288)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$1;
      var $35=(($34+296)|0);
      HEAP32[(($35)>>2)]=$33;
      __label__ = 3; break;
    case 3: // $36
      var $37=$1;
      var $38=(($37+408)|0);
      var $39=(($38+4)|0);
      var $40=HEAP32[(($39)>>2)];
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($parser, $enc, $s, $end) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $eventPP;
      var $eventEndPP;
      var $dataPtr=__stackBase__+4;
      $1=$parser;
      $2=$enc;
      HEAP32[(($3)>>2)]=$s;
      $4=$end;
      var $5=$2;
      var $6=(($5+72)|0);
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24)!=0;
      if ($8) { __label__ = 8; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=$1;
      var $12=(($11+144)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($10)|0)==(($13)|0);
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$1;
      var $17=(($16+288)|0);
      $eventPP=$17;
      var $18=$1;
      var $19=(($18+292)|0);
      $eventEndPP=$19;
      __label__ = 4; break;
    case 3: // $20
      var $21=$1;
      var $22=(($21+300)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0);
      $eventPP=$24;
      var $25=$1;
      var $26=(($25+300)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+4)|0);
      $eventEndPP=$28;
      __label__ = 4; break;
    case 4: // $29
      __label__ = 5; break;
    case 5: // $30
      var $31=$1;
      var $32=(($31+44)|0);
      var $33=HEAP32[(($32)>>2)];
      HEAP32[(($dataPtr)>>2)]=$33;
      var $34=$2;
      var $35=(($34+60)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$2;
      var $38=$4;
      var $39=$1;
      var $40=(($39+48)|0);
      var $41=HEAP32[(($40)>>2)];
      FUNCTION_TABLE[$36]($37, $3, $38, $dataPtr, $41);
      var $42=HEAP32[(($3)>>2)];
      var $43=$eventEndPP;
      HEAP32[(($43)>>2)]=$42;
      var $44=$1;
      var $45=(($44+80)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$1;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$1;
      var $51=(($50+44)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=HEAP32[(($dataPtr)>>2)];
      var $54=$1;
      var $55=(($54+44)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$53;
      var $58=$56;
      var $59=(($57-$58)|0);
      FUNCTION_TABLE[$46]($49, $52, $59);
      var $60=HEAP32[(($3)>>2)];
      var $61=$eventPP;
      HEAP32[(($61)>>2)]=$60;
      __label__ = 6; break;
    case 6: // $62
      var $63=HEAP32[(($3)>>2)];
      var $64=$4;
      var $65=(($63)|0)!=(($64)|0);
      if ($65) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 7: // $66
      __label__ = 9; break;
    case 8: // $67
      var $68=$1;
      var $69=(($68+80)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$1;
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=HEAP32[(($3)>>2)];
      var $75=$4;
      var $76=HEAP32[(($3)>>2)];
      var $77=$75;
      var $78=$76;
      var $79=(($77-$78)|0);
      FUNCTION_TABLE[$70]($73, $74, $79);
      __label__ = 9; break;
    case 9: // $80
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_["X"]=1;

function __ZL17hashTableIterInitP15HASH_TABLE_ITERPK10HASH_TABLE($iter, $table) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$iter;
  $2=$table;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$1;
  var $7=(($6)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=$1;
  var $9=(($8)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=$2;
  var $12=(($11+8)|0);
  var $13=HEAP32[(($12)>>2)];
  var $14=(($10+($13<<2))|0);
  var $15=$1;
  var $16=(($15+4)|0);
  HEAP32[(($16)>>2)]=$14;
  ;
  return;
}


function __ZL17hashTableIterNextP15HASH_TABLE_ITER($iter) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tem;
      $2=$iter;
      __label__ = 1; break;
    case 1: // $3
      var $4=$2;
      var $5=(($4)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$2;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=$2;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+4)|0);
      HEAP32[(($13)>>2)]=$15;
      var $16=HEAP32[(($14)>>2)];
      $tem=$16;
      var $17=$tem;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$tem;
      $1=$20;
      __label__ = 6; break;
    case 4: // $21
      __label__ = 1; break;
    case 5: // $22
      $1=0;
      __label__ = 6; break;
    case 6: // $23
      var $24=$1;
      ;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8poolGrowP11STRING_POOL($pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tem;
      var $blockSize;
      var $tem1;
      var $blockSize2;
      $2=$pool;
      var $3=$2;
      var $4=(($3+4)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+16)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      var $13=$2;
      var $14=(($13+4)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($16)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$2;
      var $19=(($18+4)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$2;
      var $24=(($23+4)|0);
      HEAP32[(($24)>>2)]=$22;
      var $25=$2;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=$2;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+8)|0);
      var $33=(($32)|0);
      var $34=$2;
      var $35=(($34+16)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$2;
      var $37=(($36+16)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($38+$43)|0);
      var $45=$2;
      var $46=(($45+8)|0);
      HEAP32[(($46)>>2)]=$44;
      var $47=$2;
      var $48=(($47+16)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$2;
      var $51=(($50+12)|0);
      HEAP32[(($51)>>2)]=$49;
      $1=1;
      __label__ = 20; break;
    case 3: // $52
      var $53=$2;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$2;
      var $57=(($56+16)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$55;
      var $60=$58;
      var $61=(($59-$60)|0);
      var $62=$2;
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+4)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($61)|0) < (($66)|0);
      if ($67) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $68
      var $69=$2;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      $tem=$73;
      var $74=$2;
      var $75=(($74)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$2;
      var $78=(($77+4)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0);
      HEAP32[(($80)>>2)]=$76;
      var $81=$2;
      var $82=(($81+4)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$2;
      var $85=(($84)|0);
      HEAP32[(($85)>>2)]=$83;
      var $86=$tem;
      var $87=$2;
      var $88=(($87+4)|0);
      HEAP32[(($88)>>2)]=$86;
      var $89=$2;
      var $90=(($89)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91+8)|0);
      var $93=(($92)|0);
      var $94=$2;
      var $95=(($94+16)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$2;
      var $98=(($97+8)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$2;
      var $101=(($100+16)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$99;
      var $104=$102;
      var $105=(($103-$104)|0);
      var $106=(($105)|0);
      assert($106 % 1 === 0, 'memcpy given ' + $106 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($93, $96, $106, 1);
      var $107=$2;
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+8)|0);
      var $111=(($110)|0);
      var $112=$2;
      var $113=(($112+12)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$2;
      var $116=(($115+16)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$114;
      var $119=$117;
      var $120=(($118-$119)|0);
      var $121=(($111+$120)|0);
      var $122=$2;
      var $123=(($122+12)|0);
      HEAP32[(($123)>>2)]=$121;
      var $124=$2;
      var $125=(($124)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+8)|0);
      var $128=(($127)|0);
      var $129=$2;
      var $130=(($129+16)|0);
      HEAP32[(($130)>>2)]=$128;
      var $131=$2;
      var $132=(($131+16)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$2;
      var $135=(($134)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+4)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($133+$138)|0);
      var $140=$2;
      var $141=(($140+8)|0);
      HEAP32[(($141)>>2)]=$139;
      $1=1;
      __label__ = 20; break;
    case 5: // $142
      __label__ = 6; break;
    case 6: // $143
      var $144=$2;
      var $145=(($144)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($146)|0)!=0;
      if ($147) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $148
      var $149=$2;
      var $150=(($149+16)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$2;
      var $153=(($152)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($154+8)|0);
      var $156=(($155)|0);
      var $157=(($151)|0)==(($156)|0);
      if ($157) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $158
      var $159=$2;
      var $160=(($159+8)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$2;
      var $163=(($162+16)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$161;
      var $166=$164;
      var $167=(($165-$166)|0);
      var $168=((($167<<1))|0);
      $blockSize=$168;
      var $169=$2;
      var $170=(($169+20)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171+4)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=$2;
      var $175=(($174)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$176;
      var $178=$blockSize;
      var $179=(($178)|0);
      var $180=(($179+8)|0);
      var $181=FUNCTION_TABLE[$173]($177, $180);
      var $182=$181;
      var $183=$2;
      var $184=(($183)|0);
      HEAP32[(($184)>>2)]=$182;
      var $185=$2;
      var $186=(($185)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187)|0)==0;
      if ($188) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $189
      $1=0;
      __label__ = 20; break;
    case 10: // $190
      var $191=$blockSize;
      var $192=$2;
      var $193=(($192)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194+4)|0);
      HEAP32[(($195)>>2)]=$191;
      var $196=$2;
      var $197=(($196)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198+8)|0);
      var $200=(($199)|0);
      var $201=$2;
      var $202=(($201+12)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$2;
      var $205=(($204+16)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=$203;
      var $208=$206;
      var $209=(($207-$208)|0);
      var $210=(($200+$209)|0);
      var $211=$2;
      var $212=(($211+12)|0);
      HEAP32[(($212)>>2)]=$210;
      var $213=$2;
      var $214=(($213)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(($215+8)|0);
      var $217=(($216)|0);
      var $218=$2;
      var $219=(($218+16)|0);
      HEAP32[(($219)>>2)]=$217;
      var $220=$2;
      var $221=(($220+16)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=$blockSize;
      var $224=(($222+$223)|0);
      var $225=$2;
      var $226=(($225+8)|0);
      HEAP32[(($226)>>2)]=$224;
      __label__ = 19; break;
    case 11: // $227
      var $228=$2;
      var $229=(($228+8)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$2;
      var $232=(($231+16)|0);
      var $233=HEAP32[(($232)>>2)];
      var $234=$230;
      var $235=$233;
      var $236=(($234-$235)|0);
      $blockSize2=$236;
      var $237=$blockSize2;
      var $238=(($237)|0) < 1024;
      if ($238) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $239
      $blockSize2=1024;
      __label__ = 14; break;
    case 13: // $240
      var $241=$blockSize2;
      var $242=((($241<<1))|0);
      $blockSize2=$242;
      __label__ = 14; break;
    case 14: // $243
      var $244=$2;
      var $245=(($244+20)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=$blockSize2;
      var $250=(($249)|0);
      var $251=(($250+8)|0);
      var $252=FUNCTION_TABLE[$248]($251);
      var $253=$252;
      $tem1=$253;
      var $254=$tem1;
      var $255=(($254)|0)!=0;
      if ($255) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $256
      $1=0;
      __label__ = 20; break;
    case 16: // $257
      var $258=$blockSize2;
      var $259=$tem1;
      var $260=(($259+4)|0);
      HEAP32[(($260)>>2)]=$258;
      var $261=$2;
      var $262=(($261)|0);
      var $263=HEAP32[(($262)>>2)];
      var $264=$tem1;
      var $265=(($264)|0);
      HEAP32[(($265)>>2)]=$263;
      var $266=$tem1;
      var $267=$2;
      var $268=(($267)|0);
      HEAP32[(($268)>>2)]=$266;
      var $269=$2;
      var $270=(($269+12)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=$2;
      var $273=(($272+16)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=(($271)|0)!=(($274)|0);
      if ($275) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $276
      var $277=$tem1;
      var $278=(($277+8)|0);
      var $279=(($278)|0);
      var $280=$2;
      var $281=(($280+16)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=$2;
      var $284=(($283+12)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=$2;
      var $287=(($286+16)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=$285;
      var $290=$288;
      var $291=(($289-$290)|0);
      var $292=(($291)|0);
      assert($292 % 1 === 0, 'memcpy given ' + $292 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($279, $282, $292, 1);
      __label__ = 18; break;
    case 18: // $293
      var $294=$tem1;
      var $295=(($294+8)|0);
      var $296=(($295)|0);
      var $297=$2;
      var $298=(($297+12)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=$2;
      var $301=(($300+16)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=$299;
      var $304=$302;
      var $305=(($303-$304)|0);
      var $306=(($296+$305)|0);
      var $307=$2;
      var $308=(($307+12)|0);
      HEAP32[(($308)>>2)]=$306;
      var $309=$tem1;
      var $310=(($309+8)|0);
      var $311=(($310)|0);
      var $312=$2;
      var $313=(($312+16)|0);
      HEAP32[(($313)>>2)]=$311;
      var $314=$tem1;
      var $315=(($314+8)|0);
      var $316=(($315)|0);
      var $317=$blockSize2;
      var $318=(($316+$317)|0);
      var $319=$2;
      var $320=(($319+8)|0);
      HEAP32[(($320)>>2)]=$318;
      __label__ = 19; break;
    case 19: // $321
      $1=1;
      __label__ = 20; break;
    case 20: // $322
      var $323=$1;
      ;
      return $323;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8poolGrowP11STRING_POOL["X"]=1;

function __ZL4hashPKc($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $h;
      $1=$s;
      $h=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=HEAP8[($3)];
      var $5=(($4 << 24) >> 24)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $6
      var $7=$h;
      var $8=(($7*1000003)|0);
      var $9=$1;
      var $10=(($9+1)|0);
      $1=$10;
      var $11=HEAPU8[($9)];
      var $12=(($11)&255);
      var $13=$8 ^ $12;
      $h=$13;
      __label__ = 1; break;
    case 3: // $14
      var $15=$h;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL5keyeqPKcS0_($s1, $s2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$s1;
      $3=$s2;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=HEAP8[($5)];
      var $7=(($6 << 24) >> 24);
      var $8=$3;
      var $9=HEAP8[($8)];
      var $10=(($9 << 24) >> 24);
      var $11=(($7)|0)==(($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $12
      var $13=$2;
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      $1=1;
      __label__ = 7; break;
    case 4: // $18
      __label__ = 5; break;
    case 5: // $19
      var $20=$2;
      var $21=(($20+1)|0);
      $2=$21;
      var $22=$3;
      var $23=(($22+1)|0);
      $3=$23;
      __label__ = 1; break;
    case 6: // $24
      $1=0;
      __label__ = 7; break;
    case 7: // $25
      var $26=$1;
      ;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL6lookupP10HASH_TABLEPKcj($table, $name, $createSize) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $i=__stackBase__;
      var $tsize;
      var $h;
      var $mask;
      var $step;
      var $newPower;
      var $newSize;
      var $newMask;
      var $tsize1;
      var $newV;
      var $newHash;
      var $j=__stackBase__+4;
      $2=$table;
      $3=$name;
      $4=$createSize;
      var $5=$2;
      var $6=(($5+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $9
      var $10=$4;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      $1=0;
      __label__ = 48; break;
    case 3: // $13
      var $14=$2;
      var $15=(($14+4)|0);
      HEAP8[($15)]=6;
      var $16=$2;
      var $17=(($16+8)|0);
      HEAP32[(($17)>>2)]=64;
      var $18=$2;
      var $19=(($18+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=((($20<<2))|0);
      $tsize=$21;
      var $22=$2;
      var $23=(($22+16)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$tsize;
      var $28=FUNCTION_TABLE[$26]($27);
      var $29=$28;
      var $30=$2;
      var $31=(($30)|0);
      HEAP32[(($31)>>2)]=$29;
      var $32=$2;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $36
      var $37=$2;
      var $38=(($37+8)|0);
      HEAP32[(($38)>>2)]=0;
      $1=0;
      __label__ = 48; break;
    case 5: // $39
      var $40=$2;
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$42;
      var $44=$tsize;
      _memset($43, 0, $44, 1);
      var $45=$3;
      var $46=__ZL4hashPKc($45);
      var $47=$2;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49-1)|0);
      var $51=$46 & $50;
      HEAP32[(($i)>>2)]=$51;
      __label__ = 45; break;
    case 6: // $52
      var $53=$3;
      var $54=__ZL4hashPKc($53);
      $h=$54;
      var $55=$2;
      var $56=(($55+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57-1)|0);
      $mask=$58;
      $step=0;
      var $59=$h;
      var $60=$mask;
      var $61=$59 & $60;
      HEAP32[(($i)>>2)]=$61;
      __label__ = 7; break;
    case 7: // $62
      var $63=HEAP32[(($i)>>2)];
      var $64=$2;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+($63<<2))|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 8; break; } else { __label__ = 16; break; }
    case 8: // $70
      var $71=$3;
      var $72=HEAP32[(($i)>>2)];
      var $73=$2;
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+($72<<2))|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=__ZL5keyeqPKcS0_($71, $79);
      var $81=(($80 << 24) >> 24)!=0;
      if ($81) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $82
      var $83=HEAP32[(($i)>>2)];
      var $84=$2;
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+($83<<2))|0);
      var $88=HEAP32[(($87)>>2)];
      $1=$88;
      __label__ = 48; break;
    case 10: // $89
      var $90=$step;
      var $91=(($90 << 24) >> 24)!=0;
      if ($91) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $92
      var $93=$h;
      var $94=$mask;
      var $95=$94 ^ -1;
      var $96=$93 & $95;
      var $97=$2;
      var $98=(($97+4)|0);
      var $99=HEAPU8[($98)];
      var $100=(($99)&255);
      var $101=(($100-1)|0);
      var $102=$96 >>> (($101)>>>0);
      var $103=$mask;
      var $104=$103 >>> 2;
      var $105=$102 & $104;
      var $106=$105 | 1;
      var $107=(($106) & 255);
      $step=$107;
      __label__ = 12; break;
    case 12: // $108
      var $109=HEAPU32[(($i)>>2)];
      var $110=$step;
      var $111=(($110)&255);
      var $112=(($109)>>>0) < (($111)>>>0);
      if ($112) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $113
      var $114=$2;
      var $115=(($114+8)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$step;
      var $118=(($117)&255);
      var $119=(($116-$118)|0);
      var $120=HEAP32[(($i)>>2)];
      var $121=(($120+$119)|0);
      HEAP32[(($i)>>2)]=$121;
      var $128 = $i;__label__ = 15; break;
    case 14: // $122
      var $123=$step;
      var $124=(($123)&255);
      var $125=HEAP32[(($i)>>2)];
      var $126=(($125-$124)|0);
      HEAP32[(($i)>>2)]=$126;
      var $128 = $i;__label__ = 15; break;
    case 15: // $127
      var $128;
      __label__ = 7; break;
    case 16: // $129
      var $130=$4;
      var $131=(($130)|0)!=0;
      if ($131) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $132
      $1=0;
      __label__ = 48; break;
    case 18: // $133
      var $134=$2;
      var $135=(($134+12)|0);
      var $136=HEAPU32[(($135)>>2)];
      var $137=$2;
      var $138=(($137+4)|0);
      var $139=HEAPU8[($138)];
      var $140=(($139)&255);
      var $141=(($140-1)|0);
      var $142=$136 >>> (($141)>>>0);
      var $143=(($142)|0)!=0;
      if ($143) { __label__ = 19; break; } else { __label__ = 44; break; }
    case 19: // $144
      var $145=$2;
      var $146=(($145+4)|0);
      var $147=HEAPU8[($146)];
      var $148=(($147)&255);
      var $149=(($148+1)|0);
      var $150=(($149) & 255);
      $newPower=$150;
      var $151=$newPower;
      var $152=(($151)&255);
      var $153=1 << $152;
      $newSize=$153;
      var $154=$newSize;
      var $155=(($154-1)|0);
      $newMask=$155;
      var $156=$newSize;
      var $157=((($156<<2))|0);
      $tsize1=$157;
      var $158=$2;
      var $159=(($158+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$tsize1;
      var $164=FUNCTION_TABLE[$162]($163);
      var $165=$164;
      $newV=$165;
      var $166=$newV;
      var $167=(($166)|0)!=0;
      if ($167) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $168
      $1=0;
      __label__ = 48; break;
    case 21: // $169
      var $170=$newV;
      var $171=$170;
      var $172=$tsize1;
      _memset($171, 0, $172, 1);
      HEAP32[(($i)>>2)]=0;
      __label__ = 22; break;
    case 22: // $173
      var $174=HEAPU32[(($i)>>2)];
      var $175=$2;
      var $176=(($175+8)|0);
      var $177=HEAPU32[(($176)>>2)];
      var $178=(($174)>>>0) < (($177)>>>0);
      if ($178) { __label__ = 23; break; } else { __label__ = 35; break; }
    case 23: // $179
      var $180=HEAP32[(($i)>>2)];
      var $181=$2;
      var $182=(($181)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=(($183+($180<<2))|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 24; break; } else { __label__ = 33; break; }
    case 24: // $187
      var $188=HEAP32[(($i)>>2)];
      var $189=$2;
      var $190=(($189)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=(($191+($188<<2))|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=(($193)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=__ZL4hashPKc($195);
      $newHash=$196;
      var $197=$newHash;
      var $198=$newMask;
      var $199=$197 & $198;
      HEAP32[(($j)>>2)]=$199;
      $step=0;
      __label__ = 25; break;
    case 25: // $200
      var $201=HEAP32[(($j)>>2)];
      var $202=$newV;
      var $203=(($202+($201<<2))|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 26; break; } else { __label__ = 32; break; }
    case 26: // $206
      var $207=$step;
      var $208=(($207 << 24) >> 24)!=0;
      if ($208) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $209
      var $210=$newHash;
      var $211=$newMask;
      var $212=$211 ^ -1;
      var $213=$210 & $212;
      var $214=$newPower;
      var $215=(($214)&255);
      var $216=(($215-1)|0);
      var $217=$213 >>> (($216)>>>0);
      var $218=$newMask;
      var $219=$218 >>> 2;
      var $220=$217 & $219;
      var $221=$220 | 1;
      var $222=(($221) & 255);
      $step=$222;
      __label__ = 28; break;
    case 28: // $223
      var $224=HEAPU32[(($j)>>2)];
      var $225=$step;
      var $226=(($225)&255);
      var $227=(($224)>>>0) < (($226)>>>0);
      if ($227) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $228
      var $229=$newSize;
      var $230=$step;
      var $231=(($230)&255);
      var $232=(($229-$231)|0);
      var $233=HEAP32[(($j)>>2)];
      var $234=(($233+$232)|0);
      HEAP32[(($j)>>2)]=$234;
      var $241 = $j;__label__ = 31; break;
    case 30: // $235
      var $236=$step;
      var $237=(($236)&255);
      var $238=HEAP32[(($j)>>2)];
      var $239=(($238-$237)|0);
      HEAP32[(($j)>>2)]=$239;
      var $241 = $j;__label__ = 31; break;
    case 31: // $240
      var $241;
      __label__ = 25; break;
    case 32: // $242
      var $243=HEAP32[(($i)>>2)];
      var $244=$2;
      var $245=(($244)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246+($243<<2))|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=HEAP32[(($j)>>2)];
      var $250=$newV;
      var $251=(($250+($249<<2))|0);
      HEAP32[(($251)>>2)]=$248;
      __label__ = 33; break;
    case 33: // $252
      __label__ = 34; break;
    case 34: // $253
      var $254=HEAP32[(($i)>>2)];
      var $255=(($254+1)|0);
      HEAP32[(($i)>>2)]=$255;
      __label__ = 22; break;
    case 35: // $256
      var $257=$2;
      var $258=(($257+16)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(($259+8)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$2;
      var $263=(($262)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$264;
      FUNCTION_TABLE[$261]($265);
      var $266=$newV;
      var $267=$2;
      var $268=(($267)|0);
      HEAP32[(($268)>>2)]=$266;
      var $269=$newPower;
      var $270=$2;
      var $271=(($270+4)|0);
      HEAP8[($271)]=$269;
      var $272=$newSize;
      var $273=$2;
      var $274=(($273+8)|0);
      HEAP32[(($274)>>2)]=$272;
      var $275=$h;
      var $276=$newMask;
      var $277=$275 & $276;
      HEAP32[(($i)>>2)]=$277;
      $step=0;
      __label__ = 36; break;
    case 36: // $278
      var $279=HEAP32[(($i)>>2)];
      var $280=$2;
      var $281=(($280)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=(($282+($279<<2))|0);
      var $284=HEAP32[(($283)>>2)];
      var $285=(($284)|0)!=0;
      if ($285) { __label__ = 37; break; } else { __label__ = 43; break; }
    case 37: // $286
      var $287=$step;
      var $288=(($287 << 24) >> 24)!=0;
      if ($288) { __label__ = 39; break; } else { __label__ = 38; break; }
    case 38: // $289
      var $290=$h;
      var $291=$newMask;
      var $292=$291 ^ -1;
      var $293=$290 & $292;
      var $294=$newPower;
      var $295=(($294)&255);
      var $296=(($295-1)|0);
      var $297=$293 >>> (($296)>>>0);
      var $298=$newMask;
      var $299=$298 >>> 2;
      var $300=$297 & $299;
      var $301=$300 | 1;
      var $302=(($301) & 255);
      $step=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=HEAPU32[(($i)>>2)];
      var $305=$step;
      var $306=(($305)&255);
      var $307=(($304)>>>0) < (($306)>>>0);
      if ($307) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $308
      var $309=$newSize;
      var $310=$step;
      var $311=(($310)&255);
      var $312=(($309-$311)|0);
      var $313=HEAP32[(($i)>>2)];
      var $314=(($313+$312)|0);
      HEAP32[(($i)>>2)]=$314;
      var $321 = $i;__label__ = 42; break;
    case 41: // $315
      var $316=$step;
      var $317=(($316)&255);
      var $318=HEAP32[(($i)>>2)];
      var $319=(($318-$317)|0);
      HEAP32[(($i)>>2)]=$319;
      var $321 = $i;__label__ = 42; break;
    case 42: // $320
      var $321;
      __label__ = 36; break;
    case 43: // $322
      __label__ = 44; break;
    case 44: // $323
      __label__ = 45; break;
    case 45: // $324
      var $325=$2;
      var $326=(($325+16)|0);
      var $327=HEAP32[(($326)>>2)];
      var $328=(($327)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=$4;
      var $331=FUNCTION_TABLE[$329]($330);
      var $332=$331;
      var $333=HEAP32[(($i)>>2)];
      var $334=$2;
      var $335=(($334)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=(($336+($333<<2))|0);
      HEAP32[(($337)>>2)]=$332;
      var $338=HEAP32[(($i)>>2)];
      var $339=$2;
      var $340=(($339)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=(($341+($338<<2))|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(($343)|0)!=0;
      if ($344) { __label__ = 47; break; } else { __label__ = 46; break; }
    case 46: // $345
      $1=0;
      __label__ = 48; break;
    case 47: // $346
      var $347=HEAP32[(($i)>>2)];
      var $348=$2;
      var $349=(($348)|0);
      var $350=HEAP32[(($349)>>2)];
      var $351=(($350+($347<<2))|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=$352;
      var $354=$4;
      _memset($353, 0, $354, 1);
      var $355=$3;
      var $356=HEAP32[(($i)>>2)];
      var $357=$2;
      var $358=(($357)|0);
      var $359=HEAP32[(($358)>>2)];
      var $360=(($359+($356<<2))|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($361)|0);
      HEAP32[(($362)>>2)]=$355;
      var $363=$2;
      var $364=(($363+12)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=(($365+1)|0);
      HEAP32[(($364)>>2)]=$366;
      var $367=HEAP32[(($i)>>2)];
      var $368=$2;
      var $369=(($368)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=(($370+($367<<2))|0);
      var $372=HEAP32[(($371)>>2)];
      $1=$372;
      __label__ = 48; break;
    case 48: // $373
      var $374=$1;
      STACKTOP = __stackBase__;
      return $374;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL6lookupP10HASH_TABLEPKcj["X"]=1;

function __ZL16hashTableDestroyP10HASH_TABLE($table) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      $1=$table;
      $i=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$i;
      var $4=$1;
      var $5=(($4+8)|0);
      var $6=HEAPU32[(($5)>>2)];
      var $7=(($3)>>>0) < (($6)>>>0);
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=$1;
      var $10=(($9+16)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$i;
      var $15=$1;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17+($14<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      FUNCTION_TABLE[$13]($20);
      __label__ = 3; break;
    case 3: // $21
      var $22=$i;
      var $23=(($22+1)|0);
      $i=$23;
      __label__ = 1; break;
    case 4: // $24
      var $25=$1;
      var $26=(($25+16)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+8)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$1;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$32;
      FUNCTION_TABLE[$29]($33);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7binding($parser, $prefix, $attId, $uri, $bindingsPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $mustBeXML;
      var $isXML;
      var $isXMLNS;
      var $b;
      var $len;
      var $temp;
      $2=$parser;
      $3=$prefix;
      $4=$attId;
      $5=$uri;
      $6=$bindingsPtr;
      $mustBeXML=0;
      $isXML=1;
      $isXMLNS=1;
      var $7=$5;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $11
      var $12=$3;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      $1=28;
      __label__ = 61; break;
    case 3: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 4; break; } else { __label__ = 14; break; }
    case 4: // $22
      var $23=$3;
      var $24=(($23)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0);
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=(($28)|0)==120;
      if ($29) { __label__ = 5; break; } else { __label__ = 14; break; }
    case 5: // $30
      var $31=$3;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+1)|0);
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)==109;
      if ($37) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $38
      var $39=$3;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+2)|0);
      var $43=HEAP8[($42)];
      var $44=(($43 << 24) >> 24);
      var $45=(($44)|0)==108;
      if ($45) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $46
      var $47=$3;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+3)|0);
      var $51=HEAP8[($50)];
      var $52=(($51 << 24) >> 24);
      var $53=(($52)|0)==110;
      if ($53) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $54
      var $55=$3;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+4)|0);
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $61=(($60)|0)==115;
      if ($61) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $62
      var $63=$3;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+5)|0);
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24);
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $70
      $1=39;
      __label__ = 61; break;
    case 11: // $71
      var $72=$3;
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+3)|0);
      var $76=HEAP8[($75)];
      var $77=(($76 << 24) >> 24);
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $79
      $mustBeXML=1;
      __label__ = 13; break;
    case 13: // $80
      __label__ = 14; break;
    case 14: // $81
      $len=0;
      __label__ = 15; break;
    case 15: // $82
      var $83=$len;
      var $84=$5;
      var $85=(($84+$83)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24)!=0;
      if ($87) { __label__ = 16; break; } else { __label__ = 27; break; }
    case 16: // $88
      var $89=$isXML;
      var $90=(($89 << 24) >> 24)!=0;
      if ($90) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $91
      var $92=$len;
      var $93=(($92)|0) > 36;
      if ($93) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $94
      var $95=$len;
      var $96=$5;
      var $97=(($96+$95)|0);
      var $98=HEAP8[($97)];
      var $99=(($98 << 24) >> 24);
      var $100=$len;
      var $101=((STRING_TABLE.__ZZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7bindingE12xmlNamespace+$100)|0);
      var $102=HEAP8[($101)];
      var $103=(($102 << 24) >> 24);
      var $104=(($99)|0)!=(($103)|0);
      if ($104) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $105
      $isXML=0;
      __label__ = 20; break;
    case 20: // $106
      var $107=$mustBeXML;
      var $108=(($107 << 24) >> 24)!=0;
      if ($108) { __label__ = 25; break; } else { __label__ = 21; break; }
    case 21: // $109
      var $110=$isXMLNS;
      var $111=(($110 << 24) >> 24)!=0;
      if ($111) { __label__ = 22; break; } else { __label__ = 25; break; }
    case 22: // $112
      var $113=$len;
      var $114=(($113)|0) > 29;
      if ($114) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $115
      var $116=$len;
      var $117=$5;
      var $118=(($117+$116)|0);
      var $119=HEAP8[($118)];
      var $120=(($119 << 24) >> 24);
      var $121=$len;
      var $122=((STRING_TABLE.__ZZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7bindingE14xmlnsNamespace+$121)|0);
      var $123=HEAP8[($122)];
      var $124=(($123 << 24) >> 24);
      var $125=(($120)|0)!=(($124)|0);
      if ($125) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $126
      $isXMLNS=0;
      __label__ = 25; break;
    case 25: // $127
      __label__ = 26; break;
    case 26: // $128
      var $129=$len;
      var $130=(($129+1)|0);
      $len=$130;
      __label__ = 15; break;
    case 27: // $131
      var $132=$isXML;
      var $133=(($132 << 24) >> 24)!=0;
      if ($133) { __label__ = 28; break; } else { var $138 = 0;__label__ = 29; break; }
    case 28: // $134
      var $135=$len;
      var $136=(($135)|0)==36;
      var $138 = $136;__label__ = 29; break;
    case 29: // $137
      var $138;
      var $139=(($138)&1);
      $isXML=$139;
      var $140=$isXMLNS;
      var $141=(($140 << 24) >> 24)!=0;
      if ($141) { __label__ = 30; break; } else { var $146 = 0;__label__ = 31; break; }
    case 30: // $142
      var $143=$len;
      var $144=(($143)|0)==29;
      var $146 = $144;__label__ = 31; break;
    case 31: // $145
      var $146;
      var $147=(($146)&1);
      $isXMLNS=$147;
      var $148=$mustBeXML;
      var $149=(($148)&255);
      var $150=$isXML;
      var $151=(($150)&255);
      var $152=(($149)|0)!=(($151)|0);
      if ($152) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $153
      var $154=$mustBeXML;
      var $155=(($154 << 24) >> 24)!=0;
      var $156=$155 ? 38 : 40;
      $1=$156;
      __label__ = 61; break;
    case 33: // $157
      var $158=$isXMLNS;
      var $159=(($158 << 24) >> 24)!=0;
      if ($159) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $160
      $1=40;
      __label__ = 61; break;
    case 35: // $161
      var $162=$2;
      var $163=(($162+472)|0);
      var $164=HEAP8[($163)];
      var $165=(($164 << 24) >> 24)!=0;
      if ($165) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $166
      var $167=$len;
      var $168=(($167+1)|0);
      $len=$168;
      __label__ = 37; break;
    case 37: // $169
      var $170=$2;
      var $171=(($170+376)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172)|0)!=0;
      if ($173) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $174
      var $175=$2;
      var $176=(($175+376)|0);
      var $177=HEAP32[(($176)>>2)];
      $b=$177;
      var $178=$len;
      var $179=$b;
      var $180=(($179+24)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=(($178)|0) > (($181)|0);
      if ($182) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $183
      var $184=$2;
      var $185=(($184+12)|0);
      var $186=(($185+4)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=$b;
      var $189=(($188+16)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$len;
      var $192=(($191+24)|0);
      var $193=(($192)|0);
      var $194=FUNCTION_TABLE[$187]($190, $193);
      $temp=$194;
      var $195=$temp;
      var $196=(($195)|0)==0;
      if ($196) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $197
      $1=1;
      __label__ = 61; break;
    case 41: // $198
      var $199=$temp;
      var $200=$b;
      var $201=(($200+16)|0);
      HEAP32[(($201)>>2)]=$199;
      var $202=$len;
      var $203=(($202+24)|0);
      var $204=$b;
      var $205=(($204+24)|0);
      HEAP32[(($205)>>2)]=$203;
      __label__ = 42; break;
    case 42: // $206
      var $207=$b;
      var $208=(($207+4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=$2;
      var $211=(($210+376)|0);
      HEAP32[(($211)>>2)]=$209;
      __label__ = 48; break;
    case 43: // $212
      var $213=$2;
      var $214=(($213+12)|0);
      var $215=(($214)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=FUNCTION_TABLE[$216](28);
      var $218=$217;
      $b=$218;
      var $219=$b;
      var $220=(($219)|0)!=0;
      if ($220) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $221
      $1=1;
      __label__ = 61; break;
    case 45: // $222
      var $223=$2;
      var $224=(($223+12)|0);
      var $225=(($224)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$len;
      var $228=(($227+24)|0);
      var $229=(($228)|0);
      var $230=FUNCTION_TABLE[$226]($229);
      var $231=$b;
      var $232=(($231+16)|0);
      HEAP32[(($232)>>2)]=$230;
      var $233=$b;
      var $234=(($233+16)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 47; break; } else { __label__ = 46; break; }
    case 46: // $237
      var $238=$2;
      var $239=(($238+12)|0);
      var $240=(($239+8)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=$b;
      var $243=$242;
      FUNCTION_TABLE[$241]($243);
      $1=1;
      __label__ = 61; break;
    case 47: // $244
      var $245=$len;
      var $246=(($245+24)|0);
      var $247=$b;
      var $248=(($247+24)|0);
      HEAP32[(($248)>>2)]=$246;
      __label__ = 48; break;
    case 48: // $249
      var $250=$len;
      var $251=$b;
      var $252=(($251+20)|0);
      HEAP32[(($252)>>2)]=$250;
      var $253=$b;
      var $254=(($253+16)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$5;
      var $257=$len;
      var $258=(($257)|0);
      assert($258 % 1 === 0, 'memcpy given ' + $258 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($255, $256, $258, 1);
      var $259=$2;
      var $260=(($259+472)|0);
      var $261=HEAP8[($260)];
      var $262=(($261 << 24) >> 24)!=0;
      if ($262) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $263
      var $264=$2;
      var $265=(($264+472)|0);
      var $266=HEAP8[($265)];
      var $267=$len;
      var $268=(($267-1)|0);
      var $269=$b;
      var $270=(($269+16)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=(($271+$268)|0);
      HEAP8[($272)]=$266;
      __label__ = 50; break;
    case 50: // $273
      var $274=$3;
      var $275=$b;
      var $276=(($275)|0);
      HEAP32[(($276)>>2)]=$274;
      var $277=$4;
      var $278=$b;
      var $279=(($278+12)|0);
      HEAP32[(($279)>>2)]=$277;
      var $280=$3;
      var $281=(($280+4)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=$b;
      var $284=(($283+8)|0);
      HEAP32[(($284)>>2)]=$282;
      var $285=$5;
      var $286=HEAP8[($285)];
      var $287=(($286 << 24) >> 24);
      var $288=(($287)|0)==0;
      if ($288) { __label__ = 51; break; } else { __label__ = 53; break; }
    case 51: // $289
      var $290=$3;
      var $291=$2;
      var $292=(($291+356)|0);
      var $293=HEAP32[(($292)>>2)];
      var $294=(($293+152)|0);
      var $295=(($290)|0)==(($294)|0);
      if ($295) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $296
      var $297=$3;
      var $298=(($297+4)|0);
      HEAP32[(($298)>>2)]=0;
      __label__ = 54; break;
    case 53: // $299
      var $300=$b;
      var $301=$3;
      var $302=(($301+4)|0);
      HEAP32[(($302)>>2)]=$300;
      __label__ = 54; break;
    case 54: // $303
      var $304=$6;
      var $305=HEAP32[(($304)>>2)];
      var $306=$b;
      var $307=(($306+4)|0);
      HEAP32[(($307)>>2)]=$305;
      var $308=$b;
      var $309=$6;
      HEAP32[(($309)>>2)]=$308;
      var $310=$4;
      var $311=(($310)|0)!=0;
      if ($311) { __label__ = 55; break; } else { __label__ = 60; break; }
    case 55: // $312
      var $313=$2;
      var $314=(($313+100)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=(($315)|0)!=0;
      if ($316) { __label__ = 56; break; } else { __label__ = 60; break; }
    case 56: // $317
      var $318=$2;
      var $319=(($318+100)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$2;
      var $322=(($321+4)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=$3;
      var $325=(($324)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=$3;
      var $328=(($327+4)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=(($329)|0)!=0;
      if ($330) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $331
      var $332=$5;
      var $335 = $332;__label__ = 59; break;
    case 58: // $333
      var $335 = 0;__label__ = 59; break;
    case 59: // $334
      var $335;
      FUNCTION_TABLE[$320]($323, $326, $335);
      __label__ = 60; break;
    case 60: // $336
      $1=0;
      __label__ = 61; break;
    case 61: // $337
      var $338=$1;
      ;
      return $338;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7binding["X"]=1;

function __ZL18initializeEncodingP16XML_ParserStruct($parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $s;
      $2=$parser;
      var $3=$2;
      var $4=(($3+232)|0);
      var $5=HEAP32[(($4)>>2)];
      $s=$5;
      var $6=$2;
      var $7=(($6+236)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $13 = 1502;__label__ = 3; break;
    case 2: // $11
      var $13 = 1504;__label__ = 3; break;
    case 3: // $12
      var $13;
      var $14=$2;
      var $15=(($14+148)|0);
      var $16=$2;
      var $17=(($16+144)|0);
      var $18=$s;
      var $19=FUNCTION_TABLE[$13]($15, $17, $18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $21
      $1=0;
      __label__ = 6; break;
    case 5: // $22
      var $23=$2;
      var $24=$2;
      var $25=(($24+232)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=__ZL21handleUnknownEncodingP16XML_ParserStructPKc($23, $26);
      $1=$27;
      __label__ = 6; break;
    case 6: // $28
      var $29=$1;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15prologProcessorP16XML_ParserStructPKcS2_PS2_($parser, $s, $end, $nextPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $next=__stackBase__;
  var $tok;
  $1=$parser;
  $2=$s;
  $3=$end;
  $4=$nextPtr;
  var $5=$2;
  HEAP32[(($next)>>2)]=$5;
  var $6=$1;
  var $7=(($6+144)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($8)|0);
  var $10=(($9)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$1;
  var $13=(($12+144)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$2;
  var $16=$3;
  var $17=FUNCTION_TABLE[$11]($14, $15, $16, $next);
  $tok=$17;
  var $18=$1;
  var $19=$1;
  var $20=(($19+144)|0);
  var $21=HEAP32[(($20)>>2)];
  var $22=$2;
  var $23=$3;
  var $24=$tok;
  var $25=HEAP32[(($next)>>2)];
  var $26=$4;
  var $27=$1;
  var $28=(($27+480)|0);
  var $29=(($28+4)|0);
  var $30=HEAP8[($29)];
  var $31=(($30 << 24) >> 24)!=0;
  var $32=$31 ^ 1;
  var $33=(($32)&1);
  var $34=__ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h($18, $21, $22, $23, $24, $25, $26, $33);
  STACKTOP = __stackBase__;
  return $34;
}


function __ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h($parser, $enc, $s, $end, $tok, $next, $nextPtr, $haveMore) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7=__stackBase__;
      var $8;
      var $9;
      var $dtd;
      var $eventPP;
      var $eventEndPP;
      var $quant;
      var $role;
      var $handleDefault;
      var $result;
      var $result1;
      var $tem;
      var $hadParamEntityRefs;
      var $entity;
      var $hadParamEntityRefs2;
      var $entity3;
      var $prefix;
      var $attVal;
      var $result4;
      var $result5;
      var $name;
      var $name6;
      var $tem7;
      var $systemId;
      var $result8;
      var $temp;
      var $temp9;
      var $myindex;
      var $name10;
      var $entity11;
      var $result12;
      var $betweenDecl;
      var $content;
      var $el;
      var $name13;
      var $nameLen;
      var $nxt;
      var $myindex14;
      var $model;
      $2=$parser;
      $3=$enc;
      $4=$s;
      $5=$end;
      $6=$tok;
      HEAP32[(($7)>>2)]=$next;
      $8=$nextPtr;
      $9=$haveMore;
      var $10=$2;
      var $11=(($10+356)|0);
      var $12=HEAP32[(($11)>>2)];
      $dtd=$12;
      var $13=$3;
      var $14=$2;
      var $15=(($14+144)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13)|0)==(($16)|0);
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$2;
      var $20=(($19+288)|0);
      $eventPP=$20;
      var $21=$2;
      var $22=(($21+292)|0);
      $eventEndPP=$22;
      __label__ = 3; break;
    case 2: // $23
      var $24=$2;
      var $25=(($24+300)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0);
      $eventPP=$27;
      var $28=$2;
      var $29=(($28+300)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+4)|0);
      $eventEndPP=$31;
      __label__ = 3; break;
    case 3: // $32
      __label__ = 4; break;
    case 4: // $33
      $handleDefault=1;
      var $34=$4;
      var $35=$eventPP;
      HEAP32[(($35)>>2)]=$34;
      var $36=HEAP32[(($7)>>2)];
      var $37=$eventEndPP;
      HEAP32[(($37)>>2)]=$36;
      var $38=$6;
      var $39=(($38)|0) <= 0;
      if ($39) { __label__ = 5; break; } else { __label__ = 23; break; }
    case 5: // $40
      var $41=$9;
      var $42=(($41 << 24) >> 24)!=0;
      if ($42) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $43
      var $44=$6;
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      var $47=$4;
      var $48=$8;
      HEAP32[(($48)>>2)]=$47;
      $1=0;
      __label__ = 452; break;
    case 8: // $49
      var $50=$6;
      if ($50 == 0) {
        __label__ = 9; break;
      }
      else if ($50 == -1) {
        __label__ = 10; break;
      }
      else if ($50 == -2) {
        __label__ = 11; break;
      }
      else if ($50 == -4) {
        __label__ = 12; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 9: // $51
      var $52=HEAP32[(($7)>>2)];
      var $53=$eventPP;
      HEAP32[(($53)>>2)]=$52;
      $1=4;
      __label__ = 452; break;
    case 10: // $54
      $1=5;
      __label__ = 452; break;
    case 11: // $55
      $1=6;
      __label__ = 452; break;
    case 12: // $56
      var $57=$3;
      var $58=$2;
      var $59=(($58+144)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($57)|0)!=(($60)|0);
      if ($61) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $62
      var $63=$2;
      var $64=(($63+300)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+20)|0);
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24)!=0;
      if ($68) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $69
      var $70=$4;
      var $71=$8;
      HEAP32[(($71)>>2)]=$70;
      $1=0;
      __label__ = 452; break;
    case 15: // $72
      var $73=$2;
      var $74=(($73+488)|0);
      var $75=HEAP8[($74)];
      var $76=(($75 << 24) >> 24)!=0;
      if ($76) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $77
      var $78=$3;
      var $79=$2;
      var $80=(($79+144)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($78)|0)!=(($81)|0);
      if ($82) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $83
      var $84=$2;
      var $85=(($84+256)|0);
      var $86=(($85)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$2;
      var $89=(($88+256)|0);
      var $90=$5;
      var $91=$5;
      var $92=$3;
      var $93=FUNCTION_TABLE[$87]($89, -4, $90, $91, $92);
      var $94=(($93)|0)==-1;
      if ($94) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $95
      $1=29;
      __label__ = 452; break;
    case 19: // $96
      var $97=$4;
      var $98=$8;
      HEAP32[(($98)>>2)]=$97;
      $1=0;
      __label__ = 452; break;
    case 20: // $99
      $1=3;
      __label__ = 452; break;
    case 21: // $100
      var $101=$6;
      var $102=(((-$101))|0);
      $6=$102;
      var $103=$5;
      HEAP32[(($7)>>2)]=$103;
      __label__ = 22; break;
    case 22: // $104
      __label__ = 23; break;
    case 23: // $105
      var $106=$2;
      var $107=(($106+256)|0);
      var $108=(($107)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=$2;
      var $111=(($110+256)|0);
      var $112=$6;
      var $113=$4;
      var $114=HEAP32[(($7)>>2)];
      var $115=$3;
      var $116=FUNCTION_TABLE[$109]($111, $112, $113, $114, $115);
      $role=$116;
      var $117=$role;
      if ($117 == 1) {
        __label__ = 24; break;
      }
      else if ($117 == 4) {
        __label__ = 27; break;
      }
      else if ($117 == 7) {
        __label__ = 32; break;
      }
      else if ($117 == 57) {
        __label__ = 35; break;
      }
      else if ($117 == 6) {
        __label__ = 38; break;
      }
      else if ($117 == 14) {
        __label__ = 47; break;
      }
      else if ($117 == 8) {
        __label__ = 58; break;
      }
      else if ($117 == 2) {
        __label__ = 84; break;
      }
      else if ($117 == 34) {
        __label__ = 101; break;
      }
      else if ($117 == 22) {
        __label__ = 104; break;
      }
      else if ($117 == 23) {
        __label__ = 107; break;
      }
      else if ($117 == 24) {
        __label__ = 108; break;
      }
      else if ($117 == 25) {
        __label__ = 109; break;
      }
      else if ($117 == 26) {
        __label__ = 110; break;
      }
      else if ($117 == 27) {
        __label__ = 111; break;
      }
      else if ($117 == 28) {
        __label__ = 112; break;
      }
      else if ($117 == 29) {
        __label__ = 113; break;
      }
      else if ($117 == 30) {
        __label__ = 114; break;
      }
      else if ($117 == 31 || $117 == 32) {
        __label__ = 119; break;
      }
      else if ($117 == 35 || $117 == 36) {
        __label__ = 130; break;
      }
      else if ($117 == 37 || $117 == 38) {
        __label__ = 153; break;
      }
      else if ($117 == 12) {
        __label__ = 178; break;
      }
      else if ($117 == 5) {
        __label__ = 188; break;
      }
      else if ($117 == 13) {
        __label__ = 203; break;
      }
      else if ($117 == 15) {
        __label__ = 211; break;
      }
      else if ($117 == 16) {
        __label__ = 216; break;
      }
      else if ($117 == 9) {
        __label__ = 227; break;
      }
      else if ($117 == 10) {
        __label__ = 244; break;
      }
      else if ($117 == 18) {
        __label__ = 259; break;
      }
      else if ($117 == 21) {
        __label__ = 264; break;
      }
      else if ($117 == 19) {
        __label__ = 271; break;
      }
      else if ($117 == 20) {
        __label__ = 277; break;
      }
      else if ($117 == -1) {
        __label__ = 281; break;
      }
      else if ($117 == 58) {
        __label__ = 285; break;
      }
      else if ($117 == 44) {
        __label__ = 293; break;
      }
      else if ($117 == 50) {
        __label__ = 313; break;
      }
      else if ($117 == 49) {
        __label__ = 319; break;
      }
      else if ($117 == 60 || $117 == 59) {
        __label__ = 328; break;
      }
      else if ($117 == 40) {
        __label__ = 367; break;
      }
      else if ($117 == 41 || $117 == 42) {
        __label__ = 372; break;
      }
      else if ($117 == 43) {
        __label__ = 379; break;
      }
      else if ($117 == 51) {
        __label__ = 384; break;
      }
      else if ($117 == 53) {
        __label__ = 385; break;
      }
      else if ($117 == 52) {
        __label__ = 386; break;
      }
      else if ($117 == 54) {
        __label__ = 387; break;
      }
      else if ($117 == 45) {
        __label__ = 403; break;
      }
      else if ($117 == 47) {
        __label__ = 404; break;
      }
      else if ($117 == 46) {
        __label__ = 405; break;
      }
      else if ($117 == 48) {
        __label__ = 406; break;
      }
      else if ($117 == 55) {
        __label__ = 418; break;
      }
      else if ($117 == 56) {
        __label__ = 421; break;
      }
      else if ($117 == 0) {
        __label__ = 424; break;
      }
      else if ($117 == 3) {
        __label__ = 427; break;
      }
      else if ($117 == 11) {
        __label__ = 430; break;
      }
      else if ($117 == 17) {
        __label__ = 434; break;
      }
      else if ($117 == 33) {
        __label__ = 437; break;
      }
      else if ($117 == 39) {
        __label__ = 441; break;
      }
      else {
      __label__ = 444; break;
      }
      
    case 24: // $118
      var $119=$2;
      var $120=$4;
      var $121=HEAP32[(($7)>>2)];
      var $122=__ZL14processXmlDeclP16XML_ParserStructiPKcS2_($119, 0, $120, $121);
      $result=$122;
      var $123=$result;
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $125
      var $126=$result;
      $1=$126;
      __label__ = 452; break;
    case 26: // $127
      var $128=$2;
      var $129=(($128+144)|0);
      var $130=HEAP32[(($129)>>2)];
      $3=$130;
      $handleDefault=0;
      __label__ = 444; break;
    case 27: // $131
      var $132=$2;
      var $133=(($132+84)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 28; break; } else { __label__ = 31; break; }
    case 28: // $136
      var $137=$2;
      var $138=(($137+416)|0);
      var $139=$3;
      var $140=$4;
      var $141=HEAP32[(($7)>>2)];
      var $142=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($138, $139, $140, $141);
      var $143=$2;
      var $144=(($143+320)|0);
      HEAP32[(($144)>>2)]=$142;
      var $145=$2;
      var $146=(($145+320)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147)|0)!=0;
      if ($148) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $149
      $1=1;
      __label__ = 452; break;
    case 30: // $150
      var $151=$2;
      var $152=(($151+416)|0);
      var $153=(($152+12)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$2;
      var $156=(($155+416)|0);
      var $157=(($156+16)|0);
      HEAP32[(($157)>>2)]=$154;
      var $158=$2;
      var $159=(($158+328)|0);
      HEAP32[(($159)>>2)]=0;
      $handleDefault=0;
      __label__ = 31; break;
    case 31: // $160
      var $161=$2;
      var $162=(($161+324)|0);
      HEAP32[(($162)>>2)]=0;
      __label__ = 444; break;
    case 32: // $163
      var $164=$2;
      var $165=(($164+84)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($166)|0)!=0;
      if ($167) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $168
      var $169=$2;
      var $170=(($169+84)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$2;
      var $173=(($172+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$2;
      var $176=(($175+320)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$2;
      var $179=(($178+324)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$2;
      var $182=(($181+328)|0);
      var $183=HEAP32[(($182)>>2)];
      FUNCTION_TABLE[$171]($174, $177, $180, $183, 1);
      var $184=$2;
      var $185=(($184+320)|0);
      HEAP32[(($185)>>2)]=0;
      var $186=$2;
      var $187=(($186+416)|0);
      __ZL9poolClearP11STRING_POOL($187);
      $handleDefault=0;
      __label__ = 34; break;
    case 34: // $188
      __label__ = 444; break;
    case 35: // $189
      var $190=$2;
      var $191=$4;
      var $192=HEAP32[(($7)>>2)];
      var $193=__ZL14processXmlDeclP16XML_ParserStructiPKcS2_($190, 1, $191, $192);
      $result1=$193;
      var $194=$result1;
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $196
      var $197=$result1;
      $1=$197;
      __label__ = 452; break;
    case 37: // $198
      var $199=$2;
      var $200=(($199+144)|0);
      var $201=HEAP32[(($200)>>2)];
      $3=$201;
      $handleDefault=0;
      __label__ = 444; break;
    case 38: // $202
      var $203=$2;
      var $204=(($203+489)|0);
      HEAP8[($204)]=0;
      var $205=$dtd;
      var $206=(($205+132)|0);
      var $207=__ZL6lookupP10HASH_TABLEPKcj($206, ((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE18externalSubsetName)|0), 36);
      var $208=$207;
      var $209=$2;
      var $210=(($209+316)|0);
      HEAP32[(($210)>>2)]=$208;
      var $211=$2;
      var $212=(($211+316)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213)|0)!=0;
      if ($214) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $215
      $1=1;
      __label__ = 452; break;
    case 40: // $216
      var $217=$dtd;
      var $218=(($217+129)|0);
      HEAP8[($218)]=1;
      var $219=$2;
      var $220=(($219+84)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221)|0)!=0;
      if ($222) { __label__ = 41; break; } else { __label__ = 46; break; }
    case 41: // $223
      var $224=$3;
      var $225=(($224+56)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$3;
      var $228=$4;
      var $229=HEAP32[(($7)>>2)];
      var $230=$eventPP;
      var $231=FUNCTION_TABLE[$226]($227, $228, $229, $230);
      var $232=(($231)|0)!=0;
      if ($232) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $233
      $1=32;
      __label__ = 452; break;
    case 43: // $234
      var $235=$2;
      var $236=(($235+416)|0);
      var $237=$3;
      var $238=$4;
      var $239=$3;
      var $240=(($239+68)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($238+$241)|0);
      var $243=HEAP32[(($7)>>2)];
      var $244=$3;
      var $245=(($244+68)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(((-$246))|0);
      var $248=(($243+$247)|0);
      var $249=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($236, $237, $242, $248);
      var $250=$2;
      var $251=(($250+328)|0);
      HEAP32[(($251)>>2)]=$249;
      var $252=$2;
      var $253=(($252+328)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($254)|0)!=0;
      if ($255) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $256
      $1=1;
      __label__ = 452; break;
    case 45: // $257
      var $258=$2;
      var $259=(($258+328)|0);
      var $260=HEAP32[(($259)>>2)];
      __ZL17normalizePublicIdPc($260);
      var $261=$2;
      var $262=(($261+416)|0);
      var $263=(($262+12)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$2;
      var $266=(($265+416)|0);
      var $267=(($266+16)|0);
      HEAP32[(($267)>>2)]=$264;
      $handleDefault=0;
      __label__ = 50; break;
    case 46: // $268
      __label__ = 47; break;
    case 47: // $269
      var $270=$3;
      var $271=(($270+56)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=$3;
      var $274=$4;
      var $275=HEAP32[(($7)>>2)];
      var $276=$eventPP;
      var $277=FUNCTION_TABLE[$272]($273, $274, $275, $276);
      var $278=(($277)|0)!=0;
      if ($278) { __label__ = 49; break; } else { __label__ = 48; break; }
    case 48: // $279
      $1=32;
      __label__ = 452; break;
    case 49: // $280
      __label__ = 50; break;
    case 50: // $281
      var $282=$dtd;
      var $283=(($282+128)|0);
      var $284=HEAP8[($283)];
      var $285=(($284 << 24) >> 24)!=0;
      if ($285) { __label__ = 51; break; } else { __label__ = 57; break; }
    case 51: // $286
      var $287=$2;
      var $288=(($287+316)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=(($289)|0)!=0;
      if ($290) { __label__ = 52; break; } else { __label__ = 57; break; }
    case 52: // $291
      var $292=$dtd;
      var $293=(($292+80)|0);
      var $294=$3;
      var $295=$4;
      var $296=$3;
      var $297=(($296+68)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(($295+$298)|0);
      var $300=HEAP32[(($7)>>2)];
      var $301=$3;
      var $302=(($301+68)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(((-$303))|0);
      var $305=(($300+$304)|0);
      var $306=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($293, $294, $299, $305);
      $tem=$306;
      var $307=$tem;
      var $308=(($307)|0)!=0;
      if ($308) { __label__ = 54; break; } else { __label__ = 53; break; }
    case 53: // $309
      $1=1;
      __label__ = 452; break;
    case 54: // $310
      var $311=$tem;
      __ZL17normalizePublicIdPc($311);
      var $312=$tem;
      var $313=$2;
      var $314=(($313+316)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=(($315+24)|0);
      HEAP32[(($316)>>2)]=$312;
      var $317=$dtd;
      var $318=(($317+80)|0);
      var $319=(($318+12)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$dtd;
      var $322=(($321+80)|0);
      var $323=(($322+16)|0);
      HEAP32[(($323)>>2)]=$320;
      var $324=$2;
      var $325=(($324+136)|0);
      var $326=HEAP32[(($325)>>2)];
      var $327=(($326)|0)!=0;
      if ($327) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $328
      $handleDefault=0;
      __label__ = 56; break;
    case 56: // $329
      __label__ = 57; break;
    case 57: // $330
      __label__ = 444; break;
    case 58: // $331
      var $332=$2;
      var $333=(($332+320)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($334)|0)!=0;
      if ($335) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $336
      var $337=$2;
      var $338=(($337+84)|0);
      var $339=HEAP32[(($338)>>2)];
      var $340=$2;
      var $341=(($340+4)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=$2;
      var $344=(($343+320)|0);
      var $345=HEAP32[(($344)>>2)];
      var $346=$2;
      var $347=(($346+324)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$2;
      var $350=(($349+328)|0);
      var $351=HEAP32[(($350)>>2)];
      FUNCTION_TABLE[$339]($342, $345, $348, $351, 0);
      var $352=$2;
      var $353=(($352+416)|0);
      __ZL9poolClearP11STRING_POOL($353);
      $handleDefault=0;
      __label__ = 60; break;
    case 60: // $354
      var $355=$2;
      var $356=(($355+324)|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=(($357)|0)!=0;
      if ($358) { __label__ = 62; break; } else { __label__ = 61; break; }
    case 61: // $359
      var $360=$2;
      var $361=(($360+489)|0);
      var $362=HEAP8[($361)];
      var $363=(($362 << 24) >> 24)!=0;
      if ($363) { __label__ = 62; break; } else { __label__ = 81; break; }
    case 62: // $364
      var $365=$dtd;
      var $366=(($365+129)|0);
      var $367=HEAP8[($366)];
      $hadParamEntityRefs=$367;
      var $368=$dtd;
      var $369=(($368+129)|0);
      HEAP8[($369)]=1;
      var $370=$2;
      var $371=(($370+492)|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=(($372)|0)!=0;
      if ($373) { __label__ = 63; break; } else { __label__ = 80; break; }
    case 63: // $374
      var $375=$2;
      var $376=(($375+112)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=(($377)|0)!=0;
      if ($378) { __label__ = 64; break; } else { __label__ = 80; break; }
    case 64: // $379
      var $380=$dtd;
      var $381=(($380+132)|0);
      var $382=__ZL6lookupP10HASH_TABLEPKcj($381, ((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE18externalSubsetName)|0), 36);
      var $383=$382;
      $entity=$383;
      var $384=$entity;
      var $385=(($384)|0)!=0;
      if ($385) { __label__ = 66; break; } else { __label__ = 65; break; }
    case 65: // $386
      $1=1;
      __label__ = 452; break;
    case 66: // $387
      var $388=$2;
      var $389=(($388+489)|0);
      var $390=HEAP8[($389)];
      var $391=(($390 << 24) >> 24)!=0;
      if ($391) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $392
      var $393=$2;
      var $394=(($393+360)|0);
      var $395=HEAP32[(($394)>>2)];
      var $396=$entity;
      var $397=(($396+20)|0);
      HEAP32[(($397)>>2)]=$395;
      __label__ = 68; break;
    case 68: // $398
      var $399=$dtd;
      var $400=(($399+131)|0);
      HEAP8[($400)]=0;
      var $401=$2;
      var $402=(($401+112)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=$2;
      var $405=(($404+116)|0);
      var $406=HEAP32[(($405)>>2)];
      var $407=$entity;
      var $408=(($407+20)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=$entity;
      var $411=(($410+16)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=$entity;
      var $414=(($413+24)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=FUNCTION_TABLE[$403]($406, 0, $409, $412, $415);
      var $417=(($416)|0)!=0;
      if ($417) { __label__ = 70; break; } else { __label__ = 69; break; }
    case 69: // $418
      $1=21;
      __label__ = 452; break;
    case 70: // $419
      var $420=$dtd;
      var $421=(($420+131)|0);
      var $422=HEAP8[($421)];
      var $423=(($422 << 24) >> 24)!=0;
      if ($423) { __label__ = 71; break; } else { __label__ = 76; break; }
    case 71: // $424
      var $425=$dtd;
      var $426=(($425+130)|0);
      var $427=HEAP8[($426)];
      var $428=(($427 << 24) >> 24)!=0;
      if ($428) { __label__ = 75; break; } else { __label__ = 72; break; }
    case 72: // $429
      var $430=$2;
      var $431=(($430+108)|0);
      var $432=HEAP32[(($431)>>2)];
      var $433=(($432)|0)!=0;
      if ($433) { __label__ = 73; break; } else { __label__ = 75; break; }
    case 73: // $434
      var $435=$2;
      var $436=(($435+108)|0);
      var $437=HEAP32[(($436)>>2)];
      var $438=$2;
      var $439=(($438+4)|0);
      var $440=HEAP32[(($439)>>2)];
      var $441=FUNCTION_TABLE[$437]($440);
      var $442=(($441)|0)!=0;
      if ($442) { __label__ = 75; break; } else { __label__ = 74; break; }
    case 74: // $443
      $1=22;
      __label__ = 452; break;
    case 75: // $444
      __label__ = 79; break;
    case 76: // $445
      var $446=$2;
      var $447=(($446+324)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=(($448)|0)!=0;
      if ($449) { __label__ = 78; break; } else { __label__ = 77; break; }
    case 77: // $450
      var $451=$hadParamEntityRefs;
      var $452=$dtd;
      var $453=(($452+129)|0);
      HEAP8[($453)]=$451;
      __label__ = 78; break;
    case 78: // $454
      __label__ = 79; break;
    case 79: // $455
      __label__ = 80; break;
    case 80: // $456
      var $457=$2;
      var $458=(($457+489)|0);
      HEAP8[($458)]=0;
      __label__ = 81; break;
    case 81: // $459
      var $460=$2;
      var $461=(($460+88)|0);
      var $462=HEAP32[(($461)>>2)];
      var $463=(($462)|0)!=0;
      if ($463) { __label__ = 82; break; } else { __label__ = 83; break; }
    case 82: // $464
      var $465=$2;
      var $466=(($465+88)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=$2;
      var $469=(($468+4)|0);
      var $470=HEAP32[(($469)>>2)];
      FUNCTION_TABLE[$467]($470);
      $handleDefault=0;
      __label__ = 83; break;
    case 83: // $471
      __label__ = 444; break;
    case 84: // $472
      var $473=$2;
      var $474=(($473+489)|0);
      var $475=HEAP8[($474)];
      var $476=(($475 << 24) >> 24)!=0;
      if ($476) { __label__ = 85; break; } else { __label__ = 100; break; }
    case 85: // $477
      var $478=$dtd;
      var $479=(($478+129)|0);
      var $480=HEAP8[($479)];
      $hadParamEntityRefs2=$480;
      var $481=$dtd;
      var $482=(($481+129)|0);
      HEAP8[($482)]=1;
      var $483=$2;
      var $484=(($483+492)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=(($485)|0)!=0;
      if ($486) { __label__ = 86; break; } else { __label__ = 99; break; }
    case 86: // $487
      var $488=$2;
      var $489=(($488+112)|0);
      var $490=HEAP32[(($489)>>2)];
      var $491=(($490)|0)!=0;
      if ($491) { __label__ = 87; break; } else { __label__ = 99; break; }
    case 87: // $492
      var $493=$dtd;
      var $494=(($493+132)|0);
      var $495=__ZL6lookupP10HASH_TABLEPKcj($494, ((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE18externalSubsetName)|0), 36);
      var $496=$495;
      $entity3=$496;
      var $497=$entity3;
      var $498=(($497)|0)!=0;
      if ($498) { __label__ = 89; break; } else { __label__ = 88; break; }
    case 88: // $499
      $1=1;
      __label__ = 452; break;
    case 89: // $500
      var $501=$2;
      var $502=(($501+360)|0);
      var $503=HEAP32[(($502)>>2)];
      var $504=$entity3;
      var $505=(($504+20)|0);
      HEAP32[(($505)>>2)]=$503;
      var $506=$dtd;
      var $507=(($506+131)|0);
      HEAP8[($507)]=0;
      var $508=$2;
      var $509=(($508+112)|0);
      var $510=HEAP32[(($509)>>2)];
      var $511=$2;
      var $512=(($511+116)|0);
      var $513=HEAP32[(($512)>>2)];
      var $514=$entity3;
      var $515=(($514+20)|0);
      var $516=HEAP32[(($515)>>2)];
      var $517=$entity3;
      var $518=(($517+16)|0);
      var $519=HEAP32[(($518)>>2)];
      var $520=$entity3;
      var $521=(($520+24)|0);
      var $522=HEAP32[(($521)>>2)];
      var $523=FUNCTION_TABLE[$510]($513, 0, $516, $519, $522);
      var $524=(($523)|0)!=0;
      if ($524) { __label__ = 91; break; } else { __label__ = 90; break; }
    case 90: // $525
      $1=21;
      __label__ = 452; break;
    case 91: // $526
      var $527=$dtd;
      var $528=(($527+131)|0);
      var $529=HEAP8[($528)];
      var $530=(($529 << 24) >> 24)!=0;
      if ($530) { __label__ = 92; break; } else { __label__ = 97; break; }
    case 92: // $531
      var $532=$dtd;
      var $533=(($532+130)|0);
      var $534=HEAP8[($533)];
      var $535=(($534 << 24) >> 24)!=0;
      if ($535) { __label__ = 96; break; } else { __label__ = 93; break; }
    case 93: // $536
      var $537=$2;
      var $538=(($537+108)|0);
      var $539=HEAP32[(($538)>>2)];
      var $540=(($539)|0)!=0;
      if ($540) { __label__ = 94; break; } else { __label__ = 96; break; }
    case 94: // $541
      var $542=$2;
      var $543=(($542+108)|0);
      var $544=HEAP32[(($543)>>2)];
      var $545=$2;
      var $546=(($545+4)|0);
      var $547=HEAP32[(($546)>>2)];
      var $548=FUNCTION_TABLE[$544]($547);
      var $549=(($548)|0)!=0;
      if ($549) { __label__ = 96; break; } else { __label__ = 95; break; }
    case 95: // $550
      $1=22;
      __label__ = 452; break;
    case 96: // $551
      __label__ = 98; break;
    case 97: // $552
      var $553=$hadParamEntityRefs2;
      var $554=$dtd;
      var $555=(($554+129)|0);
      HEAP8[($555)]=$553;
      __label__ = 98; break;
    case 98: // $556
      __label__ = 99; break;
    case 99: // $557
      __label__ = 100; break;
    case 100: // $558
      var $559=$2;
      var $560=(($559+280)|0);
      HEAP32[(($560)>>2)]=1506;
      var $561=$2;
      var $562=$4;
      var $563=$5;
      var $564=$8;
      var $565=__ZL16contentProcessorP16XML_ParserStructPKcS2_PS2_($561, $562, $563, $564);
      $1=$565;
      __label__ = 452; break;
    case 101: // $566
      var $567=$2;
      var $568=$3;
      var $569=$4;
      var $570=HEAP32[(($7)>>2)];
      var $571=__ZL14getElementTypeP16XML_ParserStructPK8encodingPKcS5_($567, $568, $569, $570);
      var $572=$2;
      var $573=(($572+344)|0);
      HEAP32[(($573)>>2)]=$571;
      var $574=$2;
      var $575=(($574+344)|0);
      var $576=HEAP32[(($575)>>2)];
      var $577=(($576)|0)!=0;
      if ($577) { __label__ = 103; break; } else { __label__ = 102; break; }
    case 102: // $578
      $1=1;
      __label__ = 452; break;
    case 103: // $579
      __label__ = 115; break;
    case 104: // $580
      var $581=$2;
      var $582=$3;
      var $583=$4;
      var $584=HEAP32[(($7)>>2)];
      var $585=__ZL14getAttributeIdP16XML_ParserStructPK8encodingPKcS5_($581, $582, $583, $584);
      var $586=$2;
      var $587=(($586+348)|0);
      HEAP32[(($587)>>2)]=$585;
      var $588=$2;
      var $589=(($588+348)|0);
      var $590=HEAP32[(($589)>>2)];
      var $591=(($590)|0)!=0;
      if ($591) { __label__ = 106; break; } else { __label__ = 105; break; }
    case 105: // $592
      $1=1;
      __label__ = 452; break;
    case 106: // $593
      var $594=$2;
      var $595=(($594+352)|0);
      HEAP8[($595)]=0;
      var $596=$2;
      var $597=(($596+332)|0);
      HEAP32[(($597)>>2)]=0;
      var $598=$2;
      var $599=(($598+353)|0);
      HEAP8[($599)]=0;
      __label__ = 115; break;
    case 107: // $600
      var $601=$2;
      var $602=(($601+352)|0);
      HEAP8[($602)]=1;
      var $603=$2;
      var $604=(($603+332)|0);
      HEAP32[(($604)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE10atypeCDATA)|0);
      __label__ = 115; break;
    case 108: // $605
      var $606=$2;
      var $607=(($606+353)|0);
      HEAP8[($607)]=1;
      var $608=$2;
      var $609=(($608+332)|0);
      HEAP32[(($609)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE7atypeID)|0);
      __label__ = 115; break;
    case 109: // $610
      var $611=$2;
      var $612=(($611+332)|0);
      HEAP32[(($612)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE10atypeIDREF)|0);
      __label__ = 115; break;
    case 110: // $613
      var $614=$2;
      var $615=(($614+332)|0);
      HEAP32[(($615)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE11atypeIDREFS)|0);
      __label__ = 115; break;
    case 111: // $616
      var $617=$2;
      var $618=(($617+332)|0);
      HEAP32[(($618)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE11atypeENTITY)|0);
      __label__ = 115; break;
    case 112: // $619
      var $620=$2;
      var $621=(($620+332)|0);
      HEAP32[(($621)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE13atypeENTITIES)|0);
      __label__ = 115; break;
    case 113: // $622
      var $623=$2;
      var $624=(($623+332)|0);
      HEAP32[(($624)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE12atypeNMTOKEN)|0);
      __label__ = 115; break;
    case 114: // $625
      var $626=$2;
      var $627=(($626+332)|0);
      HEAP32[(($627)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE13atypeNMTOKENS)|0);
      __label__ = 115; break;
    case 115: // $628
      var $629=$dtd;
      var $630=(($629+128)|0);
      var $631=HEAP8[($630)];
      var $632=(($631 << 24) >> 24)!=0;
      if ($632) { __label__ = 116; break; } else { __label__ = 118; break; }
    case 116: // $633
      var $634=$2;
      var $635=(($634+132)|0);
      var $636=HEAP32[(($635)>>2)];
      var $637=(($636)|0)!=0;
      if ($637) { __label__ = 117; break; } else { __label__ = 118; break; }
    case 117: // $638
      $handleDefault=0;
      __label__ = 118; break;
    case 118: // $639
      __label__ = 444; break;
    case 119: // $640
      var $641=$dtd;
      var $642=(($641+128)|0);
      var $643=HEAP8[($642)];
      var $644=(($643 << 24) >> 24)!=0;
      if ($644) { __label__ = 120; break; } else { __label__ = 129; break; }
    case 120: // $645
      var $646=$2;
      var $647=(($646+132)|0);
      var $648=HEAP32[(($647)>>2)];
      var $649=(($648)|0)!=0;
      if ($649) { __label__ = 121; break; } else { __label__ = 129; break; }
    case 121: // $650
      var $651=$2;
      var $652=(($651+332)|0);
      var $653=HEAP32[(($652)>>2)];
      var $654=(($653)|0)!=0;
      if ($654) { __label__ = 122; break; } else { __label__ = 123; break; }
    case 122: // $655
      $prefix=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE12enumValueSep)|0);
      __label__ = 124; break;
    case 123: // $656
      var $657=$role;
      var $658=(($657)|0)==32;
      var $659=$658 ? (((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE14notationPrefix)|0)) : (((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE14enumValueStart)|0));
      $prefix=$659;
      __label__ = 124; break;
    case 124: // $660
      var $661=$2;
      var $662=(($661+416)|0);
      var $663=$prefix;
      var $664=__ZL16poolAppendStringP11STRING_POOLPKc($662, $663);
      var $665=(($664)|0)!=0;
      if ($665) { __label__ = 126; break; } else { __label__ = 125; break; }
    case 125: // $666
      $1=1;
      __label__ = 452; break;
    case 126: // $667
      var $668=$2;
      var $669=(($668+416)|0);
      var $670=$3;
      var $671=$4;
      var $672=HEAP32[(($7)>>2)];
      var $673=__ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_($669, $670, $671, $672);
      var $674=(($673)|0)!=0;
      if ($674) { __label__ = 128; break; } else { __label__ = 127; break; }
    case 127: // $675
      $1=1;
      __label__ = 452; break;
    case 128: // $676
      var $677=$2;
      var $678=(($677+416)|0);
      var $679=(($678+16)|0);
      var $680=HEAP32[(($679)>>2)];
      var $681=$2;
      var $682=(($681+332)|0);
      HEAP32[(($682)>>2)]=$680;
      $handleDefault=0;
      __label__ = 129; break;
    case 129: // $683
      __label__ = 444; break;
    case 130: // $684
      var $685=$dtd;
      var $686=(($685+128)|0);
      var $687=HEAP8[($686)];
      var $688=(($687 << 24) >> 24)!=0;
      if ($688) { __label__ = 131; break; } else { __label__ = 152; break; }
    case 131: // $689
      var $690=$2;
      var $691=(($690+344)|0);
      var $692=HEAP32[(($691)>>2)];
      var $693=$2;
      var $694=(($693+348)|0);
      var $695=HEAP32[(($694)>>2)];
      var $696=$2;
      var $697=(($696+352)|0);
      var $698=HEAP8[($697)];
      var $699=$2;
      var $700=(($699+353)|0);
      var $701=HEAP8[($700)];
      var $702=$2;
      var $703=__ZL15defineAttributeP12ELEMENT_TYPEP12attribute_idhhPKcP16XML_ParserStruct($692, $695, $698, $701, 0, $702);
      var $704=(($703)|0)!=0;
      if ($704) { __label__ = 133; break; } else { __label__ = 132; break; }
    case 132: // $705
      $1=1;
      __label__ = 452; break;
    case 133: // $706
      var $707=$2;
      var $708=(($707+132)|0);
      var $709=HEAP32[(($708)>>2)];
      var $710=(($709)|0)!=0;
      if ($710) { __label__ = 134; break; } else { __label__ = 151; break; }
    case 134: // $711
      var $712=$2;
      var $713=(($712+332)|0);
      var $714=HEAP32[(($713)>>2)];
      var $715=(($714)|0)!=0;
      if ($715) { __label__ = 135; break; } else { __label__ = 151; break; }
    case 135: // $716
      var $717=$2;
      var $718=(($717+332)|0);
      var $719=HEAP32[(($718)>>2)];
      var $720=HEAP8[($719)];
      var $721=(($720 << 24) >> 24);
      var $722=(($721)|0)==40;
      if ($722) { __label__ = 138; break; } else { __label__ = 136; break; }
    case 136: // $723
      var $724=$2;
      var $725=(($724+332)|0);
      var $726=HEAP32[(($725)>>2)];
      var $727=HEAP8[($726)];
      var $728=(($727 << 24) >> 24);
      var $729=(($728)|0)==78;
      if ($729) { __label__ = 137; break; } else { __label__ = 150; break; }
    case 137: // $730
      var $731=$2;
      var $732=(($731+332)|0);
      var $733=HEAP32[(($732)>>2)];
      var $734=(($733+1)|0);
      var $735=HEAP8[($734)];
      var $736=(($735 << 24) >> 24);
      var $737=(($736)|0)==79;
      if ($737) { __label__ = 138; break; } else { __label__ = 150; break; }
    case 138: // $738
      var $739=$2;
      var $740=(($739+416)|0);
      var $741=(($740+12)|0);
      var $742=HEAP32[(($741)>>2)];
      var $743=$2;
      var $744=(($743+416)|0);
      var $745=(($744+8)|0);
      var $746=HEAP32[(($745)>>2)];
      var $747=(($742)|0)==(($746)|0);
      if ($747) { __label__ = 139; break; } else { __label__ = 141; break; }
    case 139: // $748
      var $749=$2;
      var $750=(($749+416)|0);
      var $751=__ZL8poolGrowP11STRING_POOL($750);
      var $752=(($751 << 24) >> 24)!=0;
      if ($752) { __label__ = 141; break; } else { __label__ = 140; break; }
    case 140: // $753
      var $761 = 0;__label__ = 142; break;
    case 141: // $754
      var $755=$2;
      var $756=(($755+416)|0);
      var $757=(($756+12)|0);
      var $758=HEAP32[(($757)>>2)];
      var $759=(($758+1)|0);
      HEAP32[(($757)>>2)]=$759;
      HEAP8[($758)]=41;
      var $761 = 1;__label__ = 142; break;
    case 142: // $760
      var $761;
      var $762=(($761)|0)!=0;
      if ($762) { __label__ = 143; break; } else { __label__ = 148; break; }
    case 143: // $763
      var $764=$2;
      var $765=(($764+416)|0);
      var $766=(($765+12)|0);
      var $767=HEAP32[(($766)>>2)];
      var $768=$2;
      var $769=(($768+416)|0);
      var $770=(($769+8)|0);
      var $771=HEAP32[(($770)>>2)];
      var $772=(($767)|0)==(($771)|0);
      if ($772) { __label__ = 144; break; } else { __label__ = 146; break; }
    case 144: // $773
      var $774=$2;
      var $775=(($774+416)|0);
      var $776=__ZL8poolGrowP11STRING_POOL($775);
      var $777=(($776 << 24) >> 24)!=0;
      if ($777) { __label__ = 146; break; } else { __label__ = 145; break; }
    case 145: // $778
      var $786 = 0;__label__ = 147; break;
    case 146: // $779
      var $780=$2;
      var $781=(($780+416)|0);
      var $782=(($781+12)|0);
      var $783=HEAP32[(($782)>>2)];
      var $784=(($783+1)|0);
      HEAP32[(($782)>>2)]=$784;
      HEAP8[($783)]=0;
      var $786 = 1;__label__ = 147; break;
    case 147: // $785
      var $786;
      var $787=(($786)|0)!=0;
      if ($787) { __label__ = 149; break; } else { __label__ = 148; break; }
    case 148: // $788
      $1=1;
      __label__ = 452; break;
    case 149: // $789
      var $790=$2;
      var $791=(($790+416)|0);
      var $792=(($791+16)|0);
      var $793=HEAP32[(($792)>>2)];
      var $794=$2;
      var $795=(($794+332)|0);
      HEAP32[(($795)>>2)]=$793;
      var $796=$2;
      var $797=(($796+416)|0);
      var $798=(($797+12)|0);
      var $799=HEAP32[(($798)>>2)];
      var $800=$2;
      var $801=(($800+416)|0);
      var $802=(($801+16)|0);
      HEAP32[(($802)>>2)]=$799;
      __label__ = 150; break;
    case 150: // $803
      var $804=$4;
      var $805=$eventEndPP;
      HEAP32[(($805)>>2)]=$804;
      var $806=$2;
      var $807=(($806+132)|0);
      var $808=HEAP32[(($807)>>2)];
      var $809=$2;
      var $810=(($809+4)|0);
      var $811=HEAP32[(($810)>>2)];
      var $812=$2;
      var $813=(($812+344)|0);
      var $814=HEAP32[(($813)>>2)];
      var $815=(($814)|0);
      var $816=HEAP32[(($815)>>2)];
      var $817=$2;
      var $818=(($817+348)|0);
      var $819=HEAP32[(($818)>>2)];
      var $820=(($819)|0);
      var $821=HEAP32[(($820)>>2)];
      var $822=$2;
      var $823=(($822+332)|0);
      var $824=HEAP32[(($823)>>2)];
      var $825=$role;
      var $826=(($825)|0)==36;
      var $827=(($826)&1);
      FUNCTION_TABLE[$808]($811, $816, $821, $824, 0, $827);
      var $828=$2;
      var $829=(($828+416)|0);
      __ZL9poolClearP11STRING_POOL($829);
      $handleDefault=0;
      __label__ = 151; break;
    case 151: // $830
      __label__ = 152; break;
    case 152: // $831
      __label__ = 444; break;
    case 153: // $832
      var $833=$dtd;
      var $834=(($833+128)|0);
      var $835=HEAP8[($834)];
      var $836=(($835 << 24) >> 24)!=0;
      if ($836) { __label__ = 154; break; } else { __label__ = 177; break; }
    case 154: // $837
      var $838=$2;
      var $839=$3;
      var $840=$2;
      var $841=(($840+352)|0);
      var $842=HEAP8[($841)];
      var $843=$4;
      var $844=$3;
      var $845=(($844+68)|0);
      var $846=HEAP32[(($845)>>2)];
      var $847=(($843+$846)|0);
      var $848=HEAP32[(($7)>>2)];
      var $849=$3;
      var $850=(($849+68)|0);
      var $851=HEAP32[(($850)>>2)];
      var $852=(((-$851))|0);
      var $853=(($848+$852)|0);
      var $854=$dtd;
      var $855=(($854+80)|0);
      var $856=__ZL19storeAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL($838, $839, $842, $847, $853, $855);
      $result4=$856;
      var $857=$result4;
      var $858=(($857)|0)!=0;
      if ($858) { __label__ = 155; break; } else { __label__ = 156; break; }
    case 155: // $859
      var $860=$result4;
      $1=$860;
      __label__ = 452; break;
    case 156: // $861
      var $862=$dtd;
      var $863=(($862+80)|0);
      var $864=(($863+16)|0);
      var $865=HEAP32[(($864)>>2)];
      $attVal=$865;
      var $866=$dtd;
      var $867=(($866+80)|0);
      var $868=(($867+12)|0);
      var $869=HEAP32[(($868)>>2)];
      var $870=$dtd;
      var $871=(($870+80)|0);
      var $872=(($871+16)|0);
      HEAP32[(($872)>>2)]=$869;
      var $873=$2;
      var $874=(($873+344)|0);
      var $875=HEAP32[(($874)>>2)];
      var $876=$2;
      var $877=(($876+348)|0);
      var $878=HEAP32[(($877)>>2)];
      var $879=$2;
      var $880=(($879+352)|0);
      var $881=HEAP8[($880)];
      var $882=$attVal;
      var $883=$2;
      var $884=__ZL15defineAttributeP12ELEMENT_TYPEP12attribute_idhhPKcP16XML_ParserStruct($875, $878, $881, 0, $882, $883);
      var $885=(($884)|0)!=0;
      if ($885) { __label__ = 158; break; } else { __label__ = 157; break; }
    case 157: // $886
      $1=1;
      __label__ = 452; break;
    case 158: // $887
      var $888=$2;
      var $889=(($888+132)|0);
      var $890=HEAP32[(($889)>>2)];
      var $891=(($890)|0)!=0;
      if ($891) { __label__ = 159; break; } else { __label__ = 176; break; }
    case 159: // $892
      var $893=$2;
      var $894=(($893+332)|0);
      var $895=HEAP32[(($894)>>2)];
      var $896=(($895)|0)!=0;
      if ($896) { __label__ = 160; break; } else { __label__ = 176; break; }
    case 160: // $897
      var $898=$2;
      var $899=(($898+332)|0);
      var $900=HEAP32[(($899)>>2)];
      var $901=HEAP8[($900)];
      var $902=(($901 << 24) >> 24);
      var $903=(($902)|0)==40;
      if ($903) { __label__ = 163; break; } else { __label__ = 161; break; }
    case 161: // $904
      var $905=$2;
      var $906=(($905+332)|0);
      var $907=HEAP32[(($906)>>2)];
      var $908=HEAP8[($907)];
      var $909=(($908 << 24) >> 24);
      var $910=(($909)|0)==78;
      if ($910) { __label__ = 162; break; } else { __label__ = 175; break; }
    case 162: // $911
      var $912=$2;
      var $913=(($912+332)|0);
      var $914=HEAP32[(($913)>>2)];
      var $915=(($914+1)|0);
      var $916=HEAP8[($915)];
      var $917=(($916 << 24) >> 24);
      var $918=(($917)|0)==79;
      if ($918) { __label__ = 163; break; } else { __label__ = 175; break; }
    case 163: // $919
      var $920=$2;
      var $921=(($920+416)|0);
      var $922=(($921+12)|0);
      var $923=HEAP32[(($922)>>2)];
      var $924=$2;
      var $925=(($924+416)|0);
      var $926=(($925+8)|0);
      var $927=HEAP32[(($926)>>2)];
      var $928=(($923)|0)==(($927)|0);
      if ($928) { __label__ = 164; break; } else { __label__ = 166; break; }
    case 164: // $929
      var $930=$2;
      var $931=(($930+416)|0);
      var $932=__ZL8poolGrowP11STRING_POOL($931);
      var $933=(($932 << 24) >> 24)!=0;
      if ($933) { __label__ = 166; break; } else { __label__ = 165; break; }
    case 165: // $934
      var $942 = 0;__label__ = 167; break;
    case 166: // $935
      var $936=$2;
      var $937=(($936+416)|0);
      var $938=(($937+12)|0);
      var $939=HEAP32[(($938)>>2)];
      var $940=(($939+1)|0);
      HEAP32[(($938)>>2)]=$940;
      HEAP8[($939)]=41;
      var $942 = 1;__label__ = 167; break;
    case 167: // $941
      var $942;
      var $943=(($942)|0)!=0;
      if ($943) { __label__ = 168; break; } else { __label__ = 173; break; }
    case 168: // $944
      var $945=$2;
      var $946=(($945+416)|0);
      var $947=(($946+12)|0);
      var $948=HEAP32[(($947)>>2)];
      var $949=$2;
      var $950=(($949+416)|0);
      var $951=(($950+8)|0);
      var $952=HEAP32[(($951)>>2)];
      var $953=(($948)|0)==(($952)|0);
      if ($953) { __label__ = 169; break; } else { __label__ = 171; break; }
    case 169: // $954
      var $955=$2;
      var $956=(($955+416)|0);
      var $957=__ZL8poolGrowP11STRING_POOL($956);
      var $958=(($957 << 24) >> 24)!=0;
      if ($958) { __label__ = 171; break; } else { __label__ = 170; break; }
    case 170: // $959
      var $967 = 0;__label__ = 172; break;
    case 171: // $960
      var $961=$2;
      var $962=(($961+416)|0);
      var $963=(($962+12)|0);
      var $964=HEAP32[(($963)>>2)];
      var $965=(($964+1)|0);
      HEAP32[(($963)>>2)]=$965;
      HEAP8[($964)]=0;
      var $967 = 1;__label__ = 172; break;
    case 172: // $966
      var $967;
      var $968=(($967)|0)!=0;
      if ($968) { __label__ = 174; break; } else { __label__ = 173; break; }
    case 173: // $969
      $1=1;
      __label__ = 452; break;
    case 174: // $970
      var $971=$2;
      var $972=(($971+416)|0);
      var $973=(($972+16)|0);
      var $974=HEAP32[(($973)>>2)];
      var $975=$2;
      var $976=(($975+332)|0);
      HEAP32[(($976)>>2)]=$974;
      var $977=$2;
      var $978=(($977+416)|0);
      var $979=(($978+12)|0);
      var $980=HEAP32[(($979)>>2)];
      var $981=$2;
      var $982=(($981+416)|0);
      var $983=(($982+16)|0);
      HEAP32[(($983)>>2)]=$980;
      __label__ = 175; break;
    case 175: // $984
      var $985=$4;
      var $986=$eventEndPP;
      HEAP32[(($986)>>2)]=$985;
      var $987=$2;
      var $988=(($987+132)|0);
      var $989=HEAP32[(($988)>>2)];
      var $990=$2;
      var $991=(($990+4)|0);
      var $992=HEAP32[(($991)>>2)];
      var $993=$2;
      var $994=(($993+344)|0);
      var $995=HEAP32[(($994)>>2)];
      var $996=(($995)|0);
      var $997=HEAP32[(($996)>>2)];
      var $998=$2;
      var $999=(($998+348)|0);
      var $1000=HEAP32[(($999)>>2)];
      var $1001=(($1000)|0);
      var $1002=HEAP32[(($1001)>>2)];
      var $1003=$2;
      var $1004=(($1003+332)|0);
      var $1005=HEAP32[(($1004)>>2)];
      var $1006=$attVal;
      var $1007=$role;
      var $1008=(($1007)|0)==38;
      var $1009=(($1008)&1);
      FUNCTION_TABLE[$989]($992, $997, $1002, $1005, $1006, $1009);
      var $1010=$2;
      var $1011=(($1010+416)|0);
      __ZL9poolClearP11STRING_POOL($1011);
      $handleDefault=0;
      __label__ = 176; break;
    case 176: // $1012
      __label__ = 177; break;
    case 177: // $1013
      __label__ = 444; break;
    case 178: // $1014
      var $1015=$dtd;
      var $1016=(($1015+128)|0);
      var $1017=HEAP8[($1016)];
      var $1018=(($1017 << 24) >> 24)!=0;
      if ($1018) { __label__ = 179; break; } else { __label__ = 187; break; }
    case 179: // $1019
      var $1020=$2;
      var $1021=$3;
      var $1022=$4;
      var $1023=$3;
      var $1024=(($1023+68)|0);
      var $1025=HEAP32[(($1024)>>2)];
      var $1026=(($1022+$1025)|0);
      var $1027=HEAP32[(($7)>>2)];
      var $1028=$3;
      var $1029=(($1028+68)|0);
      var $1030=HEAP32[(($1029)>>2)];
      var $1031=(((-$1030))|0);
      var $1032=(($1027+$1031)|0);
      var $1033=__ZL16storeEntityValueP16XML_ParserStructPK8encodingPKcS5_($1020, $1021, $1026, $1032);
      $result5=$1033;
      var $1034=$2;
      var $1035=(($1034+316)|0);
      var $1036=HEAP32[(($1035)>>2)];
      var $1037=(($1036)|0)!=0;
      if ($1037) { __label__ = 180; break; } else { __label__ = 183; break; }
    case 180: // $1038
      var $1039=$dtd;
      var $1040=(($1039+104)|0);
      var $1041=(($1040+16)|0);
      var $1042=HEAP32[(($1041)>>2)];
      var $1043=$2;
      var $1044=(($1043+316)|0);
      var $1045=HEAP32[(($1044)>>2)];
      var $1046=(($1045+4)|0);
      HEAP32[(($1046)>>2)]=$1042;
      var $1047=$dtd;
      var $1048=(($1047+104)|0);
      var $1049=(($1048+12)|0);
      var $1050=HEAP32[(($1049)>>2)];
      var $1051=$dtd;
      var $1052=(($1051+104)|0);
      var $1053=(($1052+16)|0);
      var $1054=HEAP32[(($1053)>>2)];
      var $1055=$1050;
      var $1056=$1054;
      var $1057=(($1055-$1056)|0);
      var $1058=$2;
      var $1059=(($1058+316)|0);
      var $1060=HEAP32[(($1059)>>2)];
      var $1061=(($1060+8)|0);
      HEAP32[(($1061)>>2)]=$1057;
      var $1062=$dtd;
      var $1063=(($1062+104)|0);
      var $1064=(($1063+12)|0);
      var $1065=HEAP32[(($1064)>>2)];
      var $1066=$dtd;
      var $1067=(($1066+104)|0);
      var $1068=(($1067+16)|0);
      HEAP32[(($1068)>>2)]=$1065;
      var $1069=$2;
      var $1070=(($1069+136)|0);
      var $1071=HEAP32[(($1070)>>2)];
      var $1072=(($1071)|0)!=0;
      if ($1072) { __label__ = 181; break; } else { __label__ = 182; break; }
    case 181: // $1073
      var $1074=$4;
      var $1075=$eventEndPP;
      HEAP32[(($1075)>>2)]=$1074;
      var $1076=$2;
      var $1077=(($1076+136)|0);
      var $1078=HEAP32[(($1077)>>2)];
      var $1079=$2;
      var $1080=(($1079+4)|0);
      var $1081=HEAP32[(($1080)>>2)];
      var $1082=$2;
      var $1083=(($1082+316)|0);
      var $1084=HEAP32[(($1083)>>2)];
      var $1085=(($1084)|0);
      var $1086=HEAP32[(($1085)>>2)];
      var $1087=$2;
      var $1088=(($1087+316)|0);
      var $1089=HEAP32[(($1088)>>2)];
      var $1090=(($1089+33)|0);
      var $1091=HEAPU8[($1090)];
      var $1092=(($1091)&255);
      var $1093=$2;
      var $1094=(($1093+316)|0);
      var $1095=HEAP32[(($1094)>>2)];
      var $1096=(($1095+4)|0);
      var $1097=HEAP32[(($1096)>>2)];
      var $1098=$2;
      var $1099=(($1098+316)|0);
      var $1100=HEAP32[(($1099)>>2)];
      var $1101=(($1100+8)|0);
      var $1102=HEAP32[(($1101)>>2)];
      var $1103=$2;
      var $1104=(($1103+360)|0);
      var $1105=HEAP32[(($1104)>>2)];
      FUNCTION_TABLE[$1078]($1081, $1086, $1092, $1097, $1102, $1105, 0, 0, 0);
      $handleDefault=0;
      __label__ = 182; break;
    case 182: // $1106
      __label__ = 184; break;
    case 183: // $1107
      var $1108=$dtd;
      var $1109=(($1108+104)|0);
      var $1110=(($1109+16)|0);
      var $1111=HEAP32[(($1110)>>2)];
      var $1112=$dtd;
      var $1113=(($1112+104)|0);
      var $1114=(($1113+12)|0);
      HEAP32[(($1114)>>2)]=$1111;
      __label__ = 184; break;
    case 184: // $1115
      var $1116=$result5;
      var $1117=(($1116)|0)!=0;
      if ($1117) { __label__ = 185; break; } else { __label__ = 186; break; }
    case 185: // $1118
      var $1119=$result5;
      $1=$1119;
      __label__ = 452; break;
    case 186: // $1120
      __label__ = 187; break;
    case 187: // $1121
      __label__ = 444; break;
    case 188: // $1122
      var $1123=$2;
      var $1124=(($1123+489)|0);
      HEAP8[($1124)]=0;
      var $1125=$dtd;
      var $1126=(($1125+129)|0);
      HEAP8[($1126)]=1;
      var $1127=$2;
      var $1128=(($1127+84)|0);
      var $1129=HEAP32[(($1128)>>2)];
      var $1130=(($1129)|0)!=0;
      if ($1130) { __label__ = 189; break; } else { __label__ = 192; break; }
    case 189: // $1131
      var $1132=$2;
      var $1133=(($1132+416)|0);
      var $1134=$3;
      var $1135=$4;
      var $1136=$3;
      var $1137=(($1136+68)|0);
      var $1138=HEAP32[(($1137)>>2)];
      var $1139=(($1135+$1138)|0);
      var $1140=HEAP32[(($7)>>2)];
      var $1141=$3;
      var $1142=(($1141+68)|0);
      var $1143=HEAP32[(($1142)>>2)];
      var $1144=(((-$1143))|0);
      var $1145=(($1140+$1144)|0);
      var $1146=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1133, $1134, $1139, $1145);
      var $1147=$2;
      var $1148=(($1147+324)|0);
      HEAP32[(($1148)>>2)]=$1146;
      var $1149=$2;
      var $1150=(($1149+324)|0);
      var $1151=HEAP32[(($1150)>>2)];
      var $1152=(($1151)|0)==0;
      if ($1152) { __label__ = 190; break; } else { __label__ = 191; break; }
    case 190: // $1153
      $1=1;
      __label__ = 452; break;
    case 191: // $1154
      var $1155=$2;
      var $1156=(($1155+416)|0);
      var $1157=(($1156+12)|0);
      var $1158=HEAP32[(($1157)>>2)];
      var $1159=$2;
      var $1160=(($1159+416)|0);
      var $1161=(($1160+16)|0);
      HEAP32[(($1161)>>2)]=$1158;
      $handleDefault=0;
      __label__ = 193; break;
    case 192: // $1162
      var $1163=$2;
      var $1164=(($1163+324)|0);
      HEAP32[(($1164)>>2)]=((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE18externalSubsetName)|0);
      __label__ = 193; break;
    case 193: // $1165
      var $1166=$dtd;
      var $1167=(($1166+130)|0);
      var $1168=HEAP8[($1167)];
      var $1169=(($1168 << 24) >> 24)!=0;
      if ($1169) { __label__ = 198; break; } else { __label__ = 194; break; }
    case 194: // $1170
      var $1171=$2;
      var $1172=(($1171+492)|0);
      var $1173=HEAP32[(($1172)>>2)];
      var $1174=(($1173)|0)!=0;
      if ($1174) { __label__ = 198; break; } else { __label__ = 195; break; }
    case 195: // $1175
      var $1176=$2;
      var $1177=(($1176+108)|0);
      var $1178=HEAP32[(($1177)>>2)];
      var $1179=(($1178)|0)!=0;
      if ($1179) { __label__ = 196; break; } else { __label__ = 198; break; }
    case 196: // $1180
      var $1181=$2;
      var $1182=(($1181+108)|0);
      var $1183=HEAP32[(($1182)>>2)];
      var $1184=$2;
      var $1185=(($1184+4)|0);
      var $1186=HEAP32[(($1185)>>2)];
      var $1187=FUNCTION_TABLE[$1183]($1186);
      var $1188=(($1187)|0)!=0;
      if ($1188) { __label__ = 198; break; } else { __label__ = 197; break; }
    case 197: // $1189
      $1=22;
      __label__ = 452; break;
    case 198: // $1190
      var $1191=$2;
      var $1192=(($1191+316)|0);
      var $1193=HEAP32[(($1192)>>2)];
      var $1194=(($1193)|0)!=0;
      if ($1194) { __label__ = 202; break; } else { __label__ = 199; break; }
    case 199: // $1195
      var $1196=$dtd;
      var $1197=(($1196+132)|0);
      var $1198=__ZL6lookupP10HASH_TABLEPKcj($1197, ((STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE18externalSubsetName)|0), 36);
      var $1199=$1198;
      var $1200=$2;
      var $1201=(($1200+316)|0);
      HEAP32[(($1201)>>2)]=$1199;
      var $1202=$2;
      var $1203=(($1202+316)|0);
      var $1204=HEAP32[(($1203)>>2)];
      var $1205=(($1204)|0)!=0;
      if ($1205) { __label__ = 201; break; } else { __label__ = 200; break; }
    case 200: // $1206
      $1=1;
      __label__ = 452; break;
    case 201: // $1207
      var $1208=$2;
      var $1209=(($1208+316)|0);
      var $1210=HEAP32[(($1209)>>2)];
      var $1211=(($1210+24)|0);
      HEAP32[(($1211)>>2)]=0;
      __label__ = 202; break;
    case 202: // $1212
      __label__ = 203; break;
    case 203: // $1213
      var $1214=$dtd;
      var $1215=(($1214+128)|0);
      var $1216=HEAP8[($1215)];
      var $1217=(($1216 << 24) >> 24)!=0;
      if ($1217) { __label__ = 204; break; } else { __label__ = 210; break; }
    case 204: // $1218
      var $1219=$2;
      var $1220=(($1219+316)|0);
      var $1221=HEAP32[(($1220)>>2)];
      var $1222=(($1221)|0)!=0;
      if ($1222) { __label__ = 205; break; } else { __label__ = 210; break; }
    case 205: // $1223
      var $1224=$dtd;
      var $1225=(($1224+80)|0);
      var $1226=$3;
      var $1227=$4;
      var $1228=$3;
      var $1229=(($1228+68)|0);
      var $1230=HEAP32[(($1229)>>2)];
      var $1231=(($1227+$1230)|0);
      var $1232=HEAP32[(($7)>>2)];
      var $1233=$3;
      var $1234=(($1233+68)|0);
      var $1235=HEAP32[(($1234)>>2)];
      var $1236=(((-$1235))|0);
      var $1237=(($1232+$1236)|0);
      var $1238=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1225, $1226, $1231, $1237);
      var $1239=$2;
      var $1240=(($1239+316)|0);
      var $1241=HEAP32[(($1240)>>2)];
      var $1242=(($1241+16)|0);
      HEAP32[(($1242)>>2)]=$1238;
      var $1243=$2;
      var $1244=(($1243+316)|0);
      var $1245=HEAP32[(($1244)>>2)];
      var $1246=(($1245+16)|0);
      var $1247=HEAP32[(($1246)>>2)];
      var $1248=(($1247)|0)!=0;
      if ($1248) { __label__ = 207; break; } else { __label__ = 206; break; }
    case 206: // $1249
      $1=1;
      __label__ = 452; break;
    case 207: // $1250
      var $1251=$2;
      var $1252=(($1251+360)|0);
      var $1253=HEAP32[(($1252)>>2)];
      var $1254=$2;
      var $1255=(($1254+316)|0);
      var $1256=HEAP32[(($1255)>>2)];
      var $1257=(($1256+20)|0);
      HEAP32[(($1257)>>2)]=$1253;
      var $1258=$dtd;
      var $1259=(($1258+80)|0);
      var $1260=(($1259+12)|0);
      var $1261=HEAP32[(($1260)>>2)];
      var $1262=$dtd;
      var $1263=(($1262+80)|0);
      var $1264=(($1263+16)|0);
      HEAP32[(($1264)>>2)]=$1261;
      var $1265=$2;
      var $1266=(($1265+136)|0);
      var $1267=HEAP32[(($1266)>>2)];
      var $1268=(($1267)|0)!=0;
      if ($1268) { __label__ = 208; break; } else { __label__ = 209; break; }
    case 208: // $1269
      $handleDefault=0;
      __label__ = 209; break;
    case 209: // $1270
      __label__ = 210; break;
    case 210: // $1271
      __label__ = 444; break;
    case 211: // $1272
      var $1273=$dtd;
      var $1274=(($1273+128)|0);
      var $1275=HEAP8[($1274)];
      var $1276=(($1275 << 24) >> 24)!=0;
      if ($1276) { __label__ = 212; break; } else { __label__ = 215; break; }
    case 212: // $1277
      var $1278=$2;
      var $1279=(($1278+316)|0);
      var $1280=HEAP32[(($1279)>>2)];
      var $1281=(($1280)|0)!=0;
      if ($1281) { __label__ = 213; break; } else { __label__ = 215; break; }
    case 213: // $1282
      var $1283=$2;
      var $1284=(($1283+136)|0);
      var $1285=HEAP32[(($1284)>>2)];
      var $1286=(($1285)|0)!=0;
      if ($1286) { __label__ = 214; break; } else { __label__ = 215; break; }
    case 214: // $1287
      var $1288=$4;
      var $1289=$eventEndPP;
      HEAP32[(($1289)>>2)]=$1288;
      var $1290=$2;
      var $1291=(($1290+136)|0);
      var $1292=HEAP32[(($1291)>>2)];
      var $1293=$2;
      var $1294=(($1293+4)|0);
      var $1295=HEAP32[(($1294)>>2)];
      var $1296=$2;
      var $1297=(($1296+316)|0);
      var $1298=HEAP32[(($1297)>>2)];
      var $1299=(($1298)|0);
      var $1300=HEAP32[(($1299)>>2)];
      var $1301=$2;
      var $1302=(($1301+316)|0);
      var $1303=HEAP32[(($1302)>>2)];
      var $1304=(($1303+33)|0);
      var $1305=HEAPU8[($1304)];
      var $1306=(($1305)&255);
      var $1307=$2;
      var $1308=(($1307+316)|0);
      var $1309=HEAP32[(($1308)>>2)];
      var $1310=(($1309+20)|0);
      var $1311=HEAP32[(($1310)>>2)];
      var $1312=$2;
      var $1313=(($1312+316)|0);
      var $1314=HEAP32[(($1313)>>2)];
      var $1315=(($1314+16)|0);
      var $1316=HEAP32[(($1315)>>2)];
      var $1317=$2;
      var $1318=(($1317+316)|0);
      var $1319=HEAP32[(($1318)>>2)];
      var $1320=(($1319+24)|0);
      var $1321=HEAP32[(($1320)>>2)];
      FUNCTION_TABLE[$1292]($1295, $1300, $1306, 0, 0, $1311, $1316, $1321, 0);
      $handleDefault=0;
      __label__ = 215; break;
    case 215: // $1322
      __label__ = 444; break;
    case 216: // $1323
      var $1324=$dtd;
      var $1325=(($1324+128)|0);
      var $1326=HEAP8[($1325)];
      var $1327=(($1326 << 24) >> 24)!=0;
      if ($1327) { __label__ = 217; break; } else { __label__ = 226; break; }
    case 217: // $1328
      var $1329=$2;
      var $1330=(($1329+316)|0);
      var $1331=HEAP32[(($1330)>>2)];
      var $1332=(($1331)|0)!=0;
      if ($1332) { __label__ = 218; break; } else { __label__ = 226; break; }
    case 218: // $1333
      var $1334=$dtd;
      var $1335=(($1334+80)|0);
      var $1336=$3;
      var $1337=$4;
      var $1338=HEAP32[(($7)>>2)];
      var $1339=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1335, $1336, $1337, $1338);
      var $1340=$2;
      var $1341=(($1340+316)|0);
      var $1342=HEAP32[(($1341)>>2)];
      var $1343=(($1342+28)|0);
      HEAP32[(($1343)>>2)]=$1339;
      var $1344=$2;
      var $1345=(($1344+316)|0);
      var $1346=HEAP32[(($1345)>>2)];
      var $1347=(($1346+28)|0);
      var $1348=HEAP32[(($1347)>>2)];
      var $1349=(($1348)|0)!=0;
      if ($1349) { __label__ = 220; break; } else { __label__ = 219; break; }
    case 219: // $1350
      $1=1;
      __label__ = 452; break;
    case 220: // $1351
      var $1352=$dtd;
      var $1353=(($1352+80)|0);
      var $1354=(($1353+12)|0);
      var $1355=HEAP32[(($1354)>>2)];
      var $1356=$dtd;
      var $1357=(($1356+80)|0);
      var $1358=(($1357+16)|0);
      HEAP32[(($1358)>>2)]=$1355;
      var $1359=$2;
      var $1360=(($1359+92)|0);
      var $1361=HEAP32[(($1360)>>2)];
      var $1362=(($1361)|0)!=0;
      if ($1362) { __label__ = 221; break; } else { __label__ = 222; break; }
    case 221: // $1363
      var $1364=$4;
      var $1365=$eventEndPP;
      HEAP32[(($1365)>>2)]=$1364;
      var $1366=$2;
      var $1367=(($1366+92)|0);
      var $1368=HEAP32[(($1367)>>2)];
      var $1369=$2;
      var $1370=(($1369+4)|0);
      var $1371=HEAP32[(($1370)>>2)];
      var $1372=$2;
      var $1373=(($1372+316)|0);
      var $1374=HEAP32[(($1373)>>2)];
      var $1375=(($1374)|0);
      var $1376=HEAP32[(($1375)>>2)];
      var $1377=$2;
      var $1378=(($1377+316)|0);
      var $1379=HEAP32[(($1378)>>2)];
      var $1380=(($1379+20)|0);
      var $1381=HEAP32[(($1380)>>2)];
      var $1382=$2;
      var $1383=(($1382+316)|0);
      var $1384=HEAP32[(($1383)>>2)];
      var $1385=(($1384+16)|0);
      var $1386=HEAP32[(($1385)>>2)];
      var $1387=$2;
      var $1388=(($1387+316)|0);
      var $1389=HEAP32[(($1388)>>2)];
      var $1390=(($1389+24)|0);
      var $1391=HEAP32[(($1390)>>2)];
      var $1392=$2;
      var $1393=(($1392+316)|0);
      var $1394=HEAP32[(($1393)>>2)];
      var $1395=(($1394+28)|0);
      var $1396=HEAP32[(($1395)>>2)];
      FUNCTION_TABLE[$1368]($1371, $1376, $1381, $1386, $1391, $1396);
      $handleDefault=0;
      __label__ = 225; break;
    case 222: // $1397
      var $1398=$2;
      var $1399=(($1398+136)|0);
      var $1400=HEAP32[(($1399)>>2)];
      var $1401=(($1400)|0)!=0;
      if ($1401) { __label__ = 223; break; } else { __label__ = 224; break; }
    case 223: // $1402
      var $1403=$4;
      var $1404=$eventEndPP;
      HEAP32[(($1404)>>2)]=$1403;
      var $1405=$2;
      var $1406=(($1405+136)|0);
      var $1407=HEAP32[(($1406)>>2)];
      var $1408=$2;
      var $1409=(($1408+4)|0);
      var $1410=HEAP32[(($1409)>>2)];
      var $1411=$2;
      var $1412=(($1411+316)|0);
      var $1413=HEAP32[(($1412)>>2)];
      var $1414=(($1413)|0);
      var $1415=HEAP32[(($1414)>>2)];
      var $1416=$2;
      var $1417=(($1416+316)|0);
      var $1418=HEAP32[(($1417)>>2)];
      var $1419=(($1418+20)|0);
      var $1420=HEAP32[(($1419)>>2)];
      var $1421=$2;
      var $1422=(($1421+316)|0);
      var $1423=HEAP32[(($1422)>>2)];
      var $1424=(($1423+16)|0);
      var $1425=HEAP32[(($1424)>>2)];
      var $1426=$2;
      var $1427=(($1426+316)|0);
      var $1428=HEAP32[(($1427)>>2)];
      var $1429=(($1428+24)|0);
      var $1430=HEAP32[(($1429)>>2)];
      var $1431=$2;
      var $1432=(($1431+316)|0);
      var $1433=HEAP32[(($1432)>>2)];
      var $1434=(($1433+28)|0);
      var $1435=HEAP32[(($1434)>>2)];
      FUNCTION_TABLE[$1407]($1410, $1415, 0, 0, 0, $1420, $1425, $1430, $1435);
      $handleDefault=0;
      __label__ = 224; break;
    case 224: // $1436
      __label__ = 225; break;
    case 225: // $1437
      __label__ = 226; break;
    case 226: // $1438
      __label__ = 444; break;
    case 227: // $1439
      var $1440=$3;
      var $1441=(($1440+48)|0);
      var $1442=HEAP32[(($1441)>>2)];
      var $1443=$3;
      var $1444=$4;
      var $1445=HEAP32[(($7)>>2)];
      var $1446=FUNCTION_TABLE[$1442]($1443, $1444, $1445);
      var $1447=(($1446)|0)!=0;
      if ($1447) { __label__ = 228; break; } else { __label__ = 229; break; }
    case 228: // $1448
      var $1449=$2;
      var $1450=(($1449+316)|0);
      HEAP32[(($1450)>>2)]=0;
      __label__ = 444; break;
    case 229: // $1451
      var $1452=$dtd;
      var $1453=(($1452+128)|0);
      var $1454=HEAP8[($1453)];
      var $1455=(($1454 << 24) >> 24)!=0;
      if ($1455) { __label__ = 230; break; } else { __label__ = 242; break; }
    case 230: // $1456
      var $1457=$dtd;
      var $1458=(($1457+80)|0);
      var $1459=$3;
      var $1460=$4;
      var $1461=HEAP32[(($7)>>2)];
      var $1462=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1458, $1459, $1460, $1461);
      $name=$1462;
      var $1463=$name;
      var $1464=(($1463)|0)!=0;
      if ($1464) { __label__ = 232; break; } else { __label__ = 231; break; }
    case 231: // $1465
      $1=1;
      __label__ = 452; break;
    case 232: // $1466
      var $1467=$dtd;
      var $1468=(($1467)|0);
      var $1469=$name;
      var $1470=__ZL6lookupP10HASH_TABLEPKcj($1468, $1469, 36);
      var $1471=$1470;
      var $1472=$2;
      var $1473=(($1472+316)|0);
      HEAP32[(($1473)>>2)]=$1471;
      var $1474=$2;
      var $1475=(($1474+316)|0);
      var $1476=HEAP32[(($1475)>>2)];
      var $1477=(($1476)|0)!=0;
      if ($1477) { __label__ = 234; break; } else { __label__ = 233; break; }
    case 233: // $1478
      $1=1;
      __label__ = 452; break;
    case 234: // $1479
      var $1480=$2;
      var $1481=(($1480+316)|0);
      var $1482=HEAP32[(($1481)>>2)];
      var $1483=(($1482)|0);
      var $1484=HEAP32[(($1483)>>2)];
      var $1485=$name;
      var $1486=(($1484)|0)!=(($1485)|0);
      if ($1486) { __label__ = 235; break; } else { __label__ = 236; break; }
    case 235: // $1487
      var $1488=$dtd;
      var $1489=(($1488+80)|0);
      var $1490=(($1489+16)|0);
      var $1491=HEAP32[(($1490)>>2)];
      var $1492=$dtd;
      var $1493=(($1492+80)|0);
      var $1494=(($1493+12)|0);
      HEAP32[(($1494)>>2)]=$1491;
      var $1495=$2;
      var $1496=(($1495+316)|0);
      HEAP32[(($1496)>>2)]=0;
      __label__ = 241; break;
    case 236: // $1497
      var $1498=$dtd;
      var $1499=(($1498+80)|0);
      var $1500=(($1499+12)|0);
      var $1501=HEAP32[(($1500)>>2)];
      var $1502=$dtd;
      var $1503=(($1502+80)|0);
      var $1504=(($1503+16)|0);
      HEAP32[(($1504)>>2)]=$1501;
      var $1505=$2;
      var $1506=(($1505+316)|0);
      var $1507=HEAP32[(($1506)>>2)];
      var $1508=(($1507+24)|0);
      HEAP32[(($1508)>>2)]=0;
      var $1509=$2;
      var $1510=(($1509+316)|0);
      var $1511=HEAP32[(($1510)>>2)];
      var $1512=(($1511+33)|0);
      HEAP8[($1512)]=0;
      var $1513=$2;
      var $1514=(($1513+476)|0);
      var $1515=HEAP32[(($1514)>>2)];
      var $1516=(($1515)|0)!=0;
      if ($1516) { var $1523 = 1;__label__ = 238; break; } else { __label__ = 237; break; }
    case 237: // $1517
      var $1518=$2;
      var $1519=(($1518+300)|0);
      var $1520=HEAP32[(($1519)>>2)];
      var $1521=(($1520)|0)!=0;
      var $1523 = $1521;__label__ = 238; break;
    case 238: // $1522
      var $1523;
      var $1524=$1523 ^ 1;
      var $1525=(($1524)&1);
      var $1526=$2;
      var $1527=(($1526+316)|0);
      var $1528=HEAP32[(($1527)>>2)];
      var $1529=(($1528+34)|0);
      HEAP8[($1529)]=$1525;
      var $1530=$2;
      var $1531=(($1530+136)|0);
      var $1532=HEAP32[(($1531)>>2)];
      var $1533=(($1532)|0)!=0;
      if ($1533) { __label__ = 239; break; } else { __label__ = 240; break; }
    case 239: // $1534
      $handleDefault=0;
      __label__ = 240; break;
    case 240: // $1535
      __label__ = 241; break;
    case 241: // $1536
      __label__ = 243; break;
    case 242: // $1537
      var $1538=$dtd;
      var $1539=(($1538+80)|0);
      var $1540=(($1539+16)|0);
      var $1541=HEAP32[(($1540)>>2)];
      var $1542=$dtd;
      var $1543=(($1542+80)|0);
      var $1544=(($1543+12)|0);
      HEAP32[(($1544)>>2)]=$1541;
      var $1545=$2;
      var $1546=(($1545+316)|0);
      HEAP32[(($1546)>>2)]=0;
      __label__ = 243; break;
    case 243: // $1547
      __label__ = 444; break;
    case 244: // $1548
      var $1549=$dtd;
      var $1550=(($1549+128)|0);
      var $1551=HEAP8[($1550)];
      var $1552=(($1551 << 24) >> 24)!=0;
      if ($1552) { __label__ = 245; break; } else { __label__ = 257; break; }
    case 245: // $1553
      var $1554=$dtd;
      var $1555=(($1554+80)|0);
      var $1556=$3;
      var $1557=$4;
      var $1558=HEAP32[(($7)>>2)];
      var $1559=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1555, $1556, $1557, $1558);
      $name6=$1559;
      var $1560=$name6;
      var $1561=(($1560)|0)!=0;
      if ($1561) { __label__ = 247; break; } else { __label__ = 246; break; }
    case 246: // $1562
      $1=1;
      __label__ = 452; break;
    case 247: // $1563
      var $1564=$dtd;
      var $1565=(($1564+132)|0);
      var $1566=$name6;
      var $1567=__ZL6lookupP10HASH_TABLEPKcj($1565, $1566, 36);
      var $1568=$1567;
      var $1569=$2;
      var $1570=(($1569+316)|0);
      HEAP32[(($1570)>>2)]=$1568;
      var $1571=$2;
      var $1572=(($1571+316)|0);
      var $1573=HEAP32[(($1572)>>2)];
      var $1574=(($1573)|0)!=0;
      if ($1574) { __label__ = 249; break; } else { __label__ = 248; break; }
    case 248: // $1575
      $1=1;
      __label__ = 452; break;
    case 249: // $1576
      var $1577=$2;
      var $1578=(($1577+316)|0);
      var $1579=HEAP32[(($1578)>>2)];
      var $1580=(($1579)|0);
      var $1581=HEAP32[(($1580)>>2)];
      var $1582=$name6;
      var $1583=(($1581)|0)!=(($1582)|0);
      if ($1583) { __label__ = 250; break; } else { __label__ = 251; break; }
    case 250: // $1584
      var $1585=$dtd;
      var $1586=(($1585+80)|0);
      var $1587=(($1586+16)|0);
      var $1588=HEAP32[(($1587)>>2)];
      var $1589=$dtd;
      var $1590=(($1589+80)|0);
      var $1591=(($1590+12)|0);
      HEAP32[(($1591)>>2)]=$1588;
      var $1592=$2;
      var $1593=(($1592+316)|0);
      HEAP32[(($1593)>>2)]=0;
      __label__ = 256; break;
    case 251: // $1594
      var $1595=$dtd;
      var $1596=(($1595+80)|0);
      var $1597=(($1596+12)|0);
      var $1598=HEAP32[(($1597)>>2)];
      var $1599=$dtd;
      var $1600=(($1599+80)|0);
      var $1601=(($1600+16)|0);
      HEAP32[(($1601)>>2)]=$1598;
      var $1602=$2;
      var $1603=(($1602+316)|0);
      var $1604=HEAP32[(($1603)>>2)];
      var $1605=(($1604+24)|0);
      HEAP32[(($1605)>>2)]=0;
      var $1606=$2;
      var $1607=(($1606+316)|0);
      var $1608=HEAP32[(($1607)>>2)];
      var $1609=(($1608+33)|0);
      HEAP8[($1609)]=1;
      var $1610=$2;
      var $1611=(($1610+476)|0);
      var $1612=HEAP32[(($1611)>>2)];
      var $1613=(($1612)|0)!=0;
      if ($1613) { var $1620 = 1;__label__ = 253; break; } else { __label__ = 252; break; }
    case 252: // $1614
      var $1615=$2;
      var $1616=(($1615+300)|0);
      var $1617=HEAP32[(($1616)>>2)];
      var $1618=(($1617)|0)!=0;
      var $1620 = $1618;__label__ = 253; break;
    case 253: // $1619
      var $1620;
      var $1621=$1620 ^ 1;
      var $1622=(($1621)&1);
      var $1623=$2;
      var $1624=(($1623+316)|0);
      var $1625=HEAP32[(($1624)>>2)];
      var $1626=(($1625+34)|0);
      HEAP8[($1626)]=$1622;
      var $1627=$2;
      var $1628=(($1627+136)|0);
      var $1629=HEAP32[(($1628)>>2)];
      var $1630=(($1629)|0)!=0;
      if ($1630) { __label__ = 254; break; } else { __label__ = 255; break; }
    case 254: // $1631
      $handleDefault=0;
      __label__ = 255; break;
    case 255: // $1632
      __label__ = 256; break;
    case 256: // $1633
      __label__ = 258; break;
    case 257: // $1634
      var $1635=$dtd;
      var $1636=(($1635+80)|0);
      var $1637=(($1636+16)|0);
      var $1638=HEAP32[(($1637)>>2)];
      var $1639=$dtd;
      var $1640=(($1639+80)|0);
      var $1641=(($1640+12)|0);
      HEAP32[(($1641)>>2)]=$1638;
      var $1642=$2;
      var $1643=(($1642+316)|0);
      HEAP32[(($1643)>>2)]=0;
      __label__ = 258; break;
    case 258: // $1644
      __label__ = 444; break;
    case 259: // $1645
      var $1646=$2;
      var $1647=(($1646+340)|0);
      HEAP32[(($1647)>>2)]=0;
      var $1648=$2;
      var $1649=(($1648+336)|0);
      HEAP32[(($1649)>>2)]=0;
      var $1650=$2;
      var $1651=(($1650+96)|0);
      var $1652=HEAP32[(($1651)>>2)];
      var $1653=(($1652)|0)!=0;
      if ($1653) { __label__ = 260; break; } else { __label__ = 263; break; }
    case 260: // $1654
      var $1655=$2;
      var $1656=(($1655+416)|0);
      var $1657=$3;
      var $1658=$4;
      var $1659=HEAP32[(($7)>>2)];
      var $1660=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1656, $1657, $1658, $1659);
      var $1661=$2;
      var $1662=(($1661+336)|0);
      HEAP32[(($1662)>>2)]=$1660;
      var $1663=$2;
      var $1664=(($1663+336)|0);
      var $1665=HEAP32[(($1664)>>2)];
      var $1666=(($1665)|0)!=0;
      if ($1666) { __label__ = 262; break; } else { __label__ = 261; break; }
    case 261: // $1667
      $1=1;
      __label__ = 452; break;
    case 262: // $1668
      var $1669=$2;
      var $1670=(($1669+416)|0);
      var $1671=(($1670+12)|0);
      var $1672=HEAP32[(($1671)>>2)];
      var $1673=$2;
      var $1674=(($1673+416)|0);
      var $1675=(($1674+16)|0);
      HEAP32[(($1675)>>2)]=$1672;
      $handleDefault=0;
      __label__ = 263; break;
    case 263: // $1676
      __label__ = 444; break;
    case 264: // $1677
      var $1678=$3;
      var $1679=(($1678+56)|0);
      var $1680=HEAP32[(($1679)>>2)];
      var $1681=$3;
      var $1682=$4;
      var $1683=HEAP32[(($7)>>2)];
      var $1684=$eventPP;
      var $1685=FUNCTION_TABLE[$1680]($1681, $1682, $1683, $1684);
      var $1686=(($1685)|0)!=0;
      if ($1686) { __label__ = 266; break; } else { __label__ = 265; break; }
    case 265: // $1687
      $1=32;
      __label__ = 452; break;
    case 266: // $1688
      var $1689=$2;
      var $1690=(($1689+336)|0);
      var $1691=HEAP32[(($1690)>>2)];
      var $1692=(($1691)|0)!=0;
      if ($1692) { __label__ = 267; break; } else { __label__ = 270; break; }
    case 267: // $1693
      var $1694=$2;
      var $1695=(($1694+416)|0);
      var $1696=$3;
      var $1697=$4;
      var $1698=$3;
      var $1699=(($1698+68)|0);
      var $1700=HEAP32[(($1699)>>2)];
      var $1701=(($1697+$1700)|0);
      var $1702=HEAP32[(($7)>>2)];
      var $1703=$3;
      var $1704=(($1703+68)|0);
      var $1705=HEAP32[(($1704)>>2)];
      var $1706=(((-$1705))|0);
      var $1707=(($1702+$1706)|0);
      var $1708=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1695, $1696, $1701, $1707);
      $tem7=$1708;
      var $1709=$tem7;
      var $1710=(($1709)|0)!=0;
      if ($1710) { __label__ = 269; break; } else { __label__ = 268; break; }
    case 268: // $1711
      $1=1;
      __label__ = 452; break;
    case 269: // $1712
      var $1713=$tem7;
      __ZL17normalizePublicIdPc($1713);
      var $1714=$tem7;
      var $1715=$2;
      var $1716=(($1715+340)|0);
      HEAP32[(($1716)>>2)]=$1714;
      var $1717=$2;
      var $1718=(($1717+416)|0);
      var $1719=(($1718+12)|0);
      var $1720=HEAP32[(($1719)>>2)];
      var $1721=$2;
      var $1722=(($1721+416)|0);
      var $1723=(($1722+16)|0);
      HEAP32[(($1723)>>2)]=$1720;
      $handleDefault=0;
      __label__ = 270; break;
    case 270: // $1724
      __label__ = 444; break;
    case 271: // $1725
      var $1726=$2;
      var $1727=(($1726+336)|0);
      var $1728=HEAP32[(($1727)>>2)];
      var $1729=(($1728)|0)!=0;
      if ($1729) { __label__ = 272; break; } else { __label__ = 276; break; }
    case 272: // $1730
      var $1731=$2;
      var $1732=(($1731+96)|0);
      var $1733=HEAP32[(($1732)>>2)];
      var $1734=(($1733)|0)!=0;
      if ($1734) { __label__ = 273; break; } else { __label__ = 276; break; }
    case 273: // $1735
      var $1736=$2;
      var $1737=(($1736+416)|0);
      var $1738=$3;
      var $1739=$4;
      var $1740=$3;
      var $1741=(($1740+68)|0);
      var $1742=HEAP32[(($1741)>>2)];
      var $1743=(($1739+$1742)|0);
      var $1744=HEAP32[(($7)>>2)];
      var $1745=$3;
      var $1746=(($1745+68)|0);
      var $1747=HEAP32[(($1746)>>2)];
      var $1748=(((-$1747))|0);
      var $1749=(($1744+$1748)|0);
      var $1750=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($1737, $1738, $1743, $1749);
      $systemId=$1750;
      var $1751=$systemId;
      var $1752=(($1751)|0)!=0;
      if ($1752) { __label__ = 275; break; } else { __label__ = 274; break; }
    case 274: // $1753
      $1=1;
      __label__ = 452; break;
    case 275: // $1754
      var $1755=$4;
      var $1756=$eventEndPP;
      HEAP32[(($1756)>>2)]=$1755;
      var $1757=$2;
      var $1758=(($1757+96)|0);
      var $1759=HEAP32[(($1758)>>2)];
      var $1760=$2;
      var $1761=(($1760+4)|0);
      var $1762=HEAP32[(($1761)>>2)];
      var $1763=$2;
      var $1764=(($1763+336)|0);
      var $1765=HEAP32[(($1764)>>2)];
      var $1766=$2;
      var $1767=(($1766+360)|0);
      var $1768=HEAP32[(($1767)>>2)];
      var $1769=$systemId;
      var $1770=$2;
      var $1771=(($1770+340)|0);
      var $1772=HEAP32[(($1771)>>2)];
      FUNCTION_TABLE[$1759]($1762, $1765, $1768, $1769, $1772);
      $handleDefault=0;
      __label__ = 276; break;
    case 276: // $1773
      var $1774=$2;
      var $1775=(($1774+416)|0);
      __ZL9poolClearP11STRING_POOL($1775);
      __label__ = 444; break;
    case 277: // $1776
      var $1777=$2;
      var $1778=(($1777+340)|0);
      var $1779=HEAP32[(($1778)>>2)];
      var $1780=(($1779)|0)!=0;
      if ($1780) { __label__ = 278; break; } else { __label__ = 280; break; }
    case 278: // $1781
      var $1782=$2;
      var $1783=(($1782+96)|0);
      var $1784=HEAP32[(($1783)>>2)];
      var $1785=(($1784)|0)!=0;
      if ($1785) { __label__ = 279; break; } else { __label__ = 280; break; }
    case 279: // $1786
      var $1787=$4;
      var $1788=$eventEndPP;
      HEAP32[(($1788)>>2)]=$1787;
      var $1789=$2;
      var $1790=(($1789+96)|0);
      var $1791=HEAP32[(($1790)>>2)];
      var $1792=$2;
      var $1793=(($1792+4)|0);
      var $1794=HEAP32[(($1793)>>2)];
      var $1795=$2;
      var $1796=(($1795+336)|0);
      var $1797=HEAP32[(($1796)>>2)];
      var $1798=$2;
      var $1799=(($1798+360)|0);
      var $1800=HEAP32[(($1799)>>2)];
      var $1801=$2;
      var $1802=(($1801+340)|0);
      var $1803=HEAP32[(($1802)>>2)];
      FUNCTION_TABLE[$1791]($1794, $1797, $1800, 0, $1803);
      $handleDefault=0;
      __label__ = 280; break;
    case 280: // $1804
      var $1805=$2;
      var $1806=(($1805+416)|0);
      __ZL9poolClearP11STRING_POOL($1806);
      __label__ = 444; break;
    case 281: // $1807
      var $1808=$6;
      if ($1808 == 28) {
        __label__ = 282; break;
      }
      else if ($1808 == 12) {
        __label__ = 283; break;
      }
      else {
      __label__ = 284; break;
      }
      
    case 282: // $1809
      $1=10;
      __label__ = 452; break;
    case 283: // $1810
      $1=17;
      __label__ = 452; break;
    case 284: // $1811
      $1=2;
      __label__ = 452; break;
    case 285: // $1812
      var $1813=$2;
      var $1814=(($1813+80)|0);
      var $1815=HEAP32[(($1814)>>2)];
      var $1816=(($1815)|0)!=0;
      if ($1816) { __label__ = 286; break; } else { __label__ = 287; break; }
    case 286: // $1817
      var $1818=$2;
      var $1819=$3;
      var $1820=$4;
      var $1821=HEAP32[(($7)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($1818, $1819, $1820, $1821);
      __label__ = 287; break;
    case 287: // $1822
      $handleDefault=0;
      var $1823=$2;
      var $1824=$3;
      var $1825=$5;
      var $1826=$8;
      var $1827=$9;
      var $1828=__ZL15doIgnoreSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h($1823, $1824, $7, $1825, $1826, $1827);
      $result8=$1828;
      var $1829=$result8;
      var $1830=(($1829)|0)!=0;
      if ($1830) { __label__ = 288; break; } else { __label__ = 289; break; }
    case 288: // $1831
      var $1832=$result8;
      $1=$1832;
      __label__ = 452; break;
    case 289: // $1833
      var $1834=HEAP32[(($7)>>2)];
      var $1835=(($1834)|0)!=0;
      if ($1835) { __label__ = 291; break; } else { __label__ = 290; break; }
    case 290: // $1836
      var $1837=$2;
      var $1838=(($1837+280)|0);
      HEAP32[(($1838)>>2)]=1508;
      var $1839=$result8;
      $1=$1839;
      __label__ = 452; break;
    case 291: // $1840
      __label__ = 292; break;
    case 292: // $1841
      __label__ = 444; break;
    case 293: // $1842
      var $1843=$2;
      var $1844=(($1843+256)|0);
      var $1845=(($1844+4)|0);
      var $1846=HEAPU32[(($1845)>>2)];
      var $1847=$2;
      var $1848=(($1847+468)|0);
      var $1849=HEAPU32[(($1848)>>2)];
      var $1850=(($1846)>>>0) >= (($1849)>>>0);
      if ($1850) { __label__ = 294; break; } else { __label__ = 306; break; }
    case 294: // $1851
      var $1852=$2;
      var $1853=(($1852+468)|0);
      var $1854=HEAP32[(($1853)>>2)];
      var $1855=(($1854)|0)!=0;
      if ($1855) { __label__ = 295; break; } else { __label__ = 302; break; }
    case 295: // $1856
      var $1857=$2;
      var $1858=(($1857+12)|0);
      var $1859=(($1858+4)|0);
      var $1860=HEAP32[(($1859)>>2)];
      var $1861=$2;
      var $1862=(($1861+464)|0);
      var $1863=HEAP32[(($1862)>>2)];
      var $1864=$2;
      var $1865=(($1864+468)|0);
      var $1866=HEAP32[(($1865)>>2)];
      var $1867=((($1866<<1))|0);
      HEAP32[(($1865)>>2)]=$1867;
      var $1868=FUNCTION_TABLE[$1860]($1863, $1867);
      $temp=$1868;
      var $1869=$temp;
      var $1870=(($1869)|0)==0;
      if ($1870) { __label__ = 296; break; } else { __label__ = 297; break; }
    case 296: // $1871
      $1=1;
      __label__ = 452; break;
    case 297: // $1872
      var $1873=$temp;
      var $1874=$2;
      var $1875=(($1874+464)|0);
      HEAP32[(($1875)>>2)]=$1873;
      var $1876=$dtd;
      var $1877=(($1876+184)|0);
      var $1878=HEAP32[(($1877)>>2)];
      var $1879=(($1878)|0)!=0;
      if ($1879) { __label__ = 298; break; } else { __label__ = 301; break; }
    case 298: // $1880
      var $1881=$2;
      var $1882=(($1881+12)|0);
      var $1883=(($1882+4)|0);
      var $1884=HEAP32[(($1883)>>2)];
      var $1885=$dtd;
      var $1886=(($1885+184)|0);
      var $1887=HEAP32[(($1886)>>2)];
      var $1888=$1887;
      var $1889=$2;
      var $1890=(($1889+468)|0);
      var $1891=HEAP32[(($1890)>>2)];
      var $1892=((($1891<<2))|0);
      var $1893=FUNCTION_TABLE[$1884]($1888, $1892);
      var $1894=$1893;
      $temp9=$1894;
      var $1895=$temp9;
      var $1896=(($1895)|0)==0;
      if ($1896) { __label__ = 299; break; } else { __label__ = 300; break; }
    case 299: // $1897
      $1=1;
      __label__ = 452; break;
    case 300: // $1898
      var $1899=$temp9;
      var $1900=$dtd;
      var $1901=(($1900+184)|0);
      HEAP32[(($1901)>>2)]=$1899;
      __label__ = 301; break;
    case 301: // $1902
      __label__ = 305; break;
    case 302: // $1903
      var $1904=$2;
      var $1905=(($1904+12)|0);
      var $1906=(($1905)|0);
      var $1907=HEAP32[(($1906)>>2)];
      var $1908=$2;
      var $1909=(($1908+468)|0);
      HEAP32[(($1909)>>2)]=32;
      var $1910=FUNCTION_TABLE[$1907](32);
      var $1911=$2;
      var $1912=(($1911+464)|0);
      HEAP32[(($1912)>>2)]=$1910;
      var $1913=$2;
      var $1914=(($1913+464)|0);
      var $1915=HEAP32[(($1914)>>2)];
      var $1916=(($1915)|0)!=0;
      if ($1916) { __label__ = 304; break; } else { __label__ = 303; break; }
    case 303: // $1917
      $1=1;
      __label__ = 452; break;
    case 304: // $1918
      __label__ = 305; break;
    case 305: // $1919
      __label__ = 306; break;
    case 306: // $1920
      var $1921=$2;
      var $1922=(($1921+256)|0);
      var $1923=(($1922+4)|0);
      var $1924=HEAP32[(($1923)>>2)];
      var $1925=$2;
      var $1926=(($1925+464)|0);
      var $1927=HEAP32[(($1926)>>2)];
      var $1928=(($1927+$1924)|0);
      HEAP8[($1928)]=0;
      var $1929=$dtd;
      var $1930=(($1929+160)|0);
      var $1931=HEAP8[($1930)];
      var $1932=(($1931 << 24) >> 24)!=0;
      if ($1932) { __label__ = 307; break; } else { __label__ = 312; break; }
    case 307: // $1933
      var $1934=$2;
      var $1935=__ZL16nextScaffoldPartP16XML_ParserStruct($1934);
      $myindex=$1935;
      var $1936=$myindex;
      var $1937=(($1936)|0) < 0;
      if ($1937) { __label__ = 308; break; } else { __label__ = 309; break; }
    case 308: // $1938
      $1=1;
      __label__ = 452; break;
    case 309: // $1939
      var $1940=$myindex;
      var $1941=$dtd;
      var $1942=(($1941+180)|0);
      var $1943=HEAP32[(($1942)>>2)];
      var $1944=$dtd;
      var $1945=(($1944+184)|0);
      var $1946=HEAP32[(($1945)>>2)];
      var $1947=(($1946+($1943<<2))|0);
      HEAP32[(($1947)>>2)]=$1940;
      var $1948=$dtd;
      var $1949=(($1948+180)|0);
      var $1950=HEAP32[(($1949)>>2)];
      var $1951=(($1950+1)|0);
      HEAP32[(($1949)>>2)]=$1951;
      var $1952=$myindex;
      var $1953=$dtd;
      var $1954=(($1953+164)|0);
      var $1955=HEAP32[(($1954)>>2)];
      var $1956=(($1955+$1952*28)|0);
      var $1957=(($1956)|0);
      HEAP32[(($1957)>>2)]=6;
      var $1958=$2;
      var $1959=(($1958+128)|0);
      var $1960=HEAP32[(($1959)>>2)];
      var $1961=(($1960)|0)!=0;
      if ($1961) { __label__ = 310; break; } else { __label__ = 311; break; }
    case 310: // $1962
      $handleDefault=0;
      __label__ = 311; break;
    case 311: // $1963
      __label__ = 312; break;
    case 312: // $1964
      __label__ = 444; break;
    case 313: // $1965
      var $1966=$2;
      var $1967=(($1966+256)|0);
      var $1968=(($1967+4)|0);
      var $1969=HEAP32[(($1968)>>2)];
      var $1970=$2;
      var $1971=(($1970+464)|0);
      var $1972=HEAP32[(($1971)>>2)];
      var $1973=(($1972+$1969)|0);
      var $1974=HEAP8[($1973)];
      var $1975=(($1974 << 24) >> 24);
      var $1976=(($1975)|0)==124;
      if ($1976) { __label__ = 314; break; } else { __label__ = 315; break; }
    case 314: // $1977
      $1=2;
      __label__ = 452; break;
    case 315: // $1978
      var $1979=$2;
      var $1980=(($1979+256)|0);
      var $1981=(($1980+4)|0);
      var $1982=HEAP32[(($1981)>>2)];
      var $1983=$2;
      var $1984=(($1983+464)|0);
      var $1985=HEAP32[(($1984)>>2)];
      var $1986=(($1985+$1982)|0);
      HEAP8[($1986)]=44;
      var $1987=$dtd;
      var $1988=(($1987+160)|0);
      var $1989=HEAP8[($1988)];
      var $1990=(($1989 << 24) >> 24)!=0;
      if ($1990) { __label__ = 316; break; } else { __label__ = 318; break; }
    case 316: // $1991
      var $1992=$2;
      var $1993=(($1992+128)|0);
      var $1994=HEAP32[(($1993)>>2)];
      var $1995=(($1994)|0)!=0;
      if ($1995) { __label__ = 317; break; } else { __label__ = 318; break; }
    case 317: // $1996
      $handleDefault=0;
      __label__ = 318; break;
    case 318: // $1997
      __label__ = 444; break;
    case 319: // $1998
      var $1999=$2;
      var $2000=(($1999+256)|0);
      var $2001=(($2000+4)|0);
      var $2002=HEAP32[(($2001)>>2)];
      var $2003=$2;
      var $2004=(($2003+464)|0);
      var $2005=HEAP32[(($2004)>>2)];
      var $2006=(($2005+$2002)|0);
      var $2007=HEAP8[($2006)];
      var $2008=(($2007 << 24) >> 24);
      var $2009=(($2008)|0)==44;
      if ($2009) { __label__ = 320; break; } else { __label__ = 321; break; }
    case 320: // $2010
      $1=2;
      __label__ = 452; break;
    case 321: // $2011
      var $2012=$dtd;
      var $2013=(($2012+160)|0);
      var $2014=HEAP8[($2013)];
      var $2015=(($2014 << 24) >> 24)!=0;
      if ($2015) { __label__ = 322; break; } else { __label__ = 327; break; }
    case 322: // $2016
      var $2017=$2;
      var $2018=(($2017+256)|0);
      var $2019=(($2018+4)|0);
      var $2020=HEAP32[(($2019)>>2)];
      var $2021=$2;
      var $2022=(($2021+464)|0);
      var $2023=HEAP32[(($2022)>>2)];
      var $2024=(($2023+$2020)|0);
      var $2025=HEAP8[($2024)];
      var $2026=(($2025 << 24) >> 24)!=0;
      if ($2026) { __label__ = 327; break; } else { __label__ = 323; break; }
    case 323: // $2027
      var $2028=$dtd;
      var $2029=(($2028+180)|0);
      var $2030=HEAP32[(($2029)>>2)];
      var $2031=(($2030-1)|0);
      var $2032=$dtd;
      var $2033=(($2032+184)|0);
      var $2034=HEAP32[(($2033)>>2)];
      var $2035=(($2034+($2031<<2))|0);
      var $2036=HEAP32[(($2035)>>2)];
      var $2037=$dtd;
      var $2038=(($2037+164)|0);
      var $2039=HEAP32[(($2038)>>2)];
      var $2040=(($2039+$2036*28)|0);
      var $2041=(($2040)|0);
      var $2042=HEAP32[(($2041)>>2)];
      var $2043=(($2042)|0)!=3;
      if ($2043) { __label__ = 324; break; } else { __label__ = 327; break; }
    case 324: // $2044
      var $2045=$dtd;
      var $2046=(($2045+180)|0);
      var $2047=HEAP32[(($2046)>>2)];
      var $2048=(($2047-1)|0);
      var $2049=$dtd;
      var $2050=(($2049+184)|0);
      var $2051=HEAP32[(($2050)>>2)];
      var $2052=(($2051+($2048<<2))|0);
      var $2053=HEAP32[(($2052)>>2)];
      var $2054=$dtd;
      var $2055=(($2054+164)|0);
      var $2056=HEAP32[(($2055)>>2)];
      var $2057=(($2056+$2053*28)|0);
      var $2058=(($2057)|0);
      HEAP32[(($2058)>>2)]=5;
      var $2059=$2;
      var $2060=(($2059+128)|0);
      var $2061=HEAP32[(($2060)>>2)];
      var $2062=(($2061)|0)!=0;
      if ($2062) { __label__ = 325; break; } else { __label__ = 326; break; }
    case 325: // $2063
      $handleDefault=0;
      __label__ = 326; break;
    case 326: // $2064
      __label__ = 327; break;
    case 327: // $2065
      var $2066=$2;
      var $2067=(($2066+256)|0);
      var $2068=(($2067+4)|0);
      var $2069=HEAP32[(($2068)>>2)];
      var $2070=$2;
      var $2071=(($2070+464)|0);
      var $2072=HEAP32[(($2071)>>2)];
      var $2073=(($2072+$2069)|0);
      HEAP8[($2073)]=124;
      __label__ = 444; break;
    case 328: // $2074
      var $2075=$dtd;
      var $2076=(($2075+129)|0);
      HEAP8[($2076)]=1;
      var $2077=$2;
      var $2078=(($2077+492)|0);
      var $2079=HEAP32[(($2078)>>2)];
      var $2080=(($2079)|0)!=0;
      if ($2080) { __label__ = 330; break; } else { __label__ = 329; break; }
    case 329: // $2081
      var $2082=$dtd;
      var $2083=(($2082+130)|0);
      var $2084=HEAP8[($2083)];
      var $2085=$dtd;
      var $2086=(($2085+128)|0);
      HEAP8[($2086)]=$2084;
      __label__ = 362; break;
    case 330: // $2087
      var $2088=$dtd;
      var $2089=(($2088+80)|0);
      var $2090=$3;
      var $2091=$4;
      var $2092=$3;
      var $2093=(($2092+68)|0);
      var $2094=HEAP32[(($2093)>>2)];
      var $2095=(($2091+$2094)|0);
      var $2096=HEAP32[(($7)>>2)];
      var $2097=$3;
      var $2098=(($2097+68)|0);
      var $2099=HEAP32[(($2098)>>2)];
      var $2100=(((-$2099))|0);
      var $2101=(($2096+$2100)|0);
      var $2102=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($2089, $2090, $2095, $2101);
      $name10=$2102;
      var $2103=$name10;
      var $2104=(($2103)|0)!=0;
      if ($2104) { __label__ = 332; break; } else { __label__ = 331; break; }
    case 331: // $2105
      $1=1;
      __label__ = 452; break;
    case 332: // $2106
      var $2107=$dtd;
      var $2108=(($2107+132)|0);
      var $2109=$name10;
      var $2110=__ZL6lookupP10HASH_TABLEPKcj($2108, $2109, 0);
      var $2111=$2110;
      $entity11=$2111;
      var $2112=$dtd;
      var $2113=(($2112+80)|0);
      var $2114=(($2113+16)|0);
      var $2115=HEAP32[(($2114)>>2)];
      var $2116=$dtd;
      var $2117=(($2116+80)|0);
      var $2118=(($2117+12)|0);
      HEAP32[(($2118)>>2)]=$2115;
      var $2119=$2;
      var $2120=(($2119+256)|0);
      var $2121=(($2120+16)|0);
      var $2122=HEAP32[(($2121)>>2)];
      var $2123=(($2122)|0)!=0;
      if ($2123) { __label__ = 333; break; } else { __label__ = 342; break; }
    case 333: // $2124
      var $2125=$dtd;
      var $2126=(($2125+130)|0);
      var $2127=HEAP8[($2126)];
      var $2128=(($2127 << 24) >> 24)!=0;
      if ($2128) { __label__ = 334; break; } else { __label__ = 335; break; }
    case 334: // $2129
      var $2130=$2;
      var $2131=(($2130+300)|0);
      var $2132=HEAP32[(($2131)>>2)];
      var $2133=(($2132)|0)!=0;
      if ($2133) { __label__ = 342; break; } else { __label__ = 336; break; }
    case 335: // $2134
      var $2135=$dtd;
      var $2136=(($2135+129)|0);
      var $2137=HEAP8[($2136)];
      var $2138=(($2137 << 24) >> 24)!=0;
      if ($2138) { __label__ = 342; break; } else { __label__ = 336; break; }
    case 336: // $2139
      var $2140=$entity11;
      var $2141=(($2140)|0)!=0;
      if ($2141) { __label__ = 338; break; } else { __label__ = 337; break; }
    case 337: // $2142
      $1=11;
      __label__ = 452; break;
    case 338: // $2143
      var $2144=$entity11;
      var $2145=(($2144+34)|0);
      var $2146=HEAP8[($2145)];
      var $2147=(($2146 << 24) >> 24)!=0;
      if ($2147) { __label__ = 340; break; } else { __label__ = 339; break; }
    case 339: // $2148
      $1=24;
      __label__ = 452; break;
    case 340: // $2149
      __label__ = 341; break;
    case 341: // $2150
      __label__ = 348; break;
    case 342: // $2151
      var $2152=$entity11;
      var $2153=(($2152)|0)!=0;
      if ($2153) { __label__ = 347; break; } else { __label__ = 343; break; }
    case 343: // $2154
      var $2155=$dtd;
      var $2156=(($2155+130)|0);
      var $2157=HEAP8[($2156)];
      var $2158=$dtd;
      var $2159=(($2158+128)|0);
      HEAP8[($2159)]=$2157;
      var $2160=$role;
      var $2161=(($2160)|0)==60;
      if ($2161) { __label__ = 344; break; } else { __label__ = 346; break; }
    case 344: // $2162
      var $2163=$2;
      var $2164=(($2163+120)|0);
      var $2165=HEAP32[(($2164)>>2)];
      var $2166=(($2165)|0)!=0;
      if ($2166) { __label__ = 345; break; } else { __label__ = 346; break; }
    case 345: // $2167
      var $2168=$2;
      var $2169=(($2168+120)|0);
      var $2170=HEAP32[(($2169)>>2)];
      var $2171=$2;
      var $2172=(($2171+4)|0);
      var $2173=HEAP32[(($2172)>>2)];
      var $2174=$name10;
      FUNCTION_TABLE[$2170]($2173, $2174, 1);
      $handleDefault=0;
      __label__ = 346; break;
    case 346: // $2175
      __label__ = 444; break;
    case 347: // $2176
      __label__ = 348; break;
    case 348: // $2177
      var $2178=$entity11;
      var $2179=(($2178+32)|0);
      var $2180=HEAP8[($2179)];
      var $2181=(($2180 << 24) >> 24)!=0;
      if ($2181) { __label__ = 349; break; } else { __label__ = 350; break; }
    case 349: // $2182
      $1=12;
      __label__ = 452; break;
    case 350: // $2183
      var $2184=$entity11;
      var $2185=(($2184+4)|0);
      var $2186=HEAP32[(($2185)>>2)];
      var $2187=(($2186)|0)!=0;
      if ($2187) { __label__ = 351; break; } else { __label__ = 354; break; }
    case 351: // $2188
      var $2189=$role;
      var $2190=(($2189)|0)==60;
      var $2191=$2190 ? 1 : 0;
      $betweenDecl=$2191;
      var $2192=$2;
      var $2193=$entity11;
      var $2194=$betweenDecl;
      var $2195=__ZL21processInternalEntityP16XML_ParserStructP6ENTITYh($2192, $2193, $2194);
      $result12=$2195;
      var $2196=$result12;
      var $2197=(($2196)|0)!=0;
      if ($2197) { __label__ = 352; break; } else { __label__ = 353; break; }
    case 352: // $2198
      var $2199=$result12;
      $1=$2199;
      __label__ = 452; break;
    case 353: // $2200
      $handleDefault=0;
      __label__ = 444; break;
    case 354: // $2201
      var $2202=$2;
      var $2203=(($2202+112)|0);
      var $2204=HEAP32[(($2203)>>2)];
      var $2205=(($2204)|0)!=0;
      if ($2205) { __label__ = 355; break; } else { __label__ = 360; break; }
    case 355: // $2206
      var $2207=$dtd;
      var $2208=(($2207+131)|0);
      HEAP8[($2208)]=0;
      var $2209=$entity11;
      var $2210=(($2209+32)|0);
      HEAP8[($2210)]=1;
      var $2211=$2;
      var $2212=(($2211+112)|0);
      var $2213=HEAP32[(($2212)>>2)];
      var $2214=$2;
      var $2215=(($2214+116)|0);
      var $2216=HEAP32[(($2215)>>2)];
      var $2217=$entity11;
      var $2218=(($2217+20)|0);
      var $2219=HEAP32[(($2218)>>2)];
      var $2220=$entity11;
      var $2221=(($2220+16)|0);
      var $2222=HEAP32[(($2221)>>2)];
      var $2223=$entity11;
      var $2224=(($2223+24)|0);
      var $2225=HEAP32[(($2224)>>2)];
      var $2226=FUNCTION_TABLE[$2213]($2216, 0, $2219, $2222, $2225);
      var $2227=(($2226)|0)!=0;
      if ($2227) { __label__ = 357; break; } else { __label__ = 356; break; }
    case 356: // $2228
      var $2229=$entity11;
      var $2230=(($2229+32)|0);
      HEAP8[($2230)]=0;
      $1=21;
      __label__ = 452; break;
    case 357: // $2231
      var $2232=$entity11;
      var $2233=(($2232+32)|0);
      HEAP8[($2233)]=0;
      $handleDefault=0;
      var $2234=$dtd;
      var $2235=(($2234+131)|0);
      var $2236=HEAP8[($2235)];
      var $2237=(($2236 << 24) >> 24)!=0;
      if ($2237) { __label__ = 359; break; } else { __label__ = 358; break; }
    case 358: // $2238
      var $2239=$dtd;
      var $2240=(($2239+130)|0);
      var $2241=HEAP8[($2240)];
      var $2242=$dtd;
      var $2243=(($2242+128)|0);
      HEAP8[($2243)]=$2241;
      __label__ = 444; break;
    case 359: // $2244
      __label__ = 361; break;
    case 360: // $2245
      var $2246=$dtd;
      var $2247=(($2246+130)|0);
      var $2248=HEAP8[($2247)];
      var $2249=$dtd;
      var $2250=(($2249+128)|0);
      HEAP8[($2250)]=$2248;
      __label__ = 444; break;
    case 361: // $2251
      __label__ = 362; break;
    case 362: // $2252
      var $2253=$dtd;
      var $2254=(($2253+130)|0);
      var $2255=HEAP8[($2254)];
      var $2256=(($2255 << 24) >> 24)!=0;
      if ($2256) { __label__ = 366; break; } else { __label__ = 363; break; }
    case 363: // $2257
      var $2258=$2;
      var $2259=(($2258+108)|0);
      var $2260=HEAP32[(($2259)>>2)];
      var $2261=(($2260)|0)!=0;
      if ($2261) { __label__ = 364; break; } else { __label__ = 366; break; }
    case 364: // $2262
      var $2263=$2;
      var $2264=(($2263+108)|0);
      var $2265=HEAP32[(($2264)>>2)];
      var $2266=$2;
      var $2267=(($2266+4)|0);
      var $2268=HEAP32[(($2267)>>2)];
      var $2269=FUNCTION_TABLE[$2265]($2268);
      var $2270=(($2269)|0)!=0;
      if ($2270) { __label__ = 366; break; } else { __label__ = 365; break; }
    case 365: // $2271
      $1=22;
      __label__ = 452; break;
    case 366: // $2272
      __label__ = 444; break;
    case 367: // $2273
      var $2274=$2;
      var $2275=(($2274+128)|0);
      var $2276=HEAP32[(($2275)>>2)];
      var $2277=(($2276)|0)!=0;
      if ($2277) { __label__ = 368; break; } else { __label__ = 371; break; }
    case 368: // $2278
      var $2279=$2;
      var $2280=$3;
      var $2281=$4;
      var $2282=HEAP32[(($7)>>2)];
      var $2283=__ZL14getElementTypeP16XML_ParserStructPK8encodingPKcS5_($2279, $2280, $2281, $2282);
      var $2284=$2;
      var $2285=(($2284+344)|0);
      HEAP32[(($2285)>>2)]=$2283;
      var $2286=$2;
      var $2287=(($2286+344)|0);
      var $2288=HEAP32[(($2287)>>2)];
      var $2289=(($2288)|0)!=0;
      if ($2289) { __label__ = 370; break; } else { __label__ = 369; break; }
    case 369: // $2290
      $1=1;
      __label__ = 452; break;
    case 370: // $2291
      var $2292=$dtd;
      var $2293=(($2292+180)|0);
      HEAP32[(($2293)>>2)]=0;
      var $2294=$dtd;
      var $2295=(($2294+176)|0);
      HEAP32[(($2295)>>2)]=0;
      var $2296=$dtd;
      var $2297=(($2296+160)|0);
      HEAP8[($2297)]=1;
      $handleDefault=0;
      __label__ = 371; break;
    case 371: // $2298
      __label__ = 444; break;
    case 372: // $2299
      var $2300=$dtd;
      var $2301=(($2300+160)|0);
      var $2302=HEAP8[($2301)];
      var $2303=(($2302 << 24) >> 24)!=0;
      if ($2303) { __label__ = 373; break; } else { __label__ = 378; break; }
    case 373: // $2304
      var $2305=$2;
      var $2306=(($2305+128)|0);
      var $2307=HEAP32[(($2306)>>2)];
      var $2308=(($2307)|0)!=0;
      if ($2308) { __label__ = 374; break; } else { __label__ = 377; break; }
    case 374: // $2309
      var $2310=$2;
      var $2311=(($2310+12)|0);
      var $2312=(($2311)|0);
      var $2313=HEAP32[(($2312)>>2)];
      var $2314=FUNCTION_TABLE[$2313](20);
      var $2315=$2314;
      $content=$2315;
      var $2316=$content;
      var $2317=(($2316)|0)!=0;
      if ($2317) { __label__ = 376; break; } else { __label__ = 375; break; }
    case 375: // $2318
      $1=1;
      __label__ = 452; break;
    case 376: // $2319
      var $2320=$content;
      var $2321=(($2320+4)|0);
      HEAP32[(($2321)>>2)]=0;
      var $2322=$content;
      var $2323=(($2322+8)|0);
      HEAP32[(($2323)>>2)]=0;
      var $2324=$content;
      var $2325=(($2324+12)|0);
      HEAP32[(($2325)>>2)]=0;
      var $2326=$content;
      var $2327=(($2326+16)|0);
      HEAP32[(($2327)>>2)]=0;
      var $2328=$role;
      var $2329=(($2328)|0)==41;
      var $2330=$2329 ? 2 : 1;
      var $2331=$content;
      var $2332=(($2331)|0);
      HEAP32[(($2332)>>2)]=$2330;
      var $2333=$4;
      var $2334=$eventEndPP;
      HEAP32[(($2334)>>2)]=$2333;
      var $2335=$2;
      var $2336=(($2335+128)|0);
      var $2337=HEAP32[(($2336)>>2)];
      var $2338=$2;
      var $2339=(($2338+4)|0);
      var $2340=HEAP32[(($2339)>>2)];
      var $2341=$2;
      var $2342=(($2341+344)|0);
      var $2343=HEAP32[(($2342)>>2)];
      var $2344=(($2343)|0);
      var $2345=HEAP32[(($2344)>>2)];
      var $2346=$content;
      FUNCTION_TABLE[$2337]($2340, $2345, $2346);
      $handleDefault=0;
      __label__ = 377; break;
    case 377: // $2347
      var $2348=$dtd;
      var $2349=(($2348+160)|0);
      HEAP8[($2349)]=0;
      __label__ = 378; break;
    case 378: // $2350
      __label__ = 444; break;
    case 379: // $2351
      var $2352=$dtd;
      var $2353=(($2352+160)|0);
      var $2354=HEAP8[($2353)];
      var $2355=(($2354 << 24) >> 24)!=0;
      if ($2355) { __label__ = 380; break; } else { __label__ = 383; break; }
    case 380: // $2356
      var $2357=$dtd;
      var $2358=(($2357+180)|0);
      var $2359=HEAP32[(($2358)>>2)];
      var $2360=(($2359-1)|0);
      var $2361=$dtd;
      var $2362=(($2361+184)|0);
      var $2363=HEAP32[(($2362)>>2)];
      var $2364=(($2363+($2360<<2))|0);
      var $2365=HEAP32[(($2364)>>2)];
      var $2366=$dtd;
      var $2367=(($2366+164)|0);
      var $2368=HEAP32[(($2367)>>2)];
      var $2369=(($2368+$2365*28)|0);
      var $2370=(($2369)|0);
      HEAP32[(($2370)>>2)]=3;
      var $2371=$2;
      var $2372=(($2371+128)|0);
      var $2373=HEAP32[(($2372)>>2)];
      var $2374=(($2373)|0)!=0;
      if ($2374) { __label__ = 381; break; } else { __label__ = 382; break; }
    case 381: // $2375
      $handleDefault=0;
      __label__ = 382; break;
    case 382: // $2376
      __label__ = 383; break;
    case 383: // $2377
      __label__ = 444; break;
    case 384: // $2378
      $quant=0;
      __label__ = 388; break;
    case 385: // $2379
      $quant=1;
      __label__ = 388; break;
    case 386: // $2380
      $quant=2;
      __label__ = 388; break;
    case 387: // $2381
      $quant=3;
      __label__ = 388; break;
    case 388: // $2382
      var $2383=$dtd;
      var $2384=(($2383+160)|0);
      var $2385=HEAP8[($2384)];
      var $2386=(($2385 << 24) >> 24)!=0;
      if ($2386) { __label__ = 389; break; } else { __label__ = 402; break; }
    case 389: // $2387
      var $2388=$quant;
      var $2389=(($2388)|0)==0;
      if ($2389) { __label__ = 390; break; } else { __label__ = 391; break; }
    case 390: // $2390
      var $2391=HEAP32[(($7)>>2)];
      var $2400 = $2391;__label__ = 392; break;
    case 391: // $2392
      var $2393=HEAP32[(($7)>>2)];
      var $2394=$3;
      var $2395=(($2394+68)|0);
      var $2396=HEAP32[(($2395)>>2)];
      var $2397=(((-$2396))|0);
      var $2398=(($2393+$2397)|0);
      var $2400 = $2398;__label__ = 392; break;
    case 392: // $2399
      var $2400;
      $nxt=$2400;
      var $2401=$2;
      var $2402=__ZL16nextScaffoldPartP16XML_ParserStruct($2401);
      $myindex14=$2402;
      var $2403=$myindex14;
      var $2404=(($2403)|0) < 0;
      if ($2404) { __label__ = 393; break; } else { __label__ = 394; break; }
    case 393: // $2405
      $1=1;
      __label__ = 452; break;
    case 394: // $2406
      var $2407=$myindex14;
      var $2408=$dtd;
      var $2409=(($2408+164)|0);
      var $2410=HEAP32[(($2409)>>2)];
      var $2411=(($2410+$2407*28)|0);
      var $2412=(($2411)|0);
      HEAP32[(($2412)>>2)]=4;
      var $2413=$quant;
      var $2414=$myindex14;
      var $2415=$dtd;
      var $2416=(($2415+164)|0);
      var $2417=HEAP32[(($2416)>>2)];
      var $2418=(($2417+$2414*28)|0);
      var $2419=(($2418+4)|0);
      HEAP32[(($2419)>>2)]=$2413;
      var $2420=$2;
      var $2421=$3;
      var $2422=$4;
      var $2423=$nxt;
      var $2424=__ZL14getElementTypeP16XML_ParserStructPK8encodingPKcS5_($2420, $2421, $2422, $2423);
      $el=$2424;
      var $2425=$el;
      var $2426=(($2425)|0)!=0;
      if ($2426) { __label__ = 396; break; } else { __label__ = 395; break; }
    case 395: // $2427
      $1=1;
      __label__ = 452; break;
    case 396: // $2428
      var $2429=$el;
      var $2430=(($2429)|0);
      var $2431=HEAP32[(($2430)>>2)];
      $name13=$2431;
      var $2432=$name13;
      var $2433=$myindex14;
      var $2434=$dtd;
      var $2435=(($2434+164)|0);
      var $2436=HEAP32[(($2435)>>2)];
      var $2437=(($2436+$2433*28)|0);
      var $2438=(($2437+8)|0);
      HEAP32[(($2438)>>2)]=$2432;
      $nameLen=0;
      __label__ = 397; break;
    case 397: // $2439
      var $2440=$nameLen;
      var $2441=(($2440+1)|0);
      $nameLen=$2441;
      var $2442=$name13;
      var $2443=(($2442+$2440)|0);
      var $2444=HEAP8[($2443)];
      var $2445=(($2444 << 24) >> 24)!=0;
      if ($2445) { __label__ = 398; break; } else { __label__ = 399; break; }
    case 398: // $2446
      __label__ = 397; break;
    case 399: // $2447
      var $2448=$nameLen;
      var $2449=$dtd;
      var $2450=(($2449+168)|0);
      var $2451=HEAP32[(($2450)>>2)];
      var $2452=(($2451+$2448)|0);
      HEAP32[(($2450)>>2)]=$2452;
      var $2453=$2;
      var $2454=(($2453+128)|0);
      var $2455=HEAP32[(($2454)>>2)];
      var $2456=(($2455)|0)!=0;
      if ($2456) { __label__ = 400; break; } else { __label__ = 401; break; }
    case 400: // $2457
      $handleDefault=0;
      __label__ = 401; break;
    case 401: // $2458
      __label__ = 402; break;
    case 402: // $2459
      __label__ = 444; break;
    case 403: // $2460
      $quant=0;
      __label__ = 407; break;
    case 404: // $2461
      $quant=1;
      __label__ = 407; break;
    case 405: // $2462
      $quant=2;
      __label__ = 407; break;
    case 406: // $2463
      $quant=3;
      __label__ = 407; break;
    case 407: // $2464
      var $2465=$dtd;
      var $2466=(($2465+160)|0);
      var $2467=HEAP8[($2466)];
      var $2468=(($2467 << 24) >> 24)!=0;
      if ($2468) { __label__ = 408; break; } else { __label__ = 417; break; }
    case 408: // $2469
      var $2470=$2;
      var $2471=(($2470+128)|0);
      var $2472=HEAP32[(($2471)>>2)];
      var $2473=(($2472)|0)!=0;
      if ($2473) { __label__ = 409; break; } else { __label__ = 410; break; }
    case 409: // $2474
      $handleDefault=0;
      __label__ = 410; break;
    case 410: // $2475
      var $2476=$dtd;
      var $2477=(($2476+180)|0);
      var $2478=HEAP32[(($2477)>>2)];
      var $2479=(($2478-1)|0);
      HEAP32[(($2477)>>2)]=$2479;
      var $2480=$quant;
      var $2481=$dtd;
      var $2482=(($2481+180)|0);
      var $2483=HEAP32[(($2482)>>2)];
      var $2484=$dtd;
      var $2485=(($2484+184)|0);
      var $2486=HEAP32[(($2485)>>2)];
      var $2487=(($2486+($2483<<2))|0);
      var $2488=HEAP32[(($2487)>>2)];
      var $2489=$dtd;
      var $2490=(($2489+164)|0);
      var $2491=HEAP32[(($2490)>>2)];
      var $2492=(($2491+$2488*28)|0);
      var $2493=(($2492+4)|0);
      HEAP32[(($2493)>>2)]=$2480;
      var $2494=$dtd;
      var $2495=(($2494+180)|0);
      var $2496=HEAP32[(($2495)>>2)];
      var $2497=(($2496)|0)==0;
      if ($2497) { __label__ = 411; break; } else { __label__ = 416; break; }
    case 411: // $2498
      var $2499=$handleDefault;
      var $2500=(($2499 << 24) >> 24)!=0;
      if ($2500) { __label__ = 415; break; } else { __label__ = 412; break; }
    case 412: // $2501
      var $2502=$2;
      var $2503=__ZL11build_modelP16XML_ParserStruct($2502);
      $model=$2503;
      var $2504=$model;
      var $2505=(($2504)|0)!=0;
      if ($2505) { __label__ = 414; break; } else { __label__ = 413; break; }
    case 413: // $2506
      $1=1;
      __label__ = 452; break;
    case 414: // $2507
      var $2508=$4;
      var $2509=$eventEndPP;
      HEAP32[(($2509)>>2)]=$2508;
      var $2510=$2;
      var $2511=(($2510+128)|0);
      var $2512=HEAP32[(($2511)>>2)];
      var $2513=$2;
      var $2514=(($2513+4)|0);
      var $2515=HEAP32[(($2514)>>2)];
      var $2516=$2;
      var $2517=(($2516+344)|0);
      var $2518=HEAP32[(($2517)>>2)];
      var $2519=(($2518)|0);
      var $2520=HEAP32[(($2519)>>2)];
      var $2521=$model;
      FUNCTION_TABLE[$2512]($2515, $2520, $2521);
      __label__ = 415; break;
    case 415: // $2522
      var $2523=$dtd;
      var $2524=(($2523+160)|0);
      HEAP8[($2524)]=0;
      var $2525=$dtd;
      var $2526=(($2525+168)|0);
      HEAP32[(($2526)>>2)]=0;
      __label__ = 416; break;
    case 416: // $2527
      __label__ = 417; break;
    case 417: // $2528
      __label__ = 444; break;
    case 418: // $2529
      var $2530=$2;
      var $2531=$3;
      var $2532=$4;
      var $2533=HEAP32[(($7)>>2)];
      var $2534=__ZL27reportProcessingInstructionP16XML_ParserStructPK8encodingPKcS5_($2530, $2531, $2532, $2533);
      var $2535=(($2534)|0)!=0;
      if ($2535) { __label__ = 420; break; } else { __label__ = 419; break; }
    case 419: // $2536
      $1=1;
      __label__ = 452; break;
    case 420: // $2537
      $handleDefault=0;
      __label__ = 444; break;
    case 421: // $2538
      var $2539=$2;
      var $2540=$3;
      var $2541=$4;
      var $2542=HEAP32[(($7)>>2)];
      var $2543=__ZL13reportCommentP16XML_ParserStructPK8encodingPKcS5_($2539, $2540, $2541, $2542);
      var $2544=(($2543)|0)!=0;
      if ($2544) { __label__ = 423; break; } else { __label__ = 422; break; }
    case 422: // $2545
      $1=1;
      __label__ = 452; break;
    case 423: // $2546
      $handleDefault=0;
      __label__ = 444; break;
    case 424: // $2547
      var $2548=$6;
      if ($2548 == 14) {
        __label__ = 425; break;
      }
      else {
      __label__ = 426; break;
      }
      
    case 425: // $2549
      $handleDefault=0;
      __label__ = 426; break;
    case 426: // $2550
      __label__ = 444; break;
    case 427: // $2551
      var $2552=$2;
      var $2553=(($2552+84)|0);
      var $2554=HEAP32[(($2553)>>2)];
      var $2555=(($2554)|0)!=0;
      if ($2555) { __label__ = 428; break; } else { __label__ = 429; break; }
    case 428: // $2556
      $handleDefault=0;
      __label__ = 429; break;
    case 429: // $2557
      __label__ = 444; break;
    case 430: // $2558
      var $2559=$dtd;
      var $2560=(($2559+128)|0);
      var $2561=HEAP8[($2560)];
      var $2562=(($2561 << 24) >> 24)!=0;
      if ($2562) { __label__ = 431; break; } else { __label__ = 433; break; }
    case 431: // $2563
      var $2564=$2;
      var $2565=(($2564+136)|0);
      var $2566=HEAP32[(($2565)>>2)];
      var $2567=(($2566)|0)!=0;
      if ($2567) { __label__ = 432; break; } else { __label__ = 433; break; }
    case 432: // $2568
      $handleDefault=0;
      __label__ = 433; break;
    case 433: // $2569
      __label__ = 444; break;
    case 434: // $2570
      var $2571=$2;
      var $2572=(($2571+96)|0);
      var $2573=HEAP32[(($2572)>>2)];
      var $2574=(($2573)|0)!=0;
      if ($2574) { __label__ = 435; break; } else { __label__ = 436; break; }
    case 435: // $2575
      $handleDefault=0;
      __label__ = 436; break;
    case 436: // $2576
      __label__ = 444; break;
    case 437: // $2577
      var $2578=$dtd;
      var $2579=(($2578+128)|0);
      var $2580=HEAP8[($2579)];
      var $2581=(($2580 << 24) >> 24)!=0;
      if ($2581) { __label__ = 438; break; } else { __label__ = 440; break; }
    case 438: // $2582
      var $2583=$2;
      var $2584=(($2583+132)|0);
      var $2585=HEAP32[(($2584)>>2)];
      var $2586=(($2585)|0)!=0;
      if ($2586) { __label__ = 439; break; } else { __label__ = 440; break; }
    case 439: // $2587
      $handleDefault=0;
      __label__ = 440; break;
    case 440: // $2588
      __label__ = 444; break;
    case 441: // $2589
      var $2590=$2;
      var $2591=(($2590+128)|0);
      var $2592=HEAP32[(($2591)>>2)];
      var $2593=(($2592)|0)!=0;
      if ($2593) { __label__ = 442; break; } else { __label__ = 443; break; }
    case 442: // $2594
      $handleDefault=0;
      __label__ = 443; break;
    case 443: // $2595
      __label__ = 444; break;
    case 444: // $2596
      var $2597=$handleDefault;
      var $2598=(($2597 << 24) >> 24)!=0;
      if ($2598) { __label__ = 445; break; } else { __label__ = 447; break; }
    case 445: // $2599
      var $2600=$2;
      var $2601=(($2600+80)|0);
      var $2602=HEAP32[(($2601)>>2)];
      var $2603=(($2602)|0)!=0;
      if ($2603) { __label__ = 446; break; } else { __label__ = 447; break; }
    case 446: // $2604
      var $2605=$2;
      var $2606=$3;
      var $2607=$4;
      var $2608=HEAP32[(($7)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($2605, $2606, $2607, $2608);
      __label__ = 447; break;
    case 447: // $2609
      var $2610=$2;
      var $2611=(($2610+480)|0);
      var $2612=(($2611)|0);
      var $2613=HEAP32[(($2612)>>2)];
      if ($2613 == 3) {
        __label__ = 448; break;
      }
      else if ($2613 == 2) {
        __label__ = 449; break;
      }
      else {
      __label__ = 450; break;
      }
      
    case 448: // $2614
      var $2615=HEAP32[(($7)>>2)];
      var $2616=$8;
      HEAP32[(($2616)>>2)]=$2615;
      $1=0;
      __label__ = 452; break;
    case 449: // $2617
      $1=35;
      __label__ = 452; break;
    case 450: // $2618
      var $2619=HEAP32[(($7)>>2)];
      $4=$2619;
      var $2620=$3;
      var $2621=(($2620)|0);
      var $2622=(($2621)|0);
      var $2623=HEAP32[(($2622)>>2)];
      var $2624=$3;
      var $2625=$4;
      var $2626=$5;
      var $2627=FUNCTION_TABLE[$2623]($2624, $2625, $2626, $7);
      $6=$2627;
      __label__ = 451; break;
    case 451: // $2628
      __label__ = 4; break;
    case 452: // $2629
      var $2630=$1;
      STACKTOP = __stackBase__;
      return $2630;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h["X"]=1;

function __ZL17normalizePublicIdPc($publicId) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $p;
      var $s;
      $1=$publicId;
      var $2=$1;
      $p=$2;
      var $3=$1;
      $s=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$s;
      var $6=HEAP8[($5)];
      var $7=(($6 << 24) >> 24)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $8
      var $9=$s;
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      if ($11 == 32 || $11 == 13 || $11 == 10) {
        __label__ = 3; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 3: // $12
      var $13=$p;
      var $14=$1;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $16
      var $17=$p;
      var $18=(($17-1)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)!=32;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$p;
      var $24=(($23+1)|0);
      $p=$24;
      HEAP8[($23)]=32;
      __label__ = 6; break;
    case 6: // $25
      __label__ = 8; break;
    case 7: // $26
      var $27=$s;
      var $28=HEAP8[($27)];
      var $29=$p;
      var $30=(($29+1)|0);
      $p=$30;
      HEAP8[($29)]=$28;
      __label__ = 8; break;
    case 8: // $31
      __label__ = 9; break;
    case 9: // $32
      var $33=$s;
      var $34=(($33+1)|0);
      $s=$34;
      __label__ = 1; break;
    case 10: // $35
      var $36=$p;
      var $37=$1;
      var $38=(($36)|0)!=(($37)|0);
      if ($38) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $39
      var $40=$p;
      var $41=(($40-1)|0);
      var $42=HEAP8[($41)];
      var $43=(($42 << 24) >> 24);
      var $44=(($43)|0)==32;
      if ($44) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $45
      var $46=$p;
      var $47=(($46-1)|0);
      $p=$47;
      __label__ = 13; break;
    case 13: // $48
      var $49=$p;
      HEAP8[($49)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17normalizePublicIdPc["X"]=1;

function __ZL14processXmlDeclP16XML_ParserStructiPKcS2_($parser, $isGeneralTextEntity, $s, $next) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $encodingName=__stackBase__;
      var $storedEncName;
      var $newEncoding=__stackBase__+4;
      var $version=__stackBase__+8;
      var $versionend=__stackBase__+12;
      var $storedversion;
      var $standalone=__stackBase__+16;
      var $result;
      $2=$parser;
      $3=$isGeneralTextEntity;
      $4=$s;
      $5=$next;
      HEAP32[(($encodingName)>>2)]=0;
      $storedEncName=0;
      HEAP32[(($newEncoding)>>2)]=0;
      HEAP32[(($version)>>2)]=0;
      $storedversion=0;
      HEAP32[(($standalone)>>2)]=-1;
      var $6=$2;
      var $7=(($6+236)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $13 = 1510;__label__ = 3; break;
    case 2: // $11
      var $13 = 1512;__label__ = 3; break;
    case 3: // $12
      var $13;
      var $14=$3;
      var $15=$2;
      var $16=(($15+144)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$4;
      var $19=$5;
      var $20=$2;
      var $21=(($20+288)|0);
      var $22=FUNCTION_TABLE[$13]($14, $17, $18, $19, $21, $version, $versionend, $encodingName, $newEncoding, $standalone);
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $24
      var $25=$3;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      $1=31;
      __label__ = 44; break;
    case 6: // $28
      $1=30;
      __label__ = 44; break;
    case 7: // $29
      var $30=$3;
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $32
      var $33=HEAP32[(($standalone)>>2)];
      var $34=(($33)|0)==1;
      if ($34) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $35
      var $36=$2;
      var $37=(($36+356)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+130)|0);
      HEAP8[($39)]=1;
      var $40=$2;
      var $41=(($40+492)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==1;
      if ($43) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $44
      var $45=$2;
      var $46=(($45+492)|0);
      HEAP32[(($46)>>2)]=0;
      __label__ = 11; break;
    case 11: // $47
      __label__ = 12; break;
    case 12: // $48
      var $49=$2;
      var $50=(($49+140)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 13; break; } else { __label__ = 22; break; }
    case 13: // $53
      var $54=HEAP32[(($encodingName)>>2)];
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $56
      var $57=$2;
      var $58=(($57+440)|0);
      var $59=$2;
      var $60=(($59+144)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=HEAP32[(($encodingName)>>2)];
      var $63=HEAP32[(($encodingName)>>2)];
      var $64=$2;
      var $65=(($64+144)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+32)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$2;
      var $70=(($69+144)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=HEAP32[(($encodingName)>>2)];
      var $73=FUNCTION_TABLE[$68]($71, $72);
      var $74=(($63+$73)|0);
      var $75=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($58, $61, $62, $74);
      $storedEncName=$75;
      var $76=$storedEncName;
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $78
      $1=1;
      __label__ = 44; break;
    case 16: // $79
      var $80=$2;
      var $81=(($80+440)|0);
      var $82=(($81+12)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$2;
      var $85=(($84+440)|0);
      var $86=(($85+16)|0);
      HEAP32[(($86)>>2)]=$83;
      __label__ = 17; break;
    case 17: // $87
      var $88=HEAP32[(($version)>>2)];
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $90
      var $91=$2;
      var $92=(($91+440)|0);
      var $93=$2;
      var $94=(($93+144)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=HEAP32[(($version)>>2)];
      var $97=HEAP32[(($versionend)>>2)];
      var $98=$2;
      var $99=(($98+144)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100+68)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(((-$102))|0);
      var $104=(($97+$103)|0);
      var $105=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($92, $95, $96, $104);
      $storedversion=$105;
      var $106=$storedversion;
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $108
      $1=1;
      __label__ = 44; break;
    case 20: // $109
      __label__ = 21; break;
    case 21: // $110
      var $111=$2;
      var $112=(($111+140)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$2;
      var $115=(($114+4)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$storedversion;
      var $118=$storedEncName;
      var $119=HEAP32[(($standalone)>>2)];
      FUNCTION_TABLE[$113]($116, $117, $118, $119);
      __label__ = 25; break;
    case 22: // $120
      var $121=$2;
      var $122=(($121+80)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123)|0)!=0;
      if ($124) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $125
      var $126=$2;
      var $127=$2;
      var $128=(($127+144)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$4;
      var $131=$5;
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($126, $129, $130, $131);
      __label__ = 24; break;
    case 24: // $132
      __label__ = 25; break;
    case 25: // $133
      var $134=$2;
      var $135=(($134+232)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136)|0)==0;
      if ($137) { __label__ = 26; break; } else { __label__ = 40; break; }
    case 26: // $138
      var $139=HEAP32[(($newEncoding)>>2)];
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 27: // $141
      var $142=HEAP32[(($newEncoding)>>2)];
      var $143=(($142+68)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$2;
      var $146=(($145+144)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+68)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($144)|0)!=(($149)|0);
      if ($150) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $151
      var $152=HEAP32[(($encodingName)>>2)];
      var $153=$2;
      var $154=(($153+288)|0);
      HEAP32[(($154)>>2)]=$152;
      $1=19;
      __label__ = 44; break;
    case 29: // $155
      var $156=HEAP32[(($newEncoding)>>2)];
      var $157=$2;
      var $158=(($157+144)|0);
      HEAP32[(($158)>>2)]=$156;
      __label__ = 39; break;
    case 30: // $159
      var $160=HEAP32[(($encodingName)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 31; break; } else { __label__ = 38; break; }
    case 31: // $162
      var $163=$storedEncName;
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 35; break; } else { __label__ = 32; break; }
    case 32: // $165
      var $166=$2;
      var $167=(($166+440)|0);
      var $168=$2;
      var $169=(($168+144)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($encodingName)>>2)];
      var $172=HEAP32[(($encodingName)>>2)];
      var $173=$2;
      var $174=(($173+144)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=(($175+32)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$2;
      var $179=(($178+144)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=HEAP32[(($encodingName)>>2)];
      var $182=FUNCTION_TABLE[$177]($180, $181);
      var $183=(($172+$182)|0);
      var $184=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($167, $170, $171, $183);
      $storedEncName=$184;
      var $185=$storedEncName;
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 34; break; } else { __label__ = 33; break; }
    case 33: // $187
      $1=1;
      __label__ = 44; break;
    case 34: // $188
      __label__ = 35; break;
    case 35: // $189
      var $190=$2;
      var $191=$storedEncName;
      var $192=__ZL21handleUnknownEncodingP16XML_ParserStructPKc($190, $191);
      $result=$192;
      var $193=$2;
      var $194=(($193+440)|0);
      __ZL9poolClearP11STRING_POOL($194);
      var $195=$result;
      var $196=(($195)|0)==18;
      if ($196) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $197
      var $198=HEAP32[(($encodingName)>>2)];
      var $199=$2;
      var $200=(($199+288)|0);
      HEAP32[(($200)>>2)]=$198;
      __label__ = 37; break;
    case 37: // $201
      var $202=$result;
      $1=$202;
      __label__ = 44; break;
    case 38: // $203
      __label__ = 39; break;
    case 39: // $204
      __label__ = 40; break;
    case 40: // $205
      var $206=$storedEncName;
      var $207=(($206)|0)!=0;
      if ($207) { __label__ = 42; break; } else { __label__ = 41; break; }
    case 41: // $208
      var $209=$storedversion;
      var $210=(($209)|0)!=0;
      if ($210) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $211
      var $212=$2;
      var $213=(($212+440)|0);
      __ZL9poolClearP11STRING_POOL($213);
      __label__ = 43; break;
    case 43: // $214
      $1=0;
      __label__ = 44; break;
    case 44: // $215
      var $216=$1;
      STACKTOP = __stackBase__;
      return $216;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14processXmlDeclP16XML_ParserStructiPKcS2_["X"]=1;

function __ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($pool, $enc, $ptr, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$pool;
      $3=$enc;
      $4=$ptr;
      $5=$end;
      var $6=$2;
      var $7=$3;
      var $8=$4;
      var $9=$5;
      var $10=__ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_($6, $7, $8, $9);
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      $1=0;
      __label__ = 6; break;
    case 2: // $13
      var $14=$2;
      var $15=(($14+12)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$2;
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($16)|0)==(($19)|0);
      if ($20) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $21
      var $22=$2;
      var $23=__ZL8poolGrowP11STRING_POOL($22);
      var $24=(($23 << 24) >> 24)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $25
      $1=0;
      __label__ = 6; break;
    case 5: // $26
      var $27=$2;
      var $28=(($27+12)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+1)|0);
      HEAP32[(($28)>>2)]=$30;
      HEAP8[($29)]=0;
      var $31=$2;
      var $32=(($31+16)|0);
      var $33=HEAP32[(($32)>>2)];
      $1=$33;
      __label__ = 6; break;
    case 6: // $34
      var $35=$1;
      ;
      return $35;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16contentProcessorP16XML_ParserStructPKcS2_PS2_($parser, $start, $end, $endPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $result;
      $2=$parser;
      $3=$start;
      $4=$end;
      $5=$endPtr;
      var $6=$2;
      var $7=$2;
      var $8=(($7+144)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$3;
      var $11=$4;
      var $12=$5;
      var $13=$2;
      var $14=(($13+480)|0);
      var $15=(($14+4)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24)!=0;
      var $18=$17 ^ 1;
      var $19=(($18)&1);
      var $20=__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h($6, 0, $9, $10, $11, $12, $19);
      $result=$20;
      var $21=$result;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $23
      var $24=$2;
      var $25=__ZL13storeRawNamesP16XML_ParserStruct($24);
      var $26=(($25 << 24) >> 24)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $27
      $1=1;
      __label__ = 5; break;
    case 3: // $28
      __label__ = 4; break;
    case 4: // $29
      var $30=$result;
      $1=$30;
      __label__ = 5; break;
    case 5: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14getElementTypeP16XML_ParserStructPK8encodingPKcS5_($parser, $enc, $ptr, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $dtd;
      var $name;
      var $ret;
      $2=$parser;
      $3=$enc;
      $4=$ptr;
      $5=$end;
      var $6=$2;
      var $7=(($6+356)|0);
      var $8=HEAP32[(($7)>>2)];
      $dtd=$8;
      var $9=$dtd;
      var $10=(($9+80)|0);
      var $11=$3;
      var $12=$4;
      var $13=$5;
      var $14=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($10, $11, $12, $13);
      $name=$14;
      var $15=$name;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $17
      $1=0;
      __label__ = 10; break;
    case 2: // $18
      var $19=$dtd;
      var $20=(($19+20)|0);
      var $21=$name;
      var $22=__ZL6lookupP10HASH_TABLEPKcj($20, $21, 24);
      var $23=$22;
      $ret=$23;
      var $24=$ret;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $26
      $1=0;
      __label__ = 10; break;
    case 4: // $27
      var $28=$ret;
      var $29=(($28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$name;
      var $32=(($30)|0)!=(($31)|0);
      if ($32) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $33
      var $34=$dtd;
      var $35=(($34+80)|0);
      var $36=(($35+16)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$dtd;
      var $39=(($38+80)|0);
      var $40=(($39+12)|0);
      HEAP32[(($40)>>2)]=$37;
      __label__ = 9; break;
    case 6: // $41
      var $42=$dtd;
      var $43=(($42+80)|0);
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$dtd;
      var $47=(($46+80)|0);
      var $48=(($47+16)|0);
      HEAP32[(($48)>>2)]=$45;
      var $49=$2;
      var $50=$ret;
      var $51=__ZL20setElementTypePrefixP16XML_ParserStructP12ELEMENT_TYPE($49, $50);
      var $52=(($51)|0)!=0;
      if ($52) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $53
      $1=0;
      __label__ = 10; break;
    case 8: // $54
      __label__ = 9; break;
    case 9: // $55
      var $56=$ret;
      $1=$56;
      __label__ = 10; break;
    case 10: // $57
      var $58=$1;
      ;
      return $58;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14getElementTypeP16XML_ParserStructPK8encodingPKcS5_["X"]=1;

function __ZL14getAttributeIdP16XML_ParserStructPK8encodingPKcS5_($parser, $enc, $start, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $dtd;
      var $id;
      var $name;
      var $i;
      var $j;
      $2=$parser;
      $3=$enc;
      $4=$start;
      $5=$end;
      var $6=$2;
      var $7=(($6+356)|0);
      var $8=HEAP32[(($7)>>2)];
      $dtd=$8;
      var $9=$dtd;
      var $10=(($9+80)|0);
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$dtd;
      var $14=(($13+80)|0);
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($12)|0)==(($16)|0);
      if ($17) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $18
      var $19=$dtd;
      var $20=(($19+80)|0);
      var $21=__ZL8poolGrowP11STRING_POOL($20);
      var $22=(($21 << 24) >> 24)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $23
      var $31 = 0;__label__ = 4; break;
    case 3: // $24
      var $25=$dtd;
      var $26=(($25+80)|0);
      var $27=(($26+12)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+1)|0);
      HEAP32[(($27)>>2)]=$29;
      HEAP8[($28)]=0;
      var $31 = 1;__label__ = 4; break;
    case 4: // $30
      var $31;
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $33
      $1=0;
      __label__ = 54; break;
    case 6: // $34
      var $35=$dtd;
      var $36=(($35+80)|0);
      var $37=$3;
      var $38=$4;
      var $39=$5;
      var $40=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($36, $37, $38, $39);
      $name=$40;
      var $41=$name;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $43
      $1=0;
      __label__ = 54; break;
    case 8: // $44
      var $45=$name;
      var $46=(($45+1)|0);
      $name=$46;
      var $47=$dtd;
      var $48=(($47+40)|0);
      var $49=$name;
      var $50=__ZL6lookupP10HASH_TABLEPKcj($48, $49, 12);
      var $51=$50;
      $id=$51;
      var $52=$id;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $54
      $1=0;
      __label__ = 54; break;
    case 10: // $55
      var $56=$id;
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$name;
      var $60=(($58)|0)!=(($59)|0);
      if ($60) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $61
      var $62=$dtd;
      var $63=(($62+80)|0);
      var $64=(($63+16)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$dtd;
      var $67=(($66+80)|0);
      var $68=(($67+12)|0);
      HEAP32[(($68)>>2)]=$65;
      __label__ = 53; break;
    case 12: // $69
      var $70=$dtd;
      var $71=(($70+80)|0);
      var $72=(($71+12)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$dtd;
      var $75=(($74+80)|0);
      var $76=(($75+16)|0);
      HEAP32[(($76)>>2)]=$73;
      var $77=$2;
      var $78=(($77+236)|0);
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24)!=0;
      if ($80) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $81
      __label__ = 52; break;
    case 14: // $82
      var $83=$name;
      var $84=(($83)|0);
      var $85=HEAP8[($84)];
      var $86=(($85 << 24) >> 24);
      var $87=(($86)|0)==120;
      if ($87) { __label__ = 15; break; } else { __label__ = 25; break; }
    case 15: // $88
      var $89=$name;
      var $90=(($89+1)|0);
      var $91=HEAP8[($90)];
      var $92=(($91 << 24) >> 24);
      var $93=(($92)|0)==109;
      if ($93) { __label__ = 16; break; } else { __label__ = 25; break; }
    case 16: // $94
      var $95=$name;
      var $96=(($95+2)|0);
      var $97=HEAP8[($96)];
      var $98=(($97 << 24) >> 24);
      var $99=(($98)|0)==108;
      if ($99) { __label__ = 17; break; } else { __label__ = 25; break; }
    case 17: // $100
      var $101=$name;
      var $102=(($101+3)|0);
      var $103=HEAP8[($102)];
      var $104=(($103 << 24) >> 24);
      var $105=(($104)|0)==110;
      if ($105) { __label__ = 18; break; } else { __label__ = 25; break; }
    case 18: // $106
      var $107=$name;
      var $108=(($107+4)|0);
      var $109=HEAP8[($108)];
      var $110=(($109 << 24) >> 24);
      var $111=(($110)|0)==115;
      if ($111) { __label__ = 19; break; } else { __label__ = 25; break; }
    case 19: // $112
      var $113=$name;
      var $114=(($113+5)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24);
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $118
      var $119=$name;
      var $120=(($119+5)|0);
      var $121=HEAP8[($120)];
      var $122=(($121 << 24) >> 24);
      var $123=(($122)|0)==58;
      if ($123) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $124
      var $125=$name;
      var $126=(($125+5)|0);
      var $127=HEAP8[($126)];
      var $128=(($127 << 24) >> 24);
      var $129=(($128)|0)==0;
      if ($129) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $130
      var $131=$dtd;
      var $132=(($131+152)|0);
      var $133=$id;
      var $134=(($133+4)|0);
      HEAP32[(($134)>>2)]=$132;
      __label__ = 24; break;
    case 23: // $135
      var $136=$dtd;
      var $137=(($136+60)|0);
      var $138=$name;
      var $139=(($138+6)|0);
      var $140=__ZL6lookupP10HASH_TABLEPKcj($137, $139, 8);
      var $141=$140;
      var $142=$id;
      var $143=(($142+4)|0);
      HEAP32[(($143)>>2)]=$141;
      __label__ = 24; break;
    case 24: // $144
      var $145=$id;
      var $146=(($145+9)|0);
      HEAP8[($146)]=1;
      __label__ = 51; break;
    case 25: // $147
      $i=0;
      __label__ = 26; break;
    case 26: // $148
      var $149=$i;
      var $150=$name;
      var $151=(($150+$149)|0);
      var $152=HEAP8[($151)];
      var $153=(($152 << 24) >> 24)!=0;
      if ($153) { __label__ = 27; break; } else { __label__ = 50; break; }
    case 27: // $154
      var $155=$i;
      var $156=$name;
      var $157=(($156+$155)|0);
      var $158=HEAP8[($157)];
      var $159=(($158 << 24) >> 24);
      var $160=(($159)|0)==58;
      if ($160) { __label__ = 28; break; } else { __label__ = 48; break; }
    case 28: // $161
      $j=0;
      __label__ = 29; break;
    case 29: // $162
      var $163=$j;
      var $164=$i;
      var $165=(($163)|0) < (($164)|0);
      if ($165) { __label__ = 30; break; } else { __label__ = 38; break; }
    case 30: // $166
      var $167=$dtd;
      var $168=(($167+80)|0);
      var $169=(($168+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$dtd;
      var $172=(($171+80)|0);
      var $173=(($172+8)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=(($170)|0)==(($174)|0);
      if ($175) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $176
      var $177=$dtd;
      var $178=(($177+80)|0);
      var $179=__ZL8poolGrowP11STRING_POOL($178);
      var $180=(($179 << 24) >> 24)!=0;
      if ($180) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $181
      var $193 = 0;__label__ = 34; break;
    case 33: // $182
      var $183=$j;
      var $184=$name;
      var $185=(($184+$183)|0);
      var $186=HEAP8[($185)];
      var $187=$dtd;
      var $188=(($187+80)|0);
      var $189=(($188+12)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190+1)|0);
      HEAP32[(($189)>>2)]=$191;
      HEAP8[($190)]=$186;
      var $193 = 1;__label__ = 34; break;
    case 34: // $192
      var $193;
      var $194=(($193)|0)!=0;
      if ($194) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $195
      $1=0;
      __label__ = 54; break;
    case 36: // $196
      __label__ = 37; break;
    case 37: // $197
      var $198=$j;
      var $199=(($198+1)|0);
      $j=$199;
      __label__ = 29; break;
    case 38: // $200
      var $201=$dtd;
      var $202=(($201+80)|0);
      var $203=(($202+12)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$dtd;
      var $206=(($205+80)|0);
      var $207=(($206+8)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($204)|0)==(($208)|0);
      if ($209) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $210
      var $211=$dtd;
      var $212=(($211+80)|0);
      var $213=__ZL8poolGrowP11STRING_POOL($212);
      var $214=(($213 << 24) >> 24)!=0;
      if ($214) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $215
      var $223 = 0;__label__ = 42; break;
    case 41: // $216
      var $217=$dtd;
      var $218=(($217+80)|0);
      var $219=(($218+12)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220+1)|0);
      HEAP32[(($219)>>2)]=$221;
      HEAP8[($220)]=0;
      var $223 = 1;__label__ = 42; break;
    case 42: // $222
      var $223;
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $225
      $1=0;
      __label__ = 54; break;
    case 44: // $226
      var $227=$dtd;
      var $228=(($227+60)|0);
      var $229=$dtd;
      var $230=(($229+80)|0);
      var $231=(($230+16)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=__ZL6lookupP10HASH_TABLEPKcj($228, $232, 8);
      var $234=$233;
      var $235=$id;
      var $236=(($235+4)|0);
      HEAP32[(($236)>>2)]=$234;
      var $237=$id;
      var $238=(($237+4)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(($239)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=$dtd;
      var $243=(($242+80)|0);
      var $244=(($243+16)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=(($241)|0)==(($245)|0);
      if ($246) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $247
      var $248=$dtd;
      var $249=(($248+80)|0);
      var $250=(($249+12)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=$dtd;
      var $253=(($252+80)|0);
      var $254=(($253+16)|0);
      HEAP32[(($254)>>2)]=$251;
      __label__ = 47; break;
    case 46: // $255
      var $256=$dtd;
      var $257=(($256+80)|0);
      var $258=(($257+16)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=$dtd;
      var $261=(($260+80)|0);
      var $262=(($261+12)|0);
      HEAP32[(($262)>>2)]=$259;
      __label__ = 47; break;
    case 47: // $263
      __label__ = 50; break;
    case 48: // $264
      __label__ = 49; break;
    case 49: // $265
      var $266=$i;
      var $267=(($266+1)|0);
      $i=$267;
      __label__ = 26; break;
    case 50: // $268
      __label__ = 51; break;
    case 51: // $269
      __label__ = 52; break;
    case 52: // $270
      __label__ = 53; break;
    case 53: // $271
      var $272=$id;
      $1=$272;
      __label__ = 54; break;
    case 54: // $273
      var $274=$1;
      ;
      return $274;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14getAttributeIdP16XML_ParserStructPK8encodingPKcS5_["X"]=1;

function __ZL16poolAppendStringP11STRING_POOLPKc($pool, $s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$pool;
      $3=$s;
      __label__ = 1; break;
    case 1: // $4
      var $5=$3;
      var $6=HEAP8[($5)];
      var $7=(($6 << 24) >> 24)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $8
      var $9=$2;
      var $10=(($9+12)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=(($12+8)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($11)|0)==(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      var $17=$2;
      var $18=__ZL8poolGrowP11STRING_POOL($17);
      var $19=(($18 << 24) >> 24)!=0;
      if ($19) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $20
      var $29 = 0;__label__ = 6; break;
    case 5: // $21
      var $22=$3;
      var $23=HEAP8[($22)];
      var $24=$2;
      var $25=(($24+12)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+1)|0);
      HEAP32[(($25)>>2)]=$27;
      HEAP8[($26)]=$23;
      var $29 = 1;__label__ = 6; break;
    case 6: // $28
      var $29;
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $31
      $1=0;
      __label__ = 10; break;
    case 8: // $32
      var $33=$3;
      var $34=(($33+1)|0);
      $3=$34;
      __label__ = 1; break;
    case 9: // $35
      var $36=$2;
      var $37=(($36+16)|0);
      var $38=HEAP32[(($37)>>2)];
      $1=$38;
      __label__ = 10; break;
    case 10: // $39
      var $40=$1;
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_($pool, $enc, $ptr, $end) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4=__stackBase__;
      var $5;
      $2=$pool;
      $3=$enc;
      HEAP32[(($4)>>2)]=$ptr;
      $5=$end;
      var $6=$2;
      var $7=(($6+12)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$2;
      var $12=__ZL8poolGrowP11STRING_POOL($11);
      var $13=(($12 << 24) >> 24)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      $1=0;
      __label__ = 10; break;
    case 3: // $15
      __label__ = 4; break;
    case 4: // $16
      var $17=$3;
      var $18=(($17+60)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$3;
      var $21=$5;
      var $22=$2;
      var $23=(($22+12)|0);
      var $24=$2;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      FUNCTION_TABLE[$19]($20, $4, $21, $23, $26);
      var $27=HEAP32[(($4)>>2)];
      var $28=$5;
      var $29=(($27)|0)==(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      __label__ = 9; break;
    case 6: // $31
      var $32=$2;
      var $33=__ZL8poolGrowP11STRING_POOL($32);
      var $34=(($33 << 24) >> 24)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $35
      $1=0;
      __label__ = 10; break;
    case 8: // $36
      __label__ = 4; break;
    case 9: // $37
      var $38=$2;
      var $39=(($38+16)|0);
      var $40=HEAP32[(($39)>>2)];
      $1=$40;
      __label__ = 10; break;
    case 10: // $41
      var $42=$1;
      STACKTOP = __stackBase__;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_["X"]=1;

function __ZL15defineAttributeP12ELEMENT_TYPEP12attribute_idhhPKcP16XML_ParserStruct($type, $attId, $isCdata, $isId, $value, $parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $att;
      var $i;
      var $temp;
      var $count;
      $2=$type;
      $3=$attId;
      $4=$isCdata;
      $5=$isId;
      $6=$value;
      $7=$parser;
      var $8=$6;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$5;
      var $12=(($11 << 24) >> 24)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $13
      $i=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$i;
      var $16=$2;
      var $17=(($16+12)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($15)|0) < (($18)|0);
      if ($19) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $20
      var $21=$3;
      var $22=$i;
      var $23=$2;
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+$22*12)|0);
      var $27=(($26)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($21)|0)==(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      $1=1;
      __label__ = 25; break;
    case 6: // $31
      __label__ = 7; break;
    case 7: // $32
      var $33=$i;
      var $34=(($33+1)|0);
      $i=$34;
      __label__ = 3; break;
    case 8: // $35
      var $36=$5;
      var $37=(($36 << 24) >> 24)!=0;
      if ($37) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $38
      var $39=$2;
      var $40=(($39+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $43
      var $44=$3;
      var $45=(($44+9)|0);
      var $46=HEAP8[($45)];
      var $47=(($46 << 24) >> 24)!=0;
      if ($47) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $48
      var $49=$3;
      var $50=$2;
      var $51=(($50+8)|0);
      HEAP32[(($51)>>2)]=$49;
      __label__ = 12; break;
    case 12: // $52
      __label__ = 13; break;
    case 13: // $53
      var $54=$2;
      var $55=(($54+12)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$2;
      var $58=(($57+16)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($56)|0)==(($59)|0);
      if ($60) { __label__ = 14; break; } else { __label__ = 22; break; }
    case 14: // $61
      var $62=$2;
      var $63=(($62+16)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)==0;
      if ($65) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $66
      var $67=$2;
      var $68=(($67+16)|0);
      HEAP32[(($68)>>2)]=8;
      var $69=$7;
      var $70=(($69+12)|0);
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$2;
      var $74=(($73+16)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75*12)|0);
      var $77=FUNCTION_TABLE[$72]($76);
      var $78=$77;
      var $79=$2;
      var $80=(($79+20)|0);
      HEAP32[(($80)>>2)]=$78;
      var $81=$2;
      var $82=(($81+20)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $85
      $1=0;
      __label__ = 25; break;
    case 17: // $86
      __label__ = 21; break;
    case 18: // $87
      var $88=$2;
      var $89=(($88+16)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=((($90<<1))|0);
      $count=$91;
      var $92=$7;
      var $93=(($92+12)|0);
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      var $97=(($96+20)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$98;
      var $100=$count;
      var $101=(($100*12)|0);
      var $102=FUNCTION_TABLE[$95]($99, $101);
      var $103=$102;
      $temp=$103;
      var $104=$temp;
      var $105=(($104)|0)==0;
      if ($105) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $106
      $1=0;
      __label__ = 25; break;
    case 20: // $107
      var $108=$count;
      var $109=$2;
      var $110=(($109+16)|0);
      HEAP32[(($110)>>2)]=$108;
      var $111=$temp;
      var $112=$2;
      var $113=(($112+20)|0);
      HEAP32[(($113)>>2)]=$111;
      __label__ = 21; break;
    case 21: // $114
      __label__ = 22; break;
    case 22: // $115
      var $116=$2;
      var $117=(($116+20)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$2;
      var $120=(($119+12)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($118+$121*12)|0);
      $att=$122;
      var $123=$3;
      var $124=$att;
      var $125=(($124)|0);
      HEAP32[(($125)>>2)]=$123;
      var $126=$6;
      var $127=$att;
      var $128=(($127+8)|0);
      HEAP32[(($128)>>2)]=$126;
      var $129=$4;
      var $130=$att;
      var $131=(($130+4)|0);
      HEAP8[($131)]=$129;
      var $132=$4;
      var $133=(($132 << 24) >> 24)!=0;
      if ($133) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $134
      var $135=$3;
      var $136=(($135+8)|0);
      HEAP8[($136)]=1;
      __label__ = 24; break;
    case 24: // $137
      var $138=$2;
      var $139=(($138+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+1)|0);
      HEAP32[(($139)>>2)]=$141;
      $1=1;
      __label__ = 25; break;
    case 25: // $142
      var $143=$1;
      ;
      return $143;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15defineAttributeP12ELEMENT_TYPEP12attribute_idhhPKcP16XML_ParserStruct["X"]=1;

function __ZL19storeAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL($parser, $enc, $isCdata, $ptr, $end, $pool) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $result;
      $2=$parser;
      $3=$enc;
      $4=$isCdata;
      $5=$ptr;
      $6=$end;
      $7=$pool;
      var $8=$2;
      var $9=$3;
      var $10=$4;
      var $11=$5;
      var $12=$6;
      var $13=$7;
      var $14=__ZL20appendAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL($8, $9, $10, $11, $12, $13);
      $result=$14;
      var $15=$result;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$result;
      $1=$18;
      __label__ = 13; break;
    case 2: // $19
      var $20=$4;
      var $21=(($20 << 24) >> 24)!=0;
      if ($21) { __label__ = 6; break; } else { __label__ = 3; break; }
    case 3: // $22
      var $23=$7;
      var $24=(($23+12)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$7;
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$25;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $33
      var $34=$7;
      var $35=(($34+12)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36-1)|0);
      var $38=HEAP8[($37)];
      var $39=(($38 << 24) >> 24);
      var $40=(($39)|0)==32;
      if ($40) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $41
      var $42=$7;
      var $43=(($42+12)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44-1)|0);
      HEAP32[(($43)>>2)]=$45;
      __label__ = 6; break;
    case 6: // $46
      var $47=$7;
      var $48=(($47+12)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$7;
      var $51=(($50+8)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49)|0)==(($52)|0);
      if ($53) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $54
      var $55=$7;
      var $56=__ZL8poolGrowP11STRING_POOL($55);
      var $57=(($56 << 24) >> 24)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $58
      var $65 = 0;__label__ = 10; break;
    case 9: // $59
      var $60=$7;
      var $61=(($60+12)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+1)|0);
      HEAP32[(($61)>>2)]=$63;
      HEAP8[($62)]=0;
      var $65 = 1;__label__ = 10; break;
    case 10: // $64
      var $65;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $67
      $1=1;
      __label__ = 13; break;
    case 12: // $68
      $1=0;
      __label__ = 13; break;
    case 13: // $69
      var $70=$1;
      ;
      return $70;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19storeAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL["X"]=1;

function __ZL16storeEntityValueP16XML_ParserStructPK8encodingPKcS5_($parser, $enc, $entityTextPtr, $entityTextEnd) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $dtd;
      var $pool;
      var $result;
      var $oldInEntityValue;
      var $next=__stackBase__;
      var $tok;
      var $name;
      var $entity;
      var $buf=__stackBase__+4;
      var $i;
      var $n;
      $2=$parser;
      $3=$enc;
      $4=$entityTextPtr;
      $5=$entityTextEnd;
      var $6=$2;
      var $7=(($6+356)|0);
      var $8=HEAP32[(($7)>>2)];
      $dtd=$8;
      var $9=$dtd;
      var $10=(($9+104)|0);
      $pool=$10;
      $result=0;
      var $11=$2;
      var $12=(($11+256)|0);
      var $13=(($12+20)|0);
      var $14=HEAP32[(($13)>>2)];
      $oldInEntityValue=$14;
      var $15=$2;
      var $16=(($15+256)|0);
      var $17=(($16+20)|0);
      HEAP32[(($17)>>2)]=1;
      var $18=$pool;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $22
      var $23=$pool;
      var $24=__ZL8poolGrowP11STRING_POOL($23);
      var $25=(($24 << 24) >> 24)!=0;
      if ($25) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $26
      $1=1;
      __label__ = 66; break;
    case 3: // $27
      __label__ = 4; break;
    case 4: // $28
      __label__ = 5; break;
    case 5: // $29
      var $30=$3;
      var $31=(($30+16)|0);
      var $32=(($31+4)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$3;
      var $35=$4;
      var $36=$5;
      var $37=FUNCTION_TABLE[$33]($34, $35, $36, $next);
      $tok=$37;
      var $38=$tok;
      if ($38 == 28) {
        __label__ = 6; break;
      }
      else if ($38 == -4) {
        __label__ = 30; break;
      }
      else if ($38 == 9 || $38 == 6) {
        __label__ = 31; break;
      }
      else if ($38 == -3) {
        __label__ = 34; break;
      }
      else if ($38 == 7) {
        __label__ = 35; break;
      }
      else if ($38 == 10) {
        __label__ = 39; break;
      }
      else if ($38 == -1) {
        __label__ = 55; break;
      }
      else if ($38 == 0) {
        __label__ = 58; break;
      }
      else {
      __label__ = 61; break;
      }
      
    case 6: // $39
      var $40=$2;
      var $41=(($40+488)|0);
      var $42=HEAP8[($41)];
      var $43=(($42 << 24) >> 24)!=0;
      if ($43) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $44
      var $45=$3;
      var $46=$2;
      var $47=(($46+144)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($45)|0)!=(($48)|0);
      if ($49) { __label__ = 8; break; } else { __label__ = 29; break; }
    case 8: // $50
      var $51=$2;
      var $52=(($51+416)|0);
      var $53=$3;
      var $54=$4;
      var $55=$3;
      var $56=(($55+68)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($54+$57)|0);
      var $59=HEAP32[(($next)>>2)];
      var $60=$3;
      var $61=(($60+68)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(((-$62))|0);
      var $64=(($59+$63)|0);
      var $65=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($52, $53, $58, $64);
      $name=$65;
      var $66=$name;
      var $67=(($66)|0)!=0;
      if ($67) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $68
      $result=1;
      __label__ = 65; break;
    case 10: // $69
      var $70=$dtd;
      var $71=(($70+132)|0);
      var $72=$name;
      var $73=__ZL6lookupP10HASH_TABLEPKcj($71, $72, 0);
      var $74=$73;
      $entity=$74;
      var $75=$2;
      var $76=(($75+416)|0);
      var $77=(($76+16)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$2;
      var $80=(($79+416)|0);
      var $81=(($80+12)|0);
      HEAP32[(($81)>>2)]=$78;
      var $82=$entity;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $84
      var $85=$dtd;
      var $86=(($85+130)|0);
      var $87=HEAP8[($86)];
      var $88=$dtd;
      var $89=(($88+128)|0);
      HEAP8[($89)]=$87;
      __label__ = 65; break;
    case 12: // $90
      var $91=$entity;
      var $92=(($91+32)|0);
      var $93=HEAP8[($92)];
      var $94=(($93 << 24) >> 24)!=0;
      if ($94) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $95
      var $96=$3;
      var $97=$2;
      var $98=(($97+144)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($96)|0)==(($99)|0);
      if ($100) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $101
      var $102=$4;
      var $103=$2;
      var $104=(($103+288)|0);
      HEAP32[(($104)>>2)]=$102;
      __label__ = 15; break;
    case 15: // $105
      $result=12;
      __label__ = 65; break;
    case 16: // $106
      var $107=$entity;
      var $108=(($107+16)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 17; break; } else { __label__ = 25; break; }
    case 17: // $111
      var $112=$2;
      var $113=(($112+112)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 18; break; } else { __label__ = 23; break; }
    case 18: // $116
      var $117=$dtd;
      var $118=(($117+131)|0);
      HEAP8[($118)]=0;
      var $119=$entity;
      var $120=(($119+32)|0);
      HEAP8[($120)]=1;
      var $121=$2;
      var $122=(($121+112)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$2;
      var $125=(($124+116)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=$entity;
      var $128=(($127+20)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$entity;
      var $131=(($130+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$entity;
      var $134=(($133+24)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=FUNCTION_TABLE[$123]($126, 0, $129, $132, $135);
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $138
      var $139=$entity;
      var $140=(($139+32)|0);
      HEAP8[($140)]=0;
      $result=21;
      __label__ = 65; break;
    case 20: // $141
      var $142=$entity;
      var $143=(($142+32)|0);
      HEAP8[($143)]=0;
      var $144=$dtd;
      var $145=(($144+131)|0);
      var $146=HEAP8[($145)];
      var $147=(($146 << 24) >> 24)!=0;
      if ($147) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $148
      var $149=$dtd;
      var $150=(($149+130)|0);
      var $151=HEAP8[($150)];
      var $152=$dtd;
      var $153=(($152+128)|0);
      HEAP8[($153)]=$151;
      __label__ = 22; break;
    case 22: // $154
      __label__ = 24; break;
    case 23: // $155
      var $156=$dtd;
      var $157=(($156+130)|0);
      var $158=HEAP8[($157)];
      var $159=$dtd;
      var $160=(($159+128)|0);
      HEAP8[($160)]=$158;
      __label__ = 24; break;
    case 24: // $161
      __label__ = 28; break;
    case 25: // $162
      var $163=$entity;
      var $164=(($163+32)|0);
      HEAP8[($164)]=1;
      var $165=$2;
      var $166=$2;
      var $167=(($166+228)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$entity;
      var $170=(($169+4)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$entity;
      var $173=(($172+4)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$entity;
      var $176=(($175+8)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($174+$177)|0);
      var $179=__ZL16storeEntityValueP16XML_ParserStructPK8encodingPKcS5_($165, $168, $171, $178);
      $result=$179;
      var $180=$entity;
      var $181=(($180+32)|0);
      HEAP8[($181)]=0;
      var $182=$result;
      var $183=(($182)|0)!=0;
      if ($183) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $184
      __label__ = 65; break;
    case 27: // $185
      __label__ = 28; break;
    case 28: // $186
      __label__ = 64; break;
    case 29: // $187
      var $188=$4;
      var $189=$2;
      var $190=(($189+288)|0);
      HEAP32[(($190)>>2)]=$188;
      $result=10;
      __label__ = 65; break;
    case 30: // $191
      $result=0;
      __label__ = 65; break;
    case 31: // $192
      var $193=$pool;
      var $194=$3;
      var $195=$4;
      var $196=HEAP32[(($next)>>2)];
      var $197=__ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_($193, $194, $195, $196);
      var $198=(($197)|0)!=0;
      if ($198) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $199
      $result=1;
      __label__ = 65; break;
    case 33: // $200
      __label__ = 64; break;
    case 34: // $201
      var $202=$4;
      var $203=$3;
      var $204=(($203+68)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($202+$205)|0);
      HEAP32[(($next)>>2)]=$206;
      __label__ = 35; break;
    case 35: // $207
      var $208=$pool;
      var $209=(($208+8)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=$pool;
      var $212=(($211+12)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($210)|0)==(($213)|0);
      if ($214) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 36: // $215
      var $216=$pool;
      var $217=__ZL8poolGrowP11STRING_POOL($216);
      var $218=(($217 << 24) >> 24)!=0;
      if ($218) { __label__ = 38; break; } else { __label__ = 37; break; }
    case 37: // $219
      $result=1;
      __label__ = 65; break;
    case 38: // $220
      var $221=$pool;
      var $222=(($221+12)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(($223+1)|0);
      HEAP32[(($222)>>2)]=$224;
      HEAP8[($223)]=10;
      __label__ = 64; break;
    case 39: // $225
      var $226=$3;
      var $227=(($226+44)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $230=$4;
      var $231=FUNCTION_TABLE[$228]($229, $230);
      $n=$231;
      var $232=$n;
      var $233=(($232)|0) < 0;
      if ($233) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $234
      var $235=$3;
      var $236=$2;
      var $237=(($236+144)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($235)|0)==(($238)|0);
      if ($239) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $240
      var $241=$4;
      var $242=$2;
      var $243=(($242+288)|0);
      HEAP32[(($243)>>2)]=$241;
      __label__ = 42; break;
    case 42: // $244
      $result=14;
      __label__ = 65; break;
    case 43: // $245
      var $246=$n;
      var $247=(($buf)|0);
      var $248=_XmlUtf8Encode($246, $247);
      $n=$248;
      var $249=$n;
      var $250=(($249)|0)!=0;
      if ($250) { __label__ = 47; break; } else { __label__ = 44; break; }
    case 44: // $251
      var $252=$3;
      var $253=$2;
      var $254=(($253+144)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($252)|0)==(($255)|0);
      if ($256) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $257
      var $258=$4;
      var $259=$2;
      var $260=(($259+288)|0);
      HEAP32[(($260)>>2)]=$258;
      __label__ = 46; break;
    case 46: // $261
      $result=14;
      __label__ = 65; break;
    case 47: // $262
      $i=0;
      __label__ = 48; break;
    case 48: // $263
      var $264=$i;
      var $265=$n;
      var $266=(($264)|0) < (($265)|0);
      if ($266) { __label__ = 49; break; } else { __label__ = 54; break; }
    case 49: // $267
      var $268=$pool;
      var $269=(($268+8)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=$pool;
      var $272=(($271+12)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=(($270)|0)==(($273)|0);
      if ($274) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $275
      var $276=$pool;
      var $277=__ZL8poolGrowP11STRING_POOL($276);
      var $278=(($277 << 24) >> 24)!=0;
      if ($278) { __label__ = 52; break; } else { __label__ = 51; break; }
    case 51: // $279
      $result=1;
      __label__ = 65; break;
    case 52: // $280
      var $281=$i;
      var $282=(($buf+$281)|0);
      var $283=HEAP8[($282)];
      var $284=$pool;
      var $285=(($284+12)|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=(($286+1)|0);
      HEAP32[(($285)>>2)]=$287;
      HEAP8[($286)]=$283;
      __label__ = 53; break;
    case 53: // $288
      var $289=$i;
      var $290=(($289+1)|0);
      $i=$290;
      __label__ = 48; break;
    case 54: // $291
      __label__ = 64; break;
    case 55: // $292
      var $293=$3;
      var $294=$2;
      var $295=(($294+144)|0);
      var $296=HEAP32[(($295)>>2)];
      var $297=(($293)|0)==(($296)|0);
      if ($297) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $298
      var $299=$4;
      var $300=$2;
      var $301=(($300+288)|0);
      HEAP32[(($301)>>2)]=$299;
      __label__ = 57; break;
    case 57: // $302
      $result=4;
      __label__ = 65; break;
    case 58: // $303
      var $304=$3;
      var $305=$2;
      var $306=(($305+144)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=(($304)|0)==(($307)|0);
      if ($308) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $309
      var $310=HEAP32[(($next)>>2)];
      var $311=$2;
      var $312=(($311+288)|0);
      HEAP32[(($312)>>2)]=$310;
      __label__ = 60; break;
    case 60: // $313
      $result=4;
      __label__ = 65; break;
    case 61: // $314
      var $315=$3;
      var $316=$2;
      var $317=(($316+144)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=(($315)|0)==(($318)|0);
      if ($319) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $320
      var $321=$4;
      var $322=$2;
      var $323=(($322+288)|0);
      HEAP32[(($323)>>2)]=$321;
      __label__ = 63; break;
    case 63: // $324
      $result=23;
      __label__ = 65; break;
    case 64: // $325
      var $326=HEAP32[(($next)>>2)];
      $4=$326;
      __label__ = 5; break;
    case 65: // $327
      var $328=$oldInEntityValue;
      var $329=$2;
      var $330=(($329+256)|0);
      var $331=(($330+20)|0);
      HEAP32[(($331)>>2)]=$328;
      var $332=$result;
      $1=$332;
      __label__ = 66; break;
    case 66: // $333
      var $334=$1;
      STACKTOP = __stackBase__;
      return $334;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16storeEntityValueP16XML_ParserStructPK8encodingPKcS5_["X"]=1;

function __ZL15doIgnoreSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h($parser, $enc, $startPtr, $end, $nextPtr, $haveMore) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $next=__stackBase__;
      var $tok;
      var $s;
      var $eventPP;
      var $eventEndPP;
      $2=$parser;
      $3=$enc;
      $4=$startPtr;
      $5=$end;
      $6=$nextPtr;
      $7=$haveMore;
      var $8=$4;
      var $9=HEAP32[(($8)>>2)];
      $s=$9;
      var $10=$3;
      var $11=$2;
      var $12=(($11+144)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($10)|0)==(($13)|0);
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$2;
      var $17=(($16+288)|0);
      $eventPP=$17;
      var $18=$s;
      var $19=$eventPP;
      HEAP32[(($19)>>2)]=$18;
      var $20=$2;
      var $21=(($20+292)|0);
      $eventEndPP=$21;
      __label__ = 3; break;
    case 2: // $22
      var $23=$2;
      var $24=(($23+300)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0);
      $eventPP=$26;
      var $27=$2;
      var $28=(($27+300)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+4)|0);
      $eventEndPP=$30;
      __label__ = 3; break;
    case 3: // $31
      var $32=$s;
      var $33=$eventPP;
      HEAP32[(($33)>>2)]=$32;
      var $34=$4;
      HEAP32[(($34)>>2)]=0;
      var $35=$3;
      var $36=(($35)|0);
      var $37=(($36+12)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$3;
      var $40=$s;
      var $41=$5;
      var $42=FUNCTION_TABLE[$38]($39, $40, $41, $next);
      $tok=$42;
      var $43=HEAP32[(($next)>>2)];
      var $44=$eventEndPP;
      HEAP32[(($44)>>2)]=$43;
      var $45=$tok;
      if ($45 == 42) {
        __label__ = 4; break;
      }
      else if ($45 == 0) {
        __label__ = 9; break;
      }
      else if ($45 == -2) {
        __label__ = 10; break;
      }
      else if ($45 == -1 || $45 == -4) {
        __label__ = 13; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 4: // $46
      var $47=$2;
      var $48=(($47+80)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $51
      var $52=$2;
      var $53=$3;
      var $54=$s;
      var $55=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($52, $53, $54, $55);
      __label__ = 6; break;
    case 6: // $56
      var $57=HEAP32[(($next)>>2)];
      var $58=$4;
      HEAP32[(($58)>>2)]=$57;
      var $59=HEAP32[(($next)>>2)];
      var $60=$6;
      HEAP32[(($60)>>2)]=$59;
      var $61=$2;
      var $62=(($61+480)|0);
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)==2;
      if ($65) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $66
      $1=35;
      __label__ = 17; break;
    case 8: // $67
      $1=0;
      __label__ = 17; break;
    case 9: // $68
      var $69=HEAP32[(($next)>>2)];
      var $70=$eventPP;
      HEAP32[(($70)>>2)]=$69;
      $1=4;
      __label__ = 17; break;
    case 10: // $71
      var $72=$7;
      var $73=(($72 << 24) >> 24)!=0;
      if ($73) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $74
      var $75=$s;
      var $76=$6;
      HEAP32[(($76)>>2)]=$75;
      $1=0;
      __label__ = 17; break;
    case 12: // $77
      $1=6;
      __label__ = 17; break;
    case 13: // $78
      var $79=$7;
      var $80=(($79 << 24) >> 24)!=0;
      if ($80) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $81
      var $82=$s;
      var $83=$6;
      HEAP32[(($83)>>2)]=$82;
      $1=0;
      __label__ = 17; break;
    case 15: // $84
      $1=2;
      __label__ = 17; break;
    case 16: // $85
      var $86=HEAP32[(($next)>>2)];
      var $87=$eventPP;
      HEAP32[(($87)>>2)]=$86;
      $1=23;
      __label__ = 17; break;
    case 17: // $88
      var $89=$1;
      STACKTOP = __stackBase__;
      return $89;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15doIgnoreSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h["X"]=1;

function __ZL22ignoreSectionProcessorP16XML_ParserStructPKcS2_PS2_($parser, $start, $end, $endPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $result;
      $2=$parser;
      HEAP32[(($3)>>2)]=$start;
      $4=$end;
      $5=$endPtr;
      var $6=$2;
      var $7=$2;
      var $8=(($7+144)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$4;
      var $11=$5;
      var $12=$2;
      var $13=(($12+480)|0);
      var $14=(($13+4)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24)!=0;
      var $17=$16 ^ 1;
      var $18=(($17)&1);
      var $19=__ZL15doIgnoreSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h($6, $9, $3, $10, $11, $18);
      $result=$19;
      var $20=$result;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$result;
      $1=$23;
      __label__ = 5; break;
    case 2: // $24
      var $25=HEAP32[(($3)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $27
      var $28=$2;
      var $29=(($28+280)|0);
      HEAP32[(($29)>>2)]=1514;
      var $30=$2;
      var $31=HEAP32[(($3)>>2)];
      var $32=$4;
      var $33=$5;
      var $34=__ZL15prologProcessorP16XML_ParserStructPKcS2_PS2_($30, $31, $32, $33);
      $1=$34;
      __label__ = 5; break;
    case 4: // $35
      var $36=$result;
      $1=$36;
      __label__ = 5; break;
    case 5: // $37
      var $38=$1;
      STACKTOP = __stackBase__;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14normalizeLinesPc($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $p;
      $1=$s;
      __label__ = 1; break;
    case 1: // $2
      var $3=$1;
      var $4=HEAP8[($3)];
      var $5=(($4 << 24) >> 24);
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $7
      __label__ = 16; break;
    case 3: // $8
      var $9=$1;
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)==13;
      if ($12) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $13
      __label__ = 7; break;
    case 5: // $14
      __label__ = 6; break;
    case 6: // $15
      var $16=$1;
      var $17=(($16+1)|0);
      $1=$17;
      __label__ = 1; break;
    case 7: // $18
      var $19=$1;
      $p=$19;
      __label__ = 8; break;
    case 8: // $20
      var $21=$1;
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=(($23)|0)==13;
      if ($24) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $25
      var $26=$p;
      var $27=(($26+1)|0);
      $p=$27;
      HEAP8[($26)]=10;
      var $28=$1;
      var $29=(($28+1)|0);
      $1=$29;
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24);
      var $32=(($31)|0)==10;
      if ($32) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $33
      var $34=$1;
      var $35=(($34+1)|0);
      $1=$35;
      __label__ = 11; break;
    case 11: // $36
      __label__ = 13; break;
    case 12: // $37
      var $38=$1;
      var $39=(($38+1)|0);
      $1=$39;
      var $40=HEAP8[($38)];
      var $41=$p;
      var $42=(($41+1)|0);
      $p=$42;
      HEAP8[($41)]=$40;
      __label__ = 13; break;
    case 13: // $43
      __label__ = 14; break;
    case 14: // $44
      var $45=$1;
      var $46=HEAP8[($45)];
      var $47=(($46 << 24) >> 24)!=0;
      if ($47) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 15: // $48
      var $49=$p;
      HEAP8[($49)]=0;
      __label__ = 16; break;
    case 16: // $50
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14normalizeLinesPc["X"]=1;

function __ZL16nextScaffoldPartP16XML_ParserStruct($parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dtd;
      var $me;
      var $next;
      var $temp;
      var $parent;
      $2=$parser;
      var $3=$2;
      var $4=(($3+356)|0);
      var $5=HEAP32[(($4)>>2)];
      $dtd=$5;
      var $6=$dtd;
      var $7=(($6+184)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$2;
      var $12=(($11+12)|0);
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$2;
      var $16=(($15+468)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=((($17<<2))|0);
      var $19=FUNCTION_TABLE[$14]($18);
      var $20=$19;
      var $21=$dtd;
      var $22=(($21+184)|0);
      HEAP32[(($22)>>2)]=$20;
      var $23=$dtd;
      var $24=(($23+184)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $27
      $1=-1;
      __label__ = 20; break;
    case 3: // $28
      var $29=$dtd;
      var $30=(($29+184)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0);
      HEAP32[(($32)>>2)]=0;
      __label__ = 4; break;
    case 4: // $33
      var $34=$dtd;
      var $35=(($34+176)|0);
      var $36=HEAPU32[(($35)>>2)];
      var $37=$dtd;
      var $38=(($37+172)|0);
      var $39=HEAPU32[(($38)>>2)];
      var $40=(($36)>>>0) >= (($39)>>>0);
      if ($40) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $41
      var $42=$dtd;
      var $43=(($42+164)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $46
      var $47=$2;
      var $48=(($47+12)|0);
      var $49=(($48+4)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$dtd;
      var $52=(($51+164)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$53;
      var $55=$dtd;
      var $56=(($55+172)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=((($57<<1))|0);
      var $59=(($58*28)|0);
      var $60=FUNCTION_TABLE[$50]($54, $59);
      var $61=$60;
      $temp=$61;
      var $62=$temp;
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $64
      $1=-1;
      __label__ = 20; break;
    case 8: // $65
      var $66=$dtd;
      var $67=(($66+172)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=((($68<<1))|0);
      HEAP32[(($67)>>2)]=$69;
      __label__ = 12; break;
    case 9: // $70
      var $71=$2;
      var $72=(($71+12)|0);
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=FUNCTION_TABLE[$74](896);
      var $76=$75;
      $temp=$76;
      var $77=$temp;
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $79
      $1=-1;
      __label__ = 20; break;
    case 11: // $80
      var $81=$dtd;
      var $82=(($81+172)|0);
      HEAP32[(($82)>>2)]=32;
      __label__ = 12; break;
    case 12: // $83
      var $84=$temp;
      var $85=$dtd;
      var $86=(($85+164)|0);
      HEAP32[(($86)>>2)]=$84;
      __label__ = 13; break;
    case 13: // $87
      var $88=$dtd;
      var $89=(($88+176)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+1)|0);
      HEAP32[(($89)>>2)]=$91;
      $next=$90;
      var $92=$next;
      var $93=$dtd;
      var $94=(($93+164)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95+$92*28)|0);
      $me=$96;
      var $97=$dtd;
      var $98=(($97+180)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=(($99)|0)!=0;
      if ($100) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $101
      var $102=$dtd;
      var $103=(($102+180)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104-1)|0);
      var $106=$dtd;
      var $107=(($106+184)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+($105<<2))|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$dtd;
      var $112=(($111+164)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+$110*28)|0);
      $parent=$114;
      var $115=$parent;
      var $116=(($115+16)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $119
      var $120=$next;
      var $121=$parent;
      var $122=(($121+16)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$dtd;
      var $125=(($124+164)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+$123*28)|0);
      var $128=(($127+24)|0);
      HEAP32[(($128)>>2)]=$120;
      __label__ = 16; break;
    case 16: // $129
      var $130=$parent;
      var $131=(($130+20)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 18; break; } else { __label__ = 17; break; }
    case 17: // $134
      var $135=$next;
      var $136=$parent;
      var $137=(($136+12)|0);
      HEAP32[(($137)>>2)]=$135;
      __label__ = 18; break;
    case 18: // $138
      var $139=$next;
      var $140=$parent;
      var $141=(($140+16)|0);
      HEAP32[(($141)>>2)]=$139;
      var $142=$parent;
      var $143=(($142+20)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+1)|0);
      HEAP32[(($143)>>2)]=$145;
      __label__ = 19; break;
    case 19: // $146
      var $147=$me;
      var $148=(($147+24)|0);
      HEAP32[(($148)>>2)]=0;
      var $149=$me;
      var $150=(($149+20)|0);
      HEAP32[(($150)>>2)]=0;
      var $151=$me;
      var $152=(($151+16)|0);
      HEAP32[(($152)>>2)]=0;
      var $153=$me;
      var $154=(($153+12)|0);
      HEAP32[(($154)>>2)]=0;
      var $155=$next;
      $1=$155;
      __label__ = 20; break;
    case 20: // $156
      var $157=$1;
      ;
      return $157;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16nextScaffoldPartP16XML_ParserStruct["X"]=1;

function __ZL21processInternalEntityP16XML_ParserStructP6ENTITYh($parser, $entity, $betweenDecl) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $textStart;
      var $textEnd;
      var $next=__stackBase__;
      var $result;
      var $openEntity;
      var $tok;
      $2=$parser;
      $3=$entity;
      $4=$betweenDecl;
      var $5=$2;
      var $6=(($5+304)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10+304)|0);
      var $12=HEAP32[(($11)>>2)];
      $openEntity=$12;
      var $13=$openEntity;
      var $14=(($13+8)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($16+304)|0);
      HEAP32[(($17)>>2)]=$15;
      __label__ = 5; break;
    case 2: // $18
      var $19=$2;
      var $20=(($19+12)|0);
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=FUNCTION_TABLE[$22](24);
      var $24=$23;
      $openEntity=$24;
      var $25=$openEntity;
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $27
      $1=1;
      __label__ = 15; break;
    case 4: // $28
      __label__ = 5; break;
    case 5: // $29
      var $30=$3;
      var $31=(($30+32)|0);
      HEAP8[($31)]=1;
      var $32=$3;
      var $33=(($32+12)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=$2;
      var $35=(($34+300)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$openEntity;
      var $38=(($37+8)|0);
      HEAP32[(($38)>>2)]=$36;
      var $39=$openEntity;
      var $40=$2;
      var $41=(($40+300)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$3;
      var $43=$openEntity;
      var $44=(($43+12)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$2;
      var $46=(($45+312)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$openEntity;
      var $49=(($48+16)|0);
      HEAP32[(($49)>>2)]=$47;
      var $50=$4;
      var $51=$openEntity;
      var $52=(($51+20)|0);
      HEAP8[($52)]=$50;
      var $53=$openEntity;
      var $54=(($53)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=$openEntity;
      var $56=(($55+4)|0);
      HEAP32[(($56)>>2)]=0;
      var $57=$3;
      var $58=(($57+4)|0);
      var $59=HEAP32[(($58)>>2)];
      $textStart=$59;
      var $60=$3;
      var $61=(($60+4)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$3;
      var $64=(($63+8)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($62+$65)|0);
      $textEnd=$66;
      var $67=$3;
      var $68=(($67+33)|0);
      var $69=HEAP8[($68)];
      var $70=(($69 << 24) >> 24)!=0;
      if ($70) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $71
      var $72=$2;
      var $73=(($72+228)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0);
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$2;
      var $79=(($78+228)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$textStart;
      var $82=$textEnd;
      var $83=FUNCTION_TABLE[$77]($80, $81, $82, $next);
      $tok=$83;
      var $84=$2;
      var $85=$2;
      var $86=(($85+228)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$textStart;
      var $89=$textEnd;
      var $90=$tok;
      var $91=HEAP32[(($next)>>2)];
      var $92=__ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h($84, $87, $88, $89, $90, $91, $next, 0);
      $result=$92;
      __label__ = 8; break;
    case 7: // $93
      var $94=$2;
      var $95=$2;
      var $96=(($95+312)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$2;
      var $99=(($98+228)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$textStart;
      var $102=$textEnd;
      var $103=__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h($94, $97, $100, $101, $102, $next, 0);
      $result=$103;
      __label__ = 8; break;
    case 8: // $104
      var $105=$result;
      var $106=(($105)|0)==0;
      if ($106) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $107
      var $108=$textEnd;
      var $109=HEAP32[(($next)>>2)];
      var $110=(($108)|0)!=(($109)|0);
      if ($110) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $111
      var $112=$2;
      var $113=(($112+480)|0);
      var $114=(($113)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115)|0)==3;
      if ($116) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $117
      var $118=HEAP32[(($next)>>2)];
      var $119=$textStart;
      var $120=$118;
      var $121=$119;
      var $122=(($120-$121)|0);
      var $123=$3;
      var $124=(($123+12)|0);
      HEAP32[(($124)>>2)]=$122;
      var $125=$2;
      var $126=(($125+280)|0);
      HEAP32[(($126)>>2)]=1516;
      __label__ = 13; break;
    case 12: // $127
      var $128=$3;
      var $129=(($128+32)|0);
      HEAP8[($129)]=0;
      var $130=$openEntity;
      var $131=(($130+8)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$2;
      var $134=(($133+300)|0);
      HEAP32[(($134)>>2)]=$132;
      var $135=$2;
      var $136=(($135+304)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$openEntity;
      var $139=(($138+8)|0);
      HEAP32[(($139)>>2)]=$137;
      var $140=$openEntity;
      var $141=$2;
      var $142=(($141+304)|0);
      HEAP32[(($142)>>2)]=$140;
      __label__ = 13; break;
    case 13: // $143
      __label__ = 14; break;
    case 14: // $144
      var $145=$result;
      $1=$145;
      __label__ = 15; break;
    case 15: // $146
      var $147=$1;
      STACKTOP = __stackBase__;
      return $147;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21processInternalEntityP16XML_ParserStructP6ENTITYh["X"]=1;

function __ZL11build_modelP16XML_ParserStruct($parser) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dtd;
      var $ret;
      var $cpos=__stackBase__;
      var $str=__stackBase__+4;
      var $allocsize;
      $2=$parser;
      var $3=$2;
      var $4=(($3+356)|0);
      var $5=HEAP32[(($4)>>2)];
      $dtd=$5;
      var $6=$dtd;
      var $7=(($6+176)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8*20)|0);
      var $10=$dtd;
      var $11=(($10+168)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      var $14=(($9+$13)|0);
      $allocsize=$14;
      var $15=$2;
      var $16=(($15+12)|0);
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$allocsize;
      var $20=FUNCTION_TABLE[$18]($19);
      var $21=$20;
      $ret=$21;
      var $22=$ret;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $24
      $1=0;
      __label__ = 3; break;
    case 2: // $25
      var $26=$dtd;
      var $27=(($26+176)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$ret;
      var $30=(($29+$28*20)|0);
      var $31=$30;
      HEAP32[(($str)>>2)]=$31;
      var $32=$ret;
      var $33=(($32+20)|0);
      HEAP32[(($cpos)>>2)]=$33;
      var $34=$2;
      var $35=$ret;
      __ZL10build_nodeP16XML_ParserStructiP6XML_cpPS2_PPc($34, 0, $35, $cpos, $str);
      var $36=$ret;
      $1=$36;
      __label__ = 3; break;
    case 3: // $37
      var $38=$1;
      STACKTOP = __stackBase__;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11build_modelP16XML_ParserStruct["X"]=1;

function __ZL27reportProcessingInstructionP16XML_ParserStructPK8encodingPKcS5_($parser, $enc, $start, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $target;
      var $data;
      var $tem;
      $2=$parser;
      $3=$enc;
      $4=$start;
      $5=$end;
      var $6=$2;
      var $7=(($6+64)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$2;
      var $12=(($11+80)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$2;
      var $17=$3;
      var $18=$4;
      var $19=$5;
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($16, $17, $18, $19);
      __label__ = 3; break;
    case 3: // $20
      $1=1;
      __label__ = 9; break;
    case 4: // $21
      var $22=$3;
      var $23=(($22+68)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=((($24<<1))|0);
      var $26=$4;
      var $27=(($26+$25)|0);
      $4=$27;
      var $28=$4;
      var $29=$3;
      var $30=(($29+32)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$3;
      var $33=$4;
      var $34=FUNCTION_TABLE[$31]($32, $33);
      var $35=(($28+$34)|0);
      $tem=$35;
      var $36=$2;
      var $37=(($36+416)|0);
      var $38=$3;
      var $39=$4;
      var $40=$tem;
      var $41=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($37, $38, $39, $40);
      $target=$41;
      var $42=$target;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $44
      $1=0;
      __label__ = 9; break;
    case 6: // $45
      var $46=$2;
      var $47=(($46+416)|0);
      var $48=(($47+12)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$2;
      var $51=(($50+416)|0);
      var $52=(($51+16)|0);
      HEAP32[(($52)>>2)]=$49;
      var $53=$2;
      var $54=(($53+416)|0);
      var $55=$3;
      var $56=$3;
      var $57=(($56+36)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$3;
      var $60=$tem;
      var $61=FUNCTION_TABLE[$58]($59, $60);
      var $62=$5;
      var $63=$3;
      var $64=(($63+68)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=((($65<<1))|0);
      var $67=(((-$66))|0);
      var $68=(($62+$67)|0);
      var $69=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($54, $55, $61, $68);
      $data=$69;
      var $70=$data;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $72
      $1=0;
      __label__ = 9; break;
    case 8: // $73
      var $74=$data;
      __ZL14normalizeLinesPc($74);
      var $75=$2;
      var $76=(($75+64)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$2;
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$target;
      var $82=$data;
      FUNCTION_TABLE[$77]($80, $81, $82);
      var $83=$2;
      var $84=(($83+416)|0);
      __ZL9poolClearP11STRING_POOL($84);
      $1=1;
      __label__ = 9; break;
    case 9: // $85
      var $86=$1;
      ;
      return $86;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27reportProcessingInstructionP16XML_ParserStructPK8encodingPKcS5_["X"]=1;

function __ZL13reportCommentP16XML_ParserStructPK8encodingPKcS5_($parser, $enc, $start, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $data;
      $2=$parser;
      $3=$enc;
      $4=$start;
      $5=$end;
      var $6=$2;
      var $7=(($6+68)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$2;
      var $12=(($11+80)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$2;
      var $17=$3;
      var $18=$4;
      var $19=$5;
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($16, $17, $18, $19);
      __label__ = 3; break;
    case 3: // $20
      $1=1;
      __label__ = 7; break;
    case 4: // $21
      var $22=$2;
      var $23=(($22+416)|0);
      var $24=$3;
      var $25=$4;
      var $26=$3;
      var $27=(($26+68)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=((($28<<2))|0);
      var $30=(($25+$29)|0);
      var $31=$5;
      var $32=$3;
      var $33=(($32+68)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34*3)|0);
      var $36=(((-$35))|0);
      var $37=(($31+$36)|0);
      var $38=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($23, $24, $30, $37);
      $data=$38;
      var $39=$data;
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $41
      $1=0;
      __label__ = 7; break;
    case 6: // $42
      var $43=$data;
      __ZL14normalizeLinesPc($43);
      var $44=$2;
      var $45=(($44+68)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$2;
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$data;
      FUNCTION_TABLE[$46]($49, $50);
      var $51=$2;
      var $52=(($51+416)|0);
      __ZL9poolClearP11STRING_POOL($52);
      $1=1;
      __label__ = 7; break;
    case 7: // $53
      var $54=$1;
      ;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13reportCommentP16XML_ParserStructPK8encodingPKcS5_["X"]=1;

function __ZL10build_nodeP16XML_ParserStructiP6XML_cpPS2_PPc($parser, $src_node, $dest, $contpos, $strpos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $dtd;
      var $src;
      var $i;
      var $cn;
      $1=$parser;
      $2=$src_node;
      $3=$dest;
      $4=$contpos;
      $5=$strpos;
      var $6=$1;
      var $7=(($6+356)|0);
      var $8=HEAP32[(($7)>>2)];
      $dtd=$8;
      var $9=$2;
      var $10=$dtd;
      var $11=(($10+164)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+$9*28)|0);
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=(($16)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$2;
      var $19=$dtd;
      var $20=(($19+164)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+$18*28)|0);
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$3;
      var $26=(($25+4)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$3;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==4;
      if ($30) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $31
      var $32=$5;
      var $33=HEAP32[(($32)>>2)];
      var $34=$3;
      var $35=(($34+8)|0);
      HEAP32[(($35)>>2)]=$33;
      var $36=$2;
      var $37=$dtd;
      var $38=(($37+164)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39+$36*28)|0);
      var $41=(($40+8)|0);
      var $42=HEAP32[(($41)>>2)];
      $src=$42;
      __label__ = 2; break;
    case 2: // $43
      var $44=$src;
      var $45=HEAP8[($44)];
      var $46=$5;
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      HEAP8[($47)]=$45;
      var $49=$src;
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24)!=0;
      if ($51) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $52
      __label__ = 5; break;
    case 4: // $53
      var $54=$src;
      var $55=(($54+1)|0);
      $src=$55;
      __label__ = 2; break;
    case 5: // $56
      var $57=$3;
      var $58=(($57+12)|0);
      HEAP32[(($58)>>2)]=0;
      var $59=$3;
      var $60=(($59+16)|0);
      HEAP32[(($60)>>2)]=0;
      __label__ = 11; break;
    case 6: // $61
      var $62=$2;
      var $63=$dtd;
      var $64=(($63+164)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+$62*28)|0);
      var $67=(($66+20)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$3;
      var $70=(($69+12)|0);
      HEAP32[(($70)>>2)]=$68;
      var $71=$4;
      var $72=HEAP32[(($71)>>2)];
      var $73=$3;
      var $74=(($73+16)|0);
      HEAP32[(($74)>>2)]=$72;
      var $75=$3;
      var $76=(($75+12)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$4;
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79+$77*20)|0);
      HEAP32[(($78)>>2)]=$80;
      $i=0;
      var $81=$2;
      var $82=$dtd;
      var $83=(($82+164)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84+$81*28)|0);
      var $86=(($85+12)|0);
      var $87=HEAP32[(($86)>>2)];
      $cn=$87;
      __label__ = 7; break;
    case 7: // $88
      var $89=$i;
      var $90=$3;
      var $91=(($90+12)|0);
      var $92=HEAPU32[(($91)>>2)];
      var $93=(($89)>>>0) < (($92)>>>0);
      if ($93) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $94
      var $95=$1;
      var $96=$cn;
      var $97=$i;
      var $98=$3;
      var $99=(($98+16)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100+$97*20)|0);
      var $102=$4;
      var $103=$5;
      __ZL10build_nodeP16XML_ParserStructiP6XML_cpPS2_PPc($95, $96, $101, $102, $103);
      __label__ = 9; break;
    case 9: // $104
      var $105=$i;
      var $106=(($105+1)|0);
      $i=$106;
      var $107=$cn;
      var $108=$dtd;
      var $109=(($108+164)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+$107*28)|0);
      var $112=(($111+24)|0);
      var $113=HEAP32[(($112)>>2)];
      $cn=$113;
      __label__ = 7; break;
    case 10: // $114
      var $115=$3;
      var $116=(($115+8)|0);
      HEAP32[(($116)>>2)]=0;
      __label__ = 11; break;
    case 11: // $117
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10build_nodeP16XML_ParserStructiP6XML_cpPS2_PPc["X"]=1;

function __ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h($parser, $startTagLevel, $enc, $s, $end, $nextPtr, $haveMore) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $6;
      var $7;
      var $8;
      var $dtd;
      var $eventPP;
      var $eventEndPP;
      var $next=__stackBase__+4;
      var $tok;
      var $c=__stackBase__+8;
      var $name;
      var $entity;
      var $ch=__stackBase__+12;
      var $result;
      var $context;
      var $tag;
      var $result1;
      var $toPtr=__stackBase__+16;
      var $rawNameEnd;
      var $fromPtr=__stackBase__+20;
      var $bufSize;
      var $convLen;
      var $temp;
      var $rawName;
      var $result2;
      var $bindings=__stackBase__+24;
      var $noElmHandlers;
      var $name3=__stackBase__+28;
      var $b;
      var $len;
      var $rawName4;
      var $tag5;
      var $localPart;
      var $prefix;
      var $uri;
      var $b6;
      var $n;
      var $buf=__stackBase__+52;
      var $c7=__stackBase__+56;
      var $result8;
      var $dataPtr=__stackBase__+60;
      var $charDataHandler;
      var $dataPtr9=__stackBase__+64;
      $2=$parser;
      $3=$startTagLevel;
      $4=$enc;
      HEAP32[(($5)>>2)]=$s;
      $6=$end;
      $7=$nextPtr;
      $8=$haveMore;
      var $9=$2;
      var $10=(($9+356)|0);
      var $11=HEAP32[(($10)>>2)];
      $dtd=$11;
      var $12=$4;
      var $13=$2;
      var $14=(($13+144)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0)==(($15)|0);
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$2;
      var $19=(($18+288)|0);
      $eventPP=$19;
      var $20=$2;
      var $21=(($20+292)|0);
      $eventEndPP=$21;
      __label__ = 3; break;
    case 2: // $22
      var $23=$2;
      var $24=(($23+300)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0);
      $eventPP=$26;
      var $27=$2;
      var $28=(($27+300)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+4)|0);
      $eventEndPP=$30;
      __label__ = 3; break;
    case 3: // $31
      var $32=HEAP32[(($5)>>2)];
      var $33=$eventPP;
      HEAP32[(($33)>>2)]=$32;
      __label__ = 4; break;
    case 4: // $34
      var $35=HEAP32[(($5)>>2)];
      HEAP32[(($next)>>2)]=$35;
      var $36=$4;
      var $37=(($36)|0);
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$4;
      var $41=HEAP32[(($5)>>2)];
      var $42=$6;
      var $43=FUNCTION_TABLE[$39]($40, $41, $42, $next);
      $tok=$43;
      var $44=HEAP32[(($next)>>2)];
      var $45=$eventEndPP;
      HEAP32[(($45)>>2)]=$44;
      var $46=$tok;
      if ($46 == -3) {
        __label__ = 5; break;
      }
      else if ($46 == -4) {
        __label__ = 17; break;
      }
      else if ($46 == 0) {
        __label__ = 24; break;
      }
      else if ($46 == -1) {
        __label__ = 25; break;
      }
      else if ($46 == -2) {
        __label__ = 28; break;
      }
      else if ($46 == 9) {
        __label__ = 31; break;
      }
      else if ($46 == 2 || $46 == 1) {
        __label__ = 82; break;
      }
      else if ($46 == 4 || $46 == 3) {
        __label__ = 103; break;
      }
      else if ($46 == 5) {
        __label__ = 124; break;
      }
      else if ($46 == 10) {
        __label__ = 155; break;
      }
      else if ($46 == 12) {
        __label__ = 163; break;
      }
      else if ($46 == 7) {
        __label__ = 164; break;
      }
      else if ($46 == 8) {
        __label__ = 170; break;
      }
      else if ($46 == -5) {
        __label__ = 181; break;
      }
      else if ($46 == 6) {
        __label__ = 196; break;
      }
      else if ($46 == 11) {
        __label__ = 209; break;
      }
      else if ($46 == 13) {
        __label__ = 212; break;
      }
      else {
      __label__ = 215; break;
      }
      
    case 5: // $47
      var $48=$8;
      var $49=(($48 << 24) >> 24)!=0;
      if ($49) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $50
      var $51=HEAP32[(($5)>>2)];
      var $52=$7;
      HEAP32[(($52)>>2)]=$51;
      $1=0;
      __label__ = 223; break;
    case 7: // $53
      var $54=$6;
      var $55=$eventEndPP;
      HEAP32[(($55)>>2)]=$54;
      var $56=$2;
      var $57=(($56+60)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $60
      HEAP8[($c)]=10;
      var $61=$2;
      var $62=(($61+60)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$2;
      var $65=(($64+4)|0);
      var $66=HEAP32[(($65)>>2)];
      FUNCTION_TABLE[$63]($66, $c, 1);
      __label__ = 12; break;
    case 9: // $67
      var $68=$2;
      var $69=(($68+80)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $72
      var $73=$2;
      var $74=$4;
      var $75=HEAP32[(($5)>>2)];
      var $76=$6;
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($73, $74, $75, $76);
      __label__ = 11; break;
    case 11: // $77
      __label__ = 12; break;
    case 12: // $78
      var $79=$3;
      var $80=(($79)|0)==0;
      if ($80) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $81
      $1=3;
      __label__ = 223; break;
    case 14: // $82
      var $83=$2;
      var $84=(($83+312)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$3;
      var $87=(($85)|0)!=(($86)|0);
      if ($87) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $88
      $1=13;
      __label__ = 223; break;
    case 16: // $89
      var $90=$6;
      var $91=$7;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 223; break;
    case 17: // $92
      var $93=$8;
      var $94=(($93 << 24) >> 24)!=0;
      if ($94) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $95
      var $96=HEAP32[(($5)>>2)];
      var $97=$7;
      HEAP32[(($97)>>2)]=$96;
      $1=0;
      __label__ = 223; break;
    case 19: // $98
      var $99=$3;
      var $100=(($99)|0) > 0;
      if ($100) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $101
      var $102=$2;
      var $103=(($102+312)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$3;
      var $106=(($104)|0)!=(($105)|0);
      if ($106) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $107
      $1=13;
      __label__ = 223; break;
    case 22: // $108
      var $109=HEAP32[(($5)>>2)];
      var $110=$7;
      HEAP32[(($110)>>2)]=$109;
      $1=0;
      __label__ = 223; break;
    case 23: // $111
      $1=3;
      __label__ = 223; break;
    case 24: // $112
      var $113=HEAP32[(($next)>>2)];
      var $114=$eventPP;
      HEAP32[(($114)>>2)]=$113;
      $1=4;
      __label__ = 223; break;
    case 25: // $115
      var $116=$8;
      var $117=(($116 << 24) >> 24)!=0;
      if ($117) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $118
      var $119=HEAP32[(($5)>>2)];
      var $120=$7;
      HEAP32[(($120)>>2)]=$119;
      $1=0;
      __label__ = 223; break;
    case 27: // $121
      $1=5;
      __label__ = 223; break;
    case 28: // $122
      var $123=$8;
      var $124=(($123 << 24) >> 24)!=0;
      if ($124) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $125
      var $126=HEAP32[(($5)>>2)];
      var $127=$7;
      HEAP32[(($127)>>2)]=$126;
      $1=0;
      __label__ = 223; break;
    case 30: // $128
      $1=6;
      __label__ = 223; break;
    case 31: // $129
      var $130=$4;
      var $131=(($130+48)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$4;
      var $134=HEAP32[(($5)>>2)];
      var $135=$4;
      var $136=(($135+68)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($134+$137)|0);
      var $139=HEAP32[(($next)>>2)];
      var $140=$4;
      var $141=(($140+68)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(((-$142))|0);
      var $144=(($139+$143)|0);
      var $145=FUNCTION_TABLE[$132]($133, $138, $144);
      var $146=(($145) & 255);
      HEAP8[($ch)]=$146;
      var $147=HEAP8[($ch)];
      var $148=(($147 << 24) >> 24)!=0;
      if ($148) { __label__ = 32; break; } else { __label__ = 38; break; }
    case 32: // $149
      var $150=$2;
      var $151=(($150+60)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152)|0)!=0;
      if ($153) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $154
      var $155=$2;
      var $156=(($155+60)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$2;
      var $159=(($158+4)|0);
      var $160=HEAP32[(($159)>>2)];
      FUNCTION_TABLE[$157]($160, $ch, 1);
      __label__ = 37; break;
    case 34: // $161
      var $162=$2;
      var $163=(($162+80)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $166
      var $167=$2;
      var $168=$4;
      var $169=HEAP32[(($5)>>2)];
      var $170=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($167, $168, $169, $170);
      __label__ = 36; break;
    case 36: // $171
      __label__ = 37; break;
    case 37: // $172
      __label__ = 218; break;
    case 38: // $173
      var $174=$dtd;
      var $175=(($174+80)|0);
      var $176=$4;
      var $177=HEAP32[(($5)>>2)];
      var $178=$4;
      var $179=(($178+68)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($177+$180)|0);
      var $182=HEAP32[(($next)>>2)];
      var $183=$4;
      var $184=(($183+68)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=(((-$185))|0);
      var $187=(($182+$186)|0);
      var $188=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($175, $176, $181, $187);
      $name=$188;
      var $189=$name;
      var $190=(($189)|0)!=0;
      if ($190) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $191
      $1=1;
      __label__ = 223; break;
    case 40: // $192
      var $193=$dtd;
      var $194=(($193)|0);
      var $195=$name;
      var $196=__ZL6lookupP10HASH_TABLEPKcj($194, $195, 0);
      var $197=$196;
      $entity=$197;
      var $198=$dtd;
      var $199=(($198+80)|0);
      var $200=(($199+16)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=$dtd;
      var $203=(($202+80)|0);
      var $204=(($203+12)|0);
      HEAP32[(($204)>>2)]=$201;
      var $205=$dtd;
      var $206=(($205+129)|0);
      var $207=HEAP8[($206)];
      var $208=(($207 << 24) >> 24)!=0;
      if ($208) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $209
      var $210=$dtd;
      var $211=(($210+130)|0);
      var $212=HEAP8[($211)];
      var $213=(($212 << 24) >> 24)!=0;
      if ($213) { __label__ = 42; break; } else { __label__ = 48; break; }
    case 42: // $214
      var $215=$entity;
      var $216=(($215)|0)!=0;
      if ($216) { __label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $217
      $1=11;
      __label__ = 223; break;
    case 44: // $218
      var $219=$entity;
      var $220=(($219+34)|0);
      var $221=HEAP8[($220)];
      var $222=(($221 << 24) >> 24)!=0;
      if ($222) { __label__ = 46; break; } else { __label__ = 45; break; }
    case 45: // $223
      $1=24;
      __label__ = 223; break;
    case 46: // $224
      __label__ = 47; break;
    case 47: // $225
      __label__ = 56; break;
    case 48: // $226
      var $227=$entity;
      var $228=(($227)|0)!=0;
      if ($228) { __label__ = 55; break; } else { __label__ = 49; break; }
    case 49: // $229
      var $230=$2;
      var $231=(($230+120)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232)|0)!=0;
      if ($233) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $234
      var $235=$2;
      var $236=(($235+120)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=$2;
      var $239=(($238+4)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$name;
      FUNCTION_TABLE[$237]($240, $241, 0);
      __label__ = 54; break;
    case 51: // $242
      var $243=$2;
      var $244=(($243+80)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=(($245)|0)!=0;
      if ($246) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $247
      var $248=$2;
      var $249=$4;
      var $250=HEAP32[(($5)>>2)];
      var $251=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($248, $249, $250, $251);
      __label__ = 53; break;
    case 53: // $252
      __label__ = 54; break;
    case 54: // $253
      __label__ = 218; break;
    case 55: // $254
      __label__ = 56; break;
    case 56: // $255
      var $256=$entity;
      var $257=(($256+32)|0);
      var $258=HEAP8[($257)];
      var $259=(($258 << 24) >> 24)!=0;
      if ($259) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $260
      $1=12;
      __label__ = 223; break;
    case 58: // $261
      var $262=$entity;
      var $263=(($262+28)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(($264)|0)!=0;
      if ($265) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $266
      $1=15;
      __label__ = 223; break;
    case 60: // $267
      var $268=$entity;
      var $269=(($268+4)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($270)|0)!=0;
      if ($271) { __label__ = 61; break; } else { __label__ = 71; break; }
    case 61: // $272
      var $273=$2;
      var $274=(($273+308)|0);
      var $275=HEAP8[($274)];
      var $276=(($275 << 24) >> 24)!=0;
      if ($276) { __label__ = 68; break; } else { __label__ = 62; break; }
    case 62: // $277
      var $278=$2;
      var $279=(($278+120)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=(($280)|0)!=0;
      if ($281) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $282
      var $283=$2;
      var $284=(($283+120)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=$2;
      var $287=(($286+4)|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=$entity;
      var $290=(($289)|0);
      var $291=HEAP32[(($290)>>2)];
      FUNCTION_TABLE[$285]($288, $291, 0);
      __label__ = 67; break;
    case 64: // $292
      var $293=$2;
      var $294=(($293+80)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=(($295)|0)!=0;
      if ($296) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $297
      var $298=$2;
      var $299=$4;
      var $300=HEAP32[(($5)>>2)];
      var $301=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($298, $299, $300, $301);
      __label__ = 66; break;
    case 66: // $302
      __label__ = 67; break;
    case 67: // $303
      __label__ = 218; break;
    case 68: // $304
      var $305=$2;
      var $306=$entity;
      var $307=__ZL21processInternalEntityP16XML_ParserStructP6ENTITYh($305, $306, 0);
      $result=$307;
      var $308=$result;
      var $309=(($308)|0)!=0;
      if ($309) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $310
      var $311=$result;
      $1=$311;
      __label__ = 223; break;
    case 70: // $312
      __label__ = 81; break;
    case 71: // $313
      var $314=$2;
      var $315=(($314+112)|0);
      var $316=HEAP32[(($315)>>2)];
      var $317=(($316)|0)!=0;
      if ($317) { __label__ = 72; break; } else { __label__ = 77; break; }
    case 72: // $318
      var $319=$entity;
      var $320=(($319+32)|0);
      HEAP8[($320)]=1;
      var $321=$2;
      var $322=__ZL10getContextP16XML_ParserStruct($321);
      $context=$322;
      var $323=$entity;
      var $324=(($323+32)|0);
      HEAP8[($324)]=0;
      var $325=$context;
      var $326=(($325)|0)!=0;
      if ($326) { __label__ = 74; break; } else { __label__ = 73; break; }
    case 73: // $327
      $1=1;
      __label__ = 223; break;
    case 74: // $328
      var $329=$2;
      var $330=(($329+112)|0);
      var $331=HEAP32[(($330)>>2)];
      var $332=$2;
      var $333=(($332+116)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=$context;
      var $336=$entity;
      var $337=(($336+20)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=$entity;
      var $340=(($339+16)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$entity;
      var $343=(($342+24)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=FUNCTION_TABLE[$331]($334, $335, $338, $341, $344);
      var $346=(($345)|0)!=0;
      if ($346) { __label__ = 76; break; } else { __label__ = 75; break; }
    case 75: // $347
      $1=21;
      __label__ = 223; break;
    case 76: // $348
      var $349=$2;
      var $350=(($349+416)|0);
      var $351=(($350+16)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=$2;
      var $354=(($353+416)|0);
      var $355=(($354+12)|0);
      HEAP32[(($355)>>2)]=$352;
      __label__ = 80; break;
    case 77: // $356
      var $357=$2;
      var $358=(($357+80)|0);
      var $359=HEAP32[(($358)>>2)];
      var $360=(($359)|0)!=0;
      if ($360) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $361
      var $362=$2;
      var $363=$4;
      var $364=HEAP32[(($5)>>2)];
      var $365=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($362, $363, $364, $365);
      __label__ = 79; break;
    case 79: // $366
      __label__ = 80; break;
    case 80: // $367
      __label__ = 81; break;
    case 81: // $368
      __label__ = 218; break;
    case 82: // $369
      var $370=$2;
      var $371=(($370+368)|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=(($372)|0)!=0;
      if ($373) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $374
      var $375=$2;
      var $376=(($375+368)|0);
      var $377=HEAP32[(($376)>>2)];
      $tag=$377;
      var $378=$2;
      var $379=(($378+368)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=(($380)|0);
      var $382=HEAP32[(($381)>>2)];
      var $383=$2;
      var $384=(($383+368)|0);
      HEAP32[(($384)>>2)]=$382;
      __label__ = 89; break;
    case 84: // $385
      var $386=$2;
      var $387=(($386+12)|0);
      var $388=(($387)|0);
      var $389=HEAP32[(($388)>>2)];
      var $390=FUNCTION_TABLE[$389](48);
      var $391=$390;
      $tag=$391;
      var $392=$tag;
      var $393=(($392)|0)!=0;
      if ($393) { __label__ = 86; break; } else { __label__ = 85; break; }
    case 85: // $394
      $1=1;
      __label__ = 223; break;
    case 86: // $395
      var $396=$2;
      var $397=(($396+12)|0);
      var $398=(($397)|0);
      var $399=HEAP32[(($398)>>2)];
      var $400=FUNCTION_TABLE[$399](32);
      var $401=$tag;
      var $402=(($401+36)|0);
      HEAP32[(($402)>>2)]=$400;
      var $403=$tag;
      var $404=(($403+36)|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=(($405)|0)!=0;
      if ($406) { __label__ = 88; break; } else { __label__ = 87; break; }
    case 87: // $407
      var $408=$2;
      var $409=(($408+12)|0);
      var $410=(($409+8)|0);
      var $411=HEAP32[(($410)>>2)];
      var $412=$tag;
      var $413=$412;
      FUNCTION_TABLE[$411]($413);
      $1=1;
      __label__ = 223; break;
    case 88: // $414
      var $415=$tag;
      var $416=(($415+36)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=(($417+32)|0);
      var $419=$tag;
      var $420=(($419+40)|0);
      HEAP32[(($420)>>2)]=$418;
      __label__ = 89; break;
    case 89: // $421
      var $422=$tag;
      var $423=(($422+44)|0);
      HEAP32[(($423)>>2)]=0;
      var $424=$2;
      var $425=(($424+364)|0);
      var $426=HEAP32[(($425)>>2)];
      var $427=$tag;
      var $428=(($427)|0);
      HEAP32[(($428)>>2)]=$426;
      var $429=$tag;
      var $430=$2;
      var $431=(($430+364)|0);
      HEAP32[(($431)>>2)]=$429;
      var $432=$tag;
      var $433=(($432+12)|0);
      var $434=(($433+4)|0);
      HEAP32[(($434)>>2)]=0;
      var $435=$tag;
      var $436=(($435+12)|0);
      var $437=(($436+8)|0);
      HEAP32[(($437)>>2)]=0;
      var $438=HEAP32[(($5)>>2)];
      var $439=$4;
      var $440=(($439+68)|0);
      var $441=HEAP32[(($440)>>2)];
      var $442=(($438+$441)|0);
      var $443=$tag;
      var $444=(($443+4)|0);
      HEAP32[(($444)>>2)]=$442;
      var $445=$4;
      var $446=(($445+32)|0);
      var $447=HEAP32[(($446)>>2)];
      var $448=$4;
      var $449=$tag;
      var $450=(($449+4)|0);
      var $451=HEAP32[(($450)>>2)];
      var $452=FUNCTION_TABLE[$447]($448, $451);
      var $453=$tag;
      var $454=(($453+8)|0);
      HEAP32[(($454)>>2)]=$452;
      var $455=$2;
      var $456=(($455+312)|0);
      var $457=HEAP32[(($456)>>2)];
      var $458=(($457+1)|0);
      HEAP32[(($456)>>2)]=$458;
      var $459=$tag;
      var $460=(($459+4)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=$tag;
      var $463=(($462+8)|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=(($461+$464)|0);
      $rawNameEnd=$465;
      var $466=$tag;
      var $467=(($466+4)|0);
      var $468=HEAP32[(($467)>>2)];
      HEAP32[(($fromPtr)>>2)]=$468;
      var $469=$tag;
      var $470=(($469+36)|0);
      var $471=HEAP32[(($470)>>2)];
      HEAP32[(($toPtr)>>2)]=$471;
      __label__ = 90; break;
    case 90: // $472
      var $473=$4;
      var $474=(($473+60)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=$4;
      var $477=$rawNameEnd;
      var $478=$tag;
      var $479=(($478+40)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=(($480-1)|0);
      FUNCTION_TABLE[$475]($476, $fromPtr, $477, $toPtr, $481);
      var $482=HEAP32[(($toPtr)>>2)];
      var $483=$tag;
      var $484=(($483+36)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=$482;
      var $487=$485;
      var $488=(($486-$487)|0);
      $convLen=$488;
      var $489=HEAP32[(($fromPtr)>>2)];
      var $490=$rawNameEnd;
      var $491=(($489)|0)==(($490)|0);
      if ($491) { __label__ = 91; break; } else { __label__ = 92; break; }
    case 91: // $492
      var $493=$convLen;
      var $494=$tag;
      var $495=(($494+12)|0);
      var $496=(($495+12)|0);
      HEAP32[(($496)>>2)]=$493;
      __label__ = 95; break;
    case 92: // $497
      var $498=$tag;
      var $499=(($498+40)|0);
      var $500=HEAP32[(($499)>>2)];
      var $501=$tag;
      var $502=(($501+36)|0);
      var $503=HEAP32[(($502)>>2)];
      var $504=$500;
      var $505=$503;
      var $506=(($504-$505)|0);
      var $507=$506 << 1;
      $bufSize=$507;
      var $508=$2;
      var $509=(($508+12)|0);
      var $510=(($509+4)|0);
      var $511=HEAP32[(($510)>>2)];
      var $512=$tag;
      var $513=(($512+36)|0);
      var $514=HEAP32[(($513)>>2)];
      var $515=$bufSize;
      var $516=FUNCTION_TABLE[$511]($514, $515);
      $temp=$516;
      var $517=$temp;
      var $518=(($517)|0)==0;
      if ($518) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $519
      $1=1;
      __label__ = 223; break;
    case 94: // $520
      var $521=$temp;
      var $522=$tag;
      var $523=(($522+36)|0);
      HEAP32[(($523)>>2)]=$521;
      var $524=$temp;
      var $525=$bufSize;
      var $526=(($524+$525)|0);
      var $527=$tag;
      var $528=(($527+40)|0);
      HEAP32[(($528)>>2)]=$526;
      var $529=$temp;
      var $530=$convLen;
      var $531=(($529+$530)|0);
      HEAP32[(($toPtr)>>2)]=$531;
      __label__ = 90; break;
    case 95: // $532
      var $533=$tag;
      var $534=(($533+36)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$tag;
      var $537=(($536+12)|0);
      var $538=(($537)|0);
      HEAP32[(($538)>>2)]=$535;
      var $539=HEAP32[(($toPtr)>>2)];
      HEAP8[($539)]=0;
      var $540=$2;
      var $541=$4;
      var $542=HEAP32[(($5)>>2)];
      var $543=$tag;
      var $544=(($543+12)|0);
      var $545=$tag;
      var $546=(($545+44)|0);
      var $547=__ZL9storeAttsP16XML_ParserStructPK8encodingPKcP8TAG_NAMEPP7binding($540, $541, $542, $544, $546);
      $result1=$547;
      var $548=$result1;
      var $549=(($548)|0)!=0;
      if ($549) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $550
      var $551=$result1;
      $1=$551;
      __label__ = 223; break;
    case 97: // $552
      var $553=$2;
      var $554=(($553+52)|0);
      var $555=HEAP32[(($554)>>2)];
      var $556=(($555)|0)!=0;
      if ($556) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $557
      var $558=$2;
      var $559=(($558+52)|0);
      var $560=HEAP32[(($559)>>2)];
      var $561=$2;
      var $562=(($561+4)|0);
      var $563=HEAP32[(($562)>>2)];
      var $564=$tag;
      var $565=(($564+12)|0);
      var $566=(($565)|0);
      var $567=HEAP32[(($566)>>2)];
      var $568=$2;
      var $569=(($568+392)|0);
      var $570=HEAP32[(($569)>>2)];
      var $571=$570;
      FUNCTION_TABLE[$560]($563, $567, $571);
      __label__ = 102; break;
    case 99: // $572
      var $573=$2;
      var $574=(($573+80)|0);
      var $575=HEAP32[(($574)>>2)];
      var $576=(($575)|0)!=0;
      if ($576) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $577
      var $578=$2;
      var $579=$4;
      var $580=HEAP32[(($5)>>2)];
      var $581=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($578, $579, $580, $581);
      __label__ = 101; break;
    case 101: // $582
      __label__ = 102; break;
    case 102: // $583
      var $584=$2;
      var $585=(($584+416)|0);
      __ZL9poolClearP11STRING_POOL($585);
      __label__ = 218; break;
    case 103: // $586
      var $587=HEAP32[(($5)>>2)];
      var $588=$4;
      var $589=(($588+68)|0);
      var $590=HEAP32[(($589)>>2)];
      var $591=(($587+$590)|0);
      $rawName=$591;
      HEAP32[(($bindings)>>2)]=0;
      $noElmHandlers=1;
      var $592=$2;
      var $593=(($592+416)|0);
      var $594=$4;
      var $595=$rawName;
      var $596=$rawName;
      var $597=$4;
      var $598=(($597+32)|0);
      var $599=HEAP32[(($598)>>2)];
      var $600=$4;
      var $601=$rawName;
      var $602=FUNCTION_TABLE[$599]($600, $601);
      var $603=(($596+$602)|0);
      var $604=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($593, $594, $595, $603);
      var $605=(($name3)|0);
      HEAP32[(($605)>>2)]=$604;
      var $606=(($name3)|0);
      var $607=HEAP32[(($606)>>2)];
      var $608=(($607)|0)!=0;
      if ($608) { __label__ = 105; break; } else { __label__ = 104; break; }
    case 104: // $609
      $1=1;
      __label__ = 223; break;
    case 105: // $610
      var $611=$2;
      var $612=(($611+416)|0);
      var $613=(($612+12)|0);
      var $614=HEAP32[(($613)>>2)];
      var $615=$2;
      var $616=(($615+416)|0);
      var $617=(($616+16)|0);
      HEAP32[(($617)>>2)]=$614;
      var $618=$2;
      var $619=$4;
      var $620=HEAP32[(($5)>>2)];
      var $621=__ZL9storeAttsP16XML_ParserStructPK8encodingPKcP8TAG_NAMEPP7binding($618, $619, $620, $name3, $bindings);
      $result2=$621;
      var $622=$result2;
      var $623=(($622)|0)!=0;
      if ($623) { __label__ = 106; break; } else { __label__ = 107; break; }
    case 106: // $624
      var $625=$result2;
      $1=$625;
      __label__ = 223; break;
    case 107: // $626
      var $627=$2;
      var $628=(($627+416)|0);
      var $629=(($628+12)|0);
      var $630=HEAP32[(($629)>>2)];
      var $631=$2;
      var $632=(($631+416)|0);
      var $633=(($632+16)|0);
      HEAP32[(($633)>>2)]=$630;
      var $634=$2;
      var $635=(($634+52)|0);
      var $636=HEAP32[(($635)>>2)];
      var $637=(($636)|0)!=0;
      if ($637) { __label__ = 108; break; } else { __label__ = 109; break; }
    case 108: // $638
      var $639=$2;
      var $640=(($639+52)|0);
      var $641=HEAP32[(($640)>>2)];
      var $642=$2;
      var $643=(($642+4)|0);
      var $644=HEAP32[(($643)>>2)];
      var $645=(($name3)|0);
      var $646=HEAP32[(($645)>>2)];
      var $647=$2;
      var $648=(($647+392)|0);
      var $649=HEAP32[(($648)>>2)];
      var $650=$649;
      FUNCTION_TABLE[$641]($644, $646, $650);
      $noElmHandlers=0;
      __label__ = 109; break;
    case 109: // $651
      var $652=$2;
      var $653=(($652+56)|0);
      var $654=HEAP32[(($653)>>2)];
      var $655=(($654)|0)!=0;
      if ($655) { __label__ = 110; break; } else { __label__ = 113; break; }
    case 110: // $656
      var $657=$2;
      var $658=(($657+52)|0);
      var $659=HEAP32[(($658)>>2)];
      var $660=(($659)|0)!=0;
      if ($660) { __label__ = 111; break; } else { __label__ = 112; break; }
    case 111: // $661
      var $662=$eventEndPP;
      var $663=HEAP32[(($662)>>2)];
      var $664=$eventPP;
      HEAP32[(($664)>>2)]=$663;
      __label__ = 112; break;
    case 112: // $665
      var $666=$2;
      var $667=(($666+56)|0);
      var $668=HEAP32[(($667)>>2)];
      var $669=$2;
      var $670=(($669+4)|0);
      var $671=HEAP32[(($670)>>2)];
      var $672=(($name3)|0);
      var $673=HEAP32[(($672)>>2)];
      FUNCTION_TABLE[$668]($671, $673);
      $noElmHandlers=0;
      __label__ = 113; break;
    case 113: // $674
      var $675=$noElmHandlers;
      var $676=(($675 << 24) >> 24)!=0;
      if ($676) { __label__ = 114; break; } else { __label__ = 116; break; }
    case 114: // $677
      var $678=$2;
      var $679=(($678+80)|0);
      var $680=HEAP32[(($679)>>2)];
      var $681=(($680)|0)!=0;
      if ($681) { __label__ = 115; break; } else { __label__ = 116; break; }
    case 115: // $682
      var $683=$2;
      var $684=$4;
      var $685=HEAP32[(($5)>>2)];
      var $686=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($683, $684, $685, $686);
      __label__ = 116; break;
    case 116: // $687
      var $688=$2;
      var $689=(($688+416)|0);
      __ZL9poolClearP11STRING_POOL($689);
      __label__ = 117; break;
    case 117: // $690
      var $691=HEAP32[(($bindings)>>2)];
      var $692=(($691)|0)!=0;
      if ($692) { __label__ = 118; break; } else { __label__ = 121; break; }
    case 118: // $693
      var $694=HEAP32[(($bindings)>>2)];
      $b=$694;
      var $695=$2;
      var $696=(($695+104)|0);
      var $697=HEAP32[(($696)>>2)];
      var $698=(($697)|0)!=0;
      if ($698) { __label__ = 119; break; } else { __label__ = 120; break; }
    case 119: // $699
      var $700=$2;
      var $701=(($700+104)|0);
      var $702=HEAP32[(($701)>>2)];
      var $703=$2;
      var $704=(($703+4)|0);
      var $705=HEAP32[(($704)>>2)];
      var $706=$b;
      var $707=(($706)|0);
      var $708=HEAP32[(($707)>>2)];
      var $709=(($708)|0);
      var $710=HEAP32[(($709)>>2)];
      FUNCTION_TABLE[$702]($705, $710);
      __label__ = 120; break;
    case 120: // $711
      var $712=HEAP32[(($bindings)>>2)];
      var $713=(($712+4)|0);
      var $714=HEAP32[(($713)>>2)];
      HEAP32[(($bindings)>>2)]=$714;
      var $715=$2;
      var $716=(($715+376)|0);
      var $717=HEAP32[(($716)>>2)];
      var $718=$b;
      var $719=(($718+4)|0);
      HEAP32[(($719)>>2)]=$717;
      var $720=$b;
      var $721=$2;
      var $722=(($721+376)|0);
      HEAP32[(($722)>>2)]=$720;
      var $723=$b;
      var $724=(($723+8)|0);
      var $725=HEAP32[(($724)>>2)];
      var $726=$b;
      var $727=(($726)|0);
      var $728=HEAP32[(($727)>>2)];
      var $729=(($728+4)|0);
      HEAP32[(($729)>>2)]=$725;
      __label__ = 117; break;
    case 121: // $730
      var $731=$2;
      var $732=(($731+312)|0);
      var $733=HEAP32[(($732)>>2)];
      var $734=(($733)|0)==0;
      if ($734) { __label__ = 122; break; } else { __label__ = 123; break; }
    case 122: // $735
      var $736=$2;
      var $737=HEAP32[(($next)>>2)];
      var $738=$6;
      var $739=$7;
      var $740=__ZL15epilogProcessorP16XML_ParserStructPKcS2_PS2_($736, $737, $738, $739);
      $1=$740;
      __label__ = 223; break;
    case 123: // $741
      __label__ = 218; break;
    case 124: // $742
      var $743=$2;
      var $744=(($743+312)|0);
      var $745=HEAP32[(($744)>>2)];
      var $746=$3;
      var $747=(($745)|0)==(($746)|0);
      if ($747) { __label__ = 125; break; } else { __label__ = 126; break; }
    case 125: // $748
      $1=13;
      __label__ = 223; break;
    case 126: // $749
      var $750=$2;
      var $751=(($750+364)|0);
      var $752=HEAP32[(($751)>>2)];
      $tag5=$752;
      var $753=$tag5;
      var $754=(($753)|0);
      var $755=HEAP32[(($754)>>2)];
      var $756=$2;
      var $757=(($756+364)|0);
      HEAP32[(($757)>>2)]=$755;
      var $758=$2;
      var $759=(($758+368)|0);
      var $760=HEAP32[(($759)>>2)];
      var $761=$tag5;
      var $762=(($761)|0);
      HEAP32[(($762)>>2)]=$760;
      var $763=$tag5;
      var $764=$2;
      var $765=(($764+368)|0);
      HEAP32[(($765)>>2)]=$763;
      var $766=HEAP32[(($5)>>2)];
      var $767=$4;
      var $768=(($767+68)|0);
      var $769=HEAP32[(($768)>>2)];
      var $770=((($769<<1))|0);
      var $771=(($766+$770)|0);
      $rawName4=$771;
      var $772=$4;
      var $773=(($772+32)|0);
      var $774=HEAP32[(($773)>>2)];
      var $775=$4;
      var $776=$rawName4;
      var $777=FUNCTION_TABLE[$774]($775, $776);
      $len=$777;
      var $778=$len;
      var $779=$tag5;
      var $780=(($779+8)|0);
      var $781=HEAP32[(($780)>>2)];
      var $782=(($778)|0)!=(($781)|0);
      if ($782) { __label__ = 128; break; } else { __label__ = 127; break; }
    case 127: // $783
      var $784=$tag5;
      var $785=(($784+4)|0);
      var $786=HEAP32[(($785)>>2)];
      var $787=$rawName4;
      var $788=$len;
      var $789=_memcmp($786, $787, $788);
      var $790=(($789)|0)!=0;
      if ($790) { __label__ = 128; break; } else { __label__ = 129; break; }
    case 128: // $791
      var $792=$rawName4;
      var $793=$eventPP;
      HEAP32[(($793)>>2)]=$792;
      $1=7;
      __label__ = 223; break;
    case 129: // $794
      var $795=$2;
      var $796=(($795+312)|0);
      var $797=HEAP32[(($796)>>2)];
      var $798=(($797-1)|0);
      HEAP32[(($796)>>2)]=$798;
      var $799=$2;
      var $800=(($799+56)|0);
      var $801=HEAP32[(($800)>>2)];
      var $802=(($801)|0)!=0;
      if ($802) { __label__ = 130; break; } else { __label__ = 143; break; }
    case 130: // $803
      var $804=$tag5;
      var $805=(($804+12)|0);
      var $806=(($805+4)|0);
      var $807=HEAP32[(($806)>>2)];
      $localPart=$807;
      var $808=$2;
      var $809=(($808+236)|0);
      var $810=HEAP8[($809)];
      var $811=(($810 << 24) >> 24)!=0;
      if ($811) { __label__ = 131; break; } else { __label__ = 142; break; }
    case 131: // $812
      var $813=$localPart;
      var $814=(($813)|0)!=0;
      if ($814) { __label__ = 132; break; } else { __label__ = 142; break; }
    case 132: // $815
      var $816=$tag5;
      var $817=(($816+12)|0);
      var $818=(($817)|0);
      var $819=HEAP32[(($818)>>2)];
      var $820=$tag5;
      var $821=(($820+12)|0);
      var $822=(($821+16)|0);
      var $823=HEAP32[(($822)>>2)];
      var $824=(($819+$823)|0);
      $uri=$824;
      __label__ = 133; break;
    case 133: // $825
      var $826=$localPart;
      var $827=HEAP8[($826)];
      var $828=(($827 << 24) >> 24)!=0;
      if ($828) { __label__ = 134; break; } else { __label__ = 135; break; }
    case 134: // $829
      var $830=$localPart;
      var $831=(($830+1)|0);
      $localPart=$831;
      var $832=HEAP8[($830)];
      var $833=$uri;
      var $834=(($833+1)|0);
      $uri=$834;
      HEAP8[($833)]=$832;
      __label__ = 133; break;
    case 135: // $835
      var $836=$tag5;
      var $837=(($836+12)|0);
      var $838=(($837+8)|0);
      var $839=HEAP32[(($838)>>2)];
      $prefix=$839;
      var $840=$2;
      var $841=(($840+237)|0);
      var $842=HEAP8[($841)];
      var $843=(($842 << 24) >> 24)!=0;
      if ($843) { __label__ = 136; break; } else { __label__ = 141; break; }
    case 136: // $844
      var $845=$prefix;
      var $846=(($845)|0)!=0;
      if ($846) { __label__ = 137; break; } else { __label__ = 141; break; }
    case 137: // $847
      var $848=$2;
      var $849=(($848+472)|0);
      var $850=HEAP8[($849)];
      var $851=$uri;
      var $852=(($851+1)|0);
      $uri=$852;
      HEAP8[($851)]=$850;
      __label__ = 138; break;
    case 138: // $853
      var $854=$prefix;
      var $855=HEAP8[($854)];
      var $856=(($855 << 24) >> 24)!=0;
      if ($856) { __label__ = 139; break; } else { __label__ = 140; break; }
    case 139: // $857
      var $858=$prefix;
      var $859=(($858+1)|0);
      $prefix=$859;
      var $860=HEAP8[($858)];
      var $861=$uri;
      var $862=(($861+1)|0);
      $uri=$862;
      HEAP8[($861)]=$860;
      __label__ = 138; break;
    case 140: // $863
      __label__ = 141; break;
    case 141: // $864
      var $865=$uri;
      HEAP8[($865)]=0;
      __label__ = 142; break;
    case 142: // $866
      var $867=$2;
      var $868=(($867+56)|0);
      var $869=HEAP32[(($868)>>2)];
      var $870=$2;
      var $871=(($870+4)|0);
      var $872=HEAP32[(($871)>>2)];
      var $873=$tag5;
      var $874=(($873+12)|0);
      var $875=(($874)|0);
      var $876=HEAP32[(($875)>>2)];
      FUNCTION_TABLE[$869]($872, $876);
      __label__ = 146; break;
    case 143: // $877
      var $878=$2;
      var $879=(($878+80)|0);
      var $880=HEAP32[(($879)>>2)];
      var $881=(($880)|0)!=0;
      if ($881) { __label__ = 144; break; } else { __label__ = 145; break; }
    case 144: // $882
      var $883=$2;
      var $884=$4;
      var $885=HEAP32[(($5)>>2)];
      var $886=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($883, $884, $885, $886);
      __label__ = 145; break;
    case 145: // $887
      __label__ = 146; break;
    case 146: // $888
      __label__ = 147; break;
    case 147: // $889
      var $890=$tag5;
      var $891=(($890+44)|0);
      var $892=HEAP32[(($891)>>2)];
      var $893=(($892)|0)!=0;
      if ($893) { __label__ = 148; break; } else { __label__ = 151; break; }
    case 148: // $894
      var $895=$tag5;
      var $896=(($895+44)|0);
      var $897=HEAP32[(($896)>>2)];
      $b6=$897;
      var $898=$2;
      var $899=(($898+104)|0);
      var $900=HEAP32[(($899)>>2)];
      var $901=(($900)|0)!=0;
      if ($901) { __label__ = 149; break; } else { __label__ = 150; break; }
    case 149: // $902
      var $903=$2;
      var $904=(($903+104)|0);
      var $905=HEAP32[(($904)>>2)];
      var $906=$2;
      var $907=(($906+4)|0);
      var $908=HEAP32[(($907)>>2)];
      var $909=$b6;
      var $910=(($909)|0);
      var $911=HEAP32[(($910)>>2)];
      var $912=(($911)|0);
      var $913=HEAP32[(($912)>>2)];
      FUNCTION_TABLE[$905]($908, $913);
      __label__ = 150; break;
    case 150: // $914
      var $915=$tag5;
      var $916=(($915+44)|0);
      var $917=HEAP32[(($916)>>2)];
      var $918=(($917+4)|0);
      var $919=HEAP32[(($918)>>2)];
      var $920=$tag5;
      var $921=(($920+44)|0);
      HEAP32[(($921)>>2)]=$919;
      var $922=$2;
      var $923=(($922+376)|0);
      var $924=HEAP32[(($923)>>2)];
      var $925=$b6;
      var $926=(($925+4)|0);
      HEAP32[(($926)>>2)]=$924;
      var $927=$b6;
      var $928=$2;
      var $929=(($928+376)|0);
      HEAP32[(($929)>>2)]=$927;
      var $930=$b6;
      var $931=(($930+8)|0);
      var $932=HEAP32[(($931)>>2)];
      var $933=$b6;
      var $934=(($933)|0);
      var $935=HEAP32[(($934)>>2)];
      var $936=(($935+4)|0);
      HEAP32[(($936)>>2)]=$932;
      __label__ = 147; break;
    case 151: // $937
      var $938=$2;
      var $939=(($938+312)|0);
      var $940=HEAP32[(($939)>>2)];
      var $941=(($940)|0)==0;
      if ($941) { __label__ = 152; break; } else { __label__ = 153; break; }
    case 152: // $942
      var $943=$2;
      var $944=HEAP32[(($next)>>2)];
      var $945=$6;
      var $946=$7;
      var $947=__ZL15epilogProcessorP16XML_ParserStructPKcS2_PS2_($943, $944, $945, $946);
      $1=$947;
      __label__ = 223; break;
    case 153: // $948
      __label__ = 154; break;
    case 154: // $949
      __label__ = 218; break;
    case 155: // $950
      var $951=$4;
      var $952=(($951+44)|0);
      var $953=HEAP32[(($952)>>2)];
      var $954=$4;
      var $955=HEAP32[(($5)>>2)];
      var $956=FUNCTION_TABLE[$953]($954, $955);
      $n=$956;
      var $957=$n;
      var $958=(($957)|0) < 0;
      if ($958) { __label__ = 156; break; } else { __label__ = 157; break; }
    case 156: // $959
      $1=14;
      __label__ = 223; break;
    case 157: // $960
      var $961=$2;
      var $962=(($961+60)|0);
      var $963=HEAP32[(($962)>>2)];
      var $964=(($963)|0)!=0;
      if ($964) { __label__ = 158; break; } else { __label__ = 159; break; }
    case 158: // $965
      var $966=$2;
      var $967=(($966+60)|0);
      var $968=HEAP32[(($967)>>2)];
      var $969=$2;
      var $970=(($969+4)|0);
      var $971=HEAP32[(($970)>>2)];
      var $972=(($buf)|0);
      var $973=$n;
      var $974=(($buf)|0);
      var $975=_XmlUtf8Encode($973, $974);
      FUNCTION_TABLE[$968]($971, $972, $975);
      __label__ = 162; break;
    case 159: // $976
      var $977=$2;
      var $978=(($977+80)|0);
      var $979=HEAP32[(($978)>>2)];
      var $980=(($979)|0)!=0;
      if ($980) { __label__ = 160; break; } else { __label__ = 161; break; }
    case 160: // $981
      var $982=$2;
      var $983=$4;
      var $984=HEAP32[(($5)>>2)];
      var $985=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($982, $983, $984, $985);
      __label__ = 161; break;
    case 161: // $986
      __label__ = 162; break;
    case 162: // $987
      __label__ = 218; break;
    case 163: // $988
      $1=17;
      __label__ = 223; break;
    case 164: // $989
      var $990=$2;
      var $991=(($990+60)|0);
      var $992=HEAP32[(($991)>>2)];
      var $993=(($992)|0)!=0;
      if ($993) { __label__ = 165; break; } else { __label__ = 166; break; }
    case 165: // $994
      HEAP8[($c7)]=10;
      var $995=$2;
      var $996=(($995+60)|0);
      var $997=HEAP32[(($996)>>2)];
      var $998=$2;
      var $999=(($998+4)|0);
      var $1000=HEAP32[(($999)>>2)];
      FUNCTION_TABLE[$997]($1000, $c7, 1);
      __label__ = 169; break;
    case 166: // $1001
      var $1002=$2;
      var $1003=(($1002+80)|0);
      var $1004=HEAP32[(($1003)>>2)];
      var $1005=(($1004)|0)!=0;
      if ($1005) { __label__ = 167; break; } else { __label__ = 168; break; }
    case 167: // $1006
      var $1007=$2;
      var $1008=$4;
      var $1009=HEAP32[(($5)>>2)];
      var $1010=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($1007, $1008, $1009, $1010);
      __label__ = 168; break;
    case 168: // $1011
      __label__ = 169; break;
    case 169: // $1012
      __label__ = 218; break;
    case 170: // $1013
      var $1014=$2;
      var $1015=(($1014+72)|0);
      var $1016=HEAP32[(($1015)>>2)];
      var $1017=(($1016)|0)!=0;
      if ($1017) { __label__ = 171; break; } else { __label__ = 172; break; }
    case 171: // $1018
      var $1019=$2;
      var $1020=(($1019+72)|0);
      var $1021=HEAP32[(($1020)>>2)];
      var $1022=$2;
      var $1023=(($1022+4)|0);
      var $1024=HEAP32[(($1023)>>2)];
      FUNCTION_TABLE[$1021]($1024);
      __label__ = 175; break;
    case 172: // $1025
      var $1026=$2;
      var $1027=(($1026+80)|0);
      var $1028=HEAP32[(($1027)>>2)];
      var $1029=(($1028)|0)!=0;
      if ($1029) { __label__ = 173; break; } else { __label__ = 174; break; }
    case 173: // $1030
      var $1031=$2;
      var $1032=$4;
      var $1033=HEAP32[(($5)>>2)];
      var $1034=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($1031, $1032, $1033, $1034);
      __label__ = 174; break;
    case 174: // $1035
      __label__ = 175; break;
    case 175: // $1036
      var $1037=$2;
      var $1038=$4;
      var $1039=$6;
      var $1040=$7;
      var $1041=$8;
      var $1042=__ZL14doCdataSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h($1037, $1038, $next, $1039, $1040, $1041);
      $result8=$1042;
      var $1043=$result8;
      var $1044=(($1043)|0)!=0;
      if ($1044) { __label__ = 176; break; } else { __label__ = 177; break; }
    case 176: // $1045
      var $1046=$result8;
      $1=$1046;
      __label__ = 223; break;
    case 177: // $1047
      var $1048=HEAP32[(($next)>>2)];
      var $1049=(($1048)|0)!=0;
      if ($1049) { __label__ = 179; break; } else { __label__ = 178; break; }
    case 178: // $1050
      var $1051=$2;
      var $1052=(($1051+280)|0);
      HEAP32[(($1052)>>2)]=1518;
      var $1053=$result8;
      $1=$1053;
      __label__ = 223; break;
    case 179: // $1054
      __label__ = 180; break;
    case 180: // $1055
      __label__ = 218; break;
    case 181: // $1056
      var $1057=$8;
      var $1058=(($1057 << 24) >> 24)!=0;
      if ($1058) { __label__ = 182; break; } else { __label__ = 183; break; }
    case 182: // $1059
      var $1060=HEAP32[(($5)>>2)];
      var $1061=$7;
      HEAP32[(($1061)>>2)]=$1060;
      $1=0;
      __label__ = 223; break;
    case 183: // $1062
      var $1063=$2;
      var $1064=(($1063+60)|0);
      var $1065=HEAP32[(($1064)>>2)];
      var $1066=(($1065)|0)!=0;
      if ($1066) { __label__ = 184; break; } else { __label__ = 188; break; }
    case 184: // $1067
      var $1068=$4;
      var $1069=(($1068+72)|0);
      var $1070=HEAP8[($1069)];
      var $1071=(($1070 << 24) >> 24)!=0;
      if ($1071) { __label__ = 186; break; } else { __label__ = 185; break; }
    case 185: // $1072
      var $1073=$2;
      var $1074=(($1073+44)|0);
      var $1075=HEAP32[(($1074)>>2)];
      HEAP32[(($dataPtr)>>2)]=$1075;
      var $1076=$4;
      var $1077=(($1076+60)|0);
      var $1078=HEAP32[(($1077)>>2)];
      var $1079=$4;
      var $1080=$6;
      var $1081=$2;
      var $1082=(($1081+48)|0);
      var $1083=HEAP32[(($1082)>>2)];
      FUNCTION_TABLE[$1078]($1079, $5, $1080, $dataPtr, $1083);
      var $1084=$2;
      var $1085=(($1084+60)|0);
      var $1086=HEAP32[(($1085)>>2)];
      var $1087=$2;
      var $1088=(($1087+4)|0);
      var $1089=HEAP32[(($1088)>>2)];
      var $1090=$2;
      var $1091=(($1090+44)|0);
      var $1092=HEAP32[(($1091)>>2)];
      var $1093=HEAP32[(($dataPtr)>>2)];
      var $1094=$2;
      var $1095=(($1094+44)|0);
      var $1096=HEAP32[(($1095)>>2)];
      var $1097=$1093;
      var $1098=$1096;
      var $1099=(($1097-$1098)|0);
      FUNCTION_TABLE[$1086]($1089, $1092, $1099);
      __label__ = 187; break;
    case 186: // $1100
      var $1101=$2;
      var $1102=(($1101+60)|0);
      var $1103=HEAP32[(($1102)>>2)];
      var $1104=$2;
      var $1105=(($1104+4)|0);
      var $1106=HEAP32[(($1105)>>2)];
      var $1107=HEAP32[(($5)>>2)];
      var $1108=$6;
      var $1109=HEAP32[(($5)>>2)];
      var $1110=$1108;
      var $1111=$1109;
      var $1112=(($1110-$1111)|0);
      FUNCTION_TABLE[$1103]($1106, $1107, $1112);
      __label__ = 187; break;
    case 187: // $1113
      __label__ = 191; break;
    case 188: // $1114
      var $1115=$2;
      var $1116=(($1115+80)|0);
      var $1117=HEAP32[(($1116)>>2)];
      var $1118=(($1117)|0)!=0;
      if ($1118) { __label__ = 189; break; } else { __label__ = 190; break; }
    case 189: // $1119
      var $1120=$2;
      var $1121=$4;
      var $1122=HEAP32[(($5)>>2)];
      var $1123=$6;
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($1120, $1121, $1122, $1123);
      __label__ = 190; break;
    case 190: // $1124
      __label__ = 191; break;
    case 191: // $1125
      var $1126=$3;
      var $1127=(($1126)|0)==0;
      if ($1127) { __label__ = 192; break; } else { __label__ = 193; break; }
    case 192: // $1128
      var $1129=$6;
      var $1130=$eventPP;
      HEAP32[(($1130)>>2)]=$1129;
      $1=3;
      __label__ = 223; break;
    case 193: // $1131
      var $1132=$2;
      var $1133=(($1132+312)|0);
      var $1134=HEAP32[(($1133)>>2)];
      var $1135=$3;
      var $1136=(($1134)|0)!=(($1135)|0);
      if ($1136) { __label__ = 194; break; } else { __label__ = 195; break; }
    case 194: // $1137
      var $1138=$6;
      var $1139=$eventPP;
      HEAP32[(($1139)>>2)]=$1138;
      $1=13;
      __label__ = 223; break;
    case 195: // $1140
      var $1141=$6;
      var $1142=$7;
      HEAP32[(($1142)>>2)]=$1141;
      $1=0;
      __label__ = 223; break;
    case 196: // $1143
      var $1144=$2;
      var $1145=(($1144+60)|0);
      var $1146=HEAP32[(($1145)>>2)];
      $charDataHandler=$1146;
      var $1147=$charDataHandler;
      var $1148=(($1147)|0)!=0;
      if ($1148) { __label__ = 197; break; } else { __label__ = 205; break; }
    case 197: // $1149
      var $1150=$4;
      var $1151=(($1150+72)|0);
      var $1152=HEAP8[($1151)];
      var $1153=(($1152 << 24) >> 24)!=0;
      if ($1153) { __label__ = 203; break; } else { __label__ = 198; break; }
    case 198: // $1154
      __label__ = 199; break;
    case 199: // $1155
      var $1156=$2;
      var $1157=(($1156+44)|0);
      var $1158=HEAP32[(($1157)>>2)];
      HEAP32[(($dataPtr9)>>2)]=$1158;
      var $1159=$4;
      var $1160=(($1159+60)|0);
      var $1161=HEAP32[(($1160)>>2)];
      var $1162=$4;
      var $1163=HEAP32[(($next)>>2)];
      var $1164=$2;
      var $1165=(($1164+48)|0);
      var $1166=HEAP32[(($1165)>>2)];
      FUNCTION_TABLE[$1161]($1162, $5, $1163, $dataPtr9, $1166);
      var $1167=HEAP32[(($5)>>2)];
      var $1168=$eventEndPP;
      HEAP32[(($1168)>>2)]=$1167;
      var $1169=$charDataHandler;
      var $1170=$2;
      var $1171=(($1170+4)|0);
      var $1172=HEAP32[(($1171)>>2)];
      var $1173=$2;
      var $1174=(($1173+44)|0);
      var $1175=HEAP32[(($1174)>>2)];
      var $1176=HEAP32[(($dataPtr9)>>2)];
      var $1177=$2;
      var $1178=(($1177+44)|0);
      var $1179=HEAP32[(($1178)>>2)];
      var $1180=$1176;
      var $1181=$1179;
      var $1182=(($1180-$1181)|0);
      FUNCTION_TABLE[$1169]($1172, $1175, $1182);
      var $1183=HEAP32[(($5)>>2)];
      var $1184=HEAP32[(($next)>>2)];
      var $1185=(($1183)|0)==(($1184)|0);
      if ($1185) { __label__ = 200; break; } else { __label__ = 201; break; }
    case 200: // $1186
      __label__ = 202; break;
    case 201: // $1187
      var $1188=HEAP32[(($5)>>2)];
      var $1189=$eventPP;
      HEAP32[(($1189)>>2)]=$1188;
      __label__ = 199; break;
    case 202: // $1190
      __label__ = 204; break;
    case 203: // $1191
      var $1192=$charDataHandler;
      var $1193=$2;
      var $1194=(($1193+4)|0);
      var $1195=HEAP32[(($1194)>>2)];
      var $1196=HEAP32[(($5)>>2)];
      var $1197=HEAP32[(($next)>>2)];
      var $1198=HEAP32[(($5)>>2)];
      var $1199=$1197;
      var $1200=$1198;
      var $1201=(($1199-$1200)|0);
      FUNCTION_TABLE[$1192]($1195, $1196, $1201);
      __label__ = 204; break;
    case 204: // $1202
      __label__ = 208; break;
    case 205: // $1203
      var $1204=$2;
      var $1205=(($1204+80)|0);
      var $1206=HEAP32[(($1205)>>2)];
      var $1207=(($1206)|0)!=0;
      if ($1207) { __label__ = 206; break; } else { __label__ = 207; break; }
    case 206: // $1208
      var $1209=$2;
      var $1210=$4;
      var $1211=HEAP32[(($5)>>2)];
      var $1212=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($1209, $1210, $1211, $1212);
      __label__ = 207; break;
    case 207: // $1213
      __label__ = 208; break;
    case 208: // $1214
      __label__ = 218; break;
    case 209: // $1215
      var $1216=$2;
      var $1217=$4;
      var $1218=HEAP32[(($5)>>2)];
      var $1219=HEAP32[(($next)>>2)];
      var $1220=__ZL27reportProcessingInstructionP16XML_ParserStructPK8encodingPKcS5_($1216, $1217, $1218, $1219);
      var $1221=(($1220)|0)!=0;
      if ($1221) { __label__ = 211; break; } else { __label__ = 210; break; }
    case 210: // $1222
      $1=1;
      __label__ = 223; break;
    case 211: // $1223
      __label__ = 218; break;
    case 212: // $1224
      var $1225=$2;
      var $1226=$4;
      var $1227=HEAP32[(($5)>>2)];
      var $1228=HEAP32[(($next)>>2)];
      var $1229=__ZL13reportCommentP16XML_ParserStructPK8encodingPKcS5_($1225, $1226, $1227, $1228);
      var $1230=(($1229)|0)!=0;
      if ($1230) { __label__ = 214; break; } else { __label__ = 213; break; }
    case 213: // $1231
      $1=1;
      __label__ = 223; break;
    case 214: // $1232
      __label__ = 218; break;
    case 215: // $1233
      var $1234=$2;
      var $1235=(($1234+80)|0);
      var $1236=HEAP32[(($1235)>>2)];
      var $1237=(($1236)|0)!=0;
      if ($1237) { __label__ = 216; break; } else { __label__ = 217; break; }
    case 216: // $1238
      var $1239=$2;
      var $1240=$4;
      var $1241=HEAP32[(($5)>>2)];
      var $1242=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($1239, $1240, $1241, $1242);
      __label__ = 217; break;
    case 217: // $1243
      __label__ = 218; break;
    case 218: // $1244
      var $1245=HEAP32[(($next)>>2)];
      HEAP32[(($5)>>2)]=$1245;
      var $1246=$eventPP;
      HEAP32[(($1246)>>2)]=$1245;
      var $1247=$2;
      var $1248=(($1247+480)|0);
      var $1249=(($1248)|0);
      var $1250=HEAP32[(($1249)>>2)];
      if ($1250 == 3) {
        __label__ = 219; break;
      }
      else if ($1250 == 2) {
        __label__ = 220; break;
      }
      else {
      __label__ = 221; break;
      }
      
    case 219: // $1251
      var $1252=HEAP32[(($next)>>2)];
      var $1253=$7;
      HEAP32[(($1253)>>2)]=$1252;
      $1=0;
      __label__ = 223; break;
    case 220: // $1254
      $1=35;
      __label__ = 223; break;
    case 221: // $1255
      __label__ = 222; break;
    case 222: // $1256
      __label__ = 4; break;
    case 223: // $1257
      var $1258=$1;
      STACKTOP = __stackBase__;
      return $1258;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h["X"]=1;

function __ZL23internalEntityProcessorP16XML_ParserStructPKcS2_PS2_($parser, $s, $end, $nextPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $entity;
      var $textStart;
      var $textEnd;
      var $next=__stackBase__;
      var $result;
      var $openEntity;
      var $tok;
      var $tok1;
      $2=$parser;
      $3=$s;
      $4=$end;
      $5=$nextPtr;
      var $6=$2;
      var $7=(($6+300)|0);
      var $8=HEAP32[(($7)>>2)];
      $openEntity=$8;
      var $9=$openEntity;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $11
      $1=23;
      __label__ = 15; break;
    case 2: // $12
      var $13=$openEntity;
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      $entity=$15;
      var $16=$entity;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$entity;
      var $20=(($19+12)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($18+$21)|0);
      $textStart=$22;
      var $23=$entity;
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$entity;
      var $27=(($26+8)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($25+$28)|0);
      $textEnd=$29;
      var $30=$entity;
      var $31=(($30+33)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24)!=0;
      if ($33) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $34
      var $35=$2;
      var $36=(($35+228)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0);
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$2;
      var $42=(($41+228)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$textStart;
      var $45=$textEnd;
      var $46=FUNCTION_TABLE[$40]($43, $44, $45, $next);
      $tok=$46;
      var $47=$2;
      var $48=$2;
      var $49=(($48+228)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$textStart;
      var $52=$textEnd;
      var $53=$tok;
      var $54=HEAP32[(($next)>>2)];
      var $55=__ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h($47, $50, $51, $52, $53, $54, $next, 0);
      $result=$55;
      __label__ = 5; break;
    case 4: // $56
      var $57=$2;
      var $58=$openEntity;
      var $59=(($58+16)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$2;
      var $62=(($61+228)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$textStart;
      var $65=$textEnd;
      var $66=__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h($57, $60, $63, $64, $65, $next, 0);
      $result=$66;
      __label__ = 5; break;
    case 5: // $67
      var $68=$result;
      var $69=(($68)|0)!=0;
      if ($69) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $70
      var $71=$result;
      $1=$71;
      __label__ = 15; break;
    case 7: // $72
      var $73=$textEnd;
      var $74=HEAP32[(($next)>>2)];
      var $75=(($73)|0)!=(($74)|0);
      if ($75) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $76
      var $77=$2;
      var $78=(($77+480)|0);
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)==3;
      if ($81) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $82
      var $83=HEAP32[(($next)>>2)];
      var $84=$entity;
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$83;
      var $88=$86;
      var $89=(($87-$88)|0);
      var $90=$entity;
      var $91=(($90+12)|0);
      HEAP32[(($91)>>2)]=$89;
      var $92=$result;
      $1=$92;
      __label__ = 15; break;
    case 10: // $93
      var $94=$entity;
      var $95=(($94+32)|0);
      HEAP8[($95)]=0;
      var $96=$openEntity;
      var $97=(($96+8)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$2;
      var $100=(($99+300)|0);
      HEAP32[(($100)>>2)]=$98;
      var $101=$2;
      var $102=(($101+304)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$openEntity;
      var $105=(($104+8)|0);
      HEAP32[(($105)>>2)]=$103;
      var $106=$openEntity;
      var $107=$2;
      var $108=(($107+304)|0);
      HEAP32[(($108)>>2)]=$106;
      __label__ = 11; break;
    case 11: // $109
      __label__ = 12; break;
    case 12: // $110
      var $111=$entity;
      var $112=(($111+33)|0);
      var $113=HEAP8[($112)];
      var $114=(($113 << 24) >> 24)!=0;
      if ($114) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $115
      var $116=$2;
      var $117=(($116+280)|0);
      HEAP32[(($117)>>2)]=1514;
      var $118=$2;
      var $119=(($118+144)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120)|0);
      var $122=(($121)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=$2;
      var $125=(($124+144)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=$3;
      var $128=$4;
      var $129=FUNCTION_TABLE[$123]($126, $127, $128, $next);
      $tok1=$129;
      var $130=$2;
      var $131=$2;
      var $132=(($131+144)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$3;
      var $135=$4;
      var $136=$tok1;
      var $137=HEAP32[(($next)>>2)];
      var $138=$5;
      var $139=$2;
      var $140=(($139+480)|0);
      var $141=(($140+4)|0);
      var $142=HEAP8[($141)];
      var $143=(($142 << 24) >> 24)!=0;
      var $144=$143 ^ 1;
      var $145=(($144)&1);
      var $146=__ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h($130, $133, $134, $135, $136, $137, $138, $145);
      $1=$146;
      __label__ = 15; break;
    case 14: // $147
      var $148=$2;
      var $149=(($148+280)|0);
      HEAP32[(($149)>>2)]=1506;
      var $150=$2;
      var $151=$2;
      var $152=(($151+476)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153)|0)!=0;
      var $155=$154 ? 1 : 0;
      var $156=$2;
      var $157=(($156+144)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$3;
      var $160=$4;
      var $161=$5;
      var $162=$2;
      var $163=(($162+480)|0);
      var $164=(($163+4)|0);
      var $165=HEAP8[($164)];
      var $166=(($165 << 24) >> 24)!=0;
      var $167=$166 ^ 1;
      var $168=(($167)&1);
      var $169=__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h($150, $155, $158, $159, $160, $161, $168);
      $1=$169;
      __label__ = 15; break;
    case 15: // $170
      var $171=$1;
      STACKTOP = __stackBase__;
      return $171;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23internalEntityProcessorP16XML_ParserStructPKcS2_PS2_["X"]=1;

function __ZL10getContextP16XML_ParserStruct($parser) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $dtd;
      var $iter=__stackBase__;
      var $needSep;
      var $i;
      var $len;
      var $i1;
      var $len2;
      var $s;
      var $prefix;
      var $s3;
      var $e;
      $2=$parser;
      var $3=$2;
      var $4=(($3+356)|0);
      var $5=HEAP32[(($4)>>2)];
      $dtd=$5;
      $needSep=0;
      var $6=$dtd;
      var $7=(($6+152)|0);
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $11
      var $12=$2;
      var $13=(($12+416)|0);
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($16+416)|0);
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($15)|0)==(($19)|0);
      if ($20) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $22=$2;
      var $23=(($22+416)|0);
      var $24=__ZL8poolGrowP11STRING_POOL($23);
      var $25=(($24 << 24) >> 24)!=0;
      if ($25) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $26
      var $34 = 0;__label__ = 5; break;
    case 4: // $27
      var $28=$2;
      var $29=(($28+416)|0);
      var $30=(($29+12)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+1)|0);
      HEAP32[(($30)>>2)]=$32;
      HEAP8[($31)]=61;
      var $34 = 1;__label__ = 5; break;
    case 5: // $33
      var $34;
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $36
      $1=0;
      __label__ = 91; break;
    case 7: // $37
      var $38=$dtd;
      var $39=(($38+152)|0);
      var $40=(($39+4)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+20)|0);
      var $43=HEAP32[(($42)>>2)];
      $len=$43;
      var $44=$2;
      var $45=(($44+472)|0);
      var $46=HEAP8[($45)];
      var $47=(($46 << 24) >> 24)!=0;
      if ($47) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $48
      var $49=$len;
      var $50=(($49-1)|0);
      $len=$50;
      __label__ = 9; break;
    case 9: // $51
      $i=0;
      __label__ = 10; break;
    case 10: // $52
      var $53=$i;
      var $54=$len;
      var $55=(($53)|0) < (($54)|0);
      if ($55) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $56
      var $57=$2;
      var $58=(($57+416)|0);
      var $59=(($58+12)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$2;
      var $62=(($61+416)|0);
      var $63=(($62+8)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($60)|0)==(($64)|0);
      if ($65) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $66
      var $67=$2;
      var $68=(($67+416)|0);
      var $69=__ZL8poolGrowP11STRING_POOL($68);
      var $70=(($69 << 24) >> 24)!=0;
      if ($70) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $71
      var $88 = 0;__label__ = 15; break;
    case 14: // $72
      var $73=$i;
      var $74=$dtd;
      var $75=(($74+152)|0);
      var $76=(($75+4)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77+16)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79+$73)|0);
      var $81=HEAP8[($80)];
      var $82=$2;
      var $83=(($82+416)|0);
      var $84=(($83+12)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85+1)|0);
      HEAP32[(($84)>>2)]=$86;
      HEAP8[($85)]=$81;
      var $88 = 1;__label__ = 15; break;
    case 15: // $87
      var $88;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $90
      $1=0;
      __label__ = 91; break;
    case 17: // $91
      __label__ = 18; break;
    case 18: // $92
      var $93=$i;
      var $94=(($93+1)|0);
      $i=$94;
      __label__ = 10; break;
    case 19: // $95
      $needSep=1;
      __label__ = 20; break;
    case 20: // $96
      var $97=$dtd;
      var $98=(($97+60)|0);
      __ZL17hashTableIterInitP15HASH_TABLE_ITERPK10HASH_TABLE($iter, $98);
      __label__ = 21; break;
    case 21: // $99
      var $100=__ZL17hashTableIterNextP15HASH_TABLE_ITER($iter);
      var $101=$100;
      $prefix=$101;
      var $102=$prefix;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $104
      __label__ = 61; break;
    case 23: // $105
      var $106=$prefix;
      var $107=(($106+4)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108)|0)!=0;
      if ($109) { __label__ = 25; break; } else { __label__ = 24; break; }
    case 24: // $110
      __label__ = 21; break;
    case 25: // $111
      var $112=$needSep;
      var $113=(($112 << 24) >> 24)!=0;
      if ($113) { __label__ = 26; break; } else { __label__ = 32; break; }
    case 26: // $114
      var $115=$2;
      var $116=(($115+416)|0);
      var $117=(($116+12)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$2;
      var $120=(($119+416)|0);
      var $121=(($120+8)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($118)|0)==(($122)|0);
      if ($123) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $124
      var $125=$2;
      var $126=(($125+416)|0);
      var $127=__ZL8poolGrowP11STRING_POOL($126);
      var $128=(($127 << 24) >> 24)!=0;
      if ($128) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $129
      var $137 = 0;__label__ = 30; break;
    case 29: // $130
      var $131=$2;
      var $132=(($131+416)|0);
      var $133=(($132+12)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+1)|0);
      HEAP32[(($133)>>2)]=$135;
      HEAP8[($134)]=12;
      var $137 = 1;__label__ = 30; break;
    case 30: // $136
      var $137;
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $139
      $1=0;
      __label__ = 91; break;
    case 32: // $140
      var $141=$prefix;
      var $142=(($141)|0);
      var $143=HEAP32[(($142)>>2)];
      $s=$143;
      __label__ = 33; break;
    case 33: // $144
      var $145=$s;
      var $146=HEAP8[($145)];
      var $147=(($146 << 24) >> 24)!=0;
      if ($147) { __label__ = 34; break; } else { __label__ = 42; break; }
    case 34: // $148
      var $149=$2;
      var $150=(($149+416)|0);
      var $151=(($150+12)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$2;
      var $154=(($153+416)|0);
      var $155=(($154+8)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($152)|0)==(($156)|0);
      if ($157) { __label__ = 35; break; } else { __label__ = 37; break; }
    case 35: // $158
      var $159=$2;
      var $160=(($159+416)|0);
      var $161=__ZL8poolGrowP11STRING_POOL($160);
      var $162=(($161 << 24) >> 24)!=0;
      if ($162) { __label__ = 37; break; } else { __label__ = 36; break; }
    case 36: // $163
      var $173 = 0;__label__ = 38; break;
    case 37: // $164
      var $165=$s;
      var $166=HEAP8[($165)];
      var $167=$2;
      var $168=(($167+416)|0);
      var $169=(($168+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($170+1)|0);
      HEAP32[(($169)>>2)]=$171;
      HEAP8[($170)]=$166;
      var $173 = 1;__label__ = 38; break;
    case 38: // $172
      var $173;
      var $174=(($173)|0)!=0;
      if ($174) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $175
      $1=0;
      __label__ = 91; break;
    case 40: // $176
      __label__ = 41; break;
    case 41: // $177
      var $178=$s;
      var $179=(($178+1)|0);
      $s=$179;
      __label__ = 33; break;
    case 42: // $180
      var $181=$2;
      var $182=(($181+416)|0);
      var $183=(($182+12)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$2;
      var $186=(($185+416)|0);
      var $187=(($186+8)|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=(($184)|0)==(($188)|0);
      if ($189) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $190
      var $191=$2;
      var $192=(($191+416)|0);
      var $193=__ZL8poolGrowP11STRING_POOL($192);
      var $194=(($193 << 24) >> 24)!=0;
      if ($194) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $195
      var $203 = 0;__label__ = 46; break;
    case 45: // $196
      var $197=$2;
      var $198=(($197+416)|0);
      var $199=(($198+12)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+1)|0);
      HEAP32[(($199)>>2)]=$201;
      HEAP8[($200)]=61;
      var $203 = 1;__label__ = 46; break;
    case 46: // $202
      var $203;
      var $204=(($203)|0)!=0;
      if ($204) { __label__ = 48; break; } else { __label__ = 47; break; }
    case 47: // $205
      $1=0;
      __label__ = 91; break;
    case 48: // $206
      var $207=$prefix;
      var $208=(($207+4)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=(($209+20)|0);
      var $211=HEAP32[(($210)>>2)];
      $len2=$211;
      var $212=$2;
      var $213=(($212+472)|0);
      var $214=HEAP8[($213)];
      var $215=(($214 << 24) >> 24)!=0;
      if ($215) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $216
      var $217=$len2;
      var $218=(($217-1)|0);
      $len2=$218;
      __label__ = 50; break;
    case 50: // $219
      $i1=0;
      __label__ = 51; break;
    case 51: // $220
      var $221=$i1;
      var $222=$len2;
      var $223=(($221)|0) < (($222)|0);
      if ($223) { __label__ = 52; break; } else { __label__ = 60; break; }
    case 52: // $224
      var $225=$2;
      var $226=(($225+416)|0);
      var $227=(($226+12)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$2;
      var $230=(($229+416)|0);
      var $231=(($230+8)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=(($228)|0)==(($232)|0);
      if ($233) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $234
      var $235=$2;
      var $236=(($235+416)|0);
      var $237=__ZL8poolGrowP11STRING_POOL($236);
      var $238=(($237 << 24) >> 24)!=0;
      if ($238) { __label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $239
      var $255 = 0;__label__ = 56; break;
    case 55: // $240
      var $241=$i1;
      var $242=$prefix;
      var $243=(($242+4)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=(($244+16)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246+$241)|0);
      var $248=HEAP8[($247)];
      var $249=$2;
      var $250=(($249+416)|0);
      var $251=(($250+12)|0);
      var $252=HEAP32[(($251)>>2)];
      var $253=(($252+1)|0);
      HEAP32[(($251)>>2)]=$253;
      HEAP8[($252)]=$248;
      var $255 = 1;__label__ = 56; break;
    case 56: // $254
      var $255;
      var $256=(($255)|0)!=0;
      if ($256) { __label__ = 58; break; } else { __label__ = 57; break; }
    case 57: // $257
      $1=0;
      __label__ = 91; break;
    case 58: // $258
      __label__ = 59; break;
    case 59: // $259
      var $260=$i1;
      var $261=(($260+1)|0);
      $i1=$261;
      __label__ = 51; break;
    case 60: // $262
      $needSep=1;
      __label__ = 21; break;
    case 61: // $263
      var $264=$dtd;
      var $265=(($264)|0);
      __ZL17hashTableIterInitP15HASH_TABLE_ITERPK10HASH_TABLE($iter, $265);
      __label__ = 62; break;
    case 62: // $266
      var $267=__ZL17hashTableIterNextP15HASH_TABLE_ITER($iter);
      var $268=$267;
      $e=$268;
      var $269=$e;
      var $270=(($269)|0)!=0;
      if ($270) { __label__ = 64; break; } else { __label__ = 63; break; }
    case 63: // $271
      __label__ = 84; break;
    case 64: // $272
      var $273=$e;
      var $274=(($273+32)|0);
      var $275=HEAP8[($274)];
      var $276=(($275 << 24) >> 24)!=0;
      if ($276) { __label__ = 66; break; } else { __label__ = 65; break; }
    case 65: // $277
      __label__ = 62; break;
    case 66: // $278
      var $279=$needSep;
      var $280=(($279 << 24) >> 24)!=0;
      if ($280) { __label__ = 67; break; } else { __label__ = 73; break; }
    case 67: // $281
      var $282=$2;
      var $283=(($282+416)|0);
      var $284=(($283+12)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=$2;
      var $287=(($286+416)|0);
      var $288=(($287+8)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=(($285)|0)==(($289)|0);
      if ($290) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $291
      var $292=$2;
      var $293=(($292+416)|0);
      var $294=__ZL8poolGrowP11STRING_POOL($293);
      var $295=(($294 << 24) >> 24)!=0;
      if ($295) { __label__ = 70; break; } else { __label__ = 69; break; }
    case 69: // $296
      var $304 = 0;__label__ = 71; break;
    case 70: // $297
      var $298=$2;
      var $299=(($298+416)|0);
      var $300=(($299+12)|0);
      var $301=HEAP32[(($300)>>2)];
      var $302=(($301+1)|0);
      HEAP32[(($300)>>2)]=$302;
      HEAP8[($301)]=12;
      var $304 = 1;__label__ = 71; break;
    case 71: // $303
      var $304;
      var $305=(($304)|0)!=0;
      if ($305) { __label__ = 73; break; } else { __label__ = 72; break; }
    case 72: // $306
      $1=0;
      __label__ = 91; break;
    case 73: // $307
      var $308=$e;
      var $309=(($308)|0);
      var $310=HEAP32[(($309)>>2)];
      $s3=$310;
      __label__ = 74; break;
    case 74: // $311
      var $312=$s3;
      var $313=HEAP8[($312)];
      var $314=(($313 << 24) >> 24)!=0;
      if ($314) { __label__ = 75; break; } else { __label__ = 83; break; }
    case 75: // $315
      var $316=$2;
      var $317=(($316+416)|0);
      var $318=(($317+12)|0);
      var $319=HEAP32[(($318)>>2)];
      var $320=$2;
      var $321=(($320+416)|0);
      var $322=(($321+8)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=(($319)|0)==(($323)|0);
      if ($324) { __label__ = 76; break; } else { __label__ = 78; break; }
    case 76: // $325
      var $326=$2;
      var $327=(($326+416)|0);
      var $328=__ZL8poolGrowP11STRING_POOL($327);
      var $329=(($328 << 24) >> 24)!=0;
      if ($329) { __label__ = 78; break; } else { __label__ = 77; break; }
    case 77: // $330
      var $340 = 0;__label__ = 79; break;
    case 78: // $331
      var $332=$s3;
      var $333=HEAP8[($332)];
      var $334=$2;
      var $335=(($334+416)|0);
      var $336=(($335+12)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=(($337+1)|0);
      HEAP32[(($336)>>2)]=$338;
      HEAP8[($337)]=$333;
      var $340 = 1;__label__ = 79; break;
    case 79: // $339
      var $340;
      var $341=(($340)|0)!=0;
      if ($341) { __label__ = 81; break; } else { __label__ = 80; break; }
    case 80: // $342
      $1=0;
      __label__ = 91; break;
    case 81: // $343
      __label__ = 82; break;
    case 82: // $344
      var $345=$s3;
      var $346=(($345+1)|0);
      $s3=$346;
      __label__ = 74; break;
    case 83: // $347
      $needSep=1;
      __label__ = 62; break;
    case 84: // $348
      var $349=$2;
      var $350=(($349+416)|0);
      var $351=(($350+12)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=$2;
      var $354=(($353+416)|0);
      var $355=(($354+8)|0);
      var $356=HEAP32[(($355)>>2)];
      var $357=(($352)|0)==(($356)|0);
      if ($357) { __label__ = 85; break; } else { __label__ = 87; break; }
    case 85: // $358
      var $359=$2;
      var $360=(($359+416)|0);
      var $361=__ZL8poolGrowP11STRING_POOL($360);
      var $362=(($361 << 24) >> 24)!=0;
      if ($362) { __label__ = 87; break; } else { __label__ = 86; break; }
    case 86: // $363
      var $371 = 0;__label__ = 88; break;
    case 87: // $364
      var $365=$2;
      var $366=(($365+416)|0);
      var $367=(($366+12)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=(($368+1)|0);
      HEAP32[(($367)>>2)]=$369;
      HEAP8[($368)]=0;
      var $371 = 1;__label__ = 88; break;
    case 88: // $370
      var $371;
      var $372=(($371)|0)!=0;
      if ($372) { __label__ = 90; break; } else { __label__ = 89; break; }
    case 89: // $373
      $1=0;
      __label__ = 91; break;
    case 90: // $374
      var $375=$2;
      var $376=(($375+416)|0);
      var $377=(($376+16)|0);
      var $378=HEAP32[(($377)>>2)];
      $1=$378;
      __label__ = 91; break;
    case 91: // $379
      var $380=$1;
      STACKTOP = __stackBase__;
      return $380;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL10getContextP16XML_ParserStruct["X"]=1;

function __ZL9storeAttsP16XML_ParserStructPK8encodingPKcP8TAG_NAMEPP7binding($parser, $enc, $attStr, $tagNamePtr, $bindingsPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $dtd;
      var $elementType;
      var $nDefaultAtts;
      var $appAtts;
      var $attIndex;
      var $prefixLen;
      var $i;
      var $n;
      var $uri;
      var $nPrefixes;
      var $binding;
      var $localPart;
      var $name;
      var $oldAttsSize;
      var $temp;
      var $attId;
      var $result;
      var $isCdata;
      var $j;
      var $result1;
      var $da;
      var $result2;
      var $j3=__stackBase__;
      var $version;
      var $nsAttsSize;
      var $temp4;
      var $s;
      var $id;
      var $b;
      var $uriHash;
      var $c;
      var $c5;
      var $step;
      var $mask;
      var $s1;
      var $s2;
      var $p;
      $2=$parser;
      $3=$enc;
      $4=$attStr;
      $5=$tagNamePtr;
      $6=$bindingsPtr;
      var $7=$2;
      var $8=(($7+356)|0);
      var $9=HEAP32[(($8)>>2)];
      $dtd=$9;
      $attIndex=0;
      $nPrefixes=0;
      var $10=$dtd;
      var $11=(($10+20)|0);
      var $12=$5;
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZL6lookupP10HASH_TABLEPKcj($11, $14, 0);
      var $16=$15;
      $elementType=$16;
      var $17=$elementType;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 9; break; } else { __label__ = 1; break; }
    case 1: // $19
      var $20=$dtd;
      var $21=(($20+80)|0);
      var $22=$5;
      var $23=(($22)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=__ZL14poolCopyStringP11STRING_POOLPKc($21, $24);
      $name=$25;
      var $26=$name;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $28
      $1=1;
      __label__ = 194; break;
    case 3: // $29
      var $30=$dtd;
      var $31=(($30+20)|0);
      var $32=$name;
      var $33=__ZL6lookupP10HASH_TABLEPKcj($31, $32, 24);
      var $34=$33;
      $elementType=$34;
      var $35=$elementType;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $37
      $1=1;
      __label__ = 194; break;
    case 5: // $38
      var $39=$2;
      var $40=(($39+236)|0);
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24)!=0;
      if ($42) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $43
      var $44=$2;
      var $45=$elementType;
      var $46=__ZL20setElementTypePrefixP16XML_ParserStructP12ELEMENT_TYPE($44, $45);
      var $47=(($46)|0)!=0;
      if ($47) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $48
      $1=1;
      __label__ = 194; break;
    case 8: // $49
      __label__ = 9; break;
    case 9: // $50
      var $51=$elementType;
      var $52=(($51+12)|0);
      var $53=HEAP32[(($52)>>2)];
      $nDefaultAtts=$53;
      var $54=$3;
      var $55=(($54+40)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=$3;
      var $58=$4;
      var $59=$2;
      var $60=(($59+380)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=(($62+392)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=FUNCTION_TABLE[$56]($57, $58, $61, $64);
      $n=$65;
      var $66=$n;
      var $67=$nDefaultAtts;
      var $68=(($66+$67)|0);
      var $69=$2;
      var $70=(($69+380)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($68)|0) > (($71)|0);
      if ($72) { __label__ = 10; break; } else { __label__ = 15; break; }
    case 10: // $73
      var $74=$2;
      var $75=(($74+380)|0);
      var $76=HEAP32[(($75)>>2)];
      $oldAttsSize=$76;
      var $77=$n;
      var $78=$nDefaultAtts;
      var $79=(($77+$78)|0);
      var $80=(($79+16)|0);
      var $81=$2;
      var $82=(($81+380)|0);
      HEAP32[(($82)>>2)]=$80;
      var $83=$2;
      var $84=(($83+12)|0);
      var $85=(($84+4)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$2;
      var $88=(($87+392)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$89;
      var $91=$2;
      var $92=(($91+380)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=((($93<<4))|0);
      var $95=FUNCTION_TABLE[$86]($90, $94);
      var $96=$95;
      $temp=$96;
      var $97=$temp;
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $99
      $1=1;
      __label__ = 194; break;
    case 12: // $100
      var $101=$temp;
      var $102=$2;
      var $103=(($102+392)|0);
      HEAP32[(($103)>>2)]=$101;
      var $104=$n;
      var $105=$oldAttsSize;
      var $106=(($104)|0) > (($105)|0);
      if ($106) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $107
      var $108=$3;
      var $109=(($108+40)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$3;
      var $112=$4;
      var $113=$n;
      var $114=$2;
      var $115=(($114+392)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=FUNCTION_TABLE[$110]($111, $112, $113, $116);
      __label__ = 14; break;
    case 14: // $118
      __label__ = 15; break;
    case 15: // $119
      var $120=$2;
      var $121=(($120+392)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$122;
      $appAtts=$123;
      $i=0;
      __label__ = 16; break;
    case 16: // $124
      var $125=$i;
      var $126=$n;
      var $127=(($125)|0) < (($126)|0);
      if ($127) { __label__ = 17; break; } else { __label__ = 48; break; }
    case 17: // $128
      var $129=$2;
      var $130=$3;
      var $131=$i;
      var $132=$2;
      var $133=(($132+392)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+($131<<4))|0);
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=$i;
      var $139=$2;
      var $140=(($139+392)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141+($138<<4))|0);
      var $143=(($142)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$3;
      var $146=(($145+32)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$3;
      var $149=$i;
      var $150=$2;
      var $151=(($150+392)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+($149<<4))|0);
      var $154=(($153)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=FUNCTION_TABLE[$147]($148, $155);
      var $157=(($144+$156)|0);
      var $158=__ZL14getAttributeIdP16XML_ParserStructPK8encodingPKcS5_($129, $130, $137, $157);
      $attId=$158;
      var $159=$attId;
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $161
      $1=1;
      __label__ = 194; break;
    case 19: // $162
      var $163=$attId;
      var $164=(($163)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165-1)|0);
      var $167=HEAP8[($166)];
      var $168=(($167 << 24) >> 24)!=0;
      if ($168) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $169
      var $170=$3;
      var $171=$2;
      var $172=(($171+144)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=(($170)|0)==(($173)|0);
      if ($174) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $175
      var $176=$i;
      var $177=$2;
      var $178=(($177+392)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+($176<<4))|0);
      var $181=(($180)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$2;
      var $184=(($183+288)|0);
      HEAP32[(($184)>>2)]=$182;
      __label__ = 22; break;
    case 22: // $185
      $1=8;
      __label__ = 194; break;
    case 23: // $186
      var $187=$attId;
      var $188=(($187)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189-1)|0);
      HEAP8[($190)]=1;
      var $191=$attId;
      var $192=(($191)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$attIndex;
      var $195=(($194+1)|0);
      $attIndex=$195;
      var $196=$appAtts;
      var $197=(($196+($194<<2))|0);
      HEAP32[(($197)>>2)]=$193;
      var $198=$i;
      var $199=$2;
      var $200=(($199+392)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=(($201+($198<<4))|0);
      var $203=(($202+12)|0);
      var $204=HEAP8[($203)];
      var $205=(($204 << 24) >> 24)!=0;
      if ($205) { __label__ = 35; break; } else { __label__ = 24; break; }
    case 24: // $206
      $isCdata=1;
      var $207=$attId;
      var $208=(($207+8)|0);
      var $209=HEAP8[($208)];
      var $210=(($209 << 24) >> 24)!=0;
      if ($210) { __label__ = 25; break; } else { __label__ = 32; break; }
    case 25: // $211
      $j=0;
      __label__ = 26; break;
    case 26: // $212
      var $213=$j;
      var $214=$nDefaultAtts;
      var $215=(($213)|0) < (($214)|0);
      if ($215) { __label__ = 27; break; } else { __label__ = 31; break; }
    case 27: // $216
      var $217=$attId;
      var $218=$j;
      var $219=$elementType;
      var $220=(($219+20)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+$218*12)|0);
      var $223=(($222)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($217)|0)==(($224)|0);
      if ($225) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $226
      var $227=$j;
      var $228=$elementType;
      var $229=(($228+20)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=(($230+$227*12)|0);
      var $232=(($231+4)|0);
      var $233=HEAP8[($232)];
      $isCdata=$233;
      __label__ = 31; break;
    case 29: // $234
      __label__ = 30; break;
    case 30: // $235
      var $236=$j;
      var $237=(($236+1)|0);
      $j=$237;
      __label__ = 26; break;
    case 31: // $238
      __label__ = 32; break;
    case 32: // $239
      var $240=$2;
      var $241=$3;
      var $242=$isCdata;
      var $243=$i;
      var $244=$2;
      var $245=(($244+392)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246+($243<<4))|0);
      var $248=(($247+4)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=$i;
      var $251=$2;
      var $252=(($251+392)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=(($253+($250<<4))|0);
      var $255=(($254+8)|0);
      var $256=HEAP32[(($255)>>2)];
      var $257=$2;
      var $258=(($257+416)|0);
      var $259=__ZL19storeAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL($240, $241, $242, $249, $256, $258);
      $result=$259;
      var $260=$result;
      var $261=(($260)|0)!=0;
      if ($261) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $262
      var $263=$result;
      $1=$263;
      __label__ = 194; break;
    case 34: // $264
      var $265=$2;
      var $266=(($265+416)|0);
      var $267=(($266+16)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=$attIndex;
      var $270=$appAtts;
      var $271=(($270+($269<<2))|0);
      HEAP32[(($271)>>2)]=$268;
      var $272=$2;
      var $273=(($272+416)|0);
      var $274=(($273+12)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=$2;
      var $277=(($276+416)|0);
      var $278=(($277+16)|0);
      HEAP32[(($278)>>2)]=$275;
      __label__ = 38; break;
    case 35: // $279
      var $280=$2;
      var $281=(($280+416)|0);
      var $282=$3;
      var $283=$i;
      var $284=$2;
      var $285=(($284+392)|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=(($286+($283<<4))|0);
      var $288=(($287+4)|0);
      var $289=HEAP32[(($288)>>2)];
      var $290=$i;
      var $291=$2;
      var $292=(($291+392)|0);
      var $293=HEAP32[(($292)>>2)];
      var $294=(($293+($290<<4))|0);
      var $295=(($294+8)|0);
      var $296=HEAP32[(($295)>>2)];
      var $297=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($281, $282, $289, $296);
      var $298=$attIndex;
      var $299=$appAtts;
      var $300=(($299+($298<<2))|0);
      HEAP32[(($300)>>2)]=$297;
      var $301=$attIndex;
      var $302=$appAtts;
      var $303=(($302+($301<<2))|0);
      var $304=HEAP32[(($303)>>2)];
      var $305=(($304)|0)==0;
      if ($305) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $306
      $1=1;
      __label__ = 194; break;
    case 37: // $307
      var $308=$2;
      var $309=(($308+416)|0);
      var $310=(($309+12)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=$2;
      var $313=(($312+416)|0);
      var $314=(($313+16)|0);
      HEAP32[(($314)>>2)]=$311;
      __label__ = 38; break;
    case 38: // $315
      var $316=$attId;
      var $317=(($316+4)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=(($318)|0)!=0;
      if ($319) { __label__ = 39; break; } else { __label__ = 45; break; }
    case 39: // $320
      var $321=$attId;
      var $322=(($321+9)|0);
      var $323=HEAP8[($322)];
      var $324=(($323 << 24) >> 24)!=0;
      if ($324) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $325
      var $326=$2;
      var $327=$attId;
      var $328=(($327+4)|0);
      var $329=HEAP32[(($328)>>2)];
      var $330=$attId;
      var $331=$attIndex;
      var $332=$appAtts;
      var $333=(($332+($331<<2))|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=$6;
      var $336=__ZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7binding($326, $329, $330, $334, $335);
      $result1=$336;
      var $337=$result1;
      var $338=(($337)|0)!=0;
      if ($338) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $339
      var $340=$result1;
      $1=$340;
      __label__ = 194; break;
    case 42: // $341
      var $342=$attIndex;
      var $343=(($342-1)|0);
      $attIndex=$343;
      __label__ = 44; break;
    case 43: // $344
      var $345=$attIndex;
      var $346=(($345+1)|0);
      $attIndex=$346;
      var $347=$nPrefixes;
      var $348=(($347+1)|0);
      $nPrefixes=$348;
      var $349=$attId;
      var $350=(($349)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=(($351-1)|0);
      HEAP8[($352)]=2;
      __label__ = 44; break;
    case 44: // $353
      __label__ = 46; break;
    case 45: // $354
      var $355=$attIndex;
      var $356=(($355+1)|0);
      $attIndex=$356;
      __label__ = 46; break;
    case 46: // $357
      __label__ = 47; break;
    case 47: // $358
      var $359=$i;
      var $360=(($359+1)|0);
      $i=$360;
      __label__ = 16; break;
    case 48: // $361
      var $362=$attIndex;
      var $363=$2;
      var $364=(($363+384)|0);
      HEAP32[(($364)>>2)]=$362;
      var $365=$elementType;
      var $366=(($365+8)|0);
      var $367=HEAP32[(($366)>>2)];
      var $368=(($367)|0)!=0;
      if ($368) { __label__ = 49; break; } else { __label__ = 57; break; }
    case 49: // $369
      var $370=$elementType;
      var $371=(($370+8)|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=(($372)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=(($374-1)|0);
      var $376=HEAP8[($375)];
      var $377=(($376 << 24) >> 24)!=0;
      if ($377) { __label__ = 50; break; } else { __label__ = 57; break; }
    case 50: // $378
      $i=0;
      __label__ = 51; break;
    case 51: // $379
      var $380=$i;
      var $381=$attIndex;
      var $382=(($380)|0) < (($381)|0);
      if ($382) { __label__ = 52; break; } else { __label__ = 56; break; }
    case 52: // $383
      var $384=$i;
      var $385=$appAtts;
      var $386=(($385+($384<<2))|0);
      var $387=HEAP32[(($386)>>2)];
      var $388=$elementType;
      var $389=(($388+8)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=(($390)|0);
      var $392=HEAP32[(($391)>>2)];
      var $393=(($387)|0)==(($392)|0);
      if ($393) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $394
      var $395=$i;
      var $396=$2;
      var $397=(($396+388)|0);
      HEAP32[(($397)>>2)]=$395;
      __label__ = 56; break;
    case 54: // $398
      __label__ = 55; break;
    case 55: // $399
      var $400=$i;
      var $401=(($400+2)|0);
      $i=$401;
      __label__ = 51; break;
    case 56: // $402
      __label__ = 58; break;
    case 57: // $403
      var $404=$2;
      var $405=(($404+388)|0);
      HEAP32[(($405)>>2)]=-1;
      __label__ = 58; break;
    case 58: // $406
      $i=0;
      __label__ = 59; break;
    case 59: // $407
      var $408=$i;
      var $409=$nDefaultAtts;
      var $410=(($408)|0) < (($409)|0);
      if ($410) { __label__ = 60; break; } else { __label__ = 73; break; }
    case 60: // $411
      var $412=$elementType;
      var $413=(($412+20)|0);
      var $414=HEAP32[(($413)>>2)];
      var $415=$i;
      var $416=(($414+$415*12)|0);
      $da=$416;
      var $417=$da;
      var $418=(($417)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=(($419)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=(($421-1)|0);
      var $423=HEAP8[($422)];
      var $424=(($423 << 24) >> 24)!=0;
      if ($424) { __label__ = 71; break; } else { __label__ = 61; break; }
    case 61: // $425
      var $426=$da;
      var $427=(($426+8)|0);
      var $428=HEAP32[(($427)>>2)];
      var $429=(($428)|0)!=0;
      if ($429) { __label__ = 62; break; } else { __label__ = 71; break; }
    case 62: // $430
      var $431=$da;
      var $432=(($431)|0);
      var $433=HEAP32[(($432)>>2)];
      var $434=(($433+4)|0);
      var $435=HEAP32[(($434)>>2)];
      var $436=(($435)|0)!=0;
      if ($436) { __label__ = 63; break; } else { __label__ = 69; break; }
    case 63: // $437
      var $438=$da;
      var $439=(($438)|0);
      var $440=HEAP32[(($439)>>2)];
      var $441=(($440+9)|0);
      var $442=HEAP8[($441)];
      var $443=(($442 << 24) >> 24)!=0;
      if ($443) { __label__ = 64; break; } else { __label__ = 67; break; }
    case 64: // $444
      var $445=$2;
      var $446=$da;
      var $447=(($446)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=(($448+4)|0);
      var $450=HEAP32[(($449)>>2)];
      var $451=$da;
      var $452=(($451)|0);
      var $453=HEAP32[(($452)>>2)];
      var $454=$da;
      var $455=(($454+8)|0);
      var $456=HEAP32[(($455)>>2)];
      var $457=$6;
      var $458=__ZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7binding($445, $450, $453, $456, $457);
      $result2=$458;
      var $459=$result2;
      var $460=(($459)|0)!=0;
      if ($460) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $461
      var $462=$result2;
      $1=$462;
      __label__ = 194; break;
    case 66: // $463
      __label__ = 68; break;
    case 67: // $464
      var $465=$da;
      var $466=(($465)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=(($467)|0);
      var $469=HEAP32[(($468)>>2)];
      var $470=(($469-1)|0);
      HEAP8[($470)]=2;
      var $471=$nPrefixes;
      var $472=(($471+1)|0);
      $nPrefixes=$472;
      var $473=$da;
      var $474=(($473)|0);
      var $475=HEAP32[(($474)>>2)];
      var $476=(($475)|0);
      var $477=HEAP32[(($476)>>2)];
      var $478=$attIndex;
      var $479=(($478+1)|0);
      $attIndex=$479;
      var $480=$appAtts;
      var $481=(($480+($478<<2))|0);
      HEAP32[(($481)>>2)]=$477;
      var $482=$da;
      var $483=(($482+8)|0);
      var $484=HEAP32[(($483)>>2)];
      var $485=$attIndex;
      var $486=(($485+1)|0);
      $attIndex=$486;
      var $487=$appAtts;
      var $488=(($487+($485<<2))|0);
      HEAP32[(($488)>>2)]=$484;
      __label__ = 68; break;
    case 68: // $489
      __label__ = 70; break;
    case 69: // $490
      var $491=$da;
      var $492=(($491)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=(($493)|0);
      var $495=HEAP32[(($494)>>2)];
      var $496=(($495-1)|0);
      HEAP8[($496)]=1;
      var $497=$da;
      var $498=(($497)|0);
      var $499=HEAP32[(($498)>>2)];
      var $500=(($499)|0);
      var $501=HEAP32[(($500)>>2)];
      var $502=$attIndex;
      var $503=(($502+1)|0);
      $attIndex=$503;
      var $504=$appAtts;
      var $505=(($504+($502<<2))|0);
      HEAP32[(($505)>>2)]=$501;
      var $506=$da;
      var $507=(($506+8)|0);
      var $508=HEAP32[(($507)>>2)];
      var $509=$attIndex;
      var $510=(($509+1)|0);
      $attIndex=$510;
      var $511=$appAtts;
      var $512=(($511+($509<<2))|0);
      HEAP32[(($512)>>2)]=$508;
      __label__ = 70; break;
    case 70: // $513
      __label__ = 71; break;
    case 71: // $514
      __label__ = 72; break;
    case 72: // $515
      var $516=$i;
      var $517=(($516+1)|0);
      $i=$517;
      __label__ = 59; break;
    case 73: // $518
      var $519=$attIndex;
      var $520=$appAtts;
      var $521=(($520+($519<<2))|0);
      HEAP32[(($521)>>2)]=0;
      $i=0;
      var $522=$nPrefixes;
      var $523=(($522)|0)!=0;
      if ($523) { __label__ = 74; break; } else { __label__ = 151; break; }
    case 74: // $524
      var $525=$2;
      var $526=(($525+400)|0);
      var $527=HEAP32[(($526)>>2)];
      $version=$527;
      var $528=$2;
      var $529=(($528+404)|0);
      var $530=HEAPU8[($529)];
      var $531=(($530)&255);
      var $532=1 << $531;
      $nsAttsSize=$532;
      var $533=$nPrefixes;
      var $534=$533 << 1;
      var $535=$2;
      var $536=(($535+404)|0);
      var $537=HEAPU8[($536)];
      var $538=(($537)&255);
      var $539=$534 >> (($538)|0);
      var $540=(($539)|0)!=0;
      if ($540) { __label__ = 75; break; } else { __label__ = 83; break; }
    case 75: // $541
      __label__ = 76; break;
    case 76: // $542
      var $543=$nPrefixes;
      var $544=$2;
      var $545=(($544+404)|0);
      var $546=HEAPU8[($545)];
      var $547=(($546+1)&255);
      HEAP8[($545)]=$547;
      var $548=(($546)&255);
      var $549=$543 >> (($548)|0);
      var $550=(($549)|0)!=0;
      if ($550) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $551
      __label__ = 76; break;
    case 78: // $552
      var $553=$2;
      var $554=(($553+404)|0);
      var $555=HEAPU8[($554)];
      var $556=(($555)&255);
      var $557=(($556)|0) < 3;
      if ($557) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $558
      var $559=$2;
      var $560=(($559+404)|0);
      HEAP8[($560)]=3;
      __label__ = 80; break;
    case 80: // $561
      var $562=$2;
      var $563=(($562+404)|0);
      var $564=HEAPU8[($563)];
      var $565=(($564)&255);
      var $566=1 << $565;
      $nsAttsSize=$566;
      var $567=$2;
      var $568=(($567+12)|0);
      var $569=(($568+4)|0);
      var $570=HEAP32[(($569)>>2)];
      var $571=$2;
      var $572=(($571+396)|0);
      var $573=HEAP32[(($572)>>2)];
      var $574=$573;
      var $575=$nsAttsSize;
      var $576=(($575*12)|0);
      var $577=FUNCTION_TABLE[$570]($574, $576);
      var $578=$577;
      $temp4=$578;
      var $579=$temp4;
      var $580=(($579)|0)!=0;
      if ($580) { __label__ = 82; break; } else { __label__ = 81; break; }
    case 81: // $581
      $1=1;
      __label__ = 194; break;
    case 82: // $582
      var $583=$temp4;
      var $584=$2;
      var $585=(($584+396)|0);
      HEAP32[(($585)>>2)]=$583;
      $version=0;
      __label__ = 83; break;
    case 83: // $586
      var $587=$version;
      var $588=(($587)|0)!=0;
      if ($588) { __label__ = 88; break; } else { __label__ = 84; break; }
    case 84: // $589
      $version=-1;
      var $590=$nsAttsSize;
      HEAP32[(($j3)>>2)]=$590;
      __label__ = 85; break;
    case 85: // $591
      var $592=HEAP32[(($j3)>>2)];
      var $593=(($592)|0)!=0;
      if ($593) { __label__ = 86; break; } else { __label__ = 87; break; }
    case 86: // $594
      var $595=$version;
      var $596=HEAP32[(($j3)>>2)];
      var $597=(($596-1)|0);
      HEAP32[(($j3)>>2)]=$597;
      var $598=$2;
      var $599=(($598+396)|0);
      var $600=HEAP32[(($599)>>2)];
      var $601=(($600+$597*12)|0);
      var $602=(($601)|0);
      HEAP32[(($602)>>2)]=$595;
      __label__ = 85; break;
    case 87: // $603
      __label__ = 88; break;
    case 88: // $604
      var $605=$version;
      var $606=(($605-1)|0);
      $version=$606;
      var $607=$2;
      var $608=(($607+400)|0);
      HEAP32[(($608)>>2)]=$606;
      __label__ = 89; break;
    case 89: // $609
      var $610=$i;
      var $611=$attIndex;
      var $612=(($610)|0) < (($611)|0);
      if ($612) { __label__ = 90; break; } else { __label__ = 150; break; }
    case 90: // $613
      var $614=$i;
      var $615=$appAtts;
      var $616=(($615+($614<<2))|0);
      var $617=HEAP32[(($616)>>2)];
      $s=$617;
      var $618=$s;
      var $619=(($618-1)|0);
      var $620=HEAP8[($619)];
      var $621=(($620 << 24) >> 24);
      var $622=(($621)|0)==2;
      if ($622) { __label__ = 91; break; } else { __label__ = 147; break; }
    case 91: // $623
      $uriHash=0;
      var $624=$s;
      var $625=(($624-1)|0);
      HEAP8[($625)]=0;
      var $626=$dtd;
      var $627=(($626+40)|0);
      var $628=$s;
      var $629=__ZL6lookupP10HASH_TABLEPKcj($627, $628, 0);
      var $630=$629;
      $id=$630;
      var $631=$id;
      var $632=(($631+4)|0);
      var $633=HEAP32[(($632)>>2)];
      var $634=(($633+4)|0);
      var $635=HEAP32[(($634)>>2)];
      $b=$635;
      var $636=$b;
      var $637=(($636)|0)!=0;
      if ($637) { __label__ = 93; break; } else { __label__ = 92; break; }
    case 92: // $638
      $1=27;
      __label__ = 194; break;
    case 93: // $639
      HEAP32[(($j3)>>2)]=0;
      __label__ = 94; break;
    case 94: // $640
      var $641=HEAP32[(($j3)>>2)];
      var $642=$b;
      var $643=(($642+20)|0);
      var $644=HEAP32[(($643)>>2)];
      var $645=(($641)|0) < (($644)|0);
      if ($645) { __label__ = 95; break; } else { __label__ = 103; break; }
    case 95: // $646
      var $647=HEAP32[(($j3)>>2)];
      var $648=$b;
      var $649=(($648+16)|0);
      var $650=HEAP32[(($649)>>2)];
      var $651=(($650+$647)|0);
      var $652=HEAP8[($651)];
      $c=$652;
      var $653=$2;
      var $654=(($653+416)|0);
      var $655=(($654+12)|0);
      var $656=HEAP32[(($655)>>2)];
      var $657=$2;
      var $658=(($657+416)|0);
      var $659=(($658+8)|0);
      var $660=HEAP32[(($659)>>2)];
      var $661=(($656)|0)==(($660)|0);
      if ($661) { __label__ = 96; break; } else { __label__ = 98; break; }
    case 96: // $662
      var $663=$2;
      var $664=(($663+416)|0);
      var $665=__ZL8poolGrowP11STRING_POOL($664);
      var $666=(($665 << 24) >> 24)!=0;
      if ($666) { __label__ = 98; break; } else { __label__ = 97; break; }
    case 97: // $667
      var $676 = 0;__label__ = 99; break;
    case 98: // $668
      var $669=$c;
      var $670=$2;
      var $671=(($670+416)|0);
      var $672=(($671+12)|0);
      var $673=HEAP32[(($672)>>2)];
      var $674=(($673+1)|0);
      HEAP32[(($672)>>2)]=$674;
      HEAP8[($673)]=$669;
      var $676 = 1;__label__ = 99; break;
    case 99: // $675
      var $676;
      var $677=(($676)|0)!=0;
      if ($677) { __label__ = 101; break; } else { __label__ = 100; break; }
    case 100: // $678
      $1=1;
      __label__ = 194; break;
    case 101: // $679
      var $680=$uriHash;
      var $681=(($680*1000003)|0);
      var $682=$c;
      var $683=(($682)&255);
      var $684=$681 ^ $683;
      $uriHash=$684;
      __label__ = 102; break;
    case 102: // $685
      var $686=HEAP32[(($j3)>>2)];
      var $687=(($686+1)|0);
      HEAP32[(($j3)>>2)]=$687;
      __label__ = 94; break;
    case 103: // $688
      __label__ = 104; break;
    case 104: // $689
      var $690=$s;
      var $691=(($690+1)|0);
      $s=$691;
      var $692=HEAP8[($690)];
      var $693=(($692 << 24) >> 24);
      var $694=(($693)|0)!=58;
      if ($694) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $695
      __label__ = 104; break;
    case 106: // $696
      __label__ = 107; break;
    case 107: // $697
      var $698=$s;
      var $699=HEAP8[($698)];
      $c5=$699;
      var $700=$2;
      var $701=(($700+416)|0);
      var $702=(($701+12)|0);
      var $703=HEAP32[(($702)>>2)];
      var $704=$2;
      var $705=(($704+416)|0);
      var $706=(($705+8)|0);
      var $707=HEAP32[(($706)>>2)];
      var $708=(($703)|0)==(($707)|0);
      if ($708) { __label__ = 108; break; } else { __label__ = 110; break; }
    case 108: // $709
      var $710=$2;
      var $711=(($710+416)|0);
      var $712=__ZL8poolGrowP11STRING_POOL($711);
      var $713=(($712 << 24) >> 24)!=0;
      if ($713) { __label__ = 110; break; } else { __label__ = 109; break; }
    case 109: // $714
      var $724 = 0;__label__ = 111; break;
    case 110: // $715
      var $716=$s;
      var $717=HEAP8[($716)];
      var $718=$2;
      var $719=(($718+416)|0);
      var $720=(($719+12)|0);
      var $721=HEAP32[(($720)>>2)];
      var $722=(($721+1)|0);
      HEAP32[(($720)>>2)]=$722;
      HEAP8[($721)]=$717;
      var $724 = 1;__label__ = 111; break;
    case 111: // $723
      var $724;
      var $725=(($724)|0)!=0;
      if ($725) { __label__ = 113; break; } else { __label__ = 112; break; }
    case 112: // $726
      $1=1;
      __label__ = 194; break;
    case 113: // $727
      var $728=$uriHash;
      var $729=(($728*1000003)|0);
      var $730=$c5;
      var $731=(($730)&255);
      var $732=$729 ^ $731;
      $uriHash=$732;
      __label__ = 114; break;
    case 114: // $733
      var $734=$s;
      var $735=(($734+1)|0);
      $s=$735;
      var $736=HEAP8[($734)];
      var $737=(($736 << 24) >> 24)!=0;
      if ($737) { __label__ = 107; break; } else { __label__ = 115; break; }
    case 115: // $738
      $step=0;
      var $739=$nsAttsSize;
      var $740=(($739-1)|0);
      $mask=$740;
      var $741=$uriHash;
      var $742=$mask;
      var $743=$741 & $742;
      HEAP32[(($j3)>>2)]=$743;
      __label__ = 116; break;
    case 116: // $744
      var $745=HEAP32[(($j3)>>2)];
      var $746=$2;
      var $747=(($746+396)|0);
      var $748=HEAP32[(($747)>>2)];
      var $749=(($748+$745*12)|0);
      var $750=(($749)|0);
      var $751=HEAP32[(($750)>>2)];
      var $752=$version;
      var $753=(($751)|0)==(($752)|0);
      if ($753) { __label__ = 117; break; } else { __label__ = 133; break; }
    case 117: // $754
      var $755=$uriHash;
      var $756=HEAP32[(($j3)>>2)];
      var $757=$2;
      var $758=(($757+396)|0);
      var $759=HEAP32[(($758)>>2)];
      var $760=(($759+$756*12)|0);
      var $761=(($760+4)|0);
      var $762=HEAP32[(($761)>>2)];
      var $763=(($755)|0)==(($762)|0);
      if ($763) { __label__ = 118; break; } else { __label__ = 127; break; }
    case 118: // $764
      var $765=$2;
      var $766=(($765+416)|0);
      var $767=(($766+16)|0);
      var $768=HEAP32[(($767)>>2)];
      $s1=$768;
      var $769=HEAP32[(($j3)>>2)];
      var $770=$2;
      var $771=(($770+396)|0);
      var $772=HEAP32[(($771)>>2)];
      var $773=(($772+$769*12)|0);
      var $774=(($773+8)|0);
      var $775=HEAP32[(($774)>>2)];
      $s2=$775;
      __label__ = 119; break;
    case 119: // $776
      var $777=$s1;
      var $778=HEAP8[($777)];
      var $779=(($778 << 24) >> 24);
      var $780=$s2;
      var $781=HEAP8[($780)];
      var $782=(($781 << 24) >> 24);
      var $783=(($779)|0)==(($782)|0);
      if ($783) { __label__ = 120; break; } else { var $790 = 0;__label__ = 121; break; }
    case 120: // $784
      var $785=$s1;
      var $786=HEAP8[($785)];
      var $787=(($786 << 24) >> 24);
      var $788=(($787)|0)!=0;
      var $790 = $788;__label__ = 121; break;
    case 121: // $789
      var $790;
      if ($790) { __label__ = 122; break; } else { __label__ = 124; break; }
    case 122: // $791
      __label__ = 123; break;
    case 123: // $792
      var $793=$s1;
      var $794=(($793+1)|0);
      $s1=$794;
      var $795=$s2;
      var $796=(($795+1)|0);
      $s2=$796;
      __label__ = 119; break;
    case 124: // $797
      var $798=$s1;
      var $799=HEAP8[($798)];
      var $800=(($799 << 24) >> 24);
      var $801=(($800)|0)==0;
      if ($801) { __label__ = 125; break; } else { __label__ = 126; break; }
    case 125: // $802
      $1=8;
      __label__ = 194; break;
    case 126: // $803
      __label__ = 127; break;
    case 127: // $804
      var $805=$step;
      var $806=(($805 << 24) >> 24)!=0;
      if ($806) { __label__ = 129; break; } else { __label__ = 128; break; }
    case 128: // $807
      var $808=$uriHash;
      var $809=$mask;
      var $810=$809 ^ -1;
      var $811=$808 & $810;
      var $812=$2;
      var $813=(($812+404)|0);
      var $814=HEAPU8[($813)];
      var $815=(($814)&255);
      var $816=(($815-1)|0);
      var $817=$811 >>> (($816)>>>0);
      var $818=$mask;
      var $819=$818 >>> 2;
      var $820=$817 & $819;
      var $821=$820 | 1;
      var $822=(($821) & 255);
      $step=$822;
      __label__ = 129; break;
    case 129: // $823
      var $824=HEAP32[(($j3)>>2)];
      var $825=$step;
      var $826=(($825)&255);
      var $827=(($824)|0) < (($826)|0);
      if ($827) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $828
      var $829=$nsAttsSize;
      var $830=$step;
      var $831=(($830)&255);
      var $832=(($829-$831)|0);
      var $833=HEAP32[(($j3)>>2)];
      var $834=(($833+$832)|0);
      HEAP32[(($j3)>>2)]=$834;
      var $841 = $j3;__label__ = 132; break;
    case 131: // $835
      var $836=$step;
      var $837=(($836)&255);
      var $838=HEAP32[(($j3)>>2)];
      var $839=(($838-$837)|0);
      HEAP32[(($j3)>>2)]=$839;
      var $841 = $j3;__label__ = 132; break;
    case 132: // $840
      var $841;
      __label__ = 116; break;
    case 133: // $842
      var $843=$2;
      var $844=(($843+237)|0);
      var $845=HEAP8[($844)];
      var $846=(($845 << 24) >> 24)!=0;
      if ($846) { __label__ = 134; break; } else { __label__ = 144; break; }
    case 134: // $847
      var $848=$2;
      var $849=(($848+472)|0);
      var $850=HEAP8[($849)];
      var $851=$2;
      var $852=(($851+416)|0);
      var $853=(($852+12)|0);
      var $854=HEAP32[(($853)>>2)];
      var $855=(($854-1)|0);
      HEAP8[($855)]=$850;
      var $856=$b;
      var $857=(($856)|0);
      var $858=HEAP32[(($857)>>2)];
      var $859=(($858)|0);
      var $860=HEAP32[(($859)>>2)];
      $s=$860;
      __label__ = 135; break;
    case 135: // $861
      var $862=$2;
      var $863=(($862+416)|0);
      var $864=(($863+12)|0);
      var $865=HEAP32[(($864)>>2)];
      var $866=$2;
      var $867=(($866+416)|0);
      var $868=(($867+8)|0);
      var $869=HEAP32[(($868)>>2)];
      var $870=(($865)|0)==(($869)|0);
      if ($870) { __label__ = 136; break; } else { __label__ = 138; break; }
    case 136: // $871
      var $872=$2;
      var $873=(($872+416)|0);
      var $874=__ZL8poolGrowP11STRING_POOL($873);
      var $875=(($874 << 24) >> 24)!=0;
      if ($875) { __label__ = 138; break; } else { __label__ = 137; break; }
    case 137: // $876
      var $886 = 0;__label__ = 139; break;
    case 138: // $877
      var $878=$s;
      var $879=HEAP8[($878)];
      var $880=$2;
      var $881=(($880+416)|0);
      var $882=(($881+12)|0);
      var $883=HEAP32[(($882)>>2)];
      var $884=(($883+1)|0);
      HEAP32[(($882)>>2)]=$884;
      HEAP8[($883)]=$879;
      var $886 = 1;__label__ = 139; break;
    case 139: // $885
      var $886;
      var $887=(($886)|0)!=0;
      if ($887) { __label__ = 141; break; } else { __label__ = 140; break; }
    case 140: // $888
      $1=1;
      __label__ = 194; break;
    case 141: // $889
      __label__ = 142; break;
    case 142: // $890
      var $891=$s;
      var $892=(($891+1)|0);
      $s=$892;
      var $893=HEAP8[($891)];
      var $894=(($893 << 24) >> 24)!=0;
      if ($894) { __label__ = 135; break; } else { __label__ = 143; break; }
    case 143: // $895
      __label__ = 144; break;
    case 144: // $896
      var $897=$2;
      var $898=(($897+416)|0);
      var $899=(($898+16)|0);
      var $900=HEAP32[(($899)>>2)];
      $s=$900;
      var $901=$2;
      var $902=(($901+416)|0);
      var $903=(($902+12)|0);
      var $904=HEAP32[(($903)>>2)];
      var $905=$2;
      var $906=(($905+416)|0);
      var $907=(($906+16)|0);
      HEAP32[(($907)>>2)]=$904;
      var $908=$s;
      var $909=$i;
      var $910=$appAtts;
      var $911=(($910+($909<<2))|0);
      HEAP32[(($911)>>2)]=$908;
      var $912=$version;
      var $913=HEAP32[(($j3)>>2)];
      var $914=$2;
      var $915=(($914+396)|0);
      var $916=HEAP32[(($915)>>2)];
      var $917=(($916+$913*12)|0);
      var $918=(($917)|0);
      HEAP32[(($918)>>2)]=$912;
      var $919=$uriHash;
      var $920=HEAP32[(($j3)>>2)];
      var $921=$2;
      var $922=(($921+396)|0);
      var $923=HEAP32[(($922)>>2)];
      var $924=(($923+$920*12)|0);
      var $925=(($924+4)|0);
      HEAP32[(($925)>>2)]=$919;
      var $926=$s;
      var $927=HEAP32[(($j3)>>2)];
      var $928=$2;
      var $929=(($928+396)|0);
      var $930=HEAP32[(($929)>>2)];
      var $931=(($930+$927*12)|0);
      var $932=(($931+8)|0);
      HEAP32[(($932)>>2)]=$926;
      var $933=$nPrefixes;
      var $934=(($933-1)|0);
      $nPrefixes=$934;
      var $935=(($934)|0)!=0;
      if ($935) { __label__ = 146; break; } else { __label__ = 145; break; }
    case 145: // $936
      var $937=$i;
      var $938=(($937+2)|0);
      $i=$938;
      __label__ = 150; break;
    case 146: // $939
      __label__ = 148; break;
    case 147: // $940
      var $941=$s;
      var $942=(($941-1)|0);
      HEAP8[($942)]=0;
      __label__ = 148; break;
    case 148: // $943
      __label__ = 149; break;
    case 149: // $944
      var $945=$i;
      var $946=(($945+2)|0);
      $i=$946;
      __label__ = 89; break;
    case 150: // $947
      __label__ = 151; break;
    case 151: // $948
      __label__ = 152; break;
    case 152: // $949
      var $950=$i;
      var $951=$attIndex;
      var $952=(($950)|0) < (($951)|0);
      if ($952) { __label__ = 153; break; } else { __label__ = 155; break; }
    case 153: // $953
      var $954=$i;
      var $955=$appAtts;
      var $956=(($955+($954<<2))|0);
      var $957=HEAP32[(($956)>>2)];
      var $958=(($957-1)|0);
      HEAP8[($958)]=0;
      __label__ = 154; break;
    case 154: // $959
      var $960=$i;
      var $961=(($960+2)|0);
      $i=$961;
      __label__ = 152; break;
    case 155: // $962
      var $963=$6;
      var $964=HEAP32[(($963)>>2)];
      $binding=$964;
      __label__ = 156; break;
    case 156: // $965
      var $966=$binding;
      var $967=(($966)|0)!=0;
      if ($967) { __label__ = 157; break; } else { __label__ = 159; break; }
    case 157: // $968
      var $969=$binding;
      var $970=(($969+12)|0);
      var $971=HEAP32[(($970)>>2)];
      var $972=(($971)|0);
      var $973=HEAP32[(($972)>>2)];
      var $974=(($973-1)|0);
      HEAP8[($974)]=0;
      __label__ = 158; break;
    case 158: // $975
      var $976=$binding;
      var $977=(($976+4)|0);
      var $978=HEAP32[(($977)>>2)];
      $binding=$978;
      __label__ = 156; break;
    case 159: // $979
      var $980=$2;
      var $981=(($980+236)|0);
      var $982=HEAP8[($981)];
      var $983=(($982 << 24) >> 24)!=0;
      if ($983) { __label__ = 161; break; } else { __label__ = 160; break; }
    case 160: // $984
      $1=0;
      __label__ = 194; break;
    case 161: // $985
      var $986=$elementType;
      var $987=(($986+4)|0);
      var $988=HEAP32[(($987)>>2)];
      var $989=(($988)|0)!=0;
      if ($989) { __label__ = 162; break; } else { __label__ = 168; break; }
    case 162: // $990
      var $991=$elementType;
      var $992=(($991+4)|0);
      var $993=HEAP32[(($992)>>2)];
      var $994=(($993+4)|0);
      var $995=HEAP32[(($994)>>2)];
      $binding=$995;
      var $996=$binding;
      var $997=(($996)|0)!=0;
      if ($997) { __label__ = 164; break; } else { __label__ = 163; break; }
    case 163: // $998
      $1=27;
      __label__ = 194; break;
    case 164: // $999
      var $1000=$5;
      var $1001=(($1000)|0);
      var $1002=HEAP32[(($1001)>>2)];
      $localPart=$1002;
      __label__ = 165; break;
    case 165: // $1003
      var $1004=$localPart;
      var $1005=(($1004+1)|0);
      $localPart=$1005;
      var $1006=HEAP8[($1004)];
      var $1007=(($1006 << 24) >> 24);
      var $1008=(($1007)|0)!=58;
      if ($1008) { __label__ = 166; break; } else { __label__ = 167; break; }
    case 166: // $1009
      __label__ = 165; break;
    case 167: // $1010
      __label__ = 172; break;
    case 168: // $1011
      var $1012=$dtd;
      var $1013=(($1012+152)|0);
      var $1014=(($1013+4)|0);
      var $1015=HEAP32[(($1014)>>2)];
      var $1016=(($1015)|0)!=0;
      if ($1016) { __label__ = 169; break; } else { __label__ = 170; break; }
    case 169: // $1017
      var $1018=$dtd;
      var $1019=(($1018+152)|0);
      var $1020=(($1019+4)|0);
      var $1021=HEAP32[(($1020)>>2)];
      $binding=$1021;
      var $1022=$5;
      var $1023=(($1022)|0);
      var $1024=HEAP32[(($1023)>>2)];
      $localPart=$1024;
      __label__ = 171; break;
    case 170: // $1025
      $1=0;
      __label__ = 194; break;
    case 171: // $1026
      __label__ = 172; break;
    case 172: // $1027
      $prefixLen=0;
      var $1028=$2;
      var $1029=(($1028+237)|0);
      var $1030=HEAP8[($1029)];
      var $1031=(($1030 << 24) >> 24)!=0;
      if ($1031) { __label__ = 173; break; } else { __label__ = 178; break; }
    case 173: // $1032
      var $1033=$binding;
      var $1034=(($1033)|0);
      var $1035=HEAP32[(($1034)>>2)];
      var $1036=(($1035)|0);
      var $1037=HEAP32[(($1036)>>2)];
      var $1038=(($1037)|0)!=0;
      if ($1038) { __label__ = 174; break; } else { __label__ = 178; break; }
    case 174: // $1039
      __label__ = 175; break;
    case 175: // $1040
      var $1041=$prefixLen;
      var $1042=(($1041+1)|0);
      $prefixLen=$1042;
      var $1043=$binding;
      var $1044=(($1043)|0);
      var $1045=HEAP32[(($1044)>>2)];
      var $1046=(($1045)|0);
      var $1047=HEAP32[(($1046)>>2)];
      var $1048=(($1047+$1041)|0);
      var $1049=HEAP8[($1048)];
      var $1050=(($1049 << 24) >> 24)!=0;
      if ($1050) { __label__ = 176; break; } else { __label__ = 177; break; }
    case 176: // $1051
      __label__ = 175; break;
    case 177: // $1052
      __label__ = 178; break;
    case 178: // $1053
      var $1054=$localPart;
      var $1055=$5;
      var $1056=(($1055+4)|0);
      HEAP32[(($1056)>>2)]=$1054;
      var $1057=$binding;
      var $1058=(($1057+20)|0);
      var $1059=HEAP32[(($1058)>>2)];
      var $1060=$5;
      var $1061=(($1060+16)|0);
      HEAP32[(($1061)>>2)]=$1059;
      var $1062=$binding;
      var $1063=(($1062)|0);
      var $1064=HEAP32[(($1063)>>2)];
      var $1065=(($1064)|0);
      var $1066=HEAP32[(($1065)>>2)];
      var $1067=$5;
      var $1068=(($1067+8)|0);
      HEAP32[(($1068)>>2)]=$1066;
      var $1069=$prefixLen;
      var $1070=$5;
      var $1071=(($1070+20)|0);
      HEAP32[(($1071)>>2)]=$1069;
      $i=0;
      __label__ = 179; break;
    case 179: // $1072
      var $1073=$i;
      var $1074=(($1073+1)|0);
      $i=$1074;
      var $1075=$localPart;
      var $1076=(($1075+$1073)|0);
      var $1077=HEAP8[($1076)];
      var $1078=(($1077 << 24) >> 24)!=0;
      if ($1078) { __label__ = 180; break; } else { __label__ = 181; break; }
    case 180: // $1079
      __label__ = 179; break;
    case 181: // $1080
      var $1081=$i;
      var $1082=$binding;
      var $1083=(($1082+20)|0);
      var $1084=HEAP32[(($1083)>>2)];
      var $1085=(($1081+$1084)|0);
      var $1086=$prefixLen;
      var $1087=(($1085+$1086)|0);
      $n=$1087;
      var $1088=$n;
      var $1089=$binding;
      var $1090=(($1089+24)|0);
      var $1091=HEAP32[(($1090)>>2)];
      var $1092=(($1088)|0) > (($1091)|0);
      if ($1092) { __label__ = 182; break; } else { __label__ = 191; break; }
    case 182: // $1093
      var $1094=$2;
      var $1095=(($1094+12)|0);
      var $1096=(($1095)|0);
      var $1097=HEAP32[(($1096)>>2)];
      var $1098=$n;
      var $1099=(($1098+24)|0);
      var $1100=(($1099)|0);
      var $1101=FUNCTION_TABLE[$1097]($1100);
      $uri=$1101;
      var $1102=$uri;
      var $1103=(($1102)|0)!=0;
      if ($1103) { __label__ = 184; break; } else { __label__ = 183; break; }
    case 183: // $1104
      $1=1;
      __label__ = 194; break;
    case 184: // $1105
      var $1106=$n;
      var $1107=(($1106+24)|0);
      var $1108=$binding;
      var $1109=(($1108+24)|0);
      HEAP32[(($1109)>>2)]=$1107;
      var $1110=$uri;
      var $1111=$binding;
      var $1112=(($1111+16)|0);
      var $1113=HEAP32[(($1112)>>2)];
      var $1114=$binding;
      var $1115=(($1114+20)|0);
      var $1116=HEAP32[(($1115)>>2)];
      var $1117=(($1116)|0);
      assert($1117 % 1 === 0, 'memcpy given ' + $1117 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($1110, $1113, $1117, 1);
      var $1118=$2;
      var $1119=(($1118+364)|0);
      var $1120=HEAP32[(($1119)>>2)];
      $p=$1120;
      __label__ = 185; break;
    case 185: // $1121
      var $1122=$p;
      var $1123=(($1122)|0)!=0;
      if ($1123) { __label__ = 186; break; } else { __label__ = 190; break; }
    case 186: // $1124
      var $1125=$p;
      var $1126=(($1125+12)|0);
      var $1127=(($1126)|0);
      var $1128=HEAP32[(($1127)>>2)];
      var $1129=$binding;
      var $1130=(($1129+16)|0);
      var $1131=HEAP32[(($1130)>>2)];
      var $1132=(($1128)|0)==(($1131)|0);
      if ($1132) { __label__ = 187; break; } else { __label__ = 188; break; }
    case 187: // $1133
      var $1134=$uri;
      var $1135=$p;
      var $1136=(($1135+12)|0);
      var $1137=(($1136)|0);
      HEAP32[(($1137)>>2)]=$1134;
      __label__ = 188; break;
    case 188: // $1138
      __label__ = 189; break;
    case 189: // $1139
      var $1140=$p;
      var $1141=(($1140)|0);
      var $1142=HEAP32[(($1141)>>2)];
      $p=$1142;
      __label__ = 185; break;
    case 190: // $1143
      var $1144=$2;
      var $1145=(($1144+12)|0);
      var $1146=(($1145+8)|0);
      var $1147=HEAP32[(($1146)>>2)];
      var $1148=$binding;
      var $1149=(($1148+16)|0);
      var $1150=HEAP32[(($1149)>>2)];
      FUNCTION_TABLE[$1147]($1150);
      var $1151=$uri;
      var $1152=$binding;
      var $1153=(($1152+16)|0);
      HEAP32[(($1153)>>2)]=$1151;
      __label__ = 191; break;
    case 191: // $1154
      var $1155=$binding;
      var $1156=(($1155+16)|0);
      var $1157=HEAP32[(($1156)>>2)];
      var $1158=$binding;
      var $1159=(($1158+20)|0);
      var $1160=HEAP32[(($1159)>>2)];
      var $1161=(($1157+$1160)|0);
      $uri=$1161;
      var $1162=$uri;
      var $1163=$localPart;
      var $1164=$i;
      var $1165=(($1164)|0);
      assert($1165 % 1 === 0, 'memcpy given ' + $1165 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($1162, $1163, $1165, 1);
      var $1166=$prefixLen;
      var $1167=(($1166)|0)!=0;
      if ($1167) { __label__ = 192; break; } else { __label__ = 193; break; }
    case 192: // $1168
      var $1169=$i;
      var $1170=(($1169-1)|0);
      var $1171=$uri;
      var $1172=(($1171+$1170)|0);
      $uri=$1172;
      var $1173=$2;
      var $1174=(($1173+472)|0);
      var $1175=HEAP8[($1174)];
      var $1176=$uri;
      HEAP8[($1176)]=$1175;
      var $1177=$uri;
      var $1178=(($1177+1)|0);
      var $1179=$binding;
      var $1180=(($1179)|0);
      var $1181=HEAP32[(($1180)>>2)];
      var $1182=(($1181)|0);
      var $1183=HEAP32[(($1182)>>2)];
      var $1184=$prefixLen;
      var $1185=(($1184)|0);
      assert($1185 % 1 === 0, 'memcpy given ' + $1185 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($1178, $1183, $1185, 1);
      __label__ = 193; break;
    case 193: // $1186
      var $1187=$binding;
      var $1188=(($1187+16)|0);
      var $1189=HEAP32[(($1188)>>2)];
      var $1190=$5;
      var $1191=(($1190)|0);
      HEAP32[(($1191)>>2)]=$1189;
      $1=0;
      __label__ = 194; break;
    case 194: // $1192
      var $1193=$1;
      STACKTOP = __stackBase__;
      return $1193;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9storeAttsP16XML_ParserStructPK8encodingPKcP8TAG_NAMEPP7binding["X"]=1;

function __ZL15epilogProcessorP16XML_ParserStructPKcS2_PS2_($parser, $s, $end, $nextPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $next=__stackBase__;
      var $tok;
      $2=$parser;
      $3=$s;
      $4=$end;
      $5=$nextPtr;
      var $6=$2;
      var $7=(($6+280)|0);
      HEAP32[(($7)>>2)]=1520;
      var $8=$3;
      var $9=$2;
      var $10=(($9+288)|0);
      HEAP32[(($10)>>2)]=$8;
      __label__ = 1; break;
    case 1: // $11
      HEAP32[(($next)>>2)]=0;
      var $12=$2;
      var $13=(($12+144)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0);
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$2;
      var $19=(($18+144)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$3;
      var $22=$4;
      var $23=FUNCTION_TABLE[$17]($20, $21, $22, $next);
      $tok=$23;
      var $24=HEAP32[(($next)>>2)];
      var $25=$2;
      var $26=(($25+292)|0);
      HEAP32[(($26)>>2)]=$24;
      var $27=$tok;
      if ($27 == -15) {
        __label__ = 2; break;
      }
      else if ($27 == -4) {
        __label__ = 7; break;
      }
      else if ($27 == 15) {
        __label__ = 8; break;
      }
      else if ($27 == 11) {
        __label__ = 11; break;
      }
      else if ($27 == 13) {
        __label__ = 14; break;
      }
      else if ($27 == 0) {
        __label__ = 17; break;
      }
      else if ($27 == -1) {
        __label__ = 18; break;
      }
      else if ($27 == -2) {
        __label__ = 21; break;
      }
      else {
      __label__ = 24; break;
      }
      
    case 2: // $28
      var $29=$2;
      var $30=(($29+80)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $33
      var $34=$2;
      var $35=$2;
      var $36=(($35+144)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$3;
      var $39=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($34, $37, $38, $39);
      var $40=$2;
      var $41=(($40+480)|0);
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)==2;
      if ($44) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $45
      $1=35;
      __label__ = 30; break;
    case 5: // $46
      __label__ = 6; break;
    case 6: // $47
      var $48=HEAP32[(($next)>>2)];
      var $49=$5;
      HEAP32[(($49)>>2)]=$48;
      $1=0;
      __label__ = 30; break;
    case 7: // $50
      var $51=$3;
      var $52=$5;
      HEAP32[(($52)>>2)]=$51;
      $1=0;
      __label__ = 30; break;
    case 8: // $53
      var $54=$2;
      var $55=(($54+80)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $58
      var $59=$2;
      var $60=$2;
      var $61=(($60+144)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$3;
      var $64=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($59, $62, $63, $64);
      __label__ = 10; break;
    case 10: // $65
      __label__ = 25; break;
    case 11: // $66
      var $67=$2;
      var $68=$2;
      var $69=(($68+144)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$3;
      var $72=HEAP32[(($next)>>2)];
      var $73=__ZL27reportProcessingInstructionP16XML_ParserStructPK8encodingPKcS5_($67, $70, $71, $72);
      var $74=(($73)|0)!=0;
      if ($74) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $75
      $1=1;
      __label__ = 30; break;
    case 13: // $76
      __label__ = 25; break;
    case 14: // $77
      var $78=$2;
      var $79=$2;
      var $80=(($79+144)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$3;
      var $83=HEAP32[(($next)>>2)];
      var $84=__ZL13reportCommentP16XML_ParserStructPK8encodingPKcS5_($78, $81, $82, $83);
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $86
      $1=1;
      __label__ = 30; break;
    case 16: // $87
      __label__ = 25; break;
    case 17: // $88
      var $89=HEAP32[(($next)>>2)];
      var $90=$2;
      var $91=(($90+288)|0);
      HEAP32[(($91)>>2)]=$89;
      $1=4;
      __label__ = 30; break;
    case 18: // $92
      var $93=$2;
      var $94=(($93+480)|0);
      var $95=(($94+4)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24)!=0;
      if ($97) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 30; break;
    case 20: // $101
      $1=5;
      __label__ = 30; break;
    case 21: // $102
      var $103=$2;
      var $104=(($103+480)|0);
      var $105=(($104+4)|0);
      var $106=HEAP8[($105)];
      var $107=(($106 << 24) >> 24)!=0;
      if ($107) { __label__ = 23; break; } else { __label__ = 22; break; }
    case 22: // $108
      var $109=$3;
      var $110=$5;
      HEAP32[(($110)>>2)]=$109;
      $1=0;
      __label__ = 30; break;
    case 23: // $111
      $1=6;
      __label__ = 30; break;
    case 24: // $112
      $1=9;
      __label__ = 30; break;
    case 25: // $113
      var $114=HEAP32[(($next)>>2)];
      $3=$114;
      var $115=$2;
      var $116=(($115+288)|0);
      HEAP32[(($116)>>2)]=$114;
      var $117=$2;
      var $118=(($117+480)|0);
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      if ($120 == 3) {
        __label__ = 26; break;
      }
      else if ($120 == 2) {
        __label__ = 27; break;
      }
      else {
      __label__ = 28; break;
      }
      
    case 26: // $121
      var $122=HEAP32[(($next)>>2)];
      var $123=$5;
      HEAP32[(($123)>>2)]=$122;
      $1=0;
      __label__ = 30; break;
    case 27: // $124
      $1=35;
      __label__ = 30; break;
    case 28: // $125
      __label__ = 29; break;
    case 29: // $126
      __label__ = 1; break;
    case 30: // $127
      var $128=$1;
      STACKTOP = __stackBase__;
      return $128;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15epilogProcessorP16XML_ParserStructPKcS2_PS2_["X"]=1;

function __ZL14doCdataSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h($parser, $enc, $startPtr, $end, $nextPtr, $haveMore) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $s=__stackBase__;
      var $eventPP;
      var $eventEndPP;
      var $next=__stackBase__+4;
      var $tok;
      var $c=__stackBase__+8;
      var $charDataHandler;
      var $dataPtr=__stackBase__+12;
      $2=$parser;
      $3=$enc;
      $4=$startPtr;
      $5=$end;
      $6=$nextPtr;
      $7=$haveMore;
      var $8=$4;
      var $9=HEAP32[(($8)>>2)];
      HEAP32[(($s)>>2)]=$9;
      var $10=$3;
      var $11=$2;
      var $12=(($11+144)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($10)|0)==(($13)|0);
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$2;
      var $17=(($16+288)|0);
      $eventPP=$17;
      var $18=HEAP32[(($s)>>2)];
      var $19=$eventPP;
      HEAP32[(($19)>>2)]=$18;
      var $20=$2;
      var $21=(($20+292)|0);
      $eventEndPP=$21;
      __label__ = 3; break;
    case 2: // $22
      var $23=$2;
      var $24=(($23+300)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0);
      $eventPP=$26;
      var $27=$2;
      var $28=(($27+300)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+4)|0);
      $eventEndPP=$30;
      __label__ = 3; break;
    case 3: // $31
      var $32=HEAP32[(($s)>>2)];
      var $33=$eventPP;
      HEAP32[(($33)>>2)]=$32;
      var $34=$4;
      HEAP32[(($34)>>2)]=0;
      __label__ = 4; break;
    case 4: // $35
      var $36=$3;
      var $37=(($36)|0);
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$3;
      var $41=HEAP32[(($s)>>2)];
      var $42=$5;
      var $43=FUNCTION_TABLE[$39]($40, $41, $42, $next);
      $tok=$43;
      var $44=HEAP32[(($next)>>2)];
      var $45=$eventEndPP;
      HEAP32[(($45)>>2)]=$44;
      var $46=$tok;
      if ($46 == 40) {
        __label__ = 5; break;
      }
      else if ($46 == 7) {
        __label__ = 13; break;
      }
      else if ($46 == 6) {
        __label__ = 19; break;
      }
      else if ($46 == 0) {
        __label__ = 32; break;
      }
      else if ($46 == -2) {
        __label__ = 33; break;
      }
      else if ($46 == -1 || $46 == -4) {
        __label__ = 36; break;
      }
      else {
      __label__ = 39; break;
      }
      
    case 5: // $47
      var $48=$2;
      var $49=(($48+76)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50)|0)!=0;
      if ($51) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $52
      var $53=$2;
      var $54=(($53+76)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$2;
      var $57=(($56+4)|0);
      var $58=HEAP32[(($57)>>2)];
      FUNCTION_TABLE[$55]($58);
      __label__ = 10; break;
    case 7: // $59
      var $60=$2;
      var $61=(($60+80)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $64
      var $65=$2;
      var $66=$3;
      var $67=HEAP32[(($s)>>2)];
      var $68=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($65, $66, $67, $68);
      __label__ = 9; break;
    case 9: // $69
      __label__ = 10; break;
    case 10: // $70
      var $71=HEAP32[(($next)>>2)];
      var $72=$4;
      HEAP32[(($72)>>2)]=$71;
      var $73=HEAP32[(($next)>>2)];
      var $74=$6;
      HEAP32[(($74)>>2)]=$73;
      var $75=$2;
      var $76=(($75+480)|0);
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78)|0)==2;
      if ($79) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $80
      $1=35;
      __label__ = 45; break;
    case 12: // $81
      $1=0;
      __label__ = 45; break;
    case 13: // $82
      var $83=$2;
      var $84=(($83+60)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      HEAP8[($c)]=10;
      var $88=$2;
      var $89=(($88+60)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$2;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      FUNCTION_TABLE[$90]($93, $c, 1);
      __label__ = 18; break;
    case 15: // $94
      var $95=$2;
      var $96=(($95+80)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $99
      var $100=$2;
      var $101=$3;
      var $102=HEAP32[(($s)>>2)];
      var $103=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($100, $101, $102, $103);
      __label__ = 17; break;
    case 17: // $104
      __label__ = 18; break;
    case 18: // $105
      __label__ = 40; break;
    case 19: // $106
      var $107=$2;
      var $108=(($107+60)|0);
      var $109=HEAP32[(($108)>>2)];
      $charDataHandler=$109;
      var $110=$charDataHandler;
      var $111=(($110)|0)!=0;
      if ($111) { __label__ = 20; break; } else { __label__ = 28; break; }
    case 20: // $112
      var $113=$3;
      var $114=(($113+72)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24)!=0;
      if ($116) { __label__ = 26; break; } else { __label__ = 21; break; }
    case 21: // $117
      __label__ = 22; break;
    case 22: // $118
      var $119=$2;
      var $120=(($119+44)|0);
      var $121=HEAP32[(($120)>>2)];
      HEAP32[(($dataPtr)>>2)]=$121;
      var $122=$3;
      var $123=(($122+60)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$3;
      var $126=HEAP32[(($next)>>2)];
      var $127=$2;
      var $128=(($127+48)|0);
      var $129=HEAP32[(($128)>>2)];
      FUNCTION_TABLE[$124]($125, $s, $126, $dataPtr, $129);
      var $130=HEAP32[(($next)>>2)];
      var $131=$eventEndPP;
      HEAP32[(($131)>>2)]=$130;
      var $132=$charDataHandler;
      var $133=$2;
      var $134=(($133+4)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$2;
      var $137=(($136+44)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=HEAP32[(($dataPtr)>>2)];
      var $140=$2;
      var $141=(($140+44)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$139;
      var $144=$142;
      var $145=(($143-$144)|0);
      FUNCTION_TABLE[$132]($135, $138, $145);
      var $146=HEAP32[(($s)>>2)];
      var $147=HEAP32[(($next)>>2)];
      var $148=(($146)|0)==(($147)|0);
      if ($148) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $149
      __label__ = 25; break;
    case 24: // $150
      var $151=HEAP32[(($s)>>2)];
      var $152=$eventPP;
      HEAP32[(($152)>>2)]=$151;
      __label__ = 22; break;
    case 25: // $153
      __label__ = 27; break;
    case 26: // $154
      var $155=$charDataHandler;
      var $156=$2;
      var $157=(($156+4)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=HEAP32[(($s)>>2)];
      var $160=HEAP32[(($next)>>2)];
      var $161=HEAP32[(($s)>>2)];
      var $162=$160;
      var $163=$161;
      var $164=(($162-$163)|0);
      FUNCTION_TABLE[$155]($158, $159, $164);
      __label__ = 27; break;
    case 27: // $165
      __label__ = 31; break;
    case 28: // $166
      var $167=$2;
      var $168=(($167+80)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169)|0)!=0;
      if ($170) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $171
      var $172=$2;
      var $173=$3;
      var $174=HEAP32[(($s)>>2)];
      var $175=HEAP32[(($next)>>2)];
      __ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_($172, $173, $174, $175);
      __label__ = 30; break;
    case 30: // $176
      __label__ = 31; break;
    case 31: // $177
      __label__ = 40; break;
    case 32: // $178
      var $179=HEAP32[(($next)>>2)];
      var $180=$eventPP;
      HEAP32[(($180)>>2)]=$179;
      $1=4;
      __label__ = 45; break;
    case 33: // $181
      var $182=$7;
      var $183=(($182 << 24) >> 24)!=0;
      if ($183) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $184
      var $185=HEAP32[(($s)>>2)];
      var $186=$6;
      HEAP32[(($186)>>2)]=$185;
      $1=0;
      __label__ = 45; break;
    case 35: // $187
      $1=6;
      __label__ = 45; break;
    case 36: // $188
      var $189=$7;
      var $190=(($189 << 24) >> 24)!=0;
      if ($190) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $191
      var $192=HEAP32[(($s)>>2)];
      var $193=$6;
      HEAP32[(($193)>>2)]=$192;
      $1=0;
      __label__ = 45; break;
    case 38: // $194
      $1=20;
      __label__ = 45; break;
    case 39: // $195
      var $196=HEAP32[(($next)>>2)];
      var $197=$eventPP;
      HEAP32[(($197)>>2)]=$196;
      $1=23;
      __label__ = 45; break;
    case 40: // $198
      var $199=HEAP32[(($next)>>2)];
      HEAP32[(($s)>>2)]=$199;
      var $200=$eventPP;
      HEAP32[(($200)>>2)]=$199;
      var $201=$2;
      var $202=(($201+480)|0);
      var $203=(($202)|0);
      var $204=HEAP32[(($203)>>2)];
      if ($204 == 3) {
        __label__ = 41; break;
      }
      else if ($204 == 2) {
        __label__ = 42; break;
      }
      else {
      __label__ = 43; break;
      }
      
    case 41: // $205
      var $206=HEAP32[(($next)>>2)];
      var $207=$6;
      HEAP32[(($207)>>2)]=$206;
      $1=0;
      __label__ = 45; break;
    case 42: // $208
      $1=35;
      __label__ = 45; break;
    case 43: // $209
      __label__ = 44; break;
    case 44: // $210
      __label__ = 4; break;
    case 45: // $211
      var $212=$1;
      STACKTOP = __stackBase__;
      return $212;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14doCdataSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h["X"]=1;

function __ZL21cdataSectionProcessorP16XML_ParserStructPKcS2_PS2_($parser, $start, $end, $endPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $result;
      $2=$parser;
      HEAP32[(($3)>>2)]=$start;
      $4=$end;
      $5=$endPtr;
      var $6=$2;
      var $7=$2;
      var $8=(($7+144)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$4;
      var $11=$5;
      var $12=$2;
      var $13=(($12+480)|0);
      var $14=(($13+4)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24)!=0;
      var $17=$16 ^ 1;
      var $18=(($17)&1);
      var $19=__ZL14doCdataSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h($6, $9, $3, $10, $11, $18);
      $result=$19;
      var $20=$result;
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=$result;
      $1=$23;
      __label__ = 7; break;
    case 2: // $24
      var $25=HEAP32[(($3)>>2)];
      var $26=(($25)|0)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $27
      var $28=$2;
      var $29=(($28+476)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $32
      var $33=$2;
      var $34=(($33+280)|0);
      HEAP32[(($34)>>2)]=1522;
      var $35=$2;
      var $36=HEAP32[(($3)>>2)];
      var $37=$4;
      var $38=$5;
      var $39=__ZL30externalEntityContentProcessorP16XML_ParserStructPKcS2_PS2_($35, $36, $37, $38);
      $1=$39;
      __label__ = 7; break;
    case 5: // $40
      var $41=$2;
      var $42=(($41+280)|0);
      HEAP32[(($42)>>2)]=1506;
      var $43=$2;
      var $44=HEAP32[(($3)>>2)];
      var $45=$4;
      var $46=$5;
      var $47=__ZL16contentProcessorP16XML_ParserStructPKcS2_PS2_($43, $44, $45, $46);
      $1=$47;
      __label__ = 7; break;
    case 6: // $48
      var $49=$result;
      $1=$49;
      __label__ = 7; break;
    case 7: // $50
      var $51=$1;
      STACKTOP = __stackBase__;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21cdataSectionProcessorP16XML_ParserStructPKcS2_PS2_["X"]=1;

function __ZL30externalEntityContentProcessorP16XML_ParserStructPKcS2_PS2_($parser, $start, $end, $endPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $result;
      $2=$parser;
      $3=$start;
      $4=$end;
      $5=$endPtr;
      var $6=$2;
      var $7=$2;
      var $8=(($7+144)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$3;
      var $11=$4;
      var $12=$5;
      var $13=$2;
      var $14=(($13+480)|0);
      var $15=(($14+4)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24)!=0;
      var $18=$17 ^ 1;
      var $19=(($18)&1);
      var $20=__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h($6, 1, $9, $10, $11, $12, $19);
      $result=$20;
      var $21=$result;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $23
      var $24=$2;
      var $25=__ZL13storeRawNamesP16XML_ParserStruct($24);
      var $26=(($25 << 24) >> 24)!=0;
      if ($26) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $27
      $1=1;
      __label__ = 5; break;
    case 3: // $28
      __label__ = 4; break;
    case 4: // $29
      var $30=$result;
      $1=$30;
      __label__ = 5; break;
    case 5: // $31
      var $32=$1;
      ;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL13storeRawNamesP16XML_ParserStruct($parser) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tag;
      var $bufSize;
      var $nameLen;
      var $rawNameBuf;
      var $temp;
      $2=$parser;
      var $3=$2;
      var $4=(($3+364)|0);
      var $5=HEAP32[(($4)>>2)];
      $tag=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$tag;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $9
      var $10=$tag;
      var $11=(($10+12)|0);
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+1)|0);
      var $15=(($14)|0);
      $nameLen=$15;
      var $16=$tag;
      var $17=(($16+36)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$nameLen;
      var $20=(($18+$19)|0);
      $rawNameBuf=$20;
      var $21=$tag;
      var $22=(($21+4)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$rawNameBuf;
      var $25=(($23)|0)==(($24)|0);
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $26
      __label__ = 13; break;
    case 4: // $27
      var $28=$nameLen;
      var $29=$tag;
      var $30=(($29+8)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0);
      var $33=(($28+$32)|0);
      $bufSize=$33;
      var $34=$bufSize;
      var $35=$tag;
      var $36=(($35+40)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$tag;
      var $39=(($38+36)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$37;
      var $42=$40;
      var $43=(($41-$42)|0);
      var $44=(($34)|0) > (($43)|0);
      if ($44) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $45
      var $46=$2;
      var $47=(($46+12)|0);
      var $48=(($47+4)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=$tag;
      var $51=(($50+36)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$bufSize;
      var $54=FUNCTION_TABLE[$49]($52, $53);
      $temp=$54;
      var $55=$temp;
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $57
      $1=0;
      __label__ = 14; break;
    case 7: // $58
      var $59=$tag;
      var $60=(($59+12)|0);
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$tag;
      var $64=(($63+36)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($62)|0)==(($65)|0);
      if ($66) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $67
      var $68=$temp;
      var $69=$tag;
      var $70=(($69+12)|0);
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=$68;
      __label__ = 9; break;
    case 9: // $72
      var $73=$tag;
      var $74=(($73+12)|0);
      var $75=(($74+4)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)!=0;
      if ($77) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $78
      var $79=$temp;
      var $80=$tag;
      var $81=(($80+12)|0);
      var $82=(($81+4)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$tag;
      var $85=(($84+36)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$83;
      var $88=$86;
      var $89=(($87-$88)|0);
      var $90=(($79+$89)|0);
      var $91=$tag;
      var $92=(($91+12)|0);
      var $93=(($92+4)|0);
      HEAP32[(($93)>>2)]=$90;
      __label__ = 11; break;
    case 11: // $94
      var $95=$temp;
      var $96=$tag;
      var $97=(($96+36)|0);
      HEAP32[(($97)>>2)]=$95;
      var $98=$temp;
      var $99=$bufSize;
      var $100=(($98+$99)|0);
      var $101=$tag;
      var $102=(($101+40)|0);
      HEAP32[(($102)>>2)]=$100;
      var $103=$temp;
      var $104=$nameLen;
      var $105=(($103+$104)|0);
      $rawNameBuf=$105;
      __label__ = 12; break;
    case 12: // $106
      var $107=$rawNameBuf;
      var $108=$tag;
      var $109=(($108+4)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$tag;
      var $112=(($111+8)|0);
      var $113=HEAP32[(($112)>>2)];
      assert($113 % 1 === 0, 'memcpy given ' + $113 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($107, $110, $113, 1);
      var $114=$rawNameBuf;
      var $115=$tag;
      var $116=(($115+4)|0);
      HEAP32[(($116)>>2)]=$114;
      var $117=$tag;
      var $118=(($117)|0);
      var $119=HEAP32[(($118)>>2)];
      $tag=$119;
      __label__ = 1; break;
    case 13: // $120
      $1=1;
      __label__ = 14; break;
    case 14: // $121
      var $122=$1;
      ;
      return $122;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13storeRawNamesP16XML_ParserStruct["X"]=1;

function __ZL20setElementTypePrefixP16XML_ParserStructP12ELEMENT_TYPE($parser, $elementType) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $dtd;
      var $name;
      var $prefix;
      var $s;
      $2=$parser;
      $3=$elementType;
      var $4=$2;
      var $5=(($4+356)|0);
      var $6=HEAP32[(($5)>>2)];
      $dtd=$6;
      var $7=$3;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      $name=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$name;
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24)!=0;
      if ($13) { __label__ = 2; break; } else { __label__ = 27; break; }
    case 2: // $14
      var $15=$name;
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)==58;
      if ($18) { __label__ = 3; break; } else { __label__ = 25; break; }
    case 3: // $19
      var $20=$3;
      var $21=(($20)|0);
      var $22=HEAP32[(($21)>>2)];
      $s=$22;
      __label__ = 4; break;
    case 4: // $23
      var $24=$s;
      var $25=$name;
      var $26=(($24)|0)!=(($25)|0);
      if ($26) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $27
      var $28=$dtd;
      var $29=(($28+80)|0);
      var $30=(($29+12)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$dtd;
      var $33=(($32+80)|0);
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($31)|0)==(($35)|0);
      if ($36) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $37
      var $38=$dtd;
      var $39=(($38+80)|0);
      var $40=__ZL8poolGrowP11STRING_POOL($39);
      var $41=(($40 << 24) >> 24)!=0;
      if ($41) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $42
      var $52 = 0;__label__ = 9; break;
    case 8: // $43
      var $44=$s;
      var $45=HEAP8[($44)];
      var $46=$dtd;
      var $47=(($46+80)|0);
      var $48=(($47+12)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+1)|0);
      HEAP32[(($48)>>2)]=$50;
      HEAP8[($49)]=$45;
      var $52 = 1;__label__ = 9; break;
    case 9: // $51
      var $52;
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $54
      $1=0;
      __label__ = 28; break;
    case 11: // $55
      __label__ = 12; break;
    case 12: // $56
      var $57=$s;
      var $58=(($57+1)|0);
      $s=$58;
      __label__ = 4; break;
    case 13: // $59
      var $60=$dtd;
      var $61=(($60+80)|0);
      var $62=(($61+12)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$dtd;
      var $65=(($64+80)|0);
      var $66=(($65+8)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($63)|0)==(($67)|0);
      if ($68) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $69
      var $70=$dtd;
      var $71=(($70+80)|0);
      var $72=__ZL8poolGrowP11STRING_POOL($71);
      var $73=(($72 << 24) >> 24)!=0;
      if ($73) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $74
      var $82 = 0;__label__ = 17; break;
    case 16: // $75
      var $76=$dtd;
      var $77=(($76+80)|0);
      var $78=(($77+12)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79+1)|0);
      HEAP32[(($78)>>2)]=$80;
      HEAP8[($79)]=0;
      var $82 = 1;__label__ = 17; break;
    case 17: // $81
      var $82;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $84
      $1=0;
      __label__ = 28; break;
    case 19: // $85
      var $86=$dtd;
      var $87=(($86+60)|0);
      var $88=$dtd;
      var $89=(($88+80)|0);
      var $90=(($89+16)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=__ZL6lookupP10HASH_TABLEPKcj($87, $91, 8);
      var $93=$92;
      $prefix=$93;
      var $94=$prefix;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $96
      $1=0;
      __label__ = 28; break;
    case 21: // $97
      var $98=$prefix;
      var $99=(($98)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$dtd;
      var $102=(($101+80)|0);
      var $103=(($102+16)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($100)|0)==(($104)|0);
      if ($105) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $106
      var $107=$dtd;
      var $108=(($107+80)|0);
      var $109=(($108+12)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$dtd;
      var $112=(($111+80)|0);
      var $113=(($112+16)|0);
      HEAP32[(($113)>>2)]=$110;
      __label__ = 24; break;
    case 23: // $114
      var $115=$dtd;
      var $116=(($115+80)|0);
      var $117=(($116+16)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$dtd;
      var $120=(($119+80)|0);
      var $121=(($120+12)|0);
      HEAP32[(($121)>>2)]=$118;
      __label__ = 24; break;
    case 24: // $122
      var $123=$prefix;
      var $124=$3;
      var $125=(($124+4)|0);
      HEAP32[(($125)>>2)]=$123;
      __label__ = 25; break;
    case 25: // $126
      __label__ = 26; break;
    case 26: // $127
      var $128=$name;
      var $129=(($128+1)|0);
      $name=$129;
      __label__ = 1; break;
    case 27: // $130
      $1=1;
      __label__ = 28; break;
    case 28: // $131
      var $132=$1;
      ;
      return $132;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20setElementTypePrefixP16XML_ParserStructP12ELEMENT_TYPE["X"]=1;

function __ZL20appendAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL($parser, $enc, $isCdata, $ptr, $end, $pool) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $dtd;
      var $next=__stackBase__;
      var $tok;
      var $buf=__stackBase__+4;
      var $i;
      var $n;
      var $name;
      var $entity;
      var $checkEntityDecl;
      var $ch;
      var $result;
      var $textEnd;
      $2=$parser;
      $3=$enc;
      $4=$isCdata;
      $5=$ptr;
      $6=$end;
      $7=$pool;
      var $8=$2;
      var $9=(($8+356)|0);
      var $10=HEAP32[(($9)>>2)];
      $dtd=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$3;
      var $13=(($12+16)|0);
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$3;
      var $17=$5;
      var $18=$6;
      var $19=FUNCTION_TABLE[$15]($16, $17, $18, $next);
      $tok=$19;
      var $20=$tok;
      if ($20 == -4) {
        __label__ = 2; break;
      }
      else if ($20 == 0) {
        __label__ = 3; break;
      }
      else if ($20 == -1) {
        __label__ = 6; break;
      }
      else if ($20 == 10) {
        __label__ = 9; break;
      }
      else if ($20 == 6) {
        __label__ = 33; break;
      }
      else if ($20 == -3) {
        __label__ = 36; break;
      }
      else if ($20 == 39 || $20 == 7) {
        __label__ = 37; break;
      }
      else if ($20 == 9) {
        __label__ = 48; break;
      }
      else {
      __label__ = 94; break;
      }
      
    case 2: // $21
      $1=0;
      __label__ = 98; break;
    case 3: // $22
      var $23=$3;
      var $24=$2;
      var $25=(($24+144)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($23)|0)==(($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=HEAP32[(($next)>>2)];
      var $30=$2;
      var $31=(($30+288)|0);
      HEAP32[(($31)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $32
      $1=4;
      __label__ = 98; break;
    case 6: // $33
      var $34=$3;
      var $35=$2;
      var $36=(($35+144)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($34)|0)==(($37)|0);
      if ($38) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $39
      var $40=$5;
      var $41=$2;
      var $42=(($41+288)|0);
      HEAP32[(($42)>>2)]=$40;
      __label__ = 8; break;
    case 8: // $43
      $1=4;
      __label__ = 98; break;
    case 9: // $44
      var $45=$3;
      var $46=(($45+44)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$3;
      var $49=$5;
      var $50=FUNCTION_TABLE[$47]($48, $49);
      $n=$50;
      var $51=$n;
      var $52=(($51)|0) < 0;
      if ($52) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $53
      var $54=$3;
      var $55=$2;
      var $56=(($55+144)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($54)|0)==(($57)|0);
      if ($58) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $59
      var $60=$5;
      var $61=$2;
      var $62=(($61+288)|0);
      HEAP32[(($62)>>2)]=$60;
      __label__ = 12; break;
    case 12: // $63
      $1=14;
      __label__ = 98; break;
    case 13: // $64
      var $65=$4;
      var $66=(($65 << 24) >> 24)!=0;
      if ($66) { __label__ = 18; break; } else { __label__ = 14; break; }
    case 14: // $67
      var $68=$n;
      var $69=(($68)|0)==32;
      if ($69) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $70
      var $71=$7;
      var $72=(($71+12)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$7;
      var $75=(($74+16)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$73;
      var $78=$76;
      var $79=(($77-$78)|0);
      var $80=(($79)|0)==0;
      if ($80) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $81
      var $82=$7;
      var $83=(($82+12)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84-1)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($87)|0)==32;
      if ($88) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $89
      __label__ = 97; break;
    case 18: // $90
      var $91=$n;
      var $92=(($buf)|0);
      var $93=_XmlUtf8Encode($91, $92);
      $n=$93;
      var $94=$n;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 22; break; } else { __label__ = 19; break; }
    case 19: // $96
      var $97=$3;
      var $98=$2;
      var $99=(($98+144)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($97)|0)==(($100)|0);
      if ($101) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $102
      var $103=$5;
      var $104=$2;
      var $105=(($104+288)|0);
      HEAP32[(($105)>>2)]=$103;
      __label__ = 21; break;
    case 21: // $106
      $1=14;
      __label__ = 98; break;
    case 22: // $107
      $i=0;
      __label__ = 23; break;
    case 23: // $108
      var $109=$i;
      var $110=$n;
      var $111=(($109)|0) < (($110)|0);
      if ($111) { __label__ = 24; break; } else { __label__ = 32; break; }
    case 24: // $112
      var $113=$7;
      var $114=(($113+12)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=$7;
      var $117=(($116+8)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($115)|0)==(($118)|0);
      if ($119) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $120
      var $121=$7;
      var $122=__ZL8poolGrowP11STRING_POOL($121);
      var $123=(($122 << 24) >> 24)!=0;
      if ($123) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $124
      var $134 = 0;__label__ = 28; break;
    case 27: // $125
      var $126=$i;
      var $127=(($buf+$126)|0);
      var $128=HEAP8[($127)];
      var $129=$7;
      var $130=(($129+12)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($131+1)|0);
      HEAP32[(($130)>>2)]=$132;
      HEAP8[($131)]=$128;
      var $134 = 1;__label__ = 28; break;
    case 28: // $133
      var $134;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $136
      $1=1;
      __label__ = 98; break;
    case 30: // $137
      __label__ = 31; break;
    case 31: // $138
      var $139=$i;
      var $140=(($139+1)|0);
      $i=$140;
      __label__ = 23; break;
    case 32: // $141
      __label__ = 97; break;
    case 33: // $142
      var $143=$7;
      var $144=$3;
      var $145=$5;
      var $146=HEAP32[(($next)>>2)];
      var $147=__ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_($143, $144, $145, $146);
      var $148=(($147)|0)!=0;
      if ($148) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $149
      $1=1;
      __label__ = 98; break;
    case 35: // $150
      __label__ = 97; break;
    case 36: // $151
      var $152=$5;
      var $153=$3;
      var $154=(($153+68)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($152+$155)|0);
      HEAP32[(($next)>>2)]=$156;
      __label__ = 37; break;
    case 37: // $157
      var $158=$4;
      var $159=(($158 << 24) >> 24)!=0;
      if ($159) { __label__ = 41; break; } else { __label__ = 38; break; }
    case 38: // $160
      var $161=$7;
      var $162=(($161+12)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$7;
      var $165=(($164+16)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$163;
      var $168=$166;
      var $169=(($167-$168)|0);
      var $170=(($169)|0)==0;
      if ($170) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $171
      var $172=$7;
      var $173=(($172+12)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=(($174-1)|0);
      var $176=HEAP8[($175)];
      var $177=(($176 << 24) >> 24);
      var $178=(($177)|0)==32;
      if ($178) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $179
      __label__ = 97; break;
    case 41: // $180
      var $181=$7;
      var $182=(($181+12)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$7;
      var $185=(($184+8)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($183)|0)==(($186)|0);
      if ($187) { __label__ = 42; break; } else { __label__ = 44; break; }
    case 42: // $188
      var $189=$7;
      var $190=__ZL8poolGrowP11STRING_POOL($189);
      var $191=(($190 << 24) >> 24)!=0;
      if ($191) { __label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $192
      var $199 = 0;__label__ = 45; break;
    case 44: // $193
      var $194=$7;
      var $195=(($194+12)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196+1)|0);
      HEAP32[(($195)>>2)]=$197;
      HEAP8[($196)]=32;
      var $199 = 1;__label__ = 45; break;
    case 45: // $198
      var $199;
      var $200=(($199)|0)!=0;
      if ($200) { __label__ = 47; break; } else { __label__ = 46; break; }
    case 46: // $201
      $1=1;
      __label__ = 98; break;
    case 47: // $202
      __label__ = 97; break;
    case 48: // $203
      var $204=$3;
      var $205=(($204+48)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=$3;
      var $208=$5;
      var $209=$3;
      var $210=(($209+68)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=(($208+$211)|0);
      var $213=HEAP32[(($next)>>2)];
      var $214=$3;
      var $215=(($214+68)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(((-$216))|0);
      var $218=(($213+$217)|0);
      var $219=FUNCTION_TABLE[$206]($207, $212, $218);
      var $220=(($219) & 255);
      $ch=$220;
      var $221=$ch;
      var $222=(($221 << 24) >> 24)!=0;
      if ($222) { __label__ = 49; break; } else { __label__ = 56; break; }
    case 49: // $223
      var $224=$7;
      var $225=(($224+12)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$7;
      var $228=(($227+8)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=(($226)|0)==(($229)|0);
      if ($230) { __label__ = 50; break; } else { __label__ = 52; break; }
    case 50: // $231
      var $232=$7;
      var $233=__ZL8poolGrowP11STRING_POOL($232);
      var $234=(($233 << 24) >> 24)!=0;
      if ($234) { __label__ = 52; break; } else { __label__ = 51; break; }
    case 51: // $235
      var $243 = 0;__label__ = 53; break;
    case 52: // $236
      var $237=$ch;
      var $238=$7;
      var $239=(($238+12)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=(($240+1)|0);
      HEAP32[(($239)>>2)]=$241;
      HEAP8[($240)]=$237;
      var $243 = 1;__label__ = 53; break;
    case 53: // $242
      var $243;
      var $244=(($243)|0)!=0;
      if ($244) { __label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $245
      $1=1;
      __label__ = 98; break;
    case 55: // $246
      __label__ = 97; break;
    case 56: // $247
      var $248=$2;
      var $249=(($248+440)|0);
      var $250=$3;
      var $251=$5;
      var $252=$3;
      var $253=(($252+68)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($251+$254)|0);
      var $256=HEAP32[(($next)>>2)];
      var $257=$3;
      var $258=(($257+68)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=(((-$259))|0);
      var $261=(($256+$260)|0);
      var $262=__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_($249, $250, $255, $261);
      $name=$262;
      var $263=$name;
      var $264=(($263)|0)!=0;
      if ($264) { __label__ = 58; break; } else { __label__ = 57; break; }
    case 57: // $265
      $1=1;
      __label__ = 98; break;
    case 58: // $266
      var $267=$dtd;
      var $268=(($267)|0);
      var $269=$name;
      var $270=__ZL6lookupP10HASH_TABLEPKcj($268, $269, 0);
      var $271=$270;
      $entity=$271;
      var $272=$2;
      var $273=(($272+440)|0);
      var $274=(($273+16)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=$2;
      var $277=(($276+440)|0);
      var $278=(($277+12)|0);
      HEAP32[(($278)>>2)]=$275;
      var $279=$7;
      var $280=$dtd;
      var $281=(($280+80)|0);
      var $282=(($279)|0)==(($281)|0);
      if ($282) { __label__ = 59; break; } else { __label__ = 65; break; }
    case 59: // $283
      var $284=$2;
      var $285=(($284+256)|0);
      var $286=(($285+16)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)!=0;
      if ($288) { __label__ = 60; break; } else { var $309 = 0;__label__ = 64; break; }
    case 60: // $289
      var $290=$dtd;
      var $291=(($290+130)|0);
      var $292=HEAP8[($291)];
      var $293=(($292 << 24) >> 24)!=0;
      if ($293) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $294
      var $295=$2;
      var $296=(($295+300)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=(($297)|0)!=0;
      var $299=$298 ^ 1;
      var $307 = $299;__label__ = 63; break;
    case 62: // $300
      var $301=$dtd;
      var $302=(($301+129)|0);
      var $303=HEAP8[($302)];
      var $304=(($303 << 24) >> 24)!=0;
      var $305=$304 ^ 1;
      var $307 = $305;__label__ = 63; break;
    case 63: // $306
      var $307;
      var $309 = $307;__label__ = 64; break;
    case 64: // $308
      var $309;
      var $310=(($309)&1);
      $checkEntityDecl=$310;
      __label__ = 68; break;
    case 65: // $311
      var $312=$dtd;
      var $313=(($312+129)|0);
      var $314=HEAP8[($313)];
      var $315=(($314 << 24) >> 24)!=0;
      if ($315) { __label__ = 66; break; } else { var $322 = 1;__label__ = 67; break; }
    case 66: // $316
      var $317=$dtd;
      var $318=(($317+130)|0);
      var $319=HEAP8[($318)];
      var $320=(($319 << 24) >> 24)!=0;
      var $322 = $320;__label__ = 67; break;
    case 67: // $321
      var $322;
      var $323=(($322)&1);
      $checkEntityDecl=$323;
      __label__ = 68; break;
    case 68: // $324
      var $325=$checkEntityDecl;
      var $326=(($325 << 24) >> 24)!=0;
      if ($326) { __label__ = 69; break; } else { __label__ = 75; break; }
    case 69: // $327
      var $328=$entity;
      var $329=(($328)|0)!=0;
      if ($329) { __label__ = 71; break; } else { __label__ = 70; break; }
    case 70: // $330
      $1=11;
      __label__ = 98; break;
    case 71: // $331
      var $332=$entity;
      var $333=(($332+34)|0);
      var $334=HEAP8[($333)];
      var $335=(($334 << 24) >> 24)!=0;
      if ($335) { __label__ = 73; break; } else { __label__ = 72; break; }
    case 72: // $336
      $1=24;
      __label__ = 98; break;
    case 73: // $337
      __label__ = 74; break;
    case 74: // $338
      __label__ = 78; break;
    case 75: // $339
      var $340=$entity;
      var $341=(($340)|0)!=0;
      if ($341) { __label__ = 77; break; } else { __label__ = 76; break; }
    case 76: // $342
      __label__ = 97; break;
    case 77: // $343
      __label__ = 78; break;
    case 78: // $344
      var $345=$entity;
      var $346=(($345+32)|0);
      var $347=HEAP8[($346)];
      var $348=(($347 << 24) >> 24)!=0;
      if ($348) { __label__ = 79; break; } else { __label__ = 82; break; }
    case 79: // $349
      var $350=$3;
      var $351=$2;
      var $352=(($351+144)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($350)|0)==(($353)|0);
      if ($354) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $355
      var $356=$5;
      var $357=$2;
      var $358=(($357+288)|0);
      HEAP32[(($358)>>2)]=$356;
      __label__ = 81; break;
    case 81: // $359
      $1=12;
      __label__ = 98; break;
    case 82: // $360
      var $361=$entity;
      var $362=(($361+28)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=(($363)|0)!=0;
      if ($364) { __label__ = 83; break; } else { __label__ = 86; break; }
    case 83: // $365
      var $366=$3;
      var $367=$2;
      var $368=(($367+144)|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=(($366)|0)==(($369)|0);
      if ($370) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $371
      var $372=$5;
      var $373=$2;
      var $374=(($373+288)|0);
      HEAP32[(($374)>>2)]=$372;
      __label__ = 85; break;
    case 85: // $375
      $1=15;
      __label__ = 98; break;
    case 86: // $376
      var $377=$entity;
      var $378=(($377+4)|0);
      var $379=HEAP32[(($378)>>2)];
      var $380=(($379)|0)!=0;
      if ($380) { __label__ = 90; break; } else { __label__ = 87; break; }
    case 87: // $381
      var $382=$3;
      var $383=$2;
      var $384=(($383+144)|0);
      var $385=HEAP32[(($384)>>2)];
      var $386=(($382)|0)==(($385)|0);
      if ($386) { __label__ = 88; break; } else { __label__ = 89; break; }
    case 88: // $387
      var $388=$5;
      var $389=$2;
      var $390=(($389+288)|0);
      HEAP32[(($390)>>2)]=$388;
      __label__ = 89; break;
    case 89: // $391
      $1=16;
      __label__ = 98; break;
    case 90: // $392
      var $393=$entity;
      var $394=(($393+4)|0);
      var $395=HEAP32[(($394)>>2)];
      var $396=$entity;
      var $397=(($396+8)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=(($395+$398)|0);
      $textEnd=$399;
      var $400=$entity;
      var $401=(($400+32)|0);
      HEAP8[($401)]=1;
      var $402=$2;
      var $403=$2;
      var $404=(($403+228)|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=$4;
      var $407=$entity;
      var $408=(($407+4)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=$textEnd;
      var $411=$7;
      var $412=__ZL20appendAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL($402, $405, $406, $409, $410, $411);
      $result=$412;
      var $413=$entity;
      var $414=(($413+32)|0);
      HEAP8[($414)]=0;
      var $415=$result;
      var $416=(($415)|0)!=0;
      if ($416) { __label__ = 91; break; } else { __label__ = 92; break; }
    case 91: // $417
      var $418=$result;
      $1=$418;
      __label__ = 98; break;
    case 92: // $419
      __label__ = 93; break;
    case 93: // $420
      __label__ = 97; break;
    case 94: // $421
      var $422=$3;
      var $423=$2;
      var $424=(($423+144)|0);
      var $425=HEAP32[(($424)>>2)];
      var $426=(($422)|0)==(($425)|0);
      if ($426) { __label__ = 95; break; } else { __label__ = 96; break; }
    case 95: // $427
      var $428=$5;
      var $429=$2;
      var $430=(($429+288)|0);
      HEAP32[(($430)>>2)]=$428;
      __label__ = 96; break;
    case 96: // $431
      $1=23;
      __label__ = 98; break;
    case 97: // $432
      var $433=HEAP32[(($next)>>2)];
      $5=$433;
      __label__ = 1; break;
    case 98: // $434
      var $435=$1;
      STACKTOP = __stackBase__;
      return $435;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20appendAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL["X"]=1;

function __ZL5errorP12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$state;
  $2=$tok;
  $3=$ptr;
  $4=$end;
  $5=$enc;
  ;
  return 0;
}


function __ZL8poolInitP11STRING_POOLPK25XML_Memory_Handling_Suite($pool, $ms) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$pool;
  $2=$ms;
  var $3=$1;
  var $4=(($3)|0);
  HEAP32[(($4)>>2)]=0;
  var $5=$1;
  var $6=(($5+4)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=$1;
  var $8=(($7+16)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=$1;
  var $10=(($9+12)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=$1;
  var $12=(($11+8)|0);
  HEAP32[(($12)>>2)]=0;
  var $13=$2;
  var $14=$1;
  var $15=(($14+20)|0);
  HEAP32[(($15)>>2)]=$13;
  ;
  return;
}


function __ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite($p, $ms) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$p;
  $2=$ms;
  var $3=$1;
  var $4=(($3+4)|0);
  HEAP8[($4)]=0;
  var $5=$1;
  var $6=(($5+8)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=$1;
  var $8=(($7+12)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=$1;
  var $10=(($9)|0);
  HEAP32[(($10)>>2)]=0;
  var $11=$2;
  var $12=$1;
  var $13=(($12+16)|0);
  HEAP32[(($13)>>2)]=$11;
  ;
  return;
}


function _XmlPrologStateInit($state) {
  ;
  var __label__;

  var $1;
  $1=$state;
  var $2=$1;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=1524;
  var $4=$1;
  var $5=(($4+16)|0);
  HEAP32[(($5)>>2)]=1;
  var $6=$1;
  var $7=(($6+12)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=$1;
  var $9=(($8+20)|0);
  HEAP32[(($9)>>2)]=0;
  ;
  return;
}


function __ZL6commonP12prolog_statei($state, $tok) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$state;
      $3=$tok;
      var $4=$2;
      var $5=(($4+16)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9)|0)==28;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      $1=59;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=1530;
      $1=-1;
      __label__ = 4; break;
    case 4: // $15
      var $16=$1;
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21handleUnknownEncodingP16XML_ParserStructPKc($parser, $encodingName) {
  var __stackBase__  = STACKTOP; STACKTOP += 1036; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $info=__stackBase__;
      var $i;
      var $enc;
      $2=$parser;
      $3=$encodingName;
      var $4=$2;
      var $5=(($4+124)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 19; break; }
    case 1: // $8
      $i=0;
      __label__ = 2; break;
    case 2: // $9
      var $10=$i;
      var $11=(($10)|0) < 256;
      if ($11) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $12
      var $13=$i;
      var $14=(($info)|0);
      var $15=(($14+($13<<2))|0);
      HEAP32[(($15)>>2)]=-1;
      __label__ = 4; break;
    case 4: // $16
      var $17=$i;
      var $18=(($17+1)|0);
      $i=$18;
      __label__ = 2; break;
    case 5: // $19
      var $20=(($info+1028)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($info+1024)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($info+1032)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=$2;
      var $24=(($23+124)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$2;
      var $27=(($26+248)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=FUNCTION_TABLE[$25]($28, $29, $info);
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 6; break; } else { __label__ = 16; break; }
    case 6: // $32
      var $33=$2;
      var $34=(($33+12)|0);
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=_XmlSizeOfUnknownEncoding();
      var $38=FUNCTION_TABLE[$36]($37);
      var $39=$2;
      var $40=(($39+240)|0);
      HEAP32[(($40)>>2)]=$38;
      var $41=$2;
      var $42=(($41+240)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 10; break; } else { __label__ = 7; break; }
    case 7: // $45
      var $46=(($info+1032)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $49
      var $50=(($info+1032)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($info+1024)|0);
      var $53=HEAP32[(($52)>>2)];
      FUNCTION_TABLE[$51]($53);
      __label__ = 9; break;
    case 9: // $54
      $1=1;
      __label__ = 20; break;
    case 10: // $55
      var $56=$2;
      var $57=(($56+236)|0);
      var $58=HEAP8[($57)];
      var $59=(($58 << 24) >> 24)!=0;
      if ($59) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      var $63 = 1558;__label__ = 13; break;
    case 12: // $61
      var $63 = 1560;__label__ = 13; break;
    case 13: // $62
      var $63;
      var $64=$2;
      var $65=(($64+240)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($info)|0);
      var $68=(($67)|0);
      var $69=(($info+1028)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($info+1024)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=FUNCTION_TABLE[$63]($66, $68, $70, $72);
      $enc=$73;
      var $74=$enc;
      var $75=(($74)|0)!=0;
      if ($75) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $76
      var $77=(($info+1024)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$2;
      var $80=(($79+244)|0);
      HEAP32[(($80)>>2)]=$78;
      var $81=(($info+1032)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$2;
      var $84=(($83+252)|0);
      HEAP32[(($84)>>2)]=$82;
      var $85=$enc;
      var $86=$2;
      var $87=(($86+144)|0);
      HEAP32[(($87)>>2)]=$85;
      $1=0;
      __label__ = 20; break;
    case 15: // $88
      __label__ = 16; break;
    case 16: // $89
      var $90=(($info+1032)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $93
      var $94=(($info+1032)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($info+1024)|0);
      var $97=HEAP32[(($96)>>2)];
      FUNCTION_TABLE[$95]($97);
      __label__ = 18; break;
    case 18: // $98
      __label__ = 19; break;
    case 19: // $99
      $1=18;
      __label__ = 20; break;
    case 20: // $100
      var $101=$1;
      STACKTOP = __stackBase__;
      return $101;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21handleUnknownEncodingP16XML_ParserStructPKc["X"]=1;

function __ZL19prologInitProcessorP16XML_ParserStructPKcS2_PS2_($parser, $s, $end, $nextPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $result;
      $2=$parser;
      $3=$s;
      $4=$end;
      $5=$nextPtr;
      var $6=$2;
      var $7=__ZL18initializeEncodingP16XML_ParserStruct($6);
      $result=$7;
      var $8=$result;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$result;
      $1=$11;
      __label__ = 3; break;
    case 2: // $12
      var $13=$2;
      var $14=(($13+280)|0);
      HEAP32[(($14)>>2)]=1514;
      var $15=$2;
      var $16=$3;
      var $17=$4;
      var $18=$5;
      var $19=__ZL15prologProcessorP16XML_ParserStructPKcS2_PS2_($15, $16, $17, $18);
      $1=$19;
      __label__ = 3; break;
    case 3: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9dtdCreatePK25XML_Memory_Handling_Suite($ms) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $p;
      $2=$ms;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=FUNCTION_TABLE[$5](188);
      var $7=$6;
      $p=$7;
      var $8=$p;
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$p;
      $1=$11;
      __label__ = 3; break;
    case 2: // $12
      var $13=$p;
      var $14=(($13+80)|0);
      var $15=$2;
      __ZL8poolInitP11STRING_POOLPK25XML_Memory_Handling_Suite($14, $15);
      var $16=$p;
      var $17=(($16+104)|0);
      var $18=$2;
      __ZL8poolInitP11STRING_POOLPK25XML_Memory_Handling_Suite($17, $18);
      var $19=$p;
      var $20=(($19)|0);
      var $21=$2;
      __ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite($20, $21);
      var $22=$p;
      var $23=(($22+20)|0);
      var $24=$2;
      __ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite($23, $24);
      var $25=$p;
      var $26=(($25+40)|0);
      var $27=$2;
      __ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite($26, $27);
      var $28=$p;
      var $29=(($28+60)|0);
      var $30=$2;
      __ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite($29, $30);
      var $31=$p;
      var $32=(($31+131)|0);
      HEAP8[($32)]=0;
      var $33=$p;
      var $34=(($33+132)|0);
      var $35=$2;
      __ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite($34, $35);
      var $36=$p;
      var $37=(($36+152)|0);
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=$p;
      var $40=(($39+152)|0);
      var $41=(($40+4)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=$p;
      var $43=(($42+160)|0);
      HEAP8[($43)]=0;
      var $44=$p;
      var $45=(($44+184)|0);
      HEAP32[(($45)>>2)]=0;
      var $46=$p;
      var $47=(($46+164)|0);
      HEAP32[(($47)>>2)]=0;
      var $48=$p;
      var $49=(($48+180)|0);
      HEAP32[(($49)>>2)]=0;
      var $50=$p;
      var $51=(($50+172)|0);
      HEAP32[(($51)>>2)]=0;
      var $52=$p;
      var $53=(($52+176)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$p;
      var $55=(($54+168)|0);
      HEAP32[(($55)>>2)]=0;
      var $56=$p;
      var $57=(($56+128)|0);
      HEAP8[($57)]=1;
      var $58=$p;
      var $59=(($58+129)|0);
      HEAP8[($59)]=0;
      var $60=$p;
      var $61=(($60+130)|0);
      HEAP8[($61)]=0;
      var $62=$p;
      $1=$62;
      __label__ = 3; break;
    case 3: // $63
      var $64=$1;
      ;
      return $64;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9dtdCreatePK25XML_Memory_Handling_Suite["X"]=1;

function __ZL7prolog0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 12) {
        __label__ = 2; break;
      }
      else if ($7 == 11) {
        __label__ = 3; break;
      }
      else if ($7 == 13) {
        __label__ = 4; break;
      }
      else if ($7 == 14) {
        __label__ = 5; break;
      }
      else if ($7 == 16) {
        __label__ = 6; break;
      }
      else if ($7 == 29) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 1: // $8
      var $9=$2;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=1526;
      $1=0;
      __label__ = 11; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=1526;
      $1=1;
      __label__ = 11; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=1526;
      $1=55;
      __label__ = 11; break;
    case 4: // $17
      var $18=$2;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=1526;
      $1=56;
      __label__ = 11; break;
    case 5: // $20
      $1=0;
      __label__ = 11; break;
    case 6: // $21
      var $22=$6;
      var $23=(($22+28)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$6;
      var $26=$4;
      var $27=$6;
      var $28=(($27+68)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=((($29<<1))|0);
      var $31=(($26+$30)|0);
      var $32=$5;
      var $33=FUNCTION_TABLE[$24]($25, $31, $32, ((STRING_TABLE.__ZL10KW_DOCTYPE)|0));
      var $34=(($33)|0)!=0;
      if ($34) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $35
      __label__ = 10; break;
    case 8: // $36
      var $37=$2;
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=1528;
      $1=3;
      __label__ = 11; break;
    case 9: // $39
      var $40=$2;
      var $41=(($40)|0);
      HEAP32[(($41)>>2)]=1530;
      $1=2;
      __label__ = 11; break;
    case 10: // $42
      var $43=$2;
      var $44=$3;
      var $45=__ZL6commonP12prolog_statei($43, $44);
      $1=$45;
      __label__ = 11; break;
    case 11: // $46
      var $47=$1;
      ;
      return $47;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7prolog0P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL15externalSubset1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 33) {
        __label__ = 1; break;
      }
      else if ($7 == 34) {
        __label__ = 2; break;
      }
      else if ($7 == 15) {
        __label__ = 5; break;
      }
      else if ($7 == 26) {
        __label__ = 10; break;
      }
      else if ($7 == -4) {
        __label__ = 6; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 1: // $8
      var $9=$2;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=1532;
      $1=0;
      __label__ = 11; break;
    case 2: // $11
      var $12=$2;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      __label__ = 10; break;
    case 4: // $17
      var $18=$2;
      var $19=(($18+12)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20-1)|0);
      HEAP32[(($19)>>2)]=$21;
      $1=0;
      __label__ = 11; break;
    case 5: // $22
      $1=0;
      __label__ = 11; break;
    case 6: // $23
      var $24=$2;
      var $25=(($24+12)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $28
      __label__ = 10; break;
    case 8: // $29
      $1=0;
      __label__ = 11; break;
    case 9: // $30
      var $31=$2;
      var $32=$3;
      var $33=$4;
      var $34=$5;
      var $35=$6;
      var $36=__ZL14internalSubsetP12prolog_stateiPKcS2_PK8encoding($31, $32, $33, $34, $35);
      $1=$36;
      __label__ = 11; break;
    case 10: // $37
      var $38=$2;
      var $39=$3;
      var $40=__ZL6commonP12prolog_statei($38, $39);
      $1=$40;
      __label__ = 11; break;
    case 11: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15externalSubset1P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL9condSect0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $8
      $1=0;
      __label__ = 8; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($13, $14, $15, ((STRING_TABLE.__ZL10KW_INCLUDE)|0));
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1534;
      $1=0;
      __label__ = 8; break;
    case 4: // $21
      var $22=$6;
      var $23=(($22+28)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$6;
      var $26=$4;
      var $27=$5;
      var $28=FUNCTION_TABLE[$24]($25, $26, $27, ((STRING_TABLE.__ZL9KW_IGNORE)|0));
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$2;
      var $32=(($31)|0);
      HEAP32[(($32)>>2)]=1536;
      $1=0;
      __label__ = 8; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$2;
      var $36=$3;
      var $37=__ZL6commonP12prolog_statei($35, $36);
      $1=$37;
      __label__ = 8; break;
    case 8: // $38
      var $39=$1;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9condSect0P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL14internalSubsetP12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 16) {
        __label__ = 2; break;
      }
      else if ($7 == 11) {
        __label__ = 11; break;
      }
      else if ($7 == 13) {
        __label__ = 12; break;
      }
      else if ($7 == 28) {
        __label__ = 13; break;
      }
      else if ($7 == 26) {
        __label__ = 14; break;
      }
      else if ($7 == -4) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 1: // $8
      $1=0;
      __label__ = 17; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$6;
      var $16=(($15+68)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=((($17<<1))|0);
      var $19=(($14+$18)|0);
      var $20=$5;
      var $21=FUNCTION_TABLE[$12]($13, $19, $20, ((STRING_TABLE.__ZL9KW_ENTITY)|0));
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      var $24=$2;
      var $25=(($24)|0);
      HEAP32[(($25)>>2)]=1538;
      $1=11;
      __label__ = 17; break;
    case 4: // $26
      var $27=$6;
      var $28=(($27+28)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$6;
      var $31=$4;
      var $32=$6;
      var $33=(($32+68)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=((($34<<1))|0);
      var $36=(($31+$35)|0);
      var $37=$5;
      var $38=FUNCTION_TABLE[$29]($30, $36, $37, ((STRING_TABLE.__ZL10KW_ATTLIST)|0));
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $40
      var $41=$2;
      var $42=(($41)|0);
      HEAP32[(($42)>>2)]=1540;
      $1=33;
      __label__ = 17; break;
    case 6: // $43
      var $44=$6;
      var $45=(($44+28)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$6;
      var $48=$4;
      var $49=$6;
      var $50=(($49+68)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=((($51<<1))|0);
      var $53=(($48+$52)|0);
      var $54=$5;
      var $55=FUNCTION_TABLE[$46]($47, $53, $54, ((STRING_TABLE.__ZL10KW_ELEMENT)|0));
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$2;
      var $59=(($58)|0);
      HEAP32[(($59)>>2)]=1542;
      $1=39;
      __label__ = 17; break;
    case 8: // $60
      var $61=$6;
      var $62=(($61+28)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$6;
      var $65=$4;
      var $66=$6;
      var $67=(($66+68)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=((($68<<1))|0);
      var $70=(($65+$69)|0);
      var $71=$5;
      var $72=FUNCTION_TABLE[$63]($64, $70, $71, ((STRING_TABLE.__ZL11KW_NOTATION)|0));
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $74
      var $75=$2;
      var $76=(($75)|0);
      HEAP32[(($76)>>2)]=1544;
      $1=17;
      __label__ = 17; break;
    case 10: // $77
      __label__ = 16; break;
    case 11: // $78
      $1=55;
      __label__ = 17; break;
    case 12: // $79
      $1=56;
      __label__ = 17; break;
    case 13: // $80
      $1=60;
      __label__ = 17; break;
    case 14: // $81
      var $82=$2;
      var $83=(($82)|0);
      HEAP32[(($83)>>2)]=1546;
      $1=3;
      __label__ = 17; break;
    case 15: // $84
      $1=0;
      __label__ = 17; break;
    case 16: // $85
      var $86=$2;
      var $87=$3;
      var $88=__ZL6commonP12prolog_statei($86, $87);
      $1=$88;
      __label__ = 17; break;
    case 17: // $89
      var $90=$1;
      ;
      return $90;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14internalSubsetP12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL7entity0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 22) {
        __label__ = 2; break;
      }
      else if ($7 == 18) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 5; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1548;
      $1=11;
      __label__ = 5; break;
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=1550;
      $1=9;
      __label__ = 5; break;
    case 4: // $15
      var $16=$2;
      var $17=$3;
      var $18=__ZL6commonP12prolog_statei($16, $17);
      $1=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1552;
      $1=34;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8element0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1554;
      $1=40;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9notation0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=17;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1556;
      $1=18;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8doctype5P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 17) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=3;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1562;
      $1=8;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7prolog2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 11) {
        __label__ = 2; break;
      }
      else if ($7 == 13) {
        __label__ = 3; break;
      }
      else if ($7 == 29) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $8
      $1=0;
      __label__ = 6; break;
    case 2: // $9
      $1=55;
      __label__ = 6; break;
    case 3: // $10
      $1=56;
      __label__ = 6; break;
    case 4: // $11
      var $12=$2;
      var $13=(($12)|0);
      HEAP32[(($13)>>2)]=1530;
      $1=2;
      __label__ = 6; break;
    case 5: // $14
      var $15=$2;
      var $16=$3;
      var $17=__ZL6commonP12prolog_statei($15, $16);
      $1=$17;
      __label__ = 6; break;
    case 6: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9notation1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $8
      $1=17;
      __label__ = 8; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($13, $14, $15, ((STRING_TABLE.__ZL9KW_SYSTEM)|0));
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1564;
      $1=17;
      __label__ = 8; break;
    case 4: // $21
      var $22=$6;
      var $23=(($22+28)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$6;
      var $26=$4;
      var $27=$5;
      var $28=FUNCTION_TABLE[$24]($25, $26, $27, ((STRING_TABLE.__ZL9KW_PUBLIC)|0));
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$2;
      var $32=(($31)|0);
      HEAP32[(($32)>>2)]=1566;
      $1=17;
      __label__ = 8; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$2;
      var $36=$3;
      var $37=__ZL6commonP12prolog_statei($35, $36);
      $1=$37;
      __label__ = 8; break;
    case 8: // $38
      var $39=$1;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL9notation1P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL9notation3P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=17;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1568;
      var $12=$2;
      var $13=(($12+8)|0);
      HEAP32[(($13)>>2)]=17;
      $1=19;
      __label__ = 4; break;
    case 3: // $14
      var $15=$2;
      var $16=$3;
      var $17=__ZL6commonP12prolog_statei($15, $16);
      $1=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9notation2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=17;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1570;
      $1=21;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9notation4P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else if ($7 == 17) {
        __label__ = 3; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $8
      $1=17;
      __label__ = 8; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1568;
      var $12=$2;
      var $13=(($12+8)|0);
      HEAP32[(($13)>>2)]=17;
      $1=19;
      __label__ = 8; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15+16)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $19
      var $22 = 1584;__label__ = 6; break;
    case 5: // $20
      var $22 = 1586;__label__ = 6; break;
    case 6: // $21
      var $22;
      var $23=$2;
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=$22;
      $1=20;
      __label__ = 8; break;
    case 7: // $25
      var $26=$2;
      var $27=$3;
      var $28=__ZL6commonP12prolog_statei($26, $27);
      $1=$28;
      __label__ = 8; break;
    case 8: // $29
      var $30=$1;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9declCloseP12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 17) {
        __label__ = 2; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 1: // $8
      var $9=$2;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      $1=$11;
      __label__ = 7; break;
    case 2: // $12
      var $13=$2;
      var $14=(($13+16)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $20 = 1584;__label__ = 5; break;
    case 4: // $18
      var $20 = 1586;__label__ = 5; break;
    case 5: // $19
      var $20;
      var $21=$2;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=$20;
      var $23=$2;
      var $24=(($23+8)|0);
      var $25=HEAP32[(($24)>>2)];
      $1=$25;
      __label__ = 7; break;
    case 6: // $26
      var $27=$2;
      var $28=$3;
      var $29=__ZL6commonP12prolog_statei($27, $28);
      $1=$29;
      __label__ = 7; break;
    case 7: // $30
      var $31=$1;
      ;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8element1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else if ($7 == 23) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 9; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($13, $14, $15, ((STRING_TABLE.__ZL8KW_EMPTY)|0));
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1568;
      var $21=$2;
      var $22=(($21+8)|0);
      HEAP32[(($22)>>2)]=39;
      $1=42;
      __label__ = 9; break;
    case 4: // $23
      var $24=$6;
      var $25=(($24+28)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$6;
      var $28=$4;
      var $29=$5;
      var $30=FUNCTION_TABLE[$26]($27, $28, $29, ((STRING_TABLE.__ZL6KW_ANY)|0));
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      var $33=$2;
      var $34=(($33)|0);
      HEAP32[(($34)>>2)]=1568;
      var $35=$2;
      var $36=(($35+8)|0);
      HEAP32[(($36)>>2)]=39;
      $1=41;
      __label__ = 9; break;
    case 6: // $37
      __label__ = 8; break;
    case 7: // $38
      var $39=$2;
      var $40=(($39)|0);
      HEAP32[(($40)>>2)]=1572;
      var $41=$2;
      var $42=(($41+4)|0);
      HEAP32[(($42)>>2)]=1;
      $1=44;
      __label__ = 9; break;
    case 8: // $43
      var $44=$2;
      var $45=$3;
      var $46=__ZL6commonP12prolog_statei($44, $45);
      $1=$46;
      __label__ = 9; break;
    case 9: // $47
      var $48=$1;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8element1P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8element2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 20) {
        __label__ = 2; break;
      }
      else if ($7 == 23) {
        __label__ = 5; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 6; break;
      }
      else if ($7 == 30) {
        __label__ = 7; break;
      }
      else if ($7 == 31) {
        __label__ = 8; break;
      }
      else if ($7 == 32) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 11; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$6;
      var $16=(($15+68)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($14+$17)|0);
      var $19=$5;
      var $20=FUNCTION_TABLE[$12]($13, $18, $19, ((STRING_TABLE.__ZL9KW_PCDATA)|0));
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$2;
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=1574;
      $1=43;
      __label__ = 11; break;
    case 4: // $25
      __label__ = 10; break;
    case 5: // $26
      var $27=$2;
      var $28=(($27+4)|0);
      HEAP32[(($28)>>2)]=2;
      var $29=$2;
      var $30=(($29)|0);
      HEAP32[(($30)>>2)]=1576;
      $1=44;
      __label__ = 11; break;
    case 6: // $31
      var $32=$2;
      var $33=(($32)|0);
      HEAP32[(($33)>>2)]=1578;
      $1=51;
      __label__ = 11; break;
    case 7: // $34
      var $35=$2;
      var $36=(($35)|0);
      HEAP32[(($36)>>2)]=1578;
      $1=53;
      __label__ = 11; break;
    case 8: // $37
      var $38=$2;
      var $39=(($38)|0);
      HEAP32[(($39)>>2)]=1578;
      $1=52;
      __label__ = 11; break;
    case 9: // $40
      var $41=$2;
      var $42=(($41)|0);
      HEAP32[(($42)>>2)]=1578;
      $1=54;
      __label__ = 11; break;
    case 10: // $43
      var $44=$2;
      var $45=$3;
      var $46=__ZL6commonP12prolog_statei($44, $45);
      $1=$46;
      __label__ = 11; break;
    case 11: // $47
      var $48=$1;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8element2P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8element3P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 24) {
        __label__ = 2; break;
      }
      else if ($7 == 36) {
        __label__ = 3; break;
      }
      else if ($7 == 21) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 6; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1568;
      var $12=$2;
      var $13=(($12+8)|0);
      HEAP32[(($13)>>2)]=39;
      $1=45;
      __label__ = 6; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=1568;
      var $17=$2;
      var $18=(($17+8)|0);
      HEAP32[(($18)>>2)]=39;
      $1=46;
      __label__ = 6; break;
    case 4: // $19
      var $20=$2;
      var $21=(($20)|0);
      HEAP32[(($21)>>2)]=1580;
      $1=39;
      __label__ = 6; break;
    case 5: // $22
      var $23=$2;
      var $24=$3;
      var $25=__ZL6commonP12prolog_statei($23, $24);
      $1=$25;
      __label__ = 6; break;
    case 6: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8element6P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 23) {
        __label__ = 2; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 3; break;
      }
      else if ($7 == 30) {
        __label__ = 4; break;
      }
      else if ($7 == 31) {
        __label__ = 5; break;
      }
      else if ($7 == 32) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 8; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+1)|0);
      HEAP32[(($11)>>2)]=$13;
      $1=44;
      __label__ = 8; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=1578;
      $1=51;
      __label__ = 8; break;
    case 4: // $17
      var $18=$2;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=1578;
      $1=53;
      __label__ = 8; break;
    case 5: // $20
      var $21=$2;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=1578;
      $1=52;
      __label__ = 8; break;
    case 6: // $23
      var $24=$2;
      var $25=(($24)|0);
      HEAP32[(($25)>>2)]=1578;
      $1=54;
      __label__ = 8; break;
    case 7: // $26
      var $27=$2;
      var $28=$3;
      var $29=__ZL6commonP12prolog_statei($27, $28);
      $1=$29;
      __label__ = 8; break;
    case 8: // $30
      var $31=$1;
      ;
      return $31;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8element7P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 24) {
        __label__ = 2; break;
      }
      else if ($7 == 36) {
        __label__ = 5; break;
      }
      else if ($7 == 35) {
        __label__ = 8; break;
      }
      else if ($7 == 37) {
        __label__ = 11; break;
      }
      else if ($7 == 38) {
        __label__ = 14; break;
      }
      else if ($7 == 21) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 17; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12-1)|0);
      HEAP32[(($11)>>2)]=$13;
      var $14=$2;
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1568;
      var $21=$2;
      var $22=(($21+8)|0);
      HEAP32[(($22)>>2)]=39;
      __label__ = 4; break;
    case 4: // $23
      $1=45;
      __label__ = 17; break;
    case 5: // $24
      var $25=$2;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27-1)|0);
      HEAP32[(($26)>>2)]=$28;
      var $29=$2;
      var $30=(($29+4)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31)|0)==0;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      var $34=$2;
      var $35=(($34)|0);
      HEAP32[(($35)>>2)]=1568;
      var $36=$2;
      var $37=(($36+8)|0);
      HEAP32[(($37)>>2)]=39;
      __label__ = 7; break;
    case 7: // $38
      $1=46;
      __label__ = 17; break;
    case 8: // $39
      var $40=$2;
      var $41=(($40+4)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42-1)|0);
      HEAP32[(($41)>>2)]=$43;
      var $44=$2;
      var $45=(($44+4)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $48
      var $49=$2;
      var $50=(($49)|0);
      HEAP32[(($50)>>2)]=1568;
      var $51=$2;
      var $52=(($51+8)|0);
      HEAP32[(($52)>>2)]=39;
      __label__ = 10; break;
    case 10: // $53
      $1=47;
      __label__ = 17; break;
    case 11: // $54
      var $55=$2;
      var $56=(($55+4)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57-1)|0);
      HEAP32[(($56)>>2)]=$58;
      var $59=$2;
      var $60=(($59+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $63
      var $64=$2;
      var $65=(($64)|0);
      HEAP32[(($65)>>2)]=1568;
      var $66=$2;
      var $67=(($66+8)|0);
      HEAP32[(($67)>>2)]=39;
      __label__ = 13; break;
    case 13: // $68
      $1=48;
      __label__ = 17; break;
    case 14: // $69
      var $70=$2;
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=1576;
      $1=50;
      __label__ = 17; break;
    case 15: // $72
      var $73=$2;
      var $74=(($73)|0);
      HEAP32[(($74)>>2)]=1576;
      $1=49;
      __label__ = 17; break;
    case 16: // $75
      var $76=$2;
      var $77=$3;
      var $78=__ZL6commonP12prolog_statei($76, $77);
      $1=$78;
      __label__ = 17; break;
    case 17: // $79
      var $80=$1;
      ;
      return $80;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8element7P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8element4P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1582;
      $1=51;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8element5P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 36) {
        __label__ = 2; break;
      }
      else if ($7 == 21) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $8
      $1=39;
      __label__ = 5; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1568;
      var $12=$2;
      var $13=(($12+8)|0);
      HEAP32[(($13)>>2)]=39;
      $1=46;
      __label__ = 5; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=1580;
      $1=39;
      __label__ = 5; break;
    case 4: // $17
      var $18=$2;
      var $19=$3;
      var $20=__ZL6commonP12prolog_statei($18, $19);
      $1=$20;
      __label__ = 5; break;
    case 5: // $21
      var $22=$1;
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 17) {
        __label__ = 2; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 8; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $17 = 1584;__label__ = 5; break;
    case 4: // $15
      var $17 = 1586;__label__ = 5; break;
    case 5: // $16
      var $17;
      var $18=$2;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      $1=33;
      __label__ = 8; break;
    case 6: // $20
      var $21=$2;
      var $22=(($21)|0);
      HEAP32[(($22)>>2)]=1588;
      $1=22;
      __label__ = 8; break;
    case 7: // $23
      var $24=$2;
      var $25=$3;
      var $26=__ZL6commonP12prolog_statei($24, $25);
      $1=$26;
      __label__ = 8; break;
    case 8: // $27
      var $28=$1;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $i;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else if ($7 == 23) {
        __label__ = 11; break;
      }
      else {
      __label__ = 12; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 13; break;
    case 2: // $9
      $i=0;
      __label__ = 3; break;
    case 3: // $10
      var $11=$i;
      var $12=(($11)|0) < 8;
      if ($12) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $13
      var $14=$6;
      var $15=(($14+28)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$6;
      var $18=$4;
      var $19=$5;
      var $20=$i;
      var $21=((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+($20<<2))|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=FUNCTION_TABLE[$16]($17, $18, $19, $22);
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=$2;
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=1590;
      var $28=$i;
      var $29=(($28+23)|0);
      $1=$29;
      __label__ = 13; break;
    case 6: // $30
      __label__ = 7; break;
    case 7: // $31
      var $32=$i;
      var $33=(($32+1)|0);
      $i=$33;
      __label__ = 3; break;
    case 8: // $34
      var $35=$6;
      var $36=(($35+28)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$6;
      var $39=$4;
      var $40=$5;
      var $41=FUNCTION_TABLE[$37]($38, $39, $40, ((STRING_TABLE.__ZL11KW_NOTATION)|0));
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$2;
      var $45=(($44)|0);
      HEAP32[(($45)>>2)]=1592;
      $1=33;
      __label__ = 13; break;
    case 10: // $46
      __label__ = 12; break;
    case 11: // $47
      var $48=$2;
      var $49=(($48)|0);
      HEAP32[(($49)>>2)]=1594;
      $1=33;
      __label__ = 13; break;
    case 12: // $50
      var $51=$2;
      var $52=$3;
      var $53=__ZL6commonP12prolog_statei($51, $52);
      $1=$53;
      __label__ = 13; break;
    case 13: // $54
      var $55=$1;
      ;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8attlist2P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8attlist8P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 20) {
        __label__ = 2; break;
      }
      else if ($7 == 27) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 11; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$6;
      var $16=(($15+68)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($14+$17)|0);
      var $19=$5;
      var $20=FUNCTION_TABLE[$12]($13, $18, $19, ((STRING_TABLE.__ZL10KW_IMPLIED)|0));
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $22
      var $23=$2;
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=1552;
      $1=35;
      __label__ = 11; break;
    case 4: // $25
      var $26=$6;
      var $27=(($26+28)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$6;
      var $30=$4;
      var $31=$6;
      var $32=(($31+68)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($30+$33)|0);
      var $35=$5;
      var $36=FUNCTION_TABLE[$28]($29, $34, $35, ((STRING_TABLE.__ZL11KW_REQUIRED)|0));
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $38
      var $39=$2;
      var $40=(($39)|0);
      HEAP32[(($40)>>2)]=1552;
      $1=36;
      __label__ = 11; break;
    case 6: // $41
      var $42=$6;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$6;
      var $46=$4;
      var $47=$6;
      var $48=(($47+68)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($46+$49)|0);
      var $51=$5;
      var $52=FUNCTION_TABLE[$44]($45, $50, $51, ((STRING_TABLE.__ZL8KW_FIXED)|0));
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $54
      var $55=$2;
      var $56=(($55)|0);
      HEAP32[(($56)>>2)]=1596;
      $1=33;
      __label__ = 11; break;
    case 8: // $57
      __label__ = 10; break;
    case 9: // $58
      var $59=$2;
      var $60=(($59)|0);
      HEAP32[(($60)>>2)]=1552;
      $1=37;
      __label__ = 11; break;
    case 10: // $61
      var $62=$2;
      var $63=$3;
      var $64=__ZL6commonP12prolog_statei($62, $63);
      $1=$64;
      __label__ = 11; break;
    case 11: // $65
      var $66=$1;
      ;
      return $66;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8attlist8P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8attlist5P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 23) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1598;
      $1=33;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist3P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 19 || $7 == 18 || $7 == 41) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1600;
      $1=31;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist4P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 24) {
        __label__ = 2; break;
      }
      else if ($7 == 21) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 5; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1590;
      $1=33;
      __label__ = 5; break;
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=1594;
      $1=33;
      __label__ = 5; break;
    case 4: // $15
      var $16=$2;
      var $17=$3;
      var $18=__ZL6commonP12prolog_statei($16, $17);
      $1=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist6P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1602;
      $1=32;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist7P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 24) {
        __label__ = 2; break;
      }
      else if ($7 == 21) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 5; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1590;
      $1=33;
      __label__ = 5; break;
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=1598;
      $1=33;
      __label__ = 5; break;
    case 4: // $15
      var $16=$2;
      var $17=$3;
      var $18=__ZL6commonP12prolog_statei($16, $17);
      $1=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8attlist9P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=33;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1552;
      $1=38;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7entity1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1604;
      $1=10;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7entity2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else if ($7 == 27) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 9; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($13, $14, $15, ((STRING_TABLE.__ZL9KW_SYSTEM)|0));
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1606;
      $1=11;
      __label__ = 9; break;
    case 4: // $21
      var $22=$6;
      var $23=(($22+28)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$6;
      var $26=$4;
      var $27=$5;
      var $28=FUNCTION_TABLE[$24]($25, $26, $27, ((STRING_TABLE.__ZL9KW_PUBLIC)|0));
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$2;
      var $32=(($31)|0);
      HEAP32[(($32)>>2)]=1608;
      $1=11;
      __label__ = 9; break;
    case 6: // $33
      __label__ = 8; break;
    case 7: // $34
      var $35=$2;
      var $36=(($35)|0);
      HEAP32[(($36)>>2)]=1568;
      var $37=$2;
      var $38=(($37+8)|0);
      HEAP32[(($38)>>2)]=11;
      $1=12;
      __label__ = 9; break;
    case 8: // $39
      var $40=$2;
      var $41=$3;
      var $42=__ZL6commonP12prolog_statei($40, $41);
      $1=$42;
      __label__ = 9; break;
    case 9: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7entity2P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL7entity4P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1610;
      $1=13;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7entity3P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1606;
      $1=14;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7entity5P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 17) {
        __label__ = 2; break;
      }
      else if ($7 == 18) {
        __label__ = 6; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 10; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $17 = 1584;__label__ = 5; break;
    case 4: // $15
      var $17 = 1586;__label__ = 5; break;
    case 5: // $16
      var $17;
      var $18=$2;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      $1=15;
      __label__ = 10; break;
    case 6: // $20
      var $21=$6;
      var $22=(($21+28)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$6;
      var $25=$4;
      var $26=$5;
      var $27=FUNCTION_TABLE[$23]($24, $25, $26, ((STRING_TABLE.__ZL8KW_NDATA)|0));
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $29
      var $30=$2;
      var $31=(($30)|0);
      HEAP32[(($31)>>2)]=1612;
      $1=11;
      __label__ = 10; break;
    case 8: // $32
      __label__ = 9; break;
    case 9: // $33
      var $34=$2;
      var $35=$3;
      var $36=__ZL6commonP12prolog_statei($34, $35);
      $1=$36;
      __label__ = 10; break;
    case 10: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7entity5P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL7entity6P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1568;
      var $12=$2;
      var $13=(($12+8)|0);
      HEAP32[(($13)>>2)]=11;
      $1=16;
      __label__ = 4; break;
    case 3: // $14
      var $15=$2;
      var $16=$3;
      var $17=__ZL6commonP12prolog_statei($15, $16);
      $1=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$1;
      ;
      return $19;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7entity7P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18) {
        __label__ = 2; break;
      }
      else if ($7 == 27) {
        __label__ = 7; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 9; break;
    case 2: // $9
      var $10=$6;
      var $11=(($10+28)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$6;
      var $14=$4;
      var $15=$5;
      var $16=FUNCTION_TABLE[$12]($13, $14, $15, ((STRING_TABLE.__ZL9KW_SYSTEM)|0));
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$2;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1614;
      $1=11;
      __label__ = 9; break;
    case 4: // $21
      var $22=$6;
      var $23=(($22+28)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$6;
      var $26=$4;
      var $27=$5;
      var $28=FUNCTION_TABLE[$24]($25, $26, $27, ((STRING_TABLE.__ZL9KW_PUBLIC)|0));
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$2;
      var $32=(($31)|0);
      HEAP32[(($32)>>2)]=1616;
      $1=11;
      __label__ = 9; break;
    case 6: // $33
      __label__ = 8; break;
    case 7: // $34
      var $35=$2;
      var $36=(($35)|0);
      HEAP32[(($36)>>2)]=1568;
      var $37=$2;
      var $38=(($37+8)|0);
      HEAP32[(($38)>>2)]=11;
      $1=12;
      __label__ = 9; break;
    case 8: // $39
      var $40=$2;
      var $41=$3;
      var $42=__ZL6commonP12prolog_statei($40, $41);
      $1=$42;
      __label__ = 9; break;
    case 9: // $43
      var $44=$1;
      ;
      return $44;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7entity7P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL7entity9P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1618;
      $1=13;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7entity8P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1614;
      $1=14;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8entity10P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 17) {
        __label__ = 2; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 1: // $8
      $1=11;
      __label__ = 7; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10+16)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $17 = 1584;__label__ = 5; break;
    case 4: // $15
      var $17 = 1586;__label__ = 5; break;
    case 5: // $16
      var $17;
      var $18=$2;
      var $19=(($18)|0);
      HEAP32[(($19)>>2)]=$17;
      $1=15;
      __label__ = 7; break;
    case 6: // $20
      var $21=$2;
      var $22=$3;
      var $23=__ZL6commonP12prolog_statei($21, $22);
      $1=$23;
      __label__ = 7; break;
    case 7: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9condSect1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 25) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=0;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1586;
      var $12=$2;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+1)|0);
      HEAP32[(($13)>>2)]=$15;
      $1=0;
      __label__ = 4; break;
    case 3: // $16
      var $17=$2;
      var $18=$3;
      var $19=__ZL6commonP12prolog_statei($17, $18);
      $1=$19;
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL9condSect2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 25) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=0;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1586;
      $1=58;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL7prolog1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 11) {
        __label__ = 2; break;
      }
      else if ($7 == 13) {
        __label__ = 3; break;
      }
      else if ($7 == 14) {
        __label__ = 4; break;
      }
      else if ($7 == 16) {
        __label__ = 5; break;
      }
      else if ($7 == 29) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 1: // $8
      $1=0;
      __label__ = 10; break;
    case 2: // $9
      $1=55;
      __label__ = 10; break;
    case 3: // $10
      $1=56;
      __label__ = 10; break;
    case 4: // $11
      $1=0;
      __label__ = 10; break;
    case 5: // $12
      var $13=$6;
      var $14=(($13+28)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$6;
      var $17=$4;
      var $18=$6;
      var $19=(($18+68)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=((($20<<1))|0);
      var $22=(($17+$21)|0);
      var $23=$5;
      var $24=FUNCTION_TABLE[$15]($16, $22, $23, ((STRING_TABLE.__ZL10KW_DOCTYPE)|0));
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $26
      __label__ = 9; break;
    case 7: // $27
      var $28=$2;
      var $29=(($28)|0);
      HEAP32[(($29)>>2)]=1528;
      $1=3;
      __label__ = 10; break;
    case 8: // $30
      var $31=$2;
      var $32=(($31)|0);
      HEAP32[(($32)>>2)]=1530;
      $1=2;
      __label__ = 10; break;
    case 9: // $33
      var $34=$2;
      var $35=$3;
      var $36=__ZL6commonP12prolog_statei($34, $35);
      $1=$36;
      __label__ = 10; break;
    case 10: // $37
      var $38=$1;
      ;
      return $38;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7prolog1P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8doctype0P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 18 || $7 == 41) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=3;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1620;
      $1=4;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8doctype1P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 25) {
        __label__ = 2; break;
      }
      else if ($7 == 17) {
        __label__ = 3; break;
      }
      else if ($7 == 18) {
        __label__ = 4; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 1: // $8
      $1=3;
      __label__ = 10; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1584;
      $1=7;
      __label__ = 10; break;
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=1562;
      $1=8;
      __label__ = 10; break;
    case 4: // $15
      var $16=$6;
      var $17=(($16+28)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$6;
      var $20=$4;
      var $21=$5;
      var $22=FUNCTION_TABLE[$18]($19, $20, $21, ((STRING_TABLE.__ZL9KW_SYSTEM)|0));
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $24
      var $25=$2;
      var $26=(($25)|0);
      HEAP32[(($26)>>2)]=1622;
      $1=3;
      __label__ = 10; break;
    case 6: // $27
      var $28=$6;
      var $29=(($28+28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$6;
      var $32=$4;
      var $33=$5;
      var $34=FUNCTION_TABLE[$30]($31, $32, $33, ((STRING_TABLE.__ZL9KW_PUBLIC)|0));
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $36
      var $37=$2;
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=1624;
      $1=3;
      __label__ = 10; break;
    case 8: // $39
      __label__ = 9; break;
    case 9: // $40
      var $41=$2;
      var $42=$3;
      var $43=__ZL6commonP12prolog_statei($41, $42);
      $1=$43;
      __label__ = 10; break;
    case 10: // $44
      var $45=$1;
      ;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8doctype1P12prolog_stateiPKcS2_PK8encoding["X"]=1;

function __ZL8doctype3P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=3;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1626;
      $1=5;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8doctype2P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 27) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 1: // $8
      $1=3;
      __label__ = 4; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1622;
      $1=6;
      __label__ = 4; break;
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=__ZL6commonP12prolog_statei($13, $14);
      $1=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$1;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8doctype4P12prolog_stateiPKcS2_PK8encoding($state, $tok, $ptr, $end, $enc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$state;
      $3=$tok;
      $4=$ptr;
      $5=$end;
      $6=$enc;
      var $7=$3;
      if ($7 == 15) {
        __label__ = 1; break;
      }
      else if ($7 == 25) {
        __label__ = 2; break;
      }
      else if ($7 == 17) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 1: // $8
      $1=3;
      __label__ = 5; break;
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      HEAP32[(($11)>>2)]=1584;
      $1=7;
      __label__ = 5; break;
    case 3: // $12
      var $13=$2;
      var $14=(($13)|0);
      HEAP32[(($14)>>2)]=1562;
      $1=8;
      __label__ = 5; break;
    case 4: // $15
      var $16=$2;
      var $17=$3;
      var $18=__ZL6commonP12prolog_statei($16, $17);
      $1=$18;
      __label__ = 5; break;
    case 5: // $19
      var $20=$1;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16normal_prologTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tok;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 133; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 12) {
        __label__ = 3; break;
      }
      else if ($19 == 13) {
        __label__ = 4; break;
      }
      else if ($19 == 2) {
        __label__ = 5; break;
      }
      else if ($19 == 9) {
        __label__ = 12; break;
      }
      else if ($19 == 21 || $19 == 10) {
        __label__ = 15; break;
      }
      else if ($19 == 30) {
        __label__ = 26; break;
      }
      else if ($19 == 35) {
        __label__ = 27; break;
      }
      else if ($19 == 20) {
        __label__ = 28; break;
      }
      else if ($19 == 4) {
        __label__ = 29; break;
      }
      else if ($19 == 31) {
        __label__ = 38; break;
      }
      else if ($19 == 32) {
        __label__ = 39; break;
      }
      else if ($19 == 36) {
        __label__ = 47; break;
      }
      else if ($19 == 11) {
        __label__ = 48; break;
      }
      else if ($19 == 19) {
        __label__ = 49; break;
      }
      else if ($19 == 5) {
        __label__ = 50; break;
      }
      else if ($19 == 6) {
        __label__ = 57; break;
      }
      else if ($19 == 7) {
        __label__ = 64; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 71; break;
      }
      else if ($19 == 25 || $19 == 26 || $19 == 27 || $19 == 23) {
        __label__ = 72; break;
      }
      else if ($19 == 29) {
        __label__ = 73; break;
      }
      else {
      __label__ = 74; break;
      }
      
    case 3: // $20
      var $21=$2;
      var $22=$3;
      var $23=(($22+1)|0);
      var $24=$4;
      var $25=$5;
      var $26=__ZL14normal_scanLitiPK8encodingPKcS3_PS3_(12, $21, $23, $24, $25);
      $1=$26;
      __label__ = 133; break;
    case 4: // $27
      var $28=$2;
      var $29=$3;
      var $30=(($29+1)|0);
      var $31=$4;
      var $32=$5;
      var $33=__ZL14normal_scanLitiPK8encodingPKcS3_PS3_(13, $28, $30, $31, $32);
      $1=$33;
      __label__ = 133; break;
    case 5: // $34
      var $35=$3;
      var $36=(($35+1)|0);
      $3=$36;
      var $37=$3;
      var $38=$4;
      var $39=(($37)|0)==(($38)|0);
      if ($39) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $40
      $1=-1;
      __label__ = 133; break;
    case 7: // $41
      var $42=$3;
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$2;
      var $46=$45;
      var $47=(($46+76)|0);
      var $48=(($47+$44)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      if ($50 == 16) {
        __label__ = 8; break;
      }
      else if ($50 == 15) {
        __label__ = 9; break;
      }
      else if ($50 == 22 || $50 == 24 || $50 == 29 || $50 == 5 || $50 == 6 || $50 == 7) {
        __label__ = 10; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 8: // $51
      var $52=$2;
      var $53=$3;
      var $54=(($53+1)|0);
      var $55=$4;
      var $56=$5;
      var $57=__ZL15normal_scanDeclPK8encodingPKcS3_PS3_($52, $54, $55, $56);
      $1=$57;
      __label__ = 133; break;
    case 9: // $58
      var $59=$2;
      var $60=$3;
      var $61=(($60+1)|0);
      var $62=$4;
      var $63=$5;
      var $64=__ZL13normal_scanPiPK8encodingPKcS3_PS3_($59, $61, $62, $63);
      $1=$64;
      __label__ = 133; break;
    case 10: // $65
      var $66=$3;
      var $67=(($66-1)|0);
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=29;
      __label__ = 133; break;
    case 11: // $69
      var $70=$3;
      var $71=$5;
      HEAP32[(($71)>>2)]=$70;
      $1=0;
      __label__ = 133; break;
    case 12: // $72
      var $73=$3;
      var $74=(($73+1)|0);
      var $75=$4;
      var $76=(($74)|0)==(($75)|0);
      if ($76) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $77
      var $78=$4;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=-15;
      __label__ = 133; break;
    case 14: // $80
      __label__ = 15; break;
    case 15: // $81
      __label__ = 16; break;
    case 16: // $82
      var $83=$3;
      var $84=(($83+1)|0);
      $3=$84;
      var $85=$3;
      var $86=$4;
      var $87=(($85)|0)==(($86)|0);
      if ($87) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $88
      __label__ = 25; break;
    case 18: // $89
      var $90=$3;
      var $91=HEAPU8[($90)];
      var $92=(($91)&255);
      var $93=$2;
      var $94=$93;
      var $95=(($94+76)|0);
      var $96=(($95+$92)|0);
      var $97=HEAPU8[($96)];
      var $98=(($97)&255);
      if ($98 == 21 || $98 == 10) {
        __label__ = 19; break;
      }
      else if ($98 == 9) {
        __label__ = 20; break;
      }
      else {
      __label__ = 23; break;
      }
      
    case 19: // $99
      __label__ = 24; break;
    case 20: // $100
      var $101=$3;
      var $102=(($101+1)|0);
      var $103=$4;
      var $104=(($102)|0)!=(($103)|0);
      if ($104) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $105
      __label__ = 24; break;
    case 22: // $106
      __label__ = 23; break;
    case 23: // $107
      var $108=$3;
      var $109=$5;
      HEAP32[(($109)>>2)]=$108;
      $1=15;
      __label__ = 133; break;
    case 24: // $110
      __label__ = 16; break;
    case 25: // $111
      var $112=$3;
      var $113=$5;
      HEAP32[(($113)>>2)]=$112;
      $1=15;
      __label__ = 133; break;
    case 26: // $114
      var $115=$2;
      var $116=$3;
      var $117=(($116+1)|0);
      var $118=$4;
      var $119=$5;
      var $120=__ZL18normal_scanPercentPK8encodingPKcS3_PS3_($115, $117, $118, $119);
      $1=$120;
      __label__ = 133; break;
    case 27: // $121
      var $122=$3;
      var $123=(($122+1)|0);
      var $124=$5;
      HEAP32[(($124)>>2)]=$123;
      $1=38;
      __label__ = 133; break;
    case 28: // $125
      var $126=$3;
      var $127=(($126+1)|0);
      var $128=$5;
      HEAP32[(($128)>>2)]=$127;
      $1=25;
      __label__ = 133; break;
    case 29: // $129
      var $130=$3;
      var $131=(($130+1)|0);
      $3=$131;
      var $132=$3;
      var $133=$4;
      var $134=(($132)|0)==(($133)|0);
      if ($134) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $135
      $1=-26;
      __label__ = 133; break;
    case 31: // $136
      var $137=$3;
      var $138=HEAP8[($137)];
      var $139=(($138 << 24) >> 24);
      var $140=(($139)|0)==93;
      if ($140) { __label__ = 32; break; } else { __label__ = 37; break; }
    case 32: // $141
      var $142=$3;
      var $143=(($142+1)|0);
      var $144=$4;
      var $145=(($143)|0)==(($144)|0);
      if ($145) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $146
      $1=-1;
      __label__ = 133; break;
    case 34: // $147
      var $148=$3;
      var $149=(($148+1)|0);
      var $150=HEAP8[($149)];
      var $151=(($150 << 24) >> 24);
      var $152=(($151)|0)==62;
      if ($152) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $153
      var $154=$3;
      var $155=(($154+2)|0);
      var $156=$5;
      HEAP32[(($156)>>2)]=$155;
      $1=34;
      __label__ = 133; break;
    case 36: // $157
      __label__ = 37; break;
    case 37: // $158
      var $159=$3;
      var $160=$5;
      HEAP32[(($160)>>2)]=$159;
      $1=26;
      __label__ = 133; break;
    case 38: // $161
      var $162=$3;
      var $163=(($162+1)|0);
      var $164=$5;
      HEAP32[(($164)>>2)]=$163;
      $1=23;
      __label__ = 133; break;
    case 39: // $165
      var $166=$3;
      var $167=(($166+1)|0);
      $3=$167;
      var $168=$3;
      var $169=$4;
      var $170=(($168)|0)==(($169)|0);
      if ($170) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $171
      $1=-24;
      __label__ = 133; break;
    case 41: // $172
      var $173=$3;
      var $174=HEAPU8[($173)];
      var $175=(($174)&255);
      var $176=$2;
      var $177=$176;
      var $178=(($177+76)|0);
      var $179=(($178+$175)|0);
      var $180=HEAPU8[($179)];
      var $181=(($180)&255);
      if ($181 == 33) {
        __label__ = 42; break;
      }
      else if ($181 == 15) {
        __label__ = 43; break;
      }
      else if ($181 == 34) {
        __label__ = 44; break;
      }
      else if ($181 == 9 || $181 == 10 || $181 == 21 || $181 == 11 || $181 == 35 || $181 == 36 || $181 == 32) {
        __label__ = 45; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 42: // $182
      var $183=$3;
      var $184=(($183+1)|0);
      var $185=$5;
      HEAP32[(($185)>>2)]=$184;
      $1=36;
      __label__ = 133; break;
    case 43: // $186
      var $187=$3;
      var $188=(($187+1)|0);
      var $189=$5;
      HEAP32[(($189)>>2)]=$188;
      $1=35;
      __label__ = 133; break;
    case 44: // $190
      var $191=$3;
      var $192=(($191+1)|0);
      var $193=$5;
      HEAP32[(($193)>>2)]=$192;
      $1=37;
      __label__ = 133; break;
    case 45: // $194
      var $195=$3;
      var $196=$5;
      HEAP32[(($196)>>2)]=$195;
      $1=24;
      __label__ = 133; break;
    case 46: // $197
      var $198=$3;
      var $199=$5;
      HEAP32[(($199)>>2)]=$198;
      $1=0;
      __label__ = 133; break;
    case 47: // $200
      var $201=$3;
      var $202=(($201+1)|0);
      var $203=$5;
      HEAP32[(($203)>>2)]=$202;
      $1=21;
      __label__ = 133; break;
    case 48: // $204
      var $205=$3;
      var $206=(($205+1)|0);
      var $207=$5;
      HEAP32[(($207)>>2)]=$206;
      $1=17;
      __label__ = 133; break;
    case 49: // $208
      var $209=$2;
      var $210=$3;
      var $211=(($210+1)|0);
      var $212=$4;
      var $213=$5;
      var $214=__ZL20normal_scanPoundNamePK8encodingPKcS3_PS3_($209, $211, $212, $213);
      $1=$214;
      __label__ = 133; break;
    case 50: // $215
      var $216=$4;
      var $217=$3;
      var $218=$216;
      var $219=$217;
      var $220=(($218-$219)|0);
      var $221=(($220)|0) < 2;
      if ($221) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $222
      $1=-2;
      __label__ = 133; break;
    case 52: // $223
      var $224=$2;
      var $225=$224;
      var $226=(($225+344)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$2;
      var $229=$3;
      var $230=FUNCTION_TABLE[$227]($228, $229);
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $232
      var $233=$3;
      var $234=(($233+2)|0);
      $3=$234;
      $tok=18;
      __label__ = 75; break;
    case 54: // $235
      var $236=$2;
      var $237=$236;
      var $238=(($237+332)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$2;
      var $241=$3;
      var $242=FUNCTION_TABLE[$239]($240, $241);
      var $243=(($242)|0)!=0;
      if ($243) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $244
      var $245=$3;
      var $246=(($245+2)|0);
      $3=$246;
      $tok=19;
      __label__ = 75; break;
    case 56: // $247
      var $248=$3;
      var $249=$5;
      HEAP32[(($249)>>2)]=$248;
      $1=0;
      __label__ = 133; break;
    case 57: // $250
      var $251=$4;
      var $252=$3;
      var $253=$251;
      var $254=$252;
      var $255=(($253-$254)|0);
      var $256=(($255)|0) < 3;
      if ($256) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $257
      $1=-2;
      __label__ = 133; break;
    case 59: // $258
      var $259=$2;
      var $260=$259;
      var $261=(($260+348)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$2;
      var $264=$3;
      var $265=FUNCTION_TABLE[$262]($263, $264);
      var $266=(($265)|0)!=0;
      if ($266) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $267
      var $268=$3;
      var $269=(($268+3)|0);
      $3=$269;
      $tok=18;
      __label__ = 75; break;
    case 61: // $270
      var $271=$2;
      var $272=$271;
      var $273=(($272+336)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=$2;
      var $276=$3;
      var $277=FUNCTION_TABLE[$274]($275, $276);
      var $278=(($277)|0)!=0;
      if ($278) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $279
      var $280=$3;
      var $281=(($280+3)|0);
      $3=$281;
      $tok=19;
      __label__ = 75; break;
    case 63: // $282
      var $283=$3;
      var $284=$5;
      HEAP32[(($284)>>2)]=$283;
      $1=0;
      __label__ = 133; break;
    case 64: // $285
      var $286=$4;
      var $287=$3;
      var $288=$286;
      var $289=$287;
      var $290=(($288-$289)|0);
      var $291=(($290)|0) < 4;
      if ($291) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $292
      $1=-2;
      __label__ = 133; break;
    case 66: // $293
      var $294=$2;
      var $295=$294;
      var $296=(($295+352)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$2;
      var $299=$3;
      var $300=FUNCTION_TABLE[$297]($298, $299);
      var $301=(($300)|0)!=0;
      if ($301) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $302
      var $303=$3;
      var $304=(($303+4)|0);
      $3=$304;
      $tok=18;
      __label__ = 75; break;
    case 68: // $305
      var $306=$2;
      var $307=$306;
      var $308=(($307+340)|0);
      var $309=HEAP32[(($308)>>2)];
      var $310=$2;
      var $311=$3;
      var $312=FUNCTION_TABLE[$309]($310, $311);
      var $313=(($312)|0)!=0;
      if ($313) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $314
      var $315=$3;
      var $316=(($315+4)|0);
      $3=$316;
      $tok=19;
      __label__ = 75; break;
    case 70: // $317
      var $318=$3;
      var $319=$5;
      HEAP32[(($319)>>2)]=$318;
      $1=0;
      __label__ = 133; break;
    case 71: // $320
      $tok=18;
      var $321=$3;
      var $322=(($321+1)|0);
      $3=$322;
      __label__ = 75; break;
    case 72: // $323
      $tok=19;
      var $324=$3;
      var $325=(($324+1)|0);
      $3=$325;
      __label__ = 75; break;
    case 73: // $326
      __label__ = 74; break;
    case 74: // $327
      var $328=$3;
      var $329=$5;
      HEAP32[(($329)>>2)]=$328;
      $1=0;
      __label__ = 133; break;
    case 75: // $330
      __label__ = 76; break;
    case 76: // $331
      var $332=$3;
      var $333=$4;
      var $334=(($332)|0)!=(($333)|0);
      if ($334) { __label__ = 77; break; } else { __label__ = 132; break; }
    case 77: // $335
      var $336=$3;
      var $337=HEAPU8[($336)];
      var $338=(($337)&255);
      var $339=$2;
      var $340=$339;
      var $341=(($340+76)|0);
      var $342=(($341+$338)|0);
      var $343=HEAPU8[($342)];
      var $344=(($343)&255);
      if ($344 == 29) {
        __label__ = 78; break;
      }
      else if ($344 == 22 || $344 == 24 || $344 == 25 || $344 == 26 || $344 == 27) {
        __label__ = 79; break;
      }
      else if ($344 == 5) {
        __label__ = 80; break;
      }
      else if ($344 == 6) {
        __label__ = 85; break;
      }
      else if ($344 == 7) {
        __label__ = 90; break;
      }
      else if ($344 == 11 || $344 == 32 || $344 == 35 || $344 == 36 || $344 == 20 || $344 == 30 || $344 == 21 || $344 == 9 || $344 == 10) {
        __label__ = 95; break;
      }
      else if ($344 == 23) {
        __label__ = 96; break;
      }
      else if ($344 == 34) {
        __label__ = 121; break;
      }
      else if ($344 == 33) {
        __label__ = 124; break;
      }
      else if ($344 == 15) {
        __label__ = 127; break;
      }
      else {
      __label__ = 130; break;
      }
      
    case 78: // $345
      var $346=$3;
      var $347=$5;
      HEAP32[(($347)>>2)]=$346;
      $1=0;
      __label__ = 133; break;
    case 79: // $348
      var $349=$3;
      var $350=(($349+1)|0);
      $3=$350;
      __label__ = 131; break;
    case 80: // $351
      var $352=$4;
      var $353=$3;
      var $354=$352;
      var $355=$353;
      var $356=(($354-$355)|0);
      var $357=(($356)|0) < 2;
      if ($357) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $358
      $1=-2;
      __label__ = 133; break;
    case 82: // $359
      var $360=$2;
      var $361=$360;
      var $362=(($361+332)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=$2;
      var $365=$3;
      var $366=FUNCTION_TABLE[$363]($364, $365);
      var $367=(($366)|0)!=0;
      if ($367) { __label__ = 84; break; } else { __label__ = 83; break; }
    case 83: // $368
      var $369=$3;
      var $370=$5;
      HEAP32[(($370)>>2)]=$369;
      $1=0;
      __label__ = 133; break;
    case 84: // $371
      var $372=$3;
      var $373=(($372+2)|0);
      $3=$373;
      __label__ = 131; break;
    case 85: // $374
      var $375=$4;
      var $376=$3;
      var $377=$375;
      var $378=$376;
      var $379=(($377-$378)|0);
      var $380=(($379)|0) < 3;
      if ($380) { __label__ = 86; break; } else { __label__ = 87; break; }
    case 86: // $381
      $1=-2;
      __label__ = 133; break;
    case 87: // $382
      var $383=$2;
      var $384=$383;
      var $385=(($384+336)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=$2;
      var $388=$3;
      var $389=FUNCTION_TABLE[$386]($387, $388);
      var $390=(($389)|0)!=0;
      if ($390) { __label__ = 89; break; } else { __label__ = 88; break; }
    case 88: // $391
      var $392=$3;
      var $393=$5;
      HEAP32[(($393)>>2)]=$392;
      $1=0;
      __label__ = 133; break;
    case 89: // $394
      var $395=$3;
      var $396=(($395+3)|0);
      $3=$396;
      __label__ = 131; break;
    case 90: // $397
      var $398=$4;
      var $399=$3;
      var $400=$398;
      var $401=$399;
      var $402=(($400-$401)|0);
      var $403=(($402)|0) < 4;
      if ($403) { __label__ = 91; break; } else { __label__ = 92; break; }
    case 91: // $404
      $1=-2;
      __label__ = 133; break;
    case 92: // $405
      var $406=$2;
      var $407=$406;
      var $408=(($407+340)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=$2;
      var $411=$3;
      var $412=FUNCTION_TABLE[$409]($410, $411);
      var $413=(($412)|0)!=0;
      if ($413) { __label__ = 94; break; } else { __label__ = 93; break; }
    case 93: // $414
      var $415=$3;
      var $416=$5;
      HEAP32[(($416)>>2)]=$415;
      $1=0;
      __label__ = 133; break;
    case 94: // $417
      var $418=$3;
      var $419=(($418+4)|0);
      $3=$419;
      __label__ = 131; break;
    case 95: // $420
      var $421=$3;
      var $422=$5;
      HEAP32[(($422)>>2)]=$421;
      var $423=$tok;
      $1=$423;
      __label__ = 133; break;
    case 96: // $424
      var $425=$3;
      var $426=(($425+1)|0);
      $3=$426;
      var $427=$tok;
      if ($427 == 18) {
        __label__ = 97; break;
      }
      else if ($427 == 41) {
        __label__ = 119; break;
      }
      else {
      __label__ = 120; break;
      }
      
    case 97: // $428
      var $429=$3;
      var $430=$4;
      var $431=(($429)|0)==(($430)|0);
      if ($431) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $432
      $1=-1;
      __label__ = 133; break;
    case 99: // $433
      $tok=41;
      var $434=$3;
      var $435=HEAPU8[($434)];
      var $436=(($435)&255);
      var $437=$2;
      var $438=$437;
      var $439=(($438+76)|0);
      var $440=(($439+$436)|0);
      var $441=HEAPU8[($440)];
      var $442=(($441)&255);
      if ($442 == 29) {
        __label__ = 100; break;
      }
      else if ($442 == 22 || $442 == 24 || $442 == 25 || $442 == 26 || $442 == 27) {
        __label__ = 101; break;
      }
      else if ($442 == 5) {
        __label__ = 102; break;
      }
      else if ($442 == 6) {
        __label__ = 107; break;
      }
      else if ($442 == 7) {
        __label__ = 112; break;
      }
      else {
      __label__ = 117; break;
      }
      
    case 100: // $443
      var $444=$3;
      var $445=$5;
      HEAP32[(($445)>>2)]=$444;
      $1=0;
      __label__ = 133; break;
    case 101: // $446
      var $447=$3;
      var $448=(($447+1)|0);
      $3=$448;
      __label__ = 118; break;
    case 102: // $449
      var $450=$4;
      var $451=$3;
      var $452=$450;
      var $453=$451;
      var $454=(($452-$453)|0);
      var $455=(($454)|0) < 2;
      if ($455) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $456
      $1=-2;
      __label__ = 133; break;
    case 104: // $457
      var $458=$2;
      var $459=$458;
      var $460=(($459+332)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=$2;
      var $463=$3;
      var $464=FUNCTION_TABLE[$461]($462, $463);
      var $465=(($464)|0)!=0;
      if ($465) { __label__ = 106; break; } else { __label__ = 105; break; }
    case 105: // $466
      var $467=$3;
      var $468=$5;
      HEAP32[(($468)>>2)]=$467;
      $1=0;
      __label__ = 133; break;
    case 106: // $469
      var $470=$3;
      var $471=(($470+2)|0);
      $3=$471;
      __label__ = 118; break;
    case 107: // $472
      var $473=$4;
      var $474=$3;
      var $475=$473;
      var $476=$474;
      var $477=(($475-$476)|0);
      var $478=(($477)|0) < 3;
      if ($478) { __label__ = 108; break; } else { __label__ = 109; break; }
    case 108: // $479
      $1=-2;
      __label__ = 133; break;
    case 109: // $480
      var $481=$2;
      var $482=$481;
      var $483=(($482+336)|0);
      var $484=HEAP32[(($483)>>2)];
      var $485=$2;
      var $486=$3;
      var $487=FUNCTION_TABLE[$484]($485, $486);
      var $488=(($487)|0)!=0;
      if ($488) { __label__ = 111; break; } else { __label__ = 110; break; }
    case 110: // $489
      var $490=$3;
      var $491=$5;
      HEAP32[(($491)>>2)]=$490;
      $1=0;
      __label__ = 133; break;
    case 111: // $492
      var $493=$3;
      var $494=(($493+3)|0);
      $3=$494;
      __label__ = 118; break;
    case 112: // $495
      var $496=$4;
      var $497=$3;
      var $498=$496;
      var $499=$497;
      var $500=(($498-$499)|0);
      var $501=(($500)|0) < 4;
      if ($501) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $502
      $1=-2;
      __label__ = 133; break;
    case 114: // $503
      var $504=$2;
      var $505=$504;
      var $506=(($505+340)|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=$2;
      var $509=$3;
      var $510=FUNCTION_TABLE[$507]($508, $509);
      var $511=(($510)|0)!=0;
      if ($511) { __label__ = 116; break; } else { __label__ = 115; break; }
    case 115: // $512
      var $513=$3;
      var $514=$5;
      HEAP32[(($514)>>2)]=$513;
      $1=0;
      __label__ = 133; break;
    case 116: // $515
      var $516=$3;
      var $517=(($516+4)|0);
      $3=$517;
      __label__ = 118; break;
    case 117: // $518
      $tok=19;
      __label__ = 118; break;
    case 118: // $519
      __label__ = 120; break;
    case 119: // $520
      $tok=19;
      __label__ = 120; break;
    case 120: // $521
      __label__ = 131; break;
    case 121: // $522
      var $523=$tok;
      var $524=(($523)|0)==19;
      if ($524) { __label__ = 122; break; } else { __label__ = 123; break; }
    case 122: // $525
      var $526=$3;
      var $527=$5;
      HEAP32[(($527)>>2)]=$526;
      $1=0;
      __label__ = 133; break;
    case 123: // $528
      var $529=$3;
      var $530=(($529+1)|0);
      var $531=$5;
      HEAP32[(($531)>>2)]=$530;
      $1=32;
      __label__ = 133; break;
    case 124: // $532
      var $533=$tok;
      var $534=(($533)|0)==19;
      if ($534) { __label__ = 125; break; } else { __label__ = 126; break; }
    case 125: // $535
      var $536=$3;
      var $537=$5;
      HEAP32[(($537)>>2)]=$536;
      $1=0;
      __label__ = 133; break;
    case 126: // $538
      var $539=$3;
      var $540=(($539+1)|0);
      var $541=$5;
      HEAP32[(($541)>>2)]=$540;
      $1=31;
      __label__ = 133; break;
    case 127: // $542
      var $543=$tok;
      var $544=(($543)|0)==19;
      if ($544) { __label__ = 128; break; } else { __label__ = 129; break; }
    case 128: // $545
      var $546=$3;
      var $547=$5;
      HEAP32[(($547)>>2)]=$546;
      $1=0;
      __label__ = 133; break;
    case 129: // $548
      var $549=$3;
      var $550=(($549+1)|0);
      var $551=$5;
      HEAP32[(($551)>>2)]=$550;
      $1=30;
      __label__ = 133; break;
    case 130: // $552
      var $553=$3;
      var $554=$5;
      HEAP32[(($554)>>2)]=$553;
      $1=0;
      __label__ = 133; break;
    case 131: // $555
      __label__ = 76; break;
    case 132: // $556
      var $557=$tok;
      var $558=(((-$557))|0);
      $1=$558;
      __label__ = 133; break;
    case 133: // $559
      var $560=$1;
      ;
      return $560;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16normal_prologTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL17normal_contentTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 65; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 2) {
        __label__ = 3; break;
      }
      else if ($19 == 3) {
        __label__ = 4; break;
      }
      else if ($19 == 9) {
        __label__ = 5; break;
      }
      else if ($19 == 10) {
        __label__ = 10; break;
      }
      else if ($19 == 4) {
        __label__ = 11; break;
      }
      else if ($19 == 5) {
        __label__ = 20; break;
      }
      else if ($19 == 6) {
        __label__ = 25; break;
      }
      else if ($19 == 7) {
        __label__ = 30; break;
      }
      else if ($19 == 0 || $19 == 1 || $19 == 8) {
        __label__ = 35; break;
      }
      else {
      __label__ = 36; break;
      }
      
    case 3: // $20
      var $21=$2;
      var $22=$3;
      var $23=(($22+1)|0);
      var $24=$4;
      var $25=$5;
      var $26=__ZL13normal_scanLtPK8encodingPKcS3_PS3_($21, $23, $24, $25);
      $1=$26;
      __label__ = 65; break;
    case 4: // $27
      var $28=$2;
      var $29=$3;
      var $30=(($29+1)|0);
      var $31=$4;
      var $32=$5;
      var $33=__ZL14normal_scanRefPK8encodingPKcS3_PS3_($28, $30, $31, $32);
      $1=$33;
      __label__ = 65; break;
    case 5: // $34
      var $35=$3;
      var $36=(($35+1)|0);
      $3=$36;
      var $37=$3;
      var $38=$4;
      var $39=(($37)|0)==(($38)|0);
      if ($39) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $40
      $1=-3;
      __label__ = 65; break;
    case 7: // $41
      var $42=$3;
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$2;
      var $46=$45;
      var $47=(($46+76)|0);
      var $48=(($47+$44)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=(($50)|0)==10;
      if ($51) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $52
      var $53=$3;
      var $54=(($53+1)|0);
      $3=$54;
      __label__ = 9; break;
    case 9: // $55
      var $56=$3;
      var $57=$5;
      HEAP32[(($57)>>2)]=$56;
      $1=7;
      __label__ = 65; break;
    case 10: // $58
      var $59=$3;
      var $60=(($59+1)|0);
      var $61=$5;
      HEAP32[(($61)>>2)]=$60;
      $1=7;
      __label__ = 65; break;
    case 11: // $62
      var $63=$3;
      var $64=(($63+1)|0);
      $3=$64;
      var $65=$3;
      var $66=$4;
      var $67=(($65)|0)==(($66)|0);
      if ($67) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $68
      $1=-5;
      __label__ = 65; break;
    case 13: // $69
      var $70=$3;
      var $71=HEAP8[($70)];
      var $72=(($71 << 24) >> 24);
      var $73=(($72)|0)==93;
      if ($73) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $74
      __label__ = 37; break;
    case 15: // $75
      var $76=$3;
      var $77=(($76+1)|0);
      $3=$77;
      var $78=$3;
      var $79=$4;
      var $80=(($78)|0)==(($79)|0);
      if ($80) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $81
      $1=-5;
      __label__ = 65; break;
    case 17: // $82
      var $83=$3;
      var $84=HEAP8[($83)];
      var $85=(($84 << 24) >> 24);
      var $86=(($85)|0)==62;
      if ($86) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $87
      var $88=$3;
      var $89=(($88-1)|0);
      $3=$89;
      __label__ = 37; break;
    case 19: // $90
      var $91=$3;
      var $92=$5;
      HEAP32[(($92)>>2)]=$91;
      $1=0;
      __label__ = 65; break;
    case 20: // $93
      var $94=$4;
      var $95=$3;
      var $96=$94;
      var $97=$95;
      var $98=(($96-$97)|0);
      var $99=(($98)|0) < 2;
      if ($99) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $100
      $1=-2;
      __label__ = 65; break;
    case 22: // $101
      var $102=$2;
      var $103=$102;
      var $104=(($103+356)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=$2;
      var $107=$3;
      var $108=FUNCTION_TABLE[$105]($106, $107);
      var $109=(($108)|0)!=0;
      if ($109) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $110
      var $111=$3;
      var $112=$5;
      HEAP32[(($112)>>2)]=$111;
      $1=0;
      __label__ = 65; break;
    case 24: // $113
      var $114=$3;
      var $115=(($114+2)|0);
      $3=$115;
      __label__ = 37; break;
    case 25: // $116
      var $117=$4;
      var $118=$3;
      var $119=$117;
      var $120=$118;
      var $121=(($119-$120)|0);
      var $122=(($121)|0) < 3;
      if ($122) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $123
      $1=-2;
      __label__ = 65; break;
    case 27: // $124
      var $125=$2;
      var $126=$125;
      var $127=(($126+360)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$2;
      var $130=$3;
      var $131=FUNCTION_TABLE[$128]($129, $130);
      var $132=(($131)|0)!=0;
      if ($132) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $133
      var $134=$3;
      var $135=$5;
      HEAP32[(($135)>>2)]=$134;
      $1=0;
      __label__ = 65; break;
    case 29: // $136
      var $137=$3;
      var $138=(($137+3)|0);
      $3=$138;
      __label__ = 37; break;
    case 30: // $139
      var $140=$4;
      var $141=$3;
      var $142=$140;
      var $143=$141;
      var $144=(($142-$143)|0);
      var $145=(($144)|0) < 4;
      if ($145) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $146
      $1=-2;
      __label__ = 65; break;
    case 32: // $147
      var $148=$2;
      var $149=$148;
      var $150=(($149+364)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$2;
      var $153=$3;
      var $154=FUNCTION_TABLE[$151]($152, $153);
      var $155=(($154)|0)!=0;
      if ($155) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $156
      var $157=$3;
      var $158=$5;
      HEAP32[(($158)>>2)]=$157;
      $1=0;
      __label__ = 65; break;
    case 34: // $159
      var $160=$3;
      var $161=(($160+4)|0);
      $3=$161;
      __label__ = 37; break;
    case 35: // $162
      var $163=$3;
      var $164=$5;
      HEAP32[(($164)>>2)]=$163;
      $1=0;
      __label__ = 65; break;
    case 36: // $165
      var $166=$3;
      var $167=(($166+1)|0);
      $3=$167;
      __label__ = 37; break;
    case 37: // $168
      __label__ = 38; break;
    case 38: // $169
      var $170=$3;
      var $171=$4;
      var $172=(($170)|0)!=(($171)|0);
      if ($172) { __label__ = 39; break; } else { __label__ = 64; break; }
    case 39: // $173
      var $174=$3;
      var $175=HEAPU8[($174)];
      var $176=(($175)&255);
      var $177=$2;
      var $178=$177;
      var $179=(($178+76)|0);
      var $180=(($179+$176)|0);
      var $181=HEAPU8[($180)];
      var $182=(($181)&255);
      if ($182 == 5) {
        __label__ = 40; break;
      }
      else if ($182 == 6) {
        __label__ = 44; break;
      }
      else if ($182 == 7) {
        __label__ = 48; break;
      }
      else if ($182 == 4) {
        __label__ = 52; break;
      }
      else if ($182 == 3 || $182 == 2 || $182 == 0 || $182 == 1 || $182 == 8 || $182 == 9 || $182 == 10) {
        __label__ = 61; break;
      }
      else {
      __label__ = 62; break;
      }
      
    case 40: // $183
      var $184=$4;
      var $185=$3;
      var $186=$184;
      var $187=$185;
      var $188=(($186-$187)|0);
      var $189=(($188)|0) < 2;
      if ($189) { __label__ = 42; break; } else { __label__ = 41; break; }
    case 41: // $190
      var $191=$2;
      var $192=$191;
      var $193=(($192+356)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=$2;
      var $196=$3;
      var $197=FUNCTION_TABLE[$194]($195, $196);
      var $198=(($197)|0)!=0;
      if ($198) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $199
      var $200=$3;
      var $201=$5;
      HEAP32[(($201)>>2)]=$200;
      $1=6;
      __label__ = 65; break;
    case 43: // $202
      var $203=$3;
      var $204=(($203+2)|0);
      $3=$204;
      __label__ = 63; break;
    case 44: // $205
      var $206=$4;
      var $207=$3;
      var $208=$206;
      var $209=$207;
      var $210=(($208-$209)|0);
      var $211=(($210)|0) < 3;
      if ($211) { __label__ = 46; break; } else { __label__ = 45; break; }
    case 45: // $212
      var $213=$2;
      var $214=$213;
      var $215=(($214+360)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=$2;
      var $218=$3;
      var $219=FUNCTION_TABLE[$216]($217, $218);
      var $220=(($219)|0)!=0;
      if ($220) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $221
      var $222=$3;
      var $223=$5;
      HEAP32[(($223)>>2)]=$222;
      $1=6;
      __label__ = 65; break;
    case 47: // $224
      var $225=$3;
      var $226=(($225+3)|0);
      $3=$226;
      __label__ = 63; break;
    case 48: // $227
      var $228=$4;
      var $229=$3;
      var $230=$228;
      var $231=$229;
      var $232=(($230-$231)|0);
      var $233=(($232)|0) < 4;
      if ($233) { __label__ = 50; break; } else { __label__ = 49; break; }
    case 49: // $234
      var $235=$2;
      var $236=$235;
      var $237=(($236+364)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$2;
      var $240=$3;
      var $241=FUNCTION_TABLE[$238]($239, $240);
      var $242=(($241)|0)!=0;
      if ($242) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $243
      var $244=$3;
      var $245=$5;
      HEAP32[(($245)>>2)]=$244;
      $1=6;
      __label__ = 65; break;
    case 51: // $246
      var $247=$3;
      var $248=(($247+4)|0);
      $3=$248;
      __label__ = 63; break;
    case 52: // $249
      var $250=$3;
      var $251=(($250+1)|0);
      var $252=$4;
      var $253=(($251)|0)!=(($252)|0);
      if ($253) { __label__ = 53; break; } else { __label__ = 60; break; }
    case 53: // $254
      var $255=$3;
      var $256=(($255+1)|0);
      var $257=HEAP8[($256)];
      var $258=(($257 << 24) >> 24);
      var $259=(($258)|0)==93;
      if ($259) { __label__ = 55; break; } else { __label__ = 54; break; }
    case 54: // $260
      var $261=$3;
      var $262=(($261+1)|0);
      $3=$262;
      __label__ = 63; break;
    case 55: // $263
      var $264=$3;
      var $265=(($264+2)|0);
      var $266=$4;
      var $267=(($265)|0)!=(($266)|0);
      if ($267) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $268
      var $269=$3;
      var $270=(($269+2)|0);
      var $271=HEAP8[($270)];
      var $272=(($271 << 24) >> 24);
      var $273=(($272)|0)==62;
      if ($273) { __label__ = 58; break; } else { __label__ = 57; break; }
    case 57: // $274
      var $275=$3;
      var $276=(($275+1)|0);
      $3=$276;
      __label__ = 63; break;
    case 58: // $277
      var $278=$3;
      var $279=(($278+2)|0);
      var $280=$5;
      HEAP32[(($280)>>2)]=$279;
      $1=0;
      __label__ = 65; break;
    case 59: // $281
      __label__ = 60; break;
    case 60: // $282
      __label__ = 61; break;
    case 61: // $283
      var $284=$3;
      var $285=$5;
      HEAP32[(($285)>>2)]=$284;
      $1=6;
      __label__ = 65; break;
    case 62: // $286
      var $287=$3;
      var $288=(($287+1)|0);
      $3=$288;
      __label__ = 63; break;
    case 63: // $289
      __label__ = 38; break;
    case 64: // $290
      var $291=$3;
      var $292=$5;
      HEAP32[(($292)>>2)]=$291;
      $1=6;
      __label__ = 65; break;
    case 65: // $293
      var $294=$1;
      ;
      return $294;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17normal_contentTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL22normal_cdataSectionTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 54; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 4) {
        __label__ = 3; break;
      }
      else if ($19 == 9) {
        __label__ = 12; break;
      }
      else if ($19 == 10) {
        __label__ = 17; break;
      }
      else if ($19 == 5) {
        __label__ = 18; break;
      }
      else if ($19 == 6) {
        __label__ = 23; break;
      }
      else if ($19 == 7) {
        __label__ = 28; break;
      }
      else if ($19 == 0 || $19 == 1 || $19 == 8) {
        __label__ = 33; break;
      }
      else {
      __label__ = 34; break;
      }
      
    case 3: // $20
      var $21=$3;
      var $22=(($21+1)|0);
      $3=$22;
      var $23=$3;
      var $24=$4;
      var $25=(($23)|0)==(($24)|0);
      if ($25) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $26
      $1=-1;
      __label__ = 54; break;
    case 5: // $27
      var $28=$3;
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==93;
      if ($31) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $32
      __label__ = 35; break;
    case 7: // $33
      var $34=$3;
      var $35=(($34+1)|0);
      $3=$35;
      var $36=$3;
      var $37=$4;
      var $38=(($36)|0)==(($37)|0);
      if ($38) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $39
      $1=-1;
      __label__ = 54; break;
    case 9: // $40
      var $41=$3;
      var $42=HEAP8[($41)];
      var $43=(($42 << 24) >> 24);
      var $44=(($43)|0)==62;
      if ($44) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $45
      var $46=$3;
      var $47=(($46-1)|0);
      $3=$47;
      __label__ = 35; break;
    case 11: // $48
      var $49=$3;
      var $50=(($49+1)|0);
      var $51=$5;
      HEAP32[(($51)>>2)]=$50;
      $1=40;
      __label__ = 54; break;
    case 12: // $52
      var $53=$3;
      var $54=(($53+1)|0);
      $3=$54;
      var $55=$3;
      var $56=$4;
      var $57=(($55)|0)==(($56)|0);
      if ($57) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $58
      $1=-1;
      __label__ = 54; break;
    case 14: // $59
      var $60=$3;
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=$2;
      var $64=$63;
      var $65=(($64+76)|0);
      var $66=(($65+$62)|0);
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      var $69=(($68)|0)==10;
      if ($69) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $70
      var $71=$3;
      var $72=(($71+1)|0);
      $3=$72;
      __label__ = 16; break;
    case 16: // $73
      var $74=$3;
      var $75=$5;
      HEAP32[(($75)>>2)]=$74;
      $1=7;
      __label__ = 54; break;
    case 17: // $76
      var $77=$3;
      var $78=(($77+1)|0);
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=7;
      __label__ = 54; break;
    case 18: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 2;
      if ($86) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $87
      $1=-2;
      __label__ = 54; break;
    case 20: // $88
      var $89=$2;
      var $90=$89;
      var $91=(($90+356)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$2;
      var $94=$3;
      var $95=FUNCTION_TABLE[$92]($93, $94);
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $97
      var $98=$3;
      var $99=$5;
      HEAP32[(($99)>>2)]=$98;
      $1=0;
      __label__ = 54; break;
    case 22: // $100
      var $101=$3;
      var $102=(($101+2)|0);
      $3=$102;
      __label__ = 35; break;
    case 23: // $103
      var $104=$4;
      var $105=$3;
      var $106=$104;
      var $107=$105;
      var $108=(($106-$107)|0);
      var $109=(($108)|0) < 3;
      if ($109) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $110
      $1=-2;
      __label__ = 54; break;
    case 25: // $111
      var $112=$2;
      var $113=$112;
      var $114=(($113+360)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=$2;
      var $117=$3;
      var $118=FUNCTION_TABLE[$115]($116, $117);
      var $119=(($118)|0)!=0;
      if ($119) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $120
      var $121=$3;
      var $122=$5;
      HEAP32[(($122)>>2)]=$121;
      $1=0;
      __label__ = 54; break;
    case 27: // $123
      var $124=$3;
      var $125=(($124+3)|0);
      $3=$125;
      __label__ = 35; break;
    case 28: // $126
      var $127=$4;
      var $128=$3;
      var $129=$127;
      var $130=$128;
      var $131=(($129-$130)|0);
      var $132=(($131)|0) < 4;
      if ($132) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $133
      $1=-2;
      __label__ = 54; break;
    case 30: // $134
      var $135=$2;
      var $136=$135;
      var $137=(($136+364)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$2;
      var $140=$3;
      var $141=FUNCTION_TABLE[$138]($139, $140);
      var $142=(($141)|0)!=0;
      if ($142) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $143
      var $144=$3;
      var $145=$5;
      HEAP32[(($145)>>2)]=$144;
      $1=0;
      __label__ = 54; break;
    case 32: // $146
      var $147=$3;
      var $148=(($147+4)|0);
      $3=$148;
      __label__ = 35; break;
    case 33: // $149
      var $150=$3;
      var $151=$5;
      HEAP32[(($151)>>2)]=$150;
      $1=0;
      __label__ = 54; break;
    case 34: // $152
      var $153=$3;
      var $154=(($153+1)|0);
      $3=$154;
      __label__ = 35; break;
    case 35: // $155
      __label__ = 36; break;
    case 36: // $156
      var $157=$3;
      var $158=$4;
      var $159=(($157)|0)!=(($158)|0);
      if ($159) { __label__ = 37; break; } else { __label__ = 53; break; }
    case 37: // $160
      var $161=$3;
      var $162=HEAPU8[($161)];
      var $163=(($162)&255);
      var $164=$2;
      var $165=$164;
      var $166=(($165+76)|0);
      var $167=(($166+$163)|0);
      var $168=HEAPU8[($167)];
      var $169=(($168)&255);
      if ($169 == 5) {
        __label__ = 38; break;
      }
      else if ($169 == 6) {
        __label__ = 42; break;
      }
      else if ($169 == 7) {
        __label__ = 46; break;
      }
      else if ($169 == 0 || $169 == 1 || $169 == 8 || $169 == 9 || $169 == 10 || $169 == 4) {
        __label__ = 50; break;
      }
      else {
      __label__ = 51; break;
      }
      
    case 38: // $170
      var $171=$4;
      var $172=$3;
      var $173=$171;
      var $174=$172;
      var $175=(($173-$174)|0);
      var $176=(($175)|0) < 2;
      if ($176) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $177
      var $178=$2;
      var $179=$178;
      var $180=(($179+356)|0);
      var $181=HEAP32[(($180)>>2)];
      var $182=$2;
      var $183=$3;
      var $184=FUNCTION_TABLE[$181]($182, $183);
      var $185=(($184)|0)!=0;
      if ($185) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $186
      var $187=$3;
      var $188=$5;
      HEAP32[(($188)>>2)]=$187;
      $1=6;
      __label__ = 54; break;
    case 41: // $189
      var $190=$3;
      var $191=(($190+2)|0);
      $3=$191;
      __label__ = 52; break;
    case 42: // $192
      var $193=$4;
      var $194=$3;
      var $195=$193;
      var $196=$194;
      var $197=(($195-$196)|0);
      var $198=(($197)|0) < 3;
      if ($198) { __label__ = 44; break; } else { __label__ = 43; break; }
    case 43: // $199
      var $200=$2;
      var $201=$200;
      var $202=(($201+360)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$2;
      var $205=$3;
      var $206=FUNCTION_TABLE[$203]($204, $205);
      var $207=(($206)|0)!=0;
      if ($207) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $208
      var $209=$3;
      var $210=$5;
      HEAP32[(($210)>>2)]=$209;
      $1=6;
      __label__ = 54; break;
    case 45: // $211
      var $212=$3;
      var $213=(($212+3)|0);
      $3=$213;
      __label__ = 52; break;
    case 46: // $214
      var $215=$4;
      var $216=$3;
      var $217=$215;
      var $218=$216;
      var $219=(($217-$218)|0);
      var $220=(($219)|0) < 4;
      if ($220) { __label__ = 48; break; } else { __label__ = 47; break; }
    case 47: // $221
      var $222=$2;
      var $223=$222;
      var $224=(($223+364)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$2;
      var $227=$3;
      var $228=FUNCTION_TABLE[$225]($226, $227);
      var $229=(($228)|0)!=0;
      if ($229) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $230
      var $231=$3;
      var $232=$5;
      HEAP32[(($232)>>2)]=$231;
      $1=6;
      __label__ = 54; break;
    case 49: // $233
      var $234=$3;
      var $235=(($234+4)|0);
      $3=$235;
      __label__ = 52; break;
    case 50: // $236
      var $237=$3;
      var $238=$5;
      HEAP32[(($238)>>2)]=$237;
      $1=6;
      __label__ = 54; break;
    case 51: // $239
      var $240=$3;
      var $241=(($240+1)|0);
      $3=$241;
      __label__ = 52; break;
    case 52: // $242
      __label__ = 36; break;
    case 53: // $243
      var $244=$3;
      var $245=$5;
      HEAP32[(($245)>>2)]=$244;
      $1=6;
      __label__ = 54; break;
    case 54: // $246
      var $247=$1;
      ;
      return $247;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22normal_cdataSectionTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL15normal_sameNamePK8encodingPKcS3_($enc, $ptr1, $ptr2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$enc;
      $3=$ptr1;
      $4=$ptr2;
      __label__ = 1; break;
    case 1: // $5
      var $6=$3;
      var $7=HEAPU8[($6)];
      var $8=(($7)&255);
      var $9=$2;
      var $10=$9;
      var $11=(($10+76)|0);
      var $12=(($11+$8)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      if ($14 == 7) {
        __label__ = 2; break;
      }
      else if ($14 == 6) {
        __label__ = 5; break;
      }
      else if ($14 == 5) {
        __label__ = 8; break;
      }
      else if ($14 == 29 || $14 == 22 || $14 == 23 || $14 == 24 || $14 == 25 || $14 == 26 || $14 == 27) {
        __label__ = 13; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 2: // $15
      var $16=$3;
      var $17=(($16+1)|0);
      $3=$17;
      var $18=HEAP8[($16)];
      var $19=(($18 << 24) >> 24);
      var $20=$4;
      var $21=(($20+1)|0);
      $4=$21;
      var $22=HEAP8[($20)];
      var $23=(($22 << 24) >> 24);
      var $24=(($19)|0)!=(($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      $1=0;
      __label__ = 22; break;
    case 4: // $26
      __label__ = 5; break;
    case 5: // $27
      var $28=$3;
      var $29=(($28+1)|0);
      $3=$29;
      var $30=HEAP8[($28)];
      var $31=(($30 << 24) >> 24);
      var $32=$4;
      var $33=(($32+1)|0);
      $4=$33;
      var $34=HEAP8[($32)];
      var $35=(($34 << 24) >> 24);
      var $36=(($31)|0)!=(($35)|0);
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      $1=0;
      __label__ = 22; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      var $40=$3;
      var $41=(($40+1)|0);
      $3=$41;
      var $42=HEAP8[($40)];
      var $43=(($42 << 24) >> 24);
      var $44=$4;
      var $45=(($44+1)|0);
      $4=$45;
      var $46=HEAP8[($44)];
      var $47=(($46 << 24) >> 24);
      var $48=(($43)|0)!=(($47)|0);
      if ($48) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $49
      $1=0;
      __label__ = 22; break;
    case 10: // $50
      var $51=$3;
      var $52=(($51+1)|0);
      $3=$52;
      var $53=HEAP8[($51)];
      var $54=(($53 << 24) >> 24);
      var $55=$4;
      var $56=(($55+1)|0);
      $4=$56;
      var $57=HEAP8[($55)];
      var $58=(($57 << 24) >> 24);
      var $59=(($54)|0)!=(($58)|0);
      if ($59) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      $1=0;
      __label__ = 22; break;
    case 12: // $61
      __label__ = 21; break;
    case 13: // $62
      var $63=$4;
      var $64=(($63+1)|0);
      $4=$64;
      var $65=HEAP8[($63)];
      var $66=(($65 << 24) >> 24);
      var $67=$3;
      var $68=(($67+1)|0);
      $3=$68;
      var $69=HEAP8[($67)];
      var $70=(($69 << 24) >> 24);
      var $71=(($66)|0)!=(($70)|0);
      if ($71) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $72
      $1=0;
      __label__ = 22; break;
    case 15: // $73
      __label__ = 21; break;
    case 16: // $74
      var $75=$3;
      var $76=HEAP8[($75)];
      var $77=(($76 << 24) >> 24);
      var $78=$4;
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24);
      var $81=(($77)|0)==(($80)|0);
      if ($81) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $82
      $1=1;
      __label__ = 22; break;
    case 18: // $83
      var $84=$4;
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$2;
      var $88=$87;
      var $89=(($88+76)|0);
      var $90=(($89+$86)|0);
      var $91=HEAPU8[($90)];
      var $92=(($91)&255);
      if ($92 == 5 || $92 == 6 || $92 == 7 || $92 == 29 || $92 == 22 || $92 == 23 || $92 == 24 || $92 == 25 || $92 == 26 || $92 == 27) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 19: // $93
      $1=0;
      __label__ = 22; break;
    case 20: // $94
      $1=1;
      __label__ = 22; break;
    case 21: // $95
      __label__ = 1; break;
    case 22: // $96
      var $97=$1;
      ;
      return $97;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15normal_sameNamePK8encodingPKcS3_["X"]=1;

function __ZL23normal_nameMatchesAsciiPK8encodingPKcS3_S3_($enc, $ptr1, $end1, $ptr2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr1;
      $4=$end1;
      $5=$ptr2;
      __label__ = 1; break;
    case 1: // $6
      var $7=$5;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $10
      var $11=$3;
      var $12=$4;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=0;
      __label__ = 9; break;
    case 4: // $15
      var $16=$3;
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=$5;
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($18)|0)==(($21)|0);
      if ($22) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $23
      $1=0;
      __label__ = 9; break;
    case 6: // $24
      __label__ = 7; break;
    case 7: // $25
      var $26=$3;
      var $27=(($26+1)|0);
      $3=$27;
      var $28=$5;
      var $29=(($28+1)|0);
      $5=$29;
      __label__ = 1; break;
    case 8: // $30
      var $31=$3;
      var $32=$4;
      var $33=(($31)|0)==(($32)|0);
      var $34=(($33)&1);
      $1=$34;
      __label__ = 9; break;
    case 9: // $35
      var $36=$1;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL23normal_ignoreSectionTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $level;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      $level=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$3;
      var $8=$4;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 41; break; }
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 5) {
        __label__ = 3; break;
      }
      else if ($19 == 6) {
        __label__ = 8; break;
      }
      else if ($19 == 7) {
        __label__ = 13; break;
      }
      else if ($19 == 0 || $19 == 1 || $19 == 8) {
        __label__ = 18; break;
      }
      else if ($19 == 2) {
        __label__ = 19; break;
      }
      else if ($19 == 4) {
        __label__ = 28; break;
      }
      else {
      __label__ = 39; break;
      }
      
    case 3: // $20
      var $21=$4;
      var $22=$3;
      var $23=$21;
      var $24=$22;
      var $25=(($23-$24)|0);
      var $26=(($25)|0) < 2;
      if ($26) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      $1=-2;
      __label__ = 42; break;
    case 5: // $28
      var $29=$2;
      var $30=$29;
      var $31=(($30+356)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$2;
      var $34=$3;
      var $35=FUNCTION_TABLE[$32]($33, $34);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$3;
      var $39=$5;
      HEAP32[(($39)>>2)]=$38;
      $1=0;
      __label__ = 42; break;
    case 7: // $40
      var $41=$3;
      var $42=(($41+2)|0);
      $3=$42;
      __label__ = 40; break;
    case 8: // $43
      var $44=$4;
      var $45=$3;
      var $46=$44;
      var $47=$45;
      var $48=(($46-$47)|0);
      var $49=(($48)|0) < 3;
      if ($49) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $50
      $1=-2;
      __label__ = 42; break;
    case 10: // $51
      var $52=$2;
      var $53=$52;
      var $54=(($53+360)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$2;
      var $57=$3;
      var $58=FUNCTION_TABLE[$55]($56, $57);
      var $59=(($58)|0)!=0;
      if ($59) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $60
      var $61=$3;
      var $62=$5;
      HEAP32[(($62)>>2)]=$61;
      $1=0;
      __label__ = 42; break;
    case 12: // $63
      var $64=$3;
      var $65=(($64+3)|0);
      $3=$65;
      __label__ = 40; break;
    case 13: // $66
      var $67=$4;
      var $68=$3;
      var $69=$67;
      var $70=$68;
      var $71=(($69-$70)|0);
      var $72=(($71)|0) < 4;
      if ($72) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $73
      $1=-2;
      __label__ = 42; break;
    case 15: // $74
      var $75=$2;
      var $76=$75;
      var $77=(($76+364)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$2;
      var $80=$3;
      var $81=FUNCTION_TABLE[$78]($79, $80);
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $83
      var $84=$3;
      var $85=$5;
      HEAP32[(($85)>>2)]=$84;
      $1=0;
      __label__ = 42; break;
    case 17: // $86
      var $87=$3;
      var $88=(($87+4)|0);
      $3=$88;
      __label__ = 40; break;
    case 18: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 42; break;
    case 19: // $92
      var $93=$3;
      var $94=(($93+1)|0);
      $3=$94;
      var $95=$4;
      var $96=(($94)|0)==(($95)|0);
      if ($96) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $97
      $1=-1;
      __label__ = 42; break;
    case 21: // $98
      var $99=$3;
      var $100=HEAP8[($99)];
      var $101=(($100 << 24) >> 24);
      var $102=(($101)|0)==33;
      if ($102) { __label__ = 22; break; } else { __label__ = 27; break; }
    case 22: // $103
      var $104=$3;
      var $105=(($104+1)|0);
      $3=$105;
      var $106=$4;
      var $107=(($105)|0)==(($106)|0);
      if ($107) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $108
      $1=-1;
      __label__ = 42; break;
    case 24: // $109
      var $110=$3;
      var $111=HEAP8[($110)];
      var $112=(($111 << 24) >> 24);
      var $113=(($112)|0)==91;
      if ($113) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $114
      var $115=$level;
      var $116=(($115+1)|0);
      $level=$116;
      var $117=$3;
      var $118=(($117+1)|0);
      $3=$118;
      __label__ = 26; break;
    case 26: // $119
      __label__ = 27; break;
    case 27: // $120
      __label__ = 40; break;
    case 28: // $121
      var $122=$3;
      var $123=(($122+1)|0);
      $3=$123;
      var $124=$4;
      var $125=(($123)|0)==(($124)|0);
      if ($125) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $126
      $1=-1;
      __label__ = 42; break;
    case 30: // $127
      var $128=$3;
      var $129=HEAP8[($128)];
      var $130=(($129 << 24) >> 24);
      var $131=(($130)|0)==93;
      if ($131) { __label__ = 31; break; } else { __label__ = 38; break; }
    case 31: // $132
      var $133=$3;
      var $134=(($133+1)|0);
      $3=$134;
      var $135=$4;
      var $136=(($134)|0)==(($135)|0);
      if ($136) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $137
      $1=-1;
      __label__ = 42; break;
    case 33: // $138
      var $139=$3;
      var $140=HEAP8[($139)];
      var $141=(($140 << 24) >> 24);
      var $142=(($141)|0)==62;
      if ($142) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 34: // $143
      var $144=$3;
      var $145=(($144+1)|0);
      $3=$145;
      var $146=$level;
      var $147=(($146)|0)==0;
      if ($147) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $148
      var $149=$3;
      var $150=$5;
      HEAP32[(($150)>>2)]=$149;
      $1=42;
      __label__ = 42; break;
    case 36: // $151
      var $152=$level;
      var $153=(($152-1)|0);
      $level=$153;
      __label__ = 37; break;
    case 37: // $154
      __label__ = 38; break;
    case 38: // $155
      __label__ = 40; break;
    case 39: // $156
      var $157=$3;
      var $158=(($157+1)|0);
      $3=$158;
      __label__ = 40; break;
    case 40: // $159
      __label__ = 1; break;
    case 41: // $160
      $1=-1;
      __label__ = 42; break;
    case 42: // $161
      var $162=$1;
      ;
      return $162;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23normal_ignoreSectionTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL24normal_attributeValueTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $start;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 28; break;
    case 2: // $10
      var $11=$3;
      $start=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 27; break; }
    case 4: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      if ($25 == 5) {
        __label__ = 5; break;
      }
      else if ($25 == 6) {
        __label__ = 6; break;
      }
      else if ($25 == 7) {
        __label__ = 7; break;
      }
      else if ($25 == 3) {
        __label__ = 8; break;
      }
      else if ($25 == 2) {
        __label__ = 11; break;
      }
      else if ($25 == 10) {
        __label__ = 12; break;
      }
      else if ($25 == 9) {
        __label__ = 15; break;
      }
      else if ($25 == 21) {
        __label__ = 22; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 5: // $26
      var $27=$3;
      var $28=(($27+2)|0);
      $3=$28;
      __label__ = 26; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30+3)|0);
      $3=$31;
      __label__ = 26; break;
    case 7: // $32
      var $33=$3;
      var $34=(($33+4)|0);
      $3=$34;
      __label__ = 26; break;
    case 8: // $35
      var $36=$3;
      var $37=$start;
      var $38=(($36)|0)==(($37)|0);
      if ($38) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      var $40=$2;
      var $41=$3;
      var $42=(($41+1)|0);
      var $43=$4;
      var $44=$5;
      var $45=__ZL14normal_scanRefPK8encodingPKcS3_PS3_($40, $42, $43, $44);
      $1=$45;
      __label__ = 28; break;
    case 10: // $46
      var $47=$3;
      var $48=$5;
      HEAP32[(($48)>>2)]=$47;
      $1=6;
      __label__ = 28; break;
    case 11: // $49
      var $50=$3;
      var $51=$5;
      HEAP32[(($51)>>2)]=$50;
      $1=0;
      __label__ = 28; break;
    case 12: // $52
      var $53=$3;
      var $54=$start;
      var $55=(($53)|0)==(($54)|0);
      if ($55) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $56
      var $57=$3;
      var $58=(($57+1)|0);
      var $59=$5;
      HEAP32[(($59)>>2)]=$58;
      $1=7;
      __label__ = 28; break;
    case 14: // $60
      var $61=$3;
      var $62=$5;
      HEAP32[(($62)>>2)]=$61;
      $1=6;
      __label__ = 28; break;
    case 15: // $63
      var $64=$3;
      var $65=$start;
      var $66=(($64)|0)==(($65)|0);
      if ($66) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $67
      var $68=$3;
      var $69=(($68+1)|0);
      $3=$69;
      var $70=$3;
      var $71=$4;
      var $72=(($70)|0)==(($71)|0);
      if ($72) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $73
      $1=-3;
      __label__ = 28; break;
    case 18: // $74
      var $75=$3;
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$2;
      var $79=$78;
      var $80=(($79+76)|0);
      var $81=(($80+$77)|0);
      var $82=HEAPU8[($81)];
      var $83=(($82)&255);
      var $84=(($83)|0)==10;
      if ($84) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $85
      var $86=$3;
      var $87=(($86+1)|0);
      $3=$87;
      __label__ = 20; break;
    case 20: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=7;
      __label__ = 28; break;
    case 21: // $91
      var $92=$3;
      var $93=$5;
      HEAP32[(($93)>>2)]=$92;
      $1=6;
      __label__ = 28; break;
    case 22: // $94
      var $95=$3;
      var $96=$start;
      var $97=(($95)|0)==(($96)|0);
      if ($97) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $98
      var $99=$3;
      var $100=(($99+1)|0);
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=39;
      __label__ = 28; break;
    case 24: // $102
      var $103=$3;
      var $104=$5;
      HEAP32[(($104)>>2)]=$103;
      $1=6;
      __label__ = 28; break;
    case 25: // $105
      var $106=$3;
      var $107=(($106+1)|0);
      $3=$107;
      __label__ = 26; break;
    case 26: // $108
      __label__ = 3; break;
    case 27: // $109
      var $110=$3;
      var $111=$5;
      HEAP32[(($111)>>2)]=$110;
      $1=6;
      __label__ = 28; break;
    case 28: // $112
      var $113=$1;
      ;
      return $113;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24normal_attributeValueTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL21normal_entityValueTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $start;
      var $tok;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 30; break;
    case 2: // $10
      var $11=$3;
      $start=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 29; break; }
    case 4: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      if ($25 == 5) {
        __label__ = 5; break;
      }
      else if ($25 == 6) {
        __label__ = 6; break;
      }
      else if ($25 == 7) {
        __label__ = 7; break;
      }
      else if ($25 == 3) {
        __label__ = 8; break;
      }
      else if ($25 == 30) {
        __label__ = 11; break;
      }
      else if ($25 == 10) {
        __label__ = 17; break;
      }
      else if ($25 == 9) {
        __label__ = 20; break;
      }
      else {
      __label__ = 27; break;
      }
      
    case 5: // $26
      var $27=$3;
      var $28=(($27+2)|0);
      $3=$28;
      __label__ = 28; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30+3)|0);
      $3=$31;
      __label__ = 28; break;
    case 7: // $32
      var $33=$3;
      var $34=(($33+4)|0);
      $3=$34;
      __label__ = 28; break;
    case 8: // $35
      var $36=$3;
      var $37=$start;
      var $38=(($36)|0)==(($37)|0);
      if ($38) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $39
      var $40=$2;
      var $41=$3;
      var $42=(($41+1)|0);
      var $43=$4;
      var $44=$5;
      var $45=__ZL14normal_scanRefPK8encodingPKcS3_PS3_($40, $42, $43, $44);
      $1=$45;
      __label__ = 30; break;
    case 10: // $46
      var $47=$3;
      var $48=$5;
      HEAP32[(($48)>>2)]=$47;
      $1=6;
      __label__ = 30; break;
    case 11: // $49
      var $50=$3;
      var $51=$start;
      var $52=(($50)|0)==(($51)|0);
      if ($52) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $53
      var $54=$2;
      var $55=$3;
      var $56=(($55+1)|0);
      var $57=$4;
      var $58=$5;
      var $59=__ZL18normal_scanPercentPK8encodingPKcS3_PS3_($54, $56, $57, $58);
      $tok=$59;
      var $60=$tok;
      var $61=(($60)|0)==22;
      if ($61) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $62
      var $66 = 0;__label__ = 15; break;
    case 14: // $63
      var $64=$tok;
      var $66 = $64;__label__ = 15; break;
    case 15: // $65
      var $66;
      $1=$66;
      __label__ = 30; break;
    case 16: // $67
      var $68=$3;
      var $69=$5;
      HEAP32[(($69)>>2)]=$68;
      $1=6;
      __label__ = 30; break;
    case 17: // $70
      var $71=$3;
      var $72=$start;
      var $73=(($71)|0)==(($72)|0);
      if ($73) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $74
      var $75=$3;
      var $76=(($75+1)|0);
      var $77=$5;
      HEAP32[(($77)>>2)]=$76;
      $1=7;
      __label__ = 30; break;
    case 19: // $78
      var $79=$3;
      var $80=$5;
      HEAP32[(($80)>>2)]=$79;
      $1=6;
      __label__ = 30; break;
    case 20: // $81
      var $82=$3;
      var $83=$start;
      var $84=(($82)|0)==(($83)|0);
      if ($84) { __label__ = 21; break; } else { __label__ = 26; break; }
    case 21: // $85
      var $86=$3;
      var $87=(($86+1)|0);
      $3=$87;
      var $88=$3;
      var $89=$4;
      var $90=(($88)|0)==(($89)|0);
      if ($90) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $91
      $1=-3;
      __label__ = 30; break;
    case 23: // $92
      var $93=$3;
      var $94=HEAPU8[($93)];
      var $95=(($94)&255);
      var $96=$2;
      var $97=$96;
      var $98=(($97+76)|0);
      var $99=(($98+$95)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=(($101)|0)==10;
      if ($102) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $103
      var $104=$3;
      var $105=(($104+1)|0);
      $3=$105;
      __label__ = 25; break;
    case 25: // $106
      var $107=$3;
      var $108=$5;
      HEAP32[(($108)>>2)]=$107;
      $1=7;
      __label__ = 30; break;
    case 26: // $109
      var $110=$3;
      var $111=$5;
      HEAP32[(($111)>>2)]=$110;
      $1=6;
      __label__ = 30; break;
    case 27: // $112
      var $113=$3;
      var $114=(($113+1)|0);
      $3=$114;
      __label__ = 28; break;
    case 28: // $115
      __label__ = 3; break;
    case 29: // $116
      var $117=$3;
      var $118=$5;
      HEAP32[(($118)>>2)]=$117;
      $1=6;
      __label__ = 30; break;
    case 30: // $119
      var $120=$1;
      ;
      return $120;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21normal_entityValueTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL17normal_nameLengthPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $start;
      $1=$enc;
      $2=$ptr;
      var $3=$2;
      $start=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=HEAPU8[($5)];
      var $7=(($6)&255);
      var $8=$1;
      var $9=$8;
      var $10=(($9+76)|0);
      var $11=(($10+$7)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      if ($13 == 5) {
        __label__ = 2; break;
      }
      else if ($13 == 6) {
        __label__ = 3; break;
      }
      else if ($13 == 7) {
        __label__ = 4; break;
      }
      else if ($13 == 29 || $13 == 22 || $13 == 23 || $13 == 24 || $13 == 25 || $13 == 26 || $13 == 27) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 2: // $14
      var $15=$2;
      var $16=(($15+2)|0);
      $2=$16;
      __label__ = 7; break;
    case 3: // $17
      var $18=$2;
      var $19=(($18+3)|0);
      $2=$19;
      __label__ = 7; break;
    case 4: // $20
      var $21=$2;
      var $22=(($21+4)|0);
      $2=$22;
      __label__ = 7; break;
    case 5: // $23
      var $24=$2;
      var $25=(($24+1)|0);
      $2=$25;
      __label__ = 7; break;
    case 6: // $26
      var $27=$2;
      var $28=$start;
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      ;
      return $31;
    case 7: // $32
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12normal_skipSPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$enc;
      $2=$ptr;
      __label__ = 1; break;
    case 1: // $3
      var $4=$2;
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$1;
      var $8=$7;
      var $9=(($8+76)|0);
      var $10=(($9+$6)|0);
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      if ($12 == 10 || $12 == 9 || $12 == 21) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 2: // $13
      var $14=$2;
      var $15=(($14+1)|0);
      $2=$15;
      __label__ = 4; break;
    case 3: // $16
      var $17=$2;
      ;
      return $17;
    case 4: // $18
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14normal_getAttsPK8encodingPKciP9ATTRIBUTE($enc, $ptr, $attsMax, $atts) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $state;
      var $nAtts;
      var $open;
      $1=$enc;
      $2=$ptr;
      $3=$attsMax;
      $4=$atts;
      $state=1;
      $nAtts=0;
      $open=0;
      var $5=$2;
      var $6=(($5+1)|0);
      $2=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$2;
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=$1;
      var $12=$11;
      var $13=(($12+76)|0);
      var $14=(($13+$10)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      if ($16 == 5) {
        __label__ = 2; break;
      }
      else if ($16 == 6) {
        __label__ = 7; break;
      }
      else if ($16 == 7) {
        __label__ = 12; break;
      }
      else if ($16 == 29 || $16 == 22 || $16 == 24) {
        __label__ = 17; break;
      }
      else if ($16 == 12) {
        __label__ = 22; break;
      }
      else if ($16 == 13) {
        __label__ = 32; break;
      }
      else if ($16 == 3) {
        __label__ = 42; break;
      }
      else if ($16 == 21) {
        __label__ = 45; break;
      }
      else if ($16 == 9 || $16 == 10) {
        __label__ = 57; break;
      }
      else if ($16 == 11 || $16 == 17) {
        __label__ = 64; break;
      }
      else {
      __label__ = 67; break;
      }
      
    case 2: // $17
      var $18=$state;
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $20
      var $21=$nAtts;
      var $22=$3;
      var $23=(($21)|0) < (($22)|0);
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      var $25=$2;
      var $26=$nAtts;
      var $27=$4;
      var $28=(($27+($26<<4))|0);
      var $29=(($28)|0);
      HEAP32[(($29)>>2)]=$25;
      var $30=$nAtts;
      var $31=$4;
      var $32=(($31+($30<<4))|0);
      var $33=(($32+12)|0);
      HEAP8[($33)]=1;
      __label__ = 5; break;
    case 5: // $34
      $state=1;
      __label__ = 6; break;
    case 6: // $35
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      __label__ = 68; break;
    case 7: // $38
      var $39=$state;
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $41
      var $42=$nAtts;
      var $43=$3;
      var $44=(($42)|0) < (($43)|0);
      if ($44) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $45
      var $46=$2;
      var $47=$nAtts;
      var $48=$4;
      var $49=(($48+($47<<4))|0);
      var $50=(($49)|0);
      HEAP32[(($50)>>2)]=$46;
      var $51=$nAtts;
      var $52=$4;
      var $53=(($52+($51<<4))|0);
      var $54=(($53+12)|0);
      HEAP8[($54)]=1;
      __label__ = 10; break;
    case 10: // $55
      $state=1;
      __label__ = 11; break;
    case 11: // $56
      var $57=$2;
      var $58=(($57+2)|0);
      $2=$58;
      __label__ = 68; break;
    case 12: // $59
      var $60=$state;
      var $61=(($60)|0)==0;
      if ($61) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $62
      var $63=$nAtts;
      var $64=$3;
      var $65=(($63)|0) < (($64)|0);
      if ($65) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $66
      var $67=$2;
      var $68=$nAtts;
      var $69=$4;
      var $70=(($69+($68<<4))|0);
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=$67;
      var $72=$nAtts;
      var $73=$4;
      var $74=(($73+($72<<4))|0);
      var $75=(($74+12)|0);
      HEAP8[($75)]=1;
      __label__ = 15; break;
    case 15: // $76
      $state=1;
      __label__ = 16; break;
    case 16: // $77
      var $78=$2;
      var $79=(($78+3)|0);
      $2=$79;
      __label__ = 68; break;
    case 17: // $80
      var $81=$state;
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $83
      var $84=$nAtts;
      var $85=$3;
      var $86=(($84)|0) < (($85)|0);
      if ($86) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $87
      var $88=$2;
      var $89=$nAtts;
      var $90=$4;
      var $91=(($90+($89<<4))|0);
      var $92=(($91)|0);
      HEAP32[(($92)>>2)]=$88;
      var $93=$nAtts;
      var $94=$4;
      var $95=(($94+($93<<4))|0);
      var $96=(($95+12)|0);
      HEAP8[($96)]=1;
      __label__ = 20; break;
    case 20: // $97
      $state=1;
      __label__ = 21; break;
    case 21: // $98
      __label__ = 68; break;
    case 22: // $99
      var $100=$state;
      var $101=(($100)|0)!=2;
      if ($101) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $102
      var $103=$nAtts;
      var $104=$3;
      var $105=(($103)|0) < (($104)|0);
      if ($105) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $106
      var $107=$2;
      var $108=(($107+1)|0);
      var $109=$nAtts;
      var $110=$4;
      var $111=(($110+($109<<4))|0);
      var $112=(($111+4)|0);
      HEAP32[(($112)>>2)]=$108;
      __label__ = 25; break;
    case 25: // $113
      $state=2;
      $open=12;
      __label__ = 31; break;
    case 26: // $114
      var $115=$open;
      var $116=(($115)|0)==12;
      if ($116) { __label__ = 27; break; } else { __label__ = 30; break; }
    case 27: // $117
      $state=0;
      var $118=$nAtts;
      var $119=$3;
      var $120=(($118)|0) < (($119)|0);
      if ($120) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $121
      var $122=$2;
      var $123=$nAtts;
      var $124=$4;
      var $125=(($124+($123<<4))|0);
      var $126=(($125+8)|0);
      HEAP32[(($126)>>2)]=$122;
      __label__ = 29; break;
    case 29: // $127
      var $128=$nAtts;
      var $129=(($128+1)|0);
      $nAtts=$129;
      __label__ = 30; break;
    case 30: // $130
      __label__ = 31; break;
    case 31: // $131
      __label__ = 68; break;
    case 32: // $132
      var $133=$state;
      var $134=(($133)|0)!=2;
      if ($134) { __label__ = 33; break; } else { __label__ = 36; break; }
    case 33: // $135
      var $136=$nAtts;
      var $137=$3;
      var $138=(($136)|0) < (($137)|0);
      if ($138) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $139
      var $140=$2;
      var $141=(($140+1)|0);
      var $142=$nAtts;
      var $143=$4;
      var $144=(($143+($142<<4))|0);
      var $145=(($144+4)|0);
      HEAP32[(($145)>>2)]=$141;
      __label__ = 35; break;
    case 35: // $146
      $state=2;
      $open=13;
      __label__ = 41; break;
    case 36: // $147
      var $148=$open;
      var $149=(($148)|0)==13;
      if ($149) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $150
      $state=0;
      var $151=$nAtts;
      var $152=$3;
      var $153=(($151)|0) < (($152)|0);
      if ($153) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $154
      var $155=$2;
      var $156=$nAtts;
      var $157=$4;
      var $158=(($157+($156<<4))|0);
      var $159=(($158+8)|0);
      HEAP32[(($159)>>2)]=$155;
      __label__ = 39; break;
    case 39: // $160
      var $161=$nAtts;
      var $162=(($161+1)|0);
      $nAtts=$162;
      __label__ = 40; break;
    case 40: // $163
      __label__ = 41; break;
    case 41: // $164
      __label__ = 68; break;
    case 42: // $165
      var $166=$nAtts;
      var $167=$3;
      var $168=(($166)|0) < (($167)|0);
      if ($168) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $169
      var $170=$nAtts;
      var $171=$4;
      var $172=(($171+($170<<4))|0);
      var $173=(($172+12)|0);
      HEAP8[($173)]=0;
      __label__ = 44; break;
    case 44: // $174
      __label__ = 68; break;
    case 45: // $175
      var $176=$state;
      var $177=(($176)|0)==1;
      if ($177) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $178
      $state=0;
      __label__ = 56; break;
    case 47: // $179
      var $180=$state;
      var $181=(($180)|0)==2;
      if ($181) { __label__ = 48; break; } else { __label__ = 55; break; }
    case 48: // $182
      var $183=$nAtts;
      var $184=$3;
      var $185=(($183)|0) < (($184)|0);
      if ($185) { __label__ = 49; break; } else { __label__ = 55; break; }
    case 49: // $186
      var $187=$nAtts;
      var $188=$4;
      var $189=(($188+($187<<4))|0);
      var $190=(($189+12)|0);
      var $191=HEAP8[($190)];
      var $192=(($191 << 24) >> 24)!=0;
      if ($192) { __label__ = 50; break; } else { __label__ = 55; break; }
    case 50: // $193
      var $194=$2;
      var $195=$nAtts;
      var $196=$4;
      var $197=(($196+($195<<4))|0);
      var $198=(($197+4)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=(($194)|0)==(($199)|0);
      if ($200) { __label__ = 54; break; } else { __label__ = 51; break; }
    case 51: // $201
      var $202=$2;
      var $203=HEAP8[($202)];
      var $204=(($203 << 24) >> 24);
      var $205=(($204)|0)!=32;
      if ($205) { __label__ = 54; break; } else { __label__ = 52; break; }
    case 52: // $206
      var $207=$2;
      var $208=(($207+1)|0);
      var $209=HEAP8[($208)];
      var $210=(($209 << 24) >> 24);
      var $211=(($210)|0)==32;
      if ($211) { __label__ = 54; break; } else { __label__ = 53; break; }
    case 53: // $212
      var $213=$2;
      var $214=(($213+1)|0);
      var $215=HEAPU8[($214)];
      var $216=(($215)&255);
      var $217=$1;
      var $218=$217;
      var $219=(($218+76)|0);
      var $220=(($219+$216)|0);
      var $221=HEAPU8[($220)];
      var $222=(($221)&255);
      var $223=$open;
      var $224=(($222)|0)==(($223)|0);
      if ($224) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $225
      var $226=$nAtts;
      var $227=$4;
      var $228=(($227+($226<<4))|0);
      var $229=(($228+12)|0);
      HEAP8[($229)]=0;
      __label__ = 55; break;
    case 55: // $230
      __label__ = 56; break;
    case 56: // $231
      __label__ = 68; break;
    case 57: // $232
      var $233=$state;
      var $234=(($233)|0)==1;
      if ($234) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $235
      $state=0;
      __label__ = 63; break;
    case 59: // $236
      var $237=$state;
      var $238=(($237)|0)==2;
      if ($238) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $239
      var $240=$nAtts;
      var $241=$3;
      var $242=(($240)|0) < (($241)|0);
      if ($242) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $243
      var $244=$nAtts;
      var $245=$4;
      var $246=(($245+($244<<4))|0);
      var $247=(($246+12)|0);
      HEAP8[($247)]=0;
      __label__ = 62; break;
    case 62: // $248
      __label__ = 63; break;
    case 63: // $249
      __label__ = 68; break;
    case 64: // $250
      var $251=$state;
      var $252=(($251)|0)!=2;
      if ($252) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $253
      var $254=$nAtts;
      ;
      return $254;
    case 66: // $255
      __label__ = 68; break;
    case 67: // $256
      __label__ = 68; break;
    case 68: // $257
      __label__ = 69; break;
    case 69: // $258
      var $259=$2;
      var $260=(($259+1)|0);
      $2=$260;
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14normal_getAttsPK8encodingPKciP9ATTRIBUTE["X"]=1;

function __ZL27normal_predefinedEntityNamePK8encodingPKcS3_($enc, $ptr, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      var $5=$4;
      var $6=$3;
      var $7=$5;
      var $8=$6;
      var $9=(($7-$8)|0);
      var $10=(((($9)|0))|0);
      if ($10 == 2) {
        __label__ = 1; break;
      }
      else if ($10 == 3) {
        __label__ = 7; break;
      }
      else if ($10 == 4) {
        __label__ = 14; break;
      }
      else {
      __label__ = 30; break;
      }
      
    case 1: // $11
      var $12=$3;
      var $13=(($12+1)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==116;
      if ($16) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $17
      var $18=$3;
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      if ($20 == 108) {
        __label__ = 3; break;
      }
      else if ($20 == 103) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 3: // $21
      $1=60;
      __label__ = 31; break;
    case 4: // $22
      $1=62;
      __label__ = 31; break;
    case 5: // $23
      __label__ = 6; break;
    case 6: // $24
      __label__ = 30; break;
    case 7: // $25
      var $26=$3;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=(($28)|0)==97;
      if ($29) { __label__ = 8; break; } else { __label__ = 13; break; }
    case 8: // $30
      var $31=$3;
      var $32=(($31+1)|0);
      $3=$32;
      var $33=$3;
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=(($35)|0)==109;
      if ($36) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $37
      var $38=$3;
      var $39=(($38+1)|0);
      $3=$39;
      var $40=$3;
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $43=(($42)|0)==112;
      if ($43) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $44
      $1=38;
      __label__ = 31; break;
    case 11: // $45
      __label__ = 12; break;
    case 12: // $46
      __label__ = 13; break;
    case 13: // $47
      __label__ = 30; break;
    case 14: // $48
      var $49=$3;
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24);
      if ($51 == 113) {
        __label__ = 15; break;
      }
      else if ($51 == 97) {
        __label__ = 22; break;
      }
      else {
      __label__ = 29; break;
      }
      
    case 15: // $52
      var $53=$3;
      var $54=(($53+1)|0);
      $3=$54;
      var $55=$3;
      var $56=HEAP8[($55)];
      var $57=(($56 << 24) >> 24);
      var $58=(($57)|0)==117;
      if ($58) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $59
      var $60=$3;
      var $61=(($60+1)|0);
      $3=$61;
      var $62=$3;
      var $63=HEAP8[($62)];
      var $64=(($63 << 24) >> 24);
      var $65=(($64)|0)==111;
      if ($65) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $66
      var $67=$3;
      var $68=(($67+1)|0);
      $3=$68;
      var $69=$3;
      var $70=HEAP8[($69)];
      var $71=(($70 << 24) >> 24);
      var $72=(($71)|0)==116;
      if ($72) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $73
      $1=34;
      __label__ = 31; break;
    case 19: // $74
      __label__ = 20; break;
    case 20: // $75
      __label__ = 21; break;
    case 21: // $76
      __label__ = 29; break;
    case 22: // $77
      var $78=$3;
      var $79=(($78+1)|0);
      $3=$79;
      var $80=$3;
      var $81=HEAP8[($80)];
      var $82=(($81 << 24) >> 24);
      var $83=(($82)|0)==112;
      if ($83) { __label__ = 23; break; } else { __label__ = 28; break; }
    case 23: // $84
      var $85=$3;
      var $86=(($85+1)|0);
      $3=$86;
      var $87=$3;
      var $88=HEAP8[($87)];
      var $89=(($88 << 24) >> 24);
      var $90=(($89)|0)==111;
      if ($90) { __label__ = 24; break; } else { __label__ = 27; break; }
    case 24: // $91
      var $92=$3;
      var $93=(($92+1)|0);
      $3=$93;
      var $94=$3;
      var $95=HEAP8[($94)];
      var $96=(($95 << 24) >> 24);
      var $97=(($96)|0)==115;
      if ($97) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $98
      $1=39;
      __label__ = 31; break;
    case 26: // $99
      __label__ = 27; break;
    case 27: // $100
      __label__ = 28; break;
    case 28: // $101
      __label__ = 29; break;
    case 29: // $102
      __label__ = 30; break;
    case 30: // $103
      $1=0;
      __label__ = 31; break;
    case 31: // $104
      var $105=$1;
      ;
      return $105;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27normal_predefinedEntityNamePK8encodingPKcS3_["X"]=1;

function __ZL20normal_charRefNumberPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $c;
      var $c1;
      $2=$enc;
      $3=$ptr;
      $result=0;
      var $4=$3;
      var $5=(($4+2)|0);
      $3=$5;
      var $6=$3;
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24);
      var $9=(($8)|0)==120;
      if ($9) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      $3=$12;
      __label__ = 2; break;
    case 2: // $13
      var $14=$3;
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)==59;
      var $18=$17 ^ 1;
      if ($18) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $19
      var $20=$3;
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      $c=$22;
      var $23=$c;
      if ($23 == 48 || $23 == 49 || $23 == 50 || $23 == 51 || $23 == 52 || $23 == 53 || $23 == 54 || $23 == 55 || $23 == 56 || $23 == 57) {
        __label__ = 4; break;
      }
      else if ($23 == 65 || $23 == 66 || $23 == 67 || $23 == 68 || $23 == 69 || $23 == 70) {
        __label__ = 5; break;
      }
      else if ($23 == 97 || $23 == 98 || $23 == 99 || $23 == 100 || $23 == 101 || $23 == 102) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 4: // $24
      var $25=$result;
      var $26=$25 << 4;
      $result=$26;
      var $27=$c;
      var $28=(($27-48)|0);
      var $29=$result;
      var $30=$29 | $28;
      $result=$30;
      __label__ = 7; break;
    case 5: // $31
      var $32=$result;
      var $33=$32 << 4;
      $result=$33;
      var $34=$c;
      var $35=(($34-65)|0);
      var $36=(($35+10)|0);
      var $37=$result;
      var $38=(($37+$36)|0);
      $result=$38;
      __label__ = 7; break;
    case 6: // $39
      var $40=$result;
      var $41=$40 << 4;
      $result=$41;
      var $42=$c;
      var $43=(($42-97)|0);
      var $44=(($43+10)|0);
      var $45=$result;
      var $46=(($45+$44)|0);
      $result=$46;
      __label__ = 7; break;
    case 7: // $47
      var $48=$result;
      var $49=(($48)|0) >= 1114112;
      if ($49) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $50
      $1=-1;
      __label__ = 20; break;
    case 9: // $51
      __label__ = 10; break;
    case 10: // $52
      var $53=$3;
      var $54=(($53+1)|0);
      $3=$54;
      __label__ = 2; break;
    case 11: // $55
      __label__ = 19; break;
    case 12: // $56
      __label__ = 13; break;
    case 13: // $57
      var $58=$3;
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $61=(($60)|0)==59;
      var $62=$61 ^ 1;
      if ($62) { __label__ = 14; break; } else { __label__ = 18; break; }
    case 14: // $63
      var $64=$3;
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24);
      $c1=$66;
      var $67=$result;
      var $68=(($67*10)|0);
      $result=$68;
      var $69=$c1;
      var $70=(($69-48)|0);
      var $71=$result;
      var $72=(($71+$70)|0);
      $result=$72;
      var $73=$result;
      var $74=(($73)|0) >= 1114112;
      if ($74) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $75
      $1=-1;
      __label__ = 20; break;
    case 16: // $76
      __label__ = 17; break;
    case 17: // $77
      var $78=$3;
      var $79=(($78+1)|0);
      $3=$79;
      __label__ = 13; break;
    case 18: // $80
      __label__ = 19; break;
    case 19: // $81
      var $82=$result;
      var $83=__ZL18checkCharRefNumberi($82);
      $1=$83;
      __label__ = 20; break;
    case 20: // $84
      var $85=$1;
      ;
      return $85;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20normal_charRefNumberPK8encodingPKc["X"]=1;

function _XmlSizeOfUnknownEncoding() {
  ;
  var __label__;

  ;
  return 1912;
}


function __ZL21normal_updatePositionPK8encodingPKcS3_P8position($enc, $ptr, $end, $pos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$enc;
      $2=$ptr;
      $3=$end;
      $4=$pos;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 13; break; }
    case 2: // $9
      var $10=$2;
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$1;
      var $14=$13;
      var $15=(($14+76)|0);
      var $16=(($15+$12)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      if ($18 == 5) {
        __label__ = 3; break;
      }
      else if ($18 == 6) {
        __label__ = 4; break;
      }
      else if ($18 == 7) {
        __label__ = 5; break;
      }
      else if ($18 == 10) {
        __label__ = 6; break;
      }
      else if ($18 == 9) {
        __label__ = 7; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 3: // $19
      var $20=$2;
      var $21=(($20+2)|0);
      $2=$21;
      __label__ = 12; break;
    case 4: // $22
      var $23=$2;
      var $24=(($23+3)|0);
      $2=$24;
      __label__ = 12; break;
    case 5: // $25
      var $26=$2;
      var $27=(($26+4)|0);
      $2=$27;
      __label__ = 12; break;
    case 6: // $28
      var $29=$4;
      var $30=(($29+4)|0);
      HEAP32[(($30)>>2)]=-1;
      var $31=$4;
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+1)|0);
      HEAP32[(($32)>>2)]=$34;
      var $35=$2;
      var $36=(($35+1)|0);
      $2=$36;
      __label__ = 12; break;
    case 7: // $37
      var $38=$4;
      var $39=(($38)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+1)|0);
      HEAP32[(($39)>>2)]=$41;
      var $42=$2;
      var $43=(($42+1)|0);
      $2=$43;
      var $44=$2;
      var $45=$3;
      var $46=(($44)|0)!=(($45)|0);
      if ($46) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $47
      var $48=$2;
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$1;
      var $52=$51;
      var $53=(($52+76)|0);
      var $54=(($53+$50)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=(($56)|0)==10;
      if ($57) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $58
      var $59=$2;
      var $60=(($59+1)|0);
      $2=$60;
      __label__ = 10; break;
    case 10: // $61
      var $62=$4;
      var $63=(($62+4)|0);
      HEAP32[(($63)>>2)]=-1;
      __label__ = 12; break;
    case 11: // $64
      var $65=$2;
      var $66=(($65+1)|0);
      $2=$66;
      __label__ = 12; break;
    case 12: // $67
      var $68=$4;
      var $69=(($68+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+1)|0);
      HEAP32[(($69)>>2)]=$71;
      __label__ = 1; break;
    case 13: // $72
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21normal_updatePositionPK8encodingPKcS3_P8position["X"]=1;

function __ZL17normal_isPublicIdPK8encodingPKcS3_PS3_($enc, $ptr, $end, $badPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$badPtr;
      var $6=$3;
      var $7=(($6+1)|0);
      $3=$7;
      var $8=$4;
      var $9=(($8-1)|0);
      $4=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$3;
      var $12=$4;
      var $13=(($11)|0)!=(($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 16; break; }
    case 2: // $14
      var $15=$3;
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$2;
      var $19=$18;
      var $20=(($19+76)|0);
      var $21=(($20+$17)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      if ($23 == 25 || $23 == 24 || $23 == 27 || $23 == 13 || $23 == 31 || $23 == 32 || $23 == 34 || $23 == 35 || $23 == 17 || $23 == 14 || $23 == 15 || $23 == 9 || $23 == 10 || $23 == 18 || $23 == 16 || $23 == 33 || $23 == 30 || $23 == 19 || $23 == 23) {
        __label__ = 3; break;
      }
      else if ($23 == 21) {
        __label__ = 4; break;
      }
      else if ($23 == 26 || $23 == 22) {
        __label__ = 7; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 3: // $24
      __label__ = 14; break;
    case 4: // $25
      var $26=$3;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=(($28)|0)==9;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$3;
      var $32=$5;
      HEAP32[(($32)>>2)]=$31;
      $1=0;
      __label__ = 17; break;
    case 6: // $33
      __label__ = 14; break;
    case 7: // $34
      var $35=$3;
      var $36=HEAP8[($35)];
      var $37=(($36 << 24) >> 24);
      var $38=$37 & -128;
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $40
      __label__ = 14; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      var $43=$3;
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      if ($45 == 36 || $45 == 64) {
        __label__ = 11; break;
      }
      else {
      __label__ = 12; break;
      }
      
    case 11: // $46
      __label__ = 13; break;
    case 12: // $47
      var $48=$3;
      var $49=$5;
      HEAP32[(($49)>>2)]=$48;
      $1=0;
      __label__ = 17; break;
    case 13: // $50
      __label__ = 14; break;
    case 14: // $51
      __label__ = 15; break;
    case 15: // $52
      var $53=$3;
      var $54=(($53+1)|0);
      $3=$54;
      __label__ = 1; break;
    case 16: // $55
      $1=1;
      __label__ = 17; break;
    case 17: // $56
      var $57=$1;
      ;
      return $57;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17normal_isPublicIdPK8encodingPKcS3_PS3_["X"]=1;

function __ZL12ascii_toUtf8PK8encodingPPKcS3_PPcS3_($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=HEAP32[(($7)>>2)];
      var $9=$3;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { var $17 = 0;__label__ = 3; break; }
    case 2: // $11
      var $12=$4;
      var $13=HEAP32[(($12)>>2)];
      var $14=$5;
      var $15=(($13)|0)!=(($14)|0);
      var $17 = $15;__label__ = 3; break;
    case 3: // $16
      var $17;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$2;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+1)|0);
      HEAP32[(($19)>>2)]=$21;
      var $22=HEAP8[($20)];
      var $23=$4;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+1)|0);
      HEAP32[(($23)>>2)]=$25;
      HEAP8[($24)]=$22;
      __label__ = 1; break;
    case 5: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14latin1_toUtf16PK8encodingPPKcS3_PPtPKt($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=HEAP32[(($7)>>2)];
      var $9=$3;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { var $17 = 0;__label__ = 3; break; }
    case 2: // $11
      var $12=$4;
      var $13=HEAP32[(($12)>>2)];
      var $14=$5;
      var $15=(($13)|0)!=(($14)|0);
      var $17 = $15;__label__ = 3; break;
    case 3: // $16
      var $17;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      var $19=$2;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+1)|0);
      HEAP32[(($19)>>2)]=$21;
      var $22=HEAPU8[($20)];
      var $23=(($22)&255);
      var $24=$4;
      var $25=HEAPU32[(($24)>>2)];
      var $26=(($25+2)|0);
      HEAP32[(($24)>>2)]=$26;
      HEAP16[(($25)>>1)]=$23;
      __label__ = 1; break;
    case 5: // $27
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function _XmlUtf8Encode($c, $buf) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$c;
      $3=$buf;
      var $4=$2;
      var $5=(($4)|0) < 0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      $1=0;
      __label__ = 11; break;
    case 2: // $7
      var $8=$2;
      var $9=(($8)|0) < 128;
      if ($9) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $10
      var $11=$2;
      var $12=(($11) & 255);
      var $13=$3;
      var $14=(($13)|0);
      HEAP8[($14)]=$12;
      $1=1;
      __label__ = 11; break;
    case 4: // $15
      var $16=$2;
      var $17=(($16)|0) < 2048;
      if ($17) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $18
      var $19=$2;
      var $20=$19 >> 6;
      var $21=$20 | 192;
      var $22=(($21) & 255);
      var $23=$3;
      var $24=(($23)|0);
      HEAP8[($24)]=$22;
      var $25=$2;
      var $26=$25 & 63;
      var $27=$26 | 128;
      var $28=(($27) & 255);
      var $29=$3;
      var $30=(($29+1)|0);
      HEAP8[($30)]=$28;
      $1=2;
      __label__ = 11; break;
    case 6: // $31
      var $32=$2;
      var $33=(($32)|0) < 65536;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$2;
      var $36=$35 >> 12;
      var $37=$36 | 224;
      var $38=(($37) & 255);
      var $39=$3;
      var $40=(($39)|0);
      HEAP8[($40)]=$38;
      var $41=$2;
      var $42=$41 >> 6;
      var $43=$42 & 63;
      var $44=$43 | 128;
      var $45=(($44) & 255);
      var $46=$3;
      var $47=(($46+1)|0);
      HEAP8[($47)]=$45;
      var $48=$2;
      var $49=$48 & 63;
      var $50=$49 | 128;
      var $51=(($50) & 255);
      var $52=$3;
      var $53=(($52+2)|0);
      HEAP8[($53)]=$51;
      $1=3;
      __label__ = 11; break;
    case 8: // $54
      var $55=$2;
      var $56=(($55)|0) < 1114112;
      if ($56) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $57
      var $58=$2;
      var $59=$58 >> 18;
      var $60=$59 | 240;
      var $61=(($60) & 255);
      var $62=$3;
      var $63=(($62)|0);
      HEAP8[($63)]=$61;
      var $64=$2;
      var $65=$64 >> 12;
      var $66=$65 & 63;
      var $67=$66 | 128;
      var $68=(($67) & 255);
      var $69=$3;
      var $70=(($69+1)|0);
      HEAP8[($70)]=$68;
      var $71=$2;
      var $72=$71 >> 6;
      var $73=$72 & 63;
      var $74=$73 | 128;
      var $75=(($74) & 255);
      var $76=$3;
      var $77=(($76+2)|0);
      HEAP8[($77)]=$75;
      var $78=$2;
      var $79=$78 & 63;
      var $80=$79 | 128;
      var $81=(($80) & 255);
      var $82=$3;
      var $83=(($82+3)|0);
      HEAP8[($83)]=$81;
      $1=4;
      __label__ = 11; break;
    case 10: // $84
      $1=0;
      __label__ = 11; break;
    case 11: // $85
      var $86=$1;
      ;
      return $86;
    default: assert(0, "bad label: " + __label__);
  }
}
_XmlUtf8Encode["X"]=1;

function _XmlInitUnknownEncoding($mem, $table, $convert, $userData) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $i;
      var $e;
      var $c;
      $2=$mem;
      $3=$table;
      $4=$convert;
      $5=$userData;
      var $6=$2;
      var $7=$6;
      $e=$7;
      $i=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$i;
      var $10=(($9)|0) < 368;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$i;
      var $13=(((STRING_TABLE.__ZL15latin1_encoding)+$12)|0);
      var $14=HEAP8[($13)];
      var $15=$i;
      var $16=$2;
      var $17=(($16+$15)|0);
      HEAP8[($17)]=$14;
      __label__ = 3; break;
    case 3: // $18
      var $19=$i;
      var $20=(($19+1)|0);
      $i=$20;
      __label__ = 1; break;
    case 4: // $21
      $i=0;
      __label__ = 5; break;
    case 5: // $22
      var $23=$i;
      var $24=(($23)|0) < 128;
      if ($24) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $25
      var $26=$i;
      var $27=(((((STRING_TABLE.__ZL15latin1_encoding)+76)|0)+$26)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $30=(($29)|0)!=28;
      if ($30) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $31
      var $32=$i;
      var $33=(((((STRING_TABLE.__ZL15latin1_encoding)+76)|0)+$32)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $37
      var $38=$i;
      var $39=$3;
      var $40=(($39+($38<<2))|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$i;
      var $43=(($41)|0)!=(($42)|0);
      if ($43) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $44
      $1=0;
      __label__ = 48; break;
    case 10: // $45
      __label__ = 11; break;
    case 11: // $46
      var $47=$i;
      var $48=(($47+1)|0);
      $i=$48;
      __label__ = 5; break;
    case 12: // $49
      $i=0;
      __label__ = 13; break;
    case 13: // $50
      var $51=$i;
      var $52=(($51)|0) < 256;
      if ($52) { __label__ = 14; break; } else { __label__ = 45; break; }
    case 14: // $53
      var $54=$i;
      var $55=$3;
      var $56=(($55+($54<<2))|0);
      var $57=HEAP32[(($56)>>2)];
      $c=$57;
      var $58=$c;
      var $59=(($58)|0)==-1;
      if ($59) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $60
      var $61=$i;
      var $62=$e;
      var $63=(($62)|0);
      var $64=(($63+76)|0);
      var $65=(($64+$61)|0);
      HEAP8[($65)]=1;
      var $66=$i;
      var $67=$e;
      var $68=(($67+376)|0);
      var $69=(($68+($66<<1))|0);
      HEAP16[(($69)>>1)]=-1;
      var $70=$i;
      var $71=$e;
      var $72=(($71+888)|0);
      var $73=(($72+($70<<2))|0);
      var $74=(($73)|0);
      HEAP8[($74)]=1;
      var $75=$i;
      var $76=$e;
      var $77=(($76+888)|0);
      var $78=(($77+($75<<2))|0);
      var $79=(($78+1)|0);
      HEAP8[($79)]=0;
      __label__ = 43; break;
    case 16: // $80
      var $81=$c;
      var $82=(($81)|0) < 0;
      if ($82) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $83
      var $84=$c;
      var $85=(($84)|0) < -4;
      if ($85) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $86
      $1=0;
      __label__ = 48; break;
    case 19: // $87
      var $88=$c;
      var $89=(($88+2)|0);
      var $90=((5-$89)|0);
      var $91=(($90) & 255);
      var $92=$i;
      var $93=$e;
      var $94=(($93)|0);
      var $95=(($94+76)|0);
      var $96=(($95+$92)|0);
      HEAP8[($96)]=$91;
      var $97=$i;
      var $98=$e;
      var $99=(($98+888)|0);
      var $100=(($99+($97<<2))|0);
      var $101=(($100)|0);
      HEAP8[($101)]=0;
      var $102=$i;
      var $103=$e;
      var $104=(($103+376)|0);
      var $105=(($104+($102<<1))|0);
      HEAP16[(($105)>>1)]=0;
      __label__ = 42; break;
    case 20: // $106
      var $107=$c;
      var $108=(($107)|0) < 128;
      if ($108) { __label__ = 21; break; } else { __label__ = 29; break; }
    case 21: // $109
      var $110=$c;
      var $111=(((((STRING_TABLE.__ZL15latin1_encoding)+76)|0)+$110)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=(($113)|0)!=28;
      if ($114) { __label__ = 22; break; } else { __label__ = 25; break; }
    case 22: // $115
      var $116=$c;
      var $117=(((((STRING_TABLE.__ZL15latin1_encoding)+76)|0)+$116)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=(($119)|0)!=0;
      if ($120) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $121
      var $122=$c;
      var $123=$i;
      var $124=(($122)|0)!=(($123)|0);
      if ($124) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $125
      $1=0;
      __label__ = 48; break;
    case 25: // $126
      var $127=$c;
      var $128=(((((STRING_TABLE.__ZL15latin1_encoding)+76)|0)+$127)|0);
      var $129=HEAP8[($128)];
      var $130=$i;
      var $131=$e;
      var $132=(($131)|0);
      var $133=(($132+76)|0);
      var $134=(($133+$130)|0);
      HEAP8[($134)]=$129;
      var $135=$i;
      var $136=$e;
      var $137=(($136+888)|0);
      var $138=(($137+($135<<2))|0);
      var $139=(($138)|0);
      HEAP8[($139)]=1;
      var $140=$c;
      var $141=(($140) & 255);
      var $142=$i;
      var $143=$e;
      var $144=(($143+888)|0);
      var $145=(($144+($142<<2))|0);
      var $146=(($145+1)|0);
      HEAP8[($146)]=$141;
      var $147=$c;
      var $148=(($147)|0)==0;
      if ($148) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $149
      var $153 = 65535;__label__ = 28; break;
    case 27: // $150
      var $151=$c;
      var $153 = $151;__label__ = 28; break;
    case 28: // $152
      var $153;
      var $154=(($153) & 65535);
      var $155=$i;
      var $156=$e;
      var $157=(($156+376)|0);
      var $158=(($157+($155<<1))|0);
      HEAP16[(($158)>>1)]=$154;
      __label__ = 41; break;
    case 29: // $159
      var $160=$c;
      var $161=__ZL18checkCharRefNumberi($160);
      var $162=(($161)|0) < 0;
      if ($162) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $163
      var $164=$i;
      var $165=$e;
      var $166=(($165)|0);
      var $167=(($166+76)|0);
      var $168=(($167+$164)|0);
      HEAP8[($168)]=0;
      var $169=$i;
      var $170=$e;
      var $171=(($170+376)|0);
      var $172=(($171+($169<<1))|0);
      HEAP16[(($172)>>1)]=-1;
      var $173=$i;
      var $174=$e;
      var $175=(($174+888)|0);
      var $176=(($175+($173<<2))|0);
      var $177=(($176)|0);
      HEAP8[($177)]=1;
      var $178=$i;
      var $179=$e;
      var $180=(($179+888)|0);
      var $181=(($180+($178<<2))|0);
      var $182=(($181+1)|0);
      HEAP8[($182)]=0;
      __label__ = 40; break;
    case 31: // $183
      var $184=$c;
      var $185=(($184)|0) > 65535;
      if ($185) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $186
      $1=0;
      __label__ = 48; break;
    case 33: // $187
      var $188=$c;
      var $189=$188 >> 8;
      var $190=((STRING_TABLE.__ZL11nmstrtPages+$189)|0);
      var $191=HEAPU8[($190)];
      var $192=(($191)&255);
      var $193=$192 << 3;
      var $194=$c;
      var $195=$194 & 255;
      var $196=$195 >> 5;
      var $197=(($193+$196)|0);
      var $198=((__ZL12namingBitmap+($197<<2))|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=$c;
      var $201=$200 & 255;
      var $202=$201 & 31;
      var $203=1 << $202;
      var $204=$199 & $203;
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $206
      var $207=$i;
      var $208=$e;
      var $209=(($208)|0);
      var $210=(($209+76)|0);
      var $211=(($210+$207)|0);
      HEAP8[($211)]=22;
      __label__ = 39; break;
    case 35: // $212
      var $213=$c;
      var $214=$213 >> 8;
      var $215=((STRING_TABLE.__ZL9namePages+$214)|0);
      var $216=HEAPU8[($215)];
      var $217=(($216)&255);
      var $218=$217 << 3;
      var $219=$c;
      var $220=$219 & 255;
      var $221=$220 >> 5;
      var $222=(($218+$221)|0);
      var $223=((__ZL12namingBitmap+($222<<2))|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=$c;
      var $226=$225 & 255;
      var $227=$226 & 31;
      var $228=1 << $227;
      var $229=$224 & $228;
      var $230=(($229)|0)!=0;
      if ($230) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $231
      var $232=$i;
      var $233=$e;
      var $234=(($233)|0);
      var $235=(($234+76)|0);
      var $236=(($235+$232)|0);
      HEAP8[($236)]=26;
      __label__ = 38; break;
    case 37: // $237
      var $238=$i;
      var $239=$e;
      var $240=(($239)|0);
      var $241=(($240+76)|0);
      var $242=(($241+$238)|0);
      HEAP8[($242)]=28;
      __label__ = 38; break;
    case 38: // $243
      __label__ = 39; break;
    case 39: // $244
      var $245=$c;
      var $246=$i;
      var $247=$e;
      var $248=(($247+888)|0);
      var $249=(($248+($246<<2))|0);
      var $250=(($249)|0);
      var $251=(($250+1)|0);
      var $252=_XmlUtf8Encode($245, $251);
      var $253=(($252) & 255);
      var $254=$i;
      var $255=$e;
      var $256=(($255+888)|0);
      var $257=(($256+($254<<2))|0);
      var $258=(($257)|0);
      HEAP8[($258)]=$253;
      var $259=$c;
      var $260=(($259) & 65535);
      var $261=$i;
      var $262=$e;
      var $263=(($262+376)|0);
      var $264=(($263+($261<<1))|0);
      HEAP16[(($264)>>1)]=$260;
      __label__ = 40; break;
    case 40: // $265
      __label__ = 41; break;
    case 41: // $266
      __label__ = 42; break;
    case 42: // $267
      __label__ = 43; break;
    case 43: // $268
      __label__ = 44; break;
    case 44: // $269
      var $270=$i;
      var $271=(($270+1)|0);
      $i=$271;
      __label__ = 13; break;
    case 45: // $272
      var $273=$5;
      var $274=$e;
      var $275=(($274+372)|0);
      HEAP32[(($275)>>2)]=$273;
      var $276=$4;
      var $277=$e;
      var $278=(($277+368)|0);
      HEAP32[(($278)>>2)]=$276;
      var $279=$4;
      var $280=(($279)|0)!=0;
      if ($280) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $281
      var $282=$e;
      var $283=(($282)|0);
      var $284=(($283+332)|0);
      HEAP32[(($284)>>2)]=1628;
      var $285=$e;
      var $286=(($285)|0);
      var $287=(($286+336)|0);
      HEAP32[(($287)>>2)]=1628;
      var $288=$e;
      var $289=(($288)|0);
      var $290=(($289+340)|0);
      HEAP32[(($290)>>2)]=1628;
      var $291=$e;
      var $292=(($291)|0);
      var $293=(($292+344)|0);
      HEAP32[(($293)>>2)]=1630;
      var $294=$e;
      var $295=(($294)|0);
      var $296=(($295+348)|0);
      HEAP32[(($296)>>2)]=1630;
      var $297=$e;
      var $298=(($297)|0);
      var $299=(($298+352)|0);
      HEAP32[(($299)>>2)]=1630;
      var $300=$e;
      var $301=(($300)|0);
      var $302=(($301+356)|0);
      HEAP32[(($302)>>2)]=1632;
      var $303=$e;
      var $304=(($303)|0);
      var $305=(($304+360)|0);
      HEAP32[(($305)>>2)]=1632;
      var $306=$e;
      var $307=(($306)|0);
      var $308=(($307+364)|0);
      HEAP32[(($308)>>2)]=1632;
      __label__ = 47; break;
    case 47: // $309
      var $310=$e;
      var $311=(($310)|0);
      var $312=(($311)|0);
      var $313=(($312+60)|0);
      HEAP32[(($313)>>2)]=1634;
      var $314=$e;
      var $315=(($314)|0);
      var $316=(($315)|0);
      var $317=(($316+64)|0);
      HEAP32[(($317)>>2)]=1636;
      var $318=$e;
      var $319=(($318)|0);
      var $320=(($319)|0);
      $1=$320;
      __label__ = 48; break;
    case 48: // $321
      var $322=$1;
      ;
      return $322;
    default: assert(0, "bad label: " + __label__);
  }
}
_XmlInitUnknownEncoding["X"]=1;

function _XmlGetUtf8InternalEncoding() {
  ;
  var __label__;

  ;
  return (((STRING_TABLE.__ZL22internal_utf8_encoding))|0);
}


function __ZL18checkCharRefNumberi($result) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$result;
      var $3=$2;
      var $4=$3 >> 8;
      if ($4 == 216 || $4 == 217 || $4 == 218 || $4 == 219 || $4 == 220 || $4 == 221 || $4 == 222 || $4 == 223) {
        __label__ = 1; break;
      }
      else if ($4 == 0) {
        __label__ = 2; break;
      }
      else if ($4 == 255) {
        __label__ = 5; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 1: // $5
      $1=-1;
      __label__ = 10; break;
    case 2: // $6
      var $7=$2;
      var $8=(((((STRING_TABLE.__ZL15latin1_encoding)+76)|0)+$7)|0);
      var $9=HEAPU8[($8)];
      var $10=(($9)&255);
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      $1=-1;
      __label__ = 10; break;
    case 4: // $13
      __label__ = 9; break;
    case 5: // $14
      var $15=$2;
      var $16=(($15)|0)==65534;
      if ($16) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $17
      var $18=$2;
      var $19=(($18)|0)==65535;
      if ($19) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $20
      $1=-1;
      __label__ = 10; break;
    case 8: // $21
      __label__ = 9; break;
    case 9: // $22
      var $23=$2;
      $1=$23;
      __label__ = 10; break;
    case 10: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14unknown_isNamePK8encodingPKc($enc, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $uenc;
      var $c;
      $2=$enc;
      $3=$p;
      var $4=$2;
      var $5=$4;
      $uenc=$5;
      var $6=$uenc;
      var $7=(($6+368)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$uenc;
      var $10=(($9+372)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=FUNCTION_TABLE[$8]($11, $12);
      $c=$13;
      var $14=$c;
      var $15=$14 & -65536;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$c;
      var $20=$19 >> 8;
      var $21=((STRING_TABLE.__ZL9namePages+$20)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 << 3;
      var $25=$c;
      var $26=$25 & 255;
      var $27=$26 >> 5;
      var $28=(($24+$27)|0);
      var $29=((__ZL12namingBitmap+($28<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$c;
      var $32=$31 & 255;
      var $33=$32 & 31;
      var $34=1 << $33;
      var $35=$30 & $34;
      $1=$35;
      __label__ = 3; break;
    case 3: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL16unknown_isNmstrtPK8encodingPKc($enc, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $uenc;
      var $c;
      $2=$enc;
      $3=$p;
      var $4=$2;
      var $5=$4;
      $uenc=$5;
      var $6=$uenc;
      var $7=(($6+368)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$uenc;
      var $10=(($9+372)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$3;
      var $13=FUNCTION_TABLE[$8]($11, $12);
      $c=$13;
      var $14=$c;
      var $15=$14 & -65536;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 3; break;
    case 2: // $18
      var $19=$c;
      var $20=$19 >> 8;
      var $21=((STRING_TABLE.__ZL11nmstrtPages+$20)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$23 << 3;
      var $25=$c;
      var $26=$25 & 255;
      var $27=$26 >> 5;
      var $28=(($24+$27)|0);
      var $29=((__ZL12namingBitmap+($28<<2))|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$c;
      var $32=$31 & 255;
      var $33=$32 & 31;
      var $34=1 << $33;
      var $35=$30 & $34;
      $1=$35;
      __label__ = 3; break;
    case 3: // $36
      var $37=$1;
      ;
      return $37;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17unknown_isInvalidPK8encodingPKc($enc, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $uenc;
      var $c;
      $1=$enc;
      $2=$p;
      var $3=$1;
      var $4=$3;
      $uenc=$4;
      var $5=$uenc;
      var $6=(($5+368)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$uenc;
      var $9=(($8+372)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$2;
      var $12=FUNCTION_TABLE[$7]($10, $11);
      $c=$12;
      var $13=$c;
      var $14=$13 & -65536;
      var $15=(($14)|0)!=0;
      if ($15) { var $21 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $16
      var $17=$c;
      var $18=__ZL18checkCharRefNumberi($17);
      var $19=(($18)|0) < 0;
      var $21 = $19;__label__ = 2; break;
    case 2: // $20
      var $21;
      var $22=(($21)&1);
      ;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14unknown_toUtf8PK8encodingPPKcS3_PPcS3_($enc, $fromP, $fromLim, $toP, $toLim) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $uenc;
      var $buf=__stackBase__;
      var $utf8;
      var $n;
      var $c;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$1;
      var $7=$6;
      $uenc=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$2;
      var $10=HEAP32[(($9)>>2)];
      var $11=$3;
      var $12=(($10)|0)==(($11)|0);
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      __label__ = 14; break;
    case 3: // $14
      var $15=$2;
      var $16=HEAP32[(($15)>>2)];
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$uenc;
      var $20=(($19+888)|0);
      var $21=(($20+($18<<2))|0);
      var $22=(($21)|0);
      $utf8=$22;
      var $23=$utf8;
      var $24=(($23+1)|0);
      $utf8=$24;
      var $25=HEAP8[($23)];
      var $26=(($25 << 24) >> 24);
      $n=$26;
      var $27=$n;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $29
      var $30=$uenc;
      var $31=(($30+368)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$uenc;
      var $34=(($33+372)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$2;
      var $37=HEAP32[(($36)>>2)];
      var $38=FUNCTION_TABLE[$32]($35, $37);
      $c=$38;
      var $39=$c;
      var $40=(($buf)|0);
      var $41=_XmlUtf8Encode($39, $40);
      $n=$41;
      var $42=$n;
      var $43=$5;
      var $44=$4;
      var $45=HEAP32[(($44)>>2)];
      var $46=$43;
      var $47=$45;
      var $48=(($46-$47)|0);
      var $49=(($42)|0) > (($48)|0);
      if ($49) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $50
      __label__ = 14; break;
    case 6: // $51
      var $52=(($buf)|0);
      $utf8=$52;
      var $53=$2;
      var $54=HEAP32[(($53)>>2)];
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$1;
      var $58=$57;
      var $59=(($58+76)|0);
      var $60=(($59+$56)|0);
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=(($62-3)|0);
      var $64=$2;
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+$63)|0);
      HEAP32[(($64)>>2)]=$66;
      __label__ = 10; break;
    case 7: // $67
      var $68=$n;
      var $69=$5;
      var $70=$4;
      var $71=HEAP32[(($70)>>2)];
      var $72=$69;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($68)|0) > (($74)|0);
      if ($75) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $76
      __label__ = 14; break;
    case 9: // $77
      var $78=$2;
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79+1)|0);
      HEAP32[(($78)>>2)]=$80;
      __label__ = 10; break;
    case 10: // $81
      __label__ = 11; break;
    case 11: // $82
      var $83=$utf8;
      var $84=(($83+1)|0);
      $utf8=$84;
      var $85=HEAP8[($83)];
      var $86=$4;
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87+1)|0);
      HEAP32[(($86)>>2)]=$88;
      HEAP8[($87)]=$85;
      __label__ = 12; break;
    case 12: // $89
      var $90=$n;
      var $91=(($90-1)|0);
      $n=$91;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 13: // $93
      __label__ = 1; break;
    case 14: // $94
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14unknown_toUtf8PK8encodingPPKcS3_PPcS3_["X"]=1;

function __ZL15unknown_toUtf16PK8encodingPPKcS3_PPtPKt($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $uenc;
      var $c;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$1;
      var $7=$6;
      $uenc=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$2;
      var $10=HEAP32[(($9)>>2)];
      var $11=$3;
      var $12=(($10)|0)!=(($11)|0);
      if ($12) { __label__ = 2; break; } else { var $19 = 0;__label__ = 3; break; }
    case 2: // $13
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$5;
      var $17=(($15)|0)!=(($16)|0);
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      if ($19) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $20
      var $21=$2;
      var $22=HEAP32[(($21)>>2)];
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$uenc;
      var $26=(($25+376)|0);
      var $27=(($26+($24<<1))|0);
      var $28=HEAP16[(($27)>>1)];
      $c=$28;
      var $29=$c;
      var $30=(($29)&65535);
      var $31=(($30)|0)==0;
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      var $33=$uenc;
      var $34=(($33+368)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$uenc;
      var $37=(($36+372)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=HEAP32[(($39)>>2)];
      var $41=FUNCTION_TABLE[$35]($38, $40);
      var $42=(($41) & 65535);
      $c=$42;
      var $43=$2;
      var $44=HEAP32[(($43)>>2)];
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $47=$1;
      var $48=$47;
      var $49=(($48+76)|0);
      var $50=(($49+$46)|0);
      var $51=HEAPU8[($50)];
      var $52=(($51)&255);
      var $53=(($52-3)|0);
      var $54=$2;
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+$53)|0);
      HEAP32[(($54)>>2)]=$56;
      __label__ = 7; break;
    case 6: // $57
      var $58=$2;
      var $59=HEAP32[(($58)>>2)];
      var $60=(($59+1)|0);
      HEAP32[(($58)>>2)]=$60;
      __label__ = 7; break;
    case 7: // $61
      var $62=$c;
      var $63=$4;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+2)|0);
      HEAP32[(($63)>>2)]=$65;
      HEAP16[(($64)>>1)]=$62;
      __label__ = 1; break;
    case 8: // $66
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15unknown_toUtf16PK8encodingPPKcS3_PPtPKt["X"]=1;

function _XmlInitEncoding($p, $encPtr, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $i;
      $2=$p;
      $3=$encPtr;
      $4=$name;
      var $5=$4;
      var $6=__ZL16getEncodingIndexPKc($5);
      $i=$6;
      var $7=$i;
      var $8=(($7)|0)==-1;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=$i;
      var $12=(($11) & 255);
      var $13=$2;
      var $14=(($13)|0);
      var $15=(($14+73)|0);
      HEAP8[($15)]=$12;
      var $16=$2;
      var $17=(($16)|0);
      var $18=(($17)|0);
      var $19=$18;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1638;
      var $21=$2;
      var $22=(($21)|0);
      var $23=(($22)|0);
      var $24=$23;
      var $25=(($24+4)|0);
      HEAP32[(($25)>>2)]=1640;
      var $26=$2;
      var $27=(($26)|0);
      var $28=(($27+52)|0);
      HEAP32[(($28)>>2)]=1642;
      var $29=$3;
      var $30=$2;
      var $31=(($30+76)|0);
      HEAP32[(($31)>>2)]=$29;
      var $32=$2;
      var $33=(($32)|0);
      var $34=$3;
      HEAP32[(($34)>>2)]=$33;
      $1=1;
      __label__ = 3; break;
    case 3: // $35
      var $36=$1;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
_XmlInitEncoding["X"]=1;

function __ZL16getEncodingIndexPKc($name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $i;
      $2=$name;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      $1=6;
      __label__ = 9; break;
    case 2: // $6
      $i=0;
      __label__ = 3; break;
    case 3: // $7
      var $8=$i;
      var $9=(($8)|0) < 6;
      if ($9) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $10
      var $11=$2;
      var $12=$i;
      var $13=((__ZZL16getEncodingIndexPKcE13encodingNames+($12<<2))|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=__ZL7streqciPKcS0_($11, $14);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      var $18=$i;
      $1=$18;
      __label__ = 9; break;
    case 6: // $19
      __label__ = 7; break;
    case 7: // $20
      var $21=$i;
      var $22=(($21+1)|0);
      $i=$22;
      __label__ = 3; break;
    case 8: // $23
      $1=-1;
      __label__ = 9; break;
    case 9: // $24
      var $25=$1;
      ;
      return $25;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL14initScanPrologPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$enc;
  $2=$ptr;
  $3=$end;
  $4=$nextTokPtr;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=__ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_(((__ZL9encodings)|0), $6, 0, $7, $8, $9);
  ;
  return $10;
}


function __ZL15initScanContentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$enc;
  $2=$ptr;
  $3=$end;
  $4=$nextTokPtr;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=__ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_(((__ZL9encodings)|0), $6, 1, $7, $8, $9);
  ;
  return $10;
}


function __ZL18initUpdatePositionPK8encodingPKcS3_P8position($enc, $ptr, $end, $pos) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$enc;
  $2=$ptr;
  $3=$end;
  $4=$pos;
  var $5=$2;
  var $6=$3;
  var $7=$4;
  __ZL21normal_updatePositionPK8encodingPKcS3_P8position((((STRING_TABLE.__ZL13utf8_encoding))|0), $5, $6, $7);
  ;
  return;
}


function _XmlParseXmlDecl($isGeneralTextEntity, $enc, $ptr, $end, $badPtr, $versionPtr, $versionEndPtr, $encodingName, $encoding, $standalone) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $10;
  $1=$isGeneralTextEntity;
  $2=$enc;
  $3=$ptr;
  $4=$end;
  $5=$badPtr;
  $6=$versionPtr;
  $7=$versionEndPtr;
  $8=$encodingName;
  $9=$encoding;
  $10=$standalone;
  var $11=$1;
  var $12=$2;
  var $13=$3;
  var $14=$4;
  var $15=$5;
  var $16=$6;
  var $17=$7;
  var $18=$8;
  var $19=$9;
  var $20=$10;
  var $21=__ZL14doParseXmlDeclPFPK8encodingS1_PKcS3_EiS1_S3_S3_PS3_S6_S6_S6_PS1_Pi(1644, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20);
  ;
  return $21;
}


function _XmlGetUtf8InternalEncodingNS() {
  ;
  var __label__;

  ;
  return (((STRING_TABLE.__ZL25internal_utf8_encoding_ns))|0);
}


function __ZL7streqciPKcS0_($s1, $s2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $c1;
      var $c2;
      $2=$s1;
      $3=$s2;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5+1)|0);
      $2=$6;
      var $7=HEAP8[($5)];
      $c1=$7;
      var $8=$3;
      var $9=(($8+1)|0);
      $3=$9;
      var $10=HEAP8[($8)];
      $c2=$10;
      var $11=$c1;
      var $12=(($11 << 24) >> 24);
      var $13=97 <= (($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      var $15=$c1;
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0) <= 122;
      if ($17) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $18
      var $19=$c1;
      var $20=(($19 << 24) >> 24);
      var $21=(($20-32)|0);
      var $22=(($21) & 255);
      $c1=$22;
      __label__ = 4; break;
    case 4: // $23
      var $24=$c2;
      var $25=(($24 << 24) >> 24);
      var $26=97 <= (($25)|0);
      if ($26) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $27
      var $28=$c2;
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0) <= 122;
      if ($30) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $31
      var $32=$c2;
      var $33=(($32 << 24) >> 24);
      var $34=(($33-32)|0);
      var $35=(($34) & 255);
      $c2=$35;
      __label__ = 7; break;
    case 7: // $36
      var $37=$c1;
      var $38=(($37 << 24) >> 24);
      var $39=$c2;
      var $40=(($39 << 24) >> 24);
      var $41=(($38)|0)!=(($40)|0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      $1=0;
      __label__ = 13; break;
    case 9: // $43
      var $44=$c1;
      var $45=(($44 << 24) >> 24)!=0;
      if ($45) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $46
      __label__ = 12; break;
    case 11: // $47
      __label__ = 1; break;
    case 12: // $48
      $1=1;
      __label__ = 13; break;
    case 13: // $49
      var $50=$1;
      ;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL7streqciPKcS0_["X"]=1;

function __ZL14doParseXmlDeclPFPK8encodingS1_PKcS3_EiS1_S3_S3_PS3_S6_S6_S6_PS1_Pi($encodingFinder, $isGeneralTextEntity, $enc, $ptr, $end, $badPtr, $versionPtr, $versionEndPtr, $encodingName, $encoding, $standalone) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $12;
      var $val=__stackBase__+4;
      var $name=__stackBase__+8;
      var $nameEnd=__stackBase__+12;
      var $c;
      $2=$encodingFinder;
      $3=$isGeneralTextEntity;
      $4=$enc;
      HEAP32[(($5)>>2)]=$ptr;
      $6=$end;
      $7=$badPtr;
      $8=$versionPtr;
      $9=$versionEndPtr;
      $10=$encodingName;
      $11=$encoding;
      $12=$standalone;
      HEAP32[(($val)>>2)]=0;
      HEAP32[(($name)>>2)]=0;
      HEAP32[(($nameEnd)>>2)]=0;
      var $13=$4;
      var $14=(($13+68)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15*5)|0);
      var $17=HEAP32[(($5)>>2)];
      var $18=(($17+$16)|0);
      HEAP32[(($5)>>2)]=$18;
      var $19=$4;
      var $20=(($19+68)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=((($21<<1))|0);
      var $23=$6;
      var $24=(((-$22))|0);
      var $25=(($23+$24)|0);
      $6=$25;
      var $26=$4;
      var $27=HEAP32[(($5)>>2)];
      var $28=$6;
      var $29=__ZL20parsePseudoAttributePK8encodingPKcS3_PS3_S4_S4_S4_($26, $27, $28, $name, $nameEnd, $val, $5);
      var $30=(($29)|0)!=0;
      if ($30) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $31
      var $32=HEAP32[(($name)>>2)];
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $34
      var $35=HEAP32[(($5)>>2)];
      var $36=$7;
      HEAP32[(($36)>>2)]=$35;
      $1=0;
      __label__ = 52; break;
    case 3: // $37
      var $38=$4;
      var $39=(($38+28)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$4;
      var $42=HEAP32[(($name)>>2)];
      var $43=HEAP32[(($nameEnd)>>2)];
      var $44=FUNCTION_TABLE[$40]($41, $42, $43, ((STRING_TABLE.__ZL10KW_version)|0));
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 7; break; } else { __label__ = 4; break; }
    case 4: // $46
      var $47=$3;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $49
      var $50=HEAP32[(($name)>>2)];
      var $51=$7;
      HEAP32[(($51)>>2)]=$50;
      $1=0;
      __label__ = 52; break;
    case 6: // $52
      __label__ = 18; break;
    case 7: // $53
      var $54=$8;
      var $55=(($54)|0)!=0;
      if ($55) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $56
      var $57=HEAP32[(($val)>>2)];
      var $58=$8;
      HEAP32[(($58)>>2)]=$57;
      __label__ = 9; break;
    case 9: // $59
      var $60=$9;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $62
      var $63=HEAP32[(($5)>>2)];
      var $64=$9;
      HEAP32[(($64)>>2)]=$63;
      __label__ = 11; break;
    case 11: // $65
      var $66=$4;
      var $67=HEAP32[(($5)>>2)];
      var $68=$6;
      var $69=__ZL20parsePseudoAttributePK8encodingPKcS3_PS3_S4_S4_S4_($66, $67, $68, $name, $nameEnd, $val, $5);
      var $70=(($69)|0)!=0;
      if ($70) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $71
      var $72=HEAP32[(($5)>>2)];
      var $73=$7;
      HEAP32[(($73)>>2)]=$72;
      $1=0;
      __label__ = 52; break;
    case 13: // $74
      var $75=HEAP32[(($name)>>2)];
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 17; break; } else { __label__ = 14; break; }
    case 14: // $77
      var $78=$3;
      var $79=(($78)|0)!=0;
      if ($79) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $80
      var $81=HEAP32[(($5)>>2)];
      var $82=$7;
      HEAP32[(($82)>>2)]=$81;
      $1=0;
      __label__ = 52; break;
    case 16: // $83
      $1=1;
      __label__ = 52; break;
    case 17: // $84
      __label__ = 18; break;
    case 18: // $85
      var $86=$4;
      var $87=(($86+28)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$4;
      var $90=HEAP32[(($name)>>2)];
      var $91=HEAP32[(($nameEnd)>>2)];
      var $92=FUNCTION_TABLE[$88]($89, $90, $91, ((STRING_TABLE.__ZL11KW_encoding)|0));
      var $93=(($92)|0)!=0;
      if ($93) { __label__ = 19; break; } else { __label__ = 33; break; }
    case 19: // $94
      var $95=$4;
      var $96=HEAP32[(($val)>>2)];
      var $97=$6;
      var $98=__ZL7toAsciiPK8encodingPKcS3_($95, $96, $97);
      $c=$98;
      var $99=$c;
      var $100=97 <= (($99)|0);
      if ($100) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $101
      var $102=$c;
      var $103=(($102)|0) <= 122;
      if ($103) { __label__ = 24; break; } else { __label__ = 21; break; }
    case 21: // $104
      var $105=$c;
      var $106=65 <= (($105)|0);
      if ($106) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $107
      var $108=$c;
      var $109=(($108)|0) <= 90;
      if ($109) { __label__ = 24; break; } else { __label__ = 23; break; }
    case 23: // $110
      var $111=HEAP32[(($val)>>2)];
      var $112=$7;
      HEAP32[(($112)>>2)]=$111;
      $1=0;
      __label__ = 52; break;
    case 24: // $113
      var $114=$10;
      var $115=(($114)|0)!=0;
      if ($115) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $116
      var $117=HEAP32[(($val)>>2)];
      var $118=$10;
      HEAP32[(($118)>>2)]=$117;
      __label__ = 26; break;
    case 26: // $119
      var $120=$11;
      var $121=(($120)|0)!=0;
      if ($121) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $122
      var $123=$2;
      var $124=$4;
      var $125=HEAP32[(($val)>>2)];
      var $126=HEAP32[(($5)>>2)];
      var $127=$4;
      var $128=(($127+68)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(((-$129))|0);
      var $131=(($126+$130)|0);
      var $132=FUNCTION_TABLE[$123]($124, $125, $131);
      var $133=$11;
      HEAP32[(($133)>>2)]=$132;
      __label__ = 28; break;
    case 28: // $134
      var $135=$4;
      var $136=HEAP32[(($5)>>2)];
      var $137=$6;
      var $138=__ZL20parsePseudoAttributePK8encodingPKcS3_PS3_S4_S4_S4_($135, $136, $137, $name, $nameEnd, $val, $5);
      var $139=(($138)|0)!=0;
      if ($139) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $140
      var $141=HEAP32[(($5)>>2)];
      var $142=$7;
      HEAP32[(($142)>>2)]=$141;
      $1=0;
      __label__ = 52; break;
    case 30: // $143
      var $144=HEAP32[(($name)>>2)];
      var $145=(($144)|0)!=0;
      if ($145) { __label__ = 32; break; } else { __label__ = 31; break; }
    case 31: // $146
      $1=1;
      __label__ = 52; break;
    case 32: // $147
      __label__ = 33; break;
    case 33: // $148
      var $149=$4;
      var $150=(($149+28)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$4;
      var $153=HEAP32[(($name)>>2)];
      var $154=HEAP32[(($nameEnd)>>2)];
      var $155=FUNCTION_TABLE[$151]($152, $153, $154, ((STRING_TABLE.__ZL13KW_standalone)|0));
      var $156=(($155)|0)!=0;
      if ($156) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $157
      var $158=$3;
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $160
      var $161=HEAP32[(($name)>>2)];
      var $162=$7;
      HEAP32[(($162)>>2)]=$161;
      $1=0;
      __label__ = 52; break;
    case 36: // $163
      var $164=$4;
      var $165=(($164+28)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$4;
      var $168=HEAP32[(($val)>>2)];
      var $169=HEAP32[(($5)>>2)];
      var $170=$4;
      var $171=(($170+68)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(((-$172))|0);
      var $174=(($169+$173)|0);
      var $175=FUNCTION_TABLE[$166]($167, $168, $174, ((STRING_TABLE.__ZL6KW_yes)|0));
      var $176=(($175)|0)!=0;
      if ($176) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $177
      var $178=$12;
      var $179=(($178)|0)!=0;
      if ($179) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $180
      var $181=$12;
      HEAP32[(($181)>>2)]=1;
      __label__ = 39; break;
    case 39: // $182
      __label__ = 46; break;
    case 40: // $183
      var $184=$4;
      var $185=(($184+28)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$4;
      var $188=HEAP32[(($val)>>2)];
      var $189=HEAP32[(($5)>>2)];
      var $190=$4;
      var $191=(($190+68)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(((-$192))|0);
      var $194=(($189+$193)|0);
      var $195=FUNCTION_TABLE[$186]($187, $188, $194, ((STRING_TABLE.__ZL5KW_no)|0));
      var $196=(($195)|0)!=0;
      if ($196) { __label__ = 41; break; } else { __label__ = 44; break; }
    case 41: // $197
      var $198=$12;
      var $199=(($198)|0)!=0;
      if ($199) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $200
      var $201=$12;
      HEAP32[(($201)>>2)]=0;
      __label__ = 43; break;
    case 43: // $202
      __label__ = 45; break;
    case 44: // $203
      var $204=HEAP32[(($val)>>2)];
      var $205=$7;
      HEAP32[(($205)>>2)]=$204;
      $1=0;
      __label__ = 52; break;
    case 45: // $206
      __label__ = 46; break;
    case 46: // $207
      __label__ = 47; break;
    case 47: // $208
      var $209=$4;
      var $210=HEAP32[(($5)>>2)];
      var $211=$6;
      var $212=__ZL7toAsciiPK8encodingPKcS3_($209, $210, $211);
      var $213=__ZL7isSpacei($212);
      var $214=(($213)|0)!=0;
      if ($214) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $215
      var $216=$4;
      var $217=(($216+68)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=HEAP32[(($5)>>2)];
      var $220=(($219+$218)|0);
      HEAP32[(($5)>>2)]=$220;
      __label__ = 47; break;
    case 49: // $221
      var $222=HEAP32[(($5)>>2)];
      var $223=$6;
      var $224=(($222)|0)!=(($223)|0);
      if ($224) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $225
      var $226=HEAP32[(($5)>>2)];
      var $227=$7;
      HEAP32[(($227)>>2)]=$226;
      $1=0;
      __label__ = 52; break;
    case 51: // $228
      $1=1;
      __label__ = 52; break;
    case 52: // $229
      var $230=$1;
      STACKTOP = __stackBase__;
      return $230;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14doParseXmlDeclPFPK8encodingS1_PKcS3_EiS1_S3_S3_PS3_S6_S6_S6_PS1_Pi["X"]=1;

function __ZL12findEncodingPK8encodingPKcS3_($enc, $ptr, $end) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $buf=__stackBase__+4;
      var $p=__stackBase__+132;
      var $i;
      $2=$enc;
      HEAP32[(($3)>>2)]=$ptr;
      $4=$end;
      var $5=(($buf)|0);
      HEAP32[(($p)>>2)]=$5;
      var $6=$2;
      var $7=(($6+60)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$2;
      var $10=$4;
      var $11=HEAP32[(($p)>>2)];
      var $12=(($11+128)|0);
      var $13=(($12-1)|0);
      FUNCTION_TABLE[$8]($9, $3, $10, $p, $13);
      var $14=HEAP32[(($3)>>2)];
      var $15=$4;
      var $16=(($14)|0)!=(($15)|0);
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 8; break;
    case 2: // $18
      var $19=HEAP32[(($p)>>2)];
      HEAP8[($19)]=0;
      var $20=(($buf)|0);
      var $21=__ZL7streqciPKcS0_($20, ((STRING_TABLE.__ZL9KW_UTF_16)|0));
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $23
      var $24=$2;
      var $25=(($24+68)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==2;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$2;
      $1=$29;
      __label__ = 8; break;
    case 5: // $30
      var $31=(($buf)|0);
      var $32=__ZL16getEncodingIndexPKc($31);
      $i=$32;
      var $33=$i;
      var $34=(($33)|0)==-1;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      $1=0;
      __label__ = 8; break;
    case 7: // $36
      var $37=$i;
      var $38=((__ZL9encodings+($37<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      $1=$39;
      __label__ = 8; break;
    case 8: // $40
      var $41=$1;
      STACKTOP = __stackBase__;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12findEncodingPK8encodingPKcS3_["X"]=1;

function _XmlInitEncodingNS($p, $encPtr, $name) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $i;
      $2=$p;
      $3=$encPtr;
      $4=$name;
      var $5=$4;
      var $6=__ZL16getEncodingIndexPKc($5);
      $i=$6;
      var $7=$i;
      var $8=(($7)|0)==-1;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=0;
      __label__ = 3; break;
    case 2: // $10
      var $11=$i;
      var $12=(($11) & 255);
      var $13=$2;
      var $14=(($13)|0);
      var $15=(($14+73)|0);
      HEAP8[($15)]=$12;
      var $16=$2;
      var $17=(($16)|0);
      var $18=(($17)|0);
      var $19=$18;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=1646;
      var $21=$2;
      var $22=(($21)|0);
      var $23=(($22)|0);
      var $24=$23;
      var $25=(($24+4)|0);
      HEAP32[(($25)>>2)]=1648;
      var $26=$2;
      var $27=(($26)|0);
      var $28=(($27+52)|0);
      HEAP32[(($28)>>2)]=1642;
      var $29=$3;
      var $30=$2;
      var $31=(($30+76)|0);
      HEAP32[(($31)>>2)]=$29;
      var $32=$2;
      var $33=(($32)|0);
      var $34=$3;
      HEAP32[(($34)>>2)]=$33;
      $1=1;
      __label__ = 3; break;
    case 3: // $35
      var $36=$1;
      ;
      return $36;
    default: assert(0, "bad label: " + __label__);
  }
}
_XmlInitEncodingNS["X"]=1;

function __ZL16initScanPrologNSPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$enc;
  $2=$ptr;
  $3=$end;
  $4=$nextTokPtr;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=__ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_(((__ZL11encodingsNS)|0), $6, 0, $7, $8, $9);
  ;
  return $10;
}


function __ZL17initScanContentNSPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$enc;
  $2=$ptr;
  $3=$end;
  $4=$nextTokPtr;
  var $5=$1;
  var $6=$5;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=__ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_(((__ZL11encodingsNS)|0), $6, 1, $7, $8, $9);
  ;
  return $10;
}


function _XmlParseXmlDeclNS($isGeneralTextEntity, $enc, $ptr, $end, $badPtr, $versionPtr, $versionEndPtr, $encodingName, $encoding, $standalone) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $10;
  $1=$isGeneralTextEntity;
  $2=$enc;
  $3=$ptr;
  $4=$end;
  $5=$badPtr;
  $6=$versionPtr;
  $7=$versionEndPtr;
  $8=$encodingName;
  $9=$encoding;
  $10=$standalone;
  var $11=$1;
  var $12=$2;
  var $13=$3;
  var $14=$4;
  var $15=$5;
  var $16=$6;
  var $17=$7;
  var $18=$8;
  var $19=$9;
  var $20=$10;
  var $21=__ZL14doParseXmlDeclPFPK8encodingS1_PKcS3_EiS1_S3_S3_PS3_S6_S6_S6_PS1_Pi(1650, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20);
  ;
  return $21;
}


function __ZL14findEncodingNSPK8encodingPKcS3_($enc, $ptr, $end) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $buf=__stackBase__+4;
      var $p=__stackBase__+132;
      var $i;
      $2=$enc;
      HEAP32[(($3)>>2)]=$ptr;
      $4=$end;
      var $5=(($buf)|0);
      HEAP32[(($p)>>2)]=$5;
      var $6=$2;
      var $7=(($6+60)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$2;
      var $10=$4;
      var $11=HEAP32[(($p)>>2)];
      var $12=(($11+128)|0);
      var $13=(($12-1)|0);
      FUNCTION_TABLE[$8]($9, $3, $10, $p, $13);
      var $14=HEAP32[(($3)>>2)];
      var $15=$4;
      var $16=(($14)|0)!=(($15)|0);
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      $1=0;
      __label__ = 8; break;
    case 2: // $18
      var $19=HEAP32[(($p)>>2)];
      HEAP8[($19)]=0;
      var $20=(($buf)|0);
      var $21=__ZL7streqciPKcS0_($20, ((STRING_TABLE.__ZL9KW_UTF_16)|0));
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $23
      var $24=$2;
      var $25=(($24+68)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==2;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$2;
      $1=$29;
      __label__ = 8; break;
    case 5: // $30
      var $31=(($buf)|0);
      var $32=__ZL16getEncodingIndexPKc($31);
      $i=$32;
      var $33=$i;
      var $34=(($33)|0)==-1;
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      $1=0;
      __label__ = 8; break;
    case 7: // $36
      var $37=$i;
      var $38=((__ZL11encodingsNS+($37<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      $1=$39;
      __label__ = 8; break;
    case 8: // $40
      var $41=$1;
      STACKTOP = __stackBase__;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14findEncodingNSPK8encodingPKcS3_["X"]=1;

function _XmlInitUnknownEncodingNS($mem, $table, $convert, $userData) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $enc;
      $1=$mem;
      $2=$table;
      $3=$convert;
      $4=$userData;
      var $5=$1;
      var $6=$2;
      var $7=$3;
      var $8=$4;
      var $9=_XmlInitUnknownEncoding($5, $6, $7, $8);
      $enc=$9;
      var $10=$enc;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$enc;
      var $14=$13;
      var $15=(($14+76)|0);
      var $16=(($15+58)|0);
      HEAP8[($16)]=23;
      __label__ = 2; break;
    case 2: // $17
      var $18=$enc;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL17little2_prologTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tok;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 141; break;
    case 2: // $10
      var $11=$4;
      var $12=$3;
      var $13=$11;
      var $14=$12;
      var $15=(($13-$14)|0);
      $n=$15;
      var $16=$n;
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$n;
      var $21=$20 & -2;
      $n=$21;
      var $22=$n;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 141; break;
    case 5: // $25
      var $26=$3;
      var $27=$n;
      var $28=(($26+$27)|0);
      $4=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30+1)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$3;
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$2;
      var $40=$39;
      var $41=(($40+76)|0);
      var $42=(($41+$38)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $54 = $44;__label__ = 9; break;
    case 8: // $45
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAP8[($47)];
      var $49=$3;
      var $50=(($49)|0);
      var $51=HEAP8[($50)];
      var $52=__ZL17unicode_byte_typecc($48, $51);
      var $54 = $52;__label__ = 9; break;
    case 9: // $53
      var $54;
      if ($54 == 12) {
        __label__ = 10; break;
      }
      else if ($54 == 13) {
        __label__ = 11; break;
      }
      else if ($54 == 2) {
        __label__ = 12; break;
      }
      else if ($54 == 9) {
        __label__ = 22; break;
      }
      else if ($54 == 21 || $54 == 10) {
        __label__ = 25; break;
      }
      else if ($54 == 30) {
        __label__ = 39; break;
      }
      else if ($54 == 35) {
        __label__ = 40; break;
      }
      else if ($54 == 20) {
        __label__ = 41; break;
      }
      else if ($54 == 4) {
        __label__ = 42; break;
      }
      else if ($54 == 31) {
        __label__ = 53; break;
      }
      else if ($54 == 32) {
        __label__ = 54; break;
      }
      else if ($54 == 36) {
        __label__ = 65; break;
      }
      else if ($54 == 11) {
        __label__ = 66; break;
      }
      else if ($54 == 19) {
        __label__ = 67; break;
      }
      else if ($54 == 5) {
        __label__ = 68; break;
      }
      else if ($54 == 6) {
        __label__ = 71; break;
      }
      else if ($54 == 7) {
        __label__ = 74; break;
      }
      else if ($54 == 22 || $54 == 24) {
        __label__ = 77; break;
      }
      else if ($54 == 25 || $54 == 26 || $54 == 27 || $54 == 23) {
        __label__ = 78; break;
      }
      else if ($54 == 29) {
        __label__ = 79; break;
      }
      else {
      __label__ = 84; break;
      }
      
    case 10: // $55
      var $56=$2;
      var $57=$3;
      var $58=(($57+2)|0);
      var $59=$4;
      var $60=$5;
      var $61=__ZL15little2_scanLitiPK8encodingPKcS3_PS3_(12, $56, $58, $59, $60);
      $1=$61;
      __label__ = 141; break;
    case 11: // $62
      var $63=$2;
      var $64=$3;
      var $65=(($64+2)|0);
      var $66=$4;
      var $67=$5;
      var $68=__ZL15little2_scanLitiPK8encodingPKcS3_PS3_(13, $63, $65, $66, $67);
      $1=$68;
      __label__ = 141; break;
    case 12: // $69
      var $70=$3;
      var $71=(($70+2)|0);
      $3=$71;
      var $72=$3;
      var $73=$4;
      var $74=(($72)|0)==(($73)|0);
      if ($74) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $75
      $1=-1;
      __label__ = 141; break;
    case 14: // $76
      var $77=$3;
      var $78=(($77+1)|0);
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24);
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $82
      var $83=$3;
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$2;
      var $87=$86;
      var $88=(($87+76)|0);
      var $89=(($88+$85)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $101 = $91;__label__ = 17; break;
    case 16: // $92
      var $93=$3;
      var $94=(($93+1)|0);
      var $95=HEAP8[($94)];
      var $96=$3;
      var $97=(($96)|0);
      var $98=HEAP8[($97)];
      var $99=__ZL17unicode_byte_typecc($95, $98);
      var $101 = $99;__label__ = 17; break;
    case 17: // $100
      var $101;
      if ($101 == 16) {
        __label__ = 18; break;
      }
      else if ($101 == 15) {
        __label__ = 19; break;
      }
      else if ($101 == 22 || $101 == 24 || $101 == 29 || $101 == 5 || $101 == 6 || $101 == 7) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 18: // $102
      var $103=$2;
      var $104=$3;
      var $105=(($104+2)|0);
      var $106=$4;
      var $107=$5;
      var $108=__ZL16little2_scanDeclPK8encodingPKcS3_PS3_($103, $105, $106, $107);
      $1=$108;
      __label__ = 141; break;
    case 19: // $109
      var $110=$2;
      var $111=$3;
      var $112=(($111+2)|0);
      var $113=$4;
      var $114=$5;
      var $115=__ZL14little2_scanPiPK8encodingPKcS3_PS3_($110, $112, $113, $114);
      $1=$115;
      __label__ = 141; break;
    case 20: // $116
      var $117=$3;
      var $118=(($117-2)|0);
      var $119=$5;
      HEAP32[(($119)>>2)]=$118;
      $1=29;
      __label__ = 141; break;
    case 21: // $120
      var $121=$3;
      var $122=$5;
      HEAP32[(($122)>>2)]=$121;
      $1=0;
      __label__ = 141; break;
    case 22: // $123
      var $124=$3;
      var $125=(($124+2)|0);
      var $126=$4;
      var $127=(($125)|0)==(($126)|0);
      if ($127) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $128
      var $129=$4;
      var $130=$5;
      HEAP32[(($130)>>2)]=$129;
      $1=-15;
      __label__ = 141; break;
    case 24: // $131
      __label__ = 25; break;
    case 25: // $132
      __label__ = 26; break;
    case 26: // $133
      var $134=$3;
      var $135=(($134+2)|0);
      $3=$135;
      var $136=$3;
      var $137=$4;
      var $138=(($136)|0)==(($137)|0);
      if ($138) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $139
      __label__ = 38; break;
    case 28: // $140
      var $141=$3;
      var $142=(($141+1)|0);
      var $143=HEAP8[($142)];
      var $144=(($143 << 24) >> 24);
      var $145=(($144)|0)==0;
      if ($145) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $146
      var $147=$3;
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$2;
      var $151=$150;
      var $152=(($151+76)|0);
      var $153=(($152+$149)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $165 = $155;__label__ = 31; break;
    case 30: // $156
      var $157=$3;
      var $158=(($157+1)|0);
      var $159=HEAP8[($158)];
      var $160=$3;
      var $161=(($160)|0);
      var $162=HEAP8[($161)];
      var $163=__ZL17unicode_byte_typecc($159, $162);
      var $165 = $163;__label__ = 31; break;
    case 31: // $164
      var $165;
      if ($165 == 21 || $165 == 10) {
        __label__ = 32; break;
      }
      else if ($165 == 9) {
        __label__ = 33; break;
      }
      else {
      __label__ = 36; break;
      }
      
    case 32: // $166
      __label__ = 37; break;
    case 33: // $167
      var $168=$3;
      var $169=(($168+2)|0);
      var $170=$4;
      var $171=(($169)|0)!=(($170)|0);
      if ($171) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $172
      __label__ = 37; break;
    case 35: // $173
      __label__ = 36; break;
    case 36: // $174
      var $175=$3;
      var $176=$5;
      HEAP32[(($176)>>2)]=$175;
      $1=15;
      __label__ = 141; break;
    case 37: // $177
      __label__ = 26; break;
    case 38: // $178
      var $179=$3;
      var $180=$5;
      HEAP32[(($180)>>2)]=$179;
      $1=15;
      __label__ = 141; break;
    case 39: // $181
      var $182=$2;
      var $183=$3;
      var $184=(($183+2)|0);
      var $185=$4;
      var $186=$5;
      var $187=__ZL19little2_scanPercentPK8encodingPKcS3_PS3_($182, $184, $185, $186);
      $1=$187;
      __label__ = 141; break;
    case 40: // $188
      var $189=$3;
      var $190=(($189+2)|0);
      var $191=$5;
      HEAP32[(($191)>>2)]=$190;
      $1=38;
      __label__ = 141; break;
    case 41: // $192
      var $193=$3;
      var $194=(($193+2)|0);
      var $195=$5;
      HEAP32[(($195)>>2)]=$194;
      $1=25;
      __label__ = 141; break;
    case 42: // $196
      var $197=$3;
      var $198=(($197+2)|0);
      $3=$198;
      var $199=$3;
      var $200=$4;
      var $201=(($199)|0)==(($200)|0);
      if ($201) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $202
      $1=-26;
      __label__ = 141; break;
    case 44: // $203
      var $204=$3;
      var $205=(($204+1)|0);
      var $206=HEAP8[($205)];
      var $207=(($206 << 24) >> 24);
      var $208=(($207)|0)==0;
      if ($208) { __label__ = 45; break; } else { __label__ = 52; break; }
    case 45: // $209
      var $210=$3;
      var $211=(($210)|0);
      var $212=HEAP8[($211)];
      var $213=(($212 << 24) >> 24);
      var $214=(($213)|0)==93;
      if ($214) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $215
      var $216=$3;
      var $217=(($216+2)|0);
      var $218=$4;
      var $219=(($217)|0)==(($218)|0);
      if ($219) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $220
      $1=-1;
      __label__ = 141; break;
    case 48: // $221
      var $222=$3;
      var $223=(($222+2)|0);
      var $224=(($223+1)|0);
      var $225=HEAP8[($224)];
      var $226=(($225 << 24) >> 24);
      var $227=(($226)|0)==0;
      if ($227) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $228
      var $229=$3;
      var $230=(($229+2)|0);
      var $231=(($230)|0);
      var $232=HEAP8[($231)];
      var $233=(($232 << 24) >> 24);
      var $234=(($233)|0)==62;
      if ($234) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $235
      var $236=$3;
      var $237=(($236+4)|0);
      var $238=$5;
      HEAP32[(($238)>>2)]=$237;
      $1=34;
      __label__ = 141; break;
    case 51: // $239
      __label__ = 52; break;
    case 52: // $240
      var $241=$3;
      var $242=$5;
      HEAP32[(($242)>>2)]=$241;
      $1=26;
      __label__ = 141; break;
    case 53: // $243
      var $244=$3;
      var $245=(($244+2)|0);
      var $246=$5;
      HEAP32[(($246)>>2)]=$245;
      $1=23;
      __label__ = 141; break;
    case 54: // $247
      var $248=$3;
      var $249=(($248+2)|0);
      $3=$249;
      var $250=$3;
      var $251=$4;
      var $252=(($250)|0)==(($251)|0);
      if ($252) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $253
      $1=-24;
      __label__ = 141; break;
    case 56: // $254
      var $255=$3;
      var $256=(($255+1)|0);
      var $257=HEAP8[($256)];
      var $258=(($257 << 24) >> 24);
      var $259=(($258)|0)==0;
      if ($259) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $260
      var $261=$3;
      var $262=HEAPU8[($261)];
      var $263=(($262)&255);
      var $264=$2;
      var $265=$264;
      var $266=(($265+76)|0);
      var $267=(($266+$263)|0);
      var $268=HEAPU8[($267)];
      var $269=(($268)&255);
      var $279 = $269;__label__ = 59; break;
    case 58: // $270
      var $271=$3;
      var $272=(($271+1)|0);
      var $273=HEAP8[($272)];
      var $274=$3;
      var $275=(($274)|0);
      var $276=HEAP8[($275)];
      var $277=__ZL17unicode_byte_typecc($273, $276);
      var $279 = $277;__label__ = 59; break;
    case 59: // $278
      var $279;
      if ($279 == 33) {
        __label__ = 60; break;
      }
      else if ($279 == 15) {
        __label__ = 61; break;
      }
      else if ($279 == 34) {
        __label__ = 62; break;
      }
      else if ($279 == 9 || $279 == 10 || $279 == 21 || $279 == 11 || $279 == 35 || $279 == 36 || $279 == 32) {
        __label__ = 63; break;
      }
      else {
      __label__ = 64; break;
      }
      
    case 60: // $280
      var $281=$3;
      var $282=(($281+2)|0);
      var $283=$5;
      HEAP32[(($283)>>2)]=$282;
      $1=36;
      __label__ = 141; break;
    case 61: // $284
      var $285=$3;
      var $286=(($285+2)|0);
      var $287=$5;
      HEAP32[(($287)>>2)]=$286;
      $1=35;
      __label__ = 141; break;
    case 62: // $288
      var $289=$3;
      var $290=(($289+2)|0);
      var $291=$5;
      HEAP32[(($291)>>2)]=$290;
      $1=37;
      __label__ = 141; break;
    case 63: // $292
      var $293=$3;
      var $294=$5;
      HEAP32[(($294)>>2)]=$293;
      $1=24;
      __label__ = 141; break;
    case 64: // $295
      var $296=$3;
      var $297=$5;
      HEAP32[(($297)>>2)]=$296;
      $1=0;
      __label__ = 141; break;
    case 65: // $298
      var $299=$3;
      var $300=(($299+2)|0);
      var $301=$5;
      HEAP32[(($301)>>2)]=$300;
      $1=21;
      __label__ = 141; break;
    case 66: // $302
      var $303=$3;
      var $304=(($303+2)|0);
      var $305=$5;
      HEAP32[(($305)>>2)]=$304;
      $1=17;
      __label__ = 141; break;
    case 67: // $306
      var $307=$2;
      var $308=$3;
      var $309=(($308+2)|0);
      var $310=$4;
      var $311=$5;
      var $312=__ZL21little2_scanPoundNamePK8encodingPKcS3_PS3_($307, $309, $310, $311);
      $1=$312;
      __label__ = 141; break;
    case 68: // $313
      var $314=$4;
      var $315=$3;
      var $316=$314;
      var $317=$315;
      var $318=(($316-$317)|0);
      var $319=(($318)|0) < 2;
      if ($319) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $320
      $1=-2;
      __label__ = 141; break;
    case 70: // $321
      var $322=$3;
      var $323=$5;
      HEAP32[(($323)>>2)]=$322;
      $1=0;
      __label__ = 141; break;
    case 71: // $324
      var $325=$4;
      var $326=$3;
      var $327=$325;
      var $328=$326;
      var $329=(($327-$328)|0);
      var $330=(($329)|0) < 3;
      if ($330) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $331
      $1=-2;
      __label__ = 141; break;
    case 73: // $332
      var $333=$3;
      var $334=$5;
      HEAP32[(($334)>>2)]=$333;
      $1=0;
      __label__ = 141; break;
    case 74: // $335
      var $336=$4;
      var $337=$3;
      var $338=$336;
      var $339=$337;
      var $340=(($338-$339)|0);
      var $341=(($340)|0) < 4;
      if ($341) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $342
      $1=-2;
      __label__ = 141; break;
    case 76: // $343
      var $344=$3;
      var $345=$5;
      HEAP32[(($345)>>2)]=$344;
      $1=0;
      __label__ = 141; break;
    case 77: // $346
      $tok=18;
      var $347=$3;
      var $348=(($347+2)|0);
      $3=$348;
      __label__ = 85; break;
    case 78: // $349
      $tok=19;
      var $350=$3;
      var $351=(($350+2)|0);
      $3=$351;
      __label__ = 85; break;
    case 79: // $352
      var $353=$3;
      var $354=(($353+1)|0);
      var $355=HEAPU8[($354)];
      var $356=(($355)&255);
      var $357=((STRING_TABLE.__ZL11nmstrtPages+$356)|0);
      var $358=HEAPU8[($357)];
      var $359=(($358)&255);
      var $360=$359 << 3;
      var $361=$3;
      var $362=(($361)|0);
      var $363=HEAPU8[($362)];
      var $364=(($363)&255);
      var $365=$364 >> 5;
      var $366=(($360+$365)|0);
      var $367=((__ZL12namingBitmap+($366<<2))|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=$3;
      var $370=(($369)|0);
      var $371=HEAPU8[($370)];
      var $372=(($371)&255);
      var $373=$372 & 31;
      var $374=1 << $373;
      var $375=$368 & $374;
      var $376=(($375)|0)!=0;
      if ($376) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $377
      var $378=$3;
      var $379=(($378+2)|0);
      $3=$379;
      $tok=18;
      __label__ = 85; break;
    case 81: // $380
      var $381=$3;
      var $382=(($381+1)|0);
      var $383=HEAPU8[($382)];
      var $384=(($383)&255);
      var $385=((STRING_TABLE.__ZL9namePages+$384)|0);
      var $386=HEAPU8[($385)];
      var $387=(($386)&255);
      var $388=$387 << 3;
      var $389=$3;
      var $390=(($389)|0);
      var $391=HEAPU8[($390)];
      var $392=(($391)&255);
      var $393=$392 >> 5;
      var $394=(($388+$393)|0);
      var $395=((__ZL12namingBitmap+($394<<2))|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=$3;
      var $398=(($397)|0);
      var $399=HEAPU8[($398)];
      var $400=(($399)&255);
      var $401=$400 & 31;
      var $402=1 << $401;
      var $403=$396 & $402;
      var $404=(($403)|0)!=0;
      if ($404) { __label__ = 82; break; } else { __label__ = 83; break; }
    case 82: // $405
      var $406=$3;
      var $407=(($406+2)|0);
      $3=$407;
      $tok=19;
      __label__ = 85; break;
    case 83: // $408
      __label__ = 84; break;
    case 84: // $409
      var $410=$3;
      var $411=$5;
      HEAP32[(($411)>>2)]=$410;
      $1=0;
      __label__ = 141; break;
    case 85: // $412
      __label__ = 86; break;
    case 86: // $413
      var $414=$3;
      var $415=$4;
      var $416=(($414)|0)!=(($415)|0);
      if ($416) { __label__ = 87; break; } else { __label__ = 140; break; }
    case 87: // $417
      var $418=$3;
      var $419=(($418+1)|0);
      var $420=HEAP8[($419)];
      var $421=(($420 << 24) >> 24);
      var $422=(($421)|0)==0;
      if ($422) { __label__ = 88; break; } else { __label__ = 89; break; }
    case 88: // $423
      var $424=$3;
      var $425=HEAPU8[($424)];
      var $426=(($425)&255);
      var $427=$2;
      var $428=$427;
      var $429=(($428+76)|0);
      var $430=(($429+$426)|0);
      var $431=HEAPU8[($430)];
      var $432=(($431)&255);
      var $442 = $432;__label__ = 90; break;
    case 89: // $433
      var $434=$3;
      var $435=(($434+1)|0);
      var $436=HEAP8[($435)];
      var $437=$3;
      var $438=(($437)|0);
      var $439=HEAP8[($438)];
      var $440=__ZL17unicode_byte_typecc($436, $439);
      var $442 = $440;__label__ = 90; break;
    case 90: // $441
      var $442;
      if ($442 == 29) {
        __label__ = 91; break;
      }
      else if ($442 == 22 || $442 == 24 || $442 == 25 || $442 == 26 || $442 == 27) {
        __label__ = 94; break;
      }
      else if ($442 == 5) {
        __label__ = 95; break;
      }
      else if ($442 == 6) {
        __label__ = 98; break;
      }
      else if ($442 == 7) {
        __label__ = 101; break;
      }
      else if ($442 == 11 || $442 == 32 || $442 == 35 || $442 == 36 || $442 == 20 || $442 == 30 || $442 == 21 || $442 == 9 || $442 == 10) {
        __label__ = 104; break;
      }
      else if ($442 == 23) {
        __label__ = 105; break;
      }
      else if ($442 == 34) {
        __label__ = 129; break;
      }
      else if ($442 == 33) {
        __label__ = 132; break;
      }
      else if ($442 == 15) {
        __label__ = 135; break;
      }
      else {
      __label__ = 138; break;
      }
      
    case 91: // $443
      var $444=$3;
      var $445=(($444+1)|0);
      var $446=HEAPU8[($445)];
      var $447=(($446)&255);
      var $448=((STRING_TABLE.__ZL9namePages+$447)|0);
      var $449=HEAPU8[($448)];
      var $450=(($449)&255);
      var $451=$450 << 3;
      var $452=$3;
      var $453=(($452)|0);
      var $454=HEAPU8[($453)];
      var $455=(($454)&255);
      var $456=$455 >> 5;
      var $457=(($451+$456)|0);
      var $458=((__ZL12namingBitmap+($457<<2))|0);
      var $459=HEAP32[(($458)>>2)];
      var $460=$3;
      var $461=(($460)|0);
      var $462=HEAPU8[($461)];
      var $463=(($462)&255);
      var $464=$463 & 31;
      var $465=1 << $464;
      var $466=$459 & $465;
      var $467=(($466)|0)!=0;
      if ($467) { __label__ = 93; break; } else { __label__ = 92; break; }
    case 92: // $468
      var $469=$3;
      var $470=$5;
      HEAP32[(($470)>>2)]=$469;
      $1=0;
      __label__ = 141; break;
    case 93: // $471
      __label__ = 94; break;
    case 94: // $472
      var $473=$3;
      var $474=(($473+2)|0);
      $3=$474;
      __label__ = 139; break;
    case 95: // $475
      var $476=$4;
      var $477=$3;
      var $478=$476;
      var $479=$477;
      var $480=(($478-$479)|0);
      var $481=(($480)|0) < 2;
      if ($481) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $482
      $1=-2;
      __label__ = 141; break;
    case 97: // $483
      var $484=$3;
      var $485=$5;
      HEAP32[(($485)>>2)]=$484;
      $1=0;
      __label__ = 141; break;
    case 98: // $486
      var $487=$4;
      var $488=$3;
      var $489=$487;
      var $490=$488;
      var $491=(($489-$490)|0);
      var $492=(($491)|0) < 3;
      if ($492) { __label__ = 99; break; } else { __label__ = 100; break; }
    case 99: // $493
      $1=-2;
      __label__ = 141; break;
    case 100: // $494
      var $495=$3;
      var $496=$5;
      HEAP32[(($496)>>2)]=$495;
      $1=0;
      __label__ = 141; break;
    case 101: // $497
      var $498=$4;
      var $499=$3;
      var $500=$498;
      var $501=$499;
      var $502=(($500-$501)|0);
      var $503=(($502)|0) < 4;
      if ($503) { __label__ = 102; break; } else { __label__ = 103; break; }
    case 102: // $504
      $1=-2;
      __label__ = 141; break;
    case 103: // $505
      var $506=$3;
      var $507=$5;
      HEAP32[(($507)>>2)]=$506;
      $1=0;
      __label__ = 141; break;
    case 104: // $508
      var $509=$3;
      var $510=$5;
      HEAP32[(($510)>>2)]=$509;
      var $511=$tok;
      $1=$511;
      __label__ = 141; break;
    case 105: // $512
      var $513=$3;
      var $514=(($513+2)|0);
      $3=$514;
      var $515=$tok;
      if ($515 == 18) {
        __label__ = 106; break;
      }
      else if ($515 == 41) {
        __label__ = 127; break;
      }
      else {
      __label__ = 128; break;
      }
      
    case 106: // $516
      var $517=$3;
      var $518=$4;
      var $519=(($517)|0)==(($518)|0);
      if ($519) { __label__ = 107; break; } else { __label__ = 108; break; }
    case 107: // $520
      $1=-1;
      __label__ = 141; break;
    case 108: // $521
      $tok=41;
      var $522=$3;
      var $523=(($522+1)|0);
      var $524=HEAP8[($523)];
      var $525=(($524 << 24) >> 24);
      var $526=(($525)|0)==0;
      if ($526) { __label__ = 109; break; } else { __label__ = 110; break; }
    case 109: // $527
      var $528=$3;
      var $529=HEAPU8[($528)];
      var $530=(($529)&255);
      var $531=$2;
      var $532=$531;
      var $533=(($532+76)|0);
      var $534=(($533+$530)|0);
      var $535=HEAPU8[($534)];
      var $536=(($535)&255);
      var $546 = $536;__label__ = 111; break;
    case 110: // $537
      var $538=$3;
      var $539=(($538+1)|0);
      var $540=HEAP8[($539)];
      var $541=$3;
      var $542=(($541)|0);
      var $543=HEAP8[($542)];
      var $544=__ZL17unicode_byte_typecc($540, $543);
      var $546 = $544;__label__ = 111; break;
    case 111: // $545
      var $546;
      if ($546 == 29) {
        __label__ = 112; break;
      }
      else if ($546 == 22 || $546 == 24 || $546 == 25 || $546 == 26 || $546 == 27) {
        __label__ = 115; break;
      }
      else if ($546 == 5) {
        __label__ = 116; break;
      }
      else if ($546 == 6) {
        __label__ = 119; break;
      }
      else if ($546 == 7) {
        __label__ = 122; break;
      }
      else {
      __label__ = 125; break;
      }
      
    case 112: // $547
      var $548=$3;
      var $549=(($548+1)|0);
      var $550=HEAPU8[($549)];
      var $551=(($550)&255);
      var $552=((STRING_TABLE.__ZL9namePages+$551)|0);
      var $553=HEAPU8[($552)];
      var $554=(($553)&255);
      var $555=$554 << 3;
      var $556=$3;
      var $557=(($556)|0);
      var $558=HEAPU8[($557)];
      var $559=(($558)&255);
      var $560=$559 >> 5;
      var $561=(($555+$560)|0);
      var $562=((__ZL12namingBitmap+($561<<2))|0);
      var $563=HEAP32[(($562)>>2)];
      var $564=$3;
      var $565=(($564)|0);
      var $566=HEAPU8[($565)];
      var $567=(($566)&255);
      var $568=$567 & 31;
      var $569=1 << $568;
      var $570=$563 & $569;
      var $571=(($570)|0)!=0;
      if ($571) { __label__ = 114; break; } else { __label__ = 113; break; }
    case 113: // $572
      var $573=$3;
      var $574=$5;
      HEAP32[(($574)>>2)]=$573;
      $1=0;
      __label__ = 141; break;
    case 114: // $575
      __label__ = 115; break;
    case 115: // $576
      var $577=$3;
      var $578=(($577+2)|0);
      $3=$578;
      __label__ = 126; break;
    case 116: // $579
      var $580=$4;
      var $581=$3;
      var $582=$580;
      var $583=$581;
      var $584=(($582-$583)|0);
      var $585=(($584)|0) < 2;
      if ($585) { __label__ = 117; break; } else { __label__ = 118; break; }
    case 117: // $586
      $1=-2;
      __label__ = 141; break;
    case 118: // $587
      var $588=$3;
      var $589=$5;
      HEAP32[(($589)>>2)]=$588;
      $1=0;
      __label__ = 141; break;
    case 119: // $590
      var $591=$4;
      var $592=$3;
      var $593=$591;
      var $594=$592;
      var $595=(($593-$594)|0);
      var $596=(($595)|0) < 3;
      if ($596) { __label__ = 120; break; } else { __label__ = 121; break; }
    case 120: // $597
      $1=-2;
      __label__ = 141; break;
    case 121: // $598
      var $599=$3;
      var $600=$5;
      HEAP32[(($600)>>2)]=$599;
      $1=0;
      __label__ = 141; break;
    case 122: // $601
      var $602=$4;
      var $603=$3;
      var $604=$602;
      var $605=$603;
      var $606=(($604-$605)|0);
      var $607=(($606)|0) < 4;
      if ($607) { __label__ = 123; break; } else { __label__ = 124; break; }
    case 123: // $608
      $1=-2;
      __label__ = 141; break;
    case 124: // $609
      var $610=$3;
      var $611=$5;
      HEAP32[(($611)>>2)]=$610;
      $1=0;
      __label__ = 141; break;
    case 125: // $612
      $tok=19;
      __label__ = 126; break;
    case 126: // $613
      __label__ = 128; break;
    case 127: // $614
      $tok=19;
      __label__ = 128; break;
    case 128: // $615
      __label__ = 139; break;
    case 129: // $616
      var $617=$tok;
      var $618=(($617)|0)==19;
      if ($618) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $619
      var $620=$3;
      var $621=$5;
      HEAP32[(($621)>>2)]=$620;
      $1=0;
      __label__ = 141; break;
    case 131: // $622
      var $623=$3;
      var $624=(($623+2)|0);
      var $625=$5;
      HEAP32[(($625)>>2)]=$624;
      $1=32;
      __label__ = 141; break;
    case 132: // $626
      var $627=$tok;
      var $628=(($627)|0)==19;
      if ($628) { __label__ = 133; break; } else { __label__ = 134; break; }
    case 133: // $629
      var $630=$3;
      var $631=$5;
      HEAP32[(($631)>>2)]=$630;
      $1=0;
      __label__ = 141; break;
    case 134: // $632
      var $633=$3;
      var $634=(($633+2)|0);
      var $635=$5;
      HEAP32[(($635)>>2)]=$634;
      $1=31;
      __label__ = 141; break;
    case 135: // $636
      var $637=$tok;
      var $638=(($637)|0)==19;
      if ($638) { __label__ = 136; break; } else { __label__ = 137; break; }
    case 136: // $639
      var $640=$3;
      var $641=$5;
      HEAP32[(($641)>>2)]=$640;
      $1=0;
      __label__ = 141; break;
    case 137: // $642
      var $643=$3;
      var $644=(($643+2)|0);
      var $645=$5;
      HEAP32[(($645)>>2)]=$644;
      $1=30;
      __label__ = 141; break;
    case 138: // $646
      var $647=$3;
      var $648=$5;
      HEAP32[(($648)>>2)]=$647;
      $1=0;
      __label__ = 141; break;
    case 139: // $649
      __label__ = 86; break;
    case 140: // $650
      var $651=$tok;
      var $652=(((-$651))|0);
      $1=$652;
      __label__ = 141; break;
    case 141: // $653
      var $654=$1;
      ;
      return $654;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17little2_prologTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18little2_contentTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 73; break;
    case 2: // $10
      var $11=$4;
      var $12=$3;
      var $13=$11;
      var $14=$12;
      var $15=(($13-$14)|0);
      $n=$15;
      var $16=$n;
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$n;
      var $21=$20 & -2;
      $n=$21;
      var $22=$n;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 73; break;
    case 5: // $25
      var $26=$3;
      var $27=$n;
      var $28=(($26+$27)|0);
      $4=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30+1)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$3;
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$2;
      var $40=$39;
      var $41=(($40+76)|0);
      var $42=(($41+$38)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $54 = $44;__label__ = 9; break;
    case 8: // $45
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAP8[($47)];
      var $49=$3;
      var $50=(($49)|0);
      var $51=HEAP8[($50)];
      var $52=__ZL17unicode_byte_typecc($48, $51);
      var $54 = $52;__label__ = 9; break;
    case 9: // $53
      var $54;
      if ($54 == 2) {
        __label__ = 10; break;
      }
      else if ($54 == 3) {
        __label__ = 11; break;
      }
      else if ($54 == 9) {
        __label__ = 12; break;
      }
      else if ($54 == 10) {
        __label__ = 20; break;
      }
      else if ($54 == 4) {
        __label__ = 21; break;
      }
      else if ($54 == 5) {
        __label__ = 32; break;
      }
      else if ($54 == 6) {
        __label__ = 35; break;
      }
      else if ($54 == 7) {
        __label__ = 38; break;
      }
      else if ($54 == 0 || $54 == 1 || $54 == 8) {
        __label__ = 41; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 10: // $55
      var $56=$2;
      var $57=$3;
      var $58=(($57+2)|0);
      var $59=$4;
      var $60=$5;
      var $61=__ZL14little2_scanLtPK8encodingPKcS3_PS3_($56, $58, $59, $60);
      $1=$61;
      __label__ = 73; break;
    case 11: // $62
      var $63=$2;
      var $64=$3;
      var $65=(($64+2)|0);
      var $66=$4;
      var $67=$5;
      var $68=__ZL15little2_scanRefPK8encodingPKcS3_PS3_($63, $65, $66, $67);
      $1=$68;
      __label__ = 73; break;
    case 12: // $69
      var $70=$3;
      var $71=(($70+2)|0);
      $3=$71;
      var $72=$3;
      var $73=$4;
      var $74=(($72)|0)==(($73)|0);
      if ($74) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $75
      $1=-3;
      __label__ = 73; break;
    case 14: // $76
      var $77=$3;
      var $78=(($77+1)|0);
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24);
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $82
      var $83=$3;
      var $84=HEAPU8[($83)];
      var $85=(($84)&255);
      var $86=$2;
      var $87=$86;
      var $88=(($87+76)|0);
      var $89=(($88+$85)|0);
      var $90=HEAPU8[($89)];
      var $91=(($90)&255);
      var $101 = $91;__label__ = 17; break;
    case 16: // $92
      var $93=$3;
      var $94=(($93+1)|0);
      var $95=HEAP8[($94)];
      var $96=$3;
      var $97=(($96)|0);
      var $98=HEAP8[($97)];
      var $99=__ZL17unicode_byte_typecc($95, $98);
      var $101 = $99;__label__ = 17; break;
    case 17: // $100
      var $101;
      var $102=(($101)|0)==10;
      if ($102) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $103
      var $104=$3;
      var $105=(($104+2)|0);
      $3=$105;
      __label__ = 19; break;
    case 19: // $106
      var $107=$3;
      var $108=$5;
      HEAP32[(($108)>>2)]=$107;
      $1=7;
      __label__ = 73; break;
    case 20: // $109
      var $110=$3;
      var $111=(($110+2)|0);
      var $112=$5;
      HEAP32[(($112)>>2)]=$111;
      $1=7;
      __label__ = 73; break;
    case 21: // $113
      var $114=$3;
      var $115=(($114+2)|0);
      $3=$115;
      var $116=$3;
      var $117=$4;
      var $118=(($116)|0)==(($117)|0);
      if ($118) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $119
      $1=-5;
      __label__ = 73; break;
    case 23: // $120
      var $121=$3;
      var $122=(($121+1)|0);
      var $123=HEAP8[($122)];
      var $124=(($123 << 24) >> 24);
      var $125=(($124)|0)==0;
      if ($125) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $126
      var $127=$3;
      var $128=(($127)|0);
      var $129=HEAP8[($128)];
      var $130=(($129 << 24) >> 24);
      var $131=(($130)|0)==93;
      if ($131) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $132
      __label__ = 43; break;
    case 26: // $133
      var $134=$3;
      var $135=(($134+2)|0);
      $3=$135;
      var $136=$3;
      var $137=$4;
      var $138=(($136)|0)==(($137)|0);
      if ($138) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $139
      $1=-5;
      __label__ = 73; break;
    case 28: // $140
      var $141=$3;
      var $142=(($141+1)|0);
      var $143=HEAP8[($142)];
      var $144=(($143 << 24) >> 24);
      var $145=(($144)|0)==0;
      if ($145) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $146
      var $147=$3;
      var $148=(($147)|0);
      var $149=HEAP8[($148)];
      var $150=(($149 << 24) >> 24);
      var $151=(($150)|0)==62;
      if ($151) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $152
      var $153=$3;
      var $154=(($153-2)|0);
      $3=$154;
      __label__ = 43; break;
    case 31: // $155
      var $156=$3;
      var $157=$5;
      HEAP32[(($157)>>2)]=$156;
      $1=0;
      __label__ = 73; break;
    case 32: // $158
      var $159=$4;
      var $160=$3;
      var $161=$159;
      var $162=$160;
      var $163=(($161-$162)|0);
      var $164=(($163)|0) < 2;
      if ($164) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $165
      $1=-2;
      __label__ = 73; break;
    case 34: // $166
      var $167=$3;
      var $168=(($167+2)|0);
      $3=$168;
      __label__ = 43; break;
    case 35: // $169
      var $170=$4;
      var $171=$3;
      var $172=$170;
      var $173=$171;
      var $174=(($172-$173)|0);
      var $175=(($174)|0) < 3;
      if ($175) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $176
      $1=-2;
      __label__ = 73; break;
    case 37: // $177
      var $178=$3;
      var $179=(($178+3)|0);
      $3=$179;
      __label__ = 43; break;
    case 38: // $180
      var $181=$4;
      var $182=$3;
      var $183=$181;
      var $184=$182;
      var $185=(($183-$184)|0);
      var $186=(($185)|0) < 4;
      if ($186) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $187
      $1=-2;
      __label__ = 73; break;
    case 40: // $188
      var $189=$3;
      var $190=(($189+4)|0);
      $3=$190;
      __label__ = 43; break;
    case 41: // $191
      var $192=$3;
      var $193=$5;
      HEAP32[(($193)>>2)]=$192;
      $1=0;
      __label__ = 73; break;
    case 42: // $194
      var $195=$3;
      var $196=(($195+2)|0);
      $3=$196;
      __label__ = 43; break;
    case 43: // $197
      __label__ = 44; break;
    case 44: // $198
      var $199=$3;
      var $200=$4;
      var $201=(($199)|0)!=(($200)|0);
      if ($201) { __label__ = 45; break; } else { __label__ = 72; break; }
    case 45: // $202
      var $203=$3;
      var $204=(($203+1)|0);
      var $205=HEAP8[($204)];
      var $206=(($205 << 24) >> 24);
      var $207=(($206)|0)==0;
      if ($207) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $208
      var $209=$3;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$2;
      var $213=$212;
      var $214=(($213+76)|0);
      var $215=(($214+$211)|0);
      var $216=HEAPU8[($215)];
      var $217=(($216)&255);
      var $227 = $217;__label__ = 48; break;
    case 47: // $218
      var $219=$3;
      var $220=(($219+1)|0);
      var $221=HEAP8[($220)];
      var $222=$3;
      var $223=(($222)|0);
      var $224=HEAP8[($223)];
      var $225=__ZL17unicode_byte_typecc($221, $224);
      var $227 = $225;__label__ = 48; break;
    case 48: // $226
      var $227;
      if ($227 == 5) {
        __label__ = 49; break;
      }
      else if ($227 == 6) {
        __label__ = 52; break;
      }
      else if ($227 == 7) {
        __label__ = 55; break;
      }
      else if ($227 == 4) {
        __label__ = 58; break;
      }
      else if ($227 == 3 || $227 == 2 || $227 == 0 || $227 == 1 || $227 == 8 || $227 == 9 || $227 == 10) {
        __label__ = 69; break;
      }
      else {
      __label__ = 70; break;
      }
      
    case 49: // $228
      var $229=$4;
      var $230=$3;
      var $231=$229;
      var $232=$230;
      var $233=(($231-$232)|0);
      var $234=(($233)|0) < 2;
      if ($234) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $235
      var $236=$3;
      var $237=$5;
      HEAP32[(($237)>>2)]=$236;
      $1=6;
      __label__ = 73; break;
    case 51: // $238
      var $239=$3;
      var $240=(($239+2)|0);
      $3=$240;
      __label__ = 71; break;
    case 52: // $241
      var $242=$4;
      var $243=$3;
      var $244=$242;
      var $245=$243;
      var $246=(($244-$245)|0);
      var $247=(($246)|0) < 3;
      if ($247) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $248
      var $249=$3;
      var $250=$5;
      HEAP32[(($250)>>2)]=$249;
      $1=6;
      __label__ = 73; break;
    case 54: // $251
      var $252=$3;
      var $253=(($252+3)|0);
      $3=$253;
      __label__ = 71; break;
    case 55: // $254
      var $255=$4;
      var $256=$3;
      var $257=$255;
      var $258=$256;
      var $259=(($257-$258)|0);
      var $260=(($259)|0) < 4;
      if ($260) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $261
      var $262=$3;
      var $263=$5;
      HEAP32[(($263)>>2)]=$262;
      $1=6;
      __label__ = 73; break;
    case 57: // $264
      var $265=$3;
      var $266=(($265+4)|0);
      $3=$266;
      __label__ = 71; break;
    case 58: // $267
      var $268=$3;
      var $269=(($268+2)|0);
      var $270=$4;
      var $271=(($269)|0)!=(($270)|0);
      if ($271) { __label__ = 59; break; } else { __label__ = 68; break; }
    case 59: // $272
      var $273=$3;
      var $274=(($273+2)|0);
      var $275=(($274+1)|0);
      var $276=HEAP8[($275)];
      var $277=(($276 << 24) >> 24);
      var $278=(($277)|0)==0;
      if ($278) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $279
      var $280=$3;
      var $281=(($280+2)|0);
      var $282=(($281)|0);
      var $283=HEAP8[($282)];
      var $284=(($283 << 24) >> 24);
      var $285=(($284)|0)==93;
      if ($285) { __label__ = 62; break; } else { __label__ = 61; break; }
    case 61: // $286
      var $287=$3;
      var $288=(($287+2)|0);
      $3=$288;
      __label__ = 71; break;
    case 62: // $289
      var $290=$3;
      var $291=(($290+4)|0);
      var $292=$4;
      var $293=(($291)|0)!=(($292)|0);
      if ($293) { __label__ = 63; break; } else { __label__ = 67; break; }
    case 63: // $294
      var $295=$3;
      var $296=(($295+4)|0);
      var $297=(($296+1)|0);
      var $298=HEAP8[($297)];
      var $299=(($298 << 24) >> 24);
      var $300=(($299)|0)==0;
      if ($300) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $301
      var $302=$3;
      var $303=(($302+4)|0);
      var $304=(($303)|0);
      var $305=HEAP8[($304)];
      var $306=(($305 << 24) >> 24);
      var $307=(($306)|0)==62;
      if ($307) { __label__ = 66; break; } else { __label__ = 65; break; }
    case 65: // $308
      var $309=$3;
      var $310=(($309+2)|0);
      $3=$310;
      __label__ = 71; break;
    case 66: // $311
      var $312=$3;
      var $313=(($312+4)|0);
      var $314=$5;
      HEAP32[(($314)>>2)]=$313;
      $1=0;
      __label__ = 73; break;
    case 67: // $315
      __label__ = 68; break;
    case 68: // $316
      __label__ = 69; break;
    case 69: // $317
      var $318=$3;
      var $319=$5;
      HEAP32[(($319)>>2)]=$318;
      $1=6;
      __label__ = 73; break;
    case 70: // $320
      var $321=$3;
      var $322=(($321+2)|0);
      $3=$322;
      __label__ = 71; break;
    case 71: // $323
      __label__ = 44; break;
    case 72: // $324
      var $325=$3;
      var $326=$5;
      HEAP32[(($326)>>2)]=$325;
      $1=6;
      __label__ = 73; break;
    case 73: // $327
      var $328=$1;
      ;
      return $328;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18little2_contentTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL23little2_cdataSectionTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 60; break;
    case 2: // $10
      var $11=$4;
      var $12=$3;
      var $13=$11;
      var $14=$12;
      var $15=(($13-$14)|0);
      $n=$15;
      var $16=$n;
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$n;
      var $21=$20 & -2;
      $n=$21;
      var $22=$n;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 60; break;
    case 5: // $25
      var $26=$3;
      var $27=$n;
      var $28=(($26+$27)|0);
      $4=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30+1)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$3;
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$2;
      var $40=$39;
      var $41=(($40+76)|0);
      var $42=(($41+$38)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $54 = $44;__label__ = 9; break;
    case 8: // $45
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAP8[($47)];
      var $49=$3;
      var $50=(($49)|0);
      var $51=HEAP8[($50)];
      var $52=__ZL17unicode_byte_typecc($48, $51);
      var $54 = $52;__label__ = 9; break;
    case 9: // $53
      var $54;
      if ($54 == 4) {
        __label__ = 10; break;
      }
      else if ($54 == 9) {
        __label__ = 21; break;
      }
      else if ($54 == 10) {
        __label__ = 29; break;
      }
      else if ($54 == 5) {
        __label__ = 30; break;
      }
      else if ($54 == 6) {
        __label__ = 33; break;
      }
      else if ($54 == 7) {
        __label__ = 36; break;
      }
      else if ($54 == 0 || $54 == 1 || $54 == 8) {
        __label__ = 39; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 10: // $55
      var $56=$3;
      var $57=(($56+2)|0);
      $3=$57;
      var $58=$3;
      var $59=$4;
      var $60=(($58)|0)==(($59)|0);
      if ($60) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $61
      $1=-1;
      __label__ = 60; break;
    case 12: // $62
      var $63=$3;
      var $64=(($63+1)|0);
      var $65=HEAP8[($64)];
      var $66=(($65 << 24) >> 24);
      var $67=(($66)|0)==0;
      if ($67) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $68
      var $69=$3;
      var $70=(($69)|0);
      var $71=HEAP8[($70)];
      var $72=(($71 << 24) >> 24);
      var $73=(($72)|0)==93;
      if ($73) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $74
      __label__ = 41; break;
    case 15: // $75
      var $76=$3;
      var $77=(($76+2)|0);
      $3=$77;
      var $78=$3;
      var $79=$4;
      var $80=(($78)|0)==(($79)|0);
      if ($80) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $81
      $1=-1;
      __label__ = 60; break;
    case 17: // $82
      var $83=$3;
      var $84=(($83+1)|0);
      var $85=HEAP8[($84)];
      var $86=(($85 << 24) >> 24);
      var $87=(($86)|0)==0;
      if ($87) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $88
      var $89=$3;
      var $90=(($89)|0);
      var $91=HEAP8[($90)];
      var $92=(($91 << 24) >> 24);
      var $93=(($92)|0)==62;
      if ($93) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $94
      var $95=$3;
      var $96=(($95-2)|0);
      $3=$96;
      __label__ = 41; break;
    case 20: // $97
      var $98=$3;
      var $99=(($98+2)|0);
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=40;
      __label__ = 60; break;
    case 21: // $101
      var $102=$3;
      var $103=(($102+2)|0);
      $3=$103;
      var $104=$3;
      var $105=$4;
      var $106=(($104)|0)==(($105)|0);
      if ($106) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $107
      $1=-1;
      __label__ = 60; break;
    case 23: // $108
      var $109=$3;
      var $110=(($109+1)|0);
      var $111=HEAP8[($110)];
      var $112=(($111 << 24) >> 24);
      var $113=(($112)|0)==0;
      if ($113) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $114
      var $115=$3;
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$2;
      var $119=$118;
      var $120=(($119+76)|0);
      var $121=(($120+$117)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $133 = $123;__label__ = 26; break;
    case 25: // $124
      var $125=$3;
      var $126=(($125+1)|0);
      var $127=HEAP8[($126)];
      var $128=$3;
      var $129=(($128)|0);
      var $130=HEAP8[($129)];
      var $131=__ZL17unicode_byte_typecc($127, $130);
      var $133 = $131;__label__ = 26; break;
    case 26: // $132
      var $133;
      var $134=(($133)|0)==10;
      if ($134) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $135
      var $136=$3;
      var $137=(($136+2)|0);
      $3=$137;
      __label__ = 28; break;
    case 28: // $138
      var $139=$3;
      var $140=$5;
      HEAP32[(($140)>>2)]=$139;
      $1=7;
      __label__ = 60; break;
    case 29: // $141
      var $142=$3;
      var $143=(($142+2)|0);
      var $144=$5;
      HEAP32[(($144)>>2)]=$143;
      $1=7;
      __label__ = 60; break;
    case 30: // $145
      var $146=$4;
      var $147=$3;
      var $148=$146;
      var $149=$147;
      var $150=(($148-$149)|0);
      var $151=(($150)|0) < 2;
      if ($151) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $152
      $1=-2;
      __label__ = 60; break;
    case 32: // $153
      var $154=$3;
      var $155=(($154+2)|0);
      $3=$155;
      __label__ = 41; break;
    case 33: // $156
      var $157=$4;
      var $158=$3;
      var $159=$157;
      var $160=$158;
      var $161=(($159-$160)|0);
      var $162=(($161)|0) < 3;
      if ($162) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $163
      $1=-2;
      __label__ = 60; break;
    case 35: // $164
      var $165=$3;
      var $166=(($165+3)|0);
      $3=$166;
      __label__ = 41; break;
    case 36: // $167
      var $168=$4;
      var $169=$3;
      var $170=$168;
      var $171=$169;
      var $172=(($170-$171)|0);
      var $173=(($172)|0) < 4;
      if ($173) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $174
      $1=-2;
      __label__ = 60; break;
    case 38: // $175
      var $176=$3;
      var $177=(($176+4)|0);
      $3=$177;
      __label__ = 41; break;
    case 39: // $178
      var $179=$3;
      var $180=$5;
      HEAP32[(($180)>>2)]=$179;
      $1=0;
      __label__ = 60; break;
    case 40: // $181
      var $182=$3;
      var $183=(($182+2)|0);
      $3=$183;
      __label__ = 41; break;
    case 41: // $184
      __label__ = 42; break;
    case 42: // $185
      var $186=$3;
      var $187=$4;
      var $188=(($186)|0)!=(($187)|0);
      if ($188) { __label__ = 43; break; } else { __label__ = 59; break; }
    case 43: // $189
      var $190=$3;
      var $191=(($190+1)|0);
      var $192=HEAP8[($191)];
      var $193=(($192 << 24) >> 24);
      var $194=(($193)|0)==0;
      if ($194) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $195
      var $196=$3;
      var $197=HEAPU8[($196)];
      var $198=(($197)&255);
      var $199=$2;
      var $200=$199;
      var $201=(($200+76)|0);
      var $202=(($201+$198)|0);
      var $203=HEAPU8[($202)];
      var $204=(($203)&255);
      var $214 = $204;__label__ = 46; break;
    case 45: // $205
      var $206=$3;
      var $207=(($206+1)|0);
      var $208=HEAP8[($207)];
      var $209=$3;
      var $210=(($209)|0);
      var $211=HEAP8[($210)];
      var $212=__ZL17unicode_byte_typecc($208, $211);
      var $214 = $212;__label__ = 46; break;
    case 46: // $213
      var $214;
      if ($214 == 5) {
        __label__ = 47; break;
      }
      else if ($214 == 6) {
        __label__ = 50; break;
      }
      else if ($214 == 7) {
        __label__ = 53; break;
      }
      else if ($214 == 0 || $214 == 1 || $214 == 8 || $214 == 9 || $214 == 10 || $214 == 4) {
        __label__ = 56; break;
      }
      else {
      __label__ = 57; break;
      }
      
    case 47: // $215
      var $216=$4;
      var $217=$3;
      var $218=$216;
      var $219=$217;
      var $220=(($218-$219)|0);
      var $221=(($220)|0) < 2;
      if ($221) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $222
      var $223=$3;
      var $224=$5;
      HEAP32[(($224)>>2)]=$223;
      $1=6;
      __label__ = 60; break;
    case 49: // $225
      var $226=$3;
      var $227=(($226+2)|0);
      $3=$227;
      __label__ = 58; break;
    case 50: // $228
      var $229=$4;
      var $230=$3;
      var $231=$229;
      var $232=$230;
      var $233=(($231-$232)|0);
      var $234=(($233)|0) < 3;
      if ($234) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $235
      var $236=$3;
      var $237=$5;
      HEAP32[(($237)>>2)]=$236;
      $1=6;
      __label__ = 60; break;
    case 52: // $238
      var $239=$3;
      var $240=(($239+3)|0);
      $3=$240;
      __label__ = 58; break;
    case 53: // $241
      var $242=$4;
      var $243=$3;
      var $244=$242;
      var $245=$243;
      var $246=(($244-$245)|0);
      var $247=(($246)|0) < 4;
      if ($247) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $248
      var $249=$3;
      var $250=$5;
      HEAP32[(($250)>>2)]=$249;
      $1=6;
      __label__ = 60; break;
    case 55: // $251
      var $252=$3;
      var $253=(($252+4)|0);
      $3=$253;
      __label__ = 58; break;
    case 56: // $254
      var $255=$3;
      var $256=$5;
      HEAP32[(($256)>>2)]=$255;
      $1=6;
      __label__ = 60; break;
    case 57: // $257
      var $258=$3;
      var $259=(($258+2)|0);
      $3=$259;
      __label__ = 58; break;
    case 58: // $260
      __label__ = 42; break;
    case 59: // $261
      var $262=$3;
      var $263=$5;
      HEAP32[(($263)>>2)]=$262;
      $1=6;
      __label__ = 60; break;
    case 60: // $264
      var $265=$1;
      ;
      return $265;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23little2_cdataSectionTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL24little2_ignoreSectionTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $level;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      $level=0;
      var $6=$4;
      var $7=$3;
      var $8=$6;
      var $9=$7;
      var $10=(($8-$9)|0);
      $n=$10;
      var $11=$n;
      var $12=$11 & 1;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$n;
      var $16=$15 & -2;
      $n=$16;
      var $17=$3;
      var $18=$n;
      var $19=(($17+$18)|0);
      $4=$19;
      __label__ = 2; break;
    case 2: // $20
      __label__ = 3; break;
    case 3: // $21
      var $22=$3;
      var $23=$4;
      var $24=(($22)|0)!=(($23)|0);
      if ($24) { __label__ = 4; break; } else { __label__ = 44; break; }
    case 4: // $25
      var $26=$3;
      var $27=(($26+1)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=$3;
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=$2;
      var $36=$35;
      var $37=(($36+76)|0);
      var $38=(($37+$34)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $50 = $40;__label__ = 7; break;
    case 6: // $41
      var $42=$3;
      var $43=(($42+1)|0);
      var $44=HEAP8[($43)];
      var $45=$3;
      var $46=(($45)|0);
      var $47=HEAP8[($46)];
      var $48=__ZL17unicode_byte_typecc($44, $47);
      var $50 = $48;__label__ = 7; break;
    case 7: // $49
      var $50;
      if ($50 == 5) {
        __label__ = 8; break;
      }
      else if ($50 == 6) {
        __label__ = 11; break;
      }
      else if ($50 == 7) {
        __label__ = 14; break;
      }
      else if ($50 == 0 || $50 == 1 || $50 == 8) {
        __label__ = 17; break;
      }
      else if ($50 == 2) {
        __label__ = 18; break;
      }
      else if ($50 == 4) {
        __label__ = 29; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 8: // $51
      var $52=$4;
      var $53=$3;
      var $54=$52;
      var $55=$53;
      var $56=(($54-$55)|0);
      var $57=(($56)|0) < 2;
      if ($57) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $58
      $1=-2;
      __label__ = 45; break;
    case 10: // $59
      var $60=$3;
      var $61=(($60+2)|0);
      $3=$61;
      __label__ = 43; break;
    case 11: // $62
      var $63=$4;
      var $64=$3;
      var $65=$63;
      var $66=$64;
      var $67=(($65-$66)|0);
      var $68=(($67)|0) < 3;
      if ($68) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $69
      $1=-2;
      __label__ = 45; break;
    case 13: // $70
      var $71=$3;
      var $72=(($71+3)|0);
      $3=$72;
      __label__ = 43; break;
    case 14: // $73
      var $74=$4;
      var $75=$3;
      var $76=$74;
      var $77=$75;
      var $78=(($76-$77)|0);
      var $79=(($78)|0) < 4;
      if ($79) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $80
      $1=-2;
      __label__ = 45; break;
    case 16: // $81
      var $82=$3;
      var $83=(($82+4)|0);
      $3=$83;
      __label__ = 43; break;
    case 17: // $84
      var $85=$3;
      var $86=$5;
      HEAP32[(($86)>>2)]=$85;
      $1=0;
      __label__ = 45; break;
    case 18: // $87
      var $88=$3;
      var $89=(($88+2)|0);
      $3=$89;
      var $90=$4;
      var $91=(($89)|0)==(($90)|0);
      if ($91) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $92
      $1=-1;
      __label__ = 45; break;
    case 20: // $93
      var $94=$3;
      var $95=(($94+1)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24);
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $99
      var $100=$3;
      var $101=(($100)|0);
      var $102=HEAP8[($101)];
      var $103=(($102 << 24) >> 24);
      var $104=(($103)|0)==33;
      if ($104) { __label__ = 22; break; } else { __label__ = 28; break; }
    case 22: // $105
      var $106=$3;
      var $107=(($106+2)|0);
      $3=$107;
      var $108=$4;
      var $109=(($107)|0)==(($108)|0);
      if ($109) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $110
      $1=-1;
      __label__ = 45; break;
    case 24: // $111
      var $112=$3;
      var $113=(($112+1)|0);
      var $114=HEAP8[($113)];
      var $115=(($114 << 24) >> 24);
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $117
      var $118=$3;
      var $119=(($118)|0);
      var $120=HEAP8[($119)];
      var $121=(($120 << 24) >> 24);
      var $122=(($121)|0)==91;
      if ($122) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $123
      var $124=$level;
      var $125=(($124+1)|0);
      $level=$125;
      var $126=$3;
      var $127=(($126+2)|0);
      $3=$127;
      __label__ = 27; break;
    case 27: // $128
      __label__ = 28; break;
    case 28: // $129
      __label__ = 43; break;
    case 29: // $130
      var $131=$3;
      var $132=(($131+2)|0);
      $3=$132;
      var $133=$4;
      var $134=(($132)|0)==(($133)|0);
      if ($134) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $135
      $1=-1;
      __label__ = 45; break;
    case 31: // $136
      var $137=$3;
      var $138=(($137+1)|0);
      var $139=HEAP8[($138)];
      var $140=(($139 << 24) >> 24);
      var $141=(($140)|0)==0;
      if ($141) { __label__ = 32; break; } else { __label__ = 41; break; }
    case 32: // $142
      var $143=$3;
      var $144=(($143)|0);
      var $145=HEAP8[($144)];
      var $146=(($145 << 24) >> 24);
      var $147=(($146)|0)==93;
      if ($147) { __label__ = 33; break; } else { __label__ = 41; break; }
    case 33: // $148
      var $149=$3;
      var $150=(($149+2)|0);
      $3=$150;
      var $151=$4;
      var $152=(($150)|0)==(($151)|0);
      if ($152) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $153
      $1=-1;
      __label__ = 45; break;
    case 35: // $154
      var $155=$3;
      var $156=(($155+1)|0);
      var $157=HEAP8[($156)];
      var $158=(($157 << 24) >> 24);
      var $159=(($158)|0)==0;
      if ($159) { __label__ = 36; break; } else { __label__ = 40; break; }
    case 36: // $160
      var $161=$3;
      var $162=(($161)|0);
      var $163=HEAP8[($162)];
      var $164=(($163 << 24) >> 24);
      var $165=(($164)|0)==62;
      if ($165) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $166
      var $167=$3;
      var $168=(($167+2)|0);
      $3=$168;
      var $169=$level;
      var $170=(($169)|0)==0;
      if ($170) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $171
      var $172=$3;
      var $173=$5;
      HEAP32[(($173)>>2)]=$172;
      $1=42;
      __label__ = 45; break;
    case 39: // $174
      var $175=$level;
      var $176=(($175-1)|0);
      $level=$176;
      __label__ = 40; break;
    case 40: // $177
      __label__ = 41; break;
    case 41: // $178
      __label__ = 43; break;
    case 42: // $179
      var $180=$3;
      var $181=(($180+2)|0);
      $3=$181;
      __label__ = 43; break;
    case 43: // $182
      __label__ = 3; break;
    case 44: // $183
      $1=-1;
      __label__ = 45; break;
    case 45: // $184
      var $185=$1;
      ;
      return $185;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24little2_ignoreSectionTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL24little2_nameMatchesAsciiPK8encodingPKcS3_S3_($enc, $ptr1, $end1, $ptr2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr1;
      $4=$end1;
      $5=$ptr2;
      __label__ = 1; break;
    case 1: // $6
      var $7=$5;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $10
      var $11=$3;
      var $12=$4;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=0;
      __label__ = 10; break;
    case 4: // $15
      var $16=$3;
      var $17=(($16+1)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=$3;
      var $23=(($22)|0);
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24);
      var $26=$5;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=(($25)|0)==(($28)|0);
      if ($29) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $30
      $1=0;
      __label__ = 10; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      var $33=$3;
      var $34=(($33+2)|0);
      $3=$34;
      var $35=$5;
      var $36=(($35+1)|0);
      $5=$36;
      __label__ = 1; break;
    case 9: // $37
      var $38=$3;
      var $39=$4;
      var $40=(($38)|0)==(($39)|0);
      var $41=(($40)&1);
      $1=$41;
      __label__ = 10; break;
    case 10: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24little2_nameMatchesAsciiPK8encodingPKcS3_S3_["X"]=1;

function __ZL25little2_attributeValueTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $start;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 34; break;
    case 2: // $10
      var $11=$3;
      $start=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 33; break; }
    case 4: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$3;
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$2;
      var $27=$26;
      var $28=(($27+76)|0);
      var $29=(($28+$25)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $41 = $31;__label__ = 7; break;
    case 6: // $32
      var $33=$3;
      var $34=(($33+1)|0);
      var $35=HEAP8[($34)];
      var $36=$3;
      var $37=(($36)|0);
      var $38=HEAP8[($37)];
      var $39=__ZL17unicode_byte_typecc($35, $38);
      var $41 = $39;__label__ = 7; break;
    case 7: // $40
      var $41;
      if ($41 == 5) {
        __label__ = 8; break;
      }
      else if ($41 == 6) {
        __label__ = 9; break;
      }
      else if ($41 == 7) {
        __label__ = 10; break;
      }
      else if ($41 == 3) {
        __label__ = 11; break;
      }
      else if ($41 == 2) {
        __label__ = 14; break;
      }
      else if ($41 == 10) {
        __label__ = 15; break;
      }
      else if ($41 == 9) {
        __label__ = 18; break;
      }
      else if ($41 == 21) {
        __label__ = 28; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 8: // $42
      var $43=$3;
      var $44=(($43+2)|0);
      $3=$44;
      __label__ = 32; break;
    case 9: // $45
      var $46=$3;
      var $47=(($46+3)|0);
      $3=$47;
      __label__ = 32; break;
    case 10: // $48
      var $49=$3;
      var $50=(($49+4)|0);
      $3=$50;
      __label__ = 32; break;
    case 11: // $51
      var $52=$3;
      var $53=$start;
      var $54=(($52)|0)==(($53)|0);
      if ($54) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $55
      var $56=$2;
      var $57=$3;
      var $58=(($57+2)|0);
      var $59=$4;
      var $60=$5;
      var $61=__ZL15little2_scanRefPK8encodingPKcS3_PS3_($56, $58, $59, $60);
      $1=$61;
      __label__ = 34; break;
    case 13: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=6;
      __label__ = 34; break;
    case 14: // $65
      var $66=$3;
      var $67=$5;
      HEAP32[(($67)>>2)]=$66;
      $1=0;
      __label__ = 34; break;
    case 15: // $68
      var $69=$3;
      var $70=$start;
      var $71=(($69)|0)==(($70)|0);
      if ($71) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $72
      var $73=$3;
      var $74=(($73+2)|0);
      var $75=$5;
      HEAP32[(($75)>>2)]=$74;
      $1=7;
      __label__ = 34; break;
    case 17: // $76
      var $77=$3;
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=6;
      __label__ = 34; break;
    case 18: // $79
      var $80=$3;
      var $81=$start;
      var $82=(($80)|0)==(($81)|0);
      if ($82) { __label__ = 19; break; } else { __label__ = 27; break; }
    case 19: // $83
      var $84=$3;
      var $85=(($84+2)|0);
      $3=$85;
      var $86=$3;
      var $87=$4;
      var $88=(($86)|0)==(($87)|0);
      if ($88) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $89
      $1=-3;
      __label__ = 34; break;
    case 21: // $90
      var $91=$3;
      var $92=(($91+1)|0);
      var $93=HEAP8[($92)];
      var $94=(($93 << 24) >> 24);
      var $95=(($94)|0)==0;
      if ($95) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $96
      var $97=$3;
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$2;
      var $101=$100;
      var $102=(($101+76)|0);
      var $103=(($102+$99)|0);
      var $104=HEAPU8[($103)];
      var $105=(($104)&255);
      var $115 = $105;__label__ = 24; break;
    case 23: // $106
      var $107=$3;
      var $108=(($107+1)|0);
      var $109=HEAP8[($108)];
      var $110=$3;
      var $111=(($110)|0);
      var $112=HEAP8[($111)];
      var $113=__ZL17unicode_byte_typecc($109, $112);
      var $115 = $113;__label__ = 24; break;
    case 24: // $114
      var $115;
      var $116=(($115)|0)==10;
      if ($116) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $117
      var $118=$3;
      var $119=(($118+2)|0);
      $3=$119;
      __label__ = 26; break;
    case 26: // $120
      var $121=$3;
      var $122=$5;
      HEAP32[(($122)>>2)]=$121;
      $1=7;
      __label__ = 34; break;
    case 27: // $123
      var $124=$3;
      var $125=$5;
      HEAP32[(($125)>>2)]=$124;
      $1=6;
      __label__ = 34; break;
    case 28: // $126
      var $127=$3;
      var $128=$start;
      var $129=(($127)|0)==(($128)|0);
      if ($129) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $130
      var $131=$3;
      var $132=(($131+2)|0);
      var $133=$5;
      HEAP32[(($133)>>2)]=$132;
      $1=39;
      __label__ = 34; break;
    case 30: // $134
      var $135=$3;
      var $136=$5;
      HEAP32[(($136)>>2)]=$135;
      $1=6;
      __label__ = 34; break;
    case 31: // $137
      var $138=$3;
      var $139=(($138+2)|0);
      $3=$139;
      __label__ = 32; break;
    case 32: // $140
      __label__ = 3; break;
    case 33: // $141
      var $142=$3;
      var $143=$5;
      HEAP32[(($143)>>2)]=$142;
      $1=6;
      __label__ = 34; break;
    case 34: // $144
      var $145=$1;
      ;
      return $145;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25little2_attributeValueTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL22little2_entityValueTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $start;
      var $tok;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 36; break;
    case 2: // $10
      var $11=$3;
      $start=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 35; break; }
    case 4: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$3;
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $26=$2;
      var $27=$26;
      var $28=(($27+76)|0);
      var $29=(($28+$25)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $41 = $31;__label__ = 7; break;
    case 6: // $32
      var $33=$3;
      var $34=(($33+1)|0);
      var $35=HEAP8[($34)];
      var $36=$3;
      var $37=(($36)|0);
      var $38=HEAP8[($37)];
      var $39=__ZL17unicode_byte_typecc($35, $38);
      var $41 = $39;__label__ = 7; break;
    case 7: // $40
      var $41;
      if ($41 == 5) {
        __label__ = 8; break;
      }
      else if ($41 == 6) {
        __label__ = 9; break;
      }
      else if ($41 == 7) {
        __label__ = 10; break;
      }
      else if ($41 == 3) {
        __label__ = 11; break;
      }
      else if ($41 == 30) {
        __label__ = 14; break;
      }
      else if ($41 == 10) {
        __label__ = 20; break;
      }
      else if ($41 == 9) {
        __label__ = 23; break;
      }
      else {
      __label__ = 33; break;
      }
      
    case 8: // $42
      var $43=$3;
      var $44=(($43+2)|0);
      $3=$44;
      __label__ = 34; break;
    case 9: // $45
      var $46=$3;
      var $47=(($46+3)|0);
      $3=$47;
      __label__ = 34; break;
    case 10: // $48
      var $49=$3;
      var $50=(($49+4)|0);
      $3=$50;
      __label__ = 34; break;
    case 11: // $51
      var $52=$3;
      var $53=$start;
      var $54=(($52)|0)==(($53)|0);
      if ($54) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $55
      var $56=$2;
      var $57=$3;
      var $58=(($57+2)|0);
      var $59=$4;
      var $60=$5;
      var $61=__ZL15little2_scanRefPK8encodingPKcS3_PS3_($56, $58, $59, $60);
      $1=$61;
      __label__ = 36; break;
    case 13: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=6;
      __label__ = 36; break;
    case 14: // $65
      var $66=$3;
      var $67=$start;
      var $68=(($66)|0)==(($67)|0);
      if ($68) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $69
      var $70=$2;
      var $71=$3;
      var $72=(($71+2)|0);
      var $73=$4;
      var $74=$5;
      var $75=__ZL19little2_scanPercentPK8encodingPKcS3_PS3_($70, $72, $73, $74);
      $tok=$75;
      var $76=$tok;
      var $77=(($76)|0)==22;
      if ($77) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $78
      var $82 = 0;__label__ = 18; break;
    case 17: // $79
      var $80=$tok;
      var $82 = $80;__label__ = 18; break;
    case 18: // $81
      var $82;
      $1=$82;
      __label__ = 36; break;
    case 19: // $83
      var $84=$3;
      var $85=$5;
      HEAP32[(($85)>>2)]=$84;
      $1=6;
      __label__ = 36; break;
    case 20: // $86
      var $87=$3;
      var $88=$start;
      var $89=(($87)|0)==(($88)|0);
      if ($89) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $90
      var $91=$3;
      var $92=(($91+2)|0);
      var $93=$5;
      HEAP32[(($93)>>2)]=$92;
      $1=7;
      __label__ = 36; break;
    case 22: // $94
      var $95=$3;
      var $96=$5;
      HEAP32[(($96)>>2)]=$95;
      $1=6;
      __label__ = 36; break;
    case 23: // $97
      var $98=$3;
      var $99=$start;
      var $100=(($98)|0)==(($99)|0);
      if ($100) { __label__ = 24; break; } else { __label__ = 32; break; }
    case 24: // $101
      var $102=$3;
      var $103=(($102+2)|0);
      $3=$103;
      var $104=$3;
      var $105=$4;
      var $106=(($104)|0)==(($105)|0);
      if ($106) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $107
      $1=-3;
      __label__ = 36; break;
    case 26: // $108
      var $109=$3;
      var $110=(($109+1)|0);
      var $111=HEAP8[($110)];
      var $112=(($111 << 24) >> 24);
      var $113=(($112)|0)==0;
      if ($113) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $114
      var $115=$3;
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$2;
      var $119=$118;
      var $120=(($119+76)|0);
      var $121=(($120+$117)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $133 = $123;__label__ = 29; break;
    case 28: // $124
      var $125=$3;
      var $126=(($125+1)|0);
      var $127=HEAP8[($126)];
      var $128=$3;
      var $129=(($128)|0);
      var $130=HEAP8[($129)];
      var $131=__ZL17unicode_byte_typecc($127, $130);
      var $133 = $131;__label__ = 29; break;
    case 29: // $132
      var $133;
      var $134=(($133)|0)==10;
      if ($134) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $135
      var $136=$3;
      var $137=(($136+2)|0);
      $3=$137;
      __label__ = 31; break;
    case 31: // $138
      var $139=$3;
      var $140=$5;
      HEAP32[(($140)>>2)]=$139;
      $1=7;
      __label__ = 36; break;
    case 32: // $141
      var $142=$3;
      var $143=$5;
      HEAP32[(($143)>>2)]=$142;
      $1=6;
      __label__ = 36; break;
    case 33: // $144
      var $145=$3;
      var $146=(($145+2)|0);
      $3=$146;
      __label__ = 34; break;
    case 34: // $147
      __label__ = 3; break;
    case 35: // $148
      var $149=$3;
      var $150=$5;
      HEAP32[(($150)>>2)]=$149;
      $1=6;
      __label__ = 36; break;
    case 36: // $151
      var $152=$1;
      ;
      return $152;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22little2_entityValueTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL16little2_sameNamePK8encodingPKcS3_($enc, $ptr1, $ptr2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$enc;
      $3=$ptr1;
      $4=$ptr2;
      __label__ = 1; break;
    case 1: // $5
      var $6=$3;
      var $7=(($6+1)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$3;
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$2;
      var $16=$15;
      var $17=(($16+76)|0);
      var $18=(($17+$14)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $30 = $20;__label__ = 4; break;
    case 3: // $21
      var $22=$3;
      var $23=(($22+1)|0);
      var $24=HEAP8[($23)];
      var $25=$3;
      var $26=(($25)|0);
      var $27=HEAP8[($26)];
      var $28=__ZL17unicode_byte_typecc($24, $27);
      var $30 = $28;__label__ = 4; break;
    case 4: // $29
      var $30;
      if ($30 == 7) {
        __label__ = 5; break;
      }
      else if ($30 == 6) {
        __label__ = 8; break;
      }
      else if ($30 == 5) {
        __label__ = 11; break;
      }
      else if ($30 == 29 || $30 == 22 || $30 == 23 || $30 == 24 || $30 == 25 || $30 == 26 || $30 == 27) {
        __label__ = 16; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 5: // $31
      var $32=$3;
      var $33=(($32+1)|0);
      $3=$33;
      var $34=HEAP8[($32)];
      var $35=(($34 << 24) >> 24);
      var $36=$4;
      var $37=(($36+1)|0);
      $4=$37;
      var $38=HEAP8[($36)];
      var $39=(($38 << 24) >> 24);
      var $40=(($35)|0)!=(($39)|0);
      if ($40) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $41
      $1=0;
      __label__ = 28; break;
    case 7: // $42
      __label__ = 8; break;
    case 8: // $43
      var $44=$3;
      var $45=(($44+1)|0);
      $3=$45;
      var $46=HEAP8[($44)];
      var $47=(($46 << 24) >> 24);
      var $48=$4;
      var $49=(($48+1)|0);
      $4=$49;
      var $50=HEAP8[($48)];
      var $51=(($50 << 24) >> 24);
      var $52=(($47)|0)!=(($51)|0);
      if ($52) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $53
      $1=0;
      __label__ = 28; break;
    case 10: // $54
      __label__ = 11; break;
    case 11: // $55
      var $56=$3;
      var $57=(($56+1)|0);
      $3=$57;
      var $58=HEAP8[($56)];
      var $59=(($58 << 24) >> 24);
      var $60=$4;
      var $61=(($60+1)|0);
      $4=$61;
      var $62=HEAP8[($60)];
      var $63=(($62 << 24) >> 24);
      var $64=(($59)|0)!=(($63)|0);
      if ($64) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $65
      $1=0;
      __label__ = 28; break;
    case 13: // $66
      var $67=$3;
      var $68=(($67+1)|0);
      $3=$68;
      var $69=HEAP8[($67)];
      var $70=(($69 << 24) >> 24);
      var $71=$4;
      var $72=(($71+1)|0);
      $4=$72;
      var $73=HEAP8[($71)];
      var $74=(($73 << 24) >> 24);
      var $75=(($70)|0)!=(($74)|0);
      if ($75) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $76
      $1=0;
      __label__ = 28; break;
    case 15: // $77
      __label__ = 27; break;
    case 16: // $78
      var $79=$4;
      var $80=(($79+1)|0);
      $4=$80;
      var $81=HEAP8[($79)];
      var $82=(($81 << 24) >> 24);
      var $83=$3;
      var $84=(($83+1)|0);
      $3=$84;
      var $85=HEAP8[($83)];
      var $86=(($85 << 24) >> 24);
      var $87=(($82)|0)!=(($86)|0);
      if ($87) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $88
      $1=0;
      __label__ = 28; break;
    case 18: // $89
      var $90=$4;
      var $91=(($90+1)|0);
      $4=$91;
      var $92=HEAP8[($90)];
      var $93=(($92 << 24) >> 24);
      var $94=$3;
      var $95=(($94+1)|0);
      $3=$95;
      var $96=HEAP8[($94)];
      var $97=(($96 << 24) >> 24);
      var $98=(($93)|0)!=(($97)|0);
      if ($98) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $99
      $1=0;
      __label__ = 28; break;
    case 20: // $100
      __label__ = 27; break;
    case 21: // $101
      var $102=$4;
      var $103=(($102+1)|0);
      var $104=HEAP8[($103)];
      var $105=(($104 << 24) >> 24);
      var $106=(($105)|0)==0;
      if ($106) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $107
      var $108=$4;
      var $109=HEAPU8[($108)];
      var $110=(($109)&255);
      var $111=$2;
      var $112=$111;
      var $113=(($112+76)|0);
      var $114=(($113+$110)|0);
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $126 = $116;__label__ = 24; break;
    case 23: // $117
      var $118=$4;
      var $119=(($118+1)|0);
      var $120=HEAP8[($119)];
      var $121=$4;
      var $122=(($121)|0);
      var $123=HEAP8[($122)];
      var $124=__ZL17unicode_byte_typecc($120, $123);
      var $126 = $124;__label__ = 24; break;
    case 24: // $125
      var $126;
      if ($126 == 5 || $126 == 6 || $126 == 7 || $126 == 29 || $126 == 22 || $126 == 23 || $126 == 24 || $126 == 25 || $126 == 26 || $126 == 27) {
        __label__ = 25; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 25: // $127
      $1=0;
      __label__ = 28; break;
    case 26: // $128
      $1=1;
      __label__ = 28; break;
    case 27: // $129
      __label__ = 1; break;
    case 28: // $130
      var $131=$1;
      ;
      return $131;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16little2_sameNamePK8encodingPKcS3_["X"]=1;

function __ZL18little2_nameLengthPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $start;
      $1=$enc;
      $2=$ptr;
      var $3=$2;
      $start=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5+1)|0);
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24);
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$2;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$1;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $29 = $19;__label__ = 4; break;
    case 3: // $20
      var $21=$2;
      var $22=(($21+1)|0);
      var $23=HEAP8[($22)];
      var $24=$2;
      var $25=(($24)|0);
      var $26=HEAP8[($25)];
      var $27=__ZL17unicode_byte_typecc($23, $26);
      var $29 = $27;__label__ = 4; break;
    case 4: // $28
      var $29;
      if ($29 == 5) {
        __label__ = 5; break;
      }
      else if ($29 == 6) {
        __label__ = 6; break;
      }
      else if ($29 == 7) {
        __label__ = 7; break;
      }
      else if ($29 == 29 || $29 == 22 || $29 == 23 || $29 == 24 || $29 == 25 || $29 == 26 || $29 == 27) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 5: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      $2=$32;
      __label__ = 10; break;
    case 6: // $33
      var $34=$2;
      var $35=(($34+3)|0);
      $2=$35;
      __label__ = 10; break;
    case 7: // $36
      var $37=$2;
      var $38=(($37+4)|0);
      $2=$38;
      __label__ = 10; break;
    case 8: // $39
      var $40=$2;
      var $41=(($40+2)|0);
      $2=$41;
      __label__ = 10; break;
    case 9: // $42
      var $43=$2;
      var $44=$start;
      var $45=$43;
      var $46=$44;
      var $47=(($45-$46)|0);
      ;
      return $47;
    case 10: // $48
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18little2_nameLengthPK8encodingPKc["X"]=1;

function __ZL13little2_skipSPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$enc;
      $2=$ptr;
      __label__ = 1; break;
    case 1: // $3
      var $4=$2;
      var $5=(($4+1)|0);
      var $6=HEAP8[($5)];
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$2;
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$1;
      var $14=$13;
      var $15=(($14+76)|0);
      var $16=(($15+$12)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $28 = $18;__label__ = 4; break;
    case 3: // $19
      var $20=$2;
      var $21=(($20+1)|0);
      var $22=HEAP8[($21)];
      var $23=$2;
      var $24=(($23)|0);
      var $25=HEAP8[($24)];
      var $26=__ZL17unicode_byte_typecc($22, $25);
      var $28 = $26;__label__ = 4; break;
    case 4: // $27
      var $28;
      if ($28 == 10 || $28 == 9 || $28 == 21) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 5: // $29
      var $30=$2;
      var $31=(($30+2)|0);
      $2=$31;
      __label__ = 7; break;
    case 6: // $32
      var $33=$2;
      ;
      return $33;
    case 7: // $34
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15little2_getAttsPK8encodingPKciP9ATTRIBUTE($enc, $ptr, $attsMax, $atts) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $state;
      var $nAtts;
      var $open;
      $1=$enc;
      $2=$ptr;
      $3=$attsMax;
      $4=$atts;
      $state=1;
      $nAtts=0;
      $open=0;
      var $5=$2;
      var $6=(($5+2)|0);
      $2=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$2;
      var $9=(($8+1)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$2;
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$1;
      var $18=$17;
      var $19=(($18+76)|0);
      var $20=(($19+$16)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $32 = $22;__label__ = 4; break;
    case 3: // $23
      var $24=$2;
      var $25=(($24+1)|0);
      var $26=HEAP8[($25)];
      var $27=$2;
      var $28=(($27)|0);
      var $29=HEAP8[($28)];
      var $30=__ZL17unicode_byte_typecc($26, $29);
      var $32 = $30;__label__ = 4; break;
    case 4: // $31
      var $32;
      if ($32 == 5) {
        __label__ = 5; break;
      }
      else if ($32 == 6) {
        __label__ = 10; break;
      }
      else if ($32 == 7) {
        __label__ = 15; break;
      }
      else if ($32 == 29 || $32 == 22 || $32 == 24) {
        __label__ = 20; break;
      }
      else if ($32 == 12) {
        __label__ = 25; break;
      }
      else if ($32 == 13) {
        __label__ = 35; break;
      }
      else if ($32 == 3) {
        __label__ = 45; break;
      }
      else if ($32 == 21) {
        __label__ = 48; break;
      }
      else if ($32 == 9 || $32 == 10) {
        __label__ = 69; break;
      }
      else if ($32 == 11 || $32 == 17) {
        __label__ = 76; break;
      }
      else {
      __label__ = 79; break;
      }
      
    case 5: // $33
      var $34=$state;
      var $35=(($34)|0)==0;
      if ($35) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $36
      var $37=$nAtts;
      var $38=$3;
      var $39=(($37)|0) < (($38)|0);
      if ($39) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $40
      var $41=$2;
      var $42=$nAtts;
      var $43=$4;
      var $44=(($43+($42<<4))|0);
      var $45=(($44)|0);
      HEAP32[(($45)>>2)]=$41;
      var $46=$nAtts;
      var $47=$4;
      var $48=(($47+($46<<4))|0);
      var $49=(($48+12)|0);
      HEAP8[($49)]=1;
      __label__ = 8; break;
    case 8: // $50
      $state=1;
      __label__ = 9; break;
    case 9: // $51
      var $52=$2;
      var $53=(($52)|0);
      $2=$53;
      __label__ = 80; break;
    case 10: // $54
      var $55=$state;
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $57
      var $58=$nAtts;
      var $59=$3;
      var $60=(($58)|0) < (($59)|0);
      if ($60) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $61
      var $62=$2;
      var $63=$nAtts;
      var $64=$4;
      var $65=(($64+($63<<4))|0);
      var $66=(($65)|0);
      HEAP32[(($66)>>2)]=$62;
      var $67=$nAtts;
      var $68=$4;
      var $69=(($68+($67<<4))|0);
      var $70=(($69+12)|0);
      HEAP8[($70)]=1;
      __label__ = 13; break;
    case 13: // $71
      $state=1;
      __label__ = 14; break;
    case 14: // $72
      var $73=$2;
      var $74=(($73+1)|0);
      $2=$74;
      __label__ = 80; break;
    case 15: // $75
      var $76=$state;
      var $77=(($76)|0)==0;
      if ($77) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $78
      var $79=$nAtts;
      var $80=$3;
      var $81=(($79)|0) < (($80)|0);
      if ($81) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $82
      var $83=$2;
      var $84=$nAtts;
      var $85=$4;
      var $86=(($85+($84<<4))|0);
      var $87=(($86)|0);
      HEAP32[(($87)>>2)]=$83;
      var $88=$nAtts;
      var $89=$4;
      var $90=(($89+($88<<4))|0);
      var $91=(($90+12)|0);
      HEAP8[($91)]=1;
      __label__ = 18; break;
    case 18: // $92
      $state=1;
      __label__ = 19; break;
    case 19: // $93
      var $94=$2;
      var $95=(($94+2)|0);
      $2=$95;
      __label__ = 80; break;
    case 20: // $96
      var $97=$state;
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $99
      var $100=$nAtts;
      var $101=$3;
      var $102=(($100)|0) < (($101)|0);
      if ($102) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $103
      var $104=$2;
      var $105=$nAtts;
      var $106=$4;
      var $107=(($106+($105<<4))|0);
      var $108=(($107)|0);
      HEAP32[(($108)>>2)]=$104;
      var $109=$nAtts;
      var $110=$4;
      var $111=(($110+($109<<4))|0);
      var $112=(($111+12)|0);
      HEAP8[($112)]=1;
      __label__ = 23; break;
    case 23: // $113
      $state=1;
      __label__ = 24; break;
    case 24: // $114
      __label__ = 80; break;
    case 25: // $115
      var $116=$state;
      var $117=(($116)|0)!=2;
      if ($117) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $118
      var $119=$nAtts;
      var $120=$3;
      var $121=(($119)|0) < (($120)|0);
      if ($121) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $122
      var $123=$2;
      var $124=(($123+2)|0);
      var $125=$nAtts;
      var $126=$4;
      var $127=(($126+($125<<4))|0);
      var $128=(($127+4)|0);
      HEAP32[(($128)>>2)]=$124;
      __label__ = 28; break;
    case 28: // $129
      $state=2;
      $open=12;
      __label__ = 34; break;
    case 29: // $130
      var $131=$open;
      var $132=(($131)|0)==12;
      if ($132) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $133
      $state=0;
      var $134=$nAtts;
      var $135=$3;
      var $136=(($134)|0) < (($135)|0);
      if ($136) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $137
      var $138=$2;
      var $139=$nAtts;
      var $140=$4;
      var $141=(($140+($139<<4))|0);
      var $142=(($141+8)|0);
      HEAP32[(($142)>>2)]=$138;
      __label__ = 32; break;
    case 32: // $143
      var $144=$nAtts;
      var $145=(($144+1)|0);
      $nAtts=$145;
      __label__ = 33; break;
    case 33: // $146
      __label__ = 34; break;
    case 34: // $147
      __label__ = 80; break;
    case 35: // $148
      var $149=$state;
      var $150=(($149)|0)!=2;
      if ($150) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $151
      var $152=$nAtts;
      var $153=$3;
      var $154=(($152)|0) < (($153)|0);
      if ($154) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $155
      var $156=$2;
      var $157=(($156+2)|0);
      var $158=$nAtts;
      var $159=$4;
      var $160=(($159+($158<<4))|0);
      var $161=(($160+4)|0);
      HEAP32[(($161)>>2)]=$157;
      __label__ = 38; break;
    case 38: // $162
      $state=2;
      $open=13;
      __label__ = 44; break;
    case 39: // $163
      var $164=$open;
      var $165=(($164)|0)==13;
      if ($165) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $166
      $state=0;
      var $167=$nAtts;
      var $168=$3;
      var $169=(($167)|0) < (($168)|0);
      if ($169) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $170
      var $171=$2;
      var $172=$nAtts;
      var $173=$4;
      var $174=(($173+($172<<4))|0);
      var $175=(($174+8)|0);
      HEAP32[(($175)>>2)]=$171;
      __label__ = 42; break;
    case 42: // $176
      var $177=$nAtts;
      var $178=(($177+1)|0);
      $nAtts=$178;
      __label__ = 43; break;
    case 43: // $179
      __label__ = 44; break;
    case 44: // $180
      __label__ = 80; break;
    case 45: // $181
      var $182=$nAtts;
      var $183=$3;
      var $184=(($182)|0) < (($183)|0);
      if ($184) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $185
      var $186=$nAtts;
      var $187=$4;
      var $188=(($187+($186<<4))|0);
      var $189=(($188+12)|0);
      HEAP8[($189)]=0;
      __label__ = 47; break;
    case 47: // $190
      __label__ = 80; break;
    case 48: // $191
      var $192=$state;
      var $193=(($192)|0)==1;
      if ($193) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $194
      $state=0;
      __label__ = 68; break;
    case 50: // $195
      var $196=$state;
      var $197=(($196)|0)==2;
      if ($197) { __label__ = 51; break; } else { __label__ = 67; break; }
    case 51: // $198
      var $199=$nAtts;
      var $200=$3;
      var $201=(($199)|0) < (($200)|0);
      if ($201) { __label__ = 52; break; } else { __label__ = 67; break; }
    case 52: // $202
      var $203=$nAtts;
      var $204=$4;
      var $205=(($204+($203<<4))|0);
      var $206=(($205+12)|0);
      var $207=HEAP8[($206)];
      var $208=(($207 << 24) >> 24)!=0;
      if ($208) { __label__ = 53; break; } else { __label__ = 67; break; }
    case 53: // $209
      var $210=$2;
      var $211=$nAtts;
      var $212=$4;
      var $213=(($212+($211<<4))|0);
      var $214=(($213+4)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(($210)|0)==(($215)|0);
      if ($216) { __label__ = 66; break; } else { __label__ = 54; break; }
    case 54: // $217
      var $218=$2;
      var $219=(($218+1)|0);
      var $220=HEAP8[($219)];
      var $221=(($220 << 24) >> 24);
      var $222=(($221)|0)==0;
      if ($222) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $223
      var $224=$2;
      var $225=(($224)|0);
      var $226=HEAP8[($225)];
      var $227=(($226 << 24) >> 24);
      var $230 = $227;__label__ = 57; break;
    case 56: // $228
      var $230 = -1;__label__ = 57; break;
    case 57: // $229
      var $230;
      var $231=(($230)|0)!=32;
      if ($231) { __label__ = 66; break; } else { __label__ = 58; break; }
    case 58: // $232
      var $233=$2;
      var $234=(($233+2)|0);
      var $235=(($234+1)|0);
      var $236=HEAP8[($235)];
      var $237=(($236 << 24) >> 24);
      var $238=(($237)|0)==0;
      if ($238) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $239
      var $240=$2;
      var $241=(($240+2)|0);
      var $242=(($241)|0);
      var $243=HEAP8[($242)];
      var $244=(($243 << 24) >> 24);
      var $247 = $244;__label__ = 61; break;
    case 60: // $245
      var $247 = -1;__label__ = 61; break;
    case 61: // $246
      var $247;
      var $248=(($247)|0)==32;
      if ($248) { __label__ = 66; break; } else { __label__ = 62; break; }
    case 62: // $249
      var $250=$2;
      var $251=(($250+2)|0);
      var $252=(($251+1)|0);
      var $253=HEAP8[($252)];
      var $254=(($253 << 24) >> 24);
      var $255=(($254)|0)==0;
      if ($255) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $256
      var $257=$2;
      var $258=(($257+2)|0);
      var $259=HEAPU8[($258)];
      var $260=(($259)&255);
      var $261=$1;
      var $262=$261;
      var $263=(($262+76)|0);
      var $264=(($263+$260)|0);
      var $265=HEAPU8[($264)];
      var $266=(($265)&255);
      var $278 = $266;__label__ = 65; break;
    case 64: // $267
      var $268=$2;
      var $269=(($268+2)|0);
      var $270=(($269+1)|0);
      var $271=HEAP8[($270)];
      var $272=$2;
      var $273=(($272+2)|0);
      var $274=(($273)|0);
      var $275=HEAP8[($274)];
      var $276=__ZL17unicode_byte_typecc($271, $275);
      var $278 = $276;__label__ = 65; break;
    case 65: // $277
      var $278;
      var $279=$open;
      var $280=(($278)|0)==(($279)|0);
      if ($280) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $281
      var $282=$nAtts;
      var $283=$4;
      var $284=(($283+($282<<4))|0);
      var $285=(($284+12)|0);
      HEAP8[($285)]=0;
      __label__ = 67; break;
    case 67: // $286
      __label__ = 68; break;
    case 68: // $287
      __label__ = 80; break;
    case 69: // $288
      var $289=$state;
      var $290=(($289)|0)==1;
      if ($290) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $291
      $state=0;
      __label__ = 75; break;
    case 71: // $292
      var $293=$state;
      var $294=(($293)|0)==2;
      if ($294) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $295
      var $296=$nAtts;
      var $297=$3;
      var $298=(($296)|0) < (($297)|0);
      if ($298) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $299
      var $300=$nAtts;
      var $301=$4;
      var $302=(($301+($300<<4))|0);
      var $303=(($302+12)|0);
      HEAP8[($303)]=0;
      __label__ = 74; break;
    case 74: // $304
      __label__ = 75; break;
    case 75: // $305
      __label__ = 80; break;
    case 76: // $306
      var $307=$state;
      var $308=(($307)|0)!=2;
      if ($308) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $309
      var $310=$nAtts;
      ;
      return $310;
    case 78: // $311
      __label__ = 80; break;
    case 79: // $312
      __label__ = 80; break;
    case 80: // $313
      __label__ = 81; break;
    case 81: // $314
      var $315=$2;
      var $316=(($315+2)|0);
      $2=$316;
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15little2_getAttsPK8encodingPKciP9ATTRIBUTE["X"]=1;

function __ZL21little2_charRefNumberPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $c;
      var $c1;
      $2=$enc;
      $3=$ptr;
      $result=0;
      var $4=$3;
      var $5=(($4+4)|0);
      $3=$5;
      var $6=$3;
      var $7=(($6+1)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 18; break; }
    case 1: // $11
      var $12=$3;
      var $13=(($12)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==120;
      if ($16) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $17
      var $18=$3;
      var $19=(($18+2)|0);
      $3=$19;
      __label__ = 3; break;
    case 3: // $20
      var $21=$3;
      var $22=(($21+1)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 4; break; } else { var $33 = 0;__label__ = 5; break; }
    case 4: // $26
      var $27=$3;
      var $28=(($27)|0);
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==59;
      var $33 = $31;__label__ = 5; break;
    case 5: // $32
      var $33;
      var $34=$33 ^ 1;
      if ($34) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $35
      var $36=$3;
      var $37=(($36+1)|0);
      var $38=HEAP8[($37)];
      var $39=(($38 << 24) >> 24);
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      var $42=$3;
      var $43=(($42)|0);
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      var $48 = $45;__label__ = 9; break;
    case 8: // $46
      var $48 = -1;__label__ = 9; break;
    case 9: // $47
      var $48;
      $c=$48;
      var $49=$c;
      if ($49 == 48 || $49 == 49 || $49 == 50 || $49 == 51 || $49 == 52 || $49 == 53 || $49 == 54 || $49 == 55 || $49 == 56 || $49 == 57) {
        __label__ = 10; break;
      }
      else if ($49 == 65 || $49 == 66 || $49 == 67 || $49 == 68 || $49 == 69 || $49 == 70) {
        __label__ = 11; break;
      }
      else if ($49 == 97 || $49 == 98 || $49 == 99 || $49 == 100 || $49 == 101 || $49 == 102) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 10: // $50
      var $51=$result;
      var $52=$51 << 4;
      $result=$52;
      var $53=$c;
      var $54=(($53-48)|0);
      var $55=$result;
      var $56=$55 | $54;
      $result=$56;
      __label__ = 13; break;
    case 11: // $57
      var $58=$result;
      var $59=$58 << 4;
      $result=$59;
      var $60=$c;
      var $61=(($60-65)|0);
      var $62=(($61+10)|0);
      var $63=$result;
      var $64=(($63+$62)|0);
      $result=$64;
      __label__ = 13; break;
    case 12: // $65
      var $66=$result;
      var $67=$66 << 4;
      $result=$67;
      var $68=$c;
      var $69=(($68-97)|0);
      var $70=(($69+10)|0);
      var $71=$result;
      var $72=(($71+$70)|0);
      $result=$72;
      __label__ = 13; break;
    case 13: // $73
      var $74=$result;
      var $75=(($74)|0) >= 1114112;
      if ($75) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $76
      $1=-1;
      __label__ = 31; break;
    case 15: // $77
      __label__ = 16; break;
    case 16: // $78
      var $79=$3;
      var $80=(($79+2)|0);
      $3=$80;
      __label__ = 3; break;
    case 17: // $81
      __label__ = 30; break;
    case 18: // $82
      __label__ = 19; break;
    case 19: // $83
      var $84=$3;
      var $85=(($84+1)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 20; break; } else { var $96 = 0;__label__ = 21; break; }
    case 20: // $89
      var $90=$3;
      var $91=(($90)|0);
      var $92=HEAP8[($91)];
      var $93=(($92 << 24) >> 24);
      var $94=(($93)|0)==59;
      var $96 = $94;__label__ = 21; break;
    case 21: // $95
      var $96;
      var $97=$96 ^ 1;
      if ($97) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $98
      var $99=$3;
      var $100=(($99+1)|0);
      var $101=HEAP8[($100)];
      var $102=(($101 << 24) >> 24);
      var $103=(($102)|0)==0;
      if ($103) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $104
      var $105=$3;
      var $106=(($105)|0);
      var $107=HEAP8[($106)];
      var $108=(($107 << 24) >> 24);
      var $111 = $108;__label__ = 25; break;
    case 24: // $109
      var $111 = -1;__label__ = 25; break;
    case 25: // $110
      var $111;
      $c1=$111;
      var $112=$result;
      var $113=(($112*10)|0);
      $result=$113;
      var $114=$c1;
      var $115=(($114-48)|0);
      var $116=$result;
      var $117=(($116+$115)|0);
      $result=$117;
      var $118=$result;
      var $119=(($118)|0) >= 1114112;
      if ($119) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $120
      $1=-1;
      __label__ = 31; break;
    case 27: // $121
      __label__ = 28; break;
    case 28: // $122
      var $123=$3;
      var $124=(($123+2)|0);
      $3=$124;
      __label__ = 19; break;
    case 29: // $125
      __label__ = 30; break;
    case 30: // $126
      var $127=$result;
      var $128=__ZL18checkCharRefNumberi($127);
      $1=$128;
      __label__ = 31; break;
    case 31: // $129
      var $130=$1;
      ;
      return $130;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21little2_charRefNumberPK8encodingPKc["X"]=1;

function __ZL28little2_predefinedEntityNamePK8encodingPKcS3_($enc, $ptr, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      var $5=$4;
      var $6=$3;
      var $7=$5;
      var $8=$6;
      var $9=(($7-$8)|0);
      var $10=(((($9)|0)/2)|0);
      if ($10 == 2) {
        __label__ = 1; break;
      }
      else if ($10 == 3) {
        __label__ = 11; break;
      }
      else if ($10 == 4) {
        __label__ = 21; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 1: // $11
      var $12=$3;
      var $13=(($12+2)|0);
      var $14=(($13+1)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $18
      var $19=$3;
      var $20=(($19+2)|0);
      var $21=(($20)|0);
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=(($23)|0)==116;
      if ($24) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $25
      var $26=$3;
      var $27=(($26+1)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=$3;
      var $33=(($32)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $38 = $35;__label__ = 6; break;
    case 5: // $36
      var $38 = -1;__label__ = 6; break;
    case 6: // $37
      var $38;
      if ($38 == 108) {
        __label__ = 7; break;
      }
      else if ($38 == 103) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 7: // $39
      $1=60;
      __label__ = 47; break;
    case 8: // $40
      $1=62;
      __label__ = 47; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      __label__ = 46; break;
    case 11: // $43
      var $44=$3;
      var $45=(($44+1)|0);
      var $46=HEAP8[($45)];
      var $47=(($46 << 24) >> 24);
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $49
      var $50=$3;
      var $51=(($50)|0);
      var $52=HEAP8[($51)];
      var $53=(($52 << 24) >> 24);
      var $54=(($53)|0)==97;
      if ($54) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $55
      var $56=$3;
      var $57=(($56+2)|0);
      $3=$57;
      var $58=$3;
      var $59=(($58+1)|0);
      var $60=HEAP8[($59)];
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $63
      var $64=$3;
      var $65=(($64)|0);
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $68=(($67)|0)==109;
      if ($68) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $69
      var $70=$3;
      var $71=(($70+2)|0);
      $3=$71;
      var $72=$3;
      var $73=(($72+1)|0);
      var $74=HEAP8[($73)];
      var $75=(($74 << 24) >> 24);
      var $76=(($75)|0)==0;
      if ($76) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $77
      var $78=$3;
      var $79=(($78)|0);
      var $80=HEAP8[($79)];
      var $81=(($80 << 24) >> 24);
      var $82=(($81)|0)==112;
      if ($82) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $83
      $1=38;
      __label__ = 47; break;
    case 18: // $84
      __label__ = 19; break;
    case 19: // $85
      __label__ = 20; break;
    case 20: // $86
      __label__ = 46; break;
    case 21: // $87
      var $88=$3;
      var $89=(($88+1)|0);
      var $90=HEAP8[($89)];
      var $91=(($90 << 24) >> 24);
      var $92=(($91)|0)==0;
      if ($92) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $93
      var $94=$3;
      var $95=(($94)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24);
      var $100 = $97;__label__ = 24; break;
    case 23: // $98
      var $100 = -1;__label__ = 24; break;
    case 24: // $99
      var $100;
      if ($100 == 113) {
        __label__ = 25; break;
      }
      else if ($100 == 97) {
        __label__ = 35; break;
      }
      else {
      __label__ = 45; break;
      }
      
    case 25: // $101
      var $102=$3;
      var $103=(($102+2)|0);
      $3=$103;
      var $104=$3;
      var $105=(($104+1)|0);
      var $106=HEAP8[($105)];
      var $107=(($106 << 24) >> 24);
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 26; break; } else { __label__ = 34; break; }
    case 26: // $109
      var $110=$3;
      var $111=(($110)|0);
      var $112=HEAP8[($111)];
      var $113=(($112 << 24) >> 24);
      var $114=(($113)|0)==117;
      if ($114) { __label__ = 27; break; } else { __label__ = 34; break; }
    case 27: // $115
      var $116=$3;
      var $117=(($116+2)|0);
      $3=$117;
      var $118=$3;
      var $119=(($118+1)|0);
      var $120=HEAP8[($119)];
      var $121=(($120 << 24) >> 24);
      var $122=(($121)|0)==0;
      if ($122) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $123
      var $124=$3;
      var $125=(($124)|0);
      var $126=HEAP8[($125)];
      var $127=(($126 << 24) >> 24);
      var $128=(($127)|0)==111;
      if ($128) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $129
      var $130=$3;
      var $131=(($130+2)|0);
      $3=$131;
      var $132=$3;
      var $133=(($132+1)|0);
      var $134=HEAP8[($133)];
      var $135=(($134 << 24) >> 24);
      var $136=(($135)|0)==0;
      if ($136) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $137
      var $138=$3;
      var $139=(($138)|0);
      var $140=HEAP8[($139)];
      var $141=(($140 << 24) >> 24);
      var $142=(($141)|0)==116;
      if ($142) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $143
      $1=34;
      __label__ = 47; break;
    case 32: // $144
      __label__ = 33; break;
    case 33: // $145
      __label__ = 34; break;
    case 34: // $146
      __label__ = 45; break;
    case 35: // $147
      var $148=$3;
      var $149=(($148+2)|0);
      $3=$149;
      var $150=$3;
      var $151=(($150+1)|0);
      var $152=HEAP8[($151)];
      var $153=(($152 << 24) >> 24);
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 36; break; } else { __label__ = 44; break; }
    case 36: // $155
      var $156=$3;
      var $157=(($156)|0);
      var $158=HEAP8[($157)];
      var $159=(($158 << 24) >> 24);
      var $160=(($159)|0)==112;
      if ($160) { __label__ = 37; break; } else { __label__ = 44; break; }
    case 37: // $161
      var $162=$3;
      var $163=(($162+2)|0);
      $3=$163;
      var $164=$3;
      var $165=(($164+1)|0);
      var $166=HEAP8[($165)];
      var $167=(($166 << 24) >> 24);
      var $168=(($167)|0)==0;
      if ($168) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $169
      var $170=$3;
      var $171=(($170)|0);
      var $172=HEAP8[($171)];
      var $173=(($172 << 24) >> 24);
      var $174=(($173)|0)==111;
      if ($174) { __label__ = 39; break; } else { __label__ = 43; break; }
    case 39: // $175
      var $176=$3;
      var $177=(($176+2)|0);
      $3=$177;
      var $178=$3;
      var $179=(($178+1)|0);
      var $180=HEAP8[($179)];
      var $181=(($180 << 24) >> 24);
      var $182=(($181)|0)==0;
      if ($182) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $183
      var $184=$3;
      var $185=(($184)|0);
      var $186=HEAP8[($185)];
      var $187=(($186 << 24) >> 24);
      var $188=(($187)|0)==115;
      if ($188) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $189
      $1=39;
      __label__ = 47; break;
    case 42: // $190
      __label__ = 43; break;
    case 43: // $191
      __label__ = 44; break;
    case 44: // $192
      __label__ = 45; break;
    case 45: // $193
      __label__ = 46; break;
    case 46: // $194
      $1=0;
      __label__ = 47; break;
    case 47: // $195
      var $196=$1;
      ;
      return $196;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL28little2_predefinedEntityNamePK8encodingPKcS3_["X"]=1;

function __ZL14little2_toUtf8PK8encodingPPKcS3_PPcS3_($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $from;
      var $plane;
      var $lo2;
      var $lo;
      var $hi;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$2;
      var $7=HEAP32[(($6)>>2)];
      $from=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$from;
      var $10=$3;
      var $11=(($9)|0)!=(($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $12
      var $13=$from;
      var $14=(($13)|0);
      var $15=HEAP8[($14)];
      $lo=$15;
      var $16=$from;
      var $17=(($16+1)|0);
      var $18=HEAP8[($17)];
      $hi=$18;
      var $19=$hi;
      var $20=(($19)&255);
      if ($20 == 0) {
        __label__ = 3; break;
      }
      else if ($20 == 1 || $20 == 2 || $20 == 3 || $20 == 4 || $20 == 5 || $20 == 6 || $20 == 7) {
        __label__ = 8; break;
      }
      else if ($20 == 216 || $20 == 217 || $20 == 218 || $20 == 219) {
        __label__ = 14; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 3: // $21
      var $22=$lo;
      var $23=(($22)&255);
      var $24=(($23)|0) < 128;
      if ($24) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=$5;
      var $29=(($27)|0)==(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$from;
      var $32=$2;
      HEAP32[(($32)>>2)]=$31;
      __label__ = 20; break;
    case 6: // $33
      var $34=$lo;
      var $35=$4;
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      HEAP32[(($35)>>2)]=$37;
      HEAP8[($36)]=$34;
      __label__ = 17; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      var $40=$5;
      var $41=$4;
      var $42=HEAP32[(($41)>>2)];
      var $43=$40;
      var $44=$42;
      var $45=(($43-$44)|0);
      var $46=(($45)|0) < 2;
      if ($46) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $47
      var $48=$from;
      var $49=$2;
      HEAP32[(($49)>>2)]=$48;
      __label__ = 20; break;
    case 10: // $50
      var $51=$lo;
      var $52=(($51)&255);
      var $53=$52 >> 6;
      var $54=$hi;
      var $55=(($54)&255);
      var $56=$55 << 2;
      var $57=$53 | $56;
      var $58=$57 | 192;
      var $59=(($58) & 255);
      var $60=$4;
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+1)|0);
      HEAP32[(($60)>>2)]=$62;
      HEAP8[($61)]=$59;
      var $63=$lo;
      var $64=(($63)&255);
      var $65=$64 & 63;
      var $66=$65 | 128;
      var $67=(($66) & 255);
      var $68=$4;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+1)|0);
      HEAP32[(($68)>>2)]=$70;
      HEAP8[($69)]=$67;
      __label__ = 17; break;
    case 11: // $71
      var $72=$5;
      var $73=$4;
      var $74=HEAP32[(($73)>>2)];
      var $75=$72;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 3;
      if ($78) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $79
      var $80=$from;
      var $81=$2;
      HEAP32[(($81)>>2)]=$80;
      __label__ = 20; break;
    case 13: // $82
      var $83=$hi;
      var $84=(($83)&255);
      var $85=$84 >> 4;
      var $86=$85 | 224;
      var $87=(($86) & 255);
      var $88=$4;
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+1)|0);
      HEAP32[(($88)>>2)]=$90;
      HEAP8[($89)]=$87;
      var $91=$hi;
      var $92=(($91)&255);
      var $93=$92 & 15;
      var $94=$93 << 2;
      var $95=$lo;
      var $96=(($95)&255);
      var $97=$96 >> 6;
      var $98=$94 | $97;
      var $99=$98 | 128;
      var $100=(($99) & 255);
      var $101=$4;
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+1)|0);
      HEAP32[(($101)>>2)]=$103;
      HEAP8[($102)]=$100;
      var $104=$lo;
      var $105=(($104)&255);
      var $106=$105 & 63;
      var $107=$106 | 128;
      var $108=(($107) & 255);
      var $109=$4;
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+1)|0);
      HEAP32[(($109)>>2)]=$111;
      HEAP8[($110)]=$108;
      __label__ = 17; break;
    case 14: // $112
      var $113=$5;
      var $114=$4;
      var $115=HEAP32[(($114)>>2)];
      var $116=$113;
      var $117=$115;
      var $118=(($116-$117)|0);
      var $119=(($118)|0) < 4;
      if ($119) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $120
      var $121=$from;
      var $122=$2;
      HEAP32[(($122)>>2)]=$121;
      __label__ = 20; break;
    case 16: // $123
      var $124=$hi;
      var $125=(($124)&255);
      var $126=$125 & 3;
      var $127=$126 << 2;
      var $128=$lo;
      var $129=(($128)&255);
      var $130=$129 >> 6;
      var $131=$130 & 3;
      var $132=$127 | $131;
      var $133=(($132+1)|0);
      $plane=$133;
      var $134=$plane;
      var $135=$134 >> 2;
      var $136=$135 | 240;
      var $137=(($136) & 255);
      var $138=$4;
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139+1)|0);
      HEAP32[(($138)>>2)]=$140;
      HEAP8[($139)]=$137;
      var $141=$lo;
      var $142=(($141)&255);
      var $143=$142 >> 2;
      var $144=$143 & 15;
      var $145=$plane;
      var $146=$145 & 3;
      var $147=$146 << 4;
      var $148=$144 | $147;
      var $149=$148 | 128;
      var $150=(($149) & 255);
      var $151=$4;
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+1)|0);
      HEAP32[(($151)>>2)]=$153;
      HEAP8[($152)]=$150;
      var $154=$from;
      var $155=(($154+2)|0);
      $from=$155;
      var $156=$from;
      var $157=(($156)|0);
      var $158=HEAP8[($157)];
      $lo2=$158;
      var $159=$lo;
      var $160=(($159)&255);
      var $161=$160 & 3;
      var $162=$161 << 4;
      var $163=$from;
      var $164=(($163+1)|0);
      var $165=HEAPU8[($164)];
      var $166=(($165)&255);
      var $167=$166 & 3;
      var $168=$167 << 2;
      var $169=$162 | $168;
      var $170=$lo2;
      var $171=(($170)&255);
      var $172=$171 >> 6;
      var $173=$169 | $172;
      var $174=$173 | 128;
      var $175=(($174) & 255);
      var $176=$4;
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177+1)|0);
      HEAP32[(($176)>>2)]=$178;
      HEAP8[($177)]=$175;
      var $179=$lo2;
      var $180=(($179)&255);
      var $181=$180 & 63;
      var $182=$181 | 128;
      var $183=(($182) & 255);
      var $184=$4;
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185+1)|0);
      HEAP32[(($184)>>2)]=$186;
      HEAP8[($185)]=$183;
      __label__ = 17; break;
    case 17: // $187
      __label__ = 18; break;
    case 18: // $188
      var $189=$from;
      var $190=(($189+2)|0);
      $from=$190;
      __label__ = 1; break;
    case 19: // $191
      var $192=$from;
      var $193=$2;
      HEAP32[(($193)>>2)]=$192;
      __label__ = 20; break;
    case 20: // $194
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14little2_toUtf8PK8encodingPPKcS3_PPcS3_["X"]=1;

function __ZL22little2_updatePositionPK8encodingPKcS3_P8position($enc, $ptr, $end, $pos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$enc;
      $2=$ptr;
      $3=$end;
      $4=$pos;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($10+1)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$1;
      var $20=$19;
      var $21=(($20+76)|0);
      var $22=(($21+$18)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $34 = $24;__label__ = 5; break;
    case 4: // $25
      var $26=$2;
      var $27=(($26+1)|0);
      var $28=HEAP8[($27)];
      var $29=$2;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=__ZL17unicode_byte_typecc($28, $31);
      var $34 = $32;__label__ = 5; break;
    case 5: // $33
      var $34;
      if ($34 == 5) {
        __label__ = 6; break;
      }
      else if ($34 == 6) {
        __label__ = 7; break;
      }
      else if ($34 == 7) {
        __label__ = 8; break;
      }
      else if ($34 == 10) {
        __label__ = 9; break;
      }
      else if ($34 == 9) {
        __label__ = 10; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 6: // $35
      var $36=$2;
      var $37=(($36+2)|0);
      $2=$37;
      __label__ = 18; break;
    case 7: // $38
      var $39=$2;
      var $40=(($39+3)|0);
      $2=$40;
      __label__ = 18; break;
    case 8: // $41
      var $42=$2;
      var $43=(($42+4)|0);
      $2=$43;
      __label__ = 18; break;
    case 9: // $44
      var $45=$4;
      var $46=(($45+4)|0);
      HEAP32[(($46)>>2)]=-1;
      var $47=$4;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+1)|0);
      HEAP32[(($48)>>2)]=$50;
      var $51=$2;
      var $52=(($51+2)|0);
      $2=$52;
      __label__ = 18; break;
    case 10: // $53
      var $54=$4;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($55)>>2)]=$57;
      var $58=$2;
      var $59=(($58+2)|0);
      $2=$59;
      var $60=$2;
      var $61=$3;
      var $62=(($60)|0)!=(($61)|0);
      if ($62) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $63
      var $64=$2;
      var $65=(($64+1)|0);
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $69
      var $70=$2;
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=$1;
      var $74=$73;
      var $75=(($74+76)|0);
      var $76=(($75+$72)|0);
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $88 = $78;__label__ = 14; break;
    case 13: // $79
      var $80=$2;
      var $81=(($80+1)|0);
      var $82=HEAP8[($81)];
      var $83=$2;
      var $84=(($83)|0);
      var $85=HEAP8[($84)];
      var $86=__ZL17unicode_byte_typecc($82, $85);
      var $88 = $86;__label__ = 14; break;
    case 14: // $87
      var $88;
      var $89=(($88)|0)==10;
      if ($89) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $90
      var $91=$2;
      var $92=(($91+2)|0);
      $2=$92;
      __label__ = 16; break;
    case 16: // $93
      var $94=$4;
      var $95=(($94+4)|0);
      HEAP32[(($95)>>2)]=-1;
      __label__ = 18; break;
    case 17: // $96
      var $97=$2;
      var $98=(($97+2)|0);
      $2=$98;
      __label__ = 18; break;
    case 18: // $99
      var $100=$4;
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+1)|0);
      HEAP32[(($101)>>2)]=$103;
      __label__ = 1; break;
    case 19: // $104
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22little2_updatePositionPK8encodingPKcS3_P8position["X"]=1;

function __ZL18little2_isPublicIdPK8encodingPKcS3_PS3_($enc, $ptr, $end, $badPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$badPtr;
      var $6=$3;
      var $7=(($6+2)|0);
      $3=$7;
      var $8=$4;
      var $9=(($8-2)|0);
      $4=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$3;
      var $12=$4;
      var $13=(($11)|0)!=(($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 26; break; }
    case 2: // $14
      var $15=$3;
      var $16=(($15+1)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$3;
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$2;
      var $25=$24;
      var $26=(($25+76)|0);
      var $27=(($26+$23)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      var $39 = $29;__label__ = 5; break;
    case 4: // $30
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=$3;
      var $35=(($34)|0);
      var $36=HEAP8[($35)];
      var $37=__ZL17unicode_byte_typecc($33, $36);
      var $39 = $37;__label__ = 5; break;
    case 5: // $38
      var $39;
      if ($39 == 25 || $39 == 24 || $39 == 27 || $39 == 13 || $39 == 31 || $39 == 32 || $39 == 34 || $39 == 35 || $39 == 17 || $39 == 14 || $39 == 15 || $39 == 9 || $39 == 10 || $39 == 18 || $39 == 16 || $39 == 33 || $39 == 30 || $39 == 19 || $39 == 23) {
        __label__ = 6; break;
      }
      else if ($39 == 21) {
        __label__ = 7; break;
      }
      else if ($39 == 26 || $39 == 22) {
        __label__ = 11; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 6: // $40
      __label__ = 24; break;
    case 7: // $41
      var $42=$3;
      var $43=(($42+1)|0);
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      var $46=(($45)|0)==0;
      if ($46) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $47
      var $48=$3;
      var $49=(($48)|0);
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24);
      var $52=(($51)|0)==9;
      if ($52) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $53
      var $54=$3;
      var $55=$5;
      HEAP32[(($55)>>2)]=$54;
      $1=0;
      __label__ = 27; break;
    case 10: // $56
      __label__ = 24; break;
    case 11: // $57
      var $58=$3;
      var $59=(($58+1)|0);
      var $60=HEAP8[($59)];
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $63
      var $64=$3;
      var $65=(($64)|0);
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $70 = $67;__label__ = 14; break;
    case 13: // $68
      var $70 = -1;__label__ = 14; break;
    case 14: // $69
      var $70;
      var $71=$70 & -128;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $73
      __label__ = 24; break;
    case 16: // $74
      __label__ = 17; break;
    case 17: // $75
      var $76=$3;
      var $77=(($76+1)|0);
      var $78=HEAP8[($77)];
      var $79=(($78 << 24) >> 24);
      var $80=(($79)|0)==0;
      if ($80) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $81
      var $82=$3;
      var $83=(($82)|0);
      var $84=HEAP8[($83)];
      var $85=(($84 << 24) >> 24);
      var $88 = $85;__label__ = 20; break;
    case 19: // $86
      var $88 = -1;__label__ = 20; break;
    case 20: // $87
      var $88;
      if ($88 == 36 || $88 == 64) {
        __label__ = 21; break;
      }
      else {
      __label__ = 22; break;
      }
      
    case 21: // $89
      __label__ = 23; break;
    case 22: // $90
      var $91=$3;
      var $92=$5;
      HEAP32[(($92)>>2)]=$91;
      $1=0;
      __label__ = 27; break;
    case 23: // $93
      __label__ = 24; break;
    case 24: // $94
      __label__ = 25; break;
    case 25: // $95
      var $96=$3;
      var $97=(($96+2)|0);
      $3=$97;
      __label__ = 1; break;
    case 26: // $98
      $1=1;
      __label__ = 27; break;
    case 27: // $99
      var $100=$1;
      ;
      return $100;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18little2_isPublicIdPK8encodingPKcS3_PS3_["X"]=1;

function __ZL17unicode_byte_typecc($hi, $lo) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$hi;
      $3=$lo;
      var $4=$2;
      var $5=(($4)&255);
      if ($5 == 216 || $5 == 217 || $5 == 218 || $5 == 219) {
        __label__ = 1; break;
      }
      else if ($5 == 220 || $5 == 221 || $5 == 222 || $5 == 223) {
        __label__ = 2; break;
      }
      else if ($5 == 255) {
        __label__ = 3; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 1: // $6
      $1=7;
      __label__ = 7; break;
    case 2: // $7
      $1=8;
      __label__ = 7; break;
    case 3: // $8
      var $9=$3;
      var $10=(($9)&255);
      if ($10 == 255 || $10 == 254) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 4: // $11
      $1=0;
      __label__ = 7; break;
    case 5: // $12
      __label__ = 6; break;
    case 6: // $13
      $1=29;
      __label__ = 7; break;
    case 7: // $14
      var $15=$1;
      ;
      return $15;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15little2_toUtf16PK8encodingPPKcS3_PPtPKt($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$3;
      var $7=$2;
      var $8=HEAP32[(($7)>>2)];
      var $9=$6;
      var $10=$8;
      var $11=(($9-$10)|0);
      var $12=$5;
      var $13=$4;
      var $14=HEAP32[(($13)>>2)];
      var $15=$12;
      var $16=$14;
      var $17=(($15-$16)|0);
      var $18=(((($17)|0)/2)|0);
      var $19=$18 << 1;
      var $20=(($11)|0) > (($19)|0);
      if ($20) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $21
      var $22=$3;
      var $23=(($22-2)|0);
      var $24=(($23+1)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & 248;
      var $28=(($27)|0)==216;
      if ($28) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $29
      var $30=$3;
      var $31=(($30-2)|0);
      $3=$31;
      __label__ = 3; break;
    case 3: // $32
      __label__ = 4; break;
    case 4: // $33
      var $34=$2;
      var $35=HEAP32[(($34)>>2)];
      var $36=$3;
      var $37=(($35)|0)!=(($36)|0);
      if ($37) { __label__ = 5; break; } else { var $44 = 0;__label__ = 6; break; }
    case 5: // $38
      var $39=$4;
      var $40=HEAP32[(($39)>>2)];
      var $41=$5;
      var $42=(($40)|0)!=(($41)|0);
      var $44 = $42;__label__ = 6; break;
    case 6: // $43
      var $44;
      if ($44) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $45
      var $46=$2;
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+1)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 << 8;
      var $52=$2;
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$51 | $56;
      var $58=(($57) & 65535);
      var $59=$4;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+2)|0);
      HEAP32[(($59)>>2)]=$61;
      HEAP16[(($60)>>1)]=$58;
      __label__ = 8; break;
    case 8: // $62
      var $63=$2;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+2)|0);
      HEAP32[(($63)>>2)]=$65;
      __label__ = 4; break;
    case 9: // $66
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15little2_toUtf16PK8encodingPPKcS3_PPtPKt["X"]=1;

function __ZL15little2_scanRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 44; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 29) {
        __label__ = 6; break;
      }
      else if ($35 == 22 || $35 == 24) {
        __label__ = 9; break;
      }
      else if ($35 == 5) {
        __label__ = 10; break;
      }
      else if ($35 == 6) {
        __label__ = 13; break;
      }
      else if ($35 == 7) {
        __label__ = 16; break;
      }
      else if ($35 == 19) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 6: // $36
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=((STRING_TABLE.__ZL11nmstrtPages+$40)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$43 << 3;
      var $45=$3;
      var $46=(($45)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 >> 5;
      var $50=(($44+$49)|0);
      var $51=((__ZL12namingBitmap+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 31;
      var $58=1 << $57;
      var $59=$52 & $58;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=$3;
      var $63=$5;
      HEAP32[(($63)>>2)]=$62;
      $1=0;
      __label__ = 44; break;
    case 8: // $64
      __label__ = 9; break;
    case 9: // $65
      var $66=$3;
      var $67=(($66+2)|0);
      $3=$67;
      __label__ = 21; break;
    case 10: // $68
      var $69=$4;
      var $70=$3;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 2;
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      $1=-2;
      __label__ = 44; break;
    case 12: // $76
      var $77=$3;
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=0;
      __label__ = 44; break;
    case 13: // $79
      var $80=$4;
      var $81=$3;
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 3;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      $1=-2;
      __label__ = 44; break;
    case 15: // $87
      var $88=$3;
      var $89=$5;
      HEAP32[(($89)>>2)]=$88;
      $1=0;
      __label__ = 44; break;
    case 16: // $90
      var $91=$4;
      var $92=$3;
      var $93=$91;
      var $94=$92;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 4;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      $1=-2;
      __label__ = 44; break;
    case 18: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 44; break;
    case 19: // $101
      var $102=$2;
      var $103=$3;
      var $104=(($103+2)|0);
      var $105=$4;
      var $106=$5;
      var $107=__ZL19little2_scanCharRefPK8encodingPKcS3_PS3_($102, $104, $105, $106);
      $1=$107;
      __label__ = 44; break;
    case 20: // $108
      var $109=$3;
      var $110=$5;
      HEAP32[(($110)>>2)]=$109;
      $1=0;
      __label__ = 44; break;
    case 21: // $111
      __label__ = 22; break;
    case 22: // $112
      var $113=$3;
      var $114=$4;
      var $115=(($113)|0)!=(($114)|0);
      if ($115) { __label__ = 23; break; } else { __label__ = 43; break; }
    case 23: // $116
      var $117=$3;
      var $118=(($117+1)|0);
      var $119=HEAP8[($118)];
      var $120=(($119 << 24) >> 24);
      var $121=(($120)|0)==0;
      if ($121) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $122
      var $123=$3;
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $126=$2;
      var $127=$126;
      var $128=(($127+76)|0);
      var $129=(($128+$125)|0);
      var $130=HEAPU8[($129)];
      var $131=(($130)&255);
      var $141 = $131;__label__ = 26; break;
    case 25: // $132
      var $133=$3;
      var $134=(($133+1)|0);
      var $135=HEAP8[($134)];
      var $136=$3;
      var $137=(($136)|0);
      var $138=HEAP8[($137)];
      var $139=__ZL17unicode_byte_typecc($135, $138);
      var $141 = $139;__label__ = 26; break;
    case 26: // $140
      var $141;
      if ($141 == 29) {
        __label__ = 27; break;
      }
      else if ($141 == 22 || $141 == 24 || $141 == 25 || $141 == 26 || $141 == 27) {
        __label__ = 30; break;
      }
      else if ($141 == 5) {
        __label__ = 31; break;
      }
      else if ($141 == 6) {
        __label__ = 34; break;
      }
      else if ($141 == 7) {
        __label__ = 37; break;
      }
      else if ($141 == 18) {
        __label__ = 40; break;
      }
      else {
      __label__ = 41; break;
      }
      
    case 27: // $142
      var $143=$3;
      var $144=(($143+1)|0);
      var $145=HEAPU8[($144)];
      var $146=(($145)&255);
      var $147=((STRING_TABLE.__ZL9namePages+$146)|0);
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 << 3;
      var $151=$3;
      var $152=(($151)|0);
      var $153=HEAPU8[($152)];
      var $154=(($153)&255);
      var $155=$154 >> 5;
      var $156=(($150+$155)|0);
      var $157=((__ZL12namingBitmap+($156<<2))|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$3;
      var $160=(($159)|0);
      var $161=HEAPU8[($160)];
      var $162=(($161)&255);
      var $163=$162 & 31;
      var $164=1 << $163;
      var $165=$158 & $164;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $167
      var $168=$3;
      var $169=$5;
      HEAP32[(($169)>>2)]=$168;
      $1=0;
      __label__ = 44; break;
    case 29: // $170
      __label__ = 30; break;
    case 30: // $171
      var $172=$3;
      var $173=(($172+2)|0);
      $3=$173;
      __label__ = 42; break;
    case 31: // $174
      var $175=$4;
      var $176=$3;
      var $177=$175;
      var $178=$176;
      var $179=(($177-$178)|0);
      var $180=(($179)|0) < 2;
      if ($180) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $181
      $1=-2;
      __label__ = 44; break;
    case 33: // $182
      var $183=$3;
      var $184=$5;
      HEAP32[(($184)>>2)]=$183;
      $1=0;
      __label__ = 44; break;
    case 34: // $185
      var $186=$4;
      var $187=$3;
      var $188=$186;
      var $189=$187;
      var $190=(($188-$189)|0);
      var $191=(($190)|0) < 3;
      if ($191) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $192
      $1=-2;
      __label__ = 44; break;
    case 36: // $193
      var $194=$3;
      var $195=$5;
      HEAP32[(($195)>>2)]=$194;
      $1=0;
      __label__ = 44; break;
    case 37: // $196
      var $197=$4;
      var $198=$3;
      var $199=$197;
      var $200=$198;
      var $201=(($199-$200)|0);
      var $202=(($201)|0) < 4;
      if ($202) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $203
      $1=-2;
      __label__ = 44; break;
    case 39: // $204
      var $205=$3;
      var $206=$5;
      HEAP32[(($206)>>2)]=$205;
      $1=0;
      __label__ = 44; break;
    case 40: // $207
      var $208=$3;
      var $209=(($208+2)|0);
      var $210=$5;
      HEAP32[(($210)>>2)]=$209;
      $1=9;
      __label__ = 44; break;
    case 41: // $211
      var $212=$3;
      var $213=$5;
      HEAP32[(($213)>>2)]=$212;
      $1=0;
      __label__ = 44; break;
    case 42: // $214
      __label__ = 22; break;
    case 43: // $215
      $1=-1;
      __label__ = 44; break;
    case 44: // $216
      var $217=$1;
      ;
      return $217;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15little2_scanRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL19little2_scanPercentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-22;
      __label__ = 44; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 29) {
        __label__ = 6; break;
      }
      else if ($35 == 22 || $35 == 24) {
        __label__ = 9; break;
      }
      else if ($35 == 5) {
        __label__ = 10; break;
      }
      else if ($35 == 6) {
        __label__ = 13; break;
      }
      else if ($35 == 7) {
        __label__ = 16; break;
      }
      else if ($35 == 21 || $35 == 10 || $35 == 9 || $35 == 30) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 6: // $36
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=((STRING_TABLE.__ZL11nmstrtPages+$40)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$43 << 3;
      var $45=$3;
      var $46=(($45)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 >> 5;
      var $50=(($44+$49)|0);
      var $51=((__ZL12namingBitmap+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 31;
      var $58=1 << $57;
      var $59=$52 & $58;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=$3;
      var $63=$5;
      HEAP32[(($63)>>2)]=$62;
      $1=0;
      __label__ = 44; break;
    case 8: // $64
      __label__ = 9; break;
    case 9: // $65
      var $66=$3;
      var $67=(($66+2)|0);
      $3=$67;
      __label__ = 21; break;
    case 10: // $68
      var $69=$4;
      var $70=$3;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 2;
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      $1=-2;
      __label__ = 44; break;
    case 12: // $76
      var $77=$3;
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=0;
      __label__ = 44; break;
    case 13: // $79
      var $80=$4;
      var $81=$3;
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 3;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      $1=-2;
      __label__ = 44; break;
    case 15: // $87
      var $88=$3;
      var $89=$5;
      HEAP32[(($89)>>2)]=$88;
      $1=0;
      __label__ = 44; break;
    case 16: // $90
      var $91=$4;
      var $92=$3;
      var $93=$91;
      var $94=$92;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 4;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      $1=-2;
      __label__ = 44; break;
    case 18: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 44; break;
    case 19: // $101
      var $102=$3;
      var $103=$5;
      HEAP32[(($103)>>2)]=$102;
      $1=22;
      __label__ = 44; break;
    case 20: // $104
      var $105=$3;
      var $106=$5;
      HEAP32[(($106)>>2)]=$105;
      $1=0;
      __label__ = 44; break;
    case 21: // $107
      __label__ = 22; break;
    case 22: // $108
      var $109=$3;
      var $110=$4;
      var $111=(($109)|0)!=(($110)|0);
      if ($111) { __label__ = 23; break; } else { __label__ = 43; break; }
    case 23: // $112
      var $113=$3;
      var $114=(($113+1)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24);
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $118
      var $119=$3;
      var $120=HEAPU8[($119)];
      var $121=(($120)&255);
      var $122=$2;
      var $123=$122;
      var $124=(($123+76)|0);
      var $125=(($124+$121)|0);
      var $126=HEAPU8[($125)];
      var $127=(($126)&255);
      var $137 = $127;__label__ = 26; break;
    case 25: // $128
      var $129=$3;
      var $130=(($129+1)|0);
      var $131=HEAP8[($130)];
      var $132=$3;
      var $133=(($132)|0);
      var $134=HEAP8[($133)];
      var $135=__ZL17unicode_byte_typecc($131, $134);
      var $137 = $135;__label__ = 26; break;
    case 26: // $136
      var $137;
      if ($137 == 29) {
        __label__ = 27; break;
      }
      else if ($137 == 22 || $137 == 24 || $137 == 25 || $137 == 26 || $137 == 27) {
        __label__ = 30; break;
      }
      else if ($137 == 5) {
        __label__ = 31; break;
      }
      else if ($137 == 6) {
        __label__ = 34; break;
      }
      else if ($137 == 7) {
        __label__ = 37; break;
      }
      else if ($137 == 18) {
        __label__ = 40; break;
      }
      else {
      __label__ = 41; break;
      }
      
    case 27: // $138
      var $139=$3;
      var $140=(($139+1)|0);
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=((STRING_TABLE.__ZL9namePages+$142)|0);
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=$145 << 3;
      var $147=$3;
      var $148=(($147)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$150 >> 5;
      var $152=(($146+$151)|0);
      var $153=((__ZL12namingBitmap+($152<<2))|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$3;
      var $156=(($155)|0);
      var $157=HEAPU8[($156)];
      var $158=(($157)&255);
      var $159=$158 & 31;
      var $160=1 << $159;
      var $161=$154 & $160;
      var $162=(($161)|0)!=0;
      if ($162) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $163
      var $164=$3;
      var $165=$5;
      HEAP32[(($165)>>2)]=$164;
      $1=0;
      __label__ = 44; break;
    case 29: // $166
      __label__ = 30; break;
    case 30: // $167
      var $168=$3;
      var $169=(($168+2)|0);
      $3=$169;
      __label__ = 42; break;
    case 31: // $170
      var $171=$4;
      var $172=$3;
      var $173=$171;
      var $174=$172;
      var $175=(($173-$174)|0);
      var $176=(($175)|0) < 2;
      if ($176) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $177
      $1=-2;
      __label__ = 44; break;
    case 33: // $178
      var $179=$3;
      var $180=$5;
      HEAP32[(($180)>>2)]=$179;
      $1=0;
      __label__ = 44; break;
    case 34: // $181
      var $182=$4;
      var $183=$3;
      var $184=$182;
      var $185=$183;
      var $186=(($184-$185)|0);
      var $187=(($186)|0) < 3;
      if ($187) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $188
      $1=-2;
      __label__ = 44; break;
    case 36: // $189
      var $190=$3;
      var $191=$5;
      HEAP32[(($191)>>2)]=$190;
      $1=0;
      __label__ = 44; break;
    case 37: // $192
      var $193=$4;
      var $194=$3;
      var $195=$193;
      var $196=$194;
      var $197=(($195-$196)|0);
      var $198=(($197)|0) < 4;
      if ($198) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $199
      $1=-2;
      __label__ = 44; break;
    case 39: // $200
      var $201=$3;
      var $202=$5;
      HEAP32[(($202)>>2)]=$201;
      $1=0;
      __label__ = 44; break;
    case 40: // $203
      var $204=$3;
      var $205=(($204+2)|0);
      var $206=$5;
      HEAP32[(($206)>>2)]=$205;
      $1=28;
      __label__ = 44; break;
    case 41: // $207
      var $208=$3;
      var $209=$5;
      HEAP32[(($209)>>2)]=$208;
      $1=0;
      __label__ = 44; break;
    case 42: // $210
      __label__ = 22; break;
    case 43: // $211
      $1=-1;
      __label__ = 44; break;
    case 44: // $212
      var $213=$1;
      ;
      return $213;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19little2_scanPercentPK8encodingPKcS3_PS3_["X"]=1;

function __ZL19little2_scanCharRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10+1)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $15
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==120;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$2;
      var $23=$3;
      var $24=(($23+2)|0);
      var $25=$4;
      var $26=$5;
      var $27=__ZL22little2_scanHexCharRefPK8encodingPKcS3_PS3_($22, $24, $25, $26);
      $1=$27;
      __label__ = 21; break;
    case 4: // $28
      var $29=$3;
      var $30=(($29+1)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24);
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$3;
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$2;
      var $39=$38;
      var $40=(($39+76)|0);
      var $41=(($40+$37)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $53 = $43;__label__ = 7; break;
    case 6: // $44
      var $45=$3;
      var $46=(($45+1)|0);
      var $47=HEAP8[($46)];
      var $48=$3;
      var $49=(($48)|0);
      var $50=HEAP8[($49)];
      var $51=__ZL17unicode_byte_typecc($47, $50);
      var $53 = $51;__label__ = 7; break;
    case 7: // $52
      var $53;
      if ($53 == 25) {
        __label__ = 9; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 8: // $54
      var $55=$3;
      var $56=$5;
      HEAP32[(($56)>>2)]=$55;
      $1=0;
      __label__ = 21; break;
    case 9: // $57
      var $58=$3;
      var $59=(($58+2)|0);
      $3=$59;
      __label__ = 10; break;
    case 10: // $60
      var $61=$3;
      var $62=$4;
      var $63=(($61)|0)!=(($62)|0);
      if ($63) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $64
      var $65=$3;
      var $66=(($65+1)|0);
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24);
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $70
      var $71=$3;
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=$2;
      var $75=$74;
      var $76=(($75+76)|0);
      var $77=(($76+$73)|0);
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $89 = $79;__label__ = 14; break;
    case 13: // $80
      var $81=$3;
      var $82=(($81+1)|0);
      var $83=HEAP8[($82)];
      var $84=$3;
      var $85=(($84)|0);
      var $86=HEAP8[($85)];
      var $87=__ZL17unicode_byte_typecc($83, $86);
      var $89 = $87;__label__ = 14; break;
    case 14: // $88
      var $89;
      if ($89 == 25) {
        __label__ = 17; break;
      }
      else if ($89 == 18) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 15: // $90
      var $91=$3;
      var $92=(($91+2)|0);
      var $93=$5;
      HEAP32[(($93)>>2)]=$92;
      $1=10;
      __label__ = 21; break;
    case 16: // $94
      var $95=$3;
      var $96=$5;
      HEAP32[(($96)>>2)]=$95;
      $1=0;
      __label__ = 21; break;
    case 17: // $97
      __label__ = 18; break;
    case 18: // $98
      var $99=$3;
      var $100=(($99+2)|0);
      $3=$100;
      __label__ = 10; break;
    case 19: // $101
      __label__ = 20; break;
    case 20: // $102
      $1=-1;
      __label__ = 21; break;
    case 21: // $103
      var $104=$1;
      ;
      return $104;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19little2_scanCharRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL22little2_scanHexCharRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 19; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10+1)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$3;
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$2;
      var $20=$19;
      var $21=(($20+76)|0);
      var $22=(($21+$18)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $34 = $24;__label__ = 4; break;
    case 3: // $25
      var $26=$3;
      var $27=(($26+1)|0);
      var $28=HEAP8[($27)];
      var $29=$3;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=__ZL17unicode_byte_typecc($28, $31);
      var $34 = $32;__label__ = 4; break;
    case 4: // $33
      var $34;
      if ($34 == 25 || $34 == 24) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 5: // $35
      __label__ = 7; break;
    case 6: // $36
      var $37=$3;
      var $38=$5;
      HEAP32[(($38)>>2)]=$37;
      $1=0;
      __label__ = 20; break;
    case 7: // $39
      var $40=$3;
      var $41=(($40+2)|0);
      $3=$41;
      __label__ = 8; break;
    case 8: // $42
      var $43=$3;
      var $44=$4;
      var $45=(($43)|0)!=(($44)|0);
      if ($45) { __label__ = 9; break; } else { __label__ = 18; break; }
    case 9: // $46
      var $47=$3;
      var $48=(($47+1)|0);
      var $49=HEAP8[($48)];
      var $50=(($49 << 24) >> 24);
      var $51=(($50)|0)==0;
      if ($51) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $52
      var $53=$3;
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$2;
      var $57=$56;
      var $58=(($57+76)|0);
      var $59=(($58+$55)|0);
      var $60=HEAPU8[($59)];
      var $61=(($60)&255);
      var $71 = $61;__label__ = 12; break;
    case 11: // $62
      var $63=$3;
      var $64=(($63+1)|0);
      var $65=HEAP8[($64)];
      var $66=$3;
      var $67=(($66)|0);
      var $68=HEAP8[($67)];
      var $69=__ZL17unicode_byte_typecc($65, $68);
      var $71 = $69;__label__ = 12; break;
    case 12: // $70
      var $71;
      if ($71 == 25 || $71 == 24) {
        __label__ = 13; break;
      }
      else if ($71 == 18) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 13: // $72
      __label__ = 16; break;
    case 14: // $73
      var $74=$3;
      var $75=(($74+2)|0);
      var $76=$5;
      HEAP32[(($76)>>2)]=$75;
      $1=10;
      __label__ = 20; break;
    case 15: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 20; break;
    case 16: // $80
      __label__ = 17; break;
    case 17: // $81
      var $82=$3;
      var $83=(($82+2)|0);
      $3=$83;
      __label__ = 8; break;
    case 18: // $84
      __label__ = 19; break;
    case 19: // $85
      $1=-1;
      __label__ = 20; break;
    case 20: // $86
      var $87=$1;
      ;
      return $87;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22little2_scanHexCharRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL14little2_scanLtPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $hadColon;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 110; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 29) {
        __label__ = 6; break;
      }
      else if ($35 == 22 || $35 == 24) {
        __label__ = 9; break;
      }
      else if ($35 == 5) {
        __label__ = 10; break;
      }
      else if ($35 == 6) {
        __label__ = 13; break;
      }
      else if ($35 == 7) {
        __label__ = 16; break;
      }
      else if ($35 == 16) {
        __label__ = 19; break;
      }
      else if ($35 == 15) {
        __label__ = 28; break;
      }
      else if ($35 == 17) {
        __label__ = 29; break;
      }
      else {
      __label__ = 30; break;
      }
      
    case 6: // $36
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=((STRING_TABLE.__ZL11nmstrtPages+$40)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$43 << 3;
      var $45=$3;
      var $46=(($45)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 >> 5;
      var $50=(($44+$49)|0);
      var $51=((__ZL12namingBitmap+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 31;
      var $58=1 << $57;
      var $59=$52 & $58;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=$3;
      var $63=$5;
      HEAP32[(($63)>>2)]=$62;
      $1=0;
      __label__ = 110; break;
    case 8: // $64
      __label__ = 9; break;
    case 9: // $65
      var $66=$3;
      var $67=(($66+2)|0);
      $3=$67;
      __label__ = 31; break;
    case 10: // $68
      var $69=$4;
      var $70=$3;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 2;
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      $1=-2;
      __label__ = 110; break;
    case 12: // $76
      var $77=$3;
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=0;
      __label__ = 110; break;
    case 13: // $79
      var $80=$4;
      var $81=$3;
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 3;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      $1=-2;
      __label__ = 110; break;
    case 15: // $87
      var $88=$3;
      var $89=$5;
      HEAP32[(($89)>>2)]=$88;
      $1=0;
      __label__ = 110; break;
    case 16: // $90
      var $91=$4;
      var $92=$3;
      var $93=$91;
      var $94=$92;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 4;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      $1=-2;
      __label__ = 110; break;
    case 18: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 110; break;
    case 19: // $101
      var $102=$3;
      var $103=(($102+2)|0);
      $3=$103;
      var $104=$4;
      var $105=(($103)|0)==(($104)|0);
      if ($105) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $106
      $1=-1;
      __label__ = 110; break;
    case 21: // $107
      var $108=$3;
      var $109=(($108+1)|0);
      var $110=HEAP8[($109)];
      var $111=(($110 << 24) >> 24);
      var $112=(($111)|0)==0;
      if ($112) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $113
      var $114=$3;
      var $115=HEAPU8[($114)];
      var $116=(($115)&255);
      var $117=$2;
      var $118=$117;
      var $119=(($118+76)|0);
      var $120=(($119+$116)|0);
      var $121=HEAPU8[($120)];
      var $122=(($121)&255);
      var $132 = $122;__label__ = 24; break;
    case 23: // $123
      var $124=$3;
      var $125=(($124+1)|0);
      var $126=HEAP8[($125)];
      var $127=$3;
      var $128=(($127)|0);
      var $129=HEAP8[($128)];
      var $130=__ZL17unicode_byte_typecc($126, $129);
      var $132 = $130;__label__ = 24; break;
    case 24: // $131
      var $132;
      if ($132 == 27) {
        __label__ = 25; break;
      }
      else if ($132 == 20) {
        __label__ = 26; break;
      }
      else {
      __label__ = 27; break;
      }
      
    case 25: // $133
      var $134=$2;
      var $135=$3;
      var $136=(($135+2)|0);
      var $137=$4;
      var $138=$5;
      var $139=__ZL19little2_scanCommentPK8encodingPKcS3_PS3_($134, $136, $137, $138);
      $1=$139;
      __label__ = 110; break;
    case 26: // $140
      var $141=$2;
      var $142=$3;
      var $143=(($142+2)|0);
      var $144=$4;
      var $145=$5;
      var $146=__ZL24little2_scanCdataSectionPK8encodingPKcS3_PS3_($141, $143, $144, $145);
      $1=$146;
      __label__ = 110; break;
    case 27: // $147
      var $148=$3;
      var $149=$5;
      HEAP32[(($149)>>2)]=$148;
      $1=0;
      __label__ = 110; break;
    case 28: // $150
      var $151=$2;
      var $152=$3;
      var $153=(($152+2)|0);
      var $154=$4;
      var $155=$5;
      var $156=__ZL14little2_scanPiPK8encodingPKcS3_PS3_($151, $153, $154, $155);
      $1=$156;
      __label__ = 110; break;
    case 29: // $157
      var $158=$2;
      var $159=$3;
      var $160=(($159+2)|0);
      var $161=$4;
      var $162=$5;
      var $163=__ZL18little2_scanEndTagPK8encodingPKcS3_PS3_($158, $160, $161, $162);
      $1=$163;
      __label__ = 110; break;
    case 30: // $164
      var $165=$3;
      var $166=$5;
      HEAP32[(($166)>>2)]=$165;
      $1=0;
      __label__ = 110; break;
    case 31: // $167
      $hadColon=0;
      __label__ = 32; break;
    case 32: // $168
      var $169=$3;
      var $170=$4;
      var $171=(($169)|0)!=(($170)|0);
      if ($171) { __label__ = 33; break; } else { __label__ = 109; break; }
    case 33: // $172
      var $173=$3;
      var $174=(($173+1)|0);
      var $175=HEAP8[($174)];
      var $176=(($175 << 24) >> 24);
      var $177=(($176)|0)==0;
      if ($177) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $178
      var $179=$3;
      var $180=HEAPU8[($179)];
      var $181=(($180)&255);
      var $182=$2;
      var $183=$182;
      var $184=(($183+76)|0);
      var $185=(($184+$181)|0);
      var $186=HEAPU8[($185)];
      var $187=(($186)&255);
      var $197 = $187;__label__ = 36; break;
    case 35: // $188
      var $189=$3;
      var $190=(($189+1)|0);
      var $191=HEAP8[($190)];
      var $192=$3;
      var $193=(($192)|0);
      var $194=HEAP8[($193)];
      var $195=__ZL17unicode_byte_typecc($191, $194);
      var $197 = $195;__label__ = 36; break;
    case 36: // $196
      var $197;
      if ($197 == 29) {
        __label__ = 37; break;
      }
      else if ($197 == 22 || $197 == 24 || $197 == 25 || $197 == 26 || $197 == 27) {
        __label__ = 40; break;
      }
      else if ($197 == 5) {
        __label__ = 41; break;
      }
      else if ($197 == 6) {
        __label__ = 44; break;
      }
      else if ($197 == 7) {
        __label__ = 47; break;
      }
      else if ($197 == 23) {
        __label__ = 50; break;
      }
      else if ($197 == 21 || $197 == 9 || $197 == 10) {
        __label__ = 73; break;
      }
      else if ($197 == 11) {
        __label__ = 98; break;
      }
      else if ($197 == 17) {
        __label__ = 100; break;
      }
      else {
      __label__ = 107; break;
      }
      
    case 37: // $198
      var $199=$3;
      var $200=(($199+1)|0);
      var $201=HEAPU8[($200)];
      var $202=(($201)&255);
      var $203=((STRING_TABLE.__ZL9namePages+$202)|0);
      var $204=HEAPU8[($203)];
      var $205=(($204)&255);
      var $206=$205 << 3;
      var $207=$3;
      var $208=(($207)|0);
      var $209=HEAPU8[($208)];
      var $210=(($209)&255);
      var $211=$210 >> 5;
      var $212=(($206+$211)|0);
      var $213=((__ZL12namingBitmap+($212<<2))|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=$3;
      var $216=(($215)|0);
      var $217=HEAPU8[($216)];
      var $218=(($217)&255);
      var $219=$218 & 31;
      var $220=1 << $219;
      var $221=$214 & $220;
      var $222=(($221)|0)!=0;
      if ($222) { __label__ = 39; break; } else { __label__ = 38; break; }
    case 38: // $223
      var $224=$3;
      var $225=$5;
      HEAP32[(($225)>>2)]=$224;
      $1=0;
      __label__ = 110; break;
    case 39: // $226
      __label__ = 40; break;
    case 40: // $227
      var $228=$3;
      var $229=(($228+2)|0);
      $3=$229;
      __label__ = 108; break;
    case 41: // $230
      var $231=$4;
      var $232=$3;
      var $233=$231;
      var $234=$232;
      var $235=(($233-$234)|0);
      var $236=(($235)|0) < 2;
      if ($236) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $237
      $1=-2;
      __label__ = 110; break;
    case 43: // $238
      var $239=$3;
      var $240=$5;
      HEAP32[(($240)>>2)]=$239;
      $1=0;
      __label__ = 110; break;
    case 44: // $241
      var $242=$4;
      var $243=$3;
      var $244=$242;
      var $245=$243;
      var $246=(($244-$245)|0);
      var $247=(($246)|0) < 3;
      if ($247) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $248
      $1=-2;
      __label__ = 110; break;
    case 46: // $249
      var $250=$3;
      var $251=$5;
      HEAP32[(($251)>>2)]=$250;
      $1=0;
      __label__ = 110; break;
    case 47: // $252
      var $253=$4;
      var $254=$3;
      var $255=$253;
      var $256=$254;
      var $257=(($255-$256)|0);
      var $258=(($257)|0) < 4;
      if ($258) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $259
      $1=-2;
      __label__ = 110; break;
    case 49: // $260
      var $261=$3;
      var $262=$5;
      HEAP32[(($262)>>2)]=$261;
      $1=0;
      __label__ = 110; break;
    case 50: // $263
      var $264=$hadColon;
      var $265=(($264)|0)!=0;
      if ($265) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $266
      var $267=$3;
      var $268=$5;
      HEAP32[(($268)>>2)]=$267;
      $1=0;
      __label__ = 110; break;
    case 52: // $269
      $hadColon=1;
      var $270=$3;
      var $271=(($270+2)|0);
      $3=$271;
      var $272=$3;
      var $273=$4;
      var $274=(($272)|0)==(($273)|0);
      if ($274) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $275
      $1=-1;
      __label__ = 110; break;
    case 54: // $276
      var $277=$3;
      var $278=(($277+1)|0);
      var $279=HEAP8[($278)];
      var $280=(($279 << 24) >> 24);
      var $281=(($280)|0)==0;
      if ($281) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $282
      var $283=$3;
      var $284=HEAPU8[($283)];
      var $285=(($284)&255);
      var $286=$2;
      var $287=$286;
      var $288=(($287+76)|0);
      var $289=(($288+$285)|0);
      var $290=HEAPU8[($289)];
      var $291=(($290)&255);
      var $301 = $291;__label__ = 57; break;
    case 56: // $292
      var $293=$3;
      var $294=(($293+1)|0);
      var $295=HEAP8[($294)];
      var $296=$3;
      var $297=(($296)|0);
      var $298=HEAP8[($297)];
      var $299=__ZL17unicode_byte_typecc($295, $298);
      var $301 = $299;__label__ = 57; break;
    case 57: // $300
      var $301;
      if ($301 == 29) {
        __label__ = 58; break;
      }
      else if ($301 == 22 || $301 == 24) {
        __label__ = 61; break;
      }
      else if ($301 == 5) {
        __label__ = 62; break;
      }
      else if ($301 == 6) {
        __label__ = 65; break;
      }
      else if ($301 == 7) {
        __label__ = 68; break;
      }
      else {
      __label__ = 71; break;
      }
      
    case 58: // $302
      var $303=$3;
      var $304=(($303+1)|0);
      var $305=HEAPU8[($304)];
      var $306=(($305)&255);
      var $307=((STRING_TABLE.__ZL11nmstrtPages+$306)|0);
      var $308=HEAPU8[($307)];
      var $309=(($308)&255);
      var $310=$309 << 3;
      var $311=$3;
      var $312=(($311)|0);
      var $313=HEAPU8[($312)];
      var $314=(($313)&255);
      var $315=$314 >> 5;
      var $316=(($310+$315)|0);
      var $317=((__ZL12namingBitmap+($316<<2))|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=$3;
      var $320=(($319)|0);
      var $321=HEAPU8[($320)];
      var $322=(($321)&255);
      var $323=$322 & 31;
      var $324=1 << $323;
      var $325=$318 & $324;
      var $326=(($325)|0)!=0;
      if ($326) { __label__ = 60; break; } else { __label__ = 59; break; }
    case 59: // $327
      var $328=$3;
      var $329=$5;
      HEAP32[(($329)>>2)]=$328;
      $1=0;
      __label__ = 110; break;
    case 60: // $330
      __label__ = 61; break;
    case 61: // $331
      var $332=$3;
      var $333=(($332+2)|0);
      $3=$333;
      __label__ = 72; break;
    case 62: // $334
      var $335=$4;
      var $336=$3;
      var $337=$335;
      var $338=$336;
      var $339=(($337-$338)|0);
      var $340=(($339)|0) < 2;
      if ($340) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $341
      $1=-2;
      __label__ = 110; break;
    case 64: // $342
      var $343=$3;
      var $344=$5;
      HEAP32[(($344)>>2)]=$343;
      $1=0;
      __label__ = 110; break;
    case 65: // $345
      var $346=$4;
      var $347=$3;
      var $348=$346;
      var $349=$347;
      var $350=(($348-$349)|0);
      var $351=(($350)|0) < 3;
      if ($351) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $352
      $1=-2;
      __label__ = 110; break;
    case 67: // $353
      var $354=$3;
      var $355=$5;
      HEAP32[(($355)>>2)]=$354;
      $1=0;
      __label__ = 110; break;
    case 68: // $356
      var $357=$4;
      var $358=$3;
      var $359=$357;
      var $360=$358;
      var $361=(($359-$360)|0);
      var $362=(($361)|0) < 4;
      if ($362) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $363
      $1=-2;
      __label__ = 110; break;
    case 70: // $364
      var $365=$3;
      var $366=$5;
      HEAP32[(($366)>>2)]=$365;
      $1=0;
      __label__ = 110; break;
    case 71: // $367
      var $368=$3;
      var $369=$5;
      HEAP32[(($369)>>2)]=$368;
      $1=0;
      __label__ = 110; break;
    case 72: // $370
      __label__ = 108; break;
    case 73: // $371
      var $372=$3;
      var $373=(($372+2)|0);
      $3=$373;
      __label__ = 74; break;
    case 74: // $374
      var $375=$3;
      var $376=$4;
      var $377=(($375)|0)!=(($376)|0);
      if ($377) { __label__ = 75; break; } else { __label__ = 97; break; }
    case 75: // $378
      var $379=$3;
      var $380=(($379+1)|0);
      var $381=HEAP8[($380)];
      var $382=(($381 << 24) >> 24);
      var $383=(($382)|0)==0;
      if ($383) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $384
      var $385=$3;
      var $386=HEAPU8[($385)];
      var $387=(($386)&255);
      var $388=$2;
      var $389=$388;
      var $390=(($389+76)|0);
      var $391=(($390+$387)|0);
      var $392=HEAPU8[($391)];
      var $393=(($392)&255);
      var $403 = $393;__label__ = 78; break;
    case 77: // $394
      var $395=$3;
      var $396=(($395+1)|0);
      var $397=HEAP8[($396)];
      var $398=$3;
      var $399=(($398)|0);
      var $400=HEAP8[($399)];
      var $401=__ZL17unicode_byte_typecc($397, $400);
      var $403 = $401;__label__ = 78; break;
    case 78: // $402
      var $403;
      if ($403 == 29) {
        __label__ = 79; break;
      }
      else if ($403 == 22 || $403 == 24) {
        __label__ = 82; break;
      }
      else if ($403 == 5) {
        __label__ = 83; break;
      }
      else if ($403 == 6) {
        __label__ = 86; break;
      }
      else if ($403 == 7) {
        __label__ = 89; break;
      }
      else if ($403 == 11) {
        __label__ = 92; break;
      }
      else if ($403 == 17) {
        __label__ = 93; break;
      }
      else if ($403 == 21 || $403 == 9 || $403 == 10) {
        __label__ = 94; break;
      }
      else {
      __label__ = 95; break;
      }
      
    case 79: // $404
      var $405=$3;
      var $406=(($405+1)|0);
      var $407=HEAPU8[($406)];
      var $408=(($407)&255);
      var $409=((STRING_TABLE.__ZL11nmstrtPages+$408)|0);
      var $410=HEAPU8[($409)];
      var $411=(($410)&255);
      var $412=$411 << 3;
      var $413=$3;
      var $414=(($413)|0);
      var $415=HEAPU8[($414)];
      var $416=(($415)&255);
      var $417=$416 >> 5;
      var $418=(($412+$417)|0);
      var $419=((__ZL12namingBitmap+($418<<2))|0);
      var $420=HEAP32[(($419)>>2)];
      var $421=$3;
      var $422=(($421)|0);
      var $423=HEAPU8[($422)];
      var $424=(($423)&255);
      var $425=$424 & 31;
      var $426=1 << $425;
      var $427=$420 & $426;
      var $428=(($427)|0)!=0;
      if ($428) { __label__ = 81; break; } else { __label__ = 80; break; }
    case 80: // $429
      var $430=$3;
      var $431=$5;
      HEAP32[(($431)>>2)]=$430;
      $1=0;
      __label__ = 110; break;
    case 81: // $432
      __label__ = 82; break;
    case 82: // $433
      var $434=$3;
      var $435=(($434+2)|0);
      $3=$435;
      __label__ = 96; break;
    case 83: // $436
      var $437=$4;
      var $438=$3;
      var $439=$437;
      var $440=$438;
      var $441=(($439-$440)|0);
      var $442=(($441)|0) < 2;
      if ($442) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $443
      $1=-2;
      __label__ = 110; break;
    case 85: // $444
      var $445=$3;
      var $446=$5;
      HEAP32[(($446)>>2)]=$445;
      $1=0;
      __label__ = 110; break;
    case 86: // $447
      var $448=$4;
      var $449=$3;
      var $450=$448;
      var $451=$449;
      var $452=(($450-$451)|0);
      var $453=(($452)|0) < 3;
      if ($453) { __label__ = 87; break; } else { __label__ = 88; break; }
    case 87: // $454
      $1=-2;
      __label__ = 110; break;
    case 88: // $455
      var $456=$3;
      var $457=$5;
      HEAP32[(($457)>>2)]=$456;
      $1=0;
      __label__ = 110; break;
    case 89: // $458
      var $459=$4;
      var $460=$3;
      var $461=$459;
      var $462=$460;
      var $463=(($461-$462)|0);
      var $464=(($463)|0) < 4;
      if ($464) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $465
      $1=-2;
      __label__ = 110; break;
    case 91: // $466
      var $467=$3;
      var $468=$5;
      HEAP32[(($468)>>2)]=$467;
      $1=0;
      __label__ = 110; break;
    case 92: // $469
      __label__ = 99; break;
    case 93: // $470
      __label__ = 101; break;
    case 94: // $471
      var $472=$3;
      var $473=(($472+2)|0);
      $3=$473;
      __label__ = 74; break;
    case 95: // $474
      var $475=$3;
      var $476=$5;
      HEAP32[(($476)>>2)]=$475;
      $1=0;
      __label__ = 110; break;
    case 96: // $477
      var $478=$2;
      var $479=$3;
      var $480=$4;
      var $481=$5;
      var $482=__ZL16little2_scanAttsPK8encodingPKcS3_PS3_($478, $479, $480, $481);
      $1=$482;
      __label__ = 110; break;
    case 97: // $483
      $1=-1;
      __label__ = 110; break;
    case 98: // $484
      __label__ = 99; break;
    case 99: // $485
      var $486=$3;
      var $487=(($486+2)|0);
      var $488=$5;
      HEAP32[(($488)>>2)]=$487;
      $1=2;
      __label__ = 110; break;
    case 100: // $489
      __label__ = 101; break;
    case 101: // $490
      var $491=$3;
      var $492=(($491+2)|0);
      $3=$492;
      var $493=$3;
      var $494=$4;
      var $495=(($493)|0)==(($494)|0);
      if ($495) { __label__ = 102; break; } else { __label__ = 103; break; }
    case 102: // $496
      $1=-1;
      __label__ = 110; break;
    case 103: // $497
      var $498=$3;
      var $499=(($498+1)|0);
      var $500=HEAP8[($499)];
      var $501=(($500 << 24) >> 24);
      var $502=(($501)|0)==0;
      if ($502) { __label__ = 104; break; } else { __label__ = 105; break; }
    case 104: // $503
      var $504=$3;
      var $505=(($504)|0);
      var $506=HEAP8[($505)];
      var $507=(($506 << 24) >> 24);
      var $508=(($507)|0)==62;
      if ($508) { __label__ = 106; break; } else { __label__ = 105; break; }
    case 105: // $509
      var $510=$3;
      var $511=$5;
      HEAP32[(($511)>>2)]=$510;
      $1=0;
      __label__ = 110; break;
    case 106: // $512
      var $513=$3;
      var $514=(($513+2)|0);
      var $515=$5;
      HEAP32[(($515)>>2)]=$514;
      $1=4;
      __label__ = 110; break;
    case 107: // $516
      var $517=$3;
      var $518=$5;
      HEAP32[(($518)>>2)]=$517;
      $1=0;
      __label__ = 110; break;
    case 108: // $519
      __label__ = 32; break;
    case 109: // $520
      $1=-1;
      __label__ = 110; break;
    case 110: // $521
      var $522=$1;
      ;
      return $522;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14little2_scanLtPK8encodingPKcS3_PS3_["X"]=1;

function __ZL24little2_scanCdataSectionPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $i;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$4;
      var $7=$3;
      var $8=$6;
      var $9=$7;
      var $10=(($8-$9)|0);
      var $11=(($10)|0) < 12;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $1=-1;
      __label__ = 10; break;
    case 2: // $13
      $i=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$i;
      var $16=(($15)|0) < 6;
      if ($16) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18+1)|0);
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$3;
      var $25=(($24)|0);
      var $26=HEAP8[($25)];
      var $27=(($26 << 24) >> 24);
      var $28=$i;
      var $29=((STRING_TABLE.__ZZL24little2_scanCdataSectionPK8encodingPKcS3_PS3_E10CDATA_LSQB+$28)|0);
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24);
      var $32=(($27)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $34=$3;
      var $35=$5;
      HEAP32[(($35)>>2)]=$34;
      $1=0;
      __label__ = 10; break;
    case 7: // $36
      __label__ = 8; break;
    case 8: // $37
      var $38=$i;
      var $39=(($38+1)|0);
      $i=$39;
      var $40=$3;
      var $41=(($40+2)|0);
      $3=$41;
      __label__ = 3; break;
    case 9: // $42
      var $43=$3;
      var $44=$5;
      HEAP32[(($44)>>2)]=$43;
      $1=8;
      __label__ = 10; break;
    case 10: // $45
      var $46=$1;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL24little2_scanCdataSectionPK8encodingPKcS3_PS3_["X"]=1;

function __ZL19little2_scanCommentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 34; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10+1)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==45;
      if ($20) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $21
      var $22=$3;
      var $23=$5;
      HEAP32[(($23)>>2)]=$22;
      $1=0;
      __label__ = 35; break;
    case 4: // $24
      var $25=$3;
      var $26=(($25+2)|0);
      $3=$26;
      __label__ = 5; break;
    case 5: // $27
      var $28=$3;
      var $29=$4;
      var $30=(($28)|0)!=(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 33; break; }
    case 6: // $31
      var $32=$3;
      var $33=(($32+1)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $37
      var $38=$3;
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=$2;
      var $42=$41;
      var $43=(($42+76)|0);
      var $44=(($43+$40)|0);
      var $45=HEAPU8[($44)];
      var $46=(($45)&255);
      var $56 = $46;__label__ = 9; break;
    case 8: // $47
      var $48=$3;
      var $49=(($48+1)|0);
      var $50=HEAP8[($49)];
      var $51=$3;
      var $52=(($51)|0);
      var $53=HEAP8[($52)];
      var $54=__ZL17unicode_byte_typecc($50, $53);
      var $56 = $54;__label__ = 9; break;
    case 9: // $55
      var $56;
      if ($56 == 5) {
        __label__ = 10; break;
      }
      else if ($56 == 6) {
        __label__ = 13; break;
      }
      else if ($56 == 7) {
        __label__ = 16; break;
      }
      else if ($56 == 0 || $56 == 1 || $56 == 8) {
        __label__ = 19; break;
      }
      else if ($56 == 27) {
        __label__ = 20; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 10: // $57
      var $58=$4;
      var $59=$3;
      var $60=$58;
      var $61=$59;
      var $62=(($60-$61)|0);
      var $63=(($62)|0) < 2;
      if ($63) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $64
      $1=-2;
      __label__ = 35; break;
    case 12: // $65
      var $66=$3;
      var $67=(($66+2)|0);
      $3=$67;
      __label__ = 32; break;
    case 13: // $68
      var $69=$4;
      var $70=$3;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 3;
      if ($74) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $75
      $1=-2;
      __label__ = 35; break;
    case 15: // $76
      var $77=$3;
      var $78=(($77+3)|0);
      $3=$78;
      __label__ = 32; break;
    case 16: // $79
      var $80=$4;
      var $81=$3;
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 4;
      if ($85) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $86
      $1=-2;
      __label__ = 35; break;
    case 18: // $87
      var $88=$3;
      var $89=(($88+4)|0);
      $3=$89;
      __label__ = 32; break;
    case 19: // $90
      var $91=$3;
      var $92=$5;
      HEAP32[(($92)>>2)]=$91;
      $1=0;
      __label__ = 35; break;
    case 20: // $93
      var $94=$3;
      var $95=(($94+2)|0);
      $3=$95;
      var $96=$4;
      var $97=(($95)|0)==(($96)|0);
      if ($97) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $98
      $1=-1;
      __label__ = 35; break;
    case 22: // $99
      var $100=$3;
      var $101=(($100+1)|0);
      var $102=HEAP8[($101)];
      var $103=(($102 << 24) >> 24);
      var $104=(($103)|0)==0;
      if ($104) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $105
      var $106=$3;
      var $107=(($106)|0);
      var $108=HEAP8[($107)];
      var $109=(($108 << 24) >> 24);
      var $110=(($109)|0)==45;
      if ($110) { __label__ = 24; break; } else { __label__ = 30; break; }
    case 24: // $111
      var $112=$3;
      var $113=(($112+2)|0);
      $3=$113;
      var $114=$4;
      var $115=(($113)|0)==(($114)|0);
      if ($115) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $116
      $1=-1;
      __label__ = 35; break;
    case 26: // $117
      var $118=$3;
      var $119=(($118+1)|0);
      var $120=HEAP8[($119)];
      var $121=(($120 << 24) >> 24);
      var $122=(($121)|0)==0;
      if ($122) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $123
      var $124=$3;
      var $125=(($124)|0);
      var $126=HEAP8[($125)];
      var $127=(($126 << 24) >> 24);
      var $128=(($127)|0)==62;
      if ($128) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $129
      var $130=$3;
      var $131=$5;
      HEAP32[(($131)>>2)]=$130;
      $1=0;
      __label__ = 35; break;
    case 29: // $132
      var $133=$3;
      var $134=(($133+2)|0);
      var $135=$5;
      HEAP32[(($135)>>2)]=$134;
      $1=13;
      __label__ = 35; break;
    case 30: // $136
      __label__ = 32; break;
    case 31: // $137
      var $138=$3;
      var $139=(($138+2)|0);
      $3=$139;
      __label__ = 32; break;
    case 32: // $140
      __label__ = 5; break;
    case 33: // $141
      __label__ = 34; break;
    case 34: // $142
      $1=-1;
      __label__ = 35; break;
    case 35: // $143
      var $144=$1;
      ;
      return $144;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19little2_scanCommentPK8encodingPKcS3_PS3_["X"]=1;

function __ZL14little2_scanPiPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tok=__stackBase__;
      var $target;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      $target=$6;
      var $7=$3;
      var $8=$4;
      var $9=(($7)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=-1;
      __label__ = 77; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12+1)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$3;
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28+1)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 6: // $37
      var $38=$3;
      var $39=(($38+1)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL11nmstrtPages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=$3;
      var $47=(($46)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 77; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 20; break;
    case 10: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 77; break;
    case 12: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 77; break;
    case 13: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 77; break;
    case 15: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 77; break;
    case 16: // $91
      var $92=$4;
      var $93=$3;
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 77; break;
    case 18: // $99
      var $100=$3;
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 77; break;
    case 19: // $102
      var $103=$3;
      var $104=$5;
      HEAP32[(($104)>>2)]=$103;
      $1=0;
      __label__ = 77; break;
    case 20: // $105
      __label__ = 21; break;
    case 21: // $106
      var $107=$3;
      var $108=$4;
      var $109=(($107)|0)!=(($108)|0);
      if ($109) { __label__ = 22; break; } else { __label__ = 76; break; }
    case 22: // $110
      var $111=$3;
      var $112=(($111+1)|0);
      var $113=HEAP8[($112)];
      var $114=(($113 << 24) >> 24);
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $116
      var $117=$3;
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$2;
      var $121=$120;
      var $122=(($121+76)|0);
      var $123=(($122+$119)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $135 = $125;__label__ = 25; break;
    case 24: // $126
      var $127=$3;
      var $128=(($127+1)|0);
      var $129=HEAP8[($128)];
      var $130=$3;
      var $131=(($130)|0);
      var $132=HEAP8[($131)];
      var $133=__ZL17unicode_byte_typecc($129, $132);
      var $135 = $133;__label__ = 25; break;
    case 25: // $134
      var $135;
      if ($135 == 29) {
        __label__ = 26; break;
      }
      else if ($135 == 22 || $135 == 24 || $135 == 25 || $135 == 26 || $135 == 27) {
        __label__ = 29; break;
      }
      else if ($135 == 5) {
        __label__ = 30; break;
      }
      else if ($135 == 6) {
        __label__ = 33; break;
      }
      else if ($135 == 7) {
        __label__ = 36; break;
      }
      else if ($135 == 21 || $135 == 9 || $135 == 10) {
        __label__ = 39; break;
      }
      else if ($135 == 15) {
        __label__ = 66; break;
      }
      else {
      __label__ = 74; break;
      }
      
    case 26: // $136
      var $137=$3;
      var $138=(($137+1)|0);
      var $139=HEAPU8[($138)];
      var $140=(($139)&255);
      var $141=((STRING_TABLE.__ZL9namePages+$140)|0);
      var $142=HEAPU8[($141)];
      var $143=(($142)&255);
      var $144=$143 << 3;
      var $145=$3;
      var $146=(($145)|0);
      var $147=HEAPU8[($146)];
      var $148=(($147)&255);
      var $149=$148 >> 5;
      var $150=(($144+$149)|0);
      var $151=((__ZL12namingBitmap+($150<<2))|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$3;
      var $154=(($153)|0);
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$156 & 31;
      var $158=1 << $157;
      var $159=$152 & $158;
      var $160=(($159)|0)!=0;
      if ($160) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $161
      var $162=$3;
      var $163=$5;
      HEAP32[(($163)>>2)]=$162;
      $1=0;
      __label__ = 77; break;
    case 28: // $164
      __label__ = 29; break;
    case 29: // $165
      var $166=$3;
      var $167=(($166+2)|0);
      $3=$167;
      __label__ = 75; break;
    case 30: // $168
      var $169=$4;
      var $170=$3;
      var $171=$169;
      var $172=$170;
      var $173=(($171-$172)|0);
      var $174=(($173)|0) < 2;
      if ($174) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $175
      $1=-2;
      __label__ = 77; break;
    case 32: // $176
      var $177=$3;
      var $178=$5;
      HEAP32[(($178)>>2)]=$177;
      $1=0;
      __label__ = 77; break;
    case 33: // $179
      var $180=$4;
      var $181=$3;
      var $182=$180;
      var $183=$181;
      var $184=(($182-$183)|0);
      var $185=(($184)|0) < 3;
      if ($185) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $186
      $1=-2;
      __label__ = 77; break;
    case 35: // $187
      var $188=$3;
      var $189=$5;
      HEAP32[(($189)>>2)]=$188;
      $1=0;
      __label__ = 77; break;
    case 36: // $190
      var $191=$4;
      var $192=$3;
      var $193=$191;
      var $194=$192;
      var $195=(($193-$194)|0);
      var $196=(($195)|0) < 4;
      if ($196) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $197
      $1=-2;
      __label__ = 77; break;
    case 38: // $198
      var $199=$3;
      var $200=$5;
      HEAP32[(($200)>>2)]=$199;
      $1=0;
      __label__ = 77; break;
    case 39: // $201
      var $202=$2;
      var $203=$target;
      var $204=$3;
      var $205=__ZL21little2_checkPiTargetPK8encodingPKcS3_Pi($202, $203, $204, $tok);
      var $206=(($205)|0)!=0;
      if ($206) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $207
      var $208=$3;
      var $209=$5;
      HEAP32[(($209)>>2)]=$208;
      $1=0;
      __label__ = 77; break;
    case 41: // $210
      var $211=$3;
      var $212=(($211+2)|0);
      $3=$212;
      __label__ = 42; break;
    case 42: // $213
      var $214=$3;
      var $215=$4;
      var $216=(($214)|0)!=(($215)|0);
      if ($216) { __label__ = 43; break; } else { __label__ = 65; break; }
    case 43: // $217
      var $218=$3;
      var $219=(($218+1)|0);
      var $220=HEAP8[($219)];
      var $221=(($220 << 24) >> 24);
      var $222=(($221)|0)==0;
      if ($222) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $223
      var $224=$3;
      var $225=HEAPU8[($224)];
      var $226=(($225)&255);
      var $227=$2;
      var $228=$227;
      var $229=(($228+76)|0);
      var $230=(($229+$226)|0);
      var $231=HEAPU8[($230)];
      var $232=(($231)&255);
      var $242 = $232;__label__ = 46; break;
    case 45: // $233
      var $234=$3;
      var $235=(($234+1)|0);
      var $236=HEAP8[($235)];
      var $237=$3;
      var $238=(($237)|0);
      var $239=HEAP8[($238)];
      var $240=__ZL17unicode_byte_typecc($236, $239);
      var $242 = $240;__label__ = 46; break;
    case 46: // $241
      var $242;
      if ($242 == 5) {
        __label__ = 47; break;
      }
      else if ($242 == 6) {
        __label__ = 50; break;
      }
      else if ($242 == 7) {
        __label__ = 53; break;
      }
      else if ($242 == 0 || $242 == 1 || $242 == 8) {
        __label__ = 56; break;
      }
      else if ($242 == 15) {
        __label__ = 57; break;
      }
      else {
      __label__ = 63; break;
      }
      
    case 47: // $243
      var $244=$4;
      var $245=$3;
      var $246=$244;
      var $247=$245;
      var $248=(($246-$247)|0);
      var $249=(($248)|0) < 2;
      if ($249) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $250
      $1=-2;
      __label__ = 77; break;
    case 49: // $251
      var $252=$3;
      var $253=(($252+2)|0);
      $3=$253;
      __label__ = 64; break;
    case 50: // $254
      var $255=$4;
      var $256=$3;
      var $257=$255;
      var $258=$256;
      var $259=(($257-$258)|0);
      var $260=(($259)|0) < 3;
      if ($260) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $261
      $1=-2;
      __label__ = 77; break;
    case 52: // $262
      var $263=$3;
      var $264=(($263+3)|0);
      $3=$264;
      __label__ = 64; break;
    case 53: // $265
      var $266=$4;
      var $267=$3;
      var $268=$266;
      var $269=$267;
      var $270=(($268-$269)|0);
      var $271=(($270)|0) < 4;
      if ($271) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $272
      $1=-2;
      __label__ = 77; break;
    case 55: // $273
      var $274=$3;
      var $275=(($274+4)|0);
      $3=$275;
      __label__ = 64; break;
    case 56: // $276
      var $277=$3;
      var $278=$5;
      HEAP32[(($278)>>2)]=$277;
      $1=0;
      __label__ = 77; break;
    case 57: // $279
      var $280=$3;
      var $281=(($280+2)|0);
      $3=$281;
      var $282=$3;
      var $283=$4;
      var $284=(($282)|0)==(($283)|0);
      if ($284) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $285
      $1=-1;
      __label__ = 77; break;
    case 59: // $286
      var $287=$3;
      var $288=(($287+1)|0);
      var $289=HEAP8[($288)];
      var $290=(($289 << 24) >> 24);
      var $291=(($290)|0)==0;
      if ($291) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $292
      var $293=$3;
      var $294=(($293)|0);
      var $295=HEAP8[($294)];
      var $296=(($295 << 24) >> 24);
      var $297=(($296)|0)==62;
      if ($297) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $298
      var $299=$3;
      var $300=(($299+2)|0);
      var $301=$5;
      HEAP32[(($301)>>2)]=$300;
      var $302=HEAP32[(($tok)>>2)];
      $1=$302;
      __label__ = 77; break;
    case 62: // $303
      __label__ = 64; break;
    case 63: // $304
      var $305=$3;
      var $306=(($305+2)|0);
      $3=$306;
      __label__ = 64; break;
    case 64: // $307
      __label__ = 42; break;
    case 65: // $308
      $1=-1;
      __label__ = 77; break;
    case 66: // $309
      var $310=$2;
      var $311=$target;
      var $312=$3;
      var $313=__ZL21little2_checkPiTargetPK8encodingPKcS3_Pi($310, $311, $312, $tok);
      var $314=(($313)|0)!=0;
      if ($314) { __label__ = 68; break; } else { __label__ = 67; break; }
    case 67: // $315
      var $316=$3;
      var $317=$5;
      HEAP32[(($317)>>2)]=$316;
      $1=0;
      __label__ = 77; break;
    case 68: // $318
      var $319=$3;
      var $320=(($319+2)|0);
      $3=$320;
      var $321=$3;
      var $322=$4;
      var $323=(($321)|0)==(($322)|0);
      if ($323) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $324
      $1=-1;
      __label__ = 77; break;
    case 70: // $325
      var $326=$3;
      var $327=(($326+1)|0);
      var $328=HEAP8[($327)];
      var $329=(($328 << 24) >> 24);
      var $330=(($329)|0)==0;
      if ($330) { __label__ = 71; break; } else { __label__ = 73; break; }
    case 71: // $331
      var $332=$3;
      var $333=(($332)|0);
      var $334=HEAP8[($333)];
      var $335=(($334 << 24) >> 24);
      var $336=(($335)|0)==62;
      if ($336) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $337
      var $338=$3;
      var $339=(($338+2)|0);
      var $340=$5;
      HEAP32[(($340)>>2)]=$339;
      var $341=HEAP32[(($tok)>>2)];
      $1=$341;
      __label__ = 77; break;
    case 73: // $342
      __label__ = 74; break;
    case 74: // $343
      var $344=$3;
      var $345=$5;
      HEAP32[(($345)>>2)]=$344;
      $1=0;
      __label__ = 77; break;
    case 75: // $346
      __label__ = 21; break;
    case 76: // $347
      $1=-1;
      __label__ = 77; break;
    case 77: // $348
      var $349=$1;
      STACKTOP = __stackBase__;
      return $349;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14little2_scanPiPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18little2_scanEndTagPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 56; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 29) {
        __label__ = 6; break;
      }
      else if ($35 == 22 || $35 == 24) {
        __label__ = 9; break;
      }
      else if ($35 == 5) {
        __label__ = 10; break;
      }
      else if ($35 == 6) {
        __label__ = 13; break;
      }
      else if ($35 == 7) {
        __label__ = 16; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 6: // $36
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=((STRING_TABLE.__ZL11nmstrtPages+$40)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$43 << 3;
      var $45=$3;
      var $46=(($45)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 >> 5;
      var $50=(($44+$49)|0);
      var $51=((__ZL12namingBitmap+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 31;
      var $58=1 << $57;
      var $59=$52 & $58;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=$3;
      var $63=$5;
      HEAP32[(($63)>>2)]=$62;
      $1=0;
      __label__ = 56; break;
    case 8: // $64
      __label__ = 9; break;
    case 9: // $65
      var $66=$3;
      var $67=(($66+2)|0);
      $3=$67;
      __label__ = 20; break;
    case 10: // $68
      var $69=$4;
      var $70=$3;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 2;
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      $1=-2;
      __label__ = 56; break;
    case 12: // $76
      var $77=$3;
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=0;
      __label__ = 56; break;
    case 13: // $79
      var $80=$4;
      var $81=$3;
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 3;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      $1=-2;
      __label__ = 56; break;
    case 15: // $87
      var $88=$3;
      var $89=$5;
      HEAP32[(($89)>>2)]=$88;
      $1=0;
      __label__ = 56; break;
    case 16: // $90
      var $91=$4;
      var $92=$3;
      var $93=$91;
      var $94=$92;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 4;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      $1=-2;
      __label__ = 56; break;
    case 18: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 56; break;
    case 19: // $101
      var $102=$3;
      var $103=$5;
      HEAP32[(($103)>>2)]=$102;
      $1=0;
      __label__ = 56; break;
    case 20: // $104
      __label__ = 21; break;
    case 21: // $105
      var $106=$3;
      var $107=$4;
      var $108=(($106)|0)!=(($107)|0);
      if ($108) { __label__ = 22; break; } else { __label__ = 55; break; }
    case 22: // $109
      var $110=$3;
      var $111=(($110+1)|0);
      var $112=HEAP8[($111)];
      var $113=(($112 << 24) >> 24);
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $115
      var $116=$3;
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$2;
      var $120=$119;
      var $121=(($120+76)|0);
      var $122=(($121+$118)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $134 = $124;__label__ = 25; break;
    case 24: // $125
      var $126=$3;
      var $127=(($126+1)|0);
      var $128=HEAP8[($127)];
      var $129=$3;
      var $130=(($129)|0);
      var $131=HEAP8[($130)];
      var $132=__ZL17unicode_byte_typecc($128, $131);
      var $134 = $132;__label__ = 25; break;
    case 25: // $133
      var $134;
      if ($134 == 29) {
        __label__ = 26; break;
      }
      else if ($134 == 22 || $134 == 24 || $134 == 25 || $134 == 26 || $134 == 27) {
        __label__ = 29; break;
      }
      else if ($134 == 5) {
        __label__ = 30; break;
      }
      else if ($134 == 6) {
        __label__ = 33; break;
      }
      else if ($134 == 7) {
        __label__ = 36; break;
      }
      else if ($134 == 21 || $134 == 9 || $134 == 10) {
        __label__ = 39; break;
      }
      else if ($134 == 23) {
        __label__ = 51; break;
      }
      else if ($134 == 11) {
        __label__ = 52; break;
      }
      else {
      __label__ = 53; break;
      }
      
    case 26: // $135
      var $136=$3;
      var $137=(($136+1)|0);
      var $138=HEAPU8[($137)];
      var $139=(($138)&255);
      var $140=((STRING_TABLE.__ZL9namePages+$139)|0);
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=$142 << 3;
      var $144=$3;
      var $145=(($144)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$147 >> 5;
      var $149=(($143+$148)|0);
      var $150=((__ZL12namingBitmap+($149<<2))|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$3;
      var $153=(($152)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $156=$155 & 31;
      var $157=1 << $156;
      var $158=$151 & $157;
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $160
      var $161=$3;
      var $162=$5;
      HEAP32[(($162)>>2)]=$161;
      $1=0;
      __label__ = 56; break;
    case 28: // $163
      __label__ = 29; break;
    case 29: // $164
      var $165=$3;
      var $166=(($165+2)|0);
      $3=$166;
      __label__ = 54; break;
    case 30: // $167
      var $168=$4;
      var $169=$3;
      var $170=$168;
      var $171=$169;
      var $172=(($170-$171)|0);
      var $173=(($172)|0) < 2;
      if ($173) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $174
      $1=-2;
      __label__ = 56; break;
    case 32: // $175
      var $176=$3;
      var $177=$5;
      HEAP32[(($177)>>2)]=$176;
      $1=0;
      __label__ = 56; break;
    case 33: // $178
      var $179=$4;
      var $180=$3;
      var $181=$179;
      var $182=$180;
      var $183=(($181-$182)|0);
      var $184=(($183)|0) < 3;
      if ($184) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $185
      $1=-2;
      __label__ = 56; break;
    case 35: // $186
      var $187=$3;
      var $188=$5;
      HEAP32[(($188)>>2)]=$187;
      $1=0;
      __label__ = 56; break;
    case 36: // $189
      var $190=$4;
      var $191=$3;
      var $192=$190;
      var $193=$191;
      var $194=(($192-$193)|0);
      var $195=(($194)|0) < 4;
      if ($195) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $196
      $1=-2;
      __label__ = 56; break;
    case 38: // $197
      var $198=$3;
      var $199=$5;
      HEAP32[(($199)>>2)]=$198;
      $1=0;
      __label__ = 56; break;
    case 39: // $200
      var $201=$3;
      var $202=(($201+2)|0);
      $3=$202;
      __label__ = 40; break;
    case 40: // $203
      var $204=$3;
      var $205=$4;
      var $206=(($204)|0)!=(($205)|0);
      if ($206) { __label__ = 41; break; } else { __label__ = 50; break; }
    case 41: // $207
      var $208=$3;
      var $209=(($208+1)|0);
      var $210=HEAP8[($209)];
      var $211=(($210 << 24) >> 24);
      var $212=(($211)|0)==0;
      if ($212) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $213
      var $214=$3;
      var $215=HEAPU8[($214)];
      var $216=(($215)&255);
      var $217=$2;
      var $218=$217;
      var $219=(($218+76)|0);
      var $220=(($219+$216)|0);
      var $221=HEAPU8[($220)];
      var $222=(($221)&255);
      var $232 = $222;__label__ = 44; break;
    case 43: // $223
      var $224=$3;
      var $225=(($224+1)|0);
      var $226=HEAP8[($225)];
      var $227=$3;
      var $228=(($227)|0);
      var $229=HEAP8[($228)];
      var $230=__ZL17unicode_byte_typecc($226, $229);
      var $232 = $230;__label__ = 44; break;
    case 44: // $231
      var $232;
      if ($232 == 21 || $232 == 9 || $232 == 10) {
        __label__ = 45; break;
      }
      else if ($232 == 11) {
        __label__ = 46; break;
      }
      else {
      __label__ = 47; break;
      }
      
    case 45: // $233
      __label__ = 48; break;
    case 46: // $234
      var $235=$3;
      var $236=(($235+2)|0);
      var $237=$5;
      HEAP32[(($237)>>2)]=$236;
      $1=5;
      __label__ = 56; break;
    case 47: // $238
      var $239=$3;
      var $240=$5;
      HEAP32[(($240)>>2)]=$239;
      $1=0;
      __label__ = 56; break;
    case 48: // $241
      __label__ = 49; break;
    case 49: // $242
      var $243=$3;
      var $244=(($243+2)|0);
      $3=$244;
      __label__ = 40; break;
    case 50: // $245
      $1=-1;
      __label__ = 56; break;
    case 51: // $246
      var $247=$3;
      var $248=(($247+2)|0);
      $3=$248;
      __label__ = 54; break;
    case 52: // $249
      var $250=$3;
      var $251=(($250+2)|0);
      var $252=$5;
      HEAP32[(($252)>>2)]=$251;
      $1=5;
      __label__ = 56; break;
    case 53: // $253
      var $254=$3;
      var $255=$5;
      HEAP32[(($255)>>2)]=$254;
      $1=0;
      __label__ = 56; break;
    case 54: // $256
      __label__ = 21; break;
    case 55: // $257
      $1=-1;
      __label__ = 56; break;
    case 56: // $258
      var $259=$1;
      ;
      return $259;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18little2_scanEndTagPK8encodingPKcS3_PS3_["X"]=1;

function __ZL16little2_scanAttsPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $hadColon;
      var $t;
      var $open;
      var $t1;
      var $tok;
      $2=$enc;
      HEAP32[(($3)>>2)]=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      $hadColon=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=HEAP32[(($3)>>2)];
      var $8=$4;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 140; break; }
    case 2: // $10
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=HEAP32[(($3)>>2)];
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=HEAP32[(($3)>>2)];
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=HEAP32[(($3)>>2)];
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 29) {
        __label__ = 6; break;
      }
      else if ($35 == 22 || $35 == 24 || $35 == 25 || $35 == 26 || $35 == 27) {
        __label__ = 9; break;
      }
      else if ($35 == 5) {
        __label__ = 10; break;
      }
      else if ($35 == 6) {
        __label__ = 13; break;
      }
      else if ($35 == 7) {
        __label__ = 16; break;
      }
      else if ($35 == 23) {
        __label__ = 19; break;
      }
      else if ($35 == 21 || $35 == 9 || $35 == 10) {
        __label__ = 42; break;
      }
      else if ($35 == 14) {
        __label__ = 55; break;
      }
      else {
      __label__ = 138; break;
      }
      
    case 6: // $36
      var $37=HEAP32[(($3)>>2)];
      var $38=(($37+1)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=((STRING_TABLE.__ZL9namePages+$40)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$43 << 3;
      var $45=HEAP32[(($3)>>2)];
      var $46=(($45)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 >> 5;
      var $50=(($44+$49)|0);
      var $51=((__ZL12namingBitmap+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=HEAP32[(($3)>>2)];
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 31;
      var $58=1 << $57;
      var $59=$52 & $58;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=HEAP32[(($3)>>2)];
      var $63=$5;
      HEAP32[(($63)>>2)]=$62;
      $1=0;
      __label__ = 141; break;
    case 8: // $64
      __label__ = 9; break;
    case 9: // $65
      var $66=HEAP32[(($3)>>2)];
      var $67=(($66+2)|0);
      HEAP32[(($3)>>2)]=$67;
      __label__ = 139; break;
    case 10: // $68
      var $69=$4;
      var $70=HEAP32[(($3)>>2)];
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 2;
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      $1=-2;
      __label__ = 141; break;
    case 12: // $76
      var $77=HEAP32[(($3)>>2)];
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=0;
      __label__ = 141; break;
    case 13: // $79
      var $80=$4;
      var $81=HEAP32[(($3)>>2)];
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 3;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      $1=-2;
      __label__ = 141; break;
    case 15: // $87
      var $88=HEAP32[(($3)>>2)];
      var $89=$5;
      HEAP32[(($89)>>2)]=$88;
      $1=0;
      __label__ = 141; break;
    case 16: // $90
      var $91=$4;
      var $92=HEAP32[(($3)>>2)];
      var $93=$91;
      var $94=$92;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 4;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      $1=-2;
      __label__ = 141; break;
    case 18: // $98
      var $99=HEAP32[(($3)>>2)];
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 141; break;
    case 19: // $101
      var $102=$hadColon;
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $104
      var $105=HEAP32[(($3)>>2)];
      var $106=$5;
      HEAP32[(($106)>>2)]=$105;
      $1=0;
      __label__ = 141; break;
    case 21: // $107
      $hadColon=1;
      var $108=HEAP32[(($3)>>2)];
      var $109=(($108+2)|0);
      HEAP32[(($3)>>2)]=$109;
      var $110=HEAP32[(($3)>>2)];
      var $111=$4;
      var $112=(($110)|0)==(($111)|0);
      if ($112) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $113
      $1=-1;
      __label__ = 141; break;
    case 23: // $114
      var $115=HEAP32[(($3)>>2)];
      var $116=(($115+1)|0);
      var $117=HEAP8[($116)];
      var $118=(($117 << 24) >> 24);
      var $119=(($118)|0)==0;
      if ($119) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $120
      var $121=HEAP32[(($3)>>2)];
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=$2;
      var $125=$124;
      var $126=(($125+76)|0);
      var $127=(($126+$123)|0);
      var $128=HEAPU8[($127)];
      var $129=(($128)&255);
      var $139 = $129;__label__ = 26; break;
    case 25: // $130
      var $131=HEAP32[(($3)>>2)];
      var $132=(($131+1)|0);
      var $133=HEAP8[($132)];
      var $134=HEAP32[(($3)>>2)];
      var $135=(($134)|0);
      var $136=HEAP8[($135)];
      var $137=__ZL17unicode_byte_typecc($133, $136);
      var $139 = $137;__label__ = 26; break;
    case 26: // $138
      var $139;
      if ($139 == 29) {
        __label__ = 27; break;
      }
      else if ($139 == 22 || $139 == 24) {
        __label__ = 30; break;
      }
      else if ($139 == 5) {
        __label__ = 31; break;
      }
      else if ($139 == 6) {
        __label__ = 34; break;
      }
      else if ($139 == 7) {
        __label__ = 37; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 27: // $140
      var $141=HEAP32[(($3)>>2)];
      var $142=(($141+1)|0);
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=((STRING_TABLE.__ZL11nmstrtPages+$144)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$147 << 3;
      var $149=HEAP32[(($3)>>2)];
      var $150=(($149)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$152 >> 5;
      var $154=(($148+$153)|0);
      var $155=((__ZL12namingBitmap+($154<<2))|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=HEAP32[(($3)>>2)];
      var $158=(($157)|0);
      var $159=HEAPU8[($158)];
      var $160=(($159)&255);
      var $161=$160 & 31;
      var $162=1 << $161;
      var $163=$156 & $162;
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $165
      var $166=HEAP32[(($3)>>2)];
      var $167=$5;
      HEAP32[(($167)>>2)]=$166;
      $1=0;
      __label__ = 141; break;
    case 29: // $168
      __label__ = 30; break;
    case 30: // $169
      var $170=HEAP32[(($3)>>2)];
      var $171=(($170+2)|0);
      HEAP32[(($3)>>2)]=$171;
      __label__ = 41; break;
    case 31: // $172
      var $173=$4;
      var $174=HEAP32[(($3)>>2)];
      var $175=$173;
      var $176=$174;
      var $177=(($175-$176)|0);
      var $178=(($177)|0) < 2;
      if ($178) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $179
      $1=-2;
      __label__ = 141; break;
    case 33: // $180
      var $181=HEAP32[(($3)>>2)];
      var $182=$5;
      HEAP32[(($182)>>2)]=$181;
      $1=0;
      __label__ = 141; break;
    case 34: // $183
      var $184=$4;
      var $185=HEAP32[(($3)>>2)];
      var $186=$184;
      var $187=$185;
      var $188=(($186-$187)|0);
      var $189=(($188)|0) < 3;
      if ($189) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $190
      $1=-2;
      __label__ = 141; break;
    case 36: // $191
      var $192=HEAP32[(($3)>>2)];
      var $193=$5;
      HEAP32[(($193)>>2)]=$192;
      $1=0;
      __label__ = 141; break;
    case 37: // $194
      var $195=$4;
      var $196=HEAP32[(($3)>>2)];
      var $197=$195;
      var $198=$196;
      var $199=(($197-$198)|0);
      var $200=(($199)|0) < 4;
      if ($200) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $201
      $1=-2;
      __label__ = 141; break;
    case 39: // $202
      var $203=HEAP32[(($3)>>2)];
      var $204=$5;
      HEAP32[(($204)>>2)]=$203;
      $1=0;
      __label__ = 141; break;
    case 40: // $205
      var $206=HEAP32[(($3)>>2)];
      var $207=$5;
      HEAP32[(($207)>>2)]=$206;
      $1=0;
      __label__ = 141; break;
    case 41: // $208
      __label__ = 139; break;
    case 42: // $209
      __label__ = 43; break;
    case 43: // $210
      var $211=HEAP32[(($3)>>2)];
      var $212=(($211+2)|0);
      HEAP32[(($3)>>2)]=$212;
      var $213=HEAP32[(($3)>>2)];
      var $214=$4;
      var $215=(($213)|0)==(($214)|0);
      if ($215) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $216
      $1=-1;
      __label__ = 141; break;
    case 45: // $217
      var $218=HEAP32[(($3)>>2)];
      var $219=(($218+1)|0);
      var $220=HEAP8[($219)];
      var $221=(($220 << 24) >> 24);
      var $222=(($221)|0)==0;
      if ($222) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $223
      var $224=HEAP32[(($3)>>2)];
      var $225=HEAPU8[($224)];
      var $226=(($225)&255);
      var $227=$2;
      var $228=$227;
      var $229=(($228+76)|0);
      var $230=(($229+$226)|0);
      var $231=HEAPU8[($230)];
      var $232=(($231)&255);
      var $242 = $232;__label__ = 48; break;
    case 47: // $233
      var $234=HEAP32[(($3)>>2)];
      var $235=(($234+1)|0);
      var $236=HEAP8[($235)];
      var $237=HEAP32[(($3)>>2)];
      var $238=(($237)|0);
      var $239=HEAP8[($238)];
      var $240=__ZL17unicode_byte_typecc($236, $239);
      var $242 = $240;__label__ = 48; break;
    case 48: // $241
      var $242;
      $t=$242;
      var $243=$t;
      var $244=(($243)|0)==14;
      if ($244) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $245
      __label__ = 54; break;
    case 50: // $246
      var $247=$t;
      if ($247 == 21 || $247 == 10 || $247 == 9) {
        __label__ = 51; break;
      }
      else {
      __label__ = 52; break;
      }
      
    case 51: // $248
      __label__ = 53; break;
    case 52: // $249
      var $250=HEAP32[(($3)>>2)];
      var $251=$5;
      HEAP32[(($251)>>2)]=$250;
      $1=0;
      __label__ = 141; break;
    case 53: // $252
      __label__ = 43; break;
    case 54: // $253
      __label__ = 55; break;
    case 55: // $254
      $hadColon=0;
      __label__ = 56; break;
    case 56: // $255
      var $256=HEAP32[(($3)>>2)];
      var $257=(($256+2)|0);
      HEAP32[(($3)>>2)]=$257;
      var $258=HEAP32[(($3)>>2)];
      var $259=$4;
      var $260=(($258)|0)==(($259)|0);
      if ($260) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $261
      $1=-1;
      __label__ = 141; break;
    case 58: // $262
      var $263=HEAP32[(($3)>>2)];
      var $264=(($263+1)|0);
      var $265=HEAP8[($264)];
      var $266=(($265 << 24) >> 24);
      var $267=(($266)|0)==0;
      if ($267) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $268
      var $269=HEAP32[(($3)>>2)];
      var $270=HEAPU8[($269)];
      var $271=(($270)&255);
      var $272=$2;
      var $273=$272;
      var $274=(($273+76)|0);
      var $275=(($274+$271)|0);
      var $276=HEAPU8[($275)];
      var $277=(($276)&255);
      var $287 = $277;__label__ = 61; break;
    case 60: // $278
      var $279=HEAP32[(($3)>>2)];
      var $280=(($279+1)|0);
      var $281=HEAP8[($280)];
      var $282=HEAP32[(($3)>>2)];
      var $283=(($282)|0);
      var $284=HEAP8[($283)];
      var $285=__ZL17unicode_byte_typecc($281, $284);
      var $287 = $285;__label__ = 61; break;
    case 61: // $286
      var $287;
      $open=$287;
      var $288=$open;
      var $289=(($288)|0)==12;
      if ($289) { __label__ = 63; break; } else { __label__ = 62; break; }
    case 62: // $290
      var $291=$open;
      var $292=(($291)|0)==13;
      if ($292) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $293
      __label__ = 68; break;
    case 64: // $294
      var $295=$open;
      if ($295 == 21 || $295 == 10 || $295 == 9) {
        __label__ = 65; break;
      }
      else {
      __label__ = 66; break;
      }
      
    case 65: // $296
      __label__ = 67; break;
    case 66: // $297
      var $298=HEAP32[(($3)>>2)];
      var $299=$5;
      HEAP32[(($299)>>2)]=$298;
      $1=0;
      __label__ = 141; break;
    case 67: // $300
      __label__ = 56; break;
    case 68: // $301
      var $302=HEAP32[(($3)>>2)];
      var $303=(($302+2)|0);
      HEAP32[(($3)>>2)]=$303;
      __label__ = 69; break;
    case 69: // $304
      var $305=HEAP32[(($3)>>2)];
      var $306=$4;
      var $307=(($305)|0)==(($306)|0);
      if ($307) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $308
      $1=-1;
      __label__ = 141; break;
    case 71: // $309
      var $310=HEAP32[(($3)>>2)];
      var $311=(($310+1)|0);
      var $312=HEAP8[($311)];
      var $313=(($312 << 24) >> 24);
      var $314=(($313)|0)==0;
      if ($314) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $315
      var $316=HEAP32[(($3)>>2)];
      var $317=HEAPU8[($316)];
      var $318=(($317)&255);
      var $319=$2;
      var $320=$319;
      var $321=(($320+76)|0);
      var $322=(($321+$318)|0);
      var $323=HEAPU8[($322)];
      var $324=(($323)&255);
      var $334 = $324;__label__ = 74; break;
    case 73: // $325
      var $326=HEAP32[(($3)>>2)];
      var $327=(($326+1)|0);
      var $328=HEAP8[($327)];
      var $329=HEAP32[(($3)>>2)];
      var $330=(($329)|0);
      var $331=HEAP8[($330)];
      var $332=__ZL17unicode_byte_typecc($328, $331);
      var $334 = $332;__label__ = 74; break;
    case 74: // $333
      var $334;
      $t1=$334;
      var $335=$t1;
      var $336=$open;
      var $337=(($335)|0)==(($336)|0);
      if ($337) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $338
      __label__ = 95; break;
    case 76: // $339
      var $340=$t1;
      if ($340 == 5) {
        __label__ = 77; break;
      }
      else if ($340 == 6) {
        __label__ = 80; break;
      }
      else if ($340 == 7) {
        __label__ = 83; break;
      }
      else if ($340 == 0 || $340 == 1 || $340 == 8) {
        __label__ = 86; break;
      }
      else if ($340 == 3) {
        __label__ = 87; break;
      }
      else if ($340 == 2) {
        __label__ = 92; break;
      }
      else {
      __label__ = 93; break;
      }
      
    case 77: // $341
      var $342=$4;
      var $343=HEAP32[(($3)>>2)];
      var $344=$342;
      var $345=$343;
      var $346=(($344-$345)|0);
      var $347=(($346)|0) < 2;
      if ($347) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $348
      $1=-2;
      __label__ = 141; break;
    case 79: // $349
      var $350=HEAP32[(($3)>>2)];
      var $351=(($350+2)|0);
      HEAP32[(($3)>>2)]=$351;
      __label__ = 94; break;
    case 80: // $352
      var $353=$4;
      var $354=HEAP32[(($3)>>2)];
      var $355=$353;
      var $356=$354;
      var $357=(($355-$356)|0);
      var $358=(($357)|0) < 3;
      if ($358) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $359
      $1=-2;
      __label__ = 141; break;
    case 82: // $360
      var $361=HEAP32[(($3)>>2)];
      var $362=(($361+3)|0);
      HEAP32[(($3)>>2)]=$362;
      __label__ = 94; break;
    case 83: // $363
      var $364=$4;
      var $365=HEAP32[(($3)>>2)];
      var $366=$364;
      var $367=$365;
      var $368=(($366-$367)|0);
      var $369=(($368)|0) < 4;
      if ($369) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $370
      $1=-2;
      __label__ = 141; break;
    case 85: // $371
      var $372=HEAP32[(($3)>>2)];
      var $373=(($372+4)|0);
      HEAP32[(($3)>>2)]=$373;
      __label__ = 94; break;
    case 86: // $374
      var $375=HEAP32[(($3)>>2)];
      var $376=$5;
      HEAP32[(($376)>>2)]=$375;
      $1=0;
      __label__ = 141; break;
    case 87: // $377
      var $378=$2;
      var $379=HEAP32[(($3)>>2)];
      var $380=(($379+2)|0);
      var $381=$4;
      var $382=__ZL15little2_scanRefPK8encodingPKcS3_PS3_($378, $380, $381, $3);
      $tok=$382;
      var $383=$tok;
      var $384=(($383)|0) <= 0;
      if ($384) { __label__ = 88; break; } else { __label__ = 91; break; }
    case 88: // $385
      var $386=$tok;
      var $387=(($386)|0)==0;
      if ($387) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $388
      var $389=HEAP32[(($3)>>2)];
      var $390=$5;
      HEAP32[(($390)>>2)]=$389;
      __label__ = 90; break;
    case 90: // $391
      var $392=$tok;
      $1=$392;
      __label__ = 141; break;
    case 91: // $393
      __label__ = 94; break;
    case 92: // $394
      var $395=HEAP32[(($3)>>2)];
      var $396=$5;
      HEAP32[(($396)>>2)]=$395;
      $1=0;
      __label__ = 141; break;
    case 93: // $397
      var $398=HEAP32[(($3)>>2)];
      var $399=(($398+2)|0);
      HEAP32[(($3)>>2)]=$399;
      __label__ = 94; break;
    case 94: // $400
      __label__ = 69; break;
    case 95: // $401
      var $402=HEAP32[(($3)>>2)];
      var $403=(($402+2)|0);
      HEAP32[(($3)>>2)]=$403;
      var $404=HEAP32[(($3)>>2)];
      var $405=$4;
      var $406=(($404)|0)==(($405)|0);
      if ($406) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $407
      $1=-1;
      __label__ = 141; break;
    case 97: // $408
      var $409=HEAP32[(($3)>>2)];
      var $410=(($409+1)|0);
      var $411=HEAP8[($410)];
      var $412=(($411 << 24) >> 24);
      var $413=(($412)|0)==0;
      if ($413) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $414
      var $415=HEAP32[(($3)>>2)];
      var $416=HEAPU8[($415)];
      var $417=(($416)&255);
      var $418=$2;
      var $419=$418;
      var $420=(($419+76)|0);
      var $421=(($420+$417)|0);
      var $422=HEAPU8[($421)];
      var $423=(($422)&255);
      var $433 = $423;__label__ = 100; break;
    case 99: // $424
      var $425=HEAP32[(($3)>>2)];
      var $426=(($425+1)|0);
      var $427=HEAP8[($426)];
      var $428=HEAP32[(($3)>>2)];
      var $429=(($428)|0);
      var $430=HEAP8[($429)];
      var $431=__ZL17unicode_byte_typecc($427, $430);
      var $433 = $431;__label__ = 100; break;
    case 100: // $432
      var $433;
      if ($433 == 21 || $433 == 9 || $433 == 10) {
        __label__ = 101; break;
      }
      else if ($433 == 17) {
        __label__ = 102; break;
      }
      else if ($433 == 11) {
        __label__ = 103; break;
      }
      else {
      __label__ = 104; break;
      }
      
    case 101: // $434
      __label__ = 105; break;
    case 102: // $435
      __label__ = 129; break;
    case 103: // $436
      __label__ = 127; break;
    case 104: // $437
      var $438=HEAP32[(($3)>>2)];
      var $439=$5;
      HEAP32[(($439)>>2)]=$438;
      $1=0;
      __label__ = 141; break;
    case 105: // $440
      __label__ = 106; break;
    case 106: // $441
      var $442=HEAP32[(($3)>>2)];
      var $443=(($442+2)|0);
      HEAP32[(($3)>>2)]=$443;
      var $444=HEAP32[(($3)>>2)];
      var $445=$4;
      var $446=(($444)|0)==(($445)|0);
      if ($446) { __label__ = 107; break; } else { __label__ = 108; break; }
    case 107: // $447
      $1=-1;
      __label__ = 141; break;
    case 108: // $448
      var $449=HEAP32[(($3)>>2)];
      var $450=(($449+1)|0);
      var $451=HEAP8[($450)];
      var $452=(($451 << 24) >> 24);
      var $453=(($452)|0)==0;
      if ($453) { __label__ = 109; break; } else { __label__ = 110; break; }
    case 109: // $454
      var $455=HEAP32[(($3)>>2)];
      var $456=HEAPU8[($455)];
      var $457=(($456)&255);
      var $458=$2;
      var $459=$458;
      var $460=(($459+76)|0);
      var $461=(($460+$457)|0);
      var $462=HEAPU8[($461)];
      var $463=(($462)&255);
      var $473 = $463;__label__ = 111; break;
    case 110: // $464
      var $465=HEAP32[(($3)>>2)];
      var $466=(($465+1)|0);
      var $467=HEAP8[($466)];
      var $468=HEAP32[(($3)>>2)];
      var $469=(($468)|0);
      var $470=HEAP8[($469)];
      var $471=__ZL17unicode_byte_typecc($467, $470);
      var $473 = $471;__label__ = 111; break;
    case 111: // $472
      var $473;
      if ($473 == 29) {
        __label__ = 112; break;
      }
      else if ($473 == 22 || $473 == 24) {
        __label__ = 115; break;
      }
      else if ($473 == 5) {
        __label__ = 116; break;
      }
      else if ($473 == 6) {
        __label__ = 119; break;
      }
      else if ($473 == 7) {
        __label__ = 122; break;
      }
      else if ($473 == 21 || $473 == 9 || $473 == 10) {
        __label__ = 125; break;
      }
      else if ($473 == 11) {
        __label__ = 126; break;
      }
      else if ($473 == 17) {
        __label__ = 128; break;
      }
      else {
      __label__ = 135; break;
      }
      
    case 112: // $474
      var $475=HEAP32[(($3)>>2)];
      var $476=(($475+1)|0);
      var $477=HEAPU8[($476)];
      var $478=(($477)&255);
      var $479=((STRING_TABLE.__ZL11nmstrtPages+$478)|0);
      var $480=HEAPU8[($479)];
      var $481=(($480)&255);
      var $482=$481 << 3;
      var $483=HEAP32[(($3)>>2)];
      var $484=(($483)|0);
      var $485=HEAPU8[($484)];
      var $486=(($485)&255);
      var $487=$486 >> 5;
      var $488=(($482+$487)|0);
      var $489=((__ZL12namingBitmap+($488<<2))|0);
      var $490=HEAP32[(($489)>>2)];
      var $491=HEAP32[(($3)>>2)];
      var $492=(($491)|0);
      var $493=HEAPU8[($492)];
      var $494=(($493)&255);
      var $495=$494 & 31;
      var $496=1 << $495;
      var $497=$490 & $496;
      var $498=(($497)|0)!=0;
      if ($498) { __label__ = 114; break; } else { __label__ = 113; break; }
    case 113: // $499
      var $500=HEAP32[(($3)>>2)];
      var $501=$5;
      HEAP32[(($501)>>2)]=$500;
      $1=0;
      __label__ = 141; break;
    case 114: // $502
      __label__ = 115; break;
    case 115: // $503
      var $504=HEAP32[(($3)>>2)];
      var $505=(($504+2)|0);
      HEAP32[(($3)>>2)]=$505;
      __label__ = 136; break;
    case 116: // $506
      var $507=$4;
      var $508=HEAP32[(($3)>>2)];
      var $509=$507;
      var $510=$508;
      var $511=(($509-$510)|0);
      var $512=(($511)|0) < 2;
      if ($512) { __label__ = 117; break; } else { __label__ = 118; break; }
    case 117: // $513
      $1=-2;
      __label__ = 141; break;
    case 118: // $514
      var $515=HEAP32[(($3)>>2)];
      var $516=$5;
      HEAP32[(($516)>>2)]=$515;
      $1=0;
      __label__ = 141; break;
    case 119: // $517
      var $518=$4;
      var $519=HEAP32[(($3)>>2)];
      var $520=$518;
      var $521=$519;
      var $522=(($520-$521)|0);
      var $523=(($522)|0) < 3;
      if ($523) { __label__ = 120; break; } else { __label__ = 121; break; }
    case 120: // $524
      $1=-2;
      __label__ = 141; break;
    case 121: // $525
      var $526=HEAP32[(($3)>>2)];
      var $527=$5;
      HEAP32[(($527)>>2)]=$526;
      $1=0;
      __label__ = 141; break;
    case 122: // $528
      var $529=$4;
      var $530=HEAP32[(($3)>>2)];
      var $531=$529;
      var $532=$530;
      var $533=(($531-$532)|0);
      var $534=(($533)|0) < 4;
      if ($534) { __label__ = 123; break; } else { __label__ = 124; break; }
    case 123: // $535
      $1=-2;
      __label__ = 141; break;
    case 124: // $536
      var $537=HEAP32[(($3)>>2)];
      var $538=$5;
      HEAP32[(($538)>>2)]=$537;
      $1=0;
      __label__ = 141; break;
    case 125: // $539
      __label__ = 106; break;
    case 126: // $540
      __label__ = 127; break;
    case 127: // $541
      var $542=HEAP32[(($3)>>2)];
      var $543=(($542+2)|0);
      var $544=$5;
      HEAP32[(($544)>>2)]=$543;
      $1=1;
      __label__ = 141; break;
    case 128: // $545
      __label__ = 129; break;
    case 129: // $546
      var $547=HEAP32[(($3)>>2)];
      var $548=(($547+2)|0);
      HEAP32[(($3)>>2)]=$548;
      var $549=HEAP32[(($3)>>2)];
      var $550=$4;
      var $551=(($549)|0)==(($550)|0);
      if ($551) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $552
      $1=-1;
      __label__ = 141; break;
    case 131: // $553
      var $554=HEAP32[(($3)>>2)];
      var $555=(($554+1)|0);
      var $556=HEAP8[($555)];
      var $557=(($556 << 24) >> 24);
      var $558=(($557)|0)==0;
      if ($558) { __label__ = 132; break; } else { __label__ = 133; break; }
    case 132: // $559
      var $560=HEAP32[(($3)>>2)];
      var $561=(($560)|0);
      var $562=HEAP8[($561)];
      var $563=(($562 << 24) >> 24);
      var $564=(($563)|0)==62;
      if ($564) { __label__ = 134; break; } else { __label__ = 133; break; }
    case 133: // $565
      var $566=HEAP32[(($3)>>2)];
      var $567=$5;
      HEAP32[(($567)>>2)]=$566;
      $1=0;
      __label__ = 141; break;
    case 134: // $568
      var $569=HEAP32[(($3)>>2)];
      var $570=(($569+2)|0);
      var $571=$5;
      HEAP32[(($571)>>2)]=$570;
      $1=3;
      __label__ = 141; break;
    case 135: // $572
      var $573=HEAP32[(($3)>>2)];
      var $574=$5;
      HEAP32[(($574)>>2)]=$573;
      $1=0;
      __label__ = 141; break;
    case 136: // $575
      __label__ = 137; break;
    case 137: // $576
      __label__ = 139; break;
    case 138: // $577
      var $578=HEAP32[(($3)>>2)];
      var $579=$5;
      HEAP32[(($579)>>2)]=$578;
      $1=0;
      __label__ = 141; break;
    case 139: // $580
      __label__ = 1; break;
    case 140: // $581
      $1=-1;
      __label__ = 141; break;
    case 141: // $582
      var $583=$1;
      STACKTOP = __stackBase__;
      return $583;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16little2_scanAttsPK8encodingPKcS3_PS3_["X"]=1;

function __ZL21little2_checkPiTargetPK8encodingPKcS3_Pi($enc, $ptr, $end, $tokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $upper;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$tokPtr;
      $upper=0;
      var $6=$5;
      HEAP32[(($6)>>2)]=11;
      var $7=$4;
      var $8=$3;
      var $9=$7;
      var $10=$8;
      var $11=(($9-$10)|0);
      var $12=(($11)|0)!=6;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=1;
      __label__ = 23; break;
    case 2: // $14
      var $15=$3;
      var $16=(($15+1)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$3;
      var $22=(($21)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $27 = $24;__label__ = 5; break;
    case 4: // $25
      var $27 = -1;__label__ = 5; break;
    case 5: // $26
      var $27;
      if ($27 == 120) {
        __label__ = 8; break;
      }
      else if ($27 == 88) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 6: // $28
      $upper=1;
      __label__ = 8; break;
    case 7: // $29
      $1=1;
      __label__ = 23; break;
    case 8: // $30
      var $31=$3;
      var $32=(($31+2)|0);
      $3=$32;
      var $33=$3;
      var $34=(($33+1)|0);
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $38
      var $39=$3;
      var $40=(($39)|0);
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $45 = $42;__label__ = 11; break;
    case 10: // $43
      var $45 = -1;__label__ = 11; break;
    case 11: // $44
      var $45;
      if ($45 == 109) {
        __label__ = 14; break;
      }
      else if ($45 == 77) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 12: // $46
      $upper=1;
      __label__ = 14; break;
    case 13: // $47
      $1=1;
      __label__ = 23; break;
    case 14: // $48
      var $49=$3;
      var $50=(($49+2)|0);
      $3=$50;
      var $51=$3;
      var $52=(($51+1)|0);
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24);
      var $55=(($54)|0)==0;
      if ($55) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $56
      var $57=$3;
      var $58=(($57)|0);
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $63 = $60;__label__ = 17; break;
    case 16: // $61
      var $63 = -1;__label__ = 17; break;
    case 17: // $62
      var $63;
      if ($63 == 108) {
        __label__ = 20; break;
      }
      else if ($63 == 76) {
        __label__ = 18; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 18: // $64
      $upper=1;
      __label__ = 20; break;
    case 19: // $65
      $1=1;
      __label__ = 23; break;
    case 20: // $66
      var $67=$upper;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $69
      $1=0;
      __label__ = 23; break;
    case 22: // $70
      var $71=$5;
      HEAP32[(($71)>>2)]=12;
      $1=1;
      __label__ = 23; break;
    case 23: // $72
      var $73=$1;
      ;
      return $73;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21little2_checkPiTargetPK8encodingPKcS3_Pi["X"]=1;

function __ZL15little2_scanLitiPK8encodingPKcS3_PS3_($open, $enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $t;
      $2=$open;
      $3=$enc;
      $4=$ptr;
      $5=$end;
      $6=$nextTokPtr;
      __label__ = 1; break;
    case 1: // $7
      var $8=$4;
      var $9=$5;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 28; break; }
    case 2: // $11
      var $12=$4;
      var $13=(($12+1)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$4;
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$3;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$4;
      var $29=(($28+1)|0);
      var $30=HEAP8[($29)];
      var $31=$4;
      var $32=(($31)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      $t=$36;
      var $37=$t;
      if ($37 == 5) {
        __label__ = 6; break;
      }
      else if ($37 == 6) {
        __label__ = 9; break;
      }
      else if ($37 == 7) {
        __label__ = 12; break;
      }
      else if ($37 == 0 || $37 == 1 || $37 == 8) {
        __label__ = 15; break;
      }
      else if ($37 == 12 || $37 == 13) {
        __label__ = 16; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 6: // $38
      var $39=$5;
      var $40=$4;
      var $41=$39;
      var $42=$40;
      var $43=(($41-$42)|0);
      var $44=(($43)|0) < 2;
      if ($44) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $45
      $1=-2;
      __label__ = 29; break;
    case 8: // $46
      var $47=$4;
      var $48=(($47+2)|0);
      $4=$48;
      __label__ = 27; break;
    case 9: // $49
      var $50=$5;
      var $51=$4;
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $56
      $1=-2;
      __label__ = 29; break;
    case 11: // $57
      var $58=$4;
      var $59=(($58+3)|0);
      $4=$59;
      __label__ = 27; break;
    case 12: // $60
      var $61=$5;
      var $62=$4;
      var $63=$61;
      var $64=$62;
      var $65=(($63-$64)|0);
      var $66=(($65)|0) < 4;
      if ($66) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $67
      $1=-2;
      __label__ = 29; break;
    case 14: // $68
      var $69=$4;
      var $70=(($69+4)|0);
      $4=$70;
      __label__ = 27; break;
    case 15: // $71
      var $72=$4;
      var $73=$6;
      HEAP32[(($73)>>2)]=$72;
      $1=0;
      __label__ = 29; break;
    case 16: // $74
      var $75=$4;
      var $76=(($75+2)|0);
      $4=$76;
      var $77=$t;
      var $78=$2;
      var $79=(($77)|0)!=(($78)|0);
      if ($79) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $80
      __label__ = 27; break;
    case 18: // $81
      var $82=$4;
      var $83=$5;
      var $84=(($82)|0)==(($83)|0);
      if ($84) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $85
      $1=-27;
      __label__ = 29; break;
    case 20: // $86
      var $87=$4;
      var $88=$6;
      HEAP32[(($88)>>2)]=$87;
      var $89=$4;
      var $90=(($89+1)|0);
      var $91=HEAP8[($90)];
      var $92=(($91 << 24) >> 24);
      var $93=(($92)|0)==0;
      if ($93) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $94
      var $95=$4;
      var $96=HEAPU8[($95)];
      var $97=(($96)&255);
      var $98=$3;
      var $99=$98;
      var $100=(($99+76)|0);
      var $101=(($100+$97)|0);
      var $102=HEAPU8[($101)];
      var $103=(($102)&255);
      var $113 = $103;__label__ = 23; break;
    case 22: // $104
      var $105=$4;
      var $106=(($105+1)|0);
      var $107=HEAP8[($106)];
      var $108=$4;
      var $109=(($108)|0);
      var $110=HEAP8[($109)];
      var $111=__ZL17unicode_byte_typecc($107, $110);
      var $113 = $111;__label__ = 23; break;
    case 23: // $112
      var $113;
      if ($113 == 21 || $113 == 9 || $113 == 10 || $113 == 11 || $113 == 30 || $113 == 20) {
        __label__ = 24; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 24: // $114
      $1=27;
      __label__ = 29; break;
    case 25: // $115
      $1=0;
      __label__ = 29; break;
    case 26: // $116
      var $117=$4;
      var $118=(($117+2)|0);
      $4=$118;
      __label__ = 27; break;
    case 27: // $119
      __label__ = 1; break;
    case 28: // $120
      $1=-1;
      __label__ = 29; break;
    case 29: // $121
      var $122=$1;
      ;
      return $122;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15little2_scanLitiPK8encodingPKcS3_PS3_["X"]=1;

function __ZL16little2_scanDeclPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 29; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 27) {
        __label__ = 6; break;
      }
      else if ($35 == 20) {
        __label__ = 7; break;
      }
      else if ($35 == 22 || $35 == 24) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 6: // $36
      var $37=$2;
      var $38=$3;
      var $39=(($38+2)|0);
      var $40=$4;
      var $41=$5;
      var $42=__ZL19little2_scanCommentPK8encodingPKcS3_PS3_($37, $39, $40, $41);
      $1=$42;
      __label__ = 29; break;
    case 7: // $43
      var $44=$3;
      var $45=(($44+2)|0);
      var $46=$5;
      HEAP32[(($46)>>2)]=$45;
      $1=33;
      __label__ = 29; break;
    case 8: // $47
      var $48=$3;
      var $49=(($48+2)|0);
      $3=$49;
      __label__ = 10; break;
    case 9: // $50
      var $51=$3;
      var $52=$5;
      HEAP32[(($52)>>2)]=$51;
      $1=0;
      __label__ = 29; break;
    case 10: // $53
      __label__ = 11; break;
    case 11: // $54
      var $55=$3;
      var $56=$4;
      var $57=(($55)|0)!=(($56)|0);
      if ($57) { __label__ = 12; break; } else { __label__ = 28; break; }
    case 12: // $58
      var $59=$3;
      var $60=(($59+1)|0);
      var $61=HEAP8[($60)];
      var $62=(($61 << 24) >> 24);
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $64
      var $65=$3;
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$2;
      var $69=$68;
      var $70=(($69+76)|0);
      var $71=(($70+$67)|0);
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $83 = $73;__label__ = 15; break;
    case 14: // $74
      var $75=$3;
      var $76=(($75+1)|0);
      var $77=HEAP8[($76)];
      var $78=$3;
      var $79=(($78)|0);
      var $80=HEAP8[($79)];
      var $81=__ZL17unicode_byte_typecc($77, $80);
      var $83 = $81;__label__ = 15; break;
    case 15: // $82
      var $83;
      if ($83 == 30) {
        __label__ = 16; break;
      }
      else if ($83 == 21 || $83 == 9 || $83 == 10) {
        __label__ = 24; break;
      }
      else if ($83 == 22 || $83 == 24) {
        __label__ = 25; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 16: // $84
      var $85=$3;
      var $86=(($85+2)|0);
      var $87=$4;
      var $88=(($86)|0)==(($87)|0);
      if ($88) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $89
      $1=-1;
      __label__ = 29; break;
    case 18: // $90
      var $91=$3;
      var $92=(($91+2)|0);
      var $93=(($92+1)|0);
      var $94=HEAP8[($93)];
      var $95=(($94 << 24) >> 24);
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $97
      var $98=$3;
      var $99=(($98+2)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=$2;
      var $103=$102;
      var $104=(($103+76)|0);
      var $105=(($104+$101)|0);
      var $106=HEAPU8[($105)];
      var $107=(($106)&255);
      var $119 = $107;__label__ = 21; break;
    case 20: // $108
      var $109=$3;
      var $110=(($109+2)|0);
      var $111=(($110+1)|0);
      var $112=HEAP8[($111)];
      var $113=$3;
      var $114=(($113+2)|0);
      var $115=(($114)|0);
      var $116=HEAP8[($115)];
      var $117=__ZL17unicode_byte_typecc($112, $116);
      var $119 = $117;__label__ = 21; break;
    case 21: // $118
      var $119;
      if ($119 == 21 || $119 == 9 || $119 == 10 || $119 == 30) {
        __label__ = 22; break;
      }
      else {
      __label__ = 23; break;
      }
      
    case 22: // $120
      var $121=$3;
      var $122=$5;
      HEAP32[(($122)>>2)]=$121;
      $1=0;
      __label__ = 29; break;
    case 23: // $123
      __label__ = 24; break;
    case 24: // $124
      var $125=$3;
      var $126=$5;
      HEAP32[(($126)>>2)]=$125;
      $1=16;
      __label__ = 29; break;
    case 25: // $127
      var $128=$3;
      var $129=(($128+2)|0);
      $3=$129;
      __label__ = 27; break;
    case 26: // $130
      var $131=$3;
      var $132=$5;
      HEAP32[(($132)>>2)]=$131;
      $1=0;
      __label__ = 29; break;
    case 27: // $133
      __label__ = 11; break;
    case 28: // $134
      $1=-1;
      __label__ = 29; break;
    case 29: // $135
      var $136=$1;
      ;
      return $136;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16little2_scanDeclPK8encodingPKcS3_PS3_["X"]=1;

function __ZL21little2_scanPoundNamePK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 43; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11+1)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 29) {
        __label__ = 6; break;
      }
      else if ($35 == 22 || $35 == 24) {
        __label__ = 9; break;
      }
      else if ($35 == 5) {
        __label__ = 10; break;
      }
      else if ($35 == 6) {
        __label__ = 13; break;
      }
      else if ($35 == 7) {
        __label__ = 16; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 6: // $36
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAPU8[($38)];
      var $40=(($39)&255);
      var $41=((STRING_TABLE.__ZL11nmstrtPages+$40)|0);
      var $42=HEAPU8[($41)];
      var $43=(($42)&255);
      var $44=$43 << 3;
      var $45=$3;
      var $46=(($45)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 >> 5;
      var $50=(($44+$49)|0);
      var $51=((__ZL12namingBitmap+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 31;
      var $58=1 << $57;
      var $59=$52 & $58;
      var $60=(($59)|0)!=0;
      if ($60) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $61
      var $62=$3;
      var $63=$5;
      HEAP32[(($63)>>2)]=$62;
      $1=0;
      __label__ = 43; break;
    case 8: // $64
      __label__ = 9; break;
    case 9: // $65
      var $66=$3;
      var $67=(($66+2)|0);
      $3=$67;
      __label__ = 20; break;
    case 10: // $68
      var $69=$4;
      var $70=$3;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 2;
      if ($74) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $75
      $1=-2;
      __label__ = 43; break;
    case 12: // $76
      var $77=$3;
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=0;
      __label__ = 43; break;
    case 13: // $79
      var $80=$4;
      var $81=$3;
      var $82=$80;
      var $83=$81;
      var $84=(($82-$83)|0);
      var $85=(($84)|0) < 3;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      $1=-2;
      __label__ = 43; break;
    case 15: // $87
      var $88=$3;
      var $89=$5;
      HEAP32[(($89)>>2)]=$88;
      $1=0;
      __label__ = 43; break;
    case 16: // $90
      var $91=$4;
      var $92=$3;
      var $93=$91;
      var $94=$92;
      var $95=(($93-$94)|0);
      var $96=(($95)|0) < 4;
      if ($96) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $97
      $1=-2;
      __label__ = 43; break;
    case 18: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 43; break;
    case 19: // $101
      var $102=$3;
      var $103=$5;
      HEAP32[(($103)>>2)]=$102;
      $1=0;
      __label__ = 43; break;
    case 20: // $104
      __label__ = 21; break;
    case 21: // $105
      var $106=$3;
      var $107=$4;
      var $108=(($106)|0)!=(($107)|0);
      if ($108) { __label__ = 22; break; } else { __label__ = 42; break; }
    case 22: // $109
      var $110=$3;
      var $111=(($110+1)|0);
      var $112=HEAP8[($111)];
      var $113=(($112 << 24) >> 24);
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $115
      var $116=$3;
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$2;
      var $120=$119;
      var $121=(($120+76)|0);
      var $122=(($121+$118)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $134 = $124;__label__ = 25; break;
    case 24: // $125
      var $126=$3;
      var $127=(($126+1)|0);
      var $128=HEAP8[($127)];
      var $129=$3;
      var $130=(($129)|0);
      var $131=HEAP8[($130)];
      var $132=__ZL17unicode_byte_typecc($128, $131);
      var $134 = $132;__label__ = 25; break;
    case 25: // $133
      var $134;
      if ($134 == 29) {
        __label__ = 26; break;
      }
      else if ($134 == 22 || $134 == 24 || $134 == 25 || $134 == 26 || $134 == 27) {
        __label__ = 29; break;
      }
      else if ($134 == 5) {
        __label__ = 30; break;
      }
      else if ($134 == 6) {
        __label__ = 33; break;
      }
      else if ($134 == 7) {
        __label__ = 36; break;
      }
      else if ($134 == 9 || $134 == 10 || $134 == 21 || $134 == 32 || $134 == 11 || $134 == 30 || $134 == 36) {
        __label__ = 39; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 26: // $135
      var $136=$3;
      var $137=(($136+1)|0);
      var $138=HEAPU8[($137)];
      var $139=(($138)&255);
      var $140=((STRING_TABLE.__ZL9namePages+$139)|0);
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=$142 << 3;
      var $144=$3;
      var $145=(($144)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$147 >> 5;
      var $149=(($143+$148)|0);
      var $150=((__ZL12namingBitmap+($149<<2))|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$3;
      var $153=(($152)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $156=$155 & 31;
      var $157=1 << $156;
      var $158=$151 & $157;
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $160
      var $161=$3;
      var $162=$5;
      HEAP32[(($162)>>2)]=$161;
      $1=0;
      __label__ = 43; break;
    case 28: // $163
      __label__ = 29; break;
    case 29: // $164
      var $165=$3;
      var $166=(($165+2)|0);
      $3=$166;
      __label__ = 41; break;
    case 30: // $167
      var $168=$4;
      var $169=$3;
      var $170=$168;
      var $171=$169;
      var $172=(($170-$171)|0);
      var $173=(($172)|0) < 2;
      if ($173) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $174
      $1=-2;
      __label__ = 43; break;
    case 32: // $175
      var $176=$3;
      var $177=$5;
      HEAP32[(($177)>>2)]=$176;
      $1=0;
      __label__ = 43; break;
    case 33: // $178
      var $179=$4;
      var $180=$3;
      var $181=$179;
      var $182=$180;
      var $183=(($181-$182)|0);
      var $184=(($183)|0) < 3;
      if ($184) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $185
      $1=-2;
      __label__ = 43; break;
    case 35: // $186
      var $187=$3;
      var $188=$5;
      HEAP32[(($188)>>2)]=$187;
      $1=0;
      __label__ = 43; break;
    case 36: // $189
      var $190=$4;
      var $191=$3;
      var $192=$190;
      var $193=$191;
      var $194=(($192-$193)|0);
      var $195=(($194)|0) < 4;
      if ($195) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $196
      $1=-2;
      __label__ = 43; break;
    case 38: // $197
      var $198=$3;
      var $199=$5;
      HEAP32[(($199)>>2)]=$198;
      $1=0;
      __label__ = 43; break;
    case 39: // $200
      var $201=$3;
      var $202=$5;
      HEAP32[(($202)>>2)]=$201;
      $1=20;
      __label__ = 43; break;
    case 40: // $203
      var $204=$3;
      var $205=$5;
      HEAP32[(($205)>>2)]=$204;
      $1=0;
      __label__ = 43; break;
    case 41: // $206
      __label__ = 21; break;
    case 42: // $207
      $1=-20;
      __label__ = 43; break;
    case 43: // $208
      var $209=$1;
      ;
      return $209;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21little2_scanPoundNamePK8encodingPKcS3_PS3_["X"]=1;

function __ZL14big2_prologTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tok;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 141; break;
    case 2: // $10
      var $11=$4;
      var $12=$3;
      var $13=$11;
      var $14=$12;
      var $15=(($13-$14)|0);
      $n=$15;
      var $16=$n;
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$n;
      var $21=$20 & -2;
      $n=$21;
      var $22=$n;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 141; break;
    case 5: // $25
      var $26=$3;
      var $27=$n;
      var $28=(($26+$27)|0);
      $4=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$3;
      var $37=(($36+1)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$2;
      var $41=$40;
      var $42=(($41+76)|0);
      var $43=(($42+$39)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $55 = $45;__label__ = 9; break;
    case 8: // $46
      var $47=$3;
      var $48=(($47)|0);
      var $49=HEAP8[($48)];
      var $50=$3;
      var $51=(($50+1)|0);
      var $52=HEAP8[($51)];
      var $53=__ZL17unicode_byte_typecc($49, $52);
      var $55 = $53;__label__ = 9; break;
    case 9: // $54
      var $55;
      if ($55 == 12) {
        __label__ = 10; break;
      }
      else if ($55 == 13) {
        __label__ = 11; break;
      }
      else if ($55 == 2) {
        __label__ = 12; break;
      }
      else if ($55 == 9) {
        __label__ = 22; break;
      }
      else if ($55 == 21 || $55 == 10) {
        __label__ = 25; break;
      }
      else if ($55 == 30) {
        __label__ = 39; break;
      }
      else if ($55 == 35) {
        __label__ = 40; break;
      }
      else if ($55 == 20) {
        __label__ = 41; break;
      }
      else if ($55 == 4) {
        __label__ = 42; break;
      }
      else if ($55 == 31) {
        __label__ = 53; break;
      }
      else if ($55 == 32) {
        __label__ = 54; break;
      }
      else if ($55 == 36) {
        __label__ = 65; break;
      }
      else if ($55 == 11) {
        __label__ = 66; break;
      }
      else if ($55 == 19) {
        __label__ = 67; break;
      }
      else if ($55 == 5) {
        __label__ = 68; break;
      }
      else if ($55 == 6) {
        __label__ = 71; break;
      }
      else if ($55 == 7) {
        __label__ = 74; break;
      }
      else if ($55 == 22 || $55 == 24) {
        __label__ = 77; break;
      }
      else if ($55 == 25 || $55 == 26 || $55 == 27 || $55 == 23) {
        __label__ = 78; break;
      }
      else if ($55 == 29) {
        __label__ = 79; break;
      }
      else {
      __label__ = 84; break;
      }
      
    case 10: // $56
      var $57=$2;
      var $58=$3;
      var $59=(($58+2)|0);
      var $60=$4;
      var $61=$5;
      var $62=__ZL12big2_scanLitiPK8encodingPKcS3_PS3_(12, $57, $59, $60, $61);
      $1=$62;
      __label__ = 141; break;
    case 11: // $63
      var $64=$2;
      var $65=$3;
      var $66=(($65+2)|0);
      var $67=$4;
      var $68=$5;
      var $69=__ZL12big2_scanLitiPK8encodingPKcS3_PS3_(13, $64, $66, $67, $68);
      $1=$69;
      __label__ = 141; break;
    case 12: // $70
      var $71=$3;
      var $72=(($71+2)|0);
      $3=$72;
      var $73=$3;
      var $74=$4;
      var $75=(($73)|0)==(($74)|0);
      if ($75) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $76
      $1=-1;
      __label__ = 141; break;
    case 14: // $77
      var $78=$3;
      var $79=(($78)|0);
      var $80=HEAP8[($79)];
      var $81=(($80 << 24) >> 24);
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $83
      var $84=$3;
      var $85=(($84+1)|0);
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$2;
      var $89=$88;
      var $90=(($89+76)|0);
      var $91=(($90+$87)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $103 = $93;__label__ = 17; break;
    case 16: // $94
      var $95=$3;
      var $96=(($95)|0);
      var $97=HEAP8[($96)];
      var $98=$3;
      var $99=(($98+1)|0);
      var $100=HEAP8[($99)];
      var $101=__ZL17unicode_byte_typecc($97, $100);
      var $103 = $101;__label__ = 17; break;
    case 17: // $102
      var $103;
      if ($103 == 16) {
        __label__ = 18; break;
      }
      else if ($103 == 15) {
        __label__ = 19; break;
      }
      else if ($103 == 22 || $103 == 24 || $103 == 29 || $103 == 5 || $103 == 6 || $103 == 7) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 18: // $104
      var $105=$2;
      var $106=$3;
      var $107=(($106+2)|0);
      var $108=$4;
      var $109=$5;
      var $110=__ZL13big2_scanDeclPK8encodingPKcS3_PS3_($105, $107, $108, $109);
      $1=$110;
      __label__ = 141; break;
    case 19: // $111
      var $112=$2;
      var $113=$3;
      var $114=(($113+2)|0);
      var $115=$4;
      var $116=$5;
      var $117=__ZL11big2_scanPiPK8encodingPKcS3_PS3_($112, $114, $115, $116);
      $1=$117;
      __label__ = 141; break;
    case 20: // $118
      var $119=$3;
      var $120=(($119-2)|0);
      var $121=$5;
      HEAP32[(($121)>>2)]=$120;
      $1=29;
      __label__ = 141; break;
    case 21: // $122
      var $123=$3;
      var $124=$5;
      HEAP32[(($124)>>2)]=$123;
      $1=0;
      __label__ = 141; break;
    case 22: // $125
      var $126=$3;
      var $127=(($126+2)|0);
      var $128=$4;
      var $129=(($127)|0)==(($128)|0);
      if ($129) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $130
      var $131=$4;
      var $132=$5;
      HEAP32[(($132)>>2)]=$131;
      $1=-15;
      __label__ = 141; break;
    case 24: // $133
      __label__ = 25; break;
    case 25: // $134
      __label__ = 26; break;
    case 26: // $135
      var $136=$3;
      var $137=(($136+2)|0);
      $3=$137;
      var $138=$3;
      var $139=$4;
      var $140=(($138)|0)==(($139)|0);
      if ($140) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $141
      __label__ = 38; break;
    case 28: // $142
      var $143=$3;
      var $144=(($143)|0);
      var $145=HEAP8[($144)];
      var $146=(($145 << 24) >> 24);
      var $147=(($146)|0)==0;
      if ($147) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $148
      var $149=$3;
      var $150=(($149+1)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$2;
      var $154=$153;
      var $155=(($154+76)|0);
      var $156=(($155+$152)|0);
      var $157=HEAPU8[($156)];
      var $158=(($157)&255);
      var $168 = $158;__label__ = 31; break;
    case 30: // $159
      var $160=$3;
      var $161=(($160)|0);
      var $162=HEAP8[($161)];
      var $163=$3;
      var $164=(($163+1)|0);
      var $165=HEAP8[($164)];
      var $166=__ZL17unicode_byte_typecc($162, $165);
      var $168 = $166;__label__ = 31; break;
    case 31: // $167
      var $168;
      if ($168 == 21 || $168 == 10) {
        __label__ = 32; break;
      }
      else if ($168 == 9) {
        __label__ = 33; break;
      }
      else {
      __label__ = 36; break;
      }
      
    case 32: // $169
      __label__ = 37; break;
    case 33: // $170
      var $171=$3;
      var $172=(($171+2)|0);
      var $173=$4;
      var $174=(($172)|0)!=(($173)|0);
      if ($174) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $175
      __label__ = 37; break;
    case 35: // $176
      __label__ = 36; break;
    case 36: // $177
      var $178=$3;
      var $179=$5;
      HEAP32[(($179)>>2)]=$178;
      $1=15;
      __label__ = 141; break;
    case 37: // $180
      __label__ = 26; break;
    case 38: // $181
      var $182=$3;
      var $183=$5;
      HEAP32[(($183)>>2)]=$182;
      $1=15;
      __label__ = 141; break;
    case 39: // $184
      var $185=$2;
      var $186=$3;
      var $187=(($186+2)|0);
      var $188=$4;
      var $189=$5;
      var $190=__ZL16big2_scanPercentPK8encodingPKcS3_PS3_($185, $187, $188, $189);
      $1=$190;
      __label__ = 141; break;
    case 40: // $191
      var $192=$3;
      var $193=(($192+2)|0);
      var $194=$5;
      HEAP32[(($194)>>2)]=$193;
      $1=38;
      __label__ = 141; break;
    case 41: // $195
      var $196=$3;
      var $197=(($196+2)|0);
      var $198=$5;
      HEAP32[(($198)>>2)]=$197;
      $1=25;
      __label__ = 141; break;
    case 42: // $199
      var $200=$3;
      var $201=(($200+2)|0);
      $3=$201;
      var $202=$3;
      var $203=$4;
      var $204=(($202)|0)==(($203)|0);
      if ($204) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $205
      $1=-26;
      __label__ = 141; break;
    case 44: // $206
      var $207=$3;
      var $208=(($207)|0);
      var $209=HEAP8[($208)];
      var $210=(($209 << 24) >> 24);
      var $211=(($210)|0)==0;
      if ($211) { __label__ = 45; break; } else { __label__ = 52; break; }
    case 45: // $212
      var $213=$3;
      var $214=(($213+1)|0);
      var $215=HEAP8[($214)];
      var $216=(($215 << 24) >> 24);
      var $217=(($216)|0)==93;
      if ($217) { __label__ = 46; break; } else { __label__ = 52; break; }
    case 46: // $218
      var $219=$3;
      var $220=(($219+2)|0);
      var $221=$4;
      var $222=(($220)|0)==(($221)|0);
      if ($222) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $223
      $1=-1;
      __label__ = 141; break;
    case 48: // $224
      var $225=$3;
      var $226=(($225+2)|0);
      var $227=(($226)|0);
      var $228=HEAP8[($227)];
      var $229=(($228 << 24) >> 24);
      var $230=(($229)|0)==0;
      if ($230) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $231
      var $232=$3;
      var $233=(($232+2)|0);
      var $234=(($233+1)|0);
      var $235=HEAP8[($234)];
      var $236=(($235 << 24) >> 24);
      var $237=(($236)|0)==62;
      if ($237) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $238
      var $239=$3;
      var $240=(($239+4)|0);
      var $241=$5;
      HEAP32[(($241)>>2)]=$240;
      $1=34;
      __label__ = 141; break;
    case 51: // $242
      __label__ = 52; break;
    case 52: // $243
      var $244=$3;
      var $245=$5;
      HEAP32[(($245)>>2)]=$244;
      $1=26;
      __label__ = 141; break;
    case 53: // $246
      var $247=$3;
      var $248=(($247+2)|0);
      var $249=$5;
      HEAP32[(($249)>>2)]=$248;
      $1=23;
      __label__ = 141; break;
    case 54: // $250
      var $251=$3;
      var $252=(($251+2)|0);
      $3=$252;
      var $253=$3;
      var $254=$4;
      var $255=(($253)|0)==(($254)|0);
      if ($255) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $256
      $1=-24;
      __label__ = 141; break;
    case 56: // $257
      var $258=$3;
      var $259=(($258)|0);
      var $260=HEAP8[($259)];
      var $261=(($260 << 24) >> 24);
      var $262=(($261)|0)==0;
      if ($262) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $263
      var $264=$3;
      var $265=(($264+1)|0);
      var $266=HEAPU8[($265)];
      var $267=(($266)&255);
      var $268=$2;
      var $269=$268;
      var $270=(($269+76)|0);
      var $271=(($270+$267)|0);
      var $272=HEAPU8[($271)];
      var $273=(($272)&255);
      var $283 = $273;__label__ = 59; break;
    case 58: // $274
      var $275=$3;
      var $276=(($275)|0);
      var $277=HEAP8[($276)];
      var $278=$3;
      var $279=(($278+1)|0);
      var $280=HEAP8[($279)];
      var $281=__ZL17unicode_byte_typecc($277, $280);
      var $283 = $281;__label__ = 59; break;
    case 59: // $282
      var $283;
      if ($283 == 33) {
        __label__ = 60; break;
      }
      else if ($283 == 15) {
        __label__ = 61; break;
      }
      else if ($283 == 34) {
        __label__ = 62; break;
      }
      else if ($283 == 9 || $283 == 10 || $283 == 21 || $283 == 11 || $283 == 35 || $283 == 36 || $283 == 32) {
        __label__ = 63; break;
      }
      else {
      __label__ = 64; break;
      }
      
    case 60: // $284
      var $285=$3;
      var $286=(($285+2)|0);
      var $287=$5;
      HEAP32[(($287)>>2)]=$286;
      $1=36;
      __label__ = 141; break;
    case 61: // $288
      var $289=$3;
      var $290=(($289+2)|0);
      var $291=$5;
      HEAP32[(($291)>>2)]=$290;
      $1=35;
      __label__ = 141; break;
    case 62: // $292
      var $293=$3;
      var $294=(($293+2)|0);
      var $295=$5;
      HEAP32[(($295)>>2)]=$294;
      $1=37;
      __label__ = 141; break;
    case 63: // $296
      var $297=$3;
      var $298=$5;
      HEAP32[(($298)>>2)]=$297;
      $1=24;
      __label__ = 141; break;
    case 64: // $299
      var $300=$3;
      var $301=$5;
      HEAP32[(($301)>>2)]=$300;
      $1=0;
      __label__ = 141; break;
    case 65: // $302
      var $303=$3;
      var $304=(($303+2)|0);
      var $305=$5;
      HEAP32[(($305)>>2)]=$304;
      $1=21;
      __label__ = 141; break;
    case 66: // $306
      var $307=$3;
      var $308=(($307+2)|0);
      var $309=$5;
      HEAP32[(($309)>>2)]=$308;
      $1=17;
      __label__ = 141; break;
    case 67: // $310
      var $311=$2;
      var $312=$3;
      var $313=(($312+2)|0);
      var $314=$4;
      var $315=$5;
      var $316=__ZL18big2_scanPoundNamePK8encodingPKcS3_PS3_($311, $313, $314, $315);
      $1=$316;
      __label__ = 141; break;
    case 68: // $317
      var $318=$4;
      var $319=$3;
      var $320=$318;
      var $321=$319;
      var $322=(($320-$321)|0);
      var $323=(($322)|0) < 2;
      if ($323) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $324
      $1=-2;
      __label__ = 141; break;
    case 70: // $325
      var $326=$3;
      var $327=$5;
      HEAP32[(($327)>>2)]=$326;
      $1=0;
      __label__ = 141; break;
    case 71: // $328
      var $329=$4;
      var $330=$3;
      var $331=$329;
      var $332=$330;
      var $333=(($331-$332)|0);
      var $334=(($333)|0) < 3;
      if ($334) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $335
      $1=-2;
      __label__ = 141; break;
    case 73: // $336
      var $337=$3;
      var $338=$5;
      HEAP32[(($338)>>2)]=$337;
      $1=0;
      __label__ = 141; break;
    case 74: // $339
      var $340=$4;
      var $341=$3;
      var $342=$340;
      var $343=$341;
      var $344=(($342-$343)|0);
      var $345=(($344)|0) < 4;
      if ($345) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $346
      $1=-2;
      __label__ = 141; break;
    case 76: // $347
      var $348=$3;
      var $349=$5;
      HEAP32[(($349)>>2)]=$348;
      $1=0;
      __label__ = 141; break;
    case 77: // $350
      $tok=18;
      var $351=$3;
      var $352=(($351+2)|0);
      $3=$352;
      __label__ = 85; break;
    case 78: // $353
      $tok=19;
      var $354=$3;
      var $355=(($354+2)|0);
      $3=$355;
      __label__ = 85; break;
    case 79: // $356
      var $357=$3;
      var $358=(($357)|0);
      var $359=HEAPU8[($358)];
      var $360=(($359)&255);
      var $361=((STRING_TABLE.__ZL11nmstrtPages+$360)|0);
      var $362=HEAPU8[($361)];
      var $363=(($362)&255);
      var $364=$363 << 3;
      var $365=$3;
      var $366=(($365+1)|0);
      var $367=HEAPU8[($366)];
      var $368=(($367)&255);
      var $369=$368 >> 5;
      var $370=(($364+$369)|0);
      var $371=((__ZL12namingBitmap+($370<<2))|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=$3;
      var $374=(($373+1)|0);
      var $375=HEAPU8[($374)];
      var $376=(($375)&255);
      var $377=$376 & 31;
      var $378=1 << $377;
      var $379=$372 & $378;
      var $380=(($379)|0)!=0;
      if ($380) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $381
      var $382=$3;
      var $383=(($382+2)|0);
      $3=$383;
      $tok=18;
      __label__ = 85; break;
    case 81: // $384
      var $385=$3;
      var $386=(($385)|0);
      var $387=HEAPU8[($386)];
      var $388=(($387)&255);
      var $389=((STRING_TABLE.__ZL9namePages+$388)|0);
      var $390=HEAPU8[($389)];
      var $391=(($390)&255);
      var $392=$391 << 3;
      var $393=$3;
      var $394=(($393+1)|0);
      var $395=HEAPU8[($394)];
      var $396=(($395)&255);
      var $397=$396 >> 5;
      var $398=(($392+$397)|0);
      var $399=((__ZL12namingBitmap+($398<<2))|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=$3;
      var $402=(($401+1)|0);
      var $403=HEAPU8[($402)];
      var $404=(($403)&255);
      var $405=$404 & 31;
      var $406=1 << $405;
      var $407=$400 & $406;
      var $408=(($407)|0)!=0;
      if ($408) { __label__ = 82; break; } else { __label__ = 83; break; }
    case 82: // $409
      var $410=$3;
      var $411=(($410+2)|0);
      $3=$411;
      $tok=19;
      __label__ = 85; break;
    case 83: // $412
      __label__ = 84; break;
    case 84: // $413
      var $414=$3;
      var $415=$5;
      HEAP32[(($415)>>2)]=$414;
      $1=0;
      __label__ = 141; break;
    case 85: // $416
      __label__ = 86; break;
    case 86: // $417
      var $418=$3;
      var $419=$4;
      var $420=(($418)|0)!=(($419)|0);
      if ($420) { __label__ = 87; break; } else { __label__ = 140; break; }
    case 87: // $421
      var $422=$3;
      var $423=(($422)|0);
      var $424=HEAP8[($423)];
      var $425=(($424 << 24) >> 24);
      var $426=(($425)|0)==0;
      if ($426) { __label__ = 88; break; } else { __label__ = 89; break; }
    case 88: // $427
      var $428=$3;
      var $429=(($428+1)|0);
      var $430=HEAPU8[($429)];
      var $431=(($430)&255);
      var $432=$2;
      var $433=$432;
      var $434=(($433+76)|0);
      var $435=(($434+$431)|0);
      var $436=HEAPU8[($435)];
      var $437=(($436)&255);
      var $447 = $437;__label__ = 90; break;
    case 89: // $438
      var $439=$3;
      var $440=(($439)|0);
      var $441=HEAP8[($440)];
      var $442=$3;
      var $443=(($442+1)|0);
      var $444=HEAP8[($443)];
      var $445=__ZL17unicode_byte_typecc($441, $444);
      var $447 = $445;__label__ = 90; break;
    case 90: // $446
      var $447;
      if ($447 == 29) {
        __label__ = 91; break;
      }
      else if ($447 == 22 || $447 == 24 || $447 == 25 || $447 == 26 || $447 == 27) {
        __label__ = 94; break;
      }
      else if ($447 == 5) {
        __label__ = 95; break;
      }
      else if ($447 == 6) {
        __label__ = 98; break;
      }
      else if ($447 == 7) {
        __label__ = 101; break;
      }
      else if ($447 == 11 || $447 == 32 || $447 == 35 || $447 == 36 || $447 == 20 || $447 == 30 || $447 == 21 || $447 == 9 || $447 == 10) {
        __label__ = 104; break;
      }
      else if ($447 == 23) {
        __label__ = 105; break;
      }
      else if ($447 == 34) {
        __label__ = 129; break;
      }
      else if ($447 == 33) {
        __label__ = 132; break;
      }
      else if ($447 == 15) {
        __label__ = 135; break;
      }
      else {
      __label__ = 138; break;
      }
      
    case 91: // $448
      var $449=$3;
      var $450=(($449)|0);
      var $451=HEAPU8[($450)];
      var $452=(($451)&255);
      var $453=((STRING_TABLE.__ZL9namePages+$452)|0);
      var $454=HEAPU8[($453)];
      var $455=(($454)&255);
      var $456=$455 << 3;
      var $457=$3;
      var $458=(($457+1)|0);
      var $459=HEAPU8[($458)];
      var $460=(($459)&255);
      var $461=$460 >> 5;
      var $462=(($456+$461)|0);
      var $463=((__ZL12namingBitmap+($462<<2))|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=$3;
      var $466=(($465+1)|0);
      var $467=HEAPU8[($466)];
      var $468=(($467)&255);
      var $469=$468 & 31;
      var $470=1 << $469;
      var $471=$464 & $470;
      var $472=(($471)|0)!=0;
      if ($472) { __label__ = 93; break; } else { __label__ = 92; break; }
    case 92: // $473
      var $474=$3;
      var $475=$5;
      HEAP32[(($475)>>2)]=$474;
      $1=0;
      __label__ = 141; break;
    case 93: // $476
      __label__ = 94; break;
    case 94: // $477
      var $478=$3;
      var $479=(($478+2)|0);
      $3=$479;
      __label__ = 139; break;
    case 95: // $480
      var $481=$4;
      var $482=$3;
      var $483=$481;
      var $484=$482;
      var $485=(($483-$484)|0);
      var $486=(($485)|0) < 2;
      if ($486) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $487
      $1=-2;
      __label__ = 141; break;
    case 97: // $488
      var $489=$3;
      var $490=$5;
      HEAP32[(($490)>>2)]=$489;
      $1=0;
      __label__ = 141; break;
    case 98: // $491
      var $492=$4;
      var $493=$3;
      var $494=$492;
      var $495=$493;
      var $496=(($494-$495)|0);
      var $497=(($496)|0) < 3;
      if ($497) { __label__ = 99; break; } else { __label__ = 100; break; }
    case 99: // $498
      $1=-2;
      __label__ = 141; break;
    case 100: // $499
      var $500=$3;
      var $501=$5;
      HEAP32[(($501)>>2)]=$500;
      $1=0;
      __label__ = 141; break;
    case 101: // $502
      var $503=$4;
      var $504=$3;
      var $505=$503;
      var $506=$504;
      var $507=(($505-$506)|0);
      var $508=(($507)|0) < 4;
      if ($508) { __label__ = 102; break; } else { __label__ = 103; break; }
    case 102: // $509
      $1=-2;
      __label__ = 141; break;
    case 103: // $510
      var $511=$3;
      var $512=$5;
      HEAP32[(($512)>>2)]=$511;
      $1=0;
      __label__ = 141; break;
    case 104: // $513
      var $514=$3;
      var $515=$5;
      HEAP32[(($515)>>2)]=$514;
      var $516=$tok;
      $1=$516;
      __label__ = 141; break;
    case 105: // $517
      var $518=$3;
      var $519=(($518+2)|0);
      $3=$519;
      var $520=$tok;
      if ($520 == 18) {
        __label__ = 106; break;
      }
      else if ($520 == 41) {
        __label__ = 127; break;
      }
      else {
      __label__ = 128; break;
      }
      
    case 106: // $521
      var $522=$3;
      var $523=$4;
      var $524=(($522)|0)==(($523)|0);
      if ($524) { __label__ = 107; break; } else { __label__ = 108; break; }
    case 107: // $525
      $1=-1;
      __label__ = 141; break;
    case 108: // $526
      $tok=41;
      var $527=$3;
      var $528=(($527)|0);
      var $529=HEAP8[($528)];
      var $530=(($529 << 24) >> 24);
      var $531=(($530)|0)==0;
      if ($531) { __label__ = 109; break; } else { __label__ = 110; break; }
    case 109: // $532
      var $533=$3;
      var $534=(($533+1)|0);
      var $535=HEAPU8[($534)];
      var $536=(($535)&255);
      var $537=$2;
      var $538=$537;
      var $539=(($538+76)|0);
      var $540=(($539+$536)|0);
      var $541=HEAPU8[($540)];
      var $542=(($541)&255);
      var $552 = $542;__label__ = 111; break;
    case 110: // $543
      var $544=$3;
      var $545=(($544)|0);
      var $546=HEAP8[($545)];
      var $547=$3;
      var $548=(($547+1)|0);
      var $549=HEAP8[($548)];
      var $550=__ZL17unicode_byte_typecc($546, $549);
      var $552 = $550;__label__ = 111; break;
    case 111: // $551
      var $552;
      if ($552 == 29) {
        __label__ = 112; break;
      }
      else if ($552 == 22 || $552 == 24 || $552 == 25 || $552 == 26 || $552 == 27) {
        __label__ = 115; break;
      }
      else if ($552 == 5) {
        __label__ = 116; break;
      }
      else if ($552 == 6) {
        __label__ = 119; break;
      }
      else if ($552 == 7) {
        __label__ = 122; break;
      }
      else {
      __label__ = 125; break;
      }
      
    case 112: // $553
      var $554=$3;
      var $555=(($554)|0);
      var $556=HEAPU8[($555)];
      var $557=(($556)&255);
      var $558=((STRING_TABLE.__ZL9namePages+$557)|0);
      var $559=HEAPU8[($558)];
      var $560=(($559)&255);
      var $561=$560 << 3;
      var $562=$3;
      var $563=(($562+1)|0);
      var $564=HEAPU8[($563)];
      var $565=(($564)&255);
      var $566=$565 >> 5;
      var $567=(($561+$566)|0);
      var $568=((__ZL12namingBitmap+($567<<2))|0);
      var $569=HEAP32[(($568)>>2)];
      var $570=$3;
      var $571=(($570+1)|0);
      var $572=HEAPU8[($571)];
      var $573=(($572)&255);
      var $574=$573 & 31;
      var $575=1 << $574;
      var $576=$569 & $575;
      var $577=(($576)|0)!=0;
      if ($577) { __label__ = 114; break; } else { __label__ = 113; break; }
    case 113: // $578
      var $579=$3;
      var $580=$5;
      HEAP32[(($580)>>2)]=$579;
      $1=0;
      __label__ = 141; break;
    case 114: // $581
      __label__ = 115; break;
    case 115: // $582
      var $583=$3;
      var $584=(($583+2)|0);
      $3=$584;
      __label__ = 126; break;
    case 116: // $585
      var $586=$4;
      var $587=$3;
      var $588=$586;
      var $589=$587;
      var $590=(($588-$589)|0);
      var $591=(($590)|0) < 2;
      if ($591) { __label__ = 117; break; } else { __label__ = 118; break; }
    case 117: // $592
      $1=-2;
      __label__ = 141; break;
    case 118: // $593
      var $594=$3;
      var $595=$5;
      HEAP32[(($595)>>2)]=$594;
      $1=0;
      __label__ = 141; break;
    case 119: // $596
      var $597=$4;
      var $598=$3;
      var $599=$597;
      var $600=$598;
      var $601=(($599-$600)|0);
      var $602=(($601)|0) < 3;
      if ($602) { __label__ = 120; break; } else { __label__ = 121; break; }
    case 120: // $603
      $1=-2;
      __label__ = 141; break;
    case 121: // $604
      var $605=$3;
      var $606=$5;
      HEAP32[(($606)>>2)]=$605;
      $1=0;
      __label__ = 141; break;
    case 122: // $607
      var $608=$4;
      var $609=$3;
      var $610=$608;
      var $611=$609;
      var $612=(($610-$611)|0);
      var $613=(($612)|0) < 4;
      if ($613) { __label__ = 123; break; } else { __label__ = 124; break; }
    case 123: // $614
      $1=-2;
      __label__ = 141; break;
    case 124: // $615
      var $616=$3;
      var $617=$5;
      HEAP32[(($617)>>2)]=$616;
      $1=0;
      __label__ = 141; break;
    case 125: // $618
      $tok=19;
      __label__ = 126; break;
    case 126: // $619
      __label__ = 128; break;
    case 127: // $620
      $tok=19;
      __label__ = 128; break;
    case 128: // $621
      __label__ = 139; break;
    case 129: // $622
      var $623=$tok;
      var $624=(($623)|0)==19;
      if ($624) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $625
      var $626=$3;
      var $627=$5;
      HEAP32[(($627)>>2)]=$626;
      $1=0;
      __label__ = 141; break;
    case 131: // $628
      var $629=$3;
      var $630=(($629+2)|0);
      var $631=$5;
      HEAP32[(($631)>>2)]=$630;
      $1=32;
      __label__ = 141; break;
    case 132: // $632
      var $633=$tok;
      var $634=(($633)|0)==19;
      if ($634) { __label__ = 133; break; } else { __label__ = 134; break; }
    case 133: // $635
      var $636=$3;
      var $637=$5;
      HEAP32[(($637)>>2)]=$636;
      $1=0;
      __label__ = 141; break;
    case 134: // $638
      var $639=$3;
      var $640=(($639+2)|0);
      var $641=$5;
      HEAP32[(($641)>>2)]=$640;
      $1=31;
      __label__ = 141; break;
    case 135: // $642
      var $643=$tok;
      var $644=(($643)|0)==19;
      if ($644) { __label__ = 136; break; } else { __label__ = 137; break; }
    case 136: // $645
      var $646=$3;
      var $647=$5;
      HEAP32[(($647)>>2)]=$646;
      $1=0;
      __label__ = 141; break;
    case 137: // $648
      var $649=$3;
      var $650=(($649+2)|0);
      var $651=$5;
      HEAP32[(($651)>>2)]=$650;
      $1=30;
      __label__ = 141; break;
    case 138: // $652
      var $653=$3;
      var $654=$5;
      HEAP32[(($654)>>2)]=$653;
      $1=0;
      __label__ = 141; break;
    case 139: // $655
      __label__ = 86; break;
    case 140: // $656
      var $657=$tok;
      var $658=(((-$657))|0);
      $1=$658;
      __label__ = 141; break;
    case 141: // $659
      var $660=$1;
      ;
      return $660;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14big2_prologTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL15big2_contentTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 73; break;
    case 2: // $10
      var $11=$4;
      var $12=$3;
      var $13=$11;
      var $14=$12;
      var $15=(($13-$14)|0);
      $n=$15;
      var $16=$n;
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$n;
      var $21=$20 & -2;
      $n=$21;
      var $22=$n;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 73; break;
    case 5: // $25
      var $26=$3;
      var $27=$n;
      var $28=(($26+$27)|0);
      $4=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$3;
      var $37=(($36+1)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$2;
      var $41=$40;
      var $42=(($41+76)|0);
      var $43=(($42+$39)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $55 = $45;__label__ = 9; break;
    case 8: // $46
      var $47=$3;
      var $48=(($47)|0);
      var $49=HEAP8[($48)];
      var $50=$3;
      var $51=(($50+1)|0);
      var $52=HEAP8[($51)];
      var $53=__ZL17unicode_byte_typecc($49, $52);
      var $55 = $53;__label__ = 9; break;
    case 9: // $54
      var $55;
      if ($55 == 2) {
        __label__ = 10; break;
      }
      else if ($55 == 3) {
        __label__ = 11; break;
      }
      else if ($55 == 9) {
        __label__ = 12; break;
      }
      else if ($55 == 10) {
        __label__ = 20; break;
      }
      else if ($55 == 4) {
        __label__ = 21; break;
      }
      else if ($55 == 5) {
        __label__ = 32; break;
      }
      else if ($55 == 6) {
        __label__ = 35; break;
      }
      else if ($55 == 7) {
        __label__ = 38; break;
      }
      else if ($55 == 0 || $55 == 1 || $55 == 8) {
        __label__ = 41; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 10: // $56
      var $57=$2;
      var $58=$3;
      var $59=(($58+2)|0);
      var $60=$4;
      var $61=$5;
      var $62=__ZL11big2_scanLtPK8encodingPKcS3_PS3_($57, $59, $60, $61);
      $1=$62;
      __label__ = 73; break;
    case 11: // $63
      var $64=$2;
      var $65=$3;
      var $66=(($65+2)|0);
      var $67=$4;
      var $68=$5;
      var $69=__ZL12big2_scanRefPK8encodingPKcS3_PS3_($64, $66, $67, $68);
      $1=$69;
      __label__ = 73; break;
    case 12: // $70
      var $71=$3;
      var $72=(($71+2)|0);
      $3=$72;
      var $73=$3;
      var $74=$4;
      var $75=(($73)|0)==(($74)|0);
      if ($75) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $76
      $1=-3;
      __label__ = 73; break;
    case 14: // $77
      var $78=$3;
      var $79=(($78)|0);
      var $80=HEAP8[($79)];
      var $81=(($80 << 24) >> 24);
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $83
      var $84=$3;
      var $85=(($84+1)|0);
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$2;
      var $89=$88;
      var $90=(($89+76)|0);
      var $91=(($90+$87)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $103 = $93;__label__ = 17; break;
    case 16: // $94
      var $95=$3;
      var $96=(($95)|0);
      var $97=HEAP8[($96)];
      var $98=$3;
      var $99=(($98+1)|0);
      var $100=HEAP8[($99)];
      var $101=__ZL17unicode_byte_typecc($97, $100);
      var $103 = $101;__label__ = 17; break;
    case 17: // $102
      var $103;
      var $104=(($103)|0)==10;
      if ($104) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $105
      var $106=$3;
      var $107=(($106+2)|0);
      $3=$107;
      __label__ = 19; break;
    case 19: // $108
      var $109=$3;
      var $110=$5;
      HEAP32[(($110)>>2)]=$109;
      $1=7;
      __label__ = 73; break;
    case 20: // $111
      var $112=$3;
      var $113=(($112+2)|0);
      var $114=$5;
      HEAP32[(($114)>>2)]=$113;
      $1=7;
      __label__ = 73; break;
    case 21: // $115
      var $116=$3;
      var $117=(($116+2)|0);
      $3=$117;
      var $118=$3;
      var $119=$4;
      var $120=(($118)|0)==(($119)|0);
      if ($120) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $121
      $1=-5;
      __label__ = 73; break;
    case 23: // $122
      var $123=$3;
      var $124=(($123)|0);
      var $125=HEAP8[($124)];
      var $126=(($125 << 24) >> 24);
      var $127=(($126)|0)==0;
      if ($127) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $128
      var $129=$3;
      var $130=(($129+1)|0);
      var $131=HEAP8[($130)];
      var $132=(($131 << 24) >> 24);
      var $133=(($132)|0)==93;
      if ($133) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $134
      __label__ = 43; break;
    case 26: // $135
      var $136=$3;
      var $137=(($136+2)|0);
      $3=$137;
      var $138=$3;
      var $139=$4;
      var $140=(($138)|0)==(($139)|0);
      if ($140) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $141
      $1=-5;
      __label__ = 73; break;
    case 28: // $142
      var $143=$3;
      var $144=(($143)|0);
      var $145=HEAP8[($144)];
      var $146=(($145 << 24) >> 24);
      var $147=(($146)|0)==0;
      if ($147) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $148
      var $149=$3;
      var $150=(($149+1)|0);
      var $151=HEAP8[($150)];
      var $152=(($151 << 24) >> 24);
      var $153=(($152)|0)==62;
      if ($153) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $154
      var $155=$3;
      var $156=(($155-2)|0);
      $3=$156;
      __label__ = 43; break;
    case 31: // $157
      var $158=$3;
      var $159=$5;
      HEAP32[(($159)>>2)]=$158;
      $1=0;
      __label__ = 73; break;
    case 32: // $160
      var $161=$4;
      var $162=$3;
      var $163=$161;
      var $164=$162;
      var $165=(($163-$164)|0);
      var $166=(($165)|0) < 2;
      if ($166) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $167
      $1=-2;
      __label__ = 73; break;
    case 34: // $168
      var $169=$3;
      var $170=(($169+2)|0);
      $3=$170;
      __label__ = 43; break;
    case 35: // $171
      var $172=$4;
      var $173=$3;
      var $174=$172;
      var $175=$173;
      var $176=(($174-$175)|0);
      var $177=(($176)|0) < 3;
      if ($177) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $178
      $1=-2;
      __label__ = 73; break;
    case 37: // $179
      var $180=$3;
      var $181=(($180+3)|0);
      $3=$181;
      __label__ = 43; break;
    case 38: // $182
      var $183=$4;
      var $184=$3;
      var $185=$183;
      var $186=$184;
      var $187=(($185-$186)|0);
      var $188=(($187)|0) < 4;
      if ($188) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $189
      $1=-2;
      __label__ = 73; break;
    case 40: // $190
      var $191=$3;
      var $192=(($191+4)|0);
      $3=$192;
      __label__ = 43; break;
    case 41: // $193
      var $194=$3;
      var $195=$5;
      HEAP32[(($195)>>2)]=$194;
      $1=0;
      __label__ = 73; break;
    case 42: // $196
      var $197=$3;
      var $198=(($197+2)|0);
      $3=$198;
      __label__ = 43; break;
    case 43: // $199
      __label__ = 44; break;
    case 44: // $200
      var $201=$3;
      var $202=$4;
      var $203=(($201)|0)!=(($202)|0);
      if ($203) { __label__ = 45; break; } else { __label__ = 72; break; }
    case 45: // $204
      var $205=$3;
      var $206=(($205)|0);
      var $207=HEAP8[($206)];
      var $208=(($207 << 24) >> 24);
      var $209=(($208)|0)==0;
      if ($209) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $210
      var $211=$3;
      var $212=(($211+1)|0);
      var $213=HEAPU8[($212)];
      var $214=(($213)&255);
      var $215=$2;
      var $216=$215;
      var $217=(($216+76)|0);
      var $218=(($217+$214)|0);
      var $219=HEAPU8[($218)];
      var $220=(($219)&255);
      var $230 = $220;__label__ = 48; break;
    case 47: // $221
      var $222=$3;
      var $223=(($222)|0);
      var $224=HEAP8[($223)];
      var $225=$3;
      var $226=(($225+1)|0);
      var $227=HEAP8[($226)];
      var $228=__ZL17unicode_byte_typecc($224, $227);
      var $230 = $228;__label__ = 48; break;
    case 48: // $229
      var $230;
      if ($230 == 5) {
        __label__ = 49; break;
      }
      else if ($230 == 6) {
        __label__ = 52; break;
      }
      else if ($230 == 7) {
        __label__ = 55; break;
      }
      else if ($230 == 4) {
        __label__ = 58; break;
      }
      else if ($230 == 3 || $230 == 2 || $230 == 0 || $230 == 1 || $230 == 8 || $230 == 9 || $230 == 10) {
        __label__ = 69; break;
      }
      else {
      __label__ = 70; break;
      }
      
    case 49: // $231
      var $232=$4;
      var $233=$3;
      var $234=$232;
      var $235=$233;
      var $236=(($234-$235)|0);
      var $237=(($236)|0) < 2;
      if ($237) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $238
      var $239=$3;
      var $240=$5;
      HEAP32[(($240)>>2)]=$239;
      $1=6;
      __label__ = 73; break;
    case 51: // $241
      var $242=$3;
      var $243=(($242+2)|0);
      $3=$243;
      __label__ = 71; break;
    case 52: // $244
      var $245=$4;
      var $246=$3;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      var $250=(($249)|0) < 3;
      if ($250) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $251
      var $252=$3;
      var $253=$5;
      HEAP32[(($253)>>2)]=$252;
      $1=6;
      __label__ = 73; break;
    case 54: // $254
      var $255=$3;
      var $256=(($255+3)|0);
      $3=$256;
      __label__ = 71; break;
    case 55: // $257
      var $258=$4;
      var $259=$3;
      var $260=$258;
      var $261=$259;
      var $262=(($260-$261)|0);
      var $263=(($262)|0) < 4;
      if ($263) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $264
      var $265=$3;
      var $266=$5;
      HEAP32[(($266)>>2)]=$265;
      $1=6;
      __label__ = 73; break;
    case 57: // $267
      var $268=$3;
      var $269=(($268+4)|0);
      $3=$269;
      __label__ = 71; break;
    case 58: // $270
      var $271=$3;
      var $272=(($271+2)|0);
      var $273=$4;
      var $274=(($272)|0)!=(($273)|0);
      if ($274) { __label__ = 59; break; } else { __label__ = 68; break; }
    case 59: // $275
      var $276=$3;
      var $277=(($276+2)|0);
      var $278=(($277)|0);
      var $279=HEAP8[($278)];
      var $280=(($279 << 24) >> 24);
      var $281=(($280)|0)==0;
      if ($281) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $282
      var $283=$3;
      var $284=(($283+2)|0);
      var $285=(($284+1)|0);
      var $286=HEAP8[($285)];
      var $287=(($286 << 24) >> 24);
      var $288=(($287)|0)==93;
      if ($288) { __label__ = 62; break; } else { __label__ = 61; break; }
    case 61: // $289
      var $290=$3;
      var $291=(($290+2)|0);
      $3=$291;
      __label__ = 71; break;
    case 62: // $292
      var $293=$3;
      var $294=(($293+4)|0);
      var $295=$4;
      var $296=(($294)|0)!=(($295)|0);
      if ($296) { __label__ = 63; break; } else { __label__ = 67; break; }
    case 63: // $297
      var $298=$3;
      var $299=(($298+4)|0);
      var $300=(($299)|0);
      var $301=HEAP8[($300)];
      var $302=(($301 << 24) >> 24);
      var $303=(($302)|0)==0;
      if ($303) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $304
      var $305=$3;
      var $306=(($305+4)|0);
      var $307=(($306+1)|0);
      var $308=HEAP8[($307)];
      var $309=(($308 << 24) >> 24);
      var $310=(($309)|0)==62;
      if ($310) { __label__ = 66; break; } else { __label__ = 65; break; }
    case 65: // $311
      var $312=$3;
      var $313=(($312+2)|0);
      $3=$313;
      __label__ = 71; break;
    case 66: // $314
      var $315=$3;
      var $316=(($315+4)|0);
      var $317=$5;
      HEAP32[(($317)>>2)]=$316;
      $1=0;
      __label__ = 73; break;
    case 67: // $318
      __label__ = 68; break;
    case 68: // $319
      __label__ = 69; break;
    case 69: // $320
      var $321=$3;
      var $322=$5;
      HEAP32[(($322)>>2)]=$321;
      $1=6;
      __label__ = 73; break;
    case 70: // $323
      var $324=$3;
      var $325=(($324+2)|0);
      $3=$325;
      __label__ = 71; break;
    case 71: // $326
      __label__ = 44; break;
    case 72: // $327
      var $328=$3;
      var $329=$5;
      HEAP32[(($329)>>2)]=$328;
      $1=6;
      __label__ = 73; break;
    case 73: // $330
      var $331=$1;
      ;
      return $331;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15big2_contentTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL20big2_cdataSectionTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 60; break;
    case 2: // $10
      var $11=$4;
      var $12=$3;
      var $13=$11;
      var $14=$12;
      var $15=(($13-$14)|0);
      $n=$15;
      var $16=$n;
      var $17=$16 & 1;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $19
      var $20=$n;
      var $21=$20 & -2;
      $n=$21;
      var $22=$n;
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 60; break;
    case 5: // $25
      var $26=$3;
      var $27=$n;
      var $28=(($26+$27)|0);
      $4=$28;
      __label__ = 6; break;
    case 6: // $29
      var $30=$3;
      var $31=(($30)|0);
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$3;
      var $37=(($36+1)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=$2;
      var $41=$40;
      var $42=(($41+76)|0);
      var $43=(($42+$39)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $55 = $45;__label__ = 9; break;
    case 8: // $46
      var $47=$3;
      var $48=(($47)|0);
      var $49=HEAP8[($48)];
      var $50=$3;
      var $51=(($50+1)|0);
      var $52=HEAP8[($51)];
      var $53=__ZL17unicode_byte_typecc($49, $52);
      var $55 = $53;__label__ = 9; break;
    case 9: // $54
      var $55;
      if ($55 == 4) {
        __label__ = 10; break;
      }
      else if ($55 == 9) {
        __label__ = 21; break;
      }
      else if ($55 == 10) {
        __label__ = 29; break;
      }
      else if ($55 == 5) {
        __label__ = 30; break;
      }
      else if ($55 == 6) {
        __label__ = 33; break;
      }
      else if ($55 == 7) {
        __label__ = 36; break;
      }
      else if ($55 == 0 || $55 == 1 || $55 == 8) {
        __label__ = 39; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 10: // $56
      var $57=$3;
      var $58=(($57+2)|0);
      $3=$58;
      var $59=$3;
      var $60=$4;
      var $61=(($59)|0)==(($60)|0);
      if ($61) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      $1=-1;
      __label__ = 60; break;
    case 12: // $63
      var $64=$3;
      var $65=(($64)|0);
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $68=(($67)|0)==0;
      if ($68) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $69
      var $70=$3;
      var $71=(($70+1)|0);
      var $72=HEAP8[($71)];
      var $73=(($72 << 24) >> 24);
      var $74=(($73)|0)==93;
      if ($74) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $75
      __label__ = 41; break;
    case 15: // $76
      var $77=$3;
      var $78=(($77+2)|0);
      $3=$78;
      var $79=$3;
      var $80=$4;
      var $81=(($79)|0)==(($80)|0);
      if ($81) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $82
      $1=-1;
      __label__ = 60; break;
    case 17: // $83
      var $84=$3;
      var $85=(($84)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $89
      var $90=$3;
      var $91=(($90+1)|0);
      var $92=HEAP8[($91)];
      var $93=(($92 << 24) >> 24);
      var $94=(($93)|0)==62;
      if ($94) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $95
      var $96=$3;
      var $97=(($96-2)|0);
      $3=$97;
      __label__ = 41; break;
    case 20: // $98
      var $99=$3;
      var $100=(($99+2)|0);
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=40;
      __label__ = 60; break;
    case 21: // $102
      var $103=$3;
      var $104=(($103+2)|0);
      $3=$104;
      var $105=$3;
      var $106=$4;
      var $107=(($105)|0)==(($106)|0);
      if ($107) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $108
      $1=-1;
      __label__ = 60; break;
    case 23: // $109
      var $110=$3;
      var $111=(($110)|0);
      var $112=HEAP8[($111)];
      var $113=(($112 << 24) >> 24);
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $115
      var $116=$3;
      var $117=(($116+1)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$2;
      var $121=$120;
      var $122=(($121+76)|0);
      var $123=(($122+$119)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $135 = $125;__label__ = 26; break;
    case 25: // $126
      var $127=$3;
      var $128=(($127)|0);
      var $129=HEAP8[($128)];
      var $130=$3;
      var $131=(($130+1)|0);
      var $132=HEAP8[($131)];
      var $133=__ZL17unicode_byte_typecc($129, $132);
      var $135 = $133;__label__ = 26; break;
    case 26: // $134
      var $135;
      var $136=(($135)|0)==10;
      if ($136) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $137
      var $138=$3;
      var $139=(($138+2)|0);
      $3=$139;
      __label__ = 28; break;
    case 28: // $140
      var $141=$3;
      var $142=$5;
      HEAP32[(($142)>>2)]=$141;
      $1=7;
      __label__ = 60; break;
    case 29: // $143
      var $144=$3;
      var $145=(($144+2)|0);
      var $146=$5;
      HEAP32[(($146)>>2)]=$145;
      $1=7;
      __label__ = 60; break;
    case 30: // $147
      var $148=$4;
      var $149=$3;
      var $150=$148;
      var $151=$149;
      var $152=(($150-$151)|0);
      var $153=(($152)|0) < 2;
      if ($153) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $154
      $1=-2;
      __label__ = 60; break;
    case 32: // $155
      var $156=$3;
      var $157=(($156+2)|0);
      $3=$157;
      __label__ = 41; break;
    case 33: // $158
      var $159=$4;
      var $160=$3;
      var $161=$159;
      var $162=$160;
      var $163=(($161-$162)|0);
      var $164=(($163)|0) < 3;
      if ($164) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $165
      $1=-2;
      __label__ = 60; break;
    case 35: // $166
      var $167=$3;
      var $168=(($167+3)|0);
      $3=$168;
      __label__ = 41; break;
    case 36: // $169
      var $170=$4;
      var $171=$3;
      var $172=$170;
      var $173=$171;
      var $174=(($172-$173)|0);
      var $175=(($174)|0) < 4;
      if ($175) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $176
      $1=-2;
      __label__ = 60; break;
    case 38: // $177
      var $178=$3;
      var $179=(($178+4)|0);
      $3=$179;
      __label__ = 41; break;
    case 39: // $180
      var $181=$3;
      var $182=$5;
      HEAP32[(($182)>>2)]=$181;
      $1=0;
      __label__ = 60; break;
    case 40: // $183
      var $184=$3;
      var $185=(($184+2)|0);
      $3=$185;
      __label__ = 41; break;
    case 41: // $186
      __label__ = 42; break;
    case 42: // $187
      var $188=$3;
      var $189=$4;
      var $190=(($188)|0)!=(($189)|0);
      if ($190) { __label__ = 43; break; } else { __label__ = 59; break; }
    case 43: // $191
      var $192=$3;
      var $193=(($192)|0);
      var $194=HEAP8[($193)];
      var $195=(($194 << 24) >> 24);
      var $196=(($195)|0)==0;
      if ($196) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $197
      var $198=$3;
      var $199=(($198+1)|0);
      var $200=HEAPU8[($199)];
      var $201=(($200)&255);
      var $202=$2;
      var $203=$202;
      var $204=(($203+76)|0);
      var $205=(($204+$201)|0);
      var $206=HEAPU8[($205)];
      var $207=(($206)&255);
      var $217 = $207;__label__ = 46; break;
    case 45: // $208
      var $209=$3;
      var $210=(($209)|0);
      var $211=HEAP8[($210)];
      var $212=$3;
      var $213=(($212+1)|0);
      var $214=HEAP8[($213)];
      var $215=__ZL17unicode_byte_typecc($211, $214);
      var $217 = $215;__label__ = 46; break;
    case 46: // $216
      var $217;
      if ($217 == 5) {
        __label__ = 47; break;
      }
      else if ($217 == 6) {
        __label__ = 50; break;
      }
      else if ($217 == 7) {
        __label__ = 53; break;
      }
      else if ($217 == 0 || $217 == 1 || $217 == 8 || $217 == 9 || $217 == 10 || $217 == 4) {
        __label__ = 56; break;
      }
      else {
      __label__ = 57; break;
      }
      
    case 47: // $218
      var $219=$4;
      var $220=$3;
      var $221=$219;
      var $222=$220;
      var $223=(($221-$222)|0);
      var $224=(($223)|0) < 2;
      if ($224) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $225
      var $226=$3;
      var $227=$5;
      HEAP32[(($227)>>2)]=$226;
      $1=6;
      __label__ = 60; break;
    case 49: // $228
      var $229=$3;
      var $230=(($229+2)|0);
      $3=$230;
      __label__ = 58; break;
    case 50: // $231
      var $232=$4;
      var $233=$3;
      var $234=$232;
      var $235=$233;
      var $236=(($234-$235)|0);
      var $237=(($236)|0) < 3;
      if ($237) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $238
      var $239=$3;
      var $240=$5;
      HEAP32[(($240)>>2)]=$239;
      $1=6;
      __label__ = 60; break;
    case 52: // $241
      var $242=$3;
      var $243=(($242+3)|0);
      $3=$243;
      __label__ = 58; break;
    case 53: // $244
      var $245=$4;
      var $246=$3;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      var $250=(($249)|0) < 4;
      if ($250) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $251
      var $252=$3;
      var $253=$5;
      HEAP32[(($253)>>2)]=$252;
      $1=6;
      __label__ = 60; break;
    case 55: // $254
      var $255=$3;
      var $256=(($255+4)|0);
      $3=$256;
      __label__ = 58; break;
    case 56: // $257
      var $258=$3;
      var $259=$5;
      HEAP32[(($259)>>2)]=$258;
      $1=6;
      __label__ = 60; break;
    case 57: // $260
      var $261=$3;
      var $262=(($261+2)|0);
      $3=$262;
      __label__ = 58; break;
    case 58: // $263
      __label__ = 42; break;
    case 59: // $264
      var $265=$3;
      var $266=$5;
      HEAP32[(($266)>>2)]=$265;
      $1=6;
      __label__ = 60; break;
    case 60: // $267
      var $268=$1;
      ;
      return $268;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20big2_cdataSectionTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL21big2_ignoreSectionTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $level;
      var $n;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      $level=0;
      var $6=$4;
      var $7=$3;
      var $8=$6;
      var $9=$7;
      var $10=(($8-$9)|0);
      $n=$10;
      var $11=$n;
      var $12=$11 & 1;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$n;
      var $16=$15 & -2;
      $n=$16;
      var $17=$3;
      var $18=$n;
      var $19=(($17+$18)|0);
      $4=$19;
      __label__ = 2; break;
    case 2: // $20
      __label__ = 3; break;
    case 3: // $21
      var $22=$3;
      var $23=$4;
      var $24=(($22)|0)!=(($23)|0);
      if ($24) { __label__ = 4; break; } else { __label__ = 44; break; }
    case 4: // $25
      var $26=$3;
      var $27=(($26)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      var $32=$3;
      var $33=(($32+1)|0);
      var $34=HEAPU8[($33)];
      var $35=(($34)&255);
      var $36=$2;
      var $37=$36;
      var $38=(($37+76)|0);
      var $39=(($38+$35)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $51 = $41;__label__ = 7; break;
    case 6: // $42
      var $43=$3;
      var $44=(($43)|0);
      var $45=HEAP8[($44)];
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAP8[($47)];
      var $49=__ZL17unicode_byte_typecc($45, $48);
      var $51 = $49;__label__ = 7; break;
    case 7: // $50
      var $51;
      if ($51 == 5) {
        __label__ = 8; break;
      }
      else if ($51 == 6) {
        __label__ = 11; break;
      }
      else if ($51 == 7) {
        __label__ = 14; break;
      }
      else if ($51 == 0 || $51 == 1 || $51 == 8) {
        __label__ = 17; break;
      }
      else if ($51 == 2) {
        __label__ = 18; break;
      }
      else if ($51 == 4) {
        __label__ = 29; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 8: // $52
      var $53=$4;
      var $54=$3;
      var $55=$53;
      var $56=$54;
      var $57=(($55-$56)|0);
      var $58=(($57)|0) < 2;
      if ($58) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $59
      $1=-2;
      __label__ = 45; break;
    case 10: // $60
      var $61=$3;
      var $62=(($61+2)|0);
      $3=$62;
      __label__ = 43; break;
    case 11: // $63
      var $64=$4;
      var $65=$3;
      var $66=$64;
      var $67=$65;
      var $68=(($66-$67)|0);
      var $69=(($68)|0) < 3;
      if ($69) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $70
      $1=-2;
      __label__ = 45; break;
    case 13: // $71
      var $72=$3;
      var $73=(($72+3)|0);
      $3=$73;
      __label__ = 43; break;
    case 14: // $74
      var $75=$4;
      var $76=$3;
      var $77=$75;
      var $78=$76;
      var $79=(($77-$78)|0);
      var $80=(($79)|0) < 4;
      if ($80) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $81
      $1=-2;
      __label__ = 45; break;
    case 16: // $82
      var $83=$3;
      var $84=(($83+4)|0);
      $3=$84;
      __label__ = 43; break;
    case 17: // $85
      var $86=$3;
      var $87=$5;
      HEAP32[(($87)>>2)]=$86;
      $1=0;
      __label__ = 45; break;
    case 18: // $88
      var $89=$3;
      var $90=(($89+2)|0);
      $3=$90;
      var $91=$4;
      var $92=(($90)|0)==(($91)|0);
      if ($92) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $93
      $1=-1;
      __label__ = 45; break;
    case 20: // $94
      var $95=$3;
      var $96=(($95)|0);
      var $97=HEAP8[($96)];
      var $98=(($97 << 24) >> 24);
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 21; break; } else { __label__ = 28; break; }
    case 21: // $100
      var $101=$3;
      var $102=(($101+1)|0);
      var $103=HEAP8[($102)];
      var $104=(($103 << 24) >> 24);
      var $105=(($104)|0)==33;
      if ($105) { __label__ = 22; break; } else { __label__ = 28; break; }
    case 22: // $106
      var $107=$3;
      var $108=(($107+2)|0);
      $3=$108;
      var $109=$4;
      var $110=(($108)|0)==(($109)|0);
      if ($110) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $111
      $1=-1;
      __label__ = 45; break;
    case 24: // $112
      var $113=$3;
      var $114=(($113)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24);
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $118
      var $119=$3;
      var $120=(($119+1)|0);
      var $121=HEAP8[($120)];
      var $122=(($121 << 24) >> 24);
      var $123=(($122)|0)==91;
      if ($123) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $124
      var $125=$level;
      var $126=(($125+1)|0);
      $level=$126;
      var $127=$3;
      var $128=(($127+2)|0);
      $3=$128;
      __label__ = 27; break;
    case 27: // $129
      __label__ = 28; break;
    case 28: // $130
      __label__ = 43; break;
    case 29: // $131
      var $132=$3;
      var $133=(($132+2)|0);
      $3=$133;
      var $134=$4;
      var $135=(($133)|0)==(($134)|0);
      if ($135) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $136
      $1=-1;
      __label__ = 45; break;
    case 31: // $137
      var $138=$3;
      var $139=(($138)|0);
      var $140=HEAP8[($139)];
      var $141=(($140 << 24) >> 24);
      var $142=(($141)|0)==0;
      if ($142) { __label__ = 32; break; } else { __label__ = 41; break; }
    case 32: // $143
      var $144=$3;
      var $145=(($144+1)|0);
      var $146=HEAP8[($145)];
      var $147=(($146 << 24) >> 24);
      var $148=(($147)|0)==93;
      if ($148) { __label__ = 33; break; } else { __label__ = 41; break; }
    case 33: // $149
      var $150=$3;
      var $151=(($150+2)|0);
      $3=$151;
      var $152=$4;
      var $153=(($151)|0)==(($152)|0);
      if ($153) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $154
      $1=-1;
      __label__ = 45; break;
    case 35: // $155
      var $156=$3;
      var $157=(($156)|0);
      var $158=HEAP8[($157)];
      var $159=(($158 << 24) >> 24);
      var $160=(($159)|0)==0;
      if ($160) { __label__ = 36; break; } else { __label__ = 40; break; }
    case 36: // $161
      var $162=$3;
      var $163=(($162+1)|0);
      var $164=HEAP8[($163)];
      var $165=(($164 << 24) >> 24);
      var $166=(($165)|0)==62;
      if ($166) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $167
      var $168=$3;
      var $169=(($168+2)|0);
      $3=$169;
      var $170=$level;
      var $171=(($170)|0)==0;
      if ($171) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $172
      var $173=$3;
      var $174=$5;
      HEAP32[(($174)>>2)]=$173;
      $1=42;
      __label__ = 45; break;
    case 39: // $175
      var $176=$level;
      var $177=(($176-1)|0);
      $level=$177;
      __label__ = 40; break;
    case 40: // $178
      __label__ = 41; break;
    case 41: // $179
      __label__ = 43; break;
    case 42: // $180
      var $181=$3;
      var $182=(($181+2)|0);
      $3=$182;
      __label__ = 43; break;
    case 43: // $183
      __label__ = 3; break;
    case 44: // $184
      $1=-1;
      __label__ = 45; break;
    case 45: // $185
      var $186=$1;
      ;
      return $186;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21big2_ignoreSectionTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL21big2_nameMatchesAsciiPK8encodingPKcS3_S3_($enc, $ptr1, $end1, $ptr2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr1;
      $4=$end1;
      $5=$ptr2;
      __label__ = 1; break;
    case 1: // $6
      var $7=$5;
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $10
      var $11=$3;
      var $12=$4;
      var $13=(($11)|0)==(($12)|0);
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      $1=0;
      __label__ = 10; break;
    case 4: // $15
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      var $22=$3;
      var $23=(($22+1)|0);
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24);
      var $26=$5;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=(($25)|0)==(($28)|0);
      if ($29) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $30
      $1=0;
      __label__ = 10; break;
    case 7: // $31
      __label__ = 8; break;
    case 8: // $32
      var $33=$3;
      var $34=(($33+2)|0);
      $3=$34;
      var $35=$5;
      var $36=(($35+1)|0);
      $5=$36;
      __label__ = 1; break;
    case 9: // $37
      var $38=$3;
      var $39=$4;
      var $40=(($38)|0)==(($39)|0);
      var $41=(($40)&1);
      $1=$41;
      __label__ = 10; break;
    case 10: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21big2_nameMatchesAsciiPK8encodingPKcS3_S3_["X"]=1;

function __ZL22big2_attributeValueTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $start;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 34; break;
    case 2: // $10
      var $11=$3;
      $start=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 33; break; }
    case 4: // $16
      var $17=$3;
      var $18=(($17)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$3;
      var $24=(($23+1)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$2;
      var $28=$27;
      var $29=(($28+76)|0);
      var $30=(($29+$26)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $42 = $32;__label__ = 7; break;
    case 6: // $33
      var $34=$3;
      var $35=(($34)|0);
      var $36=HEAP8[($35)];
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAP8[($38)];
      var $40=__ZL17unicode_byte_typecc($36, $39);
      var $42 = $40;__label__ = 7; break;
    case 7: // $41
      var $42;
      if ($42 == 5) {
        __label__ = 8; break;
      }
      else if ($42 == 6) {
        __label__ = 9; break;
      }
      else if ($42 == 7) {
        __label__ = 10; break;
      }
      else if ($42 == 3) {
        __label__ = 11; break;
      }
      else if ($42 == 2) {
        __label__ = 14; break;
      }
      else if ($42 == 10) {
        __label__ = 15; break;
      }
      else if ($42 == 9) {
        __label__ = 18; break;
      }
      else if ($42 == 21) {
        __label__ = 28; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 8: // $43
      var $44=$3;
      var $45=(($44+2)|0);
      $3=$45;
      __label__ = 32; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+3)|0);
      $3=$48;
      __label__ = 32; break;
    case 10: // $49
      var $50=$3;
      var $51=(($50+4)|0);
      $3=$51;
      __label__ = 32; break;
    case 11: // $52
      var $53=$3;
      var $54=$start;
      var $55=(($53)|0)==(($54)|0);
      if ($55) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $56
      var $57=$2;
      var $58=$3;
      var $59=(($58+2)|0);
      var $60=$4;
      var $61=$5;
      var $62=__ZL12big2_scanRefPK8encodingPKcS3_PS3_($57, $59, $60, $61);
      $1=$62;
      __label__ = 34; break;
    case 13: // $63
      var $64=$3;
      var $65=$5;
      HEAP32[(($65)>>2)]=$64;
      $1=6;
      __label__ = 34; break;
    case 14: // $66
      var $67=$3;
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 34; break;
    case 15: // $69
      var $70=$3;
      var $71=$start;
      var $72=(($70)|0)==(($71)|0);
      if ($72) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $73
      var $74=$3;
      var $75=(($74+2)|0);
      var $76=$5;
      HEAP32[(($76)>>2)]=$75;
      $1=7;
      __label__ = 34; break;
    case 17: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=6;
      __label__ = 34; break;
    case 18: // $80
      var $81=$3;
      var $82=$start;
      var $83=(($81)|0)==(($82)|0);
      if ($83) { __label__ = 19; break; } else { __label__ = 27; break; }
    case 19: // $84
      var $85=$3;
      var $86=(($85+2)|0);
      $3=$86;
      var $87=$3;
      var $88=$4;
      var $89=(($87)|0)==(($88)|0);
      if ($89) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $90
      $1=-3;
      __label__ = 34; break;
    case 21: // $91
      var $92=$3;
      var $93=(($92)|0);
      var $94=HEAP8[($93)];
      var $95=(($94 << 24) >> 24);
      var $96=(($95)|0)==0;
      if ($96) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $97
      var $98=$3;
      var $99=(($98+1)|0);
      var $100=HEAPU8[($99)];
      var $101=(($100)&255);
      var $102=$2;
      var $103=$102;
      var $104=(($103+76)|0);
      var $105=(($104+$101)|0);
      var $106=HEAPU8[($105)];
      var $107=(($106)&255);
      var $117 = $107;__label__ = 24; break;
    case 23: // $108
      var $109=$3;
      var $110=(($109)|0);
      var $111=HEAP8[($110)];
      var $112=$3;
      var $113=(($112+1)|0);
      var $114=HEAP8[($113)];
      var $115=__ZL17unicode_byte_typecc($111, $114);
      var $117 = $115;__label__ = 24; break;
    case 24: // $116
      var $117;
      var $118=(($117)|0)==10;
      if ($118) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $119
      var $120=$3;
      var $121=(($120+2)|0);
      $3=$121;
      __label__ = 26; break;
    case 26: // $122
      var $123=$3;
      var $124=$5;
      HEAP32[(($124)>>2)]=$123;
      $1=7;
      __label__ = 34; break;
    case 27: // $125
      var $126=$3;
      var $127=$5;
      HEAP32[(($127)>>2)]=$126;
      $1=6;
      __label__ = 34; break;
    case 28: // $128
      var $129=$3;
      var $130=$start;
      var $131=(($129)|0)==(($130)|0);
      if ($131) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $132
      var $133=$3;
      var $134=(($133+2)|0);
      var $135=$5;
      HEAP32[(($135)>>2)]=$134;
      $1=39;
      __label__ = 34; break;
    case 30: // $136
      var $137=$3;
      var $138=$5;
      HEAP32[(($138)>>2)]=$137;
      $1=6;
      __label__ = 34; break;
    case 31: // $139
      var $140=$3;
      var $141=(($140+2)|0);
      $3=$141;
      __label__ = 32; break;
    case 32: // $142
      __label__ = 3; break;
    case 33: // $143
      var $144=$3;
      var $145=$5;
      HEAP32[(($145)>>2)]=$144;
      $1=6;
      __label__ = 34; break;
    case 34: // $146
      var $147=$1;
      ;
      return $147;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL22big2_attributeValueTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL19big2_entityValueTokPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $start;
      var $tok;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-4;
      __label__ = 36; break;
    case 2: // $10
      var $11=$3;
      $start=$11;
      __label__ = 3; break;
    case 3: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 35; break; }
    case 4: // $16
      var $17=$3;
      var $18=(($17)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $22
      var $23=$3;
      var $24=(($23+1)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$2;
      var $28=$27;
      var $29=(($28+76)|0);
      var $30=(($29+$26)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $42 = $32;__label__ = 7; break;
    case 6: // $33
      var $34=$3;
      var $35=(($34)|0);
      var $36=HEAP8[($35)];
      var $37=$3;
      var $38=(($37+1)|0);
      var $39=HEAP8[($38)];
      var $40=__ZL17unicode_byte_typecc($36, $39);
      var $42 = $40;__label__ = 7; break;
    case 7: // $41
      var $42;
      if ($42 == 5) {
        __label__ = 8; break;
      }
      else if ($42 == 6) {
        __label__ = 9; break;
      }
      else if ($42 == 7) {
        __label__ = 10; break;
      }
      else if ($42 == 3) {
        __label__ = 11; break;
      }
      else if ($42 == 30) {
        __label__ = 14; break;
      }
      else if ($42 == 10) {
        __label__ = 20; break;
      }
      else if ($42 == 9) {
        __label__ = 23; break;
      }
      else {
      __label__ = 33; break;
      }
      
    case 8: // $43
      var $44=$3;
      var $45=(($44+2)|0);
      $3=$45;
      __label__ = 34; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+3)|0);
      $3=$48;
      __label__ = 34; break;
    case 10: // $49
      var $50=$3;
      var $51=(($50+4)|0);
      $3=$51;
      __label__ = 34; break;
    case 11: // $52
      var $53=$3;
      var $54=$start;
      var $55=(($53)|0)==(($54)|0);
      if ($55) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $56
      var $57=$2;
      var $58=$3;
      var $59=(($58+2)|0);
      var $60=$4;
      var $61=$5;
      var $62=__ZL12big2_scanRefPK8encodingPKcS3_PS3_($57, $59, $60, $61);
      $1=$62;
      __label__ = 36; break;
    case 13: // $63
      var $64=$3;
      var $65=$5;
      HEAP32[(($65)>>2)]=$64;
      $1=6;
      __label__ = 36; break;
    case 14: // $66
      var $67=$3;
      var $68=$start;
      var $69=(($67)|0)==(($68)|0);
      if ($69) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $70
      var $71=$2;
      var $72=$3;
      var $73=(($72+2)|0);
      var $74=$4;
      var $75=$5;
      var $76=__ZL16big2_scanPercentPK8encodingPKcS3_PS3_($71, $73, $74, $75);
      $tok=$76;
      var $77=$tok;
      var $78=(($77)|0)==22;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      var $83 = 0;__label__ = 18; break;
    case 17: // $80
      var $81=$tok;
      var $83 = $81;__label__ = 18; break;
    case 18: // $82
      var $83;
      $1=$83;
      __label__ = 36; break;
    case 19: // $84
      var $85=$3;
      var $86=$5;
      HEAP32[(($86)>>2)]=$85;
      $1=6;
      __label__ = 36; break;
    case 20: // $87
      var $88=$3;
      var $89=$start;
      var $90=(($88)|0)==(($89)|0);
      if ($90) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $91
      var $92=$3;
      var $93=(($92+2)|0);
      var $94=$5;
      HEAP32[(($94)>>2)]=$93;
      $1=7;
      __label__ = 36; break;
    case 22: // $95
      var $96=$3;
      var $97=$5;
      HEAP32[(($97)>>2)]=$96;
      $1=6;
      __label__ = 36; break;
    case 23: // $98
      var $99=$3;
      var $100=$start;
      var $101=(($99)|0)==(($100)|0);
      if ($101) { __label__ = 24; break; } else { __label__ = 32; break; }
    case 24: // $102
      var $103=$3;
      var $104=(($103+2)|0);
      $3=$104;
      var $105=$3;
      var $106=$4;
      var $107=(($105)|0)==(($106)|0);
      if ($107) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $108
      $1=-3;
      __label__ = 36; break;
    case 26: // $109
      var $110=$3;
      var $111=(($110)|0);
      var $112=HEAP8[($111)];
      var $113=(($112 << 24) >> 24);
      var $114=(($113)|0)==0;
      if ($114) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $115
      var $116=$3;
      var $117=(($116+1)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$2;
      var $121=$120;
      var $122=(($121+76)|0);
      var $123=(($122+$119)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $135 = $125;__label__ = 29; break;
    case 28: // $126
      var $127=$3;
      var $128=(($127)|0);
      var $129=HEAP8[($128)];
      var $130=$3;
      var $131=(($130+1)|0);
      var $132=HEAP8[($131)];
      var $133=__ZL17unicode_byte_typecc($129, $132);
      var $135 = $133;__label__ = 29; break;
    case 29: // $134
      var $135;
      var $136=(($135)|0)==10;
      if ($136) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $137
      var $138=$3;
      var $139=(($138+2)|0);
      $3=$139;
      __label__ = 31; break;
    case 31: // $140
      var $141=$3;
      var $142=$5;
      HEAP32[(($142)>>2)]=$141;
      $1=7;
      __label__ = 36; break;
    case 32: // $143
      var $144=$3;
      var $145=$5;
      HEAP32[(($145)>>2)]=$144;
      $1=6;
      __label__ = 36; break;
    case 33: // $146
      var $147=$3;
      var $148=(($147+2)|0);
      $3=$148;
      __label__ = 34; break;
    case 34: // $149
      __label__ = 3; break;
    case 35: // $150
      var $151=$3;
      var $152=$5;
      HEAP32[(($152)>>2)]=$151;
      $1=6;
      __label__ = 36; break;
    case 36: // $153
      var $154=$1;
      ;
      return $154;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19big2_entityValueTokPK8encodingPKcS3_PS3_["X"]=1;

function __ZL13big2_sameNamePK8encodingPKcS3_($enc, $ptr1, $ptr2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$enc;
      $3=$ptr1;
      $4=$ptr2;
      __label__ = 1; break;
    case 1: // $5
      var $6=$3;
      var $7=(($6)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=$3;
      var $13=(($12+1)|0);
      var $14=HEAPU8[($13)];
      var $15=(($14)&255);
      var $16=$2;
      var $17=$16;
      var $18=(($17+76)|0);
      var $19=(($18+$15)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $31 = $21;__label__ = 4; break;
    case 3: // $22
      var $23=$3;
      var $24=(($23)|0);
      var $25=HEAP8[($24)];
      var $26=$3;
      var $27=(($26+1)|0);
      var $28=HEAP8[($27)];
      var $29=__ZL17unicode_byte_typecc($25, $28);
      var $31 = $29;__label__ = 4; break;
    case 4: // $30
      var $31;
      if ($31 == 7) {
        __label__ = 5; break;
      }
      else if ($31 == 6) {
        __label__ = 8; break;
      }
      else if ($31 == 5) {
        __label__ = 11; break;
      }
      else if ($31 == 29 || $31 == 22 || $31 == 23 || $31 == 24 || $31 == 25 || $31 == 26 || $31 == 27) {
        __label__ = 16; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 5: // $32
      var $33=$3;
      var $34=(($33+1)|0);
      $3=$34;
      var $35=HEAP8[($33)];
      var $36=(($35 << 24) >> 24);
      var $37=$4;
      var $38=(($37+1)|0);
      $4=$38;
      var $39=HEAP8[($37)];
      var $40=(($39 << 24) >> 24);
      var $41=(($36)|0)!=(($40)|0);
      if ($41) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $42
      $1=0;
      __label__ = 28; break;
    case 7: // $43
      __label__ = 8; break;
    case 8: // $44
      var $45=$3;
      var $46=(($45+1)|0);
      $3=$46;
      var $47=HEAP8[($45)];
      var $48=(($47 << 24) >> 24);
      var $49=$4;
      var $50=(($49+1)|0);
      $4=$50;
      var $51=HEAP8[($49)];
      var $52=(($51 << 24) >> 24);
      var $53=(($48)|0)!=(($52)|0);
      if ($53) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $54
      $1=0;
      __label__ = 28; break;
    case 10: // $55
      __label__ = 11; break;
    case 11: // $56
      var $57=$3;
      var $58=(($57+1)|0);
      $3=$58;
      var $59=HEAP8[($57)];
      var $60=(($59 << 24) >> 24);
      var $61=$4;
      var $62=(($61+1)|0);
      $4=$62;
      var $63=HEAP8[($61)];
      var $64=(($63 << 24) >> 24);
      var $65=(($60)|0)!=(($64)|0);
      if ($65) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $66
      $1=0;
      __label__ = 28; break;
    case 13: // $67
      var $68=$3;
      var $69=(($68+1)|0);
      $3=$69;
      var $70=HEAP8[($68)];
      var $71=(($70 << 24) >> 24);
      var $72=$4;
      var $73=(($72+1)|0);
      $4=$73;
      var $74=HEAP8[($72)];
      var $75=(($74 << 24) >> 24);
      var $76=(($71)|0)!=(($75)|0);
      if ($76) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $77
      $1=0;
      __label__ = 28; break;
    case 15: // $78
      __label__ = 27; break;
    case 16: // $79
      var $80=$4;
      var $81=(($80+1)|0);
      $4=$81;
      var $82=HEAP8[($80)];
      var $83=(($82 << 24) >> 24);
      var $84=$3;
      var $85=(($84+1)|0);
      $3=$85;
      var $86=HEAP8[($84)];
      var $87=(($86 << 24) >> 24);
      var $88=(($83)|0)!=(($87)|0);
      if ($88) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $89
      $1=0;
      __label__ = 28; break;
    case 18: // $90
      var $91=$4;
      var $92=(($91+1)|0);
      $4=$92;
      var $93=HEAP8[($91)];
      var $94=(($93 << 24) >> 24);
      var $95=$3;
      var $96=(($95+1)|0);
      $3=$96;
      var $97=HEAP8[($95)];
      var $98=(($97 << 24) >> 24);
      var $99=(($94)|0)!=(($98)|0);
      if ($99) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $100
      $1=0;
      __label__ = 28; break;
    case 20: // $101
      __label__ = 27; break;
    case 21: // $102
      var $103=$4;
      var $104=(($103)|0);
      var $105=HEAP8[($104)];
      var $106=(($105 << 24) >> 24);
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $108
      var $109=$4;
      var $110=(($109+1)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$2;
      var $114=$113;
      var $115=(($114+76)|0);
      var $116=(($115+$112)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $128 = $118;__label__ = 24; break;
    case 23: // $119
      var $120=$4;
      var $121=(($120)|0);
      var $122=HEAP8[($121)];
      var $123=$4;
      var $124=(($123+1)|0);
      var $125=HEAP8[($124)];
      var $126=__ZL17unicode_byte_typecc($122, $125);
      var $128 = $126;__label__ = 24; break;
    case 24: // $127
      var $128;
      if ($128 == 5 || $128 == 6 || $128 == 7 || $128 == 29 || $128 == 22 || $128 == 23 || $128 == 24 || $128 == 25 || $128 == 26 || $128 == 27) {
        __label__ = 25; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 25: // $129
      $1=0;
      __label__ = 28; break;
    case 26: // $130
      $1=1;
      __label__ = 28; break;
    case 27: // $131
      __label__ = 1; break;
    case 28: // $132
      var $133=$1;
      ;
      return $133;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13big2_sameNamePK8encodingPKcS3_["X"]=1;

function __ZL15big2_nameLengthPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $start;
      $1=$enc;
      $2=$ptr;
      var $3=$2;
      $start=$3;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5)|0);
      var $7=HEAP8[($6)];
      var $8=(($7 << 24) >> 24);
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      var $11=$2;
      var $12=(($11+1)|0);
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$1;
      var $16=$15;
      var $17=(($16+76)|0);
      var $18=(($17+$14)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $30 = $20;__label__ = 4; break;
    case 3: // $21
      var $22=$2;
      var $23=(($22)|0);
      var $24=HEAP8[($23)];
      var $25=$2;
      var $26=(($25+1)|0);
      var $27=HEAP8[($26)];
      var $28=__ZL17unicode_byte_typecc($24, $27);
      var $30 = $28;__label__ = 4; break;
    case 4: // $29
      var $30;
      if ($30 == 5) {
        __label__ = 5; break;
      }
      else if ($30 == 6) {
        __label__ = 6; break;
      }
      else if ($30 == 7) {
        __label__ = 7; break;
      }
      else if ($30 == 29 || $30 == 22 || $30 == 23 || $30 == 24 || $30 == 25 || $30 == 26 || $30 == 27) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 5: // $31
      var $32=$2;
      var $33=(($32+2)|0);
      $2=$33;
      __label__ = 10; break;
    case 6: // $34
      var $35=$2;
      var $36=(($35+3)|0);
      $2=$36;
      __label__ = 10; break;
    case 7: // $37
      var $38=$2;
      var $39=(($38+4)|0);
      $2=$39;
      __label__ = 10; break;
    case 8: // $40
      var $41=$2;
      var $42=(($41+2)|0);
      $2=$42;
      __label__ = 10; break;
    case 9: // $43
      var $44=$2;
      var $45=$start;
      var $46=$44;
      var $47=$45;
      var $48=(($46-$47)|0);
      ;
      return $48;
    case 10: // $49
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15big2_nameLengthPK8encodingPKc["X"]=1;

function __ZL10big2_skipSPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$enc;
      $2=$ptr;
      __label__ = 1; break;
    case 1: // $3
      var $4=$2;
      var $5=(($4)|0);
      var $6=HEAP8[($5)];
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($10+1)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$1;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $29 = $19;__label__ = 4; break;
    case 3: // $20
      var $21=$2;
      var $22=(($21)|0);
      var $23=HEAP8[($22)];
      var $24=$2;
      var $25=(($24+1)|0);
      var $26=HEAP8[($25)];
      var $27=__ZL17unicode_byte_typecc($23, $26);
      var $29 = $27;__label__ = 4; break;
    case 4: // $28
      var $29;
      if ($29 == 10 || $29 == 9 || $29 == 21) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 5: // $30
      var $31=$2;
      var $32=(($31+2)|0);
      $2=$32;
      __label__ = 7; break;
    case 6: // $33
      var $34=$2;
      ;
      return $34;
    case 7: // $35
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL12big2_getAttsPK8encodingPKciP9ATTRIBUTE($enc, $ptr, $attsMax, $atts) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $state;
      var $nAtts;
      var $open;
      $1=$enc;
      $2=$ptr;
      $3=$attsMax;
      $4=$atts;
      $state=1;
      $nAtts=0;
      $open=0;
      var $5=$2;
      var $6=(($5+2)|0);
      $2=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      var $14=$2;
      var $15=(($14+1)|0);
      var $16=HEAPU8[($15)];
      var $17=(($16)&255);
      var $18=$1;
      var $19=$18;
      var $20=(($19+76)|0);
      var $21=(($20+$17)|0);
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $33 = $23;__label__ = 4; break;
    case 3: // $24
      var $25=$2;
      var $26=(($25)|0);
      var $27=HEAP8[($26)];
      var $28=$2;
      var $29=(($28+1)|0);
      var $30=HEAP8[($29)];
      var $31=__ZL17unicode_byte_typecc($27, $30);
      var $33 = $31;__label__ = 4; break;
    case 4: // $32
      var $33;
      if ($33 == 5) {
        __label__ = 5; break;
      }
      else if ($33 == 6) {
        __label__ = 10; break;
      }
      else if ($33 == 7) {
        __label__ = 15; break;
      }
      else if ($33 == 29 || $33 == 22 || $33 == 24) {
        __label__ = 20; break;
      }
      else if ($33 == 12) {
        __label__ = 25; break;
      }
      else if ($33 == 13) {
        __label__ = 35; break;
      }
      else if ($33 == 3) {
        __label__ = 45; break;
      }
      else if ($33 == 21) {
        __label__ = 48; break;
      }
      else if ($33 == 9 || $33 == 10) {
        __label__ = 69; break;
      }
      else if ($33 == 11 || $33 == 17) {
        __label__ = 76; break;
      }
      else {
      __label__ = 79; break;
      }
      
    case 5: // $34
      var $35=$state;
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $37
      var $38=$nAtts;
      var $39=$3;
      var $40=(($38)|0) < (($39)|0);
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      var $42=$2;
      var $43=$nAtts;
      var $44=$4;
      var $45=(($44+($43<<4))|0);
      var $46=(($45)|0);
      HEAP32[(($46)>>2)]=$42;
      var $47=$nAtts;
      var $48=$4;
      var $49=(($48+($47<<4))|0);
      var $50=(($49+12)|0);
      HEAP8[($50)]=1;
      __label__ = 8; break;
    case 8: // $51
      $state=1;
      __label__ = 9; break;
    case 9: // $52
      var $53=$2;
      var $54=(($53)|0);
      $2=$54;
      __label__ = 80; break;
    case 10: // $55
      var $56=$state;
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $58
      var $59=$nAtts;
      var $60=$3;
      var $61=(($59)|0) < (($60)|0);
      if ($61) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $62
      var $63=$2;
      var $64=$nAtts;
      var $65=$4;
      var $66=(($65+($64<<4))|0);
      var $67=(($66)|0);
      HEAP32[(($67)>>2)]=$63;
      var $68=$nAtts;
      var $69=$4;
      var $70=(($69+($68<<4))|0);
      var $71=(($70+12)|0);
      HEAP8[($71)]=1;
      __label__ = 13; break;
    case 13: // $72
      $state=1;
      __label__ = 14; break;
    case 14: // $73
      var $74=$2;
      var $75=(($74+1)|0);
      $2=$75;
      __label__ = 80; break;
    case 15: // $76
      var $77=$state;
      var $78=(($77)|0)==0;
      if ($78) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $79
      var $80=$nAtts;
      var $81=$3;
      var $82=(($80)|0) < (($81)|0);
      if ($82) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $83
      var $84=$2;
      var $85=$nAtts;
      var $86=$4;
      var $87=(($86+($85<<4))|0);
      var $88=(($87)|0);
      HEAP32[(($88)>>2)]=$84;
      var $89=$nAtts;
      var $90=$4;
      var $91=(($90+($89<<4))|0);
      var $92=(($91+12)|0);
      HEAP8[($92)]=1;
      __label__ = 18; break;
    case 18: // $93
      $state=1;
      __label__ = 19; break;
    case 19: // $94
      var $95=$2;
      var $96=(($95+2)|0);
      $2=$96;
      __label__ = 80; break;
    case 20: // $97
      var $98=$state;
      var $99=(($98)|0)==0;
      if ($99) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $100
      var $101=$nAtts;
      var $102=$3;
      var $103=(($101)|0) < (($102)|0);
      if ($103) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $104
      var $105=$2;
      var $106=$nAtts;
      var $107=$4;
      var $108=(($107+($106<<4))|0);
      var $109=(($108)|0);
      HEAP32[(($109)>>2)]=$105;
      var $110=$nAtts;
      var $111=$4;
      var $112=(($111+($110<<4))|0);
      var $113=(($112+12)|0);
      HEAP8[($113)]=1;
      __label__ = 23; break;
    case 23: // $114
      $state=1;
      __label__ = 24; break;
    case 24: // $115
      __label__ = 80; break;
    case 25: // $116
      var $117=$state;
      var $118=(($117)|0)!=2;
      if ($118) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $119
      var $120=$nAtts;
      var $121=$3;
      var $122=(($120)|0) < (($121)|0);
      if ($122) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $123
      var $124=$2;
      var $125=(($124+2)|0);
      var $126=$nAtts;
      var $127=$4;
      var $128=(($127+($126<<4))|0);
      var $129=(($128+4)|0);
      HEAP32[(($129)>>2)]=$125;
      __label__ = 28; break;
    case 28: // $130
      $state=2;
      $open=12;
      __label__ = 34; break;
    case 29: // $131
      var $132=$open;
      var $133=(($132)|0)==12;
      if ($133) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $134
      $state=0;
      var $135=$nAtts;
      var $136=$3;
      var $137=(($135)|0) < (($136)|0);
      if ($137) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $138
      var $139=$2;
      var $140=$nAtts;
      var $141=$4;
      var $142=(($141+($140<<4))|0);
      var $143=(($142+8)|0);
      HEAP32[(($143)>>2)]=$139;
      __label__ = 32; break;
    case 32: // $144
      var $145=$nAtts;
      var $146=(($145+1)|0);
      $nAtts=$146;
      __label__ = 33; break;
    case 33: // $147
      __label__ = 34; break;
    case 34: // $148
      __label__ = 80; break;
    case 35: // $149
      var $150=$state;
      var $151=(($150)|0)!=2;
      if ($151) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $152
      var $153=$nAtts;
      var $154=$3;
      var $155=(($153)|0) < (($154)|0);
      if ($155) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $156
      var $157=$2;
      var $158=(($157+2)|0);
      var $159=$nAtts;
      var $160=$4;
      var $161=(($160+($159<<4))|0);
      var $162=(($161+4)|0);
      HEAP32[(($162)>>2)]=$158;
      __label__ = 38; break;
    case 38: // $163
      $state=2;
      $open=13;
      __label__ = 44; break;
    case 39: // $164
      var $165=$open;
      var $166=(($165)|0)==13;
      if ($166) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $167
      $state=0;
      var $168=$nAtts;
      var $169=$3;
      var $170=(($168)|0) < (($169)|0);
      if ($170) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $171
      var $172=$2;
      var $173=$nAtts;
      var $174=$4;
      var $175=(($174+($173<<4))|0);
      var $176=(($175+8)|0);
      HEAP32[(($176)>>2)]=$172;
      __label__ = 42; break;
    case 42: // $177
      var $178=$nAtts;
      var $179=(($178+1)|0);
      $nAtts=$179;
      __label__ = 43; break;
    case 43: // $180
      __label__ = 44; break;
    case 44: // $181
      __label__ = 80; break;
    case 45: // $182
      var $183=$nAtts;
      var $184=$3;
      var $185=(($183)|0) < (($184)|0);
      if ($185) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $186
      var $187=$nAtts;
      var $188=$4;
      var $189=(($188+($187<<4))|0);
      var $190=(($189+12)|0);
      HEAP8[($190)]=0;
      __label__ = 47; break;
    case 47: // $191
      __label__ = 80; break;
    case 48: // $192
      var $193=$state;
      var $194=(($193)|0)==1;
      if ($194) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $195
      $state=0;
      __label__ = 68; break;
    case 50: // $196
      var $197=$state;
      var $198=(($197)|0)==2;
      if ($198) { __label__ = 51; break; } else { __label__ = 67; break; }
    case 51: // $199
      var $200=$nAtts;
      var $201=$3;
      var $202=(($200)|0) < (($201)|0);
      if ($202) { __label__ = 52; break; } else { __label__ = 67; break; }
    case 52: // $203
      var $204=$nAtts;
      var $205=$4;
      var $206=(($205+($204<<4))|0);
      var $207=(($206+12)|0);
      var $208=HEAP8[($207)];
      var $209=(($208 << 24) >> 24)!=0;
      if ($209) { __label__ = 53; break; } else { __label__ = 67; break; }
    case 53: // $210
      var $211=$2;
      var $212=$nAtts;
      var $213=$4;
      var $214=(($213+($212<<4))|0);
      var $215=(($214+4)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($211)|0)==(($216)|0);
      if ($217) { __label__ = 66; break; } else { __label__ = 54; break; }
    case 54: // $218
      var $219=$2;
      var $220=(($219)|0);
      var $221=HEAP8[($220)];
      var $222=(($221 << 24) >> 24);
      var $223=(($222)|0)==0;
      if ($223) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $224
      var $225=$2;
      var $226=(($225+1)|0);
      var $227=HEAP8[($226)];
      var $228=(($227 << 24) >> 24);
      var $231 = $228;__label__ = 57; break;
    case 56: // $229
      var $231 = -1;__label__ = 57; break;
    case 57: // $230
      var $231;
      var $232=(($231)|0)!=32;
      if ($232) { __label__ = 66; break; } else { __label__ = 58; break; }
    case 58: // $233
      var $234=$2;
      var $235=(($234+2)|0);
      var $236=(($235)|0);
      var $237=HEAP8[($236)];
      var $238=(($237 << 24) >> 24);
      var $239=(($238)|0)==0;
      if ($239) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $240
      var $241=$2;
      var $242=(($241+2)|0);
      var $243=(($242+1)|0);
      var $244=HEAP8[($243)];
      var $245=(($244 << 24) >> 24);
      var $248 = $245;__label__ = 61; break;
    case 60: // $246
      var $248 = -1;__label__ = 61; break;
    case 61: // $247
      var $248;
      var $249=(($248)|0)==32;
      if ($249) { __label__ = 66; break; } else { __label__ = 62; break; }
    case 62: // $250
      var $251=$2;
      var $252=(($251+2)|0);
      var $253=(($252)|0);
      var $254=HEAP8[($253)];
      var $255=(($254 << 24) >> 24);
      var $256=(($255)|0)==0;
      if ($256) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $257
      var $258=$2;
      var $259=(($258+2)|0);
      var $260=(($259+1)|0);
      var $261=HEAPU8[($260)];
      var $262=(($261)&255);
      var $263=$1;
      var $264=$263;
      var $265=(($264+76)|0);
      var $266=(($265+$262)|0);
      var $267=HEAPU8[($266)];
      var $268=(($267)&255);
      var $280 = $268;__label__ = 65; break;
    case 64: // $269
      var $270=$2;
      var $271=(($270+2)|0);
      var $272=(($271)|0);
      var $273=HEAP8[($272)];
      var $274=$2;
      var $275=(($274+2)|0);
      var $276=(($275+1)|0);
      var $277=HEAP8[($276)];
      var $278=__ZL17unicode_byte_typecc($273, $277);
      var $280 = $278;__label__ = 65; break;
    case 65: // $279
      var $280;
      var $281=$open;
      var $282=(($280)|0)==(($281)|0);
      if ($282) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $283
      var $284=$nAtts;
      var $285=$4;
      var $286=(($285+($284<<4))|0);
      var $287=(($286+12)|0);
      HEAP8[($287)]=0;
      __label__ = 67; break;
    case 67: // $288
      __label__ = 68; break;
    case 68: // $289
      __label__ = 80; break;
    case 69: // $290
      var $291=$state;
      var $292=(($291)|0)==1;
      if ($292) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $293
      $state=0;
      __label__ = 75; break;
    case 71: // $294
      var $295=$state;
      var $296=(($295)|0)==2;
      if ($296) { __label__ = 72; break; } else { __label__ = 74; break; }
    case 72: // $297
      var $298=$nAtts;
      var $299=$3;
      var $300=(($298)|0) < (($299)|0);
      if ($300) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $301
      var $302=$nAtts;
      var $303=$4;
      var $304=(($303+($302<<4))|0);
      var $305=(($304+12)|0);
      HEAP8[($305)]=0;
      __label__ = 74; break;
    case 74: // $306
      __label__ = 75; break;
    case 75: // $307
      __label__ = 80; break;
    case 76: // $308
      var $309=$state;
      var $310=(($309)|0)!=2;
      if ($310) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $311
      var $312=$nAtts;
      ;
      return $312;
    case 78: // $313
      __label__ = 80; break;
    case 79: // $314
      __label__ = 80; break;
    case 80: // $315
      __label__ = 81; break;
    case 81: // $316
      var $317=$2;
      var $318=(($317+2)|0);
      $2=$318;
      __label__ = 1; break;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12big2_getAttsPK8encodingPKciP9ATTRIBUTE["X"]=1;

function __ZL18big2_charRefNumberPK8encodingPKc($enc, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $result;
      var $c;
      var $c1;
      $2=$enc;
      $3=$ptr;
      $result=0;
      var $4=$3;
      var $5=(($4+4)|0);
      $3=$5;
      var $6=$3;
      var $7=(($6)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 1; break; } else { __label__ = 18; break; }
    case 1: // $11
      var $12=$3;
      var $13=(($12+1)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==120;
      if ($16) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $17
      var $18=$3;
      var $19=(($18+2)|0);
      $3=$19;
      __label__ = 3; break;
    case 3: // $20
      var $21=$3;
      var $22=(($21)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 4; break; } else { var $33 = 0;__label__ = 5; break; }
    case 4: // $26
      var $27=$3;
      var $28=(($27+1)|0);
      var $29=HEAP8[($28)];
      var $30=(($29 << 24) >> 24);
      var $31=(($30)|0)==59;
      var $33 = $31;__label__ = 5; break;
    case 5: // $32
      var $33;
      var $34=$33 ^ 1;
      if ($34) { __label__ = 6; break; } else { __label__ = 17; break; }
    case 6: // $35
      var $36=$3;
      var $37=(($36)|0);
      var $38=HEAP8[($37)];
      var $39=(($38 << 24) >> 24);
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      var $42=$3;
      var $43=(($42+1)|0);
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      var $48 = $45;__label__ = 9; break;
    case 8: // $46
      var $48 = -1;__label__ = 9; break;
    case 9: // $47
      var $48;
      $c=$48;
      var $49=$c;
      if ($49 == 48 || $49 == 49 || $49 == 50 || $49 == 51 || $49 == 52 || $49 == 53 || $49 == 54 || $49 == 55 || $49 == 56 || $49 == 57) {
        __label__ = 10; break;
      }
      else if ($49 == 65 || $49 == 66 || $49 == 67 || $49 == 68 || $49 == 69 || $49 == 70) {
        __label__ = 11; break;
      }
      else if ($49 == 97 || $49 == 98 || $49 == 99 || $49 == 100 || $49 == 101 || $49 == 102) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 10: // $50
      var $51=$result;
      var $52=$51 << 4;
      $result=$52;
      var $53=$c;
      var $54=(($53-48)|0);
      var $55=$result;
      var $56=$55 | $54;
      $result=$56;
      __label__ = 13; break;
    case 11: // $57
      var $58=$result;
      var $59=$58 << 4;
      $result=$59;
      var $60=$c;
      var $61=(($60-65)|0);
      var $62=(($61+10)|0);
      var $63=$result;
      var $64=(($63+$62)|0);
      $result=$64;
      __label__ = 13; break;
    case 12: // $65
      var $66=$result;
      var $67=$66 << 4;
      $result=$67;
      var $68=$c;
      var $69=(($68-97)|0);
      var $70=(($69+10)|0);
      var $71=$result;
      var $72=(($71+$70)|0);
      $result=$72;
      __label__ = 13; break;
    case 13: // $73
      var $74=$result;
      var $75=(($74)|0) >= 1114112;
      if ($75) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $76
      $1=-1;
      __label__ = 31; break;
    case 15: // $77
      __label__ = 16; break;
    case 16: // $78
      var $79=$3;
      var $80=(($79+2)|0);
      $3=$80;
      __label__ = 3; break;
    case 17: // $81
      __label__ = 30; break;
    case 18: // $82
      __label__ = 19; break;
    case 19: // $83
      var $84=$3;
      var $85=(($84)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($87)|0)==0;
      if ($88) { __label__ = 20; break; } else { var $96 = 0;__label__ = 21; break; }
    case 20: // $89
      var $90=$3;
      var $91=(($90+1)|0);
      var $92=HEAP8[($91)];
      var $93=(($92 << 24) >> 24);
      var $94=(($93)|0)==59;
      var $96 = $94;__label__ = 21; break;
    case 21: // $95
      var $96;
      var $97=$96 ^ 1;
      if ($97) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $98
      var $99=$3;
      var $100=(($99)|0);
      var $101=HEAP8[($100)];
      var $102=(($101 << 24) >> 24);
      var $103=(($102)|0)==0;
      if ($103) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $104
      var $105=$3;
      var $106=(($105+1)|0);
      var $107=HEAP8[($106)];
      var $108=(($107 << 24) >> 24);
      var $111 = $108;__label__ = 25; break;
    case 24: // $109
      var $111 = -1;__label__ = 25; break;
    case 25: // $110
      var $111;
      $c1=$111;
      var $112=$result;
      var $113=(($112*10)|0);
      $result=$113;
      var $114=$c1;
      var $115=(($114-48)|0);
      var $116=$result;
      var $117=(($116+$115)|0);
      $result=$117;
      var $118=$result;
      var $119=(($118)|0) >= 1114112;
      if ($119) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $120
      $1=-1;
      __label__ = 31; break;
    case 27: // $121
      __label__ = 28; break;
    case 28: // $122
      var $123=$3;
      var $124=(($123+2)|0);
      $3=$124;
      __label__ = 19; break;
    case 29: // $125
      __label__ = 30; break;
    case 30: // $126
      var $127=$result;
      var $128=__ZL18checkCharRefNumberi($127);
      $1=$128;
      __label__ = 31; break;
    case 31: // $129
      var $130=$1;
      ;
      return $130;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18big2_charRefNumberPK8encodingPKc["X"]=1;

function __ZL25big2_predefinedEntityNamePK8encodingPKcS3_($enc, $ptr, $end) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      var $5=$4;
      var $6=$3;
      var $7=$5;
      var $8=$6;
      var $9=(($7-$8)|0);
      var $10=(((($9)|0)/2)|0);
      if ($10 == 2) {
        __label__ = 1; break;
      }
      else if ($10 == 3) {
        __label__ = 11; break;
      }
      else if ($10 == 4) {
        __label__ = 21; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 1: // $11
      var $12=$3;
      var $13=(($12+2)|0);
      var $14=(($13)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $18
      var $19=$3;
      var $20=(($19+2)|0);
      var $21=(($20+1)|0);
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=(($23)|0)==116;
      if ($24) { __label__ = 3; break; } else { __label__ = 10; break; }
    case 3: // $25
      var $26=$3;
      var $27=(($26)|0);
      var $28=HEAP8[($27)];
      var $29=(($28 << 24) >> 24);
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $31
      var $32=$3;
      var $33=(($32+1)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $38 = $35;__label__ = 6; break;
    case 5: // $36
      var $38 = -1;__label__ = 6; break;
    case 6: // $37
      var $38;
      if ($38 == 108) {
        __label__ = 7; break;
      }
      else if ($38 == 103) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 7: // $39
      $1=60;
      __label__ = 47; break;
    case 8: // $40
      $1=62;
      __label__ = 47; break;
    case 9: // $41
      __label__ = 10; break;
    case 10: // $42
      __label__ = 46; break;
    case 11: // $43
      var $44=$3;
      var $45=(($44)|0);
      var $46=HEAP8[($45)];
      var $47=(($46 << 24) >> 24);
      var $48=(($47)|0)==0;
      if ($48) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $49
      var $50=$3;
      var $51=(($50+1)|0);
      var $52=HEAP8[($51)];
      var $53=(($52 << 24) >> 24);
      var $54=(($53)|0)==97;
      if ($54) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $55
      var $56=$3;
      var $57=(($56+2)|0);
      $3=$57;
      var $58=$3;
      var $59=(($58)|0);
      var $60=HEAP8[($59)];
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $63
      var $64=$3;
      var $65=(($64+1)|0);
      var $66=HEAP8[($65)];
      var $67=(($66 << 24) >> 24);
      var $68=(($67)|0)==109;
      if ($68) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $69
      var $70=$3;
      var $71=(($70+2)|0);
      $3=$71;
      var $72=$3;
      var $73=(($72)|0);
      var $74=HEAP8[($73)];
      var $75=(($74 << 24) >> 24);
      var $76=(($75)|0)==0;
      if ($76) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $77
      var $78=$3;
      var $79=(($78+1)|0);
      var $80=HEAP8[($79)];
      var $81=(($80 << 24) >> 24);
      var $82=(($81)|0)==112;
      if ($82) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $83
      $1=38;
      __label__ = 47; break;
    case 18: // $84
      __label__ = 19; break;
    case 19: // $85
      __label__ = 20; break;
    case 20: // $86
      __label__ = 46; break;
    case 21: // $87
      var $88=$3;
      var $89=(($88)|0);
      var $90=HEAP8[($89)];
      var $91=(($90 << 24) >> 24);
      var $92=(($91)|0)==0;
      if ($92) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $93
      var $94=$3;
      var $95=(($94+1)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24);
      var $100 = $97;__label__ = 24; break;
    case 23: // $98
      var $100 = -1;__label__ = 24; break;
    case 24: // $99
      var $100;
      if ($100 == 113) {
        __label__ = 25; break;
      }
      else if ($100 == 97) {
        __label__ = 35; break;
      }
      else {
      __label__ = 45; break;
      }
      
    case 25: // $101
      var $102=$3;
      var $103=(($102+2)|0);
      $3=$103;
      var $104=$3;
      var $105=(($104)|0);
      var $106=HEAP8[($105)];
      var $107=(($106 << 24) >> 24);
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 26; break; } else { __label__ = 34; break; }
    case 26: // $109
      var $110=$3;
      var $111=(($110+1)|0);
      var $112=HEAP8[($111)];
      var $113=(($112 << 24) >> 24);
      var $114=(($113)|0)==117;
      if ($114) { __label__ = 27; break; } else { __label__ = 34; break; }
    case 27: // $115
      var $116=$3;
      var $117=(($116+2)|0);
      $3=$117;
      var $118=$3;
      var $119=(($118)|0);
      var $120=HEAP8[($119)];
      var $121=(($120 << 24) >> 24);
      var $122=(($121)|0)==0;
      if ($122) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $123
      var $124=$3;
      var $125=(($124+1)|0);
      var $126=HEAP8[($125)];
      var $127=(($126 << 24) >> 24);
      var $128=(($127)|0)==111;
      if ($128) { __label__ = 29; break; } else { __label__ = 33; break; }
    case 29: // $129
      var $130=$3;
      var $131=(($130+2)|0);
      $3=$131;
      var $132=$3;
      var $133=(($132)|0);
      var $134=HEAP8[($133)];
      var $135=(($134 << 24) >> 24);
      var $136=(($135)|0)==0;
      if ($136) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $137
      var $138=$3;
      var $139=(($138+1)|0);
      var $140=HEAP8[($139)];
      var $141=(($140 << 24) >> 24);
      var $142=(($141)|0)==116;
      if ($142) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $143
      $1=34;
      __label__ = 47; break;
    case 32: // $144
      __label__ = 33; break;
    case 33: // $145
      __label__ = 34; break;
    case 34: // $146
      __label__ = 45; break;
    case 35: // $147
      var $148=$3;
      var $149=(($148+2)|0);
      $3=$149;
      var $150=$3;
      var $151=(($150)|0);
      var $152=HEAP8[($151)];
      var $153=(($152 << 24) >> 24);
      var $154=(($153)|0)==0;
      if ($154) { __label__ = 36; break; } else { __label__ = 44; break; }
    case 36: // $155
      var $156=$3;
      var $157=(($156+1)|0);
      var $158=HEAP8[($157)];
      var $159=(($158 << 24) >> 24);
      var $160=(($159)|0)==112;
      if ($160) { __label__ = 37; break; } else { __label__ = 44; break; }
    case 37: // $161
      var $162=$3;
      var $163=(($162+2)|0);
      $3=$163;
      var $164=$3;
      var $165=(($164)|0);
      var $166=HEAP8[($165)];
      var $167=(($166 << 24) >> 24);
      var $168=(($167)|0)==0;
      if ($168) { __label__ = 38; break; } else { __label__ = 43; break; }
    case 38: // $169
      var $170=$3;
      var $171=(($170+1)|0);
      var $172=HEAP8[($171)];
      var $173=(($172 << 24) >> 24);
      var $174=(($173)|0)==111;
      if ($174) { __label__ = 39; break; } else { __label__ = 43; break; }
    case 39: // $175
      var $176=$3;
      var $177=(($176+2)|0);
      $3=$177;
      var $178=$3;
      var $179=(($178)|0);
      var $180=HEAP8[($179)];
      var $181=(($180 << 24) >> 24);
      var $182=(($181)|0)==0;
      if ($182) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $183
      var $184=$3;
      var $185=(($184+1)|0);
      var $186=HEAP8[($185)];
      var $187=(($186 << 24) >> 24);
      var $188=(($187)|0)==115;
      if ($188) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $189
      $1=39;
      __label__ = 47; break;
    case 42: // $190
      __label__ = 43; break;
    case 43: // $191
      __label__ = 44; break;
    case 44: // $192
      __label__ = 45; break;
    case 45: // $193
      __label__ = 46; break;
    case 46: // $194
      $1=0;
      __label__ = 47; break;
    case 47: // $195
      var $196=$1;
      ;
      return $196;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL25big2_predefinedEntityNamePK8encodingPKcS3_["X"]=1;

function __ZL11big2_toUtf8PK8encodingPPKcS3_PPcS3_($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $from;
      var $plane;
      var $lo2;
      var $lo;
      var $hi;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$2;
      var $7=HEAP32[(($6)>>2)];
      $from=$7;
      __label__ = 1; break;
    case 1: // $8
      var $9=$from;
      var $10=$3;
      var $11=(($9)|0)!=(($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $12
      var $13=$from;
      var $14=(($13+1)|0);
      var $15=HEAP8[($14)];
      $lo=$15;
      var $16=$from;
      var $17=(($16)|0);
      var $18=HEAP8[($17)];
      $hi=$18;
      var $19=$hi;
      var $20=(($19)&255);
      if ($20 == 0) {
        __label__ = 3; break;
      }
      else if ($20 == 1 || $20 == 2 || $20 == 3 || $20 == 4 || $20 == 5 || $20 == 6 || $20 == 7) {
        __label__ = 8; break;
      }
      else if ($20 == 216 || $20 == 217 || $20 == 218 || $20 == 219) {
        __label__ = 14; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 3: // $21
      var $22=$lo;
      var $23=(($22)&255);
      var $24=(($23)|0) < 128;
      if ($24) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=$5;
      var $29=(($27)|0)==(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$from;
      var $32=$2;
      HEAP32[(($32)>>2)]=$31;
      __label__ = 20; break;
    case 6: // $33
      var $34=$lo;
      var $35=$4;
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      HEAP32[(($35)>>2)]=$37;
      HEAP8[($36)]=$34;
      __label__ = 17; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      var $40=$5;
      var $41=$4;
      var $42=HEAP32[(($41)>>2)];
      var $43=$40;
      var $44=$42;
      var $45=(($43-$44)|0);
      var $46=(($45)|0) < 2;
      if ($46) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $47
      var $48=$from;
      var $49=$2;
      HEAP32[(($49)>>2)]=$48;
      __label__ = 20; break;
    case 10: // $50
      var $51=$lo;
      var $52=(($51)&255);
      var $53=$52 >> 6;
      var $54=$hi;
      var $55=(($54)&255);
      var $56=$55 << 2;
      var $57=$53 | $56;
      var $58=$57 | 192;
      var $59=(($58) & 255);
      var $60=$4;
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+1)|0);
      HEAP32[(($60)>>2)]=$62;
      HEAP8[($61)]=$59;
      var $63=$lo;
      var $64=(($63)&255);
      var $65=$64 & 63;
      var $66=$65 | 128;
      var $67=(($66) & 255);
      var $68=$4;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+1)|0);
      HEAP32[(($68)>>2)]=$70;
      HEAP8[($69)]=$67;
      __label__ = 17; break;
    case 11: // $71
      var $72=$5;
      var $73=$4;
      var $74=HEAP32[(($73)>>2)];
      var $75=$72;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 3;
      if ($78) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $79
      var $80=$from;
      var $81=$2;
      HEAP32[(($81)>>2)]=$80;
      __label__ = 20; break;
    case 13: // $82
      var $83=$hi;
      var $84=(($83)&255);
      var $85=$84 >> 4;
      var $86=$85 | 224;
      var $87=(($86) & 255);
      var $88=$4;
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+1)|0);
      HEAP32[(($88)>>2)]=$90;
      HEAP8[($89)]=$87;
      var $91=$hi;
      var $92=(($91)&255);
      var $93=$92 & 15;
      var $94=$93 << 2;
      var $95=$lo;
      var $96=(($95)&255);
      var $97=$96 >> 6;
      var $98=$94 | $97;
      var $99=$98 | 128;
      var $100=(($99) & 255);
      var $101=$4;
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+1)|0);
      HEAP32[(($101)>>2)]=$103;
      HEAP8[($102)]=$100;
      var $104=$lo;
      var $105=(($104)&255);
      var $106=$105 & 63;
      var $107=$106 | 128;
      var $108=(($107) & 255);
      var $109=$4;
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+1)|0);
      HEAP32[(($109)>>2)]=$111;
      HEAP8[($110)]=$108;
      __label__ = 17; break;
    case 14: // $112
      var $113=$5;
      var $114=$4;
      var $115=HEAP32[(($114)>>2)];
      var $116=$113;
      var $117=$115;
      var $118=(($116-$117)|0);
      var $119=(($118)|0) < 4;
      if ($119) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $120
      var $121=$from;
      var $122=$2;
      HEAP32[(($122)>>2)]=$121;
      __label__ = 20; break;
    case 16: // $123
      var $124=$hi;
      var $125=(($124)&255);
      var $126=$125 & 3;
      var $127=$126 << 2;
      var $128=$lo;
      var $129=(($128)&255);
      var $130=$129 >> 6;
      var $131=$130 & 3;
      var $132=$127 | $131;
      var $133=(($132+1)|0);
      $plane=$133;
      var $134=$plane;
      var $135=$134 >> 2;
      var $136=$135 | 240;
      var $137=(($136) & 255);
      var $138=$4;
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139+1)|0);
      HEAP32[(($138)>>2)]=$140;
      HEAP8[($139)]=$137;
      var $141=$lo;
      var $142=(($141)&255);
      var $143=$142 >> 2;
      var $144=$143 & 15;
      var $145=$plane;
      var $146=$145 & 3;
      var $147=$146 << 4;
      var $148=$144 | $147;
      var $149=$148 | 128;
      var $150=(($149) & 255);
      var $151=$4;
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+1)|0);
      HEAP32[(($151)>>2)]=$153;
      HEAP8[($152)]=$150;
      var $154=$from;
      var $155=(($154+2)|0);
      $from=$155;
      var $156=$from;
      var $157=(($156+1)|0);
      var $158=HEAP8[($157)];
      $lo2=$158;
      var $159=$lo;
      var $160=(($159)&255);
      var $161=$160 & 3;
      var $162=$161 << 4;
      var $163=$from;
      var $164=(($163)|0);
      var $165=HEAPU8[($164)];
      var $166=(($165)&255);
      var $167=$166 & 3;
      var $168=$167 << 2;
      var $169=$162 | $168;
      var $170=$lo2;
      var $171=(($170)&255);
      var $172=$171 >> 6;
      var $173=$169 | $172;
      var $174=$173 | 128;
      var $175=(($174) & 255);
      var $176=$4;
      var $177=HEAP32[(($176)>>2)];
      var $178=(($177+1)|0);
      HEAP32[(($176)>>2)]=$178;
      HEAP8[($177)]=$175;
      var $179=$lo2;
      var $180=(($179)&255);
      var $181=$180 & 63;
      var $182=$181 | 128;
      var $183=(($182) & 255);
      var $184=$4;
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185+1)|0);
      HEAP32[(($184)>>2)]=$186;
      HEAP8[($185)]=$183;
      __label__ = 17; break;
    case 17: // $187
      __label__ = 18; break;
    case 18: // $188
      var $189=$from;
      var $190=(($189+2)|0);
      $from=$190;
      __label__ = 1; break;
    case 19: // $191
      var $192=$from;
      var $193=$2;
      HEAP32[(($193)>>2)]=$192;
      __label__ = 20; break;
    case 20: // $194
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11big2_toUtf8PK8encodingPPKcS3_PPcS3_["X"]=1;

function __ZL19big2_updatePositionPK8encodingPKcS3_P8position($enc, $ptr, $end, $pos) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$enc;
      $2=$ptr;
      $3=$end;
      $4=$pos;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 19; break; }
    case 2: // $9
      var $10=$2;
      var $11=(($10)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=(($16+1)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$1;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 5; break;
    case 4: // $26
      var $27=$2;
      var $28=(($27)|0);
      var $29=HEAP8[($28)];
      var $30=$2;
      var $31=(($30+1)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 5; break;
    case 5: // $34
      var $35;
      if ($35 == 5) {
        __label__ = 6; break;
      }
      else if ($35 == 6) {
        __label__ = 7; break;
      }
      else if ($35 == 7) {
        __label__ = 8; break;
      }
      else if ($35 == 10) {
        __label__ = 9; break;
      }
      else if ($35 == 9) {
        __label__ = 10; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 6: // $36
      var $37=$2;
      var $38=(($37+2)|0);
      $2=$38;
      __label__ = 18; break;
    case 7: // $39
      var $40=$2;
      var $41=(($40+3)|0);
      $2=$41;
      __label__ = 18; break;
    case 8: // $42
      var $43=$2;
      var $44=(($43+4)|0);
      $2=$44;
      __label__ = 18; break;
    case 9: // $45
      var $46=$4;
      var $47=(($46+4)|0);
      HEAP32[(($47)>>2)]=-1;
      var $48=$4;
      var $49=(($48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50+1)|0);
      HEAP32[(($49)>>2)]=$51;
      var $52=$2;
      var $53=(($52+2)|0);
      $2=$53;
      __label__ = 18; break;
    case 10: // $54
      var $55=$4;
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+1)|0);
      HEAP32[(($56)>>2)]=$58;
      var $59=$2;
      var $60=(($59+2)|0);
      $2=$60;
      var $61=$2;
      var $62=$3;
      var $63=(($61)|0)!=(($62)|0);
      if ($63) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $64
      var $65=$2;
      var $66=(($65)|0);
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24);
      var $69=(($68)|0)==0;
      if ($69) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $70
      var $71=$2;
      var $72=(($71+1)|0);
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$1;
      var $76=$75;
      var $77=(($76+76)|0);
      var $78=(($77+$74)|0);
      var $79=HEAPU8[($78)];
      var $80=(($79)&255);
      var $90 = $80;__label__ = 14; break;
    case 13: // $81
      var $82=$2;
      var $83=(($82)|0);
      var $84=HEAP8[($83)];
      var $85=$2;
      var $86=(($85+1)|0);
      var $87=HEAP8[($86)];
      var $88=__ZL17unicode_byte_typecc($84, $87);
      var $90 = $88;__label__ = 14; break;
    case 14: // $89
      var $90;
      var $91=(($90)|0)==10;
      if ($91) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $92
      var $93=$2;
      var $94=(($93+2)|0);
      $2=$94;
      __label__ = 16; break;
    case 16: // $95
      var $96=$4;
      var $97=(($96+4)|0);
      HEAP32[(($97)>>2)]=-1;
      __label__ = 18; break;
    case 17: // $98
      var $99=$2;
      var $100=(($99+2)|0);
      $2=$100;
      __label__ = 18; break;
    case 18: // $101
      var $102=$4;
      var $103=(($102+4)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104+1)|0);
      HEAP32[(($103)>>2)]=$105;
      __label__ = 1; break;
    case 19: // $106
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19big2_updatePositionPK8encodingPKcS3_P8position["X"]=1;

function __ZL15big2_isPublicIdPK8encodingPKcS3_PS3_($enc, $ptr, $end, $badPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$badPtr;
      var $6=$3;
      var $7=(($6+2)|0);
      $3=$7;
      var $8=$4;
      var $9=(($8-2)|0);
      $4=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$3;
      var $12=$4;
      var $13=(($11)|0)!=(($12)|0);
      if ($13) { __label__ = 2; break; } else { __label__ = 26; break; }
    case 2: // $14
      var $15=$3;
      var $16=(($15)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$3;
      var $22=(($21+1)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$2;
      var $26=$25;
      var $27=(($26+76)|0);
      var $28=(($27+$24)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $40 = $30;__label__ = 5; break;
    case 4: // $31
      var $32=$3;
      var $33=(($32)|0);
      var $34=HEAP8[($33)];
      var $35=$3;
      var $36=(($35+1)|0);
      var $37=HEAP8[($36)];
      var $38=__ZL17unicode_byte_typecc($34, $37);
      var $40 = $38;__label__ = 5; break;
    case 5: // $39
      var $40;
      if ($40 == 25 || $40 == 24 || $40 == 27 || $40 == 13 || $40 == 31 || $40 == 32 || $40 == 34 || $40 == 35 || $40 == 17 || $40 == 14 || $40 == 15 || $40 == 9 || $40 == 10 || $40 == 18 || $40 == 16 || $40 == 33 || $40 == 30 || $40 == 19 || $40 == 23) {
        __label__ = 6; break;
      }
      else if ($40 == 21) {
        __label__ = 7; break;
      }
      else if ($40 == 26 || $40 == 22) {
        __label__ = 11; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 6: // $41
      __label__ = 24; break;
    case 7: // $42
      var $43=$3;
      var $44=(($43)|0);
      var $45=HEAP8[($44)];
      var $46=(($45 << 24) >> 24);
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $48
      var $49=$3;
      var $50=(($49+1)|0);
      var $51=HEAP8[($50)];
      var $52=(($51 << 24) >> 24);
      var $53=(($52)|0)==9;
      if ($53) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $54
      var $55=$3;
      var $56=$5;
      HEAP32[(($56)>>2)]=$55;
      $1=0;
      __label__ = 27; break;
    case 10: // $57
      __label__ = 24; break;
    case 11: // $58
      var $59=$3;
      var $60=(($59)|0);
      var $61=HEAP8[($60)];
      var $62=(($61 << 24) >> 24);
      var $63=(($62)|0)==0;
      if ($63) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      var $65=$3;
      var $66=(($65+1)|0);
      var $67=HEAP8[($66)];
      var $68=(($67 << 24) >> 24);
      var $71 = $68;__label__ = 14; break;
    case 13: // $69
      var $71 = -1;__label__ = 14; break;
    case 14: // $70
      var $71;
      var $72=$71 & -128;
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 16; break; } else { __label__ = 15; break; }
    case 15: // $74
      __label__ = 24; break;
    case 16: // $75
      __label__ = 17; break;
    case 17: // $76
      var $77=$3;
      var $78=(($77)|0);
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24);
      var $81=(($80)|0)==0;
      if ($81) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $82
      var $83=$3;
      var $84=(($83+1)|0);
      var $85=HEAP8[($84)];
      var $86=(($85 << 24) >> 24);
      var $89 = $86;__label__ = 20; break;
    case 19: // $87
      var $89 = -1;__label__ = 20; break;
    case 20: // $88
      var $89;
      if ($89 == 36 || $89 == 64) {
        __label__ = 21; break;
      }
      else {
      __label__ = 22; break;
      }
      
    case 21: // $90
      __label__ = 23; break;
    case 22: // $91
      var $92=$3;
      var $93=$5;
      HEAP32[(($93)>>2)]=$92;
      $1=0;
      __label__ = 27; break;
    case 23: // $94
      __label__ = 24; break;
    case 24: // $95
      __label__ = 25; break;
    case 25: // $96
      var $97=$3;
      var $98=(($97+2)|0);
      $3=$98;
      __label__ = 1; break;
    case 26: // $99
      $1=1;
      __label__ = 27; break;
    case 27: // $100
      var $101=$1;
      ;
      return $101;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15big2_isPublicIdPK8encodingPKcS3_PS3_["X"]=1;

function __ZL12big2_toUtf16PK8encodingPPKcS3_PPtPKt($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$3;
      var $7=$2;
      var $8=HEAP32[(($7)>>2)];
      var $9=$6;
      var $10=$8;
      var $11=(($9-$10)|0);
      var $12=$5;
      var $13=$4;
      var $14=HEAP32[(($13)>>2)];
      var $15=$12;
      var $16=$14;
      var $17=(($15-$16)|0);
      var $18=(((($17)|0)/2)|0);
      var $19=$18 << 1;
      var $20=(($11)|0) > (($19)|0);
      if ($20) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $21
      var $22=$3;
      var $23=(($22-2)|0);
      var $24=(($23)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $27=$26 & 248;
      var $28=(($27)|0)==216;
      if ($28) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $29
      var $30=$3;
      var $31=(($30-2)|0);
      $3=$31;
      __label__ = 3; break;
    case 3: // $32
      __label__ = 4; break;
    case 4: // $33
      var $34=$2;
      var $35=HEAP32[(($34)>>2)];
      var $36=$3;
      var $37=(($35)|0)!=(($36)|0);
      if ($37) { __label__ = 5; break; } else { var $44 = 0;__label__ = 6; break; }
    case 5: // $38
      var $39=$4;
      var $40=HEAP32[(($39)>>2)];
      var $41=$5;
      var $42=(($40)|0)!=(($41)|0);
      var $44 = $42;__label__ = 6; break;
    case 6: // $43
      var $44;
      if ($44) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $45
      var $46=$2;
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 << 8;
      var $52=$2;
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+1)|0);
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$51 | $56;
      var $58=(($57) & 65535);
      var $59=$4;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+2)|0);
      HEAP32[(($59)>>2)]=$61;
      HEAP16[(($60)>>1)]=$58;
      __label__ = 8; break;
    case 8: // $62
      var $63=$2;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+2)|0);
      HEAP32[(($63)>>2)]=$65;
      __label__ = 4; break;
    case 9: // $66
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12big2_toUtf16PK8encodingPPKcS3_PPtPKt["X"]=1;

function __ZL12big2_scanRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 44; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else if ($36 == 19) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 6: // $37
      var $38=$3;
      var $39=(($38)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL11nmstrtPages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 44; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 21; break;
    case 10: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 44; break;
    case 12: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 44; break;
    case 13: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 44; break;
    case 15: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 44; break;
    case 16: // $91
      var $92=$4;
      var $93=$3;
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 44; break;
    case 18: // $99
      var $100=$3;
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 44; break;
    case 19: // $102
      var $103=$2;
      var $104=$3;
      var $105=(($104+2)|0);
      var $106=$4;
      var $107=$5;
      var $108=__ZL16big2_scanCharRefPK8encodingPKcS3_PS3_($103, $105, $106, $107);
      $1=$108;
      __label__ = 44; break;
    case 20: // $109
      var $110=$3;
      var $111=$5;
      HEAP32[(($111)>>2)]=$110;
      $1=0;
      __label__ = 44; break;
    case 21: // $112
      __label__ = 22; break;
    case 22: // $113
      var $114=$3;
      var $115=$4;
      var $116=(($114)|0)!=(($115)|0);
      if ($116) { __label__ = 23; break; } else { __label__ = 43; break; }
    case 23: // $117
      var $118=$3;
      var $119=(($118)|0);
      var $120=HEAP8[($119)];
      var $121=(($120 << 24) >> 24);
      var $122=(($121)|0)==0;
      if ($122) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $123
      var $124=$3;
      var $125=(($124+1)|0);
      var $126=HEAPU8[($125)];
      var $127=(($126)&255);
      var $128=$2;
      var $129=$128;
      var $130=(($129+76)|0);
      var $131=(($130+$127)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $143 = $133;__label__ = 26; break;
    case 25: // $134
      var $135=$3;
      var $136=(($135)|0);
      var $137=HEAP8[($136)];
      var $138=$3;
      var $139=(($138+1)|0);
      var $140=HEAP8[($139)];
      var $141=__ZL17unicode_byte_typecc($137, $140);
      var $143 = $141;__label__ = 26; break;
    case 26: // $142
      var $143;
      if ($143 == 29) {
        __label__ = 27; break;
      }
      else if ($143 == 22 || $143 == 24 || $143 == 25 || $143 == 26 || $143 == 27) {
        __label__ = 30; break;
      }
      else if ($143 == 5) {
        __label__ = 31; break;
      }
      else if ($143 == 6) {
        __label__ = 34; break;
      }
      else if ($143 == 7) {
        __label__ = 37; break;
      }
      else if ($143 == 18) {
        __label__ = 40; break;
      }
      else {
      __label__ = 41; break;
      }
      
    case 27: // $144
      var $145=$3;
      var $146=(($145)|0);
      var $147=HEAPU8[($146)];
      var $148=(($147)&255);
      var $149=((STRING_TABLE.__ZL9namePages+$148)|0);
      var $150=HEAPU8[($149)];
      var $151=(($150)&255);
      var $152=$151 << 3;
      var $153=$3;
      var $154=(($153+1)|0);
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$156 >> 5;
      var $158=(($152+$157)|0);
      var $159=((__ZL12namingBitmap+($158<<2))|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=$3;
      var $162=(($161+1)|0);
      var $163=HEAPU8[($162)];
      var $164=(($163)&255);
      var $165=$164 & 31;
      var $166=1 << $165;
      var $167=$160 & $166;
      var $168=(($167)|0)!=0;
      if ($168) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $169
      var $170=$3;
      var $171=$5;
      HEAP32[(($171)>>2)]=$170;
      $1=0;
      __label__ = 44; break;
    case 29: // $172
      __label__ = 30; break;
    case 30: // $173
      var $174=$3;
      var $175=(($174+2)|0);
      $3=$175;
      __label__ = 42; break;
    case 31: // $176
      var $177=$4;
      var $178=$3;
      var $179=$177;
      var $180=$178;
      var $181=(($179-$180)|0);
      var $182=(($181)|0) < 2;
      if ($182) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $183
      $1=-2;
      __label__ = 44; break;
    case 33: // $184
      var $185=$3;
      var $186=$5;
      HEAP32[(($186)>>2)]=$185;
      $1=0;
      __label__ = 44; break;
    case 34: // $187
      var $188=$4;
      var $189=$3;
      var $190=$188;
      var $191=$189;
      var $192=(($190-$191)|0);
      var $193=(($192)|0) < 3;
      if ($193) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $194
      $1=-2;
      __label__ = 44; break;
    case 36: // $195
      var $196=$3;
      var $197=$5;
      HEAP32[(($197)>>2)]=$196;
      $1=0;
      __label__ = 44; break;
    case 37: // $198
      var $199=$4;
      var $200=$3;
      var $201=$199;
      var $202=$200;
      var $203=(($201-$202)|0);
      var $204=(($203)|0) < 4;
      if ($204) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $205
      $1=-2;
      __label__ = 44; break;
    case 39: // $206
      var $207=$3;
      var $208=$5;
      HEAP32[(($208)>>2)]=$207;
      $1=0;
      __label__ = 44; break;
    case 40: // $209
      var $210=$3;
      var $211=(($210+2)|0);
      var $212=$5;
      HEAP32[(($212)>>2)]=$211;
      $1=9;
      __label__ = 44; break;
    case 41: // $213
      var $214=$3;
      var $215=$5;
      HEAP32[(($215)>>2)]=$214;
      $1=0;
      __label__ = 44; break;
    case 42: // $216
      __label__ = 22; break;
    case 43: // $217
      $1=-1;
      __label__ = 44; break;
    case 44: // $218
      var $219=$1;
      ;
      return $219;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12big2_scanRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL16big2_scanPercentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-22;
      __label__ = 44; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else if ($36 == 21 || $36 == 10 || $36 == 9 || $36 == 30) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 6: // $37
      var $38=$3;
      var $39=(($38)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL11nmstrtPages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 44; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 21; break;
    case 10: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 44; break;
    case 12: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 44; break;
    case 13: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 44; break;
    case 15: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 44; break;
    case 16: // $91
      var $92=$4;
      var $93=$3;
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 44; break;
    case 18: // $99
      var $100=$3;
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 44; break;
    case 19: // $102
      var $103=$3;
      var $104=$5;
      HEAP32[(($104)>>2)]=$103;
      $1=22;
      __label__ = 44; break;
    case 20: // $105
      var $106=$3;
      var $107=$5;
      HEAP32[(($107)>>2)]=$106;
      $1=0;
      __label__ = 44; break;
    case 21: // $108
      __label__ = 22; break;
    case 22: // $109
      var $110=$3;
      var $111=$4;
      var $112=(($110)|0)!=(($111)|0);
      if ($112) { __label__ = 23; break; } else { __label__ = 43; break; }
    case 23: // $113
      var $114=$3;
      var $115=(($114)|0);
      var $116=HEAP8[($115)];
      var $117=(($116 << 24) >> 24);
      var $118=(($117)|0)==0;
      if ($118) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $119
      var $120=$3;
      var $121=(($120+1)|0);
      var $122=HEAPU8[($121)];
      var $123=(($122)&255);
      var $124=$2;
      var $125=$124;
      var $126=(($125+76)|0);
      var $127=(($126+$123)|0);
      var $128=HEAPU8[($127)];
      var $129=(($128)&255);
      var $139 = $129;__label__ = 26; break;
    case 25: // $130
      var $131=$3;
      var $132=(($131)|0);
      var $133=HEAP8[($132)];
      var $134=$3;
      var $135=(($134+1)|0);
      var $136=HEAP8[($135)];
      var $137=__ZL17unicode_byte_typecc($133, $136);
      var $139 = $137;__label__ = 26; break;
    case 26: // $138
      var $139;
      if ($139 == 29) {
        __label__ = 27; break;
      }
      else if ($139 == 22 || $139 == 24 || $139 == 25 || $139 == 26 || $139 == 27) {
        __label__ = 30; break;
      }
      else if ($139 == 5) {
        __label__ = 31; break;
      }
      else if ($139 == 6) {
        __label__ = 34; break;
      }
      else if ($139 == 7) {
        __label__ = 37; break;
      }
      else if ($139 == 18) {
        __label__ = 40; break;
      }
      else {
      __label__ = 41; break;
      }
      
    case 27: // $140
      var $141=$3;
      var $142=(($141)|0);
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=((STRING_TABLE.__ZL9namePages+$144)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$147 << 3;
      var $149=$3;
      var $150=(($149+1)|0);
      var $151=HEAPU8[($150)];
      var $152=(($151)&255);
      var $153=$152 >> 5;
      var $154=(($148+$153)|0);
      var $155=((__ZL12namingBitmap+($154<<2))|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$3;
      var $158=(($157+1)|0);
      var $159=HEAPU8[($158)];
      var $160=(($159)&255);
      var $161=$160 & 31;
      var $162=1 << $161;
      var $163=$156 & $162;
      var $164=(($163)|0)!=0;
      if ($164) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $165
      var $166=$3;
      var $167=$5;
      HEAP32[(($167)>>2)]=$166;
      $1=0;
      __label__ = 44; break;
    case 29: // $168
      __label__ = 30; break;
    case 30: // $169
      var $170=$3;
      var $171=(($170+2)|0);
      $3=$171;
      __label__ = 42; break;
    case 31: // $172
      var $173=$4;
      var $174=$3;
      var $175=$173;
      var $176=$174;
      var $177=(($175-$176)|0);
      var $178=(($177)|0) < 2;
      if ($178) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $179
      $1=-2;
      __label__ = 44; break;
    case 33: // $180
      var $181=$3;
      var $182=$5;
      HEAP32[(($182)>>2)]=$181;
      $1=0;
      __label__ = 44; break;
    case 34: // $183
      var $184=$4;
      var $185=$3;
      var $186=$184;
      var $187=$185;
      var $188=(($186-$187)|0);
      var $189=(($188)|0) < 3;
      if ($189) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $190
      $1=-2;
      __label__ = 44; break;
    case 36: // $191
      var $192=$3;
      var $193=$5;
      HEAP32[(($193)>>2)]=$192;
      $1=0;
      __label__ = 44; break;
    case 37: // $194
      var $195=$4;
      var $196=$3;
      var $197=$195;
      var $198=$196;
      var $199=(($197-$198)|0);
      var $200=(($199)|0) < 4;
      if ($200) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $201
      $1=-2;
      __label__ = 44; break;
    case 39: // $202
      var $203=$3;
      var $204=$5;
      HEAP32[(($204)>>2)]=$203;
      $1=0;
      __label__ = 44; break;
    case 40: // $205
      var $206=$3;
      var $207=(($206+2)|0);
      var $208=$5;
      HEAP32[(($208)>>2)]=$207;
      $1=28;
      __label__ = 44; break;
    case 41: // $209
      var $210=$3;
      var $211=$5;
      HEAP32[(($211)>>2)]=$210;
      $1=0;
      __label__ = 44; break;
    case 42: // $212
      __label__ = 22; break;
    case 43: // $213
      $1=-1;
      __label__ = 44; break;
    case 44: // $214
      var $215=$1;
      ;
      return $215;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16big2_scanPercentPK8encodingPKcS3_PS3_["X"]=1;

function __ZL16big2_scanCharRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 20; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $15
      var $16=$3;
      var $17=(($16+1)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==120;
      if ($20) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $21
      var $22=$2;
      var $23=$3;
      var $24=(($23+2)|0);
      var $25=$4;
      var $26=$5;
      var $27=__ZL19big2_scanHexCharRefPK8encodingPKcS3_PS3_($22, $24, $25, $26);
      $1=$27;
      __label__ = 21; break;
    case 4: // $28
      var $29=$3;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=(($31 << 24) >> 24);
      var $33=(($32)|0)==0;
      if ($33) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $34
      var $35=$3;
      var $36=(($35+1)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$2;
      var $40=$39;
      var $41=(($40+76)|0);
      var $42=(($41+$38)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $54 = $44;__label__ = 7; break;
    case 6: // $45
      var $46=$3;
      var $47=(($46)|0);
      var $48=HEAP8[($47)];
      var $49=$3;
      var $50=(($49+1)|0);
      var $51=HEAP8[($50)];
      var $52=__ZL17unicode_byte_typecc($48, $51);
      var $54 = $52;__label__ = 7; break;
    case 7: // $53
      var $54;
      if ($54 == 25) {
        __label__ = 9; break;
      }
      else {
      __label__ = 8; break;
      }
      
    case 8: // $55
      var $56=$3;
      var $57=$5;
      HEAP32[(($57)>>2)]=$56;
      $1=0;
      __label__ = 21; break;
    case 9: // $58
      var $59=$3;
      var $60=(($59+2)|0);
      $3=$60;
      __label__ = 10; break;
    case 10: // $61
      var $62=$3;
      var $63=$4;
      var $64=(($62)|0)!=(($63)|0);
      if ($64) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $65
      var $66=$3;
      var $67=(($66)|0);
      var $68=HEAP8[($67)];
      var $69=(($68 << 24) >> 24);
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $71
      var $72=$3;
      var $73=(($72+1)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=$2;
      var $77=$76;
      var $78=(($77+76)|0);
      var $79=(($78+$75)|0);
      var $80=HEAPU8[($79)];
      var $81=(($80)&255);
      var $91 = $81;__label__ = 14; break;
    case 13: // $82
      var $83=$3;
      var $84=(($83)|0);
      var $85=HEAP8[($84)];
      var $86=$3;
      var $87=(($86+1)|0);
      var $88=HEAP8[($87)];
      var $89=__ZL17unicode_byte_typecc($85, $88);
      var $91 = $89;__label__ = 14; break;
    case 14: // $90
      var $91;
      if ($91 == 25) {
        __label__ = 17; break;
      }
      else if ($91 == 18) {
        __label__ = 15; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 15: // $92
      var $93=$3;
      var $94=(($93+2)|0);
      var $95=$5;
      HEAP32[(($95)>>2)]=$94;
      $1=10;
      __label__ = 21; break;
    case 16: // $96
      var $97=$3;
      var $98=$5;
      HEAP32[(($98)>>2)]=$97;
      $1=0;
      __label__ = 21; break;
    case 17: // $99
      __label__ = 18; break;
    case 18: // $100
      var $101=$3;
      var $102=(($101+2)|0);
      $3=$102;
      __label__ = 10; break;
    case 19: // $103
      __label__ = 20; break;
    case 20: // $104
      $1=-1;
      __label__ = 21; break;
    case 21: // $105
      var $106=$1;
      ;
      return $106;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16big2_scanCharRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL19big2_scanHexCharRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 19; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$3;
      var $17=(($16+1)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      var $20=$2;
      var $21=$20;
      var $22=(($21+76)|0);
      var $23=(($22+$19)|0);
      var $24=HEAPU8[($23)];
      var $25=(($24)&255);
      var $35 = $25;__label__ = 4; break;
    case 3: // $26
      var $27=$3;
      var $28=(($27)|0);
      var $29=HEAP8[($28)];
      var $30=$3;
      var $31=(($30+1)|0);
      var $32=HEAP8[($31)];
      var $33=__ZL17unicode_byte_typecc($29, $32);
      var $35 = $33;__label__ = 4; break;
    case 4: // $34
      var $35;
      if ($35 == 25 || $35 == 24) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 5: // $36
      __label__ = 7; break;
    case 6: // $37
      var $38=$3;
      var $39=$5;
      HEAP32[(($39)>>2)]=$38;
      $1=0;
      __label__ = 20; break;
    case 7: // $40
      var $41=$3;
      var $42=(($41+2)|0);
      $3=$42;
      __label__ = 8; break;
    case 8: // $43
      var $44=$3;
      var $45=$4;
      var $46=(($44)|0)!=(($45)|0);
      if ($46) { __label__ = 9; break; } else { __label__ = 18; break; }
    case 9: // $47
      var $48=$3;
      var $49=(($48)|0);
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24);
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $53
      var $54=$3;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$2;
      var $59=$58;
      var $60=(($59+76)|0);
      var $61=(($60+$57)|0);
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $73 = $63;__label__ = 12; break;
    case 11: // $64
      var $65=$3;
      var $66=(($65)|0);
      var $67=HEAP8[($66)];
      var $68=$3;
      var $69=(($68+1)|0);
      var $70=HEAP8[($69)];
      var $71=__ZL17unicode_byte_typecc($67, $70);
      var $73 = $71;__label__ = 12; break;
    case 12: // $72
      var $73;
      if ($73 == 25 || $73 == 24) {
        __label__ = 13; break;
      }
      else if ($73 == 18) {
        __label__ = 14; break;
      }
      else {
      __label__ = 15; break;
      }
      
    case 13: // $74
      __label__ = 16; break;
    case 14: // $75
      var $76=$3;
      var $77=(($76+2)|0);
      var $78=$5;
      HEAP32[(($78)>>2)]=$77;
      $1=10;
      __label__ = 20; break;
    case 15: // $79
      var $80=$3;
      var $81=$5;
      HEAP32[(($81)>>2)]=$80;
      $1=0;
      __label__ = 20; break;
    case 16: // $82
      __label__ = 17; break;
    case 17: // $83
      var $84=$3;
      var $85=(($84+2)|0);
      $3=$85;
      __label__ = 8; break;
    case 18: // $86
      __label__ = 19; break;
    case 19: // $87
      $1=-1;
      __label__ = 20; break;
    case 20: // $88
      var $89=$1;
      ;
      return $89;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL19big2_scanHexCharRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL11big2_scanLtPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $hadColon;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 110; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else if ($36 == 16) {
        __label__ = 19; break;
      }
      else if ($36 == 15) {
        __label__ = 28; break;
      }
      else if ($36 == 17) {
        __label__ = 29; break;
      }
      else {
      __label__ = 30; break;
      }
      
    case 6: // $37
      var $38=$3;
      var $39=(($38)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL11nmstrtPages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 110; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 31; break;
    case 10: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 110; break;
    case 12: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 110; break;
    case 13: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 110; break;
    case 15: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 110; break;
    case 16: // $91
      var $92=$4;
      var $93=$3;
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 110; break;
    case 18: // $99
      var $100=$3;
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 110; break;
    case 19: // $102
      var $103=$3;
      var $104=(($103+2)|0);
      $3=$104;
      var $105=$4;
      var $106=(($104)|0)==(($105)|0);
      if ($106) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $107
      $1=-1;
      __label__ = 110; break;
    case 21: // $108
      var $109=$3;
      var $110=(($109)|0);
      var $111=HEAP8[($110)];
      var $112=(($111 << 24) >> 24);
      var $113=(($112)|0)==0;
      if ($113) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $114
      var $115=$3;
      var $116=(($115+1)|0);
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=$2;
      var $120=$119;
      var $121=(($120+76)|0);
      var $122=(($121+$118)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $134 = $124;__label__ = 24; break;
    case 23: // $125
      var $126=$3;
      var $127=(($126)|0);
      var $128=HEAP8[($127)];
      var $129=$3;
      var $130=(($129+1)|0);
      var $131=HEAP8[($130)];
      var $132=__ZL17unicode_byte_typecc($128, $131);
      var $134 = $132;__label__ = 24; break;
    case 24: // $133
      var $134;
      if ($134 == 27) {
        __label__ = 25; break;
      }
      else if ($134 == 20) {
        __label__ = 26; break;
      }
      else {
      __label__ = 27; break;
      }
      
    case 25: // $135
      var $136=$2;
      var $137=$3;
      var $138=(($137+2)|0);
      var $139=$4;
      var $140=$5;
      var $141=__ZL16big2_scanCommentPK8encodingPKcS3_PS3_($136, $138, $139, $140);
      $1=$141;
      __label__ = 110; break;
    case 26: // $142
      var $143=$2;
      var $144=$3;
      var $145=(($144+2)|0);
      var $146=$4;
      var $147=$5;
      var $148=__ZL21big2_scanCdataSectionPK8encodingPKcS3_PS3_($143, $145, $146, $147);
      $1=$148;
      __label__ = 110; break;
    case 27: // $149
      var $150=$3;
      var $151=$5;
      HEAP32[(($151)>>2)]=$150;
      $1=0;
      __label__ = 110; break;
    case 28: // $152
      var $153=$2;
      var $154=$3;
      var $155=(($154+2)|0);
      var $156=$4;
      var $157=$5;
      var $158=__ZL11big2_scanPiPK8encodingPKcS3_PS3_($153, $155, $156, $157);
      $1=$158;
      __label__ = 110; break;
    case 29: // $159
      var $160=$2;
      var $161=$3;
      var $162=(($161+2)|0);
      var $163=$4;
      var $164=$5;
      var $165=__ZL15big2_scanEndTagPK8encodingPKcS3_PS3_($160, $162, $163, $164);
      $1=$165;
      __label__ = 110; break;
    case 30: // $166
      var $167=$3;
      var $168=$5;
      HEAP32[(($168)>>2)]=$167;
      $1=0;
      __label__ = 110; break;
    case 31: // $169
      $hadColon=0;
      __label__ = 32; break;
    case 32: // $170
      var $171=$3;
      var $172=$4;
      var $173=(($171)|0)!=(($172)|0);
      if ($173) { __label__ = 33; break; } else { __label__ = 109; break; }
    case 33: // $174
      var $175=$3;
      var $176=(($175)|0);
      var $177=HEAP8[($176)];
      var $178=(($177 << 24) >> 24);
      var $179=(($178)|0)==0;
      if ($179) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $180
      var $181=$3;
      var $182=(($181+1)|0);
      var $183=HEAPU8[($182)];
      var $184=(($183)&255);
      var $185=$2;
      var $186=$185;
      var $187=(($186+76)|0);
      var $188=(($187+$184)|0);
      var $189=HEAPU8[($188)];
      var $190=(($189)&255);
      var $200 = $190;__label__ = 36; break;
    case 35: // $191
      var $192=$3;
      var $193=(($192)|0);
      var $194=HEAP8[($193)];
      var $195=$3;
      var $196=(($195+1)|0);
      var $197=HEAP8[($196)];
      var $198=__ZL17unicode_byte_typecc($194, $197);
      var $200 = $198;__label__ = 36; break;
    case 36: // $199
      var $200;
      if ($200 == 29) {
        __label__ = 37; break;
      }
      else if ($200 == 22 || $200 == 24 || $200 == 25 || $200 == 26 || $200 == 27) {
        __label__ = 40; break;
      }
      else if ($200 == 5) {
        __label__ = 41; break;
      }
      else if ($200 == 6) {
        __label__ = 44; break;
      }
      else if ($200 == 7) {
        __label__ = 47; break;
      }
      else if ($200 == 23) {
        __label__ = 50; break;
      }
      else if ($200 == 21 || $200 == 9 || $200 == 10) {
        __label__ = 73; break;
      }
      else if ($200 == 11) {
        __label__ = 98; break;
      }
      else if ($200 == 17) {
        __label__ = 100; break;
      }
      else {
      __label__ = 107; break;
      }
      
    case 37: // $201
      var $202=$3;
      var $203=(($202)|0);
      var $204=HEAPU8[($203)];
      var $205=(($204)&255);
      var $206=((STRING_TABLE.__ZL9namePages+$205)|0);
      var $207=HEAPU8[($206)];
      var $208=(($207)&255);
      var $209=$208 << 3;
      var $210=$3;
      var $211=(($210+1)|0);
      var $212=HEAPU8[($211)];
      var $213=(($212)&255);
      var $214=$213 >> 5;
      var $215=(($209+$214)|0);
      var $216=((__ZL12namingBitmap+($215<<2))|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=$3;
      var $219=(($218+1)|0);
      var $220=HEAPU8[($219)];
      var $221=(($220)&255);
      var $222=$221 & 31;
      var $223=1 << $222;
      var $224=$217 & $223;
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 39; break; } else { __label__ = 38; break; }
    case 38: // $226
      var $227=$3;
      var $228=$5;
      HEAP32[(($228)>>2)]=$227;
      $1=0;
      __label__ = 110; break;
    case 39: // $229
      __label__ = 40; break;
    case 40: // $230
      var $231=$3;
      var $232=(($231+2)|0);
      $3=$232;
      __label__ = 108; break;
    case 41: // $233
      var $234=$4;
      var $235=$3;
      var $236=$234;
      var $237=$235;
      var $238=(($236-$237)|0);
      var $239=(($238)|0) < 2;
      if ($239) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $240
      $1=-2;
      __label__ = 110; break;
    case 43: // $241
      var $242=$3;
      var $243=$5;
      HEAP32[(($243)>>2)]=$242;
      $1=0;
      __label__ = 110; break;
    case 44: // $244
      var $245=$4;
      var $246=$3;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      var $250=(($249)|0) < 3;
      if ($250) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $251
      $1=-2;
      __label__ = 110; break;
    case 46: // $252
      var $253=$3;
      var $254=$5;
      HEAP32[(($254)>>2)]=$253;
      $1=0;
      __label__ = 110; break;
    case 47: // $255
      var $256=$4;
      var $257=$3;
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(($260)|0) < 4;
      if ($261) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $262
      $1=-2;
      __label__ = 110; break;
    case 49: // $263
      var $264=$3;
      var $265=$5;
      HEAP32[(($265)>>2)]=$264;
      $1=0;
      __label__ = 110; break;
    case 50: // $266
      var $267=$hadColon;
      var $268=(($267)|0)!=0;
      if ($268) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $269
      var $270=$3;
      var $271=$5;
      HEAP32[(($271)>>2)]=$270;
      $1=0;
      __label__ = 110; break;
    case 52: // $272
      $hadColon=1;
      var $273=$3;
      var $274=(($273+2)|0);
      $3=$274;
      var $275=$3;
      var $276=$4;
      var $277=(($275)|0)==(($276)|0);
      if ($277) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $278
      $1=-1;
      __label__ = 110; break;
    case 54: // $279
      var $280=$3;
      var $281=(($280)|0);
      var $282=HEAP8[($281)];
      var $283=(($282 << 24) >> 24);
      var $284=(($283)|0)==0;
      if ($284) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $285
      var $286=$3;
      var $287=(($286+1)|0);
      var $288=HEAPU8[($287)];
      var $289=(($288)&255);
      var $290=$2;
      var $291=$290;
      var $292=(($291+76)|0);
      var $293=(($292+$289)|0);
      var $294=HEAPU8[($293)];
      var $295=(($294)&255);
      var $305 = $295;__label__ = 57; break;
    case 56: // $296
      var $297=$3;
      var $298=(($297)|0);
      var $299=HEAP8[($298)];
      var $300=$3;
      var $301=(($300+1)|0);
      var $302=HEAP8[($301)];
      var $303=__ZL17unicode_byte_typecc($299, $302);
      var $305 = $303;__label__ = 57; break;
    case 57: // $304
      var $305;
      if ($305 == 29) {
        __label__ = 58; break;
      }
      else if ($305 == 22 || $305 == 24) {
        __label__ = 61; break;
      }
      else if ($305 == 5) {
        __label__ = 62; break;
      }
      else if ($305 == 6) {
        __label__ = 65; break;
      }
      else if ($305 == 7) {
        __label__ = 68; break;
      }
      else {
      __label__ = 71; break;
      }
      
    case 58: // $306
      var $307=$3;
      var $308=(($307)|0);
      var $309=HEAPU8[($308)];
      var $310=(($309)&255);
      var $311=((STRING_TABLE.__ZL11nmstrtPages+$310)|0);
      var $312=HEAPU8[($311)];
      var $313=(($312)&255);
      var $314=$313 << 3;
      var $315=$3;
      var $316=(($315+1)|0);
      var $317=HEAPU8[($316)];
      var $318=(($317)&255);
      var $319=$318 >> 5;
      var $320=(($314+$319)|0);
      var $321=((__ZL12namingBitmap+($320<<2))|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=$3;
      var $324=(($323+1)|0);
      var $325=HEAPU8[($324)];
      var $326=(($325)&255);
      var $327=$326 & 31;
      var $328=1 << $327;
      var $329=$322 & $328;
      var $330=(($329)|0)!=0;
      if ($330) { __label__ = 60; break; } else { __label__ = 59; break; }
    case 59: // $331
      var $332=$3;
      var $333=$5;
      HEAP32[(($333)>>2)]=$332;
      $1=0;
      __label__ = 110; break;
    case 60: // $334
      __label__ = 61; break;
    case 61: // $335
      var $336=$3;
      var $337=(($336+2)|0);
      $3=$337;
      __label__ = 72; break;
    case 62: // $338
      var $339=$4;
      var $340=$3;
      var $341=$339;
      var $342=$340;
      var $343=(($341-$342)|0);
      var $344=(($343)|0) < 2;
      if ($344) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $345
      $1=-2;
      __label__ = 110; break;
    case 64: // $346
      var $347=$3;
      var $348=$5;
      HEAP32[(($348)>>2)]=$347;
      $1=0;
      __label__ = 110; break;
    case 65: // $349
      var $350=$4;
      var $351=$3;
      var $352=$350;
      var $353=$351;
      var $354=(($352-$353)|0);
      var $355=(($354)|0) < 3;
      if ($355) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $356
      $1=-2;
      __label__ = 110; break;
    case 67: // $357
      var $358=$3;
      var $359=$5;
      HEAP32[(($359)>>2)]=$358;
      $1=0;
      __label__ = 110; break;
    case 68: // $360
      var $361=$4;
      var $362=$3;
      var $363=$361;
      var $364=$362;
      var $365=(($363-$364)|0);
      var $366=(($365)|0) < 4;
      if ($366) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $367
      $1=-2;
      __label__ = 110; break;
    case 70: // $368
      var $369=$3;
      var $370=$5;
      HEAP32[(($370)>>2)]=$369;
      $1=0;
      __label__ = 110; break;
    case 71: // $371
      var $372=$3;
      var $373=$5;
      HEAP32[(($373)>>2)]=$372;
      $1=0;
      __label__ = 110; break;
    case 72: // $374
      __label__ = 108; break;
    case 73: // $375
      var $376=$3;
      var $377=(($376+2)|0);
      $3=$377;
      __label__ = 74; break;
    case 74: // $378
      var $379=$3;
      var $380=$4;
      var $381=(($379)|0)!=(($380)|0);
      if ($381) { __label__ = 75; break; } else { __label__ = 97; break; }
    case 75: // $382
      var $383=$3;
      var $384=(($383)|0);
      var $385=HEAP8[($384)];
      var $386=(($385 << 24) >> 24);
      var $387=(($386)|0)==0;
      if ($387) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $388
      var $389=$3;
      var $390=(($389+1)|0);
      var $391=HEAPU8[($390)];
      var $392=(($391)&255);
      var $393=$2;
      var $394=$393;
      var $395=(($394+76)|0);
      var $396=(($395+$392)|0);
      var $397=HEAPU8[($396)];
      var $398=(($397)&255);
      var $408 = $398;__label__ = 78; break;
    case 77: // $399
      var $400=$3;
      var $401=(($400)|0);
      var $402=HEAP8[($401)];
      var $403=$3;
      var $404=(($403+1)|0);
      var $405=HEAP8[($404)];
      var $406=__ZL17unicode_byte_typecc($402, $405);
      var $408 = $406;__label__ = 78; break;
    case 78: // $407
      var $408;
      if ($408 == 29) {
        __label__ = 79; break;
      }
      else if ($408 == 22 || $408 == 24) {
        __label__ = 82; break;
      }
      else if ($408 == 5) {
        __label__ = 83; break;
      }
      else if ($408 == 6) {
        __label__ = 86; break;
      }
      else if ($408 == 7) {
        __label__ = 89; break;
      }
      else if ($408 == 11) {
        __label__ = 92; break;
      }
      else if ($408 == 17) {
        __label__ = 93; break;
      }
      else if ($408 == 21 || $408 == 9 || $408 == 10) {
        __label__ = 94; break;
      }
      else {
      __label__ = 95; break;
      }
      
    case 79: // $409
      var $410=$3;
      var $411=(($410)|0);
      var $412=HEAPU8[($411)];
      var $413=(($412)&255);
      var $414=((STRING_TABLE.__ZL11nmstrtPages+$413)|0);
      var $415=HEAPU8[($414)];
      var $416=(($415)&255);
      var $417=$416 << 3;
      var $418=$3;
      var $419=(($418+1)|0);
      var $420=HEAPU8[($419)];
      var $421=(($420)&255);
      var $422=$421 >> 5;
      var $423=(($417+$422)|0);
      var $424=((__ZL12namingBitmap+($423<<2))|0);
      var $425=HEAP32[(($424)>>2)];
      var $426=$3;
      var $427=(($426+1)|0);
      var $428=HEAPU8[($427)];
      var $429=(($428)&255);
      var $430=$429 & 31;
      var $431=1 << $430;
      var $432=$425 & $431;
      var $433=(($432)|0)!=0;
      if ($433) { __label__ = 81; break; } else { __label__ = 80; break; }
    case 80: // $434
      var $435=$3;
      var $436=$5;
      HEAP32[(($436)>>2)]=$435;
      $1=0;
      __label__ = 110; break;
    case 81: // $437
      __label__ = 82; break;
    case 82: // $438
      var $439=$3;
      var $440=(($439+2)|0);
      $3=$440;
      __label__ = 96; break;
    case 83: // $441
      var $442=$4;
      var $443=$3;
      var $444=$442;
      var $445=$443;
      var $446=(($444-$445)|0);
      var $447=(($446)|0) < 2;
      if ($447) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $448
      $1=-2;
      __label__ = 110; break;
    case 85: // $449
      var $450=$3;
      var $451=$5;
      HEAP32[(($451)>>2)]=$450;
      $1=0;
      __label__ = 110; break;
    case 86: // $452
      var $453=$4;
      var $454=$3;
      var $455=$453;
      var $456=$454;
      var $457=(($455-$456)|0);
      var $458=(($457)|0) < 3;
      if ($458) { __label__ = 87; break; } else { __label__ = 88; break; }
    case 87: // $459
      $1=-2;
      __label__ = 110; break;
    case 88: // $460
      var $461=$3;
      var $462=$5;
      HEAP32[(($462)>>2)]=$461;
      $1=0;
      __label__ = 110; break;
    case 89: // $463
      var $464=$4;
      var $465=$3;
      var $466=$464;
      var $467=$465;
      var $468=(($466-$467)|0);
      var $469=(($468)|0) < 4;
      if ($469) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $470
      $1=-2;
      __label__ = 110; break;
    case 91: // $471
      var $472=$3;
      var $473=$5;
      HEAP32[(($473)>>2)]=$472;
      $1=0;
      __label__ = 110; break;
    case 92: // $474
      __label__ = 99; break;
    case 93: // $475
      __label__ = 101; break;
    case 94: // $476
      var $477=$3;
      var $478=(($477+2)|0);
      $3=$478;
      __label__ = 74; break;
    case 95: // $479
      var $480=$3;
      var $481=$5;
      HEAP32[(($481)>>2)]=$480;
      $1=0;
      __label__ = 110; break;
    case 96: // $482
      var $483=$2;
      var $484=$3;
      var $485=$4;
      var $486=$5;
      var $487=__ZL13big2_scanAttsPK8encodingPKcS3_PS3_($483, $484, $485, $486);
      $1=$487;
      __label__ = 110; break;
    case 97: // $488
      $1=-1;
      __label__ = 110; break;
    case 98: // $489
      __label__ = 99; break;
    case 99: // $490
      var $491=$3;
      var $492=(($491+2)|0);
      var $493=$5;
      HEAP32[(($493)>>2)]=$492;
      $1=2;
      __label__ = 110; break;
    case 100: // $494
      __label__ = 101; break;
    case 101: // $495
      var $496=$3;
      var $497=(($496+2)|0);
      $3=$497;
      var $498=$3;
      var $499=$4;
      var $500=(($498)|0)==(($499)|0);
      if ($500) { __label__ = 102; break; } else { __label__ = 103; break; }
    case 102: // $501
      $1=-1;
      __label__ = 110; break;
    case 103: // $502
      var $503=$3;
      var $504=(($503)|0);
      var $505=HEAP8[($504)];
      var $506=(($505 << 24) >> 24);
      var $507=(($506)|0)==0;
      if ($507) { __label__ = 104; break; } else { __label__ = 105; break; }
    case 104: // $508
      var $509=$3;
      var $510=(($509+1)|0);
      var $511=HEAP8[($510)];
      var $512=(($511 << 24) >> 24);
      var $513=(($512)|0)==62;
      if ($513) { __label__ = 106; break; } else { __label__ = 105; break; }
    case 105: // $514
      var $515=$3;
      var $516=$5;
      HEAP32[(($516)>>2)]=$515;
      $1=0;
      __label__ = 110; break;
    case 106: // $517
      var $518=$3;
      var $519=(($518+2)|0);
      var $520=$5;
      HEAP32[(($520)>>2)]=$519;
      $1=4;
      __label__ = 110; break;
    case 107: // $521
      var $522=$3;
      var $523=$5;
      HEAP32[(($523)>>2)]=$522;
      $1=0;
      __label__ = 110; break;
    case 108: // $524
      __label__ = 32; break;
    case 109: // $525
      $1=-1;
      __label__ = 110; break;
    case 110: // $526
      var $527=$1;
      ;
      return $527;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11big2_scanLtPK8encodingPKcS3_PS3_["X"]=1;

function __ZL21big2_scanCdataSectionPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $i;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$4;
      var $7=$3;
      var $8=$6;
      var $9=$7;
      var $10=(($8-$9)|0);
      var $11=(($10)|0) < 12;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $1=-1;
      __label__ = 10; break;
    case 2: // $13
      $i=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$i;
      var $16=(($15)|0) < 6;
      if ($16) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $17
      var $18=$3;
      var $19=(($18)|0);
      var $20=HEAP8[($19)];
      var $21=(($20 << 24) >> 24);
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      var $26=HEAP8[($25)];
      var $27=(($26 << 24) >> 24);
      var $28=$i;
      var $29=((STRING_TABLE.__ZZL21big2_scanCdataSectionPK8encodingPKcS3_PS3_E10CDATA_LSQB+$28)|0);
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24);
      var $32=(($27)|0)==(($31)|0);
      if ($32) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $34=$3;
      var $35=$5;
      HEAP32[(($35)>>2)]=$34;
      $1=0;
      __label__ = 10; break;
    case 7: // $36
      __label__ = 8; break;
    case 8: // $37
      var $38=$i;
      var $39=(($38+1)|0);
      $i=$39;
      var $40=$3;
      var $41=(($40+2)|0);
      $3=$41;
      __label__ = 3; break;
    case 9: // $42
      var $43=$3;
      var $44=$5;
      HEAP32[(($44)>>2)]=$43;
      $1=8;
      __label__ = 10; break;
    case 10: // $45
      var $46=$1;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21big2_scanCdataSectionPK8encodingPKcS3_PS3_["X"]=1;

function __ZL16big2_scanCommentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 34; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10)|0);
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $15
      var $16=$3;
      var $17=(($16+1)|0);
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=(($19)|0)==45;
      if ($20) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $21
      var $22=$3;
      var $23=$5;
      HEAP32[(($23)>>2)]=$22;
      $1=0;
      __label__ = 35; break;
    case 4: // $24
      var $25=$3;
      var $26=(($25+2)|0);
      $3=$26;
      __label__ = 5; break;
    case 5: // $27
      var $28=$3;
      var $29=$4;
      var $30=(($28)|0)!=(($29)|0);
      if ($30) { __label__ = 6; break; } else { __label__ = 33; break; }
    case 6: // $31
      var $32=$3;
      var $33=(($32)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $37
      var $38=$3;
      var $39=(($38+1)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$2;
      var $43=$42;
      var $44=(($43+76)|0);
      var $45=(($44+$41)|0);
      var $46=HEAPU8[($45)];
      var $47=(($46)&255);
      var $57 = $47;__label__ = 9; break;
    case 8: // $48
      var $49=$3;
      var $50=(($49)|0);
      var $51=HEAP8[($50)];
      var $52=$3;
      var $53=(($52+1)|0);
      var $54=HEAP8[($53)];
      var $55=__ZL17unicode_byte_typecc($51, $54);
      var $57 = $55;__label__ = 9; break;
    case 9: // $56
      var $57;
      if ($57 == 5) {
        __label__ = 10; break;
      }
      else if ($57 == 6) {
        __label__ = 13; break;
      }
      else if ($57 == 7) {
        __label__ = 16; break;
      }
      else if ($57 == 0 || $57 == 1 || $57 == 8) {
        __label__ = 19; break;
      }
      else if ($57 == 27) {
        __label__ = 20; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 10: // $58
      var $59=$4;
      var $60=$3;
      var $61=$59;
      var $62=$60;
      var $63=(($61-$62)|0);
      var $64=(($63)|0) < 2;
      if ($64) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $65
      $1=-2;
      __label__ = 35; break;
    case 12: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 32; break;
    case 13: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 3;
      if ($75) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $76
      $1=-2;
      __label__ = 35; break;
    case 15: // $77
      var $78=$3;
      var $79=(($78+3)|0);
      $3=$79;
      __label__ = 32; break;
    case 16: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 4;
      if ($86) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $87
      $1=-2;
      __label__ = 35; break;
    case 18: // $88
      var $89=$3;
      var $90=(($89+4)|0);
      $3=$90;
      __label__ = 32; break;
    case 19: // $91
      var $92=$3;
      var $93=$5;
      HEAP32[(($93)>>2)]=$92;
      $1=0;
      __label__ = 35; break;
    case 20: // $94
      var $95=$3;
      var $96=(($95+2)|0);
      $3=$96;
      var $97=$4;
      var $98=(($96)|0)==(($97)|0);
      if ($98) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $99
      $1=-1;
      __label__ = 35; break;
    case 22: // $100
      var $101=$3;
      var $102=(($101)|0);
      var $103=HEAP8[($102)];
      var $104=(($103 << 24) >> 24);
      var $105=(($104)|0)==0;
      if ($105) { __label__ = 23; break; } else { __label__ = 30; break; }
    case 23: // $106
      var $107=$3;
      var $108=(($107+1)|0);
      var $109=HEAP8[($108)];
      var $110=(($109 << 24) >> 24);
      var $111=(($110)|0)==45;
      if ($111) { __label__ = 24; break; } else { __label__ = 30; break; }
    case 24: // $112
      var $113=$3;
      var $114=(($113+2)|0);
      $3=$114;
      var $115=$4;
      var $116=(($114)|0)==(($115)|0);
      if ($116) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $117
      $1=-1;
      __label__ = 35; break;
    case 26: // $118
      var $119=$3;
      var $120=(($119)|0);
      var $121=HEAP8[($120)];
      var $122=(($121 << 24) >> 24);
      var $123=(($122)|0)==0;
      if ($123) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $124
      var $125=$3;
      var $126=(($125+1)|0);
      var $127=HEAP8[($126)];
      var $128=(($127 << 24) >> 24);
      var $129=(($128)|0)==62;
      if ($129) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $130
      var $131=$3;
      var $132=$5;
      HEAP32[(($132)>>2)]=$131;
      $1=0;
      __label__ = 35; break;
    case 29: // $133
      var $134=$3;
      var $135=(($134+2)|0);
      var $136=$5;
      HEAP32[(($136)>>2)]=$135;
      $1=13;
      __label__ = 35; break;
    case 30: // $137
      __label__ = 32; break;
    case 31: // $138
      var $139=$3;
      var $140=(($139+2)|0);
      $3=$140;
      __label__ = 32; break;
    case 32: // $141
      __label__ = 5; break;
    case 33: // $142
      __label__ = 34; break;
    case 34: // $143
      $1=-1;
      __label__ = 35; break;
    case 35: // $144
      var $145=$1;
      ;
      return $145;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL16big2_scanCommentPK8encodingPKcS3_PS3_["X"]=1;

function __ZL11big2_scanPiPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tok=__stackBase__;
      var $target;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      $target=$6;
      var $7=$3;
      var $8=$4;
      var $9=(($7)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=-1;
      __label__ = 77; break;
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$3;
      var $19=(($18+1)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$2;
      var $23=$22;
      var $24=(($23+76)|0);
      var $25=(($24+$21)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $37 = $27;__label__ = 5; break;
    case 4: // $28
      var $29=$3;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=$3;
      var $33=(($32+1)|0);
      var $34=HEAP8[($33)];
      var $35=__ZL17unicode_byte_typecc($31, $34);
      var $37 = $35;__label__ = 5; break;
    case 5: // $36
      var $37;
      if ($37 == 29) {
        __label__ = 6; break;
      }
      else if ($37 == 22 || $37 == 24) {
        __label__ = 9; break;
      }
      else if ($37 == 5) {
        __label__ = 10; break;
      }
      else if ($37 == 6) {
        __label__ = 13; break;
      }
      else if ($37 == 7) {
        __label__ = 16; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 6: // $38
      var $39=$3;
      var $40=(($39)|0);
      var $41=HEAPU8[($40)];
      var $42=(($41)&255);
      var $43=((STRING_TABLE.__ZL11nmstrtPages+$42)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$45 << 3;
      var $47=$3;
      var $48=(($47+1)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      var $51=$50 >> 5;
      var $52=(($46+$51)|0);
      var $53=((__ZL12namingBitmap+($52<<2))|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$3;
      var $56=(($55+1)|0);
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=$58 & 31;
      var $60=1 << $59;
      var $61=$54 & $60;
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $63
      var $64=$3;
      var $65=$5;
      HEAP32[(($65)>>2)]=$64;
      $1=0;
      __label__ = 77; break;
    case 8: // $66
      __label__ = 9; break;
    case 9: // $67
      var $68=$3;
      var $69=(($68+2)|0);
      $3=$69;
      __label__ = 20; break;
    case 10: // $70
      var $71=$4;
      var $72=$3;
      var $73=$71;
      var $74=$72;
      var $75=(($73-$74)|0);
      var $76=(($75)|0) < 2;
      if ($76) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $77
      $1=-2;
      __label__ = 77; break;
    case 12: // $78
      var $79=$3;
      var $80=$5;
      HEAP32[(($80)>>2)]=$79;
      $1=0;
      __label__ = 77; break;
    case 13: // $81
      var $82=$4;
      var $83=$3;
      var $84=$82;
      var $85=$83;
      var $86=(($84-$85)|0);
      var $87=(($86)|0) < 3;
      if ($87) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $88
      $1=-2;
      __label__ = 77; break;
    case 15: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 77; break;
    case 16: // $92
      var $93=$4;
      var $94=$3;
      var $95=$93;
      var $96=$94;
      var $97=(($95-$96)|0);
      var $98=(($97)|0) < 4;
      if ($98) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $99
      $1=-2;
      __label__ = 77; break;
    case 18: // $100
      var $101=$3;
      var $102=$5;
      HEAP32[(($102)>>2)]=$101;
      $1=0;
      __label__ = 77; break;
    case 19: // $103
      var $104=$3;
      var $105=$5;
      HEAP32[(($105)>>2)]=$104;
      $1=0;
      __label__ = 77; break;
    case 20: // $106
      __label__ = 21; break;
    case 21: // $107
      var $108=$3;
      var $109=$4;
      var $110=(($108)|0)!=(($109)|0);
      if ($110) { __label__ = 22; break; } else { __label__ = 76; break; }
    case 22: // $111
      var $112=$3;
      var $113=(($112)|0);
      var $114=HEAP8[($113)];
      var $115=(($114 << 24) >> 24);
      var $116=(($115)|0)==0;
      if ($116) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $117
      var $118=$3;
      var $119=(($118+1)|0);
      var $120=HEAPU8[($119)];
      var $121=(($120)&255);
      var $122=$2;
      var $123=$122;
      var $124=(($123+76)|0);
      var $125=(($124+$121)|0);
      var $126=HEAPU8[($125)];
      var $127=(($126)&255);
      var $137 = $127;__label__ = 25; break;
    case 24: // $128
      var $129=$3;
      var $130=(($129)|0);
      var $131=HEAP8[($130)];
      var $132=$3;
      var $133=(($132+1)|0);
      var $134=HEAP8[($133)];
      var $135=__ZL17unicode_byte_typecc($131, $134);
      var $137 = $135;__label__ = 25; break;
    case 25: // $136
      var $137;
      if ($137 == 29) {
        __label__ = 26; break;
      }
      else if ($137 == 22 || $137 == 24 || $137 == 25 || $137 == 26 || $137 == 27) {
        __label__ = 29; break;
      }
      else if ($137 == 5) {
        __label__ = 30; break;
      }
      else if ($137 == 6) {
        __label__ = 33; break;
      }
      else if ($137 == 7) {
        __label__ = 36; break;
      }
      else if ($137 == 21 || $137 == 9 || $137 == 10) {
        __label__ = 39; break;
      }
      else if ($137 == 15) {
        __label__ = 66; break;
      }
      else {
      __label__ = 74; break;
      }
      
    case 26: // $138
      var $139=$3;
      var $140=(($139)|0);
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=((STRING_TABLE.__ZL9namePages+$142)|0);
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=$145 << 3;
      var $147=$3;
      var $148=(($147+1)|0);
      var $149=HEAPU8[($148)];
      var $150=(($149)&255);
      var $151=$150 >> 5;
      var $152=(($146+$151)|0);
      var $153=((__ZL12namingBitmap+($152<<2))|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$3;
      var $156=(($155+1)|0);
      var $157=HEAPU8[($156)];
      var $158=(($157)&255);
      var $159=$158 & 31;
      var $160=1 << $159;
      var $161=$154 & $160;
      var $162=(($161)|0)!=0;
      if ($162) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $163
      var $164=$3;
      var $165=$5;
      HEAP32[(($165)>>2)]=$164;
      $1=0;
      __label__ = 77; break;
    case 28: // $166
      __label__ = 29; break;
    case 29: // $167
      var $168=$3;
      var $169=(($168+2)|0);
      $3=$169;
      __label__ = 75; break;
    case 30: // $170
      var $171=$4;
      var $172=$3;
      var $173=$171;
      var $174=$172;
      var $175=(($173-$174)|0);
      var $176=(($175)|0) < 2;
      if ($176) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $177
      $1=-2;
      __label__ = 77; break;
    case 32: // $178
      var $179=$3;
      var $180=$5;
      HEAP32[(($180)>>2)]=$179;
      $1=0;
      __label__ = 77; break;
    case 33: // $181
      var $182=$4;
      var $183=$3;
      var $184=$182;
      var $185=$183;
      var $186=(($184-$185)|0);
      var $187=(($186)|0) < 3;
      if ($187) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $188
      $1=-2;
      __label__ = 77; break;
    case 35: // $189
      var $190=$3;
      var $191=$5;
      HEAP32[(($191)>>2)]=$190;
      $1=0;
      __label__ = 77; break;
    case 36: // $192
      var $193=$4;
      var $194=$3;
      var $195=$193;
      var $196=$194;
      var $197=(($195-$196)|0);
      var $198=(($197)|0) < 4;
      if ($198) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $199
      $1=-2;
      __label__ = 77; break;
    case 38: // $200
      var $201=$3;
      var $202=$5;
      HEAP32[(($202)>>2)]=$201;
      $1=0;
      __label__ = 77; break;
    case 39: // $203
      var $204=$2;
      var $205=$target;
      var $206=$3;
      var $207=__ZL18big2_checkPiTargetPK8encodingPKcS3_Pi($204, $205, $206, $tok);
      var $208=(($207)|0)!=0;
      if ($208) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $209
      var $210=$3;
      var $211=$5;
      HEAP32[(($211)>>2)]=$210;
      $1=0;
      __label__ = 77; break;
    case 41: // $212
      var $213=$3;
      var $214=(($213+2)|0);
      $3=$214;
      __label__ = 42; break;
    case 42: // $215
      var $216=$3;
      var $217=$4;
      var $218=(($216)|0)!=(($217)|0);
      if ($218) { __label__ = 43; break; } else { __label__ = 65; break; }
    case 43: // $219
      var $220=$3;
      var $221=(($220)|0);
      var $222=HEAP8[($221)];
      var $223=(($222 << 24) >> 24);
      var $224=(($223)|0)==0;
      if ($224) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $225
      var $226=$3;
      var $227=(($226+1)|0);
      var $228=HEAPU8[($227)];
      var $229=(($228)&255);
      var $230=$2;
      var $231=$230;
      var $232=(($231+76)|0);
      var $233=(($232+$229)|0);
      var $234=HEAPU8[($233)];
      var $235=(($234)&255);
      var $245 = $235;__label__ = 46; break;
    case 45: // $236
      var $237=$3;
      var $238=(($237)|0);
      var $239=HEAP8[($238)];
      var $240=$3;
      var $241=(($240+1)|0);
      var $242=HEAP8[($241)];
      var $243=__ZL17unicode_byte_typecc($239, $242);
      var $245 = $243;__label__ = 46; break;
    case 46: // $244
      var $245;
      if ($245 == 5) {
        __label__ = 47; break;
      }
      else if ($245 == 6) {
        __label__ = 50; break;
      }
      else if ($245 == 7) {
        __label__ = 53; break;
      }
      else if ($245 == 0 || $245 == 1 || $245 == 8) {
        __label__ = 56; break;
      }
      else if ($245 == 15) {
        __label__ = 57; break;
      }
      else {
      __label__ = 63; break;
      }
      
    case 47: // $246
      var $247=$4;
      var $248=$3;
      var $249=$247;
      var $250=$248;
      var $251=(($249-$250)|0);
      var $252=(($251)|0) < 2;
      if ($252) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $253
      $1=-2;
      __label__ = 77; break;
    case 49: // $254
      var $255=$3;
      var $256=(($255+2)|0);
      $3=$256;
      __label__ = 64; break;
    case 50: // $257
      var $258=$4;
      var $259=$3;
      var $260=$258;
      var $261=$259;
      var $262=(($260-$261)|0);
      var $263=(($262)|0) < 3;
      if ($263) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $264
      $1=-2;
      __label__ = 77; break;
    case 52: // $265
      var $266=$3;
      var $267=(($266+3)|0);
      $3=$267;
      __label__ = 64; break;
    case 53: // $268
      var $269=$4;
      var $270=$3;
      var $271=$269;
      var $272=$270;
      var $273=(($271-$272)|0);
      var $274=(($273)|0) < 4;
      if ($274) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $275
      $1=-2;
      __label__ = 77; break;
    case 55: // $276
      var $277=$3;
      var $278=(($277+4)|0);
      $3=$278;
      __label__ = 64; break;
    case 56: // $279
      var $280=$3;
      var $281=$5;
      HEAP32[(($281)>>2)]=$280;
      $1=0;
      __label__ = 77; break;
    case 57: // $282
      var $283=$3;
      var $284=(($283+2)|0);
      $3=$284;
      var $285=$3;
      var $286=$4;
      var $287=(($285)|0)==(($286)|0);
      if ($287) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $288
      $1=-1;
      __label__ = 77; break;
    case 59: // $289
      var $290=$3;
      var $291=(($290)|0);
      var $292=HEAP8[($291)];
      var $293=(($292 << 24) >> 24);
      var $294=(($293)|0)==0;
      if ($294) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $295
      var $296=$3;
      var $297=(($296+1)|0);
      var $298=HEAP8[($297)];
      var $299=(($298 << 24) >> 24);
      var $300=(($299)|0)==62;
      if ($300) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $301
      var $302=$3;
      var $303=(($302+2)|0);
      var $304=$5;
      HEAP32[(($304)>>2)]=$303;
      var $305=HEAP32[(($tok)>>2)];
      $1=$305;
      __label__ = 77; break;
    case 62: // $306
      __label__ = 64; break;
    case 63: // $307
      var $308=$3;
      var $309=(($308+2)|0);
      $3=$309;
      __label__ = 64; break;
    case 64: // $310
      __label__ = 42; break;
    case 65: // $311
      $1=-1;
      __label__ = 77; break;
    case 66: // $312
      var $313=$2;
      var $314=$target;
      var $315=$3;
      var $316=__ZL18big2_checkPiTargetPK8encodingPKcS3_Pi($313, $314, $315, $tok);
      var $317=(($316)|0)!=0;
      if ($317) { __label__ = 68; break; } else { __label__ = 67; break; }
    case 67: // $318
      var $319=$3;
      var $320=$5;
      HEAP32[(($320)>>2)]=$319;
      $1=0;
      __label__ = 77; break;
    case 68: // $321
      var $322=$3;
      var $323=(($322+2)|0);
      $3=$323;
      var $324=$3;
      var $325=$4;
      var $326=(($324)|0)==(($325)|0);
      if ($326) { __label__ = 69; break; } else { __label__ = 70; break; }
    case 69: // $327
      $1=-1;
      __label__ = 77; break;
    case 70: // $328
      var $329=$3;
      var $330=(($329)|0);
      var $331=HEAP8[($330)];
      var $332=(($331 << 24) >> 24);
      var $333=(($332)|0)==0;
      if ($333) { __label__ = 71; break; } else { __label__ = 73; break; }
    case 71: // $334
      var $335=$3;
      var $336=(($335+1)|0);
      var $337=HEAP8[($336)];
      var $338=(($337 << 24) >> 24);
      var $339=(($338)|0)==62;
      if ($339) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $340
      var $341=$3;
      var $342=(($341+2)|0);
      var $343=$5;
      HEAP32[(($343)>>2)]=$342;
      var $344=HEAP32[(($tok)>>2)];
      $1=$344;
      __label__ = 77; break;
    case 73: // $345
      __label__ = 74; break;
    case 74: // $346
      var $347=$3;
      var $348=$5;
      HEAP32[(($348)>>2)]=$347;
      $1=0;
      __label__ = 77; break;
    case 75: // $349
      __label__ = 21; break;
    case 76: // $350
      $1=-1;
      __label__ = 77; break;
    case 77: // $351
      var $352=$1;
      STACKTOP = __stackBase__;
      return $352;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11big2_scanPiPK8encodingPKcS3_PS3_["X"]=1;

function __ZL15big2_scanEndTagPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 56; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 6: // $37
      var $38=$3;
      var $39=(($38)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL11nmstrtPages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 56; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 20; break;
    case 10: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 56; break;
    case 12: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 56; break;
    case 13: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 56; break;
    case 15: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 56; break;
    case 16: // $91
      var $92=$4;
      var $93=$3;
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 56; break;
    case 18: // $99
      var $100=$3;
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 56; break;
    case 19: // $102
      var $103=$3;
      var $104=$5;
      HEAP32[(($104)>>2)]=$103;
      $1=0;
      __label__ = 56; break;
    case 20: // $105
      __label__ = 21; break;
    case 21: // $106
      var $107=$3;
      var $108=$4;
      var $109=(($107)|0)!=(($108)|0);
      if ($109) { __label__ = 22; break; } else { __label__ = 55; break; }
    case 22: // $110
      var $111=$3;
      var $112=(($111)|0);
      var $113=HEAP8[($112)];
      var $114=(($113 << 24) >> 24);
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $116
      var $117=$3;
      var $118=(($117+1)|0);
      var $119=HEAPU8[($118)];
      var $120=(($119)&255);
      var $121=$2;
      var $122=$121;
      var $123=(($122+76)|0);
      var $124=(($123+$120)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $136 = $126;__label__ = 25; break;
    case 24: // $127
      var $128=$3;
      var $129=(($128)|0);
      var $130=HEAP8[($129)];
      var $131=$3;
      var $132=(($131+1)|0);
      var $133=HEAP8[($132)];
      var $134=__ZL17unicode_byte_typecc($130, $133);
      var $136 = $134;__label__ = 25; break;
    case 25: // $135
      var $136;
      if ($136 == 29) {
        __label__ = 26; break;
      }
      else if ($136 == 22 || $136 == 24 || $136 == 25 || $136 == 26 || $136 == 27) {
        __label__ = 29; break;
      }
      else if ($136 == 5) {
        __label__ = 30; break;
      }
      else if ($136 == 6) {
        __label__ = 33; break;
      }
      else if ($136 == 7) {
        __label__ = 36; break;
      }
      else if ($136 == 21 || $136 == 9 || $136 == 10) {
        __label__ = 39; break;
      }
      else if ($136 == 23) {
        __label__ = 51; break;
      }
      else if ($136 == 11) {
        __label__ = 52; break;
      }
      else {
      __label__ = 53; break;
      }
      
    case 26: // $137
      var $138=$3;
      var $139=(($138)|0);
      var $140=HEAPU8[($139)];
      var $141=(($140)&255);
      var $142=((STRING_TABLE.__ZL9namePages+$141)|0);
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=$144 << 3;
      var $146=$3;
      var $147=(($146+1)|0);
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 >> 5;
      var $151=(($145+$150)|0);
      var $152=((__ZL12namingBitmap+($151<<2))|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=$3;
      var $155=(($154+1)|0);
      var $156=HEAPU8[($155)];
      var $157=(($156)&255);
      var $158=$157 & 31;
      var $159=1 << $158;
      var $160=$153 & $159;
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $162
      var $163=$3;
      var $164=$5;
      HEAP32[(($164)>>2)]=$163;
      $1=0;
      __label__ = 56; break;
    case 28: // $165
      __label__ = 29; break;
    case 29: // $166
      var $167=$3;
      var $168=(($167+2)|0);
      $3=$168;
      __label__ = 54; break;
    case 30: // $169
      var $170=$4;
      var $171=$3;
      var $172=$170;
      var $173=$171;
      var $174=(($172-$173)|0);
      var $175=(($174)|0) < 2;
      if ($175) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $176
      $1=-2;
      __label__ = 56; break;
    case 32: // $177
      var $178=$3;
      var $179=$5;
      HEAP32[(($179)>>2)]=$178;
      $1=0;
      __label__ = 56; break;
    case 33: // $180
      var $181=$4;
      var $182=$3;
      var $183=$181;
      var $184=$182;
      var $185=(($183-$184)|0);
      var $186=(($185)|0) < 3;
      if ($186) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $187
      $1=-2;
      __label__ = 56; break;
    case 35: // $188
      var $189=$3;
      var $190=$5;
      HEAP32[(($190)>>2)]=$189;
      $1=0;
      __label__ = 56; break;
    case 36: // $191
      var $192=$4;
      var $193=$3;
      var $194=$192;
      var $195=$193;
      var $196=(($194-$195)|0);
      var $197=(($196)|0) < 4;
      if ($197) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $198
      $1=-2;
      __label__ = 56; break;
    case 38: // $199
      var $200=$3;
      var $201=$5;
      HEAP32[(($201)>>2)]=$200;
      $1=0;
      __label__ = 56; break;
    case 39: // $202
      var $203=$3;
      var $204=(($203+2)|0);
      $3=$204;
      __label__ = 40; break;
    case 40: // $205
      var $206=$3;
      var $207=$4;
      var $208=(($206)|0)!=(($207)|0);
      if ($208) { __label__ = 41; break; } else { __label__ = 50; break; }
    case 41: // $209
      var $210=$3;
      var $211=(($210)|0);
      var $212=HEAP8[($211)];
      var $213=(($212 << 24) >> 24);
      var $214=(($213)|0)==0;
      if ($214) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $215
      var $216=$3;
      var $217=(($216+1)|0);
      var $218=HEAPU8[($217)];
      var $219=(($218)&255);
      var $220=$2;
      var $221=$220;
      var $222=(($221+76)|0);
      var $223=(($222+$219)|0);
      var $224=HEAPU8[($223)];
      var $225=(($224)&255);
      var $235 = $225;__label__ = 44; break;
    case 43: // $226
      var $227=$3;
      var $228=(($227)|0);
      var $229=HEAP8[($228)];
      var $230=$3;
      var $231=(($230+1)|0);
      var $232=HEAP8[($231)];
      var $233=__ZL17unicode_byte_typecc($229, $232);
      var $235 = $233;__label__ = 44; break;
    case 44: // $234
      var $235;
      if ($235 == 21 || $235 == 9 || $235 == 10) {
        __label__ = 45; break;
      }
      else if ($235 == 11) {
        __label__ = 46; break;
      }
      else {
      __label__ = 47; break;
      }
      
    case 45: // $236
      __label__ = 48; break;
    case 46: // $237
      var $238=$3;
      var $239=(($238+2)|0);
      var $240=$5;
      HEAP32[(($240)>>2)]=$239;
      $1=5;
      __label__ = 56; break;
    case 47: // $241
      var $242=$3;
      var $243=$5;
      HEAP32[(($243)>>2)]=$242;
      $1=0;
      __label__ = 56; break;
    case 48: // $244
      __label__ = 49; break;
    case 49: // $245
      var $246=$3;
      var $247=(($246+2)|0);
      $3=$247;
      __label__ = 40; break;
    case 50: // $248
      $1=-1;
      __label__ = 56; break;
    case 51: // $249
      var $250=$3;
      var $251=(($250+2)|0);
      $3=$251;
      __label__ = 54; break;
    case 52: // $252
      var $253=$3;
      var $254=(($253+2)|0);
      var $255=$5;
      HEAP32[(($255)>>2)]=$254;
      $1=5;
      __label__ = 56; break;
    case 53: // $256
      var $257=$3;
      var $258=$5;
      HEAP32[(($258)>>2)]=$257;
      $1=0;
      __label__ = 56; break;
    case 54: // $259
      __label__ = 21; break;
    case 55: // $260
      $1=-1;
      __label__ = 56; break;
    case 56: // $261
      var $262=$1;
      ;
      return $262;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15big2_scanEndTagPK8encodingPKcS3_PS3_["X"]=1;

function __ZL13big2_scanAttsPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $hadColon;
      var $t;
      var $open;
      var $t1;
      var $tok;
      $2=$enc;
      HEAP32[(($3)>>2)]=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      $hadColon=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=HEAP32[(($3)>>2)];
      var $8=$4;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 140; break; }
    case 2: // $10
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=HEAP32[(($3)>>2)];
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=HEAP32[(($3)>>2)];
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=HEAP32[(($3)>>2)];
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24 || $36 == 25 || $36 == 26 || $36 == 27) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else if ($36 == 23) {
        __label__ = 19; break;
      }
      else if ($36 == 21 || $36 == 9 || $36 == 10) {
        __label__ = 42; break;
      }
      else if ($36 == 14) {
        __label__ = 55; break;
      }
      else {
      __label__ = 138; break;
      }
      
    case 6: // $37
      var $38=HEAP32[(($3)>>2)];
      var $39=(($38)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL9namePages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=HEAP32[(($3)>>2)];
      var $47=(($46+1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=HEAP32[(($3)>>2)];
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=HEAP32[(($3)>>2)];
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 141; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=HEAP32[(($3)>>2)];
      var $68=(($67+2)|0);
      HEAP32[(($3)>>2)]=$68;
      __label__ = 139; break;
    case 10: // $69
      var $70=$4;
      var $71=HEAP32[(($3)>>2)];
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 141; break;
    case 12: // $77
      var $78=HEAP32[(($3)>>2)];
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 141; break;
    case 13: // $80
      var $81=$4;
      var $82=HEAP32[(($3)>>2)];
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 141; break;
    case 15: // $88
      var $89=HEAP32[(($3)>>2)];
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 141; break;
    case 16: // $91
      var $92=$4;
      var $93=HEAP32[(($3)>>2)];
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 141; break;
    case 18: // $99
      var $100=HEAP32[(($3)>>2)];
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 141; break;
    case 19: // $102
      var $103=$hadColon;
      var $104=(($103)|0)!=0;
      if ($104) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $105
      var $106=HEAP32[(($3)>>2)];
      var $107=$5;
      HEAP32[(($107)>>2)]=$106;
      $1=0;
      __label__ = 141; break;
    case 21: // $108
      $hadColon=1;
      var $109=HEAP32[(($3)>>2)];
      var $110=(($109+2)|0);
      HEAP32[(($3)>>2)]=$110;
      var $111=HEAP32[(($3)>>2)];
      var $112=$4;
      var $113=(($111)|0)==(($112)|0);
      if ($113) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $114
      $1=-1;
      __label__ = 141; break;
    case 23: // $115
      var $116=HEAP32[(($3)>>2)];
      var $117=(($116)|0);
      var $118=HEAP8[($117)];
      var $119=(($118 << 24) >> 24);
      var $120=(($119)|0)==0;
      if ($120) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $121
      var $122=HEAP32[(($3)>>2)];
      var $123=(($122+1)|0);
      var $124=HEAPU8[($123)];
      var $125=(($124)&255);
      var $126=$2;
      var $127=$126;
      var $128=(($127+76)|0);
      var $129=(($128+$125)|0);
      var $130=HEAPU8[($129)];
      var $131=(($130)&255);
      var $141 = $131;__label__ = 26; break;
    case 25: // $132
      var $133=HEAP32[(($3)>>2)];
      var $134=(($133)|0);
      var $135=HEAP8[($134)];
      var $136=HEAP32[(($3)>>2)];
      var $137=(($136+1)|0);
      var $138=HEAP8[($137)];
      var $139=__ZL17unicode_byte_typecc($135, $138);
      var $141 = $139;__label__ = 26; break;
    case 26: // $140
      var $141;
      if ($141 == 29) {
        __label__ = 27; break;
      }
      else if ($141 == 22 || $141 == 24) {
        __label__ = 30; break;
      }
      else if ($141 == 5) {
        __label__ = 31; break;
      }
      else if ($141 == 6) {
        __label__ = 34; break;
      }
      else if ($141 == 7) {
        __label__ = 37; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 27: // $142
      var $143=HEAP32[(($3)>>2)];
      var $144=(($143)|0);
      var $145=HEAPU8[($144)];
      var $146=(($145)&255);
      var $147=((STRING_TABLE.__ZL11nmstrtPages+$146)|0);
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 << 3;
      var $151=HEAP32[(($3)>>2)];
      var $152=(($151+1)|0);
      var $153=HEAPU8[($152)];
      var $154=(($153)&255);
      var $155=$154 >> 5;
      var $156=(($150+$155)|0);
      var $157=((__ZL12namingBitmap+($156<<2))|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=HEAP32[(($3)>>2)];
      var $160=(($159+1)|0);
      var $161=HEAPU8[($160)];
      var $162=(($161)&255);
      var $163=$162 & 31;
      var $164=1 << $163;
      var $165=$158 & $164;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $167
      var $168=HEAP32[(($3)>>2)];
      var $169=$5;
      HEAP32[(($169)>>2)]=$168;
      $1=0;
      __label__ = 141; break;
    case 29: // $170
      __label__ = 30; break;
    case 30: // $171
      var $172=HEAP32[(($3)>>2)];
      var $173=(($172+2)|0);
      HEAP32[(($3)>>2)]=$173;
      __label__ = 41; break;
    case 31: // $174
      var $175=$4;
      var $176=HEAP32[(($3)>>2)];
      var $177=$175;
      var $178=$176;
      var $179=(($177-$178)|0);
      var $180=(($179)|0) < 2;
      if ($180) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $181
      $1=-2;
      __label__ = 141; break;
    case 33: // $182
      var $183=HEAP32[(($3)>>2)];
      var $184=$5;
      HEAP32[(($184)>>2)]=$183;
      $1=0;
      __label__ = 141; break;
    case 34: // $185
      var $186=$4;
      var $187=HEAP32[(($3)>>2)];
      var $188=$186;
      var $189=$187;
      var $190=(($188-$189)|0);
      var $191=(($190)|0) < 3;
      if ($191) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $192
      $1=-2;
      __label__ = 141; break;
    case 36: // $193
      var $194=HEAP32[(($3)>>2)];
      var $195=$5;
      HEAP32[(($195)>>2)]=$194;
      $1=0;
      __label__ = 141; break;
    case 37: // $196
      var $197=$4;
      var $198=HEAP32[(($3)>>2)];
      var $199=$197;
      var $200=$198;
      var $201=(($199-$200)|0);
      var $202=(($201)|0) < 4;
      if ($202) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $203
      $1=-2;
      __label__ = 141; break;
    case 39: // $204
      var $205=HEAP32[(($3)>>2)];
      var $206=$5;
      HEAP32[(($206)>>2)]=$205;
      $1=0;
      __label__ = 141; break;
    case 40: // $207
      var $208=HEAP32[(($3)>>2)];
      var $209=$5;
      HEAP32[(($209)>>2)]=$208;
      $1=0;
      __label__ = 141; break;
    case 41: // $210
      __label__ = 139; break;
    case 42: // $211
      __label__ = 43; break;
    case 43: // $212
      var $213=HEAP32[(($3)>>2)];
      var $214=(($213+2)|0);
      HEAP32[(($3)>>2)]=$214;
      var $215=HEAP32[(($3)>>2)];
      var $216=$4;
      var $217=(($215)|0)==(($216)|0);
      if ($217) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $218
      $1=-1;
      __label__ = 141; break;
    case 45: // $219
      var $220=HEAP32[(($3)>>2)];
      var $221=(($220)|0);
      var $222=HEAP8[($221)];
      var $223=(($222 << 24) >> 24);
      var $224=(($223)|0)==0;
      if ($224) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $225
      var $226=HEAP32[(($3)>>2)];
      var $227=(($226+1)|0);
      var $228=HEAPU8[($227)];
      var $229=(($228)&255);
      var $230=$2;
      var $231=$230;
      var $232=(($231+76)|0);
      var $233=(($232+$229)|0);
      var $234=HEAPU8[($233)];
      var $235=(($234)&255);
      var $245 = $235;__label__ = 48; break;
    case 47: // $236
      var $237=HEAP32[(($3)>>2)];
      var $238=(($237)|0);
      var $239=HEAP8[($238)];
      var $240=HEAP32[(($3)>>2)];
      var $241=(($240+1)|0);
      var $242=HEAP8[($241)];
      var $243=__ZL17unicode_byte_typecc($239, $242);
      var $245 = $243;__label__ = 48; break;
    case 48: // $244
      var $245;
      $t=$245;
      var $246=$t;
      var $247=(($246)|0)==14;
      if ($247) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $248
      __label__ = 54; break;
    case 50: // $249
      var $250=$t;
      if ($250 == 21 || $250 == 10 || $250 == 9) {
        __label__ = 51; break;
      }
      else {
      __label__ = 52; break;
      }
      
    case 51: // $251
      __label__ = 53; break;
    case 52: // $252
      var $253=HEAP32[(($3)>>2)];
      var $254=$5;
      HEAP32[(($254)>>2)]=$253;
      $1=0;
      __label__ = 141; break;
    case 53: // $255
      __label__ = 43; break;
    case 54: // $256
      __label__ = 55; break;
    case 55: // $257
      $hadColon=0;
      __label__ = 56; break;
    case 56: // $258
      var $259=HEAP32[(($3)>>2)];
      var $260=(($259+2)|0);
      HEAP32[(($3)>>2)]=$260;
      var $261=HEAP32[(($3)>>2)];
      var $262=$4;
      var $263=(($261)|0)==(($262)|0);
      if ($263) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $264
      $1=-1;
      __label__ = 141; break;
    case 58: // $265
      var $266=HEAP32[(($3)>>2)];
      var $267=(($266)|0);
      var $268=HEAP8[($267)];
      var $269=(($268 << 24) >> 24);
      var $270=(($269)|0)==0;
      if ($270) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $271
      var $272=HEAP32[(($3)>>2)];
      var $273=(($272+1)|0);
      var $274=HEAPU8[($273)];
      var $275=(($274)&255);
      var $276=$2;
      var $277=$276;
      var $278=(($277+76)|0);
      var $279=(($278+$275)|0);
      var $280=HEAPU8[($279)];
      var $281=(($280)&255);
      var $291 = $281;__label__ = 61; break;
    case 60: // $282
      var $283=HEAP32[(($3)>>2)];
      var $284=(($283)|0);
      var $285=HEAP8[($284)];
      var $286=HEAP32[(($3)>>2)];
      var $287=(($286+1)|0);
      var $288=HEAP8[($287)];
      var $289=__ZL17unicode_byte_typecc($285, $288);
      var $291 = $289;__label__ = 61; break;
    case 61: // $290
      var $291;
      $open=$291;
      var $292=$open;
      var $293=(($292)|0)==12;
      if ($293) { __label__ = 63; break; } else { __label__ = 62; break; }
    case 62: // $294
      var $295=$open;
      var $296=(($295)|0)==13;
      if ($296) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $297
      __label__ = 68; break;
    case 64: // $298
      var $299=$open;
      if ($299 == 21 || $299 == 10 || $299 == 9) {
        __label__ = 65; break;
      }
      else {
      __label__ = 66; break;
      }
      
    case 65: // $300
      __label__ = 67; break;
    case 66: // $301
      var $302=HEAP32[(($3)>>2)];
      var $303=$5;
      HEAP32[(($303)>>2)]=$302;
      $1=0;
      __label__ = 141; break;
    case 67: // $304
      __label__ = 56; break;
    case 68: // $305
      var $306=HEAP32[(($3)>>2)];
      var $307=(($306+2)|0);
      HEAP32[(($3)>>2)]=$307;
      __label__ = 69; break;
    case 69: // $308
      var $309=HEAP32[(($3)>>2)];
      var $310=$4;
      var $311=(($309)|0)==(($310)|0);
      if ($311) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $312
      $1=-1;
      __label__ = 141; break;
    case 71: // $313
      var $314=HEAP32[(($3)>>2)];
      var $315=(($314)|0);
      var $316=HEAP8[($315)];
      var $317=(($316 << 24) >> 24);
      var $318=(($317)|0)==0;
      if ($318) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $319
      var $320=HEAP32[(($3)>>2)];
      var $321=(($320+1)|0);
      var $322=HEAPU8[($321)];
      var $323=(($322)&255);
      var $324=$2;
      var $325=$324;
      var $326=(($325+76)|0);
      var $327=(($326+$323)|0);
      var $328=HEAPU8[($327)];
      var $329=(($328)&255);
      var $339 = $329;__label__ = 74; break;
    case 73: // $330
      var $331=HEAP32[(($3)>>2)];
      var $332=(($331)|0);
      var $333=HEAP8[($332)];
      var $334=HEAP32[(($3)>>2)];
      var $335=(($334+1)|0);
      var $336=HEAP8[($335)];
      var $337=__ZL17unicode_byte_typecc($333, $336);
      var $339 = $337;__label__ = 74; break;
    case 74: // $338
      var $339;
      $t1=$339;
      var $340=$t1;
      var $341=$open;
      var $342=(($340)|0)==(($341)|0);
      if ($342) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $343
      __label__ = 95; break;
    case 76: // $344
      var $345=$t1;
      if ($345 == 5) {
        __label__ = 77; break;
      }
      else if ($345 == 6) {
        __label__ = 80; break;
      }
      else if ($345 == 7) {
        __label__ = 83; break;
      }
      else if ($345 == 0 || $345 == 1 || $345 == 8) {
        __label__ = 86; break;
      }
      else if ($345 == 3) {
        __label__ = 87; break;
      }
      else if ($345 == 2) {
        __label__ = 92; break;
      }
      else {
      __label__ = 93; break;
      }
      
    case 77: // $346
      var $347=$4;
      var $348=HEAP32[(($3)>>2)];
      var $349=$347;
      var $350=$348;
      var $351=(($349-$350)|0);
      var $352=(($351)|0) < 2;
      if ($352) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $353
      $1=-2;
      __label__ = 141; break;
    case 79: // $354
      var $355=HEAP32[(($3)>>2)];
      var $356=(($355+2)|0);
      HEAP32[(($3)>>2)]=$356;
      __label__ = 94; break;
    case 80: // $357
      var $358=$4;
      var $359=HEAP32[(($3)>>2)];
      var $360=$358;
      var $361=$359;
      var $362=(($360-$361)|0);
      var $363=(($362)|0) < 3;
      if ($363) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $364
      $1=-2;
      __label__ = 141; break;
    case 82: // $365
      var $366=HEAP32[(($3)>>2)];
      var $367=(($366+3)|0);
      HEAP32[(($3)>>2)]=$367;
      __label__ = 94; break;
    case 83: // $368
      var $369=$4;
      var $370=HEAP32[(($3)>>2)];
      var $371=$369;
      var $372=$370;
      var $373=(($371-$372)|0);
      var $374=(($373)|0) < 4;
      if ($374) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $375
      $1=-2;
      __label__ = 141; break;
    case 85: // $376
      var $377=HEAP32[(($3)>>2)];
      var $378=(($377+4)|0);
      HEAP32[(($3)>>2)]=$378;
      __label__ = 94; break;
    case 86: // $379
      var $380=HEAP32[(($3)>>2)];
      var $381=$5;
      HEAP32[(($381)>>2)]=$380;
      $1=0;
      __label__ = 141; break;
    case 87: // $382
      var $383=$2;
      var $384=HEAP32[(($3)>>2)];
      var $385=(($384+2)|0);
      var $386=$4;
      var $387=__ZL12big2_scanRefPK8encodingPKcS3_PS3_($383, $385, $386, $3);
      $tok=$387;
      var $388=$tok;
      var $389=(($388)|0) <= 0;
      if ($389) { __label__ = 88; break; } else { __label__ = 91; break; }
    case 88: // $390
      var $391=$tok;
      var $392=(($391)|0)==0;
      if ($392) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $393
      var $394=HEAP32[(($3)>>2)];
      var $395=$5;
      HEAP32[(($395)>>2)]=$394;
      __label__ = 90; break;
    case 90: // $396
      var $397=$tok;
      $1=$397;
      __label__ = 141; break;
    case 91: // $398
      __label__ = 94; break;
    case 92: // $399
      var $400=HEAP32[(($3)>>2)];
      var $401=$5;
      HEAP32[(($401)>>2)]=$400;
      $1=0;
      __label__ = 141; break;
    case 93: // $402
      var $403=HEAP32[(($3)>>2)];
      var $404=(($403+2)|0);
      HEAP32[(($3)>>2)]=$404;
      __label__ = 94; break;
    case 94: // $405
      __label__ = 69; break;
    case 95: // $406
      var $407=HEAP32[(($3)>>2)];
      var $408=(($407+2)|0);
      HEAP32[(($3)>>2)]=$408;
      var $409=HEAP32[(($3)>>2)];
      var $410=$4;
      var $411=(($409)|0)==(($410)|0);
      if ($411) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $412
      $1=-1;
      __label__ = 141; break;
    case 97: // $413
      var $414=HEAP32[(($3)>>2)];
      var $415=(($414)|0);
      var $416=HEAP8[($415)];
      var $417=(($416 << 24) >> 24);
      var $418=(($417)|0)==0;
      if ($418) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $419
      var $420=HEAP32[(($3)>>2)];
      var $421=(($420+1)|0);
      var $422=HEAPU8[($421)];
      var $423=(($422)&255);
      var $424=$2;
      var $425=$424;
      var $426=(($425+76)|0);
      var $427=(($426+$423)|0);
      var $428=HEAPU8[($427)];
      var $429=(($428)&255);
      var $439 = $429;__label__ = 100; break;
    case 99: // $430
      var $431=HEAP32[(($3)>>2)];
      var $432=(($431)|0);
      var $433=HEAP8[($432)];
      var $434=HEAP32[(($3)>>2)];
      var $435=(($434+1)|0);
      var $436=HEAP8[($435)];
      var $437=__ZL17unicode_byte_typecc($433, $436);
      var $439 = $437;__label__ = 100; break;
    case 100: // $438
      var $439;
      if ($439 == 21 || $439 == 9 || $439 == 10) {
        __label__ = 101; break;
      }
      else if ($439 == 17) {
        __label__ = 102; break;
      }
      else if ($439 == 11) {
        __label__ = 103; break;
      }
      else {
      __label__ = 104; break;
      }
      
    case 101: // $440
      __label__ = 105; break;
    case 102: // $441
      __label__ = 129; break;
    case 103: // $442
      __label__ = 127; break;
    case 104: // $443
      var $444=HEAP32[(($3)>>2)];
      var $445=$5;
      HEAP32[(($445)>>2)]=$444;
      $1=0;
      __label__ = 141; break;
    case 105: // $446
      __label__ = 106; break;
    case 106: // $447
      var $448=HEAP32[(($3)>>2)];
      var $449=(($448+2)|0);
      HEAP32[(($3)>>2)]=$449;
      var $450=HEAP32[(($3)>>2)];
      var $451=$4;
      var $452=(($450)|0)==(($451)|0);
      if ($452) { __label__ = 107; break; } else { __label__ = 108; break; }
    case 107: // $453
      $1=-1;
      __label__ = 141; break;
    case 108: // $454
      var $455=HEAP32[(($3)>>2)];
      var $456=(($455)|0);
      var $457=HEAP8[($456)];
      var $458=(($457 << 24) >> 24);
      var $459=(($458)|0)==0;
      if ($459) { __label__ = 109; break; } else { __label__ = 110; break; }
    case 109: // $460
      var $461=HEAP32[(($3)>>2)];
      var $462=(($461+1)|0);
      var $463=HEAPU8[($462)];
      var $464=(($463)&255);
      var $465=$2;
      var $466=$465;
      var $467=(($466+76)|0);
      var $468=(($467+$464)|0);
      var $469=HEAPU8[($468)];
      var $470=(($469)&255);
      var $480 = $470;__label__ = 111; break;
    case 110: // $471
      var $472=HEAP32[(($3)>>2)];
      var $473=(($472)|0);
      var $474=HEAP8[($473)];
      var $475=HEAP32[(($3)>>2)];
      var $476=(($475+1)|0);
      var $477=HEAP8[($476)];
      var $478=__ZL17unicode_byte_typecc($474, $477);
      var $480 = $478;__label__ = 111; break;
    case 111: // $479
      var $480;
      if ($480 == 29) {
        __label__ = 112; break;
      }
      else if ($480 == 22 || $480 == 24) {
        __label__ = 115; break;
      }
      else if ($480 == 5) {
        __label__ = 116; break;
      }
      else if ($480 == 6) {
        __label__ = 119; break;
      }
      else if ($480 == 7) {
        __label__ = 122; break;
      }
      else if ($480 == 21 || $480 == 9 || $480 == 10) {
        __label__ = 125; break;
      }
      else if ($480 == 11) {
        __label__ = 126; break;
      }
      else if ($480 == 17) {
        __label__ = 128; break;
      }
      else {
      __label__ = 135; break;
      }
      
    case 112: // $481
      var $482=HEAP32[(($3)>>2)];
      var $483=(($482)|0);
      var $484=HEAPU8[($483)];
      var $485=(($484)&255);
      var $486=((STRING_TABLE.__ZL11nmstrtPages+$485)|0);
      var $487=HEAPU8[($486)];
      var $488=(($487)&255);
      var $489=$488 << 3;
      var $490=HEAP32[(($3)>>2)];
      var $491=(($490+1)|0);
      var $492=HEAPU8[($491)];
      var $493=(($492)&255);
      var $494=$493 >> 5;
      var $495=(($489+$494)|0);
      var $496=((__ZL12namingBitmap+($495<<2))|0);
      var $497=HEAP32[(($496)>>2)];
      var $498=HEAP32[(($3)>>2)];
      var $499=(($498+1)|0);
      var $500=HEAPU8[($499)];
      var $501=(($500)&255);
      var $502=$501 & 31;
      var $503=1 << $502;
      var $504=$497 & $503;
      var $505=(($504)|0)!=0;
      if ($505) { __label__ = 114; break; } else { __label__ = 113; break; }
    case 113: // $506
      var $507=HEAP32[(($3)>>2)];
      var $508=$5;
      HEAP32[(($508)>>2)]=$507;
      $1=0;
      __label__ = 141; break;
    case 114: // $509
      __label__ = 115; break;
    case 115: // $510
      var $511=HEAP32[(($3)>>2)];
      var $512=(($511+2)|0);
      HEAP32[(($3)>>2)]=$512;
      __label__ = 136; break;
    case 116: // $513
      var $514=$4;
      var $515=HEAP32[(($3)>>2)];
      var $516=$514;
      var $517=$515;
      var $518=(($516-$517)|0);
      var $519=(($518)|0) < 2;
      if ($519) { __label__ = 117; break; } else { __label__ = 118; break; }
    case 117: // $520
      $1=-2;
      __label__ = 141; break;
    case 118: // $521
      var $522=HEAP32[(($3)>>2)];
      var $523=$5;
      HEAP32[(($523)>>2)]=$522;
      $1=0;
      __label__ = 141; break;
    case 119: // $524
      var $525=$4;
      var $526=HEAP32[(($3)>>2)];
      var $527=$525;
      var $528=$526;
      var $529=(($527-$528)|0);
      var $530=(($529)|0) < 3;
      if ($530) { __label__ = 120; break; } else { __label__ = 121; break; }
    case 120: // $531
      $1=-2;
      __label__ = 141; break;
    case 121: // $532
      var $533=HEAP32[(($3)>>2)];
      var $534=$5;
      HEAP32[(($534)>>2)]=$533;
      $1=0;
      __label__ = 141; break;
    case 122: // $535
      var $536=$4;
      var $537=HEAP32[(($3)>>2)];
      var $538=$536;
      var $539=$537;
      var $540=(($538-$539)|0);
      var $541=(($540)|0) < 4;
      if ($541) { __label__ = 123; break; } else { __label__ = 124; break; }
    case 123: // $542
      $1=-2;
      __label__ = 141; break;
    case 124: // $543
      var $544=HEAP32[(($3)>>2)];
      var $545=$5;
      HEAP32[(($545)>>2)]=$544;
      $1=0;
      __label__ = 141; break;
    case 125: // $546
      __label__ = 106; break;
    case 126: // $547
      __label__ = 127; break;
    case 127: // $548
      var $549=HEAP32[(($3)>>2)];
      var $550=(($549+2)|0);
      var $551=$5;
      HEAP32[(($551)>>2)]=$550;
      $1=1;
      __label__ = 141; break;
    case 128: // $552
      __label__ = 129; break;
    case 129: // $553
      var $554=HEAP32[(($3)>>2)];
      var $555=(($554+2)|0);
      HEAP32[(($3)>>2)]=$555;
      var $556=HEAP32[(($3)>>2)];
      var $557=$4;
      var $558=(($556)|0)==(($557)|0);
      if ($558) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $559
      $1=-1;
      __label__ = 141; break;
    case 131: // $560
      var $561=HEAP32[(($3)>>2)];
      var $562=(($561)|0);
      var $563=HEAP8[($562)];
      var $564=(($563 << 24) >> 24);
      var $565=(($564)|0)==0;
      if ($565) { __label__ = 132; break; } else { __label__ = 133; break; }
    case 132: // $566
      var $567=HEAP32[(($3)>>2)];
      var $568=(($567+1)|0);
      var $569=HEAP8[($568)];
      var $570=(($569 << 24) >> 24);
      var $571=(($570)|0)==62;
      if ($571) { __label__ = 134; break; } else { __label__ = 133; break; }
    case 133: // $572
      var $573=HEAP32[(($3)>>2)];
      var $574=$5;
      HEAP32[(($574)>>2)]=$573;
      $1=0;
      __label__ = 141; break;
    case 134: // $575
      var $576=HEAP32[(($3)>>2)];
      var $577=(($576+2)|0);
      var $578=$5;
      HEAP32[(($578)>>2)]=$577;
      $1=3;
      __label__ = 141; break;
    case 135: // $579
      var $580=HEAP32[(($3)>>2)];
      var $581=$5;
      HEAP32[(($581)>>2)]=$580;
      $1=0;
      __label__ = 141; break;
    case 136: // $582
      __label__ = 137; break;
    case 137: // $583
      __label__ = 139; break;
    case 138: // $584
      var $585=HEAP32[(($3)>>2)];
      var $586=$5;
      HEAP32[(($586)>>2)]=$585;
      $1=0;
      __label__ = 141; break;
    case 139: // $587
      __label__ = 1; break;
    case 140: // $588
      $1=-1;
      __label__ = 141; break;
    case 141: // $589
      var $590=$1;
      STACKTOP = __stackBase__;
      return $590;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13big2_scanAttsPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18big2_checkPiTargetPK8encodingPKcS3_Pi($enc, $ptr, $end, $tokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $upper;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$tokPtr;
      $upper=0;
      var $6=$5;
      HEAP32[(($6)>>2)]=11;
      var $7=$4;
      var $8=$3;
      var $9=$7;
      var $10=$8;
      var $11=(($9-$10)|0);
      var $12=(($11)|0)!=6;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=1;
      __label__ = 23; break;
    case 2: // $14
      var $15=$3;
      var $16=(($15)|0);
      var $17=HEAP8[($16)];
      var $18=(($17 << 24) >> 24);
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$3;
      var $22=(($21+1)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $27 = $24;__label__ = 5; break;
    case 4: // $25
      var $27 = -1;__label__ = 5; break;
    case 5: // $26
      var $27;
      if ($27 == 120) {
        __label__ = 8; break;
      }
      else if ($27 == 88) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 6: // $28
      $upper=1;
      __label__ = 8; break;
    case 7: // $29
      $1=1;
      __label__ = 23; break;
    case 8: // $30
      var $31=$3;
      var $32=(($31+2)|0);
      $3=$32;
      var $33=$3;
      var $34=(($33)|0);
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $38
      var $39=$3;
      var $40=(($39+1)|0);
      var $41=HEAP8[($40)];
      var $42=(($41 << 24) >> 24);
      var $45 = $42;__label__ = 11; break;
    case 10: // $43
      var $45 = -1;__label__ = 11; break;
    case 11: // $44
      var $45;
      if ($45 == 109) {
        __label__ = 14; break;
      }
      else if ($45 == 77) {
        __label__ = 12; break;
      }
      else {
      __label__ = 13; break;
      }
      
    case 12: // $46
      $upper=1;
      __label__ = 14; break;
    case 13: // $47
      $1=1;
      __label__ = 23; break;
    case 14: // $48
      var $49=$3;
      var $50=(($49+2)|0);
      $3=$50;
      var $51=$3;
      var $52=(($51)|0);
      var $53=HEAP8[($52)];
      var $54=(($53 << 24) >> 24);
      var $55=(($54)|0)==0;
      if ($55) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $56
      var $57=$3;
      var $58=(($57+1)|0);
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $63 = $60;__label__ = 17; break;
    case 16: // $61
      var $63 = -1;__label__ = 17; break;
    case 17: // $62
      var $63;
      if ($63 == 108) {
        __label__ = 20; break;
      }
      else if ($63 == 76) {
        __label__ = 18; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 18: // $64
      $upper=1;
      __label__ = 20; break;
    case 19: // $65
      $1=1;
      __label__ = 23; break;
    case 20: // $66
      var $67=$upper;
      var $68=(($67)|0)!=0;
      if ($68) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $69
      $1=0;
      __label__ = 23; break;
    case 22: // $70
      var $71=$5;
      HEAP32[(($71)>>2)]=12;
      $1=1;
      __label__ = 23; break;
    case 23: // $72
      var $73=$1;
      ;
      return $73;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18big2_checkPiTargetPK8encodingPKcS3_Pi["X"]=1;

function __ZL12big2_scanLitiPK8encodingPKcS3_PS3_($open, $enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $t;
      $2=$open;
      $3=$enc;
      $4=$ptr;
      $5=$end;
      $6=$nextTokPtr;
      __label__ = 1; break;
    case 1: // $7
      var $8=$4;
      var $9=$5;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 28; break; }
    case 2: // $11
      var $12=$4;
      var $13=(($12)|0);
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $18=$4;
      var $19=(($18+1)|0);
      var $20=HEAPU8[($19)];
      var $21=(($20)&255);
      var $22=$3;
      var $23=$22;
      var $24=(($23+76)|0);
      var $25=(($24+$21)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $37 = $27;__label__ = 5; break;
    case 4: // $28
      var $29=$4;
      var $30=(($29)|0);
      var $31=HEAP8[($30)];
      var $32=$4;
      var $33=(($32+1)|0);
      var $34=HEAP8[($33)];
      var $35=__ZL17unicode_byte_typecc($31, $34);
      var $37 = $35;__label__ = 5; break;
    case 5: // $36
      var $37;
      $t=$37;
      var $38=$t;
      if ($38 == 5) {
        __label__ = 6; break;
      }
      else if ($38 == 6) {
        __label__ = 9; break;
      }
      else if ($38 == 7) {
        __label__ = 12; break;
      }
      else if ($38 == 0 || $38 == 1 || $38 == 8) {
        __label__ = 15; break;
      }
      else if ($38 == 12 || $38 == 13) {
        __label__ = 16; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 6: // $39
      var $40=$5;
      var $41=$4;
      var $42=$40;
      var $43=$41;
      var $44=(($42-$43)|0);
      var $45=(($44)|0) < 2;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      $1=-2;
      __label__ = 29; break;
    case 8: // $47
      var $48=$4;
      var $49=(($48+2)|0);
      $4=$49;
      __label__ = 27; break;
    case 9: // $50
      var $51=$5;
      var $52=$4;
      var $53=$51;
      var $54=$52;
      var $55=(($53-$54)|0);
      var $56=(($55)|0) < 3;
      if ($56) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $57
      $1=-2;
      __label__ = 29; break;
    case 11: // $58
      var $59=$4;
      var $60=(($59+3)|0);
      $4=$60;
      __label__ = 27; break;
    case 12: // $61
      var $62=$5;
      var $63=$4;
      var $64=$62;
      var $65=$63;
      var $66=(($64-$65)|0);
      var $67=(($66)|0) < 4;
      if ($67) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $68
      $1=-2;
      __label__ = 29; break;
    case 14: // $69
      var $70=$4;
      var $71=(($70+4)|0);
      $4=$71;
      __label__ = 27; break;
    case 15: // $72
      var $73=$4;
      var $74=$6;
      HEAP32[(($74)>>2)]=$73;
      $1=0;
      __label__ = 29; break;
    case 16: // $75
      var $76=$4;
      var $77=(($76+2)|0);
      $4=$77;
      var $78=$t;
      var $79=$2;
      var $80=(($78)|0)!=(($79)|0);
      if ($80) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $81
      __label__ = 27; break;
    case 18: // $82
      var $83=$4;
      var $84=$5;
      var $85=(($83)|0)==(($84)|0);
      if ($85) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $86
      $1=-27;
      __label__ = 29; break;
    case 20: // $87
      var $88=$4;
      var $89=$6;
      HEAP32[(($89)>>2)]=$88;
      var $90=$4;
      var $91=(($90)|0);
      var $92=HEAP8[($91)];
      var $93=(($92 << 24) >> 24);
      var $94=(($93)|0)==0;
      if ($94) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $95
      var $96=$4;
      var $97=(($96+1)|0);
      var $98=HEAPU8[($97)];
      var $99=(($98)&255);
      var $100=$3;
      var $101=$100;
      var $102=(($101+76)|0);
      var $103=(($102+$99)|0);
      var $104=HEAPU8[($103)];
      var $105=(($104)&255);
      var $115 = $105;__label__ = 23; break;
    case 22: // $106
      var $107=$4;
      var $108=(($107)|0);
      var $109=HEAP8[($108)];
      var $110=$4;
      var $111=(($110+1)|0);
      var $112=HEAP8[($111)];
      var $113=__ZL17unicode_byte_typecc($109, $112);
      var $115 = $113;__label__ = 23; break;
    case 23: // $114
      var $115;
      if ($115 == 21 || $115 == 9 || $115 == 10 || $115 == 11 || $115 == 30 || $115 == 20) {
        __label__ = 24; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 24: // $116
      $1=27;
      __label__ = 29; break;
    case 25: // $117
      $1=0;
      __label__ = 29; break;
    case 26: // $118
      var $119=$4;
      var $120=(($119+2)|0);
      $4=$120;
      __label__ = 27; break;
    case 27: // $121
      __label__ = 1; break;
    case 28: // $122
      $1=-1;
      __label__ = 29; break;
    case 29: // $123
      var $124=$1;
      ;
      return $124;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12big2_scanLitiPK8encodingPKcS3_PS3_["X"]=1;

function __ZL13big2_scanDeclPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 29; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 27) {
        __label__ = 6; break;
      }
      else if ($36 == 20) {
        __label__ = 7; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 6: // $37
      var $38=$2;
      var $39=$3;
      var $40=(($39+2)|0);
      var $41=$4;
      var $42=$5;
      var $43=__ZL16big2_scanCommentPK8encodingPKcS3_PS3_($38, $40, $41, $42);
      $1=$43;
      __label__ = 29; break;
    case 7: // $44
      var $45=$3;
      var $46=(($45+2)|0);
      var $47=$5;
      HEAP32[(($47)>>2)]=$46;
      $1=33;
      __label__ = 29; break;
    case 8: // $48
      var $49=$3;
      var $50=(($49+2)|0);
      $3=$50;
      __label__ = 10; break;
    case 9: // $51
      var $52=$3;
      var $53=$5;
      HEAP32[(($53)>>2)]=$52;
      $1=0;
      __label__ = 29; break;
    case 10: // $54
      __label__ = 11; break;
    case 11: // $55
      var $56=$3;
      var $57=$4;
      var $58=(($56)|0)!=(($57)|0);
      if ($58) { __label__ = 12; break; } else { __label__ = 28; break; }
    case 12: // $59
      var $60=$3;
      var $61=(($60)|0);
      var $62=HEAP8[($61)];
      var $63=(($62 << 24) >> 24);
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $65
      var $66=$3;
      var $67=(($66+1)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=$2;
      var $71=$70;
      var $72=(($71+76)|0);
      var $73=(($72+$69)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $85 = $75;__label__ = 15; break;
    case 14: // $76
      var $77=$3;
      var $78=(($77)|0);
      var $79=HEAP8[($78)];
      var $80=$3;
      var $81=(($80+1)|0);
      var $82=HEAP8[($81)];
      var $83=__ZL17unicode_byte_typecc($79, $82);
      var $85 = $83;__label__ = 15; break;
    case 15: // $84
      var $85;
      if ($85 == 30) {
        __label__ = 16; break;
      }
      else if ($85 == 21 || $85 == 9 || $85 == 10) {
        __label__ = 24; break;
      }
      else if ($85 == 22 || $85 == 24) {
        __label__ = 25; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 16: // $86
      var $87=$3;
      var $88=(($87+2)|0);
      var $89=$4;
      var $90=(($88)|0)==(($89)|0);
      if ($90) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $91
      $1=-1;
      __label__ = 29; break;
    case 18: // $92
      var $93=$3;
      var $94=(($93+2)|0);
      var $95=(($94)|0);
      var $96=HEAP8[($95)];
      var $97=(($96 << 24) >> 24);
      var $98=(($97)|0)==0;
      if ($98) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $99
      var $100=$3;
      var $101=(($100+2)|0);
      var $102=(($101+1)|0);
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$2;
      var $106=$105;
      var $107=(($106+76)|0);
      var $108=(($107+$104)|0);
      var $109=HEAPU8[($108)];
      var $110=(($109)&255);
      var $122 = $110;__label__ = 21; break;
    case 20: // $111
      var $112=$3;
      var $113=(($112+2)|0);
      var $114=(($113)|0);
      var $115=HEAP8[($114)];
      var $116=$3;
      var $117=(($116+2)|0);
      var $118=(($117+1)|0);
      var $119=HEAP8[($118)];
      var $120=__ZL17unicode_byte_typecc($115, $119);
      var $122 = $120;__label__ = 21; break;
    case 21: // $121
      var $122;
      if ($122 == 21 || $122 == 9 || $122 == 10 || $122 == 30) {
        __label__ = 22; break;
      }
      else {
      __label__ = 23; break;
      }
      
    case 22: // $123
      var $124=$3;
      var $125=$5;
      HEAP32[(($125)>>2)]=$124;
      $1=0;
      __label__ = 29; break;
    case 23: // $126
      __label__ = 24; break;
    case 24: // $127
      var $128=$3;
      var $129=$5;
      HEAP32[(($129)>>2)]=$128;
      $1=16;
      __label__ = 29; break;
    case 25: // $130
      var $131=$3;
      var $132=(($131+2)|0);
      $3=$132;
      __label__ = 27; break;
    case 26: // $133
      var $134=$3;
      var $135=$5;
      HEAP32[(($135)>>2)]=$134;
      $1=0;
      __label__ = 29; break;
    case 27: // $136
      __label__ = 11; break;
    case 28: // $137
      $1=-1;
      __label__ = 29; break;
    case 29: // $138
      var $139=$1;
      ;
      return $139;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13big2_scanDeclPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18big2_scanPoundNamePK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 43; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$3;
      var $18=(($17+1)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$2;
      var $22=$21;
      var $23=(($22+76)|0);
      var $24=(($23+$20)|0);
      var $25=HEAPU8[($24)];
      var $26=(($25)&255);
      var $36 = $26;__label__ = 5; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28)|0);
      var $30=HEAP8[($29)];
      var $31=$3;
      var $32=(($31+1)|0);
      var $33=HEAP8[($32)];
      var $34=__ZL17unicode_byte_typecc($30, $33);
      var $36 = $34;__label__ = 5; break;
    case 5: // $35
      var $36;
      if ($36 == 29) {
        __label__ = 6; break;
      }
      else if ($36 == 22 || $36 == 24) {
        __label__ = 9; break;
      }
      else if ($36 == 5) {
        __label__ = 10; break;
      }
      else if ($36 == 6) {
        __label__ = 13; break;
      }
      else if ($36 == 7) {
        __label__ = 16; break;
      }
      else {
      __label__ = 19; break;
      }
      
    case 6: // $37
      var $38=$3;
      var $39=(($38)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=((STRING_TABLE.__ZL11nmstrtPages+$41)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$44 << 3;
      var $46=$3;
      var $47=(($46+1)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 >> 5;
      var $51=(($45+$50)|0);
      var $52=((__ZL12namingBitmap+($51<<2))|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$3;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 31;
      var $59=1 << $58;
      var $60=$53 & $59;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $62
      var $63=$3;
      var $64=$5;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 43; break;
    case 8: // $65
      __label__ = 9; break;
    case 9: // $66
      var $67=$3;
      var $68=(($67+2)|0);
      $3=$68;
      __label__ = 20; break;
    case 10: // $69
      var $70=$4;
      var $71=$3;
      var $72=$70;
      var $73=$71;
      var $74=(($72-$73)|0);
      var $75=(($74)|0) < 2;
      if ($75) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $76
      $1=-2;
      __label__ = 43; break;
    case 12: // $77
      var $78=$3;
      var $79=$5;
      HEAP32[(($79)>>2)]=$78;
      $1=0;
      __label__ = 43; break;
    case 13: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 3;
      if ($86) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $87
      $1=-2;
      __label__ = 43; break;
    case 15: // $88
      var $89=$3;
      var $90=$5;
      HEAP32[(($90)>>2)]=$89;
      $1=0;
      __label__ = 43; break;
    case 16: // $91
      var $92=$4;
      var $93=$3;
      var $94=$92;
      var $95=$93;
      var $96=(($94-$95)|0);
      var $97=(($96)|0) < 4;
      if ($97) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $98
      $1=-2;
      __label__ = 43; break;
    case 18: // $99
      var $100=$3;
      var $101=$5;
      HEAP32[(($101)>>2)]=$100;
      $1=0;
      __label__ = 43; break;
    case 19: // $102
      var $103=$3;
      var $104=$5;
      HEAP32[(($104)>>2)]=$103;
      $1=0;
      __label__ = 43; break;
    case 20: // $105
      __label__ = 21; break;
    case 21: // $106
      var $107=$3;
      var $108=$4;
      var $109=(($107)|0)!=(($108)|0);
      if ($109) { __label__ = 22; break; } else { __label__ = 42; break; }
    case 22: // $110
      var $111=$3;
      var $112=(($111)|0);
      var $113=HEAP8[($112)];
      var $114=(($113 << 24) >> 24);
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $116
      var $117=$3;
      var $118=(($117+1)|0);
      var $119=HEAPU8[($118)];
      var $120=(($119)&255);
      var $121=$2;
      var $122=$121;
      var $123=(($122+76)|0);
      var $124=(($123+$120)|0);
      var $125=HEAPU8[($124)];
      var $126=(($125)&255);
      var $136 = $126;__label__ = 25; break;
    case 24: // $127
      var $128=$3;
      var $129=(($128)|0);
      var $130=HEAP8[($129)];
      var $131=$3;
      var $132=(($131+1)|0);
      var $133=HEAP8[($132)];
      var $134=__ZL17unicode_byte_typecc($130, $133);
      var $136 = $134;__label__ = 25; break;
    case 25: // $135
      var $136;
      if ($136 == 29) {
        __label__ = 26; break;
      }
      else if ($136 == 22 || $136 == 24 || $136 == 25 || $136 == 26 || $136 == 27) {
        __label__ = 29; break;
      }
      else if ($136 == 5) {
        __label__ = 30; break;
      }
      else if ($136 == 6) {
        __label__ = 33; break;
      }
      else if ($136 == 7) {
        __label__ = 36; break;
      }
      else if ($136 == 9 || $136 == 10 || $136 == 21 || $136 == 32 || $136 == 11 || $136 == 30 || $136 == 36) {
        __label__ = 39; break;
      }
      else {
      __label__ = 40; break;
      }
      
    case 26: // $137
      var $138=$3;
      var $139=(($138)|0);
      var $140=HEAPU8[($139)];
      var $141=(($140)&255);
      var $142=((STRING_TABLE.__ZL9namePages+$141)|0);
      var $143=HEAPU8[($142)];
      var $144=(($143)&255);
      var $145=$144 << 3;
      var $146=$3;
      var $147=(($146+1)|0);
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 >> 5;
      var $151=(($145+$150)|0);
      var $152=((__ZL12namingBitmap+($151<<2))|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=$3;
      var $155=(($154+1)|0);
      var $156=HEAPU8[($155)];
      var $157=(($156)&255);
      var $158=$157 & 31;
      var $159=1 << $158;
      var $160=$153 & $159;
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 28; break; } else { __label__ = 27; break; }
    case 27: // $162
      var $163=$3;
      var $164=$5;
      HEAP32[(($164)>>2)]=$163;
      $1=0;
      __label__ = 43; break;
    case 28: // $165
      __label__ = 29; break;
    case 29: // $166
      var $167=$3;
      var $168=(($167+2)|0);
      $3=$168;
      __label__ = 41; break;
    case 30: // $169
      var $170=$4;
      var $171=$3;
      var $172=$170;
      var $173=$171;
      var $174=(($172-$173)|0);
      var $175=(($174)|0) < 2;
      if ($175) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $176
      $1=-2;
      __label__ = 43; break;
    case 32: // $177
      var $178=$3;
      var $179=$5;
      HEAP32[(($179)>>2)]=$178;
      $1=0;
      __label__ = 43; break;
    case 33: // $180
      var $181=$4;
      var $182=$3;
      var $183=$181;
      var $184=$182;
      var $185=(($183-$184)|0);
      var $186=(($185)|0) < 3;
      if ($186) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $187
      $1=-2;
      __label__ = 43; break;
    case 35: // $188
      var $189=$3;
      var $190=$5;
      HEAP32[(($190)>>2)]=$189;
      $1=0;
      __label__ = 43; break;
    case 36: // $191
      var $192=$4;
      var $193=$3;
      var $194=$192;
      var $195=$193;
      var $196=(($194-$195)|0);
      var $197=(($196)|0) < 4;
      if ($197) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $198
      $1=-2;
      __label__ = 43; break;
    case 38: // $199
      var $200=$3;
      var $201=$5;
      HEAP32[(($201)>>2)]=$200;
      $1=0;
      __label__ = 43; break;
    case 39: // $202
      var $203=$3;
      var $204=$5;
      HEAP32[(($204)>>2)]=$203;
      $1=20;
      __label__ = 43; break;
    case 40: // $205
      var $206=$3;
      var $207=$5;
      HEAP32[(($207)>>2)]=$206;
      $1=0;
      __label__ = 43; break;
    case 41: // $208
      __label__ = 21; break;
    case 42: // $209
      $1=-20;
      __label__ = 43; break;
    case 43: // $210
      var $211=$1;
      ;
      return $211;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18big2_scanPoundNamePK8encodingPKcS3_PS3_["X"]=1;

function __ZL7isNeverPK8encodingPKc($enc, $p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$enc;
  $2=$p;
  ;
  return 0;
}


function __ZL11utf8_toUtf8PK8encodingPPKcS3_PPcS3_($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $to;
      var $from;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$3;
      var $7=$2;
      var $8=HEAP32[(($7)>>2)];
      var $9=$6;
      var $10=$8;
      var $11=(($9-$10)|0);
      var $12=$5;
      var $13=$4;
      var $14=HEAP32[(($13)>>2)];
      var $15=$12;
      var $16=$14;
      var $17=(($15-$16)|0);
      var $18=(($11)|0) > (($17)|0);
      if ($18) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $19
      var $20=$2;
      var $21=HEAP32[(($20)>>2)];
      var $22=$5;
      var $23=$4;
      var $24=HEAP32[(($23)>>2)];
      var $25=$22;
      var $26=$24;
      var $27=(($25-$26)|0);
      var $28=(($21+$27)|0);
      $3=$28;
      __label__ = 2; break;
    case 2: // $29
      var $30=$3;
      var $31=$2;
      var $32=HEAPU32[(($31)>>2)];
      var $33=(($30)>>>0) > (($32)>>>0);
      if ($33) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $34
      var $35=$3;
      var $36=(($35-1)|0);
      var $37=HEAPU8[($36)];
      var $38=(($37)&255);
      var $39=$38 & 192;
      var $40=(($39)|0)!=128;
      if ($40) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $41
      __label__ = 7; break;
    case 5: // $42
      __label__ = 6; break;
    case 6: // $43
      var $44=$3;
      var $45=(($44-1)|0);
      $3=$45;
      __label__ = 2; break;
    case 7: // $46
      __label__ = 8; break;
    case 8: // $47
      var $48=$4;
      var $49=HEAP32[(($48)>>2)];
      $to=$49;
      var $50=$2;
      var $51=HEAP32[(($50)>>2)];
      $from=$51;
      __label__ = 9; break;
    case 9: // $52
      var $53=$from;
      var $54=$3;
      var $55=(($53)|0)!=(($54)|0);
      if ($55) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $56
      var $57=$from;
      var $58=HEAP8[($57)];
      var $59=$to;
      HEAP8[($59)]=$58;
      __label__ = 11; break;
    case 11: // $60
      var $61=$from;
      var $62=(($61+1)|0);
      $from=$62;
      var $63=$to;
      var $64=(($63+1)|0);
      $to=$64;
      __label__ = 9; break;
    case 12: // $65
      var $66=$from;
      var $67=$2;
      HEAP32[(($67)>>2)]=$66;
      var $68=$to;
      var $69=$4;
      HEAP32[(($69)>>2)]=$68;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL11utf8_toUtf8PK8encodingPPKcS3_PPcS3_["X"]=1;

function __ZL12utf8_toUtf16PK8encodingPPKcS3_PPtPKt($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $to;
      var $from;
      var $n;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      var $6=$4;
      var $7=HEAP32[(($6)>>2)];
      $to=$7;
      var $8=$2;
      var $9=HEAP32[(($8)>>2)];
      $from=$9;
      __label__ = 1; break;
    case 1: // $10
      var $11=$from;
      var $12=$3;
      var $13=(($11)|0)!=(($12)|0);
      if ($13) { __label__ = 2; break; } else { var $19 = 0;__label__ = 3; break; }
    case 2: // $14
      var $15=$to;
      var $16=$5;
      var $17=(($15)|0)!=(($16)|0);
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      if ($19) { __label__ = 4; break; } else { __label__ = 12; break; }
    case 4: // $20
      var $21=$from;
      var $22=HEAPU8[($21)];
      var $23=(($22)&255);
      var $24=$1;
      var $25=$24;
      var $26=(($25+76)|0);
      var $27=(($26+$23)|0);
      var $28=HEAPU8[($27)];
      var $29=(($28)&255);
      if ($29 == 5) {
        __label__ = 5; break;
      }
      else if ($29 == 6) {
        __label__ = 6; break;
      }
      else if ($29 == 7) {
        __label__ = 7; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 5: // $30
      var $31=$from;
      var $32=(($31)|0);
      var $33=HEAP8[($32)];
      var $34=(($33 << 24) >> 24);
      var $35=$34 & 31;
      var $36=$35 << 6;
      var $37=$from;
      var $38=(($37+1)|0);
      var $39=HEAP8[($38)];
      var $40=(($39 << 24) >> 24);
      var $41=$40 & 63;
      var $42=$36 | $41;
      var $43=(($42) & 65535);
      var $44=$to;
      var $45=(($44+2)|0);
      $to=$45;
      HEAP16[(($44)>>1)]=$43;
      var $46=$from;
      var $47=(($46+2)|0);
      $from=$47;
      __label__ = 11; break;
    case 6: // $48
      var $49=$from;
      var $50=(($49)|0);
      var $51=HEAP8[($50)];
      var $52=(($51 << 24) >> 24);
      var $53=$52 & 15;
      var $54=$53 << 12;
      var $55=$from;
      var $56=(($55+1)|0);
      var $57=HEAP8[($56)];
      var $58=(($57 << 24) >> 24);
      var $59=$58 & 63;
      var $60=$59 << 6;
      var $61=$54 | $60;
      var $62=$from;
      var $63=(($62+2)|0);
      var $64=HEAP8[($63)];
      var $65=(($64 << 24) >> 24);
      var $66=$65 & 63;
      var $67=$61 | $66;
      var $68=(($67) & 65535);
      var $69=$to;
      var $70=(($69+2)|0);
      $to=$70;
      HEAP16[(($69)>>1)]=$68;
      var $71=$from;
      var $72=(($71+3)|0);
      $from=$72;
      __label__ = 11; break;
    case 7: // $73
      var $74=$to;
      var $75=(($74+2)|0);
      var $76=$5;
      var $77=(($75)|0)==(($76)|0);
      if ($77) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $78
      __label__ = 13; break;
    case 9: // $79
      var $80=$from;
      var $81=(($80)|0);
      var $82=HEAP8[($81)];
      var $83=(($82 << 24) >> 24);
      var $84=$83 & 7;
      var $85=$84 << 18;
      var $86=$from;
      var $87=(($86+1)|0);
      var $88=HEAP8[($87)];
      var $89=(($88 << 24) >> 24);
      var $90=$89 & 63;
      var $91=$90 << 12;
      var $92=$85 | $91;
      var $93=$from;
      var $94=(($93+2)|0);
      var $95=HEAP8[($94)];
      var $96=(($95 << 24) >> 24);
      var $97=$96 & 63;
      var $98=$97 << 6;
      var $99=$92 | $98;
      var $100=$from;
      var $101=(($100+3)|0);
      var $102=HEAP8[($101)];
      var $103=(($102 << 24) >> 24);
      var $104=$103 & 63;
      var $105=$99 | $104;
      $n=$105;
      var $106=$n;
      var $107=(($106-65536)|0);
      $n=$107;
      var $108=$n;
      var $109=$108 >>> 10;
      var $110=$109 | 55296;
      var $111=(($110) & 65535);
      var $112=$to;
      var $113=(($112)|0);
      HEAP16[(($113)>>1)]=$111;
      var $114=$n;
      var $115=$114 & 1023;
      var $116=$115 | 56320;
      var $117=(($116) & 65535);
      var $118=$to;
      var $119=(($118+2)|0);
      HEAP16[(($119)>>1)]=$117;
      var $120=$to;
      var $121=(($120+4)|0);
      $to=$121;
      var $122=$from;
      var $123=(($122+4)|0);
      $from=$123;
      __label__ = 11; break;
    case 10: // $124
      var $125=$from;
      var $126=(($125+1)|0);
      $from=$126;
      var $127=HEAP8[($125)];
      var $128=(($127 << 24) >> 24);
      var $129=$to;
      var $130=(($129+2)|0);
      $to=$130;
      HEAP16[(($129)>>1)]=$128;
      __label__ = 11; break;
    case 11: // $131
      __label__ = 1; break;
    case 12: // $132
      __label__ = 13; break;
    case 13: // $133
      var $134=$from;
      var $135=$2;
      HEAP32[(($135)>>2)]=$134;
      var $136=$to;
      var $137=$4;
      HEAP32[(($137)>>2)]=$136;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12utf8_toUtf16PK8encodingPPKcS3_PPtPKt["X"]=1;

function __ZL12utf8_isName2PK8encodingPKc($enc, $p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$enc;
  $2=$p;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 >> 2;
  var $8=$7 & 7;
  var $9=((STRING_TABLE.__ZL9namePages+$8)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 << 3;
  var $13=$2;
  var $14=(($13)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 & 3;
  var $18=$17 << 1;
  var $19=(($12+$18)|0);
  var $20=$2;
  var $21=(($20+1)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$23 >> 5;
  var $25=$24 & 1;
  var $26=(($19+$25)|0);
  var $27=((__ZL12namingBitmap+($26<<2))|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$2;
  var $30=(($29+1)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=$32 & 31;
  var $34=1 << $33;
  var $35=$28 & $34;
  ;
  return $35;
}


function __ZL12utf8_isName3PK8encodingPKc($enc, $p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$enc;
  $2=$p;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 15;
  var $8=$7 << 4;
  var $9=$2;
  var $10=(($9+1)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 >> 2;
  var $14=$13 & 15;
  var $15=(($8+$14)|0);
  var $16=((STRING_TABLE.__ZL9namePages+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$18 << 3;
  var $20=$2;
  var $21=(($20+1)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$23 & 3;
  var $25=$24 << 1;
  var $26=(($19+$25)|0);
  var $27=$2;
  var $28=(($27+2)|0);
  var $29=HEAPU8[($28)];
  var $30=(($29)&255);
  var $31=$30 >> 5;
  var $32=$31 & 1;
  var $33=(($26+$32)|0);
  var $34=((__ZL12namingBitmap+($33<<2))|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$2;
  var $37=(($36+2)|0);
  var $38=HEAPU8[($37)];
  var $39=(($38)&255);
  var $40=$39 & 31;
  var $41=1 << $40;
  var $42=$35 & $41;
  ;
  return $42;
}


function __ZL14utf8_isNmstrt2PK8encodingPKc($enc, $p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$enc;
  $2=$p;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 >> 2;
  var $8=$7 & 7;
  var $9=((STRING_TABLE.__ZL11nmstrtPages+$8)|0);
  var $10=HEAPU8[($9)];
  var $11=(($10)&255);
  var $12=$11 << 3;
  var $13=$2;
  var $14=(($13)|0);
  var $15=HEAPU8[($14)];
  var $16=(($15)&255);
  var $17=$16 & 3;
  var $18=$17 << 1;
  var $19=(($12+$18)|0);
  var $20=$2;
  var $21=(($20+1)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$23 >> 5;
  var $25=$24 & 1;
  var $26=(($19+$25)|0);
  var $27=((__ZL12namingBitmap+($26<<2))|0);
  var $28=HEAP32[(($27)>>2)];
  var $29=$2;
  var $30=(($29+1)|0);
  var $31=HEAPU8[($30)];
  var $32=(($31)&255);
  var $33=$32 & 31;
  var $34=1 << $33;
  var $35=$28 & $34;
  ;
  return $35;
}


function __ZL14utf8_isNmstrt3PK8encodingPKc($enc, $p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$enc;
  $2=$p;
  var $3=$2;
  var $4=(($3)|0);
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$6 & 15;
  var $8=$7 << 4;
  var $9=$2;
  var $10=(($9+1)|0);
  var $11=HEAPU8[($10)];
  var $12=(($11)&255);
  var $13=$12 >> 2;
  var $14=$13 & 15;
  var $15=(($8+$14)|0);
  var $16=((STRING_TABLE.__ZL11nmstrtPages+$15)|0);
  var $17=HEAPU8[($16)];
  var $18=(($17)&255);
  var $19=$18 << 3;
  var $20=$2;
  var $21=(($20+1)|0);
  var $22=HEAPU8[($21)];
  var $23=(($22)&255);
  var $24=$23 & 3;
  var $25=$24 << 1;
  var $26=(($19+$25)|0);
  var $27=$2;
  var $28=(($27+2)|0);
  var $29=HEAPU8[($28)];
  var $30=(($29)&255);
  var $31=$30 >> 5;
  var $32=$31 & 1;
  var $33=(($26+$32)|0);
  var $34=((__ZL12namingBitmap+($33<<2))|0);
  var $35=HEAP32[(($34)>>2)];
  var $36=$2;
  var $37=(($36+2)|0);
  var $38=HEAPU8[($37)];
  var $39=(($38)&255);
  var $40=$39 & 31;
  var $41=1 << $40;
  var $42=$35 & $41;
  ;
  return $42;
}


function __ZL15utf8_isInvalid2PK8encodingPKc($enc, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$enc;
      $2=$p;
      var $3=$2;
      var $4=HEAPU8[($3)];
      var $5=(($4)&255);
      var $6=(($5)|0) < 194;
      if ($6) { var $22 = 1;__label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8+1)|0);
      var $10=HEAPU8[($9)];
      var $11=(($10)&255);
      var $12=$11 & 128;
      var $13=(($12)|0)==0;
      if ($13) { var $22 = 1;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=$2;
      var $16=(($15+1)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=$18 & 192;
      var $20=(($19)|0)==192;
      var $22 = $20;__label__ = 3; break;
    case 3: // $21
      var $22;
      var $23=(($22)&1);
      ;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL15utf8_isInvalid3PK8encodingPKc($enc, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$enc;
      $2=$p;
      var $3=$2;
      var $4=(($3+2)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$6 & 128;
      var $8=(($7)|0)==0;
      if ($8) { var $85 = 1;__label__ = 16; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=(($12)|0)==239;
      if ($13) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $14
      var $15=$2;
      var $16=(($15+1)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      var $19=(($18)|0)==191;
      if ($19) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $20
      var $21=$2;
      var $22=(($21+2)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=(($24)|0) > 189;
      if ($25) { var $85 = 1;__label__ = 16; break; } else { __label__ = 5; break; }
    case 4: // $26
      var $27=$2;
      var $28=(($27+2)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=$30 & 192;
      var $32=(($31)|0)==192;
      if ($32) { var $85 = 1;__label__ = 16; break; } else { __label__ = 5; break; }
    case 5: // $33
      var $34=$2;
      var $35=HEAPU8[($34)];
      var $36=(($35)&255);
      var $37=(($36)|0)==224;
      if ($37) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $38
      var $39=$2;
      var $40=(($39+1)|0);
      var $41=HEAPU8[($40)];
      var $42=(($41)&255);
      var $43=(($42)|0) < 160;
      if ($43) { var $52 = 1;__label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $44
      var $45=$2;
      var $46=(($45+1)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$48 & 192;
      var $50=(($49)|0)==192;
      var $52 = $50;__label__ = 8; break;
    case 8: // $51
      var $52;
      var $83 = $52;__label__ = 15; break;
    case 9: // $53
      var $54=$2;
      var $55=(($54+1)|0);
      var $56=HEAPU8[($55)];
      var $57=(($56)&255);
      var $58=$57 & 128;
      var $59=(($58)|0)==0;
      if ($59) { var $81 = 1;__label__ = 14; break; } else { __label__ = 10; break; }
    case 10: // $60
      var $61=$2;
      var $62=HEAPU8[($61)];
      var $63=(($62)&255);
      var $64=(($63)|0)==237;
      if ($64) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $65
      var $66=$2;
      var $67=(($66+1)|0);
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=(($69)|0) > 159;
      var $79 = $70;__label__ = 13; break;
    case 12: // $71
      var $72=$2;
      var $73=(($72+1)|0);
      var $74=HEAPU8[($73)];
      var $75=(($74)&255);
      var $76=$75 & 192;
      var $77=(($76)|0)==192;
      var $79 = $77;__label__ = 13; break;
    case 13: // $78
      var $79;
      var $81 = $79;__label__ = 14; break;
    case 14: // $80
      var $81;
      var $83 = $81;__label__ = 15; break;
    case 15: // $82
      var $83;
      var $85 = $83;__label__ = 16; break;
    case 16: // $84
      var $85;
      var $86=(($85)&1);
      ;
      return $86;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15utf8_isInvalid3PK8encodingPKc["X"]=1;

function __ZL15utf8_isInvalid4PK8encodingPKc($enc, $p) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$enc;
      $2=$p;
      var $3=$2;
      var $4=(($3+3)|0);
      var $5=HEAPU8[($4)];
      var $6=(($5)&255);
      var $7=$6 & 128;
      var $8=(($7)|0)==0;
      if ($8) { var $82 = 1;__label__ = 15; break; } else { __label__ = 1; break; }
    case 1: // $9
      var $10=$2;
      var $11=(($10+3)|0);
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$13 & 192;
      var $15=(($14)|0)==192;
      if ($15) { var $82 = 1;__label__ = 15; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$2;
      var $18=(($17+2)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      var $21=$20 & 128;
      var $22=(($21)|0)==0;
      if ($22) { var $82 = 1;__label__ = 15; break; } else { __label__ = 3; break; }
    case 3: // $23
      var $24=$2;
      var $25=(($24+2)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$27 & 192;
      var $29=(($28)|0)==192;
      if ($29) { var $82 = 1;__label__ = 15; break; } else { __label__ = 4; break; }
    case 4: // $30
      var $31=$2;
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=(($33)|0)==240;
      if ($34) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $35
      var $36=$2;
      var $37=(($36+1)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      var $40=(($39)|0) < 144;
      if ($40) { var $49 = 1;__label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $41
      var $42=$2;
      var $43=(($42+1)|0);
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$45 & 192;
      var $47=(($46)|0)==192;
      var $49 = $47;__label__ = 7; break;
    case 7: // $48
      var $49;
      var $80 = $49;__label__ = 14; break;
    case 8: // $50
      var $51=$2;
      var $52=(($51+1)|0);
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=$54 & 128;
      var $56=(($55)|0)==0;
      if ($56) { var $78 = 1;__label__ = 13; break; } else { __label__ = 9; break; }
    case 9: // $57
      var $58=$2;
      var $59=HEAPU8[($58)];
      var $60=(($59)&255);
      var $61=(($60)|0)==244;
      if ($61) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $62
      var $63=$2;
      var $64=(($63+1)|0);
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=(($66)|0) > 143;
      var $76 = $67;__label__ = 12; break;
    case 11: // $68
      var $69=$2;
      var $70=(($69+1)|0);
      var $71=HEAPU8[($70)];
      var $72=(($71)&255);
      var $73=$72 & 192;
      var $74=(($73)|0)==192;
      var $76 = $74;__label__ = 12; break;
    case 12: // $75
      var $76;
      var $78 = $76;__label__ = 13; break;
    case 13: // $77
      var $78;
      var $80 = $78;__label__ = 14; break;
    case 14: // $79
      var $80;
      var $82 = $80;__label__ = 15; break;
    case 15: // $81
      var $82;
      var $83=(($82)&1);
      ;
      return $83;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15utf8_isInvalid4PK8encodingPKc["X"]=1;

function __ZL13latin1_toUtf8PK8encodingPPKcS3_PPcS3_($enc, $fromP, $fromLim, $toP, $toLim) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $c;
      $1=$enc;
      $2=$fromP;
      $3=$fromLim;
      $4=$toP;
      $5=$toLim;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=HEAP32[(($7)>>2)];
      var $9=$3;
      var $10=(($8)|0)==(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      __label__ = 11; break;
    case 3: // $12
      var $13=$2;
      var $14=HEAP32[(($13)>>2)];
      var $15=HEAP8[($14)];
      $c=$15;
      var $16=$c;
      var $17=(($16)&255);
      var $18=$17 & 128;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $20
      var $21=$5;
      var $22=$4;
      var $23=HEAP32[(($22)>>2)];
      var $24=$21;
      var $25=$23;
      var $26=(($24-$25)|0);
      var $27=(($26)|0) < 2;
      if ($27) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $28
      __label__ = 11; break;
    case 6: // $29
      var $30=$c;
      var $31=(($30)&255);
      var $32=$31 >> 6;
      var $33=$32 | 192;
      var $34=(($33) & 255);
      var $35=$4;
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+1)|0);
      HEAP32[(($35)>>2)]=$37;
      HEAP8[($36)]=$34;
      var $38=$c;
      var $39=(($38)&255);
      var $40=$39 & 63;
      var $41=$40 | 128;
      var $42=(($41) & 255);
      var $43=$4;
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+1)|0);
      HEAP32[(($43)>>2)]=$45;
      HEAP8[($44)]=$42;
      var $46=$2;
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      __label__ = 10; break;
    case 7: // $49
      var $50=$4;
      var $51=HEAP32[(($50)>>2)];
      var $52=$5;
      var $53=(($51)|0)==(($52)|0);
      if ($53) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $54
      __label__ = 11; break;
    case 9: // $55
      var $56=$2;
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+1)|0);
      HEAP32[(($56)>>2)]=$58;
      var $59=HEAP8[($57)];
      var $60=$4;
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+1)|0);
      HEAP32[(($60)>>2)]=$62;
      HEAP8[($61)]=$59;
      __label__ = 10; break;
    case 10: // $63
      __label__ = 1; break;
    case 11: // $64
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13latin1_toUtf8PK8encodingPPKcS3_PPcS3_["X"]=1;

function __ZL7isSpacei($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$c;
      var $3=$2;
      if ($3 == 32 || $3 == 13 || $3 == 10 || $3 == 9) {
        __label__ = 1; break;
      }
      else {
      __label__ = 2; break;
      }
      
    case 1: // $4
      $1=1;
      __label__ = 3; break;
    case 2: // $5
      $1=0;
      __label__ = 3; break;
    case 3: // $6
      var $7=$1;
      ;
      return $7;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_($encodingTable, $enc, $state, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $encPtr;
      var $e;
      $2=$encodingTable;
      $3=$enc;
      $4=$state;
      $5=$ptr;
      $6=$end;
      $7=$nextTokPtr;
      var $8=$5;
      var $9=$6;
      var $10=(($8)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=-4;
      __label__ = 51; break;
    case 2: // $12
      var $13=$3;
      var $14=(($13+76)|0);
      var $15=HEAP32[(($14)>>2)];
      $encPtr=$15;
      var $16=$5;
      var $17=(($16+1)|0);
      var $18=$6;
      var $19=(($17)|0)==(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $20
      var $21=$3;
      var $22=(($21)|0);
      var $23=(($22+73)|0);
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24);
      if ($25 == 3 || $25 == 5 || $25 == 4) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 4: // $26
      $1=-1;
      __label__ = 51; break;
    case 5: // $27
      var $28=$5;
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      if ($30 == 254 || $30 == 255 || $30 == 239) {
        __label__ = 6; break;
      }
      else if ($30 == 0 || $30 == 60) {
        __label__ = 10; break;
      }
      else {
      __label__ = 11; break;
      }
      
    case 6: // $31
      var $32=$3;
      var $33=(($32)|0);
      var $34=(($33+73)|0);
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24);
      var $37=(($36)|0)==0;
      if ($37) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $38
      var $39=$4;
      var $40=(($39)|0)==1;
      if ($40) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $41
      __label__ = 11; break;
    case 9: // $42
      __label__ = 10; break;
    case 10: // $43
      $1=-1;
      __label__ = 51; break;
    case 11: // $44
      __label__ = 50; break;
    case 12: // $45
      var $46=$5;
      var $47=(($46)|0);
      var $48=HEAPU8[($47)];
      var $49=(($48)&255);
      var $50=$49 << 8;
      var $51=$5;
      var $52=(($51+1)|0);
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=$50 | $54;
      if ($55 == 65279) {
        __label__ = 13; break;
      }
      else if ($55 == 15360) {
        __label__ = 17; break;
      }
      else if ($55 == 65534) {
        __label__ = 22; break;
      }
      else if ($55 == 61371) {
        __label__ = 26; break;
      }
      else {
      __label__ = 38; break;
      }
      
    case 13: // $56
      var $57=$3;
      var $58=(($57)|0);
      var $59=(($58+73)|0);
      var $60=HEAP8[($59)];
      var $61=(($60 << 24) >> 24);
      var $62=(($61)|0)==0;
      if ($62) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $63
      var $64=$4;
      var $65=(($64)|0)==1;
      if ($65) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $66
      __label__ = 49; break;
    case 16: // $67
      var $68=$5;
      var $69=(($68+2)|0);
      var $70=$7;
      HEAP32[(($70)>>2)]=$69;
      var $71=$2;
      var $72=(($71+16)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$encPtr;
      HEAP32[(($74)>>2)]=$73;
      $1=14;
      __label__ = 51; break;
    case 17: // $75
      var $76=$3;
      var $77=(($76)|0);
      var $78=(($77+73)|0);
      var $79=HEAP8[($78)];
      var $80=(($79 << 24) >> 24);
      var $81=(($80)|0)==4;
      if ($81) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $82
      var $83=$3;
      var $84=(($83)|0);
      var $85=(($84+73)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($87)|0)==3;
      if ($88) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $89
      var $90=$4;
      var $91=(($90)|0)==1;
      if ($91) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $92
      __label__ = 49; break;
    case 21: // $93
      var $94=$2;
      var $95=(($94+20)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$encPtr;
      HEAP32[(($97)>>2)]=$96;
      var $98=$4;
      var $99=$encPtr;
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100)|0);
      var $102=$101;
      var $103=(($102+($98<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$encPtr;
      var $106=HEAP32[(($105)>>2)];
      var $107=$5;
      var $108=$6;
      var $109=$7;
      var $110=FUNCTION_TABLE[$104]($106, $107, $108, $109);
      $1=$110;
      __label__ = 51; break;
    case 22: // $111
      var $112=$3;
      var $113=(($112)|0);
      var $114=(($113+73)|0);
      var $115=HEAP8[($114)];
      var $116=(($115 << 24) >> 24);
      var $117=(($116)|0)==0;
      if ($117) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $118
      var $119=$4;
      var $120=(($119)|0)==1;
      if ($120) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $121
      __label__ = 49; break;
    case 25: // $122
      var $123=$5;
      var $124=(($123+2)|0);
      var $125=$7;
      HEAP32[(($125)>>2)]=$124;
      var $126=$2;
      var $127=(($126+20)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=$encPtr;
      HEAP32[(($129)>>2)]=$128;
      $1=14;
      __label__ = 51; break;
    case 26: // $130
      var $131=$4;
      var $132=(($131)|0)==1;
      if ($132) { __label__ = 27; break; } else { __label__ = 33; break; }
    case 27: // $133
      var $134=$3;
      var $135=(($134)|0);
      var $136=(($135+73)|0);
      var $137=HEAP8[($136)];
      var $138=(($137 << 24) >> 24);
      $e=$138;
      var $139=$e;
      var $140=(($139)|0)==0;
      if ($140) { __label__ = 31; break; } else { __label__ = 28; break; }
    case 28: // $141
      var $142=$e;
      var $143=(($142)|0)==4;
      if ($143) { __label__ = 31; break; } else { __label__ = 29; break; }
    case 29: // $144
      var $145=$e;
      var $146=(($145)|0)==5;
      if ($146) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $147
      var $148=$e;
      var $149=(($148)|0)==3;
      if ($149) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $150
      __label__ = 49; break;
    case 32: // $151
      __label__ = 33; break;
    case 33: // $152
      var $153=$5;
      var $154=(($153+2)|0);
      var $155=$6;
      var $156=(($154)|0)==(($155)|0);
      if ($156) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $157
      $1=-1;
      __label__ = 51; break;
    case 35: // $158
      var $159=$5;
      var $160=(($159+2)|0);
      var $161=HEAPU8[($160)];
      var $162=(($161)&255);
      var $163=(($162)|0)==191;
      if ($163) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $164
      var $165=$5;
      var $166=(($165+3)|0);
      var $167=$7;
      HEAP32[(($167)>>2)]=$166;
      var $168=$2;
      var $169=(($168+8)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$encPtr;
      HEAP32[(($171)>>2)]=$170;
      $1=14;
      __label__ = 51; break;
    case 37: // $172
      __label__ = 49; break;
    case 38: // $173
      var $174=$5;
      var $175=(($174)|0);
      var $176=HEAP8[($175)];
      var $177=(($176 << 24) >> 24);
      var $178=(($177)|0)==0;
      if ($178) { __label__ = 39; break; } else { __label__ = 43; break; }
    case 39: // $179
      var $180=$4;
      var $181=(($180)|0)==1;
      if ($181) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $182
      var $183=$3;
      var $184=(($183)|0);
      var $185=(($184+73)|0);
      var $186=HEAP8[($185)];
      var $187=(($186 << 24) >> 24);
      var $188=(($187)|0)==5;
      if ($188) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $189
      __label__ = 49; break;
    case 42: // $190
      var $191=$2;
      var $192=(($191+16)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$encPtr;
      HEAP32[(($194)>>2)]=$193;
      var $195=$4;
      var $196=$encPtr;
      var $197=HEAP32[(($196)>>2)];
      var $198=(($197)|0);
      var $199=$198;
      var $200=(($199+($195<<2))|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=$encPtr;
      var $203=HEAP32[(($202)>>2)];
      var $204=$5;
      var $205=$6;
      var $206=$7;
      var $207=FUNCTION_TABLE[$201]($203, $204, $205, $206);
      $1=$207;
      __label__ = 51; break;
    case 43: // $208
      var $209=$5;
      var $210=(($209+1)|0);
      var $211=HEAP8[($210)];
      var $212=(($211 << 24) >> 24);
      var $213=(($212)|0)==0;
      if ($213) { __label__ = 44; break; } else { __label__ = 47; break; }
    case 44: // $214
      var $215=$4;
      var $216=(($215)|0)==1;
      if ($216) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $217
      __label__ = 49; break;
    case 46: // $218
      var $219=$2;
      var $220=(($219+20)|0);
      var $221=HEAP32[(($220)>>2)];
      var $222=$encPtr;
      HEAP32[(($222)>>2)]=$221;
      var $223=$4;
      var $224=$encPtr;
      var $225=HEAP32[(($224)>>2)];
      var $226=(($225)|0);
      var $227=$226;
      var $228=(($227+($223<<2))|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=$encPtr;
      var $231=HEAP32[(($230)>>2)];
      var $232=$5;
      var $233=$6;
      var $234=$7;
      var $235=FUNCTION_TABLE[$229]($231, $232, $233, $234);
      $1=$235;
      __label__ = 51; break;
    case 47: // $236
      __label__ = 48; break;
    case 48: // $237
      __label__ = 49; break;
    case 49: // $238
      __label__ = 50; break;
    case 50: // $239
      var $240=$3;
      var $241=(($240)|0);
      var $242=(($241+73)|0);
      var $243=HEAP8[($242)];
      var $244=(($243 << 24) >> 24);
      var $245=$2;
      var $246=(($245+($244<<2))|0);
      var $247=HEAP32[(($246)>>2)];
      var $248=$encPtr;
      HEAP32[(($248)>>2)]=$247;
      var $249=$4;
      var $250=$encPtr;
      var $251=HEAP32[(($250)>>2)];
      var $252=(($251)|0);
      var $253=$252;
      var $254=(($253+($249<<2))|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$encPtr;
      var $257=HEAP32[(($256)>>2)];
      var $258=$5;
      var $259=$6;
      var $260=$7;
      var $261=FUNCTION_TABLE[$255]($257, $258, $259, $260);
      $1=$261;
      __label__ = 51; break;
    case 51: // $262
      var $263=$1;
      ;
      return $263;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_["X"]=1;

function __ZL20parsePseudoAttributePK8encodingPKcS3_PS3_S4_S4_S4_($enc, $ptr, $end, $namePtr, $nameEndPtr, $valPtr, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $c;
      var $open;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$namePtr;
      $6=$nameEndPtr;
      $7=$valPtr;
      $8=$nextTokPtr;
      var $9=$3;
      var $10=$4;
      var $11=(($9)|0)==(($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$5;
      HEAP32[(($13)>>2)]=0;
      $1=1;
      __label__ = 46; break;
    case 2: // $14
      var $15=$2;
      var $16=$3;
      var $17=$4;
      var $18=__ZL7toAsciiPK8encodingPKcS3_($15, $16, $17);
      var $19=__ZL7isSpacei($18);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $21
      var $22=$3;
      var $23=$8;
      HEAP32[(($23)>>2)]=$22;
      $1=0;
      __label__ = 46; break;
    case 4: // $24
      __label__ = 5; break;
    case 5: // $25
      var $26=$2;
      var $27=(($26+68)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$3;
      var $30=(($29+$28)|0);
      $3=$30;
      __label__ = 6; break;
    case 6: // $31
      var $32=$2;
      var $33=$3;
      var $34=$4;
      var $35=__ZL7toAsciiPK8encodingPKcS3_($32, $33, $34);
      var $36=__ZL7isSpacei($35);
      var $37=(($36)|0)!=0;
      if ($37) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 7: // $38
      var $39=$3;
      var $40=$4;
      var $41=(($39)|0)==(($40)|0);
      if ($41) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $42
      var $43=$5;
      HEAP32[(($43)>>2)]=0;
      $1=1;
      __label__ = 46; break;
    case 9: // $44
      var $45=$3;
      var $46=$5;
      HEAP32[(($46)>>2)]=$45;
      __label__ = 10; break;
    case 10: // $47
      var $48=$2;
      var $49=$3;
      var $50=$4;
      var $51=__ZL7toAsciiPK8encodingPKcS3_($48, $49, $50);
      $c=$51;
      var $52=$c;
      var $53=(($52)|0)==-1;
      if ($53) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $54
      var $55=$3;
      var $56=$8;
      HEAP32[(($56)>>2)]=$55;
      $1=0;
      __label__ = 46; break;
    case 12: // $57
      var $58=$c;
      var $59=(($58)|0)==61;
      if ($59) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $60
      var $61=$3;
      var $62=$6;
      HEAP32[(($62)>>2)]=$61;
      __label__ = 22; break;
    case 14: // $63
      var $64=$c;
      var $65=__ZL7isSpacei($64);
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $67
      var $68=$3;
      var $69=$6;
      HEAP32[(($69)>>2)]=$68;
      __label__ = 16; break;
    case 16: // $70
      var $71=$2;
      var $72=(($71+68)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$3;
      var $75=(($74+$73)|0);
      $3=$75;
      __label__ = 17; break;
    case 17: // $76
      var $77=$2;
      var $78=$3;
      var $79=$4;
      var $80=__ZL7toAsciiPK8encodingPKcS3_($77, $78, $79);
      $c=$80;
      var $81=__ZL7isSpacei($80);
      var $82=(($81)|0)!=0;
      if ($82) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 18: // $83
      var $84=$c;
      var $85=(($84)|0)!=61;
      if ($85) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $86
      var $87=$3;
      var $88=$8;
      HEAP32[(($88)>>2)]=$87;
      $1=0;
      __label__ = 46; break;
    case 20: // $89
      __label__ = 22; break;
    case 21: // $90
      var $91=$2;
      var $92=(($91+68)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$3;
      var $95=(($94+$93)|0);
      $3=$95;
      __label__ = 10; break;
    case 22: // $96
      var $97=$3;
      var $98=$5;
      var $99=HEAP32[(($98)>>2)];
      var $100=(($97)|0)==(($99)|0);
      if ($100) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $101
      var $102=$3;
      var $103=$8;
      HEAP32[(($103)>>2)]=$102;
      $1=0;
      __label__ = 46; break;
    case 24: // $104
      var $105=$2;
      var $106=(($105+68)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$3;
      var $109=(($108+$107)|0);
      $3=$109;
      var $110=$2;
      var $111=$3;
      var $112=$4;
      var $113=__ZL7toAsciiPK8encodingPKcS3_($110, $111, $112);
      $c=$113;
      __label__ = 25; break;
    case 25: // $114
      var $115=$c;
      var $116=__ZL7isSpacei($115);
      var $117=(($116)|0)!=0;
      if ($117) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $118
      var $119=$2;
      var $120=(($119+68)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=$3;
      var $123=(($122+$121)|0);
      $3=$123;
      var $124=$2;
      var $125=$3;
      var $126=$4;
      var $127=__ZL7toAsciiPK8encodingPKcS3_($124, $125, $126);
      $c=$127;
      __label__ = 25; break;
    case 27: // $128
      var $129=$c;
      var $130=(($129)|0)!=34;
      if ($130) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $131
      var $132=$c;
      var $133=(($132)|0)!=39;
      if ($133) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $134
      var $135=$3;
      var $136=$8;
      HEAP32[(($136)>>2)]=$135;
      $1=0;
      __label__ = 46; break;
    case 30: // $137
      var $138=$c;
      var $139=(($138) & 255);
      $open=$139;
      var $140=$2;
      var $141=(($140+68)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$3;
      var $144=(($143+$142)|0);
      $3=$144;
      var $145=$3;
      var $146=$7;
      HEAP32[(($146)>>2)]=$145;
      __label__ = 31; break;
    case 31: // $147
      var $148=$2;
      var $149=$3;
      var $150=$4;
      var $151=__ZL7toAsciiPK8encodingPKcS3_($148, $149, $150);
      $c=$151;
      var $152=$c;
      var $153=$open;
      var $154=(($153 << 24) >> 24);
      var $155=(($152)|0)==(($154)|0);
      if ($155) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $156
      __label__ = 45; break;
    case 33: // $157
      var $158=$c;
      var $159=97 <= (($158)|0);
      if ($159) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $160
      var $161=$c;
      var $162=(($161)|0) <= 122;
      if ($162) { __label__ = 43; break; } else { __label__ = 35; break; }
    case 35: // $163
      var $164=$c;
      var $165=65 <= (($164)|0);
      if ($165) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $166
      var $167=$c;
      var $168=(($167)|0) <= 90;
      if ($168) { __label__ = 43; break; } else { __label__ = 37; break; }
    case 37: // $169
      var $170=$c;
      var $171=48 <= (($170)|0);
      if ($171) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $172
      var $173=$c;
      var $174=(($173)|0) <= 57;
      if ($174) { __label__ = 43; break; } else { __label__ = 39; break; }
    case 39: // $175
      var $176=$c;
      var $177=(($176)|0)!=46;
      if ($177) { __label__ = 40; break; } else { __label__ = 43; break; }
    case 40: // $178
      var $179=$c;
      var $180=(($179)|0)!=45;
      if ($180) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 41: // $181
      var $182=$c;
      var $183=(($182)|0)!=95;
      if ($183) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $184
      var $185=$3;
      var $186=$8;
      HEAP32[(($186)>>2)]=$185;
      $1=0;
      __label__ = 46; break;
    case 43: // $187
      __label__ = 44; break;
    case 44: // $188
      var $189=$2;
      var $190=(($189+68)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=$3;
      var $193=(($192+$191)|0);
      $3=$193;
      __label__ = 31; break;
    case 45: // $194
      var $195=$3;
      var $196=$2;
      var $197=(($196+68)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($195+$198)|0);
      var $200=$8;
      HEAP32[(($200)>>2)]=$199;
      $1=1;
      __label__ = 46; break;
    case 46: // $201
      var $202=$1;
      ;
      return $202;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20parsePseudoAttributePK8encodingPKcS3_PS3_S4_S4_S4_["X"]=1;

function __ZL7toAsciiPK8encodingPKcS3_($enc, $ptr, $end) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $buf=__stackBase__+4;
      var $p=__stackBase__+8;
      $2=$enc;
      HEAP32[(($3)>>2)]=$ptr;
      $4=$end;
      var $5=(($buf)|0);
      HEAP32[(($p)>>2)]=$5;
      var $6=$2;
      var $7=(($6+60)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$2;
      var $10=$4;
      var $11=HEAP32[(($p)>>2)];
      var $12=(($11+1)|0);
      FUNCTION_TABLE[$8]($9, $3, $10, $p, $12);
      var $13=HEAP32[(($p)>>2)];
      var $14=(($buf)|0);
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $16
      $1=-1;
      __label__ = 3; break;
    case 2: // $17
      var $18=(($buf)|0);
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      $1=$20;
      __label__ = 3; break;
    case 3: // $21
      var $22=$1;
      STACKTOP = __stackBase__;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21normal_scanHexCharRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $9
      var $10=$3;
      var $11=HEAPU8[($10)];
      var $12=(($11)&255);
      var $13=$2;
      var $14=$13;
      var $15=(($14+76)|0);
      var $16=(($15+$12)|0);
      var $17=HEAPU8[($16)];
      var $18=(($17)&255);
      if ($18 == 25 || $18 == 24) {
        __label__ = 2; break;
      }
      else {
      __label__ = 3; break;
      }
      
    case 2: // $19
      __label__ = 4; break;
    case 3: // $20
      var $21=$3;
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 14; break;
    case 4: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      $3=$25;
      __label__ = 5; break;
    case 5: // $26
      var $27=$3;
      var $28=$4;
      var $29=(($27)|0)!=(($28)|0);
      if ($29) { __label__ = 6; break; } else { __label__ = 12; break; }
    case 6: // $30
      var $31=$3;
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      var $34=$2;
      var $35=$34;
      var $36=(($35+76)|0);
      var $37=(($36+$33)|0);
      var $38=HEAPU8[($37)];
      var $39=(($38)&255);
      if ($39 == 25 || $39 == 24) {
        __label__ = 7; break;
      }
      else if ($39 == 18) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 7: // $40
      __label__ = 10; break;
    case 8: // $41
      var $42=$3;
      var $43=(($42+1)|0);
      var $44=$5;
      HEAP32[(($44)>>2)]=$43;
      $1=10;
      __label__ = 14; break;
    case 9: // $45
      var $46=$3;
      var $47=$5;
      HEAP32[(($47)>>2)]=$46;
      $1=0;
      __label__ = 14; break;
    case 10: // $48
      __label__ = 11; break;
    case 11: // $49
      var $50=$3;
      var $51=(($50+1)|0);
      $3=$51;
      __label__ = 5; break;
    case 12: // $52
      __label__ = 13; break;
    case 13: // $53
      $1=-1;
      __label__ = 14; break;
    case 14: // $54
      var $55=$1;
      ;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL21normal_scanHexCharRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL14normal_scanRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 46; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 29) {
        __label__ = 3; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 4; break;
      }
      else if ($19 == 5) {
        __label__ = 5; break;
      }
      else if ($19 == 6) {
        __label__ = 10; break;
      }
      else if ($19 == 7) {
        __label__ = 15; break;
      }
      else if ($19 == 19) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 3: // $20
      var $21=$3;
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 46; break;
    case 4: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      $3=$25;
      __label__ = 22; break;
    case 5: // $26
      var $27=$4;
      var $28=$3;
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0) < 2;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=-2;
      __label__ = 46; break;
    case 7: // $34
      var $35=$2;
      var $36=$35;
      var $37=(($36+344)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=$3;
      var $41=FUNCTION_TABLE[$38]($39, $40);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$3;
      var $45=$5;
      HEAP32[(($45)>>2)]=$44;
      $1=0;
      __label__ = 46; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+2)|0);
      $3=$48;
      __label__ = 22; break;
    case 10: // $49
      var $50=$4;
      var $51=$3;
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      $1=-2;
      __label__ = 46; break;
    case 12: // $57
      var $58=$2;
      var $59=$58;
      var $60=(($59+348)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=$3;
      var $64=FUNCTION_TABLE[$61]($62, $63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=$3;
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 46; break;
    case 14: // $69
      var $70=$3;
      var $71=(($70+3)|0);
      $3=$71;
      __label__ = 22; break;
    case 15: // $72
      var $73=$4;
      var $74=$3;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 4;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $1=-2;
      __label__ = 46; break;
    case 17: // $80
      var $81=$2;
      var $82=$81;
      var $83=(($82+352)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=$3;
      var $87=FUNCTION_TABLE[$84]($85, $86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 46; break;
    case 19: // $92
      var $93=$3;
      var $94=(($93+4)|0);
      $3=$94;
      __label__ = 22; break;
    case 20: // $95
      var $96=$2;
      var $97=$3;
      var $98=(($97+1)|0);
      var $99=$4;
      var $100=$5;
      var $101=__ZL18normal_scanCharRefPK8encodingPKcS3_PS3_($96, $98, $99, $100);
      $1=$101;
      __label__ = 46; break;
    case 21: // $102
      var $103=$3;
      var $104=$5;
      HEAP32[(($104)>>2)]=$103;
      $1=0;
      __label__ = 46; break;
    case 22: // $105
      __label__ = 23; break;
    case 23: // $106
      var $107=$3;
      var $108=$4;
      var $109=(($107)|0)!=(($108)|0);
      if ($109) { __label__ = 24; break; } else { __label__ = 45; break; }
    case 24: // $110
      var $111=$3;
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=$2;
      var $115=$114;
      var $116=(($115+76)|0);
      var $117=(($116+$113)|0);
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      if ($119 == 29) {
        __label__ = 25; break;
      }
      else if ($119 == 22 || $119 == 24 || $119 == 25 || $119 == 26 || $119 == 27) {
        __label__ = 26; break;
      }
      else if ($119 == 5) {
        __label__ = 27; break;
      }
      else if ($119 == 6) {
        __label__ = 32; break;
      }
      else if ($119 == 7) {
        __label__ = 37; break;
      }
      else if ($119 == 18) {
        __label__ = 42; break;
      }
      else {
      __label__ = 43; break;
      }
      
    case 25: // $120
      var $121=$3;
      var $122=$5;
      HEAP32[(($122)>>2)]=$121;
      $1=0;
      __label__ = 46; break;
    case 26: // $123
      var $124=$3;
      var $125=(($124+1)|0);
      $3=$125;
      __label__ = 44; break;
    case 27: // $126
      var $127=$4;
      var $128=$3;
      var $129=$127;
      var $130=$128;
      var $131=(($129-$130)|0);
      var $132=(($131)|0) < 2;
      if ($132) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $133
      $1=-2;
      __label__ = 46; break;
    case 29: // $134
      var $135=$2;
      var $136=$135;
      var $137=(($136+332)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$2;
      var $140=$3;
      var $141=FUNCTION_TABLE[$138]($139, $140);
      var $142=(($141)|0)!=0;
      if ($142) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $143
      var $144=$3;
      var $145=$5;
      HEAP32[(($145)>>2)]=$144;
      $1=0;
      __label__ = 46; break;
    case 31: // $146
      var $147=$3;
      var $148=(($147+2)|0);
      $3=$148;
      __label__ = 44; break;
    case 32: // $149
      var $150=$4;
      var $151=$3;
      var $152=$150;
      var $153=$151;
      var $154=(($152-$153)|0);
      var $155=(($154)|0) < 3;
      if ($155) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $156
      $1=-2;
      __label__ = 46; break;
    case 34: // $157
      var $158=$2;
      var $159=$158;
      var $160=(($159+336)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$2;
      var $163=$3;
      var $164=FUNCTION_TABLE[$161]($162, $163);
      var $165=(($164)|0)!=0;
      if ($165) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $166
      var $167=$3;
      var $168=$5;
      HEAP32[(($168)>>2)]=$167;
      $1=0;
      __label__ = 46; break;
    case 36: // $169
      var $170=$3;
      var $171=(($170+3)|0);
      $3=$171;
      __label__ = 44; break;
    case 37: // $172
      var $173=$4;
      var $174=$3;
      var $175=$173;
      var $176=$174;
      var $177=(($175-$176)|0);
      var $178=(($177)|0) < 4;
      if ($178) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $179
      $1=-2;
      __label__ = 46; break;
    case 39: // $180
      var $181=$2;
      var $182=$181;
      var $183=(($182+340)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=$2;
      var $186=$3;
      var $187=FUNCTION_TABLE[$184]($185, $186);
      var $188=(($187)|0)!=0;
      if ($188) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $189
      var $190=$3;
      var $191=$5;
      HEAP32[(($191)>>2)]=$190;
      $1=0;
      __label__ = 46; break;
    case 41: // $192
      var $193=$3;
      var $194=(($193+4)|0);
      $3=$194;
      __label__ = 44; break;
    case 42: // $195
      var $196=$3;
      var $197=(($196+1)|0);
      var $198=$5;
      HEAP32[(($198)>>2)]=$197;
      $1=9;
      __label__ = 46; break;
    case 43: // $199
      var $200=$3;
      var $201=$5;
      HEAP32[(($201)>>2)]=$200;
      $1=0;
      __label__ = 46; break;
    case 44: // $202
      __label__ = 23; break;
    case 45: // $203
      $1=-1;
      __label__ = 46; break;
    case 46: // $204
      var $205=$1;
      ;
      return $205;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14normal_scanRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18normal_scanPercentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-22;
      __label__ = 46; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 29) {
        __label__ = 3; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 4; break;
      }
      else if ($19 == 5) {
        __label__ = 5; break;
      }
      else if ($19 == 6) {
        __label__ = 10; break;
      }
      else if ($19 == 7) {
        __label__ = 15; break;
      }
      else if ($19 == 21 || $19 == 10 || $19 == 9 || $19 == 30) {
        __label__ = 20; break;
      }
      else {
      __label__ = 21; break;
      }
      
    case 3: // $20
      var $21=$3;
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 46; break;
    case 4: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      $3=$25;
      __label__ = 22; break;
    case 5: // $26
      var $27=$4;
      var $28=$3;
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0) < 2;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=-2;
      __label__ = 46; break;
    case 7: // $34
      var $35=$2;
      var $36=$35;
      var $37=(($36+344)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=$3;
      var $41=FUNCTION_TABLE[$38]($39, $40);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$3;
      var $45=$5;
      HEAP32[(($45)>>2)]=$44;
      $1=0;
      __label__ = 46; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+2)|0);
      $3=$48;
      __label__ = 22; break;
    case 10: // $49
      var $50=$4;
      var $51=$3;
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      $1=-2;
      __label__ = 46; break;
    case 12: // $57
      var $58=$2;
      var $59=$58;
      var $60=(($59+348)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=$3;
      var $64=FUNCTION_TABLE[$61]($62, $63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=$3;
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 46; break;
    case 14: // $69
      var $70=$3;
      var $71=(($70+3)|0);
      $3=$71;
      __label__ = 22; break;
    case 15: // $72
      var $73=$4;
      var $74=$3;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 4;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $1=-2;
      __label__ = 46; break;
    case 17: // $80
      var $81=$2;
      var $82=$81;
      var $83=(($82+352)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=$3;
      var $87=FUNCTION_TABLE[$84]($85, $86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 46; break;
    case 19: // $92
      var $93=$3;
      var $94=(($93+4)|0);
      $3=$94;
      __label__ = 22; break;
    case 20: // $95
      var $96=$3;
      var $97=$5;
      HEAP32[(($97)>>2)]=$96;
      $1=22;
      __label__ = 46; break;
    case 21: // $98
      var $99=$3;
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 46; break;
    case 22: // $101
      __label__ = 23; break;
    case 23: // $102
      var $103=$3;
      var $104=$4;
      var $105=(($103)|0)!=(($104)|0);
      if ($105) { __label__ = 24; break; } else { __label__ = 45; break; }
    case 24: // $106
      var $107=$3;
      var $108=HEAPU8[($107)];
      var $109=(($108)&255);
      var $110=$2;
      var $111=$110;
      var $112=(($111+76)|0);
      var $113=(($112+$109)|0);
      var $114=HEAPU8[($113)];
      var $115=(($114)&255);
      if ($115 == 29) {
        __label__ = 25; break;
      }
      else if ($115 == 22 || $115 == 24 || $115 == 25 || $115 == 26 || $115 == 27) {
        __label__ = 26; break;
      }
      else if ($115 == 5) {
        __label__ = 27; break;
      }
      else if ($115 == 6) {
        __label__ = 32; break;
      }
      else if ($115 == 7) {
        __label__ = 37; break;
      }
      else if ($115 == 18) {
        __label__ = 42; break;
      }
      else {
      __label__ = 43; break;
      }
      
    case 25: // $116
      var $117=$3;
      var $118=$5;
      HEAP32[(($118)>>2)]=$117;
      $1=0;
      __label__ = 46; break;
    case 26: // $119
      var $120=$3;
      var $121=(($120+1)|0);
      $3=$121;
      __label__ = 44; break;
    case 27: // $122
      var $123=$4;
      var $124=$3;
      var $125=$123;
      var $126=$124;
      var $127=(($125-$126)|0);
      var $128=(($127)|0) < 2;
      if ($128) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $129
      $1=-2;
      __label__ = 46; break;
    case 29: // $130
      var $131=$2;
      var $132=$131;
      var $133=(($132+332)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$2;
      var $136=$3;
      var $137=FUNCTION_TABLE[$134]($135, $136);
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $139
      var $140=$3;
      var $141=$5;
      HEAP32[(($141)>>2)]=$140;
      $1=0;
      __label__ = 46; break;
    case 31: // $142
      var $143=$3;
      var $144=(($143+2)|0);
      $3=$144;
      __label__ = 44; break;
    case 32: // $145
      var $146=$4;
      var $147=$3;
      var $148=$146;
      var $149=$147;
      var $150=(($148-$149)|0);
      var $151=(($150)|0) < 3;
      if ($151) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $152
      $1=-2;
      __label__ = 46; break;
    case 34: // $153
      var $154=$2;
      var $155=$154;
      var $156=(($155+336)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$2;
      var $159=$3;
      var $160=FUNCTION_TABLE[$157]($158, $159);
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $162
      var $163=$3;
      var $164=$5;
      HEAP32[(($164)>>2)]=$163;
      $1=0;
      __label__ = 46; break;
    case 36: // $165
      var $166=$3;
      var $167=(($166+3)|0);
      $3=$167;
      __label__ = 44; break;
    case 37: // $168
      var $169=$4;
      var $170=$3;
      var $171=$169;
      var $172=$170;
      var $173=(($171-$172)|0);
      var $174=(($173)|0) < 4;
      if ($174) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $175
      $1=-2;
      __label__ = 46; break;
    case 39: // $176
      var $177=$2;
      var $178=$177;
      var $179=(($178+340)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$2;
      var $182=$3;
      var $183=FUNCTION_TABLE[$180]($181, $182);
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $185
      var $186=$3;
      var $187=$5;
      HEAP32[(($187)>>2)]=$186;
      $1=0;
      __label__ = 46; break;
    case 41: // $188
      var $189=$3;
      var $190=(($189+4)|0);
      $3=$190;
      __label__ = 44; break;
    case 42: // $191
      var $192=$3;
      var $193=(($192+1)|0);
      var $194=$5;
      HEAP32[(($194)>>2)]=$193;
      $1=28;
      __label__ = 46; break;
    case 43: // $195
      var $196=$3;
      var $197=$5;
      HEAP32[(($197)>>2)]=$196;
      $1=0;
      __label__ = 46; break;
    case 44: // $198
      __label__ = 23; break;
    case 45: // $199
      $1=-1;
      __label__ = 46; break;
    case 46: // $200
      var $201=$1;
      ;
      return $201;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18normal_scanPercentPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18normal_scanCharRefPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $9
      var $10=$3;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)==120;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$2;
      var $16=$3;
      var $17=(($16+1)|0);
      var $18=$4;
      var $19=$5;
      var $20=__ZL21normal_scanHexCharRefPK8encodingPKcS3_PS3_($15, $17, $18, $19);
      $1=$20;
      __label__ = 14; break;
    case 3: // $21
      var $22=$3;
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      var $25=$2;
      var $26=$25;
      var $27=(($26+76)|0);
      var $28=(($27+$24)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      if ($30 == 25) {
        __label__ = 5; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 4: // $31
      var $32=$3;
      var $33=$5;
      HEAP32[(($33)>>2)]=$32;
      $1=0;
      __label__ = 14; break;
    case 5: // $34
      var $35=$3;
      var $36=(($35+1)|0);
      $3=$36;
      __label__ = 6; break;
    case 6: // $37
      var $38=$3;
      var $39=$4;
      var $40=(($38)|0)!=(($39)|0);
      if ($40) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $41
      var $42=$3;
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=$2;
      var $46=$45;
      var $47=(($46+76)|0);
      var $48=(($47+$44)|0);
      var $49=HEAPU8[($48)];
      var $50=(($49)&255);
      if ($50 == 25) {
        __label__ = 10; break;
      }
      else if ($50 == 18) {
        __label__ = 8; break;
      }
      else {
      __label__ = 9; break;
      }
      
    case 8: // $51
      var $52=$3;
      var $53=(($52+1)|0);
      var $54=$5;
      HEAP32[(($54)>>2)]=$53;
      $1=10;
      __label__ = 14; break;
    case 9: // $55
      var $56=$3;
      var $57=$5;
      HEAP32[(($57)>>2)]=$56;
      $1=0;
      __label__ = 14; break;
    case 10: // $58
      __label__ = 11; break;
    case 11: // $59
      var $60=$3;
      var $61=(($60+1)|0);
      $3=$61;
      __label__ = 6; break;
    case 12: // $62
      __label__ = 13; break;
    case 13: // $63
      $1=-1;
      __label__ = 14; break;
    case 14: // $64
      var $65=$1;
      ;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18normal_scanCharRefPK8encodingPKcS3_PS3_["X"]=1;

function __ZL13normal_scanLtPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $hadColon;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 110; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 29) {
        __label__ = 3; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 4; break;
      }
      else if ($19 == 5) {
        __label__ = 5; break;
      }
      else if ($19 == 6) {
        __label__ = 10; break;
      }
      else if ($19 == 7) {
        __label__ = 15; break;
      }
      else if ($19 == 16) {
        __label__ = 20; break;
      }
      else if ($19 == 15) {
        __label__ = 26; break;
      }
      else if ($19 == 17) {
        __label__ = 27; break;
      }
      else {
      __label__ = 28; break;
      }
      
    case 3: // $20
      var $21=$3;
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 110; break;
    case 4: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      $3=$25;
      __label__ = 29; break;
    case 5: // $26
      var $27=$4;
      var $28=$3;
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0) < 2;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=-2;
      __label__ = 110; break;
    case 7: // $34
      var $35=$2;
      var $36=$35;
      var $37=(($36+344)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=$3;
      var $41=FUNCTION_TABLE[$38]($39, $40);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$3;
      var $45=$5;
      HEAP32[(($45)>>2)]=$44;
      $1=0;
      __label__ = 110; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+2)|0);
      $3=$48;
      __label__ = 29; break;
    case 10: // $49
      var $50=$4;
      var $51=$3;
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      $1=-2;
      __label__ = 110; break;
    case 12: // $57
      var $58=$2;
      var $59=$58;
      var $60=(($59+348)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=$3;
      var $64=FUNCTION_TABLE[$61]($62, $63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=$3;
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 110; break;
    case 14: // $69
      var $70=$3;
      var $71=(($70+3)|0);
      $3=$71;
      __label__ = 29; break;
    case 15: // $72
      var $73=$4;
      var $74=$3;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 4;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $1=-2;
      __label__ = 110; break;
    case 17: // $80
      var $81=$2;
      var $82=$81;
      var $83=(($82+352)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=$3;
      var $87=FUNCTION_TABLE[$84]($85, $86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 110; break;
    case 19: // $92
      var $93=$3;
      var $94=(($93+4)|0);
      $3=$94;
      __label__ = 29; break;
    case 20: // $95
      var $96=$3;
      var $97=(($96+1)|0);
      $3=$97;
      var $98=$4;
      var $99=(($97)|0)==(($98)|0);
      if ($99) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $100
      $1=-1;
      __label__ = 110; break;
    case 22: // $101
      var $102=$3;
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$2;
      var $106=$105;
      var $107=(($106+76)|0);
      var $108=(($107+$104)|0);
      var $109=HEAPU8[($108)];
      var $110=(($109)&255);
      if ($110 == 27) {
        __label__ = 23; break;
      }
      else if ($110 == 20) {
        __label__ = 24; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 23: // $111
      var $112=$2;
      var $113=$3;
      var $114=(($113+1)|0);
      var $115=$4;
      var $116=$5;
      var $117=__ZL18normal_scanCommentPK8encodingPKcS3_PS3_($112, $114, $115, $116);
      $1=$117;
      __label__ = 110; break;
    case 24: // $118
      var $119=$2;
      var $120=$3;
      var $121=(($120+1)|0);
      var $122=$4;
      var $123=$5;
      var $124=__ZL23normal_scanCdataSectionPK8encodingPKcS3_PS3_($119, $121, $122, $123);
      $1=$124;
      __label__ = 110; break;
    case 25: // $125
      var $126=$3;
      var $127=$5;
      HEAP32[(($127)>>2)]=$126;
      $1=0;
      __label__ = 110; break;
    case 26: // $128
      var $129=$2;
      var $130=$3;
      var $131=(($130+1)|0);
      var $132=$4;
      var $133=$5;
      var $134=__ZL13normal_scanPiPK8encodingPKcS3_PS3_($129, $131, $132, $133);
      $1=$134;
      __label__ = 110; break;
    case 27: // $135
      var $136=$2;
      var $137=$3;
      var $138=(($137+1)|0);
      var $139=$4;
      var $140=$5;
      var $141=__ZL17normal_scanEndTagPK8encodingPKcS3_PS3_($136, $138, $139, $140);
      $1=$141;
      __label__ = 110; break;
    case 28: // $142
      var $143=$3;
      var $144=$5;
      HEAP32[(($144)>>2)]=$143;
      $1=0;
      __label__ = 110; break;
    case 29: // $145
      $hadColon=0;
      __label__ = 30; break;
    case 30: // $146
      var $147=$3;
      var $148=$4;
      var $149=(($147)|0)!=(($148)|0);
      if ($149) { __label__ = 31; break; } else { __label__ = 109; break; }
    case 31: // $150
      var $151=$3;
      var $152=HEAPU8[($151)];
      var $153=(($152)&255);
      var $154=$2;
      var $155=$154;
      var $156=(($155+76)|0);
      var $157=(($156+$153)|0);
      var $158=HEAPU8[($157)];
      var $159=(($158)&255);
      if ($159 == 29) {
        __label__ = 32; break;
      }
      else if ($159 == 22 || $159 == 24 || $159 == 25 || $159 == 26 || $159 == 27) {
        __label__ = 33; break;
      }
      else if ($159 == 5) {
        __label__ = 34; break;
      }
      else if ($159 == 6) {
        __label__ = 39; break;
      }
      else if ($159 == 7) {
        __label__ = 44; break;
      }
      else if ($159 == 23) {
        __label__ = 49; break;
      }
      else if ($159 == 21 || $159 == 9 || $159 == 10) {
        __label__ = 73; break;
      }
      else if ($159 == 11) {
        __label__ = 99; break;
      }
      else if ($159 == 17) {
        __label__ = 101; break;
      }
      else {
      __label__ = 107; break;
      }
      
    case 32: // $160
      var $161=$3;
      var $162=$5;
      HEAP32[(($162)>>2)]=$161;
      $1=0;
      __label__ = 110; break;
    case 33: // $163
      var $164=$3;
      var $165=(($164+1)|0);
      $3=$165;
      __label__ = 108; break;
    case 34: // $166
      var $167=$4;
      var $168=$3;
      var $169=$167;
      var $170=$168;
      var $171=(($169-$170)|0);
      var $172=(($171)|0) < 2;
      if ($172) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $173
      $1=-2;
      __label__ = 110; break;
    case 36: // $174
      var $175=$2;
      var $176=$175;
      var $177=(($176+332)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=$2;
      var $180=$3;
      var $181=FUNCTION_TABLE[$178]($179, $180);
      var $182=(($181)|0)!=0;
      if ($182) { __label__ = 38; break; } else { __label__ = 37; break; }
    case 37: // $183
      var $184=$3;
      var $185=$5;
      HEAP32[(($185)>>2)]=$184;
      $1=0;
      __label__ = 110; break;
    case 38: // $186
      var $187=$3;
      var $188=(($187+2)|0);
      $3=$188;
      __label__ = 108; break;
    case 39: // $189
      var $190=$4;
      var $191=$3;
      var $192=$190;
      var $193=$191;
      var $194=(($192-$193)|0);
      var $195=(($194)|0) < 3;
      if ($195) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $196
      $1=-2;
      __label__ = 110; break;
    case 41: // $197
      var $198=$2;
      var $199=$198;
      var $200=(($199+336)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=$2;
      var $203=$3;
      var $204=FUNCTION_TABLE[$201]($202, $203);
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $206
      var $207=$3;
      var $208=$5;
      HEAP32[(($208)>>2)]=$207;
      $1=0;
      __label__ = 110; break;
    case 43: // $209
      var $210=$3;
      var $211=(($210+3)|0);
      $3=$211;
      __label__ = 108; break;
    case 44: // $212
      var $213=$4;
      var $214=$3;
      var $215=$213;
      var $216=$214;
      var $217=(($215-$216)|0);
      var $218=(($217)|0) < 4;
      if ($218) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $219
      $1=-2;
      __label__ = 110; break;
    case 46: // $220
      var $221=$2;
      var $222=$221;
      var $223=(($222+340)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=$2;
      var $226=$3;
      var $227=FUNCTION_TABLE[$224]($225, $226);
      var $228=(($227)|0)!=0;
      if ($228) { __label__ = 48; break; } else { __label__ = 47; break; }
    case 47: // $229
      var $230=$3;
      var $231=$5;
      HEAP32[(($231)>>2)]=$230;
      $1=0;
      __label__ = 110; break;
    case 48: // $232
      var $233=$3;
      var $234=(($233+4)|0);
      $3=$234;
      __label__ = 108; break;
    case 49: // $235
      var $236=$hadColon;
      var $237=(($236)|0)!=0;
      if ($237) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $238
      var $239=$3;
      var $240=$5;
      HEAP32[(($240)>>2)]=$239;
      $1=0;
      __label__ = 110; break;
    case 51: // $241
      $hadColon=1;
      var $242=$3;
      var $243=(($242+1)|0);
      $3=$243;
      var $244=$3;
      var $245=$4;
      var $246=(($244)|0)==(($245)|0);
      if ($246) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $247
      $1=-1;
      __label__ = 110; break;
    case 53: // $248
      var $249=$3;
      var $250=HEAPU8[($249)];
      var $251=(($250)&255);
      var $252=$2;
      var $253=$252;
      var $254=(($253+76)|0);
      var $255=(($254+$251)|0);
      var $256=HEAPU8[($255)];
      var $257=(($256)&255);
      if ($257 == 29) {
        __label__ = 54; break;
      }
      else if ($257 == 22 || $257 == 24) {
        __label__ = 55; break;
      }
      else if ($257 == 5) {
        __label__ = 56; break;
      }
      else if ($257 == 6) {
        __label__ = 61; break;
      }
      else if ($257 == 7) {
        __label__ = 66; break;
      }
      else {
      __label__ = 71; break;
      }
      
    case 54: // $258
      var $259=$3;
      var $260=$5;
      HEAP32[(($260)>>2)]=$259;
      $1=0;
      __label__ = 110; break;
    case 55: // $261
      var $262=$3;
      var $263=(($262+1)|0);
      $3=$263;
      __label__ = 72; break;
    case 56: // $264
      var $265=$4;
      var $266=$3;
      var $267=$265;
      var $268=$266;
      var $269=(($267-$268)|0);
      var $270=(($269)|0) < 2;
      if ($270) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $271
      $1=-2;
      __label__ = 110; break;
    case 58: // $272
      var $273=$2;
      var $274=$273;
      var $275=(($274+344)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$2;
      var $278=$3;
      var $279=FUNCTION_TABLE[$276]($277, $278);
      var $280=(($279)|0)!=0;
      if ($280) { __label__ = 60; break; } else { __label__ = 59; break; }
    case 59: // $281
      var $282=$3;
      var $283=$5;
      HEAP32[(($283)>>2)]=$282;
      $1=0;
      __label__ = 110; break;
    case 60: // $284
      var $285=$3;
      var $286=(($285+2)|0);
      $3=$286;
      __label__ = 72; break;
    case 61: // $287
      var $288=$4;
      var $289=$3;
      var $290=$288;
      var $291=$289;
      var $292=(($290-$291)|0);
      var $293=(($292)|0) < 3;
      if ($293) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $294
      $1=-2;
      __label__ = 110; break;
    case 63: // $295
      var $296=$2;
      var $297=$296;
      var $298=(($297+348)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=$2;
      var $301=$3;
      var $302=FUNCTION_TABLE[$299]($300, $301);
      var $303=(($302)|0)!=0;
      if ($303) { __label__ = 65; break; } else { __label__ = 64; break; }
    case 64: // $304
      var $305=$3;
      var $306=$5;
      HEAP32[(($306)>>2)]=$305;
      $1=0;
      __label__ = 110; break;
    case 65: // $307
      var $308=$3;
      var $309=(($308+3)|0);
      $3=$309;
      __label__ = 72; break;
    case 66: // $310
      var $311=$4;
      var $312=$3;
      var $313=$311;
      var $314=$312;
      var $315=(($313-$314)|0);
      var $316=(($315)|0) < 4;
      if ($316) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $317
      $1=-2;
      __label__ = 110; break;
    case 68: // $318
      var $319=$2;
      var $320=$319;
      var $321=(($320+352)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=$2;
      var $324=$3;
      var $325=FUNCTION_TABLE[$322]($323, $324);
      var $326=(($325)|0)!=0;
      if ($326) { __label__ = 70; break; } else { __label__ = 69; break; }
    case 69: // $327
      var $328=$3;
      var $329=$5;
      HEAP32[(($329)>>2)]=$328;
      $1=0;
      __label__ = 110; break;
    case 70: // $330
      var $331=$3;
      var $332=(($331+4)|0);
      $3=$332;
      __label__ = 72; break;
    case 71: // $333
      var $334=$3;
      var $335=$5;
      HEAP32[(($335)>>2)]=$334;
      $1=0;
      __label__ = 110; break;
    case 72: // $336
      __label__ = 108; break;
    case 73: // $337
      var $338=$3;
      var $339=(($338+1)|0);
      $3=$339;
      __label__ = 74; break;
    case 74: // $340
      var $341=$3;
      var $342=$4;
      var $343=(($341)|0)!=(($342)|0);
      if ($343) { __label__ = 75; break; } else { __label__ = 98; break; }
    case 75: // $344
      var $345=$3;
      var $346=HEAPU8[($345)];
      var $347=(($346)&255);
      var $348=$2;
      var $349=$348;
      var $350=(($349+76)|0);
      var $351=(($350+$347)|0);
      var $352=HEAPU8[($351)];
      var $353=(($352)&255);
      if ($353 == 29) {
        __label__ = 76; break;
      }
      else if ($353 == 22 || $353 == 24) {
        __label__ = 77; break;
      }
      else if ($353 == 5) {
        __label__ = 78; break;
      }
      else if ($353 == 6) {
        __label__ = 83; break;
      }
      else if ($353 == 7) {
        __label__ = 88; break;
      }
      else if ($353 == 11) {
        __label__ = 93; break;
      }
      else if ($353 == 17) {
        __label__ = 94; break;
      }
      else if ($353 == 21 || $353 == 9 || $353 == 10) {
        __label__ = 95; break;
      }
      else {
      __label__ = 96; break;
      }
      
    case 76: // $354
      var $355=$3;
      var $356=$5;
      HEAP32[(($356)>>2)]=$355;
      $1=0;
      __label__ = 110; break;
    case 77: // $357
      var $358=$3;
      var $359=(($358+1)|0);
      $3=$359;
      __label__ = 97; break;
    case 78: // $360
      var $361=$4;
      var $362=$3;
      var $363=$361;
      var $364=$362;
      var $365=(($363-$364)|0);
      var $366=(($365)|0) < 2;
      if ($366) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $367
      $1=-2;
      __label__ = 110; break;
    case 80: // $368
      var $369=$2;
      var $370=$369;
      var $371=(($370+344)|0);
      var $372=HEAP32[(($371)>>2)];
      var $373=$2;
      var $374=$3;
      var $375=FUNCTION_TABLE[$372]($373, $374);
      var $376=(($375)|0)!=0;
      if ($376) { __label__ = 82; break; } else { __label__ = 81; break; }
    case 81: // $377
      var $378=$3;
      var $379=$5;
      HEAP32[(($379)>>2)]=$378;
      $1=0;
      __label__ = 110; break;
    case 82: // $380
      var $381=$3;
      var $382=(($381+2)|0);
      $3=$382;
      __label__ = 97; break;
    case 83: // $383
      var $384=$4;
      var $385=$3;
      var $386=$384;
      var $387=$385;
      var $388=(($386-$387)|0);
      var $389=(($388)|0) < 3;
      if ($389) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $390
      $1=-2;
      __label__ = 110; break;
    case 85: // $391
      var $392=$2;
      var $393=$392;
      var $394=(($393+348)|0);
      var $395=HEAP32[(($394)>>2)];
      var $396=$2;
      var $397=$3;
      var $398=FUNCTION_TABLE[$395]($396, $397);
      var $399=(($398)|0)!=0;
      if ($399) { __label__ = 87; break; } else { __label__ = 86; break; }
    case 86: // $400
      var $401=$3;
      var $402=$5;
      HEAP32[(($402)>>2)]=$401;
      $1=0;
      __label__ = 110; break;
    case 87: // $403
      var $404=$3;
      var $405=(($404+3)|0);
      $3=$405;
      __label__ = 97; break;
    case 88: // $406
      var $407=$4;
      var $408=$3;
      var $409=$407;
      var $410=$408;
      var $411=(($409-$410)|0);
      var $412=(($411)|0) < 4;
      if ($412) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $413
      $1=-2;
      __label__ = 110; break;
    case 90: // $414
      var $415=$2;
      var $416=$415;
      var $417=(($416+352)|0);
      var $418=HEAP32[(($417)>>2)];
      var $419=$2;
      var $420=$3;
      var $421=FUNCTION_TABLE[$418]($419, $420);
      var $422=(($421)|0)!=0;
      if ($422) { __label__ = 92; break; } else { __label__ = 91; break; }
    case 91: // $423
      var $424=$3;
      var $425=$5;
      HEAP32[(($425)>>2)]=$424;
      $1=0;
      __label__ = 110; break;
    case 92: // $426
      var $427=$3;
      var $428=(($427+4)|0);
      $3=$428;
      __label__ = 97; break;
    case 93: // $429
      __label__ = 100; break;
    case 94: // $430
      __label__ = 102; break;
    case 95: // $431
      var $432=$3;
      var $433=(($432+1)|0);
      $3=$433;
      __label__ = 74; break;
    case 96: // $434
      var $435=$3;
      var $436=$5;
      HEAP32[(($436)>>2)]=$435;
      $1=0;
      __label__ = 110; break;
    case 97: // $437
      var $438=$2;
      var $439=$3;
      var $440=$4;
      var $441=$5;
      var $442=__ZL15normal_scanAttsPK8encodingPKcS3_PS3_($438, $439, $440, $441);
      $1=$442;
      __label__ = 110; break;
    case 98: // $443
      $1=-1;
      __label__ = 110; break;
    case 99: // $444
      __label__ = 100; break;
    case 100: // $445
      var $446=$3;
      var $447=(($446+1)|0);
      var $448=$5;
      HEAP32[(($448)>>2)]=$447;
      $1=2;
      __label__ = 110; break;
    case 101: // $449
      __label__ = 102; break;
    case 102: // $450
      var $451=$3;
      var $452=(($451+1)|0);
      $3=$452;
      var $453=$3;
      var $454=$4;
      var $455=(($453)|0)==(($454)|0);
      if ($455) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $456
      $1=-1;
      __label__ = 110; break;
    case 104: // $457
      var $458=$3;
      var $459=HEAP8[($458)];
      var $460=(($459 << 24) >> 24);
      var $461=(($460)|0)==62;
      if ($461) { __label__ = 106; break; } else { __label__ = 105; break; }
    case 105: // $462
      var $463=$3;
      var $464=$5;
      HEAP32[(($464)>>2)]=$463;
      $1=0;
      __label__ = 110; break;
    case 106: // $465
      var $466=$3;
      var $467=(($466+1)|0);
      var $468=$5;
      HEAP32[(($468)>>2)]=$467;
      $1=4;
      __label__ = 110; break;
    case 107: // $469
      var $470=$3;
      var $471=$5;
      HEAP32[(($471)>>2)]=$470;
      $1=0;
      __label__ = 110; break;
    case 108: // $472
      __label__ = 30; break;
    case 109: // $473
      $1=-1;
      __label__ = 110; break;
    case 110: // $474
      var $475=$1;
      ;
      return $475;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13normal_scanLtPK8encodingPKcS3_PS3_["X"]=1;

function __ZL23normal_scanCdataSectionPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $i;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$4;
      var $7=$3;
      var $8=$6;
      var $9=$7;
      var $10=(($8-$9)|0);
      var $11=(($10)|0) < 6;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $1=-1;
      __label__ = 9; break;
    case 2: // $13
      $i=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$i;
      var $16=(($15)|0) < 6;
      if ($16) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $17
      var $18=$3;
      var $19=HEAP8[($18)];
      var $20=(($19 << 24) >> 24);
      var $21=$i;
      var $22=((STRING_TABLE.__ZZL23normal_scanCdataSectionPK8encodingPKcS3_PS3_E10CDATA_LSQB+$21)|0);
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $25=(($20)|0)==(($24)|0);
      if ($25) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $26
      var $27=$3;
      var $28=$5;
      HEAP32[(($28)>>2)]=$27;
      $1=0;
      __label__ = 9; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $31=$i;
      var $32=(($31+1)|0);
      $i=$32;
      var $33=$3;
      var $34=(($33+1)|0);
      $3=$34;
      __label__ = 3; break;
    case 8: // $35
      var $36=$3;
      var $37=$5;
      HEAP32[(($37)>>2)]=$36;
      $1=8;
      __label__ = 9; break;
    case 9: // $38
      var $39=$1;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL23normal_scanCdataSectionPK8encodingPKcS3_PS3_["X"]=1;

function __ZL18normal_scanCommentPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 34; break; }
    case 1: // $9
      var $10=$3;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)==45;
      if ($13) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      var $15=$3;
      var $16=$5;
      HEAP32[(($16)>>2)]=$15;
      $1=0;
      __label__ = 35; break;
    case 3: // $17
      var $18=$3;
      var $19=(($18+1)|0);
      $3=$19;
      __label__ = 4; break;
    case 4: // $20
      var $21=$3;
      var $22=$4;
      var $23=(($21)|0)!=(($22)|0);
      if ($23) { __label__ = 5; break; } else { __label__ = 33; break; }
    case 5: // $24
      var $25=$3;
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$2;
      var $29=$28;
      var $30=(($29+76)|0);
      var $31=(($30+$27)|0);
      var $32=HEAPU8[($31)];
      var $33=(($32)&255);
      if ($33 == 5) {
        __label__ = 6; break;
      }
      else if ($33 == 6) {
        __label__ = 11; break;
      }
      else if ($33 == 7) {
        __label__ = 16; break;
      }
      else if ($33 == 0 || $33 == 1 || $33 == 8) {
        __label__ = 21; break;
      }
      else if ($33 == 27) {
        __label__ = 22; break;
      }
      else {
      __label__ = 31; break;
      }
      
    case 6: // $34
      var $35=$4;
      var $36=$3;
      var $37=$35;
      var $38=$36;
      var $39=(($37-$38)|0);
      var $40=(($39)|0) < 2;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      $1=-2;
      __label__ = 35; break;
    case 8: // $42
      var $43=$2;
      var $44=$43;
      var $45=(($44+356)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$2;
      var $48=$3;
      var $49=FUNCTION_TABLE[$46]($47, $48);
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $51
      var $52=$3;
      var $53=$5;
      HEAP32[(($53)>>2)]=$52;
      $1=0;
      __label__ = 35; break;
    case 10: // $54
      var $55=$3;
      var $56=(($55+2)|0);
      $3=$56;
      __label__ = 32; break;
    case 11: // $57
      var $58=$4;
      var $59=$3;
      var $60=$58;
      var $61=$59;
      var $62=(($60-$61)|0);
      var $63=(($62)|0) < 3;
      if ($63) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $64
      $1=-2;
      __label__ = 35; break;
    case 13: // $65
      var $66=$2;
      var $67=$66;
      var $68=(($67+360)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$2;
      var $71=$3;
      var $72=FUNCTION_TABLE[$69]($70, $71);
      var $73=(($72)|0)!=0;
      if ($73) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $74
      var $75=$3;
      var $76=$5;
      HEAP32[(($76)>>2)]=$75;
      $1=0;
      __label__ = 35; break;
    case 15: // $77
      var $78=$3;
      var $79=(($78+3)|0);
      $3=$79;
      __label__ = 32; break;
    case 16: // $80
      var $81=$4;
      var $82=$3;
      var $83=$81;
      var $84=$82;
      var $85=(($83-$84)|0);
      var $86=(($85)|0) < 4;
      if ($86) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $87
      $1=-2;
      __label__ = 35; break;
    case 18: // $88
      var $89=$2;
      var $90=$89;
      var $91=(($90+364)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$2;
      var $94=$3;
      var $95=FUNCTION_TABLE[$92]($93, $94);
      var $96=(($95)|0)!=0;
      if ($96) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $97
      var $98=$3;
      var $99=$5;
      HEAP32[(($99)>>2)]=$98;
      $1=0;
      __label__ = 35; break;
    case 20: // $100
      var $101=$3;
      var $102=(($101+4)|0);
      $3=$102;
      __label__ = 32; break;
    case 21: // $103
      var $104=$3;
      var $105=$5;
      HEAP32[(($105)>>2)]=$104;
      $1=0;
      __label__ = 35; break;
    case 22: // $106
      var $107=$3;
      var $108=(($107+1)|0);
      $3=$108;
      var $109=$4;
      var $110=(($108)|0)==(($109)|0);
      if ($110) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $111
      $1=-1;
      __label__ = 35; break;
    case 24: // $112
      var $113=$3;
      var $114=HEAP8[($113)];
      var $115=(($114 << 24) >> 24);
      var $116=(($115)|0)==45;
      if ($116) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $117
      var $118=$3;
      var $119=(($118+1)|0);
      $3=$119;
      var $120=$4;
      var $121=(($119)|0)==(($120)|0);
      if ($121) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $122
      $1=-1;
      __label__ = 35; break;
    case 27: // $123
      var $124=$3;
      var $125=HEAP8[($124)];
      var $126=(($125 << 24) >> 24);
      var $127=(($126)|0)==62;
      if ($127) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $128
      var $129=$3;
      var $130=$5;
      HEAP32[(($130)>>2)]=$129;
      $1=0;
      __label__ = 35; break;
    case 29: // $131
      var $132=$3;
      var $133=(($132+1)|0);
      var $134=$5;
      HEAP32[(($134)>>2)]=$133;
      $1=13;
      __label__ = 35; break;
    case 30: // $135
      __label__ = 32; break;
    case 31: // $136
      var $137=$3;
      var $138=(($137+1)|0);
      $3=$138;
      __label__ = 32; break;
    case 32: // $139
      __label__ = 4; break;
    case 33: // $140
      __label__ = 34; break;
    case 34: // $141
      $1=-1;
      __label__ = 35; break;
    case 35: // $142
      var $143=$1;
      ;
      return $143;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL18normal_scanCommentPK8encodingPKcS3_PS3_["X"]=1;

function __ZL13normal_scanPiPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $tok=__stackBase__;
      var $target;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      $target=$6;
      var $7=$3;
      var $8=$4;
      var $9=(($7)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=-1;
      __label__ = 80; break;
    case 2: // $11
      var $12=$3;
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$2;
      var $16=$15;
      var $17=(($16+76)|0);
      var $18=(($17+$14)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      if ($20 == 29) {
        __label__ = 3; break;
      }
      else if ($20 == 22 || $20 == 24) {
        __label__ = 4; break;
      }
      else if ($20 == 5) {
        __label__ = 5; break;
      }
      else if ($20 == 6) {
        __label__ = 10; break;
      }
      else if ($20 == 7) {
        __label__ = 15; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 3: // $21
      var $22=$3;
      var $23=$5;
      HEAP32[(($23)>>2)]=$22;
      $1=0;
      __label__ = 80; break;
    case 4: // $24
      var $25=$3;
      var $26=(($25+1)|0);
      $3=$26;
      __label__ = 21; break;
    case 5: // $27
      var $28=$4;
      var $29=$3;
      var $30=$28;
      var $31=$29;
      var $32=(($30-$31)|0);
      var $33=(($32)|0) < 2;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      $1=-2;
      __label__ = 80; break;
    case 7: // $35
      var $36=$2;
      var $37=$36;
      var $38=(($37+344)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$2;
      var $41=$3;
      var $42=FUNCTION_TABLE[$39]($40, $41);
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $44
      var $45=$3;
      var $46=$5;
      HEAP32[(($46)>>2)]=$45;
      $1=0;
      __label__ = 80; break;
    case 9: // $47
      var $48=$3;
      var $49=(($48+2)|0);
      $3=$49;
      __label__ = 21; break;
    case 10: // $50
      var $51=$4;
      var $52=$3;
      var $53=$51;
      var $54=$52;
      var $55=(($53-$54)|0);
      var $56=(($55)|0) < 3;
      if ($56) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $57
      $1=-2;
      __label__ = 80; break;
    case 12: // $58
      var $59=$2;
      var $60=$59;
      var $61=(($60+348)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$2;
      var $64=$3;
      var $65=FUNCTION_TABLE[$62]($63, $64);
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $67
      var $68=$3;
      var $69=$5;
      HEAP32[(($69)>>2)]=$68;
      $1=0;
      __label__ = 80; break;
    case 14: // $70
      var $71=$3;
      var $72=(($71+3)|0);
      $3=$72;
      __label__ = 21; break;
    case 15: // $73
      var $74=$4;
      var $75=$3;
      var $76=$74;
      var $77=$75;
      var $78=(($76-$77)|0);
      var $79=(($78)|0) < 4;
      if ($79) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $80
      $1=-2;
      __label__ = 80; break;
    case 17: // $81
      var $82=$2;
      var $83=$82;
      var $84=(($83+352)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$2;
      var $87=$3;
      var $88=FUNCTION_TABLE[$85]($86, $87);
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $90
      var $91=$3;
      var $92=$5;
      HEAP32[(($92)>>2)]=$91;
      $1=0;
      __label__ = 80; break;
    case 19: // $93
      var $94=$3;
      var $95=(($94+4)|0);
      $3=$95;
      __label__ = 21; break;
    case 20: // $96
      var $97=$3;
      var $98=$5;
      HEAP32[(($98)>>2)]=$97;
      $1=0;
      __label__ = 80; break;
    case 21: // $99
      __label__ = 22; break;
    case 22: // $100
      var $101=$3;
      var $102=$4;
      var $103=(($101)|0)!=(($102)|0);
      if ($103) { __label__ = 23; break; } else { __label__ = 79; break; }
    case 23: // $104
      var $105=$3;
      var $106=HEAPU8[($105)];
      var $107=(($106)&255);
      var $108=$2;
      var $109=$108;
      var $110=(($109+76)|0);
      var $111=(($110+$107)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      if ($113 == 29) {
        __label__ = 24; break;
      }
      else if ($113 == 22 || $113 == 24 || $113 == 25 || $113 == 26 || $113 == 27) {
        __label__ = 25; break;
      }
      else if ($113 == 5) {
        __label__ = 26; break;
      }
      else if ($113 == 6) {
        __label__ = 31; break;
      }
      else if ($113 == 7) {
        __label__ = 36; break;
      }
      else if ($113 == 21 || $113 == 9 || $113 == 10) {
        __label__ = 41; break;
      }
      else if ($113 == 15) {
        __label__ = 70; break;
      }
      else {
      __label__ = 77; break;
      }
      
    case 24: // $114
      var $115=$3;
      var $116=$5;
      HEAP32[(($116)>>2)]=$115;
      $1=0;
      __label__ = 80; break;
    case 25: // $117
      var $118=$3;
      var $119=(($118+1)|0);
      $3=$119;
      __label__ = 78; break;
    case 26: // $120
      var $121=$4;
      var $122=$3;
      var $123=$121;
      var $124=$122;
      var $125=(($123-$124)|0);
      var $126=(($125)|0) < 2;
      if ($126) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $127
      $1=-2;
      __label__ = 80; break;
    case 28: // $128
      var $129=$2;
      var $130=$129;
      var $131=(($130+332)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$2;
      var $134=$3;
      var $135=FUNCTION_TABLE[$132]($133, $134);
      var $136=(($135)|0)!=0;
      if ($136) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $137
      var $138=$3;
      var $139=$5;
      HEAP32[(($139)>>2)]=$138;
      $1=0;
      __label__ = 80; break;
    case 30: // $140
      var $141=$3;
      var $142=(($141+2)|0);
      $3=$142;
      __label__ = 78; break;
    case 31: // $143
      var $144=$4;
      var $145=$3;
      var $146=$144;
      var $147=$145;
      var $148=(($146-$147)|0);
      var $149=(($148)|0) < 3;
      if ($149) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $150
      $1=-2;
      __label__ = 80; break;
    case 33: // $151
      var $152=$2;
      var $153=$152;
      var $154=(($153+336)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$2;
      var $157=$3;
      var $158=FUNCTION_TABLE[$155]($156, $157);
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $160
      var $161=$3;
      var $162=$5;
      HEAP32[(($162)>>2)]=$161;
      $1=0;
      __label__ = 80; break;
    case 35: // $163
      var $164=$3;
      var $165=(($164+3)|0);
      $3=$165;
      __label__ = 78; break;
    case 36: // $166
      var $167=$4;
      var $168=$3;
      var $169=$167;
      var $170=$168;
      var $171=(($169-$170)|0);
      var $172=(($171)|0) < 4;
      if ($172) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $173
      $1=-2;
      __label__ = 80; break;
    case 38: // $174
      var $175=$2;
      var $176=$175;
      var $177=(($176+340)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=$2;
      var $180=$3;
      var $181=FUNCTION_TABLE[$178]($179, $180);
      var $182=(($181)|0)!=0;
      if ($182) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $183
      var $184=$3;
      var $185=$5;
      HEAP32[(($185)>>2)]=$184;
      $1=0;
      __label__ = 80; break;
    case 40: // $186
      var $187=$3;
      var $188=(($187+4)|0);
      $3=$188;
      __label__ = 78; break;
    case 41: // $189
      var $190=$2;
      var $191=$target;
      var $192=$3;
      var $193=__ZL20normal_checkPiTargetPK8encodingPKcS3_Pi($190, $191, $192, $tok);
      var $194=(($193)|0)!=0;
      if ($194) { __label__ = 43; break; } else { __label__ = 42; break; }
    case 42: // $195
      var $196=$3;
      var $197=$5;
      HEAP32[(($197)>>2)]=$196;
      $1=0;
      __label__ = 80; break;
    case 43: // $198
      var $199=$3;
      var $200=(($199+1)|0);
      $3=$200;
      __label__ = 44; break;
    case 44: // $201
      var $202=$3;
      var $203=$4;
      var $204=(($202)|0)!=(($203)|0);
      if ($204) { __label__ = 45; break; } else { __label__ = 69; break; }
    case 45: // $205
      var $206=$3;
      var $207=HEAPU8[($206)];
      var $208=(($207)&255);
      var $209=$2;
      var $210=$209;
      var $211=(($210+76)|0);
      var $212=(($211+$208)|0);
      var $213=HEAPU8[($212)];
      var $214=(($213)&255);
      if ($214 == 5) {
        __label__ = 46; break;
      }
      else if ($214 == 6) {
        __label__ = 51; break;
      }
      else if ($214 == 7) {
        __label__ = 56; break;
      }
      else if ($214 == 0 || $214 == 1 || $214 == 8) {
        __label__ = 61; break;
      }
      else if ($214 == 15) {
        __label__ = 62; break;
      }
      else {
      __label__ = 67; break;
      }
      
    case 46: // $215
      var $216=$4;
      var $217=$3;
      var $218=$216;
      var $219=$217;
      var $220=(($218-$219)|0);
      var $221=(($220)|0) < 2;
      if ($221) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $222
      $1=-2;
      __label__ = 80; break;
    case 48: // $223
      var $224=$2;
      var $225=$224;
      var $226=(($225+356)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$2;
      var $229=$3;
      var $230=FUNCTION_TABLE[$227]($228, $229);
      var $231=(($230)|0)!=0;
      if ($231) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $232
      var $233=$3;
      var $234=$5;
      HEAP32[(($234)>>2)]=$233;
      $1=0;
      __label__ = 80; break;
    case 50: // $235
      var $236=$3;
      var $237=(($236+2)|0);
      $3=$237;
      __label__ = 68; break;
    case 51: // $238
      var $239=$4;
      var $240=$3;
      var $241=$239;
      var $242=$240;
      var $243=(($241-$242)|0);
      var $244=(($243)|0) < 3;
      if ($244) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $245
      $1=-2;
      __label__ = 80; break;
    case 53: // $246
      var $247=$2;
      var $248=$247;
      var $249=(($248+360)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=$2;
      var $252=$3;
      var $253=FUNCTION_TABLE[$250]($251, $252);
      var $254=(($253)|0)!=0;
      if ($254) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $255
      var $256=$3;
      var $257=$5;
      HEAP32[(($257)>>2)]=$256;
      $1=0;
      __label__ = 80; break;
    case 55: // $258
      var $259=$3;
      var $260=(($259+3)|0);
      $3=$260;
      __label__ = 68; break;
    case 56: // $261
      var $262=$4;
      var $263=$3;
      var $264=$262;
      var $265=$263;
      var $266=(($264-$265)|0);
      var $267=(($266)|0) < 4;
      if ($267) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $268
      $1=-2;
      __label__ = 80; break;
    case 58: // $269
      var $270=$2;
      var $271=$270;
      var $272=(($271+364)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=$2;
      var $275=$3;
      var $276=FUNCTION_TABLE[$273]($274, $275);
      var $277=(($276)|0)!=0;
      if ($277) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $278
      var $279=$3;
      var $280=$5;
      HEAP32[(($280)>>2)]=$279;
      $1=0;
      __label__ = 80; break;
    case 60: // $281
      var $282=$3;
      var $283=(($282+4)|0);
      $3=$283;
      __label__ = 68; break;
    case 61: // $284
      var $285=$3;
      var $286=$5;
      HEAP32[(($286)>>2)]=$285;
      $1=0;
      __label__ = 80; break;
    case 62: // $287
      var $288=$3;
      var $289=(($288+1)|0);
      $3=$289;
      var $290=$3;
      var $291=$4;
      var $292=(($290)|0)==(($291)|0);
      if ($292) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $293
      $1=-1;
      __label__ = 80; break;
    case 64: // $294
      var $295=$3;
      var $296=HEAP8[($295)];
      var $297=(($296 << 24) >> 24);
      var $298=(($297)|0)==62;
      if ($298) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $299
      var $300=$3;
      var $301=(($300+1)|0);
      var $302=$5;
      HEAP32[(($302)>>2)]=$301;
      var $303=HEAP32[(($tok)>>2)];
      $1=$303;
      __label__ = 80; break;
    case 66: // $304
      __label__ = 68; break;
    case 67: // $305
      var $306=$3;
      var $307=(($306+1)|0);
      $3=$307;
      __label__ = 68; break;
    case 68: // $308
      __label__ = 44; break;
    case 69: // $309
      $1=-1;
      __label__ = 80; break;
    case 70: // $310
      var $311=$2;
      var $312=$target;
      var $313=$3;
      var $314=__ZL20normal_checkPiTargetPK8encodingPKcS3_Pi($311, $312, $313, $tok);
      var $315=(($314)|0)!=0;
      if ($315) { __label__ = 72; break; } else { __label__ = 71; break; }
    case 71: // $316
      var $317=$3;
      var $318=$5;
      HEAP32[(($318)>>2)]=$317;
      $1=0;
      __label__ = 80; break;
    case 72: // $319
      var $320=$3;
      var $321=(($320+1)|0);
      $3=$321;
      var $322=$3;
      var $323=$4;
      var $324=(($322)|0)==(($323)|0);
      if ($324) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $325
      $1=-1;
      __label__ = 80; break;
    case 74: // $326
      var $327=$3;
      var $328=HEAP8[($327)];
      var $329=(($328 << 24) >> 24);
      var $330=(($329)|0)==62;
      if ($330) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $331
      var $332=$3;
      var $333=(($332+1)|0);
      var $334=$5;
      HEAP32[(($334)>>2)]=$333;
      var $335=HEAP32[(($tok)>>2)];
      $1=$335;
      __label__ = 80; break;
    case 76: // $336
      __label__ = 77; break;
    case 77: // $337
      var $338=$3;
      var $339=$5;
      HEAP32[(($339)>>2)]=$338;
      $1=0;
      __label__ = 80; break;
    case 78: // $340
      __label__ = 22; break;
    case 79: // $341
      $1=-1;
      __label__ = 80; break;
    case 80: // $342
      var $343=$1;
      STACKTOP = __stackBase__;
      return $343;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13normal_scanPiPK8encodingPKcS3_PS3_["X"]=1;

function __ZL17normal_scanEndTagPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 55; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 29) {
        __label__ = 3; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 4; break;
      }
      else if ($19 == 5) {
        __label__ = 5; break;
      }
      else if ($19 == 6) {
        __label__ = 10; break;
      }
      else if ($19 == 7) {
        __label__ = 15; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 3: // $20
      var $21=$3;
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 55; break;
    case 4: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      $3=$25;
      __label__ = 21; break;
    case 5: // $26
      var $27=$4;
      var $28=$3;
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0) < 2;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=-2;
      __label__ = 55; break;
    case 7: // $34
      var $35=$2;
      var $36=$35;
      var $37=(($36+344)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=$3;
      var $41=FUNCTION_TABLE[$38]($39, $40);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$3;
      var $45=$5;
      HEAP32[(($45)>>2)]=$44;
      $1=0;
      __label__ = 55; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+2)|0);
      $3=$48;
      __label__ = 21; break;
    case 10: // $49
      var $50=$4;
      var $51=$3;
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      $1=-2;
      __label__ = 55; break;
    case 12: // $57
      var $58=$2;
      var $59=$58;
      var $60=(($59+348)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=$3;
      var $64=FUNCTION_TABLE[$61]($62, $63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=$3;
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 55; break;
    case 14: // $69
      var $70=$3;
      var $71=(($70+3)|0);
      $3=$71;
      __label__ = 21; break;
    case 15: // $72
      var $73=$4;
      var $74=$3;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 4;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $1=-2;
      __label__ = 55; break;
    case 17: // $80
      var $81=$2;
      var $82=$81;
      var $83=(($82+352)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=$3;
      var $87=FUNCTION_TABLE[$84]($85, $86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 55; break;
    case 19: // $92
      var $93=$3;
      var $94=(($93+4)|0);
      $3=$94;
      __label__ = 21; break;
    case 20: // $95
      var $96=$3;
      var $97=$5;
      HEAP32[(($97)>>2)]=$96;
      $1=0;
      __label__ = 55; break;
    case 21: // $98
      __label__ = 22; break;
    case 22: // $99
      var $100=$3;
      var $101=$4;
      var $102=(($100)|0)!=(($101)|0);
      if ($102) { __label__ = 23; break; } else { __label__ = 54; break; }
    case 23: // $103
      var $104=$3;
      var $105=HEAPU8[($104)];
      var $106=(($105)&255);
      var $107=$2;
      var $108=$107;
      var $109=(($108+76)|0);
      var $110=(($109+$106)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      if ($112 == 29) {
        __label__ = 24; break;
      }
      else if ($112 == 22 || $112 == 24 || $112 == 25 || $112 == 26 || $112 == 27) {
        __label__ = 25; break;
      }
      else if ($112 == 5) {
        __label__ = 26; break;
      }
      else if ($112 == 6) {
        __label__ = 31; break;
      }
      else if ($112 == 7) {
        __label__ = 36; break;
      }
      else if ($112 == 21 || $112 == 9 || $112 == 10) {
        __label__ = 41; break;
      }
      else if ($112 == 23) {
        __label__ = 50; break;
      }
      else if ($112 == 11) {
        __label__ = 51; break;
      }
      else {
      __label__ = 52; break;
      }
      
    case 24: // $113
      var $114=$3;
      var $115=$5;
      HEAP32[(($115)>>2)]=$114;
      $1=0;
      __label__ = 55; break;
    case 25: // $116
      var $117=$3;
      var $118=(($117+1)|0);
      $3=$118;
      __label__ = 53; break;
    case 26: // $119
      var $120=$4;
      var $121=$3;
      var $122=$120;
      var $123=$121;
      var $124=(($122-$123)|0);
      var $125=(($124)|0) < 2;
      if ($125) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $126
      $1=-2;
      __label__ = 55; break;
    case 28: // $127
      var $128=$2;
      var $129=$128;
      var $130=(($129+332)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$2;
      var $133=$3;
      var $134=FUNCTION_TABLE[$131]($132, $133);
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $136
      var $137=$3;
      var $138=$5;
      HEAP32[(($138)>>2)]=$137;
      $1=0;
      __label__ = 55; break;
    case 30: // $139
      var $140=$3;
      var $141=(($140+2)|0);
      $3=$141;
      __label__ = 53; break;
    case 31: // $142
      var $143=$4;
      var $144=$3;
      var $145=$143;
      var $146=$144;
      var $147=(($145-$146)|0);
      var $148=(($147)|0) < 3;
      if ($148) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $149
      $1=-2;
      __label__ = 55; break;
    case 33: // $150
      var $151=$2;
      var $152=$151;
      var $153=(($152+336)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$2;
      var $156=$3;
      var $157=FUNCTION_TABLE[$154]($155, $156);
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $159
      var $160=$3;
      var $161=$5;
      HEAP32[(($161)>>2)]=$160;
      $1=0;
      __label__ = 55; break;
    case 35: // $162
      var $163=$3;
      var $164=(($163+3)|0);
      $3=$164;
      __label__ = 53; break;
    case 36: // $165
      var $166=$4;
      var $167=$3;
      var $168=$166;
      var $169=$167;
      var $170=(($168-$169)|0);
      var $171=(($170)|0) < 4;
      if ($171) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $172
      $1=-2;
      __label__ = 55; break;
    case 38: // $173
      var $174=$2;
      var $175=$174;
      var $176=(($175+340)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$2;
      var $179=$3;
      var $180=FUNCTION_TABLE[$177]($178, $179);
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $182
      var $183=$3;
      var $184=$5;
      HEAP32[(($184)>>2)]=$183;
      $1=0;
      __label__ = 55; break;
    case 40: // $185
      var $186=$3;
      var $187=(($186+4)|0);
      $3=$187;
      __label__ = 53; break;
    case 41: // $188
      var $189=$3;
      var $190=(($189+1)|0);
      $3=$190;
      __label__ = 42; break;
    case 42: // $191
      var $192=$3;
      var $193=$4;
      var $194=(($192)|0)!=(($193)|0);
      if ($194) { __label__ = 43; break; } else { __label__ = 49; break; }
    case 43: // $195
      var $196=$3;
      var $197=HEAPU8[($196)];
      var $198=(($197)&255);
      var $199=$2;
      var $200=$199;
      var $201=(($200+76)|0);
      var $202=(($201+$198)|0);
      var $203=HEAPU8[($202)];
      var $204=(($203)&255);
      if ($204 == 21 || $204 == 9 || $204 == 10) {
        __label__ = 44; break;
      }
      else if ($204 == 11) {
        __label__ = 45; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 44: // $205
      __label__ = 47; break;
    case 45: // $206
      var $207=$3;
      var $208=(($207+1)|0);
      var $209=$5;
      HEAP32[(($209)>>2)]=$208;
      $1=5;
      __label__ = 55; break;
    case 46: // $210
      var $211=$3;
      var $212=$5;
      HEAP32[(($212)>>2)]=$211;
      $1=0;
      __label__ = 55; break;
    case 47: // $213
      __label__ = 48; break;
    case 48: // $214
      var $215=$3;
      var $216=(($215+1)|0);
      $3=$216;
      __label__ = 42; break;
    case 49: // $217
      $1=-1;
      __label__ = 55; break;
    case 50: // $218
      var $219=$3;
      var $220=(($219+1)|0);
      $3=$220;
      __label__ = 53; break;
    case 51: // $221
      var $222=$3;
      var $223=(($222+1)|0);
      var $224=$5;
      HEAP32[(($224)>>2)]=$223;
      $1=5;
      __label__ = 55; break;
    case 52: // $225
      var $226=$3;
      var $227=$5;
      HEAP32[(($227)>>2)]=$226;
      $1=0;
      __label__ = 55; break;
    case 53: // $228
      __label__ = 22; break;
    case 54: // $229
      $1=-1;
      __label__ = 55; break;
    case 55: // $230
      var $231=$1;
      ;
      return $231;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL17normal_scanEndTagPK8encodingPKcS3_PS3_["X"]=1;

function __ZL15normal_scanAttsPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $hadColon;
      var $t;
      var $open;
      var $t1;
      var $tok;
      $2=$enc;
      HEAP32[(($3)>>2)]=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      $hadColon=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=HEAP32[(($3)>>2)];
      var $8=$4;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 136; break; }
    case 2: // $10
      var $11=HEAP32[(($3)>>2)];
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 29) {
        __label__ = 3; break;
      }
      else if ($19 == 22 || $19 == 24 || $19 == 25 || $19 == 26 || $19 == 27) {
        __label__ = 4; break;
      }
      else if ($19 == 5) {
        __label__ = 5; break;
      }
      else if ($19 == 6) {
        __label__ = 10; break;
      }
      else if ($19 == 7) {
        __label__ = 15; break;
      }
      else if ($19 == 23) {
        __label__ = 20; break;
      }
      else if ($19 == 21 || $19 == 9 || $19 == 10) {
        __label__ = 44; break;
      }
      else if ($19 == 14) {
        __label__ = 54; break;
      }
      else {
      __label__ = 134; break;
      }
      
    case 3: // $20
      var $21=HEAP32[(($3)>>2)];
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 137; break;
    case 4: // $23
      var $24=HEAP32[(($3)>>2)];
      var $25=(($24+1)|0);
      HEAP32[(($3)>>2)]=$25;
      __label__ = 135; break;
    case 5: // $26
      var $27=$4;
      var $28=HEAP32[(($3)>>2)];
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0) < 2;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=-2;
      __label__ = 137; break;
    case 7: // $34
      var $35=$2;
      var $36=$35;
      var $37=(($36+332)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=HEAP32[(($3)>>2)];
      var $41=FUNCTION_TABLE[$38]($39, $40);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=HEAP32[(($3)>>2)];
      var $45=$5;
      HEAP32[(($45)>>2)]=$44;
      $1=0;
      __label__ = 137; break;
    case 9: // $46
      var $47=HEAP32[(($3)>>2)];
      var $48=(($47+2)|0);
      HEAP32[(($3)>>2)]=$48;
      __label__ = 135; break;
    case 10: // $49
      var $50=$4;
      var $51=HEAP32[(($3)>>2)];
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      $1=-2;
      __label__ = 137; break;
    case 12: // $57
      var $58=$2;
      var $59=$58;
      var $60=(($59+336)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=HEAP32[(($3)>>2)];
      var $64=FUNCTION_TABLE[$61]($62, $63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=HEAP32[(($3)>>2)];
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 137; break;
    case 14: // $69
      var $70=HEAP32[(($3)>>2)];
      var $71=(($70+3)|0);
      HEAP32[(($3)>>2)]=$71;
      __label__ = 135; break;
    case 15: // $72
      var $73=$4;
      var $74=HEAP32[(($3)>>2)];
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 4;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $1=-2;
      __label__ = 137; break;
    case 17: // $80
      var $81=$2;
      var $82=$81;
      var $83=(($82+340)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=HEAP32[(($3)>>2)];
      var $87=FUNCTION_TABLE[$84]($85, $86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=HEAP32[(($3)>>2)];
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 137; break;
    case 19: // $92
      var $93=HEAP32[(($3)>>2)];
      var $94=(($93+4)|0);
      HEAP32[(($3)>>2)]=$94;
      __label__ = 135; break;
    case 20: // $95
      var $96=$hadColon;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $98
      var $99=HEAP32[(($3)>>2)];
      var $100=$5;
      HEAP32[(($100)>>2)]=$99;
      $1=0;
      __label__ = 137; break;
    case 22: // $101
      $hadColon=1;
      var $102=HEAP32[(($3)>>2)];
      var $103=(($102+1)|0);
      HEAP32[(($3)>>2)]=$103;
      var $104=HEAP32[(($3)>>2)];
      var $105=$4;
      var $106=(($104)|0)==(($105)|0);
      if ($106) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $107
      $1=-1;
      __label__ = 137; break;
    case 24: // $108
      var $109=HEAP32[(($3)>>2)];
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$2;
      var $113=$112;
      var $114=(($113+76)|0);
      var $115=(($114+$111)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      if ($117 == 29) {
        __label__ = 25; break;
      }
      else if ($117 == 22 || $117 == 24) {
        __label__ = 26; break;
      }
      else if ($117 == 5) {
        __label__ = 27; break;
      }
      else if ($117 == 6) {
        __label__ = 32; break;
      }
      else if ($117 == 7) {
        __label__ = 37; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 25: // $118
      var $119=HEAP32[(($3)>>2)];
      var $120=$5;
      HEAP32[(($120)>>2)]=$119;
      $1=0;
      __label__ = 137; break;
    case 26: // $121
      var $122=HEAP32[(($3)>>2)];
      var $123=(($122+1)|0);
      HEAP32[(($3)>>2)]=$123;
      __label__ = 43; break;
    case 27: // $124
      var $125=$4;
      var $126=HEAP32[(($3)>>2)];
      var $127=$125;
      var $128=$126;
      var $129=(($127-$128)|0);
      var $130=(($129)|0) < 2;
      if ($130) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $131
      $1=-2;
      __label__ = 137; break;
    case 29: // $132
      var $133=$2;
      var $134=$133;
      var $135=(($134+344)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=$2;
      var $138=HEAP32[(($3)>>2)];
      var $139=FUNCTION_TABLE[$136]($137, $138);
      var $140=(($139)|0)!=0;
      if ($140) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $141
      var $142=HEAP32[(($3)>>2)];
      var $143=$5;
      HEAP32[(($143)>>2)]=$142;
      $1=0;
      __label__ = 137; break;
    case 31: // $144
      var $145=HEAP32[(($3)>>2)];
      var $146=(($145+2)|0);
      HEAP32[(($3)>>2)]=$146;
      __label__ = 43; break;
    case 32: // $147
      var $148=$4;
      var $149=HEAP32[(($3)>>2)];
      var $150=$148;
      var $151=$149;
      var $152=(($150-$151)|0);
      var $153=(($152)|0) < 3;
      if ($153) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $154
      $1=-2;
      __label__ = 137; break;
    case 34: // $155
      var $156=$2;
      var $157=$156;
      var $158=(($157+348)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=$2;
      var $161=HEAP32[(($3)>>2)];
      var $162=FUNCTION_TABLE[$159]($160, $161);
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 36; break; } else { __label__ = 35; break; }
    case 35: // $164
      var $165=HEAP32[(($3)>>2)];
      var $166=$5;
      HEAP32[(($166)>>2)]=$165;
      $1=0;
      __label__ = 137; break;
    case 36: // $167
      var $168=HEAP32[(($3)>>2)];
      var $169=(($168+3)|0);
      HEAP32[(($3)>>2)]=$169;
      __label__ = 43; break;
    case 37: // $170
      var $171=$4;
      var $172=HEAP32[(($3)>>2)];
      var $173=$171;
      var $174=$172;
      var $175=(($173-$174)|0);
      var $176=(($175)|0) < 4;
      if ($176) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $177
      $1=-2;
      __label__ = 137; break;
    case 39: // $178
      var $179=$2;
      var $180=$179;
      var $181=(($180+352)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$2;
      var $184=HEAP32[(($3)>>2)];
      var $185=FUNCTION_TABLE[$182]($183, $184);
      var $186=(($185)|0)!=0;
      if ($186) { __label__ = 41; break; } else { __label__ = 40; break; }
    case 40: // $187
      var $188=HEAP32[(($3)>>2)];
      var $189=$5;
      HEAP32[(($189)>>2)]=$188;
      $1=0;
      __label__ = 137; break;
    case 41: // $190
      var $191=HEAP32[(($3)>>2)];
      var $192=(($191+4)|0);
      HEAP32[(($3)>>2)]=$192;
      __label__ = 43; break;
    case 42: // $193
      var $194=HEAP32[(($3)>>2)];
      var $195=$5;
      HEAP32[(($195)>>2)]=$194;
      $1=0;
      __label__ = 137; break;
    case 43: // $196
      __label__ = 135; break;
    case 44: // $197
      __label__ = 45; break;
    case 45: // $198
      var $199=HEAP32[(($3)>>2)];
      var $200=(($199+1)|0);
      HEAP32[(($3)>>2)]=$200;
      var $201=HEAP32[(($3)>>2)];
      var $202=$4;
      var $203=(($201)|0)==(($202)|0);
      if ($203) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $204
      $1=-1;
      __label__ = 137; break;
    case 47: // $205
      var $206=HEAP32[(($3)>>2)];
      var $207=HEAPU8[($206)];
      var $208=(($207)&255);
      var $209=$2;
      var $210=$209;
      var $211=(($210+76)|0);
      var $212=(($211+$208)|0);
      var $213=HEAPU8[($212)];
      var $214=(($213)&255);
      $t=$214;
      var $215=$t;
      var $216=(($215)|0)==14;
      if ($216) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $217
      __label__ = 53; break;
    case 49: // $218
      var $219=$t;
      if ($219 == 21 || $219 == 10 || $219 == 9) {
        __label__ = 50; break;
      }
      else {
      __label__ = 51; break;
      }
      
    case 50: // $220
      __label__ = 52; break;
    case 51: // $221
      var $222=HEAP32[(($3)>>2)];
      var $223=$5;
      HEAP32[(($223)>>2)]=$222;
      $1=0;
      __label__ = 137; break;
    case 52: // $224
      __label__ = 45; break;
    case 53: // $225
      __label__ = 54; break;
    case 54: // $226
      $hadColon=0;
      __label__ = 55; break;
    case 55: // $227
      var $228=HEAP32[(($3)>>2)];
      var $229=(($228+1)|0);
      HEAP32[(($3)>>2)]=$229;
      var $230=HEAP32[(($3)>>2)];
      var $231=$4;
      var $232=(($230)|0)==(($231)|0);
      if ($232) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $233
      $1=-1;
      __label__ = 137; break;
    case 57: // $234
      var $235=HEAP32[(($3)>>2)];
      var $236=HEAPU8[($235)];
      var $237=(($236)&255);
      var $238=$2;
      var $239=$238;
      var $240=(($239+76)|0);
      var $241=(($240+$237)|0);
      var $242=HEAPU8[($241)];
      var $243=(($242)&255);
      $open=$243;
      var $244=$open;
      var $245=(($244)|0)==12;
      if ($245) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $246
      var $247=$open;
      var $248=(($247)|0)==13;
      if ($248) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $249
      __label__ = 64; break;
    case 60: // $250
      var $251=$open;
      if ($251 == 21 || $251 == 10 || $251 == 9) {
        __label__ = 61; break;
      }
      else {
      __label__ = 62; break;
      }
      
    case 61: // $252
      __label__ = 63; break;
    case 62: // $253
      var $254=HEAP32[(($3)>>2)];
      var $255=$5;
      HEAP32[(($255)>>2)]=$254;
      $1=0;
      __label__ = 137; break;
    case 63: // $256
      __label__ = 55; break;
    case 64: // $257
      var $258=HEAP32[(($3)>>2)];
      var $259=(($258+1)|0);
      HEAP32[(($3)>>2)]=$259;
      __label__ = 65; break;
    case 65: // $260
      var $261=HEAP32[(($3)>>2)];
      var $262=$4;
      var $263=(($261)|0)==(($262)|0);
      if ($263) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $264
      $1=-1;
      __label__ = 137; break;
    case 67: // $265
      var $266=HEAP32[(($3)>>2)];
      var $267=HEAPU8[($266)];
      var $268=(($267)&255);
      var $269=$2;
      var $270=$269;
      var $271=(($270+76)|0);
      var $272=(($271+$268)|0);
      var $273=HEAPU8[($272)];
      var $274=(($273)&255);
      $t1=$274;
      var $275=$t1;
      var $276=$open;
      var $277=(($275)|0)==(($276)|0);
      if ($277) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $278
      __label__ = 94; break;
    case 69: // $279
      var $280=$t1;
      if ($280 == 5) {
        __label__ = 70; break;
      }
      else if ($280 == 6) {
        __label__ = 75; break;
      }
      else if ($280 == 7) {
        __label__ = 80; break;
      }
      else if ($280 == 0 || $280 == 1 || $280 == 8) {
        __label__ = 85; break;
      }
      else if ($280 == 3) {
        __label__ = 86; break;
      }
      else if ($280 == 2) {
        __label__ = 91; break;
      }
      else {
      __label__ = 92; break;
      }
      
    case 70: // $281
      var $282=$4;
      var $283=HEAP32[(($3)>>2)];
      var $284=$282;
      var $285=$283;
      var $286=(($284-$285)|0);
      var $287=(($286)|0) < 2;
      if ($287) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $288
      $1=-2;
      __label__ = 137; break;
    case 72: // $289
      var $290=$2;
      var $291=$290;
      var $292=(($291+356)|0);
      var $293=HEAP32[(($292)>>2)];
      var $294=$2;
      var $295=HEAP32[(($3)>>2)];
      var $296=FUNCTION_TABLE[$293]($294, $295);
      var $297=(($296)|0)!=0;
      if ($297) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $298
      var $299=HEAP32[(($3)>>2)];
      var $300=$5;
      HEAP32[(($300)>>2)]=$299;
      $1=0;
      __label__ = 137; break;
    case 74: // $301
      var $302=HEAP32[(($3)>>2)];
      var $303=(($302+2)|0);
      HEAP32[(($3)>>2)]=$303;
      __label__ = 93; break;
    case 75: // $304
      var $305=$4;
      var $306=HEAP32[(($3)>>2)];
      var $307=$305;
      var $308=$306;
      var $309=(($307-$308)|0);
      var $310=(($309)|0) < 3;
      if ($310) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $311
      $1=-2;
      __label__ = 137; break;
    case 77: // $312
      var $313=$2;
      var $314=$313;
      var $315=(($314+360)|0);
      var $316=HEAP32[(($315)>>2)];
      var $317=$2;
      var $318=HEAP32[(($3)>>2)];
      var $319=FUNCTION_TABLE[$316]($317, $318);
      var $320=(($319)|0)!=0;
      if ($320) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $321
      var $322=HEAP32[(($3)>>2)];
      var $323=$5;
      HEAP32[(($323)>>2)]=$322;
      $1=0;
      __label__ = 137; break;
    case 79: // $324
      var $325=HEAP32[(($3)>>2)];
      var $326=(($325+3)|0);
      HEAP32[(($3)>>2)]=$326;
      __label__ = 93; break;
    case 80: // $327
      var $328=$4;
      var $329=HEAP32[(($3)>>2)];
      var $330=$328;
      var $331=$329;
      var $332=(($330-$331)|0);
      var $333=(($332)|0) < 4;
      if ($333) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $334
      $1=-2;
      __label__ = 137; break;
    case 82: // $335
      var $336=$2;
      var $337=$336;
      var $338=(($337+364)|0);
      var $339=HEAP32[(($338)>>2)];
      var $340=$2;
      var $341=HEAP32[(($3)>>2)];
      var $342=FUNCTION_TABLE[$339]($340, $341);
      var $343=(($342)|0)!=0;
      if ($343) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $344
      var $345=HEAP32[(($3)>>2)];
      var $346=$5;
      HEAP32[(($346)>>2)]=$345;
      $1=0;
      __label__ = 137; break;
    case 84: // $347
      var $348=HEAP32[(($3)>>2)];
      var $349=(($348+4)|0);
      HEAP32[(($3)>>2)]=$349;
      __label__ = 93; break;
    case 85: // $350
      var $351=HEAP32[(($3)>>2)];
      var $352=$5;
      HEAP32[(($352)>>2)]=$351;
      $1=0;
      __label__ = 137; break;
    case 86: // $353
      var $354=$2;
      var $355=HEAP32[(($3)>>2)];
      var $356=(($355+1)|0);
      var $357=$4;
      var $358=__ZL14normal_scanRefPK8encodingPKcS3_PS3_($354, $356, $357, $3);
      $tok=$358;
      var $359=$tok;
      var $360=(($359)|0) <= 0;
      if ($360) { __label__ = 87; break; } else { __label__ = 90; break; }
    case 87: // $361
      var $362=$tok;
      var $363=(($362)|0)==0;
      if ($363) { __label__ = 88; break; } else { __label__ = 89; break; }
    case 88: // $364
      var $365=HEAP32[(($3)>>2)];
      var $366=$5;
      HEAP32[(($366)>>2)]=$365;
      __label__ = 89; break;
    case 89: // $367
      var $368=$tok;
      $1=$368;
      __label__ = 137; break;
    case 90: // $369
      __label__ = 93; break;
    case 91: // $370
      var $371=HEAP32[(($3)>>2)];
      var $372=$5;
      HEAP32[(($372)>>2)]=$371;
      $1=0;
      __label__ = 137; break;
    case 92: // $373
      var $374=HEAP32[(($3)>>2)];
      var $375=(($374+1)|0);
      HEAP32[(($3)>>2)]=$375;
      __label__ = 93; break;
    case 93: // $376
      __label__ = 65; break;
    case 94: // $377
      var $378=HEAP32[(($3)>>2)];
      var $379=(($378+1)|0);
      HEAP32[(($3)>>2)]=$379;
      var $380=HEAP32[(($3)>>2)];
      var $381=$4;
      var $382=(($380)|0)==(($381)|0);
      if ($382) { __label__ = 95; break; } else { __label__ = 96; break; }
    case 95: // $383
      $1=-1;
      __label__ = 137; break;
    case 96: // $384
      var $385=HEAP32[(($3)>>2)];
      var $386=HEAPU8[($385)];
      var $387=(($386)&255);
      var $388=$2;
      var $389=$388;
      var $390=(($389+76)|0);
      var $391=(($390+$387)|0);
      var $392=HEAPU8[($391)];
      var $393=(($392)&255);
      if ($393 == 21 || $393 == 9 || $393 == 10) {
        __label__ = 97; break;
      }
      else if ($393 == 17) {
        __label__ = 98; break;
      }
      else if ($393 == 11) {
        __label__ = 99; break;
      }
      else {
      __label__ = 100; break;
      }
      
    case 97: // $394
      __label__ = 101; break;
    case 98: // $395
      __label__ = 126; break;
    case 99: // $396
      __label__ = 124; break;
    case 100: // $397
      var $398=HEAP32[(($3)>>2)];
      var $399=$5;
      HEAP32[(($399)>>2)]=$398;
      $1=0;
      __label__ = 137; break;
    case 101: // $400
      __label__ = 102; break;
    case 102: // $401
      var $402=HEAP32[(($3)>>2)];
      var $403=(($402+1)|0);
      HEAP32[(($3)>>2)]=$403;
      var $404=HEAP32[(($3)>>2)];
      var $405=$4;
      var $406=(($404)|0)==(($405)|0);
      if ($406) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $407
      $1=-1;
      __label__ = 137; break;
    case 104: // $408
      var $409=HEAP32[(($3)>>2)];
      var $410=HEAPU8[($409)];
      var $411=(($410)&255);
      var $412=$2;
      var $413=$412;
      var $414=(($413+76)|0);
      var $415=(($414+$411)|0);
      var $416=HEAPU8[($415)];
      var $417=(($416)&255);
      if ($417 == 29) {
        __label__ = 105; break;
      }
      else if ($417 == 22 || $417 == 24) {
        __label__ = 106; break;
      }
      else if ($417 == 5) {
        __label__ = 107; break;
      }
      else if ($417 == 6) {
        __label__ = 112; break;
      }
      else if ($417 == 7) {
        __label__ = 117; break;
      }
      else if ($417 == 21 || $417 == 9 || $417 == 10) {
        __label__ = 122; break;
      }
      else if ($417 == 11) {
        __label__ = 123; break;
      }
      else if ($417 == 17) {
        __label__ = 125; break;
      }
      else {
      __label__ = 131; break;
      }
      
    case 105: // $418
      var $419=HEAP32[(($3)>>2)];
      var $420=$5;
      HEAP32[(($420)>>2)]=$419;
      $1=0;
      __label__ = 137; break;
    case 106: // $421
      var $422=HEAP32[(($3)>>2)];
      var $423=(($422+1)|0);
      HEAP32[(($3)>>2)]=$423;
      __label__ = 132; break;
    case 107: // $424
      var $425=$4;
      var $426=HEAP32[(($3)>>2)];
      var $427=$425;
      var $428=$426;
      var $429=(($427-$428)|0);
      var $430=(($429)|0) < 2;
      if ($430) { __label__ = 108; break; } else { __label__ = 109; break; }
    case 108: // $431
      $1=-2;
      __label__ = 137; break;
    case 109: // $432
      var $433=$2;
      var $434=$433;
      var $435=(($434+344)|0);
      var $436=HEAP32[(($435)>>2)];
      var $437=$2;
      var $438=HEAP32[(($3)>>2)];
      var $439=FUNCTION_TABLE[$436]($437, $438);
      var $440=(($439)|0)!=0;
      if ($440) { __label__ = 111; break; } else { __label__ = 110; break; }
    case 110: // $441
      var $442=HEAP32[(($3)>>2)];
      var $443=$5;
      HEAP32[(($443)>>2)]=$442;
      $1=0;
      __label__ = 137; break;
    case 111: // $444
      var $445=HEAP32[(($3)>>2)];
      var $446=(($445+2)|0);
      HEAP32[(($3)>>2)]=$446;
      __label__ = 132; break;
    case 112: // $447
      var $448=$4;
      var $449=HEAP32[(($3)>>2)];
      var $450=$448;
      var $451=$449;
      var $452=(($450-$451)|0);
      var $453=(($452)|0) < 3;
      if ($453) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $454
      $1=-2;
      __label__ = 137; break;
    case 114: // $455
      var $456=$2;
      var $457=$456;
      var $458=(($457+348)|0);
      var $459=HEAP32[(($458)>>2)];
      var $460=$2;
      var $461=HEAP32[(($3)>>2)];
      var $462=FUNCTION_TABLE[$459]($460, $461);
      var $463=(($462)|0)!=0;
      if ($463) { __label__ = 116; break; } else { __label__ = 115; break; }
    case 115: // $464
      var $465=HEAP32[(($3)>>2)];
      var $466=$5;
      HEAP32[(($466)>>2)]=$465;
      $1=0;
      __label__ = 137; break;
    case 116: // $467
      var $468=HEAP32[(($3)>>2)];
      var $469=(($468+3)|0);
      HEAP32[(($3)>>2)]=$469;
      __label__ = 132; break;
    case 117: // $470
      var $471=$4;
      var $472=HEAP32[(($3)>>2)];
      var $473=$471;
      var $474=$472;
      var $475=(($473-$474)|0);
      var $476=(($475)|0) < 4;
      if ($476) { __label__ = 118; break; } else { __label__ = 119; break; }
    case 118: // $477
      $1=-2;
      __label__ = 137; break;
    case 119: // $478
      var $479=$2;
      var $480=$479;
      var $481=(($480+352)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=$2;
      var $484=HEAP32[(($3)>>2)];
      var $485=FUNCTION_TABLE[$482]($483, $484);
      var $486=(($485)|0)!=0;
      if ($486) { __label__ = 121; break; } else { __label__ = 120; break; }
    case 120: // $487
      var $488=HEAP32[(($3)>>2)];
      var $489=$5;
      HEAP32[(($489)>>2)]=$488;
      $1=0;
      __label__ = 137; break;
    case 121: // $490
      var $491=HEAP32[(($3)>>2)];
      var $492=(($491+4)|0);
      HEAP32[(($3)>>2)]=$492;
      __label__ = 132; break;
    case 122: // $493
      __label__ = 102; break;
    case 123: // $494
      __label__ = 124; break;
    case 124: // $495
      var $496=HEAP32[(($3)>>2)];
      var $497=(($496+1)|0);
      var $498=$5;
      HEAP32[(($498)>>2)]=$497;
      $1=1;
      __label__ = 137; break;
    case 125: // $499
      __label__ = 126; break;
    case 126: // $500
      var $501=HEAP32[(($3)>>2)];
      var $502=(($501+1)|0);
      HEAP32[(($3)>>2)]=$502;
      var $503=HEAP32[(($3)>>2)];
      var $504=$4;
      var $505=(($503)|0)==(($504)|0);
      if ($505) { __label__ = 127; break; } else { __label__ = 128; break; }
    case 127: // $506
      $1=-1;
      __label__ = 137; break;
    case 128: // $507
      var $508=HEAP32[(($3)>>2)];
      var $509=HEAP8[($508)];
      var $510=(($509 << 24) >> 24);
      var $511=(($510)|0)==62;
      if ($511) { __label__ = 130; break; } else { __label__ = 129; break; }
    case 129: // $512
      var $513=HEAP32[(($3)>>2)];
      var $514=$5;
      HEAP32[(($514)>>2)]=$513;
      $1=0;
      __label__ = 137; break;
    case 130: // $515
      var $516=HEAP32[(($3)>>2)];
      var $517=(($516+1)|0);
      var $518=$5;
      HEAP32[(($518)>>2)]=$517;
      $1=3;
      __label__ = 137; break;
    case 131: // $519
      var $520=HEAP32[(($3)>>2)];
      var $521=$5;
      HEAP32[(($521)>>2)]=$520;
      $1=0;
      __label__ = 137; break;
    case 132: // $522
      __label__ = 133; break;
    case 133: // $523
      __label__ = 135; break;
    case 134: // $524
      var $525=HEAP32[(($3)>>2)];
      var $526=$5;
      HEAP32[(($526)>>2)]=$525;
      $1=0;
      __label__ = 137; break;
    case 135: // $527
      __label__ = 1; break;
    case 136: // $528
      $1=-1;
      __label__ = 137; break;
    case 137: // $529
      var $530=$1;
      STACKTOP = __stackBase__;
      return $530;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15normal_scanAttsPK8encodingPKcS3_PS3_["X"]=1;

function __ZL20normal_checkPiTargetPK8encodingPKcS3_Pi($enc, $ptr, $end, $tokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $upper;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$tokPtr;
      $upper=0;
      var $6=$5;
      HEAP32[(($6)>>2)]=11;
      var $7=$4;
      var $8=$3;
      var $9=$7;
      var $10=$8;
      var $11=(($9-$10)|0);
      var $12=(($11)|0)!=3;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $1=1;
      __label__ = 14; break;
    case 2: // $14
      var $15=$3;
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      if ($17 == 120) {
        __label__ = 5; break;
      }
      else if ($17 == 88) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 3: // $18
      $upper=1;
      __label__ = 5; break;
    case 4: // $19
      $1=1;
      __label__ = 14; break;
    case 5: // $20
      var $21=$3;
      var $22=(($21+1)|0);
      $3=$22;
      var $23=$3;
      var $24=HEAP8[($23)];
      var $25=(($24 << 24) >> 24);
      if ($25 == 109) {
        __label__ = 8; break;
      }
      else if ($25 == 77) {
        __label__ = 6; break;
      }
      else {
      __label__ = 7; break;
      }
      
    case 6: // $26
      $upper=1;
      __label__ = 8; break;
    case 7: // $27
      $1=1;
      __label__ = 14; break;
    case 8: // $28
      var $29=$3;
      var $30=(($29+1)|0);
      $3=$30;
      var $31=$3;
      var $32=HEAP8[($31)];
      var $33=(($32 << 24) >> 24);
      if ($33 == 108) {
        __label__ = 11; break;
      }
      else if ($33 == 76) {
        __label__ = 9; break;
      }
      else {
      __label__ = 10; break;
      }
      
    case 9: // $34
      $upper=1;
      __label__ = 11; break;
    case 10: // $35
      $1=1;
      __label__ = 14; break;
    case 11: // $36
      var $37=$upper;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $39
      $1=0;
      __label__ = 14; break;
    case 13: // $40
      var $41=$5;
      HEAP32[(($41)>>2)]=12;
      $1=1;
      __label__ = 14; break;
    case 14: // $42
      var $43=$1;
      ;
      return $43;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20normal_checkPiTargetPK8encodingPKcS3_Pi["X"]=1;

function __ZL14normal_scanLitiPK8encodingPKcS3_PS3_($open, $enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $t;
      $2=$open;
      $3=$enc;
      $4=$ptr;
      $5=$end;
      $6=$nextTokPtr;
      __label__ = 1; break;
    case 1: // $7
      var $8=$4;
      var $9=$5;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 28; break; }
    case 2: // $11
      var $12=$4;
      var $13=HEAPU8[($12)];
      var $14=(($13)&255);
      var $15=$3;
      var $16=$15;
      var $17=(($16+76)|0);
      var $18=(($17+$14)|0);
      var $19=HEAPU8[($18)];
      var $20=(($19)&255);
      $t=$20;
      var $21=$t;
      if ($21 == 5) {
        __label__ = 3; break;
      }
      else if ($21 == 6) {
        __label__ = 8; break;
      }
      else if ($21 == 7) {
        __label__ = 13; break;
      }
      else if ($21 == 0 || $21 == 1 || $21 == 8) {
        __label__ = 18; break;
      }
      else if ($21 == 12 || $21 == 13) {
        __label__ = 19; break;
      }
      else {
      __label__ = 26; break;
      }
      
    case 3: // $22
      var $23=$5;
      var $24=$4;
      var $25=$23;
      var $26=$24;
      var $27=(($25-$26)|0);
      var $28=(($27)|0) < 2;
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $29
      $1=-2;
      __label__ = 29; break;
    case 5: // $30
      var $31=$3;
      var $32=$31;
      var $33=(($32+356)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$3;
      var $36=$4;
      var $37=FUNCTION_TABLE[$34]($35, $36);
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $39
      var $40=$4;
      var $41=$6;
      HEAP32[(($41)>>2)]=$40;
      $1=0;
      __label__ = 29; break;
    case 7: // $42
      var $43=$4;
      var $44=(($43+2)|0);
      $4=$44;
      __label__ = 27; break;
    case 8: // $45
      var $46=$5;
      var $47=$4;
      var $48=$46;
      var $49=$47;
      var $50=(($48-$49)|0);
      var $51=(($50)|0) < 3;
      if ($51) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $52
      $1=-2;
      __label__ = 29; break;
    case 10: // $53
      var $54=$3;
      var $55=$54;
      var $56=(($55+360)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$3;
      var $59=$4;
      var $60=FUNCTION_TABLE[$57]($58, $59);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $62
      var $63=$4;
      var $64=$6;
      HEAP32[(($64)>>2)]=$63;
      $1=0;
      __label__ = 29; break;
    case 12: // $65
      var $66=$4;
      var $67=(($66+3)|0);
      $4=$67;
      __label__ = 27; break;
    case 13: // $68
      var $69=$5;
      var $70=$4;
      var $71=$69;
      var $72=$70;
      var $73=(($71-$72)|0);
      var $74=(($73)|0) < 4;
      if ($74) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $75
      $1=-2;
      __label__ = 29; break;
    case 15: // $76
      var $77=$3;
      var $78=$77;
      var $79=(($78+364)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$3;
      var $82=$4;
      var $83=FUNCTION_TABLE[$80]($81, $82);
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $85
      var $86=$4;
      var $87=$6;
      HEAP32[(($87)>>2)]=$86;
      $1=0;
      __label__ = 29; break;
    case 17: // $88
      var $89=$4;
      var $90=(($89+4)|0);
      $4=$90;
      __label__ = 27; break;
    case 18: // $91
      var $92=$4;
      var $93=$6;
      HEAP32[(($93)>>2)]=$92;
      $1=0;
      __label__ = 29; break;
    case 19: // $94
      var $95=$4;
      var $96=(($95+1)|0);
      $4=$96;
      var $97=$t;
      var $98=$2;
      var $99=(($97)|0)!=(($98)|0);
      if ($99) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $100
      __label__ = 27; break;
    case 21: // $101
      var $102=$4;
      var $103=$5;
      var $104=(($102)|0)==(($103)|0);
      if ($104) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $105
      $1=-27;
      __label__ = 29; break;
    case 23: // $106
      var $107=$4;
      var $108=$6;
      HEAP32[(($108)>>2)]=$107;
      var $109=$4;
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$3;
      var $113=$112;
      var $114=(($113+76)|0);
      var $115=(($114+$111)|0);
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      if ($117 == 21 || $117 == 9 || $117 == 10 || $117 == 11 || $117 == 30 || $117 == 20) {
        __label__ = 24; break;
      }
      else {
      __label__ = 25; break;
      }
      
    case 24: // $118
      $1=27;
      __label__ = 29; break;
    case 25: // $119
      $1=0;
      __label__ = 29; break;
    case 26: // $120
      var $121=$4;
      var $122=(($121+1)|0);
      $4=$122;
      __label__ = 27; break;
    case 27: // $123
      __label__ = 1; break;
    case 28: // $124
      $1=-1;
      __label__ = 29; break;
    case 29: // $125
      var $126=$1;
      ;
      return $126;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL14normal_scanLitiPK8encodingPKcS3_PS3_["X"]=1;

function __ZL15normal_scanDeclPK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 20; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 27) {
        __label__ = 3; break;
      }
      else if ($19 == 20) {
        __label__ = 4; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 5; break;
      }
      else {
      __label__ = 6; break;
      }
      
    case 3: // $20
      var $21=$2;
      var $22=$3;
      var $23=(($22+1)|0);
      var $24=$4;
      var $25=$5;
      var $26=__ZL18normal_scanCommentPK8encodingPKcS3_PS3_($21, $23, $24, $25);
      $1=$26;
      __label__ = 20; break;
    case 4: // $27
      var $28=$3;
      var $29=(($28+1)|0);
      var $30=$5;
      HEAP32[(($30)>>2)]=$29;
      $1=33;
      __label__ = 20; break;
    case 5: // $31
      var $32=$3;
      var $33=(($32+1)|0);
      $3=$33;
      __label__ = 7; break;
    case 6: // $34
      var $35=$3;
      var $36=$5;
      HEAP32[(($36)>>2)]=$35;
      $1=0;
      __label__ = 20; break;
    case 7: // $37
      __label__ = 8; break;
    case 8: // $38
      var $39=$3;
      var $40=$4;
      var $41=(($39)|0)!=(($40)|0);
      if ($41) { __label__ = 9; break; } else { __label__ = 19; break; }
    case 9: // $42
      var $43=$3;
      var $44=HEAPU8[($43)];
      var $45=(($44)&255);
      var $46=$2;
      var $47=$46;
      var $48=(($47+76)|0);
      var $49=(($48+$45)|0);
      var $50=HEAPU8[($49)];
      var $51=(($50)&255);
      if ($51 == 30) {
        __label__ = 10; break;
      }
      else if ($51 == 21 || $51 == 9 || $51 == 10) {
        __label__ = 15; break;
      }
      else if ($51 == 22 || $51 == 24) {
        __label__ = 16; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 10: // $52
      var $53=$3;
      var $54=(($53+1)|0);
      var $55=$4;
      var $56=(($54)|0)==(($55)|0);
      if ($56) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $57
      $1=-1;
      __label__ = 20; break;
    case 12: // $58
      var $59=$3;
      var $60=(($59+1)|0);
      var $61=HEAPU8[($60)];
      var $62=(($61)&255);
      var $63=$2;
      var $64=$63;
      var $65=(($64+76)|0);
      var $66=(($65+$62)|0);
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      if ($68 == 21 || $68 == 9 || $68 == 10 || $68 == 30) {
        __label__ = 13; break;
      }
      else {
      __label__ = 14; break;
      }
      
    case 13: // $69
      var $70=$3;
      var $71=$5;
      HEAP32[(($71)>>2)]=$70;
      $1=0;
      __label__ = 20; break;
    case 14: // $72
      __label__ = 15; break;
    case 15: // $73
      var $74=$3;
      var $75=$5;
      HEAP32[(($75)>>2)]=$74;
      $1=16;
      __label__ = 20; break;
    case 16: // $76
      var $77=$3;
      var $78=(($77+1)|0);
      $3=$78;
      __label__ = 18; break;
    case 17: // $79
      var $80=$3;
      var $81=$5;
      HEAP32[(($81)>>2)]=$80;
      $1=0;
      __label__ = 20; break;
    case 18: // $82
      __label__ = 8; break;
    case 19: // $83
      $1=-1;
      __label__ = 20; break;
    case 20: // $84
      var $85=$1;
      ;
      return $85;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15normal_scanDeclPK8encodingPKcS3_PS3_["X"]=1;

function __ZL20normal_scanPoundNamePK8encodingPKcS3_PS3_($enc, $ptr, $end, $nextTokPtr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $2=$enc;
      $3=$ptr;
      $4=$end;
      $5=$nextTokPtr;
      var $6=$3;
      var $7=$4;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=-1;
      __label__ = 45; break;
    case 2: // $10
      var $11=$3;
      var $12=HEAPU8[($11)];
      var $13=(($12)&255);
      var $14=$2;
      var $15=$14;
      var $16=(($15+76)|0);
      var $17=(($16+$13)|0);
      var $18=HEAPU8[($17)];
      var $19=(($18)&255);
      if ($19 == 29) {
        __label__ = 3; break;
      }
      else if ($19 == 22 || $19 == 24) {
        __label__ = 4; break;
      }
      else if ($19 == 5) {
        __label__ = 5; break;
      }
      else if ($19 == 6) {
        __label__ = 10; break;
      }
      else if ($19 == 7) {
        __label__ = 15; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 3: // $20
      var $21=$3;
      var $22=$5;
      HEAP32[(($22)>>2)]=$21;
      $1=0;
      __label__ = 45; break;
    case 4: // $23
      var $24=$3;
      var $25=(($24+1)|0);
      $3=$25;
      __label__ = 21; break;
    case 5: // $26
      var $27=$4;
      var $28=$3;
      var $29=$27;
      var $30=$28;
      var $31=(($29-$30)|0);
      var $32=(($31)|0) < 2;
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=-2;
      __label__ = 45; break;
    case 7: // $34
      var $35=$2;
      var $36=$35;
      var $37=(($36+344)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=$3;
      var $41=FUNCTION_TABLE[$38]($39, $40);
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $43
      var $44=$3;
      var $45=$5;
      HEAP32[(($45)>>2)]=$44;
      $1=0;
      __label__ = 45; break;
    case 9: // $46
      var $47=$3;
      var $48=(($47+2)|0);
      $3=$48;
      __label__ = 21; break;
    case 10: // $49
      var $50=$4;
      var $51=$3;
      var $52=$50;
      var $53=$51;
      var $54=(($52-$53)|0);
      var $55=(($54)|0) < 3;
      if ($55) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $56
      $1=-2;
      __label__ = 45; break;
    case 12: // $57
      var $58=$2;
      var $59=$58;
      var $60=(($59+348)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$2;
      var $63=$3;
      var $64=FUNCTION_TABLE[$61]($62, $63);
      var $65=(($64)|0)!=0;
      if ($65) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $66
      var $67=$3;
      var $68=$5;
      HEAP32[(($68)>>2)]=$67;
      $1=0;
      __label__ = 45; break;
    case 14: // $69
      var $70=$3;
      var $71=(($70+3)|0);
      $3=$71;
      __label__ = 21; break;
    case 15: // $72
      var $73=$4;
      var $74=$3;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=(($77)|0) < 4;
      if ($78) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $79
      $1=-2;
      __label__ = 45; break;
    case 17: // $80
      var $81=$2;
      var $82=$81;
      var $83=(($82+352)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$2;
      var $86=$3;
      var $87=FUNCTION_TABLE[$84]($85, $86);
      var $88=(($87)|0)!=0;
      if ($88) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $89
      var $90=$3;
      var $91=$5;
      HEAP32[(($91)>>2)]=$90;
      $1=0;
      __label__ = 45; break;
    case 19: // $92
      var $93=$3;
      var $94=(($93+4)|0);
      $3=$94;
      __label__ = 21; break;
    case 20: // $95
      var $96=$3;
      var $97=$5;
      HEAP32[(($97)>>2)]=$96;
      $1=0;
      __label__ = 45; break;
    case 21: // $98
      __label__ = 22; break;
    case 22: // $99
      var $100=$3;
      var $101=$4;
      var $102=(($100)|0)!=(($101)|0);
      if ($102) { __label__ = 23; break; } else { __label__ = 44; break; }
    case 23: // $103
      var $104=$3;
      var $105=HEAPU8[($104)];
      var $106=(($105)&255);
      var $107=$2;
      var $108=$107;
      var $109=(($108+76)|0);
      var $110=(($109+$106)|0);
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      if ($112 == 29) {
        __label__ = 24; break;
      }
      else if ($112 == 22 || $112 == 24 || $112 == 25 || $112 == 26 || $112 == 27) {
        __label__ = 25; break;
      }
      else if ($112 == 5) {
        __label__ = 26; break;
      }
      else if ($112 == 6) {
        __label__ = 31; break;
      }
      else if ($112 == 7) {
        __label__ = 36; break;
      }
      else if ($112 == 9 || $112 == 10 || $112 == 21 || $112 == 32 || $112 == 11 || $112 == 30 || $112 == 36) {
        __label__ = 41; break;
      }
      else {
      __label__ = 42; break;
      }
      
    case 24: // $113
      var $114=$3;
      var $115=$5;
      HEAP32[(($115)>>2)]=$114;
      $1=0;
      __label__ = 45; break;
    case 25: // $116
      var $117=$3;
      var $118=(($117+1)|0);
      $3=$118;
      __label__ = 43; break;
    case 26: // $119
      var $120=$4;
      var $121=$3;
      var $122=$120;
      var $123=$121;
      var $124=(($122-$123)|0);
      var $125=(($124)|0) < 2;
      if ($125) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $126
      $1=-2;
      __label__ = 45; break;
    case 28: // $127
      var $128=$2;
      var $129=$128;
      var $130=(($129+332)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$2;
      var $133=$3;
      var $134=FUNCTION_TABLE[$131]($132, $133);
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $136
      var $137=$3;
      var $138=$5;
      HEAP32[(($138)>>2)]=$137;
      $1=0;
      __label__ = 45; break;
    case 30: // $139
      var $140=$3;
      var $141=(($140+2)|0);
      $3=$141;
      __label__ = 43; break;
    case 31: // $142
      var $143=$4;
      var $144=$3;
      var $145=$143;
      var $146=$144;
      var $147=(($145-$146)|0);
      var $148=(($147)|0) < 3;
      if ($148) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $149
      $1=-2;
      __label__ = 45; break;
    case 33: // $150
      var $151=$2;
      var $152=$151;
      var $153=(($152+336)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$2;
      var $156=$3;
      var $157=FUNCTION_TABLE[$154]($155, $156);
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $159
      var $160=$3;
      var $161=$5;
      HEAP32[(($161)>>2)]=$160;
      $1=0;
      __label__ = 45; break;
    case 35: // $162
      var $163=$3;
      var $164=(($163+3)|0);
      $3=$164;
      __label__ = 43; break;
    case 36: // $165
      var $166=$4;
      var $167=$3;
      var $168=$166;
      var $169=$167;
      var $170=(($168-$169)|0);
      var $171=(($170)|0) < 4;
      if ($171) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $172
      $1=-2;
      __label__ = 45; break;
    case 38: // $173
      var $174=$2;
      var $175=$174;
      var $176=(($175+340)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$2;
      var $179=$3;
      var $180=FUNCTION_TABLE[$177]($178, $179);
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $182
      var $183=$3;
      var $184=$5;
      HEAP32[(($184)>>2)]=$183;
      $1=0;
      __label__ = 45; break;
    case 40: // $185
      var $186=$3;
      var $187=(($186+4)|0);
      $3=$187;
      __label__ = 43; break;
    case 41: // $188
      var $189=$3;
      var $190=$5;
      HEAP32[(($190)>>2)]=$189;
      $1=20;
      __label__ = 45; break;
    case 42: // $191
      var $192=$3;
      var $193=$5;
      HEAP32[(($193)>>2)]=$192;
      $1=0;
      __label__ = 45; break;
    case 43: // $194
      __label__ = 22; break;
    case 44: // $195
      $1=-20;
      __label__ = 45; break;
    case 45: // $196
      var $197=$1;
      ;
      return $197;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL20normal_scanPoundNamePK8encodingPKcS3_PS3_["X"]=1;

function __ZL25waveform_bytes_per_samplei($waveform_flags) {
  ;
  var __label__;

  var $1;
  $1=$waveform_flags;
  var $2=$1;
  var $3=$2 & 6;
  var $4=(((($3)|0)/2)|0);
  var $5=1 << $4;
  ;
  return $5;
}


function __ZL10map_doubledyyy($d, $low$0, $low$1, $high$0, $high$1, $value$0, $value$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  var $3=__stackBase__+8;
  var $4=__stackBase__+16;
  $1=$d;
  var $st$5$0=(($2)|0);
  HEAP32[(($st$5$0)>>2)]=$low$0;
  var $st$5$1=(($2+4)|0);
  HEAP32[(($st$5$1)>>2)]=$low$1;
  var $st$9$0=(($3)|0);
  HEAP32[(($st$9$0)>>2)]=$high$0;
  var $st$9$1=(($3+4)|0);
  HEAP32[(($st$9$1)>>2)]=$high$1;
  var $st$13$0=(($4)|0);
  HEAP32[(($st$13$0)>>2)]=$value$0;
  var $st$13$1=(($4+4)|0);
  HEAP32[(($st$13$1)>>2)]=$value$1;
  var $5=$1;
  var $st$18$0=(($4)|0);
  var $6$0=HEAP32[(($st$18$0)>>2)];
  var $st$18$1=(($4+4)|0);
  var $6$1=HEAP32[(($st$18$1)>>2)];
  var $st$22$0=(($2)|0);
  var $7$0=HEAP32[(($st$22$0)>>2)];
  var $st$22$1=(($2+4)|0);
  var $7$1=HEAP32[(($st$22$1)>>2)];
  var $8$0 = ((($6$0)>>>0)+((($6$1)|0)*4294967296))-((($7$0)>>>0)+((($7$1)|0)*4294967296))>>>0; var $8$1 = Math.min(Math.floor((((($6$0)>>>0)+((($6$1)|0)*4294967296))-((($7$0)>>>0)+((($7$1)|0)*4294967296)))/4294967296), 4294967295);
  var $9=$8$0 + $8$1*4294967296;
  var $10=$5*$9;
  var $st$29$0=(($3)|0);
  var $11$0=HEAP32[(($st$29$0)>>2)];
  var $st$29$1=(($3+4)|0);
  var $11$1=HEAP32[(($st$29$1)>>2)];
  var $st$33$0=(($2)|0);
  var $12$0=HEAP32[(($st$33$0)>>2)];
  var $st$33$1=(($2+4)|0);
  var $12$1=HEAP32[(($st$33$1)>>2)];
  var $13$0 = ((($11$0)>>>0)+((($11$1)|0)*4294967296))-((($12$0)>>>0)+((($12$1)|0)*4294967296))>>>0; var $13$1 = Math.min(Math.floor((((($11$0)>>>0)+((($11$1)|0)*4294967296))-((($12$0)>>>0)+((($12$1)|0)*4294967296)))/4294967296), 4294967295);
  var $14=$13$0 + $13$1*4294967296;
  var $15=$10/$14;
  STACKTOP = __stackBase__;
  return $15;
}


function __Z21cassette_open_choicesPvPK8io_procsPKcPKPK14CassetteFormatiPP15_cassette_image($file, $procs, $extension, $formats, $flags, $outcassette) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $err;
      var $cassette;
      var $format;
      var $opts=__stackBase__;
      var $i;
      $1=$file;
      $2=$procs;
      $3=$extension;
      $4=$formats;
      $5=$flags;
      $6=$outcassette;
      var $7=$opts;
      HEAP32[(($7)>>2)]=0; HEAP32[(($7+4)>>2)]=0; HEAP32[(($7+8)>>2)]=0;
      var $8=$4;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      $4=((_cassette_default_formats)|0);
      __label__ = 2; break;
    case 2: // $11
      var $12=$1;
      var $13=$2;
      var $14=$5;
      var $15=__ZL13cassette_initPK14CassetteFormatPvPK8io_procsi(0, $12, $13, $14);
      $cassette=$15;
      var $16=$cassette;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $18
      $err=3;
      __label__ = 22; break;
    case 4: // $19
      $format=0;
      $i=0;
      __label__ = 5; break;
    case 5: // $20
      var $21=$format;
      var $22=(($21)|0)!=0;
      if ($22) { var $30 = 0;__label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $23
      var $24=$i;
      var $25=$4;
      var $26=(($25+($24<<2))|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      var $30 = $28;__label__ = 7; break;
    case 7: // $29
      var $30;
      if ($30) { __label__ = 8; break; } else { __label__ = 17; break; }
    case 8: // $31
      var $32=$i;
      var $33=$4;
      var $34=(($33+($32<<2))|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$3;
      var $37=$5;
      var $38=__ZL11good_formatPK14CassetteFormatPKci($35, $36, $37);
      var $39=(($38)|0)!=0;
      if ($39) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $40
      var $41=$i;
      var $42=$4;
      var $43=(($42+($41<<2))|0);
      var $44=HEAP32[(($43)>>2)];
      $format=$44;
      var $45=$opts;
      for (var $$dest = $45, $$stop = $$dest + 12; $$dest < $$stop; $$dest++) {
        HEAP8[$$dest] = 0
      };
      var $46=$format;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$cassette;
      var $50=FUNCTION_TABLE[$48]($49, $opts);
      $err=$50;
      var $51=$err;
      var $52=(($51)|0)==4;
      if ($52) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $53
      $format=0;
      __label__ = 14; break;
    case 11: // $54
      var $55=$err;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $57
      __label__ = 22; break;
    case 13: // $58
      __label__ = 14; break;
    case 14: // $59
      __label__ = 15; break;
    case 15: // $60
      __label__ = 16; break;
    case 16: // $61
      var $62=$i;
      var $63=(($62+1)|0);
      $i=$63;
      __label__ = 5; break;
    case 17: // $64
      var $65=$format;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $67
      $err=4;
      __label__ = 22; break;
    case 19: // $68
      var $69=$format;
      var $70=$cassette;
      var $71=(($70)|0);
      HEAP32[(($71)>>2)]=$69;
      var $72=(($opts)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$cassette;
      var $75=(($74+20)|0);
      HEAP32[(($75)>>2)]=$73;
      var $76=(($opts+8)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$cassette;
      var $79=(($78+28)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$format;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$cassette;
      var $84=FUNCTION_TABLE[$82]($83);
      $err=$84;
      var $85=$err;
      var $86=(($85)|0)!=0;
      if ($86) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $87
      __label__ = 22; break;
    case 21: // $88
      var $89=$cassette;
      var $90=(($89+24)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$91 & -65537;
      HEAP32[(($90)>>2)]=$92;
      $err=0;
      __label__ = 22; break;
    case 22: // $93
      var $94=$err;
      var $95=$cassette;
      var $96=$6;
      __ZL19cassette_finishinit9casserr_tP15_cassette_imagePS1_($94, $95, $96);
      var $97=$err;
      STACKTOP = __stackBase__;
      return $97;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21cassette_open_choicesPvPK8io_procsPKcPKPK14CassetteFormatiPP15_cassette_image["X"]=1;

function __ZL13cassette_initPK14CassetteFormatPvPK8io_procsi($format, $file, $procs, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $cassette;
      $2=$format;
      $3=$file;
      $4=$procs;
      $5=$flags;
      var $6=_malloc(44);
      var $7=$6;
      $cassette=$7;
      var $8=$cassette;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      $1=0;
      __label__ = 3; break;
    case 2: // $11
      var $12=$cassette;
      var $13=$12;
      _memset($13, 0, 44, 1);
      var $14=$2;
      var $15=$cassette;
      var $16=(($15)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$3;
      var $18=$cassette;
      var $19=(($18+4)|0);
      var $20=(($19+4)|0);
      HEAP32[(($20)>>2)]=$17;
      var $21=$4;
      var $22=$cassette;
      var $23=(($22+4)|0);
      var $24=(($23)|0);
      HEAP32[(($24)>>2)]=$21;
      var $25=$5;
      var $26=$cassette;
      var $27=(($26+24)|0);
      HEAP32[(($27)>>2)]=$25;
      var $28=__Z14pool_alloc_libPFvPKcE(0);
      var $29=$cassette;
      var $30=(($29+16)|0);
      HEAP32[(($30)>>2)]=$28;
      var $31=$cassette;
      $1=$31;
      __label__ = 3; break;
    case 3: // $32
      var $33=$1;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL11good_formatPK14CassetteFormatPKci($format, $extension, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$format;
      $3=$extension;
      $4=$flags;
      var $5=$3;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$3;
      var $12=__Z20image_find_extensionPKcS0_($10, $11);
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      $1=0;
      __label__ = 7; break;
    case 3: // $15
      var $16=$4;
      var $17=$16 & 1;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $19
      var $20=$2;
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $24
      $1=0;
      __label__ = 7; break;
    case 6: // $25
      $1=1;
      __label__ = 7; break;
    case 7: // $26
      var $27=$1;
      ;
      return $27;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL19cassette_finishinit9casserr_tP15_cassette_imagePS1_($err, $cassette, $outcassette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$err;
      $2=$cassette;
      $3=$outcassette;
      var $4=$2;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $9
      var $10=$3;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $12
      var $13=$2;
      __Z14cassette_closeP15_cassette_image($13);
      $2=0;
      __label__ = 4; break;
    case 4: // $14
      var $15=$3;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $17
      var $18=$2;
      var $19=$3;
      HEAP32[(($19)>>2)]=$18;
      __label__ = 6; break;
    case 6: // $20
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_image($file, $procs, $format, $opts, $flags, $outcassette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $err;
      var $cassette;
      $2=$file;
      $3=$procs;
      $4=$format;
      $5=$opts;
      $6=$flags;
      $7=$outcassette;
      var $8=$6;
      var $9=$8 & 1;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $1=4;
      __label__ = 10; break;
    case 2: // $12
      var $13=$4;
      var $14=$6;
      var $15=__ZL11good_formatPK14CassetteFormatPKci($13, 0, $14);
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $17
      $1=4;
      __label__ = 10; break;
    case 4: // $18
      var $19=$5;
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $21
      $5=__ZZ15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_imageE15default_options;
      __label__ = 6; break;
    case 6: // $22
      var $23=$4;
      var $24=$2;
      var $25=$3;
      var $26=$6;
      var $27=__ZL13cassette_initPK14CassetteFormatPvPK8io_procsi($23, $24, $25, $26);
      $cassette=$27;
      var $28=$cassette;
      var $29=(($28)|0)!=0;
      if ($29) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $30
      $err=3;
      __label__ = 9; break;
    case 8: // $31
      var $32=$5;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$cassette;
      var $36=(($35+20)|0);
      HEAP32[(($36)>>2)]=$34;
      var $37=$5;
      var $38=(($37+8)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$cassette;
      var $41=(($40+28)|0);
      HEAP32[(($41)>>2)]=$39;
      $err=0;
      __label__ = 9; break;
    case 9: // $42
      var $43=$err;
      var $44=$cassette;
      var $45=$7;
      __ZL19cassette_finishinit9casserr_tP15_cassette_imagePS1_($43, $44, $45);
      var $46=$err;
      $1=$46;
      __label__ = 10; break;
    case 10: // $47
      var $48=$1;
      ;
      return $48;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_image["X"]=1;

function __Z13cassette_saveP15_cassette_image($cassette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $err;
      $2=$cassette;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10+12)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $14
      $1=2;
      __label__ = 6; break;
    case 3: // $15
      var $16=$2;
      var $17=__ZL21cassette_perform_saveP15_cassette_image($16);
      $err=$17;
      var $18=$err;
      var $19=(($18)|0)!=0;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      var $21=$err;
      $1=$21;
      __label__ = 6; break;
    case 5: // $22
      var $23=$2;
      var $24=(($23+24)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25 & -65537;
      HEAP32[(($24)>>2)]=$26;
      $1=0;
      __label__ = 6; break;
    case 6: // $27
      var $28=$1;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL21cassette_perform_saveP15_cassette_image($cassette) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $info=__stackBase__;
  $1=$cassette;
  var $2=$1;
  __Z17cassette_get_infoP15_cassette_imageP12CassetteInfo($2, $info);
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+12)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$1;
  var $9=FUNCTION_TABLE[$7]($8, $info);
  STACKTOP = __stackBase__;
  return $9;
}


function __Z17cassette_get_infoP15_cassette_imageP12CassetteInfo($cassette, $info) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$cassette;
  $2=$info;
  var $3=$2;
  var $4=$3;
  for (var $$dest = $4, $$stop = $$dest + 16; $$dest < $$stop; $$dest++) {
    HEAP8[$$dest] = 0
  };
  var $5=$1;
  var $6=(($5+20)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$2;
  var $9=(($8)|0);
  HEAP32[(($9)>>2)]=$7;
  var $10=$1;
  var $11=(($10+40)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$2;
  var $14=(($13+12)|0);
  HEAP32[(($14)>>2)]=$12;
  var $15=$1;
  var $16=(($15+28)|0);
  var $17=HEAP32[(($16)>>2)];
  var $18=$2;
  var $19=(($18+8)|0);
  HEAP32[(($19)>>2)]=$17;
  var $20=$1;
  var $21=(($20+24)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=__ZL25waveform_bytes_per_samplei($22);
  var $24=((($23<<3))|0);
  var $25=$2;
  var $26=(($25+4)|0);
  HEAP32[(($26)>>2)]=$24;
  ;
  return;
}


function __Z14cassette_closeP15_cassette_image($cassette) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$cassette;
      var $2=$1;
      var $3=(($2)|0)!=0;
      if ($3) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $4
      var $5=$1;
      var $6=(($5+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & 65536;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$1;
      var $12=(($11+24)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$13 & 2;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$1;
      var $18=__Z13cassette_saveP15_cassette_image($17);
      __label__ = 4; break;
    case 4: // $19
      var $20=$1;
      var $21=(($20+16)|0);
      var $22=HEAP32[(($21)>>2)];
      __Z13pool_free_libP12_object_pool($22);
      var $23=$1;
      var $24=$23;
      _free($24);
      __label__ = 5; break;
    case 5: // $25
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __Z19cassette_image_readP15_cassette_imagePvyj($cassette, $buffer, $offset$0, $offset$1, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4;
  $1=$cassette;
  $2=$buffer;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$offset$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$offset$1;
  $4=$length;
  var $5=$1;
  var $6=(($5+4)|0);
  var $7=$2;
  var $st$14$0=(($3)|0);
  var $8$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$14$1)>>2)];
  var $9=$4;
  __Z15io_generic_readP10io_genericPvyj($6, $7, $8$0, $8$1, $9);
  STACKTOP = __stackBase__;
  return;
}


function __Z20cassette_image_writeP15_cassette_imagePKvyj($cassette, $buffer, $offset$0, $offset$1, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3=__stackBase__;
  var $4;
  $1=$cassette;
  $2=$buffer;
  var $st$6$0=(($3)|0);
  HEAP32[(($st$6$0)>>2)]=$offset$0;
  var $st$6$1=(($3+4)|0);
  HEAP32[(($st$6$1)>>2)]=$offset$1;
  $4=$length;
  var $5=$1;
  var $6=(($5+4)|0);
  var $7=$2;
  var $st$14$0=(($3)|0);
  var $8$0=HEAP32[(($st$14$0)>>2)];
  var $st$14$1=(($3+4)|0);
  var $8$1=HEAP32[(($st$14$1)>>2)];
  var $9=$4;
  __Z16io_generic_writeP10io_genericPKvyj($6, $7, $8$0, $8$1, $9);
  STACKTOP = __stackBase__;
  return;
}


function __Z19cassette_image_sizeP15_cassette_image($cassette) {
  ;
  var __label__;

  var $1;
  $1=$cassette;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__Z15io_generic_sizeP10io_generic($3);
  var $4$0=$4[0];
  var $4$1=$4[1];
  ;
  return [$4$0,$4$1];
}


function __Z20cassette_get_samplesP15_cassette_imageiddjjPvi($cassette, $channel, $time_index, $sample_period, $sample_count, $sample_bytes, $samples, $waveform_flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $err;
      var $ranges=__stackBase__;
      var $sample_index;
      var $cassette_sample_index;
      var $dest_ptr;
      var $source_ptr=__stackBase__+16;
      var $d;
      var $word;
      var $dword;
      var $sum=__stackBase__+20;
      $2=$cassette;
      $3=$channel;
      $4=$time_index;
      $5=$sample_period;
      $6=$sample_count;
      $7=$sample_bytes;
      $8=$samples;
      $9=$waveform_flags;
      var $10=$2;
      var $11=$3;
      var $12=$4;
      var $13=$5;
      var $14=__ZL27compute_manipulation_rangesP15_cassette_imageiddP19manipulation_ranges($10, $11, $12, $13, $ranges);
      $err=$14;
      var $15=$err;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $17
      var $18=$err;
      $1=$18;
      __label__ = 21; break;
    case 2: // $19
      $sample_index=0;
      __label__ = 3; break;
    case 3: // $20
      var $21=$sample_index;
      var $22=$6;
      var $23=(($21)>>>0) < (($22)>>>0);
      if ($23) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $24
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$2$0=(($sum)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$0$0;
      var $st$2$1=(($sum+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$0$1;
      var $25=(($ranges)|0);
      var $26=HEAP32[(($25)>>2)];
      $3=$26;
      __label__ = 5; break;
    case 5: // $27
      var $28=$3;
      var $29=(($ranges+4)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($28)|0) <= (($30)|0);
      if ($31) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $32
      var $33=(($ranges+12)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      var $36=(($ranges+8)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($35-$37)|0);
      var $39=(($38)>>>0);
      var $40=$6;
      var $41$0=$40;
      var $41$1=0;
      var $42=$sample_index;
      var $43$0=$42;
      var $43$1=0;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $44=__ZL10map_doubledyyy($39, $$emscripten$temp$1$0, $$emscripten$temp$1$1, $41$0, $41$1, $43$0, $43$1);
      var $45=(($ranges+8)|0);
      var $46=HEAPU32[(($45)>>2)];
      var $47=(($46)>>>0);
      var $48=$44+$47;
      $d=$48;
      var $49=$d;
      var $50=($49 >= 0 ? Math.floor($49) : Math.ceil($49));
      $cassette_sample_index=$50;
      var $51=$2;
      var $52=$3;
      var $53=$cassette_sample_index;
      var $54=__ZL13lookup_sampleP15_cassette_imageijiPPi($51, $52, $53, 1, $source_ptr);
      $err=$54;
      var $55=$err;
      var $56=(($55)|0)!=0;
      if ($56) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $57
      var $58=$err;
      $1=$58;
      __label__ = 21; break;
    case 8: // $59
      var $60=HEAP32[(($source_ptr)>>2)];
      var $61=HEAP32[(($60)>>2)];
      var $62$0=$61;
      var $62$1=(($61|0) < 0 ? -1 : 0);
      var $st$4$0=(($sum)|0);
      var $63$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($sum+4)|0);
      var $63$1=HEAP32[(($st$4$1)>>2)];
      var $64$0 = ((($63$0)>>>0)+((($63$1)|0)*4294967296))+((($62$0)>>>0)+((($62$1)|0)*4294967296))>>>0; var $64$1 = Math.min(Math.floor((((($63$0)>>>0)+((($63$1)|0)*4294967296))+((($62$0)>>>0)+((($62$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($sum)|0);
      HEAP32[(($st$9$0)>>2)]=$64$0;
      var $st$9$1=(($sum+4)|0);
      HEAP32[(($st$9$1)>>2)]=$64$1;
      __label__ = 9; break;
    case 9: // $65
      var $66=$3;
      var $67=(($66+1)|0);
      $3=$67;
      __label__ = 5; break;
    case 10: // $68
      var $69=(($ranges+4)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+1)|0);
      var $72=(($ranges)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($71-$73)|0);
      var $75$0=$74;
      var $75$1=(($74|0) < 0 ? -1 : 0);
      var $st$8$0=(($sum)|0);
      var $76$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($sum+4)|0);
      var $76$1=HEAP32[(($st$8$1)>>2)];
      var $77$0 = (tempBigIntR=((($76$0)>>>0)+((($76$1)|0)*4294967296))/((($75$0)>>>0)+((($75$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR))>>>0; var $77$1 = Math.min(Math.floor(((tempBigIntR=((($76$0)>>>0)+((($76$1)|0)*4294967296))/((($75$0)>>>0)+((($75$1)|0)*4294967296)),tempBigIntR >= 0 ? Math.floor(tempBigIntR) : Math.ceil(tempBigIntR)))/4294967296), 4294967295);
      var $st$13$0=(($sum)|0);
      HEAP32[(($st$13$0)>>2)]=$77$0;
      var $st$13$1=(($sum+4)|0);
      HEAP32[(($st$13$1)>>2)]=$77$1;
      var $78=$8;
      $dest_ptr=$78;
      var $79=$9;
      var $80=__ZL25waveform_bytes_per_samplei($79);
      var $81=$sample_index;
      var $82=(($80*$81)|0);
      var $83=$dest_ptr;
      var $84=(($83+$82)|0);
      $dest_ptr=$84;
      var $85=$9;
      var $86=__ZL25waveform_bytes_per_samplei($85);
      if ($86 == 1) {
        __label__ = 11; break;
      }
      else if ($86 == 2) {
        __label__ = 12; break;
      }
      else if ($86 == 4) {
        __label__ = 15; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 11: // $87
      var $st$0$0=(($sum)|0);
      var $88$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($sum+4)|0);
      var $88$1=HEAP32[(($st$0$1)>>2)];
      var $89$0=$88$0;
      var $89=$89$0;
      var $90=__ZL12interpolate8i($89);
      var $91=$dest_ptr;
      HEAP8[($91)]=$90;
      __label__ = 18; break;
    case 12: // $92
      var $st$0$0=(($sum)|0);
      var $93$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($sum+4)|0);
      var $93$1=HEAP32[(($st$0$1)>>2)];
      var $94$0=$93$0;
      var $94=$94$0;
      var $95=__ZL13interpolate16i($94);
      $word=$95;
      var $96=$9;
      var $97=$96 & 1;
      var $98=(($97)|0)!=0;
      if ($98) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $99
      var $100=$word;
      var $101=(($100)&65535);
      var $102=$101 >> 8;
      var $103=$word;
      var $104=(($103 << 16) >> 16);
      var $105=$104 << 8;
      var $106=$102 | $105;
      var $107=$106 & 65535;
      var $108=(($107) & 65535);
      $word=$108;
      __label__ = 14; break;
    case 14: // $109
      var $110=$word;
      var $111=$dest_ptr;
      var $112=$111;
      HEAP16[(($112)>>1)]=$110;
      __label__ = 18; break;
    case 15: // $113
      var $st$0$0=(($sum)|0);
      var $114$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($sum+4)|0);
      var $114$1=HEAP32[(($st$0$1)>>2)];
      var $115$0=$114$0;
      var $115=$115$0;
      $dword=$115;
      var $116=$9;
      var $117=$116 & 1;
      var $118=(($117)|0)!=0;
      if ($118) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $119
      var $120=$dword;
      var $121=$120 << 24;
      var $122=$dword;
      var $123=$122 >>> 24;
      var $124=$121 | $123;
      var $125=$dword;
      var $126=$125 & 65280;
      var $127=$126 << 8;
      var $128=$124 | $127;
      var $129=$dword;
      var $130=$129 & 16711680;
      var $131=$130 >>> 8;
      var $132=$128 | $131;
      $dword=$132;
      __label__ = 17; break;
    case 17: // $133
      var $134=$dword;
      var $135=$dest_ptr;
      var $136=$135;
      HEAP32[(($136)>>2)]=$134;
      __label__ = 18; break;
    case 18: // $137
      __label__ = 19; break;
    case 19: // $138
      var $139=$sample_index;
      var $140=(($139+1)|0);
      $sample_index=$140;
      __label__ = 3; break;
    case 20: // $141
      $1=0;
      __label__ = 21; break;
    case 21: // $142
      var $143=$1;
      STACKTOP = __stackBase__;
      return $143;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20cassette_get_samplesP15_cassette_imageiddjjPvi["X"]=1;

function __ZL27compute_manipulation_rangesP15_cassette_imageiddP19manipulation_ranges($cassette, $channel, $time_index, $sample_period, $ranges) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$cassette;
      $2=$channel;
      $3=$time_index;
      $4=$sample_period;
      $5=$ranges;
      var $6=$2;
      var $7=(($6)|0) < 0;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$5;
      var $10=(($9)|0);
      HEAP32[(($10)>>2)]=0;
      var $11=$1;
      var $12=(($11+20)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-1)|0);
      var $15=$5;
      var $16=(($15+4)|0);
      HEAP32[(($16)>>2)]=$14;
      __label__ = 3; break;
    case 2: // $17
      var $18=$2;
      var $19=$5;
      var $20=(($19)|0);
      HEAP32[(($20)>>2)]=$18;
      var $21=$2;
      var $22=$5;
      var $23=(($22+4)|0);
      HEAP32[(($23)>>2)]=$21;
      __label__ = 3; break;
    case 3: // $24
      var $25=$3;
      var $26=$1;
      var $27=(($26+28)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=(($28)>>>0);
      var $30=$25*$29;
      var $31=__ZL8my_roundd($30);
      var $32=$5;
      var $33=(($32+8)|0);
      HEAP32[(($33)>>2)]=$31;
      var $34=$3;
      var $35=$4;
      var $36=$34+$35;
      var $37=$1;
      var $38=(($37+28)|0);
      var $39=HEAPU32[(($38)>>2)];
      var $40=(($39)>>>0);
      var $41=$36*$40;
      var $42=__ZL8my_roundd($41);
      var $43=$5;
      var $44=(($43+12)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$5;
      var $46=(($45+12)|0);
      var $47=HEAPU32[(($46)>>2)];
      var $48=$5;
      var $49=(($48+8)|0);
      var $50=HEAPU32[(($49)>>2)];
      var $51=(($47)>>>0) > (($50)>>>0);
      if ($51) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $52
      var $53=$5;
      var $54=(($53+12)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55-1)|0);
      HEAP32[(($54)>>2)]=$56;
      __label__ = 5; break;
    case 5: // $57
      ;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL27compute_manipulation_rangesP15_cassette_imageiddP19manipulation_ranges["X"]=1;

function __ZL12interpolate8i($value) {
  ;
  var __label__;

  var $1;
  $1=$value;
  var $2=$1;
  var $3=$2 >> 24;
  var $4=(($3) & 255);
  ;
  return $4;
}


function __ZL13interpolate16i($value) {
  ;
  var __label__;

  var $1;
  $1=$value;
  var $2=$1;
  var $3=$2 >> 16;
  var $4=(($3) & 65535);
  ;
  return $4;
}


function __ZL12extrapolate8a($value) {
  ;
  var __label__;

  var $1;
  $1=$value;
  var $2=$1;
  var $3=(($2 << 24) >> 24);
  var $4=$3 << 24;
  ;
  return $4;
}


function __ZL13extrapolate16s($value) {
  ;
  var __label__;

  var $1;
  $1=$value;
  var $2=$1;
  var $3=(($2 << 16) >> 16);
  var $4=$3 << 16;
  ;
  return $4;
}


function __ZL8my_roundd($d) {
  ;
  var __label__;

  var $1;
  var $result;
  $1=$d;
  var $2=$1;
  var $3=$2+0.5;
  $1=$3;
  var $4=$1;
  var $5=($4 >= 0 ? Math.floor($4) : Math.ceil($4));
  $result=$5;
  var $6=$result;
  ;
  return $6;
}


function __ZL13lookup_sampleP15_cassette_imageijiPPi($cassette, $channel, $sample, $allocate, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $sample_block;
      var $sample_index;
      var $sample_size;
      var $new_block_count;
      var $new_block_sample_count;
      var $new_block;
      var $new_blocks;
      var $block;
      $2=$cassette;
      $3=$channel;
      $4=$sample;
      $5=$allocate;
      $6=$ptr;
      var $7=$6;
      HEAP32[(($7)>>2)]=0;
      var $8=$4;
      var $9=Math.floor((($8)>>>0)/262144);
      var $10=$2;
      var $11=(($10+20)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($9*$12)|0);
      var $14=$3;
      var $15=(($13+$14)|0);
      $sample_block=$15;
      var $16=$4;
      var $17=(($16)>>>0)%262144;
      $sample_index=$17;
      $sample_size=4;
      var $18=$sample_block;
      var $19=$2;
      var $20=(($19+36)|0);
      var $21=HEAPU32[(($20)>>2)];
      var $22=(($18)>>>0) >= (($21)>>>0);
      if ($22) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $23
      var $24=$5;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $26
      $1=0;
      __label__ = 13; break;
    case 3: // $27
      var $28=$sample_block;
      var $29=(($28+1)|0);
      $new_block_count=$29;
      var $30=$2;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$2;
      var $34=(($33+32)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$35;
      var $37=$new_block_count;
      var $38=((($37<<3))|0);
      var $39=__Z22pool_realloc_file_lineP12_object_poolPvjPKci($32, $36, $38, ((STRING_TABLE.__str17569)|0), 402);
      var $40=$39;
      $new_blocks=$40;
      var $41=$new_blocks;
      var $42=(($41)|0)!=0;
      if ($42) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $43
      $1=3;
      __label__ = 13; break;
    case 5: // $44
      var $45=$new_blocks;
      var $46=$2;
      var $47=(($46+32)|0);
      HEAP32[(($47)>>2)]=$45;
      var $48=$2;
      var $49=(($48+36)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$2;
      var $52=(($51+32)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+($50<<3))|0);
      var $55=$54;
      var $56=$new_block_count;
      var $57=$2;
      var $58=(($57+36)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=(($56-$59)|0);
      var $61=((($60<<3))|0);
      _memset($55, 0, $61, 1);
      var $62=$new_block_count;
      var $63=$2;
      var $64=(($63+36)|0);
      HEAP32[(($64)>>2)]=$62;
      __label__ = 6; break;
    case 6: // $65
      var $66=$sample_block;
      var $67=$2;
      var $68=(($67+32)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+($66<<3))|0);
      $block=$70;
      var $71=$sample_index;
      var $72=$block;
      var $73=(($72+4)|0);
      var $74=HEAPU32[(($73)>>2)];
      var $75=(($71)>>>0) >= (($74)>>>0);
      if ($75) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $76
      var $77=$5;
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $79
      $1=0;
      __label__ = 13; break;
    case 9: // $80
      $new_block_sample_count=262144;
      var $81=$2;
      var $82=(($81+16)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$block;
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86;
      var $88=$new_block_sample_count;
      var $89=$sample_size;
      var $90=(($88*$89)|0);
      var $91=__Z22pool_realloc_file_lineP12_object_poolPvjPKci($83, $87, $90, ((STRING_TABLE.__str17569)|0), 421);
      var $92=$91;
      $new_block=$92;
      var $93=$new_block;
      var $94=(($93)|0)!=0;
      if ($94) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $95
      $1=3;
      __label__ = 13; break;
    case 11: // $96
      var $97=$new_block;
      var $98=$block;
      var $99=(($98)|0);
      HEAP32[(($99)>>2)]=$97;
      var $100=$block;
      var $101=(($100+4)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$block;
      var $104=(($103)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+($102<<2))|0);
      var $107=$106;
      var $108=$new_block_sample_count;
      var $109=$block;
      var $110=(($109+4)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($108-$111)|0);
      var $113=$sample_size;
      var $114=(($112*$113)|0);
      _memset($107, 0, $114, 1);
      var $115=$new_block_sample_count;
      var $116=$block;
      var $117=(($116+4)|0);
      HEAP32[(($117)>>2)]=$115;
      __label__ = 12; break;
    case 12: // $118
      var $119=$sample_index;
      var $120=$block;
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($122+($119<<2))|0);
      var $124=$6;
      HEAP32[(($124)>>2)]=$123;
      $1=0;
      __label__ = 13; break;
    case 13: // $125
      var $126=$1;
      ;
      return $126;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL13lookup_sampleP15_cassette_imageijiPPi["X"]=1;

function __Z20cassette_put_samplesP15_cassette_imageiddjjPKvi($cassette, $channel, $time_index, $sample_period, $sample_count, $sample_bytes, $samples, $waveform_flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $err;
      var $ranges=__stackBase__;
      var $sample_index;
      var $dest_ptr=__stackBase__+16;
      var $dest_value;
      var $word;
      var $dword;
      var $source_ptr;
      var $d;
      $2=$cassette;
      $3=$channel;
      $4=$time_index;
      $5=$sample_period;
      $6=$sample_count;
      $7=$sample_bytes;
      $8=$samples;
      $9=$waveform_flags;
      var $10=$2;
      var $11=(($10)|0)!=0;
      if ($11) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $12
      $1=0;
      __label__ = 28; break;
    case 2: // $13
      var $14=$5;
      var $15=$14 == 0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=0;
      __label__ = 28; break;
    case 4: // $17
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=$5;
      var $22=__ZL27compute_manipulation_rangesP15_cassette_imageiddP19manipulation_ranges($18, $19, $20, $21, $ranges);
      $err=$22;
      var $23=$err;
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=$err;
      $1=$26;
      __label__ = 28; break;
    case 6: // $27
      var $28=$2;
      var $29=(($28+40)|0);
      var $30=HEAPU32[(($29)>>2)];
      var $31=(($ranges+12)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+1)|0);
      var $34=(($30)>>>0) < (($33)>>>0);
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=(($ranges+12)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+1)|0);
      var $39=$2;
      var $40=(($39+40)|0);
      HEAP32[(($40)>>2)]=$38;
      __label__ = 8; break;
    case 8: // $41
      var $42=$2;
      var $43=(($42+24)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44 | 65536;
      HEAP32[(($43)>>2)]=$45;
      var $46=(($ranges+8)|0);
      var $47=HEAP32[(($46)>>2)];
      $sample_index=$47;
      __label__ = 9; break;
    case 9: // $48
      var $49=$sample_index;
      var $50=(($ranges+12)|0);
      var $51=HEAPU32[(($50)>>2)];
      var $52=(($49)>>>0) <= (($51)>>>0);
      if ($52) { __label__ = 10; break; } else { __label__ = 27; break; }
    case 10: // $53
      var $54=$6;
      var $55=(($54)>>>0);
      var $56=(($ranges+8)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58$0=$57;
      var $58$1=0;
      var $59=(($ranges+12)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+1)|0);
      var $62$0=$61;
      var $62$1=0;
      var $63=$sample_index;
      var $64$0=$63;
      var $64$1=0;
      var $65=__ZL10map_doubledyyy($55, $58$0, $58$1, $62$0, $62$1, $64$0, $64$1);
      $d=$65;
      var $66=$8;
      $source_ptr=$66;
      var $67=$d;
      var $68=($67 >= 0 ? Math.floor($67) : Math.ceil($67));
      var $69=$7;
      var $70=(($68*$69)|0);
      var $71=$source_ptr;
      var $72=(($71+$70)|0);
      $source_ptr=$72;
      var $73=$9;
      var $74=__ZL25waveform_bytes_per_samplei($73);
      if ($74 == 1) {
        __label__ = 11; break;
      }
      else if ($74 == 2) {
        __label__ = 12; break;
      }
      else if ($74 == 4) {
        __label__ = 15; break;
      }
      else {
      __label__ = 18; break;
      }
      
    case 11: // $75
      var $76=$source_ptr;
      var $77=HEAP8[($76)];
      var $78=__ZL12extrapolate8a($77);
      $dest_value=$78;
      __label__ = 19; break;
    case 12: // $79
      var $80=$source_ptr;
      var $81=$80;
      var $82=HEAP16[(($81)>>1)];
      $word=$82;
      var $83=$9;
      var $84=$83 & 1;
      var $85=(($84)|0)!=0;
      if ($85) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $86
      var $87=$word;
      var $88=(($87)&65535);
      var $89=$88 >> 8;
      var $90=$word;
      var $91=(($90 << 16) >> 16);
      var $92=$91 << 8;
      var $93=$89 | $92;
      var $94=$93 & 65535;
      var $95=(($94) & 65535);
      $word=$95;
      __label__ = 14; break;
    case 14: // $96
      var $97=$word;
      var $98=__ZL13extrapolate16s($97);
      $dest_value=$98;
      __label__ = 19; break;
    case 15: // $99
      var $100=$source_ptr;
      var $101=$100;
      var $102=HEAP32[(($101)>>2)];
      $dword=$102;
      var $103=$9;
      var $104=$103 & 1;
      var $105=(($104)|0)!=0;
      if ($105) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $106
      var $107=$dword;
      var $108=$107 << 24;
      var $109=$dword;
      var $110=$109 >>> 24;
      var $111=$108 | $110;
      var $112=$dword;
      var $113=$112 & 65280;
      var $114=$113 << 8;
      var $115=$111 | $114;
      var $116=$dword;
      var $117=$116 & 16711680;
      var $118=$117 >>> 8;
      var $119=$115 | $118;
      $dword=$119;
      __label__ = 17; break;
    case 17: // $120
      var $121=$dword;
      $dest_value=$121;
      __label__ = 19; break;
    case 18: // $122
      $1=1;
      __label__ = 28; break;
    case 19: // $123
      var $124=(($ranges)|0);
      var $125=HEAP32[(($124)>>2)];
      $3=$125;
      __label__ = 20; break;
    case 20: // $126
      var $127=$3;
      var $128=(($ranges+4)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($127)|0) <= (($129)|0);
      if ($130) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $131
      var $132=$2;
      var $133=$3;
      var $134=$sample_index;
      var $135=__ZL13lookup_sampleP15_cassette_imageijiPPi($132, $133, $134, 1, $dest_ptr);
      $err=$135;
      var $136=$err;
      var $137=(($136)|0)!=0;
      if ($137) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $138
      var $139=$err;
      $1=$139;
      __label__ = 28; break;
    case 23: // $140
      var $141=$dest_value;
      var $142=HEAP32[(($dest_ptr)>>2)];
      HEAP32[(($142)>>2)]=$141;
      __label__ = 24; break;
    case 24: // $143
      var $144=$3;
      var $145=(($144+1)|0);
      $3=$145;
      __label__ = 20; break;
    case 25: // $146
      __label__ = 26; break;
    case 26: // $147
      var $148=$sample_index;
      var $149=(($148+1)|0);
      $sample_index=$149;
      __label__ = 9; break;
    case 27: // $150
      $1=0;
      __label__ = 28; break;
    case 28: // $151
      var $152=$1;
      STACKTOP = __stackBase__;
      return $152;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z20cassette_put_samplesP15_cassette_imageiddjjPKvi["X"]=1;

function __Z19cassette_get_sampleP15_cassette_imageiddPi($cassette, $channel, $time_index, $sample_period, $sample) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5;
  $1=$cassette;
  $2=$channel;
  $3=$time_index;
  $4=$sample_period;
  $5=$sample;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=$5;
  var $11=$10;
  var $12=__Z20cassette_get_samplesP15_cassette_imageiddjjPvi($6, $7, $8, $9, 1, 0, $11, 4);
  ;
  return $12;
}


function __Z19cassette_put_sampleP15_cassette_imageiddi($cassette, $channel, $time_index, $sample_period, $sample) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  $1=$cassette;
  $2=$channel;
  $3=$time_index;
  $4=$sample_period;
  HEAP32[(($5)>>2)]=$sample;
  var $6=$1;
  var $7=$2;
  var $8=$3;
  var $9=$4;
  var $10=$5;
  var $11=__Z20cassette_put_samplesP15_cassette_imageiddjjPKvi($6, $7, $8, $9, 1, 0, $10, 4);
  STACKTOP = __stackBase__;
  return $11;
}


function __Z21cassette_read_samplesP15_cassette_imageiddjyi($cassette, $channels, $time_index, $sample_period, $sample_count, $offset$0, $offset$1, $waveform_flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 8200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7=__stackBase__;
      var $8;
      var $err;
      var $chunk_sample_count;
      var $bytes_per_sample;
      var $sample_bytes;
      var $samples_loaded;
      var $chunk_time_index;
      var $chunk_sample_period;
      var $channel;
      var $buffer=__stackBase__+8;
      $2=$cassette;
      $3=$channels;
      $4=$time_index;
      $5=$sample_period;
      $6=$sample_count;
      var $st$22$0=(($7)|0);
      HEAP32[(($st$22$0)>>2)]=$offset$0;
      var $st$22$1=(($7+4)|0);
      HEAP32[(($st$22$1)>>2)]=$offset$1;
      $8=$waveform_flags;
      $samples_loaded=0;
      var $9=$8;
      var $10=__ZL25waveform_bytes_per_samplei($9);
      $bytes_per_sample=$10;
      var $11=$bytes_per_sample;
      var $12=$3;
      var $13=(($11*$12)|0);
      $sample_bytes=$13;
      __label__ = 1; break;
    case 1: // $14
      var $15=$samples_loaded;
      var $16=$6;
      var $17=(($15)>>>0) < (($16)>>>0);
      if ($17) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $18
      var $19=$sample_bytes;
      var $20=Math.floor(8192/(($19)>>>0));
      var $21=$6;
      var $22=$samples_loaded;
      var $23=(($21-$22)|0);
      var $24=(($20)>>>0) < (($23)>>>0);
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$sample_bytes;
      var $27=Math.floor(8192/(($26)>>>0));
      var $33 = $27;__label__ = 5; break;
    case 4: // $28
      var $29=$6;
      var $30=$samples_loaded;
      var $31=(($29-$30)|0);
      var $33 = $31;__label__ = 5; break;
    case 5: // $32
      var $33;
      $chunk_sample_count=$33;
      var $34=$5;
      var $35=$6;
      var $36$0=$35;
      var $36$1=0;
      var $37=$chunk_sample_count;
      var $38$0=$37;
      var $38$1=0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $39=__ZL10map_doubledyyy($34, $$emscripten$temp$0$0, $$emscripten$temp$0$1, $36$0, $36$1, $38$0, $38$1);
      $chunk_sample_period=$39;
      var $40=$4;
      var $41=$5;
      var $42=$6;
      var $43$0=$42;
      var $43$1=0;
      var $44=$samples_loaded;
      var $45$0=$44;
      var $45$1=0;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $46=__ZL10map_doubledyyy($41, $$emscripten$temp$1$0, $$emscripten$temp$1$1, $43$0, $43$1, $45$0, $45$1);
      var $47=$40+$46;
      $chunk_time_index=$47;
      var $48=$2;
      var $49=(($buffer)|0);
      var $st$28$0=(($7)|0);
      var $50$0=HEAP32[(($st$28$0)>>2)];
      var $st$28$1=(($7+4)|0);
      var $50$1=HEAP32[(($st$28$1)>>2)];
      var $51=$chunk_sample_count;
      var $52=$sample_bytes;
      var $53=(($51*$52)|0);
      __Z19cassette_image_readP15_cassette_imagePvyj($48, $49, $50$0, $50$1, $53);
      $channel=0;
      __label__ = 6; break;
    case 6: // $54
      var $55=$channel;
      var $56=$3;
      var $57=(($55)|0) < (($56)|0);
      if ($57) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $58
      var $59=$2;
      var $60=$channel;
      var $61=$chunk_time_index;
      var $62=$chunk_sample_period;
      var $63=$chunk_sample_count;
      var $64=$sample_bytes;
      var $65=$channel;
      var $66=$bytes_per_sample;
      var $67=(($65*$66)|0);
      var $68=(($buffer+$67)|0);
      var $69=$8;
      var $70=__Z20cassette_put_samplesP15_cassette_imageiddjjPKvi($59, $60, $61, $62, $63, $64, $68, $69);
      $err=$70;
      var $71=$err;
      var $72=(($71)|0)!=0;
      if ($72) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $73
      var $74=$err;
      $1=$74;
      __label__ = 13; break;
    case 9: // $75
      __label__ = 10; break;
    case 10: // $76
      var $77=$channel;
      var $78=(($77+1)|0);
      $channel=$78;
      __label__ = 6; break;
    case 11: // $79
      var $80=$chunk_sample_count;
      var $81=$sample_bytes;
      var $82=(($80*$81)|0);
      var $83$0=$82;
      var $83$1=0;
      var $st$5$0=(($7)|0);
      var $84$0=HEAP32[(($st$5$0)>>2)];
      var $st$5$1=(($7+4)|0);
      var $84$1=HEAP32[(($st$5$1)>>2)];
      var $85$0 = ((($84$0)>>>0)+((($84$1)|0)*4294967296))+((($83$0)>>>0)+((($83$1)|0)*4294967296))>>>0; var $85$1 = Math.min(Math.floor((((($84$0)>>>0)+((($84$1)|0)*4294967296))+((($83$0)>>>0)+((($83$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$10$0=(($7)|0);
      HEAP32[(($st$10$0)>>2)]=$85$0;
      var $st$10$1=(($7+4)|0);
      HEAP32[(($st$10$1)>>2)]=$85$1;
      var $86=$chunk_sample_count;
      var $87=$samples_loaded;
      var $88=(($87+$86)|0);
      $samples_loaded=$88;
      __label__ = 1; break;
    case 12: // $89
      $1=0;
      __label__ = 13; break;
    case 13: // $90
      var $91=$1;
      STACKTOP = __stackBase__;
      return $91;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z21cassette_read_samplesP15_cassette_imageiddjyi["X"]=1;

function __Z22cassette_write_samplesP15_cassette_imageiddjyi($cassette, $channels, $time_index, $sample_period, $sample_count, $offset$0, $offset$1, $waveform_flags) {
  var __stackBase__  = STACKTOP; STACKTOP += 8200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7=__stackBase__;
      var $8;
      var $err;
      var $chunk_sample_count;
      var $bytes_per_sample;
      var $sample_bytes;
      var $samples_saved;
      var $chunk_time_index;
      var $chunk_sample_period;
      var $channel;
      var $buffer=__stackBase__+8;
      $2=$cassette;
      $3=$channels;
      $4=$time_index;
      $5=$sample_period;
      $6=$sample_count;
      var $st$22$0=(($7)|0);
      HEAP32[(($st$22$0)>>2)]=$offset$0;
      var $st$22$1=(($7+4)|0);
      HEAP32[(($st$22$1)>>2)]=$offset$1;
      $8=$waveform_flags;
      $samples_saved=0;
      var $9=$8;
      var $10=__ZL25waveform_bytes_per_samplei($9);
      $bytes_per_sample=$10;
      var $11=$bytes_per_sample;
      var $12=$3;
      var $13=(($11*$12)|0);
      $sample_bytes=$13;
      __label__ = 1; break;
    case 1: // $14
      var $15=$samples_saved;
      var $16=$6;
      var $17=(($15)>>>0) < (($16)>>>0);
      if ($17) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $18
      var $19=$sample_bytes;
      var $20=Math.floor(8192/(($19)>>>0));
      var $21=$6;
      var $22=$samples_saved;
      var $23=(($21-$22)|0);
      var $24=(($20)>>>0) < (($23)>>>0);
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$sample_bytes;
      var $27=Math.floor(8192/(($26)>>>0));
      var $33 = $27;__label__ = 5; break;
    case 4: // $28
      var $29=$6;
      var $30=$samples_saved;
      var $31=(($29-$30)|0);
      var $33 = $31;__label__ = 5; break;
    case 5: // $32
      var $33;
      $chunk_sample_count=$33;
      var $34=$5;
      var $35=$6;
      var $36$0=$35;
      var $36$1=0;
      var $37=$chunk_sample_count;
      var $38$0=$37;
      var $38$1=0;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $39=__ZL10map_doubledyyy($34, $$emscripten$temp$0$0, $$emscripten$temp$0$1, $36$0, $36$1, $38$0, $38$1);
      $chunk_sample_period=$39;
      var $40=$4;
      var $41=$5;
      var $42=$6;
      var $43$0=$42;
      var $43$1=0;
      var $44=$samples_saved;
      var $45$0=$44;
      var $45$1=0;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $46=__ZL10map_doubledyyy($41, $$emscripten$temp$1$0, $$emscripten$temp$1$1, $43$0, $43$1, $45$0, $45$1);
      var $47=$40+$46;
      $chunk_time_index=$47;
      $channel=0;
      __label__ = 6; break;
    case 6: // $48
      var $49=$channel;
      var $50=$3;
      var $51=(($49)|0) < (($50)|0);
      if ($51) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $52
      var $53=$2;
      var $54=$channel;
      var $55=$chunk_time_index;
      var $56=$chunk_sample_period;
      var $57=$chunk_sample_count;
      var $58=$sample_bytes;
      var $59=$channel;
      var $60=$bytes_per_sample;
      var $61=(($59*$60)|0);
      var $62=(($buffer+$61)|0);
      var $63=$8;
      var $64=__Z20cassette_get_samplesP15_cassette_imageiddjjPvi($53, $54, $55, $56, $57, $58, $62, $63);
      $err=$64;
      var $65=$err;
      var $66=(($65)|0)!=0;
      if ($66) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $67
      var $68=$err;
      $1=$68;
      __label__ = 13; break;
    case 9: // $69
      __label__ = 10; break;
    case 10: // $70
      var $71=$channel;
      var $72=(($71+1)|0);
      $channel=$72;
      __label__ = 6; break;
    case 11: // $73
      var $74=$2;
      var $75=(($buffer)|0);
      var $st$2$0=(($7)|0);
      var $76$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($7+4)|0);
      var $76$1=HEAP32[(($st$2$1)>>2)];
      var $77=$chunk_sample_count;
      var $78=$sample_bytes;
      var $79=(($77*$78)|0);
      __Z20cassette_image_writeP15_cassette_imagePKvyj($74, $75, $76$0, $76$1, $79);
      var $80=$chunk_sample_count;
      var $81=$sample_bytes;
      var $82=(($80*$81)|0);
      var $83$0=$82;
      var $83$1=0;
      var $st$15$0=(($7)|0);
      var $84$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($7+4)|0);
      var $84$1=HEAP32[(($st$15$1)>>2)];
      var $85$0 = ((($84$0)>>>0)+((($84$1)|0)*4294967296))+((($83$0)>>>0)+((($83$1)|0)*4294967296))>>>0; var $85$1 = Math.min(Math.floor((((($84$0)>>>0)+((($84$1)|0)*4294967296))+((($83$0)>>>0)+((($83$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$20$0=(($7)|0);
      HEAP32[(($st$20$0)>>2)]=$85$0;
      var $st$20$1=(($7+4)|0);
      HEAP32[(($st$20$1)>>2)]=$85$1;
      var $86=$chunk_sample_count;
      var $87=$samples_saved;
      var $88=(($87+$86)|0);
      $samples_saved=$88;
      __label__ = 1; break;
    case 12: // $89
      $1=0;
      __label__ = 13; break;
    case 13: // $90
      var $91=$1;
      STACKTOP = __stackBase__;
      return $91;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z22cassette_write_samplesP15_cassette_imageiddjyi["X"]=1;

function __Z20image_find_extensionPKcS0_($extension_list, $target_extension) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $2=$extension_list;
      $3=$target_extension;
      var $4=$3;
      var $5=_strchr($4, 44);
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 5; break;
    case 2: // $8
      var $9=$3;
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24);
      var $12=(($11)|0)==46;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$3;
      var $15=(($14+1)|0);
      $3=$15;
      __label__ = 4; break;
    case 4: // $16
      var $17=$2;
      var $18=$3;
      var $19=__ZL29image_internal_find_extensionPKcS0_($17, $18);
      $1=$19;
      __label__ = 5; break;
    case 5: // $20
      var $21=$1;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL8is_delimc($c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$c;
      var $2=$1;
      var $3=(($2 << 24) >> 24);
      var $4=(($3)|0)==0;
      if ($4) { var $10 = 1;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)|0)==44;
      var $10 = $8;__label__ = 2; break;
    case 2: // $9
      var $10;
      var $11=(($10)&1);
      ;
      return $11;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZL29image_internal_find_extensionPKcS0_($extension_list, $target_extension) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $pos;
      var $i;
      $2=$extension_list;
      $3=$target_extension;
      $pos=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$pos;
      var $6=$2;
      var $7=(($6+$5)|0);
      var $8=HEAP8[($7)];
      var $9=(($8 << 24) >> 24);
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 2; break; } else { __label__ = 18; break; }
    case 2: // $11
      $i=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$pos;
      var $14=$i;
      var $15=(($13+$14)|0);
      var $16=$2;
      var $17=(($16+$15)|0);
      var $18=HEAP8[($17)];
      var $19=__ZL8is_delimc($18);
      var $20=(($19)|0)!=0;
      if ($20) { var $45 = 0;__label__ = 6; break; } else { __label__ = 4; break; }
    case 4: // $21
      var $22=$i;
      var $23=$3;
      var $24=(($23+$22)|0);
      var $25=HEAP8[($24)];
      var $26=__ZL8is_delimc($25);
      var $27=(($26)|0)!=0;
      if ($27) { var $45 = 0;__label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $28
      var $29=$pos;
      var $30=$i;
      var $31=(($29+$30)|0);
      var $32=$2;
      var $33=(($32+$31)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=_tolower($35);
      var $37=$i;
      var $38=$3;
      var $39=(($38+$37)|0);
      var $40=HEAP8[($39)];
      var $41=(($40 << 24) >> 24);
      var $42=_tolower($41);
      var $43=(($36)|0)==(($42)|0);
      var $45 = $43;__label__ = 6; break;
    case 6: // $44
      var $45;
      if ($45) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $46
      var $47=$i;
      var $48=(($47+1)|0);
      $i=$48;
      __label__ = 3; break;
    case 8: // $49
      var $50=$pos;
      var $51=$i;
      var $52=(($50+$51)|0);
      var $53=$2;
      var $54=(($53+$52)|0);
      var $55=HEAP8[($54)];
      var $56=__ZL8is_delimc($55);
      var $57=(($56)|0)!=0;
      if ($57) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $58
      var $59=$i;
      var $60=$3;
      var $61=(($60+$59)|0);
      var $62=HEAP8[($61)];
      var $63=__ZL8is_delimc($62);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $65
      $1=1;
      __label__ = 19; break;
    case 11: // $66
      var $67=$i;
      var $68=$pos;
      var $69=(($68+$67)|0);
      $pos=$69;
      __label__ = 12; break;
    case 12: // $70
      var $71=$pos;
      var $72=$2;
      var $73=(($72+$71)|0);
      var $74=HEAP8[($73)];
      var $75=__ZL8is_delimc($74);
      var $76=(($75)|0)!=0;
      var $77=$76 ^ 1;
      if ($77) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $78
      var $79=$pos;
      var $80=(($79+1)|0);
      $pos=$80;
      __label__ = 12; break;
    case 14: // $81
      __label__ = 15; break;
    case 15: // $82
      var $83=$pos;
      var $84=$2;
      var $85=(($84+$83)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($87)|0)==44;
      if ($88) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $89
      var $90=$pos;
      var $91=(($90+1)|0);
      $pos=$91;
      __label__ = 15; break;
    case 17: // $92
      __label__ = 1; break;
    case 18: // $93
      $1=0;
      __label__ = 19; break;
    case 19: // $94
      var $95=$1;
      ;
      return $95;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL29image_internal_find_extensionPKcS0_["X"]=1;

function __Z23image_specify_extensionPcjPKc($buffer, $buffer_len, $extension) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $extension_pos;
      var $len;
      var $found;
      $1=$buffer;
      $2=$buffer_len;
      $3=$extension;
      $extension_pos=0;
      var $4=$1;
      var $5=_strlen($4);
      $len=$5;
      var $6=$3;
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$extension_pos;
      var $11=$3;
      var $12=(($11+$10)|0);
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $16
      var $17=$1;
      var $18=$extension_pos;
      var $19=$3;
      var $20=(($19+$18)|0);
      var $21=__ZL29image_internal_find_extensionPKcS0_($17, $20);
      $found=$21;
      var $22=$found;
      var $23=(($22)|0)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 4; break; }
    case 4: // $24
      var $25=$len;
      var $26=(($25)|0) > 0;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      var $28=$len;
      var $29=$1;
      var $30=(($29+$28)|0);
      var $31=$2;
      var $32=$len;
      var $33=(($31-$32)|0);
      var $34=_snprintf($30, $33, ((STRING_TABLE.__str7582)|0), (tempInt=STACKTOP,STACKTOP += 1,STACKTOP = ((((STACKTOP)+3)>>2)<<2),assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=0,tempInt));
      var $35=$len;
      var $36=(($35+$34)|0);
      $len=$36;
      __label__ = 6; break;
    case 6: // $37
      __label__ = 7; break;
    case 7: // $38
      var $39=$extension_pos;
      var $40=$3;
      var $41=(($40+$39)|0);
      var $42=HEAP8[($41)];
      var $43=__ZL8is_delimc($42);
      var $44=(($43)|0)!=0;
      var $45=$44 ^ 1;
      if ($45) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $46
      var $47=$found;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $49
      var $50=$len;
      var $51=$1;
      var $52=(($51+$50)|0);
      var $53=$2;
      var $54=$len;
      var $55=(($53-$54)|0);
      var $56=$extension_pos;
      var $57=$3;
      var $58=(($57+$56)|0);
      var $59=HEAP8[($58)];
      var $60=(($59 << 24) >> 24);
      var $61=_snprintf($52, $55, ((STRING_TABLE.__str17583)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$60,tempInt));
      var $62=$len;
      var $63=(($62+$61)|0);
      $len=$63;
      __label__ = 10; break;
    case 10: // $64
      var $65=$extension_pos;
      var $66=(($65+1)|0);
      $extension_pos=$66;
      __label__ = 7; break;
    case 11: // $67
      __label__ = 12; break;
    case 12: // $68
      var $69=$extension_pos;
      var $70=$3;
      var $71=(($70+$69)|0);
      var $72=HEAP8[($71)];
      var $73=(($72 << 24) >> 24);
      var $74=(($73)|0)==44;
      if ($74) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $75
      var $76=$extension_pos;
      var $77=(($76+1)|0);
      $extension_pos=$77;
      __label__ = 12; break;
    case 14: // $78
      __label__ = 2; break;
    case 15: // $79
      __label__ = 16; break;
    case 16: // $80
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z23image_specify_extensionPcjPKc["X"]=1;

function __ZL16wavfile_identifyP15_cassette_imageP15CassetteOptions($cassette, $opts) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$cassette;
  $2=$opts;
  var $3=$1;
  var $4=$2;
  var $5=__ZL15wavfile_processP15_cassette_imageP15CassetteOptionsi($3, $4, 0);
  ;
  return $5;
}


function __ZL12wavfile_loadP15_cassette_image($cassette) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $opts=__stackBase__;
  $1=$cassette;
  var $2=$opts;
  for (var $$dest = $2, $$stop = $$dest + 12; $$dest < $$stop; $$dest++) {
    HEAP8[$$dest] = 0
  };
  var $3=$1;
  var $4=__ZL15wavfile_processP15_cassette_imageP15CassetteOptionsi($3, $opts, 1);
  STACKTOP = __stackBase__;
  return $4;
}


function __ZL12wavfile_saveP15_cassette_imagePK12CassetteInfo($cassette, $info) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $err;
      var $consolidated_header=__stackBase__;
      var $header;
      var $format_tag_header;
      var $format_tag_data;
      var $data_tag_header;
      var $file_size;
      var $bytes_per_second;
      var $bits_per_sample;
      var $data_size;
      var $bytes_per_sample;
      var $waveform_flags;
      var $block_align;
      $2=$cassette;
      $3=$info;
      var $4=(($consolidated_header)|0);
      $header=$4;
      var $5=(($consolidated_header+12)|0);
      $format_tag_header=$5;
      var $6=(($consolidated_header+20)|0);
      $format_tag_data=$6;
      var $7=(($consolidated_header+36)|0);
      $data_tag_header=$7;
      $bytes_per_sample=2;
      $waveform_flags=2;
      var $8=$bytes_per_sample;
      var $9=((($8<<3))|0);
      var $10=(($9) & 65535);
      $bits_per_sample=$10;
      var $11=$3;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$bytes_per_sample;
      var $15=(($13*$14)|0);
      var $16=$3;
      var $17=(($16)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($15*$18)|0);
      $bytes_per_second=$19;
      var $20=$3;
      var $21=(($20+12)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$bytes_per_sample;
      var $24=(($22*$23)|0);
      var $25=$3;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($24*$27)|0);
      $data_size=$28;
      var $29=$data_size;
      var $30=(($29+44)|0);
      var $31=(($30-8)|0);
      $file_size=$31;
      var $32=$bytes_per_sample;
      var $33=$3;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($32*$35)|0);
      var $37=(($36) & 65535);
      $block_align=$37;
      var $38=$header;
      var $39=(($38)|0);
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($39)]=HEAP8[(((STRING_TABLE.__ZL6magic1)|0))];HEAP8[($39+1)]=HEAP8[(((STRING_TABLE.__ZL6magic1)|0)+1)];HEAP8[($39+2)]=HEAP8[(((STRING_TABLE.__ZL6magic1)|0)+2)];HEAP8[($39+3)]=HEAP8[(((STRING_TABLE.__ZL6magic1)|0)+3)];
      var $40=$header;
      var $41=(($40+8)|0);
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($41)]=HEAP8[(((STRING_TABLE.__ZL6magic2)|0))];HEAP8[($41+1)]=HEAP8[(((STRING_TABLE.__ZL6magic2)|0)+1)];HEAP8[($41+2)]=HEAP8[(((STRING_TABLE.__ZL6magic2)|0)+2)];HEAP8[($41+3)]=HEAP8[(((STRING_TABLE.__ZL6magic2)|0)+3)];
      var $42=$header;
      var $43=(($42+4)|0);
      var $44=$file_size;
      __ZL12put_leuint32Pvj($43, $44);
      var $45=$format_tag_header;
      var $46=(($45)|0);
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($46)]=HEAP8[(((STRING_TABLE.__ZL13format_tag_id)|0))];HEAP8[($46+1)]=HEAP8[(((STRING_TABLE.__ZL13format_tag_id)|0)+1)];HEAP8[($46+2)]=HEAP8[(((STRING_TABLE.__ZL13format_tag_id)|0)+2)];HEAP8[($46+3)]=HEAP8[(((STRING_TABLE.__ZL13format_tag_id)|0)+3)];
      var $47=$format_tag_header;
      var $48=(($47+4)|0);
      __ZL12put_leuint32Pvj($48, 16);
      var $49=$format_tag_data;
      var $50=(($49)|0);
      __ZL12put_leuint16Pvt($50, 1);
      var $51=$format_tag_data;
      var $52=(($51+2)|0);
      var $53=$3;
      var $54=(($53)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55) & 65535);
      __ZL12put_leuint16Pvt($52, $56);
      var $57=$format_tag_data;
      var $58=(($57+4)|0);
      var $59=$3;
      var $60=(($59+8)|0);
      var $61=HEAP32[(($60)>>2)];
      __ZL12put_leuint32Pvj($58, $61);
      var $62=$format_tag_data;
      var $63=(($62+8)|0);
      var $64=$bytes_per_second;
      __ZL12put_leuint32Pvj($63, $64);
      var $65=$format_tag_data;
      var $66=(($65+12)|0);
      var $67=$block_align;
      __ZL12put_leuint16Pvt($66, $67);
      var $68=$format_tag_data;
      var $69=(($68+14)|0);
      var $70=$bits_per_sample;
      __ZL12put_leuint16Pvt($69, $70);
      var $71=$data_tag_header;
      var $72=(($71)|0);
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($72)]=HEAP8[(((STRING_TABLE.__ZL11data_tag_id)|0))];HEAP8[($72+1)]=HEAP8[(((STRING_TABLE.__ZL11data_tag_id)|0)+1)];HEAP8[($72+2)]=HEAP8[(((STRING_TABLE.__ZL11data_tag_id)|0)+2)];HEAP8[($72+3)]=HEAP8[(((STRING_TABLE.__ZL11data_tag_id)|0)+3)];
      var $73=$data_tag_header;
      var $74=(($73+4)|0);
      var $75=$data_size;
      __ZL12put_leuint32Pvj($74, $75);
      var $76=$2;
      var $77=(($consolidated_header)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __Z20cassette_image_writeP15_cassette_imagePKvyj($76, $77, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 44);
      var $78=$2;
      var $79=$3;
      var $80=(($79)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$3;
      var $83=(($82+12)|0);
      var $84=HEAPU32[(($83)>>2)];
      var $85=(($84)>>>0);
      var $86=$3;
      var $87=(($86+8)|0);
      var $88=HEAPU32[(($87)>>2)];
      var $89=(($88)>>>0);
      var $90=$85/$89;
      var $91=$3;
      var $92=(($91+12)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$waveform_flags;
      var $$emscripten$temp$1$0=44;
      var $$emscripten$temp$1$1=0;
      var $95=__Z22cassette_write_samplesP15_cassette_imageiddjyi($78, $81, 0, $90, $93, $$emscripten$temp$1$0, $$emscripten$temp$1$1, $94);
      var $95$0=$95[0];
      $err=$95;
      var $96=$err;
      var $97=(($96)|0)!=0;
      if ($97) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $98
      var $99=$err;
      $1=$99;
      __label__ = 3; break;
    case 2: // $100
      $1=0;
      __label__ = 3; break;
    case 3: // $101
      var $102=$1;
      STACKTOP = __stackBase__;
      return $102;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL12wavfile_saveP15_cassette_imagePK12CassetteInfo["X"]=1;

function __ZL12put_leuint32Pvj($ptr, $value) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$ptr;
  HEAP32[(($2)>>2)]=$value;
  var $3=HEAP32[(($2)>>2)];
  HEAP32[(($2)>>2)]=$3;
  var $4=$1;
  var $5=$2;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($4)]=HEAP8[($5)];HEAP8[($4+1)]=HEAP8[($5+1)];HEAP8[($4+2)]=HEAP8[($5+2)];HEAP8[($4+3)]=HEAP8[($5+3)];
  STACKTOP = __stackBase__;
  return;
}


function __ZL12put_leuint16Pvt($ptr, $value) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$ptr;
  HEAP16[(($2)>>1)]=$value;
  var $3=HEAP16[(($2)>>1)];
  HEAP16[(($2)>>1)]=$3;
  var $4=$1;
  var $5=$2;
  assert(2 % 1 === 0, 'memcpy given ' + 2 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($4)]=HEAP8[($5)];HEAP8[($4+1)]=HEAP8[($5+1)];
  STACKTOP = __stackBase__;
  return;
}


function __ZL15wavfile_processP15_cassette_imageP15CassetteOptionsi($cassette, $opts, $read_waveform) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $file_header=__stackBase__;
      var $tag_header=__stackBase__+12;
      var $format_tag=__stackBase__+20;
      var $stated_size;
      var $file_size=__stackBase__+36;
      var $tag_size;
      var $tag_samples;
      var $offset=__stackBase__+44;
      var $format_specified;
      var $format_type;
      var $bytes_per_second;
      var $waveform_flags;
      $2=$cassette;
      $3=$opts;
      $4=$read_waveform;
      $format_specified=0;
      $format_type=0;
      $bytes_per_second=0;
      $waveform_flags=0;
      var $5=$2;
      var $6=(($file_header)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      __Z19cassette_image_readP15_cassette_imagePvyj($5, $6, $$emscripten$temp$0$0, $$emscripten$temp$0$1, 12);
      var $$emscripten$temp$1$0=12;
      var $$emscripten$temp$1$1=0;
      var $st$30$0=(($offset)|0);
      HEAP32[(($st$30$0)>>2)]=$$emscripten$temp$1$0;
      var $st$30$1=(($offset+4)|0);
      HEAP32[(($st$30$1)>>2)]=$$emscripten$temp$1$1;
      var $7=(($file_header)|0);
      var $8=_memcmp($7, ((STRING_TABLE.__ZL6magic1)|0), 4);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $1=4;
      __label__ = 32; break;
    case 2: // $11
      var $12=(($file_header+8)|0);
      var $13=_memcmp($12, ((STRING_TABLE.__ZL6magic2)|0), 4);
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $1=4;
      __label__ = 32; break;
    case 4: // $16
      var $17=(($file_header+4)|0);
      var $18=__ZL12get_leuint32PKv($17);
      var $19=(($18+8)|0);
      $stated_size=$19;
      var $20=$2;
      var $21=__Z19cassette_image_sizeP15_cassette_image($20);
      var $21$0=$21[0];
      var $21$1=$21[1];
      var $st$8$0=(($file_size)|0);
      HEAP32[(($st$8$0)>>2)]=$21$0;
      var $st$8$1=(($file_size+4)|0);
      HEAP32[(($st$8$1)>>2)]=$21$1;
      var $22=$stated_size;
      var $23$0=$22;
      var $23$1=0;
      var $st$15$0=(($file_size)|0);
      var $24$0=HEAP32[(($st$15$0)>>2)];
      var $st$15$1=(($file_size+4)|0);
      var $24$1=HEAP32[(($st$15$1)>>2)];
      var $25=$23$1 > $24$1 || ($23$1 == $24$1 && $23$0 > $24$0);
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      var $st$0$0=(($file_size)|0);
      var $27$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($file_size+4)|0);
      var $27$1=HEAP32[(($st$0$1)>>2)];
      var $28$0=$27$0;
      var $28=$28$0;
      $stated_size=$28;
      __label__ = 6; break;
    case 6: // $29
      __label__ = 7; break;
    case 7: // $30
      var $st$0$0=(($offset)|0);
      var $31$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($offset+4)|0);
      var $31$1=HEAP32[(($st$0$1)>>2)];
      var $32=$stated_size;
      var $33$0=$32;
      var $33$1=0;
      var $34=$31$1 < $33$1 || ($31$1 == $33$1 && $31$0 < $33$0);
      if ($34) { __label__ = 8; break; } else { __label__ = 31; break; }
    case 8: // $35
      var $36=$2;
      var $37=(($tag_header)|0);
      var $st$2$0=(($offset)|0);
      var $38$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($offset+4)|0);
      var $38$1=HEAP32[(($st$2$1)>>2)];
      __Z19cassette_image_readP15_cassette_imagePvyj($36, $37, $38$0, $38$1, 8);
      var $39=(($tag_header+4)|0);
      var $40=__ZL12get_leuint32PKv($39);
      $tag_size=$40;
      var $st$10$0=(($offset)|0);
      var $41$0=HEAP32[(($st$10$0)>>2)];
      var $st$10$1=(($offset+4)|0);
      var $41$1=HEAP32[(($st$10$1)>>2)];
      var $$emscripten$temp$2$0=8;
      var $$emscripten$temp$2$1=0;
      var $42$0 = ((($41$0)>>>0)+((($41$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296))>>>0; var $42$1 = Math.min(Math.floor((((($41$0)>>>0)+((($41$1)|0)*4294967296))+((($$emscripten$temp$2$0)>>>0)+((($$emscripten$temp$2$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$17$0=(($offset)|0);
      HEAP32[(($st$17$0)>>2)]=$42$0;
      var $st$17$1=(($offset+4)|0);
      HEAP32[(($st$17$1)>>2)]=$42$1;
      var $43=(($tag_header)|0);
      var $44=_memcmp($43, ((STRING_TABLE.__ZL13format_tag_id)|0), 4);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 22; break; } else { __label__ = 9; break; }
    case 9: // $46
      var $47=$format_specified;
      var $48=(($47)|0)!=0;
      if ($48) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $49
      var $50=$tag_size;
      var $51=(($50)>>>0) < 16;
      if ($51) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $52
      $1=4;
      __label__ = 32; break;
    case 12: // $53
      $format_specified=1;
      var $54=$2;
      var $55=(($format_tag)|0);
      var $st$3$0=(($offset)|0);
      var $56$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($offset+4)|0);
      var $56$1=HEAP32[(($st$3$1)>>2)];
      __Z19cassette_image_readP15_cassette_imagePvyj($54, $55, $56$0, $56$1, 16);
      var $57=(($format_tag)|0);
      var $58=__ZL12get_leuint16PKv($57);
      $format_type=$58;
      var $59=(($format_tag+2)|0);
      var $60=__ZL12get_leuint16PKv($59);
      var $61=(($60)&65535);
      var $62=$3;
      var $63=(($62)|0);
      HEAP32[(($63)>>2)]=$61;
      var $64=(($format_tag+4)|0);
      var $65=__ZL12get_leuint32PKv($64);
      var $66=$3;
      var $67=(($66+8)|0);
      HEAP32[(($67)>>2)]=$65;
      var $68=(($format_tag+8)|0);
      var $69=__ZL12get_leuint32PKv($68);
      $bytes_per_second=$69;
      var $70=(($format_tag+14)|0);
      var $71=__ZL12get_leuint16PKv($70);
      var $72=(($71)&65535);
      var $73=$3;
      var $74=(($73+4)|0);
      HEAP32[(($74)>>2)]=$72;
      var $75=$format_type;
      var $76=(($75)&65535);
      var $77=(($76)|0)!=1;
      if ($77) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $78
      $1=4;
      __label__ = 32; break;
    case 14: // $79
      var $80=$3;
      var $81=(($80+8)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$3;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($82*$85)|0);
      var $87=$3;
      var $88=(($87)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($86*$89)|0);
      var $91=Math.floor((($90)>>>0)/8);
      var $92=$bytes_per_second;
      var $93=(($91)|0)!=(($92)|0);
      if ($93) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $94
      $1=4;
      __label__ = 32; break;
    case 16: // $95
      var $96=$3;
      var $97=(($96+4)|0);
      var $98=HEAP32[(($97)>>2)];
      if ($98 == 8) {
        __label__ = 17; break;
      }
      else if ($98 == 16) {
        __label__ = 18; break;
      }
      else if ($98 == 32) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 17: // $99
      $waveform_flags=0;
      __label__ = 21; break;
    case 18: // $100
      $waveform_flags=2;
      __label__ = 21; break;
    case 19: // $101
      $waveform_flags=4;
      __label__ = 21; break;
    case 20: // $102
      $1=4;
      __label__ = 32; break;
    case 21: // $103
      __label__ = 30; break;
    case 22: // $104
      var $105=(($tag_header)|0);
      var $106=_memcmp($105, ((STRING_TABLE.__ZL11data_tag_id)|0), 4);
      var $107=(($106)|0)!=0;
      if ($107) { __label__ = 28; break; } else { __label__ = 23; break; }
    case 23: // $108
      var $109=$format_specified;
      var $110=(($109)|0)!=0;
      if ($110) { __label__ = 25; break; } else { __label__ = 24; break; }
    case 24: // $111
      $1=4;
      __label__ = 32; break;
    case 25: // $112
      var $113=$4;
      var $114=(($113)|0)!=0;
      if ($114) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $115
      var $116=$tag_size;
      var $117=$3;
      var $118=(($117+4)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(((($119)|0)/8)|0);
      var $121=Math.floor((($116)>>>0)/(($120)>>>0));
      var $122=$3;
      var $123=(($122)|0);
      var $124=HEAPU32[(($123)>>2)];
      var $125=Math.floor((($121)>>>0)/(($124)>>>0));
      $tag_samples=$125;
      var $126=$2;
      var $127=$3;
      var $128=(($127)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=$tag_samples;
      var $131=(($130)>>>0);
      var $132=$3;
      var $133=(($132+8)|0);
      var $134=HEAPU32[(($133)>>2)];
      var $135=(($134)>>>0);
      var $136=$131/$135;
      var $137=$tag_samples;
      var $st$23$0=(($offset)|0);
      var $138$0=HEAP32[(($st$23$0)>>2)];
      var $st$23$1=(($offset+4)|0);
      var $138$1=HEAP32[(($st$23$1)>>2)];
      var $139=$waveform_flags;
      var $140=__Z21cassette_read_samplesP15_cassette_imageiddjyi($126, $129, 0, $136, $137, $138$0, $138$1, $139);
      var $140$0=$140[0];
      __label__ = 27; break;
    case 27: // $141
      __label__ = 29; break;
    case 28: // $142
      __label__ = 29; break;
    case 29: // $143
      __label__ = 30; break;
    case 30: // $144
      var $145=$tag_size;
      var $146$0=$145;
      var $146$1=0;
      var $st$3$0=(($offset)|0);
      var $147$0=HEAP32[(($st$3$0)>>2)];
      var $st$3$1=(($offset+4)|0);
      var $147$1=HEAP32[(($st$3$1)>>2)];
      var $148$0 = ((($147$0)>>>0)+((($147$1)|0)*4294967296))+((($146$0)>>>0)+((($146$1)|0)*4294967296))>>>0; var $148$1 = Math.min(Math.floor((((($147$0)>>>0)+((($147$1)|0)*4294967296))+((($146$0)>>>0)+((($146$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$8$0=(($offset)|0);
      HEAP32[(($st$8$0)>>2)]=$148$0;
      var $st$8$1=(($offset+4)|0);
      HEAP32[(($st$8$1)>>2)]=$148$1;
      __label__ = 7; break;
    case 31: // $149
      $1=0;
      __label__ = 32; break;
    case 32: // $150
      var $151=$1;
      STACKTOP = __stackBase__;
      return $151;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZL15wavfile_processP15_cassette_imageP15CassetteOptionsi["X"]=1;

function __ZL12get_leuint32PKv($ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $value=__stackBase__;
  $1=$ptr;
  var $2=$value;
  var $3=$1;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($2)]=HEAP8[($3)];HEAP8[($2+1)]=HEAP8[($3+1)];HEAP8[($2+2)]=HEAP8[($3+2)];HEAP8[($2+3)]=HEAP8[($3+3)];
  var $4=HEAP32[(($value)>>2)];
  STACKTOP = __stackBase__;
  return $4;
}


function __ZL12get_leuint16PKv($ptr) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $value=__stackBase__;
  $1=$ptr;
  var $2=$value;
  var $3=$1;
  assert(2 % 1 === 0, 'memcpy given ' + 2 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($2)]=HEAP8[($3)];HEAP8[($2+1)]=HEAP8[($3+1)];
  var $4=HEAP16[(($value)>>1)];
  STACKTOP = __stackBase__;
  return $4;
}


function __Z15io_generic_readP10io_genericPvyj($generic, $buffer, $offset$0, $offset$1, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $size=__stackBase__+8;
      var $bytes_read;
      $1=$generic;
      $2=$buffer;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$offset$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$offset$1;
      $4=$length;
      var $5=$1;
      var $6=__Z15io_generic_sizeP10io_generic($5);
      var $6$0=$6[0];
      var $6$1=$6[1];
      var $st$17$0=(($size)|0);
      HEAP32[(($st$17$0)>>2)]=$6$0;
      var $st$17$1=(($size+4)|0);
      HEAP32[(($st$17$1)>>2)]=$6$1;
      var $st$21$0=(($size)|0);
      var $7$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($size+4)|0);
      var $7$1=HEAP32[(($st$21$1)>>2)];
      var $st$25$0=(($3)|0);
      var $8$0=HEAP32[(($st$25$0)>>2)];
      var $st$25$1=(($3+4)|0);
      var $8$1=HEAP32[(($st$25$1)>>2)];
      var $9=$7$1 <= $8$1 && ($7$1 < $8$1 || $7$0 <= $8$0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      $bytes_read=0;
      __label__ = 3; break;
    case 2: // $11
      var $12=$1;
      var $st$1$0=(($3)|0);
      var $13$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$1$1)>>2)];
      __ZL15io_generic_seekP10io_genericy($12, $13$0, $13$1);
      var $14=$1;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$1;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$2;
      var $23=$4;
      var $24=FUNCTION_TABLE[$18]($21, $22, $23);
      $bytes_read=$24;
      __label__ = 3; break;
    case 3: // $25
      var $26=$2;
      var $27=$bytes_read;
      var $28=(($26+$27)|0);
      var $29=$1;
      var $30=(($29+8)|0);
      var $31=HEAPU8[($30)];
      var $32=(($31)&255);
      var $33=(($32) & 255);
      var $34=$4;
      var $35=$bytes_read;
      var $36=(($34-$35)|0);
      _memset($28, $33, $36, 1);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z15io_generic_readP10io_genericPvyj["X"]=1;

function __Z15io_generic_sizeP10io_generic($generic) {
  ;
  var __label__;

  var $1;
  $1=$generic;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4+16)|0);
  var $6=HEAP32[(($5)>>2)];
  var $7=$1;
  var $8=(($7+4)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$6]($9);
  var $10$0=$10[0];
  var $10$1=$10[1];
  ;
  return [$10$0,$10$1];
}


function __ZL15io_generic_seekP10io_genericy($generic, $offset$0, $offset$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$generic;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$offset$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$offset$1;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5+4)|0);
  var $7=HEAP32[(($6)>>2)];
  var $8=$1;
  var $9=(($8+4)|0);
  var $10=HEAP32[(($9)>>2)];
  var $st$15$0=(($2)|0);
  var $11$0=HEAP32[(($st$15$0)>>2)];
  var $st$15$1=(($2+4)|0);
  var $11$1=HEAP32[(($st$15$1)>>2)];
  var $12=FUNCTION_TABLE[$7]($10, $11$0, $11$1, 0);
  var $12$0=$12[0];
  STACKTOP = __stackBase__;
  return;
}


function __Z16io_generic_writeP10io_genericPKvyj($generic, $buffer, $offset$0, $offset$1, $length) {
  var __stackBase__  = STACKTOP; STACKTOP += 1048; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $filler_size=__stackBase__+8;
      var $filler_buffer=__stackBase__+16;
      var $bytes_to_write;
      var $size=__stackBase__+1040;
      $1=$generic;
      $2=$buffer;
      var $st$10$0=(($3)|0);
      HEAP32[(($st$10$0)>>2)]=$offset$0;
      var $st$10$1=(($3+4)|0);
      HEAP32[(($st$10$1)>>2)]=$offset$1;
      $4=$length;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$17$0=(($filler_size)|0);
      HEAP32[(($st$17$0)>>2)]=$$emscripten$temp$0$0;
      var $st$17$1=(($filler_size+4)|0);
      HEAP32[(($st$17$1)>>2)]=$$emscripten$temp$0$1;
      var $st$21$0=(($3)|0);
      var $5$0=HEAP32[(($st$21$0)>>2)];
      var $st$21$1=(($3+4)|0);
      var $5$1=HEAP32[(($st$21$1)>>2)];
      var $$emscripten$temp$1$0=171088;
      var $$emscripten$temp$1$1=0;
      var $6=$5$1 > $$emscripten$temp$1$1 || ($5$1 == $$emscripten$temp$1$1 && $5$0 > $$emscripten$temp$1$0);
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $st$0$0=(($3)|0);
      var $8$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $8$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($3)|0);
      HEAP32[(($st$4$0)>>2)]=$8$0;
      var $st$4$1=(($3+4)|0);
      HEAP32[(($st$4$1)>>2)]=$8$1;
      __label__ = 2; break;
    case 2: // $9
      var $10=$1;
      var $11=__Z15io_generic_sizeP10io_generic($10);
      var $11$0=$11[0];
      var $11$1=$11[1];
      var $st$4$0=(($size)|0);
      HEAP32[(($st$4$0)>>2)]=$11$0;
      var $st$4$1=(($size+4)|0);
      HEAP32[(($st$4$1)>>2)]=$11$1;
      var $st$8$0=(($size)|0);
      var $12$0=HEAP32[(($st$8$0)>>2)];
      var $st$8$1=(($size+4)|0);
      var $12$1=HEAP32[(($st$8$1)>>2)];
      var $st$12$0=(($3)|0);
      var $13$0=HEAP32[(($st$12$0)>>2)];
      var $st$12$1=(($3+4)|0);
      var $13$1=HEAP32[(($st$12$1)>>2)];
      var $14=$12$1 < $13$1 || ($12$1 == $13$1 && $12$0 < $13$0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $st$0$0=(($3)|0);
      var $16$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($3+4)|0);
      var $16$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($size)|0);
      var $17$0=HEAP32[(($st$4$0)>>2)];
      var $st$4$1=(($size+4)|0);
      var $17$1=HEAP32[(($st$4$1)>>2)];
      var $18$0 = ((($16$0)>>>0)+((($16$1)|0)*4294967296))-((($17$0)>>>0)+((($17$1)|0)*4294967296))>>>0; var $18$1 = Math.min(Math.floor((((($16$0)>>>0)+((($16$1)|0)*4294967296))-((($17$0)>>>0)+((($17$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$9$0=(($filler_size)|0);
      HEAP32[(($st$9$0)>>2)]=$18$0;
      var $st$9$1=(($filler_size+4)|0);
      HEAP32[(($st$9$1)>>2)]=$18$1;
      var $st$13$0=(($size)|0);
      var $19$0=HEAP32[(($st$13$0)>>2)];
      var $st$13$1=(($size+4)|0);
      var $19$1=HEAP32[(($st$13$1)>>2)];
      var $st$17$0=(($3)|0);
      HEAP32[(($st$17$0)>>2)]=$19$0;
      var $st$17$1=(($3+4)|0);
      HEAP32[(($st$17$1)>>2)]=$19$1;
      __label__ = 4; break;
    case 4: // $20
      var $21=$1;
      var $st$1$0=(($3)|0);
      var $22$0=HEAP32[(($st$1$0)>>2)];
      var $st$1$1=(($3+4)|0);
      var $22$1=HEAP32[(($st$1$1)>>2)];
      __ZL15io_generic_seekP10io_genericy($21, $22$0, $22$1);
      var $st$6$0=(($filler_size)|0);
      var $23$0=HEAP32[(($st$6$0)>>2)];
      var $st$6$1=(($filler_size+4)|0);
      var $23$1=HEAP32[(($st$6$1)>>2)];
      var $$emscripten$temp$2$0=0;
      var $$emscripten$temp$2$1=0;
      var $24=$23$0 != $$emscripten$temp$2$0 || $23$1 != $$emscripten$temp$2$1;
      if ($24) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $25
      var $26=(($filler_buffer)|0);
      var $27=$1;
      var $28=(($27+8)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=(($30) & 255);
      _memset($26, $31, 4, 1);
      __label__ = 6; break;
    case 6: // $32
      var $st$0$0=(($filler_size)|0);
      var $33$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($filler_size+4)|0);
      var $33$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$3$0=1024;
      var $$emscripten$temp$3$1=0;
      var $34=$33$1 > $$emscripten$temp$3$1 || ($33$1 == $$emscripten$temp$3$1 && $33$0 > $$emscripten$temp$3$0);
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $40 = 1024;__label__ = 9; break;
    case 8: // $36
      var $st$0$0=(($filler_size)|0);
      var $37$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($filler_size+4)|0);
      var $37$1=HEAP32[(($st$0$1)>>2)];
      var $38$0=$37$0;
      var $38=$38$0;
      var $40 = $38;__label__ = 9; break;
    case 9: // $39
      var $40;
      $bytes_to_write=$40;
      var $41=$1;
      var $42=(($41)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+12)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=$1;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=(($filler_buffer)|0);
      var $50=$bytes_to_write;
      var $51=FUNCTION_TABLE[$45]($48, $49, $50);
      var $52=$bytes_to_write;
      var $53$0=$52;
      var $53$1=0;
      var $st$16$0=(($filler_size)|0);
      var $54$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($filler_size+4)|0);
      var $54$1=HEAP32[(($st$16$1)>>2)];
      var $55$0 = ((($54$0)>>>0)+((($54$1)|0)*4294967296))-((($53$0)>>>0)+((($53$1)|0)*4294967296))>>>0; var $55$1 = Math.min(Math.floor((((($54$0)>>>0)+((($54$1)|0)*4294967296))-((($53$0)>>>0)+((($53$1)|0)*4294967296)))/4294967296), 4294967295);
      var $st$21$0=(($filler_size)|0);
      HEAP32[(($st$21$0)>>2)]=$55$0;
      var $st$21$1=(($filler_size+4)|0);
      HEAP32[(($st$21$1)>>2)]=$55$1;
      __label__ = 10; break;
    case 10: // $56
      var $st$0$0=(($filler_size)|0);
      var $57$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($filler_size+4)|0);
      var $57$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $58=$57$1 > $$emscripten$temp$4$1 || ($57$1 == $$emscripten$temp$4$1 && $57$0 > $$emscripten$temp$4$0);
      if ($58) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 11: // $59
      __label__ = 12; break;
    case 12: // $60
      var $61=$4;
      var $62=(($61)>>>0) > 0;
      if ($62) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $63
      var $64=$1;
      var $65=(($64)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66+12)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$1;
      var $70=(($69+4)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=$4;
      var $74=FUNCTION_TABLE[$68]($71, $72, $73);
      __label__ = 14; break;
    case 14: // $75
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__Z16io_generic_writeP10io_genericPKvyj["X"]=1;

function _crc32_little($crc, $buf, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $c;
      var $buf4;
      $1=$crc;
      $2=$buf;
      $3=$len;
      var $4=$1;
      $c=$4;
      var $5=$c;
      var $6=$5 ^ -1;
      $c=$6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$3;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { var $16 = 0;__label__ = 3; break; }
    case 2: // $10
      var $11=$2;
      var $12=$11;
      var $13=$12 & 3;
      var $14=(($13)|0)!=0;
      var $16 = $14;__label__ = 3; break;
    case 3: // $15
      var $16;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      var $18=$c;
      var $19=$2;
      var $20=(($19+1)|0);
      $2=$20;
      var $21=HEAPU8[($19)];
      var $22=(($21)&255);
      var $23=$18 ^ $22;
      var $24=$23 & 255;
      var $25=((((_crc_table)|0)+($24<<2))|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$c;
      var $28=$27 >>> 8;
      var $29=$26 ^ $28;
      $c=$29;
      var $30=$3;
      var $31=(($30-1)|0);
      $3=$31;
      __label__ = 1; break;
    case 5: // $32
      var $33=$2;
      var $34=$33;
      $buf4=$34;
      __label__ = 6; break;
    case 6: // $35
      var $36=$3;
      var $37=(($36)>>>0) >= 32;
      if ($37) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $38
      var $39=$buf4;
      var $40=(($39+4)|0);
      $buf4=$40;
      var $41=HEAP32[(($39)>>2)];
      var $42=$c;
      var $43=$42 ^ $41;
      $c=$43;
      var $44=$c;
      var $45=$44 & 255;
      var $46=((((_crc_table+3072)|0)+($45<<2))|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$c;
      var $49=$48 >>> 8;
      var $50=$49 & 255;
      var $51=((((_crc_table+2048)|0)+($50<<2))|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$47 ^ $52;
      var $54=$c;
      var $55=$54 >>> 16;
      var $56=$55 & 255;
      var $57=((((_crc_table+1024)|0)+($56<<2))|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$53 ^ $58;
      var $60=$c;
      var $61=$60 >>> 24;
      var $62=((((_crc_table)|0)+($61<<2))|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$59 ^ $63;
      $c=$64;
      var $65=$buf4;
      var $66=(($65+4)|0);
      $buf4=$66;
      var $67=HEAP32[(($65)>>2)];
      var $68=$c;
      var $69=$68 ^ $67;
      $c=$69;
      var $70=$c;
      var $71=$70 & 255;
      var $72=((((_crc_table+3072)|0)+($71<<2))|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$c;
      var $75=$74 >>> 8;
      var $76=$75 & 255;
      var $77=((((_crc_table+2048)|0)+($76<<2))|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$73 ^ $78;
      var $80=$c;
      var $81=$80 >>> 16;
      var $82=$81 & 255;
      var $83=((((_crc_table+1024)|0)+($82<<2))|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$79 ^ $84;
      var $86=$c;
      var $87=$86 >>> 24;
      var $88=((((_crc_table)|0)+($87<<2))|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$85 ^ $89;
      $c=$90;
      var $91=$buf4;
      var $92=(($91+4)|0);
      $buf4=$92;
      var $93=HEAP32[(($91)>>2)];
      var $94=$c;
      var $95=$94 ^ $93;
      $c=$95;
      var $96=$c;
      var $97=$96 & 255;
      var $98=((((_crc_table+3072)|0)+($97<<2))|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$c;
      var $101=$100 >>> 8;
      var $102=$101 & 255;
      var $103=((((_crc_table+2048)|0)+($102<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$99 ^ $104;
      var $106=$c;
      var $107=$106 >>> 16;
      var $108=$107 & 255;
      var $109=((((_crc_table+1024)|0)+($108<<2))|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$105 ^ $110;
      var $112=$c;
      var $113=$112 >>> 24;
      var $114=((((_crc_table)|0)+($113<<2))|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=$111 ^ $115;
      $c=$116;
      var $117=$buf4;
      var $118=(($117+4)|0);
      $buf4=$118;
      var $119=HEAP32[(($117)>>2)];
      var $120=$c;
      var $121=$120 ^ $119;
      $c=$121;
      var $122=$c;
      var $123=$122 & 255;
      var $124=((((_crc_table+3072)|0)+($123<<2))|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$c;
      var $127=$126 >>> 8;
      var $128=$127 & 255;
      var $129=((((_crc_table+2048)|0)+($128<<2))|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$125 ^ $130;
      var $132=$c;
      var $133=$132 >>> 16;
      var $134=$133 & 255;
      var $135=((((_crc_table+1024)|0)+($134<<2))|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=$131 ^ $136;
      var $138=$c;
      var $139=$138 >>> 24;
      var $140=((((_crc_table)|0)+($139<<2))|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$137 ^ $141;
      $c=$142;
      var $143=$buf4;
      var $144=(($143+4)|0);
      $buf4=$144;
      var $145=HEAP32[(($143)>>2)];
      var $146=$c;
      var $147=$146 ^ $145;
      $c=$147;
      var $148=$c;
      var $149=$148 & 255;
      var $150=((((_crc_table+3072)|0)+($149<<2))|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$c;
      var $153=$152 >>> 8;
      var $154=$153 & 255;
      var $155=((((_crc_table+2048)|0)+($154<<2))|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$151 ^ $156;
      var $158=$c;
      var $159=$158 >>> 16;
      var $160=$159 & 255;
      var $161=((((_crc_table+1024)|0)+($160<<2))|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$157 ^ $162;
      var $164=$c;
      var $165=$164 >>> 24;
      var $166=((((_crc_table)|0)+($165<<2))|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=$163 ^ $167;
      $c=$168;
      var $169=$buf4;
      var $170=(($169+4)|0);
      $buf4=$170;
      var $171=HEAP32[(($169)>>2)];
      var $172=$c;
      var $173=$172 ^ $171;
      $c=$173;
      var $174=$c;
      var $175=$174 & 255;
      var $176=((((_crc_table+3072)|0)+($175<<2))|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$c;
      var $179=$178 >>> 8;
      var $180=$179 & 255;
      var $181=((((_crc_table+2048)|0)+($180<<2))|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$177 ^ $182;
      var $184=$c;
      var $185=$184 >>> 16;
      var $186=$185 & 255;
      var $187=((((_crc_table+1024)|0)+($186<<2))|0);
      var $188=HEAP32[(($187)>>2)];
      var $189=$183 ^ $188;
      var $190=$c;
      var $191=$190 >>> 24;
      var $192=((((_crc_table)|0)+($191<<2))|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=$189 ^ $193;
      $c=$194;
      var $195=$buf4;
      var $196=(($195+4)|0);
      $buf4=$196;
      var $197=HEAP32[(($195)>>2)];
      var $198=$c;
      var $199=$198 ^ $197;
      $c=$199;
      var $200=$c;
      var $201=$200 & 255;
      var $202=((((_crc_table+3072)|0)+($201<<2))|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$c;
      var $205=$204 >>> 8;
      var $206=$205 & 255;
      var $207=((((_crc_table+2048)|0)+($206<<2))|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=$203 ^ $208;
      var $210=$c;
      var $211=$210 >>> 16;
      var $212=$211 & 255;
      var $213=((((_crc_table+1024)|0)+($212<<2))|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=$209 ^ $214;
      var $216=$c;
      var $217=$216 >>> 24;
      var $218=((((_crc_table)|0)+($217<<2))|0);
      var $219=HEAP32[(($218)>>2)];
      var $220=$215 ^ $219;
      $c=$220;
      var $221=$buf4;
      var $222=(($221+4)|0);
      $buf4=$222;
      var $223=HEAP32[(($221)>>2)];
      var $224=$c;
      var $225=$224 ^ $223;
      $c=$225;
      var $226=$c;
      var $227=$226 & 255;
      var $228=((((_crc_table+3072)|0)+($227<<2))|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=$c;
      var $231=$230 >>> 8;
      var $232=$231 & 255;
      var $233=((((_crc_table+2048)|0)+($232<<2))|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$229 ^ $234;
      var $236=$c;
      var $237=$236 >>> 16;
      var $238=$237 & 255;
      var $239=((((_crc_table+1024)|0)+($238<<2))|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$235 ^ $240;
      var $242=$c;
      var $243=$242 >>> 24;
      var $244=((((_crc_table)|0)+($243<<2))|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=$241 ^ $245;
      $c=$246;
      var $247=$3;
      var $248=(($247-32)|0);
      $3=$248;
      __label__ = 6; break;
    case 8: // $249
      __label__ = 9; break;
    case 9: // $250
      var $251=$3;
      var $252=(($251)>>>0) >= 4;
      if ($252) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $253
      var $254=$buf4;
      var $255=(($254+4)|0);
      $buf4=$255;
      var $256=HEAP32[(($254)>>2)];
      var $257=$c;
      var $258=$257 ^ $256;
      $c=$258;
      var $259=$c;
      var $260=$259 & 255;
      var $261=((((_crc_table+3072)|0)+($260<<2))|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$c;
      var $264=$263 >>> 8;
      var $265=$264 & 255;
      var $266=((((_crc_table+2048)|0)+($265<<2))|0);
      var $267=HEAP32[(($266)>>2)];
      var $268=$262 ^ $267;
      var $269=$c;
      var $270=$269 >>> 16;
      var $271=$270 & 255;
      var $272=((((_crc_table+1024)|0)+($271<<2))|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=$268 ^ $273;
      var $275=$c;
      var $276=$275 >>> 24;
      var $277=((((_crc_table)|0)+($276<<2))|0);
      var $278=HEAP32[(($277)>>2)];
      var $279=$274 ^ $278;
      $c=$279;
      var $280=$3;
      var $281=(($280-4)|0);
      $3=$281;
      __label__ = 9; break;
    case 11: // $282
      var $283=$buf4;
      var $284=$283;
      $2=$284;
      var $285=$3;
      var $286=(($285)|0)!=0;
      if ($286) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $287
      __label__ = 13; break;
    case 13: // $288
      var $289=$c;
      var $290=$2;
      var $291=(($290+1)|0);
      $2=$291;
      var $292=HEAPU8[($290)];
      var $293=(($292)&255);
      var $294=$289 ^ $293;
      var $295=$294 & 255;
      var $296=((((_crc_table)|0)+($295<<2))|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$c;
      var $299=$298 >>> 8;
      var $300=$297 ^ $299;
      $c=$300;
      __label__ = 14; break;
    case 14: // $301
      var $302=$3;
      var $303=(($302-1)|0);
      $3=$303;
      var $304=(($303)|0)!=0;
      if ($304) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 15: // $305
      __label__ = 16; break;
    case 16: // $306
      var $307=$c;
      var $308=$307 ^ -1;
      $c=$308;
      var $309=$c;
      ;
      return $309;
    default: assert(0, "bad label: " + __label__);
  }
}
_crc32_little["X"]=1;

function _crc32_big($crc, $buf, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $c;
      var $buf4;
      $1=$crc;
      $2=$buf;
      $3=$len;
      var $4=$1;
      var $5=$4 >>> 24;
      var $6=$1;
      var $7=$6 >>> 8;
      var $8=$7 & 65280;
      var $9=(($5+$8)|0);
      var $10=$1;
      var $11=$10 & 65280;
      var $12=$11 << 8;
      var $13=(($9+$12)|0);
      var $14=$1;
      var $15=$14 & 255;
      var $16=$15 << 24;
      var $17=(($13+$16)|0);
      $c=$17;
      var $18=$c;
      var $19=$18 ^ -1;
      $c=$19;
      __label__ = 1; break;
    case 1: // $20
      var $21=$3;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 2; break; } else { var $29 = 0;__label__ = 3; break; }
    case 2: // $23
      var $24=$2;
      var $25=$24;
      var $26=$25 & 3;
      var $27=(($26)|0)!=0;
      var $29 = $27;__label__ = 3; break;
    case 3: // $28
      var $29;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$c;
      var $32=$31 >>> 24;
      var $33=$2;
      var $34=(($33+1)|0);
      $2=$34;
      var $35=HEAPU8[($33)];
      var $36=(($35)&255);
      var $37=$32 ^ $36;
      var $38=((((_crc_table+4096)|0)+($37<<2))|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=$c;
      var $41=$40 << 8;
      var $42=$39 ^ $41;
      $c=$42;
      var $43=$3;
      var $44=(($43-1)|0);
      $3=$44;
      __label__ = 1; break;
    case 5: // $45
      var $46=$2;
      var $47=$46;
      $buf4=$47;
      var $48=$buf4;
      var $49=(($48-4)|0);
      $buf4=$49;
      __label__ = 6; break;
    case 6: // $50
      var $51=$3;
      var $52=(($51)>>>0) >= 32;
      if ($52) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $53
      var $54=$buf4;
      var $55=(($54+4)|0);
      $buf4=$55;
      var $56=HEAP32[(($55)>>2)];
      var $57=$c;
      var $58=$57 ^ $56;
      $c=$58;
      var $59=$c;
      var $60=$59 & 255;
      var $61=((((_crc_table+4096)|0)+($60<<2))|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$c;
      var $64=$63 >>> 8;
      var $65=$64 & 255;
      var $66=((((_crc_table+5120)|0)+($65<<2))|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$62 ^ $67;
      var $69=$c;
      var $70=$69 >>> 16;
      var $71=$70 & 255;
      var $72=((((_crc_table+6144)|0)+($71<<2))|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$68 ^ $73;
      var $75=$c;
      var $76=$75 >>> 24;
      var $77=((((_crc_table+7168)|0)+($76<<2))|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$74 ^ $78;
      $c=$79;
      var $80=$buf4;
      var $81=(($80+4)|0);
      $buf4=$81;
      var $82=HEAP32[(($81)>>2)];
      var $83=$c;
      var $84=$83 ^ $82;
      $c=$84;
      var $85=$c;
      var $86=$85 & 255;
      var $87=((((_crc_table+4096)|0)+($86<<2))|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$c;
      var $90=$89 >>> 8;
      var $91=$90 & 255;
      var $92=((((_crc_table+5120)|0)+($91<<2))|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$88 ^ $93;
      var $95=$c;
      var $96=$95 >>> 16;
      var $97=$96 & 255;
      var $98=((((_crc_table+6144)|0)+($97<<2))|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$94 ^ $99;
      var $101=$c;
      var $102=$101 >>> 24;
      var $103=((((_crc_table+7168)|0)+($102<<2))|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$100 ^ $104;
      $c=$105;
      var $106=$buf4;
      var $107=(($106+4)|0);
      $buf4=$107;
      var $108=HEAP32[(($107)>>2)];
      var $109=$c;
      var $110=$109 ^ $108;
      $c=$110;
      var $111=$c;
      var $112=$111 & 255;
      var $113=((((_crc_table+4096)|0)+($112<<2))|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=$c;
      var $116=$115 >>> 8;
      var $117=$116 & 255;
      var $118=((((_crc_table+5120)|0)+($117<<2))|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$114 ^ $119;
      var $121=$c;
      var $122=$121 >>> 16;
      var $123=$122 & 255;
      var $124=((((_crc_table+6144)|0)+($123<<2))|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$120 ^ $125;
      var $127=$c;
      var $128=$127 >>> 24;
      var $129=((((_crc_table+7168)|0)+($128<<2))|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$126 ^ $130;
      $c=$131;
      var $132=$buf4;
      var $133=(($132+4)|0);
      $buf4=$133;
      var $134=HEAP32[(($133)>>2)];
      var $135=$c;
      var $136=$135 ^ $134;
      $c=$136;
      var $137=$c;
      var $138=$137 & 255;
      var $139=((((_crc_table+4096)|0)+($138<<2))|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=$c;
      var $142=$141 >>> 8;
      var $143=$142 & 255;
      var $144=((((_crc_table+5120)|0)+($143<<2))|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$140 ^ $145;
      var $147=$c;
      var $148=$147 >>> 16;
      var $149=$148 & 255;
      var $150=((((_crc_table+6144)|0)+($149<<2))|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$146 ^ $151;
      var $153=$c;
      var $154=$153 >>> 24;
      var $155=((((_crc_table+7168)|0)+($154<<2))|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$152 ^ $156;
      $c=$157;
      var $158=$buf4;
      var $159=(($158+4)|0);
      $buf4=$159;
      var $160=HEAP32[(($159)>>2)];
      var $161=$c;
      var $162=$161 ^ $160;
      $c=$162;
      var $163=$c;
      var $164=$163 & 255;
      var $165=((((_crc_table+4096)|0)+($164<<2))|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=$c;
      var $168=$167 >>> 8;
      var $169=$168 & 255;
      var $170=((((_crc_table+5120)|0)+($169<<2))|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=$166 ^ $171;
      var $173=$c;
      var $174=$173 >>> 16;
      var $175=$174 & 255;
      var $176=((((_crc_table+6144)|0)+($175<<2))|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$172 ^ $177;
      var $179=$c;
      var $180=$179 >>> 24;
      var $181=((((_crc_table+7168)|0)+($180<<2))|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$178 ^ $182;
      $c=$183;
      var $184=$buf4;
      var $185=(($184+4)|0);
      $buf4=$185;
      var $186=HEAP32[(($185)>>2)];
      var $187=$c;
      var $188=$187 ^ $186;
      $c=$188;
      var $189=$c;
      var $190=$189 & 255;
      var $191=((((_crc_table+4096)|0)+($190<<2))|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=$c;
      var $194=$193 >>> 8;
      var $195=$194 & 255;
      var $196=((((_crc_table+5120)|0)+($195<<2))|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=$192 ^ $197;
      var $199=$c;
      var $200=$199 >>> 16;
      var $201=$200 & 255;
      var $202=((((_crc_table+6144)|0)+($201<<2))|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=$198 ^ $203;
      var $205=$c;
      var $206=$205 >>> 24;
      var $207=((((_crc_table+7168)|0)+($206<<2))|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=$204 ^ $208;
      $c=$209;
      var $210=$buf4;
      var $211=(($210+4)|0);
      $buf4=$211;
      var $212=HEAP32[(($211)>>2)];
      var $213=$c;
      var $214=$213 ^ $212;
      $c=$214;
      var $215=$c;
      var $216=$215 & 255;
      var $217=((((_crc_table+4096)|0)+($216<<2))|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$c;
      var $220=$219 >>> 8;
      var $221=$220 & 255;
      var $222=((((_crc_table+5120)|0)+($221<<2))|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=$218 ^ $223;
      var $225=$c;
      var $226=$225 >>> 16;
      var $227=$226 & 255;
      var $228=((((_crc_table+6144)|0)+($227<<2))|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=$224 ^ $229;
      var $231=$c;
      var $232=$231 >>> 24;
      var $233=((((_crc_table+7168)|0)+($232<<2))|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=$230 ^ $234;
      $c=$235;
      var $236=$buf4;
      var $237=(($236+4)|0);
      $buf4=$237;
      var $238=HEAP32[(($237)>>2)];
      var $239=$c;
      var $240=$239 ^ $238;
      $c=$240;
      var $241=$c;
      var $242=$241 & 255;
      var $243=((((_crc_table+4096)|0)+($242<<2))|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=$c;
      var $246=$245 >>> 8;
      var $247=$246 & 255;
      var $248=((((_crc_table+5120)|0)+($247<<2))|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=$244 ^ $249;
      var $251=$c;
      var $252=$251 >>> 16;
      var $253=$252 & 255;
      var $254=((((_crc_table+6144)|0)+($253<<2))|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$250 ^ $255;
      var $257=$c;
      var $258=$257 >>> 24;
      var $259=((((_crc_table+7168)|0)+($258<<2))|0);
      var $260=HEAP32[(($259)>>2)];
      var $261=$256 ^ $260;
      $c=$261;
      var $262=$3;
      var $263=(($262-32)|0);
      $3=$263;
      __label__ = 6; break;
    case 8: // $264
      __label__ = 9; break;
    case 9: // $265
      var $266=$3;
      var $267=(($266)>>>0) >= 4;
      if ($267) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $268
      var $269=$buf4;
      var $270=(($269+4)|0);
      $buf4=$270;
      var $271=HEAP32[(($270)>>2)];
      var $272=$c;
      var $273=$272 ^ $271;
      $c=$273;
      var $274=$c;
      var $275=$274 & 255;
      var $276=((((_crc_table+4096)|0)+($275<<2))|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$c;
      var $279=$278 >>> 8;
      var $280=$279 & 255;
      var $281=((((_crc_table+5120)|0)+($280<<2))|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=$277 ^ $282;
      var $284=$c;
      var $285=$284 >>> 16;
      var $286=$285 & 255;
      var $287=((((_crc_table+6144)|0)+($286<<2))|0);
      var $288=HEAP32[(($287)>>2)];
      var $289=$283 ^ $288;
      var $290=$c;
      var $291=$290 >>> 24;
      var $292=((((_crc_table+7168)|0)+($291<<2))|0);
      var $293=HEAP32[(($292)>>2)];
      var $294=$289 ^ $293;
      $c=$294;
      var $295=$3;
      var $296=(($295-4)|0);
      $3=$296;
      __label__ = 9; break;
    case 11: // $297
      var $298=$buf4;
      var $299=(($298+4)|0);
      $buf4=$299;
      var $300=$buf4;
      var $301=$300;
      $2=$301;
      var $302=$3;
      var $303=(($302)|0)!=0;
      if ($303) { __label__ = 12; break; } else { __label__ = 16; break; }
    case 12: // $304
      __label__ = 13; break;
    case 13: // $305
      var $306=$c;
      var $307=$306 >>> 24;
      var $308=$2;
      var $309=(($308+1)|0);
      $2=$309;
      var $310=HEAPU8[($308)];
      var $311=(($310)&255);
      var $312=$307 ^ $311;
      var $313=((((_crc_table+4096)|0)+($312<<2))|0);
      var $314=HEAP32[(($313)>>2)];
      var $315=$c;
      var $316=$315 << 8;
      var $317=$314 ^ $316;
      $c=$317;
      __label__ = 14; break;
    case 14: // $318
      var $319=$3;
      var $320=(($319-1)|0);
      $3=$320;
      var $321=(($320)|0)!=0;
      if ($321) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 15: // $322
      __label__ = 16; break;
    case 16: // $323
      var $324=$c;
      var $325=$324 ^ -1;
      $c=$325;
      var $326=$c;
      var $327=$326 >>> 24;
      var $328=$c;
      var $329=$328 >>> 8;
      var $330=$329 & 65280;
      var $331=(($327+$330)|0);
      var $332=$c;
      var $333=$332 & 65280;
      var $334=$333 << 8;
      var $335=(($331+$334)|0);
      var $336=$c;
      var $337=$336 & 255;
      var $338=$337 << 24;
      var $339=(($335+$338)|0);
      ;
      return $339;
    default: assert(0, "bad label: " + __label__);
  }
}
_crc32_big["X"]=1;

function _inflateReset($strm) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $state;
      $2=$strm;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=-2;
      __label__ = 4; break;
    case 3: // $11
      var $12=$2;
      var $13=(($12+28)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=$14;
      $state=$15;
      var $16=$state;
      var $17=(($16+28)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=$2;
      var $19=(($18+20)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=$2;
      var $21=(($20+8)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=$2;
      var $23=(($22+24)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=$2;
      var $25=(($24+48)|0);
      HEAP32[(($25)>>2)]=1;
      var $26=$state;
      var $27=(($26)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=$state;
      var $29=(($28+4)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=$state;
      var $31=(($30+12)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=$state;
      var $33=(($32+20)|0);
      HEAP32[(($33)>>2)]=32768;
      var $34=$state;
      var $35=(($34+32)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=$state;
      var $37=(($36+40)|0);
      HEAP32[(($37)>>2)]=0;
      var $38=$state;
      var $39=(($38+44)|0);
      HEAP32[(($39)>>2)]=0;
      var $40=$state;
      var $41=(($40+48)|0);
      HEAP32[(($41)>>2)]=0;
      var $42=$state;
      var $43=(($42+56)|0);
      HEAP32[(($43)>>2)]=0;
      var $44=$state;
      var $45=(($44+60)|0);
      HEAP32[(($45)>>2)]=0;
      var $46=$state;
      var $47=(($46+1328)|0);
      var $48=(($47)|0);
      var $49=$state;
      var $50=(($49+108)|0);
      HEAP32[(($50)>>2)]=$48;
      var $51=$state;
      var $52=(($51+80)|0);
      HEAP32[(($52)>>2)]=$48;
      var $53=$state;
      var $54=(($53+76)|0);
      HEAP32[(($54)>>2)]=$48;
      $1=0;
      __label__ = 4; break;
    case 4: // $55
      var $56=$1;
      ;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
_inflateReset["X"]=1;

function _crc32($crc, $buf, $len) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $endian=__stackBase__;
      $2=$crc;
      $3=$buf;
      $4=$len;
      var $5=$3;
      var $6=(($5)|0)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      $1=0;
      __label__ = 5; break;
    case 2: // $8
      HEAP32[(($endian)>>2)]=1;
      var $9=$endian;
      var $10=HEAP8[($9)];
      var $11=(($10 << 24) >> 24)!=0;
      if ($11) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $12
      var $13=$2;
      var $14=$3;
      var $15=$4;
      var $16=_crc32_little($13, $14, $15);
      $1=$16;
      __label__ = 5; break;
    case 4: // $17
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $21=_crc32_big($18, $19, $20);
      $1=$21;
      __label__ = 5; break;
    case 5: // $22
      var $23=$1;
      STACKTOP = __stackBase__;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function _inflateInit2_($strm, $windowBits, $version, $stream_size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $state;
      $2=$strm;
      $3=$windowBits;
      $4=$version;
      $5=$stream_size;
      var $6=$4;
      var $7=(($6)|0)==0;
      if ($7) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=$4;
      var $10=(($9)|0);
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=HEAP8[(((STRING_TABLE.__str7601)|0))];
      var $14=(($13 << 24) >> 24);
      var $15=(($12)|0)!=(($14)|0);
      if ($15) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $16
      var $17=$5;
      var $18=(($17)|0)!=56;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      $1=-6;
      __label__ = 21; break;
    case 4: // $20
      var $21=$2;
      var $22=(($21)|0)==0;
      if ($22) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $23
      $1=-2;
      __label__ = 21; break;
    case 6: // $24
      var $25=$2;
      var $26=(($25+24)|0);
      HEAP32[(($26)>>2)]=0;
      var $27=$2;
      var $28=(($27+32)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$2;
      var $33=(($32+32)|0);
      HEAP32[(($33)>>2)]=1652;
      var $34=$2;
      var $35=(($34+40)|0);
      HEAP32[(($35)>>2)]=0;
      __label__ = 8; break;
    case 8: // $36
      var $37=$2;
      var $38=(($37+36)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $41
      var $42=$2;
      var $43=(($42+36)|0);
      HEAP32[(($43)>>2)]=1654;
      __label__ = 10; break;
    case 10: // $44
      var $45=$2;
      var $46=(($45+32)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$2;
      var $49=(($48+40)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=FUNCTION_TABLE[$47]($50, 1, 9520);
      var $52=$51;
      $state=$52;
      var $53=$state;
      var $54=(($53)|0)==0;
      if ($54) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $55
      $1=-4;
      __label__ = 21; break;
    case 12: // $56
      var $57=$state;
      var $58=$57;
      var $59=$2;
      var $60=(($59+28)|0);
      HEAP32[(($60)>>2)]=$58;
      var $61=$3;
      var $62=(($61)|0) < 0;
      if ($62) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $63
      var $64=$state;
      var $65=(($64+8)|0);
      HEAP32[(($65)>>2)]=0;
      var $66=$3;
      var $67=(((-$66))|0);
      $3=$67;
      __label__ = 17; break;
    case 14: // $68
      var $69=$3;
      var $70=$69 >> 4;
      var $71=(($70+1)|0);
      var $72=$state;
      var $73=(($72+8)|0);
      HEAP32[(($73)>>2)]=$71;
      var $74=$3;
      var $75=(($74)|0) < 48;
      if ($75) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $76
      var $77=$3;
      var $78=$77 & 15;
      $3=$78;
      __label__ = 16; break;
    case 16: // $79
      __label__ = 17; break;
    case 17: // $80
      var $81=$3;
      var $82=(($81)|0) < 8;
      if ($82) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $83
      var $84=$3;
      var $85=(($84)|0) > 15;
      if ($85) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $86
      var $87=$2;
      var $88=(($87+36)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$2;
      var $91=(($90+40)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$state;
      var $94=$93;
      FUNCTION_TABLE[$89]($92, $94);
      var $95=$2;
      var $96=(($95+28)|0);
      HEAP32[(($96)>>2)]=0;
      $1=-2;
      __label__ = 21; break;
    case 20: // $97
      var $98=$3;
      var $99=$state;
      var $100=(($99+36)|0);
      HEAP32[(($100)>>2)]=$98;
      var $101=$state;
      var $102=(($101+52)|0);
      HEAP32[(($102)>>2)]=0;
      var $103=$2;
      var $104=_inflateReset($103);
      $1=$104;
      __label__ = 21; break;
    case 21: // $105
      var $106=$1;
      ;
      return $106;
    default: assert(0, "bad label: " + __label__);
  }
}
_inflateInit2_["X"]=1;

function _inflateInit_($strm, $version, $stream_size) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$strm;
  $2=$version;
  $3=$stream_size;
  var $4=$1;
  var $5=$2;
  var $6=$3;
  var $7=_inflateInit2_($4, 15, $5, $6);
  ;
  return $7;
}


function _inflate($strm, $flush) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      var $next;
      var $put;
      var $have;
      var $left;
      var $hold;
      var $bits;
      var $in;
      var $out;
      var $copy;
      var $from;
      var $this=__stackBase__;
      var $last=__stackBase__+4;
      var $len;
      var $ret;
      var $hbuf=__stackBase__+8;
      $2=$strm;
      $3=$flush;
      var $4=$2;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 5; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 5; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$2;
      var $13=(($12+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$2;
      var $18=(($17)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $21
      var $22=$2;
      var $23=(($22+4)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      $1=-2;
      __label__ = 573; break;
    case 6: // $27
      var $28=$2;
      var $29=(($28+28)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$30;
      $state=$31;
      var $32=$state;
      var $33=(($32)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)==11;
      if ($35) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $36
      var $37=$state;
      var $38=(($37)|0);
      HEAP32[(($38)>>2)]=12;
      __label__ = 8; break;
    case 8: // $39
      __label__ = 9; break;
    case 9: // $40
      var $41=$2;
      var $42=(($41+12)|0);
      var $43=HEAP32[(($42)>>2)];
      $put=$43;
      var $44=$2;
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      $left=$46;
      var $47=$2;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      $next=$49;
      var $50=$2;
      var $51=(($50+4)|0);
      var $52=HEAP32[(($51)>>2)];
      $have=$52;
      var $53=$state;
      var $54=(($53+56)|0);
      var $55=HEAP32[(($54)>>2)];
      $hold=$55;
      var $56=$state;
      var $57=(($56+60)|0);
      var $58=HEAP32[(($57)>>2)];
      $bits=$58;
      __label__ = 10; break;
    case 10: // $59
      var $60=$have;
      $in=$60;
      var $61=$left;
      $out=$61;
      $ret=0;
      __label__ = 11; break;
    case 11: // $62
      var $63=$state;
      var $64=(($63)|0);
      var $65=HEAP32[(($64)>>2)];
      if ($65 == 0) {
        __label__ = 12; break;
      }
      else if ($65 == 1) {
        __label__ = 44; break;
      }
      else if ($65 == 2) {
        __label__ = 66; break;
      }
      else if ($65 == 3) {
        __label__ = 84; break;
      }
      else if ($65 == 4) {
        __label__ = 102; break;
      }
      else if ($65 == 5) {
        __label__ = 125; break;
      }
      else if ($65 == 6) {
        __label__ = 142; break;
      }
      else if ($65 == 7) {
        __label__ = 163; break;
      }
      else if ($65 == 8) {
        __label__ = 184; break;
      }
      else if ($65 == 9) {
        __label__ = 202; break;
      }
      else if ($65 == 10) {
        __label__ = 214; break;
      }
      else if ($65 == 11) {
        __label__ = 219; break;
      }
      else if ($65 == 12) {
        __label__ = 222; break;
      }
      else if ($65 == 13) {
        __label__ = 245; break;
      }
      else if ($65 == 14) {
        __label__ = 261; break;
      }
      else if ($65 == 15) {
        __label__ = 270; break;
      }
      else if ($65 == 16) {
        __label__ = 289; break;
      }
      else if ($65 == 17) {
        __label__ = 309; break;
      }
      else if ($65 == 18) {
        __label__ = 393; break;
      }
      else if ($65 == 19) {
        __label__ = 430; break;
      }
      else if ($65 == 20) {
        __label__ = 444; break;
      }
      else if ($65 == 21) {
        __label__ = 469; break;
      }
      else if ($65 == 22) {
        __label__ = 485; break;
      }
      else if ($65 == 23) {
        __label__ = 503; break;
      }
      else if ($65 == 24) {
        __label__ = 506; break;
      }
      else if ($65 == 25) {
        __label__ = 530; break;
      }
      else if ($65 == 26) {
        __label__ = 547; break;
      }
      else if ($65 == 27) {
        __label__ = 548; break;
      }
      else if ($65 == 28) {
        __label__ = 549; break;
      }
      else if ($65 == 29) {
        __label__ = 550; break;
      }
      else {
      __label__ = 551; break;
      }
      
    case 12: // $66
      var $67=$state;
      var $68=(($67+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)==0;
      if ($70) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $71
      var $72=$state;
      var $73=(($72)|0);
      HEAP32[(($73)>>2)]=12;
      __label__ = 552; break;
    case 14: // $74
      __label__ = 15; break;
    case 15: // $75
      __label__ = 16; break;
    case 16: // $76
      var $77=$bits;
      var $78=(($77)>>>0) < 16;
      if ($78) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $79
      __label__ = 18; break;
    case 18: // $80
      var $81=$have;
      var $82=(($81)|0)==0;
      if ($82) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $83
      __label__ = 553; break;
    case 20: // $84
      var $85=$have;
      var $86=(($85-1)|0);
      $have=$86;
      var $87=$next;
      var $88=(($87+1)|0);
      $next=$88;
      var $89=HEAPU8[($87)];
      var $90=(($89)&255);
      var $91=$bits;
      var $92=$90 << $91;
      var $93=$hold;
      var $94=(($93+$92)|0);
      $hold=$94;
      var $95=$bits;
      var $96=(($95+8)|0);
      $bits=$96;
      __label__ = 21; break;
    case 21: // $97
      __label__ = 16; break;
    case 22: // $98
      __label__ = 23; break;
    case 23: // $99
      var $100=$state;
      var $101=(($100+8)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=$102 & 2;
      var $104=(($103)|0)!=0;
      if ($104) { __label__ = 24; break; } else { __label__ = 30; break; }
    case 24: // $105
      var $106=$hold;
      var $107=(($106)|0)==35615;
      if ($107) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $108
      var $109=_crc32(0, 0, 0);
      var $110=$state;
      var $111=(($110+24)|0);
      HEAP32[(($111)>>2)]=$109;
      __label__ = 26; break;
    case 26: // $112
      var $113=$hold;
      var $114=(($113) & 255);
      var $115=(($hbuf)|0);
      HEAP8[($115)]=$114;
      var $116=$hold;
      var $117=$116 >>> 8;
      var $118=(($117) & 255);
      var $119=(($hbuf+1)|0);
      HEAP8[($119)]=$118;
      var $120=$state;
      var $121=(($120+24)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=(($hbuf)|0);
      var $124=_crc32($122, $123, 2);
      var $125=$state;
      var $126=(($125+24)|0);
      HEAP32[(($126)>>2)]=$124;
      __label__ = 27; break;
    case 27: // $127
      __label__ = 28; break;
    case 28: // $128
      $hold=0;
      $bits=0;
      __label__ = 29; break;
    case 29: // $129
      var $130=$state;
      var $131=(($130)|0);
      HEAP32[(($131)>>2)]=1;
      __label__ = 552; break;
    case 30: // $132
      var $133=$state;
      var $134=(($133+16)|0);
      HEAP32[(($134)>>2)]=0;
      var $135=$state;
      var $136=(($135+32)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $139
      var $140=$state;
      var $141=(($140+32)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+48)|0);
      HEAP32[(($143)>>2)]=-1;
      __label__ = 32; break;
    case 32: // $144
      var $145=$state;
      var $146=(($145+8)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=$147 & 1;
      var $149=(($148)|0)!=0;
      if ($149) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $150
      var $151=$hold;
      var $152=$151 & 255;
      var $153=$152 << 8;
      var $154=$hold;
      var $155=$154 >>> 8;
      var $156=(($153+$155)|0);
      var $157=(($156)>>>0)%31;
      var $158=(($157)|0)!=0;
      if ($158) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $159
      var $160=$2;
      var $161=(($160+24)|0);
      HEAP32[(($161)>>2)]=((STRING_TABLE.__str17602)|0);
      var $162=$state;
      var $163=(($162)|0);
      HEAP32[(($163)>>2)]=27;
      __label__ = 552; break;
    case 35: // $164
      var $165=$hold;
      var $166=$165 & 15;
      var $167=(($166)|0)!=8;
      if ($167) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $168
      var $169=$2;
      var $170=(($169+24)|0);
      HEAP32[(($170)>>2)]=((STRING_TABLE.__str27603)|0);
      var $171=$state;
      var $172=(($171)|0);
      HEAP32[(($172)>>2)]=27;
      __label__ = 552; break;
    case 37: // $173
      __label__ = 38; break;
    case 38: // $174
      var $175=$hold;
      var $176=$175 >>> 4;
      $hold=$176;
      var $177=$bits;
      var $178=(($177-4)|0);
      $bits=$178;
      __label__ = 39; break;
    case 39: // $179
      var $180=$hold;
      var $181=$180 & 15;
      var $182=(($181+8)|0);
      $len=$182;
      var $183=$len;
      var $184=$state;
      var $185=(($184+36)|0);
      var $186=HEAPU32[(($185)>>2)];
      var $187=(($183)>>>0) > (($186)>>>0);
      if ($187) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $188
      var $189=$2;
      var $190=(($189+24)|0);
      HEAP32[(($190)>>2)]=((STRING_TABLE.__str37604)|0);
      var $191=$state;
      var $192=(($191)|0);
      HEAP32[(($192)>>2)]=27;
      __label__ = 552; break;
    case 41: // $193
      var $194=$len;
      var $195=1 << $194;
      var $196=$state;
      var $197=(($196+20)|0);
      HEAP32[(($197)>>2)]=$195;
      var $198=_adler32(0, 0, 0);
      var $199=$state;
      var $200=(($199+24)|0);
      HEAP32[(($200)>>2)]=$198;
      var $201=$2;
      var $202=(($201+48)|0);
      HEAP32[(($202)>>2)]=$198;
      var $203=$hold;
      var $204=$203 & 512;
      var $205=(($204)|0)!=0;
      var $206=$205 ? 9 : 11;
      var $207=$state;
      var $208=(($207)|0);
      HEAP32[(($208)>>2)]=$206;
      __label__ = 42; break;
    case 42: // $209
      $hold=0;
      $bits=0;
      __label__ = 43; break;
    case 43: // $210
      __label__ = 552; break;
    case 44: // $211
      __label__ = 45; break;
    case 45: // $212
      __label__ = 46; break;
    case 46: // $213
      var $214=$bits;
      var $215=(($214)>>>0) < 16;
      if ($215) { __label__ = 47; break; } else { __label__ = 52; break; }
    case 47: // $216
      __label__ = 48; break;
    case 48: // $217
      var $218=$have;
      var $219=(($218)|0)==0;
      if ($219) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $220
      __label__ = 553; break;
    case 50: // $221
      var $222=$have;
      var $223=(($222-1)|0);
      $have=$223;
      var $224=$next;
      var $225=(($224+1)|0);
      $next=$225;
      var $226=HEAPU8[($224)];
      var $227=(($226)&255);
      var $228=$bits;
      var $229=$227 << $228;
      var $230=$hold;
      var $231=(($230+$229)|0);
      $hold=$231;
      var $232=$bits;
      var $233=(($232+8)|0);
      $bits=$233;
      __label__ = 51; break;
    case 51: // $234
      __label__ = 46; break;
    case 52: // $235
      __label__ = 53; break;
    case 53: // $236
      var $237=$hold;
      var $238=$state;
      var $239=(($238+16)|0);
      HEAP32[(($239)>>2)]=$237;
      var $240=$state;
      var $241=(($240+16)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=$242 & 255;
      var $244=(($243)|0)!=8;
      if ($244) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $245
      var $246=$2;
      var $247=(($246+24)|0);
      HEAP32[(($247)>>2)]=((STRING_TABLE.__str27603)|0);
      var $248=$state;
      var $249=(($248)|0);
      HEAP32[(($249)>>2)]=27;
      __label__ = 552; break;
    case 55: // $250
      var $251=$state;
      var $252=(($251+16)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=$253 & 57344;
      var $255=(($254)|0)!=0;
      if ($255) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $256
      var $257=$2;
      var $258=(($257+24)|0);
      HEAP32[(($258)>>2)]=((STRING_TABLE.__str47605)|0);
      var $259=$state;
      var $260=(($259)|0);
      HEAP32[(($260)>>2)]=27;
      __label__ = 552; break;
    case 57: // $261
      var $262=$state;
      var $263=(($262+32)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=(($264)|0)!=0;
      if ($265) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $266
      var $267=$hold;
      var $268=$267 >>> 8;
      var $269=$268 & 1;
      var $270=$state;
      var $271=(($270+32)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($272)|0);
      HEAP32[(($273)>>2)]=$269;
      __label__ = 59; break;
    case 59: // $274
      var $275=$state;
      var $276=(($275+16)|0);
      var $277=HEAP32[(($276)>>2)];
      var $278=$277 & 512;
      var $279=(($278)|0)!=0;
      if ($279) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $280
      __label__ = 61; break;
    case 61: // $281
      var $282=$hold;
      var $283=(($282) & 255);
      var $284=(($hbuf)|0);
      HEAP8[($284)]=$283;
      var $285=$hold;
      var $286=$285 >>> 8;
      var $287=(($286) & 255);
      var $288=(($hbuf+1)|0);
      HEAP8[($288)]=$287;
      var $289=$state;
      var $290=(($289+24)|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=(($hbuf)|0);
      var $293=_crc32($291, $292, 2);
      var $294=$state;
      var $295=(($294+24)|0);
      HEAP32[(($295)>>2)]=$293;
      __label__ = 62; break;
    case 62: // $296
      __label__ = 63; break;
    case 63: // $297
      __label__ = 64; break;
    case 64: // $298
      $hold=0;
      $bits=0;
      __label__ = 65; break;
    case 65: // $299
      var $300=$state;
      var $301=(($300)|0);
      HEAP32[(($301)>>2)]=2;
      __label__ = 66; break;
    case 66: // $302
      __label__ = 67; break;
    case 67: // $303
      __label__ = 68; break;
    case 68: // $304
      var $305=$bits;
      var $306=(($305)>>>0) < 32;
      if ($306) { __label__ = 69; break; } else { __label__ = 74; break; }
    case 69: // $307
      __label__ = 70; break;
    case 70: // $308
      var $309=$have;
      var $310=(($309)|0)==0;
      if ($310) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $311
      __label__ = 553; break;
    case 72: // $312
      var $313=$have;
      var $314=(($313-1)|0);
      $have=$314;
      var $315=$next;
      var $316=(($315+1)|0);
      $next=$316;
      var $317=HEAPU8[($315)];
      var $318=(($317)&255);
      var $319=$bits;
      var $320=$318 << $319;
      var $321=$hold;
      var $322=(($321+$320)|0);
      $hold=$322;
      var $323=$bits;
      var $324=(($323+8)|0);
      $bits=$324;
      __label__ = 73; break;
    case 73: // $325
      __label__ = 68; break;
    case 74: // $326
      __label__ = 75; break;
    case 75: // $327
      var $328=$state;
      var $329=(($328+32)|0);
      var $330=HEAP32[(($329)>>2)];
      var $331=(($330)|0)!=0;
      if ($331) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $332
      var $333=$hold;
      var $334=$state;
      var $335=(($334+32)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=(($336+4)|0);
      HEAP32[(($337)>>2)]=$333;
      __label__ = 77; break;
    case 77: // $338
      var $339=$state;
      var $340=(($339+16)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$341 & 512;
      var $343=(($342)|0)!=0;
      if ($343) { __label__ = 78; break; } else { __label__ = 81; break; }
    case 78: // $344
      __label__ = 79; break;
    case 79: // $345
      var $346=$hold;
      var $347=(($346) & 255);
      var $348=(($hbuf)|0);
      HEAP8[($348)]=$347;
      var $349=$hold;
      var $350=$349 >>> 8;
      var $351=(($350) & 255);
      var $352=(($hbuf+1)|0);
      HEAP8[($352)]=$351;
      var $353=$hold;
      var $354=$353 >>> 16;
      var $355=(($354) & 255);
      var $356=(($hbuf+2)|0);
      HEAP8[($356)]=$355;
      var $357=$hold;
      var $358=$357 >>> 24;
      var $359=(($358) & 255);
      var $360=(($hbuf+3)|0);
      HEAP8[($360)]=$359;
      var $361=$state;
      var $362=(($361+24)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=(($hbuf)|0);
      var $365=_crc32($363, $364, 4);
      var $366=$state;
      var $367=(($366+24)|0);
      HEAP32[(($367)>>2)]=$365;
      __label__ = 80; break;
    case 80: // $368
      __label__ = 81; break;
    case 81: // $369
      __label__ = 82; break;
    case 82: // $370
      $hold=0;
      $bits=0;
      __label__ = 83; break;
    case 83: // $371
      var $372=$state;
      var $373=(($372)|0);
      HEAP32[(($373)>>2)]=3;
      __label__ = 84; break;
    case 84: // $374
      __label__ = 85; break;
    case 85: // $375
      __label__ = 86; break;
    case 86: // $376
      var $377=$bits;
      var $378=(($377)>>>0) < 16;
      if ($378) { __label__ = 87; break; } else { __label__ = 92; break; }
    case 87: // $379
      __label__ = 88; break;
    case 88: // $380
      var $381=$have;
      var $382=(($381)|0)==0;
      if ($382) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $383
      __label__ = 553; break;
    case 90: // $384
      var $385=$have;
      var $386=(($385-1)|0);
      $have=$386;
      var $387=$next;
      var $388=(($387+1)|0);
      $next=$388;
      var $389=HEAPU8[($387)];
      var $390=(($389)&255);
      var $391=$bits;
      var $392=$390 << $391;
      var $393=$hold;
      var $394=(($393+$392)|0);
      $hold=$394;
      var $395=$bits;
      var $396=(($395+8)|0);
      $bits=$396;
      __label__ = 91; break;
    case 91: // $397
      __label__ = 86; break;
    case 92: // $398
      __label__ = 93; break;
    case 93: // $399
      var $400=$state;
      var $401=(($400+32)|0);
      var $402=HEAP32[(($401)>>2)];
      var $403=(($402)|0)!=0;
      if ($403) { __label__ = 94; break; } else { __label__ = 95; break; }
    case 94: // $404
      var $405=$hold;
      var $406=$405 & 255;
      var $407=$state;
      var $408=(($407+32)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=(($409+8)|0);
      HEAP32[(($410)>>2)]=$406;
      var $411=$hold;
      var $412=$411 >>> 8;
      var $413=$state;
      var $414=(($413+32)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=(($415+12)|0);
      HEAP32[(($416)>>2)]=$412;
      __label__ = 95; break;
    case 95: // $417
      var $418=$state;
      var $419=(($418+16)|0);
      var $420=HEAP32[(($419)>>2)];
      var $421=$420 & 512;
      var $422=(($421)|0)!=0;
      if ($422) { __label__ = 96; break; } else { __label__ = 99; break; }
    case 96: // $423
      __label__ = 97; break;
    case 97: // $424
      var $425=$hold;
      var $426=(($425) & 255);
      var $427=(($hbuf)|0);
      HEAP8[($427)]=$426;
      var $428=$hold;
      var $429=$428 >>> 8;
      var $430=(($429) & 255);
      var $431=(($hbuf+1)|0);
      HEAP8[($431)]=$430;
      var $432=$state;
      var $433=(($432+24)|0);
      var $434=HEAP32[(($433)>>2)];
      var $435=(($hbuf)|0);
      var $436=_crc32($434, $435, 2);
      var $437=$state;
      var $438=(($437+24)|0);
      HEAP32[(($438)>>2)]=$436;
      __label__ = 98; break;
    case 98: // $439
      __label__ = 99; break;
    case 99: // $440
      __label__ = 100; break;
    case 100: // $441
      $hold=0;
      $bits=0;
      __label__ = 101; break;
    case 101: // $442
      var $443=$state;
      var $444=(($443)|0);
      HEAP32[(($444)>>2)]=4;
      __label__ = 102; break;
    case 102: // $445
      var $446=$state;
      var $447=(($446+16)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=$448 & 1024;
      var $450=(($449)|0)!=0;
      if ($450) { __label__ = 103; break; } else { __label__ = 121; break; }
    case 103: // $451
      __label__ = 104; break;
    case 104: // $452
      __label__ = 105; break;
    case 105: // $453
      var $454=$bits;
      var $455=(($454)>>>0) < 16;
      if ($455) { __label__ = 106; break; } else { __label__ = 111; break; }
    case 106: // $456
      __label__ = 107; break;
    case 107: // $457
      var $458=$have;
      var $459=(($458)|0)==0;
      if ($459) { __label__ = 108; break; } else { __label__ = 109; break; }
    case 108: // $460
      __label__ = 553; break;
    case 109: // $461
      var $462=$have;
      var $463=(($462-1)|0);
      $have=$463;
      var $464=$next;
      var $465=(($464+1)|0);
      $next=$465;
      var $466=HEAPU8[($464)];
      var $467=(($466)&255);
      var $468=$bits;
      var $469=$467 << $468;
      var $470=$hold;
      var $471=(($470+$469)|0);
      $hold=$471;
      var $472=$bits;
      var $473=(($472+8)|0);
      $bits=$473;
      __label__ = 110; break;
    case 110: // $474
      __label__ = 105; break;
    case 111: // $475
      __label__ = 112; break;
    case 112: // $476
      var $477=$hold;
      var $478=$state;
      var $479=(($478+64)|0);
      HEAP32[(($479)>>2)]=$477;
      var $480=$state;
      var $481=(($480+32)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=(($482)|0)!=0;
      if ($483) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $484
      var $485=$hold;
      var $486=$state;
      var $487=(($486+32)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=(($488+20)|0);
      HEAP32[(($489)>>2)]=$485;
      __label__ = 114; break;
    case 114: // $490
      var $491=$state;
      var $492=(($491+16)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=$493 & 512;
      var $495=(($494)|0)!=0;
      if ($495) { __label__ = 115; break; } else { __label__ = 118; break; }
    case 115: // $496
      __label__ = 116; break;
    case 116: // $497
      var $498=$hold;
      var $499=(($498) & 255);
      var $500=(($hbuf)|0);
      HEAP8[($500)]=$499;
      var $501=$hold;
      var $502=$501 >>> 8;
      var $503=(($502) & 255);
      var $504=(($hbuf+1)|0);
      HEAP8[($504)]=$503;
      var $505=$state;
      var $506=(($505+24)|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=(($hbuf)|0);
      var $509=_crc32($507, $508, 2);
      var $510=$state;
      var $511=(($510+24)|0);
      HEAP32[(($511)>>2)]=$509;
      __label__ = 117; break;
    case 117: // $512
      __label__ = 118; break;
    case 118: // $513
      __label__ = 119; break;
    case 119: // $514
      $hold=0;
      $bits=0;
      __label__ = 120; break;
    case 120: // $515
      __label__ = 124; break;
    case 121: // $516
      var $517=$state;
      var $518=(($517+32)|0);
      var $519=HEAP32[(($518)>>2)];
      var $520=(($519)|0)!=0;
      if ($520) { __label__ = 122; break; } else { __label__ = 123; break; }
    case 122: // $521
      var $522=$state;
      var $523=(($522+32)|0);
      var $524=HEAP32[(($523)>>2)];
      var $525=(($524+16)|0);
      HEAP32[(($525)>>2)]=0;
      __label__ = 123; break;
    case 123: // $526
      __label__ = 124; break;
    case 124: // $527
      var $528=$state;
      var $529=(($528)|0);
      HEAP32[(($529)>>2)]=5;
      __label__ = 125; break;
    case 125: // $530
      var $531=$state;
      var $532=(($531+16)|0);
      var $533=HEAP32[(($532)>>2)];
      var $534=$533 & 1024;
      var $535=(($534)|0)!=0;
      if ($535) { __label__ = 126; break; } else { __label__ = 141; break; }
    case 126: // $536
      var $537=$state;
      var $538=(($537+64)|0);
      var $539=HEAP32[(($538)>>2)];
      $copy=$539;
      var $540=$copy;
      var $541=$have;
      var $542=(($540)>>>0) > (($541)>>>0);
      if ($542) { __label__ = 127; break; } else { __label__ = 128; break; }
    case 127: // $543
      var $544=$have;
      $copy=$544;
      __label__ = 128; break;
    case 128: // $545
      var $546=$copy;
      var $547=(($546)|0)!=0;
      if ($547) { __label__ = 129; break; } else { __label__ = 138; break; }
    case 129: // $548
      var $549=$state;
      var $550=(($549+32)|0);
      var $551=HEAP32[(($550)>>2)];
      var $552=(($551)|0)!=0;
      if ($552) { __label__ = 130; break; } else { __label__ = 135; break; }
    case 130: // $553
      var $554=$state;
      var $555=(($554+32)|0);
      var $556=HEAP32[(($555)>>2)];
      var $557=(($556+16)|0);
      var $558=HEAP32[(($557)>>2)];
      var $559=(($558)|0)!=0;
      if ($559) { __label__ = 131; break; } else { __label__ = 135; break; }
    case 131: // $560
      var $561=$state;
      var $562=(($561+32)|0);
      var $563=HEAP32[(($562)>>2)];
      var $564=(($563+20)|0);
      var $565=HEAP32[(($564)>>2)];
      var $566=$state;
      var $567=(($566+64)|0);
      var $568=HEAP32[(($567)>>2)];
      var $569=(($565-$568)|0);
      $len=$569;
      var $570=$state;
      var $571=(($570+32)|0);
      var $572=HEAP32[(($571)>>2)];
      var $573=(($572+16)|0);
      var $574=HEAP32[(($573)>>2)];
      var $575=$len;
      var $576=(($574+$575)|0);
      var $577=$next;
      var $578=$len;
      var $579=$copy;
      var $580=(($578+$579)|0);
      var $581=$state;
      var $582=(($581+32)|0);
      var $583=HEAP32[(($582)>>2)];
      var $584=(($583+24)|0);
      var $585=HEAPU32[(($584)>>2)];
      var $586=(($580)>>>0) > (($585)>>>0);
      if ($586) { __label__ = 132; break; } else { __label__ = 133; break; }
    case 132: // $587
      var $588=$state;
      var $589=(($588+32)|0);
      var $590=HEAP32[(($589)>>2)];
      var $591=(($590+24)|0);
      var $592=HEAP32[(($591)>>2)];
      var $593=$len;
      var $594=(($592-$593)|0);
      var $598 = $594;__label__ = 134; break;
    case 133: // $595
      var $596=$copy;
      var $598 = $596;__label__ = 134; break;
    case 134: // $597
      var $598;
      assert($598 % 1 === 0, 'memcpy given ' + $598 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($576, $577, $598, 1);
      __label__ = 135; break;
    case 135: // $599
      var $600=$state;
      var $601=(($600+16)|0);
      var $602=HEAP32[(($601)>>2)];
      var $603=$602 & 512;
      var $604=(($603)|0)!=0;
      if ($604) { __label__ = 136; break; } else { __label__ = 137; break; }
    case 136: // $605
      var $606=$state;
      var $607=(($606+24)|0);
      var $608=HEAP32[(($607)>>2)];
      var $609=$next;
      var $610=$copy;
      var $611=_crc32($608, $609, $610);
      var $612=$state;
      var $613=(($612+24)|0);
      HEAP32[(($613)>>2)]=$611;
      __label__ = 137; break;
    case 137: // $614
      var $615=$copy;
      var $616=$have;
      var $617=(($616-$615)|0);
      $have=$617;
      var $618=$copy;
      var $619=$next;
      var $620=(($619+$618)|0);
      $next=$620;
      var $621=$copy;
      var $622=$state;
      var $623=(($622+64)|0);
      var $624=HEAP32[(($623)>>2)];
      var $625=(($624-$621)|0);
      HEAP32[(($623)>>2)]=$625;
      __label__ = 138; break;
    case 138: // $626
      var $627=$state;
      var $628=(($627+64)|0);
      var $629=HEAP32[(($628)>>2)];
      var $630=(($629)|0)!=0;
      if ($630) { __label__ = 139; break; } else { __label__ = 140; break; }
    case 139: // $631
      __label__ = 553; break;
    case 140: // $632
      __label__ = 141; break;
    case 141: // $633
      var $634=$state;
      var $635=(($634+64)|0);
      HEAP32[(($635)>>2)]=0;
      var $636=$state;
      var $637=(($636)|0);
      HEAP32[(($637)>>2)]=6;
      __label__ = 142; break;
    case 142: // $638
      var $639=$state;
      var $640=(($639+16)|0);
      var $641=HEAP32[(($640)>>2)];
      var $642=$641 & 2048;
      var $643=(($642)|0)!=0;
      if ($643) { __label__ = 143; break; } else { __label__ = 159; break; }
    case 143: // $644
      var $645=$have;
      var $646=(($645)|0)==0;
      if ($646) { __label__ = 144; break; } else { __label__ = 145; break; }
    case 144: // $647
      __label__ = 553; break;
    case 145: // $648
      $copy=0;
      __label__ = 146; break;
    case 146: // $649
      var $650=$copy;
      var $651=(($650+1)|0);
      $copy=$651;
      var $652=$next;
      var $653=(($652+$650)|0);
      var $654=HEAPU8[($653)];
      var $655=(($654)&255);
      $len=$655;
      var $656=$state;
      var $657=(($656+32)|0);
      var $658=HEAP32[(($657)>>2)];
      var $659=(($658)|0)!=0;
      if ($659) { __label__ = 147; break; } else { __label__ = 150; break; }
    case 147: // $660
      var $661=$state;
      var $662=(($661+32)|0);
      var $663=HEAP32[(($662)>>2)];
      var $664=(($663+28)|0);
      var $665=HEAP32[(($664)>>2)];
      var $666=(($665)|0)!=0;
      if ($666) { __label__ = 148; break; } else { __label__ = 150; break; }
    case 148: // $667
      var $668=$state;
      var $669=(($668+64)|0);
      var $670=HEAPU32[(($669)>>2)];
      var $671=$state;
      var $672=(($671+32)|0);
      var $673=HEAP32[(($672)>>2)];
      var $674=(($673+32)|0);
      var $675=HEAPU32[(($674)>>2)];
      var $676=(($670)>>>0) < (($675)>>>0);
      if ($676) { __label__ = 149; break; } else { __label__ = 150; break; }
    case 149: // $677
      var $678=$len;
      var $679=(($678) & 255);
      var $680=$state;
      var $681=(($680+64)|0);
      var $682=HEAPU32[(($681)>>2)];
      var $683=(($682+1)|0);
      HEAP32[(($681)>>2)]=$683;
      var $684=$state;
      var $685=(($684+32)|0);
      var $686=HEAP32[(($685)>>2)];
      var $687=(($686+28)|0);
      var $688=HEAP32[(($687)>>2)];
      var $689=(($688+$682)|0);
      HEAP8[($689)]=$679;
      __label__ = 150; break;
    case 150: // $690
      __label__ = 151; break;
    case 151: // $691
      var $692=$len;
      var $693=(($692)|0)!=0;
      if ($693) { __label__ = 152; break; } else { var $699 = 0;__label__ = 153; break; }
    case 152: // $694
      var $695=$copy;
      var $696=$have;
      var $697=(($695)>>>0) < (($696)>>>0);
      var $699 = $697;__label__ = 153; break;
    case 153: // $698
      var $699;
      if ($699) { __label__ = 146; break; } else { __label__ = 154; break; }
    case 154: // $700
      var $701=$state;
      var $702=(($701+16)|0);
      var $703=HEAP32[(($702)>>2)];
      var $704=$703 & 512;
      var $705=(($704)|0)!=0;
      if ($705) { __label__ = 155; break; } else { __label__ = 156; break; }
    case 155: // $706
      var $707=$state;
      var $708=(($707+24)|0);
      var $709=HEAP32[(($708)>>2)];
      var $710=$next;
      var $711=$copy;
      var $712=_crc32($709, $710, $711);
      var $713=$state;
      var $714=(($713+24)|0);
      HEAP32[(($714)>>2)]=$712;
      __label__ = 156; break;
    case 156: // $715
      var $716=$copy;
      var $717=$have;
      var $718=(($717-$716)|0);
      $have=$718;
      var $719=$copy;
      var $720=$next;
      var $721=(($720+$719)|0);
      $next=$721;
      var $722=$len;
      var $723=(($722)|0)!=0;
      if ($723) { __label__ = 157; break; } else { __label__ = 158; break; }
    case 157: // $724
      __label__ = 553; break;
    case 158: // $725
      __label__ = 162; break;
    case 159: // $726
      var $727=$state;
      var $728=(($727+32)|0);
      var $729=HEAP32[(($728)>>2)];
      var $730=(($729)|0)!=0;
      if ($730) { __label__ = 160; break; } else { __label__ = 161; break; }
    case 160: // $731
      var $732=$state;
      var $733=(($732+32)|0);
      var $734=HEAP32[(($733)>>2)];
      var $735=(($734+28)|0);
      HEAP32[(($735)>>2)]=0;
      __label__ = 161; break;
    case 161: // $736
      __label__ = 162; break;
    case 162: // $737
      var $738=$state;
      var $739=(($738+64)|0);
      HEAP32[(($739)>>2)]=0;
      var $740=$state;
      var $741=(($740)|0);
      HEAP32[(($741)>>2)]=7;
      __label__ = 163; break;
    case 163: // $742
      var $743=$state;
      var $744=(($743+16)|0);
      var $745=HEAP32[(($744)>>2)];
      var $746=$745 & 4096;
      var $747=(($746)|0)!=0;
      if ($747) { __label__ = 164; break; } else { __label__ = 180; break; }
    case 164: // $748
      var $749=$have;
      var $750=(($749)|0)==0;
      if ($750) { __label__ = 165; break; } else { __label__ = 166; break; }
    case 165: // $751
      __label__ = 553; break;
    case 166: // $752
      $copy=0;
      __label__ = 167; break;
    case 167: // $753
      var $754=$copy;
      var $755=(($754+1)|0);
      $copy=$755;
      var $756=$next;
      var $757=(($756+$754)|0);
      var $758=HEAPU8[($757)];
      var $759=(($758)&255);
      $len=$759;
      var $760=$state;
      var $761=(($760+32)|0);
      var $762=HEAP32[(($761)>>2)];
      var $763=(($762)|0)!=0;
      if ($763) { __label__ = 168; break; } else { __label__ = 171; break; }
    case 168: // $764
      var $765=$state;
      var $766=(($765+32)|0);
      var $767=HEAP32[(($766)>>2)];
      var $768=(($767+36)|0);
      var $769=HEAP32[(($768)>>2)];
      var $770=(($769)|0)!=0;
      if ($770) { __label__ = 169; break; } else { __label__ = 171; break; }
    case 169: // $771
      var $772=$state;
      var $773=(($772+64)|0);
      var $774=HEAPU32[(($773)>>2)];
      var $775=$state;
      var $776=(($775+32)|0);
      var $777=HEAP32[(($776)>>2)];
      var $778=(($777+40)|0);
      var $779=HEAPU32[(($778)>>2)];
      var $780=(($774)>>>0) < (($779)>>>0);
      if ($780) { __label__ = 170; break; } else { __label__ = 171; break; }
    case 170: // $781
      var $782=$len;
      var $783=(($782) & 255);
      var $784=$state;
      var $785=(($784+64)|0);
      var $786=HEAPU32[(($785)>>2)];
      var $787=(($786+1)|0);
      HEAP32[(($785)>>2)]=$787;
      var $788=$state;
      var $789=(($788+32)|0);
      var $790=HEAP32[(($789)>>2)];
      var $791=(($790+36)|0);
      var $792=HEAP32[(($791)>>2)];
      var $793=(($792+$786)|0);
      HEAP8[($793)]=$783;
      __label__ = 171; break;
    case 171: // $794
      __label__ = 172; break;
    case 172: // $795
      var $796=$len;
      var $797=(($796)|0)!=0;
      if ($797) { __label__ = 173; break; } else { var $803 = 0;__label__ = 174; break; }
    case 173: // $798
      var $799=$copy;
      var $800=$have;
      var $801=(($799)>>>0) < (($800)>>>0);
      var $803 = $801;__label__ = 174; break;
    case 174: // $802
      var $803;
      if ($803) { __label__ = 167; break; } else { __label__ = 175; break; }
    case 175: // $804
      var $805=$state;
      var $806=(($805+16)|0);
      var $807=HEAP32[(($806)>>2)];
      var $808=$807 & 512;
      var $809=(($808)|0)!=0;
      if ($809) { __label__ = 176; break; } else { __label__ = 177; break; }
    case 176: // $810
      var $811=$state;
      var $812=(($811+24)|0);
      var $813=HEAP32[(($812)>>2)];
      var $814=$next;
      var $815=$copy;
      var $816=_crc32($813, $814, $815);
      var $817=$state;
      var $818=(($817+24)|0);
      HEAP32[(($818)>>2)]=$816;
      __label__ = 177; break;
    case 177: // $819
      var $820=$copy;
      var $821=$have;
      var $822=(($821-$820)|0);
      $have=$822;
      var $823=$copy;
      var $824=$next;
      var $825=(($824+$823)|0);
      $next=$825;
      var $826=$len;
      var $827=(($826)|0)!=0;
      if ($827) { __label__ = 178; break; } else { __label__ = 179; break; }
    case 178: // $828
      __label__ = 553; break;
    case 179: // $829
      __label__ = 183; break;
    case 180: // $830
      var $831=$state;
      var $832=(($831+32)|0);
      var $833=HEAP32[(($832)>>2)];
      var $834=(($833)|0)!=0;
      if ($834) { __label__ = 181; break; } else { __label__ = 182; break; }
    case 181: // $835
      var $836=$state;
      var $837=(($836+32)|0);
      var $838=HEAP32[(($837)>>2)];
      var $839=(($838+36)|0);
      HEAP32[(($839)>>2)]=0;
      __label__ = 182; break;
    case 182: // $840
      __label__ = 183; break;
    case 183: // $841
      var $842=$state;
      var $843=(($842)|0);
      HEAP32[(($843)>>2)]=8;
      __label__ = 184; break;
    case 184: // $844
      var $845=$state;
      var $846=(($845+16)|0);
      var $847=HEAP32[(($846)>>2)];
      var $848=$847 & 512;
      var $849=(($848)|0)!=0;
      if ($849) { __label__ = 185; break; } else { __label__ = 199; break; }
    case 185: // $850
      __label__ = 186; break;
    case 186: // $851
      __label__ = 187; break;
    case 187: // $852
      var $853=$bits;
      var $854=(($853)>>>0) < 16;
      if ($854) { __label__ = 188; break; } else { __label__ = 193; break; }
    case 188: // $855
      __label__ = 189; break;
    case 189: // $856
      var $857=$have;
      var $858=(($857)|0)==0;
      if ($858) { __label__ = 190; break; } else { __label__ = 191; break; }
    case 190: // $859
      __label__ = 553; break;
    case 191: // $860
      var $861=$have;
      var $862=(($861-1)|0);
      $have=$862;
      var $863=$next;
      var $864=(($863+1)|0);
      $next=$864;
      var $865=HEAPU8[($863)];
      var $866=(($865)&255);
      var $867=$bits;
      var $868=$866 << $867;
      var $869=$hold;
      var $870=(($869+$868)|0);
      $hold=$870;
      var $871=$bits;
      var $872=(($871+8)|0);
      $bits=$872;
      __label__ = 192; break;
    case 192: // $873
      __label__ = 187; break;
    case 193: // $874
      __label__ = 194; break;
    case 194: // $875
      var $876=$hold;
      var $877=$state;
      var $878=(($877+24)|0);
      var $879=HEAP32[(($878)>>2)];
      var $880=$879 & 65535;
      var $881=(($876)|0)!=(($880)|0);
      if ($881) { __label__ = 195; break; } else { __label__ = 196; break; }
    case 195: // $882
      var $883=$2;
      var $884=(($883+24)|0);
      HEAP32[(($884)>>2)]=((STRING_TABLE.__str57606)|0);
      var $885=$state;
      var $886=(($885)|0);
      HEAP32[(($886)>>2)]=27;
      __label__ = 552; break;
    case 196: // $887
      __label__ = 197; break;
    case 197: // $888
      $hold=0;
      $bits=0;
      __label__ = 198; break;
    case 198: // $889
      __label__ = 199; break;
    case 199: // $890
      var $891=$state;
      var $892=(($891+32)|0);
      var $893=HEAP32[(($892)>>2)];
      var $894=(($893)|0)!=0;
      if ($894) { __label__ = 200; break; } else { __label__ = 201; break; }
    case 200: // $895
      var $896=$state;
      var $897=(($896+16)|0);
      var $898=HEAP32[(($897)>>2)];
      var $899=$898 >> 9;
      var $900=$899 & 1;
      var $901=$state;
      var $902=(($901+32)|0);
      var $903=HEAP32[(($902)>>2)];
      var $904=(($903+44)|0);
      HEAP32[(($904)>>2)]=$900;
      var $905=$state;
      var $906=(($905+32)|0);
      var $907=HEAP32[(($906)>>2)];
      var $908=(($907+48)|0);
      HEAP32[(($908)>>2)]=1;
      __label__ = 201; break;
    case 201: // $909
      var $910=_crc32(0, 0, 0);
      var $911=$state;
      var $912=(($911+24)|0);
      HEAP32[(($912)>>2)]=$910;
      var $913=$2;
      var $914=(($913+48)|0);
      HEAP32[(($914)>>2)]=$910;
      var $915=$state;
      var $916=(($915)|0);
      HEAP32[(($916)>>2)]=11;
      __label__ = 552; break;
    case 202: // $917
      __label__ = 203; break;
    case 203: // $918
      __label__ = 204; break;
    case 204: // $919
      var $920=$bits;
      var $921=(($920)>>>0) < 32;
      if ($921) { __label__ = 205; break; } else { __label__ = 210; break; }
    case 205: // $922
      __label__ = 206; break;
    case 206: // $923
      var $924=$have;
      var $925=(($924)|0)==0;
      if ($925) { __label__ = 207; break; } else { __label__ = 208; break; }
    case 207: // $926
      __label__ = 553; break;
    case 208: // $927
      var $928=$have;
      var $929=(($928-1)|0);
      $have=$929;
      var $930=$next;
      var $931=(($930+1)|0);
      $next=$931;
      var $932=HEAPU8[($930)];
      var $933=(($932)&255);
      var $934=$bits;
      var $935=$933 << $934;
      var $936=$hold;
      var $937=(($936+$935)|0);
      $hold=$937;
      var $938=$bits;
      var $939=(($938+8)|0);
      $bits=$939;
      __label__ = 209; break;
    case 209: // $940
      __label__ = 204; break;
    case 210: // $941
      __label__ = 211; break;
    case 211: // $942
      var $943=$hold;
      var $944=$943 >>> 24;
      var $945=$944 & 255;
      var $946=$hold;
      var $947=$946 >>> 8;
      var $948=$947 & 65280;
      var $949=(($945+$948)|0);
      var $950=$hold;
      var $951=$950 & 65280;
      var $952=$951 << 8;
      var $953=(($949+$952)|0);
      var $954=$hold;
      var $955=$954 & 255;
      var $956=$955 << 24;
      var $957=(($953+$956)|0);
      var $958=$state;
      var $959=(($958+24)|0);
      HEAP32[(($959)>>2)]=$957;
      var $960=$2;
      var $961=(($960+48)|0);
      HEAP32[(($961)>>2)]=$957;
      __label__ = 212; break;
    case 212: // $962
      $hold=0;
      $bits=0;
      __label__ = 213; break;
    case 213: // $963
      var $964=$state;
      var $965=(($964)|0);
      HEAP32[(($965)>>2)]=10;
      __label__ = 214; break;
    case 214: // $966
      var $967=$state;
      var $968=(($967+12)|0);
      var $969=HEAP32[(($968)>>2)];
      var $970=(($969)|0)==0;
      if ($970) { __label__ = 215; break; } else { __label__ = 218; break; }
    case 215: // $971
      __label__ = 216; break;
    case 216: // $972
      var $973=$put;
      var $974=$2;
      var $975=(($974+12)|0);
      HEAP32[(($975)>>2)]=$973;
      var $976=$left;
      var $977=$2;
      var $978=(($977+16)|0);
      HEAP32[(($978)>>2)]=$976;
      var $979=$next;
      var $980=$2;
      var $981=(($980)|0);
      HEAP32[(($981)>>2)]=$979;
      var $982=$have;
      var $983=$2;
      var $984=(($983+4)|0);
      HEAP32[(($984)>>2)]=$982;
      var $985=$hold;
      var $986=$state;
      var $987=(($986+56)|0);
      HEAP32[(($987)>>2)]=$985;
      var $988=$bits;
      var $989=$state;
      var $990=(($989+60)|0);
      HEAP32[(($990)>>2)]=$988;
      __label__ = 217; break;
    case 217: // $991
      $1=2;
      __label__ = 573; break;
    case 218: // $992
      var $993=_adler32(0, 0, 0);
      var $994=$state;
      var $995=(($994+24)|0);
      HEAP32[(($995)>>2)]=$993;
      var $996=$2;
      var $997=(($996+48)|0);
      HEAP32[(($997)>>2)]=$993;
      var $998=$state;
      var $999=(($998)|0);
      HEAP32[(($999)>>2)]=11;
      __label__ = 219; break;
    case 219: // $1000
      var $1001=$3;
      var $1002=(($1001)|0)==5;
      if ($1002) { __label__ = 220; break; } else { __label__ = 221; break; }
    case 220: // $1003
      __label__ = 553; break;
    case 221: // $1004
      __label__ = 222; break;
    case 222: // $1005
      var $1006=$state;
      var $1007=(($1006+4)|0);
      var $1008=HEAP32[(($1007)>>2)];
      var $1009=(($1008)|0)!=0;
      if ($1009) { __label__ = 223; break; } else { __label__ = 226; break; }
    case 223: // $1010
      __label__ = 224; break;
    case 224: // $1011
      var $1012=$bits;
      var $1013=$1012 & 7;
      var $1014=$hold;
      var $1015=$1014 >>> (($1013)>>>0);
      $hold=$1015;
      var $1016=$bits;
      var $1017=$1016 & 7;
      var $1018=$bits;
      var $1019=(($1018-$1017)|0);
      $bits=$1019;
      __label__ = 225; break;
    case 225: // $1020
      var $1021=$state;
      var $1022=(($1021)|0);
      HEAP32[(($1022)>>2)]=24;
      __label__ = 552; break;
    case 226: // $1023
      __label__ = 227; break;
    case 227: // $1024
      __label__ = 228; break;
    case 228: // $1025
      var $1026=$bits;
      var $1027=(($1026)>>>0) < 3;
      if ($1027) { __label__ = 229; break; } else { __label__ = 234; break; }
    case 229: // $1028
      __label__ = 230; break;
    case 230: // $1029
      var $1030=$have;
      var $1031=(($1030)|0)==0;
      if ($1031) { __label__ = 231; break; } else { __label__ = 232; break; }
    case 231: // $1032
      __label__ = 553; break;
    case 232: // $1033
      var $1034=$have;
      var $1035=(($1034-1)|0);
      $have=$1035;
      var $1036=$next;
      var $1037=(($1036+1)|0);
      $next=$1037;
      var $1038=HEAPU8[($1036)];
      var $1039=(($1038)&255);
      var $1040=$bits;
      var $1041=$1039 << $1040;
      var $1042=$hold;
      var $1043=(($1042+$1041)|0);
      $hold=$1043;
      var $1044=$bits;
      var $1045=(($1044+8)|0);
      $bits=$1045;
      __label__ = 233; break;
    case 233: // $1046
      __label__ = 228; break;
    case 234: // $1047
      __label__ = 235; break;
    case 235: // $1048
      var $1049=$hold;
      var $1050=$1049 & 1;
      var $1051=$state;
      var $1052=(($1051+4)|0);
      HEAP32[(($1052)>>2)]=$1050;
      __label__ = 236; break;
    case 236: // $1053
      var $1054=$hold;
      var $1055=$1054 >>> 1;
      $hold=$1055;
      var $1056=$bits;
      var $1057=(($1056-1)|0);
      $bits=$1057;
      __label__ = 237; break;
    case 237: // $1058
      var $1059=$hold;
      var $1060=$1059 & 3;
      if ($1060 == 0) {
        __label__ = 238; break;
      }
      else if ($1060 == 1) {
        __label__ = 239; break;
      }
      else if ($1060 == 2) {
        __label__ = 240; break;
      }
      else if ($1060 == 3) {
        __label__ = 241; break;
      }
      else {
      __label__ = 242; break;
      }
      
    case 238: // $1061
      var $1062=$state;
      var $1063=(($1062)|0);
      HEAP32[(($1063)>>2)]=13;
      __label__ = 242; break;
    case 239: // $1064
      var $1065=$state;
      _fixedtables($1065);
      var $1066=$state;
      var $1067=(($1066)|0);
      HEAP32[(($1067)>>2)]=18;
      __label__ = 242; break;
    case 240: // $1068
      var $1069=$state;
      var $1070=(($1069)|0);
      HEAP32[(($1070)>>2)]=15;
      __label__ = 242; break;
    case 241: // $1071
      var $1072=$2;
      var $1073=(($1072+24)|0);
      HEAP32[(($1073)>>2)]=((STRING_TABLE.__str67607)|0);
      var $1074=$state;
      var $1075=(($1074)|0);
      HEAP32[(($1075)>>2)]=27;
      __label__ = 242; break;
    case 242: // $1076
      __label__ = 243; break;
    case 243: // $1077
      var $1078=$hold;
      var $1079=$1078 >>> 2;
      $hold=$1079;
      var $1080=$bits;
      var $1081=(($1080-2)|0);
      $bits=$1081;
      __label__ = 244; break;
    case 244: // $1082
      __label__ = 552; break;
    case 245: // $1083
      __label__ = 246; break;
    case 246: // $1084
      var $1085=$bits;
      var $1086=$1085 & 7;
      var $1087=$hold;
      var $1088=$1087 >>> (($1086)>>>0);
      $hold=$1088;
      var $1089=$bits;
      var $1090=$1089 & 7;
      var $1091=$bits;
      var $1092=(($1091-$1090)|0);
      $bits=$1092;
      __label__ = 247; break;
    case 247: // $1093
      __label__ = 248; break;
    case 248: // $1094
      __label__ = 249; break;
    case 249: // $1095
      var $1096=$bits;
      var $1097=(($1096)>>>0) < 32;
      if ($1097) { __label__ = 250; break; } else { __label__ = 255; break; }
    case 250: // $1098
      __label__ = 251; break;
    case 251: // $1099
      var $1100=$have;
      var $1101=(($1100)|0)==0;
      if ($1101) { __label__ = 252; break; } else { __label__ = 253; break; }
    case 252: // $1102
      __label__ = 553; break;
    case 253: // $1103
      var $1104=$have;
      var $1105=(($1104-1)|0);
      $have=$1105;
      var $1106=$next;
      var $1107=(($1106+1)|0);
      $next=$1107;
      var $1108=HEAPU8[($1106)];
      var $1109=(($1108)&255);
      var $1110=$bits;
      var $1111=$1109 << $1110;
      var $1112=$hold;
      var $1113=(($1112+$1111)|0);
      $hold=$1113;
      var $1114=$bits;
      var $1115=(($1114+8)|0);
      $bits=$1115;
      __label__ = 254; break;
    case 254: // $1116
      __label__ = 249; break;
    case 255: // $1117
      __label__ = 256; break;
    case 256: // $1118
      var $1119=$hold;
      var $1120=$1119 & 65535;
      var $1121=$hold;
      var $1122=$1121 >>> 16;
      var $1123=$1122 ^ 65535;
      var $1124=(($1120)|0)!=(($1123)|0);
      if ($1124) { __label__ = 257; break; } else { __label__ = 258; break; }
    case 257: // $1125
      var $1126=$2;
      var $1127=(($1126+24)|0);
      HEAP32[(($1127)>>2)]=((STRING_TABLE.__str77608)|0);
      var $1128=$state;
      var $1129=(($1128)|0);
      HEAP32[(($1129)>>2)]=27;
      __label__ = 552; break;
    case 258: // $1130
      var $1131=$hold;
      var $1132=$1131 & 65535;
      var $1133=$state;
      var $1134=(($1133+64)|0);
      HEAP32[(($1134)>>2)]=$1132;
      __label__ = 259; break;
    case 259: // $1135
      $hold=0;
      $bits=0;
      __label__ = 260; break;
    case 260: // $1136
      var $1137=$state;
      var $1138=(($1137)|0);
      HEAP32[(($1138)>>2)]=14;
      __label__ = 261; break;
    case 261: // $1139
      var $1140=$state;
      var $1141=(($1140+64)|0);
      var $1142=HEAP32[(($1141)>>2)];
      $copy=$1142;
      var $1143=$copy;
      var $1144=(($1143)|0)!=0;
      if ($1144) { __label__ = 262; break; } else { __label__ = 269; break; }
    case 262: // $1145
      var $1146=$copy;
      var $1147=$have;
      var $1148=(($1146)>>>0) > (($1147)>>>0);
      if ($1148) { __label__ = 263; break; } else { __label__ = 264; break; }
    case 263: // $1149
      var $1150=$have;
      $copy=$1150;
      __label__ = 264; break;
    case 264: // $1151
      var $1152=$copy;
      var $1153=$left;
      var $1154=(($1152)>>>0) > (($1153)>>>0);
      if ($1154) { __label__ = 265; break; } else { __label__ = 266; break; }
    case 265: // $1155
      var $1156=$left;
      $copy=$1156;
      __label__ = 266; break;
    case 266: // $1157
      var $1158=$copy;
      var $1159=(($1158)|0)==0;
      if ($1159) { __label__ = 267; break; } else { __label__ = 268; break; }
    case 267: // $1160
      __label__ = 553; break;
    case 268: // $1161
      var $1162=$put;
      var $1163=$next;
      var $1164=$copy;
      assert($1164 % 1 === 0, 'memcpy given ' + $1164 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($1162, $1163, $1164, 1);
      var $1165=$copy;
      var $1166=$have;
      var $1167=(($1166-$1165)|0);
      $have=$1167;
      var $1168=$copy;
      var $1169=$next;
      var $1170=(($1169+$1168)|0);
      $next=$1170;
      var $1171=$copy;
      var $1172=$left;
      var $1173=(($1172-$1171)|0);
      $left=$1173;
      var $1174=$copy;
      var $1175=$put;
      var $1176=(($1175+$1174)|0);
      $put=$1176;
      var $1177=$copy;
      var $1178=$state;
      var $1179=(($1178+64)|0);
      var $1180=HEAP32[(($1179)>>2)];
      var $1181=(($1180-$1177)|0);
      HEAP32[(($1179)>>2)]=$1181;
      __label__ = 552; break;
    case 269: // $1182
      var $1183=$state;
      var $1184=(($1183)|0);
      HEAP32[(($1184)>>2)]=11;
      __label__ = 552; break;
    case 270: // $1185
      __label__ = 271; break;
    case 271: // $1186
      __label__ = 272; break;
    case 272: // $1187
      var $1188=$bits;
      var $1189=(($1188)>>>0) < 14;
      if ($1189) { __label__ = 273; break; } else { __label__ = 278; break; }
    case 273: // $1190
      __label__ = 274; break;
    case 274: // $1191
      var $1192=$have;
      var $1193=(($1192)|0)==0;
      if ($1193) { __label__ = 275; break; } else { __label__ = 276; break; }
    case 275: // $1194
      __label__ = 553; break;
    case 276: // $1195
      var $1196=$have;
      var $1197=(($1196-1)|0);
      $have=$1197;
      var $1198=$next;
      var $1199=(($1198+1)|0);
      $next=$1199;
      var $1200=HEAPU8[($1198)];
      var $1201=(($1200)&255);
      var $1202=$bits;
      var $1203=$1201 << $1202;
      var $1204=$hold;
      var $1205=(($1204+$1203)|0);
      $hold=$1205;
      var $1206=$bits;
      var $1207=(($1206+8)|0);
      $bits=$1207;
      __label__ = 277; break;
    case 277: // $1208
      __label__ = 272; break;
    case 278: // $1209
      __label__ = 279; break;
    case 279: // $1210
      var $1211=$hold;
      var $1212=$1211 & 31;
      var $1213=(($1212+257)|0);
      var $1214=$state;
      var $1215=(($1214+96)|0);
      HEAP32[(($1215)>>2)]=$1213;
      __label__ = 280; break;
    case 280: // $1216
      var $1217=$hold;
      var $1218=$1217 >>> 5;
      $hold=$1218;
      var $1219=$bits;
      var $1220=(($1219-5)|0);
      $bits=$1220;
      __label__ = 281; break;
    case 281: // $1221
      var $1222=$hold;
      var $1223=$1222 & 31;
      var $1224=(($1223+1)|0);
      var $1225=$state;
      var $1226=(($1225+100)|0);
      HEAP32[(($1226)>>2)]=$1224;
      __label__ = 282; break;
    case 282: // $1227
      var $1228=$hold;
      var $1229=$1228 >>> 5;
      $hold=$1229;
      var $1230=$bits;
      var $1231=(($1230-5)|0);
      $bits=$1231;
      __label__ = 283; break;
    case 283: // $1232
      var $1233=$hold;
      var $1234=$1233 & 15;
      var $1235=(($1234+4)|0);
      var $1236=$state;
      var $1237=(($1236+92)|0);
      HEAP32[(($1237)>>2)]=$1235;
      __label__ = 284; break;
    case 284: // $1238
      var $1239=$hold;
      var $1240=$1239 >>> 4;
      $hold=$1240;
      var $1241=$bits;
      var $1242=(($1241-4)|0);
      $bits=$1242;
      __label__ = 285; break;
    case 285: // $1243
      var $1244=$state;
      var $1245=(($1244+96)|0);
      var $1246=HEAPU32[(($1245)>>2)];
      var $1247=(($1246)>>>0) > 286;
      if ($1247) { __label__ = 287; break; } else { __label__ = 286; break; }
    case 286: // $1248
      var $1249=$state;
      var $1250=(($1249+100)|0);
      var $1251=HEAPU32[(($1250)>>2)];
      var $1252=(($1251)>>>0) > 30;
      if ($1252) { __label__ = 287; break; } else { __label__ = 288; break; }
    case 287: // $1253
      var $1254=$2;
      var $1255=(($1254+24)|0);
      HEAP32[(($1255)>>2)]=((STRING_TABLE.__str87609)|0);
      var $1256=$state;
      var $1257=(($1256)|0);
      HEAP32[(($1257)>>2)]=27;
      __label__ = 552; break;
    case 288: // $1258
      var $1259=$state;
      var $1260=(($1259+104)|0);
      HEAP32[(($1260)>>2)]=0;
      var $1261=$state;
      var $1262=(($1261)|0);
      HEAP32[(($1262)>>2)]=16;
      __label__ = 289; break;
    case 289: // $1263
      __label__ = 290; break;
    case 290: // $1264
      var $1265=$state;
      var $1266=(($1265+104)|0);
      var $1267=HEAPU32[(($1266)>>2)];
      var $1268=$state;
      var $1269=(($1268+92)|0);
      var $1270=HEAPU32[(($1269)>>2)];
      var $1271=(($1267)>>>0) < (($1270)>>>0);
      if ($1271) { __label__ = 291; break; } else { __label__ = 303; break; }
    case 291: // $1272
      __label__ = 292; break;
    case 292: // $1273
      __label__ = 293; break;
    case 293: // $1274
      var $1275=$bits;
      var $1276=(($1275)>>>0) < 3;
      if ($1276) { __label__ = 294; break; } else { __label__ = 299; break; }
    case 294: // $1277
      __label__ = 295; break;
    case 295: // $1278
      var $1279=$have;
      var $1280=(($1279)|0)==0;
      if ($1280) { __label__ = 296; break; } else { __label__ = 297; break; }
    case 296: // $1281
      __label__ = 553; break;
    case 297: // $1282
      var $1283=$have;
      var $1284=(($1283-1)|0);
      $have=$1284;
      var $1285=$next;
      var $1286=(($1285+1)|0);
      $next=$1286;
      var $1287=HEAPU8[($1285)];
      var $1288=(($1287)&255);
      var $1289=$bits;
      var $1290=$1288 << $1289;
      var $1291=$hold;
      var $1292=(($1291+$1290)|0);
      $hold=$1292;
      var $1293=$bits;
      var $1294=(($1293+8)|0);
      $bits=$1294;
      __label__ = 298; break;
    case 298: // $1295
      __label__ = 293; break;
    case 299: // $1296
      __label__ = 300; break;
    case 300: // $1297
      var $1298=$hold;
      var $1299=$1298 & 7;
      var $1300=(($1299) & 65535);
      var $1301=$state;
      var $1302=(($1301+104)|0);
      var $1303=HEAP32[(($1302)>>2)];
      var $1304=(($1303+1)|0);
      HEAP32[(($1302)>>2)]=$1304;
      var $1305=((_inflate_order+($1303<<1))|0);
      var $1306=HEAPU16[(($1305)>>1)];
      var $1307=(($1306)&65535);
      var $1308=$state;
      var $1309=(($1308+112)|0);
      var $1310=(($1309+($1307<<1))|0);
      HEAP16[(($1310)>>1)]=$1300;
      __label__ = 301; break;
    case 301: // $1311
      var $1312=$hold;
      var $1313=$1312 >>> 3;
      $hold=$1313;
      var $1314=$bits;
      var $1315=(($1314-3)|0);
      $bits=$1315;
      __label__ = 302; break;
    case 302: // $1316
      __label__ = 290; break;
    case 303: // $1317
      __label__ = 304; break;
    case 304: // $1318
      var $1319=$state;
      var $1320=(($1319+104)|0);
      var $1321=HEAPU32[(($1320)>>2)];
      var $1322=(($1321)>>>0) < 19;
      if ($1322) { __label__ = 305; break; } else { __label__ = 306; break; }
    case 305: // $1323
      var $1324=$state;
      var $1325=(($1324+104)|0);
      var $1326=HEAP32[(($1325)>>2)];
      var $1327=(($1326+1)|0);
      HEAP32[(($1325)>>2)]=$1327;
      var $1328=((_inflate_order+($1326<<1))|0);
      var $1329=HEAPU16[(($1328)>>1)];
      var $1330=(($1329)&65535);
      var $1331=$state;
      var $1332=(($1331+112)|0);
      var $1333=(($1332+($1330<<1))|0);
      HEAP16[(($1333)>>1)]=0;
      __label__ = 304; break;
    case 306: // $1334
      var $1335=$state;
      var $1336=(($1335+1328)|0);
      var $1337=(($1336)|0);
      var $1338=$state;
      var $1339=(($1338+108)|0);
      HEAP32[(($1339)>>2)]=$1337;
      var $1340=$state;
      var $1341=(($1340+108)|0);
      var $1342=HEAP32[(($1341)>>2)];
      var $1343=$state;
      var $1344=(($1343+76)|0);
      HEAP32[(($1344)>>2)]=$1342;
      var $1345=$state;
      var $1346=(($1345+84)|0);
      HEAP32[(($1346)>>2)]=7;
      var $1347=$state;
      var $1348=(($1347+112)|0);
      var $1349=(($1348)|0);
      var $1350=$state;
      var $1351=(($1350+108)|0);
      var $1352=$state;
      var $1353=(($1352+84)|0);
      var $1354=$state;
      var $1355=(($1354+752)|0);
      var $1356=(($1355)|0);
      var $1357=_inflate_table(0, $1349, 19, $1351, $1353, $1356);
      $ret=$1357;
      var $1358=$ret;
      var $1359=(($1358)|0)!=0;
      if ($1359) { __label__ = 307; break; } else { __label__ = 308; break; }
    case 307: // $1360
      var $1361=$2;
      var $1362=(($1361+24)|0);
      HEAP32[(($1362)>>2)]=((STRING_TABLE.__str97610)|0);
      var $1363=$state;
      var $1364=(($1363)|0);
      HEAP32[(($1364)>>2)]=27;
      __label__ = 552; break;
    case 308: // $1365
      var $1366=$state;
      var $1367=(($1366+104)|0);
      HEAP32[(($1367)>>2)]=0;
      var $1368=$state;
      var $1369=(($1368)|0);
      HEAP32[(($1369)>>2)]=17;
      __label__ = 309; break;
    case 309: // $1370
      __label__ = 310; break;
    case 310: // $1371
      var $1372=$state;
      var $1373=(($1372+104)|0);
      var $1374=HEAPU32[(($1373)>>2)];
      var $1375=$state;
      var $1376=(($1375+96)|0);
      var $1377=HEAP32[(($1376)>>2)];
      var $1378=$state;
      var $1379=(($1378+100)|0);
      var $1380=HEAP32[(($1379)>>2)];
      var $1381=(($1377+$1380)|0);
      var $1382=(($1374)>>>0) < (($1381)>>>0);
      if ($1382) { __label__ = 311; break; } else { __label__ = 386; break; }
    case 311: // $1383
      __label__ = 312; break;
    case 312: // $1384
      var $1385=$hold;
      var $1386=$state;
      var $1387=(($1386+84)|0);
      var $1388=HEAP32[(($1387)>>2)];
      var $1389=1 << $1388;
      var $1390=(($1389-1)|0);
      var $1391=$1385 & $1390;
      var $1392=$state;
      var $1393=(($1392+76)|0);
      var $1394=HEAP32[(($1393)>>2)];
      var $1395=(($1394+($1391<<2))|0);
      var $1396=$this;
      var $1397=$1395;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($1396)>>1)]=HEAP16[(($1397)>>1)];HEAP16[(($1396+2)>>1)]=HEAP16[(($1397+2)>>1)];
      var $1398=(($this+1)|0);
      var $1399=HEAPU8[($1398)];
      var $1400=(($1399)&255);
      var $1401=$bits;
      var $1402=(($1400)>>>0) <= (($1401)>>>0);
      if ($1402) { __label__ = 313; break; } else { __label__ = 314; break; }
    case 313: // $1403
      __label__ = 319; break;
    case 314: // $1404
      __label__ = 315; break;
    case 315: // $1405
      var $1406=$have;
      var $1407=(($1406)|0)==0;
      if ($1407) { __label__ = 316; break; } else { __label__ = 317; break; }
    case 316: // $1408
      __label__ = 553; break;
    case 317: // $1409
      var $1410=$have;
      var $1411=(($1410-1)|0);
      $have=$1411;
      var $1412=$next;
      var $1413=(($1412+1)|0);
      $next=$1413;
      var $1414=HEAPU8[($1412)];
      var $1415=(($1414)&255);
      var $1416=$bits;
      var $1417=$1415 << $1416;
      var $1418=$hold;
      var $1419=(($1418+$1417)|0);
      $hold=$1419;
      var $1420=$bits;
      var $1421=(($1420+8)|0);
      $bits=$1421;
      __label__ = 318; break;
    case 318: // $1422
      __label__ = 312; break;
    case 319: // $1423
      var $1424=(($this+2)|0);
      var $1425=HEAPU16[(($1424)>>1)];
      var $1426=(($1425)&65535);
      var $1427=(($1426)|0) < 16;
      if ($1427) { __label__ = 320; break; } else { __label__ = 332; break; }
    case 320: // $1428
      __label__ = 321; break;
    case 321: // $1429
      __label__ = 322; break;
    case 322: // $1430
      var $1431=$bits;
      var $1432=(($this+1)|0);
      var $1433=HEAPU8[($1432)];
      var $1434=(($1433)&255);
      var $1435=(($1431)>>>0) < (($1434)>>>0);
      if ($1435) { __label__ = 323; break; } else { __label__ = 328; break; }
    case 323: // $1436
      __label__ = 324; break;
    case 324: // $1437
      var $1438=$have;
      var $1439=(($1438)|0)==0;
      if ($1439) { __label__ = 325; break; } else { __label__ = 326; break; }
    case 325: // $1440
      __label__ = 553; break;
    case 326: // $1441
      var $1442=$have;
      var $1443=(($1442-1)|0);
      $have=$1443;
      var $1444=$next;
      var $1445=(($1444+1)|0);
      $next=$1445;
      var $1446=HEAPU8[($1444)];
      var $1447=(($1446)&255);
      var $1448=$bits;
      var $1449=$1447 << $1448;
      var $1450=$hold;
      var $1451=(($1450+$1449)|0);
      $hold=$1451;
      var $1452=$bits;
      var $1453=(($1452+8)|0);
      $bits=$1453;
      __label__ = 327; break;
    case 327: // $1454
      __label__ = 322; break;
    case 328: // $1455
      __label__ = 329; break;
    case 329: // $1456
      __label__ = 330; break;
    case 330: // $1457
      var $1458=(($this+1)|0);
      var $1459=HEAPU8[($1458)];
      var $1460=(($1459)&255);
      var $1461=$hold;
      var $1462=$1461 >>> (($1460)>>>0);
      $hold=$1462;
      var $1463=(($this+1)|0);
      var $1464=HEAPU8[($1463)];
      var $1465=(($1464)&255);
      var $1466=$bits;
      var $1467=(($1466-$1465)|0);
      $bits=$1467;
      __label__ = 331; break;
    case 331: // $1468
      var $1469=(($this+2)|0);
      var $1470=HEAP16[(($1469)>>1)];
      var $1471=$state;
      var $1472=(($1471+104)|0);
      var $1473=HEAP32[(($1472)>>2)];
      var $1474=(($1473+1)|0);
      HEAP32[(($1472)>>2)]=$1474;
      var $1475=$state;
      var $1476=(($1475+112)|0);
      var $1477=(($1476+($1473<<1))|0);
      HEAP16[(($1477)>>1)]=$1470;
      __label__ = 385; break;
    case 332: // $1478
      var $1479=(($this+2)|0);
      var $1480=HEAPU16[(($1479)>>1)];
      var $1481=(($1480)&65535);
      var $1482=(($1481)|0)==16;
      if ($1482) { __label__ = 333; break; } else { __label__ = 349; break; }
    case 333: // $1483
      __label__ = 334; break;
    case 334: // $1484
      __label__ = 335; break;
    case 335: // $1485
      var $1486=$bits;
      var $1487=(($this+1)|0);
      var $1488=HEAPU8[($1487)];
      var $1489=(($1488)&255);
      var $1490=(($1489+2)|0);
      var $1491=(($1486)>>>0) < (($1490)>>>0);
      if ($1491) { __label__ = 336; break; } else { __label__ = 341; break; }
    case 336: // $1492
      __label__ = 337; break;
    case 337: // $1493
      var $1494=$have;
      var $1495=(($1494)|0)==0;
      if ($1495) { __label__ = 338; break; } else { __label__ = 339; break; }
    case 338: // $1496
      __label__ = 553; break;
    case 339: // $1497
      var $1498=$have;
      var $1499=(($1498-1)|0);
      $have=$1499;
      var $1500=$next;
      var $1501=(($1500+1)|0);
      $next=$1501;
      var $1502=HEAPU8[($1500)];
      var $1503=(($1502)&255);
      var $1504=$bits;
      var $1505=$1503 << $1504;
      var $1506=$hold;
      var $1507=(($1506+$1505)|0);
      $hold=$1507;
      var $1508=$bits;
      var $1509=(($1508+8)|0);
      $bits=$1509;
      __label__ = 340; break;
    case 340: // $1510
      __label__ = 335; break;
    case 341: // $1511
      __label__ = 342; break;
    case 342: // $1512
      __label__ = 343; break;
    case 343: // $1513
      var $1514=(($this+1)|0);
      var $1515=HEAPU8[($1514)];
      var $1516=(($1515)&255);
      var $1517=$hold;
      var $1518=$1517 >>> (($1516)>>>0);
      $hold=$1518;
      var $1519=(($this+1)|0);
      var $1520=HEAPU8[($1519)];
      var $1521=(($1520)&255);
      var $1522=$bits;
      var $1523=(($1522-$1521)|0);
      $bits=$1523;
      __label__ = 344; break;
    case 344: // $1524
      var $1525=$state;
      var $1526=(($1525+104)|0);
      var $1527=HEAP32[(($1526)>>2)];
      var $1528=(($1527)|0)==0;
      if ($1528) { __label__ = 345; break; } else { __label__ = 346; break; }
    case 345: // $1529
      var $1530=$2;
      var $1531=(($1530+24)|0);
      HEAP32[(($1531)>>2)]=((STRING_TABLE.__str107611)|0);
      var $1532=$state;
      var $1533=(($1532)|0);
      HEAP32[(($1533)>>2)]=27;
      __label__ = 386; break;
    case 346: // $1534
      var $1535=$state;
      var $1536=(($1535+104)|0);
      var $1537=HEAP32[(($1536)>>2)];
      var $1538=(($1537-1)|0);
      var $1539=$state;
      var $1540=(($1539+112)|0);
      var $1541=(($1540+($1538<<1))|0);
      var $1542=HEAPU16[(($1541)>>1)];
      var $1543=(($1542)&65535);
      $len=$1543;
      var $1544=$hold;
      var $1545=$1544 & 3;
      var $1546=(($1545+3)|0);
      $copy=$1546;
      __label__ = 347; break;
    case 347: // $1547
      var $1548=$hold;
      var $1549=$1548 >>> 2;
      $hold=$1549;
      var $1550=$bits;
      var $1551=(($1550-2)|0);
      $bits=$1551;
      __label__ = 348; break;
    case 348: // $1552
      __label__ = 379; break;
    case 349: // $1553
      var $1554=(($this+2)|0);
      var $1555=HEAPU16[(($1554)>>1)];
      var $1556=(($1555)&65535);
      var $1557=(($1556)|0)==17;
      if ($1557) { __label__ = 350; break; } else { __label__ = 364; break; }
    case 350: // $1558
      __label__ = 351; break;
    case 351: // $1559
      __label__ = 352; break;
    case 352: // $1560
      var $1561=$bits;
      var $1562=(($this+1)|0);
      var $1563=HEAPU8[($1562)];
      var $1564=(($1563)&255);
      var $1565=(($1564+3)|0);
      var $1566=(($1561)>>>0) < (($1565)>>>0);
      if ($1566) { __label__ = 353; break; } else { __label__ = 358; break; }
    case 353: // $1567
      __label__ = 354; break;
    case 354: // $1568
      var $1569=$have;
      var $1570=(($1569)|0)==0;
      if ($1570) { __label__ = 355; break; } else { __label__ = 356; break; }
    case 355: // $1571
      __label__ = 553; break;
    case 356: // $1572
      var $1573=$have;
      var $1574=(($1573-1)|0);
      $have=$1574;
      var $1575=$next;
      var $1576=(($1575+1)|0);
      $next=$1576;
      var $1577=HEAPU8[($1575)];
      var $1578=(($1577)&255);
      var $1579=$bits;
      var $1580=$1578 << $1579;
      var $1581=$hold;
      var $1582=(($1581+$1580)|0);
      $hold=$1582;
      var $1583=$bits;
      var $1584=(($1583+8)|0);
      $bits=$1584;
      __label__ = 357; break;
    case 357: // $1585
      __label__ = 352; break;
    case 358: // $1586
      __label__ = 359; break;
    case 359: // $1587
      __label__ = 360; break;
    case 360: // $1588
      var $1589=(($this+1)|0);
      var $1590=HEAPU8[($1589)];
      var $1591=(($1590)&255);
      var $1592=$hold;
      var $1593=$1592 >>> (($1591)>>>0);
      $hold=$1593;
      var $1594=(($this+1)|0);
      var $1595=HEAPU8[($1594)];
      var $1596=(($1595)&255);
      var $1597=$bits;
      var $1598=(($1597-$1596)|0);
      $bits=$1598;
      __label__ = 361; break;
    case 361: // $1599
      $len=0;
      var $1600=$hold;
      var $1601=$1600 & 7;
      var $1602=(($1601+3)|0);
      $copy=$1602;
      __label__ = 362; break;
    case 362: // $1603
      var $1604=$hold;
      var $1605=$1604 >>> 3;
      $hold=$1605;
      var $1606=$bits;
      var $1607=(($1606-3)|0);
      $bits=$1607;
      __label__ = 363; break;
    case 363: // $1608
      __label__ = 378; break;
    case 364: // $1609
      __label__ = 365; break;
    case 365: // $1610
      __label__ = 366; break;
    case 366: // $1611
      var $1612=$bits;
      var $1613=(($this+1)|0);
      var $1614=HEAPU8[($1613)];
      var $1615=(($1614)&255);
      var $1616=(($1615+7)|0);
      var $1617=(($1612)>>>0) < (($1616)>>>0);
      if ($1617) { __label__ = 367; break; } else { __label__ = 372; break; }
    case 367: // $1618
      __label__ = 368; break;
    case 368: // $1619
      var $1620=$have;
      var $1621=(($1620)|0)==0;
      if ($1621) { __label__ = 369; break; } else { __label__ = 370; break; }
    case 369: // $1622
      __label__ = 553; break;
    case 370: // $1623
      var $1624=$have;
      var $1625=(($1624-1)|0);
      $have=$1625;
      var $1626=$next;
      var $1627=(($1626+1)|0);
      $next=$1627;
      var $1628=HEAPU8[($1626)];
      var $1629=(($1628)&255);
      var $1630=$bits;
      var $1631=$1629 << $1630;
      var $1632=$hold;
      var $1633=(($1632+$1631)|0);
      $hold=$1633;
      var $1634=$bits;
      var $1635=(($1634+8)|0);
      $bits=$1635;
      __label__ = 371; break;
    case 371: // $1636
      __label__ = 366; break;
    case 372: // $1637
      __label__ = 373; break;
    case 373: // $1638
      __label__ = 374; break;
    case 374: // $1639
      var $1640=(($this+1)|0);
      var $1641=HEAPU8[($1640)];
      var $1642=(($1641)&255);
      var $1643=$hold;
      var $1644=$1643 >>> (($1642)>>>0);
      $hold=$1644;
      var $1645=(($this+1)|0);
      var $1646=HEAPU8[($1645)];
      var $1647=(($1646)&255);
      var $1648=$bits;
      var $1649=(($1648-$1647)|0);
      $bits=$1649;
      __label__ = 375; break;
    case 375: // $1650
      $len=0;
      var $1651=$hold;
      var $1652=$1651 & 127;
      var $1653=(($1652+11)|0);
      $copy=$1653;
      __label__ = 376; break;
    case 376: // $1654
      var $1655=$hold;
      var $1656=$1655 >>> 7;
      $hold=$1656;
      var $1657=$bits;
      var $1658=(($1657-7)|0);
      $bits=$1658;
      __label__ = 377; break;
    case 377: // $1659
      __label__ = 378; break;
    case 378: // $1660
      __label__ = 379; break;
    case 379: // $1661
      var $1662=$state;
      var $1663=(($1662+104)|0);
      var $1664=HEAP32[(($1663)>>2)];
      var $1665=$copy;
      var $1666=(($1664+$1665)|0);
      var $1667=$state;
      var $1668=(($1667+96)|0);
      var $1669=HEAP32[(($1668)>>2)];
      var $1670=$state;
      var $1671=(($1670+100)|0);
      var $1672=HEAP32[(($1671)>>2)];
      var $1673=(($1669+$1672)|0);
      var $1674=(($1666)>>>0) > (($1673)>>>0);
      if ($1674) { __label__ = 380; break; } else { __label__ = 381; break; }
    case 380: // $1675
      var $1676=$2;
      var $1677=(($1676+24)|0);
      HEAP32[(($1677)>>2)]=((STRING_TABLE.__str107611)|0);
      var $1678=$state;
      var $1679=(($1678)|0);
      HEAP32[(($1679)>>2)]=27;
      __label__ = 386; break;
    case 381: // $1680
      __label__ = 382; break;
    case 382: // $1681
      var $1682=$copy;
      var $1683=(($1682-1)|0);
      $copy=$1683;
      var $1684=(($1682)|0)!=0;
      if ($1684) { __label__ = 383; break; } else { __label__ = 384; break; }
    case 383: // $1685
      var $1686=$len;
      var $1687=(($1686) & 65535);
      var $1688=$state;
      var $1689=(($1688+104)|0);
      var $1690=HEAP32[(($1689)>>2)];
      var $1691=(($1690+1)|0);
      HEAP32[(($1689)>>2)]=$1691;
      var $1692=$state;
      var $1693=(($1692+112)|0);
      var $1694=(($1693+($1690<<1))|0);
      HEAP16[(($1694)>>1)]=$1687;
      __label__ = 382; break;
    case 384: // $1695
      __label__ = 385; break;
    case 385: // $1696
      __label__ = 310; break;
    case 386: // $1697
      var $1698=$state;
      var $1699=(($1698)|0);
      var $1700=HEAP32[(($1699)>>2)];
      var $1701=(($1700)|0)==27;
      if ($1701) { __label__ = 387; break; } else { __label__ = 388; break; }
    case 387: // $1702
      __label__ = 552; break;
    case 388: // $1703
      var $1704=$state;
      var $1705=(($1704+1328)|0);
      var $1706=(($1705)|0);
      var $1707=$state;
      var $1708=(($1707+108)|0);
      HEAP32[(($1708)>>2)]=$1706;
      var $1709=$state;
      var $1710=(($1709+108)|0);
      var $1711=HEAP32[(($1710)>>2)];
      var $1712=$state;
      var $1713=(($1712+76)|0);
      HEAP32[(($1713)>>2)]=$1711;
      var $1714=$state;
      var $1715=(($1714+84)|0);
      HEAP32[(($1715)>>2)]=9;
      var $1716=$state;
      var $1717=(($1716+112)|0);
      var $1718=(($1717)|0);
      var $1719=$state;
      var $1720=(($1719+96)|0);
      var $1721=HEAP32[(($1720)>>2)];
      var $1722=$state;
      var $1723=(($1722+108)|0);
      var $1724=$state;
      var $1725=(($1724+84)|0);
      var $1726=$state;
      var $1727=(($1726+752)|0);
      var $1728=(($1727)|0);
      var $1729=_inflate_table(1, $1718, $1721, $1723, $1725, $1728);
      $ret=$1729;
      var $1730=$ret;
      var $1731=(($1730)|0)!=0;
      if ($1731) { __label__ = 389; break; } else { __label__ = 390; break; }
    case 389: // $1732
      var $1733=$2;
      var $1734=(($1733+24)|0);
      HEAP32[(($1734)>>2)]=((STRING_TABLE.__str117612)|0);
      var $1735=$state;
      var $1736=(($1735)|0);
      HEAP32[(($1736)>>2)]=27;
      __label__ = 552; break;
    case 390: // $1737
      var $1738=$state;
      var $1739=(($1738+108)|0);
      var $1740=HEAP32[(($1739)>>2)];
      var $1741=$state;
      var $1742=(($1741+80)|0);
      HEAP32[(($1742)>>2)]=$1740;
      var $1743=$state;
      var $1744=(($1743+88)|0);
      HEAP32[(($1744)>>2)]=6;
      var $1745=$state;
      var $1746=(($1745+112)|0);
      var $1747=(($1746)|0);
      var $1748=$state;
      var $1749=(($1748+96)|0);
      var $1750=HEAP32[(($1749)>>2)];
      var $1751=(($1747+($1750<<1))|0);
      var $1752=$state;
      var $1753=(($1752+100)|0);
      var $1754=HEAP32[(($1753)>>2)];
      var $1755=$state;
      var $1756=(($1755+108)|0);
      var $1757=$state;
      var $1758=(($1757+88)|0);
      var $1759=$state;
      var $1760=(($1759+752)|0);
      var $1761=(($1760)|0);
      var $1762=_inflate_table(2, $1751, $1754, $1756, $1758, $1761);
      $ret=$1762;
      var $1763=$ret;
      var $1764=(($1763)|0)!=0;
      if ($1764) { __label__ = 391; break; } else { __label__ = 392; break; }
    case 391: // $1765
      var $1766=$2;
      var $1767=(($1766+24)|0);
      HEAP32[(($1767)>>2)]=((STRING_TABLE.__str127613)|0);
      var $1768=$state;
      var $1769=(($1768)|0);
      HEAP32[(($1769)>>2)]=27;
      __label__ = 552; break;
    case 392: // $1770
      var $1771=$state;
      var $1772=(($1771)|0);
      HEAP32[(($1772)>>2)]=18;
      __label__ = 393; break;
    case 393: // $1773
      var $1774=$have;
      var $1775=(($1774)>>>0) >= 6;
      if ($1775) { __label__ = 394; break; } else { __label__ = 400; break; }
    case 394: // $1776
      var $1777=$left;
      var $1778=(($1777)>>>0) >= 258;
      if ($1778) { __label__ = 395; break; } else { __label__ = 400; break; }
    case 395: // $1779
      __label__ = 396; break;
    case 396: // $1780
      var $1781=$put;
      var $1782=$2;
      var $1783=(($1782+12)|0);
      HEAP32[(($1783)>>2)]=$1781;
      var $1784=$left;
      var $1785=$2;
      var $1786=(($1785+16)|0);
      HEAP32[(($1786)>>2)]=$1784;
      var $1787=$next;
      var $1788=$2;
      var $1789=(($1788)|0);
      HEAP32[(($1789)>>2)]=$1787;
      var $1790=$have;
      var $1791=$2;
      var $1792=(($1791+4)|0);
      HEAP32[(($1792)>>2)]=$1790;
      var $1793=$hold;
      var $1794=$state;
      var $1795=(($1794+56)|0);
      HEAP32[(($1795)>>2)]=$1793;
      var $1796=$bits;
      var $1797=$state;
      var $1798=(($1797+60)|0);
      HEAP32[(($1798)>>2)]=$1796;
      __label__ = 397; break;
    case 397: // $1799
      var $1800=$2;
      var $1801=$out;
      _inflate_fast($1800, $1801);
      __label__ = 398; break;
    case 398: // $1802
      var $1803=$2;
      var $1804=(($1803+12)|0);
      var $1805=HEAP32[(($1804)>>2)];
      $put=$1805;
      var $1806=$2;
      var $1807=(($1806+16)|0);
      var $1808=HEAP32[(($1807)>>2)];
      $left=$1808;
      var $1809=$2;
      var $1810=(($1809)|0);
      var $1811=HEAP32[(($1810)>>2)];
      $next=$1811;
      var $1812=$2;
      var $1813=(($1812+4)|0);
      var $1814=HEAP32[(($1813)>>2)];
      $have=$1814;
      var $1815=$state;
      var $1816=(($1815+56)|0);
      var $1817=HEAP32[(($1816)>>2)];
      $hold=$1817;
      var $1818=$state;
      var $1819=(($1818+60)|0);
      var $1820=HEAP32[(($1819)>>2)];
      $bits=$1820;
      __label__ = 399; break;
    case 399: // $1821
      __label__ = 552; break;
    case 400: // $1822
      __label__ = 401; break;
    case 401: // $1823
      var $1824=$hold;
      var $1825=$state;
      var $1826=(($1825+84)|0);
      var $1827=HEAP32[(($1826)>>2)];
      var $1828=1 << $1827;
      var $1829=(($1828-1)|0);
      var $1830=$1824 & $1829;
      var $1831=$state;
      var $1832=(($1831+76)|0);
      var $1833=HEAP32[(($1832)>>2)];
      var $1834=(($1833+($1830<<2))|0);
      var $1835=$this;
      var $1836=$1834;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($1835)>>1)]=HEAP16[(($1836)>>1)];HEAP16[(($1835+2)>>1)]=HEAP16[(($1836+2)>>1)];
      var $1837=(($this+1)|0);
      var $1838=HEAPU8[($1837)];
      var $1839=(($1838)&255);
      var $1840=$bits;
      var $1841=(($1839)>>>0) <= (($1840)>>>0);
      if ($1841) { __label__ = 402; break; } else { __label__ = 403; break; }
    case 402: // $1842
      __label__ = 408; break;
    case 403: // $1843
      __label__ = 404; break;
    case 404: // $1844
      var $1845=$have;
      var $1846=(($1845)|0)==0;
      if ($1846) { __label__ = 405; break; } else { __label__ = 406; break; }
    case 405: // $1847
      __label__ = 553; break;
    case 406: // $1848
      var $1849=$have;
      var $1850=(($1849-1)|0);
      $have=$1850;
      var $1851=$next;
      var $1852=(($1851+1)|0);
      $next=$1852;
      var $1853=HEAPU8[($1851)];
      var $1854=(($1853)&255);
      var $1855=$bits;
      var $1856=$1854 << $1855;
      var $1857=$hold;
      var $1858=(($1857+$1856)|0);
      $hold=$1858;
      var $1859=$bits;
      var $1860=(($1859+8)|0);
      $bits=$1860;
      __label__ = 407; break;
    case 407: // $1861
      __label__ = 401; break;
    case 408: // $1862
      var $1863=(($this)|0);
      var $1864=HEAPU8[($1863)];
      var $1865=(($1864)&255);
      var $1866=(($1865)|0)!=0;
      if ($1866) { __label__ = 409; break; } else { __label__ = 421; break; }
    case 409: // $1867
      var $1868=(($this)|0);
      var $1869=HEAPU8[($1868)];
      var $1870=(($1869)&255);
      var $1871=$1870 & 240;
      var $1872=(($1871)|0)==0;
      if ($1872) { __label__ = 410; break; } else { __label__ = 421; break; }
    case 410: // $1873
      var $1874=$last;
      var $1875=$this;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($1874)>>1)]=HEAP16[(($1875)>>1)];HEAP16[(($1874+2)>>1)]=HEAP16[(($1875+2)>>1)];
      __label__ = 411; break;
    case 411: // $1876
      var $1877=(($last+2)|0);
      var $1878=HEAPU16[(($1877)>>1)];
      var $1879=(($1878)&65535);
      var $1880=$hold;
      var $1881=(($last+1)|0);
      var $1882=HEAPU8[($1881)];
      var $1883=(($1882)&255);
      var $1884=(($last)|0);
      var $1885=HEAPU8[($1884)];
      var $1886=(($1885)&255);
      var $1887=(($1883+$1886)|0);
      var $1888=1 << $1887;
      var $1889=(($1888-1)|0);
      var $1890=$1880 & $1889;
      var $1891=(($last+1)|0);
      var $1892=HEAPU8[($1891)];
      var $1893=(($1892)&255);
      var $1894=$1890 >>> (($1893)>>>0);
      var $1895=(($1879+$1894)|0);
      var $1896=$state;
      var $1897=(($1896+76)|0);
      var $1898=HEAP32[(($1897)>>2)];
      var $1899=(($1898+($1895<<2))|0);
      var $1900=$this;
      var $1901=$1899;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($1900)>>1)]=HEAP16[(($1901)>>1)];HEAP16[(($1900+2)>>1)]=HEAP16[(($1901+2)>>1)];
      var $1902=(($last+1)|0);
      var $1903=HEAPU8[($1902)];
      var $1904=(($1903)&255);
      var $1905=(($this+1)|0);
      var $1906=HEAPU8[($1905)];
      var $1907=(($1906)&255);
      var $1908=(($1904+$1907)|0);
      var $1909=$bits;
      var $1910=(($1908)>>>0) <= (($1909)>>>0);
      if ($1910) { __label__ = 412; break; } else { __label__ = 413; break; }
    case 412: // $1911
      __label__ = 418; break;
    case 413: // $1912
      __label__ = 414; break;
    case 414: // $1913
      var $1914=$have;
      var $1915=(($1914)|0)==0;
      if ($1915) { __label__ = 415; break; } else { __label__ = 416; break; }
    case 415: // $1916
      __label__ = 553; break;
    case 416: // $1917
      var $1918=$have;
      var $1919=(($1918-1)|0);
      $have=$1919;
      var $1920=$next;
      var $1921=(($1920+1)|0);
      $next=$1921;
      var $1922=HEAPU8[($1920)];
      var $1923=(($1922)&255);
      var $1924=$bits;
      var $1925=$1923 << $1924;
      var $1926=$hold;
      var $1927=(($1926+$1925)|0);
      $hold=$1927;
      var $1928=$bits;
      var $1929=(($1928+8)|0);
      $bits=$1929;
      __label__ = 417; break;
    case 417: // $1930
      __label__ = 411; break;
    case 418: // $1931
      __label__ = 419; break;
    case 419: // $1932
      var $1933=(($last+1)|0);
      var $1934=HEAPU8[($1933)];
      var $1935=(($1934)&255);
      var $1936=$hold;
      var $1937=$1936 >>> (($1935)>>>0);
      $hold=$1937;
      var $1938=(($last+1)|0);
      var $1939=HEAPU8[($1938)];
      var $1940=(($1939)&255);
      var $1941=$bits;
      var $1942=(($1941-$1940)|0);
      $bits=$1942;
      __label__ = 420; break;
    case 420: // $1943
      __label__ = 421; break;
    case 421: // $1944
      __label__ = 422; break;
    case 422: // $1945
      var $1946=(($this+1)|0);
      var $1947=HEAPU8[($1946)];
      var $1948=(($1947)&255);
      var $1949=$hold;
      var $1950=$1949 >>> (($1948)>>>0);
      $hold=$1950;
      var $1951=(($this+1)|0);
      var $1952=HEAPU8[($1951)];
      var $1953=(($1952)&255);
      var $1954=$bits;
      var $1955=(($1954-$1953)|0);
      $bits=$1955;
      __label__ = 423; break;
    case 423: // $1956
      var $1957=(($this+2)|0);
      var $1958=HEAPU16[(($1957)>>1)];
      var $1959=(($1958)&65535);
      var $1960=$state;
      var $1961=(($1960+64)|0);
      HEAP32[(($1961)>>2)]=$1959;
      var $1962=(($this)|0);
      var $1963=HEAPU8[($1962)];
      var $1964=(($1963)&255);
      var $1965=(($1964)|0)==0;
      if ($1965) { __label__ = 424; break; } else { __label__ = 425; break; }
    case 424: // $1966
      var $1967=$state;
      var $1968=(($1967)|0);
      HEAP32[(($1968)>>2)]=23;
      __label__ = 552; break;
    case 425: // $1969
      var $1970=(($this)|0);
      var $1971=HEAPU8[($1970)];
      var $1972=(($1971)&255);
      var $1973=$1972 & 32;
      var $1974=(($1973)|0)!=0;
      if ($1974) { __label__ = 426; break; } else { __label__ = 427; break; }
    case 426: // $1975
      var $1976=$state;
      var $1977=(($1976)|0);
      HEAP32[(($1977)>>2)]=11;
      __label__ = 552; break;
    case 427: // $1978
      var $1979=(($this)|0);
      var $1980=HEAPU8[($1979)];
      var $1981=(($1980)&255);
      var $1982=$1981 & 64;
      var $1983=(($1982)|0)!=0;
      if ($1983) { __label__ = 428; break; } else { __label__ = 429; break; }
    case 428: // $1984
      var $1985=$2;
      var $1986=(($1985+24)|0);
      HEAP32[(($1986)>>2)]=((STRING_TABLE.__str137614)|0);
      var $1987=$state;
      var $1988=(($1987)|0);
      HEAP32[(($1988)>>2)]=27;
      __label__ = 552; break;
    case 429: // $1989
      var $1990=(($this)|0);
      var $1991=HEAPU8[($1990)];
      var $1992=(($1991)&255);
      var $1993=$1992 & 15;
      var $1994=$state;
      var $1995=(($1994+72)|0);
      HEAP32[(($1995)>>2)]=$1993;
      var $1996=$state;
      var $1997=(($1996)|0);
      HEAP32[(($1997)>>2)]=19;
      __label__ = 430; break;
    case 430: // $1998
      var $1999=$state;
      var $2000=(($1999+72)|0);
      var $2001=HEAP32[(($2000)>>2)];
      var $2002=(($2001)|0)!=0;
      if ($2002) { __label__ = 431; break; } else { __label__ = 443; break; }
    case 431: // $2003
      __label__ = 432; break;
    case 432: // $2004
      __label__ = 433; break;
    case 433: // $2005
      var $2006=$bits;
      var $2007=$state;
      var $2008=(($2007+72)|0);
      var $2009=HEAPU32[(($2008)>>2)];
      var $2010=(($2006)>>>0) < (($2009)>>>0);
      if ($2010) { __label__ = 434; break; } else { __label__ = 439; break; }
    case 434: // $2011
      __label__ = 435; break;
    case 435: // $2012
      var $2013=$have;
      var $2014=(($2013)|0)==0;
      if ($2014) { __label__ = 436; break; } else { __label__ = 437; break; }
    case 436: // $2015
      __label__ = 553; break;
    case 437: // $2016
      var $2017=$have;
      var $2018=(($2017-1)|0);
      $have=$2018;
      var $2019=$next;
      var $2020=(($2019+1)|0);
      $next=$2020;
      var $2021=HEAPU8[($2019)];
      var $2022=(($2021)&255);
      var $2023=$bits;
      var $2024=$2022 << $2023;
      var $2025=$hold;
      var $2026=(($2025+$2024)|0);
      $hold=$2026;
      var $2027=$bits;
      var $2028=(($2027+8)|0);
      $bits=$2028;
      __label__ = 438; break;
    case 438: // $2029
      __label__ = 433; break;
    case 439: // $2030
      __label__ = 440; break;
    case 440: // $2031
      var $2032=$hold;
      var $2033=$state;
      var $2034=(($2033+72)|0);
      var $2035=HEAP32[(($2034)>>2)];
      var $2036=1 << $2035;
      var $2037=(($2036-1)|0);
      var $2038=$2032 & $2037;
      var $2039=$state;
      var $2040=(($2039+64)|0);
      var $2041=HEAP32[(($2040)>>2)];
      var $2042=(($2041+$2038)|0);
      HEAP32[(($2040)>>2)]=$2042;
      __label__ = 441; break;
    case 441: // $2043
      var $2044=$state;
      var $2045=(($2044+72)|0);
      var $2046=HEAPU32[(($2045)>>2)];
      var $2047=$hold;
      var $2048=$2047 >>> (($2046)>>>0);
      $hold=$2048;
      var $2049=$state;
      var $2050=(($2049+72)|0);
      var $2051=HEAP32[(($2050)>>2)];
      var $2052=$bits;
      var $2053=(($2052-$2051)|0);
      $bits=$2053;
      __label__ = 442; break;
    case 442: // $2054
      __label__ = 443; break;
    case 443: // $2055
      var $2056=$state;
      var $2057=(($2056)|0);
      HEAP32[(($2057)>>2)]=20;
      __label__ = 444; break;
    case 444: // $2058
      __label__ = 445; break;
    case 445: // $2059
      var $2060=$hold;
      var $2061=$state;
      var $2062=(($2061+88)|0);
      var $2063=HEAP32[(($2062)>>2)];
      var $2064=1 << $2063;
      var $2065=(($2064-1)|0);
      var $2066=$2060 & $2065;
      var $2067=$state;
      var $2068=(($2067+80)|0);
      var $2069=HEAP32[(($2068)>>2)];
      var $2070=(($2069+($2066<<2))|0);
      var $2071=$this;
      var $2072=$2070;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($2071)>>1)]=HEAP16[(($2072)>>1)];HEAP16[(($2071+2)>>1)]=HEAP16[(($2072+2)>>1)];
      var $2073=(($this+1)|0);
      var $2074=HEAPU8[($2073)];
      var $2075=(($2074)&255);
      var $2076=$bits;
      var $2077=(($2075)>>>0) <= (($2076)>>>0);
      if ($2077) { __label__ = 446; break; } else { __label__ = 447; break; }
    case 446: // $2078
      __label__ = 452; break;
    case 447: // $2079
      __label__ = 448; break;
    case 448: // $2080
      var $2081=$have;
      var $2082=(($2081)|0)==0;
      if ($2082) { __label__ = 449; break; } else { __label__ = 450; break; }
    case 449: // $2083
      __label__ = 553; break;
    case 450: // $2084
      var $2085=$have;
      var $2086=(($2085-1)|0);
      $have=$2086;
      var $2087=$next;
      var $2088=(($2087+1)|0);
      $next=$2088;
      var $2089=HEAPU8[($2087)];
      var $2090=(($2089)&255);
      var $2091=$bits;
      var $2092=$2090 << $2091;
      var $2093=$hold;
      var $2094=(($2093+$2092)|0);
      $hold=$2094;
      var $2095=$bits;
      var $2096=(($2095+8)|0);
      $bits=$2096;
      __label__ = 451; break;
    case 451: // $2097
      __label__ = 445; break;
    case 452: // $2098
      var $2099=(($this)|0);
      var $2100=HEAPU8[($2099)];
      var $2101=(($2100)&255);
      var $2102=$2101 & 240;
      var $2103=(($2102)|0)==0;
      if ($2103) { __label__ = 453; break; } else { __label__ = 464; break; }
    case 453: // $2104
      var $2105=$last;
      var $2106=$this;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($2105)>>1)]=HEAP16[(($2106)>>1)];HEAP16[(($2105+2)>>1)]=HEAP16[(($2106+2)>>1)];
      __label__ = 454; break;
    case 454: // $2107
      var $2108=(($last+2)|0);
      var $2109=HEAPU16[(($2108)>>1)];
      var $2110=(($2109)&65535);
      var $2111=$hold;
      var $2112=(($last+1)|0);
      var $2113=HEAPU8[($2112)];
      var $2114=(($2113)&255);
      var $2115=(($last)|0);
      var $2116=HEAPU8[($2115)];
      var $2117=(($2116)&255);
      var $2118=(($2114+$2117)|0);
      var $2119=1 << $2118;
      var $2120=(($2119-1)|0);
      var $2121=$2111 & $2120;
      var $2122=(($last+1)|0);
      var $2123=HEAPU8[($2122)];
      var $2124=(($2123)&255);
      var $2125=$2121 >>> (($2124)>>>0);
      var $2126=(($2110+$2125)|0);
      var $2127=$state;
      var $2128=(($2127+80)|0);
      var $2129=HEAP32[(($2128)>>2)];
      var $2130=(($2129+($2126<<2))|0);
      var $2131=$this;
      var $2132=$2130;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($2131)>>1)]=HEAP16[(($2132)>>1)];HEAP16[(($2131+2)>>1)]=HEAP16[(($2132+2)>>1)];
      var $2133=(($last+1)|0);
      var $2134=HEAPU8[($2133)];
      var $2135=(($2134)&255);
      var $2136=(($this+1)|0);
      var $2137=HEAPU8[($2136)];
      var $2138=(($2137)&255);
      var $2139=(($2135+$2138)|0);
      var $2140=$bits;
      var $2141=(($2139)>>>0) <= (($2140)>>>0);
      if ($2141) { __label__ = 455; break; } else { __label__ = 456; break; }
    case 455: // $2142
      __label__ = 461; break;
    case 456: // $2143
      __label__ = 457; break;
    case 457: // $2144
      var $2145=$have;
      var $2146=(($2145)|0)==0;
      if ($2146) { __label__ = 458; break; } else { __label__ = 459; break; }
    case 458: // $2147
      __label__ = 553; break;
    case 459: // $2148
      var $2149=$have;
      var $2150=(($2149-1)|0);
      $have=$2150;
      var $2151=$next;
      var $2152=(($2151+1)|0);
      $next=$2152;
      var $2153=HEAPU8[($2151)];
      var $2154=(($2153)&255);
      var $2155=$bits;
      var $2156=$2154 << $2155;
      var $2157=$hold;
      var $2158=(($2157+$2156)|0);
      $hold=$2158;
      var $2159=$bits;
      var $2160=(($2159+8)|0);
      $bits=$2160;
      __label__ = 460; break;
    case 460: // $2161
      __label__ = 454; break;
    case 461: // $2162
      __label__ = 462; break;
    case 462: // $2163
      var $2164=(($last+1)|0);
      var $2165=HEAPU8[($2164)];
      var $2166=(($2165)&255);
      var $2167=$hold;
      var $2168=$2167 >>> (($2166)>>>0);
      $hold=$2168;
      var $2169=(($last+1)|0);
      var $2170=HEAPU8[($2169)];
      var $2171=(($2170)&255);
      var $2172=$bits;
      var $2173=(($2172-$2171)|0);
      $bits=$2173;
      __label__ = 463; break;
    case 463: // $2174
      __label__ = 464; break;
    case 464: // $2175
      __label__ = 465; break;
    case 465: // $2176
      var $2177=(($this+1)|0);
      var $2178=HEAPU8[($2177)];
      var $2179=(($2178)&255);
      var $2180=$hold;
      var $2181=$2180 >>> (($2179)>>>0);
      $hold=$2181;
      var $2182=(($this+1)|0);
      var $2183=HEAPU8[($2182)];
      var $2184=(($2183)&255);
      var $2185=$bits;
      var $2186=(($2185-$2184)|0);
      $bits=$2186;
      __label__ = 466; break;
    case 466: // $2187
      var $2188=(($this)|0);
      var $2189=HEAPU8[($2188)];
      var $2190=(($2189)&255);
      var $2191=$2190 & 64;
      var $2192=(($2191)|0)!=0;
      if ($2192) { __label__ = 467; break; } else { __label__ = 468; break; }
    case 467: // $2193
      var $2194=$2;
      var $2195=(($2194+24)|0);
      HEAP32[(($2195)>>2)]=((STRING_TABLE.__str147615)|0);
      var $2196=$state;
      var $2197=(($2196)|0);
      HEAP32[(($2197)>>2)]=27;
      __label__ = 552; break;
    case 468: // $2198
      var $2199=(($this+2)|0);
      var $2200=HEAPU16[(($2199)>>1)];
      var $2201=(($2200)&65535);
      var $2202=$state;
      var $2203=(($2202+68)|0);
      HEAP32[(($2203)>>2)]=$2201;
      var $2204=(($this)|0);
      var $2205=HEAPU8[($2204)];
      var $2206=(($2205)&255);
      var $2207=$2206 & 15;
      var $2208=$state;
      var $2209=(($2208+72)|0);
      HEAP32[(($2209)>>2)]=$2207;
      var $2210=$state;
      var $2211=(($2210)|0);
      HEAP32[(($2211)>>2)]=21;
      __label__ = 469; break;
    case 469: // $2212
      var $2213=$state;
      var $2214=(($2213+72)|0);
      var $2215=HEAP32[(($2214)>>2)];
      var $2216=(($2215)|0)!=0;
      if ($2216) { __label__ = 470; break; } else { __label__ = 482; break; }
    case 470: // $2217
      __label__ = 471; break;
    case 471: // $2218
      __label__ = 472; break;
    case 472: // $2219
      var $2220=$bits;
      var $2221=$state;
      var $2222=(($2221+72)|0);
      var $2223=HEAPU32[(($2222)>>2)];
      var $2224=(($2220)>>>0) < (($2223)>>>0);
      if ($2224) { __label__ = 473; break; } else { __label__ = 478; break; }
    case 473: // $2225
      __label__ = 474; break;
    case 474: // $2226
      var $2227=$have;
      var $2228=(($2227)|0)==0;
      if ($2228) { __label__ = 475; break; } else { __label__ = 476; break; }
    case 475: // $2229
      __label__ = 553; break;
    case 476: // $2230
      var $2231=$have;
      var $2232=(($2231-1)|0);
      $have=$2232;
      var $2233=$next;
      var $2234=(($2233+1)|0);
      $next=$2234;
      var $2235=HEAPU8[($2233)];
      var $2236=(($2235)&255);
      var $2237=$bits;
      var $2238=$2236 << $2237;
      var $2239=$hold;
      var $2240=(($2239+$2238)|0);
      $hold=$2240;
      var $2241=$bits;
      var $2242=(($2241+8)|0);
      $bits=$2242;
      __label__ = 477; break;
    case 477: // $2243
      __label__ = 472; break;
    case 478: // $2244
      __label__ = 479; break;
    case 479: // $2245
      var $2246=$hold;
      var $2247=$state;
      var $2248=(($2247+72)|0);
      var $2249=HEAP32[(($2248)>>2)];
      var $2250=1 << $2249;
      var $2251=(($2250-1)|0);
      var $2252=$2246 & $2251;
      var $2253=$state;
      var $2254=(($2253+68)|0);
      var $2255=HEAP32[(($2254)>>2)];
      var $2256=(($2255+$2252)|0);
      HEAP32[(($2254)>>2)]=$2256;
      __label__ = 480; break;
    case 480: // $2257
      var $2258=$state;
      var $2259=(($2258+72)|0);
      var $2260=HEAPU32[(($2259)>>2)];
      var $2261=$hold;
      var $2262=$2261 >>> (($2260)>>>0);
      $hold=$2262;
      var $2263=$state;
      var $2264=(($2263+72)|0);
      var $2265=HEAP32[(($2264)>>2)];
      var $2266=$bits;
      var $2267=(($2266-$2265)|0);
      $bits=$2267;
      __label__ = 481; break;
    case 481: // $2268
      __label__ = 482; break;
    case 482: // $2269
      var $2270=$state;
      var $2271=(($2270+68)|0);
      var $2272=HEAPU32[(($2271)>>2)];
      var $2273=$state;
      var $2274=(($2273+44)|0);
      var $2275=HEAP32[(($2274)>>2)];
      var $2276=$out;
      var $2277=(($2275+$2276)|0);
      var $2278=$left;
      var $2279=(($2277-$2278)|0);
      var $2280=(($2272)>>>0) > (($2279)>>>0);
      if ($2280) { __label__ = 483; break; } else { __label__ = 484; break; }
    case 483: // $2281
      var $2282=$2;
      var $2283=(($2282+24)|0);
      HEAP32[(($2283)>>2)]=((STRING_TABLE.__str157616)|0);
      var $2284=$state;
      var $2285=(($2284)|0);
      HEAP32[(($2285)>>2)]=27;
      __label__ = 552; break;
    case 484: // $2286
      var $2287=$state;
      var $2288=(($2287)|0);
      HEAP32[(($2288)>>2)]=22;
      __label__ = 485; break;
    case 485: // $2289
      var $2290=$left;
      var $2291=(($2290)|0)==0;
      if ($2291) { __label__ = 486; break; } else { __label__ = 487; break; }
    case 486: // $2292
      __label__ = 553; break;
    case 487: // $2293
      var $2294=$out;
      var $2295=$left;
      var $2296=(($2294-$2295)|0);
      $copy=$2296;
      var $2297=$state;
      var $2298=(($2297+68)|0);
      var $2299=HEAPU32[(($2298)>>2)];
      var $2300=$copy;
      var $2301=(($2299)>>>0) > (($2300)>>>0);
      if ($2301) { __label__ = 488; break; } else { __label__ = 494; break; }
    case 488: // $2302
      var $2303=$state;
      var $2304=(($2303+68)|0);
      var $2305=HEAP32[(($2304)>>2)];
      var $2306=$copy;
      var $2307=(($2305-$2306)|0);
      $copy=$2307;
      var $2308=$copy;
      var $2309=$state;
      var $2310=(($2309+48)|0);
      var $2311=HEAPU32[(($2310)>>2)];
      var $2312=(($2308)>>>0) > (($2311)>>>0);
      if ($2312) { __label__ = 489; break; } else { __label__ = 490; break; }
    case 489: // $2313
      var $2314=$state;
      var $2315=(($2314+48)|0);
      var $2316=HEAP32[(($2315)>>2)];
      var $2317=$copy;
      var $2318=(($2317-$2316)|0);
      $copy=$2318;
      var $2319=$state;
      var $2320=(($2319+52)|0);
      var $2321=HEAP32[(($2320)>>2)];
      var $2322=$state;
      var $2323=(($2322+40)|0);
      var $2324=HEAP32[(($2323)>>2)];
      var $2325=$copy;
      var $2326=(($2324-$2325)|0);
      var $2327=(($2321+$2326)|0);
      $from=$2327;
      __label__ = 491; break;
    case 490: // $2328
      var $2329=$state;
      var $2330=(($2329+52)|0);
      var $2331=HEAP32[(($2330)>>2)];
      var $2332=$state;
      var $2333=(($2332+48)|0);
      var $2334=HEAP32[(($2333)>>2)];
      var $2335=$copy;
      var $2336=(($2334-$2335)|0);
      var $2337=(($2331+$2336)|0);
      $from=$2337;
      __label__ = 491; break;
    case 491: // $2338
      var $2339=$copy;
      var $2340=$state;
      var $2341=(($2340+64)|0);
      var $2342=HEAPU32[(($2341)>>2)];
      var $2343=(($2339)>>>0) > (($2342)>>>0);
      if ($2343) { __label__ = 492; break; } else { __label__ = 493; break; }
    case 492: // $2344
      var $2345=$state;
      var $2346=(($2345+64)|0);
      var $2347=HEAP32[(($2346)>>2)];
      $copy=$2347;
      __label__ = 493; break;
    case 493: // $2348
      __label__ = 495; break;
    case 494: // $2349
      var $2350=$put;
      var $2351=$state;
      var $2352=(($2351+68)|0);
      var $2353=HEAP32[(($2352)>>2)];
      var $2354=(((-$2353))|0);
      var $2355=(($2350+$2354)|0);
      $from=$2355;
      var $2356=$state;
      var $2357=(($2356+64)|0);
      var $2358=HEAP32[(($2357)>>2)];
      $copy=$2358;
      __label__ = 495; break;
    case 495: // $2359
      var $2360=$copy;
      var $2361=$left;
      var $2362=(($2360)>>>0) > (($2361)>>>0);
      if ($2362) { __label__ = 496; break; } else { __label__ = 497; break; }
    case 496: // $2363
      var $2364=$left;
      $copy=$2364;
      __label__ = 497; break;
    case 497: // $2365
      var $2366=$copy;
      var $2367=$left;
      var $2368=(($2367-$2366)|0);
      $left=$2368;
      var $2369=$copy;
      var $2370=$state;
      var $2371=(($2370+64)|0);
      var $2372=HEAP32[(($2371)>>2)];
      var $2373=(($2372-$2369)|0);
      HEAP32[(($2371)>>2)]=$2373;
      __label__ = 498; break;
    case 498: // $2374
      var $2375=$from;
      var $2376=(($2375+1)|0);
      $from=$2376;
      var $2377=HEAP8[($2375)];
      var $2378=$put;
      var $2379=(($2378+1)|0);
      $put=$2379;
      HEAP8[($2378)]=$2377;
      __label__ = 499; break;
    case 499: // $2380
      var $2381=$copy;
      var $2382=(($2381-1)|0);
      $copy=$2382;
      var $2383=(($2382)|0)!=0;
      if ($2383) { __label__ = 498; break; } else { __label__ = 500; break; }
    case 500: // $2384
      var $2385=$state;
      var $2386=(($2385+64)|0);
      var $2387=HEAP32[(($2386)>>2)];
      var $2388=(($2387)|0)==0;
      if ($2388) { __label__ = 501; break; } else { __label__ = 502; break; }
    case 501: // $2389
      var $2390=$state;
      var $2391=(($2390)|0);
      HEAP32[(($2391)>>2)]=18;
      __label__ = 502; break;
    case 502: // $2392
      __label__ = 552; break;
    case 503: // $2393
      var $2394=$left;
      var $2395=(($2394)|0)==0;
      if ($2395) { __label__ = 504; break; } else { __label__ = 505; break; }
    case 504: // $2396
      __label__ = 553; break;
    case 505: // $2397
      var $2398=$state;
      var $2399=(($2398+64)|0);
      var $2400=HEAP32[(($2399)>>2)];
      var $2401=(($2400) & 255);
      var $2402=$put;
      var $2403=(($2402+1)|0);
      $put=$2403;
      HEAP8[($2402)]=$2401;
      var $2404=$left;
      var $2405=(($2404-1)|0);
      $left=$2405;
      var $2406=$state;
      var $2407=(($2406)|0);
      HEAP32[(($2407)>>2)]=18;
      __label__ = 552; break;
    case 506: // $2408
      var $2409=$state;
      var $2410=(($2409+8)|0);
      var $2411=HEAP32[(($2410)>>2)];
      var $2412=(($2411)|0)!=0;
      if ($2412) { __label__ = 507; break; } else { __label__ = 529; break; }
    case 507: // $2413
      __label__ = 508; break;
    case 508: // $2414
      __label__ = 509; break;
    case 509: // $2415
      var $2416=$bits;
      var $2417=(($2416)>>>0) < 32;
      if ($2417) { __label__ = 510; break; } else { __label__ = 515; break; }
    case 510: // $2418
      __label__ = 511; break;
    case 511: // $2419
      var $2420=$have;
      var $2421=(($2420)|0)==0;
      if ($2421) { __label__ = 512; break; } else { __label__ = 513; break; }
    case 512: // $2422
      __label__ = 553; break;
    case 513: // $2423
      var $2424=$have;
      var $2425=(($2424-1)|0);
      $have=$2425;
      var $2426=$next;
      var $2427=(($2426+1)|0);
      $next=$2427;
      var $2428=HEAPU8[($2426)];
      var $2429=(($2428)&255);
      var $2430=$bits;
      var $2431=$2429 << $2430;
      var $2432=$hold;
      var $2433=(($2432+$2431)|0);
      $hold=$2433;
      var $2434=$bits;
      var $2435=(($2434+8)|0);
      $bits=$2435;
      __label__ = 514; break;
    case 514: // $2436
      __label__ = 509; break;
    case 515: // $2437
      __label__ = 516; break;
    case 516: // $2438
      var $2439=$left;
      var $2440=$out;
      var $2441=(($2440-$2439)|0);
      $out=$2441;
      var $2442=$out;
      var $2443=$2;
      var $2444=(($2443+20)|0);
      var $2445=HEAP32[(($2444)>>2)];
      var $2446=(($2445+$2442)|0);
      HEAP32[(($2444)>>2)]=$2446;
      var $2447=$out;
      var $2448=$state;
      var $2449=(($2448+28)|0);
      var $2450=HEAP32[(($2449)>>2)];
      var $2451=(($2450+$2447)|0);
      HEAP32[(($2449)>>2)]=$2451;
      var $2452=$out;
      var $2453=(($2452)|0)!=0;
      if ($2453) { __label__ = 517; break; } else { __label__ = 521; break; }
    case 517: // $2454
      var $2455=$state;
      var $2456=(($2455+16)|0);
      var $2457=HEAP32[(($2456)>>2)];
      var $2458=(($2457)|0)!=0;
      if ($2458) { __label__ = 518; break; } else { __label__ = 519; break; }
    case 518: // $2459
      var $2460=$state;
      var $2461=(($2460+24)|0);
      var $2462=HEAP32[(($2461)>>2)];
      var $2463=$put;
      var $2464=$out;
      var $2465=(((-$2464))|0);
      var $2466=(($2463+$2465)|0);
      var $2467=$out;
      var $2468=_crc32($2462, $2466, $2467);
      var $2480 = $2468;__label__ = 520; break;
    case 519: // $2469
      var $2470=$state;
      var $2471=(($2470+24)|0);
      var $2472=HEAP32[(($2471)>>2)];
      var $2473=$put;
      var $2474=$out;
      var $2475=(((-$2474))|0);
      var $2476=(($2473+$2475)|0);
      var $2477=$out;
      var $2478=_adler32($2472, $2476, $2477);
      var $2480 = $2478;__label__ = 520; break;
    case 520: // $2479
      var $2480;
      var $2481=$state;
      var $2482=(($2481+24)|0);
      HEAP32[(($2482)>>2)]=$2480;
      var $2483=$2;
      var $2484=(($2483+48)|0);
      HEAP32[(($2484)>>2)]=$2480;
      __label__ = 521; break;
    case 521: // $2485
      var $2486=$left;
      $out=$2486;
      var $2487=$state;
      var $2488=(($2487+16)|0);
      var $2489=HEAP32[(($2488)>>2)];
      var $2490=(($2489)|0)!=0;
      if ($2490) { __label__ = 522; break; } else { __label__ = 523; break; }
    case 522: // $2491
      var $2492=$hold;
      var $2510 = $2492;__label__ = 524; break;
    case 523: // $2493
      var $2494=$hold;
      var $2495=$2494 >>> 24;
      var $2496=$2495 & 255;
      var $2497=$hold;
      var $2498=$2497 >>> 8;
      var $2499=$2498 & 65280;
      var $2500=(($2496+$2499)|0);
      var $2501=$hold;
      var $2502=$2501 & 65280;
      var $2503=$2502 << 8;
      var $2504=(($2500+$2503)|0);
      var $2505=$hold;
      var $2506=$2505 & 255;
      var $2507=$2506 << 24;
      var $2508=(($2504+$2507)|0);
      var $2510 = $2508;__label__ = 524; break;
    case 524: // $2509
      var $2510;
      var $2511=$state;
      var $2512=(($2511+24)|0);
      var $2513=HEAP32[(($2512)>>2)];
      var $2514=(($2510)|0)!=(($2513)|0);
      if ($2514) { __label__ = 525; break; } else { __label__ = 526; break; }
    case 525: // $2515
      var $2516=$2;
      var $2517=(($2516+24)|0);
      HEAP32[(($2517)>>2)]=((STRING_TABLE.__str167617)|0);
      var $2518=$state;
      var $2519=(($2518)|0);
      HEAP32[(($2519)>>2)]=27;
      __label__ = 552; break;
    case 526: // $2520
      __label__ = 527; break;
    case 527: // $2521
      $hold=0;
      $bits=0;
      __label__ = 528; break;
    case 528: // $2522
      __label__ = 529; break;
    case 529: // $2523
      var $2524=$state;
      var $2525=(($2524)|0);
      HEAP32[(($2525)>>2)]=25;
      __label__ = 530; break;
    case 530: // $2526
      var $2527=$state;
      var $2528=(($2527+8)|0);
      var $2529=HEAP32[(($2528)>>2)];
      var $2530=(($2529)|0)!=0;
      if ($2530) { __label__ = 531; break; } else { __label__ = 546; break; }
    case 531: // $2531
      var $2532=$state;
      var $2533=(($2532+16)|0);
      var $2534=HEAP32[(($2533)>>2)];
      var $2535=(($2534)|0)!=0;
      if ($2535) { __label__ = 532; break; } else { __label__ = 546; break; }
    case 532: // $2536
      __label__ = 533; break;
    case 533: // $2537
      __label__ = 534; break;
    case 534: // $2538
      var $2539=$bits;
      var $2540=(($2539)>>>0) < 32;
      if ($2540) { __label__ = 535; break; } else { __label__ = 540; break; }
    case 535: // $2541
      __label__ = 536; break;
    case 536: // $2542
      var $2543=$have;
      var $2544=(($2543)|0)==0;
      if ($2544) { __label__ = 537; break; } else { __label__ = 538; break; }
    case 537: // $2545
      __label__ = 553; break;
    case 538: // $2546
      var $2547=$have;
      var $2548=(($2547-1)|0);
      $have=$2548;
      var $2549=$next;
      var $2550=(($2549+1)|0);
      $next=$2550;
      var $2551=HEAPU8[($2549)];
      var $2552=(($2551)&255);
      var $2553=$bits;
      var $2554=$2552 << $2553;
      var $2555=$hold;
      var $2556=(($2555+$2554)|0);
      $hold=$2556;
      var $2557=$bits;
      var $2558=(($2557+8)|0);
      $bits=$2558;
      __label__ = 539; break;
    case 539: // $2559
      __label__ = 534; break;
    case 540: // $2560
      __label__ = 541; break;
    case 541: // $2561
      var $2562=$hold;
      var $2563=$state;
      var $2564=(($2563+28)|0);
      var $2565=HEAP32[(($2564)>>2)];
      var $2566=(($2562)|0)!=(($2565)|0);
      if ($2566) { __label__ = 542; break; } else { __label__ = 543; break; }
    case 542: // $2567
      var $2568=$2;
      var $2569=(($2568+24)|0);
      HEAP32[(($2569)>>2)]=((STRING_TABLE.__str177618)|0);
      var $2570=$state;
      var $2571=(($2570)|0);
      HEAP32[(($2571)>>2)]=27;
      __label__ = 552; break;
    case 543: // $2572
      __label__ = 544; break;
    case 544: // $2573
      $hold=0;
      $bits=0;
      __label__ = 545; break;
    case 545: // $2574
      __label__ = 546; break;
    case 546: // $2575
      var $2576=$state;
      var $2577=(($2576)|0);
      HEAP32[(($2577)>>2)]=26;
      __label__ = 547; break;
    case 547: // $2578
      $ret=1;
      __label__ = 553; break;
    case 548: // $2579
      $ret=-3;
      __label__ = 553; break;
    case 549: // $2580
      $1=-4;
      __label__ = 573; break;
    case 550: // $2581
      __label__ = 551; break;
    case 551: // $2582
      $1=-2;
      __label__ = 573; break;
    case 552: // $2583
      __label__ = 11; break;
    case 553: // $2584
      __label__ = 554; break;
    case 554: // $2585
      var $2586=$put;
      var $2587=$2;
      var $2588=(($2587+12)|0);
      HEAP32[(($2588)>>2)]=$2586;
      var $2589=$left;
      var $2590=$2;
      var $2591=(($2590+16)|0);
      HEAP32[(($2591)>>2)]=$2589;
      var $2592=$next;
      var $2593=$2;
      var $2594=(($2593)|0);
      HEAP32[(($2594)>>2)]=$2592;
      var $2595=$have;
      var $2596=$2;
      var $2597=(($2596+4)|0);
      HEAP32[(($2597)>>2)]=$2595;
      var $2598=$hold;
      var $2599=$state;
      var $2600=(($2599+56)|0);
      HEAP32[(($2600)>>2)]=$2598;
      var $2601=$bits;
      var $2602=$state;
      var $2603=(($2602+60)|0);
      HEAP32[(($2603)>>2)]=$2601;
      __label__ = 555; break;
    case 555: // $2604
      var $2605=$state;
      var $2606=(($2605+40)|0);
      var $2607=HEAP32[(($2606)>>2)];
      var $2608=(($2607)|0)!=0;
      if ($2608) { __label__ = 558; break; } else { __label__ = 556; break; }
    case 556: // $2609
      var $2610=$state;
      var $2611=(($2610)|0);
      var $2612=HEAPU32[(($2611)>>2)];
      var $2613=(($2612)>>>0) < 24;
      if ($2613) { __label__ = 557; break; } else { __label__ = 561; break; }
    case 557: // $2614
      var $2615=$out;
      var $2616=$2;
      var $2617=(($2616+16)|0);
      var $2618=HEAP32[(($2617)>>2)];
      var $2619=(($2615)|0)!=(($2618)|0);
      if ($2619) { __label__ = 558; break; } else { __label__ = 561; break; }
    case 558: // $2620
      var $2621=$2;
      var $2622=$out;
      var $2623=_updatewindow($2621, $2622);
      var $2624=(($2623)|0)!=0;
      if ($2624) { __label__ = 559; break; } else { __label__ = 560; break; }
    case 559: // $2625
      var $2626=$state;
      var $2627=(($2626)|0);
      HEAP32[(($2627)>>2)]=28;
      $1=-4;
      __label__ = 573; break;
    case 560: // $2628
      __label__ = 561; break;
    case 561: // $2629
      var $2630=$2;
      var $2631=(($2630+4)|0);
      var $2632=HEAP32[(($2631)>>2)];
      var $2633=$in;
      var $2634=(($2633-$2632)|0);
      $in=$2634;
      var $2635=$2;
      var $2636=(($2635+16)|0);
      var $2637=HEAP32[(($2636)>>2)];
      var $2638=$out;
      var $2639=(($2638-$2637)|0);
      $out=$2639;
      var $2640=$in;
      var $2641=$2;
      var $2642=(($2641+8)|0);
      var $2643=HEAP32[(($2642)>>2)];
      var $2644=(($2643+$2640)|0);
      HEAP32[(($2642)>>2)]=$2644;
      var $2645=$out;
      var $2646=$2;
      var $2647=(($2646+20)|0);
      var $2648=HEAP32[(($2647)>>2)];
      var $2649=(($2648+$2645)|0);
      HEAP32[(($2647)>>2)]=$2649;
      var $2650=$out;
      var $2651=$state;
      var $2652=(($2651+28)|0);
      var $2653=HEAP32[(($2652)>>2)];
      var $2654=(($2653+$2650)|0);
      HEAP32[(($2652)>>2)]=$2654;
      var $2655=$state;
      var $2656=(($2655+8)|0);
      var $2657=HEAP32[(($2656)>>2)];
      var $2658=(($2657)|0)!=0;
      if ($2658) { __label__ = 562; break; } else { __label__ = 567; break; }
    case 562: // $2659
      var $2660=$out;
      var $2661=(($2660)|0)!=0;
      if ($2661) { __label__ = 563; break; } else { __label__ = 567; break; }
    case 563: // $2662
      var $2663=$state;
      var $2664=(($2663+16)|0);
      var $2665=HEAP32[(($2664)>>2)];
      var $2666=(($2665)|0)!=0;
      if ($2666) { __label__ = 564; break; } else { __label__ = 565; break; }
    case 564: // $2667
      var $2668=$state;
      var $2669=(($2668+24)|0);
      var $2670=HEAP32[(($2669)>>2)];
      var $2671=$2;
      var $2672=(($2671+12)|0);
      var $2673=HEAP32[(($2672)>>2)];
      var $2674=$out;
      var $2675=(((-$2674))|0);
      var $2676=(($2673+$2675)|0);
      var $2677=$out;
      var $2678=_crc32($2670, $2676, $2677);
      var $2692 = $2678;__label__ = 566; break;
    case 565: // $2679
      var $2680=$state;
      var $2681=(($2680+24)|0);
      var $2682=HEAP32[(($2681)>>2)];
      var $2683=$2;
      var $2684=(($2683+12)|0);
      var $2685=HEAP32[(($2684)>>2)];
      var $2686=$out;
      var $2687=(((-$2686))|0);
      var $2688=(($2685+$2687)|0);
      var $2689=$out;
      var $2690=_adler32($2682, $2688, $2689);
      var $2692 = $2690;__label__ = 566; break;
    case 566: // $2691
      var $2692;
      var $2693=$state;
      var $2694=(($2693+24)|0);
      HEAP32[(($2694)>>2)]=$2692;
      var $2695=$2;
      var $2696=(($2695+48)|0);
      HEAP32[(($2696)>>2)]=$2692;
      __label__ = 567; break;
    case 567: // $2697
      var $2698=$state;
      var $2699=(($2698+60)|0);
      var $2700=HEAP32[(($2699)>>2)];
      var $2701=$state;
      var $2702=(($2701+4)|0);
      var $2703=HEAP32[(($2702)>>2)];
      var $2704=(($2703)|0)!=0;
      var $2705=$2704 ? 64 : 0;
      var $2706=(($2700+$2705)|0);
      var $2707=$state;
      var $2708=(($2707)|0);
      var $2709=HEAP32[(($2708)>>2)];
      var $2710=(($2709)|0)==11;
      var $2711=$2710 ? 128 : 0;
      var $2712=(($2706+$2711)|0);
      var $2713=$2;
      var $2714=(($2713+44)|0);
      HEAP32[(($2714)>>2)]=$2712;
      var $2715=$in;
      var $2716=(($2715)|0)==0;
      if ($2716) { __label__ = 568; break; } else { __label__ = 569; break; }
    case 568: // $2717
      var $2718=$out;
      var $2719=(($2718)|0)==0;
      if ($2719) { __label__ = 570; break; } else { __label__ = 569; break; }
    case 569: // $2720
      var $2721=$3;
      var $2722=(($2721)|0)==4;
      if ($2722) { __label__ = 570; break; } else { __label__ = 572; break; }
    case 570: // $2723
      var $2724=$ret;
      var $2725=(($2724)|0)==0;
      if ($2725) { __label__ = 571; break; } else { __label__ = 572; break; }
    case 571: // $2726
      $ret=-5;
      __label__ = 572; break;
    case 572: // $2727
      var $2728=$ret;
      $1=$2728;
      __label__ = 573; break;
    case 573: // $2729
      var $2730=$1;
      STACKTOP = __stackBase__;
      return $2730;
    default: assert(0, "bad label: " + __label__);
  }
}
_inflate["X"]=1;

function _fixedtables($state) {
  ;
  var __label__;

  var $1;
  $1=$state;
  var $2=$1;
  var $3=(($2+76)|0);
  HEAP32[(($3)>>2)]=((_fixedtables_lenfix)|0);
  var $4=$1;
  var $5=(($4+84)|0);
  HEAP32[(($5)>>2)]=9;
  var $6=$1;
  var $7=(($6+80)|0);
  HEAP32[(($7)>>2)]=((_fixedtables_distfix)|0);
  var $8=$1;
  var $9=(($8+88)|0);
  HEAP32[(($9)>>2)]=5;
  ;
  return;
}


function _updatewindow($strm, $out) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $state;
      var $copy;
      var $dist;
      $2=$strm;
      $3=$out;
      var $4=$2;
      var $5=(($4+28)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$6;
      $state=$7;
      var $8=$state;
      var $9=(($8+52)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $12
      var $13=$2;
      var $14=(($13+32)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      var $17=(($16+40)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$state;
      var $20=(($19+36)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=1 << $21;
      var $23=FUNCTION_TABLE[$15]($18, $22, 1);
      var $24=$state;
      var $25=(($24+52)|0);
      HEAP32[(($25)>>2)]=$23;
      var $26=$state;
      var $27=(($26+52)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $30
      $1=1;
      __label__ = 19; break;
    case 3: // $31
      __label__ = 4; break;
    case 4: // $32
      var $33=$state;
      var $34=(($33+40)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $37
      var $38=$state;
      var $39=(($38+36)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=1 << $40;
      var $42=$state;
      var $43=(($42+40)|0);
      HEAP32[(($43)>>2)]=$41;
      var $44=$state;
      var $45=(($44+48)|0);
      HEAP32[(($45)>>2)]=0;
      var $46=$state;
      var $47=(($46+44)|0);
      HEAP32[(($47)>>2)]=0;
      __label__ = 6; break;
    case 6: // $48
      var $49=$3;
      var $50=$2;
      var $51=(($50+16)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($49-$52)|0);
      $copy=$53;
      var $54=$copy;
      var $55=$state;
      var $56=(($55+40)|0);
      var $57=HEAPU32[(($56)>>2)];
      var $58=(($54)>>>0) >= (($57)>>>0);
      if ($58) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $59
      var $60=$state;
      var $61=(($60+52)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$2;
      var $64=(($63+12)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$state;
      var $67=(($66+40)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(((-$68))|0);
      var $70=(($65+$69)|0);
      var $71=$state;
      var $72=(($71+40)|0);
      var $73=HEAP32[(($72)>>2)];
      assert($73 % 1 === 0, 'memcpy given ' + $73 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($62, $70, $73, 1);
      var $74=$state;
      var $75=(($74+48)|0);
      HEAP32[(($75)>>2)]=0;
      var $76=$state;
      var $77=(($76+40)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$state;
      var $80=(($79+44)|0);
      HEAP32[(($80)>>2)]=$78;
      __label__ = 18; break;
    case 8: // $81
      var $82=$state;
      var $83=(($82+40)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=$state;
      var $86=(($85+48)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($84-$87)|0);
      $dist=$88;
      var $89=$dist;
      var $90=$copy;
      var $91=(($89)>>>0) > (($90)>>>0);
      if ($91) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $92
      var $93=$copy;
      $dist=$93;
      __label__ = 10; break;
    case 10: // $94
      var $95=$state;
      var $96=(($95+52)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$state;
      var $99=(($98+48)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($97+$100)|0);
      var $102=$2;
      var $103=(($102+12)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=$copy;
      var $106=(((-$105))|0);
      var $107=(($104+$106)|0);
      var $108=$dist;
      assert($108 % 1 === 0, 'memcpy given ' + $108 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($101, $107, $108, 1);
      var $109=$dist;
      var $110=$copy;
      var $111=(($110-$109)|0);
      $copy=$111;
      var $112=$copy;
      var $113=(($112)|0)!=0;
      if ($113) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $114
      var $115=$state;
      var $116=(($115+52)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$2;
      var $119=(($118+12)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$copy;
      var $122=(((-$121))|0);
      var $123=(($120+$122)|0);
      var $124=$copy;
      assert($124 % 1 === 0, 'memcpy given ' + $124 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($117, $123, $124, 1);
      var $125=$copy;
      var $126=$state;
      var $127=(($126+48)|0);
      HEAP32[(($127)>>2)]=$125;
      var $128=$state;
      var $129=(($128+40)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$state;
      var $132=(($131+44)|0);
      HEAP32[(($132)>>2)]=$130;
      __label__ = 17; break;
    case 12: // $133
      var $134=$dist;
      var $135=$state;
      var $136=(($135+48)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+$134)|0);
      HEAP32[(($136)>>2)]=$138;
      var $139=$state;
      var $140=(($139+48)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$state;
      var $143=(($142+40)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($141)|0)==(($144)|0);
      if ($145) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $146
      var $147=$state;
      var $148=(($147+48)|0);
      HEAP32[(($148)>>2)]=0;
      __label__ = 14; break;
    case 14: // $149
      var $150=$state;
      var $151=(($150+44)|0);
      var $152=HEAPU32[(($151)>>2)];
      var $153=$state;
      var $154=(($153+40)|0);
      var $155=HEAPU32[(($154)>>2)];
      var $156=(($152)>>>0) < (($155)>>>0);
      if ($156) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $157
      var $158=$dist;
      var $159=$state;
      var $160=(($159+44)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+$158)|0);
      HEAP32[(($160)>>2)]=$162;
      __label__ = 16; break;
    case 16: // $163
      __label__ = 17; break;
    case 17: // $164
      __label__ = 18; break;
    case 18: // $165
      $1=0;
      __label__ = 19; break;
    case 19: // $166
      var $167=$1;
      ;
      return $167;
    default: assert(0, "bad label: " + __label__);
  }
}
_updatewindow["X"]=1;

function _inflateEnd($strm) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $state;
      $2=$strm;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$2;
      var $12=(($11+36)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      $1=-2;
      __label__ = 7; break;
    case 4: // $16
      var $17=$2;
      var $18=(($17+28)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$19;
      $state=$20;
      var $21=$state;
      var $22=(($21+52)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23)|0)!=0;
      if ($24) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $25
      var $26=$2;
      var $27=(($26+36)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=(($29+40)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$state;
      var $33=(($32+52)|0);
      var $34=HEAP32[(($33)>>2)];
      FUNCTION_TABLE[$28]($31, $34);
      __label__ = 6; break;
    case 6: // $35
      var $36=$2;
      var $37=(($36+36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=$2;
      var $40=(($39+40)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$2;
      var $43=(($42+28)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=$44;
      FUNCTION_TABLE[$38]($41, $45);
      var $46=$2;
      var $47=(($46+28)|0);
      HEAP32[(($47)>>2)]=0;
      $1=0;
      __label__ = 7; break;
    case 7: // $48
      var $49=$1;
      ;
      return $49;
    default: assert(0, "bad label: " + __label__);
  }
}
_inflateEnd["X"]=1;

function _deflateInit_($strm, $level, $version, $stream_size) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$strm;
  $2=$level;
  $3=$version;
  $4=$stream_size;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  var $9=_deflateInit2_($5, $6, 8, 15, 8, 0, $7, $8);
  ;
  return $9;
}


function _deflateInit2_($strm, $level, $method, $windowBits, $memLevel, $strategy, $version, $stream_size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $s;
      var $wrap;
      var $overlay;
      $2=$strm;
      $3=$level;
      $4=$method;
      $5=$windowBits;
      $6=$memLevel;
      $7=$strategy;
      $8=$version;
      $9=$stream_size;
      $wrap=1;
      var $10=$8;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $12
      var $13=$8;
      var $14=(($13)|0);
      var $15=HEAP8[($14)];
      var $16=(($15 << 24) >> 24);
      var $17=HEAP8[(((STRING_TABLE._deflateInit2__my_version)|0))];
      var $18=(($17 << 24) >> 24);
      var $19=(($16)|0)!=(($18)|0);
      if ($19) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $20
      var $21=$9;
      var $22=(($21)|0)!=56;
      if ($22) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $23
      $1=-6;
      __label__ = 37; break;
    case 4: // $24
      var $25=$2;
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $27
      $1=-2;
      __label__ = 37; break;
    case 6: // $28
      var $29=$2;
      var $30=(($29+24)|0);
      HEAP32[(($30)>>2)]=0;
      var $31=$2;
      var $32=(($31+32)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33)|0)==0;
      if ($34) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $35
      var $36=$2;
      var $37=(($36+32)|0);
      HEAP32[(($37)>>2)]=1652;
      var $38=$2;
      var $39=(($38+40)|0);
      HEAP32[(($39)>>2)]=0;
      __label__ = 8; break;
    case 8: // $40
      var $41=$2;
      var $42=(($41+36)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)==0;
      if ($44) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $45
      var $46=$2;
      var $47=(($46+36)|0);
      HEAP32[(($47)>>2)]=1654;
      __label__ = 10; break;
    case 10: // $48
      var $49=$3;
      var $50=(($49)|0)==-1;
      if ($50) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $51
      $3=6;
      __label__ = 12; break;
    case 12: // $52
      var $53=$5;
      var $54=(($53)|0) < 0;
      if ($54) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $55
      $wrap=0;
      var $56=$5;
      var $57=(((-$56))|0);
      $5=$57;
      __label__ = 17; break;
    case 14: // $58
      var $59=$5;
      var $60=(($59)|0) > 15;
      if ($60) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $61
      $wrap=2;
      var $62=$5;
      var $63=(($62-16)|0);
      $5=$63;
      __label__ = 16; break;
    case 16: // $64
      __label__ = 17; break;
    case 17: // $65
      var $66=$6;
      var $67=(($66)|0) < 1;
      if ($67) { __label__ = 26; break; } else { __label__ = 18; break; }
    case 18: // $68
      var $69=$6;
      var $70=(($69)|0) > 9;
      if ($70) { __label__ = 26; break; } else { __label__ = 19; break; }
    case 19: // $71
      var $72=$4;
      var $73=(($72)|0)!=8;
      if ($73) { __label__ = 26; break; } else { __label__ = 20; break; }
    case 20: // $74
      var $75=$5;
      var $76=(($75)|0) < 8;
      if ($76) { __label__ = 26; break; } else { __label__ = 21; break; }
    case 21: // $77
      var $78=$5;
      var $79=(($78)|0) > 15;
      if ($79) { __label__ = 26; break; } else { __label__ = 22; break; }
    case 22: // $80
      var $81=$3;
      var $82=(($81)|0) < 0;
      if ($82) { __label__ = 26; break; } else { __label__ = 23; break; }
    case 23: // $83
      var $84=$3;
      var $85=(($84)|0) > 9;
      if ($85) { __label__ = 26; break; } else { __label__ = 24; break; }
    case 24: // $86
      var $87=$7;
      var $88=(($87)|0) < 0;
      if ($88) { __label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $89
      var $90=$7;
      var $91=(($90)|0) > 4;
      if ($91) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $92
      $1=-2;
      __label__ = 37; break;
    case 27: // $93
      var $94=$5;
      var $95=(($94)|0)==8;
      if ($95) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $96
      $5=9;
      __label__ = 29; break;
    case 29: // $97
      var $98=$2;
      var $99=(($98+32)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$2;
      var $102=(($101+40)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=FUNCTION_TABLE[$100]($103, 1, 5824);
      var $105=$104;
      $s=$105;
      var $106=$s;
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $108
      $1=-4;
      __label__ = 37; break;
    case 31: // $109
      var $110=$s;
      var $111=$2;
      var $112=(($111+28)|0);
      HEAP32[(($112)>>2)]=$110;
      var $113=$2;
      var $114=$s;
      var $115=(($114)|0);
      HEAP32[(($115)>>2)]=$113;
      var $116=$wrap;
      var $117=$s;
      var $118=(($117+24)|0);
      HEAP32[(($118)>>2)]=$116;
      var $119=$s;
      var $120=(($119+28)|0);
      HEAP32[(($120)>>2)]=0;
      var $121=$5;
      var $122=$s;
      var $123=(($122+48)|0);
      HEAP32[(($123)>>2)]=$121;
      var $124=$s;
      var $125=(($124+48)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=1 << $126;
      var $128=$s;
      var $129=(($128+44)|0);
      HEAP32[(($129)>>2)]=$127;
      var $130=$s;
      var $131=(($130+44)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132-1)|0);
      var $134=$s;
      var $135=(($134+52)|0);
      HEAP32[(($135)>>2)]=$133;
      var $136=$6;
      var $137=(($136+7)|0);
      var $138=$s;
      var $139=(($138+80)|0);
      HEAP32[(($139)>>2)]=$137;
      var $140=$s;
      var $141=(($140+80)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=1 << $142;
      var $144=$s;
      var $145=(($144+76)|0);
      HEAP32[(($145)>>2)]=$143;
      var $146=$s;
      var $147=(($146+76)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148-1)|0);
      var $150=$s;
      var $151=(($150+84)|0);
      HEAP32[(($151)>>2)]=$149;
      var $152=$s;
      var $153=(($152+80)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=(($154+3)|0);
      var $156=(($155-1)|0);
      var $157=Math.floor((($156)>>>0)/3);
      var $158=$s;
      var $159=(($158+88)|0);
      HEAP32[(($159)>>2)]=$157;
      var $160=$2;
      var $161=(($160+32)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$2;
      var $164=(($163+40)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=$s;
      var $167=(($166+44)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=FUNCTION_TABLE[$162]($165, $168, 2);
      var $170=$s;
      var $171=(($170+56)|0);
      HEAP32[(($171)>>2)]=$169;
      var $172=$2;
      var $173=(($172+32)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$2;
      var $176=(($175+40)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=$s;
      var $179=(($178+44)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=FUNCTION_TABLE[$174]($177, $180, 2);
      var $182=$181;
      var $183=$s;
      var $184=(($183+64)|0);
      HEAP32[(($184)>>2)]=$182;
      var $185=$2;
      var $186=(($185+32)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=$2;
      var $189=(($188+40)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$s;
      var $192=(($191+76)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=FUNCTION_TABLE[$187]($190, $193, 2);
      var $195=$194;
      var $196=$s;
      var $197=(($196+68)|0);
      HEAP32[(($197)>>2)]=$195;
      var $198=$6;
      var $199=(($198+6)|0);
      var $200=1 << $199;
      var $201=$s;
      var $202=(($201+5788)|0);
      HEAP32[(($202)>>2)]=$200;
      var $203=$2;
      var $204=(($203+32)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=$2;
      var $207=(($206+40)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=$s;
      var $210=(($209+5788)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=FUNCTION_TABLE[$205]($208, $211, 4);
      var $213=$212;
      $overlay=$213;
      var $214=$overlay;
      var $215=$214;
      var $216=$s;
      var $217=(($216+8)|0);
      HEAP32[(($217)>>2)]=$215;
      var $218=$s;
      var $219=(($218+5788)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=((($220<<2))|0);
      var $222=$s;
      var $223=(($222+12)|0);
      HEAP32[(($223)>>2)]=$221;
      var $224=$s;
      var $225=(($224+56)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=(($226)|0)==0;
      if ($227) { __label__ = 35; break; } else { __label__ = 32; break; }
    case 32: // $228
      var $229=$s;
      var $230=(($229+64)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231)|0)==0;
      if ($232) { __label__ = 35; break; } else { __label__ = 33; break; }
    case 33: // $233
      var $234=$s;
      var $235=(($234+68)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=(($236)|0)==0;
      if ($237) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $238
      var $239=$s;
      var $240=(($239+8)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241)|0)==0;
      if ($242) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $243
      var $244=$s;
      var $245=(($244+4)|0);
      HEAP32[(($245)>>2)]=666;
      var $246=HEAP32[((((_z_errmsg+24)|0))>>2)];
      var $247=$2;
      var $248=(($247+24)|0);
      HEAP32[(($248)>>2)]=$246;
      var $249=$2;
      var $250=_deflateEnd($249);
      $1=-4;
      __label__ = 37; break;
    case 36: // $251
      var $252=$overlay;
      var $253=$s;
      var $254=(($253+5788)|0);
      var $255=HEAPU32[(($254)>>2)];
      var $256=Math.floor((($255)>>>0)/2);
      var $257=(($252+($256<<1))|0);
      var $258=$s;
      var $259=(($258+5796)|0);
      HEAP32[(($259)>>2)]=$257;
      var $260=$s;
      var $261=(($260+8)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$s;
      var $264=(($263+5788)|0);
      var $265=HEAP32[(($264)>>2)];
      var $266=(($265*3)|0);
      var $267=(($262+$266)|0);
      var $268=$s;
      var $269=(($268+5784)|0);
      HEAP32[(($269)>>2)]=$267;
      var $270=$3;
      var $271=$s;
      var $272=(($271+132)|0);
      HEAP32[(($272)>>2)]=$270;
      var $273=$7;
      var $274=$s;
      var $275=(($274+136)|0);
      HEAP32[(($275)>>2)]=$273;
      var $276=$4;
      var $277=(($276) & 255);
      var $278=$s;
      var $279=(($278+36)|0);
      HEAP8[($279)]=$277;
      var $280=$2;
      var $281=_deflateReset($280);
      $1=$281;
      __label__ = 37; break;
    case 37: // $282
      var $283=$1;
      ;
      return $283;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflateInit2_["X"]=1;

function _deflateEnd($strm) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $status;
      $2=$strm;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $10
      $1=-2;
      __label__ = 20; break;
    case 3: // $11
      var $12=$2;
      var $13=(($12+28)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+4)|0);
      var $16=HEAP32[(($15)>>2)];
      $status=$16;
      var $17=$status;
      var $18=(($17)|0)!=42;
      if ($18) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $19
      var $20=$status;
      var $21=(($20)|0)!=69;
      if ($21) { __label__ = 5; break; } else { __label__ = 11; break; }
    case 5: // $22
      var $23=$status;
      var $24=(($23)|0)!=73;
      if ($24) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $25
      var $26=$status;
      var $27=(($26)|0)!=91;
      if ($27) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $28
      var $29=$status;
      var $30=(($29)|0)!=103;
      if ($30) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $31
      var $32=$status;
      var $33=(($32)|0)!=113;
      if ($33) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $34
      var $35=$status;
      var $36=(($35)|0)!=666;
      if ($36) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $37
      $1=-2;
      __label__ = 20; break;
    case 11: // $38
      var $39=$2;
      var $40=(($39+28)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+8)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $45
      var $46=$2;
      var $47=(($46+36)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$2;
      var $50=(($49+40)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$2;
      var $53=(($52+28)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      FUNCTION_TABLE[$48]($51, $56);
      __label__ = 13; break;
    case 13: // $57
      var $58=$2;
      var $59=(($58+28)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+68)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62)|0)!=0;
      if ($63) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $64
      var $65=$2;
      var $66=(($65+36)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=$2;
      var $69=(($68+40)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$2;
      var $72=(($71+28)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+68)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$75;
      FUNCTION_TABLE[$67]($70, $76);
      __label__ = 15; break;
    case 15: // $77
      var $78=$2;
      var $79=(($78+28)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+64)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $84
      var $85=$2;
      var $86=(($85+36)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$2;
      var $89=(($88+40)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$2;
      var $92=(($91+28)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+64)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$95;
      FUNCTION_TABLE[$87]($90, $96);
      __label__ = 17; break;
    case 17: // $97
      var $98=$2;
      var $99=(($98+28)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=(($100+56)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102)|0)!=0;
      if ($103) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $104
      var $105=$2;
      var $106=(($105+36)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=$2;
      var $109=(($108+40)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$2;
      var $112=(($111+28)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+56)|0);
      var $115=HEAP32[(($114)>>2)];
      FUNCTION_TABLE[$107]($110, $115);
      __label__ = 19; break;
    case 19: // $116
      var $117=$2;
      var $118=(($117+36)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$2;
      var $121=(($120+40)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$2;
      var $124=(($123+28)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$125;
      FUNCTION_TABLE[$119]($122, $126);
      var $127=$2;
      var $128=(($127+28)|0);
      HEAP32[(($128)>>2)]=0;
      var $129=$status;
      var $130=(($129)|0)==113;
      var $131=$130 ? -3 : 0;
      $1=$131;
      __label__ = 20; break;
    case 20: // $132
      var $133=$1;
      ;
      return $133;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflateEnd["X"]=1;

function _deflateReset($strm) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $s;
      $2=$strm;
      var $3=$2;
      var $4=(($3)|0)==0;
      if ($4) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$2;
      var $7=(($6+28)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $10
      var $11=$2;
      var $12=(($11+32)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $15
      var $16=$2;
      var $17=(($16+36)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=(($18)|0)==0;
      if ($19) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $20
      $1=-2;
      __label__ = 11; break;
    case 5: // $21
      var $22=$2;
      var $23=(($22+20)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=$2;
      var $25=(($24+8)|0);
      HEAP32[(($25)>>2)]=0;
      var $26=$2;
      var $27=(($26+24)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=$2;
      var $29=(($28+44)|0);
      HEAP32[(($29)>>2)]=2;
      var $30=$2;
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      $s=$32;
      var $33=$s;
      var $34=(($33+20)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=$s;
      var $36=(($35+8)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$s;
      var $39=(($38+16)|0);
      HEAP32[(($39)>>2)]=$37;
      var $40=$s;
      var $41=(($40+24)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0) < 0;
      if ($43) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $44
      var $45=$s;
      var $46=(($45+24)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(((-$47))|0);
      var $49=$s;
      var $50=(($49+24)|0);
      HEAP32[(($50)>>2)]=$48;
      __label__ = 7; break;
    case 7: // $51
      var $52=$s;
      var $53=(($52+24)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54)|0)!=0;
      var $56=$55 ? 42 : 113;
      var $57=$s;
      var $58=(($57+4)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=$s;
      var $60=(($59+24)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==2;
      if ($62) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $63
      var $64=_crc32(0, 0, 0);
      var $68 = $64;__label__ = 10; break;
    case 9: // $65
      var $66=_adler32(0, 0, 0);
      var $68 = $66;__label__ = 10; break;
    case 10: // $67
      var $68;
      var $69=$2;
      var $70=(($69+48)|0);
      HEAP32[(($70)>>2)]=$68;
      var $71=$s;
      var $72=(($71+40)|0);
      HEAP32[(($72)>>2)]=0;
      var $73=$s;
      __tr_init($73);
      var $74=$s;
      _lm_init($74);
      $1=0;
      __label__ = 11; break;
    case 11: // $75
      var $76=$1;
      ;
      return $76;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflateReset["X"]=1;

function _lm_init($s) {
  ;
  var __label__;

  var $1;
  $1=$s;
  var $2=$1;
  var $3=(($2+44)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=((($4<<1))|0);
  var $6=$1;
  var $7=(($6+60)|0);
  HEAP32[(($7)>>2)]=$5;
  var $8=$1;
  var $9=(($8+76)|0);
  var $10=HEAP32[(($9)>>2)];
  var $11=(($10-1)|0);
  var $12=$1;
  var $13=(($12+68)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=(($14+($11<<1))|0);
  HEAP16[(($15)>>1)]=0;
  var $16=$1;
  var $17=(($16+68)|0);
  var $18=HEAP32[(($17)>>2)];
  var $19=$18;
  var $20=$1;
  var $21=(($20+76)|0);
  var $22=HEAP32[(($21)>>2)];
  var $23=(($22-1)|0);
  var $24=((($23<<1))|0);
  _memset($19, 0, $24, 1);
  var $25=$1;
  var $26=(($25+132)|0);
  var $27=HEAP32[(($26)>>2)];
  var $28=((_configuration_table+$27*12)|0);
  var $29=(($28+2)|0);
  var $30=HEAPU16[(($29)>>1)];
  var $31=(($30)&65535);
  var $32=$1;
  var $33=(($32+128)|0);
  HEAP32[(($33)>>2)]=$31;
  var $34=$1;
  var $35=(($34+132)|0);
  var $36=HEAP32[(($35)>>2)];
  var $37=((_configuration_table+$36*12)|0);
  var $38=(($37)|0);
  var $39=HEAPU16[(($38)>>1)];
  var $40=(($39)&65535);
  var $41=$1;
  var $42=(($41+140)|0);
  HEAP32[(($42)>>2)]=$40;
  var $43=$1;
  var $44=(($43+132)|0);
  var $45=HEAP32[(($44)>>2)];
  var $46=((_configuration_table+$45*12)|0);
  var $47=(($46+4)|0);
  var $48=HEAPU16[(($47)>>1)];
  var $49=(($48)&65535);
  var $50=$1;
  var $51=(($50+144)|0);
  HEAP32[(($51)>>2)]=$49;
  var $52=$1;
  var $53=(($52+132)|0);
  var $54=HEAP32[(($53)>>2)];
  var $55=((_configuration_table+$54*12)|0);
  var $56=(($55+6)|0);
  var $57=HEAPU16[(($56)>>1)];
  var $58=(($57)&65535);
  var $59=$1;
  var $60=(($59+124)|0);
  HEAP32[(($60)>>2)]=$58;
  var $61=$1;
  var $62=(($61+108)|0);
  HEAP32[(($62)>>2)]=0;
  var $63=$1;
  var $64=(($63+92)|0);
  HEAP32[(($64)>>2)]=0;
  var $65=$1;
  var $66=(($65+116)|0);
  HEAP32[(($66)>>2)]=0;
  var $67=$1;
  var $68=(($67+120)|0);
  HEAP32[(($68)>>2)]=2;
  var $69=$1;
  var $70=(($69+96)|0);
  HEAP32[(($70)>>2)]=2;
  var $71=$1;
  var $72=(($71+104)|0);
  HEAP32[(($72)>>2)]=0;
  var $73=$1;
  var $74=(($73+72)|0);
  HEAP32[(($74)>>2)]=0;
  ;
  return;
}
_lm_init["X"]=1;

function _deflate($strm, $flush) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $old_flush;
      var $s;
      var $header;
      var $level_flags;
      var $beg;
      var $beg1;
      var $val;
      var $beg2;
      var $val3;
      var $bstate;
      $2=$strm;
      $3=$flush;
      var $4=$2;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=$2;
      var $8=(($7+28)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==0;
      if ($10) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $11
      var $12=$3;
      var $13=(($12)|0) > 4;
      if ($13) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $14
      var $15=$3;
      var $16=(($15)|0) < 0;
      if ($16) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $17
      $1=-2;
      __label__ = 162; break;
    case 5: // $18
      var $19=$2;
      var $20=(($19+28)|0);
      var $21=HEAP32[(($20)>>2)];
      $s=$21;
      var $22=$2;
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24)|0)==0;
      if ($25) { __label__ = 10; break; } else { __label__ = 6; break; }
    case 6: // $26
      var $27=$2;
      var $28=(($27)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29)|0)==0;
      if ($30) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $31
      var $32=$2;
      var $33=(($32+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)!=0;
      if ($35) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $36
      var $37=$s;
      var $38=(($37+4)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39)|0)==666;
      if ($40) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $41
      var $42=$3;
      var $43=(($42)|0)!=4;
      if ($43) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $44
      var $45=HEAP32[((((_z_errmsg+16)|0))>>2)];
      var $46=$2;
      var $47=(($46+24)|0);
      HEAP32[(($47)>>2)]=$45;
      $1=-2;
      __label__ = 162; break;
    case 11: // $48
      var $49=$2;
      var $50=(($49+16)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)==0;
      if ($52) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $53
      var $54=HEAP32[((((_z_errmsg+28)|0))>>2)];
      var $55=$2;
      var $56=(($55+24)|0);
      HEAP32[(($56)>>2)]=$54;
      $1=-5;
      __label__ = 162; break;
    case 13: // $57
      var $58=$2;
      var $59=$s;
      var $60=(($59)|0);
      HEAP32[(($60)>>2)]=$58;
      var $61=$s;
      var $62=(($61+40)|0);
      var $63=HEAP32[(($62)>>2)];
      $old_flush=$63;
      var $64=$3;
      var $65=$s;
      var $66=(($65+40)|0);
      HEAP32[(($66)>>2)]=$64;
      var $67=$s;
      var $68=(($67+4)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)==42;
      if ($70) { __label__ = 14; break; } else { __label__ = 49; break; }
    case 14: // $71
      var $72=$s;
      var $73=(($72+24)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)==2;
      if ($75) { __label__ = 15; break; } else { __label__ = 33; break; }
    case 15: // $76
      var $77=_crc32(0, 0, 0);
      var $78=$2;
      var $79=(($78+48)|0);
      HEAP32[(($79)>>2)]=$77;
      var $80=$s;
      var $81=(($80+20)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($82+1)|0);
      HEAP32[(($81)>>2)]=$83;
      var $84=$s;
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+$82)|0);
      HEAP8[($87)]=31;
      var $88=$s;
      var $89=(($88+20)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+1)|0);
      HEAP32[(($89)>>2)]=$91;
      var $92=$s;
      var $93=(($92+8)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94+$90)|0);
      HEAP8[($95)]=-117;
      var $96=$s;
      var $97=(($96+20)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+1)|0);
      HEAP32[(($97)>>2)]=$99;
      var $100=$s;
      var $101=(($100+8)|0);
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+$98)|0);
      HEAP8[($103)]=8;
      var $104=$s;
      var $105=(($104+28)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106)|0)==0;
      if ($107) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $108
      var $109=$s;
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+1)|0);
      HEAP32[(($110)>>2)]=$112;
      var $113=$s;
      var $114=(($113+8)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115+$111)|0);
      HEAP8[($116)]=0;
      var $117=$s;
      var $118=(($117+20)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+1)|0);
      HEAP32[(($118)>>2)]=$120;
      var $121=$s;
      var $122=(($121+8)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123+$119)|0);
      HEAP8[($124)]=0;
      var $125=$s;
      var $126=(($125+20)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+1)|0);
      HEAP32[(($126)>>2)]=$128;
      var $129=$s;
      var $130=(($129+8)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($131+$127)|0);
      HEAP8[($132)]=0;
      var $133=$s;
      var $134=(($133+20)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+1)|0);
      HEAP32[(($134)>>2)]=$136;
      var $137=$s;
      var $138=(($137+8)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=(($139+$135)|0);
      HEAP8[($140)]=0;
      var $141=$s;
      var $142=(($141+20)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143+1)|0);
      HEAP32[(($142)>>2)]=$144;
      var $145=$s;
      var $146=(($145+8)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+$143)|0);
      HEAP8[($148)]=0;
      var $149=$s;
      var $150=(($149+132)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151)|0)==9;
      if ($152) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $153
      var $168 = 2;__label__ = 21; break;
    case 18: // $154
      var $155=$s;
      var $156=(($155+136)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157)|0) >= 2;
      if ($158) { var $165 = 1;__label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $159
      var $160=$s;
      var $161=(($160+132)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162)|0) < 2;
      var $165 = $163;__label__ = 20; break;
    case 20: // $164
      var $165;
      var $166=$165 ? 4 : 0;
      var $168 = $166;__label__ = 21; break;
    case 21: // $167
      var $168;
      var $169=(($168) & 255);
      var $170=$s;
      var $171=(($170+20)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172+1)|0);
      HEAP32[(($171)>>2)]=$173;
      var $174=$s;
      var $175=(($174+8)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176+$172)|0);
      HEAP8[($177)]=$169;
      var $178=$s;
      var $179=(($178+20)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180+1)|0);
      HEAP32[(($179)>>2)]=$181;
      var $182=$s;
      var $183=(($182+8)|0);
      var $184=HEAP32[(($183)>>2)];
      var $185=(($184+$180)|0);
      HEAP8[($185)]=3;
      var $186=$s;
      var $187=(($186+4)|0);
      HEAP32[(($187)>>2)]=113;
      __label__ = 32; break;
    case 22: // $188
      var $189=$s;
      var $190=(($189+28)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=(($191)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=(($193)|0)!=0;
      var $195=$194 ? 1 : 0;
      var $196=$s;
      var $197=(($196+28)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198+44)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200)|0)!=0;
      var $202=$201 ? 2 : 0;
      var $203=(($195+$202)|0);
      var $204=$s;
      var $205=(($204+28)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206+16)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208)|0)==0;
      var $210=$209 ? 0 : 4;
      var $211=(($203+$210)|0);
      var $212=$s;
      var $213=(($212+28)|0);
      var $214=HEAP32[(($213)>>2)];
      var $215=(($214+28)|0);
      var $216=HEAP32[(($215)>>2)];
      var $217=(($216)|0)==0;
      var $218=$217 ? 0 : 8;
      var $219=(($211+$218)|0);
      var $220=$s;
      var $221=(($220+28)|0);
      var $222=HEAP32[(($221)>>2)];
      var $223=(($222+36)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224)|0)==0;
      var $226=$225 ? 0 : 16;
      var $227=(($219+$226)|0);
      var $228=(($227) & 255);
      var $229=$s;
      var $230=(($229+20)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231+1)|0);
      HEAP32[(($230)>>2)]=$232;
      var $233=$s;
      var $234=(($233+8)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($235+$231)|0);
      HEAP8[($236)]=$228;
      var $237=$s;
      var $238=(($237+28)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(($239+4)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=$241 & 255;
      var $243=(($242) & 255);
      var $244=$s;
      var $245=(($244+20)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246+1)|0);
      HEAP32[(($245)>>2)]=$247;
      var $248=$s;
      var $249=(($248+8)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=(($250+$246)|0);
      HEAP8[($251)]=$243;
      var $252=$s;
      var $253=(($252+28)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($254+4)|0);
      var $256=HEAPU32[(($255)>>2)];
      var $257=$256 >>> 8;
      var $258=$257 & 255;
      var $259=(($258) & 255);
      var $260=$s;
      var $261=(($260+20)|0);
      var $262=HEAPU32[(($261)>>2)];
      var $263=(($262+1)|0);
      HEAP32[(($261)>>2)]=$263;
      var $264=$s;
      var $265=(($264+8)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266+$262)|0);
      HEAP8[($267)]=$259;
      var $268=$s;
      var $269=(($268+28)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($270+4)|0);
      var $272=HEAPU32[(($271)>>2)];
      var $273=$272 >>> 16;
      var $274=$273 & 255;
      var $275=(($274) & 255);
      var $276=$s;
      var $277=(($276+20)|0);
      var $278=HEAPU32[(($277)>>2)];
      var $279=(($278+1)|0);
      HEAP32[(($277)>>2)]=$279;
      var $280=$s;
      var $281=(($280+8)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=(($282+$278)|0);
      HEAP8[($283)]=$275;
      var $284=$s;
      var $285=(($284+28)|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=(($286+4)|0);
      var $288=HEAPU32[(($287)>>2)];
      var $289=$288 >>> 24;
      var $290=$289 & 255;
      var $291=(($290) & 255);
      var $292=$s;
      var $293=(($292+20)|0);
      var $294=HEAPU32[(($293)>>2)];
      var $295=(($294+1)|0);
      HEAP32[(($293)>>2)]=$295;
      var $296=$s;
      var $297=(($296+8)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(($298+$294)|0);
      HEAP8[($299)]=$291;
      var $300=$s;
      var $301=(($300+132)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=(($302)|0)==9;
      if ($303) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $304
      var $319 = 2;__label__ = 27; break;
    case 24: // $305
      var $306=$s;
      var $307=(($306+136)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=(($308)|0) >= 2;
      if ($309) { var $316 = 1;__label__ = 26; break; } else { __label__ = 25; break; }
    case 25: // $310
      var $311=$s;
      var $312=(($311+132)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=(($313)|0) < 2;
      var $316 = $314;__label__ = 26; break;
    case 26: // $315
      var $316;
      var $317=$316 ? 4 : 0;
      var $319 = $317;__label__ = 27; break;
    case 27: // $318
      var $319;
      var $320=(($319) & 255);
      var $321=$s;
      var $322=(($321+20)|0);
      var $323=HEAP32[(($322)>>2)];
      var $324=(($323+1)|0);
      HEAP32[(($322)>>2)]=$324;
      var $325=$s;
      var $326=(($325+8)|0);
      var $327=HEAP32[(($326)>>2)];
      var $328=(($327+$323)|0);
      HEAP8[($328)]=$320;
      var $329=$s;
      var $330=(($329+28)|0);
      var $331=HEAP32[(($330)>>2)];
      var $332=(($331+12)|0);
      var $333=HEAP32[(($332)>>2)];
      var $334=$333 & 255;
      var $335=(($334) & 255);
      var $336=$s;
      var $337=(($336+20)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=(($338+1)|0);
      HEAP32[(($337)>>2)]=$339;
      var $340=$s;
      var $341=(($340+8)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=(($342+$338)|0);
      HEAP8[($343)]=$335;
      var $344=$s;
      var $345=(($344+28)|0);
      var $346=HEAP32[(($345)>>2)];
      var $347=(($346+16)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=(($348)|0)!=0;
      if ($349) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $350
      var $351=$s;
      var $352=(($351+28)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($353+20)|0);
      var $355=HEAP32[(($354)>>2)];
      var $356=$355 & 255;
      var $357=(($356) & 255);
      var $358=$s;
      var $359=(($358+20)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=(($360+1)|0);
      HEAP32[(($359)>>2)]=$361;
      var $362=$s;
      var $363=(($362+8)|0);
      var $364=HEAP32[(($363)>>2)];
      var $365=(($364+$360)|0);
      HEAP8[($365)]=$357;
      var $366=$s;
      var $367=(($366+28)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=(($368+20)|0);
      var $370=HEAPU32[(($369)>>2)];
      var $371=$370 >>> 8;
      var $372=$371 & 255;
      var $373=(($372) & 255);
      var $374=$s;
      var $375=(($374+20)|0);
      var $376=HEAPU32[(($375)>>2)];
      var $377=(($376+1)|0);
      HEAP32[(($375)>>2)]=$377;
      var $378=$s;
      var $379=(($378+8)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=(($380+$376)|0);
      HEAP8[($381)]=$373;
      __label__ = 29; break;
    case 29: // $382
      var $383=$s;
      var $384=(($383+28)|0);
      var $385=HEAP32[(($384)>>2)];
      var $386=(($385+44)|0);
      var $387=HEAP32[(($386)>>2)];
      var $388=(($387)|0)!=0;
      if ($388) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $389
      var $390=$2;
      var $391=(($390+48)|0);
      var $392=HEAP32[(($391)>>2)];
      var $393=$s;
      var $394=(($393+8)|0);
      var $395=HEAP32[(($394)>>2)];
      var $396=$s;
      var $397=(($396+20)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=_crc32($392, $395, $398);
      var $400=$2;
      var $401=(($400+48)|0);
      HEAP32[(($401)>>2)]=$399;
      __label__ = 31; break;
    case 31: // $402
      var $403=$s;
      var $404=(($403+32)|0);
      HEAP32[(($404)>>2)]=0;
      var $405=$s;
      var $406=(($405+4)|0);
      HEAP32[(($406)>>2)]=69;
      __label__ = 32; break;
    case 32: // $407
      __label__ = 48; break;
    case 33: // $408
      var $409=$s;
      var $410=(($409+48)|0);
      var $411=HEAP32[(($410)>>2)];
      var $412=(($411-8)|0);
      var $413=$412 << 4;
      var $414=(($413+8)|0);
      var $415=$414 << 8;
      $header=$415;
      var $416=$s;
      var $417=(($416+136)|0);
      var $418=HEAP32[(($417)>>2)];
      var $419=(($418)|0) >= 2;
      if ($419) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $420
      var $421=$s;
      var $422=(($421+132)|0);
      var $423=HEAP32[(($422)>>2)];
      var $424=(($423)|0) < 2;
      if ($424) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $425
      $level_flags=0;
      __label__ = 43; break;
    case 36: // $426
      var $427=$s;
      var $428=(($427+132)|0);
      var $429=HEAP32[(($428)>>2)];
      var $430=(($429)|0) < 6;
      if ($430) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $431
      $level_flags=1;
      __label__ = 42; break;
    case 38: // $432
      var $433=$s;
      var $434=(($433+132)|0);
      var $435=HEAP32[(($434)>>2)];
      var $436=(($435)|0)==6;
      if ($436) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $437
      $level_flags=2;
      __label__ = 41; break;
    case 40: // $438
      $level_flags=3;
      __label__ = 41; break;
    case 41: // $439
      __label__ = 42; break;
    case 42: // $440
      __label__ = 43; break;
    case 43: // $441
      var $442=$level_flags;
      var $443=$442 << 6;
      var $444=$header;
      var $445=$444 | $443;
      $header=$445;
      var $446=$s;
      var $447=(($446+108)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=(($448)|0)!=0;
      if ($449) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $450
      var $451=$header;
      var $452=$451 | 32;
      $header=$452;
      __label__ = 45; break;
    case 45: // $453
      var $454=$header;
      var $455=(($454)>>>0)%31;
      var $456=((31-$455)|0);
      var $457=$header;
      var $458=(($457+$456)|0);
      $header=$458;
      var $459=$s;
      var $460=(($459+4)|0);
      HEAP32[(($460)>>2)]=113;
      var $461=$s;
      var $462=$header;
      _putShortMSB($461, $462);
      var $463=$s;
      var $464=(($463+108)|0);
      var $465=HEAP32[(($464)>>2)];
      var $466=(($465)|0)!=0;
      if ($466) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $467
      var $468=$s;
      var $469=$2;
      var $470=(($469+48)|0);
      var $471=HEAPU32[(($470)>>2)];
      var $472=$471 >>> 16;
      _putShortMSB($468, $472);
      var $473=$s;
      var $474=$2;
      var $475=(($474+48)|0);
      var $476=HEAP32[(($475)>>2)];
      var $477=$476 & 65535;
      _putShortMSB($473, $477);
      __label__ = 47; break;
    case 47: // $478
      var $479=_adler32(0, 0, 0);
      var $480=$2;
      var $481=(($480+48)|0);
      HEAP32[(($481)>>2)]=$479;
      __label__ = 48; break;
    case 48: // $482
      __label__ = 49; break;
    case 49: // $483
      var $484=$s;
      var $485=(($484+4)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=(($486)|0)==69;
      if ($487) { __label__ = 50; break; } else { __label__ = 69; break; }
    case 50: // $488
      var $489=$s;
      var $490=(($489+28)|0);
      var $491=HEAP32[(($490)>>2)];
      var $492=(($491+16)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=(($493)|0)!=0;
      if ($494) { __label__ = 51; break; } else { __label__ = 67; break; }
    case 51: // $495
      var $496=$s;
      var $497=(($496+20)|0);
      var $498=HEAP32[(($497)>>2)];
      $beg=$498;
      __label__ = 52; break;
    case 52: // $499
      var $500=$s;
      var $501=(($500+32)|0);
      var $502=HEAPU32[(($501)>>2)];
      var $503=$s;
      var $504=(($503+28)|0);
      var $505=HEAP32[(($504)>>2)];
      var $506=(($505+20)|0);
      var $507=HEAP32[(($506)>>2)];
      var $508=$507 & 65535;
      var $509=(($502)>>>0) < (($508)>>>0);
      if ($509) { __label__ = 53; break; } else { __label__ = 61; break; }
    case 53: // $510
      var $511=$s;
      var $512=(($511+20)|0);
      var $513=HEAP32[(($512)>>2)];
      var $514=$s;
      var $515=(($514+12)|0);
      var $516=HEAP32[(($515)>>2)];
      var $517=(($513)|0)==(($516)|0);
      if ($517) { __label__ = 54; break; } else { __label__ = 60; break; }
    case 54: // $518
      var $519=$s;
      var $520=(($519+28)|0);
      var $521=HEAP32[(($520)>>2)];
      var $522=(($521+44)|0);
      var $523=HEAP32[(($522)>>2)];
      var $524=(($523)|0)!=0;
      if ($524) { __label__ = 55; break; } else { __label__ = 57; break; }
    case 55: // $525
      var $526=$s;
      var $527=(($526+20)|0);
      var $528=HEAPU32[(($527)>>2)];
      var $529=$beg;
      var $530=(($528)>>>0) > (($529)>>>0);
      if ($530) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $531
      var $532=$2;
      var $533=(($532+48)|0);
      var $534=HEAP32[(($533)>>2)];
      var $535=$s;
      var $536=(($535+8)|0);
      var $537=HEAP32[(($536)>>2)];
      var $538=$beg;
      var $539=(($537+$538)|0);
      var $540=$s;
      var $541=(($540+20)|0);
      var $542=HEAP32[(($541)>>2)];
      var $543=$beg;
      var $544=(($542-$543)|0);
      var $545=_crc32($534, $539, $544);
      var $546=$2;
      var $547=(($546+48)|0);
      HEAP32[(($547)>>2)]=$545;
      __label__ = 57; break;
    case 57: // $548
      var $549=$2;
      _flush_pending($549);
      var $550=$s;
      var $551=(($550+20)|0);
      var $552=HEAP32[(($551)>>2)];
      $beg=$552;
      var $553=$s;
      var $554=(($553+20)|0);
      var $555=HEAP32[(($554)>>2)];
      var $556=$s;
      var $557=(($556+12)|0);
      var $558=HEAP32[(($557)>>2)];
      var $559=(($555)|0)==(($558)|0);
      if ($559) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $560
      __label__ = 61; break;
    case 59: // $561
      __label__ = 60; break;
    case 60: // $562
      var $563=$s;
      var $564=(($563+32)|0);
      var $565=HEAP32[(($564)>>2)];
      var $566=$s;
      var $567=(($566+28)|0);
      var $568=HEAP32[(($567)>>2)];
      var $569=(($568+16)|0);
      var $570=HEAP32[(($569)>>2)];
      var $571=(($570+$565)|0);
      var $572=HEAP8[($571)];
      var $573=$s;
      var $574=(($573+20)|0);
      var $575=HEAP32[(($574)>>2)];
      var $576=(($575+1)|0);
      HEAP32[(($574)>>2)]=$576;
      var $577=$s;
      var $578=(($577+8)|0);
      var $579=HEAP32[(($578)>>2)];
      var $580=(($579+$575)|0);
      HEAP8[($580)]=$572;
      var $581=$s;
      var $582=(($581+32)|0);
      var $583=HEAP32[(($582)>>2)];
      var $584=(($583+1)|0);
      HEAP32[(($582)>>2)]=$584;
      __label__ = 52; break;
    case 61: // $585
      var $586=$s;
      var $587=(($586+28)|0);
      var $588=HEAP32[(($587)>>2)];
      var $589=(($588+44)|0);
      var $590=HEAP32[(($589)>>2)];
      var $591=(($590)|0)!=0;
      if ($591) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $592
      var $593=$s;
      var $594=(($593+20)|0);
      var $595=HEAPU32[(($594)>>2)];
      var $596=$beg;
      var $597=(($595)>>>0) > (($596)>>>0);
      if ($597) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $598
      var $599=$2;
      var $600=(($599+48)|0);
      var $601=HEAP32[(($600)>>2)];
      var $602=$s;
      var $603=(($602+8)|0);
      var $604=HEAP32[(($603)>>2)];
      var $605=$beg;
      var $606=(($604+$605)|0);
      var $607=$s;
      var $608=(($607+20)|0);
      var $609=HEAP32[(($608)>>2)];
      var $610=$beg;
      var $611=(($609-$610)|0);
      var $612=_crc32($601, $606, $611);
      var $613=$2;
      var $614=(($613+48)|0);
      HEAP32[(($614)>>2)]=$612;
      __label__ = 64; break;
    case 64: // $615
      var $616=$s;
      var $617=(($616+32)|0);
      var $618=HEAP32[(($617)>>2)];
      var $619=$s;
      var $620=(($619+28)|0);
      var $621=HEAP32[(($620)>>2)];
      var $622=(($621+20)|0);
      var $623=HEAP32[(($622)>>2)];
      var $624=(($618)|0)==(($623)|0);
      if ($624) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $625
      var $626=$s;
      var $627=(($626+32)|0);
      HEAP32[(($627)>>2)]=0;
      var $628=$s;
      var $629=(($628+4)|0);
      HEAP32[(($629)>>2)]=73;
      __label__ = 66; break;
    case 66: // $630
      __label__ = 68; break;
    case 67: // $631
      var $632=$s;
      var $633=(($632+4)|0);
      HEAP32[(($633)>>2)]=73;
      __label__ = 68; break;
    case 68: // $634
      __label__ = 69; break;
    case 69: // $635
      var $636=$s;
      var $637=(($636+4)|0);
      var $638=HEAP32[(($637)>>2)];
      var $639=(($638)|0)==73;
      if ($639) { __label__ = 70; break; } else { __label__ = 89; break; }
    case 70: // $640
      var $641=$s;
      var $642=(($641+28)|0);
      var $643=HEAP32[(($642)>>2)];
      var $644=(($643+28)|0);
      var $645=HEAP32[(($644)>>2)];
      var $646=(($645)|0)!=0;
      if ($646) { __label__ = 71; break; } else { __label__ = 87; break; }
    case 71: // $647
      var $648=$s;
      var $649=(($648+20)|0);
      var $650=HEAP32[(($649)>>2)];
      $beg1=$650;
      __label__ = 72; break;
    case 72: // $651
      var $652=$s;
      var $653=(($652+20)|0);
      var $654=HEAP32[(($653)>>2)];
      var $655=$s;
      var $656=(($655+12)|0);
      var $657=HEAP32[(($656)>>2)];
      var $658=(($654)|0)==(($657)|0);
      if ($658) { __label__ = 73; break; } else { __label__ = 79; break; }
    case 73: // $659
      var $660=$s;
      var $661=(($660+28)|0);
      var $662=HEAP32[(($661)>>2)];
      var $663=(($662+44)|0);
      var $664=HEAP32[(($663)>>2)];
      var $665=(($664)|0)!=0;
      if ($665) { __label__ = 74; break; } else { __label__ = 76; break; }
    case 74: // $666
      var $667=$s;
      var $668=(($667+20)|0);
      var $669=HEAPU32[(($668)>>2)];
      var $670=$beg1;
      var $671=(($669)>>>0) > (($670)>>>0);
      if ($671) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $672
      var $673=$2;
      var $674=(($673+48)|0);
      var $675=HEAP32[(($674)>>2)];
      var $676=$s;
      var $677=(($676+8)|0);
      var $678=HEAP32[(($677)>>2)];
      var $679=$beg1;
      var $680=(($678+$679)|0);
      var $681=$s;
      var $682=(($681+20)|0);
      var $683=HEAP32[(($682)>>2)];
      var $684=$beg1;
      var $685=(($683-$684)|0);
      var $686=_crc32($675, $680, $685);
      var $687=$2;
      var $688=(($687+48)|0);
      HEAP32[(($688)>>2)]=$686;
      __label__ = 76; break;
    case 76: // $689
      var $690=$2;
      _flush_pending($690);
      var $691=$s;
      var $692=(($691+20)|0);
      var $693=HEAP32[(($692)>>2)];
      $beg1=$693;
      var $694=$s;
      var $695=(($694+20)|0);
      var $696=HEAP32[(($695)>>2)];
      var $697=$s;
      var $698=(($697+12)|0);
      var $699=HEAP32[(($698)>>2)];
      var $700=(($696)|0)==(($699)|0);
      if ($700) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $701
      $val=1;
      __label__ = 81; break;
    case 78: // $702
      __label__ = 79; break;
    case 79: // $703
      var $704=$s;
      var $705=(($704+32)|0);
      var $706=HEAP32[(($705)>>2)];
      var $707=(($706+1)|0);
      HEAP32[(($705)>>2)]=$707;
      var $708=$s;
      var $709=(($708+28)|0);
      var $710=HEAP32[(($709)>>2)];
      var $711=(($710+28)|0);
      var $712=HEAP32[(($711)>>2)];
      var $713=(($712+$706)|0);
      var $714=HEAPU8[($713)];
      var $715=(($714)&255);
      $val=$715;
      var $716=$val;
      var $717=(($716) & 255);
      var $718=$s;
      var $719=(($718+20)|0);
      var $720=HEAPU32[(($719)>>2)];
      var $721=(($720+1)|0);
      HEAP32[(($719)>>2)]=$721;
      var $722=$s;
      var $723=(($722+8)|0);
      var $724=HEAP32[(($723)>>2)];
      var $725=(($724+$720)|0);
      HEAP8[($725)]=$717;
      __label__ = 80; break;
    case 80: // $726
      var $727=$val;
      var $728=(($727)|0)!=0;
      if ($728) { __label__ = 72; break; } else { __label__ = 81; break; }
    case 81: // $729
      var $730=$s;
      var $731=(($730+28)|0);
      var $732=HEAP32[(($731)>>2)];
      var $733=(($732+44)|0);
      var $734=HEAP32[(($733)>>2)];
      var $735=(($734)|0)!=0;
      if ($735) { __label__ = 82; break; } else { __label__ = 84; break; }
    case 82: // $736
      var $737=$s;
      var $738=(($737+20)|0);
      var $739=HEAPU32[(($738)>>2)];
      var $740=$beg1;
      var $741=(($739)>>>0) > (($740)>>>0);
      if ($741) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $742
      var $743=$2;
      var $744=(($743+48)|0);
      var $745=HEAP32[(($744)>>2)];
      var $746=$s;
      var $747=(($746+8)|0);
      var $748=HEAP32[(($747)>>2)];
      var $749=$beg1;
      var $750=(($748+$749)|0);
      var $751=$s;
      var $752=(($751+20)|0);
      var $753=HEAP32[(($752)>>2)];
      var $754=$beg1;
      var $755=(($753-$754)|0);
      var $756=_crc32($745, $750, $755);
      var $757=$2;
      var $758=(($757+48)|0);
      HEAP32[(($758)>>2)]=$756;
      __label__ = 84; break;
    case 84: // $759
      var $760=$val;
      var $761=(($760)|0)==0;
      if ($761) { __label__ = 85; break; } else { __label__ = 86; break; }
    case 85: // $762
      var $763=$s;
      var $764=(($763+32)|0);
      HEAP32[(($764)>>2)]=0;
      var $765=$s;
      var $766=(($765+4)|0);
      HEAP32[(($766)>>2)]=91;
      __label__ = 86; break;
    case 86: // $767
      __label__ = 88; break;
    case 87: // $768
      var $769=$s;
      var $770=(($769+4)|0);
      HEAP32[(($770)>>2)]=91;
      __label__ = 88; break;
    case 88: // $771
      __label__ = 89; break;
    case 89: // $772
      var $773=$s;
      var $774=(($773+4)|0);
      var $775=HEAP32[(($774)>>2)];
      var $776=(($775)|0)==91;
      if ($776) { __label__ = 90; break; } else { __label__ = 109; break; }
    case 90: // $777
      var $778=$s;
      var $779=(($778+28)|0);
      var $780=HEAP32[(($779)>>2)];
      var $781=(($780+36)|0);
      var $782=HEAP32[(($781)>>2)];
      var $783=(($782)|0)!=0;
      if ($783) { __label__ = 91; break; } else { __label__ = 107; break; }
    case 91: // $784
      var $785=$s;
      var $786=(($785+20)|0);
      var $787=HEAP32[(($786)>>2)];
      $beg2=$787;
      __label__ = 92; break;
    case 92: // $788
      var $789=$s;
      var $790=(($789+20)|0);
      var $791=HEAP32[(($790)>>2)];
      var $792=$s;
      var $793=(($792+12)|0);
      var $794=HEAP32[(($793)>>2)];
      var $795=(($791)|0)==(($794)|0);
      if ($795) { __label__ = 93; break; } else { __label__ = 99; break; }
    case 93: // $796
      var $797=$s;
      var $798=(($797+28)|0);
      var $799=HEAP32[(($798)>>2)];
      var $800=(($799+44)|0);
      var $801=HEAP32[(($800)>>2)];
      var $802=(($801)|0)!=0;
      if ($802) { __label__ = 94; break; } else { __label__ = 96; break; }
    case 94: // $803
      var $804=$s;
      var $805=(($804+20)|0);
      var $806=HEAPU32[(($805)>>2)];
      var $807=$beg2;
      var $808=(($806)>>>0) > (($807)>>>0);
      if ($808) { __label__ = 95; break; } else { __label__ = 96; break; }
    case 95: // $809
      var $810=$2;
      var $811=(($810+48)|0);
      var $812=HEAP32[(($811)>>2)];
      var $813=$s;
      var $814=(($813+8)|0);
      var $815=HEAP32[(($814)>>2)];
      var $816=$beg2;
      var $817=(($815+$816)|0);
      var $818=$s;
      var $819=(($818+20)|0);
      var $820=HEAP32[(($819)>>2)];
      var $821=$beg2;
      var $822=(($820-$821)|0);
      var $823=_crc32($812, $817, $822);
      var $824=$2;
      var $825=(($824+48)|0);
      HEAP32[(($825)>>2)]=$823;
      __label__ = 96; break;
    case 96: // $826
      var $827=$2;
      _flush_pending($827);
      var $828=$s;
      var $829=(($828+20)|0);
      var $830=HEAP32[(($829)>>2)];
      $beg2=$830;
      var $831=$s;
      var $832=(($831+20)|0);
      var $833=HEAP32[(($832)>>2)];
      var $834=$s;
      var $835=(($834+12)|0);
      var $836=HEAP32[(($835)>>2)];
      var $837=(($833)|0)==(($836)|0);
      if ($837) { __label__ = 97; break; } else { __label__ = 98; break; }
    case 97: // $838
      $val3=1;
      __label__ = 101; break;
    case 98: // $839
      __label__ = 99; break;
    case 99: // $840
      var $841=$s;
      var $842=(($841+32)|0);
      var $843=HEAP32[(($842)>>2)];
      var $844=(($843+1)|0);
      HEAP32[(($842)>>2)]=$844;
      var $845=$s;
      var $846=(($845+28)|0);
      var $847=HEAP32[(($846)>>2)];
      var $848=(($847+36)|0);
      var $849=HEAP32[(($848)>>2)];
      var $850=(($849+$843)|0);
      var $851=HEAPU8[($850)];
      var $852=(($851)&255);
      $val3=$852;
      var $853=$val3;
      var $854=(($853) & 255);
      var $855=$s;
      var $856=(($855+20)|0);
      var $857=HEAPU32[(($856)>>2)];
      var $858=(($857+1)|0);
      HEAP32[(($856)>>2)]=$858;
      var $859=$s;
      var $860=(($859+8)|0);
      var $861=HEAP32[(($860)>>2)];
      var $862=(($861+$857)|0);
      HEAP8[($862)]=$854;
      __label__ = 100; break;
    case 100: // $863
      var $864=$val3;
      var $865=(($864)|0)!=0;
      if ($865) { __label__ = 92; break; } else { __label__ = 101; break; }
    case 101: // $866
      var $867=$s;
      var $868=(($867+28)|0);
      var $869=HEAP32[(($868)>>2)];
      var $870=(($869+44)|0);
      var $871=HEAP32[(($870)>>2)];
      var $872=(($871)|0)!=0;
      if ($872) { __label__ = 102; break; } else { __label__ = 104; break; }
    case 102: // $873
      var $874=$s;
      var $875=(($874+20)|0);
      var $876=HEAPU32[(($875)>>2)];
      var $877=$beg2;
      var $878=(($876)>>>0) > (($877)>>>0);
      if ($878) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $879
      var $880=$2;
      var $881=(($880+48)|0);
      var $882=HEAP32[(($881)>>2)];
      var $883=$s;
      var $884=(($883+8)|0);
      var $885=HEAP32[(($884)>>2)];
      var $886=$beg2;
      var $887=(($885+$886)|0);
      var $888=$s;
      var $889=(($888+20)|0);
      var $890=HEAP32[(($889)>>2)];
      var $891=$beg2;
      var $892=(($890-$891)|0);
      var $893=_crc32($882, $887, $892);
      var $894=$2;
      var $895=(($894+48)|0);
      HEAP32[(($895)>>2)]=$893;
      __label__ = 104; break;
    case 104: // $896
      var $897=$val3;
      var $898=(($897)|0)==0;
      if ($898) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $899
      var $900=$s;
      var $901=(($900+4)|0);
      HEAP32[(($901)>>2)]=103;
      __label__ = 106; break;
    case 106: // $902
      __label__ = 108; break;
    case 107: // $903
      var $904=$s;
      var $905=(($904+4)|0);
      HEAP32[(($905)>>2)]=103;
      __label__ = 108; break;
    case 108: // $906
      __label__ = 109; break;
    case 109: // $907
      var $908=$s;
      var $909=(($908+4)|0);
      var $910=HEAP32[(($909)>>2)];
      var $911=(($910)|0)==103;
      if ($911) { __label__ = 110; break; } else { __label__ = 118; break; }
    case 110: // $912
      var $913=$s;
      var $914=(($913+28)|0);
      var $915=HEAP32[(($914)>>2)];
      var $916=(($915+44)|0);
      var $917=HEAP32[(($916)>>2)];
      var $918=(($917)|0)!=0;
      if ($918) { __label__ = 111; break; } else { __label__ = 116; break; }
    case 111: // $919
      var $920=$s;
      var $921=(($920+20)|0);
      var $922=HEAP32[(($921)>>2)];
      var $923=(($922+2)|0);
      var $924=$s;
      var $925=(($924+12)|0);
      var $926=HEAPU32[(($925)>>2)];
      var $927=(($923)>>>0) > (($926)>>>0);
      if ($927) { __label__ = 112; break; } else { __label__ = 113; break; }
    case 112: // $928
      var $929=$2;
      _flush_pending($929);
      __label__ = 113; break;
    case 113: // $930
      var $931=$s;
      var $932=(($931+20)|0);
      var $933=HEAP32[(($932)>>2)];
      var $934=(($933+2)|0);
      var $935=$s;
      var $936=(($935+12)|0);
      var $937=HEAPU32[(($936)>>2)];
      var $938=(($934)>>>0) <= (($937)>>>0);
      if ($938) { __label__ = 114; break; } else { __label__ = 115; break; }
    case 114: // $939
      var $940=$2;
      var $941=(($940+48)|0);
      var $942=HEAP32[(($941)>>2)];
      var $943=$942 & 255;
      var $944=(($943) & 255);
      var $945=$s;
      var $946=(($945+20)|0);
      var $947=HEAP32[(($946)>>2)];
      var $948=(($947+1)|0);
      HEAP32[(($946)>>2)]=$948;
      var $949=$s;
      var $950=(($949+8)|0);
      var $951=HEAP32[(($950)>>2)];
      var $952=(($951+$947)|0);
      HEAP8[($952)]=$944;
      var $953=$2;
      var $954=(($953+48)|0);
      var $955=HEAPU32[(($954)>>2)];
      var $956=$955 >>> 8;
      var $957=$956 & 255;
      var $958=(($957) & 255);
      var $959=$s;
      var $960=(($959+20)|0);
      var $961=HEAPU32[(($960)>>2)];
      var $962=(($961+1)|0);
      HEAP32[(($960)>>2)]=$962;
      var $963=$s;
      var $964=(($963+8)|0);
      var $965=HEAP32[(($964)>>2)];
      var $966=(($965+$961)|0);
      HEAP8[($966)]=$958;
      var $967=_crc32(0, 0, 0);
      var $968=$2;
      var $969=(($968+48)|0);
      HEAP32[(($969)>>2)]=$967;
      var $970=$s;
      var $971=(($970+4)|0);
      HEAP32[(($971)>>2)]=113;
      __label__ = 115; break;
    case 115: // $972
      __label__ = 117; break;
    case 116: // $973
      var $974=$s;
      var $975=(($974+4)|0);
      HEAP32[(($975)>>2)]=113;
      __label__ = 117; break;
    case 117: // $976
      __label__ = 118; break;
    case 118: // $977
      var $978=$s;
      var $979=(($978+20)|0);
      var $980=HEAP32[(($979)>>2)];
      var $981=(($980)|0)!=0;
      if ($981) { __label__ = 119; break; } else { __label__ = 122; break; }
    case 119: // $982
      var $983=$2;
      _flush_pending($983);
      var $984=$2;
      var $985=(($984+16)|0);
      var $986=HEAP32[(($985)>>2)];
      var $987=(($986)|0)==0;
      if ($987) { __label__ = 120; break; } else { __label__ = 121; break; }
    case 120: // $988
      var $989=$s;
      var $990=(($989+40)|0);
      HEAP32[(($990)>>2)]=-1;
      $1=0;
      __label__ = 162; break;
    case 121: // $991
      __label__ = 127; break;
    case 122: // $992
      var $993=$2;
      var $994=(($993+4)|0);
      var $995=HEAP32[(($994)>>2)];
      var $996=(($995)|0)==0;
      if ($996) { __label__ = 123; break; } else { __label__ = 126; break; }
    case 123: // $997
      var $998=$3;
      var $999=$old_flush;
      var $1000=(($998)|0) <= (($999)|0);
      if ($1000) { __label__ = 124; break; } else { __label__ = 126; break; }
    case 124: // $1001
      var $1002=$3;
      var $1003=(($1002)|0)!=4;
      if ($1003) { __label__ = 125; break; } else { __label__ = 126; break; }
    case 125: // $1004
      var $1005=HEAP32[((((_z_errmsg+28)|0))>>2)];
      var $1006=$2;
      var $1007=(($1006+24)|0);
      HEAP32[(($1007)>>2)]=$1005;
      $1=-5;
      __label__ = 162; break;
    case 126: // $1008
      __label__ = 127; break;
    case 127: // $1009
      var $1010=$s;
      var $1011=(($1010+4)|0);
      var $1012=HEAP32[(($1011)>>2)];
      var $1013=(($1012)|0)==666;
      if ($1013) { __label__ = 128; break; } else { __label__ = 130; break; }
    case 128: // $1014
      var $1015=$2;
      var $1016=(($1015+4)|0);
      var $1017=HEAP32[(($1016)>>2)];
      var $1018=(($1017)|0)!=0;
      if ($1018) { __label__ = 129; break; } else { __label__ = 130; break; }
    case 129: // $1019
      var $1020=HEAP32[((((_z_errmsg+28)|0))>>2)];
      var $1021=$2;
      var $1022=(($1021+24)|0);
      HEAP32[(($1022)>>2)]=$1020;
      $1=-5;
      __label__ = 162; break;
    case 130: // $1023
      var $1024=$2;
      var $1025=(($1024+4)|0);
      var $1026=HEAP32[(($1025)>>2)];
      var $1027=(($1026)|0)!=0;
      if ($1027) { __label__ = 134; break; } else { __label__ = 131; break; }
    case 131: // $1028
      var $1029=$s;
      var $1030=(($1029+116)|0);
      var $1031=HEAP32[(($1030)>>2)];
      var $1032=(($1031)|0)!=0;
      if ($1032) { __label__ = 134; break; } else { __label__ = 132; break; }
    case 132: // $1033
      var $1034=$3;
      var $1035=(($1034)|0)!=0;
      if ($1035) { __label__ = 133; break; } else { __label__ = 152; break; }
    case 133: // $1036
      var $1037=$s;
      var $1038=(($1037+4)|0);
      var $1039=HEAP32[(($1038)>>2)];
      var $1040=(($1039)|0)!=666;
      if ($1040) { __label__ = 134; break; } else { __label__ = 152; break; }
    case 134: // $1041
      var $1042=$s;
      var $1043=(($1042+132)|0);
      var $1044=HEAP32[(($1043)>>2)];
      var $1045=((_configuration_table+$1044*12)|0);
      var $1046=(($1045+8)|0);
      var $1047=HEAP32[(($1046)>>2)];
      var $1048=$s;
      var $1049=$3;
      var $1050=FUNCTION_TABLE[$1047]($1048, $1049);
      $bstate=$1050;
      var $1051=$bstate;
      var $1052=(($1051)|0)==2;
      if ($1052) { __label__ = 136; break; } else { __label__ = 135; break; }
    case 135: // $1053
      var $1054=$bstate;
      var $1055=(($1054)|0)==3;
      if ($1055) { __label__ = 136; break; } else { __label__ = 137; break; }
    case 136: // $1056
      var $1057=$s;
      var $1058=(($1057+4)|0);
      HEAP32[(($1058)>>2)]=666;
      __label__ = 137; break;
    case 137: // $1059
      var $1060=$bstate;
      var $1061=(($1060)|0)==0;
      if ($1061) { __label__ = 139; break; } else { __label__ = 138; break; }
    case 138: // $1062
      var $1063=$bstate;
      var $1064=(($1063)|0)==2;
      if ($1064) { __label__ = 139; break; } else { __label__ = 142; break; }
    case 139: // $1065
      var $1066=$2;
      var $1067=(($1066+16)|0);
      var $1068=HEAP32[(($1067)>>2)];
      var $1069=(($1068)|0)==0;
      if ($1069) { __label__ = 140; break; } else { __label__ = 141; break; }
    case 140: // $1070
      var $1071=$s;
      var $1072=(($1071+40)|0);
      HEAP32[(($1072)>>2)]=-1;
      __label__ = 141; break;
    case 141: // $1073
      $1=0;
      __label__ = 162; break;
    case 142: // $1074
      var $1075=$bstate;
      var $1076=(($1075)|0)==1;
      if ($1076) { __label__ = 143; break; } else { __label__ = 151; break; }
    case 143: // $1077
      var $1078=$3;
      var $1079=(($1078)|0)==1;
      if ($1079) { __label__ = 144; break; } else { __label__ = 145; break; }
    case 144: // $1080
      var $1081=$s;
      __tr_align($1081);
      __label__ = 148; break;
    case 145: // $1082
      var $1083=$s;
      __tr_stored_block($1083, 0, 0, 0);
      var $1084=$3;
      var $1085=(($1084)|0)==3;
      if ($1085) { __label__ = 146; break; } else { __label__ = 147; break; }
    case 146: // $1086
      var $1087=$s;
      var $1088=(($1087+76)|0);
      var $1089=HEAP32[(($1088)>>2)];
      var $1090=(($1089-1)|0);
      var $1091=$s;
      var $1092=(($1091+68)|0);
      var $1093=HEAP32[(($1092)>>2)];
      var $1094=(($1093+($1090<<1))|0);
      HEAP16[(($1094)>>1)]=0;
      var $1095=$s;
      var $1096=(($1095+68)|0);
      var $1097=HEAP32[(($1096)>>2)];
      var $1098=$1097;
      var $1099=$s;
      var $1100=(($1099+76)|0);
      var $1101=HEAP32[(($1100)>>2)];
      var $1102=(($1101-1)|0);
      var $1103=((($1102<<1))|0);
      _memset($1098, 0, $1103, 1);
      __label__ = 147; break;
    case 147: // $1104
      __label__ = 148; break;
    case 148: // $1105
      var $1106=$2;
      _flush_pending($1106);
      var $1107=$2;
      var $1108=(($1107+16)|0);
      var $1109=HEAP32[(($1108)>>2)];
      var $1110=(($1109)|0)==0;
      if ($1110) { __label__ = 149; break; } else { __label__ = 150; break; }
    case 149: // $1111
      var $1112=$s;
      var $1113=(($1112+40)|0);
      HEAP32[(($1113)>>2)]=-1;
      $1=0;
      __label__ = 162; break;
    case 150: // $1114
      __label__ = 151; break;
    case 151: // $1115
      __label__ = 152; break;
    case 152: // $1116
      var $1117=$3;
      var $1118=(($1117)|0)!=4;
      if ($1118) { __label__ = 153; break; } else { __label__ = 154; break; }
    case 153: // $1119
      $1=0;
      __label__ = 162; break;
    case 154: // $1120
      var $1121=$s;
      var $1122=(($1121+24)|0);
      var $1123=HEAP32[(($1122)>>2)];
      var $1124=(($1123)|0) <= 0;
      if ($1124) { __label__ = 155; break; } else { __label__ = 156; break; }
    case 155: // $1125
      $1=1;
      __label__ = 162; break;
    case 156: // $1126
      var $1127=$s;
      var $1128=(($1127+24)|0);
      var $1129=HEAP32[(($1128)>>2)];
      var $1130=(($1129)|0)==2;
      if ($1130) { __label__ = 157; break; } else { __label__ = 158; break; }
    case 157: // $1131
      var $1132=$2;
      var $1133=(($1132+48)|0);
      var $1134=HEAP32[(($1133)>>2)];
      var $1135=$1134 & 255;
      var $1136=(($1135) & 255);
      var $1137=$s;
      var $1138=(($1137+20)|0);
      var $1139=HEAP32[(($1138)>>2)];
      var $1140=(($1139+1)|0);
      HEAP32[(($1138)>>2)]=$1140;
      var $1141=$s;
      var $1142=(($1141+8)|0);
      var $1143=HEAP32[(($1142)>>2)];
      var $1144=(($1143+$1139)|0);
      HEAP8[($1144)]=$1136;
      var $1145=$2;
      var $1146=(($1145+48)|0);
      var $1147=HEAPU32[(($1146)>>2)];
      var $1148=$1147 >>> 8;
      var $1149=$1148 & 255;
      var $1150=(($1149) & 255);
      var $1151=$s;
      var $1152=(($1151+20)|0);
      var $1153=HEAPU32[(($1152)>>2)];
      var $1154=(($1153+1)|0);
      HEAP32[(($1152)>>2)]=$1154;
      var $1155=$s;
      var $1156=(($1155+8)|0);
      var $1157=HEAP32[(($1156)>>2)];
      var $1158=(($1157+$1153)|0);
      HEAP8[($1158)]=$1150;
      var $1159=$2;
      var $1160=(($1159+48)|0);
      var $1161=HEAPU32[(($1160)>>2)];
      var $1162=$1161 >>> 16;
      var $1163=$1162 & 255;
      var $1164=(($1163) & 255);
      var $1165=$s;
      var $1166=(($1165+20)|0);
      var $1167=HEAPU32[(($1166)>>2)];
      var $1168=(($1167+1)|0);
      HEAP32[(($1166)>>2)]=$1168;
      var $1169=$s;
      var $1170=(($1169+8)|0);
      var $1171=HEAP32[(($1170)>>2)];
      var $1172=(($1171+$1167)|0);
      HEAP8[($1172)]=$1164;
      var $1173=$2;
      var $1174=(($1173+48)|0);
      var $1175=HEAPU32[(($1174)>>2)];
      var $1176=$1175 >>> 24;
      var $1177=$1176 & 255;
      var $1178=(($1177) & 255);
      var $1179=$s;
      var $1180=(($1179+20)|0);
      var $1181=HEAPU32[(($1180)>>2)];
      var $1182=(($1181+1)|0);
      HEAP32[(($1180)>>2)]=$1182;
      var $1183=$s;
      var $1184=(($1183+8)|0);
      var $1185=HEAP32[(($1184)>>2)];
      var $1186=(($1185+$1181)|0);
      HEAP8[($1186)]=$1178;
      var $1187=$2;
      var $1188=(($1187+8)|0);
      var $1189=HEAP32[(($1188)>>2)];
      var $1190=$1189 & 255;
      var $1191=(($1190) & 255);
      var $1192=$s;
      var $1193=(($1192+20)|0);
      var $1194=HEAP32[(($1193)>>2)];
      var $1195=(($1194+1)|0);
      HEAP32[(($1193)>>2)]=$1195;
      var $1196=$s;
      var $1197=(($1196+8)|0);
      var $1198=HEAP32[(($1197)>>2)];
      var $1199=(($1198+$1194)|0);
      HEAP8[($1199)]=$1191;
      var $1200=$2;
      var $1201=(($1200+8)|0);
      var $1202=HEAPU32[(($1201)>>2)];
      var $1203=$1202 >>> 8;
      var $1204=$1203 & 255;
      var $1205=(($1204) & 255);
      var $1206=$s;
      var $1207=(($1206+20)|0);
      var $1208=HEAPU32[(($1207)>>2)];
      var $1209=(($1208+1)|0);
      HEAP32[(($1207)>>2)]=$1209;
      var $1210=$s;
      var $1211=(($1210+8)|0);
      var $1212=HEAP32[(($1211)>>2)];
      var $1213=(($1212+$1208)|0);
      HEAP8[($1213)]=$1205;
      var $1214=$2;
      var $1215=(($1214+8)|0);
      var $1216=HEAPU32[(($1215)>>2)];
      var $1217=$1216 >>> 16;
      var $1218=$1217 & 255;
      var $1219=(($1218) & 255);
      var $1220=$s;
      var $1221=(($1220+20)|0);
      var $1222=HEAPU32[(($1221)>>2)];
      var $1223=(($1222+1)|0);
      HEAP32[(($1221)>>2)]=$1223;
      var $1224=$s;
      var $1225=(($1224+8)|0);
      var $1226=HEAP32[(($1225)>>2)];
      var $1227=(($1226+$1222)|0);
      HEAP8[($1227)]=$1219;
      var $1228=$2;
      var $1229=(($1228+8)|0);
      var $1230=HEAPU32[(($1229)>>2)];
      var $1231=$1230 >>> 24;
      var $1232=$1231 & 255;
      var $1233=(($1232) & 255);
      var $1234=$s;
      var $1235=(($1234+20)|0);
      var $1236=HEAPU32[(($1235)>>2)];
      var $1237=(($1236+1)|0);
      HEAP32[(($1235)>>2)]=$1237;
      var $1238=$s;
      var $1239=(($1238+8)|0);
      var $1240=HEAP32[(($1239)>>2)];
      var $1241=(($1240+$1236)|0);
      HEAP8[($1241)]=$1233;
      __label__ = 159; break;
    case 158: // $1242
      var $1243=$s;
      var $1244=$2;
      var $1245=(($1244+48)|0);
      var $1246=HEAPU32[(($1245)>>2)];
      var $1247=$1246 >>> 16;
      _putShortMSB($1243, $1247);
      var $1248=$s;
      var $1249=$2;
      var $1250=(($1249+48)|0);
      var $1251=HEAP32[(($1250)>>2)];
      var $1252=$1251 & 65535;
      _putShortMSB($1248, $1252);
      __label__ = 159; break;
    case 159: // $1253
      var $1254=$2;
      _flush_pending($1254);
      var $1255=$s;
      var $1256=(($1255+24)|0);
      var $1257=HEAP32[(($1256)>>2)];
      var $1258=(($1257)|0) > 0;
      if ($1258) { __label__ = 160; break; } else { __label__ = 161; break; }
    case 160: // $1259
      var $1260=$s;
      var $1261=(($1260+24)|0);
      var $1262=HEAP32[(($1261)>>2)];
      var $1263=(((-$1262))|0);
      var $1264=$s;
      var $1265=(($1264+24)|0);
      HEAP32[(($1265)>>2)]=$1263;
      __label__ = 161; break;
    case 161: // $1266
      var $1267=$s;
      var $1268=(($1267+20)|0);
      var $1269=HEAP32[(($1268)>>2)];
      var $1270=(($1269)|0)!=0;
      var $1271=$1270 ? 0 : 1;
      $1=$1271;
      __label__ = 162; break;
    case 162: // $1272
      var $1273=$1;
      ;
      return $1273;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflate["X"]=1;

function _putShortMSB($s, $b) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$s;
  $2=$b;
  var $3=$2;
  var $4=$3 >>> 8;
  var $5=(($4) & 255);
  var $6=$1;
  var $7=(($6+20)|0);
  var $8=HEAPU32[(($7)>>2)];
  var $9=(($8+1)|0);
  HEAP32[(($7)>>2)]=$9;
  var $10=$1;
  var $11=(($10+8)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=(($12+$8)|0);
  HEAP8[($13)]=$5;
  var $14=$2;
  var $15=$14 & 255;
  var $16=(($15) & 255);
  var $17=$1;
  var $18=(($17+20)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=(($19+1)|0);
  HEAP32[(($18)>>2)]=$20;
  var $21=$1;
  var $22=(($21+8)|0);
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+$19)|0);
  HEAP8[($24)]=$16;
  ;
  return;
}


function _flush_pending($strm) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $len;
      $1=$strm;
      var $2=$1;
      var $3=(($2+28)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4+20)|0);
      var $6=HEAP32[(($5)>>2)];
      $len=$6;
      var $7=$len;
      var $8=$1;
      var $9=(($8+16)|0);
      var $10=HEAPU32[(($9)>>2)];
      var $11=(($7)>>>0) > (($10)>>>0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$1;
      var $14=(($13+16)|0);
      var $15=HEAP32[(($14)>>2)];
      $len=$15;
      __label__ = 2; break;
    case 2: // $16
      var $17=$len;
      var $18=(($17)|0)==0;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      __label__ = 6; break;
    case 4: // $20
      var $21=$1;
      var $22=(($21+12)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=$1;
      var $25=(($24+28)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$len;
      assert($29 % 1 === 0, 'memcpy given ' + $29 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($23, $28, $29, 1);
      var $30=$len;
      var $31=$1;
      var $32=(($31+12)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$30)|0);
      HEAP32[(($32)>>2)]=$34;
      var $35=$len;
      var $36=$1;
      var $37=(($36+28)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+16)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40+$35)|0);
      HEAP32[(($39)>>2)]=$41;
      var $42=$len;
      var $43=$1;
      var $44=(($43+20)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+$42)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$len;
      var $48=$1;
      var $49=(($48+16)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50-$47)|0);
      HEAP32[(($49)>>2)]=$51;
      var $52=$len;
      var $53=$1;
      var $54=(($53+28)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+20)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57-$52)|0);
      HEAP32[(($56)>>2)]=$58;
      var $59=$1;
      var $60=(($59+28)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+20)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      if ($64) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $65
      var $66=$1;
      var $67=(($66+28)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+8)|0);
      var $70=HEAP32[(($69)>>2)];
      var $71=$1;
      var $72=(($71+28)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+16)|0);
      HEAP32[(($74)>>2)]=$70;
      __label__ = 6; break;
    case 6: // $75
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_flush_pending["X"]=1;

function _deflate_stored($s, $flush) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $max_block_size;
      var $max_start;
      $2=$s;
      $3=$flush;
      $max_block_size=65535;
      var $4=$max_block_size;
      var $5=$2;
      var $6=(($5+12)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7-5)|0);
      var $9=(($4)>>>0) > (($8)>>>0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=(($11+12)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-5)|0);
      $max_block_size=$14;
      __label__ = 2; break;
    case 2: // $15
      __label__ = 3; break;
    case 3: // $16
      var $17=$2;
      var $18=(($17+116)|0);
      var $19=HEAPU32[(($18)>>2)];
      var $20=(($19)>>>0) <= 1;
      if ($20) { __label__ = 4; break; } else { __label__ = 10; break; }
    case 4: // $21
      var $22=$2;
      _fill_window($22);
      var $23=$2;
      var $24=(($23+116)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $27
      var $28=$3;
      var $29=(($28)|0)==0;
      if ($29) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $30
      $1=0;
      __label__ = 32; break;
    case 7: // $31
      var $32=$2;
      var $33=(($32+116)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34)|0)==0;
      if ($35) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $36
      __label__ = 26; break;
    case 9: // $37
      __label__ = 10; break;
    case 10: // $38
      var $39=$2;
      var $40=(($39+116)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$2;
      var $43=(($42+108)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=(($44+$41)|0);
      HEAP32[(($43)>>2)]=$45;
      var $46=$2;
      var $47=(($46+116)|0);
      HEAP32[(($47)>>2)]=0;
      var $48=$2;
      var $49=(($48+92)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$max_block_size;
      var $52=(($50+$51)|0);
      $max_start=$52;
      var $53=$2;
      var $54=(($53+108)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)==0;
      if ($56) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $57
      var $58=$2;
      var $59=(($58+108)|0);
      var $60=HEAPU32[(($59)>>2)];
      var $61=$max_start;
      var $62=(($60)>>>0) >= (($61)>>>0);
      if ($62) { __label__ = 12; break; } else { __label__ = 18; break; }
    case 12: // $63
      var $64=$2;
      var $65=(($64+108)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$max_start;
      var $68=(($66-$67)|0);
      var $69=$2;
      var $70=(($69+116)|0);
      HEAP32[(($70)>>2)]=$68;
      var $71=$max_start;
      var $72=$2;
      var $73=(($72+108)|0);
      HEAP32[(($73)>>2)]=$71;
      var $74=$2;
      var $75=$2;
      var $76=(($75+92)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0) >= 0;
      if ($78) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $79
      var $80=$2;
      var $81=(($80+92)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$2;
      var $84=(($83+56)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85+$82)|0);
      var $89 = $86;__label__ = 15; break;
    case 14: // $87
      var $89 = 0;__label__ = 15; break;
    case 15: // $88
      var $89;
      var $90=$2;
      var $91=(($90+108)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$2;
      var $94=(($93+92)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=(($92-$95)|0);
      __tr_flush_block($74, $89, $96, 0);
      var $97=$2;
      var $98=(($97+108)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=$2;
      var $101=(($100+92)|0);
      HEAP32[(($101)>>2)]=$99;
      var $102=$2;
      var $103=(($102)|0);
      var $104=HEAP32[(($103)>>2)];
      _flush_pending($104);
      var $105=$2;
      var $106=(($105)|0);
      var $107=HEAP32[(($106)>>2)];
      var $108=(($107+16)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109)|0)==0;
      if ($110) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $111
      $1=0;
      __label__ = 32; break;
    case 17: // $112
      __label__ = 18; break;
    case 18: // $113
      var $114=$2;
      var $115=(($114+108)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$2;
      var $118=(($117+92)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($116-$119)|0);
      var $121=$2;
      var $122=(($121+44)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123-262)|0);
      var $125=(($120)>>>0) >= (($124)>>>0);
      if ($125) { __label__ = 19; break; } else { __label__ = 25; break; }
    case 19: // $126
      var $127=$2;
      var $128=$2;
      var $129=(($128+92)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130)|0) >= 0;
      if ($131) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $132
      var $133=$2;
      var $134=(($133+92)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$2;
      var $137=(($136+56)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138+$135)|0);
      var $142 = $139;__label__ = 22; break;
    case 21: // $140
      var $142 = 0;__label__ = 22; break;
    case 22: // $141
      var $142;
      var $143=$2;
      var $144=(($143+108)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$2;
      var $147=(($146+92)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($145-$148)|0);
      __tr_flush_block($127, $142, $149, 0);
      var $150=$2;
      var $151=(($150+108)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$2;
      var $154=(($153+92)|0);
      HEAP32[(($154)>>2)]=$152;
      var $155=$2;
      var $156=(($155)|0);
      var $157=HEAP32[(($156)>>2)];
      _flush_pending($157);
      var $158=$2;
      var $159=(($158)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($160+16)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162)|0)==0;
      if ($163) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $164
      $1=0;
      __label__ = 32; break;
    case 24: // $165
      __label__ = 25; break;
    case 25: // $166
      __label__ = 3; break;
    case 26: // $167
      var $168=$2;
      var $169=$2;
      var $170=(($169+92)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171)|0) >= 0;
      if ($172) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $173
      var $174=$2;
      var $175=(($174+92)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=$2;
      var $178=(($177+56)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+$176)|0);
      var $183 = $180;__label__ = 29; break;
    case 28: // $181
      var $183 = 0;__label__ = 29; break;
    case 29: // $182
      var $183;
      var $184=$2;
      var $185=(($184+108)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$2;
      var $188=(($187+92)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($186-$189)|0);
      var $191=$3;
      var $192=(($191)|0)==4;
      var $193=(($192)&1);
      __tr_flush_block($168, $183, $190, $193);
      var $194=$2;
      var $195=(($194+108)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=$2;
      var $198=(($197+92)|0);
      HEAP32[(($198)>>2)]=$196;
      var $199=$2;
      var $200=(($199)|0);
      var $201=HEAP32[(($200)>>2)];
      _flush_pending($201);
      var $202=$2;
      var $203=(($202)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=(($204+16)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206)|0)==0;
      if ($207) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $208
      var $209=$3;
      var $210=(($209)|0)==4;
      var $211=$210 ? 2 : 0;
      $1=$211;
      __label__ = 32; break;
    case 31: // $212
      var $213=$3;
      var $214=(($213)|0)==4;
      var $215=$214 ? 3 : 1;
      $1=$215;
      __label__ = 32; break;
    case 32: // $216
      var $217=$1;
      ;
      return $217;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflate_stored["X"]=1;

function _deflate_fast($s, $flush) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $hash_head;
      var $bflush;
      var $len;
      var $dist;
      var $cc;
      $2=$s;
      $3=$flush;
      $hash_head=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5+116)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=(($7)>>>0) < 262;
      if ($8) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      var $10=$2;
      _fill_window($10);
      var $11=$2;
      var $12=(($11+116)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($13)>>>0) < 262;
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$3;
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      $1=0;
      __label__ = 47; break;
    case 5: // $19
      var $20=$2;
      var $21=(($20+116)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $24
      __label__ = 41; break;
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=$2;
      var $28=(($27+116)|0);
      var $29=HEAPU32[(($28)>>2)];
      var $30=(($29)>>>0) >= 3;
      if ($30) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $31
      var $32=$2;
      var $33=(($32+72)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$2;
      var $36=(($35+88)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$34 << $37;
      var $39=$2;
      var $40=(($39+108)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+2)|0);
      var $43=$2;
      var $44=(($43+56)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+$42)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$38 ^ $48;
      var $50=$2;
      var $51=(($50+84)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$49 & $52;
      var $54=$2;
      var $55=(($54+72)|0);
      HEAP32[(($55)>>2)]=$53;
      var $56=$2;
      var $57=(($56+72)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$2;
      var $60=(($59+68)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+($58<<1))|0);
      var $63=HEAPU16[(($62)>>1)];
      var $64=$2;
      var $65=(($64+108)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$2;
      var $68=(($67+52)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$66 & $69;
      var $71=$2;
      var $72=(($71+64)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+($70<<1))|0);
      HEAP16[(($74)>>1)]=$63;
      var $75=(($63)&65535);
      $hash_head=$75;
      var $76=$2;
      var $77=(($76+108)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78) & 65535);
      var $80=$2;
      var $81=(($80+72)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$2;
      var $84=(($83+68)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85+($82<<1))|0);
      HEAP16[(($86)>>1)]=$79;
      __label__ = 10; break;
    case 10: // $87
      var $88=$hash_head;
      var $89=(($88)|0)!=0;
      if ($89) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $90
      var $91=$2;
      var $92=(($91+108)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$hash_head;
      var $95=(($93-$94)|0);
      var $96=$2;
      var $97=(($96+44)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98-262)|0);
      var $100=(($95)>>>0) <= (($99)>>>0);
      if ($100) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $101
      var $102=$2;
      var $103=(($102+136)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104)|0)!=2;
      if ($105) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $106
      var $107=$2;
      var $108=(($107+136)|0);
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109)|0)!=3;
      if ($110) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $111
      var $112=$2;
      var $113=$hash_head;
      var $114=_longest_match($112, $113);
      var $115=$2;
      var $116=(($115+96)|0);
      HEAP32[(($116)>>2)]=$114;
      __label__ = 19; break;
    case 15: // $117
      var $118=$2;
      var $119=(($118+136)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120)|0)==3;
      if ($121) { __label__ = 16; break; } else { __label__ = 18; break; }
    case 16: // $122
      var $123=$2;
      var $124=(($123+108)|0);
      var $125=HEAP32[(($124)>>2)];
      var $126=$hash_head;
      var $127=(($125-$126)|0);
      var $128=(($127)|0)==1;
      if ($128) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $129
      var $130=$2;
      var $131=$hash_head;
      var $132=_longest_match_fast($130, $131);
      var $133=$2;
      var $134=(($133+96)|0);
      HEAP32[(($134)>>2)]=$132;
      __label__ = 18; break;
    case 18: // $135
      __label__ = 19; break;
    case 19: // $136
      __label__ = 20; break;
    case 20: // $137
      var $138=$2;
      var $139=(($138+96)|0);
      var $140=HEAPU32[(($139)>>2)];
      var $141=(($140)>>>0) >= 3;
      if ($141) { __label__ = 21; break; } else { __label__ = 32; break; }
    case 21: // $142
      var $143=$2;
      var $144=(($143+96)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145-3)|0);
      var $147=(($146) & 255);
      $len=$147;
      var $148=$2;
      var $149=(($148+108)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$2;
      var $152=(($151+112)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($150-$153)|0);
      var $155=(($154) & 65535);
      $dist=$155;
      var $156=$dist;
      var $157=$2;
      var $158=(($157+5792)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=$2;
      var $161=(($160+5796)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+($159<<1))|0);
      HEAP16[(($163)>>1)]=$156;
      var $164=$len;
      var $165=$2;
      var $166=(($165+5792)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=(($167+1)|0);
      HEAP32[(($166)>>2)]=$168;
      var $169=$2;
      var $170=(($169+5784)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171+$167)|0);
      HEAP8[($172)]=$164;
      var $173=$dist;
      var $174=(($173-1)&65535);
      $dist=$174;
      var $175=$len;
      var $176=(($175)&255);
      var $177=(((STRING_TABLE.__length_code)+$176)|0);
      var $178=HEAPU8[($177)];
      var $179=(($178)&255);
      var $180=(($179+256)|0);
      var $181=(($180+1)|0);
      var $182=$2;
      var $183=(($182+148)|0);
      var $184=(($183+($181<<2))|0);
      var $185=(($184)|0);
      var $186=$185;
      var $187=HEAP16[(($186)>>1)];
      var $188=(($187+1)&65535);
      HEAP16[(($186)>>1)]=$188;
      var $189=$dist;
      var $190=(($189)&65535);
      var $191=(($190)|0) < 256;
      if ($191) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $192
      var $193=$dist;
      var $194=(($193)&65535);
      var $195=(((STRING_TABLE.__dist_code)+$194)|0);
      var $196=HEAPU8[($195)];
      var $197=(($196)&255);
      var $207 = $197;__label__ = 24; break;
    case 23: // $198
      var $199=$dist;
      var $200=(($199)&65535);
      var $201=$200 >> 7;
      var $202=(($201+256)|0);
      var $203=(((STRING_TABLE.__dist_code)+$202)|0);
      var $204=HEAPU8[($203)];
      var $205=(($204)&255);
      var $207 = $205;__label__ = 24; break;
    case 24: // $206
      var $207;
      var $208=$2;
      var $209=(($208+2440)|0);
      var $210=(($209+($207<<2))|0);
      var $211=(($210)|0);
      var $212=$211;
      var $213=HEAP16[(($212)>>1)];
      var $214=(($213+1)&65535);
      HEAP16[(($212)>>1)]=$214;
      var $215=$2;
      var $216=(($215+5792)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=$2;
      var $219=(($218+5788)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220-1)|0);
      var $222=(($217)|0)==(($221)|0);
      var $223=(($222)&1);
      $bflush=$223;
      var $224=$2;
      var $225=(($224+96)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$2;
      var $228=(($227+116)|0);
      var $229=HEAP32[(($228)>>2)];
      var $230=(($229-$226)|0);
      HEAP32[(($228)>>2)]=$230;
      var $231=$2;
      var $232=(($231+96)|0);
      var $233=HEAPU32[(($232)>>2)];
      var $234=$2;
      var $235=(($234+128)|0);
      var $236=HEAPU32[(($235)>>2)];
      var $237=(($233)>>>0) <= (($236)>>>0);
      if ($237) { __label__ = 25; break; } else { __label__ = 30; break; }
    case 25: // $238
      var $239=$2;
      var $240=(($239+116)|0);
      var $241=HEAPU32[(($240)>>2)];
      var $242=(($241)>>>0) >= 3;
      if ($242) { __label__ = 26; break; } else { __label__ = 30; break; }
    case 26: // $243
      var $244=$2;
      var $245=(($244+96)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246-1)|0);
      HEAP32[(($245)>>2)]=$247;
      __label__ = 27; break;
    case 27: // $248
      var $249=$2;
      var $250=(($249+108)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($251+1)|0);
      HEAP32[(($250)>>2)]=$252;
      var $253=$2;
      var $254=(($253+72)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$2;
      var $257=(($256+88)|0);
      var $258=HEAP32[(($257)>>2)];
      var $259=$255 << $258;
      var $260=$2;
      var $261=(($260+108)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=(($262+2)|0);
      var $264=$2;
      var $265=(($264+56)|0);
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266+$263)|0);
      var $268=HEAPU8[($267)];
      var $269=(($268)&255);
      var $270=$259 ^ $269;
      var $271=$2;
      var $272=(($271+84)|0);
      var $273=HEAP32[(($272)>>2)];
      var $274=$270 & $273;
      var $275=$2;
      var $276=(($275+72)|0);
      HEAP32[(($276)>>2)]=$274;
      var $277=$2;
      var $278=(($277+72)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=$2;
      var $281=(($280+68)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=(($282+($279<<1))|0);
      var $284=HEAPU16[(($283)>>1)];
      var $285=$2;
      var $286=(($285+108)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=$2;
      var $289=(($288+52)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=$287 & $290;
      var $292=$2;
      var $293=(($292+64)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294+($291<<1))|0);
      HEAP16[(($295)>>1)]=$284;
      var $296=(($284)&65535);
      $hash_head=$296;
      var $297=$2;
      var $298=(($297+108)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=(($299) & 65535);
      var $301=$2;
      var $302=(($301+72)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=$2;
      var $305=(($304+68)|0);
      var $306=HEAP32[(($305)>>2)];
      var $307=(($306+($303<<1))|0);
      HEAP16[(($307)>>1)]=$300;
      __label__ = 28; break;
    case 28: // $308
      var $309=$2;
      var $310=(($309+96)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(($311-1)|0);
      HEAP32[(($310)>>2)]=$312;
      var $313=(($312)|0)!=0;
      if ($313) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 29: // $314
      var $315=$2;
      var $316=(($315+108)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=(($317+1)|0);
      HEAP32[(($316)>>2)]=$318;
      __label__ = 31; break;
    case 30: // $319
      var $320=$2;
      var $321=(($320+96)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=$2;
      var $324=(($323+108)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($325+$322)|0);
      HEAP32[(($324)>>2)]=$326;
      var $327=$2;
      var $328=(($327+96)|0);
      HEAP32[(($328)>>2)]=0;
      var $329=$2;
      var $330=(($329+108)|0);
      var $331=HEAP32[(($330)>>2)];
      var $332=$2;
      var $333=(($332+56)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($334+$331)|0);
      var $336=HEAPU8[($335)];
      var $337=(($336)&255);
      var $338=$2;
      var $339=(($338+72)|0);
      HEAP32[(($339)>>2)]=$337;
      var $340=$2;
      var $341=(($340+72)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=$2;
      var $344=(($343+88)|0);
      var $345=HEAP32[(($344)>>2)];
      var $346=$342 << $345;
      var $347=$2;
      var $348=(($347+108)|0);
      var $349=HEAP32[(($348)>>2)];
      var $350=(($349+1)|0);
      var $351=$2;
      var $352=(($351+56)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($353+$350)|0);
      var $355=HEAPU8[($354)];
      var $356=(($355)&255);
      var $357=$346 ^ $356;
      var $358=$2;
      var $359=(($358+84)|0);
      var $360=HEAP32[(($359)>>2)];
      var $361=$357 & $360;
      var $362=$2;
      var $363=(($362+72)|0);
      HEAP32[(($363)>>2)]=$361;
      __label__ = 31; break;
    case 31: // $364
      __label__ = 33; break;
    case 32: // $365
      var $366=$2;
      var $367=(($366+108)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=$2;
      var $370=(($369+56)|0);
      var $371=HEAP32[(($370)>>2)];
      var $372=(($371+$368)|0);
      var $373=HEAP8[($372)];
      $cc=$373;
      var $374=$2;
      var $375=(($374+5792)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=$2;
      var $378=(($377+5796)|0);
      var $379=HEAP32[(($378)>>2)];
      var $380=(($379+($376<<1))|0);
      HEAP16[(($380)>>1)]=0;
      var $381=$cc;
      var $382=$2;
      var $383=(($382+5792)|0);
      var $384=HEAP32[(($383)>>2)];
      var $385=(($384+1)|0);
      HEAP32[(($383)>>2)]=$385;
      var $386=$2;
      var $387=(($386+5784)|0);
      var $388=HEAP32[(($387)>>2)];
      var $389=(($388+$384)|0);
      HEAP8[($389)]=$381;
      var $390=$cc;
      var $391=(($390)&255);
      var $392=$2;
      var $393=(($392+148)|0);
      var $394=(($393+($391<<2))|0);
      var $395=(($394)|0);
      var $396=$395;
      var $397=HEAP16[(($396)>>1)];
      var $398=(($397+1)&65535);
      HEAP16[(($396)>>1)]=$398;
      var $399=$2;
      var $400=(($399+5792)|0);
      var $401=HEAP32[(($400)>>2)];
      var $402=$2;
      var $403=(($402+5788)|0);
      var $404=HEAP32[(($403)>>2)];
      var $405=(($404-1)|0);
      var $406=(($401)|0)==(($405)|0);
      var $407=(($406)&1);
      $bflush=$407;
      var $408=$2;
      var $409=(($408+116)|0);
      var $410=HEAP32[(($409)>>2)];
      var $411=(($410-1)|0);
      HEAP32[(($409)>>2)]=$411;
      var $412=$2;
      var $413=(($412+108)|0);
      var $414=HEAP32[(($413)>>2)];
      var $415=(($414+1)|0);
      HEAP32[(($413)>>2)]=$415;
      __label__ = 33; break;
    case 33: // $416
      var $417=$bflush;
      var $418=(($417)|0)!=0;
      if ($418) { __label__ = 34; break; } else { __label__ = 40; break; }
    case 34: // $419
      var $420=$2;
      var $421=$2;
      var $422=(($421+92)|0);
      var $423=HEAP32[(($422)>>2)];
      var $424=(($423)|0) >= 0;
      if ($424) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $425
      var $426=$2;
      var $427=(($426+92)|0);
      var $428=HEAP32[(($427)>>2)];
      var $429=$2;
      var $430=(($429+56)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=(($431+$428)|0);
      var $435 = $432;__label__ = 37; break;
    case 36: // $433
      var $435 = 0;__label__ = 37; break;
    case 37: // $434
      var $435;
      var $436=$2;
      var $437=(($436+108)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=$2;
      var $440=(($439+92)|0);
      var $441=HEAP32[(($440)>>2)];
      var $442=(($438-$441)|0);
      __tr_flush_block($420, $435, $442, 0);
      var $443=$2;
      var $444=(($443+108)|0);
      var $445=HEAP32[(($444)>>2)];
      var $446=$2;
      var $447=(($446+92)|0);
      HEAP32[(($447)>>2)]=$445;
      var $448=$2;
      var $449=(($448)|0);
      var $450=HEAP32[(($449)>>2)];
      _flush_pending($450);
      var $451=$2;
      var $452=(($451)|0);
      var $453=HEAP32[(($452)>>2)];
      var $454=(($453+16)|0);
      var $455=HEAP32[(($454)>>2)];
      var $456=(($455)|0)==0;
      if ($456) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $457
      $1=0;
      __label__ = 47; break;
    case 39: // $458
      __label__ = 40; break;
    case 40: // $459
      __label__ = 1; break;
    case 41: // $460
      var $461=$2;
      var $462=$2;
      var $463=(($462+92)|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=(($464)|0) >= 0;
      if ($465) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $466
      var $467=$2;
      var $468=(($467+92)|0);
      var $469=HEAP32[(($468)>>2)];
      var $470=$2;
      var $471=(($470+56)|0);
      var $472=HEAP32[(($471)>>2)];
      var $473=(($472+$469)|0);
      var $476 = $473;__label__ = 44; break;
    case 43: // $474
      var $476 = 0;__label__ = 44; break;
    case 44: // $475
      var $476;
      var $477=$2;
      var $478=(($477+108)|0);
      var $479=HEAP32[(($478)>>2)];
      var $480=$2;
      var $481=(($480+92)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=(($479-$482)|0);
      var $484=$3;
      var $485=(($484)|0)==4;
      var $486=(($485)&1);
      __tr_flush_block($461, $476, $483, $486);
      var $487=$2;
      var $488=(($487+108)|0);
      var $489=HEAP32[(($488)>>2)];
      var $490=$2;
      var $491=(($490+92)|0);
      HEAP32[(($491)>>2)]=$489;
      var $492=$2;
      var $493=(($492)|0);
      var $494=HEAP32[(($493)>>2)];
      _flush_pending($494);
      var $495=$2;
      var $496=(($495)|0);
      var $497=HEAP32[(($496)>>2)];
      var $498=(($497+16)|0);
      var $499=HEAP32[(($498)>>2)];
      var $500=(($499)|0)==0;
      if ($500) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $501
      var $502=$3;
      var $503=(($502)|0)==4;
      var $504=$503 ? 2 : 0;
      $1=$504;
      __label__ = 47; break;
    case 46: // $505
      var $506=$3;
      var $507=(($506)|0)==4;
      var $508=$507 ? 3 : 1;
      $1=$508;
      __label__ = 47; break;
    case 47: // $509
      var $510=$1;
      ;
      return $510;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflate_fast["X"]=1;

function _deflate_slow($s, $flush) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $hash_head;
      var $bflush;
      var $max_insert;
      var $len;
      var $dist;
      var $cc;
      var $cc1;
      $2=$s;
      $3=$flush;
      $hash_head=0;
      __label__ = 1; break;
    case 1: // $4
      var $5=$2;
      var $6=(($5+116)|0);
      var $7=HEAPU32[(($6)>>2)];
      var $8=(($7)>>>0) < 262;
      if ($8) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $9
      var $10=$2;
      _fill_window($10);
      var $11=$2;
      var $12=(($11+116)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($13)>>>0) < 262;
      if ($14) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $15
      var $16=$3;
      var $17=(($16)|0)==0;
      if ($17) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $18
      $1=0;
      __label__ = 64; break;
    case 5: // $19
      var $20=$2;
      var $21=(($20+116)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22)|0)==0;
      if ($23) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $24
      __label__ = 56; break;
    case 7: // $25
      __label__ = 8; break;
    case 8: // $26
      var $27=$2;
      var $28=(($27+116)|0);
      var $29=HEAPU32[(($28)>>2)];
      var $30=(($29)>>>0) >= 3;
      if ($30) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $31
      var $32=$2;
      var $33=(($32+72)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$2;
      var $36=(($35+88)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$34 << $37;
      var $39=$2;
      var $40=(($39+108)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+2)|0);
      var $43=$2;
      var $44=(($43+56)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+$42)|0);
      var $47=HEAPU8[($46)];
      var $48=(($47)&255);
      var $49=$38 ^ $48;
      var $50=$2;
      var $51=(($50+84)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$49 & $52;
      var $54=$2;
      var $55=(($54+72)|0);
      HEAP32[(($55)>>2)]=$53;
      var $56=$2;
      var $57=(($56+72)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=$2;
      var $60=(($59+68)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61+($58<<1))|0);
      var $63=HEAPU16[(($62)>>1)];
      var $64=$2;
      var $65=(($64+108)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$2;
      var $68=(($67+52)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$66 & $69;
      var $71=$2;
      var $72=(($71+64)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+($70<<1))|0);
      HEAP16[(($74)>>1)]=$63;
      var $75=(($63)&65535);
      $hash_head=$75;
      var $76=$2;
      var $77=(($76+108)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78) & 65535);
      var $80=$2;
      var $81=(($80+72)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=$2;
      var $84=(($83+68)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($85+($82<<1))|0);
      HEAP16[(($86)>>1)]=$79;
      __label__ = 10; break;
    case 10: // $87
      var $88=$2;
      var $89=(($88+96)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$2;
      var $92=(($91+120)|0);
      HEAP32[(($92)>>2)]=$90;
      var $93=$2;
      var $94=(($93+112)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      var $97=(($96+100)|0);
      HEAP32[(($97)>>2)]=$95;
      var $98=$2;
      var $99=(($98+96)|0);
      HEAP32[(($99)>>2)]=2;
      var $100=$hash_head;
      var $101=(($100)|0)!=0;
      if ($101) { __label__ = 11; break; } else { __label__ = 26; break; }
    case 11: // $102
      var $103=$2;
      var $104=(($103+120)|0);
      var $105=HEAPU32[(($104)>>2)];
      var $106=$2;
      var $107=(($106+128)|0);
      var $108=HEAPU32[(($107)>>2)];
      var $109=(($105)>>>0) < (($108)>>>0);
      if ($109) { __label__ = 12; break; } else { __label__ = 26; break; }
    case 12: // $110
      var $111=$2;
      var $112=(($111+108)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$hash_head;
      var $115=(($113-$114)|0);
      var $116=$2;
      var $117=(($116+44)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118-262)|0);
      var $120=(($115)>>>0) <= (($119)>>>0);
      if ($120) { __label__ = 13; break; } else { __label__ = 26; break; }
    case 13: // $121
      var $122=$2;
      var $123=(($122+136)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124)|0)!=2;
      if ($125) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $126
      var $127=$2;
      var $128=(($127+136)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129)|0)!=3;
      if ($130) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $131
      var $132=$2;
      var $133=$hash_head;
      var $134=_longest_match($132, $133);
      var $135=$2;
      var $136=(($135+96)|0);
      HEAP32[(($136)>>2)]=$134;
      __label__ = 20; break;
    case 16: // $137
      var $138=$2;
      var $139=(($138+136)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140)|0)==3;
      if ($141) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $142
      var $143=$2;
      var $144=(($143+108)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$hash_head;
      var $147=(($145-$146)|0);
      var $148=(($147)|0)==1;
      if ($148) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $149
      var $150=$2;
      var $151=$hash_head;
      var $152=_longest_match_fast($150, $151);
      var $153=$2;
      var $154=(($153+96)|0);
      HEAP32[(($154)>>2)]=$152;
      __label__ = 19; break;
    case 19: // $155
      __label__ = 20; break;
    case 20: // $156
      var $157=$2;
      var $158=(($157+96)|0);
      var $159=HEAPU32[(($158)>>2)];
      var $160=(($159)>>>0) <= 5;
      if ($160) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $161
      var $162=$2;
      var $163=(($162+136)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164)|0)==1;
      if ($165) { __label__ = 24; break; } else { __label__ = 22; break; }
    case 22: // $166
      var $167=$2;
      var $168=(($167+96)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=(($169)|0)==3;
      if ($170) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $171
      var $172=$2;
      var $173=(($172+108)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=$2;
      var $176=(($175+112)|0);
      var $177=HEAP32[(($176)>>2)];
      var $178=(($174-$177)|0);
      var $179=(($178)>>>0) > 4096;
      if ($179) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $180
      var $181=$2;
      var $182=(($181+96)|0);
      HEAP32[(($182)>>2)]=2;
      __label__ = 25; break;
    case 25: // $183
      __label__ = 26; break;
    case 26: // $184
      var $185=$2;
      var $186=(($185+120)|0);
      var $187=HEAPU32[(($186)>>2)];
      var $188=(($187)>>>0) >= 3;
      if ($188) { __label__ = 27; break; } else { __label__ = 44; break; }
    case 27: // $189
      var $190=$2;
      var $191=(($190+96)|0);
      var $192=HEAPU32[(($191)>>2)];
      var $193=$2;
      var $194=(($193+120)|0);
      var $195=HEAPU32[(($194)>>2)];
      var $196=(($192)>>>0) <= (($195)>>>0);
      if ($196) { __label__ = 28; break; } else { __label__ = 44; break; }
    case 28: // $197
      var $198=$2;
      var $199=(($198+108)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=$2;
      var $202=(($201+116)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=(($200+$203)|0);
      var $205=(($204-3)|0);
      $max_insert=$205;
      var $206=$2;
      var $207=(($206+120)|0);
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208-3)|0);
      var $210=(($209) & 255);
      $len=$210;
      var $211=$2;
      var $212=(($211+108)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213-1)|0);
      var $215=$2;
      var $216=(($215+100)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(($214-$217)|0);
      var $219=(($218) & 65535);
      $dist=$219;
      var $220=$dist;
      var $221=$2;
      var $222=(($221+5792)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=$2;
      var $225=(($224+5796)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=(($226+($223<<1))|0);
      HEAP16[(($227)>>1)]=$220;
      var $228=$len;
      var $229=$2;
      var $230=(($229+5792)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231+1)|0);
      HEAP32[(($230)>>2)]=$232;
      var $233=$2;
      var $234=(($233+5784)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=(($235+$231)|0);
      HEAP8[($236)]=$228;
      var $237=$dist;
      var $238=(($237-1)&65535);
      $dist=$238;
      var $239=$len;
      var $240=(($239)&255);
      var $241=(((STRING_TABLE.__length_code)+$240)|0);
      var $242=HEAPU8[($241)];
      var $243=(($242)&255);
      var $244=(($243+256)|0);
      var $245=(($244+1)|0);
      var $246=$2;
      var $247=(($246+148)|0);
      var $248=(($247+($245<<2))|0);
      var $249=(($248)|0);
      var $250=$249;
      var $251=HEAP16[(($250)>>1)];
      var $252=(($251+1)&65535);
      HEAP16[(($250)>>1)]=$252;
      var $253=$dist;
      var $254=(($253)&65535);
      var $255=(($254)|0) < 256;
      if ($255) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $256
      var $257=$dist;
      var $258=(($257)&65535);
      var $259=(((STRING_TABLE.__dist_code)+$258)|0);
      var $260=HEAPU8[($259)];
      var $261=(($260)&255);
      var $271 = $261;__label__ = 31; break;
    case 30: // $262
      var $263=$dist;
      var $264=(($263)&65535);
      var $265=$264 >> 7;
      var $266=(($265+256)|0);
      var $267=(((STRING_TABLE.__dist_code)+$266)|0);
      var $268=HEAPU8[($267)];
      var $269=(($268)&255);
      var $271 = $269;__label__ = 31; break;
    case 31: // $270
      var $271;
      var $272=$2;
      var $273=(($272+2440)|0);
      var $274=(($273+($271<<2))|0);
      var $275=(($274)|0);
      var $276=$275;
      var $277=HEAP16[(($276)>>1)];
      var $278=(($277+1)&65535);
      HEAP16[(($276)>>1)]=$278;
      var $279=$2;
      var $280=(($279+5792)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=$2;
      var $283=(($282+5788)|0);
      var $284=HEAP32[(($283)>>2)];
      var $285=(($284-1)|0);
      var $286=(($281)|0)==(($285)|0);
      var $287=(($286)&1);
      $bflush=$287;
      var $288=$2;
      var $289=(($288+120)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290-1)|0);
      var $292=$2;
      var $293=(($292+116)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294-$291)|0);
      HEAP32[(($293)>>2)]=$295;
      var $296=$2;
      var $297=(($296+120)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(($298-2)|0);
      HEAP32[(($297)>>2)]=$299;
      __label__ = 32; break;
    case 32: // $300
      var $301=$2;
      var $302=(($301+108)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(($303+1)|0);
      HEAP32[(($302)>>2)]=$304;
      var $305=$max_insert;
      var $306=(($304)>>>0) <= (($305)>>>0);
      if ($306) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $307
      var $308=$2;
      var $309=(($308+72)|0);
      var $310=HEAP32[(($309)>>2)];
      var $311=$2;
      var $312=(($311+88)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=$310 << $313;
      var $315=$2;
      var $316=(($315+108)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=(($317+2)|0);
      var $319=$2;
      var $320=(($319+56)|0);
      var $321=HEAP32[(($320)>>2)];
      var $322=(($321+$318)|0);
      var $323=HEAPU8[($322)];
      var $324=(($323)&255);
      var $325=$314 ^ $324;
      var $326=$2;
      var $327=(($326+84)|0);
      var $328=HEAP32[(($327)>>2)];
      var $329=$325 & $328;
      var $330=$2;
      var $331=(($330+72)|0);
      HEAP32[(($331)>>2)]=$329;
      var $332=$2;
      var $333=(($332+72)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=$2;
      var $336=(($335+68)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=(($337+($334<<1))|0);
      var $339=HEAPU16[(($338)>>1)];
      var $340=$2;
      var $341=(($340+108)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=$2;
      var $344=(($343+52)|0);
      var $345=HEAP32[(($344)>>2)];
      var $346=$342 & $345;
      var $347=$2;
      var $348=(($347+64)|0);
      var $349=HEAP32[(($348)>>2)];
      var $350=(($349+($346<<1))|0);
      HEAP16[(($350)>>1)]=$339;
      var $351=(($339)&65535);
      $hash_head=$351;
      var $352=$2;
      var $353=(($352+108)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=(($354) & 65535);
      var $356=$2;
      var $357=(($356+72)|0);
      var $358=HEAP32[(($357)>>2)];
      var $359=$2;
      var $360=(($359+68)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($361+($358<<1))|0);
      HEAP16[(($362)>>1)]=$355;
      __label__ = 34; break;
    case 34: // $363
      __label__ = 35; break;
    case 35: // $364
      var $365=$2;
      var $366=(($365+120)|0);
      var $367=HEAP32[(($366)>>2)];
      var $368=(($367-1)|0);
      HEAP32[(($366)>>2)]=$368;
      var $369=(($368)|0)!=0;
      if ($369) { __label__ = 32; break; } else { __label__ = 36; break; }
    case 36: // $370
      var $371=$2;
      var $372=(($371+104)|0);
      HEAP32[(($372)>>2)]=0;
      var $373=$2;
      var $374=(($373+96)|0);
      HEAP32[(($374)>>2)]=2;
      var $375=$2;
      var $376=(($375+108)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=(($377+1)|0);
      HEAP32[(($376)>>2)]=$378;
      var $379=$bflush;
      var $380=(($379)|0)!=0;
      if ($380) { __label__ = 37; break; } else { __label__ = 43; break; }
    case 37: // $381
      var $382=$2;
      var $383=$2;
      var $384=(($383+92)|0);
      var $385=HEAP32[(($384)>>2)];
      var $386=(($385)|0) >= 0;
      if ($386) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $387
      var $388=$2;
      var $389=(($388+92)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=$2;
      var $392=(($391+56)|0);
      var $393=HEAP32[(($392)>>2)];
      var $394=(($393+$390)|0);
      var $397 = $394;__label__ = 40; break;
    case 39: // $395
      var $397 = 0;__label__ = 40; break;
    case 40: // $396
      var $397;
      var $398=$2;
      var $399=(($398+108)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=$2;
      var $402=(($401+92)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=(($400-$403)|0);
      __tr_flush_block($382, $397, $404, 0);
      var $405=$2;
      var $406=(($405+108)|0);
      var $407=HEAP32[(($406)>>2)];
      var $408=$2;
      var $409=(($408+92)|0);
      HEAP32[(($409)>>2)]=$407;
      var $410=$2;
      var $411=(($410)|0);
      var $412=HEAP32[(($411)>>2)];
      _flush_pending($412);
      var $413=$2;
      var $414=(($413)|0);
      var $415=HEAP32[(($414)>>2)];
      var $416=(($415+16)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=(($417)|0)==0;
      if ($418) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $419
      $1=0;
      __label__ = 64; break;
    case 42: // $420
      __label__ = 43; break;
    case 43: // $421
      __label__ = 55; break;
    case 44: // $422
      var $423=$2;
      var $424=(($423+104)|0);
      var $425=HEAP32[(($424)>>2)];
      var $426=(($425)|0)!=0;
      if ($426) { __label__ = 45; break; } else { __label__ = 53; break; }
    case 45: // $427
      var $428=$2;
      var $429=(($428+108)|0);
      var $430=HEAP32[(($429)>>2)];
      var $431=(($430-1)|0);
      var $432=$2;
      var $433=(($432+56)|0);
      var $434=HEAP32[(($433)>>2)];
      var $435=(($434+$431)|0);
      var $436=HEAP8[($435)];
      $cc=$436;
      var $437=$2;
      var $438=(($437+5792)|0);
      var $439=HEAP32[(($438)>>2)];
      var $440=$2;
      var $441=(($440+5796)|0);
      var $442=HEAP32[(($441)>>2)];
      var $443=(($442+($439<<1))|0);
      HEAP16[(($443)>>1)]=0;
      var $444=$cc;
      var $445=$2;
      var $446=(($445+5792)|0);
      var $447=HEAP32[(($446)>>2)];
      var $448=(($447+1)|0);
      HEAP32[(($446)>>2)]=$448;
      var $449=$2;
      var $450=(($449+5784)|0);
      var $451=HEAP32[(($450)>>2)];
      var $452=(($451+$447)|0);
      HEAP8[($452)]=$444;
      var $453=$cc;
      var $454=(($453)&255);
      var $455=$2;
      var $456=(($455+148)|0);
      var $457=(($456+($454<<2))|0);
      var $458=(($457)|0);
      var $459=$458;
      var $460=HEAP16[(($459)>>1)];
      var $461=(($460+1)&65535);
      HEAP16[(($459)>>1)]=$461;
      var $462=$2;
      var $463=(($462+5792)|0);
      var $464=HEAP32[(($463)>>2)];
      var $465=$2;
      var $466=(($465+5788)|0);
      var $467=HEAP32[(($466)>>2)];
      var $468=(($467-1)|0);
      var $469=(($464)|0)==(($468)|0);
      var $470=(($469)&1);
      $bflush=$470;
      var $471=$bflush;
      var $472=(($471)|0)!=0;
      if ($472) { __label__ = 46; break; } else { __label__ = 50; break; }
    case 46: // $473
      var $474=$2;
      var $475=$2;
      var $476=(($475+92)|0);
      var $477=HEAP32[(($476)>>2)];
      var $478=(($477)|0) >= 0;
      if ($478) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $479
      var $480=$2;
      var $481=(($480+92)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=$2;
      var $484=(($483+56)|0);
      var $485=HEAP32[(($484)>>2)];
      var $486=(($485+$482)|0);
      var $489 = $486;__label__ = 49; break;
    case 48: // $487
      var $489 = 0;__label__ = 49; break;
    case 49: // $488
      var $489;
      var $490=$2;
      var $491=(($490+108)|0);
      var $492=HEAP32[(($491)>>2)];
      var $493=$2;
      var $494=(($493+92)|0);
      var $495=HEAP32[(($494)>>2)];
      var $496=(($492-$495)|0);
      __tr_flush_block($474, $489, $496, 0);
      var $497=$2;
      var $498=(($497+108)|0);
      var $499=HEAP32[(($498)>>2)];
      var $500=$2;
      var $501=(($500+92)|0);
      HEAP32[(($501)>>2)]=$499;
      var $502=$2;
      var $503=(($502)|0);
      var $504=HEAP32[(($503)>>2)];
      _flush_pending($504);
      __label__ = 50; break;
    case 50: // $505
      var $506=$2;
      var $507=(($506+108)|0);
      var $508=HEAP32[(($507)>>2)];
      var $509=(($508+1)|0);
      HEAP32[(($507)>>2)]=$509;
      var $510=$2;
      var $511=(($510+116)|0);
      var $512=HEAP32[(($511)>>2)];
      var $513=(($512-1)|0);
      HEAP32[(($511)>>2)]=$513;
      var $514=$2;
      var $515=(($514)|0);
      var $516=HEAP32[(($515)>>2)];
      var $517=(($516+16)|0);
      var $518=HEAP32[(($517)>>2)];
      var $519=(($518)|0)==0;
      if ($519) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $520
      $1=0;
      __label__ = 64; break;
    case 52: // $521
      __label__ = 54; break;
    case 53: // $522
      var $523=$2;
      var $524=(($523+104)|0);
      HEAP32[(($524)>>2)]=1;
      var $525=$2;
      var $526=(($525+108)|0);
      var $527=HEAP32[(($526)>>2)];
      var $528=(($527+1)|0);
      HEAP32[(($526)>>2)]=$528;
      var $529=$2;
      var $530=(($529+116)|0);
      var $531=HEAP32[(($530)>>2)];
      var $532=(($531-1)|0);
      HEAP32[(($530)>>2)]=$532;
      __label__ = 54; break;
    case 54: // $533
      __label__ = 55; break;
    case 55: // $534
      __label__ = 1; break;
    case 56: // $535
      var $536=$2;
      var $537=(($536+104)|0);
      var $538=HEAP32[(($537)>>2)];
      var $539=(($538)|0)!=0;
      if ($539) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $540
      var $541=$2;
      var $542=(($541+108)|0);
      var $543=HEAP32[(($542)>>2)];
      var $544=(($543-1)|0);
      var $545=$2;
      var $546=(($545+56)|0);
      var $547=HEAP32[(($546)>>2)];
      var $548=(($547+$544)|0);
      var $549=HEAP8[($548)];
      $cc1=$549;
      var $550=$2;
      var $551=(($550+5792)|0);
      var $552=HEAP32[(($551)>>2)];
      var $553=$2;
      var $554=(($553+5796)|0);
      var $555=HEAP32[(($554)>>2)];
      var $556=(($555+($552<<1))|0);
      HEAP16[(($556)>>1)]=0;
      var $557=$cc1;
      var $558=$2;
      var $559=(($558+5792)|0);
      var $560=HEAP32[(($559)>>2)];
      var $561=(($560+1)|0);
      HEAP32[(($559)>>2)]=$561;
      var $562=$2;
      var $563=(($562+5784)|0);
      var $564=HEAP32[(($563)>>2)];
      var $565=(($564+$560)|0);
      HEAP8[($565)]=$557;
      var $566=$cc1;
      var $567=(($566)&255);
      var $568=$2;
      var $569=(($568+148)|0);
      var $570=(($569+($567<<2))|0);
      var $571=(($570)|0);
      var $572=$571;
      var $573=HEAP16[(($572)>>1)];
      var $574=(($573+1)&65535);
      HEAP16[(($572)>>1)]=$574;
      var $575=$2;
      var $576=(($575+5792)|0);
      var $577=HEAP32[(($576)>>2)];
      var $578=$2;
      var $579=(($578+5788)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=(($580-1)|0);
      var $582=(($577)|0)==(($581)|0);
      var $583=(($582)&1);
      $bflush=$583;
      var $584=$2;
      var $585=(($584+104)|0);
      HEAP32[(($585)>>2)]=0;
      __label__ = 58; break;
    case 58: // $586
      var $587=$2;
      var $588=$2;
      var $589=(($588+92)|0);
      var $590=HEAP32[(($589)>>2)];
      var $591=(($590)|0) >= 0;
      if ($591) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $592
      var $593=$2;
      var $594=(($593+92)|0);
      var $595=HEAP32[(($594)>>2)];
      var $596=$2;
      var $597=(($596+56)|0);
      var $598=HEAP32[(($597)>>2)];
      var $599=(($598+$595)|0);
      var $602 = $599;__label__ = 61; break;
    case 60: // $600
      var $602 = 0;__label__ = 61; break;
    case 61: // $601
      var $602;
      var $603=$2;
      var $604=(($603+108)|0);
      var $605=HEAP32[(($604)>>2)];
      var $606=$2;
      var $607=(($606+92)|0);
      var $608=HEAP32[(($607)>>2)];
      var $609=(($605-$608)|0);
      var $610=$3;
      var $611=(($610)|0)==4;
      var $612=(($611)&1);
      __tr_flush_block($587, $602, $609, $612);
      var $613=$2;
      var $614=(($613+108)|0);
      var $615=HEAP32[(($614)>>2)];
      var $616=$2;
      var $617=(($616+92)|0);
      HEAP32[(($617)>>2)]=$615;
      var $618=$2;
      var $619=(($618)|0);
      var $620=HEAP32[(($619)>>2)];
      _flush_pending($620);
      var $621=$2;
      var $622=(($621)|0);
      var $623=HEAP32[(($622)>>2)];
      var $624=(($623+16)|0);
      var $625=HEAP32[(($624)>>2)];
      var $626=(($625)|0)==0;
      if ($626) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $627
      var $628=$3;
      var $629=(($628)|0)==4;
      var $630=$629 ? 2 : 0;
      $1=$630;
      __label__ = 64; break;
    case 63: // $631
      var $632=$3;
      var $633=(($632)|0)==4;
      var $634=$633 ? 3 : 1;
      $1=$634;
      __label__ = 64; break;
    case 64: // $635
      var $636=$1;
      ;
      return $636;
    default: assert(0, "bad label: " + __label__);
  }
}
_deflate_slow["X"]=1;

function _longest_match($s, $cur_match) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $chain_length;
      var $scan;
      var $match;
      var $len;
      var $best_len;
      var $nice_match;
      var $limit;
      var $prev;
      var $wmask;
      var $strend;
      var $scan_end1;
      var $scan_end;
      $2=$s;
      $3=$cur_match;
      var $4=$2;
      var $5=(($4+124)|0);
      var $6=HEAP32[(($5)>>2)];
      $chain_length=$6;
      var $7=$2;
      var $8=(($7+56)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=$2;
      var $11=(($10+108)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($9+$12)|0);
      $scan=$13;
      var $14=$2;
      var $15=(($14+120)|0);
      var $16=HEAP32[(($15)>>2)];
      $best_len=$16;
      var $17=$2;
      var $18=(($17+144)|0);
      var $19=HEAP32[(($18)>>2)];
      $nice_match=$19;
      var $20=$2;
      var $21=(($20+108)|0);
      var $22=HEAPU32[(($21)>>2)];
      var $23=$2;
      var $24=(($23+44)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25-262)|0);
      var $27=(($22)>>>0) > (($26)>>>0);
      if ($27) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $28
      var $29=$2;
      var $30=(($29+108)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$2;
      var $33=(($32+44)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34-262)|0);
      var $36=(($31-$35)|0);
      var $39 = $36;__label__ = 3; break;
    case 2: // $37
      var $39 = 0;__label__ = 3; break;
    case 3: // $38
      var $39;
      $limit=$39;
      var $40=$2;
      var $41=(($40+64)|0);
      var $42=HEAP32[(($41)>>2)];
      $prev=$42;
      var $43=$2;
      var $44=(($43+52)|0);
      var $45=HEAP32[(($44)>>2)];
      $wmask=$45;
      var $46=$2;
      var $47=(($46+56)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$2;
      var $50=(($49+108)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($48+$51)|0);
      var $53=(($52+258)|0);
      $strend=$53;
      var $54=$best_len;
      var $55=(($54-1)|0);
      var $56=$scan;
      var $57=(($56+$55)|0);
      var $58=HEAP8[($57)];
      $scan_end1=$58;
      var $59=$best_len;
      var $60=$scan;
      var $61=(($60+$59)|0);
      var $62=HEAP8[($61)];
      $scan_end=$62;
      var $63=$2;
      var $64=(($63+120)|0);
      var $65=HEAPU32[(($64)>>2)];
      var $66=$2;
      var $67=(($66+140)|0);
      var $68=HEAPU32[(($67)>>2)];
      var $69=(($65)>>>0) >= (($68)>>>0);
      if ($69) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $70
      var $71=$chain_length;
      var $72=$71 >>> 2;
      $chain_length=$72;
      __label__ = 5; break;
    case 5: // $73
      var $74=$nice_match;
      var $75=$2;
      var $76=(($75+116)|0);
      var $77=HEAPU32[(($76)>>2)];
      var $78=(($74)>>>0) > (($77)>>>0);
      if ($78) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $79
      var $80=$2;
      var $81=(($80+116)|0);
      var $82=HEAP32[(($81)>>2)];
      $nice_match=$82;
      __label__ = 7; break;
    case 7: // $83
      __label__ = 8; break;
    case 8: // $84
      var $85=$2;
      var $86=(($85+56)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=$3;
      var $89=(($87+$88)|0);
      $match=$89;
      var $90=$best_len;
      var $91=$match;
      var $92=(($91+$90)|0);
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=$scan_end;
      var $96=(($95)&255);
      var $97=(($94)|0)!=(($96)|0);
      if ($97) { __label__ = 12; break; } else { __label__ = 9; break; }
    case 9: // $98
      var $99=$best_len;
      var $100=(($99-1)|0);
      var $101=$match;
      var $102=(($101+$100)|0);
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$scan_end1;
      var $106=(($105)&255);
      var $107=(($104)|0)!=(($106)|0);
      if ($107) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $108
      var $109=$match;
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$scan;
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=(($111)|0)!=(($114)|0);
      if ($115) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $116
      var $117=$match;
      var $118=(($117+1)|0);
      $match=$118;
      var $119=HEAPU8[($118)];
      var $120=(($119)&255);
      var $121=$scan;
      var $122=(($121+1)|0);
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=(($120)|0)!=(($124)|0);
      if ($125) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $126
      __label__ = 30; break;
    case 13: // $127
      var $128=$scan;
      var $129=(($128+2)|0);
      $scan=$129;
      var $130=$match;
      var $131=(($130+1)|0);
      $match=$131;
      __label__ = 14; break;
    case 14: // $132
      __label__ = 15; break;
    case 15: // $133
      var $134=$scan;
      var $135=(($134+1)|0);
      $scan=$135;
      var $136=HEAPU8[($135)];
      var $137=(($136)&255);
      var $138=$match;
      var $139=(($138+1)|0);
      $match=$139;
      var $140=HEAPU8[($139)];
      var $141=(($140)&255);
      var $142=(($137)|0)==(($141)|0);
      if ($142) { __label__ = 16; break; } else { var $218 = 0;__label__ = 24; break; }
    case 16: // $143
      var $144=$scan;
      var $145=(($144+1)|0);
      $scan=$145;
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$match;
      var $149=(($148+1)|0);
      $match=$149;
      var $150=HEAPU8[($149)];
      var $151=(($150)&255);
      var $152=(($147)|0)==(($151)|0);
      if ($152) { __label__ = 17; break; } else { var $218 = 0;__label__ = 24; break; }
    case 17: // $153
      var $154=$scan;
      var $155=(($154+1)|0);
      $scan=$155;
      var $156=HEAPU8[($155)];
      var $157=(($156)&255);
      var $158=$match;
      var $159=(($158+1)|0);
      $match=$159;
      var $160=HEAPU8[($159)];
      var $161=(($160)&255);
      var $162=(($157)|0)==(($161)|0);
      if ($162) { __label__ = 18; break; } else { var $218 = 0;__label__ = 24; break; }
    case 18: // $163
      var $164=$scan;
      var $165=(($164+1)|0);
      $scan=$165;
      var $166=HEAPU8[($165)];
      var $167=(($166)&255);
      var $168=$match;
      var $169=(($168+1)|0);
      $match=$169;
      var $170=HEAPU8[($169)];
      var $171=(($170)&255);
      var $172=(($167)|0)==(($171)|0);
      if ($172) { __label__ = 19; break; } else { var $218 = 0;__label__ = 24; break; }
    case 19: // $173
      var $174=$scan;
      var $175=(($174+1)|0);
      $scan=$175;
      var $176=HEAPU8[($175)];
      var $177=(($176)&255);
      var $178=$match;
      var $179=(($178+1)|0);
      $match=$179;
      var $180=HEAPU8[($179)];
      var $181=(($180)&255);
      var $182=(($177)|0)==(($181)|0);
      if ($182) { __label__ = 20; break; } else { var $218 = 0;__label__ = 24; break; }
    case 20: // $183
      var $184=$scan;
      var $185=(($184+1)|0);
      $scan=$185;
      var $186=HEAPU8[($185)];
      var $187=(($186)&255);
      var $188=$match;
      var $189=(($188+1)|0);
      $match=$189;
      var $190=HEAPU8[($189)];
      var $191=(($190)&255);
      var $192=(($187)|0)==(($191)|0);
      if ($192) { __label__ = 21; break; } else { var $218 = 0;__label__ = 24; break; }
    case 21: // $193
      var $194=$scan;
      var $195=(($194+1)|0);
      $scan=$195;
      var $196=HEAPU8[($195)];
      var $197=(($196)&255);
      var $198=$match;
      var $199=(($198+1)|0);
      $match=$199;
      var $200=HEAPU8[($199)];
      var $201=(($200)&255);
      var $202=(($197)|0)==(($201)|0);
      if ($202) { __label__ = 22; break; } else { var $218 = 0;__label__ = 24; break; }
    case 22: // $203
      var $204=$scan;
      var $205=(($204+1)|0);
      $scan=$205;
      var $206=HEAPU8[($205)];
      var $207=(($206)&255);
      var $208=$match;
      var $209=(($208+1)|0);
      $match=$209;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=(($207)|0)==(($211)|0);
      if ($212) { __label__ = 23; break; } else { var $218 = 0;__label__ = 24; break; }
    case 23: // $213
      var $214=$scan;
      var $215=$strend;
      var $216=(($214)>>>0) < (($215)>>>0);
      var $218 = $216;__label__ = 24; break;
    case 24: // $217
      var $218;
      if ($218) { __label__ = 14; break; } else { __label__ = 25; break; }
    case 25: // $219
      var $220=$strend;
      var $221=$scan;
      var $222=$220;
      var $223=$221;
      var $224=(($222-$223)|0);
      var $225=((258-$224)|0);
      $len=$225;
      var $226=$strend;
      var $227=(($226-258)|0);
      $scan=$227;
      var $228=$len;
      var $229=$best_len;
      var $230=(($228)|0) > (($229)|0);
      if ($230) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $231
      var $232=$3;
      var $233=$2;
      var $234=(($233+112)|0);
      HEAP32[(($234)>>2)]=$232;
      var $235=$len;
      $best_len=$235;
      var $236=$len;
      var $237=$nice_match;
      var $238=(($236)|0) >= (($237)|0);
      if ($238) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $239
      __label__ = 33; break;
    case 28: // $240
      var $241=$best_len;
      var $242=(($241-1)|0);
      var $243=$scan;
      var $244=(($243+$242)|0);
      var $245=HEAP8[($244)];
      $scan_end1=$245;
      var $246=$best_len;
      var $247=$scan;
      var $248=(($247+$246)|0);
      var $249=HEAP8[($248)];
      $scan_end=$249;
      __label__ = 29; break;
    case 29: // $250
      __label__ = 30; break;
    case 30: // $251
      var $252=$3;
      var $253=$wmask;
      var $254=$252 & $253;
      var $255=$prev;
      var $256=(($255+($254<<1))|0);
      var $257=HEAPU16[(($256)>>1)];
      var $258=(($257)&65535);
      $3=$258;
      var $259=$limit;
      var $260=(($258)>>>0) > (($259)>>>0);
      if ($260) { __label__ = 31; break; } else { var $266 = 0;__label__ = 32; break; }
    case 31: // $261
      var $262=$chain_length;
      var $263=(($262-1)|0);
      $chain_length=$263;
      var $264=(($263)|0)!=0;
      var $266 = $264;__label__ = 32; break;
    case 32: // $265
      var $266;
      if ($266) { __label__ = 8; break; } else { __label__ = 33; break; }
    case 33: // $267
      var $268=$best_len;
      var $269=$2;
      var $270=(($269+116)|0);
      var $271=HEAPU32[(($270)>>2)];
      var $272=(($268)>>>0) <= (($271)>>>0);
      if ($272) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $273
      var $274=$best_len;
      $1=$274;
      __label__ = 36; break;
    case 35: // $275
      var $276=$2;
      var $277=(($276+116)|0);
      var $278=HEAP32[(($277)>>2)];
      $1=$278;
      __label__ = 36; break;
    case 36: // $279
      var $280=$1;
      ;
      return $280;
    default: assert(0, "bad label: " + __label__);
  }
}
_longest_match["X"]=1;

function _longest_match_fast($s, $cur_match) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $scan;
      var $match;
      var $len;
      var $strend;
      $2=$s;
      $3=$cur_match;
      var $4=$2;
      var $5=(($4+56)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$2;
      var $8=(($7+108)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6+$9)|0);
      $scan=$10;
      var $11=$2;
      var $12=(($11+56)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$2;
      var $15=(($14+108)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($13+$16)|0);
      var $18=(($17+258)|0);
      $strend=$18;
      var $19=$2;
      var $20=(($19+56)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$3;
      var $23=(($21+$22)|0);
      $match=$23;
      var $24=$match;
      var $25=(($24)|0);
      var $26=HEAPU8[($25)];
      var $27=(($26)&255);
      var $28=$scan;
      var $29=(($28)|0);
      var $30=HEAPU8[($29)];
      var $31=(($30)&255);
      var $32=(($27)|0)!=(($31)|0);
      if ($32) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $33
      var $34=$match;
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=$scan;
      var $39=(($38+1)|0);
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=(($37)|0)!=(($41)|0);
      if ($42) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $43
      $1=2;
      __label__ = 21; break;
    case 3: // $44
      var $45=$scan;
      var $46=(($45+2)|0);
      $scan=$46;
      var $47=$match;
      var $48=(($47+2)|0);
      $match=$48;
      __label__ = 4; break;
    case 4: // $49
      __label__ = 5; break;
    case 5: // $50
      var $51=$scan;
      var $52=(($51+1)|0);
      $scan=$52;
      var $53=HEAPU8[($52)];
      var $54=(($53)&255);
      var $55=$match;
      var $56=(($55+1)|0);
      $match=$56;
      var $57=HEAPU8[($56)];
      var $58=(($57)&255);
      var $59=(($54)|0)==(($58)|0);
      if ($59) { __label__ = 6; break; } else { var $135 = 0;__label__ = 14; break; }
    case 6: // $60
      var $61=$scan;
      var $62=(($61+1)|0);
      $scan=$62;
      var $63=HEAPU8[($62)];
      var $64=(($63)&255);
      var $65=$match;
      var $66=(($65+1)|0);
      $match=$66;
      var $67=HEAPU8[($66)];
      var $68=(($67)&255);
      var $69=(($64)|0)==(($68)|0);
      if ($69) { __label__ = 7; break; } else { var $135 = 0;__label__ = 14; break; }
    case 7: // $70
      var $71=$scan;
      var $72=(($71+1)|0);
      $scan=$72;
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$match;
      var $76=(($75+1)|0);
      $match=$76;
      var $77=HEAPU8[($76)];
      var $78=(($77)&255);
      var $79=(($74)|0)==(($78)|0);
      if ($79) { __label__ = 8; break; } else { var $135 = 0;__label__ = 14; break; }
    case 8: // $80
      var $81=$scan;
      var $82=(($81+1)|0);
      $scan=$82;
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$match;
      var $86=(($85+1)|0);
      $match=$86;
      var $87=HEAPU8[($86)];
      var $88=(($87)&255);
      var $89=(($84)|0)==(($88)|0);
      if ($89) { __label__ = 9; break; } else { var $135 = 0;__label__ = 14; break; }
    case 9: // $90
      var $91=$scan;
      var $92=(($91+1)|0);
      $scan=$92;
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=$match;
      var $96=(($95+1)|0);
      $match=$96;
      var $97=HEAPU8[($96)];
      var $98=(($97)&255);
      var $99=(($94)|0)==(($98)|0);
      if ($99) { __label__ = 10; break; } else { var $135 = 0;__label__ = 14; break; }
    case 10: // $100
      var $101=$scan;
      var $102=(($101+1)|0);
      $scan=$102;
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$match;
      var $106=(($105+1)|0);
      $match=$106;
      var $107=HEAPU8[($106)];
      var $108=(($107)&255);
      var $109=(($104)|0)==(($108)|0);
      if ($109) { __label__ = 11; break; } else { var $135 = 0;__label__ = 14; break; }
    case 11: // $110
      var $111=$scan;
      var $112=(($111+1)|0);
      $scan=$112;
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=$match;
      var $116=(($115+1)|0);
      $match=$116;
      var $117=HEAPU8[($116)];
      var $118=(($117)&255);
      var $119=(($114)|0)==(($118)|0);
      if ($119) { __label__ = 12; break; } else { var $135 = 0;__label__ = 14; break; }
    case 12: // $120
      var $121=$scan;
      var $122=(($121+1)|0);
      $scan=$122;
      var $123=HEAPU8[($122)];
      var $124=(($123)&255);
      var $125=$match;
      var $126=(($125+1)|0);
      $match=$126;
      var $127=HEAPU8[($126)];
      var $128=(($127)&255);
      var $129=(($124)|0)==(($128)|0);
      if ($129) { __label__ = 13; break; } else { var $135 = 0;__label__ = 14; break; }
    case 13: // $130
      var $131=$scan;
      var $132=$strend;
      var $133=(($131)>>>0) < (($132)>>>0);
      var $135 = $133;__label__ = 14; break;
    case 14: // $134
      var $135;
      if ($135) { __label__ = 4; break; } else { __label__ = 15; break; }
    case 15: // $136
      var $137=$strend;
      var $138=$scan;
      var $139=$137;
      var $140=$138;
      var $141=(($139-$140)|0);
      var $142=((258-$141)|0);
      $len=$142;
      var $143=$len;
      var $144=(($143)|0) < 3;
      if ($144) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $145
      $1=2;
      __label__ = 21; break;
    case 17: // $146
      var $147=$3;
      var $148=$2;
      var $149=(($148+112)|0);
      HEAP32[(($149)>>2)]=$147;
      var $150=$len;
      var $151=$2;
      var $152=(($151+116)|0);
      var $153=HEAPU32[(($152)>>2)];
      var $154=(($150)>>>0) <= (($153)>>>0);
      if ($154) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $155
      var $156=$len;
      var $162 = $156;__label__ = 20; break;
    case 19: // $157
      var $158=$2;
      var $159=(($158+116)|0);
      var $160=HEAP32[(($159)>>2)];
      var $162 = $160;__label__ = 20; break;
    case 20: // $161
      var $162;
      $1=$162;
      __label__ = 21; break;
    case 21: // $163
      var $164=$1;
      ;
      return $164;
    default: assert(0, "bad label: " + __label__);
  }
}
_longest_match_fast["X"]=1;

function _fill_window($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $n;
      var $m;
      var $p;
      var $more;
      var $wsize;
      $1=$s;
      var $2=$1;
      var $3=(($2+44)|0);
      var $4=HEAP32[(($3)>>2)];
      $wsize=$4;
      __label__ = 1; break;
    case 1: // $5
      var $6=$1;
      var $7=(($6+60)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$1;
      var $10=(($9+116)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($8-$11)|0);
      var $13=$1;
      var $14=(($13+108)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12-$15)|0);
      $more=$16;
      var $17=$1;
      var $18=(($17+108)|0);
      var $19=HEAPU32[(($18)>>2)];
      var $20=$wsize;
      var $21=$1;
      var $22=(($21+44)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23-262)|0);
      var $25=(($20+$24)|0);
      var $26=(($19)>>>0) >= (($25)>>>0);
      if ($26) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $27
      var $28=$1;
      var $29=(($28+56)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=$1;
      var $32=(($31+56)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$wsize;
      var $35=(($33+$34)|0);
      var $36=$wsize;
      assert($36 % 1 === 0, 'memcpy given ' + $36 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($30, $35, $36, 1);
      var $37=$wsize;
      var $38=$1;
      var $39=(($38+112)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40-$37)|0);
      HEAP32[(($39)>>2)]=$41;
      var $42=$wsize;
      var $43=$1;
      var $44=(($43+108)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45-$42)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$wsize;
      var $48=$1;
      var $49=(($48+92)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=(($50-$47)|0);
      HEAP32[(($49)>>2)]=$51;
      var $52=$1;
      var $53=(($52+76)|0);
      var $54=HEAP32[(($53)>>2)];
      $n=$54;
      var $55=$n;
      var $56=$1;
      var $57=(($56+68)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58+($55<<1))|0);
      $p=$59;
      __label__ = 3; break;
    case 3: // $60
      var $61=$p;
      var $62=(($61-2)|0);
      $p=$62;
      var $63=HEAPU16[(($62)>>1)];
      var $64=(($63)&65535);
      $m=$64;
      var $65=$m;
      var $66=$wsize;
      var $67=(($65)>>>0) >= (($66)>>>0);
      if ($67) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $68
      var $69=$m;
      var $70=$wsize;
      var $71=(($69-$70)|0);
      var $74 = $71;__label__ = 6; break;
    case 5: // $72
      var $74 = 0;__label__ = 6; break;
    case 6: // $73
      var $74;
      var $75=(($74) & 65535);
      var $76=$p;
      HEAP16[(($76)>>1)]=$75;
      __label__ = 7; break;
    case 7: // $77
      var $78=$n;
      var $79=(($78-1)|0);
      $n=$79;
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 8: // $81
      var $82=$wsize;
      $n=$82;
      var $83=$n;
      var $84=$1;
      var $85=(($84+64)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+($83<<1))|0);
      $p=$87;
      __label__ = 9; break;
    case 9: // $88
      var $89=$p;
      var $90=(($89-2)|0);
      $p=$90;
      var $91=HEAPU16[(($90)>>1)];
      var $92=(($91)&65535);
      $m=$92;
      var $93=$m;
      var $94=$wsize;
      var $95=(($93)>>>0) >= (($94)>>>0);
      if ($95) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $96
      var $97=$m;
      var $98=$wsize;
      var $99=(($97-$98)|0);
      var $102 = $99;__label__ = 12; break;
    case 11: // $100
      var $102 = 0;__label__ = 12; break;
    case 12: // $101
      var $102;
      var $103=(($102) & 65535);
      var $104=$p;
      HEAP16[(($104)>>1)]=$103;
      __label__ = 13; break;
    case 13: // $105
      var $106=$n;
      var $107=(($106-1)|0);
      $n=$107;
      var $108=(($107)|0)!=0;
      if ($108) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 14: // $109
      var $110=$wsize;
      var $111=$more;
      var $112=(($111+$110)|0);
      $more=$112;
      __label__ = 15; break;
    case 15: // $113
      var $114=$1;
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116+4)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($118)|0)==0;
      if ($119) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $120
      __label__ = 23; break;
    case 17: // $121
      var $122=$1;
      var $123=(($122)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=$1;
      var $126=(($125+56)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=$1;
      var $129=(($128+108)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($127+$130)|0);
      var $132=$1;
      var $133=(($132+116)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=(($131+$134)|0);
      var $136=$more;
      var $137=_read_buf($124, $135, $136);
      $n=$137;
      var $138=$n;
      var $139=$1;
      var $140=(($139+116)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141+$138)|0);
      HEAP32[(($140)>>2)]=$142;
      var $143=$1;
      var $144=(($143+116)|0);
      var $145=HEAPU32[(($144)>>2)];
      var $146=(($145)>>>0) >= 3;
      if ($146) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $147
      var $148=$1;
      var $149=(($148+108)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$1;
      var $152=(($151+56)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153+$150)|0);
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$1;
      var $158=(($157+72)|0);
      HEAP32[(($158)>>2)]=$156;
      var $159=$1;
      var $160=(($159+72)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$1;
      var $163=(($162+88)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$161 << $164;
      var $166=$1;
      var $167=(($166+108)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+1)|0);
      var $170=$1;
      var $171=(($170+56)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172+$169)|0);
      var $174=HEAPU8[($173)];
      var $175=(($174)&255);
      var $176=$165 ^ $175;
      var $177=$1;
      var $178=(($177+84)|0);
      var $179=HEAP32[(($178)>>2)];
      var $180=$176 & $179;
      var $181=$1;
      var $182=(($181+72)|0);
      HEAP32[(($182)>>2)]=$180;
      __label__ = 19; break;
    case 19: // $183
      __label__ = 20; break;
    case 20: // $184
      var $185=$1;
      var $186=(($185+116)|0);
      var $187=HEAPU32[(($186)>>2)];
      var $188=(($187)>>>0) < 262;
      if ($188) { __label__ = 21; break; } else { var $197 = 0;__label__ = 22; break; }
    case 21: // $189
      var $190=$1;
      var $191=(($190)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+4)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194)|0)!=0;
      var $197 = $195;__label__ = 22; break;
    case 22: // $196
      var $197;
      if ($197) { __label__ = 1; break; } else { __label__ = 23; break; }
    case 23: // $198
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_fill_window["X"]=1;

function _read_buf($strm, $buf, $size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $len;
      $2=$strm;
      $3=$buf;
      $4=$size;
      var $5=$2;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      $len=$7;
      var $8=$len;
      var $9=$4;
      var $10=(($8)>>>0) > (($9)>>>0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      $len=$12;
      __label__ = 2; break;
    case 2: // $13
      var $14=$len;
      var $15=(($14)|0)==0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      $1=0;
      __label__ = 10; break;
    case 4: // $17
      var $18=$len;
      var $19=$2;
      var $20=(($19+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21-$18)|0);
      HEAP32[(($20)>>2)]=$22;
      var $23=$2;
      var $24=(($23+28)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($25+24)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)==1;
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $29
      var $30=$2;
      var $31=(($30+48)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$2;
      var $34=(($33)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=$len;
      var $37=_adler32($32, $35, $36);
      var $38=$2;
      var $39=(($38+48)|0);
      HEAP32[(($39)>>2)]=$37;
      __label__ = 9; break;
    case 6: // $40
      var $41=$2;
      var $42=(($41+28)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+24)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45)|0)==2;
      if ($46) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $47
      var $48=$2;
      var $49=(($48+48)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$2;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$len;
      var $55=_crc32($50, $53, $54);
      var $56=$2;
      var $57=(($56+48)|0);
      HEAP32[(($57)>>2)]=$55;
      __label__ = 8; break;
    case 8: // $58
      __label__ = 9; break;
    case 9: // $59
      var $60=$3;
      var $61=$2;
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=$len;
      assert($64 % 1 === 0, 'memcpy given ' + $64 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($60, $63, $64, 1);
      var $65=$len;
      var $66=$2;
      var $67=(($66)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+$65)|0);
      HEAP32[(($67)>>2)]=$69;
      var $70=$len;
      var $71=$2;
      var $72=(($71+8)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+$70)|0);
      HEAP32[(($72)>>2)]=$74;
      var $75=$len;
      $1=$75;
      __label__ = 10; break;
    case 10: // $76
      var $77=$1;
      ;
      return $77;
    default: assert(0, "bad label: " + __label__);
  }
}
_read_buf["X"]=1;

function _inflate_fast($strm, $start) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $state;
      var $in;
      var $last;
      var $out;
      var $beg;
      var $end;
      var $wsize;
      var $whave;
      var $write;
      var $window;
      var $hold;
      var $bits;
      var $lcode;
      var $dcode;
      var $lmask;
      var $dmask;
      var $this=__stackBase__;
      var $op;
      var $len;
      var $dist;
      var $from;
      $1=$strm;
      $2=$start;
      var $3=$1;
      var $4=(($3+28)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=$5;
      $state=$6;
      var $7=$1;
      var $8=(($7)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9-1)|0);
      $in=$10;
      var $11=$in;
      var $12=$1;
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14-5)|0);
      var $16=(($11+$15)|0);
      $last=$16;
      var $17=$1;
      var $18=(($17+12)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19-1)|0);
      $out=$20;
      var $21=$out;
      var $22=$2;
      var $23=$1;
      var $24=(($23+16)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=(($22-$25)|0);
      var $27=(((-$26))|0);
      var $28=(($21+$27)|0);
      $beg=$28;
      var $29=$out;
      var $30=$1;
      var $31=(($30+16)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32-257)|0);
      var $34=(($29+$33)|0);
      $end=$34;
      var $35=$state;
      var $36=(($35+40)|0);
      var $37=HEAP32[(($36)>>2)];
      $wsize=$37;
      var $38=$state;
      var $39=(($38+44)|0);
      var $40=HEAP32[(($39)>>2)];
      $whave=$40;
      var $41=$state;
      var $42=(($41+48)|0);
      var $43=HEAP32[(($42)>>2)];
      $write=$43;
      var $44=$state;
      var $45=(($44+52)|0);
      var $46=HEAP32[(($45)>>2)];
      $window=$46;
      var $47=$state;
      var $48=(($47+56)|0);
      var $49=HEAP32[(($48)>>2)];
      $hold=$49;
      var $50=$state;
      var $51=(($50+60)|0);
      var $52=HEAP32[(($51)>>2)];
      $bits=$52;
      var $53=$state;
      var $54=(($53+76)|0);
      var $55=HEAP32[(($54)>>2)];
      $lcode=$55;
      var $56=$state;
      var $57=(($56+80)|0);
      var $58=HEAP32[(($57)>>2)];
      $dcode=$58;
      var $59=$state;
      var $60=(($59+84)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=1 << $61;
      var $63=(($62-1)|0);
      $lmask=$63;
      var $64=$state;
      var $65=(($64+88)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=1 << $66;
      var $68=(($67-1)|0);
      $dmask=$68;
      __label__ = 1; break;
    case 1: // $69
      var $70=$bits;
      var $71=(($70)>>>0) < 15;
      if ($71) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $72
      var $73=$in;
      var $74=(($73+1)|0);
      $in=$74;
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=$bits;
      var $78=$76 << $77;
      var $79=$hold;
      var $80=(($79+$78)|0);
      $hold=$80;
      var $81=$bits;
      var $82=(($81+8)|0);
      $bits=$82;
      var $83=$in;
      var $84=(($83+1)|0);
      $in=$84;
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$bits;
      var $88=$86 << $87;
      var $89=$hold;
      var $90=(($89+$88)|0);
      $hold=$90;
      var $91=$bits;
      var $92=(($91+8)|0);
      $bits=$92;
      __label__ = 3; break;
    case 3: // $93
      var $94=$hold;
      var $95=$lmask;
      var $96=$94 & $95;
      var $97=$lcode;
      var $98=(($97+($96<<2))|0);
      var $99=$this;
      var $100=$98;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($99)>>1)]=HEAP16[(($100)>>1)];HEAP16[(($99+2)>>1)]=HEAP16[(($100+2)>>1)];
      __label__ = 4; break;
    case 4: // $101
      var $102=(($this+1)|0);
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      $op=$104;
      var $105=$op;
      var $106=$hold;
      var $107=$106 >>> (($105)>>>0);
      $hold=$107;
      var $108=$op;
      var $109=$bits;
      var $110=(($109-$108)|0);
      $bits=$110;
      var $111=(($this)|0);
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      $op=$113;
      var $114=$op;
      var $115=(($114)|0)==0;
      if ($115) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $116
      var $117=(($this+2)|0);
      var $118=HEAP16[(($117)>>1)];
      var $119=(($118) & 255);
      var $120=$out;
      var $121=(($120+1)|0);
      $out=$121;
      HEAP8[($121)]=$119;
      __label__ = 75; break;
    case 6: // $122
      var $123=$op;
      var $124=$123 & 16;
      var $125=(($124)|0)!=0;
      if ($125) { __label__ = 7; break; } else { __label__ = 69; break; }
    case 7: // $126
      var $127=(($this+2)|0);
      var $128=HEAPU16[(($127)>>1)];
      var $129=(($128)&65535);
      $len=$129;
      var $130=$op;
      var $131=$130 & 15;
      $op=$131;
      var $132=$op;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $134
      var $135=$bits;
      var $136=$op;
      var $137=(($135)>>>0) < (($136)>>>0);
      if ($137) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $138
      var $139=$in;
      var $140=(($139+1)|0);
      $in=$140;
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=$bits;
      var $144=$142 << $143;
      var $145=$hold;
      var $146=(($145+$144)|0);
      $hold=$146;
      var $147=$bits;
      var $148=(($147+8)|0);
      $bits=$148;
      __label__ = 10; break;
    case 10: // $149
      var $150=$hold;
      var $151=$op;
      var $152=1 << $151;
      var $153=(($152-1)|0);
      var $154=$150 & $153;
      var $155=$len;
      var $156=(($155+$154)|0);
      $len=$156;
      var $157=$op;
      var $158=$hold;
      var $159=$158 >>> (($157)>>>0);
      $hold=$159;
      var $160=$op;
      var $161=$bits;
      var $162=(($161-$160)|0);
      $bits=$162;
      __label__ = 11; break;
    case 11: // $163
      var $164=$bits;
      var $165=(($164)>>>0) < 15;
      if ($165) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $166
      var $167=$in;
      var $168=(($167+1)|0);
      $in=$168;
      var $169=HEAPU8[($168)];
      var $170=(($169)&255);
      var $171=$bits;
      var $172=$170 << $171;
      var $173=$hold;
      var $174=(($173+$172)|0);
      $hold=$174;
      var $175=$bits;
      var $176=(($175+8)|0);
      $bits=$176;
      var $177=$in;
      var $178=(($177+1)|0);
      $in=$178;
      var $179=HEAPU8[($178)];
      var $180=(($179)&255);
      var $181=$bits;
      var $182=$180 << $181;
      var $183=$hold;
      var $184=(($183+$182)|0);
      $hold=$184;
      var $185=$bits;
      var $186=(($185+8)|0);
      $bits=$186;
      __label__ = 13; break;
    case 13: // $187
      var $188=$hold;
      var $189=$dmask;
      var $190=$188 & $189;
      var $191=$dcode;
      var $192=(($191+($190<<2))|0);
      var $193=$this;
      var $194=$192;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($193)>>1)]=HEAP16[(($194)>>1)];HEAP16[(($193+2)>>1)]=HEAP16[(($194+2)>>1)];
      __label__ = 14; break;
    case 14: // $195
      var $196=(($this+1)|0);
      var $197=HEAPU8[($196)];
      var $198=(($197)&255);
      $op=$198;
      var $199=$op;
      var $200=$hold;
      var $201=$200 >>> (($199)>>>0);
      $hold=$201;
      var $202=$op;
      var $203=$bits;
      var $204=(($203-$202)|0);
      $bits=$204;
      var $205=(($this)|0);
      var $206=HEAPU8[($205)];
      var $207=(($206)&255);
      $op=$207;
      var $208=$op;
      var $209=$208 & 16;
      var $210=(($209)|0)!=0;
      if ($210) { __label__ = 15; break; } else { __label__ = 65; break; }
    case 15: // $211
      var $212=(($this+2)|0);
      var $213=HEAPU16[(($212)>>1)];
      var $214=(($213)&65535);
      $dist=$214;
      var $215=$op;
      var $216=$215 & 15;
      $op=$216;
      var $217=$bits;
      var $218=$op;
      var $219=(($217)>>>0) < (($218)>>>0);
      if ($219) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $220
      var $221=$in;
      var $222=(($221+1)|0);
      $in=$222;
      var $223=HEAPU8[($222)];
      var $224=(($223)&255);
      var $225=$bits;
      var $226=$224 << $225;
      var $227=$hold;
      var $228=(($227+$226)|0);
      $hold=$228;
      var $229=$bits;
      var $230=(($229+8)|0);
      $bits=$230;
      var $231=$bits;
      var $232=$op;
      var $233=(($231)>>>0) < (($232)>>>0);
      if ($233) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $234
      var $235=$in;
      var $236=(($235+1)|0);
      $in=$236;
      var $237=HEAPU8[($236)];
      var $238=(($237)&255);
      var $239=$bits;
      var $240=$238 << $239;
      var $241=$hold;
      var $242=(($241+$240)|0);
      $hold=$242;
      var $243=$bits;
      var $244=(($243+8)|0);
      $bits=$244;
      __label__ = 18; break;
    case 18: // $245
      __label__ = 19; break;
    case 19: // $246
      var $247=$hold;
      var $248=$op;
      var $249=1 << $248;
      var $250=(($249-1)|0);
      var $251=$247 & $250;
      var $252=$dist;
      var $253=(($252+$251)|0);
      $dist=$253;
      var $254=$op;
      var $255=$hold;
      var $256=$255 >>> (($254)>>>0);
      $hold=$256;
      var $257=$op;
      var $258=$bits;
      var $259=(($258-$257)|0);
      $bits=$259;
      var $260=$out;
      var $261=$beg;
      var $262=$260;
      var $263=$261;
      var $264=(($262-$263)|0);
      $op=$264;
      var $265=$dist;
      var $266=$op;
      var $267=(($265)>>>0) > (($266)>>>0);
      if ($267) { __label__ = 20; break; } else { __label__ = 56; break; }
    case 20: // $268
      var $269=$dist;
      var $270=$op;
      var $271=(($269-$270)|0);
      $op=$271;
      var $272=$op;
      var $273=$whave;
      var $274=(($272)>>>0) > (($273)>>>0);
      if ($274) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $275
      var $276=$1;
      var $277=(($276+24)|0);
      HEAP32[(($277)>>2)]=((STRING_TABLE.__str7639)|0);
      var $278=$state;
      var $279=(($278)|0);
      HEAP32[(($279)>>2)]=27;
      __label__ = 79; break;
    case 22: // $280
      var $281=$window;
      var $282=(($281-1)|0);
      $from=$282;
      var $283=$write;
      var $284=(($283)|0)==0;
      if ($284) { __label__ = 23; break; } else { __label__ = 29; break; }
    case 23: // $285
      var $286=$wsize;
      var $287=$op;
      var $288=(($286-$287)|0);
      var $289=$from;
      var $290=(($289+$288)|0);
      $from=$290;
      var $291=$op;
      var $292=$len;
      var $293=(($291)>>>0) < (($292)>>>0);
      if ($293) { __label__ = 24; break; } else { __label__ = 28; break; }
    case 24: // $294
      var $295=$op;
      var $296=$len;
      var $297=(($296-$295)|0);
      $len=$297;
      __label__ = 25; break;
    case 25: // $298
      var $299=$from;
      var $300=(($299+1)|0);
      $from=$300;
      var $301=HEAP8[($300)];
      var $302=$out;
      var $303=(($302+1)|0);
      $out=$303;
      HEAP8[($303)]=$301;
      __label__ = 26; break;
    case 26: // $304
      var $305=$op;
      var $306=(($305-1)|0);
      $op=$306;
      var $307=(($306)|0)!=0;
      if ($307) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 27: // $308
      var $309=$out;
      var $310=$dist;
      var $311=(((-$310))|0);
      var $312=(($309+$311)|0);
      $from=$312;
      __label__ = 28; break;
    case 28: // $313
      __label__ = 48; break;
    case 29: // $314
      var $315=$write;
      var $316=$op;
      var $317=(($315)>>>0) < (($316)>>>0);
      if ($317) { __label__ = 30; break; } else { __label__ = 41; break; }
    case 30: // $318
      var $319=$wsize;
      var $320=$write;
      var $321=(($319+$320)|0);
      var $322=$op;
      var $323=(($321-$322)|0);
      var $324=$from;
      var $325=(($324+$323)|0);
      $from=$325;
      var $326=$write;
      var $327=$op;
      var $328=(($327-$326)|0);
      $op=$328;
      var $329=$op;
      var $330=$len;
      var $331=(($329)>>>0) < (($330)>>>0);
      if ($331) { __label__ = 31; break; } else { __label__ = 40; break; }
    case 31: // $332
      var $333=$op;
      var $334=$len;
      var $335=(($334-$333)|0);
      $len=$335;
      __label__ = 32; break;
    case 32: // $336
      var $337=$from;
      var $338=(($337+1)|0);
      $from=$338;
      var $339=HEAP8[($338)];
      var $340=$out;
      var $341=(($340+1)|0);
      $out=$341;
      HEAP8[($341)]=$339;
      __label__ = 33; break;
    case 33: // $342
      var $343=$op;
      var $344=(($343-1)|0);
      $op=$344;
      var $345=(($344)|0)!=0;
      if ($345) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 34: // $346
      var $347=$window;
      var $348=(($347-1)|0);
      $from=$348;
      var $349=$write;
      var $350=$len;
      var $351=(($349)>>>0) < (($350)>>>0);
      if ($351) { __label__ = 35; break; } else { __label__ = 39; break; }
    case 35: // $352
      var $353=$write;
      $op=$353;
      var $354=$op;
      var $355=$len;
      var $356=(($355-$354)|0);
      $len=$356;
      __label__ = 36; break;
    case 36: // $357
      var $358=$from;
      var $359=(($358+1)|0);
      $from=$359;
      var $360=HEAP8[($359)];
      var $361=$out;
      var $362=(($361+1)|0);
      $out=$362;
      HEAP8[($362)]=$360;
      __label__ = 37; break;
    case 37: // $363
      var $364=$op;
      var $365=(($364-1)|0);
      $op=$365;
      var $366=(($365)|0)!=0;
      if ($366) { __label__ = 36; break; } else { __label__ = 38; break; }
    case 38: // $367
      var $368=$out;
      var $369=$dist;
      var $370=(((-$369))|0);
      var $371=(($368+$370)|0);
      $from=$371;
      __label__ = 39; break;
    case 39: // $372
      __label__ = 40; break;
    case 40: // $373
      __label__ = 47; break;
    case 41: // $374
      var $375=$write;
      var $376=$op;
      var $377=(($375-$376)|0);
      var $378=$from;
      var $379=(($378+$377)|0);
      $from=$379;
      var $380=$op;
      var $381=$len;
      var $382=(($380)>>>0) < (($381)>>>0);
      if ($382) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $383
      var $384=$op;
      var $385=$len;
      var $386=(($385-$384)|0);
      $len=$386;
      __label__ = 43; break;
    case 43: // $387
      var $388=$from;
      var $389=(($388+1)|0);
      $from=$389;
      var $390=HEAP8[($389)];
      var $391=$out;
      var $392=(($391+1)|0);
      $out=$392;
      HEAP8[($392)]=$390;
      __label__ = 44; break;
    case 44: // $393
      var $394=$op;
      var $395=(($394-1)|0);
      $op=$395;
      var $396=(($395)|0)!=0;
      if ($396) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 45: // $397
      var $398=$out;
      var $399=$dist;
      var $400=(((-$399))|0);
      var $401=(($398+$400)|0);
      $from=$401;
      __label__ = 46; break;
    case 46: // $402
      __label__ = 47; break;
    case 47: // $403
      __label__ = 48; break;
    case 48: // $404
      __label__ = 49; break;
    case 49: // $405
      var $406=$len;
      var $407=(($406)>>>0) > 2;
      if ($407) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $408
      var $409=$from;
      var $410=(($409+1)|0);
      $from=$410;
      var $411=HEAP8[($410)];
      var $412=$out;
      var $413=(($412+1)|0);
      $out=$413;
      HEAP8[($413)]=$411;
      var $414=$from;
      var $415=(($414+1)|0);
      $from=$415;
      var $416=HEAP8[($415)];
      var $417=$out;
      var $418=(($417+1)|0);
      $out=$418;
      HEAP8[($418)]=$416;
      var $419=$from;
      var $420=(($419+1)|0);
      $from=$420;
      var $421=HEAP8[($420)];
      var $422=$out;
      var $423=(($422+1)|0);
      $out=$423;
      HEAP8[($423)]=$421;
      var $424=$len;
      var $425=(($424-3)|0);
      $len=$425;
      __label__ = 49; break;
    case 51: // $426
      var $427=$len;
      var $428=(($427)|0)!=0;
      if ($428) { __label__ = 52; break; } else { __label__ = 55; break; }
    case 52: // $429
      var $430=$from;
      var $431=(($430+1)|0);
      $from=$431;
      var $432=HEAP8[($431)];
      var $433=$out;
      var $434=(($433+1)|0);
      $out=$434;
      HEAP8[($434)]=$432;
      var $435=$len;
      var $436=(($435)>>>0) > 1;
      if ($436) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $437
      var $438=$from;
      var $439=(($438+1)|0);
      $from=$439;
      var $440=HEAP8[($439)];
      var $441=$out;
      var $442=(($441+1)|0);
      $out=$442;
      HEAP8[($442)]=$440;
      __label__ = 54; break;
    case 54: // $443
      __label__ = 55; break;
    case 55: // $444
      __label__ = 64; break;
    case 56: // $445
      var $446=$out;
      var $447=$dist;
      var $448=(((-$447))|0);
      var $449=(($446+$448)|0);
      $from=$449;
      __label__ = 57; break;
    case 57: // $450
      var $451=$from;
      var $452=(($451+1)|0);
      $from=$452;
      var $453=HEAP8[($452)];
      var $454=$out;
      var $455=(($454+1)|0);
      $out=$455;
      HEAP8[($455)]=$453;
      var $456=$from;
      var $457=(($456+1)|0);
      $from=$457;
      var $458=HEAP8[($457)];
      var $459=$out;
      var $460=(($459+1)|0);
      $out=$460;
      HEAP8[($460)]=$458;
      var $461=$from;
      var $462=(($461+1)|0);
      $from=$462;
      var $463=HEAP8[($462)];
      var $464=$out;
      var $465=(($464+1)|0);
      $out=$465;
      HEAP8[($465)]=$463;
      var $466=$len;
      var $467=(($466-3)|0);
      $len=$467;
      __label__ = 58; break;
    case 58: // $468
      var $469=$len;
      var $470=(($469)>>>0) > 2;
      if ($470) { __label__ = 57; break; } else { __label__ = 59; break; }
    case 59: // $471
      var $472=$len;
      var $473=(($472)|0)!=0;
      if ($473) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $474
      var $475=$from;
      var $476=(($475+1)|0);
      $from=$476;
      var $477=HEAP8[($476)];
      var $478=$out;
      var $479=(($478+1)|0);
      $out=$479;
      HEAP8[($479)]=$477;
      var $480=$len;
      var $481=(($480)>>>0) > 1;
      if ($481) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $482
      var $483=$from;
      var $484=(($483+1)|0);
      $from=$484;
      var $485=HEAP8[($484)];
      var $486=$out;
      var $487=(($486+1)|0);
      $out=$487;
      HEAP8[($487)]=$485;
      __label__ = 62; break;
    case 62: // $488
      __label__ = 63; break;
    case 63: // $489
      __label__ = 64; break;
    case 64: // $490
      __label__ = 68; break;
    case 65: // $491
      var $492=$op;
      var $493=$492 & 64;
      var $494=(($493)|0)==0;
      if ($494) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $495
      var $496=(($this+2)|0);
      var $497=HEAPU16[(($496)>>1)];
      var $498=(($497)&65535);
      var $499=$hold;
      var $500=$op;
      var $501=1 << $500;
      var $502=(($501-1)|0);
      var $503=$499 & $502;
      var $504=(($498+$503)|0);
      var $505=$dcode;
      var $506=(($505+($504<<2))|0);
      var $507=$this;
      var $508=$506;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($507)>>1)]=HEAP16[(($508)>>1)];HEAP16[(($507+2)>>1)]=HEAP16[(($508+2)>>1)];
      __label__ = 14; break;
    case 67: // $509
      var $510=$1;
      var $511=(($510+24)|0);
      HEAP32[(($511)>>2)]=((STRING_TABLE.__str17640)|0);
      var $512=$state;
      var $513=(($512)|0);
      HEAP32[(($513)>>2)]=27;
      __label__ = 79; break;
    case 68: // $514
      __label__ = 74; break;
    case 69: // $515
      var $516=$op;
      var $517=$516 & 64;
      var $518=(($517)|0)==0;
      if ($518) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $519
      var $520=(($this+2)|0);
      var $521=HEAPU16[(($520)>>1)];
      var $522=(($521)&65535);
      var $523=$hold;
      var $524=$op;
      var $525=1 << $524;
      var $526=(($525-1)|0);
      var $527=$523 & $526;
      var $528=(($522+$527)|0);
      var $529=$lcode;
      var $530=(($529+($528<<2))|0);
      var $531=$this;
      var $532=$530;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($531)>>1)]=HEAP16[(($532)>>1)];HEAP16[(($531+2)>>1)]=HEAP16[(($532+2)>>1)];
      __label__ = 4; break;
    case 71: // $533
      var $534=$op;
      var $535=$534 & 32;
      var $536=(($535)|0)!=0;
      if ($536) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $537
      var $538=$state;
      var $539=(($538)|0);
      HEAP32[(($539)>>2)]=11;
      __label__ = 79; break;
    case 73: // $540
      var $541=$1;
      var $542=(($541+24)|0);
      HEAP32[(($542)>>2)]=((STRING_TABLE.__str27641)|0);
      var $543=$state;
      var $544=(($543)|0);
      HEAP32[(($544)>>2)]=27;
      __label__ = 79; break;
    case 74: // $545
      __label__ = 75; break;
    case 75: // $546
      __label__ = 76; break;
    case 76: // $547
      var $548=$in;
      var $549=$last;
      var $550=(($548)>>>0) < (($549)>>>0);
      if ($550) { __label__ = 77; break; } else { var $556 = 0;__label__ = 78; break; }
    case 77: // $551
      var $552=$out;
      var $553=$end;
      var $554=(($552)>>>0) < (($553)>>>0);
      var $556 = $554;__label__ = 78; break;
    case 78: // $555
      var $556;
      if ($556) { __label__ = 1; break; } else { __label__ = 79; break; }
    case 79: // $557
      var $558=$bits;
      var $559=$558 >>> 3;
      $len=$559;
      var $560=$len;
      var $561=$in;
      var $562=(((-$560))|0);
      var $563=(($561+$562)|0);
      $in=$563;
      var $564=$len;
      var $565=$564 << 3;
      var $566=$bits;
      var $567=(($566-$565)|0);
      $bits=$567;
      var $568=$bits;
      var $569=1 << $568;
      var $570=(($569-1)|0);
      var $571=$hold;
      var $572=$571 & $570;
      $hold=$572;
      var $573=$in;
      var $574=(($573+1)|0);
      var $575=$1;
      var $576=(($575)|0);
      HEAP32[(($576)>>2)]=$574;
      var $577=$out;
      var $578=(($577+1)|0);
      var $579=$1;
      var $580=(($579+12)|0);
      HEAP32[(($580)>>2)]=$578;
      var $581=$in;
      var $582=$last;
      var $583=(($581)>>>0) < (($582)>>>0);
      if ($583) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $584
      var $585=$last;
      var $586=$in;
      var $587=$585;
      var $588=$586;
      var $589=(($587-$588)|0);
      var $590=(($589+5)|0);
      var $599 = $590;__label__ = 82; break;
    case 81: // $591
      var $592=$in;
      var $593=$last;
      var $594=$592;
      var $595=$593;
      var $596=(($594-$595)|0);
      var $597=((5-$596)|0);
      var $599 = $597;__label__ = 82; break;
    case 82: // $598
      var $599;
      var $600=$1;
      var $601=(($600+4)|0);
      HEAP32[(($601)>>2)]=$599;
      var $602=$out;
      var $603=$end;
      var $604=(($602)>>>0) < (($603)>>>0);
      if ($604) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $605
      var $606=$end;
      var $607=$out;
      var $608=$606;
      var $609=$607;
      var $610=(($608-$609)|0);
      var $611=(($610+257)|0);
      var $620 = $611;__label__ = 85; break;
    case 84: // $612
      var $613=$out;
      var $614=$end;
      var $615=$613;
      var $616=$614;
      var $617=(($615-$616)|0);
      var $618=((257-$617)|0);
      var $620 = $618;__label__ = 85; break;
    case 85: // $619
      var $620;
      var $621=$1;
      var $622=(($621+16)|0);
      HEAP32[(($622)>>2)]=$620;
      var $623=$hold;
      var $624=$state;
      var $625=(($624+56)|0);
      HEAP32[(($625)>>2)]=$623;
      var $626=$bits;
      var $627=$state;
      var $628=(($627+60)|0);
      HEAP32[(($628)>>2)]=$626;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_inflate_fast["X"]=1;

function _inflate_table($type, $lens, $codes, $table, $bits, $work) {
  var __stackBase__  = STACKTOP; STACKTOP += 68; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $len;
      var $sym;
      var $min;
      var $max;
      var $root;
      var $curr;
      var $drop;
      var $left;
      var $used;
      var $huff;
      var $incr;
      var $fill;
      var $low;
      var $mask;
      var $this=__stackBase__;
      var $next;
      var $base;
      var $extra;
      var $end;
      var $count=__stackBase__+4;
      var $offs=__stackBase__+36;
      $2=$type;
      $3=$lens;
      $4=$codes;
      $5=$table;
      $6=$bits;
      $7=$work;
      $len=0;
      __label__ = 1; break;
    case 1: // $8
      var $9=$len;
      var $10=(($9)>>>0) <= 15;
      if ($10) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      var $12=$len;
      var $13=(($count+($12<<1))|0);
      HEAP16[(($13)>>1)]=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$len;
      var $16=(($15+1)|0);
      $len=$16;
      __label__ = 1; break;
    case 4: // $17
      $sym=0;
      __label__ = 5; break;
    case 5: // $18
      var $19=$sym;
      var $20=$4;
      var $21=(($19)>>>0) < (($20)>>>0);
      if ($21) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $22
      var $23=$sym;
      var $24=$3;
      var $25=(($24+($23<<1))|0);
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      var $28=(($count+($27<<1))|0);
      var $29=HEAP16[(($28)>>1)];
      var $30=(($29+1)&65535);
      HEAP16[(($28)>>1)]=$30;
      __label__ = 7; break;
    case 7: // $31
      var $32=$sym;
      var $33=(($32+1)|0);
      $sym=$33;
      __label__ = 5; break;
    case 8: // $34
      var $35=$6;
      var $36=HEAP32[(($35)>>2)];
      $root=$36;
      $max=15;
      __label__ = 9; break;
    case 9: // $37
      var $38=$max;
      var $39=(($38)>>>0) >= 1;
      if ($39) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $40
      var $41=$max;
      var $42=(($count+($41<<1))|0);
      var $43=HEAPU16[(($42)>>1)];
      var $44=(($43)&65535);
      var $45=(($44)|0)!=0;
      if ($45) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $46
      __label__ = 14; break;
    case 12: // $47
      __label__ = 13; break;
    case 13: // $48
      var $49=$max;
      var $50=(($49-1)|0);
      $max=$50;
      __label__ = 9; break;
    case 14: // $51
      var $52=$root;
      var $53=$max;
      var $54=(($52)>>>0) > (($53)>>>0);
      if ($54) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $55
      var $56=$max;
      $root=$56;
      __label__ = 16; break;
    case 16: // $57
      var $58=$max;
      var $59=(($58)|0)==0;
      if ($59) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $60
      var $61=(($this)|0);
      HEAP8[($61)]=64;
      var $62=(($this+1)|0);
      HEAP8[($62)]=1;
      var $63=(($this+2)|0);
      HEAP16[(($63)>>1)]=0;
      var $64=$5;
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65+4)|0);
      HEAP32[(($64)>>2)]=$66;
      var $67=$65;
      var $68=$this;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($67)>>1)]=HEAP16[(($68)>>1)];HEAP16[(($67+2)>>1)]=HEAP16[(($68+2)>>1)];
      var $69=$5;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+4)|0);
      HEAP32[(($69)>>2)]=$71;
      var $72=$70;
      var $73=$this;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($72)>>1)]=HEAP16[(($73)>>1)];HEAP16[(($72+2)>>1)]=HEAP16[(($73+2)>>1)];
      var $74=$6;
      HEAP32[(($74)>>2)]=1;
      $1=0;
      __label__ = 100; break;
    case 18: // $75
      $min=1;
      __label__ = 19; break;
    case 19: // $76
      var $77=$min;
      var $78=(($77)>>>0) <= 15;
      if ($78) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $79
      var $80=$min;
      var $81=(($count+($80<<1))|0);
      var $82=HEAPU16[(($81)>>1)];
      var $83=(($82)&65535);
      var $84=(($83)|0)!=0;
      if ($84) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $85
      __label__ = 24; break;
    case 22: // $86
      __label__ = 23; break;
    case 23: // $87
      var $88=$min;
      var $89=(($88+1)|0);
      $min=$89;
      __label__ = 19; break;
    case 24: // $90
      var $91=$root;
      var $92=$min;
      var $93=(($91)>>>0) < (($92)>>>0);
      if ($93) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $94
      var $95=$min;
      $root=$95;
      __label__ = 26; break;
    case 26: // $96
      $left=1;
      $len=1;
      __label__ = 27; break;
    case 27: // $97
      var $98=$len;
      var $99=(($98)>>>0) <= 15;
      if ($99) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $100
      var $101=$left;
      var $102=$101 << 1;
      $left=$102;
      var $103=$len;
      var $104=(($count+($103<<1))|0);
      var $105=HEAPU16[(($104)>>1)];
      var $106=(($105)&65535);
      var $107=$left;
      var $108=(($107-$106)|0);
      $left=$108;
      var $109=$left;
      var $110=(($109)|0) < 0;
      if ($110) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $111
      $1=-1;
      __label__ = 100; break;
    case 30: // $112
      __label__ = 31; break;
    case 31: // $113
      var $114=$len;
      var $115=(($114+1)|0);
      $len=$115;
      __label__ = 27; break;
    case 32: // $116
      var $117=$left;
      var $118=(($117)|0) > 0;
      if ($118) { __label__ = 33; break; } else { __label__ = 36; break; }
    case 33: // $119
      var $120=$2;
      var $121=(($120)|0)==0;
      if ($121) { __label__ = 35; break; } else { __label__ = 34; break; }
    case 34: // $122
      var $123=$max;
      var $124=(($123)|0)!=1;
      if ($124) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $125
      $1=-1;
      __label__ = 100; break;
    case 36: // $126
      var $127=(($offs+2)|0);
      HEAP16[(($127)>>1)]=0;
      $len=1;
      __label__ = 37; break;
    case 37: // $128
      var $129=$len;
      var $130=(($129)>>>0) < 15;
      if ($130) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $131
      var $132=$len;
      var $133=(($offs+($132<<1))|0);
      var $134=HEAPU16[(($133)>>1)];
      var $135=(($134)&65535);
      var $136=$len;
      var $137=(($count+($136<<1))|0);
      var $138=HEAPU16[(($137)>>1)];
      var $139=(($138)&65535);
      var $140=(($135+$139)|0);
      var $141=(($140) & 65535);
      var $142=$len;
      var $143=(($142+1)|0);
      var $144=(($offs+($143<<1))|0);
      HEAP16[(($144)>>1)]=$141;
      __label__ = 39; break;
    case 39: // $145
      var $146=$len;
      var $147=(($146+1)|0);
      $len=$147;
      __label__ = 37; break;
    case 40: // $148
      $sym=0;
      __label__ = 41; break;
    case 41: // $149
      var $150=$sym;
      var $151=$4;
      var $152=(($150)>>>0) < (($151)>>>0);
      if ($152) { __label__ = 42; break; } else { __label__ = 46; break; }
    case 42: // $153
      var $154=$sym;
      var $155=$3;
      var $156=(($155+($154<<1))|0);
      var $157=HEAPU16[(($156)>>1)];
      var $158=(($157)&65535);
      var $159=(($158)|0)!=0;
      if ($159) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $160
      var $161=$sym;
      var $162=(($161) & 65535);
      var $163=$sym;
      var $164=$3;
      var $165=(($164+($163<<1))|0);
      var $166=HEAPU16[(($165)>>1)];
      var $167=(($166)&65535);
      var $168=(($offs+($167<<1))|0);
      var $169=HEAPU16[(($168)>>1)];
      var $170=(($169+1)&65535);
      HEAP16[(($168)>>1)]=$170;
      var $171=(($169)&65535);
      var $172=$7;
      var $173=(($172+($171<<1))|0);
      HEAP16[(($173)>>1)]=$162;
      __label__ = 44; break;
    case 44: // $174
      __label__ = 45; break;
    case 45: // $175
      var $176=$sym;
      var $177=(($176+1)|0);
      $sym=$177;
      __label__ = 41; break;
    case 46: // $178
      var $179=$2;
      if ($179 == 0) {
        __label__ = 47; break;
      }
      else if ($179 == 1) {
        __label__ = 48; break;
      }
      else {
      __label__ = 49; break;
      }
      
    case 47: // $180
      var $181=$7;
      $extra=$181;
      $base=$181;
      $end=19;
      __label__ = 50; break;
    case 48: // $182
      $base=((_inflate_table_lbase)|0);
      var $183=$base;
      var $184=(($183-514)|0);
      $base=$184;
      $extra=((_inflate_table_lext)|0);
      var $185=$extra;
      var $186=(($185-514)|0);
      $extra=$186;
      $end=256;
      __label__ = 50; break;
    case 49: // $187
      $base=((_inflate_table_dbase)|0);
      $extra=((_inflate_table_dext)|0);
      $end=-1;
      __label__ = 50; break;
    case 50: // $188
      $huff=0;
      $sym=0;
      var $189=$min;
      $len=$189;
      var $190=$5;
      var $191=HEAP32[(($190)>>2)];
      $next=$191;
      var $192=$root;
      $curr=$192;
      $drop=0;
      $low=-1;
      var $193=$root;
      var $194=1 << $193;
      $used=$194;
      var $195=$used;
      var $196=(($195-1)|0);
      $mask=$196;
      var $197=$2;
      var $198=(($197)|0)==1;
      if ($198) { __label__ = 51; break; } else { __label__ = 53; break; }
    case 51: // $199
      var $200=$used;
      var $201=(($200)>>>0) >= 1456;
      if ($201) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $202
      $1=1;
      __label__ = 100; break;
    case 53: // $203
      __label__ = 54; break;
    case 54: // $204
      var $205=$len;
      var $206=$drop;
      var $207=(($205-$206)|0);
      var $208=(($207) & 255);
      var $209=(($this+1)|0);
      HEAP8[($209)]=$208;
      var $210=$sym;
      var $211=$7;
      var $212=(($211+($210<<1))|0);
      var $213=HEAPU16[(($212)>>1)];
      var $214=(($213)&65535);
      var $215=$end;
      var $216=(($214)|0) < (($215)|0);
      if ($216) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $217
      var $218=(($this)|0);
      HEAP8[($218)]=0;
      var $219=$sym;
      var $220=$7;
      var $221=(($220+($219<<1))|0);
      var $222=HEAP16[(($221)>>1)];
      var $223=(($this+2)|0);
      HEAP16[(($223)>>1)]=$222;
      __label__ = 60; break;
    case 56: // $224
      var $225=$sym;
      var $226=$7;
      var $227=(($226+($225<<1))|0);
      var $228=HEAPU16[(($227)>>1)];
      var $229=(($228)&65535);
      var $230=$end;
      var $231=(($229)|0) > (($230)|0);
      if ($231) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $232
      var $233=$sym;
      var $234=$7;
      var $235=(($234+($233<<1))|0);
      var $236=HEAPU16[(($235)>>1)];
      var $237=(($236)&65535);
      var $238=$extra;
      var $239=(($238+($237<<1))|0);
      var $240=HEAP16[(($239)>>1)];
      var $241=(($240) & 255);
      var $242=(($this)|0);
      HEAP8[($242)]=$241;
      var $243=$sym;
      var $244=$7;
      var $245=(($244+($243<<1))|0);
      var $246=HEAPU16[(($245)>>1)];
      var $247=(($246)&65535);
      var $248=$base;
      var $249=(($248+($247<<1))|0);
      var $250=HEAP16[(($249)>>1)];
      var $251=(($this+2)|0);
      HEAP16[(($251)>>1)]=$250;
      __label__ = 59; break;
    case 58: // $252
      var $253=(($this)|0);
      HEAP8[($253)]=96;
      var $254=(($this+2)|0);
      HEAP16[(($254)>>1)]=0;
      __label__ = 59; break;
    case 59: // $255
      __label__ = 60; break;
    case 60: // $256
      var $257=$len;
      var $258=$drop;
      var $259=(($257-$258)|0);
      var $260=1 << $259;
      $incr=$260;
      var $261=$curr;
      var $262=1 << $261;
      $fill=$262;
      var $263=$fill;
      $min=$263;
      __label__ = 61; break;
    case 61: // $264
      var $265=$incr;
      var $266=$fill;
      var $267=(($266-$265)|0);
      $fill=$267;
      var $268=$huff;
      var $269=$drop;
      var $270=$268 >>> (($269)>>>0);
      var $271=$fill;
      var $272=(($270+$271)|0);
      var $273=$next;
      var $274=(($273+($272<<2))|0);
      var $275=$274;
      var $276=$this;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($275)>>1)]=HEAP16[(($276)>>1)];HEAP16[(($275+2)>>1)]=HEAP16[(($276+2)>>1)];
      __label__ = 62; break;
    case 62: // $277
      var $278=$fill;
      var $279=(($278)|0)!=0;
      if ($279) { __label__ = 61; break; } else { __label__ = 63; break; }
    case 63: // $280
      var $281=$len;
      var $282=(($281-1)|0);
      var $283=1 << $282;
      $incr=$283;
      __label__ = 64; break;
    case 64: // $284
      var $285=$huff;
      var $286=$incr;
      var $287=$285 & $286;
      var $288=(($287)|0)!=0;
      if ($288) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $289
      var $290=$incr;
      var $291=$290 >>> 1;
      $incr=$291;
      __label__ = 64; break;
    case 66: // $292
      var $293=$incr;
      var $294=(($293)|0)!=0;
      if ($294) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $295
      var $296=$incr;
      var $297=(($296-1)|0);
      var $298=$huff;
      var $299=$298 & $297;
      $huff=$299;
      var $300=$incr;
      var $301=$huff;
      var $302=(($301+$300)|0);
      $huff=$302;
      __label__ = 69; break;
    case 68: // $303
      $huff=0;
      __label__ = 69; break;
    case 69: // $304
      var $305=$sym;
      var $306=(($305+1)|0);
      $sym=$306;
      var $307=$len;
      var $308=(($count+($307<<1))|0);
      var $309=HEAP16[(($308)>>1)];
      var $310=(($309-1)&65535);
      HEAP16[(($308)>>1)]=$310;
      var $311=(($310)&65535);
      var $312=(($311)|0)==0;
      if ($312) { __label__ = 70; break; } else { __label__ = 73; break; }
    case 70: // $313
      var $314=$len;
      var $315=$max;
      var $316=(($314)|0)==(($315)|0);
      if ($316) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $317
      __label__ = 87; break;
    case 72: // $318
      var $319=$sym;
      var $320=$7;
      var $321=(($320+($319<<1))|0);
      var $322=HEAPU16[(($321)>>1)];
      var $323=(($322)&65535);
      var $324=$3;
      var $325=(($324+($323<<1))|0);
      var $326=HEAPU16[(($325)>>1)];
      var $327=(($326)&65535);
      $len=$327;
      __label__ = 73; break;
    case 73: // $328
      var $329=$len;
      var $330=$root;
      var $331=(($329)>>>0) > (($330)>>>0);
      if ($331) { __label__ = 74; break; } else { __label__ = 86; break; }
    case 74: // $332
      var $333=$huff;
      var $334=$mask;
      var $335=$333 & $334;
      var $336=$low;
      var $337=(($335)|0)!=(($336)|0);
      if ($337) { __label__ = 75; break; } else { __label__ = 86; break; }
    case 75: // $338
      var $339=$drop;
      var $340=(($339)|0)==0;
      if ($340) { __label__ = 76; break; } else { __label__ = 77; break; }
    case 76: // $341
      var $342=$root;
      $drop=$342;
      __label__ = 77; break;
    case 77: // $343
      var $344=$min;
      var $345=$next;
      var $346=(($345+($344<<2))|0);
      $next=$346;
      var $347=$len;
      var $348=$drop;
      var $349=(($347-$348)|0);
      $curr=$349;
      var $350=$curr;
      var $351=1 << $350;
      $left=$351;
      __label__ = 78; break;
    case 78: // $352
      var $353=$curr;
      var $354=$drop;
      var $355=(($353+$354)|0);
      var $356=$max;
      var $357=(($355)>>>0) < (($356)>>>0);
      if ($357) { __label__ = 79; break; } else { __label__ = 82; break; }
    case 79: // $358
      var $359=$curr;
      var $360=$drop;
      var $361=(($359+$360)|0);
      var $362=(($count+($361<<1))|0);
      var $363=HEAPU16[(($362)>>1)];
      var $364=(($363)&65535);
      var $365=$left;
      var $366=(($365-$364)|0);
      $left=$366;
      var $367=$left;
      var $368=(($367)|0) <= 0;
      if ($368) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $369
      __label__ = 82; break;
    case 81: // $370
      var $371=$curr;
      var $372=(($371+1)|0);
      $curr=$372;
      var $373=$left;
      var $374=$373 << 1;
      $left=$374;
      __label__ = 78; break;
    case 82: // $375
      var $376=$curr;
      var $377=1 << $376;
      var $378=$used;
      var $379=(($378+$377)|0);
      $used=$379;
      var $380=$2;
      var $381=(($380)|0)==1;
      if ($381) { __label__ = 83; break; } else { __label__ = 85; break; }
    case 83: // $382
      var $383=$used;
      var $384=(($383)>>>0) >= 1456;
      if ($384) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $385
      $1=1;
      __label__ = 100; break;
    case 85: // $386
      var $387=$huff;
      var $388=$mask;
      var $389=$387 & $388;
      $low=$389;
      var $390=$curr;
      var $391=(($390) & 255);
      var $392=$low;
      var $393=$5;
      var $394=HEAP32[(($393)>>2)];
      var $395=(($394+($392<<2))|0);
      var $396=(($395)|0);
      HEAP8[($396)]=$391;
      var $397=$root;
      var $398=(($397) & 255);
      var $399=$low;
      var $400=$5;
      var $401=HEAP32[(($400)>>2)];
      var $402=(($401+($399<<2))|0);
      var $403=(($402+1)|0);
      HEAP8[($403)]=$398;
      var $404=$next;
      var $405=$5;
      var $406=HEAP32[(($405)>>2)];
      var $407=$404;
      var $408=$406;
      var $409=(($407-$408)|0);
      var $410=(((($409)|0)/4)|0);
      var $411=(($410) & 65535);
      var $412=$low;
      var $413=$5;
      var $414=HEAP32[(($413)>>2)];
      var $415=(($414+($412<<2))|0);
      var $416=(($415+2)|0);
      HEAP16[(($416)>>1)]=$411;
      __label__ = 86; break;
    case 86: // $417
      __label__ = 54; break;
    case 87: // $418
      var $419=(($this)|0);
      HEAP8[($419)]=64;
      var $420=$len;
      var $421=$drop;
      var $422=(($420-$421)|0);
      var $423=(($422) & 255);
      var $424=(($this+1)|0);
      HEAP8[($424)]=$423;
      var $425=(($this+2)|0);
      HEAP16[(($425)>>1)]=0;
      __label__ = 88; break;
    case 88: // $426
      var $427=$huff;
      var $428=(($427)|0)!=0;
      if ($428) { __label__ = 89; break; } else { __label__ = 99; break; }
    case 89: // $429
      var $430=$drop;
      var $431=(($430)|0)!=0;
      if ($431) { __label__ = 90; break; } else { __label__ = 92; break; }
    case 90: // $432
      var $433=$huff;
      var $434=$mask;
      var $435=$433 & $434;
      var $436=$low;
      var $437=(($435)|0)!=(($436)|0);
      if ($437) { __label__ = 91; break; } else { __label__ = 92; break; }
    case 91: // $438
      $drop=0;
      var $439=$root;
      $len=$439;
      var $440=$5;
      var $441=HEAP32[(($440)>>2)];
      $next=$441;
      var $442=$len;
      var $443=(($442) & 255);
      var $444=(($this+1)|0);
      HEAP8[($444)]=$443;
      __label__ = 92; break;
    case 92: // $445
      var $446=$huff;
      var $447=$drop;
      var $448=$446 >>> (($447)>>>0);
      var $449=$next;
      var $450=(($449+($448<<2))|0);
      var $451=$450;
      var $452=$this;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP16[(($451)>>1)]=HEAP16[(($452)>>1)];HEAP16[(($451+2)>>1)]=HEAP16[(($452+2)>>1)];
      var $453=$len;
      var $454=(($453-1)|0);
      var $455=1 << $454;
      $incr=$455;
      __label__ = 93; break;
    case 93: // $456
      var $457=$huff;
      var $458=$incr;
      var $459=$457 & $458;
      var $460=(($459)|0)!=0;
      if ($460) { __label__ = 94; break; } else { __label__ = 95; break; }
    case 94: // $461
      var $462=$incr;
      var $463=$462 >>> 1;
      $incr=$463;
      __label__ = 93; break;
    case 95: // $464
      var $465=$incr;
      var $466=(($465)|0)!=0;
      if ($466) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $467
      var $468=$incr;
      var $469=(($468-1)|0);
      var $470=$huff;
      var $471=$470 & $469;
      $huff=$471;
      var $472=$incr;
      var $473=$huff;
      var $474=(($473+$472)|0);
      $huff=$474;
      __label__ = 98; break;
    case 97: // $475
      $huff=0;
      __label__ = 98; break;
    case 98: // $476
      __label__ = 88; break;
    case 99: // $477
      var $478=$used;
      var $479=$5;
      var $480=HEAP32[(($479)>>2)];
      var $481=(($480+($478<<2))|0);
      HEAP32[(($479)>>2)]=$481;
      var $482=$root;
      var $483=$6;
      HEAP32[(($483)>>2)]=$482;
      $1=0;
      __label__ = 100; break;
    case 100: // $484
      var $485=$1;
      STACKTOP = __stackBase__;
      return $485;
    default: assert(0, "bad label: " + __label__);
  }
}
_inflate_table["X"]=1;

function _zcalloc($opaque, $items, $size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$opaque;
      $2=$items;
      $3=$size;
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$3;
      var $8=$3;
      var $9=(($7-$8)|0);
      var $10=$2;
      var $11=(($10+$9)|0);
      $2=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$2;
      var $14=$3;
      var $15=(($13*$14)|0);
      var $16=_malloc($15);
      ;
      return $16;
    default: assert(0, "bad label: " + __label__);
  }
}


function _zcfree($opaque, $ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$opaque;
      $2=$ptr;
      var $3=$2;
      _free($3);
      var $4=$1;
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      __label__ = 2; break;
    case 2: // $7
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function _tr_static_init() {
  ;
  var __label__;

  ;
  return;
}


function _adler32($adler, $buf, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $sum2;
      var $n;
      $2=$adler;
      $3=$buf;
      $4=$len;
      var $5=$2;
      var $6=$5 >>> 16;
      var $7=$6 & 65535;
      $sum2=$7;
      var $8=$2;
      var $9=$8 & 65535;
      $2=$9;
      var $10=$4;
      var $11=(($10)|0)==1;
      if ($11) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $12
      var $13=$3;
      var $14=(($13)|0);
      var $15=HEAPU8[($14)];
      var $16=(($15)&255);
      var $17=$2;
      var $18=(($17+$16)|0);
      $2=$18;
      var $19=$2;
      var $20=(($19)>>>0) >= 65521;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$2;
      var $23=(($22-65521)|0);
      $2=$23;
      __label__ = 3; break;
    case 3: // $24
      var $25=$2;
      var $26=$sum2;
      var $27=(($26+$25)|0);
      $sum2=$27;
      var $28=$sum2;
      var $29=(($28)>>>0) >= 65521;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$sum2;
      var $32=(($31-65521)|0);
      $sum2=$32;
      __label__ = 5; break;
    case 5: // $33
      var $34=$2;
      var $35=$sum2;
      var $36=$35 << 16;
      var $37=$34 | $36;
      $1=$37;
      __label__ = 30; break;
    case 6: // $38
      var $39=$3;
      var $40=(($39)|0)==0;
      if ($40) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $41
      $1=1;
      __label__ = 30; break;
    case 8: // $42
      var $43=$4;
      var $44=(($43)>>>0) < 16;
      if ($44) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $45
      __label__ = 10; break;
    case 10: // $46
      var $47=$4;
      var $48=(($47-1)|0);
      $4=$48;
      var $49=(($47)|0)!=0;
      if ($49) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $50
      var $51=$3;
      var $52=(($51+1)|0);
      $3=$52;
      var $53=HEAPU8[($51)];
      var $54=(($53)&255);
      var $55=$2;
      var $56=(($55+$54)|0);
      $2=$56;
      var $57=$2;
      var $58=$sum2;
      var $59=(($58+$57)|0);
      $sum2=$59;
      __label__ = 10; break;
    case 12: // $60
      var $61=$2;
      var $62=(($61)>>>0) >= 65521;
      if ($62) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $63
      var $64=$2;
      var $65=(($64-65521)|0);
      $2=$65;
      __label__ = 14; break;
    case 14: // $66
      var $67=$sum2;
      var $68=(($67)>>>0)%65521;
      $sum2=$68;
      var $69=$2;
      var $70=$sum2;
      var $71=$70 << 16;
      var $72=$69 | $71;
      $1=$72;
      __label__ = 30; break;
    case 15: // $73
      __label__ = 16; break;
    case 16: // $74
      var $75=$4;
      var $76=(($75)>>>0) >= 5552;
      if ($76) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $77
      var $78=$4;
      var $79=(($78-5552)|0);
      $4=$79;
      $n=347;
      __label__ = 18; break;
    case 18: // $80
      var $81=$3;
      var $82=(($81)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$2;
      var $86=(($85+$84)|0);
      $2=$86;
      var $87=$2;
      var $88=$sum2;
      var $89=(($88+$87)|0);
      $sum2=$89;
      var $90=$3;
      var $91=(($90+1)|0);
      var $92=HEAPU8[($91)];
      var $93=(($92)&255);
      var $94=$2;
      var $95=(($94+$93)|0);
      $2=$95;
      var $96=$2;
      var $97=$sum2;
      var $98=(($97+$96)|0);
      $sum2=$98;
      var $99=$3;
      var $100=(($99+2)|0);
      var $101=HEAPU8[($100)];
      var $102=(($101)&255);
      var $103=$2;
      var $104=(($103+$102)|0);
      $2=$104;
      var $105=$2;
      var $106=$sum2;
      var $107=(($106+$105)|0);
      $sum2=$107;
      var $108=$3;
      var $109=(($108+3)|0);
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$2;
      var $113=(($112+$111)|0);
      $2=$113;
      var $114=$2;
      var $115=$sum2;
      var $116=(($115+$114)|0);
      $sum2=$116;
      var $117=$3;
      var $118=(($117+4)|0);
      var $119=HEAPU8[($118)];
      var $120=(($119)&255);
      var $121=$2;
      var $122=(($121+$120)|0);
      $2=$122;
      var $123=$2;
      var $124=$sum2;
      var $125=(($124+$123)|0);
      $sum2=$125;
      var $126=$3;
      var $127=(($126+5)|0);
      var $128=HEAPU8[($127)];
      var $129=(($128)&255);
      var $130=$2;
      var $131=(($130+$129)|0);
      $2=$131;
      var $132=$2;
      var $133=$sum2;
      var $134=(($133+$132)|0);
      $sum2=$134;
      var $135=$3;
      var $136=(($135+6)|0);
      var $137=HEAPU8[($136)];
      var $138=(($137)&255);
      var $139=$2;
      var $140=(($139+$138)|0);
      $2=$140;
      var $141=$2;
      var $142=$sum2;
      var $143=(($142+$141)|0);
      $sum2=$143;
      var $144=$3;
      var $145=(($144+7)|0);
      var $146=HEAPU8[($145)];
      var $147=(($146)&255);
      var $148=$2;
      var $149=(($148+$147)|0);
      $2=$149;
      var $150=$2;
      var $151=$sum2;
      var $152=(($151+$150)|0);
      $sum2=$152;
      var $153=$3;
      var $154=(($153+8)|0);
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$2;
      var $158=(($157+$156)|0);
      $2=$158;
      var $159=$2;
      var $160=$sum2;
      var $161=(($160+$159)|0);
      $sum2=$161;
      var $162=$3;
      var $163=(($162+9)|0);
      var $164=HEAPU8[($163)];
      var $165=(($164)&255);
      var $166=$2;
      var $167=(($166+$165)|0);
      $2=$167;
      var $168=$2;
      var $169=$sum2;
      var $170=(($169+$168)|0);
      $sum2=$170;
      var $171=$3;
      var $172=(($171+10)|0);
      var $173=HEAPU8[($172)];
      var $174=(($173)&255);
      var $175=$2;
      var $176=(($175+$174)|0);
      $2=$176;
      var $177=$2;
      var $178=$sum2;
      var $179=(($178+$177)|0);
      $sum2=$179;
      var $180=$3;
      var $181=(($180+11)|0);
      var $182=HEAPU8[($181)];
      var $183=(($182)&255);
      var $184=$2;
      var $185=(($184+$183)|0);
      $2=$185;
      var $186=$2;
      var $187=$sum2;
      var $188=(($187+$186)|0);
      $sum2=$188;
      var $189=$3;
      var $190=(($189+12)|0);
      var $191=HEAPU8[($190)];
      var $192=(($191)&255);
      var $193=$2;
      var $194=(($193+$192)|0);
      $2=$194;
      var $195=$2;
      var $196=$sum2;
      var $197=(($196+$195)|0);
      $sum2=$197;
      var $198=$3;
      var $199=(($198+13)|0);
      var $200=HEAPU8[($199)];
      var $201=(($200)&255);
      var $202=$2;
      var $203=(($202+$201)|0);
      $2=$203;
      var $204=$2;
      var $205=$sum2;
      var $206=(($205+$204)|0);
      $sum2=$206;
      var $207=$3;
      var $208=(($207+14)|0);
      var $209=HEAPU8[($208)];
      var $210=(($209)&255);
      var $211=$2;
      var $212=(($211+$210)|0);
      $2=$212;
      var $213=$2;
      var $214=$sum2;
      var $215=(($214+$213)|0);
      $sum2=$215;
      var $216=$3;
      var $217=(($216+15)|0);
      var $218=HEAPU8[($217)];
      var $219=(($218)&255);
      var $220=$2;
      var $221=(($220+$219)|0);
      $2=$221;
      var $222=$2;
      var $223=$sum2;
      var $224=(($223+$222)|0);
      $sum2=$224;
      var $225=$3;
      var $226=(($225+16)|0);
      $3=$226;
      __label__ = 19; break;
    case 19: // $227
      var $228=$n;
      var $229=(($228-1)|0);
      $n=$229;
      var $230=(($229)|0)!=0;
      if ($230) { __label__ = 18; break; } else { __label__ = 20; break; }
    case 20: // $231
      var $232=$2;
      var $233=(($232)>>>0)%65521;
      $2=$233;
      var $234=$sum2;
      var $235=(($234)>>>0)%65521;
      $sum2=$235;
      __label__ = 16; break;
    case 21: // $236
      var $237=$4;
      var $238=(($237)|0)!=0;
      if ($238) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $239
      __label__ = 23; break;
    case 23: // $240
      var $241=$4;
      var $242=(($241)>>>0) >= 16;
      if ($242) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $243
      var $244=$4;
      var $245=(($244-16)|0);
      $4=$245;
      var $246=$3;
      var $247=(($246)|0);
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$2;
      var $251=(($250+$249)|0);
      $2=$251;
      var $252=$2;
      var $253=$sum2;
      var $254=(($253+$252)|0);
      $sum2=$254;
      var $255=$3;
      var $256=(($255+1)|0);
      var $257=HEAPU8[($256)];
      var $258=(($257)&255);
      var $259=$2;
      var $260=(($259+$258)|0);
      $2=$260;
      var $261=$2;
      var $262=$sum2;
      var $263=(($262+$261)|0);
      $sum2=$263;
      var $264=$3;
      var $265=(($264+2)|0);
      var $266=HEAPU8[($265)];
      var $267=(($266)&255);
      var $268=$2;
      var $269=(($268+$267)|0);
      $2=$269;
      var $270=$2;
      var $271=$sum2;
      var $272=(($271+$270)|0);
      $sum2=$272;
      var $273=$3;
      var $274=(($273+3)|0);
      var $275=HEAPU8[($274)];
      var $276=(($275)&255);
      var $277=$2;
      var $278=(($277+$276)|0);
      $2=$278;
      var $279=$2;
      var $280=$sum2;
      var $281=(($280+$279)|0);
      $sum2=$281;
      var $282=$3;
      var $283=(($282+4)|0);
      var $284=HEAPU8[($283)];
      var $285=(($284)&255);
      var $286=$2;
      var $287=(($286+$285)|0);
      $2=$287;
      var $288=$2;
      var $289=$sum2;
      var $290=(($289+$288)|0);
      $sum2=$290;
      var $291=$3;
      var $292=(($291+5)|0);
      var $293=HEAPU8[($292)];
      var $294=(($293)&255);
      var $295=$2;
      var $296=(($295+$294)|0);
      $2=$296;
      var $297=$2;
      var $298=$sum2;
      var $299=(($298+$297)|0);
      $sum2=$299;
      var $300=$3;
      var $301=(($300+6)|0);
      var $302=HEAPU8[($301)];
      var $303=(($302)&255);
      var $304=$2;
      var $305=(($304+$303)|0);
      $2=$305;
      var $306=$2;
      var $307=$sum2;
      var $308=(($307+$306)|0);
      $sum2=$308;
      var $309=$3;
      var $310=(($309+7)|0);
      var $311=HEAPU8[($310)];
      var $312=(($311)&255);
      var $313=$2;
      var $314=(($313+$312)|0);
      $2=$314;
      var $315=$2;
      var $316=$sum2;
      var $317=(($316+$315)|0);
      $sum2=$317;
      var $318=$3;
      var $319=(($318+8)|0);
      var $320=HEAPU8[($319)];
      var $321=(($320)&255);
      var $322=$2;
      var $323=(($322+$321)|0);
      $2=$323;
      var $324=$2;
      var $325=$sum2;
      var $326=(($325+$324)|0);
      $sum2=$326;
      var $327=$3;
      var $328=(($327+9)|0);
      var $329=HEAPU8[($328)];
      var $330=(($329)&255);
      var $331=$2;
      var $332=(($331+$330)|0);
      $2=$332;
      var $333=$2;
      var $334=$sum2;
      var $335=(($334+$333)|0);
      $sum2=$335;
      var $336=$3;
      var $337=(($336+10)|0);
      var $338=HEAPU8[($337)];
      var $339=(($338)&255);
      var $340=$2;
      var $341=(($340+$339)|0);
      $2=$341;
      var $342=$2;
      var $343=$sum2;
      var $344=(($343+$342)|0);
      $sum2=$344;
      var $345=$3;
      var $346=(($345+11)|0);
      var $347=HEAPU8[($346)];
      var $348=(($347)&255);
      var $349=$2;
      var $350=(($349+$348)|0);
      $2=$350;
      var $351=$2;
      var $352=$sum2;
      var $353=(($352+$351)|0);
      $sum2=$353;
      var $354=$3;
      var $355=(($354+12)|0);
      var $356=HEAPU8[($355)];
      var $357=(($356)&255);
      var $358=$2;
      var $359=(($358+$357)|0);
      $2=$359;
      var $360=$2;
      var $361=$sum2;
      var $362=(($361+$360)|0);
      $sum2=$362;
      var $363=$3;
      var $364=(($363+13)|0);
      var $365=HEAPU8[($364)];
      var $366=(($365)&255);
      var $367=$2;
      var $368=(($367+$366)|0);
      $2=$368;
      var $369=$2;
      var $370=$sum2;
      var $371=(($370+$369)|0);
      $sum2=$371;
      var $372=$3;
      var $373=(($372+14)|0);
      var $374=HEAPU8[($373)];
      var $375=(($374)&255);
      var $376=$2;
      var $377=(($376+$375)|0);
      $2=$377;
      var $378=$2;
      var $379=$sum2;
      var $380=(($379+$378)|0);
      $sum2=$380;
      var $381=$3;
      var $382=(($381+15)|0);
      var $383=HEAPU8[($382)];
      var $384=(($383)&255);
      var $385=$2;
      var $386=(($385+$384)|0);
      $2=$386;
      var $387=$2;
      var $388=$sum2;
      var $389=(($388+$387)|0);
      $sum2=$389;
      var $390=$3;
      var $391=(($390+16)|0);
      $3=$391;
      __label__ = 23; break;
    case 25: // $392
      __label__ = 26; break;
    case 26: // $393
      var $394=$4;
      var $395=(($394-1)|0);
      $4=$395;
      var $396=(($394)|0)!=0;
      if ($396) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $397
      var $398=$3;
      var $399=(($398+1)|0);
      $3=$399;
      var $400=HEAPU8[($398)];
      var $401=(($400)&255);
      var $402=$2;
      var $403=(($402+$401)|0);
      $2=$403;
      var $404=$2;
      var $405=$sum2;
      var $406=(($405+$404)|0);
      $sum2=$406;
      __label__ = 26; break;
    case 28: // $407
      var $408=$2;
      var $409=(($408)>>>0)%65521;
      $2=$409;
      var $410=$sum2;
      var $411=(($410)>>>0)%65521;
      $sum2=$411;
      __label__ = 29; break;
    case 29: // $412
      var $413=$2;
      var $414=$sum2;
      var $415=$414 << 16;
      var $416=$413 | $415;
      $1=$416;
      __label__ = 30; break;
    case 30: // $417
      var $418=$1;
      ;
      return $418;
    default: assert(0, "bad label: " + __label__);
  }
}
_adler32["X"]=1;

function _init_block($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $n;
      $1=$s;
      $n=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$n;
      var $4=(($3)|0) < 286;
      if ($4) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $5
      var $6=$n;
      var $7=$1;
      var $8=(($7+148)|0);
      var $9=(($8+($6<<2))|0);
      var $10=(($9)|0);
      var $11=$10;
      HEAP16[(($11)>>1)]=0;
      __label__ = 3; break;
    case 3: // $12
      var $13=$n;
      var $14=(($13+1)|0);
      $n=$14;
      __label__ = 1; break;
    case 4: // $15
      $n=0;
      __label__ = 5; break;
    case 5: // $16
      var $17=$n;
      var $18=(($17)|0) < 30;
      if ($18) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $19
      var $20=$n;
      var $21=$1;
      var $22=(($21+2440)|0);
      var $23=(($22+($20<<2))|0);
      var $24=(($23)|0);
      var $25=$24;
      HEAP16[(($25)>>1)]=0;
      __label__ = 7; break;
    case 7: // $26
      var $27=$n;
      var $28=(($27+1)|0);
      $n=$28;
      __label__ = 5; break;
    case 8: // $29
      $n=0;
      __label__ = 9; break;
    case 9: // $30
      var $31=$n;
      var $32=(($31)|0) < 19;
      if ($32) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $33
      var $34=$n;
      var $35=$1;
      var $36=(($35+2684)|0);
      var $37=(($36+($34<<2))|0);
      var $38=(($37)|0);
      var $39=$38;
      HEAP16[(($39)>>1)]=0;
      __label__ = 11; break;
    case 11: // $40
      var $41=$n;
      var $42=(($41+1)|0);
      $n=$42;
      __label__ = 9; break;
    case 12: // $43
      var $44=$1;
      var $45=(($44+148)|0);
      var $46=(($45+1024)|0);
      var $47=(($46)|0);
      var $48=$47;
      HEAP16[(($48)>>1)]=1;
      var $49=$1;
      var $50=(($49+5804)|0);
      HEAP32[(($50)>>2)]=0;
      var $51=$1;
      var $52=(($51+5800)|0);
      HEAP32[(($52)>>2)]=0;
      var $53=$1;
      var $54=(($53+5808)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=$1;
      var $56=(($55+5792)|0);
      HEAP32[(($56)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_init_block["X"]=1;

function __tr_init($s) {
  ;
  var __label__;

  var $1;
  $1=$s;
  _tr_static_init();
  var $2=$1;
  var $3=(($2+148)|0);
  var $4=(($3)|0);
  var $5=$1;
  var $6=(($5+2840)|0);
  var $7=(($6)|0);
  HEAP32[(($7)>>2)]=$4;
  var $8=$1;
  var $9=(($8+2840)|0);
  var $10=(($9+8)|0);
  HEAP32[(($10)>>2)]=_static_l_desc;
  var $11=$1;
  var $12=(($11+2440)|0);
  var $13=(($12)|0);
  var $14=$1;
  var $15=(($14+2852)|0);
  var $16=(($15)|0);
  HEAP32[(($16)>>2)]=$13;
  var $17=$1;
  var $18=(($17+2852)|0);
  var $19=(($18+8)|0);
  HEAP32[(($19)>>2)]=_static_d_desc;
  var $20=$1;
  var $21=(($20+2684)|0);
  var $22=(($21)|0);
  var $23=$1;
  var $24=(($23+2864)|0);
  var $25=(($24)|0);
  HEAP32[(($25)>>2)]=$22;
  var $26=$1;
  var $27=(($26+2864)|0);
  var $28=(($27+8)|0);
  HEAP32[(($28)>>2)]=_static_bl_desc;
  var $29=$1;
  var $30=(($29+5816)|0);
  HEAP16[(($30)>>1)]=0;
  var $31=$1;
  var $32=(($31+5820)|0);
  HEAP32[(($32)>>2)]=0;
  var $33=$1;
  var $34=(($33+5812)|0);
  HEAP32[(($34)>>2)]=8;
  var $35=$1;
  _init_block($35);
  ;
  return;
}


function __tr_stored_block($s, $buf, $stored_len, $eof) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $len;
      var $val;
      $1=$s;
      $2=$buf;
      $3=$stored_len;
      $4=$eof;
      $len=3;
      var $5=$1;
      var $6=(($5+5820)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$len;
      var $9=((16-$8)|0);
      var $10=(($7)|0) > (($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$4;
      var $13=(($12)|0);
      $val=$13;
      var $14=$val;
      var $15=$1;
      var $16=(($15+5820)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$14 << $17;
      var $19=$1;
      var $20=(($19+5816)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=$22 | $18;
      var $24=(($23) & 65535);
      HEAP16[(($20)>>1)]=$24;
      var $25=$1;
      var $26=(($25+5816)|0);
      var $27=HEAPU16[(($26)>>1)];
      var $28=(($27)&65535);
      var $29=$28 & 255;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+20)|0);
      var $33=HEAPU32[(($32)>>2)];
      var $34=(($33+1)|0);
      HEAP32[(($32)>>2)]=$34;
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+$33)|0);
      HEAP8[($38)]=$30;
      var $39=$1;
      var $40=(($39+5816)|0);
      var $41=HEAPU16[(($40)>>1)];
      var $42=(($41)&65535);
      var $43=$42 >> 8;
      var $44=(($43) & 255);
      var $45=$1;
      var $46=(($45+20)|0);
      var $47=HEAPU32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      var $49=$1;
      var $50=(($49+8)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$47)|0);
      HEAP8[($52)]=$44;
      var $53=$val;
      var $54=(($53) & 65535);
      var $55=(($54)&65535);
      var $56=$1;
      var $57=(($56+5820)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=((16-$58)|0);
      var $60=$55 >> (($59)|0);
      var $61=(($60) & 65535);
      var $62=$1;
      var $63=(($62+5816)|0);
      HEAP16[(($63)>>1)]=$61;
      var $64=$len;
      var $65=(($64-16)|0);
      var $66=$1;
      var $67=(($66+5820)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+$65)|0);
      HEAP32[(($67)>>2)]=$69;
      __label__ = 3; break;
    case 2: // $70
      var $71=$4;
      var $72=(($71)|0);
      var $73=$1;
      var $74=(($73+5820)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$72 << $75;
      var $77=$1;
      var $78=(($77+5816)|0);
      var $79=HEAPU16[(($78)>>1)];
      var $80=(($79)&65535);
      var $81=$80 | $76;
      var $82=(($81) & 65535);
      HEAP16[(($78)>>1)]=$82;
      var $83=$len;
      var $84=$1;
      var $85=(($84+5820)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+$83)|0);
      HEAP32[(($85)>>2)]=$87;
      __label__ = 3; break;
    case 3: // $88
      var $89=$1;
      var $90=$2;
      var $91=$3;
      _copy_block($89, $90, $91, 1);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__tr_stored_block["X"]=1;

function _copy_block($s, $buf, $len, $header) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$s;
      $2=$buf;
      $3=$len;
      $4=$header;
      var $5=$1;
      _bi_windup($5);
      var $6=$1;
      var $7=(($6+5812)|0);
      HEAP32[(($7)>>2)]=8;
      var $8=$4;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$3;
      var $12=(($11) & 65535);
      var $13=(($12)&65535);
      var $14=$13 & 255;
      var $15=(($14) & 255);
      var $16=$1;
      var $17=(($16+20)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($18+1)|0);
      HEAP32[(($17)>>2)]=$19;
      var $20=$1;
      var $21=(($20+8)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+$18)|0);
      HEAP8[($23)]=$15;
      var $24=$3;
      var $25=(($24) & 65535);
      var $26=(($25)&65535);
      var $27=$26 >> 8;
      var $28=(($27) & 255);
      var $29=$1;
      var $30=(($29+20)|0);
      var $31=HEAPU32[(($30)>>2)];
      var $32=(($31+1)|0);
      HEAP32[(($30)>>2)]=$32;
      var $33=$1;
      var $34=(($33+8)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($35+$31)|0);
      HEAP8[($36)]=$28;
      var $37=$3;
      var $38=$37 ^ -1;
      var $39=(($38) & 65535);
      var $40=(($39)&65535);
      var $41=$40 & 255;
      var $42=(($41) & 255);
      var $43=$1;
      var $44=(($43+20)|0);
      var $45=HEAPU32[(($44)>>2)];
      var $46=(($45+1)|0);
      HEAP32[(($44)>>2)]=$46;
      var $47=$1;
      var $48=(($47+8)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+$45)|0);
      HEAP8[($50)]=$42;
      var $51=$3;
      var $52=$51 ^ -1;
      var $53=(($52) & 65535);
      var $54=(($53)&65535);
      var $55=$54 >> 8;
      var $56=(($55) & 255);
      var $57=$1;
      var $58=(($57+20)|0);
      var $59=HEAPU32[(($58)>>2)];
      var $60=(($59+1)|0);
      HEAP32[(($58)>>2)]=$60;
      var $61=$1;
      var $62=(($61+8)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+$59)|0);
      HEAP8[($64)]=$56;
      __label__ = 2; break;
    case 2: // $65
      __label__ = 3; break;
    case 3: // $66
      var $67=$3;
      var $68=(($67-1)|0);
      $3=$68;
      var $69=(($67)|0)!=0;
      if ($69) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $70
      var $71=$2;
      var $72=(($71+1)|0);
      $2=$72;
      var $73=HEAP8[($71)];
      var $74=$1;
      var $75=(($74+20)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76+1)|0);
      HEAP32[(($75)>>2)]=$77;
      var $78=$1;
      var $79=(($78+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+$76)|0);
      HEAP8[($81)]=$73;
      __label__ = 3; break;
    case 5: // $82
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_copy_block["X"]=1;

function _bi_flush($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$s;
      var $2=$1;
      var $3=(($2+5820)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)==16;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+5816)|0);
      var $9=HEAPU16[(($8)>>1)];
      var $10=(($9)&65535);
      var $11=$10 & 255;
      var $12=(($11) & 255);
      var $13=$1;
      var $14=(($13+20)|0);
      var $15=HEAPU32[(($14)>>2)];
      var $16=(($15+1)|0);
      HEAP32[(($14)>>2)]=$16;
      var $17=$1;
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+$15)|0);
      HEAP8[($20)]=$12;
      var $21=$1;
      var $22=(($21+5816)|0);
      var $23=HEAPU16[(($22)>>1)];
      var $24=(($23)&65535);
      var $25=$24 >> 8;
      var $26=(($25) & 255);
      var $27=$1;
      var $28=(($27+20)|0);
      var $29=HEAPU32[(($28)>>2)];
      var $30=(($29+1)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$1;
      var $32=(($31+8)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$29)|0);
      HEAP8[($34)]=$26;
      var $35=$1;
      var $36=(($35+5816)|0);
      HEAP16[(($36)>>1)]=0;
      var $37=$1;
      var $38=(($37+5820)|0);
      HEAP32[(($38)>>2)]=0;
      __label__ = 5; break;
    case 2: // $39
      var $40=$1;
      var $41=(($40+5820)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0) >= 8;
      if ($43) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $44
      var $45=$1;
      var $46=(($45+5816)|0);
      var $47=HEAP16[(($46)>>1)];
      var $48=(($47) & 255);
      var $49=$1;
      var $50=(($49+20)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+1)|0);
      HEAP32[(($50)>>2)]=$52;
      var $53=$1;
      var $54=(($53+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+$51)|0);
      HEAP8[($56)]=$48;
      var $57=$1;
      var $58=(($57+5816)|0);
      var $59=HEAPU16[(($58)>>1)];
      var $60=(($59)&65535);
      var $61=$60 >> 8;
      var $62=(($61) & 65535);
      HEAP16[(($58)>>1)]=$62;
      var $63=$1;
      var $64=(($63+5820)|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=(($65-8)|0);
      HEAP32[(($64)>>2)]=$66;
      __label__ = 4; break;
    case 4: // $67
      __label__ = 5; break;
    case 5: // $68
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_bi_flush["X"]=1;

function _set_data_type($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $n;
      $1=$s;
      $n=0;
      __label__ = 1; break;
    case 1: // $2
      var $3=$n;
      var $4=(($3)|0) < 9;
      if ($4) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $5
      var $6=$n;
      var $7=$1;
      var $8=(($7+148)|0);
      var $9=(($8+($6<<2))|0);
      var $10=(($9)|0);
      var $11=$10;
      var $12=HEAPU16[(($11)>>1)];
      var $13=(($12)&65535);
      var $14=(($13)|0)!=0;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      __label__ = 6; break;
    case 4: // $16
      __label__ = 5; break;
    case 5: // $17
      var $18=$n;
      var $19=(($18+1)|0);
      $n=$19;
      __label__ = 1; break;
    case 6: // $20
      var $21=$n;
      var $22=(($21)|0)==9;
      if ($22) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $23
      $n=14;
      __label__ = 8; break;
    case 8: // $24
      var $25=$n;
      var $26=(($25)|0) < 32;
      if ($26) { __label__ = 9; break; } else { __label__ = 13; break; }
    case 9: // $27
      var $28=$n;
      var $29=$1;
      var $30=(($29+148)|0);
      var $31=(($30+($28<<2))|0);
      var $32=(($31)|0);
      var $33=$32;
      var $34=HEAPU16[(($33)>>1)];
      var $35=(($34)&65535);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $37
      __label__ = 13; break;
    case 11: // $38
      __label__ = 12; break;
    case 12: // $39
      var $40=$n;
      var $41=(($40+1)|0);
      $n=$41;
      __label__ = 8; break;
    case 13: // $42
      __label__ = 14; break;
    case 14: // $43
      var $44=$n;
      var $45=(($44)|0)==32;
      var $46=$45 ? 1 : 0;
      var $47=$1;
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+44)|0);
      HEAP32[(($50)>>2)]=$46;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_set_data_type["X"]=1;

function __tr_align($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $len;
      var $val;
      var $len1;
      var $val2;
      var $len3;
      var $val4;
      var $len5;
      var $val6;
      $1=$s;
      $len=3;
      var $2=$1;
      var $3=(($2+5820)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$len;
      var $6=((16-$5)|0);
      var $7=(($4)|0) > (($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      $val=2;
      var $9=$val;
      var $10=$1;
      var $11=(($10+5820)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=$9 << $12;
      var $14=$1;
      var $15=(($14+5816)|0);
      var $16=HEAPU16[(($15)>>1)];
      var $17=(($16)&65535);
      var $18=$17 | $13;
      var $19=(($18) & 65535);
      HEAP16[(($15)>>1)]=$19;
      var $20=$1;
      var $21=(($20+5816)|0);
      var $22=HEAPU16[(($21)>>1)];
      var $23=(($22)&65535);
      var $24=$23 & 255;
      var $25=(($24) & 255);
      var $26=$1;
      var $27=(($26+20)|0);
      var $28=HEAPU32[(($27)>>2)];
      var $29=(($28+1)|0);
      HEAP32[(($27)>>2)]=$29;
      var $30=$1;
      var $31=(($30+8)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+$28)|0);
      HEAP8[($33)]=$25;
      var $34=$1;
      var $35=(($34+5816)|0);
      var $36=HEAPU16[(($35)>>1)];
      var $37=(($36)&65535);
      var $38=$37 >> 8;
      var $39=(($38) & 255);
      var $40=$1;
      var $41=(($40+20)|0);
      var $42=HEAPU32[(($41)>>2)];
      var $43=(($42+1)|0);
      HEAP32[(($41)>>2)]=$43;
      var $44=$1;
      var $45=(($44+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+$42)|0);
      HEAP8[($47)]=$39;
      var $48=$val;
      var $49=(($48) & 65535);
      var $50=(($49)&65535);
      var $51=$1;
      var $52=(($51+5820)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=((16-$53)|0);
      var $55=$50 >> (($54)|0);
      var $56=(($55) & 65535);
      var $57=$1;
      var $58=(($57+5816)|0);
      HEAP16[(($58)>>1)]=$56;
      var $59=$len;
      var $60=(($59-16)|0);
      var $61=$1;
      var $62=(($61+5820)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63+$60)|0);
      HEAP32[(($62)>>2)]=$64;
      __label__ = 3; break;
    case 2: // $65
      var $66=$1;
      var $67=(($66+5820)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=2 << $68;
      var $70=$1;
      var $71=(($70+5816)|0);
      var $72=HEAPU16[(($71)>>1)];
      var $73=(($72)&65535);
      var $74=$73 | $69;
      var $75=(($74) & 65535);
      HEAP16[(($71)>>1)]=$75;
      var $76=$len;
      var $77=$1;
      var $78=(($77+5820)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79+$76)|0);
      HEAP32[(($78)>>2)]=$80;
      __label__ = 3; break;
    case 3: // $81
      var $82=HEAPU16[((((_static_ltree+1026)|0))>>1)];
      var $83=(($82)&65535);
      $len1=$83;
      var $84=$1;
      var $85=(($84+5820)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$len1;
      var $88=((16-$87)|0);
      var $89=(($86)|0) > (($88)|0);
      if ($89) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $90
      var $91=HEAPU16[((((_static_ltree+1024)|0))>>1)];
      var $92=(($91)&65535);
      $val2=$92;
      var $93=$val2;
      var $94=$1;
      var $95=(($94+5820)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$93 << $96;
      var $98=$1;
      var $99=(($98+5816)|0);
      var $100=HEAPU16[(($99)>>1)];
      var $101=(($100)&65535);
      var $102=$101 | $97;
      var $103=(($102) & 65535);
      HEAP16[(($99)>>1)]=$103;
      var $104=$1;
      var $105=(($104+5816)|0);
      var $106=HEAPU16[(($105)>>1)];
      var $107=(($106)&65535);
      var $108=$107 & 255;
      var $109=(($108) & 255);
      var $110=$1;
      var $111=(($110+20)|0);
      var $112=HEAPU32[(($111)>>2)];
      var $113=(($112+1)|0);
      HEAP32[(($111)>>2)]=$113;
      var $114=$1;
      var $115=(($114+8)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116+$112)|0);
      HEAP8[($117)]=$109;
      var $118=$1;
      var $119=(($118+5816)|0);
      var $120=HEAPU16[(($119)>>1)];
      var $121=(($120)&65535);
      var $122=$121 >> 8;
      var $123=(($122) & 255);
      var $124=$1;
      var $125=(($124+20)|0);
      var $126=HEAPU32[(($125)>>2)];
      var $127=(($126+1)|0);
      HEAP32[(($125)>>2)]=$127;
      var $128=$1;
      var $129=(($128+8)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+$126)|0);
      HEAP8[($131)]=$123;
      var $132=$val2;
      var $133=(($132) & 65535);
      var $134=(($133)&65535);
      var $135=$1;
      var $136=(($135+5820)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=((16-$137)|0);
      var $139=$134 >> (($138)|0);
      var $140=(($139) & 65535);
      var $141=$1;
      var $142=(($141+5816)|0);
      HEAP16[(($142)>>1)]=$140;
      var $143=$len1;
      var $144=(($143-16)|0);
      var $145=$1;
      var $146=(($145+5820)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($147+$144)|0);
      HEAP32[(($146)>>2)]=$148;
      __label__ = 6; break;
    case 5: // $149
      var $150=HEAPU16[((((_static_ltree+1024)|0))>>1)];
      var $151=(($150)&65535);
      var $152=$1;
      var $153=(($152+5820)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$151 << $154;
      var $156=$1;
      var $157=(($156+5816)|0);
      var $158=HEAPU16[(($157)>>1)];
      var $159=(($158)&65535);
      var $160=$159 | $155;
      var $161=(($160) & 65535);
      HEAP16[(($157)>>1)]=$161;
      var $162=$len1;
      var $163=$1;
      var $164=(($163+5820)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165+$162)|0);
      HEAP32[(($164)>>2)]=$166;
      __label__ = 6; break;
    case 6: // $167
      var $168=$1;
      _bi_flush($168);
      var $169=$1;
      var $170=(($169+5812)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=(($171+1)|0);
      var $173=(($172+10)|0);
      var $174=$1;
      var $175=(($174+5820)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=(($173-$176)|0);
      var $178=(($177)|0) < 9;
      if ($178) { __label__ = 7; break; } else { __label__ = 14; break; }
    case 7: // $179
      $len3=3;
      var $180=$1;
      var $181=(($180+5820)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$len3;
      var $184=((16-$183)|0);
      var $185=(($182)|0) > (($184)|0);
      if ($185) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $186
      $val4=2;
      var $187=$val4;
      var $188=$1;
      var $189=(($188+5820)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=$187 << $190;
      var $192=$1;
      var $193=(($192+5816)|0);
      var $194=HEAPU16[(($193)>>1)];
      var $195=(($194)&65535);
      var $196=$195 | $191;
      var $197=(($196) & 65535);
      HEAP16[(($193)>>1)]=$197;
      var $198=$1;
      var $199=(($198+5816)|0);
      var $200=HEAPU16[(($199)>>1)];
      var $201=(($200)&65535);
      var $202=$201 & 255;
      var $203=(($202) & 255);
      var $204=$1;
      var $205=(($204+20)|0);
      var $206=HEAPU32[(($205)>>2)];
      var $207=(($206+1)|0);
      HEAP32[(($205)>>2)]=$207;
      var $208=$1;
      var $209=(($208+8)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=(($210+$206)|0);
      HEAP8[($211)]=$203;
      var $212=$1;
      var $213=(($212+5816)|0);
      var $214=HEAPU16[(($213)>>1)];
      var $215=(($214)&65535);
      var $216=$215 >> 8;
      var $217=(($216) & 255);
      var $218=$1;
      var $219=(($218+20)|0);
      var $220=HEAPU32[(($219)>>2)];
      var $221=(($220+1)|0);
      HEAP32[(($219)>>2)]=$221;
      var $222=$1;
      var $223=(($222+8)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224+$220)|0);
      HEAP8[($225)]=$217;
      var $226=$val4;
      var $227=(($226) & 65535);
      var $228=(($227)&65535);
      var $229=$1;
      var $230=(($229+5820)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=((16-$231)|0);
      var $233=$228 >> (($232)|0);
      var $234=(($233) & 65535);
      var $235=$1;
      var $236=(($235+5816)|0);
      HEAP16[(($236)>>1)]=$234;
      var $237=$len3;
      var $238=(($237-16)|0);
      var $239=$1;
      var $240=(($239+5820)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241+$238)|0);
      HEAP32[(($240)>>2)]=$242;
      __label__ = 10; break;
    case 9: // $243
      var $244=$1;
      var $245=(($244+5820)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=2 << $246;
      var $248=$1;
      var $249=(($248+5816)|0);
      var $250=HEAPU16[(($249)>>1)];
      var $251=(($250)&65535);
      var $252=$251 | $247;
      var $253=(($252) & 65535);
      HEAP16[(($249)>>1)]=$253;
      var $254=$len3;
      var $255=$1;
      var $256=(($255+5820)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($257+$254)|0);
      HEAP32[(($256)>>2)]=$258;
      __label__ = 10; break;
    case 10: // $259
      var $260=HEAPU16[((((_static_ltree+1026)|0))>>1)];
      var $261=(($260)&65535);
      $len5=$261;
      var $262=$1;
      var $263=(($262+5820)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$len5;
      var $266=((16-$265)|0);
      var $267=(($264)|0) > (($266)|0);
      if ($267) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $268
      var $269=HEAPU16[((((_static_ltree+1024)|0))>>1)];
      var $270=(($269)&65535);
      $val6=$270;
      var $271=$val6;
      var $272=$1;
      var $273=(($272+5820)|0);
      var $274=HEAP32[(($273)>>2)];
      var $275=$271 << $274;
      var $276=$1;
      var $277=(($276+5816)|0);
      var $278=HEAPU16[(($277)>>1)];
      var $279=(($278)&65535);
      var $280=$279 | $275;
      var $281=(($280) & 65535);
      HEAP16[(($277)>>1)]=$281;
      var $282=$1;
      var $283=(($282+5816)|0);
      var $284=HEAPU16[(($283)>>1)];
      var $285=(($284)&65535);
      var $286=$285 & 255;
      var $287=(($286) & 255);
      var $288=$1;
      var $289=(($288+20)|0);
      var $290=HEAPU32[(($289)>>2)];
      var $291=(($290+1)|0);
      HEAP32[(($289)>>2)]=$291;
      var $292=$1;
      var $293=(($292+8)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294+$290)|0);
      HEAP8[($295)]=$287;
      var $296=$1;
      var $297=(($296+5816)|0);
      var $298=HEAPU16[(($297)>>1)];
      var $299=(($298)&65535);
      var $300=$299 >> 8;
      var $301=(($300) & 255);
      var $302=$1;
      var $303=(($302+20)|0);
      var $304=HEAPU32[(($303)>>2)];
      var $305=(($304+1)|0);
      HEAP32[(($303)>>2)]=$305;
      var $306=$1;
      var $307=(($306+8)|0);
      var $308=HEAP32[(($307)>>2)];
      var $309=(($308+$304)|0);
      HEAP8[($309)]=$301;
      var $310=$val6;
      var $311=(($310) & 65535);
      var $312=(($311)&65535);
      var $313=$1;
      var $314=(($313+5820)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=((16-$315)|0);
      var $317=$312 >> (($316)|0);
      var $318=(($317) & 65535);
      var $319=$1;
      var $320=(($319+5816)|0);
      HEAP16[(($320)>>1)]=$318;
      var $321=$len5;
      var $322=(($321-16)|0);
      var $323=$1;
      var $324=(($323+5820)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($325+$322)|0);
      HEAP32[(($324)>>2)]=$326;
      __label__ = 13; break;
    case 12: // $327
      var $328=HEAPU16[((((_static_ltree+1024)|0))>>1)];
      var $329=(($328)&65535);
      var $330=$1;
      var $331=(($330+5820)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=$329 << $332;
      var $334=$1;
      var $335=(($334+5816)|0);
      var $336=HEAPU16[(($335)>>1)];
      var $337=(($336)&65535);
      var $338=$337 | $333;
      var $339=(($338) & 65535);
      HEAP16[(($335)>>1)]=$339;
      var $340=$len5;
      var $341=$1;
      var $342=(($341+5820)|0);
      var $343=HEAP32[(($342)>>2)];
      var $344=(($343+$340)|0);
      HEAP32[(($342)>>2)]=$344;
      __label__ = 13; break;
    case 13: // $345
      var $346=$1;
      _bi_flush($346);
      __label__ = 14; break;
    case 14: // $347
      var $348=$1;
      var $349=(($348+5812)|0);
      HEAP32[(($349)>>2)]=7;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__tr_align["X"]=1;

function __tr_flush_block($s, $buf, $stored_len, $eof) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $opt_lenb;
      var $static_lenb;
      var $max_blindex;
      var $len;
      var $val;
      var $len1;
      var $val2;
      $1=$s;
      $2=$buf;
      $3=$stored_len;
      $4=$eof;
      $max_blindex=0;
      var $5=$1;
      var $6=(($5+132)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0) > 0;
      if ($8) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $9
      var $10=$3;
      var $11=(($10)>>>0) > 0;
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $12
      var $13=$1;
      var $14=(($13)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+44)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17)|0)==2;
      if ($18) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $19
      var $20=$1;
      _set_data_type($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$1;
      var $23=$1;
      var $24=(($23+2840)|0);
      _build_tree($22, $24);
      var $25=$1;
      var $26=$1;
      var $27=(($26+2852)|0);
      _build_tree($25, $27);
      var $28=$1;
      var $29=_build_bl_tree($28);
      $max_blindex=$29;
      var $30=$1;
      var $31=(($30+5800)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+3)|0);
      var $34=(($33+7)|0);
      var $35=$34 >>> 3;
      $opt_lenb=$35;
      var $36=$1;
      var $37=(($36+5804)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+3)|0);
      var $40=(($39+7)|0);
      var $41=$40 >>> 3;
      $static_lenb=$41;
      var $42=$static_lenb;
      var $43=$opt_lenb;
      var $44=(($42)>>>0) <= (($43)>>>0);
      if ($44) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $45
      var $46=$static_lenb;
      $opt_lenb=$46;
      __label__ = 6; break;
    case 6: // $47
      __label__ = 8; break;
    case 7: // $48
      var $49=$3;
      var $50=(($49+5)|0);
      $static_lenb=$50;
      $opt_lenb=$50;
      __label__ = 8; break;
    case 8: // $51
      var $52=$3;
      var $53=(($52+4)|0);
      var $54=$opt_lenb;
      var $55=(($53)>>>0) <= (($54)>>>0);
      if ($55) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $56
      var $57=$2;
      var $58=(($57)|0)!=0;
      if ($58) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $59
      var $60=$1;
      var $61=$2;
      var $62=$3;
      var $63=$4;
      __tr_stored_block($60, $61, $62, $63);
      __label__ = 22; break;
    case 11: // $64
      var $65=$1;
      var $66=(($65+136)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67)|0)==4;
      if ($68) { __label__ = 13; break; } else { __label__ = 12; break; }
    case 12: // $69
      var $70=$static_lenb;
      var $71=$opt_lenb;
      var $72=(($70)|0)==(($71)|0);
      if ($72) { __label__ = 13; break; } else { __label__ = 17; break; }
    case 13: // $73
      $len=3;
      var $74=$1;
      var $75=(($74+5820)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=$len;
      var $78=((16-$77)|0);
      var $79=(($76)|0) > (($78)|0);
      if ($79) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $80
      var $81=$4;
      var $82=(($81+2)|0);
      $val=$82;
      var $83=$val;
      var $84=$1;
      var $85=(($84+5820)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$83 << $86;
      var $88=$1;
      var $89=(($88+5816)|0);
      var $90=HEAPU16[(($89)>>1)];
      var $91=(($90)&65535);
      var $92=$91 | $87;
      var $93=(($92) & 65535);
      HEAP16[(($89)>>1)]=$93;
      var $94=$1;
      var $95=(($94+5816)|0);
      var $96=HEAPU16[(($95)>>1)];
      var $97=(($96)&65535);
      var $98=$97 & 255;
      var $99=(($98) & 255);
      var $100=$1;
      var $101=(($100+20)|0);
      var $102=HEAPU32[(($101)>>2)];
      var $103=(($102+1)|0);
      HEAP32[(($101)>>2)]=$103;
      var $104=$1;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106+$102)|0);
      HEAP8[($107)]=$99;
      var $108=$1;
      var $109=(($108+5816)|0);
      var $110=HEAPU16[(($109)>>1)];
      var $111=(($110)&65535);
      var $112=$111 >> 8;
      var $113=(($112) & 255);
      var $114=$1;
      var $115=(($114+20)|0);
      var $116=HEAPU32[(($115)>>2)];
      var $117=(($116+1)|0);
      HEAP32[(($115)>>2)]=$117;
      var $118=$1;
      var $119=(($118+8)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+$116)|0);
      HEAP8[($121)]=$113;
      var $122=$val;
      var $123=(($122) & 65535);
      var $124=(($123)&65535);
      var $125=$1;
      var $126=(($125+5820)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=((16-$127)|0);
      var $129=$124 >> (($128)|0);
      var $130=(($129) & 65535);
      var $131=$1;
      var $132=(($131+5816)|0);
      HEAP16[(($132)>>1)]=$130;
      var $133=$len;
      var $134=(($133-16)|0);
      var $135=$1;
      var $136=(($135+5820)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+$134)|0);
      HEAP32[(($136)>>2)]=$138;
      __label__ = 16; break;
    case 15: // $139
      var $140=$4;
      var $141=(($140+2)|0);
      var $142=$1;
      var $143=(($142+5820)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=$141 << $144;
      var $146=$1;
      var $147=(($146+5816)|0);
      var $148=HEAPU16[(($147)>>1)];
      var $149=(($148)&65535);
      var $150=$149 | $145;
      var $151=(($150) & 65535);
      HEAP16[(($147)>>1)]=$151;
      var $152=$len;
      var $153=$1;
      var $154=(($153+5820)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+$152)|0);
      HEAP32[(($154)>>2)]=$156;
      __label__ = 16; break;
    case 16: // $157
      var $158=$1;
      _compress_block($158, ((_static_ltree)|0), ((_static_dtree)|0));
      __label__ = 21; break;
    case 17: // $159
      $len1=3;
      var $160=$1;
      var $161=(($160+5820)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$len1;
      var $164=((16-$163)|0);
      var $165=(($162)|0) > (($164)|0);
      if ($165) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $166
      var $167=$4;
      var $168=(($167+4)|0);
      $val2=$168;
      var $169=$val2;
      var $170=$1;
      var $171=(($170+5820)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=$169 << $172;
      var $174=$1;
      var $175=(($174+5816)|0);
      var $176=HEAPU16[(($175)>>1)];
      var $177=(($176)&65535);
      var $178=$177 | $173;
      var $179=(($178) & 65535);
      HEAP16[(($175)>>1)]=$179;
      var $180=$1;
      var $181=(($180+5816)|0);
      var $182=HEAPU16[(($181)>>1)];
      var $183=(($182)&65535);
      var $184=$183 & 255;
      var $185=(($184) & 255);
      var $186=$1;
      var $187=(($186+20)|0);
      var $188=HEAPU32[(($187)>>2)];
      var $189=(($188+1)|0);
      HEAP32[(($187)>>2)]=$189;
      var $190=$1;
      var $191=(($190+8)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+$188)|0);
      HEAP8[($193)]=$185;
      var $194=$1;
      var $195=(($194+5816)|0);
      var $196=HEAPU16[(($195)>>1)];
      var $197=(($196)&65535);
      var $198=$197 >> 8;
      var $199=(($198) & 255);
      var $200=$1;
      var $201=(($200+20)|0);
      var $202=HEAPU32[(($201)>>2)];
      var $203=(($202+1)|0);
      HEAP32[(($201)>>2)]=$203;
      var $204=$1;
      var $205=(($204+8)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206+$202)|0);
      HEAP8[($207)]=$199;
      var $208=$val2;
      var $209=(($208) & 65535);
      var $210=(($209)&65535);
      var $211=$1;
      var $212=(($211+5820)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=((16-$213)|0);
      var $215=$210 >> (($214)|0);
      var $216=(($215) & 65535);
      var $217=$1;
      var $218=(($217+5816)|0);
      HEAP16[(($218)>>1)]=$216;
      var $219=$len1;
      var $220=(($219-16)|0);
      var $221=$1;
      var $222=(($221+5820)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(($223+$220)|0);
      HEAP32[(($222)>>2)]=$224;
      __label__ = 20; break;
    case 19: // $225
      var $226=$4;
      var $227=(($226+4)|0);
      var $228=$1;
      var $229=(($228+5820)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$227 << $230;
      var $232=$1;
      var $233=(($232+5816)|0);
      var $234=HEAPU16[(($233)>>1)];
      var $235=(($234)&65535);
      var $236=$235 | $231;
      var $237=(($236) & 65535);
      HEAP16[(($233)>>1)]=$237;
      var $238=$len1;
      var $239=$1;
      var $240=(($239+5820)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241+$238)|0);
      HEAP32[(($240)>>2)]=$242;
      __label__ = 20; break;
    case 20: // $243
      var $244=$1;
      var $245=$1;
      var $246=(($245+2840)|0);
      var $247=(($246+4)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=(($248+1)|0);
      var $250=$1;
      var $251=(($250+2852)|0);
      var $252=(($251+4)|0);
      var $253=HEAP32[(($252)>>2)];
      var $254=(($253+1)|0);
      var $255=$max_blindex;
      var $256=(($255+1)|0);
      _send_all_trees($244, $249, $254, $256);
      var $257=$1;
      var $258=$1;
      var $259=(($258+148)|0);
      var $260=(($259)|0);
      var $261=$1;
      var $262=(($261+2440)|0);
      var $263=(($262)|0);
      _compress_block($257, $260, $263);
      __label__ = 21; break;
    case 21: // $264
      __label__ = 22; break;
    case 22: // $265
      var $266=$1;
      _init_block($266);
      var $267=$4;
      var $268=(($267)|0)!=0;
      if ($268) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $269
      var $270=$1;
      _bi_windup($270);
      __label__ = 24; break;
    case 24: // $271
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__tr_flush_block["X"]=1;

function _build_tree($s, $desc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tree;
      var $stree;
      var $elems;
      var $n;
      var $m;
      var $max_code;
      var $node;
      $1=$s;
      $2=$desc;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $tree=$5;
      var $6=$2;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0);
      var $10=HEAP32[(($9)>>2)];
      $stree=$10;
      var $11=$2;
      var $12=(($11+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+12)|0);
      var $15=HEAP32[(($14)>>2)];
      $elems=$15;
      $max_code=-1;
      var $16=$1;
      var $17=(($16+5200)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=$1;
      var $19=(($18+5204)|0);
      HEAP32[(($19)>>2)]=573;
      $n=0;
      __label__ = 1; break;
    case 1: // $20
      var $21=$n;
      var $22=$elems;
      var $23=(($21)|0) < (($22)|0);
      if ($23) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $24
      var $25=$n;
      var $26=$tree;
      var $27=(($26+($25<<2))|0);
      var $28=(($27)|0);
      var $29=$28;
      var $30=HEAPU16[(($29)>>1)];
      var $31=(($30)&65535);
      var $32=(($31)|0)!=0;
      if ($32) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $33
      var $34=$n;
      $max_code=$34;
      var $35=$1;
      var $36=(($35+5200)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+1)|0);
      HEAP32[(($36)>>2)]=$38;
      var $39=$1;
      var $40=(($39+2908)|0);
      var $41=(($40+($38<<2))|0);
      HEAP32[(($41)>>2)]=$34;
      var $42=$n;
      var $43=$1;
      var $44=(($43+5208)|0);
      var $45=(($44+$42)|0);
      HEAP8[($45)]=0;
      __label__ = 5; break;
    case 4: // $46
      var $47=$n;
      var $48=$tree;
      var $49=(($48+($47<<2))|0);
      var $50=(($49+2)|0);
      var $51=$50;
      HEAP16[(($51)>>1)]=0;
      __label__ = 5; break;
    case 5: // $52
      __label__ = 6; break;
    case 6: // $53
      var $54=$n;
      var $55=(($54+1)|0);
      $n=$55;
      __label__ = 1; break;
    case 7: // $56
      __label__ = 8; break;
    case 8: // $57
      var $58=$1;
      var $59=(($58+5200)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60)|0) < 2;
      if ($61) { __label__ = 9; break; } else { __label__ = 15; break; }
    case 9: // $62
      var $63=$max_code;
      var $64=(($63)|0) < 2;
      if ($64) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $65
      var $66=$max_code;
      var $67=(($66+1)|0);
      $max_code=$67;
      var $70 = $67;__label__ = 12; break;
    case 11: // $68
      var $70 = 0;__label__ = 12; break;
    case 12: // $69
      var $70;
      var $71=$1;
      var $72=(($71+5200)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+1)|0);
      HEAP32[(($72)>>2)]=$74;
      var $75=$1;
      var $76=(($75+2908)|0);
      var $77=(($76+($74<<2))|0);
      HEAP32[(($77)>>2)]=$70;
      $node=$70;
      var $78=$node;
      var $79=$tree;
      var $80=(($79+($78<<2))|0);
      var $81=(($80)|0);
      var $82=$81;
      HEAP16[(($82)>>1)]=1;
      var $83=$node;
      var $84=$1;
      var $85=(($84+5208)|0);
      var $86=(($85+$83)|0);
      HEAP8[($86)]=0;
      var $87=$1;
      var $88=(($87+5800)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89-1)|0);
      HEAP32[(($88)>>2)]=$90;
      var $91=$stree;
      var $92=(($91)|0)!=0;
      if ($92) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $93
      var $94=$node;
      var $95=$stree;
      var $96=(($95+($94<<2))|0);
      var $97=(($96+2)|0);
      var $98=$97;
      var $99=HEAPU16[(($98)>>1)];
      var $100=(($99)&65535);
      var $101=$1;
      var $102=(($101+5804)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103-$100)|0);
      HEAP32[(($102)>>2)]=$104;
      __label__ = 14; break;
    case 14: // $105
      __label__ = 8; break;
    case 15: // $106
      var $107=$max_code;
      var $108=$2;
      var $109=(($108+4)|0);
      HEAP32[(($109)>>2)]=$107;
      var $110=$1;
      var $111=(($110+5200)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=(((($112)|0)/2)|0);
      $n=$113;
      __label__ = 16; break;
    case 16: // $114
      var $115=$n;
      var $116=(($115)|0) >= 1;
      if ($116) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $117
      var $118=$1;
      var $119=$tree;
      var $120=$n;
      _pqdownheap($118, $119, $120);
      __label__ = 18; break;
    case 18: // $121
      var $122=$n;
      var $123=(($122-1)|0);
      $n=$123;
      __label__ = 16; break;
    case 19: // $124
      var $125=$elems;
      $node=$125;
      __label__ = 20; break;
    case 20: // $126
      var $127=$1;
      var $128=(($127+2908)|0);
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      $n=$130;
      var $131=$1;
      var $132=(($131+5200)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133-1)|0);
      HEAP32[(($132)>>2)]=$134;
      var $135=$1;
      var $136=(($135+2908)|0);
      var $137=(($136+($133<<2))|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$1;
      var $140=(($139+2908)|0);
      var $141=(($140+4)|0);
      HEAP32[(($141)>>2)]=$138;
      var $142=$1;
      var $143=$tree;
      _pqdownheap($142, $143, 1);
      var $144=$1;
      var $145=(($144+2908)|0);
      var $146=(($145+4)|0);
      var $147=HEAP32[(($146)>>2)];
      $m=$147;
      var $148=$n;
      var $149=$1;
      var $150=(($149+5204)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151-1)|0);
      HEAP32[(($150)>>2)]=$152;
      var $153=$1;
      var $154=(($153+2908)|0);
      var $155=(($154+($152<<2))|0);
      HEAP32[(($155)>>2)]=$148;
      var $156=$m;
      var $157=$1;
      var $158=(($157+5204)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($159-1)|0);
      HEAP32[(($158)>>2)]=$160;
      var $161=$1;
      var $162=(($161+2908)|0);
      var $163=(($162+($160<<2))|0);
      HEAP32[(($163)>>2)]=$156;
      var $164=$n;
      var $165=$tree;
      var $166=(($165+($164<<2))|0);
      var $167=(($166)|0);
      var $168=$167;
      var $169=HEAPU16[(($168)>>1)];
      var $170=(($169)&65535);
      var $171=$m;
      var $172=$tree;
      var $173=(($172+($171<<2))|0);
      var $174=(($173)|0);
      var $175=$174;
      var $176=HEAPU16[(($175)>>1)];
      var $177=(($176)&65535);
      var $178=(($170+$177)|0);
      var $179=(($178) & 65535);
      var $180=$node;
      var $181=$tree;
      var $182=(($181+($180<<2))|0);
      var $183=(($182)|0);
      var $184=$183;
      HEAP16[(($184)>>1)]=$179;
      var $185=$n;
      var $186=$1;
      var $187=(($186+5208)|0);
      var $188=(($187+$185)|0);
      var $189=HEAPU8[($188)];
      var $190=(($189)&255);
      var $191=$m;
      var $192=$1;
      var $193=(($192+5208)|0);
      var $194=(($193+$191)|0);
      var $195=HEAPU8[($194)];
      var $196=(($195)&255);
      var $197=(($190)|0) >= (($196)|0);
      if ($197) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $198
      var $199=$n;
      var $200=$1;
      var $201=(($200+5208)|0);
      var $202=(($201+$199)|0);
      var $203=HEAPU8[($202)];
      var $204=(($203)&255);
      var $213 = $204;__label__ = 23; break;
    case 22: // $205
      var $206=$m;
      var $207=$1;
      var $208=(($207+5208)|0);
      var $209=(($208+$206)|0);
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $213 = $211;__label__ = 23; break;
    case 23: // $212
      var $213;
      var $214=(($213+1)|0);
      var $215=(($214) & 255);
      var $216=$node;
      var $217=$1;
      var $218=(($217+5208)|0);
      var $219=(($218+$216)|0);
      HEAP8[($219)]=$215;
      var $220=$node;
      var $221=(($220) & 65535);
      var $222=$m;
      var $223=$tree;
      var $224=(($223+($222<<2))|0);
      var $225=(($224+2)|0);
      var $226=$225;
      HEAP16[(($226)>>1)]=$221;
      var $227=$n;
      var $228=$tree;
      var $229=(($228+($227<<2))|0);
      var $230=(($229+2)|0);
      var $231=$230;
      HEAP16[(($231)>>1)]=$221;
      var $232=$node;
      var $233=(($232+1)|0);
      $node=$233;
      var $234=$1;
      var $235=(($234+2908)|0);
      var $236=(($235+4)|0);
      HEAP32[(($236)>>2)]=$232;
      var $237=$1;
      var $238=$tree;
      _pqdownheap($237, $238, 1);
      __label__ = 24; break;
    case 24: // $239
      var $240=$1;
      var $241=(($240+5200)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242)|0) >= 2;
      if ($243) { __label__ = 20; break; } else { __label__ = 25; break; }
    case 25: // $244
      var $245=$1;
      var $246=(($245+2908)|0);
      var $247=(($246+4)|0);
      var $248=HEAP32[(($247)>>2)];
      var $249=$1;
      var $250=(($249+5204)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(($251-1)|0);
      HEAP32[(($250)>>2)]=$252;
      var $253=$1;
      var $254=(($253+2908)|0);
      var $255=(($254+($252<<2))|0);
      HEAP32[(($255)>>2)]=$248;
      var $256=$1;
      var $257=$2;
      _gen_bitlen($256, $257);
      var $258=$tree;
      var $259=$max_code;
      var $260=$1;
      var $261=(($260+2876)|0);
      var $262=(($261)|0);
      _gen_codes($258, $259, $262);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_build_tree["X"]=1;

function _build_bl_tree($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $max_blindex;
      $1=$s;
      var $2=$1;
      var $3=$1;
      var $4=(($3+148)|0);
      var $5=(($4)|0);
      var $6=$1;
      var $7=(($6+2840)|0);
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      _scan_tree($2, $5, $9);
      var $10=$1;
      var $11=$1;
      var $12=(($11+2440)|0);
      var $13=(($12)|0);
      var $14=$1;
      var $15=(($14+2852)|0);
      var $16=(($15+4)|0);
      var $17=HEAP32[(($16)>>2)];
      _scan_tree($10, $13, $17);
      var $18=$1;
      var $19=$1;
      var $20=(($19+2864)|0);
      _build_tree($18, $20);
      $max_blindex=18;
      __label__ = 1; break;
    case 1: // $21
      var $22=$max_blindex;
      var $23=(($22)|0) >= 3;
      if ($23) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $24
      var $25=$max_blindex;
      var $26=((STRING_TABLE._bl_order+$25)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=$1;
      var $30=(($29+2684)|0);
      var $31=(($30+($28<<2))|0);
      var $32=(($31+2)|0);
      var $33=$32;
      var $34=HEAPU16[(($33)>>1)];
      var $35=(($34)&65535);
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $37
      __label__ = 6; break;
    case 4: // $38
      __label__ = 5; break;
    case 5: // $39
      var $40=$max_blindex;
      var $41=(($40-1)|0);
      $max_blindex=$41;
      __label__ = 1; break;
    case 6: // $42
      var $43=$max_blindex;
      var $44=(($43+1)|0);
      var $45=(($44*3)|0);
      var $46=(($45+5)|0);
      var $47=(($46+5)|0);
      var $48=(($47+4)|0);
      var $49=$1;
      var $50=(($49+5800)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$48)|0);
      HEAP32[(($50)>>2)]=$52;
      var $53=$max_blindex;
      ;
      return $53;
    default: assert(0, "bad label: " + __label__);
  }
}
_build_bl_tree["X"]=1;

function _compress_block($s, $ltree, $dtree) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $dist;
      var $lc;
      var $lx;
      var $code;
      var $extra;
      var $len;
      var $val;
      var $len1;
      var $val2;
      var $len3;
      var $val4;
      var $len5;
      var $val6;
      var $len7;
      var $val8;
      var $len9;
      var $val10;
      $1=$s;
      $2=$ltree;
      $3=$dtree;
      $lx=0;
      var $4=$1;
      var $5=(($4+5792)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 1; break; } else { __label__ = 30; break; }
    case 1: // $8
      __label__ = 2; break;
    case 2: // $9
      var $10=$lx;
      var $11=$1;
      var $12=(($11+5796)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13+($10<<1))|0);
      var $15=HEAPU16[(($14)>>1)];
      var $16=(($15)&65535);
      $dist=$16;
      var $17=$lx;
      var $18=(($17+1)|0);
      $lx=$18;
      var $19=$1;
      var $20=(($19+5784)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+$17)|0);
      var $23=HEAPU8[($22)];
      var $24=(($23)&255);
      $lc=$24;
      var $25=$dist;
      var $26=(($25)|0)==0;
      if ($26) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $27
      var $28=$lc;
      var $29=$2;
      var $30=(($29+($28<<2))|0);
      var $31=(($30+2)|0);
      var $32=$31;
      var $33=HEAPU16[(($32)>>1)];
      var $34=(($33)&65535);
      $len=$34;
      var $35=$1;
      var $36=(($35+5820)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=$len;
      var $39=((16-$38)|0);
      var $40=(($37)|0) > (($39)|0);
      if ($40) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $41
      var $42=$lc;
      var $43=$2;
      var $44=(($43+($42<<2))|0);
      var $45=(($44)|0);
      var $46=$45;
      var $47=HEAPU16[(($46)>>1)];
      var $48=(($47)&65535);
      $val=$48;
      var $49=$val;
      var $50=$1;
      var $51=(($50+5820)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$49 << $52;
      var $54=$1;
      var $55=(($54+5816)|0);
      var $56=HEAPU16[(($55)>>1)];
      var $57=(($56)&65535);
      var $58=$57 | $53;
      var $59=(($58) & 65535);
      HEAP16[(($55)>>1)]=$59;
      var $60=$1;
      var $61=(($60+5816)|0);
      var $62=HEAPU16[(($61)>>1)];
      var $63=(($62)&65535);
      var $64=$63 & 255;
      var $65=(($64) & 255);
      var $66=$1;
      var $67=(($66+20)|0);
      var $68=HEAPU32[(($67)>>2)];
      var $69=(($68+1)|0);
      HEAP32[(($67)>>2)]=$69;
      var $70=$1;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+$68)|0);
      HEAP8[($73)]=$65;
      var $74=$1;
      var $75=(($74+5816)|0);
      var $76=HEAPU16[(($75)>>1)];
      var $77=(($76)&65535);
      var $78=$77 >> 8;
      var $79=(($78) & 255);
      var $80=$1;
      var $81=(($80+20)|0);
      var $82=HEAPU32[(($81)>>2)];
      var $83=(($82+1)|0);
      HEAP32[(($81)>>2)]=$83;
      var $84=$1;
      var $85=(($84+8)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+$82)|0);
      HEAP8[($87)]=$79;
      var $88=$val;
      var $89=(($88) & 65535);
      var $90=(($89)&65535);
      var $91=$1;
      var $92=(($91+5820)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=((16-$93)|0);
      var $95=$90 >> (($94)|0);
      var $96=(($95) & 65535);
      var $97=$1;
      var $98=(($97+5816)|0);
      HEAP16[(($98)>>1)]=$96;
      var $99=$len;
      var $100=(($99-16)|0);
      var $101=$1;
      var $102=(($101+5820)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+$100)|0);
      HEAP32[(($102)>>2)]=$104;
      __label__ = 6; break;
    case 5: // $105
      var $106=$lc;
      var $107=$2;
      var $108=(($107+($106<<2))|0);
      var $109=(($108)|0);
      var $110=$109;
      var $111=HEAPU16[(($110)>>1)];
      var $112=(($111)&65535);
      var $113=$1;
      var $114=(($113+5820)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=$112 << $115;
      var $117=$1;
      var $118=(($117+5816)|0);
      var $119=HEAPU16[(($118)>>1)];
      var $120=(($119)&65535);
      var $121=$120 | $116;
      var $122=(($121) & 65535);
      HEAP16[(($118)>>1)]=$122;
      var $123=$len;
      var $124=$1;
      var $125=(($124+5820)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($126+$123)|0);
      HEAP32[(($125)>>2)]=$127;
      __label__ = 6; break;
    case 6: // $128
      __label__ = 27; break;
    case 7: // $129
      var $130=$lc;
      var $131=((STRING_TABLE.__length_code+$130)|0);
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      $code=$133;
      var $134=$code;
      var $135=(($134+256)|0);
      var $136=(($135+1)|0);
      var $137=$2;
      var $138=(($137+($136<<2))|0);
      var $139=(($138+2)|0);
      var $140=$139;
      var $141=HEAPU16[(($140)>>1)];
      var $142=(($141)&65535);
      $len1=$142;
      var $143=$1;
      var $144=(($143+5820)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=$len1;
      var $147=((16-$146)|0);
      var $148=(($145)|0) > (($147)|0);
      if ($148) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $149
      var $150=$code;
      var $151=(($150+256)|0);
      var $152=(($151+1)|0);
      var $153=$2;
      var $154=(($153+($152<<2))|0);
      var $155=(($154)|0);
      var $156=$155;
      var $157=HEAPU16[(($156)>>1)];
      var $158=(($157)&65535);
      $val2=$158;
      var $159=$val2;
      var $160=$1;
      var $161=(($160+5820)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$159 << $162;
      var $164=$1;
      var $165=(($164+5816)|0);
      var $166=HEAPU16[(($165)>>1)];
      var $167=(($166)&65535);
      var $168=$167 | $163;
      var $169=(($168) & 65535);
      HEAP16[(($165)>>1)]=$169;
      var $170=$1;
      var $171=(($170+5816)|0);
      var $172=HEAPU16[(($171)>>1)];
      var $173=(($172)&65535);
      var $174=$173 & 255;
      var $175=(($174) & 255);
      var $176=$1;
      var $177=(($176+20)|0);
      var $178=HEAPU32[(($177)>>2)];
      var $179=(($178+1)|0);
      HEAP32[(($177)>>2)]=$179;
      var $180=$1;
      var $181=(($180+8)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=(($182+$178)|0);
      HEAP8[($183)]=$175;
      var $184=$1;
      var $185=(($184+5816)|0);
      var $186=HEAPU16[(($185)>>1)];
      var $187=(($186)&65535);
      var $188=$187 >> 8;
      var $189=(($188) & 255);
      var $190=$1;
      var $191=(($190+20)|0);
      var $192=HEAPU32[(($191)>>2)];
      var $193=(($192+1)|0);
      HEAP32[(($191)>>2)]=$193;
      var $194=$1;
      var $195=(($194+8)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196+$192)|0);
      HEAP8[($197)]=$189;
      var $198=$val2;
      var $199=(($198) & 65535);
      var $200=(($199)&65535);
      var $201=$1;
      var $202=(($201+5820)|0);
      var $203=HEAP32[(($202)>>2)];
      var $204=((16-$203)|0);
      var $205=$200 >> (($204)|0);
      var $206=(($205) & 65535);
      var $207=$1;
      var $208=(($207+5816)|0);
      HEAP16[(($208)>>1)]=$206;
      var $209=$len1;
      var $210=(($209-16)|0);
      var $211=$1;
      var $212=(($211+5820)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($213+$210)|0);
      HEAP32[(($212)>>2)]=$214;
      __label__ = 10; break;
    case 9: // $215
      var $216=$code;
      var $217=(($216+256)|0);
      var $218=(($217+1)|0);
      var $219=$2;
      var $220=(($219+($218<<2))|0);
      var $221=(($220)|0);
      var $222=$221;
      var $223=HEAPU16[(($222)>>1)];
      var $224=(($223)&65535);
      var $225=$1;
      var $226=(($225+5820)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=$224 << $227;
      var $229=$1;
      var $230=(($229+5816)|0);
      var $231=HEAPU16[(($230)>>1)];
      var $232=(($231)&65535);
      var $233=$232 | $228;
      var $234=(($233) & 65535);
      HEAP16[(($230)>>1)]=$234;
      var $235=$len1;
      var $236=$1;
      var $237=(($236+5820)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=(($238+$235)|0);
      HEAP32[(($237)>>2)]=$239;
      __label__ = 10; break;
    case 10: // $240
      var $241=$code;
      var $242=((_extra_lbits+($241<<2))|0);
      var $243=HEAP32[(($242)>>2)];
      $extra=$243;
      var $244=$extra;
      var $245=(($244)|0)!=0;
      if ($245) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $246
      var $247=$code;
      var $248=((_base_length+($247<<2))|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=$lc;
      var $251=(($250-$249)|0);
      $lc=$251;
      var $252=$extra;
      $len3=$252;
      var $253=$1;
      var $254=(($253+5820)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$len3;
      var $257=((16-$256)|0);
      var $258=(($255)|0) > (($257)|0);
      if ($258) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $259
      var $260=$lc;
      $val4=$260;
      var $261=$val4;
      var $262=$1;
      var $263=(($262+5820)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$261 << $264;
      var $266=$1;
      var $267=(($266+5816)|0);
      var $268=HEAPU16[(($267)>>1)];
      var $269=(($268)&65535);
      var $270=$269 | $265;
      var $271=(($270) & 65535);
      HEAP16[(($267)>>1)]=$271;
      var $272=$1;
      var $273=(($272+5816)|0);
      var $274=HEAPU16[(($273)>>1)];
      var $275=(($274)&65535);
      var $276=$275 & 255;
      var $277=(($276) & 255);
      var $278=$1;
      var $279=(($278+20)|0);
      var $280=HEAPU32[(($279)>>2)];
      var $281=(($280+1)|0);
      HEAP32[(($279)>>2)]=$281;
      var $282=$1;
      var $283=(($282+8)|0);
      var $284=HEAP32[(($283)>>2)];
      var $285=(($284+$280)|0);
      HEAP8[($285)]=$277;
      var $286=$1;
      var $287=(($286+5816)|0);
      var $288=HEAPU16[(($287)>>1)];
      var $289=(($288)&65535);
      var $290=$289 >> 8;
      var $291=(($290) & 255);
      var $292=$1;
      var $293=(($292+20)|0);
      var $294=HEAPU32[(($293)>>2)];
      var $295=(($294+1)|0);
      HEAP32[(($293)>>2)]=$295;
      var $296=$1;
      var $297=(($296+8)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=(($298+$294)|0);
      HEAP8[($299)]=$291;
      var $300=$val4;
      var $301=(($300) & 65535);
      var $302=(($301)&65535);
      var $303=$1;
      var $304=(($303+5820)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=((16-$305)|0);
      var $307=$302 >> (($306)|0);
      var $308=(($307) & 65535);
      var $309=$1;
      var $310=(($309+5816)|0);
      HEAP16[(($310)>>1)]=$308;
      var $311=$len3;
      var $312=(($311-16)|0);
      var $313=$1;
      var $314=(($313+5820)|0);
      var $315=HEAP32[(($314)>>2)];
      var $316=(($315+$312)|0);
      HEAP32[(($314)>>2)]=$316;
      __label__ = 14; break;
    case 13: // $317
      var $318=$lc;
      var $319=$1;
      var $320=(($319+5820)|0);
      var $321=HEAP32[(($320)>>2)];
      var $322=$318 << $321;
      var $323=$1;
      var $324=(($323+5816)|0);
      var $325=HEAPU16[(($324)>>1)];
      var $326=(($325)&65535);
      var $327=$326 | $322;
      var $328=(($327) & 65535);
      HEAP16[(($324)>>1)]=$328;
      var $329=$len3;
      var $330=$1;
      var $331=(($330+5820)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=(($332+$329)|0);
      HEAP32[(($331)>>2)]=$333;
      __label__ = 14; break;
    case 14: // $334
      __label__ = 15; break;
    case 15: // $335
      var $336=$dist;
      var $337=(($336-1)|0);
      $dist=$337;
      var $338=$dist;
      var $339=(($338)>>>0) < 256;
      if ($339) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $340
      var $341=$dist;
      var $342=((STRING_TABLE.__dist_code+$341)|0);
      var $343=HEAPU8[($342)];
      var $344=(($343)&255);
      var $353 = $344;__label__ = 18; break;
    case 17: // $345
      var $346=$dist;
      var $347=$346 >>> 7;
      var $348=(($347+256)|0);
      var $349=((STRING_TABLE.__dist_code+$348)|0);
      var $350=HEAPU8[($349)];
      var $351=(($350)&255);
      var $353 = $351;__label__ = 18; break;
    case 18: // $352
      var $353;
      $code=$353;
      var $354=$code;
      var $355=$3;
      var $356=(($355+($354<<2))|0);
      var $357=(($356+2)|0);
      var $358=$357;
      var $359=HEAPU16[(($358)>>1)];
      var $360=(($359)&65535);
      $len5=$360;
      var $361=$1;
      var $362=(($361+5820)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=$len5;
      var $365=((16-$364)|0);
      var $366=(($363)|0) > (($365)|0);
      if ($366) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $367
      var $368=$code;
      var $369=$3;
      var $370=(($369+($368<<2))|0);
      var $371=(($370)|0);
      var $372=$371;
      var $373=HEAPU16[(($372)>>1)];
      var $374=(($373)&65535);
      $val6=$374;
      var $375=$val6;
      var $376=$1;
      var $377=(($376+5820)|0);
      var $378=HEAP32[(($377)>>2)];
      var $379=$375 << $378;
      var $380=$1;
      var $381=(($380+5816)|0);
      var $382=HEAPU16[(($381)>>1)];
      var $383=(($382)&65535);
      var $384=$383 | $379;
      var $385=(($384) & 65535);
      HEAP16[(($381)>>1)]=$385;
      var $386=$1;
      var $387=(($386+5816)|0);
      var $388=HEAPU16[(($387)>>1)];
      var $389=(($388)&65535);
      var $390=$389 & 255;
      var $391=(($390) & 255);
      var $392=$1;
      var $393=(($392+20)|0);
      var $394=HEAPU32[(($393)>>2)];
      var $395=(($394+1)|0);
      HEAP32[(($393)>>2)]=$395;
      var $396=$1;
      var $397=(($396+8)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=(($398+$394)|0);
      HEAP8[($399)]=$391;
      var $400=$1;
      var $401=(($400+5816)|0);
      var $402=HEAPU16[(($401)>>1)];
      var $403=(($402)&65535);
      var $404=$403 >> 8;
      var $405=(($404) & 255);
      var $406=$1;
      var $407=(($406+20)|0);
      var $408=HEAPU32[(($407)>>2)];
      var $409=(($408+1)|0);
      HEAP32[(($407)>>2)]=$409;
      var $410=$1;
      var $411=(($410+8)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=(($412+$408)|0);
      HEAP8[($413)]=$405;
      var $414=$val6;
      var $415=(($414) & 65535);
      var $416=(($415)&65535);
      var $417=$1;
      var $418=(($417+5820)|0);
      var $419=HEAP32[(($418)>>2)];
      var $420=((16-$419)|0);
      var $421=$416 >> (($420)|0);
      var $422=(($421) & 65535);
      var $423=$1;
      var $424=(($423+5816)|0);
      HEAP16[(($424)>>1)]=$422;
      var $425=$len5;
      var $426=(($425-16)|0);
      var $427=$1;
      var $428=(($427+5820)|0);
      var $429=HEAP32[(($428)>>2)];
      var $430=(($429+$426)|0);
      HEAP32[(($428)>>2)]=$430;
      __label__ = 21; break;
    case 20: // $431
      var $432=$code;
      var $433=$3;
      var $434=(($433+($432<<2))|0);
      var $435=(($434)|0);
      var $436=$435;
      var $437=HEAPU16[(($436)>>1)];
      var $438=(($437)&65535);
      var $439=$1;
      var $440=(($439+5820)|0);
      var $441=HEAP32[(($440)>>2)];
      var $442=$438 << $441;
      var $443=$1;
      var $444=(($443+5816)|0);
      var $445=HEAPU16[(($444)>>1)];
      var $446=(($445)&65535);
      var $447=$446 | $442;
      var $448=(($447) & 65535);
      HEAP16[(($444)>>1)]=$448;
      var $449=$len5;
      var $450=$1;
      var $451=(($450+5820)|0);
      var $452=HEAP32[(($451)>>2)];
      var $453=(($452+$449)|0);
      HEAP32[(($451)>>2)]=$453;
      __label__ = 21; break;
    case 21: // $454
      var $455=$code;
      var $456=((_extra_dbits+($455<<2))|0);
      var $457=HEAP32[(($456)>>2)];
      $extra=$457;
      var $458=$extra;
      var $459=(($458)|0)!=0;
      if ($459) { __label__ = 22; break; } else { __label__ = 26; break; }
    case 22: // $460
      var $461=$code;
      var $462=((_base_dist+($461<<2))|0);
      var $463=HEAP32[(($462)>>2)];
      var $464=$dist;
      var $465=(($464-$463)|0);
      $dist=$465;
      var $466=$extra;
      $len7=$466;
      var $467=$1;
      var $468=(($467+5820)|0);
      var $469=HEAP32[(($468)>>2)];
      var $470=$len7;
      var $471=((16-$470)|0);
      var $472=(($469)|0) > (($471)|0);
      if ($472) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $473
      var $474=$dist;
      $val8=$474;
      var $475=$val8;
      var $476=$1;
      var $477=(($476+5820)|0);
      var $478=HEAP32[(($477)>>2)];
      var $479=$475 << $478;
      var $480=$1;
      var $481=(($480+5816)|0);
      var $482=HEAPU16[(($481)>>1)];
      var $483=(($482)&65535);
      var $484=$483 | $479;
      var $485=(($484) & 65535);
      HEAP16[(($481)>>1)]=$485;
      var $486=$1;
      var $487=(($486+5816)|0);
      var $488=HEAPU16[(($487)>>1)];
      var $489=(($488)&65535);
      var $490=$489 & 255;
      var $491=(($490) & 255);
      var $492=$1;
      var $493=(($492+20)|0);
      var $494=HEAPU32[(($493)>>2)];
      var $495=(($494+1)|0);
      HEAP32[(($493)>>2)]=$495;
      var $496=$1;
      var $497=(($496+8)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=(($498+$494)|0);
      HEAP8[($499)]=$491;
      var $500=$1;
      var $501=(($500+5816)|0);
      var $502=HEAPU16[(($501)>>1)];
      var $503=(($502)&65535);
      var $504=$503 >> 8;
      var $505=(($504) & 255);
      var $506=$1;
      var $507=(($506+20)|0);
      var $508=HEAPU32[(($507)>>2)];
      var $509=(($508+1)|0);
      HEAP32[(($507)>>2)]=$509;
      var $510=$1;
      var $511=(($510+8)|0);
      var $512=HEAP32[(($511)>>2)];
      var $513=(($512+$508)|0);
      HEAP8[($513)]=$505;
      var $514=$val8;
      var $515=(($514) & 65535);
      var $516=(($515)&65535);
      var $517=$1;
      var $518=(($517+5820)|0);
      var $519=HEAP32[(($518)>>2)];
      var $520=((16-$519)|0);
      var $521=$516 >> (($520)|0);
      var $522=(($521) & 65535);
      var $523=$1;
      var $524=(($523+5816)|0);
      HEAP16[(($524)>>1)]=$522;
      var $525=$len7;
      var $526=(($525-16)|0);
      var $527=$1;
      var $528=(($527+5820)|0);
      var $529=HEAP32[(($528)>>2)];
      var $530=(($529+$526)|0);
      HEAP32[(($528)>>2)]=$530;
      __label__ = 25; break;
    case 24: // $531
      var $532=$dist;
      var $533=$1;
      var $534=(($533+5820)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$532 << $535;
      var $537=$1;
      var $538=(($537+5816)|0);
      var $539=HEAPU16[(($538)>>1)];
      var $540=(($539)&65535);
      var $541=$540 | $536;
      var $542=(($541) & 65535);
      HEAP16[(($538)>>1)]=$542;
      var $543=$len7;
      var $544=$1;
      var $545=(($544+5820)|0);
      var $546=HEAP32[(($545)>>2)];
      var $547=(($546+$543)|0);
      HEAP32[(($545)>>2)]=$547;
      __label__ = 25; break;
    case 25: // $548
      __label__ = 26; break;
    case 26: // $549
      __label__ = 27; break;
    case 27: // $550
      __label__ = 28; break;
    case 28: // $551
      var $552=$lx;
      var $553=$1;
      var $554=(($553+5792)|0);
      var $555=HEAPU32[(($554)>>2)];
      var $556=(($552)>>>0) < (($555)>>>0);
      if ($556) { __label__ = 2; break; } else { __label__ = 29; break; }
    case 29: // $557
      __label__ = 30; break;
    case 30: // $558
      var $559=$2;
      var $560=(($559+1024)|0);
      var $561=(($560+2)|0);
      var $562=$561;
      var $563=HEAPU16[(($562)>>1)];
      var $564=(($563)&65535);
      $len9=$564;
      var $565=$1;
      var $566=(($565+5820)|0);
      var $567=HEAP32[(($566)>>2)];
      var $568=$len9;
      var $569=((16-$568)|0);
      var $570=(($567)|0) > (($569)|0);
      if ($570) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $571
      var $572=$2;
      var $573=(($572+1024)|0);
      var $574=(($573)|0);
      var $575=$574;
      var $576=HEAPU16[(($575)>>1)];
      var $577=(($576)&65535);
      $val10=$577;
      var $578=$val10;
      var $579=$1;
      var $580=(($579+5820)|0);
      var $581=HEAP32[(($580)>>2)];
      var $582=$578 << $581;
      var $583=$1;
      var $584=(($583+5816)|0);
      var $585=HEAPU16[(($584)>>1)];
      var $586=(($585)&65535);
      var $587=$586 | $582;
      var $588=(($587) & 65535);
      HEAP16[(($584)>>1)]=$588;
      var $589=$1;
      var $590=(($589+5816)|0);
      var $591=HEAPU16[(($590)>>1)];
      var $592=(($591)&65535);
      var $593=$592 & 255;
      var $594=(($593) & 255);
      var $595=$1;
      var $596=(($595+20)|0);
      var $597=HEAPU32[(($596)>>2)];
      var $598=(($597+1)|0);
      HEAP32[(($596)>>2)]=$598;
      var $599=$1;
      var $600=(($599+8)|0);
      var $601=HEAP32[(($600)>>2)];
      var $602=(($601+$597)|0);
      HEAP8[($602)]=$594;
      var $603=$1;
      var $604=(($603+5816)|0);
      var $605=HEAPU16[(($604)>>1)];
      var $606=(($605)&65535);
      var $607=$606 >> 8;
      var $608=(($607) & 255);
      var $609=$1;
      var $610=(($609+20)|0);
      var $611=HEAPU32[(($610)>>2)];
      var $612=(($611+1)|0);
      HEAP32[(($610)>>2)]=$612;
      var $613=$1;
      var $614=(($613+8)|0);
      var $615=HEAP32[(($614)>>2)];
      var $616=(($615+$611)|0);
      HEAP8[($616)]=$608;
      var $617=$val10;
      var $618=(($617) & 65535);
      var $619=(($618)&65535);
      var $620=$1;
      var $621=(($620+5820)|0);
      var $622=HEAP32[(($621)>>2)];
      var $623=((16-$622)|0);
      var $624=$619 >> (($623)|0);
      var $625=(($624) & 65535);
      var $626=$1;
      var $627=(($626+5816)|0);
      HEAP16[(($627)>>1)]=$625;
      var $628=$len9;
      var $629=(($628-16)|0);
      var $630=$1;
      var $631=(($630+5820)|0);
      var $632=HEAP32[(($631)>>2)];
      var $633=(($632+$629)|0);
      HEAP32[(($631)>>2)]=$633;
      __label__ = 33; break;
    case 32: // $634
      var $635=$2;
      var $636=(($635+1024)|0);
      var $637=(($636)|0);
      var $638=$637;
      var $639=HEAPU16[(($638)>>1)];
      var $640=(($639)&65535);
      var $641=$1;
      var $642=(($641+5820)|0);
      var $643=HEAP32[(($642)>>2)];
      var $644=$640 << $643;
      var $645=$1;
      var $646=(($645+5816)|0);
      var $647=HEAPU16[(($646)>>1)];
      var $648=(($647)&65535);
      var $649=$648 | $644;
      var $650=(($649) & 65535);
      HEAP16[(($646)>>1)]=$650;
      var $651=$len9;
      var $652=$1;
      var $653=(($652+5820)|0);
      var $654=HEAP32[(($653)>>2)];
      var $655=(($654+$651)|0);
      HEAP32[(($653)>>2)]=$655;
      __label__ = 33; break;
    case 33: // $656
      var $657=$2;
      var $658=(($657+1024)|0);
      var $659=(($658+2)|0);
      var $660=$659;
      var $661=HEAPU16[(($660)>>1)];
      var $662=(($661)&65535);
      var $663=$1;
      var $664=(($663+5812)|0);
      HEAP32[(($664)>>2)]=$662;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_compress_block["X"]=1;

function _bi_windup($s) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$s;
      var $2=$1;
      var $3=(($2+5820)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0) > 8;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$1;
      var $8=(($7+5816)|0);
      var $9=HEAPU16[(($8)>>1)];
      var $10=(($9)&65535);
      var $11=$10 & 255;
      var $12=(($11) & 255);
      var $13=$1;
      var $14=(($13+20)|0);
      var $15=HEAPU32[(($14)>>2)];
      var $16=(($15+1)|0);
      HEAP32[(($14)>>2)]=$16;
      var $17=$1;
      var $18=(($17+8)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+$15)|0);
      HEAP8[($20)]=$12;
      var $21=$1;
      var $22=(($21+5816)|0);
      var $23=HEAPU16[(($22)>>1)];
      var $24=(($23)&65535);
      var $25=$24 >> 8;
      var $26=(($25) & 255);
      var $27=$1;
      var $28=(($27+20)|0);
      var $29=HEAPU32[(($28)>>2)];
      var $30=(($29+1)|0);
      HEAP32[(($28)>>2)]=$30;
      var $31=$1;
      var $32=(($31+8)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33+$29)|0);
      HEAP8[($34)]=$26;
      __label__ = 5; break;
    case 2: // $35
      var $36=$1;
      var $37=(($36+5820)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0) > 0;
      if ($39) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $40
      var $41=$1;
      var $42=(($41+5816)|0);
      var $43=HEAP16[(($42)>>1)];
      var $44=(($43) & 255);
      var $45=$1;
      var $46=(($45+20)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      var $49=$1;
      var $50=(($49+8)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$47)|0);
      HEAP8[($52)]=$44;
      __label__ = 4; break;
    case 4: // $53
      __label__ = 5; break;
    case 5: // $54
      var $55=$1;
      var $56=(($55+5816)|0);
      HEAP16[(($56)>>1)]=0;
      var $57=$1;
      var $58=(($57+5820)|0);
      HEAP32[(($58)>>2)]=0;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_bi_windup["X"]=1;

function _send_all_trees($s, $lcodes, $dcodes, $blcodes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $rank;
      var $len;
      var $val;
      var $len1;
      var $val2;
      var $len3;
      var $val4;
      var $len5;
      var $val6;
      $1=$s;
      $2=$lcodes;
      $3=$dcodes;
      $4=$blcodes;
      $len=5;
      var $5=$1;
      var $6=(($5+5820)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$len;
      var $9=((16-$8)|0);
      var $10=(($7)|0) > (($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      var $13=(($12-257)|0);
      $val=$13;
      var $14=$val;
      var $15=$1;
      var $16=(($15+5820)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$14 << $17;
      var $19=$1;
      var $20=(($19+5816)|0);
      var $21=HEAPU16[(($20)>>1)];
      var $22=(($21)&65535);
      var $23=$22 | $18;
      var $24=(($23) & 65535);
      HEAP16[(($20)>>1)]=$24;
      var $25=$1;
      var $26=(($25+5816)|0);
      var $27=HEAPU16[(($26)>>1)];
      var $28=(($27)&65535);
      var $29=$28 & 255;
      var $30=(($29) & 255);
      var $31=$1;
      var $32=(($31+20)|0);
      var $33=HEAPU32[(($32)>>2)];
      var $34=(($33+1)|0);
      HEAP32[(($32)>>2)]=$34;
      var $35=$1;
      var $36=(($35+8)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+$33)|0);
      HEAP8[($38)]=$30;
      var $39=$1;
      var $40=(($39+5816)|0);
      var $41=HEAPU16[(($40)>>1)];
      var $42=(($41)&65535);
      var $43=$42 >> 8;
      var $44=(($43) & 255);
      var $45=$1;
      var $46=(($45+20)|0);
      var $47=HEAPU32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      var $49=$1;
      var $50=(($49+8)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+$47)|0);
      HEAP8[($52)]=$44;
      var $53=$val;
      var $54=(($53) & 65535);
      var $55=(($54)&65535);
      var $56=$1;
      var $57=(($56+5820)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=((16-$58)|0);
      var $60=$55 >> (($59)|0);
      var $61=(($60) & 65535);
      var $62=$1;
      var $63=(($62+5816)|0);
      HEAP16[(($63)>>1)]=$61;
      var $64=$len;
      var $65=(($64-16)|0);
      var $66=$1;
      var $67=(($66+5820)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+$65)|0);
      HEAP32[(($67)>>2)]=$69;
      __label__ = 3; break;
    case 2: // $70
      var $71=$2;
      var $72=(($71-257)|0);
      var $73=$1;
      var $74=(($73+5820)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$72 << $75;
      var $77=$1;
      var $78=(($77+5816)|0);
      var $79=HEAPU16[(($78)>>1)];
      var $80=(($79)&65535);
      var $81=$80 | $76;
      var $82=(($81) & 65535);
      HEAP16[(($78)>>1)]=$82;
      var $83=$len;
      var $84=$1;
      var $85=(($84+5820)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+$83)|0);
      HEAP32[(($85)>>2)]=$87;
      __label__ = 3; break;
    case 3: // $88
      $len1=5;
      var $89=$1;
      var $90=(($89+5820)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$len1;
      var $93=((16-$92)|0);
      var $94=(($91)|0) > (($93)|0);
      if ($94) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $95
      var $96=$3;
      var $97=(($96-1)|0);
      $val2=$97;
      var $98=$val2;
      var $99=$1;
      var $100=(($99+5820)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=$98 << $101;
      var $103=$1;
      var $104=(($103+5816)|0);
      var $105=HEAPU16[(($104)>>1)];
      var $106=(($105)&65535);
      var $107=$106 | $102;
      var $108=(($107) & 65535);
      HEAP16[(($104)>>1)]=$108;
      var $109=$1;
      var $110=(($109+5816)|0);
      var $111=HEAPU16[(($110)>>1)];
      var $112=(($111)&65535);
      var $113=$112 & 255;
      var $114=(($113) & 255);
      var $115=$1;
      var $116=(($115+20)|0);
      var $117=HEAPU32[(($116)>>2)];
      var $118=(($117+1)|0);
      HEAP32[(($116)>>2)]=$118;
      var $119=$1;
      var $120=(($119+8)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($121+$117)|0);
      HEAP8[($122)]=$114;
      var $123=$1;
      var $124=(($123+5816)|0);
      var $125=HEAPU16[(($124)>>1)];
      var $126=(($125)&65535);
      var $127=$126 >> 8;
      var $128=(($127) & 255);
      var $129=$1;
      var $130=(($129+20)|0);
      var $131=HEAPU32[(($130)>>2)];
      var $132=(($131+1)|0);
      HEAP32[(($130)>>2)]=$132;
      var $133=$1;
      var $134=(($133+8)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=(($135+$131)|0);
      HEAP8[($136)]=$128;
      var $137=$val2;
      var $138=(($137) & 65535);
      var $139=(($138)&65535);
      var $140=$1;
      var $141=(($140+5820)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=((16-$142)|0);
      var $144=$139 >> (($143)|0);
      var $145=(($144) & 65535);
      var $146=$1;
      var $147=(($146+5816)|0);
      HEAP16[(($147)>>1)]=$145;
      var $148=$len1;
      var $149=(($148-16)|0);
      var $150=$1;
      var $151=(($150+5820)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+$149)|0);
      HEAP32[(($151)>>2)]=$153;
      __label__ = 6; break;
    case 5: // $154
      var $155=$3;
      var $156=(($155-1)|0);
      var $157=$1;
      var $158=(($157+5820)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=$156 << $159;
      var $161=$1;
      var $162=(($161+5816)|0);
      var $163=HEAPU16[(($162)>>1)];
      var $164=(($163)&65535);
      var $165=$164 | $160;
      var $166=(($165) & 65535);
      HEAP16[(($162)>>1)]=$166;
      var $167=$len1;
      var $168=$1;
      var $169=(($168+5820)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($170+$167)|0);
      HEAP32[(($169)>>2)]=$171;
      __label__ = 6; break;
    case 6: // $172
      $len3=4;
      var $173=$1;
      var $174=(($173+5820)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=$len3;
      var $177=((16-$176)|0);
      var $178=(($175)|0) > (($177)|0);
      if ($178) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $179
      var $180=$4;
      var $181=(($180-4)|0);
      $val4=$181;
      var $182=$val4;
      var $183=$1;
      var $184=(($183+5820)|0);
      var $185=HEAP32[(($184)>>2)];
      var $186=$182 << $185;
      var $187=$1;
      var $188=(($187+5816)|0);
      var $189=HEAPU16[(($188)>>1)];
      var $190=(($189)&65535);
      var $191=$190 | $186;
      var $192=(($191) & 65535);
      HEAP16[(($188)>>1)]=$192;
      var $193=$1;
      var $194=(($193+5816)|0);
      var $195=HEAPU16[(($194)>>1)];
      var $196=(($195)&65535);
      var $197=$196 & 255;
      var $198=(($197) & 255);
      var $199=$1;
      var $200=(($199+20)|0);
      var $201=HEAPU32[(($200)>>2)];
      var $202=(($201+1)|0);
      HEAP32[(($200)>>2)]=$202;
      var $203=$1;
      var $204=(($203+8)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205+$201)|0);
      HEAP8[($206)]=$198;
      var $207=$1;
      var $208=(($207+5816)|0);
      var $209=HEAPU16[(($208)>>1)];
      var $210=(($209)&65535);
      var $211=$210 >> 8;
      var $212=(($211) & 255);
      var $213=$1;
      var $214=(($213+20)|0);
      var $215=HEAPU32[(($214)>>2)];
      var $216=(($215+1)|0);
      HEAP32[(($214)>>2)]=$216;
      var $217=$1;
      var $218=(($217+8)|0);
      var $219=HEAP32[(($218)>>2)];
      var $220=(($219+$215)|0);
      HEAP8[($220)]=$212;
      var $221=$val4;
      var $222=(($221) & 65535);
      var $223=(($222)&65535);
      var $224=$1;
      var $225=(($224+5820)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=((16-$226)|0);
      var $228=$223 >> (($227)|0);
      var $229=(($228) & 65535);
      var $230=$1;
      var $231=(($230+5816)|0);
      HEAP16[(($231)>>1)]=$229;
      var $232=$len3;
      var $233=(($232-16)|0);
      var $234=$1;
      var $235=(($234+5820)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=(($236+$233)|0);
      HEAP32[(($235)>>2)]=$237;
      __label__ = 9; break;
    case 8: // $238
      var $239=$4;
      var $240=(($239-4)|0);
      var $241=$1;
      var $242=(($241+5820)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=$240 << $243;
      var $245=$1;
      var $246=(($245+5816)|0);
      var $247=HEAPU16[(($246)>>1)];
      var $248=(($247)&65535);
      var $249=$248 | $244;
      var $250=(($249) & 65535);
      HEAP16[(($246)>>1)]=$250;
      var $251=$len3;
      var $252=$1;
      var $253=(($252+5820)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=(($254+$251)|0);
      HEAP32[(($253)>>2)]=$255;
      __label__ = 9; break;
    case 9: // $256
      $rank=0;
      __label__ = 10; break;
    case 10: // $257
      var $258=$rank;
      var $259=$4;
      var $260=(($258)|0) < (($259)|0);
      if ($260) { __label__ = 11; break; } else { __label__ = 16; break; }
    case 11: // $261
      $len5=3;
      var $262=$1;
      var $263=(($262+5820)|0);
      var $264=HEAP32[(($263)>>2)];
      var $265=$len5;
      var $266=((16-$265)|0);
      var $267=(($264)|0) > (($266)|0);
      if ($267) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $268
      var $269=$rank;
      var $270=((STRING_TABLE._bl_order+$269)|0);
      var $271=HEAPU8[($270)];
      var $272=(($271)&255);
      var $273=$1;
      var $274=(($273+2684)|0);
      var $275=(($274+($272<<2))|0);
      var $276=(($275+2)|0);
      var $277=$276;
      var $278=HEAPU16[(($277)>>1)];
      var $279=(($278)&65535);
      $val6=$279;
      var $280=$val6;
      var $281=$1;
      var $282=(($281+5820)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=$280 << $283;
      var $285=$1;
      var $286=(($285+5816)|0);
      var $287=HEAPU16[(($286)>>1)];
      var $288=(($287)&65535);
      var $289=$288 | $284;
      var $290=(($289) & 65535);
      HEAP16[(($286)>>1)]=$290;
      var $291=$1;
      var $292=(($291+5816)|0);
      var $293=HEAPU16[(($292)>>1)];
      var $294=(($293)&65535);
      var $295=$294 & 255;
      var $296=(($295) & 255);
      var $297=$1;
      var $298=(($297+20)|0);
      var $299=HEAPU32[(($298)>>2)];
      var $300=(($299+1)|0);
      HEAP32[(($298)>>2)]=$300;
      var $301=$1;
      var $302=(($301+8)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(($303+$299)|0);
      HEAP8[($304)]=$296;
      var $305=$1;
      var $306=(($305+5816)|0);
      var $307=HEAPU16[(($306)>>1)];
      var $308=(($307)&65535);
      var $309=$308 >> 8;
      var $310=(($309) & 255);
      var $311=$1;
      var $312=(($311+20)|0);
      var $313=HEAPU32[(($312)>>2)];
      var $314=(($313+1)|0);
      HEAP32[(($312)>>2)]=$314;
      var $315=$1;
      var $316=(($315+8)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=(($317+$313)|0);
      HEAP8[($318)]=$310;
      var $319=$val6;
      var $320=(($319) & 65535);
      var $321=(($320)&65535);
      var $322=$1;
      var $323=(($322+5820)|0);
      var $324=HEAP32[(($323)>>2)];
      var $325=((16-$324)|0);
      var $326=$321 >> (($325)|0);
      var $327=(($326) & 65535);
      var $328=$1;
      var $329=(($328+5816)|0);
      HEAP16[(($329)>>1)]=$327;
      var $330=$len5;
      var $331=(($330-16)|0);
      var $332=$1;
      var $333=(($332+5820)|0);
      var $334=HEAP32[(($333)>>2)];
      var $335=(($334+$331)|0);
      HEAP32[(($333)>>2)]=$335;
      __label__ = 14; break;
    case 13: // $336
      var $337=$rank;
      var $338=((STRING_TABLE._bl_order+$337)|0);
      var $339=HEAPU8[($338)];
      var $340=(($339)&255);
      var $341=$1;
      var $342=(($341+2684)|0);
      var $343=(($342+($340<<2))|0);
      var $344=(($343+2)|0);
      var $345=$344;
      var $346=HEAPU16[(($345)>>1)];
      var $347=(($346)&65535);
      var $348=$1;
      var $349=(($348+5820)|0);
      var $350=HEAP32[(($349)>>2)];
      var $351=$347 << $350;
      var $352=$1;
      var $353=(($352+5816)|0);
      var $354=HEAPU16[(($353)>>1)];
      var $355=(($354)&65535);
      var $356=$355 | $351;
      var $357=(($356) & 65535);
      HEAP16[(($353)>>1)]=$357;
      var $358=$len5;
      var $359=$1;
      var $360=(($359+5820)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($361+$358)|0);
      HEAP32[(($360)>>2)]=$362;
      __label__ = 14; break;
    case 14: // $363
      __label__ = 15; break;
    case 15: // $364
      var $365=$rank;
      var $366=(($365+1)|0);
      $rank=$366;
      __label__ = 10; break;
    case 16: // $367
      var $368=$1;
      var $369=$1;
      var $370=(($369+148)|0);
      var $371=(($370)|0);
      var $372=$2;
      var $373=(($372-1)|0);
      _send_tree($368, $371, $373);
      var $374=$1;
      var $375=$1;
      var $376=(($375+2440)|0);
      var $377=(($376)|0);
      var $378=$3;
      var $379=(($378-1)|0);
      _send_tree($374, $377, $379);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_send_all_trees["X"]=1;

function _send_tree($s, $tree, $max_code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $n;
      var $prevlen;
      var $curlen;
      var $nextlen;
      var $count;
      var $max_count;
      var $min_count;
      var $len;
      var $val;
      var $len1;
      var $val2;
      var $len3;
      var $val4;
      var $len5;
      var $val6;
      var $len7;
      var $val8;
      var $len9;
      var $val10;
      var $len11;
      var $val12;
      var $len13;
      var $val14;
      $1=$s;
      $2=$tree;
      $3=$max_code;
      $prevlen=-1;
      var $4=$2;
      var $5=(($4)|0);
      var $6=(($5+2)|0);
      var $7=$6;
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      $nextlen=$9;
      $count=0;
      $max_count=7;
      $min_count=4;
      var $10=$nextlen;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $max_count=138;
      $min_count=3;
      __label__ = 2; break;
    case 2: // $13
      $n=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$n;
      var $16=$3;
      var $17=(($15)|0) <= (($16)|0);
      if ($17) { __label__ = 4; break; } else { __label__ = 54; break; }
    case 4: // $18
      var $19=$nextlen;
      $curlen=$19;
      var $20=$n;
      var $21=(($20+1)|0);
      var $22=$2;
      var $23=(($22+($21<<2))|0);
      var $24=(($23+2)|0);
      var $25=$24;
      var $26=HEAPU16[(($25)>>1)];
      var $27=(($26)&65535);
      $nextlen=$27;
      var $28=$count;
      var $29=(($28+1)|0);
      $count=$29;
      var $30=$max_count;
      var $31=(($29)|0) < (($30)|0);
      if ($31) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $32
      var $33=$curlen;
      var $34=$nextlen;
      var $35=(($33)|0)==(($34)|0);
      if ($35) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $36
      __label__ = 53; break;
    case 7: // $37
      var $38=$count;
      var $39=$min_count;
      var $40=(($38)|0) < (($39)|0);
      if ($40) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $41
      __label__ = 9; break;
    case 9: // $42
      var $43=$curlen;
      var $44=$1;
      var $45=(($44+2684)|0);
      var $46=(($45+($43<<2))|0);
      var $47=(($46+2)|0);
      var $48=$47;
      var $49=HEAPU16[(($48)>>1)];
      var $50=(($49)&65535);
      $len=$50;
      var $51=$1;
      var $52=(($51+5820)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=$len;
      var $55=((16-$54)|0);
      var $56=(($53)|0) > (($55)|0);
      if ($56) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $57
      var $58=$curlen;
      var $59=$1;
      var $60=(($59+2684)|0);
      var $61=(($60+($58<<2))|0);
      var $62=(($61)|0);
      var $63=$62;
      var $64=HEAPU16[(($63)>>1)];
      var $65=(($64)&65535);
      $val=$65;
      var $66=$val;
      var $67=$1;
      var $68=(($67+5820)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$66 << $69;
      var $71=$1;
      var $72=(($71+5816)|0);
      var $73=HEAPU16[(($72)>>1)];
      var $74=(($73)&65535);
      var $75=$74 | $70;
      var $76=(($75) & 65535);
      HEAP16[(($72)>>1)]=$76;
      var $77=$1;
      var $78=(($77+5816)|0);
      var $79=HEAPU16[(($78)>>1)];
      var $80=(($79)&65535);
      var $81=$80 & 255;
      var $82=(($81) & 255);
      var $83=$1;
      var $84=(($83+20)|0);
      var $85=HEAPU32[(($84)>>2)];
      var $86=(($85+1)|0);
      HEAP32[(($84)>>2)]=$86;
      var $87=$1;
      var $88=(($87+8)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($89+$85)|0);
      HEAP8[($90)]=$82;
      var $91=$1;
      var $92=(($91+5816)|0);
      var $93=HEAPU16[(($92)>>1)];
      var $94=(($93)&65535);
      var $95=$94 >> 8;
      var $96=(($95) & 255);
      var $97=$1;
      var $98=(($97+20)|0);
      var $99=HEAPU32[(($98)>>2)];
      var $100=(($99+1)|0);
      HEAP32[(($98)>>2)]=$100;
      var $101=$1;
      var $102=(($101+8)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+$99)|0);
      HEAP8[($104)]=$96;
      var $105=$val;
      var $106=(($105) & 65535);
      var $107=(($106)&65535);
      var $108=$1;
      var $109=(($108+5820)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=((16-$110)|0);
      var $112=$107 >> (($111)|0);
      var $113=(($112) & 65535);
      var $114=$1;
      var $115=(($114+5816)|0);
      HEAP16[(($115)>>1)]=$113;
      var $116=$len;
      var $117=(($116-16)|0);
      var $118=$1;
      var $119=(($118+5820)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+$117)|0);
      HEAP32[(($119)>>2)]=$121;
      __label__ = 12; break;
    case 11: // $122
      var $123=$curlen;
      var $124=$1;
      var $125=(($124+2684)|0);
      var $126=(($125+($123<<2))|0);
      var $127=(($126)|0);
      var $128=$127;
      var $129=HEAPU16[(($128)>>1)];
      var $130=(($129)&65535);
      var $131=$1;
      var $132=(($131+5820)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$130 << $133;
      var $135=$1;
      var $136=(($135+5816)|0);
      var $137=HEAPU16[(($136)>>1)];
      var $138=(($137)&65535);
      var $139=$138 | $134;
      var $140=(($139) & 65535);
      HEAP16[(($136)>>1)]=$140;
      var $141=$len;
      var $142=$1;
      var $143=(($142+5820)|0);
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+$141)|0);
      HEAP32[(($143)>>2)]=$145;
      __label__ = 12; break;
    case 12: // $146
      __label__ = 13; break;
    case 13: // $147
      var $148=$count;
      var $149=(($148-1)|0);
      $count=$149;
      var $150=(($149)|0)!=0;
      if ($150) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 14: // $151
      __label__ = 45; break;
    case 15: // $152
      var $153=$curlen;
      var $154=(($153)|0)!=0;
      if ($154) { __label__ = 16; break; } else { __label__ = 28; break; }
    case 16: // $155
      var $156=$curlen;
      var $157=$prevlen;
      var $158=(($156)|0)!=(($157)|0);
      if ($158) { __label__ = 17; break; } else { __label__ = 21; break; }
    case 17: // $159
      var $160=$curlen;
      var $161=$1;
      var $162=(($161+2684)|0);
      var $163=(($162+($160<<2))|0);
      var $164=(($163+2)|0);
      var $165=$164;
      var $166=HEAPU16[(($165)>>1)];
      var $167=(($166)&65535);
      $len1=$167;
      var $168=$1;
      var $169=(($168+5820)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=$len1;
      var $172=((16-$171)|0);
      var $173=(($170)|0) > (($172)|0);
      if ($173) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $174
      var $175=$curlen;
      var $176=$1;
      var $177=(($176+2684)|0);
      var $178=(($177+($175<<2))|0);
      var $179=(($178)|0);
      var $180=$179;
      var $181=HEAPU16[(($180)>>1)];
      var $182=(($181)&65535);
      $val2=$182;
      var $183=$val2;
      var $184=$1;
      var $185=(($184+5820)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$183 << $186;
      var $188=$1;
      var $189=(($188+5816)|0);
      var $190=HEAPU16[(($189)>>1)];
      var $191=(($190)&65535);
      var $192=$191 | $187;
      var $193=(($192) & 65535);
      HEAP16[(($189)>>1)]=$193;
      var $194=$1;
      var $195=(($194+5816)|0);
      var $196=HEAPU16[(($195)>>1)];
      var $197=(($196)&65535);
      var $198=$197 & 255;
      var $199=(($198) & 255);
      var $200=$1;
      var $201=(($200+20)|0);
      var $202=HEAPU32[(($201)>>2)];
      var $203=(($202+1)|0);
      HEAP32[(($201)>>2)]=$203;
      var $204=$1;
      var $205=(($204+8)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206+$202)|0);
      HEAP8[($207)]=$199;
      var $208=$1;
      var $209=(($208+5816)|0);
      var $210=HEAPU16[(($209)>>1)];
      var $211=(($210)&65535);
      var $212=$211 >> 8;
      var $213=(($212) & 255);
      var $214=$1;
      var $215=(($214+20)|0);
      var $216=HEAPU32[(($215)>>2)];
      var $217=(($216+1)|0);
      HEAP32[(($215)>>2)]=$217;
      var $218=$1;
      var $219=(($218+8)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220+$216)|0);
      HEAP8[($221)]=$213;
      var $222=$val2;
      var $223=(($222) & 65535);
      var $224=(($223)&65535);
      var $225=$1;
      var $226=(($225+5820)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=((16-$227)|0);
      var $229=$224 >> (($228)|0);
      var $230=(($229) & 65535);
      var $231=$1;
      var $232=(($231+5816)|0);
      HEAP16[(($232)>>1)]=$230;
      var $233=$len1;
      var $234=(($233-16)|0);
      var $235=$1;
      var $236=(($235+5820)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=(($237+$234)|0);
      HEAP32[(($236)>>2)]=$238;
      __label__ = 20; break;
    case 19: // $239
      var $240=$curlen;
      var $241=$1;
      var $242=(($241+2684)|0);
      var $243=(($242+($240<<2))|0);
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU16[(($245)>>1)];
      var $247=(($246)&65535);
      var $248=$1;
      var $249=(($248+5820)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=$247 << $250;
      var $252=$1;
      var $253=(($252+5816)|0);
      var $254=HEAPU16[(($253)>>1)];
      var $255=(($254)&65535);
      var $256=$255 | $251;
      var $257=(($256) & 65535);
      HEAP16[(($253)>>1)]=$257;
      var $258=$len1;
      var $259=$1;
      var $260=(($259+5820)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=(($261+$258)|0);
      HEAP32[(($260)>>2)]=$262;
      __label__ = 20; break;
    case 20: // $263
      var $264=$count;
      var $265=(($264-1)|0);
      $count=$265;
      __label__ = 21; break;
    case 21: // $266
      var $267=$1;
      var $268=(($267+2684)|0);
      var $269=(($268+64)|0);
      var $270=(($269+2)|0);
      var $271=$270;
      var $272=HEAPU16[(($271)>>1)];
      var $273=(($272)&65535);
      $len3=$273;
      var $274=$1;
      var $275=(($274+5820)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=$len3;
      var $278=((16-$277)|0);
      var $279=(($276)|0) > (($278)|0);
      if ($279) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $280
      var $281=$1;
      var $282=(($281+2684)|0);
      var $283=(($282+64)|0);
      var $284=(($283)|0);
      var $285=$284;
      var $286=HEAPU16[(($285)>>1)];
      var $287=(($286)&65535);
      $val4=$287;
      var $288=$val4;
      var $289=$1;
      var $290=(($289+5820)|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=$288 << $291;
      var $293=$1;
      var $294=(($293+5816)|0);
      var $295=HEAPU16[(($294)>>1)];
      var $296=(($295)&65535);
      var $297=$296 | $292;
      var $298=(($297) & 65535);
      HEAP16[(($294)>>1)]=$298;
      var $299=$1;
      var $300=(($299+5816)|0);
      var $301=HEAPU16[(($300)>>1)];
      var $302=(($301)&65535);
      var $303=$302 & 255;
      var $304=(($303) & 255);
      var $305=$1;
      var $306=(($305+20)|0);
      var $307=HEAPU32[(($306)>>2)];
      var $308=(($307+1)|0);
      HEAP32[(($306)>>2)]=$308;
      var $309=$1;
      var $310=(($309+8)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=(($311+$307)|0);
      HEAP8[($312)]=$304;
      var $313=$1;
      var $314=(($313+5816)|0);
      var $315=HEAPU16[(($314)>>1)];
      var $316=(($315)&65535);
      var $317=$316 >> 8;
      var $318=(($317) & 255);
      var $319=$1;
      var $320=(($319+20)|0);
      var $321=HEAPU32[(($320)>>2)];
      var $322=(($321+1)|0);
      HEAP32[(($320)>>2)]=$322;
      var $323=$1;
      var $324=(($323+8)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=(($325+$321)|0);
      HEAP8[($326)]=$318;
      var $327=$val4;
      var $328=(($327) & 65535);
      var $329=(($328)&65535);
      var $330=$1;
      var $331=(($330+5820)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=((16-$332)|0);
      var $334=$329 >> (($333)|0);
      var $335=(($334) & 65535);
      var $336=$1;
      var $337=(($336+5816)|0);
      HEAP16[(($337)>>1)]=$335;
      var $338=$len3;
      var $339=(($338-16)|0);
      var $340=$1;
      var $341=(($340+5820)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=(($342+$339)|0);
      HEAP32[(($341)>>2)]=$343;
      __label__ = 24; break;
    case 23: // $344
      var $345=$1;
      var $346=(($345+2684)|0);
      var $347=(($346+64)|0);
      var $348=(($347)|0);
      var $349=$348;
      var $350=HEAPU16[(($349)>>1)];
      var $351=(($350)&65535);
      var $352=$1;
      var $353=(($352+5820)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=$351 << $354;
      var $356=$1;
      var $357=(($356+5816)|0);
      var $358=HEAPU16[(($357)>>1)];
      var $359=(($358)&65535);
      var $360=$359 | $355;
      var $361=(($360) & 65535);
      HEAP16[(($357)>>1)]=$361;
      var $362=$len3;
      var $363=$1;
      var $364=(($363+5820)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=(($365+$362)|0);
      HEAP32[(($364)>>2)]=$366;
      __label__ = 24; break;
    case 24: // $367
      $len5=2;
      var $368=$1;
      var $369=(($368+5820)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=$len5;
      var $372=((16-$371)|0);
      var $373=(($370)|0) > (($372)|0);
      if ($373) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $374
      var $375=$count;
      var $376=(($375-3)|0);
      $val6=$376;
      var $377=$val6;
      var $378=$1;
      var $379=(($378+5820)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=$377 << $380;
      var $382=$1;
      var $383=(($382+5816)|0);
      var $384=HEAPU16[(($383)>>1)];
      var $385=(($384)&65535);
      var $386=$385 | $381;
      var $387=(($386) & 65535);
      HEAP16[(($383)>>1)]=$387;
      var $388=$1;
      var $389=(($388+5816)|0);
      var $390=HEAPU16[(($389)>>1)];
      var $391=(($390)&65535);
      var $392=$391 & 255;
      var $393=(($392) & 255);
      var $394=$1;
      var $395=(($394+20)|0);
      var $396=HEAPU32[(($395)>>2)];
      var $397=(($396+1)|0);
      HEAP32[(($395)>>2)]=$397;
      var $398=$1;
      var $399=(($398+8)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=(($400+$396)|0);
      HEAP8[($401)]=$393;
      var $402=$1;
      var $403=(($402+5816)|0);
      var $404=HEAPU16[(($403)>>1)];
      var $405=(($404)&65535);
      var $406=$405 >> 8;
      var $407=(($406) & 255);
      var $408=$1;
      var $409=(($408+20)|0);
      var $410=HEAPU32[(($409)>>2)];
      var $411=(($410+1)|0);
      HEAP32[(($409)>>2)]=$411;
      var $412=$1;
      var $413=(($412+8)|0);
      var $414=HEAP32[(($413)>>2)];
      var $415=(($414+$410)|0);
      HEAP8[($415)]=$407;
      var $416=$val6;
      var $417=(($416) & 65535);
      var $418=(($417)&65535);
      var $419=$1;
      var $420=(($419+5820)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=((16-$421)|0);
      var $423=$418 >> (($422)|0);
      var $424=(($423) & 65535);
      var $425=$1;
      var $426=(($425+5816)|0);
      HEAP16[(($426)>>1)]=$424;
      var $427=$len5;
      var $428=(($427-16)|0);
      var $429=$1;
      var $430=(($429+5820)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=(($431+$428)|0);
      HEAP32[(($430)>>2)]=$432;
      __label__ = 27; break;
    case 26: // $433
      var $434=$count;
      var $435=(($434-3)|0);
      var $436=$1;
      var $437=(($436+5820)|0);
      var $438=HEAP32[(($437)>>2)];
      var $439=$435 << $438;
      var $440=$1;
      var $441=(($440+5816)|0);
      var $442=HEAPU16[(($441)>>1)];
      var $443=(($442)&65535);
      var $444=$443 | $439;
      var $445=(($444) & 65535);
      HEAP16[(($441)>>1)]=$445;
      var $446=$len5;
      var $447=$1;
      var $448=(($447+5820)|0);
      var $449=HEAP32[(($448)>>2)];
      var $450=(($449+$446)|0);
      HEAP32[(($448)>>2)]=$450;
      __label__ = 27; break;
    case 27: // $451
      __label__ = 44; break;
    case 28: // $452
      var $453=$count;
      var $454=(($453)|0) <= 10;
      if ($454) { __label__ = 29; break; } else { __label__ = 36; break; }
    case 29: // $455
      var $456=$1;
      var $457=(($456+2684)|0);
      var $458=(($457+68)|0);
      var $459=(($458+2)|0);
      var $460=$459;
      var $461=HEAPU16[(($460)>>1)];
      var $462=(($461)&65535);
      $len7=$462;
      var $463=$1;
      var $464=(($463+5820)|0);
      var $465=HEAP32[(($464)>>2)];
      var $466=$len7;
      var $467=((16-$466)|0);
      var $468=(($465)|0) > (($467)|0);
      if ($468) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $469
      var $470=$1;
      var $471=(($470+2684)|0);
      var $472=(($471+68)|0);
      var $473=(($472)|0);
      var $474=$473;
      var $475=HEAPU16[(($474)>>1)];
      var $476=(($475)&65535);
      $val8=$476;
      var $477=$val8;
      var $478=$1;
      var $479=(($478+5820)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=$477 << $480;
      var $482=$1;
      var $483=(($482+5816)|0);
      var $484=HEAPU16[(($483)>>1)];
      var $485=(($484)&65535);
      var $486=$485 | $481;
      var $487=(($486) & 65535);
      HEAP16[(($483)>>1)]=$487;
      var $488=$1;
      var $489=(($488+5816)|0);
      var $490=HEAPU16[(($489)>>1)];
      var $491=(($490)&65535);
      var $492=$491 & 255;
      var $493=(($492) & 255);
      var $494=$1;
      var $495=(($494+20)|0);
      var $496=HEAPU32[(($495)>>2)];
      var $497=(($496+1)|0);
      HEAP32[(($495)>>2)]=$497;
      var $498=$1;
      var $499=(($498+8)|0);
      var $500=HEAP32[(($499)>>2)];
      var $501=(($500+$496)|0);
      HEAP8[($501)]=$493;
      var $502=$1;
      var $503=(($502+5816)|0);
      var $504=HEAPU16[(($503)>>1)];
      var $505=(($504)&65535);
      var $506=$505 >> 8;
      var $507=(($506) & 255);
      var $508=$1;
      var $509=(($508+20)|0);
      var $510=HEAPU32[(($509)>>2)];
      var $511=(($510+1)|0);
      HEAP32[(($509)>>2)]=$511;
      var $512=$1;
      var $513=(($512+8)|0);
      var $514=HEAP32[(($513)>>2)];
      var $515=(($514+$510)|0);
      HEAP8[($515)]=$507;
      var $516=$val8;
      var $517=(($516) & 65535);
      var $518=(($517)&65535);
      var $519=$1;
      var $520=(($519+5820)|0);
      var $521=HEAP32[(($520)>>2)];
      var $522=((16-$521)|0);
      var $523=$518 >> (($522)|0);
      var $524=(($523) & 65535);
      var $525=$1;
      var $526=(($525+5816)|0);
      HEAP16[(($526)>>1)]=$524;
      var $527=$len7;
      var $528=(($527-16)|0);
      var $529=$1;
      var $530=(($529+5820)|0);
      var $531=HEAP32[(($530)>>2)];
      var $532=(($531+$528)|0);
      HEAP32[(($530)>>2)]=$532;
      __label__ = 32; break;
    case 31: // $533
      var $534=$1;
      var $535=(($534+2684)|0);
      var $536=(($535+68)|0);
      var $537=(($536)|0);
      var $538=$537;
      var $539=HEAPU16[(($538)>>1)];
      var $540=(($539)&65535);
      var $541=$1;
      var $542=(($541+5820)|0);
      var $543=HEAP32[(($542)>>2)];
      var $544=$540 << $543;
      var $545=$1;
      var $546=(($545+5816)|0);
      var $547=HEAPU16[(($546)>>1)];
      var $548=(($547)&65535);
      var $549=$548 | $544;
      var $550=(($549) & 65535);
      HEAP16[(($546)>>1)]=$550;
      var $551=$len7;
      var $552=$1;
      var $553=(($552+5820)|0);
      var $554=HEAP32[(($553)>>2)];
      var $555=(($554+$551)|0);
      HEAP32[(($553)>>2)]=$555;
      __label__ = 32; break;
    case 32: // $556
      $len9=3;
      var $557=$1;
      var $558=(($557+5820)|0);
      var $559=HEAP32[(($558)>>2)];
      var $560=$len9;
      var $561=((16-$560)|0);
      var $562=(($559)|0) > (($561)|0);
      if ($562) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $563
      var $564=$count;
      var $565=(($564-3)|0);
      $val10=$565;
      var $566=$val10;
      var $567=$1;
      var $568=(($567+5820)|0);
      var $569=HEAP32[(($568)>>2)];
      var $570=$566 << $569;
      var $571=$1;
      var $572=(($571+5816)|0);
      var $573=HEAPU16[(($572)>>1)];
      var $574=(($573)&65535);
      var $575=$574 | $570;
      var $576=(($575) & 65535);
      HEAP16[(($572)>>1)]=$576;
      var $577=$1;
      var $578=(($577+5816)|0);
      var $579=HEAPU16[(($578)>>1)];
      var $580=(($579)&65535);
      var $581=$580 & 255;
      var $582=(($581) & 255);
      var $583=$1;
      var $584=(($583+20)|0);
      var $585=HEAPU32[(($584)>>2)];
      var $586=(($585+1)|0);
      HEAP32[(($584)>>2)]=$586;
      var $587=$1;
      var $588=(($587+8)|0);
      var $589=HEAP32[(($588)>>2)];
      var $590=(($589+$585)|0);
      HEAP8[($590)]=$582;
      var $591=$1;
      var $592=(($591+5816)|0);
      var $593=HEAPU16[(($592)>>1)];
      var $594=(($593)&65535);
      var $595=$594 >> 8;
      var $596=(($595) & 255);
      var $597=$1;
      var $598=(($597+20)|0);
      var $599=HEAPU32[(($598)>>2)];
      var $600=(($599+1)|0);
      HEAP32[(($598)>>2)]=$600;
      var $601=$1;
      var $602=(($601+8)|0);
      var $603=HEAP32[(($602)>>2)];
      var $604=(($603+$599)|0);
      HEAP8[($604)]=$596;
      var $605=$val10;
      var $606=(($605) & 65535);
      var $607=(($606)&65535);
      var $608=$1;
      var $609=(($608+5820)|0);
      var $610=HEAP32[(($609)>>2)];
      var $611=((16-$610)|0);
      var $612=$607 >> (($611)|0);
      var $613=(($612) & 65535);
      var $614=$1;
      var $615=(($614+5816)|0);
      HEAP16[(($615)>>1)]=$613;
      var $616=$len9;
      var $617=(($616-16)|0);
      var $618=$1;
      var $619=(($618+5820)|0);
      var $620=HEAP32[(($619)>>2)];
      var $621=(($620+$617)|0);
      HEAP32[(($619)>>2)]=$621;
      __label__ = 35; break;
    case 34: // $622
      var $623=$count;
      var $624=(($623-3)|0);
      var $625=$1;
      var $626=(($625+5820)|0);
      var $627=HEAP32[(($626)>>2)];
      var $628=$624 << $627;
      var $629=$1;
      var $630=(($629+5816)|0);
      var $631=HEAPU16[(($630)>>1)];
      var $632=(($631)&65535);
      var $633=$632 | $628;
      var $634=(($633) & 65535);
      HEAP16[(($630)>>1)]=$634;
      var $635=$len9;
      var $636=$1;
      var $637=(($636+5820)|0);
      var $638=HEAP32[(($637)>>2)];
      var $639=(($638+$635)|0);
      HEAP32[(($637)>>2)]=$639;
      __label__ = 35; break;
    case 35: // $640
      __label__ = 43; break;
    case 36: // $641
      var $642=$1;
      var $643=(($642+2684)|0);
      var $644=(($643+72)|0);
      var $645=(($644+2)|0);
      var $646=$645;
      var $647=HEAPU16[(($646)>>1)];
      var $648=(($647)&65535);
      $len11=$648;
      var $649=$1;
      var $650=(($649+5820)|0);
      var $651=HEAP32[(($650)>>2)];
      var $652=$len11;
      var $653=((16-$652)|0);
      var $654=(($651)|0) > (($653)|0);
      if ($654) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $655
      var $656=$1;
      var $657=(($656+2684)|0);
      var $658=(($657+72)|0);
      var $659=(($658)|0);
      var $660=$659;
      var $661=HEAPU16[(($660)>>1)];
      var $662=(($661)&65535);
      $val12=$662;
      var $663=$val12;
      var $664=$1;
      var $665=(($664+5820)|0);
      var $666=HEAP32[(($665)>>2)];
      var $667=$663 << $666;
      var $668=$1;
      var $669=(($668+5816)|0);
      var $670=HEAPU16[(($669)>>1)];
      var $671=(($670)&65535);
      var $672=$671 | $667;
      var $673=(($672) & 65535);
      HEAP16[(($669)>>1)]=$673;
      var $674=$1;
      var $675=(($674+5816)|0);
      var $676=HEAPU16[(($675)>>1)];
      var $677=(($676)&65535);
      var $678=$677 & 255;
      var $679=(($678) & 255);
      var $680=$1;
      var $681=(($680+20)|0);
      var $682=HEAPU32[(($681)>>2)];
      var $683=(($682+1)|0);
      HEAP32[(($681)>>2)]=$683;
      var $684=$1;
      var $685=(($684+8)|0);
      var $686=HEAP32[(($685)>>2)];
      var $687=(($686+$682)|0);
      HEAP8[($687)]=$679;
      var $688=$1;
      var $689=(($688+5816)|0);
      var $690=HEAPU16[(($689)>>1)];
      var $691=(($690)&65535);
      var $692=$691 >> 8;
      var $693=(($692) & 255);
      var $694=$1;
      var $695=(($694+20)|0);
      var $696=HEAPU32[(($695)>>2)];
      var $697=(($696+1)|0);
      HEAP32[(($695)>>2)]=$697;
      var $698=$1;
      var $699=(($698+8)|0);
      var $700=HEAP32[(($699)>>2)];
      var $701=(($700+$696)|0);
      HEAP8[($701)]=$693;
      var $702=$val12;
      var $703=(($702) & 65535);
      var $704=(($703)&65535);
      var $705=$1;
      var $706=(($705+5820)|0);
      var $707=HEAP32[(($706)>>2)];
      var $708=((16-$707)|0);
      var $709=$704 >> (($708)|0);
      var $710=(($709) & 65535);
      var $711=$1;
      var $712=(($711+5816)|0);
      HEAP16[(($712)>>1)]=$710;
      var $713=$len11;
      var $714=(($713-16)|0);
      var $715=$1;
      var $716=(($715+5820)|0);
      var $717=HEAP32[(($716)>>2)];
      var $718=(($717+$714)|0);
      HEAP32[(($716)>>2)]=$718;
      __label__ = 39; break;
    case 38: // $719
      var $720=$1;
      var $721=(($720+2684)|0);
      var $722=(($721+72)|0);
      var $723=(($722)|0);
      var $724=$723;
      var $725=HEAPU16[(($724)>>1)];
      var $726=(($725)&65535);
      var $727=$1;
      var $728=(($727+5820)|0);
      var $729=HEAP32[(($728)>>2)];
      var $730=$726 << $729;
      var $731=$1;
      var $732=(($731+5816)|0);
      var $733=HEAPU16[(($732)>>1)];
      var $734=(($733)&65535);
      var $735=$734 | $730;
      var $736=(($735) & 65535);
      HEAP16[(($732)>>1)]=$736;
      var $737=$len11;
      var $738=$1;
      var $739=(($738+5820)|0);
      var $740=HEAP32[(($739)>>2)];
      var $741=(($740+$737)|0);
      HEAP32[(($739)>>2)]=$741;
      __label__ = 39; break;
    case 39: // $742
      $len13=7;
      var $743=$1;
      var $744=(($743+5820)|0);
      var $745=HEAP32[(($744)>>2)];
      var $746=$len13;
      var $747=((16-$746)|0);
      var $748=(($745)|0) > (($747)|0);
      if ($748) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $749
      var $750=$count;
      var $751=(($750-11)|0);
      $val14=$751;
      var $752=$val14;
      var $753=$1;
      var $754=(($753+5820)|0);
      var $755=HEAP32[(($754)>>2)];
      var $756=$752 << $755;
      var $757=$1;
      var $758=(($757+5816)|0);
      var $759=HEAPU16[(($758)>>1)];
      var $760=(($759)&65535);
      var $761=$760 | $756;
      var $762=(($761) & 65535);
      HEAP16[(($758)>>1)]=$762;
      var $763=$1;
      var $764=(($763+5816)|0);
      var $765=HEAPU16[(($764)>>1)];
      var $766=(($765)&65535);
      var $767=$766 & 255;
      var $768=(($767) & 255);
      var $769=$1;
      var $770=(($769+20)|0);
      var $771=HEAPU32[(($770)>>2)];
      var $772=(($771+1)|0);
      HEAP32[(($770)>>2)]=$772;
      var $773=$1;
      var $774=(($773+8)|0);
      var $775=HEAP32[(($774)>>2)];
      var $776=(($775+$771)|0);
      HEAP8[($776)]=$768;
      var $777=$1;
      var $778=(($777+5816)|0);
      var $779=HEAPU16[(($778)>>1)];
      var $780=(($779)&65535);
      var $781=$780 >> 8;
      var $782=(($781) & 255);
      var $783=$1;
      var $784=(($783+20)|0);
      var $785=HEAPU32[(($784)>>2)];
      var $786=(($785+1)|0);
      HEAP32[(($784)>>2)]=$786;
      var $787=$1;
      var $788=(($787+8)|0);
      var $789=HEAP32[(($788)>>2)];
      var $790=(($789+$785)|0);
      HEAP8[($790)]=$782;
      var $791=$val14;
      var $792=(($791) & 65535);
      var $793=(($792)&65535);
      var $794=$1;
      var $795=(($794+5820)|0);
      var $796=HEAP32[(($795)>>2)];
      var $797=((16-$796)|0);
      var $798=$793 >> (($797)|0);
      var $799=(($798) & 65535);
      var $800=$1;
      var $801=(($800+5816)|0);
      HEAP16[(($801)>>1)]=$799;
      var $802=$len13;
      var $803=(($802-16)|0);
      var $804=$1;
      var $805=(($804+5820)|0);
      var $806=HEAP32[(($805)>>2)];
      var $807=(($806+$803)|0);
      HEAP32[(($805)>>2)]=$807;
      __label__ = 42; break;
    case 41: // $808
      var $809=$count;
      var $810=(($809-11)|0);
      var $811=$1;
      var $812=(($811+5820)|0);
      var $813=HEAP32[(($812)>>2)];
      var $814=$810 << $813;
      var $815=$1;
      var $816=(($815+5816)|0);
      var $817=HEAPU16[(($816)>>1)];
      var $818=(($817)&65535);
      var $819=$818 | $814;
      var $820=(($819) & 65535);
      HEAP16[(($816)>>1)]=$820;
      var $821=$len13;
      var $822=$1;
      var $823=(($822+5820)|0);
      var $824=HEAP32[(($823)>>2)];
      var $825=(($824+$821)|0);
      HEAP32[(($823)>>2)]=$825;
      __label__ = 42; break;
    case 42: // $826
      __label__ = 43; break;
    case 43: // $827
      __label__ = 44; break;
    case 44: // $828
      __label__ = 45; break;
    case 45: // $829
      __label__ = 46; break;
    case 46: // $830
      $count=0;
      var $831=$curlen;
      $prevlen=$831;
      var $832=$nextlen;
      var $833=(($832)|0)==0;
      if ($833) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $834
      $max_count=138;
      $min_count=3;
      __label__ = 52; break;
    case 48: // $835
      var $836=$curlen;
      var $837=$nextlen;
      var $838=(($836)|0)==(($837)|0);
      if ($838) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $839
      $max_count=6;
      $min_count=3;
      __label__ = 51; break;
    case 50: // $840
      $max_count=7;
      $min_count=4;
      __label__ = 51; break;
    case 51: // $841
      __label__ = 52; break;
    case 52: // $842
      __label__ = 53; break;
    case 53: // $843
      var $844=$n;
      var $845=(($844+1)|0);
      $n=$845;
      __label__ = 3; break;
    case 54: // $846
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_send_tree["X"]=1;

function _bi_reverse($code, $len) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $res;
      $1=$code;
      $2=$len;
      $res=0;
      __label__ = 1; break;
    case 1: // $3
      var $4=$1;
      var $5=$4 & 1;
      var $6=$res;
      var $7=$6 | $5;
      $res=$7;
      var $8=$1;
      var $9=$8 >>> 1;
      $1=$9;
      var $10=$res;
      var $11=$10 << 1;
      $res=$11;
      __label__ = 2; break;
    case 2: // $12
      var $13=$2;
      var $14=(($13-1)|0);
      $2=$14;
      var $15=(($14)|0) > 0;
      if ($15) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$res;
      var $18=$17 >>> 1;
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function _scan_tree($s, $tree, $max_code) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $n;
      var $prevlen;
      var $curlen;
      var $nextlen;
      var $count;
      var $max_count;
      var $min_count;
      $1=$s;
      $2=$tree;
      $3=$max_code;
      $prevlen=-1;
      var $4=$2;
      var $5=(($4)|0);
      var $6=(($5+2)|0);
      var $7=$6;
      var $8=HEAPU16[(($7)>>1)];
      var $9=(($8)&65535);
      $nextlen=$9;
      $count=0;
      $max_count=7;
      $min_count=4;
      var $10=$nextlen;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $max_count=138;
      $min_count=3;
      __label__ = 2; break;
    case 2: // $13
      var $14=$3;
      var $15=(($14+1)|0);
      var $16=$2;
      var $17=(($16+($15<<2))|0);
      var $18=(($17+2)|0);
      var $19=$18;
      HEAP16[(($19)>>1)]=-1;
      $n=0;
      __label__ = 3; break;
    case 3: // $20
      var $21=$n;
      var $22=$3;
      var $23=(($21)|0) <= (($22)|0);
      if ($23) { __label__ = 4; break; } else { __label__ = 27; break; }
    case 4: // $24
      var $25=$nextlen;
      $curlen=$25;
      var $26=$n;
      var $27=(($26+1)|0);
      var $28=$2;
      var $29=(($28+($27<<2))|0);
      var $30=(($29+2)|0);
      var $31=$30;
      var $32=HEAPU16[(($31)>>1)];
      var $33=(($32)&65535);
      $nextlen=$33;
      var $34=$count;
      var $35=(($34+1)|0);
      $count=$35;
      var $36=$max_count;
      var $37=(($35)|0) < (($36)|0);
      if ($37) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $38
      var $39=$curlen;
      var $40=$nextlen;
      var $41=(($39)|0)==(($40)|0);
      if ($41) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $42
      __label__ = 26; break;
    case 7: // $43
      var $44=$count;
      var $45=$min_count;
      var $46=(($44)|0) < (($45)|0);
      if ($46) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $47
      var $48=$count;
      var $49=$curlen;
      var $50=$1;
      var $51=(($50+2684)|0);
      var $52=(($51+($49<<2))|0);
      var $53=(($52)|0);
      var $54=$53;
      var $55=HEAPU16[(($54)>>1)];
      var $56=(($55)&65535);
      var $57=(($56+$48)|0);
      var $58=(($57) & 65535);
      HEAP16[(($54)>>1)]=$58;
      __label__ = 18; break;
    case 9: // $59
      var $60=$curlen;
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $62
      var $63=$curlen;
      var $64=$prevlen;
      var $65=(($63)|0)!=(($64)|0);
      if ($65) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $66
      var $67=$curlen;
      var $68=$1;
      var $69=(($68+2684)|0);
      var $70=(($69+($67<<2))|0);
      var $71=(($70)|0);
      var $72=$71;
      var $73=HEAP16[(($72)>>1)];
      var $74=(($73+1)&65535);
      HEAP16[(($72)>>1)]=$74;
      __label__ = 12; break;
    case 12: // $75
      var $76=$1;
      var $77=(($76+2684)|0);
      var $78=(($77+64)|0);
      var $79=(($78)|0);
      var $80=$79;
      var $81=HEAP16[(($80)>>1)];
      var $82=(($81+1)&65535);
      HEAP16[(($80)>>1)]=$82;
      __label__ = 17; break;
    case 13: // $83
      var $84=$count;
      var $85=(($84)|0) <= 10;
      if ($85) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $86
      var $87=$1;
      var $88=(($87+2684)|0);
      var $89=(($88+68)|0);
      var $90=(($89)|0);
      var $91=$90;
      var $92=HEAP16[(($91)>>1)];
      var $93=(($92+1)&65535);
      HEAP16[(($91)>>1)]=$93;
      __label__ = 16; break;
    case 15: // $94
      var $95=$1;
      var $96=(($95+2684)|0);
      var $97=(($96+72)|0);
      var $98=(($97)|0);
      var $99=$98;
      var $100=HEAP16[(($99)>>1)];
      var $101=(($100+1)&65535);
      HEAP16[(($99)>>1)]=$101;
      __label__ = 16; break;
    case 16: // $102
      __label__ = 17; break;
    case 17: // $103
      __label__ = 18; break;
    case 18: // $104
      __label__ = 19; break;
    case 19: // $105
      $count=0;
      var $106=$curlen;
      $prevlen=$106;
      var $107=$nextlen;
      var $108=(($107)|0)==0;
      if ($108) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $109
      $max_count=138;
      $min_count=3;
      __label__ = 25; break;
    case 21: // $110
      var $111=$curlen;
      var $112=$nextlen;
      var $113=(($111)|0)==(($112)|0);
      if ($113) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $114
      $max_count=6;
      $min_count=3;
      __label__ = 24; break;
    case 23: // $115
      $max_count=7;
      $min_count=4;
      __label__ = 24; break;
    case 24: // $116
      __label__ = 25; break;
    case 25: // $117
      __label__ = 26; break;
    case 26: // $118
      var $119=$n;
      var $120=(($119+1)|0);
      $n=$120;
      __label__ = 3; break;
    case 27: // $121
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_scan_tree["X"]=1;

function _pqdownheap($s, $tree, $k) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $v;
      var $j;
      $1=$s;
      $2=$tree;
      $3=$k;
      var $4=$3;
      var $5=$1;
      var $6=(($5+2908)|0);
      var $7=(($6+($4<<2))|0);
      var $8=HEAP32[(($7)>>2)];
      $v=$8;
      var $9=$3;
      var $10=$9 << 1;
      $j=$10;
      __label__ = 1; break;
    case 1: // $11
      var $12=$j;
      var $13=$1;
      var $14=(($13+5200)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=(($12)|0) <= (($15)|0);
      if ($16) { __label__ = 2; break; } else { __label__ = 12; break; }
    case 2: // $17
      var $18=$j;
      var $19=$1;
      var $20=(($19+5200)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($18)|0) < (($21)|0);
      if ($22) { __label__ = 3; break; } else { __label__ = 7; break; }
    case 3: // $23
      var $24=$j;
      var $25=(($24+1)|0);
      var $26=$1;
      var $27=(($26+2908)|0);
      var $28=(($27+($25<<2))|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=(($30+($29<<2))|0);
      var $32=(($31)|0);
      var $33=$32;
      var $34=HEAPU16[(($33)>>1)];
      var $35=(($34)&65535);
      var $36=$j;
      var $37=$1;
      var $38=(($37+2908)|0);
      var $39=(($38+($36<<2))|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$2;
      var $42=(($41+($40<<2))|0);
      var $43=(($42)|0);
      var $44=$43;
      var $45=HEAPU16[(($44)>>1)];
      var $46=(($45)&65535);
      var $47=(($35)|0) < (($46)|0);
      if ($47) { __label__ = 6; break; } else { __label__ = 4; break; }
    case 4: // $48
      var $49=$j;
      var $50=(($49+1)|0);
      var $51=$1;
      var $52=(($51+2908)|0);
      var $53=(($52+($50<<2))|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=$2;
      var $56=(($55+($54<<2))|0);
      var $57=(($56)|0);
      var $58=$57;
      var $59=HEAPU16[(($58)>>1)];
      var $60=(($59)&65535);
      var $61=$j;
      var $62=$1;
      var $63=(($62+2908)|0);
      var $64=(($63+($61<<2))|0);
      var $65=HEAP32[(($64)>>2)];
      var $66=$2;
      var $67=(($66+($65<<2))|0);
      var $68=(($67)|0);
      var $69=$68;
      var $70=HEAPU16[(($69)>>1)];
      var $71=(($70)&65535);
      var $72=(($60)|0)==(($71)|0);
      if ($72) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $73
      var $74=$j;
      var $75=(($74+1)|0);
      var $76=$1;
      var $77=(($76+2908)|0);
      var $78=(($77+($75<<2))|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$1;
      var $81=(($80+5208)|0);
      var $82=(($81+$79)|0);
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$j;
      var $86=$1;
      var $87=(($86+2908)|0);
      var $88=(($87+($85<<2))|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=$1;
      var $91=(($90+5208)|0);
      var $92=(($91+$89)|0);
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=(($84)|0) <= (($94)|0);
      if ($95) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $96
      var $97=$j;
      var $98=(($97+1)|0);
      $j=$98;
      __label__ = 7; break;
    case 7: // $99
      var $100=$v;
      var $101=$2;
      var $102=(($101+($100<<2))|0);
      var $103=(($102)|0);
      var $104=$103;
      var $105=HEAPU16[(($104)>>1)];
      var $106=(($105)&65535);
      var $107=$j;
      var $108=$1;
      var $109=(($108+2908)|0);
      var $110=(($109+($107<<2))|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$2;
      var $113=(($112+($111<<2))|0);
      var $114=(($113)|0);
      var $115=$114;
      var $116=HEAPU16[(($115)>>1)];
      var $117=(($116)&65535);
      var $118=(($106)|0) < (($117)|0);
      if ($118) { __label__ = 10; break; } else { __label__ = 8; break; }
    case 8: // $119
      var $120=$v;
      var $121=$2;
      var $122=(($121+($120<<2))|0);
      var $123=(($122)|0);
      var $124=$123;
      var $125=HEAPU16[(($124)>>1)];
      var $126=(($125)&65535);
      var $127=$j;
      var $128=$1;
      var $129=(($128+2908)|0);
      var $130=(($129+($127<<2))|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$2;
      var $133=(($132+($131<<2))|0);
      var $134=(($133)|0);
      var $135=$134;
      var $136=HEAPU16[(($135)>>1)];
      var $137=(($136)&65535);
      var $138=(($126)|0)==(($137)|0);
      if ($138) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $139
      var $140=$v;
      var $141=$1;
      var $142=(($141+5208)|0);
      var $143=(($142+$140)|0);
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=$j;
      var $147=$1;
      var $148=(($147+2908)|0);
      var $149=(($148+($146<<2))|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=$1;
      var $152=(($151+5208)|0);
      var $153=(($152+$150)|0);
      var $154=HEAPU8[($153)];
      var $155=(($154)&255);
      var $156=(($145)|0) <= (($155)|0);
      if ($156) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $157
      __label__ = 12; break;
    case 11: // $158
      var $159=$j;
      var $160=$1;
      var $161=(($160+2908)|0);
      var $162=(($161+($159<<2))|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=$3;
      var $165=$1;
      var $166=(($165+2908)|0);
      var $167=(($166+($164<<2))|0);
      HEAP32[(($167)>>2)]=$163;
      var $168=$j;
      $3=$168;
      var $169=$j;
      var $170=$169 << 1;
      $j=$170;
      __label__ = 1; break;
    case 12: // $171
      var $172=$v;
      var $173=$3;
      var $174=$1;
      var $175=(($174+2908)|0);
      var $176=(($175+($173<<2))|0);
      HEAP32[(($176)>>2)]=$172;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_pqdownheap["X"]=1;

function _gen_bitlen($s, $desc) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $tree;
      var $max_code;
      var $stree;
      var $extra;
      var $base;
      var $max_length;
      var $h;
      var $n;
      var $m;
      var $bits;
      var $xbits;
      var $f;
      var $overflow;
      $1=$s;
      $2=$desc;
      var $3=$2;
      var $4=(($3)|0);
      var $5=HEAP32[(($4)>>2)];
      $tree=$5;
      var $6=$2;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      $max_code=$8;
      var $9=$2;
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($11)|0);
      var $13=HEAP32[(($12)>>2)];
      $stree=$13;
      var $14=$2;
      var $15=(($14+8)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      $extra=$18;
      var $19=$2;
      var $20=(($19+8)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21+8)|0);
      var $23=HEAP32[(($22)>>2)];
      $base=$23;
      var $24=$2;
      var $25=(($24+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      $max_length=$28;
      $overflow=0;
      $bits=0;
      __label__ = 1; break;
    case 1: // $29
      var $30=$bits;
      var $31=(($30)|0) <= 15;
      if ($31) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $32
      var $33=$bits;
      var $34=$1;
      var $35=(($34+2876)|0);
      var $36=(($35+($33<<1))|0);
      HEAP16[(($36)>>1)]=0;
      __label__ = 3; break;
    case 3: // $37
      var $38=$bits;
      var $39=(($38+1)|0);
      $bits=$39;
      __label__ = 1; break;
    case 4: // $40
      var $41=$1;
      var $42=(($41+5204)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$1;
      var $45=(($44+2908)|0);
      var $46=(($45+($43<<2))|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$tree;
      var $49=(($48+($47<<2))|0);
      var $50=(($49+2)|0);
      var $51=$50;
      HEAP16[(($51)>>1)]=0;
      var $52=$1;
      var $53=(($52+5204)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=(($54+1)|0);
      $h=$55;
      __label__ = 5; break;
    case 5: // $56
      var $57=$h;
      var $58=(($57)|0) < 573;
      if ($58) { __label__ = 6; break; } else { __label__ = 16; break; }
    case 6: // $59
      var $60=$h;
      var $61=$1;
      var $62=(($61+2908)|0);
      var $63=(($62+($60<<2))|0);
      var $64=HEAP32[(($63)>>2)];
      $n=$64;
      var $65=$n;
      var $66=$tree;
      var $67=(($66+($65<<2))|0);
      var $68=(($67+2)|0);
      var $69=$68;
      var $70=HEAPU16[(($69)>>1)];
      var $71=(($70)&65535);
      var $72=$tree;
      var $73=(($72+($71<<2))|0);
      var $74=(($73+2)|0);
      var $75=$74;
      var $76=HEAPU16[(($75)>>1)];
      var $77=(($76)&65535);
      var $78=(($77+1)|0);
      $bits=$78;
      var $79=$bits;
      var $80=$max_length;
      var $81=(($79)|0) > (($80)|0);
      if ($81) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $82
      var $83=$max_length;
      $bits=$83;
      var $84=$overflow;
      var $85=(($84+1)|0);
      $overflow=$85;
      __label__ = 8; break;
    case 8: // $86
      var $87=$bits;
      var $88=(($87) & 65535);
      var $89=$n;
      var $90=$tree;
      var $91=(($90+($89<<2))|0);
      var $92=(($91+2)|0);
      var $93=$92;
      HEAP16[(($93)>>1)]=$88;
      var $94=$n;
      var $95=$max_code;
      var $96=(($94)|0) > (($95)|0);
      if ($96) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $97
      __label__ = 15; break;
    case 10: // $98
      var $99=$bits;
      var $100=$1;
      var $101=(($100+2876)|0);
      var $102=(($101+($99<<1))|0);
      var $103=HEAP16[(($102)>>1)];
      var $104=(($103+1)&65535);
      HEAP16[(($102)>>1)]=$104;
      $xbits=0;
      var $105=$n;
      var $106=$base;
      var $107=(($105)|0) >= (($106)|0);
      if ($107) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $108
      var $109=$n;
      var $110=$base;
      var $111=(($109-$110)|0);
      var $112=$extra;
      var $113=(($112+($111<<2))|0);
      var $114=HEAP32[(($113)>>2)];
      $xbits=$114;
      __label__ = 12; break;
    case 12: // $115
      var $116=$n;
      var $117=$tree;
      var $118=(($117+($116<<2))|0);
      var $119=(($118)|0);
      var $120=$119;
      var $121=HEAP16[(($120)>>1)];
      $f=$121;
      var $122=$f;
      var $123=(($122)&65535);
      var $124=$bits;
      var $125=$xbits;
      var $126=(($124+$125)|0);
      var $127=(($123*$126)|0);
      var $128=$1;
      var $129=(($128+5800)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+$127)|0);
      HEAP32[(($129)>>2)]=$131;
      var $132=$stree;
      var $133=(($132)|0)!=0;
      if ($133) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $134
      var $135=$f;
      var $136=(($135)&65535);
      var $137=$n;
      var $138=$stree;
      var $139=(($138+($137<<2))|0);
      var $140=(($139+2)|0);
      var $141=$140;
      var $142=HEAPU16[(($141)>>1)];
      var $143=(($142)&65535);
      var $144=$xbits;
      var $145=(($143+$144)|0);
      var $146=(($136*$145)|0);
      var $147=$1;
      var $148=(($147+5804)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+$146)|0);
      HEAP32[(($148)>>2)]=$150;
      __label__ = 14; break;
    case 14: // $151
      __label__ = 15; break;
    case 15: // $152
      var $153=$h;
      var $154=(($153+1)|0);
      $h=$154;
      __label__ = 5; break;
    case 16: // $155
      var $156=$overflow;
      var $157=(($156)|0)==0;
      if ($157) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $158
      __label__ = 35; break;
    case 18: // $159
      __label__ = 19; break;
    case 19: // $160
      var $161=$max_length;
      var $162=(($161-1)|0);
      $bits=$162;
      __label__ = 20; break;
    case 20: // $163
      var $164=$bits;
      var $165=$1;
      var $166=(($165+2876)|0);
      var $167=(($166+($164<<1))|0);
      var $168=HEAPU16[(($167)>>1)];
      var $169=(($168)&65535);
      var $170=(($169)|0)==0;
      if ($170) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $171
      var $172=$bits;
      var $173=(($172-1)|0);
      $bits=$173;
      __label__ = 20; break;
    case 22: // $174
      var $175=$bits;
      var $176=$1;
      var $177=(($176+2876)|0);
      var $178=(($177+($175<<1))|0);
      var $179=HEAP16[(($178)>>1)];
      var $180=(($179-1)&65535);
      HEAP16[(($178)>>1)]=$180;
      var $181=$bits;
      var $182=(($181+1)|0);
      var $183=$1;
      var $184=(($183+2876)|0);
      var $185=(($184+($182<<1))|0);
      var $186=HEAPU16[(($185)>>1)];
      var $187=(($186)&65535);
      var $188=(($187+2)|0);
      var $189=(($188) & 65535);
      HEAP16[(($185)>>1)]=$189;
      var $190=$max_length;
      var $191=$1;
      var $192=(($191+2876)|0);
      var $193=(($192+($190<<1))|0);
      var $194=HEAP16[(($193)>>1)];
      var $195=(($194-1)&65535);
      HEAP16[(($193)>>1)]=$195;
      var $196=$overflow;
      var $197=(($196-2)|0);
      $overflow=$197;
      __label__ = 23; break;
    case 23: // $198
      var $199=$overflow;
      var $200=(($199)|0) > 0;
      if ($200) { __label__ = 19; break; } else { __label__ = 24; break; }
    case 24: // $201
      var $202=$max_length;
      $bits=$202;
      __label__ = 25; break;
    case 25: // $203
      var $204=$bits;
      var $205=(($204)|0)!=0;
      if ($205) { __label__ = 26; break; } else { __label__ = 35; break; }
    case 26: // $206
      var $207=$bits;
      var $208=$1;
      var $209=(($208+2876)|0);
      var $210=(($209+($207<<1))|0);
      var $211=HEAPU16[(($210)>>1)];
      var $212=(($211)&65535);
      $n=$212;
      __label__ = 27; break;
    case 27: // $213
      var $214=$n;
      var $215=(($214)|0)!=0;
      if ($215) { __label__ = 28; break; } else { __label__ = 33; break; }
    case 28: // $216
      var $217=$h;
      var $218=(($217-1)|0);
      $h=$218;
      var $219=$1;
      var $220=(($219+2908)|0);
      var $221=(($220+($218<<2))|0);
      var $222=HEAP32[(($221)>>2)];
      $m=$222;
      var $223=$m;
      var $224=$max_code;
      var $225=(($223)|0) > (($224)|0);
      if ($225) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $226
      __label__ = 27; break;
    case 30: // $227
      var $228=$m;
      var $229=$tree;
      var $230=(($229+($228<<2))|0);
      var $231=(($230+2)|0);
      var $232=$231;
      var $233=HEAPU16[(($232)>>1)];
      var $234=(($233)&65535);
      var $235=$bits;
      var $236=(($234)|0)!=(($235)|0);
      if ($236) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $237
      var $238=$bits;
      var $239=$m;
      var $240=$tree;
      var $241=(($240+($239<<2))|0);
      var $242=(($241+2)|0);
      var $243=$242;
      var $244=HEAPU16[(($243)>>1)];
      var $245=(($244)&65535);
      var $246=(($238-$245)|0);
      var $247=$m;
      var $248=$tree;
      var $249=(($248+($247<<2))|0);
      var $250=(($249)|0);
      var $251=$250;
      var $252=HEAPU16[(($251)>>1)];
      var $253=(($252)&65535);
      var $254=(($246*$253)|0);
      var $255=$1;
      var $256=(($255+5800)|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=(($257+$254)|0);
      HEAP32[(($256)>>2)]=$258;
      var $259=$bits;
      var $260=(($259) & 65535);
      var $261=$m;
      var $262=$tree;
      var $263=(($262+($261<<2))|0);
      var $264=(($263+2)|0);
      var $265=$264;
      HEAP16[(($265)>>1)]=$260;
      __label__ = 32; break;
    case 32: // $266
      var $267=$n;
      var $268=(($267-1)|0);
      $n=$268;
      __label__ = 27; break;
    case 33: // $269
      __label__ = 34; break;
    case 34: // $270
      var $271=$bits;
      var $272=(($271-1)|0);
      $bits=$272;
      __label__ = 25; break;
    case 35: // $273
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_gen_bitlen["X"]=1;

function _gen_codes($tree, $max_code, $bl_count) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $next_code=__stackBase__;
      var $code;
      var $bits;
      var $n;
      var $len;
      $1=$tree;
      $2=$max_code;
      $3=$bl_count;
      $code=0;
      $bits=1;
      __label__ = 1; break;
    case 1: // $4
      var $5=$bits;
      var $6=(($5)|0) <= 15;
      if ($6) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $7
      var $8=$code;
      var $9=(($8)&65535);
      var $10=$bits;
      var $11=(($10-1)|0);
      var $12=$3;
      var $13=(($12+($11<<1))|0);
      var $14=HEAPU16[(($13)>>1)];
      var $15=(($14)&65535);
      var $16=(($9+$15)|0);
      var $17=$16 << 1;
      var $18=(($17) & 65535);
      $code=$18;
      var $19=$bits;
      var $20=(($next_code+($19<<1))|0);
      HEAP16[(($20)>>1)]=$18;
      __label__ = 3; break;
    case 3: // $21
      var $22=$bits;
      var $23=(($22+1)|0);
      $bits=$23;
      __label__ = 1; break;
    case 4: // $24
      $n=0;
      __label__ = 5; break;
    case 5: // $25
      var $26=$n;
      var $27=$2;
      var $28=(($26)|0) <= (($27)|0);
      if ($28) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $29
      var $30=$n;
      var $31=$1;
      var $32=(($31+($30<<2))|0);
      var $33=(($32+2)|0);
      var $34=$33;
      var $35=HEAPU16[(($34)>>1)];
      var $36=(($35)&65535);
      $len=$36;
      var $37=$len;
      var $38=(($37)|0)==0;
      if ($38) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $39
      __label__ = 9; break;
    case 8: // $40
      var $41=$len;
      var $42=(($next_code+($41<<1))|0);
      var $43=HEAPU16[(($42)>>1)];
      var $44=(($43+1)&65535);
      HEAP16[(($42)>>1)]=$44;
      var $45=(($43)&65535);
      var $46=$len;
      var $47=_bi_reverse($45, $46);
      var $48=(($47) & 65535);
      var $49=$n;
      var $50=$1;
      var $51=(($50+($49<<2))|0);
      var $52=(($51)|0);
      var $53=$52;
      HEAP16[(($53)>>1)]=$48;
      __label__ = 9; break;
    case 9: // $54
      var $55=$n;
      var $56=(($55+1)|0);
      $n=$56;
      __label__ = 5; break;
    case 10: // $57
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
_gen_codes["X"]=1;

function _osd_get_clipboard_text() {
  ;
  var __label__;

  ;
  return 0;
}


function _osd_ticks_per_second() {
  ;
  var __label__;

  var $$emscripten$temp$0$0=1000;
  var $$emscripten$temp$0$1=0;
  ;
  return [$$emscripten$temp$0$0,$$emscripten$temp$0$1];
}


function _osd_lock_alloc() {
  ;
  var __label__;

  ;
  return 1;
}


function _osd_get_volume_name($idx) {
  ;
  var __label__;

  var $1;
  $1=$idx;
  ;
  return 0;
}


function _osd_opendir($dirname) {
  ;
  var __label__;

  var $1;
  $1=$dirname;
  ;
  return 0;
}


function _osd_readdir($dir) {
  ;
  var __label__;

  var $1;
  $1=$dir;
  ;
  return 0;
}


function _osd_closedir($dir) {
  ;
  var __label__;

  var $1;
  $1=$dir;
  ;
  return;
}


function _osd_is_absolute_path($path) {
  ;
  var __label__;

  var $1;
  $1=$path;
  ;
  return 0;
}


function _osd_break_into_debugger($message) {
  ;
  var __label__;

  var $1;
  $1=$message;
  ;
  return;
}


function _osd_work_queue_alloc($flags) {
  ;
  var __label__;

  var $1;
  $1=$flags;
  ;
  return 1;
}


function _osd_work_queue_free($queue) {
  ;
  var __label__;

  var $1;
  $1=$queue;
  ;
  return;
}


function _osd_lock_acquire($lock) {
  ;
  var __label__;

  var $1;
  $1=$lock;
  ;
  return;
}


function _osd_lock_release($lock) {
  ;
  var __label__;

  var $1;
  $1=$lock;
  ;
  return;
}


function _osd_lock_free($lock) {
  ;
  var __label__;

  var $1;
  $1=$lock;
  ;
  return;
}


function _osd_uchar_from_osdchar($uchar, $osdchar, $count) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  $1=$uchar;
  $2=$osdchar;
  $3=$count;
  var $4=$2;
  var $5=HEAPU8[($4)];
  var $6=(($5)&255);
  var $7=$1;
  HEAP32[(($7)>>2)]=$6;
  ;
  return 1;
}


function _osd_work_item_wait($item, $timeout$0, $timeout$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2=__stackBase__;
  $1=$item;
  var $st$3$0=(($2)|0);
  HEAP32[(($st$3$0)>>2)]=$timeout$0;
  var $st$3$1=(($2+4)|0);
  HEAP32[(($st$3$1)>>2)]=$timeout$1;
  STACKTOP = __stackBase__;
  return 1;
}


function _osd_work_item_result($item) {
  ;
  var __label__;

  var $1;
  $1=$item;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function _osd_sleep($duration$0, $duration$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $st$1$0=(($1)|0);
  HEAP32[(($st$1$0)>>2)]=$duration$0;
  var $st$1$1=(($1+4)|0);
  HEAP32[(($st$1$1)>>2)]=$duration$1;
  STACKTOP = __stackBase__;
  return;
}


function _osd_open($path, $openflags, $file, $filesize) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $mode;
      var $fileptr;
      $2=$path;
      $3=$openflags;
      $4=$file;
      $5=$filesize;
      var $6=$3;
      var $7=$6 & 2;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $9
      var $10=$3;
      var $11=$10 & 1;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $13
      var $14=$3;
      var $15=$14 & 4;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      var $20 = STRING_TABLE.__str7679;__label__ = 5; break;
    case 4: // $18
      var $20 = STRING_TABLE.__str17680;__label__ = 5; break;
    case 5: // $19
      var $20;
      var $21=(($20)|0);
      $mode=$21;
      __label__ = 7; break;
    case 6: // $22
      $mode=((STRING_TABLE.__str27681)|0);
      __label__ = 7; break;
    case 7: // $23
      __label__ = 12; break;
    case 8: // $24
      var $25=$3;
      var $26=$25 & 1;
      var $27=(($26)|0)!=0;
      if ($27) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $28
      $mode=((STRING_TABLE.__str37682)|0);
      __label__ = 11; break;
    case 10: // $29
      $1=8;
      __label__ = 15; break;
    case 11: // $30
      __label__ = 12; break;
    case 12: // $31
      var $32=$2;
      var $33=$mode;
      var $34=_fopen($32, $33);
      $fileptr=$34;
      var $35=$fileptr;
      var $36=(($35)|0)==0;
      if ($36) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $37
      $1=3;
      __label__ = 15; break;
    case 14: // $38
      var $39=$fileptr;
      var $40=$39;
      var $41=$4;
      HEAP32[(($41)>>2)]=$40;
      var $42=$fileptr;
      var $43=_fseek($42, 0, 2);
      var $44=$fileptr;
      var $45=_ftell($44);
      var $46$0=$45;
      var $46$1=(($45|0) < 0 ? -1 : 0);
      var $47=$5;
      var $st$11$0=(($47)|0);
      HEAP32[(($st$11$0)>>2)]=$46$0;
      var $st$11$1=(($47+4)|0);
      HEAP32[(($st$11$1)>>2)]=$46$1;
      var $48=$fileptr;
      var $49=_fseek($48, 0, 0);
      $1=0;
      __label__ = 15; break;
    case 15: // $50
      var $51=$1;
      ;
      return $51;
    default: assert(0, "bad label: " + __label__);
  }
}
_osd_open["X"]=1;

function _osd_close($file) {
  ;
  var __label__;

  var $1;
  $1=$file;
  var $2=$1;
  var $3=$2;
  var $4=_fclose($3);
  ;
  return 0;
}


function _osd_read($file, $buffer, $offset$0, $offset$1, $length, $actual) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $count;
      $1=$file;
      $2=$buffer;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$offset$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$offset$1;
      $4=$length;
      $5=$actual;
      var $6=$1;
      var $7=$6;
      var $st$16$0=(($3)|0);
      var $8$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($3+4)|0);
      var $8$1=HEAP32[(($st$16$1)>>2)];
      var $9$0=$8$0;
      var $9=$9$0;
      var $10=_fseek($7, $9, 0);
      var $11=$2;
      var $12=$4;
      var $13=$1;
      var $14=$13;
      var $15=_fread($11, 1, $12, $14);
      $count=$15;
      var $16=$5;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$count;
      var $20=$5;
      HEAP32[(($20)>>2)]=$19;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}


function _osd_write($file, $buffer, $offset$0, $offset$1, $length, $actual) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__stackBase__;
      var $4;
      var $5;
      var $count;
      $1=$file;
      $2=$buffer;
      var $st$8$0=(($3)|0);
      HEAP32[(($st$8$0)>>2)]=$offset$0;
      var $st$8$1=(($3+4)|0);
      HEAP32[(($st$8$1)>>2)]=$offset$1;
      $4=$length;
      $5=$actual;
      var $6=$1;
      var $7=$6;
      var $st$16$0=(($3)|0);
      var $8$0=HEAP32[(($st$16$0)>>2)];
      var $st$16$1=(($3+4)|0);
      var $8$1=HEAP32[(($st$16$1)>>2)];
      var $9$0=$8$0;
      var $9=$9$0;
      var $10=_fseek($7, $9, 0);
      var $11=$2;
      var $12=$4;
      var $13=$1;
      var $14=$13;
      var $15=_fwrite($11, 1, $12, $14);
      $count=$15;
      var $16=$5;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $18
      var $19=$count;
      var $20=$5;
      HEAP32[(($20)>>2)]=$19;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return 0;
    default: assert(0, "bad label: " + __label__);
  }
}


function _osd_rmfile($filename) {
  ;
  var __label__;

  var $1;
  $1=$filename;
  var $2=$1;
  var $3=_remove($2);
  var $4=(($3)|0)!=0;
  var $5=$4 ? 1 : 0;
  ;
  return $5;
}


function _osd_stat($path) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $result;
      var $f;
      $1=$path;
      $result=0;
      var $2=$1;
      var $3=_strlen($2);
      var $4=(($3+16)|0);
      var $5=(($4+1)|0);
      var $6=_malloc($5);
      var $7=$6;
      $result=$7;
      var $8=$result;
      var $9=(($8+16)|0);
      var $10=$9;
      var $11=$1;
      var $12=_strcpy($10, $11);
      var $13=$result;
      var $14=(($13+16)|0);
      var $15=$14;
      var $16=$result;
      var $17=(($16)|0);
      HEAP32[(($17)>>2)]=$15;
      var $18=$result;
      var $19=(($18+4)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=$result;
      var $21=(($20+8)|0);
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$30$0=(($21)|0);
      HEAP32[(($st$30$0)>>2)]=$$emscripten$temp$0$0;
      var $st$30$1=(($21+4)|0);
      HEAP32[(($st$30$1)>>2)]=$$emscripten$temp$0$1;
      var $22=$1;
      var $23=_fopen($22, ((STRING_TABLE.__str37682)|0));
      $f=$23;
      var $24=$f;
      var $25=(($24)|0)!=0;
      if ($25) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $26
      var $27=$f;
      var $28=_fseek($27, 0, 2);
      var $29=$result;
      var $30=(($29+4)|0);
      HEAP32[(($30)>>2)]=1;
      var $31=$f;
      var $32=_ftell($31);
      var $33$0=$32;
      var $33$1=(($32|0) < 0 ? -1 : 0);
      var $34=$result;
      var $35=(($34+8)|0);
      var $st$11$0=(($35)|0);
      HEAP32[(($st$11$0)>>2)]=$33$0;
      var $st$11$1=(($35+4)|0);
      HEAP32[(($st$11$1)>>2)]=$33$1;
      var $36=$f;
      var $37=_fclose($36);
      __label__ = 2; break;
    case 2: // $38
      var $39=$result;
      ;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}
_osd_stat["X"]=1;

function _osd_get_full_path($dst, $path) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$dst;
  $2=$path;
  var $3=$2;
  var $4=_strdup($3);
  var $5=$1;
  HEAP32[(($5)>>2)]=$4;
  ;
  return 0;
}


function _osd_malloc($size) {
  ;
  var __label__;

  var $1;
  $1=$size;
  var $2=$1;
  var $3=_malloc($2);
  ;
  return $3;
}


function _osd_malloc_array($size) {
  ;
  var __label__;

  var $1;
  $1=$size;
  var $2=$1;
  var $3=_malloc($2);
  ;
  return $3;
}


function _osd_free($ptr) {
  ;
  var __label__;

  var $1;
  $1=$ptr;
  var $2=$1;
  _free($2);
  ;
  return;
}


function _osd_work_item_queue_multiple($queue, $callback, $numitems, $parambase, $paramstep, $flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $item;
      var $itemnum;
      $2=$queue;
      $3=$callback;
      $4=$numitems;
      $5=$parambase;
      $6=$paramstep;
      $7=$flags;
      var $8=_malloc(4);
      var $9=$8;
      $item=$9;
      var $10=$item;
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      $1=0;
      __label__ = 9; break;
    case 2: // $13
      $itemnum=0;
      __label__ = 3; break;
    case 3: // $14
      var $15=$itemnum;
      var $16=$4;
      var $17=(($15)|0) < (($16)|0);
      if ($17) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $18
      var $19=$3;
      var $20=$5;
      var $21=FUNCTION_TABLE[$19]($20, 0);
      var $22=$item;
      var $23=(($22)|0);
      HEAP32[(($23)>>2)]=$21;
      var $24=$5;
      var $25=$6;
      var $26=(($24+$25)|0);
      $5=$26;
      __label__ = 5; break;
    case 5: // $27
      var $28=$itemnum;
      var $29=(($28+1)|0);
      $itemnum=$29;
      __label__ = 3; break;
    case 6: // $30
      var $31=$7;
      var $32=$31 & 1;
      var $33=(($32)|0)!=0;
      if ($33) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $34
      var $35=$item;
      var $36=$35;
      _free($36);
      $item=0;
      __label__ = 8; break;
    case 8: // $37
      var $38=$item;
      $1=$38;
      __label__ = 9; break;
    case 9: // $39
      var $40=$1;
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}
_osd_work_item_queue_multiple["X"]=1;

function _osd_work_item_release($item) {
  ;
  var __label__;

  var $1;
  $1=$item;
  var $2=$1;
  var $3=$2;
  _free($3);
  ;
  return;
}


function _osd_ticks() {
  ;
  var __label__;

  var $1=_clock();
  var $2$0=$1;
  var $2$1=0;
  ;
  return [$2$0,$2$1];
}


function __ZNSt3__112__do_messageD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__114error_categoryD2Ev($3);
  ;
  return;
}


function __ZNSt3__112__do_messageC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__114error_categoryC2Ev($3);
  var $4=$2;
  HEAP32[(($4)>>2)]=((__ZTVNSt3__112__do_messageE+8)|0);
  ;
  return;
}


function ___cxx_global_var_init1775() {
  ;
  var __label__;

  var $1=HEAP32[((__impure_ptr)>>2)];
  var $2=(($1+4)|0);
  var $3=HEAP32[(($2)>>2)];
  __ZNSt3__110__stdinbufIcEC1EP7__sFILE(__ZNSt3__1L5__cinE, $3);
  var $4=___cxa_atexit(1656, __ZNSt3__1L5__cinE, ___dso_handle);
  ;
  return;
}


function __ZNSt3__110__stdinbufIcEC1EP7__sFILE($this, $__fp) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__fp;
  var $3=$1;
  var $4=$2;
  __ZNSt3__110__stdinbufIcEC2EP7__sFILE($3, $4);
  ;
  return;
}


function __ZNSt3__110__stdinbufIcED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__110__stdinbufIcED2Ev($2);
  ;
  return;
}


function ___cxx_global_var_init11776() {
  ;
  var __label__;

  var $1=HEAP32[((__impure_ptr)>>2)];
  var $2=(($1+8)|0);
  var $3=HEAP32[(($2)>>2)];
  __ZNSt3__111__stdoutbufIcEC1EP7__sFILE(__ZNSt3__1L6__coutE, $3);
  var $4=___cxa_atexit(1658, __ZNSt3__1L6__coutE, ___dso_handle);
  ;
  return;
}


function __ZNSt3__111__stdoutbufIcEC1EP7__sFILE($this, $__fp) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__fp;
  var $3=$1;
  var $4=$2;
  __ZNSt3__111__stdoutbufIcEC2EP7__sFILE($3, $4);
  ;
  return;
}


function __ZNSt3__111__stdoutbufIcED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__111__stdoutbufIcED2Ev($2);
  ;
  return;
}


function ___cxx_global_var_init21777() {
  ;
  var __label__;

  var $1=HEAP32[((__impure_ptr)>>2)];
  var $2=(($1+12)|0);
  var $3=HEAP32[(($2)>>2)];
  __ZNSt3__111__stdoutbufIcEC1EP7__sFILE(__ZNSt3__1L6__cerrE, $3);
  var $4=___cxa_atexit(1658, __ZNSt3__1L6__cerrE, ___dso_handle);
  ;
  return;
}


function ___cxx_global_var_init31778() {
  ;
  var __label__;

  var $1=HEAP32[((__impure_ptr)>>2)];
  var $2=(($1+4)|0);
  var $3=HEAP32[(($2)>>2)];
  __ZNSt3__110__stdinbufIwEC1EP7__sFILE(__ZNSt3__1L6__wcinE, $3);
  var $4=___cxa_atexit(1660, __ZNSt3__1L6__wcinE, ___dso_handle);
  ;
  return;
}


function __ZNSt3__110__stdinbufIwEC1EP7__sFILE($this, $__fp) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__fp;
  var $3=$1;
  var $4=$2;
  __ZNSt3__110__stdinbufIwEC2EP7__sFILE($3, $4);
  ;
  return;
}


function __ZNSt3__110__stdinbufIwED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__110__stdinbufIwED2Ev($2);
  ;
  return;
}


function ___cxx_global_var_init41779() {
  ;
  var __label__;

  var $1=HEAP32[((__impure_ptr)>>2)];
  var $2=(($1+8)|0);
  var $3=HEAP32[(($2)>>2)];
  __ZNSt3__111__stdoutbufIwEC1EP7__sFILE(__ZNSt3__1L7__wcoutE, $3);
  var $4=___cxa_atexit(1662, __ZNSt3__1L7__wcoutE, ___dso_handle);
  ;
  return;
}


function __ZNSt3__111__stdoutbufIwEC1EP7__sFILE($this, $__fp) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__fp;
  var $3=$1;
  var $4=$2;
  __ZNSt3__111__stdoutbufIwEC2EP7__sFILE($3, $4);
  ;
  return;
}


function __ZNSt3__111__stdoutbufIwED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__111__stdoutbufIwED2Ev($2);
  ;
  return;
}


function ___cxx_global_var_init5() {
  ;
  var __label__;

  var $1=HEAP32[((__impure_ptr)>>2)];
  var $2=(($1+12)|0);
  var $3=HEAP32[(($2)>>2)];
  __ZNSt3__111__stdoutbufIwEC1EP7__sFILE(__ZNSt3__1L7__wcerrE, $3);
  var $4=___cxa_atexit(1662, __ZNSt3__1L7__wcerrE, ___dso_handle);
  ;
  return;
}


function ___cxx_global_var_init6() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__13cinE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L5__cinE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+8)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+12)|0);
      var $35=$21;
      var $36=(($35+8)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+32)|0);
      var $38=(($21+4)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=$21;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40-12)|0);
      var $42=$41;
      var $43=HEAP32[(($42)>>2)];
      var $44=$21;
      var $45=(($44+$43)|0);
      var $46=$45;
      var $47=HEAP32[(($14)>>2)];
      var $48=$9;
      var $49=$10;
      HEAP32[(($9)>>2)]=$46;
      HEAP32[(($10)>>2)]=$47;
      var $50=HEAP32[(($9)>>2)];
      var $51=$50;
      var $52=HEAP32[(($10)>>2)];
      var $53=$52;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($51, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $54=(($50+72)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=$4;
      var $56=$6;
      var $57=$7;
      var $58=$8;
      HEAP32[(($4)>>2)]=$50;
      $5=32;
      var $59=HEAP32[(($4)>>2)];
      var $60=$59;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $61=$3;
      HEAP32[(($3)>>2)]=$6;
      var $62=HEAP32[(($3)>>2)];
      var $63=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($62, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit_i_i_i
      var $64=$63;
      var $65=$3;
      var $66=$5;
      var $67=$1;
      HEAP32[(($1)>>2)]=$64;
      $2=$66;
      var $68=HEAP32[(($1)>>2)];
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+28)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$2;
      var $74=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$72]($68, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      HEAP32[(($7)>>2)]=$77;
      var $78=$76.f1;
      HEAP32[(($8)>>2)]=$78;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $79
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($7)>>2)];
      var $82=HEAP32[(($8)>>2)];
      var $83=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $81, tempValue);
      var $84=($83.f1 = $82, $83);
      var $eh_lpad_body_i = $84;__label__ = 9; break;
    case 6: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIcNS_11char_traitsIcEEE5widenEc_exit_i_i
      var $87=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $89;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $90=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$90;
      var $91=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$91;
      var $92=$21;
      var $93=(($92+8)|0);
      var $94=$93;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $95
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($15)>>2)];
      var $98=HEAP32[(($16)>>2)];
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_istreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE_exit
      var $103=$4;
      var $104=$6;
      var $105=$7;
      var $106=$8;
      var $107=(($50+76)|0);
      HEAP8[($107)]=$74;
      var $108=$9;
      var $109=$10;
      var $110=$13;
      var $111=$14;
      var $112=$15;
      var $113=$16;
      var $114=___cxa_atexit(1664, __ZNSt3__13cinE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init6["X"]=1;

function ___cxx_global_var_init7() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__14coutE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L6__coutE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+12)|0);
      var $35=$21;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+32)|0);
      var $38=$21;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$21;
      var $44=(($43+$42)|0);
      var $45=$44;
      var $46=HEAP32[(($14)>>2)];
      var $47=$9;
      var $48=$10;
      HEAP32[(($9)>>2)]=$45;
      HEAP32[(($10)>>2)]=$46;
      var $49=HEAP32[(($9)>>2)];
      var $50=$49;
      var $51=HEAP32[(($10)>>2)];
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($50, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $53=(($49+72)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$4;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      HEAP32[(($4)>>2)]=$49;
      $5=32;
      var $58=HEAP32[(($4)>>2)];
      var $59=$58;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $60=$3;
      HEAP32[(($3)>>2)]=$6;
      var $61=HEAP32[(($3)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($61, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit_i_i_i
      var $63=$62;
      var $64=$3;
      var $65=$5;
      var $66=$1;
      HEAP32[(($1)>>2)]=$63;
      $2=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+28)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($67, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      HEAP32[(($7)>>2)]=$76;
      var $77=$75.f1;
      HEAP32[(($8)>>2)]=$77;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $78
      var $79=HEAP32[(($7)>>2)];
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($8)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      var $eh_lpad_body_i = $83;__label__ = 9; break;
    case 6: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIcNS_11char_traitsIcEEE5widenEc_exit_i_i
      var $86=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $88;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $89=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$89;
      var $90=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$90;
      var $91=$21;
      var $92=(($91+4)|0);
      var $93=$92;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $94
      var $95=HEAP32[(($15)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($16)>>2)];
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE_exit
      var $102=$4;
      var $103=$6;
      var $104=$7;
      var $105=$8;
      var $106=(($49+76)|0);
      HEAP8[($106)]=$73;
      var $107=$9;
      var $108=$10;
      var $109=$13;
      var $110=$14;
      var $111=$15;
      var $112=$16;
      var $113=___cxa_atexit(1666, __ZNSt3__14coutE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init7["X"]=1;

function ___cxx_global_var_init8() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__14cerrE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L6__cerrE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+12)|0);
      var $35=$21;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+32)|0);
      var $38=$21;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$21;
      var $44=(($43+$42)|0);
      var $45=$44;
      var $46=HEAP32[(($14)>>2)];
      var $47=$9;
      var $48=$10;
      HEAP32[(($9)>>2)]=$45;
      HEAP32[(($10)>>2)]=$46;
      var $49=HEAP32[(($9)>>2)];
      var $50=$49;
      var $51=HEAP32[(($10)>>2)];
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($50, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $53=(($49+72)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$4;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      HEAP32[(($4)>>2)]=$49;
      $5=32;
      var $58=HEAP32[(($4)>>2)];
      var $59=$58;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $60=$3;
      HEAP32[(($3)>>2)]=$6;
      var $61=HEAP32[(($3)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($61, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit_i_i_i
      var $63=$62;
      var $64=$3;
      var $65=$5;
      var $66=$1;
      HEAP32[(($1)>>2)]=$63;
      $2=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+28)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($67, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      HEAP32[(($7)>>2)]=$76;
      var $77=$75.f1;
      HEAP32[(($8)>>2)]=$77;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $78
      var $79=HEAP32[(($7)>>2)];
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($8)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      var $eh_lpad_body_i = $83;__label__ = 9; break;
    case 6: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIcNS_11char_traitsIcEEE5widenEc_exit_i_i
      var $86=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $88;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $89=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$89;
      var $90=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$90;
      var $91=$21;
      var $92=(($91+4)|0);
      var $93=$92;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $94
      var $95=HEAP32[(($15)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($16)>>2)];
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE_exit
      var $102=$4;
      var $103=$6;
      var $104=$7;
      var $105=$8;
      var $106=(($49+76)|0);
      HEAP8[($106)]=$73;
      var $107=$9;
      var $108=$10;
      var $109=$13;
      var $110=$14;
      var $111=$15;
      var $112=$16;
      var $113=___cxa_atexit(1666, __ZNSt3__14cerrE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init8["X"]=1;

function ___cxx_global_var_init9() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__14clogE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L6__cerrE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+12)|0);
      var $35=$21;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+32)|0);
      var $38=$21;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$21;
      var $44=(($43+$42)|0);
      var $45=$44;
      var $46=HEAP32[(($14)>>2)];
      var $47=$9;
      var $48=$10;
      HEAP32[(($9)>>2)]=$45;
      HEAP32[(($10)>>2)]=$46;
      var $49=HEAP32[(($9)>>2)];
      var $50=$49;
      var $51=HEAP32[(($10)>>2)];
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($50, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $53=(($49+72)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$4;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      HEAP32[(($4)>>2)]=$49;
      $5=32;
      var $58=HEAP32[(($4)>>2)];
      var $59=$58;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $60=$3;
      HEAP32[(($3)>>2)]=$6;
      var $61=HEAP32[(($3)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($61, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit_i_i_i
      var $63=$62;
      var $64=$3;
      var $65=$5;
      var $66=$1;
      HEAP32[(($1)>>2)]=$63;
      $2=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+28)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($67, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      HEAP32[(($7)>>2)]=$76;
      var $77=$75.f1;
      HEAP32[(($8)>>2)]=$77;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $78
      var $79=HEAP32[(($7)>>2)];
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($8)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      var $eh_lpad_body_i = $83;__label__ = 9; break;
    case 6: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIcNS_11char_traitsIcEEE5widenEc_exit_i_i
      var $86=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $88;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $89=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$89;
      var $90=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$90;
      var $91=$21;
      var $92=(($91+4)|0);
      var $93=$92;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $94
      var $95=HEAP32[(($15)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($16)>>2)];
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE_exit
      var $102=$4;
      var $103=$6;
      var $104=$7;
      var $105=$8;
      var $106=(($49+76)|0);
      HEAP8[($106)]=$73;
      var $107=$9;
      var $108=$10;
      var $109=$13;
      var $110=$14;
      var $111=$15;
      var $112=$16;
      var $113=___cxa_atexit(1666, __ZNSt3__14clogE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init9["X"]=1;

function ___cxx_global_var_init10() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__14wcinE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L6__wcinE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+8)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+12)|0);
      var $35=$21;
      var $36=(($35+8)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+32)|0);
      var $38=(($21+4)|0);
      HEAP32[(($38)>>2)]=0;
      var $39=$21;
      var $40=HEAP32[(($39)>>2)];
      var $41=(($40-12)|0);
      var $42=$41;
      var $43=HEAP32[(($42)>>2)];
      var $44=$21;
      var $45=(($44+$43)|0);
      var $46=$45;
      var $47=HEAP32[(($14)>>2)];
      var $48=$9;
      var $49=$10;
      HEAP32[(($9)>>2)]=$46;
      HEAP32[(($10)>>2)]=$47;
      var $50=HEAP32[(($9)>>2)];
      var $51=$50;
      var $52=HEAP32[(($10)>>2)];
      var $53=$52;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($51, $53) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $54=(($50+72)|0);
      HEAP32[(($54)>>2)]=0;
      var $55=$4;
      var $56=$6;
      var $57=$7;
      var $58=$8;
      HEAP32[(($4)>>2)]=$50;
      $5=32;
      var $59=HEAP32[(($4)>>2)];
      var $60=$59;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $61=$3;
      HEAP32[(($3)>>2)]=$6;
      var $62=HEAP32[(($3)>>2)];
      var $63=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($62, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit_i_i_i
      var $64=$63;
      var $65=$3;
      var $66=$5;
      var $67=$1;
      HEAP32[(($1)>>2)]=$64;
      $2=$66;
      var $68=HEAP32[(($1)>>2)];
      var $69=$68;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+44)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$2;
      var $74=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$72]($68, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $75
      var $76=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $77=$76.f0;
      HEAP32[(($7)>>2)]=$77;
      var $78=$76.f1;
      HEAP32[(($8)>>2)]=$78;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $79
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($7)>>2)];
      var $82=HEAP32[(($8)>>2)];
      var $83=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $81, tempValue);
      var $84=($83.f1 = $82, $83);
      var $eh_lpad_body_i = $84;__label__ = 9; break;
    case 6: // $85
      var $86=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIwNS_11char_traitsIwEEE5widenEc_exit_i_i
      var $87=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $89;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $90=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$90;
      var $91=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$91;
      var $92=$21;
      var $93=(($92+8)|0);
      var $94=$93;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $95
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($15)>>2)];
      var $98=HEAP32[(($16)>>2)];
      var $99=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $97, tempValue);
      var $100=($99.f1 = $98, $99);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $101
      var $102=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_istreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE_exit
      var $103=$4;
      var $104=$6;
      var $105=$7;
      var $106=$8;
      var $107=(($50+76)|0);
      HEAP32[(($107)>>2)]=$74;
      var $108=$9;
      var $109=$10;
      var $110=$13;
      var $111=$14;
      var $112=$15;
      var $113=$16;
      var $114=___cxa_atexit(1668, __ZNSt3__14wcinE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init10["X"]=1;

function __ZNSt3__18ios_base4InitC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $__r_i_i4=__stackBase__+8;
  var $3=__stackBase__+12;
  var $4=__stackBase__+16;
  var $5=__stackBase__+20;
  var $__r_i3=__stackBase__+24;
  var $6=__stackBase__+28;
  var $7=__stackBase__+32;
  var $__r_i2=__stackBase__+36;
  var $8=__stackBase__+40;
  var $9=__stackBase__+44;
  var $__r_i_i=__stackBase__+48;
  var $10=__stackBase__+52;
  var $11=__stackBase__+56;
  var $12=__stackBase__+60;
  var $__r_i1=__stackBase__+64;
  var $13=__stackBase__+68;
  var $14=__stackBase__+72;
  var $__r_i=__stackBase__+76;
  var $15;
  $15=$this;
  var $16=$15;
  var $17=HEAP32[((__ZNSt3__13cinE)>>2)];
  var $18=(($17-12)|0);
  var $19=$18;
  var $20=HEAP32[(($19)>>2)];
  var $21=((__ZNSt3__13cinE+$20)|0);
  var $22=$21;
  var $23=$13;
  var $24=$14;
  var $25=$__r_i;
  HEAP32[(($13)>>2)]=$22;
  HEAP32[(($14)>>2)]=__ZNSt3__14coutE;
  var $26=HEAP32[(($13)>>2)];
  var $27=(($26+72)|0);
  var $28=HEAP32[(($27)>>2)];
  HEAP32[(($__r_i)>>2)]=$28;
  var $29=HEAP32[(($14)>>2)];
  var $30=(($26+72)|0);
  HEAP32[(($30)>>2)]=$29;
  var $31=HEAP32[(($__r_i)>>2)];
  var $32=$13;
  var $33=$14;
  var $34=$__r_i;
  var $35=HEAP32[((__ZNSt3__14cerrE)>>2)];
  var $36=(($35-12)|0);
  var $37=$36;
  var $38=HEAP32[(($37)>>2)];
  var $39=((__ZNSt3__14cerrE+$38)|0);
  var $40=$39;
  var $41=$3;
  HEAP32[(($3)>>2)]=$40;
  var $42=HEAP32[(($3)>>2)];
  var $43=$1;
  var $44=$2;
  var $45=$__r_i_i4;
  HEAP32[(($1)>>2)]=$42;
  HEAP32[(($2)>>2)]=8192;
  var $46=HEAP32[(($1)>>2)];
  var $47=(($46+4)|0);
  var $48=HEAP32[(($47)>>2)];
  HEAP32[(($__r_i_i4)>>2)]=$48;
  var $49=HEAP32[(($2)>>2)];
  var $50=(($46+4)|0);
  var $51=HEAP32[(($50)>>2)];
  var $52=$51 | $49;
  HEAP32[(($50)>>2)]=$52;
  var $53=HEAP32[(($__r_i_i4)>>2)];
  var $54=$1;
  var $55=$2;
  var $56=$__r_i_i4;
  var $57=HEAP32[(($3)>>2)];
  var $58=$3;
  var $59=HEAP32[((__ZNSt3__14cerrE)>>2)];
  var $60=(($59-12)|0);
  var $61=$60;
  var $62=HEAP32[(($61)>>2)];
  var $63=((__ZNSt3__14cerrE+$62)|0);
  var $64=$63;
  var $65=$4;
  var $66=$5;
  var $67=$__r_i3;
  HEAP32[(($4)>>2)]=$64;
  HEAP32[(($5)>>2)]=__ZNSt3__14coutE;
  var $68=HEAP32[(($4)>>2)];
  var $69=(($68+72)|0);
  var $70=HEAP32[(($69)>>2)];
  HEAP32[(($__r_i3)>>2)]=$70;
  var $71=HEAP32[(($5)>>2)];
  var $72=(($68+72)|0);
  HEAP32[(($72)>>2)]=$71;
  var $73=HEAP32[(($__r_i3)>>2)];
  var $74=$4;
  var $75=$5;
  var $76=$__r_i3;
  var $77=HEAP32[((__ZNSt3__14wcinE)>>2)];
  var $78=(($77-12)|0);
  var $79=$78;
  var $80=HEAP32[(($79)>>2)];
  var $81=((__ZNSt3__14wcinE+$80)|0);
  var $82=$81;
  var $83=$6;
  var $84=$7;
  var $85=$__r_i2;
  HEAP32[(($6)>>2)]=$82;
  HEAP32[(($7)>>2)]=__ZNSt3__15wcoutE;
  var $86=HEAP32[(($6)>>2)];
  var $87=(($86+72)|0);
  var $88=HEAP32[(($87)>>2)];
  HEAP32[(($__r_i2)>>2)]=$88;
  var $89=HEAP32[(($7)>>2)];
  var $90=(($86+72)|0);
  HEAP32[(($90)>>2)]=$89;
  var $91=HEAP32[(($__r_i2)>>2)];
  var $92=$6;
  var $93=$7;
  var $94=$__r_i2;
  var $95=HEAP32[((__ZNSt3__15wcerrE)>>2)];
  var $96=(($95-12)|0);
  var $97=$96;
  var $98=HEAP32[(($97)>>2)];
  var $99=((__ZNSt3__15wcerrE+$98)|0);
  var $100=$99;
  var $101=$10;
  HEAP32[(($10)>>2)]=$100;
  var $102=HEAP32[(($10)>>2)];
  var $103=$8;
  var $104=$9;
  var $105=$__r_i_i;
  HEAP32[(($8)>>2)]=$102;
  HEAP32[(($9)>>2)]=8192;
  var $106=HEAP32[(($8)>>2)];
  var $107=(($106+4)|0);
  var $108=HEAP32[(($107)>>2)];
  HEAP32[(($__r_i_i)>>2)]=$108;
  var $109=HEAP32[(($9)>>2)];
  var $110=(($106+4)|0);
  var $111=HEAP32[(($110)>>2)];
  var $112=$111 | $109;
  HEAP32[(($110)>>2)]=$112;
  var $113=HEAP32[(($__r_i_i)>>2)];
  var $114=$8;
  var $115=$9;
  var $116=$__r_i_i;
  var $117=HEAP32[(($10)>>2)];
  var $118=$10;
  var $119=HEAP32[((__ZNSt3__15wcerrE)>>2)];
  var $120=(($119-12)|0);
  var $121=$120;
  var $122=HEAP32[(($121)>>2)];
  var $123=((__ZNSt3__15wcerrE+$122)|0);
  var $124=$123;
  var $125=$11;
  var $126=$12;
  var $127=$__r_i1;
  HEAP32[(($11)>>2)]=$124;
  HEAP32[(($12)>>2)]=__ZNSt3__15wcoutE;
  var $128=HEAP32[(($11)>>2)];
  var $129=(($128+72)|0);
  var $130=HEAP32[(($129)>>2)];
  HEAP32[(($__r_i1)>>2)]=$130;
  var $131=HEAP32[(($12)>>2)];
  var $132=(($128+72)|0);
  HEAP32[(($132)>>2)]=$131;
  var $133=HEAP32[(($__r_i1)>>2)];
  var $134=$11;
  var $135=$12;
  var $136=$__r_i1;
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__18ios_base4InitC2Ev["X"]=1;

function ___cxx_global_var_init14() {
  ;
  var __label__;

  FUNCTION_TABLE[__ZNSt3__18ios_base4InitC1Ev](__ZNSt3__119__start_std_streamsE);
  var $1=___cxa_atexit(1672, ((__ZNSt3__119__start_std_streamsE)|0), ___dso_handle);
  ;
  return;
}


function __ZNSt3__18ios_base4InitD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(__ZNSt3__14coutE);
  var $4=__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(__ZNSt3__14clogE);
  var $5=__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(__ZNSt3__15wcoutE);
  var $6=__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(__ZNSt3__15wclogE);
  ;
  return;
}


function ___cxx_global_var_init11() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__15wcoutE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L7__wcoutE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+12)|0);
      var $35=$21;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+32)|0);
      var $38=$21;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$21;
      var $44=(($43+$42)|0);
      var $45=$44;
      var $46=HEAP32[(($14)>>2)];
      var $47=$9;
      var $48=$10;
      HEAP32[(($9)>>2)]=$45;
      HEAP32[(($10)>>2)]=$46;
      var $49=HEAP32[(($9)>>2)];
      var $50=$49;
      var $51=HEAP32[(($10)>>2)];
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($50, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $53=(($49+72)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$4;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      HEAP32[(($4)>>2)]=$49;
      $5=32;
      var $58=HEAP32[(($4)>>2)];
      var $59=$58;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $60=$3;
      HEAP32[(($3)>>2)]=$6;
      var $61=HEAP32[(($3)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($61, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit_i_i_i
      var $63=$62;
      var $64=$3;
      var $65=$5;
      var $66=$1;
      HEAP32[(($1)>>2)]=$63;
      $2=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+44)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($67, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      HEAP32[(($7)>>2)]=$76;
      var $77=$75.f1;
      HEAP32[(($8)>>2)]=$77;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $78
      var $79=HEAP32[(($7)>>2)];
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($8)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      var $eh_lpad_body_i = $83;__label__ = 9; break;
    case 6: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIwNS_11char_traitsIwEEE5widenEc_exit_i_i
      var $86=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $88;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $89=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$89;
      var $90=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$90;
      var $91=$21;
      var $92=(($91+4)|0);
      var $93=$92;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $94
      var $95=HEAP32[(($15)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($16)>>2)];
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE_exit
      var $102=$4;
      var $103=$6;
      var $104=$7;
      var $105=$8;
      var $106=(($49+76)|0);
      HEAP32[(($106)>>2)]=$73;
      var $107=$9;
      var $108=$10;
      var $109=$13;
      var $110=$14;
      var $111=$15;
      var $112=$16;
      var $113=___cxa_atexit(1670, __ZNSt3__15wcoutE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init11["X"]=1;

function ___cxx_global_var_init12() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__15wcerrE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L7__wcerrE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+12)|0);
      var $35=$21;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+32)|0);
      var $38=$21;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$21;
      var $44=(($43+$42)|0);
      var $45=$44;
      var $46=HEAP32[(($14)>>2)];
      var $47=$9;
      var $48=$10;
      HEAP32[(($9)>>2)]=$45;
      HEAP32[(($10)>>2)]=$46;
      var $49=HEAP32[(($9)>>2)];
      var $50=$49;
      var $51=HEAP32[(($10)>>2)];
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($50, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $53=(($49+72)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$4;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      HEAP32[(($4)>>2)]=$49;
      $5=32;
      var $58=HEAP32[(($4)>>2)];
      var $59=$58;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $60=$3;
      HEAP32[(($3)>>2)]=$6;
      var $61=HEAP32[(($3)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($61, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit_i_i_i
      var $63=$62;
      var $64=$3;
      var $65=$5;
      var $66=$1;
      HEAP32[(($1)>>2)]=$63;
      $2=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+44)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($67, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      HEAP32[(($7)>>2)]=$76;
      var $77=$75.f1;
      HEAP32[(($8)>>2)]=$77;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $78
      var $79=HEAP32[(($7)>>2)];
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($8)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      var $eh_lpad_body_i = $83;__label__ = 9; break;
    case 6: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIwNS_11char_traitsIwEEE5widenEc_exit_i_i
      var $86=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $88;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $89=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$89;
      var $90=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$90;
      var $91=$21;
      var $92=(($91+4)|0);
      var $93=$92;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $94
      var $95=HEAP32[(($15)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($16)>>2)];
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE_exit
      var $102=$4;
      var $103=$6;
      var $104=$7;
      var $105=$8;
      var $106=(($49+76)|0);
      HEAP32[(($106)>>2)]=$73;
      var $107=$9;
      var $108=$10;
      var $109=$13;
      var $110=$14;
      var $111=$15;
      var $112=$16;
      var $113=___cxa_atexit(1670, __ZNSt3__15wcerrE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init12["X"]=1;

function ___cxx_global_var_init13() {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=$13;
      var $18=$14;
      var $19=$15;
      var $20=$16;
      HEAP32[(($13)>>2)]=__ZNSt3__15wclogE;
      HEAP32[(($14)>>2)]=((__ZNSt3__1L7__wcerrE)|0);
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      var $23=(($22+4)|0);
      var $24=$23;
      var $25=$12;
      HEAP32[(($12)>>2)]=$24;
      var $26=HEAP32[(($12)>>2)];
      var $27=$26;
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
      var $31=$11;
      var $32=$26;
      HEAP32[(($32)>>2)]=((__ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE+8)|0);
      var $33=$12;
      var $34=$21;
      HEAP32[(($34)>>2)]=((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+12)|0);
      var $35=$21;
      var $36=(($35+4)|0);
      var $37=$36;
      HEAP32[(($37)>>2)]=((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+32)|0);
      var $38=$21;
      var $39=HEAP32[(($38)>>2)];
      var $40=(($39-12)|0);
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=$21;
      var $44=(($43+$42)|0);
      var $45=$44;
      var $46=HEAP32[(($14)>>2)];
      var $47=$9;
      var $48=$10;
      HEAP32[(($9)>>2)]=$45;
      HEAP32[(($10)>>2)]=$46;
      var $49=HEAP32[(($9)>>2)];
      var $50=$49;
      var $51=HEAP32[(($10)>>2)];
      var $52=$51;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base4initEPv($50, $52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $_noexc_i
      var $53=(($49+72)|0);
      HEAP32[(($53)>>2)]=0;
      var $54=$4;
      var $55=$6;
      var $56=$7;
      var $57=$8;
      HEAP32[(($4)>>2)]=$49;
      $5=32;
      var $58=HEAP32[(($4)>>2)];
      var $59=$58;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($6, $59) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $_noexc1_i
      var $60=$3;
      HEAP32[(($3)>>2)]=$6;
      var $61=HEAP32[(($3)>>2)];
      var $62=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($61, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit_i_i_i
      var $63=$62;
      var $64=$3;
      var $65=$5;
      var $66=$1;
      HEAP32[(($1)>>2)]=$63;
      $2=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=$67;
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69+44)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=$2;
      var $73=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$71]($67, $72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 4; break; };
    case 4: // $74
      var $75=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $76=$75.f0;
      HEAP32[(($7)>>2)]=$76;
      var $77=$75.f1;
      HEAP32[(($8)>>2)]=$77;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $78
      var $79=HEAP32[(($7)>>2)];
      var $80=HEAP32[(($7)>>2)];
      var $81=HEAP32[(($8)>>2)];
      var $82=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $80, tempValue);
      var $83=($82.f1 = $81, $82);
      var $eh_lpad_body_i = $83;__label__ = 9; break;
    case 6: // $84
      var $85=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 7: // $_ZNKSt3__19basic_iosIwNS_11char_traitsIwEEE5widenEc_exit_i_i
      var $86=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 8; break; }
    case 8: // $87
      var $88=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body_i = $88;__label__ = 9; break;
    case 9: // $_body_i
      var $eh_lpad_body_i;
      var $89=$eh_lpad_body_i.f0;
      HEAP32[(($15)>>2)]=$89;
      var $90=$eh_lpad_body_i.f1;
      HEAP32[(($16)>>2)]=$90;
      var $91=$21;
      var $92=(($91+4)|0);
      var $93=$92;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $94
      var $95=HEAP32[(($15)>>2)];
      var $96=HEAP32[(($15)>>2)];
      var $97=HEAP32[(($16)>>2)];
      var $98=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $96, tempValue);
      var $99=($98.f1 = $97, $98);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE_exit
      var $102=$4;
      var $103=$6;
      var $104=$7;
      var $105=$8;
      var $106=(($49+76)|0);
      HEAP32[(($106)>>2)]=$73;
      var $107=$9;
      var $108=$10;
      var $109=$13;
      var $110=$14;
      var $111=$15;
      var $112=$16;
      var $113=___cxa_atexit(1670, __ZNSt3__15wclogE, ___dso_handle);
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
___cxx_global_var_init13["X"]=1;

function __ZNSt3__111__stdoutbufIwEC2EP7__sFILE($this, $__fp) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      var $5;
      var $6=__stackBase__+12;
      var $7;
      var $8;
      $4=$this;
      $5=$__fp;
      var $9=$4;
      var $10=$9;
      __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev($10);
      var $11=$9;
      HEAP32[(($11)>>2)]=((__ZTVNSt3__111__stdoutbufIwEE+8)|0);
      var $12=(($9+32)|0);
      var $13=$5;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($9+36)|0);
      var $15=$9;
      var $16=$3;
      HEAP32[(($3)>>2)]=$15;
      var $17=HEAP32[(($3)>>2)];
      var $18=(($17+4)|0);
      FUNCTION_TABLE[__ZNSt3__16localeC1ERKS0_]($6, $18);
      var $19=$3;
      __label__ = 1; break;
    case 1: // $20
      var $21=$2;
      HEAP32[(($2)>>2)]=$6;
      var $22=HEAP32[(($2)>>2)];
      var $23=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($22, __ZNSt3__17codecvtIwc10_mbstate_tE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $_ZNSt3__19use_facetINS_7codecvtIwc10_mbstate_tEEEERKT_RKNS_6localeE_exit
      var $24=$23;
      var $25=$2;
      __label__ = 3; break;
    case 3: // $26
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      HEAP32[(($14)>>2)]=$24;
      var $28=(($9+40)|0);
      var $29=$28;
      HEAP32[(($29)>>2)]=0; HEAP32[(($29+4)>>2)]=0;
      var $30=(($9+48)|0);
      var $31=(($9+36)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      HEAP32[(($1)>>2)]=$32;
      var $34=HEAP32[(($1)>>2)];
      var $35=$34;
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+28)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=FUNCTION_TABLE[$38]($34);
      var $40=$1;
      var $41=(($39)&1);
      HEAP8[($30)]=$41;
      STACKTOP = __stackBase__;
      return;
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      $7=$44;
      var $45=$43.f1;
      $8=$45;
      __label__ = 8; break;
    case 6: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      var $52=$9;
      (function() { try { __THREW__ = false; return __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $53
      __label__ = 10; break;
    case 10: // $54
      var $55=$7;
      var $56=$7;
      var $57=$8;
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__stdoutbufIwEC2EP7__sFILE["X"]=1;

function __ZNSt3__111__stdoutbufIwED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__111__stdoutbufIwED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE($this, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3;
  var $4;
  $3=$this;
  $4=$__loc;
  var $5=$3;
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+24)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$9]($5);
  var $11=$4;
  var $12=$2;
  HEAP32[(($2)>>2)]=$11;
  var $13=HEAP32[(($2)>>2)];
  var $14=__ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__17codecvtIwc10_mbstate_tE2idE);
  var $15=$14;
  var $16=$2;
  var $17=(($5+36)|0);
  HEAP32[(($17)>>2)]=$15;
  var $18=(($5+36)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  HEAP32[(($1)>>2)]=$19;
  var $21=HEAP32[(($1)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+28)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=FUNCTION_TABLE[$25]($21);
  var $27=$1;
  var $28=(($5+48)|0);
  var $29=(($26)&1);
  HEAP8[($28)]=$29;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__111__stdoutbufIwE4syncEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $__extbuf=__stackBase__+20;
      var $__r;
      var $__extbe=__stackBase__+28;
      var $__nmemb;
      $7=$this;
      var $8=$7;
      __label__ = 1; break;
    case 1: // $9
      var $10=(($8+36)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($8+40)|0);
      var $13=(($__extbuf)|0);
      var $14=(($__extbuf)|0);
      var $15=(($14+8)|0);
      var $16=$1;
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      HEAP32[(($1)>>2)]=$11;
      HEAP32[(($2)>>2)]=$12;
      HEAP32[(($3)>>2)]=$13;
      HEAP32[(($4)>>2)]=$15;
      HEAP32[(($5)>>2)]=$__extbe;
      var $21=HEAP32[(($1)>>2)];
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=HEAP32[(($2)>>2)];
      var $27=HEAP32[(($3)>>2)];
      var $28=HEAP32[(($4)>>2)];
      var $29=HEAP32[(($5)>>2)];
      var $30=FUNCTION_TABLE[$25]($21, $26, $27, $28, $29);
      var $31=$1;
      var $32=$2;
      var $33=$3;
      var $34=$4;
      var $35=$5;
      $__r=$30;
      var $36=HEAP32[(($__extbe)>>2)];
      var $37=(($__extbuf)|0);
      var $38=$36;
      var $39=$37;
      var $40=(($38-$39)|0);
      $__nmemb=$40;
      var $41=(($__extbuf)|0);
      var $42=$__nmemb;
      var $43=(($8+32)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_fwrite($41, 1, $42, $44);
      var $46=$__nmemb;
      var $47=(($45)|0)!=(($46)|0);
      if ($47) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $48
      $6=-1;
      __label__ = 10; break;
    case 3: // $49
      __label__ = 4; break;
    case 4: // $50
      var $51=$__r;
      var $52=(($51)|0)==1;
      if ($52) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 5: // $53
      var $54=$__r;
      var $55=(($54)|0)==2;
      if ($55) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $56
      $6=-1;
      __label__ = 10; break;
    case 7: // $57
      var $58=(($8+32)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=_fflush($59);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $62
      $6=-1;
      __label__ = 10; break;
    case 9: // $63
      $6=0;
      __label__ = 10; break;
    case 10: // $64
      var $65=$6;
      STACKTOP = __stackBase__;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__stdoutbufIwE4syncEv["X"]=1;

function __ZNSt3__111__stdoutbufIwE8overflowEj($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 164; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37;
      var $38;
      var $39;
      var $__extbuf=__stackBase__+144;
      var $__1buf=__stackBase__+152;
      var $__extbe=__stackBase__+156;
      var $__r;
      var $__e=__stackBase__+160;
      var $__nmemb;
      $38=$this;
      $39=$__c;
      var $40=$38;
      var $41=$39;
      var $42=$11;
      var $43=$12;
      HEAP32[(($11)>>2)]=$41;
      HEAP32[(($12)>>2)]=-1;
      var $44=HEAP32[(($11)>>2)];
      var $45=HEAP32[(($12)>>2)];
      var $46=(($44)|0)==(($45)|0);
      var $47=$11;
      var $48=$12;
      if ($46) { __label__ = 25; break; } else { __label__ = 1; break; }
    case 1: // $49
      var $50=$40;
      var $51=(($__1buf+4)|0);
      var $52=$1;
      var $53=$2;
      var $54=$3;
      HEAP32[(($1)>>2)]=$50;
      HEAP32[(($2)>>2)]=$__1buf;
      HEAP32[(($3)>>2)]=$51;
      var $55=HEAP32[(($1)>>2)];
      var $56=HEAP32[(($2)>>2)];
      var $57=(($55+24)|0);
      HEAP32[(($57)>>2)]=$56;
      var $58=(($55+20)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=HEAP32[(($3)>>2)];
      var $60=(($55+28)|0);
      HEAP32[(($60)>>2)]=$59;
      var $61=$1;
      var $62=$2;
      var $63=$3;
      var $64=$39;
      var $65=$4;
      HEAP32[(($4)>>2)]=$64;
      var $66=HEAP32[(($4)>>2)];
      var $67=$4;
      var $68=$40;
      var $69=$5;
      HEAP32[(($5)>>2)]=$68;
      var $70=HEAP32[(($5)>>2)];
      var $71=(($70+24)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$5;
      HEAP32[(($72)>>2)]=$66;
      var $74=$40;
      var $75=$6;
      var $76=$7;
      HEAP32[(($6)>>2)]=$74;
      HEAP32[(($7)>>2)]=1;
      var $77=HEAP32[(($6)>>2)];
      var $78=HEAP32[(($7)>>2)];
      var $79=(($77+24)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+($78<<2))|0);
      HEAP32[(($79)>>2)]=$81;
      var $82=$6;
      var $83=$7;
      var $84=(($40+48)|0);
      var $85=HEAP8[($84)];
      var $86=(($85) & 1);
      if ($86) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $87
      var $88=$40;
      var $89=$8;
      HEAP32[(($8)>>2)]=$88;
      var $90=HEAP32[(($8)>>2)];
      var $91=(($90+20)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$8;
      var $94=$92;
      var $95=(($40+32)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=_fwrite($94, 4, 1, $96);
      var $98=(($97)|0)!=1;
      if ($98) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $99
      $37=-1;
      __label__ = 29; break;
    case 4: // $100
      __label__ = 24; break;
    case 5: // $101
      var $102=(($__extbuf)|0);
      HEAP32[(($__extbe)>>2)]=$102;
      __label__ = 6; break;
    case 6: // $103
      var $104=(($40+36)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($40+40)|0);
      var $107=$40;
      var $108=$9;
      HEAP32[(($9)>>2)]=$107;
      var $109=HEAP32[(($9)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$9;
      var $113=$40;
      var $114=$10;
      HEAP32[(($10)>>2)]=$113;
      var $115=HEAP32[(($10)>>2)];
      var $116=(($115+24)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$10;
      var $119=(($__extbuf)|0);
      var $120=(($__extbuf)|0);
      var $121=(($120+8)|0);
      var $122=$13;
      var $123=$14;
      var $124=$15;
      var $125=$16;
      var $126=$17;
      var $127=$18;
      var $128=$19;
      var $129=$20;
      HEAP32[(($13)>>2)]=$105;
      HEAP32[(($14)>>2)]=$106;
      HEAP32[(($15)>>2)]=$111;
      HEAP32[(($16)>>2)]=$117;
      HEAP32[(($17)>>2)]=$__e;
      HEAP32[(($18)>>2)]=$119;
      HEAP32[(($19)>>2)]=$121;
      HEAP32[(($20)>>2)]=$__extbe;
      var $130=HEAP32[(($13)>>2)];
      var $131=$130;
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132+12)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=HEAP32[(($14)>>2)];
      var $136=HEAP32[(($15)>>2)];
      var $137=HEAP32[(($16)>>2)];
      var $138=HEAP32[(($17)>>2)];
      var $139=HEAP32[(($18)>>2)];
      var $140=HEAP32[(($19)>>2)];
      var $141=HEAP32[(($20)>>2)];
      var $142=FUNCTION_TABLE[$134]($130, $135, $136, $137, $138, $139, $140, $141);
      var $143=$13;
      var $144=$14;
      var $145=$15;
      var $146=$16;
      var $147=$17;
      var $148=$18;
      var $149=$19;
      var $150=$20;
      $__r=$142;
      var $151=HEAP32[(($__e)>>2)];
      var $152=$40;
      var $153=$21;
      HEAP32[(($21)>>2)]=$152;
      var $154=HEAP32[(($21)>>2)];
      var $155=(($154+20)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$21;
      var $158=(($151)|0)==(($156)|0);
      if ($158) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $159
      $37=-1;
      __label__ = 29; break;
    case 8: // $160
      var $161=$__r;
      var $162=(($161)|0)==3;
      if ($162) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $163
      var $164=$40;
      var $165=$22;
      HEAP32[(($22)>>2)]=$164;
      var $166=HEAP32[(($22)>>2)];
      var $167=(($166+20)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$22;
      var $170=$168;
      var $171=(($40+32)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=_fwrite($170, 1, 1, $172);
      var $174=(($173)|0)!=1;
      if ($174) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $175
      $37=-1;
      __label__ = 29; break;
    case 11: // $176
      __label__ = 21; break;
    case 12: // $177
      var $178=$__r;
      var $179=(($178)|0)==0;
      if ($179) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $180
      var $181=$__r;
      var $182=(($181)|0)==1;
      if ($182) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $183
      var $184=HEAP32[(($__extbe)>>2)];
      var $185=(($__extbuf)|0);
      var $186=$184;
      var $187=$185;
      var $188=(($186-$187)|0);
      $__nmemb=$188;
      var $189=(($__extbuf)|0);
      var $190=$__nmemb;
      var $191=(($40+32)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=_fwrite($189, 1, $190, $192);
      var $194=$__nmemb;
      var $195=(($193)|0)!=(($194)|0);
      if ($195) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $196
      $37=-1;
      __label__ = 29; break;
    case 16: // $197
      var $198=$__r;
      var $199=(($198)|0)==1;
      if ($199) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $200
      var $201=$40;
      var $202=HEAP32[(($__e)>>2)];
      var $203=$40;
      var $204=$23;
      HEAP32[(($23)>>2)]=$203;
      var $205=HEAP32[(($23)>>2)];
      var $206=(($205+24)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$23;
      var $209=$24;
      var $210=$25;
      var $211=$26;
      HEAP32[(($24)>>2)]=$201;
      HEAP32[(($25)>>2)]=$202;
      HEAP32[(($26)>>2)]=$207;
      var $212=HEAP32[(($24)>>2)];
      var $213=HEAP32[(($25)>>2)];
      var $214=(($212+24)|0);
      HEAP32[(($214)>>2)]=$213;
      var $215=(($212+20)|0);
      HEAP32[(($215)>>2)]=$213;
      var $216=HEAP32[(($26)>>2)];
      var $217=(($212+28)|0);
      HEAP32[(($217)>>2)]=$216;
      var $218=$24;
      var $219=$25;
      var $220=$26;
      var $221=$40;
      var $222=$40;
      var $223=$27;
      HEAP32[(($27)>>2)]=$222;
      var $224=HEAP32[(($27)>>2)];
      var $225=(($224+28)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$27;
      var $228=$40;
      var $229=$28;
      HEAP32[(($28)>>2)]=$228;
      var $230=HEAP32[(($28)>>2)];
      var $231=(($230+20)|0);
      var $232=HEAP32[(($231)>>2)];
      var $233=$28;
      var $234=$226;
      var $235=$232;
      var $236=(($234-$235)|0);
      var $237=(((($236)|0)/4)|0);
      var $238=$29;
      var $239=$30;
      HEAP32[(($29)>>2)]=$221;
      HEAP32[(($30)>>2)]=$237;
      var $240=HEAP32[(($29)>>2)];
      var $241=HEAP32[(($30)>>2)];
      var $242=(($240+24)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243+($241<<2))|0);
      HEAP32[(($242)>>2)]=$244;
      var $245=$29;
      var $246=$30;
      __label__ = 18; break;
    case 18: // $247
      __label__ = 20; break;
    case 19: // $248
      $37=-1;
      __label__ = 29; break;
    case 20: // $249
      __label__ = 21; break;
    case 21: // $250
      __label__ = 22; break;
    case 22: // $251
      var $252=$__r;
      var $253=(($252)|0)==1;
      if ($253) { __label__ = 6; break; } else { __label__ = 23; break; }
    case 23: // $254
      __label__ = 24; break;
    case 24: // $255
      var $256=$40;
      var $257=$31;
      var $258=$32;
      var $259=$33;
      HEAP32[(($31)>>2)]=$256;
      HEAP32[(($32)>>2)]=0;
      HEAP32[(($33)>>2)]=0;
      var $260=HEAP32[(($31)>>2)];
      var $261=HEAP32[(($32)>>2)];
      var $262=(($260+24)|0);
      HEAP32[(($262)>>2)]=$261;
      var $263=(($260+20)|0);
      HEAP32[(($263)>>2)]=$261;
      var $264=HEAP32[(($33)>>2)];
      var $265=(($260+28)|0);
      HEAP32[(($265)>>2)]=$264;
      var $266=$31;
      var $267=$32;
      var $268=$33;
      __label__ = 25; break;
    case 25: // $269
      var $270=$39;
      var $271=$36;
      HEAP32[(($36)>>2)]=$270;
      var $272=HEAP32[(($36)>>2)];
      var $273=$34;
      var $274=$35;
      HEAP32[(($34)>>2)]=$272;
      HEAP32[(($35)>>2)]=-1;
      var $275=HEAP32[(($34)>>2)];
      var $276=HEAP32[(($35)>>2)];
      var $277=(($275)|0)==(($276)|0);
      var $278=$34;
      var $279=$35;
      if ($277) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $280
      var $283 = 0;__label__ = 28; break;
    case 27: // $281
      var $282=HEAP32[(($36)>>2)];
      var $283 = $282;__label__ = 28; break;
    case 28: // $_ZNSt3__111char_traitsIwE7not_eofEj_exit
      var $283;
      var $284=$36;
      $37=$283;
      __label__ = 29; break;
    case 29: // $285
      var $286=$37;
      STACKTOP = __stackBase__;
      return $286;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__stdoutbufIwE8overflowEj["X"]=1;

function __ZNSt3__110__stdinbufIwED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__110__stdinbufIwED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE($this, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      var $5;
      $4=$this;
      $5=$__loc;
      var $6=$4;
      var $7=$5;
      var $8=$3;
      HEAP32[(($3)>>2)]=$7;
      var $9=HEAP32[(($3)>>2)];
      var $10=__ZNKSt3__16locale9use_facetERNS0_2idE($9, __ZNSt3__17codecvtIwc10_mbstate_tE2idE);
      var $11=$10;
      var $12=$3;
      var $13=(($6+36)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=(($6+36)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      HEAP32[(($2)>>2)]=$15;
      var $17=HEAP32[(($2)>>2)];
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+24)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=FUNCTION_TABLE[$21]($17);
      var $23=$2;
      var $24=(($6+48)|0);
      HEAP32[(($24)>>2)]=$22;
      var $25=(($6+36)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$1;
      HEAP32[(($1)>>2)]=$26;
      var $28=HEAP32[(($1)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=FUNCTION_TABLE[$32]($28);
      var $34=$1;
      var $35=(($6+52)|0);
      var $36=(($33)&1);
      HEAP8[($35)]=$36;
      var $37=(($6+48)|0);
      var $38=HEAPU32[(($37)>>2)];
      var $39=(($38)>>>0) > 8;
      if ($39) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $40
      __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str91587)|0));
      __label__ = 2; break;
    case 2: // $41
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE["X"]=1;

function __ZNSt3__110__stdinbufIwE9underflowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNSt3__110__stdinbufIwE9__getcharEb($2, 0);
  ;
  return $3;
}


function __ZNSt3__110__stdinbufIwE5uflowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNSt3__110__stdinbufIwE9__getcharEb($2, 1);
  ;
  return $3;
}


function __ZNSt3__110__stdinbufIwEC2EP7__sFILE($this, $__fp) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+4;
      var $5;
      var $6;
      $2=$this;
      $3=$__fp;
      var $7=$2;
      var $8=$7;
      __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev($8);
      var $9=$7;
      HEAP32[(($9)>>2)]=((__ZTVNSt3__110__stdinbufIwEE+8)|0);
      var $10=(($7+32)|0);
      var $11=$3;
      HEAP32[(($10)>>2)]=$11;
      var $12=(($7+40)|0);
      var $13=$12;
      HEAP32[(($13)>>2)]=0; HEAP32[(($13+4)>>2)]=0;
      var $14=$7;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$7;
      var $19=$1;
      HEAP32[(($1)>>2)]=$18;
      var $20=HEAP32[(($1)>>2)];
      var $21=(($20+4)|0);
      FUNCTION_TABLE[__ZNSt3__16localeC1ERKS0_]($4, $21);
      var $22=$1;
      __label__ = 1; break;
    case 1: // $23
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$17]($7, $4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $24
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      STACKTOP = __stackBase__;
      return;
    case 4: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $5=$28;
      var $29=$27.f1;
      $6=$29;
      __label__ = 7; break;
    case 5: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $5=$32;
      var $33=$31.f1;
      $6=$33;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $34
      __label__ = 7; break;
    case 7: // $35
      var $36=$7;
      (function() { try { __THREW__ = false; return __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $37
      __label__ = 9; break;
    case 9: // $38
      var $39=$5;
      var $40=$5;
      var $41=$6;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIwEC2EP7__sFILE["X"]=1;

function __ZNSt3__110__stdinbufIwE9pbackfailEj($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15;
      var $16;
      var $17;
      var $__extbuf=__stackBase__+56;
      var $__enxt=__stackBase__+64;
      var $__ci=__stackBase__+68;
      var $__inxt=__stackBase__+72;
      $16=$this;
      $17=$__c;
      var $18=$16;
      var $19=$17;
      var $20=$2;
      var $21=$3;
      HEAP32[(($2)>>2)]=$19;
      HEAP32[(($3)>>2)]=-1;
      var $22=HEAP32[(($2)>>2)];
      var $23=HEAP32[(($3)>>2)];
      var $24=(($22)|0)==(($23)|0);
      var $25=$2;
      var $26=$3;
      if ($24) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      var $28=$17;
      $15=$28;
      __label__ = 14; break;
    case 2: // $29
      var $30=$17;
      var $31=$1;
      HEAP32[(($1)>>2)]=$30;
      var $32=HEAP32[(($1)>>2)];
      var $33=$1;
      HEAP32[(($__ci)>>2)]=$32;
      var $34=(($18+36)|0);
      var $35=HEAP32[(($34)>>2)];
      var $36=(($18+40)|0);
      var $37=(($__ci+4)|0);
      var $38=(($__extbuf)|0);
      var $39=(($__extbuf)|0);
      var $40=(($39+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$6;
      var $44=$7;
      var $45=$8;
      var $46=$9;
      var $47=$10;
      var $48=$11;
      HEAP32[(($4)>>2)]=$35;
      HEAP32[(($5)>>2)]=$36;
      HEAP32[(($6)>>2)]=$__ci;
      HEAP32[(($7)>>2)]=$37;
      HEAP32[(($8)>>2)]=$__inxt;
      HEAP32[(($9)>>2)]=$38;
      HEAP32[(($10)>>2)]=$40;
      HEAP32[(($11)>>2)]=$__enxt;
      var $49=HEAP32[(($4)>>2)];
      var $50=$49;
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+12)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=HEAP32[(($5)>>2)];
      var $55=HEAP32[(($6)>>2)];
      var $56=HEAP32[(($7)>>2)];
      var $57=HEAP32[(($8)>>2)];
      var $58=HEAP32[(($9)>>2)];
      var $59=HEAP32[(($10)>>2)];
      var $60=HEAP32[(($11)>>2)];
      var $61=FUNCTION_TABLE[$53]($49, $54, $55, $56, $57, $58, $59, $60);
      var $62=$4;
      var $63=$5;
      var $64=$6;
      var $65=$7;
      var $66=$8;
      var $67=$9;
      var $68=$10;
      var $69=$11;
      if ($61 == 0) {
        __label__ = 5; break;
      }
      else if ($61 == 3) {
        __label__ = 3; break;
      }
      else if ($61 == 1 || $61 == 2) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 3: // $70
      var $71=$17;
      var $72=(($71) & 255);
      var $73=(($__extbuf)|0);
      HEAP8[($73)]=$72;
      var $74=(($__extbuf)|0);
      var $75=(($74+1)|0);
      HEAP32[(($__enxt)>>2)]=$75;
      __label__ = 5; break;
    case 4: // $76
      $15=-1;
      __label__ = 14; break;
    case 5: // $77
      __label__ = 6; break;
    case 6: // $78
      var $79=HEAPU32[(($__enxt)>>2)];
      var $80=(($__extbuf)|0);
      var $81=(($79)>>>0) > (($80)>>>0);
      if ($81) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $82
      var $83=HEAP32[(($__enxt)>>2)];
      var $84=(($83-1)|0);
      HEAP32[(($__enxt)>>2)]=$84;
      var $85=HEAP8[($84)];
      var $86=(($85 << 24) >> 24);
      var $87=(($18+32)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=_ungetc($86, $88);
      var $90=(($89)|0)==-1;
      if ($90) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $91
      $15=-1;
      __label__ = 14; break;
    case 9: // $92
      __label__ = 6; break;
    case 10: // $93
      var $94=$17;
      var $95=$14;
      HEAP32[(($14)>>2)]=$94;
      var $96=HEAP32[(($14)>>2)];
      var $97=$12;
      var $98=$13;
      HEAP32[(($12)>>2)]=$96;
      HEAP32[(($13)>>2)]=-1;
      var $99=HEAP32[(($12)>>2)];
      var $100=HEAP32[(($13)>>2)];
      var $101=(($99)|0)==(($100)|0);
      var $102=$12;
      var $103=$13;
      if ($101) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $104
      var $107 = 0;__label__ = 13; break;
    case 12: // $105
      var $106=HEAP32[(($14)>>2)];
      var $107 = $106;__label__ = 13; break;
    case 13: // $_ZNSt3__111char_traitsIwE7not_eofEj_exit
      var $107;
      var $108=$14;
      $15=$107;
      __label__ = 14; break;
    case 14: // $109
      var $110=$15;
      STACKTOP = __stackBase__;
      return $110;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIwE9pbackfailEj["X"]=1;

function __ZNSt3__110__stdinbufIwE9__getcharEb($this, $__consume) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19;
      var $20;
      var $21;
      var $__extbuf=__stackBase__+72;
      var $__nread;
      var $22=__stackBase__+80;
      var $__i;
      var $__c;
      var $__1buf=__stackBase__+84;
      var $__enxt=__stackBase__+88;
      var $__inxt=__stackBase__+92;
      var $__r;
      var $__sv_st=__stackBase__+96;
      var $__c1;
      var $__i2;
      $20=$this;
      var $23=(($__consume)&1);
      $21=$23;
      var $24=$20;
      HEAP32[(($22)>>2)]=1;
      var $25=(($24+48)|0);
      var $26=$15;
      var $27=$16;
      var $28=$17;
      var $29=$18;
      HEAP32[(($16)>>2)]=$22;
      HEAP32[(($17)>>2)]=$25;
      var $30=HEAP32[(($16)>>2)];
      var $31=HEAP32[(($17)>>2)];
      var $tmp_i=$15;
      var $tmp1_i=$18;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $32=$13;
      var $33=$14;
      HEAP32[(($13)>>2)]=$30;
      HEAP32[(($14)>>2)]=$31;
      var $34=HEAP32[(($13)>>2)];
      var $35=HEAP32[(($14)>>2)];
      var $36=$10;
      var $37=$11;
      var $38=$12;
      HEAP32[(($10)>>2)]=$15;
      HEAP32[(($11)>>2)]=$34;
      HEAP32[(($12)>>2)]=$35;
      var $39=HEAP32[(($10)>>2)];
      var $40=HEAP32[(($11)>>2)];
      var $41=HEAP32[(($40)>>2)];
      var $42=HEAP32[(($12)>>2)];
      var $43=HEAP32[(($42)>>2)];
      var $44=(($41)|0) < (($43)|0);
      var $45=$10;
      var $46=$11;
      var $47=$12;
      if ($44) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $48
      var $49=HEAP32[(($14)>>2)];
      var $52 = $49;__label__ = 3; break;
    case 2: // $50
      var $51=HEAP32[(($13)>>2)];
      var $52 = $51;__label__ = 3; break;
    case 3: // $_ZNSt3__13maxIiEERKT_S3_S3__exit
      var $52;
      var $53=$13;
      var $54=$14;
      var $55=$15;
      var $56=$16;
      var $57=$17;
      var $58=$18;
      var $59=HEAP32[(($52)>>2)];
      $__nread=$59;
      $__i=0;
      __label__ = 4; break;
    case 4: // $60
      var $61=$__i;
      var $62=$__nread;
      var $63=(($61)|0) < (($62)|0);
      if ($63) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $64
      var $65=(($24+32)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=_getc($66);
      var $68=(($67) & 255);
      $__c=$68;
      var $69=$__c;
      var $70=(($69 << 24) >> 24);
      var $71=(($70)|0)==-1;
      if ($71) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $72
      $19=-1;
      __label__ = 31; break;
    case 7: // $73
      var $74=$__c;
      var $75=$__i;
      var $76=(($__extbuf+$75)|0);
      HEAP8[($76)]=$74;
      __label__ = 8; break;
    case 8: // $77
      var $78=$__i;
      var $79=(($78+1)|0);
      $__i=$79;
      __label__ = 4; break;
    case 9: // $80
      var $81=(($24+52)|0);
      var $82=HEAP8[($81)];
      var $83=(($82) & 1);
      if ($83) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $84
      var $85=(($__extbuf)|0);
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      HEAP32[(($__1buf)>>2)]=$87;
      __label__ = 23; break;
    case 11: // $88
      __label__ = 12; break;
    case 12: // $89
      var $90=(($24+40)|0);
      var $91=$__sv_st;
      var $92=$90;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($91)>>2)]=HEAP32[(($92)>>2)];HEAP32[(($91+4)>>2)]=HEAP32[(($92+4)>>2)];
      var $93=(($24+36)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=(($24+40)|0);
      var $96=(($__extbuf)|0);
      var $97=(($__extbuf)|0);
      var $98=$__nread;
      var $99=(($97+$98)|0);
      var $100=(($__1buf+4)|0);
      var $101=$1;
      var $102=$2;
      var $103=$3;
      var $104=$4;
      var $105=$5;
      var $106=$6;
      var $107=$7;
      var $108=$8;
      HEAP32[(($1)>>2)]=$94;
      HEAP32[(($2)>>2)]=$95;
      HEAP32[(($3)>>2)]=$96;
      HEAP32[(($4)>>2)]=$99;
      HEAP32[(($5)>>2)]=$__enxt;
      HEAP32[(($6)>>2)]=$__1buf;
      HEAP32[(($7)>>2)]=$100;
      HEAP32[(($8)>>2)]=$__inxt;
      var $109=HEAP32[(($1)>>2)];
      var $110=$109;
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+16)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=HEAP32[(($2)>>2)];
      var $115=HEAP32[(($3)>>2)];
      var $116=HEAP32[(($4)>>2)];
      var $117=HEAP32[(($5)>>2)];
      var $118=HEAP32[(($6)>>2)];
      var $119=HEAP32[(($7)>>2)];
      var $120=HEAP32[(($8)>>2)];
      var $121=FUNCTION_TABLE[$113]($109, $114, $115, $116, $117, $118, $119, $120);
      var $122=$1;
      var $123=$2;
      var $124=$3;
      var $125=$4;
      var $126=$5;
      var $127=$6;
      var $128=$7;
      var $129=$8;
      $__r=$121;
      var $130=$__r;
      if ($130 == 0) {
        __label__ = 20; break;
      }
      else if ($130 == 1) {
        __label__ = 13; break;
      }
      else if ($130 == 2) {
        __label__ = 18; break;
      }
      else if ($130 == 3) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 13: // $131
      var $132=(($24+40)|0);
      var $133=$132;
      var $134=$__sv_st;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($133)>>2)]=HEAP32[(($134)>>2)];HEAP32[(($133+4)>>2)]=HEAP32[(($134+4)>>2)];
      var $135=$__nread;
      var $136=(($135)|0)==8;
      if ($136) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $137
      $19=-1;
      __label__ = 31; break;
    case 15: // $138
      var $139=(($24+32)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=_getc($140);
      var $142=(($141) & 255);
      $__c1=$142;
      var $143=$__c1;
      var $144=(($143 << 24) >> 24);
      var $145=(($144)|0)==-1;
      if ($145) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $146
      $19=-1;
      __label__ = 31; break;
    case 17: // $147
      var $148=$__c1;
      var $149=$__nread;
      var $150=(($__extbuf+$149)|0);
      HEAP8[($150)]=$148;
      var $151=$__nread;
      var $152=(($151+1)|0);
      $__nread=$152;
      __label__ = 20; break;
    case 18: // $153
      $19=-1;
      __label__ = 31; break;
    case 19: // $154
      var $155=(($__extbuf)|0);
      var $156=HEAP8[($155)];
      var $157=(($156 << 24) >> 24);
      HEAP32[(($__1buf)>>2)]=$157;
      __label__ = 20; break;
    case 20: // $158
      __label__ = 21; break;
    case 21: // $159
      var $160=$__r;
      var $161=(($160)|0)==1;
      if ($161) { __label__ = 12; break; } else { __label__ = 22; break; }
    case 22: // $162
      __label__ = 23; break;
    case 23: // $163
      var $164=$21;
      var $165=(($164) & 1);
      if ($165) { __label__ = 30; break; } else { __label__ = 24; break; }
    case 24: // $166
      var $167=$__nread;
      $__i2=$167;
      __label__ = 25; break;
    case 25: // $168
      var $169=$__i2;
      var $170=(($169)|0) > 0;
      if ($170) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $171
      var $172=$__i2;
      var $173=(($172-1)|0);
      $__i2=$173;
      var $174=(($__extbuf+$173)|0);
      var $175=HEAP8[($174)];
      var $176=(($175 << 24) >> 24);
      var $177=(($24+32)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=_ungetc($176, $178);
      var $180=(($179)|0)==-1;
      if ($180) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $181
      $19=-1;
      __label__ = 31; break;
    case 28: // $182
      __label__ = 25; break;
    case 29: // $183
      __label__ = 30; break;
    case 30: // $184
      var $185=HEAP32[(($__1buf)>>2)];
      var $186=$9;
      HEAP32[(($9)>>2)]=$185;
      var $187=HEAP32[(($9)>>2)];
      var $188=$9;
      $19=$187;
      __label__ = 31; break;
    case 31: // $189
      var $190=$19;
      STACKTOP = __stackBase__;
      return $190;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIwE9__getcharEb["X"]=1;

function __ZNSt3__111__stdoutbufIcED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__111__stdoutbufIcED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE($this, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3;
  var $4;
  $3=$this;
  $4=$__loc;
  var $5=$3;
  var $6=$5;
  var $7=HEAP32[(($6)>>2)];
  var $8=(($7+24)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=FUNCTION_TABLE[$9]($5);
  var $11=$4;
  var $12=$2;
  HEAP32[(($2)>>2)]=$11;
  var $13=HEAP32[(($2)>>2)];
  var $14=__ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__17codecvtIcc10_mbstate_tE2idE);
  var $15=$14;
  var $16=$2;
  var $17=(($5+36)|0);
  HEAP32[(($17)>>2)]=$15;
  var $18=(($5+36)|0);
  var $19=HEAP32[(($18)>>2)];
  var $20=$1;
  HEAP32[(($1)>>2)]=$19;
  var $21=HEAP32[(($1)>>2)];
  var $22=$21;
  var $23=HEAP32[(($22)>>2)];
  var $24=(($23+28)|0);
  var $25=HEAP32[(($24)>>2)];
  var $26=FUNCTION_TABLE[$25]($21);
  var $27=$1;
  var $28=(($5+48)|0);
  var $29=(($26)&1);
  HEAP8[($28)]=$29;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__111__stdoutbufIcE4syncEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $__extbuf=__stackBase__+20;
      var $__r;
      var $__extbe=__stackBase__+28;
      var $__nmemb;
      $7=$this;
      var $8=$7;
      __label__ = 1; break;
    case 1: // $9
      var $10=(($8+36)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=(($8+40)|0);
      var $13=(($__extbuf)|0);
      var $14=(($__extbuf)|0);
      var $15=(($14+8)|0);
      var $16=$1;
      var $17=$2;
      var $18=$3;
      var $19=$4;
      var $20=$5;
      HEAP32[(($1)>>2)]=$11;
      HEAP32[(($2)>>2)]=$12;
      HEAP32[(($3)>>2)]=$13;
      HEAP32[(($4)>>2)]=$15;
      HEAP32[(($5)>>2)]=$__extbe;
      var $21=HEAP32[(($1)>>2)];
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+20)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=HEAP32[(($2)>>2)];
      var $27=HEAP32[(($3)>>2)];
      var $28=HEAP32[(($4)>>2)];
      var $29=HEAP32[(($5)>>2)];
      var $30=FUNCTION_TABLE[$25]($21, $26, $27, $28, $29);
      var $31=$1;
      var $32=$2;
      var $33=$3;
      var $34=$4;
      var $35=$5;
      $__r=$30;
      var $36=HEAP32[(($__extbe)>>2)];
      var $37=(($__extbuf)|0);
      var $38=$36;
      var $39=$37;
      var $40=(($38-$39)|0);
      $__nmemb=$40;
      var $41=(($__extbuf)|0);
      var $42=$__nmemb;
      var $43=(($8+32)|0);
      var $44=HEAP32[(($43)>>2)];
      var $45=_fwrite($41, 1, $42, $44);
      var $46=$__nmemb;
      var $47=(($45)|0)!=(($46)|0);
      if ($47) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $48
      $6=-1;
      __label__ = 10; break;
    case 3: // $49
      __label__ = 4; break;
    case 4: // $50
      var $51=$__r;
      var $52=(($51)|0)==1;
      if ($52) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 5: // $53
      var $54=$__r;
      var $55=(($54)|0)==2;
      if ($55) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $56
      $6=-1;
      __label__ = 10; break;
    case 7: // $57
      var $58=(($8+32)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=_fflush($59);
      var $61=(($60)|0)!=0;
      if ($61) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $62
      $6=-1;
      __label__ = 10; break;
    case 9: // $63
      $6=0;
      __label__ = 10; break;
    case 10: // $64
      var $65=$6;
      STACKTOP = __stackBase__;
      return $65;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__stdoutbufIcE4syncEv["X"]=1;

function __ZNSt3__111__stdoutbufIcEC2EP7__sFILE($this, $__fp) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      var $5;
      var $6=__stackBase__+12;
      var $7;
      var $8;
      $4=$this;
      $5=$__fp;
      var $9=$4;
      var $10=$9;
      __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev($10);
      var $11=$9;
      HEAP32[(($11)>>2)]=((__ZTVNSt3__111__stdoutbufIcEE+8)|0);
      var $12=(($9+32)|0);
      var $13=$5;
      HEAP32[(($12)>>2)]=$13;
      var $14=(($9+36)|0);
      var $15=$9;
      var $16=$3;
      HEAP32[(($3)>>2)]=$15;
      var $17=HEAP32[(($3)>>2)];
      var $18=(($17+4)|0);
      FUNCTION_TABLE[__ZNSt3__16localeC1ERKS0_]($6, $18);
      var $19=$3;
      __label__ = 1; break;
    case 1: // $20
      var $21=$2;
      HEAP32[(($2)>>2)]=$6;
      var $22=HEAP32[(($2)>>2)];
      var $23=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($22, __ZNSt3__17codecvtIcc10_mbstate_tE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $_ZNSt3__19use_facetINS_7codecvtIcc10_mbstate_tEEEERKT_RKNS_6localeE_exit
      var $24=$23;
      var $25=$2;
      __label__ = 3; break;
    case 3: // $26
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $27
      HEAP32[(($14)>>2)]=$24;
      var $28=(($9+40)|0);
      var $29=$28;
      HEAP32[(($29)>>2)]=0; HEAP32[(($29+4)>>2)]=0;
      var $30=(($9+48)|0);
      var $31=(($9+36)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      HEAP32[(($1)>>2)]=$32;
      var $34=HEAP32[(($1)>>2)];
      var $35=$34;
      var $36=HEAP32[(($35)>>2)];
      var $37=(($36+28)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=FUNCTION_TABLE[$38]($34);
      var $40=$1;
      var $41=(($39)&1);
      HEAP8[($30)]=$41;
      STACKTOP = __stackBase__;
      return;
    case 5: // $42
      var $43=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $44=$43.f0;
      $7=$44;
      var $45=$43.f1;
      $8=$45;
      __label__ = 8; break;
    case 6: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; }
    case 7: // $50
      __label__ = 8; break;
    case 8: // $51
      var $52=$9;
      (function() { try { __THREW__ = false; return __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($52) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $53
      __label__ = 10; break;
    case 10: // $54
      var $55=$7;
      var $56=$7;
      var $57=$8;
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 11: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__stdoutbufIcEC2EP7__sFILE["X"]=1;

function __ZNSt3__111__stdoutbufIcE8overflowEi($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 164; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37;
      var $38;
      var $39;
      var $__extbuf=__stackBase__+144;
      var $__1buf=__stackBase__+152;
      var $__extbe=__stackBase__+156;
      var $__r;
      var $__e=__stackBase__+160;
      var $__nmemb;
      $38=$this;
      $39=$__c;
      var $40=$38;
      var $41=$39;
      var $42=$11;
      var $43=$12;
      HEAP32[(($11)>>2)]=$41;
      HEAP32[(($12)>>2)]=-1;
      var $44=HEAP32[(($11)>>2)];
      var $45=HEAP32[(($12)>>2)];
      var $46=(($44)|0)==(($45)|0);
      var $47=$11;
      var $48=$12;
      if ($46) { __label__ = 25; break; } else { __label__ = 1; break; }
    case 1: // $49
      var $50=$40;
      var $51=(($__1buf+1)|0);
      var $52=$1;
      var $53=$2;
      var $54=$3;
      HEAP32[(($1)>>2)]=$50;
      HEAP32[(($2)>>2)]=$__1buf;
      HEAP32[(($3)>>2)]=$51;
      var $55=HEAP32[(($1)>>2)];
      var $56=HEAP32[(($2)>>2)];
      var $57=(($55+24)|0);
      HEAP32[(($57)>>2)]=$56;
      var $58=(($55+20)|0);
      HEAP32[(($58)>>2)]=$56;
      var $59=HEAP32[(($3)>>2)];
      var $60=(($55+28)|0);
      HEAP32[(($60)>>2)]=$59;
      var $61=$1;
      var $62=$2;
      var $63=$3;
      var $64=$39;
      var $65=$4;
      HEAP32[(($4)>>2)]=$64;
      var $66=HEAP32[(($4)>>2)];
      var $67=(($66) & 255);
      var $68=$4;
      var $69=$40;
      var $70=$5;
      HEAP32[(($5)>>2)]=$69;
      var $71=HEAP32[(($5)>>2)];
      var $72=(($71+24)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$5;
      HEAP8[($73)]=$67;
      var $75=$40;
      var $76=$6;
      var $77=$7;
      HEAP32[(($6)>>2)]=$75;
      HEAP32[(($7)>>2)]=1;
      var $78=HEAP32[(($6)>>2)];
      var $79=HEAP32[(($7)>>2)];
      var $80=(($78+24)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=(($81+$79)|0);
      HEAP32[(($80)>>2)]=$82;
      var $83=$6;
      var $84=$7;
      var $85=(($40+48)|0);
      var $86=HEAP8[($85)];
      var $87=(($86) & 1);
      if ($87) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $88
      var $89=$40;
      var $90=$8;
      HEAP32[(($8)>>2)]=$89;
      var $91=HEAP32[(($8)>>2)];
      var $92=(($91+20)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$8;
      var $95=(($40+32)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=_fwrite($93, 1, 1, $96);
      var $98=(($97)|0)!=1;
      if ($98) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $99
      $37=-1;
      __label__ = 29; break;
    case 4: // $100
      __label__ = 24; break;
    case 5: // $101
      var $102=(($__extbuf)|0);
      HEAP32[(($__extbe)>>2)]=$102;
      __label__ = 6; break;
    case 6: // $103
      var $104=(($40+36)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($40+40)|0);
      var $107=$40;
      var $108=$9;
      HEAP32[(($9)>>2)]=$107;
      var $109=HEAP32[(($9)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$9;
      var $113=$40;
      var $114=$10;
      HEAP32[(($10)>>2)]=$113;
      var $115=HEAP32[(($10)>>2)];
      var $116=(($115+24)|0);
      var $117=HEAP32[(($116)>>2)];
      var $118=$10;
      var $119=(($__extbuf)|0);
      var $120=(($__extbuf)|0);
      var $121=(($120+8)|0);
      var $122=$13;
      var $123=$14;
      var $124=$15;
      var $125=$16;
      var $126=$17;
      var $127=$18;
      var $128=$19;
      var $129=$20;
      HEAP32[(($13)>>2)]=$105;
      HEAP32[(($14)>>2)]=$106;
      HEAP32[(($15)>>2)]=$111;
      HEAP32[(($16)>>2)]=$117;
      HEAP32[(($17)>>2)]=$__e;
      HEAP32[(($18)>>2)]=$119;
      HEAP32[(($19)>>2)]=$121;
      HEAP32[(($20)>>2)]=$__extbe;
      var $130=HEAP32[(($13)>>2)];
      var $131=$130;
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132+12)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=HEAP32[(($14)>>2)];
      var $136=HEAP32[(($15)>>2)];
      var $137=HEAP32[(($16)>>2)];
      var $138=HEAP32[(($17)>>2)];
      var $139=HEAP32[(($18)>>2)];
      var $140=HEAP32[(($19)>>2)];
      var $141=HEAP32[(($20)>>2)];
      var $142=FUNCTION_TABLE[$134]($130, $135, $136, $137, $138, $139, $140, $141);
      var $143=$13;
      var $144=$14;
      var $145=$15;
      var $146=$16;
      var $147=$17;
      var $148=$18;
      var $149=$19;
      var $150=$20;
      $__r=$142;
      var $151=HEAP32[(($__e)>>2)];
      var $152=$40;
      var $153=$21;
      HEAP32[(($21)>>2)]=$152;
      var $154=HEAP32[(($21)>>2)];
      var $155=(($154+20)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$21;
      var $158=(($151)|0)==(($156)|0);
      if ($158) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $159
      $37=-1;
      __label__ = 29; break;
    case 8: // $160
      var $161=$__r;
      var $162=(($161)|0)==3;
      if ($162) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $163
      var $164=$40;
      var $165=$22;
      HEAP32[(($22)>>2)]=$164;
      var $166=HEAP32[(($22)>>2)];
      var $167=(($166+20)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$22;
      var $170=(($40+32)|0);
      var $171=HEAP32[(($170)>>2)];
      var $172=_fwrite($168, 1, 1, $171);
      var $173=(($172)|0)!=1;
      if ($173) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $174
      $37=-1;
      __label__ = 29; break;
    case 11: // $175
      __label__ = 21; break;
    case 12: // $176
      var $177=$__r;
      var $178=(($177)|0)==0;
      if ($178) { __label__ = 14; break; } else { __label__ = 13; break; }
    case 13: // $179
      var $180=$__r;
      var $181=(($180)|0)==1;
      if ($181) { __label__ = 14; break; } else { __label__ = 19; break; }
    case 14: // $182
      var $183=HEAP32[(($__extbe)>>2)];
      var $184=(($__extbuf)|0);
      var $185=$183;
      var $186=$184;
      var $187=(($185-$186)|0);
      $__nmemb=$187;
      var $188=(($__extbuf)|0);
      var $189=$__nmemb;
      var $190=(($40+32)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=_fwrite($188, 1, $189, $191);
      var $193=$__nmemb;
      var $194=(($192)|0)!=(($193)|0);
      if ($194) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $195
      $37=-1;
      __label__ = 29; break;
    case 16: // $196
      var $197=$__r;
      var $198=(($197)|0)==1;
      if ($198) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $199
      var $200=$40;
      var $201=HEAP32[(($__e)>>2)];
      var $202=$40;
      var $203=$23;
      HEAP32[(($23)>>2)]=$202;
      var $204=HEAP32[(($23)>>2)];
      var $205=(($204+24)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=$23;
      var $208=$24;
      var $209=$25;
      var $210=$26;
      HEAP32[(($24)>>2)]=$200;
      HEAP32[(($25)>>2)]=$201;
      HEAP32[(($26)>>2)]=$206;
      var $211=HEAP32[(($24)>>2)];
      var $212=HEAP32[(($25)>>2)];
      var $213=(($211+24)|0);
      HEAP32[(($213)>>2)]=$212;
      var $214=(($211+20)|0);
      HEAP32[(($214)>>2)]=$212;
      var $215=HEAP32[(($26)>>2)];
      var $216=(($211+28)|0);
      HEAP32[(($216)>>2)]=$215;
      var $217=$24;
      var $218=$25;
      var $219=$26;
      var $220=$40;
      var $221=$40;
      var $222=$27;
      HEAP32[(($27)>>2)]=$221;
      var $223=HEAP32[(($27)>>2)];
      var $224=(($223+28)|0);
      var $225=HEAP32[(($224)>>2)];
      var $226=$27;
      var $227=$40;
      var $228=$28;
      HEAP32[(($28)>>2)]=$227;
      var $229=HEAP32[(($28)>>2)];
      var $230=(($229+20)|0);
      var $231=HEAP32[(($230)>>2)];
      var $232=$28;
      var $233=$225;
      var $234=$231;
      var $235=(($233-$234)|0);
      var $236=$29;
      var $237=$30;
      HEAP32[(($29)>>2)]=$220;
      HEAP32[(($30)>>2)]=$235;
      var $238=HEAP32[(($29)>>2)];
      var $239=HEAP32[(($30)>>2)];
      var $240=(($238+24)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241+$239)|0);
      HEAP32[(($240)>>2)]=$242;
      var $243=$29;
      var $244=$30;
      __label__ = 18; break;
    case 18: // $245
      __label__ = 20; break;
    case 19: // $246
      $37=-1;
      __label__ = 29; break;
    case 20: // $247
      __label__ = 21; break;
    case 21: // $248
      __label__ = 22; break;
    case 22: // $249
      var $250=$__r;
      var $251=(($250)|0)==1;
      if ($251) { __label__ = 6; break; } else { __label__ = 23; break; }
    case 23: // $252
      __label__ = 24; break;
    case 24: // $253
      var $254=$40;
      var $255=$31;
      var $256=$32;
      var $257=$33;
      HEAP32[(($31)>>2)]=$254;
      HEAP32[(($32)>>2)]=0;
      HEAP32[(($33)>>2)]=0;
      var $258=HEAP32[(($31)>>2)];
      var $259=HEAP32[(($32)>>2)];
      var $260=(($258+24)|0);
      HEAP32[(($260)>>2)]=$259;
      var $261=(($258+20)|0);
      HEAP32[(($261)>>2)]=$259;
      var $262=HEAP32[(($33)>>2)];
      var $263=(($258+28)|0);
      HEAP32[(($263)>>2)]=$262;
      var $264=$31;
      var $265=$32;
      var $266=$33;
      __label__ = 25; break;
    case 25: // $267
      var $268=$39;
      var $269=$36;
      HEAP32[(($36)>>2)]=$268;
      var $270=HEAP32[(($36)>>2)];
      var $271=$34;
      var $272=$35;
      HEAP32[(($34)>>2)]=$270;
      HEAP32[(($35)>>2)]=-1;
      var $273=HEAP32[(($34)>>2)];
      var $274=HEAP32[(($35)>>2)];
      var $275=(($273)|0)==(($274)|0);
      var $276=$34;
      var $277=$35;
      if ($275) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $278
      var $281 = 0;__label__ = 28; break;
    case 27: // $279
      var $280=HEAP32[(($36)>>2)];
      var $281 = $280;__label__ = 28; break;
    case 28: // $_ZNSt3__111char_traitsIcE7not_eofEi_exit
      var $281;
      var $282=$36;
      $37=$281;
      __label__ = 29; break;
    case 29: // $283
      var $284=$37;
      STACKTOP = __stackBase__;
      return $284;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__stdoutbufIcE8overflowEi["X"]=1;

function __ZNSt3__110__stdinbufIcED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__110__stdinbufIcED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE($this, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      var $5;
      $4=$this;
      $5=$__loc;
      var $6=$4;
      var $7=$5;
      var $8=$3;
      HEAP32[(($3)>>2)]=$7;
      var $9=HEAP32[(($3)>>2)];
      var $10=__ZNKSt3__16locale9use_facetERNS0_2idE($9, __ZNSt3__17codecvtIcc10_mbstate_tE2idE);
      var $11=$10;
      var $12=$3;
      var $13=(($6+36)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=(($6+36)|0);
      var $15=HEAP32[(($14)>>2)];
      var $16=$2;
      HEAP32[(($2)>>2)]=$15;
      var $17=HEAP32[(($2)>>2)];
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+24)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=FUNCTION_TABLE[$21]($17);
      var $23=$2;
      var $24=(($6+48)|0);
      HEAP32[(($24)>>2)]=$22;
      var $25=(($6+36)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$1;
      HEAP32[(($1)>>2)]=$26;
      var $28=HEAP32[(($1)>>2)];
      var $29=$28;
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30+28)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=FUNCTION_TABLE[$32]($28);
      var $34=$1;
      var $35=(($6+52)|0);
      var $36=(($33)&1);
      HEAP8[($35)]=$36;
      var $37=(($6+48)|0);
      var $38=HEAPU32[(($37)>>2)];
      var $39=(($38)>>>0) > 8;
      if ($39) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $40
      __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str91587)|0));
      __label__ = 2; break;
    case 2: // $41
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE["X"]=1;

function __ZNSt3__110__stdinbufIcE9underflowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNSt3__110__stdinbufIcE9__getcharEb($2, 0);
  ;
  return $3;
}


function __ZNSt3__110__stdinbufIcE5uflowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=__ZNSt3__110__stdinbufIcE9__getcharEb($2, 1);
  ;
  return $3;
}


function __ZNSt3__110__stdinbufIcE9pbackfailEi($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15;
      var $16;
      var $17;
      var $__extbuf=__stackBase__+56;
      var $__enxt=__stackBase__+64;
      var $__ci=__stackBase__+68;
      var $__inxt=__stackBase__+72;
      $16=$this;
      $17=$__c;
      var $18=$16;
      var $19=$17;
      var $20=$2;
      var $21=$3;
      HEAP32[(($2)>>2)]=$19;
      HEAP32[(($3)>>2)]=-1;
      var $22=HEAP32[(($2)>>2)];
      var $23=HEAP32[(($3)>>2)];
      var $24=(($22)|0)==(($23)|0);
      var $25=$2;
      var $26=$3;
      if ($24) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $27
      var $28=$17;
      $15=$28;
      __label__ = 14; break;
    case 2: // $29
      var $30=$17;
      var $31=$1;
      HEAP32[(($1)>>2)]=$30;
      var $32=HEAP32[(($1)>>2)];
      var $33=(($32) & 255);
      var $34=$1;
      HEAP8[($__ci)]=$33;
      var $35=(($18+36)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=(($18+40)|0);
      var $38=(($__ci+1)|0);
      var $39=(($__extbuf)|0);
      var $40=(($__extbuf)|0);
      var $41=(($40+8)|0);
      var $42=$4;
      var $43=$5;
      var $44=$6;
      var $45=$7;
      var $46=$8;
      var $47=$9;
      var $48=$10;
      var $49=$11;
      HEAP32[(($4)>>2)]=$36;
      HEAP32[(($5)>>2)]=$37;
      HEAP32[(($6)>>2)]=$__ci;
      HEAP32[(($7)>>2)]=$38;
      HEAP32[(($8)>>2)]=$__inxt;
      HEAP32[(($9)>>2)]=$39;
      HEAP32[(($10)>>2)]=$41;
      HEAP32[(($11)>>2)]=$__enxt;
      var $50=HEAP32[(($4)>>2)];
      var $51=$50;
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52+12)|0);
      var $54=HEAP32[(($53)>>2)];
      var $55=HEAP32[(($5)>>2)];
      var $56=HEAP32[(($6)>>2)];
      var $57=HEAP32[(($7)>>2)];
      var $58=HEAP32[(($8)>>2)];
      var $59=HEAP32[(($9)>>2)];
      var $60=HEAP32[(($10)>>2)];
      var $61=HEAP32[(($11)>>2)];
      var $62=FUNCTION_TABLE[$54]($50, $55, $56, $57, $58, $59, $60, $61);
      var $63=$4;
      var $64=$5;
      var $65=$6;
      var $66=$7;
      var $67=$8;
      var $68=$9;
      var $69=$10;
      var $70=$11;
      if ($62 == 0) {
        __label__ = 5; break;
      }
      else if ($62 == 3) {
        __label__ = 3; break;
      }
      else if ($62 == 1 || $62 == 2) {
        __label__ = 4; break;
      }
      else {
      __label__ = 5; break;
      }
      
    case 3: // $71
      var $72=$17;
      var $73=(($72) & 255);
      var $74=(($__extbuf)|0);
      HEAP8[($74)]=$73;
      var $75=(($__extbuf)|0);
      var $76=(($75+1)|0);
      HEAP32[(($__enxt)>>2)]=$76;
      __label__ = 5; break;
    case 4: // $77
      $15=-1;
      __label__ = 14; break;
    case 5: // $78
      __label__ = 6; break;
    case 6: // $79
      var $80=HEAPU32[(($__enxt)>>2)];
      var $81=(($__extbuf)|0);
      var $82=(($80)>>>0) > (($81)>>>0);
      if ($82) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $83
      var $84=HEAP32[(($__enxt)>>2)];
      var $85=(($84-1)|0);
      HEAP32[(($__enxt)>>2)]=$85;
      var $86=HEAP8[($85)];
      var $87=(($86 << 24) >> 24);
      var $88=(($18+32)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=_ungetc($87, $89);
      var $91=(($90)|0)==-1;
      if ($91) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $92
      $15=-1;
      __label__ = 14; break;
    case 9: // $93
      __label__ = 6; break;
    case 10: // $94
      var $95=$17;
      var $96=$14;
      HEAP32[(($14)>>2)]=$95;
      var $97=HEAP32[(($14)>>2)];
      var $98=$12;
      var $99=$13;
      HEAP32[(($12)>>2)]=$97;
      HEAP32[(($13)>>2)]=-1;
      var $100=HEAP32[(($12)>>2)];
      var $101=HEAP32[(($13)>>2)];
      var $102=(($100)|0)==(($101)|0);
      var $103=$12;
      var $104=$13;
      if ($102) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $105
      var $108 = 0;__label__ = 13; break;
    case 12: // $106
      var $107=HEAP32[(($14)>>2)];
      var $108 = $107;__label__ = 13; break;
    case 13: // $_ZNSt3__111char_traitsIcE7not_eofEi_exit
      var $108;
      var $109=$14;
      $15=$108;
      __label__ = 14; break;
    case 14: // $110
      var $111=$15;
      STACKTOP = __stackBase__;
      return $111;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIcE9pbackfailEi["X"]=1;

function __ZNSt3__110__stdinbufIcEC2EP7__sFILE($this, $__fp) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+4;
      var $5;
      var $6;
      $2=$this;
      $3=$__fp;
      var $7=$2;
      var $8=$7;
      __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev($8);
      var $9=$7;
      HEAP32[(($9)>>2)]=((__ZTVNSt3__110__stdinbufIcEE+8)|0);
      var $10=(($7+32)|0);
      var $11=$3;
      HEAP32[(($10)>>2)]=$11;
      var $12=(($7+40)|0);
      var $13=$12;
      HEAP32[(($13)>>2)]=0; HEAP32[(($13+4)>>2)]=0;
      var $14=$7;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+8)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$7;
      var $19=$1;
      HEAP32[(($1)>>2)]=$18;
      var $20=HEAP32[(($1)>>2)];
      var $21=(($20+4)|0);
      FUNCTION_TABLE[__ZNSt3__16localeC1ERKS0_]($4, $21);
      var $22=$1;
      __label__ = 1; break;
    case 1: // $23
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$17]($7, $4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $24
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      STACKTOP = __stackBase__;
      return;
    case 4: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $5=$28;
      var $29=$27.f1;
      $6=$29;
      __label__ = 7; break;
    case 5: // $30
      var $31=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $32=$31.f0;
      $5=$32;
      var $33=$31.f1;
      $6=$33;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $34
      __label__ = 7; break;
    case 7: // $35
      var $36=$7;
      (function() { try { __THREW__ = false; return __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $37
      __label__ = 9; break;
    case 9: // $38
      var $39=$5;
      var $40=$5;
      var $41=$6;
      var $42=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $40, tempValue);
      var $43=($42.f1 = $41, $42);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $44
      var $45=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIcEC2EP7__sFILE["X"]=1;

function __ZNSt3__114__shared_countD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNSt3__114error_categoryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_19incrementIlEET_RS2_($t) {
  ;
  var __label__;

  var $1;
  $1=$t;
  var $2=$1;
  var $3=(tempValue=HEAP32[(($2)>>2)],HEAP32[(($2)>>2)]=tempValue+1,tempValue);
  var $4=(($3+1)|0);
  ;
  return $4;
}


function __ZNSt3__112_GLOBAL__N_19decrementIlEET_RS2_($t) {
  ;
  var __label__;

  var $1;
  $1=$t;
  var $2=$1;
  var $3=(tempValue=HEAP32[(($2)>>2)],HEAP32[(($2)>>2)]=tempValue+-1,tempValue);
  var $4=(($3-1)|0);
  ;
  return $4;
}


function __ZNSt3__114error_categoryC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__114error_categoryE+8)|0);
  ;
  return;
}


function __ZNK12_GLOBAL__N_114__libcpp_nmstr5c_strEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNK12_GLOBAL__N_114__libcpp_nmstr5countEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=(($4-4)|0);
  var $6=$5;
  ;
  return $6;
}


function __ZNSt3__110__stdinbufIcE9__getcharEb($this, $__consume) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $18=__stackBase__+64;
      var $19;
      var $20;
      var $21;
      var $__extbuf=__stackBase__+68;
      var $__nread;
      var $22=__stackBase__+76;
      var $__i;
      var $__c;
      var $__1buf=__stackBase__+80;
      var $__enxt=__stackBase__+84;
      var $__inxt=__stackBase__+88;
      var $__r;
      var $__sv_st=__stackBase__+92;
      var $__c1;
      var $__i2;
      $20=$this;
      var $23=(($__consume)&1);
      $21=$23;
      var $24=$20;
      HEAP32[(($22)>>2)]=1;
      var $25=(($24+48)|0);
      var $26=$15;
      var $27=$16;
      var $28=$17;
      var $29=$18;
      HEAP32[(($16)>>2)]=$22;
      HEAP32[(($17)>>2)]=$25;
      var $30=HEAP32[(($16)>>2)];
      var $31=HEAP32[(($17)>>2)];
      var $tmp_i=$15;
      var $tmp1_i=$18;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $32=$13;
      var $33=$14;
      HEAP32[(($13)>>2)]=$30;
      HEAP32[(($14)>>2)]=$31;
      var $34=HEAP32[(($13)>>2)];
      var $35=HEAP32[(($14)>>2)];
      var $36=$10;
      var $37=$11;
      var $38=$12;
      HEAP32[(($10)>>2)]=$15;
      HEAP32[(($11)>>2)]=$34;
      HEAP32[(($12)>>2)]=$35;
      var $39=HEAP32[(($10)>>2)];
      var $40=HEAP32[(($11)>>2)];
      var $41=HEAP32[(($40)>>2)];
      var $42=HEAP32[(($12)>>2)];
      var $43=HEAP32[(($42)>>2)];
      var $44=(($41)|0) < (($43)|0);
      var $45=$10;
      var $46=$11;
      var $47=$12;
      if ($44) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $48
      var $49=HEAP32[(($14)>>2)];
      var $52 = $49;__label__ = 3; break;
    case 2: // $50
      var $51=HEAP32[(($13)>>2)];
      var $52 = $51;__label__ = 3; break;
    case 3: // $_ZNSt3__13maxIiEERKT_S3_S3__exit
      var $52;
      var $53=$13;
      var $54=$14;
      var $55=$15;
      var $56=$16;
      var $57=$17;
      var $58=$18;
      var $59=HEAP32[(($52)>>2)];
      $__nread=$59;
      $__i=0;
      __label__ = 4; break;
    case 4: // $60
      var $61=$__i;
      var $62=$__nread;
      var $63=(($61)|0) < (($62)|0);
      if ($63) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $64
      var $65=(($24+32)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=_getc($66);
      var $68=(($67) & 255);
      $__c=$68;
      var $69=$__c;
      var $70=(($69 << 24) >> 24);
      var $71=(($70)|0)==-1;
      if ($71) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $72
      $19=-1;
      __label__ = 31; break;
    case 7: // $73
      var $74=$__c;
      var $75=$__i;
      var $76=(($__extbuf+$75)|0);
      HEAP8[($76)]=$74;
      __label__ = 8; break;
    case 8: // $77
      var $78=$__i;
      var $79=(($78+1)|0);
      $__i=$79;
      __label__ = 4; break;
    case 9: // $80
      var $81=(($24+52)|0);
      var $82=HEAP8[($81)];
      var $83=(($82) & 1);
      if ($83) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $84
      var $85=(($__extbuf)|0);
      var $86=HEAP8[($85)];
      HEAP8[($__1buf)]=$86;
      __label__ = 23; break;
    case 11: // $87
      __label__ = 12; break;
    case 12: // $88
      var $89=(($24+40)|0);
      var $90=$__sv_st;
      var $91=$89;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($90)>>2)]=HEAP32[(($91)>>2)];HEAP32[(($90+4)>>2)]=HEAP32[(($91+4)>>2)];
      var $92=(($24+36)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($24+40)|0);
      var $95=(($__extbuf)|0);
      var $96=(($__extbuf)|0);
      var $97=$__nread;
      var $98=(($96+$97)|0);
      var $99=(($__1buf+1)|0);
      var $100=$1;
      var $101=$2;
      var $102=$3;
      var $103=$4;
      var $104=$5;
      var $105=$6;
      var $106=$7;
      var $107=$8;
      HEAP32[(($1)>>2)]=$93;
      HEAP32[(($2)>>2)]=$94;
      HEAP32[(($3)>>2)]=$95;
      HEAP32[(($4)>>2)]=$98;
      HEAP32[(($5)>>2)]=$__enxt;
      HEAP32[(($6)>>2)]=$__1buf;
      HEAP32[(($7)>>2)]=$99;
      HEAP32[(($8)>>2)]=$__inxt;
      var $108=HEAP32[(($1)>>2)];
      var $109=$108;
      var $110=HEAP32[(($109)>>2)];
      var $111=(($110+16)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=HEAP32[(($2)>>2)];
      var $114=HEAP32[(($3)>>2)];
      var $115=HEAP32[(($4)>>2)];
      var $116=HEAP32[(($5)>>2)];
      var $117=HEAP32[(($6)>>2)];
      var $118=HEAP32[(($7)>>2)];
      var $119=HEAP32[(($8)>>2)];
      var $120=FUNCTION_TABLE[$112]($108, $113, $114, $115, $116, $117, $118, $119);
      var $121=$1;
      var $122=$2;
      var $123=$3;
      var $124=$4;
      var $125=$5;
      var $126=$6;
      var $127=$7;
      var $128=$8;
      $__r=$120;
      var $129=$__r;
      if ($129 == 0) {
        __label__ = 20; break;
      }
      else if ($129 == 1) {
        __label__ = 13; break;
      }
      else if ($129 == 2) {
        __label__ = 18; break;
      }
      else if ($129 == 3) {
        __label__ = 19; break;
      }
      else {
      __label__ = 20; break;
      }
      
    case 13: // $130
      var $131=(($24+40)|0);
      var $132=$131;
      var $133=$__sv_st;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($132)>>2)]=HEAP32[(($133)>>2)];HEAP32[(($132+4)>>2)]=HEAP32[(($133+4)>>2)];
      var $134=$__nread;
      var $135=(($134)|0)==8;
      if ($135) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $136
      $19=-1;
      __label__ = 31; break;
    case 15: // $137
      var $138=(($24+32)|0);
      var $139=HEAP32[(($138)>>2)];
      var $140=_getc($139);
      var $141=(($140) & 255);
      $__c1=$141;
      var $142=$__c1;
      var $143=(($142 << 24) >> 24);
      var $144=(($143)|0)==-1;
      if ($144) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $145
      $19=-1;
      __label__ = 31; break;
    case 17: // $146
      var $147=$__c1;
      var $148=$__nread;
      var $149=(($__extbuf+$148)|0);
      HEAP8[($149)]=$147;
      var $150=$__nread;
      var $151=(($150+1)|0);
      $__nread=$151;
      __label__ = 20; break;
    case 18: // $152
      $19=-1;
      __label__ = 31; break;
    case 19: // $153
      var $154=(($__extbuf)|0);
      var $155=HEAP8[($154)];
      HEAP8[($__1buf)]=$155;
      __label__ = 20; break;
    case 20: // $156
      __label__ = 21; break;
    case 21: // $157
      var $158=$__r;
      var $159=(($158)|0)==1;
      if ($159) { __label__ = 12; break; } else { __label__ = 22; break; }
    case 22: // $160
      __label__ = 23; break;
    case 23: // $161
      var $162=$21;
      var $163=(($162) & 1);
      if ($163) { __label__ = 30; break; } else { __label__ = 24; break; }
    case 24: // $164
      var $165=$__nread;
      $__i2=$165;
      __label__ = 25; break;
    case 25: // $166
      var $167=$__i2;
      var $168=(($167)|0) > 0;
      if ($168) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $169
      var $170=$__i2;
      var $171=(($170-1)|0);
      $__i2=$171;
      var $172=(($__extbuf+$171)|0);
      var $173=HEAP8[($172)];
      var $174=(($173 << 24) >> 24);
      var $175=(($24+32)|0);
      var $176=HEAP32[(($175)>>2)];
      var $177=_ungetc($174, $176);
      var $178=(($177)|0)==-1;
      if ($178) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $179
      $19=-1;
      __label__ = 31; break;
    case 28: // $180
      __label__ = 25; break;
    case 29: // $181
      __label__ = 30; break;
    case 30: // $182
      var $183=HEAP8[($__1buf)];
      $9=$183;
      var $184=$9;
      var $185=(($184)&255);
      $19=$185;
      __label__ = 31; break;
    case 31: // $186
      var $187=$19;
      STACKTOP = __stackBase__;
      return $187;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__stdinbufIcE9__getcharEb["X"]=1;

function __ZNSt3__111__stdoutbufIwED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev($3);
  ;
  return;
}


function __ZNSt3__110__stdinbufIwED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev($3);
  ;
  return;
}


function __ZNSt3__111__stdoutbufIcED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($3);
  ;
  return;
}


function __ZNSt3__110__stdinbufIcED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($3);
  ;
  return;
}


function __GLOBAL__I_a1780() {
  ;
  var __label__;

  ___cxx_global_var_init1775();
  ___cxx_global_var_init11776();
  ___cxx_global_var_init21777();
  ___cxx_global_var_init31778();
  ___cxx_global_var_init41779();
  ___cxx_global_var_init5();
  ___cxx_global_var_init6();
  ___cxx_global_var_init7();
  ___cxx_global_var_init8();
  ___cxx_global_var_init9();
  ___cxx_global_var_init10();
  ___cxx_global_var_init11();
  ___cxx_global_var_init12();
  ___cxx_global_var_init13();
  ___cxx_global_var_init14();
  ;
  return;
}


function __ZNSt3__114__shared_countD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__114__shared_countD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__114__shared_count12__add_sharedEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=__ZNSt3__112_GLOBAL__N_19incrementIlEET_RS2_($3);
  ;
  return;
}


function __ZNSt3__114__shared_count16__release_sharedEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $2=$this;
      var $3=$2;
      var $4=(($3+4)|0);
      var $5=__ZNSt3__112_GLOBAL__N_19decrementIlEET_RS2_($4);
      var $6=(($5)|0)==-1;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$3;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9+8)|0);
      var $11=HEAP32[(($10)>>2)];
      FUNCTION_TABLE[$11]($3);
      $1=1;
      __label__ = 3; break;
    case 2: // $12
      $1=0;
      __label__ = 3; break;
    case 3: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt11logic_errorC2EPKc($this, $msg) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $s;
      var $4;
      var $5;
      $2=$this;
      $3=$msg;
      var $6=$2;
      var $7=$6;
      var $8=$1;
      HEAP32[(($1)>>2)]=$7;
      var $9=HEAP32[(($1)>>2)];
      var $10=$9;
      HEAP32[(($10)>>2)]=((__ZTVSt9exception+8)|0);
      var $11=$1;
      var $12=$6;
      HEAP32[(($12)>>2)]=((__ZTVSt11logic_error+8)|0);
      var $13=(($6+4)|0);
      var $14=$13;
      $s=$14;
      var $15=$s;
      var $16=$15;
      var $17=(($16)|0)==0;
      if ($17) { var $23 = 0;__label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$16;
      var $20=$3;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12_GLOBAL__N_114__libcpp_nmstrC1EPKc]($19, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $23 = $19;__label__ = 3; break;
    case 3: // $22
      var $23;
      STACKTOP = __stackBase__;
      return;
    case 4: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $4=$26;
      var $27=$25.f1;
      $5=$27;
      var $28=$6;
      __ZNSt9exceptionD2Ev($28);
      __label__ = 5; break;
    case 5: // $29
      var $30=$4;
      var $31=$4;
      var $32=$5;
      var $33=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31, tempValue);
      var $34=($33.f1 = $32, $33);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt11logic_errorD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt11logic_errorD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt11logic_errorD2Ev($this) {
  ;
  var __label__;

  var $1;
  var $s;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVSt11logic_error+8)|0);
  var $4=(($2+4)|0);
  var $5=$4;
  $s=$5;
  var $6=$s;
  FUNCTION_TABLE[__ZN12_GLOBAL__N_114__libcpp_nmstrD1Ev]($6);
  var $7=$2;
  __ZNSt9exceptionD2Ev($7);
  ;
  return;
}


function __ZNKSt11logic_error4whatEv($this) {
  ;
  var __label__;

  var $1;
  var $s;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=$3;
  $s=$4;
  var $5=$s;
  var $6=__ZNK12_GLOBAL__N_114__libcpp_nmstr5c_strEv($5);
  ;
  return $6;
}


function __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE($this, $msg) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14;
      var $15;
      var $s;
      var $16;
      var $17;
      $14=$this;
      $15=$msg;
      var $18=$14;
      var $19=$18;
      var $20=$13;
      HEAP32[(($13)>>2)]=$19;
      var $21=HEAP32[(($13)>>2)];
      var $22=$21;
      HEAP32[(($22)>>2)]=((__ZTVSt9exception+8)|0);
      var $23=$13;
      var $24=$18;
      HEAP32[(($24)>>2)]=((__ZTVSt13runtime_error+8)|0);
      var $25=(($18+4)|0);
      var $26=$25;
      $s=$26;
      var $27=$s;
      var $28=$27;
      var $29=(($28)|0)==0;
      if ($29) { var $99 = 0;__label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $30
      var $31=$28;
      var $32=$15;
      var $33=$12;
      HEAP32[(($12)>>2)]=$32;
      var $34=HEAP32[(($12)>>2)];
      var $35=$11;
      HEAP32[(($11)>>2)]=$34;
      var $36=HEAP32[(($11)>>2)];
      var $37=$10;
      HEAP32[(($10)>>2)]=$36;
      var $38=HEAPU32[(($10)>>2)];
      var $39=$9;
      HEAP32[(($9)>>2)]=$38;
      var $40=HEAP32[(($9)>>2)];
      var $41=(($40)|0);
      var $42=$8;
      HEAP32[(($8)>>2)]=$41;
      var $43=HEAP32[(($8)>>2)];
      var $44=$43;
      var $45=$7;
      HEAP32[(($7)>>2)]=$44;
      var $46=HEAP32[(($7)>>2)];
      var $47=(($46)|0);
      var $48=$7;
      var $49=$8;
      var $50=(($47)|0);
      var $51=$50;
      var $52=(($51)|0);
      var $53=$52;
      var $54=HEAPU8[($53)];
      var $55=(($54)&255);
      var $56=$55 & 1;
      var $57=(($56)|0)!=0;
      var $58=$9;
      if ($57) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $59
      var $60=$3;
      HEAP32[(($3)>>2)]=$38;
      var $61=HEAP32[(($3)>>2)];
      var $62=(($61)|0);
      var $63=$2;
      HEAP32[(($2)>>2)]=$62;
      var $64=HEAP32[(($2)>>2)];
      var $65=$64;
      var $66=$1;
      HEAP32[(($1)>>2)]=$65;
      var $67=HEAP32[(($1)>>2)];
      var $68=(($67)|0);
      var $69=$1;
      var $70=$2;
      var $71=(($68)|0);
      var $72=$71;
      var $73=(($72+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=$3;
      var $93 = $74;__label__ = 4; break;
    case 3: // $76
      var $77=$6;
      HEAP32[(($6)>>2)]=$38;
      var $78=HEAP32[(($6)>>2)];
      var $79=(($78)|0);
      var $80=$5;
      HEAP32[(($5)>>2)]=$79;
      var $81=HEAP32[(($5)>>2)];
      var $82=$81;
      var $83=$4;
      HEAP32[(($4)>>2)]=$82;
      var $84=HEAP32[(($4)>>2)];
      var $85=(($84)|0);
      var $86=$4;
      var $87=$5;
      var $88=(($85)|0);
      var $89=$88;
      var $90=(($89+1)|0);
      var $91=(($90)|0);
      var $92=$6;
      var $93 = $91;__label__ = 4; break;
    case 4: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit
      var $93;
      var $94=$10;
      var $95=$11;
      var $96=$12;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12_GLOBAL__N_114__libcpp_nmstrC1EPKc]($31, $93) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $97
      var $99 = $31;__label__ = 6; break;
    case 6: // $98
      var $99;
      STACKTOP = __stackBase__;
      return;
    case 7: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $102=$101.f0;
      $16=$102;
      var $103=$101.f1;
      $17=$103;
      var $104=$18;
      __ZNSt9exceptionD2Ev($104);
      __label__ = 8; break;
    case 8: // $105
      var $106=$16;
      var $107=$16;
      var $108=$17;
      var $109=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $107, tempValue);
      var $110=($109.f1 = $108, $109);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE["X"]=1;

function __ZNSt13runtime_errorC2EPKc($this, $msg) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $s;
      var $4;
      var $5;
      $2=$this;
      $3=$msg;
      var $6=$2;
      var $7=$6;
      var $8=$1;
      HEAP32[(($1)>>2)]=$7;
      var $9=HEAP32[(($1)>>2)];
      var $10=$9;
      HEAP32[(($10)>>2)]=((__ZTVSt9exception+8)|0);
      var $11=$1;
      var $12=$6;
      HEAP32[(($12)>>2)]=((__ZTVSt13runtime_error+8)|0);
      var $13=(($6+4)|0);
      var $14=$13;
      $s=$14;
      var $15=$s;
      var $16=$15;
      var $17=(($16)|0)==0;
      if ($17) { var $23 = 0;__label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$16;
      var $20=$3;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN12_GLOBAL__N_114__libcpp_nmstrC1EPKc]($19, $20) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $23 = $19;__label__ = 3; break;
    case 3: // $22
      var $23;
      STACKTOP = __stackBase__;
      return;
    case 4: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $26=$25.f0;
      $4=$26;
      var $27=$25.f1;
      $5=$27;
      var $28=$6;
      __ZNSt9exceptionD2Ev($28);
      __label__ = 5; break;
    case 5: // $29
      var $30=$4;
      var $31=$4;
      var $32=$5;
      var $33=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $31, tempValue);
      var $34=($33.f1 = $32, $33);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt13runtime_errorD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt13runtime_errorD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt13runtime_errorD2Ev($this) {
  ;
  var __label__;

  var $1;
  var $s;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVSt13runtime_error+8)|0);
  var $4=(($2+4)|0);
  var $5=$4;
  $s=$5;
  var $6=$s;
  FUNCTION_TABLE[__ZN12_GLOBAL__N_114__libcpp_nmstrD1Ev]($6);
  var $7=$2;
  __ZNSt9exceptionD2Ev($7);
  ;
  return;
}


function __ZNKSt13runtime_error4whatEv($this) {
  ;
  var __label__;

  var $1;
  var $s;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=$3;
  $s=$4;
  var $5=$s;
  var $6=__ZNK12_GLOBAL__N_114__libcpp_nmstr5c_strEv($5);
  ;
  return $6;
}


function __ZNSt12length_errorD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt12length_errorD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=__ZNK12_GLOBAL__N_114__libcpp_nmstr5countEv($2);
      var $4=(tempValue=HEAP32[(($3)>>2)],HEAP32[(($3)>>2)]=tempValue+-1,tempValue);
      var $5=(($4-1)|0);
      var $6=(($5)|0) < 0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=(($2)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9-12)|0);
      var $11=(($10)|0)==0;
      if ($11) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $12
      __ZdaPv($10);
      __label__ = 3; break;
    case 3: // $13
      __label__ = 4; break;
    case 4: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN12_GLOBAL__N_114__libcpp_nmstrC2EPKc($this, $msg) {
  ;
  var __label__;

  var $1;
  var $2;
  var $len;
  var $c;
  $1=$this;
  $2=$msg;
  var $3=$1;
  var $4=$2;
  var $5=_strlen($4);
  $len=$5;
  var $6=$len;
  var $7=(($6+1)|0);
  var $8=(($7+12)|0);
  var $9=__Znaj($8);
  var $10=(($3)|0);
  HEAP32[(($10)>>2)]=$9;
  var $11=(($3)|0);
  var $12=HEAP32[(($11)>>2)];
  var $13=$12;
  $c=$13;
  var $14=$len;
  var $15=$c;
  var $16=(($15+4)|0);
  HEAP32[(($16)>>2)]=$14;
  var $17=$c;
  var $18=(($17)|0);
  HEAP32[(($18)>>2)]=$14;
  var $19=(($3)|0);
  var $20=HEAP32[(($19)>>2)];
  var $21=(($20+12)|0);
  HEAP32[(($19)>>2)]=$21;
  var $22=__ZNK12_GLOBAL__N_114__libcpp_nmstr5countEv($3);
  HEAP32[(($22)>>2)]=0;
  var $23=__ZNK12_GLOBAL__N_114__libcpp_nmstr5c_strEv($3);
  var $24=$2;
  var $25=_strcpy($23, $24);
  ;
  return;
}


function __ZNSt3__114error_categoryD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt3__114error_categoryD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNKSt3__114error_category23default_error_conditionEi($agg_result, $this, $ev) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7;
  var $8;
  $7=$this;
  $8=$ev;
  var $9=$7;
  var $10=$8;
  var $11=$4;
  var $12=$5;
  var $13=$6;
  HEAP32[(($4)>>2)]=$agg_result;
  HEAP32[(($5)>>2)]=$10;
  HEAP32[(($6)>>2)]=$9;
  var $14=HEAP32[(($4)>>2)];
  var $15=HEAP32[(($5)>>2)];
  var $16=HEAP32[(($6)>>2)];
  var $17=$1;
  var $18=$2;
  var $19=$3;
  HEAP32[(($1)>>2)]=$14;
  HEAP32[(($2)>>2)]=$15;
  HEAP32[(($3)>>2)]=$16;
  var $20=HEAP32[(($1)>>2)];
  var $21=(($20)|0);
  var $22=HEAP32[(($2)>>2)];
  HEAP32[(($21)>>2)]=$22;
  var $23=(($20+4)|0);
  var $24=HEAP32[(($3)>>2)];
  HEAP32[(($23)>>2)]=$24;
  var $25=$1;
  var $26=$2;
  var $27=$3;
  var $28=$4;
  var $29=$5;
  var $30=$6;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__114error_category10equivalentERKNS_10error_codeEi($this, $code, $condition) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      var $7;
      $5=$this;
      $6=$code;
      $7=$condition;
      var $8=$5;
      var $9=$6;
      var $10=$4;
      HEAP32[(($4)>>2)]=$9;
      var $11=HEAP32[(($4)>>2)];
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$4;
      var $15=$1;
      var $16=$2;
      HEAP32[(($1)>>2)]=$8;
      HEAP32[(($2)>>2)]=$13;
      var $17=HEAP32[(($1)>>2)];
      var $18=HEAP32[(($2)>>2)];
      var $19=(($17)|0)==(($18)|0);
      var $20=$1;
      var $21=$2;
      if ($19) { __label__ = 1; break; } else { var $32 = 0;__label__ = 2; break; }
    case 1: // $22
      var $23=$6;
      var $24=$3;
      HEAP32[(($3)>>2)]=$23;
      var $25=HEAP32[(($3)>>2)];
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$3;
      var $29=$7;
      var $30=(($27)|0)==(($29)|0);
      var $32 = $30;__label__ = 2; break;
    case 2: // $31
      var $32;
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE($this, $code, $condition) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      var $11;
      var $12=__stackBase__+32;
      $9=$this;
      $10=$code;
      $11=$condition;
      var $13=$9;
      var $14=$13;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15+12)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$10;
      FUNCTION_TABLE[$17]($12, $13, $18);
      var $19=$11;
      var $20=$7;
      var $21=$8;
      HEAP32[(($7)>>2)]=$12;
      HEAP32[(($8)>>2)]=$19;
      var $22=HEAP32[(($7)>>2)];
      var $23=$6;
      HEAP32[(($6)>>2)]=$22;
      var $24=HEAP32[(($6)>>2)];
      var $25=(($24+4)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$6;
      var $28=HEAP32[(($8)>>2)];
      var $29=$1;
      HEAP32[(($1)>>2)]=$28;
      var $30=HEAP32[(($1)>>2)];
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=$1;
      var $34=$2;
      var $35=$3;
      HEAP32[(($2)>>2)]=$26;
      HEAP32[(($3)>>2)]=$32;
      var $36=HEAP32[(($2)>>2)];
      var $37=HEAP32[(($3)>>2)];
      var $38=(($36)|0)==(($37)|0);
      var $39=$2;
      var $40=$3;
      if ($38) { __label__ = 1; break; } else { var $55 = 0;__label__ = 2; break; }
    case 1: // $41
      var $42=HEAP32[(($7)>>2)];
      var $43=$4;
      HEAP32[(($4)>>2)]=$42;
      var $44=HEAP32[(($4)>>2)];
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$4;
      var $48=HEAP32[(($8)>>2)];
      var $49=$5;
      HEAP32[(($5)>>2)]=$48;
      var $50=HEAP32[(($5)>>2)];
      var $51=(($50)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$5;
      var $54=(($46)|0)==(($52)|0);
      var $55 = $54;__label__ = 2; break;
    case 2: // $_ZNSt3__1eqERKNS_15error_conditionES2__exit
      var $55;
      var $56=$7;
      var $57=$8;
      STACKTOP = __stackBase__;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE["X"]=1;

function __ZNKSt3__112__do_message7messageEi($agg_result, $this, $ev) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10;
  var $11;
  $10=$this;
  $11=$ev;
  var $12=$10;
  var $13=$11;
  var $14=_strerror($13);
  var $15=$8;
  var $16=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=$14;
  var $17=HEAP32[(($8)>>2)];
  var $18=HEAP32[(($9)>>2)];
  var $19=$6;
  var $20=$7;
  HEAP32[(($6)>>2)]=$17;
  HEAP32[(($7)>>2)]=$18;
  var $21=HEAP32[(($6)>>2)];
  var $22=$21;
  var $23=(($21)|0);
  var $24=$5;
  HEAP32[(($5)>>2)]=$23;
  var $25=HEAP32[(($5)>>2)];
  var $26=$4;
  HEAP32[(($4)>>2)]=$25;
  var $27=HEAP32[(($4)>>2)];
  var $28=$27;
  var $29=$3;
  HEAP32[(($3)>>2)]=$28;
  var $30=HEAP32[(($3)>>2)];
  var $31=$30;
  var $32=$2;
  HEAP32[(($2)>>2)]=$31;
  var $33=HEAP32[(($2)>>2)];
  var $34=$2;
  var $35=(($30)|0);
  var $36=$3;
  var $37=$4;
  var $38=$5;
  var $39=HEAP32[(($7)>>2)];
  var $40=HEAP32[(($7)>>2)];
  var $41=$1;
  HEAP32[(($1)>>2)]=$40;
  var $42=HEAP32[(($1)>>2)];
  var $43=_strlen($42);
  var $44=$1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($21, $39, $43);
  var $45=$6;
  var $46=$7;
  var $47=$8;
  var $48=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__112__do_message7messageEi["X"]=1;

function __ZNKSt3__110error_code7messageEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+4)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=HEAP32[(($5)>>2)];
  var $7=(($6+24)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=(($2)|0);
  var $10=HEAP32[(($9)>>2)];
  FUNCTION_TABLE[$8]($agg_result, $4, $10);
  ;
  return;
}


function __ZNSt3__112system_errorD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt3__112system_errorD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt3__112system_errorD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt13runtime_errorD2Ev($3);
  ;
  return;
}


function __ZNSt3__112__do_messageD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__112__do_messageD2Ev($2);
  ;
  return;
}


function __ZNSt3__112__do_messageD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__112__do_messageD1Ev($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE($agg_result, $ec, $what_arg) {
  var __stackBase__  = STACKTOP; STACKTOP += 172; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41;
      var $42=__stackBase__+160;
      var $43;
      var $44;
      $41=$ec;
      var $45=$41;
      var $46=$40;
      HEAP32[(($40)>>2)]=$45;
      var $47=HEAP32[(($40)>>2)];
      var $48=(($47)|0);
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49)|0)!=0;
      var $51=$40;
      if ($50) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $52
      var $53=$13;
      HEAP32[(($13)>>2)]=$what_arg;
      var $54=HEAP32[(($13)>>2)];
      var $55=$12;
      HEAP32[(($12)>>2)]=$54;
      var $56=HEAPU32[(($12)>>2)];
      var $57=$11;
      HEAP32[(($11)>>2)]=$56;
      var $58=HEAP32[(($11)>>2)];
      var $59=(($58)|0);
      var $60=$10;
      HEAP32[(($10)>>2)]=$59;
      var $61=HEAP32[(($10)>>2)];
      var $62=$61;
      var $63=$9;
      HEAP32[(($9)>>2)]=$62;
      var $64=HEAP32[(($9)>>2)];
      var $65=(($64)|0);
      var $66=$9;
      var $67=$10;
      var $68=(($65)|0);
      var $69=$68;
      var $70=(($69)|0);
      var $71=$70;
      var $72=HEAPU8[($71)];
      var $73=(($72)&255);
      var $74=$73 & 1;
      var $75=(($74)|0)!=0;
      var $76=$11;
      if ($75) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $77
      var $78=$5;
      HEAP32[(($5)>>2)]=$56;
      var $79=HEAP32[(($5)>>2)];
      var $80=(($79)|0);
      var $81=$4;
      HEAP32[(($4)>>2)]=$80;
      var $82=HEAP32[(($4)>>2)];
      var $83=$82;
      var $84=$3;
      HEAP32[(($3)>>2)]=$83;
      var $85=HEAP32[(($3)>>2)];
      var $86=(($85)|0);
      var $87=$3;
      var $88=$4;
      var $89=(($86)|0);
      var $90=$89;
      var $91=(($90+4)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=$5;
      var $114 = $92;__label__ = 4; break;
    case 3: // $94
      var $95=$8;
      HEAP32[(($8)>>2)]=$56;
      var $96=HEAP32[(($8)>>2)];
      var $97=(($96)|0);
      var $98=$7;
      HEAP32[(($7)>>2)]=$97;
      var $99=HEAP32[(($7)>>2)];
      var $100=$99;
      var $101=$6;
      HEAP32[(($6)>>2)]=$100;
      var $102=HEAP32[(($6)>>2)];
      var $103=(($102)|0);
      var $104=$6;
      var $105=$7;
      var $106=(($103)|0);
      var $107=$106;
      var $108=(($107)|0);
      var $109=$108;
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$111 >> 1;
      var $113=$8;
      var $114 = $112;__label__ = 4; break;
    case 4: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $114;
      var $115=$12;
      var $116=(($114)|0)==0;
      var $117=$13;
      if ($116) { __label__ = 6; break; } else { __label__ = 5; break; }
    case 5: // $118
      var $119=$1;
      var $120=$2;
      HEAP32[(($1)>>2)]=$what_arg;
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str2341593)|0);
      var $121=HEAP32[(($1)>>2)];
      var $122=HEAP32[(($2)>>2)];
      var $123=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc($121, $122);
      var $124=$1;
      var $125=$2;
      __label__ = 6; break;
    case 6: // $126
      var $127=$41;
      __ZNKSt3__110error_code7messageEv($42, $127);
      var $128=$37;
      var $129=$38;
      HEAP32[(($37)>>2)]=$what_arg;
      HEAP32[(($38)>>2)]=$42;
      var $130=HEAP32[(($37)>>2)];
      var $131=HEAP32[(($38)>>2)];
      var $132=$35;
      var $133=$36;
      HEAP32[(($35)>>2)]=$130;
      HEAP32[(($36)>>2)]=$131;
      var $134=HEAP32[(($35)>>2)];
      var $135=HEAP32[(($36)>>2)];
      var $136=$34;
      HEAP32[(($34)>>2)]=$135;
      var $137=HEAP32[(($34)>>2)];
      var $138=$33;
      HEAP32[(($33)>>2)]=$137;
      var $139=HEAPU32[(($33)>>2)];
      var $140=$32;
      HEAP32[(($32)>>2)]=$139;
      var $141=HEAP32[(($32)>>2)];
      var $142=(($141)|0);
      var $143=$31;
      HEAP32[(($31)>>2)]=$142;
      var $144=HEAP32[(($31)>>2)];
      var $145=$144;
      var $146=$30;
      HEAP32[(($30)>>2)]=$145;
      var $147=HEAP32[(($30)>>2)];
      var $148=(($147)|0);
      var $149=$30;
      var $150=$31;
      var $151=(($148)|0);
      var $152=$151;
      var $153=(($152)|0);
      var $154=$153;
      var $155=HEAPU8[($154)];
      var $156=(($155)&255);
      var $157=$156 & 1;
      var $158=(($157)|0)!=0;
      var $159=$32;
      if ($158) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $160
      var $161=$26;
      HEAP32[(($26)>>2)]=$139;
      var $162=HEAP32[(($26)>>2)];
      var $163=(($162)|0);
      var $164=$25;
      HEAP32[(($25)>>2)]=$163;
      var $165=HEAP32[(($25)>>2)];
      var $166=$165;
      var $167=$24;
      HEAP32[(($24)>>2)]=$166;
      var $168=HEAP32[(($24)>>2)];
      var $169=(($168)|0);
      var $170=$24;
      var $171=$25;
      var $172=(($169)|0);
      var $173=$172;
      var $174=(($173+8)|0);
      var $175=HEAP32[(($174)>>2)];
      var $176=$26;
      var $194 = $175;__label__ = 9; break;
    case 8: // $177
      var $178=$29;
      HEAP32[(($29)>>2)]=$139;
      var $179=HEAP32[(($29)>>2)];
      var $180=(($179)|0);
      var $181=$28;
      HEAP32[(($28)>>2)]=$180;
      var $182=HEAP32[(($28)>>2)];
      var $183=$182;
      var $184=$27;
      HEAP32[(($27)>>2)]=$183;
      var $185=HEAP32[(($27)>>2)];
      var $186=(($185)|0);
      var $187=$27;
      var $188=$28;
      var $189=(($186)|0);
      var $190=$189;
      var $191=(($190+1)|0);
      var $192=(($191)|0);
      var $193=$29;
      var $194 = $192;__label__ = 9; break;
    case 9: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit_i_i
      var $194;
      var $195=$33;
      var $196=$34;
      var $197=HEAP32[(($36)>>2)];
      var $198=$23;
      HEAP32[(($23)>>2)]=$197;
      var $199=HEAPU32[(($23)>>2)];
      var $200=$22;
      HEAP32[(($22)>>2)]=$199;
      var $201=HEAP32[(($22)>>2)];
      var $202=(($201)|0);
      var $203=$21;
      HEAP32[(($21)>>2)]=$202;
      var $204=HEAP32[(($21)>>2)];
      var $205=$204;
      var $206=$20;
      HEAP32[(($20)>>2)]=$205;
      var $207=HEAP32[(($20)>>2)];
      var $208=(($207)|0);
      var $209=$20;
      var $210=$21;
      var $211=(($208)|0);
      var $212=$211;
      var $213=(($212)|0);
      var $214=$213;
      var $215=HEAPU8[($214)];
      var $216=(($215)&255);
      var $217=$216 & 1;
      var $218=(($217)|0)!=0;
      var $219=$22;
      if ($218) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $220
      var $221=$16;
      HEAP32[(($16)>>2)]=$199;
      var $222=HEAP32[(($16)>>2)];
      var $223=(($222)|0);
      var $224=$15;
      HEAP32[(($15)>>2)]=$223;
      var $225=HEAP32[(($15)>>2)];
      var $226=$225;
      var $227=$14;
      HEAP32[(($14)>>2)]=$226;
      var $228=HEAP32[(($14)>>2)];
      var $229=(($228)|0);
      var $230=$14;
      var $231=$15;
      var $232=(($229)|0);
      var $233=$232;
      var $234=(($233+4)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=$16;
      var $257 = $235;__label__ = 12; break;
    case 11: // $237
      var $238=$19;
      HEAP32[(($19)>>2)]=$199;
      var $239=HEAP32[(($19)>>2)];
      var $240=(($239)|0);
      var $241=$18;
      HEAP32[(($18)>>2)]=$240;
      var $242=HEAP32[(($18)>>2)];
      var $243=$242;
      var $244=$17;
      HEAP32[(($17)>>2)]=$243;
      var $245=HEAP32[(($17)>>2)];
      var $246=(($245)|0);
      var $247=$17;
      var $248=$18;
      var $249=(($246)|0);
      var $250=$249;
      var $251=(($250)|0);
      var $252=$251;
      var $253=HEAPU8[($252)];
      var $254=(($253)&255);
      var $255=$254 >> 1;
      var $256=$19;
      var $257 = $255;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5__exit_i
      var $257;
      var $258=$23;
      var $259=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj($134, $194, $257) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLERKS5__exit
      var $260=$35;
      var $261=$36;
      var $262=$37;
      var $263=$38;
      __label__ = 14; break;
    case 14: // $264
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($42);
      __label__ = 17; break;
    case 15: // $265
      var $266=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $267=$266.f0;
      $43=$267;
      var $268=$266.f1;
      $44=$268;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $269
      __label__ = 18; break;
    case 17: // $270
      var $271=$39;
      HEAP32[(($39)>>2)]=$what_arg;
      var $272=HEAP32[(($39)>>2)];
      var $273=$39;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($agg_result, $272);
      STACKTOP = __stackBase__;
      return;
    case 18: // $274
      var $275=$43;
      var $276=$43;
      var $277=$44;
      var $278=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $276, tempValue);
      var $279=($278.f1 = $277, $278);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $280
      var $281=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE["X"]=1;

function __ZNSt3__112system_errorC2ENS_10error_codeEPKc($this, $ec, $what_arg) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $ec; $ec = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($ec)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($ec+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12=__stackBase__+36;
      var $13=__stackBase__+48;
      var $14;
      var $15;
      $10=$this;
      $11=$what_arg;
      var $16=$10;
      var $17=$16;
      var $18=$11;
      var $19=$8;
      var $20=$9;
      HEAP32[(($8)>>2)]=$13;
      HEAP32[(($9)>>2)]=$18;
      var $21=HEAP32[(($8)>>2)];
      var $22=HEAP32[(($9)>>2)];
      var $23=$6;
      var $24=$7;
      HEAP32[(($6)>>2)]=$21;
      HEAP32[(($7)>>2)]=$22;
      var $25=HEAP32[(($6)>>2)];
      var $26=$25;
      var $27=(($25)|0);
      var $28=$5;
      HEAP32[(($5)>>2)]=$27;
      var $29=HEAP32[(($5)>>2)];
      var $30=$4;
      HEAP32[(($4)>>2)]=$29;
      var $31=HEAP32[(($4)>>2)];
      var $32=$31;
      var $33=$3;
      HEAP32[(($3)>>2)]=$32;
      var $34=HEAP32[(($3)>>2)];
      var $35=$34;
      var $36=$2;
      HEAP32[(($2)>>2)]=$35;
      var $37=HEAP32[(($2)>>2)];
      var $38=$2;
      var $39=(($34)|0);
      var $40=$3;
      var $41=$4;
      var $42=$5;
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($7)>>2)];
      var $45=$1;
      HEAP32[(($1)>>2)]=$44;
      var $46=HEAP32[(($1)>>2)];
      var $47=_strlen($46);
      var $48=$1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($25, $43, $47);
      var $49=$6;
      var $50=$7;
      var $51=$8;
      var $52=$9;
      (function() { try { __THREW__ = false; return __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE($12, $ec, $13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $53
      (function() { try { __THREW__ = false; return __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE($17, $12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $54
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $55
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($13);
      var $56=$16;
      HEAP32[(($56)>>2)]=((__ZTVNSt3__112system_errorE+8)|0);
      var $57=(($16+8)|0);
      var $58=$57;
      var $59=$ec;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($58)>>2)]=HEAP32[(($59)>>2)];HEAP32[(($58+4)>>2)]=HEAP32[(($59+4)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 4: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $62=$61.f0;
      $14=$62;
      var $63=$61.f1;
      $15=$63;
      __label__ = 7; break;
    case 5: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $66=$65.f0;
      $14=$66;
      var $67=$65.f1;
      $15=$67;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $68
      __label__ = 7; break;
    case 7: // $69
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; }
    case 8: // $70
      __label__ = 9; break;
    case 9: // $71
      var $72=$14;
      var $73=$14;
      var $74=$15;
      var $75=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $73, tempValue);
      var $76=($75.f1 = $74, $75);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $77
      var $78=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112system_errorC2ENS_10error_codeEPKc["X"]=1;
// WARNING: content after a branch in a label, line: 796590

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($this, $__str) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__str;
  var $3=$1;
  var $4=$2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_($3, $4);
  ;
  return;
}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_($this, $__str) {
  var __stackBase__  = STACKTOP; STACKTOP += 132; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $__t21_i=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32;
      var $33;
      var $34=__stackBase__+128;
      $32=$this;
      $33=$__str;
      var $35=$32;
      var $36=$35;
      var $37=(($35)|0);
      var $38=$33;
      var $39=$31;
      HEAP32[(($31)>>2)]=$38;
      var $40=HEAP32[(($31)>>2)];
      var $41=(($40)|0);
      var $42=$30;
      HEAP32[(($30)>>2)]=$41;
      var $43=HEAP32[(($30)>>2)];
      var $44=$43;
      var $45=$29;
      HEAP32[(($29)>>2)]=$44;
      var $46=HEAP32[(($29)>>2)];
      var $47=$46;
      var $48=$29;
      var $49=$30;
      var $50=$31;
      var $51=$25;
      var $52=$26;
      var $53=$27;
      var $54=$28;
      HEAP32[(($26)>>2)]=$47;
      var $55=$28;
      var $56=HEAP32[(($26)>>2)];
      var $tmp_i=$25;
      var $tmp1_i=$27;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $57=$24;
      HEAP32[(($24)>>2)]=$56;
      var $58=HEAP32[(($24)>>2)];
      var $59=$24;
      var $60=$25;
      var $61=$26;
      var $62=$27;
      var $63=$28;
      var $tmp=$10;
      var $tmp1=$34;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];
      var $64=$__t21_i;
      var $65=$8;
      var $66=$9;
      HEAP32[(($8)>>2)]=$37;
      HEAP32[(($9)>>2)]=0;
      var $67=HEAP32[(($8)>>2)];
      var $68=HEAP32[(($9)>>2)];
      var $tmp_i2=$__t21_i;
      var $tmp2_i=$10;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i2)]=HEAP8[($tmp2_i)];
      var $69=$3;
      var $70=$5;
      var $71=$6;
      var $72=$7;
      HEAP32[(($5)>>2)]=$67;
      HEAP32[(($6)>>2)]=$68;
      var $73=HEAP32[(($5)>>2)];
      var $74=$73;
      var $75=$4;
      HEAP32[(($4)>>2)]=$__t21_i;
      var $76=HEAP32[(($4)>>2)];
      var $77=$4;
      var $tmp_i_i=$3;
      var $tmp1_i_i=$7;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $78=$2;
      HEAP32[(($2)>>2)]=$74;
      var $79=HEAP32[(($2)>>2)];
      var $80=$79;
      var $81=$1;
      HEAP32[(($1)>>2)]=$3;
      var $82=HEAP32[(($1)>>2)];
      var $83=$1;
      var $84=(($79)|0);
      var $85=$2;
      var $86=$3;
      var $87=$5;
      var $88=$6;
      var $89=$7;
      var $90=$__t21_i;
      var $91=$8;
      var $92=$9;
      var $93=$33;
      var $94=$13;
      HEAP32[(($13)>>2)]=$93;
      var $95=HEAP32[(($13)>>2)];
      var $96=(($95)|0);
      var $97=$12;
      HEAP32[(($12)>>2)]=$96;
      var $98=HEAP32[(($12)>>2)];
      var $99=$98;
      var $100=$11;
      HEAP32[(($11)>>2)]=$99;
      var $101=HEAP32[(($11)>>2)];
      var $102=(($101)|0);
      var $103=$11;
      var $104=$12;
      var $105=(($102)|0);
      var $106=$105;
      var $107=(($106)|0);
      var $108=$107;
      var $109=HEAPU8[($108)];
      var $110=(($109)&255);
      var $111=$110 & 1;
      var $112=(($111)|0)!=0;
      var $113=$13;
      if ($112) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $114
      var $115=(($35)|0);
      var $116=$15;
      HEAP32[(($15)>>2)]=$115;
      var $117=HEAP32[(($15)>>2)];
      var $118=$117;
      var $119=$14;
      HEAP32[(($14)>>2)]=$118;
      var $120=HEAP32[(($14)>>2)];
      var $121=(($120)|0);
      var $122=$14;
      var $123=$15;
      var $124=(($121)|0);
      var $125=$124;
      var $126=$33;
      var $127=(($126)|0);
      var $128=$17;
      HEAP32[(($17)>>2)]=$127;
      var $129=HEAP32[(($17)>>2)];
      var $130=$129;
      var $131=$16;
      HEAP32[(($16)>>2)]=$130;
      var $132=HEAP32[(($16)>>2)];
      var $133=(($132)|0);
      var $134=$16;
      var $135=$17;
      var $136=(($133)|0);
      var $137=$136;
      var $138=$125;
      var $139=$137;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($138)>>2)]=HEAP32[(($139)>>2)];HEAP32[(($138+4)>>2)]=HEAP32[(($139+4)>>2)];HEAP32[(($138+8)>>2)]=HEAP32[(($139+8)>>2)];
      __label__ = 3; break;
    case 2: // $140
      var $141=$33;
      var $142=$20;
      HEAP32[(($20)>>2)]=$141;
      var $143=HEAP32[(($20)>>2)];
      var $144=(($143)|0);
      var $145=$19;
      HEAP32[(($19)>>2)]=$144;
      var $146=HEAP32[(($19)>>2)];
      var $147=$146;
      var $148=$18;
      HEAP32[(($18)>>2)]=$147;
      var $149=HEAP32[(($18)>>2)];
      var $150=(($149)|0);
      var $151=$18;
      var $152=$19;
      var $153=(($150)|0);
      var $154=$153;
      var $155=(($154+8)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$20;
      var $158=$33;
      var $159=$23;
      HEAP32[(($23)>>2)]=$158;
      var $160=HEAP32[(($23)>>2)];
      var $161=(($160)|0);
      var $162=$22;
      HEAP32[(($22)>>2)]=$161;
      var $163=HEAP32[(($22)>>2)];
      var $164=$163;
      var $165=$21;
      HEAP32[(($21)>>2)]=$164;
      var $166=HEAP32[(($21)>>2)];
      var $167=(($166)|0);
      var $168=$21;
      var $169=$22;
      var $170=(($167)|0);
      var $171=$170;
      var $172=(($171+4)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=$23;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($35, $156, $173);
      __label__ = 3; break;
    case 3: // $175
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($this, $__s, $__sz) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $__m_i=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47;
      var $48;
      var $49;
      var $__p;
      var $__cap;
      var $50=__stackBase__+188;
      $47=$this;
      $48=$__s;
      $49=$__sz;
      var $51=$47;
      var $52=$49;
      var $53=$44;
      var $54=$__m_i;
      var $55=$45;
      var $56=$46;
      HEAP32[(($44)>>2)]=$51;
      var $57=HEAP32[(($44)>>2)];
      var $58=$43;
      HEAP32[(($43)>>2)]=$57;
      var $59=HEAP32[(($43)>>2)];
      var $60=(($59)|0);
      var $61=$42;
      HEAP32[(($42)>>2)]=$60;
      var $62=HEAP32[(($42)>>2)];
      var $63=$62;
      var $64=$41;
      HEAP32[(($41)>>2)]=$63;
      var $65=HEAP32[(($41)>>2)];
      var $66=$65;
      var $67=$41;
      var $68=$42;
      var $69=$43;
      var $70=$37;
      var $71=$38;
      var $72=$39;
      var $73=$40;
      HEAP32[(($38)>>2)]=$66;
      var $74=$40;
      var $75=HEAP32[(($38)>>2)];
      var $tmp_i_i=$37;
      var $tmp1_i_i=$39;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $76=$36;
      HEAP32[(($36)>>2)]=$75;
      var $77=HEAP32[(($36)>>2)];
      var $78=$35;
      HEAP32[(($35)>>2)]=$77;
      var $79=HEAP32[(($35)>>2)];
      var $80=$35;
      var $81=$36;
      var $82=$37;
      var $83=$38;
      var $84=$39;
      var $85=$40;
      HEAP32[(($__m_i)>>2)]=-1;
      var $86=HEAP32[(($__m_i)>>2)];
      var $87=(($86-1)|0);
      var $88=$44;
      var $89=$__m_i;
      var $90=$45;
      var $91=$46;
      var $92=(($52)>>>0) > (($87)>>>0);
      if ($92) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $93
      var $94=$51;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($94);
      __label__ = 2; break;
    case 2: // $95
      var $96=$49;
      var $97=(($96)>>>0) < 11;
      if ($97) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $98
      var $99=$49;
      var $100=$11;
      var $101=$12;
      HEAP32[(($11)>>2)]=$51;
      HEAP32[(($12)>>2)]=$99;
      var $102=HEAP32[(($11)>>2)];
      var $103=HEAP32[(($12)>>2)];
      var $104=$103 << 1;
      var $105=(($104) & 255);
      var $106=(($102)|0);
      var $107=$10;
      HEAP32[(($10)>>2)]=$106;
      var $108=HEAP32[(($10)>>2)];
      var $109=$108;
      var $110=$9;
      HEAP32[(($9)>>2)]=$109;
      var $111=HEAP32[(($9)>>2)];
      var $112=(($111)|0);
      var $113=$9;
      var $114=$10;
      var $115=(($112)|0);
      var $116=$115;
      var $117=(($116)|0);
      var $118=$117;
      HEAP8[($118)]=$105;
      var $119=$11;
      var $120=$12;
      var $121=$3;
      HEAP32[(($3)>>2)]=$51;
      var $122=HEAP32[(($3)>>2)];
      var $123=(($122)|0);
      var $124=$2;
      HEAP32[(($2)>>2)]=$123;
      var $125=HEAP32[(($2)>>2)];
      var $126=$125;
      var $127=$1;
      HEAP32[(($1)>>2)]=$126;
      var $128=HEAP32[(($1)>>2)];
      var $129=(($128)|0);
      var $130=$1;
      var $131=$2;
      var $132=(($129)|0);
      var $133=$132;
      var $134=(($133+1)|0);
      var $135=(($134)|0);
      var $136=$3;
      $__p=$135;
      __label__ = 8; break;
    case 4: // $137
      var $138=$49;
      var $139=$5;
      HEAP32[(($5)>>2)]=$138;
      var $140=HEAPU32[(($5)>>2)];
      var $141=(($140)>>>0) < 11;
      if ($141) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $142
      var $151 = 11;__label__ = 7; break;
    case 6: // $143
      var $144=HEAP32[(($5)>>2)];
      var $145=(($144+1)|0);
      var $146=$4;
      HEAP32[(($4)>>2)]=$145;
      var $147=HEAP32[(($4)>>2)];
      var $148=(($147+15)|0);
      var $149=$148 & -16;
      var $150=$4;
      var $151 = $149;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj_exit
      var $151;
      var $152=(($151-1)|0);
      var $153=$5;
      $__cap=$152;
      var $154=$8;
      HEAP32[(($8)>>2)]=$51;
      var $155=HEAP32[(($8)>>2)];
      var $156=(($155)|0);
      var $157=$7;
      HEAP32[(($7)>>2)]=$156;
      var $158=HEAP32[(($7)>>2)];
      var $159=$158;
      var $160=$6;
      HEAP32[(($6)>>2)]=$159;
      var $161=HEAP32[(($6)>>2)];
      var $162=$161;
      var $163=$6;
      var $164=$7;
      var $165=$8;
      var $166=$__cap;
      var $167=(($166+1)|0);
      var $168=$16;
      var $169=$17;
      HEAP32[(($16)>>2)]=$162;
      HEAP32[(($17)>>2)]=$167;
      var $170=HEAP32[(($16)>>2)];
      var $171=HEAP32[(($17)>>2)];
      var $172=$13;
      var $173=$14;
      var $174=$15;
      HEAP32[(($13)>>2)]=$170;
      HEAP32[(($14)>>2)]=$171;
      HEAP32[(($15)>>2)]=0;
      var $175=HEAP32[(($13)>>2)];
      var $176=HEAP32[(($14)>>2)];
      var $177=(($176)|0);
      var $178=__Znwj($177);
      var $179=$13;
      var $180=$14;
      var $181=$15;
      var $182=$16;
      var $183=$17;
      $__p=$178;
      var $184=$__p;
      var $185=$20;
      var $186=$21;
      HEAP32[(($20)>>2)]=$51;
      HEAP32[(($21)>>2)]=$184;
      var $187=HEAP32[(($20)>>2)];
      var $188=HEAP32[(($21)>>2)];
      var $189=(($187)|0);
      var $190=$19;
      HEAP32[(($19)>>2)]=$189;
      var $191=HEAP32[(($19)>>2)];
      var $192=$191;
      var $193=$18;
      HEAP32[(($18)>>2)]=$192;
      var $194=HEAP32[(($18)>>2)];
      var $195=(($194)|0);
      var $196=$18;
      var $197=$19;
      var $198=(($195)|0);
      var $199=$198;
      var $200=(($199+8)|0);
      HEAP32[(($200)>>2)]=$188;
      var $201=$20;
      var $202=$21;
      var $203=$__cap;
      var $204=(($203+1)|0);
      var $205=$24;
      var $206=$25;
      HEAP32[(($24)>>2)]=$51;
      HEAP32[(($25)>>2)]=$204;
      var $207=HEAP32[(($24)>>2)];
      var $208=HEAP32[(($25)>>2)];
      var $209=1 | $208;
      var $210=(($207)|0);
      var $211=$23;
      HEAP32[(($23)>>2)]=$210;
      var $212=HEAP32[(($23)>>2)];
      var $213=$212;
      var $214=$22;
      HEAP32[(($22)>>2)]=$213;
      var $215=HEAP32[(($22)>>2)];
      var $216=(($215)|0);
      var $217=$22;
      var $218=$23;
      var $219=(($216)|0);
      var $220=$219;
      var $221=(($220)|0);
      HEAP32[(($221)>>2)]=$209;
      var $222=$24;
      var $223=$25;
      var $224=$49;
      var $225=$28;
      var $226=$29;
      HEAP32[(($28)>>2)]=$51;
      HEAP32[(($29)>>2)]=$224;
      var $227=HEAP32[(($28)>>2)];
      var $228=HEAP32[(($29)>>2)];
      var $229=(($227)|0);
      var $230=$27;
      HEAP32[(($27)>>2)]=$229;
      var $231=HEAP32[(($27)>>2)];
      var $232=$231;
      var $233=$26;
      HEAP32[(($26)>>2)]=$232;
      var $234=HEAP32[(($26)>>2)];
      var $235=(($234)|0);
      var $236=$26;
      var $237=$27;
      var $238=(($235)|0);
      var $239=$238;
      var $240=(($239+4)|0);
      HEAP32[(($240)>>2)]=$228;
      var $241=$28;
      var $242=$29;
      __label__ = 8; break;
    case 8: // $243
      var $244=$__p;
      var $245=$48;
      var $246=$49;
      var $247=$30;
      var $248=$31;
      var $249=$32;
      HEAP32[(($30)>>2)]=$244;
      HEAP32[(($31)>>2)]=$245;
      HEAP32[(($32)>>2)]=$246;
      var $250=HEAP32[(($30)>>2)];
      var $251=HEAP32[(($31)>>2)];
      var $252=HEAP32[(($32)>>2)];
      assert($252 % 1 === 0, 'memcpy given ' + $252 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($250, $251, $252, 1);
      var $253=$30;
      var $254=$31;
      var $255=$32;
      var $256=$49;
      var $257=$__p;
      var $258=(($257+$256)|0);
      HEAP8[($50)]=0;
      var $259=$33;
      var $260=$34;
      HEAP32[(($33)>>2)]=$258;
      HEAP32[(($34)>>2)]=$50;
      var $261=HEAP32[(($34)>>2)];
      var $262=HEAP8[($261)];
      var $263=HEAP32[(($33)>>2)];
      HEAP8[($263)]=$262;
      var $264=$33;
      var $265=$34;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj["X"]=1;

function __ZNSt3__111__call_onceERVmPvPFvS2_E($flag, $arg, $func) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$flag;
      $2=$arg;
      $3=$func;
      var $6;
      __label__ = 1; break;
    case 1: // $7
      var $8=$1;
      var $9=HEAP32[(($8)>>2)];
      var $10=(($9)|0)==1;
      if ($10) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $11
      var $12=_pthread_cond_wait(__ZNSt3__1L2cvE, __ZNSt3__1L3mutE);
      __label__ = 1; break;
    case 3: // $13
      var $14=$1;
      var $15=HEAP32[(($14)>>2)];
      var $16=(($15)|0)==0;
      if ($16) { __label__ = 4; break; } else { __label__ = 18; break; }
    case 4: // $17
      var $18=$1;
      HEAP32[(($18)>>2)]=1;
      var $19=(function() { try { __THREW__ = false; return _pthread_mutex_unlock(__ZNSt3__1L3mutE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 10; break; };
    case 5: // $20
      var $21=$3;
      var $22=$2;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$21]($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 10; break; }
    case 6: // $23
      var $24=(function() { try { __THREW__ = false; return _pthread_mutex_lock(__ZNSt3__1L3mutE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 10; break; };
    case 7: // $25
      var $26=$1;
      HEAP32[(($26)>>2)]=-1;
      var $27=(function() { try { __THREW__ = false; return _pthread_mutex_unlock(__ZNSt3__1L3mutE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 10; break; };
    case 8: // $28
      var $29=(function() { try { __THREW__ = false; return _pthread_cond_broadcast(__ZNSt3__1L2cvE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 10; break; };
    case 9: // $30
      __label__ = 17; break;
    case 10: // $31
      var $32=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $33=$32.f0;
      $4=$33;
      var $34=$32.f1;
      $5=$34;
      __label__ = 11; break;
    case 11: // $35
      var $36=$4;
      var $37=___cxa_begin_catch($36);
      var $38=(function() { try { __THREW__ = false; return _pthread_mutex_lock(__ZNSt3__1L3mutE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $39
      var $40=$1;
      HEAP32[(($40)>>2)]=0;
      var $41=(function() { try { __THREW__ = false; return _pthread_mutex_unlock(__ZNSt3__1L3mutE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; };
    case 13: // $42
      var $43=(function() { try { __THREW__ = false; return _pthread_cond_broadcast(__ZNSt3__1L2cvE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; };
    case 14: // $44
      (function() { try { __THREW__ = false; return ___cxa_rethrow() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 15; break; }
    case 15: // $45
      var $46=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $47=$46.f0;
      $4=$47;
      var $48=$46.f1;
      $5=$48;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $49
      __label__ = 20; break;
    case 17: // $50
      __label__ = 19; break;
    case 18: // $51
      var $52;
      __label__ = 19; break;
    case 19: // $53
      ;
      return;
    case 20: // $54
      var $55=$4;
      var $56=$4;
      var $57=$5;
      var $58=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $56, tempValue);
      var $59=($58.f1 = $57, $58);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $60
      var $61=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 22: // $62
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__call_onceERVmPvPFvS2_E["X"]=1;

function __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      var $7;
      $5=$this;
      var $8=$5;
      var $9=___cxa_allocate_exception(8);
      var $10=$9;
      var $11=$3;
      var $12=$4;
      HEAP32[(($3)>>2)]=$10;
      HEAP32[(($4)>>2)]=((STRING_TABLE.__str801618)|0);
      var $13=HEAP32[(($3)>>2)];
      var $14=HEAP32[(($4)>>2)];
      var $15=$1;
      var $16=$2;
      HEAP32[(($1)>>2)]=$13;
      HEAP32[(($2)>>2)]=$14;
      var $17=HEAP32[(($1)>>2)];
      var $18=$17;
      var $19=HEAP32[(($2)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt11logic_errorC2EPKc($18, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt12length_errorC1EPKc_exit
      var $20=$17;
      HEAP32[(($20)>>2)]=((__ZTVSt12length_error+8)|0);
      var $21=$1;
      var $22=$2;
      var $23=$3;
      var $24=$4;
      __label__ = 2; break;
    case 2: // $25
      ___cxa_throw($9, __ZTISt12length_error, 1674);
      throw "Reached an unreachable!"
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $6=$28;
      var $29=$27.f1;
      $7=$29;
      ___cxa_free_exception($9);
      __label__ = 4; break;
    case 4: // $31
      var $32=$6;
      var $33=$6;
      var $34=$7;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($this, $__n, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 188; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30;
      var $31=__stackBase__+116;
      var $32=__stackBase__+120;
      var $33;
      var $34=__stackBase__+124;
      var $35=__stackBase__+128;
      var $36=__stackBase__+132;
      var $37=__stackBase__+136;
      var $38=__stackBase__+140;
      var $39=__stackBase__+144;
      var $40=__stackBase__+148;
      var $41=__stackBase__+152;
      var $42=__stackBase__+156;
      var $43=__stackBase__+160;
      var $44=__stackBase__+164;
      var $45=__stackBase__+168;
      var $__m_i=__stackBase__+172;
      var $46=__stackBase__+176;
      var $47=__stackBase__+180;
      var $48;
      var $49;
      var $50;
      var $__p;
      var $__cap;
      var $51=__stackBase__+184;
      $48=$this;
      $49=$__n;
      $50=$__c;
      var $52=$48;
      var $53=$49;
      var $54=$45;
      var $55=$__m_i;
      var $56=$46;
      var $57=$47;
      HEAP32[(($45)>>2)]=$52;
      var $58=HEAP32[(($45)>>2)];
      var $59=$44;
      HEAP32[(($44)>>2)]=$58;
      var $60=HEAP32[(($44)>>2)];
      var $61=(($60)|0);
      var $62=$43;
      HEAP32[(($43)>>2)]=$61;
      var $63=HEAP32[(($43)>>2)];
      var $64=$63;
      var $65=$42;
      HEAP32[(($42)>>2)]=$64;
      var $66=HEAP32[(($42)>>2)];
      var $67=$66;
      var $68=$42;
      var $69=$43;
      var $70=$44;
      var $71=$38;
      var $72=$39;
      var $73=$40;
      var $74=$41;
      HEAP32[(($39)>>2)]=$67;
      var $75=$41;
      var $76=HEAP32[(($39)>>2)];
      var $tmp_i_i=$38;
      var $tmp1_i_i=$40;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $77=$37;
      HEAP32[(($37)>>2)]=$76;
      var $78=HEAP32[(($37)>>2)];
      var $79=$36;
      HEAP32[(($36)>>2)]=$78;
      var $80=HEAP32[(($36)>>2)];
      var $81=$36;
      var $82=$37;
      var $83=$38;
      var $84=$39;
      var $85=$40;
      var $86=$41;
      HEAP32[(($__m_i)>>2)]=-1;
      var $87=HEAP32[(($__m_i)>>2)];
      var $88=(($87-1)|0);
      var $89=$45;
      var $90=$__m_i;
      var $91=$46;
      var $92=$47;
      var $93=(($53)>>>0) > (($88)>>>0);
      if ($93) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $94
      var $95=$52;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($95);
      __label__ = 2; break;
    case 2: // $96
      var $97=$49;
      var $98=(($97)>>>0) < 11;
      if ($98) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $99
      var $100=$49;
      var $101=$11;
      var $102=$12;
      HEAP32[(($11)>>2)]=$52;
      HEAP32[(($12)>>2)]=$100;
      var $103=HEAP32[(($11)>>2)];
      var $104=HEAP32[(($12)>>2)];
      var $105=$104 << 1;
      var $106=(($105) & 255);
      var $107=(($103)|0);
      var $108=$10;
      HEAP32[(($10)>>2)]=$107;
      var $109=HEAP32[(($10)>>2)];
      var $110=$109;
      var $111=$9;
      HEAP32[(($9)>>2)]=$110;
      var $112=HEAP32[(($9)>>2)];
      var $113=(($112)|0);
      var $114=$9;
      var $115=$10;
      var $116=(($113)|0);
      var $117=$116;
      var $118=(($117)|0);
      var $119=$118;
      HEAP8[($119)]=$106;
      var $120=$11;
      var $121=$12;
      var $122=$3;
      HEAP32[(($3)>>2)]=$52;
      var $123=HEAP32[(($3)>>2)];
      var $124=(($123)|0);
      var $125=$2;
      HEAP32[(($2)>>2)]=$124;
      var $126=HEAP32[(($2)>>2)];
      var $127=$126;
      var $128=$1;
      HEAP32[(($1)>>2)]=$127;
      var $129=HEAP32[(($1)>>2)];
      var $130=(($129)|0);
      var $131=$1;
      var $132=$2;
      var $133=(($130)|0);
      var $134=$133;
      var $135=(($134+1)|0);
      var $136=(($135)|0);
      var $137=$3;
      $__p=$136;
      __label__ = 8; break;
    case 4: // $138
      var $139=$49;
      var $140=$5;
      HEAP32[(($5)>>2)]=$139;
      var $141=HEAPU32[(($5)>>2)];
      var $142=(($141)>>>0) < 11;
      if ($142) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $143
      var $152 = 11;__label__ = 7; break;
    case 6: // $144
      var $145=HEAP32[(($5)>>2)];
      var $146=(($145+1)|0);
      var $147=$4;
      HEAP32[(($4)>>2)]=$146;
      var $148=HEAP32[(($4)>>2)];
      var $149=(($148+15)|0);
      var $150=$149 & -16;
      var $151=$4;
      var $152 = $150;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj_exit
      var $152;
      var $153=(($152-1)|0);
      var $154=$5;
      $__cap=$153;
      var $155=$8;
      HEAP32[(($8)>>2)]=$52;
      var $156=HEAP32[(($8)>>2)];
      var $157=(($156)|0);
      var $158=$7;
      HEAP32[(($7)>>2)]=$157;
      var $159=HEAP32[(($7)>>2)];
      var $160=$159;
      var $161=$6;
      HEAP32[(($6)>>2)]=$160;
      var $162=HEAP32[(($6)>>2)];
      var $163=$162;
      var $164=$6;
      var $165=$7;
      var $166=$8;
      var $167=$__cap;
      var $168=(($167+1)|0);
      var $169=$16;
      var $170=$17;
      HEAP32[(($16)>>2)]=$163;
      HEAP32[(($17)>>2)]=$168;
      var $171=HEAP32[(($16)>>2)];
      var $172=HEAP32[(($17)>>2)];
      var $173=$13;
      var $174=$14;
      var $175=$15;
      HEAP32[(($13)>>2)]=$171;
      HEAP32[(($14)>>2)]=$172;
      HEAP32[(($15)>>2)]=0;
      var $176=HEAP32[(($13)>>2)];
      var $177=HEAP32[(($14)>>2)];
      var $178=(($177)|0);
      var $179=__Znwj($178);
      var $180=$13;
      var $181=$14;
      var $182=$15;
      var $183=$16;
      var $184=$17;
      $__p=$179;
      var $185=$__p;
      var $186=$20;
      var $187=$21;
      HEAP32[(($20)>>2)]=$52;
      HEAP32[(($21)>>2)]=$185;
      var $188=HEAP32[(($20)>>2)];
      var $189=HEAP32[(($21)>>2)];
      var $190=(($188)|0);
      var $191=$19;
      HEAP32[(($19)>>2)]=$190;
      var $192=HEAP32[(($19)>>2)];
      var $193=$192;
      var $194=$18;
      HEAP32[(($18)>>2)]=$193;
      var $195=HEAP32[(($18)>>2)];
      var $196=(($195)|0);
      var $197=$18;
      var $198=$19;
      var $199=(($196)|0);
      var $200=$199;
      var $201=(($200+8)|0);
      HEAP32[(($201)>>2)]=$189;
      var $202=$20;
      var $203=$21;
      var $204=$__cap;
      var $205=(($204+1)|0);
      var $206=$24;
      var $207=$25;
      HEAP32[(($24)>>2)]=$52;
      HEAP32[(($25)>>2)]=$205;
      var $208=HEAP32[(($24)>>2)];
      var $209=HEAP32[(($25)>>2)];
      var $210=1 | $209;
      var $211=(($208)|0);
      var $212=$23;
      HEAP32[(($23)>>2)]=$211;
      var $213=HEAP32[(($23)>>2)];
      var $214=$213;
      var $215=$22;
      HEAP32[(($22)>>2)]=$214;
      var $216=HEAP32[(($22)>>2)];
      var $217=(($216)|0);
      var $218=$22;
      var $219=$23;
      var $220=(($217)|0);
      var $221=$220;
      var $222=(($221)|0);
      HEAP32[(($222)>>2)]=$210;
      var $223=$24;
      var $224=$25;
      var $225=$49;
      var $226=$28;
      var $227=$29;
      HEAP32[(($28)>>2)]=$52;
      HEAP32[(($29)>>2)]=$225;
      var $228=HEAP32[(($28)>>2)];
      var $229=HEAP32[(($29)>>2)];
      var $230=(($228)|0);
      var $231=$27;
      HEAP32[(($27)>>2)]=$230;
      var $232=HEAP32[(($27)>>2)];
      var $233=$232;
      var $234=$26;
      HEAP32[(($26)>>2)]=$233;
      var $235=HEAP32[(($26)>>2)];
      var $236=(($235)|0);
      var $237=$26;
      var $238=$27;
      var $239=(($236)|0);
      var $240=$239;
      var $241=(($240+4)|0);
      HEAP32[(($241)>>2)]=$229;
      var $242=$28;
      var $243=$29;
      __label__ = 8; break;
    case 8: // $244
      var $245=$__p;
      var $246=$49;
      var $247=$50;
      var $248=$31;
      var $249=$32;
      HEAP32[(($31)>>2)]=$245;
      HEAP32[(($32)>>2)]=$246;
      $33=$247;
      var $250=HEAP32[(($31)>>2)];
      var $251=$33;
      $30=$251;
      var $252=$30;
      var $253=(($252)&255);
      var $254=(($253) & 255);
      var $255=HEAP32[(($32)>>2)];
      _memset($250, $254, $255, 1);
      var $256=$31;
      var $257=$32;
      var $258=$49;
      var $259=$__p;
      var $260=(($259+$258)|0);
      HEAP8[($51)]=0;
      var $261=$34;
      var $262=$35;
      HEAP32[(($34)>>2)]=$260;
      HEAP32[(($35)>>2)]=$51;
      var $263=HEAP32[(($35)>>2)];
      var $264=HEAP8[($263)];
      var $265=HEAP32[(($34)>>2)];
      HEAP8[($265)]=$264;
      var $266=$34;
      var $267=$35;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20;
      $20=$this;
      var $21=$20;
      var $22=$19;
      HEAP32[(($19)>>2)]=$21;
      var $23=HEAP32[(($19)>>2)];
      var $24=$19;
      var $25=$12;
      HEAP32[(($12)>>2)]=$21;
      var $26=HEAP32[(($12)>>2)];
      var $27=(($26)|0);
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      var $31=$10;
      HEAP32[(($10)>>2)]=$30;
      var $32=HEAP32[(($10)>>2)];
      var $33=(($32)|0);
      var $34=$10;
      var $35=$11;
      var $36=(($33)|0);
      var $37=$36;
      var $38=(($37)|0);
      var $39=$38;
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$41 & 1;
      var $43=(($42)|0)!=0;
      var $44=$12;
      if ($43) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $46=$3;
      HEAP32[(($3)>>2)]=$21;
      var $47=HEAP32[(($3)>>2)];
      var $48=(($47)|0);
      var $49=$2;
      HEAP32[(($2)>>2)]=$48;
      var $50=HEAP32[(($2)>>2)];
      var $51=$50;
      var $52=$1;
      HEAP32[(($1)>>2)]=$51;
      var $53=HEAP32[(($1)>>2)];
      var $54=$53;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      var $58=$6;
      HEAP32[(($6)>>2)]=$21;
      var $59=HEAP32[(($6)>>2)];
      var $60=(($59)|0);
      var $61=$5;
      HEAP32[(($5)>>2)]=$60;
      var $62=HEAP32[(($5)>>2)];
      var $63=$62;
      var $64=$4;
      HEAP32[(($4)>>2)]=$63;
      var $65=HEAP32[(($4)>>2)];
      var $66=(($65)|0);
      var $67=$4;
      var $68=$5;
      var $69=(($66)|0);
      var $70=$69;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$6;
      var $74=$9;
      HEAP32[(($9)>>2)]=$21;
      var $75=HEAP32[(($9)>>2)];
      var $76=(($75)|0);
      var $77=$8;
      HEAP32[(($8)>>2)]=$76;
      var $78=HEAP32[(($8)>>2)];
      var $79=$78;
      var $80=$7;
      HEAP32[(($7)>>2)]=$79;
      var $81=HEAP32[(($7)>>2)];
      var $82=(($81)|0);
      var $83=$7;
      var $84=$8;
      var $85=(($82)|0);
      var $86=$85;
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$88 & -2;
      var $90=$9;
      var $91=$16;
      var $92=$17;
      var $93=$18;
      HEAP32[(($16)>>2)]=$54;
      HEAP32[(($17)>>2)]=$72;
      HEAP32[(($18)>>2)]=$89;
      var $94=HEAP32[(($16)>>2)];
      var $95=HEAP32[(($17)>>2)];
      var $96=HEAP32[(($18)>>2)];
      var $97=$13;
      var $98=$14;
      var $99=$15;
      HEAP32[(($13)>>2)]=$94;
      HEAP32[(($14)>>2)]=$95;
      HEAP32[(($15)>>2)]=$96;
      var $100=HEAP32[(($13)>>2)];
      var $101=HEAP32[(($14)>>2)];
      __ZdlPv($101);
      var $102=$13;
      var $103=$14;
      var $104=$15;
      var $105=$16;
      var $106=$17;
      var $107=$18;
      __label__ = 2; break;
    case 2: // $108
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($this, $__str) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30;
      var $31;
      $30=$this;
      $31=$__str;
      var $32=$30;
      var $33=$31;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $35
      var $36=$31;
      var $37=$26;
      var $38=$27;
      var $39=$28;
      var $40=$29;
      HEAP32[(($27)>>2)]=$32;
      HEAP32[(($28)>>2)]=$36;
      var $41=HEAP32[(($27)>>2)];
      var $42=HEAP32[(($28)>>2)];
      var $tmp_i=$26;
      var $tmp1_i=$29;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $43=$24;
      var $44=$25;
      HEAP32[(($24)>>2)]=$41;
      HEAP32[(($25)>>2)]=$42;
      var $45=HEAP32[(($24)>>2)];
      var $46=$24;
      var $47=$25;
      var $48=$26;
      var $49=$27;
      var $50=$28;
      var $51=$29;
      var $52=$31;
      var $53=$22;
      var $54=$23;
      HEAP32[(($22)>>2)]=$32;
      HEAP32[(($23)>>2)]=$52;
      var $55=HEAP32[(($22)>>2)];
      var $56=HEAP32[(($23)>>2)];
      var $57=$21;
      HEAP32[(($21)>>2)]=$56;
      var $58=HEAP32[(($21)>>2)];
      var $59=$20;
      HEAP32[(($20)>>2)]=$58;
      var $60=HEAPU32[(($20)>>2)];
      var $61=$19;
      HEAP32[(($19)>>2)]=$60;
      var $62=HEAP32[(($19)>>2)];
      var $63=(($62)|0);
      var $64=$18;
      HEAP32[(($18)>>2)]=$63;
      var $65=HEAP32[(($18)>>2)];
      var $66=$65;
      var $67=$17;
      HEAP32[(($17)>>2)]=$66;
      var $68=HEAP32[(($17)>>2)];
      var $69=(($68)|0);
      var $70=$17;
      var $71=$18;
      var $72=(($69)|0);
      var $73=$72;
      var $74=(($73)|0);
      var $75=$74;
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$77 & 1;
      var $79=(($78)|0)!=0;
      var $80=$19;
      if ($79) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $81
      var $82=$13;
      HEAP32[(($13)>>2)]=$60;
      var $83=HEAP32[(($13)>>2)];
      var $84=(($83)|0);
      var $85=$12;
      HEAP32[(($12)>>2)]=$84;
      var $86=HEAP32[(($12)>>2)];
      var $87=$86;
      var $88=$11;
      HEAP32[(($11)>>2)]=$87;
      var $89=HEAP32[(($11)>>2)];
      var $90=(($89)|0);
      var $91=$11;
      var $92=$12;
      var $93=(($90)|0);
      var $94=$93;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$13;
      var $115 = $96;__label__ = 4; break;
    case 3: // $98
      var $99=$16;
      HEAP32[(($16)>>2)]=$60;
      var $100=HEAP32[(($16)>>2)];
      var $101=(($100)|0);
      var $102=$15;
      HEAP32[(($15)>>2)]=$101;
      var $103=HEAP32[(($15)>>2)];
      var $104=$103;
      var $105=$14;
      HEAP32[(($14)>>2)]=$104;
      var $106=HEAP32[(($14)>>2)];
      var $107=(($106)|0);
      var $108=$14;
      var $109=$15;
      var $110=(($107)|0);
      var $111=$110;
      var $112=(($111+1)|0);
      var $113=(($112)|0);
      var $114=$16;
      var $115 = $113;__label__ = 4; break;
    case 4: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit_i
      var $115;
      var $116=$20;
      var $117=$21;
      var $118=HEAP32[(($23)>>2)];
      var $119=$10;
      HEAP32[(($10)>>2)]=$118;
      var $120=HEAPU32[(($10)>>2)];
      var $121=$9;
      HEAP32[(($9)>>2)]=$120;
      var $122=HEAP32[(($9)>>2)];
      var $123=(($122)|0);
      var $124=$8;
      HEAP32[(($8)>>2)]=$123;
      var $125=HEAP32[(($8)>>2)];
      var $126=$125;
      var $127=$7;
      HEAP32[(($7)>>2)]=$126;
      var $128=HEAP32[(($7)>>2)];
      var $129=(($128)|0);
      var $130=$7;
      var $131=$8;
      var $132=(($129)|0);
      var $133=$132;
      var $134=(($133)|0);
      var $135=$134;
      var $136=HEAPU8[($135)];
      var $137=(($136)&255);
      var $138=$137 & 1;
      var $139=(($138)|0)!=0;
      var $140=$9;
      if ($139) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $141
      var $142=$3;
      HEAP32[(($3)>>2)]=$120;
      var $143=HEAP32[(($3)>>2)];
      var $144=(($143)|0);
      var $145=$2;
      HEAP32[(($2)>>2)]=$144;
      var $146=HEAP32[(($2)>>2)];
      var $147=$146;
      var $148=$1;
      HEAP32[(($1)>>2)]=$147;
      var $149=HEAP32[(($1)>>2)];
      var $150=(($149)|0);
      var $151=$1;
      var $152=$2;
      var $153=(($150)|0);
      var $154=$153;
      var $155=(($154+4)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$3;
      var $178 = $156;__label__ = 7; break;
    case 6: // $158
      var $159=$6;
      HEAP32[(($6)>>2)]=$120;
      var $160=HEAP32[(($6)>>2)];
      var $161=(($160)|0);
      var $162=$5;
      HEAP32[(($5)>>2)]=$161;
      var $163=HEAP32[(($5)>>2)];
      var $164=$163;
      var $165=$4;
      HEAP32[(($4)>>2)]=$164;
      var $166=HEAP32[(($4)>>2)];
      var $167=(($166)|0);
      var $168=$4;
      var $169=$5;
      var $170=(($167)|0);
      var $171=$170;
      var $172=(($171)|0);
      var $173=$172;
      var $174=HEAPU8[($173)];
      var $175=(($174)&255);
      var $176=$175 >> 1;
      var $177=$6;
      var $178 = $176;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5__exit
      var $178;
      var $179=$10;
      var $180=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj($55, $115, $178);
      var $181=$22;
      var $182=$23;
      __label__ = 8; break;
    case 8: // $183
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($this, $__s) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  $2=$this;
  $3=$__s;
  var $4=$2;
  var $5=$3;
  var $6=$3;
  var $7=$1;
  HEAP32[(($1)>>2)]=$6;
  var $8=HEAP32[(($1)>>2)];
  var $9=_strlen($8);
  var $10=$1;
  var $11=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj($4, $5, $9);
  STACKTOP = __stackBase__;
  return $11;
}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc($this, $__s) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  $2=$this;
  $3=$__s;
  var $4=$2;
  var $5=$3;
  var $6=$3;
  var $7=$1;
  HEAP32[(($1)>>2)]=$6;
  var $8=HEAP32[(($1)>>2)];
  var $9=_strlen($8);
  var $10=$1;
  var $11=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj($4, $5, $9);
  STACKTOP = __stackBase__;
  return $11;
}


function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 184; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45;
      var $46=__stackBase__+176;
      var $__cap;
      var $__sz;
      var $__p;
      var $47=__stackBase__+180;
      $45=$this;
      HEAP8[($46)]=$__c;
      var $48=$45;
      var $49=$44;
      HEAP32[(($44)>>2)]=$48;
      var $50=HEAPU32[(($44)>>2)];
      var $51=$43;
      HEAP32[(($43)>>2)]=$50;
      var $52=HEAP32[(($43)>>2)];
      var $53=(($52)|0);
      var $54=$42;
      HEAP32[(($42)>>2)]=$53;
      var $55=HEAP32[(($42)>>2)];
      var $56=$55;
      var $57=$41;
      HEAP32[(($41)>>2)]=$56;
      var $58=HEAP32[(($41)>>2)];
      var $59=(($58)|0);
      var $60=$41;
      var $61=$42;
      var $62=(($59)|0);
      var $63=$62;
      var $64=(($63)|0);
      var $65=$64;
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$67 & 1;
      var $69=(($68)|0)!=0;
      var $70=$43;
      if ($69) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $71
      var $72=$40;
      HEAP32[(($40)>>2)]=$50;
      var $73=HEAP32[(($40)>>2)];
      var $74=(($73)|0);
      var $75=$39;
      HEAP32[(($39)>>2)]=$74;
      var $76=HEAP32[(($39)>>2)];
      var $77=$76;
      var $78=$38;
      HEAP32[(($38)>>2)]=$77;
      var $79=HEAP32[(($38)>>2)];
      var $80=(($79)|0);
      var $81=$38;
      var $82=$39;
      var $83=(($80)|0);
      var $84=$83;
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86 & -2;
      var $88=$40;
      var $90 = $87;__label__ = 3; break;
    case 2: // $89
      var $90 = 11;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv_exit
      var $90;
      var $91=(($90-1)|0);
      var $92=$44;
      $__cap=$91;
      var $93=$10;
      HEAP32[(($10)>>2)]=$48;
      var $94=HEAPU32[(($10)>>2)];
      var $95=$9;
      HEAP32[(($9)>>2)]=$94;
      var $96=HEAP32[(($9)>>2)];
      var $97=(($96)|0);
      var $98=$8;
      HEAP32[(($8)>>2)]=$97;
      var $99=HEAP32[(($8)>>2)];
      var $100=$99;
      var $101=$7;
      HEAP32[(($7)>>2)]=$100;
      var $102=HEAP32[(($7)>>2)];
      var $103=(($102)|0);
      var $104=$7;
      var $105=$8;
      var $106=(($103)|0);
      var $107=$106;
      var $108=(($107)|0);
      var $109=$108;
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$111 & 1;
      var $113=(($112)|0)!=0;
      var $114=$9;
      if ($113) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $115
      var $116=$3;
      HEAP32[(($3)>>2)]=$94;
      var $117=HEAP32[(($3)>>2)];
      var $118=(($117)|0);
      var $119=$2;
      HEAP32[(($2)>>2)]=$118;
      var $120=HEAP32[(($2)>>2)];
      var $121=$120;
      var $122=$1;
      HEAP32[(($1)>>2)]=$121;
      var $123=HEAP32[(($1)>>2)];
      var $124=(($123)|0);
      var $125=$1;
      var $126=$2;
      var $127=(($124)|0);
      var $128=$127;
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$3;
      var $152 = $130;__label__ = 6; break;
    case 5: // $132
      var $133=$6;
      HEAP32[(($6)>>2)]=$94;
      var $134=HEAP32[(($6)>>2)];
      var $135=(($134)|0);
      var $136=$5;
      HEAP32[(($5)>>2)]=$135;
      var $137=HEAP32[(($5)>>2)];
      var $138=$137;
      var $139=$4;
      HEAP32[(($4)>>2)]=$138;
      var $140=HEAP32[(($4)>>2)];
      var $141=(($140)|0);
      var $142=$4;
      var $143=$5;
      var $144=(($141)|0);
      var $145=$144;
      var $146=(($145)|0);
      var $147=$146;
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 >> 1;
      var $151=$6;
      var $152 = $150;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $152;
      var $153=$10;
      $__sz=$152;
      var $154=$__sz;
      var $155=$__cap;
      var $156=(($154)|0)==(($155)|0);
      if ($156) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $157
      var $158=$__cap;
      var $159=$__sz;
      var $160=$__sz;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($48, $158, 1, $159, $160, 0, 0);
      __label__ = 8; break;
    case 8: // $161
      var $162=$20;
      HEAP32[(($20)>>2)]=$48;
      var $163=HEAPU32[(($20)>>2)];
      var $164=$19;
      HEAP32[(($19)>>2)]=$163;
      var $165=HEAP32[(($19)>>2)];
      var $166=(($165)|0);
      var $167=$18;
      HEAP32[(($18)>>2)]=$166;
      var $168=HEAP32[(($18)>>2)];
      var $169=$168;
      var $170=$17;
      HEAP32[(($17)>>2)]=$169;
      var $171=HEAP32[(($17)>>2)];
      var $172=(($171)|0);
      var $173=$17;
      var $174=$18;
      var $175=(($172)|0);
      var $176=$175;
      var $177=(($176)|0);
      var $178=$177;
      var $179=HEAPU8[($178)];
      var $180=(($179)&255);
      var $181=$180 & 1;
      var $182=(($181)|0)!=0;
      var $183=$19;
      if ($182) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $184
      var $185=$13;
      HEAP32[(($13)>>2)]=$163;
      var $186=HEAP32[(($13)>>2)];
      var $187=(($186)|0);
      var $188=$12;
      HEAP32[(($12)>>2)]=$187;
      var $189=HEAP32[(($12)>>2)];
      var $190=$189;
      var $191=$11;
      HEAP32[(($11)>>2)]=$190;
      var $192=HEAP32[(($11)>>2)];
      var $193=(($192)|0);
      var $194=$11;
      var $195=$12;
      var $196=(($193)|0);
      var $197=$196;
      var $198=(($197+8)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=$13;
      var $218 = $199;__label__ = 11; break;
    case 10: // $201
      var $202=$16;
      HEAP32[(($16)>>2)]=$163;
      var $203=HEAP32[(($16)>>2)];
      var $204=(($203)|0);
      var $205=$15;
      HEAP32[(($15)>>2)]=$204;
      var $206=HEAP32[(($15)>>2)];
      var $207=$206;
      var $208=$14;
      HEAP32[(($14)>>2)]=$207;
      var $209=HEAP32[(($14)>>2)];
      var $210=(($209)|0);
      var $211=$14;
      var $212=$15;
      var $213=(($210)|0);
      var $214=$213;
      var $215=(($214+1)|0);
      var $216=(($215)|0);
      var $217=$16;
      var $218 = $216;__label__ = 11; break;
    case 11: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit
      var $218;
      var $219=$20;
      var $220=$__sz;
      var $221=(($218+$220)|0);
      $__p=$221;
      var $222=$__p;
      var $223=$21;
      var $224=$22;
      HEAP32[(($21)>>2)]=$222;
      HEAP32[(($22)>>2)]=$46;
      var $225=HEAP32[(($22)>>2)];
      var $226=HEAP8[($225)];
      var $227=HEAP32[(($21)>>2)];
      HEAP8[($227)]=$226;
      var $228=$21;
      var $229=$22;
      var $230=$__p;
      var $231=(($230+1)|0);
      $__p=$231;
      HEAP8[($47)]=0;
      var $232=$23;
      var $233=$24;
      HEAP32[(($23)>>2)]=$231;
      HEAP32[(($24)>>2)]=$47;
      var $234=HEAP32[(($24)>>2)];
      var $235=HEAP8[($234)];
      var $236=HEAP32[(($23)>>2)];
      HEAP8[($236)]=$235;
      var $237=$23;
      var $238=$24;
      var $239=$__sz;
      var $240=(($239+1)|0);
      var $241=$36;
      var $242=$37;
      HEAP32[(($36)>>2)]=$48;
      HEAP32[(($37)>>2)]=$240;
      var $243=HEAPU32[(($36)>>2)];
      var $244=$35;
      HEAP32[(($35)>>2)]=$243;
      var $245=HEAP32[(($35)>>2)];
      var $246=(($245)|0);
      var $247=$34;
      HEAP32[(($34)>>2)]=$246;
      var $248=HEAP32[(($34)>>2)];
      var $249=$248;
      var $250=$33;
      HEAP32[(($33)>>2)]=$249;
      var $251=HEAP32[(($33)>>2)];
      var $252=(($251)|0);
      var $253=$33;
      var $254=$34;
      var $255=(($252)|0);
      var $256=$255;
      var $257=(($256)|0);
      var $258=$257;
      var $259=HEAPU8[($258)];
      var $260=(($259)&255);
      var $261=$260 & 1;
      var $262=(($261)|0)!=0;
      var $263=$35;
      if ($262) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $264
      var $265=HEAP32[(($37)>>2)];
      var $266=$27;
      var $267=$28;
      HEAP32[(($27)>>2)]=$243;
      HEAP32[(($28)>>2)]=$265;
      var $268=HEAP32[(($27)>>2)];
      var $269=HEAP32[(($28)>>2)];
      var $270=(($268)|0);
      var $271=$26;
      HEAP32[(($26)>>2)]=$270;
      var $272=HEAP32[(($26)>>2)];
      var $273=$272;
      var $274=$25;
      HEAP32[(($25)>>2)]=$273;
      var $275=HEAP32[(($25)>>2)];
      var $276=(($275)|0);
      var $277=$25;
      var $278=$26;
      var $279=(($276)|0);
      var $280=$279;
      var $281=(($280+4)|0);
      HEAP32[(($281)>>2)]=$269;
      var $282=$27;
      var $283=$28;
      __label__ = 14; break;
    case 13: // $284
      var $285=HEAP32[(($37)>>2)];
      var $286=$31;
      var $287=$32;
      HEAP32[(($31)>>2)]=$243;
      HEAP32[(($32)>>2)]=$285;
      var $288=HEAP32[(($31)>>2)];
      var $289=HEAP32[(($32)>>2)];
      var $290=$289 << 1;
      var $291=(($290) & 255);
      var $292=(($288)|0);
      var $293=$30;
      HEAP32[(($30)>>2)]=$292;
      var $294=HEAP32[(($30)>>2)];
      var $295=$294;
      var $296=$29;
      HEAP32[(($29)>>2)]=$295;
      var $297=HEAP32[(($29)>>2)];
      var $298=(($297)|0);
      var $299=$29;
      var $300=$30;
      var $301=(($298)|0);
      var $302=$301;
      var $303=(($302)|0);
      var $304=$303;
      HEAP8[($304)]=$291;
      var $305=$31;
      var $306=$32;
      __label__ = 14; break;
    case 14: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj_exit
      var $307=$36;
      var $308=$37;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj($this, $__s, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 184; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46;
      var $47;
      var $48;
      var $__cap;
      var $__sz;
      var $__p;
      var $49=__stackBase__+180;
      $46=$this;
      $47=$__s;
      $48=$__n;
      var $50=$46;
      var $51=$45;
      HEAP32[(($45)>>2)]=$50;
      var $52=HEAPU32[(($45)>>2)];
      var $53=$44;
      HEAP32[(($44)>>2)]=$52;
      var $54=HEAP32[(($44)>>2)];
      var $55=(($54)|0);
      var $56=$43;
      HEAP32[(($43)>>2)]=$55;
      var $57=HEAP32[(($43)>>2)];
      var $58=$57;
      var $59=$42;
      HEAP32[(($42)>>2)]=$58;
      var $60=HEAP32[(($42)>>2)];
      var $61=(($60)|0);
      var $62=$42;
      var $63=$43;
      var $64=(($61)|0);
      var $65=$64;
      var $66=(($65)|0);
      var $67=$66;
      var $68=HEAPU8[($67)];
      var $69=(($68)&255);
      var $70=$69 & 1;
      var $71=(($70)|0)!=0;
      var $72=$44;
      if ($71) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $73
      var $74=$41;
      HEAP32[(($41)>>2)]=$52;
      var $75=HEAP32[(($41)>>2)];
      var $76=(($75)|0);
      var $77=$40;
      HEAP32[(($40)>>2)]=$76;
      var $78=HEAP32[(($40)>>2)];
      var $79=$78;
      var $80=$39;
      HEAP32[(($39)>>2)]=$79;
      var $81=HEAP32[(($39)>>2)];
      var $82=(($81)|0);
      var $83=$39;
      var $84=$40;
      var $85=(($82)|0);
      var $86=$85;
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$88 & -2;
      var $90=$41;
      var $92 = $89;__label__ = 3; break;
    case 2: // $91
      var $92 = 11;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv_exit
      var $92;
      var $93=(($92-1)|0);
      var $94=$45;
      $__cap=$93;
      var $95=$38;
      HEAP32[(($38)>>2)]=$50;
      var $96=HEAPU32[(($38)>>2)];
      var $97=$37;
      HEAP32[(($37)>>2)]=$96;
      var $98=HEAP32[(($37)>>2)];
      var $99=(($98)|0);
      var $100=$36;
      HEAP32[(($36)>>2)]=$99;
      var $101=HEAP32[(($36)>>2)];
      var $102=$101;
      var $103=$35;
      HEAP32[(($35)>>2)]=$102;
      var $104=HEAP32[(($35)>>2)];
      var $105=(($104)|0);
      var $106=$35;
      var $107=$36;
      var $108=(($105)|0);
      var $109=$108;
      var $110=(($109)|0);
      var $111=$110;
      var $112=HEAPU8[($111)];
      var $113=(($112)&255);
      var $114=$113 & 1;
      var $115=(($114)|0)!=0;
      var $116=$37;
      if ($115) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $117
      var $118=$31;
      HEAP32[(($31)>>2)]=$96;
      var $119=HEAP32[(($31)>>2)];
      var $120=(($119)|0);
      var $121=$30;
      HEAP32[(($30)>>2)]=$120;
      var $122=HEAP32[(($30)>>2)];
      var $123=$122;
      var $124=$29;
      HEAP32[(($29)>>2)]=$123;
      var $125=HEAP32[(($29)>>2)];
      var $126=(($125)|0);
      var $127=$29;
      var $128=$30;
      var $129=(($126)|0);
      var $130=$129;
      var $131=(($130+4)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=$31;
      var $154 = $132;__label__ = 6; break;
    case 5: // $134
      var $135=$34;
      HEAP32[(($34)>>2)]=$96;
      var $136=HEAP32[(($34)>>2)];
      var $137=(($136)|0);
      var $138=$33;
      HEAP32[(($33)>>2)]=$137;
      var $139=HEAP32[(($33)>>2)];
      var $140=$139;
      var $141=$32;
      HEAP32[(($32)>>2)]=$140;
      var $142=HEAP32[(($32)>>2)];
      var $143=(($142)|0);
      var $144=$32;
      var $145=$33;
      var $146=(($143)|0);
      var $147=$146;
      var $148=(($147)|0);
      var $149=$148;
      var $150=HEAPU8[($149)];
      var $151=(($150)&255);
      var $152=$151 >> 1;
      var $153=$34;
      var $154 = $152;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $154;
      var $155=$38;
      $__sz=$154;
      var $156=$__cap;
      var $157=$__sz;
      var $158=(($156-$157)|0);
      var $159=$48;
      var $160=(($158)>>>0) >= (($159)>>>0);
      if ($160) { __label__ = 7; break; } else { __label__ = 16; break; }
    case 7: // $161
      var $162=$48;
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 8; break; } else { __label__ = 15; break; }
    case 8: // $164
      var $165=$10;
      HEAP32[(($10)>>2)]=$50;
      var $166=HEAPU32[(($10)>>2)];
      var $167=$9;
      HEAP32[(($9)>>2)]=$166;
      var $168=HEAP32[(($9)>>2)];
      var $169=(($168)|0);
      var $170=$8;
      HEAP32[(($8)>>2)]=$169;
      var $171=HEAP32[(($8)>>2)];
      var $172=$171;
      var $173=$7;
      HEAP32[(($7)>>2)]=$172;
      var $174=HEAP32[(($7)>>2)];
      var $175=(($174)|0);
      var $176=$7;
      var $177=$8;
      var $178=(($175)|0);
      var $179=$178;
      var $180=(($179)|0);
      var $181=$180;
      var $182=HEAPU8[($181)];
      var $183=(($182)&255);
      var $184=$183 & 1;
      var $185=(($184)|0)!=0;
      var $186=$9;
      if ($185) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $187
      var $188=$3;
      HEAP32[(($3)>>2)]=$166;
      var $189=HEAP32[(($3)>>2)];
      var $190=(($189)|0);
      var $191=$2;
      HEAP32[(($2)>>2)]=$190;
      var $192=HEAP32[(($2)>>2)];
      var $193=$192;
      var $194=$1;
      HEAP32[(($1)>>2)]=$193;
      var $195=HEAP32[(($1)>>2)];
      var $196=(($195)|0);
      var $197=$1;
      var $198=$2;
      var $199=(($196)|0);
      var $200=$199;
      var $201=(($200+8)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=$3;
      var $221 = $202;__label__ = 11; break;
    case 10: // $204
      var $205=$6;
      HEAP32[(($6)>>2)]=$166;
      var $206=HEAP32[(($6)>>2)];
      var $207=(($206)|0);
      var $208=$5;
      HEAP32[(($5)>>2)]=$207;
      var $209=HEAP32[(($5)>>2)];
      var $210=$209;
      var $211=$4;
      HEAP32[(($4)>>2)]=$210;
      var $212=HEAP32[(($4)>>2)];
      var $213=(($212)|0);
      var $214=$4;
      var $215=$5;
      var $216=(($213)|0);
      var $217=$216;
      var $218=(($217+1)|0);
      var $219=(($218)|0);
      var $220=$6;
      var $221 = $219;__label__ = 11; break;
    case 11: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit
      var $221;
      var $222=$10;
      $__p=$221;
      var $223=$__p;
      var $224=$__sz;
      var $225=(($223+$224)|0);
      var $226=$47;
      var $227=$48;
      var $228=$11;
      var $229=$12;
      var $230=$13;
      HEAP32[(($11)>>2)]=$225;
      HEAP32[(($12)>>2)]=$226;
      HEAP32[(($13)>>2)]=$227;
      var $231=HEAP32[(($11)>>2)];
      var $232=HEAP32[(($12)>>2)];
      var $233=HEAP32[(($13)>>2)];
      assert($233 % 1 === 0, 'memcpy given ' + $233 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($231, $232, $233, 1);
      var $234=$11;
      var $235=$12;
      var $236=$13;
      var $237=$48;
      var $238=$__sz;
      var $239=(($238+$237)|0);
      $__sz=$239;
      var $240=$__sz;
      var $241=$25;
      var $242=$26;
      HEAP32[(($25)>>2)]=$50;
      HEAP32[(($26)>>2)]=$240;
      var $243=HEAPU32[(($25)>>2)];
      var $244=$24;
      HEAP32[(($24)>>2)]=$243;
      var $245=HEAP32[(($24)>>2)];
      var $246=(($245)|0);
      var $247=$23;
      HEAP32[(($23)>>2)]=$246;
      var $248=HEAP32[(($23)>>2)];
      var $249=$248;
      var $250=$22;
      HEAP32[(($22)>>2)]=$249;
      var $251=HEAP32[(($22)>>2)];
      var $252=(($251)|0);
      var $253=$22;
      var $254=$23;
      var $255=(($252)|0);
      var $256=$255;
      var $257=(($256)|0);
      var $258=$257;
      var $259=HEAPU8[($258)];
      var $260=(($259)&255);
      var $261=$260 & 1;
      var $262=(($261)|0)!=0;
      var $263=$24;
      if ($262) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $264
      var $265=HEAP32[(($26)>>2)];
      var $266=$16;
      var $267=$17;
      HEAP32[(($16)>>2)]=$243;
      HEAP32[(($17)>>2)]=$265;
      var $268=HEAP32[(($16)>>2)];
      var $269=HEAP32[(($17)>>2)];
      var $270=(($268)|0);
      var $271=$15;
      HEAP32[(($15)>>2)]=$270;
      var $272=HEAP32[(($15)>>2)];
      var $273=$272;
      var $274=$14;
      HEAP32[(($14)>>2)]=$273;
      var $275=HEAP32[(($14)>>2)];
      var $276=(($275)|0);
      var $277=$14;
      var $278=$15;
      var $279=(($276)|0);
      var $280=$279;
      var $281=(($280+4)|0);
      HEAP32[(($281)>>2)]=$269;
      var $282=$16;
      var $283=$17;
      __label__ = 14; break;
    case 13: // $284
      var $285=HEAP32[(($26)>>2)];
      var $286=$20;
      var $287=$21;
      HEAP32[(($20)>>2)]=$243;
      HEAP32[(($21)>>2)]=$285;
      var $288=HEAP32[(($20)>>2)];
      var $289=HEAP32[(($21)>>2)];
      var $290=$289 << 1;
      var $291=(($290) & 255);
      var $292=(($288)|0);
      var $293=$19;
      HEAP32[(($19)>>2)]=$292;
      var $294=HEAP32[(($19)>>2)];
      var $295=$294;
      var $296=$18;
      HEAP32[(($18)>>2)]=$295;
      var $297=HEAP32[(($18)>>2)];
      var $298=(($297)|0);
      var $299=$18;
      var $300=$19;
      var $301=(($298)|0);
      var $302=$301;
      var $303=(($302)|0);
      var $304=$303;
      HEAP8[($304)]=$291;
      var $305=$20;
      var $306=$21;
      __label__ = 14; break;
    case 14: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj_exit
      var $307=$25;
      var $308=$26;
      var $309=$__sz;
      var $310=$__p;
      var $311=(($310+$309)|0);
      HEAP8[($49)]=0;
      var $312=$27;
      var $313=$28;
      HEAP32[(($27)>>2)]=$311;
      HEAP32[(($28)>>2)]=$49;
      var $314=HEAP32[(($28)>>2)];
      var $315=HEAP8[($314)];
      var $316=HEAP32[(($27)>>2)];
      HEAP8[($316)]=$315;
      var $317=$27;
      var $318=$28;
      __label__ = 15; break;
    case 15: // $319
      __label__ = 17; break;
    case 16: // $320
      var $321=$__cap;
      var $322=$__sz;
      var $323=$48;
      var $324=(($322+$323)|0);
      var $325=$__cap;
      var $326=(($324-$325)|0);
      var $327=$__sz;
      var $328=$__sz;
      var $329=$48;
      var $330=$47;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc($50, $321, $326, $327, $328, 0, $329, $330);
      __label__ = 17; break;
    case 17: // $331
      STACKTOP = __stackBase__;
      return $50;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc($this, $__old_cap, $__delta_cap, $__old_sz, $__n_copy, $__n_del, $__n_add, $__p_new_stuff) {
  var __stackBase__  = STACKTOP; STACKTOP += 312; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $__m_i=__stackBase__+288;
      var $73=__stackBase__+292;
      var $74=__stackBase__+296;
      var $75;
      var $76;
      var $77;
      var $78;
      var $79;
      var $80;
      var $81;
      var $82;
      var $__ms;
      var $__old_p;
      var $__cap;
      var $83=__stackBase__+300;
      var $84=__stackBase__+304;
      var $__p;
      var $__sec_cp_sz;
      var $85=__stackBase__+308;
      $75=$this;
      $76=$__old_cap;
      $77=$__delta_cap;
      $78=$__old_sz;
      $79=$__n_copy;
      $80=$__n_del;
      $81=$__n_add;
      $82=$__p_new_stuff;
      var $86=$75;
      var $87=$72;
      var $88=$__m_i;
      var $89=$73;
      var $90=$74;
      HEAP32[(($72)>>2)]=$86;
      var $91=HEAP32[(($72)>>2)];
      var $92=$71;
      HEAP32[(($71)>>2)]=$91;
      var $93=HEAP32[(($71)>>2)];
      var $94=(($93)|0);
      var $95=$70;
      HEAP32[(($70)>>2)]=$94;
      var $96=HEAP32[(($70)>>2)];
      var $97=$96;
      var $98=$69;
      HEAP32[(($69)>>2)]=$97;
      var $99=HEAP32[(($69)>>2)];
      var $100=$99;
      var $101=$69;
      var $102=$70;
      var $103=$71;
      var $104=$65;
      var $105=$66;
      var $106=$67;
      var $107=$68;
      HEAP32[(($66)>>2)]=$100;
      var $108=$68;
      var $109=HEAP32[(($66)>>2)];
      var $tmp_i_i=$65;
      var $tmp1_i_i=$67;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $110=$64;
      HEAP32[(($64)>>2)]=$109;
      var $111=HEAP32[(($64)>>2)];
      var $112=$63;
      HEAP32[(($63)>>2)]=$111;
      var $113=HEAP32[(($63)>>2)];
      var $114=$63;
      var $115=$64;
      var $116=$65;
      var $117=$66;
      var $118=$67;
      var $119=$68;
      HEAP32[(($__m_i)>>2)]=-1;
      var $120=HEAP32[(($__m_i)>>2)];
      var $121=(($120-1)|0);
      var $122=$72;
      var $123=$__m_i;
      var $124=$73;
      var $125=$74;
      $__ms=$121;
      var $126=$77;
      var $127=$__ms;
      var $128=$76;
      var $129=(($127-$128)|0);
      var $130=(($129-1)|0);
      var $131=(($126)>>>0) > (($130)>>>0);
      if ($131) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $132
      var $133=$86;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($133);
      __label__ = 2; break;
    case 2: // $134
      var $135=$42;
      HEAP32[(($42)>>2)]=$86;
      var $136=HEAPU32[(($42)>>2)];
      var $137=$41;
      HEAP32[(($41)>>2)]=$136;
      var $138=HEAP32[(($41)>>2)];
      var $139=(($138)|0);
      var $140=$40;
      HEAP32[(($40)>>2)]=$139;
      var $141=HEAP32[(($40)>>2)];
      var $142=$141;
      var $143=$39;
      HEAP32[(($39)>>2)]=$142;
      var $144=HEAP32[(($39)>>2)];
      var $145=(($144)|0);
      var $146=$39;
      var $147=$40;
      var $148=(($145)|0);
      var $149=$148;
      var $150=(($149)|0);
      var $151=$150;
      var $152=HEAPU8[($151)];
      var $153=(($152)&255);
      var $154=$153 & 1;
      var $155=(($154)|0)!=0;
      var $156=$41;
      if ($155) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $157
      var $158=$35;
      HEAP32[(($35)>>2)]=$136;
      var $159=HEAP32[(($35)>>2)];
      var $160=(($159)|0);
      var $161=$34;
      HEAP32[(($34)>>2)]=$160;
      var $162=HEAP32[(($34)>>2)];
      var $163=$162;
      var $164=$33;
      HEAP32[(($33)>>2)]=$163;
      var $165=HEAP32[(($33)>>2)];
      var $166=(($165)|0);
      var $167=$33;
      var $168=$34;
      var $169=(($166)|0);
      var $170=$169;
      var $171=(($170+8)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=$35;
      var $191 = $172;__label__ = 5; break;
    case 4: // $174
      var $175=$38;
      HEAP32[(($38)>>2)]=$136;
      var $176=HEAP32[(($38)>>2)];
      var $177=(($176)|0);
      var $178=$37;
      HEAP32[(($37)>>2)]=$177;
      var $179=HEAP32[(($37)>>2)];
      var $180=$179;
      var $181=$36;
      HEAP32[(($36)>>2)]=$180;
      var $182=HEAP32[(($36)>>2)];
      var $183=(($182)|0);
      var $184=$36;
      var $185=$37;
      var $186=(($183)|0);
      var $187=$186;
      var $188=(($187+1)|0);
      var $189=(($188)|0);
      var $190=$38;
      var $191 = $189;__label__ = 5; break;
    case 5: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit
      var $191;
      var $192=$42;
      $__old_p=$191;
      var $193=$76;
      var $194=$__ms;
      var $195=Math.floor((($194)>>>0)/2);
      var $196=(($195-16)|0);
      var $197=(($193)>>>0) < (($196)>>>0);
      if ($197) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $198
      var $199=$76;
      var $200=$77;
      var $201=(($199+$200)|0);
      HEAP32[(($83)>>2)]=$201;
      var $202=$76;
      var $203=((($202<<1))|0);
      HEAP32[(($84)>>2)]=$203;
      var $204=$11;
      var $205=$12;
      var $206=$13;
      var $207=$14;
      HEAP32[(($12)>>2)]=$83;
      HEAP32[(($13)>>2)]=$84;
      var $208=HEAP32[(($12)>>2)];
      var $209=HEAP32[(($13)>>2)];
      var $tmp_i=$11;
      var $tmp1_i=$14;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $210=$9;
      var $211=$10;
      HEAP32[(($9)>>2)]=$208;
      HEAP32[(($10)>>2)]=$209;
      var $212=HEAP32[(($9)>>2)];
      var $213=HEAP32[(($10)>>2)];
      var $214=$6;
      var $215=$7;
      var $216=$8;
      HEAP32[(($6)>>2)]=$11;
      HEAP32[(($7)>>2)]=$212;
      HEAP32[(($8)>>2)]=$213;
      var $217=HEAP32[(($6)>>2)];
      var $218=HEAP32[(($7)>>2)];
      var $219=HEAPU32[(($218)>>2)];
      var $220=HEAP32[(($8)>>2)];
      var $221=HEAPU32[(($220)>>2)];
      var $222=(($219)>>>0) < (($221)>>>0);
      var $223=$6;
      var $224=$7;
      var $225=$8;
      if ($222) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $226
      var $227=HEAP32[(($10)>>2)];
      var $230 = $227;__label__ = 9; break;
    case 8: // $228
      var $229=HEAP32[(($9)>>2)];
      var $230 = $229;__label__ = 9; break;
    case 9: // $_ZNSt3__13maxIjEERKT_S3_S3__exit
      var $230;
      var $231=$9;
      var $232=$10;
      var $233=$11;
      var $234=$12;
      var $235=$13;
      var $236=$14;
      var $237=HEAP32[(($230)>>2)];
      var $238=$2;
      HEAP32[(($2)>>2)]=$237;
      var $239=HEAPU32[(($2)>>2)];
      var $240=(($239)>>>0) < 11;
      if ($240) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $241
      var $250 = 11;__label__ = 12; break;
    case 11: // $242
      var $243=HEAP32[(($2)>>2)];
      var $244=(($243+1)|0);
      var $245=$1;
      HEAP32[(($1)>>2)]=$244;
      var $246=HEAP32[(($1)>>2)];
      var $247=(($246+15)|0);
      var $248=$247 & -16;
      var $249=$1;
      var $250 = $248;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj_exit
      var $250;
      var $251=(($250-1)|0);
      var $252=$2;
      var $257 = $251;__label__ = 14; break;
    case 13: // $253
      var $254=$__ms;
      var $255=(($254-1)|0);
      var $257 = $255;__label__ = 14; break;
    case 14: // $256
      var $257;
      $__cap=$257;
      var $258=$5;
      HEAP32[(($5)>>2)]=$86;
      var $259=HEAP32[(($5)>>2)];
      var $260=(($259)|0);
      var $261=$4;
      HEAP32[(($4)>>2)]=$260;
      var $262=HEAP32[(($4)>>2)];
      var $263=$262;
      var $264=$3;
      HEAP32[(($3)>>2)]=$263;
      var $265=HEAP32[(($3)>>2)];
      var $266=$265;
      var $267=$3;
      var $268=$4;
      var $269=$5;
      var $270=$__cap;
      var $271=(($270+1)|0);
      var $272=$18;
      var $273=$19;
      HEAP32[(($18)>>2)]=$266;
      HEAP32[(($19)>>2)]=$271;
      var $274=HEAP32[(($18)>>2)];
      var $275=HEAP32[(($19)>>2)];
      var $276=$15;
      var $277=$16;
      var $278=$17;
      HEAP32[(($15)>>2)]=$274;
      HEAP32[(($16)>>2)]=$275;
      HEAP32[(($17)>>2)]=0;
      var $279=HEAP32[(($15)>>2)];
      var $280=HEAP32[(($16)>>2)];
      var $281=(($280)|0);
      var $282=__Znwj($281);
      var $283=$15;
      var $284=$16;
      var $285=$17;
      var $286=$18;
      var $287=$19;
      $__p=$282;
      var $288=$20;
      HEAP32[(($20)>>2)]=$86;
      var $289=HEAP32[(($20)>>2)];
      var $290=$20;
      var $291=$79;
      var $292=(($291)|0)!=0;
      if ($292) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $293
      var $294=$__p;
      var $295=$__old_p;
      var $296=$79;
      var $297=$21;
      var $298=$22;
      var $299=$23;
      HEAP32[(($21)>>2)]=$294;
      HEAP32[(($22)>>2)]=$295;
      HEAP32[(($23)>>2)]=$296;
      var $300=HEAP32[(($21)>>2)];
      var $301=HEAP32[(($22)>>2)];
      var $302=HEAP32[(($23)>>2)];
      assert($302 % 1 === 0, 'memcpy given ' + $302 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($300, $301, $302, 1);
      var $303=$21;
      var $304=$22;
      var $305=$23;
      __label__ = 16; break;
    case 16: // $306
      var $307=$81;
      var $308=(($307)|0)!=0;
      if ($308) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $309
      var $310=$__p;
      var $311=$79;
      var $312=(($310+$311)|0);
      var $313=$82;
      var $314=$81;
      var $315=$24;
      var $316=$25;
      var $317=$26;
      HEAP32[(($24)>>2)]=$312;
      HEAP32[(($25)>>2)]=$313;
      HEAP32[(($26)>>2)]=$314;
      var $318=HEAP32[(($24)>>2)];
      var $319=HEAP32[(($25)>>2)];
      var $320=HEAP32[(($26)>>2)];
      assert($320 % 1 === 0, 'memcpy given ' + $320 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($318, $319, $320, 1);
      var $321=$24;
      var $322=$25;
      var $323=$26;
      __label__ = 18; break;
    case 18: // $324
      var $325=$78;
      var $326=$80;
      var $327=(($325-$326)|0);
      var $328=$79;
      var $329=(($327-$328)|0);
      $__sec_cp_sz=$329;
      var $330=$__sec_cp_sz;
      var $331=(($330)|0)!=0;
      if ($331) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $332
      var $333=$__p;
      var $334=$79;
      var $335=(($333+$334)|0);
      var $336=$81;
      var $337=(($335+$336)|0);
      var $338=$__old_p;
      var $339=$79;
      var $340=(($338+$339)|0);
      var $341=$80;
      var $342=(($340+$341)|0);
      var $343=$__sec_cp_sz;
      var $344=$27;
      var $345=$28;
      var $346=$29;
      HEAP32[(($27)>>2)]=$337;
      HEAP32[(($28)>>2)]=$342;
      HEAP32[(($29)>>2)]=$343;
      var $347=HEAP32[(($27)>>2)];
      var $348=HEAP32[(($28)>>2)];
      var $349=HEAP32[(($29)>>2)];
      assert($349 % 1 === 0, 'memcpy given ' + $349 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($347, $348, $349, 1);
      var $350=$27;
      var $351=$28;
      var $352=$29;
      __label__ = 20; break;
    case 20: // $353
      var $354=$76;
      var $355=(($354+1)|0);
      var $356=(($355)|0)!=11;
      if ($356) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $357
      var $358=$32;
      HEAP32[(($32)>>2)]=$86;
      var $359=HEAP32[(($32)>>2)];
      var $360=(($359)|0);
      var $361=$31;
      HEAP32[(($31)>>2)]=$360;
      var $362=HEAP32[(($31)>>2)];
      var $363=$362;
      var $364=$30;
      HEAP32[(($30)>>2)]=$363;
      var $365=HEAP32[(($30)>>2)];
      var $366=$365;
      var $367=$30;
      var $368=$31;
      var $369=$32;
      var $370=$__old_p;
      var $371=$76;
      var $372=(($371+1)|0);
      var $373=$46;
      var $374=$47;
      var $375=$48;
      HEAP32[(($46)>>2)]=$366;
      HEAP32[(($47)>>2)]=$370;
      HEAP32[(($48)>>2)]=$372;
      var $376=HEAP32[(($46)>>2)];
      var $377=HEAP32[(($47)>>2)];
      var $378=HEAP32[(($48)>>2)];
      var $379=$43;
      var $380=$44;
      var $381=$45;
      HEAP32[(($43)>>2)]=$376;
      HEAP32[(($44)>>2)]=$377;
      HEAP32[(($45)>>2)]=$378;
      var $382=HEAP32[(($43)>>2)];
      var $383=HEAP32[(($44)>>2)];
      __ZdlPv($383);
      var $384=$43;
      var $385=$44;
      var $386=$45;
      var $387=$46;
      var $388=$47;
      var $389=$48;
      __label__ = 22; break;
    case 22: // $390
      var $391=$__p;
      var $392=$51;
      var $393=$52;
      HEAP32[(($51)>>2)]=$86;
      HEAP32[(($52)>>2)]=$391;
      var $394=HEAP32[(($51)>>2)];
      var $395=HEAP32[(($52)>>2)];
      var $396=(($394)|0);
      var $397=$50;
      HEAP32[(($50)>>2)]=$396;
      var $398=HEAP32[(($50)>>2)];
      var $399=$398;
      var $400=$49;
      HEAP32[(($49)>>2)]=$399;
      var $401=HEAP32[(($49)>>2)];
      var $402=(($401)|0);
      var $403=$49;
      var $404=$50;
      var $405=(($402)|0);
      var $406=$405;
      var $407=(($406+8)|0);
      HEAP32[(($407)>>2)]=$395;
      var $408=$51;
      var $409=$52;
      var $410=$__cap;
      var $411=(($410+1)|0);
      var $412=$55;
      var $413=$56;
      HEAP32[(($55)>>2)]=$86;
      HEAP32[(($56)>>2)]=$411;
      var $414=HEAP32[(($55)>>2)];
      var $415=HEAP32[(($56)>>2)];
      var $416=1 | $415;
      var $417=(($414)|0);
      var $418=$54;
      HEAP32[(($54)>>2)]=$417;
      var $419=HEAP32[(($54)>>2)];
      var $420=$419;
      var $421=$53;
      HEAP32[(($53)>>2)]=$420;
      var $422=HEAP32[(($53)>>2)];
      var $423=(($422)|0);
      var $424=$53;
      var $425=$54;
      var $426=(($423)|0);
      var $427=$426;
      var $428=(($427)|0);
      HEAP32[(($428)>>2)]=$416;
      var $429=$55;
      var $430=$56;
      var $431=$79;
      var $432=$81;
      var $433=(($431+$432)|0);
      var $434=$__sec_cp_sz;
      var $435=(($433+$434)|0);
      $78=$435;
      var $436=$78;
      var $437=$59;
      var $438=$60;
      HEAP32[(($59)>>2)]=$86;
      HEAP32[(($60)>>2)]=$436;
      var $439=HEAP32[(($59)>>2)];
      var $440=HEAP32[(($60)>>2)];
      var $441=(($439)|0);
      var $442=$58;
      HEAP32[(($58)>>2)]=$441;
      var $443=HEAP32[(($58)>>2)];
      var $444=$443;
      var $445=$57;
      HEAP32[(($57)>>2)]=$444;
      var $446=HEAP32[(($57)>>2)];
      var $447=(($446)|0);
      var $448=$57;
      var $449=$58;
      var $450=(($447)|0);
      var $451=$450;
      var $452=(($451+4)|0);
      HEAP32[(($452)>>2)]=$440;
      var $453=$59;
      var $454=$60;
      var $455=$78;
      var $456=$__p;
      var $457=(($456+$455)|0);
      HEAP8[($85)]=0;
      var $458=$61;
      var $459=$62;
      HEAP32[(($61)>>2)]=$457;
      HEAP32[(($62)>>2)]=$85;
      var $460=HEAP32[(($62)>>2)];
      var $461=HEAP8[($460)];
      var $462=HEAP32[(($61)>>2)];
      HEAP8[($462)]=$461;
      var $463=$61;
      var $464=$62;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($this, $__old_cap, $__delta_cap, $__old_sz, $__n_copy, $__n_del, $__n_add) {
  var __stackBase__  = STACKTOP; STACKTOP += 272; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $__m_i=__stackBase__+252;
      var $64=__stackBase__+256;
      var $65=__stackBase__+260;
      var $66;
      var $67;
      var $68;
      var $69;
      var $70;
      var $71;
      var $72;
      var $__ms;
      var $__old_p;
      var $__cap;
      var $73=__stackBase__+264;
      var $74=__stackBase__+268;
      var $__p;
      var $__sec_cp_sz;
      $66=$this;
      $67=$__old_cap;
      $68=$__delta_cap;
      $69=$__old_sz;
      $70=$__n_copy;
      $71=$__n_del;
      $72=$__n_add;
      var $75=$66;
      var $76=$63;
      var $77=$__m_i;
      var $78=$64;
      var $79=$65;
      HEAP32[(($63)>>2)]=$75;
      var $80=HEAP32[(($63)>>2)];
      var $81=$62;
      HEAP32[(($62)>>2)]=$80;
      var $82=HEAP32[(($62)>>2)];
      var $83=(($82)|0);
      var $84=$61;
      HEAP32[(($61)>>2)]=$83;
      var $85=HEAP32[(($61)>>2)];
      var $86=$85;
      var $87=$60;
      HEAP32[(($60)>>2)]=$86;
      var $88=HEAP32[(($60)>>2)];
      var $89=$88;
      var $90=$60;
      var $91=$61;
      var $92=$62;
      var $93=$56;
      var $94=$57;
      var $95=$58;
      var $96=$59;
      HEAP32[(($57)>>2)]=$89;
      var $97=$59;
      var $98=HEAP32[(($57)>>2)];
      var $tmp_i_i=$56;
      var $tmp1_i_i=$58;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $99=$55;
      HEAP32[(($55)>>2)]=$98;
      var $100=HEAP32[(($55)>>2)];
      var $101=$54;
      HEAP32[(($54)>>2)]=$100;
      var $102=HEAP32[(($54)>>2)];
      var $103=$54;
      var $104=$55;
      var $105=$56;
      var $106=$57;
      var $107=$58;
      var $108=$59;
      HEAP32[(($__m_i)>>2)]=-1;
      var $109=HEAP32[(($__m_i)>>2)];
      var $110=(($109-1)|0);
      var $111=$63;
      var $112=$__m_i;
      var $113=$64;
      var $114=$65;
      $__ms=$110;
      var $115=$68;
      var $116=$__ms;
      var $117=$67;
      var $118=(($116-$117)|0);
      var $119=(($118-1)|0);
      var $120=(($115)>>>0) > (($119)>>>0);
      if ($120) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $121
      var $122=$75;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($122);
      __label__ = 2; break;
    case 2: // $123
      var $124=$39;
      HEAP32[(($39)>>2)]=$75;
      var $125=HEAPU32[(($39)>>2)];
      var $126=$38;
      HEAP32[(($38)>>2)]=$125;
      var $127=HEAP32[(($38)>>2)];
      var $128=(($127)|0);
      var $129=$37;
      HEAP32[(($37)>>2)]=$128;
      var $130=HEAP32[(($37)>>2)];
      var $131=$130;
      var $132=$36;
      HEAP32[(($36)>>2)]=$131;
      var $133=HEAP32[(($36)>>2)];
      var $134=(($133)|0);
      var $135=$36;
      var $136=$37;
      var $137=(($134)|0);
      var $138=$137;
      var $139=(($138)|0);
      var $140=$139;
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=$142 & 1;
      var $144=(($143)|0)!=0;
      var $145=$38;
      if ($144) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $146
      var $147=$32;
      HEAP32[(($32)>>2)]=$125;
      var $148=HEAP32[(($32)>>2)];
      var $149=(($148)|0);
      var $150=$31;
      HEAP32[(($31)>>2)]=$149;
      var $151=HEAP32[(($31)>>2)];
      var $152=$151;
      var $153=$30;
      HEAP32[(($30)>>2)]=$152;
      var $154=HEAP32[(($30)>>2)];
      var $155=(($154)|0);
      var $156=$30;
      var $157=$31;
      var $158=(($155)|0);
      var $159=$158;
      var $160=(($159+8)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$32;
      var $180 = $161;__label__ = 5; break;
    case 4: // $163
      var $164=$35;
      HEAP32[(($35)>>2)]=$125;
      var $165=HEAP32[(($35)>>2)];
      var $166=(($165)|0);
      var $167=$34;
      HEAP32[(($34)>>2)]=$166;
      var $168=HEAP32[(($34)>>2)];
      var $169=$168;
      var $170=$33;
      HEAP32[(($33)>>2)]=$169;
      var $171=HEAP32[(($33)>>2)];
      var $172=(($171)|0);
      var $173=$33;
      var $174=$34;
      var $175=(($172)|0);
      var $176=$175;
      var $177=(($176+1)|0);
      var $178=(($177)|0);
      var $179=$35;
      var $180 = $178;__label__ = 5; break;
    case 5: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit
      var $180;
      var $181=$39;
      $__old_p=$180;
      var $182=$67;
      var $183=$__ms;
      var $184=Math.floor((($183)>>>0)/2);
      var $185=(($184-16)|0);
      var $186=(($182)>>>0) < (($185)>>>0);
      if ($186) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $187
      var $188=$67;
      var $189=$68;
      var $190=(($188+$189)|0);
      HEAP32[(($73)>>2)]=$190;
      var $191=$67;
      var $192=((($191<<1))|0);
      HEAP32[(($74)>>2)]=$192;
      var $193=$11;
      var $194=$12;
      var $195=$13;
      var $196=$14;
      HEAP32[(($12)>>2)]=$73;
      HEAP32[(($13)>>2)]=$74;
      var $197=HEAP32[(($12)>>2)];
      var $198=HEAP32[(($13)>>2)];
      var $tmp_i=$11;
      var $tmp1_i=$14;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $199=$9;
      var $200=$10;
      HEAP32[(($9)>>2)]=$197;
      HEAP32[(($10)>>2)]=$198;
      var $201=HEAP32[(($9)>>2)];
      var $202=HEAP32[(($10)>>2)];
      var $203=$6;
      var $204=$7;
      var $205=$8;
      HEAP32[(($6)>>2)]=$11;
      HEAP32[(($7)>>2)]=$201;
      HEAP32[(($8)>>2)]=$202;
      var $206=HEAP32[(($6)>>2)];
      var $207=HEAP32[(($7)>>2)];
      var $208=HEAPU32[(($207)>>2)];
      var $209=HEAP32[(($8)>>2)];
      var $210=HEAPU32[(($209)>>2)];
      var $211=(($208)>>>0) < (($210)>>>0);
      var $212=$6;
      var $213=$7;
      var $214=$8;
      if ($211) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $215
      var $216=HEAP32[(($10)>>2)];
      var $219 = $216;__label__ = 9; break;
    case 8: // $217
      var $218=HEAP32[(($9)>>2)];
      var $219 = $218;__label__ = 9; break;
    case 9: // $_ZNSt3__13maxIjEERKT_S3_S3__exit
      var $219;
      var $220=$9;
      var $221=$10;
      var $222=$11;
      var $223=$12;
      var $224=$13;
      var $225=$14;
      var $226=HEAP32[(($219)>>2)];
      var $227=$2;
      HEAP32[(($2)>>2)]=$226;
      var $228=HEAPU32[(($2)>>2)];
      var $229=(($228)>>>0) < 11;
      if ($229) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $230
      var $239 = 11;__label__ = 12; break;
    case 11: // $231
      var $232=HEAP32[(($2)>>2)];
      var $233=(($232+1)|0);
      var $234=$1;
      HEAP32[(($1)>>2)]=$233;
      var $235=HEAP32[(($1)>>2)];
      var $236=(($235+15)|0);
      var $237=$236 & -16;
      var $238=$1;
      var $239 = $237;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj_exit
      var $239;
      var $240=(($239-1)|0);
      var $241=$2;
      var $246 = $240;__label__ = 14; break;
    case 13: // $242
      var $243=$__ms;
      var $244=(($243-1)|0);
      var $246 = $244;__label__ = 14; break;
    case 14: // $245
      var $246;
      $__cap=$246;
      var $247=$5;
      HEAP32[(($5)>>2)]=$75;
      var $248=HEAP32[(($5)>>2)];
      var $249=(($248)|0);
      var $250=$4;
      HEAP32[(($4)>>2)]=$249;
      var $251=HEAP32[(($4)>>2)];
      var $252=$251;
      var $253=$3;
      HEAP32[(($3)>>2)]=$252;
      var $254=HEAP32[(($3)>>2)];
      var $255=$254;
      var $256=$3;
      var $257=$4;
      var $258=$5;
      var $259=$__cap;
      var $260=(($259+1)|0);
      var $261=$18;
      var $262=$19;
      HEAP32[(($18)>>2)]=$255;
      HEAP32[(($19)>>2)]=$260;
      var $263=HEAP32[(($18)>>2)];
      var $264=HEAP32[(($19)>>2)];
      var $265=$15;
      var $266=$16;
      var $267=$17;
      HEAP32[(($15)>>2)]=$263;
      HEAP32[(($16)>>2)]=$264;
      HEAP32[(($17)>>2)]=0;
      var $268=HEAP32[(($15)>>2)];
      var $269=HEAP32[(($16)>>2)];
      var $270=(($269)|0);
      var $271=__Znwj($270);
      var $272=$15;
      var $273=$16;
      var $274=$17;
      var $275=$18;
      var $276=$19;
      $__p=$271;
      var $277=$20;
      HEAP32[(($20)>>2)]=$75;
      var $278=HEAP32[(($20)>>2)];
      var $279=$20;
      var $280=$70;
      var $281=(($280)|0)!=0;
      if ($281) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $282
      var $283=$__p;
      var $284=$__old_p;
      var $285=$70;
      var $286=$21;
      var $287=$22;
      var $288=$23;
      HEAP32[(($21)>>2)]=$283;
      HEAP32[(($22)>>2)]=$284;
      HEAP32[(($23)>>2)]=$285;
      var $289=HEAP32[(($21)>>2)];
      var $290=HEAP32[(($22)>>2)];
      var $291=HEAP32[(($23)>>2)];
      assert($291 % 1 === 0, 'memcpy given ' + $291 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($289, $290, $291, 1);
      var $292=$21;
      var $293=$22;
      var $294=$23;
      __label__ = 16; break;
    case 16: // $295
      var $296=$69;
      var $297=$71;
      var $298=(($296-$297)|0);
      var $299=$70;
      var $300=(($298-$299)|0);
      $__sec_cp_sz=$300;
      var $301=$__sec_cp_sz;
      var $302=(($301)|0)!=0;
      if ($302) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $303
      var $304=$__p;
      var $305=$70;
      var $306=(($304+$305)|0);
      var $307=$72;
      var $308=(($306+$307)|0);
      var $309=$__old_p;
      var $310=$70;
      var $311=(($309+$310)|0);
      var $312=$71;
      var $313=(($311+$312)|0);
      var $314=$__sec_cp_sz;
      var $315=$24;
      var $316=$25;
      var $317=$26;
      HEAP32[(($24)>>2)]=$308;
      HEAP32[(($25)>>2)]=$313;
      HEAP32[(($26)>>2)]=$314;
      var $318=HEAP32[(($24)>>2)];
      var $319=HEAP32[(($25)>>2)];
      var $320=HEAP32[(($26)>>2)];
      assert($320 % 1 === 0, 'memcpy given ' + $320 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($318, $319, $320, 1);
      var $321=$24;
      var $322=$25;
      var $323=$26;
      __label__ = 18; break;
    case 18: // $324
      var $325=$67;
      var $326=(($325+1)|0);
      var $327=(($326)|0)!=11;
      if ($327) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $328
      var $329=$29;
      HEAP32[(($29)>>2)]=$75;
      var $330=HEAP32[(($29)>>2)];
      var $331=(($330)|0);
      var $332=$28;
      HEAP32[(($28)>>2)]=$331;
      var $333=HEAP32[(($28)>>2)];
      var $334=$333;
      var $335=$27;
      HEAP32[(($27)>>2)]=$334;
      var $336=HEAP32[(($27)>>2)];
      var $337=$336;
      var $338=$27;
      var $339=$28;
      var $340=$29;
      var $341=$__old_p;
      var $342=$67;
      var $343=(($342+1)|0);
      var $344=$43;
      var $345=$44;
      var $346=$45;
      HEAP32[(($43)>>2)]=$337;
      HEAP32[(($44)>>2)]=$341;
      HEAP32[(($45)>>2)]=$343;
      var $347=HEAP32[(($43)>>2)];
      var $348=HEAP32[(($44)>>2)];
      var $349=HEAP32[(($45)>>2)];
      var $350=$40;
      var $351=$41;
      var $352=$42;
      HEAP32[(($40)>>2)]=$347;
      HEAP32[(($41)>>2)]=$348;
      HEAP32[(($42)>>2)]=$349;
      var $353=HEAP32[(($40)>>2)];
      var $354=HEAP32[(($41)>>2)];
      __ZdlPv($354);
      var $355=$40;
      var $356=$41;
      var $357=$42;
      var $358=$43;
      var $359=$44;
      var $360=$45;
      __label__ = 20; break;
    case 20: // $361
      var $362=$__p;
      var $363=$48;
      var $364=$49;
      HEAP32[(($48)>>2)]=$75;
      HEAP32[(($49)>>2)]=$362;
      var $365=HEAP32[(($48)>>2)];
      var $366=HEAP32[(($49)>>2)];
      var $367=(($365)|0);
      var $368=$47;
      HEAP32[(($47)>>2)]=$367;
      var $369=HEAP32[(($47)>>2)];
      var $370=$369;
      var $371=$46;
      HEAP32[(($46)>>2)]=$370;
      var $372=HEAP32[(($46)>>2)];
      var $373=(($372)|0);
      var $374=$46;
      var $375=$47;
      var $376=(($373)|0);
      var $377=$376;
      var $378=(($377+8)|0);
      HEAP32[(($378)>>2)]=$366;
      var $379=$48;
      var $380=$49;
      var $381=$__cap;
      var $382=(($381+1)|0);
      var $383=$52;
      var $384=$53;
      HEAP32[(($52)>>2)]=$75;
      HEAP32[(($53)>>2)]=$382;
      var $385=HEAP32[(($52)>>2)];
      var $386=HEAP32[(($53)>>2)];
      var $387=1 | $386;
      var $388=(($385)|0);
      var $389=$51;
      HEAP32[(($51)>>2)]=$388;
      var $390=HEAP32[(($51)>>2)];
      var $391=$390;
      var $392=$50;
      HEAP32[(($50)>>2)]=$391;
      var $393=HEAP32[(($50)>>2)];
      var $394=(($393)|0);
      var $395=$50;
      var $396=$51;
      var $397=(($394)|0);
      var $398=$397;
      var $399=(($398)|0);
      HEAP32[(($399)>>2)]=$387;
      var $400=$52;
      var $401=$53;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj($this, $__s, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48;
      var $49;
      var $50;
      var $__cap;
      var $__p;
      var $51=__stackBase__+188;
      var $__sz;
      $48=$this;
      $49=$__s;
      $50=$__n;
      var $52=$48;
      var $53=$47;
      HEAP32[(($47)>>2)]=$52;
      var $54=HEAPU32[(($47)>>2)];
      var $55=$46;
      HEAP32[(($46)>>2)]=$54;
      var $56=HEAP32[(($46)>>2)];
      var $57=(($56)|0);
      var $58=$45;
      HEAP32[(($45)>>2)]=$57;
      var $59=HEAP32[(($45)>>2)];
      var $60=$59;
      var $61=$44;
      HEAP32[(($44)>>2)]=$60;
      var $62=HEAP32[(($44)>>2)];
      var $63=(($62)|0);
      var $64=$44;
      var $65=$45;
      var $66=(($63)|0);
      var $67=$66;
      var $68=(($67)|0);
      var $69=$68;
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=$71 & 1;
      var $73=(($72)|0)!=0;
      var $74=$46;
      if ($73) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $75
      var $76=$43;
      HEAP32[(($43)>>2)]=$54;
      var $77=HEAP32[(($43)>>2)];
      var $78=(($77)|0);
      var $79=$42;
      HEAP32[(($42)>>2)]=$78;
      var $80=HEAP32[(($42)>>2)];
      var $81=$80;
      var $82=$41;
      HEAP32[(($41)>>2)]=$81;
      var $83=HEAP32[(($41)>>2)];
      var $84=(($83)|0);
      var $85=$41;
      var $86=$42;
      var $87=(($84)|0);
      var $88=$87;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$90 & -2;
      var $92=$43;
      var $94 = $91;__label__ = 3; break;
    case 2: // $93
      var $94 = 11;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv_exit
      var $94;
      var $95=(($94-1)|0);
      var $96=$47;
      $__cap=$95;
      var $97=$__cap;
      var $98=$50;
      var $99=(($97)>>>0) >= (($98)>>>0);
      if ($99) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $100
      var $101=$40;
      HEAP32[(($40)>>2)]=$52;
      var $102=HEAPU32[(($40)>>2)];
      var $103=$39;
      HEAP32[(($39)>>2)]=$102;
      var $104=HEAP32[(($39)>>2)];
      var $105=(($104)|0);
      var $106=$38;
      HEAP32[(($38)>>2)]=$105;
      var $107=HEAP32[(($38)>>2)];
      var $108=$107;
      var $109=$37;
      HEAP32[(($37)>>2)]=$108;
      var $110=HEAP32[(($37)>>2)];
      var $111=(($110)|0);
      var $112=$37;
      var $113=$38;
      var $114=(($111)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=$116;
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 & 1;
      var $121=(($120)|0)!=0;
      var $122=$39;
      if ($121) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $123
      var $124=$33;
      HEAP32[(($33)>>2)]=$102;
      var $125=HEAP32[(($33)>>2)];
      var $126=(($125)|0);
      var $127=$32;
      HEAP32[(($32)>>2)]=$126;
      var $128=HEAP32[(($32)>>2)];
      var $129=$128;
      var $130=$31;
      HEAP32[(($31)>>2)]=$129;
      var $131=HEAP32[(($31)>>2)];
      var $132=(($131)|0);
      var $133=$31;
      var $134=$32;
      var $135=(($132)|0);
      var $136=$135;
      var $137=(($136+8)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$33;
      var $157 = $138;__label__ = 7; break;
    case 6: // $140
      var $141=$36;
      HEAP32[(($36)>>2)]=$102;
      var $142=HEAP32[(($36)>>2)];
      var $143=(($142)|0);
      var $144=$35;
      HEAP32[(($35)>>2)]=$143;
      var $145=HEAP32[(($35)>>2)];
      var $146=$145;
      var $147=$34;
      HEAP32[(($34)>>2)]=$146;
      var $148=HEAP32[(($34)>>2)];
      var $149=(($148)|0);
      var $150=$34;
      var $151=$35;
      var $152=(($149)|0);
      var $153=$152;
      var $154=(($153+1)|0);
      var $155=(($154)|0);
      var $156=$36;
      var $157 = $155;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit
      var $157;
      var $158=$40;
      $__p=$157;
      var $159=$__p;
      var $160=$49;
      var $161=$50;
      var $162=$1;
      var $163=$2;
      var $164=$3;
      HEAP32[(($1)>>2)]=$159;
      HEAP32[(($2)>>2)]=$160;
      HEAP32[(($3)>>2)]=$161;
      var $165=HEAP32[(($1)>>2)];
      var $166=HEAP32[(($2)>>2)];
      var $167=HEAP32[(($3)>>2)];
      _llvm_memmove_p0i8_p0i8_i32($165, $166, $167, 1, 0);
      var $168=$1;
      var $169=$2;
      var $170=$3;
      var $171=$50;
      var $172=$__p;
      var $173=(($172+$171)|0);
      HEAP8[($51)]=0;
      var $174=$4;
      var $175=$5;
      HEAP32[(($4)>>2)]=$173;
      HEAP32[(($5)>>2)]=$51;
      var $176=HEAP32[(($5)>>2)];
      var $177=HEAP8[($176)];
      var $178=HEAP32[(($4)>>2)];
      HEAP8[($178)]=$177;
      var $179=$4;
      var $180=$5;
      var $181=$50;
      var $182=$17;
      var $183=$18;
      HEAP32[(($17)>>2)]=$52;
      HEAP32[(($18)>>2)]=$181;
      var $184=HEAPU32[(($17)>>2)];
      var $185=$16;
      HEAP32[(($16)>>2)]=$184;
      var $186=HEAP32[(($16)>>2)];
      var $187=(($186)|0);
      var $188=$15;
      HEAP32[(($15)>>2)]=$187;
      var $189=HEAP32[(($15)>>2)];
      var $190=$189;
      var $191=$14;
      HEAP32[(($14)>>2)]=$190;
      var $192=HEAP32[(($14)>>2)];
      var $193=(($192)|0);
      var $194=$14;
      var $195=$15;
      var $196=(($193)|0);
      var $197=$196;
      var $198=(($197)|0);
      var $199=$198;
      var $200=HEAPU8[($199)];
      var $201=(($200)&255);
      var $202=$201 & 1;
      var $203=(($202)|0)!=0;
      var $204=$16;
      if ($203) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $205
      var $206=HEAP32[(($18)>>2)];
      var $207=$8;
      var $208=$9;
      HEAP32[(($8)>>2)]=$184;
      HEAP32[(($9)>>2)]=$206;
      var $209=HEAP32[(($8)>>2)];
      var $210=HEAP32[(($9)>>2)];
      var $211=(($209)|0);
      var $212=$7;
      HEAP32[(($7)>>2)]=$211;
      var $213=HEAP32[(($7)>>2)];
      var $214=$213;
      var $215=$6;
      HEAP32[(($6)>>2)]=$214;
      var $216=HEAP32[(($6)>>2)];
      var $217=(($216)|0);
      var $218=$6;
      var $219=$7;
      var $220=(($217)|0);
      var $221=$220;
      var $222=(($221+4)|0);
      HEAP32[(($222)>>2)]=$210;
      var $223=$8;
      var $224=$9;
      __label__ = 10; break;
    case 9: // $225
      var $226=HEAP32[(($18)>>2)];
      var $227=$12;
      var $228=$13;
      HEAP32[(($12)>>2)]=$184;
      HEAP32[(($13)>>2)]=$226;
      var $229=HEAP32[(($12)>>2)];
      var $230=HEAP32[(($13)>>2)];
      var $231=$230 << 1;
      var $232=(($231) & 255);
      var $233=(($229)|0);
      var $234=$11;
      HEAP32[(($11)>>2)]=$233;
      var $235=HEAP32[(($11)>>2)];
      var $236=$235;
      var $237=$10;
      HEAP32[(($10)>>2)]=$236;
      var $238=HEAP32[(($10)>>2)];
      var $239=(($238)|0);
      var $240=$10;
      var $241=$11;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      HEAP8[($245)]=$232;
      var $246=$12;
      var $247=$13;
      __label__ = 10; break;
    case 10: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj_exit
      var $248=$17;
      var $249=$18;
      var $250=$50;
      var $251=$19;
      var $252=$20;
      HEAP32[(($19)>>2)]=$52;
      HEAP32[(($20)>>2)]=$250;
      var $253=HEAP32[(($19)>>2)];
      var $254=$19;
      var $255=$20;
      __label__ = 15; break;
    case 11: // $256
      var $257=$30;
      HEAP32[(($30)>>2)]=$52;
      var $258=HEAPU32[(($30)>>2)];
      var $259=$29;
      HEAP32[(($29)>>2)]=$258;
      var $260=HEAP32[(($29)>>2)];
      var $261=(($260)|0);
      var $262=$28;
      HEAP32[(($28)>>2)]=$261;
      var $263=HEAP32[(($28)>>2)];
      var $264=$263;
      var $265=$27;
      HEAP32[(($27)>>2)]=$264;
      var $266=HEAP32[(($27)>>2)];
      var $267=(($266)|0);
      var $268=$27;
      var $269=$28;
      var $270=(($267)|0);
      var $271=$270;
      var $272=(($271)|0);
      var $273=$272;
      var $274=HEAPU8[($273)];
      var $275=(($274)&255);
      var $276=$275 & 1;
      var $277=(($276)|0)!=0;
      var $278=$29;
      if ($277) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $279
      var $280=$23;
      HEAP32[(($23)>>2)]=$258;
      var $281=HEAP32[(($23)>>2)];
      var $282=(($281)|0);
      var $283=$22;
      HEAP32[(($22)>>2)]=$282;
      var $284=HEAP32[(($22)>>2)];
      var $285=$284;
      var $286=$21;
      HEAP32[(($21)>>2)]=$285;
      var $287=HEAP32[(($21)>>2)];
      var $288=(($287)|0);
      var $289=$21;
      var $290=$22;
      var $291=(($288)|0);
      var $292=$291;
      var $293=(($292+4)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=$23;
      var $316 = $294;__label__ = 14; break;
    case 13: // $296
      var $297=$26;
      HEAP32[(($26)>>2)]=$258;
      var $298=HEAP32[(($26)>>2)];
      var $299=(($298)|0);
      var $300=$25;
      HEAP32[(($25)>>2)]=$299;
      var $301=HEAP32[(($25)>>2)];
      var $302=$301;
      var $303=$24;
      HEAP32[(($24)>>2)]=$302;
      var $304=HEAP32[(($24)>>2)];
      var $305=(($304)|0);
      var $306=$24;
      var $307=$25;
      var $308=(($305)|0);
      var $309=$308;
      var $310=(($309)|0);
      var $311=$310;
      var $312=HEAPU8[($311)];
      var $313=(($312)&255);
      var $314=$313 >> 1;
      var $315=$26;
      var $316 = $314;__label__ = 14; break;
    case 14: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $316;
      var $317=$30;
      $__sz=$316;
      var $318=$__cap;
      var $319=$50;
      var $320=$__cap;
      var $321=(($319-$320)|0);
      var $322=$__sz;
      var $323=$__sz;
      var $324=$50;
      var $325=$49;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc($52, $318, $321, $322, 0, $323, $324, $325);
      __label__ = 15; break;
    case 15: // $326
      STACKTOP = __stackBase__;
      return $52;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($this, $__s, $__sz) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $__m_i=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47;
      var $48;
      var $49;
      var $__p;
      var $__cap;
      var $50=__stackBase__+188;
      $47=$this;
      $48=$__s;
      $49=$__sz;
      var $51=$47;
      var $52=$49;
      var $53=$44;
      var $54=$__m_i;
      var $55=$45;
      var $56=$46;
      HEAP32[(($44)>>2)]=$51;
      var $57=HEAP32[(($44)>>2)];
      var $58=$43;
      HEAP32[(($43)>>2)]=$57;
      var $59=HEAP32[(($43)>>2)];
      var $60=(($59)|0);
      var $61=$42;
      HEAP32[(($42)>>2)]=$60;
      var $62=HEAP32[(($42)>>2)];
      var $63=$62;
      var $64=$41;
      HEAP32[(($41)>>2)]=$63;
      var $65=HEAP32[(($41)>>2)];
      var $66=$65;
      var $67=$41;
      var $68=$42;
      var $69=$43;
      var $70=$37;
      var $71=$38;
      var $72=$39;
      var $73=$40;
      HEAP32[(($38)>>2)]=$66;
      var $74=$40;
      var $75=HEAP32[(($38)>>2)];
      var $tmp_i_i=$37;
      var $tmp1_i_i=$39;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $76=$36;
      HEAP32[(($36)>>2)]=$75;
      var $77=HEAP32[(($36)>>2)];
      var $78=$35;
      HEAP32[(($35)>>2)]=$77;
      var $79=HEAP32[(($35)>>2)];
      var $80=$35;
      var $81=$36;
      var $82=$37;
      var $83=$38;
      var $84=$39;
      var $85=$40;
      HEAP32[(($__m_i)>>2)]=1073741823;
      var $86=HEAP32[(($__m_i)>>2)];
      var $87=(($86-1)|0);
      var $88=$44;
      var $89=$__m_i;
      var $90=$45;
      var $91=$46;
      var $92=(($52)>>>0) > (($87)>>>0);
      if ($92) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $93
      var $94=$51;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($94);
      __label__ = 2; break;
    case 2: // $95
      var $96=$49;
      var $97=(($96)>>>0) < 2;
      if ($97) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $98
      var $99=$49;
      var $100=$28;
      var $101=$29;
      HEAP32[(($28)>>2)]=$51;
      HEAP32[(($29)>>2)]=$99;
      var $102=HEAP32[(($28)>>2)];
      var $103=HEAP32[(($29)>>2)];
      var $104=$103 << 1;
      var $105=(($104) & 255);
      var $106=(($102)|0);
      var $107=$27;
      HEAP32[(($27)>>2)]=$106;
      var $108=HEAP32[(($27)>>2)];
      var $109=$108;
      var $110=$26;
      HEAP32[(($26)>>2)]=$109;
      var $111=HEAP32[(($26)>>2)];
      var $112=(($111)|0);
      var $113=$26;
      var $114=$27;
      var $115=(($112)|0);
      var $116=$115;
      var $117=(($116)|0);
      var $118=$117;
      HEAP8[($118)]=$105;
      var $119=$28;
      var $120=$29;
      var $121=$8;
      HEAP32[(($8)>>2)]=$51;
      var $122=HEAP32[(($8)>>2)];
      var $123=(($122)|0);
      var $124=$7;
      HEAP32[(($7)>>2)]=$123;
      var $125=HEAP32[(($7)>>2)];
      var $126=$125;
      var $127=$6;
      HEAP32[(($6)>>2)]=$126;
      var $128=HEAP32[(($6)>>2)];
      var $129=(($128)|0);
      var $130=$6;
      var $131=$7;
      var $132=(($129)|0);
      var $133=$132;
      var $134=(($133+4)|0);
      var $135=(($134)|0);
      var $136=$8;
      $__p=$135;
      __label__ = 8; break;
    case 4: // $137
      var $138=$49;
      var $139=$2;
      HEAP32[(($2)>>2)]=$138;
      var $140=HEAPU32[(($2)>>2)];
      var $141=(($140)>>>0) < 2;
      if ($141) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $142
      var $151 = 2;__label__ = 7; break;
    case 6: // $143
      var $144=HEAP32[(($2)>>2)];
      var $145=(($144+1)|0);
      var $146=$1;
      HEAP32[(($1)>>2)]=$145;
      var $147=HEAP32[(($1)>>2)];
      var $148=(($147+3)|0);
      var $149=$148 & -4;
      var $150=$1;
      var $151 = $149;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj_exit
      var $151;
      var $152=(($151-1)|0);
      var $153=$2;
      $__cap=$152;
      var $154=$5;
      HEAP32[(($5)>>2)]=$51;
      var $155=HEAP32[(($5)>>2)];
      var $156=(($155)|0);
      var $157=$4;
      HEAP32[(($4)>>2)]=$156;
      var $158=HEAP32[(($4)>>2)];
      var $159=$158;
      var $160=$3;
      HEAP32[(($3)>>2)]=$159;
      var $161=HEAP32[(($3)>>2)];
      var $162=$161;
      var $163=$3;
      var $164=$4;
      var $165=$5;
      var $166=$__cap;
      var $167=(($166+1)|0);
      var $168=$12;
      var $169=$13;
      HEAP32[(($12)>>2)]=$162;
      HEAP32[(($13)>>2)]=$167;
      var $170=HEAP32[(($12)>>2)];
      var $171=HEAP32[(($13)>>2)];
      var $172=$9;
      var $173=$10;
      var $174=$11;
      HEAP32[(($9)>>2)]=$170;
      HEAP32[(($10)>>2)]=$171;
      HEAP32[(($11)>>2)]=0;
      var $175=HEAP32[(($9)>>2)];
      var $176=HEAP32[(($10)>>2)];
      var $177=((($176<<2))|0);
      var $178=__Znwj($177);
      var $179=$178;
      var $180=$9;
      var $181=$10;
      var $182=$11;
      var $183=$12;
      var $184=$13;
      $__p=$179;
      var $185=$__p;
      var $186=$16;
      var $187=$17;
      HEAP32[(($16)>>2)]=$51;
      HEAP32[(($17)>>2)]=$185;
      var $188=HEAP32[(($16)>>2)];
      var $189=HEAP32[(($17)>>2)];
      var $190=(($188)|0);
      var $191=$15;
      HEAP32[(($15)>>2)]=$190;
      var $192=HEAP32[(($15)>>2)];
      var $193=$192;
      var $194=$14;
      HEAP32[(($14)>>2)]=$193;
      var $195=HEAP32[(($14)>>2)];
      var $196=(($195)|0);
      var $197=$14;
      var $198=$15;
      var $199=(($196)|0);
      var $200=$199;
      var $201=(($200+8)|0);
      HEAP32[(($201)>>2)]=$189;
      var $202=$16;
      var $203=$17;
      var $204=$__cap;
      var $205=(($204+1)|0);
      var $206=$20;
      var $207=$21;
      HEAP32[(($20)>>2)]=$51;
      HEAP32[(($21)>>2)]=$205;
      var $208=HEAP32[(($20)>>2)];
      var $209=HEAP32[(($21)>>2)];
      var $210=1 | $209;
      var $211=(($208)|0);
      var $212=$19;
      HEAP32[(($19)>>2)]=$211;
      var $213=HEAP32[(($19)>>2)];
      var $214=$213;
      var $215=$18;
      HEAP32[(($18)>>2)]=$214;
      var $216=HEAP32[(($18)>>2)];
      var $217=(($216)|0);
      var $218=$18;
      var $219=$19;
      var $220=(($217)|0);
      var $221=$220;
      var $222=(($221)|0);
      HEAP32[(($222)>>2)]=$210;
      var $223=$20;
      var $224=$21;
      var $225=$49;
      var $226=$24;
      var $227=$25;
      HEAP32[(($24)>>2)]=$51;
      HEAP32[(($25)>>2)]=$225;
      var $228=HEAP32[(($24)>>2)];
      var $229=HEAP32[(($25)>>2)];
      var $230=(($228)|0);
      var $231=$23;
      HEAP32[(($23)>>2)]=$230;
      var $232=HEAP32[(($23)>>2)];
      var $233=$232;
      var $234=$22;
      HEAP32[(($22)>>2)]=$233;
      var $235=HEAP32[(($22)>>2)];
      var $236=(($235)|0);
      var $237=$22;
      var $238=$23;
      var $239=(($236)|0);
      var $240=$239;
      var $241=(($240+4)|0);
      HEAP32[(($241)>>2)]=$229;
      var $242=$24;
      var $243=$25;
      __label__ = 8; break;
    case 8: // $244
      var $245=$__p;
      var $246=$48;
      var $247=$49;
      var $248=$30;
      var $249=$31;
      var $250=$32;
      HEAP32[(($30)>>2)]=$245;
      HEAP32[(($31)>>2)]=$246;
      HEAP32[(($32)>>2)]=$247;
      var $251=HEAP32[(($30)>>2)];
      var $252=HEAP32[(($31)>>2)];
      var $253=HEAP32[(($32)>>2)];
      var $254=_wmemcpy($251, $252, $253);
      var $255=$30;
      var $256=$31;
      var $257=$32;
      var $258=$49;
      var $259=$__p;
      var $260=(($259+($258<<2))|0);
      HEAP32[(($50)>>2)]=0;
      var $261=$33;
      var $262=$34;
      HEAP32[(($33)>>2)]=$260;
      HEAP32[(($34)>>2)]=$50;
      var $263=HEAP32[(($34)>>2)];
      var $264=HEAP32[(($263)>>2)];
      var $265=HEAP32[(($33)>>2)];
      HEAP32[(($265)>>2)]=$264;
      var $266=$33;
      var $267=$34;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($this, $__n, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $__m_i=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47;
      var $48;
      var $49;
      var $__p;
      var $__cap;
      var $50=__stackBase__+188;
      $47=$this;
      $48=$__n;
      $49=$__c;
      var $51=$47;
      var $52=$48;
      var $53=$44;
      var $54=$__m_i;
      var $55=$45;
      var $56=$46;
      HEAP32[(($44)>>2)]=$51;
      var $57=HEAP32[(($44)>>2)];
      var $58=$43;
      HEAP32[(($43)>>2)]=$57;
      var $59=HEAP32[(($43)>>2)];
      var $60=(($59)|0);
      var $61=$42;
      HEAP32[(($42)>>2)]=$60;
      var $62=HEAP32[(($42)>>2)];
      var $63=$62;
      var $64=$41;
      HEAP32[(($41)>>2)]=$63;
      var $65=HEAP32[(($41)>>2)];
      var $66=$65;
      var $67=$41;
      var $68=$42;
      var $69=$43;
      var $70=$37;
      var $71=$38;
      var $72=$39;
      var $73=$40;
      HEAP32[(($38)>>2)]=$66;
      var $74=$40;
      var $75=HEAP32[(($38)>>2)];
      var $tmp_i_i=$37;
      var $tmp1_i_i=$39;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $76=$36;
      HEAP32[(($36)>>2)]=$75;
      var $77=HEAP32[(($36)>>2)];
      var $78=$35;
      HEAP32[(($35)>>2)]=$77;
      var $79=HEAP32[(($35)>>2)];
      var $80=$35;
      var $81=$36;
      var $82=$37;
      var $83=$38;
      var $84=$39;
      var $85=$40;
      HEAP32[(($__m_i)>>2)]=1073741823;
      var $86=HEAP32[(($__m_i)>>2)];
      var $87=(($86-1)|0);
      var $88=$44;
      var $89=$__m_i;
      var $90=$45;
      var $91=$46;
      var $92=(($52)>>>0) > (($87)>>>0);
      if ($92) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $93
      var $94=$51;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($94);
      __label__ = 2; break;
    case 2: // $95
      var $96=$48;
      var $97=(($96)>>>0) < 2;
      if ($97) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $98
      var $99=$48;
      var $100=$28;
      var $101=$29;
      HEAP32[(($28)>>2)]=$51;
      HEAP32[(($29)>>2)]=$99;
      var $102=HEAP32[(($28)>>2)];
      var $103=HEAP32[(($29)>>2)];
      var $104=$103 << 1;
      var $105=(($104) & 255);
      var $106=(($102)|0);
      var $107=$27;
      HEAP32[(($27)>>2)]=$106;
      var $108=HEAP32[(($27)>>2)];
      var $109=$108;
      var $110=$26;
      HEAP32[(($26)>>2)]=$109;
      var $111=HEAP32[(($26)>>2)];
      var $112=(($111)|0);
      var $113=$26;
      var $114=$27;
      var $115=(($112)|0);
      var $116=$115;
      var $117=(($116)|0);
      var $118=$117;
      HEAP8[($118)]=$105;
      var $119=$28;
      var $120=$29;
      var $121=$8;
      HEAP32[(($8)>>2)]=$51;
      var $122=HEAP32[(($8)>>2)];
      var $123=(($122)|0);
      var $124=$7;
      HEAP32[(($7)>>2)]=$123;
      var $125=HEAP32[(($7)>>2)];
      var $126=$125;
      var $127=$6;
      HEAP32[(($6)>>2)]=$126;
      var $128=HEAP32[(($6)>>2)];
      var $129=(($128)|0);
      var $130=$6;
      var $131=$7;
      var $132=(($129)|0);
      var $133=$132;
      var $134=(($133+4)|0);
      var $135=(($134)|0);
      var $136=$8;
      $__p=$135;
      __label__ = 8; break;
    case 4: // $137
      var $138=$48;
      var $139=$2;
      HEAP32[(($2)>>2)]=$138;
      var $140=HEAPU32[(($2)>>2)];
      var $141=(($140)>>>0) < 2;
      if ($141) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $142
      var $151 = 2;__label__ = 7; break;
    case 6: // $143
      var $144=HEAP32[(($2)>>2)];
      var $145=(($144+1)|0);
      var $146=$1;
      HEAP32[(($1)>>2)]=$145;
      var $147=HEAP32[(($1)>>2)];
      var $148=(($147+3)|0);
      var $149=$148 & -4;
      var $150=$1;
      var $151 = $149;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj_exit
      var $151;
      var $152=(($151-1)|0);
      var $153=$2;
      $__cap=$152;
      var $154=$5;
      HEAP32[(($5)>>2)]=$51;
      var $155=HEAP32[(($5)>>2)];
      var $156=(($155)|0);
      var $157=$4;
      HEAP32[(($4)>>2)]=$156;
      var $158=HEAP32[(($4)>>2)];
      var $159=$158;
      var $160=$3;
      HEAP32[(($3)>>2)]=$159;
      var $161=HEAP32[(($3)>>2)];
      var $162=$161;
      var $163=$3;
      var $164=$4;
      var $165=$5;
      var $166=$__cap;
      var $167=(($166+1)|0);
      var $168=$12;
      var $169=$13;
      HEAP32[(($12)>>2)]=$162;
      HEAP32[(($13)>>2)]=$167;
      var $170=HEAP32[(($12)>>2)];
      var $171=HEAP32[(($13)>>2)];
      var $172=$9;
      var $173=$10;
      var $174=$11;
      HEAP32[(($9)>>2)]=$170;
      HEAP32[(($10)>>2)]=$171;
      HEAP32[(($11)>>2)]=0;
      var $175=HEAP32[(($9)>>2)];
      var $176=HEAP32[(($10)>>2)];
      var $177=((($176<<2))|0);
      var $178=__Znwj($177);
      var $179=$178;
      var $180=$9;
      var $181=$10;
      var $182=$11;
      var $183=$12;
      var $184=$13;
      $__p=$179;
      var $185=$__p;
      var $186=$16;
      var $187=$17;
      HEAP32[(($16)>>2)]=$51;
      HEAP32[(($17)>>2)]=$185;
      var $188=HEAP32[(($16)>>2)];
      var $189=HEAP32[(($17)>>2)];
      var $190=(($188)|0);
      var $191=$15;
      HEAP32[(($15)>>2)]=$190;
      var $192=HEAP32[(($15)>>2)];
      var $193=$192;
      var $194=$14;
      HEAP32[(($14)>>2)]=$193;
      var $195=HEAP32[(($14)>>2)];
      var $196=(($195)|0);
      var $197=$14;
      var $198=$15;
      var $199=(($196)|0);
      var $200=$199;
      var $201=(($200+8)|0);
      HEAP32[(($201)>>2)]=$189;
      var $202=$16;
      var $203=$17;
      var $204=$__cap;
      var $205=(($204+1)|0);
      var $206=$20;
      var $207=$21;
      HEAP32[(($20)>>2)]=$51;
      HEAP32[(($21)>>2)]=$205;
      var $208=HEAP32[(($20)>>2)];
      var $209=HEAP32[(($21)>>2)];
      var $210=1 | $209;
      var $211=(($208)|0);
      var $212=$19;
      HEAP32[(($19)>>2)]=$211;
      var $213=HEAP32[(($19)>>2)];
      var $214=$213;
      var $215=$18;
      HEAP32[(($18)>>2)]=$214;
      var $216=HEAP32[(($18)>>2)];
      var $217=(($216)|0);
      var $218=$18;
      var $219=$19;
      var $220=(($217)|0);
      var $221=$220;
      var $222=(($221)|0);
      HEAP32[(($222)>>2)]=$210;
      var $223=$20;
      var $224=$21;
      var $225=$48;
      var $226=$24;
      var $227=$25;
      HEAP32[(($24)>>2)]=$51;
      HEAP32[(($25)>>2)]=$225;
      var $228=HEAP32[(($24)>>2)];
      var $229=HEAP32[(($25)>>2)];
      var $230=(($228)|0);
      var $231=$23;
      HEAP32[(($23)>>2)]=$230;
      var $232=HEAP32[(($23)>>2)];
      var $233=$232;
      var $234=$22;
      HEAP32[(($22)>>2)]=$233;
      var $235=HEAP32[(($22)>>2)];
      var $236=(($235)|0);
      var $237=$22;
      var $238=$23;
      var $239=(($236)|0);
      var $240=$239;
      var $241=(($240+4)|0);
      HEAP32[(($241)>>2)]=$229;
      var $242=$24;
      var $243=$25;
      __label__ = 8; break;
    case 8: // $244
      var $245=$__p;
      var $246=$48;
      var $247=$49;
      var $248=$30;
      var $249=$31;
      var $250=$32;
      HEAP32[(($30)>>2)]=$245;
      HEAP32[(($31)>>2)]=$246;
      HEAP32[(($32)>>2)]=$247;
      var $251=HEAP32[(($30)>>2)];
      var $252=HEAP32[(($32)>>2)];
      var $253=HEAP32[(($31)>>2)];
      var $254=_wmemset($251, $252, $253);
      var $255=$30;
      var $256=$31;
      var $257=$32;
      var $258=$48;
      var $259=$__p;
      var $260=(($259+($258<<2))|0);
      HEAP32[(($50)>>2)]=0;
      var $261=$33;
      var $262=$34;
      HEAP32[(($33)>>2)]=$260;
      HEAP32[(($34)>>2)]=$50;
      var $263=HEAP32[(($34)>>2)];
      var $264=HEAP32[(($263)>>2)];
      var $265=HEAP32[(($33)>>2)];
      HEAP32[(($265)>>2)]=$264;
      var $266=$33;
      var $267=$34;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 76; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20;
      $20=$this;
      var $21=$20;
      var $22=$19;
      HEAP32[(($19)>>2)]=$21;
      var $23=HEAP32[(($19)>>2)];
      var $24=$19;
      var $25=$12;
      HEAP32[(($12)>>2)]=$21;
      var $26=HEAP32[(($12)>>2)];
      var $27=(($26)|0);
      var $28=$11;
      HEAP32[(($11)>>2)]=$27;
      var $29=HEAP32[(($11)>>2)];
      var $30=$29;
      var $31=$10;
      HEAP32[(($10)>>2)]=$30;
      var $32=HEAP32[(($10)>>2)];
      var $33=(($32)|0);
      var $34=$10;
      var $35=$11;
      var $36=(($33)|0);
      var $37=$36;
      var $38=(($37)|0);
      var $39=$38;
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$41 & 1;
      var $43=(($42)|0)!=0;
      var $44=$12;
      if ($43) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $46=$3;
      HEAP32[(($3)>>2)]=$21;
      var $47=HEAP32[(($3)>>2)];
      var $48=(($47)|0);
      var $49=$2;
      HEAP32[(($2)>>2)]=$48;
      var $50=HEAP32[(($2)>>2)];
      var $51=$50;
      var $52=$1;
      HEAP32[(($1)>>2)]=$51;
      var $53=HEAP32[(($1)>>2)];
      var $54=$53;
      var $55=$1;
      var $56=$2;
      var $57=$3;
      var $58=$6;
      HEAP32[(($6)>>2)]=$21;
      var $59=HEAP32[(($6)>>2)];
      var $60=(($59)|0);
      var $61=$5;
      HEAP32[(($5)>>2)]=$60;
      var $62=HEAP32[(($5)>>2)];
      var $63=$62;
      var $64=$4;
      HEAP32[(($4)>>2)]=$63;
      var $65=HEAP32[(($4)>>2)];
      var $66=(($65)|0);
      var $67=$4;
      var $68=$5;
      var $69=(($66)|0);
      var $70=$69;
      var $71=(($70+8)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$6;
      var $74=$9;
      HEAP32[(($9)>>2)]=$21;
      var $75=HEAP32[(($9)>>2)];
      var $76=(($75)|0);
      var $77=$8;
      HEAP32[(($8)>>2)]=$76;
      var $78=HEAP32[(($8)>>2)];
      var $79=$78;
      var $80=$7;
      HEAP32[(($7)>>2)]=$79;
      var $81=HEAP32[(($7)>>2)];
      var $82=(($81)|0);
      var $83=$7;
      var $84=$8;
      var $85=(($82)|0);
      var $86=$85;
      var $87=(($86)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$88 & -2;
      var $90=$9;
      var $91=$16;
      var $92=$17;
      var $93=$18;
      HEAP32[(($16)>>2)]=$54;
      HEAP32[(($17)>>2)]=$72;
      HEAP32[(($18)>>2)]=$89;
      var $94=HEAP32[(($16)>>2)];
      var $95=HEAP32[(($17)>>2)];
      var $96=HEAP32[(($18)>>2)];
      var $97=$13;
      var $98=$14;
      var $99=$15;
      HEAP32[(($13)>>2)]=$94;
      HEAP32[(($14)>>2)]=$95;
      HEAP32[(($15)>>2)]=$96;
      var $100=HEAP32[(($13)>>2)];
      var $101=HEAP32[(($14)>>2)];
      var $102=$101;
      __ZdlPv($102);
      var $103=$13;
      var $104=$14;
      var $105=$15;
      var $106=$16;
      var $107=$17;
      var $108=$18;
      __label__ = 2; break;
    case 2: // $109
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($this, $__str) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30;
      var $31;
      $30=$this;
      $31=$__str;
      var $32=$30;
      var $33=$31;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 1; break; } else { __label__ = 8; break; }
    case 1: // $35
      var $36=$31;
      var $37=$26;
      var $38=$27;
      var $39=$28;
      var $40=$29;
      HEAP32[(($27)>>2)]=$32;
      HEAP32[(($28)>>2)]=$36;
      var $41=HEAP32[(($27)>>2)];
      var $42=HEAP32[(($28)>>2)];
      var $tmp_i=$26;
      var $tmp1_i=$29;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $43=$24;
      var $44=$25;
      HEAP32[(($24)>>2)]=$41;
      HEAP32[(($25)>>2)]=$42;
      var $45=HEAP32[(($24)>>2)];
      var $46=$24;
      var $47=$25;
      var $48=$26;
      var $49=$27;
      var $50=$28;
      var $51=$29;
      var $52=$31;
      var $53=$22;
      var $54=$23;
      HEAP32[(($22)>>2)]=$32;
      HEAP32[(($23)>>2)]=$52;
      var $55=HEAP32[(($22)>>2)];
      var $56=HEAP32[(($23)>>2)];
      var $57=$21;
      HEAP32[(($21)>>2)]=$56;
      var $58=HEAP32[(($21)>>2)];
      var $59=$20;
      HEAP32[(($20)>>2)]=$58;
      var $60=HEAPU32[(($20)>>2)];
      var $61=$19;
      HEAP32[(($19)>>2)]=$60;
      var $62=HEAP32[(($19)>>2)];
      var $63=(($62)|0);
      var $64=$18;
      HEAP32[(($18)>>2)]=$63;
      var $65=HEAP32[(($18)>>2)];
      var $66=$65;
      var $67=$17;
      HEAP32[(($17)>>2)]=$66;
      var $68=HEAP32[(($17)>>2)];
      var $69=(($68)|0);
      var $70=$17;
      var $71=$18;
      var $72=(($69)|0);
      var $73=$72;
      var $74=(($73)|0);
      var $75=$74;
      var $76=HEAPU8[($75)];
      var $77=(($76)&255);
      var $78=$77 & 1;
      var $79=(($78)|0)!=0;
      var $80=$19;
      if ($79) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $81
      var $82=$13;
      HEAP32[(($13)>>2)]=$60;
      var $83=HEAP32[(($13)>>2)];
      var $84=(($83)|0);
      var $85=$12;
      HEAP32[(($12)>>2)]=$84;
      var $86=HEAP32[(($12)>>2)];
      var $87=$86;
      var $88=$11;
      HEAP32[(($11)>>2)]=$87;
      var $89=HEAP32[(($11)>>2)];
      var $90=(($89)|0);
      var $91=$11;
      var $92=$12;
      var $93=(($90)|0);
      var $94=$93;
      var $95=(($94+8)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$13;
      var $115 = $96;__label__ = 4; break;
    case 3: // $98
      var $99=$16;
      HEAP32[(($16)>>2)]=$60;
      var $100=HEAP32[(($16)>>2)];
      var $101=(($100)|0);
      var $102=$15;
      HEAP32[(($15)>>2)]=$101;
      var $103=HEAP32[(($15)>>2)];
      var $104=$103;
      var $105=$14;
      HEAP32[(($14)>>2)]=$104;
      var $106=HEAP32[(($14)>>2)];
      var $107=(($106)|0);
      var $108=$14;
      var $109=$15;
      var $110=(($107)|0);
      var $111=$110;
      var $112=(($111+4)|0);
      var $113=(($112)|0);
      var $114=$16;
      var $115 = $113;__label__ = 4; break;
    case 4: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit_i
      var $115;
      var $116=$20;
      var $117=$21;
      var $118=HEAP32[(($23)>>2)];
      var $119=$10;
      HEAP32[(($10)>>2)]=$118;
      var $120=HEAPU32[(($10)>>2)];
      var $121=$9;
      HEAP32[(($9)>>2)]=$120;
      var $122=HEAP32[(($9)>>2)];
      var $123=(($122)|0);
      var $124=$8;
      HEAP32[(($8)>>2)]=$123;
      var $125=HEAP32[(($8)>>2)];
      var $126=$125;
      var $127=$7;
      HEAP32[(($7)>>2)]=$126;
      var $128=HEAP32[(($7)>>2)];
      var $129=(($128)|0);
      var $130=$7;
      var $131=$8;
      var $132=(($129)|0);
      var $133=$132;
      var $134=(($133)|0);
      var $135=$134;
      var $136=HEAPU8[($135)];
      var $137=(($136)&255);
      var $138=$137 & 1;
      var $139=(($138)|0)!=0;
      var $140=$9;
      if ($139) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $141
      var $142=$3;
      HEAP32[(($3)>>2)]=$120;
      var $143=HEAP32[(($3)>>2)];
      var $144=(($143)|0);
      var $145=$2;
      HEAP32[(($2)>>2)]=$144;
      var $146=HEAP32[(($2)>>2)];
      var $147=$146;
      var $148=$1;
      HEAP32[(($1)>>2)]=$147;
      var $149=HEAP32[(($1)>>2)];
      var $150=(($149)|0);
      var $151=$1;
      var $152=$2;
      var $153=(($150)|0);
      var $154=$153;
      var $155=(($154+4)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$3;
      var $178 = $156;__label__ = 7; break;
    case 6: // $158
      var $159=$6;
      HEAP32[(($6)>>2)]=$120;
      var $160=HEAP32[(($6)>>2)];
      var $161=(($160)|0);
      var $162=$5;
      HEAP32[(($5)>>2)]=$161;
      var $163=HEAP32[(($5)>>2)];
      var $164=$163;
      var $165=$4;
      HEAP32[(($4)>>2)]=$164;
      var $166=HEAP32[(($4)>>2)];
      var $167=(($166)|0);
      var $168=$4;
      var $169=$5;
      var $170=(($167)|0);
      var $171=$170;
      var $172=(($171)|0);
      var $173=$172;
      var $174=HEAPU8[($173)];
      var $175=(($174)&255);
      var $176=$175 >> 1;
      var $177=$6;
      var $178 = $176;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5__exit
      var $178;
      var $179=$10;
      var $180=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj($55, $115, $178);
      var $181=$22;
      var $182=$23;
      __label__ = 8; break;
    case 8: // $183
      STACKTOP = __stackBase__;
      return $32;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($this, $__s) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $3;
  $2=$this;
  $3=$__s;
  var $4=$2;
  var $5=$3;
  var $6=$3;
  var $7=$1;
  HEAP32[(($1)>>2)]=$6;
  var $8=HEAP32[(($1)>>2)];
  var $9=_wcslen($8);
  var $10=$1;
  var $11=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj($4, $5, $9);
  STACKTOP = __stackBase__;
  return $11;
}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($this, $__c) {
  var __stackBase__  = STACKTOP; STACKTOP += 184; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45;
      var $46=__stackBase__+176;
      var $__cap;
      var $__sz;
      var $__p;
      var $47=__stackBase__+180;
      $45=$this;
      HEAP32[(($46)>>2)]=$__c;
      var $48=$45;
      var $49=$44;
      HEAP32[(($44)>>2)]=$48;
      var $50=HEAPU32[(($44)>>2)];
      var $51=$43;
      HEAP32[(($43)>>2)]=$50;
      var $52=HEAP32[(($43)>>2)];
      var $53=(($52)|0);
      var $54=$42;
      HEAP32[(($42)>>2)]=$53;
      var $55=HEAP32[(($42)>>2)];
      var $56=$55;
      var $57=$41;
      HEAP32[(($41)>>2)]=$56;
      var $58=HEAP32[(($41)>>2)];
      var $59=(($58)|0);
      var $60=$41;
      var $61=$42;
      var $62=(($59)|0);
      var $63=$62;
      var $64=(($63)|0);
      var $65=$64;
      var $66=HEAPU8[($65)];
      var $67=(($66)&255);
      var $68=$67 & 1;
      var $69=(($68)|0)!=0;
      var $70=$43;
      if ($69) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $71
      var $72=$40;
      HEAP32[(($40)>>2)]=$50;
      var $73=HEAP32[(($40)>>2)];
      var $74=(($73)|0);
      var $75=$39;
      HEAP32[(($39)>>2)]=$74;
      var $76=HEAP32[(($39)>>2)];
      var $77=$76;
      var $78=$38;
      HEAP32[(($38)>>2)]=$77;
      var $79=HEAP32[(($38)>>2)];
      var $80=(($79)|0);
      var $81=$38;
      var $82=$39;
      var $83=(($80)|0);
      var $84=$83;
      var $85=(($84)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$86 & -2;
      var $88=$40;
      var $90 = $87;__label__ = 3; break;
    case 2: // $89
      var $90 = 2;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8capacityEv_exit
      var $90;
      var $91=(($90-1)|0);
      var $92=$44;
      $__cap=$91;
      var $93=$10;
      HEAP32[(($10)>>2)]=$48;
      var $94=HEAPU32[(($10)>>2)];
      var $95=$9;
      HEAP32[(($9)>>2)]=$94;
      var $96=HEAP32[(($9)>>2)];
      var $97=(($96)|0);
      var $98=$8;
      HEAP32[(($8)>>2)]=$97;
      var $99=HEAP32[(($8)>>2)];
      var $100=$99;
      var $101=$7;
      HEAP32[(($7)>>2)]=$100;
      var $102=HEAP32[(($7)>>2)];
      var $103=(($102)|0);
      var $104=$7;
      var $105=$8;
      var $106=(($103)|0);
      var $107=$106;
      var $108=(($107)|0);
      var $109=$108;
      var $110=HEAPU8[($109)];
      var $111=(($110)&255);
      var $112=$111 & 1;
      var $113=(($112)|0)!=0;
      var $114=$9;
      if ($113) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $115
      var $116=$3;
      HEAP32[(($3)>>2)]=$94;
      var $117=HEAP32[(($3)>>2)];
      var $118=(($117)|0);
      var $119=$2;
      HEAP32[(($2)>>2)]=$118;
      var $120=HEAP32[(($2)>>2)];
      var $121=$120;
      var $122=$1;
      HEAP32[(($1)>>2)]=$121;
      var $123=HEAP32[(($1)>>2)];
      var $124=(($123)|0);
      var $125=$1;
      var $126=$2;
      var $127=(($124)|0);
      var $128=$127;
      var $129=(($128+4)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=$3;
      var $152 = $130;__label__ = 6; break;
    case 5: // $132
      var $133=$6;
      HEAP32[(($6)>>2)]=$94;
      var $134=HEAP32[(($6)>>2)];
      var $135=(($134)|0);
      var $136=$5;
      HEAP32[(($5)>>2)]=$135;
      var $137=HEAP32[(($5)>>2)];
      var $138=$137;
      var $139=$4;
      HEAP32[(($4)>>2)]=$138;
      var $140=HEAP32[(($4)>>2)];
      var $141=(($140)|0);
      var $142=$4;
      var $143=$5;
      var $144=(($141)|0);
      var $145=$144;
      var $146=(($145)|0);
      var $147=$146;
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 >> 1;
      var $151=$6;
      var $152 = $150;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $152;
      var $153=$10;
      $__sz=$152;
      var $154=$__sz;
      var $155=$__cap;
      var $156=(($154)|0)==(($155)|0);
      if ($156) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $157
      var $158=$__cap;
      var $159=$__sz;
      var $160=$__sz;
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj($48, $158, 1, $159, $160, 0, 0);
      __label__ = 8; break;
    case 8: // $161
      var $162=$20;
      HEAP32[(($20)>>2)]=$48;
      var $163=HEAPU32[(($20)>>2)];
      var $164=$19;
      HEAP32[(($19)>>2)]=$163;
      var $165=HEAP32[(($19)>>2)];
      var $166=(($165)|0);
      var $167=$18;
      HEAP32[(($18)>>2)]=$166;
      var $168=HEAP32[(($18)>>2)];
      var $169=$168;
      var $170=$17;
      HEAP32[(($17)>>2)]=$169;
      var $171=HEAP32[(($17)>>2)];
      var $172=(($171)|0);
      var $173=$17;
      var $174=$18;
      var $175=(($172)|0);
      var $176=$175;
      var $177=(($176)|0);
      var $178=$177;
      var $179=HEAPU8[($178)];
      var $180=(($179)&255);
      var $181=$180 & 1;
      var $182=(($181)|0)!=0;
      var $183=$19;
      if ($182) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $184
      var $185=$13;
      HEAP32[(($13)>>2)]=$163;
      var $186=HEAP32[(($13)>>2)];
      var $187=(($186)|0);
      var $188=$12;
      HEAP32[(($12)>>2)]=$187;
      var $189=HEAP32[(($12)>>2)];
      var $190=$189;
      var $191=$11;
      HEAP32[(($11)>>2)]=$190;
      var $192=HEAP32[(($11)>>2)];
      var $193=(($192)|0);
      var $194=$11;
      var $195=$12;
      var $196=(($193)|0);
      var $197=$196;
      var $198=(($197+8)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=$13;
      var $218 = $199;__label__ = 11; break;
    case 10: // $201
      var $202=$16;
      HEAP32[(($16)>>2)]=$163;
      var $203=HEAP32[(($16)>>2)];
      var $204=(($203)|0);
      var $205=$15;
      HEAP32[(($15)>>2)]=$204;
      var $206=HEAP32[(($15)>>2)];
      var $207=$206;
      var $208=$14;
      HEAP32[(($14)>>2)]=$207;
      var $209=HEAP32[(($14)>>2)];
      var $210=(($209)|0);
      var $211=$14;
      var $212=$15;
      var $213=(($210)|0);
      var $214=$213;
      var $215=(($214+4)|0);
      var $216=(($215)|0);
      var $217=$16;
      var $218 = $216;__label__ = 11; break;
    case 11: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv_exit
      var $218;
      var $219=$20;
      var $220=$__sz;
      var $221=(($218+($220<<2))|0);
      $__p=$221;
      var $222=$__p;
      var $223=$21;
      var $224=$22;
      HEAP32[(($21)>>2)]=$222;
      HEAP32[(($22)>>2)]=$46;
      var $225=HEAP32[(($22)>>2)];
      var $226=HEAP32[(($225)>>2)];
      var $227=HEAP32[(($21)>>2)];
      HEAP32[(($227)>>2)]=$226;
      var $228=$21;
      var $229=$22;
      var $230=$__p;
      var $231=(($230+4)|0);
      $__p=$231;
      HEAP32[(($47)>>2)]=0;
      var $232=$23;
      var $233=$24;
      HEAP32[(($23)>>2)]=$231;
      HEAP32[(($24)>>2)]=$47;
      var $234=HEAP32[(($24)>>2)];
      var $235=HEAP32[(($234)>>2)];
      var $236=HEAP32[(($23)>>2)];
      HEAP32[(($236)>>2)]=$235;
      var $237=$23;
      var $238=$24;
      var $239=$__sz;
      var $240=(($239+1)|0);
      var $241=$36;
      var $242=$37;
      HEAP32[(($36)>>2)]=$48;
      HEAP32[(($37)>>2)]=$240;
      var $243=HEAPU32[(($36)>>2)];
      var $244=$35;
      HEAP32[(($35)>>2)]=$243;
      var $245=HEAP32[(($35)>>2)];
      var $246=(($245)|0);
      var $247=$34;
      HEAP32[(($34)>>2)]=$246;
      var $248=HEAP32[(($34)>>2)];
      var $249=$248;
      var $250=$33;
      HEAP32[(($33)>>2)]=$249;
      var $251=HEAP32[(($33)>>2)];
      var $252=(($251)|0);
      var $253=$33;
      var $254=$34;
      var $255=(($252)|0);
      var $256=$255;
      var $257=(($256)|0);
      var $258=$257;
      var $259=HEAPU8[($258)];
      var $260=(($259)&255);
      var $261=$260 & 1;
      var $262=(($261)|0)!=0;
      var $263=$35;
      if ($262) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $264
      var $265=HEAP32[(($37)>>2)];
      var $266=$27;
      var $267=$28;
      HEAP32[(($27)>>2)]=$243;
      HEAP32[(($28)>>2)]=$265;
      var $268=HEAP32[(($27)>>2)];
      var $269=HEAP32[(($28)>>2)];
      var $270=(($268)|0);
      var $271=$26;
      HEAP32[(($26)>>2)]=$270;
      var $272=HEAP32[(($26)>>2)];
      var $273=$272;
      var $274=$25;
      HEAP32[(($25)>>2)]=$273;
      var $275=HEAP32[(($25)>>2)];
      var $276=(($275)|0);
      var $277=$25;
      var $278=$26;
      var $279=(($276)|0);
      var $280=$279;
      var $281=(($280+4)|0);
      HEAP32[(($281)>>2)]=$269;
      var $282=$27;
      var $283=$28;
      __label__ = 14; break;
    case 13: // $284
      var $285=HEAP32[(($37)>>2)];
      var $286=$31;
      var $287=$32;
      HEAP32[(($31)>>2)]=$243;
      HEAP32[(($32)>>2)]=$285;
      var $288=HEAP32[(($31)>>2)];
      var $289=HEAP32[(($32)>>2)];
      var $290=$289 << 1;
      var $291=(($290) & 255);
      var $292=(($288)|0);
      var $293=$30;
      HEAP32[(($30)>>2)]=$292;
      var $294=HEAP32[(($30)>>2)];
      var $295=$294;
      var $296=$29;
      HEAP32[(($29)>>2)]=$295;
      var $297=HEAP32[(($29)>>2)];
      var $298=(($297)|0);
      var $299=$29;
      var $300=$30;
      var $301=(($298)|0);
      var $302=$301;
      var $303=(($302)|0);
      var $304=$303;
      HEAP8[($304)]=$291;
      var $305=$31;
      var $306=$32;
      __label__ = 14; break;
    case 14: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE10__set_sizeEj_exit
      var $307=$36;
      var $308=$37;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw($this, $__old_cap, $__delta_cap, $__old_sz, $__n_copy, $__n_del, $__n_add, $__p_new_stuff) {
  var __stackBase__  = STACKTOP; STACKTOP += 312; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $__m_i=__stackBase__+288;
      var $73=__stackBase__+292;
      var $74=__stackBase__+296;
      var $75;
      var $76;
      var $77;
      var $78;
      var $79;
      var $80;
      var $81;
      var $82;
      var $__ms;
      var $__old_p;
      var $__cap;
      var $83=__stackBase__+300;
      var $84=__stackBase__+304;
      var $__p;
      var $__sec_cp_sz;
      var $85=__stackBase__+308;
      $75=$this;
      $76=$__old_cap;
      $77=$__delta_cap;
      $78=$__old_sz;
      $79=$__n_copy;
      $80=$__n_del;
      $81=$__n_add;
      $82=$__p_new_stuff;
      var $86=$75;
      var $87=$72;
      var $88=$__m_i;
      var $89=$73;
      var $90=$74;
      HEAP32[(($72)>>2)]=$86;
      var $91=HEAP32[(($72)>>2)];
      var $92=$71;
      HEAP32[(($71)>>2)]=$91;
      var $93=HEAP32[(($71)>>2)];
      var $94=(($93)|0);
      var $95=$70;
      HEAP32[(($70)>>2)]=$94;
      var $96=HEAP32[(($70)>>2)];
      var $97=$96;
      var $98=$69;
      HEAP32[(($69)>>2)]=$97;
      var $99=HEAP32[(($69)>>2)];
      var $100=$99;
      var $101=$69;
      var $102=$70;
      var $103=$71;
      var $104=$65;
      var $105=$66;
      var $106=$67;
      var $107=$68;
      HEAP32[(($66)>>2)]=$100;
      var $108=$68;
      var $109=HEAP32[(($66)>>2)];
      var $tmp_i_i=$65;
      var $tmp1_i_i=$67;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $110=$64;
      HEAP32[(($64)>>2)]=$109;
      var $111=HEAP32[(($64)>>2)];
      var $112=$63;
      HEAP32[(($63)>>2)]=$111;
      var $113=HEAP32[(($63)>>2)];
      var $114=$63;
      var $115=$64;
      var $116=$65;
      var $117=$66;
      var $118=$67;
      var $119=$68;
      HEAP32[(($__m_i)>>2)]=1073741823;
      var $120=HEAP32[(($__m_i)>>2)];
      var $121=(($120-1)|0);
      var $122=$72;
      var $123=$__m_i;
      var $124=$73;
      var $125=$74;
      $__ms=$121;
      var $126=$77;
      var $127=$__ms;
      var $128=$76;
      var $129=(($127-$128)|0);
      var $130=(($129-1)|0);
      var $131=(($126)>>>0) > (($130)>>>0);
      if ($131) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $132
      var $133=$86;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($133);
      __label__ = 2; break;
    case 2: // $134
      var $135=$42;
      HEAP32[(($42)>>2)]=$86;
      var $136=HEAPU32[(($42)>>2)];
      var $137=$41;
      HEAP32[(($41)>>2)]=$136;
      var $138=HEAP32[(($41)>>2)];
      var $139=(($138)|0);
      var $140=$40;
      HEAP32[(($40)>>2)]=$139;
      var $141=HEAP32[(($40)>>2)];
      var $142=$141;
      var $143=$39;
      HEAP32[(($39)>>2)]=$142;
      var $144=HEAP32[(($39)>>2)];
      var $145=(($144)|0);
      var $146=$39;
      var $147=$40;
      var $148=(($145)|0);
      var $149=$148;
      var $150=(($149)|0);
      var $151=$150;
      var $152=HEAPU8[($151)];
      var $153=(($152)&255);
      var $154=$153 & 1;
      var $155=(($154)|0)!=0;
      var $156=$41;
      if ($155) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $157
      var $158=$35;
      HEAP32[(($35)>>2)]=$136;
      var $159=HEAP32[(($35)>>2)];
      var $160=(($159)|0);
      var $161=$34;
      HEAP32[(($34)>>2)]=$160;
      var $162=HEAP32[(($34)>>2)];
      var $163=$162;
      var $164=$33;
      HEAP32[(($33)>>2)]=$163;
      var $165=HEAP32[(($33)>>2)];
      var $166=(($165)|0);
      var $167=$33;
      var $168=$34;
      var $169=(($166)|0);
      var $170=$169;
      var $171=(($170+8)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=$35;
      var $191 = $172;__label__ = 5; break;
    case 4: // $174
      var $175=$38;
      HEAP32[(($38)>>2)]=$136;
      var $176=HEAP32[(($38)>>2)];
      var $177=(($176)|0);
      var $178=$37;
      HEAP32[(($37)>>2)]=$177;
      var $179=HEAP32[(($37)>>2)];
      var $180=$179;
      var $181=$36;
      HEAP32[(($36)>>2)]=$180;
      var $182=HEAP32[(($36)>>2)];
      var $183=(($182)|0);
      var $184=$36;
      var $185=$37;
      var $186=(($183)|0);
      var $187=$186;
      var $188=(($187+4)|0);
      var $189=(($188)|0);
      var $190=$38;
      var $191 = $189;__label__ = 5; break;
    case 5: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv_exit
      var $191;
      var $192=$42;
      $__old_p=$191;
      var $193=$76;
      var $194=$__ms;
      var $195=Math.floor((($194)>>>0)/2);
      var $196=(($195-16)|0);
      var $197=(($193)>>>0) < (($196)>>>0);
      if ($197) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $198
      var $199=$76;
      var $200=$77;
      var $201=(($199+$200)|0);
      HEAP32[(($83)>>2)]=$201;
      var $202=$76;
      var $203=((($202<<1))|0);
      HEAP32[(($84)>>2)]=$203;
      var $204=$23;
      var $205=$24;
      var $206=$25;
      var $207=$26;
      HEAP32[(($24)>>2)]=$83;
      HEAP32[(($25)>>2)]=$84;
      var $208=HEAP32[(($24)>>2)];
      var $209=HEAP32[(($25)>>2)];
      var $tmp_i=$23;
      var $tmp1_i=$26;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $210=$21;
      var $211=$22;
      HEAP32[(($21)>>2)]=$208;
      HEAP32[(($22)>>2)]=$209;
      var $212=HEAP32[(($21)>>2)];
      var $213=HEAP32[(($22)>>2)];
      var $214=$18;
      var $215=$19;
      var $216=$20;
      HEAP32[(($18)>>2)]=$23;
      HEAP32[(($19)>>2)]=$212;
      HEAP32[(($20)>>2)]=$213;
      var $217=HEAP32[(($18)>>2)];
      var $218=HEAP32[(($19)>>2)];
      var $219=HEAPU32[(($218)>>2)];
      var $220=HEAP32[(($20)>>2)];
      var $221=HEAPU32[(($220)>>2)];
      var $222=(($219)>>>0) < (($221)>>>0);
      var $223=$18;
      var $224=$19;
      var $225=$20;
      if ($222) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $226
      var $227=HEAP32[(($22)>>2)];
      var $230 = $227;__label__ = 9; break;
    case 8: // $228
      var $229=HEAP32[(($21)>>2)];
      var $230 = $229;__label__ = 9; break;
    case 9: // $_ZNSt3__13maxIjEERKT_S3_S3__exit
      var $230;
      var $231=$21;
      var $232=$22;
      var $233=$23;
      var $234=$24;
      var $235=$25;
      var $236=$26;
      var $237=HEAP32[(($230)>>2)];
      var $238=$14;
      HEAP32[(($14)>>2)]=$237;
      var $239=HEAPU32[(($14)>>2)];
      var $240=(($239)>>>0) < 2;
      if ($240) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $241
      var $250 = 2;__label__ = 12; break;
    case 11: // $242
      var $243=HEAP32[(($14)>>2)];
      var $244=(($243+1)|0);
      var $245=$13;
      HEAP32[(($13)>>2)]=$244;
      var $246=HEAP32[(($13)>>2)];
      var $247=(($246+3)|0);
      var $248=$247 & -4;
      var $249=$13;
      var $250 = $248;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj_exit
      var $250;
      var $251=(($250-1)|0);
      var $252=$14;
      var $257 = $251;__label__ = 14; break;
    case 13: // $253
      var $254=$__ms;
      var $255=(($254-1)|0);
      var $257 = $255;__label__ = 14; break;
    case 14: // $256
      var $257;
      $__cap=$257;
      var $258=$9;
      HEAP32[(($9)>>2)]=$86;
      var $259=HEAP32[(($9)>>2)];
      var $260=(($259)|0);
      var $261=$8;
      HEAP32[(($8)>>2)]=$260;
      var $262=HEAP32[(($8)>>2)];
      var $263=$262;
      var $264=$7;
      HEAP32[(($7)>>2)]=$263;
      var $265=HEAP32[(($7)>>2)];
      var $266=$265;
      var $267=$7;
      var $268=$8;
      var $269=$9;
      var $270=$__cap;
      var $271=(($270+1)|0);
      var $272=$4;
      var $273=$5;
      HEAP32[(($4)>>2)]=$266;
      HEAP32[(($5)>>2)]=$271;
      var $274=HEAP32[(($4)>>2)];
      var $275=HEAP32[(($5)>>2)];
      var $276=$1;
      var $277=$2;
      var $278=$3;
      HEAP32[(($1)>>2)]=$274;
      HEAP32[(($2)>>2)]=$275;
      HEAP32[(($3)>>2)]=0;
      var $279=HEAP32[(($1)>>2)];
      var $280=HEAP32[(($2)>>2)];
      var $281=((($280<<2))|0);
      var $282=__Znwj($281);
      var $283=$282;
      var $284=$1;
      var $285=$2;
      var $286=$3;
      var $287=$4;
      var $288=$5;
      $__p=$283;
      var $289=$6;
      HEAP32[(($6)>>2)]=$86;
      var $290=HEAP32[(($6)>>2)];
      var $291=$6;
      var $292=$79;
      var $293=(($292)|0)!=0;
      if ($293) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $294
      var $295=$__p;
      var $296=$__old_p;
      var $297=$79;
      var $298=$10;
      var $299=$11;
      var $300=$12;
      HEAP32[(($10)>>2)]=$295;
      HEAP32[(($11)>>2)]=$296;
      HEAP32[(($12)>>2)]=$297;
      var $301=HEAP32[(($10)>>2)];
      var $302=HEAP32[(($11)>>2)];
      var $303=HEAP32[(($12)>>2)];
      var $304=_wmemcpy($301, $302, $303);
      var $305=$10;
      var $306=$11;
      var $307=$12;
      __label__ = 16; break;
    case 16: // $308
      var $309=$81;
      var $310=(($309)|0)!=0;
      if ($310) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $311
      var $312=$__p;
      var $313=$79;
      var $314=(($312+($313<<2))|0);
      var $315=$82;
      var $316=$81;
      var $317=$15;
      var $318=$16;
      var $319=$17;
      HEAP32[(($15)>>2)]=$314;
      HEAP32[(($16)>>2)]=$315;
      HEAP32[(($17)>>2)]=$316;
      var $320=HEAP32[(($15)>>2)];
      var $321=HEAP32[(($16)>>2)];
      var $322=HEAP32[(($17)>>2)];
      var $323=_wmemcpy($320, $321, $322);
      var $324=$15;
      var $325=$16;
      var $326=$17;
      __label__ = 18; break;
    case 18: // $327
      var $328=$78;
      var $329=$80;
      var $330=(($328-$329)|0);
      var $331=$79;
      var $332=(($330-$331)|0);
      $__sec_cp_sz=$332;
      var $333=$__sec_cp_sz;
      var $334=(($333)|0)!=0;
      if ($334) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $335
      var $336=$__p;
      var $337=$79;
      var $338=(($336+($337<<2))|0);
      var $339=$81;
      var $340=(($338+($339<<2))|0);
      var $341=$__old_p;
      var $342=$79;
      var $343=(($341+($342<<2))|0);
      var $344=$80;
      var $345=(($343+($344<<2))|0);
      var $346=$__sec_cp_sz;
      var $347=$27;
      var $348=$28;
      var $349=$29;
      HEAP32[(($27)>>2)]=$340;
      HEAP32[(($28)>>2)]=$345;
      HEAP32[(($29)>>2)]=$346;
      var $350=HEAP32[(($27)>>2)];
      var $351=HEAP32[(($28)>>2)];
      var $352=HEAP32[(($29)>>2)];
      var $353=_wmemcpy($350, $351, $352);
      var $354=$27;
      var $355=$28;
      var $356=$29;
      __label__ = 20; break;
    case 20: // $357
      var $358=$76;
      var $359=(($358+1)|0);
      var $360=(($359)|0)!=2;
      if ($360) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $361
      var $362=$32;
      HEAP32[(($32)>>2)]=$86;
      var $363=HEAP32[(($32)>>2)];
      var $364=(($363)|0);
      var $365=$31;
      HEAP32[(($31)>>2)]=$364;
      var $366=HEAP32[(($31)>>2)];
      var $367=$366;
      var $368=$30;
      HEAP32[(($30)>>2)]=$367;
      var $369=HEAP32[(($30)>>2)];
      var $370=$369;
      var $371=$30;
      var $372=$31;
      var $373=$32;
      var $374=$__old_p;
      var $375=$76;
      var $376=(($375+1)|0);
      var $377=$46;
      var $378=$47;
      var $379=$48;
      HEAP32[(($46)>>2)]=$370;
      HEAP32[(($47)>>2)]=$374;
      HEAP32[(($48)>>2)]=$376;
      var $380=HEAP32[(($46)>>2)];
      var $381=HEAP32[(($47)>>2)];
      var $382=HEAP32[(($48)>>2)];
      var $383=$43;
      var $384=$44;
      var $385=$45;
      HEAP32[(($43)>>2)]=$380;
      HEAP32[(($44)>>2)]=$381;
      HEAP32[(($45)>>2)]=$382;
      var $386=HEAP32[(($43)>>2)];
      var $387=HEAP32[(($44)>>2)];
      var $388=$387;
      __ZdlPv($388);
      var $389=$43;
      var $390=$44;
      var $391=$45;
      var $392=$46;
      var $393=$47;
      var $394=$48;
      __label__ = 22; break;
    case 22: // $395
      var $396=$__p;
      var $397=$51;
      var $398=$52;
      HEAP32[(($51)>>2)]=$86;
      HEAP32[(($52)>>2)]=$396;
      var $399=HEAP32[(($51)>>2)];
      var $400=HEAP32[(($52)>>2)];
      var $401=(($399)|0);
      var $402=$50;
      HEAP32[(($50)>>2)]=$401;
      var $403=HEAP32[(($50)>>2)];
      var $404=$403;
      var $405=$49;
      HEAP32[(($49)>>2)]=$404;
      var $406=HEAP32[(($49)>>2)];
      var $407=(($406)|0);
      var $408=$49;
      var $409=$50;
      var $410=(($407)|0);
      var $411=$410;
      var $412=(($411+8)|0);
      HEAP32[(($412)>>2)]=$400;
      var $413=$51;
      var $414=$52;
      var $415=$__cap;
      var $416=(($415+1)|0);
      var $417=$55;
      var $418=$56;
      HEAP32[(($55)>>2)]=$86;
      HEAP32[(($56)>>2)]=$416;
      var $419=HEAP32[(($55)>>2)];
      var $420=HEAP32[(($56)>>2)];
      var $421=1 | $420;
      var $422=(($419)|0);
      var $423=$54;
      HEAP32[(($54)>>2)]=$422;
      var $424=HEAP32[(($54)>>2)];
      var $425=$424;
      var $426=$53;
      HEAP32[(($53)>>2)]=$425;
      var $427=HEAP32[(($53)>>2)];
      var $428=(($427)|0);
      var $429=$53;
      var $430=$54;
      var $431=(($428)|0);
      var $432=$431;
      var $433=(($432)|0);
      HEAP32[(($433)>>2)]=$421;
      var $434=$55;
      var $435=$56;
      var $436=$79;
      var $437=$81;
      var $438=(($436+$437)|0);
      var $439=$__sec_cp_sz;
      var $440=(($438+$439)|0);
      $78=$440;
      var $441=$78;
      var $442=$59;
      var $443=$60;
      HEAP32[(($59)>>2)]=$86;
      HEAP32[(($60)>>2)]=$441;
      var $444=HEAP32[(($59)>>2)];
      var $445=HEAP32[(($60)>>2)];
      var $446=(($444)|0);
      var $447=$58;
      HEAP32[(($58)>>2)]=$446;
      var $448=HEAP32[(($58)>>2)];
      var $449=$448;
      var $450=$57;
      HEAP32[(($57)>>2)]=$449;
      var $451=HEAP32[(($57)>>2)];
      var $452=(($451)|0);
      var $453=$57;
      var $454=$58;
      var $455=(($452)|0);
      var $456=$455;
      var $457=(($456+4)|0);
      HEAP32[(($457)>>2)]=$445;
      var $458=$59;
      var $459=$60;
      var $460=$78;
      var $461=$__p;
      var $462=(($461+($460<<2))|0);
      HEAP32[(($85)>>2)]=0;
      var $463=$61;
      var $464=$62;
      HEAP32[(($61)>>2)]=$462;
      HEAP32[(($62)>>2)]=$85;
      var $465=HEAP32[(($62)>>2)];
      var $466=HEAP32[(($465)>>2)];
      var $467=HEAP32[(($61)>>2)];
      HEAP32[(($467)>>2)]=$466;
      var $468=$61;
      var $469=$62;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj($this, $__old_cap, $__delta_cap, $__old_sz, $__n_copy, $__n_del, $__n_add) {
  var __stackBase__  = STACKTOP; STACKTOP += 272; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $__m_i=__stackBase__+252;
      var $64=__stackBase__+256;
      var $65=__stackBase__+260;
      var $66;
      var $67;
      var $68;
      var $69;
      var $70;
      var $71;
      var $72;
      var $__ms;
      var $__old_p;
      var $__cap;
      var $73=__stackBase__+264;
      var $74=__stackBase__+268;
      var $__p;
      var $__sec_cp_sz;
      $66=$this;
      $67=$__old_cap;
      $68=$__delta_cap;
      $69=$__old_sz;
      $70=$__n_copy;
      $71=$__n_del;
      $72=$__n_add;
      var $75=$66;
      var $76=$63;
      var $77=$__m_i;
      var $78=$64;
      var $79=$65;
      HEAP32[(($63)>>2)]=$75;
      var $80=HEAP32[(($63)>>2)];
      var $81=$62;
      HEAP32[(($62)>>2)]=$80;
      var $82=HEAP32[(($62)>>2)];
      var $83=(($82)|0);
      var $84=$61;
      HEAP32[(($61)>>2)]=$83;
      var $85=HEAP32[(($61)>>2)];
      var $86=$85;
      var $87=$60;
      HEAP32[(($60)>>2)]=$86;
      var $88=HEAP32[(($60)>>2)];
      var $89=$88;
      var $90=$60;
      var $91=$61;
      var $92=$62;
      var $93=$56;
      var $94=$57;
      var $95=$58;
      var $96=$59;
      HEAP32[(($57)>>2)]=$89;
      var $97=$59;
      var $98=HEAP32[(($57)>>2)];
      var $tmp_i_i=$56;
      var $tmp1_i_i=$58;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $99=$55;
      HEAP32[(($55)>>2)]=$98;
      var $100=HEAP32[(($55)>>2)];
      var $101=$54;
      HEAP32[(($54)>>2)]=$100;
      var $102=HEAP32[(($54)>>2)];
      var $103=$54;
      var $104=$55;
      var $105=$56;
      var $106=$57;
      var $107=$58;
      var $108=$59;
      HEAP32[(($__m_i)>>2)]=1073741823;
      var $109=HEAP32[(($__m_i)>>2)];
      var $110=(($109-1)|0);
      var $111=$63;
      var $112=$__m_i;
      var $113=$64;
      var $114=$65;
      $__ms=$110;
      var $115=$68;
      var $116=$__ms;
      var $117=$67;
      var $118=(($116-$117)|0);
      var $119=(($118-1)|0);
      var $120=(($115)>>>0) > (($119)>>>0);
      if ($120) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $121
      var $122=$75;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($122);
      __label__ = 2; break;
    case 2: // $123
      var $124=$39;
      HEAP32[(($39)>>2)]=$75;
      var $125=HEAPU32[(($39)>>2)];
      var $126=$38;
      HEAP32[(($38)>>2)]=$125;
      var $127=HEAP32[(($38)>>2)];
      var $128=(($127)|0);
      var $129=$37;
      HEAP32[(($37)>>2)]=$128;
      var $130=HEAP32[(($37)>>2)];
      var $131=$130;
      var $132=$36;
      HEAP32[(($36)>>2)]=$131;
      var $133=HEAP32[(($36)>>2)];
      var $134=(($133)|0);
      var $135=$36;
      var $136=$37;
      var $137=(($134)|0);
      var $138=$137;
      var $139=(($138)|0);
      var $140=$139;
      var $141=HEAPU8[($140)];
      var $142=(($141)&255);
      var $143=$142 & 1;
      var $144=(($143)|0)!=0;
      var $145=$38;
      if ($144) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $146
      var $147=$32;
      HEAP32[(($32)>>2)]=$125;
      var $148=HEAP32[(($32)>>2)];
      var $149=(($148)|0);
      var $150=$31;
      HEAP32[(($31)>>2)]=$149;
      var $151=HEAP32[(($31)>>2)];
      var $152=$151;
      var $153=$30;
      HEAP32[(($30)>>2)]=$152;
      var $154=HEAP32[(($30)>>2)];
      var $155=(($154)|0);
      var $156=$30;
      var $157=$31;
      var $158=(($155)|0);
      var $159=$158;
      var $160=(($159+8)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=$32;
      var $180 = $161;__label__ = 5; break;
    case 4: // $163
      var $164=$35;
      HEAP32[(($35)>>2)]=$125;
      var $165=HEAP32[(($35)>>2)];
      var $166=(($165)|0);
      var $167=$34;
      HEAP32[(($34)>>2)]=$166;
      var $168=HEAP32[(($34)>>2)];
      var $169=$168;
      var $170=$33;
      HEAP32[(($33)>>2)]=$169;
      var $171=HEAP32[(($33)>>2)];
      var $172=(($171)|0);
      var $173=$33;
      var $174=$34;
      var $175=(($172)|0);
      var $176=$175;
      var $177=(($176+4)|0);
      var $178=(($177)|0);
      var $179=$35;
      var $180 = $178;__label__ = 5; break;
    case 5: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv_exit
      var $180;
      var $181=$39;
      $__old_p=$180;
      var $182=$67;
      var $183=$__ms;
      var $184=Math.floor((($183)>>>0)/2);
      var $185=(($184-16)|0);
      var $186=(($182)>>>0) < (($185)>>>0);
      if ($186) { __label__ = 6; break; } else { __label__ = 13; break; }
    case 6: // $187
      var $188=$67;
      var $189=$68;
      var $190=(($188+$189)|0);
      HEAP32[(($73)>>2)]=$190;
      var $191=$67;
      var $192=((($191<<1))|0);
      HEAP32[(($74)>>2)]=$192;
      var $193=$20;
      var $194=$21;
      var $195=$22;
      var $196=$23;
      HEAP32[(($21)>>2)]=$73;
      HEAP32[(($22)>>2)]=$74;
      var $197=HEAP32[(($21)>>2)];
      var $198=HEAP32[(($22)>>2)];
      var $tmp_i=$20;
      var $tmp1_i=$23;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $199=$18;
      var $200=$19;
      HEAP32[(($18)>>2)]=$197;
      HEAP32[(($19)>>2)]=$198;
      var $201=HEAP32[(($18)>>2)];
      var $202=HEAP32[(($19)>>2)];
      var $203=$15;
      var $204=$16;
      var $205=$17;
      HEAP32[(($15)>>2)]=$20;
      HEAP32[(($16)>>2)]=$201;
      HEAP32[(($17)>>2)]=$202;
      var $206=HEAP32[(($15)>>2)];
      var $207=HEAP32[(($16)>>2)];
      var $208=HEAPU32[(($207)>>2)];
      var $209=HEAP32[(($17)>>2)];
      var $210=HEAPU32[(($209)>>2)];
      var $211=(($208)>>>0) < (($210)>>>0);
      var $212=$15;
      var $213=$16;
      var $214=$17;
      if ($211) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $215
      var $216=HEAP32[(($19)>>2)];
      var $219 = $216;__label__ = 9; break;
    case 8: // $217
      var $218=HEAP32[(($18)>>2)];
      var $219 = $218;__label__ = 9; break;
    case 9: // $_ZNSt3__13maxIjEERKT_S3_S3__exit
      var $219;
      var $220=$18;
      var $221=$19;
      var $222=$20;
      var $223=$21;
      var $224=$22;
      var $225=$23;
      var $226=HEAP32[(($219)>>2)];
      var $227=$11;
      HEAP32[(($11)>>2)]=$226;
      var $228=HEAPU32[(($11)>>2)];
      var $229=(($228)>>>0) < 2;
      if ($229) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $230
      var $239 = 2;__label__ = 12; break;
    case 11: // $231
      var $232=HEAP32[(($11)>>2)];
      var $233=(($232+1)|0);
      var $234=$10;
      HEAP32[(($10)>>2)]=$233;
      var $235=HEAP32[(($10)>>2)];
      var $236=(($235+3)|0);
      var $237=$236 & -4;
      var $238=$10;
      var $239 = $237;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj_exit
      var $239;
      var $240=(($239-1)|0);
      var $241=$11;
      var $246 = $240;__label__ = 14; break;
    case 13: // $242
      var $243=$__ms;
      var $244=(($243-1)|0);
      var $246 = $244;__label__ = 14; break;
    case 14: // $245
      var $246;
      $__cap=$246;
      var $247=$3;
      HEAP32[(($3)>>2)]=$75;
      var $248=HEAP32[(($3)>>2)];
      var $249=(($248)|0);
      var $250=$2;
      HEAP32[(($2)>>2)]=$249;
      var $251=HEAP32[(($2)>>2)];
      var $252=$251;
      var $253=$1;
      HEAP32[(($1)>>2)]=$252;
      var $254=HEAP32[(($1)>>2)];
      var $255=$254;
      var $256=$1;
      var $257=$2;
      var $258=$3;
      var $259=$__cap;
      var $260=(($259+1)|0);
      var $261=$7;
      var $262=$8;
      HEAP32[(($7)>>2)]=$255;
      HEAP32[(($8)>>2)]=$260;
      var $263=HEAP32[(($7)>>2)];
      var $264=HEAP32[(($8)>>2)];
      var $265=$4;
      var $266=$5;
      var $267=$6;
      HEAP32[(($4)>>2)]=$263;
      HEAP32[(($5)>>2)]=$264;
      HEAP32[(($6)>>2)]=0;
      var $268=HEAP32[(($4)>>2)];
      var $269=HEAP32[(($5)>>2)];
      var $270=((($269<<2))|0);
      var $271=__Znwj($270);
      var $272=$271;
      var $273=$4;
      var $274=$5;
      var $275=$6;
      var $276=$7;
      var $277=$8;
      $__p=$272;
      var $278=$9;
      HEAP32[(($9)>>2)]=$75;
      var $279=HEAP32[(($9)>>2)];
      var $280=$9;
      var $281=$70;
      var $282=(($281)|0)!=0;
      if ($282) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $283
      var $284=$__p;
      var $285=$__old_p;
      var $286=$70;
      var $287=$12;
      var $288=$13;
      var $289=$14;
      HEAP32[(($12)>>2)]=$284;
      HEAP32[(($13)>>2)]=$285;
      HEAP32[(($14)>>2)]=$286;
      var $290=HEAP32[(($12)>>2)];
      var $291=HEAP32[(($13)>>2)];
      var $292=HEAP32[(($14)>>2)];
      var $293=_wmemcpy($290, $291, $292);
      var $294=$12;
      var $295=$13;
      var $296=$14;
      __label__ = 16; break;
    case 16: // $297
      var $298=$69;
      var $299=$71;
      var $300=(($298-$299)|0);
      var $301=$70;
      var $302=(($300-$301)|0);
      $__sec_cp_sz=$302;
      var $303=$__sec_cp_sz;
      var $304=(($303)|0)!=0;
      if ($304) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $305
      var $306=$__p;
      var $307=$70;
      var $308=(($306+($307<<2))|0);
      var $309=$72;
      var $310=(($308+($309<<2))|0);
      var $311=$__old_p;
      var $312=$70;
      var $313=(($311+($312<<2))|0);
      var $314=$71;
      var $315=(($313+($314<<2))|0);
      var $316=$__sec_cp_sz;
      var $317=$24;
      var $318=$25;
      var $319=$26;
      HEAP32[(($24)>>2)]=$310;
      HEAP32[(($25)>>2)]=$315;
      HEAP32[(($26)>>2)]=$316;
      var $320=HEAP32[(($24)>>2)];
      var $321=HEAP32[(($25)>>2)];
      var $322=HEAP32[(($26)>>2)];
      var $323=_wmemcpy($320, $321, $322);
      var $324=$24;
      var $325=$25;
      var $326=$26;
      __label__ = 18; break;
    case 18: // $327
      var $328=$67;
      var $329=(($328+1)|0);
      var $330=(($329)|0)!=2;
      if ($330) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $331
      var $332=$29;
      HEAP32[(($29)>>2)]=$75;
      var $333=HEAP32[(($29)>>2)];
      var $334=(($333)|0);
      var $335=$28;
      HEAP32[(($28)>>2)]=$334;
      var $336=HEAP32[(($28)>>2)];
      var $337=$336;
      var $338=$27;
      HEAP32[(($27)>>2)]=$337;
      var $339=HEAP32[(($27)>>2)];
      var $340=$339;
      var $341=$27;
      var $342=$28;
      var $343=$29;
      var $344=$__old_p;
      var $345=$67;
      var $346=(($345+1)|0);
      var $347=$43;
      var $348=$44;
      var $349=$45;
      HEAP32[(($43)>>2)]=$340;
      HEAP32[(($44)>>2)]=$344;
      HEAP32[(($45)>>2)]=$346;
      var $350=HEAP32[(($43)>>2)];
      var $351=HEAP32[(($44)>>2)];
      var $352=HEAP32[(($45)>>2)];
      var $353=$40;
      var $354=$41;
      var $355=$42;
      HEAP32[(($40)>>2)]=$350;
      HEAP32[(($41)>>2)]=$351;
      HEAP32[(($42)>>2)]=$352;
      var $356=HEAP32[(($40)>>2)];
      var $357=HEAP32[(($41)>>2)];
      var $358=$357;
      __ZdlPv($358);
      var $359=$40;
      var $360=$41;
      var $361=$42;
      var $362=$43;
      var $363=$44;
      var $364=$45;
      __label__ = 20; break;
    case 20: // $365
      var $366=$__p;
      var $367=$48;
      var $368=$49;
      HEAP32[(($48)>>2)]=$75;
      HEAP32[(($49)>>2)]=$366;
      var $369=HEAP32[(($48)>>2)];
      var $370=HEAP32[(($49)>>2)];
      var $371=(($369)|0);
      var $372=$47;
      HEAP32[(($47)>>2)]=$371;
      var $373=HEAP32[(($47)>>2)];
      var $374=$373;
      var $375=$46;
      HEAP32[(($46)>>2)]=$374;
      var $376=HEAP32[(($46)>>2)];
      var $377=(($376)|0);
      var $378=$46;
      var $379=$47;
      var $380=(($377)|0);
      var $381=$380;
      var $382=(($381+8)|0);
      HEAP32[(($382)>>2)]=$370;
      var $383=$48;
      var $384=$49;
      var $385=$__cap;
      var $386=(($385+1)|0);
      var $387=$52;
      var $388=$53;
      HEAP32[(($52)>>2)]=$75;
      HEAP32[(($53)>>2)]=$386;
      var $389=HEAP32[(($52)>>2)];
      var $390=HEAP32[(($53)>>2)];
      var $391=1 | $390;
      var $392=(($389)|0);
      var $393=$51;
      HEAP32[(($51)>>2)]=$392;
      var $394=HEAP32[(($51)>>2)];
      var $395=$394;
      var $396=$50;
      HEAP32[(($50)>>2)]=$395;
      var $397=HEAP32[(($50)>>2)];
      var $398=(($397)|0);
      var $399=$50;
      var $400=$51;
      var $401=(($398)|0);
      var $402=$401;
      var $403=(($402)|0);
      HEAP32[(($403)>>2)]=$391;
      var $404=$52;
      var $405=$53;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj["X"]=1;

function __ZNSt9exceptionD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return;
}


function __ZNKSt9exception4whatEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return ((STRING_TABLE.__str1221650)|0);
}


function __ZSt13get_terminatev() {
  ;
  var __label__;

  var $1=(tempValue=HEAP32[((__ZL19__terminate_handler)>>2)],HEAP32[((__ZL19__terminate_handler)>>2)]=tempValue+0,tempValue);
  var $2=$1;
  ;
  return $2;
}


function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj($this, $__s, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48;
      var $49;
      var $50;
      var $__cap;
      var $__p;
      var $51=__stackBase__+188;
      var $__sz;
      $48=$this;
      $49=$__s;
      $50=$__n;
      var $52=$48;
      var $53=$47;
      HEAP32[(($47)>>2)]=$52;
      var $54=HEAPU32[(($47)>>2)];
      var $55=$46;
      HEAP32[(($46)>>2)]=$54;
      var $56=HEAP32[(($46)>>2)];
      var $57=(($56)|0);
      var $58=$45;
      HEAP32[(($45)>>2)]=$57;
      var $59=HEAP32[(($45)>>2)];
      var $60=$59;
      var $61=$44;
      HEAP32[(($44)>>2)]=$60;
      var $62=HEAP32[(($44)>>2)];
      var $63=(($62)|0);
      var $64=$44;
      var $65=$45;
      var $66=(($63)|0);
      var $67=$66;
      var $68=(($67)|0);
      var $69=$68;
      var $70=HEAPU8[($69)];
      var $71=(($70)&255);
      var $72=$71 & 1;
      var $73=(($72)|0)!=0;
      var $74=$46;
      if ($73) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $75
      var $76=$43;
      HEAP32[(($43)>>2)]=$54;
      var $77=HEAP32[(($43)>>2)];
      var $78=(($77)|0);
      var $79=$42;
      HEAP32[(($42)>>2)]=$78;
      var $80=HEAP32[(($42)>>2)];
      var $81=$80;
      var $82=$41;
      HEAP32[(($41)>>2)]=$81;
      var $83=HEAP32[(($41)>>2)];
      var $84=(($83)|0);
      var $85=$41;
      var $86=$42;
      var $87=(($84)|0);
      var $88=$87;
      var $89=(($88)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=$90 & -2;
      var $92=$43;
      var $94 = $91;__label__ = 3; break;
    case 2: // $93
      var $94 = 2;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8capacityEv_exit
      var $94;
      var $95=(($94-1)|0);
      var $96=$47;
      $__cap=$95;
      var $97=$__cap;
      var $98=$50;
      var $99=(($97)>>>0) >= (($98)>>>0);
      if ($99) { __label__ = 4; break; } else { __label__ = 11; break; }
    case 4: // $100
      var $101=$40;
      HEAP32[(($40)>>2)]=$52;
      var $102=HEAPU32[(($40)>>2)];
      var $103=$39;
      HEAP32[(($39)>>2)]=$102;
      var $104=HEAP32[(($39)>>2)];
      var $105=(($104)|0);
      var $106=$38;
      HEAP32[(($38)>>2)]=$105;
      var $107=HEAP32[(($38)>>2)];
      var $108=$107;
      var $109=$37;
      HEAP32[(($37)>>2)]=$108;
      var $110=HEAP32[(($37)>>2)];
      var $111=(($110)|0);
      var $112=$37;
      var $113=$38;
      var $114=(($111)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=$116;
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 & 1;
      var $121=(($120)|0)!=0;
      var $122=$39;
      if ($121) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $123
      var $124=$33;
      HEAP32[(($33)>>2)]=$102;
      var $125=HEAP32[(($33)>>2)];
      var $126=(($125)|0);
      var $127=$32;
      HEAP32[(($32)>>2)]=$126;
      var $128=HEAP32[(($32)>>2)];
      var $129=$128;
      var $130=$31;
      HEAP32[(($31)>>2)]=$129;
      var $131=HEAP32[(($31)>>2)];
      var $132=(($131)|0);
      var $133=$31;
      var $134=$32;
      var $135=(($132)|0);
      var $136=$135;
      var $137=(($136+8)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$33;
      var $157 = $138;__label__ = 7; break;
    case 6: // $140
      var $141=$36;
      HEAP32[(($36)>>2)]=$102;
      var $142=HEAP32[(($36)>>2)];
      var $143=(($142)|0);
      var $144=$35;
      HEAP32[(($35)>>2)]=$143;
      var $145=HEAP32[(($35)>>2)];
      var $146=$145;
      var $147=$34;
      HEAP32[(($34)>>2)]=$146;
      var $148=HEAP32[(($34)>>2)];
      var $149=(($148)|0);
      var $150=$34;
      var $151=$35;
      var $152=(($149)|0);
      var $153=$152;
      var $154=(($153+4)|0);
      var $155=(($154)|0);
      var $156=$36;
      var $157 = $155;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv_exit
      var $157;
      var $158=$40;
      $__p=$157;
      var $159=$__p;
      var $160=$49;
      var $161=$50;
      var $162=$1;
      var $163=$2;
      var $164=$3;
      HEAP32[(($1)>>2)]=$159;
      HEAP32[(($2)>>2)]=$160;
      HEAP32[(($3)>>2)]=$161;
      var $165=HEAP32[(($1)>>2)];
      var $166=HEAP32[(($2)>>2)];
      var $167=HEAP32[(($3)>>2)];
      var $168=_wmemmove($165, $166, $167);
      var $169=$1;
      var $170=$2;
      var $171=$3;
      var $172=$50;
      var $173=$__p;
      var $174=(($173+($172<<2))|0);
      HEAP32[(($51)>>2)]=0;
      var $175=$4;
      var $176=$5;
      HEAP32[(($4)>>2)]=$174;
      HEAP32[(($5)>>2)]=$51;
      var $177=HEAP32[(($5)>>2)];
      var $178=HEAP32[(($177)>>2)];
      var $179=HEAP32[(($4)>>2)];
      HEAP32[(($179)>>2)]=$178;
      var $180=$4;
      var $181=$5;
      var $182=$50;
      var $183=$17;
      var $184=$18;
      HEAP32[(($17)>>2)]=$52;
      HEAP32[(($18)>>2)]=$182;
      var $185=HEAPU32[(($17)>>2)];
      var $186=$16;
      HEAP32[(($16)>>2)]=$185;
      var $187=HEAP32[(($16)>>2)];
      var $188=(($187)|0);
      var $189=$15;
      HEAP32[(($15)>>2)]=$188;
      var $190=HEAP32[(($15)>>2)];
      var $191=$190;
      var $192=$14;
      HEAP32[(($14)>>2)]=$191;
      var $193=HEAP32[(($14)>>2)];
      var $194=(($193)|0);
      var $195=$14;
      var $196=$15;
      var $197=(($194)|0);
      var $198=$197;
      var $199=(($198)|0);
      var $200=$199;
      var $201=HEAPU8[($200)];
      var $202=(($201)&255);
      var $203=$202 & 1;
      var $204=(($203)|0)!=0;
      var $205=$16;
      if ($204) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $206
      var $207=HEAP32[(($18)>>2)];
      var $208=$8;
      var $209=$9;
      HEAP32[(($8)>>2)]=$185;
      HEAP32[(($9)>>2)]=$207;
      var $210=HEAP32[(($8)>>2)];
      var $211=HEAP32[(($9)>>2)];
      var $212=(($210)|0);
      var $213=$7;
      HEAP32[(($7)>>2)]=$212;
      var $214=HEAP32[(($7)>>2)];
      var $215=$214;
      var $216=$6;
      HEAP32[(($6)>>2)]=$215;
      var $217=HEAP32[(($6)>>2)];
      var $218=(($217)|0);
      var $219=$6;
      var $220=$7;
      var $221=(($218)|0);
      var $222=$221;
      var $223=(($222+4)|0);
      HEAP32[(($223)>>2)]=$211;
      var $224=$8;
      var $225=$9;
      __label__ = 10; break;
    case 9: // $226
      var $227=HEAP32[(($18)>>2)];
      var $228=$12;
      var $229=$13;
      HEAP32[(($12)>>2)]=$185;
      HEAP32[(($13)>>2)]=$227;
      var $230=HEAP32[(($12)>>2)];
      var $231=HEAP32[(($13)>>2)];
      var $232=$231 << 1;
      var $233=(($232) & 255);
      var $234=(($230)|0);
      var $235=$11;
      HEAP32[(($11)>>2)]=$234;
      var $236=HEAP32[(($11)>>2)];
      var $237=$236;
      var $238=$10;
      HEAP32[(($10)>>2)]=$237;
      var $239=HEAP32[(($10)>>2)];
      var $240=(($239)|0);
      var $241=$10;
      var $242=$11;
      var $243=(($240)|0);
      var $244=$243;
      var $245=(($244)|0);
      var $246=$245;
      HEAP8[($246)]=$233;
      var $247=$12;
      var $248=$13;
      __label__ = 10; break;
    case 10: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE10__set_sizeEj_exit
      var $249=$17;
      var $250=$18;
      var $251=$50;
      var $252=$19;
      var $253=$20;
      HEAP32[(($19)>>2)]=$52;
      HEAP32[(($20)>>2)]=$251;
      var $254=HEAP32[(($19)>>2)];
      var $255=$19;
      var $256=$20;
      __label__ = 15; break;
    case 11: // $257
      var $258=$30;
      HEAP32[(($30)>>2)]=$52;
      var $259=HEAPU32[(($30)>>2)];
      var $260=$29;
      HEAP32[(($29)>>2)]=$259;
      var $261=HEAP32[(($29)>>2)];
      var $262=(($261)|0);
      var $263=$28;
      HEAP32[(($28)>>2)]=$262;
      var $264=HEAP32[(($28)>>2)];
      var $265=$264;
      var $266=$27;
      HEAP32[(($27)>>2)]=$265;
      var $267=HEAP32[(($27)>>2)];
      var $268=(($267)|0);
      var $269=$27;
      var $270=$28;
      var $271=(($268)|0);
      var $272=$271;
      var $273=(($272)|0);
      var $274=$273;
      var $275=HEAPU8[($274)];
      var $276=(($275)&255);
      var $277=$276 & 1;
      var $278=(($277)|0)!=0;
      var $279=$29;
      if ($278) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $280
      var $281=$23;
      HEAP32[(($23)>>2)]=$259;
      var $282=HEAP32[(($23)>>2)];
      var $283=(($282)|0);
      var $284=$22;
      HEAP32[(($22)>>2)]=$283;
      var $285=HEAP32[(($22)>>2)];
      var $286=$285;
      var $287=$21;
      HEAP32[(($21)>>2)]=$286;
      var $288=HEAP32[(($21)>>2)];
      var $289=(($288)|0);
      var $290=$21;
      var $291=$22;
      var $292=(($289)|0);
      var $293=$292;
      var $294=(($293+4)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$23;
      var $317 = $295;__label__ = 14; break;
    case 13: // $297
      var $298=$26;
      HEAP32[(($26)>>2)]=$259;
      var $299=HEAP32[(($26)>>2)];
      var $300=(($299)|0);
      var $301=$25;
      HEAP32[(($25)>>2)]=$300;
      var $302=HEAP32[(($25)>>2)];
      var $303=$302;
      var $304=$24;
      HEAP32[(($24)>>2)]=$303;
      var $305=HEAP32[(($24)>>2)];
      var $306=(($305)|0);
      var $307=$24;
      var $308=$25;
      var $309=(($306)|0);
      var $310=$309;
      var $311=(($310)|0);
      var $312=$311;
      var $313=HEAPU8[($312)];
      var $314=(($313)&255);
      var $315=$314 >> 1;
      var $316=$26;
      var $317 = $315;__label__ = 14; break;
    case 14: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $317;
      var $318=$30;
      $__sz=$317;
      var $319=$__cap;
      var $320=$50;
      var $321=$__cap;
      var $322=(($320-$321)|0);
      var $323=$__sz;
      var $324=$__sz;
      var $325=$50;
      var $326=$49;
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw($52, $319, $322, $323, 0, $324, $325, $326);
      __label__ = 15; break;
    case 15: // $327
      STACKTOP = __stackBase__;
      return $52;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj["X"]=1;

function __ZNSt9exceptionD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt9exceptionD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt3__18ios_baseD2Ev($this) {
  ;
  var __label__;

  var $1;
  var $loc_storage;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__18ios_baseE+8)|0);
  __ZNSt3__18ios_base16__call_callbacksENS0_5eventE($2, 0);
  var $4=(($2+28)|0);
  var $5=$4;
  $loc_storage=$5;
  var $6=$loc_storage;
  FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
  var $7=(($2+32)|0);
  var $8=HEAP32[(($7)>>2)];
  var $9=$8;
  _free($9);
  var $10=(($2+36)|0);
  var $11=HEAP32[(($10)>>2)];
  var $12=$11;
  _free($12);
  var $13=(($2+48)|0);
  var $14=HEAP32[(($13)>>2)];
  var $15=$14;
  _free($15);
  var $16=(($2+60)|0);
  var $17=HEAP32[(($16)>>2)];
  var $18=$17;
  _free($18);
  ;
  return;
}


function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__18ios_baseD2Ev($3);
  ;
  return;
}


function __ZSt9terminatev() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=__ZSt13get_terminatev();
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$3]() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $4
      (function() { try { __THREW__ = false; return _abort() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $5
      __label__ = 7; break;
    case 3: // $6
      var $7=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $8=$7.f0;
      $1=$8;
      var $9=$7.f1;
      $2=$9;
      __label__ = 4; break;
    case 4: // $10
      var $11=$1;
      var $12=___cxa_begin_catch($11);
      (function() { try { __THREW__ = false; return _abort() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $13
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $14
      __label__ = 7; break;
    case 7: // $15
      ;
      return;
    case 8: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $1=$18;
      var $19=$17.f1;
      $2=$19;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 9: // $20
      var $21=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $22=$21.f0;
      $1=$22;
      var $23=$21.f1;
      $2=$23;
      __label__ = 11; break;
    case 10: // $24
      __label__ = 11; break;
    case 11: // $25
      var $26=$1;
      ___cxa_call_unexpected($26);
      throw "Reached an unreachable!"
    case 12: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZSt18uncaught_exceptionv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      (function() { try { __THREW__ = false; return _abort() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $4
      var $5=$1;
      ;
      return $5;
    case 2: // $6
      var $7=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $8=$7.f0;
      $2=$8;
      var $9=$7.f1;
      $3=$9;
      __label__ = 3; break;
    case 3: // $10
      var $11=$2;
      ___cxa_call_unexpected($11);
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18ios_base5clearEj($this, $state) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23;
      var $24;
      var $25=__stackBase__+92;
      var $26;
      var $27;
      $23=$this;
      $24=$state;
      var $28=$23;
      var $29=(($28+24)|0);
      var $30=HEAP32[(($29)>>2)];
      var $31=(($30)|0)!=0;
      if ($31) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $32
      var $33=$24;
      var $34=(($28+16)|0);
      HEAP32[(($34)>>2)]=$33;
      __label__ = 3; break;
    case 2: // $35
      var $36=$24;
      var $37=$36 | 1;
      var $38=(($28+16)|0);
      HEAP32[(($38)>>2)]=$37;
      __label__ = 3; break;
    case 3: // $39
      var $40=$24;
      var $41=(($28+24)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)!=0;
      var $44=$43 ? 0 : 1;
      var $45=$40 | $44;
      var $46=(($28+20)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=$45 & $47;
      var $49=(($48)|0)!=0;
      if ($49) { __label__ = 4; break; } else { __label__ = 9; break; }
    case 4: // $50
      var $51=___cxa_allocate_exception(16);
      var $52=$51;
      var $53=$20;
      var $54=$21;
      var $55=$22;
      HEAP32[(($20)>>2)]=$25;
      HEAP32[(($21)>>2)]=1;
      HEAP32[(($22)>>2)]=0;
      var $56=HEAP32[(($20)>>2)];
      var $57=HEAP32[(($21)>>2)];
      var $58=HEAP32[(($22)>>2)];
      var $59=$8;
      var $60=$13;
      var $61=$14;
      var $62=$15;
      var $63=$16;
      var $64=$17;
      var $65=$18;
      var $66=$19;
      HEAP32[(($13)>>2)]=$56;
      HEAP32[(($14)>>2)]=$57;
      HEAP32[(($15)>>2)]=$58;
      var $67=HEAP32[(($13)>>2)];
      var $68=HEAP32[(($14)>>2)];
      var $69=$11;
      var $70=$12;
      HEAP32[(($11)>>2)]=$17;
      HEAP32[(($12)>>2)]=$68;
      var $71=HEAP32[(($11)>>2)];
      var $72=HEAP32[(($12)>>2)];
      var $73=$9;
      var $74=$10;
      HEAP32[(($9)>>2)]=$71;
      HEAP32[(($10)>>2)]=$72;
      var $75=HEAP32[(($9)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($10)>>2)];
      HEAP32[(($76)>>2)]=$77;
      var $78=$9;
      var $79=$10;
      var $80=$11;
      var $81=$12;
      var $tmp_i_i=$8;
      var $tmp1_i_i=$17;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];HEAP8[($tmp_i_i+1)]=HEAP8[($tmp1_i_i+1)];HEAP8[($tmp_i_i+2)]=HEAP8[($tmp1_i_i+2)];HEAP8[($tmp_i_i+3)]=HEAP8[($tmp1_i_i+3)];
      var $82=$7;
      HEAP32[(($7)>>2)]=$8;
      var $83=HEAP32[(($7)>>2)];
      var $84=(($83)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$7;
      var $87=(function() { try { __THREW__ = false; return __ZNSt3__117iostream_categoryEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 5; break; };
    case 5: // $88
      var $89=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $90=$89.f0;
      HEAP32[(($18)>>2)]=$90;
      var $91=$89.f1;
      HEAP32[(($19)>>2)]=$91;
      var $92=HEAP32[(($18)>>2)];
      ___cxa_call_unexpected($92);
      throw "Reached an unreachable!"
    case 6: // $_ZNSt3__110error_codeC1INS_7io_errc1_EEET_PNS_9enable_ifIXsr18is_error_code_enumIS4_EE5valueEvE4typeE_exit
      var $93=$4;
      var $94=$5;
      var $95=$6;
      HEAP32[(($4)>>2)]=$16;
      HEAP32[(($5)>>2)]=$85;
      HEAP32[(($6)>>2)]=$87;
      var $96=HEAP32[(($4)>>2)];
      var $97=HEAP32[(($5)>>2)];
      var $98=HEAP32[(($6)>>2)];
      var $99=$1;
      var $100=$2;
      var $101=$3;
      HEAP32[(($1)>>2)]=$96;
      HEAP32[(($2)>>2)]=$97;
      HEAP32[(($3)>>2)]=$98;
      var $102=HEAP32[(($1)>>2)];
      var $103=(($102)|0);
      var $104=HEAP32[(($2)>>2)];
      HEAP32[(($103)>>2)]=$104;
      var $105=(($102+4)|0);
      var $106=HEAP32[(($3)>>2)];
      HEAP32[(($105)>>2)]=$106;
      var $107=$1;
      var $108=$2;
      var $109=$3;
      var $110=$4;
      var $111=$5;
      var $112=$6;
      var $113=$67;
      var $114=$16;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($113)>>2)]=HEAP32[(($114)>>2)];HEAP32[(($113+4)>>2)]=HEAP32[(($114+4)>>2)];
      var $115=$8;
      var $116=$13;
      var $117=$14;
      var $118=$15;
      var $119=$16;
      var $120=$17;
      var $121=$18;
      var $122=$19;
      var $123=$20;
      var $124=$21;
      var $125=$22;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__18ios_base7failureC1EPKcRKNS_10error_codeE]($52, ((STRING_TABLE.__str2158)|0), $25) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $126
      ___cxa_throw($51, __ZTINSt3__18ios_base7failureE, 1676);
      throw "Reached an unreachable!"
    case 8: // $127
      var $128=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $129=$128.f0;
      $26=$129;
      var $130=$128.f1;
      $27=$130;
      ___cxa_free_exception($51);
      __label__ = 10; break;
    case 9: // $131
      STACKTOP = __stackBase__;
      return;
    case 10: // $132
      var $133=$26;
      var $134=$26;
      var $135=$27;
      var $136=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $134, tempValue);
      var $137=($136.f1 = $135, $136);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__18ios_base5clearEj["X"]=1;

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  ;
  return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci($this, $0, $1) {
  ;
  var __label__;

  var $3;
  var $4;
  var $5;
  $3=$this;
  $4=$0;
  $5=$1;
  var $6=$3;
  ;
  return $6;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return -1;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  ;
  return -1;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi($this, $__c) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__c;
  var $3=$1;
  ;
  return -1;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  ;
  return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi($this, $0, $1) {
  ;
  var __label__;

  var $3;
  var $4;
  var $5;
  $3=$this;
  $4=$0;
  $5=$1;
  var $6=$3;
  ;
  return $6;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return -1;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj($this, $0) {
  ;
  var __label__;

  var $2;
  var $3;
  $2=$this;
  $3=$0;
  var $4=$2;
  ;
  return -1;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj($this, $__c) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__c;
  var $3=$1;
  ;
  return -1;
}


function __ZNSt3__18ios_base16__call_callbacksENS0_5eventE($this, $ev) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $i;
      $1=$this;
      $2=$ev;
      var $3=$1;
      var $4=(($3+40)|0);
      var $5=HEAP32[(($4)>>2)];
      $i=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$i;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $9
      var $10=$i;
      var $11=(($10-1)|0);
      $i=$11;
      var $12=$i;
      var $13=(($3+32)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+($12<<2))|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$2;
      var $18=$i;
      var $19=(($3+36)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+($18<<2))|0);
      var $22=HEAP32[(($21)>>2)];
      FUNCTION_TABLE[$16]($17, $3, $22);
      __label__ = 1; break;
    case 3: // $23
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18ios_base6getlocEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  var $loc_storage;
  $1=$this;
  var $2=$1;
  var $3=(($2+28)|0);
  var $4=$3;
  $loc_storage=$4;
  var $5=$loc_storage;
  FUNCTION_TABLE[__ZNSt3__16localeC1ERKS0_]($agg_result, $5);
  ;
  return;
}


function __ZNSt3__18ios_base4initEPv($this, $sb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$sb;
      var $3=$1;
      var $4=$2;
      var $5=(($3+24)|0);
      HEAP32[(($5)>>2)]=$4;
      var $6=(($3+24)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      var $9=$8 ? 0 : 1;
      var $10=(($3+16)|0);
      HEAP32[(($10)>>2)]=$9;
      var $11=(($3+20)|0);
      HEAP32[(($11)>>2)]=0;
      var $12=(($3+4)|0);
      HEAP32[(($12)>>2)]=4098;
      var $13=(($3+12)|0);
      HEAP32[(($13)>>2)]=0;
      var $14=(($3+8)|0);
      HEAP32[(($14)>>2)]=6;
      var $15=(($3+32)|0);
      HEAP32[(($15)>>2)]=0;
      var $16=(($3+36)|0);
      HEAP32[(($16)>>2)]=0;
      var $17=(($3+40)|0);
      HEAP32[(($17)>>2)]=0;
      var $18=(($3+44)|0);
      HEAP32[(($18)>>2)]=0;
      var $19=(($3+48)|0);
      HEAP32[(($19)>>2)]=0;
      var $20=(($3+52)|0);
      HEAP32[(($20)>>2)]=0;
      var $21=(($3+56)|0);
      HEAP32[(($21)>>2)]=0;
      var $22=(($3+60)|0);
      HEAP32[(($22)>>2)]=0;
      var $23=(($3+64)|0);
      HEAP32[(($23)>>2)]=0;
      var $24=(($3+68)|0);
      HEAP32[(($24)>>2)]=0;
      var $25=(($3+28)|0);
      var $26=$25;
      var $27=(($26)|0)==0;
      if ($27) { var $31 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $28
      var $29=$26;
      FUNCTION_TABLE[__ZNSt3__16localeC1Ev]($29);
      var $31 = $29;__label__ = 2; break;
    case 2: // $30
      var $31;
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__18ios_base4initEPv["X"]=1;

function __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__18ios_baseD2Ev($3);
  ;
  return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__115basic_streambufIcNS_11char_traitsIcEEEE+8)|0);
  var $4=(($2+4)|0);
  FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($4);
  ;
  return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__115basic_streambufIcNS_11char_traitsIcEEEE+8)|0);
  var $4=(($2+4)|0);
  FUNCTION_TABLE[__ZNSt3__16localeC1Ev]($4);
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+20)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($2+24)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=(($2+28)|0);
  HEAP32[(($10)>>2)]=0;
  ;
  return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj($agg_result, $this, $__off$0, $__off$1, $__way, $__which) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+12;
  var $4=__stackBase__+16;
  var $5;
  var $6=__stackBase__+24;
  var $7;
  var $8;
  $5=$this;
  var $st$9$0=(($6)|0);
  HEAP32[(($st$9$0)>>2)]=$__off$0;
  var $st$9$1=(($6+4)|0);
  HEAP32[(($st$9$1)>>2)]=$__off$1;
  $7=$__way;
  $8=$__which;
  var $9=$5;
  var $10=$3;
  var $11=$4;
  HEAP32[(($3)>>2)]=$agg_result;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $st$21$0=(($4)|0);
  HEAP32[(($st$21$0)>>2)]=$$emscripten$temp$0$0;
  var $st$21$1=(($4+4)|0);
  HEAP32[(($st$21$1)>>2)]=$$emscripten$temp$0$1;
  var $12=HEAP32[(($3)>>2)];
  var $st$26$0=(($4)|0);
  var $13$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $13$1=HEAP32[(($st$26$1)>>2)];
  var $14=$1;
  var $15=$2;
  HEAP32[(($1)>>2)]=$12;
  var $st$33$0=(($2)|0);
  HEAP32[(($st$33$0)>>2)]=$13$0;
  var $st$33$1=(($2+4)|0);
  HEAP32[(($st$33$1)>>2)]=$13$1;
  var $16=HEAP32[(($1)>>2)];
  var $17=(($16)|0);
  var $18=$17;
  HEAP32[(($18)>>2)]=0; HEAP32[(($18+4)>>2)]=0;
  var $19=(($16+8)|0);
  var $st$42$0=(($2)|0);
  var $20$0=HEAP32[(($st$42$0)>>2)];
  var $st$42$1=(($2+4)|0);
  var $20$1=HEAP32[(($st$42$1)>>2)];
  var $st$46$0=(($19)|0);
  HEAP32[(($st$46$0)>>2)]=$20$0;
  var $st$46$1=(($19+4)|0);
  HEAP32[(($st$46$1)>>2)]=$20$1;
  var $21=$1;
  var $22=$2;
  var $23=$3;
  var $24=$4;
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj["X"]=1;

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI10_mbstate_tEEj($agg_result, $this, $__sp, $__which) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__sp; $__sp = STACKTOP;STACKTOP += 16;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__sp)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($__sp+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($__sp+8)>>2)]=HEAP32[((tempParam+8)>>2)];HEAP32[(($__sp+12)>>2)]=HEAP32[((tempParam+12)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+12;
  var $4=__stackBase__+16;
  var $5;
  var $6;
  $5=$this;
  $6=$__which;
  var $7=$5;
  var $8=$3;
  var $9=$4;
  HEAP32[(($3)>>2)]=$agg_result;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $st$14$0=(($4)|0);
  HEAP32[(($st$14$0)>>2)]=$$emscripten$temp$0$0;
  var $st$14$1=(($4+4)|0);
  HEAP32[(($st$14$1)>>2)]=$$emscripten$temp$0$1;
  var $10=HEAP32[(($3)>>2)];
  var $st$19$0=(($4)|0);
  var $11$0=HEAP32[(($st$19$0)>>2)];
  var $st$19$1=(($4+4)|0);
  var $11$1=HEAP32[(($st$19$1)>>2)];
  var $12=$1;
  var $13=$2;
  HEAP32[(($1)>>2)]=$10;
  var $st$26$0=(($2)|0);
  HEAP32[(($st$26$0)>>2)]=$11$0;
  var $st$26$1=(($2+4)|0);
  HEAP32[(($st$26$1)>>2)]=$11$1;
  var $14=HEAP32[(($1)>>2)];
  var $15=(($14)|0);
  var $16=$15;
  HEAP32[(($16)>>2)]=0; HEAP32[(($16+4)>>2)]=0;
  var $17=(($14+8)|0);
  var $st$35$0=(($2)|0);
  var $18$0=HEAP32[(($st$35$0)>>2)];
  var $st$35$1=(($2+4)|0);
  var $18$1=HEAP32[(($st$35$1)>>2)];
  var $st$39$0=(($17)|0);
  HEAP32[(($st$39$0)>>2)]=$18$0;
  var $st$39$1=(($17+4)|0);
  HEAP32[(($st$39$1)>>2)]=$18$1;
  var $19=$1;
  var $20=$2;
  var $21=$3;
  var $22=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci($this, $__s, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $__eof;
      var $__c;
      var $__i;
      $2=$this;
      $3=$__s;
      $4=$__n;
      var $5=$2;
      $__eof=-1;
      $__i=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$__i;
      var $8=$4;
      var $9=(($7)|0) < (($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $10
      var $11=(($5+12)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($5+16)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($12)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($5+12)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($18+1)|0);
      HEAP32[(($17)>>2)]=$19;
      var $20=HEAP8[($18)];
      var $21=$3;
      HEAP8[($21)]=$20;
      __label__ = 8; break;
    case 4: // $22
      var $23=$5;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+40)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=FUNCTION_TABLE[$26]($5);
      $__c=$27;
      var $28=$__eof;
      var $29=(($27)|0)!=(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$__c;
      var $32=$1;
      HEAP32[(($1)>>2)]=$31;
      var $33=HEAP32[(($1)>>2)];
      var $34=(($33) & 255);
      var $35=$1;
      var $36=$3;
      HEAP8[($36)]=$34;
      __label__ = 7; break;
    case 6: // $37
      __label__ = 10; break;
    case 7: // $38
      __label__ = 8; break;
    case 8: // $39
      __label__ = 9; break;
    case 9: // $40
      var $41=$__i;
      var $42=(($41+1)|0);
      $__i=$42;
      var $43=$3;
      var $44=(($43+1)|0);
      $3=$44;
      __label__ = 1; break;
    case 10: // $45
      var $46=$__i;
      STACKTOP = __stackBase__;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci["X"]=1;

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $3=$this;
      var $4=$3;
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+36)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=FUNCTION_TABLE[$8]($4);
      var $10=(($9)|0)==-1;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $2=-1;
      __label__ = 3; break;
    case 2: // $12
      var $13=(($4+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+1)|0);
      HEAP32[(($13)>>2)]=$15;
      var $16=HEAP8[($14)];
      $1=$16;
      var $17=$1;
      var $18=(($17)&255);
      $2=$18;
      __label__ = 3; break;
    case 3: // $19
      var $20=$2;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci($this, $__s, $__n) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $__i;
      var $__eof;
      $1=$this;
      $2=$__s;
      $3=$__n;
      var $4=$1;
      $__i=0;
      $__eof=-1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$__i;
      var $7=$3;
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $9
      var $10=(($4+24)|0);
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($4+28)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($11)>>>0) < (($13)>>>0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=HEAP8[($16)];
      var $18=(($4+24)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+1)|0);
      HEAP32[(($18)>>2)]=$20;
      HEAP8[($19)]=$17;
      __label__ = 7; break;
    case 4: // $21
      var $22=$4;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+52)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$2;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=FUNCTION_TABLE[$25]($4, $28);
      var $30=$__eof;
      var $31=(($29)|0)==(($30)|0);
      if ($31) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $32
      __label__ = 9; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      __label__ = 8; break;
    case 8: // $35
      var $36=$2;
      var $37=(($36+1)|0);
      $2=$37;
      var $38=$__i;
      var $39=(($38+1)|0);
      $__i=$39;
      __label__ = 1; break;
    case 9: // $40
      var $41=$__i;
      ;
      return $41;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci["X"]=1;

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__115basic_streambufIwNS_11char_traitsIwEEEE+8)|0);
  var $4=(($2+4)|0);
  FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($4);
  ;
  return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__115basic_streambufIwNS_11char_traitsIwEEEE+8)|0);
  var $4=(($2+4)|0);
  FUNCTION_TABLE[__ZNSt3__16localeC1Ev]($4);
  var $5=(($2+8)|0);
  HEAP32[(($5)>>2)]=0;
  var $6=(($2+12)|0);
  HEAP32[(($6)>>2)]=0;
  var $7=(($2+16)|0);
  HEAP32[(($7)>>2)]=0;
  var $8=(($2+20)|0);
  HEAP32[(($8)>>2)]=0;
  var $9=(($2+24)|0);
  HEAP32[(($9)>>2)]=0;
  var $10=(($2+28)|0);
  HEAP32[(($10)>>2)]=0;
  ;
  return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj($agg_result, $this, $__off$0, $__off$1, $__way, $__which) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+12;
  var $4=__stackBase__+16;
  var $5;
  var $6=__stackBase__+24;
  var $7;
  var $8;
  $5=$this;
  var $st$9$0=(($6)|0);
  HEAP32[(($st$9$0)>>2)]=$__off$0;
  var $st$9$1=(($6+4)|0);
  HEAP32[(($st$9$1)>>2)]=$__off$1;
  $7=$__way;
  $8=$__which;
  var $9=$5;
  var $10=$3;
  var $11=$4;
  HEAP32[(($3)>>2)]=$agg_result;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $st$21$0=(($4)|0);
  HEAP32[(($st$21$0)>>2)]=$$emscripten$temp$0$0;
  var $st$21$1=(($4+4)|0);
  HEAP32[(($st$21$1)>>2)]=$$emscripten$temp$0$1;
  var $12=HEAP32[(($3)>>2)];
  var $st$26$0=(($4)|0);
  var $13$0=HEAP32[(($st$26$0)>>2)];
  var $st$26$1=(($4+4)|0);
  var $13$1=HEAP32[(($st$26$1)>>2)];
  var $14=$1;
  var $15=$2;
  HEAP32[(($1)>>2)]=$12;
  var $st$33$0=(($2)|0);
  HEAP32[(($st$33$0)>>2)]=$13$0;
  var $st$33$1=(($2+4)|0);
  HEAP32[(($st$33$1)>>2)]=$13$1;
  var $16=HEAP32[(($1)>>2)];
  var $17=(($16)|0);
  var $18=$17;
  HEAP32[(($18)>>2)]=0; HEAP32[(($18+4)>>2)]=0;
  var $19=(($16+8)|0);
  var $st$42$0=(($2)|0);
  var $20$0=HEAP32[(($st$42$0)>>2)];
  var $st$42$1=(($2+4)|0);
  var $20$1=HEAP32[(($st$42$1)>>2)];
  var $st$46$0=(($19)|0);
  HEAP32[(($st$46$0)>>2)]=$20$0;
  var $st$46$1=(($19+4)|0);
  HEAP32[(($st$46$1)>>2)]=$20$1;
  var $21=$1;
  var $22=$2;
  var $23=$3;
  var $24=$4;
  STACKTOP = __stackBase__;
  return;
}
__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj["X"]=1;

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI10_mbstate_tEEj($agg_result, $this, $__sp, $__which) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__sp; $__sp = STACKTOP;STACKTOP += 16;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__sp)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($__sp+4)>>2)]=HEAP32[((tempParam+4)>>2)];HEAP32[(($__sp+8)>>2)]=HEAP32[((tempParam+8)>>2)];HEAP32[(($__sp+12)>>2)]=HEAP32[((tempParam+12)>>2)];
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+12;
  var $4=__stackBase__+16;
  var $5;
  var $6;
  $5=$this;
  $6=$__which;
  var $7=$5;
  var $8=$3;
  var $9=$4;
  HEAP32[(($3)>>2)]=$agg_result;
  var $$emscripten$temp$0$0=-1;
  var $$emscripten$temp$0$1=-1;
  var $st$14$0=(($4)|0);
  HEAP32[(($st$14$0)>>2)]=$$emscripten$temp$0$0;
  var $st$14$1=(($4+4)|0);
  HEAP32[(($st$14$1)>>2)]=$$emscripten$temp$0$1;
  var $10=HEAP32[(($3)>>2)];
  var $st$19$0=(($4)|0);
  var $11$0=HEAP32[(($st$19$0)>>2)];
  var $st$19$1=(($4+4)|0);
  var $11$1=HEAP32[(($st$19$1)>>2)];
  var $12=$1;
  var $13=$2;
  HEAP32[(($1)>>2)]=$10;
  var $st$26$0=(($2)|0);
  HEAP32[(($st$26$0)>>2)]=$11$0;
  var $st$26$1=(($2+4)|0);
  HEAP32[(($st$26$1)>>2)]=$11$1;
  var $14=HEAP32[(($1)>>2)];
  var $15=(($14)|0);
  var $16=$15;
  HEAP32[(($16)>>2)]=0; HEAP32[(($16+4)>>2)]=0;
  var $17=(($14+8)|0);
  var $st$35$0=(($2)|0);
  var $18$0=HEAP32[(($st$35$0)>>2)];
  var $st$35$1=(($2+4)|0);
  var $18$1=HEAP32[(($st$35$1)>>2)];
  var $st$39$0=(($17)|0);
  HEAP32[(($st$39$0)>>2)]=$18$0;
  var $st$39$1=(($17+4)|0);
  HEAP32[(($st$39$1)>>2)]=$18$1;
  var $19=$1;
  var $20=$2;
  var $21=$3;
  var $22=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi($this, $__s, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $__eof;
      var $__c;
      var $__i;
      $2=$this;
      $3=$__s;
      $4=$__n;
      var $5=$2;
      $__eof=-1;
      $__i=0;
      __label__ = 1; break;
    case 1: // $6
      var $7=$__i;
      var $8=$4;
      var $9=(($7)|0) < (($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $10
      var $11=(($5+12)|0);
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($5+16)|0);
      var $14=HEAPU32[(($13)>>2)];
      var $15=(($12)>>>0) < (($14)>>>0);
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=(($5+12)|0);
      var $18=HEAPU32[(($17)>>2)];
      var $19=(($18+4)|0);
      HEAP32[(($17)>>2)]=$19;
      var $20=HEAP32[(($18)>>2)];
      var $21=$3;
      HEAP32[(($21)>>2)]=$20;
      __label__ = 8; break;
    case 4: // $22
      var $23=$5;
      var $24=HEAP32[(($23)>>2)];
      var $25=(($24+40)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=FUNCTION_TABLE[$26]($5);
      $__c=$27;
      var $28=$__eof;
      var $29=(($27)|0)!=(($28)|0);
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$__c;
      var $32=$1;
      HEAP32[(($1)>>2)]=$31;
      var $33=HEAP32[(($1)>>2)];
      var $34=$1;
      var $35=$3;
      HEAP32[(($35)>>2)]=$33;
      __label__ = 7; break;
    case 6: // $36
      __label__ = 10; break;
    case 7: // $37
      __label__ = 8; break;
    case 8: // $38
      __label__ = 9; break;
    case 9: // $39
      var $40=$__i;
      var $41=(($40+1)|0);
      $__i=$41;
      var $42=$3;
      var $43=(($42+4)|0);
      $3=$43;
      __label__ = 1; break;
    case 10: // $44
      var $45=$__i;
      STACKTOP = __stackBase__;
      return $45;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi["X"]=1;

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      $3=$this;
      var $4=$3;
      var $5=$4;
      var $6=HEAP32[(($5)>>2)];
      var $7=(($6+36)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=FUNCTION_TABLE[$8]($4);
      var $10=(($9)|0)==-1;
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      $2=-1;
      __label__ = 3; break;
    case 2: // $12
      var $13=(($4+12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14+4)|0);
      HEAP32[(($13)>>2)]=$15;
      var $16=HEAP32[(($14)>>2)];
      var $17=$1;
      HEAP32[(($1)>>2)]=$16;
      var $18=HEAP32[(($1)>>2)];
      var $19=$1;
      $2=$18;
      __label__ = 3; break;
    case 3: // $20
      var $21=$2;
      STACKTOP = __stackBase__;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi($this, $__s, $__n) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $__i;
      var $__eof;
      $1=$this;
      $2=$__s;
      $3=$__n;
      var $4=$1;
      $__i=0;
      $__eof=-1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$__i;
      var $7=$3;
      var $8=(($6)|0) < (($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $9
      var $10=(($4+24)|0);
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($4+28)|0);
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($11)>>>0) < (($13)>>>0);
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($4+24)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19+4)|0);
      HEAP32[(($18)>>2)]=$20;
      HEAP32[(($19)>>2)]=$17;
      __label__ = 7; break;
    case 4: // $21
      var $22=$4;
      var $23=HEAP32[(($22)>>2)];
      var $24=(($23+52)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$2;
      var $27=HEAP32[(($26)>>2)];
      var $28=FUNCTION_TABLE[$25]($4, $27);
      var $29=$__eof;
      var $30=(($28)|0)==(($29)|0);
      if ($30) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $31
      __label__ = 9; break;
    case 6: // $32
      __label__ = 7; break;
    case 7: // $33
      __label__ = 8; break;
    case 8: // $34
      var $35=$2;
      var $36=(($35+4)|0);
      $2=$36;
      var $37=$__i;
      var $38=(($37+1)|0);
      $__i=$38;
      __label__ = 1; break;
    case 9: // $39
      var $40=$__i;
      ;
      return $40;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi["X"]=1;

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED2Ev($this, $vtt) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$vtt;
  var $3=$1;
  var $4=$2;
  ;
  return;
}


function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED2Ev($this, $vtt) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$vtt;
  var $3=$1;
  var $4=$2;
  ;
  return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev($this, $vtt) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$vtt;
  var $3=$1;
  var $4=$2;
  ;
  return;
}


function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev($10);
  ;
  return;
}


function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev($10);
  ;
  return;
}


function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev($10);
  ;
  return;
}


function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev($10);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev($10);
  ;
  return;
}


function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev($10);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_($this, $__os) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__os;
  var $3=$1;
  var $4=$2;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_($3, $4);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_($this, $__os) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      $5=$this;
      $6=$__os;
      var $7=$5;
      var $8=(($7)|0);
      HEAP8[($8)]=0;
      var $9=(($7+4)|0);
      var $10=$6;
      HEAP32[(($9)>>2)]=$10;
      var $11=$6;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$11;
      var $18=(($17+$16)|0);
      var $19=$18;
      var $20=$4;
      HEAP32[(($4)>>2)]=$19;
      var $21=HEAP32[(($4)>>2)];
      var $22=$21;
      var $23=$3;
      HEAP32[(($3)>>2)]=$22;
      var $24=HEAP32[(($3)>>2)];
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==0;
      var $28=$3;
      var $29=$4;
      if ($27) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $30
      var $31=$6;
      var $32=$31;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33-12)|0);
      var $35=$34;
      var $36=HEAP32[(($35)>>2)];
      var $37=$31;
      var $38=(($37+$36)|0);
      var $39=$38;
      var $40=$2;
      HEAP32[(($2)>>2)]=$39;
      var $41=HEAP32[(($2)>>2)];
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$2;
      var $45=(($43)|0)!=0;
      if ($45) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $46
      var $47=$6;
      var $48=$47;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49-12)|0);
      var $51=$50;
      var $52=HEAP32[(($51)>>2)];
      var $53=$47;
      var $54=(($53+$52)|0);
      var $55=$54;
      var $56=$1;
      HEAP32[(($1)>>2)]=$55;
      var $57=HEAP32[(($1)>>2)];
      var $58=(($57+72)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$1;
      var $61=__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($59);
      __label__ = 3; break;
    case 3: // $62
      var $63=(($7)|0);
      HEAP8[($63)]=1;
      __label__ = 4; break;
    case 4: // $64
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_["X"]=1;

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($2);
  ;
  return;
}


function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED2Ev($4, ((__ZTTNSt3__113basic_istreamIcNS_11char_traitsIcEEEE)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      var $7=(($6+8)|0);
      var $8=$7;
      __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      var $14=(($13+8)|0);
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      var $18=$2;
      var $19=$2;
      var $20=$3;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11;
      var $12;
      var $13;
      var $__s=__stackBase__+40;
      $11=$this;
      var $14=$11;
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16-12)|0);
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=$14;
      var $21=(($20+$19)|0);
      var $22=$21;
      var $23=$10;
      HEAP32[(($10)>>2)]=$22;
      var $24=HEAP32[(($10)>>2)];
      var $25=$24;
      var $26=$9;
      HEAP32[(($9)>>2)]=$25;
      var $27=HEAP32[(($9)>>2)];
      var $28=(($27+24)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$9;
      var $31=$29;
      var $32=$10;
      __label__ = 1; break;
    case 1: // $33
      var $34=(($31)|0)!=0;
      if ($34) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $35
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_($__s, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $36
      var $37=$8;
      HEAP32[(($8)>>2)]=$__s;
      var $38=HEAP32[(($8)>>2)];
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      var $41=(($40) & 1);
      var $42=$8;
      __label__ = 4; break;
    case 4: // $43
      if ($41) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $44
      var $45=$14;
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46-12)|0);
      var $48=$47;
      var $49=HEAP32[(($48)>>2)];
      var $50=$14;
      var $51=(($50+$49)|0);
      var $52=$51;
      var $53=$7;
      HEAP32[(($7)>>2)]=$52;
      var $54=HEAP32[(($7)>>2)];
      var $55=$54;
      var $56=$6;
      HEAP32[(($6)>>2)]=$55;
      var $57=HEAP32[(($6)>>2)];
      var $58=(($57+24)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$6;
      var $61=$59;
      var $62=$7;
      __label__ = 6; break;
    case 6: // $63
      var $64=$5;
      HEAP32[(($5)>>2)]=$61;
      var $65=HEAP32[(($5)>>2)];
      var $66=$65;
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+24)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$69]($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7pubsyncEv_exit
      var $71=$5;
      __label__ = 8; break;
    case 8: // $72
      var $73=(($70)|0)==-1;
      if ($73) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $74
      var $75=$14;
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76-12)|0);
      var $78=$77;
      var $79=HEAP32[(($78)>>2)];
      var $80=$14;
      var $81=(($80+$79)|0);
      var $82=$81;
      var $83=$3;
      var $84=$4;
      HEAP32[(($3)>>2)]=$82;
      HEAP32[(($4)>>2)]=1;
      var $85=HEAP32[(($3)>>2)];
      var $86=$85;
      var $87=HEAP32[(($4)>>2)];
      var $88=$1;
      var $89=$2;
      HEAP32[(($1)>>2)]=$86;
      HEAP32[(($2)>>2)]=$87;
      var $90=HEAP32[(($1)>>2)];
      var $91=(($90+16)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP32[(($2)>>2)];
      var $94=$92 | $93;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base5clearEj($90, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $_ZNSt3__19basic_iosIcNS_11char_traitsIcEEE8setstateEj_exit
      var $95=$1;
      var $96=$2;
      var $97=$3;
      var $98=$4;
      __label__ = 11; break;
    case 11: // $99
      __label__ = 14; break;
    case 12: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $102=$101.f0;
      $12=$102;
      var $103=$101.f1;
      $13=$103;
      __label__ = 18; break;
    case 13: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $106=$105.f0;
      $12=$106;
      var $107=$105.f1;
      $13=$107;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev($__s) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 25; break; }
    case 14: // $108
      __label__ = 15; break;
    case 15: // $109
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev($__s) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 16: // $110
      __label__ = 21; break;
    case 17: // $111
      __label__ = 18; break;
    case 18: // $112
      var $113=$12;
      var $114=___cxa_begin_catch($113);
      var $115=$14;
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116-12)|0);
      var $118=$117;
      var $119=HEAP32[(($118)>>2)];
      var $120=$14;
      var $121=(($120+$119)|0);
      var $122=$121;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $123
      ___cxa_end_catch();
      __label__ = 20; break;
    case 20: // $124
      STACKTOP = __stackBase__;
      return $14;
    case 21: // $125
      __label__ = 20; break;
    case 22: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $128=$127.f0;
      $12=$128;
      var $129=$127.f1;
      $13=$129;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $130
      __label__ = 24; break;
    case 24: // $131
      var $132=$12;
      var $133=$12;
      var $134=$13;
      var $135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $133, tempValue);
      var $136=($135.f1 = $134, $135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $137
      var $138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv["X"]=1;

function __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+16)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=$4 | 1;
      HEAP32[(($3)>>2)]=$5;
      var $6=(($2+20)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 & 1;
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      ___cxa_rethrow();
      throw "Reached an unreachable!"
    case 2: // $11
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED2Ev($4, ((__ZTTNSt3__113basic_istreamIwNS_11char_traitsIwEEEE)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      var $7=(($6+8)|0);
      var $8=$7;
      __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      var $14=(($13+8)|0);
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      var $18=$2;
      var $19=$2;
      var $20=$3;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11;
      var $12;
      var $13;
      var $__s=__stackBase__+40;
      $11=$this;
      var $14=$11;
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($16-12)|0);
      var $18=$17;
      var $19=HEAP32[(($18)>>2)];
      var $20=$14;
      var $21=(($20+$19)|0);
      var $22=$21;
      var $23=$10;
      HEAP32[(($10)>>2)]=$22;
      var $24=HEAP32[(($10)>>2)];
      var $25=$24;
      var $26=$9;
      HEAP32[(($9)>>2)]=$25;
      var $27=HEAP32[(($9)>>2)];
      var $28=(($27+24)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$9;
      var $31=$29;
      var $32=$10;
      __label__ = 1; break;
    case 1: // $33
      var $34=(($31)|0)!=0;
      if ($34) { __label__ = 2; break; } else { __label__ = 21; break; }
    case 2: // $35
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC1ERS3_($__s, $14) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 12; break; }
    case 3: // $36
      var $37=$8;
      HEAP32[(($8)>>2)]=$__s;
      var $38=HEAP32[(($8)>>2)];
      var $39=(($38)|0);
      var $40=HEAP8[($39)];
      var $41=(($40) & 1);
      var $42=$8;
      __label__ = 4; break;
    case 4: // $43
      if ($41) { __label__ = 5; break; } else { __label__ = 15; break; }
    case 5: // $44
      var $45=$14;
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46-12)|0);
      var $48=$47;
      var $49=HEAP32[(($48)>>2)];
      var $50=$14;
      var $51=(($50+$49)|0);
      var $52=$51;
      var $53=$7;
      HEAP32[(($7)>>2)]=$52;
      var $54=HEAP32[(($7)>>2)];
      var $55=$54;
      var $56=$6;
      HEAP32[(($6)>>2)]=$55;
      var $57=HEAP32[(($6)>>2)];
      var $58=(($57+24)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$6;
      var $61=$59;
      var $62=$7;
      __label__ = 6; break;
    case 6: // $63
      var $64=$5;
      HEAP32[(($5)>>2)]=$61;
      var $65=HEAP32[(($5)>>2)];
      var $66=$65;
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+24)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$69]($65) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7pubsyncEv_exit
      var $71=$5;
      __label__ = 8; break;
    case 8: // $72
      var $73=(($70)|0)==-1;
      if ($73) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $74
      var $75=$14;
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76-12)|0);
      var $78=$77;
      var $79=HEAP32[(($78)>>2)];
      var $80=$14;
      var $81=(($80+$79)|0);
      var $82=$81;
      var $83=$3;
      var $84=$4;
      HEAP32[(($3)>>2)]=$82;
      HEAP32[(($4)>>2)]=1;
      var $85=HEAP32[(($3)>>2)];
      var $86=$85;
      var $87=HEAP32[(($4)>>2)];
      var $88=$1;
      var $89=$2;
      HEAP32[(($1)>>2)]=$86;
      HEAP32[(($2)>>2)]=$87;
      var $90=HEAP32[(($1)>>2)];
      var $91=(($90+16)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP32[(($2)>>2)];
      var $94=$92 | $93;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base5clearEj($90, $94) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $_ZNSt3__19basic_iosIwNS_11char_traitsIwEEE8setstateEj_exit
      var $95=$1;
      var $96=$2;
      var $97=$3;
      var $98=$4;
      __label__ = 11; break;
    case 11: // $99
      __label__ = 14; break;
    case 12: // $100
      var $101=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $102=$101.f0;
      $12=$102;
      var $103=$101.f1;
      $13=$103;
      __label__ = 18; break;
    case 13: // $104
      var $105=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $106=$105.f0;
      $12=$106;
      var $107=$105.f1;
      $13=$107;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD1Ev($__s) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 25; break; }
    case 14: // $108
      __label__ = 15; break;
    case 15: // $109
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD1Ev($__s) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 12; break; }
    case 16: // $110
      __label__ = 21; break;
    case 17: // $111
      __label__ = 18; break;
    case 18: // $112
      var $113=$12;
      var $114=___cxa_begin_catch($113);
      var $115=$14;
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116-12)|0);
      var $118=$117;
      var $119=HEAP32[(($118)>>2)];
      var $120=$14;
      var $121=(($120+$119)|0);
      var $122=$121;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv($122) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $123
      ___cxa_end_catch();
      __label__ = 20; break;
    case 20: // $124
      STACKTOP = __stackBase__;
      return $14;
    case 21: // $125
      __label__ = 20; break;
    case 22: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $128=$127.f0;
      $12=$128;
      var $129=$127.f1;
      $13=$129;
      (function() { try { __THREW__ = false; return ___cxa_end_catch() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 25; break; }
    case 23: // $130
      __label__ = 24; break;
    case 24: // $131
      var $132=$12;
      var $133=$12;
      var $134=$13;
      var $135=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $133, tempValue);
      var $136=($135.f1 = $134, $135);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 25: // $137
      var $138=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv["X"]=1;

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev($4, ((__ZTTNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      var $7=(($6+4)|0);
      var $8=$7;
      __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      var $14=(($13+4)|0);
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      var $18=$2;
      var $19=$2;
      var $20=$3;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED2Ev($this, $vtt) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$vtt;
  var $3=$1;
  var $4=$2;
  ;
  return;
}


function __ZNKSt3__119__iostream_category4nameEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return ((STRING_TABLE.__str1541656)|0);
}


function ___cxx_global_var_init270() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__17collateIcE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__17collateIcE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__17collateIcE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__17collateIcE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14;
      var $15;
      $13=$this;
      var $16=$13;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20-12)|0);
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=$18;
      var $25=(($24+$23)|0);
      var $26=$25;
      var $27=$12;
      HEAP32[(($12)>>2)]=$26;
      var $28=HEAP32[(($12)>>2)];
      var $29=$28;
      var $30=$11;
      HEAP32[(($11)>>2)]=$29;
      var $31=HEAP32[(($11)>>2)];
      var $32=(($31+24)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$11;
      var $35=$33;
      var $36=$12;
      var $37=(($35)|0)!=0;
      if ($37) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $38
      var $39=(($16+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42-12)|0);
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=$40;
      var $47=(($46+$45)|0);
      var $48=$47;
      var $49=$6;
      HEAP32[(($6)>>2)]=$48;
      var $50=HEAP32[(($6)>>2)];
      var $51=$50;
      var $52=$5;
      HEAP32[(($5)>>2)]=$51;
      var $53=HEAP32[(($5)>>2)];
      var $54=(($53+16)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)==0;
      var $57=$5;
      var $58=$6;
      if ($56) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $59
      var $60=(($16+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63-12)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=$61;
      var $68=(($67+$66)|0);
      var $69=$68;
      var $70=$3;
      HEAP32[(($3)>>2)]=$69;
      var $71=HEAP32[(($3)>>2)];
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$3;
      var $75=$73 & 8192;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $77
      var $78=__ZSt18uncaught_exceptionv();
      if ($78) { __label__ = 15; break; } else { __label__ = 4; break; }
    case 4: // $79
      var $80=(($16+4)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83-12)|0);
      var $85=$84;
      var $86=HEAP32[(($85)>>2)];
      var $87=$81;
      var $88=(($87+$86)|0);
      var $89=$88;
      var $90=$2;
      HEAP32[(($2)>>2)]=$89;
      var $91=HEAP32[(($2)>>2)];
      var $92=$91;
      var $93=$1;
      HEAP32[(($1)>>2)]=$92;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94+24)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$1;
      var $98=$96;
      var $99=$2;
      __label__ = 5; break;
    case 5: // $100
      var $101=$4;
      HEAP32[(($4)>>2)]=$98;
      var $102=HEAP32[(($4)>>2)];
      var $103=$102;
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104+24)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$106]($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 11; break; };
    case 6: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7pubsyncEv_exit
      var $108=$4;
      __label__ = 7; break;
    case 7: // $109
      var $110=(($107)|0)==-1;
      if ($110) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $111
      var $112=(($16+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113;
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115-12)|0);
      var $117=$116;
      var $118=HEAP32[(($117)>>2)];
      var $119=$113;
      var $120=(($119+$118)|0);
      var $121=$120;
      var $122=$9;
      var $123=$10;
      HEAP32[(($9)>>2)]=$121;
      HEAP32[(($10)>>2)]=1;
      var $124=HEAP32[(($9)>>2)];
      var $125=$124;
      var $126=HEAP32[(($10)>>2)];
      var $127=$7;
      var $128=$8;
      HEAP32[(($7)>>2)]=$125;
      HEAP32[(($8)>>2)]=$126;
      var $129=HEAP32[(($7)>>2)];
      var $130=(($129+16)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=HEAP32[(($8)>>2)];
      var $133=$131 | $132;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base5clearEj($129, $133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $_ZNSt3__19basic_iosIcNS_11char_traitsIcEEE8setstateEj_exit
      var $134=$7;
      var $135=$8;
      var $136=$9;
      var $137=$10;
      __label__ = 10; break;
    case 10: // $138
      __label__ = 14; break;
    case 11: // $139
      var $140=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $141=$140.f0;
      $14=$141;
      var $142=$140.f1;
      $15=$142;
      __label__ = 12; break;
    case 12: // $143
      var $144=$14;
      var $145=___cxa_begin_catch($144);
      ___cxa_end_catch();
      __label__ = 13; break;
    case 13: // $146
      __label__ = 15; break;
    case 14: // $147
      __label__ = 13; break;
    case 15: // $148
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev["X"]=1;

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev($10);
  ;
  return;
}


function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  var $4=$3;
  var $5=HEAP32[(($4)>>2)];
  var $6=(($5-12)|0);
  var $7=$6;
  var $8=HEAP32[(($7)>>2)];
  var $9=(($3+$8)|0);
  var $10=$9;
  __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev($10);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC1ERS3_($this, $__os) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__os;
  var $3=$1;
  var $4=$2;
  __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_($3, $4);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_($this, $__os) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      $5=$this;
      $6=$__os;
      var $7=$5;
      var $8=(($7)|0);
      HEAP8[($8)]=0;
      var $9=(($7+4)|0);
      var $10=$6;
      HEAP32[(($9)>>2)]=$10;
      var $11=$6;
      var $12=$11;
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13-12)|0);
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      var $17=$11;
      var $18=(($17+$16)|0);
      var $19=$18;
      var $20=$4;
      HEAP32[(($4)>>2)]=$19;
      var $21=HEAP32[(($4)>>2)];
      var $22=$21;
      var $23=$3;
      HEAP32[(($3)>>2)]=$22;
      var $24=HEAP32[(($3)>>2)];
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26)|0)==0;
      var $28=$3;
      var $29=$4;
      if ($27) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $30
      var $31=$6;
      var $32=$31;
      var $33=HEAP32[(($32)>>2)];
      var $34=(($33-12)|0);
      var $35=$34;
      var $36=HEAP32[(($35)>>2)];
      var $37=$31;
      var $38=(($37+$36)|0);
      var $39=$38;
      var $40=$2;
      HEAP32[(($2)>>2)]=$39;
      var $41=HEAP32[(($2)>>2)];
      var $42=(($41+72)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=$2;
      var $45=(($43)|0)!=0;
      if ($45) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $46
      var $47=$6;
      var $48=$47;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49-12)|0);
      var $51=$50;
      var $52=HEAP32[(($51)>>2)];
      var $53=$47;
      var $54=(($53+$52)|0);
      var $55=$54;
      var $56=$1;
      HEAP32[(($1)>>2)]=$55;
      var $57=HEAP32[(($1)>>2)];
      var $58=(($57+72)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$1;
      var $61=__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv($59);
      __label__ = 3; break;
    case 3: // $62
      var $63=(($7)|0);
      HEAP8[($63)]=1;
      __label__ = 4; break;
    case 4: // $64
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_["X"]=1;

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev($2);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14;
      var $15;
      $13=$this;
      var $16=$13;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20-12)|0);
      var $22=$21;
      var $23=HEAP32[(($22)>>2)];
      var $24=$18;
      var $25=(($24+$23)|0);
      var $26=$25;
      var $27=$12;
      HEAP32[(($12)>>2)]=$26;
      var $28=HEAP32[(($12)>>2)];
      var $29=$28;
      var $30=$11;
      HEAP32[(($11)>>2)]=$29;
      var $31=HEAP32[(($11)>>2)];
      var $32=(($31+24)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$11;
      var $35=$33;
      var $36=$12;
      var $37=(($35)|0)!=0;
      if ($37) { __label__ = 1; break; } else { __label__ = 15; break; }
    case 1: // $38
      var $39=(($16+4)|0);
      var $40=HEAP32[(($39)>>2)];
      var $41=$40;
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42-12)|0);
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=$40;
      var $47=(($46+$45)|0);
      var $48=$47;
      var $49=$6;
      HEAP32[(($6)>>2)]=$48;
      var $50=HEAP32[(($6)>>2)];
      var $51=$50;
      var $52=$5;
      HEAP32[(($5)>>2)]=$51;
      var $53=HEAP32[(($5)>>2)];
      var $54=(($53+16)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55)|0)==0;
      var $57=$5;
      var $58=$6;
      if ($56) { __label__ = 2; break; } else { __label__ = 15; break; }
    case 2: // $59
      var $60=(($16+4)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$61;
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63-12)|0);
      var $65=$64;
      var $66=HEAP32[(($65)>>2)];
      var $67=$61;
      var $68=(($67+$66)|0);
      var $69=$68;
      var $70=$3;
      HEAP32[(($3)>>2)]=$69;
      var $71=HEAP32[(($3)>>2)];
      var $72=(($71+4)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$3;
      var $75=$73 & 8192;
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 3; break; } else { __label__ = 15; break; }
    case 3: // $77
      var $78=__ZSt18uncaught_exceptionv();
      if ($78) { __label__ = 15; break; } else { __label__ = 4; break; }
    case 4: // $79
      var $80=(($16+4)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83-12)|0);
      var $85=$84;
      var $86=HEAP32[(($85)>>2)];
      var $87=$81;
      var $88=(($87+$86)|0);
      var $89=$88;
      var $90=$2;
      HEAP32[(($2)>>2)]=$89;
      var $91=HEAP32[(($2)>>2)];
      var $92=$91;
      var $93=$1;
      HEAP32[(($1)>>2)]=$92;
      var $94=HEAP32[(($1)>>2)];
      var $95=(($94+24)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=$1;
      var $98=$96;
      var $99=$2;
      __label__ = 5; break;
    case 5: // $100
      var $101=$4;
      HEAP32[(($4)>>2)]=$98;
      var $102=HEAP32[(($4)>>2)];
      var $103=$102;
      var $104=HEAP32[(($103)>>2)];
      var $105=(($104+24)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$106]($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 11; break; };
    case 6: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7pubsyncEv_exit
      var $108=$4;
      __label__ = 7; break;
    case 7: // $109
      var $110=(($107)|0)==-1;
      if ($110) { __label__ = 8; break; } else { __label__ = 14; break; }
    case 8: // $111
      var $112=(($16+4)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$113;
      var $115=HEAP32[(($114)>>2)];
      var $116=(($115-12)|0);
      var $117=$116;
      var $118=HEAP32[(($117)>>2)];
      var $119=$113;
      var $120=(($119+$118)|0);
      var $121=$120;
      var $122=$9;
      var $123=$10;
      HEAP32[(($9)>>2)]=$121;
      HEAP32[(($10)>>2)]=1;
      var $124=HEAP32[(($9)>>2)];
      var $125=$124;
      var $126=HEAP32[(($10)>>2)];
      var $127=$7;
      var $128=$8;
      HEAP32[(($7)>>2)]=$125;
      HEAP32[(($8)>>2)]=$126;
      var $129=HEAP32[(($7)>>2)];
      var $130=(($129+16)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=HEAP32[(($8)>>2)];
      var $133=$131 | $132;
      (function() { try { __THREW__ = false; return __ZNSt3__18ios_base5clearEj($129, $133) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $_ZNSt3__19basic_iosIwNS_11char_traitsIwEEE8setstateEj_exit
      var $134=$7;
      var $135=$8;
      var $136=$9;
      var $137=$10;
      __label__ = 10; break;
    case 10: // $138
      __label__ = 14; break;
    case 11: // $139
      var $140=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $141=$140.f0;
      $14=$141;
      var $142=$140.f1;
      $15=$142;
      __label__ = 12; break;
    case 12: // $143
      var $144=$14;
      var $145=___cxa_begin_catch($144);
      ___cxa_end_catch();
      __label__ = 13; break;
    case 13: // $146
      __label__ = 15; break;
    case 14: // $147
      __label__ = 13; break;
    case 15: // $148
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev["X"]=1;

function __ZNKSt3__119__iostream_category7messageEi($agg_result, $this, $ev) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      $10=$this;
      $11=$ev;
      var $12=$10;
      var $13=$11;
      var $14=(($13)|0)!=1;
      if ($14) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $15
      var $16=$12;
      var $17=$11;
      __ZNKSt3__112__do_message7messageEi($agg_result, $16, $17);
      __label__ = 3; break;
    case 2: // $18
      var $19=$8;
      var $20=$9;
      HEAP32[(($8)>>2)]=$agg_result;
      HEAP32[(($9)>>2)]=((STRING_TABLE.__str11551657)|0);
      var $21=HEAP32[(($8)>>2)];
      var $22=HEAP32[(($9)>>2)];
      var $23=$6;
      var $24=$7;
      HEAP32[(($6)>>2)]=$21;
      HEAP32[(($7)>>2)]=$22;
      var $25=HEAP32[(($6)>>2)];
      var $26=$25;
      var $27=(($25)|0);
      var $28=$5;
      HEAP32[(($5)>>2)]=$27;
      var $29=HEAP32[(($5)>>2)];
      var $30=$4;
      HEAP32[(($4)>>2)]=$29;
      var $31=HEAP32[(($4)>>2)];
      var $32=$31;
      var $33=$3;
      HEAP32[(($3)>>2)]=$32;
      var $34=HEAP32[(($3)>>2)];
      var $35=$34;
      var $36=$2;
      HEAP32[(($2)>>2)]=$35;
      var $37=HEAP32[(($2)>>2)];
      var $38=$2;
      var $39=(($34)|0);
      var $40=$3;
      var $41=$4;
      var $42=$5;
      var $43=HEAP32[(($7)>>2)];
      var $44=HEAP32[(($7)>>2)];
      var $45=$1;
      HEAP32[(($1)>>2)]=$44;
      var $46=HEAP32[(($1)>>2)];
      var $47=_strlen($46);
      var $48=$1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($25, $43, $47);
      var $49=$6;
      var $50=$7;
      var $51=$8;
      var $52=$9;
      __label__ = 3; break;
    case 3: // $53
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__119__iostream_category7messageEi["X"]=1;

function __ZNSt3__117iostream_categoryEv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=HEAP8[(__ZGVZNSt3__117iostream_categoryEvE1s)];
      var $2=(($1 << 24) >> 24)==0;
      if ($2) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $3
      var $4=___cxa_guard_acquire(__ZGVZNSt3__117iostream_categoryEvE1s);
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $6
      __ZNSt3__119__iostream_categoryC1Ev(__ZZNSt3__117iostream_categoryEvE1s);
      var $7=___cxa_atexit(1678, __ZZNSt3__117iostream_categoryEvE1s, ___dso_handle);
      ;
      __label__ = 3; break;
    case 3: // $8
      ;
      return ((__ZZNSt3__117iostream_categoryEvE1s)|0);
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__119__iostream_categoryC1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__119__iostream_categoryC2Ev($2);
  ;
  return;
}


function __ZNSt3__119__iostream_categoryD1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__119__iostream_categoryD2Ev($2);
  ;
  return;
}


function __ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE($this, $msg, $ec) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4=__stackBase__;
  $1=$this;
  $2=$msg;
  $3=$ec;
  var $5=$1;
  var $6=$5;
  var $7=$3;
  var $8=$4;
  var $9=$7;
  assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];HEAP32[(($8+4)>>2)]=HEAP32[(($9+4)>>2)];
  var $10=$2;
  __ZNSt3__112system_errorC2ENS_10error_codeEPKc($6, $4, $10);
  var $11=$5;
  HEAP32[(($11)>>2)]=((__ZTVNSt3__18ios_base7failureE+8)|0);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__18ios_base7failureD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt3__18ios_base7failureD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt3__18ios_base7failureD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__112system_errorD2Ev($3);
  ;
  return;
}


function __ZNSt3__18ios_baseD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__18ios_baseD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__119__iostream_categoryD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__119__iostream_categoryD1Ev($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt3__119__iostream_categoryD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__112__do_messageD2Ev($3);
  ;
  return;
}


function __ZNSt3__119__iostream_categoryC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__112__do_messageC2Ev($3);
  var $4=$2;
  HEAP32[(($4)>>2)]=((__ZTVNSt3__119__iostream_categoryE+8)|0);
  ;
  return;
}


function __ZNSt3__17collateIcED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__17collateIcED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17collateIcED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__17collateIcED2Ev($2);
  ;
  return;
}


function __ZNSt3__17collateIcED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__16locale5facetD2Ev($3);
  ;
  return;
}


function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED2Ev($4, ((__ZTTNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      var $7=(($6+4)|0);
      var $8=$7;
      __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      var $14=(($13+4)|0);
      var $15=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev($15) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $16
      __label__ = 4; break;
    case 4: // $17
      var $18=$2;
      var $19=$2;
      var $20=$3;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $23
      var $24=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_($this, $__lo1, $__hi1, $__lo2, $__hi2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$__lo1;
      $4=$__hi1;
      $5=$__lo2;
      $6=$__hi2;
      var $7=$2;
      __label__ = 1; break;
    case 1: // $8
      var $9=$5;
      var $10=$6;
      var $11=(($9)|0)!=(($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAP8[($17)];
      var $19=(($18 << 24) >> 24);
      var $20=$5;
      var $21=HEAP8[($20)];
      var $22=(($21 << 24) >> 24);
      var $23=(($19)|0) < (($22)|0);
      if ($23) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $24
      $1=-1;
      __label__ = 10; break;
    case 5: // $25
      var $26=$5;
      var $27=HEAP8[($26)];
      var $28=(($27 << 24) >> 24);
      var $29=$3;
      var $30=HEAP8[($29)];
      var $31=(($30 << 24) >> 24);
      var $32=(($28)|0) < (($31)|0);
      if ($32) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $33
      $1=1;
      __label__ = 10; break;
    case 7: // $34
      __label__ = 8; break;
    case 8: // $35
      var $36=$3;
      var $37=(($36+1)|0);
      $3=$37;
      var $38=$5;
      var $39=(($38+1)|0);
      $5=$39;
      __label__ = 1; break;
    case 9: // $40
      var $41=$3;
      var $42=$4;
      var $43=(($41)|0)!=(($42)|0);
      var $44=(($43)&1);
      $1=$44;
      __label__ = 10; break;
    case 10: // $45
      var $46=$1;
      ;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_["X"]=1;

function __ZNKSt3__17collateIcE7do_hashEPKcS3_($this, $lo, $hi) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $h;
      var $sr;
      var $mask;
      var $p;
      var $g;
      $1=$this;
      $2=$lo;
      $3=$hi;
      var $4=$1;
      $h=0;
      $sr=24;
      $mask=-268435456;
      var $5=$2;
      $p=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$p;
      var $8=$3;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$h;
      var $12=$11 << 4;
      var $13=$p;
      var $14=HEAP8[($13)];
      var $15=(($14 << 24) >> 24);
      var $16=(($12+$15)|0);
      $h=$16;
      var $17=$h;
      var $18=$17 & -268435456;
      $g=$18;
      var $19=$g;
      var $20=$g;
      var $21=$20 >>> 24;
      var $22=$19 | $21;
      var $23=$h;
      var $24=$23 ^ $22;
      $h=$24;
      __label__ = 3; break;
    case 3: // $25
      var $26=$p;
      var $27=(($26+1)|0);
      $p=$27;
      __label__ = 1; break;
    case 4: // $28
      var $29=$h;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_var_init1271() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__17collateIwE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__17collateIwE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__17collateIwE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__17collateIwE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_($this, $__lo1, $__hi1, $__lo2, $__hi2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      $2=$this;
      $3=$__lo1;
      $4=$__hi1;
      $5=$__lo2;
      $6=$__hi2;
      var $7=$2;
      __label__ = 1; break;
    case 1: // $8
      var $9=$5;
      var $10=$6;
      var $11=(($9)|0)!=(($10)|0);
      if ($11) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $12
      var $13=$3;
      var $14=$4;
      var $15=(($13)|0)==(($14)|0);
      if ($15) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $16
      var $17=$3;
      var $18=HEAP32[(($17)>>2)];
      var $19=$5;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($18)|0) < (($20)|0);
      if ($21) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $22
      $1=-1;
      __label__ = 10; break;
    case 5: // $23
      var $24=$5;
      var $25=HEAP32[(($24)>>2)];
      var $26=$3;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($25)|0) < (($27)|0);
      if ($28) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $29
      $1=1;
      __label__ = 10; break;
    case 7: // $30
      __label__ = 8; break;
    case 8: // $31
      var $32=$3;
      var $33=(($32+4)|0);
      $3=$33;
      var $34=$5;
      var $35=(($34+4)|0);
      $5=$35;
      __label__ = 1; break;
    case 9: // $36
      var $37=$3;
      var $38=$4;
      var $39=(($37)|0)!=(($38)|0);
      var $40=(($39)&1);
      $1=$40;
      __label__ = 10; break;
    case 10: // $41
      var $42=$1;
      ;
      return $42;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_["X"]=1;

function __ZNKSt3__17collateIwE7do_hashEPKwS3_($this, $lo, $hi) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $h;
      var $sr;
      var $mask;
      var $p;
      var $g;
      $1=$this;
      $2=$lo;
      $3=$hi;
      var $4=$1;
      $h=0;
      $sr=24;
      $mask=-268435456;
      var $5=$2;
      $p=$5;
      __label__ = 1; break;
    case 1: // $6
      var $7=$p;
      var $8=$3;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$h;
      var $12=$11 << 4;
      var $13=$p;
      var $14=HEAP32[(($13)>>2)];
      var $15=(($12+$14)|0);
      $h=$15;
      var $16=$h;
      var $17=$16 & -268435456;
      $g=$17;
      var $18=$g;
      var $19=$g;
      var $20=$19 >>> 24;
      var $21=$18 | $20;
      var $22=$h;
      var $23=$22 ^ $21;
      $h=$23;
      __label__ = 3; break;
    case 3: // $24
      var $25=$p;
      var $26=(($25+4)|0);
      $p=$26;
      __label__ = 1; break;
    case 4: // $27
      var $28=$h;
      ;
      return $28;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_var_init2272() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5facetD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__114__shared_countD2Ev($3);
  ;
  return;
}


function __ZNKSt3__17collateIcE12do_transformEPKcS3_($agg_result, $this, $__lo, $__hi) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  var $11;
  var $12;
  var $13;
  $11=$this;
  $12=$__lo;
  $13=$__hi;
  var $14=$11;
  var $15=$12;
  var $16=$13;
  var $17=$8;
  var $18=$9;
  var $19=$10;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=$15;
  HEAP32[(($10)>>2)]=$16;
  var $20=HEAP32[(($8)>>2)];
  var $21=HEAP32[(($9)>>2)];
  var $22=HEAP32[(($10)>>2)];
  var $23=$5;
  var $24=$6;
  var $25=$7;
  HEAP32[(($5)>>2)]=$20;
  HEAP32[(($6)>>2)]=$21;
  HEAP32[(($7)>>2)]=$22;
  var $26=HEAP32[(($5)>>2)];
  var $27=$26;
  var $28=(($26)|0);
  var $29=$4;
  HEAP32[(($4)>>2)]=$28;
  var $30=HEAP32[(($4)>>2)];
  var $31=$3;
  HEAP32[(($3)>>2)]=$30;
  var $32=HEAP32[(($3)>>2)];
  var $33=$32;
  var $34=$2;
  HEAP32[(($2)>>2)]=$33;
  var $35=HEAP32[(($2)>>2)];
  var $36=$35;
  var $37=$1;
  HEAP32[(($1)>>2)]=$36;
  var $38=HEAP32[(($1)>>2)];
  var $39=$1;
  var $40=(($35)|0);
  var $41=$2;
  var $42=$3;
  var $43=$4;
  var $44=HEAP32[(($6)>>2)];
  var $45=HEAP32[(($7)>>2)];
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_($26, $44, $45);
  var $46=$5;
  var $47=$6;
  var $48=$7;
  var $49=$8;
  var $50=$9;
  var $51=$10;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__17collateIcE12do_transformEPKcS3_["X"]=1;

function __ZNSt3__17collateIwED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__17collateIwED1Ev($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17collateIwED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__17collateIwED2Ev($2);
  ;
  return;
}


function __ZNSt3__17collateIwED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__16locale5facetD2Ev($3);
  ;
  return;
}


function __ZNKSt3__17collateIwE12do_transformEPKwS3_($agg_result, $this, $__lo, $__hi) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  var $11;
  var $12;
  var $13;
  $11=$this;
  $12=$__lo;
  $13=$__hi;
  var $14=$11;
  var $15=$12;
  var $16=$13;
  var $17=$8;
  var $18=$9;
  var $19=$10;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=$15;
  HEAP32[(($10)>>2)]=$16;
  var $20=HEAP32[(($8)>>2)];
  var $21=HEAP32[(($9)>>2)];
  var $22=HEAP32[(($10)>>2)];
  var $23=$5;
  var $24=$6;
  var $25=$7;
  HEAP32[(($5)>>2)]=$20;
  HEAP32[(($6)>>2)]=$21;
  HEAP32[(($7)>>2)]=$22;
  var $26=HEAP32[(($5)>>2)];
  var $27=$26;
  var $28=(($26)|0);
  var $29=$4;
  HEAP32[(($4)>>2)]=$28;
  var $30=HEAP32[(($4)>>2)];
  var $31=$3;
  HEAP32[(($3)>>2)]=$30;
  var $32=HEAP32[(($3)>>2)];
  var $33=$32;
  var $34=$2;
  HEAP32[(($2)>>2)]=$33;
  var $35=HEAP32[(($2)>>2)];
  var $36=$35;
  var $37=$1;
  HEAP32[(($1)>>2)]=$36;
  var $38=HEAP32[(($1)>>2)];
  var $39=$1;
  var $40=(($35)|0);
  var $41=$2;
  var $42=$3;
  var $43=$4;
  var $44=HEAP32[(($6)>>2)];
  var $45=HEAP32[(($7)>>2)];
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_($26, $44, $45);
  var $46=$5;
  var $47=$6;
  var $48=$7;
  var $49=$8;
  var $50=$9;
  var $51=$10;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__17collateIwE12do_transformEPKwS3_["X"]=1;

function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $8;
      var $9;
      var $__lv=__stackBase__+20;
      var $10=__stackBase__+24;
      var $11=__stackBase__+28;
      var $12=__stackBase__+32;
      var $__ct;
      var $13=__stackBase__+36;
      var $14;
      var $15;
      var $__np;
      var $16=__stackBase__+40;
      var $__names=__stackBase__+44;
      var $17;
      var $__i;
      var $18=__stackBase__+68;
      var $19;
      $6=$this;
      $7=$__iob;
      $8=$__err;
      $9=$__v;
      var $20=$6;
      var $21=$7;
      var $22=$5;
      HEAP32[(($5)>>2)]=$21;
      var $23=HEAP32[(($5)>>2)];
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$5;
      var $27=$25 & 1;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $29
      HEAP32[(($__lv)>>2)]=-1;
      var $30=$20;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+16)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$11;
      var $35=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];
      var $36=$12;
      var $37=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];
      var $38=$7;
      var $39=$8;
      FUNCTION_TABLE[$33]($10, $20, $11, $12, $38, $39, $__lv);
      var $40=$__b;
      var $41=$10;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($40)>>2)]=HEAP32[(($41)>>2)];
      var $42=HEAP32[(($__lv)>>2)];
      if ($42 == 0) {
        __label__ = 2; break;
      }
      else if ($42 == 1) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 2: // $43
      var $44=$9;
      HEAP8[($44)]=0;
      __label__ = 5; break;
    case 3: // $45
      var $46=$9;
      HEAP8[($46)]=1;
      __label__ = 5; break;
    case 4: // $47
      var $48=$9;
      HEAP8[($48)]=1;
      var $49=$8;
      HEAP32[(($49)>>2)]=4;
      __label__ = 5; break;
    case 5: // $50
      var $51=$agg_result;
      var $52=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($51)>>2)]=HEAP32[(($52)>>2)];
      __label__ = 35; break;
    case 6: // $53
      var $54=$7;
      __ZNKSt3__18ios_base6getlocEv($13, $54);
      var $55=$4;
      HEAP32[(($4)>>2)]=$13;
      var $56=HEAP32[(($4)>>2)];
      var $57=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($56, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 16; break; };
    case 7: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $58=$57;
      var $59=$4;
      __label__ = 8; break;
    case 8: // $60
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($13);
      $__ct=$58;
      var $61=$7;
      __ZNKSt3__18ios_base6getlocEv($16, $61);
      var $62=$3;
      HEAP32[(($3)>>2)]=$16;
      var $63=HEAP32[(($3)>>2)];
      var $64=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($63, __ZNSt3__18numpunctIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 18; break; };
    case 9: // $_ZNSt3__19use_facetINS_8numpunctIcEEEERKT_RKNS_6localeE_exit
      var $65=$64;
      var $66=$3;
      __label__ = 10; break;
    case 10: // $67
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($16);
      $__np=$65;
      var $68=(($__names)|0);
      $17=$68;
      var $69=$__np;
      var $70=$2;
      HEAP32[(($2)>>2)]=$69;
      var $71=HEAP32[(($2)>>2)];
      var $72=$71;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+24)|0);
      var $75=HEAP32[(($74)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$75]($68, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $_ZNKSt3__18numpunctIcE8truenameEv_exit
      var $76=$2;
      __label__ = 12; break;
    case 12: // $77
      var $78=(($68+12)|0);
      $17=$78;
      var $79=$__np;
      var $80=$1;
      HEAP32[(($1)>>2)]=$79;
      var $81=HEAP32[(($1)>>2)];
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+28)|0);
      var $85=HEAP32[(($84)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$85]($78, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $_ZNKSt3__18numpunctIcE9falsenameEv_exit
      var $86=$1;
      __label__ = 14; break;
    case 14: // $87
      var $88=$18;
      var $89=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($88)>>2)]=HEAP32[(($89)>>2)];
      var $90=(($__names)|0);
      var $91=(($__names)|0);
      var $92=(($91+24)|0);
      var $93=$__ct;
      var $94=$8;
      var $95=(function() { try { __THREW__ = false; return __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b, $18, $90, $92, $93, $94, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 24; break; };
    case 15: // $96
      $__i=$95;
      var $97=$__i;
      var $98=(($__names)|0);
      var $99=(($97)|0)==(($98)|0);
      var $100=$9;
      var $101=(($99)&1);
      HEAP8[($100)]=$101;
      var $102=$agg_result;
      var $103=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($102)>>2)]=HEAP32[(($103)>>2)];
      $19=1;
      var $104=(($__names)|0);
      var $105=(($104+24)|0);
      var $135 = $105;__label__ = 25; break;
    case 16: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $108=$107.f0;
      $14=$108;
      var $109=$107.f1;
      $15=$109;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 37; break; }
    case 17: // $110
      __label__ = 36; break;
    case 18: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $14=$113;
      var $114=$112.f1;
      $15=$114;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 37; break; }
    case 19: // $115
      __label__ = 36; break;
    case 20: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $118=$117.f0;
      $14=$118;
      var $119=$117.f1;
      $15=$119;
      var $120=$17;
      var $121=(($68)|0)==(($120)|0);
      if ($121) { __label__ = 23; break; } else { var $123 = $120;__label__ = 21; break; }
    case 21: // $122
      var $123;
      var $124=(($123-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 37; break; }
    case 22: // $125
      var $126=(($124)|0)==(($68)|0);
      if ($126) { __label__ = 23; break; } else { var $123 = $124;__label__ = 21; break; }
    case 23: // $127
      __label__ = 36; break;
    case 24: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $130=$129.f0;
      $14=$130;
      var $131=$129.f1;
      $15=$131;
      var $132=(($__names)|0);
      var $133=(($132+24)|0);
      var $152 = $133;__label__ = 32; break;
    case 25: // $134
      var $135;
      var $136=(($135-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $137
      var $138=(($136)|0)==(($104)|0);
      if ($138) { __label__ = 27; break; } else { var $135 = $136;__label__ = 25; break; }
    case 27: // $139
      __label__ = 35; break;
    case 28: // $140
      var $141=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $142=$141.f0;
      $14=$142;
      var $143=$141.f1;
      $15=$143;
      var $144=(($104)|0)==(($136)|0);
      if ($144) { __label__ = 31; break; } else { var $146 = $136;__label__ = 29; break; }
    case 29: // $145
      var $146;
      var $147=(($146-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 37; break; }
    case 30: // $148
      var $149=(($147)|0)==(($104)|0);
      if ($149) { __label__ = 31; break; } else { var $146 = $147;__label__ = 29; break; }
    case 31: // $150
      __label__ = 36; break;
    case 32: // $151
      var $152;
      var $153=(($152-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 37; break; }
    case 33: // $154
      var $155=(($153)|0)==(($132)|0);
      if ($155) { __label__ = 34; break; } else { var $152 = $153;__label__ = 32; break; }
    case 34: // $156
      __label__ = 36; break;
    case 35: // $157
      STACKTOP = __stackBase__;
      return;
    case 36: // $158
      var $159=$14;
      var $160=$14;
      var $161=$15;
      var $162=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $160, tempValue);
      var $163=($162.f1 = $161, $162);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $164
      var $165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb["X"]=1;

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b, $__e, $__kb, $__ke, $__ct, $__err, $__case_sensitive) {
  var __stackBase__  = STACKTOP; STACKTOP += 628; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15;
      var $16=__stackBase__+52;
      var $17=__stackBase__+56;
      var $18;
      var $19=__stackBase__+60;
      var $20=__stackBase__+64;
      var $21=__stackBase__+68;
      var $22=__stackBase__+72;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34=__stackBase__+120;
      var $35=__stackBase__+124;
      var $36=__stackBase__+128;
      var $37=__stackBase__+132;
      var $38=__stackBase__+136;
      var $39=__stackBase__+140;
      var $40=__stackBase__+144;
      var $41=__stackBase__+148;
      var $42=__stackBase__+152;
      var $43=__stackBase__+156;
      var $44=__stackBase__+160;
      var $45=__stackBase__+164;
      var $46=__stackBase__+168;
      var $47=__stackBase__+172;
      var $48=__stackBase__+176;
      var $49=__stackBase__+180;
      var $50=__stackBase__+184;
      var $51=__stackBase__+188;
      var $52;
      var $53;
      var $54=__stackBase__+192;
      var $55=__stackBase__+196;
      var $56=__stackBase__+200;
      var $57=__stackBase__+204;
      var $58=__stackBase__+208;
      var $59=__stackBase__+212;
      var $60=__stackBase__+216;
      var $61=__stackBase__+220;
      var $62=__stackBase__+224;
      var $63=__stackBase__+228;
      var $64=__stackBase__+232;
      var $65=__stackBase__+236;
      var $66=__stackBase__+240;
      var $67=__stackBase__+244;
      var $68=__stackBase__+248;
      var $69=__stackBase__+252;
      var $70=__stackBase__+256;
      var $71=__stackBase__+260;
      var $72=__stackBase__+264;
      var $73=__stackBase__+268;
      var $74=__stackBase__+272;
      var $75=__stackBase__+276;
      var $76=__stackBase__+280;
      var $77=__stackBase__+284;
      var $78=__stackBase__+288;
      var $79=__stackBase__+292;
      var $__tmp_i=__stackBase__+296;
      var $80=__stackBase__+300;
      var $81=__stackBase__+304;
      var $82=__stackBase__+308;
      var $83=__stackBase__+312;
      var $84=__stackBase__+316;
      var $85=__stackBase__+320;
      var $86=__stackBase__+324;
      var $87=__stackBase__+328;
      var $88=__stackBase__+332;
      var $89=__stackBase__+336;
      var $__tmp_i_i_i3=__stackBase__+340;
      var $90=__stackBase__+344;
      var $91=__stackBase__+348;
      var $92=__stackBase__+352;
      var $93=__stackBase__+356;
      var $94=__stackBase__+360;
      var $95=__stackBase__+364;
      var $96=__stackBase__+368;
      var $97=__stackBase__+372;
      var $98=__stackBase__+376;
      var $99=__stackBase__+380;
      var $100=__stackBase__+384;
      var $101=__stackBase__+388;
      var $102=__stackBase__+392;
      var $103=__stackBase__+396;
      var $104=__stackBase__+400;
      var $105=__stackBase__+404;
      var $106=__stackBase__+408;
      var $107=__stackBase__+412;
      var $108=__stackBase__+416;
      var $109=__stackBase__+420;
      var $110=__stackBase__+424;
      var $111=__stackBase__+428;
      var $112=__stackBase__+432;
      var $113=__stackBase__+436;
      var $114=__stackBase__+440;
      var $115=__stackBase__+444;
      var $116=__stackBase__+448;
      var $117=__stackBase__+452;
      var $118=__stackBase__+456;
      var $119=__stackBase__+460;
      var $120=__stackBase__+464;
      var $121=__stackBase__+468;
      var $122=__stackBase__+472;
      var $__tmp_i_i_i=__stackBase__+476;
      var $123=__stackBase__+480;
      var $124=__stackBase__+484;
      var $125=__stackBase__+488;
      var $126=__stackBase__+492;
      var $127=__stackBase__+496;
      var $128=__stackBase__+500;
      var $129=__stackBase__+504;
      var $130=__stackBase__+508;
      var $131=__stackBase__+512;
      var $132=__stackBase__+516;
      var $133;
      var $134;
      var $135;
      var $136;
      var $137;
      var $138;
      var $139;
      var $__nkw;
      var $__doesnt_match;
      var $__might_match;
      var $__does_match;
      var $__statbuf=__stackBase__+520;
      var $__status;
      var $__stat_hold=__stackBase__+620;
      var $140;
      var $141;
      var $__n_might_match;
      var $__n_does_match;
      var $__st;
      var $__ky;
      var $__indx;
      var $__c;
      var $__consume;
      var $__ky1;
      var $__kc;
      var $__ky2;
      var $142;
      $134=$__b;
      $135=$__kb;
      $136=$__ke;
      $137=$__ct;
      $138=$__err;
      var $143=(($__case_sensitive)&1);
      $139=$143;
      var $144=$135;
      var $145=$136;
      var $146=$129;
      var $147=$130;
      var $148=$131;
      var $149=$132;
      HEAP32[(($130)>>2)]=$144;
      HEAP32[(($131)>>2)]=$145;
      var $150=HEAP32[(($130)>>2)];
      var $151=HEAP32[(($131)>>2)];
      var $tmp_i=$129;
      var $tmp1_i=$132;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $152=$127;
      var $153=$128;
      HEAP32[(($127)>>2)]=$150;
      HEAP32[(($128)>>2)]=$151;
      var $154=HEAP32[(($128)>>2)];
      var $155=HEAP32[(($127)>>2)];
      var $156=$154;
      var $157=$155;
      var $158=(($156-$157)|0);
      var $159=(((($158)|0)/12)|0);
      var $160=$127;
      var $161=$128;
      var $162=$129;
      var $163=$130;
      var $164=$131;
      var $165=$132;
      $__nkw=$159;
      $__doesnt_match=0;
      $__might_match=1;
      $__does_match=2;
      var $166=(($__statbuf)|0);
      $__status=$166;
      var $167=$112;
      var $168=$113;
      var $169=$114;
      HEAP32[(($112)>>2)]=$__stat_hold;
      HEAP32[(($113)>>2)]=0;
      HEAP32[(($114)>>2)]=1496;
      var $170=HEAP32[(($112)>>2)];
      var $171=HEAP32[(($113)>>2)];
      var $172=HEAP32[(($114)>>2)];
      var $173=$109;
      var $174=$110;
      var $175=$111;
      HEAP32[(($109)>>2)]=$170;
      HEAP32[(($110)>>2)]=$171;
      HEAP32[(($111)>>2)]=$172;
      var $176=HEAP32[(($109)>>2)];
      var $177=(($176)|0);
      var $178=$108;
      HEAP32[(($108)>>2)]=$110;
      var $179=HEAP32[(($108)>>2)];
      var $180=$108;
      var $181=HEAP32[(($179)>>2)];
      var $182=$94;
      HEAP32[(($94)>>2)]=$111;
      var $183=HEAP32[(($94)>>2)];
      var $184=$94;
      var $185=HEAP32[(($183)>>2)];
      var $186=$105;
      var $187=$106;
      var $188=$107;
      HEAP32[(($105)>>2)]=$177;
      HEAP32[(($106)>>2)]=$181;
      HEAP32[(($107)>>2)]=$185;
      var $189=HEAP32[(($105)>>2)];
      var $190=HEAP32[(($106)>>2)];
      var $191=HEAP32[(($107)>>2)];
      var $192=$102;
      var $193=$103;
      var $194=$104;
      HEAP32[(($102)>>2)]=$189;
      HEAP32[(($103)>>2)]=$190;
      HEAP32[(($104)>>2)]=$191;
      var $195=HEAP32[(($102)>>2)];
      var $196=$195;
      var $197=$101;
      HEAP32[(($101)>>2)]=$103;
      var $198=HEAP32[(($101)>>2)];
      var $199=$101;
      var $200=HEAP32[(($198)>>2)];
      var $201=$95;
      HEAP32[(($95)>>2)]=$104;
      var $202=HEAP32[(($95)>>2)];
      var $203=$95;
      var $204=HEAP32[(($202)>>2)];
      var $205=$98;
      var $206=$99;
      var $207=$100;
      HEAP32[(($98)>>2)]=$196;
      HEAP32[(($99)>>2)]=$200;
      HEAP32[(($100)>>2)]=$204;
      var $208=HEAP32[(($98)>>2)];
      var $209=(($208)|0);
      var $210=$97;
      HEAP32[(($97)>>2)]=$99;
      var $211=HEAP32[(($97)>>2)];
      var $212=$97;
      var $213=HEAP32[(($211)>>2)];
      HEAP32[(($209)>>2)]=$213;
      var $214=(($208+4)|0);
      var $215=$96;
      HEAP32[(($96)>>2)]=$100;
      var $216=HEAP32[(($96)>>2)];
      var $217=$96;
      var $218=HEAP32[(($216)>>2)];
      HEAP32[(($214)>>2)]=$218;
      var $219=$98;
      var $220=$99;
      var $221=$100;
      var $222=$102;
      var $223=$103;
      var $224=$104;
      var $225=$105;
      var $226=$106;
      var $227=$107;
      var $228=$109;
      var $229=$110;
      var $230=$111;
      var $231=$112;
      var $232=$113;
      var $233=$114;
      var $234=$__nkw;
      var $235=(($234)>>>0) > 100;
      if ($235) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $236
      var $237=$__nkw;
      var $238=_malloc($237);
      $__status=$238;
      var $239=$__status;
      var $240=(($239)|0)==0;
      if ($240) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $241
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $242
      __label__ = 9; break;
    case 4: // $243
      var $244=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $245=$244.f0;
      $140=$245;
      var $246=$244.f1;
      $141=$246;
      var $247=$93;
      HEAP32[(($93)>>2)]=$__stat_hold;
      var $248=HEAP32[(($93)>>2)];
      var $249=$92;
      HEAP32[(($92)>>2)]=$248;
      var $250=HEAP32[(($92)>>2)];
      var $251=$88;
      var $252=$89;
      var $253=$__tmp_i_i_i3;
      var $254=$90;
      var $255=$91;
      HEAP32[(($88)>>2)]=$250;
      HEAP32[(($89)>>2)]=0;
      var $256=HEAPU32[(($88)>>2)];
      var $257=(($256)|0);
      var $258=$87;
      HEAP32[(($87)>>2)]=$257;
      var $259=HEAP32[(($87)>>2)];
      var $260=$259;
      var $261=$86;
      HEAP32[(($86)>>2)]=$260;
      var $262=HEAP32[(($86)>>2)];
      var $263=(($262)|0);
      var $264=$86;
      var $265=$87;
      var $266=HEAP32[(($263)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$266;
      var $267=HEAP32[(($89)>>2)];
      var $268=(($256)|0);
      var $269=$85;
      HEAP32[(($85)>>2)]=$268;
      var $270=HEAP32[(($85)>>2)];
      var $271=$270;
      var $272=$84;
      HEAP32[(($84)>>2)]=$271;
      var $273=HEAP32[(($84)>>2)];
      var $274=(($273)|0);
      var $275=$84;
      var $276=$85;
      HEAP32[(($274)>>2)]=$267;
      var $277=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $278=(($277)|0)!=0;
      if ($278) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $279
      var $280=(($256)|0);
      var $281=$83;
      HEAP32[(($83)>>2)]=$280;
      var $282=HEAP32[(($83)>>2)];
      var $283=$282;
      var $284=$82;
      HEAP32[(($82)>>2)]=$283;
      var $285=HEAP32[(($82)>>2)];
      var $286=(($285+4)|0);
      var $287=$82;
      var $288=$83;
      var $289=HEAP32[(($286)>>2)];
      var $290=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$289]($290) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $291
      __label__ = 8; break;
    case 7: // $292
      var $293=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $294=$293.f0;
      HEAP32[(($90)>>2)]=$294;
      var $295=$293.f1;
      HEAP32[(($91)>>2)]=$295;
      var $296=HEAP32[(($90)>>2)];
      ___cxa_call_unexpected($296);
      throw "Reached an unreachable!"
    case 8: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit4
      var $297=$88;
      var $298=$89;
      var $299=$__tmp_i_i_i3;
      var $300=$90;
      var $301=$91;
      var $302=$92;
      var $303=$93;
      __label__ = 106; break;
    case 9: // $304
      var $305=$__status;
      var $306=$78;
      var $307=$79;
      var $308=$__tmp_i;
      var $309=$80;
      var $310=$81;
      HEAP32[(($78)>>2)]=$__stat_hold;
      HEAP32[(($79)>>2)]=$305;
      var $311=HEAP32[(($78)>>2)];
      var $312=(($311)|0);
      var $313=$77;
      HEAP32[(($77)>>2)]=$312;
      var $314=HEAP32[(($77)>>2)];
      var $315=$314;
      var $316=$76;
      HEAP32[(($76)>>2)]=$315;
      var $317=HEAP32[(($76)>>2)];
      var $318=(($317)|0);
      var $319=$76;
      var $320=$77;
      var $321=HEAP32[(($318)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$321;
      var $322=HEAP32[(($79)>>2)];
      var $323=(($311)|0);
      var $324=$75;
      HEAP32[(($75)>>2)]=$323;
      var $325=HEAP32[(($75)>>2)];
      var $326=$325;
      var $327=$74;
      HEAP32[(($74)>>2)]=$326;
      var $328=HEAP32[(($74)>>2)];
      var $329=(($328)|0);
      var $330=$74;
      var $331=$75;
      HEAP32[(($329)>>2)]=$322;
      var $332=HEAP32[(($__tmp_i)>>2)];
      var $333=(($332)|0)!=0;
      if ($333) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $334
      var $335=(($311)|0);
      var $336=$73;
      HEAP32[(($73)>>2)]=$335;
      var $337=HEAP32[(($73)>>2)];
      var $338=$337;
      var $339=$72;
      HEAP32[(($72)>>2)]=$338;
      var $340=HEAP32[(($72)>>2)];
      var $341=(($340+4)|0);
      var $342=$72;
      var $343=$73;
      var $344=HEAP32[(($341)>>2)];
      var $345=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$344]($345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $346
      __label__ = 13; break;
    case 12: // $347
      var $348=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $349=$348.f0;
      HEAP32[(($80)>>2)]=$349;
      var $350=$348.f1;
      HEAP32[(($81)>>2)]=$350;
      var $351=HEAP32[(($80)>>2)];
      ___cxa_call_unexpected($351);
      throw "Reached an unreachable!"
    case 13: // $_ZNSt3__110unique_ptrIhPFvPvEE5resetEPh_exit
      var $352=$78;
      var $353=$79;
      var $354=$__tmp_i;
      var $355=$80;
      var $356=$81;
      __label__ = 14; break;
    case 14: // $357
      var $358=$__nkw;
      $__n_might_match=$358;
      $__n_does_match=0;
      var $359=$__status;
      $__st=$359;
      var $360=$135;
      $__ky=$360;
      __label__ = 15; break;
    case 15: // $361
      var $362=$__ky;
      var $363=$136;
      var $364=(($362)|0)!=(($363)|0);
      if ($364) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $365
      var $366=$__ky;
      var $367=$71;
      HEAP32[(($71)>>2)]=$366;
      var $368=HEAP32[(($71)>>2)];
      var $369=$70;
      HEAP32[(($70)>>2)]=$368;
      var $370=HEAPU32[(($70)>>2)];
      var $371=$69;
      HEAP32[(($69)>>2)]=$370;
      var $372=HEAP32[(($69)>>2)];
      var $373=(($372)|0);
      var $374=$68;
      HEAP32[(($68)>>2)]=$373;
      var $375=HEAP32[(($68)>>2)];
      var $376=$375;
      var $377=$67;
      HEAP32[(($67)>>2)]=$376;
      var $378=HEAP32[(($67)>>2)];
      var $379=(($378)|0);
      var $380=$67;
      var $381=$68;
      var $382=(($379)|0);
      var $383=$382;
      var $384=(($383)|0);
      var $385=$384;
      var $386=HEAPU8[($385)];
      var $387=(($386)&255);
      var $388=$387 & 1;
      var $389=(($388)|0)!=0;
      var $390=$69;
      if ($389) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $391
      var $392=$63;
      HEAP32[(($63)>>2)]=$370;
      var $393=HEAP32[(($63)>>2)];
      var $394=(($393)|0);
      var $395=$62;
      HEAP32[(($62)>>2)]=$394;
      var $396=HEAP32[(($62)>>2)];
      var $397=$396;
      var $398=$61;
      HEAP32[(($61)>>2)]=$397;
      var $399=HEAP32[(($61)>>2)];
      var $400=(($399)|0);
      var $401=$61;
      var $402=$62;
      var $403=(($400)|0);
      var $404=$403;
      var $405=(($404+4)|0);
      var $406=HEAP32[(($405)>>2)];
      var $407=$63;
      var $428 = $406;__label__ = 19; break;
    case 18: // $408
      var $409=$66;
      HEAP32[(($66)>>2)]=$370;
      var $410=HEAP32[(($66)>>2)];
      var $411=(($410)|0);
      var $412=$65;
      HEAP32[(($65)>>2)]=$411;
      var $413=HEAP32[(($65)>>2)];
      var $414=$413;
      var $415=$64;
      HEAP32[(($64)>>2)]=$414;
      var $416=HEAP32[(($64)>>2)];
      var $417=(($416)|0);
      var $418=$64;
      var $419=$65;
      var $420=(($417)|0);
      var $421=$420;
      var $422=(($421)|0);
      var $423=$422;
      var $424=HEAPU8[($423)];
      var $425=(($424)&255);
      var $426=$425 >> 1;
      var $427=$66;
      var $428 = $426;__label__ = 19; break;
    case 19: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $428;
      var $429=$70;
      var $430=(($428)|0)==0;
      var $431=$71;
      if ($430) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $432
      var $433=$__st;
      HEAP8[($433)]=1;
      __label__ = 22; break;
    case 21: // $434
      var $435=$__st;
      HEAP8[($435)]=2;
      var $436=$__n_might_match;
      var $437=(($436-1)|0);
      $__n_might_match=$437;
      var $438=$__n_does_match;
      var $439=(($438+1)|0);
      $__n_does_match=$439;
      __label__ = 22; break;
    case 22: // $440
      __label__ = 23; break;
    case 23: // $441
      var $442=$__ky;
      var $443=(($442+12)|0);
      $__ky=$443;
      var $444=$__st;
      var $445=(($444+1)|0);
      $__st=$445;
      __label__ = 15; break;
    case 24: // $446
      $__indx=0;
      __label__ = 25; break;
    case 25: // $447
      var $448=$134;
      var $449=$59;
      var $450=$60;
      HEAP32[(($59)>>2)]=$448;
      HEAP32[(($60)>>2)]=$__e;
      var $451=HEAP32[(($59)>>2)];
      var $452=HEAP32[(($60)>>2)];
      var $453=$57;
      var $454=$58;
      HEAP32[(($57)>>2)]=$451;
      HEAP32[(($58)>>2)]=$452;
      var $455=HEAP32[(($57)>>2)];
      var $456=(($455)|0);
      var $457=HEAP32[(($456)>>2)];
      var $458=(($457)|0)==0;
      var $459=(($458)&1);
      var $460=HEAP32[(($58)>>2)];
      var $461=(($460)|0);
      var $462=HEAP32[(($461)>>2)];
      var $463=(($462)|0)==0;
      var $464=(($463)&1);
      var $465=(($459)|0)==(($464)|0);
      var $466=$57;
      var $467=$58;
      var $468=$465 ^ 1;
      var $469=$59;
      var $470=$60;
      __label__ = 26; break;
    case 26: // $471
      if ($468) { __label__ = 27; break; } else { var $476 = 0;__label__ = 28; break; }
    case 27: // $472
      var $473=$__n_might_match;
      var $474=(($473)>>>0) > 0;
      var $476 = $474;__label__ = 28; break;
    case 28: // $475
      var $476;
      if ($476) { __label__ = 29; break; } else { __label__ = 90; break; }
    case 29: // $477
      var $478=$134;
      var $479=$56;
      HEAP32[(($56)>>2)]=$478;
      var $480=HEAP32[(($56)>>2)];
      var $481=(($480)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=$54;
      var $484=$55;
      HEAP32[(($55)>>2)]=$482;
      var $485=HEAPU32[(($55)>>2)];
      var $486=(($485+12)|0);
      var $487=HEAP32[(($486)>>2)];
      var $488=(($485+16)|0);
      var $489=HEAP32[(($488)>>2)];
      var $490=(($487)|0)==(($489)|0);
      if ($490) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $491
      var $492=$485;
      var $493=HEAP32[(($492)>>2)];
      var $494=(($493+36)|0);
      var $495=HEAP32[(($494)>>2)];
      var $496=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$495]($485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; };
    case 31: // $_noexc
      HEAP32[(($54)>>2)]=$496;
      __label__ = 33; break;
    case 32: // $497
      var $498=(($485+12)|0);
      var $499=HEAP32[(($498)>>2)];
      var $500=HEAP8[($499)];
      $53=$500;
      var $501=$53;
      var $502=(($501)&255);
      HEAP32[(($54)>>2)]=$502;
      __label__ = 33; break;
    case 33: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $503=HEAP32[(($54)>>2)];
      var $504=$54;
      var $505=$55;
      var $506=(($503) & 255);
      var $507=$56;
      __label__ = 34; break;
    case 34: // $508
      $__c=$506;
      var $509=$139;
      var $510=(($509) & 1);
      if ($510) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $511
      var $512=$137;
      var $513=$__c;
      var $514=$51;
      HEAP32[(($51)>>2)]=$512;
      $52=$513;
      var $515=HEAP32[(($51)>>2)];
      var $516=$515;
      var $517=HEAP32[(($516)>>2)];
      var $518=(($517+12)|0);
      var $519=HEAP32[(($518)>>2)];
      var $520=$52;
      var $521=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$519]($515, $520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $_ZNKSt3__15ctypeIcE7toupperEc_exit
      var $522=$51;
      __label__ = 37; break;
    case 37: // $523
      $__c=$521;
      __label__ = 38; break;
    case 38: // $524
      $__consume=0;
      var $525=$__status;
      $__st=$525;
      var $526=$135;
      $__ky1=$526;
      __label__ = 39; break;
    case 39: // $527
      var $528=$__ky1;
      var $529=$136;
      var $530=(($528)|0)!=(($529)|0);
      if ($530) { __label__ = 40; break; } else { __label__ = 60; break; }
    case 40: // $531
      var $532=$__st;
      var $533=HEAPU8[($532)];
      var $534=(($533)&255);
      var $535=(($534)|0)==1;
      if ($535) { __label__ = 41; break; } else { __label__ = 58; break; }
    case 41: // $536
      var $537=$__ky1;
      var $538=$__indx;
      var $539=$49;
      var $540=$50;
      HEAP32[(($49)>>2)]=$537;
      HEAP32[(($50)>>2)]=$538;
      var $541=HEAP32[(($49)>>2)];
      var $542=$48;
      HEAP32[(($48)>>2)]=$541;
      var $543=HEAP32[(($48)>>2)];
      var $544=$47;
      HEAP32[(($47)>>2)]=$543;
      var $545=HEAPU32[(($47)>>2)];
      var $546=$46;
      HEAP32[(($46)>>2)]=$545;
      var $547=HEAP32[(($46)>>2)];
      var $548=(($547)|0);
      var $549=$45;
      HEAP32[(($45)>>2)]=$548;
      var $550=HEAP32[(($45)>>2)];
      var $551=$550;
      var $552=$44;
      HEAP32[(($44)>>2)]=$551;
      var $553=HEAP32[(($44)>>2)];
      var $554=(($553)|0);
      var $555=$44;
      var $556=$45;
      var $557=(($554)|0);
      var $558=$557;
      var $559=(($558)|0);
      var $560=$559;
      var $561=HEAPU8[($560)];
      var $562=(($561)&255);
      var $563=$562 & 1;
      var $564=(($563)|0)!=0;
      var $565=$46;
      if ($564) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $566
      var $567=$40;
      HEAP32[(($40)>>2)]=$545;
      var $568=HEAP32[(($40)>>2)];
      var $569=(($568)|0);
      var $570=$39;
      HEAP32[(($39)>>2)]=$569;
      var $571=HEAP32[(($39)>>2)];
      var $572=$571;
      var $573=$38;
      HEAP32[(($38)>>2)]=$572;
      var $574=HEAP32[(($38)>>2)];
      var $575=(($574)|0);
      var $576=$38;
      var $577=$39;
      var $578=(($575)|0);
      var $579=$578;
      var $580=(($579+8)|0);
      var $581=HEAP32[(($580)>>2)];
      var $582=$40;
      var $600 = $581;__label__ = 44; break;
    case 43: // $583
      var $584=$43;
      HEAP32[(($43)>>2)]=$545;
      var $585=HEAP32[(($43)>>2)];
      var $586=(($585)|0);
      var $587=$42;
      HEAP32[(($42)>>2)]=$586;
      var $588=HEAP32[(($42)>>2)];
      var $589=$588;
      var $590=$41;
      HEAP32[(($41)>>2)]=$589;
      var $591=HEAP32[(($41)>>2)];
      var $592=(($591)|0);
      var $593=$41;
      var $594=$42;
      var $595=(($592)|0);
      var $596=$595;
      var $597=(($596+1)|0);
      var $598=(($597)|0);
      var $599=$43;
      var $600 = $598;__label__ = 44; break;
    case 44: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $600;
      var $601=$47;
      var $602=$48;
      var $603=HEAP32[(($50)>>2)];
      var $604=(($600+$603)|0);
      var $605=$49;
      var $606=$50;
      __label__ = 45; break;
    case 45: // $607
      var $608=HEAP8[($604)];
      $__kc=$608;
      var $609=$139;
      var $610=(($609) & 1);
      if ($610) { __label__ = 49; break; } else { __label__ = 46; break; }
    case 46: // $611
      var $612=$137;
      var $613=$__kc;
      var $614=$11;
      HEAP32[(($11)>>2)]=$612;
      $12=$613;
      var $615=HEAP32[(($11)>>2)];
      var $616=$615;
      var $617=HEAP32[(($616)>>2)];
      var $618=(($617+12)|0);
      var $619=HEAP32[(($618)>>2)];
      var $620=$12;
      var $621=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$619]($615, $620) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 4; break; };
    case 47: // $_ZNKSt3__15ctypeIcE7toupperEc_exit9
      var $622=$11;
      __label__ = 48; break;
    case 48: // $623
      $__kc=$621;
      __label__ = 49; break;
    case 49: // $624
      var $625=$__c;
      var $626=(($625 << 24) >> 24);
      var $627=$__kc;
      var $628=(($627 << 24) >> 24);
      var $629=(($626)|0)==(($628)|0);
      if ($629) { __label__ = 50; break; } else { __label__ = 56; break; }
    case 50: // $630
      $__consume=1;
      var $631=$__ky1;
      var $632=$10;
      HEAP32[(($10)>>2)]=$631;
      var $633=HEAPU32[(($10)>>2)];
      var $634=$9;
      HEAP32[(($9)>>2)]=$633;
      var $635=HEAP32[(($9)>>2)];
      var $636=(($635)|0);
      var $637=$8;
      HEAP32[(($8)>>2)]=$636;
      var $638=HEAP32[(($8)>>2)];
      var $639=$638;
      var $640=$7;
      HEAP32[(($7)>>2)]=$639;
      var $641=HEAP32[(($7)>>2)];
      var $642=(($641)|0);
      var $643=$7;
      var $644=$8;
      var $645=(($642)|0);
      var $646=$645;
      var $647=(($646)|0);
      var $648=$647;
      var $649=HEAPU8[($648)];
      var $650=(($649)&255);
      var $651=$650 & 1;
      var $652=(($651)|0)!=0;
      var $653=$9;
      if ($652) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $654
      var $655=$3;
      HEAP32[(($3)>>2)]=$633;
      var $656=HEAP32[(($3)>>2)];
      var $657=(($656)|0);
      var $658=$2;
      HEAP32[(($2)>>2)]=$657;
      var $659=HEAP32[(($2)>>2)];
      var $660=$659;
      var $661=$1;
      HEAP32[(($1)>>2)]=$660;
      var $662=HEAP32[(($1)>>2)];
      var $663=(($662)|0);
      var $664=$1;
      var $665=$2;
      var $666=(($663)|0);
      var $667=$666;
      var $668=(($667+4)|0);
      var $669=HEAP32[(($668)>>2)];
      var $670=$3;
      var $691 = $669;__label__ = 53; break;
    case 52: // $671
      var $672=$6;
      HEAP32[(($6)>>2)]=$633;
      var $673=HEAP32[(($6)>>2)];
      var $674=(($673)|0);
      var $675=$5;
      HEAP32[(($5)>>2)]=$674;
      var $676=HEAP32[(($5)>>2)];
      var $677=$676;
      var $678=$4;
      HEAP32[(($4)>>2)]=$677;
      var $679=HEAP32[(($4)>>2)];
      var $680=(($679)|0);
      var $681=$4;
      var $682=$5;
      var $683=(($680)|0);
      var $684=$683;
      var $685=(($684)|0);
      var $686=$685;
      var $687=HEAPU8[($686)];
      var $688=(($687)&255);
      var $689=$688 >> 1;
      var $690=$6;
      var $691 = $689;__label__ = 53; break;
    case 53: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit10
      var $691;
      var $692=$10;
      var $693=$__indx;
      var $694=(($693+1)|0);
      var $695=(($691)|0)==(($694)|0);
      if ($695) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $696
      var $697=$__st;
      HEAP8[($697)]=2;
      var $698=$__n_might_match;
      var $699=(($698-1)|0);
      $__n_might_match=$699;
      var $700=$__n_does_match;
      var $701=(($700+1)|0);
      $__n_does_match=$701;
      __label__ = 55; break;
    case 55: // $702
      __label__ = 57; break;
    case 56: // $703
      var $704=$__st;
      HEAP8[($704)]=0;
      var $705=$__n_might_match;
      var $706=(($705-1)|0);
      $__n_might_match=$706;
      __label__ = 57; break;
    case 57: // $707
      __label__ = 58; break;
    case 58: // $708
      __label__ = 59; break;
    case 59: // $709
      var $710=$__ky1;
      var $711=(($710+12)|0);
      $__ky1=$711;
      var $712=$__st;
      var $713=(($712+1)|0);
      $__st=$713;
      __label__ = 39; break;
    case 60: // $714
      var $715=$__consume;
      var $716=(($715) & 1);
      if ($716) { __label__ = 61; break; } else { __label__ = 88; break; }
    case 61: // $717
      var $718=$134;
      var $719=$23;
      HEAP32[(($23)>>2)]=$718;
      var $720=HEAPU32[(($23)>>2)];
      var $721=(($720)|0);
      var $722=HEAP32[(($721)>>2)];
      var $723=$21;
      var $724=$22;
      HEAP32[(($22)>>2)]=$722;
      var $725=HEAPU32[(($22)>>2)];
      var $726=$19;
      var $727=$20;
      HEAP32[(($20)>>2)]=$725;
      var $728=HEAP32[(($20)>>2)];
      var $729=(($728+12)|0);
      var $730=HEAP32[(($729)>>2)];
      var $731=(($728+16)|0);
      var $732=HEAP32[(($731)>>2)];
      var $733=(($730)|0)==(($732)|0);
      if ($733) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $734
      var $735=$728;
      var $736=HEAP32[(($735)>>2)];
      var $737=(($736+40)|0);
      var $738=HEAP32[(($737)>>2)];
      var $739=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$738]($728) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 4; break; };
    case 63: // $_noexc6
      HEAP32[(($19)>>2)]=$739;
      __label__ = 65; break;
    case 64: // $740
      var $741=(($728+12)|0);
      var $742=HEAP32[(($741)>>2)];
      var $743=(($742+1)|0);
      HEAP32[(($741)>>2)]=$743;
      var $744=HEAP8[($742)];
      $18=$744;
      var $745=$18;
      var $746=(($745)&255);
      HEAP32[(($19)>>2)]=$746;
      __label__ = 65; break;
    case 65: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $747=HEAP32[(($19)>>2)];
      var $748=$19;
      var $749=$20;
      var $750=(($747)|0)==-1;
      if ($750) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $751
      HEAP32[(($21)>>2)]=-1;
      __label__ = 72; break;
    case 67: // $752
      var $753=$16;
      var $754=$17;
      HEAP32[(($17)>>2)]=$725;
      var $755=HEAPU32[(($17)>>2)];
      var $756=(($755+12)|0);
      var $757=HEAP32[(($756)>>2)];
      var $758=(($755+16)|0);
      var $759=HEAP32[(($758)>>2)];
      var $760=(($757)|0)==(($759)|0);
      if ($760) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $761
      var $762=$755;
      var $763=HEAP32[(($762)>>2)];
      var $764=(($763+36)|0);
      var $765=HEAP32[(($764)>>2)];
      var $766=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$765]($755) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 4; break; };
    case 69: // $_noexc7
      HEAP32[(($16)>>2)]=$766;
      __label__ = 71; break;
    case 70: // $767
      var $768=(($755+12)|0);
      var $769=HEAP32[(($768)>>2)];
      var $770=HEAP8[($769)];
      $15=$770;
      var $771=$15;
      var $772=(($771)&255);
      HEAP32[(($16)>>2)]=$772;
      __label__ = 71; break;
    case 71: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $773=HEAP32[(($16)>>2)];
      var $774=$16;
      var $775=$17;
      HEAP32[(($21)>>2)]=$773;
      __label__ = 72; break;
    case 72: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $776=HEAP32[(($21)>>2)];
      var $777=$21;
      var $778=$22;
      var $779=$13;
      var $780=$14;
      HEAP32[(($13)>>2)]=$776;
      HEAP32[(($14)>>2)]=-1;
      var $781=HEAP32[(($13)>>2)];
      var $782=HEAP32[(($14)>>2)];
      var $783=(($781)|0)==(($782)|0);
      var $784=$13;
      var $785=$14;
      if ($783) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $786
      var $787=(($720)|0);
      HEAP32[(($787)>>2)]=0;
      __label__ = 74; break;
    case 74: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $788=$23;
      __label__ = 75; break;
    case 75: // $789
      var $790=$__n_might_match;
      var $791=$__n_does_match;
      var $792=(($790+$791)|0);
      var $793=(($792)>>>0) > 1;
      if ($793) { __label__ = 76; break; } else { __label__ = 87; break; }
    case 76: // $794
      var $795=$__status;
      $__st=$795;
      var $796=$135;
      $__ky2=$796;
      __label__ = 77; break;
    case 77: // $797
      var $798=$__ky2;
      var $799=$136;
      var $800=(($798)|0)!=(($799)|0);
      if ($800) { __label__ = 78; break; } else { __label__ = 86; break; }
    case 78: // $801
      var $802=$__st;
      var $803=HEAPU8[($802)];
      var $804=(($803)&255);
      var $805=(($804)|0)==2;
      if ($805) { __label__ = 79; break; } else { __label__ = 84; break; }
    case 79: // $806
      var $807=$__ky2;
      var $808=$33;
      HEAP32[(($33)>>2)]=$807;
      var $809=HEAPU32[(($33)>>2)];
      var $810=$32;
      HEAP32[(($32)>>2)]=$809;
      var $811=HEAP32[(($32)>>2)];
      var $812=(($811)|0);
      var $813=$31;
      HEAP32[(($31)>>2)]=$812;
      var $814=HEAP32[(($31)>>2)];
      var $815=$814;
      var $816=$30;
      HEAP32[(($30)>>2)]=$815;
      var $817=HEAP32[(($30)>>2)];
      var $818=(($817)|0);
      var $819=$30;
      var $820=$31;
      var $821=(($818)|0);
      var $822=$821;
      var $823=(($822)|0);
      var $824=$823;
      var $825=HEAPU8[($824)];
      var $826=(($825)&255);
      var $827=$826 & 1;
      var $828=(($827)|0)!=0;
      var $829=$32;
      if ($828) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $830
      var $831=$26;
      HEAP32[(($26)>>2)]=$809;
      var $832=HEAP32[(($26)>>2)];
      var $833=(($832)|0);
      var $834=$25;
      HEAP32[(($25)>>2)]=$833;
      var $835=HEAP32[(($25)>>2)];
      var $836=$835;
      var $837=$24;
      HEAP32[(($24)>>2)]=$836;
      var $838=HEAP32[(($24)>>2)];
      var $839=(($838)|0);
      var $840=$24;
      var $841=$25;
      var $842=(($839)|0);
      var $843=$842;
      var $844=(($843+4)|0);
      var $845=HEAP32[(($844)>>2)];
      var $846=$26;
      var $867 = $845;__label__ = 82; break;
    case 81: // $847
      var $848=$29;
      HEAP32[(($29)>>2)]=$809;
      var $849=HEAP32[(($29)>>2)];
      var $850=(($849)|0);
      var $851=$28;
      HEAP32[(($28)>>2)]=$850;
      var $852=HEAP32[(($28)>>2)];
      var $853=$852;
      var $854=$27;
      HEAP32[(($27)>>2)]=$853;
      var $855=HEAP32[(($27)>>2)];
      var $856=(($855)|0);
      var $857=$27;
      var $858=$28;
      var $859=(($856)|0);
      var $860=$859;
      var $861=(($860)|0);
      var $862=$861;
      var $863=HEAPU8[($862)];
      var $864=(($863)&255);
      var $865=$864 >> 1;
      var $866=$29;
      var $867 = $865;__label__ = 82; break;
    case 82: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $867;
      var $868=$33;
      var $869=$__indx;
      var $870=(($869+1)|0);
      var $871=(($867)|0)!=(($870)|0);
      if ($871) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $872
      var $873=$__st;
      HEAP8[($873)]=0;
      var $874=$__n_does_match;
      var $875=(($874-1)|0);
      $__n_does_match=$875;
      __label__ = 84; break;
    case 84: // $876
      __label__ = 85; break;
    case 85: // $877
      var $878=$__ky2;
      var $879=(($878+12)|0);
      $__ky2=$879;
      var $880=$__st;
      var $881=(($880+1)|0);
      $__st=$881;
      __label__ = 77; break;
    case 86: // $882
      __label__ = 87; break;
    case 87: // $883
      __label__ = 88; break;
    case 88: // $884
      __label__ = 89; break;
    case 89: // $885
      var $886=$__indx;
      var $887=(($886+1)|0);
      $__indx=$887;
      __label__ = 25; break;
    case 90: // $888
      var $889=$134;
      var $890=$36;
      var $891=$37;
      HEAP32[(($36)>>2)]=$889;
      HEAP32[(($37)>>2)]=$__e;
      var $892=HEAP32[(($36)>>2)];
      var $893=HEAP32[(($37)>>2)];
      var $894=$34;
      var $895=$35;
      HEAP32[(($34)>>2)]=$892;
      HEAP32[(($35)>>2)]=$893;
      var $896=HEAP32[(($34)>>2)];
      var $897=(($896)|0);
      var $898=HEAP32[(($897)>>2)];
      var $899=(($898)|0)==0;
      var $900=(($899)&1);
      var $901=HEAP32[(($35)>>2)];
      var $902=(($901)|0);
      var $903=HEAP32[(($902)>>2)];
      var $904=(($903)|0)==0;
      var $905=(($904)&1);
      var $906=(($900)|0)==(($905)|0);
      var $907=$34;
      var $908=$35;
      var $909=$36;
      var $910=$37;
      __label__ = 91; break;
    case 91: // $911
      if ($906) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $912
      var $913=$138;
      var $914=HEAP32[(($913)>>2)];
      var $915=$914 | 2;
      HEAP32[(($913)>>2)]=$915;
      __label__ = 93; break;
    case 93: // $916
      var $917=$__status;
      $__st=$917;
      __label__ = 94; break;
    case 94: // $918
      var $919=$135;
      var $920=$136;
      var $921=(($919)|0)!=(($920)|0);
      if ($921) { __label__ = 95; break; } else { __label__ = 99; break; }
    case 95: // $922
      var $923=$__st;
      var $924=HEAPU8[($923)];
      var $925=(($924)&255);
      var $926=(($925)|0)==2;
      if ($926) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $927
      __label__ = 99; break;
    case 97: // $928
      __label__ = 98; break;
    case 98: // $929
      var $930=$135;
      var $931=(($930+12)|0);
      $135=$931;
      var $932=$__st;
      var $933=(($932+1)|0);
      $__st=$933;
      __label__ = 94; break;
    case 99: // $934
      var $935=$135;
      var $936=$136;
      var $937=(($935)|0)==(($936)|0);
      if ($937) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $938
      var $939=$138;
      var $940=HEAP32[(($939)>>2)];
      var $941=$940 | 4;
      HEAP32[(($939)>>2)]=$941;
      __label__ = 101; break;
    case 101: // $942
      var $943=$135;
      $133=$943;
      $142=1;
      var $944=$126;
      HEAP32[(($126)>>2)]=$__stat_hold;
      var $945=HEAP32[(($126)>>2)];
      var $946=$125;
      HEAP32[(($125)>>2)]=$945;
      var $947=HEAP32[(($125)>>2)];
      var $948=$121;
      var $949=$122;
      var $950=$__tmp_i_i_i;
      var $951=$123;
      var $952=$124;
      HEAP32[(($121)>>2)]=$947;
      HEAP32[(($122)>>2)]=0;
      var $953=HEAP32[(($121)>>2)];
      var $954=(($953)|0);
      var $955=$120;
      HEAP32[(($120)>>2)]=$954;
      var $956=HEAP32[(($120)>>2)];
      var $957=$956;
      var $958=$119;
      HEAP32[(($119)>>2)]=$957;
      var $959=HEAP32[(($119)>>2)];
      var $960=(($959)|0);
      var $961=$119;
      var $962=$120;
      var $963=HEAP32[(($960)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$963;
      var $964=HEAP32[(($122)>>2)];
      var $965=(($953)|0);
      var $966=$118;
      HEAP32[(($118)>>2)]=$965;
      var $967=HEAP32[(($118)>>2)];
      var $968=$967;
      var $969=$117;
      HEAP32[(($117)>>2)]=$968;
      var $970=HEAP32[(($117)>>2)];
      var $971=(($970)|0);
      var $972=$117;
      var $973=$118;
      HEAP32[(($971)>>2)]=$964;
      var $974=HEAP32[(($__tmp_i_i_i)>>2)];
      var $975=(($974)|0)!=0;
      if ($975) { __label__ = 102; break; } else { __label__ = 105; break; }
    case 102: // $976
      var $977=(($953)|0);
      var $978=$116;
      HEAP32[(($116)>>2)]=$977;
      var $979=HEAP32[(($116)>>2)];
      var $980=$979;
      var $981=$115;
      HEAP32[(($115)>>2)]=$980;
      var $982=HEAP32[(($115)>>2)];
      var $983=(($982+4)|0);
      var $984=$115;
      var $985=$116;
      var $986=HEAP32[(($983)>>2)];
      var $987=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$986]($987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $988
      __label__ = 105; break;
    case 104: // $989
      var $990=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $991=$990.f0;
      HEAP32[(($123)>>2)]=$991;
      var $992=$990.f1;
      HEAP32[(($124)>>2)]=$992;
      var $993=HEAP32[(($123)>>2)];
      ___cxa_call_unexpected($993);
      throw "Reached an unreachable!"
    case 105: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit
      var $994=$121;
      var $995=$122;
      var $996=$__tmp_i_i_i;
      var $997=$123;
      var $998=$124;
      var $999=$125;
      var $1000=$126;
      var $1001=$133;
      STACKTOP = __stackBase__;
      return $1001;
    case 106: // $1002
      __label__ = 107; break;
    case 107: // $1003
      var $1004=$140;
      var $1005=$140;
      var $1006=$141;
      var $1007=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1005, tempValue);
      var $1008=($1007.f1 = $1006, $1007);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $1010=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb["X"]=1;

function __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($iob) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $__basefield;
      $3=$iob;
      var $4=$3;
      var $5=$1;
      HEAP32[(($1)>>2)]=$4;
      var $6=HEAP32[(($1)>>2)];
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$1;
      var $10=$8 & 74;
      $__basefield=$10;
      var $11=$__basefield;
      var $12=(($11)|0)==64;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      $2=8;
      __label__ = 9; break;
    case 2: // $14
      var $15=$__basefield;
      var $16=(($15)|0)==8;
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $17
      $2=16;
      __label__ = 9; break;
    case 4: // $18
      var $19=$__basefield;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $21
      $2=0;
      __label__ = 9; break;
    case 6: // $22
      __label__ = 7; break;
    case 7: // $23
      __label__ = 8; break;
    case 8: // $24
      $2=10;
      __label__ = 9; break;
    case 9: // $25
      var $26=$2;
      STACKTOP = __stackBase__;
      return $26;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+120;
      var $__thousands_sep=__stackBase__+148;
      var $__grouping=__stackBase__+152;
      var $__a=__stackBase__+164;
      var $__a_end=__stackBase__+204;
      var $__g=__stackBase__+208;
      var $__g_end=__stackBase__+368;
      var $__dc=__stackBase__+372;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP8[($94)];
      $22=$95;
      var $96=$22;
      var $97=(($96)&255);
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $98=HEAP32[(($23)>>2)];
      var $99=$23;
      var $100=$24;
      var $101=(($98) & 255);
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP8[($__thousands_sep)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($101, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAPU32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP8[($142)];
      $16=$144;
      var $145=$16;
      var $146=(($145)&255);
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $147=HEAP32[(($17)>>2)];
      var $148=$17;
      var $149=$18;
      var $150=(($147)|0)==-1;
      if ($150) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $151
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $152
      var $153=$14;
      var $154=$15;
      HEAP32[(($15)>>2)]=$125;
      var $155=HEAPU32[(($15)>>2)];
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155+16)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($157)|0)==(($159)|0);
      if ($160) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $161
      var $162=$155;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$165]($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$166;
      __label__ = 23; break;
    case 22: // $167
      var $168=(($155+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=HEAP8[($169)];
      $13=$170;
      var $171=$13;
      var $172=(($171)&255);
      HEAP32[(($14)>>2)]=$172;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($120)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $253
      var $254=HEAP32[(($__g_end)>>2)];
      var $255=(($__g)|0);
      var $256=$254;
      var $257=$255;
      var $258=(($256-$257)|0);
      var $259=(((($258)|0)/4)|0);
      var $260=(($259)|0) < 40;
      if ($260) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $261
      var $262=HEAP32[(($__dc)>>2)];
      var $263=HEAP32[(($__g_end)>>2)];
      var $264=(($263+4)|0);
      HEAP32[(($__g_end)>>2)]=$264;
      HEAP32[(($263)>>2)]=$262;
      __label__ = 34; break;
    case 34: // $265
      var $266=(($__a)|0);
      var $267=HEAP32[(($__a_end)>>2)];
      var $268=$36;
      var $269=$__base;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji($266, $267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $271
      var $272=$37;
      HEAP32[(($272)>>2)]=$270;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 37; break;
    case 37: // $298
      if ($293) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $306
      __label__ = 41; break;
    case 41: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl["X"]=1;

function __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($agg_result, $__iob, $__atoms, $__thousands_sep) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      var $11;
      var $__loc=__stackBase__+32;
      var $12;
      var $13;
      var $__np;
      var $14;
      $9=$__iob;
      $10=$__atoms;
      $11=$__thousands_sep;
      var $15=$9;
      __ZNKSt3__18ios_base6getlocEv($__loc, $15);
      var $16=$8;
      HEAP32[(($8)>>2)]=$__loc;
      var $17=HEAP32[(($8)>>2)];
      var $18=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($17, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 11; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $19=$18;
      var $20=$8;
      __label__ = 2; break;
    case 2: // $21
      var $22=$10;
      var $23=$4;
      var $24=$5;
      var $25=$6;
      var $26=$7;
      HEAP32[(($4)>>2)]=$19;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE)|0);
      HEAP32[(($6)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+26)|0);
      HEAP32[(($7)>>2)]=$22;
      var $27=HEAP32[(($4)>>2)];
      var $28=$27;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+32)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=HEAP32[(($5)>>2)];
      var $33=HEAP32[(($6)>>2)];
      var $34=HEAP32[(($7)>>2)];
      var $35=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$31]($27, $32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; };
    case 3: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $36=$4;
      var $37=$5;
      var $38=$6;
      var $39=$7;
      __label__ = 4; break;
    case 4: // $40
      var $41=$3;
      HEAP32[(($3)>>2)]=$__loc;
      var $42=HEAP32[(($3)>>2)];
      var $43=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($42, __ZNSt3__18numpunctIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_ZNSt3__19use_facetINS_8numpunctIcEEEERKT_RKNS_6localeE_exit
      var $44=$43;
      var $45=$3;
      __label__ = 6; break;
    case 6: // $46
      $__np=$44;
      var $47=$__np;
      var $48=$2;
      HEAP32[(($2)>>2)]=$47;
      var $49=HEAP32[(($2)>>2)];
      var $50=$49;
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+16)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$53]($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $_ZNKSt3__18numpunctIcE13thousands_sepEv_exit
      var $55=$2;
      __label__ = 8; break;
    case 8: // $56
      var $57=$11;
      HEAP8[($57)]=$54;
      var $58=$__np;
      var $59=$1;
      HEAP32[(($1)>>2)]=$58;
      var $60=HEAP32[(($1)>>2)];
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+20)|0);
      var $64=HEAP32[(($63)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$64]($agg_result, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $_ZNKSt3__18numpunctIcE8groupingEv_exit
      var $65=$1;
      __label__ = 10; break;
    case 10: // $66
      $14=1;
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc);
      STACKTOP = __stackBase__;
      return;
    case 11: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $12=$69;
      var $70=$68.f1;
      $13=$70;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $71
      __label__ = 13; break;
    case 13: // $72
      var $73=$12;
      var $74=$12;
      var $75=$13;
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc["X"]=1;

function __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($__ct, $__base, $__a, $__a_end, $__dc, $__thousands_sep, $__grouping, $__g, $__g_end, $__atoms) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14;
      var $15=__stackBase__+52;
      var $16;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $24;
      var $__f;
      HEAP8[($15)]=$__ct;
      $16=$__base;
      $17=$__a;
      $18=$__a_end;
      $19=$__dc;
      $20=$__thousands_sep;
      $21=$__grouping;
      $22=$__g;
      $23=$__g_end;
      $24=$__atoms;
      var $25=$18;
      var $26=HEAP32[(($25)>>2)];
      var $27=$17;
      var $28=(($26)|0)==(($27)|0);
      if ($28) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $29
      var $30=HEAP8[($15)];
      var $31=(($30 << 24) >> 24);
      var $32=$24;
      var $33=(($32+24)|0);
      var $34=HEAP8[($33)];
      var $35=(($34 << 24) >> 24);
      var $36=(($31)|0)==(($35)|0);
      if ($36) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $37
      var $38=HEAP8[($15)];
      var $39=(($38 << 24) >> 24);
      var $40=$24;
      var $41=(($40+25)|0);
      var $42=HEAP8[($41)];
      var $43=(($42 << 24) >> 24);
      var $44=(($39)|0)==(($43)|0);
      if ($44) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $45
      var $46=HEAP8[($15)];
      var $47=(($46 << 24) >> 24);
      var $48=$24;
      var $49=(($48+24)|0);
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24);
      var $52=(($47)|0)==(($51)|0);
      var $53=$52 ? 43 : 45;
      var $54=$18;
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+1)|0);
      HEAP32[(($54)>>2)]=$56;
      HEAP8[($55)]=$53;
      var $57=$19;
      HEAP32[(($57)>>2)]=0;
      $14=0;
      __label__ = 33; break;
    case 4: // $58
      var $59=HEAP8[($15)];
      var $60=(($59 << 24) >> 24);
      var $61=$20;
      var $62=(($61 << 24) >> 24);
      var $63=(($60)|0)==(($62)|0);
      if ($63) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $64
      var $65=$21;
      var $66=$13;
      HEAP32[(($13)>>2)]=$65;
      var $67=HEAPU32[(($13)>>2)];
      var $68=$12;
      HEAP32[(($12)>>2)]=$67;
      var $69=HEAP32[(($12)>>2)];
      var $70=(($69)|0);
      var $71=$11;
      HEAP32[(($11)>>2)]=$70;
      var $72=HEAP32[(($11)>>2)];
      var $73=$72;
      var $74=$10;
      HEAP32[(($10)>>2)]=$73;
      var $75=HEAP32[(($10)>>2)];
      var $76=(($75)|0);
      var $77=$10;
      var $78=$11;
      var $79=(($76)|0);
      var $80=$79;
      var $81=(($80)|0);
      var $82=$81;
      var $83=HEAPU8[($82)];
      var $84=(($83)&255);
      var $85=$84 & 1;
      var $86=(($85)|0)!=0;
      var $87=$12;
      if ($86) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $88
      var $89=$6;
      HEAP32[(($6)>>2)]=$67;
      var $90=HEAP32[(($6)>>2)];
      var $91=(($90)|0);
      var $92=$5;
      HEAP32[(($5)>>2)]=$91;
      var $93=HEAP32[(($5)>>2)];
      var $94=$93;
      var $95=$4;
      HEAP32[(($4)>>2)]=$94;
      var $96=HEAP32[(($4)>>2)];
      var $97=(($96)|0);
      var $98=$4;
      var $99=$5;
      var $100=(($97)|0);
      var $101=$100;
      var $102=(($101+4)|0);
      var $103=HEAP32[(($102)>>2)];
      var $104=$6;
      var $125 = $103;__label__ = 8; break;
    case 7: // $105
      var $106=$9;
      HEAP32[(($9)>>2)]=$67;
      var $107=HEAP32[(($9)>>2)];
      var $108=(($107)|0);
      var $109=$8;
      HEAP32[(($8)>>2)]=$108;
      var $110=HEAP32[(($8)>>2)];
      var $111=$110;
      var $112=$7;
      HEAP32[(($7)>>2)]=$111;
      var $113=HEAP32[(($7)>>2)];
      var $114=(($113)|0);
      var $115=$7;
      var $116=$8;
      var $117=(($114)|0);
      var $118=$117;
      var $119=(($118)|0);
      var $120=$119;
      var $121=HEAPU8[($120)];
      var $122=(($121)&255);
      var $123=$122 >> 1;
      var $124=$9;
      var $125 = $123;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $125;
      var $126=$13;
      var $127=(($125)|0)!=0;
      if ($127) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $128
      var $129=$23;
      var $130=HEAP32[(($129)>>2)];
      var $131=$22;
      var $132=$130;
      var $133=$131;
      var $134=(($132-$133)|0);
      var $135=(((($134)|0)/4)|0);
      var $136=(($135)|0) < 40;
      if ($136) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $137
      var $138=$19;
      var $139=HEAP32[(($138)>>2)];
      var $140=$23;
      var $141=HEAP32[(($140)>>2)];
      var $142=(($141+4)|0);
      HEAP32[(($140)>>2)]=$142;
      HEAP32[(($141)>>2)]=$139;
      var $143=$19;
      HEAP32[(($143)>>2)]=0;
      __label__ = 11; break;
    case 11: // $144
      $14=0;
      __label__ = 33; break;
    case 12: // $145
      var $146=$24;
      var $147=$24;
      var $148=(($147+26)|0);
      var $149=$1;
      var $150=$2;
      var $151=$3;
      HEAP32[(($1)>>2)]=$146;
      HEAP32[(($2)>>2)]=$148;
      HEAP32[(($3)>>2)]=$15;
      __label__ = 13; break;
    case 13: // $152
      var $153=HEAP32[(($1)>>2)];
      var $154=HEAP32[(($2)>>2)];
      var $155=(($153)|0)!=(($154)|0);
      if ($155) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $156
      var $157=HEAP32[(($1)>>2)];
      var $158=HEAP8[($157)];
      var $159=(($158 << 24) >> 24);
      var $160=HEAP32[(($3)>>2)];
      var $161=HEAP8[($160)];
      var $162=(($161 << 24) >> 24);
      var $163=(($159)|0)==(($162)|0);
      if ($163) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $164
      __label__ = 17; break;
    case 16: // $165
      var $166=HEAP32[(($1)>>2)];
      var $167=(($166+1)|0);
      HEAP32[(($1)>>2)]=$167;
      __label__ = 13; break;
    case 17: // $_ZNSt3__14findIPccEET_S2_S2_RKT0__exit
      var $168=HEAP32[(($1)>>2)];
      var $169=$1;
      var $170=$2;
      var $171=$3;
      var $172=$24;
      var $173=$168;
      var $174=$172;
      var $175=(($173-$174)|0);
      $__f=$175;
      var $176=$__f;
      var $177=(($176)|0) >= 24;
      if ($177) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $178
      $14=-1;
      __label__ = 33; break;
    case 19: // $179
      var $180=$16;
      if ($180 == 8 || $180 == 10) {
        __label__ = 20; break;
      }
      else if ($180 == 16) {
        __label__ = 23; break;
      }
      else {
      __label__ = 30; break;
      }
      
    case 20: // $181
      var $182=$__f;
      var $183=$16;
      var $184=(($182)|0) >= (($183)|0);
      if ($184) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $185
      $14=-1;
      __label__ = 33; break;
    case 22: // $186
      __label__ = 30; break;
    case 23: // $187
      var $188=$__f;
      var $189=(($188)|0) < 22;
      if ($189) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $190
      __label__ = 30; break;
    case 25: // $191
      var $192=$18;
      var $193=HEAP32[(($192)>>2)];
      var $194=$17;
      var $195=(($193)|0)!=(($194)|0);
      if ($195) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $196
      var $197=$18;
      var $198=HEAP32[(($197)>>2)];
      var $199=$17;
      var $200=$198;
      var $201=$199;
      var $202=(($200-$201)|0);
      var $203=(($202)|0) <= 2;
      if ($203) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $204
      var $205=$18;
      var $206=HEAP32[(($205)>>2)];
      var $207=(($206-1)|0);
      var $208=HEAP8[($207)];
      var $209=(($208 << 24) >> 24);
      var $210=(($209)|0)==48;
      if ($210) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $211
      var $212=$19;
      HEAP32[(($212)>>2)]=0;
      var $213=$__f;
      var $214=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+$213)|0);
      var $215=HEAP8[($214)];
      var $216=$18;
      var $217=HEAP32[(($216)>>2)];
      var $218=(($217+1)|0);
      HEAP32[(($216)>>2)]=$218;
      HEAP8[($217)]=$215;
      $14=0;
      __label__ = 33; break;
    case 29: // $219
      $14=-1;
      __label__ = 33; break;
    case 30: // $220
      var $221=$18;
      var $222=HEAP32[(($221)>>2)];
      var $223=$17;
      var $224=$222;
      var $225=$223;
      var $226=(($224-$225)|0);
      var $227=(($226)|0) < 39;
      if ($227) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $228
      var $229=$__f;
      var $230=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+$229)|0);
      var $231=HEAP8[($230)];
      var $232=$18;
      var $233=HEAP32[(($232)>>2)];
      var $234=(($233+1)|0);
      HEAP32[(($232)>>2)]=$234;
      HEAP8[($233)]=$231;
      __label__ = 32; break;
    case 32: // $235
      var $236=$19;
      var $237=HEAP32[(($236)>>2)];
      var $238=(($237+1)|0);
      HEAP32[(($236)>>2)]=$238;
      $14=0;
      __label__ = 33; break;
    case 33: // $239
      var $240=$14;
      STACKTOP = __stackBase__;
      return $240;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_["X"]=1;

function __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji($__a, $__a_end, $__err, $__base) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__save_errno;
      var $__p2=__stackBase__;
      var $__ll=__stackBase__+4;
      var $__current_errno;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      $5=$__base;
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $9
      var $10=___errno();
      var $11=HEAP32[(($10)>>2)];
      $__save_errno=$11;
      var $12=___errno();
      HEAP32[(($12)>>2)]=0;
      var $13=$2;
      var $14=$5;
      var $15=__ZNSt3__16__clocEv();
      var $16=_strtoll_l($13, $__p2, $14, $15);
      var $16$0=$16[0];
      var $16$1=$16[1];
      var $st$11$0=(($__ll)|0);
      HEAP32[(($st$11$0)>>2)]=$16$0;
      var $st$11$1=(($__ll+4)|0);
      HEAP32[(($st$11$1)>>2)]=$16$1;
      var $17=___errno();
      var $18=HEAP32[(($17)>>2)];
      $__current_errno=$18;
      var $19=$__current_errno;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__save_errno;
      var $23=___errno();
      HEAP32[(($23)>>2)]=$22;
      __label__ = 3; break;
    case 3: // $24
      var $25=HEAP32[(($__p2)>>2)];
      var $26=$3;
      var $27=(($25)|0)!=(($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$4;
      HEAP32[(($29)>>2)]=4;
      $1=0;
      __label__ = 14; break;
    case 5: // $30
      var $31=$__current_errno;
      var $32=(($31)|0)==34;
      if ($32) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $st$0$0=(($__ll)|0);
      var $34$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $34$1=HEAP32[(($st$0$1)>>2)];
      var $35$0=-2147483648;
      var $35$1=((-2147483648|0) < 0 ? -1 : 0);
      var $36=($34$1|0) < ($35$1|0) || (($34$1|0) == ($35$1|0) && ($34$0|0) <  ($35$0|0));
      if ($36) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $37
      var $38$0=2147483647;
      var $38$1=((2147483647|0) < 0 ? -1 : 0);
      var $st$2$0=(($__ll)|0);
      var $39$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($__ll+4)|0);
      var $39$1=HEAP32[(($st$2$1)>>2)];
      var $40=($38$1|0) < ($39$1|0) || (($38$1|0) == ($39$1|0) && ($38$0|0) <  ($39$0|0));
      if ($40) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $41
      var $42=$4;
      HEAP32[(($42)>>2)]=4;
      var $st$2$0=(($__ll)|0);
      var $43$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($__ll+4)|0);
      var $43$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $44=($43$1|0) > ($$emscripten$temp$0$1|0) || (($43$1|0) == ($$emscripten$temp$0$1|0) && ($43$0|0) >  ($$emscripten$temp$0$0|0));
      if ($44) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $45
      $1=2147483647;
      __label__ = 14; break;
    case 10: // $46
      $1=-2147483648;
      __label__ = 14; break;
    case 11: // $47
      __label__ = 12; break;
    case 12: // $48
      var $st$0$0=(($__ll)|0);
      var $49$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $49$1=HEAP32[(($st$0$1)>>2)];
      var $50$0=$49$0;
      var $50=$50$0;
      $1=$50;
      __label__ = 14; break;
    case 13: // $51
      var $52=$4;
      HEAP32[(($52)>>2)]=4;
      $1=0;
      __label__ = 14; break;
    case 14: // $53
      var $54=$1;
      STACKTOP = __stackBase__;
      return $54;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji["X"]=1;

function __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $__g, $__g_end, $__err) {
  var __stackBase__  = STACKTOP; STACKTOP += 172; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i_i_i=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $34=__stackBase__+136;
      var $35=__stackBase__+140;
      var $36=__stackBase__+144;
      var $37=__stackBase__+148;
      var $38=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43;
      var $44;
      var $45;
      var $46;
      var $__ig;
      var $__eg;
      var $__r;
      $43=$__grouping;
      $44=$__g;
      $45=$__g_end;
      $46=$__err;
      var $47=$43;
      var $48=$42;
      HEAP32[(($42)>>2)]=$47;
      var $49=HEAPU32[(($42)>>2)];
      var $50=$41;
      HEAP32[(($41)>>2)]=$49;
      var $51=HEAP32[(($41)>>2)];
      var $52=(($51)|0);
      var $53=$40;
      HEAP32[(($40)>>2)]=$52;
      var $54=HEAP32[(($40)>>2)];
      var $55=$54;
      var $56=$39;
      HEAP32[(($39)>>2)]=$55;
      var $57=HEAP32[(($39)>>2)];
      var $58=(($57)|0);
      var $59=$39;
      var $60=$40;
      var $61=(($58)|0);
      var $62=$61;
      var $63=(($62)|0);
      var $64=$63;
      var $65=HEAPU8[($64)];
      var $66=(($65)&255);
      var $67=$66 & 1;
      var $68=(($67)|0)!=0;
      var $69=$41;
      if ($68) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $70
      var $71=$35;
      HEAP32[(($35)>>2)]=$49;
      var $72=HEAP32[(($35)>>2)];
      var $73=(($72)|0);
      var $74=$34;
      HEAP32[(($34)>>2)]=$73;
      var $75=HEAP32[(($34)>>2)];
      var $76=$75;
      var $77=$33;
      HEAP32[(($33)>>2)]=$76;
      var $78=HEAP32[(($33)>>2)];
      var $79=(($78)|0);
      var $80=$33;
      var $81=$34;
      var $82=(($79)|0);
      var $83=$82;
      var $84=(($83+4)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$35;
      var $107 = $85;__label__ = 3; break;
    case 2: // $87
      var $88=$38;
      HEAP32[(($38)>>2)]=$49;
      var $89=HEAP32[(($38)>>2)];
      var $90=(($89)|0);
      var $91=$37;
      HEAP32[(($37)>>2)]=$90;
      var $92=HEAP32[(($37)>>2)];
      var $93=$92;
      var $94=$36;
      HEAP32[(($36)>>2)]=$93;
      var $95=HEAP32[(($36)>>2)];
      var $96=(($95)|0);
      var $97=$36;
      var $98=$37;
      var $99=(($96)|0);
      var $100=$99;
      var $101=(($100)|0);
      var $102=$101;
      var $103=HEAPU8[($102)];
      var $104=(($103)&255);
      var $105=$104 >> 1;
      var $106=$38;
      var $107 = $105;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $107;
      var $108=$42;
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 4; break; } else { __label__ = 33; break; }
    case 4: // $110
      var $111=$44;
      var $112=$45;
      var $113=$8;
      var $114=$9;
      var $115=$10;
      var $116=$11;
      HEAP32[(($9)>>2)]=$111;
      HEAP32[(($10)>>2)]=$112;
      var $117=HEAP32[(($9)>>2)];
      var $118=HEAP32[(($10)>>2)];
      var $tmp_i=$8;
      var $tmp1_i=$11;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $119=$6;
      var $120=$7;
      HEAP32[(($6)>>2)]=$117;
      HEAP32[(($7)>>2)]=$118;
      var $121=HEAP32[(($6)>>2)];
      var $122=HEAP32[(($7)>>2)];
      var $123=(($121)|0)!=(($122)|0);
      if ($123) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $124
      __label__ = 6; break;
    case 6: // $125
      var $126=HEAPU32[(($6)>>2)];
      var $127=HEAP32[(($7)>>2)];
      var $128=(($127-4)|0);
      HEAP32[(($7)>>2)]=$128;
      var $129=(($126)>>>0) < (($128)>>>0);
      if ($129) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $130
      var $131=HEAP32[(($6)>>2)];
      var $132=HEAP32[(($7)>>2)];
      var $133=$4;
      var $134=$5;
      var $135=$__t_i_i_i;
      HEAP32[(($4)>>2)]=$131;
      HEAP32[(($5)>>2)]=$132;
      var $136=HEAP32[(($4)>>2)];
      var $137=$3;
      HEAP32[(($3)>>2)]=$136;
      var $138=HEAP32[(($3)>>2)];
      var $139=$3;
      var $140=HEAP32[(($138)>>2)];
      HEAP32[(($__t_i_i_i)>>2)]=$140;
      var $141=HEAP32[(($5)>>2)];
      var $142=$1;
      HEAP32[(($1)>>2)]=$141;
      var $143=HEAP32[(($1)>>2)];
      var $144=$1;
      var $145=HEAP32[(($143)>>2)];
      var $146=HEAP32[(($4)>>2)];
      HEAP32[(($146)>>2)]=$145;
      var $147=$2;
      HEAP32[(($2)>>2)]=$__t_i_i_i;
      var $148=HEAP32[(($2)>>2)];
      var $149=$2;
      var $150=HEAP32[(($148)>>2)];
      var $151=HEAP32[(($5)>>2)];
      HEAP32[(($151)>>2)]=$150;
      var $152=$4;
      var $153=$5;
      var $154=$__t_i_i_i;
      var $155=HEAP32[(($6)>>2)];
      var $156=(($155+4)|0);
      HEAP32[(($6)>>2)]=$156;
      __label__ = 6; break;
    case 8: // $157
      __label__ = 9; break;
    case 9: // $_ZNSt3__17reverseIPjEEvT_S2__exit
      var $158=$6;
      var $159=$7;
      var $160=$8;
      var $161=$9;
      var $162=$10;
      var $163=$11;
      var $164=$43;
      var $165=$22;
      HEAP32[(($22)>>2)]=$164;
      var $166=HEAP32[(($22)>>2)];
      var $167=$21;
      HEAP32[(($21)>>2)]=$166;
      var $168=HEAPU32[(($21)>>2)];
      var $169=$20;
      HEAP32[(($20)>>2)]=$168;
      var $170=HEAP32[(($20)>>2)];
      var $171=(($170)|0);
      var $172=$19;
      HEAP32[(($19)>>2)]=$171;
      var $173=HEAP32[(($19)>>2)];
      var $174=$173;
      var $175=$18;
      HEAP32[(($18)>>2)]=$174;
      var $176=HEAP32[(($18)>>2)];
      var $177=(($176)|0);
      var $178=$18;
      var $179=$19;
      var $180=(($177)|0);
      var $181=$180;
      var $182=(($181)|0);
      var $183=$182;
      var $184=HEAPU8[($183)];
      var $185=(($184)&255);
      var $186=$185 & 1;
      var $187=(($186)|0)!=0;
      var $188=$20;
      if ($187) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $189
      var $190=$14;
      HEAP32[(($14)>>2)]=$168;
      var $191=HEAP32[(($14)>>2)];
      var $192=(($191)|0);
      var $193=$13;
      HEAP32[(($13)>>2)]=$192;
      var $194=HEAP32[(($13)>>2)];
      var $195=$194;
      var $196=$12;
      HEAP32[(($12)>>2)]=$195;
      var $197=HEAP32[(($12)>>2)];
      var $198=(($197)|0);
      var $199=$12;
      var $200=$13;
      var $201=(($198)|0);
      var $202=$201;
      var $203=(($202+8)|0);
      var $204=HEAP32[(($203)>>2)];
      var $205=$14;
      var $223 = $204;__label__ = 12; break;
    case 11: // $206
      var $207=$17;
      HEAP32[(($17)>>2)]=$168;
      var $208=HEAP32[(($17)>>2)];
      var $209=(($208)|0);
      var $210=$16;
      HEAP32[(($16)>>2)]=$209;
      var $211=HEAP32[(($16)>>2)];
      var $212=$211;
      var $213=$15;
      HEAP32[(($15)>>2)]=$212;
      var $214=HEAP32[(($15)>>2)];
      var $215=(($214)|0);
      var $216=$15;
      var $217=$16;
      var $218=(($215)|0);
      var $219=$218;
      var $220=(($219+1)|0);
      var $221=(($220)|0);
      var $222=$17;
      var $223 = $221;__label__ = 12; break;
    case 12: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit
      var $223;
      var $224=$21;
      var $225=$22;
      $__ig=$223;
      var $226=$__ig;
      var $227=$43;
      var $228=$32;
      HEAP32[(($32)>>2)]=$227;
      var $229=HEAPU32[(($32)>>2)];
      var $230=$31;
      HEAP32[(($31)>>2)]=$229;
      var $231=HEAP32[(($31)>>2)];
      var $232=(($231)|0);
      var $233=$30;
      HEAP32[(($30)>>2)]=$232;
      var $234=HEAP32[(($30)>>2)];
      var $235=$234;
      var $236=$29;
      HEAP32[(($29)>>2)]=$235;
      var $237=HEAP32[(($29)>>2)];
      var $238=(($237)|0);
      var $239=$29;
      var $240=$30;
      var $241=(($238)|0);
      var $242=$241;
      var $243=(($242)|0);
      var $244=$243;
      var $245=HEAPU8[($244)];
      var $246=(($245)&255);
      var $247=$246 & 1;
      var $248=(($247)|0)!=0;
      var $249=$31;
      if ($248) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $250
      var $251=$25;
      HEAP32[(($25)>>2)]=$229;
      var $252=HEAP32[(($25)>>2)];
      var $253=(($252)|0);
      var $254=$24;
      HEAP32[(($24)>>2)]=$253;
      var $255=HEAP32[(($24)>>2)];
      var $256=$255;
      var $257=$23;
      HEAP32[(($23)>>2)]=$256;
      var $258=HEAP32[(($23)>>2)];
      var $259=(($258)|0);
      var $260=$23;
      var $261=$24;
      var $262=(($259)|0);
      var $263=$262;
      var $264=(($263+4)|0);
      var $265=HEAP32[(($264)>>2)];
      var $266=$25;
      var $287 = $265;__label__ = 15; break;
    case 14: // $267
      var $268=$28;
      HEAP32[(($28)>>2)]=$229;
      var $269=HEAP32[(($28)>>2)];
      var $270=(($269)|0);
      var $271=$27;
      HEAP32[(($27)>>2)]=$270;
      var $272=HEAP32[(($27)>>2)];
      var $273=$272;
      var $274=$26;
      HEAP32[(($26)>>2)]=$273;
      var $275=HEAP32[(($26)>>2)];
      var $276=(($275)|0);
      var $277=$26;
      var $278=$27;
      var $279=(($276)|0);
      var $280=$279;
      var $281=(($280)|0);
      var $282=$281;
      var $283=HEAPU8[($282)];
      var $284=(($283)&255);
      var $285=$284 >> 1;
      var $286=$28;
      var $287 = $285;__label__ = 15; break;
    case 15: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit1
      var $287;
      var $288=$32;
      var $289=(($226+$287)|0);
      $__eg=$289;
      var $290=$44;
      $__r=$290;
      __label__ = 16; break;
    case 16: // $291
      var $292=$__r;
      var $293=$45;
      var $294=(($293-4)|0);
      var $295=(($292)>>>0) < (($294)>>>0);
      if ($295) { __label__ = 17; break; } else { __label__ = 26; break; }
    case 17: // $296
      var $297=$__ig;
      var $298=HEAP8[($297)];
      var $299=(($298 << 24) >> 24);
      var $300=0 < (($299)|0);
      if ($300) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $301
      var $302=$__ig;
      var $303=HEAP8[($302)];
      var $304=(($303 << 24) >> 24);
      var $305=127;
      var $306=(($304)|0) < (($305)|0);
      if ($306) { __label__ = 19; break; } else { __label__ = 22; break; }
    case 19: // $307
      var $308=$__ig;
      var $309=HEAP8[($308)];
      var $310=(($309 << 24) >> 24);
      var $311=$__r;
      var $312=HEAP32[(($311)>>2)];
      var $313=(($310)|0)!=(($312)|0);
      if ($313) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $314
      var $315=$46;
      HEAP32[(($315)>>2)]=4;
      __label__ = 33; break;
    case 21: // $316
      __label__ = 22; break;
    case 22: // $317
      var $318=$__eg;
      var $319=$__ig;
      var $320=$318;
      var $321=$319;
      var $322=(($320-$321)|0);
      var $323=(($322)|0) > 1;
      if ($323) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $324
      var $325=$__ig;
      var $326=(($325+1)|0);
      $__ig=$326;
      __label__ = 24; break;
    case 24: // $327
      __label__ = 25; break;
    case 25: // $328
      var $329=$__r;
      var $330=(($329+4)|0);
      $__r=$330;
      __label__ = 16; break;
    case 26: // $331
      var $332=$__ig;
      var $333=HEAP8[($332)];
      var $334=(($333 << 24) >> 24);
      var $335=0 < (($334)|0);
      if ($335) { __label__ = 27; break; } else { __label__ = 32; break; }
    case 27: // $336
      var $337=$__ig;
      var $338=HEAP8[($337)];
      var $339=(($338 << 24) >> 24);
      var $340=127;
      var $341=(($339)|0) < (($340)|0);
      if ($341) { __label__ = 28; break; } else { __label__ = 32; break; }
    case 28: // $342
      var $343=$__ig;
      var $344=HEAP8[($343)];
      var $345=(($344 << 24) >> 24);
      var $346=$45;
      var $347=(($346-4)|0);
      var $348=HEAPU32[(($347)>>2)];
      var $349=(($345)>>>0) < (($348)>>>0);
      if ($349) { __label__ = 30; break; } else { __label__ = 29; break; }
    case 29: // $350
      var $351=$45;
      var $352=(($351-4)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=(($353)|0)==0;
      if ($354) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $355
      var $356=$46;
      HEAP32[(($356)>>2)]=4;
      __label__ = 31; break;
    case 31: // $357
      __label__ = 32; break;
    case 32: // $358
      __label__ = 33; break;
    case 33: // $359
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj["X"]=1;

function __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji($__a, $__a_end, $__err, $__base) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__save_errno;
      var $__p2=__stackBase__+8;
      var $__ll=__stackBase__+12;
      var $__current_errno;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      $5=$__base;
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 13; break; }
    case 1: // $9
      var $10=___errno();
      var $11=HEAP32[(($10)>>2)];
      $__save_errno=$11;
      var $12=___errno();
      HEAP32[(($12)>>2)]=0;
      var $13=$2;
      var $14=$5;
      var $15=__ZNSt3__16__clocEv();
      var $16=_strtoll_l($13, $__p2, $14, $15);
      var $16$0=$16[0];
      var $16$1=$16[1];
      var $st$11$0=(($__ll)|0);
      HEAP32[(($st$11$0)>>2)]=$16$0;
      var $st$11$1=(($__ll+4)|0);
      HEAP32[(($st$11$1)>>2)]=$16$1;
      var $17=___errno();
      var $18=HEAP32[(($17)>>2)];
      $__current_errno=$18;
      var $19=$__current_errno;
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__save_errno;
      var $23=___errno();
      HEAP32[(($23)>>2)]=$22;
      __label__ = 3; break;
    case 3: // $24
      var $25=HEAP32[(($__p2)>>2)];
      var $26=$3;
      var $27=(($25)|0)!=(($26)|0);
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$4;
      HEAP32[(($29)>>2)]=4;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 14; break;
    case 5: // $30
      var $31=$__current_errno;
      var $32=(($31)|0)==34;
      if ($32) { __label__ = 8; break; } else { __label__ = 6; break; }
    case 6: // $33
      var $st$0$0=(($__ll)|0);
      var $34$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $34$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=-2147483648;
      var $35=($34$1|0) < ($$emscripten$temp$1$1|0) || (($34$1|0) == ($$emscripten$temp$1$1|0) && ($34$0|0) <  ($$emscripten$temp$1$0|0));
      if ($35) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $36
      var $st$0$0=(($__ll)|0);
      var $37$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $37$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=-1;
      var $$emscripten$temp$2$1=2147483647;
      var $38=($$emscripten$temp$2$1|0) < ($37$1|0) || (($$emscripten$temp$2$1|0) == ($37$1|0) && ($$emscripten$temp$2$0|0) <  ($37$0|0));
      if ($38) { __label__ = 8; break; } else { __label__ = 11; break; }
    case 8: // $39
      var $40=$4;
      HEAP32[(($40)>>2)]=4;
      var $st$2$0=(($__ll)|0);
      var $41$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($__ll+4)|0);
      var $41$1=HEAP32[(($st$2$1)>>2)];
      var $$emscripten$temp$3$0=0;
      var $$emscripten$temp$3$1=0;
      var $42=($41$1|0) > ($$emscripten$temp$3$1|0) || (($41$1|0) == ($$emscripten$temp$3$1|0) && ($41$0|0) >  ($$emscripten$temp$3$0|0));
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $$emscripten$temp$4$0=-1;
      var $$emscripten$temp$4$1=2147483647;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$4$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 14; break;
    case 10: // $44
      var $$emscripten$temp$5$0=0;
      var $$emscripten$temp$5$1=-2147483648;
      var $st$2$0=(($1)|0);
      HEAP32[(($st$2$0)>>2)]=$$emscripten$temp$5$0;
      var $st$2$1=(($1+4)|0);
      HEAP32[(($st$2$1)>>2)]=$$emscripten$temp$5$1;
      __label__ = 14; break;
    case 11: // $45
      __label__ = 12; break;
    case 12: // $46
      var $st$0$0=(($__ll)|0);
      var $47$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $47$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$47$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$47$1;
      __label__ = 14; break;
    case 13: // $48
      var $49=$4;
      HEAP32[(($49)>>2)]=4;
      var $$emscripten$temp$6$0=0;
      var $$emscripten$temp$6$1=0;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$6$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$6$1;
      __label__ = 14; break;
    case 14: // $50
      var $st$0$0=(($1)|0);
      var $51$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $51$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$51$0,$51$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+120;
      var $__thousands_sep=__stackBase__+148;
      var $__grouping=__stackBase__+152;
      var $__a=__stackBase__+164;
      var $__a_end=__stackBase__+204;
      var $__g=__stackBase__+208;
      var $__g_end=__stackBase__+368;
      var $__dc=__stackBase__+372;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP8[($94)];
      $22=$95;
      var $96=$22;
      var $97=(($96)&255);
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $98=HEAP32[(($23)>>2)];
      var $99=$23;
      var $100=$24;
      var $101=(($98) & 255);
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP8[($__thousands_sep)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($101, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAPU32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP8[($142)];
      $16=$144;
      var $145=$16;
      var $146=(($145)&255);
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $147=HEAP32[(($17)>>2)];
      var $148=$17;
      var $149=$18;
      var $150=(($147)|0)==-1;
      if ($150) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $151
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $152
      var $153=$14;
      var $154=$15;
      HEAP32[(($15)>>2)]=$125;
      var $155=HEAPU32[(($15)>>2)];
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155+16)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($157)|0)==(($159)|0);
      if ($160) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $161
      var $162=$155;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$165]($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$166;
      __label__ = 23; break;
    case 22: // $167
      var $168=(($155+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=HEAP8[($169)];
      $13=$170;
      var $171=$13;
      var $172=(($171)&255);
      HEAP32[(($14)>>2)]=$172;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($120)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $253
      var $254=HEAP32[(($__g_end)>>2)];
      var $255=(($__g)|0);
      var $256=$254;
      var $257=$255;
      var $258=(($256-$257)|0);
      var $259=(((($258)|0)/4)|0);
      var $260=(($259)|0) < 40;
      if ($260) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $261
      var $262=HEAP32[(($__dc)>>2)];
      var $263=HEAP32[(($__g_end)>>2)];
      var $264=(($263+4)|0);
      HEAP32[(($__g_end)>>2)]=$264;
      HEAP32[(($263)>>2)]=$262;
      __label__ = 34; break;
    case 34: // $265
      var $266=(($__a)|0);
      var $267=HEAP32[(($__a_end)>>2)];
      var $268=$36;
      var $269=$__base;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji($266, $267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
      var $270$0=$270[0];
      var $270$1=$270[1];
    case 35: // $271
      var $272=$37;
      var $st$1$0=(($272)|0);
      HEAP32[(($st$1$0)>>2)]=$270$0;
      var $st$1$1=(($272+4)|0);
      HEAP32[(($st$1$1)>>2)]=$270$1;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 37; break;
    case 37: // $298
      if ($293) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $306
      __label__ = 41; break;
    case 41: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx["X"]=1;

function __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji($__a, $__a_end, $__err, $__base) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__save_errno;
      var $__p2=__stackBase__;
      var $__ll=__stackBase__+4;
      var $__current_errno;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      $5=$__base;
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $9
      var $10=$2;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)==45;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$4;
      HEAP32[(($15)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 3: // $16
      var $17=___errno();
      var $18=HEAP32[(($17)>>2)];
      $__save_errno=$18;
      var $19=___errno();
      HEAP32[(($19)>>2)]=0;
      var $20=$2;
      var $21=$5;
      var $22=__ZNSt3__16__clocEv();
      var $23=_strtoull_l($20, $__p2, $21, $22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $st$11$0=(($__ll)|0);
      HEAP32[(($st$11$0)>>2)]=$23$0;
      var $st$11$1=(($__ll+4)|0);
      HEAP32[(($st$11$1)>>2)]=$23$1;
      var $24=___errno();
      var $25=HEAP32[(($24)>>2)];
      $__current_errno=$25;
      var $26=$__current_errno;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$__save_errno;
      var $30=___errno();
      HEAP32[(($30)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $31
      var $32=HEAP32[(($__p2)>>2)];
      var $33=$3;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=$4;
      HEAP32[(($36)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 7: // $37
      var $38=$__current_errno;
      var $39=(($38)|0)==34;
      if ($39) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $40
      var $41$0=-1;
      var $41$1=0;
      var $st$2$0=(($__ll)|0);
      var $42$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($__ll+4)|0);
      var $42$1=HEAP32[(($st$2$1)>>2)];
      var $43=$41$1 < $42$1 || ($41$1 == $42$1 && $41$0 < $42$0);
      if ($43) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $44
      var $45=$4;
      HEAP32[(($45)>>2)]=4;
      $1=-1;
      __label__ = 13; break;
    case 10: // $46
      __label__ = 11; break;
    case 11: // $47
      var $st$0$0=(($__ll)|0);
      var $48$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $48$1=HEAP32[(($st$0$1)>>2)];
      var $49$0=$48$0;
      var $49=$49$0&65535;
      $1=$49;
      __label__ = 13; break;
    case 12: // $50
      var $51=$4;
      HEAP32[(($51)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 13: // $52
      var $53=$1;
      STACKTOP = __stackBase__;
      return $53;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+120;
      var $__thousands_sep=__stackBase__+148;
      var $__grouping=__stackBase__+152;
      var $__a=__stackBase__+164;
      var $__a_end=__stackBase__+204;
      var $__g=__stackBase__+208;
      var $__g_end=__stackBase__+368;
      var $__dc=__stackBase__+372;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP8[($94)];
      $22=$95;
      var $96=$22;
      var $97=(($96)&255);
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $98=HEAP32[(($23)>>2)];
      var $99=$23;
      var $100=$24;
      var $101=(($98) & 255);
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP8[($__thousands_sep)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($101, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAPU32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP8[($142)];
      $16=$144;
      var $145=$16;
      var $146=(($145)&255);
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $147=HEAP32[(($17)>>2)];
      var $148=$17;
      var $149=$18;
      var $150=(($147)|0)==-1;
      if ($150) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $151
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $152
      var $153=$14;
      var $154=$15;
      HEAP32[(($15)>>2)]=$125;
      var $155=HEAPU32[(($15)>>2)];
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155+16)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($157)|0)==(($159)|0);
      if ($160) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $161
      var $162=$155;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$165]($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$166;
      __label__ = 23; break;
    case 22: // $167
      var $168=(($155+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=HEAP8[($169)];
      $13=$170;
      var $171=$13;
      var $172=(($171)&255);
      HEAP32[(($14)>>2)]=$172;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($120)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $253
      var $254=HEAP32[(($__g_end)>>2)];
      var $255=(($__g)|0);
      var $256=$254;
      var $257=$255;
      var $258=(($256-$257)|0);
      var $259=(((($258)|0)/4)|0);
      var $260=(($259)|0) < 40;
      if ($260) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $261
      var $262=HEAP32[(($__dc)>>2)];
      var $263=HEAP32[(($__g_end)>>2)];
      var $264=(($263+4)|0);
      HEAP32[(($__g_end)>>2)]=$264;
      HEAP32[(($263)>>2)]=$262;
      __label__ = 34; break;
    case 34: // $265
      var $266=(($__a)|0);
      var $267=HEAP32[(($__a_end)>>2)];
      var $268=$36;
      var $269=$__base;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji($266, $267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $271
      var $272=$37;
      HEAP16[(($272)>>1)]=$270;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 37; break;
    case 37: // $298
      if ($293) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $306
      __label__ = 41; break;
    case 41: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt["X"]=1;

function __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji($__a, $__a_end, $__err, $__base) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__save_errno;
      var $__p2=__stackBase__;
      var $__ll=__stackBase__+4;
      var $__current_errno;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      $5=$__base;
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $9
      var $10=$2;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)==45;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$4;
      HEAP32[(($15)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 3: // $16
      var $17=___errno();
      var $18=HEAP32[(($17)>>2)];
      $__save_errno=$18;
      var $19=___errno();
      HEAP32[(($19)>>2)]=0;
      var $20=$2;
      var $21=$5;
      var $22=__ZNSt3__16__clocEv();
      var $23=_strtoull_l($20, $__p2, $21, $22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $st$11$0=(($__ll)|0);
      HEAP32[(($st$11$0)>>2)]=$23$0;
      var $st$11$1=(($__ll+4)|0);
      HEAP32[(($st$11$1)>>2)]=$23$1;
      var $24=___errno();
      var $25=HEAP32[(($24)>>2)];
      $__current_errno=$25;
      var $26=$__current_errno;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$__save_errno;
      var $30=___errno();
      HEAP32[(($30)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $31
      var $32=HEAP32[(($__p2)>>2)];
      var $33=$3;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=$4;
      HEAP32[(($36)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 7: // $37
      var $38=$__current_errno;
      var $39=(($38)|0)==34;
      if ($39) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $40
      var $41$0=-1;
      var $41$1=0;
      var $st$2$0=(($__ll)|0);
      var $42$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($__ll+4)|0);
      var $42$1=HEAP32[(($st$2$1)>>2)];
      var $43=$41$1 < $42$1 || ($41$1 == $42$1 && $41$0 < $42$0);
      if ($43) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $44
      var $45=$4;
      HEAP32[(($45)>>2)]=4;
      $1=-1;
      __label__ = 13; break;
    case 10: // $46
      __label__ = 11; break;
    case 11: // $47
      var $st$0$0=(($__ll)|0);
      var $48$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $48$1=HEAP32[(($st$0$1)>>2)];
      var $49$0=$48$0;
      var $49=$49$0;
      $1=$49;
      __label__ = 13; break;
    case 12: // $50
      var $51=$4;
      HEAP32[(($51)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 13: // $52
      var $53=$1;
      STACKTOP = __stackBase__;
      return $53;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+120;
      var $__thousands_sep=__stackBase__+148;
      var $__grouping=__stackBase__+152;
      var $__a=__stackBase__+164;
      var $__a_end=__stackBase__+204;
      var $__g=__stackBase__+208;
      var $__g_end=__stackBase__+368;
      var $__dc=__stackBase__+372;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP8[($94)];
      $22=$95;
      var $96=$22;
      var $97=(($96)&255);
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $98=HEAP32[(($23)>>2)];
      var $99=$23;
      var $100=$24;
      var $101=(($98) & 255);
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP8[($__thousands_sep)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($101, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAPU32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP8[($142)];
      $16=$144;
      var $145=$16;
      var $146=(($145)&255);
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $147=HEAP32[(($17)>>2)];
      var $148=$17;
      var $149=$18;
      var $150=(($147)|0)==-1;
      if ($150) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $151
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $152
      var $153=$14;
      var $154=$15;
      HEAP32[(($15)>>2)]=$125;
      var $155=HEAPU32[(($15)>>2)];
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155+16)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($157)|0)==(($159)|0);
      if ($160) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $161
      var $162=$155;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$165]($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$166;
      __label__ = 23; break;
    case 22: // $167
      var $168=(($155+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=HEAP8[($169)];
      $13=$170;
      var $171=$13;
      var $172=(($171)&255);
      HEAP32[(($14)>>2)]=$172;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($120)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $253
      var $254=HEAP32[(($__g_end)>>2)];
      var $255=(($__g)|0);
      var $256=$254;
      var $257=$255;
      var $258=(($256-$257)|0);
      var $259=(((($258)|0)/4)|0);
      var $260=(($259)|0) < 40;
      if ($260) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $261
      var $262=HEAP32[(($__dc)>>2)];
      var $263=HEAP32[(($__g_end)>>2)];
      var $264=(($263+4)|0);
      HEAP32[(($__g_end)>>2)]=$264;
      HEAP32[(($263)>>2)]=$262;
      __label__ = 34; break;
    case 34: // $265
      var $266=(($__a)|0);
      var $267=HEAP32[(($__a_end)>>2)];
      var $268=$36;
      var $269=$__base;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji($266, $267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $271
      var $272=$37;
      HEAP32[(($272)>>2)]=$270;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 37; break;
    case 37: // $298
      if ($293) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $306
      __label__ = 41; break;
    case 41: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_["X"]=1;

function __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji($__a, $__a_end, $__err, $__base) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__save_errno;
      var $__p2=__stackBase__;
      var $__ll=__stackBase__+4;
      var $__current_errno;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      $5=$__base;
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $9
      var $10=$2;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)==45;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$4;
      HEAP32[(($15)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 3: // $16
      var $17=___errno();
      var $18=HEAP32[(($17)>>2)];
      $__save_errno=$18;
      var $19=___errno();
      HEAP32[(($19)>>2)]=0;
      var $20=$2;
      var $21=$5;
      var $22=__ZNSt3__16__clocEv();
      var $23=_strtoull_l($20, $__p2, $21, $22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $st$11$0=(($__ll)|0);
      HEAP32[(($st$11$0)>>2)]=$23$0;
      var $st$11$1=(($__ll+4)|0);
      HEAP32[(($st$11$1)>>2)]=$23$1;
      var $24=___errno();
      var $25=HEAP32[(($24)>>2)];
      $__current_errno=$25;
      var $26=$__current_errno;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$__save_errno;
      var $30=___errno();
      HEAP32[(($30)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $31
      var $32=HEAP32[(($__p2)>>2)];
      var $33=$3;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=$4;
      HEAP32[(($36)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 7: // $37
      var $38=$__current_errno;
      var $39=(($38)|0)==34;
      if ($39) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $40
      var $41$0=-1;
      var $41$1=0;
      var $st$2$0=(($__ll)|0);
      var $42$0=HEAP32[(($st$2$0)>>2)];
      var $st$2$1=(($__ll+4)|0);
      var $42$1=HEAP32[(($st$2$1)>>2)];
      var $43=$41$1 < $42$1 || ($41$1 == $42$1 && $41$0 < $42$0);
      if ($43) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $44
      var $45=$4;
      HEAP32[(($45)>>2)]=4;
      $1=-1;
      __label__ = 13; break;
    case 10: // $46
      __label__ = 11; break;
    case 11: // $47
      var $st$0$0=(($__ll)|0);
      var $48$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $48$1=HEAP32[(($st$0$1)>>2)];
      var $49$0=$48$0;
      var $49=$49$0;
      $1=$49;
      __label__ = 13; break;
    case 12: // $50
      var $51=$4;
      HEAP32[(($51)>>2)]=4;
      $1=0;
      __label__ = 13; break;
    case 13: // $52
      var $53=$1;
      STACKTOP = __stackBase__;
      return $53;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+120;
      var $__thousands_sep=__stackBase__+148;
      var $__grouping=__stackBase__+152;
      var $__a=__stackBase__+164;
      var $__a_end=__stackBase__+204;
      var $__g=__stackBase__+208;
      var $__g_end=__stackBase__+368;
      var $__dc=__stackBase__+372;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP8[($94)];
      $22=$95;
      var $96=$22;
      var $97=(($96)&255);
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $98=HEAP32[(($23)>>2)];
      var $99=$23;
      var $100=$24;
      var $101=(($98) & 255);
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP8[($__thousands_sep)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($101, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAPU32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP8[($142)];
      $16=$144;
      var $145=$16;
      var $146=(($145)&255);
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $147=HEAP32[(($17)>>2)];
      var $148=$17;
      var $149=$18;
      var $150=(($147)|0)==-1;
      if ($150) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $151
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $152
      var $153=$14;
      var $154=$15;
      HEAP32[(($15)>>2)]=$125;
      var $155=HEAPU32[(($15)>>2)];
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155+16)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($157)|0)==(($159)|0);
      if ($160) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $161
      var $162=$155;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$165]($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$166;
      __label__ = 23; break;
    case 22: // $167
      var $168=(($155+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=HEAP8[($169)];
      $13=$170;
      var $171=$13;
      var $172=(($171)&255);
      HEAP32[(($14)>>2)]=$172;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($120)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $253
      var $254=HEAP32[(($__g_end)>>2)];
      var $255=(($__g)|0);
      var $256=$254;
      var $257=$255;
      var $258=(($256-$257)|0);
      var $259=(((($258)|0)/4)|0);
      var $260=(($259)|0) < 40;
      if ($260) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $261
      var $262=HEAP32[(($__dc)>>2)];
      var $263=HEAP32[(($__g_end)>>2)];
      var $264=(($263+4)|0);
      HEAP32[(($__g_end)>>2)]=$264;
      HEAP32[(($263)>>2)]=$262;
      __label__ = 34; break;
    case 34: // $265
      var $266=(($__a)|0);
      var $267=HEAP32[(($__a_end)>>2)];
      var $268=$36;
      var $269=$__base;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji($266, $267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $271
      var $272=$37;
      HEAP32[(($272)>>2)]=$270;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 37; break;
    case 37: // $298
      if ($293) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $306
      __label__ = 41; break;
    case 41: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm["X"]=1;

function __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji($__a, $__a_end, $__err, $__base) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__save_errno;
      var $__p2=__stackBase__+8;
      var $__ll=__stackBase__+12;
      var $__current_errno;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      $5=$__base;
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 12; break; }
    case 1: // $9
      var $10=$2;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)|0)==45;
      if ($13) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $14
      var $15=$4;
      HEAP32[(($15)>>2)]=4;
      var $$emscripten$temp$0$0=0;
      var $$emscripten$temp$0$1=0;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$0$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 13; break;
    case 3: // $16
      var $17=___errno();
      var $18=HEAP32[(($17)>>2)];
      $__save_errno=$18;
      var $19=___errno();
      HEAP32[(($19)>>2)]=0;
      var $20=$2;
      var $21=$5;
      var $22=__ZNSt3__16__clocEv();
      var $23=_strtoull_l($20, $__p2, $21, $22);
      var $23$0=$23[0];
      var $23$1=$23[1];
      var $st$11$0=(($__ll)|0);
      HEAP32[(($st$11$0)>>2)]=$23$0;
      var $st$11$1=(($__ll+4)|0);
      HEAP32[(($st$11$1)>>2)]=$23$1;
      var $24=___errno();
      var $25=HEAP32[(($24)>>2)];
      $__current_errno=$25;
      var $26=$__current_errno;
      var $27=(($26)|0)==0;
      if ($27) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $28
      var $29=$__save_errno;
      var $30=___errno();
      HEAP32[(($30)>>2)]=$29;
      __label__ = 5; break;
    case 5: // $31
      var $32=HEAP32[(($__p2)>>2)];
      var $33=$3;
      var $34=(($32)|0)!=(($33)|0);
      if ($34) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $35
      var $36=$4;
      HEAP32[(($36)>>2)]=4;
      var $$emscripten$temp$1$0=0;
      var $$emscripten$temp$1$1=0;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$1$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$1$1;
      __label__ = 13; break;
    case 7: // $37
      var $38=$__current_errno;
      var $39=(($38)|0)==34;
      if ($39) { __label__ = 9; break; } else { __label__ = 8; break; }
    case 8: // $40
      var $st$0$0=(($__ll)|0);
      var $41$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $41$1=HEAP32[(($st$0$1)>>2)];
      var $$emscripten$temp$2$0=-1;
      var $$emscripten$temp$2$1=-1;
      var $42=$$emscripten$temp$2$1 < $41$1 || ($$emscripten$temp$2$1 == $41$1 && $$emscripten$temp$2$0 < $41$0);
      if ($42) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $43
      var $44=$4;
      HEAP32[(($44)>>2)]=4;
      var $$emscripten$temp$3$0=-1;
      var $$emscripten$temp$3$1=-1;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$3$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$3$1;
      __label__ = 13; break;
    case 10: // $45
      __label__ = 11; break;
    case 11: // $46
      var $st$0$0=(($__ll)|0);
      var $47$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($__ll+4)|0);
      var $47$1=HEAP32[(($st$0$1)>>2)];
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$47$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$47$1;
      __label__ = 13; break;
    case 12: // $48
      var $49=$4;
      HEAP32[(($49)>>2)]=4;
      var $$emscripten$temp$4$0=0;
      var $$emscripten$temp$4$1=0;
      var $st$4$0=(($1)|0);
      HEAP32[(($st$4$0)>>2)]=$$emscripten$temp$4$0;
      var $st$4$1=(($1+4)|0);
      HEAP32[(($st$4$1)>>2)]=$$emscripten$temp$4$1;
      __label__ = 13; break;
    case 13: // $50
      var $st$0$0=(($1)|0);
      var $51$0=HEAP32[(($st$0$0)>>2)];
      var $st$0$1=(($1+4)|0);
      var $51$1=HEAP32[(($st$0$1)>>2)];
      STACKTOP = __stackBase__;
      return [$51$0,$51$1];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+120;
      var $__thousands_sep=__stackBase__+148;
      var $__grouping=__stackBase__+152;
      var $__a=__stackBase__+164;
      var $__a_end=__stackBase__+204;
      var $__g=__stackBase__+208;
      var $__g_end=__stackBase__+368;
      var $__dc=__stackBase__+372;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP8[($94)];
      $22=$95;
      var $96=$22;
      var $97=(($96)&255);
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $98=HEAP32[(($23)>>2)];
      var $99=$23;
      var $100=$24;
      var $101=(($98) & 255);
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP8[($__thousands_sep)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($101, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAPU32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+1)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP8[($142)];
      $16=$144;
      var $145=$16;
      var $146=(($145)&255);
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $147=HEAP32[(($17)>>2)];
      var $148=$17;
      var $149=$18;
      var $150=(($147)|0)==-1;
      if ($150) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $151
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $152
      var $153=$14;
      var $154=$15;
      HEAP32[(($15)>>2)]=$125;
      var $155=HEAPU32[(($15)>>2)];
      var $156=(($155+12)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155+16)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=(($157)|0)==(($159)|0);
      if ($160) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $161
      var $162=$155;
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+36)|0);
      var $165=HEAP32[(($164)>>2)];
      var $166=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$165]($155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$166;
      __label__ = 23; break;
    case 22: // $167
      var $168=(($155+12)|0);
      var $169=HEAP32[(($168)>>2)];
      var $170=HEAP8[($169)];
      $13=$170;
      var $171=$13;
      var $172=(($171)&255);
      HEAP32[(($14)>>2)]=$172;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($120)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $253
      var $254=HEAP32[(($__g_end)>>2)];
      var $255=(($__g)|0);
      var $256=$254;
      var $257=$255;
      var $258=(($256-$257)|0);
      var $259=(((($258)|0)/4)|0);
      var $260=(($259)|0) < 40;
      if ($260) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $261
      var $262=HEAP32[(($__dc)>>2)];
      var $263=HEAP32[(($__g_end)>>2)];
      var $264=(($263+4)|0);
      HEAP32[(($__g_end)>>2)]=$264;
      HEAP32[(($263)>>2)]=$262;
      __label__ = 34; break;
    case 34: // $265
      var $266=(($__a)|0);
      var $267=HEAP32[(($__a_end)>>2)];
      var $268=$36;
      var $269=$__base;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji($266, $267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
      var $270$0=$270[0];
      var $270$1=$270[1];
    case 35: // $271
      var $272=$37;
      var $st$1$0=(($272)|0);
      HEAP32[(($st$1$0)>>2)]=$270$0;
      var $st$1$1=(($272+4)|0);
      HEAP32[(($st$1$1)>>2)]=$270$1;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 37; break;
    case 37: // $298
      if ($293) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 39; break;
    case 39: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $306
      __label__ = 41; break;
    case 41: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 392; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__atoms=__stackBase__+120;
      var $__decimal_point=__stackBase__+152;
      var $__thousands_sep=__stackBase__+156;
      var $__grouping=__stackBase__+160;
      var $__a=__stackBase__+172;
      var $__a_end=__stackBase__+212;
      var $__g=__stackBase__+216;
      var $__g_end=__stackBase__+376;
      var $__dc=__stackBase__+380;
      var $__in_units=__stackBase__+384;
      var $__exp=__stackBase__+388;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=(($__atoms)|0);
      __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($__grouping, $42, $43, $__decimal_point, $__thousands_sep);
      var $44=$__a;
      _memset($44, 0, 40, 1);
      var $45=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$45;
      var $46=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$46;
      HEAP32[(($__dc)>>2)]=0;
      HEAP8[($__in_units)]=1;
      HEAP8[($__exp)]=69;
      __label__ = 1; break;
    case 1: // $47
      var $48=$32;
      var $49=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $50=HEAP32[(($32)>>2)];
      var $51=HEAP32[(($33)>>2)];
      var $52=$30;
      var $53=$31;
      HEAP32[(($30)>>2)]=$50;
      HEAP32[(($31)>>2)]=$51;
      var $54=HEAP32[(($30)>>2)];
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      var $58=(($57)&1);
      var $59=HEAP32[(($31)>>2)];
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      var $63=(($62)&1);
      var $64=(($58)|0)==(($63)|0);
      var $65=$30;
      var $66=$31;
      var $67=$64 ^ 1;
      var $68=$32;
      var $69=$33;
      __label__ = 2; break;
    case 2: // $70
      if ($67) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $71
      var $72=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $73=HEAP32[(($25)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$23;
      var $77=$24;
      HEAP32[(($24)>>2)]=$75;
      var $78=HEAP32[(($24)>>2)];
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78+16)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0)==(($82)|0);
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$78;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+36)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$89;
      __label__ = 7; break;
    case 6: // $90
      var $91=(($78+12)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP8[($92)];
      $22=$93;
      var $94=$22;
      var $95=(($94)&255);
      HEAP32[(($23)>>2)]=$95;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $96=HEAP32[(($23)>>2)];
      var $97=$23;
      var $98=$24;
      var $99=(($96) & 255);
      var $100=$25;
      __label__ = 8; break;
    case 8: // $101
      var $102=(($__a)|0);
      var $103=HEAP8[($__decimal_point)];
      var $104=HEAP8[($__thousands_sep)];
      var $105=(($__g)|0);
      var $106=(($__atoms)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($99, $__in_units, $__exp, $102, $__a_end, $103, $104, $__grouping, $105, $__g_end, $__dc, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $110
      __label__ = 28; break;
    case 11: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $38=$113;
      var $114=$112.f1;
      $39=$114;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 12: // $115
      __label__ = 13; break;
    case 13: // $116
      var $117=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $118=HEAPU32[(($21)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$19;
      var $122=$20;
      HEAP32[(($20)>>2)]=$120;
      var $123=HEAPU32[(($20)>>2)];
      var $124=$17;
      var $125=$18;
      HEAP32[(($18)>>2)]=$123;
      var $126=HEAP32[(($18)>>2)];
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($126+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0)==(($130)|0);
      if ($131) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $132
      var $133=$126;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+40)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$136]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$137;
      __label__ = 17; break;
    case 16: // $138
      var $139=(($126+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+1)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=HEAP8[($140)];
      $16=$142;
      var $143=$16;
      var $144=(($143)&255);
      HEAP32[(($17)>>2)]=$144;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $145=HEAP32[(($17)>>2)];
      var $146=$17;
      var $147=$18;
      var $148=(($145)|0)==-1;
      if ($148) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $149
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $150
      var $151=$14;
      var $152=$15;
      HEAP32[(($15)>>2)]=$123;
      var $153=HEAPU32[(($15)>>2)];
      var $154=(($153+12)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($153+16)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155)|0)==(($157)|0);
      if ($158) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $159
      var $160=$153;
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+36)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$163]($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$164;
      __label__ = 23; break;
    case 22: // $165
      var $166=(($153+12)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=HEAP8[($167)];
      $13=$168;
      var $169=$13;
      var $170=(($169)&255);
      HEAP32[(($14)>>2)]=$170;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $171=HEAP32[(($14)>>2)];
      var $172=$14;
      var $173=$15;
      HEAP32[(($19)>>2)]=$171;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $174=HEAP32[(($19)>>2)];
      var $175=$19;
      var $176=$20;
      var $177=$11;
      var $178=$12;
      HEAP32[(($11)>>2)]=$174;
      HEAP32[(($12)>>2)]=-1;
      var $179=HEAP32[(($11)>>2)];
      var $180=HEAP32[(($12)>>2)];
      var $181=(($179)|0)==(($180)|0);
      var $182=$11;
      var $183=$12;
      if ($181) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $184
      var $185=(($118)|0);
      HEAP32[(($185)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $186=$21;
      __label__ = 27; break;
    case 27: // $187
      __label__ = 1; break;
    case 28: // $188
      var $189=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $190=HEAPU32[(($10)>>2)];
      var $191=$9;
      HEAP32[(($9)>>2)]=$190;
      var $192=HEAP32[(($9)>>2)];
      var $193=(($192)|0);
      var $194=$8;
      HEAP32[(($8)>>2)]=$193;
      var $195=HEAP32[(($8)>>2)];
      var $196=$195;
      var $197=$7;
      HEAP32[(($7)>>2)]=$196;
      var $198=HEAP32[(($7)>>2)];
      var $199=(($198)|0);
      var $200=$7;
      var $201=$8;
      var $202=(($199)|0);
      var $203=$202;
      var $204=(($203)|0);
      var $205=$204;
      var $206=HEAPU8[($205)];
      var $207=(($206)&255);
      var $208=$207 & 1;
      var $209=(($208)|0)!=0;
      var $210=$9;
      if ($209) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $211
      var $212=$3;
      HEAP32[(($3)>>2)]=$190;
      var $213=HEAP32[(($3)>>2)];
      var $214=(($213)|0);
      var $215=$2;
      HEAP32[(($2)>>2)]=$214;
      var $216=HEAP32[(($2)>>2)];
      var $217=$216;
      var $218=$1;
      HEAP32[(($1)>>2)]=$217;
      var $219=HEAP32[(($1)>>2)];
      var $220=(($219)|0);
      var $221=$1;
      var $222=$2;
      var $223=(($220)|0);
      var $224=$223;
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$3;
      var $248 = $226;__label__ = 31; break;
    case 30: // $228
      var $229=$6;
      HEAP32[(($6)>>2)]=$190;
      var $230=HEAP32[(($6)>>2)];
      var $231=(($230)|0);
      var $232=$5;
      HEAP32[(($5)>>2)]=$231;
      var $233=HEAP32[(($5)>>2)];
      var $234=$233;
      var $235=$4;
      HEAP32[(($4)>>2)]=$234;
      var $236=HEAP32[(($4)>>2)];
      var $237=(($236)|0);
      var $238=$4;
      var $239=$5;
      var $240=(($237)|0);
      var $241=$240;
      var $242=(($241)|0);
      var $243=$242;
      var $244=HEAPU8[($243)];
      var $245=(($244)&255);
      var $246=$245 >> 1;
      var $247=$6;
      var $248 = $246;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $248;
      var $249=$10;
      var $250=(($248)|0)!=0;
      if ($250) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $251
      var $252=HEAP8[($__in_units)];
      var $253=(($252) & 1);
      if ($253) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $254
      var $255=HEAP32[(($__g_end)>>2)];
      var $256=(($__g)|0);
      var $257=$255;
      var $258=$256;
      var $259=(($257-$258)|0);
      var $260=(((($259)|0)/4)|0);
      var $261=(($260)|0) < 40;
      if ($261) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $262
      var $263=HEAP32[(($__dc)>>2)];
      var $264=HEAP32[(($__g_end)>>2)];
      var $265=(($264+4)|0);
      HEAP32[(($__g_end)>>2)]=$265;
      HEAP32[(($264)>>2)]=$263;
      __label__ = 35; break;
    case 35: // $266
      var $267=(($__a)|0);
      var $268=HEAP32[(($__a_end)>>2)];
      var $269=$36;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj($267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; };
    case 36: // $271
      var $272=$37;
      HEAPF32[(($272)>>2)]=$270;
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 11; break; }
    case 37: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 38; break;
    case 38: // $298
      if ($293) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 40; break;
    case 40: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 41: // $306
      __label__ = 42; break;
    case 42: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf["X"]=1;

function __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($agg_result, $__iob, $__atoms, $__decimal_point, $__thousands_sep) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      var $13;
      var $__loc=__stackBase__+36;
      var $14;
      var $15;
      var $__np;
      var $16;
      $10=$__iob;
      $11=$__atoms;
      $12=$__decimal_point;
      $13=$__thousands_sep;
      var $17=$10;
      __ZNKSt3__18ios_base6getlocEv($__loc, $17);
      var $18=$9;
      HEAP32[(($9)>>2)]=$__loc;
      var $19=HEAP32[(($9)>>2)];
      var $20=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($19, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 13; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $21=$20;
      var $22=$9;
      __label__ = 2; break;
    case 2: // $23
      var $24=$11;
      var $25=$5;
      var $26=$6;
      var $27=$7;
      var $28=$8;
      HEAP32[(($5)>>2)]=$21;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE)|0);
      HEAP32[(($7)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+32)|0);
      HEAP32[(($8)>>2)]=$24;
      var $29=HEAP32[(($5)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+32)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=HEAP32[(($6)>>2)];
      var $35=HEAP32[(($7)>>2)];
      var $36=HEAP32[(($8)>>2)];
      var $37=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$33]($29, $34, $35, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; };
    case 3: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $38=$5;
      var $39=$6;
      var $40=$7;
      var $41=$8;
      __label__ = 4; break;
    case 4: // $42
      var $43=$4;
      HEAP32[(($4)>>2)]=$__loc;
      var $44=HEAP32[(($4)>>2)];
      var $45=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($44, __ZNSt3__18numpunctIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 13; break; };
    case 5: // $_ZNSt3__19use_facetINS_8numpunctIcEEEERKT_RKNS_6localeE_exit
      var $46=$45;
      var $47=$4;
      __label__ = 6; break;
    case 6: // $48
      $__np=$46;
      var $49=$__np;
      var $50=$3;
      HEAP32[(($3)>>2)]=$49;
      var $51=HEAP32[(($3)>>2)];
      var $52=$51;
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+12)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$55]($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $_ZNKSt3__18numpunctIcE13decimal_pointEv_exit
      var $57=$3;
      __label__ = 8; break;
    case 8: // $58
      var $59=$12;
      HEAP8[($59)]=$56;
      var $60=$__np;
      var $61=$2;
      HEAP32[(($2)>>2)]=$60;
      var $62=HEAP32[(($2)>>2)];
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+16)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$66]($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $_ZNKSt3__18numpunctIcE13thousands_sepEv_exit
      var $68=$2;
      __label__ = 10; break;
    case 10: // $69
      var $70=$13;
      HEAP8[($70)]=$67;
      var $71=$__np;
      var $72=$1;
      HEAP32[(($1)>>2)]=$71;
      var $73=HEAP32[(($1)>>2)];
      var $74=$73;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$77]($agg_result, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $_ZNKSt3__18numpunctIcE8groupingEv_exit
      var $78=$1;
      __label__ = 12; break;
    case 12: // $79
      $16=1;
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc);
      STACKTOP = __stackBase__;
      return;
    case 13: // $80
      var $81=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $82=$81.f0;
      $14=$82;
      var $83=$81.f1;
      $15=$83;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $84
      __label__ = 15; break;
    case 15: // $85
      var $86=$14;
      var $87=$14;
      var $88=$15;
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_["X"]=1;

function __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($__ct, $__in_units, $__exp, $__a, $__a_end, $__decimal_point, $__thousands_sep, $__grouping, $__g, $__g_end, $__dc, $__atoms) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35=__stackBase__+132;
      var $36;
      var $37;
      var $38;
      var $39;
      var $40;
      var $41;
      var $42;
      var $43;
      var $44;
      var $45;
      var $46;
      var $__f;
      var $__x;
      HEAP8[($35)]=$__ct;
      $36=$__in_units;
      $37=$__exp;
      $38=$__a;
      $39=$__a_end;
      $40=$__decimal_point;
      $41=$__thousands_sep;
      $42=$__grouping;
      $43=$__g;
      $44=$__g_end;
      $45=$__dc;
      $46=$__atoms;
      var $47=HEAP8[($35)];
      var $48=(($47 << 24) >> 24);
      var $49=$40;
      var $50=(($49 << 24) >> 24);
      var $51=(($48)|0)==(($50)|0);
      if ($51) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $52
      var $53=$36;
      var $54=HEAP8[($53)];
      var $55=(($54) & 1);
      if ($55) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $56
      $34=-1;
      __label__ = 44; break;
    case 3: // $57
      var $58=$36;
      HEAP8[($58)]=0;
      var $59=$39;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+1)|0);
      HEAP32[(($59)>>2)]=$61;
      HEAP8[($60)]=46;
      var $62=$42;
      var $63=$33;
      HEAP32[(($33)>>2)]=$62;
      var $64=HEAPU32[(($33)>>2)];
      var $65=$32;
      HEAP32[(($32)>>2)]=$64;
      var $66=HEAP32[(($32)>>2)];
      var $67=(($66)|0);
      var $68=$31;
      HEAP32[(($31)>>2)]=$67;
      var $69=HEAP32[(($31)>>2)];
      var $70=$69;
      var $71=$30;
      HEAP32[(($30)>>2)]=$70;
      var $72=HEAP32[(($30)>>2)];
      var $73=(($72)|0);
      var $74=$30;
      var $75=$31;
      var $76=(($73)|0);
      var $77=$76;
      var $78=(($77)|0);
      var $79=$78;
      var $80=HEAPU8[($79)];
      var $81=(($80)&255);
      var $82=$81 & 1;
      var $83=(($82)|0)!=0;
      var $84=$32;
      if ($83) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $85
      var $86=$26;
      HEAP32[(($26)>>2)]=$64;
      var $87=HEAP32[(($26)>>2)];
      var $88=(($87)|0);
      var $89=$25;
      HEAP32[(($25)>>2)]=$88;
      var $90=HEAP32[(($25)>>2)];
      var $91=$90;
      var $92=$24;
      HEAP32[(($24)>>2)]=$91;
      var $93=HEAP32[(($24)>>2)];
      var $94=(($93)|0);
      var $95=$24;
      var $96=$25;
      var $97=(($94)|0);
      var $98=$97;
      var $99=(($98+4)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$26;
      var $122 = $100;__label__ = 6; break;
    case 5: // $102
      var $103=$29;
      HEAP32[(($29)>>2)]=$64;
      var $104=HEAP32[(($29)>>2)];
      var $105=(($104)|0);
      var $106=$28;
      HEAP32[(($28)>>2)]=$105;
      var $107=HEAP32[(($28)>>2)];
      var $108=$107;
      var $109=$27;
      HEAP32[(($27)>>2)]=$108;
      var $110=HEAP32[(($27)>>2)];
      var $111=(($110)|0);
      var $112=$27;
      var $113=$28;
      var $114=(($111)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=$116;
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 >> 1;
      var $121=$29;
      var $122 = $120;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $122;
      var $123=$33;
      var $124=(($122)|0)!=0;
      if ($124) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $125
      var $126=$44;
      var $127=HEAP32[(($126)>>2)];
      var $128=$43;
      var $129=$127;
      var $130=$128;
      var $131=(($129-$130)|0);
      var $132=(((($131)|0)/4)|0);
      var $133=(($132)|0) < 40;
      if ($133) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $134
      var $135=$45;
      var $136=HEAP32[(($135)>>2)];
      var $137=$44;
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138+4)|0);
      HEAP32[(($137)>>2)]=$139;
      HEAP32[(($138)>>2)]=$136;
      __label__ = 9; break;
    case 9: // $140
      $34=0;
      __label__ = 44; break;
    case 10: // $141
      var $142=HEAP8[($35)];
      var $143=(($142 << 24) >> 24);
      var $144=$41;
      var $145=(($144 << 24) >> 24);
      var $146=(($143)|0)==(($145)|0);
      if ($146) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $147
      var $148=$42;
      var $149=$10;
      HEAP32[(($10)>>2)]=$148;
      var $150=HEAPU32[(($10)>>2)];
      var $151=$9;
      HEAP32[(($9)>>2)]=$150;
      var $152=HEAP32[(($9)>>2)];
      var $153=(($152)|0);
      var $154=$8;
      HEAP32[(($8)>>2)]=$153;
      var $155=HEAP32[(($8)>>2)];
      var $156=$155;
      var $157=$7;
      HEAP32[(($7)>>2)]=$156;
      var $158=HEAP32[(($7)>>2)];
      var $159=(($158)|0);
      var $160=$7;
      var $161=$8;
      var $162=(($159)|0);
      var $163=$162;
      var $164=(($163)|0);
      var $165=$164;
      var $166=HEAPU8[($165)];
      var $167=(($166)&255);
      var $168=$167 & 1;
      var $169=(($168)|0)!=0;
      var $170=$9;
      if ($169) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $171
      var $172=$3;
      HEAP32[(($3)>>2)]=$150;
      var $173=HEAP32[(($3)>>2)];
      var $174=(($173)|0);
      var $175=$2;
      HEAP32[(($2)>>2)]=$174;
      var $176=HEAP32[(($2)>>2)];
      var $177=$176;
      var $178=$1;
      HEAP32[(($1)>>2)]=$177;
      var $179=HEAP32[(($1)>>2)];
      var $180=(($179)|0);
      var $181=$1;
      var $182=$2;
      var $183=(($180)|0);
      var $184=$183;
      var $185=(($184+4)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=$3;
      var $208 = $186;__label__ = 14; break;
    case 13: // $188
      var $189=$6;
      HEAP32[(($6)>>2)]=$150;
      var $190=HEAP32[(($6)>>2)];
      var $191=(($190)|0);
      var $192=$5;
      HEAP32[(($5)>>2)]=$191;
      var $193=HEAP32[(($5)>>2)];
      var $194=$193;
      var $195=$4;
      HEAP32[(($4)>>2)]=$194;
      var $196=HEAP32[(($4)>>2)];
      var $197=(($196)|0);
      var $198=$4;
      var $199=$5;
      var $200=(($197)|0);
      var $201=$200;
      var $202=(($201)|0);
      var $203=$202;
      var $204=HEAPU8[($203)];
      var $205=(($204)&255);
      var $206=$205 >> 1;
      var $207=$6;
      var $208 = $206;__label__ = 14; break;
    case 14: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit2
      var $208;
      var $209=$10;
      var $210=(($208)|0)!=0;
      if ($210) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $211
      var $212=$36;
      var $213=HEAP8[($212)];
      var $214=(($213) & 1);
      if ($214) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $215
      $34=-1;
      __label__ = 44; break;
    case 17: // $216
      var $217=$44;
      var $218=HEAP32[(($217)>>2)];
      var $219=$43;
      var $220=$218;
      var $221=$219;
      var $222=(($220-$221)|0);
      var $223=(((($222)|0)/4)|0);
      var $224=(($223)|0) < 40;
      if ($224) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $225
      var $226=$45;
      var $227=HEAP32[(($226)>>2)];
      var $228=$44;
      var $229=HEAP32[(($228)>>2)];
      var $230=(($229+4)|0);
      HEAP32[(($228)>>2)]=$230;
      HEAP32[(($229)>>2)]=$227;
      var $231=$45;
      HEAP32[(($231)>>2)]=0;
      __label__ = 19; break;
    case 19: // $232
      $34=0;
      __label__ = 44; break;
    case 20: // $233
      var $234=$46;
      var $235=$46;
      var $236=(($235+32)|0);
      var $237=$11;
      var $238=$12;
      var $239=$13;
      HEAP32[(($11)>>2)]=$234;
      HEAP32[(($12)>>2)]=$236;
      HEAP32[(($13)>>2)]=$35;
      __label__ = 21; break;
    case 21: // $240
      var $241=HEAP32[(($11)>>2)];
      var $242=HEAP32[(($12)>>2)];
      var $243=(($241)|0)!=(($242)|0);
      if ($243) { __label__ = 22; break; } else { __label__ = 25; break; }
    case 22: // $244
      var $245=HEAP32[(($11)>>2)];
      var $246=HEAP8[($245)];
      var $247=(($246 << 24) >> 24);
      var $248=HEAP32[(($13)>>2)];
      var $249=HEAP8[($248)];
      var $250=(($249 << 24) >> 24);
      var $251=(($247)|0)==(($250)|0);
      if ($251) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $252
      __label__ = 25; break;
    case 24: // $253
      var $254=HEAP32[(($11)>>2)];
      var $255=(($254+1)|0);
      HEAP32[(($11)>>2)]=$255;
      __label__ = 21; break;
    case 25: // $_ZNSt3__14findIPccEET_S2_S2_RKT0__exit
      var $256=HEAP32[(($11)>>2)];
      var $257=$11;
      var $258=$12;
      var $259=$13;
      var $260=$46;
      var $261=$256;
      var $262=$260;
      var $263=(($261-$262)|0);
      $__f=$263;
      var $264=$__f;
      var $265=(($264)|0) >= 32;
      if ($265) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $266
      $34=-1;
      __label__ = 44; break;
    case 27: // $267
      var $268=$__f;
      var $269=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+$268)|0);
      var $270=HEAP8[($269)];
      $__x=$270;
      var $271=$39;
      var $272=HEAP32[(($271)>>2)];
      var $273=$38;
      var $274=$272;
      var $275=$273;
      var $276=(($274-$275)|0);
      var $277=(($276)|0) < 39;
      if ($277) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $278
      var $279=$__x;
      var $280=$39;
      var $281=HEAP32[(($280)>>2)];
      var $282=(($281+1)|0);
      HEAP32[(($280)>>2)]=$282;
      HEAP8[($281)]=$279;
      __label__ = 29; break;
    case 29: // $283
      var $284=$__x;
      var $285=(($284 << 24) >> 24);
      var $286=(($285)|0)==120;
      if ($286) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $287
      var $288=$__x;
      var $289=(($288 << 24) >> 24);
      var $290=(($289)|0)==88;
      if ($290) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $291
      var $292=$37;
      HEAP8[($292)]=80;
      __label__ = 41; break;
    case 32: // $293
      var $294=$__x;
      var $295=(($294 << 24) >> 24);
      var $296=$295 & 223;
      var $297=$37;
      var $298=HEAP8[($297)];
      var $299=(($298 << 24) >> 24);
      var $300=(($296)|0)==(($299)|0);
      if ($300) { __label__ = 33; break; } else { __label__ = 40; break; }
    case 33: // $301
      var $302=$36;
      HEAP8[($302)]=0;
      var $303=$42;
      var $304=$23;
      HEAP32[(($23)>>2)]=$303;
      var $305=HEAPU32[(($23)>>2)];
      var $306=$22;
      HEAP32[(($22)>>2)]=$305;
      var $307=HEAP32[(($22)>>2)];
      var $308=(($307)|0);
      var $309=$21;
      HEAP32[(($21)>>2)]=$308;
      var $310=HEAP32[(($21)>>2)];
      var $311=$310;
      var $312=$20;
      HEAP32[(($20)>>2)]=$311;
      var $313=HEAP32[(($20)>>2)];
      var $314=(($313)|0);
      var $315=$20;
      var $316=$21;
      var $317=(($314)|0);
      var $318=$317;
      var $319=(($318)|0);
      var $320=$319;
      var $321=HEAPU8[($320)];
      var $322=(($321)&255);
      var $323=$322 & 1;
      var $324=(($323)|0)!=0;
      var $325=$22;
      if ($324) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $326
      var $327=$16;
      HEAP32[(($16)>>2)]=$305;
      var $328=HEAP32[(($16)>>2)];
      var $329=(($328)|0);
      var $330=$15;
      HEAP32[(($15)>>2)]=$329;
      var $331=HEAP32[(($15)>>2)];
      var $332=$331;
      var $333=$14;
      HEAP32[(($14)>>2)]=$332;
      var $334=HEAP32[(($14)>>2)];
      var $335=(($334)|0);
      var $336=$14;
      var $337=$15;
      var $338=(($335)|0);
      var $339=$338;
      var $340=(($339+4)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$16;
      var $363 = $341;__label__ = 36; break;
    case 35: // $343
      var $344=$19;
      HEAP32[(($19)>>2)]=$305;
      var $345=HEAP32[(($19)>>2)];
      var $346=(($345)|0);
      var $347=$18;
      HEAP32[(($18)>>2)]=$346;
      var $348=HEAP32[(($18)>>2)];
      var $349=$348;
      var $350=$17;
      HEAP32[(($17)>>2)]=$349;
      var $351=HEAP32[(($17)>>2)];
      var $352=(($351)|0);
      var $353=$17;
      var $354=$18;
      var $355=(($352)|0);
      var $356=$355;
      var $357=(($356)|0);
      var $358=$357;
      var $359=HEAPU8[($358)];
      var $360=(($359)&255);
      var $361=$360 >> 1;
      var $362=$19;
      var $363 = $361;__label__ = 36; break;
    case 36: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit1
      var $363;
      var $364=$23;
      var $365=(($363)|0)!=0;
      if ($365) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $366
      var $367=$44;
      var $368=HEAP32[(($367)>>2)];
      var $369=$43;
      var $370=$368;
      var $371=$369;
      var $372=(($370-$371)|0);
      var $373=(((($372)|0)/4)|0);
      var $374=(($373)|0) < 40;
      if ($374) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $375
      var $376=$45;
      var $377=HEAP32[(($376)>>2)];
      var $378=$44;
      var $379=HEAP32[(($378)>>2)];
      var $380=(($379+4)|0);
      HEAP32[(($378)>>2)]=$380;
      HEAP32[(($379)>>2)]=$377;
      __label__ = 39; break;
    case 39: // $381
      __label__ = 40; break;
    case 40: // $382
      __label__ = 41; break;
    case 41: // $383
      var $384=$__f;
      var $385=(($384)|0) >= 22;
      if ($385) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $386
      $34=0;
      __label__ = 44; break;
    case 43: // $387
      var $388=$45;
      var $389=HEAP32[(($388)>>2)];
      var $390=(($389+1)|0);
      HEAP32[(($388)>>2)]=$390;
      $34=0;
      __label__ = 44; break;
    case 44: // $391
      var $392=$34;
      STACKTOP = __stackBase__;
      return $392;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_["X"]=1;

function __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj($__a, $__a_end, $__err) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $__p2=__stackBase__;
      var $__ld;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      var $5=$2;
      var $6=$3;
      var $7=(($5)|0)!=(($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$2;
      var $10=__ZNSt3__16__clocEv();
      var $11=_strtold_l($9, $__p2, $10);
      var $12=$11;
      $__ld=$12;
      var $13=HEAP32[(($__p2)>>2)];
      var $14=$3;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$4;
      HEAP32[(($17)>>2)]=4;
      $1=0;
      __label__ = 5; break;
    case 3: // $18
      var $19=$__ld;
      var $20=$19;
      $1=$20;
      __label__ = 5; break;
    case 4: // $21
      var $22=$4;
      HEAP32[(($22)>>2)]=4;
      $1=0;
      __label__ = 5; break;
    case 5: // $23
      var $24=$1;
      STACKTOP = __stackBase__;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj($__a, $__a_end, $__err) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $__p2=__stackBase__;
      var $__ld;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      var $5=$2;
      var $6=$3;
      var $7=(($5)|0)!=(($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$2;
      var $10=__ZNSt3__16__clocEv();
      var $11=_strtold_l($9, $__p2, $10);
      var $12=$11;
      $__ld=$12;
      var $13=HEAP32[(($__p2)>>2)];
      var $14=$3;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$4;
      HEAP32[(($17)>>2)]=4;
      $1=0;
      __label__ = 5; break;
    case 3: // $18
      var $19=$__ld;
      var $20=$19;
      $1=$20;
      __label__ = 5; break;
    case 4: // $21
      var $22=$4;
      HEAP32[(($22)>>2)]=4;
      $1=0;
      __label__ = 5; break;
    case 5: // $23
      var $24=$1;
      STACKTOP = __stackBase__;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 392; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__atoms=__stackBase__+120;
      var $__decimal_point=__stackBase__+152;
      var $__thousands_sep=__stackBase__+156;
      var $__grouping=__stackBase__+160;
      var $__a=__stackBase__+172;
      var $__a_end=__stackBase__+212;
      var $__g=__stackBase__+216;
      var $__g_end=__stackBase__+376;
      var $__dc=__stackBase__+380;
      var $__in_units=__stackBase__+384;
      var $__exp=__stackBase__+388;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=(($__atoms)|0);
      __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($__grouping, $42, $43, $__decimal_point, $__thousands_sep);
      var $44=$__a;
      _memset($44, 0, 40, 1);
      var $45=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$45;
      var $46=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$46;
      HEAP32[(($__dc)>>2)]=0;
      HEAP8[($__in_units)]=1;
      HEAP8[($__exp)]=69;
      __label__ = 1; break;
    case 1: // $47
      var $48=$32;
      var $49=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $50=HEAP32[(($32)>>2)];
      var $51=HEAP32[(($33)>>2)];
      var $52=$30;
      var $53=$31;
      HEAP32[(($30)>>2)]=$50;
      HEAP32[(($31)>>2)]=$51;
      var $54=HEAP32[(($30)>>2)];
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      var $58=(($57)&1);
      var $59=HEAP32[(($31)>>2)];
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      var $63=(($62)&1);
      var $64=(($58)|0)==(($63)|0);
      var $65=$30;
      var $66=$31;
      var $67=$64 ^ 1;
      var $68=$32;
      var $69=$33;
      __label__ = 2; break;
    case 2: // $70
      if ($67) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $71
      var $72=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $73=HEAP32[(($25)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$23;
      var $77=$24;
      HEAP32[(($24)>>2)]=$75;
      var $78=HEAP32[(($24)>>2)];
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78+16)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0)==(($82)|0);
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$78;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+36)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$89;
      __label__ = 7; break;
    case 6: // $90
      var $91=(($78+12)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP8[($92)];
      $22=$93;
      var $94=$22;
      var $95=(($94)&255);
      HEAP32[(($23)>>2)]=$95;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $96=HEAP32[(($23)>>2)];
      var $97=$23;
      var $98=$24;
      var $99=(($96) & 255);
      var $100=$25;
      __label__ = 8; break;
    case 8: // $101
      var $102=(($__a)|0);
      var $103=HEAP8[($__decimal_point)];
      var $104=HEAP8[($__thousands_sep)];
      var $105=(($__g)|0);
      var $106=(($__atoms)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($99, $__in_units, $__exp, $102, $__a_end, $103, $104, $__grouping, $105, $__g_end, $__dc, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $110
      __label__ = 28; break;
    case 11: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $38=$113;
      var $114=$112.f1;
      $39=$114;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 12: // $115
      __label__ = 13; break;
    case 13: // $116
      var $117=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $118=HEAPU32[(($21)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$19;
      var $122=$20;
      HEAP32[(($20)>>2)]=$120;
      var $123=HEAPU32[(($20)>>2)];
      var $124=$17;
      var $125=$18;
      HEAP32[(($18)>>2)]=$123;
      var $126=HEAP32[(($18)>>2)];
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($126+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0)==(($130)|0);
      if ($131) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $132
      var $133=$126;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+40)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$136]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$137;
      __label__ = 17; break;
    case 16: // $138
      var $139=(($126+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+1)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=HEAP8[($140)];
      $16=$142;
      var $143=$16;
      var $144=(($143)&255);
      HEAP32[(($17)>>2)]=$144;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $145=HEAP32[(($17)>>2)];
      var $146=$17;
      var $147=$18;
      var $148=(($145)|0)==-1;
      if ($148) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $149
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $150
      var $151=$14;
      var $152=$15;
      HEAP32[(($15)>>2)]=$123;
      var $153=HEAPU32[(($15)>>2)];
      var $154=(($153+12)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($153+16)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155)|0)==(($157)|0);
      if ($158) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $159
      var $160=$153;
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+36)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$163]($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$164;
      __label__ = 23; break;
    case 22: // $165
      var $166=(($153+12)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=HEAP8[($167)];
      $13=$168;
      var $169=$13;
      var $170=(($169)&255);
      HEAP32[(($14)>>2)]=$170;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $171=HEAP32[(($14)>>2)];
      var $172=$14;
      var $173=$15;
      HEAP32[(($19)>>2)]=$171;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $174=HEAP32[(($19)>>2)];
      var $175=$19;
      var $176=$20;
      var $177=$11;
      var $178=$12;
      HEAP32[(($11)>>2)]=$174;
      HEAP32[(($12)>>2)]=-1;
      var $179=HEAP32[(($11)>>2)];
      var $180=HEAP32[(($12)>>2)];
      var $181=(($179)|0)==(($180)|0);
      var $182=$11;
      var $183=$12;
      if ($181) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $184
      var $185=(($118)|0);
      HEAP32[(($185)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $186=$21;
      __label__ = 27; break;
    case 27: // $187
      __label__ = 1; break;
    case 28: // $188
      var $189=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $190=HEAPU32[(($10)>>2)];
      var $191=$9;
      HEAP32[(($9)>>2)]=$190;
      var $192=HEAP32[(($9)>>2)];
      var $193=(($192)|0);
      var $194=$8;
      HEAP32[(($8)>>2)]=$193;
      var $195=HEAP32[(($8)>>2)];
      var $196=$195;
      var $197=$7;
      HEAP32[(($7)>>2)]=$196;
      var $198=HEAP32[(($7)>>2)];
      var $199=(($198)|0);
      var $200=$7;
      var $201=$8;
      var $202=(($199)|0);
      var $203=$202;
      var $204=(($203)|0);
      var $205=$204;
      var $206=HEAPU8[($205)];
      var $207=(($206)&255);
      var $208=$207 & 1;
      var $209=(($208)|0)!=0;
      var $210=$9;
      if ($209) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $211
      var $212=$3;
      HEAP32[(($3)>>2)]=$190;
      var $213=HEAP32[(($3)>>2)];
      var $214=(($213)|0);
      var $215=$2;
      HEAP32[(($2)>>2)]=$214;
      var $216=HEAP32[(($2)>>2)];
      var $217=$216;
      var $218=$1;
      HEAP32[(($1)>>2)]=$217;
      var $219=HEAP32[(($1)>>2)];
      var $220=(($219)|0);
      var $221=$1;
      var $222=$2;
      var $223=(($220)|0);
      var $224=$223;
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$3;
      var $248 = $226;__label__ = 31; break;
    case 30: // $228
      var $229=$6;
      HEAP32[(($6)>>2)]=$190;
      var $230=HEAP32[(($6)>>2)];
      var $231=(($230)|0);
      var $232=$5;
      HEAP32[(($5)>>2)]=$231;
      var $233=HEAP32[(($5)>>2)];
      var $234=$233;
      var $235=$4;
      HEAP32[(($4)>>2)]=$234;
      var $236=HEAP32[(($4)>>2)];
      var $237=(($236)|0);
      var $238=$4;
      var $239=$5;
      var $240=(($237)|0);
      var $241=$240;
      var $242=(($241)|0);
      var $243=$242;
      var $244=HEAPU8[($243)];
      var $245=(($244)&255);
      var $246=$245 >> 1;
      var $247=$6;
      var $248 = $246;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $248;
      var $249=$10;
      var $250=(($248)|0)!=0;
      if ($250) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $251
      var $252=HEAP8[($__in_units)];
      var $253=(($252) & 1);
      if ($253) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $254
      var $255=HEAP32[(($__g_end)>>2)];
      var $256=(($__g)|0);
      var $257=$255;
      var $258=$256;
      var $259=(($257-$258)|0);
      var $260=(((($259)|0)/4)|0);
      var $261=(($260)|0) < 40;
      if ($261) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $262
      var $263=HEAP32[(($__dc)>>2)];
      var $264=HEAP32[(($__g_end)>>2)];
      var $265=(($264+4)|0);
      HEAP32[(($__g_end)>>2)]=$265;
      HEAP32[(($264)>>2)]=$263;
      __label__ = 35; break;
    case 35: // $266
      var $267=(($__a)|0);
      var $268=HEAP32[(($__a_end)>>2)];
      var $269=$36;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj($267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; };
    case 36: // $271
      var $272=$37;
      (tempDoubleF64[0]=$270,HEAP32[(($272)>>2)]=tempDoubleI32[0],HEAP32[(($272+4)>>2)]=tempDoubleI32[1]);
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 11; break; }
    case 37: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 38; break;
    case 38: // $298
      if ($293) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 40; break;
    case 40: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 41: // $306
      __label__ = 42; break;
    case 42: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd["X"]=1;
// Warning: .ll contains floating-point values with more than 64 bits. Faking values for them. If they are used, this will almost certainly fail!

function __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj($__a, $__a_end, $__err) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $__p2=__stackBase__;
      var $__ld;
      $2=$__a;
      $3=$__a_end;
      $4=$__err;
      var $5=$2;
      var $6=$3;
      var $7=(($5)|0)!=(($6)|0);
      if ($7) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $8
      var $9=$2;
      var $10=__ZNSt3__16__clocEv();
      var $11=_strtold_l($9, $__p2, $10);
      var $12=$11;
      $__ld=$12;
      var $13=HEAP32[(($__p2)>>2)];
      var $14=$3;
      var $15=(($13)|0)!=(($14)|0);
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$4;
      HEAP32[(($17)>>2)]=4;
      $1=1.1125369292536007e-308;
      __label__ = 5; break;
    case 3: // $18
      var $19=$__ld;
      $1=$19;
      __label__ = 5; break;
    case 4: // $20
      var $21=$4;
      HEAP32[(($21)>>2)]=4;
      $1=1.1125369292536007e-308;
      __label__ = 5; break;
    case 5: // $22
      var $23=$1;
      STACKTOP = __stackBase__;
      return $23;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 392; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__atoms=__stackBase__+120;
      var $__decimal_point=__stackBase__+152;
      var $__thousands_sep=__stackBase__+156;
      var $__grouping=__stackBase__+160;
      var $__a=__stackBase__+172;
      var $__a_end=__stackBase__+212;
      var $__g=__stackBase__+216;
      var $__g_end=__stackBase__+376;
      var $__dc=__stackBase__+380;
      var $__in_units=__stackBase__+384;
      var $__exp=__stackBase__+388;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=(($__atoms)|0);
      __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_($__grouping, $42, $43, $__decimal_point, $__thousands_sep);
      var $44=$__a;
      _memset($44, 0, 40, 1);
      var $45=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$45;
      var $46=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$46;
      HEAP32[(($__dc)>>2)]=0;
      HEAP8[($__in_units)]=1;
      HEAP8[($__exp)]=69;
      __label__ = 1; break;
    case 1: // $47
      var $48=$32;
      var $49=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $50=HEAP32[(($32)>>2)];
      var $51=HEAP32[(($33)>>2)];
      var $52=$30;
      var $53=$31;
      HEAP32[(($30)>>2)]=$50;
      HEAP32[(($31)>>2)]=$51;
      var $54=HEAP32[(($30)>>2)];
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      var $58=(($57)&1);
      var $59=HEAP32[(($31)>>2)];
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      var $63=(($62)&1);
      var $64=(($58)|0)==(($63)|0);
      var $65=$30;
      var $66=$31;
      var $67=$64 ^ 1;
      var $68=$32;
      var $69=$33;
      __label__ = 2; break;
    case 2: // $70
      if ($67) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $71
      var $72=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $73=HEAP32[(($25)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$23;
      var $77=$24;
      HEAP32[(($24)>>2)]=$75;
      var $78=HEAP32[(($24)>>2)];
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78+16)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0)==(($82)|0);
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$78;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+36)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$89;
      __label__ = 7; break;
    case 6: // $90
      var $91=(($78+12)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP8[($92)];
      $22=$93;
      var $94=$22;
      var $95=(($94)&255);
      HEAP32[(($23)>>2)]=$95;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $96=HEAP32[(($23)>>2)];
      var $97=$23;
      var $98=$24;
      var $99=(($96) & 255);
      var $100=$25;
      __label__ = 8; break;
    case 8: // $101
      var $102=(($__a)|0);
      var $103=HEAP8[($__decimal_point)];
      var $104=HEAP8[($__thousands_sep)];
      var $105=(($__g)|0);
      var $106=(($__atoms)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_($99, $__in_units, $__exp, $102, $__a_end, $103, $104, $__grouping, $105, $__g_end, $__dc, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $110
      __label__ = 28; break;
    case 11: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $38=$113;
      var $114=$112.f1;
      $39=$114;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 12: // $115
      __label__ = 13; break;
    case 13: // $116
      var $117=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $118=HEAPU32[(($21)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$19;
      var $122=$20;
      HEAP32[(($20)>>2)]=$120;
      var $123=HEAPU32[(($20)>>2)];
      var $124=$17;
      var $125=$18;
      HEAP32[(($18)>>2)]=$123;
      var $126=HEAP32[(($18)>>2)];
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($126+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0)==(($130)|0);
      if ($131) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $132
      var $133=$126;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+40)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$136]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$137;
      __label__ = 17; break;
    case 16: // $138
      var $139=(($126+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+1)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=HEAP8[($140)];
      $16=$142;
      var $143=$16;
      var $144=(($143)&255);
      HEAP32[(($17)>>2)]=$144;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $145=HEAP32[(($17)>>2)];
      var $146=$17;
      var $147=$18;
      var $148=(($145)|0)==-1;
      if ($148) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $149
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $150
      var $151=$14;
      var $152=$15;
      HEAP32[(($15)>>2)]=$123;
      var $153=HEAPU32[(($15)>>2)];
      var $154=(($153+12)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=(($153+16)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=(($155)|0)==(($157)|0);
      if ($158) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $159
      var $160=$153;
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+36)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$163]($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$164;
      __label__ = 23; break;
    case 22: // $165
      var $166=(($153+12)|0);
      var $167=HEAP32[(($166)>>2)];
      var $168=HEAP8[($167)];
      $13=$168;
      var $169=$13;
      var $170=(($169)&255);
      HEAP32[(($14)>>2)]=$170;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $171=HEAP32[(($14)>>2)];
      var $172=$14;
      var $173=$15;
      HEAP32[(($19)>>2)]=$171;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $174=HEAP32[(($19)>>2)];
      var $175=$19;
      var $176=$20;
      var $177=$11;
      var $178=$12;
      HEAP32[(($11)>>2)]=$174;
      HEAP32[(($12)>>2)]=-1;
      var $179=HEAP32[(($11)>>2)];
      var $180=HEAP32[(($12)>>2)];
      var $181=(($179)|0)==(($180)|0);
      var $182=$11;
      var $183=$12;
      if ($181) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $184
      var $185=(($118)|0);
      HEAP32[(($185)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $186=$21;
      __label__ = 27; break;
    case 27: // $187
      __label__ = 1; break;
    case 28: // $188
      var $189=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $190=HEAPU32[(($10)>>2)];
      var $191=$9;
      HEAP32[(($9)>>2)]=$190;
      var $192=HEAP32[(($9)>>2)];
      var $193=(($192)|0);
      var $194=$8;
      HEAP32[(($8)>>2)]=$193;
      var $195=HEAP32[(($8)>>2)];
      var $196=$195;
      var $197=$7;
      HEAP32[(($7)>>2)]=$196;
      var $198=HEAP32[(($7)>>2)];
      var $199=(($198)|0);
      var $200=$7;
      var $201=$8;
      var $202=(($199)|0);
      var $203=$202;
      var $204=(($203)|0);
      var $205=$204;
      var $206=HEAPU8[($205)];
      var $207=(($206)&255);
      var $208=$207 & 1;
      var $209=(($208)|0)!=0;
      var $210=$9;
      if ($209) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $211
      var $212=$3;
      HEAP32[(($3)>>2)]=$190;
      var $213=HEAP32[(($3)>>2)];
      var $214=(($213)|0);
      var $215=$2;
      HEAP32[(($2)>>2)]=$214;
      var $216=HEAP32[(($2)>>2)];
      var $217=$216;
      var $218=$1;
      HEAP32[(($1)>>2)]=$217;
      var $219=HEAP32[(($1)>>2)];
      var $220=(($219)|0);
      var $221=$1;
      var $222=$2;
      var $223=(($220)|0);
      var $224=$223;
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$3;
      var $248 = $226;__label__ = 31; break;
    case 30: // $228
      var $229=$6;
      HEAP32[(($6)>>2)]=$190;
      var $230=HEAP32[(($6)>>2)];
      var $231=(($230)|0);
      var $232=$5;
      HEAP32[(($5)>>2)]=$231;
      var $233=HEAP32[(($5)>>2)];
      var $234=$233;
      var $235=$4;
      HEAP32[(($4)>>2)]=$234;
      var $236=HEAP32[(($4)>>2)];
      var $237=(($236)|0);
      var $238=$4;
      var $239=$5;
      var $240=(($237)|0);
      var $241=$240;
      var $242=(($241)|0);
      var $243=$242;
      var $244=HEAPU8[($243)];
      var $245=(($244)&255);
      var $246=$245 >> 1;
      var $247=$6;
      var $248 = $246;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $248;
      var $249=$10;
      var $250=(($248)|0)!=0;
      if ($250) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $251
      var $252=HEAP8[($__in_units)];
      var $253=(($252) & 1);
      if ($253) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $254
      var $255=HEAP32[(($__g_end)>>2)];
      var $256=(($__g)|0);
      var $257=$255;
      var $258=$256;
      var $259=(($257-$258)|0);
      var $260=(((($259)|0)/4)|0);
      var $261=(($260)|0) < 40;
      if ($261) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $262
      var $263=HEAP32[(($__dc)>>2)];
      var $264=HEAP32[(($__g_end)>>2)];
      var $265=(($264+4)|0);
      HEAP32[(($__g_end)>>2)]=$265;
      HEAP32[(($264)>>2)]=$263;
      __label__ = 35; break;
    case 35: // $266
      var $267=(($__a)|0);
      var $268=HEAP32[(($__a_end)>>2)];
      var $269=$36;
      var $270=(function() { try { __THREW__ = false; return __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj($267, $268, $269) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; };
    case 36: // $271
      var $272=$37;
      (tempDoubleF64[0]=$270,HEAP32[(($272)>>2)]=tempDoubleI32[0],HEAP32[(($272+4)>>2)]=tempDoubleI32[1]);
      var $273=(($__g)|0);
      var $274=HEAP32[(($__g_end)>>2)];
      var $275=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $273, $274, $275) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 11; break; }
    case 37: // $276
      var $277=$28;
      var $278=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $279=HEAP32[(($28)>>2)];
      var $280=HEAP32[(($29)>>2)];
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$279;
      HEAP32[(($27)>>2)]=$280;
      var $283=HEAP32[(($26)>>2)];
      var $284=(($283)|0);
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285)|0)==0;
      var $287=(($286)&1);
      var $288=HEAP32[(($27)>>2)];
      var $289=(($288)|0);
      var $290=HEAP32[(($289)>>2)];
      var $291=(($290)|0)==0;
      var $292=(($291)&1);
      var $293=(($287)|0)==(($292)|0);
      var $294=$26;
      var $295=$27;
      var $296=$28;
      var $297=$29;
      __label__ = 38; break;
    case 38: // $298
      if ($293) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $299
      var $300=$36;
      var $301=HEAP32[(($300)>>2)];
      var $302=$301 | 2;
      HEAP32[(($300)>>2)]=$302;
      __label__ = 40; break;
    case 40: // $303
      var $304=$agg_result;
      var $305=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($304)>>2)]=HEAP32[(($305)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 41: // $306
      __label__ = 42; break;
    case 42: // $307
      var $308=$38;
      var $309=$38;
      var $310=$39;
      var $311=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $309, tempValue);
      var $312=($311.f1 = $310, $311);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $313
      var $314=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe["X"]=1;

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 400; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12;
      var $13=__stackBase__+36;
      var $14=__stackBase__+40;
      var $15=__stackBase__+44;
      var $16=__stackBase__+48;
      var $17=__stackBase__+52;
      var $18=__stackBase__+56;
      var $19=__stackBase__+60;
      var $20=__stackBase__+64;
      var $21=__stackBase__+68;
      var $22=__stackBase__+72;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $__a_i_i_i=__stackBase__+112;
      var $__i_i_i_i=__stackBase__+116;
      var $32=__stackBase__+120;
      var $33=__stackBase__+124;
      var $34=__stackBase__+128;
      var $35=__stackBase__+132;
      var $36=__stackBase__+136;
      var $37=__stackBase__+140;
      var $38;
      var $39;
      var $40;
      var $41;
      var $__base;
      var $__atoms=__stackBase__+144;
      var $__thousands_sep;
      var $__grouping=__stackBase__+172;
      var $42=__stackBase__+184;
      var $43;
      var $44;
      var $__a=__stackBase__+188;
      var $__a_end=__stackBase__+228;
      var $__g=__stackBase__+232;
      var $__g_end=__stackBase__+392;
      var $__dc=__stackBase__+396;
      var $45;
      $38=$this;
      $39=$__iob;
      $40=$__err;
      $41=$__v;
      var $46=$38;
      $__base=16;
      var $47=$37;
      HEAP32[(($37)>>2)]=$__grouping;
      var $48=HEAP32[(($37)>>2)];
      var $49=$36;
      HEAP32[(($36)>>2)]=$48;
      var $50=HEAP32[(($36)>>2)];
      var $51=$50;
      var $52=(($50)|0);
      var $53=$35;
      HEAP32[(($35)>>2)]=$52;
      var $54=HEAP32[(($35)>>2)];
      var $55=$34;
      HEAP32[(($34)>>2)]=$54;
      var $56=HEAP32[(($34)>>2)];
      var $57=$56;
      var $58=$33;
      HEAP32[(($33)>>2)]=$57;
      var $59=HEAP32[(($33)>>2)];
      var $60=$59;
      var $61=$32;
      HEAP32[(($32)>>2)]=$60;
      var $62=HEAP32[(($32)>>2)];
      var $63=$32;
      var $64=(($59)|0);
      var $65=$33;
      var $66=$34;
      var $67=$35;
      var $68=$31;
      var $69=$__a_i_i_i;
      var $70=$__i_i_i_i;
      HEAP32[(($31)>>2)]=$50;
      var $71=HEAP32[(($31)>>2)];
      var $72=(($71)|0);
      var $73=$30;
      HEAP32[(($30)>>2)]=$72;
      var $74=HEAP32[(($30)>>2)];
      var $75=$74;
      var $76=$29;
      HEAP32[(($29)>>2)]=$75;
      var $77=HEAP32[(($29)>>2)];
      var $78=(($77)|0);
      var $79=$29;
      var $80=$30;
      var $81=(($78)|0);
      var $82=$81;
      var $83=(($82)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$83;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $84
      var $85=HEAPU32[(($__i_i_i_i)>>2)];
      var $86=(($85)>>>0) < 3;
      if ($86) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $87
      var $88=HEAP32[(($__i_i_i_i)>>2)];
      var $89=HEAP32[(($__a_i_i_i)>>2)];
      var $90=(($89+($88<<2))|0);
      HEAP32[(($90)>>2)]=0;
      var $91=HEAP32[(($__i_i_i_i)>>2)];
      var $92=(($91+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$92;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $93=$31;
      var $94=$__a_i_i_i;
      var $95=$__i_i_i_i;
      var $96=$36;
      var $97=$37;
      var $98=$39;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($42, $98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $99
      var $100=$24;
      HEAP32[(($24)>>2)]=$42;
      var $101=HEAP32[(($24)>>2)];
      var $102=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($101, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 21; break; };
    case 5: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $103=$102;
      var $104=$24;
      __label__ = 6; break;
    case 6: // $105
      var $106=(($__atoms)|0);
      var $107=$20;
      var $108=$21;
      var $109=$22;
      var $110=$23;
      HEAP32[(($20)>>2)]=$103;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE)|0);
      HEAP32[(($22)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+26)|0);
      HEAP32[(($23)>>2)]=$106;
      var $111=HEAP32[(($20)>>2)];
      var $112=$111;
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+32)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=HEAP32[(($21)>>2)];
      var $117=HEAP32[(($22)>>2)];
      var $118=HEAP32[(($23)>>2)];
      var $119=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$115]($111, $116, $117, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 21; break; };
    case 7: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $120=$20;
      var $121=$21;
      var $122=$22;
      var $123=$23;
      __label__ = 8; break;
    case 8: // $124
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 20; break; }
    case 9: // $125
      var $126=$__a;
      _memset($126, 0, 40, 1);
      var $127=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$127;
      var $128=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$128;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 10; break;
    case 10: // $129
      var $130=$18;
      var $131=$19;
      HEAP32[(($18)>>2)]=$__b;
      HEAP32[(($19)>>2)]=$__e;
      var $132=HEAP32[(($18)>>2)];
      var $133=HEAP32[(($19)>>2)];
      var $134=$16;
      var $135=$17;
      HEAP32[(($16)>>2)]=$132;
      HEAP32[(($17)>>2)]=$133;
      var $136=HEAP32[(($16)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138)|0)==0;
      var $140=(($139)&1);
      var $141=HEAP32[(($17)>>2)];
      var $142=(($141)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143)|0)==0;
      var $145=(($144)&1);
      var $146=(($140)|0)==(($145)|0);
      var $147=$16;
      var $148=$17;
      var $149=$146 ^ 1;
      var $150=$18;
      var $151=$19;
      __label__ = 11; break;
    case 11: // $152
      if ($149) { __label__ = 12; break; } else { __label__ = 39; break; }
    case 12: // $153
      var $154=$15;
      HEAP32[(($15)>>2)]=$__b;
      var $155=HEAP32[(($15)>>2)];
      var $156=(($155)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$13;
      var $159=$14;
      HEAP32[(($14)>>2)]=$157;
      var $160=HEAP32[(($14)>>2)];
      var $161=(($160+12)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($160+16)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($162)|0)==(($164)|0);
      if ($165) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $166
      var $167=$160;
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+36)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$170]($160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 20; break; };
    case 14: // $_noexc
      HEAP32[(($13)>>2)]=$171;
      __label__ = 16; break;
    case 15: // $172
      var $173=(($160+12)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=HEAP8[($174)];
      $12=$175;
      var $176=$12;
      var $177=(($176)&255);
      HEAP32[(($13)>>2)]=$177;
      __label__ = 16; break;
    case 16: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $178=HEAP32[(($13)>>2)];
      var $179=$13;
      var $180=$14;
      var $181=(($178) & 255);
      var $182=$15;
      __label__ = 17; break;
    case 17: // $183
      var $184=$__base;
      var $185=(($__a)|0);
      var $186=$__thousands_sep;
      var $187=(($__g)|0);
      var $188=(($__atoms)|0);
      var $189=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_($181, $184, $185, $__a_end, $__dc, $186, $__grouping, $187, $__g_end, $188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $190
      var $191=(($189)|0)!=0;
      if ($191) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $192
      __label__ = 39; break;
    case 20: // $193
      var $194=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $195=$194.f0;
      $43=$195;
      var $196=$194.f1;
      $44=$196;
      __label__ = 47; break;
    case 21: // $197
      var $198=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $199=$198.f0;
      $43=$199;
      var $200=$198.f1;
      $44=$200;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 50; break; }
    case 22: // $201
      __label__ = 47; break;
    case 23: // $202
      __label__ = 24; break;
    case 24: // $203
      var $204=$11;
      HEAP32[(($11)>>2)]=$__b;
      var $205=HEAPU32[(($11)>>2)];
      var $206=(($205)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$9;
      var $209=$10;
      HEAP32[(($10)>>2)]=$207;
      var $210=HEAPU32[(($10)>>2)];
      var $211=$7;
      var $212=$8;
      HEAP32[(($8)>>2)]=$210;
      var $213=HEAP32[(($8)>>2)];
      var $214=(($213+12)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(($213+16)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(($215)|0)==(($217)|0);
      if ($218) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $219
      var $220=$213;
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+40)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$223]($213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 20; break; };
    case 26: // $_noexc1
      HEAP32[(($7)>>2)]=$224;
      __label__ = 28; break;
    case 27: // $225
      var $226=(($213+12)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($227+1)|0);
      HEAP32[(($226)>>2)]=$228;
      var $229=HEAP8[($227)];
      $6=$229;
      var $230=$6;
      var $231=(($230)&255);
      HEAP32[(($7)>>2)]=$231;
      __label__ = 28; break;
    case 28: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $232=HEAP32[(($7)>>2)];
      var $233=$7;
      var $234=$8;
      var $235=(($232)|0)==-1;
      if ($235) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $236
      HEAP32[(($9)>>2)]=-1;
      __label__ = 35; break;
    case 30: // $237
      var $238=$4;
      var $239=$5;
      HEAP32[(($5)>>2)]=$210;
      var $240=HEAPU32[(($5)>>2)];
      var $241=(($240+12)|0);
      var $242=HEAP32[(($241)>>2)];
      var $243=(($240+16)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=(($242)|0)==(($244)|0);
      if ($245) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $246
      var $247=$240;
      var $248=HEAP32[(($247)>>2)];
      var $249=(($248+36)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$250]($240) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 20; break; };
    case 32: // $_noexc2
      HEAP32[(($4)>>2)]=$251;
      __label__ = 34; break;
    case 33: // $252
      var $253=(($240+12)|0);
      var $254=HEAP32[(($253)>>2)];
      var $255=HEAP8[($254)];
      $3=$255;
      var $256=$3;
      var $257=(($256)&255);
      HEAP32[(($4)>>2)]=$257;
      __label__ = 34; break;
    case 34: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $258=HEAP32[(($4)>>2)];
      var $259=$4;
      var $260=$5;
      HEAP32[(($9)>>2)]=$258;
      __label__ = 35; break;
    case 35: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $261=HEAP32[(($9)>>2)];
      var $262=$9;
      var $263=$10;
      var $264=$1;
      var $265=$2;
      HEAP32[(($1)>>2)]=$261;
      HEAP32[(($2)>>2)]=-1;
      var $266=HEAP32[(($1)>>2)];
      var $267=HEAP32[(($2)>>2)];
      var $268=(($266)|0)==(($267)|0);
      var $269=$1;
      var $270=$2;
      if ($268) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $271
      var $272=(($205)|0);
      HEAP32[(($272)>>2)]=0;
      __label__ = 37; break;
    case 37: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $273=$11;
      __label__ = 38; break;
    case 38: // $274
      __label__ = 10; break;
    case 39: // $275
      var $276=(($__a+39)|0);
      HEAP8[($276)]=0;
      var $277=(($__a)|0);
      var $278=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 20; break; };
    case 40: // $279
      var $280=$41;
      var $281=(function() { try { __THREW__ = false; return __ZNSt3__110__sscanf_lEPKcPvS1_z($277, $278, ((STRING_TABLE.__str2371658)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$280,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 20; break; };
    case 41: // $282
      var $283=(($281)|0)!=1;
      if ($283) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $284
      var $285=$40;
      HEAP32[(($285)>>2)]=4;
      __label__ = 43; break;
    case 43: // $286
      var $287=$27;
      var $288=$28;
      HEAP32[(($27)>>2)]=$__b;
      HEAP32[(($28)>>2)]=$__e;
      var $289=HEAP32[(($27)>>2)];
      var $290=HEAP32[(($28)>>2)];
      var $291=$25;
      var $292=$26;
      HEAP32[(($25)>>2)]=$289;
      HEAP32[(($26)>>2)]=$290;
      var $293=HEAP32[(($25)>>2)];
      var $294=(($293)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=(($295)|0)==0;
      var $297=(($296)&1);
      var $298=HEAP32[(($26)>>2)];
      var $299=(($298)|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=(($300)|0)==0;
      var $302=(($301)&1);
      var $303=(($297)|0)==(($302)|0);
      var $304=$25;
      var $305=$26;
      var $306=$27;
      var $307=$28;
      __label__ = 44; break;
    case 44: // $308
      if ($303) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $309
      var $310=$40;
      var $311=HEAP32[(($310)>>2)];
      var $312=$311 | 2;
      HEAP32[(($310)>>2)]=$312;
      __label__ = 46; break;
    case 46: // $313
      var $314=$agg_result;
      var $315=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($314)>>2)]=HEAP32[(($315)>>2)];
      $45=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 47: // $316
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $317
      __label__ = 49; break;
    case 49: // $318
      var $319=$43;
      var $320=$43;
      var $321=$44;
      var $322=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $320, tempValue);
      var $323=($322.f1 = $321, $322);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $324
      var $325=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv["X"]=1;

function ___cxx_global_var_init3273() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16__clocEv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=HEAP8[(__ZGVZNSt3__16__clocEvE6result)];
      var $4=(($3 << 24) >> 24)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $5
      var $6=___cxa_guard_acquire(__ZGVZNSt3__16__clocEvE6result);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(function() { try { __THREW__ = false; return _newlocale(1, ((STRING_TABLE.__str361660)|0), 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $10
      HEAP32[((__ZZNSt3__16__clocEvE6result)>>2)]=$9;
      ;
      __label__ = 4; break;
    case 4: // $11
      var $12=HEAP32[((__ZZNSt3__16__clocEvE6result)>>2)];
      ;
      return $12;
    case 5: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $1=$15;
      var $16=$14.f1;
      $2=$16;
      ;
      __label__ = 6; break;
    case 6: // $17
      var $18=$1;
      var $19=$1;
      var $20=$2;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__110__sscanf_lEPKcPvS1_z($__s, $__l, $__format) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46;
      var $47;
      var $48;
      var $49;
      var $__va=__stackBase__+188;
      var $__current=__stackBase__+192;
      var $__res;
      var $50;
      var $51;
      var $52;
      $47=$__s;
      $48=$__l;
      $49=$__format;
      var $53=$__va;
      HEAP32[(($53)>>2)]=arguments[__ZNSt3__110__sscanf_lEPKcPvS1_z.length];
      var $54=$48;
      var $55=_uselocale($54);
      var $56=$43;
      var $57=$44;
      var $58=$45;
      HEAP32[(($43)>>2)]=$__current;
      HEAP32[(($44)>>2)]=$55;
      HEAP32[(($45)>>2)]=1680;
      var $59=HEAP32[(($43)>>2)];
      var $60=HEAP32[(($44)>>2)];
      var $61=HEAP32[(($45)>>2)];
      var $62=$40;
      var $63=$41;
      var $64=$42;
      HEAP32[(($40)>>2)]=$59;
      HEAP32[(($41)>>2)]=$60;
      HEAP32[(($42)>>2)]=$61;
      var $65=HEAP32[(($40)>>2)];
      var $66=(($65)|0);
      var $67=$39;
      HEAP32[(($39)>>2)]=$41;
      var $68=HEAP32[(($39)>>2)];
      var $69=$39;
      var $70=HEAP32[(($68)>>2)];
      var $71=$25;
      HEAP32[(($25)>>2)]=$42;
      var $72=HEAP32[(($25)>>2)];
      var $73=$25;
      var $74=HEAP32[(($72)>>2)];
      var $75=$36;
      var $76=$37;
      var $77=$38;
      HEAP32[(($36)>>2)]=$66;
      HEAP32[(($37)>>2)]=$70;
      HEAP32[(($38)>>2)]=$74;
      var $78=HEAP32[(($36)>>2)];
      var $79=HEAP32[(($37)>>2)];
      var $80=HEAP32[(($38)>>2)];
      var $81=$33;
      var $82=$34;
      var $83=$35;
      HEAP32[(($33)>>2)]=$78;
      HEAP32[(($34)>>2)]=$79;
      HEAP32[(($35)>>2)]=$80;
      var $84=HEAP32[(($33)>>2)];
      var $85=$84;
      var $86=$32;
      HEAP32[(($32)>>2)]=$34;
      var $87=HEAP32[(($32)>>2)];
      var $88=$32;
      var $89=HEAP32[(($87)>>2)];
      var $90=$26;
      HEAP32[(($26)>>2)]=$35;
      var $91=HEAP32[(($26)>>2)];
      var $92=$26;
      var $93=HEAP32[(($91)>>2)];
      var $94=$29;
      var $95=$30;
      var $96=$31;
      HEAP32[(($29)>>2)]=$85;
      HEAP32[(($30)>>2)]=$89;
      HEAP32[(($31)>>2)]=$93;
      var $97=HEAP32[(($29)>>2)];
      var $98=(($97)|0);
      var $99=$28;
      HEAP32[(($28)>>2)]=$30;
      var $100=HEAP32[(($28)>>2)];
      var $101=$28;
      var $102=HEAP32[(($100)>>2)];
      HEAP32[(($98)>>2)]=$102;
      var $103=(($97+4)|0);
      var $104=$27;
      HEAP32[(($27)>>2)]=$31;
      var $105=HEAP32[(($27)>>2)];
      var $106=$27;
      var $107=HEAP32[(($105)>>2)];
      HEAP32[(($103)>>2)]=$107;
      var $108=$29;
      var $109=$30;
      var $110=$31;
      var $111=$33;
      var $112=$34;
      var $113=$35;
      var $114=$36;
      var $115=$37;
      var $116=$38;
      var $117=$40;
      var $118=$41;
      var $119=$42;
      var $120=$43;
      var $121=$44;
      var $122=$45;
      var $123=$47;
      var $124=$49;
      var $125=HEAP32[(($__va)>>2)];
      var $126=(function() { try { __THREW__ = false; return _vsscanf($123, $124, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $127
      $__res=$126;
      var $128=$__va;
      ;
      var $129=$__res;
      $46=$129;
      $52=1;
      var $130=$12;
      HEAP32[(($12)>>2)]=$__current;
      var $131=HEAP32[(($12)>>2)];
      var $132=$11;
      HEAP32[(($11)>>2)]=$131;
      var $133=HEAP32[(($11)>>2)];
      var $134=$7;
      var $135=$8;
      var $136=$__tmp_i_i_i1;
      var $137=$9;
      var $138=$10;
      HEAP32[(($7)>>2)]=$133;
      HEAP32[(($8)>>2)]=0;
      var $139=HEAP32[(($7)>>2)];
      var $140=(($139)|0);
      var $141=$6;
      HEAP32[(($6)>>2)]=$140;
      var $142=HEAP32[(($6)>>2)];
      var $143=$142;
      var $144=$5;
      HEAP32[(($5)>>2)]=$143;
      var $145=HEAP32[(($5)>>2)];
      var $146=(($145)|0);
      var $147=$5;
      var $148=$6;
      var $149=HEAP32[(($146)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$149;
      var $150=HEAP32[(($8)>>2)];
      var $151=(($139)|0);
      var $152=$4;
      HEAP32[(($4)>>2)]=$151;
      var $153=HEAP32[(($4)>>2)];
      var $154=$153;
      var $155=$3;
      HEAP32[(($3)>>2)]=$154;
      var $156=HEAP32[(($3)>>2)];
      var $157=(($156)|0);
      var $158=$3;
      var $159=$4;
      HEAP32[(($157)>>2)]=$150;
      var $160=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $162
      var $163=(($139)|0);
      var $164=$2;
      HEAP32[(($2)>>2)]=$163;
      var $165=HEAP32[(($2)>>2)];
      var $166=$165;
      var $167=$1;
      HEAP32[(($1)>>2)]=$166;
      var $168=HEAP32[(($1)>>2)];
      var $169=(($168+4)|0);
      var $170=$1;
      var $171=$2;
      var $172=HEAP32[(($169)>>2)];
      var $173=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $174=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$172]($173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $175
      __label__ = 5; break;
    case 4: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $178=$177.f0;
      HEAP32[(($9)>>2)]=$178;
      var $179=$177.f1;
      HEAP32[(($10)>>2)]=$179;
      var $180=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($180);
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit2
      var $181=$7;
      var $182=$8;
      var $183=$__tmp_i_i_i1;
      var $184=$9;
      var $185=$10;
      var $186=$11;
      var $187=$12;
      var $188=$46;
      STACKTOP = __stackBase__;
      return $188;
    case 6: // $189
      var $190=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $191=$190.f0;
      $50=$191;
      var $192=$190.f1;
      $51=$192;
      var $193=$24;
      HEAP32[(($24)>>2)]=$__current;
      var $194=HEAP32[(($24)>>2)];
      var $195=$23;
      HEAP32[(($23)>>2)]=$194;
      var $196=HEAP32[(($23)>>2)];
      var $197=$19;
      var $198=$20;
      var $199=$__tmp_i_i_i;
      var $200=$21;
      var $201=$22;
      HEAP32[(($19)>>2)]=$196;
      HEAP32[(($20)>>2)]=0;
      var $202=HEAP32[(($19)>>2)];
      var $203=(($202)|0);
      var $204=$18;
      HEAP32[(($18)>>2)]=$203;
      var $205=HEAP32[(($18)>>2)];
      var $206=$205;
      var $207=$17;
      HEAP32[(($17)>>2)]=$206;
      var $208=HEAP32[(($17)>>2)];
      var $209=(($208)|0);
      var $210=$17;
      var $211=$18;
      var $212=HEAP32[(($209)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$212;
      var $213=HEAP32[(($20)>>2)];
      var $214=(($202)|0);
      var $215=$16;
      HEAP32[(($16)>>2)]=$214;
      var $216=HEAP32[(($16)>>2)];
      var $217=$216;
      var $218=$15;
      HEAP32[(($15)>>2)]=$217;
      var $219=HEAP32[(($15)>>2)];
      var $220=(($219)|0);
      var $221=$15;
      var $222=$16;
      HEAP32[(($220)>>2)]=$213;
      var $223=HEAP32[(($__tmp_i_i_i)>>2)];
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $225
      var $226=(($202)|0);
      var $227=$14;
      HEAP32[(($14)>>2)]=$226;
      var $228=HEAP32[(($14)>>2)];
      var $229=$228;
      var $230=$13;
      HEAP32[(($13)>>2)]=$229;
      var $231=HEAP32[(($13)>>2)];
      var $232=(($231+4)|0);
      var $233=$13;
      var $234=$14;
      var $235=HEAP32[(($232)>>2)];
      var $236=HEAP32[(($__tmp_i_i_i)>>2)];
      var $237=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$235]($236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $238
      __label__ = 10; break;
    case 9: // $239
      var $240=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $241=$240.f0;
      HEAP32[(($21)>>2)]=$241;
      var $242=$240.f1;
      HEAP32[(($22)>>2)]=$242;
      var $243=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($243);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit
      var $244=$19;
      var $245=$20;
      var $246=$__tmp_i_i_i;
      var $247=$21;
      var $248=$22;
      var $249=$23;
      var $250=$24;
      __label__ = 11; break;
    case 11: // $251
      __label__ = 12; break;
    case 12: // $252
      var $253=$50;
      var $254=$50;
      var $255=$51;
      var $256=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $254, tempValue);
      var $257=($256.f1 = $255, $256);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110__sscanf_lEPKcPvS1_z["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 72; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $8;
      var $9;
      var $__lv=__stackBase__+20;
      var $10=__stackBase__+24;
      var $11=__stackBase__+28;
      var $12=__stackBase__+32;
      var $__ct;
      var $13=__stackBase__+36;
      var $14;
      var $15;
      var $__np;
      var $16=__stackBase__+40;
      var $__names=__stackBase__+44;
      var $17;
      var $__i;
      var $18=__stackBase__+68;
      var $19;
      $6=$this;
      $7=$__iob;
      $8=$__err;
      $9=$__v;
      var $20=$6;
      var $21=$7;
      var $22=$5;
      HEAP32[(($5)>>2)]=$21;
      var $23=HEAP32[(($5)>>2)];
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$5;
      var $27=$25 & 1;
      var $28=(($27)|0)==0;
      if ($28) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $29
      HEAP32[(($__lv)>>2)]=-1;
      var $30=$20;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+16)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$11;
      var $35=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($34)>>2)]=HEAP32[(($35)>>2)];
      var $36=$12;
      var $37=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($36)>>2)]=HEAP32[(($37)>>2)];
      var $38=$7;
      var $39=$8;
      FUNCTION_TABLE[$33]($10, $20, $11, $12, $38, $39, $__lv);
      var $40=$__b;
      var $41=$10;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($40)>>2)]=HEAP32[(($41)>>2)];
      var $42=HEAP32[(($__lv)>>2)];
      if ($42 == 0) {
        __label__ = 2; break;
      }
      else if ($42 == 1) {
        __label__ = 3; break;
      }
      else {
      __label__ = 4; break;
      }
      
    case 2: // $43
      var $44=$9;
      HEAP8[($44)]=0;
      __label__ = 5; break;
    case 3: // $45
      var $46=$9;
      HEAP8[($46)]=1;
      __label__ = 5; break;
    case 4: // $47
      var $48=$9;
      HEAP8[($48)]=1;
      var $49=$8;
      HEAP32[(($49)>>2)]=4;
      __label__ = 5; break;
    case 5: // $50
      var $51=$agg_result;
      var $52=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($51)>>2)]=HEAP32[(($52)>>2)];
      __label__ = 35; break;
    case 6: // $53
      var $54=$7;
      __ZNKSt3__18ios_base6getlocEv($13, $54);
      var $55=$4;
      HEAP32[(($4)>>2)]=$13;
      var $56=HEAP32[(($4)>>2)];
      var $57=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($56, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 16; break; };
    case 7: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $58=$57;
      var $59=$4;
      __label__ = 8; break;
    case 8: // $60
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($13);
      $__ct=$58;
      var $61=$7;
      __ZNKSt3__18ios_base6getlocEv($16, $61);
      var $62=$3;
      HEAP32[(($3)>>2)]=$16;
      var $63=HEAP32[(($3)>>2)];
      var $64=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($63, __ZNSt3__18numpunctIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 18; break; };
    case 9: // $_ZNSt3__19use_facetINS_8numpunctIwEEEERKT_RKNS_6localeE_exit
      var $65=$64;
      var $66=$3;
      __label__ = 10; break;
    case 10: // $67
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($16);
      $__np=$65;
      var $68=(($__names)|0);
      $17=$68;
      var $69=$__np;
      var $70=$2;
      HEAP32[(($2)>>2)]=$69;
      var $71=HEAP32[(($2)>>2)];
      var $72=$71;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+24)|0);
      var $75=HEAP32[(($74)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$75]($68, $71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $_ZNKSt3__18numpunctIwE8truenameEv_exit
      var $76=$2;
      __label__ = 12; break;
    case 12: // $77
      var $78=(($68+12)|0);
      $17=$78;
      var $79=$__np;
      var $80=$1;
      HEAP32[(($1)>>2)]=$79;
      var $81=HEAP32[(($1)>>2)];
      var $82=$81;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+28)|0);
      var $85=HEAP32[(($84)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$85]($78, $81) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 20; break; }
    case 13: // $_ZNKSt3__18numpunctIwE9falsenameEv_exit
      var $86=$1;
      __label__ = 14; break;
    case 14: // $87
      var $88=$18;
      var $89=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($88)>>2)]=HEAP32[(($89)>>2)];
      var $90=(($__names)|0);
      var $91=(($__names)|0);
      var $92=(($91+24)|0);
      var $93=$__ct;
      var $94=$8;
      var $95=(function() { try { __THREW__ = false; return __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b, $18, $90, $92, $93, $94, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 24; break; };
    case 15: // $96
      $__i=$95;
      var $97=$__i;
      var $98=(($__names)|0);
      var $99=(($97)|0)==(($98)|0);
      var $100=$9;
      var $101=(($99)&1);
      HEAP8[($100)]=$101;
      var $102=$agg_result;
      var $103=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($102)>>2)]=HEAP32[(($103)>>2)];
      $19=1;
      var $104=(($__names)|0);
      var $105=(($104+24)|0);
      var $135 = $105;__label__ = 25; break;
    case 16: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $108=$107.f0;
      $14=$108;
      var $109=$107.f1;
      $15=$109;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 37; break; }
    case 17: // $110
      __label__ = 36; break;
    case 18: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $14=$113;
      var $114=$112.f1;
      $15=$114;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($16) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 37; break; }
    case 19: // $115
      __label__ = 36; break;
    case 20: // $116
      var $117=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $118=$117.f0;
      $14=$118;
      var $119=$117.f1;
      $15=$119;
      var $120=$17;
      var $121=(($68)|0)==(($120)|0);
      if ($121) { __label__ = 23; break; } else { var $123 = $120;__label__ = 21; break; }
    case 21: // $122
      var $123;
      var $124=(($123-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($124) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 37; break; }
    case 22: // $125
      var $126=(($124)|0)==(($68)|0);
      if ($126) { __label__ = 23; break; } else { var $123 = $124;__label__ = 21; break; }
    case 23: // $127
      __label__ = 36; break;
    case 24: // $128
      var $129=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $130=$129.f0;
      $14=$130;
      var $131=$129.f1;
      $15=$131;
      var $132=(($__names)|0);
      var $133=(($132+24)|0);
      var $152 = $133;__label__ = 32; break;
    case 25: // $134
      var $135;
      var $136=(($135-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($136) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 28; break; }
    case 26: // $137
      var $138=(($136)|0)==(($104)|0);
      if ($138) { __label__ = 27; break; } else { var $135 = $136;__label__ = 25; break; }
    case 27: // $139
      __label__ = 35; break;
    case 28: // $140
      var $141=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $142=$141.f0;
      $14=$142;
      var $143=$141.f1;
      $15=$143;
      var $144=(($104)|0)==(($136)|0);
      if ($144) { __label__ = 31; break; } else { var $146 = $136;__label__ = 29; break; }
    case 29: // $145
      var $146;
      var $147=(($146-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 37; break; }
    case 30: // $148
      var $149=(($147)|0)==(($104)|0);
      if ($149) { __label__ = 31; break; } else { var $146 = $147;__label__ = 29; break; }
    case 31: // $150
      __label__ = 36; break;
    case 32: // $151
      var $152;
      var $153=(($152-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 37; break; }
    case 33: // $154
      var $155=(($153)|0)==(($132)|0);
      if ($155) { __label__ = 34; break; } else { var $152 = $153;__label__ = 32; break; }
    case 34: // $156
      __label__ = 36; break;
    case 35: // $157
      STACKTOP = __stackBase__;
      return;
    case 36: // $158
      var $159=$14;
      var $160=$14;
      var $161=$15;
      var $162=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $160, tempValue);
      var $163=($162.f1 = $161, $162);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $164
      var $165=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb["X"]=1;

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($__b, $__e, $__kb, $__ke, $__ct, $__err, $__case_sensitive) {
  var __stackBase__  = STACKTOP; STACKTOP += 648; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $__tmp_i=__stackBase__+316;
      var $80=__stackBase__+320;
      var $81=__stackBase__+324;
      var $82=__stackBase__+328;
      var $83=__stackBase__+332;
      var $84=__stackBase__+336;
      var $85=__stackBase__+340;
      var $86=__stackBase__+344;
      var $87=__stackBase__+348;
      var $88=__stackBase__+352;
      var $89=__stackBase__+356;
      var $__tmp_i_i_i3=__stackBase__+360;
      var $90=__stackBase__+364;
      var $91=__stackBase__+368;
      var $92=__stackBase__+372;
      var $93=__stackBase__+376;
      var $94=__stackBase__+380;
      var $95=__stackBase__+384;
      var $96=__stackBase__+388;
      var $97=__stackBase__+392;
      var $98=__stackBase__+396;
      var $99=__stackBase__+400;
      var $100=__stackBase__+404;
      var $101=__stackBase__+408;
      var $102=__stackBase__+412;
      var $103=__stackBase__+416;
      var $104=__stackBase__+420;
      var $105=__stackBase__+424;
      var $106=__stackBase__+428;
      var $107=__stackBase__+432;
      var $108=__stackBase__+436;
      var $109=__stackBase__+440;
      var $110=__stackBase__+444;
      var $111=__stackBase__+448;
      var $112=__stackBase__+452;
      var $113=__stackBase__+456;
      var $114=__stackBase__+460;
      var $115=__stackBase__+464;
      var $116=__stackBase__+468;
      var $117=__stackBase__+472;
      var $118=__stackBase__+476;
      var $119=__stackBase__+480;
      var $120=__stackBase__+484;
      var $121=__stackBase__+488;
      var $122=__stackBase__+492;
      var $__tmp_i_i_i=__stackBase__+496;
      var $123=__stackBase__+500;
      var $124=__stackBase__+504;
      var $125=__stackBase__+508;
      var $126=__stackBase__+512;
      var $127=__stackBase__+516;
      var $128=__stackBase__+520;
      var $129=__stackBase__+524;
      var $130=__stackBase__+528;
      var $131=__stackBase__+532;
      var $132=__stackBase__+536;
      var $133;
      var $134;
      var $135;
      var $136;
      var $137;
      var $138;
      var $139;
      var $__nkw;
      var $__doesnt_match;
      var $__might_match;
      var $__does_match;
      var $__statbuf=__stackBase__+540;
      var $__status;
      var $__stat_hold=__stackBase__+640;
      var $140;
      var $141;
      var $__n_might_match;
      var $__n_does_match;
      var $__st;
      var $__ky;
      var $__indx;
      var $__c;
      var $__consume;
      var $__ky1;
      var $__kc;
      var $__ky2;
      var $142;
      $134=$__b;
      $135=$__kb;
      $136=$__ke;
      $137=$__ct;
      $138=$__err;
      var $143=(($__case_sensitive)&1);
      $139=$143;
      var $144=$135;
      var $145=$136;
      var $146=$129;
      var $147=$130;
      var $148=$131;
      var $149=$132;
      HEAP32[(($130)>>2)]=$144;
      HEAP32[(($131)>>2)]=$145;
      var $150=HEAP32[(($130)>>2)];
      var $151=HEAP32[(($131)>>2)];
      var $tmp_i=$129;
      var $tmp1_i=$132;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $152=$127;
      var $153=$128;
      HEAP32[(($127)>>2)]=$150;
      HEAP32[(($128)>>2)]=$151;
      var $154=HEAP32[(($128)>>2)];
      var $155=HEAP32[(($127)>>2)];
      var $156=$154;
      var $157=$155;
      var $158=(($156-$157)|0);
      var $159=(((($158)|0)/12)|0);
      var $160=$127;
      var $161=$128;
      var $162=$129;
      var $163=$130;
      var $164=$131;
      var $165=$132;
      $__nkw=$159;
      $__doesnt_match=0;
      $__might_match=1;
      $__does_match=2;
      var $166=(($__statbuf)|0);
      $__status=$166;
      var $167=$112;
      var $168=$113;
      var $169=$114;
      HEAP32[(($112)>>2)]=$__stat_hold;
      HEAP32[(($113)>>2)]=0;
      HEAP32[(($114)>>2)]=1496;
      var $170=HEAP32[(($112)>>2)];
      var $171=HEAP32[(($113)>>2)];
      var $172=HEAP32[(($114)>>2)];
      var $173=$109;
      var $174=$110;
      var $175=$111;
      HEAP32[(($109)>>2)]=$170;
      HEAP32[(($110)>>2)]=$171;
      HEAP32[(($111)>>2)]=$172;
      var $176=HEAP32[(($109)>>2)];
      var $177=(($176)|0);
      var $178=$108;
      HEAP32[(($108)>>2)]=$110;
      var $179=HEAP32[(($108)>>2)];
      var $180=$108;
      var $181=HEAP32[(($179)>>2)];
      var $182=$94;
      HEAP32[(($94)>>2)]=$111;
      var $183=HEAP32[(($94)>>2)];
      var $184=$94;
      var $185=HEAP32[(($183)>>2)];
      var $186=$105;
      var $187=$106;
      var $188=$107;
      HEAP32[(($105)>>2)]=$177;
      HEAP32[(($106)>>2)]=$181;
      HEAP32[(($107)>>2)]=$185;
      var $189=HEAP32[(($105)>>2)];
      var $190=HEAP32[(($106)>>2)];
      var $191=HEAP32[(($107)>>2)];
      var $192=$102;
      var $193=$103;
      var $194=$104;
      HEAP32[(($102)>>2)]=$189;
      HEAP32[(($103)>>2)]=$190;
      HEAP32[(($104)>>2)]=$191;
      var $195=HEAP32[(($102)>>2)];
      var $196=$195;
      var $197=$101;
      HEAP32[(($101)>>2)]=$103;
      var $198=HEAP32[(($101)>>2)];
      var $199=$101;
      var $200=HEAP32[(($198)>>2)];
      var $201=$95;
      HEAP32[(($95)>>2)]=$104;
      var $202=HEAP32[(($95)>>2)];
      var $203=$95;
      var $204=HEAP32[(($202)>>2)];
      var $205=$98;
      var $206=$99;
      var $207=$100;
      HEAP32[(($98)>>2)]=$196;
      HEAP32[(($99)>>2)]=$200;
      HEAP32[(($100)>>2)]=$204;
      var $208=HEAP32[(($98)>>2)];
      var $209=(($208)|0);
      var $210=$97;
      HEAP32[(($97)>>2)]=$99;
      var $211=HEAP32[(($97)>>2)];
      var $212=$97;
      var $213=HEAP32[(($211)>>2)];
      HEAP32[(($209)>>2)]=$213;
      var $214=(($208+4)|0);
      var $215=$96;
      HEAP32[(($96)>>2)]=$100;
      var $216=HEAP32[(($96)>>2)];
      var $217=$96;
      var $218=HEAP32[(($216)>>2)];
      HEAP32[(($214)>>2)]=$218;
      var $219=$98;
      var $220=$99;
      var $221=$100;
      var $222=$102;
      var $223=$103;
      var $224=$104;
      var $225=$105;
      var $226=$106;
      var $227=$107;
      var $228=$109;
      var $229=$110;
      var $230=$111;
      var $231=$112;
      var $232=$113;
      var $233=$114;
      var $234=$__nkw;
      var $235=(($234)>>>0) > 100;
      if ($235) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $236
      var $237=$__nkw;
      var $238=_malloc($237);
      $__status=$238;
      var $239=$__status;
      var $240=(($239)|0)==0;
      if ($240) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $241
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $242
      __label__ = 9; break;
    case 4: // $243
      var $244=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $245=$244.f0;
      $140=$245;
      var $246=$244.f1;
      $141=$246;
      var $247=$93;
      HEAP32[(($93)>>2)]=$__stat_hold;
      var $248=HEAP32[(($93)>>2)];
      var $249=$92;
      HEAP32[(($92)>>2)]=$248;
      var $250=HEAP32[(($92)>>2)];
      var $251=$88;
      var $252=$89;
      var $253=$__tmp_i_i_i3;
      var $254=$90;
      var $255=$91;
      HEAP32[(($88)>>2)]=$250;
      HEAP32[(($89)>>2)]=0;
      var $256=HEAPU32[(($88)>>2)];
      var $257=(($256)|0);
      var $258=$87;
      HEAP32[(($87)>>2)]=$257;
      var $259=HEAP32[(($87)>>2)];
      var $260=$259;
      var $261=$86;
      HEAP32[(($86)>>2)]=$260;
      var $262=HEAP32[(($86)>>2)];
      var $263=(($262)|0);
      var $264=$86;
      var $265=$87;
      var $266=HEAP32[(($263)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$266;
      var $267=HEAP32[(($89)>>2)];
      var $268=(($256)|0);
      var $269=$85;
      HEAP32[(($85)>>2)]=$268;
      var $270=HEAP32[(($85)>>2)];
      var $271=$270;
      var $272=$84;
      HEAP32[(($84)>>2)]=$271;
      var $273=HEAP32[(($84)>>2)];
      var $274=(($273)|0);
      var $275=$84;
      var $276=$85;
      HEAP32[(($274)>>2)]=$267;
      var $277=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $278=(($277)|0)!=0;
      if ($278) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $279
      var $280=(($256)|0);
      var $281=$83;
      HEAP32[(($83)>>2)]=$280;
      var $282=HEAP32[(($83)>>2)];
      var $283=$282;
      var $284=$82;
      HEAP32[(($82)>>2)]=$283;
      var $285=HEAP32[(($82)>>2)];
      var $286=(($285+4)|0);
      var $287=$82;
      var $288=$83;
      var $289=HEAP32[(($286)>>2)];
      var $290=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$289]($290) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $291
      __label__ = 8; break;
    case 7: // $292
      var $293=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $294=$293.f0;
      HEAP32[(($90)>>2)]=$294;
      var $295=$293.f1;
      HEAP32[(($91)>>2)]=$295;
      var $296=HEAP32[(($90)>>2)];
      ___cxa_call_unexpected($296);
      throw "Reached an unreachable!"
    case 8: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit4
      var $297=$88;
      var $298=$89;
      var $299=$__tmp_i_i_i3;
      var $300=$90;
      var $301=$91;
      var $302=$92;
      var $303=$93;
      __label__ = 106; break;
    case 9: // $304
      var $305=$__status;
      var $306=$78;
      var $307=$79;
      var $308=$__tmp_i;
      var $309=$80;
      var $310=$81;
      HEAP32[(($78)>>2)]=$__stat_hold;
      HEAP32[(($79)>>2)]=$305;
      var $311=HEAP32[(($78)>>2)];
      var $312=(($311)|0);
      var $313=$77;
      HEAP32[(($77)>>2)]=$312;
      var $314=HEAP32[(($77)>>2)];
      var $315=$314;
      var $316=$76;
      HEAP32[(($76)>>2)]=$315;
      var $317=HEAP32[(($76)>>2)];
      var $318=(($317)|0);
      var $319=$76;
      var $320=$77;
      var $321=HEAP32[(($318)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$321;
      var $322=HEAP32[(($79)>>2)];
      var $323=(($311)|0);
      var $324=$75;
      HEAP32[(($75)>>2)]=$323;
      var $325=HEAP32[(($75)>>2)];
      var $326=$325;
      var $327=$74;
      HEAP32[(($74)>>2)]=$326;
      var $328=HEAP32[(($74)>>2)];
      var $329=(($328)|0);
      var $330=$74;
      var $331=$75;
      HEAP32[(($329)>>2)]=$322;
      var $332=HEAP32[(($__tmp_i)>>2)];
      var $333=(($332)|0)!=0;
      if ($333) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $334
      var $335=(($311)|0);
      var $336=$73;
      HEAP32[(($73)>>2)]=$335;
      var $337=HEAP32[(($73)>>2)];
      var $338=$337;
      var $339=$72;
      HEAP32[(($72)>>2)]=$338;
      var $340=HEAP32[(($72)>>2)];
      var $341=(($340+4)|0);
      var $342=$72;
      var $343=$73;
      var $344=HEAP32[(($341)>>2)];
      var $345=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$344]($345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $346
      __label__ = 13; break;
    case 12: // $347
      var $348=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $349=$348.f0;
      HEAP32[(($80)>>2)]=$349;
      var $350=$348.f1;
      HEAP32[(($81)>>2)]=$350;
      var $351=HEAP32[(($80)>>2)];
      ___cxa_call_unexpected($351);
      throw "Reached an unreachable!"
    case 13: // $_ZNSt3__110unique_ptrIhPFvPvEE5resetEPh_exit
      var $352=$78;
      var $353=$79;
      var $354=$__tmp_i;
      var $355=$80;
      var $356=$81;
      __label__ = 14; break;
    case 14: // $357
      var $358=$__nkw;
      $__n_might_match=$358;
      $__n_does_match=0;
      var $359=$__status;
      $__st=$359;
      var $360=$135;
      $__ky=$360;
      __label__ = 15; break;
    case 15: // $361
      var $362=$__ky;
      var $363=$136;
      var $364=(($362)|0)!=(($363)|0);
      if ($364) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $365
      var $366=$__ky;
      var $367=$71;
      HEAP32[(($71)>>2)]=$366;
      var $368=HEAP32[(($71)>>2)];
      var $369=$70;
      HEAP32[(($70)>>2)]=$368;
      var $370=HEAPU32[(($70)>>2)];
      var $371=$69;
      HEAP32[(($69)>>2)]=$370;
      var $372=HEAP32[(($69)>>2)];
      var $373=(($372)|0);
      var $374=$68;
      HEAP32[(($68)>>2)]=$373;
      var $375=HEAP32[(($68)>>2)];
      var $376=$375;
      var $377=$67;
      HEAP32[(($67)>>2)]=$376;
      var $378=HEAP32[(($67)>>2)];
      var $379=(($378)|0);
      var $380=$67;
      var $381=$68;
      var $382=(($379)|0);
      var $383=$382;
      var $384=(($383)|0);
      var $385=$384;
      var $386=HEAPU8[($385)];
      var $387=(($386)&255);
      var $388=$387 & 1;
      var $389=(($388)|0)!=0;
      var $390=$69;
      if ($389) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $391
      var $392=$63;
      HEAP32[(($63)>>2)]=$370;
      var $393=HEAP32[(($63)>>2)];
      var $394=(($393)|0);
      var $395=$62;
      HEAP32[(($62)>>2)]=$394;
      var $396=HEAP32[(($62)>>2)];
      var $397=$396;
      var $398=$61;
      HEAP32[(($61)>>2)]=$397;
      var $399=HEAP32[(($61)>>2)];
      var $400=(($399)|0);
      var $401=$61;
      var $402=$62;
      var $403=(($400)|0);
      var $404=$403;
      var $405=(($404+4)|0);
      var $406=HEAP32[(($405)>>2)];
      var $407=$63;
      var $428 = $406;__label__ = 19; break;
    case 18: // $408
      var $409=$66;
      HEAP32[(($66)>>2)]=$370;
      var $410=HEAP32[(($66)>>2)];
      var $411=(($410)|0);
      var $412=$65;
      HEAP32[(($65)>>2)]=$411;
      var $413=HEAP32[(($65)>>2)];
      var $414=$413;
      var $415=$64;
      HEAP32[(($64)>>2)]=$414;
      var $416=HEAP32[(($64)>>2)];
      var $417=(($416)|0);
      var $418=$64;
      var $419=$65;
      var $420=(($417)|0);
      var $421=$420;
      var $422=(($421)|0);
      var $423=$422;
      var $424=HEAPU8[($423)];
      var $425=(($424)&255);
      var $426=$425 >> 1;
      var $427=$66;
      var $428 = $426;__label__ = 19; break;
    case 19: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv_exit
      var $428;
      var $429=$70;
      var $430=(($428)|0)==0;
      var $431=$71;
      if ($430) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $432
      var $433=$__st;
      HEAP8[($433)]=1;
      __label__ = 22; break;
    case 21: // $434
      var $435=$__st;
      HEAP8[($435)]=2;
      var $436=$__n_might_match;
      var $437=(($436-1)|0);
      $__n_might_match=$437;
      var $438=$__n_does_match;
      var $439=(($438+1)|0);
      $__n_does_match=$439;
      __label__ = 22; break;
    case 22: // $440
      __label__ = 23; break;
    case 23: // $441
      var $442=$__ky;
      var $443=(($442+12)|0);
      $__ky=$443;
      var $444=$__st;
      var $445=(($444+1)|0);
      $__st=$445;
      __label__ = 15; break;
    case 24: // $446
      $__indx=0;
      __label__ = 25; break;
    case 25: // $447
      var $448=$134;
      var $449=$59;
      var $450=$60;
      HEAP32[(($59)>>2)]=$448;
      HEAP32[(($60)>>2)]=$__e;
      var $451=HEAP32[(($59)>>2)];
      var $452=HEAP32[(($60)>>2)];
      var $453=$57;
      var $454=$58;
      HEAP32[(($57)>>2)]=$451;
      HEAP32[(($58)>>2)]=$452;
      var $455=HEAP32[(($57)>>2)];
      var $456=(($455)|0);
      var $457=HEAP32[(($456)>>2)];
      var $458=(($457)|0)==0;
      var $459=(($458)&1);
      var $460=HEAP32[(($58)>>2)];
      var $461=(($460)|0);
      var $462=HEAP32[(($461)>>2)];
      var $463=(($462)|0)==0;
      var $464=(($463)&1);
      var $465=(($459)|0)==(($464)|0);
      var $466=$57;
      var $467=$58;
      var $468=$465 ^ 1;
      var $469=$59;
      var $470=$60;
      __label__ = 26; break;
    case 26: // $471
      if ($468) { __label__ = 27; break; } else { var $476 = 0;__label__ = 28; break; }
    case 27: // $472
      var $473=$__n_might_match;
      var $474=(($473)>>>0) > 0;
      var $476 = $474;__label__ = 28; break;
    case 28: // $475
      var $476;
      if ($476) { __label__ = 29; break; } else { __label__ = 90; break; }
    case 29: // $477
      var $478=$134;
      var $479=$56;
      HEAP32[(($56)>>2)]=$478;
      var $480=HEAP32[(($56)>>2)];
      var $481=(($480)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=$54;
      var $484=$55;
      HEAP32[(($55)>>2)]=$482;
      var $485=HEAPU32[(($55)>>2)];
      var $486=(($485+12)|0);
      var $487=HEAP32[(($486)>>2)];
      var $488=(($485+16)|0);
      var $489=HEAP32[(($488)>>2)];
      var $490=(($487)|0)==(($489)|0);
      if ($490) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $491
      var $492=$485;
      var $493=HEAP32[(($492)>>2)];
      var $494=(($493+36)|0);
      var $495=HEAP32[(($494)>>2)];
      var $496=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$495]($485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; };
    case 31: // $_noexc
      HEAP32[(($54)>>2)]=$496;
      __label__ = 33; break;
    case 32: // $497
      var $498=(($485+12)|0);
      var $499=HEAP32[(($498)>>2)];
      var $500=HEAP32[(($499)>>2)];
      var $501=$53;
      HEAP32[(($53)>>2)]=$500;
      var $502=HEAP32[(($53)>>2)];
      var $503=$53;
      HEAP32[(($54)>>2)]=$502;
      __label__ = 33; break;
    case 33: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $504=HEAP32[(($54)>>2)];
      var $505=$54;
      var $506=$55;
      var $507=$56;
      __label__ = 34; break;
    case 34: // $508
      $__c=$504;
      var $509=$139;
      var $510=(($509) & 1);
      if ($510) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $511
      var $512=$137;
      var $513=$__c;
      var $514=$51;
      var $515=$52;
      HEAP32[(($51)>>2)]=$512;
      HEAP32[(($52)>>2)]=$513;
      var $516=HEAP32[(($51)>>2)];
      var $517=$516;
      var $518=HEAP32[(($517)>>2)];
      var $519=(($518+28)|0);
      var $520=HEAP32[(($519)>>2)];
      var $521=HEAP32[(($52)>>2)];
      var $522=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$520]($516, $521) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $_ZNKSt3__15ctypeIwE7toupperEw_exit
      var $523=$51;
      var $524=$52;
      __label__ = 37; break;
    case 37: // $525
      $__c=$522;
      __label__ = 38; break;
    case 38: // $526
      $__consume=0;
      var $527=$__status;
      $__st=$527;
      var $528=$135;
      $__ky1=$528;
      __label__ = 39; break;
    case 39: // $529
      var $530=$__ky1;
      var $531=$136;
      var $532=(($530)|0)!=(($531)|0);
      if ($532) { __label__ = 40; break; } else { __label__ = 60; break; }
    case 40: // $533
      var $534=$__st;
      var $535=HEAPU8[($534)];
      var $536=(($535)&255);
      var $537=(($536)|0)==1;
      if ($537) { __label__ = 41; break; } else { __label__ = 58; break; }
    case 41: // $538
      var $539=$__ky1;
      var $540=$__indx;
      var $541=$49;
      var $542=$50;
      HEAP32[(($49)>>2)]=$539;
      HEAP32[(($50)>>2)]=$540;
      var $543=HEAP32[(($49)>>2)];
      var $544=$48;
      HEAP32[(($48)>>2)]=$543;
      var $545=HEAP32[(($48)>>2)];
      var $546=$47;
      HEAP32[(($47)>>2)]=$545;
      var $547=HEAPU32[(($47)>>2)];
      var $548=$46;
      HEAP32[(($46)>>2)]=$547;
      var $549=HEAP32[(($46)>>2)];
      var $550=(($549)|0);
      var $551=$45;
      HEAP32[(($45)>>2)]=$550;
      var $552=HEAP32[(($45)>>2)];
      var $553=$552;
      var $554=$44;
      HEAP32[(($44)>>2)]=$553;
      var $555=HEAP32[(($44)>>2)];
      var $556=(($555)|0);
      var $557=$44;
      var $558=$45;
      var $559=(($556)|0);
      var $560=$559;
      var $561=(($560)|0);
      var $562=$561;
      var $563=HEAPU8[($562)];
      var $564=(($563)&255);
      var $565=$564 & 1;
      var $566=(($565)|0)!=0;
      var $567=$46;
      if ($566) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $568
      var $569=$40;
      HEAP32[(($40)>>2)]=$547;
      var $570=HEAP32[(($40)>>2)];
      var $571=(($570)|0);
      var $572=$39;
      HEAP32[(($39)>>2)]=$571;
      var $573=HEAP32[(($39)>>2)];
      var $574=$573;
      var $575=$38;
      HEAP32[(($38)>>2)]=$574;
      var $576=HEAP32[(($38)>>2)];
      var $577=(($576)|0);
      var $578=$38;
      var $579=$39;
      var $580=(($577)|0);
      var $581=$580;
      var $582=(($581+8)|0);
      var $583=HEAP32[(($582)>>2)];
      var $584=$40;
      var $602 = $583;__label__ = 44; break;
    case 43: // $585
      var $586=$43;
      HEAP32[(($43)>>2)]=$547;
      var $587=HEAP32[(($43)>>2)];
      var $588=(($587)|0);
      var $589=$42;
      HEAP32[(($42)>>2)]=$588;
      var $590=HEAP32[(($42)>>2)];
      var $591=$590;
      var $592=$41;
      HEAP32[(($41)>>2)]=$591;
      var $593=HEAP32[(($41)>>2)];
      var $594=(($593)|0);
      var $595=$41;
      var $596=$42;
      var $597=(($594)|0);
      var $598=$597;
      var $599=(($598+4)|0);
      var $600=(($599)|0);
      var $601=$43;
      var $602 = $600;__label__ = 44; break;
    case 44: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit
      var $602;
      var $603=$47;
      var $604=$48;
      var $605=HEAP32[(($50)>>2)];
      var $606=(($602+($605<<2))|0);
      var $607=$49;
      var $608=$50;
      __label__ = 45; break;
    case 45: // $609
      var $610=HEAP32[(($606)>>2)];
      $__kc=$610;
      var $611=$139;
      var $612=(($611) & 1);
      if ($612) { __label__ = 49; break; } else { __label__ = 46; break; }
    case 46: // $613
      var $614=$137;
      var $615=$__kc;
      var $616=$11;
      var $617=$12;
      HEAP32[(($11)>>2)]=$614;
      HEAP32[(($12)>>2)]=$615;
      var $618=HEAP32[(($11)>>2)];
      var $619=$618;
      var $620=HEAP32[(($619)>>2)];
      var $621=(($620+28)|0);
      var $622=HEAP32[(($621)>>2)];
      var $623=HEAP32[(($12)>>2)];
      var $624=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$622]($618, $623) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 4; break; };
    case 47: // $_ZNKSt3__15ctypeIwE7toupperEw_exit9
      var $625=$11;
      var $626=$12;
      __label__ = 48; break;
    case 48: // $627
      $__kc=$624;
      __label__ = 49; break;
    case 49: // $628
      var $629=$__c;
      var $630=$__kc;
      var $631=(($629)|0)==(($630)|0);
      if ($631) { __label__ = 50; break; } else { __label__ = 56; break; }
    case 50: // $632
      $__consume=1;
      var $633=$__ky1;
      var $634=$10;
      HEAP32[(($10)>>2)]=$633;
      var $635=HEAPU32[(($10)>>2)];
      var $636=$9;
      HEAP32[(($9)>>2)]=$635;
      var $637=HEAP32[(($9)>>2)];
      var $638=(($637)|0);
      var $639=$8;
      HEAP32[(($8)>>2)]=$638;
      var $640=HEAP32[(($8)>>2)];
      var $641=$640;
      var $642=$7;
      HEAP32[(($7)>>2)]=$641;
      var $643=HEAP32[(($7)>>2)];
      var $644=(($643)|0);
      var $645=$7;
      var $646=$8;
      var $647=(($644)|0);
      var $648=$647;
      var $649=(($648)|0);
      var $650=$649;
      var $651=HEAPU8[($650)];
      var $652=(($651)&255);
      var $653=$652 & 1;
      var $654=(($653)|0)!=0;
      var $655=$9;
      if ($654) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $656
      var $657=$3;
      HEAP32[(($3)>>2)]=$635;
      var $658=HEAP32[(($3)>>2)];
      var $659=(($658)|0);
      var $660=$2;
      HEAP32[(($2)>>2)]=$659;
      var $661=HEAP32[(($2)>>2)];
      var $662=$661;
      var $663=$1;
      HEAP32[(($1)>>2)]=$662;
      var $664=HEAP32[(($1)>>2)];
      var $665=(($664)|0);
      var $666=$1;
      var $667=$2;
      var $668=(($665)|0);
      var $669=$668;
      var $670=(($669+4)|0);
      var $671=HEAP32[(($670)>>2)];
      var $672=$3;
      var $693 = $671;__label__ = 53; break;
    case 52: // $673
      var $674=$6;
      HEAP32[(($6)>>2)]=$635;
      var $675=HEAP32[(($6)>>2)];
      var $676=(($675)|0);
      var $677=$5;
      HEAP32[(($5)>>2)]=$676;
      var $678=HEAP32[(($5)>>2)];
      var $679=$678;
      var $680=$4;
      HEAP32[(($4)>>2)]=$679;
      var $681=HEAP32[(($4)>>2)];
      var $682=(($681)|0);
      var $683=$4;
      var $684=$5;
      var $685=(($682)|0);
      var $686=$685;
      var $687=(($686)|0);
      var $688=$687;
      var $689=HEAPU8[($688)];
      var $690=(($689)&255);
      var $691=$690 >> 1;
      var $692=$6;
      var $693 = $691;__label__ = 53; break;
    case 53: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit10
      var $693;
      var $694=$10;
      var $695=$__indx;
      var $696=(($695+1)|0);
      var $697=(($693)|0)==(($696)|0);
      if ($697) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $698
      var $699=$__st;
      HEAP8[($699)]=2;
      var $700=$__n_might_match;
      var $701=(($700-1)|0);
      $__n_might_match=$701;
      var $702=$__n_does_match;
      var $703=(($702+1)|0);
      $__n_does_match=$703;
      __label__ = 55; break;
    case 55: // $704
      __label__ = 57; break;
    case 56: // $705
      var $706=$__st;
      HEAP8[($706)]=0;
      var $707=$__n_might_match;
      var $708=(($707-1)|0);
      $__n_might_match=$708;
      __label__ = 57; break;
    case 57: // $709
      __label__ = 58; break;
    case 58: // $710
      __label__ = 59; break;
    case 59: // $711
      var $712=$__ky1;
      var $713=(($712+12)|0);
      $__ky1=$713;
      var $714=$__st;
      var $715=(($714+1)|0);
      $__st=$715;
      __label__ = 39; break;
    case 60: // $716
      var $717=$__consume;
      var $718=(($717) & 1);
      if ($718) { __label__ = 61; break; } else { __label__ = 88; break; }
    case 61: // $719
      var $720=$134;
      var $721=$23;
      HEAP32[(($23)>>2)]=$720;
      var $722=HEAPU32[(($23)>>2)];
      var $723=(($722)|0);
      var $724=HEAP32[(($723)>>2)];
      var $725=$21;
      var $726=$22;
      HEAP32[(($22)>>2)]=$724;
      var $727=HEAP32[(($22)>>2)];
      var $728=$19;
      var $729=$20;
      HEAP32[(($20)>>2)]=$727;
      var $730=HEAP32[(($20)>>2)];
      var $731=(($730+12)|0);
      var $732=HEAP32[(($731)>>2)];
      var $733=(($730+16)|0);
      var $734=HEAP32[(($733)>>2)];
      var $735=(($732)|0)==(($734)|0);
      if ($735) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $736
      var $737=$730;
      var $738=HEAP32[(($737)>>2)];
      var $739=(($738+40)|0);
      var $740=HEAP32[(($739)>>2)];
      var $741=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$740]($730) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 4; break; };
    case 63: // $_noexc6
      HEAP32[(($19)>>2)]=$741;
      __label__ = 65; break;
    case 64: // $742
      var $743=(($730+12)|0);
      var $744=HEAP32[(($743)>>2)];
      var $745=(($744+4)|0);
      HEAP32[(($743)>>2)]=$745;
      var $746=HEAP32[(($744)>>2)];
      var $747=$18;
      HEAP32[(($18)>>2)]=$746;
      var $748=HEAP32[(($18)>>2)];
      var $749=$18;
      HEAP32[(($19)>>2)]=$748;
      __label__ = 65; break;
    case 65: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $750=HEAP32[(($19)>>2)];
      var $751=$19;
      var $752=$20;
      var $753=(($750)|0)==-1;
      if ($753) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $754
      HEAP32[(($21)>>2)]=-1;
      __label__ = 72; break;
    case 67: // $755
      var $756=$16;
      var $757=$17;
      HEAP32[(($17)>>2)]=$727;
      var $758=HEAP32[(($17)>>2)];
      var $759=(($758+12)|0);
      var $760=HEAP32[(($759)>>2)];
      var $761=(($758+16)|0);
      var $762=HEAP32[(($761)>>2)];
      var $763=(($760)|0)==(($762)|0);
      if ($763) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $764
      var $765=$758;
      var $766=HEAP32[(($765)>>2)];
      var $767=(($766+36)|0);
      var $768=HEAP32[(($767)>>2)];
      var $769=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$768]($758) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 4; break; };
    case 69: // $_noexc7
      HEAP32[(($16)>>2)]=$769;
      __label__ = 71; break;
    case 70: // $770
      var $771=(($758+12)|0);
      var $772=HEAP32[(($771)>>2)];
      var $773=HEAP32[(($772)>>2)];
      var $774=$15;
      HEAP32[(($15)>>2)]=$773;
      var $775=HEAP32[(($15)>>2)];
      var $776=$15;
      HEAP32[(($16)>>2)]=$775;
      __label__ = 71; break;
    case 71: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $777=HEAP32[(($16)>>2)];
      var $778=$16;
      var $779=$17;
      HEAP32[(($21)>>2)]=$777;
      __label__ = 72; break;
    case 72: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $780=HEAP32[(($21)>>2)];
      var $781=$21;
      var $782=$22;
      var $783=$13;
      var $784=$14;
      HEAP32[(($13)>>2)]=$780;
      HEAP32[(($14)>>2)]=-1;
      var $785=HEAP32[(($13)>>2)];
      var $786=HEAP32[(($14)>>2)];
      var $787=(($785)|0)==(($786)|0);
      var $788=$13;
      var $789=$14;
      if ($787) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $790
      var $791=(($722)|0);
      HEAP32[(($791)>>2)]=0;
      __label__ = 74; break;
    case 74: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $792=$23;
      __label__ = 75; break;
    case 75: // $793
      var $794=$__n_might_match;
      var $795=$__n_does_match;
      var $796=(($794+$795)|0);
      var $797=(($796)>>>0) > 1;
      if ($797) { __label__ = 76; break; } else { __label__ = 87; break; }
    case 76: // $798
      var $799=$__status;
      $__st=$799;
      var $800=$135;
      $__ky2=$800;
      __label__ = 77; break;
    case 77: // $801
      var $802=$__ky2;
      var $803=$136;
      var $804=(($802)|0)!=(($803)|0);
      if ($804) { __label__ = 78; break; } else { __label__ = 86; break; }
    case 78: // $805
      var $806=$__st;
      var $807=HEAPU8[($806)];
      var $808=(($807)&255);
      var $809=(($808)|0)==2;
      if ($809) { __label__ = 79; break; } else { __label__ = 84; break; }
    case 79: // $810
      var $811=$__ky2;
      var $812=$33;
      HEAP32[(($33)>>2)]=$811;
      var $813=HEAPU32[(($33)>>2)];
      var $814=$32;
      HEAP32[(($32)>>2)]=$813;
      var $815=HEAP32[(($32)>>2)];
      var $816=(($815)|0);
      var $817=$31;
      HEAP32[(($31)>>2)]=$816;
      var $818=HEAP32[(($31)>>2)];
      var $819=$818;
      var $820=$30;
      HEAP32[(($30)>>2)]=$819;
      var $821=HEAP32[(($30)>>2)];
      var $822=(($821)|0);
      var $823=$30;
      var $824=$31;
      var $825=(($822)|0);
      var $826=$825;
      var $827=(($826)|0);
      var $828=$827;
      var $829=HEAPU8[($828)];
      var $830=(($829)&255);
      var $831=$830 & 1;
      var $832=(($831)|0)!=0;
      var $833=$32;
      if ($832) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $834
      var $835=$26;
      HEAP32[(($26)>>2)]=$813;
      var $836=HEAP32[(($26)>>2)];
      var $837=(($836)|0);
      var $838=$25;
      HEAP32[(($25)>>2)]=$837;
      var $839=HEAP32[(($25)>>2)];
      var $840=$839;
      var $841=$24;
      HEAP32[(($24)>>2)]=$840;
      var $842=HEAP32[(($24)>>2)];
      var $843=(($842)|0);
      var $844=$24;
      var $845=$25;
      var $846=(($843)|0);
      var $847=$846;
      var $848=(($847+4)|0);
      var $849=HEAP32[(($848)>>2)];
      var $850=$26;
      var $871 = $849;__label__ = 82; break;
    case 81: // $851
      var $852=$29;
      HEAP32[(($29)>>2)]=$813;
      var $853=HEAP32[(($29)>>2)];
      var $854=(($853)|0);
      var $855=$28;
      HEAP32[(($28)>>2)]=$854;
      var $856=HEAP32[(($28)>>2)];
      var $857=$856;
      var $858=$27;
      HEAP32[(($27)>>2)]=$857;
      var $859=HEAP32[(($27)>>2)];
      var $860=(($859)|0);
      var $861=$27;
      var $862=$28;
      var $863=(($860)|0);
      var $864=$863;
      var $865=(($864)|0);
      var $866=$865;
      var $867=HEAPU8[($866)];
      var $868=(($867)&255);
      var $869=$868 >> 1;
      var $870=$29;
      var $871 = $869;__label__ = 82; break;
    case 82: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $871;
      var $872=$33;
      var $873=$__indx;
      var $874=(($873+1)|0);
      var $875=(($871)|0)!=(($874)|0);
      if ($875) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $876
      var $877=$__st;
      HEAP8[($877)]=0;
      var $878=$__n_does_match;
      var $879=(($878-1)|0);
      $__n_does_match=$879;
      __label__ = 84; break;
    case 84: // $880
      __label__ = 85; break;
    case 85: // $881
      var $882=$__ky2;
      var $883=(($882+12)|0);
      $__ky2=$883;
      var $884=$__st;
      var $885=(($884+1)|0);
      $__st=$885;
      __label__ = 77; break;
    case 86: // $886
      __label__ = 87; break;
    case 87: // $887
      __label__ = 88; break;
    case 88: // $888
      __label__ = 89; break;
    case 89: // $889
      var $890=$__indx;
      var $891=(($890+1)|0);
      $__indx=$891;
      __label__ = 25; break;
    case 90: // $892
      var $893=$134;
      var $894=$36;
      var $895=$37;
      HEAP32[(($36)>>2)]=$893;
      HEAP32[(($37)>>2)]=$__e;
      var $896=HEAP32[(($36)>>2)];
      var $897=HEAP32[(($37)>>2)];
      var $898=$34;
      var $899=$35;
      HEAP32[(($34)>>2)]=$896;
      HEAP32[(($35)>>2)]=$897;
      var $900=HEAP32[(($34)>>2)];
      var $901=(($900)|0);
      var $902=HEAP32[(($901)>>2)];
      var $903=(($902)|0)==0;
      var $904=(($903)&1);
      var $905=HEAP32[(($35)>>2)];
      var $906=(($905)|0);
      var $907=HEAP32[(($906)>>2)];
      var $908=(($907)|0)==0;
      var $909=(($908)&1);
      var $910=(($904)|0)==(($909)|0);
      var $911=$34;
      var $912=$35;
      var $913=$36;
      var $914=$37;
      __label__ = 91; break;
    case 91: // $915
      if ($910) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $916
      var $917=$138;
      var $918=HEAP32[(($917)>>2)];
      var $919=$918 | 2;
      HEAP32[(($917)>>2)]=$919;
      __label__ = 93; break;
    case 93: // $920
      var $921=$__status;
      $__st=$921;
      __label__ = 94; break;
    case 94: // $922
      var $923=$135;
      var $924=$136;
      var $925=(($923)|0)!=(($924)|0);
      if ($925) { __label__ = 95; break; } else { __label__ = 99; break; }
    case 95: // $926
      var $927=$__st;
      var $928=HEAPU8[($927)];
      var $929=(($928)&255);
      var $930=(($929)|0)==2;
      if ($930) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $931
      __label__ = 99; break;
    case 97: // $932
      __label__ = 98; break;
    case 98: // $933
      var $934=$135;
      var $935=(($934+12)|0);
      $135=$935;
      var $936=$__st;
      var $937=(($936+1)|0);
      $__st=$937;
      __label__ = 94; break;
    case 99: // $938
      var $939=$135;
      var $940=$136;
      var $941=(($939)|0)==(($940)|0);
      if ($941) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $942
      var $943=$138;
      var $944=HEAP32[(($943)>>2)];
      var $945=$944 | 4;
      HEAP32[(($943)>>2)]=$945;
      __label__ = 101; break;
    case 101: // $946
      var $947=$135;
      $133=$947;
      $142=1;
      var $948=$126;
      HEAP32[(($126)>>2)]=$__stat_hold;
      var $949=HEAP32[(($126)>>2)];
      var $950=$125;
      HEAP32[(($125)>>2)]=$949;
      var $951=HEAP32[(($125)>>2)];
      var $952=$121;
      var $953=$122;
      var $954=$__tmp_i_i_i;
      var $955=$123;
      var $956=$124;
      HEAP32[(($121)>>2)]=$951;
      HEAP32[(($122)>>2)]=0;
      var $957=HEAP32[(($121)>>2)];
      var $958=(($957)|0);
      var $959=$120;
      HEAP32[(($120)>>2)]=$958;
      var $960=HEAP32[(($120)>>2)];
      var $961=$960;
      var $962=$119;
      HEAP32[(($119)>>2)]=$961;
      var $963=HEAP32[(($119)>>2)];
      var $964=(($963)|0);
      var $965=$119;
      var $966=$120;
      var $967=HEAP32[(($964)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$967;
      var $968=HEAP32[(($122)>>2)];
      var $969=(($957)|0);
      var $970=$118;
      HEAP32[(($118)>>2)]=$969;
      var $971=HEAP32[(($118)>>2)];
      var $972=$971;
      var $973=$117;
      HEAP32[(($117)>>2)]=$972;
      var $974=HEAP32[(($117)>>2)];
      var $975=(($974)|0);
      var $976=$117;
      var $977=$118;
      HEAP32[(($975)>>2)]=$968;
      var $978=HEAP32[(($__tmp_i_i_i)>>2)];
      var $979=(($978)|0)!=0;
      if ($979) { __label__ = 102; break; } else { __label__ = 105; break; }
    case 102: // $980
      var $981=(($957)|0);
      var $982=$116;
      HEAP32[(($116)>>2)]=$981;
      var $983=HEAP32[(($116)>>2)];
      var $984=$983;
      var $985=$115;
      HEAP32[(($115)>>2)]=$984;
      var $986=HEAP32[(($115)>>2)];
      var $987=(($986+4)|0);
      var $988=$115;
      var $989=$116;
      var $990=HEAP32[(($987)>>2)];
      var $991=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$990]($991) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $992
      __label__ = 105; break;
    case 104: // $993
      var $994=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $995=$994.f0;
      HEAP32[(($123)>>2)]=$995;
      var $996=$994.f1;
      HEAP32[(($124)>>2)]=$996;
      var $997=HEAP32[(($123)>>2)];
      ___cxa_call_unexpected($997);
      throw "Reached an unreachable!"
    case 105: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit
      var $998=$121;
      var $999=$122;
      var $1000=$__tmp_i_i_i;
      var $1001=$123;
      var $1002=$124;
      var $1003=$125;
      var $1004=$126;
      var $1005=$133;
      STACKTOP = __stackBase__;
      return $1005;
    case 106: // $1006
      __label__ = 107; break;
    case 107: // $1007
      var $1008=$140;
      var $1009=$140;
      var $1010=$141;
      var $1011=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1009, tempValue);
      var $1012=($1011.f1 = $1010, $1011);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $1014=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+132;
      var $__thousands_sep=__stackBase__+236;
      var $__grouping=__stackBase__+240;
      var $__a=__stackBase__+252;
      var $__a_end=__stackBase__+292;
      var $__g=__stackBase__+296;
      var $__g_end=__stackBase__+456;
      var $__dc=__stackBase__+460;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP32[(($94)>>2)];
      var $96=$22;
      HEAP32[(($22)>>2)]=$95;
      var $97=HEAP32[(($22)>>2)];
      var $98=$22;
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $99=HEAP32[(($23)>>2)];
      var $100=$23;
      var $101=$24;
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP32[(($__thousands_sep)>>2)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($99, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAP32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+4)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP32[(($142)>>2)];
      var $145=$16;
      HEAP32[(($16)>>2)]=$144;
      var $146=HEAP32[(($16)>>2)];
      var $147=$16;
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=$18;
      var $151=(($148)|0)==-1;
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $153
      var $154=$14;
      var $155=$15;
      HEAP32[(($15)>>2)]=$125;
      var $156=HEAP32[(($15)>>2)];
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($158)|0)==(($160)|0);
      if ($161) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $162
      var $163=$156;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+36)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$166]($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$167;
      __label__ = 23; break;
    case 22: // $168
      var $169=(($156+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($170)>>2)];
      var $172=$13;
      HEAP32[(($13)>>2)]=$171;
      var $173=HEAP32[(($13)>>2)];
      var $174=$13;
      HEAP32[(($14)>>2)]=$173;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $175=HEAP32[(($14)>>2)];
      var $176=$14;
      var $177=$15;
      HEAP32[(($19)>>2)]=$175;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $178=HEAP32[(($19)>>2)];
      var $179=$19;
      var $180=$20;
      var $181=$11;
      var $182=$12;
      HEAP32[(($11)>>2)]=$178;
      HEAP32[(($12)>>2)]=-1;
      var $183=HEAP32[(($11)>>2)];
      var $184=HEAP32[(($12)>>2)];
      var $185=(($183)|0)==(($184)|0);
      var $186=$11;
      var $187=$12;
      if ($185) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $188
      var $189=(($120)|0);
      HEAP32[(($189)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $190=$21;
      __label__ = 27; break;
    case 27: // $191
      __label__ = 1; break;
    case 28: // $192
      var $193=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $194=HEAPU32[(($10)>>2)];
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196)|0);
      var $198=$8;
      HEAP32[(($8)>>2)]=$197;
      var $199=HEAP32[(($8)>>2)];
      var $200=$199;
      var $201=$7;
      HEAP32[(($7)>>2)]=$200;
      var $202=HEAP32[(($7)>>2)];
      var $203=(($202)|0);
      var $204=$7;
      var $205=$8;
      var $206=(($203)|0);
      var $207=$206;
      var $208=(($207)|0);
      var $209=$208;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$211 & 1;
      var $213=(($212)|0)!=0;
      var $214=$9;
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $215
      var $216=$3;
      HEAP32[(($3)>>2)]=$194;
      var $217=HEAP32[(($3)>>2)];
      var $218=(($217)|0);
      var $219=$2;
      HEAP32[(($2)>>2)]=$218;
      var $220=HEAP32[(($2)>>2)];
      var $221=$220;
      var $222=$1;
      HEAP32[(($1)>>2)]=$221;
      var $223=HEAP32[(($1)>>2)];
      var $224=(($223)|0);
      var $225=$1;
      var $226=$2;
      var $227=(($224)|0);
      var $228=$227;
      var $229=(($228+4)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$3;
      var $252 = $230;__label__ = 31; break;
    case 30: // $232
      var $233=$6;
      HEAP32[(($6)>>2)]=$194;
      var $234=HEAP32[(($6)>>2)];
      var $235=(($234)|0);
      var $236=$5;
      HEAP32[(($5)>>2)]=$235;
      var $237=HEAP32[(($5)>>2)];
      var $238=$237;
      var $239=$4;
      HEAP32[(($4)>>2)]=$238;
      var $240=HEAP32[(($4)>>2)];
      var $241=(($240)|0);
      var $242=$4;
      var $243=$5;
      var $244=(($241)|0);
      var $245=$244;
      var $246=(($245)|0);
      var $247=$246;
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$249 >> 1;
      var $251=$6;
      var $252 = $250;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $252;
      var $253=$10;
      var $254=(($252)|0)!=0;
      if ($254) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $255
      var $256=HEAP32[(($__g_end)>>2)];
      var $257=(($__g)|0);
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(((($260)|0)/4)|0);
      var $262=(($261)|0) < 40;
      if ($262) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $263
      var $264=HEAP32[(($__dc)>>2)];
      var $265=HEAP32[(($__g_end)>>2)];
      var $266=(($265+4)|0);
      HEAP32[(($__g_end)>>2)]=$266;
      HEAP32[(($265)>>2)]=$264;
      __label__ = 34; break;
    case 34: // $267
      var $268=(($__a)|0);
      var $269=HEAP32[(($__a_end)>>2)];
      var $270=$36;
      var $271=$__base;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji($268, $269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $273
      var $274=$37;
      HEAP32[(($274)>>2)]=$272;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 37; break;
    case 37: // $300
      if ($295) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 39; break;
    case 39: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $308
      __label__ = 41; break;
    case 41: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl["X"]=1;

function __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($agg_result, $__iob, $__atoms, $__thousands_sep) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      var $10;
      var $11;
      var $__loc=__stackBase__+32;
      var $12;
      var $13;
      var $__np;
      var $14;
      $9=$__iob;
      $10=$__atoms;
      $11=$__thousands_sep;
      var $15=$9;
      __ZNKSt3__18ios_base6getlocEv($__loc, $15);
      var $16=$8;
      HEAP32[(($8)>>2)]=$__loc;
      var $17=HEAP32[(($8)>>2)];
      var $18=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($17, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 11; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $19=$18;
      var $20=$8;
      __label__ = 2; break;
    case 2: // $21
      var $22=$10;
      var $23=$4;
      var $24=$5;
      var $25=$6;
      var $26=$7;
      HEAP32[(($4)>>2)]=$19;
      HEAP32[(($5)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE)|0);
      HEAP32[(($6)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+26)|0);
      HEAP32[(($7)>>2)]=$22;
      var $27=HEAP32[(($4)>>2)];
      var $28=$27;
      var $29=HEAP32[(($28)>>2)];
      var $30=(($29+48)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=HEAP32[(($5)>>2)];
      var $33=HEAP32[(($6)>>2)];
      var $34=HEAP32[(($7)>>2)];
      var $35=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$31]($27, $32, $33, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 11; break; };
    case 3: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $36=$4;
      var $37=$5;
      var $38=$6;
      var $39=$7;
      __label__ = 4; break;
    case 4: // $40
      var $41=$3;
      HEAP32[(($3)>>2)]=$__loc;
      var $42=HEAP32[(($3)>>2)];
      var $43=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($42, __ZNSt3__18numpunctIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_ZNSt3__19use_facetINS_8numpunctIwEEEERKT_RKNS_6localeE_exit
      var $44=$43;
      var $45=$3;
      __label__ = 6; break;
    case 6: // $46
      $__np=$44;
      var $47=$__np;
      var $48=$2;
      HEAP32[(($2)>>2)]=$47;
      var $49=HEAP32[(($2)>>2)];
      var $50=$49;
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51+16)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$53]($49) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 11; break; };
    case 7: // $_ZNKSt3__18numpunctIwE13thousands_sepEv_exit
      var $55=$2;
      __label__ = 8; break;
    case 8: // $56
      var $57=$11;
      HEAP32[(($57)>>2)]=$54;
      var $58=$__np;
      var $59=$1;
      HEAP32[(($1)>>2)]=$58;
      var $60=HEAP32[(($1)>>2)];
      var $61=$60;
      var $62=HEAP32[(($61)>>2)];
      var $63=(($62+20)|0);
      var $64=HEAP32[(($63)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$64]($agg_result, $60) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $_ZNKSt3__18numpunctIwE8groupingEv_exit
      var $65=$1;
      __label__ = 10; break;
    case 10: // $66
      $14=1;
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc);
      STACKTOP = __stackBase__;
      return;
    case 11: // $67
      var $68=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $69=$68.f0;
      $12=$69;
      var $70=$68.f1;
      $13=$70;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $71
      __label__ = 13; break;
    case 13: // $72
      var $73=$12;
      var $74=$12;
      var $75=$13;
      var $76=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $74, tempValue);
      var $77=($76.f1 = $75, $76);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $78
      var $79=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw["X"]=1;

function __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($__ct, $__base, $__a, $__a_end, $__dc, $__thousands_sep, $__grouping, $__g, $__g_end, $__atoms) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14;
      var $15=__stackBase__+52;
      var $16;
      var $17;
      var $18;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $24;
      var $__f;
      HEAP32[(($15)>>2)]=$__ct;
      $16=$__base;
      $17=$__a;
      $18=$__a_end;
      $19=$__dc;
      $20=$__thousands_sep;
      $21=$__grouping;
      $22=$__g;
      $23=$__g_end;
      $24=$__atoms;
      var $25=$18;
      var $26=HEAP32[(($25)>>2)];
      var $27=$17;
      var $28=(($26)|0)==(($27)|0);
      if ($28) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $29
      var $30=HEAP32[(($15)>>2)];
      var $31=$24;
      var $32=(($31+96)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=(($30)|0)==(($33)|0);
      if ($34) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $35
      var $36=HEAP32[(($15)>>2)];
      var $37=$24;
      var $38=(($37+100)|0);
      var $39=HEAP32[(($38)>>2)];
      var $40=(($36)|0)==(($39)|0);
      if ($40) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $41
      var $42=HEAP32[(($15)>>2)];
      var $43=$24;
      var $44=(($43+96)|0);
      var $45=HEAP32[(($44)>>2)];
      var $46=(($42)|0)==(($45)|0);
      var $47=$46 ? 43 : 45;
      var $48=$18;
      var $49=HEAP32[(($48)>>2)];
      var $50=(($49+1)|0);
      HEAP32[(($48)>>2)]=$50;
      HEAP8[($49)]=$47;
      var $51=$19;
      HEAP32[(($51)>>2)]=0;
      $14=0;
      __label__ = 33; break;
    case 4: // $52
      var $53=HEAP32[(($15)>>2)];
      var $54=$20;
      var $55=(($53)|0)==(($54)|0);
      if ($55) { __label__ = 5; break; } else { __label__ = 12; break; }
    case 5: // $56
      var $57=$21;
      var $58=$13;
      HEAP32[(($13)>>2)]=$57;
      var $59=HEAPU32[(($13)>>2)];
      var $60=$12;
      HEAP32[(($12)>>2)]=$59;
      var $61=HEAP32[(($12)>>2)];
      var $62=(($61)|0);
      var $63=$11;
      HEAP32[(($11)>>2)]=$62;
      var $64=HEAP32[(($11)>>2)];
      var $65=$64;
      var $66=$10;
      HEAP32[(($10)>>2)]=$65;
      var $67=HEAP32[(($10)>>2)];
      var $68=(($67)|0);
      var $69=$10;
      var $70=$11;
      var $71=(($68)|0);
      var $72=$71;
      var $73=(($72)|0);
      var $74=$73;
      var $75=HEAPU8[($74)];
      var $76=(($75)&255);
      var $77=$76 & 1;
      var $78=(($77)|0)!=0;
      var $79=$12;
      if ($78) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $80
      var $81=$6;
      HEAP32[(($6)>>2)]=$59;
      var $82=HEAP32[(($6)>>2)];
      var $83=(($82)|0);
      var $84=$5;
      HEAP32[(($5)>>2)]=$83;
      var $85=HEAP32[(($5)>>2)];
      var $86=$85;
      var $87=$4;
      HEAP32[(($4)>>2)]=$86;
      var $88=HEAP32[(($4)>>2)];
      var $89=(($88)|0);
      var $90=$4;
      var $91=$5;
      var $92=(($89)|0);
      var $93=$92;
      var $94=(($93+4)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$6;
      var $117 = $95;__label__ = 8; break;
    case 7: // $97
      var $98=$9;
      HEAP32[(($9)>>2)]=$59;
      var $99=HEAP32[(($9)>>2)];
      var $100=(($99)|0);
      var $101=$8;
      HEAP32[(($8)>>2)]=$100;
      var $102=HEAP32[(($8)>>2)];
      var $103=$102;
      var $104=$7;
      HEAP32[(($7)>>2)]=$103;
      var $105=HEAP32[(($7)>>2)];
      var $106=(($105)|0);
      var $107=$7;
      var $108=$8;
      var $109=(($106)|0);
      var $110=$109;
      var $111=(($110)|0);
      var $112=$111;
      var $113=HEAPU8[($112)];
      var $114=(($113)&255);
      var $115=$114 >> 1;
      var $116=$9;
      var $117 = $115;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $117;
      var $118=$13;
      var $119=(($117)|0)!=0;
      if ($119) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $120
      var $121=$23;
      var $122=HEAP32[(($121)>>2)];
      var $123=$22;
      var $124=$122;
      var $125=$123;
      var $126=(($124-$125)|0);
      var $127=(((($126)|0)/4)|0);
      var $128=(($127)|0) < 40;
      if ($128) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $129
      var $130=$19;
      var $131=HEAP32[(($130)>>2)];
      var $132=$23;
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+4)|0);
      HEAP32[(($132)>>2)]=$134;
      HEAP32[(($133)>>2)]=$131;
      var $135=$19;
      HEAP32[(($135)>>2)]=0;
      __label__ = 11; break;
    case 11: // $136
      $14=0;
      __label__ = 33; break;
    case 12: // $137
      var $138=$24;
      var $139=$24;
      var $140=(($139+104)|0);
      var $141=$1;
      var $142=$2;
      var $143=$3;
      HEAP32[(($1)>>2)]=$138;
      HEAP32[(($2)>>2)]=$140;
      HEAP32[(($3)>>2)]=$15;
      __label__ = 13; break;
    case 13: // $144
      var $145=HEAP32[(($1)>>2)];
      var $146=HEAP32[(($2)>>2)];
      var $147=(($145)|0)!=(($146)|0);
      if ($147) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $148
      var $149=HEAP32[(($1)>>2)];
      var $150=HEAP32[(($149)>>2)];
      var $151=HEAP32[(($3)>>2)];
      var $152=HEAP32[(($151)>>2)];
      var $153=(($150)|0)==(($152)|0);
      if ($153) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $154
      __label__ = 17; break;
    case 16: // $155
      var $156=HEAP32[(($1)>>2)];
      var $157=(($156+4)|0);
      HEAP32[(($1)>>2)]=$157;
      __label__ = 13; break;
    case 17: // $_ZNSt3__14findIPwwEET_S2_S2_RKT0__exit
      var $158=HEAP32[(($1)>>2)];
      var $159=$1;
      var $160=$2;
      var $161=$3;
      var $162=$24;
      var $163=$158;
      var $164=$162;
      var $165=(($163-$164)|0);
      var $166=(((($165)|0)/4)|0);
      $__f=$166;
      var $167=$__f;
      var $168=(($167)|0) >= 24;
      if ($168) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $169
      $14=-1;
      __label__ = 33; break;
    case 19: // $170
      var $171=$16;
      if ($171 == 8 || $171 == 10) {
        __label__ = 20; break;
      }
      else if ($171 == 16) {
        __label__ = 23; break;
      }
      else {
      __label__ = 30; break;
      }
      
    case 20: // $172
      var $173=$__f;
      var $174=$16;
      var $175=(($173)|0) >= (($174)|0);
      if ($175) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $176
      $14=-1;
      __label__ = 33; break;
    case 22: // $177
      __label__ = 30; break;
    case 23: // $178
      var $179=$__f;
      var $180=(($179)|0) < 22;
      if ($180) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $181
      __label__ = 30; break;
    case 25: // $182
      var $183=$18;
      var $184=HEAP32[(($183)>>2)];
      var $185=$17;
      var $186=(($184)|0)!=(($185)|0);
      if ($186) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $187
      var $188=$18;
      var $189=HEAP32[(($188)>>2)];
      var $190=$17;
      var $191=$189;
      var $192=$190;
      var $193=(($191-$192)|0);
      var $194=(($193)|0) <= 2;
      if ($194) { __label__ = 27; break; } else { __label__ = 29; break; }
    case 27: // $195
      var $196=$18;
      var $197=HEAP32[(($196)>>2)];
      var $198=(($197-1)|0);
      var $199=HEAP8[($198)];
      var $200=(($199 << 24) >> 24);
      var $201=(($200)|0)==48;
      if ($201) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $202
      var $203=$19;
      HEAP32[(($203)>>2)]=0;
      var $204=$__f;
      var $205=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+$204)|0);
      var $206=HEAP8[($205)];
      var $207=$18;
      var $208=HEAP32[(($207)>>2)];
      var $209=(($208+1)|0);
      HEAP32[(($207)>>2)]=$209;
      HEAP8[($208)]=$206;
      $14=0;
      __label__ = 33; break;
    case 29: // $210
      $14=-1;
      __label__ = 33; break;
    case 30: // $211
      var $212=$18;
      var $213=HEAP32[(($212)>>2)];
      var $214=$17;
      var $215=$213;
      var $216=$214;
      var $217=(($215-$216)|0);
      var $218=(($217)|0) < 39;
      if ($218) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $219
      var $220=$__f;
      var $221=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+$220)|0);
      var $222=HEAP8[($221)];
      var $223=$18;
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224+1)|0);
      HEAP32[(($223)>>2)]=$225;
      HEAP8[($224)]=$222;
      __label__ = 32; break;
    case 32: // $226
      var $227=$19;
      var $228=HEAP32[(($227)>>2)];
      var $229=(($228+1)|0);
      HEAP32[(($227)>>2)]=$229;
      $14=0;
      __label__ = 33; break;
    case 33: // $230
      var $231=$14;
      STACKTOP = __stackBase__;
      return $231;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+132;
      var $__thousands_sep=__stackBase__+236;
      var $__grouping=__stackBase__+240;
      var $__a=__stackBase__+252;
      var $__a_end=__stackBase__+292;
      var $__g=__stackBase__+296;
      var $__g_end=__stackBase__+456;
      var $__dc=__stackBase__+460;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP32[(($94)>>2)];
      var $96=$22;
      HEAP32[(($22)>>2)]=$95;
      var $97=HEAP32[(($22)>>2)];
      var $98=$22;
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $99=HEAP32[(($23)>>2)];
      var $100=$23;
      var $101=$24;
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP32[(($__thousands_sep)>>2)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($99, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAP32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+4)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP32[(($142)>>2)];
      var $145=$16;
      HEAP32[(($16)>>2)]=$144;
      var $146=HEAP32[(($16)>>2)];
      var $147=$16;
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=$18;
      var $151=(($148)|0)==-1;
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $153
      var $154=$14;
      var $155=$15;
      HEAP32[(($15)>>2)]=$125;
      var $156=HEAP32[(($15)>>2)];
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($158)|0)==(($160)|0);
      if ($161) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $162
      var $163=$156;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+36)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$166]($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$167;
      __label__ = 23; break;
    case 22: // $168
      var $169=(($156+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($170)>>2)];
      var $172=$13;
      HEAP32[(($13)>>2)]=$171;
      var $173=HEAP32[(($13)>>2)];
      var $174=$13;
      HEAP32[(($14)>>2)]=$173;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $175=HEAP32[(($14)>>2)];
      var $176=$14;
      var $177=$15;
      HEAP32[(($19)>>2)]=$175;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $178=HEAP32[(($19)>>2)];
      var $179=$19;
      var $180=$20;
      var $181=$11;
      var $182=$12;
      HEAP32[(($11)>>2)]=$178;
      HEAP32[(($12)>>2)]=-1;
      var $183=HEAP32[(($11)>>2)];
      var $184=HEAP32[(($12)>>2)];
      var $185=(($183)|0)==(($184)|0);
      var $186=$11;
      var $187=$12;
      if ($185) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $188
      var $189=(($120)|0);
      HEAP32[(($189)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $190=$21;
      __label__ = 27; break;
    case 27: // $191
      __label__ = 1; break;
    case 28: // $192
      var $193=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $194=HEAPU32[(($10)>>2)];
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196)|0);
      var $198=$8;
      HEAP32[(($8)>>2)]=$197;
      var $199=HEAP32[(($8)>>2)];
      var $200=$199;
      var $201=$7;
      HEAP32[(($7)>>2)]=$200;
      var $202=HEAP32[(($7)>>2)];
      var $203=(($202)|0);
      var $204=$7;
      var $205=$8;
      var $206=(($203)|0);
      var $207=$206;
      var $208=(($207)|0);
      var $209=$208;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$211 & 1;
      var $213=(($212)|0)!=0;
      var $214=$9;
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $215
      var $216=$3;
      HEAP32[(($3)>>2)]=$194;
      var $217=HEAP32[(($3)>>2)];
      var $218=(($217)|0);
      var $219=$2;
      HEAP32[(($2)>>2)]=$218;
      var $220=HEAP32[(($2)>>2)];
      var $221=$220;
      var $222=$1;
      HEAP32[(($1)>>2)]=$221;
      var $223=HEAP32[(($1)>>2)];
      var $224=(($223)|0);
      var $225=$1;
      var $226=$2;
      var $227=(($224)|0);
      var $228=$227;
      var $229=(($228+4)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$3;
      var $252 = $230;__label__ = 31; break;
    case 30: // $232
      var $233=$6;
      HEAP32[(($6)>>2)]=$194;
      var $234=HEAP32[(($6)>>2)];
      var $235=(($234)|0);
      var $236=$5;
      HEAP32[(($5)>>2)]=$235;
      var $237=HEAP32[(($5)>>2)];
      var $238=$237;
      var $239=$4;
      HEAP32[(($4)>>2)]=$238;
      var $240=HEAP32[(($4)>>2)];
      var $241=(($240)|0);
      var $242=$4;
      var $243=$5;
      var $244=(($241)|0);
      var $245=$244;
      var $246=(($245)|0);
      var $247=$246;
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$249 >> 1;
      var $251=$6;
      var $252 = $250;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $252;
      var $253=$10;
      var $254=(($252)|0)!=0;
      if ($254) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $255
      var $256=HEAP32[(($__g_end)>>2)];
      var $257=(($__g)|0);
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(((($260)|0)/4)|0);
      var $262=(($261)|0) < 40;
      if ($262) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $263
      var $264=HEAP32[(($__dc)>>2)];
      var $265=HEAP32[(($__g_end)>>2)];
      var $266=(($265+4)|0);
      HEAP32[(($__g_end)>>2)]=$266;
      HEAP32[(($265)>>2)]=$264;
      __label__ = 34; break;
    case 34: // $267
      var $268=(($__a)|0);
      var $269=HEAP32[(($__a_end)>>2)];
      var $270=$36;
      var $271=$__base;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji($268, $269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
      var $272$0=$272[0];
      var $272$1=$272[1];
    case 35: // $273
      var $274=$37;
      var $st$1$0=(($274)|0);
      HEAP32[(($st$1$0)>>2)]=$272$0;
      var $st$1$1=(($274+4)|0);
      HEAP32[(($st$1$1)>>2)]=$272$1;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 37; break;
    case 37: // $300
      if ($295) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 39; break;
    case 39: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $308
      __label__ = 41; break;
    case 41: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+132;
      var $__thousands_sep=__stackBase__+236;
      var $__grouping=__stackBase__+240;
      var $__a=__stackBase__+252;
      var $__a_end=__stackBase__+292;
      var $__g=__stackBase__+296;
      var $__g_end=__stackBase__+456;
      var $__dc=__stackBase__+460;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP32[(($94)>>2)];
      var $96=$22;
      HEAP32[(($22)>>2)]=$95;
      var $97=HEAP32[(($22)>>2)];
      var $98=$22;
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $99=HEAP32[(($23)>>2)];
      var $100=$23;
      var $101=$24;
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP32[(($__thousands_sep)>>2)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($99, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAP32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+4)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP32[(($142)>>2)];
      var $145=$16;
      HEAP32[(($16)>>2)]=$144;
      var $146=HEAP32[(($16)>>2)];
      var $147=$16;
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=$18;
      var $151=(($148)|0)==-1;
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $153
      var $154=$14;
      var $155=$15;
      HEAP32[(($15)>>2)]=$125;
      var $156=HEAP32[(($15)>>2)];
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($158)|0)==(($160)|0);
      if ($161) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $162
      var $163=$156;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+36)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$166]($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$167;
      __label__ = 23; break;
    case 22: // $168
      var $169=(($156+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($170)>>2)];
      var $172=$13;
      HEAP32[(($13)>>2)]=$171;
      var $173=HEAP32[(($13)>>2)];
      var $174=$13;
      HEAP32[(($14)>>2)]=$173;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $175=HEAP32[(($14)>>2)];
      var $176=$14;
      var $177=$15;
      HEAP32[(($19)>>2)]=$175;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $178=HEAP32[(($19)>>2)];
      var $179=$19;
      var $180=$20;
      var $181=$11;
      var $182=$12;
      HEAP32[(($11)>>2)]=$178;
      HEAP32[(($12)>>2)]=-1;
      var $183=HEAP32[(($11)>>2)];
      var $184=HEAP32[(($12)>>2)];
      var $185=(($183)|0)==(($184)|0);
      var $186=$11;
      var $187=$12;
      if ($185) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $188
      var $189=(($120)|0);
      HEAP32[(($189)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $190=$21;
      __label__ = 27; break;
    case 27: // $191
      __label__ = 1; break;
    case 28: // $192
      var $193=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $194=HEAPU32[(($10)>>2)];
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196)|0);
      var $198=$8;
      HEAP32[(($8)>>2)]=$197;
      var $199=HEAP32[(($8)>>2)];
      var $200=$199;
      var $201=$7;
      HEAP32[(($7)>>2)]=$200;
      var $202=HEAP32[(($7)>>2)];
      var $203=(($202)|0);
      var $204=$7;
      var $205=$8;
      var $206=(($203)|0);
      var $207=$206;
      var $208=(($207)|0);
      var $209=$208;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$211 & 1;
      var $213=(($212)|0)!=0;
      var $214=$9;
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $215
      var $216=$3;
      HEAP32[(($3)>>2)]=$194;
      var $217=HEAP32[(($3)>>2)];
      var $218=(($217)|0);
      var $219=$2;
      HEAP32[(($2)>>2)]=$218;
      var $220=HEAP32[(($2)>>2)];
      var $221=$220;
      var $222=$1;
      HEAP32[(($1)>>2)]=$221;
      var $223=HEAP32[(($1)>>2)];
      var $224=(($223)|0);
      var $225=$1;
      var $226=$2;
      var $227=(($224)|0);
      var $228=$227;
      var $229=(($228+4)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$3;
      var $252 = $230;__label__ = 31; break;
    case 30: // $232
      var $233=$6;
      HEAP32[(($6)>>2)]=$194;
      var $234=HEAP32[(($6)>>2)];
      var $235=(($234)|0);
      var $236=$5;
      HEAP32[(($5)>>2)]=$235;
      var $237=HEAP32[(($5)>>2)];
      var $238=$237;
      var $239=$4;
      HEAP32[(($4)>>2)]=$238;
      var $240=HEAP32[(($4)>>2)];
      var $241=(($240)|0);
      var $242=$4;
      var $243=$5;
      var $244=(($241)|0);
      var $245=$244;
      var $246=(($245)|0);
      var $247=$246;
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$249 >> 1;
      var $251=$6;
      var $252 = $250;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $252;
      var $253=$10;
      var $254=(($252)|0)!=0;
      if ($254) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $255
      var $256=HEAP32[(($__g_end)>>2)];
      var $257=(($__g)|0);
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(((($260)|0)/4)|0);
      var $262=(($261)|0) < 40;
      if ($262) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $263
      var $264=HEAP32[(($__dc)>>2)];
      var $265=HEAP32[(($__g_end)>>2)];
      var $266=(($265+4)|0);
      HEAP32[(($__g_end)>>2)]=$266;
      HEAP32[(($265)>>2)]=$264;
      __label__ = 34; break;
    case 34: // $267
      var $268=(($__a)|0);
      var $269=HEAP32[(($__a_end)>>2)];
      var $270=$36;
      var $271=$__base;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji($268, $269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $273
      var $274=$37;
      HEAP16[(($274)>>1)]=$272;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 37; break;
    case 37: // $300
      if ($295) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 39; break;
    case 39: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $308
      __label__ = 41; break;
    case 41: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+132;
      var $__thousands_sep=__stackBase__+236;
      var $__grouping=__stackBase__+240;
      var $__a=__stackBase__+252;
      var $__a_end=__stackBase__+292;
      var $__g=__stackBase__+296;
      var $__g_end=__stackBase__+456;
      var $__dc=__stackBase__+460;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP32[(($94)>>2)];
      var $96=$22;
      HEAP32[(($22)>>2)]=$95;
      var $97=HEAP32[(($22)>>2)];
      var $98=$22;
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $99=HEAP32[(($23)>>2)];
      var $100=$23;
      var $101=$24;
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP32[(($__thousands_sep)>>2)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($99, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAP32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+4)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP32[(($142)>>2)];
      var $145=$16;
      HEAP32[(($16)>>2)]=$144;
      var $146=HEAP32[(($16)>>2)];
      var $147=$16;
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=$18;
      var $151=(($148)|0)==-1;
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $153
      var $154=$14;
      var $155=$15;
      HEAP32[(($15)>>2)]=$125;
      var $156=HEAP32[(($15)>>2)];
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($158)|0)==(($160)|0);
      if ($161) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $162
      var $163=$156;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+36)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$166]($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$167;
      __label__ = 23; break;
    case 22: // $168
      var $169=(($156+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($170)>>2)];
      var $172=$13;
      HEAP32[(($13)>>2)]=$171;
      var $173=HEAP32[(($13)>>2)];
      var $174=$13;
      HEAP32[(($14)>>2)]=$173;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $175=HEAP32[(($14)>>2)];
      var $176=$14;
      var $177=$15;
      HEAP32[(($19)>>2)]=$175;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $178=HEAP32[(($19)>>2)];
      var $179=$19;
      var $180=$20;
      var $181=$11;
      var $182=$12;
      HEAP32[(($11)>>2)]=$178;
      HEAP32[(($12)>>2)]=-1;
      var $183=HEAP32[(($11)>>2)];
      var $184=HEAP32[(($12)>>2)];
      var $185=(($183)|0)==(($184)|0);
      var $186=$11;
      var $187=$12;
      if ($185) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $188
      var $189=(($120)|0);
      HEAP32[(($189)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $190=$21;
      __label__ = 27; break;
    case 27: // $191
      __label__ = 1; break;
    case 28: // $192
      var $193=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $194=HEAPU32[(($10)>>2)];
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196)|0);
      var $198=$8;
      HEAP32[(($8)>>2)]=$197;
      var $199=HEAP32[(($8)>>2)];
      var $200=$199;
      var $201=$7;
      HEAP32[(($7)>>2)]=$200;
      var $202=HEAP32[(($7)>>2)];
      var $203=(($202)|0);
      var $204=$7;
      var $205=$8;
      var $206=(($203)|0);
      var $207=$206;
      var $208=(($207)|0);
      var $209=$208;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$211 & 1;
      var $213=(($212)|0)!=0;
      var $214=$9;
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $215
      var $216=$3;
      HEAP32[(($3)>>2)]=$194;
      var $217=HEAP32[(($3)>>2)];
      var $218=(($217)|0);
      var $219=$2;
      HEAP32[(($2)>>2)]=$218;
      var $220=HEAP32[(($2)>>2)];
      var $221=$220;
      var $222=$1;
      HEAP32[(($1)>>2)]=$221;
      var $223=HEAP32[(($1)>>2)];
      var $224=(($223)|0);
      var $225=$1;
      var $226=$2;
      var $227=(($224)|0);
      var $228=$227;
      var $229=(($228+4)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$3;
      var $252 = $230;__label__ = 31; break;
    case 30: // $232
      var $233=$6;
      HEAP32[(($6)>>2)]=$194;
      var $234=HEAP32[(($6)>>2)];
      var $235=(($234)|0);
      var $236=$5;
      HEAP32[(($5)>>2)]=$235;
      var $237=HEAP32[(($5)>>2)];
      var $238=$237;
      var $239=$4;
      HEAP32[(($4)>>2)]=$238;
      var $240=HEAP32[(($4)>>2)];
      var $241=(($240)|0);
      var $242=$4;
      var $243=$5;
      var $244=(($241)|0);
      var $245=$244;
      var $246=(($245)|0);
      var $247=$246;
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$249 >> 1;
      var $251=$6;
      var $252 = $250;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $252;
      var $253=$10;
      var $254=(($252)|0)!=0;
      if ($254) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $255
      var $256=HEAP32[(($__g_end)>>2)];
      var $257=(($__g)|0);
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(((($260)|0)/4)|0);
      var $262=(($261)|0) < 40;
      if ($262) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $263
      var $264=HEAP32[(($__dc)>>2)];
      var $265=HEAP32[(($__g_end)>>2)];
      var $266=(($265+4)|0);
      HEAP32[(($__g_end)>>2)]=$266;
      HEAP32[(($265)>>2)]=$264;
      __label__ = 34; break;
    case 34: // $267
      var $268=(($__a)|0);
      var $269=HEAP32[(($__a_end)>>2)];
      var $270=$36;
      var $271=$__base;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji($268, $269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $273
      var $274=$37;
      HEAP32[(($274)>>2)]=$272;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 37; break;
    case 37: // $300
      if ($295) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 39; break;
    case 39: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $308
      __label__ = 41; break;
    case 41: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+132;
      var $__thousands_sep=__stackBase__+236;
      var $__grouping=__stackBase__+240;
      var $__a=__stackBase__+252;
      var $__a_end=__stackBase__+292;
      var $__g=__stackBase__+296;
      var $__g_end=__stackBase__+456;
      var $__dc=__stackBase__+460;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP32[(($94)>>2)];
      var $96=$22;
      HEAP32[(($22)>>2)]=$95;
      var $97=HEAP32[(($22)>>2)];
      var $98=$22;
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $99=HEAP32[(($23)>>2)];
      var $100=$23;
      var $101=$24;
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP32[(($__thousands_sep)>>2)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($99, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAP32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+4)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP32[(($142)>>2)];
      var $145=$16;
      HEAP32[(($16)>>2)]=$144;
      var $146=HEAP32[(($16)>>2)];
      var $147=$16;
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=$18;
      var $151=(($148)|0)==-1;
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $153
      var $154=$14;
      var $155=$15;
      HEAP32[(($15)>>2)]=$125;
      var $156=HEAP32[(($15)>>2)];
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($158)|0)==(($160)|0);
      if ($161) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $162
      var $163=$156;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+36)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$166]($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$167;
      __label__ = 23; break;
    case 22: // $168
      var $169=(($156+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($170)>>2)];
      var $172=$13;
      HEAP32[(($13)>>2)]=$171;
      var $173=HEAP32[(($13)>>2)];
      var $174=$13;
      HEAP32[(($14)>>2)]=$173;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $175=HEAP32[(($14)>>2)];
      var $176=$14;
      var $177=$15;
      HEAP32[(($19)>>2)]=$175;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $178=HEAP32[(($19)>>2)];
      var $179=$19;
      var $180=$20;
      var $181=$11;
      var $182=$12;
      HEAP32[(($11)>>2)]=$178;
      HEAP32[(($12)>>2)]=-1;
      var $183=HEAP32[(($11)>>2)];
      var $184=HEAP32[(($12)>>2)];
      var $185=(($183)|0)==(($184)|0);
      var $186=$11;
      var $187=$12;
      if ($185) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $188
      var $189=(($120)|0);
      HEAP32[(($189)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $190=$21;
      __label__ = 27; break;
    case 27: // $191
      __label__ = 1; break;
    case 28: // $192
      var $193=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $194=HEAPU32[(($10)>>2)];
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196)|0);
      var $198=$8;
      HEAP32[(($8)>>2)]=$197;
      var $199=HEAP32[(($8)>>2)];
      var $200=$199;
      var $201=$7;
      HEAP32[(($7)>>2)]=$200;
      var $202=HEAP32[(($7)>>2)];
      var $203=(($202)|0);
      var $204=$7;
      var $205=$8;
      var $206=(($203)|0);
      var $207=$206;
      var $208=(($207)|0);
      var $209=$208;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$211 & 1;
      var $213=(($212)|0)!=0;
      var $214=$9;
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $215
      var $216=$3;
      HEAP32[(($3)>>2)]=$194;
      var $217=HEAP32[(($3)>>2)];
      var $218=(($217)|0);
      var $219=$2;
      HEAP32[(($2)>>2)]=$218;
      var $220=HEAP32[(($2)>>2)];
      var $221=$220;
      var $222=$1;
      HEAP32[(($1)>>2)]=$221;
      var $223=HEAP32[(($1)>>2)];
      var $224=(($223)|0);
      var $225=$1;
      var $226=$2;
      var $227=(($224)|0);
      var $228=$227;
      var $229=(($228+4)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$3;
      var $252 = $230;__label__ = 31; break;
    case 30: // $232
      var $233=$6;
      HEAP32[(($6)>>2)]=$194;
      var $234=HEAP32[(($6)>>2)];
      var $235=(($234)|0);
      var $236=$5;
      HEAP32[(($5)>>2)]=$235;
      var $237=HEAP32[(($5)>>2)];
      var $238=$237;
      var $239=$4;
      HEAP32[(($4)>>2)]=$238;
      var $240=HEAP32[(($4)>>2)];
      var $241=(($240)|0);
      var $242=$4;
      var $243=$5;
      var $244=(($241)|0);
      var $245=$244;
      var $246=(($245)|0);
      var $247=$246;
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$249 >> 1;
      var $251=$6;
      var $252 = $250;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $252;
      var $253=$10;
      var $254=(($252)|0)!=0;
      if ($254) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $255
      var $256=HEAP32[(($__g_end)>>2)];
      var $257=(($__g)|0);
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(((($260)|0)/4)|0);
      var $262=(($261)|0) < 40;
      if ($262) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $263
      var $264=HEAP32[(($__dc)>>2)];
      var $265=HEAP32[(($__g_end)>>2)];
      var $266=(($265+4)|0);
      HEAP32[(($__g_end)>>2)]=$266;
      HEAP32[(($265)>>2)]=$264;
      __label__ = 34; break;
    case 34: // $267
      var $268=(($__a)|0);
      var $269=HEAP32[(($__a_end)>>2)];
      var $270=$36;
      var $271=$__base;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji($268, $269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
    case 35: // $273
      var $274=$37;
      HEAP32[(($274)>>2)]=$272;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 37; break;
    case 37: // $300
      if ($295) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 39; break;
    case 39: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $308
      __label__ = 41; break;
    case 41: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__base;
      var $__atoms=__stackBase__+132;
      var $__thousands_sep=__stackBase__+236;
      var $__grouping=__stackBase__+240;
      var $__a=__stackBase__+252;
      var $__a_end=__stackBase__+292;
      var $__g=__stackBase__+296;
      var $__g_end=__stackBase__+456;
      var $__dc=__stackBase__+460;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE($42);
      $__base=$43;
      var $44=$35;
      var $45=(($__atoms)|0);
      __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw($__grouping, $44, $45, $__thousands_sep);
      var $46=$__a;
      _memset($46, 0, 40, 1);
      var $47=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$47;
      var $48=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$48;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=$32;
      var $51=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $52=HEAP32[(($32)>>2)];
      var $53=HEAP32[(($33)>>2)];
      var $54=$30;
      var $55=$31;
      HEAP32[(($30)>>2)]=$52;
      HEAP32[(($31)>>2)]=$53;
      var $56=HEAP32[(($30)>>2)];
      var $57=(($56)|0);
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58)|0)==0;
      var $60=(($59)&1);
      var $61=HEAP32[(($31)>>2)];
      var $62=(($61)|0);
      var $63=HEAP32[(($62)>>2)];
      var $64=(($63)|0)==0;
      var $65=(($64)&1);
      var $66=(($60)|0)==(($65)|0);
      var $67=$30;
      var $68=$31;
      var $69=$66 ^ 1;
      var $70=$32;
      var $71=$33;
      __label__ = 2; break;
    case 2: // $72
      if ($69) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $73
      var $74=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $75=HEAP32[(($25)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=$23;
      var $79=$24;
      HEAP32[(($24)>>2)]=$77;
      var $80=HEAP32[(($24)>>2)];
      var $81=(($80+12)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80+16)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $86
      var $87=$80;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+36)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$90]($80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$91;
      __label__ = 7; break;
    case 6: // $92
      var $93=(($80+12)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=HEAP32[(($94)>>2)];
      var $96=$22;
      HEAP32[(($22)>>2)]=$95;
      var $97=HEAP32[(($22)>>2)];
      var $98=$22;
      HEAP32[(($23)>>2)]=$97;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $99=HEAP32[(($23)>>2)];
      var $100=$23;
      var $101=$24;
      var $102=$25;
      __label__ = 8; break;
    case 8: // $103
      var $104=$__base;
      var $105=(($__a)|0);
      var $106=HEAP32[(($__thousands_sep)>>2)];
      var $107=(($__g)|0);
      var $108=(($__atoms)|0);
      var $109=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($99, $104, $105, $__a_end, $__dc, $106, $__grouping, $107, $__g_end, $108) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $110
      var $111=(($109)|0)!=0;
      if ($111) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $112
      __label__ = 28; break;
    case 11: // $113
      var $114=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $115=$114.f0;
      $38=$115;
      var $116=$114.f1;
      $39=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 12: // $117
      __label__ = 13; break;
    case 13: // $118
      var $119=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $120=HEAPU32[(($21)>>2)];
      var $121=(($120)|0);
      var $122=HEAP32[(($121)>>2)];
      var $123=$19;
      var $124=$20;
      HEAP32[(($20)>>2)]=$122;
      var $125=HEAP32[(($20)>>2)];
      var $126=$17;
      var $127=$18;
      HEAP32[(($18)>>2)]=$125;
      var $128=HEAP32[(($18)>>2)];
      var $129=(($128+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128+16)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=(($130)|0)==(($132)|0);
      if ($133) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $134
      var $135=$128;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+40)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$138]($128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$139;
      __label__ = 17; break;
    case 16: // $140
      var $141=(($128+12)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=(($142+4)|0);
      HEAP32[(($141)>>2)]=$143;
      var $144=HEAP32[(($142)>>2)];
      var $145=$16;
      HEAP32[(($16)>>2)]=$144;
      var $146=HEAP32[(($16)>>2)];
      var $147=$16;
      HEAP32[(($17)>>2)]=$146;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $148=HEAP32[(($17)>>2)];
      var $149=$17;
      var $150=$18;
      var $151=(($148)|0)==-1;
      if ($151) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $152
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $153
      var $154=$14;
      var $155=$15;
      HEAP32[(($15)>>2)]=$125;
      var $156=HEAP32[(($15)>>2)];
      var $157=(($156+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156+16)|0);
      var $160=HEAP32[(($159)>>2)];
      var $161=(($158)|0)==(($160)|0);
      if ($161) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $162
      var $163=$156;
      var $164=HEAP32[(($163)>>2)];
      var $165=(($164+36)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$166]($156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$167;
      __label__ = 23; break;
    case 22: // $168
      var $169=(($156+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=HEAP32[(($170)>>2)];
      var $172=$13;
      HEAP32[(($13)>>2)]=$171;
      var $173=HEAP32[(($13)>>2)];
      var $174=$13;
      HEAP32[(($14)>>2)]=$173;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $175=HEAP32[(($14)>>2)];
      var $176=$14;
      var $177=$15;
      HEAP32[(($19)>>2)]=$175;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $178=HEAP32[(($19)>>2)];
      var $179=$19;
      var $180=$20;
      var $181=$11;
      var $182=$12;
      HEAP32[(($11)>>2)]=$178;
      HEAP32[(($12)>>2)]=-1;
      var $183=HEAP32[(($11)>>2)];
      var $184=HEAP32[(($12)>>2)];
      var $185=(($183)|0)==(($184)|0);
      var $186=$11;
      var $187=$12;
      if ($185) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $188
      var $189=(($120)|0);
      HEAP32[(($189)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $190=$21;
      __label__ = 27; break;
    case 27: // $191
      __label__ = 1; break;
    case 28: // $192
      var $193=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $194=HEAPU32[(($10)>>2)];
      var $195=$9;
      HEAP32[(($9)>>2)]=$194;
      var $196=HEAP32[(($9)>>2)];
      var $197=(($196)|0);
      var $198=$8;
      HEAP32[(($8)>>2)]=$197;
      var $199=HEAP32[(($8)>>2)];
      var $200=$199;
      var $201=$7;
      HEAP32[(($7)>>2)]=$200;
      var $202=HEAP32[(($7)>>2)];
      var $203=(($202)|0);
      var $204=$7;
      var $205=$8;
      var $206=(($203)|0);
      var $207=$206;
      var $208=(($207)|0);
      var $209=$208;
      var $210=HEAPU8[($209)];
      var $211=(($210)&255);
      var $212=$211 & 1;
      var $213=(($212)|0)!=0;
      var $214=$9;
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $215
      var $216=$3;
      HEAP32[(($3)>>2)]=$194;
      var $217=HEAP32[(($3)>>2)];
      var $218=(($217)|0);
      var $219=$2;
      HEAP32[(($2)>>2)]=$218;
      var $220=HEAP32[(($2)>>2)];
      var $221=$220;
      var $222=$1;
      HEAP32[(($1)>>2)]=$221;
      var $223=HEAP32[(($1)>>2)];
      var $224=(($223)|0);
      var $225=$1;
      var $226=$2;
      var $227=(($224)|0);
      var $228=$227;
      var $229=(($228+4)|0);
      var $230=HEAP32[(($229)>>2)];
      var $231=$3;
      var $252 = $230;__label__ = 31; break;
    case 30: // $232
      var $233=$6;
      HEAP32[(($6)>>2)]=$194;
      var $234=HEAP32[(($6)>>2)];
      var $235=(($234)|0);
      var $236=$5;
      HEAP32[(($5)>>2)]=$235;
      var $237=HEAP32[(($5)>>2)];
      var $238=$237;
      var $239=$4;
      HEAP32[(($4)>>2)]=$238;
      var $240=HEAP32[(($4)>>2)];
      var $241=(($240)|0);
      var $242=$4;
      var $243=$5;
      var $244=(($241)|0);
      var $245=$244;
      var $246=(($245)|0);
      var $247=$246;
      var $248=HEAPU8[($247)];
      var $249=(($248)&255);
      var $250=$249 >> 1;
      var $251=$6;
      var $252 = $250;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $252;
      var $253=$10;
      var $254=(($252)|0)!=0;
      if ($254) { __label__ = 32; break; } else { __label__ = 34; break; }
    case 32: // $255
      var $256=HEAP32[(($__g_end)>>2)];
      var $257=(($__g)|0);
      var $258=$256;
      var $259=$257;
      var $260=(($258-$259)|0);
      var $261=(((($260)|0)/4)|0);
      var $262=(($261)|0) < 40;
      if ($262) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $263
      var $264=HEAP32[(($__dc)>>2)];
      var $265=HEAP32[(($__g_end)>>2)];
      var $266=(($265+4)|0);
      HEAP32[(($__g_end)>>2)]=$266;
      HEAP32[(($265)>>2)]=$264;
      __label__ = 34; break;
    case 34: // $267
      var $268=(($__a)|0);
      var $269=HEAP32[(($__a_end)>>2)];
      var $270=$36;
      var $271=$__base;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji($268, $269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 11; break; };
      var $272$0=$272[0];
      var $272$1=$272[1];
    case 35: // $273
      var $274=$37;
      var $st$1$0=(($274)|0);
      HEAP32[(($st$1$0)>>2)]=$272$0;
      var $st$1$1=(($274+4)|0);
      HEAP32[(($st$1$1)>>2)]=$272$1;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; }
    case 36: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 37; break;
    case 37: // $300
      if ($295) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 39; break;
    case 39: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 40: // $308
      __label__ = 41; break;
    case 41: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 42: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 500; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__atoms=__stackBase__+132;
      var $__decimal_point=__stackBase__+260;
      var $__thousands_sep=__stackBase__+264;
      var $__grouping=__stackBase__+268;
      var $__a=__stackBase__+280;
      var $__a_end=__stackBase__+320;
      var $__g=__stackBase__+324;
      var $__g_end=__stackBase__+484;
      var $__dc=__stackBase__+488;
      var $__in_units=__stackBase__+492;
      var $__exp=__stackBase__+496;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=(($__atoms)|0);
      __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($__grouping, $42, $43, $__decimal_point, $__thousands_sep);
      var $44=$__a;
      _memset($44, 0, 40, 1);
      var $45=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$45;
      var $46=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$46;
      HEAP32[(($__dc)>>2)]=0;
      HEAP8[($__in_units)]=1;
      HEAP8[($__exp)]=69;
      __label__ = 1; break;
    case 1: // $47
      var $48=$32;
      var $49=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $50=HEAP32[(($32)>>2)];
      var $51=HEAP32[(($33)>>2)];
      var $52=$30;
      var $53=$31;
      HEAP32[(($30)>>2)]=$50;
      HEAP32[(($31)>>2)]=$51;
      var $54=HEAP32[(($30)>>2)];
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      var $58=(($57)&1);
      var $59=HEAP32[(($31)>>2)];
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      var $63=(($62)&1);
      var $64=(($58)|0)==(($63)|0);
      var $65=$30;
      var $66=$31;
      var $67=$64 ^ 1;
      var $68=$32;
      var $69=$33;
      __label__ = 2; break;
    case 2: // $70
      if ($67) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $71
      var $72=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $73=HEAP32[(($25)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$23;
      var $77=$24;
      HEAP32[(($24)>>2)]=$75;
      var $78=HEAP32[(($24)>>2)];
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78+16)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0)==(($82)|0);
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$78;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+36)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$89;
      __label__ = 7; break;
    case 6: // $90
      var $91=(($78+12)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP32[(($92)>>2)];
      var $94=$22;
      HEAP32[(($22)>>2)]=$93;
      var $95=HEAP32[(($22)>>2)];
      var $96=$22;
      HEAP32[(($23)>>2)]=$95;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $97=HEAP32[(($23)>>2)];
      var $98=$23;
      var $99=$24;
      var $100=$25;
      __label__ = 8; break;
    case 8: // $101
      var $102=(($__a)|0);
      var $103=HEAP32[(($__decimal_point)>>2)];
      var $104=HEAP32[(($__thousands_sep)>>2)];
      var $105=(($__g)|0);
      var $106=(($__atoms)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($97, $__in_units, $__exp, $102, $__a_end, $103, $104, $__grouping, $105, $__g_end, $__dc, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $110
      __label__ = 28; break;
    case 11: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $38=$113;
      var $114=$112.f1;
      $39=$114;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 12: // $115
      __label__ = 13; break;
    case 13: // $116
      var $117=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $118=HEAPU32[(($21)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$19;
      var $122=$20;
      HEAP32[(($20)>>2)]=$120;
      var $123=HEAP32[(($20)>>2)];
      var $124=$17;
      var $125=$18;
      HEAP32[(($18)>>2)]=$123;
      var $126=HEAP32[(($18)>>2)];
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($126+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0)==(($130)|0);
      if ($131) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $132
      var $133=$126;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+40)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$136]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$137;
      __label__ = 17; break;
    case 16: // $138
      var $139=(($126+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+4)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=HEAP32[(($140)>>2)];
      var $143=$16;
      HEAP32[(($16)>>2)]=$142;
      var $144=HEAP32[(($16)>>2)];
      var $145=$16;
      HEAP32[(($17)>>2)]=$144;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $146=HEAP32[(($17)>>2)];
      var $147=$17;
      var $148=$18;
      var $149=(($146)|0)==-1;
      if ($149) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $150
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $151
      var $152=$14;
      var $153=$15;
      HEAP32[(($15)>>2)]=$123;
      var $154=HEAP32[(($15)>>2)];
      var $155=(($154+12)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($154+16)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156)|0)==(($158)|0);
      if ($159) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $160
      var $161=$154;
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+36)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$164]($154) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$165;
      __label__ = 23; break;
    case 22: // $166
      var $167=(($154+12)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=HEAP32[(($168)>>2)];
      var $170=$13;
      HEAP32[(($13)>>2)]=$169;
      var $171=HEAP32[(($13)>>2)];
      var $172=$13;
      HEAP32[(($14)>>2)]=$171;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($118)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $253
      var $254=HEAP8[($__in_units)];
      var $255=(($254) & 1);
      if ($255) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $256
      var $257=HEAP32[(($__g_end)>>2)];
      var $258=(($__g)|0);
      var $259=$257;
      var $260=$258;
      var $261=(($259-$260)|0);
      var $262=(((($261)|0)/4)|0);
      var $263=(($262)|0) < 40;
      if ($263) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $264
      var $265=HEAP32[(($__dc)>>2)];
      var $266=HEAP32[(($__g_end)>>2)];
      var $267=(($266+4)|0);
      HEAP32[(($__g_end)>>2)]=$267;
      HEAP32[(($266)>>2)]=$265;
      __label__ = 35; break;
    case 35: // $268
      var $269=(($__a)|0);
      var $270=HEAP32[(($__a_end)>>2)];
      var $271=$36;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj($269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; };
    case 36: // $273
      var $274=$37;
      HEAPF32[(($274)>>2)]=$272;
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 11; break; }
    case 37: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 38; break;
    case 38: // $300
      if ($295) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 40; break;
    case 40: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 41: // $308
      __label__ = 42; break;
    case 42: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf["X"]=1;

function __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($agg_result, $__iob, $__atoms, $__decimal_point, $__thousands_sep) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      var $13;
      var $__loc=__stackBase__+36;
      var $14;
      var $15;
      var $__np;
      var $16;
      $10=$__iob;
      $11=$__atoms;
      $12=$__decimal_point;
      $13=$__thousands_sep;
      var $17=$10;
      __ZNKSt3__18ios_base6getlocEv($__loc, $17);
      var $18=$9;
      HEAP32[(($9)>>2)]=$__loc;
      var $19=HEAP32[(($9)>>2)];
      var $20=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($19, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 13; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $21=$20;
      var $22=$9;
      __label__ = 2; break;
    case 2: // $23
      var $24=$11;
      var $25=$5;
      var $26=$6;
      var $27=$7;
      var $28=$8;
      HEAP32[(($5)>>2)]=$21;
      HEAP32[(($6)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE)|0);
      HEAP32[(($7)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+32)|0);
      HEAP32[(($8)>>2)]=$24;
      var $29=HEAP32[(($5)>>2)];
      var $30=$29;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+48)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=HEAP32[(($6)>>2)];
      var $35=HEAP32[(($7)>>2)];
      var $36=HEAP32[(($8)>>2)];
      var $37=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$33]($29, $34, $35, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 13; break; };
    case 3: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $38=$5;
      var $39=$6;
      var $40=$7;
      var $41=$8;
      __label__ = 4; break;
    case 4: // $42
      var $43=$4;
      HEAP32[(($4)>>2)]=$__loc;
      var $44=HEAP32[(($4)>>2)];
      var $45=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($44, __ZNSt3__18numpunctIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 13; break; };
    case 5: // $_ZNSt3__19use_facetINS_8numpunctIwEEEERKT_RKNS_6localeE_exit
      var $46=$45;
      var $47=$4;
      __label__ = 6; break;
    case 6: // $48
      $__np=$46;
      var $49=$__np;
      var $50=$3;
      HEAP32[(($3)>>2)]=$49;
      var $51=HEAP32[(($3)>>2)];
      var $52=$51;
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+12)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$55]($51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 13; break; };
    case 7: // $_ZNKSt3__18numpunctIwE13decimal_pointEv_exit
      var $57=$3;
      __label__ = 8; break;
    case 8: // $58
      var $59=$12;
      HEAP32[(($59)>>2)]=$56;
      var $60=$__np;
      var $61=$2;
      HEAP32[(($2)>>2)]=$60;
      var $62=HEAP32[(($2)>>2)];
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+16)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$66]($62) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 13; break; };
    case 9: // $_ZNKSt3__18numpunctIwE13thousands_sepEv_exit
      var $68=$2;
      __label__ = 10; break;
    case 10: // $69
      var $70=$13;
      HEAP32[(($70)>>2)]=$67;
      var $71=$__np;
      var $72=$1;
      HEAP32[(($1)>>2)]=$71;
      var $73=HEAP32[(($1)>>2)];
      var $74=$73;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+20)|0);
      var $77=HEAP32[(($76)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$77]($agg_result, $73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $_ZNKSt3__18numpunctIwE8groupingEv_exit
      var $78=$1;
      __label__ = 12; break;
    case 12: // $79
      $16=1;
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc);
      STACKTOP = __stackBase__;
      return;
    case 13: // $80
      var $81=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $82=$81.f0;
      $14=$82;
      var $83=$81.f1;
      $15=$83;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $84
      __label__ = 15; break;
    case 15: // $85
      var $86=$14;
      var $87=$14;
      var $88=$15;
      var $89=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $87, tempValue);
      var $90=($89.f1 = $88, $89);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 16: // $91
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_["X"]=1;

function __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($__ct, $__in_units, $__exp, $__a, $__a_end, $__decimal_point, $__thousands_sep, $__grouping, $__g, $__g_end, $__dc, $__atoms) {
  var __stackBase__  = STACKTOP; STACKTOP += 136; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35=__stackBase__+132;
      var $36;
      var $37;
      var $38;
      var $39;
      var $40;
      var $41;
      var $42;
      var $43;
      var $44;
      var $45;
      var $46;
      var $__f;
      var $__x;
      HEAP32[(($35)>>2)]=$__ct;
      $36=$__in_units;
      $37=$__exp;
      $38=$__a;
      $39=$__a_end;
      $40=$__decimal_point;
      $41=$__thousands_sep;
      $42=$__grouping;
      $43=$__g;
      $44=$__g_end;
      $45=$__dc;
      $46=$__atoms;
      var $47=HEAP32[(($35)>>2)];
      var $48=$40;
      var $49=(($47)|0)==(($48)|0);
      if ($49) { __label__ = 1; break; } else { __label__ = 10; break; }
    case 1: // $50
      var $51=$36;
      var $52=HEAP8[($51)];
      var $53=(($52) & 1);
      if ($53) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $54
      $34=-1;
      __label__ = 44; break;
    case 3: // $55
      var $56=$36;
      HEAP8[($56)]=0;
      var $57=$39;
      var $58=HEAP32[(($57)>>2)];
      var $59=(($58+1)|0);
      HEAP32[(($57)>>2)]=$59;
      HEAP8[($58)]=46;
      var $60=$42;
      var $61=$33;
      HEAP32[(($33)>>2)]=$60;
      var $62=HEAPU32[(($33)>>2)];
      var $63=$32;
      HEAP32[(($32)>>2)]=$62;
      var $64=HEAP32[(($32)>>2)];
      var $65=(($64)|0);
      var $66=$31;
      HEAP32[(($31)>>2)]=$65;
      var $67=HEAP32[(($31)>>2)];
      var $68=$67;
      var $69=$30;
      HEAP32[(($30)>>2)]=$68;
      var $70=HEAP32[(($30)>>2)];
      var $71=(($70)|0);
      var $72=$30;
      var $73=$31;
      var $74=(($71)|0);
      var $75=$74;
      var $76=(($75)|0);
      var $77=$76;
      var $78=HEAPU8[($77)];
      var $79=(($78)&255);
      var $80=$79 & 1;
      var $81=(($80)|0)!=0;
      var $82=$32;
      if ($81) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $83
      var $84=$26;
      HEAP32[(($26)>>2)]=$62;
      var $85=HEAP32[(($26)>>2)];
      var $86=(($85)|0);
      var $87=$25;
      HEAP32[(($25)>>2)]=$86;
      var $88=HEAP32[(($25)>>2)];
      var $89=$88;
      var $90=$24;
      HEAP32[(($24)>>2)]=$89;
      var $91=HEAP32[(($24)>>2)];
      var $92=(($91)|0);
      var $93=$24;
      var $94=$25;
      var $95=(($92)|0);
      var $96=$95;
      var $97=(($96+4)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$26;
      var $120 = $98;__label__ = 6; break;
    case 5: // $100
      var $101=$29;
      HEAP32[(($29)>>2)]=$62;
      var $102=HEAP32[(($29)>>2)];
      var $103=(($102)|0);
      var $104=$28;
      HEAP32[(($28)>>2)]=$103;
      var $105=HEAP32[(($28)>>2)];
      var $106=$105;
      var $107=$27;
      HEAP32[(($27)>>2)]=$106;
      var $108=HEAP32[(($27)>>2)];
      var $109=(($108)|0);
      var $110=$27;
      var $111=$28;
      var $112=(($109)|0);
      var $113=$112;
      var $114=(($113)|0);
      var $115=$114;
      var $116=HEAPU8[($115)];
      var $117=(($116)&255);
      var $118=$117 >> 1;
      var $119=$29;
      var $120 = $118;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $120;
      var $121=$33;
      var $122=(($120)|0)!=0;
      if ($122) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $123
      var $124=$44;
      var $125=HEAP32[(($124)>>2)];
      var $126=$43;
      var $127=$125;
      var $128=$126;
      var $129=(($127-$128)|0);
      var $130=(((($129)|0)/4)|0);
      var $131=(($130)|0) < 40;
      if ($131) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $132
      var $133=$45;
      var $134=HEAP32[(($133)>>2)];
      var $135=$44;
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+4)|0);
      HEAP32[(($135)>>2)]=$137;
      HEAP32[(($136)>>2)]=$134;
      __label__ = 9; break;
    case 9: // $138
      $34=0;
      __label__ = 44; break;
    case 10: // $139
      var $140=HEAP32[(($35)>>2)];
      var $141=$41;
      var $142=(($140)|0)==(($141)|0);
      if ($142) { __label__ = 11; break; } else { __label__ = 20; break; }
    case 11: // $143
      var $144=$42;
      var $145=$10;
      HEAP32[(($10)>>2)]=$144;
      var $146=HEAPU32[(($10)>>2)];
      var $147=$9;
      HEAP32[(($9)>>2)]=$146;
      var $148=HEAP32[(($9)>>2)];
      var $149=(($148)|0);
      var $150=$8;
      HEAP32[(($8)>>2)]=$149;
      var $151=HEAP32[(($8)>>2)];
      var $152=$151;
      var $153=$7;
      HEAP32[(($7)>>2)]=$152;
      var $154=HEAP32[(($7)>>2)];
      var $155=(($154)|0);
      var $156=$7;
      var $157=$8;
      var $158=(($155)|0);
      var $159=$158;
      var $160=(($159)|0);
      var $161=$160;
      var $162=HEAPU8[($161)];
      var $163=(($162)&255);
      var $164=$163 & 1;
      var $165=(($164)|0)!=0;
      var $166=$9;
      if ($165) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $167
      var $168=$3;
      HEAP32[(($3)>>2)]=$146;
      var $169=HEAP32[(($3)>>2)];
      var $170=(($169)|0);
      var $171=$2;
      HEAP32[(($2)>>2)]=$170;
      var $172=HEAP32[(($2)>>2)];
      var $173=$172;
      var $174=$1;
      HEAP32[(($1)>>2)]=$173;
      var $175=HEAP32[(($1)>>2)];
      var $176=(($175)|0);
      var $177=$1;
      var $178=$2;
      var $179=(($176)|0);
      var $180=$179;
      var $181=(($180+4)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=$3;
      var $204 = $182;__label__ = 14; break;
    case 13: // $184
      var $185=$6;
      HEAP32[(($6)>>2)]=$146;
      var $186=HEAP32[(($6)>>2)];
      var $187=(($186)|0);
      var $188=$5;
      HEAP32[(($5)>>2)]=$187;
      var $189=HEAP32[(($5)>>2)];
      var $190=$189;
      var $191=$4;
      HEAP32[(($4)>>2)]=$190;
      var $192=HEAP32[(($4)>>2)];
      var $193=(($192)|0);
      var $194=$4;
      var $195=$5;
      var $196=(($193)|0);
      var $197=$196;
      var $198=(($197)|0);
      var $199=$198;
      var $200=HEAPU8[($199)];
      var $201=(($200)&255);
      var $202=$201 >> 1;
      var $203=$6;
      var $204 = $202;__label__ = 14; break;
    case 14: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit2
      var $204;
      var $205=$10;
      var $206=(($204)|0)!=0;
      if ($206) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $207
      var $208=$36;
      var $209=HEAP8[($208)];
      var $210=(($209) & 1);
      if ($210) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $211
      $34=-1;
      __label__ = 44; break;
    case 17: // $212
      var $213=$44;
      var $214=HEAP32[(($213)>>2)];
      var $215=$43;
      var $216=$214;
      var $217=$215;
      var $218=(($216-$217)|0);
      var $219=(((($218)|0)/4)|0);
      var $220=(($219)|0) < 40;
      if ($220) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $221
      var $222=$45;
      var $223=HEAP32[(($222)>>2)];
      var $224=$44;
      var $225=HEAP32[(($224)>>2)];
      var $226=(($225+4)|0);
      HEAP32[(($224)>>2)]=$226;
      HEAP32[(($225)>>2)]=$223;
      var $227=$45;
      HEAP32[(($227)>>2)]=0;
      __label__ = 19; break;
    case 19: // $228
      $34=0;
      __label__ = 44; break;
    case 20: // $229
      var $230=$46;
      var $231=$46;
      var $232=(($231+128)|0);
      var $233=$11;
      var $234=$12;
      var $235=$13;
      HEAP32[(($11)>>2)]=$230;
      HEAP32[(($12)>>2)]=$232;
      HEAP32[(($13)>>2)]=$35;
      __label__ = 21; break;
    case 21: // $236
      var $237=HEAP32[(($11)>>2)];
      var $238=HEAP32[(($12)>>2)];
      var $239=(($237)|0)!=(($238)|0);
      if ($239) { __label__ = 22; break; } else { __label__ = 25; break; }
    case 22: // $240
      var $241=HEAP32[(($11)>>2)];
      var $242=HEAP32[(($241)>>2)];
      var $243=HEAP32[(($13)>>2)];
      var $244=HEAP32[(($243)>>2)];
      var $245=(($242)|0)==(($244)|0);
      if ($245) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $246
      __label__ = 25; break;
    case 24: // $247
      var $248=HEAP32[(($11)>>2)];
      var $249=(($248+4)|0);
      HEAP32[(($11)>>2)]=$249;
      __label__ = 21; break;
    case 25: // $_ZNSt3__14findIPwwEET_S2_S2_RKT0__exit
      var $250=HEAP32[(($11)>>2)];
      var $251=$11;
      var $252=$12;
      var $253=$13;
      var $254=$46;
      var $255=$250;
      var $256=$254;
      var $257=(($255-$256)|0);
      var $258=(((($257)|0)/4)|0);
      $__f=$258;
      var $259=$__f;
      var $260=(($259)|0) >= 32;
      if ($260) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $261
      $34=-1;
      __label__ = 44; break;
    case 27: // $262
      var $263=$__f;
      var $264=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+$263)|0);
      var $265=HEAP8[($264)];
      $__x=$265;
      var $266=$39;
      var $267=HEAP32[(($266)>>2)];
      var $268=$38;
      var $269=$267;
      var $270=$268;
      var $271=(($269-$270)|0);
      var $272=(($271)|0) < 39;
      if ($272) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $273
      var $274=$__x;
      var $275=$39;
      var $276=HEAP32[(($275)>>2)];
      var $277=(($276+1)|0);
      HEAP32[(($275)>>2)]=$277;
      HEAP8[($276)]=$274;
      __label__ = 29; break;
    case 29: // $278
      var $279=$__x;
      var $280=(($279 << 24) >> 24);
      var $281=(($280)|0)==120;
      if ($281) { __label__ = 31; break; } else { __label__ = 30; break; }
    case 30: // $282
      var $283=$__x;
      var $284=(($283 << 24) >> 24);
      var $285=(($284)|0)==88;
      if ($285) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $286
      var $287=$37;
      HEAP8[($287)]=80;
      __label__ = 41; break;
    case 32: // $288
      var $289=$__x;
      var $290=(($289 << 24) >> 24);
      var $291=$290 & 223;
      var $292=$37;
      var $293=HEAP8[($292)];
      var $294=(($293 << 24) >> 24);
      var $295=(($291)|0)==(($294)|0);
      if ($295) { __label__ = 33; break; } else { __label__ = 40; break; }
    case 33: // $296
      var $297=$36;
      HEAP8[($297)]=0;
      var $298=$42;
      var $299=$23;
      HEAP32[(($23)>>2)]=$298;
      var $300=HEAPU32[(($23)>>2)];
      var $301=$22;
      HEAP32[(($22)>>2)]=$300;
      var $302=HEAP32[(($22)>>2)];
      var $303=(($302)|0);
      var $304=$21;
      HEAP32[(($21)>>2)]=$303;
      var $305=HEAP32[(($21)>>2)];
      var $306=$305;
      var $307=$20;
      HEAP32[(($20)>>2)]=$306;
      var $308=HEAP32[(($20)>>2)];
      var $309=(($308)|0);
      var $310=$20;
      var $311=$21;
      var $312=(($309)|0);
      var $313=$312;
      var $314=(($313)|0);
      var $315=$314;
      var $316=HEAPU8[($315)];
      var $317=(($316)&255);
      var $318=$317 & 1;
      var $319=(($318)|0)!=0;
      var $320=$22;
      if ($319) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $321
      var $322=$16;
      HEAP32[(($16)>>2)]=$300;
      var $323=HEAP32[(($16)>>2)];
      var $324=(($323)|0);
      var $325=$15;
      HEAP32[(($15)>>2)]=$324;
      var $326=HEAP32[(($15)>>2)];
      var $327=$326;
      var $328=$14;
      HEAP32[(($14)>>2)]=$327;
      var $329=HEAP32[(($14)>>2)];
      var $330=(($329)|0);
      var $331=$14;
      var $332=$15;
      var $333=(($330)|0);
      var $334=$333;
      var $335=(($334+4)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=$16;
      var $358 = $336;__label__ = 36; break;
    case 35: // $338
      var $339=$19;
      HEAP32[(($19)>>2)]=$300;
      var $340=HEAP32[(($19)>>2)];
      var $341=(($340)|0);
      var $342=$18;
      HEAP32[(($18)>>2)]=$341;
      var $343=HEAP32[(($18)>>2)];
      var $344=$343;
      var $345=$17;
      HEAP32[(($17)>>2)]=$344;
      var $346=HEAP32[(($17)>>2)];
      var $347=(($346)|0);
      var $348=$17;
      var $349=$18;
      var $350=(($347)|0);
      var $351=$350;
      var $352=(($351)|0);
      var $353=$352;
      var $354=HEAPU8[($353)];
      var $355=(($354)&255);
      var $356=$355 >> 1;
      var $357=$19;
      var $358 = $356;__label__ = 36; break;
    case 36: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit1
      var $358;
      var $359=$23;
      var $360=(($358)|0)!=0;
      if ($360) { __label__ = 37; break; } else { __label__ = 39; break; }
    case 37: // $361
      var $362=$44;
      var $363=HEAP32[(($362)>>2)];
      var $364=$43;
      var $365=$363;
      var $366=$364;
      var $367=(($365-$366)|0);
      var $368=(((($367)|0)/4)|0);
      var $369=(($368)|0) < 40;
      if ($369) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $370
      var $371=$45;
      var $372=HEAP32[(($371)>>2)];
      var $373=$44;
      var $374=HEAP32[(($373)>>2)];
      var $375=(($374+4)|0);
      HEAP32[(($373)>>2)]=$375;
      HEAP32[(($374)>>2)]=$372;
      __label__ = 39; break;
    case 39: // $376
      __label__ = 40; break;
    case 40: // $377
      __label__ = 41; break;
    case 41: // $378
      var $379=$__f;
      var $380=(($379)|0) >= 22;
      if ($380) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $381
      $34=0;
      __label__ = 44; break;
    case 43: // $382
      var $383=$45;
      var $384=HEAP32[(($383)>>2)];
      var $385=(($384+1)|0);
      HEAP32[(($383)>>2)]=$385;
      $34=0;
      __label__ = 44; break;
    case 44: // $386
      var $387=$34;
      STACKTOP = __stackBase__;
      return $387;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 500; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__atoms=__stackBase__+132;
      var $__decimal_point=__stackBase__+260;
      var $__thousands_sep=__stackBase__+264;
      var $__grouping=__stackBase__+268;
      var $__a=__stackBase__+280;
      var $__a_end=__stackBase__+320;
      var $__g=__stackBase__+324;
      var $__g_end=__stackBase__+484;
      var $__dc=__stackBase__+488;
      var $__in_units=__stackBase__+492;
      var $__exp=__stackBase__+496;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=(($__atoms)|0);
      __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($__grouping, $42, $43, $__decimal_point, $__thousands_sep);
      var $44=$__a;
      _memset($44, 0, 40, 1);
      var $45=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$45;
      var $46=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$46;
      HEAP32[(($__dc)>>2)]=0;
      HEAP8[($__in_units)]=1;
      HEAP8[($__exp)]=69;
      __label__ = 1; break;
    case 1: // $47
      var $48=$32;
      var $49=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $50=HEAP32[(($32)>>2)];
      var $51=HEAP32[(($33)>>2)];
      var $52=$30;
      var $53=$31;
      HEAP32[(($30)>>2)]=$50;
      HEAP32[(($31)>>2)]=$51;
      var $54=HEAP32[(($30)>>2)];
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      var $58=(($57)&1);
      var $59=HEAP32[(($31)>>2)];
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      var $63=(($62)&1);
      var $64=(($58)|0)==(($63)|0);
      var $65=$30;
      var $66=$31;
      var $67=$64 ^ 1;
      var $68=$32;
      var $69=$33;
      __label__ = 2; break;
    case 2: // $70
      if ($67) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $71
      var $72=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $73=HEAP32[(($25)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$23;
      var $77=$24;
      HEAP32[(($24)>>2)]=$75;
      var $78=HEAP32[(($24)>>2)];
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78+16)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0)==(($82)|0);
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$78;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+36)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$89;
      __label__ = 7; break;
    case 6: // $90
      var $91=(($78+12)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP32[(($92)>>2)];
      var $94=$22;
      HEAP32[(($22)>>2)]=$93;
      var $95=HEAP32[(($22)>>2)];
      var $96=$22;
      HEAP32[(($23)>>2)]=$95;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $97=HEAP32[(($23)>>2)];
      var $98=$23;
      var $99=$24;
      var $100=$25;
      __label__ = 8; break;
    case 8: // $101
      var $102=(($__a)|0);
      var $103=HEAP32[(($__decimal_point)>>2)];
      var $104=HEAP32[(($__thousands_sep)>>2)];
      var $105=(($__g)|0);
      var $106=(($__atoms)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($97, $__in_units, $__exp, $102, $__a_end, $103, $104, $__grouping, $105, $__g_end, $__dc, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $110
      __label__ = 28; break;
    case 11: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $38=$113;
      var $114=$112.f1;
      $39=$114;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 12: // $115
      __label__ = 13; break;
    case 13: // $116
      var $117=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $118=HEAPU32[(($21)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$19;
      var $122=$20;
      HEAP32[(($20)>>2)]=$120;
      var $123=HEAP32[(($20)>>2)];
      var $124=$17;
      var $125=$18;
      HEAP32[(($18)>>2)]=$123;
      var $126=HEAP32[(($18)>>2)];
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($126+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0)==(($130)|0);
      if ($131) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $132
      var $133=$126;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+40)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$136]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$137;
      __label__ = 17; break;
    case 16: // $138
      var $139=(($126+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+4)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=HEAP32[(($140)>>2)];
      var $143=$16;
      HEAP32[(($16)>>2)]=$142;
      var $144=HEAP32[(($16)>>2)];
      var $145=$16;
      HEAP32[(($17)>>2)]=$144;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $146=HEAP32[(($17)>>2)];
      var $147=$17;
      var $148=$18;
      var $149=(($146)|0)==-1;
      if ($149) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $150
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $151
      var $152=$14;
      var $153=$15;
      HEAP32[(($15)>>2)]=$123;
      var $154=HEAP32[(($15)>>2)];
      var $155=(($154+12)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($154+16)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156)|0)==(($158)|0);
      if ($159) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $160
      var $161=$154;
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+36)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$164]($154) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$165;
      __label__ = 23; break;
    case 22: // $166
      var $167=(($154+12)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=HEAP32[(($168)>>2)];
      var $170=$13;
      HEAP32[(($13)>>2)]=$169;
      var $171=HEAP32[(($13)>>2)];
      var $172=$13;
      HEAP32[(($14)>>2)]=$171;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($118)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $253
      var $254=HEAP8[($__in_units)];
      var $255=(($254) & 1);
      if ($255) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $256
      var $257=HEAP32[(($__g_end)>>2)];
      var $258=(($__g)|0);
      var $259=$257;
      var $260=$258;
      var $261=(($259-$260)|0);
      var $262=(((($261)|0)/4)|0);
      var $263=(($262)|0) < 40;
      if ($263) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $264
      var $265=HEAP32[(($__dc)>>2)];
      var $266=HEAP32[(($__g_end)>>2)];
      var $267=(($266+4)|0);
      HEAP32[(($__g_end)>>2)]=$267;
      HEAP32[(($266)>>2)]=$265;
      __label__ = 35; break;
    case 35: // $268
      var $269=(($__a)|0);
      var $270=HEAP32[(($__a_end)>>2)];
      var $271=$36;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj($269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; };
    case 36: // $273
      var $274=$37;
      (tempDoubleF64[0]=$272,HEAP32[(($274)>>2)]=tempDoubleI32[0],HEAP32[(($274+4)>>2)]=tempDoubleI32[1]);
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 11; break; }
    case 37: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 38; break;
    case 38: // $300
      if ($295) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 40; break;
    case 40: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 41: // $308
      __label__ = 42; break;
    case 42: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd["X"]=1;

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 500; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__atoms=__stackBase__+132;
      var $__decimal_point=__stackBase__+260;
      var $__thousands_sep=__stackBase__+264;
      var $__grouping=__stackBase__+268;
      var $__a=__stackBase__+280;
      var $__a_end=__stackBase__+320;
      var $__g=__stackBase__+324;
      var $__g_end=__stackBase__+484;
      var $__dc=__stackBase__+488;
      var $__in_units=__stackBase__+492;
      var $__exp=__stackBase__+496;
      var $38;
      var $39;
      var $40;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__v;
      var $41=$34;
      var $42=$35;
      var $43=(($__atoms)|0);
      __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_($__grouping, $42, $43, $__decimal_point, $__thousands_sep);
      var $44=$__a;
      _memset($44, 0, 40, 1);
      var $45=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$45;
      var $46=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$46;
      HEAP32[(($__dc)>>2)]=0;
      HEAP8[($__in_units)]=1;
      HEAP8[($__exp)]=69;
      __label__ = 1; break;
    case 1: // $47
      var $48=$32;
      var $49=$33;
      HEAP32[(($32)>>2)]=$__b;
      HEAP32[(($33)>>2)]=$__e;
      var $50=HEAP32[(($32)>>2)];
      var $51=HEAP32[(($33)>>2)];
      var $52=$30;
      var $53=$31;
      HEAP32[(($30)>>2)]=$50;
      HEAP32[(($31)>>2)]=$51;
      var $54=HEAP32[(($30)>>2)];
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      var $58=(($57)&1);
      var $59=HEAP32[(($31)>>2)];
      var $60=(($59)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==0;
      var $63=(($62)&1);
      var $64=(($58)|0)==(($63)|0);
      var $65=$30;
      var $66=$31;
      var $67=$64 ^ 1;
      var $68=$32;
      var $69=$33;
      __label__ = 2; break;
    case 2: // $70
      if ($67) { __label__ = 3; break; } else { __label__ = 28; break; }
    case 3: // $71
      var $72=$25;
      HEAP32[(($25)>>2)]=$__b;
      var $73=HEAP32[(($25)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$23;
      var $77=$24;
      HEAP32[(($24)>>2)]=$75;
      var $78=HEAP32[(($24)>>2)];
      var $79=(($78+12)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($78+16)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0)==(($82)|0);
      if ($83) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $84
      var $85=$78;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+36)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$88]($78) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 11; break; };
    case 5: // $_noexc
      HEAP32[(($23)>>2)]=$89;
      __label__ = 7; break;
    case 6: // $90
      var $91=(($78+12)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=HEAP32[(($92)>>2)];
      var $94=$22;
      HEAP32[(($22)>>2)]=$93;
      var $95=HEAP32[(($22)>>2)];
      var $96=$22;
      HEAP32[(($23)>>2)]=$95;
      __label__ = 7; break;
    case 7: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $97=HEAP32[(($23)>>2)];
      var $98=$23;
      var $99=$24;
      var $100=$25;
      __label__ = 8; break;
    case 8: // $101
      var $102=(($__a)|0);
      var $103=HEAP32[(($__decimal_point)>>2)];
      var $104=HEAP32[(($__thousands_sep)>>2)];
      var $105=(($__g)|0);
      var $106=(($__atoms)|0);
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw($97, $__in_units, $__exp, $102, $__a_end, $103, $104, $__grouping, $105, $__g_end, $__dc, $106) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; };
    case 9: // $108
      var $109=(($107)|0)!=0;
      if ($109) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $110
      __label__ = 28; break;
    case 11: // $111
      var $112=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $113=$112.f0;
      $38=$113;
      var $114=$112.f1;
      $39=$114;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 43; break; }
    case 12: // $115
      __label__ = 13; break;
    case 13: // $116
      var $117=$21;
      HEAP32[(($21)>>2)]=$__b;
      var $118=HEAPU32[(($21)>>2)];
      var $119=(($118)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=$19;
      var $122=$20;
      HEAP32[(($20)>>2)]=$120;
      var $123=HEAP32[(($20)>>2)];
      var $124=$17;
      var $125=$18;
      HEAP32[(($18)>>2)]=$123;
      var $126=HEAP32[(($18)>>2)];
      var $127=(($126+12)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($126+16)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($128)|0)==(($130)|0);
      if ($131) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $132
      var $133=$126;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+40)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$136]($126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 11; break; };
    case 15: // $_noexc1
      HEAP32[(($17)>>2)]=$137;
      __label__ = 17; break;
    case 16: // $138
      var $139=(($126+12)|0);
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+4)|0);
      HEAP32[(($139)>>2)]=$141;
      var $142=HEAP32[(($140)>>2)];
      var $143=$16;
      HEAP32[(($16)>>2)]=$142;
      var $144=HEAP32[(($16)>>2)];
      var $145=$16;
      HEAP32[(($17)>>2)]=$144;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $146=HEAP32[(($17)>>2)];
      var $147=$17;
      var $148=$18;
      var $149=(($146)|0)==-1;
      if ($149) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $150
      HEAP32[(($19)>>2)]=-1;
      __label__ = 24; break;
    case 19: // $151
      var $152=$14;
      var $153=$15;
      HEAP32[(($15)>>2)]=$123;
      var $154=HEAP32[(($15)>>2)];
      var $155=(($154+12)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($154+16)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156)|0)==(($158)|0);
      if ($159) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $160
      var $161=$154;
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+36)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$164]($154) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 11; break; };
    case 21: // $_noexc2
      HEAP32[(($14)>>2)]=$165;
      __label__ = 23; break;
    case 22: // $166
      var $167=(($154+12)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=HEAP32[(($168)>>2)];
      var $170=$13;
      HEAP32[(($13)>>2)]=$169;
      var $171=HEAP32[(($13)>>2)];
      var $172=$13;
      HEAP32[(($14)>>2)]=$171;
      __label__ = 23; break;
    case 23: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $173=HEAP32[(($14)>>2)];
      var $174=$14;
      var $175=$15;
      HEAP32[(($19)>>2)]=$173;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $176=HEAP32[(($19)>>2)];
      var $177=$19;
      var $178=$20;
      var $179=$11;
      var $180=$12;
      HEAP32[(($11)>>2)]=$176;
      HEAP32[(($12)>>2)]=-1;
      var $181=HEAP32[(($11)>>2)];
      var $182=HEAP32[(($12)>>2)];
      var $183=(($181)|0)==(($182)|0);
      var $184=$11;
      var $185=$12;
      if ($183) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $186
      var $187=(($118)|0);
      HEAP32[(($187)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $188=$21;
      __label__ = 27; break;
    case 27: // $189
      __label__ = 1; break;
    case 28: // $190
      var $191=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 31; break;
    case 30: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 31; break;
    case 31: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($250)|0)!=0;
      if ($252) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $253
      var $254=HEAP8[($__in_units)];
      var $255=(($254) & 1);
      if ($255) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $256
      var $257=HEAP32[(($__g_end)>>2)];
      var $258=(($__g)|0);
      var $259=$257;
      var $260=$258;
      var $261=(($259-$260)|0);
      var $262=(((($261)|0)/4)|0);
      var $263=(($262)|0) < 40;
      if ($263) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $264
      var $265=HEAP32[(($__dc)>>2)];
      var $266=HEAP32[(($__g_end)>>2)];
      var $267=(($266+4)|0);
      HEAP32[(($__g_end)>>2)]=$267;
      HEAP32[(($266)>>2)]=$265;
      __label__ = 35; break;
    case 35: // $268
      var $269=(($__a)|0);
      var $270=HEAP32[(($__a_end)>>2)];
      var $271=$36;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj($269, $270, $271) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 11; break; };
    case 36: // $273
      var $274=$37;
      (tempDoubleF64[0]=$272,HEAP32[(($274)>>2)]=tempDoubleI32[0],HEAP32[(($274+4)>>2)]=tempDoubleI32[1]);
      var $275=(($__g)|0);
      var $276=HEAP32[(($__g_end)>>2)];
      var $277=$36;
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grouping, $275, $276, $277) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 11; break; }
    case 37: // $278
      var $279=$28;
      var $280=$29;
      HEAP32[(($28)>>2)]=$__b;
      HEAP32[(($29)>>2)]=$__e;
      var $281=HEAP32[(($28)>>2)];
      var $282=HEAP32[(($29)>>2)];
      var $283=$26;
      var $284=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$282;
      var $285=HEAP32[(($26)>>2)];
      var $286=(($285)|0);
      var $287=HEAP32[(($286)>>2)];
      var $288=(($287)|0)==0;
      var $289=(($288)&1);
      var $290=HEAP32[(($27)>>2)];
      var $291=(($290)|0);
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292)|0)==0;
      var $294=(($293)&1);
      var $295=(($289)|0)==(($294)|0);
      var $296=$26;
      var $297=$27;
      var $298=$28;
      var $299=$29;
      __label__ = 38; break;
    case 38: // $300
      if ($295) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $301
      var $302=$36;
      var $303=HEAP32[(($302)>>2)];
      var $304=$303 | 2;
      HEAP32[(($302)>>2)]=$304;
      __label__ = 40; break;
    case 40: // $305
      var $306=$agg_result;
      var $307=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($306)>>2)]=HEAP32[(($307)>>2)];
      $40=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 41: // $308
      __label__ = 42; break;
    case 42: // $309
      var $310=$38;
      var $311=$38;
      var $312=$39;
      var $313=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $311, tempValue);
      var $314=($313.f1 = $312, $313);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $315
      var $316=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe["X"]=1;

function ___cxx_global_var_init4274() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv($agg_result, $this, $__b, $__e, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 488; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $__a_i_i_i=__stackBase__+124;
      var $__i_i_i_i=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38;
      var $39;
      var $40;
      var $41;
      var $__base;
      var $__atoms=__stackBase__+156;
      var $__thousands_sep;
      var $__grouping=__stackBase__+260;
      var $42=__stackBase__+272;
      var $43;
      var $44;
      var $__a=__stackBase__+276;
      var $__a_end=__stackBase__+316;
      var $__g=__stackBase__+320;
      var $__g_end=__stackBase__+480;
      var $__dc=__stackBase__+484;
      var $45;
      $38=$this;
      $39=$__iob;
      $40=$__err;
      $41=$__v;
      var $46=$38;
      $__base=16;
      var $47=$37;
      HEAP32[(($37)>>2)]=$__grouping;
      var $48=HEAP32[(($37)>>2)];
      var $49=$36;
      HEAP32[(($36)>>2)]=$48;
      var $50=HEAP32[(($36)>>2)];
      var $51=$50;
      var $52=(($50)|0);
      var $53=$35;
      HEAP32[(($35)>>2)]=$52;
      var $54=HEAP32[(($35)>>2)];
      var $55=$34;
      HEAP32[(($34)>>2)]=$54;
      var $56=HEAP32[(($34)>>2)];
      var $57=$56;
      var $58=$33;
      HEAP32[(($33)>>2)]=$57;
      var $59=HEAP32[(($33)>>2)];
      var $60=$59;
      var $61=$32;
      HEAP32[(($32)>>2)]=$60;
      var $62=HEAP32[(($32)>>2)];
      var $63=$32;
      var $64=(($59)|0);
      var $65=$33;
      var $66=$34;
      var $67=$35;
      var $68=$31;
      var $69=$__a_i_i_i;
      var $70=$__i_i_i_i;
      HEAP32[(($31)>>2)]=$50;
      var $71=HEAP32[(($31)>>2)];
      var $72=(($71)|0);
      var $73=$30;
      HEAP32[(($30)>>2)]=$72;
      var $74=HEAP32[(($30)>>2)];
      var $75=$74;
      var $76=$29;
      HEAP32[(($29)>>2)]=$75;
      var $77=HEAP32[(($29)>>2)];
      var $78=(($77)|0);
      var $79=$29;
      var $80=$30;
      var $81=(($78)|0);
      var $82=$81;
      var $83=(($82)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$83;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $84
      var $85=HEAPU32[(($__i_i_i_i)>>2)];
      var $86=(($85)>>>0) < 3;
      if ($86) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $87
      var $88=HEAP32[(($__i_i_i_i)>>2)];
      var $89=HEAP32[(($__a_i_i_i)>>2)];
      var $90=(($89+($88<<2))|0);
      HEAP32[(($90)>>2)]=0;
      var $91=HEAP32[(($__i_i_i_i)>>2)];
      var $92=(($91+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$92;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $93=$31;
      var $94=$__a_i_i_i;
      var $95=$__i_i_i_i;
      var $96=$36;
      var $97=$37;
      var $98=$39;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($42, $98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $99
      var $100=$24;
      HEAP32[(($24)>>2)]=$42;
      var $101=HEAP32[(($24)>>2)];
      var $102=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($101, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 21; break; };
    case 5: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $103=$102;
      var $104=$24;
      __label__ = 6; break;
    case 6: // $105
      var $106=(($__atoms)|0);
      var $107=$20;
      var $108=$21;
      var $109=$22;
      var $110=$23;
      HEAP32[(($20)>>2)]=$103;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE)|0);
      HEAP32[(($22)>>2)]=((STRING_TABLE.__ZNSt3__114__num_get_base5__srcE+26)|0);
      HEAP32[(($23)>>2)]=$106;
      var $111=HEAP32[(($20)>>2)];
      var $112=$111;
      var $113=HEAP32[(($112)>>2)];
      var $114=(($113+48)|0);
      var $115=HEAP32[(($114)>>2)];
      var $116=HEAP32[(($21)>>2)];
      var $117=HEAP32[(($22)>>2)];
      var $118=HEAP32[(($23)>>2)];
      var $119=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$115]($111, $116, $117, $118) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 21; break; };
    case 7: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $120=$20;
      var $121=$21;
      var $122=$22;
      var $123=$23;
      __label__ = 8; break;
    case 8: // $124
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 20; break; }
    case 9: // $125
      var $126=$__a;
      _memset($126, 0, 40, 1);
      var $127=(($__a)|0);
      HEAP32[(($__a_end)>>2)]=$127;
      var $128=(($__g)|0);
      HEAP32[(($__g_end)>>2)]=$128;
      HEAP32[(($__dc)>>2)]=0;
      __label__ = 10; break;
    case 10: // $129
      var $130=$18;
      var $131=$19;
      HEAP32[(($18)>>2)]=$__b;
      HEAP32[(($19)>>2)]=$__e;
      var $132=HEAP32[(($18)>>2)];
      var $133=HEAP32[(($19)>>2)];
      var $134=$16;
      var $135=$17;
      HEAP32[(($16)>>2)]=$132;
      HEAP32[(($17)>>2)]=$133;
      var $136=HEAP32[(($16)>>2)];
      var $137=(($136)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=(($138)|0)==0;
      var $140=(($139)&1);
      var $141=HEAP32[(($17)>>2)];
      var $142=(($141)|0);
      var $143=HEAP32[(($142)>>2)];
      var $144=(($143)|0)==0;
      var $145=(($144)&1);
      var $146=(($140)|0)==(($145)|0);
      var $147=$16;
      var $148=$17;
      var $149=$146 ^ 1;
      var $150=$18;
      var $151=$19;
      __label__ = 11; break;
    case 11: // $152
      if ($149) { __label__ = 12; break; } else { __label__ = 39; break; }
    case 12: // $153
      var $154=$15;
      HEAP32[(($15)>>2)]=$__b;
      var $155=HEAP32[(($15)>>2)];
      var $156=(($155)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=$13;
      var $159=$14;
      HEAP32[(($14)>>2)]=$157;
      var $160=HEAP32[(($14)>>2)];
      var $161=(($160+12)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=(($160+16)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=(($162)|0)==(($164)|0);
      if ($165) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $166
      var $167=$160;
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+36)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$170]($160) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 20; break; };
    case 14: // $_noexc
      HEAP32[(($13)>>2)]=$171;
      __label__ = 16; break;
    case 15: // $172
      var $173=(($160+12)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=HEAP32[(($174)>>2)];
      var $176=$12;
      HEAP32[(($12)>>2)]=$175;
      var $177=HEAP32[(($12)>>2)];
      var $178=$12;
      HEAP32[(($13)>>2)]=$177;
      __label__ = 16; break;
    case 16: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $179=HEAP32[(($13)>>2)];
      var $180=$13;
      var $181=$14;
      var $182=$15;
      __label__ = 17; break;
    case 17: // $183
      var $184=$__base;
      var $185=(($__a)|0);
      var $186=$__thousands_sep;
      var $187=(($__g)|0);
      var $188=(($__atoms)|0);
      var $189=(function() { try { __THREW__ = false; return __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw($179, $184, $185, $__a_end, $__dc, $186, $__grouping, $187, $__g_end, $188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 20; break; };
    case 18: // $190
      var $191=(($189)|0)!=0;
      if ($191) { __label__ = 19; break; } else { __label__ = 23; break; }
    case 19: // $192
      __label__ = 39; break;
    case 20: // $193
      var $194=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $195=$194.f0;
      $43=$195;
      var $196=$194.f1;
      $44=$196;
      __label__ = 47; break;
    case 21: // $197
      var $198=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $199=$198.f0;
      $43=$199;
      var $200=$198.f1;
      $44=$200;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 50; break; }
    case 22: // $201
      __label__ = 47; break;
    case 23: // $202
      __label__ = 24; break;
    case 24: // $203
      var $204=$11;
      HEAP32[(($11)>>2)]=$__b;
      var $205=HEAPU32[(($11)>>2)];
      var $206=(($205)|0);
      var $207=HEAP32[(($206)>>2)];
      var $208=$9;
      var $209=$10;
      HEAP32[(($10)>>2)]=$207;
      var $210=HEAP32[(($10)>>2)];
      var $211=$7;
      var $212=$8;
      HEAP32[(($8)>>2)]=$210;
      var $213=HEAP32[(($8)>>2)];
      var $214=(($213+12)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(($213+16)|0);
      var $217=HEAP32[(($216)>>2)];
      var $218=(($215)|0)==(($217)|0);
      if ($218) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $219
      var $220=$213;
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+40)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$223]($213) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 20; break; };
    case 26: // $_noexc1
      HEAP32[(($7)>>2)]=$224;
      __label__ = 28; break;
    case 27: // $225
      var $226=(($213+12)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($227+4)|0);
      HEAP32[(($226)>>2)]=$228;
      var $229=HEAP32[(($227)>>2)];
      var $230=$6;
      HEAP32[(($6)>>2)]=$229;
      var $231=HEAP32[(($6)>>2)];
      var $232=$6;
      HEAP32[(($7)>>2)]=$231;
      __label__ = 28; break;
    case 28: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $233=HEAP32[(($7)>>2)];
      var $234=$7;
      var $235=$8;
      var $236=(($233)|0)==-1;
      if ($236) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $237
      HEAP32[(($9)>>2)]=-1;
      __label__ = 35; break;
    case 30: // $238
      var $239=$4;
      var $240=$5;
      HEAP32[(($5)>>2)]=$210;
      var $241=HEAP32[(($5)>>2)];
      var $242=(($241+12)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($241+16)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=(($243)|0)==(($245)|0);
      if ($246) { __label__ = 31; break; } else { __label__ = 33; break; }
    case 31: // $247
      var $248=$241;
      var $249=HEAP32[(($248)>>2)];
      var $250=(($249+36)|0);
      var $251=HEAP32[(($250)>>2)];
      var $252=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$251]($241) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 20; break; };
    case 32: // $_noexc2
      HEAP32[(($4)>>2)]=$252;
      __label__ = 34; break;
    case 33: // $253
      var $254=(($241+12)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=HEAP32[(($255)>>2)];
      var $257=$3;
      HEAP32[(($3)>>2)]=$256;
      var $258=HEAP32[(($3)>>2)];
      var $259=$3;
      HEAP32[(($4)>>2)]=$258;
      __label__ = 34; break;
    case 34: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $260=HEAP32[(($4)>>2)];
      var $261=$4;
      var $262=$5;
      HEAP32[(($9)>>2)]=$260;
      __label__ = 35; break;
    case 35: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $263=HEAP32[(($9)>>2)];
      var $264=$9;
      var $265=$10;
      var $266=$1;
      var $267=$2;
      HEAP32[(($1)>>2)]=$263;
      HEAP32[(($2)>>2)]=-1;
      var $268=HEAP32[(($1)>>2)];
      var $269=HEAP32[(($2)>>2)];
      var $270=(($268)|0)==(($269)|0);
      var $271=$1;
      var $272=$2;
      if ($270) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $273
      var $274=(($205)|0);
      HEAP32[(($274)>>2)]=0;
      __label__ = 37; break;
    case 37: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $275=$11;
      __label__ = 38; break;
    case 38: // $276
      __label__ = 10; break;
    case 39: // $277
      var $278=(($__a+39)|0);
      HEAP8[($278)]=0;
      var $279=(($__a)|0);
      var $280=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 20; break; };
    case 40: // $281
      var $282=$41;
      var $283=(function() { try { __THREW__ = false; return __ZNSt3__110__sscanf_lEPKcPvS1_z($279, $280, ((STRING_TABLE.__str2371658)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$282,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 20; break; };
    case 41: // $284
      var $285=(($283)|0)!=1;
      if ($285) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $286
      var $287=$40;
      HEAP32[(($287)>>2)]=4;
      __label__ = 43; break;
    case 43: // $288
      var $289=$27;
      var $290=$28;
      HEAP32[(($27)>>2)]=$__b;
      HEAP32[(($28)>>2)]=$__e;
      var $291=HEAP32[(($27)>>2)];
      var $292=HEAP32[(($28)>>2)];
      var $293=$25;
      var $294=$26;
      HEAP32[(($25)>>2)]=$291;
      HEAP32[(($26)>>2)]=$292;
      var $295=HEAP32[(($25)>>2)];
      var $296=(($295)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=(($297)|0)==0;
      var $299=(($298)&1);
      var $300=HEAP32[(($26)>>2)];
      var $301=(($300)|0);
      var $302=HEAP32[(($301)>>2)];
      var $303=(($302)|0)==0;
      var $304=(($303)&1);
      var $305=(($299)|0)==(($304)|0);
      var $306=$25;
      var $307=$26;
      var $308=$27;
      var $309=$28;
      __label__ = 44; break;
    case 44: // $310
      if ($305) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $311
      var $312=$40;
      var $313=HEAP32[(($312)>>2)];
      var $314=$313 | 2;
      HEAP32[(($312)>>2)]=$314;
      __label__ = 46; break;
    case 46: // $315
      var $316=$agg_result;
      var $317=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($316)>>2)]=HEAP32[(($317)>>2)];
      $45=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 47: // $318
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 50; break; }
    case 48: // $319
      __label__ = 49; break;
    case 49: // $320
      var $321=$43;
      var $322=$43;
      var $323=$44;
      var $324=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $322, tempValue);
      var $325=($324.f1 = $323, $324);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $326
      var $327=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv["X"]=1;

function __ZNSt3__114__num_put_base12__format_intEPcPKcbj($__fmtp, $__len, $__signd, $__flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$__fmtp;
      $2=$__len;
      var $5=(($__signd)&1);
      $3=$5;
      $4=$__flags;
      var $6=$4;
      var $7=$6 & 2048;
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$1;
      var $11=(($10+1)|0);
      $1=$11;
      HEAP8[($10)]=43;
      __label__ = 2; break;
    case 2: // $12
      var $13=$4;
      var $14=$13 & 512;
      var $15=(($14)|0)!=0;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$1;
      var $18=(($17+1)|0);
      $1=$18;
      HEAP8[($17)]=35;
      __label__ = 4; break;
    case 4: // $19
      __label__ = 5; break;
    case 5: // $20
      var $21=$2;
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24)!=0;
      if ($23) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $24
      var $25=$2;
      var $26=(($25+1)|0);
      $2=$26;
      var $27=HEAP8[($25)];
      var $28=$1;
      var $29=(($28+1)|0);
      $1=$29;
      HEAP8[($28)]=$27;
      __label__ = 5; break;
    case 7: // $30
      var $31=$4;
      var $32=$31 & 74;
      var $33=(($32)|0)==64;
      if ($33) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $34
      var $35=$1;
      HEAP8[($35)]=111;
      __label__ = 19; break;
    case 9: // $36
      var $37=$4;
      var $38=$37 & 74;
      var $39=(($38)|0)==8;
      if ($39) { __label__ = 10; break; } else { __label__ = 14; break; }
    case 10: // $40
      var $41=$4;
      var $42=$41 & 16384;
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $44
      var $45=$1;
      HEAP8[($45)]=88;
      __label__ = 13; break;
    case 12: // $46
      var $47=$1;
      HEAP8[($47)]=120;
      __label__ = 13; break;
    case 13: // $48
      __label__ = 18; break;
    case 14: // $49
      var $50=$3;
      var $51=(($50) & 1);
      if ($51) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $52
      var $53=$1;
      HEAP8[($53)]=100;
      __label__ = 17; break;
    case 16: // $54
      var $55=$1;
      HEAP8[($55)]=117;
      __label__ = 17; break;
    case 17: // $56
      __label__ = 18; break;
    case 18: // $57
      __label__ = 19; break;
    case 19: // $58
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__num_put_base12__format_intEPcPKcbj["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 264; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36;
      var $37;
      var $38=__stackBase__+140;
      var $39=__stackBase__+144;
      var $40;
      var $41=__stackBase__+148;
      var $42;
      var $43=__stackBase__+152;
      var $44=__stackBase__+156;
      var $45=__stackBase__+160;
      var $46=__stackBase__+164;
      var $47=__stackBase__+168;
      var $48=__stackBase__+172;
      var $49=__stackBase__+176;
      var $50=__stackBase__+180;
      var $51=__stackBase__+184;
      var $52=__stackBase__+188;
      var $53=__stackBase__+192;
      var $54=__stackBase__+196;
      var $55=__stackBase__+200;
      var $56=__stackBase__+204;
      var $57=__stackBase__+208;
      var $58=__stackBase__+212;
      var $59=__stackBase__+216;
      var $60=__stackBase__+220;
      var $61=__stackBase__+224;
      var $62=__stackBase__+228;
      var $63=__stackBase__+232;
      var $64;
      var $65;
      var $66;
      var $67;
      var $68=__stackBase__+236;
      var $__np;
      var $69=__stackBase__+240;
      var $70;
      var $71;
      var $__nm=__stackBase__+244;
      var $__i=__stackBase__+256;
      var $72=__stackBase__+260;
      var $73;
      $64=$this;
      $65=$__iob;
      $66=$__fl;
      var $74=(($__v)&1);
      $67=$74;
      var $75=$64;
      var $76=$65;
      var $77=$63;
      HEAP32[(($63)>>2)]=$76;
      var $78=HEAP32[(($63)>>2)];
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$63;
      var $82=$80 & 1;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $84
      var $85=$75;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$68;
      var $90=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($89)>>2)]=HEAP32[(($90)>>2)];
      var $91=$65;
      var $92=$66;
      var $93=$67;
      var $94=(($93) & 1);
      var $95=(($94)&1);
      FUNCTION_TABLE[$88]($agg_result, $75, $68, $91, $92, $95);
      __label__ = 35; break;
    case 2: // $96
      var $97=$65;
      __ZNKSt3__18ios_base6getlocEv($69, $97);
      var $98=$62;
      HEAP32[(($62)>>2)]=$69;
      var $99=HEAP32[(($62)>>2)];
      var $100=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($99, __ZNSt3__18numpunctIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 30; break; };
    case 3: // $_ZNSt3__19use_facetINS_8numpunctIcEEEERKT_RKNS_6localeE_exit
      var $101=$100;
      var $102=$62;
      __label__ = 4; break;
    case 4: // $103
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($69);
      $__np=$101;
      var $104=$67;
      var $105=(($104) & 1);
      if ($105) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $106
      var $107=$__np;
      var $108=$61;
      HEAP32[(($61)>>2)]=$107;
      var $109=HEAP32[(($61)>>2)];
      var $110=$109;
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+24)|0);
      var $113=HEAP32[(($112)>>2)];
      FUNCTION_TABLE[$113]($__nm, $109);
      var $114=$61;
      __label__ = 7; break;
    case 6: // $115
      var $116=$__np;
      var $117=$60;
      HEAP32[(($60)>>2)]=$116;
      var $118=HEAP32[(($60)>>2)];
      var $119=$118;
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+28)|0);
      var $122=HEAP32[(($121)>>2)];
      FUNCTION_TABLE[$122]($__nm, $118);
      var $123=$60;
      __label__ = 7; break;
    case 7: // $124
      var $125=$59;
      HEAP32[(($59)>>2)]=$__nm;
      var $126=HEAP32[(($59)>>2)];
      var $127=$58;
      HEAP32[(($58)>>2)]=$126;
      var $128=HEAPU32[(($58)>>2)];
      var $129=$57;
      HEAP32[(($57)>>2)]=$128;
      var $130=HEAP32[(($57)>>2)];
      var $131=(($130)|0);
      var $132=$56;
      HEAP32[(($56)>>2)]=$131;
      var $133=HEAP32[(($56)>>2)];
      var $134=$133;
      var $135=$55;
      HEAP32[(($55)>>2)]=$134;
      var $136=HEAP32[(($55)>>2)];
      var $137=(($136)|0);
      var $138=$55;
      var $139=$56;
      var $140=(($137)|0);
      var $141=$140;
      var $142=(($141)|0);
      var $143=$142;
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=$145 & 1;
      var $147=(($146)|0)!=0;
      var $148=$57;
      if ($147) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $149
      var $150=$51;
      HEAP32[(($51)>>2)]=$128;
      var $151=HEAP32[(($51)>>2)];
      var $152=(($151)|0);
      var $153=$50;
      HEAP32[(($50)>>2)]=$152;
      var $154=HEAP32[(($50)>>2)];
      var $155=$154;
      var $156=$49;
      HEAP32[(($49)>>2)]=$155;
      var $157=HEAP32[(($49)>>2)];
      var $158=(($157)|0);
      var $159=$49;
      var $160=$50;
      var $161=(($158)|0);
      var $162=$161;
      var $163=(($162+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$51;
      var $183 = $164;__label__ = 10; break;
    case 9: // $166
      var $167=$54;
      HEAP32[(($54)>>2)]=$128;
      var $168=HEAP32[(($54)>>2)];
      var $169=(($168)|0);
      var $170=$53;
      HEAP32[(($53)>>2)]=$169;
      var $171=HEAP32[(($53)>>2)];
      var $172=$171;
      var $173=$52;
      HEAP32[(($52)>>2)]=$172;
      var $174=HEAP32[(($52)>>2)];
      var $175=(($174)|0);
      var $176=$52;
      var $177=$53;
      var $178=(($175)|0);
      var $179=$178;
      var $180=(($179+1)|0);
      var $181=(($180)|0);
      var $182=$54;
      var $183 = $181;__label__ = 10; break;
    case 10: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv_exit
      var $183;
      var $184=$58;
      var $185=$47;
      var $186=$48;
      HEAP32[(($47)>>2)]=$__i;
      HEAP32[(($48)>>2)]=$183;
      var $187=HEAP32[(($47)>>2)];
      var $188=HEAP32[(($48)>>2)];
      var $189=$45;
      var $190=$46;
      HEAP32[(($45)>>2)]=$187;
      HEAP32[(($46)>>2)]=$188;
      var $191=HEAP32[(($45)>>2)];
      var $192=(($191)|0);
      var $193=HEAP32[(($46)>>2)];
      HEAP32[(($192)>>2)]=$193;
      var $194=$45;
      var $195=$46;
      var $196=$47;
      var $197=$48;
      var $198=$59;
      __label__ = 11; break;
    case 11: // $199
      var $200=$33;
      HEAP32[(($33)>>2)]=$__nm;
      var $201=HEAPU32[(($33)>>2)];
      var $202=$32;
      HEAP32[(($32)>>2)]=$201;
      var $203=HEAPU32[(($32)>>2)];
      var $204=$31;
      HEAP32[(($31)>>2)]=$203;
      var $205=HEAP32[(($31)>>2)];
      var $206=(($205)|0);
      var $207=$30;
      HEAP32[(($30)>>2)]=$206;
      var $208=HEAP32[(($30)>>2)];
      var $209=$208;
      var $210=$29;
      HEAP32[(($29)>>2)]=$209;
      var $211=HEAP32[(($29)>>2)];
      var $212=(($211)|0);
      var $213=$29;
      var $214=$30;
      var $215=(($212)|0);
      var $216=$215;
      var $217=(($216)|0);
      var $218=$217;
      var $219=HEAPU8[($218)];
      var $220=(($219)&255);
      var $221=$220 & 1;
      var $222=(($221)|0)!=0;
      var $223=$31;
      if ($222) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $224
      var $225=$25;
      HEAP32[(($25)>>2)]=$203;
      var $226=HEAP32[(($25)>>2)];
      var $227=(($226)|0);
      var $228=$24;
      HEAP32[(($24)>>2)]=$227;
      var $229=HEAP32[(($24)>>2)];
      var $230=$229;
      var $231=$23;
      HEAP32[(($23)>>2)]=$230;
      var $232=HEAP32[(($23)>>2)];
      var $233=(($232)|0);
      var $234=$23;
      var $235=$24;
      var $236=(($233)|0);
      var $237=$236;
      var $238=(($237+8)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$25;
      var $258 = $239;__label__ = 14; break;
    case 13: // $241
      var $242=$28;
      HEAP32[(($28)>>2)]=$203;
      var $243=HEAP32[(($28)>>2)];
      var $244=(($243)|0);
      var $245=$27;
      HEAP32[(($27)>>2)]=$244;
      var $246=HEAP32[(($27)>>2)];
      var $247=$246;
      var $248=$26;
      HEAP32[(($26)>>2)]=$247;
      var $249=HEAP32[(($26)>>2)];
      var $250=(($249)|0);
      var $251=$26;
      var $252=$27;
      var $253=(($250)|0);
      var $254=$253;
      var $255=(($254+1)|0);
      var $256=(($255)|0);
      var $257=$28;
      var $258 = $256;__label__ = 14; break;
    case 14: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit_i
      var $258;
      var $259=$32;
      var $260=$18;
      HEAP32[(($18)>>2)]=$201;
      var $261=HEAPU32[(($18)>>2)];
      var $262=$17;
      HEAP32[(($17)>>2)]=$261;
      var $263=HEAP32[(($17)>>2)];
      var $264=(($263)|0);
      var $265=$16;
      HEAP32[(($16)>>2)]=$264;
      var $266=HEAP32[(($16)>>2)];
      var $267=$266;
      var $268=$15;
      HEAP32[(($15)>>2)]=$267;
      var $269=HEAP32[(($15)>>2)];
      var $270=(($269)|0);
      var $271=$15;
      var $272=$16;
      var $273=(($270)|0);
      var $274=$273;
      var $275=(($274)|0);
      var $276=$275;
      var $277=HEAPU8[($276)];
      var $278=(($277)&255);
      var $279=$278 & 1;
      var $280=(($279)|0)!=0;
      var $281=$17;
      if ($280) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $282
      var $283=$11;
      HEAP32[(($11)>>2)]=$261;
      var $284=HEAP32[(($11)>>2)];
      var $285=(($284)|0);
      var $286=$10;
      HEAP32[(($10)>>2)]=$285;
      var $287=HEAP32[(($10)>>2)];
      var $288=$287;
      var $289=$9;
      HEAP32[(($9)>>2)]=$288;
      var $290=HEAP32[(($9)>>2)];
      var $291=(($290)|0);
      var $292=$9;
      var $293=$10;
      var $294=(($291)|0);
      var $295=$294;
      var $296=(($295+4)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$11;
      var $319 = $297;__label__ = 17; break;
    case 16: // $299
      var $300=$14;
      HEAP32[(($14)>>2)]=$261;
      var $301=HEAP32[(($14)>>2)];
      var $302=(($301)|0);
      var $303=$13;
      HEAP32[(($13)>>2)]=$302;
      var $304=HEAP32[(($13)>>2)];
      var $305=$304;
      var $306=$12;
      HEAP32[(($12)>>2)]=$305;
      var $307=HEAP32[(($12)>>2)];
      var $308=(($307)|0);
      var $309=$12;
      var $310=$13;
      var $311=(($308)|0);
      var $312=$311;
      var $313=(($312)|0);
      var $314=$313;
      var $315=HEAPU8[($314)];
      var $316=(($315)&255);
      var $317=$316 >> 1;
      var $318=$14;
      var $319 = $317;__label__ = 17; break;
    case 17: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv_exit
      var $319;
      var $320=$18;
      var $321=(($258+$319)|0);
      var $322=$21;
      var $323=$22;
      HEAP32[(($21)>>2)]=$72;
      HEAP32[(($22)>>2)]=$321;
      var $324=HEAP32[(($21)>>2)];
      var $325=HEAP32[(($22)>>2)];
      var $326=$19;
      var $327=$20;
      HEAP32[(($19)>>2)]=$324;
      HEAP32[(($20)>>2)]=$325;
      var $328=HEAP32[(($19)>>2)];
      var $329=(($328)|0);
      var $330=HEAP32[(($20)>>2)];
      HEAP32[(($329)>>2)]=$330;
      var $331=$19;
      var $332=$20;
      var $333=$21;
      var $334=$22;
      var $335=$33;
      var $336=$5;
      var $337=$6;
      HEAP32[(($5)>>2)]=$__i;
      HEAP32[(($6)>>2)]=$72;
      var $338=HEAP32[(($5)>>2)];
      var $339=HEAP32[(($6)>>2)];
      var $340=$3;
      var $341=$4;
      HEAP32[(($3)>>2)]=$338;
      HEAP32[(($4)>>2)]=$339;
      var $342=HEAP32[(($3)>>2)];
      var $343=$2;
      HEAP32[(($2)>>2)]=$342;
      var $344=HEAP32[(($2)>>2)];
      var $345=(($344)|0);
      var $346=HEAP32[(($345)>>2)];
      var $347=$2;
      var $348=HEAP32[(($4)>>2)];
      var $349=$1;
      HEAP32[(($1)>>2)]=$348;
      var $350=HEAP32[(($1)>>2)];
      var $351=(($350)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=$1;
      var $354=(($346)|0)==(($352)|0);
      var $355=$3;
      var $356=$4;
      var $357=$354 ^ 1;
      var $358=$5;
      var $359=$6;
      if ($357) { __label__ = 18; break; } else { __label__ = 33; break; }
    case 18: // $360
      var $361=$7;
      HEAP32[(($7)>>2)]=$__s;
      var $362=HEAP32[(($7)>>2)];
      var $363=$7;
      __label__ = 19; break;
    case 19: // $364
      var $365=$8;
      HEAP32[(($8)>>2)]=$__i;
      var $366=HEAP32[(($8)>>2)];
      var $367=(($366)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=$8;
      var $370=HEAP8[($368)];
      var $371=$41;
      HEAP32[(($41)>>2)]=$362;
      $42=$370;
      var $372=HEAPU32[(($41)>>2)];
      var $373=(($372)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=(($374)|0)!=0;
      if ($375) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $376
      var $377=(($372)|0);
      var $378=HEAP32[(($377)>>2)];
      var $379=$42;
      var $380=$38;
      var $381=$39;
      HEAP32[(($39)>>2)]=$378;
      $40=$379;
      var $382=HEAPU32[(($39)>>2)];
      var $383=(($382+24)|0);
      var $384=HEAP32[(($383)>>2)];
      var $385=(($382+28)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=(($384)|0)==(($386)|0);
      if ($387) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $388
      var $389=$382;
      var $390=HEAP32[(($389)>>2)];
      var $391=(($390+52)|0);
      var $392=HEAP32[(($391)>>2)];
      var $393=$40;
      $37=$393;
      var $394=$37;
      var $395=(($394)&255);
      var $396=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$392]($382, $395) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 32; break; };
    case 22: // $_noexc
      HEAP32[(($38)>>2)]=$396;
      __label__ = 24; break;
    case 23: // $397
      var $398=$40;
      var $399=(($382+24)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=(($400+1)|0);
      HEAP32[(($399)>>2)]=$401;
      HEAP8[($400)]=$398;
      var $402=$40;
      $36=$402;
      var $403=$36;
      var $404=(($403)&255);
      HEAP32[(($38)>>2)]=$404;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sputcEc_exit_i
      var $405=HEAP32[(($38)>>2)];
      var $406=$38;
      var $407=$39;
      var $408=$34;
      var $409=$35;
      HEAP32[(($34)>>2)]=$405;
      HEAP32[(($35)>>2)]=-1;
      var $410=HEAP32[(($34)>>2)];
      var $411=HEAP32[(($35)>>2)];
      var $412=(($410)|0)==(($411)|0);
      var $413=$34;
      var $414=$35;
      if ($412) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $415
      var $416=(($372)|0);
      HEAP32[(($416)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119ostreambuf_iteratorIcNS_11char_traitsIcEEEaSEc_exit
      var $417=$41;
      __label__ = 27; break;
    case 27: // $418
      __label__ = 28; break;
    case 28: // $419
      var $420=$43;
      HEAP32[(($43)>>2)]=$__i;
      var $421=HEAP32[(($43)>>2)];
      var $422=(($421)|0);
      var $423=HEAP32[(($422)>>2)];
      var $424=(($423+1)|0);
      HEAP32[(($422)>>2)]=$424;
      var $425=$43;
      var $426=$44;
      HEAP32[(($44)>>2)]=$__s;
      var $427=HEAP32[(($44)>>2)];
      var $428=$44;
      __label__ = 29; break;
    case 29: // $429
      __label__ = 11; break;
    case 30: // $430
      var $431=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $432=$431.f0;
      $70=$432;
      var $433=$431.f1;
      $71=$433;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 37; break; }
    case 31: // $434
      __label__ = 36; break;
    case 32: // $435
      var $436=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $437=$436.f0;
      $70=$437;
      var $438=$436.f1;
      $71=$438;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 33: // $439
      var $440=$agg_result;
      var $441=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($440)>>2)]=HEAP32[(($441)>>2)];
      $73=1;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nm);
      __label__ = 35; break;
    case 34: // $442
      __label__ = 36; break;
    case 35: // $443
      STACKTOP = __stackBase__;
      return;
    case 36: // $444
      var $445=$70;
      var $446=$70;
      var $447=$71;
      var $448=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $446, tempValue);
      var $449=($448.f1 = $447, $448);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $450
      var $451=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__fmt=__stackBase__+4;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+12;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+24;
      var $__op=__stackBase__+48;
      var $__oe=__stackBase__+52;
      var $6=__stackBase__+56;
      var $7;
      var $8;
      var $9=__stackBase__+60;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      $5=$__v;
      var $10=$2;
      var $11=$__fmt;
      assert(6 % 1 === 0, 'memcpy given ' + 6 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt)|0)+5)];
      $__len=((STRING_TABLE.__str5242)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 1, $19);
      $__nbuf=12;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $24=$5;
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl["X"]=1;

function __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($__nb, $__ne, $__iob) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      $3=$__nb;
      $4=$__ne;
      $5=$__iob;
      var $6=$5;
      var $7=$1;
      HEAP32[(($1)>>2)]=$6;
      var $8=HEAP32[(($1)>>2)];
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$1;
      var $12=$10 & 176;
      if ($12 == 16) {
        __label__ = 1; break;
      }
      else if ($12 == 32) {
        __label__ = 10; break;
      }
      else if ($12 == 128) {
        __label__ = 11; break;
      }
      else {
      __label__ = 12; break;
      }
      
    case 1: // $13
      var $14=$3;
      var $15=(($14)|0);
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=(($17)|0)==45;
      if ($18) { __label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $19
      var $20=$3;
      var $21=(($20)|0);
      var $22=HEAP8[($21)];
      var $23=(($22 << 24) >> 24);
      var $24=(($23)|0)==43;
      if ($24) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $25
      var $26=$3;
      var $27=(($26+1)|0);
      $2=$27;
      __label__ = 14; break;
    case 4: // $28
      var $29=$4;
      var $30=$3;
      var $31=$29;
      var $32=$30;
      var $33=(($31-$32)|0);
      var $34=(($33)|0) >= 2;
      if ($34) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $35
      var $36=$3;
      var $37=(($36)|0);
      var $38=HEAP8[($37)];
      var $39=(($38 << 24) >> 24);
      var $40=(($39)|0)==48;
      if ($40) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $41
      var $42=$3;
      var $43=(($42+1)|0);
      var $44=HEAP8[($43)];
      var $45=(($44 << 24) >> 24);
      var $46=(($45)|0)==120;
      if ($46) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $47
      var $48=$3;
      var $49=(($48+1)|0);
      var $50=HEAP8[($49)];
      var $51=(($50 << 24) >> 24);
      var $52=(($51)|0)==88;
      if ($52) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $53
      var $54=$3;
      var $55=(($54+2)|0);
      $2=$55;
      __label__ = 14; break;
    case 9: // $56
      __label__ = 13; break;
    case 10: // $57
      var $58=$4;
      $2=$58;
      __label__ = 14; break;
    case 11: // $59
      __label__ = 12; break;
    case 12: // $60
      __label__ = 13; break;
    case 13: // $61
      var $62=$3;
      $2=$62;
      __label__ = 14; break;
    case 14: // $63
      var $64=$2;
      STACKTOP = __stackBase__;
      return $64;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE["X"]=1;

function __ZNSt3__111__sprintf_lEPcPvPKcz($__s, $__l, $__format) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46;
      var $47;
      var $48;
      var $49;
      var $__va=__stackBase__+188;
      var $__current=__stackBase__+192;
      var $__res;
      var $50;
      var $51;
      var $52;
      $47=$__s;
      $48=$__l;
      $49=$__format;
      var $53=$__va;
      HEAP32[(($53)>>2)]=arguments[__ZNSt3__111__sprintf_lEPcPvPKcz.length];
      var $54=$48;
      var $55=_uselocale($54);
      var $56=$43;
      var $57=$44;
      var $58=$45;
      HEAP32[(($43)>>2)]=$__current;
      HEAP32[(($44)>>2)]=$55;
      HEAP32[(($45)>>2)]=1680;
      var $59=HEAP32[(($43)>>2)];
      var $60=HEAP32[(($44)>>2)];
      var $61=HEAP32[(($45)>>2)];
      var $62=$40;
      var $63=$41;
      var $64=$42;
      HEAP32[(($40)>>2)]=$59;
      HEAP32[(($41)>>2)]=$60;
      HEAP32[(($42)>>2)]=$61;
      var $65=HEAP32[(($40)>>2)];
      var $66=(($65)|0);
      var $67=$39;
      HEAP32[(($39)>>2)]=$41;
      var $68=HEAP32[(($39)>>2)];
      var $69=$39;
      var $70=HEAP32[(($68)>>2)];
      var $71=$25;
      HEAP32[(($25)>>2)]=$42;
      var $72=HEAP32[(($25)>>2)];
      var $73=$25;
      var $74=HEAP32[(($72)>>2)];
      var $75=$36;
      var $76=$37;
      var $77=$38;
      HEAP32[(($36)>>2)]=$66;
      HEAP32[(($37)>>2)]=$70;
      HEAP32[(($38)>>2)]=$74;
      var $78=HEAP32[(($36)>>2)];
      var $79=HEAP32[(($37)>>2)];
      var $80=HEAP32[(($38)>>2)];
      var $81=$33;
      var $82=$34;
      var $83=$35;
      HEAP32[(($33)>>2)]=$78;
      HEAP32[(($34)>>2)]=$79;
      HEAP32[(($35)>>2)]=$80;
      var $84=HEAP32[(($33)>>2)];
      var $85=$84;
      var $86=$32;
      HEAP32[(($32)>>2)]=$34;
      var $87=HEAP32[(($32)>>2)];
      var $88=$32;
      var $89=HEAP32[(($87)>>2)];
      var $90=$26;
      HEAP32[(($26)>>2)]=$35;
      var $91=HEAP32[(($26)>>2)];
      var $92=$26;
      var $93=HEAP32[(($91)>>2)];
      var $94=$29;
      var $95=$30;
      var $96=$31;
      HEAP32[(($29)>>2)]=$85;
      HEAP32[(($30)>>2)]=$89;
      HEAP32[(($31)>>2)]=$93;
      var $97=HEAP32[(($29)>>2)];
      var $98=(($97)|0);
      var $99=$28;
      HEAP32[(($28)>>2)]=$30;
      var $100=HEAP32[(($28)>>2)];
      var $101=$28;
      var $102=HEAP32[(($100)>>2)];
      HEAP32[(($98)>>2)]=$102;
      var $103=(($97+4)|0);
      var $104=$27;
      HEAP32[(($27)>>2)]=$31;
      var $105=HEAP32[(($27)>>2)];
      var $106=$27;
      var $107=HEAP32[(($105)>>2)];
      HEAP32[(($103)>>2)]=$107;
      var $108=$29;
      var $109=$30;
      var $110=$31;
      var $111=$33;
      var $112=$34;
      var $113=$35;
      var $114=$36;
      var $115=$37;
      var $116=$38;
      var $117=$40;
      var $118=$41;
      var $119=$42;
      var $120=$43;
      var $121=$44;
      var $122=$45;
      var $123=$47;
      var $124=$49;
      var $125=HEAP32[(($__va)>>2)];
      var $126=(function() { try { __THREW__ = false; return _vsprintf($123, $124, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $127
      $__res=$126;
      var $128=$__va;
      ;
      var $129=$__res;
      $46=$129;
      $52=1;
      var $130=$12;
      HEAP32[(($12)>>2)]=$__current;
      var $131=HEAP32[(($12)>>2)];
      var $132=$11;
      HEAP32[(($11)>>2)]=$131;
      var $133=HEAP32[(($11)>>2)];
      var $134=$7;
      var $135=$8;
      var $136=$__tmp_i_i_i1;
      var $137=$9;
      var $138=$10;
      HEAP32[(($7)>>2)]=$133;
      HEAP32[(($8)>>2)]=0;
      var $139=HEAP32[(($7)>>2)];
      var $140=(($139)|0);
      var $141=$6;
      HEAP32[(($6)>>2)]=$140;
      var $142=HEAP32[(($6)>>2)];
      var $143=$142;
      var $144=$5;
      HEAP32[(($5)>>2)]=$143;
      var $145=HEAP32[(($5)>>2)];
      var $146=(($145)|0);
      var $147=$5;
      var $148=$6;
      var $149=HEAP32[(($146)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$149;
      var $150=HEAP32[(($8)>>2)];
      var $151=(($139)|0);
      var $152=$4;
      HEAP32[(($4)>>2)]=$151;
      var $153=HEAP32[(($4)>>2)];
      var $154=$153;
      var $155=$3;
      HEAP32[(($3)>>2)]=$154;
      var $156=HEAP32[(($3)>>2)];
      var $157=(($156)|0);
      var $158=$3;
      var $159=$4;
      HEAP32[(($157)>>2)]=$150;
      var $160=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $162
      var $163=(($139)|0);
      var $164=$2;
      HEAP32[(($2)>>2)]=$163;
      var $165=HEAP32[(($2)>>2)];
      var $166=$165;
      var $167=$1;
      HEAP32[(($1)>>2)]=$166;
      var $168=HEAP32[(($1)>>2)];
      var $169=(($168+4)|0);
      var $170=$1;
      var $171=$2;
      var $172=HEAP32[(($169)>>2)];
      var $173=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $174=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$172]($173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $175
      __label__ = 5; break;
    case 4: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $178=$177.f0;
      HEAP32[(($9)>>2)]=$178;
      var $179=$177.f1;
      HEAP32[(($10)>>2)]=$179;
      var $180=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($180);
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit2
      var $181=$7;
      var $182=$8;
      var $183=$__tmp_i_i_i1;
      var $184=$9;
      var $185=$10;
      var $186=$11;
      var $187=$12;
      var $188=$46;
      STACKTOP = __stackBase__;
      return $188;
    case 6: // $189
      var $190=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $191=$190.f0;
      $50=$191;
      var $192=$190.f1;
      $51=$192;
      var $193=$24;
      HEAP32[(($24)>>2)]=$__current;
      var $194=HEAP32[(($24)>>2)];
      var $195=$23;
      HEAP32[(($23)>>2)]=$194;
      var $196=HEAP32[(($23)>>2)];
      var $197=$19;
      var $198=$20;
      var $199=$__tmp_i_i_i;
      var $200=$21;
      var $201=$22;
      HEAP32[(($19)>>2)]=$196;
      HEAP32[(($20)>>2)]=0;
      var $202=HEAP32[(($19)>>2)];
      var $203=(($202)|0);
      var $204=$18;
      HEAP32[(($18)>>2)]=$203;
      var $205=HEAP32[(($18)>>2)];
      var $206=$205;
      var $207=$17;
      HEAP32[(($17)>>2)]=$206;
      var $208=HEAP32[(($17)>>2)];
      var $209=(($208)|0);
      var $210=$17;
      var $211=$18;
      var $212=HEAP32[(($209)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$212;
      var $213=HEAP32[(($20)>>2)];
      var $214=(($202)|0);
      var $215=$16;
      HEAP32[(($16)>>2)]=$214;
      var $216=HEAP32[(($16)>>2)];
      var $217=$216;
      var $218=$15;
      HEAP32[(($15)>>2)]=$217;
      var $219=HEAP32[(($15)>>2)];
      var $220=(($219)|0);
      var $221=$15;
      var $222=$16;
      HEAP32[(($220)>>2)]=$213;
      var $223=HEAP32[(($__tmp_i_i_i)>>2)];
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $225
      var $226=(($202)|0);
      var $227=$14;
      HEAP32[(($14)>>2)]=$226;
      var $228=HEAP32[(($14)>>2)];
      var $229=$228;
      var $230=$13;
      HEAP32[(($13)>>2)]=$229;
      var $231=HEAP32[(($13)>>2)];
      var $232=(($231+4)|0);
      var $233=$13;
      var $234=$14;
      var $235=HEAP32[(($232)>>2)];
      var $236=HEAP32[(($__tmp_i_i_i)>>2)];
      var $237=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$235]($236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $238
      __label__ = 10; break;
    case 9: // $239
      var $240=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $241=$240.f0;
      HEAP32[(($21)>>2)]=$241;
      var $242=$240.f1;
      HEAP32[(($22)>>2)]=$242;
      var $243=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($243);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit
      var $244=$19;
      var $245=$20;
      var $246=$__tmp_i_i_i;
      var $247=$21;
      var $248=$22;
      var $249=$23;
      var $250=$24;
      __label__ = 11; break;
    case 11: // $251
      __label__ = 12; break;
    case 12: // $252
      var $253=$50;
      var $254=$50;
      var $255=$51;
      var $256=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $254, tempValue);
      var $257=($256.f1 = $255, $256);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__sprintf_lEPcPvPKcz["X"]=1;

function __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($__nb, $__np, $__ne, $__ob, $__op, $__oe, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 336; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $__t_i_i_i4=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48;
      var $49=__stackBase__+192;
      var $50;
      var $51=__stackBase__+196;
      var $52;
      var $53=__stackBase__+200;
      var $54=__stackBase__+204;
      var $55=__stackBase__+208;
      var $56=__stackBase__+212;
      var $57=__stackBase__+216;
      var $58;
      var $59=__stackBase__+220;
      var $60=__stackBase__+224;
      var $61=__stackBase__+228;
      var $62=__stackBase__+232;
      var $63=__stackBase__+236;
      var $__t_i_i_i=__stackBase__+240;
      var $64=__stackBase__+244;
      var $65=__stackBase__+248;
      var $66=__stackBase__+252;
      var $67=__stackBase__+256;
      var $68=__stackBase__+260;
      var $69=__stackBase__+264;
      var $70=__stackBase__+268;
      var $71=__stackBase__+272;
      var $72=__stackBase__+276;
      var $73=__stackBase__+280;
      var $74=__stackBase__+284;
      var $75=__stackBase__+288;
      var $76=__stackBase__+292;
      var $77=__stackBase__+296;
      var $78=__stackBase__+300;
      var $79=__stackBase__+304;
      var $80=__stackBase__+308;
      var $81=__stackBase__+312;
      var $82=__stackBase__+316;
      var $83=__stackBase__+320;
      var $84;
      var $85;
      var $86;
      var $87;
      var $88;
      var $89;
      var $90;
      var $__ct;
      var $__npt;
      var $__grouping=__stackBase__+324;
      var $91;
      var $92;
      var $__nf;
      var $__thousands_sep;
      var $__dc;
      var $__dg;
      var $__p;
      $84=$__nb;
      $85=$__np;
      $86=$__ne;
      $87=$__ob;
      $88=$__op;
      $89=$__oe;
      $90=$__loc;
      var $93=$90;
      var $94=$83;
      HEAP32[(($83)>>2)]=$93;
      var $95=HEAP32[(($83)>>2)];
      var $96=__ZNKSt3__16locale9use_facetERNS0_2idE($95, __ZNSt3__15ctypeIcE2idE);
      var $97=$96;
      var $98=$83;
      $__ct=$97;
      var $99=$90;
      var $100=$82;
      HEAP32[(($82)>>2)]=$99;
      var $101=HEAP32[(($82)>>2)];
      var $102=__ZNKSt3__16locale9use_facetERNS0_2idE($101, __ZNSt3__18numpunctIcE2idE);
      var $103=$102;
      var $104=$82;
      $__npt=$103;
      var $105=$__npt;
      var $106=$81;
      HEAP32[(($81)>>2)]=$105;
      var $107=HEAP32[(($81)>>2)];
      var $108=$107;
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      FUNCTION_TABLE[$111]($__grouping, $107);
      var $112=$81;
      var $113=$80;
      HEAP32[(($80)>>2)]=$__grouping;
      var $114=HEAP32[(($80)>>2)];
      var $115=$79;
      HEAP32[(($79)>>2)]=$114;
      var $116=HEAPU32[(($79)>>2)];
      var $117=$78;
      HEAP32[(($78)>>2)]=$116;
      var $118=HEAP32[(($78)>>2)];
      var $119=(($118)|0);
      var $120=$77;
      HEAP32[(($77)>>2)]=$119;
      var $121=HEAP32[(($77)>>2)];
      var $122=$121;
      var $123=$76;
      HEAP32[(($76)>>2)]=$122;
      var $124=HEAP32[(($76)>>2)];
      var $125=(($124)|0);
      var $126=$76;
      var $127=$77;
      var $128=(($125)|0);
      var $129=$128;
      var $130=(($129)|0);
      var $131=$130;
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=$133 & 1;
      var $135=(($134)|0)!=0;
      var $136=$78;
      if ($135) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $137
      var $138=$72;
      HEAP32[(($72)>>2)]=$116;
      var $139=HEAP32[(($72)>>2)];
      var $140=(($139)|0);
      var $141=$71;
      HEAP32[(($71)>>2)]=$140;
      var $142=HEAP32[(($71)>>2)];
      var $143=$142;
      var $144=$70;
      HEAP32[(($70)>>2)]=$143;
      var $145=HEAP32[(($70)>>2)];
      var $146=(($145)|0);
      var $147=$70;
      var $148=$71;
      var $149=(($146)|0);
      var $150=$149;
      var $151=(($150+4)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$72;
      var $174 = $152;__label__ = 3; break;
    case 2: // $154
      var $155=$75;
      HEAP32[(($75)>>2)]=$116;
      var $156=HEAP32[(($75)>>2)];
      var $157=(($156)|0);
      var $158=$74;
      HEAP32[(($74)>>2)]=$157;
      var $159=HEAP32[(($74)>>2)];
      var $160=$159;
      var $161=$73;
      HEAP32[(($73)>>2)]=$160;
      var $162=HEAP32[(($73)>>2)];
      var $163=(($162)|0);
      var $164=$73;
      var $165=$74;
      var $166=(($163)|0);
      var $167=$166;
      var $168=(($167)|0);
      var $169=$168;
      var $170=HEAPU8[($169)];
      var $171=(($170)&255);
      var $172=$171 >> 1;
      var $173=$75;
      var $174 = $172;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $174;
      var $175=$79;
      var $176=(($174)|0)==0;
      var $177=$80;
      if ($176) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $178
      var $179=$__ct;
      var $180=$84;
      var $181=$86;
      var $182=$87;
      var $183=$53;
      var $184=$54;
      var $185=$55;
      var $186=$56;
      HEAP32[(($53)>>2)]=$179;
      HEAP32[(($54)>>2)]=$180;
      HEAP32[(($55)>>2)]=$181;
      HEAP32[(($56)>>2)]=$182;
      var $187=HEAP32[(($53)>>2)];
      var $188=$187;
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189+32)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=HEAP32[(($54)>>2)];
      var $193=HEAP32[(($55)>>2)];
      var $194=HEAP32[(($56)>>2)];
      var $195=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$191]($187, $192, $193, $194) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $196=$53;
      var $197=$54;
      var $198=$55;
      var $199=$56;
      __label__ = 6; break;
    case 6: // $200
      var $201=$87;
      var $202=$86;
      var $203=$84;
      var $204=$202;
      var $205=$203;
      var $206=(($204-$205)|0);
      var $207=(($201+$206)|0);
      var $208=$89;
      HEAP32[(($208)>>2)]=$207;
      __label__ = 59; break;
    case 7: // $209
      var $210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $211=$210.f0;
      $91=$211;
      var $212=$210.f1;
      $92=$212;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 8: // $213
      var $214=$87;
      var $215=$89;
      HEAP32[(($215)>>2)]=$214;
      var $216=$84;
      $__nf=$216;
      var $217=$__nf;
      var $218=HEAP8[($217)];
      var $219=(($218 << 24) >> 24);
      var $220=(($219)|0)==45;
      if ($220) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $221
      var $222=$__nf;
      var $223=HEAP8[($222)];
      var $224=(($223 << 24) >> 24);
      var $225=(($224)|0)==43;
      if ($225) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $226
      var $227=$__ct;
      var $228=$__nf;
      var $229=(($228+1)|0);
      $__nf=$229;
      var $230=HEAP8[($228)];
      var $231=$51;
      HEAP32[(($51)>>2)]=$227;
      $52=$230;
      var $232=HEAP32[(($51)>>2)];
      var $233=$232;
      var $234=HEAP32[(($233)>>2)];
      var $235=(($234+28)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=$52;
      var $238=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$236]($232, $237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 7; break; };
    case 11: // $_ZNKSt3__15ctypeIcE5widenEc_exit1
      var $239=$51;
      __label__ = 12; break;
    case 12: // $240
      var $241=$89;
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242+1)|0);
      HEAP32[(($241)>>2)]=$243;
      HEAP8[($242)]=$238;
      __label__ = 13; break;
    case 13: // $244
      var $245=$86;
      var $246=$__nf;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      var $250=(($249)|0) >= 2;
      if ($250) { __label__ = 14; break; } else { __label__ = 22; break; }
    case 14: // $251
      var $252=$__nf;
      var $253=(($252)|0);
      var $254=HEAP8[($253)];
      var $255=(($254 << 24) >> 24);
      var $256=(($255)|0)==48;
      if ($256) { __label__ = 15; break; } else { __label__ = 22; break; }
    case 15: // $257
      var $258=$__nf;
      var $259=(($258+1)|0);
      var $260=HEAP8[($259)];
      var $261=(($260 << 24) >> 24);
      var $262=(($261)|0)==120;
      if ($262) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $263
      var $264=$__nf;
      var $265=(($264+1)|0);
      var $266=HEAP8[($265)];
      var $267=(($266 << 24) >> 24);
      var $268=(($267)|0)==88;
      if ($268) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $269
      var $270=$__ct;
      var $271=$__nf;
      var $272=(($271+1)|0);
      $__nf=$272;
      var $273=HEAP8[($271)];
      var $274=$49;
      HEAP32[(($49)>>2)]=$270;
      $50=$273;
      var $275=HEAP32[(($49)>>2)];
      var $276=$275;
      var $277=HEAP32[(($276)>>2)];
      var $278=(($277+28)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=$50;
      var $281=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$279]($275, $280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 7; break; };
    case 18: // $_ZNKSt3__15ctypeIcE5widenEc_exit2
      var $282=$49;
      __label__ = 19; break;
    case 19: // $283
      var $284=$89;
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285+1)|0);
      HEAP32[(($284)>>2)]=$286;
      HEAP8[($285)]=$281;
      var $287=$__ct;
      var $288=$__nf;
      var $289=(($288+1)|0);
      $__nf=$289;
      var $290=HEAP8[($288)];
      var $291=$47;
      HEAP32[(($47)>>2)]=$287;
      $48=$290;
      var $292=HEAP32[(($47)>>2)];
      var $293=$292;
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294+28)|0);
      var $296=HEAP32[(($295)>>2)];
      var $297=$48;
      var $298=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$296]($292, $297) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 7; break; };
    case 20: // $_ZNKSt3__15ctypeIcE5widenEc_exit3
      var $299=$47;
      __label__ = 21; break;
    case 21: // $300
      var $301=$89;
      var $302=HEAP32[(($301)>>2)];
      var $303=(($302+1)|0);
      HEAP32[(($301)>>2)]=$303;
      HEAP8[($302)]=$298;
      __label__ = 22; break;
    case 22: // $304
      var $305=$__nf;
      var $306=$86;
      var $307=$43;
      var $308=$44;
      var $309=$45;
      var $310=$46;
      HEAP32[(($44)>>2)]=$305;
      HEAP32[(($45)>>2)]=$306;
      var $311=HEAP32[(($44)>>2)];
      var $312=HEAP32[(($45)>>2)];
      var $tmp_i5=$43;
      var $tmp1_i6=$46;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i5)]=HEAP8[($tmp1_i6)];
      var $313=$41;
      var $314=$42;
      HEAP32[(($41)>>2)]=$311;
      HEAP32[(($42)>>2)]=$312;
      var $315=HEAP32[(($41)>>2)];
      var $316=HEAP32[(($42)>>2)];
      var $317=(($315)|0)!=(($316)|0);
      if ($317) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $318
      __label__ = 24; break;
    case 24: // $319
      var $320=HEAPU32[(($41)>>2)];
      var $321=HEAP32[(($42)>>2)];
      var $322=(($321-1)|0);
      HEAP32[(($42)>>2)]=$322;
      var $323=(($320)>>>0) < (($322)>>>0);
      if ($323) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $324
      var $325=HEAP32[(($41)>>2)];
      var $326=HEAP32[(($42)>>2)];
      var $327=$39;
      var $328=$40;
      HEAP32[(($39)>>2)]=$325;
      HEAP32[(($40)>>2)]=$326;
      var $329=HEAP32[(($39)>>2)];
      var $330=$38;
      HEAP32[(($38)>>2)]=$329;
      var $331=HEAP32[(($38)>>2)];
      var $332=$38;
      var $333=HEAP8[($331)];
      HEAP8[($__t_i_i_i4)]=$333;
      var $334=HEAP32[(($40)>>2)];
      var $335=$36;
      HEAP32[(($36)>>2)]=$334;
      var $336=HEAP32[(($36)>>2)];
      var $337=$36;
      var $338=HEAP8[($336)];
      var $339=HEAP32[(($39)>>2)];
      HEAP8[($339)]=$338;
      var $340=$37;
      HEAP32[(($37)>>2)]=$__t_i_i_i4;
      var $341=HEAP32[(($37)>>2)];
      var $342=$37;
      var $343=HEAP8[($341)];
      var $344=HEAP32[(($40)>>2)];
      HEAP8[($344)]=$343;
      var $345=$39;
      var $346=$40;
      var $347=HEAP32[(($41)>>2)];
      var $348=(($347+1)|0);
      HEAP32[(($41)>>2)]=$348;
      __label__ = 24; break;
    case 26: // $349
      __label__ = 27; break;
    case 27: // $_ZNSt3__17reverseIPcEEvT_S2__exit7
      var $350=$41;
      var $351=$42;
      var $352=$43;
      var $353=$44;
      var $354=$45;
      var $355=$46;
      __label__ = 28; break;
    case 28: // $356
      var $357=$__npt;
      var $358=$1;
      HEAP32[(($1)>>2)]=$357;
      var $359=HEAP32[(($1)>>2)];
      var $360=$359;
      var $361=HEAP32[(($360)>>2)];
      var $362=(($361+16)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$363]($359) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 7; break; };
    case 29: // $_ZNKSt3__18numpunctIcE13thousands_sepEv_exit
      var $365=$1;
      __label__ = 30; break;
    case 30: // $366
      $__thousands_sep=$364;
      $__dc=0;
      $__dg=0;
      var $367=$__nf;
      $__p=$367;
      __label__ = 31; break;
    case 31: // $368
      var $369=$__p;
      var $370=$86;
      var $371=(($369)>>>0) < (($370)>>>0);
      if ($371) { __label__ = 32; break; } else { __label__ = 52; break; }
    case 32: // $372
      var $373=$__dg;
      var $374=$12;
      var $375=$13;
      HEAP32[(($12)>>2)]=$__grouping;
      HEAP32[(($13)>>2)]=$373;
      var $376=HEAP32[(($12)>>2)];
      var $377=$11;
      HEAP32[(($11)>>2)]=$376;
      var $378=HEAPU32[(($11)>>2)];
      var $379=$10;
      HEAP32[(($10)>>2)]=$378;
      var $380=HEAP32[(($10)>>2)];
      var $381=(($380)|0);
      var $382=$9;
      HEAP32[(($9)>>2)]=$381;
      var $383=HEAP32[(($9)>>2)];
      var $384=$383;
      var $385=$8;
      HEAP32[(($8)>>2)]=$384;
      var $386=HEAP32[(($8)>>2)];
      var $387=(($386)|0);
      var $388=$8;
      var $389=$9;
      var $390=(($387)|0);
      var $391=$390;
      var $392=(($391)|0);
      var $393=$392;
      var $394=HEAPU8[($393)];
      var $395=(($394)&255);
      var $396=$395 & 1;
      var $397=(($396)|0)!=0;
      var $398=$10;
      if ($397) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $399
      var $400=$4;
      HEAP32[(($4)>>2)]=$378;
      var $401=HEAP32[(($4)>>2)];
      var $402=(($401)|0);
      var $403=$3;
      HEAP32[(($3)>>2)]=$402;
      var $404=HEAP32[(($3)>>2)];
      var $405=$404;
      var $406=$2;
      HEAP32[(($2)>>2)]=$405;
      var $407=HEAP32[(($2)>>2)];
      var $408=(($407)|0);
      var $409=$2;
      var $410=$3;
      var $411=(($408)|0);
      var $412=$411;
      var $413=(($412+8)|0);
      var $414=HEAP32[(($413)>>2)];
      var $415=$4;
      var $433 = $414;__label__ = 35; break;
    case 34: // $416
      var $417=$7;
      HEAP32[(($7)>>2)]=$378;
      var $418=HEAP32[(($7)>>2)];
      var $419=(($418)|0);
      var $420=$6;
      HEAP32[(($6)>>2)]=$419;
      var $421=HEAP32[(($6)>>2)];
      var $422=$421;
      var $423=$5;
      HEAP32[(($5)>>2)]=$422;
      var $424=HEAP32[(($5)>>2)];
      var $425=(($424)|0);
      var $426=$5;
      var $427=$6;
      var $428=(($425)|0);
      var $429=$428;
      var $430=(($429+1)|0);
      var $431=(($430)|0);
      var $432=$7;
      var $433 = $431;__label__ = 35; break;
    case 35: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit8
      var $433;
      var $434=$11;
      var $435=HEAP32[(($13)>>2)];
      var $436=(($433+$435)|0);
      var $437=$12;
      var $438=$13;
      __label__ = 36; break;
    case 36: // $439
      var $440=HEAP8[($436)];
      var $441=(($440 << 24) >> 24);
      var $442=(($441)>>>0) > 0;
      if ($442) { __label__ = 37; break; } else { __label__ = 48; break; }
    case 37: // $443
      var $444=$__dc;
      var $445=$__dg;
      var $446=$24;
      var $447=$25;
      HEAP32[(($24)>>2)]=$__grouping;
      HEAP32[(($25)>>2)]=$445;
      var $448=HEAP32[(($24)>>2)];
      var $449=$23;
      HEAP32[(($23)>>2)]=$448;
      var $450=HEAPU32[(($23)>>2)];
      var $451=$22;
      HEAP32[(($22)>>2)]=$450;
      var $452=HEAP32[(($22)>>2)];
      var $453=(($452)|0);
      var $454=$21;
      HEAP32[(($21)>>2)]=$453;
      var $455=HEAP32[(($21)>>2)];
      var $456=$455;
      var $457=$20;
      HEAP32[(($20)>>2)]=$456;
      var $458=HEAP32[(($20)>>2)];
      var $459=(($458)|0);
      var $460=$20;
      var $461=$21;
      var $462=(($459)|0);
      var $463=$462;
      var $464=(($463)|0);
      var $465=$464;
      var $466=HEAPU8[($465)];
      var $467=(($466)&255);
      var $468=$467 & 1;
      var $469=(($468)|0)!=0;
      var $470=$22;
      if ($469) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $471
      var $472=$16;
      HEAP32[(($16)>>2)]=$450;
      var $473=HEAP32[(($16)>>2)];
      var $474=(($473)|0);
      var $475=$15;
      HEAP32[(($15)>>2)]=$474;
      var $476=HEAP32[(($15)>>2)];
      var $477=$476;
      var $478=$14;
      HEAP32[(($14)>>2)]=$477;
      var $479=HEAP32[(($14)>>2)];
      var $480=(($479)|0);
      var $481=$14;
      var $482=$15;
      var $483=(($480)|0);
      var $484=$483;
      var $485=(($484+8)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=$16;
      var $505 = $486;__label__ = 40; break;
    case 39: // $488
      var $489=$19;
      HEAP32[(($19)>>2)]=$450;
      var $490=HEAP32[(($19)>>2)];
      var $491=(($490)|0);
      var $492=$18;
      HEAP32[(($18)>>2)]=$491;
      var $493=HEAP32[(($18)>>2)];
      var $494=$493;
      var $495=$17;
      HEAP32[(($17)>>2)]=$494;
      var $496=HEAP32[(($17)>>2)];
      var $497=(($496)|0);
      var $498=$17;
      var $499=$18;
      var $500=(($497)|0);
      var $501=$500;
      var $502=(($501+1)|0);
      var $503=(($502)|0);
      var $504=$19;
      var $505 = $503;__label__ = 40; break;
    case 40: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $505;
      var $506=$23;
      var $507=HEAP32[(($25)>>2)];
      var $508=(($505+$507)|0);
      var $509=$24;
      var $510=$25;
      __label__ = 41; break;
    case 41: // $511
      var $512=HEAP8[($508)];
      var $513=(($512 << 24) >> 24);
      var $514=(($444)|0)==(($513)|0);
      if ($514) { __label__ = 42; break; } else { __label__ = 48; break; }
    case 42: // $515
      var $516=$__thousands_sep;
      var $517=$89;
      var $518=HEAP32[(($517)>>2)];
      var $519=(($518+1)|0);
      HEAP32[(($517)>>2)]=$519;
      HEAP8[($518)]=$516;
      $__dc=0;
      var $520=$__dg;
      var $521=$35;
      HEAP32[(($35)>>2)]=$__grouping;
      var $522=HEAPU32[(($35)>>2)];
      var $523=$34;
      HEAP32[(($34)>>2)]=$522;
      var $524=HEAP32[(($34)>>2)];
      var $525=(($524)|0);
      var $526=$33;
      HEAP32[(($33)>>2)]=$525;
      var $527=HEAP32[(($33)>>2)];
      var $528=$527;
      var $529=$32;
      HEAP32[(($32)>>2)]=$528;
      var $530=HEAP32[(($32)>>2)];
      var $531=(($530)|0);
      var $532=$32;
      var $533=$33;
      var $534=(($531)|0);
      var $535=$534;
      var $536=(($535)|0);
      var $537=$536;
      var $538=HEAPU8[($537)];
      var $539=(($538)&255);
      var $540=$539 & 1;
      var $541=(($540)|0)!=0;
      var $542=$34;
      if ($541) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $543
      var $544=$28;
      HEAP32[(($28)>>2)]=$522;
      var $545=HEAP32[(($28)>>2)];
      var $546=(($545)|0);
      var $547=$27;
      HEAP32[(($27)>>2)]=$546;
      var $548=HEAP32[(($27)>>2)];
      var $549=$548;
      var $550=$26;
      HEAP32[(($26)>>2)]=$549;
      var $551=HEAP32[(($26)>>2)];
      var $552=(($551)|0);
      var $553=$26;
      var $554=$27;
      var $555=(($552)|0);
      var $556=$555;
      var $557=(($556+4)|0);
      var $558=HEAP32[(($557)>>2)];
      var $559=$28;
      var $580 = $558;__label__ = 45; break;
    case 44: // $560
      var $561=$31;
      HEAP32[(($31)>>2)]=$522;
      var $562=HEAP32[(($31)>>2)];
      var $563=(($562)|0);
      var $564=$30;
      HEAP32[(($30)>>2)]=$563;
      var $565=HEAP32[(($30)>>2)];
      var $566=$565;
      var $567=$29;
      HEAP32[(($29)>>2)]=$566;
      var $568=HEAP32[(($29)>>2)];
      var $569=(($568)|0);
      var $570=$29;
      var $571=$30;
      var $572=(($569)|0);
      var $573=$572;
      var $574=(($573)|0);
      var $575=$574;
      var $576=HEAPU8[($575)];
      var $577=(($576)&255);
      var $578=$577 >> 1;
      var $579=$31;
      var $580 = $578;__label__ = 45; break;
    case 45: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $580;
      var $581=$35;
      var $582=(($580-1)|0);
      var $583=(($520)>>>0) < (($582)>>>0);
      if ($583) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $584
      var $585=$__dg;
      var $586=(($585+1)|0);
      $__dg=$586;
      __label__ = 47; break;
    case 47: // $587
      __label__ = 48; break;
    case 48: // $588
      var $589=$__ct;
      var $590=$__p;
      var $591=HEAP8[($590)];
      var $592=$57;
      HEAP32[(($57)>>2)]=$589;
      $58=$591;
      var $593=HEAP32[(($57)>>2)];
      var $594=$593;
      var $595=HEAP32[(($594)>>2)];
      var $596=(($595+28)|0);
      var $597=HEAP32[(($596)>>2)];
      var $598=$58;
      var $599=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$597]($593, $598) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 7; break; };
    case 49: // $_ZNKSt3__15ctypeIcE5widenEc_exit
      var $600=$57;
      __label__ = 50; break;
    case 50: // $601
      var $602=$89;
      var $603=HEAP32[(($602)>>2)];
      var $604=(($603+1)|0);
      HEAP32[(($602)>>2)]=$604;
      HEAP8[($603)]=$599;
      var $605=$__dc;
      var $606=(($605+1)|0);
      $__dc=$606;
      __label__ = 51; break;
    case 51: // $607
      var $608=$__p;
      var $609=(($608+1)|0);
      $__p=$609;
      __label__ = 31; break;
    case 52: // $610
      var $611=$87;
      var $612=$__nf;
      var $613=$84;
      var $614=$612;
      var $615=$613;
      var $616=(($614-$615)|0);
      var $617=(($611+$616)|0);
      var $618=$89;
      var $619=HEAP32[(($618)>>2)];
      var $620=$66;
      var $621=$67;
      var $622=$68;
      var $623=$69;
      HEAP32[(($67)>>2)]=$617;
      HEAP32[(($68)>>2)]=$619;
      var $624=HEAP32[(($67)>>2)];
      var $625=HEAP32[(($68)>>2)];
      var $tmp_i=$66;
      var $tmp1_i=$69;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $626=$64;
      var $627=$65;
      HEAP32[(($64)>>2)]=$624;
      HEAP32[(($65)>>2)]=$625;
      var $628=HEAP32[(($64)>>2)];
      var $629=HEAP32[(($65)>>2)];
      var $630=(($628)|0)!=(($629)|0);
      if ($630) { __label__ = 53; break; } else { __label__ = 57; break; }
    case 53: // $631
      __label__ = 54; break;
    case 54: // $632
      var $633=HEAPU32[(($64)>>2)];
      var $634=HEAP32[(($65)>>2)];
      var $635=(($634-1)|0);
      HEAP32[(($65)>>2)]=$635;
      var $636=(($633)>>>0) < (($635)>>>0);
      if ($636) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $637
      var $638=HEAP32[(($64)>>2)];
      var $639=HEAP32[(($65)>>2)];
      var $640=$62;
      var $641=$63;
      HEAP32[(($62)>>2)]=$638;
      HEAP32[(($63)>>2)]=$639;
      var $642=HEAP32[(($62)>>2)];
      var $643=$61;
      HEAP32[(($61)>>2)]=$642;
      var $644=HEAP32[(($61)>>2)];
      var $645=$61;
      var $646=HEAP8[($644)];
      HEAP8[($__t_i_i_i)]=$646;
      var $647=HEAP32[(($63)>>2)];
      var $648=$59;
      HEAP32[(($59)>>2)]=$647;
      var $649=HEAP32[(($59)>>2)];
      var $650=$59;
      var $651=HEAP8[($649)];
      var $652=HEAP32[(($62)>>2)];
      HEAP8[($652)]=$651;
      var $653=$60;
      HEAP32[(($60)>>2)]=$__t_i_i_i;
      var $654=HEAP32[(($60)>>2)];
      var $655=$60;
      var $656=HEAP8[($654)];
      var $657=HEAP32[(($63)>>2)];
      HEAP8[($657)]=$656;
      var $658=$62;
      var $659=$63;
      var $660=HEAP32[(($64)>>2)];
      var $661=(($660+1)|0);
      HEAP32[(($64)>>2)]=$661;
      __label__ = 54; break;
    case 56: // $662
      __label__ = 57; break;
    case 57: // $_ZNSt3__17reverseIPcEEvT_S2__exit
      var $663=$64;
      var $664=$65;
      var $665=$66;
      var $666=$67;
      var $667=$68;
      var $668=$69;
      __label__ = 58; break;
    case 58: // $669
      __label__ = 59; break;
    case 59: // $670
      var $671=$85;
      var $672=$86;
      var $673=(($671)|0)==(($672)|0);
      if ($673) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $674
      var $675=$89;
      var $676=HEAP32[(($675)>>2)];
      var $677=$88;
      HEAP32[(($677)>>2)]=$676;
      __label__ = 62; break;
    case 61: // $678
      var $679=$87;
      var $680=$85;
      var $681=$84;
      var $682=$680;
      var $683=$681;
      var $684=(($682-$683)|0);
      var $685=(($679+$684)|0);
      var $686=$88;
      HEAP32[(($686)>>2)]=$685;
      __label__ = 62; break;
    case 62: // $687
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 63: // $688
      __label__ = 64; break;
    case 64: // $689
      var $690=$91;
      var $691=$91;
      var $692=$92;
      var $693=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $691, tempValue);
      var $694=($693.f1 = $692, $693);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 65: // $695
      var $696=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE["X"]=1;

function __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $__s, $__ob, $__op, $__oe, $__iob, $__fl) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9;
      var $10=__stackBase__+24;
      var $11;
      var $12=__stackBase__+28;
      var $13=__stackBase__+32;
      var $14;
      var $15;
      var $16=__stackBase__+36;
      var $17=__stackBase__+40;
      var $18;
      var $19=__stackBase__+44;
      var $20;
      var $21=__stackBase__+48;
      var $22=__stackBase__+52;
      var $23=__stackBase__+56;
      var $24=__stackBase__+60;
      var $25=__stackBase__+64;
      var $26;
      var $27;
      var $28=__stackBase__+68;
      var $29=__stackBase__+72;
      var $30;
      var $31=__stackBase__+76;
      var $32;
      var $33=__stackBase__+80;
      var $34=__stackBase__+84;
      var $35=__stackBase__+88;
      var $__r_i=__stackBase__+92;
      var $36=__stackBase__+96;
      var $37;
      var $38;
      var $39;
      var $40;
      var $41;
      var $__sz;
      var $__ns;
      $37=$__ob;
      $38=$__op;
      $39=$__oe;
      $40=$__iob;
      $41=$__fl;
      var $42=$39;
      var $43=$37;
      var $44=$42;
      var $45=$43;
      var $46=(($44-$45)|0);
      $__sz=$46;
      var $47=$40;
      var $48=$36;
      HEAP32[(($36)>>2)]=$47;
      var $49=HEAP32[(($36)>>2)];
      var $50=(($49+12)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=$36;
      $__ns=$51;
      var $53=$__ns;
      var $54=$__sz;
      var $55=(($53)|0) > (($54)|0);
      if ($55) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $56
      var $57=$__sz;
      var $58=$__ns;
      var $59=(($58-$57)|0);
      $__ns=$59;
      __label__ = 3; break;
    case 2: // $60
      $__ns=0;
      __label__ = 3; break;
    case 3: // $61
      __label__ = 4; break;
    case 4: // $62
      var $63=$37;
      var $64=$38;
      var $65=(($63)>>>0) < (($64)>>>0);
      if ($65) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $66
      var $67=$23;
      HEAP32[(($23)>>2)]=$__s;
      var $68=HEAP32[(($23)>>2)];
      var $69=$23;
      var $70=$37;
      var $71=HEAP8[($70)];
      var $72=$10;
      HEAP32[(($10)>>2)]=$68;
      $11=$71;
      var $73=HEAPU32[(($10)>>2)];
      var $74=(($73)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75)|0)!=0;
      if ($76) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $77
      var $78=(($73)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=$11;
      var $81=$7;
      var $82=$8;
      HEAP32[(($8)>>2)]=$79;
      $9=$80;
      var $83=HEAPU32[(($8)>>2)];
      var $84=(($83+24)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=(($83+28)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($85)|0)==(($87)|0);
      if ($88) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $89
      var $90=$83;
      var $91=HEAP32[(($90)>>2)];
      var $92=(($91+52)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$9;
      $6=$94;
      var $95=$6;
      var $96=(($95)&255);
      var $97=FUNCTION_TABLE[$93]($83, $96);
      HEAP32[(($7)>>2)]=$97;
      __label__ = 9; break;
    case 8: // $98
      var $99=$9;
      var $100=(($83+24)|0);
      var $101=HEAP32[(($100)>>2)];
      var $102=(($101+1)|0);
      HEAP32[(($100)>>2)]=$102;
      HEAP8[($101)]=$99;
      var $103=$9;
      $5=$103;
      var $104=$5;
      var $105=(($104)&255);
      HEAP32[(($7)>>2)]=$105;
      __label__ = 9; break;
    case 9: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sputcEc_exit_i3
      var $106=HEAP32[(($7)>>2)];
      var $107=$7;
      var $108=$8;
      var $109=$3;
      var $110=$4;
      HEAP32[(($3)>>2)]=$106;
      HEAP32[(($4)>>2)]=-1;
      var $111=HEAP32[(($3)>>2)];
      var $112=HEAP32[(($4)>>2)];
      var $113=(($111)|0)==(($112)|0);
      var $114=$3;
      var $115=$4;
      if ($113) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $116
      var $117=(($73)|0);
      HEAP32[(($117)>>2)]=0;
      __label__ = 11; break;
    case 11: // $_ZNSt3__119ostreambuf_iteratorIcNS_11char_traitsIcEEEaSEc_exit4
      var $118=$10;
      __label__ = 12; break;
    case 12: // $119
      var $120=$37;
      var $121=(($120+1)|0);
      $37=$121;
      var $122=$2;
      HEAP32[(($2)>>2)]=$__s;
      var $123=HEAP32[(($2)>>2)];
      var $124=$2;
      __label__ = 4; break;
    case 13: // $125
      __label__ = 14; break;
    case 14: // $126
      var $127=$__ns;
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $129
      var $130=$1;
      HEAP32[(($1)>>2)]=$__s;
      var $131=HEAP32[(($1)>>2)];
      var $132=$1;
      var $133=$41;
      var $134=$19;
      HEAP32[(($19)>>2)]=$131;
      $20=$133;
      var $135=HEAPU32[(($19)>>2)];
      var $136=(($135)|0);
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137)|0)!=0;
      if ($138) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $139
      var $140=(($135)|0);
      var $141=HEAP32[(($140)>>2)];
      var $142=$20;
      var $143=$16;
      var $144=$17;
      HEAP32[(($17)>>2)]=$141;
      $18=$142;
      var $145=HEAPU32[(($17)>>2)];
      var $146=(($145+24)|0);
      var $147=HEAP32[(($146)>>2)];
      var $148=(($145+28)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($147)|0)==(($149)|0);
      if ($150) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $151
      var $152=$145;
      var $153=HEAP32[(($152)>>2)];
      var $154=(($153+52)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$18;
      $15=$156;
      var $157=$15;
      var $158=(($157)&255);
      var $159=FUNCTION_TABLE[$155]($145, $158);
      HEAP32[(($16)>>2)]=$159;
      __label__ = 19; break;
    case 18: // $160
      var $161=$18;
      var $162=(($145+24)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=(($163+1)|0);
      HEAP32[(($162)>>2)]=$164;
      HEAP8[($163)]=$161;
      var $165=$18;
      $14=$165;
      var $166=$14;
      var $167=(($166)&255);
      HEAP32[(($16)>>2)]=$167;
      __label__ = 19; break;
    case 19: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sputcEc_exit_i1
      var $168=HEAP32[(($16)>>2)];
      var $169=$16;
      var $170=$17;
      var $171=$12;
      var $172=$13;
      HEAP32[(($12)>>2)]=$168;
      HEAP32[(($13)>>2)]=-1;
      var $173=HEAP32[(($12)>>2)];
      var $174=HEAP32[(($13)>>2)];
      var $175=(($173)|0)==(($174)|0);
      var $176=$12;
      var $177=$13;
      if ($175) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $178
      var $179=(($135)|0);
      HEAP32[(($179)>>2)]=0;
      __label__ = 21; break;
    case 21: // $_ZNSt3__119ostreambuf_iteratorIcNS_11char_traitsIcEEEaSEc_exit2
      var $180=$19;
      __label__ = 22; break;
    case 22: // $181
      var $182=$__ns;
      var $183=(($182-1)|0);
      $__ns=$183;
      var $184=$21;
      HEAP32[(($21)>>2)]=$__s;
      var $185=HEAP32[(($21)>>2)];
      var $186=$21;
      __label__ = 14; break;
    case 23: // $187
      __label__ = 24; break;
    case 24: // $188
      var $189=$37;
      var $190=$39;
      var $191=(($189)>>>0) < (($190)>>>0);
      if ($191) { __label__ = 25; break; } else { __label__ = 33; break; }
    case 25: // $192
      var $193=$22;
      HEAP32[(($22)>>2)]=$__s;
      var $194=HEAP32[(($22)>>2)];
      var $195=$22;
      var $196=$37;
      var $197=HEAP8[($196)];
      var $198=$31;
      HEAP32[(($31)>>2)]=$194;
      $32=$197;
      var $199=HEAPU32[(($31)>>2)];
      var $200=(($199)|0);
      var $201=HEAP32[(($200)>>2)];
      var $202=(($201)|0)!=0;
      if ($202) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $203
      var $204=(($199)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=$32;
      var $207=$28;
      var $208=$29;
      HEAP32[(($29)>>2)]=$205;
      $30=$206;
      var $209=HEAPU32[(($29)>>2)];
      var $210=(($209+24)|0);
      var $211=HEAP32[(($210)>>2)];
      var $212=(($209+28)|0);
      var $213=HEAP32[(($212)>>2)];
      var $214=(($211)|0)==(($213)|0);
      if ($214) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $215
      var $216=$209;
      var $217=HEAP32[(($216)>>2)];
      var $218=(($217+52)|0);
      var $219=HEAP32[(($218)>>2)];
      var $220=$30;
      $27=$220;
      var $221=$27;
      var $222=(($221)&255);
      var $223=FUNCTION_TABLE[$219]($209, $222);
      HEAP32[(($28)>>2)]=$223;
      __label__ = 29; break;
    case 28: // $224
      var $225=$30;
      var $226=(($209+24)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=(($227+1)|0);
      HEAP32[(($226)>>2)]=$228;
      HEAP8[($227)]=$225;
      var $229=$30;
      $26=$229;
      var $230=$26;
      var $231=(($230)&255);
      HEAP32[(($28)>>2)]=$231;
      __label__ = 29; break;
    case 29: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sputcEc_exit_i
      var $232=HEAP32[(($28)>>2)];
      var $233=$28;
      var $234=$29;
      var $235=$24;
      var $236=$25;
      HEAP32[(($24)>>2)]=$232;
      HEAP32[(($25)>>2)]=-1;
      var $237=HEAP32[(($24)>>2)];
      var $238=HEAP32[(($25)>>2)];
      var $239=(($237)|0)==(($238)|0);
      var $240=$24;
      var $241=$25;
      if ($239) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $242
      var $243=(($199)|0);
      HEAP32[(($243)>>2)]=0;
      __label__ = 31; break;
    case 31: // $_ZNSt3__119ostreambuf_iteratorIcNS_11char_traitsIcEEEaSEc_exit
      var $244=$31;
      __label__ = 32; break;
    case 32: // $245
      var $246=$37;
      var $247=(($246+1)|0);
      $37=$247;
      var $248=$33;
      HEAP32[(($33)>>2)]=$__s;
      var $249=HEAP32[(($33)>>2)];
      var $250=$33;
      __label__ = 24; break;
    case 33: // $251
      var $252=$40;
      var $253=$34;
      var $254=$35;
      var $255=$__r_i;
      HEAP32[(($34)>>2)]=$252;
      HEAP32[(($35)>>2)]=0;
      var $256=HEAP32[(($34)>>2)];
      var $257=(($256+12)|0);
      var $258=HEAP32[(($257)>>2)];
      HEAP32[(($__r_i)>>2)]=$258;
      var $259=HEAP32[(($35)>>2)];
      var $260=(($256+12)|0);
      HEAP32[(($260)>>2)]=$259;
      var $261=HEAP32[(($__r_i)>>2)];
      var $262=$34;
      var $263=$35;
      var $264=$__r_i;
      var $265=$agg_result;
      var $266=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($265)>>2)]=HEAP32[(($266)>>2)];
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx($agg_result, $this, $__s, $__iob, $__fl, $__v$0, $__v$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__+4;
      var $__fmt=__stackBase__+12;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+20;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+44;
      var $__op=__stackBase__+88;
      var $__oe=__stackBase__+92;
      var $6=__stackBase__+96;
      var $7;
      var $8;
      var $9=__stackBase__+100;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      var $st$22$0=(($5)|0);
      HEAP32[(($st$22$0)>>2)]=$__v$0;
      var $st$22$1=(($5+4)|0);
      HEAP32[(($st$22$1)>>2)]=$__v$1;
      var $10=$2;
      var $11=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+5)];HEAP8[($11+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+6)];HEAP8[($11+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt)|0)+7)];
      $__len=((STRING_TABLE.__str6243)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 1, $19);
      $__nbuf=22;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $st$45$0=(($5)|0);
      var $24$0=HEAP32[(($st$45$0)>>2)];
      var $st$45$1=(($5+4)|0);
      var $24$1=HEAP32[(($st$45$1)>>2)];
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24$0,HEAP32[((tempInt+4)>>2)]=$24$1,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 64; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__fmt=__stackBase__+4;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+12;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+24;
      var $__op=__stackBase__+48;
      var $__oe=__stackBase__+52;
      var $6=__stackBase__+56;
      var $7;
      var $8;
      var $9=__stackBase__+60;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      $5=$__v;
      var $10=$2;
      var $11=$__fmt;
      assert(6 % 1 === 0, 'memcpy given ' + 6 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt)|0)+5)];
      $__len=((STRING_TABLE.__str5242)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 0, $19);
      $__nbuf=12;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $24=$5;
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy($agg_result, $this, $__s, $__iob, $__fl, $__v$0, $__v$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__+4;
      var $__fmt=__stackBase__+12;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+20;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+44;
      var $__op=__stackBase__+88;
      var $__oe=__stackBase__+92;
      var $6=__stackBase__+96;
      var $7;
      var $8;
      var $9=__stackBase__+100;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      var $st$22$0=(($5)|0);
      HEAP32[(($st$22$0)>>2)]=$__v$0;
      var $st$22$1=(($5+4)|0);
      HEAP32[(($st$22$1)>>2)]=$__v$1;
      var $10=$2;
      var $11=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+5)];HEAP8[($11+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+6)];HEAP8[($11+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt)|0)+7)];
      $__len=((STRING_TABLE.__str6243)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 0, $19);
      $__nbuf=23;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $st$45$0=(($5)|0);
      var $24$0=HEAP32[(($st$45$0)>>2)];
      var $st$45$1=(($5+4)|0);
      var $24$1=HEAP32[(($st$45$1)>>2)];
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24$0,HEAP32[((tempInt+4)>>2)]=$24$1,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 620; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i7=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i5=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $__tmp_i=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $__tmp_i_i_i3=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $__tmp_i_i_i1=__stackBase__+316;
      var $76=__stackBase__+320;
      var $77=__stackBase__+324;
      var $78=__stackBase__+328;
      var $79=__stackBase__+332;
      var $80=__stackBase__+336;
      var $81=__stackBase__+340;
      var $82=__stackBase__+344;
      var $83=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $93=__stackBase__+388;
      var $94=__stackBase__+392;
      var $95=__stackBase__+396;
      var $96=__stackBase__+400;
      var $97=__stackBase__+404;
      var $98=__stackBase__+408;
      var $99=__stackBase__+412;
      var $100=__stackBase__+416;
      var $101=__stackBase__+420;
      var $102=__stackBase__+424;
      var $103=__stackBase__+428;
      var $104=__stackBase__+432;
      var $105=__stackBase__+436;
      var $106=__stackBase__+440;
      var $107=__stackBase__+444;
      var $108=__stackBase__+448;
      var $109=__stackBase__+452;
      var $__tmp_i_i_i=__stackBase__+456;
      var $110=__stackBase__+460;
      var $111=__stackBase__+464;
      var $112=__stackBase__+468;
      var $113=__stackBase__+472;
      var $114=__stackBase__+476;
      var $115;
      var $116;
      var $117;
      var $118;
      var $__fmt=__stackBase__+480;
      var $__len;
      var $__specify_precision;
      var $__nbuf;
      var $__nar=__stackBase__+488;
      var $__nb=__stackBase__+520;
      var $__nc;
      var $__nbh=__stackBase__+524;
      var $119;
      var $120;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+532;
      var $__ob;
      var $__obh=__stackBase__+592;
      var $__op=__stackBase__+600;
      var $__oe=__stackBase__+604;
      var $121=__stackBase__+608;
      var $122=__stackBase__+612;
      var $123=__stackBase__+616;
      var $124;
      $115=$this;
      $116=$__iob;
      $117=$__fl;
      $118=$__v;
      var $125=$115;
      var $126=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($126)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0))];HEAP8[($126+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+1)];HEAP8[($126+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+2)];HEAP8[($126+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+3)];HEAP8[($126+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+4)];HEAP8[($126+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+5)];HEAP8[($126+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+6)];HEAP8[($126+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt)|0)+7)];
      $__len=((__str7244)|0);
      var $127=(($__fmt)|0);
      var $128=(($127+1)|0);
      var $129=$__len;
      var $130=$116;
      var $131=$114;
      HEAP32[(($114)>>2)]=$130;
      var $132=HEAP32[(($114)>>2)];
      var $133=(($132+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$114;
      var $136=__ZNSt3__114__num_put_base14__format_floatEPcPKcj($128, $129, $134);
      var $137=(($136)&1);
      $__specify_precision=$137;
      $__nbuf=30;
      var $138=(($__nar)|0);
      HEAP32[(($__nb)>>2)]=$138;
      var $139=$__specify_precision;
      var $140=(($139) & 1);
      if ($140) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $141
      var $142=HEAP32[(($__nb)>>2)];
      var $143=__ZNSt3__16__clocEv();
      var $144=(($__fmt)|0);
      var $145=$116;
      var $146=$101;
      HEAP32[(($101)>>2)]=$145;
      var $147=HEAP32[(($101)>>2)];
      var $148=(($147+8)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$101;
      var $151=$118;
      var $152=__ZNSt3__112__snprintf_lEPcjPvPKcz($142, 30, $143, $144, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,(tempDoubleF64[0]=$151,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$152;
      __label__ = 3; break;
    case 2: // $153
      var $154=HEAP32[(($__nb)>>2)];
      var $155=__ZNSt3__16__clocEv();
      var $156=(($__fmt)|0);
      var $157=$118;
      var $158=__ZNSt3__112__snprintf_lEPcjPvPKcz($154, 30, $155, $156, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$157,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$158;
      __label__ = 3; break;
    case 3: // $159
      var $160=$98;
      var $161=$99;
      var $162=$100;
      HEAP32[(($98)>>2)]=$__nbh;
      HEAP32[(($99)>>2)]=0;
      HEAP32[(($100)>>2)]=1496;
      var $163=HEAP32[(($98)>>2)];
      var $164=HEAP32[(($99)>>2)];
      var $165=HEAP32[(($100)>>2)];
      var $166=$95;
      var $167=$96;
      var $168=$97;
      HEAP32[(($95)>>2)]=$163;
      HEAP32[(($96)>>2)]=$164;
      HEAP32[(($97)>>2)]=$165;
      var $169=HEAP32[(($95)>>2)];
      var $170=(($169)|0);
      var $171=$94;
      HEAP32[(($94)>>2)]=$96;
      var $172=HEAP32[(($94)>>2)];
      var $173=$94;
      var $174=HEAP32[(($172)>>2)];
      var $175=$80;
      HEAP32[(($80)>>2)]=$97;
      var $176=HEAP32[(($80)>>2)];
      var $177=$80;
      var $178=HEAP32[(($176)>>2)];
      var $179=$91;
      var $180=$92;
      var $181=$93;
      HEAP32[(($91)>>2)]=$170;
      HEAP32[(($92)>>2)]=$174;
      HEAP32[(($93)>>2)]=$178;
      var $182=HEAP32[(($91)>>2)];
      var $183=HEAP32[(($92)>>2)];
      var $184=HEAP32[(($93)>>2)];
      var $185=$88;
      var $186=$89;
      var $187=$90;
      HEAP32[(($88)>>2)]=$182;
      HEAP32[(($89)>>2)]=$183;
      HEAP32[(($90)>>2)]=$184;
      var $188=HEAP32[(($88)>>2)];
      var $189=$188;
      var $190=$87;
      HEAP32[(($87)>>2)]=$89;
      var $191=HEAP32[(($87)>>2)];
      var $192=$87;
      var $193=HEAP32[(($191)>>2)];
      var $194=$81;
      HEAP32[(($81)>>2)]=$90;
      var $195=HEAP32[(($81)>>2)];
      var $196=$81;
      var $197=HEAP32[(($195)>>2)];
      var $198=$84;
      var $199=$85;
      var $200=$86;
      HEAP32[(($84)>>2)]=$189;
      HEAP32[(($85)>>2)]=$193;
      HEAP32[(($86)>>2)]=$197;
      var $201=HEAP32[(($84)>>2)];
      var $202=(($201)|0);
      var $203=$83;
      HEAP32[(($83)>>2)]=$85;
      var $204=HEAP32[(($83)>>2)];
      var $205=$83;
      var $206=HEAP32[(($204)>>2)];
      HEAP32[(($202)>>2)]=$206;
      var $207=(($201+4)|0);
      var $208=$82;
      HEAP32[(($82)>>2)]=$86;
      var $209=HEAP32[(($82)>>2)];
      var $210=$82;
      var $211=HEAP32[(($209)>>2)];
      HEAP32[(($207)>>2)]=$211;
      var $212=$84;
      var $213=$85;
      var $214=$86;
      var $215=$88;
      var $216=$89;
      var $217=$90;
      var $218=$91;
      var $219=$92;
      var $220=$93;
      var $221=$95;
      var $222=$96;
      var $223=$97;
      var $224=$98;
      var $225=$99;
      var $226=$100;
      var $227=$__nc;
      var $228=(($227)|0) > 29;
      if ($228) { __label__ = 4; break; } else { __label__ = 22; break; }
    case 4: // $229
      var $230=$__specify_precision;
      var $231=(($230) & 1);
      if ($231) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $232
      var $233=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $234
      var $235=(($__fmt)|0);
      var $236=$116;
      var $237=$67;
      HEAP32[(($67)>>2)]=$236;
      var $238=HEAP32[(($67)>>2)];
      var $239=(($238+8)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$67;
      __label__ = 7; break;
    case 7: // $242
      var $243=$118;
      var $244=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $233, $235, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$240,(tempDoubleF64[0]=$243,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $245
      $__nc=$244;
      __label__ = 14; break;
    case 9: // $246
      var $247=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $248=$247.f0;
      $119=$248;
      var $249=$247.f1;
      $120=$249;
      __label__ = 56; break;
    case 10: // $250
      var $251=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $252
      var $253=(($__fmt)|0);
      var $254=$116;
      var $255=$66;
      HEAP32[(($66)>>2)]=$254;
      var $256=HEAP32[(($66)>>2)];
      var $257=(($256+8)|0);
      var $258=HEAP32[(($257)>>2)];
      var $259=$66;
      __label__ = 12; break;
    case 12: // $260
      var $261=$118;
      var $262=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $251, $253, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$258,(tempDoubleF64[0]=$261,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 9; break; };
    case 13: // $263
      $__nc=$262;
      __label__ = 14; break;
    case 14: // $264
      var $265=HEAP32[(($__nb)>>2)];
      var $266=(($265)|0)==0;
      if ($266) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $267
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 9; break; }
    case 16: // $268
      __label__ = 17; break;
    case 17: // $269
      var $270=HEAP32[(($__nb)>>2)];
      var $271=$50;
      var $272=$51;
      var $273=$__tmp_i;
      var $274=$52;
      var $275=$53;
      HEAP32[(($50)>>2)]=$__nbh;
      HEAP32[(($51)>>2)]=$270;
      var $276=HEAP32[(($50)>>2)];
      var $277=(($276)|0);
      var $278=$49;
      HEAP32[(($49)>>2)]=$277;
      var $279=HEAP32[(($49)>>2)];
      var $280=$279;
      var $281=$48;
      HEAP32[(($48)>>2)]=$280;
      var $282=HEAP32[(($48)>>2)];
      var $283=(($282)|0);
      var $284=$48;
      var $285=$49;
      var $286=HEAP32[(($283)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$286;
      var $287=HEAP32[(($51)>>2)];
      var $288=(($276)|0);
      var $289=$47;
      HEAP32[(($47)>>2)]=$288;
      var $290=HEAP32[(($47)>>2)];
      var $291=$290;
      var $292=$46;
      HEAP32[(($46)>>2)]=$291;
      var $293=HEAP32[(($46)>>2)];
      var $294=(($293)|0);
      var $295=$46;
      var $296=$47;
      HEAP32[(($294)>>2)]=$287;
      var $297=HEAP32[(($__tmp_i)>>2)];
      var $298=(($297)|0)!=0;
      if ($298) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $299
      var $300=(($276)|0);
      var $301=$45;
      HEAP32[(($45)>>2)]=$300;
      var $302=HEAP32[(($45)>>2)];
      var $303=$302;
      var $304=$44;
      HEAP32[(($44)>>2)]=$303;
      var $305=HEAP32[(($44)>>2)];
      var $306=(($305+4)|0);
      var $307=$44;
      var $308=$45;
      var $309=HEAP32[(($306)>>2)];
      var $310=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$309]($310) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $311
      __label__ = 21; break;
    case 20: // $312
      var $313=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $314=$313.f0;
      HEAP32[(($52)>>2)]=$314;
      var $315=$313.f1;
      HEAP32[(($53)>>2)]=$315;
      var $316=HEAP32[(($52)>>2)];
      ___cxa_call_unexpected($316);
      throw "Reached an unreachable!"
    case 21: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $317=$50;
      var $318=$51;
      var $319=$__tmp_i;
      var $320=$52;
      var $321=$53;
      __label__ = 22; break;
    case 22: // $322
      var $323=HEAP32[(($__nb)>>2)];
      var $324=$__nc;
      var $325=(($323+$324)|0);
      $__ne=$325;
      var $326=HEAP32[(($__nb)>>2)];
      var $327=$__ne;
      var $328=$116;
      var $329=(function() { try { __THREW__ = false; return __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($326, $327, $328) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 9; break; };
    case 23: // $330
      $__np=$329;
      var $331=(($__o)|0);
      $__ob=$331;
      var $332=$41;
      var $333=$42;
      var $334=$43;
      HEAP32[(($41)>>2)]=$__obh;
      HEAP32[(($42)>>2)]=0;
      HEAP32[(($43)>>2)]=1496;
      var $335=HEAP32[(($41)>>2)];
      var $336=HEAP32[(($42)>>2)];
      var $337=HEAP32[(($43)>>2)];
      var $338=$38;
      var $339=$39;
      var $340=$40;
      HEAP32[(($38)>>2)]=$335;
      HEAP32[(($39)>>2)]=$336;
      HEAP32[(($40)>>2)]=$337;
      var $341=HEAP32[(($38)>>2)];
      var $342=(($341)|0);
      var $343=$37;
      HEAP32[(($37)>>2)]=$39;
      var $344=HEAP32[(($37)>>2)];
      var $345=$37;
      var $346=HEAP32[(($344)>>2)];
      var $347=$23;
      HEAP32[(($23)>>2)]=$40;
      var $348=HEAP32[(($23)>>2)];
      var $349=$23;
      var $350=HEAP32[(($348)>>2)];
      var $351=$34;
      var $352=$35;
      var $353=$36;
      HEAP32[(($34)>>2)]=$342;
      HEAP32[(($35)>>2)]=$346;
      HEAP32[(($36)>>2)]=$350;
      var $354=HEAP32[(($34)>>2)];
      var $355=HEAP32[(($35)>>2)];
      var $356=HEAP32[(($36)>>2)];
      var $357=$31;
      var $358=$32;
      var $359=$33;
      HEAP32[(($31)>>2)]=$354;
      HEAP32[(($32)>>2)]=$355;
      HEAP32[(($33)>>2)]=$356;
      var $360=HEAP32[(($31)>>2)];
      var $361=$360;
      var $362=$30;
      HEAP32[(($30)>>2)]=$32;
      var $363=HEAP32[(($30)>>2)];
      var $364=$30;
      var $365=HEAP32[(($363)>>2)];
      var $366=$24;
      HEAP32[(($24)>>2)]=$33;
      var $367=HEAP32[(($24)>>2)];
      var $368=$24;
      var $369=HEAP32[(($367)>>2)];
      var $370=$27;
      var $371=$28;
      var $372=$29;
      HEAP32[(($27)>>2)]=$361;
      HEAP32[(($28)>>2)]=$365;
      HEAP32[(($29)>>2)]=$369;
      var $373=HEAP32[(($27)>>2)];
      var $374=(($373)|0);
      var $375=$26;
      HEAP32[(($26)>>2)]=$28;
      var $376=HEAP32[(($26)>>2)];
      var $377=$26;
      var $378=HEAP32[(($376)>>2)];
      HEAP32[(($374)>>2)]=$378;
      var $379=(($373+4)|0);
      var $380=$25;
      HEAP32[(($25)>>2)]=$29;
      var $381=HEAP32[(($25)>>2)];
      var $382=$25;
      var $383=HEAP32[(($381)>>2)];
      HEAP32[(($379)>>2)]=$383;
      var $384=$27;
      var $385=$28;
      var $386=$29;
      var $387=$31;
      var $388=$32;
      var $389=$33;
      var $390=$34;
      var $391=$35;
      var $392=$36;
      var $393=$38;
      var $394=$39;
      var $395=$40;
      var $396=$41;
      var $397=$42;
      var $398=$43;
      __label__ = 24; break;
    case 24: // $399
      var $400=HEAP32[(($__nb)>>2)];
      var $401=(($__nar)|0);
      var $402=(($400)|0)!=(($401)|0);
      if ($402) { __label__ = 25; break; } else { __label__ = 34; break; }
    case 25: // $403
      var $404=$__nc;
      var $405=((($404<<1))|0);
      var $406=(($405)|0);
      var $407=_malloc($406);
      $__ob=$407;
      var $408=$__ob;
      var $409=(($408)|0)==0;
      if ($409) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $410
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $411
      __label__ = 29; break;
    case 28: // $412
      var $413=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $414=$413.f0;
      $119=$414;
      var $415=$413.f1;
      $120=$415;
      __label__ = 50; break;
    case 29: // $416
      var $417=$__ob;
      var $418=$19;
      var $419=$20;
      var $420=$__tmp_i5;
      var $421=$21;
      var $422=$22;
      HEAP32[(($19)>>2)]=$__obh;
      HEAP32[(($20)>>2)]=$417;
      var $423=HEAP32[(($19)>>2)];
      var $424=(($423)|0);
      var $425=$18;
      HEAP32[(($18)>>2)]=$424;
      var $426=HEAP32[(($18)>>2)];
      var $427=$426;
      var $428=$17;
      HEAP32[(($17)>>2)]=$427;
      var $429=HEAP32[(($17)>>2)];
      var $430=(($429)|0);
      var $431=$17;
      var $432=$18;
      var $433=HEAP32[(($430)>>2)];
      HEAP32[(($__tmp_i5)>>2)]=$433;
      var $434=HEAP32[(($20)>>2)];
      var $435=(($423)|0);
      var $436=$16;
      HEAP32[(($16)>>2)]=$435;
      var $437=HEAP32[(($16)>>2)];
      var $438=$437;
      var $439=$15;
      HEAP32[(($15)>>2)]=$438;
      var $440=HEAP32[(($15)>>2)];
      var $441=(($440)|0);
      var $442=$15;
      var $443=$16;
      HEAP32[(($441)>>2)]=$434;
      var $444=HEAP32[(($__tmp_i5)>>2)];
      var $445=(($444)|0)!=0;
      if ($445) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $446
      var $447=(($423)|0);
      var $448=$14;
      HEAP32[(($14)>>2)]=$447;
      var $449=HEAP32[(($14)>>2)];
      var $450=$449;
      var $451=$13;
      HEAP32[(($13)>>2)]=$450;
      var $452=HEAP32[(($13)>>2)];
      var $453=(($452+4)|0);
      var $454=$13;
      var $455=$14;
      var $456=HEAP32[(($453)>>2)];
      var $457=HEAP32[(($__tmp_i5)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$456]($457) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $458
      __label__ = 33; break;
    case 32: // $459
      var $460=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $461=$460.f0;
      HEAP32[(($21)>>2)]=$461;
      var $462=$460.f1;
      HEAP32[(($22)>>2)]=$462;
      var $463=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($463);
      throw "Reached an unreachable!"
    case 33: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit6
      var $464=$19;
      var $465=$20;
      var $466=$__tmp_i5;
      var $467=$21;
      var $468=$22;
      __label__ = 34; break;
    case 34: // $469
      var $470=HEAP32[(($__nb)>>2)];
      var $471=$__np;
      var $472=$__ne;
      var $473=$__ob;
      var $474=$116;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($121, $474) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 28; break; }
    case 35: // $475
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE($470, $471, $472, $473, $__op, $__oe, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 43; break; }
    case 36: // $476
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 28; break; }
    case 37: // $477
      var $478=$123;
      var $479=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($478)>>2)]=HEAP32[(($479)>>2)];
      var $480=$__ob;
      var $481=HEAP32[(($__op)>>2)];
      var $482=HEAP32[(($__oe)>>2)];
      var $483=$116;
      var $484=$117;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($122, $123, $480, $481, $482, $483, $484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 28; break; }
    case 38: // $485
      var $486=$__s;
      var $487=$122;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($486)>>2)]=HEAP32[(($487)>>2)];
      var $488=$agg_result;
      var $489=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($488)>>2)]=HEAP32[(($489)>>2)];
      $124=1;
      var $490=$12;
      HEAP32[(($12)>>2)]=$__obh;
      var $491=HEAP32[(($12)>>2)];
      var $492=$11;
      HEAP32[(($11)>>2)]=$491;
      var $493=HEAP32[(($11)>>2)];
      var $494=$7;
      var $495=$8;
      var $496=$__tmp_i_i_i7;
      var $497=$9;
      var $498=$10;
      HEAP32[(($7)>>2)]=$493;
      HEAP32[(($8)>>2)]=0;
      var $499=HEAP32[(($7)>>2)];
      var $500=(($499)|0);
      var $501=$6;
      HEAP32[(($6)>>2)]=$500;
      var $502=HEAP32[(($6)>>2)];
      var $503=$502;
      var $504=$5;
      HEAP32[(($5)>>2)]=$503;
      var $505=HEAP32[(($5)>>2)];
      var $506=(($505)|0);
      var $507=$5;
      var $508=$6;
      var $509=HEAP32[(($506)>>2)];
      HEAP32[(($__tmp_i_i_i7)>>2)]=$509;
      var $510=HEAP32[(($8)>>2)];
      var $511=(($499)|0);
      var $512=$4;
      HEAP32[(($4)>>2)]=$511;
      var $513=HEAP32[(($4)>>2)];
      var $514=$513;
      var $515=$3;
      HEAP32[(($3)>>2)]=$514;
      var $516=HEAP32[(($3)>>2)];
      var $517=(($516)|0);
      var $518=$3;
      var $519=$4;
      HEAP32[(($517)>>2)]=$510;
      var $520=HEAP32[(($__tmp_i_i_i7)>>2)];
      var $521=(($520)|0)!=0;
      if ($521) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $522
      var $523=(($499)|0);
      var $524=$2;
      HEAP32[(($2)>>2)]=$523;
      var $525=HEAP32[(($2)>>2)];
      var $526=$525;
      var $527=$1;
      HEAP32[(($1)>>2)]=$526;
      var $528=HEAP32[(($1)>>2)];
      var $529=(($528+4)|0);
      var $530=$1;
      var $531=$2;
      var $532=HEAP32[(($529)>>2)];
      var $533=HEAP32[(($__tmp_i_i_i7)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$532]($533) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $534
      __label__ = 42; break;
    case 41: // $535
      var $536=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $537=$536.f0;
      HEAP32[(($9)>>2)]=$537;
      var $538=$536.f1;
      HEAP32[(($10)>>2)]=$538;
      var $539=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($539);
      throw "Reached an unreachable!"
    case 42: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit8
      var $540=$7;
      var $541=$8;
      var $542=$__tmp_i_i_i7;
      var $543=$9;
      var $544=$10;
      var $545=$11;
      var $546=$12;
      __label__ = 45; break;
    case 43: // $547
      var $548=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $549=$548.f0;
      $119=$549;
      var $550=$548.f1;
      $120=$550;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 63; break; }
    case 44: // $551
      __label__ = 50; break;
    case 45: // $552
      var $553=$65;
      HEAP32[(($65)>>2)]=$__nbh;
      var $554=HEAP32[(($65)>>2)];
      var $555=$64;
      HEAP32[(($64)>>2)]=$554;
      var $556=HEAP32[(($64)>>2)];
      var $557=$60;
      var $558=$61;
      var $559=$__tmp_i_i_i3;
      var $560=$62;
      var $561=$63;
      HEAP32[(($60)>>2)]=$556;
      HEAP32[(($61)>>2)]=0;
      var $562=HEAP32[(($60)>>2)];
      var $563=(($562)|0);
      var $564=$59;
      HEAP32[(($59)>>2)]=$563;
      var $565=HEAP32[(($59)>>2)];
      var $566=$565;
      var $567=$58;
      HEAP32[(($58)>>2)]=$566;
      var $568=HEAP32[(($58)>>2)];
      var $569=(($568)|0);
      var $570=$58;
      var $571=$59;
      var $572=HEAP32[(($569)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$572;
      var $573=HEAP32[(($61)>>2)];
      var $574=(($562)|0);
      var $575=$57;
      HEAP32[(($57)>>2)]=$574;
      var $576=HEAP32[(($57)>>2)];
      var $577=$576;
      var $578=$56;
      HEAP32[(($56)>>2)]=$577;
      var $579=HEAP32[(($56)>>2)];
      var $580=(($579)|0);
      var $581=$56;
      var $582=$57;
      HEAP32[(($580)>>2)]=$573;
      var $583=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $584=(($583)|0)!=0;
      if ($584) { __label__ = 46; break; } else { __label__ = 49; break; }
    case 46: // $585
      var $586=(($562)|0);
      var $587=$55;
      HEAP32[(($55)>>2)]=$586;
      var $588=HEAP32[(($55)>>2)];
      var $589=$588;
      var $590=$54;
      HEAP32[(($54)>>2)]=$589;
      var $591=HEAP32[(($54)>>2)];
      var $592=(($591+4)|0);
      var $593=$54;
      var $594=$55;
      var $595=HEAP32[(($592)>>2)];
      var $596=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$595]($596) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $597
      __label__ = 49; break;
    case 48: // $598
      var $599=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $600=$599.f0;
      HEAP32[(($62)>>2)]=$600;
      var $601=$599.f1;
      HEAP32[(($63)>>2)]=$601;
      var $602=HEAP32[(($62)>>2)];
      ___cxa_call_unexpected($602);
      throw "Reached an unreachable!"
    case 49: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit4
      var $603=$60;
      var $604=$61;
      var $605=$__tmp_i_i_i3;
      var $606=$62;
      var $607=$63;
      var $608=$64;
      var $609=$65;
      STACKTOP = __stackBase__;
      return;
    case 50: // $610
      var $611=$79;
      HEAP32[(($79)>>2)]=$__obh;
      var $612=HEAP32[(($79)>>2)];
      var $613=$78;
      HEAP32[(($78)>>2)]=$612;
      var $614=HEAP32[(($78)>>2)];
      var $615=$74;
      var $616=$75;
      var $617=$__tmp_i_i_i1;
      var $618=$76;
      var $619=$77;
      HEAP32[(($74)>>2)]=$614;
      HEAP32[(($75)>>2)]=0;
      var $620=HEAP32[(($74)>>2)];
      var $621=(($620)|0);
      var $622=$73;
      HEAP32[(($73)>>2)]=$621;
      var $623=HEAP32[(($73)>>2)];
      var $624=$623;
      var $625=$72;
      HEAP32[(($72)>>2)]=$624;
      var $626=HEAP32[(($72)>>2)];
      var $627=(($626)|0);
      var $628=$72;
      var $629=$73;
      var $630=HEAP32[(($627)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$630;
      var $631=HEAP32[(($75)>>2)];
      var $632=(($620)|0);
      var $633=$71;
      HEAP32[(($71)>>2)]=$632;
      var $634=HEAP32[(($71)>>2)];
      var $635=$634;
      var $636=$70;
      HEAP32[(($70)>>2)]=$635;
      var $637=HEAP32[(($70)>>2)];
      var $638=(($637)|0);
      var $639=$70;
      var $640=$71;
      HEAP32[(($638)>>2)]=$631;
      var $641=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $642=(($641)|0)!=0;
      if ($642) { __label__ = 51; break; } else { __label__ = 54; break; }
    case 51: // $643
      var $644=(($620)|0);
      var $645=$69;
      HEAP32[(($69)>>2)]=$644;
      var $646=HEAP32[(($69)>>2)];
      var $647=$646;
      var $648=$68;
      HEAP32[(($68)>>2)]=$647;
      var $649=HEAP32[(($68)>>2)];
      var $650=(($649+4)|0);
      var $651=$68;
      var $652=$69;
      var $653=HEAP32[(($650)>>2)];
      var $654=HEAP32[(($__tmp_i_i_i1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$653]($654) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $655
      __label__ = 54; break;
    case 53: // $656
      var $657=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $658=$657.f0;
      HEAP32[(($76)>>2)]=$658;
      var $659=$657.f1;
      HEAP32[(($77)>>2)]=$659;
      var $660=HEAP32[(($76)>>2)];
      ___cxa_call_unexpected($660);
      throw "Reached an unreachable!"
    case 54: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit2
      var $661=$74;
      var $662=$75;
      var $663=$__tmp_i_i_i1;
      var $664=$76;
      var $665=$77;
      var $666=$78;
      var $667=$79;
      __label__ = 55; break;
    case 55: // $668
      __label__ = 56; break;
    case 56: // $669
      var $670=$113;
      HEAP32[(($113)>>2)]=$__nbh;
      var $671=HEAP32[(($113)>>2)];
      var $672=$112;
      HEAP32[(($112)>>2)]=$671;
      var $673=HEAP32[(($112)>>2)];
      var $674=$108;
      var $675=$109;
      var $676=$__tmp_i_i_i;
      var $677=$110;
      var $678=$111;
      HEAP32[(($108)>>2)]=$673;
      HEAP32[(($109)>>2)]=0;
      var $679=HEAP32[(($108)>>2)];
      var $680=(($679)|0);
      var $681=$107;
      HEAP32[(($107)>>2)]=$680;
      var $682=HEAP32[(($107)>>2)];
      var $683=$682;
      var $684=$106;
      HEAP32[(($106)>>2)]=$683;
      var $685=HEAP32[(($106)>>2)];
      var $686=(($685)|0);
      var $687=$106;
      var $688=$107;
      var $689=HEAP32[(($686)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$689;
      var $690=HEAP32[(($109)>>2)];
      var $691=(($679)|0);
      var $692=$105;
      HEAP32[(($105)>>2)]=$691;
      var $693=HEAP32[(($105)>>2)];
      var $694=$693;
      var $695=$104;
      HEAP32[(($104)>>2)]=$694;
      var $696=HEAP32[(($104)>>2)];
      var $697=(($696)|0);
      var $698=$104;
      var $699=$105;
      HEAP32[(($697)>>2)]=$690;
      var $700=HEAP32[(($__tmp_i_i_i)>>2)];
      var $701=(($700)|0)!=0;
      if ($701) { __label__ = 57; break; } else { __label__ = 60; break; }
    case 57: // $702
      var $703=(($679)|0);
      var $704=$103;
      HEAP32[(($103)>>2)]=$703;
      var $705=HEAP32[(($103)>>2)];
      var $706=$705;
      var $707=$102;
      HEAP32[(($102)>>2)]=$706;
      var $708=HEAP32[(($102)>>2)];
      var $709=(($708+4)|0);
      var $710=$102;
      var $711=$103;
      var $712=HEAP32[(($709)>>2)];
      var $713=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$712]($713) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $714
      __label__ = 60; break;
    case 59: // $715
      var $716=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $717=$716.f0;
      HEAP32[(($110)>>2)]=$717;
      var $718=$716.f1;
      HEAP32[(($111)>>2)]=$718;
      var $719=HEAP32[(($110)>>2)];
      ___cxa_call_unexpected($719);
      throw "Reached an unreachable!"
    case 60: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $720=$108;
      var $721=$109;
      var $722=$__tmp_i_i_i;
      var $723=$110;
      var $724=$111;
      var $725=$112;
      var $726=$113;
      __label__ = 61; break;
    case 61: // $727
      __label__ = 62; break;
    case 62: // $728
      var $729=$119;
      var $730=$119;
      var $731=$120;
      var $732=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $730, tempValue);
      var $733=($732.f1 = $731, $732);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 63: // $734
      var $735=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd["X"]=1;

function __ZNSt3__114__num_put_base14__format_floatEPcPKcj($__fmtp, $__len, $__flags) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $specify_precision;
      var $floatfield;
      var $uppercase;
      $1=$__fmtp;
      $2=$__len;
      $3=$__flags;
      $specify_precision=1;
      var $4=$3;
      var $5=$4 & 2048;
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$1;
      var $9=(($8+1)|0);
      $1=$9;
      HEAP8[($8)]=43;
      __label__ = 2; break;
    case 2: // $10
      var $11=$3;
      var $12=$11 & 1024;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$1;
      var $16=(($15+1)|0);
      $1=$16;
      HEAP8[($15)]=35;
      __label__ = 4; break;
    case 4: // $17
      var $18=$3;
      var $19=$18 & 260;
      $floatfield=$19;
      var $20=$3;
      var $21=$20 & 16384;
      var $22=(($21)|0)!=0;
      var $23=(($22)&1);
      $uppercase=$23;
      var $24=$floatfield;
      var $25=(($24)|0)==260;
      if ($25) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $26
      $specify_precision=0;
      __label__ = 7; break;
    case 6: // $27
      var $28=$1;
      var $29=(($28+1)|0);
      $1=$29;
      HEAP8[($28)]=46;
      var $30=$1;
      var $31=(($30+1)|0);
      $1=$31;
      HEAP8[($30)]=42;
      __label__ = 7; break;
    case 7: // $32
      __label__ = 8; break;
    case 8: // $33
      var $34=$2;
      var $35=HEAP8[($34)];
      var $36=(($35 << 24) >> 24)!=0;
      if ($36) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $37
      var $38=$2;
      var $39=(($38+1)|0);
      $2=$39;
      var $40=HEAP8[($38)];
      var $41=$1;
      var $42=(($41+1)|0);
      $1=$42;
      HEAP8[($41)]=$40;
      __label__ = 8; break;
    case 10: // $43
      var $44=$floatfield;
      var $45=(($44)|0)==4;
      if ($45) { __label__ = 11; break; } else { __label__ = 15; break; }
    case 11: // $46
      var $47=$uppercase;
      var $48=(($47) & 1);
      if ($48) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $49
      var $50=$1;
      HEAP8[($50)]=70;
      __label__ = 14; break;
    case 13: // $51
      var $52=$1;
      HEAP8[($52)]=102;
      __label__ = 14; break;
    case 14: // $53
      __label__ = 31; break;
    case 15: // $54
      var $55=$floatfield;
      var $56=(($55)|0)==256;
      if ($56) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $57
      var $58=$uppercase;
      var $59=(($58) & 1);
      if ($59) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $60
      var $61=$1;
      HEAP8[($61)]=69;
      __label__ = 19; break;
    case 18: // $62
      var $63=$1;
      HEAP8[($63)]=101;
      __label__ = 19; break;
    case 19: // $64
      __label__ = 30; break;
    case 20: // $65
      var $66=$floatfield;
      var $67=(($66)|0)==260;
      if ($67) { __label__ = 21; break; } else { __label__ = 25; break; }
    case 21: // $68
      var $69=$uppercase;
      var $70=(($69) & 1);
      if ($70) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $71
      var $72=$1;
      HEAP8[($72)]=65;
      __label__ = 24; break;
    case 23: // $73
      var $74=$1;
      HEAP8[($74)]=97;
      __label__ = 24; break;
    case 24: // $75
      __label__ = 29; break;
    case 25: // $76
      var $77=$uppercase;
      var $78=(($77) & 1);
      if ($78) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $79
      var $80=$1;
      HEAP8[($80)]=71;
      __label__ = 28; break;
    case 27: // $81
      var $82=$1;
      HEAP8[($82)]=103;
      __label__ = 28; break;
    case 28: // $83
      __label__ = 29; break;
    case 29: // $84
      __label__ = 30; break;
    case 30: // $85
      __label__ = 31; break;
    case 31: // $86
      var $87=$specify_precision;
      var $88=(($87) & 1);
      ;
      return $88;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__num_put_base14__format_floatEPcPKcj["X"]=1;

function __ZNSt3__112__snprintf_lEPcjPvPKcz($__s, $__n, $__l, $__format) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46;
      var $47;
      var $48;
      var $49;
      var $50;
      var $__va=__stackBase__+188;
      var $__current=__stackBase__+192;
      var $__res;
      var $51;
      var $52;
      var $53;
      $47=$__s;
      $48=$__n;
      $49=$__l;
      $50=$__format;
      var $54=$__va;
      HEAP32[(($54)>>2)]=arguments[__ZNSt3__112__snprintf_lEPcjPvPKcz.length];
      var $55=$49;
      var $56=_uselocale($55);
      var $57=$43;
      var $58=$44;
      var $59=$45;
      HEAP32[(($43)>>2)]=$__current;
      HEAP32[(($44)>>2)]=$56;
      HEAP32[(($45)>>2)]=1680;
      var $60=HEAP32[(($43)>>2)];
      var $61=HEAP32[(($44)>>2)];
      var $62=HEAP32[(($45)>>2)];
      var $63=$40;
      var $64=$41;
      var $65=$42;
      HEAP32[(($40)>>2)]=$60;
      HEAP32[(($41)>>2)]=$61;
      HEAP32[(($42)>>2)]=$62;
      var $66=HEAP32[(($40)>>2)];
      var $67=(($66)|0);
      var $68=$39;
      HEAP32[(($39)>>2)]=$41;
      var $69=HEAP32[(($39)>>2)];
      var $70=$39;
      var $71=HEAP32[(($69)>>2)];
      var $72=$25;
      HEAP32[(($25)>>2)]=$42;
      var $73=HEAP32[(($25)>>2)];
      var $74=$25;
      var $75=HEAP32[(($73)>>2)];
      var $76=$36;
      var $77=$37;
      var $78=$38;
      HEAP32[(($36)>>2)]=$67;
      HEAP32[(($37)>>2)]=$71;
      HEAP32[(($38)>>2)]=$75;
      var $79=HEAP32[(($36)>>2)];
      var $80=HEAP32[(($37)>>2)];
      var $81=HEAP32[(($38)>>2)];
      var $82=$33;
      var $83=$34;
      var $84=$35;
      HEAP32[(($33)>>2)]=$79;
      HEAP32[(($34)>>2)]=$80;
      HEAP32[(($35)>>2)]=$81;
      var $85=HEAP32[(($33)>>2)];
      var $86=$85;
      var $87=$32;
      HEAP32[(($32)>>2)]=$34;
      var $88=HEAP32[(($32)>>2)];
      var $89=$32;
      var $90=HEAP32[(($88)>>2)];
      var $91=$26;
      HEAP32[(($26)>>2)]=$35;
      var $92=HEAP32[(($26)>>2)];
      var $93=$26;
      var $94=HEAP32[(($92)>>2)];
      var $95=$29;
      var $96=$30;
      var $97=$31;
      HEAP32[(($29)>>2)]=$86;
      HEAP32[(($30)>>2)]=$90;
      HEAP32[(($31)>>2)]=$94;
      var $98=HEAP32[(($29)>>2)];
      var $99=(($98)|0);
      var $100=$28;
      HEAP32[(($28)>>2)]=$30;
      var $101=HEAP32[(($28)>>2)];
      var $102=$28;
      var $103=HEAP32[(($101)>>2)];
      HEAP32[(($99)>>2)]=$103;
      var $104=(($98+4)|0);
      var $105=$27;
      HEAP32[(($27)>>2)]=$31;
      var $106=HEAP32[(($27)>>2)];
      var $107=$27;
      var $108=HEAP32[(($106)>>2)];
      HEAP32[(($104)>>2)]=$108;
      var $109=$29;
      var $110=$30;
      var $111=$31;
      var $112=$33;
      var $113=$34;
      var $114=$35;
      var $115=$36;
      var $116=$37;
      var $117=$38;
      var $118=$40;
      var $119=$41;
      var $120=$42;
      var $121=$43;
      var $122=$44;
      var $123=$45;
      var $124=$47;
      var $125=$48;
      var $126=$50;
      var $127=HEAP32[(($__va)>>2)];
      var $128=(function() { try { __THREW__ = false; return _vsnprintf($124, $125, $126, $127) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $129
      $__res=$128;
      var $130=$__va;
      ;
      var $131=$__res;
      $46=$131;
      $53=1;
      var $132=$12;
      HEAP32[(($12)>>2)]=$__current;
      var $133=HEAP32[(($12)>>2)];
      var $134=$11;
      HEAP32[(($11)>>2)]=$133;
      var $135=HEAP32[(($11)>>2)];
      var $136=$7;
      var $137=$8;
      var $138=$__tmp_i_i_i1;
      var $139=$9;
      var $140=$10;
      HEAP32[(($7)>>2)]=$135;
      HEAP32[(($8)>>2)]=0;
      var $141=HEAP32[(($7)>>2)];
      var $142=(($141)|0);
      var $143=$6;
      HEAP32[(($6)>>2)]=$142;
      var $144=HEAP32[(($6)>>2)];
      var $145=$144;
      var $146=$5;
      HEAP32[(($5)>>2)]=$145;
      var $147=HEAP32[(($5)>>2)];
      var $148=(($147)|0);
      var $149=$5;
      var $150=$6;
      var $151=HEAP32[(($148)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$151;
      var $152=HEAP32[(($8)>>2)];
      var $153=(($141)|0);
      var $154=$4;
      HEAP32[(($4)>>2)]=$153;
      var $155=HEAP32[(($4)>>2)];
      var $156=$155;
      var $157=$3;
      HEAP32[(($3)>>2)]=$156;
      var $158=HEAP32[(($3)>>2)];
      var $159=(($158)|0);
      var $160=$3;
      var $161=$4;
      HEAP32[(($159)>>2)]=$152;
      var $162=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $163=(($162)|0)!=0;
      if ($163) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $164
      var $165=(($141)|0);
      var $166=$2;
      HEAP32[(($2)>>2)]=$165;
      var $167=HEAP32[(($2)>>2)];
      var $168=$167;
      var $169=$1;
      HEAP32[(($1)>>2)]=$168;
      var $170=HEAP32[(($1)>>2)];
      var $171=(($170+4)|0);
      var $172=$1;
      var $173=$2;
      var $174=HEAP32[(($171)>>2)];
      var $175=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $176=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$174]($175) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $177
      __label__ = 5; break;
    case 4: // $178
      var $179=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $180=$179.f0;
      HEAP32[(($9)>>2)]=$180;
      var $181=$179.f1;
      HEAP32[(($10)>>2)]=$181;
      var $182=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($182);
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit2
      var $183=$7;
      var $184=$8;
      var $185=$__tmp_i_i_i1;
      var $186=$9;
      var $187=$10;
      var $188=$11;
      var $189=$12;
      var $190=$46;
      STACKTOP = __stackBase__;
      return $190;
    case 6: // $191
      var $192=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $193=$192.f0;
      $51=$193;
      var $194=$192.f1;
      $52=$194;
      var $195=$24;
      HEAP32[(($24)>>2)]=$__current;
      var $196=HEAP32[(($24)>>2)];
      var $197=$23;
      HEAP32[(($23)>>2)]=$196;
      var $198=HEAP32[(($23)>>2)];
      var $199=$19;
      var $200=$20;
      var $201=$__tmp_i_i_i;
      var $202=$21;
      var $203=$22;
      HEAP32[(($19)>>2)]=$198;
      HEAP32[(($20)>>2)]=0;
      var $204=HEAP32[(($19)>>2)];
      var $205=(($204)|0);
      var $206=$18;
      HEAP32[(($18)>>2)]=$205;
      var $207=HEAP32[(($18)>>2)];
      var $208=$207;
      var $209=$17;
      HEAP32[(($17)>>2)]=$208;
      var $210=HEAP32[(($17)>>2)];
      var $211=(($210)|0);
      var $212=$17;
      var $213=$18;
      var $214=HEAP32[(($211)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$214;
      var $215=HEAP32[(($20)>>2)];
      var $216=(($204)|0);
      var $217=$16;
      HEAP32[(($16)>>2)]=$216;
      var $218=HEAP32[(($16)>>2)];
      var $219=$218;
      var $220=$15;
      HEAP32[(($15)>>2)]=$219;
      var $221=HEAP32[(($15)>>2)];
      var $222=(($221)|0);
      var $223=$15;
      var $224=$16;
      HEAP32[(($222)>>2)]=$215;
      var $225=HEAP32[(($__tmp_i_i_i)>>2)];
      var $226=(($225)|0)!=0;
      if ($226) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $227
      var $228=(($204)|0);
      var $229=$14;
      HEAP32[(($14)>>2)]=$228;
      var $230=HEAP32[(($14)>>2)];
      var $231=$230;
      var $232=$13;
      HEAP32[(($13)>>2)]=$231;
      var $233=HEAP32[(($13)>>2)];
      var $234=(($233+4)|0);
      var $235=$13;
      var $236=$14;
      var $237=HEAP32[(($234)>>2)];
      var $238=HEAP32[(($__tmp_i_i_i)>>2)];
      var $239=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$237]($238) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $240
      __label__ = 10; break;
    case 9: // $241
      var $242=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $243=$242.f0;
      HEAP32[(($21)>>2)]=$243;
      var $244=$242.f1;
      HEAP32[(($22)>>2)]=$244;
      var $245=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($245);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit
      var $246=$19;
      var $247=$20;
      var $248=$__tmp_i_i_i;
      var $249=$21;
      var $250=$22;
      var $251=$23;
      var $252=$24;
      __label__ = 11; break;
    case 11: // $253
      __label__ = 12; break;
    case 12: // $254
      var $255=$51;
      var $256=$51;
      var $257=$52;
      var $258=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $256, tempValue);
      var $259=($258.f1 = $257, $258);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $261=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112__snprintf_lEPcjPvPKcz["X"]=1;

function __ZNSt3__112__asprintf_lEPPcPvPKcz($__s, $__l, $__format) {
  var __stackBase__  = STACKTOP; STACKTOP += 200; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46;
      var $47;
      var $48;
      var $49;
      var $__va=__stackBase__+188;
      var $__current=__stackBase__+192;
      var $__res;
      var $50;
      var $51;
      var $52;
      $47=$__s;
      $48=$__l;
      $49=$__format;
      var $53=$__va;
      HEAP32[(($53)>>2)]=arguments[__ZNSt3__112__asprintf_lEPPcPvPKcz.length];
      var $54=$48;
      var $55=_uselocale($54);
      var $56=$43;
      var $57=$44;
      var $58=$45;
      HEAP32[(($43)>>2)]=$__current;
      HEAP32[(($44)>>2)]=$55;
      HEAP32[(($45)>>2)]=1680;
      var $59=HEAP32[(($43)>>2)];
      var $60=HEAP32[(($44)>>2)];
      var $61=HEAP32[(($45)>>2)];
      var $62=$40;
      var $63=$41;
      var $64=$42;
      HEAP32[(($40)>>2)]=$59;
      HEAP32[(($41)>>2)]=$60;
      HEAP32[(($42)>>2)]=$61;
      var $65=HEAP32[(($40)>>2)];
      var $66=(($65)|0);
      var $67=$39;
      HEAP32[(($39)>>2)]=$41;
      var $68=HEAP32[(($39)>>2)];
      var $69=$39;
      var $70=HEAP32[(($68)>>2)];
      var $71=$25;
      HEAP32[(($25)>>2)]=$42;
      var $72=HEAP32[(($25)>>2)];
      var $73=$25;
      var $74=HEAP32[(($72)>>2)];
      var $75=$36;
      var $76=$37;
      var $77=$38;
      HEAP32[(($36)>>2)]=$66;
      HEAP32[(($37)>>2)]=$70;
      HEAP32[(($38)>>2)]=$74;
      var $78=HEAP32[(($36)>>2)];
      var $79=HEAP32[(($37)>>2)];
      var $80=HEAP32[(($38)>>2)];
      var $81=$33;
      var $82=$34;
      var $83=$35;
      HEAP32[(($33)>>2)]=$78;
      HEAP32[(($34)>>2)]=$79;
      HEAP32[(($35)>>2)]=$80;
      var $84=HEAP32[(($33)>>2)];
      var $85=$84;
      var $86=$32;
      HEAP32[(($32)>>2)]=$34;
      var $87=HEAP32[(($32)>>2)];
      var $88=$32;
      var $89=HEAP32[(($87)>>2)];
      var $90=$26;
      HEAP32[(($26)>>2)]=$35;
      var $91=HEAP32[(($26)>>2)];
      var $92=$26;
      var $93=HEAP32[(($91)>>2)];
      var $94=$29;
      var $95=$30;
      var $96=$31;
      HEAP32[(($29)>>2)]=$85;
      HEAP32[(($30)>>2)]=$89;
      HEAP32[(($31)>>2)]=$93;
      var $97=HEAP32[(($29)>>2)];
      var $98=(($97)|0);
      var $99=$28;
      HEAP32[(($28)>>2)]=$30;
      var $100=HEAP32[(($28)>>2)];
      var $101=$28;
      var $102=HEAP32[(($100)>>2)];
      HEAP32[(($98)>>2)]=$102;
      var $103=(($97+4)|0);
      var $104=$27;
      HEAP32[(($27)>>2)]=$31;
      var $105=HEAP32[(($27)>>2)];
      var $106=$27;
      var $107=HEAP32[(($105)>>2)];
      HEAP32[(($103)>>2)]=$107;
      var $108=$29;
      var $109=$30;
      var $110=$31;
      var $111=$33;
      var $112=$34;
      var $113=$35;
      var $114=$36;
      var $115=$37;
      var $116=$38;
      var $117=$40;
      var $118=$41;
      var $119=$42;
      var $120=$43;
      var $121=$44;
      var $122=$45;
      var $123=$47;
      var $124=$49;
      var $125=HEAP32[(($__va)>>2)];
      var $126=(function() { try { __THREW__ = false; return _vasprintf($123, $124, $125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 6; break; };
    case 1: // $127
      $__res=$126;
      var $128=$__va;
      ;
      var $129=$__res;
      $46=$129;
      $52=1;
      var $130=$12;
      HEAP32[(($12)>>2)]=$__current;
      var $131=HEAP32[(($12)>>2)];
      var $132=$11;
      HEAP32[(($11)>>2)]=$131;
      var $133=HEAP32[(($11)>>2)];
      var $134=$7;
      var $135=$8;
      var $136=$__tmp_i_i_i1;
      var $137=$9;
      var $138=$10;
      HEAP32[(($7)>>2)]=$133;
      HEAP32[(($8)>>2)]=0;
      var $139=HEAP32[(($7)>>2)];
      var $140=(($139)|0);
      var $141=$6;
      HEAP32[(($6)>>2)]=$140;
      var $142=HEAP32[(($6)>>2)];
      var $143=$142;
      var $144=$5;
      HEAP32[(($5)>>2)]=$143;
      var $145=HEAP32[(($5)>>2)];
      var $146=(($145)|0);
      var $147=$5;
      var $148=$6;
      var $149=HEAP32[(($146)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$149;
      var $150=HEAP32[(($8)>>2)];
      var $151=(($139)|0);
      var $152=$4;
      HEAP32[(($4)>>2)]=$151;
      var $153=HEAP32[(($4)>>2)];
      var $154=$153;
      var $155=$3;
      HEAP32[(($3)>>2)]=$154;
      var $156=HEAP32[(($3)>>2)];
      var $157=(($156)|0);
      var $158=$3;
      var $159=$4;
      HEAP32[(($157)>>2)]=$150;
      var $160=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $161=(($160)|0)!=0;
      if ($161) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $162
      var $163=(($139)|0);
      var $164=$2;
      HEAP32[(($2)>>2)]=$163;
      var $165=HEAP32[(($2)>>2)];
      var $166=$165;
      var $167=$1;
      HEAP32[(($1)>>2)]=$166;
      var $168=HEAP32[(($1)>>2)];
      var $169=(($168+4)|0);
      var $170=$1;
      var $171=$2;
      var $172=HEAP32[(($169)>>2)];
      var $173=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $174=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$172]($173) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $175
      __label__ = 5; break;
    case 4: // $176
      var $177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $178=$177.f0;
      HEAP32[(($9)>>2)]=$178;
      var $179=$177.f1;
      HEAP32[(($10)>>2)]=$179;
      var $180=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($180);
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit2
      var $181=$7;
      var $182=$8;
      var $183=$__tmp_i_i_i1;
      var $184=$9;
      var $185=$10;
      var $186=$11;
      var $187=$12;
      var $188=$46;
      STACKTOP = __stackBase__;
      return $188;
    case 6: // $189
      var $190=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $191=$190.f0;
      $50=$191;
      var $192=$190.f1;
      $51=$192;
      var $193=$24;
      HEAP32[(($24)>>2)]=$__current;
      var $194=HEAP32[(($24)>>2)];
      var $195=$23;
      HEAP32[(($23)>>2)]=$194;
      var $196=HEAP32[(($23)>>2)];
      var $197=$19;
      var $198=$20;
      var $199=$__tmp_i_i_i;
      var $200=$21;
      var $201=$22;
      HEAP32[(($19)>>2)]=$196;
      HEAP32[(($20)>>2)]=0;
      var $202=HEAP32[(($19)>>2)];
      var $203=(($202)|0);
      var $204=$18;
      HEAP32[(($18)>>2)]=$203;
      var $205=HEAP32[(($18)>>2)];
      var $206=$205;
      var $207=$17;
      HEAP32[(($17)>>2)]=$206;
      var $208=HEAP32[(($17)>>2)];
      var $209=(($208)|0);
      var $210=$17;
      var $211=$18;
      var $212=HEAP32[(($209)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$212;
      var $213=HEAP32[(($20)>>2)];
      var $214=(($202)|0);
      var $215=$16;
      HEAP32[(($16)>>2)]=$214;
      var $216=HEAP32[(($16)>>2)];
      var $217=$216;
      var $218=$15;
      HEAP32[(($15)>>2)]=$217;
      var $219=HEAP32[(($15)>>2)];
      var $220=(($219)|0);
      var $221=$15;
      var $222=$16;
      HEAP32[(($220)>>2)]=$213;
      var $223=HEAP32[(($__tmp_i_i_i)>>2)];
      var $224=(($223)|0)!=0;
      if ($224) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $225
      var $226=(($202)|0);
      var $227=$14;
      HEAP32[(($14)>>2)]=$226;
      var $228=HEAP32[(($14)>>2)];
      var $229=$228;
      var $230=$13;
      HEAP32[(($13)>>2)]=$229;
      var $231=HEAP32[(($13)>>2)];
      var $232=(($231+4)|0);
      var $233=$13;
      var $234=$14;
      var $235=HEAP32[(($232)>>2)];
      var $236=HEAP32[(($__tmp_i_i_i)>>2)];
      var $237=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$235]($236) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $238
      __label__ = 10; break;
    case 9: // $239
      var $240=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $241=$240.f0;
      HEAP32[(($21)>>2)]=$241;
      var $242=$240.f1;
      HEAP32[(($22)>>2)]=$242;
      var $243=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($243);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit
      var $244=$19;
      var $245=$20;
      var $246=$__tmp_i_i_i;
      var $247=$21;
      var $248=$22;
      var $249=$23;
      var $250=$24;
      __label__ = 11; break;
    case 11: // $251
      __label__ = 12; break;
    case 12: // $252
      var $253=$50;
      var $254=$50;
      var $255=$51;
      var $256=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $254, tempValue);
      var $257=($256.f1 = $255, $256);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112__asprintf_lEPPcPvPKcz["X"]=1;

function __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE($__nb, $__np, $__ne, $__ob, $__op, $__oe, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 360; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $__t_i_i_i6=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51;
      var $52=__stackBase__+200;
      var $53=__stackBase__+204;
      var $54=__stackBase__+208;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $__t_i_i_i=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $80=__stackBase__+316;
      var $81=__stackBase__+320;
      var $82=__stackBase__+324;
      var $83;
      var $84=__stackBase__+328;
      var $85;
      var $86=__stackBase__+332;
      var $87;
      var $88=__stackBase__+336;
      var $89=__stackBase__+340;
      var $90=__stackBase__+344;
      var $91;
      var $92;
      var $93;
      var $94;
      var $95;
      var $96;
      var $97;
      var $__ct;
      var $__npt;
      var $__grouping=__stackBase__+348;
      var $__nf;
      var $98;
      var $99;
      var $__ns;
      var $__thousands_sep;
      var $__dc;
      var $__dg;
      var $__p;
      $91=$__nb;
      $92=$__np;
      $93=$__ne;
      $94=$__ob;
      $95=$__op;
      $96=$__oe;
      $97=$__loc;
      var $100=$97;
      var $101=$90;
      HEAP32[(($90)>>2)]=$100;
      var $102=HEAP32[(($90)>>2)];
      var $103=__ZNKSt3__16locale9use_facetERNS0_2idE($102, __ZNSt3__15ctypeIcE2idE);
      var $104=$103;
      var $105=$90;
      $__ct=$104;
      var $106=$97;
      var $107=$89;
      HEAP32[(($89)>>2)]=$106;
      var $108=HEAP32[(($89)>>2)];
      var $109=__ZNKSt3__16locale9use_facetERNS0_2idE($108, __ZNSt3__18numpunctIcE2idE);
      var $110=$109;
      var $111=$89;
      $__npt=$110;
      var $112=$__npt;
      var $113=$88;
      HEAP32[(($88)>>2)]=$112;
      var $114=HEAP32[(($88)>>2)];
      var $115=$114;
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116+20)|0);
      var $118=HEAP32[(($117)>>2)];
      FUNCTION_TABLE[$118]($__grouping, $114);
      var $119=$88;
      var $120=$94;
      var $121=$96;
      HEAP32[(($121)>>2)]=$120;
      var $122=$91;
      $__nf=$122;
      var $123=$__nf;
      var $124=HEAP8[($123)];
      var $125=(($124 << 24) >> 24);
      var $126=(($125)|0)==45;
      if ($126) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $127
      var $128=$__nf;
      var $129=HEAP8[($128)];
      var $130=(($129 << 24) >> 24);
      var $131=(($130)|0)==43;
      if ($131) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $132
      var $133=$__ct;
      var $134=$__nf;
      var $135=(($134+1)|0);
      $__nf=$135;
      var $136=HEAP8[($134)];
      var $137=$86;
      HEAP32[(($86)>>2)]=$133;
      $87=$136;
      var $138=HEAP32[(($86)>>2)];
      var $139=$138;
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+28)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$87;
      var $144=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$142]($138, $143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $_ZNKSt3__15ctypeIcE5widenEc_exit
      var $145=$86;
      __label__ = 4; break;
    case 4: // $146
      var $147=$96;
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+1)|0);
      HEAP32[(($147)>>2)]=$149;
      HEAP8[($148)]=$144;
      __label__ = 6; break;
    case 5: // $150
      var $151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $152=$151.f0;
      $98=$152;
      var $153=$151.f1;
      $99=$153;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 6: // $154
      var $155=$93;
      var $156=$__nf;
      var $157=$155;
      var $158=$156;
      var $159=(($157-$158)|0);
      var $160=(($159)|0) >= 2;
      if ($160) { __label__ = 7; break; } else { __label__ = 23; break; }
    case 7: // $161
      var $162=$__nf;
      var $163=(($162)|0);
      var $164=HEAP8[($163)];
      var $165=(($164 << 24) >> 24);
      var $166=(($165)|0)==48;
      if ($166) { __label__ = 8; break; } else { __label__ = 23; break; }
    case 8: // $167
      var $168=$__nf;
      var $169=(($168+1)|0);
      var $170=HEAP8[($169)];
      var $171=(($170 << 24) >> 24);
      var $172=(($171)|0)==120;
      if ($172) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $173
      var $174=$__nf;
      var $175=(($174+1)|0);
      var $176=HEAP8[($175)];
      var $177=(($176 << 24) >> 24);
      var $178=(($177)|0)==88;
      if ($178) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $179
      var $180=$__ct;
      var $181=$__nf;
      var $182=(($181+1)|0);
      $__nf=$182;
      var $183=HEAP8[($181)];
      var $184=$84;
      HEAP32[(($84)>>2)]=$180;
      $85=$183;
      var $185=HEAP32[(($84)>>2)];
      var $186=$185;
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187+28)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=$85;
      var $191=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$189]($185, $190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 5; break; };
    case 11: // $_ZNKSt3__15ctypeIcE5widenEc_exit1
      var $192=$84;
      __label__ = 12; break;
    case 12: // $193
      var $194=$96;
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195+1)|0);
      HEAP32[(($194)>>2)]=$196;
      HEAP8[($195)]=$191;
      var $197=$__ct;
      var $198=$__nf;
      var $199=(($198+1)|0);
      $__nf=$199;
      var $200=HEAP8[($198)];
      var $201=$82;
      HEAP32[(($82)>>2)]=$197;
      $83=$200;
      var $202=HEAP32[(($82)>>2)];
      var $203=$202;
      var $204=HEAP32[(($203)>>2)];
      var $205=(($204+28)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=$83;
      var $208=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$206]($202, $207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 5; break; };
    case 13: // $_ZNKSt3__15ctypeIcE5widenEc_exit2
      var $209=$82;
      __label__ = 14; break;
    case 14: // $210
      var $211=$96;
      var $212=HEAP32[(($211)>>2)];
      var $213=(($212+1)|0);
      HEAP32[(($211)>>2)]=$213;
      HEAP8[($212)]=$208;
      var $214=$__nf;
      $__ns=$214;
      __label__ = 15; break;
    case 15: // $215
      var $216=$__ns;
      var $217=$93;
      var $218=(($216)>>>0) < (($217)>>>0);
      if ($218) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $219
      var $220=$__ns;
      var $221=HEAP8[($220)];
      var $222=(($221 << 24) >> 24);
      var $223=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 5; break; };
    case 17: // $224
      var $225=(function() { try { __THREW__ = false; return _isxdigit_l($222, $223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 5; break; };
    case 18: // $226
      var $227=(($225)|0)!=0;
      if ($227) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $228
      __label__ = 22; break;
    case 20: // $229
      __label__ = 21; break;
    case 21: // $230
      var $231=$__ns;
      var $232=(($231+1)|0);
      $__ns=$232;
      __label__ = 15; break;
    case 22: // $233
      __label__ = 32; break;
    case 23: // $234
      var $235=$__nf;
      $__ns=$235;
      __label__ = 24; break;
    case 24: // $236
      var $237=$__ns;
      var $238=$93;
      var $239=(($237)>>>0) < (($238)>>>0);
      if ($239) { __label__ = 25; break; } else { __label__ = 31; break; }
    case 25: // $240
      var $241=$__ns;
      var $242=HEAP8[($241)];
      var $243=(($242 << 24) >> 24);
      var $244=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 5; break; };
    case 26: // $245
      var $246=(function() { try { __THREW__ = false; return _isdigit_l($243, $244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 5; break; };
    case 27: // $247
      var $248=(($246)|0)!=0;
      if ($248) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $249
      __label__ = 31; break;
    case 29: // $250
      __label__ = 30; break;
    case 30: // $251
      var $252=$__ns;
      var $253=(($252+1)|0);
      $__ns=$253;
      __label__ = 24; break;
    case 31: // $254
      __label__ = 32; break;
    case 32: // $255
      var $256=$81;
      HEAP32[(($81)>>2)]=$__grouping;
      var $257=HEAP32[(($81)>>2)];
      var $258=$80;
      HEAP32[(($80)>>2)]=$257;
      var $259=HEAPU32[(($80)>>2)];
      var $260=$79;
      HEAP32[(($79)>>2)]=$259;
      var $261=HEAP32[(($79)>>2)];
      var $262=(($261)|0);
      var $263=$78;
      HEAP32[(($78)>>2)]=$262;
      var $264=HEAP32[(($78)>>2)];
      var $265=$264;
      var $266=$77;
      HEAP32[(($77)>>2)]=$265;
      var $267=HEAP32[(($77)>>2)];
      var $268=(($267)|0);
      var $269=$77;
      var $270=$78;
      var $271=(($268)|0);
      var $272=$271;
      var $273=(($272)|0);
      var $274=$273;
      var $275=HEAPU8[($274)];
      var $276=(($275)&255);
      var $277=$276 & 1;
      var $278=(($277)|0)!=0;
      var $279=$79;
      if ($278) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $280
      var $281=$73;
      HEAP32[(($73)>>2)]=$259;
      var $282=HEAP32[(($73)>>2)];
      var $283=(($282)|0);
      var $284=$72;
      HEAP32[(($72)>>2)]=$283;
      var $285=HEAP32[(($72)>>2)];
      var $286=$285;
      var $287=$71;
      HEAP32[(($71)>>2)]=$286;
      var $288=HEAP32[(($71)>>2)];
      var $289=(($288)|0);
      var $290=$71;
      var $291=$72;
      var $292=(($289)|0);
      var $293=$292;
      var $294=(($293+4)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$73;
      var $317 = $295;__label__ = 35; break;
    case 34: // $297
      var $298=$76;
      HEAP32[(($76)>>2)]=$259;
      var $299=HEAP32[(($76)>>2)];
      var $300=(($299)|0);
      var $301=$75;
      HEAP32[(($75)>>2)]=$300;
      var $302=HEAP32[(($75)>>2)];
      var $303=$302;
      var $304=$74;
      HEAP32[(($74)>>2)]=$303;
      var $305=HEAP32[(($74)>>2)];
      var $306=(($305)|0);
      var $307=$74;
      var $308=$75;
      var $309=(($306)|0);
      var $310=$309;
      var $311=(($310)|0);
      var $312=$311;
      var $313=HEAPU8[($312)];
      var $314=(($313)&255);
      var $315=$314 >> 1;
      var $316=$76;
      var $317 = $315;__label__ = 35; break;
    case 35: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $317;
      var $318=$80;
      var $319=(($317)|0)==0;
      var $320=$81;
      if ($319) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $321
      var $322=$__ct;
      var $323=$__nf;
      var $324=$__ns;
      var $325=$96;
      var $326=HEAP32[(($325)>>2)];
      var $327=$63;
      var $328=$64;
      var $329=$65;
      var $330=$66;
      HEAP32[(($63)>>2)]=$322;
      HEAP32[(($64)>>2)]=$323;
      HEAP32[(($65)>>2)]=$324;
      HEAP32[(($66)>>2)]=$326;
      var $331=HEAP32[(($63)>>2)];
      var $332=$331;
      var $333=HEAP32[(($332)>>2)];
      var $334=(($333+32)|0);
      var $335=HEAP32[(($334)>>2)];
      var $336=HEAP32[(($64)>>2)];
      var $337=HEAP32[(($65)>>2)];
      var $338=HEAP32[(($66)>>2)];
      var $339=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$335]($331, $336, $337, $338) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 5; break; };
    case 37: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit3
      var $340=$63;
      var $341=$64;
      var $342=$65;
      var $343=$66;
      __label__ = 38; break;
    case 38: // $344
      var $345=$__ns;
      var $346=$__nf;
      var $347=$345;
      var $348=$346;
      var $349=(($347-$348)|0);
      var $350=$96;
      var $351=HEAP32[(($350)>>2)];
      var $352=(($351+$349)|0);
      HEAP32[(($350)>>2)]=$352;
      __label__ = 76; break;
    case 39: // $353
      var $354=$__nf;
      var $355=$__ns;
      var $356=$59;
      var $357=$60;
      var $358=$61;
      var $359=$62;
      HEAP32[(($60)>>2)]=$354;
      HEAP32[(($61)>>2)]=$355;
      var $360=HEAP32[(($60)>>2)];
      var $361=HEAP32[(($61)>>2)];
      var $tmp_i=$59;
      var $tmp1_i=$62;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $362=$57;
      var $363=$58;
      HEAP32[(($57)>>2)]=$360;
      HEAP32[(($58)>>2)]=$361;
      var $364=HEAP32[(($57)>>2)];
      var $365=HEAP32[(($58)>>2)];
      var $366=(($364)|0)!=(($365)|0);
      if ($366) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $367
      __label__ = 41; break;
    case 41: // $368
      var $369=HEAPU32[(($57)>>2)];
      var $370=HEAP32[(($58)>>2)];
      var $371=(($370-1)|0);
      HEAP32[(($58)>>2)]=$371;
      var $372=(($369)>>>0) < (($371)>>>0);
      if ($372) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $373
      var $374=HEAP32[(($57)>>2)];
      var $375=HEAP32[(($58)>>2)];
      var $376=$55;
      var $377=$56;
      HEAP32[(($55)>>2)]=$374;
      HEAP32[(($56)>>2)]=$375;
      var $378=HEAP32[(($55)>>2)];
      var $379=$54;
      HEAP32[(($54)>>2)]=$378;
      var $380=HEAP32[(($54)>>2)];
      var $381=$54;
      var $382=HEAP8[($380)];
      HEAP8[($__t_i_i_i)]=$382;
      var $383=HEAP32[(($56)>>2)];
      var $384=$52;
      HEAP32[(($52)>>2)]=$383;
      var $385=HEAP32[(($52)>>2)];
      var $386=$52;
      var $387=HEAP8[($385)];
      var $388=HEAP32[(($55)>>2)];
      HEAP8[($388)]=$387;
      var $389=$53;
      HEAP32[(($53)>>2)]=$__t_i_i_i;
      var $390=HEAP32[(($53)>>2)];
      var $391=$53;
      var $392=HEAP8[($390)];
      var $393=HEAP32[(($56)>>2)];
      HEAP8[($393)]=$392;
      var $394=$55;
      var $395=$56;
      var $396=HEAP32[(($57)>>2)];
      var $397=(($396+1)|0);
      HEAP32[(($57)>>2)]=$397;
      __label__ = 41; break;
    case 43: // $398
      __label__ = 44; break;
    case 44: // $_ZNSt3__17reverseIPcEEvT_S2__exit
      var $399=$57;
      var $400=$58;
      var $401=$59;
      var $402=$60;
      var $403=$61;
      var $404=$62;
      __label__ = 45; break;
    case 45: // $405
      var $406=$__npt;
      var $407=$49;
      HEAP32[(($49)>>2)]=$406;
      var $408=HEAP32[(($49)>>2)];
      var $409=$408;
      var $410=HEAP32[(($409)>>2)];
      var $411=(($410+16)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$412]($408) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 5; break; };
    case 46: // $_ZNKSt3__18numpunctIcE13thousands_sepEv_exit
      var $414=$49;
      __label__ = 47; break;
    case 47: // $415
      $__thousands_sep=$413;
      $__dc=0;
      $__dg=0;
      var $416=$__nf;
      $__p=$416;
      __label__ = 48; break;
    case 48: // $417
      var $418=$__p;
      var $419=$__ns;
      var $420=(($418)>>>0) < (($419)>>>0);
      if ($420) { __label__ = 49; break; } else { __label__ = 69; break; }
    case 49: // $421
      var $422=$__dg;
      var $423=$47;
      var $424=$48;
      HEAP32[(($47)>>2)]=$__grouping;
      HEAP32[(($48)>>2)]=$422;
      var $425=HEAP32[(($47)>>2)];
      var $426=$46;
      HEAP32[(($46)>>2)]=$425;
      var $427=HEAPU32[(($46)>>2)];
      var $428=$45;
      HEAP32[(($45)>>2)]=$427;
      var $429=HEAP32[(($45)>>2)];
      var $430=(($429)|0);
      var $431=$44;
      HEAP32[(($44)>>2)]=$430;
      var $432=HEAP32[(($44)>>2)];
      var $433=$432;
      var $434=$43;
      HEAP32[(($43)>>2)]=$433;
      var $435=HEAP32[(($43)>>2)];
      var $436=(($435)|0);
      var $437=$43;
      var $438=$44;
      var $439=(($436)|0);
      var $440=$439;
      var $441=(($440)|0);
      var $442=$441;
      var $443=HEAPU8[($442)];
      var $444=(($443)&255);
      var $445=$444 & 1;
      var $446=(($445)|0)!=0;
      var $447=$45;
      if ($446) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $448
      var $449=$39;
      HEAP32[(($39)>>2)]=$427;
      var $450=HEAP32[(($39)>>2)];
      var $451=(($450)|0);
      var $452=$38;
      HEAP32[(($38)>>2)]=$451;
      var $453=HEAP32[(($38)>>2)];
      var $454=$453;
      var $455=$37;
      HEAP32[(($37)>>2)]=$454;
      var $456=HEAP32[(($37)>>2)];
      var $457=(($456)|0);
      var $458=$37;
      var $459=$38;
      var $460=(($457)|0);
      var $461=$460;
      var $462=(($461+8)|0);
      var $463=HEAP32[(($462)>>2)];
      var $464=$39;
      var $482 = $463;__label__ = 52; break;
    case 51: // $465
      var $466=$42;
      HEAP32[(($42)>>2)]=$427;
      var $467=HEAP32[(($42)>>2)];
      var $468=(($467)|0);
      var $469=$41;
      HEAP32[(($41)>>2)]=$468;
      var $470=HEAP32[(($41)>>2)];
      var $471=$470;
      var $472=$40;
      HEAP32[(($40)>>2)]=$471;
      var $473=HEAP32[(($40)>>2)];
      var $474=(($473)|0);
      var $475=$40;
      var $476=$41;
      var $477=(($474)|0);
      var $478=$477;
      var $479=(($478+1)|0);
      var $480=(($479)|0);
      var $481=$42;
      var $482 = $480;__label__ = 52; break;
    case 52: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $482;
      var $483=$46;
      var $484=HEAP32[(($48)>>2)];
      var $485=(($482+$484)|0);
      var $486=$47;
      var $487=$48;
      __label__ = 53; break;
    case 53: // $488
      var $489=HEAP8[($485)];
      var $490=(($489 << 24) >> 24);
      var $491=(($490)|0) > 0;
      if ($491) { __label__ = 54; break; } else { __label__ = 65; break; }
    case 54: // $492
      var $493=$__dc;
      var $494=$__dg;
      var $495=$34;
      var $496=$35;
      HEAP32[(($34)>>2)]=$__grouping;
      HEAP32[(($35)>>2)]=$494;
      var $497=HEAP32[(($34)>>2)];
      var $498=$33;
      HEAP32[(($33)>>2)]=$497;
      var $499=HEAPU32[(($33)>>2)];
      var $500=$32;
      HEAP32[(($32)>>2)]=$499;
      var $501=HEAP32[(($32)>>2)];
      var $502=(($501)|0);
      var $503=$31;
      HEAP32[(($31)>>2)]=$502;
      var $504=HEAP32[(($31)>>2)];
      var $505=$504;
      var $506=$30;
      HEAP32[(($30)>>2)]=$505;
      var $507=HEAP32[(($30)>>2)];
      var $508=(($507)|0);
      var $509=$30;
      var $510=$31;
      var $511=(($508)|0);
      var $512=$511;
      var $513=(($512)|0);
      var $514=$513;
      var $515=HEAPU8[($514)];
      var $516=(($515)&255);
      var $517=$516 & 1;
      var $518=(($517)|0)!=0;
      var $519=$32;
      if ($518) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $520
      var $521=$26;
      HEAP32[(($26)>>2)]=$499;
      var $522=HEAP32[(($26)>>2)];
      var $523=(($522)|0);
      var $524=$25;
      HEAP32[(($25)>>2)]=$523;
      var $525=HEAP32[(($25)>>2)];
      var $526=$525;
      var $527=$24;
      HEAP32[(($24)>>2)]=$526;
      var $528=HEAP32[(($24)>>2)];
      var $529=(($528)|0);
      var $530=$24;
      var $531=$25;
      var $532=(($529)|0);
      var $533=$532;
      var $534=(($533+8)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$26;
      var $554 = $535;__label__ = 57; break;
    case 56: // $537
      var $538=$29;
      HEAP32[(($29)>>2)]=$499;
      var $539=HEAP32[(($29)>>2)];
      var $540=(($539)|0);
      var $541=$28;
      HEAP32[(($28)>>2)]=$540;
      var $542=HEAP32[(($28)>>2)];
      var $543=$542;
      var $544=$27;
      HEAP32[(($27)>>2)]=$543;
      var $545=HEAP32[(($27)>>2)];
      var $546=(($545)|0);
      var $547=$27;
      var $548=$28;
      var $549=(($546)|0);
      var $550=$549;
      var $551=(($550+1)|0);
      var $552=(($551)|0);
      var $553=$29;
      var $554 = $552;__label__ = 57; break;
    case 57: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit5
      var $554;
      var $555=$33;
      var $556=HEAP32[(($35)>>2)];
      var $557=(($554+$556)|0);
      var $558=$34;
      var $559=$35;
      __label__ = 58; break;
    case 58: // $560
      var $561=HEAP8[($557)];
      var $562=(($561 << 24) >> 24);
      var $563=(($493)|0)==(($562)|0);
      if ($563) { __label__ = 59; break; } else { __label__ = 65; break; }
    case 59: // $564
      var $565=$__thousands_sep;
      var $566=$96;
      var $567=HEAP32[(($566)>>2)];
      var $568=(($567+1)|0);
      HEAP32[(($566)>>2)]=$568;
      HEAP8[($567)]=$565;
      $__dc=0;
      var $569=$__dg;
      var $570=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $571=HEAPU32[(($10)>>2)];
      var $572=$9;
      HEAP32[(($9)>>2)]=$571;
      var $573=HEAP32[(($9)>>2)];
      var $574=(($573)|0);
      var $575=$8;
      HEAP32[(($8)>>2)]=$574;
      var $576=HEAP32[(($8)>>2)];
      var $577=$576;
      var $578=$7;
      HEAP32[(($7)>>2)]=$577;
      var $579=HEAP32[(($7)>>2)];
      var $580=(($579)|0);
      var $581=$7;
      var $582=$8;
      var $583=(($580)|0);
      var $584=$583;
      var $585=(($584)|0);
      var $586=$585;
      var $587=HEAPU8[($586)];
      var $588=(($587)&255);
      var $589=$588 & 1;
      var $590=(($589)|0)!=0;
      var $591=$9;
      if ($590) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $592
      var $593=$3;
      HEAP32[(($3)>>2)]=$571;
      var $594=HEAP32[(($3)>>2)];
      var $595=(($594)|0);
      var $596=$2;
      HEAP32[(($2)>>2)]=$595;
      var $597=HEAP32[(($2)>>2)];
      var $598=$597;
      var $599=$1;
      HEAP32[(($1)>>2)]=$598;
      var $600=HEAP32[(($1)>>2)];
      var $601=(($600)|0);
      var $602=$1;
      var $603=$2;
      var $604=(($601)|0);
      var $605=$604;
      var $606=(($605+4)|0);
      var $607=HEAP32[(($606)>>2)];
      var $608=$3;
      var $629 = $607;__label__ = 62; break;
    case 61: // $609
      var $610=$6;
      HEAP32[(($6)>>2)]=$571;
      var $611=HEAP32[(($6)>>2)];
      var $612=(($611)|0);
      var $613=$5;
      HEAP32[(($5)>>2)]=$612;
      var $614=HEAP32[(($5)>>2)];
      var $615=$614;
      var $616=$4;
      HEAP32[(($4)>>2)]=$615;
      var $617=HEAP32[(($4)>>2)];
      var $618=(($617)|0);
      var $619=$4;
      var $620=$5;
      var $621=(($618)|0);
      var $622=$621;
      var $623=(($622)|0);
      var $624=$623;
      var $625=HEAPU8[($624)];
      var $626=(($625)&255);
      var $627=$626 >> 1;
      var $628=$6;
      var $629 = $627;__label__ = 62; break;
    case 62: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $629;
      var $630=$10;
      var $631=(($629-1)|0);
      var $632=(($569)>>>0) < (($631)>>>0);
      if ($632) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $633
      var $634=$__dg;
      var $635=(($634+1)|0);
      $__dg=$635;
      __label__ = 64; break;
    case 64: // $636
      __label__ = 65; break;
    case 65: // $637
      var $638=$__ct;
      var $639=$__p;
      var $640=HEAP8[($639)];
      var $641=$11;
      HEAP32[(($11)>>2)]=$638;
      $12=$640;
      var $642=HEAP32[(($11)>>2)];
      var $643=$642;
      var $644=HEAP32[(($643)>>2)];
      var $645=(($644+28)|0);
      var $646=HEAP32[(($645)>>2)];
      var $647=$12;
      var $648=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$646]($642, $647) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 5; break; };
    case 66: // $_ZNKSt3__15ctypeIcE5widenEc_exit10
      var $649=$11;
      __label__ = 67; break;
    case 67: // $650
      var $651=$96;
      var $652=HEAP32[(($651)>>2)];
      var $653=(($652+1)|0);
      HEAP32[(($651)>>2)]=$653;
      HEAP8[($652)]=$648;
      var $654=$__dc;
      var $655=(($654+1)|0);
      $__dc=$655;
      __label__ = 68; break;
    case 68: // $656
      var $657=$__p;
      var $658=(($657+1)|0);
      $__p=$658;
      __label__ = 48; break;
    case 69: // $659
      var $660=$94;
      var $661=$__nf;
      var $662=$91;
      var $663=$661;
      var $664=$662;
      var $665=(($663-$664)|0);
      var $666=(($660+$665)|0);
      var $667=$96;
      var $668=HEAP32[(($667)>>2)];
      var $669=$20;
      var $670=$21;
      var $671=$22;
      var $672=$23;
      HEAP32[(($21)>>2)]=$666;
      HEAP32[(($22)>>2)]=$668;
      var $673=HEAP32[(($21)>>2)];
      var $674=HEAP32[(($22)>>2)];
      var $tmp_i7=$20;
      var $tmp1_i8=$23;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i7)]=HEAP8[($tmp1_i8)];
      var $675=$18;
      var $676=$19;
      HEAP32[(($18)>>2)]=$673;
      HEAP32[(($19)>>2)]=$674;
      var $677=HEAP32[(($18)>>2)];
      var $678=HEAP32[(($19)>>2)];
      var $679=(($677)|0)!=(($678)|0);
      if ($679) { __label__ = 70; break; } else { __label__ = 74; break; }
    case 70: // $680
      __label__ = 71; break;
    case 71: // $681
      var $682=HEAPU32[(($18)>>2)];
      var $683=HEAP32[(($19)>>2)];
      var $684=(($683-1)|0);
      HEAP32[(($19)>>2)]=$684;
      var $685=(($682)>>>0) < (($684)>>>0);
      if ($685) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $686
      var $687=HEAP32[(($18)>>2)];
      var $688=HEAP32[(($19)>>2)];
      var $689=$16;
      var $690=$17;
      HEAP32[(($16)>>2)]=$687;
      HEAP32[(($17)>>2)]=$688;
      var $691=HEAP32[(($16)>>2)];
      var $692=$15;
      HEAP32[(($15)>>2)]=$691;
      var $693=HEAP32[(($15)>>2)];
      var $694=$15;
      var $695=HEAP8[($693)];
      HEAP8[($__t_i_i_i6)]=$695;
      var $696=HEAP32[(($17)>>2)];
      var $697=$13;
      HEAP32[(($13)>>2)]=$696;
      var $698=HEAP32[(($13)>>2)];
      var $699=$13;
      var $700=HEAP8[($698)];
      var $701=HEAP32[(($16)>>2)];
      HEAP8[($701)]=$700;
      var $702=$14;
      HEAP32[(($14)>>2)]=$__t_i_i_i6;
      var $703=HEAP32[(($14)>>2)];
      var $704=$14;
      var $705=HEAP8[($703)];
      var $706=HEAP32[(($17)>>2)];
      HEAP8[($706)]=$705;
      var $707=$16;
      var $708=$17;
      var $709=HEAP32[(($18)>>2)];
      var $710=(($709+1)|0);
      HEAP32[(($18)>>2)]=$710;
      __label__ = 71; break;
    case 73: // $711
      __label__ = 74; break;
    case 74: // $_ZNSt3__17reverseIPcEEvT_S2__exit9
      var $712=$18;
      var $713=$19;
      var $714=$20;
      var $715=$21;
      var $716=$22;
      var $717=$23;
      __label__ = 75; break;
    case 75: // $718
      __label__ = 76; break;
    case 76: // $719
      var $720=$__ns;
      $__nf=$720;
      __label__ = 77; break;
    case 77: // $721
      var $722=$__nf;
      var $723=$93;
      var $724=(($722)>>>0) < (($723)>>>0);
      if ($724) { __label__ = 78; break; } else { __label__ = 87; break; }
    case 78: // $725
      var $726=$__nf;
      var $727=HEAP8[($726)];
      var $728=(($727 << 24) >> 24);
      var $729=(($728)|0)==46;
      if ($729) { __label__ = 79; break; } else { __label__ = 82; break; }
    case 79: // $730
      var $731=$__npt;
      var $732=$36;
      HEAP32[(($36)>>2)]=$731;
      var $733=HEAP32[(($36)>>2)];
      var $734=$733;
      var $735=HEAP32[(($734)>>2)];
      var $736=(($735+12)|0);
      var $737=HEAP32[(($736)>>2)];
      var $738=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$737]($733) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 5; break; };
    case 80: // $_ZNKSt3__18numpunctIcE13decimal_pointEv_exit
      var $739=$36;
      __label__ = 81; break;
    case 81: // $740
      var $741=$96;
      var $742=HEAP32[(($741)>>2)];
      var $743=(($742+1)|0);
      HEAP32[(($741)>>2)]=$743;
      HEAP8[($742)]=$738;
      var $744=$__nf;
      var $745=(($744+1)|0);
      $__nf=$745;
      __label__ = 87; break;
    case 82: // $746
      var $747=$__ct;
      var $748=$__nf;
      var $749=HEAP8[($748)];
      var $750=$50;
      HEAP32[(($50)>>2)]=$747;
      $51=$749;
      var $751=HEAP32[(($50)>>2)];
      var $752=$751;
      var $753=HEAP32[(($752)>>2)];
      var $754=(($753+28)|0);
      var $755=HEAP32[(($754)>>2)];
      var $756=$51;
      var $757=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$755]($751, $756) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 5; break; };
    case 83: // $_ZNKSt3__15ctypeIcE5widenEc_exit4
      var $758=$50;
      __label__ = 84; break;
    case 84: // $759
      var $760=$96;
      var $761=HEAP32[(($760)>>2)];
      var $762=(($761+1)|0);
      HEAP32[(($760)>>2)]=$762;
      HEAP8[($761)]=$757;
      __label__ = 85; break;
    case 85: // $763
      __label__ = 86; break;
    case 86: // $764
      var $765=$__nf;
      var $766=(($765+1)|0);
      $__nf=$766;
      __label__ = 77; break;
    case 87: // $767
      var $768=$__ct;
      var $769=$__nf;
      var $770=$93;
      var $771=$96;
      var $772=HEAP32[(($771)>>2)];
      var $773=$67;
      var $774=$68;
      var $775=$69;
      var $776=$70;
      HEAP32[(($67)>>2)]=$768;
      HEAP32[(($68)>>2)]=$769;
      HEAP32[(($69)>>2)]=$770;
      HEAP32[(($70)>>2)]=$772;
      var $777=HEAP32[(($67)>>2)];
      var $778=$777;
      var $779=HEAP32[(($778)>>2)];
      var $780=(($779+32)|0);
      var $781=HEAP32[(($780)>>2)];
      var $782=HEAP32[(($68)>>2)];
      var $783=HEAP32[(($69)>>2)];
      var $784=HEAP32[(($70)>>2)];
      var $785=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$781]($777, $782, $783, $784) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 5; break; };
    case 88: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $786=$67;
      var $787=$68;
      var $788=$69;
      var $789=$70;
      __label__ = 89; break;
    case 89: // $790
      var $791=$93;
      var $792=$__nf;
      var $793=$791;
      var $794=$792;
      var $795=(($793-$794)|0);
      var $796=$96;
      var $797=HEAP32[(($796)>>2)];
      var $798=(($797+$795)|0);
      HEAP32[(($796)>>2)]=$798;
      var $799=$92;
      var $800=$93;
      var $801=(($799)|0)==(($800)|0);
      if ($801) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $802
      var $803=$96;
      var $804=HEAP32[(($803)>>2)];
      var $805=$95;
      HEAP32[(($805)>>2)]=$804;
      __label__ = 92; break;
    case 91: // $806
      var $807=$94;
      var $808=$92;
      var $809=$91;
      var $810=$808;
      var $811=$809;
      var $812=(($810-$811)|0);
      var $813=(($807+$812)|0);
      var $814=$95;
      HEAP32[(($814)>>2)]=$813;
      __label__ = 92; break;
    case 92: // $815
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 93: // $816
      __label__ = 94; break;
    case 94: // $817
      var $818=$98;
      var $819=$98;
      var $820=$99;
      var $821=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $819, tempValue);
      var $822=($821.f1 = $820, $821);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 95: // $823
      var $824=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE["X"]=1;

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 616; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i7=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i5=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $__tmp_i3=__stackBase__+136;
      var $33=__stackBase__+140;
      var $34=__stackBase__+144;
      var $35=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $49=__stackBase__+204;
      var $50=__stackBase__+208;
      var $51=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $62=__stackBase__+256;
      var $63=__stackBase__+260;
      var $__tmp_i=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $__tmp_i_i_i1=__stackBase__+312;
      var $75=__stackBase__+316;
      var $76=__stackBase__+320;
      var $77=__stackBase__+324;
      var $78=__stackBase__+328;
      var $79=__stackBase__+332;
      var $80=__stackBase__+336;
      var $81=__stackBase__+340;
      var $82=__stackBase__+344;
      var $83=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $93=__stackBase__+388;
      var $94=__stackBase__+392;
      var $95=__stackBase__+396;
      var $96=__stackBase__+400;
      var $97=__stackBase__+404;
      var $98=__stackBase__+408;
      var $99=__stackBase__+412;
      var $100=__stackBase__+416;
      var $101=__stackBase__+420;
      var $102=__stackBase__+424;
      var $103=__stackBase__+428;
      var $104=__stackBase__+432;
      var $105=__stackBase__+436;
      var $106=__stackBase__+440;
      var $107=__stackBase__+444;
      var $108=__stackBase__+448;
      var $__tmp_i_i_i=__stackBase__+452;
      var $109=__stackBase__+456;
      var $110=__stackBase__+460;
      var $111=__stackBase__+464;
      var $112=__stackBase__+468;
      var $113=__stackBase__+472;
      var $114;
      var $115;
      var $116;
      var $117;
      var $__fmt=__stackBase__+476;
      var $__len;
      var $__specify_precision;
      var $__nbuf;
      var $__nar=__stackBase__+484;
      var $__nb=__stackBase__+516;
      var $__nc;
      var $__nbh=__stackBase__+520;
      var $118;
      var $119;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+528;
      var $__ob;
      var $__obh=__stackBase__+588;
      var $__op=__stackBase__+596;
      var $__oe=__stackBase__+600;
      var $120=__stackBase__+604;
      var $121=__stackBase__+608;
      var $122=__stackBase__+612;
      var $123;
      $114=$this;
      $115=$__iob;
      $116=$__fl;
      $117=$__v;
      var $124=$114;
      var $125=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($125)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0))];HEAP8[($125+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+1)];HEAP8[($125+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+2)];HEAP8[($125+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+3)];HEAP8[($125+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+4)];HEAP8[($125+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+5)];HEAP8[($125+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+6)];HEAP8[($125+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt)|0)+7)];
      $__len=((STRING_TABLE.__str8245)|0);
      var $126=(($__fmt)|0);
      var $127=(($126+1)|0);
      var $128=$__len;
      var $129=$115;
      var $130=$113;
      HEAP32[(($113)>>2)]=$129;
      var $131=HEAP32[(($113)>>2)];
      var $132=(($131+4)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$113;
      var $135=__ZNSt3__114__num_put_base14__format_floatEPcPKcj($127, $128, $133);
      var $136=(($135)&1);
      $__specify_precision=$136;
      $__nbuf=30;
      var $137=(($__nar)|0);
      HEAP32[(($__nb)>>2)]=$137;
      var $138=$__specify_precision;
      var $139=(($138) & 1);
      if ($139) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $140
      var $141=HEAP32[(($__nb)>>2)];
      var $142=__ZNSt3__16__clocEv();
      var $143=(($__fmt)|0);
      var $144=$115;
      var $145=$100;
      HEAP32[(($100)>>2)]=$144;
      var $146=HEAP32[(($100)>>2)];
      var $147=(($146+8)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=$100;
      var $150=$117;
      var $151=__ZNSt3__112__snprintf_lEPcjPvPKcz($141, 30, $142, $143, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$148,(tempDoubleF64[0]=$150,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$151;
      __label__ = 3; break;
    case 2: // $152
      var $153=HEAP32[(($__nb)>>2)];
      var $154=__ZNSt3__16__clocEv();
      var $155=(($__fmt)|0);
      var $156=$117;
      var $157=__ZNSt3__112__snprintf_lEPcjPvPKcz($153, 30, $154, $155, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$156,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$157;
      __label__ = 3; break;
    case 3: // $158
      var $159=$97;
      var $160=$98;
      var $161=$99;
      HEAP32[(($97)>>2)]=$__nbh;
      HEAP32[(($98)>>2)]=0;
      HEAP32[(($99)>>2)]=1496;
      var $162=HEAP32[(($97)>>2)];
      var $163=HEAP32[(($98)>>2)];
      var $164=HEAP32[(($99)>>2)];
      var $165=$94;
      var $166=$95;
      var $167=$96;
      HEAP32[(($94)>>2)]=$162;
      HEAP32[(($95)>>2)]=$163;
      HEAP32[(($96)>>2)]=$164;
      var $168=HEAP32[(($94)>>2)];
      var $169=(($168)|0);
      var $170=$93;
      HEAP32[(($93)>>2)]=$95;
      var $171=HEAP32[(($93)>>2)];
      var $172=$93;
      var $173=HEAP32[(($171)>>2)];
      var $174=$79;
      HEAP32[(($79)>>2)]=$96;
      var $175=HEAP32[(($79)>>2)];
      var $176=$79;
      var $177=HEAP32[(($175)>>2)];
      var $178=$90;
      var $179=$91;
      var $180=$92;
      HEAP32[(($90)>>2)]=$169;
      HEAP32[(($91)>>2)]=$173;
      HEAP32[(($92)>>2)]=$177;
      var $181=HEAP32[(($90)>>2)];
      var $182=HEAP32[(($91)>>2)];
      var $183=HEAP32[(($92)>>2)];
      var $184=$87;
      var $185=$88;
      var $186=$89;
      HEAP32[(($87)>>2)]=$181;
      HEAP32[(($88)>>2)]=$182;
      HEAP32[(($89)>>2)]=$183;
      var $187=HEAP32[(($87)>>2)];
      var $188=$187;
      var $189=$86;
      HEAP32[(($86)>>2)]=$88;
      var $190=HEAP32[(($86)>>2)];
      var $191=$86;
      var $192=HEAP32[(($190)>>2)];
      var $193=$80;
      HEAP32[(($80)>>2)]=$89;
      var $194=HEAP32[(($80)>>2)];
      var $195=$80;
      var $196=HEAP32[(($194)>>2)];
      var $197=$83;
      var $198=$84;
      var $199=$85;
      HEAP32[(($83)>>2)]=$188;
      HEAP32[(($84)>>2)]=$192;
      HEAP32[(($85)>>2)]=$196;
      var $200=HEAP32[(($83)>>2)];
      var $201=(($200)|0);
      var $202=$82;
      HEAP32[(($82)>>2)]=$84;
      var $203=HEAP32[(($82)>>2)];
      var $204=$82;
      var $205=HEAP32[(($203)>>2)];
      HEAP32[(($201)>>2)]=$205;
      var $206=(($200+4)|0);
      var $207=$81;
      HEAP32[(($81)>>2)]=$85;
      var $208=HEAP32[(($81)>>2)];
      var $209=$81;
      var $210=HEAP32[(($208)>>2)];
      HEAP32[(($206)>>2)]=$210;
      var $211=$83;
      var $212=$84;
      var $213=$85;
      var $214=$87;
      var $215=$88;
      var $216=$89;
      var $217=$90;
      var $218=$91;
      var $219=$92;
      var $220=$94;
      var $221=$95;
      var $222=$96;
      var $223=$97;
      var $224=$98;
      var $225=$99;
      var $226=$__nc;
      var $227=(($226)|0) > 29;
      if ($227) { __label__ = 4; break; } else { __label__ = 21; break; }
    case 4: // $228
      var $229=$__specify_precision;
      var $230=(($229) & 1);
      if ($230) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $231
      var $232=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $233
      var $234=(($__fmt)|0);
      var $235=$115;
      var $236=$66;
      HEAP32[(($66)>>2)]=$235;
      var $237=HEAP32[(($66)>>2)];
      var $238=(($237+8)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$66;
      __label__ = 7; break;
    case 7: // $241
      var $242=$117;
      var $243=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $232, $234, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$239,(tempDoubleF64[0]=$242,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $244
      $__nc=$243;
      __label__ = 13; break;
    case 9: // $245
      var $246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $247=$246.f0;
      $118=$247;
      var $248=$246.f1;
      $119=$248;
      __label__ = 55; break;
    case 10: // $249
      var $250=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $251
      var $252=(($__fmt)|0);
      var $253=$117;
      var $254=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $250, $252, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$253,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $255
      $__nc=$254;
      __label__ = 13; break;
    case 13: // $256
      var $257=HEAP32[(($__nb)>>2)];
      var $258=(($257)|0)==0;
      if ($258) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $259
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 9; break; }
    case 15: // $260
      __label__ = 16; break;
    case 16: // $261
      var $262=HEAP32[(($__nb)>>2)];
      var $263=$62;
      var $264=$63;
      var $265=$__tmp_i;
      var $266=$64;
      var $267=$65;
      HEAP32[(($62)>>2)]=$__nbh;
      HEAP32[(($63)>>2)]=$262;
      var $268=HEAP32[(($62)>>2)];
      var $269=(($268)|0);
      var $270=$61;
      HEAP32[(($61)>>2)]=$269;
      var $271=HEAP32[(($61)>>2)];
      var $272=$271;
      var $273=$60;
      HEAP32[(($60)>>2)]=$272;
      var $274=HEAP32[(($60)>>2)];
      var $275=(($274)|0);
      var $276=$60;
      var $277=$61;
      var $278=HEAP32[(($275)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$278;
      var $279=HEAP32[(($63)>>2)];
      var $280=(($268)|0);
      var $281=$59;
      HEAP32[(($59)>>2)]=$280;
      var $282=HEAP32[(($59)>>2)];
      var $283=$282;
      var $284=$58;
      HEAP32[(($58)>>2)]=$283;
      var $285=HEAP32[(($58)>>2)];
      var $286=(($285)|0);
      var $287=$58;
      var $288=$59;
      HEAP32[(($286)>>2)]=$279;
      var $289=HEAP32[(($__tmp_i)>>2)];
      var $290=(($289)|0)!=0;
      if ($290) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $291
      var $292=(($268)|0);
      var $293=$57;
      HEAP32[(($57)>>2)]=$292;
      var $294=HEAP32[(($57)>>2)];
      var $295=$294;
      var $296=$56;
      HEAP32[(($56)>>2)]=$295;
      var $297=HEAP32[(($56)>>2)];
      var $298=(($297+4)|0);
      var $299=$56;
      var $300=$57;
      var $301=HEAP32[(($298)>>2)];
      var $302=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$301]($302) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $303
      __label__ = 20; break;
    case 19: // $304
      var $305=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $306=$305.f0;
      HEAP32[(($64)>>2)]=$306;
      var $307=$305.f1;
      HEAP32[(($65)>>2)]=$307;
      var $308=HEAP32[(($64)>>2)];
      ___cxa_call_unexpected($308);
      throw "Reached an unreachable!"
    case 20: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $309=$62;
      var $310=$63;
      var $311=$__tmp_i;
      var $312=$64;
      var $313=$65;
      __label__ = 21; break;
    case 21: // $314
      var $315=HEAP32[(($__nb)>>2)];
      var $316=$__nc;
      var $317=(($315+$316)|0);
      $__ne=$317;
      var $318=HEAP32[(($__nb)>>2)];
      var $319=$__ne;
      var $320=$115;
      var $321=(function() { try { __THREW__ = false; return __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($318, $319, $320) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $322
      $__np=$321;
      var $323=(($__o)|0);
      $__ob=$323;
      var $324=$53;
      var $325=$54;
      var $326=$55;
      HEAP32[(($53)>>2)]=$__obh;
      HEAP32[(($54)>>2)]=0;
      HEAP32[(($55)>>2)]=1496;
      var $327=HEAP32[(($53)>>2)];
      var $328=HEAP32[(($54)>>2)];
      var $329=HEAP32[(($55)>>2)];
      var $330=$50;
      var $331=$51;
      var $332=$52;
      HEAP32[(($50)>>2)]=$327;
      HEAP32[(($51)>>2)]=$328;
      HEAP32[(($52)>>2)]=$329;
      var $333=HEAP32[(($50)>>2)];
      var $334=(($333)|0);
      var $335=$49;
      HEAP32[(($49)>>2)]=$51;
      var $336=HEAP32[(($49)>>2)];
      var $337=$49;
      var $338=HEAP32[(($336)>>2)];
      var $339=$35;
      HEAP32[(($35)>>2)]=$52;
      var $340=HEAP32[(($35)>>2)];
      var $341=$35;
      var $342=HEAP32[(($340)>>2)];
      var $343=$46;
      var $344=$47;
      var $345=$48;
      HEAP32[(($46)>>2)]=$334;
      HEAP32[(($47)>>2)]=$338;
      HEAP32[(($48)>>2)]=$342;
      var $346=HEAP32[(($46)>>2)];
      var $347=HEAP32[(($47)>>2)];
      var $348=HEAP32[(($48)>>2)];
      var $349=$43;
      var $350=$44;
      var $351=$45;
      HEAP32[(($43)>>2)]=$346;
      HEAP32[(($44)>>2)]=$347;
      HEAP32[(($45)>>2)]=$348;
      var $352=HEAP32[(($43)>>2)];
      var $353=$352;
      var $354=$42;
      HEAP32[(($42)>>2)]=$44;
      var $355=HEAP32[(($42)>>2)];
      var $356=$42;
      var $357=HEAP32[(($355)>>2)];
      var $358=$36;
      HEAP32[(($36)>>2)]=$45;
      var $359=HEAP32[(($36)>>2)];
      var $360=$36;
      var $361=HEAP32[(($359)>>2)];
      var $362=$39;
      var $363=$40;
      var $364=$41;
      HEAP32[(($39)>>2)]=$353;
      HEAP32[(($40)>>2)]=$357;
      HEAP32[(($41)>>2)]=$361;
      var $365=HEAP32[(($39)>>2)];
      var $366=(($365)|0);
      var $367=$38;
      HEAP32[(($38)>>2)]=$40;
      var $368=HEAP32[(($38)>>2)];
      var $369=$38;
      var $370=HEAP32[(($368)>>2)];
      HEAP32[(($366)>>2)]=$370;
      var $371=(($365+4)|0);
      var $372=$37;
      HEAP32[(($37)>>2)]=$41;
      var $373=HEAP32[(($37)>>2)];
      var $374=$37;
      var $375=HEAP32[(($373)>>2)];
      HEAP32[(($371)>>2)]=$375;
      var $376=$39;
      var $377=$40;
      var $378=$41;
      var $379=$43;
      var $380=$44;
      var $381=$45;
      var $382=$46;
      var $383=$47;
      var $384=$48;
      var $385=$50;
      var $386=$51;
      var $387=$52;
      var $388=$53;
      var $389=$54;
      var $390=$55;
      __label__ = 23; break;
    case 23: // $391
      var $392=HEAP32[(($__nb)>>2)];
      var $393=(($__nar)|0);
      var $394=(($392)|0)!=(($393)|0);
      if ($394) { __label__ = 24; break; } else { __label__ = 33; break; }
    case 24: // $395
      var $396=$__nc;
      var $397=((($396<<1))|0);
      var $398=(($397)|0);
      var $399=_malloc($398);
      $__ob=$399;
      var $400=$__ob;
      var $401=(($400)|0)==0;
      if ($401) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $402
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $403
      __label__ = 28; break;
    case 27: // $404
      var $405=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $406=$405.f0;
      $118=$406;
      var $407=$405.f1;
      $119=$407;
      __label__ = 49; break;
    case 28: // $408
      var $409=$__ob;
      var $410=$31;
      var $411=$32;
      var $412=$__tmp_i3;
      var $413=$33;
      var $414=$34;
      HEAP32[(($31)>>2)]=$__obh;
      HEAP32[(($32)>>2)]=$409;
      var $415=HEAP32[(($31)>>2)];
      var $416=(($415)|0);
      var $417=$30;
      HEAP32[(($30)>>2)]=$416;
      var $418=HEAP32[(($30)>>2)];
      var $419=$418;
      var $420=$29;
      HEAP32[(($29)>>2)]=$419;
      var $421=HEAP32[(($29)>>2)];
      var $422=(($421)|0);
      var $423=$29;
      var $424=$30;
      var $425=HEAP32[(($422)>>2)];
      HEAP32[(($__tmp_i3)>>2)]=$425;
      var $426=HEAP32[(($32)>>2)];
      var $427=(($415)|0);
      var $428=$28;
      HEAP32[(($28)>>2)]=$427;
      var $429=HEAP32[(($28)>>2)];
      var $430=$429;
      var $431=$27;
      HEAP32[(($27)>>2)]=$430;
      var $432=HEAP32[(($27)>>2)];
      var $433=(($432)|0);
      var $434=$27;
      var $435=$28;
      HEAP32[(($433)>>2)]=$426;
      var $436=HEAP32[(($__tmp_i3)>>2)];
      var $437=(($436)|0)!=0;
      if ($437) { __label__ = 29; break; } else { __label__ = 32; break; }
    case 29: // $438
      var $439=(($415)|0);
      var $440=$26;
      HEAP32[(($26)>>2)]=$439;
      var $441=HEAP32[(($26)>>2)];
      var $442=$441;
      var $443=$25;
      HEAP32[(($25)>>2)]=$442;
      var $444=HEAP32[(($25)>>2)];
      var $445=(($444+4)|0);
      var $446=$25;
      var $447=$26;
      var $448=HEAP32[(($445)>>2)];
      var $449=HEAP32[(($__tmp_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$448]($449) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $450
      __label__ = 32; break;
    case 31: // $451
      var $452=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $453=$452.f0;
      HEAP32[(($33)>>2)]=$453;
      var $454=$452.f1;
      HEAP32[(($34)>>2)]=$454;
      var $455=HEAP32[(($33)>>2)];
      ___cxa_call_unexpected($455);
      throw "Reached an unreachable!"
    case 32: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit4
      var $456=$31;
      var $457=$32;
      var $458=$__tmp_i3;
      var $459=$33;
      var $460=$34;
      __label__ = 33; break;
    case 33: // $461
      var $462=HEAP32[(($__nb)>>2)];
      var $463=$__np;
      var $464=$__ne;
      var $465=$__ob;
      var $466=$115;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($120, $466) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 27; break; }
    case 34: // $467
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE($462, $463, $464, $465, $__op, $__oe, $120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 42; break; }
    case 35: // $468
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 27; break; }
    case 36: // $469
      var $470=$122;
      var $471=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($470)>>2)]=HEAP32[(($471)>>2)];
      var $472=$__ob;
      var $473=HEAP32[(($__op)>>2)];
      var $474=HEAP32[(($__oe)>>2)];
      var $475=$115;
      var $476=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($121, $122, $472, $473, $474, $475, $476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 27; break; }
    case 37: // $477
      var $478=$__s;
      var $479=$121;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($478)>>2)]=HEAP32[(($479)>>2)];
      var $480=$agg_result;
      var $481=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($480)>>2)]=HEAP32[(($481)>>2)];
      $123=1;
      var $482=$24;
      HEAP32[(($24)>>2)]=$__obh;
      var $483=HEAP32[(($24)>>2)];
      var $484=$23;
      HEAP32[(($23)>>2)]=$483;
      var $485=HEAP32[(($23)>>2)];
      var $486=$19;
      var $487=$20;
      var $488=$__tmp_i_i_i5;
      var $489=$21;
      var $490=$22;
      HEAP32[(($19)>>2)]=$485;
      HEAP32[(($20)>>2)]=0;
      var $491=HEAP32[(($19)>>2)];
      var $492=(($491)|0);
      var $493=$18;
      HEAP32[(($18)>>2)]=$492;
      var $494=HEAP32[(($18)>>2)];
      var $495=$494;
      var $496=$17;
      HEAP32[(($17)>>2)]=$495;
      var $497=HEAP32[(($17)>>2)];
      var $498=(($497)|0);
      var $499=$17;
      var $500=$18;
      var $501=HEAP32[(($498)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$501;
      var $502=HEAP32[(($20)>>2)];
      var $503=(($491)|0);
      var $504=$16;
      HEAP32[(($16)>>2)]=$503;
      var $505=HEAP32[(($16)>>2)];
      var $506=$505;
      var $507=$15;
      HEAP32[(($15)>>2)]=$506;
      var $508=HEAP32[(($15)>>2)];
      var $509=(($508)|0);
      var $510=$15;
      var $511=$16;
      HEAP32[(($509)>>2)]=$502;
      var $512=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $513=(($512)|0)!=0;
      if ($513) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $514
      var $515=(($491)|0);
      var $516=$14;
      HEAP32[(($14)>>2)]=$515;
      var $517=HEAP32[(($14)>>2)];
      var $518=$517;
      var $519=$13;
      HEAP32[(($13)>>2)]=$518;
      var $520=HEAP32[(($13)>>2)];
      var $521=(($520+4)|0);
      var $522=$13;
      var $523=$14;
      var $524=HEAP32[(($521)>>2)];
      var $525=HEAP32[(($__tmp_i_i_i5)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$524]($525) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $526
      __label__ = 41; break;
    case 40: // $527
      var $528=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $529=$528.f0;
      HEAP32[(($21)>>2)]=$529;
      var $530=$528.f1;
      HEAP32[(($22)>>2)]=$530;
      var $531=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($531);
      throw "Reached an unreachable!"
    case 41: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit6
      var $532=$19;
      var $533=$20;
      var $534=$__tmp_i_i_i5;
      var $535=$21;
      var $536=$22;
      var $537=$23;
      var $538=$24;
      __label__ = 44; break;
    case 42: // $539
      var $540=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $541=$540.f0;
      $118=$541;
      var $542=$540.f1;
      $119=$542;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 62; break; }
    case 43: // $543
      __label__ = 49; break;
    case 44: // $544
      var $545=$12;
      HEAP32[(($12)>>2)]=$__nbh;
      var $546=HEAP32[(($12)>>2)];
      var $547=$11;
      HEAP32[(($11)>>2)]=$546;
      var $548=HEAP32[(($11)>>2)];
      var $549=$7;
      var $550=$8;
      var $551=$__tmp_i_i_i7;
      var $552=$9;
      var $553=$10;
      HEAP32[(($7)>>2)]=$548;
      HEAP32[(($8)>>2)]=0;
      var $554=HEAP32[(($7)>>2)];
      var $555=(($554)|0);
      var $556=$6;
      HEAP32[(($6)>>2)]=$555;
      var $557=HEAP32[(($6)>>2)];
      var $558=$557;
      var $559=$5;
      HEAP32[(($5)>>2)]=$558;
      var $560=HEAP32[(($5)>>2)];
      var $561=(($560)|0);
      var $562=$5;
      var $563=$6;
      var $564=HEAP32[(($561)>>2)];
      HEAP32[(($__tmp_i_i_i7)>>2)]=$564;
      var $565=HEAP32[(($8)>>2)];
      var $566=(($554)|0);
      var $567=$4;
      HEAP32[(($4)>>2)]=$566;
      var $568=HEAP32[(($4)>>2)];
      var $569=$568;
      var $570=$3;
      HEAP32[(($3)>>2)]=$569;
      var $571=HEAP32[(($3)>>2)];
      var $572=(($571)|0);
      var $573=$3;
      var $574=$4;
      HEAP32[(($572)>>2)]=$565;
      var $575=HEAP32[(($__tmp_i_i_i7)>>2)];
      var $576=(($575)|0)!=0;
      if ($576) { __label__ = 45; break; } else { __label__ = 48; break; }
    case 45: // $577
      var $578=(($554)|0);
      var $579=$2;
      HEAP32[(($2)>>2)]=$578;
      var $580=HEAP32[(($2)>>2)];
      var $581=$580;
      var $582=$1;
      HEAP32[(($1)>>2)]=$581;
      var $583=HEAP32[(($1)>>2)];
      var $584=(($583+4)|0);
      var $585=$1;
      var $586=$2;
      var $587=HEAP32[(($584)>>2)];
      var $588=HEAP32[(($__tmp_i_i_i7)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$587]($588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $589
      __label__ = 48; break;
    case 47: // $590
      var $591=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $592=$591.f0;
      HEAP32[(($9)>>2)]=$592;
      var $593=$591.f1;
      HEAP32[(($10)>>2)]=$593;
      var $594=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($594);
      throw "Reached an unreachable!"
    case 48: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit8
      var $595=$7;
      var $596=$8;
      var $597=$__tmp_i_i_i7;
      var $598=$9;
      var $599=$10;
      var $600=$11;
      var $601=$12;
      STACKTOP = __stackBase__;
      return;
    case 49: // $602
      var $603=$78;
      HEAP32[(($78)>>2)]=$__obh;
      var $604=HEAP32[(($78)>>2)];
      var $605=$77;
      HEAP32[(($77)>>2)]=$604;
      var $606=HEAP32[(($77)>>2)];
      var $607=$73;
      var $608=$74;
      var $609=$__tmp_i_i_i1;
      var $610=$75;
      var $611=$76;
      HEAP32[(($73)>>2)]=$606;
      HEAP32[(($74)>>2)]=0;
      var $612=HEAP32[(($73)>>2)];
      var $613=(($612)|0);
      var $614=$72;
      HEAP32[(($72)>>2)]=$613;
      var $615=HEAP32[(($72)>>2)];
      var $616=$615;
      var $617=$71;
      HEAP32[(($71)>>2)]=$616;
      var $618=HEAP32[(($71)>>2)];
      var $619=(($618)|0);
      var $620=$71;
      var $621=$72;
      var $622=HEAP32[(($619)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$622;
      var $623=HEAP32[(($74)>>2)];
      var $624=(($612)|0);
      var $625=$70;
      HEAP32[(($70)>>2)]=$624;
      var $626=HEAP32[(($70)>>2)];
      var $627=$626;
      var $628=$69;
      HEAP32[(($69)>>2)]=$627;
      var $629=HEAP32[(($69)>>2)];
      var $630=(($629)|0);
      var $631=$69;
      var $632=$70;
      HEAP32[(($630)>>2)]=$623;
      var $633=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $634=(($633)|0)!=0;
      if ($634) { __label__ = 50; break; } else { __label__ = 53; break; }
    case 50: // $635
      var $636=(($612)|0);
      var $637=$68;
      HEAP32[(($68)>>2)]=$636;
      var $638=HEAP32[(($68)>>2)];
      var $639=$638;
      var $640=$67;
      HEAP32[(($67)>>2)]=$639;
      var $641=HEAP32[(($67)>>2)];
      var $642=(($641+4)|0);
      var $643=$67;
      var $644=$68;
      var $645=HEAP32[(($642)>>2)];
      var $646=HEAP32[(($__tmp_i_i_i1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$645]($646) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $647
      __label__ = 53; break;
    case 52: // $648
      var $649=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $650=$649.f0;
      HEAP32[(($75)>>2)]=$650;
      var $651=$649.f1;
      HEAP32[(($76)>>2)]=$651;
      var $652=HEAP32[(($75)>>2)];
      ___cxa_call_unexpected($652);
      throw "Reached an unreachable!"
    case 53: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit2
      var $653=$73;
      var $654=$74;
      var $655=$__tmp_i_i_i1;
      var $656=$75;
      var $657=$76;
      var $658=$77;
      var $659=$78;
      __label__ = 54; break;
    case 54: // $660
      __label__ = 55; break;
    case 55: // $661
      var $662=$112;
      HEAP32[(($112)>>2)]=$__nbh;
      var $663=HEAP32[(($112)>>2)];
      var $664=$111;
      HEAP32[(($111)>>2)]=$663;
      var $665=HEAP32[(($111)>>2)];
      var $666=$107;
      var $667=$108;
      var $668=$__tmp_i_i_i;
      var $669=$109;
      var $670=$110;
      HEAP32[(($107)>>2)]=$665;
      HEAP32[(($108)>>2)]=0;
      var $671=HEAP32[(($107)>>2)];
      var $672=(($671)|0);
      var $673=$106;
      HEAP32[(($106)>>2)]=$672;
      var $674=HEAP32[(($106)>>2)];
      var $675=$674;
      var $676=$105;
      HEAP32[(($105)>>2)]=$675;
      var $677=HEAP32[(($105)>>2)];
      var $678=(($677)|0);
      var $679=$105;
      var $680=$106;
      var $681=HEAP32[(($678)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$681;
      var $682=HEAP32[(($108)>>2)];
      var $683=(($671)|0);
      var $684=$104;
      HEAP32[(($104)>>2)]=$683;
      var $685=HEAP32[(($104)>>2)];
      var $686=$685;
      var $687=$103;
      HEAP32[(($103)>>2)]=$686;
      var $688=HEAP32[(($103)>>2)];
      var $689=(($688)|0);
      var $690=$103;
      var $691=$104;
      HEAP32[(($689)>>2)]=$682;
      var $692=HEAP32[(($__tmp_i_i_i)>>2)];
      var $693=(($692)|0)!=0;
      if ($693) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $694
      var $695=(($671)|0);
      var $696=$102;
      HEAP32[(($102)>>2)]=$695;
      var $697=HEAP32[(($102)>>2)];
      var $698=$697;
      var $699=$101;
      HEAP32[(($101)>>2)]=$698;
      var $700=HEAP32[(($101)>>2)];
      var $701=(($700+4)|0);
      var $702=$101;
      var $703=$102;
      var $704=HEAP32[(($701)>>2)];
      var $705=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$704]($705) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $706
      __label__ = 59; break;
    case 58: // $707
      var $708=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $709=$708.f0;
      HEAP32[(($109)>>2)]=$709;
      var $710=$708.f1;
      HEAP32[(($110)>>2)]=$710;
      var $711=HEAP32[(($109)>>2)];
      ___cxa_call_unexpected($711);
      throw "Reached an unreachable!"
    case 59: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $712=$107;
      var $713=$108;
      var $714=$__tmp_i_i_i;
      var $715=$109;
      var $716=$110;
      var $717=$111;
      var $718=$112;
      __label__ = 60; break;
    case 60: // $719
      __label__ = 61; break;
    case 61: // $720
      var $721=$118;
      var $722=$118;
      var $723=$119;
      var $724=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $722, tempValue);
      var $725=($724.f1 = $723, $724);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $726
      var $727=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce["X"]=1;

function ___cxx_global_var_init9275() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 96; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $8;
      var $9;
      var $__fmt=__stackBase__+20;
      var $__nbuf;
      var $__nar=__stackBase__+28;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+48;
      var $__op;
      var $__oe;
      var $__ct;
      var $10=__stackBase__+88;
      var $11;
      var $12;
      var $13=__stackBase__+92;
      $6=$this;
      $7=$__iob;
      $8=$__fl;
      $9=$__v;
      var $14=$6;
      var $15=$__fmt;
      assert(6 % 1 === 0, 'memcpy given ' + 6 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($15)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt)|0))];HEAP8[($15+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt)|0)+1)];HEAP8[($15+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt)|0)+2)];HEAP8[($15+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt)|0)+3)];HEAP8[($15+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt)|0)+4)];HEAP8[($15+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt)|0)+5)];
      $__nbuf=20;
      var $16=(($__nar)|0);
      var $17=__ZNSt3__16__clocEv();
      var $18=(($__fmt)|0);
      var $19=$9;
      var $20=__ZNSt3__111__sprintf_lEPcPvPKcz($16, $17, $18, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt));
      $__nc=$20;
      var $21=(($__nar)|0);
      var $22=$__nc;
      var $23=(($21+$22)|0);
      $__ne=$23;
      var $24=(($__nar)|0);
      var $25=$__ne;
      var $26=$7;
      var $27=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($24, $25, $26);
      $__np=$27;
      var $28=$7;
      __ZNKSt3__18ios_base6getlocEv($10, $28);
      var $29=$5;
      HEAP32[(($5)>>2)]=$10;
      var $30=HEAP32[(($5)>>2)];
      var $31=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($30, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $32=$31;
      var $33=$5;
      __label__ = 2; break;
    case 2: // $34
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($10);
      $__ct=$32;
      var $35=$__ct;
      var $36=(($__nar)|0);
      var $37=$__ne;
      var $38=(($__o)|0);
      var $39=$1;
      var $40=$2;
      var $41=$3;
      var $42=$4;
      HEAP32[(($1)>>2)]=$35;
      HEAP32[(($2)>>2)]=$36;
      HEAP32[(($3)>>2)]=$37;
      HEAP32[(($4)>>2)]=$38;
      var $43=HEAP32[(($1)>>2)];
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+32)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=HEAP32[(($2)>>2)];
      var $49=HEAP32[(($3)>>2)];
      var $50=HEAP32[(($4)>>2)];
      var $51=FUNCTION_TABLE[$47]($43, $48, $49, $50);
      var $52=$1;
      var $53=$2;
      var $54=$3;
      var $55=$4;
      var $56=(($__o)|0);
      var $57=$__ne;
      var $58=(($__nar)|0);
      var $59=$57;
      var $60=$58;
      var $61=(($59-$60)|0);
      var $62=(($56+$61)|0);
      $__oe=$62;
      var $63=$__np;
      var $64=$__ne;
      var $65=(($63)|0)==(($64)|0);
      if ($65) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $66
      var $67=$__oe;
      $__op=$67;
      __label__ = 7; break;
    case 4: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $11=$70;
      var $71=$69.f1;
      $12=$71;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $72
      __label__ = 8; break;
    case 6: // $73
      var $74=(($__o)|0);
      var $75=$__np;
      var $76=(($__nar)|0);
      var $77=$75;
      var $78=$76;
      var $79=(($77-$78)|0);
      var $80=(($74+$79)|0);
      $__op=$80;
      __label__ = 7; break;
    case 7: // $81
      var $82=$13;
      var $83=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($82)>>2)]=HEAP32[(($83)>>2)];
      var $84=(($__o)|0);
      var $85=$__op;
      var $86=$__oe;
      var $87=$7;
      var $88=$8;
      __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $13, $84, $85, $86, $87, $88);
      STACKTOP = __stackBase__;
      return;
    case 8: // $89
      var $90=$11;
      var $91=$11;
      var $92=$12;
      var $93=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $91, tempValue);
      var $94=($93.f1 = $92, $93);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $95
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 280; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64;
      var $65;
      var $66;
      var $67;
      var $68=__stackBase__+252;
      var $__np;
      var $69=__stackBase__+256;
      var $70;
      var $71;
      var $__nm=__stackBase__+260;
      var $__i=__stackBase__+272;
      var $72=__stackBase__+276;
      var $73;
      $64=$this;
      $65=$__iob;
      $66=$__fl;
      var $74=(($__v)&1);
      $67=$74;
      var $75=$64;
      var $76=$65;
      var $77=$63;
      HEAP32[(($63)>>2)]=$76;
      var $78=HEAP32[(($63)>>2)];
      var $79=(($78+4)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$63;
      var $82=$80 & 1;
      var $83=(($82)|0)==0;
      if ($83) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $84
      var $85=$75;
      var $86=HEAP32[(($85)>>2)];
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=$68;
      var $90=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($89)>>2)]=HEAP32[(($90)>>2)];
      var $91=$65;
      var $92=$66;
      var $93=$67;
      var $94=(($93) & 1);
      var $95=(($94)&1);
      FUNCTION_TABLE[$88]($agg_result, $75, $68, $91, $92, $95);
      __label__ = 35; break;
    case 2: // $96
      var $97=$65;
      __ZNKSt3__18ios_base6getlocEv($69, $97);
      var $98=$62;
      HEAP32[(($62)>>2)]=$69;
      var $99=HEAP32[(($62)>>2)];
      var $100=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($99, __ZNSt3__18numpunctIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 30; break; };
    case 3: // $_ZNSt3__19use_facetINS_8numpunctIwEEEERKT_RKNS_6localeE_exit
      var $101=$100;
      var $102=$62;
      __label__ = 4; break;
    case 4: // $103
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($69);
      $__np=$101;
      var $104=$67;
      var $105=(($104) & 1);
      if ($105) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $106
      var $107=$__np;
      var $108=$61;
      HEAP32[(($61)>>2)]=$107;
      var $109=HEAP32[(($61)>>2)];
      var $110=$109;
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111+24)|0);
      var $113=HEAP32[(($112)>>2)];
      FUNCTION_TABLE[$113]($__nm, $109);
      var $114=$61;
      __label__ = 7; break;
    case 6: // $115
      var $116=$__np;
      var $117=$60;
      HEAP32[(($60)>>2)]=$116;
      var $118=HEAP32[(($60)>>2)];
      var $119=$118;
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+28)|0);
      var $122=HEAP32[(($121)>>2)];
      FUNCTION_TABLE[$122]($__nm, $118);
      var $123=$60;
      __label__ = 7; break;
    case 7: // $124
      var $125=$59;
      HEAP32[(($59)>>2)]=$__nm;
      var $126=HEAP32[(($59)>>2)];
      var $127=$58;
      HEAP32[(($58)>>2)]=$126;
      var $128=HEAPU32[(($58)>>2)];
      var $129=$57;
      HEAP32[(($57)>>2)]=$128;
      var $130=HEAP32[(($57)>>2)];
      var $131=(($130)|0);
      var $132=$56;
      HEAP32[(($56)>>2)]=$131;
      var $133=HEAP32[(($56)>>2)];
      var $134=$133;
      var $135=$55;
      HEAP32[(($55)>>2)]=$134;
      var $136=HEAP32[(($55)>>2)];
      var $137=(($136)|0);
      var $138=$55;
      var $139=$56;
      var $140=(($137)|0);
      var $141=$140;
      var $142=(($141)|0);
      var $143=$142;
      var $144=HEAPU8[($143)];
      var $145=(($144)&255);
      var $146=$145 & 1;
      var $147=(($146)|0)!=0;
      var $148=$57;
      if ($147) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $149
      var $150=$51;
      HEAP32[(($51)>>2)]=$128;
      var $151=HEAP32[(($51)>>2)];
      var $152=(($151)|0);
      var $153=$50;
      HEAP32[(($50)>>2)]=$152;
      var $154=HEAP32[(($50)>>2)];
      var $155=$154;
      var $156=$49;
      HEAP32[(($49)>>2)]=$155;
      var $157=HEAP32[(($49)>>2)];
      var $158=(($157)|0);
      var $159=$49;
      var $160=$50;
      var $161=(($158)|0);
      var $162=$161;
      var $163=(($162+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$51;
      var $183 = $164;__label__ = 10; break;
    case 9: // $166
      var $167=$54;
      HEAP32[(($54)>>2)]=$128;
      var $168=HEAP32[(($54)>>2)];
      var $169=(($168)|0);
      var $170=$53;
      HEAP32[(($53)>>2)]=$169;
      var $171=HEAP32[(($53)>>2)];
      var $172=$171;
      var $173=$52;
      HEAP32[(($52)>>2)]=$172;
      var $174=HEAP32[(($52)>>2)];
      var $175=(($174)|0);
      var $176=$52;
      var $177=$53;
      var $178=(($175)|0);
      var $179=$178;
      var $180=(($179+4)|0);
      var $181=(($180)|0);
      var $182=$54;
      var $183 = $181;__label__ = 10; break;
    case 10: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv_exit
      var $183;
      var $184=$58;
      var $185=$47;
      var $186=$48;
      HEAP32[(($47)>>2)]=$__i;
      HEAP32[(($48)>>2)]=$183;
      var $187=HEAP32[(($47)>>2)];
      var $188=HEAP32[(($48)>>2)];
      var $189=$45;
      var $190=$46;
      HEAP32[(($45)>>2)]=$187;
      HEAP32[(($46)>>2)]=$188;
      var $191=HEAP32[(($45)>>2)];
      var $192=(($191)|0);
      var $193=HEAP32[(($46)>>2)];
      HEAP32[(($192)>>2)]=$193;
      var $194=$45;
      var $195=$46;
      var $196=$47;
      var $197=$48;
      var $198=$59;
      __label__ = 11; break;
    case 11: // $199
      var $200=$33;
      HEAP32[(($33)>>2)]=$__nm;
      var $201=HEAPU32[(($33)>>2)];
      var $202=$32;
      HEAP32[(($32)>>2)]=$201;
      var $203=HEAPU32[(($32)>>2)];
      var $204=$31;
      HEAP32[(($31)>>2)]=$203;
      var $205=HEAP32[(($31)>>2)];
      var $206=(($205)|0);
      var $207=$30;
      HEAP32[(($30)>>2)]=$206;
      var $208=HEAP32[(($30)>>2)];
      var $209=$208;
      var $210=$29;
      HEAP32[(($29)>>2)]=$209;
      var $211=HEAP32[(($29)>>2)];
      var $212=(($211)|0);
      var $213=$29;
      var $214=$30;
      var $215=(($212)|0);
      var $216=$215;
      var $217=(($216)|0);
      var $218=$217;
      var $219=HEAPU8[($218)];
      var $220=(($219)&255);
      var $221=$220 & 1;
      var $222=(($221)|0)!=0;
      var $223=$31;
      if ($222) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $224
      var $225=$25;
      HEAP32[(($25)>>2)]=$203;
      var $226=HEAP32[(($25)>>2)];
      var $227=(($226)|0);
      var $228=$24;
      HEAP32[(($24)>>2)]=$227;
      var $229=HEAP32[(($24)>>2)];
      var $230=$229;
      var $231=$23;
      HEAP32[(($23)>>2)]=$230;
      var $232=HEAP32[(($23)>>2)];
      var $233=(($232)|0);
      var $234=$23;
      var $235=$24;
      var $236=(($233)|0);
      var $237=$236;
      var $238=(($237+8)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$25;
      var $258 = $239;__label__ = 14; break;
    case 13: // $241
      var $242=$28;
      HEAP32[(($28)>>2)]=$203;
      var $243=HEAP32[(($28)>>2)];
      var $244=(($243)|0);
      var $245=$27;
      HEAP32[(($27)>>2)]=$244;
      var $246=HEAP32[(($27)>>2)];
      var $247=$246;
      var $248=$26;
      HEAP32[(($26)>>2)]=$247;
      var $249=HEAP32[(($26)>>2)];
      var $250=(($249)|0);
      var $251=$26;
      var $252=$27;
      var $253=(($250)|0);
      var $254=$253;
      var $255=(($254+4)|0);
      var $256=(($255)|0);
      var $257=$28;
      var $258 = $256;__label__ = 14; break;
    case 14: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv_exit_i
      var $258;
      var $259=$32;
      var $260=$18;
      HEAP32[(($18)>>2)]=$201;
      var $261=HEAPU32[(($18)>>2)];
      var $262=$17;
      HEAP32[(($17)>>2)]=$261;
      var $263=HEAP32[(($17)>>2)];
      var $264=(($263)|0);
      var $265=$16;
      HEAP32[(($16)>>2)]=$264;
      var $266=HEAP32[(($16)>>2)];
      var $267=$266;
      var $268=$15;
      HEAP32[(($15)>>2)]=$267;
      var $269=HEAP32[(($15)>>2)];
      var $270=(($269)|0);
      var $271=$15;
      var $272=$16;
      var $273=(($270)|0);
      var $274=$273;
      var $275=(($274)|0);
      var $276=$275;
      var $277=HEAPU8[($276)];
      var $278=(($277)&255);
      var $279=$278 & 1;
      var $280=(($279)|0)!=0;
      var $281=$17;
      if ($280) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $282
      var $283=$11;
      HEAP32[(($11)>>2)]=$261;
      var $284=HEAP32[(($11)>>2)];
      var $285=(($284)|0);
      var $286=$10;
      HEAP32[(($10)>>2)]=$285;
      var $287=HEAP32[(($10)>>2)];
      var $288=$287;
      var $289=$9;
      HEAP32[(($9)>>2)]=$288;
      var $290=HEAP32[(($9)>>2)];
      var $291=(($290)|0);
      var $292=$9;
      var $293=$10;
      var $294=(($291)|0);
      var $295=$294;
      var $296=(($295+4)|0);
      var $297=HEAP32[(($296)>>2)];
      var $298=$11;
      var $319 = $297;__label__ = 17; break;
    case 16: // $299
      var $300=$14;
      HEAP32[(($14)>>2)]=$261;
      var $301=HEAP32[(($14)>>2)];
      var $302=(($301)|0);
      var $303=$13;
      HEAP32[(($13)>>2)]=$302;
      var $304=HEAP32[(($13)>>2)];
      var $305=$304;
      var $306=$12;
      HEAP32[(($12)>>2)]=$305;
      var $307=HEAP32[(($12)>>2)];
      var $308=(($307)|0);
      var $309=$12;
      var $310=$13;
      var $311=(($308)|0);
      var $312=$311;
      var $313=(($312)|0);
      var $314=$313;
      var $315=HEAPU8[($314)];
      var $316=(($315)&255);
      var $317=$316 >> 1;
      var $318=$14;
      var $319 = $317;__label__ = 17; break;
    case 17: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv_exit
      var $319;
      var $320=$18;
      var $321=(($258+($319<<2))|0);
      var $322=$21;
      var $323=$22;
      HEAP32[(($21)>>2)]=$72;
      HEAP32[(($22)>>2)]=$321;
      var $324=HEAP32[(($21)>>2)];
      var $325=HEAP32[(($22)>>2)];
      var $326=$19;
      var $327=$20;
      HEAP32[(($19)>>2)]=$324;
      HEAP32[(($20)>>2)]=$325;
      var $328=HEAP32[(($19)>>2)];
      var $329=(($328)|0);
      var $330=HEAP32[(($20)>>2)];
      HEAP32[(($329)>>2)]=$330;
      var $331=$19;
      var $332=$20;
      var $333=$21;
      var $334=$22;
      var $335=$33;
      var $336=$5;
      var $337=$6;
      HEAP32[(($5)>>2)]=$__i;
      HEAP32[(($6)>>2)]=$72;
      var $338=HEAP32[(($5)>>2)];
      var $339=HEAP32[(($6)>>2)];
      var $340=$3;
      var $341=$4;
      HEAP32[(($3)>>2)]=$338;
      HEAP32[(($4)>>2)]=$339;
      var $342=HEAP32[(($3)>>2)];
      var $343=$2;
      HEAP32[(($2)>>2)]=$342;
      var $344=HEAP32[(($2)>>2)];
      var $345=(($344)|0);
      var $346=HEAP32[(($345)>>2)];
      var $347=$2;
      var $348=HEAP32[(($4)>>2)];
      var $349=$1;
      HEAP32[(($1)>>2)]=$348;
      var $350=HEAP32[(($1)>>2)];
      var $351=(($350)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=$1;
      var $354=(($346)|0)==(($352)|0);
      var $355=$3;
      var $356=$4;
      var $357=$354 ^ 1;
      var $358=$5;
      var $359=$6;
      if ($357) { __label__ = 18; break; } else { __label__ = 33; break; }
    case 18: // $360
      var $361=$7;
      HEAP32[(($7)>>2)]=$__s;
      var $362=HEAP32[(($7)>>2)];
      var $363=$7;
      __label__ = 19; break;
    case 19: // $364
      var $365=$8;
      HEAP32[(($8)>>2)]=$__i;
      var $366=HEAP32[(($8)>>2)];
      var $367=(($366)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=$8;
      var $370=HEAP32[(($368)>>2)];
      var $371=$41;
      var $372=$42;
      HEAP32[(($41)>>2)]=$362;
      HEAP32[(($42)>>2)]=$370;
      var $373=HEAP32[(($41)>>2)];
      var $374=(($373)|0);
      var $375=HEAP32[(($374)>>2)];
      var $376=(($375)|0)!=0;
      if ($376) { __label__ = 20; break; } else { __label__ = 26; break; }
    case 20: // $377
      var $378=(($373)|0);
      var $379=HEAP32[(($378)>>2)];
      var $380=HEAP32[(($42)>>2)];
      var $381=$38;
      var $382=$39;
      var $383=$40;
      HEAP32[(($39)>>2)]=$379;
      HEAP32[(($40)>>2)]=$380;
      var $384=HEAP32[(($39)>>2)];
      var $385=(($384+24)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=(($384+28)|0);
      var $388=HEAP32[(($387)>>2)];
      var $389=(($386)|0)==(($388)|0);
      if ($389) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $390
      var $391=$384;
      var $392=HEAP32[(($391)>>2)];
      var $393=(($392+52)|0);
      var $394=HEAP32[(($393)>>2)];
      var $395=HEAP32[(($40)>>2)];
      var $396=$37;
      HEAP32[(($37)>>2)]=$395;
      var $397=HEAP32[(($37)>>2)];
      var $398=$37;
      var $399=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$394]($384, $397) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 32; break; };
    case 22: // $_noexc
      HEAP32[(($38)>>2)]=$399;
      __label__ = 24; break;
    case 23: // $400
      var $401=HEAP32[(($40)>>2)];
      var $402=(($384+24)|0);
      var $403=HEAP32[(($402)>>2)];
      var $404=(($403+4)|0);
      HEAP32[(($402)>>2)]=$404;
      HEAP32[(($403)>>2)]=$401;
      var $405=HEAP32[(($40)>>2)];
      var $406=$36;
      HEAP32[(($36)>>2)]=$405;
      var $407=HEAP32[(($36)>>2)];
      var $408=$36;
      HEAP32[(($38)>>2)]=$407;
      __label__ = 24; break;
    case 24: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sputcEw_exit_i
      var $409=HEAP32[(($38)>>2)];
      var $410=$38;
      var $411=$39;
      var $412=$40;
      var $413=$34;
      var $414=$35;
      HEAP32[(($34)>>2)]=$409;
      HEAP32[(($35)>>2)]=-1;
      var $415=HEAP32[(($34)>>2)];
      var $416=HEAP32[(($35)>>2)];
      var $417=(($415)|0)==(($416)|0);
      var $418=$34;
      var $419=$35;
      if ($417) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $420
      var $421=(($373)|0);
      HEAP32[(($421)>>2)]=0;
      __label__ = 26; break;
    case 26: // $_ZNSt3__119ostreambuf_iteratorIwNS_11char_traitsIwEEEaSEw_exit
      var $422=$41;
      var $423=$42;
      __label__ = 27; break;
    case 27: // $424
      __label__ = 28; break;
    case 28: // $425
      var $426=$43;
      HEAP32[(($43)>>2)]=$__i;
      var $427=HEAP32[(($43)>>2)];
      var $428=(($427)|0);
      var $429=HEAP32[(($428)>>2)];
      var $430=(($429+4)|0);
      HEAP32[(($428)>>2)]=$430;
      var $431=$43;
      var $432=$44;
      HEAP32[(($44)>>2)]=$__s;
      var $433=HEAP32[(($44)>>2)];
      var $434=$44;
      __label__ = 29; break;
    case 29: // $435
      __label__ = 11; break;
    case 30: // $436
      var $437=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $438=$437.f0;
      $70=$438;
      var $439=$437.f1;
      $71=$439;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($69) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 37; break; }
    case 31: // $440
      __label__ = 36; break;
    case 32: // $441
      var $442=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $443=$442.f0;
      $70=$443;
      var $444=$442.f1;
      $71=$444;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nm) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 33: // $445
      var $446=$agg_result;
      var $447=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($446)>>2)]=HEAP32[(($447)>>2)];
      $73=1;
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nm);
      __label__ = 35; break;
    case 34: // $448
      __label__ = 36; break;
    case 35: // $449
      STACKTOP = __stackBase__;
      return;
    case 36: // $450
      var $451=$70;
      var $452=$70;
      var $453=$71;
      var $454=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $452, tempValue);
      var $455=($454.f1 = $453, $454);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 37: // $456
      var $457=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 124; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__fmt=__stackBase__+4;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+12;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+24;
      var $__op=__stackBase__+108;
      var $__oe=__stackBase__+112;
      var $6=__stackBase__+116;
      var $7;
      var $8;
      var $9=__stackBase__+120;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      $5=$__v;
      var $10=$2;
      var $11=$__fmt;
      assert(6 % 1 === 0, 'memcpy given ' + 6 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt)|0)+5)];
      $__len=((STRING_TABLE.__str5242)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 1, $19);
      $__nbuf=12;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $24=$5;
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl["X"]=1;

function __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($__nb, $__np, $__ne, $__ob, $__op, $__oe, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 336; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $__t_i_i_i4=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48;
      var $49=__stackBase__+192;
      var $50;
      var $51=__stackBase__+196;
      var $52;
      var $53=__stackBase__+200;
      var $54=__stackBase__+204;
      var $55=__stackBase__+208;
      var $56=__stackBase__+212;
      var $57=__stackBase__+216;
      var $58;
      var $59=__stackBase__+220;
      var $60=__stackBase__+224;
      var $61=__stackBase__+228;
      var $62=__stackBase__+232;
      var $63=__stackBase__+236;
      var $__t_i_i_i=__stackBase__+240;
      var $64=__stackBase__+244;
      var $65=__stackBase__+248;
      var $66=__stackBase__+252;
      var $67=__stackBase__+256;
      var $68=__stackBase__+260;
      var $69=__stackBase__+264;
      var $70=__stackBase__+268;
      var $71=__stackBase__+272;
      var $72=__stackBase__+276;
      var $73=__stackBase__+280;
      var $74=__stackBase__+284;
      var $75=__stackBase__+288;
      var $76=__stackBase__+292;
      var $77=__stackBase__+296;
      var $78=__stackBase__+300;
      var $79=__stackBase__+304;
      var $80=__stackBase__+308;
      var $81=__stackBase__+312;
      var $82=__stackBase__+316;
      var $83=__stackBase__+320;
      var $84;
      var $85;
      var $86;
      var $87;
      var $88;
      var $89;
      var $90;
      var $__ct;
      var $__npt;
      var $__grouping=__stackBase__+324;
      var $91;
      var $92;
      var $__nf;
      var $__thousands_sep;
      var $__dc;
      var $__dg;
      var $__p;
      $84=$__nb;
      $85=$__np;
      $86=$__ne;
      $87=$__ob;
      $88=$__op;
      $89=$__oe;
      $90=$__loc;
      var $93=$90;
      var $94=$83;
      HEAP32[(($83)>>2)]=$93;
      var $95=HEAP32[(($83)>>2)];
      var $96=__ZNKSt3__16locale9use_facetERNS0_2idE($95, __ZNSt3__15ctypeIwE2idE);
      var $97=$96;
      var $98=$83;
      $__ct=$97;
      var $99=$90;
      var $100=$82;
      HEAP32[(($82)>>2)]=$99;
      var $101=HEAP32[(($82)>>2)];
      var $102=__ZNKSt3__16locale9use_facetERNS0_2idE($101, __ZNSt3__18numpunctIwE2idE);
      var $103=$102;
      var $104=$82;
      $__npt=$103;
      var $105=$__npt;
      var $106=$81;
      HEAP32[(($81)>>2)]=$105;
      var $107=HEAP32[(($81)>>2)];
      var $108=$107;
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      FUNCTION_TABLE[$111]($__grouping, $107);
      var $112=$81;
      var $113=$80;
      HEAP32[(($80)>>2)]=$__grouping;
      var $114=HEAP32[(($80)>>2)];
      var $115=$79;
      HEAP32[(($79)>>2)]=$114;
      var $116=HEAPU32[(($79)>>2)];
      var $117=$78;
      HEAP32[(($78)>>2)]=$116;
      var $118=HEAP32[(($78)>>2)];
      var $119=(($118)|0);
      var $120=$77;
      HEAP32[(($77)>>2)]=$119;
      var $121=HEAP32[(($77)>>2)];
      var $122=$121;
      var $123=$76;
      HEAP32[(($76)>>2)]=$122;
      var $124=HEAP32[(($76)>>2)];
      var $125=(($124)|0);
      var $126=$76;
      var $127=$77;
      var $128=(($125)|0);
      var $129=$128;
      var $130=(($129)|0);
      var $131=$130;
      var $132=HEAPU8[($131)];
      var $133=(($132)&255);
      var $134=$133 & 1;
      var $135=(($134)|0)!=0;
      var $136=$78;
      if ($135) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $137
      var $138=$72;
      HEAP32[(($72)>>2)]=$116;
      var $139=HEAP32[(($72)>>2)];
      var $140=(($139)|0);
      var $141=$71;
      HEAP32[(($71)>>2)]=$140;
      var $142=HEAP32[(($71)>>2)];
      var $143=$142;
      var $144=$70;
      HEAP32[(($70)>>2)]=$143;
      var $145=HEAP32[(($70)>>2)];
      var $146=(($145)|0);
      var $147=$70;
      var $148=$71;
      var $149=(($146)|0);
      var $150=$149;
      var $151=(($150+4)|0);
      var $152=HEAP32[(($151)>>2)];
      var $153=$72;
      var $174 = $152;__label__ = 3; break;
    case 2: // $154
      var $155=$75;
      HEAP32[(($75)>>2)]=$116;
      var $156=HEAP32[(($75)>>2)];
      var $157=(($156)|0);
      var $158=$74;
      HEAP32[(($74)>>2)]=$157;
      var $159=HEAP32[(($74)>>2)];
      var $160=$159;
      var $161=$73;
      HEAP32[(($73)>>2)]=$160;
      var $162=HEAP32[(($73)>>2)];
      var $163=(($162)|0);
      var $164=$73;
      var $165=$74;
      var $166=(($163)|0);
      var $167=$166;
      var $168=(($167)|0);
      var $169=$168;
      var $170=HEAPU8[($169)];
      var $171=(($170)&255);
      var $172=$171 >> 1;
      var $173=$75;
      var $174 = $172;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $174;
      var $175=$79;
      var $176=(($174)|0)==0;
      var $177=$80;
      if ($176) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 4: // $178
      var $179=$__ct;
      var $180=$84;
      var $181=$86;
      var $182=$87;
      var $183=$53;
      var $184=$54;
      var $185=$55;
      var $186=$56;
      HEAP32[(($53)>>2)]=$179;
      HEAP32[(($54)>>2)]=$180;
      HEAP32[(($55)>>2)]=$181;
      HEAP32[(($56)>>2)]=$182;
      var $187=HEAP32[(($53)>>2)];
      var $188=$187;
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189+48)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=HEAP32[(($54)>>2)];
      var $193=HEAP32[(($55)>>2)];
      var $194=HEAP32[(($56)>>2)];
      var $195=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$191]($187, $192, $193, $194) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; };
    case 5: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $196=$53;
      var $197=$54;
      var $198=$55;
      var $199=$56;
      __label__ = 6; break;
    case 6: // $200
      var $201=$87;
      var $202=$86;
      var $203=$84;
      var $204=$202;
      var $205=$203;
      var $206=(($204-$205)|0);
      var $207=(($201+($206<<2))|0);
      var $208=$89;
      HEAP32[(($208)>>2)]=$207;
      __label__ = 59; break;
    case 7: // $209
      var $210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $211=$210.f0;
      $91=$211;
      var $212=$210.f1;
      $92=$212;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 65; break; }
    case 8: // $213
      var $214=$87;
      var $215=$89;
      HEAP32[(($215)>>2)]=$214;
      var $216=$84;
      $__nf=$216;
      var $217=$__nf;
      var $218=HEAP8[($217)];
      var $219=(($218 << 24) >> 24);
      var $220=(($219)|0)==45;
      if ($220) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $221
      var $222=$__nf;
      var $223=HEAP8[($222)];
      var $224=(($223 << 24) >> 24);
      var $225=(($224)|0)==43;
      if ($225) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $226
      var $227=$__ct;
      var $228=$__nf;
      var $229=(($228+1)|0);
      $__nf=$229;
      var $230=HEAP8[($228)];
      var $231=$51;
      HEAP32[(($51)>>2)]=$227;
      $52=$230;
      var $232=HEAP32[(($51)>>2)];
      var $233=$232;
      var $234=HEAP32[(($233)>>2)];
      var $235=(($234+44)|0);
      var $236=HEAP32[(($235)>>2)];
      var $237=$52;
      var $238=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$236]($232, $237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 7; break; };
    case 11: // $_ZNKSt3__15ctypeIwE5widenEc_exit1
      var $239=$51;
      __label__ = 12; break;
    case 12: // $240
      var $241=$89;
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242+4)|0);
      HEAP32[(($241)>>2)]=$243;
      HEAP32[(($242)>>2)]=$238;
      __label__ = 13; break;
    case 13: // $244
      var $245=$86;
      var $246=$__nf;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      var $250=(($249)|0) >= 2;
      if ($250) { __label__ = 14; break; } else { __label__ = 22; break; }
    case 14: // $251
      var $252=$__nf;
      var $253=(($252)|0);
      var $254=HEAP8[($253)];
      var $255=(($254 << 24) >> 24);
      var $256=(($255)|0)==48;
      if ($256) { __label__ = 15; break; } else { __label__ = 22; break; }
    case 15: // $257
      var $258=$__nf;
      var $259=(($258+1)|0);
      var $260=HEAP8[($259)];
      var $261=(($260 << 24) >> 24);
      var $262=(($261)|0)==120;
      if ($262) { __label__ = 17; break; } else { __label__ = 16; break; }
    case 16: // $263
      var $264=$__nf;
      var $265=(($264+1)|0);
      var $266=HEAP8[($265)];
      var $267=(($266 << 24) >> 24);
      var $268=(($267)|0)==88;
      if ($268) { __label__ = 17; break; } else { __label__ = 22; break; }
    case 17: // $269
      var $270=$__ct;
      var $271=$__nf;
      var $272=(($271+1)|0);
      $__nf=$272;
      var $273=HEAP8[($271)];
      var $274=$49;
      HEAP32[(($49)>>2)]=$270;
      $50=$273;
      var $275=HEAP32[(($49)>>2)];
      var $276=$275;
      var $277=HEAP32[(($276)>>2)];
      var $278=(($277+44)|0);
      var $279=HEAP32[(($278)>>2)];
      var $280=$50;
      var $281=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$279]($275, $280) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 7; break; };
    case 18: // $_ZNKSt3__15ctypeIwE5widenEc_exit2
      var $282=$49;
      __label__ = 19; break;
    case 19: // $283
      var $284=$89;
      var $285=HEAP32[(($284)>>2)];
      var $286=(($285+4)|0);
      HEAP32[(($284)>>2)]=$286;
      HEAP32[(($285)>>2)]=$281;
      var $287=$__ct;
      var $288=$__nf;
      var $289=(($288+1)|0);
      $__nf=$289;
      var $290=HEAP8[($288)];
      var $291=$47;
      HEAP32[(($47)>>2)]=$287;
      $48=$290;
      var $292=HEAP32[(($47)>>2)];
      var $293=$292;
      var $294=HEAP32[(($293)>>2)];
      var $295=(($294+44)|0);
      var $296=HEAP32[(($295)>>2)];
      var $297=$48;
      var $298=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$296]($292, $297) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 7; break; };
    case 20: // $_ZNKSt3__15ctypeIwE5widenEc_exit3
      var $299=$47;
      __label__ = 21; break;
    case 21: // $300
      var $301=$89;
      var $302=HEAP32[(($301)>>2)];
      var $303=(($302+4)|0);
      HEAP32[(($301)>>2)]=$303;
      HEAP32[(($302)>>2)]=$298;
      __label__ = 22; break;
    case 22: // $304
      var $305=$__nf;
      var $306=$86;
      var $307=$43;
      var $308=$44;
      var $309=$45;
      var $310=$46;
      HEAP32[(($44)>>2)]=$305;
      HEAP32[(($45)>>2)]=$306;
      var $311=HEAP32[(($44)>>2)];
      var $312=HEAP32[(($45)>>2)];
      var $tmp_i5=$43;
      var $tmp1_i6=$46;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i5)]=HEAP8[($tmp1_i6)];
      var $313=$41;
      var $314=$42;
      HEAP32[(($41)>>2)]=$311;
      HEAP32[(($42)>>2)]=$312;
      var $315=HEAP32[(($41)>>2)];
      var $316=HEAP32[(($42)>>2)];
      var $317=(($315)|0)!=(($316)|0);
      if ($317) { __label__ = 23; break; } else { __label__ = 27; break; }
    case 23: // $318
      __label__ = 24; break;
    case 24: // $319
      var $320=HEAPU32[(($41)>>2)];
      var $321=HEAP32[(($42)>>2)];
      var $322=(($321-1)|0);
      HEAP32[(($42)>>2)]=$322;
      var $323=(($320)>>>0) < (($322)>>>0);
      if ($323) { __label__ = 25; break; } else { __label__ = 26; break; }
    case 25: // $324
      var $325=HEAP32[(($41)>>2)];
      var $326=HEAP32[(($42)>>2)];
      var $327=$39;
      var $328=$40;
      HEAP32[(($39)>>2)]=$325;
      HEAP32[(($40)>>2)]=$326;
      var $329=HEAP32[(($39)>>2)];
      var $330=$38;
      HEAP32[(($38)>>2)]=$329;
      var $331=HEAP32[(($38)>>2)];
      var $332=$38;
      var $333=HEAP8[($331)];
      HEAP8[($__t_i_i_i4)]=$333;
      var $334=HEAP32[(($40)>>2)];
      var $335=$36;
      HEAP32[(($36)>>2)]=$334;
      var $336=HEAP32[(($36)>>2)];
      var $337=$36;
      var $338=HEAP8[($336)];
      var $339=HEAP32[(($39)>>2)];
      HEAP8[($339)]=$338;
      var $340=$37;
      HEAP32[(($37)>>2)]=$__t_i_i_i4;
      var $341=HEAP32[(($37)>>2)];
      var $342=$37;
      var $343=HEAP8[($341)];
      var $344=HEAP32[(($40)>>2)];
      HEAP8[($344)]=$343;
      var $345=$39;
      var $346=$40;
      var $347=HEAP32[(($41)>>2)];
      var $348=(($347+1)|0);
      HEAP32[(($41)>>2)]=$348;
      __label__ = 24; break;
    case 26: // $349
      __label__ = 27; break;
    case 27: // $_ZNSt3__17reverseIPcEEvT_S2__exit
      var $350=$41;
      var $351=$42;
      var $352=$43;
      var $353=$44;
      var $354=$45;
      var $355=$46;
      __label__ = 28; break;
    case 28: // $356
      var $357=$__npt;
      var $358=$1;
      HEAP32[(($1)>>2)]=$357;
      var $359=HEAP32[(($1)>>2)];
      var $360=$359;
      var $361=HEAP32[(($360)>>2)];
      var $362=(($361+16)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$363]($359) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 7; break; };
    case 29: // $_ZNKSt3__18numpunctIwE13thousands_sepEv_exit
      var $365=$1;
      __label__ = 30; break;
    case 30: // $366
      $__thousands_sep=$364;
      $__dc=0;
      $__dg=0;
      var $367=$__nf;
      $__p=$367;
      __label__ = 31; break;
    case 31: // $368
      var $369=$__p;
      var $370=$86;
      var $371=(($369)>>>0) < (($370)>>>0);
      if ($371) { __label__ = 32; break; } else { __label__ = 52; break; }
    case 32: // $372
      var $373=$__dg;
      var $374=$12;
      var $375=$13;
      HEAP32[(($12)>>2)]=$__grouping;
      HEAP32[(($13)>>2)]=$373;
      var $376=HEAP32[(($12)>>2)];
      var $377=$11;
      HEAP32[(($11)>>2)]=$376;
      var $378=HEAPU32[(($11)>>2)];
      var $379=$10;
      HEAP32[(($10)>>2)]=$378;
      var $380=HEAP32[(($10)>>2)];
      var $381=(($380)|0);
      var $382=$9;
      HEAP32[(($9)>>2)]=$381;
      var $383=HEAP32[(($9)>>2)];
      var $384=$383;
      var $385=$8;
      HEAP32[(($8)>>2)]=$384;
      var $386=HEAP32[(($8)>>2)];
      var $387=(($386)|0);
      var $388=$8;
      var $389=$9;
      var $390=(($387)|0);
      var $391=$390;
      var $392=(($391)|0);
      var $393=$392;
      var $394=HEAPU8[($393)];
      var $395=(($394)&255);
      var $396=$395 & 1;
      var $397=(($396)|0)!=0;
      var $398=$10;
      if ($397) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $399
      var $400=$4;
      HEAP32[(($4)>>2)]=$378;
      var $401=HEAP32[(($4)>>2)];
      var $402=(($401)|0);
      var $403=$3;
      HEAP32[(($3)>>2)]=$402;
      var $404=HEAP32[(($3)>>2)];
      var $405=$404;
      var $406=$2;
      HEAP32[(($2)>>2)]=$405;
      var $407=HEAP32[(($2)>>2)];
      var $408=(($407)|0);
      var $409=$2;
      var $410=$3;
      var $411=(($408)|0);
      var $412=$411;
      var $413=(($412+8)|0);
      var $414=HEAP32[(($413)>>2)];
      var $415=$4;
      var $433 = $414;__label__ = 35; break;
    case 34: // $416
      var $417=$7;
      HEAP32[(($7)>>2)]=$378;
      var $418=HEAP32[(($7)>>2)];
      var $419=(($418)|0);
      var $420=$6;
      HEAP32[(($6)>>2)]=$419;
      var $421=HEAP32[(($6)>>2)];
      var $422=$421;
      var $423=$5;
      HEAP32[(($5)>>2)]=$422;
      var $424=HEAP32[(($5)>>2)];
      var $425=(($424)|0);
      var $426=$5;
      var $427=$6;
      var $428=(($425)|0);
      var $429=$428;
      var $430=(($429+1)|0);
      var $431=(($430)|0);
      var $432=$7;
      var $433 = $431;__label__ = 35; break;
    case 35: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit7
      var $433;
      var $434=$11;
      var $435=HEAP32[(($13)>>2)];
      var $436=(($433+$435)|0);
      var $437=$12;
      var $438=$13;
      __label__ = 36; break;
    case 36: // $439
      var $440=HEAP8[($436)];
      var $441=(($440 << 24) >> 24);
      var $442=(($441)>>>0) > 0;
      if ($442) { __label__ = 37; break; } else { __label__ = 48; break; }
    case 37: // $443
      var $444=$__dc;
      var $445=$__dg;
      var $446=$24;
      var $447=$25;
      HEAP32[(($24)>>2)]=$__grouping;
      HEAP32[(($25)>>2)]=$445;
      var $448=HEAP32[(($24)>>2)];
      var $449=$23;
      HEAP32[(($23)>>2)]=$448;
      var $450=HEAPU32[(($23)>>2)];
      var $451=$22;
      HEAP32[(($22)>>2)]=$450;
      var $452=HEAP32[(($22)>>2)];
      var $453=(($452)|0);
      var $454=$21;
      HEAP32[(($21)>>2)]=$453;
      var $455=HEAP32[(($21)>>2)];
      var $456=$455;
      var $457=$20;
      HEAP32[(($20)>>2)]=$456;
      var $458=HEAP32[(($20)>>2)];
      var $459=(($458)|0);
      var $460=$20;
      var $461=$21;
      var $462=(($459)|0);
      var $463=$462;
      var $464=(($463)|0);
      var $465=$464;
      var $466=HEAPU8[($465)];
      var $467=(($466)&255);
      var $468=$467 & 1;
      var $469=(($468)|0)!=0;
      var $470=$22;
      if ($469) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $471
      var $472=$16;
      HEAP32[(($16)>>2)]=$450;
      var $473=HEAP32[(($16)>>2)];
      var $474=(($473)|0);
      var $475=$15;
      HEAP32[(($15)>>2)]=$474;
      var $476=HEAP32[(($15)>>2)];
      var $477=$476;
      var $478=$14;
      HEAP32[(($14)>>2)]=$477;
      var $479=HEAP32[(($14)>>2)];
      var $480=(($479)|0);
      var $481=$14;
      var $482=$15;
      var $483=(($480)|0);
      var $484=$483;
      var $485=(($484+8)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=$16;
      var $505 = $486;__label__ = 40; break;
    case 39: // $488
      var $489=$19;
      HEAP32[(($19)>>2)]=$450;
      var $490=HEAP32[(($19)>>2)];
      var $491=(($490)|0);
      var $492=$18;
      HEAP32[(($18)>>2)]=$491;
      var $493=HEAP32[(($18)>>2)];
      var $494=$493;
      var $495=$17;
      HEAP32[(($17)>>2)]=$494;
      var $496=HEAP32[(($17)>>2)];
      var $497=(($496)|0);
      var $498=$17;
      var $499=$18;
      var $500=(($497)|0);
      var $501=$500;
      var $502=(($501+1)|0);
      var $503=(($502)|0);
      var $504=$19;
      var $505 = $503;__label__ = 40; break;
    case 40: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $505;
      var $506=$23;
      var $507=HEAP32[(($25)>>2)];
      var $508=(($505+$507)|0);
      var $509=$24;
      var $510=$25;
      __label__ = 41; break;
    case 41: // $511
      var $512=HEAP8[($508)];
      var $513=(($512 << 24) >> 24);
      var $514=(($444)|0)==(($513)|0);
      if ($514) { __label__ = 42; break; } else { __label__ = 48; break; }
    case 42: // $515
      var $516=$__thousands_sep;
      var $517=$89;
      var $518=HEAP32[(($517)>>2)];
      var $519=(($518+4)|0);
      HEAP32[(($517)>>2)]=$519;
      HEAP32[(($518)>>2)]=$516;
      $__dc=0;
      var $520=$__dg;
      var $521=$35;
      HEAP32[(($35)>>2)]=$__grouping;
      var $522=HEAPU32[(($35)>>2)];
      var $523=$34;
      HEAP32[(($34)>>2)]=$522;
      var $524=HEAP32[(($34)>>2)];
      var $525=(($524)|0);
      var $526=$33;
      HEAP32[(($33)>>2)]=$525;
      var $527=HEAP32[(($33)>>2)];
      var $528=$527;
      var $529=$32;
      HEAP32[(($32)>>2)]=$528;
      var $530=HEAP32[(($32)>>2)];
      var $531=(($530)|0);
      var $532=$32;
      var $533=$33;
      var $534=(($531)|0);
      var $535=$534;
      var $536=(($535)|0);
      var $537=$536;
      var $538=HEAPU8[($537)];
      var $539=(($538)&255);
      var $540=$539 & 1;
      var $541=(($540)|0)!=0;
      var $542=$34;
      if ($541) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $543
      var $544=$28;
      HEAP32[(($28)>>2)]=$522;
      var $545=HEAP32[(($28)>>2)];
      var $546=(($545)|0);
      var $547=$27;
      HEAP32[(($27)>>2)]=$546;
      var $548=HEAP32[(($27)>>2)];
      var $549=$548;
      var $550=$26;
      HEAP32[(($26)>>2)]=$549;
      var $551=HEAP32[(($26)>>2)];
      var $552=(($551)|0);
      var $553=$26;
      var $554=$27;
      var $555=(($552)|0);
      var $556=$555;
      var $557=(($556+4)|0);
      var $558=HEAP32[(($557)>>2)];
      var $559=$28;
      var $580 = $558;__label__ = 45; break;
    case 44: // $560
      var $561=$31;
      HEAP32[(($31)>>2)]=$522;
      var $562=HEAP32[(($31)>>2)];
      var $563=(($562)|0);
      var $564=$30;
      HEAP32[(($30)>>2)]=$563;
      var $565=HEAP32[(($30)>>2)];
      var $566=$565;
      var $567=$29;
      HEAP32[(($29)>>2)]=$566;
      var $568=HEAP32[(($29)>>2)];
      var $569=(($568)|0);
      var $570=$29;
      var $571=$30;
      var $572=(($569)|0);
      var $573=$572;
      var $574=(($573)|0);
      var $575=$574;
      var $576=HEAPU8[($575)];
      var $577=(($576)&255);
      var $578=$577 >> 1;
      var $579=$31;
      var $580 = $578;__label__ = 45; break;
    case 45: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $580;
      var $581=$35;
      var $582=(($580-1)|0);
      var $583=(($520)>>>0) < (($582)>>>0);
      if ($583) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $584
      var $585=$__dg;
      var $586=(($585+1)|0);
      $__dg=$586;
      __label__ = 47; break;
    case 47: // $587
      __label__ = 48; break;
    case 48: // $588
      var $589=$__ct;
      var $590=$__p;
      var $591=HEAP8[($590)];
      var $592=$57;
      HEAP32[(($57)>>2)]=$589;
      $58=$591;
      var $593=HEAP32[(($57)>>2)];
      var $594=$593;
      var $595=HEAP32[(($594)>>2)];
      var $596=(($595+44)|0);
      var $597=HEAP32[(($596)>>2)];
      var $598=$58;
      var $599=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$597]($593, $598) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 7; break; };
    case 49: // $_ZNKSt3__15ctypeIwE5widenEc_exit
      var $600=$57;
      __label__ = 50; break;
    case 50: // $601
      var $602=$89;
      var $603=HEAP32[(($602)>>2)];
      var $604=(($603+4)|0);
      HEAP32[(($602)>>2)]=$604;
      HEAP32[(($603)>>2)]=$599;
      var $605=$__dc;
      var $606=(($605+1)|0);
      $__dc=$606;
      __label__ = 51; break;
    case 51: // $607
      var $608=$__p;
      var $609=(($608+1)|0);
      $__p=$609;
      __label__ = 31; break;
    case 52: // $610
      var $611=$87;
      var $612=$__nf;
      var $613=$84;
      var $614=$612;
      var $615=$613;
      var $616=(($614-$615)|0);
      var $617=(($611+($616<<2))|0);
      var $618=$89;
      var $619=HEAP32[(($618)>>2)];
      var $620=$66;
      var $621=$67;
      var $622=$68;
      var $623=$69;
      HEAP32[(($67)>>2)]=$617;
      HEAP32[(($68)>>2)]=$619;
      var $624=HEAP32[(($67)>>2)];
      var $625=HEAP32[(($68)>>2)];
      var $tmp_i=$66;
      var $tmp1_i=$69;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $626=$64;
      var $627=$65;
      HEAP32[(($64)>>2)]=$624;
      HEAP32[(($65)>>2)]=$625;
      var $628=HEAP32[(($64)>>2)];
      var $629=HEAP32[(($65)>>2)];
      var $630=(($628)|0)!=(($629)|0);
      if ($630) { __label__ = 53; break; } else { __label__ = 57; break; }
    case 53: // $631
      __label__ = 54; break;
    case 54: // $632
      var $633=HEAPU32[(($64)>>2)];
      var $634=HEAP32[(($65)>>2)];
      var $635=(($634-4)|0);
      HEAP32[(($65)>>2)]=$635;
      var $636=(($633)>>>0) < (($635)>>>0);
      if ($636) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $637
      var $638=HEAP32[(($64)>>2)];
      var $639=HEAP32[(($65)>>2)];
      var $640=$62;
      var $641=$63;
      var $642=$__t_i_i_i;
      HEAP32[(($62)>>2)]=$638;
      HEAP32[(($63)>>2)]=$639;
      var $643=HEAP32[(($62)>>2)];
      var $644=$61;
      HEAP32[(($61)>>2)]=$643;
      var $645=HEAP32[(($61)>>2)];
      var $646=$61;
      var $647=HEAP32[(($645)>>2)];
      HEAP32[(($__t_i_i_i)>>2)]=$647;
      var $648=HEAP32[(($63)>>2)];
      var $649=$59;
      HEAP32[(($59)>>2)]=$648;
      var $650=HEAP32[(($59)>>2)];
      var $651=$59;
      var $652=HEAP32[(($650)>>2)];
      var $653=HEAP32[(($62)>>2)];
      HEAP32[(($653)>>2)]=$652;
      var $654=$60;
      HEAP32[(($60)>>2)]=$__t_i_i_i;
      var $655=HEAP32[(($60)>>2)];
      var $656=$60;
      var $657=HEAP32[(($655)>>2)];
      var $658=HEAP32[(($63)>>2)];
      HEAP32[(($658)>>2)]=$657;
      var $659=$62;
      var $660=$63;
      var $661=$__t_i_i_i;
      var $662=HEAP32[(($64)>>2)];
      var $663=(($662+4)|0);
      HEAP32[(($64)>>2)]=$663;
      __label__ = 54; break;
    case 56: // $664
      __label__ = 57; break;
    case 57: // $_ZNSt3__17reverseIPwEEvT_S2__exit
      var $665=$64;
      var $666=$65;
      var $667=$66;
      var $668=$67;
      var $669=$68;
      var $670=$69;
      __label__ = 58; break;
    case 58: // $671
      __label__ = 59; break;
    case 59: // $672
      var $673=$85;
      var $674=$86;
      var $675=(($673)|0)==(($674)|0);
      if ($675) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $676
      var $677=$89;
      var $678=HEAP32[(($677)>>2)];
      var $679=$88;
      HEAP32[(($679)>>2)]=$678;
      __label__ = 62; break;
    case 61: // $680
      var $681=$87;
      var $682=$85;
      var $683=$84;
      var $684=$682;
      var $685=$683;
      var $686=(($684-$685)|0);
      var $687=(($681+($686<<2))|0);
      var $688=$88;
      HEAP32[(($688)>>2)]=$687;
      __label__ = 62; break;
    case 62: // $689
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 63: // $690
      __label__ = 64; break;
    case 64: // $691
      var $692=$91;
      var $693=$91;
      var $694=$92;
      var $695=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $693, tempValue);
      var $696=($695.f1 = $694, $695);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 65: // $697
      var $698=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE["X"]=1;

function __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $__s, $__ob, $__op, $__oe, $__iob, $__fl) {
  var __stackBase__  = STACKTOP; STACKTOP += 148; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $__r_i=__stackBase__+140;
      var $36=__stackBase__+144;
      var $37;
      var $38;
      var $39;
      var $40;
      var $41;
      var $__sz;
      var $__ns;
      $37=$__ob;
      $38=$__op;
      $39=$__oe;
      $40=$__iob;
      $41=$__fl;
      var $42=$39;
      var $43=$37;
      var $44=$42;
      var $45=$43;
      var $46=(($44-$45)|0);
      var $47=(((($46)|0)/4)|0);
      $__sz=$47;
      var $48=$40;
      var $49=$36;
      HEAP32[(($36)>>2)]=$48;
      var $50=HEAP32[(($36)>>2)];
      var $51=(($50+12)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=$36;
      $__ns=$52;
      var $54=$__ns;
      var $55=$__sz;
      var $56=(($54)|0) > (($55)|0);
      if ($56) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $57
      var $58=$__sz;
      var $59=$__ns;
      var $60=(($59-$58)|0);
      $__ns=$60;
      __label__ = 3; break;
    case 2: // $61
      $__ns=0;
      __label__ = 3; break;
    case 3: // $62
      __label__ = 4; break;
    case 4: // $63
      var $64=$37;
      var $65=$38;
      var $66=(($64)>>>0) < (($65)>>>0);
      if ($66) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $67
      var $68=$23;
      HEAP32[(($23)>>2)]=$__s;
      var $69=HEAP32[(($23)>>2)];
      var $70=$23;
      var $71=$37;
      var $72=HEAP32[(($71)>>2)];
      var $73=$10;
      var $74=$11;
      HEAP32[(($10)>>2)]=$69;
      HEAP32[(($11)>>2)]=$72;
      var $75=HEAPU32[(($10)>>2)];
      var $76=(($75)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=(($77)|0)!=0;
      if ($78) { __label__ = 6; break; } else { __label__ = 11; break; }
    case 6: // $79
      var $80=(($75)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=HEAP32[(($11)>>2)];
      var $83=$7;
      var $84=$8;
      var $85=$9;
      HEAP32[(($8)>>2)]=$81;
      HEAP32[(($9)>>2)]=$82;
      var $86=HEAP32[(($8)>>2)];
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($86+28)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=(($88)|0)==(($90)|0);
      if ($91) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $92
      var $93=$86;
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94+52)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=HEAP32[(($9)>>2)];
      var $98=$6;
      HEAP32[(($6)>>2)]=$97;
      var $99=HEAP32[(($6)>>2)];
      var $100=$6;
      var $101=FUNCTION_TABLE[$96]($86, $99);
      HEAP32[(($7)>>2)]=$101;
      __label__ = 9; break;
    case 8: // $102
      var $103=HEAP32[(($9)>>2)];
      var $104=(($86+24)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+4)|0);
      HEAP32[(($104)>>2)]=$106;
      HEAP32[(($105)>>2)]=$103;
      var $107=HEAP32[(($9)>>2)];
      var $108=$5;
      HEAP32[(($5)>>2)]=$107;
      var $109=HEAP32[(($5)>>2)];
      var $110=$5;
      HEAP32[(($7)>>2)]=$109;
      __label__ = 9; break;
    case 9: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sputcEw_exit_i3
      var $111=HEAP32[(($7)>>2)];
      var $112=$7;
      var $113=$8;
      var $114=$9;
      var $115=$3;
      var $116=$4;
      HEAP32[(($3)>>2)]=$111;
      HEAP32[(($4)>>2)]=-1;
      var $117=HEAP32[(($3)>>2)];
      var $118=HEAP32[(($4)>>2)];
      var $119=(($117)|0)==(($118)|0);
      var $120=$3;
      var $121=$4;
      if ($119) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $122
      var $123=(($75)|0);
      HEAP32[(($123)>>2)]=0;
      __label__ = 11; break;
    case 11: // $_ZNSt3__119ostreambuf_iteratorIwNS_11char_traitsIwEEEaSEw_exit4
      var $124=$10;
      var $125=$11;
      __label__ = 12; break;
    case 12: // $126
      var $127=$37;
      var $128=(($127+4)|0);
      $37=$128;
      var $129=$2;
      HEAP32[(($2)>>2)]=$__s;
      var $130=HEAP32[(($2)>>2)];
      var $131=$2;
      __label__ = 4; break;
    case 13: // $132
      __label__ = 14; break;
    case 14: // $133
      var $134=$__ns;
      var $135=(($134)|0)!=0;
      if ($135) { __label__ = 15; break; } else { __label__ = 23; break; }
    case 15: // $136
      var $137=$1;
      HEAP32[(($1)>>2)]=$__s;
      var $138=HEAP32[(($1)>>2)];
      var $139=$1;
      var $140=$41;
      var $141=$19;
      var $142=$20;
      HEAP32[(($19)>>2)]=$138;
      HEAP32[(($20)>>2)]=$140;
      var $143=HEAP32[(($19)>>2)];
      var $144=(($143)|0);
      var $145=HEAP32[(($144)>>2)];
      var $146=(($145)|0)!=0;
      if ($146) { __label__ = 16; break; } else { __label__ = 21; break; }
    case 16: // $147
      var $148=(($143)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=HEAP32[(($20)>>2)];
      var $151=$16;
      var $152=$17;
      var $153=$18;
      HEAP32[(($17)>>2)]=$149;
      HEAP32[(($18)>>2)]=$150;
      var $154=HEAP32[(($17)>>2)];
      var $155=(($154+24)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=(($154+28)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=(($156)|0)==(($158)|0);
      if ($159) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $160
      var $161=$154;
      var $162=HEAP32[(($161)>>2)];
      var $163=(($162+52)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=HEAP32[(($18)>>2)];
      var $166=$15;
      HEAP32[(($15)>>2)]=$165;
      var $167=HEAP32[(($15)>>2)];
      var $168=$15;
      var $169=FUNCTION_TABLE[$164]($154, $167);
      HEAP32[(($16)>>2)]=$169;
      __label__ = 19; break;
    case 18: // $170
      var $171=HEAP32[(($18)>>2)];
      var $172=(($154+24)|0);
      var $173=HEAP32[(($172)>>2)];
      var $174=(($173+4)|0);
      HEAP32[(($172)>>2)]=$174;
      HEAP32[(($173)>>2)]=$171;
      var $175=HEAP32[(($18)>>2)];
      var $176=$14;
      HEAP32[(($14)>>2)]=$175;
      var $177=HEAP32[(($14)>>2)];
      var $178=$14;
      HEAP32[(($16)>>2)]=$177;
      __label__ = 19; break;
    case 19: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sputcEw_exit_i1
      var $179=HEAP32[(($16)>>2)];
      var $180=$16;
      var $181=$17;
      var $182=$18;
      var $183=$12;
      var $184=$13;
      HEAP32[(($12)>>2)]=$179;
      HEAP32[(($13)>>2)]=-1;
      var $185=HEAP32[(($12)>>2)];
      var $186=HEAP32[(($13)>>2)];
      var $187=(($185)|0)==(($186)|0);
      var $188=$12;
      var $189=$13;
      if ($187) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $190
      var $191=(($143)|0);
      HEAP32[(($191)>>2)]=0;
      __label__ = 21; break;
    case 21: // $_ZNSt3__119ostreambuf_iteratorIwNS_11char_traitsIwEEEaSEw_exit2
      var $192=$19;
      var $193=$20;
      __label__ = 22; break;
    case 22: // $194
      var $195=$__ns;
      var $196=(($195-1)|0);
      $__ns=$196;
      var $197=$21;
      HEAP32[(($21)>>2)]=$__s;
      var $198=HEAP32[(($21)>>2)];
      var $199=$21;
      __label__ = 14; break;
    case 23: // $200
      __label__ = 24; break;
    case 24: // $201
      var $202=$37;
      var $203=$39;
      var $204=(($202)>>>0) < (($203)>>>0);
      if ($204) { __label__ = 25; break; } else { __label__ = 33; break; }
    case 25: // $205
      var $206=$22;
      HEAP32[(($22)>>2)]=$__s;
      var $207=HEAP32[(($22)>>2)];
      var $208=$22;
      var $209=$37;
      var $210=HEAP32[(($209)>>2)];
      var $211=$31;
      var $212=$32;
      HEAP32[(($31)>>2)]=$207;
      HEAP32[(($32)>>2)]=$210;
      var $213=HEAPU32[(($31)>>2)];
      var $214=(($213)|0);
      var $215=HEAP32[(($214)>>2)];
      var $216=(($215)|0)!=0;
      if ($216) { __label__ = 26; break; } else { __label__ = 31; break; }
    case 26: // $217
      var $218=(($213)|0);
      var $219=HEAP32[(($218)>>2)];
      var $220=HEAP32[(($32)>>2)];
      var $221=$28;
      var $222=$29;
      var $223=$30;
      HEAP32[(($29)>>2)]=$219;
      HEAP32[(($30)>>2)]=$220;
      var $224=HEAP32[(($29)>>2)];
      var $225=(($224+24)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=(($224+28)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=(($226)|0)==(($228)|0);
      if ($229) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $230
      var $231=$224;
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232+52)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=HEAP32[(($30)>>2)];
      var $236=$27;
      HEAP32[(($27)>>2)]=$235;
      var $237=HEAP32[(($27)>>2)];
      var $238=$27;
      var $239=FUNCTION_TABLE[$234]($224, $237);
      HEAP32[(($28)>>2)]=$239;
      __label__ = 29; break;
    case 28: // $240
      var $241=HEAP32[(($30)>>2)];
      var $242=(($224+24)|0);
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243+4)|0);
      HEAP32[(($242)>>2)]=$244;
      HEAP32[(($243)>>2)]=$241;
      var $245=HEAP32[(($30)>>2)];
      var $246=$26;
      HEAP32[(($26)>>2)]=$245;
      var $247=HEAP32[(($26)>>2)];
      var $248=$26;
      HEAP32[(($28)>>2)]=$247;
      __label__ = 29; break;
    case 29: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sputcEw_exit_i
      var $249=HEAP32[(($28)>>2)];
      var $250=$28;
      var $251=$29;
      var $252=$30;
      var $253=$24;
      var $254=$25;
      HEAP32[(($24)>>2)]=$249;
      HEAP32[(($25)>>2)]=-1;
      var $255=HEAP32[(($24)>>2)];
      var $256=HEAP32[(($25)>>2)];
      var $257=(($255)|0)==(($256)|0);
      var $258=$24;
      var $259=$25;
      if ($257) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $260
      var $261=(($213)|0);
      HEAP32[(($261)>>2)]=0;
      __label__ = 31; break;
    case 31: // $_ZNSt3__119ostreambuf_iteratorIwNS_11char_traitsIwEEEaSEw_exit
      var $262=$31;
      var $263=$32;
      __label__ = 32; break;
    case 32: // $264
      var $265=$37;
      var $266=(($265+4)|0);
      $37=$266;
      var $267=$33;
      HEAP32[(($33)>>2)]=$__s;
      var $268=HEAP32[(($33)>>2)];
      var $269=$33;
      __label__ = 24; break;
    case 33: // $270
      var $271=$40;
      var $272=$34;
      var $273=$35;
      var $274=$__r_i;
      HEAP32[(($34)>>2)]=$271;
      HEAP32[(($35)>>2)]=0;
      var $275=HEAP32[(($34)>>2)];
      var $276=(($275+12)|0);
      var $277=HEAP32[(($276)>>2)];
      HEAP32[(($__r_i)>>2)]=$277;
      var $278=HEAP32[(($35)>>2)];
      var $279=(($275+12)|0);
      HEAP32[(($279)>>2)]=$278;
      var $280=HEAP32[(($__r_i)>>2)];
      var $281=$34;
      var $282=$35;
      var $283=$__r_i;
      var $284=$agg_result;
      var $285=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($284)>>2)]=HEAP32[(($285)>>2)];
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx($agg_result, $this, $__s, $__iob, $__fl, $__v$0, $__v$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 224; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__+4;
      var $__fmt=__stackBase__+12;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+20;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+44;
      var $__op=__stackBase__+208;
      var $__oe=__stackBase__+212;
      var $6=__stackBase__+216;
      var $7;
      var $8;
      var $9=__stackBase__+220;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      var $st$22$0=(($5)|0);
      HEAP32[(($st$22$0)>>2)]=$__v$0;
      var $st$22$1=(($5+4)|0);
      HEAP32[(($st$22$1)>>2)]=$__v$1;
      var $10=$2;
      var $11=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+5)];HEAP8[($11+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+6)];HEAP8[($11+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt)|0)+7)];
      $__len=((STRING_TABLE.__str6243)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 1, $19);
      $__nbuf=22;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $st$45$0=(($5)|0);
      var $24$0=HEAP32[(($st$45$0)>>2)];
      var $st$45$1=(($5+4)|0);
      var $24$1=HEAP32[(($st$45$1)>>2)];
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24$0,HEAP32[((tempInt+4)>>2)]=$24$1,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 124; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__fmt=__stackBase__+4;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+12;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+24;
      var $__op=__stackBase__+108;
      var $__oe=__stackBase__+112;
      var $6=__stackBase__+116;
      var $7;
      var $8;
      var $9=__stackBase__+120;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      $5=$__v;
      var $10=$2;
      var $11=$__fmt;
      assert(6 % 1 === 0, 'memcpy given ' + 6 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt)|0)+5)];
      $__len=((STRING_TABLE.__str5242)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 0, $19);
      $__nbuf=12;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $24=$5;
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy($agg_result, $this, $__s, $__iob, $__fl, $__v$0, $__v$1) {
  var __stackBase__  = STACKTOP; STACKTOP += 232; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__+4;
      var $__fmt=__stackBase__+12;
      var $__len;
      var $__nbuf;
      var $__nar=__stackBase__+20;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+44;
      var $__op=__stackBase__+216;
      var $__oe=__stackBase__+220;
      var $6=__stackBase__+224;
      var $7;
      var $8;
      var $9=__stackBase__+228;
      $2=$this;
      $3=$__iob;
      $4=$__fl;
      var $st$22$0=(($5)|0);
      HEAP32[(($st$22$0)>>2)]=$__v$0;
      var $st$22$1=(($5+4)|0);
      HEAP32[(($st$22$1)>>2)]=$__v$1;
      var $10=$2;
      var $11=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($11)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0))];HEAP8[($11+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+1)];HEAP8[($11+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+2)];HEAP8[($11+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+3)];HEAP8[($11+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+4)];HEAP8[($11+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+5)];HEAP8[($11+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+6)];HEAP8[($11+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt)|0)+7)];
      $__len=((STRING_TABLE.__str6243)|0);
      var $12=(($__fmt)|0);
      var $13=(($12+1)|0);
      var $14=$__len;
      var $15=$3;
      var $16=$1;
      HEAP32[(($1)>>2)]=$15;
      var $17=HEAP32[(($1)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$1;
      __ZNSt3__114__num_put_base12__format_intEPcPKcbj($13, $14, 0, $19);
      $__nbuf=23;
      var $21=(($__nar)|0);
      var $22=__ZNSt3__16__clocEv();
      var $23=(($__fmt)|0);
      var $st$45$0=(($5)|0);
      var $24$0=HEAP32[(($st$45$0)>>2)];
      var $st$45$1=(($5+4)|0);
      var $24$1=HEAP32[(($st$45$1)>>2)];
      var $25=__ZNSt3__111__sprintf_lEPcPvPKcz($21, $22, $23, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$24$0,HEAP32[((tempInt+4)>>2)]=$24$1,tempInt));
      $__nc=$25;
      var $26=(($__nar)|0);
      var $27=$__nc;
      var $28=(($26+$27)|0);
      $__ne=$28;
      var $29=(($__nar)|0);
      var $30=$__ne;
      var $31=$3;
      var $32=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($29, $30, $31);
      $__np=$32;
      var $33=(($__nar)|0);
      var $34=$__np;
      var $35=$__ne;
      var $36=(($__o)|0);
      var $37=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $37);
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE($33, $34, $35, $36, $__op, $__oe, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $38
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      var $39=$9;
      var $40=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($39)>>2)]=HEAP32[(($40)>>2)];
      var $41=(($__o)|0);
      var $42=HEAP32[(($__op)>>2)];
      var $43=HEAP32[(($__oe)>>2)];
      var $44=$3;
      var $45=$4;
      __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $9, $41, $42, $43, $44, $45);
      STACKTOP = __stackBase__;
      return;
    case 2: // $46
      var $47=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $48=$47.f0;
      $7=$48;
      var $49=$47.f1;
      $8=$49;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $50
      __label__ = 4; break;
    case 4: // $51
      var $52=$7;
      var $53=$7;
      var $54=$8;
      var $55=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $53, tempValue);
      var $56=($55.f1 = $54, $55);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 788; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i5=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i4=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $__tmp_i=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $__tmp_i_i_i2=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $__tmp_i_i_i1=__stackBase__+316;
      var $76=__stackBase__+320;
      var $77=__stackBase__+324;
      var $78=__stackBase__+328;
      var $79=__stackBase__+332;
      var $80=__stackBase__+336;
      var $81=__stackBase__+340;
      var $82=__stackBase__+344;
      var $83=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $93=__stackBase__+388;
      var $94=__stackBase__+392;
      var $95=__stackBase__+396;
      var $96=__stackBase__+400;
      var $97=__stackBase__+404;
      var $98=__stackBase__+408;
      var $99=__stackBase__+412;
      var $100=__stackBase__+416;
      var $101=__stackBase__+420;
      var $102=__stackBase__+424;
      var $103=__stackBase__+428;
      var $104=__stackBase__+432;
      var $105=__stackBase__+436;
      var $106=__stackBase__+440;
      var $107=__stackBase__+444;
      var $108=__stackBase__+448;
      var $109=__stackBase__+452;
      var $__tmp_i_i_i=__stackBase__+456;
      var $110=__stackBase__+460;
      var $111=__stackBase__+464;
      var $112=__stackBase__+468;
      var $113=__stackBase__+472;
      var $114=__stackBase__+476;
      var $115;
      var $116;
      var $117;
      var $118;
      var $__fmt=__stackBase__+480;
      var $__len;
      var $__specify_precision;
      var $__nbuf;
      var $__nar=__stackBase__+488;
      var $__nb=__stackBase__+520;
      var $__nc;
      var $__nbh=__stackBase__+524;
      var $119;
      var $120;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+532;
      var $__ob;
      var $__obh=__stackBase__+760;
      var $__op=__stackBase__+768;
      var $__oe=__stackBase__+772;
      var $121=__stackBase__+776;
      var $122=__stackBase__+780;
      var $123=__stackBase__+784;
      var $124;
      $115=$this;
      $116=$__iob;
      $117=$__fl;
      $118=$__v;
      var $125=$115;
      var $126=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($126)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0))];HEAP8[($126+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+1)];HEAP8[($126+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+2)];HEAP8[($126+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+3)];HEAP8[($126+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+4)];HEAP8[($126+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+5)];HEAP8[($126+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+6)];HEAP8[($126+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt)|0)+7)];
      $__len=((__str7244)|0);
      var $127=(($__fmt)|0);
      var $128=(($127+1)|0);
      var $129=$__len;
      var $130=$116;
      var $131=$114;
      HEAP32[(($114)>>2)]=$130;
      var $132=HEAP32[(($114)>>2)];
      var $133=(($132+4)|0);
      var $134=HEAP32[(($133)>>2)];
      var $135=$114;
      var $136=__ZNSt3__114__num_put_base14__format_floatEPcPKcj($128, $129, $134);
      var $137=(($136)&1);
      $__specify_precision=$137;
      $__nbuf=30;
      var $138=(($__nar)|0);
      HEAP32[(($__nb)>>2)]=$138;
      var $139=$__specify_precision;
      var $140=(($139) & 1);
      if ($140) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $141
      var $142=HEAP32[(($__nb)>>2)];
      var $143=__ZNSt3__16__clocEv();
      var $144=(($__fmt)|0);
      var $145=$116;
      var $146=$101;
      HEAP32[(($101)>>2)]=$145;
      var $147=HEAP32[(($101)>>2)];
      var $148=(($147+8)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$101;
      var $151=$118;
      var $152=__ZNSt3__112__snprintf_lEPcjPvPKcz($142, 30, $143, $144, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$149,(tempDoubleF64[0]=$151,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$152;
      __label__ = 3; break;
    case 2: // $153
      var $154=HEAP32[(($__nb)>>2)];
      var $155=__ZNSt3__16__clocEv();
      var $156=(($__fmt)|0);
      var $157=$118;
      var $158=__ZNSt3__112__snprintf_lEPcjPvPKcz($154, 30, $155, $156, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$157,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$158;
      __label__ = 3; break;
    case 3: // $159
      var $160=$98;
      var $161=$99;
      var $162=$100;
      HEAP32[(($98)>>2)]=$__nbh;
      HEAP32[(($99)>>2)]=0;
      HEAP32[(($100)>>2)]=1496;
      var $163=HEAP32[(($98)>>2)];
      var $164=HEAP32[(($99)>>2)];
      var $165=HEAP32[(($100)>>2)];
      var $166=$95;
      var $167=$96;
      var $168=$97;
      HEAP32[(($95)>>2)]=$163;
      HEAP32[(($96)>>2)]=$164;
      HEAP32[(($97)>>2)]=$165;
      var $169=HEAP32[(($95)>>2)];
      var $170=(($169)|0);
      var $171=$94;
      HEAP32[(($94)>>2)]=$96;
      var $172=HEAP32[(($94)>>2)];
      var $173=$94;
      var $174=HEAP32[(($172)>>2)];
      var $175=$80;
      HEAP32[(($80)>>2)]=$97;
      var $176=HEAP32[(($80)>>2)];
      var $177=$80;
      var $178=HEAP32[(($176)>>2)];
      var $179=$91;
      var $180=$92;
      var $181=$93;
      HEAP32[(($91)>>2)]=$170;
      HEAP32[(($92)>>2)]=$174;
      HEAP32[(($93)>>2)]=$178;
      var $182=HEAP32[(($91)>>2)];
      var $183=HEAP32[(($92)>>2)];
      var $184=HEAP32[(($93)>>2)];
      var $185=$88;
      var $186=$89;
      var $187=$90;
      HEAP32[(($88)>>2)]=$182;
      HEAP32[(($89)>>2)]=$183;
      HEAP32[(($90)>>2)]=$184;
      var $188=HEAP32[(($88)>>2)];
      var $189=$188;
      var $190=$87;
      HEAP32[(($87)>>2)]=$89;
      var $191=HEAP32[(($87)>>2)];
      var $192=$87;
      var $193=HEAP32[(($191)>>2)];
      var $194=$81;
      HEAP32[(($81)>>2)]=$90;
      var $195=HEAP32[(($81)>>2)];
      var $196=$81;
      var $197=HEAP32[(($195)>>2)];
      var $198=$84;
      var $199=$85;
      var $200=$86;
      HEAP32[(($84)>>2)]=$189;
      HEAP32[(($85)>>2)]=$193;
      HEAP32[(($86)>>2)]=$197;
      var $201=HEAP32[(($84)>>2)];
      var $202=(($201)|0);
      var $203=$83;
      HEAP32[(($83)>>2)]=$85;
      var $204=HEAP32[(($83)>>2)];
      var $205=$83;
      var $206=HEAP32[(($204)>>2)];
      HEAP32[(($202)>>2)]=$206;
      var $207=(($201+4)|0);
      var $208=$82;
      HEAP32[(($82)>>2)]=$86;
      var $209=HEAP32[(($82)>>2)];
      var $210=$82;
      var $211=HEAP32[(($209)>>2)];
      HEAP32[(($207)>>2)]=$211;
      var $212=$84;
      var $213=$85;
      var $214=$86;
      var $215=$88;
      var $216=$89;
      var $217=$90;
      var $218=$91;
      var $219=$92;
      var $220=$93;
      var $221=$95;
      var $222=$96;
      var $223=$97;
      var $224=$98;
      var $225=$99;
      var $226=$100;
      var $227=$__nc;
      var $228=(($227)|0) > 29;
      if ($228) { __label__ = 4; break; } else { __label__ = 22; break; }
    case 4: // $229
      var $230=$__specify_precision;
      var $231=(($230) & 1);
      if ($231) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $232
      var $233=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $234
      var $235=(($__fmt)|0);
      var $236=$116;
      var $237=$67;
      HEAP32[(($67)>>2)]=$236;
      var $238=HEAP32[(($67)>>2)];
      var $239=(($238+8)|0);
      var $240=HEAP32[(($239)>>2)];
      var $241=$67;
      __label__ = 7; break;
    case 7: // $242
      var $243=$118;
      var $244=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $233, $235, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$240,(tempDoubleF64[0]=$243,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $245
      $__nc=$244;
      __label__ = 14; break;
    case 9: // $246
      var $247=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $248=$247.f0;
      $119=$248;
      var $249=$247.f1;
      $120=$249;
      __label__ = 56; break;
    case 10: // $250
      var $251=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $252
      var $253=(($__fmt)|0);
      var $254=$116;
      var $255=$66;
      HEAP32[(($66)>>2)]=$254;
      var $256=HEAP32[(($66)>>2)];
      var $257=(($256+8)|0);
      var $258=HEAP32[(($257)>>2)];
      var $259=$66;
      __label__ = 12; break;
    case 12: // $260
      var $261=$118;
      var $262=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $251, $253, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$258,(tempDoubleF64[0]=$261,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 9; break; };
    case 13: // $263
      $__nc=$262;
      __label__ = 14; break;
    case 14: // $264
      var $265=HEAP32[(($__nb)>>2)];
      var $266=(($265)|0)==0;
      if ($266) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $267
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 9; break; }
    case 16: // $268
      __label__ = 17; break;
    case 17: // $269
      var $270=HEAP32[(($__nb)>>2)];
      var $271=$50;
      var $272=$51;
      var $273=$__tmp_i;
      var $274=$52;
      var $275=$53;
      HEAP32[(($50)>>2)]=$__nbh;
      HEAP32[(($51)>>2)]=$270;
      var $276=HEAP32[(($50)>>2)];
      var $277=(($276)|0);
      var $278=$49;
      HEAP32[(($49)>>2)]=$277;
      var $279=HEAP32[(($49)>>2)];
      var $280=$279;
      var $281=$48;
      HEAP32[(($48)>>2)]=$280;
      var $282=HEAP32[(($48)>>2)];
      var $283=(($282)|0);
      var $284=$48;
      var $285=$49;
      var $286=HEAP32[(($283)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$286;
      var $287=HEAP32[(($51)>>2)];
      var $288=(($276)|0);
      var $289=$47;
      HEAP32[(($47)>>2)]=$288;
      var $290=HEAP32[(($47)>>2)];
      var $291=$290;
      var $292=$46;
      HEAP32[(($46)>>2)]=$291;
      var $293=HEAP32[(($46)>>2)];
      var $294=(($293)|0);
      var $295=$46;
      var $296=$47;
      HEAP32[(($294)>>2)]=$287;
      var $297=HEAP32[(($__tmp_i)>>2)];
      var $298=(($297)|0)!=0;
      if ($298) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $299
      var $300=(($276)|0);
      var $301=$45;
      HEAP32[(($45)>>2)]=$300;
      var $302=HEAP32[(($45)>>2)];
      var $303=$302;
      var $304=$44;
      HEAP32[(($44)>>2)]=$303;
      var $305=HEAP32[(($44)>>2)];
      var $306=(($305+4)|0);
      var $307=$44;
      var $308=$45;
      var $309=HEAP32[(($306)>>2)];
      var $310=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$309]($310) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $311
      __label__ = 21; break;
    case 20: // $312
      var $313=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $314=$313.f0;
      HEAP32[(($52)>>2)]=$314;
      var $315=$313.f1;
      HEAP32[(($53)>>2)]=$315;
      var $316=HEAP32[(($52)>>2)];
      ___cxa_call_unexpected($316);
      throw "Reached an unreachable!"
    case 21: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $317=$50;
      var $318=$51;
      var $319=$__tmp_i;
      var $320=$52;
      var $321=$53;
      __label__ = 22; break;
    case 22: // $322
      var $323=HEAP32[(($__nb)>>2)];
      var $324=$__nc;
      var $325=(($323+$324)|0);
      $__ne=$325;
      var $326=HEAP32[(($__nb)>>2)];
      var $327=$__ne;
      var $328=$116;
      var $329=(function() { try { __THREW__ = false; return __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($326, $327, $328) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 9; break; };
    case 23: // $330
      $__np=$329;
      var $331=(($__o)|0);
      $__ob=$331;
      var $332=$41;
      var $333=$42;
      var $334=$43;
      HEAP32[(($41)>>2)]=$__obh;
      HEAP32[(($42)>>2)]=0;
      HEAP32[(($43)>>2)]=1496;
      var $335=HEAP32[(($41)>>2)];
      var $336=HEAP32[(($42)>>2)];
      var $337=HEAP32[(($43)>>2)];
      var $338=$38;
      var $339=$39;
      var $340=$40;
      HEAP32[(($38)>>2)]=$335;
      HEAP32[(($39)>>2)]=$336;
      HEAP32[(($40)>>2)]=$337;
      var $341=HEAP32[(($38)>>2)];
      var $342=(($341)|0);
      var $343=$37;
      HEAP32[(($37)>>2)]=$39;
      var $344=HEAP32[(($37)>>2)];
      var $345=$37;
      var $346=HEAP32[(($344)>>2)];
      var $347=$23;
      HEAP32[(($23)>>2)]=$40;
      var $348=HEAP32[(($23)>>2)];
      var $349=$23;
      var $350=HEAP32[(($348)>>2)];
      var $351=$34;
      var $352=$35;
      var $353=$36;
      HEAP32[(($34)>>2)]=$342;
      HEAP32[(($35)>>2)]=$346;
      HEAP32[(($36)>>2)]=$350;
      var $354=HEAP32[(($34)>>2)];
      var $355=HEAP32[(($35)>>2)];
      var $356=HEAP32[(($36)>>2)];
      var $357=$31;
      var $358=$32;
      var $359=$33;
      HEAP32[(($31)>>2)]=$354;
      HEAP32[(($32)>>2)]=$355;
      HEAP32[(($33)>>2)]=$356;
      var $360=HEAP32[(($31)>>2)];
      var $361=$360;
      var $362=$30;
      HEAP32[(($30)>>2)]=$32;
      var $363=HEAP32[(($30)>>2)];
      var $364=$30;
      var $365=HEAP32[(($363)>>2)];
      var $366=$24;
      HEAP32[(($24)>>2)]=$33;
      var $367=HEAP32[(($24)>>2)];
      var $368=$24;
      var $369=HEAP32[(($367)>>2)];
      var $370=$27;
      var $371=$28;
      var $372=$29;
      HEAP32[(($27)>>2)]=$361;
      HEAP32[(($28)>>2)]=$365;
      HEAP32[(($29)>>2)]=$369;
      var $373=HEAP32[(($27)>>2)];
      var $374=(($373)|0);
      var $375=$26;
      HEAP32[(($26)>>2)]=$28;
      var $376=HEAP32[(($26)>>2)];
      var $377=$26;
      var $378=HEAP32[(($376)>>2)];
      HEAP32[(($374)>>2)]=$378;
      var $379=(($373+4)|0);
      var $380=$25;
      HEAP32[(($25)>>2)]=$29;
      var $381=HEAP32[(($25)>>2)];
      var $382=$25;
      var $383=HEAP32[(($381)>>2)];
      HEAP32[(($379)>>2)]=$383;
      var $384=$27;
      var $385=$28;
      var $386=$29;
      var $387=$31;
      var $388=$32;
      var $389=$33;
      var $390=$34;
      var $391=$35;
      var $392=$36;
      var $393=$38;
      var $394=$39;
      var $395=$40;
      var $396=$41;
      var $397=$42;
      var $398=$43;
      __label__ = 24; break;
    case 24: // $399
      var $400=HEAP32[(($__nb)>>2)];
      var $401=(($__nar)|0);
      var $402=(($400)|0)!=(($401)|0);
      if ($402) { __label__ = 25; break; } else { __label__ = 34; break; }
    case 25: // $403
      var $404=$__nc;
      var $405=((($404<<1))|0);
      var $406=((($405<<2))|0);
      var $407=_malloc($406);
      var $408=$407;
      $__ob=$408;
      var $409=$__ob;
      var $410=(($409)|0)==0;
      if ($410) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $411
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $412
      __label__ = 29; break;
    case 28: // $413
      var $414=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $415=$414.f0;
      $119=$415;
      var $416=$414.f1;
      $120=$416;
      __label__ = 50; break;
    case 29: // $417
      var $418=$__ob;
      var $419=$19;
      var $420=$20;
      var $421=$__tmp_i4;
      var $422=$21;
      var $423=$22;
      HEAP32[(($19)>>2)]=$__obh;
      HEAP32[(($20)>>2)]=$418;
      var $424=HEAP32[(($19)>>2)];
      var $425=(($424)|0);
      var $426=$18;
      HEAP32[(($18)>>2)]=$425;
      var $427=HEAP32[(($18)>>2)];
      var $428=$427;
      var $429=$17;
      HEAP32[(($17)>>2)]=$428;
      var $430=HEAP32[(($17)>>2)];
      var $431=(($430)|0);
      var $432=$17;
      var $433=$18;
      var $434=HEAP32[(($431)>>2)];
      HEAP32[(($__tmp_i4)>>2)]=$434;
      var $435=HEAP32[(($20)>>2)];
      var $436=(($424)|0);
      var $437=$16;
      HEAP32[(($16)>>2)]=$436;
      var $438=HEAP32[(($16)>>2)];
      var $439=$438;
      var $440=$15;
      HEAP32[(($15)>>2)]=$439;
      var $441=HEAP32[(($15)>>2)];
      var $442=(($441)|0);
      var $443=$15;
      var $444=$16;
      HEAP32[(($442)>>2)]=$435;
      var $445=HEAP32[(($__tmp_i4)>>2)];
      var $446=(($445)|0)!=0;
      if ($446) { __label__ = 30; break; } else { __label__ = 33; break; }
    case 30: // $447
      var $448=(($424)|0);
      var $449=$14;
      HEAP32[(($14)>>2)]=$448;
      var $450=HEAP32[(($14)>>2)];
      var $451=$450;
      var $452=$13;
      HEAP32[(($13)>>2)]=$451;
      var $453=HEAP32[(($13)>>2)];
      var $454=(($453+4)|0);
      var $455=$13;
      var $456=$14;
      var $457=HEAP32[(($454)>>2)];
      var $458=HEAP32[(($__tmp_i4)>>2)];
      var $459=$458;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$457]($459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $460
      __label__ = 33; break;
    case 32: // $461
      var $462=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $463=$462.f0;
      HEAP32[(($21)>>2)]=$463;
      var $464=$462.f1;
      HEAP32[(($22)>>2)]=$464;
      var $465=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($465);
      throw "Reached an unreachable!"
    case 33: // $_ZNSt3__110unique_ptrIwPFvPvEE5resetEPw_exit
      var $466=$19;
      var $467=$20;
      var $468=$__tmp_i4;
      var $469=$21;
      var $470=$22;
      __label__ = 34; break;
    case 34: // $471
      var $472=HEAP32[(($__nb)>>2)];
      var $473=$__np;
      var $474=$__ne;
      var $475=$__ob;
      var $476=$116;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($121, $476) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 28; break; }
    case 35: // $477
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE($472, $473, $474, $475, $__op, $__oe, $121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 43; break; }
    case 36: // $478
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 28; break; }
    case 37: // $479
      var $480=$123;
      var $481=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($480)>>2)]=HEAP32[(($481)>>2)];
      var $482=$__ob;
      var $483=HEAP32[(($__op)>>2)];
      var $484=HEAP32[(($__oe)>>2)];
      var $485=$116;
      var $486=$117;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($122, $123, $482, $483, $484, $485, $486) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 28; break; }
    case 38: // $487
      var $488=$__s;
      var $489=$122;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($488)>>2)]=HEAP32[(($489)>>2)];
      var $490=$agg_result;
      var $491=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($490)>>2)]=HEAP32[(($491)>>2)];
      $124=1;
      var $492=$12;
      HEAP32[(($12)>>2)]=$__obh;
      var $493=HEAP32[(($12)>>2)];
      var $494=$11;
      HEAP32[(($11)>>2)]=$493;
      var $495=HEAP32[(($11)>>2)];
      var $496=$7;
      var $497=$8;
      var $498=$__tmp_i_i_i5;
      var $499=$9;
      var $500=$10;
      HEAP32[(($7)>>2)]=$495;
      HEAP32[(($8)>>2)]=0;
      var $501=HEAP32[(($7)>>2)];
      var $502=(($501)|0);
      var $503=$6;
      HEAP32[(($6)>>2)]=$502;
      var $504=HEAP32[(($6)>>2)];
      var $505=$504;
      var $506=$5;
      HEAP32[(($5)>>2)]=$505;
      var $507=HEAP32[(($5)>>2)];
      var $508=(($507)|0);
      var $509=$5;
      var $510=$6;
      var $511=HEAP32[(($508)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$511;
      var $512=HEAP32[(($8)>>2)];
      var $513=(($501)|0);
      var $514=$4;
      HEAP32[(($4)>>2)]=$513;
      var $515=HEAP32[(($4)>>2)];
      var $516=$515;
      var $517=$3;
      HEAP32[(($3)>>2)]=$516;
      var $518=HEAP32[(($3)>>2)];
      var $519=(($518)|0);
      var $520=$3;
      var $521=$4;
      HEAP32[(($519)>>2)]=$512;
      var $522=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $523=(($522)|0)!=0;
      if ($523) { __label__ = 39; break; } else { __label__ = 42; break; }
    case 39: // $524
      var $525=(($501)|0);
      var $526=$2;
      HEAP32[(($2)>>2)]=$525;
      var $527=HEAP32[(($2)>>2)];
      var $528=$527;
      var $529=$1;
      HEAP32[(($1)>>2)]=$528;
      var $530=HEAP32[(($1)>>2)];
      var $531=(($530+4)|0);
      var $532=$1;
      var $533=$2;
      var $534=HEAP32[(($531)>>2)];
      var $535=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $536=$535;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$534]($536) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $537
      __label__ = 42; break;
    case 41: // $538
      var $539=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $540=$539.f0;
      HEAP32[(($9)>>2)]=$540;
      var $541=$539.f1;
      HEAP32[(($10)>>2)]=$541;
      var $542=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($542);
      throw "Reached an unreachable!"
    case 42: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit6
      var $543=$7;
      var $544=$8;
      var $545=$__tmp_i_i_i5;
      var $546=$9;
      var $547=$10;
      var $548=$11;
      var $549=$12;
      __label__ = 45; break;
    case 43: // $550
      var $551=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $552=$551.f0;
      $119=$552;
      var $553=$551.f1;
      $120=$553;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($121) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 63; break; }
    case 44: // $554
      __label__ = 50; break;
    case 45: // $555
      var $556=$65;
      HEAP32[(($65)>>2)]=$__nbh;
      var $557=HEAP32[(($65)>>2)];
      var $558=$64;
      HEAP32[(($64)>>2)]=$557;
      var $559=HEAP32[(($64)>>2)];
      var $560=$60;
      var $561=$61;
      var $562=$__tmp_i_i_i2;
      var $563=$62;
      var $564=$63;
      HEAP32[(($60)>>2)]=$559;
      HEAP32[(($61)>>2)]=0;
      var $565=HEAP32[(($60)>>2)];
      var $566=(($565)|0);
      var $567=$59;
      HEAP32[(($59)>>2)]=$566;
      var $568=HEAP32[(($59)>>2)];
      var $569=$568;
      var $570=$58;
      HEAP32[(($58)>>2)]=$569;
      var $571=HEAP32[(($58)>>2)];
      var $572=(($571)|0);
      var $573=$58;
      var $574=$59;
      var $575=HEAP32[(($572)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$575;
      var $576=HEAP32[(($61)>>2)];
      var $577=(($565)|0);
      var $578=$57;
      HEAP32[(($57)>>2)]=$577;
      var $579=HEAP32[(($57)>>2)];
      var $580=$579;
      var $581=$56;
      HEAP32[(($56)>>2)]=$580;
      var $582=HEAP32[(($56)>>2)];
      var $583=(($582)|0);
      var $584=$56;
      var $585=$57;
      HEAP32[(($583)>>2)]=$576;
      var $586=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $587=(($586)|0)!=0;
      if ($587) { __label__ = 46; break; } else { __label__ = 49; break; }
    case 46: // $588
      var $589=(($565)|0);
      var $590=$55;
      HEAP32[(($55)>>2)]=$589;
      var $591=HEAP32[(($55)>>2)];
      var $592=$591;
      var $593=$54;
      HEAP32[(($54)>>2)]=$592;
      var $594=HEAP32[(($54)>>2)];
      var $595=(($594+4)|0);
      var $596=$54;
      var $597=$55;
      var $598=HEAP32[(($595)>>2)];
      var $599=HEAP32[(($__tmp_i_i_i2)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$598]($599) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $600
      __label__ = 49; break;
    case 48: // $601
      var $602=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $603=$602.f0;
      HEAP32[(($62)>>2)]=$603;
      var $604=$602.f1;
      HEAP32[(($63)>>2)]=$604;
      var $605=HEAP32[(($62)>>2)];
      ___cxa_call_unexpected($605);
      throw "Reached an unreachable!"
    case 49: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit3
      var $606=$60;
      var $607=$61;
      var $608=$__tmp_i_i_i2;
      var $609=$62;
      var $610=$63;
      var $611=$64;
      var $612=$65;
      STACKTOP = __stackBase__;
      return;
    case 50: // $613
      var $614=$79;
      HEAP32[(($79)>>2)]=$__obh;
      var $615=HEAP32[(($79)>>2)];
      var $616=$78;
      HEAP32[(($78)>>2)]=$615;
      var $617=HEAP32[(($78)>>2)];
      var $618=$74;
      var $619=$75;
      var $620=$__tmp_i_i_i1;
      var $621=$76;
      var $622=$77;
      HEAP32[(($74)>>2)]=$617;
      HEAP32[(($75)>>2)]=0;
      var $623=HEAP32[(($74)>>2)];
      var $624=(($623)|0);
      var $625=$73;
      HEAP32[(($73)>>2)]=$624;
      var $626=HEAP32[(($73)>>2)];
      var $627=$626;
      var $628=$72;
      HEAP32[(($72)>>2)]=$627;
      var $629=HEAP32[(($72)>>2)];
      var $630=(($629)|0);
      var $631=$72;
      var $632=$73;
      var $633=HEAP32[(($630)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$633;
      var $634=HEAP32[(($75)>>2)];
      var $635=(($623)|0);
      var $636=$71;
      HEAP32[(($71)>>2)]=$635;
      var $637=HEAP32[(($71)>>2)];
      var $638=$637;
      var $639=$70;
      HEAP32[(($70)>>2)]=$638;
      var $640=HEAP32[(($70)>>2)];
      var $641=(($640)|0);
      var $642=$70;
      var $643=$71;
      HEAP32[(($641)>>2)]=$634;
      var $644=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $645=(($644)|0)!=0;
      if ($645) { __label__ = 51; break; } else { __label__ = 54; break; }
    case 51: // $646
      var $647=(($623)|0);
      var $648=$69;
      HEAP32[(($69)>>2)]=$647;
      var $649=HEAP32[(($69)>>2)];
      var $650=$649;
      var $651=$68;
      HEAP32[(($68)>>2)]=$650;
      var $652=HEAP32[(($68)>>2)];
      var $653=(($652+4)|0);
      var $654=$68;
      var $655=$69;
      var $656=HEAP32[(($653)>>2)];
      var $657=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $658=$657;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$656]($658) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $659
      __label__ = 54; break;
    case 53: // $660
      var $661=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $662=$661.f0;
      HEAP32[(($76)>>2)]=$662;
      var $663=$661.f1;
      HEAP32[(($77)>>2)]=$663;
      var $664=HEAP32[(($76)>>2)];
      ___cxa_call_unexpected($664);
      throw "Reached an unreachable!"
    case 54: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $665=$74;
      var $666=$75;
      var $667=$__tmp_i_i_i1;
      var $668=$76;
      var $669=$77;
      var $670=$78;
      var $671=$79;
      __label__ = 55; break;
    case 55: // $672
      __label__ = 56; break;
    case 56: // $673
      var $674=$113;
      HEAP32[(($113)>>2)]=$__nbh;
      var $675=HEAP32[(($113)>>2)];
      var $676=$112;
      HEAP32[(($112)>>2)]=$675;
      var $677=HEAP32[(($112)>>2)];
      var $678=$108;
      var $679=$109;
      var $680=$__tmp_i_i_i;
      var $681=$110;
      var $682=$111;
      HEAP32[(($108)>>2)]=$677;
      HEAP32[(($109)>>2)]=0;
      var $683=HEAP32[(($108)>>2)];
      var $684=(($683)|0);
      var $685=$107;
      HEAP32[(($107)>>2)]=$684;
      var $686=HEAP32[(($107)>>2)];
      var $687=$686;
      var $688=$106;
      HEAP32[(($106)>>2)]=$687;
      var $689=HEAP32[(($106)>>2)];
      var $690=(($689)|0);
      var $691=$106;
      var $692=$107;
      var $693=HEAP32[(($690)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$693;
      var $694=HEAP32[(($109)>>2)];
      var $695=(($683)|0);
      var $696=$105;
      HEAP32[(($105)>>2)]=$695;
      var $697=HEAP32[(($105)>>2)];
      var $698=$697;
      var $699=$104;
      HEAP32[(($104)>>2)]=$698;
      var $700=HEAP32[(($104)>>2)];
      var $701=(($700)|0);
      var $702=$104;
      var $703=$105;
      HEAP32[(($701)>>2)]=$694;
      var $704=HEAP32[(($__tmp_i_i_i)>>2)];
      var $705=(($704)|0)!=0;
      if ($705) { __label__ = 57; break; } else { __label__ = 60; break; }
    case 57: // $706
      var $707=(($683)|0);
      var $708=$103;
      HEAP32[(($103)>>2)]=$707;
      var $709=HEAP32[(($103)>>2)];
      var $710=$709;
      var $711=$102;
      HEAP32[(($102)>>2)]=$710;
      var $712=HEAP32[(($102)>>2)];
      var $713=(($712+4)|0);
      var $714=$102;
      var $715=$103;
      var $716=HEAP32[(($713)>>2)];
      var $717=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$716]($717) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $718
      __label__ = 60; break;
    case 59: // $719
      var $720=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $721=$720.f0;
      HEAP32[(($110)>>2)]=$721;
      var $722=$720.f1;
      HEAP32[(($111)>>2)]=$722;
      var $723=HEAP32[(($110)>>2)];
      ___cxa_call_unexpected($723);
      throw "Reached an unreachable!"
    case 60: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $724=$108;
      var $725=$109;
      var $726=$__tmp_i_i_i;
      var $727=$110;
      var $728=$111;
      var $729=$112;
      var $730=$113;
      __label__ = 61; break;
    case 61: // $731
      __label__ = 62; break;
    case 62: // $732
      var $733=$119;
      var $734=$119;
      var $735=$120;
      var $736=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $734, tempValue);
      var $737=($736.f1 = $735, $736);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 63: // $738
      var $739=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd["X"]=1;

function __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE($__nb, $__np, $__ne, $__ob, $__op, $__oe, $__loc) {
  var __stackBase__  = STACKTOP; STACKTOP += 360; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $__t_i_i_i6=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51;
      var $52=__stackBase__+200;
      var $53=__stackBase__+204;
      var $54=__stackBase__+208;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $__t_i_i_i=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $80=__stackBase__+316;
      var $81=__stackBase__+320;
      var $82=__stackBase__+324;
      var $83;
      var $84=__stackBase__+328;
      var $85;
      var $86=__stackBase__+332;
      var $87;
      var $88=__stackBase__+336;
      var $89=__stackBase__+340;
      var $90=__stackBase__+344;
      var $91;
      var $92;
      var $93;
      var $94;
      var $95;
      var $96;
      var $97;
      var $__ct;
      var $__npt;
      var $__grouping=__stackBase__+348;
      var $__nf;
      var $98;
      var $99;
      var $__ns;
      var $__thousands_sep;
      var $__dc;
      var $__dg;
      var $__p;
      $91=$__nb;
      $92=$__np;
      $93=$__ne;
      $94=$__ob;
      $95=$__op;
      $96=$__oe;
      $97=$__loc;
      var $100=$97;
      var $101=$90;
      HEAP32[(($90)>>2)]=$100;
      var $102=HEAP32[(($90)>>2)];
      var $103=__ZNKSt3__16locale9use_facetERNS0_2idE($102, __ZNSt3__15ctypeIwE2idE);
      var $104=$103;
      var $105=$90;
      $__ct=$104;
      var $106=$97;
      var $107=$89;
      HEAP32[(($89)>>2)]=$106;
      var $108=HEAP32[(($89)>>2)];
      var $109=__ZNKSt3__16locale9use_facetERNS0_2idE($108, __ZNSt3__18numpunctIwE2idE);
      var $110=$109;
      var $111=$89;
      $__npt=$110;
      var $112=$__npt;
      var $113=$88;
      HEAP32[(($88)>>2)]=$112;
      var $114=HEAP32[(($88)>>2)];
      var $115=$114;
      var $116=HEAP32[(($115)>>2)];
      var $117=(($116+20)|0);
      var $118=HEAP32[(($117)>>2)];
      FUNCTION_TABLE[$118]($__grouping, $114);
      var $119=$88;
      var $120=$94;
      var $121=$96;
      HEAP32[(($121)>>2)]=$120;
      var $122=$91;
      $__nf=$122;
      var $123=$__nf;
      var $124=HEAP8[($123)];
      var $125=(($124 << 24) >> 24);
      var $126=(($125)|0)==45;
      if ($126) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $127
      var $128=$__nf;
      var $129=HEAP8[($128)];
      var $130=(($129 << 24) >> 24);
      var $131=(($130)|0)==43;
      if ($131) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $132
      var $133=$__ct;
      var $134=$__nf;
      var $135=(($134+1)|0);
      $__nf=$135;
      var $136=HEAP8[($134)];
      var $137=$86;
      HEAP32[(($86)>>2)]=$133;
      $87=$136;
      var $138=HEAP32[(($86)>>2)];
      var $139=$138;
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+44)|0);
      var $142=HEAP32[(($141)>>2)];
      var $143=$87;
      var $144=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$142]($138, $143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $_ZNKSt3__15ctypeIwE5widenEc_exit
      var $145=$86;
      __label__ = 4; break;
    case 4: // $146
      var $147=$96;
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+4)|0);
      HEAP32[(($147)>>2)]=$149;
      HEAP32[(($148)>>2)]=$144;
      __label__ = 6; break;
    case 5: // $150
      var $151=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $152=$151.f0;
      $98=$152;
      var $153=$151.f1;
      $99=$153;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 95; break; }
    case 6: // $154
      var $155=$93;
      var $156=$__nf;
      var $157=$155;
      var $158=$156;
      var $159=(($157-$158)|0);
      var $160=(($159)|0) >= 2;
      if ($160) { __label__ = 7; break; } else { __label__ = 23; break; }
    case 7: // $161
      var $162=$__nf;
      var $163=(($162)|0);
      var $164=HEAP8[($163)];
      var $165=(($164 << 24) >> 24);
      var $166=(($165)|0)==48;
      if ($166) { __label__ = 8; break; } else { __label__ = 23; break; }
    case 8: // $167
      var $168=$__nf;
      var $169=(($168+1)|0);
      var $170=HEAP8[($169)];
      var $171=(($170 << 24) >> 24);
      var $172=(($171)|0)==120;
      if ($172) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $173
      var $174=$__nf;
      var $175=(($174+1)|0);
      var $176=HEAP8[($175)];
      var $177=(($176 << 24) >> 24);
      var $178=(($177)|0)==88;
      if ($178) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $179
      var $180=$__ct;
      var $181=$__nf;
      var $182=(($181+1)|0);
      $__nf=$182;
      var $183=HEAP8[($181)];
      var $184=$84;
      HEAP32[(($84)>>2)]=$180;
      $85=$183;
      var $185=HEAP32[(($84)>>2)];
      var $186=$185;
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187+44)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=$85;
      var $191=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$189]($185, $190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 5; break; };
    case 11: // $_ZNKSt3__15ctypeIwE5widenEc_exit1
      var $192=$84;
      __label__ = 12; break;
    case 12: // $193
      var $194=$96;
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195+4)|0);
      HEAP32[(($194)>>2)]=$196;
      HEAP32[(($195)>>2)]=$191;
      var $197=$__ct;
      var $198=$__nf;
      var $199=(($198+1)|0);
      $__nf=$199;
      var $200=HEAP8[($198)];
      var $201=$82;
      HEAP32[(($82)>>2)]=$197;
      $83=$200;
      var $202=HEAP32[(($82)>>2)];
      var $203=$202;
      var $204=HEAP32[(($203)>>2)];
      var $205=(($204+44)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=$83;
      var $208=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$206]($202, $207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 5; break; };
    case 13: // $_ZNKSt3__15ctypeIwE5widenEc_exit2
      var $209=$82;
      __label__ = 14; break;
    case 14: // $210
      var $211=$96;
      var $212=HEAP32[(($211)>>2)];
      var $213=(($212+4)|0);
      HEAP32[(($211)>>2)]=$213;
      HEAP32[(($212)>>2)]=$208;
      var $214=$__nf;
      $__ns=$214;
      __label__ = 15; break;
    case 15: // $215
      var $216=$__ns;
      var $217=$93;
      var $218=(($216)>>>0) < (($217)>>>0);
      if ($218) { __label__ = 16; break; } else { __label__ = 22; break; }
    case 16: // $219
      var $220=$__ns;
      var $221=HEAP8[($220)];
      var $222=(($221 << 24) >> 24);
      var $223=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 5; break; };
    case 17: // $224
      var $225=(function() { try { __THREW__ = false; return _isxdigit_l($222, $223) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 5; break; };
    case 18: // $226
      var $227=(($225)|0)!=0;
      if ($227) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $228
      __label__ = 22; break;
    case 20: // $229
      __label__ = 21; break;
    case 21: // $230
      var $231=$__ns;
      var $232=(($231+1)|0);
      $__ns=$232;
      __label__ = 15; break;
    case 22: // $233
      __label__ = 32; break;
    case 23: // $234
      var $235=$__nf;
      $__ns=$235;
      __label__ = 24; break;
    case 24: // $236
      var $237=$__ns;
      var $238=$93;
      var $239=(($237)>>>0) < (($238)>>>0);
      if ($239) { __label__ = 25; break; } else { __label__ = 31; break; }
    case 25: // $240
      var $241=$__ns;
      var $242=HEAP8[($241)];
      var $243=(($242 << 24) >> 24);
      var $244=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 5; break; };
    case 26: // $245
      var $246=(function() { try { __THREW__ = false; return _isdigit_l($243, $244) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 5; break; };
    case 27: // $247
      var $248=(($246)|0)!=0;
      if ($248) { __label__ = 29; break; } else { __label__ = 28; break; }
    case 28: // $249
      __label__ = 31; break;
    case 29: // $250
      __label__ = 30; break;
    case 30: // $251
      var $252=$__ns;
      var $253=(($252+1)|0);
      $__ns=$253;
      __label__ = 24; break;
    case 31: // $254
      __label__ = 32; break;
    case 32: // $255
      var $256=$81;
      HEAP32[(($81)>>2)]=$__grouping;
      var $257=HEAP32[(($81)>>2)];
      var $258=$80;
      HEAP32[(($80)>>2)]=$257;
      var $259=HEAPU32[(($80)>>2)];
      var $260=$79;
      HEAP32[(($79)>>2)]=$259;
      var $261=HEAP32[(($79)>>2)];
      var $262=(($261)|0);
      var $263=$78;
      HEAP32[(($78)>>2)]=$262;
      var $264=HEAP32[(($78)>>2)];
      var $265=$264;
      var $266=$77;
      HEAP32[(($77)>>2)]=$265;
      var $267=HEAP32[(($77)>>2)];
      var $268=(($267)|0);
      var $269=$77;
      var $270=$78;
      var $271=(($268)|0);
      var $272=$271;
      var $273=(($272)|0);
      var $274=$273;
      var $275=HEAPU8[($274)];
      var $276=(($275)&255);
      var $277=$276 & 1;
      var $278=(($277)|0)!=0;
      var $279=$79;
      if ($278) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $280
      var $281=$73;
      HEAP32[(($73)>>2)]=$259;
      var $282=HEAP32[(($73)>>2)];
      var $283=(($282)|0);
      var $284=$72;
      HEAP32[(($72)>>2)]=$283;
      var $285=HEAP32[(($72)>>2)];
      var $286=$285;
      var $287=$71;
      HEAP32[(($71)>>2)]=$286;
      var $288=HEAP32[(($71)>>2)];
      var $289=(($288)|0);
      var $290=$71;
      var $291=$72;
      var $292=(($289)|0);
      var $293=$292;
      var $294=(($293+4)|0);
      var $295=HEAP32[(($294)>>2)];
      var $296=$73;
      var $317 = $295;__label__ = 35; break;
    case 34: // $297
      var $298=$76;
      HEAP32[(($76)>>2)]=$259;
      var $299=HEAP32[(($76)>>2)];
      var $300=(($299)|0);
      var $301=$75;
      HEAP32[(($75)>>2)]=$300;
      var $302=HEAP32[(($75)>>2)];
      var $303=$302;
      var $304=$74;
      HEAP32[(($74)>>2)]=$303;
      var $305=HEAP32[(($74)>>2)];
      var $306=(($305)|0);
      var $307=$74;
      var $308=$75;
      var $309=(($306)|0);
      var $310=$309;
      var $311=(($310)|0);
      var $312=$311;
      var $313=HEAPU8[($312)];
      var $314=(($313)&255);
      var $315=$314 >> 1;
      var $316=$76;
      var $317 = $315;__label__ = 35; break;
    case 35: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $317;
      var $318=$80;
      var $319=(($317)|0)==0;
      var $320=$81;
      if ($319) { __label__ = 36; break; } else { __label__ = 39; break; }
    case 36: // $321
      var $322=$__ct;
      var $323=$__nf;
      var $324=$__ns;
      var $325=$96;
      var $326=HEAP32[(($325)>>2)];
      var $327=$63;
      var $328=$64;
      var $329=$65;
      var $330=$66;
      HEAP32[(($63)>>2)]=$322;
      HEAP32[(($64)>>2)]=$323;
      HEAP32[(($65)>>2)]=$324;
      HEAP32[(($66)>>2)]=$326;
      var $331=HEAP32[(($63)>>2)];
      var $332=$331;
      var $333=HEAP32[(($332)>>2)];
      var $334=(($333+48)|0);
      var $335=HEAP32[(($334)>>2)];
      var $336=HEAP32[(($64)>>2)];
      var $337=HEAP32[(($65)>>2)];
      var $338=HEAP32[(($66)>>2)];
      var $339=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$335]($331, $336, $337, $338) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 5; break; };
    case 37: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit3
      var $340=$63;
      var $341=$64;
      var $342=$65;
      var $343=$66;
      __label__ = 38; break;
    case 38: // $344
      var $345=$__ns;
      var $346=$__nf;
      var $347=$345;
      var $348=$346;
      var $349=(($347-$348)|0);
      var $350=$96;
      var $351=HEAP32[(($350)>>2)];
      var $352=(($351+($349<<2))|0);
      HEAP32[(($350)>>2)]=$352;
      __label__ = 76; break;
    case 39: // $353
      var $354=$__nf;
      var $355=$__ns;
      var $356=$59;
      var $357=$60;
      var $358=$61;
      var $359=$62;
      HEAP32[(($60)>>2)]=$354;
      HEAP32[(($61)>>2)]=$355;
      var $360=HEAP32[(($60)>>2)];
      var $361=HEAP32[(($61)>>2)];
      var $tmp_i=$59;
      var $tmp1_i=$62;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $362=$57;
      var $363=$58;
      HEAP32[(($57)>>2)]=$360;
      HEAP32[(($58)>>2)]=$361;
      var $364=HEAP32[(($57)>>2)];
      var $365=HEAP32[(($58)>>2)];
      var $366=(($364)|0)!=(($365)|0);
      if ($366) { __label__ = 40; break; } else { __label__ = 44; break; }
    case 40: // $367
      __label__ = 41; break;
    case 41: // $368
      var $369=HEAPU32[(($57)>>2)];
      var $370=HEAP32[(($58)>>2)];
      var $371=(($370-1)|0);
      HEAP32[(($58)>>2)]=$371;
      var $372=(($369)>>>0) < (($371)>>>0);
      if ($372) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $373
      var $374=HEAP32[(($57)>>2)];
      var $375=HEAP32[(($58)>>2)];
      var $376=$55;
      var $377=$56;
      HEAP32[(($55)>>2)]=$374;
      HEAP32[(($56)>>2)]=$375;
      var $378=HEAP32[(($55)>>2)];
      var $379=$54;
      HEAP32[(($54)>>2)]=$378;
      var $380=HEAP32[(($54)>>2)];
      var $381=$54;
      var $382=HEAP8[($380)];
      HEAP8[($__t_i_i_i)]=$382;
      var $383=HEAP32[(($56)>>2)];
      var $384=$52;
      HEAP32[(($52)>>2)]=$383;
      var $385=HEAP32[(($52)>>2)];
      var $386=$52;
      var $387=HEAP8[($385)];
      var $388=HEAP32[(($55)>>2)];
      HEAP8[($388)]=$387;
      var $389=$53;
      HEAP32[(($53)>>2)]=$__t_i_i_i;
      var $390=HEAP32[(($53)>>2)];
      var $391=$53;
      var $392=HEAP8[($390)];
      var $393=HEAP32[(($56)>>2)];
      HEAP8[($393)]=$392;
      var $394=$55;
      var $395=$56;
      var $396=HEAP32[(($57)>>2)];
      var $397=(($396+1)|0);
      HEAP32[(($57)>>2)]=$397;
      __label__ = 41; break;
    case 43: // $398
      __label__ = 44; break;
    case 44: // $_ZNSt3__17reverseIPcEEvT_S2__exit
      var $399=$57;
      var $400=$58;
      var $401=$59;
      var $402=$60;
      var $403=$61;
      var $404=$62;
      __label__ = 45; break;
    case 45: // $405
      var $406=$__npt;
      var $407=$49;
      HEAP32[(($49)>>2)]=$406;
      var $408=HEAP32[(($49)>>2)];
      var $409=$408;
      var $410=HEAP32[(($409)>>2)];
      var $411=(($410+16)|0);
      var $412=HEAP32[(($411)>>2)];
      var $413=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$412]($408) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 5; break; };
    case 46: // $_ZNKSt3__18numpunctIwE13thousands_sepEv_exit
      var $414=$49;
      __label__ = 47; break;
    case 47: // $415
      $__thousands_sep=$413;
      $__dc=0;
      $__dg=0;
      var $416=$__nf;
      $__p=$416;
      __label__ = 48; break;
    case 48: // $417
      var $418=$__p;
      var $419=$__ns;
      var $420=(($418)>>>0) < (($419)>>>0);
      if ($420) { __label__ = 49; break; } else { __label__ = 69; break; }
    case 49: // $421
      var $422=$__dg;
      var $423=$47;
      var $424=$48;
      HEAP32[(($47)>>2)]=$__grouping;
      HEAP32[(($48)>>2)]=$422;
      var $425=HEAP32[(($47)>>2)];
      var $426=$46;
      HEAP32[(($46)>>2)]=$425;
      var $427=HEAPU32[(($46)>>2)];
      var $428=$45;
      HEAP32[(($45)>>2)]=$427;
      var $429=HEAP32[(($45)>>2)];
      var $430=(($429)|0);
      var $431=$44;
      HEAP32[(($44)>>2)]=$430;
      var $432=HEAP32[(($44)>>2)];
      var $433=$432;
      var $434=$43;
      HEAP32[(($43)>>2)]=$433;
      var $435=HEAP32[(($43)>>2)];
      var $436=(($435)|0);
      var $437=$43;
      var $438=$44;
      var $439=(($436)|0);
      var $440=$439;
      var $441=(($440)|0);
      var $442=$441;
      var $443=HEAPU8[($442)];
      var $444=(($443)&255);
      var $445=$444 & 1;
      var $446=(($445)|0)!=0;
      var $447=$45;
      if ($446) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $448
      var $449=$39;
      HEAP32[(($39)>>2)]=$427;
      var $450=HEAP32[(($39)>>2)];
      var $451=(($450)|0);
      var $452=$38;
      HEAP32[(($38)>>2)]=$451;
      var $453=HEAP32[(($38)>>2)];
      var $454=$453;
      var $455=$37;
      HEAP32[(($37)>>2)]=$454;
      var $456=HEAP32[(($37)>>2)];
      var $457=(($456)|0);
      var $458=$37;
      var $459=$38;
      var $460=(($457)|0);
      var $461=$460;
      var $462=(($461+8)|0);
      var $463=HEAP32[(($462)>>2)];
      var $464=$39;
      var $482 = $463;__label__ = 52; break;
    case 51: // $465
      var $466=$42;
      HEAP32[(($42)>>2)]=$427;
      var $467=HEAP32[(($42)>>2)];
      var $468=(($467)|0);
      var $469=$41;
      HEAP32[(($41)>>2)]=$468;
      var $470=HEAP32[(($41)>>2)];
      var $471=$470;
      var $472=$40;
      HEAP32[(($40)>>2)]=$471;
      var $473=HEAP32[(($40)>>2)];
      var $474=(($473)|0);
      var $475=$40;
      var $476=$41;
      var $477=(($474)|0);
      var $478=$477;
      var $479=(($478+1)|0);
      var $480=(($479)|0);
      var $481=$42;
      var $482 = $480;__label__ = 52; break;
    case 52: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $482;
      var $483=$46;
      var $484=HEAP32[(($48)>>2)];
      var $485=(($482+$484)|0);
      var $486=$47;
      var $487=$48;
      __label__ = 53; break;
    case 53: // $488
      var $489=HEAP8[($485)];
      var $490=(($489 << 24) >> 24);
      var $491=(($490)|0) > 0;
      if ($491) { __label__ = 54; break; } else { __label__ = 65; break; }
    case 54: // $492
      var $493=$__dc;
      var $494=$__dg;
      var $495=$34;
      var $496=$35;
      HEAP32[(($34)>>2)]=$__grouping;
      HEAP32[(($35)>>2)]=$494;
      var $497=HEAP32[(($34)>>2)];
      var $498=$33;
      HEAP32[(($33)>>2)]=$497;
      var $499=HEAPU32[(($33)>>2)];
      var $500=$32;
      HEAP32[(($32)>>2)]=$499;
      var $501=HEAP32[(($32)>>2)];
      var $502=(($501)|0);
      var $503=$31;
      HEAP32[(($31)>>2)]=$502;
      var $504=HEAP32[(($31)>>2)];
      var $505=$504;
      var $506=$30;
      HEAP32[(($30)>>2)]=$505;
      var $507=HEAP32[(($30)>>2)];
      var $508=(($507)|0);
      var $509=$30;
      var $510=$31;
      var $511=(($508)|0);
      var $512=$511;
      var $513=(($512)|0);
      var $514=$513;
      var $515=HEAPU8[($514)];
      var $516=(($515)&255);
      var $517=$516 & 1;
      var $518=(($517)|0)!=0;
      var $519=$32;
      if ($518) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $520
      var $521=$26;
      HEAP32[(($26)>>2)]=$499;
      var $522=HEAP32[(($26)>>2)];
      var $523=(($522)|0);
      var $524=$25;
      HEAP32[(($25)>>2)]=$523;
      var $525=HEAP32[(($25)>>2)];
      var $526=$525;
      var $527=$24;
      HEAP32[(($24)>>2)]=$526;
      var $528=HEAP32[(($24)>>2)];
      var $529=(($528)|0);
      var $530=$24;
      var $531=$25;
      var $532=(($529)|0);
      var $533=$532;
      var $534=(($533+8)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$26;
      var $554 = $535;__label__ = 57; break;
    case 56: // $537
      var $538=$29;
      HEAP32[(($29)>>2)]=$499;
      var $539=HEAP32[(($29)>>2)];
      var $540=(($539)|0);
      var $541=$28;
      HEAP32[(($28)>>2)]=$540;
      var $542=HEAP32[(($28)>>2)];
      var $543=$542;
      var $544=$27;
      HEAP32[(($27)>>2)]=$543;
      var $545=HEAP32[(($27)>>2)];
      var $546=(($545)|0);
      var $547=$27;
      var $548=$28;
      var $549=(($546)|0);
      var $550=$549;
      var $551=(($550+1)|0);
      var $552=(($551)|0);
      var $553=$29;
      var $554 = $552;__label__ = 57; break;
    case 57: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit5
      var $554;
      var $555=$33;
      var $556=HEAP32[(($35)>>2)];
      var $557=(($554+$556)|0);
      var $558=$34;
      var $559=$35;
      __label__ = 58; break;
    case 58: // $560
      var $561=HEAP8[($557)];
      var $562=(($561 << 24) >> 24);
      var $563=(($493)|0)==(($562)|0);
      if ($563) { __label__ = 59; break; } else { __label__ = 65; break; }
    case 59: // $564
      var $565=$__thousands_sep;
      var $566=$96;
      var $567=HEAP32[(($566)>>2)];
      var $568=(($567+4)|0);
      HEAP32[(($566)>>2)]=$568;
      HEAP32[(($567)>>2)]=$565;
      $__dc=0;
      var $569=$__dg;
      var $570=$10;
      HEAP32[(($10)>>2)]=$__grouping;
      var $571=HEAPU32[(($10)>>2)];
      var $572=$9;
      HEAP32[(($9)>>2)]=$571;
      var $573=HEAP32[(($9)>>2)];
      var $574=(($573)|0);
      var $575=$8;
      HEAP32[(($8)>>2)]=$574;
      var $576=HEAP32[(($8)>>2)];
      var $577=$576;
      var $578=$7;
      HEAP32[(($7)>>2)]=$577;
      var $579=HEAP32[(($7)>>2)];
      var $580=(($579)|0);
      var $581=$7;
      var $582=$8;
      var $583=(($580)|0);
      var $584=$583;
      var $585=(($584)|0);
      var $586=$585;
      var $587=HEAPU8[($586)];
      var $588=(($587)&255);
      var $589=$588 & 1;
      var $590=(($589)|0)!=0;
      var $591=$9;
      if ($590) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $592
      var $593=$3;
      HEAP32[(($3)>>2)]=$571;
      var $594=HEAP32[(($3)>>2)];
      var $595=(($594)|0);
      var $596=$2;
      HEAP32[(($2)>>2)]=$595;
      var $597=HEAP32[(($2)>>2)];
      var $598=$597;
      var $599=$1;
      HEAP32[(($1)>>2)]=$598;
      var $600=HEAP32[(($1)>>2)];
      var $601=(($600)|0);
      var $602=$1;
      var $603=$2;
      var $604=(($601)|0);
      var $605=$604;
      var $606=(($605+4)|0);
      var $607=HEAP32[(($606)>>2)];
      var $608=$3;
      var $629 = $607;__label__ = 62; break;
    case 61: // $609
      var $610=$6;
      HEAP32[(($6)>>2)]=$571;
      var $611=HEAP32[(($6)>>2)];
      var $612=(($611)|0);
      var $613=$5;
      HEAP32[(($5)>>2)]=$612;
      var $614=HEAP32[(($5)>>2)];
      var $615=$614;
      var $616=$4;
      HEAP32[(($4)>>2)]=$615;
      var $617=HEAP32[(($4)>>2)];
      var $618=(($617)|0);
      var $619=$4;
      var $620=$5;
      var $621=(($618)|0);
      var $622=$621;
      var $623=(($622)|0);
      var $624=$623;
      var $625=HEAPU8[($624)];
      var $626=(($625)&255);
      var $627=$626 >> 1;
      var $628=$6;
      var $629 = $627;__label__ = 62; break;
    case 62: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $629;
      var $630=$10;
      var $631=(($629-1)|0);
      var $632=(($569)>>>0) < (($631)>>>0);
      if ($632) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $633
      var $634=$__dg;
      var $635=(($634+1)|0);
      $__dg=$635;
      __label__ = 64; break;
    case 64: // $636
      __label__ = 65; break;
    case 65: // $637
      var $638=$__ct;
      var $639=$__p;
      var $640=HEAP8[($639)];
      var $641=$11;
      HEAP32[(($11)>>2)]=$638;
      $12=$640;
      var $642=HEAP32[(($11)>>2)];
      var $643=$642;
      var $644=HEAP32[(($643)>>2)];
      var $645=(($644+44)|0);
      var $646=HEAP32[(($645)>>2)];
      var $647=$12;
      var $648=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$646]($642, $647) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 5; break; };
    case 66: // $_ZNKSt3__15ctypeIwE5widenEc_exit9
      var $649=$11;
      __label__ = 67; break;
    case 67: // $650
      var $651=$96;
      var $652=HEAP32[(($651)>>2)];
      var $653=(($652+4)|0);
      HEAP32[(($651)>>2)]=$653;
      HEAP32[(($652)>>2)]=$648;
      var $654=$__dc;
      var $655=(($654+1)|0);
      $__dc=$655;
      __label__ = 68; break;
    case 68: // $656
      var $657=$__p;
      var $658=(($657+1)|0);
      $__p=$658;
      __label__ = 48; break;
    case 69: // $659
      var $660=$94;
      var $661=$__nf;
      var $662=$91;
      var $663=$661;
      var $664=$662;
      var $665=(($663-$664)|0);
      var $666=(($660+($665<<2))|0);
      var $667=$96;
      var $668=HEAP32[(($667)>>2)];
      var $669=$20;
      var $670=$21;
      var $671=$22;
      var $672=$23;
      HEAP32[(($21)>>2)]=$666;
      HEAP32[(($22)>>2)]=$668;
      var $673=HEAP32[(($21)>>2)];
      var $674=HEAP32[(($22)>>2)];
      var $tmp_i7=$20;
      var $tmp1_i8=$23;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i7)]=HEAP8[($tmp1_i8)];
      var $675=$18;
      var $676=$19;
      HEAP32[(($18)>>2)]=$673;
      HEAP32[(($19)>>2)]=$674;
      var $677=HEAP32[(($18)>>2)];
      var $678=HEAP32[(($19)>>2)];
      var $679=(($677)|0)!=(($678)|0);
      if ($679) { __label__ = 70; break; } else { __label__ = 74; break; }
    case 70: // $680
      __label__ = 71; break;
    case 71: // $681
      var $682=HEAPU32[(($18)>>2)];
      var $683=HEAP32[(($19)>>2)];
      var $684=(($683-4)|0);
      HEAP32[(($19)>>2)]=$684;
      var $685=(($682)>>>0) < (($684)>>>0);
      if ($685) { __label__ = 72; break; } else { __label__ = 73; break; }
    case 72: // $686
      var $687=HEAP32[(($18)>>2)];
      var $688=HEAP32[(($19)>>2)];
      var $689=$16;
      var $690=$17;
      var $691=$__t_i_i_i6;
      HEAP32[(($16)>>2)]=$687;
      HEAP32[(($17)>>2)]=$688;
      var $692=HEAP32[(($16)>>2)];
      var $693=$15;
      HEAP32[(($15)>>2)]=$692;
      var $694=HEAP32[(($15)>>2)];
      var $695=$15;
      var $696=HEAP32[(($694)>>2)];
      HEAP32[(($__t_i_i_i6)>>2)]=$696;
      var $697=HEAP32[(($17)>>2)];
      var $698=$13;
      HEAP32[(($13)>>2)]=$697;
      var $699=HEAP32[(($13)>>2)];
      var $700=$13;
      var $701=HEAP32[(($699)>>2)];
      var $702=HEAP32[(($16)>>2)];
      HEAP32[(($702)>>2)]=$701;
      var $703=$14;
      HEAP32[(($14)>>2)]=$__t_i_i_i6;
      var $704=HEAP32[(($14)>>2)];
      var $705=$14;
      var $706=HEAP32[(($704)>>2)];
      var $707=HEAP32[(($17)>>2)];
      HEAP32[(($707)>>2)]=$706;
      var $708=$16;
      var $709=$17;
      var $710=$__t_i_i_i6;
      var $711=HEAP32[(($18)>>2)];
      var $712=(($711+4)|0);
      HEAP32[(($18)>>2)]=$712;
      __label__ = 71; break;
    case 73: // $713
      __label__ = 74; break;
    case 74: // $_ZNSt3__17reverseIPwEEvT_S2__exit
      var $714=$18;
      var $715=$19;
      var $716=$20;
      var $717=$21;
      var $718=$22;
      var $719=$23;
      __label__ = 75; break;
    case 75: // $720
      __label__ = 76; break;
    case 76: // $721
      var $722=$__ns;
      $__nf=$722;
      __label__ = 77; break;
    case 77: // $723
      var $724=$__nf;
      var $725=$93;
      var $726=(($724)>>>0) < (($725)>>>0);
      if ($726) { __label__ = 78; break; } else { __label__ = 87; break; }
    case 78: // $727
      var $728=$__nf;
      var $729=HEAP8[($728)];
      var $730=(($729 << 24) >> 24);
      var $731=(($730)|0)==46;
      if ($731) { __label__ = 79; break; } else { __label__ = 82; break; }
    case 79: // $732
      var $733=$__npt;
      var $734=$36;
      HEAP32[(($36)>>2)]=$733;
      var $735=HEAP32[(($36)>>2)];
      var $736=$735;
      var $737=HEAP32[(($736)>>2)];
      var $738=(($737+12)|0);
      var $739=HEAP32[(($738)>>2)];
      var $740=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$739]($735) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 5; break; };
    case 80: // $_ZNKSt3__18numpunctIwE13decimal_pointEv_exit
      var $741=$36;
      __label__ = 81; break;
    case 81: // $742
      var $743=$96;
      var $744=HEAP32[(($743)>>2)];
      var $745=(($744+4)|0);
      HEAP32[(($743)>>2)]=$745;
      HEAP32[(($744)>>2)]=$740;
      var $746=$__nf;
      var $747=(($746+1)|0);
      $__nf=$747;
      __label__ = 87; break;
    case 82: // $748
      var $749=$__ct;
      var $750=$__nf;
      var $751=HEAP8[($750)];
      var $752=$50;
      HEAP32[(($50)>>2)]=$749;
      $51=$751;
      var $753=HEAP32[(($50)>>2)];
      var $754=$753;
      var $755=HEAP32[(($754)>>2)];
      var $756=(($755+44)|0);
      var $757=HEAP32[(($756)>>2)];
      var $758=$51;
      var $759=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$757]($753, $758) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 83; break; } else { __label__ = 5; break; };
    case 83: // $_ZNKSt3__15ctypeIwE5widenEc_exit4
      var $760=$50;
      __label__ = 84; break;
    case 84: // $761
      var $762=$96;
      var $763=HEAP32[(($762)>>2)];
      var $764=(($763+4)|0);
      HEAP32[(($762)>>2)]=$764;
      HEAP32[(($763)>>2)]=$759;
      __label__ = 85; break;
    case 85: // $765
      __label__ = 86; break;
    case 86: // $766
      var $767=$__nf;
      var $768=(($767+1)|0);
      $__nf=$768;
      __label__ = 77; break;
    case 87: // $769
      var $770=$__ct;
      var $771=$__nf;
      var $772=$93;
      var $773=$96;
      var $774=HEAP32[(($773)>>2)];
      var $775=$67;
      var $776=$68;
      var $777=$69;
      var $778=$70;
      HEAP32[(($67)>>2)]=$770;
      HEAP32[(($68)>>2)]=$771;
      HEAP32[(($69)>>2)]=$772;
      HEAP32[(($70)>>2)]=$774;
      var $779=HEAP32[(($67)>>2)];
      var $780=$779;
      var $781=HEAP32[(($780)>>2)];
      var $782=(($781+48)|0);
      var $783=HEAP32[(($782)>>2)];
      var $784=HEAP32[(($68)>>2)];
      var $785=HEAP32[(($69)>>2)];
      var $786=HEAP32[(($70)>>2)];
      var $787=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$783]($779, $784, $785, $786) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 5; break; };
    case 88: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $788=$67;
      var $789=$68;
      var $790=$69;
      var $791=$70;
      __label__ = 89; break;
    case 89: // $792
      var $793=$93;
      var $794=$__nf;
      var $795=$793;
      var $796=$794;
      var $797=(($795-$796)|0);
      var $798=$96;
      var $799=HEAP32[(($798)>>2)];
      var $800=(($799+($797<<2))|0);
      HEAP32[(($798)>>2)]=$800;
      var $801=$92;
      var $802=$93;
      var $803=(($801)|0)==(($802)|0);
      if ($803) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $804
      var $805=$96;
      var $806=HEAP32[(($805)>>2)];
      var $807=$95;
      HEAP32[(($807)>>2)]=$806;
      __label__ = 92; break;
    case 91: // $808
      var $809=$94;
      var $810=$92;
      var $811=$91;
      var $812=$810;
      var $813=$811;
      var $814=(($812-$813)|0);
      var $815=(($809+($814<<2))|0);
      var $816=$95;
      HEAP32[(($816)>>2)]=$815;
      __label__ = 92; break;
    case 92: // $817
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grouping);
      STACKTOP = __stackBase__;
      return;
    case 93: // $818
      __label__ = 94; break;
    case 94: // $819
      var $820=$98;
      var $821=$98;
      var $822=$99;
      var $823=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $821, tempValue);
      var $824=($823.f1 = $822, $823);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 95: // $825
      var $826=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE["X"]=1;

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 784; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i5=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i3=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $__tmp_i2=__stackBase__+136;
      var $33=__stackBase__+140;
      var $34=__stackBase__+144;
      var $35=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $49=__stackBase__+204;
      var $50=__stackBase__+208;
      var $51=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $62=__stackBase__+256;
      var $63=__stackBase__+260;
      var $__tmp_i=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $__tmp_i_i_i1=__stackBase__+312;
      var $75=__stackBase__+316;
      var $76=__stackBase__+320;
      var $77=__stackBase__+324;
      var $78=__stackBase__+328;
      var $79=__stackBase__+332;
      var $80=__stackBase__+336;
      var $81=__stackBase__+340;
      var $82=__stackBase__+344;
      var $83=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $93=__stackBase__+388;
      var $94=__stackBase__+392;
      var $95=__stackBase__+396;
      var $96=__stackBase__+400;
      var $97=__stackBase__+404;
      var $98=__stackBase__+408;
      var $99=__stackBase__+412;
      var $100=__stackBase__+416;
      var $101=__stackBase__+420;
      var $102=__stackBase__+424;
      var $103=__stackBase__+428;
      var $104=__stackBase__+432;
      var $105=__stackBase__+436;
      var $106=__stackBase__+440;
      var $107=__stackBase__+444;
      var $108=__stackBase__+448;
      var $__tmp_i_i_i=__stackBase__+452;
      var $109=__stackBase__+456;
      var $110=__stackBase__+460;
      var $111=__stackBase__+464;
      var $112=__stackBase__+468;
      var $113=__stackBase__+472;
      var $114;
      var $115;
      var $116;
      var $117;
      var $__fmt=__stackBase__+476;
      var $__len;
      var $__specify_precision;
      var $__nbuf;
      var $__nar=__stackBase__+484;
      var $__nb=__stackBase__+516;
      var $__nc;
      var $__nbh=__stackBase__+520;
      var $118;
      var $119;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+528;
      var $__ob;
      var $__obh=__stackBase__+756;
      var $__op=__stackBase__+764;
      var $__oe=__stackBase__+768;
      var $120=__stackBase__+772;
      var $121=__stackBase__+776;
      var $122=__stackBase__+780;
      var $123;
      $114=$this;
      $115=$__iob;
      $116=$__fl;
      $117=$__v;
      var $124=$114;
      var $125=$__fmt;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($125)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0))];HEAP8[($125+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+1)];HEAP8[($125+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+2)];HEAP8[($125+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+3)];HEAP8[($125+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+4)];HEAP8[($125+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+5)];HEAP8[($125+6)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+6)];HEAP8[($125+7)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt)|0)+7)];
      $__len=((STRING_TABLE.__str8245)|0);
      var $126=(($__fmt)|0);
      var $127=(($126+1)|0);
      var $128=$__len;
      var $129=$115;
      var $130=$113;
      HEAP32[(($113)>>2)]=$129;
      var $131=HEAP32[(($113)>>2)];
      var $132=(($131+4)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=$113;
      var $135=__ZNSt3__114__num_put_base14__format_floatEPcPKcj($127, $128, $133);
      var $136=(($135)&1);
      $__specify_precision=$136;
      $__nbuf=30;
      var $137=(($__nar)|0);
      HEAP32[(($__nb)>>2)]=$137;
      var $138=$__specify_precision;
      var $139=(($138) & 1);
      if ($139) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $140
      var $141=HEAP32[(($__nb)>>2)];
      var $142=__ZNSt3__16__clocEv();
      var $143=(($__fmt)|0);
      var $144=$115;
      var $145=$100;
      HEAP32[(($100)>>2)]=$144;
      var $146=HEAP32[(($100)>>2)];
      var $147=(($146+8)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=$100;
      var $150=$117;
      var $151=__ZNSt3__112__snprintf_lEPcjPvPKcz($141, 30, $142, $143, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$148,(tempDoubleF64[0]=$150,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$151;
      __label__ = 3; break;
    case 2: // $152
      var $153=HEAP32[(($__nb)>>2)];
      var $154=__ZNSt3__16__clocEv();
      var $155=(($__fmt)|0);
      var $156=$117;
      var $157=__ZNSt3__112__snprintf_lEPcjPvPKcz($153, 30, $154, $155, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$156,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__nc=$157;
      __label__ = 3; break;
    case 3: // $158
      var $159=$97;
      var $160=$98;
      var $161=$99;
      HEAP32[(($97)>>2)]=$__nbh;
      HEAP32[(($98)>>2)]=0;
      HEAP32[(($99)>>2)]=1496;
      var $162=HEAP32[(($97)>>2)];
      var $163=HEAP32[(($98)>>2)];
      var $164=HEAP32[(($99)>>2)];
      var $165=$94;
      var $166=$95;
      var $167=$96;
      HEAP32[(($94)>>2)]=$162;
      HEAP32[(($95)>>2)]=$163;
      HEAP32[(($96)>>2)]=$164;
      var $168=HEAP32[(($94)>>2)];
      var $169=(($168)|0);
      var $170=$93;
      HEAP32[(($93)>>2)]=$95;
      var $171=HEAP32[(($93)>>2)];
      var $172=$93;
      var $173=HEAP32[(($171)>>2)];
      var $174=$79;
      HEAP32[(($79)>>2)]=$96;
      var $175=HEAP32[(($79)>>2)];
      var $176=$79;
      var $177=HEAP32[(($175)>>2)];
      var $178=$90;
      var $179=$91;
      var $180=$92;
      HEAP32[(($90)>>2)]=$169;
      HEAP32[(($91)>>2)]=$173;
      HEAP32[(($92)>>2)]=$177;
      var $181=HEAP32[(($90)>>2)];
      var $182=HEAP32[(($91)>>2)];
      var $183=HEAP32[(($92)>>2)];
      var $184=$87;
      var $185=$88;
      var $186=$89;
      HEAP32[(($87)>>2)]=$181;
      HEAP32[(($88)>>2)]=$182;
      HEAP32[(($89)>>2)]=$183;
      var $187=HEAP32[(($87)>>2)];
      var $188=$187;
      var $189=$86;
      HEAP32[(($86)>>2)]=$88;
      var $190=HEAP32[(($86)>>2)];
      var $191=$86;
      var $192=HEAP32[(($190)>>2)];
      var $193=$80;
      HEAP32[(($80)>>2)]=$89;
      var $194=HEAP32[(($80)>>2)];
      var $195=$80;
      var $196=HEAP32[(($194)>>2)];
      var $197=$83;
      var $198=$84;
      var $199=$85;
      HEAP32[(($83)>>2)]=$188;
      HEAP32[(($84)>>2)]=$192;
      HEAP32[(($85)>>2)]=$196;
      var $200=HEAP32[(($83)>>2)];
      var $201=(($200)|0);
      var $202=$82;
      HEAP32[(($82)>>2)]=$84;
      var $203=HEAP32[(($82)>>2)];
      var $204=$82;
      var $205=HEAP32[(($203)>>2)];
      HEAP32[(($201)>>2)]=$205;
      var $206=(($200+4)|0);
      var $207=$81;
      HEAP32[(($81)>>2)]=$85;
      var $208=HEAP32[(($81)>>2)];
      var $209=$81;
      var $210=HEAP32[(($208)>>2)];
      HEAP32[(($206)>>2)]=$210;
      var $211=$83;
      var $212=$84;
      var $213=$85;
      var $214=$87;
      var $215=$88;
      var $216=$89;
      var $217=$90;
      var $218=$91;
      var $219=$92;
      var $220=$94;
      var $221=$95;
      var $222=$96;
      var $223=$97;
      var $224=$98;
      var $225=$99;
      var $226=$__nc;
      var $227=(($226)|0) > 29;
      if ($227) { __label__ = 4; break; } else { __label__ = 21; break; }
    case 4: // $228
      var $229=$__specify_precision;
      var $230=(($229) & 1);
      if ($230) { __label__ = 5; break; } else { __label__ = 10; break; }
    case 5: // $231
      var $232=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; };
    case 6: // $233
      var $234=(($__fmt)|0);
      var $235=$115;
      var $236=$66;
      HEAP32[(($66)>>2)]=$235;
      var $237=HEAP32[(($66)>>2)];
      var $238=(($237+8)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=$66;
      __label__ = 7; break;
    case 7: // $241
      var $242=$117;
      var $243=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $232, $234, (tempInt=STACKTOP,STACKTOP += 12,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$239,(tempDoubleF64[0]=$242,HEAP32[((tempInt+4)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $244
      $__nc=$243;
      __label__ = 13; break;
    case 9: // $245
      var $246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $247=$246.f0;
      $118=$247;
      var $248=$246.f1;
      $119=$248;
      __label__ = 55; break;
    case 10: // $249
      var $250=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 9; break; };
    case 11: // $251
      var $252=(($__fmt)|0);
      var $253=$117;
      var $254=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__nb, $250, $252, (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$253,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 9; break; };
    case 12: // $255
      $__nc=$254;
      __label__ = 13; break;
    case 13: // $256
      var $257=HEAP32[(($__nb)>>2)];
      var $258=(($257)|0)==0;
      if ($258) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $259
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 9; break; }
    case 15: // $260
      __label__ = 16; break;
    case 16: // $261
      var $262=HEAP32[(($__nb)>>2)];
      var $263=$62;
      var $264=$63;
      var $265=$__tmp_i;
      var $266=$64;
      var $267=$65;
      HEAP32[(($62)>>2)]=$__nbh;
      HEAP32[(($63)>>2)]=$262;
      var $268=HEAP32[(($62)>>2)];
      var $269=(($268)|0);
      var $270=$61;
      HEAP32[(($61)>>2)]=$269;
      var $271=HEAP32[(($61)>>2)];
      var $272=$271;
      var $273=$60;
      HEAP32[(($60)>>2)]=$272;
      var $274=HEAP32[(($60)>>2)];
      var $275=(($274)|0);
      var $276=$60;
      var $277=$61;
      var $278=HEAP32[(($275)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$278;
      var $279=HEAP32[(($63)>>2)];
      var $280=(($268)|0);
      var $281=$59;
      HEAP32[(($59)>>2)]=$280;
      var $282=HEAP32[(($59)>>2)];
      var $283=$282;
      var $284=$58;
      HEAP32[(($58)>>2)]=$283;
      var $285=HEAP32[(($58)>>2)];
      var $286=(($285)|0);
      var $287=$58;
      var $288=$59;
      HEAP32[(($286)>>2)]=$279;
      var $289=HEAP32[(($__tmp_i)>>2)];
      var $290=(($289)|0)!=0;
      if ($290) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $291
      var $292=(($268)|0);
      var $293=$57;
      HEAP32[(($57)>>2)]=$292;
      var $294=HEAP32[(($57)>>2)];
      var $295=$294;
      var $296=$56;
      HEAP32[(($56)>>2)]=$295;
      var $297=HEAP32[(($56)>>2)];
      var $298=(($297+4)|0);
      var $299=$56;
      var $300=$57;
      var $301=HEAP32[(($298)>>2)];
      var $302=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$301]($302) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $303
      __label__ = 20; break;
    case 19: // $304
      var $305=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $306=$305.f0;
      HEAP32[(($64)>>2)]=$306;
      var $307=$305.f1;
      HEAP32[(($65)>>2)]=$307;
      var $308=HEAP32[(($64)>>2)];
      ___cxa_call_unexpected($308);
      throw "Reached an unreachable!"
    case 20: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $309=$62;
      var $310=$63;
      var $311=$__tmp_i;
      var $312=$64;
      var $313=$65;
      __label__ = 21; break;
    case 21: // $314
      var $315=HEAP32[(($__nb)>>2)];
      var $316=$__nc;
      var $317=(($315+$316)|0);
      $__ne=$317;
      var $318=HEAP32[(($__nb)>>2)];
      var $319=$__ne;
      var $320=$115;
      var $321=(function() { try { __THREW__ = false; return __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($318, $319, $320) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 9; break; };
    case 22: // $322
      $__np=$321;
      var $323=(($__o)|0);
      $__ob=$323;
      var $324=$53;
      var $325=$54;
      var $326=$55;
      HEAP32[(($53)>>2)]=$__obh;
      HEAP32[(($54)>>2)]=0;
      HEAP32[(($55)>>2)]=1496;
      var $327=HEAP32[(($53)>>2)];
      var $328=HEAP32[(($54)>>2)];
      var $329=HEAP32[(($55)>>2)];
      var $330=$50;
      var $331=$51;
      var $332=$52;
      HEAP32[(($50)>>2)]=$327;
      HEAP32[(($51)>>2)]=$328;
      HEAP32[(($52)>>2)]=$329;
      var $333=HEAP32[(($50)>>2)];
      var $334=(($333)|0);
      var $335=$49;
      HEAP32[(($49)>>2)]=$51;
      var $336=HEAP32[(($49)>>2)];
      var $337=$49;
      var $338=HEAP32[(($336)>>2)];
      var $339=$35;
      HEAP32[(($35)>>2)]=$52;
      var $340=HEAP32[(($35)>>2)];
      var $341=$35;
      var $342=HEAP32[(($340)>>2)];
      var $343=$46;
      var $344=$47;
      var $345=$48;
      HEAP32[(($46)>>2)]=$334;
      HEAP32[(($47)>>2)]=$338;
      HEAP32[(($48)>>2)]=$342;
      var $346=HEAP32[(($46)>>2)];
      var $347=HEAP32[(($47)>>2)];
      var $348=HEAP32[(($48)>>2)];
      var $349=$43;
      var $350=$44;
      var $351=$45;
      HEAP32[(($43)>>2)]=$346;
      HEAP32[(($44)>>2)]=$347;
      HEAP32[(($45)>>2)]=$348;
      var $352=HEAP32[(($43)>>2)];
      var $353=$352;
      var $354=$42;
      HEAP32[(($42)>>2)]=$44;
      var $355=HEAP32[(($42)>>2)];
      var $356=$42;
      var $357=HEAP32[(($355)>>2)];
      var $358=$36;
      HEAP32[(($36)>>2)]=$45;
      var $359=HEAP32[(($36)>>2)];
      var $360=$36;
      var $361=HEAP32[(($359)>>2)];
      var $362=$39;
      var $363=$40;
      var $364=$41;
      HEAP32[(($39)>>2)]=$353;
      HEAP32[(($40)>>2)]=$357;
      HEAP32[(($41)>>2)]=$361;
      var $365=HEAP32[(($39)>>2)];
      var $366=(($365)|0);
      var $367=$38;
      HEAP32[(($38)>>2)]=$40;
      var $368=HEAP32[(($38)>>2)];
      var $369=$38;
      var $370=HEAP32[(($368)>>2)];
      HEAP32[(($366)>>2)]=$370;
      var $371=(($365+4)|0);
      var $372=$37;
      HEAP32[(($37)>>2)]=$41;
      var $373=HEAP32[(($37)>>2)];
      var $374=$37;
      var $375=HEAP32[(($373)>>2)];
      HEAP32[(($371)>>2)]=$375;
      var $376=$39;
      var $377=$40;
      var $378=$41;
      var $379=$43;
      var $380=$44;
      var $381=$45;
      var $382=$46;
      var $383=$47;
      var $384=$48;
      var $385=$50;
      var $386=$51;
      var $387=$52;
      var $388=$53;
      var $389=$54;
      var $390=$55;
      __label__ = 23; break;
    case 23: // $391
      var $392=HEAP32[(($__nb)>>2)];
      var $393=(($__nar)|0);
      var $394=(($392)|0)!=(($393)|0);
      if ($394) { __label__ = 24; break; } else { __label__ = 33; break; }
    case 24: // $395
      var $396=$__nc;
      var $397=((($396<<1))|0);
      var $398=((($397<<2))|0);
      var $399=_malloc($398);
      var $400=$399;
      $__ob=$400;
      var $401=$__ob;
      var $402=(($401)|0)==0;
      if ($402) { __label__ = 25; break; } else { __label__ = 28; break; }
    case 25: // $403
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $404
      __label__ = 28; break;
    case 27: // $405
      var $406=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $407=$406.f0;
      $118=$407;
      var $408=$406.f1;
      $119=$408;
      __label__ = 49; break;
    case 28: // $409
      var $410=$__ob;
      var $411=$31;
      var $412=$32;
      var $413=$__tmp_i2;
      var $414=$33;
      var $415=$34;
      HEAP32[(($31)>>2)]=$__obh;
      HEAP32[(($32)>>2)]=$410;
      var $416=HEAP32[(($31)>>2)];
      var $417=(($416)|0);
      var $418=$30;
      HEAP32[(($30)>>2)]=$417;
      var $419=HEAP32[(($30)>>2)];
      var $420=$419;
      var $421=$29;
      HEAP32[(($29)>>2)]=$420;
      var $422=HEAP32[(($29)>>2)];
      var $423=(($422)|0);
      var $424=$29;
      var $425=$30;
      var $426=HEAP32[(($423)>>2)];
      HEAP32[(($__tmp_i2)>>2)]=$426;
      var $427=HEAP32[(($32)>>2)];
      var $428=(($416)|0);
      var $429=$28;
      HEAP32[(($28)>>2)]=$428;
      var $430=HEAP32[(($28)>>2)];
      var $431=$430;
      var $432=$27;
      HEAP32[(($27)>>2)]=$431;
      var $433=HEAP32[(($27)>>2)];
      var $434=(($433)|0);
      var $435=$27;
      var $436=$28;
      HEAP32[(($434)>>2)]=$427;
      var $437=HEAP32[(($__tmp_i2)>>2)];
      var $438=(($437)|0)!=0;
      if ($438) { __label__ = 29; break; } else { __label__ = 32; break; }
    case 29: // $439
      var $440=(($416)|0);
      var $441=$26;
      HEAP32[(($26)>>2)]=$440;
      var $442=HEAP32[(($26)>>2)];
      var $443=$442;
      var $444=$25;
      HEAP32[(($25)>>2)]=$443;
      var $445=HEAP32[(($25)>>2)];
      var $446=(($445+4)|0);
      var $447=$25;
      var $448=$26;
      var $449=HEAP32[(($446)>>2)];
      var $450=HEAP32[(($__tmp_i2)>>2)];
      var $451=$450;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$449]($451) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $452
      __label__ = 32; break;
    case 31: // $453
      var $454=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $455=$454.f0;
      HEAP32[(($33)>>2)]=$455;
      var $456=$454.f1;
      HEAP32[(($34)>>2)]=$456;
      var $457=HEAP32[(($33)>>2)];
      ___cxa_call_unexpected($457);
      throw "Reached an unreachable!"
    case 32: // $_ZNSt3__110unique_ptrIwPFvPvEE5resetEPw_exit
      var $458=$31;
      var $459=$32;
      var $460=$__tmp_i2;
      var $461=$33;
      var $462=$34;
      __label__ = 33; break;
    case 33: // $463
      var $464=HEAP32[(($__nb)>>2)];
      var $465=$__np;
      var $466=$__ne;
      var $467=$__ob;
      var $468=$115;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($120, $468) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 27; break; }
    case 34: // $469
      (function() { try { __THREW__ = false; return __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE($464, $465, $466, $467, $__op, $__oe, $120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 42; break; }
    case 35: // $470
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 27; break; }
    case 36: // $471
      var $472=$122;
      var $473=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($472)>>2)]=HEAP32[(($473)>>2)];
      var $474=$__ob;
      var $475=HEAP32[(($__op)>>2)];
      var $476=HEAP32[(($__oe)>>2)];
      var $477=$115;
      var $478=$116;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($121, $122, $474, $475, $476, $477, $478) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 27; break; }
    case 37: // $479
      var $480=$__s;
      var $481=$121;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($480)>>2)]=HEAP32[(($481)>>2)];
      var $482=$agg_result;
      var $483=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($482)>>2)]=HEAP32[(($483)>>2)];
      $123=1;
      var $484=$24;
      HEAP32[(($24)>>2)]=$__obh;
      var $485=HEAP32[(($24)>>2)];
      var $486=$23;
      HEAP32[(($23)>>2)]=$485;
      var $487=HEAP32[(($23)>>2)];
      var $488=$19;
      var $489=$20;
      var $490=$__tmp_i_i_i3;
      var $491=$21;
      var $492=$22;
      HEAP32[(($19)>>2)]=$487;
      HEAP32[(($20)>>2)]=0;
      var $493=HEAP32[(($19)>>2)];
      var $494=(($493)|0);
      var $495=$18;
      HEAP32[(($18)>>2)]=$494;
      var $496=HEAP32[(($18)>>2)];
      var $497=$496;
      var $498=$17;
      HEAP32[(($17)>>2)]=$497;
      var $499=HEAP32[(($17)>>2)];
      var $500=(($499)|0);
      var $501=$17;
      var $502=$18;
      var $503=HEAP32[(($500)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$503;
      var $504=HEAP32[(($20)>>2)];
      var $505=(($493)|0);
      var $506=$16;
      HEAP32[(($16)>>2)]=$505;
      var $507=HEAP32[(($16)>>2)];
      var $508=$507;
      var $509=$15;
      HEAP32[(($15)>>2)]=$508;
      var $510=HEAP32[(($15)>>2)];
      var $511=(($510)|0);
      var $512=$15;
      var $513=$16;
      HEAP32[(($511)>>2)]=$504;
      var $514=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $515=(($514)|0)!=0;
      if ($515) { __label__ = 38; break; } else { __label__ = 41; break; }
    case 38: // $516
      var $517=(($493)|0);
      var $518=$14;
      HEAP32[(($14)>>2)]=$517;
      var $519=HEAP32[(($14)>>2)];
      var $520=$519;
      var $521=$13;
      HEAP32[(($13)>>2)]=$520;
      var $522=HEAP32[(($13)>>2)];
      var $523=(($522+4)|0);
      var $524=$13;
      var $525=$14;
      var $526=HEAP32[(($523)>>2)];
      var $527=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $528=$527;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$526]($528) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $529
      __label__ = 41; break;
    case 40: // $530
      var $531=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $532=$531.f0;
      HEAP32[(($21)>>2)]=$532;
      var $533=$531.f1;
      HEAP32[(($22)>>2)]=$533;
      var $534=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($534);
      throw "Reached an unreachable!"
    case 41: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit4
      var $535=$19;
      var $536=$20;
      var $537=$__tmp_i_i_i3;
      var $538=$21;
      var $539=$22;
      var $540=$23;
      var $541=$24;
      __label__ = 44; break;
    case 42: // $542
      var $543=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $544=$543.f0;
      $118=$544;
      var $545=$543.f1;
      $119=$545;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 62; break; }
    case 43: // $546
      __label__ = 49; break;
    case 44: // $547
      var $548=$12;
      HEAP32[(($12)>>2)]=$__nbh;
      var $549=HEAP32[(($12)>>2)];
      var $550=$11;
      HEAP32[(($11)>>2)]=$549;
      var $551=HEAP32[(($11)>>2)];
      var $552=$7;
      var $553=$8;
      var $554=$__tmp_i_i_i5;
      var $555=$9;
      var $556=$10;
      HEAP32[(($7)>>2)]=$551;
      HEAP32[(($8)>>2)]=0;
      var $557=HEAP32[(($7)>>2)];
      var $558=(($557)|0);
      var $559=$6;
      HEAP32[(($6)>>2)]=$558;
      var $560=HEAP32[(($6)>>2)];
      var $561=$560;
      var $562=$5;
      HEAP32[(($5)>>2)]=$561;
      var $563=HEAP32[(($5)>>2)];
      var $564=(($563)|0);
      var $565=$5;
      var $566=$6;
      var $567=HEAP32[(($564)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$567;
      var $568=HEAP32[(($8)>>2)];
      var $569=(($557)|0);
      var $570=$4;
      HEAP32[(($4)>>2)]=$569;
      var $571=HEAP32[(($4)>>2)];
      var $572=$571;
      var $573=$3;
      HEAP32[(($3)>>2)]=$572;
      var $574=HEAP32[(($3)>>2)];
      var $575=(($574)|0);
      var $576=$3;
      var $577=$4;
      HEAP32[(($575)>>2)]=$568;
      var $578=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $579=(($578)|0)!=0;
      if ($579) { __label__ = 45; break; } else { __label__ = 48; break; }
    case 45: // $580
      var $581=(($557)|0);
      var $582=$2;
      HEAP32[(($2)>>2)]=$581;
      var $583=HEAP32[(($2)>>2)];
      var $584=$583;
      var $585=$1;
      HEAP32[(($1)>>2)]=$584;
      var $586=HEAP32[(($1)>>2)];
      var $587=(($586+4)|0);
      var $588=$1;
      var $589=$2;
      var $590=HEAP32[(($587)>>2)];
      var $591=HEAP32[(($__tmp_i_i_i5)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$590]($591) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $592
      __label__ = 48; break;
    case 47: // $593
      var $594=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $595=$594.f0;
      HEAP32[(($9)>>2)]=$595;
      var $596=$594.f1;
      HEAP32[(($10)>>2)]=$596;
      var $597=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($597);
      throw "Reached an unreachable!"
    case 48: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit6
      var $598=$7;
      var $599=$8;
      var $600=$__tmp_i_i_i5;
      var $601=$9;
      var $602=$10;
      var $603=$11;
      var $604=$12;
      STACKTOP = __stackBase__;
      return;
    case 49: // $605
      var $606=$78;
      HEAP32[(($78)>>2)]=$__obh;
      var $607=HEAP32[(($78)>>2)];
      var $608=$77;
      HEAP32[(($77)>>2)]=$607;
      var $609=HEAP32[(($77)>>2)];
      var $610=$73;
      var $611=$74;
      var $612=$__tmp_i_i_i1;
      var $613=$75;
      var $614=$76;
      HEAP32[(($73)>>2)]=$609;
      HEAP32[(($74)>>2)]=0;
      var $615=HEAP32[(($73)>>2)];
      var $616=(($615)|0);
      var $617=$72;
      HEAP32[(($72)>>2)]=$616;
      var $618=HEAP32[(($72)>>2)];
      var $619=$618;
      var $620=$71;
      HEAP32[(($71)>>2)]=$619;
      var $621=HEAP32[(($71)>>2)];
      var $622=(($621)|0);
      var $623=$71;
      var $624=$72;
      var $625=HEAP32[(($622)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$625;
      var $626=HEAP32[(($74)>>2)];
      var $627=(($615)|0);
      var $628=$70;
      HEAP32[(($70)>>2)]=$627;
      var $629=HEAP32[(($70)>>2)];
      var $630=$629;
      var $631=$69;
      HEAP32[(($69)>>2)]=$630;
      var $632=HEAP32[(($69)>>2)];
      var $633=(($632)|0);
      var $634=$69;
      var $635=$70;
      HEAP32[(($633)>>2)]=$626;
      var $636=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $637=(($636)|0)!=0;
      if ($637) { __label__ = 50; break; } else { __label__ = 53; break; }
    case 50: // $638
      var $639=(($615)|0);
      var $640=$68;
      HEAP32[(($68)>>2)]=$639;
      var $641=HEAP32[(($68)>>2)];
      var $642=$641;
      var $643=$67;
      HEAP32[(($67)>>2)]=$642;
      var $644=HEAP32[(($67)>>2)];
      var $645=(($644+4)|0);
      var $646=$67;
      var $647=$68;
      var $648=HEAP32[(($645)>>2)];
      var $649=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $650=$649;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$648]($650) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $651
      __label__ = 53; break;
    case 52: // $652
      var $653=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $654=$653.f0;
      HEAP32[(($75)>>2)]=$654;
      var $655=$653.f1;
      HEAP32[(($76)>>2)]=$655;
      var $656=HEAP32[(($75)>>2)];
      ___cxa_call_unexpected($656);
      throw "Reached an unreachable!"
    case 53: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $657=$73;
      var $658=$74;
      var $659=$__tmp_i_i_i1;
      var $660=$75;
      var $661=$76;
      var $662=$77;
      var $663=$78;
      __label__ = 54; break;
    case 54: // $664
      __label__ = 55; break;
    case 55: // $665
      var $666=$112;
      HEAP32[(($112)>>2)]=$__nbh;
      var $667=HEAP32[(($112)>>2)];
      var $668=$111;
      HEAP32[(($111)>>2)]=$667;
      var $669=HEAP32[(($111)>>2)];
      var $670=$107;
      var $671=$108;
      var $672=$__tmp_i_i_i;
      var $673=$109;
      var $674=$110;
      HEAP32[(($107)>>2)]=$669;
      HEAP32[(($108)>>2)]=0;
      var $675=HEAP32[(($107)>>2)];
      var $676=(($675)|0);
      var $677=$106;
      HEAP32[(($106)>>2)]=$676;
      var $678=HEAP32[(($106)>>2)];
      var $679=$678;
      var $680=$105;
      HEAP32[(($105)>>2)]=$679;
      var $681=HEAP32[(($105)>>2)];
      var $682=(($681)|0);
      var $683=$105;
      var $684=$106;
      var $685=HEAP32[(($682)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$685;
      var $686=HEAP32[(($108)>>2)];
      var $687=(($675)|0);
      var $688=$104;
      HEAP32[(($104)>>2)]=$687;
      var $689=HEAP32[(($104)>>2)];
      var $690=$689;
      var $691=$103;
      HEAP32[(($103)>>2)]=$690;
      var $692=HEAP32[(($103)>>2)];
      var $693=(($692)|0);
      var $694=$103;
      var $695=$104;
      HEAP32[(($693)>>2)]=$686;
      var $696=HEAP32[(($__tmp_i_i_i)>>2)];
      var $697=(($696)|0)!=0;
      if ($697) { __label__ = 56; break; } else { __label__ = 59; break; }
    case 56: // $698
      var $699=(($675)|0);
      var $700=$102;
      HEAP32[(($102)>>2)]=$699;
      var $701=HEAP32[(($102)>>2)];
      var $702=$701;
      var $703=$101;
      HEAP32[(($101)>>2)]=$702;
      var $704=HEAP32[(($101)>>2)];
      var $705=(($704+4)|0);
      var $706=$101;
      var $707=$102;
      var $708=HEAP32[(($705)>>2)];
      var $709=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$708]($709) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $710
      __label__ = 59; break;
    case 58: // $711
      var $712=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $713=$712.f0;
      HEAP32[(($109)>>2)]=$713;
      var $714=$712.f1;
      HEAP32[(($110)>>2)]=$714;
      var $715=HEAP32[(($109)>>2)];
      ___cxa_call_unexpected($715);
      throw "Reached an unreachable!"
    case 59: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $716=$107;
      var $717=$108;
      var $718=$__tmp_i_i_i;
      var $719=$109;
      var $720=$110;
      var $721=$111;
      var $722=$112;
      __label__ = 60; break;
    case 60: // $723
      __label__ = 61; break;
    case 61: // $724
      var $725=$118;
      var $726=$118;
      var $727=$119;
      var $728=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $726, tempValue);
      var $729=($728.f1 = $727, $728);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 62: // $730
      var $731=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe["X"]=1;

function __ZNSt3__120__time_get_c_storageIcEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__120__time_get_c_storageIcEE+8)|0);
  ;
  return;
}


function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv($agg_result, $this, $__s, $__iob, $__fl, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 204; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $8;
      var $9;
      var $__fmt=__stackBase__+20;
      var $__nbuf;
      var $__nar=__stackBase__+28;
      var $__nc;
      var $__ne;
      var $__np;
      var $__o=__stackBase__+48;
      var $__op;
      var $__oe;
      var $__ct;
      var $10=__stackBase__+196;
      var $11;
      var $12;
      var $13=__stackBase__+200;
      $6=$this;
      $7=$__iob;
      $8=$__fl;
      $9=$__v;
      var $14=$6;
      var $15=$__fmt;
      assert(6 % 1 === 0, 'memcpy given ' + 6 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($15)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt)|0))];HEAP8[($15+1)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt)|0)+1)];HEAP8[($15+2)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt)|0)+2)];HEAP8[($15+3)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt)|0)+3)];HEAP8[($15+4)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt)|0)+4)];HEAP8[($15+5)]=HEAP8[(((STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt)|0)+5)];
      $__nbuf=20;
      var $16=(($__nar)|0);
      var $17=__ZNSt3__16__clocEv();
      var $18=(($__fmt)|0);
      var $19=$9;
      var $20=__ZNSt3__111__sprintf_lEPcPvPKcz($16, $17, $18, (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$19,tempInt));
      $__nc=$20;
      var $21=(($__nar)|0);
      var $22=$__nc;
      var $23=(($21+$22)|0);
      $__ne=$23;
      var $24=(($__nar)|0);
      var $25=$__ne;
      var $26=$7;
      var $27=__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE($24, $25, $26);
      $__np=$27;
      var $28=$7;
      __ZNKSt3__18ios_base6getlocEv($10, $28);
      var $29=$5;
      HEAP32[(($5)>>2)]=$10;
      var $30=HEAP32[(($5)>>2)];
      var $31=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($30, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 4; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $32=$31;
      var $33=$5;
      __label__ = 2; break;
    case 2: // $34
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($10);
      $__ct=$32;
      var $35=$__ct;
      var $36=(($__nar)|0);
      var $37=$__ne;
      var $38=(($__o)|0);
      var $39=$1;
      var $40=$2;
      var $41=$3;
      var $42=$4;
      HEAP32[(($1)>>2)]=$35;
      HEAP32[(($2)>>2)]=$36;
      HEAP32[(($3)>>2)]=$37;
      HEAP32[(($4)>>2)]=$38;
      var $43=HEAP32[(($1)>>2)];
      var $44=$43;
      var $45=HEAP32[(($44)>>2)];
      var $46=(($45+48)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=HEAP32[(($2)>>2)];
      var $49=HEAP32[(($3)>>2)];
      var $50=HEAP32[(($4)>>2)];
      var $51=FUNCTION_TABLE[$47]($43, $48, $49, $50);
      var $52=$1;
      var $53=$2;
      var $54=$3;
      var $55=$4;
      var $56=(($__o)|0);
      var $57=$__ne;
      var $58=(($__nar)|0);
      var $59=$57;
      var $60=$58;
      var $61=(($59-$60)|0);
      var $62=(($56+($61<<2))|0);
      $__oe=$62;
      var $63=$__np;
      var $64=$__ne;
      var $65=(($63)|0)==(($64)|0);
      if ($65) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $66
      var $67=$__oe;
      $__op=$67;
      __label__ = 7; break;
    case 4: // $68
      var $69=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $70=$69.f0;
      $11=$70;
      var $71=$69.f1;
      $12=$71;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($10) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; }
    case 5: // $72
      __label__ = 8; break;
    case 6: // $73
      var $74=(($__o)|0);
      var $75=$__np;
      var $76=(($__nar)|0);
      var $77=$75;
      var $78=$76;
      var $79=(($77-$78)|0);
      var $80=(($74+($79<<2))|0);
      $__op=$80;
      __label__ = 7; break;
    case 7: // $81
      var $82=$13;
      var $83=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($82)>>2)]=HEAP32[(($83)>>2)];
      var $84=(($__o)|0);
      var $85=$__op;
      var $86=$__oe;
      var $87=$7;
      var $88=$8;
      __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $13, $84, $85, $86, $87, $88);
      STACKTOP = __stackBase__;
      return;
    case 8: // $89
      var $90=$11;
      var $91=$11;
      var $92=$12;
      var $93=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $91, tempValue);
      var $94=($93.f1 = $92, $93);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $95
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm, $__fmtb, $__fmte) {
  var __stackBase__  = STACKTOP; STACKTOP += 208; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10=__stackBase__+28;
      var $11=__stackBase__+32;
      var $12;
      var $13=__stackBase__+36;
      var $14=__stackBase__+40;
      var $15=__stackBase__+44;
      var $16=__stackBase__+48;
      var $17=__stackBase__+52;
      var $18;
      var $19;
      var $20=__stackBase__+56;
      var $21=__stackBase__+60;
      var $22=__stackBase__+64;
      var $23=__stackBase__+68;
      var $24;
      var $25=__stackBase__+72;
      var $26=__stackBase__+76;
      var $27=__stackBase__+80;
      var $28=__stackBase__+84;
      var $29=__stackBase__+88;
      var $30;
      var $31=__stackBase__+92;
      var $32=__stackBase__+96;
      var $33;
      var $34=__stackBase__+100;
      var $35=__stackBase__+104;
      var $36;
      var $37=__stackBase__+108;
      var $38;
      var $39;
      var $40=__stackBase__+112;
      var $41;
      var $42;
      var $43=__stackBase__+116;
      var $44;
      var $45;
      var $46=__stackBase__+120;
      var $47=__stackBase__+124;
      var $48;
      var $49=__stackBase__+128;
      var $50=__stackBase__+132;
      var $51;
      var $52=__stackBase__+136;
      var $53=__stackBase__+140;
      var $54=__stackBase__+144;
      var $55=__stackBase__+148;
      var $56=__stackBase__+152;
      var $57=__stackBase__+156;
      var $58=__stackBase__+160;
      var $59=__stackBase__+164;
      var $60=__stackBase__+168;
      var $61=__stackBase__+172;
      var $62=__stackBase__+176;
      var $63=__stackBase__+180;
      var $64=__stackBase__+184;
      var $65=__stackBase__+188;
      var $66;
      var $67;
      var $68;
      var $69;
      var $70;
      var $71;
      var $__ct;
      var $72=__stackBase__+192;
      var $73;
      var $74;
      var $__cmd;
      var $__opt;
      var $75=__stackBase__+196;
      var $76=__stackBase__+200;
      var $77=__stackBase__+204;
      $66=$this;
      $67=$__iob;
      $68=$__err;
      $69=$__tm;
      $70=$__fmtb;
      $71=$__fmte;
      var $78=$66;
      var $79=$67;
      __ZNKSt3__18ios_base6getlocEv($72, $79);
      var $80=$65;
      HEAP32[(($65)>>2)]=$72;
      var $81=HEAP32[(($65)>>2)];
      var $82=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($81, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $83=$82;
      var $84=$65;
      __label__ = 2; break;
    case 2: // $85
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($72);
      $__ct=$83;
      var $86=$68;
      HEAP32[(($86)>>2)]=0;
      __label__ = 3; break;
    case 3: // $87
      var $88=$70;
      var $89=$71;
      var $90=(($88)|0)!=(($89)|0);
      if ($90) { __label__ = 4; break; } else { var $96 = 0;__label__ = 5; break; }
    case 4: // $91
      var $92=$68;
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93)|0)==0;
      var $96 = $94;__label__ = 5; break;
    case 5: // $95
      var $96;
      if ($96) { __label__ = 6; break; } else { __label__ = 76; break; }
    case 6: // $97
      var $98=$63;
      var $99=$64;
      HEAP32[(($63)>>2)]=$__b;
      HEAP32[(($64)>>2)]=$__e;
      var $100=HEAP32[(($63)>>2)];
      var $101=HEAP32[(($64)>>2)];
      var $102=$61;
      var $103=$62;
      HEAP32[(($61)>>2)]=$100;
      HEAP32[(($62)>>2)]=$101;
      var $104=HEAP32[(($61)>>2)];
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106)|0)==0;
      var $108=(($107)&1);
      var $109=HEAP32[(($62)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111)|0)==0;
      var $113=(($112)&1);
      var $114=(($108)|0)==(($113)|0);
      var $115=$61;
      var $116=$62;
      var $117=$63;
      var $118=$64;
      if ($114) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $119
      var $120=$68;
      HEAP32[(($120)>>2)]=4;
      __label__ = 76; break;
    case 8: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $123=$122.f0;
      $73=$123;
      var $124=$122.f1;
      $74=$124;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 80; break; }
    case 9: // $125
      __label__ = 79; break;
    case 10: // $126
      var $127=$__ct;
      var $128=$70;
      var $129=HEAP8[($128)];
      var $130=$43;
      HEAP32[(($43)>>2)]=$127;
      $44=$129;
      $45=0;
      var $131=HEAP32[(($43)>>2)];
      var $132=$131;
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+36)|0);
      var $135=HEAP32[(($134)>>2)];
      var $136=$44;
      var $137=$45;
      var $138=FUNCTION_TABLE[$135]($131, $136, $137);
      var $139=$43;
      var $140=(($138 << 24) >> 24);
      var $141=(($140)|0)==37;
      if ($141) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $142
      var $143=$70;
      var $144=(($143+1)|0);
      $70=$144;
      var $145=$71;
      var $146=(($144)|0)==(($145)|0);
      if ($146) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $147
      var $148=$68;
      HEAP32[(($148)>>2)]=4;
      __label__ = 76; break;
    case 13: // $149
      var $150=$__ct;
      var $151=$70;
      var $152=HEAP8[($151)];
      var $153=$40;
      HEAP32[(($40)>>2)]=$150;
      $41=$152;
      $42=0;
      var $154=HEAP32[(($40)>>2)];
      var $155=$154;
      var $156=HEAP32[(($155)>>2)];
      var $157=(($156+36)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$41;
      var $160=$42;
      var $161=FUNCTION_TABLE[$158]($154, $159, $160);
      var $162=$40;
      $__cmd=$161;
      $__opt=0;
      var $163=$__cmd;
      var $164=(($163 << 24) >> 24);
      var $165=(($164)|0)==69;
      if ($165) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $166
      var $167=$__cmd;
      var $168=(($167 << 24) >> 24);
      var $169=(($168)|0)==48;
      if ($169) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $170
      var $171=$70;
      var $172=(($171+1)|0);
      $70=$172;
      var $173=$71;
      var $174=(($172)|0)==(($173)|0);
      if ($174) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $175
      var $176=$68;
      HEAP32[(($176)>>2)]=4;
      __label__ = 76; break;
    case 17: // $177
      var $178=$__cmd;
      $__opt=$178;
      var $179=$__ct;
      var $180=$70;
      var $181=HEAP8[($180)];
      var $182=$37;
      HEAP32[(($37)>>2)]=$179;
      $38=$181;
      $39=0;
      var $183=HEAP32[(($37)>>2)];
      var $184=$183;
      var $185=HEAP32[(($184)>>2)];
      var $186=(($185+36)|0);
      var $187=HEAP32[(($186)>>2)];
      var $188=$38;
      var $189=$39;
      var $190=FUNCTION_TABLE[$187]($183, $188, $189);
      var $191=$37;
      $__cmd=$190;
      __label__ = 18; break;
    case 18: // $192
      var $193=$78;
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194+36)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=$76;
      var $198=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($197)>>2)]=HEAP32[(($198)>>2)];
      var $199=$77;
      var $200=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($199)>>2)]=HEAP32[(($200)>>2)];
      var $201=$67;
      var $202=$68;
      var $203=$69;
      var $204=$__cmd;
      var $205=$__opt;
      FUNCTION_TABLE[$196]($75, $78, $76, $77, $201, $202, $203, $204, $205);
      var $206=$__b;
      var $207=$75;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($206)>>2)]=HEAP32[(($207)>>2)];
      var $208=$70;
      var $209=(($208+1)|0);
      $70=$209;
      __label__ = 75; break;
    case 19: // $210
      var $211=$__ct;
      var $212=$70;
      var $213=HEAP8[($212)];
      var $214=$34;
      var $215=$35;
      HEAP32[(($34)>>2)]=$211;
      HEAP32[(($35)>>2)]=16384;
      $36=$213;
      var $216=HEAP32[(($34)>>2)];
      var $217=$36;
      var $218=(($217 << 24) >> 24);
      var $219=(($218)>>>0) <= 127;
      if ($219) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $220
      var $221=$36;
      var $222=(($221 << 24) >> 24);
      var $223=(($216+8)|0);
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224+($222<<2))|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=HEAP32[(($35)>>2)];
      var $228=$226 & $227;
      var $230 = $228;__label__ = 22; break;
    case 21: // $229
      var $230 = 0;__label__ = 22; break;
    case 22: // $_ZNKSt3__15ctypeIcE2isEjc_exit
      var $230;
      var $231=(($230)|0)!=0;
      var $232=$34;
      var $233=$35;
      if ($231) { __label__ = 23; break; } else { __label__ = 56; break; }
    case 23: // $234
      var $235=$70;
      var $236=(($235+1)|0);
      $70=$236;
      __label__ = 24; break;
    case 24: // $237
      var $238=$70;
      var $239=$71;
      var $240=(($238)|0)!=(($239)|0);
      if ($240) { __label__ = 25; break; } else { var $266 = 0;__label__ = 29; break; }
    case 25: // $241
      var $242=$__ct;
      var $243=$70;
      var $244=HEAP8[($243)];
      var $245=$31;
      var $246=$32;
      HEAP32[(($31)>>2)]=$242;
      HEAP32[(($32)>>2)]=16384;
      $33=$244;
      var $247=HEAP32[(($31)>>2)];
      var $248=$33;
      var $249=(($248 << 24) >> 24);
      var $250=(($249)>>>0) <= 127;
      if ($250) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $251
      var $252=$33;
      var $253=(($252 << 24) >> 24);
      var $254=(($247+8)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=(($255+($253<<2))|0);
      var $257=HEAP32[(($256)>>2)];
      var $258=HEAP32[(($32)>>2)];
      var $259=$257 & $258;
      var $261 = $259;__label__ = 28; break;
    case 27: // $260
      var $261 = 0;__label__ = 28; break;
    case 28: // $_ZNKSt3__15ctypeIcE2isEjc_exit1
      var $261;
      var $262=(($261)|0)!=0;
      var $263=$31;
      var $264=$32;
      var $266 = $262;__label__ = 29; break;
    case 29: // $265
      var $266;
      if ($266) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $267
      __label__ = 31; break;
    case 31: // $268
      var $269=$70;
      var $270=(($269+1)|0);
      $70=$270;
      __label__ = 24; break;
    case 32: // $271
      __label__ = 33; break;
    case 33: // $272
      var $273=$27;
      var $274=$28;
      HEAP32[(($27)>>2)]=$__b;
      HEAP32[(($28)>>2)]=$__e;
      var $275=HEAP32[(($27)>>2)];
      var $276=HEAP32[(($28)>>2)];
      var $277=$25;
      var $278=$26;
      HEAP32[(($25)>>2)]=$275;
      HEAP32[(($26)>>2)]=$276;
      var $279=HEAP32[(($25)>>2)];
      var $280=(($279)|0);
      var $281=HEAP32[(($280)>>2)];
      var $282=(($281)|0)==0;
      var $283=(($282)&1);
      var $284=HEAP32[(($26)>>2)];
      var $285=(($284)|0);
      var $286=HEAP32[(($285)>>2)];
      var $287=(($286)|0)==0;
      var $288=(($287)&1);
      var $289=(($283)|0)==(($288)|0);
      var $290=$25;
      var $291=$26;
      var $292=$289 ^ 1;
      var $293=$27;
      var $294=$28;
      if ($292) { __label__ = 34; break; } else { var $347 = 0;__label__ = 41; break; }
    case 34: // $295
      var $296=$__ct;
      var $297=$22;
      HEAP32[(($22)>>2)]=$__b;
      var $298=HEAP32[(($22)>>2)];
      var $299=(($298)|0);
      var $300=HEAP32[(($299)>>2)];
      var $301=$20;
      var $302=$21;
      HEAP32[(($21)>>2)]=$300;
      var $303=HEAP32[(($21)>>2)];
      var $304=(($303+12)|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=(($303+16)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=(($305)|0)==(($307)|0);
      if ($308) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $309
      var $310=$303;
      var $311=HEAP32[(($310)>>2)];
      var $312=(($311+36)|0);
      var $313=HEAP32[(($312)>>2)];
      var $314=FUNCTION_TABLE[$313]($303);
      HEAP32[(($20)>>2)]=$314;
      __label__ = 37; break;
    case 36: // $315
      var $316=(($303+12)|0);
      var $317=HEAP32[(($316)>>2)];
      var $318=HEAP8[($317)];
      $19=$318;
      var $319=$19;
      var $320=(($319)&255);
      HEAP32[(($20)>>2)]=$320;
      __label__ = 37; break;
    case 37: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $321=HEAP32[(($20)>>2)];
      var $322=$20;
      var $323=$21;
      var $324=(($321) & 255);
      var $325=$22;
      var $326=$16;
      var $327=$17;
      HEAP32[(($16)>>2)]=$296;
      HEAP32[(($17)>>2)]=16384;
      $18=$324;
      var $328=HEAP32[(($16)>>2)];
      var $329=$18;
      var $330=(($329 << 24) >> 24);
      var $331=(($330)>>>0) <= 127;
      if ($331) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $332
      var $333=$18;
      var $334=(($333 << 24) >> 24);
      var $335=(($328+8)|0);
      var $336=HEAP32[(($335)>>2)];
      var $337=(($336+($334<<2))|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=HEAP32[(($17)>>2)];
      var $340=$338 & $339;
      var $342 = $340;__label__ = 40; break;
    case 39: // $341
      var $342 = 0;__label__ = 40; break;
    case 40: // $_ZNKSt3__15ctypeIcE2isEjc_exit2
      var $342;
      var $343=(($342)|0)!=0;
      var $344=$16;
      var $345=$17;
      var $347 = $343;__label__ = 41; break;
    case 41: // $346
      var $347;
      if ($347) { __label__ = 42; break; } else { __label__ = 55; break; }
    case 42: // $348
      __label__ = 43; break;
    case 43: // $349
      var $350=$11;
      HEAP32[(($11)>>2)]=$__b;
      var $351=HEAPU32[(($11)>>2)];
      var $352=(($351)|0);
      var $353=HEAP32[(($352)>>2)];
      var $354=$9;
      var $355=$10;
      HEAP32[(($10)>>2)]=$353;
      var $356=HEAPU32[(($10)>>2)];
      var $357=$7;
      var $358=$8;
      HEAP32[(($8)>>2)]=$356;
      var $359=HEAP32[(($8)>>2)];
      var $360=(($359+12)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($359+16)|0);
      var $363=HEAP32[(($362)>>2)];
      var $364=(($361)|0)==(($363)|0);
      if ($364) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $365
      var $366=$359;
      var $367=HEAP32[(($366)>>2)];
      var $368=(($367+40)|0);
      var $369=HEAP32[(($368)>>2)];
      var $370=FUNCTION_TABLE[$369]($359);
      HEAP32[(($7)>>2)]=$370;
      __label__ = 46; break;
    case 45: // $371
      var $372=(($359+12)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=(($373+1)|0);
      HEAP32[(($372)>>2)]=$374;
      var $375=HEAP8[($373)];
      $6=$375;
      var $376=$6;
      var $377=(($376)&255);
      HEAP32[(($7)>>2)]=$377;
      __label__ = 46; break;
    case 46: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i4
      var $378=HEAP32[(($7)>>2)];
      var $379=$7;
      var $380=$8;
      var $381=(($378)|0)==-1;
      if ($381) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $382
      HEAP32[(($9)>>2)]=-1;
      __label__ = 52; break;
    case 48: // $383
      var $384=$4;
      var $385=$5;
      HEAP32[(($5)>>2)]=$356;
      var $386=HEAPU32[(($5)>>2)];
      var $387=(($386+12)|0);
      var $388=HEAP32[(($387)>>2)];
      var $389=(($386+16)|0);
      var $390=HEAP32[(($389)>>2)];
      var $391=(($388)|0)==(($390)|0);
      if ($391) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $392
      var $393=$386;
      var $394=HEAP32[(($393)>>2)];
      var $395=(($394+36)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=FUNCTION_TABLE[$396]($386);
      HEAP32[(($4)>>2)]=$397;
      __label__ = 51; break;
    case 50: // $398
      var $399=(($386+12)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=HEAP8[($400)];
      $3=$401;
      var $402=$3;
      var $403=(($402)&255);
      HEAP32[(($4)>>2)]=$403;
      __label__ = 51; break;
    case 51: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i5
      var $404=HEAP32[(($4)>>2)];
      var $405=$4;
      var $406=$5;
      HEAP32[(($9)>>2)]=$404;
      __label__ = 52; break;
    case 52: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i6
      var $407=HEAP32[(($9)>>2)];
      var $408=$9;
      var $409=$10;
      var $410=$1;
      var $411=$2;
      HEAP32[(($1)>>2)]=$407;
      HEAP32[(($2)>>2)]=-1;
      var $412=HEAP32[(($1)>>2)];
      var $413=HEAP32[(($2)>>2)];
      var $414=(($412)|0)==(($413)|0);
      var $415=$1;
      var $416=$2;
      if ($414) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $417
      var $418=(($351)|0);
      HEAP32[(($418)>>2)]=0;
      __label__ = 54; break;
    case 54: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit7
      var $419=$11;
      __label__ = 33; break;
    case 55: // $420
      __label__ = 74; break;
    case 56: // $421
      var $422=$__ct;
      var $423=$15;
      HEAP32[(($15)>>2)]=$__b;
      var $424=HEAP32[(($15)>>2)];
      var $425=(($424)|0);
      var $426=HEAP32[(($425)>>2)];
      var $427=$13;
      var $428=$14;
      HEAP32[(($14)>>2)]=$426;
      var $429=HEAP32[(($14)>>2)];
      var $430=(($429+12)|0);
      var $431=HEAP32[(($430)>>2)];
      var $432=(($429+16)|0);
      var $433=HEAP32[(($432)>>2)];
      var $434=(($431)|0)==(($433)|0);
      if ($434) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $435
      var $436=$429;
      var $437=HEAP32[(($436)>>2)];
      var $438=(($437+36)|0);
      var $439=HEAP32[(($438)>>2)];
      var $440=FUNCTION_TABLE[$439]($429);
      HEAP32[(($13)>>2)]=$440;
      __label__ = 59; break;
    case 58: // $441
      var $442=(($429+12)|0);
      var $443=HEAP32[(($442)>>2)];
      var $444=HEAP8[($443)];
      $12=$444;
      var $445=$12;
      var $446=(($445)&255);
      HEAP32[(($13)>>2)]=$446;
      __label__ = 59; break;
    case 59: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit3
      var $447=HEAP32[(($13)>>2)];
      var $448=$13;
      var $449=$14;
      var $450=(($447) & 255);
      var $451=$15;
      var $452=$23;
      HEAP32[(($23)>>2)]=$422;
      $24=$450;
      var $453=HEAP32[(($23)>>2)];
      var $454=$453;
      var $455=HEAP32[(($454)>>2)];
      var $456=(($455+12)|0);
      var $457=HEAP32[(($456)>>2)];
      var $458=$24;
      var $459=FUNCTION_TABLE[$457]($453, $458);
      var $460=$23;
      var $461=(($459 << 24) >> 24);
      var $462=$__ct;
      var $463=$70;
      var $464=HEAP8[($463)];
      var $465=$29;
      HEAP32[(($29)>>2)]=$462;
      $30=$464;
      var $466=HEAP32[(($29)>>2)];
      var $467=$466;
      var $468=HEAP32[(($467)>>2)];
      var $469=(($468+12)|0);
      var $470=HEAP32[(($469)>>2)];
      var $471=$30;
      var $472=FUNCTION_TABLE[$470]($466, $471);
      var $473=$29;
      var $474=(($472 << 24) >> 24);
      var $475=(($461)|0)==(($474)|0);
      if ($475) { __label__ = 60; break; } else { __label__ = 72; break; }
    case 60: // $476
      var $477=$56;
      HEAP32[(($56)>>2)]=$__b;
      var $478=HEAPU32[(($56)>>2)];
      var $479=(($478)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=$54;
      var $482=$55;
      HEAP32[(($55)>>2)]=$480;
      var $483=HEAPU32[(($55)>>2)];
      var $484=$52;
      var $485=$53;
      HEAP32[(($53)>>2)]=$483;
      var $486=HEAP32[(($53)>>2)];
      var $487=(($486+12)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=(($486+16)|0);
      var $490=HEAP32[(($489)>>2)];
      var $491=(($488)|0)==(($490)|0);
      if ($491) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $492
      var $493=$486;
      var $494=HEAP32[(($493)>>2)];
      var $495=(($494+40)|0);
      var $496=HEAP32[(($495)>>2)];
      var $497=FUNCTION_TABLE[$496]($486);
      HEAP32[(($52)>>2)]=$497;
      __label__ = 63; break;
    case 62: // $498
      var $499=(($486+12)|0);
      var $500=HEAP32[(($499)>>2)];
      var $501=(($500+1)|0);
      HEAP32[(($499)>>2)]=$501;
      var $502=HEAP8[($500)];
      $51=$502;
      var $503=$51;
      var $504=(($503)&255);
      HEAP32[(($52)>>2)]=$504;
      __label__ = 63; break;
    case 63: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $505=HEAP32[(($52)>>2)];
      var $506=$52;
      var $507=$53;
      var $508=(($505)|0)==-1;
      if ($508) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $509
      HEAP32[(($54)>>2)]=-1;
      __label__ = 69; break;
    case 65: // $510
      var $511=$49;
      var $512=$50;
      HEAP32[(($50)>>2)]=$483;
      var $513=HEAPU32[(($50)>>2)];
      var $514=(($513+12)|0);
      var $515=HEAP32[(($514)>>2)];
      var $516=(($513+16)|0);
      var $517=HEAP32[(($516)>>2)];
      var $518=(($515)|0)==(($517)|0);
      if ($518) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $519
      var $520=$513;
      var $521=HEAP32[(($520)>>2)];
      var $522=(($521+36)|0);
      var $523=HEAP32[(($522)>>2)];
      var $524=FUNCTION_TABLE[$523]($513);
      HEAP32[(($49)>>2)]=$524;
      __label__ = 68; break;
    case 67: // $525
      var $526=(($513+12)|0);
      var $527=HEAP32[(($526)>>2)];
      var $528=HEAP8[($527)];
      $48=$528;
      var $529=$48;
      var $530=(($529)&255);
      HEAP32[(($49)>>2)]=$530;
      __label__ = 68; break;
    case 68: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $531=HEAP32[(($49)>>2)];
      var $532=$49;
      var $533=$50;
      HEAP32[(($54)>>2)]=$531;
      __label__ = 69; break;
    case 69: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $534=HEAP32[(($54)>>2)];
      var $535=$54;
      var $536=$55;
      var $537=$46;
      var $538=$47;
      HEAP32[(($46)>>2)]=$534;
      HEAP32[(($47)>>2)]=-1;
      var $539=HEAP32[(($46)>>2)];
      var $540=HEAP32[(($47)>>2)];
      var $541=(($539)|0)==(($540)|0);
      var $542=$46;
      var $543=$47;
      if ($541) { __label__ = 70; break; } else { __label__ = 71; break; }
    case 70: // $544
      var $545=(($478)|0);
      HEAP32[(($545)>>2)]=0;
      __label__ = 71; break;
    case 71: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $546=$56;
      var $547=$70;
      var $548=(($547+1)|0);
      $70=$548;
      __label__ = 73; break;
    case 72: // $549
      var $550=$68;
      HEAP32[(($550)>>2)]=4;
      __label__ = 73; break;
    case 73: // $551
      __label__ = 74; break;
    case 74: // $552
      __label__ = 75; break;
    case 75: // $553
      __label__ = 3; break;
    case 76: // $554
      var $555=$59;
      var $556=$60;
      HEAP32[(($59)>>2)]=$__b;
      HEAP32[(($60)>>2)]=$__e;
      var $557=HEAP32[(($59)>>2)];
      var $558=HEAP32[(($60)>>2)];
      var $559=$57;
      var $560=$58;
      HEAP32[(($57)>>2)]=$557;
      HEAP32[(($58)>>2)]=$558;
      var $561=HEAP32[(($57)>>2)];
      var $562=(($561)|0);
      var $563=HEAP32[(($562)>>2)];
      var $564=(($563)|0)==0;
      var $565=(($564)&1);
      var $566=HEAP32[(($58)>>2)];
      var $567=(($566)|0);
      var $568=HEAP32[(($567)>>2)];
      var $569=(($568)|0)==0;
      var $570=(($569)&1);
      var $571=(($565)|0)==(($570)|0);
      var $572=$57;
      var $573=$58;
      var $574=$59;
      var $575=$60;
      if ($571) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $576
      var $577=$68;
      var $578=HEAP32[(($577)>>2)];
      var $579=$578 | 2;
      HEAP32[(($577)>>2)]=$579;
      __label__ = 78; break;
    case 78: // $580
      var $581=$agg_result;
      var $582=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($581)>>2)]=HEAP32[(($582)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 79: // $583
      var $584=$73;
      var $585=$73;
      var $586=$74;
      var $587=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $585, tempValue);
      var $588=($587.f1 = $586, $587);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 80: // $589
      var $590=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 2;
}


function ___cxx_global_var_init10276() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $6=__stackBase__+4;
  $1=$this;
  $2=$__iob;
  $3=$__err;
  $4=$__tm;
  var $7=$1;
  var $8=$5;
  var $9=$__b;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];
  var $10=$6;
  var $11=$__e;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[(($11)>>2)];
  var $12=$2;
  var $13=$3;
  var $14=$4;
  __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($agg_result, $7, $5, $6, $12, $13, $14, ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt)|0), ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt+8)|0));
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__w, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__wk;
      var $__i;
      var $6=__stackBase__;
      $1=$this;
      $2=$__w;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$7;
      var $9=(($8+8)|0);
      var $10=$9;
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=FUNCTION_TABLE[$14]($10);
      $__wk=$15;
      var $16=$3;
      var $17=$6;
      var $18=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];
      var $19=$__wk;
      var $20=$__wk;
      var $21=(($20+168)|0);
      var $22=$5;
      var $23=$4;
      var $24=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($16, $6, $19, $21, $22, $23, 0);
      var $25=$__wk;
      var $26=$24;
      var $27=$25;
      var $28=(($26-$27)|0);
      var $29=(((($28)|0)/12)|0);
      $__i=$29;
      var $30=$__i;
      var $31=(($30)|0) < 14;
      if ($31) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $32
      var $33=$__i;
      var $34=(($33)|0)%7;
      var $35=$2;
      HEAP32[(($35)>>2)]=$34;
      __label__ = 2; break;
    case 2: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__m, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__month;
      var $__i;
      var $6=__stackBase__;
      $1=$this;
      $2=$__m;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$7;
      var $9=(($8+8)|0);
      var $10=$9;
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=FUNCTION_TABLE[$14]($10);
      $__month=$15;
      var $16=$3;
      var $17=$6;
      var $18=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];
      var $19=$__month;
      var $20=$__month;
      var $21=(($20+288)|0);
      var $22=$5;
      var $23=$4;
      var $24=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($16, $6, $19, $21, $22, $23, 0);
      var $25=$__month;
      var $26=$24;
      var $27=$25;
      var $28=(($26-$27)|0);
      var $29=(((($28)|0)/12)|0);
      $__i=$29;
      var $30=$__i;
      var $31=(($30)|0) < 24;
      if ($31) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $32
      var $33=$__i;
      var $34=(($33)|0)%12;
      var $35=$2;
      HEAP32[(($35)>>2)]=$34;
      __label__ = 2; break;
    case 2: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__y, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__y;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 4);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 8; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) < 69;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=(($22+2000)|0);
      $__t=$23;
      __label__ = 7; break;
    case 3: // $24
      var $25=$__t;
      var $26=69 <= (($25)|0);
      if ($26) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $27
      var $28=$__t;
      var $29=(($28)|0) <= 99;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$__t;
      var $32=(($31+1900)|0);
      $__t=$32;
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$__t;
      var $36=(($35-1900)|0);
      var $37=$2;
      HEAP32[(($37)>>2)]=$36;
      __label__ = 8; break;
    case 8: // $38
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 144; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__ct;
      var $38=__stackBase__+132;
      var $39;
      var $40;
      var $__fmt;
      var $41=__stackBase__+136;
      var $42=__stackBase__+140;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__tm;
      var $43=$34;
      var $44=$35;
      __ZNKSt3__18ios_base6getlocEv($38, $44);
      var $45=$33;
      HEAP32[(($33)>>2)]=$38;
      var $46=HEAP32[(($33)>>2)];
      var $47=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($46, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 12; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $48=$47;
      var $49=$33;
      __label__ = 2; break;
    case 2: // $50
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($38);
      $__ct=$48;
      var $51=$43;
      var $52=(($51+8)|0);
      var $53=$52;
      var $54=$53;
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+20)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=FUNCTION_TABLE[$57]($53);
      $__fmt=$58;
      var $59=$41;
      var $60=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];
      var $61=$42;
      var $62=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($61)>>2)]=HEAP32[(($62)>>2)];
      var $63=$35;
      var $64=$36;
      var $65=$37;
      var $66=$__fmt;
      var $67=$32;
      HEAP32[(($32)>>2)]=$66;
      var $68=HEAP32[(($32)>>2)];
      var $69=$31;
      HEAP32[(($31)>>2)]=$68;
      var $70=HEAPU32[(($31)>>2)];
      var $71=$30;
      HEAP32[(($30)>>2)]=$70;
      var $72=HEAP32[(($30)>>2)];
      var $73=(($72)|0);
      var $74=$29;
      HEAP32[(($29)>>2)]=$73;
      var $75=HEAP32[(($29)>>2)];
      var $76=$75;
      var $77=$28;
      HEAP32[(($28)>>2)]=$76;
      var $78=HEAP32[(($28)>>2)];
      var $79=(($78)|0);
      var $80=$28;
      var $81=$29;
      var $82=(($79)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=$84;
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$87 & 1;
      var $89=(($88)|0)!=0;
      var $90=$30;
      if ($89) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $91
      var $92=$24;
      HEAP32[(($24)>>2)]=$70;
      var $93=HEAP32[(($24)>>2)];
      var $94=(($93)|0);
      var $95=$23;
      HEAP32[(($23)>>2)]=$94;
      var $96=HEAP32[(($23)>>2)];
      var $97=$96;
      var $98=$22;
      HEAP32[(($22)>>2)]=$97;
      var $99=HEAP32[(($22)>>2)];
      var $100=(($99)|0);
      var $101=$22;
      var $102=$23;
      var $103=(($100)|0);
      var $104=$103;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$24;
      var $125 = $106;__label__ = 5; break;
    case 4: // $108
      var $109=$27;
      HEAP32[(($27)>>2)]=$70;
      var $110=HEAP32[(($27)>>2)];
      var $111=(($110)|0);
      var $112=$26;
      HEAP32[(($26)>>2)]=$111;
      var $113=HEAP32[(($26)>>2)];
      var $114=$113;
      var $115=$25;
      HEAP32[(($25)>>2)]=$114;
      var $116=HEAP32[(($25)>>2)];
      var $117=(($116)|0);
      var $118=$25;
      var $119=$26;
      var $120=(($117)|0);
      var $121=$120;
      var $122=(($121+1)|0);
      var $123=(($122)|0);
      var $124=$27;
      var $125 = $123;__label__ = 5; break;
    case 5: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit
      var $125;
      var $126=$31;
      var $127=$32;
      var $128=$__fmt;
      var $129=$21;
      HEAP32[(($21)>>2)]=$128;
      var $130=HEAP32[(($21)>>2)];
      var $131=$20;
      HEAP32[(($20)>>2)]=$130;
      var $132=HEAPU32[(($20)>>2)];
      var $133=$19;
      HEAP32[(($19)>>2)]=$132;
      var $134=HEAP32[(($19)>>2)];
      var $135=(($134)|0);
      var $136=$18;
      HEAP32[(($18)>>2)]=$135;
      var $137=HEAP32[(($18)>>2)];
      var $138=$137;
      var $139=$17;
      HEAP32[(($17)>>2)]=$138;
      var $140=HEAP32[(($17)>>2)];
      var $141=(($140)|0);
      var $142=$17;
      var $143=$18;
      var $144=(($141)|0);
      var $145=$144;
      var $146=(($145)|0);
      var $147=$146;
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 & 1;
      var $151=(($150)|0)!=0;
      var $152=$19;
      if ($151) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $153
      var $154=$13;
      HEAP32[(($13)>>2)]=$132;
      var $155=HEAP32[(($13)>>2)];
      var $156=(($155)|0);
      var $157=$12;
      HEAP32[(($12)>>2)]=$156;
      var $158=HEAP32[(($12)>>2)];
      var $159=$158;
      var $160=$11;
      HEAP32[(($11)>>2)]=$159;
      var $161=HEAP32[(($11)>>2)];
      var $162=(($161)|0);
      var $163=$11;
      var $164=$12;
      var $165=(($162)|0);
      var $166=$165;
      var $167=(($166+8)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$13;
      var $187 = $168;__label__ = 8; break;
    case 7: // $170
      var $171=$16;
      HEAP32[(($16)>>2)]=$132;
      var $172=HEAP32[(($16)>>2)];
      var $173=(($172)|0);
      var $174=$15;
      HEAP32[(($15)>>2)]=$173;
      var $175=HEAP32[(($15)>>2)];
      var $176=$175;
      var $177=$14;
      HEAP32[(($14)>>2)]=$176;
      var $178=HEAP32[(($14)>>2)];
      var $179=(($178)|0);
      var $180=$14;
      var $181=$15;
      var $182=(($179)|0);
      var $183=$182;
      var $184=(($183+1)|0);
      var $185=(($184)|0);
      var $186=$16;
      var $187 = $185;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit1
      var $187;
      var $188=$20;
      var $189=$21;
      var $190=$__fmt;
      var $191=$10;
      HEAP32[(($10)>>2)]=$190;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 11; break;
    case 10: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 11; break;
    case 11: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($187+$250)|0);
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($agg_result, $43, $41, $42, $63, $64, $65, $125, $252);
      STACKTOP = __stackBase__;
      return;
    case 12: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $255=$254.f0;
      $39=$255;
      var $256=$254.f1;
      $40=$256;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $257
      __label__ = 14; break;
    case 14: // $258
      var $259=$39;
      var $260=$39;
      var $261=$40;
      var $262=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $260, tempValue);
      var $263=($262.f1 = $261, $262);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $264
      var $265=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__ct;
      var $6=__stackBase__+4;
      var $7;
      var $8;
      var $9=__stackBase__+8;
      $2=$this;
      $3=$__iob;
      $4=$__err;
      $5=$__tm;
      var $10=$2;
      var $11=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $11);
      var $12=$1;
      HEAP32[(($1)>>2)]=$6;
      var $13=HEAP32[(($1)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $15=$14;
      var $16=$1;
      __label__ = 2; break;
    case 2: // $17
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      $__ct=$15;
      var $18=$5;
      var $19=(($18+24)|0);
      var $20=$9;
      var $21=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];
      var $22=$4;
      var $23=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE($10, $19, $__b, $9, $22, $23);
      var $24=$agg_result;
      var $25=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $7=$28;
      var $29=$27.f1;
      $8=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$7;
      var $33=$7;
      var $34=$8;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__ct;
      var $6=__stackBase__+4;
      var $7;
      var $8;
      var $9=__stackBase__+8;
      $2=$this;
      $3=$__iob;
      $4=$__err;
      $5=$__tm;
      var $10=$2;
      var $11=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $11);
      var $12=$1;
      HEAP32[(($1)>>2)]=$6;
      var $13=HEAP32[(($1)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $15=$14;
      var $16=$1;
      __label__ = 2; break;
    case 2: // $17
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      $__ct=$15;
      var $18=$5;
      var $19=(($18+16)|0);
      var $20=$9;
      var $21=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];
      var $22=$4;
      var $23=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE($10, $19, $__b, $9, $22, $23);
      var $24=$agg_result;
      var $25=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $7=$28;
      var $29=$27.f1;
      $8=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$7;
      var $33=$7;
      var $34=$8;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__ct;
      var $6=__stackBase__+4;
      var $7;
      var $8;
      var $9=__stackBase__+8;
      $2=$this;
      $3=$__iob;
      $4=$__err;
      $5=$__tm;
      var $10=$2;
      var $11=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $11);
      var $12=$1;
      HEAP32[(($1)>>2)]=$6;
      var $13=HEAP32[(($1)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $15=$14;
      var $16=$1;
      __label__ = 2; break;
    case 2: // $17
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      $__ct=$15;
      var $18=$5;
      var $19=(($18+20)|0);
      var $20=$9;
      var $21=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];
      var $22=$4;
      var $23=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE($10, $19, $__b, $9, $22, $23);
      var $24=$agg_result;
      var $25=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $7=$28;
      var $29=$27.f1;
      $8=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$7;
      var $33=$7;
      var $34=$8;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm, $__fmt, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 416; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $18=__stackBase__+64;
      var $19=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      var $25=__stackBase__+92;
      var $26=__stackBase__+96;
      var $27=__stackBase__+100;
      var $28=__stackBase__+104;
      var $29=__stackBase__+108;
      var $30=__stackBase__+112;
      var $31=__stackBase__+116;
      var $32=__stackBase__+120;
      var $33=__stackBase__+124;
      var $34=__stackBase__+128;
      var $35=__stackBase__+132;
      var $36=__stackBase__+136;
      var $37=__stackBase__+140;
      var $38=__stackBase__+144;
      var $39=__stackBase__+148;
      var $40=__stackBase__+152;
      var $41=__stackBase__+156;
      var $42=__stackBase__+160;
      var $43=__stackBase__+164;
      var $44=__stackBase__+168;
      var $45=__stackBase__+172;
      var $46=__stackBase__+176;
      var $47=__stackBase__+180;
      var $48=__stackBase__+184;
      var $49=__stackBase__+188;
      var $50=__stackBase__+192;
      var $51=__stackBase__+196;
      var $52=__stackBase__+200;
      var $53=__stackBase__+204;
      var $54=__stackBase__+208;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $57=__stackBase__+220;
      var $58=__stackBase__+224;
      var $59=__stackBase__+228;
      var $60=__stackBase__+232;
      var $61=__stackBase__+236;
      var $62=__stackBase__+240;
      var $63=__stackBase__+244;
      var $64=__stackBase__+248;
      var $65=__stackBase__+252;
      var $66=__stackBase__+256;
      var $67;
      var $68;
      var $69;
      var $70;
      var $71;
      var $72;
      var $__ct;
      var $73=__stackBase__+260;
      var $74;
      var $75;
      var $76=__stackBase__+264;
      var $77=__stackBase__+268;
      var $__fmt1;
      var $78=__stackBase__+272;
      var $79=__stackBase__+276;
      var $80=__stackBase__+280;
      var $81=__stackBase__+284;
      var $82=__stackBase__+288;
      var $83=__stackBase__+292;
      var $84=__stackBase__+296;
      var $85=__stackBase__+300;
      var $86=__stackBase__+304;
      var $87=__stackBase__+308;
      var $88=__stackBase__+312;
      var $89=__stackBase__+316;
      var $90=__stackBase__+320;
      var $91=__stackBase__+324;
      var $92=__stackBase__+328;
      var $93=__stackBase__+332;
      var $94=__stackBase__+336;
      var $95=__stackBase__+340;
      var $96=__stackBase__+344;
      var $97=__stackBase__+348;
      var $98=__stackBase__+352;
      var $99=__stackBase__+356;
      var $100=__stackBase__+360;
      var $101=__stackBase__+364;
      var $102=__stackBase__+368;
      var $103=__stackBase__+372;
      var $104=__stackBase__+376;
      var $105=__stackBase__+380;
      var $106=__stackBase__+384;
      var $107=__stackBase__+388;
      var $__fmt2;
      var $108=__stackBase__+392;
      var $109=__stackBase__+396;
      var $110=__stackBase__+400;
      var $111=__stackBase__+404;
      var $112=__stackBase__+408;
      var $113=__stackBase__+412;
      $67=$this;
      $68=$__iob;
      $69=$__err;
      $70=$__tm;
      $71=$__fmt;
      $72=$0;
      var $114=$67;
      var $115=$69;
      HEAP32[(($115)>>2)]=0;
      var $116=$68;
      __ZNKSt3__18ios_base6getlocEv($73, $116);
      var $117=$66;
      HEAP32[(($66)>>2)]=$73;
      var $118=HEAP32[(($66)>>2)];
      var $119=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($118, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $120=$119;
      var $121=$66;
      __label__ = 2; break;
    case 2: // $122
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($73);
      $__ct=$120;
      var $123=$71;
      var $124=(($123 << 24) >> 24);
      if ($124 == 97 || $124 == 65) {
        __label__ = 5; break;
      }
      else if ($124 == 98 || $124 == 66 || $124 == 104) {
        __label__ = 6; break;
      }
      else if ($124 == 99) {
        __label__ = 7; break;
      }
      else if ($124 == 100 || $124 == 101) {
        __label__ = 17; break;
      }
      else if ($124 == 68) {
        __label__ = 18; break;
      }
      else if ($124 == 70) {
        __label__ = 19; break;
      }
      else if ($124 == 72) {
        __label__ = 20; break;
      }
      else if ($124 == 73) {
        __label__ = 21; break;
      }
      else if ($124 == 106) {
        __label__ = 22; break;
      }
      else if ($124 == 109) {
        __label__ = 23; break;
      }
      else if ($124 == 77) {
        __label__ = 24; break;
      }
      else if ($124 == 110 || $124 == 116) {
        __label__ = 25; break;
      }
      else if ($124 == 112) {
        __label__ = 26; break;
      }
      else if ($124 == 114) {
        __label__ = 27; break;
      }
      else if ($124 == 82) {
        __label__ = 28; break;
      }
      else if ($124 == 83) {
        __label__ = 29; break;
      }
      else if ($124 == 84) {
        __label__ = 30; break;
      }
      else if ($124 == 119) {
        __label__ = 31; break;
      }
      else if ($124 == 120) {
        __label__ = 32; break;
      }
      else if ($124 == 88) {
        __label__ = 33; break;
      }
      else if ($124 == 121) {
        __label__ = 43; break;
      }
      else if ($124 == 89) {
        __label__ = 44; break;
      }
      else if ($124 == 37) {
        __label__ = 45; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 3: // $125
      var $126=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $127=$126.f0;
      $74=$127;
      var $128=$126.f1;
      $75=$128;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 50; break; }
    case 4: // $129
      __label__ = 49; break;
    case 5: // $130
      var $131=$70;
      var $132=(($131+24)|0);
      var $133=$76;
      var $134=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($133)>>2)]=HEAP32[(($134)>>2)];
      var $135=$69;
      var $136=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE($114, $132, $__b, $76, $135, $136);
      __label__ = 47; break;
    case 6: // $137
      var $138=$70;
      var $139=(($138+16)|0);
      var $140=$77;
      var $141=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($140)>>2)]=HEAP32[(($141)>>2)];
      var $142=$69;
      var $143=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE($114, $139, $__b, $77, $142, $143);
      __label__ = 47; break;
    case 7: // $144
      var $145=$114;
      var $146=(($145+8)|0);
      var $147=$146;
      var $148=$147;
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+12)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=FUNCTION_TABLE[$151]($147);
      $__fmt1=$152;
      var $153=$79;
      var $154=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($153)>>2)]=HEAP32[(($154)>>2)];
      var $155=$80;
      var $156=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($155)>>2)]=HEAP32[(($156)>>2)];
      var $157=$68;
      var $158=$69;
      var $159=$70;
      var $160=$__fmt1;
      var $161=$65;
      HEAP32[(($65)>>2)]=$160;
      var $162=HEAP32[(($65)>>2)];
      var $163=$64;
      HEAP32[(($64)>>2)]=$162;
      var $164=HEAPU32[(($64)>>2)];
      var $165=$63;
      HEAP32[(($63)>>2)]=$164;
      var $166=HEAP32[(($63)>>2)];
      var $167=(($166)|0);
      var $168=$62;
      HEAP32[(($62)>>2)]=$167;
      var $169=HEAP32[(($62)>>2)];
      var $170=$169;
      var $171=$61;
      HEAP32[(($61)>>2)]=$170;
      var $172=HEAP32[(($61)>>2)];
      var $173=(($172)|0);
      var $174=$61;
      var $175=$62;
      var $176=(($173)|0);
      var $177=$176;
      var $178=(($177)|0);
      var $179=$178;
      var $180=HEAPU8[($179)];
      var $181=(($180)&255);
      var $182=$181 & 1;
      var $183=(($182)|0)!=0;
      var $184=$63;
      if ($183) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $185
      var $186=$57;
      HEAP32[(($57)>>2)]=$164;
      var $187=HEAP32[(($57)>>2)];
      var $188=(($187)|0);
      var $189=$56;
      HEAP32[(($56)>>2)]=$188;
      var $190=HEAP32[(($56)>>2)];
      var $191=$190;
      var $192=$55;
      HEAP32[(($55)>>2)]=$191;
      var $193=HEAP32[(($55)>>2)];
      var $194=(($193)|0);
      var $195=$55;
      var $196=$56;
      var $197=(($194)|0);
      var $198=$197;
      var $199=(($198+8)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=$57;
      var $219 = $200;__label__ = 10; break;
    case 9: // $202
      var $203=$60;
      HEAP32[(($60)>>2)]=$164;
      var $204=HEAP32[(($60)>>2)];
      var $205=(($204)|0);
      var $206=$59;
      HEAP32[(($59)>>2)]=$205;
      var $207=HEAP32[(($59)>>2)];
      var $208=$207;
      var $209=$58;
      HEAP32[(($58)>>2)]=$208;
      var $210=HEAP32[(($58)>>2)];
      var $211=(($210)|0);
      var $212=$58;
      var $213=$59;
      var $214=(($211)|0);
      var $215=$214;
      var $216=(($215+1)|0);
      var $217=(($216)|0);
      var $218=$60;
      var $219 = $217;__label__ = 10; break;
    case 10: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit
      var $219;
      var $220=$64;
      var $221=$65;
      var $222=$__fmt1;
      var $223=$54;
      HEAP32[(($54)>>2)]=$222;
      var $224=HEAP32[(($54)>>2)];
      var $225=$53;
      HEAP32[(($53)>>2)]=$224;
      var $226=HEAPU32[(($53)>>2)];
      var $227=$52;
      HEAP32[(($52)>>2)]=$226;
      var $228=HEAP32[(($52)>>2)];
      var $229=(($228)|0);
      var $230=$51;
      HEAP32[(($51)>>2)]=$229;
      var $231=HEAP32[(($51)>>2)];
      var $232=$231;
      var $233=$50;
      HEAP32[(($50)>>2)]=$232;
      var $234=HEAP32[(($50)>>2)];
      var $235=(($234)|0);
      var $236=$50;
      var $237=$51;
      var $238=(($235)|0);
      var $239=$238;
      var $240=(($239)|0);
      var $241=$240;
      var $242=HEAPU8[($241)];
      var $243=(($242)&255);
      var $244=$243 & 1;
      var $245=(($244)|0)!=0;
      var $246=$52;
      if ($245) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $247
      var $248=$46;
      HEAP32[(($46)>>2)]=$226;
      var $249=HEAP32[(($46)>>2)];
      var $250=(($249)|0);
      var $251=$45;
      HEAP32[(($45)>>2)]=$250;
      var $252=HEAP32[(($45)>>2)];
      var $253=$252;
      var $254=$44;
      HEAP32[(($44)>>2)]=$253;
      var $255=HEAP32[(($44)>>2)];
      var $256=(($255)|0);
      var $257=$44;
      var $258=$45;
      var $259=(($256)|0);
      var $260=$259;
      var $261=(($260+8)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$46;
      var $281 = $262;__label__ = 13; break;
    case 12: // $264
      var $265=$49;
      HEAP32[(($49)>>2)]=$226;
      var $266=HEAP32[(($49)>>2)];
      var $267=(($266)|0);
      var $268=$48;
      HEAP32[(($48)>>2)]=$267;
      var $269=HEAP32[(($48)>>2)];
      var $270=$269;
      var $271=$47;
      HEAP32[(($47)>>2)]=$270;
      var $272=HEAP32[(($47)>>2)];
      var $273=(($272)|0);
      var $274=$47;
      var $275=$48;
      var $276=(($273)|0);
      var $277=$276;
      var $278=(($277+1)|0);
      var $279=(($278)|0);
      var $280=$49;
      var $281 = $279;__label__ = 13; break;
    case 13: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit3
      var $281;
      var $282=$53;
      var $283=$54;
      var $284=$__fmt1;
      var $285=$43;
      HEAP32[(($43)>>2)]=$284;
      var $286=HEAPU32[(($43)>>2)];
      var $287=$42;
      HEAP32[(($42)>>2)]=$286;
      var $288=HEAP32[(($42)>>2)];
      var $289=(($288)|0);
      var $290=$41;
      HEAP32[(($41)>>2)]=$289;
      var $291=HEAP32[(($41)>>2)];
      var $292=$291;
      var $293=$40;
      HEAP32[(($40)>>2)]=$292;
      var $294=HEAP32[(($40)>>2)];
      var $295=(($294)|0);
      var $296=$40;
      var $297=$41;
      var $298=(($295)|0);
      var $299=$298;
      var $300=(($299)|0);
      var $301=$300;
      var $302=HEAPU8[($301)];
      var $303=(($302)&255);
      var $304=$303 & 1;
      var $305=(($304)|0)!=0;
      var $306=$42;
      if ($305) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $307
      var $308=$36;
      HEAP32[(($36)>>2)]=$286;
      var $309=HEAP32[(($36)>>2)];
      var $310=(($309)|0);
      var $311=$35;
      HEAP32[(($35)>>2)]=$310;
      var $312=HEAP32[(($35)>>2)];
      var $313=$312;
      var $314=$34;
      HEAP32[(($34)>>2)]=$313;
      var $315=HEAP32[(($34)>>2)];
      var $316=(($315)|0);
      var $317=$34;
      var $318=$35;
      var $319=(($316)|0);
      var $320=$319;
      var $321=(($320+4)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=$36;
      var $344 = $322;__label__ = 16; break;
    case 15: // $324
      var $325=$39;
      HEAP32[(($39)>>2)]=$286;
      var $326=HEAP32[(($39)>>2)];
      var $327=(($326)|0);
      var $328=$38;
      HEAP32[(($38)>>2)]=$327;
      var $329=HEAP32[(($38)>>2)];
      var $330=$329;
      var $331=$37;
      HEAP32[(($37)>>2)]=$330;
      var $332=HEAP32[(($37)>>2)];
      var $333=(($332)|0);
      var $334=$37;
      var $335=$38;
      var $336=(($333)|0);
      var $337=$336;
      var $338=(($337)|0);
      var $339=$338;
      var $340=HEAPU8[($339)];
      var $341=(($340)&255);
      var $342=$341 >> 1;
      var $343=$39;
      var $344 = $342;__label__ = 16; break;
    case 16: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $344;
      var $345=$43;
      var $346=(($281+$344)|0);
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($78, $114, $79, $80, $157, $158, $159, $219, $346);
      var $347=$__b;
      var $348=$78;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($347)>>2)]=HEAP32[(($348)>>2)];
      __label__ = 47; break;
    case 17: // $349
      var $350=$70;
      var $351=(($350+12)|0);
      var $352=$81;
      var $353=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($352)>>2)]=HEAP32[(($353)>>2)];
      var $354=$69;
      var $355=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE($114, $351, $__b, $81, $354, $355);
      __label__ = 47; break;
    case 18: // $356
      var $357=$83;
      var $358=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($357)>>2)]=HEAP32[(($358)>>2)];
      var $359=$84;
      var $360=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($359)>>2)]=HEAP32[(($360)>>2)];
      var $361=$68;
      var $362=$69;
      var $363=$70;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($82, $114, $83, $84, $361, $362, $363, ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt)|0), ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt+8)|0));
      var $364=$__b;
      var $365=$82;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($364)>>2)]=HEAP32[(($365)>>2)];
      __label__ = 47; break;
    case 19: // $366
      var $367=$86;
      var $368=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($367)>>2)]=HEAP32[(($368)>>2)];
      var $369=$87;
      var $370=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($369)>>2)]=HEAP32[(($370)>>2)];
      var $371=$68;
      var $372=$69;
      var $373=$70;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($85, $114, $86, $87, $371, $372, $373, ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt11)|0), ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt11+8)|0));
      var $374=$__b;
      var $375=$85;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($374)>>2)]=HEAP32[(($375)>>2)];
      __label__ = 47; break;
    case 20: // $376
      var $377=$70;
      var $378=(($377+8)|0);
      var $379=$88;
      var $380=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($379)>>2)]=HEAP32[(($380)>>2)];
      var $381=$69;
      var $382=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE($114, $378, $__b, $88, $381, $382);
      __label__ = 47; break;
    case 21: // $383
      var $384=$70;
      var $385=(($384+8)|0);
      var $386=$89;
      var $387=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($386)>>2)]=HEAP32[(($387)>>2)];
      var $388=$69;
      var $389=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE($114, $385, $__b, $89, $388, $389);
      __label__ = 47; break;
    case 22: // $390
      var $391=$70;
      var $392=(($391+28)|0);
      var $393=$90;
      var $394=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($393)>>2)]=HEAP32[(($394)>>2)];
      var $395=$69;
      var $396=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE($114, $392, $__b, $90, $395, $396);
      __label__ = 47; break;
    case 23: // $397
      var $398=$70;
      var $399=(($398+16)|0);
      var $400=$91;
      var $401=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($400)>>2)]=HEAP32[(($401)>>2)];
      var $402=$69;
      var $403=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE($114, $399, $__b, $91, $402, $403);
      __label__ = 47; break;
    case 24: // $404
      var $405=$70;
      var $406=(($405+4)|0);
      var $407=$92;
      var $408=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($407)>>2)]=HEAP32[(($408)>>2)];
      var $409=$69;
      var $410=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE($114, $406, $__b, $92, $409, $410);
      __label__ = 47; break;
    case 25: // $411
      var $412=$93;
      var $413=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($412)>>2)]=HEAP32[(($413)>>2)];
      var $414=$69;
      var $415=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE($114, $__b, $93, $414, $415);
      __label__ = 47; break;
    case 26: // $416
      var $417=$70;
      var $418=(($417+8)|0);
      var $419=$94;
      var $420=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($419)>>2)]=HEAP32[(($420)>>2)];
      var $421=$69;
      var $422=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE($114, $418, $__b, $94, $421, $422);
      __label__ = 47; break;
    case 27: // $423
      var $424=$96;
      var $425=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($424)>>2)]=HEAP32[(($425)>>2)];
      var $426=$97;
      var $427=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($426)>>2)]=HEAP32[(($427)>>2)];
      var $428=$68;
      var $429=$69;
      var $430=$70;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($95, $114, $96, $97, $428, $429, $430, ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt12)|0), ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt12+11)|0));
      var $431=$__b;
      var $432=$95;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($431)>>2)]=HEAP32[(($432)>>2)];
      __label__ = 47; break;
    case 28: // $433
      var $434=$99;
      var $435=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($434)>>2)]=HEAP32[(($435)>>2)];
      var $436=$100;
      var $437=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($436)>>2)]=HEAP32[(($437)>>2)];
      var $438=$68;
      var $439=$69;
      var $440=$70;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($98, $114, $99, $100, $438, $439, $440, ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt13)|0), ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt13+5)|0));
      var $441=$__b;
      var $442=$98;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($441)>>2)]=HEAP32[(($442)>>2)];
      __label__ = 47; break;
    case 29: // $443
      var $444=$70;
      var $445=(($444)|0);
      var $446=$101;
      var $447=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($446)>>2)]=HEAP32[(($447)>>2)];
      var $448=$69;
      var $449=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE($114, $445, $__b, $101, $448, $449);
      __label__ = 47; break;
    case 30: // $450
      var $451=$103;
      var $452=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($451)>>2)]=HEAP32[(($452)>>2)];
      var $453=$104;
      var $454=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($453)>>2)]=HEAP32[(($454)>>2)];
      var $455=$68;
      var $456=$69;
      var $457=$70;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($102, $114, $103, $104, $455, $456, $457, ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt14)|0), ((STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt14+8)|0));
      var $458=$__b;
      var $459=$102;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($458)>>2)]=HEAP32[(($459)>>2)];
      __label__ = 47; break;
    case 31: // $460
      var $461=$70;
      var $462=(($461+24)|0);
      var $463=$105;
      var $464=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($463)>>2)]=HEAP32[(($464)>>2)];
      var $465=$69;
      var $466=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE($114, $462, $__b, $105, $465, $466);
      __label__ = 47; break;
    case 32: // $467
      var $468=$114;
      var $469=HEAP32[(($468)>>2)];
      var $470=(($469+20)|0);
      var $471=HEAP32[(($470)>>2)];
      var $472=$106;
      var $473=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($472)>>2)]=HEAP32[(($473)>>2)];
      var $474=$107;
      var $475=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($474)>>2)]=HEAP32[(($475)>>2)];
      var $476=$68;
      var $477=$69;
      var $478=$70;
      FUNCTION_TABLE[$471]($agg_result, $114, $106, $107, $476, $477, $478);
      __label__ = 48; break;
    case 33: // $479
      var $480=$114;
      var $481=(($480+8)|0);
      var $482=$481;
      var $483=$482;
      var $484=HEAP32[(($483)>>2)];
      var $485=(($484+24)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=FUNCTION_TABLE[$486]($482);
      $__fmt2=$487;
      var $488=$109;
      var $489=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($488)>>2)]=HEAP32[(($489)>>2)];
      var $490=$110;
      var $491=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($490)>>2)]=HEAP32[(($491)>>2)];
      var $492=$68;
      var $493=$69;
      var $494=$70;
      var $495=$__fmt2;
      var $496=$33;
      HEAP32[(($33)>>2)]=$495;
      var $497=HEAP32[(($33)>>2)];
      var $498=$32;
      HEAP32[(($32)>>2)]=$497;
      var $499=HEAPU32[(($32)>>2)];
      var $500=$31;
      HEAP32[(($31)>>2)]=$499;
      var $501=HEAP32[(($31)>>2)];
      var $502=(($501)|0);
      var $503=$30;
      HEAP32[(($30)>>2)]=$502;
      var $504=HEAP32[(($30)>>2)];
      var $505=$504;
      var $506=$29;
      HEAP32[(($29)>>2)]=$505;
      var $507=HEAP32[(($29)>>2)];
      var $508=(($507)|0);
      var $509=$29;
      var $510=$30;
      var $511=(($508)|0);
      var $512=$511;
      var $513=(($512)|0);
      var $514=$513;
      var $515=HEAPU8[($514)];
      var $516=(($515)&255);
      var $517=$516 & 1;
      var $518=(($517)|0)!=0;
      var $519=$31;
      if ($518) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $520
      var $521=$25;
      HEAP32[(($25)>>2)]=$499;
      var $522=HEAP32[(($25)>>2)];
      var $523=(($522)|0);
      var $524=$24;
      HEAP32[(($24)>>2)]=$523;
      var $525=HEAP32[(($24)>>2)];
      var $526=$525;
      var $527=$23;
      HEAP32[(($23)>>2)]=$526;
      var $528=HEAP32[(($23)>>2)];
      var $529=(($528)|0);
      var $530=$23;
      var $531=$24;
      var $532=(($529)|0);
      var $533=$532;
      var $534=(($533+8)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$25;
      var $554 = $535;__label__ = 36; break;
    case 35: // $537
      var $538=$28;
      HEAP32[(($28)>>2)]=$499;
      var $539=HEAP32[(($28)>>2)];
      var $540=(($539)|0);
      var $541=$27;
      HEAP32[(($27)>>2)]=$540;
      var $542=HEAP32[(($27)>>2)];
      var $543=$542;
      var $544=$26;
      HEAP32[(($26)>>2)]=$543;
      var $545=HEAP32[(($26)>>2)];
      var $546=(($545)|0);
      var $547=$26;
      var $548=$27;
      var $549=(($546)|0);
      var $550=$549;
      var $551=(($550+1)|0);
      var $552=(($551)|0);
      var $553=$28;
      var $554 = $552;__label__ = 36; break;
    case 36: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit4
      var $554;
      var $555=$32;
      var $556=$33;
      var $557=$__fmt2;
      var $558=$22;
      HEAP32[(($22)>>2)]=$557;
      var $559=HEAP32[(($22)>>2)];
      var $560=$21;
      HEAP32[(($21)>>2)]=$559;
      var $561=HEAPU32[(($21)>>2)];
      var $562=$20;
      HEAP32[(($20)>>2)]=$561;
      var $563=HEAP32[(($20)>>2)];
      var $564=(($563)|0);
      var $565=$19;
      HEAP32[(($19)>>2)]=$564;
      var $566=HEAP32[(($19)>>2)];
      var $567=$566;
      var $568=$18;
      HEAP32[(($18)>>2)]=$567;
      var $569=HEAP32[(($18)>>2)];
      var $570=(($569)|0);
      var $571=$18;
      var $572=$19;
      var $573=(($570)|0);
      var $574=$573;
      var $575=(($574)|0);
      var $576=$575;
      var $577=HEAPU8[($576)];
      var $578=(($577)&255);
      var $579=$578 & 1;
      var $580=(($579)|0)!=0;
      var $581=$20;
      if ($580) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $582
      var $583=$14;
      HEAP32[(($14)>>2)]=$561;
      var $584=HEAP32[(($14)>>2)];
      var $585=(($584)|0);
      var $586=$13;
      HEAP32[(($13)>>2)]=$585;
      var $587=HEAP32[(($13)>>2)];
      var $588=$587;
      var $589=$12;
      HEAP32[(($12)>>2)]=$588;
      var $590=HEAP32[(($12)>>2)];
      var $591=(($590)|0);
      var $592=$12;
      var $593=$13;
      var $594=(($591)|0);
      var $595=$594;
      var $596=(($595+8)|0);
      var $597=HEAP32[(($596)>>2)];
      var $598=$14;
      var $616 = $597;__label__ = 39; break;
    case 38: // $599
      var $600=$17;
      HEAP32[(($17)>>2)]=$561;
      var $601=HEAP32[(($17)>>2)];
      var $602=(($601)|0);
      var $603=$16;
      HEAP32[(($16)>>2)]=$602;
      var $604=HEAP32[(($16)>>2)];
      var $605=$604;
      var $606=$15;
      HEAP32[(($15)>>2)]=$605;
      var $607=HEAP32[(($15)>>2)];
      var $608=(($607)|0);
      var $609=$15;
      var $610=$16;
      var $611=(($608)|0);
      var $612=$611;
      var $613=(($612+1)|0);
      var $614=(($613)|0);
      var $615=$17;
      var $616 = $614;__label__ = 39; break;
    case 39: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit5
      var $616;
      var $617=$21;
      var $618=$22;
      var $619=$__fmt2;
      var $620=$11;
      HEAP32[(($11)>>2)]=$619;
      var $621=HEAPU32[(($11)>>2)];
      var $622=$10;
      HEAP32[(($10)>>2)]=$621;
      var $623=HEAP32[(($10)>>2)];
      var $624=(($623)|0);
      var $625=$9;
      HEAP32[(($9)>>2)]=$624;
      var $626=HEAP32[(($9)>>2)];
      var $627=$626;
      var $628=$8;
      HEAP32[(($8)>>2)]=$627;
      var $629=HEAP32[(($8)>>2)];
      var $630=(($629)|0);
      var $631=$8;
      var $632=$9;
      var $633=(($630)|0);
      var $634=$633;
      var $635=(($634)|0);
      var $636=$635;
      var $637=HEAPU8[($636)];
      var $638=(($637)&255);
      var $639=$638 & 1;
      var $640=(($639)|0)!=0;
      var $641=$10;
      if ($640) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $642
      var $643=$4;
      HEAP32[(($4)>>2)]=$621;
      var $644=HEAP32[(($4)>>2)];
      var $645=(($644)|0);
      var $646=$3;
      HEAP32[(($3)>>2)]=$645;
      var $647=HEAP32[(($3)>>2)];
      var $648=$647;
      var $649=$2;
      HEAP32[(($2)>>2)]=$648;
      var $650=HEAP32[(($2)>>2)];
      var $651=(($650)|0);
      var $652=$2;
      var $653=$3;
      var $654=(($651)|0);
      var $655=$654;
      var $656=(($655+4)|0);
      var $657=HEAP32[(($656)>>2)];
      var $658=$4;
      var $679 = $657;__label__ = 42; break;
    case 41: // $659
      var $660=$7;
      HEAP32[(($7)>>2)]=$621;
      var $661=HEAP32[(($7)>>2)];
      var $662=(($661)|0);
      var $663=$6;
      HEAP32[(($6)>>2)]=$662;
      var $664=HEAP32[(($6)>>2)];
      var $665=$664;
      var $666=$5;
      HEAP32[(($5)>>2)]=$665;
      var $667=HEAP32[(($5)>>2)];
      var $668=(($667)|0);
      var $669=$5;
      var $670=$6;
      var $671=(($668)|0);
      var $672=$671;
      var $673=(($672)|0);
      var $674=$673;
      var $675=HEAPU8[($674)];
      var $676=(($675)&255);
      var $677=$676 >> 1;
      var $678=$7;
      var $679 = $677;__label__ = 42; break;
    case 42: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit6
      var $679;
      var $680=$11;
      var $681=(($616+$679)|0);
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_($108, $114, $109, $110, $492, $493, $494, $554, $681);
      var $682=$__b;
      var $683=$108;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($682)>>2)]=HEAP32[(($683)>>2)];
      __label__ = 47; break;
    case 43: // $684
      var $685=$70;
      var $686=(($685+20)|0);
      var $687=$111;
      var $688=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($687)>>2)]=HEAP32[(($688)>>2)];
      var $689=$69;
      var $690=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE($114, $686, $__b, $111, $689, $690);
      __label__ = 47; break;
    case 44: // $691
      var $692=$70;
      var $693=(($692+20)|0);
      var $694=$112;
      var $695=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($694)>>2)]=HEAP32[(($695)>>2)];
      var $696=$69;
      var $697=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE($114, $693, $__b, $112, $696, $697);
      __label__ = 47; break;
    case 45: // $698
      var $699=$113;
      var $700=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($699)>>2)]=HEAP32[(($700)>>2)];
      var $701=$69;
      var $702=$__ct;
      __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE($114, $__b, $113, $701, $702);
      __label__ = 47; break;
    case 46: // $703
      var $704=$69;
      var $705=HEAP32[(($704)>>2)];
      var $706=$705 | 4;
      HEAP32[(($704)>>2)]=$706;
      __label__ = 47; break;
    case 47: // $707
      var $708=$agg_result;
      var $709=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($708)>>2)]=HEAP32[(($709)>>2)];
      __label__ = 48; break;
    case 48: // $710
      STACKTOP = __stackBase__;
      return;
    case 49: // $711
      var $712=$74;
      var $713=$74;
      var $714=$75;
      var $715=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $713, tempValue);
      var $716=($715.f1 = $714, $715);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $717
      var $718=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__d, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__d;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=1 <= (($19)|0);
      if ($20) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $22=$__t;
      var $23=(($22)|0) <= 31;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$__t;
      var $26=$2;
      HEAP32[(($26)>>2)]=$25;
      __label__ = 5; break;
    case 4: // $27
      var $28=$4;
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 | 4;
      HEAP32[(($28)>>2)]=$30;
      __label__ = 5; break;
    case 5: // $31
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__h, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__h;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 23;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__h, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__h;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=1 <= (($19)|0);
      if ($20) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $22=$__t;
      var $23=(($22)|0) <= 12;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$__t;
      var $26=$2;
      HEAP32[(($26)>>2)]=$25;
      __label__ = 5; break;
    case 4: // $27
      var $28=$4;
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 | 4;
      HEAP32[(($28)>>2)]=$30;
      __label__ = 5; break;
    case 5: // $31
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__d, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__d;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 3);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 365;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__m, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__m;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      var $14=(($13-1)|0);
      $__t=$14;
      var $15=$4;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 4;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $19
      var $20=$__t;
      var $21=(($20)|0) <= 11;
      if ($21) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $22
      var $23=$__t;
      var $24=$2;
      HEAP32[(($24)>>2)]=$23;
      __label__ = 4; break;
    case 3: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=$27 | 4;
      HEAP32[(($26)>>2)]=$28;
      __label__ = 4; break;
    case 4: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__m, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__m;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 59;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE($this, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 88; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5=__stackBase__+8;
      var $6=__stackBase__+12;
      var $7=__stackBase__+16;
      var $8=__stackBase__+20;
      var $9=__stackBase__+24;
      var $10;
      var $11=__stackBase__+28;
      var $12=__stackBase__+32;
      var $13;
      var $14=__stackBase__+36;
      var $15=__stackBase__+40;
      var $16=__stackBase__+44;
      var $17=__stackBase__+48;
      var $18=__stackBase__+52;
      var $19=__stackBase__+56;
      var $20=__stackBase__+60;
      var $21=__stackBase__+64;
      var $22=__stackBase__+68;
      var $23=__stackBase__+72;
      var $24=__stackBase__+76;
      var $25=__stackBase__+80;
      var $26=__stackBase__+84;
      var $27;
      var $28;
      var $29;
      var $30;
      $27=$this;
      $28=$__b;
      $29=$__err;
      $30=$__ct;
      var $31=$27;
      __label__ = 1; break;
    case 1: // $32
      var $33=$28;
      var $34=$25;
      var $35=$26;
      HEAP32[(($25)>>2)]=$33;
      HEAP32[(($26)>>2)]=$__e;
      var $36=HEAP32[(($25)>>2)];
      var $37=HEAP32[(($26)>>2)];
      var $38=$23;
      var $39=$24;
      HEAP32[(($23)>>2)]=$36;
      HEAP32[(($24)>>2)]=$37;
      var $40=HEAP32[(($23)>>2)];
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==0;
      var $44=(($43)&1);
      var $45=HEAP32[(($24)>>2)];
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)==0;
      var $49=(($48)&1);
      var $50=(($44)|0)==(($49)|0);
      var $51=$23;
      var $52=$24;
      var $53=$50 ^ 1;
      var $54=$25;
      var $55=$26;
      if ($53) { __label__ = 2; break; } else { var $109 = 0;__label__ = 9; break; }
    case 2: // $56
      var $57=$30;
      var $58=$28;
      var $59=$7;
      HEAP32[(($7)>>2)]=$58;
      var $60=HEAP32[(($7)>>2)];
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$5;
      var $64=$6;
      HEAP32[(($6)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65+12)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($65+16)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($67)|0)==(($69)|0);
      if ($70) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $71
      var $72=$65;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+36)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=FUNCTION_TABLE[$75]($65);
      HEAP32[(($5)>>2)]=$76;
      __label__ = 5; break;
    case 4: // $77
      var $78=(($65+12)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=HEAP8[($79)];
      $4=$80;
      var $81=$4;
      var $82=(($81)&255);
      HEAP32[(($5)>>2)]=$82;
      __label__ = 5; break;
    case 5: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $83=HEAP32[(($5)>>2)];
      var $84=$5;
      var $85=$6;
      var $86=(($83) & 255);
      var $87=$7;
      var $88=$1;
      var $89=$2;
      HEAP32[(($1)>>2)]=$57;
      HEAP32[(($2)>>2)]=16384;
      $3=$86;
      var $90=HEAP32[(($1)>>2)];
      var $91=$3;
      var $92=(($91 << 24) >> 24);
      var $93=(($92)>>>0) <= 127;
      if ($93) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $94
      var $95=$3;
      var $96=(($95 << 24) >> 24);
      var $97=(($90+8)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+($96<<2))|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=HEAP32[(($2)>>2)];
      var $102=$100 & $101;
      var $104 = $102;__label__ = 8; break;
    case 7: // $103
      var $104 = 0;__label__ = 8; break;
    case 8: // $_ZNKSt3__15ctypeIcE2isEjc_exit
      var $104;
      var $105=(($104)|0)!=0;
      var $106=$1;
      var $107=$2;
      var $109 = $105;__label__ = 9; break;
    case 9: // $108
      var $109;
      if ($109) { __label__ = 10; break; } else { __label__ = 23; break; }
    case 10: // $110
      __label__ = 11; break;
    case 11: // $111
      var $112=$28;
      var $113=$18;
      HEAP32[(($18)>>2)]=$112;
      var $114=HEAPU32[(($18)>>2)];
      var $115=(($114)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$16;
      var $118=$17;
      HEAP32[(($17)>>2)]=$116;
      var $119=HEAPU32[(($17)>>2)];
      var $120=$14;
      var $121=$15;
      HEAP32[(($15)>>2)]=$119;
      var $122=HEAP32[(($15)>>2)];
      var $123=(($122+12)|0);
      var $124=HEAP32[(($123)>>2)];
      var $125=(($122+16)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=(($124)|0)==(($126)|0);
      if ($127) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $128
      var $129=$122;
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+40)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=FUNCTION_TABLE[$132]($122);
      HEAP32[(($14)>>2)]=$133;
      __label__ = 14; break;
    case 13: // $134
      var $135=(($122+12)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=(($136+1)|0);
      HEAP32[(($135)>>2)]=$137;
      var $138=HEAP8[($136)];
      $13=$138;
      var $139=$13;
      var $140=(($139)&255);
      HEAP32[(($14)>>2)]=$140;
      __label__ = 14; break;
    case 14: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $141=HEAP32[(($14)>>2)];
      var $142=$14;
      var $143=$15;
      var $144=(($141)|0)==-1;
      if ($144) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $145
      HEAP32[(($16)>>2)]=-1;
      __label__ = 20; break;
    case 16: // $146
      var $147=$11;
      var $148=$12;
      HEAP32[(($12)>>2)]=$119;
      var $149=HEAPU32[(($12)>>2)];
      var $150=(($149+12)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($149+16)|0);
      var $153=HEAP32[(($152)>>2)];
      var $154=(($151)|0)==(($153)|0);
      if ($154) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $155
      var $156=$149;
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157+36)|0);
      var $159=HEAP32[(($158)>>2)];
      var $160=FUNCTION_TABLE[$159]($149);
      HEAP32[(($11)>>2)]=$160;
      __label__ = 19; break;
    case 18: // $161
      var $162=(($149+12)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=HEAP8[($163)];
      $10=$164;
      var $165=$10;
      var $166=(($165)&255);
      HEAP32[(($11)>>2)]=$166;
      __label__ = 19; break;
    case 19: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $167=HEAP32[(($11)>>2)];
      var $168=$11;
      var $169=$12;
      HEAP32[(($16)>>2)]=$167;
      __label__ = 20; break;
    case 20: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $170=HEAP32[(($16)>>2)];
      var $171=$16;
      var $172=$17;
      var $173=$8;
      var $174=$9;
      HEAP32[(($8)>>2)]=$170;
      HEAP32[(($9)>>2)]=-1;
      var $175=HEAP32[(($8)>>2)];
      var $176=HEAP32[(($9)>>2)];
      var $177=(($175)|0)==(($176)|0);
      var $178=$8;
      var $179=$9;
      if ($177) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $180
      var $181=(($114)|0);
      HEAP32[(($181)>>2)]=0;
      __label__ = 22; break;
    case 22: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $182=$18;
      __label__ = 1; break;
    case 23: // $183
      var $184=$28;
      var $185=$21;
      var $186=$22;
      HEAP32[(($21)>>2)]=$184;
      HEAP32[(($22)>>2)]=$__e;
      var $187=HEAP32[(($21)>>2)];
      var $188=HEAP32[(($22)>>2)];
      var $189=$19;
      var $190=$20;
      HEAP32[(($19)>>2)]=$187;
      HEAP32[(($20)>>2)]=$188;
      var $191=HEAP32[(($19)>>2)];
      var $192=(($191)|0);
      var $193=HEAP32[(($192)>>2)];
      var $194=(($193)|0)==0;
      var $195=(($194)&1);
      var $196=HEAP32[(($20)>>2)];
      var $197=(($196)|0);
      var $198=HEAP32[(($197)>>2)];
      var $199=(($198)|0)==0;
      var $200=(($199)&1);
      var $201=(($195)|0)==(($200)|0);
      var $202=$19;
      var $203=$20;
      var $204=$21;
      var $205=$22;
      if ($201) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $206
      var $207=$29;
      var $208=HEAP32[(($207)>>2)];
      var $209=$208 | 2;
      HEAP32[(($207)>>2)]=$209;
      __label__ = 25; break;
    case 25: // $210
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__h, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $__ap;
      var $__i;
      var $26=__stackBase__+80;
      $21=$this;
      $22=$__h;
      $23=$__b;
      $24=$__err;
      $25=$__ct;
      var $27=$21;
      var $28=$27;
      var $29=(($28+8)|0);
      var $30=$29;
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=FUNCTION_TABLE[$34]($30);
      $__ap=$35;
      var $36=$__ap;
      var $37=(($36)|0);
      var $38=$20;
      HEAP32[(($20)>>2)]=$37;
      var $39=HEAPU32[(($20)>>2)];
      var $40=$19;
      HEAP32[(($19)>>2)]=$39;
      var $41=HEAP32[(($19)>>2)];
      var $42=(($41)|0);
      var $43=$18;
      HEAP32[(($18)>>2)]=$42;
      var $44=HEAP32[(($18)>>2)];
      var $45=$44;
      var $46=$17;
      HEAP32[(($17)>>2)]=$45;
      var $47=HEAP32[(($17)>>2)];
      var $48=(($47)|0);
      var $49=$17;
      var $50=$18;
      var $51=(($48)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=$53;
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 1;
      var $58=(($57)|0)!=0;
      var $59=$19;
      if ($58) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $60
      var $61=$13;
      HEAP32[(($13)>>2)]=$39;
      var $62=HEAP32[(($13)>>2)];
      var $63=(($62)|0);
      var $64=$12;
      HEAP32[(($12)>>2)]=$63;
      var $65=HEAP32[(($12)>>2)];
      var $66=$65;
      var $67=$11;
      HEAP32[(($11)>>2)]=$66;
      var $68=HEAP32[(($11)>>2)];
      var $69=(($68)|0);
      var $70=$11;
      var $71=$12;
      var $72=(($69)|0);
      var $73=$72;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$13;
      var $97 = $75;__label__ = 3; break;
    case 2: // $77
      var $78=$16;
      HEAP32[(($16)>>2)]=$39;
      var $79=HEAP32[(($16)>>2)];
      var $80=(($79)|0);
      var $81=$15;
      HEAP32[(($15)>>2)]=$80;
      var $82=HEAP32[(($15)>>2)];
      var $83=$82;
      var $84=$14;
      HEAP32[(($14)>>2)]=$83;
      var $85=HEAP32[(($14)>>2)];
      var $86=(($85)|0);
      var $87=$14;
      var $88=$15;
      var $89=(($86)|0);
      var $90=$89;
      var $91=(($90)|0);
      var $92=$91;
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=$94 >> 1;
      var $96=$16;
      var $97 = $95;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $97;
      var $98=$20;
      var $99=$__ap;
      var $100=(($99+12)|0);
      var $101=$10;
      HEAP32[(($10)>>2)]=$100;
      var $102=HEAPU32[(($10)>>2)];
      var $103=$9;
      HEAP32[(($9)>>2)]=$102;
      var $104=HEAP32[(($9)>>2)];
      var $105=(($104)|0);
      var $106=$8;
      HEAP32[(($8)>>2)]=$105;
      var $107=HEAP32[(($8)>>2)];
      var $108=$107;
      var $109=$7;
      HEAP32[(($7)>>2)]=$108;
      var $110=HEAP32[(($7)>>2)];
      var $111=(($110)|0);
      var $112=$7;
      var $113=$8;
      var $114=(($111)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=$116;
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 & 1;
      var $121=(($120)|0)!=0;
      var $122=$9;
      if ($121) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $123
      var $124=$3;
      HEAP32[(($3)>>2)]=$102;
      var $125=HEAP32[(($3)>>2)];
      var $126=(($125)|0);
      var $127=$2;
      HEAP32[(($2)>>2)]=$126;
      var $128=HEAP32[(($2)>>2)];
      var $129=$128;
      var $130=$1;
      HEAP32[(($1)>>2)]=$129;
      var $131=HEAP32[(($1)>>2)];
      var $132=(($131)|0);
      var $133=$1;
      var $134=$2;
      var $135=(($132)|0);
      var $136=$135;
      var $137=(($136+4)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$3;
      var $160 = $138;__label__ = 6; break;
    case 5: // $140
      var $141=$6;
      HEAP32[(($6)>>2)]=$102;
      var $142=HEAP32[(($6)>>2)];
      var $143=(($142)|0);
      var $144=$5;
      HEAP32[(($5)>>2)]=$143;
      var $145=HEAP32[(($5)>>2)];
      var $146=$145;
      var $147=$4;
      HEAP32[(($4)>>2)]=$146;
      var $148=HEAP32[(($4)>>2)];
      var $149=(($148)|0);
      var $150=$4;
      var $151=$5;
      var $152=(($149)|0);
      var $153=$152;
      var $154=(($153)|0);
      var $155=$154;
      var $156=HEAPU8[($155)];
      var $157=(($156)&255);
      var $158=$157 >> 1;
      var $159=$6;
      var $160 = $158;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit1
      var $160;
      var $161=$10;
      var $162=(($97+$160)|0);
      var $163=(($162)|0)==0;
      if ($163) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $164
      var $165=$24;
      var $166=HEAP32[(($165)>>2)];
      var $167=$166 | 4;
      HEAP32[(($165)>>2)]=$167;
      __label__ = 15; break;
    case 8: // $168
      var $169=$23;
      var $170=$26;
      var $171=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($170)>>2)]=HEAP32[(($171)>>2)];
      var $172=$__ap;
      var $173=$__ap;
      var $174=(($173+24)|0);
      var $175=$25;
      var $176=$24;
      var $177=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb($169, $26, $172, $174, $175, $176, 0);
      var $178=$__ap;
      var $179=$177;
      var $180=$178;
      var $181=(($179-$180)|0);
      var $182=(((($181)|0)/12)|0);
      $__i=$182;
      var $183=$__i;
      var $184=(($183)|0)==0;
      if ($184) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $185
      var $186=$22;
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187)|0)==12;
      if ($188) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $189
      var $190=$22;
      HEAP32[(($190)>>2)]=0;
      __label__ = 15; break;
    case 11: // $191
      var $192=$__i;
      var $193=(($192)|0)==1;
      if ($193) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $194
      var $195=$22;
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196)|0) < 12;
      if ($197) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $198
      var $199=$22;
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+12)|0);
      HEAP32[(($199)>>2)]=$201;
      __label__ = 14; break;
    case 14: // $202
      __label__ = 15; break;
    case 15: // $203
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE["X"]=1;

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__s, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__s;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 60;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__w, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__w;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 1);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 6;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE($this, $__y, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__y;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 4);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19-1900)|0);
      var $21=$2;
      HEAP32[(($21)>>2)]=$20;
      __label__ = 2; break;
    case 2: // $22
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE($this, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5=__stackBase__+4;
      var $6=__stackBase__+8;
      var $7=__stackBase__+12;
      var $8=__stackBase__+16;
      var $9=__stackBase__+20;
      var $10;
      var $11=__stackBase__+24;
      var $12=__stackBase__+28;
      var $13;
      var $14=__stackBase__+32;
      var $15=__stackBase__+36;
      var $16=__stackBase__+40;
      var $17=__stackBase__+44;
      var $18=__stackBase__+48;
      var $19=__stackBase__+52;
      var $20=__stackBase__+56;
      var $21=__stackBase__+60;
      var $22=__stackBase__+64;
      var $23=__stackBase__+68;
      var $24=__stackBase__+72;
      var $25=__stackBase__+76;
      var $26=__stackBase__+80;
      var $27;
      var $28;
      var $29;
      var $30;
      $27=$this;
      $28=$__b;
      $29=$__err;
      $30=$__ct;
      var $31=$27;
      var $32=$28;
      var $33=$25;
      var $34=$26;
      HEAP32[(($25)>>2)]=$32;
      HEAP32[(($26)>>2)]=$__e;
      var $35=HEAP32[(($25)>>2)];
      var $36=HEAP32[(($26)>>2)];
      var $37=$23;
      var $38=$24;
      HEAP32[(($23)>>2)]=$35;
      HEAP32[(($24)>>2)]=$36;
      var $39=HEAP32[(($23)>>2)];
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)==0;
      var $43=(($42)&1);
      var $44=HEAP32[(($24)>>2)];
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==0;
      var $48=(($47)&1);
      var $49=(($43)|0)==(($48)|0);
      var $50=$23;
      var $51=$24;
      var $52=$25;
      var $53=$26;
      if ($49) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $54
      var $55=$29;
      var $56=HEAP32[(($55)>>2)];
      var $57=$56 | 6;
      HEAP32[(($55)>>2)]=$57;
      __label__ = 21; break;
    case 2: // $58
      var $59=$30;
      var $60=$28;
      var $61=$7;
      HEAP32[(($7)>>2)]=$60;
      var $62=HEAP32[(($7)>>2)];
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$5;
      var $66=$6;
      HEAP32[(($6)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67+12)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($67+16)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($69)|0)==(($71)|0);
      if ($72) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $73
      var $74=$67;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+36)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=FUNCTION_TABLE[$77]($67);
      HEAP32[(($5)>>2)]=$78;
      __label__ = 5; break;
    case 4: // $79
      var $80=(($67+12)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=HEAP8[($81)];
      $4=$82;
      var $83=$4;
      var $84=(($83)&255);
      HEAP32[(($5)>>2)]=$84;
      __label__ = 5; break;
    case 5: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $85=HEAP32[(($5)>>2)];
      var $86=$5;
      var $87=$6;
      var $88=(($85) & 255);
      var $89=$7;
      var $90=$1;
      HEAP32[(($1)>>2)]=$59;
      $2=$88;
      $3=0;
      var $91=HEAP32[(($1)>>2)];
      var $92=$91;
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+36)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=$2;
      var $97=$3;
      var $98=FUNCTION_TABLE[$95]($91, $96, $97);
      var $99=$1;
      var $100=(($98 << 24) >> 24);
      var $101=(($100)|0)!=37;
      if ($101) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $102
      var $103=$29;
      var $104=HEAP32[(($103)>>2)];
      var $105=$104 | 4;
      HEAP32[(($103)>>2)]=$105;
      __label__ = 21; break;
    case 7: // $106
      var $107=$28;
      var $108=$18;
      HEAP32[(($18)>>2)]=$107;
      var $109=HEAPU32[(($18)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=$16;
      var $113=$17;
      HEAP32[(($17)>>2)]=$111;
      var $114=HEAPU32[(($17)>>2)];
      var $115=$14;
      var $116=$15;
      HEAP32[(($15)>>2)]=$114;
      var $117=HEAP32[(($15)>>2)];
      var $118=(($117+12)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($117+16)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($119)|0)==(($121)|0);
      if ($122) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $123
      var $124=$117;
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125+40)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=FUNCTION_TABLE[$127]($117);
      HEAP32[(($14)>>2)]=$128;
      __label__ = 10; break;
    case 9: // $129
      var $130=(($117+12)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=(($131+1)|0);
      HEAP32[(($130)>>2)]=$132;
      var $133=HEAP8[($131)];
      $13=$133;
      var $134=$13;
      var $135=(($134)&255);
      HEAP32[(($14)>>2)]=$135;
      __label__ = 10; break;
    case 10: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $136=HEAP32[(($14)>>2)];
      var $137=$14;
      var $138=$15;
      var $139=(($136)|0)==-1;
      if ($139) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $140
      HEAP32[(($16)>>2)]=-1;
      __label__ = 16; break;
    case 12: // $141
      var $142=$11;
      var $143=$12;
      HEAP32[(($12)>>2)]=$114;
      var $144=HEAPU32[(($12)>>2)];
      var $145=(($144+12)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($144+16)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($146)|0)==(($148)|0);
      if ($149) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $150
      var $151=$144;
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+36)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=FUNCTION_TABLE[$154]($144);
      HEAP32[(($11)>>2)]=$155;
      __label__ = 15; break;
    case 14: // $156
      var $157=(($144+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=HEAP8[($158)];
      $10=$159;
      var $160=$10;
      var $161=(($160)&255);
      HEAP32[(($11)>>2)]=$161;
      __label__ = 15; break;
    case 15: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $162=HEAP32[(($11)>>2)];
      var $163=$11;
      var $164=$12;
      HEAP32[(($16)>>2)]=$162;
      __label__ = 16; break;
    case 16: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $165=HEAP32[(($16)>>2)];
      var $166=$16;
      var $167=$17;
      var $168=$8;
      var $169=$9;
      HEAP32[(($8)>>2)]=$165;
      HEAP32[(($9)>>2)]=-1;
      var $170=HEAP32[(($8)>>2)];
      var $171=HEAP32[(($9)>>2)];
      var $172=(($170)|0)==(($171)|0);
      var $173=$8;
      var $174=$9;
      if ($172) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $175
      var $176=(($109)|0);
      HEAP32[(($176)>>2)]=0;
      __label__ = 18; break;
    case 18: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $177=$18;
      var $178=$21;
      var $179=$22;
      HEAP32[(($21)>>2)]=$109;
      HEAP32[(($22)>>2)]=$__e;
      var $180=HEAP32[(($21)>>2)];
      var $181=HEAP32[(($22)>>2)];
      var $182=$19;
      var $183=$20;
      HEAP32[(($19)>>2)]=$180;
      HEAP32[(($20)>>2)]=$181;
      var $184=HEAP32[(($19)>>2)];
      var $185=(($184)|0);
      var $186=HEAP32[(($185)>>2)];
      var $187=(($186)|0)==0;
      var $188=(($187)&1);
      var $189=HEAP32[(($20)>>2)];
      var $190=(($189)|0);
      var $191=HEAP32[(($190)>>2)];
      var $192=(($191)|0)==0;
      var $193=(($192)&1);
      var $194=(($188)|0)==(($193)|0);
      var $195=$19;
      var $196=$20;
      var $197=$21;
      var $198=$22;
      if ($194) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $199
      var $200=$29;
      var $201=HEAP32[(($200)>>2)];
      var $202=$201 | 2;
      HEAP32[(($200)>>2)]=$202;
      __label__ = 20; break;
    case 20: // $203
      __label__ = 21; break;
    case 21: // $204
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE["X"]=1;

function __ZNSt3__120__time_get_c_storageIwEC2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  HEAP32[(($3)>>2)]=((__ZTVNSt3__120__time_get_c_storageIwEE+8)|0);
  ;
  return;
}


function __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b, $__e, $__err, $__ct, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 168; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4=__stackBase__+4;
      var $5=__stackBase__+8;
      var $6;
      var $7;
      var $8=__stackBase__+12;
      var $9=__stackBase__+16;
      var $10=__stackBase__+20;
      var $11=__stackBase__+24;
      var $12=__stackBase__+28;
      var $13=__stackBase__+32;
      var $14=__stackBase__+36;
      var $15=__stackBase__+40;
      var $16=__stackBase__+44;
      var $17;
      var $18=__stackBase__+48;
      var $19=__stackBase__+52;
      var $20;
      var $21=__stackBase__+56;
      var $22=__stackBase__+60;
      var $23=__stackBase__+64;
      var $24=__stackBase__+68;
      var $25=__stackBase__+72;
      var $26=__stackBase__+76;
      var $27;
      var $28;
      var $29=__stackBase__+80;
      var $30=__stackBase__+84;
      var $31;
      var $32;
      var $33=__stackBase__+88;
      var $34=__stackBase__+92;
      var $35=__stackBase__+96;
      var $36=__stackBase__+100;
      var $37=__stackBase__+104;
      var $38;
      var $39=__stackBase__+108;
      var $40=__stackBase__+112;
      var $41;
      var $42=__stackBase__+116;
      var $43=__stackBase__+120;
      var $44=__stackBase__+124;
      var $45=__stackBase__+128;
      var $46=__stackBase__+132;
      var $47=__stackBase__+136;
      var $48=__stackBase__+140;
      var $49=__stackBase__+144;
      var $50=__stackBase__+148;
      var $51=__stackBase__+152;
      var $52=__stackBase__+156;
      var $53=__stackBase__+160;
      var $54=__stackBase__+164;
      var $55;
      var $56;
      var $57;
      var $58;
      var $59;
      var $__c;
      var $__r;
      $56=$__b;
      $57=$__err;
      $58=$__ct;
      $59=$__n;
      var $60=$56;
      var $61=$53;
      var $62=$54;
      HEAP32[(($53)>>2)]=$60;
      HEAP32[(($54)>>2)]=$__e;
      var $63=HEAP32[(($53)>>2)];
      var $64=HEAP32[(($54)>>2)];
      var $65=$51;
      var $66=$52;
      HEAP32[(($51)>>2)]=$63;
      HEAP32[(($52)>>2)]=$64;
      var $67=HEAP32[(($51)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)==0;
      var $71=(($70)&1);
      var $72=HEAP32[(($52)>>2)];
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)==0;
      var $76=(($75)&1);
      var $77=(($71)|0)==(($76)|0);
      var $78=$51;
      var $79=$52;
      var $80=$53;
      var $81=$54;
      if ($77) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $82
      var $83=$57;
      var $84=HEAP32[(($83)>>2)];
      var $85=$84 | 6;
      HEAP32[(($83)>>2)]=$85;
      $55=0;
      __label__ = 49; break;
    case 2: // $86
      var $87=$56;
      var $88=$35;
      HEAP32[(($35)>>2)]=$87;
      var $89=HEAP32[(($35)>>2)];
      var $90=(($89)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$33;
      var $93=$34;
      HEAP32[(($34)>>2)]=$91;
      var $94=HEAP32[(($34)>>2)];
      var $95=(($94+12)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($94+16)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($96)|0)==(($98)|0);
      if ($99) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $100
      var $101=$94;
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+36)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=FUNCTION_TABLE[$104]($94);
      HEAP32[(($33)>>2)]=$105;
      __label__ = 5; break;
    case 4: // $106
      var $107=(($94+12)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=HEAP8[($108)];
      $32=$109;
      var $110=$32;
      var $111=(($110)&255);
      HEAP32[(($33)>>2)]=$111;
      __label__ = 5; break;
    case 5: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $112=HEAP32[(($33)>>2)];
      var $113=$33;
      var $114=$34;
      var $115=(($112) & 255);
      var $116=$35;
      $__c=$115;
      var $117=$58;
      var $118=$__c;
      var $119=$29;
      var $120=$30;
      HEAP32[(($29)>>2)]=$117;
      HEAP32[(($30)>>2)]=1024;
      $31=$118;
      var $121=HEAP32[(($29)>>2)];
      var $122=$31;
      var $123=(($122 << 24) >> 24);
      var $124=(($123)>>>0) <= 127;
      if ($124) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $125
      var $126=$31;
      var $127=(($126 << 24) >> 24);
      var $128=(($121+8)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+($127<<2))|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=HEAP32[(($30)>>2)];
      var $133=$131 & $132;
      var $135 = $133;__label__ = 8; break;
    case 7: // $134
      var $135 = 0;__label__ = 8; break;
    case 8: // $_ZNKSt3__15ctypeIcE2isEjc_exit
      var $135;
      var $136=(($135)|0)!=0;
      var $137=$29;
      var $138=$30;
      if ($136) { __label__ = 10; break; } else { __label__ = 9; break; }
    case 9: // $139
      var $140=$57;
      var $141=HEAP32[(($140)>>2)];
      var $142=$141 | 4;
      HEAP32[(($140)>>2)]=$142;
      $55=0;
      __label__ = 49; break;
    case 10: // $143
      var $144=$58;
      var $145=$__c;
      var $146=$26;
      HEAP32[(($26)>>2)]=$144;
      $27=$145;
      $28=0;
      var $147=HEAP32[(($26)>>2)];
      var $148=$147;
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+36)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=$27;
      var $153=$28;
      var $154=FUNCTION_TABLE[$151]($147, $152, $153);
      var $155=$26;
      var $156=(($154 << 24) >> 24);
      var $157=(($156-48)|0);
      $__r=$157;
      var $158=$56;
      var $159=$25;
      HEAP32[(($25)>>2)]=$158;
      var $160=HEAPU32[(($25)>>2)];
      var $161=(($160)|0);
      var $162=HEAP32[(($161)>>2)];
      var $163=$23;
      var $164=$24;
      HEAP32[(($24)>>2)]=$162;
      var $165=HEAPU32[(($24)>>2)];
      var $166=$21;
      var $167=$22;
      HEAP32[(($22)>>2)]=$165;
      var $168=HEAP32[(($22)>>2)];
      var $169=(($168+12)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($168+16)|0);
      var $172=HEAP32[(($171)>>2)];
      var $173=(($170)|0)==(($172)|0);
      if ($173) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $174
      var $175=$168;
      var $176=HEAP32[(($175)>>2)];
      var $177=(($176+40)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=FUNCTION_TABLE[$178]($168);
      HEAP32[(($21)>>2)]=$179;
      __label__ = 13; break;
    case 12: // $180
      var $181=(($168+12)|0);
      var $182=HEAP32[(($181)>>2)];
      var $183=(($182+1)|0);
      HEAP32[(($181)>>2)]=$183;
      var $184=HEAP8[($182)];
      $20=$184;
      var $185=$20;
      var $186=(($185)&255);
      HEAP32[(($21)>>2)]=$186;
      __label__ = 13; break;
    case 13: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i1
      var $187=HEAP32[(($21)>>2)];
      var $188=$21;
      var $189=$22;
      var $190=(($187)|0)==-1;
      if ($190) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $191
      HEAP32[(($23)>>2)]=-1;
      __label__ = 19; break;
    case 15: // $192
      var $193=$18;
      var $194=$19;
      HEAP32[(($19)>>2)]=$165;
      var $195=HEAPU32[(($19)>>2)];
      var $196=(($195+12)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=(($195+16)|0);
      var $199=HEAP32[(($198)>>2)];
      var $200=(($197)|0)==(($199)|0);
      if ($200) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $201
      var $202=$195;
      var $203=HEAP32[(($202)>>2)];
      var $204=(($203+36)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=FUNCTION_TABLE[$205]($195);
      HEAP32[(($18)>>2)]=$206;
      __label__ = 18; break;
    case 17: // $207
      var $208=(($195+12)|0);
      var $209=HEAP32[(($208)>>2)];
      var $210=HEAP8[($209)];
      $17=$210;
      var $211=$17;
      var $212=(($211)&255);
      HEAP32[(($18)>>2)]=$212;
      __label__ = 18; break;
    case 18: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i2
      var $213=HEAP32[(($18)>>2)];
      var $214=$18;
      var $215=$19;
      HEAP32[(($23)>>2)]=$213;
      __label__ = 19; break;
    case 19: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i3
      var $216=HEAP32[(($23)>>2)];
      var $217=$23;
      var $218=$24;
      var $219=$15;
      var $220=$16;
      HEAP32[(($15)>>2)]=$216;
      HEAP32[(($16)>>2)]=-1;
      var $221=HEAP32[(($15)>>2)];
      var $222=HEAP32[(($16)>>2)];
      var $223=(($221)|0)==(($222)|0);
      var $224=$15;
      var $225=$16;
      if ($223) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $226
      var $227=(($160)|0);
      HEAP32[(($227)>>2)]=0;
      __label__ = 21; break;
    case 21: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit4
      var $228=$25;
      var $229=$59;
      var $230=(($229-1)|0);
      $59=$230;
      __label__ = 22; break;
    case 22: // $231
      var $232=$56;
      var $233=$13;
      var $234=$14;
      HEAP32[(($13)>>2)]=$232;
      HEAP32[(($14)>>2)]=$__e;
      var $235=HEAP32[(($13)>>2)];
      var $236=HEAP32[(($14)>>2)];
      var $237=$11;
      var $238=$12;
      HEAP32[(($11)>>2)]=$235;
      HEAP32[(($12)>>2)]=$236;
      var $239=HEAP32[(($11)>>2)];
      var $240=(($239)|0);
      var $241=HEAP32[(($240)>>2)];
      var $242=(($241)|0)==0;
      var $243=(($242)&1);
      var $244=HEAP32[(($12)>>2)];
      var $245=(($244)|0);
      var $246=HEAP32[(($245)>>2)];
      var $247=(($246)|0)==0;
      var $248=(($247)&1);
      var $249=(($243)|0)==(($248)|0);
      var $250=$11;
      var $251=$12;
      var $252=$249 ^ 1;
      var $253=$13;
      var $254=$14;
      if ($252) { __label__ = 23; break; } else { var $259 = 0;__label__ = 24; break; }
    case 23: // $255
      var $256=$59;
      var $257=(($256)|0) > 0;
      var $259 = $257;__label__ = 24; break;
    case 24: // $258
      var $259;
      if ($259) { __label__ = 25; break; } else { __label__ = 46; break; }
    case 25: // $260
      var $261=$56;
      var $262=$10;
      HEAP32[(($10)>>2)]=$261;
      var $263=HEAP32[(($10)>>2)];
      var $264=(($263)|0);
      var $265=HEAP32[(($264)>>2)];
      var $266=$8;
      var $267=$9;
      HEAP32[(($9)>>2)]=$265;
      var $268=HEAP32[(($9)>>2)];
      var $269=(($268+12)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($268+16)|0);
      var $272=HEAP32[(($271)>>2)];
      var $273=(($270)|0)==(($272)|0);
      if ($273) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $274
      var $275=$268;
      var $276=HEAP32[(($275)>>2)];
      var $277=(($276+36)|0);
      var $278=HEAP32[(($277)>>2)];
      var $279=FUNCTION_TABLE[$278]($268);
      HEAP32[(($8)>>2)]=$279;
      __label__ = 28; break;
    case 27: // $280
      var $281=(($268+12)|0);
      var $282=HEAP32[(($281)>>2)];
      var $283=HEAP8[($282)];
      $7=$283;
      var $284=$7;
      var $285=(($284)&255);
      HEAP32[(($8)>>2)]=$285;
      __label__ = 28; break;
    case 28: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit5
      var $286=HEAP32[(($8)>>2)];
      var $287=$8;
      var $288=$9;
      var $289=(($286) & 255);
      var $290=$10;
      $__c=$289;
      var $291=$58;
      var $292=$__c;
      var $293=$4;
      var $294=$5;
      HEAP32[(($4)>>2)]=$291;
      HEAP32[(($5)>>2)]=1024;
      $6=$292;
      var $295=HEAP32[(($4)>>2)];
      var $296=$6;
      var $297=(($296 << 24) >> 24);
      var $298=(($297)>>>0) <= 127;
      if ($298) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $299
      var $300=$6;
      var $301=(($300 << 24) >> 24);
      var $302=(($295+8)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=(($303+($301<<2))|0);
      var $305=HEAP32[(($304)>>2)];
      var $306=HEAP32[(($5)>>2)];
      var $307=$305 & $306;
      var $309 = $307;__label__ = 31; break;
    case 30: // $308
      var $309 = 0;__label__ = 31; break;
    case 31: // $_ZNKSt3__15ctypeIcE2isEjc_exit6
      var $309;
      var $310=(($309)|0)!=0;
      var $311=$4;
      var $312=$5;
      if ($310) { __label__ = 33; break; } else { __label__ = 32; break; }
    case 32: // $313
      var $314=$__r;
      $55=$314;
      __label__ = 49; break;
    case 33: // $315
      var $316=$__r;
      var $317=(($316*10)|0);
      var $318=$58;
      var $319=$__c;
      var $320=$1;
      HEAP32[(($1)>>2)]=$318;
      $2=$319;
      $3=0;
      var $321=HEAP32[(($1)>>2)];
      var $322=$321;
      var $323=HEAP32[(($322)>>2)];
      var $324=(($323+36)|0);
      var $325=HEAP32[(($324)>>2)];
      var $326=$2;
      var $327=$3;
      var $328=FUNCTION_TABLE[$325]($321, $326, $327);
      var $329=$1;
      var $330=(($328 << 24) >> 24);
      var $331=(($317+$330)|0);
      var $332=(($331-48)|0);
      $__r=$332;
      __label__ = 34; break;
    case 34: // $333
      var $334=$56;
      var $335=$46;
      HEAP32[(($46)>>2)]=$334;
      var $336=HEAPU32[(($46)>>2)];
      var $337=(($336)|0);
      var $338=HEAP32[(($337)>>2)];
      var $339=$44;
      var $340=$45;
      HEAP32[(($45)>>2)]=$338;
      var $341=HEAPU32[(($45)>>2)];
      var $342=$42;
      var $343=$43;
      HEAP32[(($43)>>2)]=$341;
      var $344=HEAP32[(($43)>>2)];
      var $345=(($344+12)|0);
      var $346=HEAP32[(($345)>>2)];
      var $347=(($344+16)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=(($346)|0)==(($348)|0);
      if ($349) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $350
      var $351=$344;
      var $352=HEAP32[(($351)>>2)];
      var $353=(($352+40)|0);
      var $354=HEAP32[(($353)>>2)];
      var $355=FUNCTION_TABLE[$354]($344);
      HEAP32[(($42)>>2)]=$355;
      __label__ = 37; break;
    case 36: // $356
      var $357=(($344+12)|0);
      var $358=HEAP32[(($357)>>2)];
      var $359=(($358+1)|0);
      HEAP32[(($357)>>2)]=$359;
      var $360=HEAP8[($358)];
      $41=$360;
      var $361=$41;
      var $362=(($361)&255);
      HEAP32[(($42)>>2)]=$362;
      __label__ = 37; break;
    case 37: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $363=HEAP32[(($42)>>2)];
      var $364=$42;
      var $365=$43;
      var $366=(($363)|0)==-1;
      if ($366) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $367
      HEAP32[(($44)>>2)]=-1;
      __label__ = 43; break;
    case 39: // $368
      var $369=$39;
      var $370=$40;
      HEAP32[(($40)>>2)]=$341;
      var $371=HEAPU32[(($40)>>2)];
      var $372=(($371+12)|0);
      var $373=HEAP32[(($372)>>2)];
      var $374=(($371+16)|0);
      var $375=HEAP32[(($374)>>2)];
      var $376=(($373)|0)==(($375)|0);
      if ($376) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $377
      var $378=$371;
      var $379=HEAP32[(($378)>>2)];
      var $380=(($379+36)|0);
      var $381=HEAP32[(($380)>>2)];
      var $382=FUNCTION_TABLE[$381]($371);
      HEAP32[(($39)>>2)]=$382;
      __label__ = 42; break;
    case 41: // $383
      var $384=(($371+12)|0);
      var $385=HEAP32[(($384)>>2)];
      var $386=HEAP8[($385)];
      $38=$386;
      var $387=$38;
      var $388=(($387)&255);
      HEAP32[(($39)>>2)]=$388;
      __label__ = 42; break;
    case 42: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $389=HEAP32[(($39)>>2)];
      var $390=$39;
      var $391=$40;
      HEAP32[(($44)>>2)]=$389;
      __label__ = 43; break;
    case 43: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $392=HEAP32[(($44)>>2)];
      var $393=$44;
      var $394=$45;
      var $395=$36;
      var $396=$37;
      HEAP32[(($36)>>2)]=$392;
      HEAP32[(($37)>>2)]=-1;
      var $397=HEAP32[(($36)>>2)];
      var $398=HEAP32[(($37)>>2)];
      var $399=(($397)|0)==(($398)|0);
      var $400=$36;
      var $401=$37;
      if ($399) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $402
      var $403=(($336)|0);
      HEAP32[(($403)>>2)]=0;
      __label__ = 45; break;
    case 45: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $404=$46;
      var $405=$59;
      var $406=(($405-1)|0);
      $59=$406;
      __label__ = 22; break;
    case 46: // $407
      var $408=$56;
      var $409=$49;
      var $410=$50;
      HEAP32[(($49)>>2)]=$408;
      HEAP32[(($50)>>2)]=$__e;
      var $411=HEAP32[(($49)>>2)];
      var $412=HEAP32[(($50)>>2)];
      var $413=$47;
      var $414=$48;
      HEAP32[(($47)>>2)]=$411;
      HEAP32[(($48)>>2)]=$412;
      var $415=HEAP32[(($47)>>2)];
      var $416=(($415)|0);
      var $417=HEAP32[(($416)>>2)];
      var $418=(($417)|0)==0;
      var $419=(($418)&1);
      var $420=HEAP32[(($48)>>2)];
      var $421=(($420)|0);
      var $422=HEAP32[(($421)>>2)];
      var $423=(($422)|0)==0;
      var $424=(($423)&1);
      var $425=(($419)|0)==(($424)|0);
      var $426=$47;
      var $427=$48;
      var $428=$49;
      var $429=$50;
      if ($425) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $430
      var $431=$57;
      var $432=HEAP32[(($431)>>2)];
      var $433=$432 | 2;
      HEAP32[(($431)>>2)]=$433;
      __label__ = 48; break;
    case 48: // $434
      var $435=$__r;
      $55=$435;
      __label__ = 49; break;
    case 49: // $436
      var $437=$55;
      STACKTOP = __stackBase__;
      return $437;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm, $__fmtb, $__fmte) {
  var __stackBase__  = STACKTOP; STACKTOP += 264; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39;
      var $40=__stackBase__+152;
      var $41=__stackBase__+156;
      var $42;
      var $43=__stackBase__+160;
      var $44=__stackBase__+164;
      var $45;
      var $46=__stackBase__+168;
      var $47=__stackBase__+172;
      var $48=__stackBase__+176;
      var $49=__stackBase__+180;
      var $50=__stackBase__+184;
      var $51=__stackBase__+188;
      var $52=__stackBase__+192;
      var $53=__stackBase__+196;
      var $54=__stackBase__+200;
      var $55=__stackBase__+204;
      var $56=__stackBase__+208;
      var $57=__stackBase__+212;
      var $58=__stackBase__+216;
      var $59=__stackBase__+220;
      var $60=__stackBase__+224;
      var $61=__stackBase__+228;
      var $62=__stackBase__+232;
      var $63=__stackBase__+236;
      var $64=__stackBase__+240;
      var $65=__stackBase__+244;
      var $66;
      var $67;
      var $68;
      var $69;
      var $70;
      var $71;
      var $__ct;
      var $72=__stackBase__+248;
      var $73;
      var $74;
      var $__cmd;
      var $__opt;
      var $75=__stackBase__+252;
      var $76=__stackBase__+256;
      var $77=__stackBase__+260;
      $66=$this;
      $67=$__iob;
      $68=$__err;
      $69=$__tm;
      $70=$__fmtb;
      $71=$__fmte;
      var $78=$66;
      var $79=$67;
      __ZNKSt3__18ios_base6getlocEv($72, $79);
      var $80=$65;
      HEAP32[(($65)>>2)]=$72;
      var $81=HEAP32[(($65)>>2)];
      var $82=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($81, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 8; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $83=$82;
      var $84=$65;
      __label__ = 2; break;
    case 2: // $85
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($72);
      $__ct=$83;
      var $86=$68;
      HEAP32[(($86)>>2)]=0;
      __label__ = 3; break;
    case 3: // $87
      var $88=$70;
      var $89=$71;
      var $90=(($88)|0)!=(($89)|0);
      if ($90) { __label__ = 4; break; } else { var $96 = 0;__label__ = 5; break; }
    case 4: // $91
      var $92=$68;
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93)|0)==0;
      var $96 = $94;__label__ = 5; break;
    case 5: // $95
      var $96;
      if ($96) { __label__ = 6; break; } else { __label__ = 67; break; }
    case 6: // $97
      var $98=$63;
      var $99=$64;
      HEAP32[(($63)>>2)]=$__b;
      HEAP32[(($64)>>2)]=$__e;
      var $100=HEAP32[(($63)>>2)];
      var $101=HEAP32[(($64)>>2)];
      var $102=$61;
      var $103=$62;
      HEAP32[(($61)>>2)]=$100;
      HEAP32[(($62)>>2)]=$101;
      var $104=HEAP32[(($61)>>2)];
      var $105=(($104)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=(($106)|0)==0;
      var $108=(($107)&1);
      var $109=HEAP32[(($62)>>2)];
      var $110=(($109)|0);
      var $111=HEAP32[(($110)>>2)];
      var $112=(($111)|0)==0;
      var $113=(($112)&1);
      var $114=(($108)|0)==(($113)|0);
      var $115=$61;
      var $116=$62;
      var $117=$63;
      var $118=$64;
      if ($114) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $119
      var $120=$68;
      HEAP32[(($120)>>2)]=4;
      __label__ = 67; break;
    case 8: // $121
      var $122=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $123=$122.f0;
      $73=$123;
      var $124=$122.f1;
      $74=$124;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($72) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 71; break; }
    case 9: // $125
      __label__ = 70; break;
    case 10: // $126
      var $127=$__ct;
      var $128=$70;
      var $129=HEAP32[(($128)>>2)];
      var $130=$43;
      var $131=$44;
      HEAP32[(($43)>>2)]=$127;
      HEAP32[(($44)>>2)]=$129;
      $45=0;
      var $132=HEAP32[(($43)>>2)];
      var $133=$132;
      var $134=HEAP32[(($133)>>2)];
      var $135=(($134+52)|0);
      var $136=HEAP32[(($135)>>2)];
      var $137=HEAP32[(($44)>>2)];
      var $138=$45;
      var $139=FUNCTION_TABLE[$136]($132, $137, $138);
      var $140=$43;
      var $141=$44;
      var $142=(($139 << 24) >> 24);
      var $143=(($142)|0)==37;
      if ($143) { __label__ = 11; break; } else { __label__ = 19; break; }
    case 11: // $144
      var $145=$70;
      var $146=(($145+4)|0);
      $70=$146;
      var $147=$71;
      var $148=(($146)|0)==(($147)|0);
      if ($148) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $149
      var $150=$68;
      HEAP32[(($150)>>2)]=4;
      __label__ = 67; break;
    case 13: // $151
      var $152=$__ct;
      var $153=$70;
      var $154=HEAP32[(($153)>>2)];
      var $155=$40;
      var $156=$41;
      HEAP32[(($40)>>2)]=$152;
      HEAP32[(($41)>>2)]=$154;
      $42=0;
      var $157=HEAP32[(($40)>>2)];
      var $158=$157;
      var $159=HEAP32[(($158)>>2)];
      var $160=(($159+52)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=HEAP32[(($41)>>2)];
      var $163=$42;
      var $164=FUNCTION_TABLE[$161]($157, $162, $163);
      var $165=$40;
      var $166=$41;
      $__cmd=$164;
      $__opt=0;
      var $167=$__cmd;
      var $168=(($167 << 24) >> 24);
      var $169=(($168)|0)==69;
      if ($169) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $170
      var $171=$__cmd;
      var $172=(($171 << 24) >> 24);
      var $173=(($172)|0)==48;
      if ($173) { __label__ = 15; break; } else { __label__ = 18; break; }
    case 15: // $174
      var $175=$70;
      var $176=(($175+4)|0);
      $70=$176;
      var $177=$71;
      var $178=(($176)|0)==(($177)|0);
      if ($178) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $179
      var $180=$68;
      HEAP32[(($180)>>2)]=4;
      __label__ = 67; break;
    case 17: // $181
      var $182=$__cmd;
      $__opt=$182;
      var $183=$__ct;
      var $184=$70;
      var $185=HEAP32[(($184)>>2)];
      var $186=$37;
      var $187=$38;
      HEAP32[(($37)>>2)]=$183;
      HEAP32[(($38)>>2)]=$185;
      $39=0;
      var $188=HEAP32[(($37)>>2)];
      var $189=$188;
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190+52)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=HEAP32[(($38)>>2)];
      var $194=$39;
      var $195=FUNCTION_TABLE[$192]($188, $193, $194);
      var $196=$37;
      var $197=$38;
      $__cmd=$195;
      __label__ = 18; break;
    case 18: // $198
      var $199=$78;
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+36)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=$76;
      var $204=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($203)>>2)]=HEAP32[(($204)>>2)];
      var $205=$77;
      var $206=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($205)>>2)]=HEAP32[(($206)>>2)];
      var $207=$67;
      var $208=$68;
      var $209=$69;
      var $210=$__cmd;
      var $211=$__opt;
      FUNCTION_TABLE[$202]($75, $78, $76, $77, $207, $208, $209, $210, $211);
      var $212=$__b;
      var $213=$75;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($212)>>2)]=HEAP32[(($213)>>2)];
      var $214=$70;
      var $215=(($214+4)|0);
      $70=$215;
      __label__ = 66; break;
    case 19: // $216
      var $217=$__ct;
      var $218=$70;
      var $219=HEAP32[(($218)>>2)];
      var $220=$34;
      var $221=$35;
      var $222=$36;
      HEAP32[(($34)>>2)]=$217;
      HEAP32[(($35)>>2)]=16384;
      HEAP32[(($36)>>2)]=$219;
      var $223=HEAP32[(($34)>>2)];
      var $224=$223;
      var $225=HEAP32[(($224)>>2)];
      var $226=(($225+12)|0);
      var $227=HEAP32[(($226)>>2)];
      var $228=HEAP32[(($35)>>2)];
      var $229=HEAP32[(($36)>>2)];
      var $230=FUNCTION_TABLE[$227]($223, $228, $229);
      var $231=$34;
      var $232=$35;
      var $233=$36;
      if ($230) { __label__ = 20; break; } else { __label__ = 47; break; }
    case 20: // $234
      var $235=$70;
      var $236=(($235+4)|0);
      $70=$236;
      __label__ = 21; break;
    case 21: // $237
      var $238=$70;
      var $239=$71;
      var $240=(($238)|0)!=(($239)|0);
      if ($240) { __label__ = 22; break; } else { var $260 = 0;__label__ = 23; break; }
    case 22: // $241
      var $242=$__ct;
      var $243=$70;
      var $244=HEAP32[(($243)>>2)];
      var $245=$31;
      var $246=$32;
      var $247=$33;
      HEAP32[(($31)>>2)]=$242;
      HEAP32[(($32)>>2)]=16384;
      HEAP32[(($33)>>2)]=$244;
      var $248=HEAP32[(($31)>>2)];
      var $249=$248;
      var $250=HEAP32[(($249)>>2)];
      var $251=(($250+12)|0);
      var $252=HEAP32[(($251)>>2)];
      var $253=HEAP32[(($32)>>2)];
      var $254=HEAP32[(($33)>>2)];
      var $255=FUNCTION_TABLE[$252]($248, $253, $254);
      var $256=$31;
      var $257=$32;
      var $258=$33;
      var $260 = $255;__label__ = 23; break;
    case 23: // $259
      var $260;
      if ($260) { __label__ = 24; break; } else { __label__ = 26; break; }
    case 24: // $261
      __label__ = 25; break;
    case 25: // $262
      var $263=$70;
      var $264=(($263+4)|0);
      $70=$264;
      __label__ = 21; break;
    case 26: // $265
      __label__ = 27; break;
    case 27: // $266
      var $267=$29;
      var $268=$30;
      HEAP32[(($29)>>2)]=$__b;
      HEAP32[(($30)>>2)]=$__e;
      var $269=HEAP32[(($29)>>2)];
      var $270=HEAP32[(($30)>>2)];
      var $271=$27;
      var $272=$28;
      HEAP32[(($27)>>2)]=$269;
      HEAP32[(($28)>>2)]=$270;
      var $273=HEAP32[(($27)>>2)];
      var $274=(($273)|0);
      var $275=HEAP32[(($274)>>2)];
      var $276=(($275)|0)==0;
      var $277=(($276)&1);
      var $278=HEAP32[(($28)>>2)];
      var $279=(($278)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=(($280)|0)==0;
      var $282=(($281)&1);
      var $283=(($277)|0)==(($282)|0);
      var $284=$27;
      var $285=$28;
      var $286=$283 ^ 1;
      var $287=$29;
      var $288=$30;
      if ($286) { __label__ = 28; break; } else { var $335 = 0;__label__ = 32; break; }
    case 28: // $289
      var $290=$__ct;
      var $291=$26;
      HEAP32[(($26)>>2)]=$__b;
      var $292=HEAP32[(($26)>>2)];
      var $293=(($292)|0);
      var $294=HEAP32[(($293)>>2)];
      var $295=$24;
      var $296=$25;
      HEAP32[(($25)>>2)]=$294;
      var $297=HEAP32[(($25)>>2)];
      var $298=(($297+12)|0);
      var $299=HEAP32[(($298)>>2)];
      var $300=(($297+16)|0);
      var $301=HEAP32[(($300)>>2)];
      var $302=(($299)|0)==(($301)|0);
      if ($302) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $303
      var $304=$297;
      var $305=HEAP32[(($304)>>2)];
      var $306=(($305+36)|0);
      var $307=HEAP32[(($306)>>2)];
      var $308=FUNCTION_TABLE[$307]($297);
      HEAP32[(($24)>>2)]=$308;
      __label__ = 31; break;
    case 30: // $309
      var $310=(($297+12)|0);
      var $311=HEAP32[(($310)>>2)];
      var $312=HEAP32[(($311)>>2)];
      var $313=$23;
      HEAP32[(($23)>>2)]=$312;
      var $314=HEAP32[(($23)>>2)];
      var $315=$23;
      HEAP32[(($24)>>2)]=$314;
      __label__ = 31; break;
    case 31: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $316=HEAP32[(($24)>>2)];
      var $317=$24;
      var $318=$25;
      var $319=$26;
      var $320=$20;
      var $321=$21;
      var $322=$22;
      HEAP32[(($20)>>2)]=$290;
      HEAP32[(($21)>>2)]=16384;
      HEAP32[(($22)>>2)]=$316;
      var $323=HEAP32[(($20)>>2)];
      var $324=$323;
      var $325=HEAP32[(($324)>>2)];
      var $326=(($325+12)|0);
      var $327=HEAP32[(($326)>>2)];
      var $328=HEAP32[(($21)>>2)];
      var $329=HEAP32[(($22)>>2)];
      var $330=FUNCTION_TABLE[$327]($323, $328, $329);
      var $331=$20;
      var $332=$21;
      var $333=$22;
      var $335 = $330;__label__ = 32; break;
    case 32: // $334
      var $335;
      if ($335) { __label__ = 33; break; } else { __label__ = 46; break; }
    case 33: // $336
      __label__ = 34; break;
    case 34: // $337
      var $338=$19;
      HEAP32[(($19)>>2)]=$__b;
      var $339=HEAPU32[(($19)>>2)];
      var $340=(($339)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$17;
      var $343=$18;
      HEAP32[(($18)>>2)]=$341;
      var $344=HEAP32[(($18)>>2)];
      var $345=$15;
      var $346=$16;
      HEAP32[(($16)>>2)]=$344;
      var $347=HEAP32[(($16)>>2)];
      var $348=(($347+12)|0);
      var $349=HEAP32[(($348)>>2)];
      var $350=(($347+16)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=(($349)|0)==(($351)|0);
      if ($352) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $353
      var $354=$347;
      var $355=HEAP32[(($354)>>2)];
      var $356=(($355+40)|0);
      var $357=HEAP32[(($356)>>2)];
      var $358=FUNCTION_TABLE[$357]($347);
      HEAP32[(($15)>>2)]=$358;
      __label__ = 37; break;
    case 36: // $359
      var $360=(($347+12)|0);
      var $361=HEAP32[(($360)>>2)];
      var $362=(($361+4)|0);
      HEAP32[(($360)>>2)]=$362;
      var $363=HEAP32[(($361)>>2)];
      var $364=$14;
      HEAP32[(($14)>>2)]=$363;
      var $365=HEAP32[(($14)>>2)];
      var $366=$14;
      HEAP32[(($15)>>2)]=$365;
      __label__ = 37; break;
    case 37: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i1
      var $367=HEAP32[(($15)>>2)];
      var $368=$15;
      var $369=$16;
      var $370=(($367)|0)==-1;
      if ($370) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $371
      HEAP32[(($17)>>2)]=-1;
      __label__ = 43; break;
    case 39: // $372
      var $373=$12;
      var $374=$13;
      HEAP32[(($13)>>2)]=$344;
      var $375=HEAP32[(($13)>>2)];
      var $376=(($375+12)|0);
      var $377=HEAP32[(($376)>>2)];
      var $378=(($375+16)|0);
      var $379=HEAP32[(($378)>>2)];
      var $380=(($377)|0)==(($379)|0);
      if ($380) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $381
      var $382=$375;
      var $383=HEAP32[(($382)>>2)];
      var $384=(($383+36)|0);
      var $385=HEAP32[(($384)>>2)];
      var $386=FUNCTION_TABLE[$385]($375);
      HEAP32[(($12)>>2)]=$386;
      __label__ = 42; break;
    case 41: // $387
      var $388=(($375+12)|0);
      var $389=HEAP32[(($388)>>2)];
      var $390=HEAP32[(($389)>>2)];
      var $391=$11;
      HEAP32[(($11)>>2)]=$390;
      var $392=HEAP32[(($11)>>2)];
      var $393=$11;
      HEAP32[(($12)>>2)]=$392;
      __label__ = 42; break;
    case 42: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i2
      var $394=HEAP32[(($12)>>2)];
      var $395=$12;
      var $396=$13;
      HEAP32[(($17)>>2)]=$394;
      __label__ = 43; break;
    case 43: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i3
      var $397=HEAP32[(($17)>>2)];
      var $398=$17;
      var $399=$18;
      var $400=$9;
      var $401=$10;
      HEAP32[(($9)>>2)]=$397;
      HEAP32[(($10)>>2)]=-1;
      var $402=HEAP32[(($9)>>2)];
      var $403=HEAP32[(($10)>>2)];
      var $404=(($402)|0)==(($403)|0);
      var $405=$9;
      var $406=$10;
      if ($404) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $407
      var $408=(($339)|0);
      HEAP32[(($408)>>2)]=0;
      __label__ = 45; break;
    case 45: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit4
      var $409=$19;
      __label__ = 27; break;
    case 46: // $410
      __label__ = 65; break;
    case 47: // $411
      var $412=$__ct;
      var $413=$8;
      HEAP32[(($8)>>2)]=$__b;
      var $414=HEAP32[(($8)>>2)];
      var $415=(($414)|0);
      var $416=HEAP32[(($415)>>2)];
      var $417=$6;
      var $418=$7;
      HEAP32[(($7)>>2)]=$416;
      var $419=HEAP32[(($7)>>2)];
      var $420=(($419+12)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=(($419+16)|0);
      var $423=HEAP32[(($422)>>2)];
      var $424=(($421)|0)==(($423)|0);
      if ($424) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $425
      var $426=$419;
      var $427=HEAP32[(($426)>>2)];
      var $428=(($427+36)|0);
      var $429=HEAP32[(($428)>>2)];
      var $430=FUNCTION_TABLE[$429]($419);
      HEAP32[(($6)>>2)]=$430;
      __label__ = 50; break;
    case 49: // $431
      var $432=(($419+12)|0);
      var $433=HEAP32[(($432)>>2)];
      var $434=HEAP32[(($433)>>2)];
      var $435=$5;
      HEAP32[(($5)>>2)]=$434;
      var $436=HEAP32[(($5)>>2)];
      var $437=$5;
      HEAP32[(($6)>>2)]=$436;
      __label__ = 50; break;
    case 50: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit5
      var $438=HEAP32[(($6)>>2)];
      var $439=$6;
      var $440=$7;
      var $441=$8;
      var $442=$3;
      var $443=$4;
      HEAP32[(($3)>>2)]=$412;
      HEAP32[(($4)>>2)]=$438;
      var $444=HEAP32[(($3)>>2)];
      var $445=$444;
      var $446=HEAP32[(($445)>>2)];
      var $447=(($446+28)|0);
      var $448=HEAP32[(($447)>>2)];
      var $449=HEAP32[(($4)>>2)];
      var $450=FUNCTION_TABLE[$448]($444, $449);
      var $451=$3;
      var $452=$4;
      var $453=$__ct;
      var $454=$70;
      var $455=HEAP32[(($454)>>2)];
      var $456=$1;
      var $457=$2;
      HEAP32[(($1)>>2)]=$453;
      HEAP32[(($2)>>2)]=$455;
      var $458=HEAP32[(($1)>>2)];
      var $459=$458;
      var $460=HEAP32[(($459)>>2)];
      var $461=(($460+28)|0);
      var $462=HEAP32[(($461)>>2)];
      var $463=HEAP32[(($2)>>2)];
      var $464=FUNCTION_TABLE[$462]($458, $463);
      var $465=$1;
      var $466=$2;
      var $467=(($450)|0)==(($464)|0);
      if ($467) { __label__ = 51; break; } else { __label__ = 63; break; }
    case 51: // $468
      var $469=$56;
      HEAP32[(($56)>>2)]=$__b;
      var $470=HEAP32[(($56)>>2)];
      var $471=(($470)|0);
      var $472=HEAP32[(($471)>>2)];
      var $473=$54;
      var $474=$55;
      HEAP32[(($55)>>2)]=$472;
      var $475=HEAP32[(($55)>>2)];
      var $476=$52;
      var $477=$53;
      HEAP32[(($53)>>2)]=$475;
      var $478=HEAP32[(($53)>>2)];
      var $479=(($478+12)|0);
      var $480=HEAP32[(($479)>>2)];
      var $481=(($478+16)|0);
      var $482=HEAP32[(($481)>>2)];
      var $483=(($480)|0)==(($482)|0);
      if ($483) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $484
      var $485=$478;
      var $486=HEAP32[(($485)>>2)];
      var $487=(($486+40)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=FUNCTION_TABLE[$488]($478);
      HEAP32[(($52)>>2)]=$489;
      __label__ = 54; break;
    case 53: // $490
      var $491=(($478+12)|0);
      var $492=HEAP32[(($491)>>2)];
      var $493=(($492+4)|0);
      HEAP32[(($491)>>2)]=$493;
      var $494=HEAP32[(($492)>>2)];
      var $495=$51;
      HEAP32[(($51)>>2)]=$494;
      var $496=HEAP32[(($51)>>2)];
      var $497=$51;
      HEAP32[(($52)>>2)]=$496;
      __label__ = 54; break;
    case 54: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $498=HEAP32[(($52)>>2)];
      var $499=$52;
      var $500=$53;
      var $501=(($498)|0)==-1;
      if ($501) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $502
      HEAP32[(($54)>>2)]=-1;
      __label__ = 60; break;
    case 56: // $503
      var $504=$49;
      var $505=$50;
      HEAP32[(($50)>>2)]=$475;
      var $506=HEAP32[(($50)>>2)];
      var $507=(($506+12)|0);
      var $508=HEAP32[(($507)>>2)];
      var $509=(($506+16)|0);
      var $510=HEAP32[(($509)>>2)];
      var $511=(($508)|0)==(($510)|0);
      if ($511) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $512
      var $513=$506;
      var $514=HEAP32[(($513)>>2)];
      var $515=(($514+36)|0);
      var $516=HEAP32[(($515)>>2)];
      var $517=FUNCTION_TABLE[$516]($506);
      HEAP32[(($49)>>2)]=$517;
      __label__ = 59; break;
    case 58: // $518
      var $519=(($506+12)|0);
      var $520=HEAP32[(($519)>>2)];
      var $521=HEAP32[(($520)>>2)];
      var $522=$48;
      HEAP32[(($48)>>2)]=$521;
      var $523=HEAP32[(($48)>>2)];
      var $524=$48;
      HEAP32[(($49)>>2)]=$523;
      __label__ = 59; break;
    case 59: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $525=HEAP32[(($49)>>2)];
      var $526=$49;
      var $527=$50;
      HEAP32[(($54)>>2)]=$525;
      __label__ = 60; break;
    case 60: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $528=HEAP32[(($54)>>2)];
      var $529=$54;
      var $530=$55;
      var $531=$46;
      var $532=$47;
      HEAP32[(($46)>>2)]=$528;
      HEAP32[(($47)>>2)]=-1;
      var $533=HEAP32[(($46)>>2)];
      var $534=HEAP32[(($47)>>2)];
      var $535=(($533)|0)==(($534)|0);
      var $536=$46;
      var $537=$47;
      if ($535) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $538
      var $539=(($470)|0);
      HEAP32[(($539)>>2)]=0;
      __label__ = 62; break;
    case 62: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $540=$56;
      var $541=$70;
      var $542=(($541+4)|0);
      $70=$542;
      __label__ = 64; break;
    case 63: // $543
      var $544=$68;
      HEAP32[(($544)>>2)]=4;
      __label__ = 64; break;
    case 64: // $545
      __label__ = 65; break;
    case 65: // $546
      __label__ = 66; break;
    case 66: // $547
      __label__ = 3; break;
    case 67: // $548
      var $549=$59;
      var $550=$60;
      HEAP32[(($59)>>2)]=$__b;
      HEAP32[(($60)>>2)]=$__e;
      var $551=HEAP32[(($59)>>2)];
      var $552=HEAP32[(($60)>>2)];
      var $553=$57;
      var $554=$58;
      HEAP32[(($57)>>2)]=$551;
      HEAP32[(($58)>>2)]=$552;
      var $555=HEAP32[(($57)>>2)];
      var $556=(($555)|0);
      var $557=HEAP32[(($556)>>2)];
      var $558=(($557)|0)==0;
      var $559=(($558)&1);
      var $560=HEAP32[(($58)>>2)];
      var $561=(($560)|0);
      var $562=HEAP32[(($561)>>2)];
      var $563=(($562)|0)==0;
      var $564=(($563)&1);
      var $565=(($559)|0)==(($564)|0);
      var $566=$57;
      var $567=$58;
      var $568=$59;
      var $569=$60;
      if ($565) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $570
      var $571=$68;
      var $572=HEAP32[(($571)>>2)];
      var $573=$572 | 2;
      HEAP32[(($571)>>2)]=$573;
      __label__ = 69; break;
    case 69: // $574
      var $575=$agg_result;
      var $576=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($575)>>2)]=HEAP32[(($576)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 70: // $577
      var $578=$73;
      var $579=$73;
      var $580=$74;
      var $581=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $579, tempValue);
      var $582=($581.f1 = $580, $581);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 71: // $583
      var $584=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 2;
}


function ___cxx_global_var_init15() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  var $5=__stackBase__;
  var $6=__stackBase__+4;
  $1=$this;
  $2=$__iob;
  $3=$__err;
  $4=$__tm;
  var $7=$1;
  var $8=$5;
  var $9=$__b;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($8)>>2)]=HEAP32[(($9)>>2)];
  var $10=$6;
  var $11=$__e;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($10)>>2)]=HEAP32[(($11)>>2)];
  var $12=$2;
  var $13=$3;
  var $14=$4;
  __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($agg_result, $7, $5, $6, $12, $13, $14, ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt)|0), ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt+32)|0));
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__w, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__wk;
      var $__i;
      var $6=__stackBase__;
      $1=$this;
      $2=$__w;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$7;
      var $9=(($8+8)|0);
      var $10=$9;
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=FUNCTION_TABLE[$14]($10);
      $__wk=$15;
      var $16=$3;
      var $17=$6;
      var $18=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];
      var $19=$__wk;
      var $20=$__wk;
      var $21=(($20+168)|0);
      var $22=$5;
      var $23=$4;
      var $24=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($16, $6, $19, $21, $22, $23, 0);
      var $25=$__wk;
      var $26=$24;
      var $27=$25;
      var $28=(($26-$27)|0);
      var $29=(((($28)|0)/12)|0);
      $__i=$29;
      var $30=$__i;
      var $31=(($30)|0) < 14;
      if ($31) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $32
      var $33=$__i;
      var $34=(($33)|0)%7;
      var $35=$2;
      HEAP32[(($35)>>2)]=$34;
      __label__ = 2; break;
    case 2: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__m, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__month;
      var $__i;
      var $6=__stackBase__;
      $1=$this;
      $2=$__m;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$7;
      var $9=(($8+8)|0);
      var $10=$9;
      var $11=$10;
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12+4)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=FUNCTION_TABLE[$14]($10);
      $__month=$15;
      var $16=$3;
      var $17=$6;
      var $18=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($17)>>2)]=HEAP32[(($18)>>2)];
      var $19=$__month;
      var $20=$__month;
      var $21=(($20+288)|0);
      var $22=$5;
      var $23=$4;
      var $24=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($16, $6, $19, $21, $22, $23, 0);
      var $25=$__month;
      var $26=$24;
      var $27=$25;
      var $28=(($26-$27)|0);
      var $29=(((($28)|0)/12)|0);
      $__i=$29;
      var $30=$__i;
      var $31=(($30)|0) < 24;
      if ($31) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $32
      var $33=$__i;
      var $34=(($33)|0)%12;
      var $35=$2;
      HEAP32[(($35)>>2)]=$34;
      __label__ = 2; break;
    case 2: // $36
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__y, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__y;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 4);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 8; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) < 69;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=(($22+2000)|0);
      $__t=$23;
      __label__ = 7; break;
    case 3: // $24
      var $25=$__t;
      var $26=69 <= (($25)|0);
      if ($26) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $27
      var $28=$__t;
      var $29=(($28)|0) <= 99;
      if ($29) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $30
      var $31=$__t;
      var $32=(($31+1900)|0);
      $__t=$32;
      __label__ = 6; break;
    case 6: // $33
      __label__ = 7; break;
    case 7: // $34
      var $35=$__t;
      var $36=(($35-1900)|0);
      var $37=$2;
      HEAP32[(($37)>>2)]=$36;
      __label__ = 8; break;
    case 8: // $38
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 144; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34;
      var $35;
      var $36;
      var $37;
      var $__ct;
      var $38=__stackBase__+132;
      var $39;
      var $40;
      var $__fmt;
      var $41=__stackBase__+136;
      var $42=__stackBase__+140;
      $34=$this;
      $35=$__iob;
      $36=$__err;
      $37=$__tm;
      var $43=$34;
      var $44=$35;
      __ZNKSt3__18ios_base6getlocEv($38, $44);
      var $45=$33;
      HEAP32[(($33)>>2)]=$38;
      var $46=HEAP32[(($33)>>2)];
      var $47=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($46, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 12; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $48=$47;
      var $49=$33;
      __label__ = 2; break;
    case 2: // $50
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($38);
      $__ct=$48;
      var $51=$43;
      var $52=(($51+8)|0);
      var $53=$52;
      var $54=$53;
      var $55=HEAP32[(($54)>>2)];
      var $56=(($55+20)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=FUNCTION_TABLE[$57]($53);
      $__fmt=$58;
      var $59=$41;
      var $60=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($59)>>2)]=HEAP32[(($60)>>2)];
      var $61=$42;
      var $62=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($61)>>2)]=HEAP32[(($62)>>2)];
      var $63=$35;
      var $64=$36;
      var $65=$37;
      var $66=$__fmt;
      var $67=$32;
      HEAP32[(($32)>>2)]=$66;
      var $68=HEAP32[(($32)>>2)];
      var $69=$31;
      HEAP32[(($31)>>2)]=$68;
      var $70=HEAPU32[(($31)>>2)];
      var $71=$30;
      HEAP32[(($30)>>2)]=$70;
      var $72=HEAP32[(($30)>>2)];
      var $73=(($72)|0);
      var $74=$29;
      HEAP32[(($29)>>2)]=$73;
      var $75=HEAP32[(($29)>>2)];
      var $76=$75;
      var $77=$28;
      HEAP32[(($28)>>2)]=$76;
      var $78=HEAP32[(($28)>>2)];
      var $79=(($78)|0);
      var $80=$28;
      var $81=$29;
      var $82=(($79)|0);
      var $83=$82;
      var $84=(($83)|0);
      var $85=$84;
      var $86=HEAPU8[($85)];
      var $87=(($86)&255);
      var $88=$87 & 1;
      var $89=(($88)|0)!=0;
      var $90=$30;
      if ($89) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $91
      var $92=$24;
      HEAP32[(($24)>>2)]=$70;
      var $93=HEAP32[(($24)>>2)];
      var $94=(($93)|0);
      var $95=$23;
      HEAP32[(($23)>>2)]=$94;
      var $96=HEAP32[(($23)>>2)];
      var $97=$96;
      var $98=$22;
      HEAP32[(($22)>>2)]=$97;
      var $99=HEAP32[(($22)>>2)];
      var $100=(($99)|0);
      var $101=$22;
      var $102=$23;
      var $103=(($100)|0);
      var $104=$103;
      var $105=(($104+8)|0);
      var $106=HEAP32[(($105)>>2)];
      var $107=$24;
      var $125 = $106;__label__ = 5; break;
    case 4: // $108
      var $109=$27;
      HEAP32[(($27)>>2)]=$70;
      var $110=HEAP32[(($27)>>2)];
      var $111=(($110)|0);
      var $112=$26;
      HEAP32[(($26)>>2)]=$111;
      var $113=HEAP32[(($26)>>2)];
      var $114=$113;
      var $115=$25;
      HEAP32[(($25)>>2)]=$114;
      var $116=HEAP32[(($25)>>2)];
      var $117=(($116)|0);
      var $118=$25;
      var $119=$26;
      var $120=(($117)|0);
      var $121=$120;
      var $122=(($121+4)|0);
      var $123=(($122)|0);
      var $124=$27;
      var $125 = $123;__label__ = 5; break;
    case 5: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit
      var $125;
      var $126=$31;
      var $127=$32;
      var $128=$__fmt;
      var $129=$21;
      HEAP32[(($21)>>2)]=$128;
      var $130=HEAP32[(($21)>>2)];
      var $131=$20;
      HEAP32[(($20)>>2)]=$130;
      var $132=HEAPU32[(($20)>>2)];
      var $133=$19;
      HEAP32[(($19)>>2)]=$132;
      var $134=HEAP32[(($19)>>2)];
      var $135=(($134)|0);
      var $136=$18;
      HEAP32[(($18)>>2)]=$135;
      var $137=HEAP32[(($18)>>2)];
      var $138=$137;
      var $139=$17;
      HEAP32[(($17)>>2)]=$138;
      var $140=HEAP32[(($17)>>2)];
      var $141=(($140)|0);
      var $142=$17;
      var $143=$18;
      var $144=(($141)|0);
      var $145=$144;
      var $146=(($145)|0);
      var $147=$146;
      var $148=HEAPU8[($147)];
      var $149=(($148)&255);
      var $150=$149 & 1;
      var $151=(($150)|0)!=0;
      var $152=$19;
      if ($151) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $153
      var $154=$13;
      HEAP32[(($13)>>2)]=$132;
      var $155=HEAP32[(($13)>>2)];
      var $156=(($155)|0);
      var $157=$12;
      HEAP32[(($12)>>2)]=$156;
      var $158=HEAP32[(($12)>>2)];
      var $159=$158;
      var $160=$11;
      HEAP32[(($11)>>2)]=$159;
      var $161=HEAP32[(($11)>>2)];
      var $162=(($161)|0);
      var $163=$11;
      var $164=$12;
      var $165=(($162)|0);
      var $166=$165;
      var $167=(($166+8)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=$13;
      var $187 = $168;__label__ = 8; break;
    case 7: // $170
      var $171=$16;
      HEAP32[(($16)>>2)]=$132;
      var $172=HEAP32[(($16)>>2)];
      var $173=(($172)|0);
      var $174=$15;
      HEAP32[(($15)>>2)]=$173;
      var $175=HEAP32[(($15)>>2)];
      var $176=$175;
      var $177=$14;
      HEAP32[(($14)>>2)]=$176;
      var $178=HEAP32[(($14)>>2)];
      var $179=(($178)|0);
      var $180=$14;
      var $181=$15;
      var $182=(($179)|0);
      var $183=$182;
      var $184=(($183+4)|0);
      var $185=(($184)|0);
      var $186=$16;
      var $187 = $185;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit1
      var $187;
      var $188=$20;
      var $189=$21;
      var $190=$__fmt;
      var $191=$10;
      HEAP32[(($10)>>2)]=$190;
      var $192=HEAPU32[(($10)>>2)];
      var $193=$9;
      HEAP32[(($9)>>2)]=$192;
      var $194=HEAP32[(($9)>>2)];
      var $195=(($194)|0);
      var $196=$8;
      HEAP32[(($8)>>2)]=$195;
      var $197=HEAP32[(($8)>>2)];
      var $198=$197;
      var $199=$7;
      HEAP32[(($7)>>2)]=$198;
      var $200=HEAP32[(($7)>>2)];
      var $201=(($200)|0);
      var $202=$7;
      var $203=$8;
      var $204=(($201)|0);
      var $205=$204;
      var $206=(($205)|0);
      var $207=$206;
      var $208=HEAPU8[($207)];
      var $209=(($208)&255);
      var $210=$209 & 1;
      var $211=(($210)|0)!=0;
      var $212=$9;
      if ($211) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $213
      var $214=$3;
      HEAP32[(($3)>>2)]=$192;
      var $215=HEAP32[(($3)>>2)];
      var $216=(($215)|0);
      var $217=$2;
      HEAP32[(($2)>>2)]=$216;
      var $218=HEAP32[(($2)>>2)];
      var $219=$218;
      var $220=$1;
      HEAP32[(($1)>>2)]=$219;
      var $221=HEAP32[(($1)>>2)];
      var $222=(($221)|0);
      var $223=$1;
      var $224=$2;
      var $225=(($222)|0);
      var $226=$225;
      var $227=(($226+4)|0);
      var $228=HEAP32[(($227)>>2)];
      var $229=$3;
      var $250 = $228;__label__ = 11; break;
    case 10: // $230
      var $231=$6;
      HEAP32[(($6)>>2)]=$192;
      var $232=HEAP32[(($6)>>2)];
      var $233=(($232)|0);
      var $234=$5;
      HEAP32[(($5)>>2)]=$233;
      var $235=HEAP32[(($5)>>2)];
      var $236=$235;
      var $237=$4;
      HEAP32[(($4)>>2)]=$236;
      var $238=HEAP32[(($4)>>2)];
      var $239=(($238)|0);
      var $240=$4;
      var $241=$5;
      var $242=(($239)|0);
      var $243=$242;
      var $244=(($243)|0);
      var $245=$244;
      var $246=HEAPU8[($245)];
      var $247=(($246)&255);
      var $248=$247 >> 1;
      var $249=$6;
      var $250 = $248;__label__ = 11; break;
    case 11: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $250;
      var $251=$10;
      var $252=(($187+($250<<2))|0);
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($agg_result, $43, $41, $42, $63, $64, $65, $125, $252);
      STACKTOP = __stackBase__;
      return;
    case 12: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $255=$254.f0;
      $39=$255;
      var $256=$254.f1;
      $40=$256;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $257
      __label__ = 14; break;
    case 14: // $258
      var $259=$39;
      var $260=$39;
      var $261=$40;
      var $262=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $260, tempValue);
      var $263=($262.f1 = $261, $262);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 15: // $264
      var $265=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__ct;
      var $6=__stackBase__+4;
      var $7;
      var $8;
      var $9=__stackBase__+8;
      $2=$this;
      $3=$__iob;
      $4=$__err;
      $5=$__tm;
      var $10=$2;
      var $11=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $11);
      var $12=$1;
      HEAP32[(($1)>>2)]=$6;
      var $13=HEAP32[(($1)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $15=$14;
      var $16=$1;
      __label__ = 2; break;
    case 2: // $17
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      $__ct=$15;
      var $18=$5;
      var $19=(($18+24)|0);
      var $20=$9;
      var $21=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];
      var $22=$4;
      var $23=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE($10, $19, $__b, $9, $22, $23);
      var $24=$agg_result;
      var $25=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $7=$28;
      var $29=$27.f1;
      $8=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$7;
      var $33=$7;
      var $34=$8;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__ct;
      var $6=__stackBase__+4;
      var $7;
      var $8;
      var $9=__stackBase__+8;
      $2=$this;
      $3=$__iob;
      $4=$__err;
      $5=$__tm;
      var $10=$2;
      var $11=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $11);
      var $12=$1;
      HEAP32[(($1)>>2)]=$6;
      var $13=HEAP32[(($1)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $15=$14;
      var $16=$1;
      __label__ = 2; break;
    case 2: // $17
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      $__ct=$15;
      var $18=$5;
      var $19=(($18+16)|0);
      var $20=$9;
      var $21=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];
      var $22=$4;
      var $23=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE($10, $19, $__b, $9, $22, $23);
      var $24=$agg_result;
      var $25=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $7=$28;
      var $29=$27.f1;
      $8=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$7;
      var $33=$7;
      var $34=$8;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__ct;
      var $6=__stackBase__+4;
      var $7;
      var $8;
      var $9=__stackBase__+8;
      $2=$this;
      $3=$__iob;
      $4=$__err;
      $5=$__tm;
      var $10=$2;
      var $11=$3;
      __ZNKSt3__18ios_base6getlocEv($6, $11);
      var $12=$1;
      HEAP32[(($1)>>2)]=$6;
      var $13=HEAP32[(($1)>>2)];
      var $14=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($13, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $15=$14;
      var $16=$1;
      __label__ = 2; break;
    case 2: // $17
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6);
      $__ct=$15;
      var $18=$5;
      var $19=(($18+20)|0);
      var $20=$9;
      var $21=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($20)>>2)]=HEAP32[(($21)>>2)];
      var $22=$4;
      var $23=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE($10, $19, $__b, $9, $22, $23);
      var $24=$agg_result;
      var $25=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($24)>>2)]=HEAP32[(($25)>>2)];
      STACKTOP = __stackBase__;
      return;
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $7=$28;
      var $29=$27.f1;
      $8=$29;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      __label__ = 5; break;
    case 5: // $31
      var $32=$7;
      var $33=$7;
      var $34=$8;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $37
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc($agg_result, $this, $__b, $__e, $__iob, $__err, $__tm, $__fmt, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 416; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $18=__stackBase__+64;
      var $19=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      var $25=__stackBase__+92;
      var $26=__stackBase__+96;
      var $27=__stackBase__+100;
      var $28=__stackBase__+104;
      var $29=__stackBase__+108;
      var $30=__stackBase__+112;
      var $31=__stackBase__+116;
      var $32=__stackBase__+120;
      var $33=__stackBase__+124;
      var $34=__stackBase__+128;
      var $35=__stackBase__+132;
      var $36=__stackBase__+136;
      var $37=__stackBase__+140;
      var $38=__stackBase__+144;
      var $39=__stackBase__+148;
      var $40=__stackBase__+152;
      var $41=__stackBase__+156;
      var $42=__stackBase__+160;
      var $43=__stackBase__+164;
      var $44=__stackBase__+168;
      var $45=__stackBase__+172;
      var $46=__stackBase__+176;
      var $47=__stackBase__+180;
      var $48=__stackBase__+184;
      var $49=__stackBase__+188;
      var $50=__stackBase__+192;
      var $51=__stackBase__+196;
      var $52=__stackBase__+200;
      var $53=__stackBase__+204;
      var $54=__stackBase__+208;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $57=__stackBase__+220;
      var $58=__stackBase__+224;
      var $59=__stackBase__+228;
      var $60=__stackBase__+232;
      var $61=__stackBase__+236;
      var $62=__stackBase__+240;
      var $63=__stackBase__+244;
      var $64=__stackBase__+248;
      var $65=__stackBase__+252;
      var $66=__stackBase__+256;
      var $67;
      var $68;
      var $69;
      var $70;
      var $71;
      var $72;
      var $__ct;
      var $73=__stackBase__+260;
      var $74;
      var $75;
      var $76=__stackBase__+264;
      var $77=__stackBase__+268;
      var $__fmt1;
      var $78=__stackBase__+272;
      var $79=__stackBase__+276;
      var $80=__stackBase__+280;
      var $81=__stackBase__+284;
      var $82=__stackBase__+288;
      var $83=__stackBase__+292;
      var $84=__stackBase__+296;
      var $85=__stackBase__+300;
      var $86=__stackBase__+304;
      var $87=__stackBase__+308;
      var $88=__stackBase__+312;
      var $89=__stackBase__+316;
      var $90=__stackBase__+320;
      var $91=__stackBase__+324;
      var $92=__stackBase__+328;
      var $93=__stackBase__+332;
      var $94=__stackBase__+336;
      var $95=__stackBase__+340;
      var $96=__stackBase__+344;
      var $97=__stackBase__+348;
      var $98=__stackBase__+352;
      var $99=__stackBase__+356;
      var $100=__stackBase__+360;
      var $101=__stackBase__+364;
      var $102=__stackBase__+368;
      var $103=__stackBase__+372;
      var $104=__stackBase__+376;
      var $105=__stackBase__+380;
      var $106=__stackBase__+384;
      var $107=__stackBase__+388;
      var $__fmt2;
      var $108=__stackBase__+392;
      var $109=__stackBase__+396;
      var $110=__stackBase__+400;
      var $111=__stackBase__+404;
      var $112=__stackBase__+408;
      var $113=__stackBase__+412;
      $67=$this;
      $68=$__iob;
      $69=$__err;
      $70=$__tm;
      $71=$__fmt;
      $72=$0;
      var $114=$67;
      var $115=$69;
      HEAP32[(($115)>>2)]=0;
      var $116=$68;
      __ZNKSt3__18ios_base6getlocEv($73, $116);
      var $117=$66;
      HEAP32[(($66)>>2)]=$73;
      var $118=HEAP32[(($66)>>2)];
      var $119=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($118, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $120=$119;
      var $121=$66;
      __label__ = 2; break;
    case 2: // $122
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($73);
      $__ct=$120;
      var $123=$71;
      var $124=(($123 << 24) >> 24);
      if ($124 == 97 || $124 == 65) {
        __label__ = 5; break;
      }
      else if ($124 == 98 || $124 == 66 || $124 == 104) {
        __label__ = 6; break;
      }
      else if ($124 == 99) {
        __label__ = 7; break;
      }
      else if ($124 == 100 || $124 == 101) {
        __label__ = 17; break;
      }
      else if ($124 == 68) {
        __label__ = 18; break;
      }
      else if ($124 == 70) {
        __label__ = 19; break;
      }
      else if ($124 == 72) {
        __label__ = 20; break;
      }
      else if ($124 == 73) {
        __label__ = 21; break;
      }
      else if ($124 == 106) {
        __label__ = 22; break;
      }
      else if ($124 == 109) {
        __label__ = 23; break;
      }
      else if ($124 == 77) {
        __label__ = 24; break;
      }
      else if ($124 == 110 || $124 == 116) {
        __label__ = 25; break;
      }
      else if ($124 == 112) {
        __label__ = 26; break;
      }
      else if ($124 == 114) {
        __label__ = 27; break;
      }
      else if ($124 == 82) {
        __label__ = 28; break;
      }
      else if ($124 == 83) {
        __label__ = 29; break;
      }
      else if ($124 == 84) {
        __label__ = 30; break;
      }
      else if ($124 == 119) {
        __label__ = 31; break;
      }
      else if ($124 == 120) {
        __label__ = 32; break;
      }
      else if ($124 == 88) {
        __label__ = 33; break;
      }
      else if ($124 == 121) {
        __label__ = 43; break;
      }
      else if ($124 == 89) {
        __label__ = 44; break;
      }
      else if ($124 == 37) {
        __label__ = 45; break;
      }
      else {
      __label__ = 46; break;
      }
      
    case 3: // $125
      var $126=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $127=$126.f0;
      $74=$127;
      var $128=$126.f1;
      $75=$128;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 50; break; }
    case 4: // $129
      __label__ = 49; break;
    case 5: // $130
      var $131=$70;
      var $132=(($131+24)|0);
      var $133=$76;
      var $134=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($133)>>2)]=HEAP32[(($134)>>2)];
      var $135=$69;
      var $136=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE($114, $132, $__b, $76, $135, $136);
      __label__ = 47; break;
    case 6: // $137
      var $138=$70;
      var $139=(($138+16)|0);
      var $140=$77;
      var $141=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($140)>>2)]=HEAP32[(($141)>>2)];
      var $142=$69;
      var $143=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE($114, $139, $__b, $77, $142, $143);
      __label__ = 47; break;
    case 7: // $144
      var $145=$114;
      var $146=(($145+8)|0);
      var $147=$146;
      var $148=$147;
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+12)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=FUNCTION_TABLE[$151]($147);
      $__fmt1=$152;
      var $153=$79;
      var $154=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($153)>>2)]=HEAP32[(($154)>>2)];
      var $155=$80;
      var $156=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($155)>>2)]=HEAP32[(($156)>>2)];
      var $157=$68;
      var $158=$69;
      var $159=$70;
      var $160=$__fmt1;
      var $161=$65;
      HEAP32[(($65)>>2)]=$160;
      var $162=HEAP32[(($65)>>2)];
      var $163=$64;
      HEAP32[(($64)>>2)]=$162;
      var $164=HEAPU32[(($64)>>2)];
      var $165=$63;
      HEAP32[(($63)>>2)]=$164;
      var $166=HEAP32[(($63)>>2)];
      var $167=(($166)|0);
      var $168=$62;
      HEAP32[(($62)>>2)]=$167;
      var $169=HEAP32[(($62)>>2)];
      var $170=$169;
      var $171=$61;
      HEAP32[(($61)>>2)]=$170;
      var $172=HEAP32[(($61)>>2)];
      var $173=(($172)|0);
      var $174=$61;
      var $175=$62;
      var $176=(($173)|0);
      var $177=$176;
      var $178=(($177)|0);
      var $179=$178;
      var $180=HEAPU8[($179)];
      var $181=(($180)&255);
      var $182=$181 & 1;
      var $183=(($182)|0)!=0;
      var $184=$63;
      if ($183) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $185
      var $186=$57;
      HEAP32[(($57)>>2)]=$164;
      var $187=HEAP32[(($57)>>2)];
      var $188=(($187)|0);
      var $189=$56;
      HEAP32[(($56)>>2)]=$188;
      var $190=HEAP32[(($56)>>2)];
      var $191=$190;
      var $192=$55;
      HEAP32[(($55)>>2)]=$191;
      var $193=HEAP32[(($55)>>2)];
      var $194=(($193)|0);
      var $195=$55;
      var $196=$56;
      var $197=(($194)|0);
      var $198=$197;
      var $199=(($198+8)|0);
      var $200=HEAP32[(($199)>>2)];
      var $201=$57;
      var $219 = $200;__label__ = 10; break;
    case 9: // $202
      var $203=$60;
      HEAP32[(($60)>>2)]=$164;
      var $204=HEAP32[(($60)>>2)];
      var $205=(($204)|0);
      var $206=$59;
      HEAP32[(($59)>>2)]=$205;
      var $207=HEAP32[(($59)>>2)];
      var $208=$207;
      var $209=$58;
      HEAP32[(($58)>>2)]=$208;
      var $210=HEAP32[(($58)>>2)];
      var $211=(($210)|0);
      var $212=$58;
      var $213=$59;
      var $214=(($211)|0);
      var $215=$214;
      var $216=(($215+4)|0);
      var $217=(($216)|0);
      var $218=$60;
      var $219 = $217;__label__ = 10; break;
    case 10: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit
      var $219;
      var $220=$64;
      var $221=$65;
      var $222=$__fmt1;
      var $223=$54;
      HEAP32[(($54)>>2)]=$222;
      var $224=HEAP32[(($54)>>2)];
      var $225=$53;
      HEAP32[(($53)>>2)]=$224;
      var $226=HEAPU32[(($53)>>2)];
      var $227=$52;
      HEAP32[(($52)>>2)]=$226;
      var $228=HEAP32[(($52)>>2)];
      var $229=(($228)|0);
      var $230=$51;
      HEAP32[(($51)>>2)]=$229;
      var $231=HEAP32[(($51)>>2)];
      var $232=$231;
      var $233=$50;
      HEAP32[(($50)>>2)]=$232;
      var $234=HEAP32[(($50)>>2)];
      var $235=(($234)|0);
      var $236=$50;
      var $237=$51;
      var $238=(($235)|0);
      var $239=$238;
      var $240=(($239)|0);
      var $241=$240;
      var $242=HEAPU8[($241)];
      var $243=(($242)&255);
      var $244=$243 & 1;
      var $245=(($244)|0)!=0;
      var $246=$52;
      if ($245) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $247
      var $248=$46;
      HEAP32[(($46)>>2)]=$226;
      var $249=HEAP32[(($46)>>2)];
      var $250=(($249)|0);
      var $251=$45;
      HEAP32[(($45)>>2)]=$250;
      var $252=HEAP32[(($45)>>2)];
      var $253=$252;
      var $254=$44;
      HEAP32[(($44)>>2)]=$253;
      var $255=HEAP32[(($44)>>2)];
      var $256=(($255)|0);
      var $257=$44;
      var $258=$45;
      var $259=(($256)|0);
      var $260=$259;
      var $261=(($260+8)|0);
      var $262=HEAP32[(($261)>>2)];
      var $263=$46;
      var $281 = $262;__label__ = 13; break;
    case 12: // $264
      var $265=$49;
      HEAP32[(($49)>>2)]=$226;
      var $266=HEAP32[(($49)>>2)];
      var $267=(($266)|0);
      var $268=$48;
      HEAP32[(($48)>>2)]=$267;
      var $269=HEAP32[(($48)>>2)];
      var $270=$269;
      var $271=$47;
      HEAP32[(($47)>>2)]=$270;
      var $272=HEAP32[(($47)>>2)];
      var $273=(($272)|0);
      var $274=$47;
      var $275=$48;
      var $276=(($273)|0);
      var $277=$276;
      var $278=(($277+4)|0);
      var $279=(($278)|0);
      var $280=$49;
      var $281 = $279;__label__ = 13; break;
    case 13: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit3
      var $281;
      var $282=$53;
      var $283=$54;
      var $284=$__fmt1;
      var $285=$43;
      HEAP32[(($43)>>2)]=$284;
      var $286=HEAPU32[(($43)>>2)];
      var $287=$42;
      HEAP32[(($42)>>2)]=$286;
      var $288=HEAP32[(($42)>>2)];
      var $289=(($288)|0);
      var $290=$41;
      HEAP32[(($41)>>2)]=$289;
      var $291=HEAP32[(($41)>>2)];
      var $292=$291;
      var $293=$40;
      HEAP32[(($40)>>2)]=$292;
      var $294=HEAP32[(($40)>>2)];
      var $295=(($294)|0);
      var $296=$40;
      var $297=$41;
      var $298=(($295)|0);
      var $299=$298;
      var $300=(($299)|0);
      var $301=$300;
      var $302=HEAPU8[($301)];
      var $303=(($302)&255);
      var $304=$303 & 1;
      var $305=(($304)|0)!=0;
      var $306=$42;
      if ($305) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $307
      var $308=$36;
      HEAP32[(($36)>>2)]=$286;
      var $309=HEAP32[(($36)>>2)];
      var $310=(($309)|0);
      var $311=$35;
      HEAP32[(($35)>>2)]=$310;
      var $312=HEAP32[(($35)>>2)];
      var $313=$312;
      var $314=$34;
      HEAP32[(($34)>>2)]=$313;
      var $315=HEAP32[(($34)>>2)];
      var $316=(($315)|0);
      var $317=$34;
      var $318=$35;
      var $319=(($316)|0);
      var $320=$319;
      var $321=(($320+4)|0);
      var $322=HEAP32[(($321)>>2)];
      var $323=$36;
      var $344 = $322;__label__ = 16; break;
    case 15: // $324
      var $325=$39;
      HEAP32[(($39)>>2)]=$286;
      var $326=HEAP32[(($39)>>2)];
      var $327=(($326)|0);
      var $328=$38;
      HEAP32[(($38)>>2)]=$327;
      var $329=HEAP32[(($38)>>2)];
      var $330=$329;
      var $331=$37;
      HEAP32[(($37)>>2)]=$330;
      var $332=HEAP32[(($37)>>2)];
      var $333=(($332)|0);
      var $334=$37;
      var $335=$38;
      var $336=(($333)|0);
      var $337=$336;
      var $338=(($337)|0);
      var $339=$338;
      var $340=HEAPU8[($339)];
      var $341=(($340)&255);
      var $342=$341 >> 1;
      var $343=$39;
      var $344 = $342;__label__ = 16; break;
    case 16: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $344;
      var $345=$43;
      var $346=(($281+($344<<2))|0);
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($78, $114, $79, $80, $157, $158, $159, $219, $346);
      var $347=$__b;
      var $348=$78;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($347)>>2)]=HEAP32[(($348)>>2)];
      __label__ = 47; break;
    case 17: // $349
      var $350=$70;
      var $351=(($350+12)|0);
      var $352=$81;
      var $353=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($352)>>2)]=HEAP32[(($353)>>2)];
      var $354=$69;
      var $355=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE($114, $351, $__b, $81, $354, $355);
      __label__ = 47; break;
    case 18: // $356
      var $357=$83;
      var $358=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($357)>>2)]=HEAP32[(($358)>>2)];
      var $359=$84;
      var $360=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($359)>>2)]=HEAP32[(($360)>>2)];
      var $361=$68;
      var $362=$69;
      var $363=$70;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($82, $114, $83, $84, $361, $362, $363, ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt)|0), ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt+32)|0));
      var $364=$__b;
      var $365=$82;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($364)>>2)]=HEAP32[(($365)>>2)];
      __label__ = 47; break;
    case 19: // $366
      var $367=$86;
      var $368=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($367)>>2)]=HEAP32[(($368)>>2)];
      var $369=$87;
      var $370=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($369)>>2)]=HEAP32[(($370)>>2)];
      var $371=$68;
      var $372=$69;
      var $373=$70;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($85, $114, $86, $87, $371, $372, $373, ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt16)|0), ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt16+32)|0));
      var $374=$__b;
      var $375=$85;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($374)>>2)]=HEAP32[(($375)>>2)];
      __label__ = 47; break;
    case 20: // $376
      var $377=$70;
      var $378=(($377+8)|0);
      var $379=$88;
      var $380=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($379)>>2)]=HEAP32[(($380)>>2)];
      var $381=$69;
      var $382=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE($114, $378, $__b, $88, $381, $382);
      __label__ = 47; break;
    case 21: // $383
      var $384=$70;
      var $385=(($384+8)|0);
      var $386=$89;
      var $387=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($386)>>2)]=HEAP32[(($387)>>2)];
      var $388=$69;
      var $389=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE($114, $385, $__b, $89, $388, $389);
      __label__ = 47; break;
    case 22: // $390
      var $391=$70;
      var $392=(($391+28)|0);
      var $393=$90;
      var $394=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($393)>>2)]=HEAP32[(($394)>>2)];
      var $395=$69;
      var $396=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE($114, $392, $__b, $90, $395, $396);
      __label__ = 47; break;
    case 23: // $397
      var $398=$70;
      var $399=(($398+16)|0);
      var $400=$91;
      var $401=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($400)>>2)]=HEAP32[(($401)>>2)];
      var $402=$69;
      var $403=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE($114, $399, $__b, $91, $402, $403);
      __label__ = 47; break;
    case 24: // $404
      var $405=$70;
      var $406=(($405+4)|0);
      var $407=$92;
      var $408=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($407)>>2)]=HEAP32[(($408)>>2)];
      var $409=$69;
      var $410=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE($114, $406, $__b, $92, $409, $410);
      __label__ = 47; break;
    case 25: // $411
      var $412=$93;
      var $413=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($412)>>2)]=HEAP32[(($413)>>2)];
      var $414=$69;
      var $415=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE($114, $__b, $93, $414, $415);
      __label__ = 47; break;
    case 26: // $416
      var $417=$70;
      var $418=(($417+8)|0);
      var $419=$94;
      var $420=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($419)>>2)]=HEAP32[(($420)>>2)];
      var $421=$69;
      var $422=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE($114, $418, $__b, $94, $421, $422);
      __label__ = 47; break;
    case 27: // $423
      var $424=$96;
      var $425=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($424)>>2)]=HEAP32[(($425)>>2)];
      var $426=$97;
      var $427=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($426)>>2)]=HEAP32[(($427)>>2)];
      var $428=$68;
      var $429=$69;
      var $430=$70;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($95, $114, $96, $97, $428, $429, $430, ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt17)|0), ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt17+44)|0));
      var $431=$__b;
      var $432=$95;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($431)>>2)]=HEAP32[(($432)>>2)];
      __label__ = 47; break;
    case 28: // $433
      var $434=$99;
      var $435=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($434)>>2)]=HEAP32[(($435)>>2)];
      var $436=$100;
      var $437=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($436)>>2)]=HEAP32[(($437)>>2)];
      var $438=$68;
      var $439=$69;
      var $440=$70;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($98, $114, $99, $100, $438, $439, $440, ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt18)|0), ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt18+20)|0));
      var $441=$__b;
      var $442=$98;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($441)>>2)]=HEAP32[(($442)>>2)];
      __label__ = 47; break;
    case 29: // $443
      var $444=$70;
      var $445=(($444)|0);
      var $446=$101;
      var $447=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($446)>>2)]=HEAP32[(($447)>>2)];
      var $448=$69;
      var $449=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE($114, $445, $__b, $101, $448, $449);
      __label__ = 47; break;
    case 30: // $450
      var $451=$103;
      var $452=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($451)>>2)]=HEAP32[(($452)>>2)];
      var $453=$104;
      var $454=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($453)>>2)]=HEAP32[(($454)>>2)];
      var $455=$68;
      var $456=$69;
      var $457=$70;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($102, $114, $103, $104, $455, $456, $457, ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt19)|0), ((__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt19+32)|0));
      var $458=$__b;
      var $459=$102;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($458)>>2)]=HEAP32[(($459)>>2)];
      __label__ = 47; break;
    case 31: // $460
      var $461=$70;
      var $462=(($461+24)|0);
      var $463=$105;
      var $464=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($463)>>2)]=HEAP32[(($464)>>2)];
      var $465=$69;
      var $466=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE($114, $462, $__b, $105, $465, $466);
      __label__ = 47; break;
    case 32: // $467
      var $468=$114;
      var $469=HEAP32[(($468)>>2)];
      var $470=(($469+20)|0);
      var $471=HEAP32[(($470)>>2)];
      var $472=$106;
      var $473=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($472)>>2)]=HEAP32[(($473)>>2)];
      var $474=$107;
      var $475=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($474)>>2)]=HEAP32[(($475)>>2)];
      var $476=$68;
      var $477=$69;
      var $478=$70;
      FUNCTION_TABLE[$471]($agg_result, $114, $106, $107, $476, $477, $478);
      __label__ = 48; break;
    case 33: // $479
      var $480=$114;
      var $481=(($480+8)|0);
      var $482=$481;
      var $483=$482;
      var $484=HEAP32[(($483)>>2)];
      var $485=(($484+24)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=FUNCTION_TABLE[$486]($482);
      $__fmt2=$487;
      var $488=$109;
      var $489=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($488)>>2)]=HEAP32[(($489)>>2)];
      var $490=$110;
      var $491=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($490)>>2)]=HEAP32[(($491)>>2)];
      var $492=$68;
      var $493=$69;
      var $494=$70;
      var $495=$__fmt2;
      var $496=$33;
      HEAP32[(($33)>>2)]=$495;
      var $497=HEAP32[(($33)>>2)];
      var $498=$32;
      HEAP32[(($32)>>2)]=$497;
      var $499=HEAPU32[(($32)>>2)];
      var $500=$31;
      HEAP32[(($31)>>2)]=$499;
      var $501=HEAP32[(($31)>>2)];
      var $502=(($501)|0);
      var $503=$30;
      HEAP32[(($30)>>2)]=$502;
      var $504=HEAP32[(($30)>>2)];
      var $505=$504;
      var $506=$29;
      HEAP32[(($29)>>2)]=$505;
      var $507=HEAP32[(($29)>>2)];
      var $508=(($507)|0);
      var $509=$29;
      var $510=$30;
      var $511=(($508)|0);
      var $512=$511;
      var $513=(($512)|0);
      var $514=$513;
      var $515=HEAPU8[($514)];
      var $516=(($515)&255);
      var $517=$516 & 1;
      var $518=(($517)|0)!=0;
      var $519=$31;
      if ($518) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $520
      var $521=$25;
      HEAP32[(($25)>>2)]=$499;
      var $522=HEAP32[(($25)>>2)];
      var $523=(($522)|0);
      var $524=$24;
      HEAP32[(($24)>>2)]=$523;
      var $525=HEAP32[(($24)>>2)];
      var $526=$525;
      var $527=$23;
      HEAP32[(($23)>>2)]=$526;
      var $528=HEAP32[(($23)>>2)];
      var $529=(($528)|0);
      var $530=$23;
      var $531=$24;
      var $532=(($529)|0);
      var $533=$532;
      var $534=(($533+8)|0);
      var $535=HEAP32[(($534)>>2)];
      var $536=$25;
      var $554 = $535;__label__ = 36; break;
    case 35: // $537
      var $538=$28;
      HEAP32[(($28)>>2)]=$499;
      var $539=HEAP32[(($28)>>2)];
      var $540=(($539)|0);
      var $541=$27;
      HEAP32[(($27)>>2)]=$540;
      var $542=HEAP32[(($27)>>2)];
      var $543=$542;
      var $544=$26;
      HEAP32[(($26)>>2)]=$543;
      var $545=HEAP32[(($26)>>2)];
      var $546=(($545)|0);
      var $547=$26;
      var $548=$27;
      var $549=(($546)|0);
      var $550=$549;
      var $551=(($550+4)|0);
      var $552=(($551)|0);
      var $553=$28;
      var $554 = $552;__label__ = 36; break;
    case 36: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit4
      var $554;
      var $555=$32;
      var $556=$33;
      var $557=$__fmt2;
      var $558=$22;
      HEAP32[(($22)>>2)]=$557;
      var $559=HEAP32[(($22)>>2)];
      var $560=$21;
      HEAP32[(($21)>>2)]=$559;
      var $561=HEAPU32[(($21)>>2)];
      var $562=$20;
      HEAP32[(($20)>>2)]=$561;
      var $563=HEAP32[(($20)>>2)];
      var $564=(($563)|0);
      var $565=$19;
      HEAP32[(($19)>>2)]=$564;
      var $566=HEAP32[(($19)>>2)];
      var $567=$566;
      var $568=$18;
      HEAP32[(($18)>>2)]=$567;
      var $569=HEAP32[(($18)>>2)];
      var $570=(($569)|0);
      var $571=$18;
      var $572=$19;
      var $573=(($570)|0);
      var $574=$573;
      var $575=(($574)|0);
      var $576=$575;
      var $577=HEAPU8[($576)];
      var $578=(($577)&255);
      var $579=$578 & 1;
      var $580=(($579)|0)!=0;
      var $581=$20;
      if ($580) { __label__ = 37; break; } else { __label__ = 38; break; }
    case 37: // $582
      var $583=$14;
      HEAP32[(($14)>>2)]=$561;
      var $584=HEAP32[(($14)>>2)];
      var $585=(($584)|0);
      var $586=$13;
      HEAP32[(($13)>>2)]=$585;
      var $587=HEAP32[(($13)>>2)];
      var $588=$587;
      var $589=$12;
      HEAP32[(($12)>>2)]=$588;
      var $590=HEAP32[(($12)>>2)];
      var $591=(($590)|0);
      var $592=$12;
      var $593=$13;
      var $594=(($591)|0);
      var $595=$594;
      var $596=(($595+8)|0);
      var $597=HEAP32[(($596)>>2)];
      var $598=$14;
      var $616 = $597;__label__ = 39; break;
    case 38: // $599
      var $600=$17;
      HEAP32[(($17)>>2)]=$561;
      var $601=HEAP32[(($17)>>2)];
      var $602=(($601)|0);
      var $603=$16;
      HEAP32[(($16)>>2)]=$602;
      var $604=HEAP32[(($16)>>2)];
      var $605=$604;
      var $606=$15;
      HEAP32[(($15)>>2)]=$605;
      var $607=HEAP32[(($15)>>2)];
      var $608=(($607)|0);
      var $609=$15;
      var $610=$16;
      var $611=(($608)|0);
      var $612=$611;
      var $613=(($612+4)|0);
      var $614=(($613)|0);
      var $615=$17;
      var $616 = $614;__label__ = 39; break;
    case 39: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit5
      var $616;
      var $617=$21;
      var $618=$22;
      var $619=$__fmt2;
      var $620=$11;
      HEAP32[(($11)>>2)]=$619;
      var $621=HEAPU32[(($11)>>2)];
      var $622=$10;
      HEAP32[(($10)>>2)]=$621;
      var $623=HEAP32[(($10)>>2)];
      var $624=(($623)|0);
      var $625=$9;
      HEAP32[(($9)>>2)]=$624;
      var $626=HEAP32[(($9)>>2)];
      var $627=$626;
      var $628=$8;
      HEAP32[(($8)>>2)]=$627;
      var $629=HEAP32[(($8)>>2)];
      var $630=(($629)|0);
      var $631=$8;
      var $632=$9;
      var $633=(($630)|0);
      var $634=$633;
      var $635=(($634)|0);
      var $636=$635;
      var $637=HEAPU8[($636)];
      var $638=(($637)&255);
      var $639=$638 & 1;
      var $640=(($639)|0)!=0;
      var $641=$10;
      if ($640) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $642
      var $643=$4;
      HEAP32[(($4)>>2)]=$621;
      var $644=HEAP32[(($4)>>2)];
      var $645=(($644)|0);
      var $646=$3;
      HEAP32[(($3)>>2)]=$645;
      var $647=HEAP32[(($3)>>2)];
      var $648=$647;
      var $649=$2;
      HEAP32[(($2)>>2)]=$648;
      var $650=HEAP32[(($2)>>2)];
      var $651=(($650)|0);
      var $652=$2;
      var $653=$3;
      var $654=(($651)|0);
      var $655=$654;
      var $656=(($655+4)|0);
      var $657=HEAP32[(($656)>>2)];
      var $658=$4;
      var $679 = $657;__label__ = 42; break;
    case 41: // $659
      var $660=$7;
      HEAP32[(($7)>>2)]=$621;
      var $661=HEAP32[(($7)>>2)];
      var $662=(($661)|0);
      var $663=$6;
      HEAP32[(($6)>>2)]=$662;
      var $664=HEAP32[(($6)>>2)];
      var $665=$664;
      var $666=$5;
      HEAP32[(($5)>>2)]=$665;
      var $667=HEAP32[(($5)>>2)];
      var $668=(($667)|0);
      var $669=$5;
      var $670=$6;
      var $671=(($668)|0);
      var $672=$671;
      var $673=(($672)|0);
      var $674=$673;
      var $675=HEAPU8[($674)];
      var $676=(($675)&255);
      var $677=$676 >> 1;
      var $678=$7;
      var $679 = $677;__label__ = 42; break;
    case 42: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit6
      var $679;
      var $680=$11;
      var $681=(($616+($679<<2))|0);
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_($108, $114, $109, $110, $492, $493, $494, $554, $681);
      var $682=$__b;
      var $683=$108;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($682)>>2)]=HEAP32[(($683)>>2)];
      __label__ = 47; break;
    case 43: // $684
      var $685=$70;
      var $686=(($685+20)|0);
      var $687=$111;
      var $688=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($687)>>2)]=HEAP32[(($688)>>2)];
      var $689=$69;
      var $690=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE($114, $686, $__b, $111, $689, $690);
      __label__ = 47; break;
    case 44: // $691
      var $692=$70;
      var $693=(($692+20)|0);
      var $694=$112;
      var $695=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($694)>>2)]=HEAP32[(($695)>>2)];
      var $696=$69;
      var $697=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE($114, $693, $__b, $112, $696, $697);
      __label__ = 47; break;
    case 45: // $698
      var $699=$113;
      var $700=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($699)>>2)]=HEAP32[(($700)>>2)];
      var $701=$69;
      var $702=$__ct;
      __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE($114, $__b, $113, $701, $702);
      __label__ = 47; break;
    case 46: // $703
      var $704=$69;
      var $705=HEAP32[(($704)>>2)];
      var $706=$705 | 4;
      HEAP32[(($704)>>2)]=$706;
      __label__ = 47; break;
    case 47: // $707
      var $708=$agg_result;
      var $709=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($708)>>2)]=HEAP32[(($709)>>2)];
      __label__ = 48; break;
    case 48: // $710
      STACKTOP = __stackBase__;
      return;
    case 49: // $711
      var $712=$74;
      var $713=$74;
      var $714=$75;
      var $715=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $713, tempValue);
      var $716=($715.f1 = $714, $715);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 50: // $717
      var $718=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__d, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__d;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=1 <= (($19)|0);
      if ($20) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $22=$__t;
      var $23=(($22)|0) <= 31;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$__t;
      var $26=$2;
      HEAP32[(($26)>>2)]=$25;
      __label__ = 5; break;
    case 4: // $27
      var $28=$4;
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 | 4;
      HEAP32[(($28)>>2)]=$30;
      __label__ = 5; break;
    case 5: // $31
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__h, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__h;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 23;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__h, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__h;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=1 <= (($19)|0);
      if ($20) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $21
      var $22=$__t;
      var $23=(($22)|0) <= 12;
      if ($23) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $24
      var $25=$__t;
      var $26=$2;
      HEAP32[(($26)>>2)]=$25;
      __label__ = 5; break;
    case 4: // $27
      var $28=$4;
      var $29=HEAP32[(($28)>>2)];
      var $30=$29 | 4;
      HEAP32[(($28)>>2)]=$30;
      __label__ = 5; break;
    case 5: // $31
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__d, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__d;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 3);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 365;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__m, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__m;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      var $14=(($13-1)|0);
      $__t=$14;
      var $15=$4;
      var $16=HEAP32[(($15)>>2)];
      var $17=$16 & 4;
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $19
      var $20=$__t;
      var $21=(($20)|0) <= 11;
      if ($21) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $22
      var $23=$__t;
      var $24=$2;
      HEAP32[(($24)>>2)]=$23;
      __label__ = 4; break;
    case 3: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=$27 | 4;
      HEAP32[(($26)>>2)]=$28;
      __label__ = 4; break;
    case 4: // $29
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__m, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__m;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 59;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE($this, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27;
      var $28;
      var $29;
      var $30;
      $27=$this;
      $28=$__b;
      $29=$__err;
      $30=$__ct;
      var $31=$27;
      __label__ = 1; break;
    case 1: // $32
      var $33=$28;
      var $34=$25;
      var $35=$26;
      HEAP32[(($25)>>2)]=$33;
      HEAP32[(($26)>>2)]=$__e;
      var $36=HEAP32[(($25)>>2)];
      var $37=HEAP32[(($26)>>2)];
      var $38=$23;
      var $39=$24;
      HEAP32[(($23)>>2)]=$36;
      HEAP32[(($24)>>2)]=$37;
      var $40=HEAP32[(($23)>>2)];
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=(($42)|0)==0;
      var $44=(($43)&1);
      var $45=HEAP32[(($24)>>2)];
      var $46=(($45)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)==0;
      var $49=(($48)&1);
      var $50=(($44)|0)==(($49)|0);
      var $51=$23;
      var $52=$24;
      var $53=$50 ^ 1;
      var $54=$25;
      var $55=$26;
      if ($53) { __label__ = 2; break; } else { var $103 = 0;__label__ = 6; break; }
    case 2: // $56
      var $57=$30;
      var $58=$28;
      var $59=$7;
      HEAP32[(($7)>>2)]=$58;
      var $60=HEAP32[(($7)>>2)];
      var $61=(($60)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$5;
      var $64=$6;
      HEAP32[(($6)>>2)]=$62;
      var $65=HEAP32[(($6)>>2)];
      var $66=(($65+12)|0);
      var $67=HEAP32[(($66)>>2)];
      var $68=(($65+16)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($67)|0)==(($69)|0);
      if ($70) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $71
      var $72=$65;
      var $73=HEAP32[(($72)>>2)];
      var $74=(($73+36)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=FUNCTION_TABLE[$75]($65);
      HEAP32[(($5)>>2)]=$76;
      __label__ = 5; break;
    case 4: // $77
      var $78=(($65+12)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=HEAP32[(($79)>>2)];
      var $81=$4;
      HEAP32[(($4)>>2)]=$80;
      var $82=HEAP32[(($4)>>2)];
      var $83=$4;
      HEAP32[(($5)>>2)]=$82;
      __label__ = 5; break;
    case 5: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $84=HEAP32[(($5)>>2)];
      var $85=$5;
      var $86=$6;
      var $87=$7;
      var $88=$1;
      var $89=$2;
      var $90=$3;
      HEAP32[(($1)>>2)]=$57;
      HEAP32[(($2)>>2)]=16384;
      HEAP32[(($3)>>2)]=$84;
      var $91=HEAP32[(($1)>>2)];
      var $92=$91;
      var $93=HEAP32[(($92)>>2)];
      var $94=(($93+12)|0);
      var $95=HEAP32[(($94)>>2)];
      var $96=HEAP32[(($2)>>2)];
      var $97=HEAP32[(($3)>>2)];
      var $98=FUNCTION_TABLE[$95]($91, $96, $97);
      var $99=$1;
      var $100=$2;
      var $101=$3;
      var $103 = $98;__label__ = 6; break;
    case 6: // $102
      var $103;
      if ($103) { __label__ = 7; break; } else { __label__ = 20; break; }
    case 7: // $104
      __label__ = 8; break;
    case 8: // $105
      var $106=$28;
      var $107=$18;
      HEAP32[(($18)>>2)]=$106;
      var $108=HEAPU32[(($18)>>2)];
      var $109=(($108)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$16;
      var $112=$17;
      HEAP32[(($17)>>2)]=$110;
      var $113=HEAP32[(($17)>>2)];
      var $114=$14;
      var $115=$15;
      HEAP32[(($15)>>2)]=$113;
      var $116=HEAP32[(($15)>>2)];
      var $117=(($116+12)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=(($116+16)|0);
      var $120=HEAP32[(($119)>>2)];
      var $121=(($118)|0)==(($120)|0);
      if ($121) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $122
      var $123=$116;
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124+40)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=FUNCTION_TABLE[$126]($116);
      HEAP32[(($14)>>2)]=$127;
      __label__ = 11; break;
    case 10: // $128
      var $129=(($116+12)|0);
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+4)|0);
      HEAP32[(($129)>>2)]=$131;
      var $132=HEAP32[(($130)>>2)];
      var $133=$13;
      HEAP32[(($13)>>2)]=$132;
      var $134=HEAP32[(($13)>>2)];
      var $135=$13;
      HEAP32[(($14)>>2)]=$134;
      __label__ = 11; break;
    case 11: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $136=HEAP32[(($14)>>2)];
      var $137=$14;
      var $138=$15;
      var $139=(($136)|0)==-1;
      if ($139) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $140
      HEAP32[(($16)>>2)]=-1;
      __label__ = 17; break;
    case 13: // $141
      var $142=$11;
      var $143=$12;
      HEAP32[(($12)>>2)]=$113;
      var $144=HEAP32[(($12)>>2)];
      var $145=(($144+12)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=(($144+16)|0);
      var $148=HEAP32[(($147)>>2)];
      var $149=(($146)|0)==(($148)|0);
      if ($149) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $150
      var $151=$144;
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+36)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=FUNCTION_TABLE[$154]($144);
      HEAP32[(($11)>>2)]=$155;
      __label__ = 16; break;
    case 15: // $156
      var $157=(($144+12)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=HEAP32[(($158)>>2)];
      var $160=$10;
      HEAP32[(($10)>>2)]=$159;
      var $161=HEAP32[(($10)>>2)];
      var $162=$10;
      HEAP32[(($11)>>2)]=$161;
      __label__ = 16; break;
    case 16: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $163=HEAP32[(($11)>>2)];
      var $164=$11;
      var $165=$12;
      HEAP32[(($16)>>2)]=$163;
      __label__ = 17; break;
    case 17: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $166=HEAP32[(($16)>>2)];
      var $167=$16;
      var $168=$17;
      var $169=$8;
      var $170=$9;
      HEAP32[(($8)>>2)]=$166;
      HEAP32[(($9)>>2)]=-1;
      var $171=HEAP32[(($8)>>2)];
      var $172=HEAP32[(($9)>>2)];
      var $173=(($171)|0)==(($172)|0);
      var $174=$8;
      var $175=$9;
      if ($173) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $176
      var $177=(($108)|0);
      HEAP32[(($177)>>2)]=0;
      __label__ = 19; break;
    case 19: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $178=$18;
      __label__ = 1; break;
    case 20: // $179
      var $180=$28;
      var $181=$21;
      var $182=$22;
      HEAP32[(($21)>>2)]=$180;
      HEAP32[(($22)>>2)]=$__e;
      var $183=HEAP32[(($21)>>2)];
      var $184=HEAP32[(($22)>>2)];
      var $185=$19;
      var $186=$20;
      HEAP32[(($19)>>2)]=$183;
      HEAP32[(($20)>>2)]=$184;
      var $187=HEAP32[(($19)>>2)];
      var $188=(($187)|0);
      var $189=HEAP32[(($188)>>2)];
      var $190=(($189)|0)==0;
      var $191=(($190)&1);
      var $192=HEAP32[(($20)>>2)];
      var $193=(($192)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($194)|0)==0;
      var $196=(($195)&1);
      var $197=(($191)|0)==(($196)|0);
      var $198=$19;
      var $199=$20;
      var $200=$21;
      var $201=$22;
      if ($197) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $202
      var $203=$29;
      var $204=HEAP32[(($203)>>2)];
      var $205=$204 | 2;
      HEAP32[(($203)>>2)]=$205;
      __label__ = 22; break;
    case 22: // $206
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__h, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 84; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $__ap;
      var $__i;
      var $26=__stackBase__+80;
      $21=$this;
      $22=$__h;
      $23=$__b;
      $24=$__err;
      $25=$__ct;
      var $27=$21;
      var $28=$27;
      var $29=(($28+8)|0);
      var $30=$29;
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+8)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=FUNCTION_TABLE[$34]($30);
      $__ap=$35;
      var $36=$__ap;
      var $37=(($36)|0);
      var $38=$20;
      HEAP32[(($20)>>2)]=$37;
      var $39=HEAPU32[(($20)>>2)];
      var $40=$19;
      HEAP32[(($19)>>2)]=$39;
      var $41=HEAP32[(($19)>>2)];
      var $42=(($41)|0);
      var $43=$18;
      HEAP32[(($18)>>2)]=$42;
      var $44=HEAP32[(($18)>>2)];
      var $45=$44;
      var $46=$17;
      HEAP32[(($17)>>2)]=$45;
      var $47=HEAP32[(($17)>>2)];
      var $48=(($47)|0);
      var $49=$17;
      var $50=$18;
      var $51=(($48)|0);
      var $52=$51;
      var $53=(($52)|0);
      var $54=$53;
      var $55=HEAPU8[($54)];
      var $56=(($55)&255);
      var $57=$56 & 1;
      var $58=(($57)|0)!=0;
      var $59=$19;
      if ($58) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $60
      var $61=$13;
      HEAP32[(($13)>>2)]=$39;
      var $62=HEAP32[(($13)>>2)];
      var $63=(($62)|0);
      var $64=$12;
      HEAP32[(($12)>>2)]=$63;
      var $65=HEAP32[(($12)>>2)];
      var $66=$65;
      var $67=$11;
      HEAP32[(($11)>>2)]=$66;
      var $68=HEAP32[(($11)>>2)];
      var $69=(($68)|0);
      var $70=$11;
      var $71=$12;
      var $72=(($69)|0);
      var $73=$72;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$13;
      var $97 = $75;__label__ = 3; break;
    case 2: // $77
      var $78=$16;
      HEAP32[(($16)>>2)]=$39;
      var $79=HEAP32[(($16)>>2)];
      var $80=(($79)|0);
      var $81=$15;
      HEAP32[(($15)>>2)]=$80;
      var $82=HEAP32[(($15)>>2)];
      var $83=$82;
      var $84=$14;
      HEAP32[(($14)>>2)]=$83;
      var $85=HEAP32[(($14)>>2)];
      var $86=(($85)|0);
      var $87=$14;
      var $88=$15;
      var $89=(($86)|0);
      var $90=$89;
      var $91=(($90)|0);
      var $92=$91;
      var $93=HEAPU8[($92)];
      var $94=(($93)&255);
      var $95=$94 >> 1;
      var $96=$16;
      var $97 = $95;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $97;
      var $98=$20;
      var $99=$__ap;
      var $100=(($99+12)|0);
      var $101=$10;
      HEAP32[(($10)>>2)]=$100;
      var $102=HEAPU32[(($10)>>2)];
      var $103=$9;
      HEAP32[(($9)>>2)]=$102;
      var $104=HEAP32[(($9)>>2)];
      var $105=(($104)|0);
      var $106=$8;
      HEAP32[(($8)>>2)]=$105;
      var $107=HEAP32[(($8)>>2)];
      var $108=$107;
      var $109=$7;
      HEAP32[(($7)>>2)]=$108;
      var $110=HEAP32[(($7)>>2)];
      var $111=(($110)|0);
      var $112=$7;
      var $113=$8;
      var $114=(($111)|0);
      var $115=$114;
      var $116=(($115)|0);
      var $117=$116;
      var $118=HEAPU8[($117)];
      var $119=(($118)&255);
      var $120=$119 & 1;
      var $121=(($120)|0)!=0;
      var $122=$9;
      if ($121) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $123
      var $124=$3;
      HEAP32[(($3)>>2)]=$102;
      var $125=HEAP32[(($3)>>2)];
      var $126=(($125)|0);
      var $127=$2;
      HEAP32[(($2)>>2)]=$126;
      var $128=HEAP32[(($2)>>2)];
      var $129=$128;
      var $130=$1;
      HEAP32[(($1)>>2)]=$129;
      var $131=HEAP32[(($1)>>2)];
      var $132=(($131)|0);
      var $133=$1;
      var $134=$2;
      var $135=(($132)|0);
      var $136=$135;
      var $137=(($136+4)|0);
      var $138=HEAP32[(($137)>>2)];
      var $139=$3;
      var $160 = $138;__label__ = 6; break;
    case 5: // $140
      var $141=$6;
      HEAP32[(($6)>>2)]=$102;
      var $142=HEAP32[(($6)>>2)];
      var $143=(($142)|0);
      var $144=$5;
      HEAP32[(($5)>>2)]=$143;
      var $145=HEAP32[(($5)>>2)];
      var $146=$145;
      var $147=$4;
      HEAP32[(($4)>>2)]=$146;
      var $148=HEAP32[(($4)>>2)];
      var $149=(($148)|0);
      var $150=$4;
      var $151=$5;
      var $152=(($149)|0);
      var $153=$152;
      var $154=(($153)|0);
      var $155=$154;
      var $156=HEAPU8[($155)];
      var $157=(($156)&255);
      var $158=$157 >> 1;
      var $159=$6;
      var $160 = $158;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit1
      var $160;
      var $161=$10;
      var $162=(($97+$160)|0);
      var $163=(($162)|0)==0;
      if ($163) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $164
      var $165=$24;
      var $166=HEAP32[(($165)>>2)];
      var $167=$166 | 4;
      HEAP32[(($165)>>2)]=$167;
      __label__ = 15; break;
    case 8: // $168
      var $169=$23;
      var $170=$26;
      var $171=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($170)>>2)]=HEAP32[(($171)>>2)];
      var $172=$__ap;
      var $173=$__ap;
      var $174=(($173+24)|0);
      var $175=$25;
      var $176=$24;
      var $177=__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb($169, $26, $172, $174, $175, $176, 0);
      var $178=$__ap;
      var $179=$177;
      var $180=$178;
      var $181=(($179-$180)|0);
      var $182=(((($181)|0)/12)|0);
      $__i=$182;
      var $183=$__i;
      var $184=(($183)|0)==0;
      if ($184) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $185
      var $186=$22;
      var $187=HEAP32[(($186)>>2)];
      var $188=(($187)|0)==12;
      if ($188) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $189
      var $190=$22;
      HEAP32[(($190)>>2)]=0;
      __label__ = 15; break;
    case 11: // $191
      var $192=$__i;
      var $193=(($192)|0)==1;
      if ($193) { __label__ = 12; break; } else { __label__ = 14; break; }
    case 12: // $194
      var $195=$22;
      var $196=HEAP32[(($195)>>2)];
      var $197=(($196)|0) < 12;
      if ($197) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $198
      var $199=$22;
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+12)|0);
      HEAP32[(($199)>>2)]=$201;
      __label__ = 14; break;
    case 14: // $202
      __label__ = 15; break;
    case 15: // $203
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE["X"]=1;

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__s, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__s;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 2);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 60;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__w, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__w;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 1);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19)|0) <= 6;
      if ($20) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $21
      var $22=$__t;
      var $23=$2;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 4; break;
    case 3: // $24
      var $25=$4;
      var $26=HEAP32[(($25)>>2)];
      var $27=$26 | 4;
      HEAP32[(($25)>>2)]=$27;
      __label__ = 4; break;
    case 4: // $28
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE($this, $__y, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $__t;
      var $6=__stackBase__;
      $1=$this;
      $2=$__y;
      $3=$__b;
      $4=$__err;
      $5=$__ct;
      var $7=$1;
      var $8=$3;
      var $9=$6;
      var $10=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($9)>>2)]=HEAP32[(($10)>>2)];
      var $11=$4;
      var $12=$5;
      var $13=__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($8, $6, $11, $12, 4);
      $__t=$13;
      var $14=$4;
      var $15=HEAP32[(($14)>>2)];
      var $16=$15 & 4;
      var $17=(($16)|0)!=0;
      if ($17) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=$__t;
      var $20=(($19-1900)|0);
      var $21=$2;
      HEAP32[(($21)>>2)]=$20;
      __label__ = 2; break;
    case 2: // $22
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE($this, $__b, $__e, $__err, $__ct) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $18=__stackBase__+64;
      var $19=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      var $25=__stackBase__+92;
      var $26=__stackBase__+96;
      var $27;
      var $28;
      var $29;
      var $30;
      $27=$this;
      $28=$__b;
      $29=$__err;
      $30=$__ct;
      var $31=$27;
      var $32=$28;
      var $33=$25;
      var $34=$26;
      HEAP32[(($25)>>2)]=$32;
      HEAP32[(($26)>>2)]=$__e;
      var $35=HEAP32[(($25)>>2)];
      var $36=HEAP32[(($26)>>2)];
      var $37=$23;
      var $38=$24;
      HEAP32[(($23)>>2)]=$35;
      HEAP32[(($24)>>2)]=$36;
      var $39=HEAP32[(($23)>>2)];
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41)|0)==0;
      var $43=(($42)&1);
      var $44=HEAP32[(($24)>>2)];
      var $45=(($44)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==0;
      var $48=(($47)&1);
      var $49=(($43)|0)==(($48)|0);
      var $50=$23;
      var $51=$24;
      var $52=$25;
      var $53=$26;
      if ($49) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $54
      var $55=$29;
      var $56=HEAP32[(($55)>>2)];
      var $57=$56 | 6;
      HEAP32[(($55)>>2)]=$57;
      __label__ = 21; break;
    case 2: // $58
      var $59=$30;
      var $60=$28;
      var $61=$7;
      HEAP32[(($7)>>2)]=$60;
      var $62=HEAP32[(($7)>>2)];
      var $63=(($62)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$5;
      var $66=$6;
      HEAP32[(($6)>>2)]=$64;
      var $67=HEAP32[(($6)>>2)];
      var $68=(($67+12)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($67+16)|0);
      var $71=HEAP32[(($70)>>2)];
      var $72=(($69)|0)==(($71)|0);
      if ($72) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $73
      var $74=$67;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+36)|0);
      var $77=HEAP32[(($76)>>2)];
      var $78=FUNCTION_TABLE[$77]($67);
      HEAP32[(($5)>>2)]=$78;
      __label__ = 5; break;
    case 4: // $79
      var $80=(($67+12)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=HEAP32[(($81)>>2)];
      var $83=$4;
      HEAP32[(($4)>>2)]=$82;
      var $84=HEAP32[(($4)>>2)];
      var $85=$4;
      HEAP32[(($5)>>2)]=$84;
      __label__ = 5; break;
    case 5: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $86=HEAP32[(($5)>>2)];
      var $87=$5;
      var $88=$6;
      var $89=$7;
      var $90=$1;
      var $91=$2;
      HEAP32[(($1)>>2)]=$59;
      HEAP32[(($2)>>2)]=$86;
      $3=0;
      var $92=HEAP32[(($1)>>2)];
      var $93=$92;
      var $94=HEAP32[(($93)>>2)];
      var $95=(($94+52)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=HEAP32[(($2)>>2)];
      var $98=$3;
      var $99=FUNCTION_TABLE[$96]($92, $97, $98);
      var $100=$1;
      var $101=$2;
      var $102=(($99 << 24) >> 24);
      var $103=(($102)|0)!=37;
      if ($103) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $104
      var $105=$29;
      var $106=HEAP32[(($105)>>2)];
      var $107=$106 | 4;
      HEAP32[(($105)>>2)]=$107;
      __label__ = 21; break;
    case 7: // $108
      var $109=$28;
      var $110=$18;
      HEAP32[(($18)>>2)]=$109;
      var $111=HEAPU32[(($18)>>2)];
      var $112=(($111)|0);
      var $113=HEAP32[(($112)>>2)];
      var $114=$16;
      var $115=$17;
      HEAP32[(($17)>>2)]=$113;
      var $116=HEAP32[(($17)>>2)];
      var $117=$14;
      var $118=$15;
      HEAP32[(($15)>>2)]=$116;
      var $119=HEAP32[(($15)>>2)];
      var $120=(($119+12)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=(($119+16)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($121)|0)==(($123)|0);
      if ($124) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $125
      var $126=$119;
      var $127=HEAP32[(($126)>>2)];
      var $128=(($127+40)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=FUNCTION_TABLE[$129]($119);
      HEAP32[(($14)>>2)]=$130;
      __label__ = 10; break;
    case 9: // $131
      var $132=(($119+12)|0);
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+4)|0);
      HEAP32[(($132)>>2)]=$134;
      var $135=HEAP32[(($133)>>2)];
      var $136=$13;
      HEAP32[(($13)>>2)]=$135;
      var $137=HEAP32[(($13)>>2)];
      var $138=$13;
      HEAP32[(($14)>>2)]=$137;
      __label__ = 10; break;
    case 10: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $139=HEAP32[(($14)>>2)];
      var $140=$14;
      var $141=$15;
      var $142=(($139)|0)==-1;
      if ($142) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $143
      HEAP32[(($16)>>2)]=-1;
      __label__ = 16; break;
    case 12: // $144
      var $145=$11;
      var $146=$12;
      HEAP32[(($12)>>2)]=$116;
      var $147=HEAP32[(($12)>>2)];
      var $148=(($147+12)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=(($147+16)|0);
      var $151=HEAP32[(($150)>>2)];
      var $152=(($149)|0)==(($151)|0);
      if ($152) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $153
      var $154=$147;
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+36)|0);
      var $157=HEAP32[(($156)>>2)];
      var $158=FUNCTION_TABLE[$157]($147);
      HEAP32[(($11)>>2)]=$158;
      __label__ = 15; break;
    case 14: // $159
      var $160=(($147+12)|0);
      var $161=HEAP32[(($160)>>2)];
      var $162=HEAP32[(($161)>>2)];
      var $163=$10;
      HEAP32[(($10)>>2)]=$162;
      var $164=HEAP32[(($10)>>2)];
      var $165=$10;
      HEAP32[(($11)>>2)]=$164;
      __label__ = 15; break;
    case 15: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $166=HEAP32[(($11)>>2)];
      var $167=$11;
      var $168=$12;
      HEAP32[(($16)>>2)]=$166;
      __label__ = 16; break;
    case 16: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $169=HEAP32[(($16)>>2)];
      var $170=$16;
      var $171=$17;
      var $172=$8;
      var $173=$9;
      HEAP32[(($8)>>2)]=$169;
      HEAP32[(($9)>>2)]=-1;
      var $174=HEAP32[(($8)>>2)];
      var $175=HEAP32[(($9)>>2)];
      var $176=(($174)|0)==(($175)|0);
      var $177=$8;
      var $178=$9;
      if ($176) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $179
      var $180=(($111)|0);
      HEAP32[(($180)>>2)]=0;
      __label__ = 18; break;
    case 18: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $181=$18;
      var $182=$21;
      var $183=$22;
      HEAP32[(($21)>>2)]=$111;
      HEAP32[(($22)>>2)]=$__e;
      var $184=HEAP32[(($21)>>2)];
      var $185=HEAP32[(($22)>>2)];
      var $186=$19;
      var $187=$20;
      HEAP32[(($19)>>2)]=$184;
      HEAP32[(($20)>>2)]=$185;
      var $188=HEAP32[(($19)>>2)];
      var $189=(($188)|0);
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190)|0)==0;
      var $192=(($191)&1);
      var $193=HEAP32[(($20)>>2)];
      var $194=(($193)|0);
      var $195=HEAP32[(($194)>>2)];
      var $196=(($195)|0)==0;
      var $197=(($196)&1);
      var $198=(($192)|0)==(($197)|0);
      var $199=$19;
      var $200=$20;
      var $201=$21;
      var $202=$22;
      if ($198) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $203
      var $204=$29;
      var $205=HEAP32[(($204)>>2)];
      var $206=$205 | 2;
      HEAP32[(($204)>>2)]=$206;
      __label__ = 20; break;
    case 20: // $207
      __label__ = 21; break;
    case 21: // $208
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE["X"]=1;

function ___cxx_global_var_init20() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi($__b, $__e, $__err, $__ct, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 208; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $18=__stackBase__+64;
      var $19=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      var $25=__stackBase__+92;
      var $26=__stackBase__+96;
      var $27=__stackBase__+100;
      var $28;
      var $29=__stackBase__+104;
      var $30=__stackBase__+108;
      var $31=__stackBase__+112;
      var $32=__stackBase__+116;
      var $33=__stackBase__+120;
      var $34=__stackBase__+124;
      var $35=__stackBase__+128;
      var $36=__stackBase__+132;
      var $37=__stackBase__+136;
      var $38=__stackBase__+140;
      var $39=__stackBase__+144;
      var $40=__stackBase__+148;
      var $41=__stackBase__+152;
      var $42=__stackBase__+156;
      var $43=__stackBase__+160;
      var $44=__stackBase__+164;
      var $45=__stackBase__+168;
      var $46=__stackBase__+172;
      var $47=__stackBase__+176;
      var $48=__stackBase__+180;
      var $49=__stackBase__+184;
      var $50=__stackBase__+188;
      var $51=__stackBase__+192;
      var $52=__stackBase__+196;
      var $53=__stackBase__+200;
      var $54=__stackBase__+204;
      var $55;
      var $56;
      var $57;
      var $58;
      var $59;
      var $__c;
      var $__r;
      $56=$__b;
      $57=$__err;
      $58=$__ct;
      $59=$__n;
      var $60=$56;
      var $61=$53;
      var $62=$54;
      HEAP32[(($53)>>2)]=$60;
      HEAP32[(($54)>>2)]=$__e;
      var $63=HEAP32[(($53)>>2)];
      var $64=HEAP32[(($54)>>2)];
      var $65=$51;
      var $66=$52;
      HEAP32[(($51)>>2)]=$63;
      HEAP32[(($52)>>2)]=$64;
      var $67=HEAP32[(($51)>>2)];
      var $68=(($67)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=(($69)|0)==0;
      var $71=(($70)&1);
      var $72=HEAP32[(($52)>>2)];
      var $73=(($72)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74)|0)==0;
      var $76=(($75)&1);
      var $77=(($71)|0)==(($76)|0);
      var $78=$51;
      var $79=$52;
      var $80=$53;
      var $81=$54;
      if ($77) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $82
      var $83=$57;
      var $84=HEAP32[(($83)>>2)];
      var $85=$84 | 6;
      HEAP32[(($83)>>2)]=$85;
      $55=0;
      __label__ = 43; break;
    case 2: // $86
      var $87=$56;
      var $88=$35;
      HEAP32[(($35)>>2)]=$87;
      var $89=HEAP32[(($35)>>2)];
      var $90=(($89)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=$33;
      var $93=$34;
      HEAP32[(($34)>>2)]=$91;
      var $94=HEAP32[(($34)>>2)];
      var $95=(($94+12)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($94+16)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=(($96)|0)==(($98)|0);
      if ($99) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $100
      var $101=$94;
      var $102=HEAP32[(($101)>>2)];
      var $103=(($102+36)|0);
      var $104=HEAP32[(($103)>>2)];
      var $105=FUNCTION_TABLE[$104]($94);
      HEAP32[(($33)>>2)]=$105;
      __label__ = 5; break;
    case 4: // $106
      var $107=(($94+12)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=HEAP32[(($108)>>2)];
      var $110=$32;
      HEAP32[(($32)>>2)]=$109;
      var $111=HEAP32[(($32)>>2)];
      var $112=$32;
      HEAP32[(($33)>>2)]=$111;
      __label__ = 5; break;
    case 5: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $113=HEAP32[(($33)>>2)];
      var $114=$33;
      var $115=$34;
      var $116=$35;
      $__c=$113;
      var $117=$58;
      var $118=$__c;
      var $119=$29;
      var $120=$30;
      var $121=$31;
      HEAP32[(($29)>>2)]=$117;
      HEAP32[(($30)>>2)]=1024;
      HEAP32[(($31)>>2)]=$118;
      var $122=HEAP32[(($29)>>2)];
      var $123=$122;
      var $124=HEAP32[(($123)>>2)];
      var $125=(($124+12)|0);
      var $126=HEAP32[(($125)>>2)];
      var $127=HEAP32[(($30)>>2)];
      var $128=HEAP32[(($31)>>2)];
      var $129=FUNCTION_TABLE[$126]($122, $127, $128);
      var $130=$29;
      var $131=$30;
      var $132=$31;
      if ($129) { __label__ = 7; break; } else { __label__ = 6; break; }
    case 6: // $133
      var $134=$57;
      var $135=HEAP32[(($134)>>2)];
      var $136=$135 | 4;
      HEAP32[(($134)>>2)]=$136;
      $55=0;
      __label__ = 43; break;
    case 7: // $137
      var $138=$58;
      var $139=$__c;
      var $140=$26;
      var $141=$27;
      HEAP32[(($26)>>2)]=$138;
      HEAP32[(($27)>>2)]=$139;
      $28=0;
      var $142=HEAP32[(($26)>>2)];
      var $143=$142;
      var $144=HEAP32[(($143)>>2)];
      var $145=(($144+52)|0);
      var $146=HEAP32[(($145)>>2)];
      var $147=HEAP32[(($27)>>2)];
      var $148=$28;
      var $149=FUNCTION_TABLE[$146]($142, $147, $148);
      var $150=$26;
      var $151=$27;
      var $152=(($149 << 24) >> 24);
      var $153=(($152-48)|0);
      $__r=$153;
      var $154=$56;
      var $155=$25;
      HEAP32[(($25)>>2)]=$154;
      var $156=HEAP32[(($25)>>2)];
      var $157=(($156)|0);
      var $158=HEAP32[(($157)>>2)];
      var $159=$23;
      var $160=$24;
      HEAP32[(($24)>>2)]=$158;
      var $161=HEAP32[(($24)>>2)];
      var $162=$21;
      var $163=$22;
      HEAP32[(($22)>>2)]=$161;
      var $164=HEAP32[(($22)>>2)];
      var $165=(($164+12)|0);
      var $166=HEAP32[(($165)>>2)];
      var $167=(($164+16)|0);
      var $168=HEAP32[(($167)>>2)];
      var $169=(($166)|0)==(($168)|0);
      if ($169) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $170
      var $171=$164;
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172+40)|0);
      var $174=HEAP32[(($173)>>2)];
      var $175=FUNCTION_TABLE[$174]($164);
      HEAP32[(($21)>>2)]=$175;
      __label__ = 10; break;
    case 9: // $176
      var $177=(($164+12)|0);
      var $178=HEAP32[(($177)>>2)];
      var $179=(($178+4)|0);
      HEAP32[(($177)>>2)]=$179;
      var $180=HEAP32[(($178)>>2)];
      var $181=$20;
      HEAP32[(($20)>>2)]=$180;
      var $182=HEAP32[(($20)>>2)];
      var $183=$20;
      HEAP32[(($21)>>2)]=$182;
      __label__ = 10; break;
    case 10: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i1
      var $184=HEAP32[(($21)>>2)];
      var $185=$21;
      var $186=$22;
      var $187=(($184)|0)==-1;
      if ($187) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $188
      HEAP32[(($23)>>2)]=-1;
      __label__ = 16; break;
    case 12: // $189
      var $190=$18;
      var $191=$19;
      HEAP32[(($19)>>2)]=$161;
      var $192=HEAP32[(($19)>>2)];
      var $193=(($192+12)|0);
      var $194=HEAP32[(($193)>>2)];
      var $195=(($192+16)|0);
      var $196=HEAP32[(($195)>>2)];
      var $197=(($194)|0)==(($196)|0);
      if ($197) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $198
      var $199=$192;
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+36)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=FUNCTION_TABLE[$202]($192);
      HEAP32[(($18)>>2)]=$203;
      __label__ = 15; break;
    case 14: // $204
      var $205=(($192+12)|0);
      var $206=HEAP32[(($205)>>2)];
      var $207=HEAP32[(($206)>>2)];
      var $208=$17;
      HEAP32[(($17)>>2)]=$207;
      var $209=HEAP32[(($17)>>2)];
      var $210=$17;
      HEAP32[(($18)>>2)]=$209;
      __label__ = 15; break;
    case 15: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i2
      var $211=HEAP32[(($18)>>2)];
      var $212=$18;
      var $213=$19;
      HEAP32[(($23)>>2)]=$211;
      __label__ = 16; break;
    case 16: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i3
      var $214=HEAP32[(($23)>>2)];
      var $215=$23;
      var $216=$24;
      var $217=$15;
      var $218=$16;
      HEAP32[(($15)>>2)]=$214;
      HEAP32[(($16)>>2)]=-1;
      var $219=HEAP32[(($15)>>2)];
      var $220=HEAP32[(($16)>>2)];
      var $221=(($219)|0)==(($220)|0);
      var $222=$15;
      var $223=$16;
      if ($221) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $224
      var $225=(($156)|0);
      HEAP32[(($225)>>2)]=0;
      __label__ = 18; break;
    case 18: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit4
      var $226=$25;
      var $227=$59;
      var $228=(($227-1)|0);
      $59=$228;
      __label__ = 19; break;
    case 19: // $229
      var $230=$56;
      var $231=$13;
      var $232=$14;
      HEAP32[(($13)>>2)]=$230;
      HEAP32[(($14)>>2)]=$__e;
      var $233=HEAP32[(($13)>>2)];
      var $234=HEAP32[(($14)>>2)];
      var $235=$11;
      var $236=$12;
      HEAP32[(($11)>>2)]=$233;
      HEAP32[(($12)>>2)]=$234;
      var $237=HEAP32[(($11)>>2)];
      var $238=(($237)|0);
      var $239=HEAP32[(($238)>>2)];
      var $240=(($239)|0)==0;
      var $241=(($240)&1);
      var $242=HEAP32[(($12)>>2)];
      var $243=(($242)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=(($244)|0)==0;
      var $246=(($245)&1);
      var $247=(($241)|0)==(($246)|0);
      var $248=$11;
      var $249=$12;
      var $250=$247 ^ 1;
      var $251=$13;
      var $252=$14;
      if ($250) { __label__ = 20; break; } else { var $257 = 0;__label__ = 21; break; }
    case 20: // $253
      var $254=$59;
      var $255=(($254)|0) > 0;
      var $257 = $255;__label__ = 21; break;
    case 21: // $256
      var $257;
      if ($257) { __label__ = 22; break; } else { __label__ = 40; break; }
    case 22: // $258
      var $259=$56;
      var $260=$10;
      HEAP32[(($10)>>2)]=$259;
      var $261=HEAP32[(($10)>>2)];
      var $262=(($261)|0);
      var $263=HEAP32[(($262)>>2)];
      var $264=$8;
      var $265=$9;
      HEAP32[(($9)>>2)]=$263;
      var $266=HEAP32[(($9)>>2)];
      var $267=(($266+12)|0);
      var $268=HEAP32[(($267)>>2)];
      var $269=(($266+16)|0);
      var $270=HEAP32[(($269)>>2)];
      var $271=(($268)|0)==(($270)|0);
      if ($271) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $272
      var $273=$266;
      var $274=HEAP32[(($273)>>2)];
      var $275=(($274+36)|0);
      var $276=HEAP32[(($275)>>2)];
      var $277=FUNCTION_TABLE[$276]($266);
      HEAP32[(($8)>>2)]=$277;
      __label__ = 25; break;
    case 24: // $278
      var $279=(($266+12)|0);
      var $280=HEAP32[(($279)>>2)];
      var $281=HEAP32[(($280)>>2)];
      var $282=$7;
      HEAP32[(($7)>>2)]=$281;
      var $283=HEAP32[(($7)>>2)];
      var $284=$7;
      HEAP32[(($8)>>2)]=$283;
      __label__ = 25; break;
    case 25: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit5
      var $285=HEAP32[(($8)>>2)];
      var $286=$8;
      var $287=$9;
      var $288=$10;
      $__c=$285;
      var $289=$58;
      var $290=$__c;
      var $291=$4;
      var $292=$5;
      var $293=$6;
      HEAP32[(($4)>>2)]=$289;
      HEAP32[(($5)>>2)]=1024;
      HEAP32[(($6)>>2)]=$290;
      var $294=HEAP32[(($4)>>2)];
      var $295=$294;
      var $296=HEAP32[(($295)>>2)];
      var $297=(($296+12)|0);
      var $298=HEAP32[(($297)>>2)];
      var $299=HEAP32[(($5)>>2)];
      var $300=HEAP32[(($6)>>2)];
      var $301=FUNCTION_TABLE[$298]($294, $299, $300);
      var $302=$4;
      var $303=$5;
      var $304=$6;
      if ($301) { __label__ = 27; break; } else { __label__ = 26; break; }
    case 26: // $305
      var $306=$__r;
      $55=$306;
      __label__ = 43; break;
    case 27: // $307
      var $308=$__r;
      var $309=(($308*10)|0);
      var $310=$58;
      var $311=$__c;
      var $312=$1;
      var $313=$2;
      HEAP32[(($1)>>2)]=$310;
      HEAP32[(($2)>>2)]=$311;
      $3=0;
      var $314=HEAP32[(($1)>>2)];
      var $315=$314;
      var $316=HEAP32[(($315)>>2)];
      var $317=(($316+52)|0);
      var $318=HEAP32[(($317)>>2)];
      var $319=HEAP32[(($2)>>2)];
      var $320=$3;
      var $321=FUNCTION_TABLE[$318]($314, $319, $320);
      var $322=$1;
      var $323=$2;
      var $324=(($321 << 24) >> 24);
      var $325=(($309+$324)|0);
      var $326=(($325-48)|0);
      $__r=$326;
      __label__ = 28; break;
    case 28: // $327
      var $328=$56;
      var $329=$46;
      HEAP32[(($46)>>2)]=$328;
      var $330=HEAP32[(($46)>>2)];
      var $331=(($330)|0);
      var $332=HEAP32[(($331)>>2)];
      var $333=$44;
      var $334=$45;
      HEAP32[(($45)>>2)]=$332;
      var $335=HEAP32[(($45)>>2)];
      var $336=$42;
      var $337=$43;
      HEAP32[(($43)>>2)]=$335;
      var $338=HEAP32[(($43)>>2)];
      var $339=(($338+12)|0);
      var $340=HEAP32[(($339)>>2)];
      var $341=(($338+16)|0);
      var $342=HEAP32[(($341)>>2)];
      var $343=(($340)|0)==(($342)|0);
      if ($343) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $344
      var $345=$338;
      var $346=HEAP32[(($345)>>2)];
      var $347=(($346+40)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=FUNCTION_TABLE[$348]($338);
      HEAP32[(($42)>>2)]=$349;
      __label__ = 31; break;
    case 30: // $350
      var $351=(($338+12)|0);
      var $352=HEAP32[(($351)>>2)];
      var $353=(($352+4)|0);
      HEAP32[(($351)>>2)]=$353;
      var $354=HEAP32[(($352)>>2)];
      var $355=$41;
      HEAP32[(($41)>>2)]=$354;
      var $356=HEAP32[(($41)>>2)];
      var $357=$41;
      HEAP32[(($42)>>2)]=$356;
      __label__ = 31; break;
    case 31: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $358=HEAP32[(($42)>>2)];
      var $359=$42;
      var $360=$43;
      var $361=(($358)|0)==-1;
      if ($361) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $362
      HEAP32[(($44)>>2)]=-1;
      __label__ = 37; break;
    case 33: // $363
      var $364=$39;
      var $365=$40;
      HEAP32[(($40)>>2)]=$335;
      var $366=HEAP32[(($40)>>2)];
      var $367=(($366+12)|0);
      var $368=HEAP32[(($367)>>2)];
      var $369=(($366+16)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=(($368)|0)==(($370)|0);
      if ($371) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $372
      var $373=$366;
      var $374=HEAP32[(($373)>>2)];
      var $375=(($374+36)|0);
      var $376=HEAP32[(($375)>>2)];
      var $377=FUNCTION_TABLE[$376]($366);
      HEAP32[(($39)>>2)]=$377;
      __label__ = 36; break;
    case 35: // $378
      var $379=(($366+12)|0);
      var $380=HEAP32[(($379)>>2)];
      var $381=HEAP32[(($380)>>2)];
      var $382=$38;
      HEAP32[(($38)>>2)]=$381;
      var $383=HEAP32[(($38)>>2)];
      var $384=$38;
      HEAP32[(($39)>>2)]=$383;
      __label__ = 36; break;
    case 36: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $385=HEAP32[(($39)>>2)];
      var $386=$39;
      var $387=$40;
      HEAP32[(($44)>>2)]=$385;
      __label__ = 37; break;
    case 37: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $388=HEAP32[(($44)>>2)];
      var $389=$44;
      var $390=$45;
      var $391=$36;
      var $392=$37;
      HEAP32[(($36)>>2)]=$388;
      HEAP32[(($37)>>2)]=-1;
      var $393=HEAP32[(($36)>>2)];
      var $394=HEAP32[(($37)>>2)];
      var $395=(($393)|0)==(($394)|0);
      var $396=$36;
      var $397=$37;
      if ($395) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $398
      var $399=(($330)|0);
      HEAP32[(($399)>>2)]=0;
      __label__ = 39; break;
    case 39: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $400=$46;
      var $401=$59;
      var $402=(($401-1)|0);
      $59=$402;
      __label__ = 19; break;
    case 40: // $403
      var $404=$56;
      var $405=$49;
      var $406=$50;
      HEAP32[(($49)>>2)]=$404;
      HEAP32[(($50)>>2)]=$__e;
      var $407=HEAP32[(($49)>>2)];
      var $408=HEAP32[(($50)>>2)];
      var $409=$47;
      var $410=$48;
      HEAP32[(($47)>>2)]=$407;
      HEAP32[(($48)>>2)]=$408;
      var $411=HEAP32[(($47)>>2)];
      var $412=(($411)|0);
      var $413=HEAP32[(($412)>>2)];
      var $414=(($413)|0)==0;
      var $415=(($414)&1);
      var $416=HEAP32[(($48)>>2)];
      var $417=(($416)|0);
      var $418=HEAP32[(($417)>>2)];
      var $419=(($418)|0)==0;
      var $420=(($419)&1);
      var $421=(($415)|0)==(($420)|0);
      var $422=$47;
      var $423=$48;
      var $424=$49;
      var $425=$50;
      if ($421) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $426
      var $427=$57;
      var $428=HEAP32[(($427)>>2)];
      var $429=$428 | 2;
      HEAP32[(($427)>>2)]=$429;
      __label__ = 42; break;
    case 42: // $430
      var $431=$__r;
      $55=$431;
      __label__ = 43; break;
    case 43: // $432
      var $433=$55;
      STACKTOP = __stackBase__;
      return $433;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi["X"]=1;

function __ZNSt3__110__time_putD2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2)|0);
      var $4=HEAP32[(($3)>>2)];
      var $5=(($4)|0)!=0;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=(($2)|0);
      var $8=HEAP32[(($7)>>2)];
      _freelocale($8);
      __label__ = 2; break;
    case 2: // $9
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      var $7;
      $5=$this;
      var $8=$5;
      var $9=$4;
      HEAP32[(($4)>>2)]=$8;
      var $10=HEAP32[(($4)>>2)];
      var $11=$1;
      var $12=$2;
      var $13=$3;
      HEAP32[(($1)>>2)]=$10;
      var $14=HEAP32[(($1)>>2)];
      var $15=$14;
      var $16=(($15+8)|0);
      var $17=$16;
      (function() { try { __THREW__ = false; return __ZNSt3__110__time_putD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      HEAP32[(($2)>>2)]=$20;
      var $21=$19.f1;
      HEAP32[(($3)>>2)]=$21;
      var $22=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      var $24=HEAP32[(($2)>>2)];
      var $25=HEAP32[(($2)>>2)];
      var $26=HEAP32[(($3)>>2)];
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      var $eh_lpad_body = $28;__label__ = 8; break;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 4: // $_ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev_exit_i
      var $31=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $_ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev_exit
      var $32=$1;
      var $33=$2;
      var $34=$3;
      var $35=$4;
      __label__ = 6; break;
    case 6: // $36
      var $37=$8;
      __ZdlPv($37);
      STACKTOP = __stackBase__;
      return;
    case 7: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $39;__label__ = 8; break;
    case 8: // $_body
      var $eh_lpad_body;
      var $40=$eh_lpad_body.f0;
      $6=$40;
      var $41=$eh_lpad_body.f1;
      $7=$41;
      var $42=$8;
      __ZdlPv($42);
      __label__ = 9; break;
    case 9: // $43
      var $44=$6;
      var $45=$6;
      var $46=$7;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev["X"]=1;

function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$1;
      var $7=$2;
      var $8=$3;
      HEAP32[(($1)>>2)]=$5;
      var $9=HEAP32[(($1)>>2)];
      var $10=$9;
      var $11=(($10+8)|0);
      var $12=$11;
      (function() { try { __THREW__ = false; return __ZNSt3__110__time_putD2Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      HEAP32[(($2)>>2)]=$15;
      var $16=$14.f1;
      HEAP32[(($3)>>2)]=$16;
      var $17=$9;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=HEAP32[(($2)>>2)];
      var $20=HEAP32[(($2)>>2)];
      var $21=HEAP32[(($3)>>2)];
      var $22=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20, tempValue);
      var $23=($22.f1 = $21, $22);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 4: // $_ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev_exit
      var $26=$9;
      __ZNSt3__16locale5facetD2Ev($26);
      var $27=$1;
      var $28=$2;
      var $29=$3;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_var_init21() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc($agg_result, $this, $__s, $__iob, $0, $__tm, $__fmt, $__mod) {
  var __stackBase__  = STACKTOP; STACKTOP += 180; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6;
      var $7;
      var $8=__stackBase__+16;
      var $9=__stackBase__+20;
      var $10;
      var $11=__stackBase__+24;
      var $12;
      var $13=__stackBase__+28;
      var $14=__stackBase__+32;
      var $15=__stackBase__+36;
      var $16=__stackBase__+40;
      var $17=__stackBase__+44;
      var $18=__stackBase__+48;
      var $19=__stackBase__+52;
      var $20=__stackBase__+56;
      var $21=__stackBase__+60;
      var $22=__stackBase__+64;
      var $23=__stackBase__+68;
      var $24;
      var $25;
      var $26;
      var $27;
      var $28;
      var $29;
      var $__nar=__stackBase__+72;
      var $__nb;
      var $__ne=__stackBase__+172;
      var $30=__stackBase__+176;
      $24=$this;
      $25=$__iob;
      $26=$0;
      $27=$__tm;
      $28=$__fmt;
      $29=$__mod;
      var $31=$24;
      var $32=(($__nar)|0);
      $__nb=$32;
      var $33=$__nb;
      var $34=(($33+100)|0);
      HEAP32[(($__ne)>>2)]=$34;
      var $35=$31;
      var $36=(($35+8)|0);
      var $37=$36;
      var $38=$__nb;
      var $39=$27;
      var $40=$28;
      var $41=$29;
      __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc($37, $38, $__ne, $39, $40, $41);
      var $42=$__nb;
      var $43=HEAP32[(($__ne)>>2)];
      var $44=$30;
      var $45=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($44)>>2)]=HEAP32[(($45)>>2)];
      var $tmp=$23;
      var $tmp1=$30;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $46=$2;
      var $47=$17;
      var $48=$19;
      var $49=$20;
      var $50=$21;
      var $51=$22;
      HEAP32[(($19)>>2)]=$42;
      HEAP32[(($20)>>2)]=$43;
      var $52=HEAP32[(($19)>>2)];
      var $53=$18;
      HEAP32[(($18)>>2)]=$52;
      var $54=HEAP32[(($18)>>2)];
      var $55=$18;
      var $56=HEAP32[(($20)>>2)];
      var $57=$3;
      HEAP32[(($3)>>2)]=$56;
      var $58=HEAP32[(($3)>>2)];
      var $59=$3;
      var $60=$22;
      var $61=$23;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($60)>>2)]=HEAP32[(($61)>>2)];
      var $tmp2_i=$2;
      var $tmp3_i=$22;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2_i)]=HEAP8[($tmp3_i)];HEAP8[($tmp2_i+1)]=HEAP8[($tmp3_i+1)];HEAP8[($tmp2_i+2)]=HEAP8[($tmp3_i+2)];HEAP8[($tmp2_i+3)]=HEAP8[($tmp3_i+3)];
      var $62=$21;
      var $63=$2;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($62)>>2)]=HEAP32[(($63)>>2)];
      var $tmp_i=$17;
      var $tmp1_i=$21;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp1_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp1_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp1_i+3)];
      var $64=$15;
      var $65=$16;
      HEAP32[(($15)>>2)]=$54;
      HEAP32[(($16)>>2)]=$58;
      __label__ = 1; break;
    case 1: // $66
      var $67=HEAP32[(($15)>>2)];
      var $68=HEAP32[(($16)>>2)];
      var $69=(($67)|0)!=(($68)|0);
      if ($69) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $70
      var $71=$14;
      HEAP32[(($14)>>2)]=$17;
      var $72=HEAP32[(($14)>>2)];
      var $73=$14;
      var $74=HEAP32[(($15)>>2)];
      var $75=HEAP8[($74)];
      var $76=$11;
      HEAP32[(($11)>>2)]=$72;
      $12=$75;
      var $77=HEAPU32[(($11)>>2)];
      var $78=(($77)|0);
      var $79=HEAP32[(($78)>>2)];
      var $80=(($79)|0)!=0;
      if ($80) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $81
      var $82=(($77)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=$12;
      var $85=$8;
      var $86=$9;
      HEAP32[(($9)>>2)]=$83;
      $10=$84;
      var $87=HEAPU32[(($9)>>2)];
      var $88=(($87+24)|0);
      var $89=HEAP32[(($88)>>2)];
      var $90=(($87+28)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($89)|0)==(($91)|0);
      if ($92) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $93
      var $94=$87;
      var $95=HEAP32[(($94)>>2)];
      var $96=(($95+52)|0);
      var $97=HEAP32[(($96)>>2)];
      var $98=$10;
      $7=$98;
      var $99=$7;
      var $100=(($99)&255);
      var $101=FUNCTION_TABLE[$97]($87, $100);
      HEAP32[(($8)>>2)]=$101;
      __label__ = 6; break;
    case 5: // $102
      var $103=$10;
      var $104=(($87+24)|0);
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+1)|0);
      HEAP32[(($104)>>2)]=$106;
      HEAP8[($105)]=$103;
      var $107=$10;
      $6=$107;
      var $108=$6;
      var $109=(($108)&255);
      HEAP32[(($8)>>2)]=$109;
      __label__ = 6; break;
    case 6: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sputcEc_exit_i_i_i
      var $110=HEAP32[(($8)>>2)];
      var $111=$8;
      var $112=$9;
      var $113=$4;
      var $114=$5;
      HEAP32[(($4)>>2)]=$110;
      HEAP32[(($5)>>2)]=-1;
      var $115=HEAP32[(($4)>>2)];
      var $116=HEAP32[(($5)>>2)];
      var $117=(($115)|0)==(($116)|0);
      var $118=$4;
      var $119=$5;
      if ($117) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $120
      var $121=(($77)|0);
      HEAP32[(($121)>>2)]=0;
      __label__ = 8; break;
    case 8: // $_ZNSt3__119ostreambuf_iteratorIcNS_11char_traitsIcEEEaSEc_exit_i_i
      var $122=$11;
      var $123=HEAP32[(($15)>>2)];
      var $124=(($123+1)|0);
      HEAP32[(($15)>>2)]=$124;
      var $125=$13;
      HEAP32[(($13)>>2)]=$17;
      var $126=HEAP32[(($13)>>2)];
      var $127=$13;
      __label__ = 1; break;
    case 9: // $_ZNSt3__14copyIPcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_T_S7_S6__exit
      var $128=$agg_result;
      var $129=$17;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($128)>>2)]=HEAP32[(($129)>>2)];
      var $130=$15;
      var $131=$16;
      var $132=$2;
      var $133=$17;
      var $134=$19;
      var $135=$20;
      var $136=$21;
      var $137=$22;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc["X"]=1;

function __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc($this, $__nb, $__ne, $__tm, $__fmt, $__mod) {
  var __stackBase__  = STACKTOP; STACKTOP += 28; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i=__stackBase__+20;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      var $fmt=__stackBase__+24;
      var $n;
      $6=$this;
      $7=$__nb;
      $8=$__ne;
      $9=$__tm;
      $10=$__fmt;
      $11=$__mod;
      var $12=$6;
      var $13=(($fmt)|0);
      HEAP8[($13)]=37;
      var $14=(($13+1)|0);
      var $15=$10;
      HEAP8[($14)]=$15;
      var $16=(($14+1)|0);
      var $17=$11;
      HEAP8[($16)]=$17;
      var $18=(($16+1)|0);
      HEAP8[($18)]=0;
      var $19=$11;
      var $20=(($19 << 24) >> 24);
      var $21=(($20)|0)!=0;
      if ($21) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $22
      var $23=(($fmt+1)|0);
      var $24=(($fmt+2)|0);
      var $25=$4;
      var $26=$5;
      HEAP32[(($4)>>2)]=$23;
      HEAP32[(($5)>>2)]=$24;
      var $27=HEAP32[(($4)>>2)];
      var $28=$3;
      HEAP32[(($3)>>2)]=$27;
      var $29=HEAP32[(($3)>>2)];
      var $30=$3;
      var $31=HEAP8[($29)];
      HEAP8[($__t_i)]=$31;
      var $32=HEAP32[(($5)>>2)];
      var $33=$1;
      HEAP32[(($1)>>2)]=$32;
      var $34=HEAP32[(($1)>>2)];
      var $35=$1;
      var $36=HEAP8[($34)];
      var $37=HEAP32[(($4)>>2)];
      HEAP8[($37)]=$36;
      var $38=$2;
      HEAP32[(($2)>>2)]=$__t_i;
      var $39=HEAP32[(($2)>>2)];
      var $40=$2;
      var $41=HEAP8[($39)];
      var $42=HEAP32[(($5)>>2)];
      HEAP8[($42)]=$41;
      var $43=$4;
      var $44=$5;
      __label__ = 2; break;
    case 2: // $45
      var $46=$7;
      var $47=$8;
      var $48=HEAP32[(($47)>>2)];
      var $49=$7;
      var $50=$48;
      var $51=$49;
      var $52=(($50-$51)|0);
      var $53=(($fmt)|0);
      var $54=$9;
      var $55=(($12)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=_strftime_l($46, $52, $53, $54, $56);
      $n=$57;
      var $58=$7;
      var $59=$n;
      var $60=(($58+$59)|0);
      var $61=$8;
      HEAP32[(($61)>>2)]=$60;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc["X"]=1;

function __ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc($agg_result, $this, $__s, $__iob, $0, $__tm, $__fmt, $__mod) {
  var __stackBase__  = STACKTOP; STACKTOP += 496; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15=__stackBase__+52;
      var $16=__stackBase__+56;
      var $17=__stackBase__+60;
      var $18=__stackBase__+64;
      var $19=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24;
      var $25;
      var $26;
      var $27;
      var $28;
      var $29;
      var $__nar=__stackBase__+88;
      var $__nb;
      var $__ne=__stackBase__+488;
      var $30=__stackBase__+492;
      $24=$this;
      $25=$__iob;
      $26=$0;
      $27=$__tm;
      $28=$__fmt;
      $29=$__mod;
      var $31=$24;
      var $32=(($__nar)|0);
      $__nb=$32;
      var $33=$__nb;
      var $34=(($33+400)|0);
      HEAP32[(($__ne)>>2)]=$34;
      var $35=$31;
      var $36=(($35+8)|0);
      var $37=$36;
      var $38=$__nb;
      var $39=$27;
      var $40=$28;
      var $41=$29;
      __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc($37, $38, $__ne, $39, $40, $41);
      var $42=$__nb;
      var $43=HEAP32[(($__ne)>>2)];
      var $44=$30;
      var $45=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($44)>>2)]=HEAP32[(($45)>>2)];
      var $tmp=$23;
      var $tmp1=$30;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $46=$2;
      var $47=$17;
      var $48=$19;
      var $49=$20;
      var $50=$21;
      var $51=$22;
      HEAP32[(($19)>>2)]=$42;
      HEAP32[(($20)>>2)]=$43;
      var $52=HEAP32[(($19)>>2)];
      var $53=$18;
      HEAP32[(($18)>>2)]=$52;
      var $54=HEAP32[(($18)>>2)];
      var $55=$18;
      var $56=HEAP32[(($20)>>2)];
      var $57=$3;
      HEAP32[(($3)>>2)]=$56;
      var $58=HEAP32[(($3)>>2)];
      var $59=$3;
      var $60=$22;
      var $61=$23;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($60)>>2)]=HEAP32[(($61)>>2)];
      var $tmp2_i=$2;
      var $tmp3_i=$22;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2_i)]=HEAP8[($tmp3_i)];HEAP8[($tmp2_i+1)]=HEAP8[($tmp3_i+1)];HEAP8[($tmp2_i+2)]=HEAP8[($tmp3_i+2)];HEAP8[($tmp2_i+3)]=HEAP8[($tmp3_i+3)];
      var $62=$21;
      var $63=$2;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($62)>>2)]=HEAP32[(($63)>>2)];
      var $tmp_i=$17;
      var $tmp1_i=$21;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp1_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp1_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp1_i+3)];
      var $64=$15;
      var $65=$16;
      HEAP32[(($15)>>2)]=$54;
      HEAP32[(($16)>>2)]=$58;
      __label__ = 1; break;
    case 1: // $66
      var $67=HEAP32[(($15)>>2)];
      var $68=HEAP32[(($16)>>2)];
      var $69=(($67)|0)!=(($68)|0);
      if ($69) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $70
      var $71=$14;
      HEAP32[(($14)>>2)]=$17;
      var $72=HEAP32[(($14)>>2)];
      var $73=$14;
      var $74=HEAP32[(($15)>>2)];
      var $75=HEAP32[(($74)>>2)];
      var $76=$11;
      var $77=$12;
      HEAP32[(($11)>>2)]=$72;
      HEAP32[(($12)>>2)]=$75;
      var $78=HEAP32[(($11)>>2)];
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80)|0)!=0;
      if ($81) { __label__ = 3; break; } else { __label__ = 8; break; }
    case 3: // $82
      var $83=(($78)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=HEAP32[(($12)>>2)];
      var $86=$8;
      var $87=$9;
      var $88=$10;
      HEAP32[(($9)>>2)]=$84;
      HEAP32[(($10)>>2)]=$85;
      var $89=HEAP32[(($9)>>2)];
      var $90=(($89+24)|0);
      var $91=HEAP32[(($90)>>2)];
      var $92=(($89+28)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=(($91)|0)==(($93)|0);
      if ($94) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $95
      var $96=$89;
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+52)|0);
      var $99=HEAP32[(($98)>>2)];
      var $100=HEAP32[(($10)>>2)];
      var $101=$7;
      HEAP32[(($7)>>2)]=$100;
      var $102=HEAP32[(($7)>>2)];
      var $103=$7;
      var $104=FUNCTION_TABLE[$99]($89, $102);
      HEAP32[(($8)>>2)]=$104;
      __label__ = 6; break;
    case 5: // $105
      var $106=HEAP32[(($10)>>2)];
      var $107=(($89+24)|0);
      var $108=HEAP32[(($107)>>2)];
      var $109=(($108+4)|0);
      HEAP32[(($107)>>2)]=$109;
      HEAP32[(($108)>>2)]=$106;
      var $110=HEAP32[(($10)>>2)];
      var $111=$6;
      HEAP32[(($6)>>2)]=$110;
      var $112=HEAP32[(($6)>>2)];
      var $113=$6;
      HEAP32[(($8)>>2)]=$112;
      __label__ = 6; break;
    case 6: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sputcEw_exit_i_i_i
      var $114=HEAP32[(($8)>>2)];
      var $115=$8;
      var $116=$9;
      var $117=$10;
      var $118=$4;
      var $119=$5;
      HEAP32[(($4)>>2)]=$114;
      HEAP32[(($5)>>2)]=-1;
      var $120=HEAP32[(($4)>>2)];
      var $121=HEAP32[(($5)>>2)];
      var $122=(($120)|0)==(($121)|0);
      var $123=$4;
      var $124=$5;
      if ($122) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $125
      var $126=(($78)|0);
      HEAP32[(($126)>>2)]=0;
      __label__ = 8; break;
    case 8: // $_ZNSt3__119ostreambuf_iteratorIwNS_11char_traitsIwEEEaSEw_exit_i_i
      var $127=$11;
      var $128=$12;
      var $129=HEAP32[(($15)>>2)];
      var $130=(($129+4)|0);
      HEAP32[(($15)>>2)]=$130;
      var $131=$13;
      HEAP32[(($13)>>2)]=$17;
      var $132=HEAP32[(($13)>>2)];
      var $133=$13;
      __label__ = 1; break;
    case 9: // $_ZNSt3__14copyIPwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_T_S7_S6__exit
      var $134=$agg_result;
      var $135=$17;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($134)>>2)]=HEAP32[(($135)>>2)];
      var $136=$15;
      var $137=$16;
      var $138=$2;
      var $139=$17;
      var $140=$19;
      var $141=$20;
      var $142=$21;
      var $143=$22;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc["X"]=1;

function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      var $7;
      $5=$this;
      var $8=$5;
      var $9=$4;
      HEAP32[(($4)>>2)]=$8;
      var $10=HEAP32[(($4)>>2)];
      var $11=$1;
      var $12=$2;
      var $13=$3;
      HEAP32[(($1)>>2)]=$10;
      var $14=HEAP32[(($1)>>2)];
      var $15=$14;
      var $16=(($15+8)|0);
      var $17=$16;
      (function() { try { __THREW__ = false; return __ZNSt3__110__time_putD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $18
      var $19=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $20=$19.f0;
      HEAP32[(($2)>>2)]=$20;
      var $21=$19.f1;
      HEAP32[(($3)>>2)]=$21;
      var $22=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($22) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $23
      var $24=HEAP32[(($2)>>2)];
      var $25=HEAP32[(($2)>>2)];
      var $26=HEAP32[(($3)>>2)];
      var $27=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $25, tempValue);
      var $28=($27.f1 = $26, $27);
      var $eh_lpad_body = $28;__label__ = 8; break;
    case 3: // $29
      var $30=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 4: // $_ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev_exit_i
      var $31=$14;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($31) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $_ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev_exit
      var $32=$1;
      var $33=$2;
      var $34=$3;
      var $35=$4;
      __label__ = 6; break;
    case 6: // $36
      var $37=$8;
      __ZdlPv($37);
      STACKTOP = __stackBase__;
      return;
    case 7: // $38
      var $39=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $39;__label__ = 8; break;
    case 8: // $_body
      var $eh_lpad_body;
      var $40=$eh_lpad_body.f0;
      $6=$40;
      var $41=$eh_lpad_body.f1;
      $7=$41;
      var $42=$8;
      __ZdlPv($42);
      __label__ = 9; break;
    case 9: // $43
      var $44=$6;
      var $45=$6;
      var $46=$7;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev["X"]=1;

function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      $4=$this;
      var $5=$4;
      var $6=$1;
      var $7=$2;
      var $8=$3;
      HEAP32[(($1)>>2)]=$5;
      var $9=HEAP32[(($1)>>2)];
      var $10=$9;
      var $11=(($10+8)|0);
      var $12=$11;
      (function() { try { __THREW__ = false; return __ZNSt3__110__time_putD2Ev($12) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      HEAP32[(($2)>>2)]=$15;
      var $16=$14.f1;
      HEAP32[(($3)>>2)]=$16;
      var $17=$9;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $18
      var $19=HEAP32[(($2)>>2)];
      var $20=HEAP32[(($2)>>2)];
      var $21=HEAP32[(($3)>>2)];
      var $22=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $20, tempValue);
      var $23=($22.f1 = $21, $22);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 3: // $24
      var $25=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 4: // $_ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev_exit
      var $26=$9;
      __ZNSt3__16locale5facetD2Ev($26);
      var $27=$1;
      var $28=$2;
      var $29=$3;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 127;
}


function __ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 127;
}


function ___cxx_global_var_init22() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__110moneypunctIcLb0EE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__110moneypunctIcLb0EE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__110moneypunctIcLb0EE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__110moneypunctIcLb0EE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__110moneypunctIcLb0EE11do_groupingEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIcLb0EE11do_groupingEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv["X"]=1;

function __ZNSt3__110moneypunctIcLb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__110moneypunctIcLb0EED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__110moneypunctIcLb0EED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc($this, $__wb, $__we, $__tm, $__fmt, $__mod) {
  var __stackBase__  = STACKTOP; STACKTOP += 348; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $__current_i=__stackBase__+212;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55;
      var $56;
      var $57;
      var $58;
      var $59;
      var $60;
      var $__nar=__stackBase__+232;
      var $__ne=__stackBase__+332;
      var $mb=__stackBase__+336;
      var $__nb=__stackBase__+344;
      var $j;
      $55=$this;
      $56=$__wb;
      $57=$__we;
      $58=$__tm;
      $59=$__fmt;
      $60=$__mod;
      var $61=$55;
      var $62=(($__nar)|0);
      var $63=(($62+100)|0);
      HEAP32[(($__ne)>>2)]=$63;
      var $64=(($__nar)|0);
      var $65=$58;
      var $66=$59;
      var $67=$60;
      __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc($61, $64, $__ne, $65, $66, $67);
      var $68=$mb;
      HEAP32[(($68)>>2)]=0; HEAP32[(($68+4)>>2)]=0;
      var $69=(($__nar)|0);
      HEAP32[(($__nb)>>2)]=$69;
      var $70=$56;
      var $71=(($61)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=$46;
      var $74=$47;
      var $75=$48;
      var $76=$49;
      var $77=$50;
      var $78=$51;
      var $79=$__current_i;
      var $80=$52;
      var $81=$53;
      var $82=$54;
      HEAP32[(($47)>>2)]=$70;
      HEAP32[(($48)>>2)]=$__nb;
      HEAP32[(($49)>>2)]=100;
      HEAP32[(($50)>>2)]=$mb;
      HEAP32[(($51)>>2)]=$72;
      var $83=HEAP32[(($51)>>2)];
      var $84=_uselocale($83);
      var $85=$43;
      var $86=$44;
      var $87=$45;
      HEAP32[(($43)>>2)]=$__current_i;
      HEAP32[(($44)>>2)]=$84;
      HEAP32[(($45)>>2)]=1680;
      var $88=HEAP32[(($43)>>2)];
      var $89=HEAP32[(($44)>>2)];
      var $90=HEAP32[(($45)>>2)];
      var $91=$40;
      var $92=$41;
      var $93=$42;
      HEAP32[(($40)>>2)]=$88;
      HEAP32[(($41)>>2)]=$89;
      HEAP32[(($42)>>2)]=$90;
      var $94=HEAP32[(($40)>>2)];
      var $95=(($94)|0);
      var $96=$39;
      HEAP32[(($39)>>2)]=$41;
      var $97=HEAP32[(($39)>>2)];
      var $98=$39;
      var $99=HEAP32[(($97)>>2)];
      var $100=$25;
      HEAP32[(($25)>>2)]=$42;
      var $101=HEAP32[(($25)>>2)];
      var $102=$25;
      var $103=HEAP32[(($101)>>2)];
      var $104=$36;
      var $105=$37;
      var $106=$38;
      HEAP32[(($36)>>2)]=$95;
      HEAP32[(($37)>>2)]=$99;
      HEAP32[(($38)>>2)]=$103;
      var $107=HEAP32[(($36)>>2)];
      var $108=HEAP32[(($37)>>2)];
      var $109=HEAP32[(($38)>>2)];
      var $110=$33;
      var $111=$34;
      var $112=$35;
      HEAP32[(($33)>>2)]=$107;
      HEAP32[(($34)>>2)]=$108;
      HEAP32[(($35)>>2)]=$109;
      var $113=HEAP32[(($33)>>2)];
      var $114=$113;
      var $115=$32;
      HEAP32[(($32)>>2)]=$34;
      var $116=HEAP32[(($32)>>2)];
      var $117=$32;
      var $118=HEAP32[(($116)>>2)];
      var $119=$26;
      HEAP32[(($26)>>2)]=$35;
      var $120=HEAP32[(($26)>>2)];
      var $121=$26;
      var $122=HEAP32[(($120)>>2)];
      var $123=$29;
      var $124=$30;
      var $125=$31;
      HEAP32[(($29)>>2)]=$114;
      HEAP32[(($30)>>2)]=$118;
      HEAP32[(($31)>>2)]=$122;
      var $126=HEAP32[(($29)>>2)];
      var $127=(($126)|0);
      var $128=$28;
      HEAP32[(($28)>>2)]=$30;
      var $129=HEAP32[(($28)>>2)];
      var $130=$28;
      var $131=HEAP32[(($129)>>2)];
      HEAP32[(($127)>>2)]=$131;
      var $132=(($126+4)|0);
      var $133=$27;
      HEAP32[(($27)>>2)]=$31;
      var $134=HEAP32[(($27)>>2)];
      var $135=$27;
      var $136=HEAP32[(($134)>>2)];
      HEAP32[(($132)>>2)]=$136;
      var $137=$29;
      var $138=$30;
      var $139=$31;
      var $140=$33;
      var $141=$34;
      var $142=$35;
      var $143=$36;
      var $144=$37;
      var $145=$38;
      var $146=$40;
      var $147=$41;
      var $148=$42;
      var $149=$43;
      var $150=$44;
      var $151=$45;
      var $152=HEAP32[(($47)>>2)];
      var $153=HEAP32[(($48)>>2)];
      var $154=HEAP32[(($49)>>2)];
      var $155=HEAP32[(($50)>>2)];
      var $156=(function() { try { __THREW__ = false; return _mbsrtowcs($152, $153, $154, $155) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $157
      HEAP32[(($46)>>2)]=$156;
      HEAP32[(($54)>>2)]=1;
      var $158=$12;
      HEAP32[(($12)>>2)]=$__current_i;
      var $159=HEAP32[(($12)>>2)];
      var $160=$11;
      HEAP32[(($11)>>2)]=$159;
      var $161=HEAP32[(($11)>>2)];
      var $162=$7;
      var $163=$8;
      var $164=$__tmp_i_i_i1_i;
      var $165=$9;
      var $166=$10;
      HEAP32[(($7)>>2)]=$161;
      HEAP32[(($8)>>2)]=0;
      var $167=HEAP32[(($7)>>2)];
      var $168=(($167)|0);
      var $169=$6;
      HEAP32[(($6)>>2)]=$168;
      var $170=HEAP32[(($6)>>2)];
      var $171=$170;
      var $172=$5;
      HEAP32[(($5)>>2)]=$171;
      var $173=HEAP32[(($5)>>2)];
      var $174=(($173)|0);
      var $175=$5;
      var $176=$6;
      var $177=HEAP32[(($174)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$177;
      var $178=HEAP32[(($8)>>2)];
      var $179=(($167)|0);
      var $180=$4;
      HEAP32[(($4)>>2)]=$179;
      var $181=HEAP32[(($4)>>2)];
      var $182=$181;
      var $183=$3;
      HEAP32[(($3)>>2)]=$182;
      var $184=HEAP32[(($3)>>2)];
      var $185=(($184)|0);
      var $186=$3;
      var $187=$4;
      HEAP32[(($185)>>2)]=$178;
      var $188=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $189=(($188)|0)!=0;
      if ($189) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $190
      var $191=(($167)|0);
      var $192=$2;
      HEAP32[(($2)>>2)]=$191;
      var $193=HEAP32[(($2)>>2)];
      var $194=$193;
      var $195=$1;
      HEAP32[(($1)>>2)]=$194;
      var $196=HEAP32[(($1)>>2)];
      var $197=(($196+4)|0);
      var $198=$1;
      var $199=$2;
      var $200=HEAP32[(($197)>>2)];
      var $201=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $202=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$200]($201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $203
      __label__ = 10; break;
    case 4: // $204
      var $205=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $206=$205.f0;
      HEAP32[(($9)>>2)]=$206;
      var $207=$205.f1;
      HEAP32[(($10)>>2)]=$207;
      var $208=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($208);
      throw "Reached an unreachable!"
    case 5: // $209
      var $210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $211=$210.f0;
      HEAP32[(($52)>>2)]=$211;
      var $212=$210.f1;
      HEAP32[(($53)>>2)]=$212;
      var $213=$24;
      HEAP32[(($24)>>2)]=$__current_i;
      var $214=HEAP32[(($24)>>2)];
      var $215=$23;
      HEAP32[(($23)>>2)]=$214;
      var $216=HEAP32[(($23)>>2)];
      var $217=$19;
      var $218=$20;
      var $219=$__tmp_i_i_i_i;
      var $220=$21;
      var $221=$22;
      HEAP32[(($19)>>2)]=$216;
      HEAP32[(($20)>>2)]=0;
      var $222=HEAP32[(($19)>>2)];
      var $223=(($222)|0);
      var $224=$18;
      HEAP32[(($18)>>2)]=$223;
      var $225=HEAP32[(($18)>>2)];
      var $226=$225;
      var $227=$17;
      HEAP32[(($17)>>2)]=$226;
      var $228=HEAP32[(($17)>>2)];
      var $229=(($228)|0);
      var $230=$17;
      var $231=$18;
      var $232=HEAP32[(($229)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$232;
      var $233=HEAP32[(($20)>>2)];
      var $234=(($222)|0);
      var $235=$16;
      HEAP32[(($16)>>2)]=$234;
      var $236=HEAP32[(($16)>>2)];
      var $237=$236;
      var $238=$15;
      HEAP32[(($15)>>2)]=$237;
      var $239=HEAP32[(($15)>>2)];
      var $240=(($239)|0);
      var $241=$15;
      var $242=$16;
      HEAP32[(($240)>>2)]=$233;
      var $243=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $244=(($243)|0)!=0;
      if ($244) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $245
      var $246=(($222)|0);
      var $247=$14;
      HEAP32[(($14)>>2)]=$246;
      var $248=HEAP32[(($14)>>2)];
      var $249=$248;
      var $250=$13;
      HEAP32[(($13)>>2)]=$249;
      var $251=HEAP32[(($13)>>2)];
      var $252=(($251+4)|0);
      var $253=$13;
      var $254=$14;
      var $255=HEAP32[(($252)>>2)];
      var $256=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $257=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$255]($256) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $258
      __label__ = 9; break;
    case 8: // $259
      var $260=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $261=$260.f0;
      HEAP32[(($21)>>2)]=$261;
      var $262=$260.f1;
      HEAP32[(($22)>>2)]=$262;
      var $263=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($263);
      throw "Reached an unreachable!"
    case 9: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $264=$19;
      var $265=$20;
      var $266=$__tmp_i_i_i_i;
      var $267=$21;
      var $268=$22;
      var $269=$23;
      var $270=$24;
      var $271=HEAP32[(($52)>>2)];
      var $272=HEAP32[(($52)>>2)];
      var $273=HEAP32[(($53)>>2)];
      var $274=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $272, tempValue);
      var $275=($274.f1 = $273, $274);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $_ZNSt3__113__mbsrtowcs_lEPwPPKcjP10_mbstate_tPv_exit
      var $276=$7;
      var $277=$8;
      var $278=$__tmp_i_i_i1_i;
      var $279=$9;
      var $280=$10;
      var $281=$11;
      var $282=$12;
      var $283=HEAP32[(($46)>>2)];
      var $284=$46;
      var $285=$47;
      var $286=$48;
      var $287=$49;
      var $288=$50;
      var $289=$51;
      var $290=$__current_i;
      var $291=$52;
      var $292=$53;
      var $293=$54;
      $j=$283;
      var $294=$j;
      var $295=(($294)|0)==-1;
      if ($295) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $296
      __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str66262)|0));
      __label__ = 12; break;
    case 12: // $297
      var $298=$56;
      var $299=$j;
      var $300=(($298+($299<<2))|0);
      var $301=$57;
      HEAP32[(($301)>>2)]=$300;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc["X"]=1;

function __ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 127;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 127;
}


function __ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 2147483647;
}


function ___cxx_global_var_init23() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__110moneypunctIcLb1EE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__110moneypunctIcLb1EE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__110moneypunctIcLb1EE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__110moneypunctIcLb1EE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__110moneypunctIcLb1EE11do_groupingEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIcLb1EE11do_groupingEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv["X"]=1;

function ___cxx_global_var_init24() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__110moneypunctIwLb0EE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__110moneypunctIwLb0EE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__110moneypunctIwLb0EE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__110moneypunctIwLb0EE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__110moneypunctIwLb0EE11do_groupingEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIwLb0EE11do_groupingEv["X"]=1;

function __ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7;
  var $8=__stackBase__+24;
  var $9=__stackBase__+28;
  var $10;
  var $11;
  $11=$this;
  var $12=$11;
  var $13=$8;
  var $14=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=1;
  $10=45;
  var $15=HEAP32[(($8)>>2)];
  var $16=HEAP32[(($9)>>2)];
  var $17=$10;
  var $18=$5;
  var $19=$6;
  HEAP32[(($5)>>2)]=$15;
  HEAP32[(($6)>>2)]=$16;
  $7=$17;
  var $20=HEAP32[(($5)>>2)];
  var $21=$20;
  var $22=(($20)|0);
  var $23=$4;
  HEAP32[(($4)>>2)]=$22;
  var $24=HEAP32[(($4)>>2)];
  var $25=$3;
  HEAP32[(($3)>>2)]=$24;
  var $26=HEAP32[(($3)>>2)];
  var $27=$26;
  var $28=$2;
  HEAP32[(($2)>>2)]=$27;
  var $29=HEAP32[(($2)>>2)];
  var $30=$29;
  var $31=$1;
  HEAP32[(($1)>>2)]=$30;
  var $32=HEAP32[(($1)>>2)];
  var $33=$1;
  var $34=(($29)|0);
  var $35=$2;
  var $36=$3;
  var $37=$4;
  var $38=HEAP32[(($6)>>2)];
  var $39=$7;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($20, $38, $39);
  var $40=$5;
  var $41=$6;
  var $42=$8;
  var $43=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_pos_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_pos_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_pos_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_pos_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_neg_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_neg_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_neg_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb0EE13do_neg_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNSt3__110moneypunctIcLb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__110moneypunctIcLb1EED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__110moneypunctIcLb1EED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7;
  var $8=__stackBase__+24;
  var $9=__stackBase__+28;
  var $10;
  var $11;
  $11=$this;
  var $12=$11;
  var $13=$8;
  var $14=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=1;
  $10=45;
  var $15=HEAP32[(($8)>>2)];
  var $16=HEAP32[(($9)>>2)];
  var $17=$10;
  var $18=$5;
  var $19=$6;
  HEAP32[(($5)>>2)]=$15;
  HEAP32[(($6)>>2)]=$16;
  $7=$17;
  var $20=HEAP32[(($5)>>2)];
  var $21=$20;
  var $22=(($20)|0);
  var $23=$4;
  HEAP32[(($4)>>2)]=$22;
  var $24=HEAP32[(($4)>>2)];
  var $25=$3;
  HEAP32[(($3)>>2)]=$24;
  var $26=HEAP32[(($3)>>2)];
  var $27=$26;
  var $28=$2;
  HEAP32[(($2)>>2)]=$27;
  var $29=HEAP32[(($2)>>2)];
  var $30=$29;
  var $31=$1;
  HEAP32[(($1)>>2)]=$30;
  var $32=HEAP32[(($1)>>2)];
  var $33=$1;
  var $34=(($29)|0);
  var $35=$2;
  var $36=$3;
  var $37=$4;
  var $38=HEAP32[(($6)>>2)];
  var $39=$7;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc($20, $38, $39);
  var $40=$5;
  var $41=$6;
  var $42=$8;
  var $43=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv["X"]=1;

function __ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_pos_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_pos_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_pos_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_pos_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_neg_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_neg_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_neg_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIcLb1EE13do_neg_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNSt3__110moneypunctIwLb0EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__110moneypunctIwLb0EED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__110moneypunctIwLb0EED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 2147483647;
}


function __ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv["X"]=1;

function ___cxx_global_var_init25() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__110moneypunctIwLb1EE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__110moneypunctIwLb1EE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__110moneypunctIwLb1EE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__110moneypunctIwLb1EE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__110moneypunctIwLb1EE11do_groupingEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIwLb1EE11do_groupingEv["X"]=1;

function __ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv["X"]=1;

function __ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10;
      $10=$this;
      var $11=$10;
      var $12=$9;
      HEAP32[(($9)>>2)]=$agg_result;
      var $13=HEAP32[(($9)>>2)];
      var $14=$8;
      HEAP32[(($8)>>2)]=$13;
      var $15=HEAP32[(($8)>>2)];
      var $16=$15;
      var $17=(($15)|0);
      var $18=$7;
      HEAP32[(($7)>>2)]=$17;
      var $19=HEAP32[(($7)>>2)];
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=$24;
      var $26=$4;
      HEAP32[(($4)>>2)]=$25;
      var $27=HEAP32[(($4)>>2)];
      var $28=$4;
      var $29=(($24)|0);
      var $30=$5;
      var $31=$6;
      var $32=$7;
      var $33=$3;
      var $34=$__a_i_i_i;
      var $35=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$15;
      var $36=HEAP32[(($3)>>2)];
      var $37=(($36)|0);
      var $38=$2;
      HEAP32[(($2)>>2)]=$37;
      var $39=HEAP32[(($2)>>2)];
      var $40=$39;
      var $41=$1;
      HEAP32[(($1)>>2)]=$40;
      var $42=HEAP32[(($1)>>2)];
      var $43=(($42)|0);
      var $44=$1;
      var $45=$2;
      var $46=(($43)|0);
      var $47=$46;
      var $48=(($47)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$48;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $49
      var $50=HEAPU32[(($__i_i_i_i)>>2)];
      var $51=(($50)>>>0) < 3;
      if ($51) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      var $53=HEAP32[(($__i_i_i_i)>>2)];
      var $54=HEAP32[(($__a_i_i_i)>>2)];
      var $55=(($54+($53<<2))|0);
      HEAP32[(($55)>>2)]=0;
      var $56=HEAP32[(($__i_i_i_i)>>2)];
      var $57=(($56+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$57;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $58=$3;
      var $59=$__a_i_i_i;
      var $60=$__i_i_i_i;
      var $61=$8;
      var $62=$9;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv["X"]=1;

function ___cxx_global_var_init26() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  var $11;
  $11=$this;
  var $12=$11;
  var $13=$8;
  var $14=$9;
  var $15=$10;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=1;
  HEAP32[(($10)>>2)]=45;
  var $16=HEAP32[(($8)>>2)];
  var $17=HEAP32[(($9)>>2)];
  var $18=HEAP32[(($10)>>2)];
  var $19=$5;
  var $20=$6;
  var $21=$7;
  HEAP32[(($5)>>2)]=$16;
  HEAP32[(($6)>>2)]=$17;
  HEAP32[(($7)>>2)]=$18;
  var $22=HEAP32[(($5)>>2)];
  var $23=$22;
  var $24=(($22)|0);
  var $25=$4;
  HEAP32[(($4)>>2)]=$24;
  var $26=HEAP32[(($4)>>2)];
  var $27=$3;
  HEAP32[(($3)>>2)]=$26;
  var $28=HEAP32[(($3)>>2)];
  var $29=$28;
  var $30=$2;
  HEAP32[(($2)>>2)]=$29;
  var $31=HEAP32[(($2)>>2)];
  var $32=$31;
  var $33=$1;
  HEAP32[(($1)>>2)]=$32;
  var $34=HEAP32[(($1)>>2)];
  var $35=$1;
  var $36=(($31)|0);
  var $37=$2;
  var $38=$3;
  var $39=$4;
  var $40=HEAP32[(($6)>>2)];
  var $41=HEAP32[(($7)>>2)];
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($22, $40, $41);
  var $42=$5;
  var $43=$6;
  var $44=$7;
  var $45=$8;
  var $46=$9;
  var $47=$10;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv["X"]=1;

function __ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_pos_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_pos_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_pos_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_pos_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_neg_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_neg_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_neg_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb0EE13do_neg_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNSt3__110moneypunctIwLb1EED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__110moneypunctIwLb1EED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__110moneypunctIwLb1EED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10=__stackBase__+36;
  var $11;
  $11=$this;
  var $12=$11;
  var $13=$8;
  var $14=$9;
  var $15=$10;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=1;
  HEAP32[(($10)>>2)]=45;
  var $16=HEAP32[(($8)>>2)];
  var $17=HEAP32[(($9)>>2)];
  var $18=HEAP32[(($10)>>2)];
  var $19=$5;
  var $20=$6;
  var $21=$7;
  HEAP32[(($5)>>2)]=$16;
  HEAP32[(($6)>>2)]=$17;
  HEAP32[(($7)>>2)]=$18;
  var $22=HEAP32[(($5)>>2)];
  var $23=$22;
  var $24=(($22)|0);
  var $25=$4;
  HEAP32[(($4)>>2)]=$24;
  var $26=HEAP32[(($4)>>2)];
  var $27=$3;
  HEAP32[(($3)>>2)]=$26;
  var $28=HEAP32[(($3)>>2)];
  var $29=$28;
  var $30=$2;
  HEAP32[(($2)>>2)]=$29;
  var $31=HEAP32[(($2)>>2)];
  var $32=$31;
  var $33=$1;
  HEAP32[(($1)>>2)]=$32;
  var $34=HEAP32[(($1)>>2)];
  var $35=$1;
  var $36=(($31)|0);
  var $37=$2;
  var $38=$3;
  var $39=$4;
  var $40=HEAP32[(($6)>>2)];
  var $41=HEAP32[(($7)>>2)];
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw($22, $40, $41);
  var $42=$5;
  var $43=$6;
  var $44=$7;
  var $45=$8;
  var $46=$9;
  var $47=$10;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv["X"]=1;

function __ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_pos_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_pos_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_pos_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_pos_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$agg_result;
  assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_neg_formatEvE3__p)|0))];HEAP8[($3+1)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_neg_formatEvE3__p)|0)+1)];HEAP8[($3+2)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_neg_formatEvE3__p)|0)+2)];HEAP8[($3+3)]=HEAP8[(((__ZZNKSt3__110moneypunctIwLb1EE13do_neg_formatEvE3__p)|0)+3)];
  ;
  return;
}


function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe($agg_result, $this, $__b, $__e, $__intl, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 776; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i5=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $__tmp_i_i_i3=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $__tmp_i=__stackBase__+200;
      var $49=__stackBase__+204;
      var $50=__stackBase__+208;
      var $51=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $__tmp_i_i_i1=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $84=__stackBase__+348;
      var $85=__stackBase__+352;
      var $86=__stackBase__+356;
      var $87=__stackBase__+360;
      var $88=__stackBase__+364;
      var $89=__stackBase__+368;
      var $90=__stackBase__+372;
      var $91=__stackBase__+376;
      var $92=__stackBase__+380;
      var $93=__stackBase__+384;
      var $94=__stackBase__+388;
      var $95=__stackBase__+392;
      var $96=__stackBase__+396;
      var $97=__stackBase__+400;
      var $98=__stackBase__+404;
      var $99=__stackBase__+408;
      var $100=__stackBase__+412;
      var $101=__stackBase__+416;
      var $102=__stackBase__+420;
      var $103=__stackBase__+424;
      var $__tmp_i_i_i=__stackBase__+428;
      var $104=__stackBase__+432;
      var $105=__stackBase__+436;
      var $106=__stackBase__+440;
      var $107=__stackBase__+444;
      var $108=__stackBase__+448;
      var $109=__stackBase__+452;
      var $110=__stackBase__+456;
      var $111=__stackBase__+460;
      var $112=__stackBase__+464;
      var $113=__stackBase__+468;
      var $114=__stackBase__+472;
      var $115=__stackBase__+476;
      var $116=__stackBase__+480;
      var $117=__stackBase__+484;
      var $118=__stackBase__+488;
      var $119=__stackBase__+492;
      var $120=__stackBase__+496;
      var $121=__stackBase__+500;
      var $122=__stackBase__+504;
      var $123=__stackBase__+508;
      var $124=__stackBase__+512;
      var $125=__stackBase__+516;
      var $126=__stackBase__+520;
      var $127=__stackBase__+524;
      var $128=__stackBase__+528;
      var $129;
      var $130;
      var $131;
      var $132;
      var $133;
      var $__bz;
      var $__wbuf=__stackBase__+532;
      var $__wb=__stackBase__+632;
      var $__wn=__stackBase__+640;
      var $__we;
      var $__loc=__stackBase__+644;
      var $134;
      var $135;
      var $__ct;
      var $__neg=__stackBase__+648;
      var $136=__stackBase__+652;
      var $__atoms=__stackBase__+656;
      var $__nbuf=__stackBase__+668;
      var $__nc;
      var $__h=__stackBase__+768;
      var $__w;
      var $137;
      $129=$this;
      var $138=(($__intl)&1);
      $130=$138;
      $131=$__iob;
      $132=$__err;
      $133=$__v;
      var $139=$129;
      $__bz=100;
      var $140=(($__wbuf)|0);
      var $141=$126;
      var $142=$127;
      var $143=$128;
      HEAP32[(($126)>>2)]=$__wb;
      HEAP32[(($127)>>2)]=$140;
      HEAP32[(($128)>>2)]=1682;
      var $144=HEAP32[(($126)>>2)];
      var $145=HEAP32[(($127)>>2)];
      var $146=HEAP32[(($128)>>2)];
      var $147=$123;
      var $148=$124;
      var $149=$125;
      HEAP32[(($123)>>2)]=$144;
      HEAP32[(($124)>>2)]=$145;
      HEAP32[(($125)>>2)]=$146;
      var $150=HEAP32[(($123)>>2)];
      var $151=(($150)|0);
      var $152=$122;
      HEAP32[(($122)>>2)]=$124;
      var $153=HEAP32[(($122)>>2)];
      var $154=$122;
      var $155=HEAP32[(($153)>>2)];
      var $156=$108;
      HEAP32[(($108)>>2)]=$125;
      var $157=HEAP32[(($108)>>2)];
      var $158=$108;
      var $159=HEAP32[(($157)>>2)];
      var $160=$119;
      var $161=$120;
      var $162=$121;
      HEAP32[(($119)>>2)]=$151;
      HEAP32[(($120)>>2)]=$155;
      HEAP32[(($121)>>2)]=$159;
      var $163=HEAP32[(($119)>>2)];
      var $164=HEAP32[(($120)>>2)];
      var $165=HEAP32[(($121)>>2)];
      var $166=$116;
      var $167=$117;
      var $168=$118;
      HEAP32[(($116)>>2)]=$163;
      HEAP32[(($117)>>2)]=$164;
      HEAP32[(($118)>>2)]=$165;
      var $169=HEAP32[(($116)>>2)];
      var $170=$169;
      var $171=$115;
      HEAP32[(($115)>>2)]=$117;
      var $172=HEAP32[(($115)>>2)];
      var $173=$115;
      var $174=HEAP32[(($172)>>2)];
      var $175=$109;
      HEAP32[(($109)>>2)]=$118;
      var $176=HEAP32[(($109)>>2)];
      var $177=$109;
      var $178=HEAP32[(($176)>>2)];
      var $179=$112;
      var $180=$113;
      var $181=$114;
      HEAP32[(($112)>>2)]=$170;
      HEAP32[(($113)>>2)]=$174;
      HEAP32[(($114)>>2)]=$178;
      var $182=HEAP32[(($112)>>2)];
      var $183=(($182)|0);
      var $184=$111;
      HEAP32[(($111)>>2)]=$113;
      var $185=HEAP32[(($111)>>2)];
      var $186=$111;
      var $187=HEAP32[(($185)>>2)];
      HEAP32[(($183)>>2)]=$187;
      var $188=(($182+4)|0);
      var $189=$110;
      HEAP32[(($110)>>2)]=$114;
      var $190=HEAP32[(($110)>>2)];
      var $191=$110;
      var $192=HEAP32[(($190)>>2)];
      HEAP32[(($188)>>2)]=$192;
      var $193=$112;
      var $194=$113;
      var $195=$114;
      var $196=$116;
      var $197=$117;
      var $198=$118;
      var $199=$119;
      var $200=$120;
      var $201=$121;
      var $202=$123;
      var $203=$124;
      var $204=$125;
      var $205=$126;
      var $206=$127;
      var $207=$128;
      var $208=(($__wbuf)|0);
      var $209=(($208+100)|0);
      $__we=$209;
      var $210=$131;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($__loc, $210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $211
      var $212=$95;
      HEAP32[(($95)>>2)]=$__loc;
      var $213=HEAP32[(($95)>>2)];
      var $214=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($213, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 18; break; };
    case 2: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $215=$214;
      var $216=$95;
      __label__ = 3; break;
    case 3: // $217
      $__ct=$215;
      HEAP8[($__neg)]=0;
      var $218=$136;
      var $219=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($218)>>2)]=HEAP32[(($219)>>2)];
      var $220=$130;
      var $221=(($220) & 1);
      var $222=$131;
      var $223=$94;
      HEAP32[(($94)>>2)]=$222;
      var $224=HEAP32[(($94)>>2)];
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$94;
      __label__ = 4; break;
    case 4: // $228
      var $229=$132;
      var $230=$__ct;
      var $231=$__we;
      var $232=(function() { try { __THREW__ = false; return __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_($__b, $136, $221, $__loc, $226, $229, $__neg, $230, $__wb, $__wn, $231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 18; break; };
    case 5: // $233
      if ($232) { __label__ = 6; break; } else { __label__ = 48; break; }
    case 6: // $234
      var $235=$__ct;
      var $236=(($__atoms)|0);
      var $237=$90;
      var $238=$91;
      var $239=$92;
      var $240=$93;
      HEAP32[(($90)>>2)]=$235;
      HEAP32[(($91)>>2)]=((STRING_TABLE.__ZZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src)|0);
      HEAP32[(($92)>>2)]=((STRING_TABLE.__ZZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src+10)|0);
      HEAP32[(($93)>>2)]=$236;
      var $241=HEAP32[(($90)>>2)];
      var $242=$241;
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243+32)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=HEAP32[(($91)>>2)];
      var $247=HEAP32[(($92)>>2)];
      var $248=HEAP32[(($93)>>2)];
      var $249=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$245]($241, $246, $247, $248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 18; break; };
    case 7: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $250=$90;
      var $251=$91;
      var $252=$92;
      var $253=$93;
      __label__ = 8; break;
    case 8: // $254
      var $255=(($__nbuf)|0);
      $__nc=$255;
      var $256=$87;
      var $257=$88;
      var $258=$89;
      HEAP32[(($87)>>2)]=$__h;
      HEAP32[(($88)>>2)]=0;
      HEAP32[(($89)>>2)]=1496;
      var $259=HEAP32[(($87)>>2)];
      var $260=HEAP32[(($88)>>2)];
      var $261=HEAP32[(($89)>>2)];
      var $262=$84;
      var $263=$85;
      var $264=$86;
      HEAP32[(($84)>>2)]=$259;
      HEAP32[(($85)>>2)]=$260;
      HEAP32[(($86)>>2)]=$261;
      var $265=HEAP32[(($84)>>2)];
      var $266=(($265)|0);
      var $267=$83;
      HEAP32[(($83)>>2)]=$85;
      var $268=HEAP32[(($83)>>2)];
      var $269=$83;
      var $270=HEAP32[(($268)>>2)];
      var $271=$69;
      HEAP32[(($69)>>2)]=$86;
      var $272=HEAP32[(($69)>>2)];
      var $273=$69;
      var $274=HEAP32[(($272)>>2)];
      var $275=$80;
      var $276=$81;
      var $277=$82;
      HEAP32[(($80)>>2)]=$266;
      HEAP32[(($81)>>2)]=$270;
      HEAP32[(($82)>>2)]=$274;
      var $278=HEAP32[(($80)>>2)];
      var $279=HEAP32[(($81)>>2)];
      var $280=HEAP32[(($82)>>2)];
      var $281=$77;
      var $282=$78;
      var $283=$79;
      HEAP32[(($77)>>2)]=$278;
      HEAP32[(($78)>>2)]=$279;
      HEAP32[(($79)>>2)]=$280;
      var $284=HEAP32[(($77)>>2)];
      var $285=$284;
      var $286=$76;
      HEAP32[(($76)>>2)]=$78;
      var $287=HEAP32[(($76)>>2)];
      var $288=$76;
      var $289=HEAP32[(($287)>>2)];
      var $290=$70;
      HEAP32[(($70)>>2)]=$79;
      var $291=HEAP32[(($70)>>2)];
      var $292=$70;
      var $293=HEAP32[(($291)>>2)];
      var $294=$73;
      var $295=$74;
      var $296=$75;
      HEAP32[(($73)>>2)]=$285;
      HEAP32[(($74)>>2)]=$289;
      HEAP32[(($75)>>2)]=$293;
      var $297=HEAP32[(($73)>>2)];
      var $298=(($297)|0);
      var $299=$72;
      HEAP32[(($72)>>2)]=$74;
      var $300=HEAP32[(($72)>>2)];
      var $301=$72;
      var $302=HEAP32[(($300)>>2)];
      HEAP32[(($298)>>2)]=$302;
      var $303=(($297+4)|0);
      var $304=$71;
      HEAP32[(($71)>>2)]=$75;
      var $305=HEAP32[(($71)>>2)];
      var $306=$71;
      var $307=HEAP32[(($305)>>2)];
      HEAP32[(($303)>>2)]=$307;
      var $308=$73;
      var $309=$74;
      var $310=$75;
      var $311=$77;
      var $312=$78;
      var $313=$79;
      var $314=$80;
      var $315=$81;
      var $316=$82;
      var $317=$84;
      var $318=$85;
      var $319=$86;
      var $320=$87;
      var $321=$88;
      var $322=$89;
      __label__ = 9; break;
    case 9: // $323
      var $324=HEAP32[(($__wn)>>2)];
      var $325=$68;
      HEAP32[(($68)>>2)]=$__wb;
      var $326=HEAP32[(($68)>>2)];
      var $327=(($326)|0);
      var $328=$67;
      HEAP32[(($67)>>2)]=$327;
      var $329=HEAP32[(($67)>>2)];
      var $330=$329;
      var $331=$66;
      HEAP32[(($66)>>2)]=$330;
      var $332=HEAP32[(($66)>>2)];
      var $333=(($332)|0);
      var $334=$66;
      var $335=$67;
      var $336=HEAP32[(($333)>>2)];
      var $337=$68;
      var $338=$324;
      var $339=$336;
      var $340=(($338-$339)|0);
      var $341=(($340)>>>0) > 98;
      if ($341) { __label__ = 10; break; } else { __label__ = 25; break; }
    case 10: // $342
      var $343=HEAP32[(($__wn)>>2)];
      var $344=$53;
      HEAP32[(($53)>>2)]=$__wb;
      var $345=HEAP32[(($53)>>2)];
      var $346=(($345)|0);
      var $347=$52;
      HEAP32[(($52)>>2)]=$346;
      var $348=HEAP32[(($52)>>2)];
      var $349=$348;
      var $350=$51;
      HEAP32[(($51)>>2)]=$349;
      var $351=HEAP32[(($51)>>2)];
      var $352=(($351)|0);
      var $353=$51;
      var $354=$52;
      var $355=HEAP32[(($352)>>2)];
      var $356=$53;
      var $357=$343;
      var $358=$355;
      var $359=(($357-$358)|0);
      var $360=(($359+2)|0);
      var $361=_malloc($360);
      var $362=$47;
      var $363=$48;
      var $364=$__tmp_i;
      var $365=$49;
      var $366=$50;
      HEAP32[(($47)>>2)]=$__h;
      HEAP32[(($48)>>2)]=$361;
      var $367=HEAP32[(($47)>>2)];
      var $368=(($367)|0);
      var $369=$46;
      HEAP32[(($46)>>2)]=$368;
      var $370=HEAP32[(($46)>>2)];
      var $371=$370;
      var $372=$45;
      HEAP32[(($45)>>2)]=$371;
      var $373=HEAP32[(($45)>>2)];
      var $374=(($373)|0);
      var $375=$45;
      var $376=$46;
      var $377=HEAP32[(($374)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$377;
      var $378=HEAP32[(($48)>>2)];
      var $379=(($367)|0);
      var $380=$44;
      HEAP32[(($44)>>2)]=$379;
      var $381=HEAP32[(($44)>>2)];
      var $382=$381;
      var $383=$43;
      HEAP32[(($43)>>2)]=$382;
      var $384=HEAP32[(($43)>>2)];
      var $385=(($384)|0);
      var $386=$43;
      var $387=$44;
      HEAP32[(($385)>>2)]=$378;
      var $388=HEAP32[(($__tmp_i)>>2)];
      var $389=(($388)|0)!=0;
      if ($389) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $390
      var $391=(($367)|0);
      var $392=$42;
      HEAP32[(($42)>>2)]=$391;
      var $393=HEAP32[(($42)>>2)];
      var $394=$393;
      var $395=$41;
      HEAP32[(($41)>>2)]=$394;
      var $396=HEAP32[(($41)>>2)];
      var $397=(($396+4)|0);
      var $398=$41;
      var $399=$42;
      var $400=HEAP32[(($397)>>2)];
      var $401=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$400]($401) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $402
      __label__ = 14; break;
    case 13: // $403
      var $404=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $405=$404.f0;
      HEAP32[(($49)>>2)]=$405;
      var $406=$404.f1;
      HEAP32[(($50)>>2)]=$406;
      var $407=HEAP32[(($49)>>2)];
      ___cxa_call_unexpected($407);
      throw "Reached an unreachable!"
    case 14: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $408=$47;
      var $409=$48;
      var $410=$__tmp_i;
      var $411=$49;
      var $412=$50;
      var $413=$40;
      HEAP32[(($40)>>2)]=$__h;
      var $414=HEAP32[(($40)>>2)];
      var $415=(($414)|0);
      var $416=$39;
      HEAP32[(($39)>>2)]=$415;
      var $417=HEAP32[(($39)>>2)];
      var $418=$417;
      var $419=$38;
      HEAP32[(($38)>>2)]=$418;
      var $420=HEAP32[(($38)>>2)];
      var $421=(($420)|0);
      var $422=$38;
      var $423=$39;
      var $424=HEAP32[(($421)>>2)];
      var $425=$40;
      var $426=(($424)|0)==0;
      if ($426) { __label__ = 15; break; } else { __label__ = 24; break; }
    case 15: // $427
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $428
      __label__ = 24; break;
    case 17: // $429
      var $430=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $431=$430.f0;
      $134=$431;
      var $432=$430.f1;
      $135=$432;
      __label__ = 59; break;
    case 18: // $433
      var $434=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $435=$434.f0;
      $134=$435;
      var $436=$434.f1;
      $135=$436;
      __label__ = 57; break;
    case 19: // $437
      var $438=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $439=$438.f0;
      $134=$439;
      var $440=$438.f1;
      $135=$440;
      var $441=$37;
      HEAP32[(($37)>>2)]=$__h;
      var $442=HEAP32[(($37)>>2)];
      var $443=$36;
      HEAP32[(($36)>>2)]=$442;
      var $444=HEAP32[(($36)>>2)];
      var $445=$32;
      var $446=$33;
      var $447=$__tmp_i_i_i3;
      var $448=$34;
      var $449=$35;
      HEAP32[(($32)>>2)]=$444;
      HEAP32[(($33)>>2)]=0;
      var $450=HEAP32[(($32)>>2)];
      var $451=(($450)|0);
      var $452=$31;
      HEAP32[(($31)>>2)]=$451;
      var $453=HEAP32[(($31)>>2)];
      var $454=$453;
      var $455=$30;
      HEAP32[(($30)>>2)]=$454;
      var $456=HEAP32[(($30)>>2)];
      var $457=(($456)|0);
      var $458=$30;
      var $459=$31;
      var $460=HEAP32[(($457)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$460;
      var $461=HEAP32[(($33)>>2)];
      var $462=(($450)|0);
      var $463=$29;
      HEAP32[(($29)>>2)]=$462;
      var $464=HEAP32[(($29)>>2)];
      var $465=$464;
      var $466=$28;
      HEAP32[(($28)>>2)]=$465;
      var $467=HEAP32[(($28)>>2)];
      var $468=(($467)|0);
      var $469=$28;
      var $470=$29;
      HEAP32[(($468)>>2)]=$461;
      var $471=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $472=(($471)|0)!=0;
      if ($472) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $473
      var $474=(($450)|0);
      var $475=$27;
      HEAP32[(($27)>>2)]=$474;
      var $476=HEAP32[(($27)>>2)];
      var $477=$476;
      var $478=$26;
      HEAP32[(($26)>>2)]=$477;
      var $479=HEAP32[(($26)>>2)];
      var $480=(($479+4)|0);
      var $481=$26;
      var $482=$27;
      var $483=HEAP32[(($480)>>2)];
      var $484=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$483]($484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $485
      __label__ = 23; break;
    case 22: // $486
      var $487=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $488=$487.f0;
      HEAP32[(($34)>>2)]=$488;
      var $489=$487.f1;
      HEAP32[(($35)>>2)]=$489;
      var $490=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($490);
      throw "Reached an unreachable!"
    case 23: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit4
      var $491=$32;
      var $492=$33;
      var $493=$__tmp_i_i_i3;
      var $494=$34;
      var $495=$35;
      var $496=$36;
      var $497=$37;
      __label__ = 47; break;
    case 24: // $498
      var $499=$25;
      HEAP32[(($25)>>2)]=$__h;
      var $500=HEAP32[(($25)>>2)];
      var $501=(($500)|0);
      var $502=$24;
      HEAP32[(($24)>>2)]=$501;
      var $503=HEAP32[(($24)>>2)];
      var $504=$503;
      var $505=$23;
      HEAP32[(($23)>>2)]=$504;
      var $506=HEAP32[(($23)>>2)];
      var $507=(($506)|0);
      var $508=$23;
      var $509=$24;
      var $510=HEAP32[(($507)>>2)];
      var $511=$25;
      $__nc=$510;
      __label__ = 25; break;
    case 25: // $512
      var $513=HEAP8[($__neg)];
      var $514=(($513) & 1);
      if ($514) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $515
      var $516=$__nc;
      var $517=(($516+1)|0);
      $__nc=$517;
      HEAP8[($516)]=45;
      __label__ = 27; break;
    case 27: // $518
      var $519=$22;
      HEAP32[(($22)>>2)]=$__wb;
      var $520=HEAP32[(($22)>>2)];
      var $521=(($520)|0);
      var $522=$21;
      HEAP32[(($21)>>2)]=$521;
      var $523=HEAP32[(($21)>>2)];
      var $524=$523;
      var $525=$20;
      HEAP32[(($20)>>2)]=$524;
      var $526=HEAP32[(($20)>>2)];
      var $527=(($526)|0);
      var $528=$20;
      var $529=$21;
      var $530=HEAP32[(($527)>>2)];
      var $531=$22;
      $__w=$530;
      __label__ = 28; break;
    case 28: // $532
      var $533=$__w;
      var $534=HEAPU32[(($__wn)>>2)];
      var $535=(($533)>>>0) < (($534)>>>0);
      if ($535) { __label__ = 29; break; } else { __label__ = 37; break; }
    case 29: // $536
      var $537=(($__atoms)|0);
      var $538=(($__atoms)|0);
      var $539=(($538+10)|0);
      var $540=$__w;
      var $541=$17;
      var $542=$18;
      var $543=$19;
      HEAP32[(($17)>>2)]=$537;
      HEAP32[(($18)>>2)]=$539;
      HEAP32[(($19)>>2)]=$540;
      __label__ = 30; break;
    case 30: // $544
      var $545=HEAP32[(($17)>>2)];
      var $546=HEAP32[(($18)>>2)];
      var $547=(($545)|0)!=(($546)|0);
      if ($547) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $548
      var $549=HEAP32[(($17)>>2)];
      var $550=HEAP8[($549)];
      var $551=(($550 << 24) >> 24);
      var $552=HEAP32[(($19)>>2)];
      var $553=HEAP8[($552)];
      var $554=(($553 << 24) >> 24);
      var $555=(($551)|0)==(($554)|0);
      if ($555) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $556
      __label__ = 34; break;
    case 33: // $557
      var $558=HEAP32[(($17)>>2)];
      var $559=(($558+1)|0);
      HEAP32[(($17)>>2)]=$559;
      __label__ = 30; break;
    case 34: // $_ZNSt3__14findIPccEET_S2_S2_RKT0__exit
      var $560=HEAP32[(($17)>>2)];
      var $561=$17;
      var $562=$18;
      var $563=$19;
      __label__ = 35; break;
    case 35: // $564
      var $565=(($__atoms)|0);
      var $566=$560;
      var $567=$565;
      var $568=(($566-$567)|0);
      var $569=((STRING_TABLE.__ZZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src+$568)|0);
      var $570=HEAP8[($569)];
      var $571=$__nc;
      HEAP8[($571)]=$570;
      __label__ = 36; break;
    case 36: // $572
      var $573=$__w;
      var $574=(($573+1)|0);
      $__w=$574;
      var $575=$__nc;
      var $576=(($575+1)|0);
      $__nc=$576;
      __label__ = 28; break;
    case 37: // $577
      var $578=$__nc;
      HEAP8[($578)]=0;
      var $579=(($__nbuf)|0);
      var $580=$133;
      var $581=(function() { try { __THREW__ = false; return _sscanf($579, ((STRING_TABLE.__str27248)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$580,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 19; break; };
    case 38: // $582
      var $583=(($581)|0)!=1;
      if ($583) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $584
      (function() { try { __THREW__ = false; return __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str28249)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 19; break; }
    case 40: // $585
      __label__ = 41; break;
    case 41: // $586
      var $587=$12;
      HEAP32[(($12)>>2)]=$__h;
      var $588=HEAP32[(($12)>>2)];
      var $589=$11;
      HEAP32[(($11)>>2)]=$588;
      var $590=HEAP32[(($11)>>2)];
      var $591=$7;
      var $592=$8;
      var $593=$__tmp_i_i_i5;
      var $594=$9;
      var $595=$10;
      HEAP32[(($7)>>2)]=$590;
      HEAP32[(($8)>>2)]=0;
      var $596=HEAP32[(($7)>>2)];
      var $597=(($596)|0);
      var $598=$6;
      HEAP32[(($6)>>2)]=$597;
      var $599=HEAP32[(($6)>>2)];
      var $600=$599;
      var $601=$5;
      HEAP32[(($5)>>2)]=$600;
      var $602=HEAP32[(($5)>>2)];
      var $603=(($602)|0);
      var $604=$5;
      var $605=$6;
      var $606=HEAP32[(($603)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$606;
      var $607=HEAP32[(($8)>>2)];
      var $608=(($596)|0);
      var $609=$4;
      HEAP32[(($4)>>2)]=$608;
      var $610=HEAP32[(($4)>>2)];
      var $611=$610;
      var $612=$3;
      HEAP32[(($3)>>2)]=$611;
      var $613=HEAP32[(($3)>>2)];
      var $614=(($613)|0);
      var $615=$3;
      var $616=$4;
      HEAP32[(($614)>>2)]=$607;
      var $617=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $618=(($617)|0)!=0;
      if ($618) { __label__ = 42; break; } else { __label__ = 45; break; }
    case 42: // $619
      var $620=(($596)|0);
      var $621=$2;
      HEAP32[(($2)>>2)]=$620;
      var $622=HEAP32[(($2)>>2)];
      var $623=$622;
      var $624=$1;
      HEAP32[(($1)>>2)]=$623;
      var $625=HEAP32[(($1)>>2)];
      var $626=(($625+4)|0);
      var $627=$1;
      var $628=$2;
      var $629=HEAP32[(($626)>>2)];
      var $630=HEAP32[(($__tmp_i_i_i5)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$629]($630) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $631
      __label__ = 45; break;
    case 44: // $632
      var $633=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $634=$633.f0;
      HEAP32[(($9)>>2)]=$634;
      var $635=$633.f1;
      HEAP32[(($10)>>2)]=$635;
      var $636=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($636);
      throw "Reached an unreachable!"
    case 45: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit6
      var $637=$7;
      var $638=$8;
      var $639=$__tmp_i_i_i5;
      var $640=$9;
      var $641=$10;
      var $642=$11;
      var $643=$12;
      __label__ = 46; break;
    case 46: // $644
      __label__ = 48; break;
    case 47: // $645
      __label__ = 57; break;
    case 48: // $646
      var $647=$15;
      var $648=$16;
      HEAP32[(($15)>>2)]=$__b;
      HEAP32[(($16)>>2)]=$__e;
      var $649=HEAP32[(($15)>>2)];
      var $650=HEAP32[(($16)>>2)];
      var $651=$13;
      var $652=$14;
      HEAP32[(($13)>>2)]=$649;
      HEAP32[(($14)>>2)]=$650;
      var $653=HEAP32[(($13)>>2)];
      var $654=(($653)|0);
      var $655=HEAP32[(($654)>>2)];
      var $656=(($655)|0)==0;
      var $657=(($656)&1);
      var $658=HEAP32[(($14)>>2)];
      var $659=(($658)|0);
      var $660=HEAP32[(($659)>>2)];
      var $661=(($660)|0)==0;
      var $662=(($661)&1);
      var $663=(($657)|0)==(($662)|0);
      var $664=$13;
      var $665=$14;
      var $666=$15;
      var $667=$16;
      __label__ = 49; break;
    case 49: // $668
      if ($663) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $669
      var $670=$132;
      var $671=HEAP32[(($670)>>2)];
      var $672=$671 | 2;
      HEAP32[(($670)>>2)]=$672;
      __label__ = 51; break;
    case 51: // $673
      var $674=$agg_result;
      var $675=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($674)>>2)]=HEAP32[(($675)>>2)];
      $137=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 17; break; }
    case 52: // $676
      var $677=$65;
      HEAP32[(($65)>>2)]=$__wb;
      var $678=HEAP32[(($65)>>2)];
      var $679=$64;
      HEAP32[(($64)>>2)]=$678;
      var $680=HEAP32[(($64)>>2)];
      var $681=$60;
      var $682=$61;
      var $683=$__tmp_i_i_i1;
      var $684=$62;
      var $685=$63;
      HEAP32[(($60)>>2)]=$680;
      HEAP32[(($61)>>2)]=0;
      var $686=HEAP32[(($60)>>2)];
      var $687=(($686)|0);
      var $688=$59;
      HEAP32[(($59)>>2)]=$687;
      var $689=HEAP32[(($59)>>2)];
      var $690=$689;
      var $691=$58;
      HEAP32[(($58)>>2)]=$690;
      var $692=HEAP32[(($58)>>2)];
      var $693=(($692)|0);
      var $694=$58;
      var $695=$59;
      var $696=HEAP32[(($693)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$696;
      var $697=HEAP32[(($61)>>2)];
      var $698=(($686)|0);
      var $699=$57;
      HEAP32[(($57)>>2)]=$698;
      var $700=HEAP32[(($57)>>2)];
      var $701=$700;
      var $702=$56;
      HEAP32[(($56)>>2)]=$701;
      var $703=HEAP32[(($56)>>2)];
      var $704=(($703)|0);
      var $705=$56;
      var $706=$57;
      HEAP32[(($704)>>2)]=$697;
      var $707=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $708=(($707)|0)!=0;
      if ($708) { __label__ = 53; break; } else { __label__ = 56; break; }
    case 53: // $709
      var $710=(($686)|0);
      var $711=$55;
      HEAP32[(($55)>>2)]=$710;
      var $712=HEAP32[(($55)>>2)];
      var $713=$712;
      var $714=$54;
      HEAP32[(($54)>>2)]=$713;
      var $715=HEAP32[(($54)>>2)];
      var $716=(($715+4)|0);
      var $717=$54;
      var $718=$55;
      var $719=HEAP32[(($716)>>2)];
      var $720=HEAP32[(($__tmp_i_i_i1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$719]($720) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $721
      __label__ = 56; break;
    case 55: // $722
      var $723=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $724=$723.f0;
      HEAP32[(($62)>>2)]=$724;
      var $725=$723.f1;
      HEAP32[(($63)>>2)]=$725;
      var $726=HEAP32[(($62)>>2)];
      ___cxa_call_unexpected($726);
      throw "Reached an unreachable!"
    case 56: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit2
      var $727=$60;
      var $728=$61;
      var $729=$__tmp_i_i_i1;
      var $730=$62;
      var $731=$63;
      var $732=$64;
      var $733=$65;
      STACKTOP = __stackBase__;
      return;
    case 57: // $734
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 66; break; }
    case 58: // $735
      __label__ = 59; break;
    case 59: // $736
      var $737=$107;
      HEAP32[(($107)>>2)]=$__wb;
      var $738=HEAP32[(($107)>>2)];
      var $739=$106;
      HEAP32[(($106)>>2)]=$738;
      var $740=HEAP32[(($106)>>2)];
      var $741=$102;
      var $742=$103;
      var $743=$__tmp_i_i_i;
      var $744=$104;
      var $745=$105;
      HEAP32[(($102)>>2)]=$740;
      HEAP32[(($103)>>2)]=0;
      var $746=HEAP32[(($102)>>2)];
      var $747=(($746)|0);
      var $748=$101;
      HEAP32[(($101)>>2)]=$747;
      var $749=HEAP32[(($101)>>2)];
      var $750=$749;
      var $751=$100;
      HEAP32[(($100)>>2)]=$750;
      var $752=HEAP32[(($100)>>2)];
      var $753=(($752)|0);
      var $754=$100;
      var $755=$101;
      var $756=HEAP32[(($753)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$756;
      var $757=HEAP32[(($103)>>2)];
      var $758=(($746)|0);
      var $759=$99;
      HEAP32[(($99)>>2)]=$758;
      var $760=HEAP32[(($99)>>2)];
      var $761=$760;
      var $762=$98;
      HEAP32[(($98)>>2)]=$761;
      var $763=HEAP32[(($98)>>2)];
      var $764=(($763)|0);
      var $765=$98;
      var $766=$99;
      HEAP32[(($764)>>2)]=$757;
      var $767=HEAP32[(($__tmp_i_i_i)>>2)];
      var $768=(($767)|0)!=0;
      if ($768) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $769
      var $770=(($746)|0);
      var $771=$97;
      HEAP32[(($97)>>2)]=$770;
      var $772=HEAP32[(($97)>>2)];
      var $773=$772;
      var $774=$96;
      HEAP32[(($96)>>2)]=$773;
      var $775=HEAP32[(($96)>>2)];
      var $776=(($775+4)|0);
      var $777=$96;
      var $778=$97;
      var $779=HEAP32[(($776)>>2)];
      var $780=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$779]($780) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $781
      __label__ = 63; break;
    case 62: // $782
      var $783=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $784=$783.f0;
      HEAP32[(($104)>>2)]=$784;
      var $785=$783.f1;
      HEAP32[(($105)>>2)]=$785;
      var $786=HEAP32[(($104)>>2)];
      ___cxa_call_unexpected($786);
      throw "Reached an unreachable!"
    case 63: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $787=$102;
      var $788=$103;
      var $789=$__tmp_i_i_i;
      var $790=$104;
      var $791=$105;
      var $792=$106;
      var $793=$107;
      __label__ = 64; break;
    case 64: // $794
      __label__ = 65; break;
    case 65: // $795
      var $796=$134;
      var $797=$134;
      var $798=$135;
      var $799=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $797, tempValue);
      var $800=($799.f1 = $798, $799);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $801
      var $802=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe["X"]=1;

function __ZNSt3__112__do_nothingEPv($0) {
  ;
  var __label__;

  var $2;
  $2=$0;
  ;
  return;
}


function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_($__b, $__e, $__intl, $__loc, $__flags, $__err, $__neg, $__ct, $__wb, $__wn, $__we) {
  var __stackBase__  = STACKTOP; STACKTOP += 2236; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $20=__stackBase__+68;
      var $21=__stackBase__+72;
      var $22=__stackBase__+76;
      var $23=__stackBase__+80;
      var $24=__stackBase__+84;
      var $25=__stackBase__+88;
      var $26=__stackBase__+92;
      var $27=__stackBase__+96;
      var $28=__stackBase__+100;
      var $29=__stackBase__+104;
      var $30=__stackBase__+108;
      var $31=__stackBase__+112;
      var $32=__stackBase__+116;
      var $33=__stackBase__+120;
      var $34;
      var $35=__stackBase__+124;
      var $36=__stackBase__+128;
      var $37;
      var $38=__stackBase__+132;
      var $39=__stackBase__+136;
      var $40=__stackBase__+140;
      var $41=__stackBase__+144;
      var $42=__stackBase__+148;
      var $43=__stackBase__+152;
      var $44=__stackBase__+156;
      var $45;
      var $46=__stackBase__+160;
      var $47=__stackBase__+164;
      var $48;
      var $49=__stackBase__+168;
      var $50=__stackBase__+172;
      var $51=__stackBase__+176;
      var $52=__stackBase__+180;
      var $53=__stackBase__+184;
      var $54=__stackBase__+188;
      var $55=__stackBase__+192;
      var $56=__stackBase__+196;
      var $57=__stackBase__+200;
      var $58=__stackBase__+204;
      var $59=__stackBase__+208;
      var $60=__stackBase__+212;
      var $61=__stackBase__+216;
      var $62=__stackBase__+220;
      var $63=__stackBase__+224;
      var $64=__stackBase__+228;
      var $65=__stackBase__+232;
      var $66=__stackBase__+236;
      var $67=__stackBase__+240;
      var $68=__stackBase__+244;
      var $69;
      var $70=__stackBase__+248;
      var $71=__stackBase__+252;
      var $72=__stackBase__+256;
      var $73=__stackBase__+260;
      var $74=__stackBase__+264;
      var $75=__stackBase__+268;
      var $76=__stackBase__+272;
      var $77=__stackBase__+276;
      var $78=__stackBase__+280;
      var $79=__stackBase__+284;
      var $80=__stackBase__+288;
      var $81=__stackBase__+292;
      var $82=__stackBase__+296;
      var $83=__stackBase__+300;
      var $84=__stackBase__+304;
      var $85;
      var $86=__stackBase__+308;
      var $87=__stackBase__+312;
      var $88;
      var $89=__stackBase__+316;
      var $90=__stackBase__+320;
      var $91=__stackBase__+324;
      var $92=__stackBase__+328;
      var $93=__stackBase__+332;
      var $94=__stackBase__+336;
      var $95=__stackBase__+340;
      var $96=__stackBase__+344;
      var $97=__stackBase__+348;
      var $98=__stackBase__+352;
      var $99=__stackBase__+356;
      var $100=__stackBase__+360;
      var $101=__stackBase__+364;
      var $102=__stackBase__+368;
      var $103=__stackBase__+372;
      var $104=__stackBase__+376;
      var $105=__stackBase__+380;
      var $106=__stackBase__+384;
      var $107=__stackBase__+388;
      var $108=__stackBase__+392;
      var $109=__stackBase__+396;
      var $110;
      var $111=__stackBase__+400;
      var $112=__stackBase__+404;
      var $113=__stackBase__+408;
      var $114=__stackBase__+412;
      var $115=__stackBase__+416;
      var $116=__stackBase__+420;
      var $117=__stackBase__+424;
      var $118=__stackBase__+428;
      var $119=__stackBase__+432;
      var $120=__stackBase__+436;
      var $121=__stackBase__+440;
      var $122=__stackBase__+444;
      var $123=__stackBase__+448;
      var $124=__stackBase__+452;
      var $125=__stackBase__+456;
      var $126;
      var $127=__stackBase__+460;
      var $128=__stackBase__+464;
      var $129;
      var $130=__stackBase__+468;
      var $131=__stackBase__+472;
      var $132=__stackBase__+476;
      var $133=__stackBase__+480;
      var $134=__stackBase__+484;
      var $135;
      var $136=__stackBase__+488;
      var $137=__stackBase__+492;
      var $138=__stackBase__+496;
      var $139=__stackBase__+500;
      var $140=__stackBase__+504;
      var $141=__stackBase__+508;
      var $142=__stackBase__+512;
      var $143=__stackBase__+516;
      var $144=__stackBase__+520;
      var $145=__stackBase__+524;
      var $146=__stackBase__+528;
      var $147=__stackBase__+532;
      var $148=__stackBase__+536;
      var $149=__stackBase__+540;
      var $150=__stackBase__+544;
      var $151;
      var $152=__stackBase__+548;
      var $153=__stackBase__+552;
      var $154=__stackBase__+556;
      var $155=__stackBase__+560;
      var $156=__stackBase__+564;
      var $157=__stackBase__+568;
      var $158=__stackBase__+572;
      var $159=__stackBase__+576;
      var $160=__stackBase__+580;
      var $161=__stackBase__+584;
      var $162=__stackBase__+588;
      var $163=__stackBase__+592;
      var $164=__stackBase__+596;
      var $165=__stackBase__+600;
      var $166=__stackBase__+604;
      var $167;
      var $168=__stackBase__+608;
      var $169=__stackBase__+612;
      var $170;
      var $171=__stackBase__+616;
      var $172=__stackBase__+620;
      var $173=__stackBase__+624;
      var $174=__stackBase__+628;
      var $175=__stackBase__+632;
      var $176=__stackBase__+636;
      var $177=__stackBase__+640;
      var $178=__stackBase__+644;
      var $179=__stackBase__+648;
      var $180=__stackBase__+652;
      var $181=__stackBase__+656;
      var $182=__stackBase__+660;
      var $183=__stackBase__+664;
      var $184=__stackBase__+668;
      var $185=__stackBase__+672;
      var $186=__stackBase__+676;
      var $187=__stackBase__+680;
      var $188;
      var $189=__stackBase__+684;
      var $190=__stackBase__+688;
      var $191=__stackBase__+692;
      var $192=__stackBase__+696;
      var $193=__stackBase__+700;
      var $194;
      var $195=__stackBase__+704;
      var $196=__stackBase__+708;
      var $197;
      var $198=__stackBase__+712;
      var $199=__stackBase__+716;
      var $200=__stackBase__+720;
      var $201=__stackBase__+724;
      var $202=__stackBase__+728;
      var $203=__stackBase__+732;
      var $204=__stackBase__+736;
      var $205=__stackBase__+740;
      var $206=__stackBase__+744;
      var $207=__stackBase__+748;
      var $208=__stackBase__+752;
      var $209=__stackBase__+756;
      var $210=__stackBase__+760;
      var $211=__stackBase__+764;
      var $212=__stackBase__+768;
      var $213=__stackBase__+772;
      var $214=__stackBase__+776;
      var $215=__stackBase__+780;
      var $216=__stackBase__+784;
      var $217;
      var $218=__stackBase__+788;
      var $219=__stackBase__+792;
      var $220=__stackBase__+796;
      var $221=__stackBase__+800;
      var $222=__stackBase__+804;
      var $223;
      var $224=__stackBase__+808;
      var $225=__stackBase__+812;
      var $226=__stackBase__+816;
      var $227=__stackBase__+820;
      var $228=__stackBase__+824;
      var $229=__stackBase__+828;
      var $230=__stackBase__+832;
      var $231=__stackBase__+836;
      var $232=__stackBase__+840;
      var $233=__stackBase__+844;
      var $234=__stackBase__+848;
      var $235=__stackBase__+852;
      var $236=__stackBase__+856;
      var $237=__stackBase__+860;
      var $238=__stackBase__+864;
      var $239=__stackBase__+868;
      var $240=__stackBase__+872;
      var $241=__stackBase__+876;
      var $242=__stackBase__+880;
      var $243=__stackBase__+884;
      var $244;
      var $245=__stackBase__+888;
      var $246=__stackBase__+892;
      var $247=__stackBase__+896;
      var $248=__stackBase__+900;
      var $249=__stackBase__+904;
      var $250=__stackBase__+908;
      var $251=__stackBase__+912;
      var $252=__stackBase__+916;
      var $253=__stackBase__+920;
      var $254=__stackBase__+924;
      var $255=__stackBase__+928;
      var $256=__stackBase__+932;
      var $257=__stackBase__+936;
      var $258=__stackBase__+940;
      var $259=__stackBase__+944;
      var $260=__stackBase__+948;
      var $261=__stackBase__+952;
      var $262=__stackBase__+956;
      var $263=__stackBase__+960;
      var $264=__stackBase__+964;
      var $265=__stackBase__+968;
      var $266=__stackBase__+972;
      var $267=__stackBase__+976;
      var $268=__stackBase__+980;
      var $269=__stackBase__+984;
      var $270;
      var $271=__stackBase__+988;
      var $272=__stackBase__+992;
      var $273;
      var $274=__stackBase__+996;
      var $275=__stackBase__+1000;
      var $276=__stackBase__+1004;
      var $277=__stackBase__+1008;
      var $278=__stackBase__+1012;
      var $279=__stackBase__+1016;
      var $280=__stackBase__+1020;
      var $281;
      var $282;
      var $283=__stackBase__+1024;
      var $284=__stackBase__+1028;
      var $285=__stackBase__+1032;
      var $286=__stackBase__+1036;
      var $287=__stackBase__+1040;
      var $288=__stackBase__+1044;
      var $289=__stackBase__+1048;
      var $290=__stackBase__+1052;
      var $291=__stackBase__+1056;
      var $292;
      var $293=__stackBase__+1060;
      var $294=__stackBase__+1064;
      var $295;
      var $296=__stackBase__+1068;
      var $297=__stackBase__+1072;
      var $298=__stackBase__+1076;
      var $299=__stackBase__+1080;
      var $300=__stackBase__+1084;
      var $301=__stackBase__+1088;
      var $302=__stackBase__+1092;
      var $303;
      var $304=__stackBase__+1096;
      var $305=__stackBase__+1100;
      var $306;
      var $307=__stackBase__+1104;
      var $308=__stackBase__+1108;
      var $309=__stackBase__+1112;
      var $310=__stackBase__+1116;
      var $311=__stackBase__+1120;
      var $312=__stackBase__+1124;
      var $313=__stackBase__+1128;
      var $314=__stackBase__+1132;
      var $315=__stackBase__+1136;
      var $316=__stackBase__+1140;
      var $317=__stackBase__+1144;
      var $318=__stackBase__+1148;
      var $319=__stackBase__+1152;
      var $320=__stackBase__+1156;
      var $321=__stackBase__+1160;
      var $322=__stackBase__+1164;
      var $323=__stackBase__+1168;
      var $324=__stackBase__+1172;
      var $325=__stackBase__+1176;
      var $326=__stackBase__+1180;
      var $327=__stackBase__+1184;
      var $328=__stackBase__+1188;
      var $329=__stackBase__+1192;
      var $330=__stackBase__+1196;
      var $331;
      var $332;
      var $333=__stackBase__+1200;
      var $334=__stackBase__+1204;
      var $335=__stackBase__+1208;
      var $336;
      var $337=__stackBase__+1212;
      var $338=__stackBase__+1216;
      var $339=__stackBase__+1220;
      var $340=__stackBase__+1224;
      var $341=__stackBase__+1228;
      var $342=__stackBase__+1232;
      var $343=__stackBase__+1236;
      var $344=__stackBase__+1240;
      var $345=__stackBase__+1244;
      var $346=__stackBase__+1248;
      var $347=__stackBase__+1252;
      var $348=__stackBase__+1256;
      var $349=__stackBase__+1260;
      var $350=__stackBase__+1264;
      var $351=__stackBase__+1268;
      var $352=__stackBase__+1272;
      var $353=__stackBase__+1276;
      var $354=__stackBase__+1280;
      var $355=__stackBase__+1284;
      var $356=__stackBase__+1288;
      var $357=__stackBase__+1292;
      var $358=__stackBase__+1296;
      var $359=__stackBase__+1300;
      var $360=__stackBase__+1304;
      var $361=__stackBase__+1308;
      var $362;
      var $363=__stackBase__+1312;
      var $364=__stackBase__+1316;
      var $365;
      var $366=__stackBase__+1320;
      var $367=__stackBase__+1324;
      var $368=__stackBase__+1328;
      var $369=__stackBase__+1332;
      var $370=__stackBase__+1336;
      var $371=__stackBase__+1340;
      var $372=__stackBase__+1344;
      var $373=__stackBase__+1348;
      var $374=__stackBase__+1352;
      var $375=__stackBase__+1356;
      var $376=__stackBase__+1360;
      var $377=__stackBase__+1364;
      var $378=__stackBase__+1368;
      var $379=__stackBase__+1372;
      var $__a_i_i_i10=__stackBase__+1376;
      var $__i_i_i_i11=__stackBase__+1380;
      var $380=__stackBase__+1384;
      var $381=__stackBase__+1388;
      var $382=__stackBase__+1392;
      var $383=__stackBase__+1396;
      var $384=__stackBase__+1400;
      var $385=__stackBase__+1404;
      var $386=__stackBase__+1408;
      var $387=__stackBase__+1412;
      var $388=__stackBase__+1416;
      var $__a_i_i_i7=__stackBase__+1420;
      var $__i_i_i_i8=__stackBase__+1424;
      var $389=__stackBase__+1428;
      var $390=__stackBase__+1432;
      var $391=__stackBase__+1436;
      var $392=__stackBase__+1440;
      var $393=__stackBase__+1444;
      var $394=__stackBase__+1448;
      var $395=__stackBase__+1452;
      var $396=__stackBase__+1456;
      var $397=__stackBase__+1460;
      var $__a_i_i_i4=__stackBase__+1464;
      var $__i_i_i_i5=__stackBase__+1468;
      var $398=__stackBase__+1472;
      var $399=__stackBase__+1476;
      var $400=__stackBase__+1480;
      var $401=__stackBase__+1484;
      var $402=__stackBase__+1488;
      var $403=__stackBase__+1492;
      var $404=__stackBase__+1496;
      var $405=__stackBase__+1500;
      var $406=__stackBase__+1504;
      var $407=__stackBase__+1508;
      var $408=__stackBase__+1512;
      var $409=__stackBase__+1516;
      var $410=__stackBase__+1520;
      var $411=__stackBase__+1524;
      var $__tmp_i_i_i2=__stackBase__+1528;
      var $412=__stackBase__+1532;
      var $413=__stackBase__+1536;
      var $414=__stackBase__+1540;
      var $415=__stackBase__+1544;
      var $416=__stackBase__+1548;
      var $417=__stackBase__+1552;
      var $418=__stackBase__+1556;
      var $__a_i_i_i=__stackBase__+1560;
      var $__i_i_i_i=__stackBase__+1564;
      var $419=__stackBase__+1568;
      var $420=__stackBase__+1572;
      var $421=__stackBase__+1576;
      var $422=__stackBase__+1580;
      var $423=__stackBase__+1584;
      var $424=__stackBase__+1588;
      var $425=__stackBase__+1592;
      var $426=__stackBase__+1596;
      var $427=__stackBase__+1600;
      var $428=__stackBase__+1604;
      var $429=__stackBase__+1608;
      var $430=__stackBase__+1612;
      var $431=__stackBase__+1616;
      var $432=__stackBase__+1620;
      var $433=__stackBase__+1624;
      var $434=__stackBase__+1628;
      var $435=__stackBase__+1632;
      var $__tmp_i_i_i=__stackBase__+1636;
      var $436=__stackBase__+1640;
      var $437=__stackBase__+1644;
      var $438=__stackBase__+1648;
      var $439=__stackBase__+1652;
      var $440=__stackBase__+1656;
      var $441=__stackBase__+1660;
      var $442=__stackBase__+1664;
      var $443=__stackBase__+1668;
      var $444=__stackBase__+1672;
      var $445=__stackBase__+1676;
      var $446=__stackBase__+1680;
      var $447=__stackBase__+1684;
      var $448=__stackBase__+1688;
      var $449=__stackBase__+1692;
      var $450=__stackBase__+1696;
      var $451=__stackBase__+1700;
      var $452=__stackBase__+1704;
      var $453=__stackBase__+1708;
      var $454=__stackBase__+1712;
      var $455=__stackBase__+1716;
      var $456=__stackBase__+1720;
      var $457=__stackBase__+1724;
      var $458=__stackBase__+1728;
      var $459=__stackBase__+1732;
      var $460=__stackBase__+1736;
      var $461;
      var $462;
      var $463;
      var $464;
      var $465;
      var $466;
      var $467;
      var $468;
      var $469;
      var $470;
      var $471=__stackBase__+1740;
      var $__bz;
      var $__gbuf=__stackBase__+1744;
      var $__gb=__stackBase__+2144;
      var $__gn=__stackBase__+2152;
      var $__ge=__stackBase__+2156;
      var $__pat=__stackBase__+2160;
      var $__dp=__stackBase__+2164;
      var $__ts=__stackBase__+2168;
      var $__grp=__stackBase__+2172;
      var $472;
      var $473;
      var $__sym=__stackBase__+2184;
      var $__psn=__stackBase__+2196;
      var $__nsn=__stackBase__+2208;
      var $__fd=__stackBase__+2220;
      var $__trailing_sign;
      var $__p;
      var $474;
      var $__more_needed;
      var $__sb;
      var $__et=__stackBase__+2224;
      var $__k;
      var $475=__stackBase__+2228;
      var $__ng;
      var $__c;
      var $__i;
      var $__et1=__stackBase__+2232;
      $462=$__b;
      var $476=(($__intl)&1);
      $463=$476;
      $464=$__loc;
      $465=$__flags;
      $466=$__err;
      $467=$__neg;
      $468=$__ct;
      $469=$__wb;
      $470=$__wn;
      HEAP32[(($471)>>2)]=$__we;
      $__bz=100;
      var $477=(($__gbuf)|0);
      var $478=$458;
      var $479=$459;
      var $480=$460;
      HEAP32[(($458)>>2)]=$__gb;
      HEAP32[(($459)>>2)]=$477;
      HEAP32[(($460)>>2)]=1682;
      var $481=HEAP32[(($458)>>2)];
      var $482=HEAP32[(($459)>>2)];
      var $483=HEAP32[(($460)>>2)];
      var $484=$455;
      var $485=$456;
      var $486=$457;
      HEAP32[(($455)>>2)]=$481;
      HEAP32[(($456)>>2)]=$482;
      HEAP32[(($457)>>2)]=$483;
      var $487=HEAP32[(($455)>>2)];
      var $488=(($487)|0);
      var $489=$454;
      HEAP32[(($454)>>2)]=$456;
      var $490=HEAP32[(($454)>>2)];
      var $491=$454;
      var $492=HEAP32[(($490)>>2)];
      var $493=$440;
      HEAP32[(($440)>>2)]=$457;
      var $494=HEAP32[(($440)>>2)];
      var $495=$440;
      var $496=HEAP32[(($494)>>2)];
      var $497=$451;
      var $498=$452;
      var $499=$453;
      HEAP32[(($451)>>2)]=$488;
      HEAP32[(($452)>>2)]=$492;
      HEAP32[(($453)>>2)]=$496;
      var $500=HEAP32[(($451)>>2)];
      var $501=HEAP32[(($452)>>2)];
      var $502=HEAP32[(($453)>>2)];
      var $503=$448;
      var $504=$449;
      var $505=$450;
      HEAP32[(($448)>>2)]=$500;
      HEAP32[(($449)>>2)]=$501;
      HEAP32[(($450)>>2)]=$502;
      var $506=HEAP32[(($448)>>2)];
      var $507=$506;
      var $508=$447;
      HEAP32[(($447)>>2)]=$449;
      var $509=HEAP32[(($447)>>2)];
      var $510=$447;
      var $511=HEAP32[(($509)>>2)];
      var $512=$441;
      HEAP32[(($441)>>2)]=$450;
      var $513=HEAP32[(($441)>>2)];
      var $514=$441;
      var $515=HEAP32[(($513)>>2)];
      var $516=$444;
      var $517=$445;
      var $518=$446;
      HEAP32[(($444)>>2)]=$507;
      HEAP32[(($445)>>2)]=$511;
      HEAP32[(($446)>>2)]=$515;
      var $519=HEAP32[(($444)>>2)];
      var $520=(($519)|0);
      var $521=$443;
      HEAP32[(($443)>>2)]=$445;
      var $522=HEAP32[(($443)>>2)];
      var $523=$443;
      var $524=HEAP32[(($522)>>2)];
      HEAP32[(($520)>>2)]=$524;
      var $525=(($519+4)|0);
      var $526=$442;
      HEAP32[(($442)>>2)]=$446;
      var $527=HEAP32[(($442)>>2)];
      var $528=$442;
      var $529=HEAP32[(($527)>>2)];
      HEAP32[(($525)>>2)]=$529;
      var $530=$444;
      var $531=$445;
      var $532=$446;
      var $533=$448;
      var $534=$449;
      var $535=$450;
      var $536=$451;
      var $537=$452;
      var $538=$453;
      var $539=$455;
      var $540=$456;
      var $541=$457;
      var $542=$458;
      var $543=$459;
      var $544=$460;
      var $545=$427;
      HEAP32[(($427)>>2)]=$__gb;
      var $546=HEAP32[(($427)>>2)];
      var $547=(($546)|0);
      var $548=$426;
      HEAP32[(($426)>>2)]=$547;
      var $549=HEAP32[(($426)>>2)];
      var $550=$549;
      var $551=$425;
      HEAP32[(($425)>>2)]=$550;
      var $552=HEAP32[(($425)>>2)];
      var $553=(($552)|0);
      var $554=$425;
      var $555=$426;
      var $556=HEAP32[(($553)>>2)];
      var $557=$427;
      HEAP32[(($__gn)>>2)]=$556;
      var $558=HEAP32[(($__gn)>>2)];
      var $559=(($558+400)|0);
      HEAP32[(($__ge)>>2)]=$559;
      var $560=$424;
      HEAP32[(($424)>>2)]=$__grp;
      var $561=HEAP32[(($424)>>2)];
      var $562=$423;
      HEAP32[(($423)>>2)]=$561;
      var $563=HEAP32[(($423)>>2)];
      var $564=$563;
      var $565=(($563)|0);
      var $566=$422;
      HEAP32[(($422)>>2)]=$565;
      var $567=HEAP32[(($422)>>2)];
      var $568=$421;
      HEAP32[(($421)>>2)]=$567;
      var $569=HEAP32[(($421)>>2)];
      var $570=$569;
      var $571=$420;
      HEAP32[(($420)>>2)]=$570;
      var $572=HEAP32[(($420)>>2)];
      var $573=$572;
      var $574=$419;
      HEAP32[(($419)>>2)]=$573;
      var $575=HEAP32[(($419)>>2)];
      var $576=$419;
      var $577=(($572)|0);
      var $578=$420;
      var $579=$421;
      var $580=$422;
      var $581=$418;
      var $582=$__a_i_i_i;
      var $583=$__i_i_i_i;
      HEAP32[(($418)>>2)]=$563;
      var $584=HEAP32[(($418)>>2)];
      var $585=(($584)|0);
      var $586=$417;
      HEAP32[(($417)>>2)]=$585;
      var $587=HEAP32[(($417)>>2)];
      var $588=$587;
      var $589=$416;
      HEAP32[(($416)>>2)]=$588;
      var $590=HEAP32[(($416)>>2)];
      var $591=(($590)|0);
      var $592=$416;
      var $593=$417;
      var $594=(($591)|0);
      var $595=$594;
      var $596=(($595)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$596;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $597
      var $598=HEAPU32[(($__i_i_i_i)>>2)];
      var $599=(($598)>>>0) < 3;
      if ($599) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $600
      var $601=HEAP32[(($__i_i_i_i)>>2)];
      var $602=HEAP32[(($__a_i_i_i)>>2)];
      var $603=(($602+($601<<2))|0);
      HEAP32[(($603)>>2)]=0;
      var $604=HEAP32[(($__i_i_i_i)>>2)];
      var $605=(($604+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$605;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $606=$418;
      var $607=$__a_i_i_i;
      var $608=$__i_i_i_i;
      var $609=$423;
      var $610=$424;
      __label__ = 4; break;
    case 4: // $611
      var $612=$403;
      HEAP32[(($403)>>2)]=$__sym;
      var $613=HEAP32[(($403)>>2)];
      var $614=$402;
      HEAP32[(($402)>>2)]=$613;
      var $615=HEAPU32[(($402)>>2)];
      var $616=$615;
      var $617=(($615)|0);
      var $618=$401;
      HEAP32[(($401)>>2)]=$617;
      var $619=HEAP32[(($401)>>2)];
      var $620=$400;
      HEAP32[(($400)>>2)]=$619;
      var $621=HEAP32[(($400)>>2)];
      var $622=$621;
      var $623=$399;
      HEAP32[(($399)>>2)]=$622;
      var $624=HEAP32[(($399)>>2)];
      var $625=$624;
      var $626=$398;
      HEAP32[(($398)>>2)]=$625;
      var $627=HEAP32[(($398)>>2)];
      var $628=$398;
      var $629=(($624)|0);
      var $630=$399;
      var $631=$400;
      var $632=$401;
      var $633=$397;
      var $634=$__a_i_i_i4;
      var $635=$__i_i_i_i5;
      HEAP32[(($397)>>2)]=$615;
      var $636=HEAP32[(($397)>>2)];
      var $637=(($636)|0);
      var $638=$396;
      HEAP32[(($396)>>2)]=$637;
      var $639=HEAP32[(($396)>>2)];
      var $640=$639;
      var $641=$395;
      HEAP32[(($395)>>2)]=$640;
      var $642=HEAP32[(($395)>>2)];
      var $643=(($642)|0);
      var $644=$395;
      var $645=$396;
      var $646=(($643)|0);
      var $647=$646;
      var $648=(($647)|0);
      HEAP32[(($__a_i_i_i4)>>2)]=$648;
      HEAP32[(($__i_i_i_i5)>>2)]=0;
      __label__ = 5; break;
    case 5: // $649
      var $650=HEAPU32[(($__i_i_i_i5)>>2)];
      var $651=(($650)>>>0) < 3;
      if ($651) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $652
      var $653=HEAP32[(($__i_i_i_i5)>>2)];
      var $654=HEAP32[(($__a_i_i_i4)>>2)];
      var $655=(($654+($653<<2))|0);
      HEAP32[(($655)>>2)]=0;
      var $656=HEAP32[(($__i_i_i_i5)>>2)];
      var $657=(($656+1)|0);
      HEAP32[(($__i_i_i_i5)>>2)]=$657;
      __label__ = 5; break;
    case 7: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit6
      var $658=$397;
      var $659=$__a_i_i_i4;
      var $660=$__i_i_i_i5;
      var $661=$402;
      var $662=$403;
      __label__ = 8; break;
    case 8: // $663
      var $664=$394;
      HEAP32[(($394)>>2)]=$__psn;
      var $665=HEAP32[(($394)>>2)];
      var $666=$393;
      HEAP32[(($393)>>2)]=$665;
      var $667=HEAPU32[(($393)>>2)];
      var $668=$667;
      var $669=(($667)|0);
      var $670=$392;
      HEAP32[(($392)>>2)]=$669;
      var $671=HEAP32[(($392)>>2)];
      var $672=$391;
      HEAP32[(($391)>>2)]=$671;
      var $673=HEAP32[(($391)>>2)];
      var $674=$673;
      var $675=$390;
      HEAP32[(($390)>>2)]=$674;
      var $676=HEAP32[(($390)>>2)];
      var $677=$676;
      var $678=$389;
      HEAP32[(($389)>>2)]=$677;
      var $679=HEAP32[(($389)>>2)];
      var $680=$389;
      var $681=(($676)|0);
      var $682=$390;
      var $683=$391;
      var $684=$392;
      var $685=$388;
      var $686=$__a_i_i_i7;
      var $687=$__i_i_i_i8;
      HEAP32[(($388)>>2)]=$667;
      var $688=HEAP32[(($388)>>2)];
      var $689=(($688)|0);
      var $690=$387;
      HEAP32[(($387)>>2)]=$689;
      var $691=HEAP32[(($387)>>2)];
      var $692=$691;
      var $693=$386;
      HEAP32[(($386)>>2)]=$692;
      var $694=HEAP32[(($386)>>2)];
      var $695=(($694)|0);
      var $696=$386;
      var $697=$387;
      var $698=(($695)|0);
      var $699=$698;
      var $700=(($699)|0);
      HEAP32[(($__a_i_i_i7)>>2)]=$700;
      HEAP32[(($__i_i_i_i8)>>2)]=0;
      __label__ = 9; break;
    case 9: // $701
      var $702=HEAPU32[(($__i_i_i_i8)>>2)];
      var $703=(($702)>>>0) < 3;
      if ($703) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $704
      var $705=HEAP32[(($__i_i_i_i8)>>2)];
      var $706=HEAP32[(($__a_i_i_i7)>>2)];
      var $707=(($706+($705<<2))|0);
      HEAP32[(($707)>>2)]=0;
      var $708=HEAP32[(($__i_i_i_i8)>>2)];
      var $709=(($708+1)|0);
      HEAP32[(($__i_i_i_i8)>>2)]=$709;
      __label__ = 9; break;
    case 11: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit9
      var $710=$388;
      var $711=$__a_i_i_i7;
      var $712=$__i_i_i_i8;
      var $713=$393;
      var $714=$394;
      __label__ = 12; break;
    case 12: // $715
      var $716=$385;
      HEAP32[(($385)>>2)]=$__nsn;
      var $717=HEAP32[(($385)>>2)];
      var $718=$384;
      HEAP32[(($384)>>2)]=$717;
      var $719=HEAPU32[(($384)>>2)];
      var $720=$719;
      var $721=(($719)|0);
      var $722=$383;
      HEAP32[(($383)>>2)]=$721;
      var $723=HEAP32[(($383)>>2)];
      var $724=$382;
      HEAP32[(($382)>>2)]=$723;
      var $725=HEAP32[(($382)>>2)];
      var $726=$725;
      var $727=$381;
      HEAP32[(($381)>>2)]=$726;
      var $728=HEAP32[(($381)>>2)];
      var $729=$728;
      var $730=$380;
      HEAP32[(($380)>>2)]=$729;
      var $731=HEAP32[(($380)>>2)];
      var $732=$380;
      var $733=(($728)|0);
      var $734=$381;
      var $735=$382;
      var $736=$383;
      var $737=$379;
      var $738=$__a_i_i_i10;
      var $739=$__i_i_i_i11;
      HEAP32[(($379)>>2)]=$719;
      var $740=HEAP32[(($379)>>2)];
      var $741=(($740)|0);
      var $742=$378;
      HEAP32[(($378)>>2)]=$741;
      var $743=HEAP32[(($378)>>2)];
      var $744=$743;
      var $745=$377;
      HEAP32[(($377)>>2)]=$744;
      var $746=HEAP32[(($377)>>2)];
      var $747=(($746)|0);
      var $748=$377;
      var $749=$378;
      var $750=(($747)|0);
      var $751=$750;
      var $752=(($751)|0);
      HEAP32[(($__a_i_i_i10)>>2)]=$752;
      HEAP32[(($__i_i_i_i11)>>2)]=0;
      __label__ = 13; break;
    case 13: // $753
      var $754=HEAPU32[(($__i_i_i_i11)>>2)];
      var $755=(($754)>>>0) < 3;
      if ($755) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $756
      var $757=HEAP32[(($__i_i_i_i11)>>2)];
      var $758=HEAP32[(($__a_i_i_i10)>>2)];
      var $759=(($758+($757<<2))|0);
      HEAP32[(($759)>>2)]=0;
      var $760=HEAP32[(($__i_i_i_i11)>>2)];
      var $761=(($760+1)|0);
      HEAP32[(($__i_i_i_i11)>>2)]=$761;
      __label__ = 13; break;
    case 15: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit12
      var $762=$379;
      var $763=$__a_i_i_i10;
      var $764=$__i_i_i_i11;
      var $765=$384;
      var $766=$385;
      __label__ = 16; break;
    case 16: // $767
      var $768=$463;
      var $769=(($768) & 1);
      var $770=$464;
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri($769, $770, $__pat, $__dp, $__ts, $__grp, $__sym, $__psn, $__nsn, $__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 27; break; }
    case 17: // $771
      $__trailing_sign=0;
      var $772=$469;
      var $773=$359;
      HEAP32[(($359)>>2)]=$772;
      var $774=HEAP32[(($359)>>2)];
      var $775=(($774)|0);
      var $776=$358;
      HEAP32[(($358)>>2)]=$775;
      var $777=HEAP32[(($358)>>2)];
      var $778=$777;
      var $779=$357;
      HEAP32[(($357)>>2)]=$778;
      var $780=HEAP32[(($357)>>2)];
      var $781=(($780)|0);
      var $782=$357;
      var $783=$358;
      var $784=HEAP32[(($781)>>2)];
      var $785=$359;
      var $786=$470;
      HEAP32[(($786)>>2)]=$784;
      $__p=0;
      __label__ = 18; break;
    case 18: // $787
      var $788=$__p;
      var $789=(($788)>>>0) < 4;
      if ($789) { __label__ = 19; break; } else { var $816 = 0;__label__ = 21; break; }
    case 19: // $790
      var $791=$462;
      var $792=$355;
      var $793=$356;
      HEAP32[(($355)>>2)]=$791;
      HEAP32[(($356)>>2)]=$__e;
      var $794=HEAP32[(($355)>>2)];
      var $795=HEAP32[(($356)>>2)];
      var $796=$353;
      var $797=$354;
      HEAP32[(($353)>>2)]=$794;
      HEAP32[(($354)>>2)]=$795;
      var $798=HEAP32[(($353)>>2)];
      var $799=(($798)|0);
      var $800=HEAP32[(($799)>>2)];
      var $801=(($800)|0)==0;
      var $802=(($801)&1);
      var $803=HEAP32[(($354)>>2)];
      var $804=(($803)|0);
      var $805=HEAP32[(($804)>>2)];
      var $806=(($805)|0)==0;
      var $807=(($806)&1);
      var $808=(($802)|0)==(($807)|0);
      var $809=$353;
      var $810=$354;
      var $811=$808 ^ 1;
      var $812=$355;
      var $813=$356;
      __label__ = 20; break;
    case 20: // $814
      var $816 = $811;__label__ = 21; break;
    case 21: // $815
      var $816;
      if ($816) { __label__ = 22; break; } else { __label__ = 370; break; }
    case 22: // $817
      var $818=$__p;
      var $819=(($__pat)|0);
      var $820=(($819+$818)|0);
      var $821=HEAP8[($820)];
      var $822=(($821 << 24) >> 24);
      if ($822 == 1) {
        __label__ = 28; break;
      }
      else if ($822 == 0) {
        __label__ = 57; break;
      }
      else if ($822 == 3) {
        __label__ = 89; break;
      }
      else if ($822 == 2) {
        __label__ = 237; break;
      }
      else if ($822 == 4) {
        __label__ = 250; break;
      }
      else {
      __label__ = 368; break;
      }
      
    case 23: // $823
      var $824=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $825=$824.f0;
      $472=$825;
      var $826=$824.f1;
      $473=$826;
      __label__ = 428; break;
    case 24: // $827
      var $828=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $829=$828.f0;
      $472=$829;
      var $830=$828.f1;
      $473=$830;
      __label__ = 426; break;
    case 25: // $831
      var $832=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $833=$832.f0;
      $472=$833;
      var $834=$832.f1;
      $473=$834;
      __label__ = 419; break;
    case 26: // $835
      var $836=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $837=$836.f0;
      $472=$837;
      var $838=$836.f1;
      $473=$838;
      __label__ = 416; break;
    case 27: // $839
      var $840=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $841=$840.f0;
      $472=$841;
      var $842=$840.f1;
      $473=$842;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nsn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 414; break; } else { __label__ = 435; break; }
    case 28: // $843
      var $844=$__p;
      var $845=(($844)|0)!=3;
      if ($845) { __label__ = 29; break; } else { __label__ = 56; break; }
    case 29: // $846
      var $847=$468;
      var $848=$462;
      var $849=$335;
      HEAP32[(($335)>>2)]=$848;
      var $850=HEAP32[(($335)>>2)];
      var $851=(($850)|0);
      var $852=HEAP32[(($851)>>2)];
      var $853=$333;
      var $854=$334;
      HEAP32[(($334)>>2)]=$852;
      var $855=HEAP32[(($334)>>2)];
      var $856=(($855+12)|0);
      var $857=HEAP32[(($856)>>2)];
      var $858=(($855+16)|0);
      var $859=HEAP32[(($858)>>2)];
      var $860=(($857)|0)==(($859)|0);
      if ($860) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $861
      var $862=$855;
      var $863=HEAP32[(($862)>>2)];
      var $864=(($863+36)|0);
      var $865=HEAP32[(($864)>>2)];
      var $866=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$865]($855) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 27; break; };
    case 31: // $_noexc15
      HEAP32[(($333)>>2)]=$866;
      __label__ = 33; break;
    case 32: // $867
      var $868=(($855+12)|0);
      var $869=HEAP32[(($868)>>2)];
      var $870=HEAP8[($869)];
      $332=$870;
      var $871=$332;
      var $872=(($871)&255);
      HEAP32[(($333)>>2)]=$872;
      __label__ = 33; break;
    case 33: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit16
      var $873=HEAP32[(($333)>>2)];
      var $874=$333;
      var $875=$334;
      var $876=(($873) & 255);
      var $877=$335;
      __label__ = 34; break;
    case 34: // $878
      var $879=$329;
      var $880=$330;
      HEAP32[(($329)>>2)]=$847;
      HEAP32[(($330)>>2)]=16384;
      $331=$876;
      var $881=HEAP32[(($329)>>2)];
      var $882=$331;
      var $883=(($882 << 24) >> 24);
      var $884=(($883)>>>0) <= 127;
      if ($884) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $885
      var $886=$331;
      var $887=(($886 << 24) >> 24);
      var $888=(($881+8)|0);
      var $889=HEAP32[(($888)>>2)];
      var $890=(($889+($887<<2))|0);
      var $891=HEAP32[(($890)>>2)];
      var $892=HEAP32[(($330)>>2)];
      var $893=$891 & $892;
      var $895 = $893;__label__ = 37; break;
    case 36: // $894
      var $895 = 0;__label__ = 37; break;
    case 37: // $_ZNKSt3__15ctypeIcE2isEjc_exit
      var $895;
      var $896=(($895)|0)!=0;
      var $897=$329;
      var $898=$330;
      __label__ = 38; break;
    case 38: // $899
      if ($896) { __label__ = 39; break; } else { __label__ = 54; break; }
    case 39: // $900
      var $901=$462;
      var $902=$300;
      HEAP32[(($300)>>2)]=$901;
      var $903=HEAPU32[(($300)>>2)];
      var $904=(($903)|0);
      var $905=HEAP32[(($904)>>2)];
      var $906=$298;
      var $907=$299;
      HEAP32[(($299)>>2)]=$905;
      var $908=HEAPU32[(($299)>>2)];
      var $909=$296;
      var $910=$297;
      HEAP32[(($297)>>2)]=$908;
      var $911=HEAP32[(($297)>>2)];
      var $912=(($911+12)|0);
      var $913=HEAP32[(($912)>>2)];
      var $914=(($911+16)|0);
      var $915=HEAP32[(($914)>>2)];
      var $916=(($913)|0)==(($915)|0);
      if ($916) { __label__ = 40; break; } else { __label__ = 42; break; }
    case 40: // $917
      var $918=$911;
      var $919=HEAP32[(($918)>>2)];
      var $920=(($919+40)|0);
      var $921=HEAP32[(($920)>>2)];
      var $922=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$921]($911) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 27; break; };
    case 41: // $_noexc26
      HEAP32[(($296)>>2)]=$922;
      __label__ = 43; break;
    case 42: // $923
      var $924=(($911+12)|0);
      var $925=HEAP32[(($924)>>2)];
      var $926=(($925+1)|0);
      HEAP32[(($924)>>2)]=$926;
      var $927=HEAP8[($925)];
      $295=$927;
      var $928=$295;
      var $929=(($928)&255);
      HEAP32[(($296)>>2)]=$929;
      __label__ = 43; break;
    case 43: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i23
      var $930=HEAP32[(($296)>>2)];
      var $931=$296;
      var $932=$297;
      var $933=(($930)|0)==-1;
      if ($933) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $934
      HEAP32[(($298)>>2)]=-1;
      __label__ = 50; break;
    case 45: // $935
      var $936=$293;
      var $937=$294;
      HEAP32[(($294)>>2)]=$908;
      var $938=HEAPU32[(($294)>>2)];
      var $939=(($938+12)|0);
      var $940=HEAP32[(($939)>>2)];
      var $941=(($938+16)|0);
      var $942=HEAP32[(($941)>>2)];
      var $943=(($940)|0)==(($942)|0);
      if ($943) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $944
      var $945=$938;
      var $946=HEAP32[(($945)>>2)];
      var $947=(($946+36)|0);
      var $948=HEAP32[(($947)>>2)];
      var $949=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$948]($938) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 27; break; };
    case 47: // $_noexc27
      HEAP32[(($293)>>2)]=$949;
      __label__ = 49; break;
    case 48: // $950
      var $951=(($938+12)|0);
      var $952=HEAP32[(($951)>>2)];
      var $953=HEAP8[($952)];
      $292=$953;
      var $954=$292;
      var $955=(($954)&255);
      HEAP32[(($293)>>2)]=$955;
      __label__ = 49; break;
    case 49: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i24
      var $956=HEAP32[(($293)>>2)];
      var $957=$293;
      var $958=$294;
      HEAP32[(($298)>>2)]=$956;
      __label__ = 50; break;
    case 50: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i25
      var $959=HEAP32[(($298)>>2)];
      var $960=$298;
      var $961=$299;
      var $962=$290;
      var $963=$291;
      HEAP32[(($290)>>2)]=$959;
      HEAP32[(($291)>>2)]=-1;
      var $964=HEAP32[(($290)>>2)];
      var $965=HEAP32[(($291)>>2)];
      var $966=(($964)|0)==(($965)|0);
      var $967=$290;
      var $968=$291;
      if ($966) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $969
      var $970=(($903)|0);
      HEAP32[(($970)>>2)]=0;
      __label__ = 52; break;
    case 52: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit28
      var $971=$300;
      __label__ = 53; break;
    case 53: // $972
      __label__ = 55; break;
    case 54: // $973
      var $974=$466;
      var $975=HEAP32[(($974)>>2)];
      var $976=$975 | 4;
      HEAP32[(($974)>>2)]=$976;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 55: // $977
      __label__ = 56; break;
    case 56: // $978
      __label__ = 57; break;
    case 57: // $979
      var $980=$__p;
      var $981=(($980)|0)!=3;
      if ($981) { __label__ = 58; break; } else { __label__ = 88; break; }
    case 58: // $982
      __label__ = 59; break;
    case 59: // $983
      var $984=$462;
      var $985=$288;
      var $986=$289;
      HEAP32[(($288)>>2)]=$984;
      HEAP32[(($289)>>2)]=$__e;
      var $987=HEAP32[(($288)>>2)];
      var $988=HEAP32[(($289)>>2)];
      var $989=$286;
      var $990=$287;
      HEAP32[(($286)>>2)]=$987;
      HEAP32[(($287)>>2)]=$988;
      var $991=HEAP32[(($286)>>2)];
      var $992=(($991)|0);
      var $993=HEAP32[(($992)>>2)];
      var $994=(($993)|0)==0;
      var $995=(($994)&1);
      var $996=HEAP32[(($287)>>2)];
      var $997=(($996)|0);
      var $998=HEAP32[(($997)>>2)];
      var $999=(($998)|0)==0;
      var $1000=(($999)&1);
      var $1001=(($995)|0)==(($1000)|0);
      var $1002=$286;
      var $1003=$287;
      var $1004=$1001 ^ 1;
      var $1005=$288;
      var $1006=$289;
      __label__ = 60; break;
    case 60: // $1007
      if ($1004) { __label__ = 61; break; } else { var $1063 = 0;__label__ = 71; break; }
    case 61: // $1008
      var $1009=$468;
      var $1010=$462;
      var $1011=$285;
      HEAP32[(($285)>>2)]=$1010;
      var $1012=HEAP32[(($285)>>2)];
      var $1013=(($1012)|0);
      var $1014=HEAP32[(($1013)>>2)];
      var $1015=$283;
      var $1016=$284;
      HEAP32[(($284)>>2)]=$1014;
      var $1017=HEAP32[(($284)>>2)];
      var $1018=(($1017+12)|0);
      var $1019=HEAP32[(($1018)>>2)];
      var $1020=(($1017+16)|0);
      var $1021=HEAP32[(($1020)>>2)];
      var $1022=(($1019)|0)==(($1021)|0);
      if ($1022) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $1023
      var $1024=$1017;
      var $1025=HEAP32[(($1024)>>2)];
      var $1026=(($1025+36)|0);
      var $1027=HEAP32[(($1026)>>2)];
      var $1028=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1027]($1017) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 27; break; };
    case 63: // $_noexc29
      HEAP32[(($283)>>2)]=$1028;
      __label__ = 65; break;
    case 64: // $1029
      var $1030=(($1017+12)|0);
      var $1031=HEAP32[(($1030)>>2)];
      var $1032=HEAP8[($1031)];
      $282=$1032;
      var $1033=$282;
      var $1034=(($1033)&255);
      HEAP32[(($283)>>2)]=$1034;
      __label__ = 65; break;
    case 65: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit30
      var $1035=HEAP32[(($283)>>2)];
      var $1036=$283;
      var $1037=$284;
      var $1038=(($1035) & 255);
      var $1039=$285;
      __label__ = 66; break;
    case 66: // $1040
      var $1041=$279;
      var $1042=$280;
      HEAP32[(($279)>>2)]=$1009;
      HEAP32[(($280)>>2)]=16384;
      $281=$1038;
      var $1043=HEAP32[(($279)>>2)];
      var $1044=$281;
      var $1045=(($1044 << 24) >> 24);
      var $1046=(($1045)>>>0) <= 127;
      if ($1046) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $1047
      var $1048=$281;
      var $1049=(($1048 << 24) >> 24);
      var $1050=(($1043+8)|0);
      var $1051=HEAP32[(($1050)>>2)];
      var $1052=(($1051+($1049<<2))|0);
      var $1053=HEAP32[(($1052)>>2)];
      var $1054=HEAP32[(($280)>>2)];
      var $1055=$1053 & $1054;
      var $1057 = $1055;__label__ = 69; break;
    case 68: // $1056
      var $1057 = 0;__label__ = 69; break;
    case 69: // $_ZNKSt3__15ctypeIcE2isEjc_exit31
      var $1057;
      var $1058=(($1057)|0)!=0;
      var $1059=$279;
      var $1060=$280;
      __label__ = 70; break;
    case 70: // $1061
      var $1063 = $1058;__label__ = 71; break;
    case 71: // $1062
      var $1063;
      if ($1063) { __label__ = 72; break; } else { __label__ = 87; break; }
    case 72: // $1064
      var $1065=$462;
      var $1066=$278;
      HEAP32[(($278)>>2)]=$1065;
      var $1067=HEAPU32[(($278)>>2)];
      var $1068=(($1067)|0);
      var $1069=HEAP32[(($1068)>>2)];
      var $1070=$276;
      var $1071=$277;
      HEAP32[(($277)>>2)]=$1069;
      var $1072=HEAPU32[(($277)>>2)];
      var $1073=$274;
      var $1074=$275;
      HEAP32[(($275)>>2)]=$1072;
      var $1075=HEAP32[(($275)>>2)];
      var $1076=(($1075+12)|0);
      var $1077=HEAP32[(($1076)>>2)];
      var $1078=(($1075+16)|0);
      var $1079=HEAP32[(($1078)>>2)];
      var $1080=(($1077)|0)==(($1079)|0);
      if ($1080) { __label__ = 73; break; } else { __label__ = 75; break; }
    case 73: // $1081
      var $1082=$1075;
      var $1083=HEAP32[(($1082)>>2)];
      var $1084=(($1083+40)|0);
      var $1085=HEAP32[(($1084)>>2)];
      var $1086=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1085]($1075) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 74; break; } else { __label__ = 27; break; };
    case 74: // $_noexc35
      HEAP32[(($274)>>2)]=$1086;
      __label__ = 76; break;
    case 75: // $1087
      var $1088=(($1075+12)|0);
      var $1089=HEAP32[(($1088)>>2)];
      var $1090=(($1089+1)|0);
      HEAP32[(($1088)>>2)]=$1090;
      var $1091=HEAP8[($1089)];
      $273=$1091;
      var $1092=$273;
      var $1093=(($1092)&255);
      HEAP32[(($274)>>2)]=$1093;
      __label__ = 76; break;
    case 76: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i32
      var $1094=HEAP32[(($274)>>2)];
      var $1095=$274;
      var $1096=$275;
      var $1097=(($1094)|0)==-1;
      if ($1097) { __label__ = 77; break; } else { __label__ = 78; break; }
    case 77: // $1098
      HEAP32[(($276)>>2)]=-1;
      __label__ = 83; break;
    case 78: // $1099
      var $1100=$271;
      var $1101=$272;
      HEAP32[(($272)>>2)]=$1072;
      var $1102=HEAPU32[(($272)>>2)];
      var $1103=(($1102+12)|0);
      var $1104=HEAP32[(($1103)>>2)];
      var $1105=(($1102+16)|0);
      var $1106=HEAP32[(($1105)>>2)];
      var $1107=(($1104)|0)==(($1106)|0);
      if ($1107) { __label__ = 79; break; } else { __label__ = 81; break; }
    case 79: // $1108
      var $1109=$1102;
      var $1110=HEAP32[(($1109)>>2)];
      var $1111=(($1110+36)|0);
      var $1112=HEAP32[(($1111)>>2)];
      var $1113=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1112]($1102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 27; break; };
    case 80: // $_noexc36
      HEAP32[(($271)>>2)]=$1113;
      __label__ = 82; break;
    case 81: // $1114
      var $1115=(($1102+12)|0);
      var $1116=HEAP32[(($1115)>>2)];
      var $1117=HEAP8[($1116)];
      $270=$1117;
      var $1118=$270;
      var $1119=(($1118)&255);
      HEAP32[(($271)>>2)]=$1119;
      __label__ = 82; break;
    case 82: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i33
      var $1120=HEAP32[(($271)>>2)];
      var $1121=$271;
      var $1122=$272;
      HEAP32[(($276)>>2)]=$1120;
      __label__ = 83; break;
    case 83: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i34
      var $1123=HEAP32[(($276)>>2)];
      var $1124=$276;
      var $1125=$277;
      var $1126=$268;
      var $1127=$269;
      HEAP32[(($268)>>2)]=$1123;
      HEAP32[(($269)>>2)]=-1;
      var $1128=HEAP32[(($268)>>2)];
      var $1129=HEAP32[(($269)>>2)];
      var $1130=(($1128)|0)==(($1129)|0);
      var $1131=$268;
      var $1132=$269;
      if ($1130) { __label__ = 84; break; } else { __label__ = 85; break; }
    case 84: // $1133
      var $1134=(($1067)|0);
      HEAP32[(($1134)>>2)]=0;
      __label__ = 85; break;
    case 85: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit37
      var $1135=$278;
      __label__ = 86; break;
    case 86: // $1136
      __label__ = 59; break;
    case 87: // $1137
      __label__ = 88; break;
    case 88: // $1138
      __label__ = 368; break;
    case 89: // $1139
      var $1140=$267;
      HEAP32[(($267)>>2)]=$__psn;
      var $1141=HEAPU32[(($267)>>2)];
      var $1142=$266;
      HEAP32[(($266)>>2)]=$1141;
      var $1143=HEAP32[(($266)>>2)];
      var $1144=(($1143)|0);
      var $1145=$265;
      HEAP32[(($265)>>2)]=$1144;
      var $1146=HEAP32[(($265)>>2)];
      var $1147=$1146;
      var $1148=$264;
      HEAP32[(($264)>>2)]=$1147;
      var $1149=HEAP32[(($264)>>2)];
      var $1150=(($1149)|0);
      var $1151=$264;
      var $1152=$265;
      var $1153=(($1150)|0);
      var $1154=$1153;
      var $1155=(($1154)|0);
      var $1156=$1155;
      var $1157=HEAPU8[($1156)];
      var $1158=(($1157)&255);
      var $1159=$1158 & 1;
      var $1160=(($1159)|0)!=0;
      var $1161=$266;
      if ($1160) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $1162
      var $1163=$260;
      HEAP32[(($260)>>2)]=$1141;
      var $1164=HEAP32[(($260)>>2)];
      var $1165=(($1164)|0);
      var $1166=$259;
      HEAP32[(($259)>>2)]=$1165;
      var $1167=HEAP32[(($259)>>2)];
      var $1168=$1167;
      var $1169=$258;
      HEAP32[(($258)>>2)]=$1168;
      var $1170=HEAP32[(($258)>>2)];
      var $1171=(($1170)|0);
      var $1172=$258;
      var $1173=$259;
      var $1174=(($1171)|0);
      var $1175=$1174;
      var $1176=(($1175+4)|0);
      var $1177=HEAP32[(($1176)>>2)];
      var $1178=$260;
      var $1199 = $1177;__label__ = 92; break;
    case 91: // $1179
      var $1180=$263;
      HEAP32[(($263)>>2)]=$1141;
      var $1181=HEAP32[(($263)>>2)];
      var $1182=(($1181)|0);
      var $1183=$262;
      HEAP32[(($262)>>2)]=$1182;
      var $1184=HEAP32[(($262)>>2)];
      var $1185=$1184;
      var $1186=$261;
      HEAP32[(($261)>>2)]=$1185;
      var $1187=HEAP32[(($261)>>2)];
      var $1188=(($1187)|0);
      var $1189=$261;
      var $1190=$262;
      var $1191=(($1188)|0);
      var $1192=$1191;
      var $1193=(($1192)|0);
      var $1194=$1193;
      var $1195=HEAPU8[($1194)];
      var $1196=(($1195)&255);
      var $1197=$1196 >> 1;
      var $1198=$263;
      var $1199 = $1197;__label__ = 92; break;
    case 92: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit38
      var $1199;
      var $1200=$267;
      var $1201=$257;
      HEAP32[(($257)>>2)]=$__nsn;
      var $1202=HEAPU32[(($257)>>2)];
      var $1203=$256;
      HEAP32[(($256)>>2)]=$1202;
      var $1204=HEAP32[(($256)>>2)];
      var $1205=(($1204)|0);
      var $1206=$255;
      HEAP32[(($255)>>2)]=$1205;
      var $1207=HEAP32[(($255)>>2)];
      var $1208=$1207;
      var $1209=$254;
      HEAP32[(($254)>>2)]=$1208;
      var $1210=HEAP32[(($254)>>2)];
      var $1211=(($1210)|0);
      var $1212=$254;
      var $1213=$255;
      var $1214=(($1211)|0);
      var $1215=$1214;
      var $1216=(($1215)|0);
      var $1217=$1216;
      var $1218=HEAPU8[($1217)];
      var $1219=(($1218)&255);
      var $1220=$1219 & 1;
      var $1221=(($1220)|0)!=0;
      var $1222=$256;
      if ($1221) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $1223
      var $1224=$250;
      HEAP32[(($250)>>2)]=$1202;
      var $1225=HEAP32[(($250)>>2)];
      var $1226=(($1225)|0);
      var $1227=$249;
      HEAP32[(($249)>>2)]=$1226;
      var $1228=HEAP32[(($249)>>2)];
      var $1229=$1228;
      var $1230=$248;
      HEAP32[(($248)>>2)]=$1229;
      var $1231=HEAP32[(($248)>>2)];
      var $1232=(($1231)|0);
      var $1233=$248;
      var $1234=$249;
      var $1235=(($1232)|0);
      var $1236=$1235;
      var $1237=(($1236+4)|0);
      var $1238=HEAP32[(($1237)>>2)];
      var $1239=$250;
      var $1260 = $1238;__label__ = 95; break;
    case 94: // $1240
      var $1241=$253;
      HEAP32[(($253)>>2)]=$1202;
      var $1242=HEAP32[(($253)>>2)];
      var $1243=(($1242)|0);
      var $1244=$252;
      HEAP32[(($252)>>2)]=$1243;
      var $1245=HEAP32[(($252)>>2)];
      var $1246=$1245;
      var $1247=$251;
      HEAP32[(($251)>>2)]=$1246;
      var $1248=HEAP32[(($251)>>2)];
      var $1249=(($1248)|0);
      var $1250=$251;
      var $1251=$252;
      var $1252=(($1249)|0);
      var $1253=$1252;
      var $1254=(($1253)|0);
      var $1255=$1254;
      var $1256=HEAPU8[($1255)];
      var $1257=(($1256)&255);
      var $1258=$1257 >> 1;
      var $1259=$253;
      var $1260 = $1258;__label__ = 95; break;
    case 95: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit39
      var $1260;
      var $1261=$257;
      var $1262=(($1199+$1260)|0);
      var $1263=(($1262)>>>0) > 0;
      if ($1263) { __label__ = 96; break; } else { __label__ = 236; break; }
    case 96: // $1264
      var $1265=$243;
      HEAP32[(($243)>>2)]=$__psn;
      var $1266=HEAPU32[(($243)>>2)];
      var $1267=$242;
      HEAP32[(($242)>>2)]=$1266;
      var $1268=HEAP32[(($242)>>2)];
      var $1269=(($1268)|0);
      var $1270=$241;
      HEAP32[(($241)>>2)]=$1269;
      var $1271=HEAP32[(($241)>>2)];
      var $1272=$1271;
      var $1273=$240;
      HEAP32[(($240)>>2)]=$1272;
      var $1274=HEAP32[(($240)>>2)];
      var $1275=(($1274)|0);
      var $1276=$240;
      var $1277=$241;
      var $1278=(($1275)|0);
      var $1279=$1278;
      var $1280=(($1279)|0);
      var $1281=$1280;
      var $1282=HEAPU8[($1281)];
      var $1283=(($1282)&255);
      var $1284=$1283 & 1;
      var $1285=(($1284)|0)!=0;
      var $1286=$242;
      if ($1285) { __label__ = 97; break; } else { __label__ = 98; break; }
    case 97: // $1287
      var $1288=$236;
      HEAP32[(($236)>>2)]=$1266;
      var $1289=HEAP32[(($236)>>2)];
      var $1290=(($1289)|0);
      var $1291=$235;
      HEAP32[(($235)>>2)]=$1290;
      var $1292=HEAP32[(($235)>>2)];
      var $1293=$1292;
      var $1294=$234;
      HEAP32[(($234)>>2)]=$1293;
      var $1295=HEAP32[(($234)>>2)];
      var $1296=(($1295)|0);
      var $1297=$234;
      var $1298=$235;
      var $1299=(($1296)|0);
      var $1300=$1299;
      var $1301=(($1300+4)|0);
      var $1302=HEAP32[(($1301)>>2)];
      var $1303=$236;
      var $1324 = $1302;__label__ = 99; break;
    case 98: // $1304
      var $1305=$239;
      HEAP32[(($239)>>2)]=$1266;
      var $1306=HEAP32[(($239)>>2)];
      var $1307=(($1306)|0);
      var $1308=$238;
      HEAP32[(($238)>>2)]=$1307;
      var $1309=HEAP32[(($238)>>2)];
      var $1310=$1309;
      var $1311=$237;
      HEAP32[(($237)>>2)]=$1310;
      var $1312=HEAP32[(($237)>>2)];
      var $1313=(($1312)|0);
      var $1314=$237;
      var $1315=$238;
      var $1316=(($1313)|0);
      var $1317=$1316;
      var $1318=(($1317)|0);
      var $1319=$1318;
      var $1320=HEAPU8[($1319)];
      var $1321=(($1320)&255);
      var $1322=$1321 >> 1;
      var $1323=$239;
      var $1324 = $1322;__label__ = 99; break;
    case 99: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit42
      var $1324;
      var $1325=$243;
      var $1326=(($1324)|0)==0;
      if ($1326) { __label__ = 104; break; } else { __label__ = 100; break; }
    case 100: // $1327
      var $1328=$233;
      HEAP32[(($233)>>2)]=$__nsn;
      var $1329=HEAPU32[(($233)>>2)];
      var $1330=$232;
      HEAP32[(($232)>>2)]=$1329;
      var $1331=HEAP32[(($232)>>2)];
      var $1332=(($1331)|0);
      var $1333=$231;
      HEAP32[(($231)>>2)]=$1332;
      var $1334=HEAP32[(($231)>>2)];
      var $1335=$1334;
      var $1336=$230;
      HEAP32[(($230)>>2)]=$1335;
      var $1337=HEAP32[(($230)>>2)];
      var $1338=(($1337)|0);
      var $1339=$230;
      var $1340=$231;
      var $1341=(($1338)|0);
      var $1342=$1341;
      var $1343=(($1342)|0);
      var $1344=$1343;
      var $1345=HEAPU8[($1344)];
      var $1346=(($1345)&255);
      var $1347=$1346 & 1;
      var $1348=(($1347)|0)!=0;
      var $1349=$232;
      if ($1348) { __label__ = 101; break; } else { __label__ = 102; break; }
    case 101: // $1350
      var $1351=$226;
      HEAP32[(($226)>>2)]=$1329;
      var $1352=HEAP32[(($226)>>2)];
      var $1353=(($1352)|0);
      var $1354=$225;
      HEAP32[(($225)>>2)]=$1353;
      var $1355=HEAP32[(($225)>>2)];
      var $1356=$1355;
      var $1357=$224;
      HEAP32[(($224)>>2)]=$1356;
      var $1358=HEAP32[(($224)>>2)];
      var $1359=(($1358)|0);
      var $1360=$224;
      var $1361=$225;
      var $1362=(($1359)|0);
      var $1363=$1362;
      var $1364=(($1363+4)|0);
      var $1365=HEAP32[(($1364)>>2)];
      var $1366=$226;
      var $1387 = $1365;__label__ = 103; break;
    case 102: // $1367
      var $1368=$229;
      HEAP32[(($229)>>2)]=$1329;
      var $1369=HEAP32[(($229)>>2)];
      var $1370=(($1369)|0);
      var $1371=$228;
      HEAP32[(($228)>>2)]=$1370;
      var $1372=HEAP32[(($228)>>2)];
      var $1373=$1372;
      var $1374=$227;
      HEAP32[(($227)>>2)]=$1373;
      var $1375=HEAP32[(($227)>>2)];
      var $1376=(($1375)|0);
      var $1377=$227;
      var $1378=$228;
      var $1379=(($1376)|0);
      var $1380=$1379;
      var $1381=(($1380)|0);
      var $1382=$1381;
      var $1383=HEAPU8[($1382)];
      var $1384=(($1383)&255);
      var $1385=$1384 >> 1;
      var $1386=$229;
      var $1387 = $1385;__label__ = 103; break;
    case 103: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit43
      var $1387;
      var $1388=$233;
      var $1389=(($1387)|0)==0;
      if ($1389) { __label__ = 104; break; } else { __label__ = 172; break; }
    case 104: // $1390
      var $1391=$216;
      HEAP32[(($216)>>2)]=$__psn;
      var $1392=HEAPU32[(($216)>>2)];
      var $1393=$215;
      HEAP32[(($215)>>2)]=$1392;
      var $1394=HEAP32[(($215)>>2)];
      var $1395=(($1394)|0);
      var $1396=$214;
      HEAP32[(($214)>>2)]=$1395;
      var $1397=HEAP32[(($214)>>2)];
      var $1398=$1397;
      var $1399=$213;
      HEAP32[(($213)>>2)]=$1398;
      var $1400=HEAP32[(($213)>>2)];
      var $1401=(($1400)|0);
      var $1402=$213;
      var $1403=$214;
      var $1404=(($1401)|0);
      var $1405=$1404;
      var $1406=(($1405)|0);
      var $1407=$1406;
      var $1408=HEAPU8[($1407)];
      var $1409=(($1408)&255);
      var $1410=$1409 & 1;
      var $1411=(($1410)|0)!=0;
      var $1412=$215;
      if ($1411) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $1413
      var $1414=$209;
      HEAP32[(($209)>>2)]=$1392;
      var $1415=HEAP32[(($209)>>2)];
      var $1416=(($1415)|0);
      var $1417=$208;
      HEAP32[(($208)>>2)]=$1416;
      var $1418=HEAP32[(($208)>>2)];
      var $1419=$1418;
      var $1420=$207;
      HEAP32[(($207)>>2)]=$1419;
      var $1421=HEAP32[(($207)>>2)];
      var $1422=(($1421)|0);
      var $1423=$207;
      var $1424=$208;
      var $1425=(($1422)|0);
      var $1426=$1425;
      var $1427=(($1426+4)|0);
      var $1428=HEAP32[(($1427)>>2)];
      var $1429=$209;
      var $1450 = $1428;__label__ = 107; break;
    case 106: // $1430
      var $1431=$212;
      HEAP32[(($212)>>2)]=$1392;
      var $1432=HEAP32[(($212)>>2)];
      var $1433=(($1432)|0);
      var $1434=$211;
      HEAP32[(($211)>>2)]=$1433;
      var $1435=HEAP32[(($211)>>2)];
      var $1436=$1435;
      var $1437=$210;
      HEAP32[(($210)>>2)]=$1436;
      var $1438=HEAP32[(($210)>>2)];
      var $1439=(($1438)|0);
      var $1440=$210;
      var $1441=$211;
      var $1442=(($1439)|0);
      var $1443=$1442;
      var $1444=(($1443)|0);
      var $1445=$1444;
      var $1446=HEAPU8[($1445)];
      var $1447=(($1446)&255);
      var $1448=$1447 >> 1;
      var $1449=$212;
      var $1450 = $1448;__label__ = 107; break;
    case 107: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit47
      var $1450;
      var $1451=$216;
      var $1452=(($1450)>>>0) > 0;
      if ($1452) { __label__ = 108; break; } else { __label__ = 140; break; }
    case 108: // $1453
      var $1454=$462;
      var $1455=$191;
      HEAP32[(($191)>>2)]=$1454;
      var $1456=HEAP32[(($191)>>2)];
      var $1457=(($1456)|0);
      var $1458=HEAP32[(($1457)>>2)];
      var $1459=$189;
      var $1460=$190;
      HEAP32[(($190)>>2)]=$1458;
      var $1461=HEAPU32[(($190)>>2)];
      var $1462=(($1461+12)|0);
      var $1463=HEAP32[(($1462)>>2)];
      var $1464=(($1461+16)|0);
      var $1465=HEAP32[(($1464)>>2)];
      var $1466=(($1463)|0)==(($1465)|0);
      if ($1466) { __label__ = 109; break; } else { __label__ = 111; break; }
    case 109: // $1467
      var $1468=$1461;
      var $1469=HEAP32[(($1468)>>2)];
      var $1470=(($1469+36)|0);
      var $1471=HEAP32[(($1470)>>2)];
      var $1472=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1471]($1461) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 27; break; };
    case 110: // $_noexc54
      HEAP32[(($189)>>2)]=$1472;
      __label__ = 112; break;
    case 111: // $1473
      var $1474=(($1461+12)|0);
      var $1475=HEAP32[(($1474)>>2)];
      var $1476=HEAP8[($1475)];
      $188=$1476;
      var $1477=$188;
      var $1478=(($1477)&255);
      HEAP32[(($189)>>2)]=$1478;
      __label__ = 112; break;
    case 112: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit55
      var $1479=HEAP32[(($189)>>2)];
      var $1480=$189;
      var $1481=$190;
      var $1482=(($1479) & 255);
      var $1483=$191;
      __label__ = 113; break;
    case 113: // $1484
      var $1485=(($1482 << 24) >> 24);
      var $1486=$186;
      var $1487=$187;
      HEAP32[(($186)>>2)]=$__psn;
      HEAP32[(($187)>>2)]=0;
      var $1488=HEAP32[(($186)>>2)];
      var $1489=$185;
      HEAP32[(($185)>>2)]=$1488;
      var $1490=HEAPU32[(($185)>>2)];
      var $1491=$184;
      HEAP32[(($184)>>2)]=$1490;
      var $1492=HEAP32[(($184)>>2)];
      var $1493=(($1492)|0);
      var $1494=$183;
      HEAP32[(($183)>>2)]=$1493;
      var $1495=HEAP32[(($183)>>2)];
      var $1496=$1495;
      var $1497=$182;
      HEAP32[(($182)>>2)]=$1496;
      var $1498=HEAP32[(($182)>>2)];
      var $1499=(($1498)|0);
      var $1500=$182;
      var $1501=$183;
      var $1502=(($1499)|0);
      var $1503=$1502;
      var $1504=(($1503)|0);
      var $1505=$1504;
      var $1506=HEAPU8[($1505)];
      var $1507=(($1506)&255);
      var $1508=$1507 & 1;
      var $1509=(($1508)|0)!=0;
      var $1510=$184;
      if ($1509) { __label__ = 114; break; } else { __label__ = 115; break; }
    case 114: // $1511
      var $1512=$178;
      HEAP32[(($178)>>2)]=$1490;
      var $1513=HEAP32[(($178)>>2)];
      var $1514=(($1513)|0);
      var $1515=$177;
      HEAP32[(($177)>>2)]=$1514;
      var $1516=HEAP32[(($177)>>2)];
      var $1517=$1516;
      var $1518=$176;
      HEAP32[(($176)>>2)]=$1517;
      var $1519=HEAP32[(($176)>>2)];
      var $1520=(($1519)|0);
      var $1521=$176;
      var $1522=$177;
      var $1523=(($1520)|0);
      var $1524=$1523;
      var $1525=(($1524+8)|0);
      var $1526=HEAP32[(($1525)>>2)];
      var $1527=$178;
      var $1545 = $1526;__label__ = 116; break;
    case 115: // $1528
      var $1529=$181;
      HEAP32[(($181)>>2)]=$1490;
      var $1530=HEAP32[(($181)>>2)];
      var $1531=(($1530)|0);
      var $1532=$180;
      HEAP32[(($180)>>2)]=$1531;
      var $1533=HEAP32[(($180)>>2)];
      var $1534=$1533;
      var $1535=$179;
      HEAP32[(($179)>>2)]=$1534;
      var $1536=HEAP32[(($179)>>2)];
      var $1537=(($1536)|0);
      var $1538=$179;
      var $1539=$180;
      var $1540=(($1537)|0);
      var $1541=$1540;
      var $1542=(($1541+1)|0);
      var $1543=(($1542)|0);
      var $1544=$181;
      var $1545 = $1543;__label__ = 116; break;
    case 116: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $1545;
      var $1546=$185;
      var $1547=HEAP32[(($187)>>2)];
      var $1548=(($1545+$1547)|0);
      var $1549=$186;
      var $1550=$187;
      __label__ = 117; break;
    case 117: // $1551
      var $1552=HEAP8[($1548)];
      var $1553=(($1552 << 24) >> 24);
      var $1554=(($1485)|0)==(($1553)|0);
      if ($1554) { __label__ = 118; break; } else { __label__ = 138; break; }
    case 118: // $1555
      var $1556=$462;
      var $1557=$175;
      HEAP32[(($175)>>2)]=$1556;
      var $1558=HEAPU32[(($175)>>2)];
      var $1559=(($1558)|0);
      var $1560=HEAP32[(($1559)>>2)];
      var $1561=$173;
      var $1562=$174;
      HEAP32[(($174)>>2)]=$1560;
      var $1563=HEAPU32[(($174)>>2)];
      var $1564=$171;
      var $1565=$172;
      HEAP32[(($172)>>2)]=$1563;
      var $1566=HEAP32[(($172)>>2)];
      var $1567=(($1566+12)|0);
      var $1568=HEAP32[(($1567)>>2)];
      var $1569=(($1566+16)|0);
      var $1570=HEAP32[(($1569)>>2)];
      var $1571=(($1568)|0)==(($1570)|0);
      if ($1571) { __label__ = 119; break; } else { __label__ = 121; break; }
    case 119: // $1572
      var $1573=$1566;
      var $1574=HEAP32[(($1573)>>2)];
      var $1575=(($1574+40)|0);
      var $1576=HEAP32[(($1575)>>2)];
      var $1577=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1576]($1566) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 120; break; } else { __label__ = 27; break; };
    case 120: // $_noexc59
      HEAP32[(($171)>>2)]=$1577;
      __label__ = 122; break;
    case 121: // $1578
      var $1579=(($1566+12)|0);
      var $1580=HEAP32[(($1579)>>2)];
      var $1581=(($1580+1)|0);
      HEAP32[(($1579)>>2)]=$1581;
      var $1582=HEAP8[($1580)];
      $170=$1582;
      var $1583=$170;
      var $1584=(($1583)&255);
      HEAP32[(($171)>>2)]=$1584;
      __label__ = 122; break;
    case 122: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i56
      var $1585=HEAP32[(($171)>>2)];
      var $1586=$171;
      var $1587=$172;
      var $1588=(($1585)|0)==-1;
      if ($1588) { __label__ = 123; break; } else { __label__ = 124; break; }
    case 123: // $1589
      HEAP32[(($173)>>2)]=-1;
      __label__ = 129; break;
    case 124: // $1590
      var $1591=$168;
      var $1592=$169;
      HEAP32[(($169)>>2)]=$1563;
      var $1593=HEAPU32[(($169)>>2)];
      var $1594=(($1593+12)|0);
      var $1595=HEAP32[(($1594)>>2)];
      var $1596=(($1593+16)|0);
      var $1597=HEAP32[(($1596)>>2)];
      var $1598=(($1595)|0)==(($1597)|0);
      if ($1598) { __label__ = 125; break; } else { __label__ = 127; break; }
    case 125: // $1599
      var $1600=$1593;
      var $1601=HEAP32[(($1600)>>2)];
      var $1602=(($1601+36)|0);
      var $1603=HEAP32[(($1602)>>2)];
      var $1604=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1603]($1593) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 126; break; } else { __label__ = 27; break; };
    case 126: // $_noexc60
      HEAP32[(($168)>>2)]=$1604;
      __label__ = 128; break;
    case 127: // $1605
      var $1606=(($1593+12)|0);
      var $1607=HEAP32[(($1606)>>2)];
      var $1608=HEAP8[($1607)];
      $167=$1608;
      var $1609=$167;
      var $1610=(($1609)&255);
      HEAP32[(($168)>>2)]=$1610;
      __label__ = 128; break;
    case 128: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i57
      var $1611=HEAP32[(($168)>>2)];
      var $1612=$168;
      var $1613=$169;
      HEAP32[(($173)>>2)]=$1611;
      __label__ = 129; break;
    case 129: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i58
      var $1614=HEAP32[(($173)>>2)];
      var $1615=$173;
      var $1616=$174;
      var $1617=$165;
      var $1618=$166;
      HEAP32[(($165)>>2)]=$1614;
      HEAP32[(($166)>>2)]=-1;
      var $1619=HEAP32[(($165)>>2)];
      var $1620=HEAP32[(($166)>>2)];
      var $1621=(($1619)|0)==(($1620)|0);
      var $1622=$165;
      var $1623=$166;
      if ($1621) { __label__ = 130; break; } else { __label__ = 131; break; }
    case 130: // $1624
      var $1625=(($1558)|0);
      HEAP32[(($1625)>>2)]=0;
      __label__ = 131; break;
    case 131: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit61
      var $1626=$175;
      __label__ = 132; break;
    case 132: // $1627
      var $1628=$164;
      HEAP32[(($164)>>2)]=$__psn;
      var $1629=HEAPU32[(($164)>>2)];
      var $1630=$163;
      HEAP32[(($163)>>2)]=$1629;
      var $1631=HEAP32[(($163)>>2)];
      var $1632=(($1631)|0);
      var $1633=$162;
      HEAP32[(($162)>>2)]=$1632;
      var $1634=HEAP32[(($162)>>2)];
      var $1635=$1634;
      var $1636=$161;
      HEAP32[(($161)>>2)]=$1635;
      var $1637=HEAP32[(($161)>>2)];
      var $1638=(($1637)|0);
      var $1639=$161;
      var $1640=$162;
      var $1641=(($1638)|0);
      var $1642=$1641;
      var $1643=(($1642)|0);
      var $1644=$1643;
      var $1645=HEAPU8[($1644)];
      var $1646=(($1645)&255);
      var $1647=$1646 & 1;
      var $1648=(($1647)|0)!=0;
      var $1649=$163;
      if ($1648) { __label__ = 133; break; } else { __label__ = 134; break; }
    case 133: // $1650
      var $1651=$157;
      HEAP32[(($157)>>2)]=$1629;
      var $1652=HEAP32[(($157)>>2)];
      var $1653=(($1652)|0);
      var $1654=$156;
      HEAP32[(($156)>>2)]=$1653;
      var $1655=HEAP32[(($156)>>2)];
      var $1656=$1655;
      var $1657=$155;
      HEAP32[(($155)>>2)]=$1656;
      var $1658=HEAP32[(($155)>>2)];
      var $1659=(($1658)|0);
      var $1660=$155;
      var $1661=$156;
      var $1662=(($1659)|0);
      var $1663=$1662;
      var $1664=(($1663+4)|0);
      var $1665=HEAP32[(($1664)>>2)];
      var $1666=$157;
      var $1687 = $1665;__label__ = 135; break;
    case 134: // $1667
      var $1668=$160;
      HEAP32[(($160)>>2)]=$1629;
      var $1669=HEAP32[(($160)>>2)];
      var $1670=(($1669)|0);
      var $1671=$159;
      HEAP32[(($159)>>2)]=$1670;
      var $1672=HEAP32[(($159)>>2)];
      var $1673=$1672;
      var $1674=$158;
      HEAP32[(($158)>>2)]=$1673;
      var $1675=HEAP32[(($158)>>2)];
      var $1676=(($1675)|0);
      var $1677=$158;
      var $1678=$159;
      var $1679=(($1676)|0);
      var $1680=$1679;
      var $1681=(($1680)|0);
      var $1682=$1681;
      var $1683=HEAPU8[($1682)];
      var $1684=(($1683)&255);
      var $1685=$1684 >> 1;
      var $1686=$160;
      var $1687 = $1685;__label__ = 135; break;
    case 135: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit62
      var $1687;
      var $1688=$164;
      var $1689=(($1687)>>>0) > 1;
      if ($1689) { __label__ = 136; break; } else { __label__ = 137; break; }
    case 136: // $1690
      $__trailing_sign=$__psn;
      __label__ = 137; break;
    case 137: // $1691
      __label__ = 139; break;
    case 138: // $1692
      var $1693=$467;
      HEAP8[($1693)]=1;
      __label__ = 139; break;
    case 139: // $1694
      __label__ = 171; break;
    case 140: // $1695
      var $1696=$462;
      var $1697=$154;
      HEAP32[(($154)>>2)]=$1696;
      var $1698=HEAP32[(($154)>>2)];
      var $1699=(($1698)|0);
      var $1700=HEAP32[(($1699)>>2)];
      var $1701=$152;
      var $1702=$153;
      HEAP32[(($153)>>2)]=$1700;
      var $1703=HEAP32[(($153)>>2)];
      var $1704=(($1703+12)|0);
      var $1705=HEAP32[(($1704)>>2)];
      var $1706=(($1703+16)|0);
      var $1707=HEAP32[(($1706)>>2)];
      var $1708=(($1705)|0)==(($1707)|0);
      if ($1708) { __label__ = 141; break; } else { __label__ = 143; break; }
    case 141: // $1709
      var $1710=$1703;
      var $1711=HEAP32[(($1710)>>2)];
      var $1712=(($1711+36)|0);
      var $1713=HEAP32[(($1712)>>2)];
      var $1714=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1713]($1703) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 142; break; } else { __label__ = 27; break; };
    case 142: // $_noexc63
      HEAP32[(($152)>>2)]=$1714;
      __label__ = 144; break;
    case 143: // $1715
      var $1716=(($1703+12)|0);
      var $1717=HEAP32[(($1716)>>2)];
      var $1718=HEAP8[($1717)];
      $151=$1718;
      var $1719=$151;
      var $1720=(($1719)&255);
      HEAP32[(($152)>>2)]=$1720;
      __label__ = 144; break;
    case 144: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit64
      var $1721=HEAP32[(($152)>>2)];
      var $1722=$152;
      var $1723=$153;
      var $1724=(($1721) & 255);
      var $1725=$154;
      __label__ = 145; break;
    case 145: // $1726
      var $1727=(($1724 << 24) >> 24);
      var $1728=$149;
      var $1729=$150;
      HEAP32[(($149)>>2)]=$__nsn;
      HEAP32[(($150)>>2)]=0;
      var $1730=HEAP32[(($149)>>2)];
      var $1731=$148;
      HEAP32[(($148)>>2)]=$1730;
      var $1732=HEAPU32[(($148)>>2)];
      var $1733=$147;
      HEAP32[(($147)>>2)]=$1732;
      var $1734=HEAP32[(($147)>>2)];
      var $1735=(($1734)|0);
      var $1736=$146;
      HEAP32[(($146)>>2)]=$1735;
      var $1737=HEAP32[(($146)>>2)];
      var $1738=$1737;
      var $1739=$145;
      HEAP32[(($145)>>2)]=$1738;
      var $1740=HEAP32[(($145)>>2)];
      var $1741=(($1740)|0);
      var $1742=$145;
      var $1743=$146;
      var $1744=(($1741)|0);
      var $1745=$1744;
      var $1746=(($1745)|0);
      var $1747=$1746;
      var $1748=HEAPU8[($1747)];
      var $1749=(($1748)&255);
      var $1750=$1749 & 1;
      var $1751=(($1750)|0)!=0;
      var $1752=$147;
      if ($1751) { __label__ = 146; break; } else { __label__ = 147; break; }
    case 146: // $1753
      var $1754=$141;
      HEAP32[(($141)>>2)]=$1732;
      var $1755=HEAP32[(($141)>>2)];
      var $1756=(($1755)|0);
      var $1757=$140;
      HEAP32[(($140)>>2)]=$1756;
      var $1758=HEAP32[(($140)>>2)];
      var $1759=$1758;
      var $1760=$139;
      HEAP32[(($139)>>2)]=$1759;
      var $1761=HEAP32[(($139)>>2)];
      var $1762=(($1761)|0);
      var $1763=$139;
      var $1764=$140;
      var $1765=(($1762)|0);
      var $1766=$1765;
      var $1767=(($1766+8)|0);
      var $1768=HEAP32[(($1767)>>2)];
      var $1769=$141;
      var $1787 = $1768;__label__ = 148; break;
    case 147: // $1770
      var $1771=$144;
      HEAP32[(($144)>>2)]=$1732;
      var $1772=HEAP32[(($144)>>2)];
      var $1773=(($1772)|0);
      var $1774=$143;
      HEAP32[(($143)>>2)]=$1773;
      var $1775=HEAP32[(($143)>>2)];
      var $1776=$1775;
      var $1777=$142;
      HEAP32[(($142)>>2)]=$1776;
      var $1778=HEAP32[(($142)>>2)];
      var $1779=(($1778)|0);
      var $1780=$142;
      var $1781=$143;
      var $1782=(($1779)|0);
      var $1783=$1782;
      var $1784=(($1783+1)|0);
      var $1785=(($1784)|0);
      var $1786=$144;
      var $1787 = $1785;__label__ = 148; break;
    case 148: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit65
      var $1787;
      var $1788=$148;
      var $1789=HEAP32[(($150)>>2)];
      var $1790=(($1787+$1789)|0);
      var $1791=$149;
      var $1792=$150;
      __label__ = 149; break;
    case 149: // $1793
      var $1794=HEAP8[($1790)];
      var $1795=(($1794 << 24) >> 24);
      var $1796=(($1727)|0)==(($1795)|0);
      if ($1796) { __label__ = 150; break; } else { __label__ = 170; break; }
    case 150: // $1797
      var $1798=$462;
      var $1799=$134;
      HEAP32[(($134)>>2)]=$1798;
      var $1800=HEAPU32[(($134)>>2)];
      var $1801=(($1800)|0);
      var $1802=HEAP32[(($1801)>>2)];
      var $1803=$132;
      var $1804=$133;
      HEAP32[(($133)>>2)]=$1802;
      var $1805=HEAPU32[(($133)>>2)];
      var $1806=$130;
      var $1807=$131;
      HEAP32[(($131)>>2)]=$1805;
      var $1808=HEAP32[(($131)>>2)];
      var $1809=(($1808+12)|0);
      var $1810=HEAP32[(($1809)>>2)];
      var $1811=(($1808+16)|0);
      var $1812=HEAP32[(($1811)>>2)];
      var $1813=(($1810)|0)==(($1812)|0);
      if ($1813) { __label__ = 151; break; } else { __label__ = 153; break; }
    case 151: // $1814
      var $1815=$1808;
      var $1816=HEAP32[(($1815)>>2)];
      var $1817=(($1816+40)|0);
      var $1818=HEAP32[(($1817)>>2)];
      var $1819=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1818]($1808) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 152; break; } else { __label__ = 27; break; };
    case 152: // $_noexc71
      HEAP32[(($130)>>2)]=$1819;
      __label__ = 154; break;
    case 153: // $1820
      var $1821=(($1808+12)|0);
      var $1822=HEAP32[(($1821)>>2)];
      var $1823=(($1822+1)|0);
      HEAP32[(($1821)>>2)]=$1823;
      var $1824=HEAP8[($1822)];
      $129=$1824;
      var $1825=$129;
      var $1826=(($1825)&255);
      HEAP32[(($130)>>2)]=$1826;
      __label__ = 154; break;
    case 154: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i68
      var $1827=HEAP32[(($130)>>2)];
      var $1828=$130;
      var $1829=$131;
      var $1830=(($1827)|0)==-1;
      if ($1830) { __label__ = 155; break; } else { __label__ = 156; break; }
    case 155: // $1831
      HEAP32[(($132)>>2)]=-1;
      __label__ = 161; break;
    case 156: // $1832
      var $1833=$127;
      var $1834=$128;
      HEAP32[(($128)>>2)]=$1805;
      var $1835=HEAPU32[(($128)>>2)];
      var $1836=(($1835+12)|0);
      var $1837=HEAP32[(($1836)>>2)];
      var $1838=(($1835+16)|0);
      var $1839=HEAP32[(($1838)>>2)];
      var $1840=(($1837)|0)==(($1839)|0);
      if ($1840) { __label__ = 157; break; } else { __label__ = 159; break; }
    case 157: // $1841
      var $1842=$1835;
      var $1843=HEAP32[(($1842)>>2)];
      var $1844=(($1843+36)|0);
      var $1845=HEAP32[(($1844)>>2)];
      var $1846=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1845]($1835) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 158; break; } else { __label__ = 27; break; };
    case 158: // $_noexc72
      HEAP32[(($127)>>2)]=$1846;
      __label__ = 160; break;
    case 159: // $1847
      var $1848=(($1835+12)|0);
      var $1849=HEAP32[(($1848)>>2)];
      var $1850=HEAP8[($1849)];
      $126=$1850;
      var $1851=$126;
      var $1852=(($1851)&255);
      HEAP32[(($127)>>2)]=$1852;
      __label__ = 160; break;
    case 160: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i69
      var $1853=HEAP32[(($127)>>2)];
      var $1854=$127;
      var $1855=$128;
      HEAP32[(($132)>>2)]=$1853;
      __label__ = 161; break;
    case 161: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i70
      var $1856=HEAP32[(($132)>>2)];
      var $1857=$132;
      var $1858=$133;
      var $1859=$124;
      var $1860=$125;
      HEAP32[(($124)>>2)]=$1856;
      HEAP32[(($125)>>2)]=-1;
      var $1861=HEAP32[(($124)>>2)];
      var $1862=HEAP32[(($125)>>2)];
      var $1863=(($1861)|0)==(($1862)|0);
      var $1864=$124;
      var $1865=$125;
      if ($1863) { __label__ = 162; break; } else { __label__ = 163; break; }
    case 162: // $1866
      var $1867=(($1800)|0);
      HEAP32[(($1867)>>2)]=0;
      __label__ = 163; break;
    case 163: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit73
      var $1868=$134;
      __label__ = 164; break;
    case 164: // $1869
      var $1870=$467;
      HEAP8[($1870)]=1;
      var $1871=$123;
      HEAP32[(($123)>>2)]=$__nsn;
      var $1872=HEAPU32[(($123)>>2)];
      var $1873=$122;
      HEAP32[(($122)>>2)]=$1872;
      var $1874=HEAP32[(($122)>>2)];
      var $1875=(($1874)|0);
      var $1876=$121;
      HEAP32[(($121)>>2)]=$1875;
      var $1877=HEAP32[(($121)>>2)];
      var $1878=$1877;
      var $1879=$120;
      HEAP32[(($120)>>2)]=$1878;
      var $1880=HEAP32[(($120)>>2)];
      var $1881=(($1880)|0);
      var $1882=$120;
      var $1883=$121;
      var $1884=(($1881)|0);
      var $1885=$1884;
      var $1886=(($1885)|0);
      var $1887=$1886;
      var $1888=HEAPU8[($1887)];
      var $1889=(($1888)&255);
      var $1890=$1889 & 1;
      var $1891=(($1890)|0)!=0;
      var $1892=$122;
      if ($1891) { __label__ = 165; break; } else { __label__ = 166; break; }
    case 165: // $1893
      var $1894=$116;
      HEAP32[(($116)>>2)]=$1872;
      var $1895=HEAP32[(($116)>>2)];
      var $1896=(($1895)|0);
      var $1897=$115;
      HEAP32[(($115)>>2)]=$1896;
      var $1898=HEAP32[(($115)>>2)];
      var $1899=$1898;
      var $1900=$114;
      HEAP32[(($114)>>2)]=$1899;
      var $1901=HEAP32[(($114)>>2)];
      var $1902=(($1901)|0);
      var $1903=$114;
      var $1904=$115;
      var $1905=(($1902)|0);
      var $1906=$1905;
      var $1907=(($1906+4)|0);
      var $1908=HEAP32[(($1907)>>2)];
      var $1909=$116;
      var $1930 = $1908;__label__ = 167; break;
    case 166: // $1910
      var $1911=$119;
      HEAP32[(($119)>>2)]=$1872;
      var $1912=HEAP32[(($119)>>2)];
      var $1913=(($1912)|0);
      var $1914=$118;
      HEAP32[(($118)>>2)]=$1913;
      var $1915=HEAP32[(($118)>>2)];
      var $1916=$1915;
      var $1917=$117;
      HEAP32[(($117)>>2)]=$1916;
      var $1918=HEAP32[(($117)>>2)];
      var $1919=(($1918)|0);
      var $1920=$117;
      var $1921=$118;
      var $1922=(($1919)|0);
      var $1923=$1922;
      var $1924=(($1923)|0);
      var $1925=$1924;
      var $1926=HEAPU8[($1925)];
      var $1927=(($1926)&255);
      var $1928=$1927 >> 1;
      var $1929=$119;
      var $1930 = $1928;__label__ = 167; break;
    case 167: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit74
      var $1930;
      var $1931=$123;
      var $1932=(($1930)>>>0) > 1;
      if ($1932) { __label__ = 168; break; } else { __label__ = 169; break; }
    case 168: // $1933
      $__trailing_sign=$__nsn;
      __label__ = 169; break;
    case 169: // $1934
      __label__ = 170; break;
    case 170: // $1935
      __label__ = 171; break;
    case 171: // $1936
      __label__ = 235; break;
    case 172: // $1937
      var $1938=$462;
      var $1939=$113;
      HEAP32[(($113)>>2)]=$1938;
      var $1940=HEAP32[(($113)>>2)];
      var $1941=(($1940)|0);
      var $1942=HEAP32[(($1941)>>2)];
      var $1943=$111;
      var $1944=$112;
      HEAP32[(($112)>>2)]=$1942;
      var $1945=HEAP32[(($112)>>2)];
      var $1946=(($1945+12)|0);
      var $1947=HEAP32[(($1946)>>2)];
      var $1948=(($1945+16)|0);
      var $1949=HEAP32[(($1948)>>2)];
      var $1950=(($1947)|0)==(($1949)|0);
      if ($1950) { __label__ = 173; break; } else { __label__ = 175; break; }
    case 173: // $1951
      var $1952=$1945;
      var $1953=HEAP32[(($1952)>>2)];
      var $1954=(($1953+36)|0);
      var $1955=HEAP32[(($1954)>>2)];
      var $1956=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1955]($1945) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 174; break; } else { __label__ = 27; break; };
    case 174: // $_noexc75
      HEAP32[(($111)>>2)]=$1956;
      __label__ = 176; break;
    case 175: // $1957
      var $1958=(($1945+12)|0);
      var $1959=HEAP32[(($1958)>>2)];
      var $1960=HEAP8[($1959)];
      $110=$1960;
      var $1961=$110;
      var $1962=(($1961)&255);
      HEAP32[(($111)>>2)]=$1962;
      __label__ = 176; break;
    case 176: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit76
      var $1963=HEAP32[(($111)>>2)];
      var $1964=$111;
      var $1965=$112;
      var $1966=(($1963) & 255);
      var $1967=$113;
      __label__ = 177; break;
    case 177: // $1968
      var $1969=(($1966 << 24) >> 24);
      var $1970=$108;
      var $1971=$109;
      HEAP32[(($108)>>2)]=$__psn;
      HEAP32[(($109)>>2)]=0;
      var $1972=HEAP32[(($108)>>2)];
      var $1973=$107;
      HEAP32[(($107)>>2)]=$1972;
      var $1974=HEAPU32[(($107)>>2)];
      var $1975=$106;
      HEAP32[(($106)>>2)]=$1974;
      var $1976=HEAP32[(($106)>>2)];
      var $1977=(($1976)|0);
      var $1978=$105;
      HEAP32[(($105)>>2)]=$1977;
      var $1979=HEAP32[(($105)>>2)];
      var $1980=$1979;
      var $1981=$104;
      HEAP32[(($104)>>2)]=$1980;
      var $1982=HEAP32[(($104)>>2)];
      var $1983=(($1982)|0);
      var $1984=$104;
      var $1985=$105;
      var $1986=(($1983)|0);
      var $1987=$1986;
      var $1988=(($1987)|0);
      var $1989=$1988;
      var $1990=HEAPU8[($1989)];
      var $1991=(($1990)&255);
      var $1992=$1991 & 1;
      var $1993=(($1992)|0)!=0;
      var $1994=$106;
      if ($1993) { __label__ = 178; break; } else { __label__ = 179; break; }
    case 178: // $1995
      var $1996=$100;
      HEAP32[(($100)>>2)]=$1974;
      var $1997=HEAP32[(($100)>>2)];
      var $1998=(($1997)|0);
      var $1999=$99;
      HEAP32[(($99)>>2)]=$1998;
      var $2000=HEAP32[(($99)>>2)];
      var $2001=$2000;
      var $2002=$98;
      HEAP32[(($98)>>2)]=$2001;
      var $2003=HEAP32[(($98)>>2)];
      var $2004=(($2003)|0);
      var $2005=$98;
      var $2006=$99;
      var $2007=(($2004)|0);
      var $2008=$2007;
      var $2009=(($2008+8)|0);
      var $2010=HEAP32[(($2009)>>2)];
      var $2011=$100;
      var $2029 = $2010;__label__ = 180; break;
    case 179: // $2012
      var $2013=$103;
      HEAP32[(($103)>>2)]=$1974;
      var $2014=HEAP32[(($103)>>2)];
      var $2015=(($2014)|0);
      var $2016=$102;
      HEAP32[(($102)>>2)]=$2015;
      var $2017=HEAP32[(($102)>>2)];
      var $2018=$2017;
      var $2019=$101;
      HEAP32[(($101)>>2)]=$2018;
      var $2020=HEAP32[(($101)>>2)];
      var $2021=(($2020)|0);
      var $2022=$101;
      var $2023=$102;
      var $2024=(($2021)|0);
      var $2025=$2024;
      var $2026=(($2025+1)|0);
      var $2027=(($2026)|0);
      var $2028=$103;
      var $2029 = $2027;__label__ = 180; break;
    case 180: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit77
      var $2029;
      var $2030=$107;
      var $2031=HEAP32[(($109)>>2)];
      var $2032=(($2029+$2031)|0);
      var $2033=$108;
      var $2034=$109;
      __label__ = 181; break;
    case 181: // $2035
      var $2036=HEAP8[($2032)];
      var $2037=(($2036 << 24) >> 24);
      var $2038=(($1969)|0)==(($2037)|0);
      if ($2038) { __label__ = 182; break; } else { __label__ = 202; break; }
    case 182: // $2039
      var $2040=$462;
      var $2041=$93;
      HEAP32[(($93)>>2)]=$2040;
      var $2042=HEAPU32[(($93)>>2)];
      var $2043=(($2042)|0);
      var $2044=HEAP32[(($2043)>>2)];
      var $2045=$91;
      var $2046=$92;
      HEAP32[(($92)>>2)]=$2044;
      var $2047=HEAPU32[(($92)>>2)];
      var $2048=$89;
      var $2049=$90;
      HEAP32[(($90)>>2)]=$2047;
      var $2050=HEAP32[(($90)>>2)];
      var $2051=(($2050+12)|0);
      var $2052=HEAP32[(($2051)>>2)];
      var $2053=(($2050+16)|0);
      var $2054=HEAP32[(($2053)>>2)];
      var $2055=(($2052)|0)==(($2054)|0);
      if ($2055) { __label__ = 183; break; } else { __label__ = 185; break; }
    case 183: // $2056
      var $2057=$2050;
      var $2058=HEAP32[(($2057)>>2)];
      var $2059=(($2058+40)|0);
      var $2060=HEAP32[(($2059)>>2)];
      var $2061=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2060]($2050) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 184; break; } else { __label__ = 27; break; };
    case 184: // $_noexc81
      HEAP32[(($89)>>2)]=$2061;
      __label__ = 186; break;
    case 185: // $2062
      var $2063=(($2050+12)|0);
      var $2064=HEAP32[(($2063)>>2)];
      var $2065=(($2064+1)|0);
      HEAP32[(($2063)>>2)]=$2065;
      var $2066=HEAP8[($2064)];
      $88=$2066;
      var $2067=$88;
      var $2068=(($2067)&255);
      HEAP32[(($89)>>2)]=$2068;
      __label__ = 186; break;
    case 186: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i78
      var $2069=HEAP32[(($89)>>2)];
      var $2070=$89;
      var $2071=$90;
      var $2072=(($2069)|0)==-1;
      if ($2072) { __label__ = 187; break; } else { __label__ = 188; break; }
    case 187: // $2073
      HEAP32[(($91)>>2)]=-1;
      __label__ = 193; break;
    case 188: // $2074
      var $2075=$86;
      var $2076=$87;
      HEAP32[(($87)>>2)]=$2047;
      var $2077=HEAPU32[(($87)>>2)];
      var $2078=(($2077+12)|0);
      var $2079=HEAP32[(($2078)>>2)];
      var $2080=(($2077+16)|0);
      var $2081=HEAP32[(($2080)>>2)];
      var $2082=(($2079)|0)==(($2081)|0);
      if ($2082) { __label__ = 189; break; } else { __label__ = 191; break; }
    case 189: // $2083
      var $2084=$2077;
      var $2085=HEAP32[(($2084)>>2)];
      var $2086=(($2085+36)|0);
      var $2087=HEAP32[(($2086)>>2)];
      var $2088=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2087]($2077) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 190; break; } else { __label__ = 27; break; };
    case 190: // $_noexc82
      HEAP32[(($86)>>2)]=$2088;
      __label__ = 192; break;
    case 191: // $2089
      var $2090=(($2077+12)|0);
      var $2091=HEAP32[(($2090)>>2)];
      var $2092=HEAP8[($2091)];
      $85=$2092;
      var $2093=$85;
      var $2094=(($2093)&255);
      HEAP32[(($86)>>2)]=$2094;
      __label__ = 192; break;
    case 192: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i79
      var $2095=HEAP32[(($86)>>2)];
      var $2096=$86;
      var $2097=$87;
      HEAP32[(($91)>>2)]=$2095;
      __label__ = 193; break;
    case 193: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i80
      var $2098=HEAP32[(($91)>>2)];
      var $2099=$91;
      var $2100=$92;
      var $2101=$83;
      var $2102=$84;
      HEAP32[(($83)>>2)]=$2098;
      HEAP32[(($84)>>2)]=-1;
      var $2103=HEAP32[(($83)>>2)];
      var $2104=HEAP32[(($84)>>2)];
      var $2105=(($2103)|0)==(($2104)|0);
      var $2106=$83;
      var $2107=$84;
      if ($2105) { __label__ = 194; break; } else { __label__ = 195; break; }
    case 194: // $2108
      var $2109=(($2042)|0);
      HEAP32[(($2109)>>2)]=0;
      __label__ = 195; break;
    case 195: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit83
      var $2110=$93;
      __label__ = 196; break;
    case 196: // $2111
      var $2112=$82;
      HEAP32[(($82)>>2)]=$__psn;
      var $2113=HEAPU32[(($82)>>2)];
      var $2114=$81;
      HEAP32[(($81)>>2)]=$2113;
      var $2115=HEAP32[(($81)>>2)];
      var $2116=(($2115)|0);
      var $2117=$80;
      HEAP32[(($80)>>2)]=$2116;
      var $2118=HEAP32[(($80)>>2)];
      var $2119=$2118;
      var $2120=$79;
      HEAP32[(($79)>>2)]=$2119;
      var $2121=HEAP32[(($79)>>2)];
      var $2122=(($2121)|0);
      var $2123=$79;
      var $2124=$80;
      var $2125=(($2122)|0);
      var $2126=$2125;
      var $2127=(($2126)|0);
      var $2128=$2127;
      var $2129=HEAPU8[($2128)];
      var $2130=(($2129)&255);
      var $2131=$2130 & 1;
      var $2132=(($2131)|0)!=0;
      var $2133=$81;
      if ($2132) { __label__ = 197; break; } else { __label__ = 198; break; }
    case 197: // $2134
      var $2135=$75;
      HEAP32[(($75)>>2)]=$2113;
      var $2136=HEAP32[(($75)>>2)];
      var $2137=(($2136)|0);
      var $2138=$74;
      HEAP32[(($74)>>2)]=$2137;
      var $2139=HEAP32[(($74)>>2)];
      var $2140=$2139;
      var $2141=$73;
      HEAP32[(($73)>>2)]=$2140;
      var $2142=HEAP32[(($73)>>2)];
      var $2143=(($2142)|0);
      var $2144=$73;
      var $2145=$74;
      var $2146=(($2143)|0);
      var $2147=$2146;
      var $2148=(($2147+4)|0);
      var $2149=HEAP32[(($2148)>>2)];
      var $2150=$75;
      var $2171 = $2149;__label__ = 199; break;
    case 198: // $2151
      var $2152=$78;
      HEAP32[(($78)>>2)]=$2113;
      var $2153=HEAP32[(($78)>>2)];
      var $2154=(($2153)|0);
      var $2155=$77;
      HEAP32[(($77)>>2)]=$2154;
      var $2156=HEAP32[(($77)>>2)];
      var $2157=$2156;
      var $2158=$76;
      HEAP32[(($76)>>2)]=$2157;
      var $2159=HEAP32[(($76)>>2)];
      var $2160=(($2159)|0);
      var $2161=$76;
      var $2162=$77;
      var $2163=(($2160)|0);
      var $2164=$2163;
      var $2165=(($2164)|0);
      var $2166=$2165;
      var $2167=HEAPU8[($2166)];
      var $2168=(($2167)&255);
      var $2169=$2168 >> 1;
      var $2170=$78;
      var $2171 = $2169;__label__ = 199; break;
    case 199: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit84
      var $2171;
      var $2172=$82;
      var $2173=(($2171)>>>0) > 1;
      if ($2173) { __label__ = 200; break; } else { __label__ = 201; break; }
    case 200: // $2174
      $__trailing_sign=$__psn;
      __label__ = 201; break;
    case 201: // $2175
      __label__ = 234; break;
    case 202: // $2176
      var $2177=$462;
      var $2178=$72;
      HEAP32[(($72)>>2)]=$2177;
      var $2179=HEAP32[(($72)>>2)];
      var $2180=(($2179)|0);
      var $2181=HEAP32[(($2180)>>2)];
      var $2182=$70;
      var $2183=$71;
      HEAP32[(($71)>>2)]=$2181;
      var $2184=HEAPU32[(($71)>>2)];
      var $2185=(($2184+12)|0);
      var $2186=HEAP32[(($2185)>>2)];
      var $2187=(($2184+16)|0);
      var $2188=HEAP32[(($2187)>>2)];
      var $2189=(($2186)|0)==(($2188)|0);
      if ($2189) { __label__ = 203; break; } else { __label__ = 205; break; }
    case 203: // $2190
      var $2191=$2184;
      var $2192=HEAP32[(($2191)>>2)];
      var $2193=(($2192+36)|0);
      var $2194=HEAP32[(($2193)>>2)];
      var $2195=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2194]($2184) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 204; break; } else { __label__ = 27; break; };
    case 204: // $_noexc85
      HEAP32[(($70)>>2)]=$2195;
      __label__ = 206; break;
    case 205: // $2196
      var $2197=(($2184+12)|0);
      var $2198=HEAP32[(($2197)>>2)];
      var $2199=HEAP8[($2198)];
      $69=$2199;
      var $2200=$69;
      var $2201=(($2200)&255);
      HEAP32[(($70)>>2)]=$2201;
      __label__ = 206; break;
    case 206: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit86
      var $2202=HEAP32[(($70)>>2)];
      var $2203=$70;
      var $2204=$71;
      var $2205=(($2202) & 255);
      var $2206=$72;
      __label__ = 207; break;
    case 207: // $2207
      var $2208=(($2205 << 24) >> 24);
      var $2209=$67;
      var $2210=$68;
      HEAP32[(($67)>>2)]=$__nsn;
      HEAP32[(($68)>>2)]=0;
      var $2211=HEAP32[(($67)>>2)];
      var $2212=$66;
      HEAP32[(($66)>>2)]=$2211;
      var $2213=HEAPU32[(($66)>>2)];
      var $2214=$65;
      HEAP32[(($65)>>2)]=$2213;
      var $2215=HEAP32[(($65)>>2)];
      var $2216=(($2215)|0);
      var $2217=$64;
      HEAP32[(($64)>>2)]=$2216;
      var $2218=HEAP32[(($64)>>2)];
      var $2219=$2218;
      var $2220=$63;
      HEAP32[(($63)>>2)]=$2219;
      var $2221=HEAP32[(($63)>>2)];
      var $2222=(($2221)|0);
      var $2223=$63;
      var $2224=$64;
      var $2225=(($2222)|0);
      var $2226=$2225;
      var $2227=(($2226)|0);
      var $2228=$2227;
      var $2229=HEAPU8[($2228)];
      var $2230=(($2229)&255);
      var $2231=$2230 & 1;
      var $2232=(($2231)|0)!=0;
      var $2233=$65;
      if ($2232) { __label__ = 208; break; } else { __label__ = 209; break; }
    case 208: // $2234
      var $2235=$59;
      HEAP32[(($59)>>2)]=$2213;
      var $2236=HEAP32[(($59)>>2)];
      var $2237=(($2236)|0);
      var $2238=$58;
      HEAP32[(($58)>>2)]=$2237;
      var $2239=HEAP32[(($58)>>2)];
      var $2240=$2239;
      var $2241=$57;
      HEAP32[(($57)>>2)]=$2240;
      var $2242=HEAP32[(($57)>>2)];
      var $2243=(($2242)|0);
      var $2244=$57;
      var $2245=$58;
      var $2246=(($2243)|0);
      var $2247=$2246;
      var $2248=(($2247+8)|0);
      var $2249=HEAP32[(($2248)>>2)];
      var $2250=$59;
      var $2268 = $2249;__label__ = 210; break;
    case 209: // $2251
      var $2252=$62;
      HEAP32[(($62)>>2)]=$2213;
      var $2253=HEAP32[(($62)>>2)];
      var $2254=(($2253)|0);
      var $2255=$61;
      HEAP32[(($61)>>2)]=$2254;
      var $2256=HEAP32[(($61)>>2)];
      var $2257=$2256;
      var $2258=$60;
      HEAP32[(($60)>>2)]=$2257;
      var $2259=HEAP32[(($60)>>2)];
      var $2260=(($2259)|0);
      var $2261=$60;
      var $2262=$61;
      var $2263=(($2260)|0);
      var $2264=$2263;
      var $2265=(($2264+1)|0);
      var $2266=(($2265)|0);
      var $2267=$62;
      var $2268 = $2266;__label__ = 210; break;
    case 210: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit87
      var $2268;
      var $2269=$66;
      var $2270=HEAP32[(($68)>>2)];
      var $2271=(($2268+$2270)|0);
      var $2272=$67;
      var $2273=$68;
      __label__ = 211; break;
    case 211: // $2274
      var $2275=HEAP8[($2271)];
      var $2276=(($2275 << 24) >> 24);
      var $2277=(($2208)|0)==(($2276)|0);
      if ($2277) { __label__ = 212; break; } else { __label__ = 232; break; }
    case 212: // $2278
      var $2279=$462;
      var $2280=$42;
      HEAP32[(($42)>>2)]=$2279;
      var $2281=HEAPU32[(($42)>>2)];
      var $2282=(($2281)|0);
      var $2283=HEAP32[(($2282)>>2)];
      var $2284=$40;
      var $2285=$41;
      HEAP32[(($41)>>2)]=$2283;
      var $2286=HEAPU32[(($41)>>2)];
      var $2287=$38;
      var $2288=$39;
      HEAP32[(($39)>>2)]=$2286;
      var $2289=HEAP32[(($39)>>2)];
      var $2290=(($2289+12)|0);
      var $2291=HEAP32[(($2290)>>2)];
      var $2292=(($2289+16)|0);
      var $2293=HEAP32[(($2292)>>2)];
      var $2294=(($2291)|0)==(($2293)|0);
      if ($2294) { __label__ = 213; break; } else { __label__ = 215; break; }
    case 213: // $2295
      var $2296=$2289;
      var $2297=HEAP32[(($2296)>>2)];
      var $2298=(($2297+40)|0);
      var $2299=HEAP32[(($2298)>>2)];
      var $2300=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2299]($2289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 214; break; } else { __label__ = 27; break; };
    case 214: // $_noexc97
      HEAP32[(($38)>>2)]=$2300;
      __label__ = 216; break;
    case 215: // $2301
      var $2302=(($2289+12)|0);
      var $2303=HEAP32[(($2302)>>2)];
      var $2304=(($2303+1)|0);
      HEAP32[(($2302)>>2)]=$2304;
      var $2305=HEAP8[($2303)];
      $37=$2305;
      var $2306=$37;
      var $2307=(($2306)&255);
      HEAP32[(($38)>>2)]=$2307;
      __label__ = 216; break;
    case 216: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i94
      var $2308=HEAP32[(($38)>>2)];
      var $2309=$38;
      var $2310=$39;
      var $2311=(($2308)|0)==-1;
      if ($2311) { __label__ = 217; break; } else { __label__ = 218; break; }
    case 217: // $2312
      HEAP32[(($40)>>2)]=-1;
      __label__ = 223; break;
    case 218: // $2313
      var $2314=$35;
      var $2315=$36;
      HEAP32[(($36)>>2)]=$2286;
      var $2316=HEAPU32[(($36)>>2)];
      var $2317=(($2316+12)|0);
      var $2318=HEAP32[(($2317)>>2)];
      var $2319=(($2316+16)|0);
      var $2320=HEAP32[(($2319)>>2)];
      var $2321=(($2318)|0)==(($2320)|0);
      if ($2321) { __label__ = 219; break; } else { __label__ = 221; break; }
    case 219: // $2322
      var $2323=$2316;
      var $2324=HEAP32[(($2323)>>2)];
      var $2325=(($2324+36)|0);
      var $2326=HEAP32[(($2325)>>2)];
      var $2327=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2326]($2316) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 220; break; } else { __label__ = 27; break; };
    case 220: // $_noexc98
      HEAP32[(($35)>>2)]=$2327;
      __label__ = 222; break;
    case 221: // $2328
      var $2329=(($2316+12)|0);
      var $2330=HEAP32[(($2329)>>2)];
      var $2331=HEAP8[($2330)];
      $34=$2331;
      var $2332=$34;
      var $2333=(($2332)&255);
      HEAP32[(($35)>>2)]=$2333;
      __label__ = 222; break;
    case 222: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i95
      var $2334=HEAP32[(($35)>>2)];
      var $2335=$35;
      var $2336=$36;
      HEAP32[(($40)>>2)]=$2334;
      __label__ = 223; break;
    case 223: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i96
      var $2337=HEAP32[(($40)>>2)];
      var $2338=$40;
      var $2339=$41;
      var $2340=$32;
      var $2341=$33;
      HEAP32[(($32)>>2)]=$2337;
      HEAP32[(($33)>>2)]=-1;
      var $2342=HEAP32[(($32)>>2)];
      var $2343=HEAP32[(($33)>>2)];
      var $2344=(($2342)|0)==(($2343)|0);
      var $2345=$32;
      var $2346=$33;
      if ($2344) { __label__ = 224; break; } else { __label__ = 225; break; }
    case 224: // $2347
      var $2348=(($2281)|0);
      HEAP32[(($2348)>>2)]=0;
      __label__ = 225; break;
    case 225: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit99
      var $2349=$42;
      __label__ = 226; break;
    case 226: // $2350
      var $2351=$467;
      HEAP8[($2351)]=1;
      var $2352=$31;
      HEAP32[(($31)>>2)]=$__nsn;
      var $2353=HEAPU32[(($31)>>2)];
      var $2354=$30;
      HEAP32[(($30)>>2)]=$2353;
      var $2355=HEAP32[(($30)>>2)];
      var $2356=(($2355)|0);
      var $2357=$29;
      HEAP32[(($29)>>2)]=$2356;
      var $2358=HEAP32[(($29)>>2)];
      var $2359=$2358;
      var $2360=$28;
      HEAP32[(($28)>>2)]=$2359;
      var $2361=HEAP32[(($28)>>2)];
      var $2362=(($2361)|0);
      var $2363=$28;
      var $2364=$29;
      var $2365=(($2362)|0);
      var $2366=$2365;
      var $2367=(($2366)|0);
      var $2368=$2367;
      var $2369=HEAPU8[($2368)];
      var $2370=(($2369)&255);
      var $2371=$2370 & 1;
      var $2372=(($2371)|0)!=0;
      var $2373=$30;
      if ($2372) { __label__ = 227; break; } else { __label__ = 228; break; }
    case 227: // $2374
      var $2375=$24;
      HEAP32[(($24)>>2)]=$2353;
      var $2376=HEAP32[(($24)>>2)];
      var $2377=(($2376)|0);
      var $2378=$23;
      HEAP32[(($23)>>2)]=$2377;
      var $2379=HEAP32[(($23)>>2)];
      var $2380=$2379;
      var $2381=$22;
      HEAP32[(($22)>>2)]=$2380;
      var $2382=HEAP32[(($22)>>2)];
      var $2383=(($2382)|0);
      var $2384=$22;
      var $2385=$23;
      var $2386=(($2383)|0);
      var $2387=$2386;
      var $2388=(($2387+4)|0);
      var $2389=HEAP32[(($2388)>>2)];
      var $2390=$24;
      var $2411 = $2389;__label__ = 229; break;
    case 228: // $2391
      var $2392=$27;
      HEAP32[(($27)>>2)]=$2353;
      var $2393=HEAP32[(($27)>>2)];
      var $2394=(($2393)|0);
      var $2395=$26;
      HEAP32[(($26)>>2)]=$2394;
      var $2396=HEAP32[(($26)>>2)];
      var $2397=$2396;
      var $2398=$25;
      HEAP32[(($25)>>2)]=$2397;
      var $2399=HEAP32[(($25)>>2)];
      var $2400=(($2399)|0);
      var $2401=$25;
      var $2402=$26;
      var $2403=(($2400)|0);
      var $2404=$2403;
      var $2405=(($2404)|0);
      var $2406=$2405;
      var $2407=HEAPU8[($2406)];
      var $2408=(($2407)&255);
      var $2409=$2408 >> 1;
      var $2410=$27;
      var $2411 = $2409;__label__ = 229; break;
    case 229: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit100
      var $2411;
      var $2412=$31;
      var $2413=(($2411)>>>0) > 1;
      if ($2413) { __label__ = 230; break; } else { __label__ = 231; break; }
    case 230: // $2414
      $__trailing_sign=$__nsn;
      __label__ = 231; break;
    case 231: // $2415
      __label__ = 233; break;
    case 232: // $2416
      var $2417=$466;
      var $2418=HEAP32[(($2417)>>2)];
      var $2419=$2418 | 4;
      HEAP32[(($2417)>>2)]=$2419;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 233: // $2420
      __label__ = 234; break;
    case 234: // $2421
      __label__ = 235; break;
    case 235: // $2422
      __label__ = 236; break;
    case 236: // $2423
      __label__ = 368; break;
    case 237: // $2424
      var $2425=$__trailing_sign;
      var $2426=(($2425)|0)!=0;
      if ($2426) { var $2442 = 1;__label__ = 242; break; } else { __label__ = 238; break; }
    case 238: // $2427
      var $2428=$__p;
      var $2429=(($2428)>>>0) < 2;
      if ($2429) { var $2442 = 1;__label__ = 242; break; } else { __label__ = 239; break; }
    case 239: // $2430
      var $2431=$__p;
      var $2432=(($2431)|0)==2;
      if ($2432) { __label__ = 240; break; } else { var $2440 = 0;__label__ = 241; break; }
    case 240: // $2433
      var $2434=(($__pat)|0);
      var $2435=(($2434+3)|0);
      var $2436=HEAP8[($2435)];
      var $2437=(($2436 << 24) >> 24);
      var $2438=(($2437)|0)!=0;
      var $2440 = $2438;__label__ = 241; break;
    case 241: // $2439
      var $2440;
      var $2442 = $2440;__label__ = 242; break;
    case 242: // $2441
      var $2442;
      var $2443=(($2442)&1);
      $__more_needed=$2443;
      var $2444=$465;
      var $2445=$2444 & 512;
      var $2446=(($2445)|0)!=0;
      var $2447=(($2446)&1);
      $__sb=$2447;
      var $2448=$__sb;
      var $2449=(($2448) & 1);
      if ($2449) { __label__ = 244; break; } else { __label__ = 243; break; }
    case 243: // $2450
      var $2451=$__more_needed;
      var $2452=(($2451) & 1);
      if ($2452) { __label__ = 244; break; } else { __label__ = 249; break; }
    case 244: // $2453
      HEAP32[(($__et)>>2)]=0;
      var $2454=$462;
      var $2455=$475;
      var $2456=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($2455)>>2)]=HEAP32[(($2456)>>2)];
      var $2457=(($__sym+12)|0);
      var $2458=$468;
      var $2459=(function() { try { __THREW__ = false; return __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SD_SC_SC_RKT1_Rjb($2454, $475, $__sym, $2457, $2458, $__et, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 245; break; } else { __label__ = 27; break; };
    case 245: // $2460
      $__k=$2459;
      var $2461=$__sb;
      var $2462=(($2461) & 1);
      if ($2462) { __label__ = 246; break; } else { __label__ = 248; break; }
    case 246: // $2463
      var $2464=$__k;
      var $2465=(($2464)|0)!=(($__sym)|0);
      if ($2465) { __label__ = 247; break; } else { __label__ = 248; break; }
    case 247: // $2466
      var $2467=$466;
      var $2468=HEAP32[(($2467)>>2)];
      var $2469=$2468 | 4;
      HEAP32[(($2467)>>2)]=$2469;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 248: // $2470
      __label__ = 249; break;
    case 249: // $2471
      __label__ = 368; break;
    case 250: // $2472
      $__ng=0;
      __label__ = 251; break;
    case 251: // $2473
      var $2474=$462;
      var $2475=$20;
      var $2476=$21;
      HEAP32[(($20)>>2)]=$2474;
      HEAP32[(($21)>>2)]=$__e;
      var $2477=HEAP32[(($20)>>2)];
      var $2478=HEAP32[(($21)>>2)];
      var $2479=$18;
      var $2480=$19;
      HEAP32[(($18)>>2)]=$2477;
      HEAP32[(($19)>>2)]=$2478;
      var $2481=HEAP32[(($18)>>2)];
      var $2482=(($2481)|0);
      var $2483=HEAP32[(($2482)>>2)];
      var $2484=(($2483)|0)==0;
      var $2485=(($2484)&1);
      var $2486=HEAP32[(($19)>>2)];
      var $2487=(($2486)|0);
      var $2488=HEAP32[(($2487)>>2)];
      var $2489=(($2488)|0)==0;
      var $2490=(($2489)&1);
      var $2491=(($2485)|0)==(($2490)|0);
      var $2492=$18;
      var $2493=$19;
      var $2494=$2491 ^ 1;
      var $2495=$20;
      var $2496=$21;
      __label__ = 252; break;
    case 252: // $2497
      if ($2494) { __label__ = 253; break; } else { __label__ = 295; break; }
    case 253: // $2498
      var $2499=$462;
      var $2500=$17;
      HEAP32[(($17)>>2)]=$2499;
      var $2501=HEAP32[(($17)>>2)];
      var $2502=(($2501)|0);
      var $2503=HEAP32[(($2502)>>2)];
      var $2504=$15;
      var $2505=$16;
      HEAP32[(($16)>>2)]=$2503;
      var $2506=HEAP32[(($16)>>2)];
      var $2507=(($2506+12)|0);
      var $2508=HEAP32[(($2507)>>2)];
      var $2509=(($2506+16)|0);
      var $2510=HEAP32[(($2509)>>2)];
      var $2511=(($2508)|0)==(($2510)|0);
      if ($2511) { __label__ = 254; break; } else { __label__ = 256; break; }
    case 254: // $2512
      var $2513=$2506;
      var $2514=HEAP32[(($2513)>>2)];
      var $2515=(($2514+36)|0);
      var $2516=HEAP32[(($2515)>>2)];
      var $2517=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2516]($2506) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 255; break; } else { __label__ = 27; break; };
    case 255: // $_noexc101
      HEAP32[(($15)>>2)]=$2517;
      __label__ = 257; break;
    case 256: // $2518
      var $2519=(($2506+12)|0);
      var $2520=HEAP32[(($2519)>>2)];
      var $2521=HEAP8[($2520)];
      $14=$2521;
      var $2522=$14;
      var $2523=(($2522)&255);
      HEAP32[(($15)>>2)]=$2523;
      __label__ = 257; break;
    case 257: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit102
      var $2524=HEAP32[(($15)>>2)];
      var $2525=$15;
      var $2526=$16;
      var $2527=(($2524) & 255);
      var $2528=$17;
      __label__ = 258; break;
    case 258: // $2529
      $__c=$2527;
      var $2530=$468;
      var $2531=$__c;
      var $2532=$11;
      var $2533=$12;
      HEAP32[(($11)>>2)]=$2530;
      HEAP32[(($12)>>2)]=1024;
      $13=$2531;
      var $2534=HEAP32[(($11)>>2)];
      var $2535=$13;
      var $2536=(($2535 << 24) >> 24);
      var $2537=(($2536)>>>0) <= 127;
      if ($2537) { __label__ = 259; break; } else { __label__ = 260; break; }
    case 259: // $2538
      var $2539=$13;
      var $2540=(($2539 << 24) >> 24);
      var $2541=(($2534+8)|0);
      var $2542=HEAP32[(($2541)>>2)];
      var $2543=(($2542+($2540<<2))|0);
      var $2544=HEAP32[(($2543)>>2)];
      var $2545=HEAP32[(($12)>>2)];
      var $2546=$2544 & $2545;
      var $2548 = $2546;__label__ = 261; break;
    case 260: // $2547
      var $2548 = 0;__label__ = 261; break;
    case 261: // $_ZNKSt3__15ctypeIcE2isEjc_exit103
      var $2548;
      var $2549=(($2548)|0)!=0;
      var $2550=$11;
      var $2551=$12;
      __label__ = 262; break;
    case 262: // $2552
      if ($2549) { __label__ = 263; break; } else { __label__ = 267; break; }
    case 263: // $2553
      var $2554=$470;
      var $2555=HEAP32[(($2554)>>2)];
      var $2556=HEAP32[(($471)>>2)];
      var $2557=(($2555)|0)==(($2556)|0);
      if ($2557) { __label__ = 264; break; } else { __label__ = 266; break; }
    case 264: // $2558
      var $2559=$469;
      var $2560=$470;
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($2559, $2560, $471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 265; break; } else { __label__ = 27; break; }
    case 265: // $2561
      __label__ = 266; break;
    case 266: // $2562
      var $2563=$__c;
      var $2564=$470;
      var $2565=HEAP32[(($2564)>>2)];
      var $2566=(($2565+1)|0);
      HEAP32[(($2564)>>2)]=$2566;
      HEAP8[($2565)]=$2563;
      var $2567=$__ng;
      var $2568=(($2567+1)|0);
      $__ng=$2568;
      __label__ = 279; break;
    case 267: // $2569
      var $2570=$10;
      HEAP32[(($10)>>2)]=$__grp;
      var $2571=HEAPU32[(($10)>>2)];
      var $2572=$9;
      HEAP32[(($9)>>2)]=$2571;
      var $2573=HEAP32[(($9)>>2)];
      var $2574=(($2573)|0);
      var $2575=$8;
      HEAP32[(($8)>>2)]=$2574;
      var $2576=HEAP32[(($8)>>2)];
      var $2577=$2576;
      var $2578=$7;
      HEAP32[(($7)>>2)]=$2577;
      var $2579=HEAP32[(($7)>>2)];
      var $2580=(($2579)|0);
      var $2581=$7;
      var $2582=$8;
      var $2583=(($2580)|0);
      var $2584=$2583;
      var $2585=(($2584)|0);
      var $2586=$2585;
      var $2587=HEAPU8[($2586)];
      var $2588=(($2587)&255);
      var $2589=$2588 & 1;
      var $2590=(($2589)|0)!=0;
      var $2591=$9;
      if ($2590) { __label__ = 268; break; } else { __label__ = 269; break; }
    case 268: // $2592
      var $2593=$3;
      HEAP32[(($3)>>2)]=$2571;
      var $2594=HEAP32[(($3)>>2)];
      var $2595=(($2594)|0);
      var $2596=$2;
      HEAP32[(($2)>>2)]=$2595;
      var $2597=HEAP32[(($2)>>2)];
      var $2598=$2597;
      var $2599=$1;
      HEAP32[(($1)>>2)]=$2598;
      var $2600=HEAP32[(($1)>>2)];
      var $2601=(($2600)|0);
      var $2602=$1;
      var $2603=$2;
      var $2604=(($2601)|0);
      var $2605=$2604;
      var $2606=(($2605+4)|0);
      var $2607=HEAP32[(($2606)>>2)];
      var $2608=$3;
      var $2629 = $2607;__label__ = 270; break;
    case 269: // $2609
      var $2610=$6;
      HEAP32[(($6)>>2)]=$2571;
      var $2611=HEAP32[(($6)>>2)];
      var $2612=(($2611)|0);
      var $2613=$5;
      HEAP32[(($5)>>2)]=$2612;
      var $2614=HEAP32[(($5)>>2)];
      var $2615=$2614;
      var $2616=$4;
      HEAP32[(($4)>>2)]=$2615;
      var $2617=HEAP32[(($4)>>2)];
      var $2618=(($2617)|0);
      var $2619=$4;
      var $2620=$5;
      var $2621=(($2618)|0);
      var $2622=$2621;
      var $2623=(($2622)|0);
      var $2624=$2623;
      var $2625=HEAPU8[($2624)];
      var $2626=(($2625)&255);
      var $2627=$2626 >> 1;
      var $2628=$6;
      var $2629 = $2627;__label__ = 270; break;
    case 270: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit104
      var $2629;
      var $2630=$10;
      var $2631=(($2629)>>>0) > 0;
      if ($2631) { __label__ = 271; break; } else { __label__ = 277; break; }
    case 271: // $2632
      var $2633=$__ng;
      var $2634=(($2633)>>>0) > 0;
      if ($2634) { __label__ = 272; break; } else { __label__ = 277; break; }
    case 272: // $2635
      var $2636=$__c;
      var $2637=(($2636 << 24) >> 24);
      var $2638=HEAP8[($__ts)];
      var $2639=(($2638 << 24) >> 24);
      var $2640=(($2637)|0)==(($2639)|0);
      if ($2640) { __label__ = 273; break; } else { __label__ = 277; break; }
    case 273: // $2641
      var $2642=HEAP32[(($__gn)>>2)];
      var $2643=HEAP32[(($__ge)>>2)];
      var $2644=(($2642)|0)==(($2643)|0);
      if ($2644) { __label__ = 274; break; } else { __label__ = 276; break; }
    case 274: // $2645
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__gb, $__gn, $__ge) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 275; break; } else { __label__ = 27; break; }
    case 275: // $2646
      __label__ = 276; break;
    case 276: // $2647
      var $2648=$__ng;
      var $2649=HEAP32[(($__gn)>>2)];
      var $2650=(($2649+4)|0);
      HEAP32[(($__gn)>>2)]=$2650;
      HEAP32[(($2649)>>2)]=$2648;
      $__ng=0;
      __label__ = 278; break;
    case 277: // $2651
      __label__ = 295; break;
    case 278: // $2652
      __label__ = 279; break;
    case 279: // $2653
      __label__ = 280; break;
    case 280: // $2654
      var $2655=$462;
      var $2656=$53;
      HEAP32[(($53)>>2)]=$2655;
      var $2657=HEAPU32[(($53)>>2)];
      var $2658=(($2657)|0);
      var $2659=HEAP32[(($2658)>>2)];
      var $2660=$51;
      var $2661=$52;
      HEAP32[(($52)>>2)]=$2659;
      var $2662=HEAPU32[(($52)>>2)];
      var $2663=$49;
      var $2664=$50;
      HEAP32[(($50)>>2)]=$2662;
      var $2665=HEAP32[(($50)>>2)];
      var $2666=(($2665+12)|0);
      var $2667=HEAP32[(($2666)>>2)];
      var $2668=(($2665+16)|0);
      var $2669=HEAP32[(($2668)>>2)];
      var $2670=(($2667)|0)==(($2669)|0);
      if ($2670) { __label__ = 281; break; } else { __label__ = 283; break; }
    case 281: // $2671
      var $2672=$2665;
      var $2673=HEAP32[(($2672)>>2)];
      var $2674=(($2673+40)|0);
      var $2675=HEAP32[(($2674)>>2)];
      var $2676=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2675]($2665) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 282; break; } else { __label__ = 27; break; };
    case 282: // $_noexc91
      HEAP32[(($49)>>2)]=$2676;
      __label__ = 284; break;
    case 283: // $2677
      var $2678=(($2665+12)|0);
      var $2679=HEAP32[(($2678)>>2)];
      var $2680=(($2679+1)|0);
      HEAP32[(($2678)>>2)]=$2680;
      var $2681=HEAP8[($2679)];
      $48=$2681;
      var $2682=$48;
      var $2683=(($2682)&255);
      HEAP32[(($49)>>2)]=$2683;
      __label__ = 284; break;
    case 284: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i88
      var $2684=HEAP32[(($49)>>2)];
      var $2685=$49;
      var $2686=$50;
      var $2687=(($2684)|0)==-1;
      if ($2687) { __label__ = 285; break; } else { __label__ = 286; break; }
    case 285: // $2688
      HEAP32[(($51)>>2)]=-1;
      __label__ = 291; break;
    case 286: // $2689
      var $2690=$46;
      var $2691=$47;
      HEAP32[(($47)>>2)]=$2662;
      var $2692=HEAPU32[(($47)>>2)];
      var $2693=(($2692+12)|0);
      var $2694=HEAP32[(($2693)>>2)];
      var $2695=(($2692+16)|0);
      var $2696=HEAP32[(($2695)>>2)];
      var $2697=(($2694)|0)==(($2696)|0);
      if ($2697) { __label__ = 287; break; } else { __label__ = 289; break; }
    case 287: // $2698
      var $2699=$2692;
      var $2700=HEAP32[(($2699)>>2)];
      var $2701=(($2700+36)|0);
      var $2702=HEAP32[(($2701)>>2)];
      var $2703=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2702]($2692) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 288; break; } else { __label__ = 27; break; };
    case 288: // $_noexc92
      HEAP32[(($46)>>2)]=$2703;
      __label__ = 290; break;
    case 289: // $2704
      var $2705=(($2692+12)|0);
      var $2706=HEAP32[(($2705)>>2)];
      var $2707=HEAP8[($2706)];
      $45=$2707;
      var $2708=$45;
      var $2709=(($2708)&255);
      HEAP32[(($46)>>2)]=$2709;
      __label__ = 290; break;
    case 290: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i89
      var $2710=HEAP32[(($46)>>2)];
      var $2711=$46;
      var $2712=$47;
      HEAP32[(($51)>>2)]=$2710;
      __label__ = 291; break;
    case 291: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i90
      var $2713=HEAP32[(($51)>>2)];
      var $2714=$51;
      var $2715=$52;
      var $2716=$43;
      var $2717=$44;
      HEAP32[(($43)>>2)]=$2713;
      HEAP32[(($44)>>2)]=-1;
      var $2718=HEAP32[(($43)>>2)];
      var $2719=HEAP32[(($44)>>2)];
      var $2720=(($2718)|0)==(($2719)|0);
      var $2721=$43;
      var $2722=$44;
      if ($2720) { __label__ = 292; break; } else { __label__ = 293; break; }
    case 292: // $2723
      var $2724=(($2657)|0);
      HEAP32[(($2724)>>2)]=0;
      __label__ = 293; break;
    case 293: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit93
      var $2725=$53;
      __label__ = 294; break;
    case 294: // $2726
      __label__ = 251; break;
    case 295: // $2727
      var $2728=$56;
      HEAP32[(($56)>>2)]=$__gb;
      var $2729=HEAP32[(($56)>>2)];
      var $2730=(($2729)|0);
      var $2731=$55;
      HEAP32[(($55)>>2)]=$2730;
      var $2732=HEAP32[(($55)>>2)];
      var $2733=$2732;
      var $2734=$54;
      HEAP32[(($54)>>2)]=$2733;
      var $2735=HEAP32[(($54)>>2)];
      var $2736=(($2735)|0);
      var $2737=$54;
      var $2738=$55;
      var $2739=HEAP32[(($2736)>>2)];
      var $2740=$56;
      var $2741=HEAP32[(($__gn)>>2)];
      var $2742=(($2739)|0)!=(($2741)|0);
      if ($2742) { __label__ = 296; break; } else { __label__ = 301; break; }
    case 296: // $2743
      var $2744=$__ng;
      var $2745=(($2744)>>>0) > 0;
      if ($2745) { __label__ = 297; break; } else { __label__ = 301; break; }
    case 297: // $2746
      var $2747=HEAP32[(($__gn)>>2)];
      var $2748=HEAP32[(($__ge)>>2)];
      var $2749=(($2747)|0)==(($2748)|0);
      if ($2749) { __label__ = 298; break; } else { __label__ = 300; break; }
    case 298: // $2750
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__gb, $__gn, $__ge) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 299; break; } else { __label__ = 27; break; }
    case 299: // $2751
      __label__ = 300; break;
    case 300: // $2752
      var $2753=$__ng;
      var $2754=HEAP32[(($__gn)>>2)];
      var $2755=(($2754+4)|0);
      HEAP32[(($__gn)>>2)]=$2755;
      HEAP32[(($2754)>>2)]=$2753;
      __label__ = 301; break;
    case 301: // $2756
      var $2757=HEAP32[(($__fd)>>2)];
      var $2758=(($2757)|0) > 0;
      if ($2758) { __label__ = 302; break; } else { __label__ = 365; break; }
    case 302: // $2759
      var $2760=$462;
      var $2761=$96;
      var $2762=$97;
      HEAP32[(($96)>>2)]=$2760;
      HEAP32[(($97)>>2)]=$__e;
      var $2763=HEAP32[(($96)>>2)];
      var $2764=HEAP32[(($97)>>2)];
      var $2765=$94;
      var $2766=$95;
      HEAP32[(($94)>>2)]=$2763;
      HEAP32[(($95)>>2)]=$2764;
      var $2767=HEAP32[(($94)>>2)];
      var $2768=(($2767)|0);
      var $2769=HEAP32[(($2768)>>2)];
      var $2770=(($2769)|0)==0;
      var $2771=(($2770)&1);
      var $2772=HEAP32[(($95)>>2)];
      var $2773=(($2772)|0);
      var $2774=HEAP32[(($2773)>>2)];
      var $2775=(($2774)|0)==0;
      var $2776=(($2775)&1);
      var $2777=(($2771)|0)==(($2776)|0);
      var $2778=$94;
      var $2779=$95;
      var $2780=$96;
      var $2781=$97;
      __label__ = 303; break;
    case 303: // $2782
      if ($2777) { __label__ = 310; break; } else { __label__ = 304; break; }
    case 304: // $2783
      var $2784=$462;
      var $2785=$138;
      HEAP32[(($138)>>2)]=$2784;
      var $2786=HEAP32[(($138)>>2)];
      var $2787=(($2786)|0);
      var $2788=HEAP32[(($2787)>>2)];
      var $2789=$136;
      var $2790=$137;
      HEAP32[(($137)>>2)]=$2788;
      var $2791=HEAP32[(($137)>>2)];
      var $2792=(($2791+12)|0);
      var $2793=HEAP32[(($2792)>>2)];
      var $2794=(($2791+16)|0);
      var $2795=HEAP32[(($2794)>>2)];
      var $2796=(($2793)|0)==(($2795)|0);
      if ($2796) { __label__ = 305; break; } else { __label__ = 307; break; }
    case 305: // $2797
      var $2798=$2791;
      var $2799=HEAP32[(($2798)>>2)];
      var $2800=(($2799+36)|0);
      var $2801=HEAP32[(($2800)>>2)];
      var $2802=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2801]($2791) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 306; break; } else { __label__ = 27; break; };
    case 306: // $_noexc66
      HEAP32[(($136)>>2)]=$2802;
      __label__ = 308; break;
    case 307: // $2803
      var $2804=(($2791+12)|0);
      var $2805=HEAP32[(($2804)>>2)];
      var $2806=HEAP8[($2805)];
      $135=$2806;
      var $2807=$135;
      var $2808=(($2807)&255);
      HEAP32[(($136)>>2)]=$2808;
      __label__ = 308; break;
    case 308: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit67
      var $2809=HEAP32[(($136)>>2)];
      var $2810=$136;
      var $2811=$137;
      var $2812=(($2809) & 255);
      var $2813=$138;
      __label__ = 309; break;
    case 309: // $2814
      var $2815=(($2812 << 24) >> 24);
      var $2816=HEAP8[($__dp)];
      var $2817=(($2816 << 24) >> 24);
      var $2818=(($2815)|0)!=(($2817)|0);
      if ($2818) { __label__ = 310; break; } else { __label__ = 311; break; }
    case 310: // $2819
      var $2820=$466;
      var $2821=HEAP32[(($2820)>>2)];
      var $2822=$2821 | 4;
      HEAP32[(($2820)>>2)]=$2822;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 311: // $2823
      var $2824=$462;
      var $2825=$202;
      HEAP32[(($202)>>2)]=$2824;
      var $2826=HEAPU32[(($202)>>2)];
      var $2827=(($2826)|0);
      var $2828=HEAP32[(($2827)>>2)];
      var $2829=$200;
      var $2830=$201;
      HEAP32[(($201)>>2)]=$2828;
      var $2831=HEAPU32[(($201)>>2)];
      var $2832=$198;
      var $2833=$199;
      HEAP32[(($199)>>2)]=$2831;
      var $2834=HEAP32[(($199)>>2)];
      var $2835=(($2834+12)|0);
      var $2836=HEAP32[(($2835)>>2)];
      var $2837=(($2834+16)|0);
      var $2838=HEAP32[(($2837)>>2)];
      var $2839=(($2836)|0)==(($2838)|0);
      if ($2839) { __label__ = 312; break; } else { __label__ = 314; break; }
    case 312: // $2840
      var $2841=$2834;
      var $2842=HEAP32[(($2841)>>2)];
      var $2843=(($2842+40)|0);
      var $2844=HEAP32[(($2843)>>2)];
      var $2845=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2844]($2834) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 313; break; } else { __label__ = 27; break; };
    case 313: // $_noexc51
      HEAP32[(($198)>>2)]=$2845;
      __label__ = 315; break;
    case 314: // $2846
      var $2847=(($2834+12)|0);
      var $2848=HEAP32[(($2847)>>2)];
      var $2849=(($2848+1)|0);
      HEAP32[(($2847)>>2)]=$2849;
      var $2850=HEAP8[($2848)];
      $197=$2850;
      var $2851=$197;
      var $2852=(($2851)&255);
      HEAP32[(($198)>>2)]=$2852;
      __label__ = 315; break;
    case 315: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i48
      var $2853=HEAP32[(($198)>>2)];
      var $2854=$198;
      var $2855=$199;
      var $2856=(($2853)|0)==-1;
      if ($2856) { __label__ = 316; break; } else { __label__ = 317; break; }
    case 316: // $2857
      HEAP32[(($200)>>2)]=-1;
      __label__ = 322; break;
    case 317: // $2858
      var $2859=$195;
      var $2860=$196;
      HEAP32[(($196)>>2)]=$2831;
      var $2861=HEAPU32[(($196)>>2)];
      var $2862=(($2861+12)|0);
      var $2863=HEAP32[(($2862)>>2)];
      var $2864=(($2861+16)|0);
      var $2865=HEAP32[(($2864)>>2)];
      var $2866=(($2863)|0)==(($2865)|0);
      if ($2866) { __label__ = 318; break; } else { __label__ = 320; break; }
    case 318: // $2867
      var $2868=$2861;
      var $2869=HEAP32[(($2868)>>2)];
      var $2870=(($2869+36)|0);
      var $2871=HEAP32[(($2870)>>2)];
      var $2872=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2871]($2861) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 319; break; } else { __label__ = 27; break; };
    case 319: // $_noexc52
      HEAP32[(($195)>>2)]=$2872;
      __label__ = 321; break;
    case 320: // $2873
      var $2874=(($2861+12)|0);
      var $2875=HEAP32[(($2874)>>2)];
      var $2876=HEAP8[($2875)];
      $194=$2876;
      var $2877=$194;
      var $2878=(($2877)&255);
      HEAP32[(($195)>>2)]=$2878;
      __label__ = 321; break;
    case 321: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i49
      var $2879=HEAP32[(($195)>>2)];
      var $2880=$195;
      var $2881=$196;
      HEAP32[(($200)>>2)]=$2879;
      __label__ = 322; break;
    case 322: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i50
      var $2882=HEAP32[(($200)>>2)];
      var $2883=$200;
      var $2884=$201;
      var $2885=$192;
      var $2886=$193;
      HEAP32[(($192)>>2)]=$2882;
      HEAP32[(($193)>>2)]=-1;
      var $2887=HEAP32[(($192)>>2)];
      var $2888=HEAP32[(($193)>>2)];
      var $2889=(($2887)|0)==(($2888)|0);
      var $2890=$192;
      var $2891=$193;
      if ($2889) { __label__ = 323; break; } else { __label__ = 324; break; }
    case 323: // $2892
      var $2893=(($2826)|0);
      HEAP32[(($2893)>>2)]=0;
      __label__ = 324; break;
    case 324: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit53
      var $2894=$202;
      __label__ = 325; break;
    case 325: // $2895
      __label__ = 326; break;
    case 326: // $2896
      var $2897=HEAP32[(($__fd)>>2)];
      var $2898=(($2897)|0) > 0;
      if ($2898) { __label__ = 327; break; } else { __label__ = 364; break; }
    case 327: // $2899
      var $2900=$462;
      var $2901=$205;
      var $2902=$206;
      HEAP32[(($205)>>2)]=$2900;
      HEAP32[(($206)>>2)]=$__e;
      var $2903=HEAP32[(($205)>>2)];
      var $2904=HEAP32[(($206)>>2)];
      var $2905=$203;
      var $2906=$204;
      HEAP32[(($203)>>2)]=$2903;
      HEAP32[(($204)>>2)]=$2904;
      var $2907=HEAP32[(($203)>>2)];
      var $2908=(($2907)|0);
      var $2909=HEAP32[(($2908)>>2)];
      var $2910=(($2909)|0)==0;
      var $2911=(($2910)&1);
      var $2912=HEAP32[(($204)>>2)];
      var $2913=(($2912)|0);
      var $2914=HEAP32[(($2913)>>2)];
      var $2915=(($2914)|0)==0;
      var $2916=(($2915)&1);
      var $2917=(($2911)|0)==(($2916)|0);
      var $2918=$203;
      var $2919=$204;
      var $2920=$205;
      var $2921=$206;
      __label__ = 328; break;
    case 328: // $2922
      if ($2917) { __label__ = 339; break; } else { __label__ = 329; break; }
    case 329: // $2923
      var $2924=$468;
      var $2925=$462;
      var $2926=$220;
      HEAP32[(($220)>>2)]=$2925;
      var $2927=HEAP32[(($220)>>2)];
      var $2928=(($2927)|0);
      var $2929=HEAP32[(($2928)>>2)];
      var $2930=$218;
      var $2931=$219;
      HEAP32[(($219)>>2)]=$2929;
      var $2932=HEAP32[(($219)>>2)];
      var $2933=(($2932+12)|0);
      var $2934=HEAP32[(($2933)>>2)];
      var $2935=(($2932+16)|0);
      var $2936=HEAP32[(($2935)>>2)];
      var $2937=(($2934)|0)==(($2936)|0);
      if ($2937) { __label__ = 330; break; } else { __label__ = 332; break; }
    case 330: // $2938
      var $2939=$2932;
      var $2940=HEAP32[(($2939)>>2)];
      var $2941=(($2940+36)|0);
      var $2942=HEAP32[(($2941)>>2)];
      var $2943=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2942]($2932) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 331; break; } else { __label__ = 27; break; };
    case 331: // $_noexc45
      HEAP32[(($218)>>2)]=$2943;
      __label__ = 333; break;
    case 332: // $2944
      var $2945=(($2932+12)|0);
      var $2946=HEAP32[(($2945)>>2)];
      var $2947=HEAP8[($2946)];
      $217=$2947;
      var $2948=$217;
      var $2949=(($2948)&255);
      HEAP32[(($218)>>2)]=$2949;
      __label__ = 333; break;
    case 333: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit46
      var $2950=HEAP32[(($218)>>2)];
      var $2951=$218;
      var $2952=$219;
      var $2953=(($2950) & 255);
      var $2954=$220;
      __label__ = 334; break;
    case 334: // $2955
      var $2956=$221;
      var $2957=$222;
      HEAP32[(($221)>>2)]=$2924;
      HEAP32[(($222)>>2)]=1024;
      $223=$2953;
      var $2958=HEAP32[(($221)>>2)];
      var $2959=$223;
      var $2960=(($2959 << 24) >> 24);
      var $2961=(($2960)>>>0) <= 127;
      if ($2961) { __label__ = 335; break; } else { __label__ = 336; break; }
    case 335: // $2962
      var $2963=$223;
      var $2964=(($2963 << 24) >> 24);
      var $2965=(($2958+8)|0);
      var $2966=HEAP32[(($2965)>>2)];
      var $2967=(($2966+($2964<<2))|0);
      var $2968=HEAP32[(($2967)>>2)];
      var $2969=HEAP32[(($222)>>2)];
      var $2970=$2968 & $2969;
      var $2972 = $2970;__label__ = 337; break;
    case 336: // $2971
      var $2972 = 0;__label__ = 337; break;
    case 337: // $_ZNKSt3__15ctypeIcE2isEjc_exit44
      var $2972;
      var $2973=(($2972)|0)!=0;
      var $2974=$221;
      var $2975=$222;
      __label__ = 338; break;
    case 338: // $2976
      if ($2973) { __label__ = 340; break; } else { __label__ = 339; break; }
    case 339: // $2977
      var $2978=$466;
      var $2979=HEAP32[(($2978)>>2)];
      var $2980=$2979 | 4;
      HEAP32[(($2978)>>2)]=$2980;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 340: // $2981
      var $2982=$470;
      var $2983=HEAP32[(($2982)>>2)];
      var $2984=HEAP32[(($471)>>2)];
      var $2985=(($2983)|0)==(($2984)|0);
      if ($2985) { __label__ = 341; break; } else { __label__ = 343; break; }
    case 341: // $2986
      var $2987=$469;
      var $2988=$470;
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($2987, $2988, $471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 342; break; } else { __label__ = 27; break; }
    case 342: // $2989
      __label__ = 343; break;
    case 343: // $2990
      var $2991=$462;
      var $2992=$247;
      HEAP32[(($247)>>2)]=$2991;
      var $2993=HEAP32[(($247)>>2)];
      var $2994=(($2993)|0);
      var $2995=HEAP32[(($2994)>>2)];
      var $2996=$245;
      var $2997=$246;
      HEAP32[(($246)>>2)]=$2995;
      var $2998=HEAP32[(($246)>>2)];
      var $2999=(($2998+12)|0);
      var $3000=HEAP32[(($2999)>>2)];
      var $3001=(($2998+16)|0);
      var $3002=HEAP32[(($3001)>>2)];
      var $3003=(($3000)|0)==(($3002)|0);
      if ($3003) { __label__ = 344; break; } else { __label__ = 346; break; }
    case 344: // $3004
      var $3005=$2998;
      var $3006=HEAP32[(($3005)>>2)];
      var $3007=(($3006+36)|0);
      var $3008=HEAP32[(($3007)>>2)];
      var $3009=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3008]($2998) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 345; break; } else { __label__ = 27; break; };
    case 345: // $_noexc40
      HEAP32[(($245)>>2)]=$3009;
      __label__ = 347; break;
    case 346: // $3010
      var $3011=(($2998+12)|0);
      var $3012=HEAP32[(($3011)>>2)];
      var $3013=HEAP8[($3012)];
      $244=$3013;
      var $3014=$244;
      var $3015=(($3014)&255);
      HEAP32[(($245)>>2)]=$3015;
      __label__ = 347; break;
    case 347: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit41
      var $3016=HEAP32[(($245)>>2)];
      var $3017=$245;
      var $3018=$246;
      var $3019=(($3016) & 255);
      var $3020=$247;
      __label__ = 348; break;
    case 348: // $3021
      var $3022=$470;
      var $3023=HEAP32[(($3022)>>2)];
      var $3024=(($3023+1)|0);
      HEAP32[(($3022)>>2)]=$3024;
      HEAP8[($3023)]=$3019;
      __label__ = 349; break;
    case 349: // $3025
      var $3026=HEAP32[(($__fd)>>2)];
      var $3027=(($3026-1)|0);
      HEAP32[(($__fd)>>2)]=$3027;
      var $3028=$462;
      var $3029=$311;
      HEAP32[(($311)>>2)]=$3028;
      var $3030=HEAPU32[(($311)>>2)];
      var $3031=(($3030)|0);
      var $3032=HEAP32[(($3031)>>2)];
      var $3033=$309;
      var $3034=$310;
      HEAP32[(($310)>>2)]=$3032;
      var $3035=HEAPU32[(($310)>>2)];
      var $3036=$307;
      var $3037=$308;
      HEAP32[(($308)>>2)]=$3035;
      var $3038=HEAP32[(($308)>>2)];
      var $3039=(($3038+12)|0);
      var $3040=HEAP32[(($3039)>>2)];
      var $3041=(($3038+16)|0);
      var $3042=HEAP32[(($3041)>>2)];
      var $3043=(($3040)|0)==(($3042)|0);
      if ($3043) { __label__ = 350; break; } else { __label__ = 352; break; }
    case 350: // $3044
      var $3045=$3038;
      var $3046=HEAP32[(($3045)>>2)];
      var $3047=(($3046+40)|0);
      var $3048=HEAP32[(($3047)>>2)];
      var $3049=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3048]($3038) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 351; break; } else { __label__ = 27; break; };
    case 351: // $_noexc20
      HEAP32[(($307)>>2)]=$3049;
      __label__ = 353; break;
    case 352: // $3050
      var $3051=(($3038+12)|0);
      var $3052=HEAP32[(($3051)>>2)];
      var $3053=(($3052+1)|0);
      HEAP32[(($3051)>>2)]=$3053;
      var $3054=HEAP8[($3052)];
      $306=$3054;
      var $3055=$306;
      var $3056=(($3055)&255);
      HEAP32[(($307)>>2)]=$3056;
      __label__ = 353; break;
    case 353: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i17
      var $3057=HEAP32[(($307)>>2)];
      var $3058=$307;
      var $3059=$308;
      var $3060=(($3057)|0)==-1;
      if ($3060) { __label__ = 354; break; } else { __label__ = 355; break; }
    case 354: // $3061
      HEAP32[(($309)>>2)]=-1;
      __label__ = 360; break;
    case 355: // $3062
      var $3063=$304;
      var $3064=$305;
      HEAP32[(($305)>>2)]=$3035;
      var $3065=HEAPU32[(($305)>>2)];
      var $3066=(($3065+12)|0);
      var $3067=HEAP32[(($3066)>>2)];
      var $3068=(($3065+16)|0);
      var $3069=HEAP32[(($3068)>>2)];
      var $3070=(($3067)|0)==(($3069)|0);
      if ($3070) { __label__ = 356; break; } else { __label__ = 358; break; }
    case 356: // $3071
      var $3072=$3065;
      var $3073=HEAP32[(($3072)>>2)];
      var $3074=(($3073+36)|0);
      var $3075=HEAP32[(($3074)>>2)];
      var $3076=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3075]($3065) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 357; break; } else { __label__ = 27; break; };
    case 357: // $_noexc21
      HEAP32[(($304)>>2)]=$3076;
      __label__ = 359; break;
    case 358: // $3077
      var $3078=(($3065+12)|0);
      var $3079=HEAP32[(($3078)>>2)];
      var $3080=HEAP8[($3079)];
      $303=$3080;
      var $3081=$303;
      var $3082=(($3081)&255);
      HEAP32[(($304)>>2)]=$3082;
      __label__ = 359; break;
    case 359: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i18
      var $3083=HEAP32[(($304)>>2)];
      var $3084=$304;
      var $3085=$305;
      HEAP32[(($309)>>2)]=$3083;
      __label__ = 360; break;
    case 360: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i19
      var $3086=HEAP32[(($309)>>2)];
      var $3087=$309;
      var $3088=$310;
      var $3089=$301;
      var $3090=$302;
      HEAP32[(($301)>>2)]=$3086;
      HEAP32[(($302)>>2)]=-1;
      var $3091=HEAP32[(($301)>>2)];
      var $3092=HEAP32[(($302)>>2)];
      var $3093=(($3091)|0)==(($3092)|0);
      var $3094=$301;
      var $3095=$302;
      if ($3093) { __label__ = 361; break; } else { __label__ = 362; break; }
    case 361: // $3096
      var $3097=(($3030)|0);
      HEAP32[(($3097)>>2)]=0;
      __label__ = 362; break;
    case 362: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit22
      var $3098=$311;
      __label__ = 363; break;
    case 363: // $3099
      __label__ = 326; break;
    case 364: // $3100
      __label__ = 365; break;
    case 365: // $3101
      var $3102=$470;
      var $3103=HEAP32[(($3102)>>2)];
      var $3104=$469;
      var $3105=$314;
      HEAP32[(($314)>>2)]=$3104;
      var $3106=HEAP32[(($314)>>2)];
      var $3107=(($3106)|0);
      var $3108=$313;
      HEAP32[(($313)>>2)]=$3107;
      var $3109=HEAP32[(($313)>>2)];
      var $3110=$3109;
      var $3111=$312;
      HEAP32[(($312)>>2)]=$3110;
      var $3112=HEAP32[(($312)>>2)];
      var $3113=(($3112)|0);
      var $3114=$312;
      var $3115=$313;
      var $3116=HEAP32[(($3113)>>2)];
      var $3117=$314;
      var $3118=(($3103)|0)==(($3116)|0);
      if ($3118) { __label__ = 366; break; } else { __label__ = 367; break; }
    case 366: // $3119
      var $3120=$466;
      var $3121=HEAP32[(($3120)>>2)];
      var $3122=$3121 | 4;
      HEAP32[(($3120)>>2)]=$3122;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 367: // $3123
      __label__ = 368; break;
    case 368: // $3124
      __label__ = 369; break;
    case 369: // $3125
      var $3126=$__p;
      var $3127=(($3126+1)|0);
      $__p=$3127;
      __label__ = 18; break;
    case 370: // $3128
      var $3129=$__trailing_sign;
      var $3130=(($3129)|0)!=0;
      if ($3130) { __label__ = 371; break; } else { __label__ = 406; break; }
    case 371: // $3131
      $__i=1;
      __label__ = 372; break;
    case 372: // $3132
      var $3133=$__i;
      var $3134=$__trailing_sign;
      var $3135=$324;
      HEAP32[(($324)>>2)]=$3134;
      var $3136=HEAPU32[(($324)>>2)];
      var $3137=$323;
      HEAP32[(($323)>>2)]=$3136;
      var $3138=HEAP32[(($323)>>2)];
      var $3139=(($3138)|0);
      var $3140=$322;
      HEAP32[(($322)>>2)]=$3139;
      var $3141=HEAP32[(($322)>>2)];
      var $3142=$3141;
      var $3143=$321;
      HEAP32[(($321)>>2)]=$3142;
      var $3144=HEAP32[(($321)>>2)];
      var $3145=(($3144)|0);
      var $3146=$321;
      var $3147=$322;
      var $3148=(($3145)|0);
      var $3149=$3148;
      var $3150=(($3149)|0);
      var $3151=$3150;
      var $3152=HEAPU8[($3151)];
      var $3153=(($3152)&255);
      var $3154=$3153 & 1;
      var $3155=(($3154)|0)!=0;
      var $3156=$323;
      if ($3155) { __label__ = 373; break; } else { __label__ = 374; break; }
    case 373: // $3157
      var $3158=$317;
      HEAP32[(($317)>>2)]=$3136;
      var $3159=HEAP32[(($317)>>2)];
      var $3160=(($3159)|0);
      var $3161=$316;
      HEAP32[(($316)>>2)]=$3160;
      var $3162=HEAP32[(($316)>>2)];
      var $3163=$3162;
      var $3164=$315;
      HEAP32[(($315)>>2)]=$3163;
      var $3165=HEAP32[(($315)>>2)];
      var $3166=(($3165)|0);
      var $3167=$315;
      var $3168=$316;
      var $3169=(($3166)|0);
      var $3170=$3169;
      var $3171=(($3170+4)|0);
      var $3172=HEAP32[(($3171)>>2)];
      var $3173=$317;
      var $3194 = $3172;__label__ = 375; break;
    case 374: // $3174
      var $3175=$320;
      HEAP32[(($320)>>2)]=$3136;
      var $3176=HEAP32[(($320)>>2)];
      var $3177=(($3176)|0);
      var $3178=$319;
      HEAP32[(($319)>>2)]=$3177;
      var $3179=HEAP32[(($319)>>2)];
      var $3180=$3179;
      var $3181=$318;
      HEAP32[(($318)>>2)]=$3180;
      var $3182=HEAP32[(($318)>>2)];
      var $3183=(($3182)|0);
      var $3184=$318;
      var $3185=$319;
      var $3186=(($3183)|0);
      var $3187=$3186;
      var $3188=(($3187)|0);
      var $3189=$3188;
      var $3190=HEAPU8[($3189)];
      var $3191=(($3190)&255);
      var $3192=$3191 >> 1;
      var $3193=$320;
      var $3194 = $3192;__label__ = 375; break;
    case 375: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $3194;
      var $3195=$324;
      var $3196=(($3133)>>>0) < (($3194)>>>0);
      if ($3196) { __label__ = 376; break; } else { __label__ = 405; break; }
    case 376: // $3197
      var $3198=$462;
      var $3199=$327;
      var $3200=$328;
      HEAP32[(($327)>>2)]=$3198;
      HEAP32[(($328)>>2)]=$__e;
      var $3201=HEAP32[(($327)>>2)];
      var $3202=HEAP32[(($328)>>2)];
      var $3203=$325;
      var $3204=$326;
      HEAP32[(($325)>>2)]=$3201;
      HEAP32[(($326)>>2)]=$3202;
      var $3205=HEAP32[(($325)>>2)];
      var $3206=(($3205)|0);
      var $3207=HEAP32[(($3206)>>2)];
      var $3208=(($3207)|0)==0;
      var $3209=(($3208)&1);
      var $3210=HEAP32[(($326)>>2)];
      var $3211=(($3210)|0);
      var $3212=HEAP32[(($3211)>>2)];
      var $3213=(($3212)|0)==0;
      var $3214=(($3213)&1);
      var $3215=(($3209)|0)==(($3214)|0);
      var $3216=$325;
      var $3217=$326;
      var $3218=$327;
      var $3219=$328;
      __label__ = 377; break;
    case 377: // $3220
      if ($3215) { __label__ = 388; break; } else { __label__ = 378; break; }
    case 378: // $3221
      var $3222=$462;
      var $3223=$339;
      HEAP32[(($339)>>2)]=$3222;
      var $3224=HEAP32[(($339)>>2)];
      var $3225=(($3224)|0);
      var $3226=HEAP32[(($3225)>>2)];
      var $3227=$337;
      var $3228=$338;
      HEAP32[(($338)>>2)]=$3226;
      var $3229=HEAP32[(($338)>>2)];
      var $3230=(($3229+12)|0);
      var $3231=HEAP32[(($3230)>>2)];
      var $3232=(($3229+16)|0);
      var $3233=HEAP32[(($3232)>>2)];
      var $3234=(($3231)|0)==(($3233)|0);
      if ($3234) { __label__ = 379; break; } else { __label__ = 381; break; }
    case 379: // $3235
      var $3236=$3229;
      var $3237=HEAP32[(($3236)>>2)];
      var $3238=(($3237+36)|0);
      var $3239=HEAP32[(($3238)>>2)];
      var $3240=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3239]($3229) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 380; break; } else { __label__ = 27; break; };
    case 380: // $_noexc14
      HEAP32[(($337)>>2)]=$3240;
      __label__ = 382; break;
    case 381: // $3241
      var $3242=(($3229+12)|0);
      var $3243=HEAP32[(($3242)>>2)];
      var $3244=HEAP8[($3243)];
      $336=$3244;
      var $3245=$336;
      var $3246=(($3245)&255);
      HEAP32[(($337)>>2)]=$3246;
      __label__ = 382; break;
    case 382: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $3247=HEAP32[(($337)>>2)];
      var $3248=$337;
      var $3249=$338;
      var $3250=(($3247) & 255);
      var $3251=$339;
      __label__ = 383; break;
    case 383: // $3252
      var $3253=(($3250 << 24) >> 24);
      var $3254=$__trailing_sign;
      var $3255=$__i;
      var $3256=$351;
      var $3257=$352;
      HEAP32[(($351)>>2)]=$3254;
      HEAP32[(($352)>>2)]=$3255;
      var $3258=HEAP32[(($351)>>2)];
      var $3259=$350;
      HEAP32[(($350)>>2)]=$3258;
      var $3260=HEAP32[(($350)>>2)];
      var $3261=$349;
      HEAP32[(($349)>>2)]=$3260;
      var $3262=HEAPU32[(($349)>>2)];
      var $3263=$348;
      HEAP32[(($348)>>2)]=$3262;
      var $3264=HEAP32[(($348)>>2)];
      var $3265=(($3264)|0);
      var $3266=$347;
      HEAP32[(($347)>>2)]=$3265;
      var $3267=HEAP32[(($347)>>2)];
      var $3268=$3267;
      var $3269=$346;
      HEAP32[(($346)>>2)]=$3268;
      var $3270=HEAP32[(($346)>>2)];
      var $3271=(($3270)|0);
      var $3272=$346;
      var $3273=$347;
      var $3274=(($3271)|0);
      var $3275=$3274;
      var $3276=(($3275)|0);
      var $3277=$3276;
      var $3278=HEAPU8[($3277)];
      var $3279=(($3278)&255);
      var $3280=$3279 & 1;
      var $3281=(($3280)|0)!=0;
      var $3282=$348;
      if ($3281) { __label__ = 384; break; } else { __label__ = 385; break; }
    case 384: // $3283
      var $3284=$342;
      HEAP32[(($342)>>2)]=$3262;
      var $3285=HEAP32[(($342)>>2)];
      var $3286=(($3285)|0);
      var $3287=$341;
      HEAP32[(($341)>>2)]=$3286;
      var $3288=HEAP32[(($341)>>2)];
      var $3289=$3288;
      var $3290=$340;
      HEAP32[(($340)>>2)]=$3289;
      var $3291=HEAP32[(($340)>>2)];
      var $3292=(($3291)|0);
      var $3293=$340;
      var $3294=$341;
      var $3295=(($3292)|0);
      var $3296=$3295;
      var $3297=(($3296+8)|0);
      var $3298=HEAP32[(($3297)>>2)];
      var $3299=$342;
      var $3317 = $3298;__label__ = 386; break;
    case 385: // $3300
      var $3301=$345;
      HEAP32[(($345)>>2)]=$3262;
      var $3302=HEAP32[(($345)>>2)];
      var $3303=(($3302)|0);
      var $3304=$344;
      HEAP32[(($344)>>2)]=$3303;
      var $3305=HEAP32[(($344)>>2)];
      var $3306=$3305;
      var $3307=$343;
      HEAP32[(($343)>>2)]=$3306;
      var $3308=HEAP32[(($343)>>2)];
      var $3309=(($3308)|0);
      var $3310=$343;
      var $3311=$344;
      var $3312=(($3309)|0);
      var $3313=$3312;
      var $3314=(($3313+1)|0);
      var $3315=(($3314)|0);
      var $3316=$345;
      var $3317 = $3315;__label__ = 386; break;
    case 386: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $3317;
      var $3318=$349;
      var $3319=$350;
      var $3320=HEAP32[(($352)>>2)];
      var $3321=(($3317+$3320)|0);
      var $3322=$351;
      var $3323=$352;
      __label__ = 387; break;
    case 387: // $3324
      var $3325=HEAP8[($3321)];
      var $3326=(($3325 << 24) >> 24);
      var $3327=(($3253)|0)!=(($3326)|0);
      if ($3327) { __label__ = 388; break; } else { __label__ = 389; break; }
    case 388: // $3328
      var $3329=$466;
      var $3330=HEAP32[(($3329)>>2)];
      var $3331=$3330 | 4;
      HEAP32[(($3329)>>2)]=$3331;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 389: // $3332
      __label__ = 390; break;
    case 390: // $3333
      var $3334=$__i;
      var $3335=(($3334+1)|0);
      $__i=$3335;
      var $3336=$462;
      var $3337=$370;
      HEAP32[(($370)>>2)]=$3336;
      var $3338=HEAPU32[(($370)>>2)];
      var $3339=(($3338)|0);
      var $3340=HEAP32[(($3339)>>2)];
      var $3341=$368;
      var $3342=$369;
      HEAP32[(($369)>>2)]=$3340;
      var $3343=HEAPU32[(($369)>>2)];
      var $3344=$366;
      var $3345=$367;
      HEAP32[(($367)>>2)]=$3343;
      var $3346=HEAP32[(($367)>>2)];
      var $3347=(($3346+12)|0);
      var $3348=HEAP32[(($3347)>>2)];
      var $3349=(($3346+16)|0);
      var $3350=HEAP32[(($3349)>>2)];
      var $3351=(($3348)|0)==(($3350)|0);
      if ($3351) { __label__ = 391; break; } else { __label__ = 393; break; }
    case 391: // $3352
      var $3353=$3346;
      var $3354=HEAP32[(($3353)>>2)];
      var $3355=(($3354+40)|0);
      var $3356=HEAP32[(($3355)>>2)];
      var $3357=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3356]($3346) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 392; break; } else { __label__ = 27; break; };
    case 392: // $_noexc
      HEAP32[(($366)>>2)]=$3357;
      __label__ = 394; break;
    case 393: // $3358
      var $3359=(($3346+12)|0);
      var $3360=HEAP32[(($3359)>>2)];
      var $3361=(($3360+1)|0);
      HEAP32[(($3359)>>2)]=$3361;
      var $3362=HEAP8[($3360)];
      $365=$3362;
      var $3363=$365;
      var $3364=(($3363)&255);
      HEAP32[(($366)>>2)]=$3364;
      __label__ = 394; break;
    case 394: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $3365=HEAP32[(($366)>>2)];
      var $3366=$366;
      var $3367=$367;
      var $3368=(($3365)|0)==-1;
      if ($3368) { __label__ = 395; break; } else { __label__ = 396; break; }
    case 395: // $3369
      HEAP32[(($368)>>2)]=-1;
      __label__ = 401; break;
    case 396: // $3370
      var $3371=$363;
      var $3372=$364;
      HEAP32[(($364)>>2)]=$3343;
      var $3373=HEAPU32[(($364)>>2)];
      var $3374=(($3373+12)|0);
      var $3375=HEAP32[(($3374)>>2)];
      var $3376=(($3373+16)|0);
      var $3377=HEAP32[(($3376)>>2)];
      var $3378=(($3375)|0)==(($3377)|0);
      if ($3378) { __label__ = 397; break; } else { __label__ = 399; break; }
    case 397: // $3379
      var $3380=$3373;
      var $3381=HEAP32[(($3380)>>2)];
      var $3382=(($3381+36)|0);
      var $3383=HEAP32[(($3382)>>2)];
      var $3384=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3383]($3373) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 398; break; } else { __label__ = 27; break; };
    case 398: // $_noexc13
      HEAP32[(($363)>>2)]=$3384;
      __label__ = 400; break;
    case 399: // $3385
      var $3386=(($3373+12)|0);
      var $3387=HEAP32[(($3386)>>2)];
      var $3388=HEAP8[($3387)];
      $362=$3388;
      var $3389=$362;
      var $3390=(($3389)&255);
      HEAP32[(($363)>>2)]=$3390;
      __label__ = 400; break;
    case 400: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $3391=HEAP32[(($363)>>2)];
      var $3392=$363;
      var $3393=$364;
      HEAP32[(($368)>>2)]=$3391;
      __label__ = 401; break;
    case 401: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $3394=HEAP32[(($368)>>2)];
      var $3395=$368;
      var $3396=$369;
      var $3397=$360;
      var $3398=$361;
      HEAP32[(($360)>>2)]=$3394;
      HEAP32[(($361)>>2)]=-1;
      var $3399=HEAP32[(($360)>>2)];
      var $3400=HEAP32[(($361)>>2)];
      var $3401=(($3399)|0)==(($3400)|0);
      var $3402=$360;
      var $3403=$361;
      if ($3401) { __label__ = 402; break; } else { __label__ = 403; break; }
    case 402: // $3404
      var $3405=(($3338)|0);
      HEAP32[(($3405)>>2)]=0;
      __label__ = 403; break;
    case 403: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $3406=$370;
      __label__ = 404; break;
    case 404: // $3407
      __label__ = 372; break;
    case 405: // $3408
      __label__ = 406; break;
    case 406: // $3409
      var $3410=$373;
      HEAP32[(($373)>>2)]=$__gb;
      var $3411=HEAP32[(($373)>>2)];
      var $3412=(($3411)|0);
      var $3413=$372;
      HEAP32[(($372)>>2)]=$3412;
      var $3414=HEAP32[(($372)>>2)];
      var $3415=$3414;
      var $3416=$371;
      HEAP32[(($371)>>2)]=$3415;
      var $3417=HEAP32[(($371)>>2)];
      var $3418=(($3417)|0);
      var $3419=$371;
      var $3420=$372;
      var $3421=HEAP32[(($3418)>>2)];
      var $3422=$373;
      var $3423=HEAP32[(($__gn)>>2)];
      var $3424=(($3421)|0)!=(($3423)|0);
      if ($3424) { __label__ = 407; break; } else { __label__ = 411; break; }
    case 407: // $3425
      HEAP32[(($__et1)>>2)]=0;
      var $3426=$376;
      HEAP32[(($376)>>2)]=$__gb;
      var $3427=HEAP32[(($376)>>2)];
      var $3428=(($3427)|0);
      var $3429=$375;
      HEAP32[(($375)>>2)]=$3428;
      var $3430=HEAP32[(($375)>>2)];
      var $3431=$3430;
      var $3432=$374;
      HEAP32[(($374)>>2)]=$3431;
      var $3433=HEAP32[(($374)>>2)];
      var $3434=(($3433)|0);
      var $3435=$374;
      var $3436=$375;
      var $3437=HEAP32[(($3434)>>2)];
      var $3438=$376;
      var $3439=HEAP32[(($__gn)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grp, $3437, $3439, $__et1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 408; break; } else { __label__ = 27; break; }
    case 408: // $3440
      var $3441=HEAP32[(($__et1)>>2)];
      var $3442=(($3441)|0)!=0;
      if ($3442) { __label__ = 409; break; } else { __label__ = 410; break; }
    case 409: // $3443
      var $3444=$466;
      var $3445=HEAP32[(($3444)>>2)];
      var $3446=$3445 | 4;
      HEAP32[(($3444)>>2)]=$3446;
      $461=0;
      $474=1;
      __label__ = 412; break;
    case 410: // $3447
      __label__ = 411; break;
    case 411: // $3448
      $461=1;
      $474=1;
      __label__ = 412; break;
    case 412: // $3449
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__nsn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 413; break; } else { __label__ = 26; break; }
    case 413: // $3450
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__psn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 415; break; } else { __label__ = 25; break; }
    case 414: // $3451
      __label__ = 416; break;
    case 415: // $3452
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 418; break; } else { __label__ = 24; break; }
    case 416: // $3453
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__psn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 417; break; } else { __label__ = 435; break; }
    case 417: // $3454
      __label__ = 419; break;
    case 418: // $3455
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 421; break; } else { __label__ = 23; break; }
    case 419: // $3456
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 420; break; } else { __label__ = 435; break; }
    case 420: // $3457
      __label__ = 426; break;
    case 421: // $3458
      var $3459=$415;
      HEAP32[(($415)>>2)]=$__gb;
      var $3460=HEAP32[(($415)>>2)];
      var $3461=$414;
      HEAP32[(($414)>>2)]=$3460;
      var $3462=HEAP32[(($414)>>2)];
      var $3463=$410;
      var $3464=$411;
      var $3465=$__tmp_i_i_i2;
      var $3466=$412;
      var $3467=$413;
      HEAP32[(($410)>>2)]=$3462;
      HEAP32[(($411)>>2)]=0;
      var $3468=HEAP32[(($410)>>2)];
      var $3469=(($3468)|0);
      var $3470=$409;
      HEAP32[(($409)>>2)]=$3469;
      var $3471=HEAP32[(($409)>>2)];
      var $3472=$3471;
      var $3473=$408;
      HEAP32[(($408)>>2)]=$3472;
      var $3474=HEAP32[(($408)>>2)];
      var $3475=(($3474)|0);
      var $3476=$408;
      var $3477=$409;
      var $3478=HEAP32[(($3475)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$3478;
      var $3479=HEAP32[(($411)>>2)];
      var $3480=(($3468)|0);
      var $3481=$407;
      HEAP32[(($407)>>2)]=$3480;
      var $3482=HEAP32[(($407)>>2)];
      var $3483=$3482;
      var $3484=$406;
      HEAP32[(($406)>>2)]=$3483;
      var $3485=HEAP32[(($406)>>2)];
      var $3486=(($3485)|0);
      var $3487=$406;
      var $3488=$407;
      HEAP32[(($3486)>>2)]=$3479;
      var $3489=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $3490=(($3489)|0)!=0;
      if ($3490) { __label__ = 422; break; } else { __label__ = 425; break; }
    case 422: // $3491
      var $3492=(($3468)|0);
      var $3493=$405;
      HEAP32[(($405)>>2)]=$3492;
      var $3494=HEAP32[(($405)>>2)];
      var $3495=$3494;
      var $3496=$404;
      HEAP32[(($404)>>2)]=$3495;
      var $3497=HEAP32[(($404)>>2)];
      var $3498=(($3497+4)|0);
      var $3499=$404;
      var $3500=$405;
      var $3501=HEAP32[(($3498)>>2)];
      var $3502=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $3503=$3502;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$3501]($3503) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 423; break; } else { __label__ = 424; break; }
    case 423: // $3504
      __label__ = 425; break;
    case 424: // $3505
      var $3506=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $3507=$3506.f0;
      HEAP32[(($412)>>2)]=$3507;
      var $3508=$3506.f1;
      HEAP32[(($413)>>2)]=$3508;
      var $3509=HEAP32[(($412)>>2)];
      ___cxa_call_unexpected($3509);
      throw "Reached an unreachable!"
    case 425: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit3
      var $3510=$410;
      var $3511=$411;
      var $3512=$__tmp_i_i_i2;
      var $3513=$412;
      var $3514=$413;
      var $3515=$414;
      var $3516=$415;
      var $3517=$461;
      STACKTOP = __stackBase__;
      return $3517;
    case 426: // $3518
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 427; break; } else { __label__ = 435; break; }
    case 427: // $3519
      __label__ = 428; break;
    case 428: // $3520
      var $3521=$439;
      HEAP32[(($439)>>2)]=$__gb;
      var $3522=HEAP32[(($439)>>2)];
      var $3523=$438;
      HEAP32[(($438)>>2)]=$3522;
      var $3524=HEAP32[(($438)>>2)];
      var $3525=$434;
      var $3526=$435;
      var $3527=$__tmp_i_i_i;
      var $3528=$436;
      var $3529=$437;
      HEAP32[(($434)>>2)]=$3524;
      HEAP32[(($435)>>2)]=0;
      var $3530=HEAP32[(($434)>>2)];
      var $3531=(($3530)|0);
      var $3532=$433;
      HEAP32[(($433)>>2)]=$3531;
      var $3533=HEAP32[(($433)>>2)];
      var $3534=$3533;
      var $3535=$432;
      HEAP32[(($432)>>2)]=$3534;
      var $3536=HEAP32[(($432)>>2)];
      var $3537=(($3536)|0);
      var $3538=$432;
      var $3539=$433;
      var $3540=HEAP32[(($3537)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$3540;
      var $3541=HEAP32[(($435)>>2)];
      var $3542=(($3530)|0);
      var $3543=$431;
      HEAP32[(($431)>>2)]=$3542;
      var $3544=HEAP32[(($431)>>2)];
      var $3545=$3544;
      var $3546=$430;
      HEAP32[(($430)>>2)]=$3545;
      var $3547=HEAP32[(($430)>>2)];
      var $3548=(($3547)|0);
      var $3549=$430;
      var $3550=$431;
      HEAP32[(($3548)>>2)]=$3541;
      var $3551=HEAP32[(($__tmp_i_i_i)>>2)];
      var $3552=(($3551)|0)!=0;
      if ($3552) { __label__ = 429; break; } else { __label__ = 432; break; }
    case 429: // $3553
      var $3554=(($3530)|0);
      var $3555=$429;
      HEAP32[(($429)>>2)]=$3554;
      var $3556=HEAP32[(($429)>>2)];
      var $3557=$3556;
      var $3558=$428;
      HEAP32[(($428)>>2)]=$3557;
      var $3559=HEAP32[(($428)>>2)];
      var $3560=(($3559+4)|0);
      var $3561=$428;
      var $3562=$429;
      var $3563=HEAP32[(($3560)>>2)];
      var $3564=HEAP32[(($__tmp_i_i_i)>>2)];
      var $3565=$3564;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$3563]($3565) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 430; break; } else { __label__ = 431; break; }
    case 430: // $3566
      __label__ = 432; break;
    case 431: // $3567
      var $3568=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $3569=$3568.f0;
      HEAP32[(($436)>>2)]=$3569;
      var $3570=$3568.f1;
      HEAP32[(($437)>>2)]=$3570;
      var $3571=HEAP32[(($436)>>2)];
      ___cxa_call_unexpected($3571);
      throw "Reached an unreachable!"
    case 432: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit
      var $3572=$434;
      var $3573=$435;
      var $3574=$__tmp_i_i_i;
      var $3575=$436;
      var $3576=$437;
      var $3577=$438;
      var $3578=$439;
      __label__ = 433; break;
    case 433: // $3579
      __label__ = 434; break;
    case 434: // $3580
      var $3581=$472;
      var $3582=$472;
      var $3583=$473;
      var $3584=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $3582, tempValue);
      var $3585=($3584.f1 = $3583, $3584);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 435: // $3586
      var $3587=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_["X"]=1;
// WARNING: content after a branch in a label, line: 867533

function __ZNSt3__121__throw_runtime_errorEPKc($msg) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$msg;
      var $4=___cxa_allocate_exception(8);
      var $5=$4;
      var $6=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt13runtime_errorC1EPKc]($5, $6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      ___cxa_throw($4, __ZTISt13runtime_error, 1684);
      throw "Reached an unreachable!"
    case 2: // $8
      var $9=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $10=$9.f0;
      $2=$10;
      var $11=$9.f1;
      $3=$11;
      ___cxa_free_exception($4);
      __label__ = 3; break;
    case 3: // $13
      var $14=$2;
      var $15=$2;
      var $16=$3;
      var $17=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $15, tempValue);
      var $18=($17.f1 = $16, $17);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE($agg_result, $this, $__b, $__e, $__intl, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 464; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      var $10=__stackBase__+32;
      var $11;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $__tmp_i_i_i1=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      var $25=__stackBase__+92;
      var $26=__stackBase__+96;
      var $27=__stackBase__+100;
      var $28=__stackBase__+104;
      var $29=__stackBase__+108;
      var $30=__stackBase__+112;
      var $31=__stackBase__+116;
      var $32=__stackBase__+120;
      var $33=__stackBase__+124;
      var $34=__stackBase__+128;
      var $35=__stackBase__+132;
      var $36=__stackBase__+136;
      var $37=__stackBase__+140;
      var $38=__stackBase__+144;
      var $39=__stackBase__+148;
      var $40=__stackBase__+152;
      var $41=__stackBase__+156;
      var $42=__stackBase__+160;
      var $43=__stackBase__+164;
      var $44=__stackBase__+168;
      var $45=__stackBase__+172;
      var $46=__stackBase__+176;
      var $47=__stackBase__+180;
      var $48=__stackBase__+184;
      var $49=__stackBase__+188;
      var $50=__stackBase__+192;
      var $51=__stackBase__+196;
      var $52=__stackBase__+200;
      var $53=__stackBase__+204;
      var $54=__stackBase__+208;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $57=__stackBase__+220;
      var $58=__stackBase__+224;
      var $59=__stackBase__+228;
      var $60=__stackBase__+232;
      var $__tmp_i_i_i=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $80=__stackBase__+316;
      var $81=__stackBase__+320;
      var $82=__stackBase__+324;
      var $83=__stackBase__+328;
      var $84=__stackBase__+332;
      var $85=__stackBase__+336;
      var $86;
      var $87;
      var $88;
      var $89;
      var $90;
      var $__bz;
      var $__wbuf=__stackBase__+340;
      var $__wb=__stackBase__+440;
      var $__wn=__stackBase__+448;
      var $__we;
      var $__loc=__stackBase__+452;
      var $91;
      var $92;
      var $__ct;
      var $__neg=__stackBase__+456;
      var $93=__stackBase__+460;
      var $__z;
      var $__w;
      var $94;
      $86=$this;
      var $95=(($__intl)&1);
      $87=$95;
      $88=$__iob;
      $89=$__err;
      $90=$__v;
      var $96=$86;
      $__bz=100;
      var $97=(($__wbuf)|0);
      var $98=$83;
      var $99=$84;
      var $100=$85;
      HEAP32[(($83)>>2)]=$__wb;
      HEAP32[(($84)>>2)]=$97;
      HEAP32[(($85)>>2)]=1682;
      var $101=HEAP32[(($83)>>2)];
      var $102=HEAP32[(($84)>>2)];
      var $103=HEAP32[(($85)>>2)];
      var $104=$80;
      var $105=$81;
      var $106=$82;
      HEAP32[(($80)>>2)]=$101;
      HEAP32[(($81)>>2)]=$102;
      HEAP32[(($82)>>2)]=$103;
      var $107=HEAP32[(($80)>>2)];
      var $108=(($107)|0);
      var $109=$79;
      HEAP32[(($79)>>2)]=$81;
      var $110=HEAP32[(($79)>>2)];
      var $111=$79;
      var $112=HEAP32[(($110)>>2)];
      var $113=$65;
      HEAP32[(($65)>>2)]=$82;
      var $114=HEAP32[(($65)>>2)];
      var $115=$65;
      var $116=HEAP32[(($114)>>2)];
      var $117=$76;
      var $118=$77;
      var $119=$78;
      HEAP32[(($76)>>2)]=$108;
      HEAP32[(($77)>>2)]=$112;
      HEAP32[(($78)>>2)]=$116;
      var $120=HEAP32[(($76)>>2)];
      var $121=HEAP32[(($77)>>2)];
      var $122=HEAP32[(($78)>>2)];
      var $123=$73;
      var $124=$74;
      var $125=$75;
      HEAP32[(($73)>>2)]=$120;
      HEAP32[(($74)>>2)]=$121;
      HEAP32[(($75)>>2)]=$122;
      var $126=HEAP32[(($73)>>2)];
      var $127=$126;
      var $128=$72;
      HEAP32[(($72)>>2)]=$74;
      var $129=HEAP32[(($72)>>2)];
      var $130=$72;
      var $131=HEAP32[(($129)>>2)];
      var $132=$66;
      HEAP32[(($66)>>2)]=$75;
      var $133=HEAP32[(($66)>>2)];
      var $134=$66;
      var $135=HEAP32[(($133)>>2)];
      var $136=$69;
      var $137=$70;
      var $138=$71;
      HEAP32[(($69)>>2)]=$127;
      HEAP32[(($70)>>2)]=$131;
      HEAP32[(($71)>>2)]=$135;
      var $139=HEAP32[(($69)>>2)];
      var $140=(($139)|0);
      var $141=$68;
      HEAP32[(($68)>>2)]=$70;
      var $142=HEAP32[(($68)>>2)];
      var $143=$68;
      var $144=HEAP32[(($142)>>2)];
      HEAP32[(($140)>>2)]=$144;
      var $145=(($139+4)|0);
      var $146=$67;
      HEAP32[(($67)>>2)]=$71;
      var $147=HEAP32[(($67)>>2)];
      var $148=$67;
      var $149=HEAP32[(($147)>>2)];
      HEAP32[(($145)>>2)]=$149;
      var $150=$69;
      var $151=$70;
      var $152=$71;
      var $153=$73;
      var $154=$74;
      var $155=$75;
      var $156=$76;
      var $157=$77;
      var $158=$78;
      var $159=$80;
      var $160=$81;
      var $161=$82;
      var $162=$83;
      var $163=$84;
      var $164=$85;
      var $165=(($__wbuf)|0);
      var $166=(($165+100)|0);
      $__we=$166;
      var $167=$88;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($__loc, $167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $168
      var $169=$52;
      HEAP32[(($52)>>2)]=$__loc;
      var $170=HEAP32[(($52)>>2)];
      var $171=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($170, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $172=$171;
      var $173=$52;
      __label__ = 3; break;
    case 3: // $174
      $__ct=$172;
      HEAP8[($__neg)]=0;
      var $175=$93;
      var $176=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($175)>>2)]=HEAP32[(($176)>>2)];
      var $177=$87;
      var $178=(($177) & 1);
      var $179=$88;
      var $180=$51;
      HEAP32[(($51)>>2)]=$179;
      var $181=HEAP32[(($51)>>2)];
      var $182=(($181+4)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$51;
      __label__ = 4; break;
    case 4: // $185
      var $186=$89;
      var $187=$__ct;
      var $188=$__we;
      var $189=(function() { try { __THREW__ = false; return __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_($__b, $93, $178, $__loc, $183, $186, $__neg, $187, $__wb, $__wn, $188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; };
    case 5: // $190
      if ($189) { __label__ = 6; break; } else { __label__ = 26; break; }
    case 6: // $191
      var $192=$90;
      var $193=$46;
      var $194=$47;
      var $195=$48;
      HEAP32[(($46)>>2)]=$192;
      var $196=HEAPU32[(($46)>>2)];
      var $197=$45;
      HEAP32[(($45)>>2)]=$196;
      var $198=HEAP32[(($45)>>2)];
      var $199=$45;
      var $200=$26;
      HEAP32[(($26)>>2)]=$196;
      var $201=HEAP32[(($26)>>2)];
      var $202=(($201)|0);
      var $203=$25;
      HEAP32[(($25)>>2)]=$202;
      var $204=HEAP32[(($25)>>2)];
      var $205=$204;
      var $206=$24;
      HEAP32[(($24)>>2)]=$205;
      var $207=HEAP32[(($24)>>2)];
      var $208=(($207)|0);
      var $209=$24;
      var $210=$25;
      var $211=(($208)|0);
      var $212=$211;
      var $213=(($212)|0);
      var $214=$213;
      var $215=HEAPU8[($214)];
      var $216=(($215)&255);
      var $217=$216 & 1;
      var $218=(($217)|0)!=0;
      var $219=$26;
      if ($218) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $220
      var $221=$29;
      HEAP32[(($29)>>2)]=$196;
      var $222=HEAP32[(($29)>>2)];
      var $223=(($222)|0);
      var $224=$28;
      HEAP32[(($28)>>2)]=$223;
      var $225=HEAP32[(($28)>>2)];
      var $226=$225;
      var $227=$27;
      HEAP32[(($27)>>2)]=$226;
      var $228=HEAP32[(($27)>>2)];
      var $229=(($228)|0);
      var $230=$27;
      var $231=$28;
      var $232=(($229)|0);
      var $233=$232;
      var $234=(($233+8)|0);
      var $235=HEAP32[(($234)>>2)];
      var $236=$29;
      HEAP8[($49)]=0;
      var $237=$30;
      var $238=$31;
      HEAP32[(($30)>>2)]=$235;
      HEAP32[(($31)>>2)]=$49;
      var $239=HEAP32[(($31)>>2)];
      var $240=HEAP8[($239)];
      var $241=HEAP32[(($30)>>2)];
      HEAP8[($241)]=$240;
      var $242=$30;
      var $243=$31;
      var $244=$34;
      var $245=$35;
      HEAP32[(($34)>>2)]=$196;
      HEAP32[(($35)>>2)]=0;
      var $246=HEAP32[(($34)>>2)];
      var $247=HEAP32[(($35)>>2)];
      var $248=(($246)|0);
      var $249=$33;
      HEAP32[(($33)>>2)]=$248;
      var $250=HEAP32[(($33)>>2)];
      var $251=$250;
      var $252=$32;
      HEAP32[(($32)>>2)]=$251;
      var $253=HEAP32[(($32)>>2)];
      var $254=(($253)|0);
      var $255=$32;
      var $256=$33;
      var $257=(($254)|0);
      var $258=$257;
      var $259=(($258+4)|0);
      HEAP32[(($259)>>2)]=$247;
      var $260=$34;
      var $261=$35;
      __label__ = 9; break;
    case 8: // $262
      var $263=$38;
      HEAP32[(($38)>>2)]=$196;
      var $264=HEAP32[(($38)>>2)];
      var $265=(($264)|0);
      var $266=$37;
      HEAP32[(($37)>>2)]=$265;
      var $267=HEAP32[(($37)>>2)];
      var $268=$267;
      var $269=$36;
      HEAP32[(($36)>>2)]=$268;
      var $270=HEAP32[(($36)>>2)];
      var $271=(($270)|0);
      var $272=$36;
      var $273=$37;
      var $274=(($271)|0);
      var $275=$274;
      var $276=(($275+1)|0);
      var $277=(($276)|0);
      var $278=$38;
      HEAP8[($50)]=0;
      var $279=$39;
      var $280=$40;
      HEAP32[(($39)>>2)]=$277;
      HEAP32[(($40)>>2)]=$50;
      var $281=HEAP32[(($40)>>2)];
      var $282=HEAP8[($281)];
      var $283=HEAP32[(($39)>>2)];
      HEAP8[($283)]=$282;
      var $284=$39;
      var $285=$40;
      var $286=$43;
      var $287=$44;
      HEAP32[(($43)>>2)]=$196;
      HEAP32[(($44)>>2)]=0;
      var $288=HEAP32[(($43)>>2)];
      var $289=HEAP32[(($44)>>2)];
      var $290=$289 << 1;
      var $291=(($290) & 255);
      var $292=(($288)|0);
      var $293=$42;
      HEAP32[(($42)>>2)]=$292;
      var $294=HEAP32[(($42)>>2)];
      var $295=$294;
      var $296=$41;
      HEAP32[(($41)>>2)]=$295;
      var $297=HEAP32[(($41)>>2)];
      var $298=(($297)|0);
      var $299=$41;
      var $300=$42;
      var $301=(($298)|0);
      var $302=$301;
      var $303=(($302)|0);
      var $304=$303;
      HEAP8[($304)]=$291;
      var $305=$43;
      var $306=$44;
      __label__ = 9; break;
    case 9: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5clearEv_exit
      var $307=$46;
      var $308=$47;
      var $309=$48;
      var $310=HEAP8[($__neg)];
      var $311=(($310) & 1);
      if ($311) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $312
      var $313=$90;
      var $314=$__ct;
      var $315=$10;
      HEAP32[(($10)>>2)]=$314;
      $11=45;
      var $316=HEAP32[(($10)>>2)];
      var $317=$316;
      var $318=HEAP32[(($317)>>2)];
      var $319=(($318+28)|0);
      var $320=HEAP32[(($319)>>2)];
      var $321=$11;
      var $322=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$320]($316, $321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $_ZNKSt3__15ctypeIcE5widenEc_exit
      var $323=$10;
      __label__ = 12; break;
    case 12: // $324
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($313, $322) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $325
      __label__ = 16; break;
    case 14: // $326
      var $327=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $328=$327.f0;
      $91=$328;
      var $329=$327.f1;
      $92=$329;
      __label__ = 36; break;
    case 15: // $330
      var $331=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $332=$331.f0;
      $91=$332;
      var $333=$331.f1;
      $92=$333;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 43; break; }
    case 16: // $334
      var $335=$__ct;
      var $336=$8;
      HEAP32[(($8)>>2)]=$335;
      $9=48;
      var $337=HEAP32[(($8)>>2)];
      var $338=$337;
      var $339=HEAP32[(($338)>>2)];
      var $340=(($339+28)|0);
      var $341=HEAP32[(($340)>>2)];
      var $342=$9;
      var $343=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$341]($337, $342) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $_ZNKSt3__15ctypeIcE5widenEc_exit3
      var $344=$8;
      __label__ = 18; break;
    case 18: // $345
      $__z=$343;
      var $346=$7;
      HEAP32[(($7)>>2)]=$__wb;
      var $347=HEAP32[(($7)>>2)];
      var $348=(($347)|0);
      var $349=$6;
      HEAP32[(($6)>>2)]=$348;
      var $350=HEAP32[(($6)>>2)];
      var $351=$350;
      var $352=$5;
      HEAP32[(($5)>>2)]=$351;
      var $353=HEAP32[(($5)>>2)];
      var $354=(($353)|0);
      var $355=$5;
      var $356=$6;
      var $357=HEAP32[(($354)>>2)];
      var $358=$7;
      $__w=$357;
      __label__ = 19; break;
    case 19: // $359
      var $360=$__w;
      var $361=HEAP32[(($__wn)>>2)];
      var $362=(($361-1)|0);
      var $363=(($360)>>>0) < (($362)>>>0);
      if ($363) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $364
      var $365=$__w;
      var $366=HEAP8[($365)];
      var $367=(($366 << 24) >> 24);
      var $368=$__z;
      var $369=(($368 << 24) >> 24);
      var $370=(($367)|0)!=(($369)|0);
      if ($370) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $371
      __label__ = 24; break;
    case 22: // $372
      __label__ = 23; break;
    case 23: // $373
      var $374=$__w;
      var $375=(($374+1)|0);
      $__w=$375;
      __label__ = 19; break;
    case 24: // $376
      var $377=$90;
      var $378=$__w;
      var $379=HEAP32[(($__wn)>>2)];
      var $380=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($377, $378, $379) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $381
      __label__ = 26; break;
    case 26: // $382
      var $383=$3;
      var $384=$4;
      HEAP32[(($3)>>2)]=$__b;
      HEAP32[(($4)>>2)]=$__e;
      var $385=HEAP32[(($3)>>2)];
      var $386=HEAP32[(($4)>>2)];
      var $387=$1;
      var $388=$2;
      HEAP32[(($1)>>2)]=$385;
      HEAP32[(($2)>>2)]=$386;
      var $389=HEAP32[(($1)>>2)];
      var $390=(($389)|0);
      var $391=HEAP32[(($390)>>2)];
      var $392=(($391)|0)==0;
      var $393=(($392)&1);
      var $394=HEAP32[(($2)>>2)];
      var $395=(($394)|0);
      var $396=HEAP32[(($395)>>2)];
      var $397=(($396)|0)==0;
      var $398=(($397)&1);
      var $399=(($393)|0)==(($398)|0);
      var $400=$1;
      var $401=$2;
      var $402=$3;
      var $403=$4;
      __label__ = 27; break;
    case 27: // $404
      if ($399) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $405
      var $406=$89;
      var $407=HEAP32[(($406)>>2)];
      var $408=$407 | 2;
      HEAP32[(($406)>>2)]=$408;
      __label__ = 29; break;
    case 29: // $409
      var $410=$agg_result;
      var $411=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($410)>>2)]=HEAP32[(($411)>>2)];
      $94=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 14; break; }
    case 30: // $412
      var $413=$23;
      HEAP32[(($23)>>2)]=$__wb;
      var $414=HEAP32[(($23)>>2)];
      var $415=$22;
      HEAP32[(($22)>>2)]=$414;
      var $416=HEAP32[(($22)>>2)];
      var $417=$18;
      var $418=$19;
      var $419=$__tmp_i_i_i1;
      var $420=$20;
      var $421=$21;
      HEAP32[(($18)>>2)]=$416;
      HEAP32[(($19)>>2)]=0;
      var $422=HEAP32[(($18)>>2)];
      var $423=(($422)|0);
      var $424=$17;
      HEAP32[(($17)>>2)]=$423;
      var $425=HEAP32[(($17)>>2)];
      var $426=$425;
      var $427=$16;
      HEAP32[(($16)>>2)]=$426;
      var $428=HEAP32[(($16)>>2)];
      var $429=(($428)|0);
      var $430=$16;
      var $431=$17;
      var $432=HEAP32[(($429)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$432;
      var $433=HEAP32[(($19)>>2)];
      var $434=(($422)|0);
      var $435=$15;
      HEAP32[(($15)>>2)]=$434;
      var $436=HEAP32[(($15)>>2)];
      var $437=$436;
      var $438=$14;
      HEAP32[(($14)>>2)]=$437;
      var $439=HEAP32[(($14)>>2)];
      var $440=(($439)|0);
      var $441=$14;
      var $442=$15;
      HEAP32[(($440)>>2)]=$433;
      var $443=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $444=(($443)|0)!=0;
      if ($444) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $445
      var $446=(($422)|0);
      var $447=$13;
      HEAP32[(($13)>>2)]=$446;
      var $448=HEAP32[(($13)>>2)];
      var $449=$448;
      var $450=$12;
      HEAP32[(($12)>>2)]=$449;
      var $451=HEAP32[(($12)>>2)];
      var $452=(($451+4)|0);
      var $453=$12;
      var $454=$13;
      var $455=HEAP32[(($452)>>2)];
      var $456=HEAP32[(($__tmp_i_i_i1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$455]($456) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $457
      __label__ = 34; break;
    case 33: // $458
      var $459=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $460=$459.f0;
      HEAP32[(($20)>>2)]=$460;
      var $461=$459.f1;
      HEAP32[(($21)>>2)]=$461;
      var $462=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($462);
      throw "Reached an unreachable!"
    case 34: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit2
      var $463=$18;
      var $464=$19;
      var $465=$__tmp_i_i_i1;
      var $466=$20;
      var $467=$21;
      var $468=$22;
      var $469=$23;
      STACKTOP = __stackBase__;
      return;
    case 35: // $470
      __label__ = 36; break;
    case 36: // $471
      var $472=$64;
      HEAP32[(($64)>>2)]=$__wb;
      var $473=HEAP32[(($64)>>2)];
      var $474=$63;
      HEAP32[(($63)>>2)]=$473;
      var $475=HEAP32[(($63)>>2)];
      var $476=$59;
      var $477=$60;
      var $478=$__tmp_i_i_i;
      var $479=$61;
      var $480=$62;
      HEAP32[(($59)>>2)]=$475;
      HEAP32[(($60)>>2)]=0;
      var $481=HEAP32[(($59)>>2)];
      var $482=(($481)|0);
      var $483=$58;
      HEAP32[(($58)>>2)]=$482;
      var $484=HEAP32[(($58)>>2)];
      var $485=$484;
      var $486=$57;
      HEAP32[(($57)>>2)]=$485;
      var $487=HEAP32[(($57)>>2)];
      var $488=(($487)|0);
      var $489=$57;
      var $490=$58;
      var $491=HEAP32[(($488)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$491;
      var $492=HEAP32[(($60)>>2)];
      var $493=(($481)|0);
      var $494=$56;
      HEAP32[(($56)>>2)]=$493;
      var $495=HEAP32[(($56)>>2)];
      var $496=$495;
      var $497=$55;
      HEAP32[(($55)>>2)]=$496;
      var $498=HEAP32[(($55)>>2)];
      var $499=(($498)|0);
      var $500=$55;
      var $501=$56;
      HEAP32[(($499)>>2)]=$492;
      var $502=HEAP32[(($__tmp_i_i_i)>>2)];
      var $503=(($502)|0)!=0;
      if ($503) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $504
      var $505=(($481)|0);
      var $506=$54;
      HEAP32[(($54)>>2)]=$505;
      var $507=HEAP32[(($54)>>2)];
      var $508=$507;
      var $509=$53;
      HEAP32[(($53)>>2)]=$508;
      var $510=HEAP32[(($53)>>2)];
      var $511=(($510+4)|0);
      var $512=$53;
      var $513=$54;
      var $514=HEAP32[(($511)>>2)];
      var $515=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$514]($515) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $516
      __label__ = 40; break;
    case 39: // $517
      var $518=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $519=$518.f0;
      HEAP32[(($61)>>2)]=$519;
      var $520=$518.f1;
      HEAP32[(($62)>>2)]=$520;
      var $521=HEAP32[(($61)>>2)];
      ___cxa_call_unexpected($521);
      throw "Reached an unreachable!"
    case 40: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $522=$59;
      var $523=$60;
      var $524=$__tmp_i_i_i;
      var $525=$61;
      var $526=$62;
      var $527=$63;
      var $528=$64;
      __label__ = 41; break;
    case 41: // $529
      __label__ = 42; break;
    case 42: // $530
      var $531=$91;
      var $532=$91;
      var $533=$92;
      var $534=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $532, tempValue);
      var $535=($534.f1 = $533, $534);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $536
      var $537=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($this, $__first, $__last) {
  var __stackBase__  = STACKTOP; STACKTOP += 204; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51;
      var $52;
      var $53;
      var $__sz;
      var $__cap;
      var $__n;
      var $__p;
      var $54=__stackBase__+200;
      $51=$this;
      $52=$__first;
      $53=$__last;
      var $55=$51;
      var $56=$50;
      HEAP32[(($50)>>2)]=$55;
      var $57=HEAPU32[(($50)>>2)];
      var $58=$49;
      HEAP32[(($49)>>2)]=$57;
      var $59=HEAP32[(($49)>>2)];
      var $60=(($59)|0);
      var $61=$48;
      HEAP32[(($48)>>2)]=$60;
      var $62=HEAP32[(($48)>>2)];
      var $63=$62;
      var $64=$47;
      HEAP32[(($47)>>2)]=$63;
      var $65=HEAP32[(($47)>>2)];
      var $66=(($65)|0);
      var $67=$47;
      var $68=$48;
      var $69=(($66)|0);
      var $70=$69;
      var $71=(($70)|0);
      var $72=$71;
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$74 & 1;
      var $76=(($75)|0)!=0;
      var $77=$49;
      if ($76) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $78
      var $79=$43;
      HEAP32[(($43)>>2)]=$57;
      var $80=HEAP32[(($43)>>2)];
      var $81=(($80)|0);
      var $82=$42;
      HEAP32[(($42)>>2)]=$81;
      var $83=HEAP32[(($42)>>2)];
      var $84=$83;
      var $85=$41;
      HEAP32[(($41)>>2)]=$84;
      var $86=HEAP32[(($41)>>2)];
      var $87=(($86)|0);
      var $88=$41;
      var $89=$42;
      var $90=(($87)|0);
      var $91=$90;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$43;
      var $115 = $93;__label__ = 3; break;
    case 2: // $95
      var $96=$46;
      HEAP32[(($46)>>2)]=$57;
      var $97=HEAP32[(($46)>>2)];
      var $98=(($97)|0);
      var $99=$45;
      HEAP32[(($45)>>2)]=$98;
      var $100=HEAP32[(($45)>>2)];
      var $101=$100;
      var $102=$44;
      HEAP32[(($44)>>2)]=$101;
      var $103=HEAP32[(($44)>>2)];
      var $104=(($103)|0);
      var $105=$44;
      var $106=$45;
      var $107=(($104)|0);
      var $108=$107;
      var $109=(($108)|0);
      var $110=$109;
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$112 >> 1;
      var $114=$46;
      var $115 = $113;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $115;
      var $116=$50;
      $__sz=$115;
      var $117=$7;
      HEAP32[(($7)>>2)]=$55;
      var $118=HEAPU32[(($7)>>2)];
      var $119=$6;
      HEAP32[(($6)>>2)]=$118;
      var $120=HEAP32[(($6)>>2)];
      var $121=(($120)|0);
      var $122=$5;
      HEAP32[(($5)>>2)]=$121;
      var $123=HEAP32[(($5)>>2)];
      var $124=$123;
      var $125=$4;
      HEAP32[(($4)>>2)]=$124;
      var $126=HEAP32[(($4)>>2)];
      var $127=(($126)|0);
      var $128=$4;
      var $129=$5;
      var $130=(($127)|0);
      var $131=$130;
      var $132=(($131)|0);
      var $133=$132;
      var $134=HEAPU8[($133)];
      var $135=(($134)&255);
      var $136=$135 & 1;
      var $137=(($136)|0)!=0;
      var $138=$6;
      if ($137) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $139
      var $140=$3;
      HEAP32[(($3)>>2)]=$118;
      var $141=HEAP32[(($3)>>2)];
      var $142=(($141)|0);
      var $143=$2;
      HEAP32[(($2)>>2)]=$142;
      var $144=HEAP32[(($2)>>2)];
      var $145=$144;
      var $146=$1;
      HEAP32[(($1)>>2)]=$145;
      var $147=HEAP32[(($1)>>2)];
      var $148=(($147)|0);
      var $149=$1;
      var $150=$2;
      var $151=(($148)|0);
      var $152=$151;
      var $153=(($152)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$154 & -2;
      var $156=$3;
      var $158 = $155;__label__ = 6; break;
    case 5: // $157
      var $158 = 11;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv_exit
      var $158;
      var $159=(($158-1)|0);
      var $160=$7;
      $__cap=$159;
      var $161=$52;
      var $162=$53;
      var $163=$10;
      var $164=$11;
      var $165=$12;
      var $166=$13;
      HEAP32[(($11)>>2)]=$161;
      HEAP32[(($12)>>2)]=$162;
      var $167=HEAP32[(($11)>>2)];
      var $168=HEAP32[(($12)>>2)];
      var $tmp_i=$10;
      var $tmp1_i=$13;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $169=$8;
      var $170=$9;
      HEAP32[(($8)>>2)]=$167;
      HEAP32[(($9)>>2)]=$168;
      var $171=HEAP32[(($9)>>2)];
      var $172=HEAP32[(($8)>>2)];
      var $173=$171;
      var $174=$172;
      var $175=(($173-$174)|0);
      var $176=$8;
      var $177=$9;
      var $178=$10;
      var $179=$11;
      var $180=$12;
      var $181=$13;
      $__n=$175;
      var $182=$__n;
      var $183=(($182)|0)!=0;
      if ($183) { __label__ = 7; break; } else { __label__ = 20; break; }
    case 7: // $184
      var $185=$__cap;
      var $186=$__sz;
      var $187=(($185-$186)|0);
      var $188=$__n;
      var $189=(($187)>>>0) < (($188)>>>0);
      if ($189) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $190
      var $191=$__cap;
      var $192=$__sz;
      var $193=$__n;
      var $194=(($192+$193)|0);
      var $195=$__cap;
      var $196=(($194-$195)|0);
      var $197=$__sz;
      var $198=$__sz;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj($55, $191, $196, $197, $198, 0, 0);
      __label__ = 9; break;
    case 9: // $199
      var $200=$23;
      HEAP32[(($23)>>2)]=$55;
      var $201=HEAPU32[(($23)>>2)];
      var $202=$22;
      HEAP32[(($22)>>2)]=$201;
      var $203=HEAP32[(($22)>>2)];
      var $204=(($203)|0);
      var $205=$21;
      HEAP32[(($21)>>2)]=$204;
      var $206=HEAP32[(($21)>>2)];
      var $207=$206;
      var $208=$20;
      HEAP32[(($20)>>2)]=$207;
      var $209=HEAP32[(($20)>>2)];
      var $210=(($209)|0);
      var $211=$20;
      var $212=$21;
      var $213=(($210)|0);
      var $214=$213;
      var $215=(($214)|0);
      var $216=$215;
      var $217=HEAPU8[($216)];
      var $218=(($217)&255);
      var $219=$218 & 1;
      var $220=(($219)|0)!=0;
      var $221=$22;
      if ($220) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $222
      var $223=$16;
      HEAP32[(($16)>>2)]=$201;
      var $224=HEAP32[(($16)>>2)];
      var $225=(($224)|0);
      var $226=$15;
      HEAP32[(($15)>>2)]=$225;
      var $227=HEAP32[(($15)>>2)];
      var $228=$227;
      var $229=$14;
      HEAP32[(($14)>>2)]=$228;
      var $230=HEAP32[(($14)>>2)];
      var $231=(($230)|0);
      var $232=$14;
      var $233=$15;
      var $234=(($231)|0);
      var $235=$234;
      var $236=(($235+8)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=$16;
      var $256 = $237;__label__ = 12; break;
    case 11: // $239
      var $240=$19;
      HEAP32[(($19)>>2)]=$201;
      var $241=HEAP32[(($19)>>2)];
      var $242=(($241)|0);
      var $243=$18;
      HEAP32[(($18)>>2)]=$242;
      var $244=HEAP32[(($18)>>2)];
      var $245=$244;
      var $246=$17;
      HEAP32[(($17)>>2)]=$245;
      var $247=HEAP32[(($17)>>2)];
      var $248=(($247)|0);
      var $249=$17;
      var $250=$18;
      var $251=(($248)|0);
      var $252=$251;
      var $253=(($252+1)|0);
      var $254=(($253)|0);
      var $255=$19;
      var $256 = $254;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv_exit
      var $256;
      var $257=$23;
      var $258=$__sz;
      var $259=(($256+$258)|0);
      $__p=$259;
      __label__ = 13; break;
    case 13: // $260
      var $261=$52;
      var $262=$53;
      var $263=(($261)|0)!=(($262)|0);
      if ($263) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $264
      var $265=$__p;
      var $266=$52;
      var $267=$24;
      var $268=$25;
      HEAP32[(($24)>>2)]=$265;
      HEAP32[(($25)>>2)]=$266;
      var $269=HEAP32[(($25)>>2)];
      var $270=HEAP8[($269)];
      var $271=HEAP32[(($24)>>2)];
      HEAP8[($271)]=$270;
      var $272=$24;
      var $273=$25;
      __label__ = 15; break;
    case 15: // $274
      var $275=$__p;
      var $276=(($275+1)|0);
      $__p=$276;
      var $277=$52;
      var $278=(($277+1)|0);
      $52=$278;
      __label__ = 13; break;
    case 16: // $279
      var $280=$__p;
      HEAP8[($54)]=0;
      var $281=$26;
      var $282=$27;
      HEAP32[(($26)>>2)]=$280;
      HEAP32[(($27)>>2)]=$54;
      var $283=HEAP32[(($27)>>2)];
      var $284=HEAP8[($283)];
      var $285=HEAP32[(($26)>>2)];
      HEAP8[($285)]=$284;
      var $286=$26;
      var $287=$27;
      var $288=$__sz;
      var $289=$__n;
      var $290=(($288+$289)|0);
      var $291=$39;
      var $292=$40;
      HEAP32[(($39)>>2)]=$55;
      HEAP32[(($40)>>2)]=$290;
      var $293=HEAPU32[(($39)>>2)];
      var $294=$38;
      HEAP32[(($38)>>2)]=$293;
      var $295=HEAP32[(($38)>>2)];
      var $296=(($295)|0);
      var $297=$37;
      HEAP32[(($37)>>2)]=$296;
      var $298=HEAP32[(($37)>>2)];
      var $299=$298;
      var $300=$36;
      HEAP32[(($36)>>2)]=$299;
      var $301=HEAP32[(($36)>>2)];
      var $302=(($301)|0);
      var $303=$36;
      var $304=$37;
      var $305=(($302)|0);
      var $306=$305;
      var $307=(($306)|0);
      var $308=$307;
      var $309=HEAPU8[($308)];
      var $310=(($309)&255);
      var $311=$310 & 1;
      var $312=(($311)|0)!=0;
      var $313=$38;
      if ($312) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $314
      var $315=HEAP32[(($40)>>2)];
      var $316=$30;
      var $317=$31;
      HEAP32[(($30)>>2)]=$293;
      HEAP32[(($31)>>2)]=$315;
      var $318=HEAP32[(($30)>>2)];
      var $319=HEAP32[(($31)>>2)];
      var $320=(($318)|0);
      var $321=$29;
      HEAP32[(($29)>>2)]=$320;
      var $322=HEAP32[(($29)>>2)];
      var $323=$322;
      var $324=$28;
      HEAP32[(($28)>>2)]=$323;
      var $325=HEAP32[(($28)>>2)];
      var $326=(($325)|0);
      var $327=$28;
      var $328=$29;
      var $329=(($326)|0);
      var $330=$329;
      var $331=(($330+4)|0);
      HEAP32[(($331)>>2)]=$319;
      var $332=$30;
      var $333=$31;
      __label__ = 19; break;
    case 18: // $334
      var $335=HEAP32[(($40)>>2)];
      var $336=$34;
      var $337=$35;
      HEAP32[(($34)>>2)]=$293;
      HEAP32[(($35)>>2)]=$335;
      var $338=HEAP32[(($34)>>2)];
      var $339=HEAP32[(($35)>>2)];
      var $340=$339 << 1;
      var $341=(($340) & 255);
      var $342=(($338)|0);
      var $343=$33;
      HEAP32[(($33)>>2)]=$342;
      var $344=HEAP32[(($33)>>2)];
      var $345=$344;
      var $346=$32;
      HEAP32[(($32)>>2)]=$345;
      var $347=HEAP32[(($32)>>2)];
      var $348=(($347)|0);
      var $349=$32;
      var $350=$33;
      var $351=(($348)|0);
      var $352=$351;
      var $353=(($352)|0);
      var $354=$353;
      HEAP8[($354)]=$341;
      var $355=$34;
      var $356=$35;
      __label__ = 19; break;
    case 19: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj_exit
      var $357=$39;
      var $358=$40;
      __label__ = 20; break;
    case 20: // $359
      STACKTOP = __stackBase__;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_["X"]=1;

function __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri($__intl, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__psn, $__nsn, $__fd) {
  var __stackBase__  = STACKTOP; STACKTOP += 176; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $26;
      var $27;
      var $28;
      var $__mp;
      var $29=__stackBase__+72;
      var $30=__stackBase__+76;
      var $31;
      var $32;
      var $33=__stackBase__+88;
      var $34=__stackBase__+100;
      var $35=__stackBase__+112;
      var $__mp1;
      var $36=__stackBase__+124;
      var $37=__stackBase__+128;
      var $38=__stackBase__+140;
      var $39=__stackBase__+152;
      var $40=__stackBase__+164;
      var $41=(($__intl)&1);
      $19=$41;
      $20=$__loc;
      $21=$__pat;
      $22=$__dp;
      $23=$__ts;
      $24=$__grp;
      $25=$__sym;
      $26=$__psn;
      $27=$__nsn;
      $28=$__fd;
      var $42=$19;
      var $43=(($42) & 1);
      if ($43) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $44
      var $45=$20;
      var $46=$18;
      HEAP32[(($18)>>2)]=$45;
      var $47=HEAP32[(($18)>>2)];
      var $48=__ZNKSt3__16locale9use_facetERNS0_2idE($47, __ZNSt3__110moneypunctIcLb1EE2idE);
      var $49=$48;
      var $50=$18;
      $__mp=$49;
      var $51=$21;
      var $52=$__mp;
      var $53=$17;
      HEAP32[(($17)>>2)]=$52;
      var $54=HEAP32[(($17)>>2)];
      var $55=$54;
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+44)|0);
      var $58=HEAP32[(($57)>>2)];
      FUNCTION_TABLE[$58]($29, $54);
      var $59=$17;
      var $60=$51;
      var $61=$29;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($60)]=HEAP8[($61)];HEAP8[($60+1)]=HEAP8[($61+1)];HEAP8[($60+2)]=HEAP8[($61+2)];HEAP8[($60+3)]=HEAP8[($61+3)];
      var $62=$27;
      var $63=$__mp;
      var $64=$16;
      HEAP32[(($16)>>2)]=$63;
      var $65=HEAP32[(($16)>>2)];
      var $66=$65;
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+32)|0);
      var $69=HEAP32[(($68)>>2)];
      FUNCTION_TABLE[$69]($30, $65);
      var $70=$16;
      var $71=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($62, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $72
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($30);
      var $73=$26;
      var $74=$__mp;
      var $75=$15;
      HEAP32[(($15)>>2)]=$74;
      var $76=HEAP32[(($15)>>2)];
      var $77=$76;
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+28)|0);
      var $80=HEAP32[(($79)>>2)];
      FUNCTION_TABLE[$80]($33, $76);
      var $81=$15;
      var $82=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($73, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $83
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($33);
      var $84=$__mp;
      var $85=$14;
      HEAP32[(($14)>>2)]=$84;
      var $86=HEAP32[(($14)>>2)];
      var $87=$86;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+12)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=FUNCTION_TABLE[$90]($86);
      var $92=$14;
      var $93=$22;
      HEAP8[($93)]=$91;
      var $94=$__mp;
      var $95=$13;
      HEAP32[(($13)>>2)]=$94;
      var $96=HEAP32[(($13)>>2)];
      var $97=$96;
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+16)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=FUNCTION_TABLE[$100]($96);
      var $102=$13;
      var $103=$23;
      HEAP8[($103)]=$101;
      var $104=$24;
      var $105=$__mp;
      var $106=$12;
      HEAP32[(($12)>>2)]=$105;
      var $107=HEAP32[(($12)>>2)];
      var $108=$107;
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      FUNCTION_TABLE[$111]($34, $107);
      var $112=$12;
      var $113=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($104, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $114
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($34);
      var $115=$25;
      var $116=$__mp;
      var $117=$11;
      HEAP32[(($11)>>2)]=$116;
      var $118=HEAP32[(($11)>>2)];
      var $119=$118;
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+24)|0);
      var $122=HEAP32[(($121)>>2)];
      FUNCTION_TABLE[$122]($35, $118);
      var $123=$11;
      var $124=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($115, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; };
    case 5: // $125
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($35);
      var $126=$__mp;
      var $127=$10;
      HEAP32[(($10)>>2)]=$126;
      var $128=HEAP32[(($10)>>2)];
      var $129=$128;
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+36)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=FUNCTION_TABLE[$132]($128);
      var $134=$10;
      var $135=$28;
      HEAP32[(($135)>>2)]=$133;
      __label__ = 27; break;
    case 6: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      $31=$138;
      var $139=$137.f1;
      $32=$139;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 29; break; }
    case 7: // $140
      __label__ = 28; break;
    case 8: // $141
      var $142=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $143=$142.f0;
      $31=$143;
      var $144=$142.f1;
      $32=$144;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 29; break; }
    case 9: // $145
      __label__ = 28; break;
    case 10: // $146
      var $147=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $148=$147.f0;
      $31=$148;
      var $149=$147.f1;
      $32=$149;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 29; break; }
    case 11: // $150
      __label__ = 28; break;
    case 12: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      $31=$153;
      var $154=$152.f1;
      $32=$154;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 29; break; }
    case 13: // $155
      __label__ = 28; break;
    case 14: // $156
      var $157=$20;
      var $158=$9;
      HEAP32[(($9)>>2)]=$157;
      var $159=HEAP32[(($9)>>2)];
      var $160=__ZNKSt3__16locale9use_facetERNS0_2idE($159, __ZNSt3__110moneypunctIcLb0EE2idE);
      var $161=$160;
      var $162=$9;
      $__mp1=$161;
      var $163=$21;
      var $164=$__mp1;
      var $165=$8;
      HEAP32[(($8)>>2)]=$164;
      var $166=HEAP32[(($8)>>2)];
      var $167=$166;
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+44)|0);
      var $170=HEAP32[(($169)>>2)];
      FUNCTION_TABLE[$170]($36, $166);
      var $171=$8;
      var $172=$163;
      var $173=$36;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($172)]=HEAP8[($173)];HEAP8[($172+1)]=HEAP8[($173+1)];HEAP8[($172+2)]=HEAP8[($173+2)];HEAP8[($172+3)]=HEAP8[($173+3)];
      var $174=$27;
      var $175=$__mp1;
      var $176=$7;
      HEAP32[(($7)>>2)]=$175;
      var $177=HEAP32[(($7)>>2)];
      var $178=$177;
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+32)|0);
      var $181=HEAP32[(($180)>>2)];
      FUNCTION_TABLE[$181]($37, $177);
      var $182=$7;
      var $183=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($174, $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; };
    case 15: // $184
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($37);
      var $185=$26;
      var $186=$__mp1;
      var $187=$6;
      HEAP32[(($6)>>2)]=$186;
      var $188=HEAP32[(($6)>>2)];
      var $189=$188;
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190+28)|0);
      var $192=HEAP32[(($191)>>2)];
      FUNCTION_TABLE[$192]($38, $188);
      var $193=$6;
      var $194=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($185, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 21; break; };
    case 16: // $195
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($38);
      var $196=$__mp1;
      var $197=$5;
      HEAP32[(($5)>>2)]=$196;
      var $198=HEAP32[(($5)>>2)];
      var $199=$198;
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+12)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=FUNCTION_TABLE[$202]($198);
      var $204=$5;
      var $205=$22;
      HEAP8[($205)]=$203;
      var $206=$__mp1;
      var $207=$4;
      HEAP32[(($4)>>2)]=$206;
      var $208=HEAP32[(($4)>>2)];
      var $209=$208;
      var $210=HEAP32[(($209)>>2)];
      var $211=(($210+16)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=FUNCTION_TABLE[$212]($208);
      var $214=$4;
      var $215=$23;
      HEAP8[($215)]=$213;
      var $216=$24;
      var $217=$__mp1;
      var $218=$3;
      HEAP32[(($3)>>2)]=$217;
      var $219=HEAP32[(($3)>>2)];
      var $220=$219;
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+20)|0);
      var $223=HEAP32[(($222)>>2)];
      FUNCTION_TABLE[$223]($39, $219);
      var $224=$3;
      var $225=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($216, $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 23; break; };
    case 17: // $226
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($39);
      var $227=$25;
      var $228=$__mp1;
      var $229=$2;
      HEAP32[(($2)>>2)]=$228;
      var $230=HEAP32[(($2)>>2)];
      var $231=$230;
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232+24)|0);
      var $234=HEAP32[(($233)>>2)];
      FUNCTION_TABLE[$234]($40, $230);
      var $235=$2;
      var $236=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($227, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 25; break; };
    case 18: // $237
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($40);
      var $238=$__mp1;
      var $239=$1;
      HEAP32[(($1)>>2)]=$238;
      var $240=HEAP32[(($1)>>2)];
      var $241=$240;
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242+36)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=FUNCTION_TABLE[$244]($240);
      var $246=$1;
      var $247=$28;
      HEAP32[(($247)>>2)]=$245;
      __label__ = 27; break;
    case 19: // $248
      var $249=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $250=$249.f0;
      $31=$250;
      var $251=$249.f1;
      $32=$251;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 29; break; }
    case 20: // $252
      __label__ = 28; break;
    case 21: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $255=$254.f0;
      $31=$255;
      var $256=$254.f1;
      $32=$256;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $257
      __label__ = 28; break;
    case 23: // $258
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $260=$259.f0;
      $31=$260;
      var $261=$259.f1;
      $32=$261;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 29; break; }
    case 24: // $262
      __label__ = 28; break;
    case 25: // $263
      var $264=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $265=$264.f0;
      $31=$265;
      var $266=$264.f1;
      $32=$266;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $267
      __label__ = 28; break;
    case 27: // $268
      STACKTOP = __stackBase__;
      return;
    case 28: // $269
      var $270=$31;
      var $271=$31;
      var $272=$32;
      var $273=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $271, tempValue);
      var $274=($273.f1 = $272, $273);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $275
      var $276=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri["X"]=1;

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SD_SC_SC_RKT1_Rjb($__b, $__e, $__kb, $__ke, $__ct, $__err, $__case_sensitive) {
  var __stackBase__  = STACKTOP; STACKTOP += 624; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      var $13=__stackBase__+44;
      var $14=__stackBase__+48;
      var $15;
      var $16=__stackBase__+52;
      var $17=__stackBase__+56;
      var $18;
      var $19=__stackBase__+60;
      var $20=__stackBase__+64;
      var $21=__stackBase__+68;
      var $22=__stackBase__+72;
      var $23=__stackBase__+76;
      var $24=__stackBase__+80;
      var $25=__stackBase__+84;
      var $26=__stackBase__+88;
      var $27=__stackBase__+92;
      var $28=__stackBase__+96;
      var $29=__stackBase__+100;
      var $30=__stackBase__+104;
      var $31=__stackBase__+108;
      var $32=__stackBase__+112;
      var $33=__stackBase__+116;
      var $34=__stackBase__+120;
      var $35=__stackBase__+124;
      var $36=__stackBase__+128;
      var $37=__stackBase__+132;
      var $38=__stackBase__+136;
      var $39=__stackBase__+140;
      var $40=__stackBase__+144;
      var $41=__stackBase__+148;
      var $42=__stackBase__+152;
      var $43=__stackBase__+156;
      var $44=__stackBase__+160;
      var $45=__stackBase__+164;
      var $46=__stackBase__+168;
      var $47=__stackBase__+172;
      var $48=__stackBase__+176;
      var $49=__stackBase__+180;
      var $50=__stackBase__+184;
      var $51;
      var $52;
      var $53=__stackBase__+188;
      var $54=__stackBase__+192;
      var $55=__stackBase__+196;
      var $56=__stackBase__+200;
      var $57=__stackBase__+204;
      var $58=__stackBase__+208;
      var $59=__stackBase__+212;
      var $60=__stackBase__+216;
      var $61=__stackBase__+220;
      var $62=__stackBase__+224;
      var $63=__stackBase__+228;
      var $64=__stackBase__+232;
      var $65=__stackBase__+236;
      var $66=__stackBase__+240;
      var $67=__stackBase__+244;
      var $68=__stackBase__+248;
      var $69=__stackBase__+252;
      var $70=__stackBase__+256;
      var $71=__stackBase__+260;
      var $72=__stackBase__+264;
      var $73=__stackBase__+268;
      var $74=__stackBase__+272;
      var $75=__stackBase__+276;
      var $76=__stackBase__+280;
      var $77=__stackBase__+284;
      var $78=__stackBase__+288;
      var $__tmp_i=__stackBase__+292;
      var $79=__stackBase__+296;
      var $80=__stackBase__+300;
      var $81=__stackBase__+304;
      var $82=__stackBase__+308;
      var $83=__stackBase__+312;
      var $84=__stackBase__+316;
      var $85=__stackBase__+320;
      var $86=__stackBase__+324;
      var $87=__stackBase__+328;
      var $88=__stackBase__+332;
      var $__tmp_i_i_i3=__stackBase__+336;
      var $89=__stackBase__+340;
      var $90=__stackBase__+344;
      var $91=__stackBase__+348;
      var $92=__stackBase__+352;
      var $93=__stackBase__+356;
      var $94=__stackBase__+360;
      var $95=__stackBase__+364;
      var $96=__stackBase__+368;
      var $97=__stackBase__+372;
      var $98=__stackBase__+376;
      var $99=__stackBase__+380;
      var $100=__stackBase__+384;
      var $101=__stackBase__+388;
      var $102=__stackBase__+392;
      var $103=__stackBase__+396;
      var $104=__stackBase__+400;
      var $105=__stackBase__+404;
      var $106=__stackBase__+408;
      var $107=__stackBase__+412;
      var $108=__stackBase__+416;
      var $109=__stackBase__+420;
      var $110=__stackBase__+424;
      var $111=__stackBase__+428;
      var $112=__stackBase__+432;
      var $113=__stackBase__+436;
      var $114=__stackBase__+440;
      var $115=__stackBase__+444;
      var $116=__stackBase__+448;
      var $117=__stackBase__+452;
      var $118=__stackBase__+456;
      var $119=__stackBase__+460;
      var $120=__stackBase__+464;
      var $121=__stackBase__+468;
      var $__tmp_i_i_i=__stackBase__+472;
      var $122=__stackBase__+476;
      var $123=__stackBase__+480;
      var $124=__stackBase__+484;
      var $125=__stackBase__+488;
      var $126=__stackBase__+492;
      var $127=__stackBase__+496;
      var $128=__stackBase__+500;
      var $129=__stackBase__+504;
      var $130=__stackBase__+508;
      var $131=__stackBase__+512;
      var $132;
      var $133;
      var $134;
      var $135;
      var $136;
      var $137;
      var $138;
      var $__nkw;
      var $__doesnt_match;
      var $__might_match;
      var $__does_match;
      var $__statbuf=__stackBase__+516;
      var $__status;
      var $__stat_hold=__stackBase__+616;
      var $139;
      var $140;
      var $__n_might_match;
      var $__n_does_match;
      var $__st;
      var $__ky;
      var $__indx;
      var $__c;
      var $__consume;
      var $__ky1;
      var $__kc;
      var $__ky2;
      var $141;
      $133=$__b;
      $134=$__kb;
      $135=$__ke;
      $136=$__ct;
      $137=$__err;
      var $142=(($__case_sensitive)&1);
      $138=$142;
      var $143=$134;
      var $144=$135;
      var $145=$128;
      var $146=$129;
      var $147=$130;
      var $148=$131;
      HEAP32[(($129)>>2)]=$143;
      HEAP32[(($130)>>2)]=$144;
      var $149=HEAP32[(($129)>>2)];
      var $150=HEAP32[(($130)>>2)];
      var $tmp_i=$128;
      var $tmp1_i=$131;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $151=$126;
      var $152=$127;
      HEAP32[(($126)>>2)]=$149;
      HEAP32[(($127)>>2)]=$150;
      var $153=HEAP32[(($127)>>2)];
      var $154=HEAP32[(($126)>>2)];
      var $155=$153;
      var $156=$154;
      var $157=(($155-$156)|0);
      var $158=(((($157)|0)/12)|0);
      var $159=$126;
      var $160=$127;
      var $161=$128;
      var $162=$129;
      var $163=$130;
      var $164=$131;
      $__nkw=$158;
      $__doesnt_match=0;
      $__might_match=1;
      $__does_match=2;
      var $165=(($__statbuf)|0);
      $__status=$165;
      var $166=$111;
      var $167=$112;
      var $168=$113;
      HEAP32[(($111)>>2)]=$__stat_hold;
      HEAP32[(($112)>>2)]=0;
      HEAP32[(($113)>>2)]=1496;
      var $169=HEAP32[(($111)>>2)];
      var $170=HEAP32[(($112)>>2)];
      var $171=HEAP32[(($113)>>2)];
      var $172=$108;
      var $173=$109;
      var $174=$110;
      HEAP32[(($108)>>2)]=$169;
      HEAP32[(($109)>>2)]=$170;
      HEAP32[(($110)>>2)]=$171;
      var $175=HEAP32[(($108)>>2)];
      var $176=(($175)|0);
      var $177=$107;
      HEAP32[(($107)>>2)]=$109;
      var $178=HEAP32[(($107)>>2)];
      var $179=$107;
      var $180=HEAP32[(($178)>>2)];
      var $181=$93;
      HEAP32[(($93)>>2)]=$110;
      var $182=HEAP32[(($93)>>2)];
      var $183=$93;
      var $184=HEAP32[(($182)>>2)];
      var $185=$104;
      var $186=$105;
      var $187=$106;
      HEAP32[(($104)>>2)]=$176;
      HEAP32[(($105)>>2)]=$180;
      HEAP32[(($106)>>2)]=$184;
      var $188=HEAP32[(($104)>>2)];
      var $189=HEAP32[(($105)>>2)];
      var $190=HEAP32[(($106)>>2)];
      var $191=$101;
      var $192=$102;
      var $193=$103;
      HEAP32[(($101)>>2)]=$188;
      HEAP32[(($102)>>2)]=$189;
      HEAP32[(($103)>>2)]=$190;
      var $194=HEAP32[(($101)>>2)];
      var $195=$194;
      var $196=$100;
      HEAP32[(($100)>>2)]=$102;
      var $197=HEAP32[(($100)>>2)];
      var $198=$100;
      var $199=HEAP32[(($197)>>2)];
      var $200=$94;
      HEAP32[(($94)>>2)]=$103;
      var $201=HEAP32[(($94)>>2)];
      var $202=$94;
      var $203=HEAP32[(($201)>>2)];
      var $204=$97;
      var $205=$98;
      var $206=$99;
      HEAP32[(($97)>>2)]=$195;
      HEAP32[(($98)>>2)]=$199;
      HEAP32[(($99)>>2)]=$203;
      var $207=HEAP32[(($97)>>2)];
      var $208=(($207)|0);
      var $209=$96;
      HEAP32[(($96)>>2)]=$98;
      var $210=HEAP32[(($96)>>2)];
      var $211=$96;
      var $212=HEAP32[(($210)>>2)];
      HEAP32[(($208)>>2)]=$212;
      var $213=(($207+4)|0);
      var $214=$95;
      HEAP32[(($95)>>2)]=$99;
      var $215=HEAP32[(($95)>>2)];
      var $216=$95;
      var $217=HEAP32[(($215)>>2)];
      HEAP32[(($213)>>2)]=$217;
      var $218=$97;
      var $219=$98;
      var $220=$99;
      var $221=$101;
      var $222=$102;
      var $223=$103;
      var $224=$104;
      var $225=$105;
      var $226=$106;
      var $227=$108;
      var $228=$109;
      var $229=$110;
      var $230=$111;
      var $231=$112;
      var $232=$113;
      var $233=$__nkw;
      var $234=(($233)>>>0) > 100;
      if ($234) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $235
      var $236=$__nkw;
      var $237=_malloc($236);
      $__status=$237;
      var $238=$__status;
      var $239=(($238)|0)==0;
      if ($239) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $240
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $241
      __label__ = 9; break;
    case 4: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $244=$243.f0;
      $139=$244;
      var $245=$243.f1;
      $140=$245;
      var $246=$92;
      HEAP32[(($92)>>2)]=$__stat_hold;
      var $247=HEAP32[(($92)>>2)];
      var $248=$91;
      HEAP32[(($91)>>2)]=$247;
      var $249=HEAP32[(($91)>>2)];
      var $250=$87;
      var $251=$88;
      var $252=$__tmp_i_i_i3;
      var $253=$89;
      var $254=$90;
      HEAP32[(($87)>>2)]=$249;
      HEAP32[(($88)>>2)]=0;
      var $255=HEAPU32[(($87)>>2)];
      var $256=(($255)|0);
      var $257=$86;
      HEAP32[(($86)>>2)]=$256;
      var $258=HEAP32[(($86)>>2)];
      var $259=$258;
      var $260=$85;
      HEAP32[(($85)>>2)]=$259;
      var $261=HEAP32[(($85)>>2)];
      var $262=(($261)|0);
      var $263=$85;
      var $264=$86;
      var $265=HEAP32[(($262)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$265;
      var $266=HEAP32[(($88)>>2)];
      var $267=(($255)|0);
      var $268=$84;
      HEAP32[(($84)>>2)]=$267;
      var $269=HEAP32[(($84)>>2)];
      var $270=$269;
      var $271=$83;
      HEAP32[(($83)>>2)]=$270;
      var $272=HEAP32[(($83)>>2)];
      var $273=(($272)|0);
      var $274=$83;
      var $275=$84;
      HEAP32[(($273)>>2)]=$266;
      var $276=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $277=(($276)|0)!=0;
      if ($277) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $278
      var $279=(($255)|0);
      var $280=$82;
      HEAP32[(($82)>>2)]=$279;
      var $281=HEAP32[(($82)>>2)];
      var $282=$281;
      var $283=$81;
      HEAP32[(($81)>>2)]=$282;
      var $284=HEAP32[(($81)>>2)];
      var $285=(($284+4)|0);
      var $286=$81;
      var $287=$82;
      var $288=HEAP32[(($285)>>2)];
      var $289=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$288]($289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $290
      __label__ = 8; break;
    case 7: // $291
      var $292=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $293=$292.f0;
      HEAP32[(($89)>>2)]=$293;
      var $294=$292.f1;
      HEAP32[(($90)>>2)]=$294;
      var $295=HEAP32[(($89)>>2)];
      ___cxa_call_unexpected($295);
      throw "Reached an unreachable!"
    case 8: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit4
      var $296=$87;
      var $297=$88;
      var $298=$__tmp_i_i_i3;
      var $299=$89;
      var $300=$90;
      var $301=$91;
      var $302=$92;
      __label__ = 106; break;
    case 9: // $303
      var $304=$__status;
      var $305=$77;
      var $306=$78;
      var $307=$__tmp_i;
      var $308=$79;
      var $309=$80;
      HEAP32[(($77)>>2)]=$__stat_hold;
      HEAP32[(($78)>>2)]=$304;
      var $310=HEAP32[(($77)>>2)];
      var $311=(($310)|0);
      var $312=$76;
      HEAP32[(($76)>>2)]=$311;
      var $313=HEAP32[(($76)>>2)];
      var $314=$313;
      var $315=$75;
      HEAP32[(($75)>>2)]=$314;
      var $316=HEAP32[(($75)>>2)];
      var $317=(($316)|0);
      var $318=$75;
      var $319=$76;
      var $320=HEAP32[(($317)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$320;
      var $321=HEAP32[(($78)>>2)];
      var $322=(($310)|0);
      var $323=$74;
      HEAP32[(($74)>>2)]=$322;
      var $324=HEAP32[(($74)>>2)];
      var $325=$324;
      var $326=$73;
      HEAP32[(($73)>>2)]=$325;
      var $327=HEAP32[(($73)>>2)];
      var $328=(($327)|0);
      var $329=$73;
      var $330=$74;
      HEAP32[(($328)>>2)]=$321;
      var $331=HEAP32[(($__tmp_i)>>2)];
      var $332=(($331)|0)!=0;
      if ($332) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $333
      var $334=(($310)|0);
      var $335=$72;
      HEAP32[(($72)>>2)]=$334;
      var $336=HEAP32[(($72)>>2)];
      var $337=$336;
      var $338=$71;
      HEAP32[(($71)>>2)]=$337;
      var $339=HEAP32[(($71)>>2)];
      var $340=(($339+4)|0);
      var $341=$71;
      var $342=$72;
      var $343=HEAP32[(($340)>>2)];
      var $344=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$343]($344) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $345
      __label__ = 13; break;
    case 12: // $346
      var $347=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $348=$347.f0;
      HEAP32[(($79)>>2)]=$348;
      var $349=$347.f1;
      HEAP32[(($80)>>2)]=$349;
      var $350=HEAP32[(($79)>>2)];
      ___cxa_call_unexpected($350);
      throw "Reached an unreachable!"
    case 13: // $_ZNSt3__110unique_ptrIhPFvPvEE5resetEPh_exit
      var $351=$77;
      var $352=$78;
      var $353=$__tmp_i;
      var $354=$79;
      var $355=$80;
      __label__ = 14; break;
    case 14: // $356
      var $357=$__nkw;
      $__n_might_match=$357;
      $__n_does_match=0;
      var $358=$__status;
      $__st=$358;
      var $359=$134;
      $__ky=$359;
      __label__ = 15; break;
    case 15: // $360
      var $361=$__ky;
      var $362=$135;
      var $363=(($361)|0)!=(($362)|0);
      if ($363) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $364
      var $365=$__ky;
      var $366=$70;
      HEAP32[(($70)>>2)]=$365;
      var $367=HEAP32[(($70)>>2)];
      var $368=$69;
      HEAP32[(($69)>>2)]=$367;
      var $369=HEAPU32[(($69)>>2)];
      var $370=$68;
      HEAP32[(($68)>>2)]=$369;
      var $371=HEAP32[(($68)>>2)];
      var $372=(($371)|0);
      var $373=$67;
      HEAP32[(($67)>>2)]=$372;
      var $374=HEAP32[(($67)>>2)];
      var $375=$374;
      var $376=$66;
      HEAP32[(($66)>>2)]=$375;
      var $377=HEAP32[(($66)>>2)];
      var $378=(($377)|0);
      var $379=$66;
      var $380=$67;
      var $381=(($378)|0);
      var $382=$381;
      var $383=(($382)|0);
      var $384=$383;
      var $385=HEAPU8[($384)];
      var $386=(($385)&255);
      var $387=$386 & 1;
      var $388=(($387)|0)!=0;
      var $389=$68;
      if ($388) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $390
      var $391=$62;
      HEAP32[(($62)>>2)]=$369;
      var $392=HEAP32[(($62)>>2)];
      var $393=(($392)|0);
      var $394=$61;
      HEAP32[(($61)>>2)]=$393;
      var $395=HEAP32[(($61)>>2)];
      var $396=$395;
      var $397=$60;
      HEAP32[(($60)>>2)]=$396;
      var $398=HEAP32[(($60)>>2)];
      var $399=(($398)|0);
      var $400=$60;
      var $401=$61;
      var $402=(($399)|0);
      var $403=$402;
      var $404=(($403+4)|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=$62;
      var $427 = $405;__label__ = 19; break;
    case 18: // $407
      var $408=$65;
      HEAP32[(($65)>>2)]=$369;
      var $409=HEAP32[(($65)>>2)];
      var $410=(($409)|0);
      var $411=$64;
      HEAP32[(($64)>>2)]=$410;
      var $412=HEAP32[(($64)>>2)];
      var $413=$412;
      var $414=$63;
      HEAP32[(($63)>>2)]=$413;
      var $415=HEAP32[(($63)>>2)];
      var $416=(($415)|0);
      var $417=$63;
      var $418=$64;
      var $419=(($416)|0);
      var $420=$419;
      var $421=(($420)|0);
      var $422=$421;
      var $423=HEAPU8[($422)];
      var $424=(($423)&255);
      var $425=$424 >> 1;
      var $426=$65;
      var $427 = $425;__label__ = 19; break;
    case 19: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $427;
      var $428=$69;
      var $429=(($427)|0)==0;
      var $430=$70;
      if ($429) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $431
      var $432=$__st;
      HEAP8[($432)]=1;
      __label__ = 22; break;
    case 21: // $433
      var $434=$__st;
      HEAP8[($434)]=2;
      var $435=$__n_might_match;
      var $436=(($435-1)|0);
      $__n_might_match=$436;
      var $437=$__n_does_match;
      var $438=(($437+1)|0);
      $__n_does_match=$438;
      __label__ = 22; break;
    case 22: // $439
      __label__ = 23; break;
    case 23: // $440
      var $441=$__ky;
      var $442=(($441+12)|0);
      $__ky=$442;
      var $443=$__st;
      var $444=(($443+1)|0);
      $__st=$444;
      __label__ = 15; break;
    case 24: // $445
      $__indx=0;
      __label__ = 25; break;
    case 25: // $446
      var $447=$133;
      var $448=$58;
      var $449=$59;
      HEAP32[(($58)>>2)]=$447;
      HEAP32[(($59)>>2)]=$__e;
      var $450=HEAP32[(($58)>>2)];
      var $451=HEAP32[(($59)>>2)];
      var $452=$56;
      var $453=$57;
      HEAP32[(($56)>>2)]=$450;
      HEAP32[(($57)>>2)]=$451;
      var $454=HEAP32[(($56)>>2)];
      var $455=(($454)|0);
      var $456=HEAP32[(($455)>>2)];
      var $457=(($456)|0)==0;
      var $458=(($457)&1);
      var $459=HEAP32[(($57)>>2)];
      var $460=(($459)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=(($461)|0)==0;
      var $463=(($462)&1);
      var $464=(($458)|0)==(($463)|0);
      var $465=$56;
      var $466=$57;
      var $467=$464 ^ 1;
      var $468=$58;
      var $469=$59;
      __label__ = 26; break;
    case 26: // $470
      if ($467) { __label__ = 27; break; } else { var $475 = 0;__label__ = 28; break; }
    case 27: // $471
      var $472=$__n_might_match;
      var $473=(($472)>>>0) > 0;
      var $475 = $473;__label__ = 28; break;
    case 28: // $474
      var $475;
      if ($475) { __label__ = 29; break; } else { __label__ = 90; break; }
    case 29: // $476
      var $477=$133;
      var $478=$55;
      HEAP32[(($55)>>2)]=$477;
      var $479=HEAP32[(($55)>>2)];
      var $480=(($479)|0);
      var $481=HEAP32[(($480)>>2)];
      var $482=$53;
      var $483=$54;
      HEAP32[(($54)>>2)]=$481;
      var $484=HEAPU32[(($54)>>2)];
      var $485=(($484+12)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=(($484+16)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=(($486)|0)==(($488)|0);
      if ($489) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $490
      var $491=$484;
      var $492=HEAP32[(($491)>>2)];
      var $493=(($492+36)|0);
      var $494=HEAP32[(($493)>>2)];
      var $495=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$494]($484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; };
    case 31: // $_noexc
      HEAP32[(($53)>>2)]=$495;
      __label__ = 33; break;
    case 32: // $496
      var $497=(($484+12)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=HEAP8[($498)];
      $52=$499;
      var $500=$52;
      var $501=(($500)&255);
      HEAP32[(($53)>>2)]=$501;
      __label__ = 33; break;
    case 33: // $_ZNKSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEdeEv_exit
      var $502=HEAP32[(($53)>>2)];
      var $503=$53;
      var $504=$54;
      var $505=(($502) & 255);
      var $506=$55;
      __label__ = 34; break;
    case 34: // $507
      $__c=$505;
      var $508=$138;
      var $509=(($508) & 1);
      if ($509) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $510
      var $511=$136;
      var $512=$__c;
      var $513=$50;
      HEAP32[(($50)>>2)]=$511;
      $51=$512;
      var $514=HEAP32[(($50)>>2)];
      var $515=$514;
      var $516=HEAP32[(($515)>>2)];
      var $517=(($516+12)|0);
      var $518=HEAP32[(($517)>>2)];
      var $519=$51;
      var $520=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$518]($514, $519) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $_ZNKSt3__15ctypeIcE7toupperEc_exit
      var $521=$50;
      __label__ = 37; break;
    case 37: // $522
      $__c=$520;
      __label__ = 38; break;
    case 38: // $523
      $__consume=0;
      var $524=$__status;
      $__st=$524;
      var $525=$134;
      $__ky1=$525;
      __label__ = 39; break;
    case 39: // $526
      var $527=$__ky1;
      var $528=$135;
      var $529=(($527)|0)!=(($528)|0);
      if ($529) { __label__ = 40; break; } else { __label__ = 60; break; }
    case 40: // $530
      var $531=$__st;
      var $532=HEAPU8[($531)];
      var $533=(($532)&255);
      var $534=(($533)|0)==1;
      if ($534) { __label__ = 41; break; } else { __label__ = 58; break; }
    case 41: // $535
      var $536=$__ky1;
      var $537=$__indx;
      var $538=$48;
      var $539=$49;
      HEAP32[(($48)>>2)]=$536;
      HEAP32[(($49)>>2)]=$537;
      var $540=HEAP32[(($48)>>2)];
      var $541=$47;
      HEAP32[(($47)>>2)]=$540;
      var $542=HEAPU32[(($47)>>2)];
      var $543=$46;
      HEAP32[(($46)>>2)]=$542;
      var $544=HEAP32[(($46)>>2)];
      var $545=(($544)|0);
      var $546=$45;
      HEAP32[(($45)>>2)]=$545;
      var $547=HEAP32[(($45)>>2)];
      var $548=$547;
      var $549=$44;
      HEAP32[(($44)>>2)]=$548;
      var $550=HEAP32[(($44)>>2)];
      var $551=(($550)|0);
      var $552=$44;
      var $553=$45;
      var $554=(($551)|0);
      var $555=$554;
      var $556=(($555)|0);
      var $557=$556;
      var $558=HEAPU8[($557)];
      var $559=(($558)&255);
      var $560=$559 & 1;
      var $561=(($560)|0)!=0;
      var $562=$46;
      if ($561) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $563
      var $564=$40;
      HEAP32[(($40)>>2)]=$542;
      var $565=HEAP32[(($40)>>2)];
      var $566=(($565)|0);
      var $567=$39;
      HEAP32[(($39)>>2)]=$566;
      var $568=HEAP32[(($39)>>2)];
      var $569=$568;
      var $570=$38;
      HEAP32[(($38)>>2)]=$569;
      var $571=HEAP32[(($38)>>2)];
      var $572=(($571)|0);
      var $573=$38;
      var $574=$39;
      var $575=(($572)|0);
      var $576=$575;
      var $577=(($576+8)|0);
      var $578=HEAP32[(($577)>>2)];
      var $579=$40;
      var $597 = $578;__label__ = 44; break;
    case 43: // $580
      var $581=$43;
      HEAP32[(($43)>>2)]=$542;
      var $582=HEAP32[(($43)>>2)];
      var $583=(($582)|0);
      var $584=$42;
      HEAP32[(($42)>>2)]=$583;
      var $585=HEAP32[(($42)>>2)];
      var $586=$585;
      var $587=$41;
      HEAP32[(($41)>>2)]=$586;
      var $588=HEAP32[(($41)>>2)];
      var $589=(($588)|0);
      var $590=$41;
      var $591=$42;
      var $592=(($589)|0);
      var $593=$592;
      var $594=(($593+1)|0);
      var $595=(($594)|0);
      var $596=$43;
      var $597 = $595;__label__ = 44; break;
    case 44: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $597;
      var $598=$47;
      var $599=HEAP32[(($49)>>2)];
      var $600=(($597+$599)|0);
      var $601=$48;
      var $602=$49;
      __label__ = 45; break;
    case 45: // $603
      var $604=HEAP8[($600)];
      $__kc=$604;
      var $605=$138;
      var $606=(($605) & 1);
      if ($606) { __label__ = 49; break; } else { __label__ = 46; break; }
    case 46: // $607
      var $608=$136;
      var $609=$__kc;
      var $610=$11;
      HEAP32[(($11)>>2)]=$608;
      $12=$609;
      var $611=HEAP32[(($11)>>2)];
      var $612=$611;
      var $613=HEAP32[(($612)>>2)];
      var $614=(($613+12)|0);
      var $615=HEAP32[(($614)>>2)];
      var $616=$12;
      var $617=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$615]($611, $616) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 4; break; };
    case 47: // $_ZNKSt3__15ctypeIcE7toupperEc_exit9
      var $618=$11;
      __label__ = 48; break;
    case 48: // $619
      $__kc=$617;
      __label__ = 49; break;
    case 49: // $620
      var $621=$__c;
      var $622=(($621 << 24) >> 24);
      var $623=$__kc;
      var $624=(($623 << 24) >> 24);
      var $625=(($622)|0)==(($624)|0);
      if ($625) { __label__ = 50; break; } else { __label__ = 56; break; }
    case 50: // $626
      $__consume=1;
      var $627=$__ky1;
      var $628=$10;
      HEAP32[(($10)>>2)]=$627;
      var $629=HEAPU32[(($10)>>2)];
      var $630=$9;
      HEAP32[(($9)>>2)]=$629;
      var $631=HEAP32[(($9)>>2)];
      var $632=(($631)|0);
      var $633=$8;
      HEAP32[(($8)>>2)]=$632;
      var $634=HEAP32[(($8)>>2)];
      var $635=$634;
      var $636=$7;
      HEAP32[(($7)>>2)]=$635;
      var $637=HEAP32[(($7)>>2)];
      var $638=(($637)|0);
      var $639=$7;
      var $640=$8;
      var $641=(($638)|0);
      var $642=$641;
      var $643=(($642)|0);
      var $644=$643;
      var $645=HEAPU8[($644)];
      var $646=(($645)&255);
      var $647=$646 & 1;
      var $648=(($647)|0)!=0;
      var $649=$9;
      if ($648) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $650
      var $651=$3;
      HEAP32[(($3)>>2)]=$629;
      var $652=HEAP32[(($3)>>2)];
      var $653=(($652)|0);
      var $654=$2;
      HEAP32[(($2)>>2)]=$653;
      var $655=HEAP32[(($2)>>2)];
      var $656=$655;
      var $657=$1;
      HEAP32[(($1)>>2)]=$656;
      var $658=HEAP32[(($1)>>2)];
      var $659=(($658)|0);
      var $660=$1;
      var $661=$2;
      var $662=(($659)|0);
      var $663=$662;
      var $664=(($663+4)|0);
      var $665=HEAP32[(($664)>>2)];
      var $666=$3;
      var $687 = $665;__label__ = 53; break;
    case 52: // $667
      var $668=$6;
      HEAP32[(($6)>>2)]=$629;
      var $669=HEAP32[(($6)>>2)];
      var $670=(($669)|0);
      var $671=$5;
      HEAP32[(($5)>>2)]=$670;
      var $672=HEAP32[(($5)>>2)];
      var $673=$672;
      var $674=$4;
      HEAP32[(($4)>>2)]=$673;
      var $675=HEAP32[(($4)>>2)];
      var $676=(($675)|0);
      var $677=$4;
      var $678=$5;
      var $679=(($676)|0);
      var $680=$679;
      var $681=(($680)|0);
      var $682=$681;
      var $683=HEAPU8[($682)];
      var $684=(($683)&255);
      var $685=$684 >> 1;
      var $686=$6;
      var $687 = $685;__label__ = 53; break;
    case 53: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit10
      var $687;
      var $688=$10;
      var $689=$__indx;
      var $690=(($689+1)|0);
      var $691=(($687)|0)==(($690)|0);
      if ($691) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $692
      var $693=$__st;
      HEAP8[($693)]=2;
      var $694=$__n_might_match;
      var $695=(($694-1)|0);
      $__n_might_match=$695;
      var $696=$__n_does_match;
      var $697=(($696+1)|0);
      $__n_does_match=$697;
      __label__ = 55; break;
    case 55: // $698
      __label__ = 57; break;
    case 56: // $699
      var $700=$__st;
      HEAP8[($700)]=0;
      var $701=$__n_might_match;
      var $702=(($701-1)|0);
      $__n_might_match=$702;
      __label__ = 57; break;
    case 57: // $703
      __label__ = 58; break;
    case 58: // $704
      __label__ = 59; break;
    case 59: // $705
      var $706=$__ky1;
      var $707=(($706+12)|0);
      $__ky1=$707;
      var $708=$__st;
      var $709=(($708+1)|0);
      $__st=$709;
      __label__ = 39; break;
    case 60: // $710
      var $711=$__consume;
      var $712=(($711) & 1);
      if ($712) { __label__ = 61; break; } else { __label__ = 88; break; }
    case 61: // $713
      var $714=$133;
      var $715=$23;
      HEAP32[(($23)>>2)]=$714;
      var $716=HEAPU32[(($23)>>2)];
      var $717=(($716)|0);
      var $718=HEAP32[(($717)>>2)];
      var $719=$21;
      var $720=$22;
      HEAP32[(($22)>>2)]=$718;
      var $721=HEAPU32[(($22)>>2)];
      var $722=$19;
      var $723=$20;
      HEAP32[(($20)>>2)]=$721;
      var $724=HEAP32[(($20)>>2)];
      var $725=(($724+12)|0);
      var $726=HEAP32[(($725)>>2)];
      var $727=(($724+16)|0);
      var $728=HEAP32[(($727)>>2)];
      var $729=(($726)|0)==(($728)|0);
      if ($729) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $730
      var $731=$724;
      var $732=HEAP32[(($731)>>2)];
      var $733=(($732+40)|0);
      var $734=HEAP32[(($733)>>2)];
      var $735=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$734]($724) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 4; break; };
    case 63: // $_noexc6
      HEAP32[(($19)>>2)]=$735;
      __label__ = 65; break;
    case 64: // $736
      var $737=(($724+12)|0);
      var $738=HEAP32[(($737)>>2)];
      var $739=(($738+1)|0);
      HEAP32[(($737)>>2)]=$739;
      var $740=HEAP8[($738)];
      $18=$740;
      var $741=$18;
      var $742=(($741)&255);
      HEAP32[(($19)>>2)]=$742;
      __label__ = 65; break;
    case 65: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv_exit_i_i
      var $743=HEAP32[(($19)>>2)];
      var $744=$19;
      var $745=$20;
      var $746=(($743)|0)==-1;
      if ($746) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $747
      HEAP32[(($21)>>2)]=-1;
      __label__ = 72; break;
    case 67: // $748
      var $749=$16;
      var $750=$17;
      HEAP32[(($17)>>2)]=$721;
      var $751=HEAPU32[(($17)>>2)];
      var $752=(($751+12)|0);
      var $753=HEAP32[(($752)>>2)];
      var $754=(($751+16)|0);
      var $755=HEAP32[(($754)>>2)];
      var $756=(($753)|0)==(($755)|0);
      if ($756) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $757
      var $758=$751;
      var $759=HEAP32[(($758)>>2)];
      var $760=(($759+36)|0);
      var $761=HEAP32[(($760)>>2)];
      var $762=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$761]($751) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 4; break; };
    case 69: // $_noexc7
      HEAP32[(($16)>>2)]=$762;
      __label__ = 71; break;
    case 70: // $763
      var $764=(($751+12)|0);
      var $765=HEAP32[(($764)>>2)];
      var $766=HEAP8[($765)];
      $15=$766;
      var $767=$15;
      var $768=(($767)&255);
      HEAP32[(($16)>>2)]=$768;
      __label__ = 71; break;
    case 71: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5sgetcEv_exit_i_i
      var $769=HEAP32[(($16)>>2)];
      var $770=$16;
      var $771=$17;
      HEAP32[(($21)>>2)]=$769;
      __label__ = 72; break;
    case 72: // $_ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6snextcEv_exit_i
      var $772=HEAP32[(($21)>>2)];
      var $773=$21;
      var $774=$22;
      var $775=$13;
      var $776=$14;
      HEAP32[(($13)>>2)]=$772;
      HEAP32[(($14)>>2)]=-1;
      var $777=HEAP32[(($13)>>2)];
      var $778=HEAP32[(($14)>>2)];
      var $779=(($777)|0)==(($778)|0);
      var $780=$13;
      var $781=$14;
      if ($779) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $782
      var $783=(($716)|0);
      HEAP32[(($783)>>2)]=0;
      __label__ = 74; break;
    case 74: // $_ZNSt3__119istreambuf_iteratorIcNS_11char_traitsIcEEEppEv_exit
      var $784=$23;
      __label__ = 75; break;
    case 75: // $785
      var $786=$__n_might_match;
      var $787=$__n_does_match;
      var $788=(($786+$787)|0);
      var $789=(($788)>>>0) > 1;
      if ($789) { __label__ = 76; break; } else { __label__ = 87; break; }
    case 76: // $790
      var $791=$__status;
      $__st=$791;
      var $792=$134;
      $__ky2=$792;
      __label__ = 77; break;
    case 77: // $793
      var $794=$__ky2;
      var $795=$135;
      var $796=(($794)|0)!=(($795)|0);
      if ($796) { __label__ = 78; break; } else { __label__ = 86; break; }
    case 78: // $797
      var $798=$__st;
      var $799=HEAPU8[($798)];
      var $800=(($799)&255);
      var $801=(($800)|0)==2;
      if ($801) { __label__ = 79; break; } else { __label__ = 84; break; }
    case 79: // $802
      var $803=$__ky2;
      var $804=$33;
      HEAP32[(($33)>>2)]=$803;
      var $805=HEAPU32[(($33)>>2)];
      var $806=$32;
      HEAP32[(($32)>>2)]=$805;
      var $807=HEAP32[(($32)>>2)];
      var $808=(($807)|0);
      var $809=$31;
      HEAP32[(($31)>>2)]=$808;
      var $810=HEAP32[(($31)>>2)];
      var $811=$810;
      var $812=$30;
      HEAP32[(($30)>>2)]=$811;
      var $813=HEAP32[(($30)>>2)];
      var $814=(($813)|0);
      var $815=$30;
      var $816=$31;
      var $817=(($814)|0);
      var $818=$817;
      var $819=(($818)|0);
      var $820=$819;
      var $821=HEAPU8[($820)];
      var $822=(($821)&255);
      var $823=$822 & 1;
      var $824=(($823)|0)!=0;
      var $825=$32;
      if ($824) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $826
      var $827=$26;
      HEAP32[(($26)>>2)]=$805;
      var $828=HEAP32[(($26)>>2)];
      var $829=(($828)|0);
      var $830=$25;
      HEAP32[(($25)>>2)]=$829;
      var $831=HEAP32[(($25)>>2)];
      var $832=$831;
      var $833=$24;
      HEAP32[(($24)>>2)]=$832;
      var $834=HEAP32[(($24)>>2)];
      var $835=(($834)|0);
      var $836=$24;
      var $837=$25;
      var $838=(($835)|0);
      var $839=$838;
      var $840=(($839+4)|0);
      var $841=HEAP32[(($840)>>2)];
      var $842=$26;
      var $863 = $841;__label__ = 82; break;
    case 81: // $843
      var $844=$29;
      HEAP32[(($29)>>2)]=$805;
      var $845=HEAP32[(($29)>>2)];
      var $846=(($845)|0);
      var $847=$28;
      HEAP32[(($28)>>2)]=$846;
      var $848=HEAP32[(($28)>>2)];
      var $849=$848;
      var $850=$27;
      HEAP32[(($27)>>2)]=$849;
      var $851=HEAP32[(($27)>>2)];
      var $852=(($851)|0);
      var $853=$27;
      var $854=$28;
      var $855=(($852)|0);
      var $856=$855;
      var $857=(($856)|0);
      var $858=$857;
      var $859=HEAPU8[($858)];
      var $860=(($859)&255);
      var $861=$860 >> 1;
      var $862=$29;
      var $863 = $861;__label__ = 82; break;
    case 82: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $863;
      var $864=$33;
      var $865=$__indx;
      var $866=(($865+1)|0);
      var $867=(($863)|0)!=(($866)|0);
      if ($867) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $868
      var $869=$__st;
      HEAP8[($869)]=0;
      var $870=$__n_does_match;
      var $871=(($870-1)|0);
      $__n_does_match=$871;
      __label__ = 84; break;
    case 84: // $872
      __label__ = 85; break;
    case 85: // $873
      var $874=$__ky2;
      var $875=(($874+12)|0);
      $__ky2=$875;
      var $876=$__st;
      var $877=(($876+1)|0);
      $__st=$877;
      __label__ = 77; break;
    case 86: // $878
      __label__ = 87; break;
    case 87: // $879
      __label__ = 88; break;
    case 88: // $880
      __label__ = 89; break;
    case 89: // $881
      var $882=$__indx;
      var $883=(($882+1)|0);
      $__indx=$883;
      __label__ = 25; break;
    case 90: // $884
      var $885=$133;
      var $886=$36;
      var $887=$37;
      HEAP32[(($36)>>2)]=$885;
      HEAP32[(($37)>>2)]=$__e;
      var $888=HEAP32[(($36)>>2)];
      var $889=HEAP32[(($37)>>2)];
      var $890=$34;
      var $891=$35;
      HEAP32[(($34)>>2)]=$888;
      HEAP32[(($35)>>2)]=$889;
      var $892=HEAP32[(($34)>>2)];
      var $893=(($892)|0);
      var $894=HEAP32[(($893)>>2)];
      var $895=(($894)|0)==0;
      var $896=(($895)&1);
      var $897=HEAP32[(($35)>>2)];
      var $898=(($897)|0);
      var $899=HEAP32[(($898)>>2)];
      var $900=(($899)|0)==0;
      var $901=(($900)&1);
      var $902=(($896)|0)==(($901)|0);
      var $903=$34;
      var $904=$35;
      var $905=$36;
      var $906=$37;
      __label__ = 91; break;
    case 91: // $907
      if ($902) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $908
      var $909=$137;
      var $910=HEAP32[(($909)>>2)];
      var $911=$910 | 2;
      HEAP32[(($909)>>2)]=$911;
      __label__ = 93; break;
    case 93: // $912
      var $913=$__status;
      $__st=$913;
      __label__ = 94; break;
    case 94: // $914
      var $915=$134;
      var $916=$135;
      var $917=(($915)|0)!=(($916)|0);
      if ($917) { __label__ = 95; break; } else { __label__ = 99; break; }
    case 95: // $918
      var $919=$__st;
      var $920=HEAPU8[($919)];
      var $921=(($920)&255);
      var $922=(($921)|0)==2;
      if ($922) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $923
      __label__ = 99; break;
    case 97: // $924
      __label__ = 98; break;
    case 98: // $925
      var $926=$134;
      var $927=(($926+12)|0);
      $134=$927;
      var $928=$__st;
      var $929=(($928+1)|0);
      $__st=$929;
      __label__ = 94; break;
    case 99: // $930
      var $931=$134;
      var $932=$135;
      var $933=(($931)|0)==(($932)|0);
      if ($933) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $934
      var $935=$137;
      var $936=HEAP32[(($935)>>2)];
      var $937=$936 | 4;
      HEAP32[(($935)>>2)]=$937;
      __label__ = 101; break;
    case 101: // $938
      var $939=$134;
      $132=$939;
      $141=1;
      var $940=$125;
      HEAP32[(($125)>>2)]=$__stat_hold;
      var $941=HEAP32[(($125)>>2)];
      var $942=$124;
      HEAP32[(($124)>>2)]=$941;
      var $943=HEAP32[(($124)>>2)];
      var $944=$120;
      var $945=$121;
      var $946=$__tmp_i_i_i;
      var $947=$122;
      var $948=$123;
      HEAP32[(($120)>>2)]=$943;
      HEAP32[(($121)>>2)]=0;
      var $949=HEAP32[(($120)>>2)];
      var $950=(($949)|0);
      var $951=$119;
      HEAP32[(($119)>>2)]=$950;
      var $952=HEAP32[(($119)>>2)];
      var $953=$952;
      var $954=$118;
      HEAP32[(($118)>>2)]=$953;
      var $955=HEAP32[(($118)>>2)];
      var $956=(($955)|0);
      var $957=$118;
      var $958=$119;
      var $959=HEAP32[(($956)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$959;
      var $960=HEAP32[(($121)>>2)];
      var $961=(($949)|0);
      var $962=$117;
      HEAP32[(($117)>>2)]=$961;
      var $963=HEAP32[(($117)>>2)];
      var $964=$963;
      var $965=$116;
      HEAP32[(($116)>>2)]=$964;
      var $966=HEAP32[(($116)>>2)];
      var $967=(($966)|0);
      var $968=$116;
      var $969=$117;
      HEAP32[(($967)>>2)]=$960;
      var $970=HEAP32[(($__tmp_i_i_i)>>2)];
      var $971=(($970)|0)!=0;
      if ($971) { __label__ = 102; break; } else { __label__ = 105; break; }
    case 102: // $972
      var $973=(($949)|0);
      var $974=$115;
      HEAP32[(($115)>>2)]=$973;
      var $975=HEAP32[(($115)>>2)];
      var $976=$975;
      var $977=$114;
      HEAP32[(($114)>>2)]=$976;
      var $978=HEAP32[(($114)>>2)];
      var $979=(($978+4)|0);
      var $980=$114;
      var $981=$115;
      var $982=HEAP32[(($979)>>2)];
      var $983=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$982]($983) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $984
      __label__ = 105; break;
    case 104: // $985
      var $986=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $987=$986.f0;
      HEAP32[(($122)>>2)]=$987;
      var $988=$986.f1;
      HEAP32[(($123)>>2)]=$988;
      var $989=HEAP32[(($122)>>2)];
      ___cxa_call_unexpected($989);
      throw "Reached an unreachable!"
    case 105: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit
      var $990=$120;
      var $991=$121;
      var $992=$__tmp_i_i_i;
      var $993=$122;
      var $994=$123;
      var $995=$124;
      var $996=$125;
      var $997=$132;
      STACKTOP = __stackBase__;
      return $997;
    case 106: // $998
      __label__ = 107; break;
    case 107: // $999
      var $1000=$139;
      var $1001=$139;
      var $1002=$140;
      var $1003=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1001, tempValue);
      var $1004=($1003.f1 = $1002, $1003);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $1006=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SD_SC_SC_RKT1_Rjb["X"]=1;
// WARNING: content after a branch in a label, line: 872499
// WARNING: content after a branch in a label, line: 872501
// WARNING: content after a branch in a label, line: 872502
// WARNING: content after a branch in a label, line: 872503
// WARNING: content after a branch in a label, line: 872504
// WARNING: content after a branch in a label, line: 872505
// WARNING: content after a branch in a label, line: 872507
// WARNING: content after a branch in a label, line: 872508
// WARNING: content after a branch in a label, line: 872509
// WARNING: content after a branch in a label, line: 872511
// WARNING: content after a branch in a label, line: 872512
// WARNING: content after a branch in a label, line: 872513
// WARNING: content after a branch in a label, line: 872515
// WARNING: content after a branch in a label, line: 872517
// WARNING: content after a branch in a label, line: 872519
// WARNING: content after a branch in a label, line: 872521
// WARNING: content after a branch in a label, line: 872523
// WARNING: content after a branch in a label, line: 872524
// WARNING: content after a branch in a label, line: 872525
// WARNING: content after a branch in a label, line: 872526
// WARNING: content after a branch in a label, line: 872527
// WARNING: content after a branch in a label, line: 872529
// WARNING: content after a branch in a label, line: 872530
// WARNING: content after a branch in a label, line: 872531
// WARNING: content after a branch in a label, line: 872532
// WARNING: content after a branch in a label, line: 872534
// WARNING: content after a branch in a label, line: 872535
// WARNING: content after a branch in a label, line: 872536
// WARNING: content after a branch in a label, line: 872537
// WARNING: content after a branch in a label, line: 872539
// WARNING: content after a branch in a label, line: 872541
// WARNING: content after a branch in a label, line: 872542
// WARNING: content after a branch in a label, line: 872543
// WARNING: content after a branch in a label, line: 872544
// WARNING: content after a branch in a label, line: 872545
// WARNING: content after a branch in a label, line: 872547
// WARNING: content after a branch in a label, line: 872548
// WARNING: content after a branch in a label, line: 872549
// WARNING: content after a branch in a label, line: 872550
// WARNING: content after a branch in a label, line: 872552
// WARNING: content after a branch in a label, line: 872553
// WARNING: content after a branch in a label, line: 872554
// WARNING: content after a branch in a label, line: 872555
// WARNING: content after a branch in a label, line: 872557
// WARNING: content after a branch in a label, line: 872559
// WARNING: content after a branch in a label, line: 872560
// WARNING: content after a branch in a label, line: 872561
// WARNING: content after a branch in a label, line: 872562

function __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__b, $__n, $__e) {
  var __stackBase__  = STACKTOP; STACKTOP += 624; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i_i_i=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $__u1_i=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $__tmp_i_i=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $__t_i_i=__stackBase__+204;
      var $49=__stackBase__+208;
      var $50=__stackBase__+212;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55=__stackBase__+232;
      var $56=__stackBase__+236;
      var $57=__stackBase__+240;
      var $58=__stackBase__+244;
      var $59=__stackBase__+248;
      var $60=__stackBase__+252;
      var $61=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $__tmp_i_i_i5=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $__t_i=__stackBase__+388;
      var $93=__stackBase__+392;
      var $94=__stackBase__+396;
      var $95=__stackBase__+400;
      var $96=__stackBase__+404;
      var $97=__stackBase__+408;
      var $98=__stackBase__+412;
      var $99=__stackBase__+416;
      var $100=__stackBase__+420;
      var $101=__stackBase__+424;
      var $102=__stackBase__+428;
      var $103=__stackBase__+432;
      var $__tmp_i_i_i3=__stackBase__+436;
      var $104=__stackBase__+440;
      var $105=__stackBase__+444;
      var $106=__stackBase__+448;
      var $107=__stackBase__+452;
      var $108=__stackBase__+456;
      var $109=__stackBase__+460;
      var $110=__stackBase__+464;
      var $111=__stackBase__+468;
      var $112=__stackBase__+472;
      var $113=__stackBase__+476;
      var $114=__stackBase__+480;
      var $115=__stackBase__+484;
      var $116=__stackBase__+488;
      var $117=__stackBase__+492;
      var $118=__stackBase__+496;
      var $119;
      var $120;
      var $121;
      var $122;
      var $123=__stackBase__+500;
      var $124=__stackBase__+504;
      var $__tmp_i_i_i1=__stackBase__+508;
      var $125=__stackBase__+512;
      var $126=__stackBase__+516;
      var $127=__stackBase__+520;
      var $128=__stackBase__+524;
      var $129=__stackBase__+528;
      var $130=__stackBase__+532;
      var $131=__stackBase__+536;
      var $132=__stackBase__+540;
      var $133=__stackBase__+544;
      var $134=__stackBase__+548;
      var $135=__stackBase__+552;
      var $136=__stackBase__+556;
      var $137=__stackBase__+560;
      var $138=__stackBase__+564;
      var $139=__stackBase__+568;
      var $__tmp_i_i_i=__stackBase__+572;
      var $140=__stackBase__+576;
      var $141=__stackBase__+580;
      var $142=__stackBase__+584;
      var $143=__stackBase__+588;
      var $144=__stackBase__+592;
      var $145=__stackBase__+596;
      var $146=__stackBase__+600;
      var $147;
      var $148;
      var $149;
      var $__owns;
      var $__cur_cap;
      var $__new_cap;
      var $__n_off;
      var $__t;
      var $150=__stackBase__+604;
      var $151=__stackBase__+612;
      var $152=__stackBase__+616;
      var $153;
      var $154;
      $147=$__b;
      $148=$__n;
      $149=$__e;
      var $155=$147;
      var $156=$146;
      HEAP32[(($146)>>2)]=$155;
      var $157=HEAP32[(($146)>>2)];
      var $158=(($157)|0);
      var $159=$145;
      HEAP32[(($145)>>2)]=$158;
      var $160=HEAP32[(($145)>>2)];
      var $161=$160;
      var $162=$144;
      HEAP32[(($144)>>2)]=$161;
      var $163=HEAP32[(($144)>>2)];
      var $164=(($163+4)|0);
      var $165=$144;
      var $166=$145;
      var $167=$146;
      var $168=HEAP32[(($164)>>2)];
      var $169=(($168)|0)!=1682;
      var $170=(($169)&1);
      $__owns=$170;
      var $171=$149;
      var $172=HEAP32[(($171)>>2)];
      var $173=$147;
      var $174=$131;
      HEAP32[(($131)>>2)]=$173;
      var $175=HEAP32[(($131)>>2)];
      var $176=(($175)|0);
      var $177=$130;
      HEAP32[(($130)>>2)]=$176;
      var $178=HEAP32[(($130)>>2)];
      var $179=$178;
      var $180=$129;
      HEAP32[(($129)>>2)]=$179;
      var $181=HEAP32[(($129)>>2)];
      var $182=(($181)|0);
      var $183=$129;
      var $184=$130;
      var $185=HEAP32[(($182)>>2)];
      var $186=$131;
      var $187=$172;
      var $188=$185;
      var $189=(($187-$188)|0);
      var $190=(($189)|0);
      $__cur_cap=$190;
      var $191=$__cur_cap;
      var $192=Math.floor(2147483647.5);
      var $193=(($191)>>>0) < (($192)>>>0);
      if ($193) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $194
      var $195=$__cur_cap;
      var $196=((($195<<1))|0);
      var $199 = $196;__label__ = 3; break;
    case 2: // $197
      var $199 = -1;__label__ = 3; break;
    case 3: // $198
      var $199;
      $__new_cap=$199;
      var $200=$148;
      var $201=HEAP32[(($200)>>2)];
      var $202=$147;
      var $203=$116;
      HEAP32[(($116)>>2)]=$202;
      var $204=HEAP32[(($116)>>2)];
      var $205=(($204)|0);
      var $206=$115;
      HEAP32[(($115)>>2)]=$205;
      var $207=HEAP32[(($115)>>2)];
      var $208=$207;
      var $209=$114;
      HEAP32[(($114)>>2)]=$208;
      var $210=HEAP32[(($114)>>2)];
      var $211=(($210)|0);
      var $212=$114;
      var $213=$115;
      var $214=HEAP32[(($211)>>2)];
      var $215=$116;
      var $216=$201;
      var $217=$214;
      var $218=(($216-$217)|0);
      $__n_off=$218;
      var $219=$__owns;
      var $220=(($219) & 1);
      if ($220) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $221
      var $222=$147;
      var $223=$95;
      HEAP32[(($95)>>2)]=$222;
      var $224=HEAP32[(($95)>>2)];
      var $225=(($224)|0);
      var $226=$94;
      HEAP32[(($94)>>2)]=$225;
      var $227=HEAP32[(($94)>>2)];
      var $228=$227;
      var $229=$93;
      HEAP32[(($93)>>2)]=$228;
      var $230=HEAP32[(($93)>>2)];
      var $231=(($230)|0);
      var $232=$93;
      var $233=$94;
      var $234=HEAP32[(($231)>>2)];
      var $235=$95;
      var $238 = $234;__label__ = 6; break;
    case 5: // $236
      var $238 = 0;__label__ = 6; break;
    case 6: // $237
      var $238;
      var $239=$__new_cap;
      var $240=_realloc($238, $239);
      $__t=$240;
      var $241=$__t;
      var $242=(($241)|0)==0;
      if ($242) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $243
      __ZSt17__throw_bad_allocv();
      __label__ = 8; break;
    case 8: // $244
      var $245=$__owns;
      var $246=(($245) & 1);
      if ($246) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $247
      var $248=$147;
      var $249=$92;
      var $250=$__t_i;
      HEAP32[(($92)>>2)]=$248;
      var $251=HEAP32[(($92)>>2)];
      var $252=(($251)|0);
      var $253=$91;
      HEAP32[(($91)>>2)]=$252;
      var $254=HEAP32[(($91)>>2)];
      var $255=$254;
      var $256=$90;
      HEAP32[(($90)>>2)]=$255;
      var $257=HEAP32[(($90)>>2)];
      var $258=(($257)|0);
      var $259=$90;
      var $260=$91;
      var $261=HEAP32[(($258)>>2)];
      HEAP32[(($__t_i)>>2)]=$261;
      var $262=(($251)|0);
      var $263=$89;
      HEAP32[(($89)>>2)]=$262;
      var $264=HEAP32[(($89)>>2)];
      var $265=$264;
      var $266=$88;
      HEAP32[(($88)>>2)]=$265;
      var $267=HEAP32[(($88)>>2)];
      var $268=(($267)|0);
      var $269=$88;
      var $270=$89;
      HEAP32[(($268)>>2)]=0;
      var $271=HEAP32[(($__t_i)>>2)];
      var $272=$92;
      var $273=$__t_i;
      __label__ = 10; break;
    case 10: // $274
      var $275=$147;
      var $276=$__t;
      var $277=$73;
      var $278=$74;
      var $279=$75;
      HEAP32[(($73)>>2)]=$152;
      HEAP32[(($74)>>2)]=$276;
      HEAP32[(($75)>>2)]=1496;
      var $280=HEAP32[(($73)>>2)];
      var $281=HEAP32[(($74)>>2)];
      var $282=HEAP32[(($75)>>2)];
      var $283=$70;
      var $284=$71;
      var $285=$72;
      HEAP32[(($70)>>2)]=$280;
      HEAP32[(($71)>>2)]=$281;
      HEAP32[(($72)>>2)]=$282;
      var $286=HEAP32[(($70)>>2)];
      var $287=(($286)|0);
      var $288=$69;
      HEAP32[(($69)>>2)]=$71;
      var $289=HEAP32[(($69)>>2)];
      var $290=$69;
      var $291=HEAP32[(($289)>>2)];
      var $292=$55;
      HEAP32[(($55)>>2)]=$72;
      var $293=HEAP32[(($55)>>2)];
      var $294=$55;
      var $295=HEAP32[(($293)>>2)];
      var $296=$66;
      var $297=$67;
      var $298=$68;
      HEAP32[(($66)>>2)]=$287;
      HEAP32[(($67)>>2)]=$291;
      HEAP32[(($68)>>2)]=$295;
      var $299=HEAP32[(($66)>>2)];
      var $300=HEAP32[(($67)>>2)];
      var $301=HEAP32[(($68)>>2)];
      var $302=$63;
      var $303=$64;
      var $304=$65;
      HEAP32[(($63)>>2)]=$299;
      HEAP32[(($64)>>2)]=$300;
      HEAP32[(($65)>>2)]=$301;
      var $305=HEAP32[(($63)>>2)];
      var $306=$305;
      var $307=$62;
      HEAP32[(($62)>>2)]=$64;
      var $308=HEAP32[(($62)>>2)];
      var $309=$62;
      var $310=HEAP32[(($308)>>2)];
      var $311=$56;
      HEAP32[(($56)>>2)]=$65;
      var $312=HEAP32[(($56)>>2)];
      var $313=$56;
      var $314=HEAP32[(($312)>>2)];
      var $315=$59;
      var $316=$60;
      var $317=$61;
      HEAP32[(($59)>>2)]=$306;
      HEAP32[(($60)>>2)]=$310;
      HEAP32[(($61)>>2)]=$314;
      var $318=HEAP32[(($59)>>2)];
      var $319=(($318)|0);
      var $320=$58;
      HEAP32[(($58)>>2)]=$60;
      var $321=HEAP32[(($58)>>2)];
      var $322=$58;
      var $323=HEAP32[(($321)>>2)];
      HEAP32[(($319)>>2)]=$323;
      var $324=(($318+4)|0);
      var $325=$57;
      HEAP32[(($57)>>2)]=$61;
      var $326=HEAP32[(($57)>>2)];
      var $327=$57;
      var $328=HEAP32[(($326)>>2)];
      HEAP32[(($324)>>2)]=$328;
      var $329=$59;
      var $330=$60;
      var $331=$61;
      var $332=$63;
      var $333=$64;
      var $334=$65;
      var $335=$66;
      var $336=$67;
      var $337=$68;
      var $338=$70;
      var $339=$71;
      var $340=$72;
      var $341=$73;
      var $342=$74;
      var $343=$75;
      var $344=$54;
      HEAP32[(($54)>>2)]=$152;
      var $345=HEAP32[(($54)>>2)];
      var $346=$52;
      var $347=$53;
      HEAP32[(($52)>>2)]=$151;
      HEAP32[(($53)>>2)]=$345;
      var $348=HEAP32[(($52)>>2)];
      var $349=HEAP32[(($53)>>2)];
      var $350=$50;
      var $351=$51;
      HEAP32[(($50)>>2)]=$348;
      HEAP32[(($51)>>2)]=$349;
      var $352=HEAP32[(($50)>>2)];
      var $353=(($352)|0);
      var $354=HEAP32[(($51)>>2)];
      HEAP32[(($353)>>2)]=$354;
      var $355=$50;
      var $356=$51;
      var $357=$52;
      var $358=$53;
      var $359=$54;
      __label__ = 11; break;
    case 11: // $360
      var $tmp=$27;
      var $tmp7=$151;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp7)];HEAP8[($tmp+1)]=HEAP8[($tmp7+1)];HEAP8[($tmp+2)]=HEAP8[($tmp7+2)];HEAP8[($tmp+3)]=HEAP8[($tmp7+3)];
      var $361=$__u1_i;
      var $362=$26;
      HEAP32[(($26)>>2)]=$150;
      var $363=HEAP32[(($26)>>2)];
      var $tmp_i=$__u1_i;
      var $tmp2_i=$27;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];
      var $364=$25;
      HEAP32[(($25)>>2)]=$363;
      var $365=HEAP32[(($25)>>2)];
      var $366=(($365)|0);
      var $367=$24;
      HEAP32[(($24)>>2)]=$__u1_i;
      var $368=HEAP32[(($24)>>2)];
      var $369=(($368)|0);
      var $370=HEAP32[(($369)>>2)];
      var $371=$24;
      var $372=$5;
      var $373=$__t_i_i_i;
      HEAP32[(($5)>>2)]=$370;
      var $374=HEAP32[(($5)>>2)];
      var $375=(($374)|0);
      var $376=$4;
      HEAP32[(($4)>>2)]=$375;
      var $377=HEAP32[(($4)>>2)];
      var $378=$377;
      var $379=$3;
      HEAP32[(($3)>>2)]=$378;
      var $380=HEAP32[(($3)>>2)];
      var $381=(($380)|0);
      var $382=$3;
      var $383=$4;
      var $384=HEAP32[(($381)>>2)];
      HEAP32[(($__t_i_i_i)>>2)]=$384;
      var $385=(($374)|0);
      var $386=$2;
      HEAP32[(($2)>>2)]=$385;
      var $387=HEAP32[(($2)>>2)];
      var $388=$387;
      var $389=$1;
      HEAP32[(($1)>>2)]=$388;
      var $390=HEAP32[(($1)>>2)];
      var $391=(($390)|0);
      var $392=$1;
      var $393=$2;
      HEAP32[(($391)>>2)]=0;
      var $394=HEAP32[(($__t_i_i_i)>>2)];
      var $395=$5;
      var $396=$__t_i_i_i;
      var $397=$6;
      HEAP32[(($6)>>2)]=$__u1_i;
      var $398=HEAP32[(($6)>>2)];
      var $399=(($398)|0);
      var $400=HEAP32[(($399)>>2)];
      var $401=$6;
      var $402=$9;
      HEAP32[(($9)>>2)]=$400;
      var $403=HEAP32[(($9)>>2)];
      var $404=(($403)|0);
      var $405=$8;
      HEAP32[(($8)>>2)]=$404;
      var $406=HEAP32[(($8)>>2)];
      var $407=$406;
      var $408=$7;
      HEAP32[(($7)>>2)]=$407;
      var $409=HEAP32[(($7)>>2)];
      var $410=(($409+4)|0);
      var $411=$7;
      var $412=$8;
      var $413=$9;
      var $414=$10;
      HEAP32[(($10)>>2)]=$410;
      var $415=HEAP32[(($10)>>2)];
      var $416=$10;
      var $417=HEAP32[(($415)>>2)];
      var $418=$21;
      var $419=$22;
      var $420=$23;
      HEAP32[(($21)>>2)]=$366;
      HEAP32[(($22)>>2)]=$394;
      HEAP32[(($23)>>2)]=$417;
      var $421=HEAP32[(($21)>>2)];
      var $422=HEAP32[(($22)>>2)];
      var $423=HEAP32[(($23)>>2)];
      var $424=$18;
      var $425=$19;
      var $426=$20;
      HEAP32[(($18)>>2)]=$421;
      HEAP32[(($19)>>2)]=$422;
      HEAP32[(($20)>>2)]=$423;
      var $427=HEAP32[(($18)>>2)];
      var $428=$427;
      var $429=$17;
      HEAP32[(($17)>>2)]=$19;
      var $430=HEAP32[(($17)>>2)];
      var $431=$17;
      var $432=HEAP32[(($430)>>2)];
      var $433=$11;
      HEAP32[(($11)>>2)]=$20;
      var $434=HEAP32[(($11)>>2)];
      var $435=$11;
      var $436=HEAP32[(($434)>>2)];
      var $437=$14;
      var $438=$15;
      var $439=$16;
      HEAP32[(($14)>>2)]=$428;
      HEAP32[(($15)>>2)]=$432;
      HEAP32[(($16)>>2)]=$436;
      var $440=HEAP32[(($14)>>2)];
      var $441=(($440)|0);
      var $442=$13;
      HEAP32[(($13)>>2)]=$15;
      var $443=HEAP32[(($13)>>2)];
      var $444=$13;
      var $445=HEAP32[(($443)>>2)];
      HEAP32[(($441)>>2)]=$445;
      var $446=(($440+4)|0);
      var $447=$12;
      HEAP32[(($12)>>2)]=$16;
      var $448=HEAP32[(($12)>>2)];
      var $449=$12;
      var $450=HEAP32[(($448)>>2)];
      HEAP32[(($446)>>2)]=$450;
      var $451=$14;
      var $452=$15;
      var $453=$16;
      var $454=$18;
      var $455=$19;
      var $456=$20;
      var $457=$21;
      var $458=$22;
      var $459=$23;
      var $460=$25;
      var $461=$__u1_i;
      var $462=$26;
      __label__ = 12; break;
    case 12: // $463
      var $464=$49;
      HEAP32[(($49)>>2)]=$275;
      var $465=HEAP32[(($49)>>2)];
      var $466=$48;
      var $467=$__t_i_i;
      HEAP32[(($48)>>2)]=$150;
      var $468=HEAP32[(($48)>>2)];
      var $469=(($468)|0);
      var $470=$47;
      HEAP32[(($47)>>2)]=$469;
      var $471=HEAP32[(($47)>>2)];
      var $472=$471;
      var $473=$46;
      HEAP32[(($46)>>2)]=$472;
      var $474=HEAP32[(($46)>>2)];
      var $475=(($474)|0);
      var $476=$46;
      var $477=$47;
      var $478=HEAP32[(($475)>>2)];
      HEAP32[(($__t_i_i)>>2)]=$478;
      var $479=(($468)|0);
      var $480=$45;
      HEAP32[(($45)>>2)]=$479;
      var $481=HEAP32[(($45)>>2)];
      var $482=$481;
      var $483=$44;
      HEAP32[(($44)>>2)]=$482;
      var $484=HEAP32[(($44)>>2)];
      var $485=(($484)|0);
      var $486=$44;
      var $487=$45;
      HEAP32[(($485)>>2)]=0;
      var $488=HEAP32[(($__t_i_i)>>2)];
      var $489=$48;
      var $490=$__t_i_i;
      var $491=$34;
      var $492=$35;
      var $493=$__tmp_i_i;
      var $494=$36;
      var $495=$37;
      HEAP32[(($34)>>2)]=$465;
      HEAP32[(($35)>>2)]=$488;
      var $496=HEAP32[(($34)>>2)];
      var $497=(($496)|0);
      var $498=$33;
      HEAP32[(($33)>>2)]=$497;
      var $499=HEAP32[(($33)>>2)];
      var $500=$499;
      var $501=$32;
      HEAP32[(($32)>>2)]=$500;
      var $502=HEAP32[(($32)>>2)];
      var $503=(($502)|0);
      var $504=$32;
      var $505=$33;
      var $506=HEAP32[(($503)>>2)];
      HEAP32[(($__tmp_i_i)>>2)]=$506;
      var $507=HEAP32[(($35)>>2)];
      var $508=(($496)|0);
      var $509=$31;
      HEAP32[(($31)>>2)]=$508;
      var $510=HEAP32[(($31)>>2)];
      var $511=$510;
      var $512=$30;
      HEAP32[(($30)>>2)]=$511;
      var $513=HEAP32[(($30)>>2)];
      var $514=(($513)|0);
      var $515=$30;
      var $516=$31;
      HEAP32[(($514)>>2)]=$507;
      var $517=HEAP32[(($__tmp_i_i)>>2)];
      var $518=(($517)|0)!=0;
      if ($518) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $519
      var $520=(($496)|0);
      var $521=$29;
      HEAP32[(($29)>>2)]=$520;
      var $522=HEAP32[(($29)>>2)];
      var $523=$522;
      var $524=$28;
      HEAP32[(($28)>>2)]=$523;
      var $525=HEAP32[(($28)>>2)];
      var $526=(($525+4)|0);
      var $527=$28;
      var $528=$29;
      var $529=HEAP32[(($526)>>2)];
      var $530=HEAP32[(($__tmp_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$529]($530) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $531
      __label__ = 16; break;
    case 15: // $532
      var $533=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $534=$533.f0;
      HEAP32[(($36)>>2)]=$534;
      var $535=$533.f1;
      HEAP32[(($37)>>2)]=$535;
      var $536=HEAP32[(($36)>>2)];
      ___cxa_call_unexpected($536);
      throw "Reached an unreachable!"
    case 16: // $_ZNSt3__110unique_ptrIcPFvPvEEaSIcS3_EERS4_NS0_IT_T0_EE_exit
      var $537=$34;
      var $538=$35;
      var $539=$__tmp_i_i;
      var $540=$36;
      var $541=$37;
      var $542=$40;
      HEAP32[(($40)>>2)]=$150;
      var $543=HEAP32[(($40)>>2)];
      var $544=(($543)|0);
      var $545=$39;
      HEAP32[(($39)>>2)]=$544;
      var $546=HEAP32[(($39)>>2)];
      var $547=$546;
      var $548=$38;
      HEAP32[(($38)>>2)]=$547;
      var $549=HEAP32[(($38)>>2)];
      var $550=(($549+4)|0);
      var $551=$38;
      var $552=$39;
      var $553=$40;
      var $554=$41;
      HEAP32[(($41)>>2)]=$550;
      var $555=HEAP32[(($41)>>2)];
      var $556=$41;
      var $557=HEAP32[(($555)>>2)];
      var $558=(($465)|0);
      var $559=$43;
      HEAP32[(($43)>>2)]=$558;
      var $560=HEAP32[(($43)>>2)];
      var $561=$560;
      var $562=$42;
      HEAP32[(($42)>>2)]=$561;
      var $563=HEAP32[(($42)>>2)];
      var $564=(($563+4)|0);
      var $565=$42;
      var $566=$43;
      HEAP32[(($564)>>2)]=$557;
      var $567=$49;
      __label__ = 17; break;
    case 17: // $568
      var $569=$87;
      HEAP32[(($87)>>2)]=$150;
      var $570=HEAP32[(($87)>>2)];
      var $571=$86;
      HEAP32[(($86)>>2)]=$570;
      var $572=HEAP32[(($86)>>2)];
      var $573=$82;
      var $574=$83;
      var $575=$__tmp_i_i_i5;
      var $576=$84;
      var $577=$85;
      HEAP32[(($82)>>2)]=$572;
      HEAP32[(($83)>>2)]=0;
      var $578=HEAP32[(($82)>>2)];
      var $579=(($578)|0);
      var $580=$81;
      HEAP32[(($81)>>2)]=$579;
      var $581=HEAP32[(($81)>>2)];
      var $582=$581;
      var $583=$80;
      HEAP32[(($80)>>2)]=$582;
      var $584=HEAP32[(($80)>>2)];
      var $585=(($584)|0);
      var $586=$80;
      var $587=$81;
      var $588=HEAP32[(($585)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$588;
      var $589=HEAP32[(($83)>>2)];
      var $590=(($578)|0);
      var $591=$79;
      HEAP32[(($79)>>2)]=$590;
      var $592=HEAP32[(($79)>>2)];
      var $593=$592;
      var $594=$78;
      HEAP32[(($78)>>2)]=$593;
      var $595=HEAP32[(($78)>>2)];
      var $596=(($595)|0);
      var $597=$78;
      var $598=$79;
      HEAP32[(($596)>>2)]=$589;
      var $599=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $600=(($599)|0)!=0;
      if ($600) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $601
      var $602=(($578)|0);
      var $603=$77;
      HEAP32[(($77)>>2)]=$602;
      var $604=HEAP32[(($77)>>2)];
      var $605=$604;
      var $606=$76;
      HEAP32[(($76)>>2)]=$605;
      var $607=HEAP32[(($76)>>2)];
      var $608=(($607+4)|0);
      var $609=$76;
      var $610=$77;
      var $611=HEAP32[(($608)>>2)];
      var $612=HEAP32[(($__tmp_i_i_i5)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$611]($612) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $613
      __label__ = 21; break;
    case 20: // $614
      var $615=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $616=$615.f0;
      HEAP32[(($84)>>2)]=$616;
      var $617=$615.f1;
      HEAP32[(($85)>>2)]=$617;
      var $618=HEAP32[(($84)>>2)];
      ___cxa_call_unexpected($618);
      throw "Reached an unreachable!"
    case 21: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit6
      var $619=$82;
      var $620=$83;
      var $621=$__tmp_i_i_i5;
      var $622=$84;
      var $623=$85;
      var $624=$86;
      var $625=$87;
      __label__ = 22; break;
    case 22: // $626
      var $627=$107;
      HEAP32[(($107)>>2)]=$152;
      var $628=HEAP32[(($107)>>2)];
      var $629=$106;
      HEAP32[(($106)>>2)]=$628;
      var $630=HEAP32[(($106)>>2)];
      var $631=$102;
      var $632=$103;
      var $633=$__tmp_i_i_i3;
      var $634=$104;
      var $635=$105;
      HEAP32[(($102)>>2)]=$630;
      HEAP32[(($103)>>2)]=0;
      var $636=HEAP32[(($102)>>2)];
      var $637=(($636)|0);
      var $638=$101;
      HEAP32[(($101)>>2)]=$637;
      var $639=HEAP32[(($101)>>2)];
      var $640=$639;
      var $641=$100;
      HEAP32[(($100)>>2)]=$640;
      var $642=HEAP32[(($100)>>2)];
      var $643=(($642)|0);
      var $644=$100;
      var $645=$101;
      var $646=HEAP32[(($643)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$646;
      var $647=HEAP32[(($103)>>2)];
      var $648=(($636)|0);
      var $649=$99;
      HEAP32[(($99)>>2)]=$648;
      var $650=HEAP32[(($99)>>2)];
      var $651=$650;
      var $652=$98;
      HEAP32[(($98)>>2)]=$651;
      var $653=HEAP32[(($98)>>2)];
      var $654=(($653)|0);
      var $655=$98;
      var $656=$99;
      HEAP32[(($654)>>2)]=$647;
      var $657=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $658=(($657)|0)!=0;
      if ($658) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $659
      var $660=(($636)|0);
      var $661=$97;
      HEAP32[(($97)>>2)]=$660;
      var $662=HEAP32[(($97)>>2)];
      var $663=$662;
      var $664=$96;
      HEAP32[(($96)>>2)]=$663;
      var $665=HEAP32[(($96)>>2)];
      var $666=(($665+4)|0);
      var $667=$96;
      var $668=$97;
      var $669=HEAP32[(($666)>>2)];
      var $670=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$669]($670) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $671
      __label__ = 26; break;
    case 25: // $672
      var $673=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $674=$673.f0;
      HEAP32[(($104)>>2)]=$674;
      var $675=$673.f1;
      HEAP32[(($105)>>2)]=$675;
      var $676=HEAP32[(($104)>>2)];
      ___cxa_call_unexpected($676);
      throw "Reached an unreachable!"
    case 26: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit4
      var $677=$102;
      var $678=$103;
      var $679=$__tmp_i_i_i3;
      var $680=$104;
      var $681=$105;
      var $682=$106;
      var $683=$107;
      var $684=$__new_cap;
      var $685=Math.floor((($684)>>>0));
      $__new_cap=$685;
      var $686=$147;
      var $687=$110;
      HEAP32[(($110)>>2)]=$686;
      var $688=HEAP32[(($110)>>2)];
      var $689=(($688)|0);
      var $690=$109;
      HEAP32[(($109)>>2)]=$689;
      var $691=HEAP32[(($109)>>2)];
      var $692=$691;
      var $693=$108;
      HEAP32[(($108)>>2)]=$692;
      var $694=HEAP32[(($108)>>2)];
      var $695=(($694)|0);
      var $696=$108;
      var $697=$109;
      var $698=HEAP32[(($695)>>2)];
      var $699=$110;
      var $700=$__n_off;
      var $701=(($698+$700)|0);
      var $702=$148;
      HEAP32[(($702)>>2)]=$701;
      var $703=$147;
      var $704=$113;
      HEAP32[(($113)>>2)]=$703;
      var $705=HEAP32[(($113)>>2)];
      var $706=(($705)|0);
      var $707=$112;
      HEAP32[(($112)>>2)]=$706;
      var $708=HEAP32[(($112)>>2)];
      var $709=$708;
      var $710=$111;
      HEAP32[(($111)>>2)]=$709;
      var $711=HEAP32[(($111)>>2)];
      var $712=(($711)|0);
      var $713=$111;
      var $714=$112;
      var $715=HEAP32[(($712)>>2)];
      var $716=$113;
      var $717=$__new_cap;
      var $718=(($715+$717)|0);
      var $719=$149;
      HEAP32[(($719)>>2)]=$718;
      STACKTOP = __stackBase__;
      return;
      var $721=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $722=$721.f0;
      $153=$722;
      var $723=$721.f1;
      $154=$723;
      __label__ = 32; break;
    case 27: // $760
      var $761=(($737)|0);
      var $762=$118;
      HEAP32[(($118)>>2)]=$761;
      var $763=HEAP32[(($118)>>2)];
      var $764=$763;
      var $765=$117;
      HEAP32[(($117)>>2)]=$764;
      var $766=HEAP32[(($117)>>2)];
      var $767=(($766+4)|0);
      var $768=$117;
      var $769=$118;
      var $770=HEAP32[(($767)>>2)];
      var $771=HEAP32[(($__tmp_i_i_i1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$770]($771) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $772
      __label__ = 30; break;
    case 29: // $773
      var $774=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $775=$774.f0;
      HEAP32[(($125)>>2)]=$775;
      var $776=$774.f1;
      HEAP32[(($126)>>2)]=$776;
      var $777=HEAP32[(($125)>>2)];
      ___cxa_call_unexpected($777);
      throw "Reached an unreachable!"
    case 30: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit2
      var $778=$123;
      var $779=$124;
      var $780=$__tmp_i_i_i1;
      var $781=$125;
      var $782=$126;
      var $783=$127;
      var $784=$128;
      __label__ = 31; break;
    case 31: // $785
      __label__ = 32; break;
    case 32: // $786
      var $787=$143;
      HEAP32[(($143)>>2)]=$152;
      var $788=HEAP32[(($143)>>2)];
      var $789=$142;
      HEAP32[(($142)>>2)]=$788;
      var $790=HEAP32[(($142)>>2)];
      var $791=$138;
      var $792=$139;
      var $793=$__tmp_i_i_i;
      var $794=$140;
      var $795=$141;
      HEAP32[(($138)>>2)]=$790;
      HEAP32[(($139)>>2)]=0;
      var $796=HEAP32[(($138)>>2)];
      var $797=(($796)|0);
      var $798=$137;
      HEAP32[(($137)>>2)]=$797;
      var $799=HEAP32[(($137)>>2)];
      var $800=$799;
      var $801=$136;
      HEAP32[(($136)>>2)]=$800;
      var $802=HEAP32[(($136)>>2)];
      var $803=(($802)|0);
      var $804=$136;
      var $805=$137;
      var $806=HEAP32[(($803)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$806;
      var $807=HEAP32[(($139)>>2)];
      var $808=(($796)|0);
      var $809=$135;
      HEAP32[(($135)>>2)]=$808;
      var $810=HEAP32[(($135)>>2)];
      var $811=$810;
      var $812=$134;
      HEAP32[(($134)>>2)]=$811;
      var $813=HEAP32[(($134)>>2)];
      var $814=(($813)|0);
      var $815=$134;
      var $816=$135;
      HEAP32[(($814)>>2)]=$807;
      var $817=HEAP32[(($__tmp_i_i_i)>>2)];
      var $818=(($817)|0)!=0;
      if ($818) { __label__ = 33; break; } else { __label__ = 36; break; }
    case 33: // $819
      var $820=(($796)|0);
      var $821=$133;
      HEAP32[(($133)>>2)]=$820;
      var $822=HEAP32[(($133)>>2)];
      var $823=$822;
      var $824=$132;
      HEAP32[(($132)>>2)]=$823;
      var $825=HEAP32[(($132)>>2)];
      var $826=(($825+4)|0);
      var $827=$132;
      var $828=$133;
      var $829=HEAP32[(($826)>>2)];
      var $830=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$829]($830) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $831
      __label__ = 36; break;
    case 35: // $832
      var $833=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $834=$833.f0;
      HEAP32[(($140)>>2)]=$834;
      var $835=$833.f1;
      HEAP32[(($141)>>2)]=$835;
      var $836=HEAP32[(($140)>>2)];
      ___cxa_call_unexpected($836);
      throw "Reached an unreachable!"
    case 36: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $837=$138;
      var $838=$139;
      var $839=$__tmp_i_i_i;
      var $840=$140;
      var $841=$141;
      var $842=$142;
      var $843=$143;
      __label__ = 37; break;
    case 37: // $844
      __label__ = 38; break;
    case 38: // $845
      var $846=$153;
      var $847=$153;
      var $848=$154;
      var $849=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $847, tempValue);
      var $850=($849.f1 = $848, $849);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $852=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_["X"]=1;
// WARNING: content after a branch in a label, line: 873978
// WARNING: content after a branch in a label, line: 873980
// WARNING: content after a branch in a label, line: 873981
// WARNING: content after a branch in a label, line: 873982
// WARNING: content after a branch in a label, line: 873983
// WARNING: content after a branch in a label, line: 873984
// WARNING: content after a branch in a label, line: 873986
// WARNING: content after a branch in a label, line: 873987
// WARNING: content after a branch in a label, line: 873988
// WARNING: content after a branch in a label, line: 873990
// WARNING: content after a branch in a label, line: 873991
// WARNING: content after a branch in a label, line: 873992
// WARNING: content after a branch in a label, line: 873994
// WARNING: content after a branch in a label, line: 873996
// WARNING: content after a branch in a label, line: 873998
// WARNING: content after a branch in a label, line: 874000
// WARNING: content after a branch in a label, line: 874002
// WARNING: content after a branch in a label, line: 874003
// WARNING: content after a branch in a label, line: 874004
// WARNING: content after a branch in a label, line: 874005
// WARNING: content after a branch in a label, line: 874006
// WARNING: content after a branch in a label, line: 874008
// WARNING: content after a branch in a label, line: 874009
// WARNING: content after a branch in a label, line: 874010
// WARNING: content after a branch in a label, line: 874011
// WARNING: content after a branch in a label, line: 874013
// WARNING: content after a branch in a label, line: 874014
// WARNING: content after a branch in a label, line: 874015
// WARNING: content after a branch in a label, line: 874016
// WARNING: content after a branch in a label, line: 874018
// WARNING: content after a branch in a label, line: 874020
// WARNING: content after a branch in a label, line: 874021
// WARNING: content after a branch in a label, line: 874022
// WARNING: content after a branch in a label, line: 874023
// WARNING: content after a branch in a label, line: 874024
// WARNING: content after a branch in a label, line: 874026
// WARNING: content after a branch in a label, line: 874027
// WARNING: content after a branch in a label, line: 874028
// WARNING: content after a branch in a label, line: 874029
// WARNING: content after a branch in a label, line: 874031
// WARNING: content after a branch in a label, line: 874032
// WARNING: content after a branch in a label, line: 874033
// WARNING: content after a branch in a label, line: 874034
// WARNING: content after a branch in a label, line: 874036
// WARNING: content after a branch in a label, line: 874038
// WARNING: content after a branch in a label, line: 874039
// WARNING: content after a branch in a label, line: 874040
// WARNING: content after a branch in a label, line: 874041

function __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__b, $__n, $__e) {
  var __stackBase__  = STACKTOP; STACKTOP += 624; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i_i_i=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $__u1_i=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $__tmp_i_i=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $__t_i_i=__stackBase__+204;
      var $49=__stackBase__+208;
      var $50=__stackBase__+212;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55=__stackBase__+232;
      var $56=__stackBase__+236;
      var $57=__stackBase__+240;
      var $58=__stackBase__+244;
      var $59=__stackBase__+248;
      var $60=__stackBase__+252;
      var $61=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $__tmp_i_i_i5=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $__t_i=__stackBase__+388;
      var $93=__stackBase__+392;
      var $94=__stackBase__+396;
      var $95=__stackBase__+400;
      var $96=__stackBase__+404;
      var $97=__stackBase__+408;
      var $98=__stackBase__+412;
      var $99=__stackBase__+416;
      var $100=__stackBase__+420;
      var $101=__stackBase__+424;
      var $102=__stackBase__+428;
      var $103=__stackBase__+432;
      var $__tmp_i_i_i3=__stackBase__+436;
      var $104=__stackBase__+440;
      var $105=__stackBase__+444;
      var $106=__stackBase__+448;
      var $107=__stackBase__+452;
      var $108=__stackBase__+456;
      var $109=__stackBase__+460;
      var $110=__stackBase__+464;
      var $111=__stackBase__+468;
      var $112=__stackBase__+472;
      var $113=__stackBase__+476;
      var $114=__stackBase__+480;
      var $115=__stackBase__+484;
      var $116=__stackBase__+488;
      var $117=__stackBase__+492;
      var $118=__stackBase__+496;
      var $119;
      var $120;
      var $121;
      var $122;
      var $123=__stackBase__+500;
      var $124=__stackBase__+504;
      var $__tmp_i_i_i1=__stackBase__+508;
      var $125=__stackBase__+512;
      var $126=__stackBase__+516;
      var $127=__stackBase__+520;
      var $128=__stackBase__+524;
      var $129=__stackBase__+528;
      var $130=__stackBase__+532;
      var $131=__stackBase__+536;
      var $132=__stackBase__+540;
      var $133=__stackBase__+544;
      var $134=__stackBase__+548;
      var $135=__stackBase__+552;
      var $136=__stackBase__+556;
      var $137=__stackBase__+560;
      var $138=__stackBase__+564;
      var $139=__stackBase__+568;
      var $__tmp_i_i_i=__stackBase__+572;
      var $140=__stackBase__+576;
      var $141=__stackBase__+580;
      var $142=__stackBase__+584;
      var $143=__stackBase__+588;
      var $144=__stackBase__+592;
      var $145=__stackBase__+596;
      var $146=__stackBase__+600;
      var $147;
      var $148;
      var $149;
      var $__owns;
      var $__cur_cap;
      var $__new_cap;
      var $__n_off;
      var $__t;
      var $150=__stackBase__+604;
      var $151=__stackBase__+612;
      var $152=__stackBase__+616;
      var $153;
      var $154;
      $147=$__b;
      $148=$__n;
      $149=$__e;
      var $155=$147;
      var $156=$146;
      HEAP32[(($146)>>2)]=$155;
      var $157=HEAP32[(($146)>>2)];
      var $158=(($157)|0);
      var $159=$145;
      HEAP32[(($145)>>2)]=$158;
      var $160=HEAP32[(($145)>>2)];
      var $161=$160;
      var $162=$144;
      HEAP32[(($144)>>2)]=$161;
      var $163=HEAP32[(($144)>>2)];
      var $164=(($163+4)|0);
      var $165=$144;
      var $166=$145;
      var $167=$146;
      var $168=HEAP32[(($164)>>2)];
      var $169=(($168)|0)!=1682;
      var $170=(($169)&1);
      $__owns=$170;
      var $171=$149;
      var $172=HEAP32[(($171)>>2)];
      var $173=$147;
      var $174=$131;
      HEAP32[(($131)>>2)]=$173;
      var $175=HEAP32[(($131)>>2)];
      var $176=(($175)|0);
      var $177=$130;
      HEAP32[(($130)>>2)]=$176;
      var $178=HEAP32[(($130)>>2)];
      var $179=$178;
      var $180=$129;
      HEAP32[(($129)>>2)]=$179;
      var $181=HEAP32[(($129)>>2)];
      var $182=(($181)|0);
      var $183=$129;
      var $184=$130;
      var $185=HEAP32[(($182)>>2)];
      var $186=$131;
      var $187=$172;
      var $188=$185;
      var $189=(($187-$188)|0);
      var $190=(((($189)|0)/4)|0);
      var $191=((($190<<2))|0);
      $__cur_cap=$191;
      var $192=$__cur_cap;
      var $193=Math.floor(2147483647.5);
      var $194=(($192)>>>0) < (($193)>>>0);
      if ($194) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $195
      var $196=$__cur_cap;
      var $197=((($196<<1))|0);
      var $200 = $197;__label__ = 3; break;
    case 2: // $198
      var $200 = -1;__label__ = 3; break;
    case 3: // $199
      var $200;
      $__new_cap=$200;
      var $201=$148;
      var $202=HEAP32[(($201)>>2)];
      var $203=$147;
      var $204=$116;
      HEAP32[(($116)>>2)]=$203;
      var $205=HEAP32[(($116)>>2)];
      var $206=(($205)|0);
      var $207=$115;
      HEAP32[(($115)>>2)]=$206;
      var $208=HEAP32[(($115)>>2)];
      var $209=$208;
      var $210=$114;
      HEAP32[(($114)>>2)]=$209;
      var $211=HEAP32[(($114)>>2)];
      var $212=(($211)|0);
      var $213=$114;
      var $214=$115;
      var $215=HEAP32[(($212)>>2)];
      var $216=$116;
      var $217=$202;
      var $218=$215;
      var $219=(($217-$218)|0);
      var $220=(((($219)|0)/4)|0);
      $__n_off=$220;
      var $221=$__owns;
      var $222=(($221) & 1);
      if ($222) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $223
      var $224=$147;
      var $225=$95;
      HEAP32[(($95)>>2)]=$224;
      var $226=HEAP32[(($95)>>2)];
      var $227=(($226)|0);
      var $228=$94;
      HEAP32[(($94)>>2)]=$227;
      var $229=HEAP32[(($94)>>2)];
      var $230=$229;
      var $231=$93;
      HEAP32[(($93)>>2)]=$230;
      var $232=HEAP32[(($93)>>2)];
      var $233=(($232)|0);
      var $234=$93;
      var $235=$94;
      var $236=HEAP32[(($233)>>2)];
      var $237=$95;
      var $240 = $236;__label__ = 6; break;
    case 5: // $238
      var $240 = 0;__label__ = 6; break;
    case 6: // $239
      var $240;
      var $241=$240;
      var $242=$__new_cap;
      var $243=_realloc($241, $242);
      var $244=$243;
      $__t=$244;
      var $245=$__t;
      var $246=(($245)|0)==0;
      if ($246) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $247
      __ZSt17__throw_bad_allocv();
      __label__ = 8; break;
    case 8: // $248
      var $249=$__owns;
      var $250=(($249) & 1);
      if ($250) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $251
      var $252=$147;
      var $253=$92;
      var $254=$__t_i;
      HEAP32[(($92)>>2)]=$252;
      var $255=HEAP32[(($92)>>2)];
      var $256=(($255)|0);
      var $257=$91;
      HEAP32[(($91)>>2)]=$256;
      var $258=HEAP32[(($91)>>2)];
      var $259=$258;
      var $260=$90;
      HEAP32[(($90)>>2)]=$259;
      var $261=HEAP32[(($90)>>2)];
      var $262=(($261)|0);
      var $263=$90;
      var $264=$91;
      var $265=HEAP32[(($262)>>2)];
      HEAP32[(($__t_i)>>2)]=$265;
      var $266=(($255)|0);
      var $267=$89;
      HEAP32[(($89)>>2)]=$266;
      var $268=HEAP32[(($89)>>2)];
      var $269=$268;
      var $270=$88;
      HEAP32[(($88)>>2)]=$269;
      var $271=HEAP32[(($88)>>2)];
      var $272=(($271)|0);
      var $273=$88;
      var $274=$89;
      HEAP32[(($272)>>2)]=0;
      var $275=HEAP32[(($__t_i)>>2)];
      var $276=$92;
      var $277=$__t_i;
      __label__ = 10; break;
    case 10: // $278
      var $279=$147;
      var $280=$__t;
      var $281=$73;
      var $282=$74;
      var $283=$75;
      HEAP32[(($73)>>2)]=$152;
      HEAP32[(($74)>>2)]=$280;
      HEAP32[(($75)>>2)]=1496;
      var $284=HEAP32[(($73)>>2)];
      var $285=HEAP32[(($74)>>2)];
      var $286=HEAP32[(($75)>>2)];
      var $287=$70;
      var $288=$71;
      var $289=$72;
      HEAP32[(($70)>>2)]=$284;
      HEAP32[(($71)>>2)]=$285;
      HEAP32[(($72)>>2)]=$286;
      var $290=HEAP32[(($70)>>2)];
      var $291=(($290)|0);
      var $292=$69;
      HEAP32[(($69)>>2)]=$71;
      var $293=HEAP32[(($69)>>2)];
      var $294=$69;
      var $295=HEAP32[(($293)>>2)];
      var $296=$55;
      HEAP32[(($55)>>2)]=$72;
      var $297=HEAP32[(($55)>>2)];
      var $298=$55;
      var $299=HEAP32[(($297)>>2)];
      var $300=$66;
      var $301=$67;
      var $302=$68;
      HEAP32[(($66)>>2)]=$291;
      HEAP32[(($67)>>2)]=$295;
      HEAP32[(($68)>>2)]=$299;
      var $303=HEAP32[(($66)>>2)];
      var $304=HEAP32[(($67)>>2)];
      var $305=HEAP32[(($68)>>2)];
      var $306=$63;
      var $307=$64;
      var $308=$65;
      HEAP32[(($63)>>2)]=$303;
      HEAP32[(($64)>>2)]=$304;
      HEAP32[(($65)>>2)]=$305;
      var $309=HEAP32[(($63)>>2)];
      var $310=$309;
      var $311=$62;
      HEAP32[(($62)>>2)]=$64;
      var $312=HEAP32[(($62)>>2)];
      var $313=$62;
      var $314=HEAP32[(($312)>>2)];
      var $315=$56;
      HEAP32[(($56)>>2)]=$65;
      var $316=HEAP32[(($56)>>2)];
      var $317=$56;
      var $318=HEAP32[(($316)>>2)];
      var $319=$59;
      var $320=$60;
      var $321=$61;
      HEAP32[(($59)>>2)]=$310;
      HEAP32[(($60)>>2)]=$314;
      HEAP32[(($61)>>2)]=$318;
      var $322=HEAP32[(($59)>>2)];
      var $323=(($322)|0);
      var $324=$58;
      HEAP32[(($58)>>2)]=$60;
      var $325=HEAP32[(($58)>>2)];
      var $326=$58;
      var $327=HEAP32[(($325)>>2)];
      HEAP32[(($323)>>2)]=$327;
      var $328=(($322+4)|0);
      var $329=$57;
      HEAP32[(($57)>>2)]=$61;
      var $330=HEAP32[(($57)>>2)];
      var $331=$57;
      var $332=HEAP32[(($330)>>2)];
      HEAP32[(($328)>>2)]=$332;
      var $333=$59;
      var $334=$60;
      var $335=$61;
      var $336=$63;
      var $337=$64;
      var $338=$65;
      var $339=$66;
      var $340=$67;
      var $341=$68;
      var $342=$70;
      var $343=$71;
      var $344=$72;
      var $345=$73;
      var $346=$74;
      var $347=$75;
      var $348=$54;
      HEAP32[(($54)>>2)]=$152;
      var $349=HEAP32[(($54)>>2)];
      var $350=$52;
      var $351=$53;
      HEAP32[(($52)>>2)]=$151;
      HEAP32[(($53)>>2)]=$349;
      var $352=HEAP32[(($52)>>2)];
      var $353=HEAP32[(($53)>>2)];
      var $354=$50;
      var $355=$51;
      HEAP32[(($50)>>2)]=$352;
      HEAP32[(($51)>>2)]=$353;
      var $356=HEAP32[(($50)>>2)];
      var $357=(($356)|0);
      var $358=HEAP32[(($51)>>2)];
      HEAP32[(($357)>>2)]=$358;
      var $359=$50;
      var $360=$51;
      var $361=$52;
      var $362=$53;
      var $363=$54;
      __label__ = 11; break;
    case 11: // $364
      var $tmp=$27;
      var $tmp7=$151;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp7)];HEAP8[($tmp+1)]=HEAP8[($tmp7+1)];HEAP8[($tmp+2)]=HEAP8[($tmp7+2)];HEAP8[($tmp+3)]=HEAP8[($tmp7+3)];
      var $365=$__u1_i;
      var $366=$26;
      HEAP32[(($26)>>2)]=$150;
      var $367=HEAP32[(($26)>>2)];
      var $tmp_i=$__u1_i;
      var $tmp2_i=$27;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];
      var $368=$25;
      HEAP32[(($25)>>2)]=$367;
      var $369=HEAP32[(($25)>>2)];
      var $370=(($369)|0);
      var $371=$24;
      HEAP32[(($24)>>2)]=$__u1_i;
      var $372=HEAP32[(($24)>>2)];
      var $373=(($372)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=$24;
      var $376=$5;
      var $377=$__t_i_i_i;
      HEAP32[(($5)>>2)]=$374;
      var $378=HEAP32[(($5)>>2)];
      var $379=(($378)|0);
      var $380=$4;
      HEAP32[(($4)>>2)]=$379;
      var $381=HEAP32[(($4)>>2)];
      var $382=$381;
      var $383=$3;
      HEAP32[(($3)>>2)]=$382;
      var $384=HEAP32[(($3)>>2)];
      var $385=(($384)|0);
      var $386=$3;
      var $387=$4;
      var $388=HEAP32[(($385)>>2)];
      HEAP32[(($__t_i_i_i)>>2)]=$388;
      var $389=(($378)|0);
      var $390=$2;
      HEAP32[(($2)>>2)]=$389;
      var $391=HEAP32[(($2)>>2)];
      var $392=$391;
      var $393=$1;
      HEAP32[(($1)>>2)]=$392;
      var $394=HEAP32[(($1)>>2)];
      var $395=(($394)|0);
      var $396=$1;
      var $397=$2;
      HEAP32[(($395)>>2)]=0;
      var $398=HEAP32[(($__t_i_i_i)>>2)];
      var $399=$5;
      var $400=$__t_i_i_i;
      var $401=$6;
      HEAP32[(($6)>>2)]=$__u1_i;
      var $402=HEAP32[(($6)>>2)];
      var $403=(($402)|0);
      var $404=HEAP32[(($403)>>2)];
      var $405=$6;
      var $406=$9;
      HEAP32[(($9)>>2)]=$404;
      var $407=HEAP32[(($9)>>2)];
      var $408=(($407)|0);
      var $409=$8;
      HEAP32[(($8)>>2)]=$408;
      var $410=HEAP32[(($8)>>2)];
      var $411=$410;
      var $412=$7;
      HEAP32[(($7)>>2)]=$411;
      var $413=HEAP32[(($7)>>2)];
      var $414=(($413+4)|0);
      var $415=$7;
      var $416=$8;
      var $417=$9;
      var $418=$10;
      HEAP32[(($10)>>2)]=$414;
      var $419=HEAP32[(($10)>>2)];
      var $420=$10;
      var $421=HEAP32[(($419)>>2)];
      var $422=$21;
      var $423=$22;
      var $424=$23;
      HEAP32[(($21)>>2)]=$370;
      HEAP32[(($22)>>2)]=$398;
      HEAP32[(($23)>>2)]=$421;
      var $425=HEAP32[(($21)>>2)];
      var $426=HEAP32[(($22)>>2)];
      var $427=HEAP32[(($23)>>2)];
      var $428=$18;
      var $429=$19;
      var $430=$20;
      HEAP32[(($18)>>2)]=$425;
      HEAP32[(($19)>>2)]=$426;
      HEAP32[(($20)>>2)]=$427;
      var $431=HEAP32[(($18)>>2)];
      var $432=$431;
      var $433=$17;
      HEAP32[(($17)>>2)]=$19;
      var $434=HEAP32[(($17)>>2)];
      var $435=$17;
      var $436=HEAP32[(($434)>>2)];
      var $437=$11;
      HEAP32[(($11)>>2)]=$20;
      var $438=HEAP32[(($11)>>2)];
      var $439=$11;
      var $440=HEAP32[(($438)>>2)];
      var $441=$14;
      var $442=$15;
      var $443=$16;
      HEAP32[(($14)>>2)]=$432;
      HEAP32[(($15)>>2)]=$436;
      HEAP32[(($16)>>2)]=$440;
      var $444=HEAP32[(($14)>>2)];
      var $445=(($444)|0);
      var $446=$13;
      HEAP32[(($13)>>2)]=$15;
      var $447=HEAP32[(($13)>>2)];
      var $448=$13;
      var $449=HEAP32[(($447)>>2)];
      HEAP32[(($445)>>2)]=$449;
      var $450=(($444+4)|0);
      var $451=$12;
      HEAP32[(($12)>>2)]=$16;
      var $452=HEAP32[(($12)>>2)];
      var $453=$12;
      var $454=HEAP32[(($452)>>2)];
      HEAP32[(($450)>>2)]=$454;
      var $455=$14;
      var $456=$15;
      var $457=$16;
      var $458=$18;
      var $459=$19;
      var $460=$20;
      var $461=$21;
      var $462=$22;
      var $463=$23;
      var $464=$25;
      var $465=$__u1_i;
      var $466=$26;
      __label__ = 12; break;
    case 12: // $467
      var $468=$49;
      HEAP32[(($49)>>2)]=$279;
      var $469=HEAP32[(($49)>>2)];
      var $470=$48;
      var $471=$__t_i_i;
      HEAP32[(($48)>>2)]=$150;
      var $472=HEAP32[(($48)>>2)];
      var $473=(($472)|0);
      var $474=$47;
      HEAP32[(($47)>>2)]=$473;
      var $475=HEAP32[(($47)>>2)];
      var $476=$475;
      var $477=$46;
      HEAP32[(($46)>>2)]=$476;
      var $478=HEAP32[(($46)>>2)];
      var $479=(($478)|0);
      var $480=$46;
      var $481=$47;
      var $482=HEAP32[(($479)>>2)];
      HEAP32[(($__t_i_i)>>2)]=$482;
      var $483=(($472)|0);
      var $484=$45;
      HEAP32[(($45)>>2)]=$483;
      var $485=HEAP32[(($45)>>2)];
      var $486=$485;
      var $487=$44;
      HEAP32[(($44)>>2)]=$486;
      var $488=HEAP32[(($44)>>2)];
      var $489=(($488)|0);
      var $490=$44;
      var $491=$45;
      HEAP32[(($489)>>2)]=0;
      var $492=HEAP32[(($__t_i_i)>>2)];
      var $493=$48;
      var $494=$__t_i_i;
      var $495=$34;
      var $496=$35;
      var $497=$__tmp_i_i;
      var $498=$36;
      var $499=$37;
      HEAP32[(($34)>>2)]=$469;
      HEAP32[(($35)>>2)]=$492;
      var $500=HEAP32[(($34)>>2)];
      var $501=(($500)|0);
      var $502=$33;
      HEAP32[(($33)>>2)]=$501;
      var $503=HEAP32[(($33)>>2)];
      var $504=$503;
      var $505=$32;
      HEAP32[(($32)>>2)]=$504;
      var $506=HEAP32[(($32)>>2)];
      var $507=(($506)|0);
      var $508=$32;
      var $509=$33;
      var $510=HEAP32[(($507)>>2)];
      HEAP32[(($__tmp_i_i)>>2)]=$510;
      var $511=HEAP32[(($35)>>2)];
      var $512=(($500)|0);
      var $513=$31;
      HEAP32[(($31)>>2)]=$512;
      var $514=HEAP32[(($31)>>2)];
      var $515=$514;
      var $516=$30;
      HEAP32[(($30)>>2)]=$515;
      var $517=HEAP32[(($30)>>2)];
      var $518=(($517)|0);
      var $519=$30;
      var $520=$31;
      HEAP32[(($518)>>2)]=$511;
      var $521=HEAP32[(($__tmp_i_i)>>2)];
      var $522=(($521)|0)!=0;
      if ($522) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $523
      var $524=(($500)|0);
      var $525=$29;
      HEAP32[(($29)>>2)]=$524;
      var $526=HEAP32[(($29)>>2)];
      var $527=$526;
      var $528=$28;
      HEAP32[(($28)>>2)]=$527;
      var $529=HEAP32[(($28)>>2)];
      var $530=(($529+4)|0);
      var $531=$28;
      var $532=$29;
      var $533=HEAP32[(($530)>>2)];
      var $534=HEAP32[(($__tmp_i_i)>>2)];
      var $535=$534;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$533]($535) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $536
      __label__ = 16; break;
    case 15: // $537
      var $538=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $539=$538.f0;
      HEAP32[(($36)>>2)]=$539;
      var $540=$538.f1;
      HEAP32[(($37)>>2)]=$540;
      var $541=HEAP32[(($36)>>2)];
      ___cxa_call_unexpected($541);
      throw "Reached an unreachable!"
    case 16: // $_ZNSt3__110unique_ptrIjPFvPvEEaSIjS3_EERS4_NS0_IT_T0_EE_exit
      var $542=$34;
      var $543=$35;
      var $544=$__tmp_i_i;
      var $545=$36;
      var $546=$37;
      var $547=$40;
      HEAP32[(($40)>>2)]=$150;
      var $548=HEAP32[(($40)>>2)];
      var $549=(($548)|0);
      var $550=$39;
      HEAP32[(($39)>>2)]=$549;
      var $551=HEAP32[(($39)>>2)];
      var $552=$551;
      var $553=$38;
      HEAP32[(($38)>>2)]=$552;
      var $554=HEAP32[(($38)>>2)];
      var $555=(($554+4)|0);
      var $556=$38;
      var $557=$39;
      var $558=$40;
      var $559=$41;
      HEAP32[(($41)>>2)]=$555;
      var $560=HEAP32[(($41)>>2)];
      var $561=$41;
      var $562=HEAP32[(($560)>>2)];
      var $563=(($469)|0);
      var $564=$43;
      HEAP32[(($43)>>2)]=$563;
      var $565=HEAP32[(($43)>>2)];
      var $566=$565;
      var $567=$42;
      HEAP32[(($42)>>2)]=$566;
      var $568=HEAP32[(($42)>>2)];
      var $569=(($568+4)|0);
      var $570=$42;
      var $571=$43;
      HEAP32[(($569)>>2)]=$562;
      var $572=$49;
      __label__ = 17; break;
    case 17: // $573
      var $574=$87;
      HEAP32[(($87)>>2)]=$150;
      var $575=HEAP32[(($87)>>2)];
      var $576=$86;
      HEAP32[(($86)>>2)]=$575;
      var $577=HEAP32[(($86)>>2)];
      var $578=$82;
      var $579=$83;
      var $580=$__tmp_i_i_i5;
      var $581=$84;
      var $582=$85;
      HEAP32[(($82)>>2)]=$577;
      HEAP32[(($83)>>2)]=0;
      var $583=HEAP32[(($82)>>2)];
      var $584=(($583)|0);
      var $585=$81;
      HEAP32[(($81)>>2)]=$584;
      var $586=HEAP32[(($81)>>2)];
      var $587=$586;
      var $588=$80;
      HEAP32[(($80)>>2)]=$587;
      var $589=HEAP32[(($80)>>2)];
      var $590=(($589)|0);
      var $591=$80;
      var $592=$81;
      var $593=HEAP32[(($590)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$593;
      var $594=HEAP32[(($83)>>2)];
      var $595=(($583)|0);
      var $596=$79;
      HEAP32[(($79)>>2)]=$595;
      var $597=HEAP32[(($79)>>2)];
      var $598=$597;
      var $599=$78;
      HEAP32[(($78)>>2)]=$598;
      var $600=HEAP32[(($78)>>2)];
      var $601=(($600)|0);
      var $602=$78;
      var $603=$79;
      HEAP32[(($601)>>2)]=$594;
      var $604=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $605=(($604)|0)!=0;
      if ($605) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $606
      var $607=(($583)|0);
      var $608=$77;
      HEAP32[(($77)>>2)]=$607;
      var $609=HEAP32[(($77)>>2)];
      var $610=$609;
      var $611=$76;
      HEAP32[(($76)>>2)]=$610;
      var $612=HEAP32[(($76)>>2)];
      var $613=(($612+4)|0);
      var $614=$76;
      var $615=$77;
      var $616=HEAP32[(($613)>>2)];
      var $617=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $618=$617;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$616]($618) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $619
      __label__ = 21; break;
    case 20: // $620
      var $621=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $622=$621.f0;
      HEAP32[(($84)>>2)]=$622;
      var $623=$621.f1;
      HEAP32[(($85)>>2)]=$623;
      var $624=HEAP32[(($84)>>2)];
      ___cxa_call_unexpected($624);
      throw "Reached an unreachable!"
    case 21: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit6
      var $625=$82;
      var $626=$83;
      var $627=$__tmp_i_i_i5;
      var $628=$84;
      var $629=$85;
      var $630=$86;
      var $631=$87;
      __label__ = 22; break;
    case 22: // $632
      var $633=$107;
      HEAP32[(($107)>>2)]=$152;
      var $634=HEAP32[(($107)>>2)];
      var $635=$106;
      HEAP32[(($106)>>2)]=$634;
      var $636=HEAP32[(($106)>>2)];
      var $637=$102;
      var $638=$103;
      var $639=$__tmp_i_i_i3;
      var $640=$104;
      var $641=$105;
      HEAP32[(($102)>>2)]=$636;
      HEAP32[(($103)>>2)]=0;
      var $642=HEAP32[(($102)>>2)];
      var $643=(($642)|0);
      var $644=$101;
      HEAP32[(($101)>>2)]=$643;
      var $645=HEAP32[(($101)>>2)];
      var $646=$645;
      var $647=$100;
      HEAP32[(($100)>>2)]=$646;
      var $648=HEAP32[(($100)>>2)];
      var $649=(($648)|0);
      var $650=$100;
      var $651=$101;
      var $652=HEAP32[(($649)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$652;
      var $653=HEAP32[(($103)>>2)];
      var $654=(($642)|0);
      var $655=$99;
      HEAP32[(($99)>>2)]=$654;
      var $656=HEAP32[(($99)>>2)];
      var $657=$656;
      var $658=$98;
      HEAP32[(($98)>>2)]=$657;
      var $659=HEAP32[(($98)>>2)];
      var $660=(($659)|0);
      var $661=$98;
      var $662=$99;
      HEAP32[(($660)>>2)]=$653;
      var $663=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $664=(($663)|0)!=0;
      if ($664) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $665
      var $666=(($642)|0);
      var $667=$97;
      HEAP32[(($97)>>2)]=$666;
      var $668=HEAP32[(($97)>>2)];
      var $669=$668;
      var $670=$96;
      HEAP32[(($96)>>2)]=$669;
      var $671=HEAP32[(($96)>>2)];
      var $672=(($671+4)|0);
      var $673=$96;
      var $674=$97;
      var $675=HEAP32[(($672)>>2)];
      var $676=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $677=$676;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$675]($677) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $678
      __label__ = 26; break;
    case 25: // $679
      var $680=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $681=$680.f0;
      HEAP32[(($104)>>2)]=$681;
      var $682=$680.f1;
      HEAP32[(($105)>>2)]=$682;
      var $683=HEAP32[(($104)>>2)];
      ___cxa_call_unexpected($683);
      throw "Reached an unreachable!"
    case 26: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit4
      var $684=$102;
      var $685=$103;
      var $686=$__tmp_i_i_i3;
      var $687=$104;
      var $688=$105;
      var $689=$106;
      var $690=$107;
      var $691=$__new_cap;
      var $692=Math.floor((($691)>>>0)/4);
      $__new_cap=$692;
      var $693=$147;
      var $694=$110;
      HEAP32[(($110)>>2)]=$693;
      var $695=HEAP32[(($110)>>2)];
      var $696=(($695)|0);
      var $697=$109;
      HEAP32[(($109)>>2)]=$696;
      var $698=HEAP32[(($109)>>2)];
      var $699=$698;
      var $700=$108;
      HEAP32[(($108)>>2)]=$699;
      var $701=HEAP32[(($108)>>2)];
      var $702=(($701)|0);
      var $703=$108;
      var $704=$109;
      var $705=HEAP32[(($702)>>2)];
      var $706=$110;
      var $707=$__n_off;
      var $708=(($705+($707<<2))|0);
      var $709=$148;
      HEAP32[(($709)>>2)]=$708;
      var $710=$147;
      var $711=$113;
      HEAP32[(($113)>>2)]=$710;
      var $712=HEAP32[(($113)>>2)];
      var $713=(($712)|0);
      var $714=$112;
      HEAP32[(($112)>>2)]=$713;
      var $715=HEAP32[(($112)>>2)];
      var $716=$715;
      var $717=$111;
      HEAP32[(($111)>>2)]=$716;
      var $718=HEAP32[(($111)>>2)];
      var $719=(($718)|0);
      var $720=$111;
      var $721=$112;
      var $722=HEAP32[(($719)>>2)];
      var $723=$113;
      var $724=$__new_cap;
      var $725=(($722+($724<<2))|0);
      var $726=$149;
      HEAP32[(($726)>>2)]=$725;
      STACKTOP = __stackBase__;
      return;
      var $728=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $729=$728.f0;
      $153=$729;
      var $730=$728.f1;
      $154=$730;
      __label__ = 32; break;
    case 27: // $767
      var $768=(($744)|0);
      var $769=$118;
      HEAP32[(($118)>>2)]=$768;
      var $770=HEAP32[(($118)>>2)];
      var $771=$770;
      var $772=$117;
      HEAP32[(($117)>>2)]=$771;
      var $773=HEAP32[(($117)>>2)];
      var $774=(($773+4)|0);
      var $775=$117;
      var $776=$118;
      var $777=HEAP32[(($774)>>2)];
      var $778=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $779=$778;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$777]($779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $780
      __label__ = 30; break;
    case 29: // $781
      var $782=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $783=$782.f0;
      HEAP32[(($125)>>2)]=$783;
      var $784=$782.f1;
      HEAP32[(($126)>>2)]=$784;
      var $785=HEAP32[(($125)>>2)];
      ___cxa_call_unexpected($785);
      throw "Reached an unreachable!"
    case 30: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit2
      var $786=$123;
      var $787=$124;
      var $788=$__tmp_i_i_i1;
      var $789=$125;
      var $790=$126;
      var $791=$127;
      var $792=$128;
      __label__ = 31; break;
    case 31: // $793
      __label__ = 32; break;
    case 32: // $794
      var $795=$143;
      HEAP32[(($143)>>2)]=$152;
      var $796=HEAP32[(($143)>>2)];
      var $797=$142;
      HEAP32[(($142)>>2)]=$796;
      var $798=HEAP32[(($142)>>2)];
      var $799=$138;
      var $800=$139;
      var $801=$__tmp_i_i_i;
      var $802=$140;
      var $803=$141;
      HEAP32[(($138)>>2)]=$798;
      HEAP32[(($139)>>2)]=0;
      var $804=HEAP32[(($138)>>2)];
      var $805=(($804)|0);
      var $806=$137;
      HEAP32[(($137)>>2)]=$805;
      var $807=HEAP32[(($137)>>2)];
      var $808=$807;
      var $809=$136;
      HEAP32[(($136)>>2)]=$808;
      var $810=HEAP32[(($136)>>2)];
      var $811=(($810)|0);
      var $812=$136;
      var $813=$137;
      var $814=HEAP32[(($811)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$814;
      var $815=HEAP32[(($139)>>2)];
      var $816=(($804)|0);
      var $817=$135;
      HEAP32[(($135)>>2)]=$816;
      var $818=HEAP32[(($135)>>2)];
      var $819=$818;
      var $820=$134;
      HEAP32[(($134)>>2)]=$819;
      var $821=HEAP32[(($134)>>2)];
      var $822=(($821)|0);
      var $823=$134;
      var $824=$135;
      HEAP32[(($822)>>2)]=$815;
      var $825=HEAP32[(($__tmp_i_i_i)>>2)];
      var $826=(($825)|0)!=0;
      if ($826) { __label__ = 33; break; } else { __label__ = 36; break; }
    case 33: // $827
      var $828=(($804)|0);
      var $829=$133;
      HEAP32[(($133)>>2)]=$828;
      var $830=HEAP32[(($133)>>2)];
      var $831=$830;
      var $832=$132;
      HEAP32[(($132)>>2)]=$831;
      var $833=HEAP32[(($132)>>2)];
      var $834=(($833+4)|0);
      var $835=$132;
      var $836=$133;
      var $837=HEAP32[(($834)>>2)];
      var $838=HEAP32[(($__tmp_i_i_i)>>2)];
      var $839=$838;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$837]($839) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $840
      __label__ = 36; break;
    case 35: // $841
      var $842=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $843=$842.f0;
      HEAP32[(($140)>>2)]=$843;
      var $844=$842.f1;
      HEAP32[(($141)>>2)]=$844;
      var $845=HEAP32[(($140)>>2)];
      ___cxa_call_unexpected($845);
      throw "Reached an unreachable!"
    case 36: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit
      var $846=$138;
      var $847=$139;
      var $848=$__tmp_i_i_i;
      var $849=$140;
      var $850=$141;
      var $851=$142;
      var $852=$143;
      __label__ = 37; break;
    case 37: // $853
      __label__ = 38; break;
    case 38: // $854
      var $855=$153;
      var $856=$153;
      var $857=$154;
      var $858=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $856, tempValue);
      var $859=($858.f1 = $857, $858);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $861=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_["X"]=1;

function ___cxx_global_var_init29() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe($agg_result, $this, $__b, $__e, $__intl, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 1104; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i4=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $__tmp_i_i_i3=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $__tmp_i=__stackBase__+200;
      var $49=__stackBase__+204;
      var $50=__stackBase__+208;
      var $51=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $__tmp_i_i_i1=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $84=__stackBase__+348;
      var $85=__stackBase__+352;
      var $86=__stackBase__+356;
      var $87=__stackBase__+360;
      var $88=__stackBase__+364;
      var $89=__stackBase__+368;
      var $90=__stackBase__+372;
      var $91=__stackBase__+376;
      var $92=__stackBase__+380;
      var $93=__stackBase__+384;
      var $94=__stackBase__+388;
      var $95=__stackBase__+392;
      var $96=__stackBase__+396;
      var $97=__stackBase__+400;
      var $98=__stackBase__+404;
      var $99=__stackBase__+408;
      var $100=__stackBase__+412;
      var $101=__stackBase__+416;
      var $102=__stackBase__+420;
      var $103=__stackBase__+424;
      var $__tmp_i_i_i=__stackBase__+428;
      var $104=__stackBase__+432;
      var $105=__stackBase__+436;
      var $106=__stackBase__+440;
      var $107=__stackBase__+444;
      var $108=__stackBase__+448;
      var $109=__stackBase__+452;
      var $110=__stackBase__+456;
      var $111=__stackBase__+460;
      var $112=__stackBase__+464;
      var $113=__stackBase__+468;
      var $114=__stackBase__+472;
      var $115=__stackBase__+476;
      var $116=__stackBase__+480;
      var $117=__stackBase__+484;
      var $118=__stackBase__+488;
      var $119=__stackBase__+492;
      var $120=__stackBase__+496;
      var $121=__stackBase__+500;
      var $122=__stackBase__+504;
      var $123=__stackBase__+508;
      var $124=__stackBase__+512;
      var $125=__stackBase__+516;
      var $126=__stackBase__+520;
      var $127=__stackBase__+524;
      var $128=__stackBase__+528;
      var $129;
      var $130;
      var $131;
      var $132;
      var $133;
      var $__bz;
      var $__wbuf=__stackBase__+532;
      var $__wb=__stackBase__+932;
      var $__wn=__stackBase__+940;
      var $__we;
      var $__loc=__stackBase__+944;
      var $134;
      var $135;
      var $__ct;
      var $__neg=__stackBase__+948;
      var $136=__stackBase__+952;
      var $__atoms=__stackBase__+956;
      var $__nbuf=__stackBase__+996;
      var $__nc;
      var $__h=__stackBase__+1096;
      var $__w;
      var $137;
      $129=$this;
      var $138=(($__intl)&1);
      $130=$138;
      $131=$__iob;
      $132=$__err;
      $133=$__v;
      var $139=$129;
      $__bz=100;
      var $140=(($__wbuf)|0);
      var $141=$126;
      var $142=$127;
      var $143=$128;
      HEAP32[(($126)>>2)]=$__wb;
      HEAP32[(($127)>>2)]=$140;
      HEAP32[(($128)>>2)]=1682;
      var $144=HEAP32[(($126)>>2)];
      var $145=HEAP32[(($127)>>2)];
      var $146=HEAP32[(($128)>>2)];
      var $147=$123;
      var $148=$124;
      var $149=$125;
      HEAP32[(($123)>>2)]=$144;
      HEAP32[(($124)>>2)]=$145;
      HEAP32[(($125)>>2)]=$146;
      var $150=HEAP32[(($123)>>2)];
      var $151=(($150)|0);
      var $152=$122;
      HEAP32[(($122)>>2)]=$124;
      var $153=HEAP32[(($122)>>2)];
      var $154=$122;
      var $155=HEAP32[(($153)>>2)];
      var $156=$108;
      HEAP32[(($108)>>2)]=$125;
      var $157=HEAP32[(($108)>>2)];
      var $158=$108;
      var $159=HEAP32[(($157)>>2)];
      var $160=$119;
      var $161=$120;
      var $162=$121;
      HEAP32[(($119)>>2)]=$151;
      HEAP32[(($120)>>2)]=$155;
      HEAP32[(($121)>>2)]=$159;
      var $163=HEAP32[(($119)>>2)];
      var $164=HEAP32[(($120)>>2)];
      var $165=HEAP32[(($121)>>2)];
      var $166=$116;
      var $167=$117;
      var $168=$118;
      HEAP32[(($116)>>2)]=$163;
      HEAP32[(($117)>>2)]=$164;
      HEAP32[(($118)>>2)]=$165;
      var $169=HEAP32[(($116)>>2)];
      var $170=$169;
      var $171=$115;
      HEAP32[(($115)>>2)]=$117;
      var $172=HEAP32[(($115)>>2)];
      var $173=$115;
      var $174=HEAP32[(($172)>>2)];
      var $175=$109;
      HEAP32[(($109)>>2)]=$118;
      var $176=HEAP32[(($109)>>2)];
      var $177=$109;
      var $178=HEAP32[(($176)>>2)];
      var $179=$112;
      var $180=$113;
      var $181=$114;
      HEAP32[(($112)>>2)]=$170;
      HEAP32[(($113)>>2)]=$174;
      HEAP32[(($114)>>2)]=$178;
      var $182=HEAP32[(($112)>>2)];
      var $183=(($182)|0);
      var $184=$111;
      HEAP32[(($111)>>2)]=$113;
      var $185=HEAP32[(($111)>>2)];
      var $186=$111;
      var $187=HEAP32[(($185)>>2)];
      HEAP32[(($183)>>2)]=$187;
      var $188=(($182+4)|0);
      var $189=$110;
      HEAP32[(($110)>>2)]=$114;
      var $190=HEAP32[(($110)>>2)];
      var $191=$110;
      var $192=HEAP32[(($190)>>2)];
      HEAP32[(($188)>>2)]=$192;
      var $193=$112;
      var $194=$113;
      var $195=$114;
      var $196=$116;
      var $197=$117;
      var $198=$118;
      var $199=$119;
      var $200=$120;
      var $201=$121;
      var $202=$123;
      var $203=$124;
      var $204=$125;
      var $205=$126;
      var $206=$127;
      var $207=$128;
      var $208=(($__wbuf)|0);
      var $209=(($208+400)|0);
      $__we=$209;
      var $210=$131;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($__loc, $210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $211
      var $212=$95;
      HEAP32[(($95)>>2)]=$__loc;
      var $213=HEAP32[(($95)>>2)];
      var $214=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($213, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 18; break; };
    case 2: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $215=$214;
      var $216=$95;
      __label__ = 3; break;
    case 3: // $217
      $__ct=$215;
      HEAP8[($__neg)]=0;
      var $218=$136;
      var $219=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($218)>>2)]=HEAP32[(($219)>>2)];
      var $220=$130;
      var $221=(($220) & 1);
      var $222=$131;
      var $223=$94;
      HEAP32[(($94)>>2)]=$222;
      var $224=HEAP32[(($94)>>2)];
      var $225=(($224+4)|0);
      var $226=HEAP32[(($225)>>2)];
      var $227=$94;
      __label__ = 4; break;
    case 4: // $228
      var $229=$132;
      var $230=$__ct;
      var $231=$__we;
      var $232=(function() { try { __THREW__ = false; return __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_($__b, $136, $221, $__loc, $226, $229, $__neg, $230, $__wb, $__wn, $231) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 18; break; };
    case 5: // $233
      if ($232) { __label__ = 6; break; } else { __label__ = 48; break; }
    case 6: // $234
      var $235=$__ct;
      var $236=(($__atoms)|0);
      var $237=$90;
      var $238=$91;
      var $239=$92;
      var $240=$93;
      HEAP32[(($90)>>2)]=$235;
      HEAP32[(($91)>>2)]=((STRING_TABLE.__ZZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src)|0);
      HEAP32[(($92)>>2)]=((STRING_TABLE.__ZZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src+10)|0);
      HEAP32[(($93)>>2)]=$236;
      var $241=HEAP32[(($90)>>2)];
      var $242=$241;
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243+48)|0);
      var $245=HEAP32[(($244)>>2)];
      var $246=HEAP32[(($91)>>2)];
      var $247=HEAP32[(($92)>>2)];
      var $248=HEAP32[(($93)>>2)];
      var $249=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$245]($241, $246, $247, $248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 18; break; };
    case 7: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $250=$90;
      var $251=$91;
      var $252=$92;
      var $253=$93;
      __label__ = 8; break;
    case 8: // $254
      var $255=(($__nbuf)|0);
      $__nc=$255;
      var $256=$87;
      var $257=$88;
      var $258=$89;
      HEAP32[(($87)>>2)]=$__h;
      HEAP32[(($88)>>2)]=0;
      HEAP32[(($89)>>2)]=1496;
      var $259=HEAP32[(($87)>>2)];
      var $260=HEAP32[(($88)>>2)];
      var $261=HEAP32[(($89)>>2)];
      var $262=$84;
      var $263=$85;
      var $264=$86;
      HEAP32[(($84)>>2)]=$259;
      HEAP32[(($85)>>2)]=$260;
      HEAP32[(($86)>>2)]=$261;
      var $265=HEAP32[(($84)>>2)];
      var $266=(($265)|0);
      var $267=$83;
      HEAP32[(($83)>>2)]=$85;
      var $268=HEAP32[(($83)>>2)];
      var $269=$83;
      var $270=HEAP32[(($268)>>2)];
      var $271=$69;
      HEAP32[(($69)>>2)]=$86;
      var $272=HEAP32[(($69)>>2)];
      var $273=$69;
      var $274=HEAP32[(($272)>>2)];
      var $275=$80;
      var $276=$81;
      var $277=$82;
      HEAP32[(($80)>>2)]=$266;
      HEAP32[(($81)>>2)]=$270;
      HEAP32[(($82)>>2)]=$274;
      var $278=HEAP32[(($80)>>2)];
      var $279=HEAP32[(($81)>>2)];
      var $280=HEAP32[(($82)>>2)];
      var $281=$77;
      var $282=$78;
      var $283=$79;
      HEAP32[(($77)>>2)]=$278;
      HEAP32[(($78)>>2)]=$279;
      HEAP32[(($79)>>2)]=$280;
      var $284=HEAP32[(($77)>>2)];
      var $285=$284;
      var $286=$76;
      HEAP32[(($76)>>2)]=$78;
      var $287=HEAP32[(($76)>>2)];
      var $288=$76;
      var $289=HEAP32[(($287)>>2)];
      var $290=$70;
      HEAP32[(($70)>>2)]=$79;
      var $291=HEAP32[(($70)>>2)];
      var $292=$70;
      var $293=HEAP32[(($291)>>2)];
      var $294=$73;
      var $295=$74;
      var $296=$75;
      HEAP32[(($73)>>2)]=$285;
      HEAP32[(($74)>>2)]=$289;
      HEAP32[(($75)>>2)]=$293;
      var $297=HEAP32[(($73)>>2)];
      var $298=(($297)|0);
      var $299=$72;
      HEAP32[(($72)>>2)]=$74;
      var $300=HEAP32[(($72)>>2)];
      var $301=$72;
      var $302=HEAP32[(($300)>>2)];
      HEAP32[(($298)>>2)]=$302;
      var $303=(($297+4)|0);
      var $304=$71;
      HEAP32[(($71)>>2)]=$75;
      var $305=HEAP32[(($71)>>2)];
      var $306=$71;
      var $307=HEAP32[(($305)>>2)];
      HEAP32[(($303)>>2)]=$307;
      var $308=$73;
      var $309=$74;
      var $310=$75;
      var $311=$77;
      var $312=$78;
      var $313=$79;
      var $314=$80;
      var $315=$81;
      var $316=$82;
      var $317=$84;
      var $318=$85;
      var $319=$86;
      var $320=$87;
      var $321=$88;
      var $322=$89;
      __label__ = 9; break;
    case 9: // $323
      var $324=HEAP32[(($__wn)>>2)];
      var $325=$68;
      HEAP32[(($68)>>2)]=$__wb;
      var $326=HEAP32[(($68)>>2)];
      var $327=(($326)|0);
      var $328=$67;
      HEAP32[(($67)>>2)]=$327;
      var $329=HEAP32[(($67)>>2)];
      var $330=$329;
      var $331=$66;
      HEAP32[(($66)>>2)]=$330;
      var $332=HEAP32[(($66)>>2)];
      var $333=(($332)|0);
      var $334=$66;
      var $335=$67;
      var $336=HEAP32[(($333)>>2)];
      var $337=$68;
      var $338=$324;
      var $339=$336;
      var $340=(($338-$339)|0);
      var $341=(((($340)|0)/4)|0);
      var $342=(($341)>>>0) > 98;
      if ($342) { __label__ = 10; break; } else { __label__ = 25; break; }
    case 10: // $343
      var $344=HEAP32[(($__wn)>>2)];
      var $345=$53;
      HEAP32[(($53)>>2)]=$__wb;
      var $346=HEAP32[(($53)>>2)];
      var $347=(($346)|0);
      var $348=$52;
      HEAP32[(($52)>>2)]=$347;
      var $349=HEAP32[(($52)>>2)];
      var $350=$349;
      var $351=$51;
      HEAP32[(($51)>>2)]=$350;
      var $352=HEAP32[(($51)>>2)];
      var $353=(($352)|0);
      var $354=$51;
      var $355=$52;
      var $356=HEAP32[(($353)>>2)];
      var $357=$53;
      var $358=$344;
      var $359=$356;
      var $360=(($358-$359)|0);
      var $361=(((($360)|0)/4)|0);
      var $362=(($361+2)|0);
      var $363=_malloc($362);
      var $364=$47;
      var $365=$48;
      var $366=$__tmp_i;
      var $367=$49;
      var $368=$50;
      HEAP32[(($47)>>2)]=$__h;
      HEAP32[(($48)>>2)]=$363;
      var $369=HEAP32[(($47)>>2)];
      var $370=(($369)|0);
      var $371=$46;
      HEAP32[(($46)>>2)]=$370;
      var $372=HEAP32[(($46)>>2)];
      var $373=$372;
      var $374=$45;
      HEAP32[(($45)>>2)]=$373;
      var $375=HEAP32[(($45)>>2)];
      var $376=(($375)|0);
      var $377=$45;
      var $378=$46;
      var $379=HEAP32[(($376)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$379;
      var $380=HEAP32[(($48)>>2)];
      var $381=(($369)|0);
      var $382=$44;
      HEAP32[(($44)>>2)]=$381;
      var $383=HEAP32[(($44)>>2)];
      var $384=$383;
      var $385=$43;
      HEAP32[(($43)>>2)]=$384;
      var $386=HEAP32[(($43)>>2)];
      var $387=(($386)|0);
      var $388=$43;
      var $389=$44;
      HEAP32[(($387)>>2)]=$380;
      var $390=HEAP32[(($__tmp_i)>>2)];
      var $391=(($390)|0)!=0;
      if ($391) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $392
      var $393=(($369)|0);
      var $394=$42;
      HEAP32[(($42)>>2)]=$393;
      var $395=HEAP32[(($42)>>2)];
      var $396=$395;
      var $397=$41;
      HEAP32[(($41)>>2)]=$396;
      var $398=HEAP32[(($41)>>2)];
      var $399=(($398+4)|0);
      var $400=$41;
      var $401=$42;
      var $402=HEAP32[(($399)>>2)];
      var $403=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$402]($403) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $404
      __label__ = 14; break;
    case 13: // $405
      var $406=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $407=$406.f0;
      HEAP32[(($49)>>2)]=$407;
      var $408=$406.f1;
      HEAP32[(($50)>>2)]=$408;
      var $409=HEAP32[(($49)>>2)];
      ___cxa_call_unexpected($409);
      throw "Reached an unreachable!"
    case 14: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $410=$47;
      var $411=$48;
      var $412=$__tmp_i;
      var $413=$49;
      var $414=$50;
      var $415=$40;
      HEAP32[(($40)>>2)]=$__h;
      var $416=HEAP32[(($40)>>2)];
      var $417=(($416)|0);
      var $418=$39;
      HEAP32[(($39)>>2)]=$417;
      var $419=HEAP32[(($39)>>2)];
      var $420=$419;
      var $421=$38;
      HEAP32[(($38)>>2)]=$420;
      var $422=HEAP32[(($38)>>2)];
      var $423=(($422)|0);
      var $424=$38;
      var $425=$39;
      var $426=HEAP32[(($423)>>2)];
      var $427=$40;
      var $428=(($426)|0)==0;
      if ($428) { __label__ = 15; break; } else { __label__ = 24; break; }
    case 15: // $429
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $430
      __label__ = 24; break;
    case 17: // $431
      var $432=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $433=$432.f0;
      $134=$433;
      var $434=$432.f1;
      $135=$434;
      __label__ = 59; break;
    case 18: // $435
      var $436=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $437=$436.f0;
      $134=$437;
      var $438=$436.f1;
      $135=$438;
      __label__ = 57; break;
    case 19: // $439
      var $440=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $441=$440.f0;
      $134=$441;
      var $442=$440.f1;
      $135=$442;
      var $443=$37;
      HEAP32[(($37)>>2)]=$__h;
      var $444=HEAP32[(($37)>>2)];
      var $445=$36;
      HEAP32[(($36)>>2)]=$444;
      var $446=HEAP32[(($36)>>2)];
      var $447=$32;
      var $448=$33;
      var $449=$__tmp_i_i_i3;
      var $450=$34;
      var $451=$35;
      HEAP32[(($32)>>2)]=$446;
      HEAP32[(($33)>>2)]=0;
      var $452=HEAP32[(($32)>>2)];
      var $453=(($452)|0);
      var $454=$31;
      HEAP32[(($31)>>2)]=$453;
      var $455=HEAP32[(($31)>>2)];
      var $456=$455;
      var $457=$30;
      HEAP32[(($30)>>2)]=$456;
      var $458=HEAP32[(($30)>>2)];
      var $459=(($458)|0);
      var $460=$30;
      var $461=$31;
      var $462=HEAP32[(($459)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$462;
      var $463=HEAP32[(($33)>>2)];
      var $464=(($452)|0);
      var $465=$29;
      HEAP32[(($29)>>2)]=$464;
      var $466=HEAP32[(($29)>>2)];
      var $467=$466;
      var $468=$28;
      HEAP32[(($28)>>2)]=$467;
      var $469=HEAP32[(($28)>>2)];
      var $470=(($469)|0);
      var $471=$28;
      var $472=$29;
      HEAP32[(($470)>>2)]=$463;
      var $473=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $474=(($473)|0)!=0;
      if ($474) { __label__ = 20; break; } else { __label__ = 23; break; }
    case 20: // $475
      var $476=(($452)|0);
      var $477=$27;
      HEAP32[(($27)>>2)]=$476;
      var $478=HEAP32[(($27)>>2)];
      var $479=$478;
      var $480=$26;
      HEAP32[(($26)>>2)]=$479;
      var $481=HEAP32[(($26)>>2)];
      var $482=(($481+4)|0);
      var $483=$26;
      var $484=$27;
      var $485=HEAP32[(($482)>>2)];
      var $486=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$485]($486) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $487
      __label__ = 23; break;
    case 22: // $488
      var $489=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $490=$489.f0;
      HEAP32[(($34)>>2)]=$490;
      var $491=$489.f1;
      HEAP32[(($35)>>2)]=$491;
      var $492=HEAP32[(($34)>>2)];
      ___cxa_call_unexpected($492);
      throw "Reached an unreachable!"
    case 23: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $493=$32;
      var $494=$33;
      var $495=$__tmp_i_i_i3;
      var $496=$34;
      var $497=$35;
      var $498=$36;
      var $499=$37;
      __label__ = 47; break;
    case 24: // $500
      var $501=$25;
      HEAP32[(($25)>>2)]=$__h;
      var $502=HEAP32[(($25)>>2)];
      var $503=(($502)|0);
      var $504=$24;
      HEAP32[(($24)>>2)]=$503;
      var $505=HEAP32[(($24)>>2)];
      var $506=$505;
      var $507=$23;
      HEAP32[(($23)>>2)]=$506;
      var $508=HEAP32[(($23)>>2)];
      var $509=(($508)|0);
      var $510=$23;
      var $511=$24;
      var $512=HEAP32[(($509)>>2)];
      var $513=$25;
      $__nc=$512;
      __label__ = 25; break;
    case 25: // $514
      var $515=HEAP8[($__neg)];
      var $516=(($515) & 1);
      if ($516) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $517
      var $518=$__nc;
      var $519=(($518+1)|0);
      $__nc=$519;
      HEAP8[($518)]=45;
      __label__ = 27; break;
    case 27: // $520
      var $521=$22;
      HEAP32[(($22)>>2)]=$__wb;
      var $522=HEAP32[(($22)>>2)];
      var $523=(($522)|0);
      var $524=$21;
      HEAP32[(($21)>>2)]=$523;
      var $525=HEAP32[(($21)>>2)];
      var $526=$525;
      var $527=$20;
      HEAP32[(($20)>>2)]=$526;
      var $528=HEAP32[(($20)>>2)];
      var $529=(($528)|0);
      var $530=$20;
      var $531=$21;
      var $532=HEAP32[(($529)>>2)];
      var $533=$22;
      $__w=$532;
      __label__ = 28; break;
    case 28: // $534
      var $535=$__w;
      var $536=HEAPU32[(($__wn)>>2)];
      var $537=(($535)>>>0) < (($536)>>>0);
      if ($537) { __label__ = 29; break; } else { __label__ = 37; break; }
    case 29: // $538
      var $539=(($__atoms)|0);
      var $540=(($__atoms)|0);
      var $541=(($540+160)|0);
      var $542=$__w;
      var $543=$17;
      var $544=$18;
      var $545=$19;
      HEAP32[(($17)>>2)]=$539;
      HEAP32[(($18)>>2)]=$541;
      HEAP32[(($19)>>2)]=$542;
      __label__ = 30; break;
    case 30: // $546
      var $547=HEAP32[(($17)>>2)];
      var $548=HEAP32[(($18)>>2)];
      var $549=(($547)|0)!=(($548)|0);
      if ($549) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $550
      var $551=HEAP32[(($17)>>2)];
      var $552=HEAP32[(($551)>>2)];
      var $553=HEAP32[(($19)>>2)];
      var $554=HEAP32[(($553)>>2)];
      var $555=(($552)|0)==(($554)|0);
      if ($555) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $556
      __label__ = 34; break;
    case 33: // $557
      var $558=HEAP32[(($17)>>2)];
      var $559=(($558+4)|0);
      HEAP32[(($17)>>2)]=$559;
      __label__ = 30; break;
    case 34: // $_ZNSt3__14findIPwwEET_S2_S2_RKT0__exit
      var $560=HEAP32[(($17)>>2)];
      var $561=$17;
      var $562=$18;
      var $563=$19;
      __label__ = 35; break;
    case 35: // $564
      var $565=(($__atoms)|0);
      var $566=$560;
      var $567=$565;
      var $568=(($566-$567)|0);
      var $569=(((($568)|0)/4)|0);
      var $570=((STRING_TABLE.__ZZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src+$569)|0);
      var $571=HEAP8[($570)];
      var $572=$__nc;
      HEAP8[($572)]=$571;
      __label__ = 36; break;
    case 36: // $573
      var $574=$__w;
      var $575=(($574+4)|0);
      $__w=$575;
      var $576=$__nc;
      var $577=(($576+1)|0);
      $__nc=$577;
      __label__ = 28; break;
    case 37: // $578
      var $579=$__nc;
      HEAP8[($579)]=0;
      var $580=(($__nbuf)|0);
      var $581=$133;
      var $582=(function() { try { __THREW__ = false; return _sscanf($580, ((STRING_TABLE.__str27248)|0), (tempInt=STACKTOP,STACKTOP += 4,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),HEAP32[((tempInt)>>2)]=$581,tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 19; break; };
    case 38: // $583
      var $584=(($582)|0)!=1;
      if ($584) { __label__ = 39; break; } else { __label__ = 41; break; }
    case 39: // $585
      (function() { try { __THREW__ = false; return __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str28249)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 19; break; }
    case 40: // $586
      __label__ = 41; break;
    case 41: // $587
      var $588=$12;
      HEAP32[(($12)>>2)]=$__h;
      var $589=HEAP32[(($12)>>2)];
      var $590=$11;
      HEAP32[(($11)>>2)]=$589;
      var $591=HEAP32[(($11)>>2)];
      var $592=$7;
      var $593=$8;
      var $594=$__tmp_i_i_i4;
      var $595=$9;
      var $596=$10;
      HEAP32[(($7)>>2)]=$591;
      HEAP32[(($8)>>2)]=0;
      var $597=HEAP32[(($7)>>2)];
      var $598=(($597)|0);
      var $599=$6;
      HEAP32[(($6)>>2)]=$598;
      var $600=HEAP32[(($6)>>2)];
      var $601=$600;
      var $602=$5;
      HEAP32[(($5)>>2)]=$601;
      var $603=HEAP32[(($5)>>2)];
      var $604=(($603)|0);
      var $605=$5;
      var $606=$6;
      var $607=HEAP32[(($604)>>2)];
      HEAP32[(($__tmp_i_i_i4)>>2)]=$607;
      var $608=HEAP32[(($8)>>2)];
      var $609=(($597)|0);
      var $610=$4;
      HEAP32[(($4)>>2)]=$609;
      var $611=HEAP32[(($4)>>2)];
      var $612=$611;
      var $613=$3;
      HEAP32[(($3)>>2)]=$612;
      var $614=HEAP32[(($3)>>2)];
      var $615=(($614)|0);
      var $616=$3;
      var $617=$4;
      HEAP32[(($615)>>2)]=$608;
      var $618=HEAP32[(($__tmp_i_i_i4)>>2)];
      var $619=(($618)|0)!=0;
      if ($619) { __label__ = 42; break; } else { __label__ = 45; break; }
    case 42: // $620
      var $621=(($597)|0);
      var $622=$2;
      HEAP32[(($2)>>2)]=$621;
      var $623=HEAP32[(($2)>>2)];
      var $624=$623;
      var $625=$1;
      HEAP32[(($1)>>2)]=$624;
      var $626=HEAP32[(($1)>>2)];
      var $627=(($626+4)|0);
      var $628=$1;
      var $629=$2;
      var $630=HEAP32[(($627)>>2)];
      var $631=HEAP32[(($__tmp_i_i_i4)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$630]($631) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 44; break; }
    case 43: // $632
      __label__ = 45; break;
    case 44: // $633
      var $634=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $635=$634.f0;
      HEAP32[(($9)>>2)]=$635;
      var $636=$634.f1;
      HEAP32[(($10)>>2)]=$636;
      var $637=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($637);
      throw "Reached an unreachable!"
    case 45: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit5
      var $638=$7;
      var $639=$8;
      var $640=$__tmp_i_i_i4;
      var $641=$9;
      var $642=$10;
      var $643=$11;
      var $644=$12;
      __label__ = 46; break;
    case 46: // $645
      __label__ = 48; break;
    case 47: // $646
      __label__ = 57; break;
    case 48: // $647
      var $648=$15;
      var $649=$16;
      HEAP32[(($15)>>2)]=$__b;
      HEAP32[(($16)>>2)]=$__e;
      var $650=HEAP32[(($15)>>2)];
      var $651=HEAP32[(($16)>>2)];
      var $652=$13;
      var $653=$14;
      HEAP32[(($13)>>2)]=$650;
      HEAP32[(($14)>>2)]=$651;
      var $654=HEAP32[(($13)>>2)];
      var $655=(($654)|0);
      var $656=HEAP32[(($655)>>2)];
      var $657=(($656)|0)==0;
      var $658=(($657)&1);
      var $659=HEAP32[(($14)>>2)];
      var $660=(($659)|0);
      var $661=HEAP32[(($660)>>2)];
      var $662=(($661)|0)==0;
      var $663=(($662)&1);
      var $664=(($658)|0)==(($663)|0);
      var $665=$13;
      var $666=$14;
      var $667=$15;
      var $668=$16;
      __label__ = 49; break;
    case 49: // $669
      if ($664) { __label__ = 50; break; } else { __label__ = 51; break; }
    case 50: // $670
      var $671=$132;
      var $672=HEAP32[(($671)>>2)];
      var $673=$672 | 2;
      HEAP32[(($671)>>2)]=$673;
      __label__ = 51; break;
    case 51: // $674
      var $675=$agg_result;
      var $676=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($675)>>2)]=HEAP32[(($676)>>2)];
      $137=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 17; break; }
    case 52: // $677
      var $678=$65;
      HEAP32[(($65)>>2)]=$__wb;
      var $679=HEAP32[(($65)>>2)];
      var $680=$64;
      HEAP32[(($64)>>2)]=$679;
      var $681=HEAP32[(($64)>>2)];
      var $682=$60;
      var $683=$61;
      var $684=$__tmp_i_i_i1;
      var $685=$62;
      var $686=$63;
      HEAP32[(($60)>>2)]=$681;
      HEAP32[(($61)>>2)]=0;
      var $687=HEAP32[(($60)>>2)];
      var $688=(($687)|0);
      var $689=$59;
      HEAP32[(($59)>>2)]=$688;
      var $690=HEAP32[(($59)>>2)];
      var $691=$690;
      var $692=$58;
      HEAP32[(($58)>>2)]=$691;
      var $693=HEAP32[(($58)>>2)];
      var $694=(($693)|0);
      var $695=$58;
      var $696=$59;
      var $697=HEAP32[(($694)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$697;
      var $698=HEAP32[(($61)>>2)];
      var $699=(($687)|0);
      var $700=$57;
      HEAP32[(($57)>>2)]=$699;
      var $701=HEAP32[(($57)>>2)];
      var $702=$701;
      var $703=$56;
      HEAP32[(($56)>>2)]=$702;
      var $704=HEAP32[(($56)>>2)];
      var $705=(($704)|0);
      var $706=$56;
      var $707=$57;
      HEAP32[(($705)>>2)]=$698;
      var $708=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $709=(($708)|0)!=0;
      if ($709) { __label__ = 53; break; } else { __label__ = 56; break; }
    case 53: // $710
      var $711=(($687)|0);
      var $712=$55;
      HEAP32[(($55)>>2)]=$711;
      var $713=HEAP32[(($55)>>2)];
      var $714=$713;
      var $715=$54;
      HEAP32[(($54)>>2)]=$714;
      var $716=HEAP32[(($54)>>2)];
      var $717=(($716+4)|0);
      var $718=$54;
      var $719=$55;
      var $720=HEAP32[(($717)>>2)];
      var $721=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $722=$721;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$720]($722) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $723
      __label__ = 56; break;
    case 55: // $724
      var $725=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $726=$725.f0;
      HEAP32[(($62)>>2)]=$726;
      var $727=$725.f1;
      HEAP32[(($63)>>2)]=$727;
      var $728=HEAP32[(($62)>>2)];
      ___cxa_call_unexpected($728);
      throw "Reached an unreachable!"
    case 56: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit2
      var $729=$60;
      var $730=$61;
      var $731=$__tmp_i_i_i1;
      var $732=$62;
      var $733=$63;
      var $734=$64;
      var $735=$65;
      STACKTOP = __stackBase__;
      return;
    case 57: // $736
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 66; break; }
    case 58: // $737
      __label__ = 59; break;
    case 59: // $738
      var $739=$107;
      HEAP32[(($107)>>2)]=$__wb;
      var $740=HEAP32[(($107)>>2)];
      var $741=$106;
      HEAP32[(($106)>>2)]=$740;
      var $742=HEAP32[(($106)>>2)];
      var $743=$102;
      var $744=$103;
      var $745=$__tmp_i_i_i;
      var $746=$104;
      var $747=$105;
      HEAP32[(($102)>>2)]=$742;
      HEAP32[(($103)>>2)]=0;
      var $748=HEAP32[(($102)>>2)];
      var $749=(($748)|0);
      var $750=$101;
      HEAP32[(($101)>>2)]=$749;
      var $751=HEAP32[(($101)>>2)];
      var $752=$751;
      var $753=$100;
      HEAP32[(($100)>>2)]=$752;
      var $754=HEAP32[(($100)>>2)];
      var $755=(($754)|0);
      var $756=$100;
      var $757=$101;
      var $758=HEAP32[(($755)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$758;
      var $759=HEAP32[(($103)>>2)];
      var $760=(($748)|0);
      var $761=$99;
      HEAP32[(($99)>>2)]=$760;
      var $762=HEAP32[(($99)>>2)];
      var $763=$762;
      var $764=$98;
      HEAP32[(($98)>>2)]=$763;
      var $765=HEAP32[(($98)>>2)];
      var $766=(($765)|0);
      var $767=$98;
      var $768=$99;
      HEAP32[(($766)>>2)]=$759;
      var $769=HEAP32[(($__tmp_i_i_i)>>2)];
      var $770=(($769)|0)!=0;
      if ($770) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $771
      var $772=(($748)|0);
      var $773=$97;
      HEAP32[(($97)>>2)]=$772;
      var $774=HEAP32[(($97)>>2)];
      var $775=$774;
      var $776=$96;
      HEAP32[(($96)>>2)]=$775;
      var $777=HEAP32[(($96)>>2)];
      var $778=(($777+4)|0);
      var $779=$96;
      var $780=$97;
      var $781=HEAP32[(($778)>>2)];
      var $782=HEAP32[(($__tmp_i_i_i)>>2)];
      var $783=$782;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$781]($783) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $784
      __label__ = 63; break;
    case 62: // $785
      var $786=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $787=$786.f0;
      HEAP32[(($104)>>2)]=$787;
      var $788=$786.f1;
      HEAP32[(($105)>>2)]=$788;
      var $789=HEAP32[(($104)>>2)];
      ___cxa_call_unexpected($789);
      throw "Reached an unreachable!"
    case 63: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $790=$102;
      var $791=$103;
      var $792=$__tmp_i_i_i;
      var $793=$104;
      var $794=$105;
      var $795=$106;
      var $796=$107;
      __label__ = 64; break;
    case 64: // $797
      __label__ = 65; break;
    case 65: // $798
      var $799=$134;
      var $800=$134;
      var $801=$135;
      var $802=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $800, tempValue);
      var $803=($802.f1 = $801, $802);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 66: // $804
      var $805=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe["X"]=1;

function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_($__b, $__e, $__intl, $__loc, $__flags, $__err, $__neg, $__ct, $__wb, $__wn, $__we) {
  var __stackBase__  = STACKTOP; STACKTOP += 2376; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $80=__stackBase__+316;
      var $81=__stackBase__+320;
      var $82=__stackBase__+324;
      var $83=__stackBase__+328;
      var $84=__stackBase__+332;
      var $85=__stackBase__+336;
      var $86=__stackBase__+340;
      var $87=__stackBase__+344;
      var $88=__stackBase__+348;
      var $89=__stackBase__+352;
      var $90=__stackBase__+356;
      var $91=__stackBase__+360;
      var $92=__stackBase__+364;
      var $93=__stackBase__+368;
      var $94=__stackBase__+372;
      var $95=__stackBase__+376;
      var $96=__stackBase__+380;
      var $97=__stackBase__+384;
      var $98=__stackBase__+388;
      var $99=__stackBase__+392;
      var $100=__stackBase__+396;
      var $101=__stackBase__+400;
      var $102=__stackBase__+404;
      var $103=__stackBase__+408;
      var $104=__stackBase__+412;
      var $105=__stackBase__+416;
      var $106=__stackBase__+420;
      var $107=__stackBase__+424;
      var $108=__stackBase__+428;
      var $109=__stackBase__+432;
      var $110=__stackBase__+436;
      var $111=__stackBase__+440;
      var $112=__stackBase__+444;
      var $113=__stackBase__+448;
      var $114=__stackBase__+452;
      var $115=__stackBase__+456;
      var $116=__stackBase__+460;
      var $117=__stackBase__+464;
      var $118=__stackBase__+468;
      var $119=__stackBase__+472;
      var $120=__stackBase__+476;
      var $121=__stackBase__+480;
      var $122=__stackBase__+484;
      var $123=__stackBase__+488;
      var $124=__stackBase__+492;
      var $125=__stackBase__+496;
      var $126=__stackBase__+500;
      var $127=__stackBase__+504;
      var $128=__stackBase__+508;
      var $129=__stackBase__+512;
      var $130=__stackBase__+516;
      var $131=__stackBase__+520;
      var $132=__stackBase__+524;
      var $133=__stackBase__+528;
      var $134=__stackBase__+532;
      var $135=__stackBase__+536;
      var $136=__stackBase__+540;
      var $137=__stackBase__+544;
      var $138=__stackBase__+548;
      var $139=__stackBase__+552;
      var $140=__stackBase__+556;
      var $141=__stackBase__+560;
      var $142=__stackBase__+564;
      var $143=__stackBase__+568;
      var $144=__stackBase__+572;
      var $145=__stackBase__+576;
      var $146=__stackBase__+580;
      var $147=__stackBase__+584;
      var $148=__stackBase__+588;
      var $149=__stackBase__+592;
      var $150=__stackBase__+596;
      var $151=__stackBase__+600;
      var $152=__stackBase__+604;
      var $153=__stackBase__+608;
      var $154=__stackBase__+612;
      var $155=__stackBase__+616;
      var $156=__stackBase__+620;
      var $157=__stackBase__+624;
      var $158=__stackBase__+628;
      var $159=__stackBase__+632;
      var $160=__stackBase__+636;
      var $161=__stackBase__+640;
      var $162=__stackBase__+644;
      var $163=__stackBase__+648;
      var $164=__stackBase__+652;
      var $165=__stackBase__+656;
      var $166=__stackBase__+660;
      var $167=__stackBase__+664;
      var $168=__stackBase__+668;
      var $169=__stackBase__+672;
      var $170=__stackBase__+676;
      var $171=__stackBase__+680;
      var $172=__stackBase__+684;
      var $173=__stackBase__+688;
      var $174=__stackBase__+692;
      var $175=__stackBase__+696;
      var $176=__stackBase__+700;
      var $177=__stackBase__+704;
      var $178=__stackBase__+708;
      var $179=__stackBase__+712;
      var $180=__stackBase__+716;
      var $181=__stackBase__+720;
      var $182=__stackBase__+724;
      var $183=__stackBase__+728;
      var $184=__stackBase__+732;
      var $185=__stackBase__+736;
      var $186=__stackBase__+740;
      var $187=__stackBase__+744;
      var $188=__stackBase__+748;
      var $189=__stackBase__+752;
      var $190=__stackBase__+756;
      var $191=__stackBase__+760;
      var $192=__stackBase__+764;
      var $193=__stackBase__+768;
      var $194=__stackBase__+772;
      var $195=__stackBase__+776;
      var $196=__stackBase__+780;
      var $197=__stackBase__+784;
      var $198=__stackBase__+788;
      var $199=__stackBase__+792;
      var $200=__stackBase__+796;
      var $201=__stackBase__+800;
      var $202=__stackBase__+804;
      var $203=__stackBase__+808;
      var $204=__stackBase__+812;
      var $205=__stackBase__+816;
      var $206=__stackBase__+820;
      var $207=__stackBase__+824;
      var $208=__stackBase__+828;
      var $209=__stackBase__+832;
      var $210=__stackBase__+836;
      var $211=__stackBase__+840;
      var $212=__stackBase__+844;
      var $213=__stackBase__+848;
      var $214=__stackBase__+852;
      var $215=__stackBase__+856;
      var $216=__stackBase__+860;
      var $217=__stackBase__+864;
      var $218=__stackBase__+868;
      var $219=__stackBase__+872;
      var $220=__stackBase__+876;
      var $221=__stackBase__+880;
      var $222=__stackBase__+884;
      var $223=__stackBase__+888;
      var $224=__stackBase__+892;
      var $225=__stackBase__+896;
      var $226=__stackBase__+900;
      var $227=__stackBase__+904;
      var $228=__stackBase__+908;
      var $229=__stackBase__+912;
      var $230=__stackBase__+916;
      var $231=__stackBase__+920;
      var $232=__stackBase__+924;
      var $233=__stackBase__+928;
      var $234=__stackBase__+932;
      var $235=__stackBase__+936;
      var $236=__stackBase__+940;
      var $237=__stackBase__+944;
      var $238=__stackBase__+948;
      var $239=__stackBase__+952;
      var $240=__stackBase__+956;
      var $241=__stackBase__+960;
      var $242=__stackBase__+964;
      var $243=__stackBase__+968;
      var $244=__stackBase__+972;
      var $245=__stackBase__+976;
      var $246=__stackBase__+980;
      var $247=__stackBase__+984;
      var $248=__stackBase__+988;
      var $249=__stackBase__+992;
      var $250=__stackBase__+996;
      var $251=__stackBase__+1000;
      var $252=__stackBase__+1004;
      var $253=__stackBase__+1008;
      var $254=__stackBase__+1012;
      var $255=__stackBase__+1016;
      var $256=__stackBase__+1020;
      var $257=__stackBase__+1024;
      var $258=__stackBase__+1028;
      var $259=__stackBase__+1032;
      var $260=__stackBase__+1036;
      var $261=__stackBase__+1040;
      var $262=__stackBase__+1044;
      var $263=__stackBase__+1048;
      var $264=__stackBase__+1052;
      var $265=__stackBase__+1056;
      var $266=__stackBase__+1060;
      var $267=__stackBase__+1064;
      var $268=__stackBase__+1068;
      var $269=__stackBase__+1072;
      var $270=__stackBase__+1076;
      var $271=__stackBase__+1080;
      var $272=__stackBase__+1084;
      var $273=__stackBase__+1088;
      var $274=__stackBase__+1092;
      var $275=__stackBase__+1096;
      var $276=__stackBase__+1100;
      var $277=__stackBase__+1104;
      var $278=__stackBase__+1108;
      var $279=__stackBase__+1112;
      var $280=__stackBase__+1116;
      var $281=__stackBase__+1120;
      var $282=__stackBase__+1124;
      var $283=__stackBase__+1128;
      var $284=__stackBase__+1132;
      var $285=__stackBase__+1136;
      var $286=__stackBase__+1140;
      var $287=__stackBase__+1144;
      var $288=__stackBase__+1148;
      var $289=__stackBase__+1152;
      var $290=__stackBase__+1156;
      var $291=__stackBase__+1160;
      var $292=__stackBase__+1164;
      var $293=__stackBase__+1168;
      var $294=__stackBase__+1172;
      var $295=__stackBase__+1176;
      var $296=__stackBase__+1180;
      var $297=__stackBase__+1184;
      var $298=__stackBase__+1188;
      var $299=__stackBase__+1192;
      var $300=__stackBase__+1196;
      var $301=__stackBase__+1200;
      var $302=__stackBase__+1204;
      var $303=__stackBase__+1208;
      var $304=__stackBase__+1212;
      var $305=__stackBase__+1216;
      var $306=__stackBase__+1220;
      var $307=__stackBase__+1224;
      var $308=__stackBase__+1228;
      var $309=__stackBase__+1232;
      var $310=__stackBase__+1236;
      var $311=__stackBase__+1240;
      var $312=__stackBase__+1244;
      var $313=__stackBase__+1248;
      var $314=__stackBase__+1252;
      var $315=__stackBase__+1256;
      var $316=__stackBase__+1260;
      var $317=__stackBase__+1264;
      var $318=__stackBase__+1268;
      var $319=__stackBase__+1272;
      var $320=__stackBase__+1276;
      var $321=__stackBase__+1280;
      var $322=__stackBase__+1284;
      var $323=__stackBase__+1288;
      var $324=__stackBase__+1292;
      var $325=__stackBase__+1296;
      var $326=__stackBase__+1300;
      var $327=__stackBase__+1304;
      var $328=__stackBase__+1308;
      var $329=__stackBase__+1312;
      var $330=__stackBase__+1316;
      var $331=__stackBase__+1320;
      var $332=__stackBase__+1324;
      var $333=__stackBase__+1328;
      var $334=__stackBase__+1332;
      var $335=__stackBase__+1336;
      var $336=__stackBase__+1340;
      var $337=__stackBase__+1344;
      var $338=__stackBase__+1348;
      var $339=__stackBase__+1352;
      var $340=__stackBase__+1356;
      var $341=__stackBase__+1360;
      var $342=__stackBase__+1364;
      var $343=__stackBase__+1368;
      var $344=__stackBase__+1372;
      var $345=__stackBase__+1376;
      var $346=__stackBase__+1380;
      var $347=__stackBase__+1384;
      var $348=__stackBase__+1388;
      var $349=__stackBase__+1392;
      var $350=__stackBase__+1396;
      var $351=__stackBase__+1400;
      var $352=__stackBase__+1404;
      var $353=__stackBase__+1408;
      var $354=__stackBase__+1412;
      var $355=__stackBase__+1416;
      var $356=__stackBase__+1420;
      var $357=__stackBase__+1424;
      var $358=__stackBase__+1428;
      var $359=__stackBase__+1432;
      var $360=__stackBase__+1436;
      var $361=__stackBase__+1440;
      var $362=__stackBase__+1444;
      var $363=__stackBase__+1448;
      var $364=__stackBase__+1452;
      var $365=__stackBase__+1456;
      var $366=__stackBase__+1460;
      var $367=__stackBase__+1464;
      var $368=__stackBase__+1468;
      var $369=__stackBase__+1472;
      var $370=__stackBase__+1476;
      var $371=__stackBase__+1480;
      var $372=__stackBase__+1484;
      var $373=__stackBase__+1488;
      var $374=__stackBase__+1492;
      var $375=__stackBase__+1496;
      var $376=__stackBase__+1500;
      var $377=__stackBase__+1504;
      var $378=__stackBase__+1508;
      var $379=__stackBase__+1512;
      var $__a_i_i_i9=__stackBase__+1516;
      var $__i_i_i_i10=__stackBase__+1520;
      var $380=__stackBase__+1524;
      var $381=__stackBase__+1528;
      var $382=__stackBase__+1532;
      var $383=__stackBase__+1536;
      var $384=__stackBase__+1540;
      var $385=__stackBase__+1544;
      var $386=__stackBase__+1548;
      var $387=__stackBase__+1552;
      var $388=__stackBase__+1556;
      var $__a_i_i_i6=__stackBase__+1560;
      var $__i_i_i_i7=__stackBase__+1564;
      var $389=__stackBase__+1568;
      var $390=__stackBase__+1572;
      var $391=__stackBase__+1576;
      var $392=__stackBase__+1580;
      var $393=__stackBase__+1584;
      var $394=__stackBase__+1588;
      var $395=__stackBase__+1592;
      var $396=__stackBase__+1596;
      var $397=__stackBase__+1600;
      var $__a_i_i_i4=__stackBase__+1604;
      var $__i_i_i_i5=__stackBase__+1608;
      var $398=__stackBase__+1612;
      var $399=__stackBase__+1616;
      var $400=__stackBase__+1620;
      var $401=__stackBase__+1624;
      var $402=__stackBase__+1628;
      var $403=__stackBase__+1632;
      var $404=__stackBase__+1636;
      var $405=__stackBase__+1640;
      var $406=__stackBase__+1644;
      var $407=__stackBase__+1648;
      var $408=__stackBase__+1652;
      var $409=__stackBase__+1656;
      var $410=__stackBase__+1660;
      var $411=__stackBase__+1664;
      var $__tmp_i_i_i2=__stackBase__+1668;
      var $412=__stackBase__+1672;
      var $413=__stackBase__+1676;
      var $414=__stackBase__+1680;
      var $415=__stackBase__+1684;
      var $416=__stackBase__+1688;
      var $417=__stackBase__+1692;
      var $418=__stackBase__+1696;
      var $__a_i_i_i=__stackBase__+1700;
      var $__i_i_i_i=__stackBase__+1704;
      var $419=__stackBase__+1708;
      var $420=__stackBase__+1712;
      var $421=__stackBase__+1716;
      var $422=__stackBase__+1720;
      var $423=__stackBase__+1724;
      var $424=__stackBase__+1728;
      var $425=__stackBase__+1732;
      var $426=__stackBase__+1736;
      var $427=__stackBase__+1740;
      var $428=__stackBase__+1744;
      var $429=__stackBase__+1748;
      var $430=__stackBase__+1752;
      var $431=__stackBase__+1756;
      var $432=__stackBase__+1760;
      var $433=__stackBase__+1764;
      var $434=__stackBase__+1768;
      var $435=__stackBase__+1772;
      var $__tmp_i_i_i=__stackBase__+1776;
      var $436=__stackBase__+1780;
      var $437=__stackBase__+1784;
      var $438=__stackBase__+1788;
      var $439=__stackBase__+1792;
      var $440=__stackBase__+1796;
      var $441=__stackBase__+1800;
      var $442=__stackBase__+1804;
      var $443=__stackBase__+1808;
      var $444=__stackBase__+1812;
      var $445=__stackBase__+1816;
      var $446=__stackBase__+1820;
      var $447=__stackBase__+1824;
      var $448=__stackBase__+1828;
      var $449=__stackBase__+1832;
      var $450=__stackBase__+1836;
      var $451=__stackBase__+1840;
      var $452=__stackBase__+1844;
      var $453=__stackBase__+1848;
      var $454=__stackBase__+1852;
      var $455=__stackBase__+1856;
      var $456=__stackBase__+1860;
      var $457=__stackBase__+1864;
      var $458=__stackBase__+1868;
      var $459=__stackBase__+1872;
      var $460=__stackBase__+1876;
      var $461;
      var $462;
      var $463;
      var $464;
      var $465;
      var $466;
      var $467;
      var $468;
      var $469;
      var $470;
      var $471=__stackBase__+1880;
      var $__bz;
      var $__gbuf=__stackBase__+1884;
      var $__gb=__stackBase__+2284;
      var $__gn=__stackBase__+2292;
      var $__ge=__stackBase__+2296;
      var $__pat=__stackBase__+2300;
      var $__dp=__stackBase__+2304;
      var $__ts=__stackBase__+2308;
      var $__grp=__stackBase__+2312;
      var $472;
      var $473;
      var $__sym=__stackBase__+2324;
      var $__psn=__stackBase__+2336;
      var $__nsn=__stackBase__+2348;
      var $__fd=__stackBase__+2360;
      var $__trailing_sign;
      var $__p;
      var $474;
      var $__more_needed;
      var $__sb;
      var $__et=__stackBase__+2364;
      var $__k;
      var $475=__stackBase__+2368;
      var $__ng;
      var $__c;
      var $__i;
      var $__et1=__stackBase__+2372;
      $462=$__b;
      var $476=(($__intl)&1);
      $463=$476;
      $464=$__loc;
      $465=$__flags;
      $466=$__err;
      $467=$__neg;
      $468=$__ct;
      $469=$__wb;
      $470=$__wn;
      HEAP32[(($471)>>2)]=$__we;
      $__bz=100;
      var $477=(($__gbuf)|0);
      var $478=$458;
      var $479=$459;
      var $480=$460;
      HEAP32[(($458)>>2)]=$__gb;
      HEAP32[(($459)>>2)]=$477;
      HEAP32[(($460)>>2)]=1682;
      var $481=HEAP32[(($458)>>2)];
      var $482=HEAP32[(($459)>>2)];
      var $483=HEAP32[(($460)>>2)];
      var $484=$455;
      var $485=$456;
      var $486=$457;
      HEAP32[(($455)>>2)]=$481;
      HEAP32[(($456)>>2)]=$482;
      HEAP32[(($457)>>2)]=$483;
      var $487=HEAP32[(($455)>>2)];
      var $488=(($487)|0);
      var $489=$454;
      HEAP32[(($454)>>2)]=$456;
      var $490=HEAP32[(($454)>>2)];
      var $491=$454;
      var $492=HEAP32[(($490)>>2)];
      var $493=$440;
      HEAP32[(($440)>>2)]=$457;
      var $494=HEAP32[(($440)>>2)];
      var $495=$440;
      var $496=HEAP32[(($494)>>2)];
      var $497=$451;
      var $498=$452;
      var $499=$453;
      HEAP32[(($451)>>2)]=$488;
      HEAP32[(($452)>>2)]=$492;
      HEAP32[(($453)>>2)]=$496;
      var $500=HEAP32[(($451)>>2)];
      var $501=HEAP32[(($452)>>2)];
      var $502=HEAP32[(($453)>>2)];
      var $503=$448;
      var $504=$449;
      var $505=$450;
      HEAP32[(($448)>>2)]=$500;
      HEAP32[(($449)>>2)]=$501;
      HEAP32[(($450)>>2)]=$502;
      var $506=HEAP32[(($448)>>2)];
      var $507=$506;
      var $508=$447;
      HEAP32[(($447)>>2)]=$449;
      var $509=HEAP32[(($447)>>2)];
      var $510=$447;
      var $511=HEAP32[(($509)>>2)];
      var $512=$441;
      HEAP32[(($441)>>2)]=$450;
      var $513=HEAP32[(($441)>>2)];
      var $514=$441;
      var $515=HEAP32[(($513)>>2)];
      var $516=$444;
      var $517=$445;
      var $518=$446;
      HEAP32[(($444)>>2)]=$507;
      HEAP32[(($445)>>2)]=$511;
      HEAP32[(($446)>>2)]=$515;
      var $519=HEAP32[(($444)>>2)];
      var $520=(($519)|0);
      var $521=$443;
      HEAP32[(($443)>>2)]=$445;
      var $522=HEAP32[(($443)>>2)];
      var $523=$443;
      var $524=HEAP32[(($522)>>2)];
      HEAP32[(($520)>>2)]=$524;
      var $525=(($519+4)|0);
      var $526=$442;
      HEAP32[(($442)>>2)]=$446;
      var $527=HEAP32[(($442)>>2)];
      var $528=$442;
      var $529=HEAP32[(($527)>>2)];
      HEAP32[(($525)>>2)]=$529;
      var $530=$444;
      var $531=$445;
      var $532=$446;
      var $533=$448;
      var $534=$449;
      var $535=$450;
      var $536=$451;
      var $537=$452;
      var $538=$453;
      var $539=$455;
      var $540=$456;
      var $541=$457;
      var $542=$458;
      var $543=$459;
      var $544=$460;
      var $545=$427;
      HEAP32[(($427)>>2)]=$__gb;
      var $546=HEAP32[(($427)>>2)];
      var $547=(($546)|0);
      var $548=$426;
      HEAP32[(($426)>>2)]=$547;
      var $549=HEAP32[(($426)>>2)];
      var $550=$549;
      var $551=$425;
      HEAP32[(($425)>>2)]=$550;
      var $552=HEAP32[(($425)>>2)];
      var $553=(($552)|0);
      var $554=$425;
      var $555=$426;
      var $556=HEAP32[(($553)>>2)];
      var $557=$427;
      HEAP32[(($__gn)>>2)]=$556;
      var $558=HEAP32[(($__gn)>>2)];
      var $559=(($558+400)|0);
      HEAP32[(($__ge)>>2)]=$559;
      var $560=$424;
      HEAP32[(($424)>>2)]=$__grp;
      var $561=HEAP32[(($424)>>2)];
      var $562=$423;
      HEAP32[(($423)>>2)]=$561;
      var $563=HEAP32[(($423)>>2)];
      var $564=$563;
      var $565=(($563)|0);
      var $566=$422;
      HEAP32[(($422)>>2)]=$565;
      var $567=HEAP32[(($422)>>2)];
      var $568=$421;
      HEAP32[(($421)>>2)]=$567;
      var $569=HEAP32[(($421)>>2)];
      var $570=$569;
      var $571=$420;
      HEAP32[(($420)>>2)]=$570;
      var $572=HEAP32[(($420)>>2)];
      var $573=$572;
      var $574=$419;
      HEAP32[(($419)>>2)]=$573;
      var $575=HEAP32[(($419)>>2)];
      var $576=$419;
      var $577=(($572)|0);
      var $578=$420;
      var $579=$421;
      var $580=$422;
      var $581=$418;
      var $582=$__a_i_i_i;
      var $583=$__i_i_i_i;
      HEAP32[(($418)>>2)]=$563;
      var $584=HEAP32[(($418)>>2)];
      var $585=(($584)|0);
      var $586=$417;
      HEAP32[(($417)>>2)]=$585;
      var $587=HEAP32[(($417)>>2)];
      var $588=$587;
      var $589=$416;
      HEAP32[(($416)>>2)]=$588;
      var $590=HEAP32[(($416)>>2)];
      var $591=(($590)|0);
      var $592=$416;
      var $593=$417;
      var $594=(($591)|0);
      var $595=$594;
      var $596=(($595)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$596;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $597
      var $598=HEAPU32[(($__i_i_i_i)>>2)];
      var $599=(($598)>>>0) < 3;
      if ($599) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $600
      var $601=HEAP32[(($__i_i_i_i)>>2)];
      var $602=HEAP32[(($__a_i_i_i)>>2)];
      var $603=(($602+($601<<2))|0);
      HEAP32[(($603)>>2)]=0;
      var $604=HEAP32[(($__i_i_i_i)>>2)];
      var $605=(($604+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$605;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $606=$418;
      var $607=$__a_i_i_i;
      var $608=$__i_i_i_i;
      var $609=$423;
      var $610=$424;
      __label__ = 4; break;
    case 4: // $611
      var $612=$403;
      HEAP32[(($403)>>2)]=$__sym;
      var $613=HEAP32[(($403)>>2)];
      var $614=$402;
      HEAP32[(($402)>>2)]=$613;
      var $615=HEAPU32[(($402)>>2)];
      var $616=$615;
      var $617=(($615)|0);
      var $618=$401;
      HEAP32[(($401)>>2)]=$617;
      var $619=HEAP32[(($401)>>2)];
      var $620=$400;
      HEAP32[(($400)>>2)]=$619;
      var $621=HEAP32[(($400)>>2)];
      var $622=$621;
      var $623=$399;
      HEAP32[(($399)>>2)]=$622;
      var $624=HEAP32[(($399)>>2)];
      var $625=$624;
      var $626=$398;
      HEAP32[(($398)>>2)]=$625;
      var $627=HEAP32[(($398)>>2)];
      var $628=$398;
      var $629=(($624)|0);
      var $630=$399;
      var $631=$400;
      var $632=$401;
      var $633=$397;
      var $634=$__a_i_i_i4;
      var $635=$__i_i_i_i5;
      HEAP32[(($397)>>2)]=$615;
      var $636=HEAP32[(($397)>>2)];
      var $637=(($636)|0);
      var $638=$396;
      HEAP32[(($396)>>2)]=$637;
      var $639=HEAP32[(($396)>>2)];
      var $640=$639;
      var $641=$395;
      HEAP32[(($395)>>2)]=$640;
      var $642=HEAP32[(($395)>>2)];
      var $643=(($642)|0);
      var $644=$395;
      var $645=$396;
      var $646=(($643)|0);
      var $647=$646;
      var $648=(($647)|0);
      HEAP32[(($__a_i_i_i4)>>2)]=$648;
      HEAP32[(($__i_i_i_i5)>>2)]=0;
      __label__ = 5; break;
    case 5: // $649
      var $650=HEAPU32[(($__i_i_i_i5)>>2)];
      var $651=(($650)>>>0) < 3;
      if ($651) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $652
      var $653=HEAP32[(($__i_i_i_i5)>>2)];
      var $654=HEAP32[(($__a_i_i_i4)>>2)];
      var $655=(($654+($653<<2))|0);
      HEAP32[(($655)>>2)]=0;
      var $656=HEAP32[(($__i_i_i_i5)>>2)];
      var $657=(($656+1)|0);
      HEAP32[(($__i_i_i_i5)>>2)]=$657;
      __label__ = 5; break;
    case 7: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $658=$397;
      var $659=$__a_i_i_i4;
      var $660=$__i_i_i_i5;
      var $661=$402;
      var $662=$403;
      __label__ = 8; break;
    case 8: // $663
      var $664=$394;
      HEAP32[(($394)>>2)]=$__psn;
      var $665=HEAP32[(($394)>>2)];
      var $666=$393;
      HEAP32[(($393)>>2)]=$665;
      var $667=HEAPU32[(($393)>>2)];
      var $668=$667;
      var $669=(($667)|0);
      var $670=$392;
      HEAP32[(($392)>>2)]=$669;
      var $671=HEAP32[(($392)>>2)];
      var $672=$391;
      HEAP32[(($391)>>2)]=$671;
      var $673=HEAP32[(($391)>>2)];
      var $674=$673;
      var $675=$390;
      HEAP32[(($390)>>2)]=$674;
      var $676=HEAP32[(($390)>>2)];
      var $677=$676;
      var $678=$389;
      HEAP32[(($389)>>2)]=$677;
      var $679=HEAP32[(($389)>>2)];
      var $680=$389;
      var $681=(($676)|0);
      var $682=$390;
      var $683=$391;
      var $684=$392;
      var $685=$388;
      var $686=$__a_i_i_i6;
      var $687=$__i_i_i_i7;
      HEAP32[(($388)>>2)]=$667;
      var $688=HEAP32[(($388)>>2)];
      var $689=(($688)|0);
      var $690=$387;
      HEAP32[(($387)>>2)]=$689;
      var $691=HEAP32[(($387)>>2)];
      var $692=$691;
      var $693=$386;
      HEAP32[(($386)>>2)]=$692;
      var $694=HEAP32[(($386)>>2)];
      var $695=(($694)|0);
      var $696=$386;
      var $697=$387;
      var $698=(($695)|0);
      var $699=$698;
      var $700=(($699)|0);
      HEAP32[(($__a_i_i_i6)>>2)]=$700;
      HEAP32[(($__i_i_i_i7)>>2)]=0;
      __label__ = 9; break;
    case 9: // $701
      var $702=HEAPU32[(($__i_i_i_i7)>>2)];
      var $703=(($702)>>>0) < 3;
      if ($703) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $704
      var $705=HEAP32[(($__i_i_i_i7)>>2)];
      var $706=HEAP32[(($__a_i_i_i6)>>2)];
      var $707=(($706+($705<<2))|0);
      HEAP32[(($707)>>2)]=0;
      var $708=HEAP32[(($__i_i_i_i7)>>2)];
      var $709=(($708+1)|0);
      HEAP32[(($__i_i_i_i7)>>2)]=$709;
      __label__ = 9; break;
    case 11: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit8
      var $710=$388;
      var $711=$__a_i_i_i6;
      var $712=$__i_i_i_i7;
      var $713=$393;
      var $714=$394;
      __label__ = 12; break;
    case 12: // $715
      var $716=$385;
      HEAP32[(($385)>>2)]=$__nsn;
      var $717=HEAP32[(($385)>>2)];
      var $718=$384;
      HEAP32[(($384)>>2)]=$717;
      var $719=HEAPU32[(($384)>>2)];
      var $720=$719;
      var $721=(($719)|0);
      var $722=$383;
      HEAP32[(($383)>>2)]=$721;
      var $723=HEAP32[(($383)>>2)];
      var $724=$382;
      HEAP32[(($382)>>2)]=$723;
      var $725=HEAP32[(($382)>>2)];
      var $726=$725;
      var $727=$381;
      HEAP32[(($381)>>2)]=$726;
      var $728=HEAP32[(($381)>>2)];
      var $729=$728;
      var $730=$380;
      HEAP32[(($380)>>2)]=$729;
      var $731=HEAP32[(($380)>>2)];
      var $732=$380;
      var $733=(($728)|0);
      var $734=$381;
      var $735=$382;
      var $736=$383;
      var $737=$379;
      var $738=$__a_i_i_i9;
      var $739=$__i_i_i_i10;
      HEAP32[(($379)>>2)]=$719;
      var $740=HEAP32[(($379)>>2)];
      var $741=(($740)|0);
      var $742=$378;
      HEAP32[(($378)>>2)]=$741;
      var $743=HEAP32[(($378)>>2)];
      var $744=$743;
      var $745=$377;
      HEAP32[(($377)>>2)]=$744;
      var $746=HEAP32[(($377)>>2)];
      var $747=(($746)|0);
      var $748=$377;
      var $749=$378;
      var $750=(($747)|0);
      var $751=$750;
      var $752=(($751)|0);
      HEAP32[(($__a_i_i_i9)>>2)]=$752;
      HEAP32[(($__i_i_i_i10)>>2)]=0;
      __label__ = 13; break;
    case 13: // $753
      var $754=HEAPU32[(($__i_i_i_i10)>>2)];
      var $755=(($754)>>>0) < 3;
      if ($755) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $756
      var $757=HEAP32[(($__i_i_i_i10)>>2)];
      var $758=HEAP32[(($__a_i_i_i9)>>2)];
      var $759=(($758+($757<<2))|0);
      HEAP32[(($759)>>2)]=0;
      var $760=HEAP32[(($__i_i_i_i10)>>2)];
      var $761=(($760+1)|0);
      HEAP32[(($__i_i_i_i10)>>2)]=$761;
      __label__ = 13; break;
    case 15: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit11
      var $762=$379;
      var $763=$__a_i_i_i9;
      var $764=$__i_i_i_i10;
      var $765=$384;
      var $766=$385;
      __label__ = 16; break;
    case 16: // $767
      var $768=$463;
      var $769=(($768) & 1);
      var $770=$464;
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri($769, $770, $__pat, $__dp, $__ts, $__grp, $__sym, $__psn, $__nsn, $__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 27; break; }
    case 17: // $771
      $__trailing_sign=0;
      var $772=$469;
      var $773=$359;
      HEAP32[(($359)>>2)]=$772;
      var $774=HEAP32[(($359)>>2)];
      var $775=(($774)|0);
      var $776=$358;
      HEAP32[(($358)>>2)]=$775;
      var $777=HEAP32[(($358)>>2)];
      var $778=$777;
      var $779=$357;
      HEAP32[(($357)>>2)]=$778;
      var $780=HEAP32[(($357)>>2)];
      var $781=(($780)|0);
      var $782=$357;
      var $783=$358;
      var $784=HEAP32[(($781)>>2)];
      var $785=$359;
      var $786=$470;
      HEAP32[(($786)>>2)]=$784;
      $__p=0;
      __label__ = 18; break;
    case 18: // $787
      var $788=$__p;
      var $789=(($788)>>>0) < 4;
      if ($789) { __label__ = 19; break; } else { var $816 = 0;__label__ = 21; break; }
    case 19: // $790
      var $791=$462;
      var $792=$355;
      var $793=$356;
      HEAP32[(($355)>>2)]=$791;
      HEAP32[(($356)>>2)]=$__e;
      var $794=HEAP32[(($355)>>2)];
      var $795=HEAP32[(($356)>>2)];
      var $796=$353;
      var $797=$354;
      HEAP32[(($353)>>2)]=$794;
      HEAP32[(($354)>>2)]=$795;
      var $798=HEAP32[(($353)>>2)];
      var $799=(($798)|0);
      var $800=HEAP32[(($799)>>2)];
      var $801=(($800)|0)==0;
      var $802=(($801)&1);
      var $803=HEAP32[(($354)>>2)];
      var $804=(($803)|0);
      var $805=HEAP32[(($804)>>2)];
      var $806=(($805)|0)==0;
      var $807=(($806)&1);
      var $808=(($802)|0)==(($807)|0);
      var $809=$353;
      var $810=$354;
      var $811=$808 ^ 1;
      var $812=$355;
      var $813=$356;
      __label__ = 20; break;
    case 20: // $814
      var $816 = $811;__label__ = 21; break;
    case 21: // $815
      var $816;
      if ($816) { __label__ = 22; break; } else { __label__ = 362; break; }
    case 22: // $817
      var $818=$__p;
      var $819=(($__pat)|0);
      var $820=(($819+$818)|0);
      var $821=HEAP8[($820)];
      var $822=(($821 << 24) >> 24);
      if ($822 == 1) {
        __label__ = 28; break;
      }
      else if ($822 == 0) {
        __label__ = 55; break;
      }
      else if ($822 == 3) {
        __label__ = 85; break;
      }
      else if ($822 == 2) {
        __label__ = 233; break;
      }
      else if ($822 == 4) {
        __label__ = 246; break;
      }
      else {
      __label__ = 360; break;
      }
      
    case 23: // $823
      var $824=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $825=$824.f0;
      $472=$825;
      var $826=$824.f1;
      $473=$826;
      __label__ = 420; break;
    case 24: // $827
      var $828=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $829=$828.f0;
      $472=$829;
      var $830=$828.f1;
      $473=$830;
      __label__ = 418; break;
    case 25: // $831
      var $832=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $833=$832.f0;
      $472=$833;
      var $834=$832.f1;
      $473=$834;
      __label__ = 411; break;
    case 26: // $835
      var $836=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $837=$836.f0;
      $472=$837;
      var $838=$836.f1;
      $473=$838;
      __label__ = 408; break;
    case 27: // $839
      var $840=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $841=$840.f0;
      $472=$841;
      var $842=$840.f1;
      $473=$842;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nsn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 406; break; } else { __label__ = 427; break; }
    case 28: // $843
      var $844=$__p;
      var $845=(($844)|0)!=3;
      if ($845) { __label__ = 29; break; } else { __label__ = 54; break; }
    case 29: // $846
      var $847=$468;
      var $848=$462;
      var $849=$335;
      HEAP32[(($335)>>2)]=$848;
      var $850=HEAP32[(($335)>>2)];
      var $851=(($850)|0);
      var $852=HEAP32[(($851)>>2)];
      var $853=$333;
      var $854=$334;
      HEAP32[(($334)>>2)]=$852;
      var $855=HEAP32[(($334)>>2)];
      var $856=(($855+12)|0);
      var $857=HEAP32[(($856)>>2)];
      var $858=(($855+16)|0);
      var $859=HEAP32[(($858)>>2)];
      var $860=(($857)|0)==(($859)|0);
      if ($860) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $861
      var $862=$855;
      var $863=HEAP32[(($862)>>2)];
      var $864=(($863+36)|0);
      var $865=HEAP32[(($864)>>2)];
      var $866=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$865]($855) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 27; break; };
    case 31: // $_noexc14
      HEAP32[(($333)>>2)]=$866;
      __label__ = 33; break;
    case 32: // $867
      var $868=(($855+12)|0);
      var $869=HEAP32[(($868)>>2)];
      var $870=HEAP32[(($869)>>2)];
      var $871=$332;
      HEAP32[(($332)>>2)]=$870;
      var $872=HEAP32[(($332)>>2)];
      var $873=$332;
      HEAP32[(($333)>>2)]=$872;
      __label__ = 33; break;
    case 33: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit15
      var $874=HEAP32[(($333)>>2)];
      var $875=$333;
      var $876=$334;
      var $877=$335;
      __label__ = 34; break;
    case 34: // $878
      var $879=$329;
      var $880=$330;
      var $881=$331;
      HEAP32[(($329)>>2)]=$847;
      HEAP32[(($330)>>2)]=16384;
      HEAP32[(($331)>>2)]=$874;
      var $882=HEAP32[(($329)>>2)];
      var $883=$882;
      var $884=HEAP32[(($883)>>2)];
      var $885=(($884+12)|0);
      var $886=HEAP32[(($885)>>2)];
      var $887=HEAP32[(($330)>>2)];
      var $888=HEAP32[(($331)>>2)];
      var $889=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$886]($882, $887, $888) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 27; break; };
    case 35: // $_ZNKSt3__15ctypeIwE2isEjw_exit
      var $890=$329;
      var $891=$330;
      var $892=$331;
      __label__ = 36; break;
    case 36: // $893
      if ($889) { __label__ = 37; break; } else { __label__ = 52; break; }
    case 37: // $894
      var $895=$462;
      var $896=$328;
      HEAP32[(($328)>>2)]=$895;
      var $897=HEAP32[(($328)>>2)];
      var $898=(($897)|0);
      var $899=HEAP32[(($898)>>2)];
      var $900=$326;
      var $901=$327;
      HEAP32[(($327)>>2)]=$899;
      var $902=HEAP32[(($327)>>2)];
      var $903=$324;
      var $904=$325;
      HEAP32[(($325)>>2)]=$902;
      var $905=HEAP32[(($325)>>2)];
      var $906=(($905+12)|0);
      var $907=HEAP32[(($906)>>2)];
      var $908=(($905+16)|0);
      var $909=HEAP32[(($908)>>2)];
      var $910=(($907)|0)==(($909)|0);
      if ($910) { __label__ = 38; break; } else { __label__ = 40; break; }
    case 38: // $911
      var $912=$905;
      var $913=HEAP32[(($912)>>2)];
      var $914=(($913+40)|0);
      var $915=HEAP32[(($914)>>2)];
      var $916=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$915]($905) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 27; break; };
    case 39: // $_noexc20
      HEAP32[(($324)>>2)]=$916;
      __label__ = 41; break;
    case 40: // $917
      var $918=(($905+12)|0);
      var $919=HEAP32[(($918)>>2)];
      var $920=(($919+4)|0);
      HEAP32[(($918)>>2)]=$920;
      var $921=HEAP32[(($919)>>2)];
      var $922=$323;
      HEAP32[(($323)>>2)]=$921;
      var $923=HEAP32[(($323)>>2)];
      var $924=$323;
      HEAP32[(($324)>>2)]=$923;
      __label__ = 41; break;
    case 41: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i17
      var $925=HEAP32[(($324)>>2)];
      var $926=$324;
      var $927=$325;
      var $928=(($925)|0)==-1;
      if ($928) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $929
      HEAP32[(($326)>>2)]=-1;
      __label__ = 48; break;
    case 43: // $930
      var $931=$321;
      var $932=$322;
      HEAP32[(($322)>>2)]=$902;
      var $933=HEAP32[(($322)>>2)];
      var $934=(($933+12)|0);
      var $935=HEAP32[(($934)>>2)];
      var $936=(($933+16)|0);
      var $937=HEAP32[(($936)>>2)];
      var $938=(($935)|0)==(($937)|0);
      if ($938) { __label__ = 44; break; } else { __label__ = 46; break; }
    case 44: // $939
      var $940=$933;
      var $941=HEAP32[(($940)>>2)];
      var $942=(($941+36)|0);
      var $943=HEAP32[(($942)>>2)];
      var $944=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$943]($933) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 27; break; };
    case 45: // $_noexc21
      HEAP32[(($321)>>2)]=$944;
      __label__ = 47; break;
    case 46: // $945
      var $946=(($933+12)|0);
      var $947=HEAP32[(($946)>>2)];
      var $948=HEAP32[(($947)>>2)];
      var $949=$320;
      HEAP32[(($320)>>2)]=$948;
      var $950=HEAP32[(($320)>>2)];
      var $951=$320;
      HEAP32[(($321)>>2)]=$950;
      __label__ = 47; break;
    case 47: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i18
      var $952=HEAP32[(($321)>>2)];
      var $953=$321;
      var $954=$322;
      HEAP32[(($326)>>2)]=$952;
      __label__ = 48; break;
    case 48: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i19
      var $955=HEAP32[(($326)>>2)];
      var $956=$326;
      var $957=$327;
      var $958=$318;
      var $959=$319;
      HEAP32[(($318)>>2)]=$955;
      HEAP32[(($319)>>2)]=-1;
      var $960=HEAP32[(($318)>>2)];
      var $961=HEAP32[(($319)>>2)];
      var $962=(($960)|0)==(($961)|0);
      var $963=$318;
      var $964=$319;
      if ($962) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $965
      var $966=(($897)|0);
      HEAP32[(($966)>>2)]=0;
      __label__ = 50; break;
    case 50: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit22
      var $967=$328;
      __label__ = 51; break;
    case 51: // $968
      __label__ = 53; break;
    case 52: // $969
      var $970=$466;
      var $971=HEAP32[(($970)>>2)];
      var $972=$971 | 4;
      HEAP32[(($970)>>2)]=$972;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 53: // $973
      __label__ = 54; break;
    case 54: // $974
      __label__ = 55; break;
    case 55: // $975
      var $976=$__p;
      var $977=(($976)|0)!=3;
      if ($977) { __label__ = 56; break; } else { __label__ = 84; break; }
    case 56: // $978
      __label__ = 57; break;
    case 57: // $979
      var $980=$462;
      var $981=$316;
      var $982=$317;
      HEAP32[(($316)>>2)]=$980;
      HEAP32[(($317)>>2)]=$__e;
      var $983=HEAP32[(($316)>>2)];
      var $984=HEAP32[(($317)>>2)];
      var $985=$314;
      var $986=$315;
      HEAP32[(($314)>>2)]=$983;
      HEAP32[(($315)>>2)]=$984;
      var $987=HEAP32[(($314)>>2)];
      var $988=(($987)|0);
      var $989=HEAP32[(($988)>>2)];
      var $990=(($989)|0)==0;
      var $991=(($990)&1);
      var $992=HEAP32[(($315)>>2)];
      var $993=(($992)|0);
      var $994=HEAP32[(($993)>>2)];
      var $995=(($994)|0)==0;
      var $996=(($995)&1);
      var $997=(($991)|0)==(($996)|0);
      var $998=$314;
      var $999=$315;
      var $1000=$997 ^ 1;
      var $1001=$316;
      var $1002=$317;
      __label__ = 58; break;
    case 58: // $1003
      if ($1000) { __label__ = 59; break; } else { var $1053 = 0;__label__ = 67; break; }
    case 59: // $1004
      var $1005=$468;
      var $1006=$462;
      var $1007=$313;
      HEAP32[(($313)>>2)]=$1006;
      var $1008=HEAP32[(($313)>>2)];
      var $1009=(($1008)|0);
      var $1010=HEAP32[(($1009)>>2)];
      var $1011=$311;
      var $1012=$312;
      HEAP32[(($312)>>2)]=$1010;
      var $1013=HEAP32[(($312)>>2)];
      var $1014=(($1013+12)|0);
      var $1015=HEAP32[(($1014)>>2)];
      var $1016=(($1013+16)|0);
      var $1017=HEAP32[(($1016)>>2)];
      var $1018=(($1015)|0)==(($1017)|0);
      if ($1018) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $1019
      var $1020=$1013;
      var $1021=HEAP32[(($1020)>>2)];
      var $1022=(($1021+36)|0);
      var $1023=HEAP32[(($1022)>>2)];
      var $1024=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1023]($1013) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 27; break; };
    case 61: // $_noexc23
      HEAP32[(($311)>>2)]=$1024;
      __label__ = 63; break;
    case 62: // $1025
      var $1026=(($1013+12)|0);
      var $1027=HEAP32[(($1026)>>2)];
      var $1028=HEAP32[(($1027)>>2)];
      var $1029=$310;
      HEAP32[(($310)>>2)]=$1028;
      var $1030=HEAP32[(($310)>>2)];
      var $1031=$310;
      HEAP32[(($311)>>2)]=$1030;
      __label__ = 63; break;
    case 63: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit24
      var $1032=HEAP32[(($311)>>2)];
      var $1033=$311;
      var $1034=$312;
      var $1035=$313;
      __label__ = 64; break;
    case 64: // $1036
      var $1037=$307;
      var $1038=$308;
      var $1039=$309;
      HEAP32[(($307)>>2)]=$1005;
      HEAP32[(($308)>>2)]=16384;
      HEAP32[(($309)>>2)]=$1032;
      var $1040=HEAP32[(($307)>>2)];
      var $1041=$1040;
      var $1042=HEAP32[(($1041)>>2)];
      var $1043=(($1042+12)|0);
      var $1044=HEAP32[(($1043)>>2)];
      var $1045=HEAP32[(($308)>>2)];
      var $1046=HEAP32[(($309)>>2)];
      var $1047=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1044]($1040, $1045, $1046) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 27; break; };
    case 65: // $_ZNKSt3__15ctypeIwE2isEjw_exit26
      var $1048=$307;
      var $1049=$308;
      var $1050=$309;
      __label__ = 66; break;
    case 66: // $1051
      var $1053 = $1047;__label__ = 67; break;
    case 67: // $1052
      var $1053;
      if ($1053) { __label__ = 68; break; } else { __label__ = 83; break; }
    case 68: // $1054
      var $1055=$462;
      var $1056=$306;
      HEAP32[(($306)>>2)]=$1055;
      var $1057=HEAPU32[(($306)>>2)];
      var $1058=(($1057)|0);
      var $1059=HEAP32[(($1058)>>2)];
      var $1060=$304;
      var $1061=$305;
      HEAP32[(($305)>>2)]=$1059;
      var $1062=HEAP32[(($305)>>2)];
      var $1063=$302;
      var $1064=$303;
      HEAP32[(($303)>>2)]=$1062;
      var $1065=HEAP32[(($303)>>2)];
      var $1066=(($1065+12)|0);
      var $1067=HEAP32[(($1066)>>2)];
      var $1068=(($1065+16)|0);
      var $1069=HEAP32[(($1068)>>2)];
      var $1070=(($1067)|0)==(($1069)|0);
      if ($1070) { __label__ = 69; break; } else { __label__ = 71; break; }
    case 69: // $1071
      var $1072=$1065;
      var $1073=HEAP32[(($1072)>>2)];
      var $1074=(($1073+40)|0);
      var $1075=HEAP32[(($1074)>>2)];
      var $1076=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1075]($1065) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 27; break; };
    case 70: // $_noexc30
      HEAP32[(($302)>>2)]=$1076;
      __label__ = 72; break;
    case 71: // $1077
      var $1078=(($1065+12)|0);
      var $1079=HEAP32[(($1078)>>2)];
      var $1080=(($1079+4)|0);
      HEAP32[(($1078)>>2)]=$1080;
      var $1081=HEAP32[(($1079)>>2)];
      var $1082=$301;
      HEAP32[(($301)>>2)]=$1081;
      var $1083=HEAP32[(($301)>>2)];
      var $1084=$301;
      HEAP32[(($302)>>2)]=$1083;
      __label__ = 72; break;
    case 72: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i27
      var $1085=HEAP32[(($302)>>2)];
      var $1086=$302;
      var $1087=$303;
      var $1088=(($1085)|0)==-1;
      if ($1088) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $1089
      HEAP32[(($304)>>2)]=-1;
      __label__ = 79; break;
    case 74: // $1090
      var $1091=$299;
      var $1092=$300;
      HEAP32[(($300)>>2)]=$1062;
      var $1093=HEAP32[(($300)>>2)];
      var $1094=(($1093+12)|0);
      var $1095=HEAP32[(($1094)>>2)];
      var $1096=(($1093+16)|0);
      var $1097=HEAP32[(($1096)>>2)];
      var $1098=(($1095)|0)==(($1097)|0);
      if ($1098) { __label__ = 75; break; } else { __label__ = 77; break; }
    case 75: // $1099
      var $1100=$1093;
      var $1101=HEAP32[(($1100)>>2)];
      var $1102=(($1101+36)|0);
      var $1103=HEAP32[(($1102)>>2)];
      var $1104=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1103]($1093) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 76; break; } else { __label__ = 27; break; };
    case 76: // $_noexc31
      HEAP32[(($299)>>2)]=$1104;
      __label__ = 78; break;
    case 77: // $1105
      var $1106=(($1093+12)|0);
      var $1107=HEAP32[(($1106)>>2)];
      var $1108=HEAP32[(($1107)>>2)];
      var $1109=$298;
      HEAP32[(($298)>>2)]=$1108;
      var $1110=HEAP32[(($298)>>2)];
      var $1111=$298;
      HEAP32[(($299)>>2)]=$1110;
      __label__ = 78; break;
    case 78: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i28
      var $1112=HEAP32[(($299)>>2)];
      var $1113=$299;
      var $1114=$300;
      HEAP32[(($304)>>2)]=$1112;
      __label__ = 79; break;
    case 79: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i29
      var $1115=HEAP32[(($304)>>2)];
      var $1116=$304;
      var $1117=$305;
      var $1118=$296;
      var $1119=$297;
      HEAP32[(($296)>>2)]=$1115;
      HEAP32[(($297)>>2)]=-1;
      var $1120=HEAP32[(($296)>>2)];
      var $1121=HEAP32[(($297)>>2)];
      var $1122=(($1120)|0)==(($1121)|0);
      var $1123=$296;
      var $1124=$297;
      if ($1122) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $1125
      var $1126=(($1057)|0);
      HEAP32[(($1126)>>2)]=0;
      __label__ = 81; break;
    case 81: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit32
      var $1127=$306;
      __label__ = 82; break;
    case 82: // $1128
      __label__ = 57; break;
    case 83: // $1129
      __label__ = 84; break;
    case 84: // $1130
      __label__ = 360; break;
    case 85: // $1131
      var $1132=$295;
      HEAP32[(($295)>>2)]=$__psn;
      var $1133=HEAPU32[(($295)>>2)];
      var $1134=$294;
      HEAP32[(($294)>>2)]=$1133;
      var $1135=HEAP32[(($294)>>2)];
      var $1136=(($1135)|0);
      var $1137=$293;
      HEAP32[(($293)>>2)]=$1136;
      var $1138=HEAP32[(($293)>>2)];
      var $1139=$1138;
      var $1140=$292;
      HEAP32[(($292)>>2)]=$1139;
      var $1141=HEAP32[(($292)>>2)];
      var $1142=(($1141)|0);
      var $1143=$292;
      var $1144=$293;
      var $1145=(($1142)|0);
      var $1146=$1145;
      var $1147=(($1146)|0);
      var $1148=$1147;
      var $1149=HEAPU8[($1148)];
      var $1150=(($1149)&255);
      var $1151=$1150 & 1;
      var $1152=(($1151)|0)!=0;
      var $1153=$294;
      if ($1152) { __label__ = 86; break; } else { __label__ = 87; break; }
    case 86: // $1154
      var $1155=$288;
      HEAP32[(($288)>>2)]=$1133;
      var $1156=HEAP32[(($288)>>2)];
      var $1157=(($1156)|0);
      var $1158=$287;
      HEAP32[(($287)>>2)]=$1157;
      var $1159=HEAP32[(($287)>>2)];
      var $1160=$1159;
      var $1161=$286;
      HEAP32[(($286)>>2)]=$1160;
      var $1162=HEAP32[(($286)>>2)];
      var $1163=(($1162)|0);
      var $1164=$286;
      var $1165=$287;
      var $1166=(($1163)|0);
      var $1167=$1166;
      var $1168=(($1167+4)|0);
      var $1169=HEAP32[(($1168)>>2)];
      var $1170=$288;
      var $1191 = $1169;__label__ = 88; break;
    case 87: // $1171
      var $1172=$291;
      HEAP32[(($291)>>2)]=$1133;
      var $1173=HEAP32[(($291)>>2)];
      var $1174=(($1173)|0);
      var $1175=$290;
      HEAP32[(($290)>>2)]=$1174;
      var $1176=HEAP32[(($290)>>2)];
      var $1177=$1176;
      var $1178=$289;
      HEAP32[(($289)>>2)]=$1177;
      var $1179=HEAP32[(($289)>>2)];
      var $1180=(($1179)|0);
      var $1181=$289;
      var $1182=$290;
      var $1183=(($1180)|0);
      var $1184=$1183;
      var $1185=(($1184)|0);
      var $1186=$1185;
      var $1187=HEAPU8[($1186)];
      var $1188=(($1187)&255);
      var $1189=$1188 >> 1;
      var $1190=$291;
      var $1191 = $1189;__label__ = 88; break;
    case 88: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $1191;
      var $1192=$295;
      var $1193=$285;
      HEAP32[(($285)>>2)]=$__nsn;
      var $1194=HEAPU32[(($285)>>2)];
      var $1195=$284;
      HEAP32[(($284)>>2)]=$1194;
      var $1196=HEAP32[(($284)>>2)];
      var $1197=(($1196)|0);
      var $1198=$283;
      HEAP32[(($283)>>2)]=$1197;
      var $1199=HEAP32[(($283)>>2)];
      var $1200=$1199;
      var $1201=$282;
      HEAP32[(($282)>>2)]=$1200;
      var $1202=HEAP32[(($282)>>2)];
      var $1203=(($1202)|0);
      var $1204=$282;
      var $1205=$283;
      var $1206=(($1203)|0);
      var $1207=$1206;
      var $1208=(($1207)|0);
      var $1209=$1208;
      var $1210=HEAPU8[($1209)];
      var $1211=(($1210)&255);
      var $1212=$1211 & 1;
      var $1213=(($1212)|0)!=0;
      var $1214=$284;
      if ($1213) { __label__ = 89; break; } else { __label__ = 90; break; }
    case 89: // $1215
      var $1216=$278;
      HEAP32[(($278)>>2)]=$1194;
      var $1217=HEAP32[(($278)>>2)];
      var $1218=(($1217)|0);
      var $1219=$277;
      HEAP32[(($277)>>2)]=$1218;
      var $1220=HEAP32[(($277)>>2)];
      var $1221=$1220;
      var $1222=$276;
      HEAP32[(($276)>>2)]=$1221;
      var $1223=HEAP32[(($276)>>2)];
      var $1224=(($1223)|0);
      var $1225=$276;
      var $1226=$277;
      var $1227=(($1224)|0);
      var $1228=$1227;
      var $1229=(($1228+4)|0);
      var $1230=HEAP32[(($1229)>>2)];
      var $1231=$278;
      var $1252 = $1230;__label__ = 91; break;
    case 90: // $1232
      var $1233=$281;
      HEAP32[(($281)>>2)]=$1194;
      var $1234=HEAP32[(($281)>>2)];
      var $1235=(($1234)|0);
      var $1236=$280;
      HEAP32[(($280)>>2)]=$1235;
      var $1237=HEAP32[(($280)>>2)];
      var $1238=$1237;
      var $1239=$279;
      HEAP32[(($279)>>2)]=$1238;
      var $1240=HEAP32[(($279)>>2)];
      var $1241=(($1240)|0);
      var $1242=$279;
      var $1243=$280;
      var $1244=(($1241)|0);
      var $1245=$1244;
      var $1246=(($1245)|0);
      var $1247=$1246;
      var $1248=HEAPU8[($1247)];
      var $1249=(($1248)&255);
      var $1250=$1249 >> 1;
      var $1251=$281;
      var $1252 = $1250;__label__ = 91; break;
    case 91: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit33
      var $1252;
      var $1253=$285;
      var $1254=(($1191+$1252)|0);
      var $1255=(($1254)>>>0) > 0;
      if ($1255) { __label__ = 92; break; } else { __label__ = 232; break; }
    case 92: // $1256
      var $1257=$247;
      HEAP32[(($247)>>2)]=$__psn;
      var $1258=HEAPU32[(($247)>>2)];
      var $1259=$246;
      HEAP32[(($246)>>2)]=$1258;
      var $1260=HEAP32[(($246)>>2)];
      var $1261=(($1260)|0);
      var $1262=$245;
      HEAP32[(($245)>>2)]=$1261;
      var $1263=HEAP32[(($245)>>2)];
      var $1264=$1263;
      var $1265=$244;
      HEAP32[(($244)>>2)]=$1264;
      var $1266=HEAP32[(($244)>>2)];
      var $1267=(($1266)|0);
      var $1268=$244;
      var $1269=$245;
      var $1270=(($1267)|0);
      var $1271=$1270;
      var $1272=(($1271)|0);
      var $1273=$1272;
      var $1274=HEAPU8[($1273)];
      var $1275=(($1274)&255);
      var $1276=$1275 & 1;
      var $1277=(($1276)|0)!=0;
      var $1278=$246;
      if ($1277) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $1279
      var $1280=$240;
      HEAP32[(($240)>>2)]=$1258;
      var $1281=HEAP32[(($240)>>2)];
      var $1282=(($1281)|0);
      var $1283=$239;
      HEAP32[(($239)>>2)]=$1282;
      var $1284=HEAP32[(($239)>>2)];
      var $1285=$1284;
      var $1286=$238;
      HEAP32[(($238)>>2)]=$1285;
      var $1287=HEAP32[(($238)>>2)];
      var $1288=(($1287)|0);
      var $1289=$238;
      var $1290=$239;
      var $1291=(($1288)|0);
      var $1292=$1291;
      var $1293=(($1292+4)|0);
      var $1294=HEAP32[(($1293)>>2)];
      var $1295=$240;
      var $1316 = $1294;__label__ = 95; break;
    case 94: // $1296
      var $1297=$243;
      HEAP32[(($243)>>2)]=$1258;
      var $1298=HEAP32[(($243)>>2)];
      var $1299=(($1298)|0);
      var $1300=$242;
      HEAP32[(($242)>>2)]=$1299;
      var $1301=HEAP32[(($242)>>2)];
      var $1302=$1301;
      var $1303=$241;
      HEAP32[(($241)>>2)]=$1302;
      var $1304=HEAP32[(($241)>>2)];
      var $1305=(($1304)|0);
      var $1306=$241;
      var $1307=$242;
      var $1308=(($1305)|0);
      var $1309=$1308;
      var $1310=(($1309)|0);
      var $1311=$1310;
      var $1312=HEAPU8[($1311)];
      var $1313=(($1312)&255);
      var $1314=$1313 >> 1;
      var $1315=$243;
      var $1316 = $1314;__label__ = 95; break;
    case 95: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit41
      var $1316;
      var $1317=$247;
      var $1318=(($1316)|0)==0;
      if ($1318) { __label__ = 100; break; } else { __label__ = 96; break; }
    case 96: // $1319
      var $1320=$237;
      HEAP32[(($237)>>2)]=$__nsn;
      var $1321=HEAPU32[(($237)>>2)];
      var $1322=$236;
      HEAP32[(($236)>>2)]=$1321;
      var $1323=HEAP32[(($236)>>2)];
      var $1324=(($1323)|0);
      var $1325=$235;
      HEAP32[(($235)>>2)]=$1324;
      var $1326=HEAP32[(($235)>>2)];
      var $1327=$1326;
      var $1328=$234;
      HEAP32[(($234)>>2)]=$1327;
      var $1329=HEAP32[(($234)>>2)];
      var $1330=(($1329)|0);
      var $1331=$234;
      var $1332=$235;
      var $1333=(($1330)|0);
      var $1334=$1333;
      var $1335=(($1334)|0);
      var $1336=$1335;
      var $1337=HEAPU8[($1336)];
      var $1338=(($1337)&255);
      var $1339=$1338 & 1;
      var $1340=(($1339)|0)!=0;
      var $1341=$236;
      if ($1340) { __label__ = 97; break; } else { __label__ = 98; break; }
    case 97: // $1342
      var $1343=$230;
      HEAP32[(($230)>>2)]=$1321;
      var $1344=HEAP32[(($230)>>2)];
      var $1345=(($1344)|0);
      var $1346=$229;
      HEAP32[(($229)>>2)]=$1345;
      var $1347=HEAP32[(($229)>>2)];
      var $1348=$1347;
      var $1349=$228;
      HEAP32[(($228)>>2)]=$1348;
      var $1350=HEAP32[(($228)>>2)];
      var $1351=(($1350)|0);
      var $1352=$228;
      var $1353=$229;
      var $1354=(($1351)|0);
      var $1355=$1354;
      var $1356=(($1355+4)|0);
      var $1357=HEAP32[(($1356)>>2)];
      var $1358=$230;
      var $1379 = $1357;__label__ = 99; break;
    case 98: // $1359
      var $1360=$233;
      HEAP32[(($233)>>2)]=$1321;
      var $1361=HEAP32[(($233)>>2)];
      var $1362=(($1361)|0);
      var $1363=$232;
      HEAP32[(($232)>>2)]=$1362;
      var $1364=HEAP32[(($232)>>2)];
      var $1365=$1364;
      var $1366=$231;
      HEAP32[(($231)>>2)]=$1365;
      var $1367=HEAP32[(($231)>>2)];
      var $1368=(($1367)|0);
      var $1369=$231;
      var $1370=$232;
      var $1371=(($1368)|0);
      var $1372=$1371;
      var $1373=(($1372)|0);
      var $1374=$1373;
      var $1375=HEAPU8[($1374)];
      var $1376=(($1375)&255);
      var $1377=$1376 >> 1;
      var $1378=$233;
      var $1379 = $1377;__label__ = 99; break;
    case 99: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit42
      var $1379;
      var $1380=$237;
      var $1381=(($1379)|0)==0;
      if ($1381) { __label__ = 100; break; } else { __label__ = 168; break; }
    case 100: // $1382
      var $1383=$223;
      HEAP32[(($223)>>2)]=$__psn;
      var $1384=HEAPU32[(($223)>>2)];
      var $1385=$222;
      HEAP32[(($222)>>2)]=$1384;
      var $1386=HEAP32[(($222)>>2)];
      var $1387=(($1386)|0);
      var $1388=$221;
      HEAP32[(($221)>>2)]=$1387;
      var $1389=HEAP32[(($221)>>2)];
      var $1390=$1389;
      var $1391=$220;
      HEAP32[(($220)>>2)]=$1390;
      var $1392=HEAP32[(($220)>>2)];
      var $1393=(($1392)|0);
      var $1394=$220;
      var $1395=$221;
      var $1396=(($1393)|0);
      var $1397=$1396;
      var $1398=(($1397)|0);
      var $1399=$1398;
      var $1400=HEAPU8[($1399)];
      var $1401=(($1400)&255);
      var $1402=$1401 & 1;
      var $1403=(($1402)|0)!=0;
      var $1404=$222;
      if ($1403) { __label__ = 101; break; } else { __label__ = 102; break; }
    case 101: // $1405
      var $1406=$216;
      HEAP32[(($216)>>2)]=$1384;
      var $1407=HEAP32[(($216)>>2)];
      var $1408=(($1407)|0);
      var $1409=$215;
      HEAP32[(($215)>>2)]=$1408;
      var $1410=HEAP32[(($215)>>2)];
      var $1411=$1410;
      var $1412=$214;
      HEAP32[(($214)>>2)]=$1411;
      var $1413=HEAP32[(($214)>>2)];
      var $1414=(($1413)|0);
      var $1415=$214;
      var $1416=$215;
      var $1417=(($1414)|0);
      var $1418=$1417;
      var $1419=(($1418+4)|0);
      var $1420=HEAP32[(($1419)>>2)];
      var $1421=$216;
      var $1442 = $1420;__label__ = 103; break;
    case 102: // $1422
      var $1423=$219;
      HEAP32[(($219)>>2)]=$1384;
      var $1424=HEAP32[(($219)>>2)];
      var $1425=(($1424)|0);
      var $1426=$218;
      HEAP32[(($218)>>2)]=$1425;
      var $1427=HEAP32[(($218)>>2)];
      var $1428=$1427;
      var $1429=$217;
      HEAP32[(($217)>>2)]=$1428;
      var $1430=HEAP32[(($217)>>2)];
      var $1431=(($1430)|0);
      var $1432=$217;
      var $1433=$218;
      var $1434=(($1431)|0);
      var $1435=$1434;
      var $1436=(($1435)|0);
      var $1437=$1436;
      var $1438=HEAPU8[($1437)];
      var $1439=(($1438)&255);
      var $1440=$1439 >> 1;
      var $1441=$219;
      var $1442 = $1440;__label__ = 103; break;
    case 103: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit45
      var $1442;
      var $1443=$223;
      var $1444=(($1442)>>>0) > 0;
      if ($1444) { __label__ = 104; break; } else { __label__ = 136; break; }
    case 104: // $1445
      var $1446=$462;
      var $1447=$213;
      HEAP32[(($213)>>2)]=$1446;
      var $1448=HEAP32[(($213)>>2)];
      var $1449=(($1448)|0);
      var $1450=HEAP32[(($1449)>>2)];
      var $1451=$211;
      var $1452=$212;
      HEAP32[(($212)>>2)]=$1450;
      var $1453=HEAPU32[(($212)>>2)];
      var $1454=(($1453+12)|0);
      var $1455=HEAP32[(($1454)>>2)];
      var $1456=(($1453+16)|0);
      var $1457=HEAP32[(($1456)>>2)];
      var $1458=(($1455)|0)==(($1457)|0);
      if ($1458) { __label__ = 105; break; } else { __label__ = 107; break; }
    case 105: // $1459
      var $1460=$1453;
      var $1461=HEAP32[(($1460)>>2)];
      var $1462=(($1461+36)|0);
      var $1463=HEAP32[(($1462)>>2)];
      var $1464=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1463]($1453) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 106; break; } else { __label__ = 27; break; };
    case 106: // $_noexc46
      HEAP32[(($211)>>2)]=$1464;
      __label__ = 108; break;
    case 107: // $1465
      var $1466=(($1453+12)|0);
      var $1467=HEAP32[(($1466)>>2)];
      var $1468=HEAP32[(($1467)>>2)];
      var $1469=$210;
      HEAP32[(($210)>>2)]=$1468;
      var $1470=HEAP32[(($210)>>2)];
      var $1471=$210;
      HEAP32[(($211)>>2)]=$1470;
      __label__ = 108; break;
    case 108: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit47
      var $1472=HEAP32[(($211)>>2)];
      var $1473=$211;
      var $1474=$212;
      var $1475=$213;
      __label__ = 109; break;
    case 109: // $1476
      var $1477=$208;
      var $1478=$209;
      HEAP32[(($208)>>2)]=$__psn;
      HEAP32[(($209)>>2)]=0;
      var $1479=HEAP32[(($208)>>2)];
      var $1480=$207;
      HEAP32[(($207)>>2)]=$1479;
      var $1481=HEAPU32[(($207)>>2)];
      var $1482=$206;
      HEAP32[(($206)>>2)]=$1481;
      var $1483=HEAP32[(($206)>>2)];
      var $1484=(($1483)|0);
      var $1485=$205;
      HEAP32[(($205)>>2)]=$1484;
      var $1486=HEAP32[(($205)>>2)];
      var $1487=$1486;
      var $1488=$204;
      HEAP32[(($204)>>2)]=$1487;
      var $1489=HEAP32[(($204)>>2)];
      var $1490=(($1489)|0);
      var $1491=$204;
      var $1492=$205;
      var $1493=(($1490)|0);
      var $1494=$1493;
      var $1495=(($1494)|0);
      var $1496=$1495;
      var $1497=HEAPU8[($1496)];
      var $1498=(($1497)&255);
      var $1499=$1498 & 1;
      var $1500=(($1499)|0)!=0;
      var $1501=$206;
      if ($1500) { __label__ = 110; break; } else { __label__ = 111; break; }
    case 110: // $1502
      var $1503=$200;
      HEAP32[(($200)>>2)]=$1481;
      var $1504=HEAP32[(($200)>>2)];
      var $1505=(($1504)|0);
      var $1506=$199;
      HEAP32[(($199)>>2)]=$1505;
      var $1507=HEAP32[(($199)>>2)];
      var $1508=$1507;
      var $1509=$198;
      HEAP32[(($198)>>2)]=$1508;
      var $1510=HEAP32[(($198)>>2)];
      var $1511=(($1510)|0);
      var $1512=$198;
      var $1513=$199;
      var $1514=(($1511)|0);
      var $1515=$1514;
      var $1516=(($1515+8)|0);
      var $1517=HEAP32[(($1516)>>2)];
      var $1518=$200;
      var $1536 = $1517;__label__ = 112; break;
    case 111: // $1519
      var $1520=$203;
      HEAP32[(($203)>>2)]=$1481;
      var $1521=HEAP32[(($203)>>2)];
      var $1522=(($1521)|0);
      var $1523=$202;
      HEAP32[(($202)>>2)]=$1522;
      var $1524=HEAP32[(($202)>>2)];
      var $1525=$1524;
      var $1526=$201;
      HEAP32[(($201)>>2)]=$1525;
      var $1527=HEAP32[(($201)>>2)];
      var $1528=(($1527)|0);
      var $1529=$201;
      var $1530=$202;
      var $1531=(($1528)|0);
      var $1532=$1531;
      var $1533=(($1532+4)|0);
      var $1534=(($1533)|0);
      var $1535=$203;
      var $1536 = $1534;__label__ = 112; break;
    case 112: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit
      var $1536;
      var $1537=$207;
      var $1538=HEAP32[(($209)>>2)];
      var $1539=(($1536+($1538<<2))|0);
      var $1540=$208;
      var $1541=$209;
      __label__ = 113; break;
    case 113: // $1542
      var $1543=HEAP32[(($1539)>>2)];
      var $1544=(($1472)|0)==(($1543)|0);
      if ($1544) { __label__ = 114; break; } else { __label__ = 134; break; }
    case 114: // $1545
      var $1546=$462;
      var $1547=$194;
      HEAP32[(($194)>>2)]=$1546;
      var $1548=HEAPU32[(($194)>>2)];
      var $1549=(($1548)|0);
      var $1550=HEAP32[(($1549)>>2)];
      var $1551=$192;
      var $1552=$193;
      HEAP32[(($193)>>2)]=$1550;
      var $1553=HEAP32[(($193)>>2)];
      var $1554=$190;
      var $1555=$191;
      HEAP32[(($191)>>2)]=$1553;
      var $1556=HEAP32[(($191)>>2)];
      var $1557=(($1556+12)|0);
      var $1558=HEAP32[(($1557)>>2)];
      var $1559=(($1556+16)|0);
      var $1560=HEAP32[(($1559)>>2)];
      var $1561=(($1558)|0)==(($1560)|0);
      if ($1561) { __label__ = 115; break; } else { __label__ = 117; break; }
    case 115: // $1562
      var $1563=$1556;
      var $1564=HEAP32[(($1563)>>2)];
      var $1565=(($1564+40)|0);
      var $1566=HEAP32[(($1565)>>2)];
      var $1567=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1566]($1556) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 27; break; };
    case 116: // $_noexc53
      HEAP32[(($190)>>2)]=$1567;
      __label__ = 118; break;
    case 117: // $1568
      var $1569=(($1556+12)|0);
      var $1570=HEAP32[(($1569)>>2)];
      var $1571=(($1570+4)|0);
      HEAP32[(($1569)>>2)]=$1571;
      var $1572=HEAP32[(($1570)>>2)];
      var $1573=$189;
      HEAP32[(($189)>>2)]=$1572;
      var $1574=HEAP32[(($189)>>2)];
      var $1575=$189;
      HEAP32[(($190)>>2)]=$1574;
      __label__ = 118; break;
    case 118: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i50
      var $1576=HEAP32[(($190)>>2)];
      var $1577=$190;
      var $1578=$191;
      var $1579=(($1576)|0)==-1;
      if ($1579) { __label__ = 119; break; } else { __label__ = 120; break; }
    case 119: // $1580
      HEAP32[(($192)>>2)]=-1;
      __label__ = 125; break;
    case 120: // $1581
      var $1582=$187;
      var $1583=$188;
      HEAP32[(($188)>>2)]=$1553;
      var $1584=HEAP32[(($188)>>2)];
      var $1585=(($1584+12)|0);
      var $1586=HEAP32[(($1585)>>2)];
      var $1587=(($1584+16)|0);
      var $1588=HEAP32[(($1587)>>2)];
      var $1589=(($1586)|0)==(($1588)|0);
      if ($1589) { __label__ = 121; break; } else { __label__ = 123; break; }
    case 121: // $1590
      var $1591=$1584;
      var $1592=HEAP32[(($1591)>>2)];
      var $1593=(($1592+36)|0);
      var $1594=HEAP32[(($1593)>>2)];
      var $1595=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1594]($1584) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 122; break; } else { __label__ = 27; break; };
    case 122: // $_noexc54
      HEAP32[(($187)>>2)]=$1595;
      __label__ = 124; break;
    case 123: // $1596
      var $1597=(($1584+12)|0);
      var $1598=HEAP32[(($1597)>>2)];
      var $1599=HEAP32[(($1598)>>2)];
      var $1600=$186;
      HEAP32[(($186)>>2)]=$1599;
      var $1601=HEAP32[(($186)>>2)];
      var $1602=$186;
      HEAP32[(($187)>>2)]=$1601;
      __label__ = 124; break;
    case 124: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i51
      var $1603=HEAP32[(($187)>>2)];
      var $1604=$187;
      var $1605=$188;
      HEAP32[(($192)>>2)]=$1603;
      __label__ = 125; break;
    case 125: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i52
      var $1606=HEAP32[(($192)>>2)];
      var $1607=$192;
      var $1608=$193;
      var $1609=$184;
      var $1610=$185;
      HEAP32[(($184)>>2)]=$1606;
      HEAP32[(($185)>>2)]=-1;
      var $1611=HEAP32[(($184)>>2)];
      var $1612=HEAP32[(($185)>>2)];
      var $1613=(($1611)|0)==(($1612)|0);
      var $1614=$184;
      var $1615=$185;
      if ($1613) { __label__ = 126; break; } else { __label__ = 127; break; }
    case 126: // $1616
      var $1617=(($1548)|0);
      HEAP32[(($1617)>>2)]=0;
      __label__ = 127; break;
    case 127: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit55
      var $1618=$194;
      __label__ = 128; break;
    case 128: // $1619
      var $1620=$183;
      HEAP32[(($183)>>2)]=$__psn;
      var $1621=HEAPU32[(($183)>>2)];
      var $1622=$182;
      HEAP32[(($182)>>2)]=$1621;
      var $1623=HEAP32[(($182)>>2)];
      var $1624=(($1623)|0);
      var $1625=$181;
      HEAP32[(($181)>>2)]=$1624;
      var $1626=HEAP32[(($181)>>2)];
      var $1627=$1626;
      var $1628=$180;
      HEAP32[(($180)>>2)]=$1627;
      var $1629=HEAP32[(($180)>>2)];
      var $1630=(($1629)|0);
      var $1631=$180;
      var $1632=$181;
      var $1633=(($1630)|0);
      var $1634=$1633;
      var $1635=(($1634)|0);
      var $1636=$1635;
      var $1637=HEAPU8[($1636)];
      var $1638=(($1637)&255);
      var $1639=$1638 & 1;
      var $1640=(($1639)|0)!=0;
      var $1641=$182;
      if ($1640) { __label__ = 129; break; } else { __label__ = 130; break; }
    case 129: // $1642
      var $1643=$176;
      HEAP32[(($176)>>2)]=$1621;
      var $1644=HEAP32[(($176)>>2)];
      var $1645=(($1644)|0);
      var $1646=$175;
      HEAP32[(($175)>>2)]=$1645;
      var $1647=HEAP32[(($175)>>2)];
      var $1648=$1647;
      var $1649=$174;
      HEAP32[(($174)>>2)]=$1648;
      var $1650=HEAP32[(($174)>>2)];
      var $1651=(($1650)|0);
      var $1652=$174;
      var $1653=$175;
      var $1654=(($1651)|0);
      var $1655=$1654;
      var $1656=(($1655+4)|0);
      var $1657=HEAP32[(($1656)>>2)];
      var $1658=$176;
      var $1679 = $1657;__label__ = 131; break;
    case 130: // $1659
      var $1660=$179;
      HEAP32[(($179)>>2)]=$1621;
      var $1661=HEAP32[(($179)>>2)];
      var $1662=(($1661)|0);
      var $1663=$178;
      HEAP32[(($178)>>2)]=$1662;
      var $1664=HEAP32[(($178)>>2)];
      var $1665=$1664;
      var $1666=$177;
      HEAP32[(($177)>>2)]=$1665;
      var $1667=HEAP32[(($177)>>2)];
      var $1668=(($1667)|0);
      var $1669=$177;
      var $1670=$178;
      var $1671=(($1668)|0);
      var $1672=$1671;
      var $1673=(($1672)|0);
      var $1674=$1673;
      var $1675=HEAPU8[($1674)];
      var $1676=(($1675)&255);
      var $1677=$1676 >> 1;
      var $1678=$179;
      var $1679 = $1677;__label__ = 131; break;
    case 131: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit56
      var $1679;
      var $1680=$183;
      var $1681=(($1679)>>>0) > 1;
      if ($1681) { __label__ = 132; break; } else { __label__ = 133; break; }
    case 132: // $1682
      $__trailing_sign=$__psn;
      __label__ = 133; break;
    case 133: // $1683
      __label__ = 135; break;
    case 134: // $1684
      var $1685=$467;
      HEAP8[($1685)]=1;
      __label__ = 135; break;
    case 135: // $1686
      __label__ = 167; break;
    case 136: // $1687
      var $1688=$462;
      var $1689=$173;
      HEAP32[(($173)>>2)]=$1688;
      var $1690=HEAP32[(($173)>>2)];
      var $1691=(($1690)|0);
      var $1692=HEAP32[(($1691)>>2)];
      var $1693=$171;
      var $1694=$172;
      HEAP32[(($172)>>2)]=$1692;
      var $1695=HEAP32[(($172)>>2)];
      var $1696=(($1695+12)|0);
      var $1697=HEAP32[(($1696)>>2)];
      var $1698=(($1695+16)|0);
      var $1699=HEAP32[(($1698)>>2)];
      var $1700=(($1697)|0)==(($1699)|0);
      if ($1700) { __label__ = 137; break; } else { __label__ = 139; break; }
    case 137: // $1701
      var $1702=$1695;
      var $1703=HEAP32[(($1702)>>2)];
      var $1704=(($1703+36)|0);
      var $1705=HEAP32[(($1704)>>2)];
      var $1706=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1705]($1695) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 138; break; } else { __label__ = 27; break; };
    case 138: // $_noexc57
      HEAP32[(($171)>>2)]=$1706;
      __label__ = 140; break;
    case 139: // $1707
      var $1708=(($1695+12)|0);
      var $1709=HEAP32[(($1708)>>2)];
      var $1710=HEAP32[(($1709)>>2)];
      var $1711=$170;
      HEAP32[(($170)>>2)]=$1710;
      var $1712=HEAP32[(($170)>>2)];
      var $1713=$170;
      HEAP32[(($171)>>2)]=$1712;
      __label__ = 140; break;
    case 140: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit58
      var $1714=HEAP32[(($171)>>2)];
      var $1715=$171;
      var $1716=$172;
      var $1717=$173;
      __label__ = 141; break;
    case 141: // $1718
      var $1719=$168;
      var $1720=$169;
      HEAP32[(($168)>>2)]=$__nsn;
      HEAP32[(($169)>>2)]=0;
      var $1721=HEAP32[(($168)>>2)];
      var $1722=$167;
      HEAP32[(($167)>>2)]=$1721;
      var $1723=HEAPU32[(($167)>>2)];
      var $1724=$166;
      HEAP32[(($166)>>2)]=$1723;
      var $1725=HEAP32[(($166)>>2)];
      var $1726=(($1725)|0);
      var $1727=$165;
      HEAP32[(($165)>>2)]=$1726;
      var $1728=HEAP32[(($165)>>2)];
      var $1729=$1728;
      var $1730=$164;
      HEAP32[(($164)>>2)]=$1729;
      var $1731=HEAP32[(($164)>>2)];
      var $1732=(($1731)|0);
      var $1733=$164;
      var $1734=$165;
      var $1735=(($1732)|0);
      var $1736=$1735;
      var $1737=(($1736)|0);
      var $1738=$1737;
      var $1739=HEAPU8[($1738)];
      var $1740=(($1739)&255);
      var $1741=$1740 & 1;
      var $1742=(($1741)|0)!=0;
      var $1743=$166;
      if ($1742) { __label__ = 142; break; } else { __label__ = 143; break; }
    case 142: // $1744
      var $1745=$160;
      HEAP32[(($160)>>2)]=$1723;
      var $1746=HEAP32[(($160)>>2)];
      var $1747=(($1746)|0);
      var $1748=$159;
      HEAP32[(($159)>>2)]=$1747;
      var $1749=HEAP32[(($159)>>2)];
      var $1750=$1749;
      var $1751=$158;
      HEAP32[(($158)>>2)]=$1750;
      var $1752=HEAP32[(($158)>>2)];
      var $1753=(($1752)|0);
      var $1754=$158;
      var $1755=$159;
      var $1756=(($1753)|0);
      var $1757=$1756;
      var $1758=(($1757+8)|0);
      var $1759=HEAP32[(($1758)>>2)];
      var $1760=$160;
      var $1778 = $1759;__label__ = 144; break;
    case 143: // $1761
      var $1762=$163;
      HEAP32[(($163)>>2)]=$1723;
      var $1763=HEAP32[(($163)>>2)];
      var $1764=(($1763)|0);
      var $1765=$162;
      HEAP32[(($162)>>2)]=$1764;
      var $1766=HEAP32[(($162)>>2)];
      var $1767=$1766;
      var $1768=$161;
      HEAP32[(($161)>>2)]=$1767;
      var $1769=HEAP32[(($161)>>2)];
      var $1770=(($1769)|0);
      var $1771=$161;
      var $1772=$162;
      var $1773=(($1770)|0);
      var $1774=$1773;
      var $1775=(($1774+4)|0);
      var $1776=(($1775)|0);
      var $1777=$163;
      var $1778 = $1776;__label__ = 144; break;
    case 144: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit59
      var $1778;
      var $1779=$167;
      var $1780=HEAP32[(($169)>>2)];
      var $1781=(($1778+($1780<<2))|0);
      var $1782=$168;
      var $1783=$169;
      __label__ = 145; break;
    case 145: // $1784
      var $1785=HEAP32[(($1781)>>2)];
      var $1786=(($1714)|0)==(($1785)|0);
      if ($1786) { __label__ = 146; break; } else { __label__ = 166; break; }
    case 146: // $1787
      var $1788=$462;
      var $1789=$153;
      HEAP32[(($153)>>2)]=$1788;
      var $1790=HEAPU32[(($153)>>2)];
      var $1791=(($1790)|0);
      var $1792=HEAP32[(($1791)>>2)];
      var $1793=$151;
      var $1794=$152;
      HEAP32[(($152)>>2)]=$1792;
      var $1795=HEAP32[(($152)>>2)];
      var $1796=$149;
      var $1797=$150;
      HEAP32[(($150)>>2)]=$1795;
      var $1798=HEAP32[(($150)>>2)];
      var $1799=(($1798+12)|0);
      var $1800=HEAP32[(($1799)>>2)];
      var $1801=(($1798+16)|0);
      var $1802=HEAP32[(($1801)>>2)];
      var $1803=(($1800)|0)==(($1802)|0);
      if ($1803) { __label__ = 147; break; } else { __label__ = 149; break; }
    case 147: // $1804
      var $1805=$1798;
      var $1806=HEAP32[(($1805)>>2)];
      var $1807=(($1806+40)|0);
      var $1808=HEAP32[(($1807)>>2)];
      var $1809=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1808]($1798) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 148; break; } else { __label__ = 27; break; };
    case 148: // $_noexc65
      HEAP32[(($149)>>2)]=$1809;
      __label__ = 150; break;
    case 149: // $1810
      var $1811=(($1798+12)|0);
      var $1812=HEAP32[(($1811)>>2)];
      var $1813=(($1812+4)|0);
      HEAP32[(($1811)>>2)]=$1813;
      var $1814=HEAP32[(($1812)>>2)];
      var $1815=$148;
      HEAP32[(($148)>>2)]=$1814;
      var $1816=HEAP32[(($148)>>2)];
      var $1817=$148;
      HEAP32[(($149)>>2)]=$1816;
      __label__ = 150; break;
    case 150: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i62
      var $1818=HEAP32[(($149)>>2)];
      var $1819=$149;
      var $1820=$150;
      var $1821=(($1818)|0)==-1;
      if ($1821) { __label__ = 151; break; } else { __label__ = 152; break; }
    case 151: // $1822
      HEAP32[(($151)>>2)]=-1;
      __label__ = 157; break;
    case 152: // $1823
      var $1824=$146;
      var $1825=$147;
      HEAP32[(($147)>>2)]=$1795;
      var $1826=HEAP32[(($147)>>2)];
      var $1827=(($1826+12)|0);
      var $1828=HEAP32[(($1827)>>2)];
      var $1829=(($1826+16)|0);
      var $1830=HEAP32[(($1829)>>2)];
      var $1831=(($1828)|0)==(($1830)|0);
      if ($1831) { __label__ = 153; break; } else { __label__ = 155; break; }
    case 153: // $1832
      var $1833=$1826;
      var $1834=HEAP32[(($1833)>>2)];
      var $1835=(($1834+36)|0);
      var $1836=HEAP32[(($1835)>>2)];
      var $1837=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1836]($1826) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 154; break; } else { __label__ = 27; break; };
    case 154: // $_noexc66
      HEAP32[(($146)>>2)]=$1837;
      __label__ = 156; break;
    case 155: // $1838
      var $1839=(($1826+12)|0);
      var $1840=HEAP32[(($1839)>>2)];
      var $1841=HEAP32[(($1840)>>2)];
      var $1842=$145;
      HEAP32[(($145)>>2)]=$1841;
      var $1843=HEAP32[(($145)>>2)];
      var $1844=$145;
      HEAP32[(($146)>>2)]=$1843;
      __label__ = 156; break;
    case 156: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i63
      var $1845=HEAP32[(($146)>>2)];
      var $1846=$146;
      var $1847=$147;
      HEAP32[(($151)>>2)]=$1845;
      __label__ = 157; break;
    case 157: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i64
      var $1848=HEAP32[(($151)>>2)];
      var $1849=$151;
      var $1850=$152;
      var $1851=$143;
      var $1852=$144;
      HEAP32[(($143)>>2)]=$1848;
      HEAP32[(($144)>>2)]=-1;
      var $1853=HEAP32[(($143)>>2)];
      var $1854=HEAP32[(($144)>>2)];
      var $1855=(($1853)|0)==(($1854)|0);
      var $1856=$143;
      var $1857=$144;
      if ($1855) { __label__ = 158; break; } else { __label__ = 159; break; }
    case 158: // $1858
      var $1859=(($1790)|0);
      HEAP32[(($1859)>>2)]=0;
      __label__ = 159; break;
    case 159: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit67
      var $1860=$153;
      __label__ = 160; break;
    case 160: // $1861
      var $1862=$467;
      HEAP8[($1862)]=1;
      var $1863=$142;
      HEAP32[(($142)>>2)]=$__nsn;
      var $1864=HEAPU32[(($142)>>2)];
      var $1865=$141;
      HEAP32[(($141)>>2)]=$1864;
      var $1866=HEAP32[(($141)>>2)];
      var $1867=(($1866)|0);
      var $1868=$140;
      HEAP32[(($140)>>2)]=$1867;
      var $1869=HEAP32[(($140)>>2)];
      var $1870=$1869;
      var $1871=$139;
      HEAP32[(($139)>>2)]=$1870;
      var $1872=HEAP32[(($139)>>2)];
      var $1873=(($1872)|0);
      var $1874=$139;
      var $1875=$140;
      var $1876=(($1873)|0);
      var $1877=$1876;
      var $1878=(($1877)|0);
      var $1879=$1878;
      var $1880=HEAPU8[($1879)];
      var $1881=(($1880)&255);
      var $1882=$1881 & 1;
      var $1883=(($1882)|0)!=0;
      var $1884=$141;
      if ($1883) { __label__ = 161; break; } else { __label__ = 162; break; }
    case 161: // $1885
      var $1886=$135;
      HEAP32[(($135)>>2)]=$1864;
      var $1887=HEAP32[(($135)>>2)];
      var $1888=(($1887)|0);
      var $1889=$134;
      HEAP32[(($134)>>2)]=$1888;
      var $1890=HEAP32[(($134)>>2)];
      var $1891=$1890;
      var $1892=$133;
      HEAP32[(($133)>>2)]=$1891;
      var $1893=HEAP32[(($133)>>2)];
      var $1894=(($1893)|0);
      var $1895=$133;
      var $1896=$134;
      var $1897=(($1894)|0);
      var $1898=$1897;
      var $1899=(($1898+4)|0);
      var $1900=HEAP32[(($1899)>>2)];
      var $1901=$135;
      var $1922 = $1900;__label__ = 163; break;
    case 162: // $1902
      var $1903=$138;
      HEAP32[(($138)>>2)]=$1864;
      var $1904=HEAP32[(($138)>>2)];
      var $1905=(($1904)|0);
      var $1906=$137;
      HEAP32[(($137)>>2)]=$1905;
      var $1907=HEAP32[(($137)>>2)];
      var $1908=$1907;
      var $1909=$136;
      HEAP32[(($136)>>2)]=$1908;
      var $1910=HEAP32[(($136)>>2)];
      var $1911=(($1910)|0);
      var $1912=$136;
      var $1913=$137;
      var $1914=(($1911)|0);
      var $1915=$1914;
      var $1916=(($1915)|0);
      var $1917=$1916;
      var $1918=HEAPU8[($1917)];
      var $1919=(($1918)&255);
      var $1920=$1919 >> 1;
      var $1921=$138;
      var $1922 = $1920;__label__ = 163; break;
    case 163: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit68
      var $1922;
      var $1923=$142;
      var $1924=(($1922)>>>0) > 1;
      if ($1924) { __label__ = 164; break; } else { __label__ = 165; break; }
    case 164: // $1925
      $__trailing_sign=$__nsn;
      __label__ = 165; break;
    case 165: // $1926
      __label__ = 166; break;
    case 166: // $1927
      __label__ = 167; break;
    case 167: // $1928
      __label__ = 231; break;
    case 168: // $1929
      var $1930=$462;
      var $1931=$132;
      HEAP32[(($132)>>2)]=$1930;
      var $1932=HEAP32[(($132)>>2)];
      var $1933=(($1932)|0);
      var $1934=HEAP32[(($1933)>>2)];
      var $1935=$130;
      var $1936=$131;
      HEAP32[(($131)>>2)]=$1934;
      var $1937=HEAP32[(($131)>>2)];
      var $1938=(($1937+12)|0);
      var $1939=HEAP32[(($1938)>>2)];
      var $1940=(($1937+16)|0);
      var $1941=HEAP32[(($1940)>>2)];
      var $1942=(($1939)|0)==(($1941)|0);
      if ($1942) { __label__ = 169; break; } else { __label__ = 171; break; }
    case 169: // $1943
      var $1944=$1937;
      var $1945=HEAP32[(($1944)>>2)];
      var $1946=(($1945+36)|0);
      var $1947=HEAP32[(($1946)>>2)];
      var $1948=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$1947]($1937) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 170; break; } else { __label__ = 27; break; };
    case 170: // $_noexc69
      HEAP32[(($130)>>2)]=$1948;
      __label__ = 172; break;
    case 171: // $1949
      var $1950=(($1937+12)|0);
      var $1951=HEAP32[(($1950)>>2)];
      var $1952=HEAP32[(($1951)>>2)];
      var $1953=$129;
      HEAP32[(($129)>>2)]=$1952;
      var $1954=HEAP32[(($129)>>2)];
      var $1955=$129;
      HEAP32[(($130)>>2)]=$1954;
      __label__ = 172; break;
    case 172: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit70
      var $1956=HEAP32[(($130)>>2)];
      var $1957=$130;
      var $1958=$131;
      var $1959=$132;
      __label__ = 173; break;
    case 173: // $1960
      var $1961=$127;
      var $1962=$128;
      HEAP32[(($127)>>2)]=$__psn;
      HEAP32[(($128)>>2)]=0;
      var $1963=HEAP32[(($127)>>2)];
      var $1964=$126;
      HEAP32[(($126)>>2)]=$1963;
      var $1965=HEAPU32[(($126)>>2)];
      var $1966=$125;
      HEAP32[(($125)>>2)]=$1965;
      var $1967=HEAP32[(($125)>>2)];
      var $1968=(($1967)|0);
      var $1969=$124;
      HEAP32[(($124)>>2)]=$1968;
      var $1970=HEAP32[(($124)>>2)];
      var $1971=$1970;
      var $1972=$123;
      HEAP32[(($123)>>2)]=$1971;
      var $1973=HEAP32[(($123)>>2)];
      var $1974=(($1973)|0);
      var $1975=$123;
      var $1976=$124;
      var $1977=(($1974)|0);
      var $1978=$1977;
      var $1979=(($1978)|0);
      var $1980=$1979;
      var $1981=HEAPU8[($1980)];
      var $1982=(($1981)&255);
      var $1983=$1982 & 1;
      var $1984=(($1983)|0)!=0;
      var $1985=$125;
      if ($1984) { __label__ = 174; break; } else { __label__ = 175; break; }
    case 174: // $1986
      var $1987=$119;
      HEAP32[(($119)>>2)]=$1965;
      var $1988=HEAP32[(($119)>>2)];
      var $1989=(($1988)|0);
      var $1990=$118;
      HEAP32[(($118)>>2)]=$1989;
      var $1991=HEAP32[(($118)>>2)];
      var $1992=$1991;
      var $1993=$117;
      HEAP32[(($117)>>2)]=$1992;
      var $1994=HEAP32[(($117)>>2)];
      var $1995=(($1994)|0);
      var $1996=$117;
      var $1997=$118;
      var $1998=(($1995)|0);
      var $1999=$1998;
      var $2000=(($1999+8)|0);
      var $2001=HEAP32[(($2000)>>2)];
      var $2002=$119;
      var $2020 = $2001;__label__ = 176; break;
    case 175: // $2003
      var $2004=$122;
      HEAP32[(($122)>>2)]=$1965;
      var $2005=HEAP32[(($122)>>2)];
      var $2006=(($2005)|0);
      var $2007=$121;
      HEAP32[(($121)>>2)]=$2006;
      var $2008=HEAP32[(($121)>>2)];
      var $2009=$2008;
      var $2010=$120;
      HEAP32[(($120)>>2)]=$2009;
      var $2011=HEAP32[(($120)>>2)];
      var $2012=(($2011)|0);
      var $2013=$120;
      var $2014=$121;
      var $2015=(($2012)|0);
      var $2016=$2015;
      var $2017=(($2016+4)|0);
      var $2018=(($2017)|0);
      var $2019=$122;
      var $2020 = $2018;__label__ = 176; break;
    case 176: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit71
      var $2020;
      var $2021=$126;
      var $2022=HEAP32[(($128)>>2)];
      var $2023=(($2020+($2022<<2))|0);
      var $2024=$127;
      var $2025=$128;
      __label__ = 177; break;
    case 177: // $2026
      var $2027=HEAP32[(($2023)>>2)];
      var $2028=(($1956)|0)==(($2027)|0);
      if ($2028) { __label__ = 178; break; } else { __label__ = 198; break; }
    case 178: // $2029
      var $2030=$462;
      var $2031=$101;
      HEAP32[(($101)>>2)]=$2030;
      var $2032=HEAPU32[(($101)>>2)];
      var $2033=(($2032)|0);
      var $2034=HEAP32[(($2033)>>2)];
      var $2035=$99;
      var $2036=$100;
      HEAP32[(($100)>>2)]=$2034;
      var $2037=HEAP32[(($100)>>2)];
      var $2038=$97;
      var $2039=$98;
      HEAP32[(($98)>>2)]=$2037;
      var $2040=HEAP32[(($98)>>2)];
      var $2041=(($2040+12)|0);
      var $2042=HEAP32[(($2041)>>2)];
      var $2043=(($2040+16)|0);
      var $2044=HEAP32[(($2043)>>2)];
      var $2045=(($2042)|0)==(($2044)|0);
      if ($2045) { __label__ = 179; break; } else { __label__ = 181; break; }
    case 179: // $2046
      var $2047=$2040;
      var $2048=HEAP32[(($2047)>>2)];
      var $2049=(($2048+40)|0);
      var $2050=HEAP32[(($2049)>>2)];
      var $2051=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2050]($2040) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 180; break; } else { __label__ = 27; break; };
    case 180: // $_noexc81
      HEAP32[(($97)>>2)]=$2051;
      __label__ = 182; break;
    case 181: // $2052
      var $2053=(($2040+12)|0);
      var $2054=HEAP32[(($2053)>>2)];
      var $2055=(($2054+4)|0);
      HEAP32[(($2053)>>2)]=$2055;
      var $2056=HEAP32[(($2054)>>2)];
      var $2057=$96;
      HEAP32[(($96)>>2)]=$2056;
      var $2058=HEAP32[(($96)>>2)];
      var $2059=$96;
      HEAP32[(($97)>>2)]=$2058;
      __label__ = 182; break;
    case 182: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i78
      var $2060=HEAP32[(($97)>>2)];
      var $2061=$97;
      var $2062=$98;
      var $2063=(($2060)|0)==-1;
      if ($2063) { __label__ = 183; break; } else { __label__ = 184; break; }
    case 183: // $2064
      HEAP32[(($99)>>2)]=-1;
      __label__ = 189; break;
    case 184: // $2065
      var $2066=$94;
      var $2067=$95;
      HEAP32[(($95)>>2)]=$2037;
      var $2068=HEAP32[(($95)>>2)];
      var $2069=(($2068+12)|0);
      var $2070=HEAP32[(($2069)>>2)];
      var $2071=(($2068+16)|0);
      var $2072=HEAP32[(($2071)>>2)];
      var $2073=(($2070)|0)==(($2072)|0);
      if ($2073) { __label__ = 185; break; } else { __label__ = 187; break; }
    case 185: // $2074
      var $2075=$2068;
      var $2076=HEAP32[(($2075)>>2)];
      var $2077=(($2076+36)|0);
      var $2078=HEAP32[(($2077)>>2)];
      var $2079=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2078]($2068) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 186; break; } else { __label__ = 27; break; };
    case 186: // $_noexc82
      HEAP32[(($94)>>2)]=$2079;
      __label__ = 188; break;
    case 187: // $2080
      var $2081=(($2068+12)|0);
      var $2082=HEAP32[(($2081)>>2)];
      var $2083=HEAP32[(($2082)>>2)];
      var $2084=$93;
      HEAP32[(($93)>>2)]=$2083;
      var $2085=HEAP32[(($93)>>2)];
      var $2086=$93;
      HEAP32[(($94)>>2)]=$2085;
      __label__ = 188; break;
    case 188: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i79
      var $2087=HEAP32[(($94)>>2)];
      var $2088=$94;
      var $2089=$95;
      HEAP32[(($99)>>2)]=$2087;
      __label__ = 189; break;
    case 189: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i80
      var $2090=HEAP32[(($99)>>2)];
      var $2091=$99;
      var $2092=$100;
      var $2093=$91;
      var $2094=$92;
      HEAP32[(($91)>>2)]=$2090;
      HEAP32[(($92)>>2)]=-1;
      var $2095=HEAP32[(($91)>>2)];
      var $2096=HEAP32[(($92)>>2)];
      var $2097=(($2095)|0)==(($2096)|0);
      var $2098=$91;
      var $2099=$92;
      if ($2097) { __label__ = 190; break; } else { __label__ = 191; break; }
    case 190: // $2100
      var $2101=(($2032)|0);
      HEAP32[(($2101)>>2)]=0;
      __label__ = 191; break;
    case 191: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit83
      var $2102=$101;
      __label__ = 192; break;
    case 192: // $2103
      var $2104=$90;
      HEAP32[(($90)>>2)]=$__psn;
      var $2105=HEAPU32[(($90)>>2)];
      var $2106=$89;
      HEAP32[(($89)>>2)]=$2105;
      var $2107=HEAP32[(($89)>>2)];
      var $2108=(($2107)|0);
      var $2109=$88;
      HEAP32[(($88)>>2)]=$2108;
      var $2110=HEAP32[(($88)>>2)];
      var $2111=$2110;
      var $2112=$87;
      HEAP32[(($87)>>2)]=$2111;
      var $2113=HEAP32[(($87)>>2)];
      var $2114=(($2113)|0);
      var $2115=$87;
      var $2116=$88;
      var $2117=(($2114)|0);
      var $2118=$2117;
      var $2119=(($2118)|0);
      var $2120=$2119;
      var $2121=HEAPU8[($2120)];
      var $2122=(($2121)&255);
      var $2123=$2122 & 1;
      var $2124=(($2123)|0)!=0;
      var $2125=$89;
      if ($2124) { __label__ = 193; break; } else { __label__ = 194; break; }
    case 193: // $2126
      var $2127=$83;
      HEAP32[(($83)>>2)]=$2105;
      var $2128=HEAP32[(($83)>>2)];
      var $2129=(($2128)|0);
      var $2130=$82;
      HEAP32[(($82)>>2)]=$2129;
      var $2131=HEAP32[(($82)>>2)];
      var $2132=$2131;
      var $2133=$81;
      HEAP32[(($81)>>2)]=$2132;
      var $2134=HEAP32[(($81)>>2)];
      var $2135=(($2134)|0);
      var $2136=$81;
      var $2137=$82;
      var $2138=(($2135)|0);
      var $2139=$2138;
      var $2140=(($2139+4)|0);
      var $2141=HEAP32[(($2140)>>2)];
      var $2142=$83;
      var $2163 = $2141;__label__ = 195; break;
    case 194: // $2143
      var $2144=$86;
      HEAP32[(($86)>>2)]=$2105;
      var $2145=HEAP32[(($86)>>2)];
      var $2146=(($2145)|0);
      var $2147=$85;
      HEAP32[(($85)>>2)]=$2146;
      var $2148=HEAP32[(($85)>>2)];
      var $2149=$2148;
      var $2150=$84;
      HEAP32[(($84)>>2)]=$2149;
      var $2151=HEAP32[(($84)>>2)];
      var $2152=(($2151)|0);
      var $2153=$84;
      var $2154=$85;
      var $2155=(($2152)|0);
      var $2156=$2155;
      var $2157=(($2156)|0);
      var $2158=$2157;
      var $2159=HEAPU8[($2158)];
      var $2160=(($2159)&255);
      var $2161=$2160 >> 1;
      var $2162=$86;
      var $2163 = $2161;__label__ = 195; break;
    case 195: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit84
      var $2163;
      var $2164=$90;
      var $2165=(($2163)>>>0) > 1;
      if ($2165) { __label__ = 196; break; } else { __label__ = 197; break; }
    case 196: // $2166
      $__trailing_sign=$__psn;
      __label__ = 197; break;
    case 197: // $2167
      __label__ = 230; break;
    case 198: // $2168
      var $2169=$462;
      var $2170=$80;
      HEAP32[(($80)>>2)]=$2169;
      var $2171=HEAP32[(($80)>>2)];
      var $2172=(($2171)|0);
      var $2173=HEAP32[(($2172)>>2)];
      var $2174=$78;
      var $2175=$79;
      HEAP32[(($79)>>2)]=$2173;
      var $2176=HEAPU32[(($79)>>2)];
      var $2177=(($2176+12)|0);
      var $2178=HEAP32[(($2177)>>2)];
      var $2179=(($2176+16)|0);
      var $2180=HEAP32[(($2179)>>2)];
      var $2181=(($2178)|0)==(($2180)|0);
      if ($2181) { __label__ = 199; break; } else { __label__ = 201; break; }
    case 199: // $2182
      var $2183=$2176;
      var $2184=HEAP32[(($2183)>>2)];
      var $2185=(($2184+36)|0);
      var $2186=HEAP32[(($2185)>>2)];
      var $2187=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2186]($2176) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 200; break; } else { __label__ = 27; break; };
    case 200: // $_noexc85
      HEAP32[(($78)>>2)]=$2187;
      __label__ = 202; break;
    case 201: // $2188
      var $2189=(($2176+12)|0);
      var $2190=HEAP32[(($2189)>>2)];
      var $2191=HEAP32[(($2190)>>2)];
      var $2192=$77;
      HEAP32[(($77)>>2)]=$2191;
      var $2193=HEAP32[(($77)>>2)];
      var $2194=$77;
      HEAP32[(($78)>>2)]=$2193;
      __label__ = 202; break;
    case 202: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit86
      var $2195=HEAP32[(($78)>>2)];
      var $2196=$78;
      var $2197=$79;
      var $2198=$80;
      __label__ = 203; break;
    case 203: // $2199
      var $2200=$75;
      var $2201=$76;
      HEAP32[(($75)>>2)]=$__nsn;
      HEAP32[(($76)>>2)]=0;
      var $2202=HEAP32[(($75)>>2)];
      var $2203=$74;
      HEAP32[(($74)>>2)]=$2202;
      var $2204=HEAPU32[(($74)>>2)];
      var $2205=$73;
      HEAP32[(($73)>>2)]=$2204;
      var $2206=HEAP32[(($73)>>2)];
      var $2207=(($2206)|0);
      var $2208=$72;
      HEAP32[(($72)>>2)]=$2207;
      var $2209=HEAP32[(($72)>>2)];
      var $2210=$2209;
      var $2211=$71;
      HEAP32[(($71)>>2)]=$2210;
      var $2212=HEAP32[(($71)>>2)];
      var $2213=(($2212)|0);
      var $2214=$71;
      var $2215=$72;
      var $2216=(($2213)|0);
      var $2217=$2216;
      var $2218=(($2217)|0);
      var $2219=$2218;
      var $2220=HEAPU8[($2219)];
      var $2221=(($2220)&255);
      var $2222=$2221 & 1;
      var $2223=(($2222)|0)!=0;
      var $2224=$73;
      if ($2223) { __label__ = 204; break; } else { __label__ = 205; break; }
    case 204: // $2225
      var $2226=$67;
      HEAP32[(($67)>>2)]=$2204;
      var $2227=HEAP32[(($67)>>2)];
      var $2228=(($2227)|0);
      var $2229=$66;
      HEAP32[(($66)>>2)]=$2228;
      var $2230=HEAP32[(($66)>>2)];
      var $2231=$2230;
      var $2232=$65;
      HEAP32[(($65)>>2)]=$2231;
      var $2233=HEAP32[(($65)>>2)];
      var $2234=(($2233)|0);
      var $2235=$65;
      var $2236=$66;
      var $2237=(($2234)|0);
      var $2238=$2237;
      var $2239=(($2238+8)|0);
      var $2240=HEAP32[(($2239)>>2)];
      var $2241=$67;
      var $2259 = $2240;__label__ = 206; break;
    case 205: // $2242
      var $2243=$70;
      HEAP32[(($70)>>2)]=$2204;
      var $2244=HEAP32[(($70)>>2)];
      var $2245=(($2244)|0);
      var $2246=$69;
      HEAP32[(($69)>>2)]=$2245;
      var $2247=HEAP32[(($69)>>2)];
      var $2248=$2247;
      var $2249=$68;
      HEAP32[(($68)>>2)]=$2248;
      var $2250=HEAP32[(($68)>>2)];
      var $2251=(($2250)|0);
      var $2252=$68;
      var $2253=$69;
      var $2254=(($2251)|0);
      var $2255=$2254;
      var $2256=(($2255+4)|0);
      var $2257=(($2256)|0);
      var $2258=$70;
      var $2259 = $2257;__label__ = 206; break;
    case 206: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit87
      var $2259;
      var $2260=$74;
      var $2261=HEAP32[(($76)>>2)];
      var $2262=(($2259+($2261<<2))|0);
      var $2263=$75;
      var $2264=$76;
      __label__ = 207; break;
    case 207: // $2265
      var $2266=HEAP32[(($2262)>>2)];
      var $2267=(($2195)|0)==(($2266)|0);
      if ($2267) { __label__ = 208; break; } else { __label__ = 228; break; }
    case 208: // $2268
      var $2269=$462;
      var $2270=$64;
      HEAP32[(($64)>>2)]=$2269;
      var $2271=HEAPU32[(($64)>>2)];
      var $2272=(($2271)|0);
      var $2273=HEAP32[(($2272)>>2)];
      var $2274=$62;
      var $2275=$63;
      HEAP32[(($63)>>2)]=$2273;
      var $2276=HEAP32[(($63)>>2)];
      var $2277=$60;
      var $2278=$61;
      HEAP32[(($61)>>2)]=$2276;
      var $2279=HEAP32[(($61)>>2)];
      var $2280=(($2279+12)|0);
      var $2281=HEAP32[(($2280)>>2)];
      var $2282=(($2279+16)|0);
      var $2283=HEAP32[(($2282)>>2)];
      var $2284=(($2281)|0)==(($2283)|0);
      if ($2284) { __label__ = 209; break; } else { __label__ = 211; break; }
    case 209: // $2285
      var $2286=$2279;
      var $2287=HEAP32[(($2286)>>2)];
      var $2288=(($2287+40)|0);
      var $2289=HEAP32[(($2288)>>2)];
      var $2290=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2289]($2279) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 210; break; } else { __label__ = 27; break; };
    case 210: // $_noexc91
      HEAP32[(($60)>>2)]=$2290;
      __label__ = 212; break;
    case 211: // $2291
      var $2292=(($2279+12)|0);
      var $2293=HEAP32[(($2292)>>2)];
      var $2294=(($2293+4)|0);
      HEAP32[(($2292)>>2)]=$2294;
      var $2295=HEAP32[(($2293)>>2)];
      var $2296=$59;
      HEAP32[(($59)>>2)]=$2295;
      var $2297=HEAP32[(($59)>>2)];
      var $2298=$59;
      HEAP32[(($60)>>2)]=$2297;
      __label__ = 212; break;
    case 212: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i88
      var $2299=HEAP32[(($60)>>2)];
      var $2300=$60;
      var $2301=$61;
      var $2302=(($2299)|0)==-1;
      if ($2302) { __label__ = 213; break; } else { __label__ = 214; break; }
    case 213: // $2303
      HEAP32[(($62)>>2)]=-1;
      __label__ = 219; break;
    case 214: // $2304
      var $2305=$57;
      var $2306=$58;
      HEAP32[(($58)>>2)]=$2276;
      var $2307=HEAP32[(($58)>>2)];
      var $2308=(($2307+12)|0);
      var $2309=HEAP32[(($2308)>>2)];
      var $2310=(($2307+16)|0);
      var $2311=HEAP32[(($2310)>>2)];
      var $2312=(($2309)|0)==(($2311)|0);
      if ($2312) { __label__ = 215; break; } else { __label__ = 217; break; }
    case 215: // $2313
      var $2314=$2307;
      var $2315=HEAP32[(($2314)>>2)];
      var $2316=(($2315+36)|0);
      var $2317=HEAP32[(($2316)>>2)];
      var $2318=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2317]($2307) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 216; break; } else { __label__ = 27; break; };
    case 216: // $_noexc92
      HEAP32[(($57)>>2)]=$2318;
      __label__ = 218; break;
    case 217: // $2319
      var $2320=(($2307+12)|0);
      var $2321=HEAP32[(($2320)>>2)];
      var $2322=HEAP32[(($2321)>>2)];
      var $2323=$56;
      HEAP32[(($56)>>2)]=$2322;
      var $2324=HEAP32[(($56)>>2)];
      var $2325=$56;
      HEAP32[(($57)>>2)]=$2324;
      __label__ = 218; break;
    case 218: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i89
      var $2326=HEAP32[(($57)>>2)];
      var $2327=$57;
      var $2328=$58;
      HEAP32[(($62)>>2)]=$2326;
      __label__ = 219; break;
    case 219: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i90
      var $2329=HEAP32[(($62)>>2)];
      var $2330=$62;
      var $2331=$63;
      var $2332=$54;
      var $2333=$55;
      HEAP32[(($54)>>2)]=$2329;
      HEAP32[(($55)>>2)]=-1;
      var $2334=HEAP32[(($54)>>2)];
      var $2335=HEAP32[(($55)>>2)];
      var $2336=(($2334)|0)==(($2335)|0);
      var $2337=$54;
      var $2338=$55;
      if ($2336) { __label__ = 220; break; } else { __label__ = 221; break; }
    case 220: // $2339
      var $2340=(($2271)|0);
      HEAP32[(($2340)>>2)]=0;
      __label__ = 221; break;
    case 221: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit93
      var $2341=$64;
      __label__ = 222; break;
    case 222: // $2342
      var $2343=$467;
      HEAP8[($2343)]=1;
      var $2344=$53;
      HEAP32[(($53)>>2)]=$__nsn;
      var $2345=HEAPU32[(($53)>>2)];
      var $2346=$52;
      HEAP32[(($52)>>2)]=$2345;
      var $2347=HEAP32[(($52)>>2)];
      var $2348=(($2347)|0);
      var $2349=$51;
      HEAP32[(($51)>>2)]=$2348;
      var $2350=HEAP32[(($51)>>2)];
      var $2351=$2350;
      var $2352=$50;
      HEAP32[(($50)>>2)]=$2351;
      var $2353=HEAP32[(($50)>>2)];
      var $2354=(($2353)|0);
      var $2355=$50;
      var $2356=$51;
      var $2357=(($2354)|0);
      var $2358=$2357;
      var $2359=(($2358)|0);
      var $2360=$2359;
      var $2361=HEAPU8[($2360)];
      var $2362=(($2361)&255);
      var $2363=$2362 & 1;
      var $2364=(($2363)|0)!=0;
      var $2365=$52;
      if ($2364) { __label__ = 223; break; } else { __label__ = 224; break; }
    case 223: // $2366
      var $2367=$46;
      HEAP32[(($46)>>2)]=$2345;
      var $2368=HEAP32[(($46)>>2)];
      var $2369=(($2368)|0);
      var $2370=$45;
      HEAP32[(($45)>>2)]=$2369;
      var $2371=HEAP32[(($45)>>2)];
      var $2372=$2371;
      var $2373=$44;
      HEAP32[(($44)>>2)]=$2372;
      var $2374=HEAP32[(($44)>>2)];
      var $2375=(($2374)|0);
      var $2376=$44;
      var $2377=$45;
      var $2378=(($2375)|0);
      var $2379=$2378;
      var $2380=(($2379+4)|0);
      var $2381=HEAP32[(($2380)>>2)];
      var $2382=$46;
      var $2403 = $2381;__label__ = 225; break;
    case 224: // $2383
      var $2384=$49;
      HEAP32[(($49)>>2)]=$2345;
      var $2385=HEAP32[(($49)>>2)];
      var $2386=(($2385)|0);
      var $2387=$48;
      HEAP32[(($48)>>2)]=$2386;
      var $2388=HEAP32[(($48)>>2)];
      var $2389=$2388;
      var $2390=$47;
      HEAP32[(($47)>>2)]=$2389;
      var $2391=HEAP32[(($47)>>2)];
      var $2392=(($2391)|0);
      var $2393=$47;
      var $2394=$48;
      var $2395=(($2392)|0);
      var $2396=$2395;
      var $2397=(($2396)|0);
      var $2398=$2397;
      var $2399=HEAPU8[($2398)];
      var $2400=(($2399)&255);
      var $2401=$2400 >> 1;
      var $2402=$49;
      var $2403 = $2401;__label__ = 225; break;
    case 225: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit94
      var $2403;
      var $2404=$53;
      var $2405=(($2403)>>>0) > 1;
      if ($2405) { __label__ = 226; break; } else { __label__ = 227; break; }
    case 226: // $2406
      $__trailing_sign=$__nsn;
      __label__ = 227; break;
    case 227: // $2407
      __label__ = 229; break;
    case 228: // $2408
      var $2409=$466;
      var $2410=HEAP32[(($2409)>>2)];
      var $2411=$2410 | 4;
      HEAP32[(($2409)>>2)]=$2411;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 229: // $2412
      __label__ = 230; break;
    case 230: // $2413
      __label__ = 231; break;
    case 231: // $2414
      __label__ = 232; break;
    case 232: // $2415
      __label__ = 360; break;
    case 233: // $2416
      var $2417=$__trailing_sign;
      var $2418=(($2417)|0)!=0;
      if ($2418) { var $2434 = 1;__label__ = 238; break; } else { __label__ = 234; break; }
    case 234: // $2419
      var $2420=$__p;
      var $2421=(($2420)>>>0) < 2;
      if ($2421) { var $2434 = 1;__label__ = 238; break; } else { __label__ = 235; break; }
    case 235: // $2422
      var $2423=$__p;
      var $2424=(($2423)|0)==2;
      if ($2424) { __label__ = 236; break; } else { var $2432 = 0;__label__ = 237; break; }
    case 236: // $2425
      var $2426=(($__pat)|0);
      var $2427=(($2426+3)|0);
      var $2428=HEAP8[($2427)];
      var $2429=(($2428 << 24) >> 24);
      var $2430=(($2429)|0)!=0;
      var $2432 = $2430;__label__ = 237; break;
    case 237: // $2431
      var $2432;
      var $2434 = $2432;__label__ = 238; break;
    case 238: // $2433
      var $2434;
      var $2435=(($2434)&1);
      $__more_needed=$2435;
      var $2436=$465;
      var $2437=$2436 & 512;
      var $2438=(($2437)|0)!=0;
      var $2439=(($2438)&1);
      $__sb=$2439;
      var $2440=$__sb;
      var $2441=(($2440) & 1);
      if ($2441) { __label__ = 240; break; } else { __label__ = 239; break; }
    case 239: // $2442
      var $2443=$__more_needed;
      var $2444=(($2443) & 1);
      if ($2444) { __label__ = 240; break; } else { __label__ = 245; break; }
    case 240: // $2445
      HEAP32[(($__et)>>2)]=0;
      var $2446=$462;
      var $2447=$475;
      var $2448=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($2447)>>2)]=HEAP32[(($2448)>>2)];
      var $2449=(($__sym+12)|0);
      var $2450=$468;
      var $2451=(function() { try { __THREW__ = false; return __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SD_SC_SC_RKT1_Rjb($2446, $475, $__sym, $2449, $2450, $__et, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 241; break; } else { __label__ = 27; break; };
    case 241: // $2452
      $__k=$2451;
      var $2453=$__sb;
      var $2454=(($2453) & 1);
      if ($2454) { __label__ = 242; break; } else { __label__ = 244; break; }
    case 242: // $2455
      var $2456=$__k;
      var $2457=(($2456)|0)!=(($__sym)|0);
      if ($2457) { __label__ = 243; break; } else { __label__ = 244; break; }
    case 243: // $2458
      var $2459=$466;
      var $2460=HEAP32[(($2459)>>2)];
      var $2461=$2460 | 4;
      HEAP32[(($2459)>>2)]=$2461;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 244: // $2462
      __label__ = 245; break;
    case 245: // $2463
      __label__ = 360; break;
    case 246: // $2464
      $__ng=0;
      __label__ = 247; break;
    case 247: // $2465
      var $2466=$462;
      var $2467=$42;
      var $2468=$43;
      HEAP32[(($42)>>2)]=$2466;
      HEAP32[(($43)>>2)]=$__e;
      var $2469=HEAP32[(($42)>>2)];
      var $2470=HEAP32[(($43)>>2)];
      var $2471=$40;
      var $2472=$41;
      HEAP32[(($40)>>2)]=$2469;
      HEAP32[(($41)>>2)]=$2470;
      var $2473=HEAP32[(($40)>>2)];
      var $2474=(($2473)|0);
      var $2475=HEAP32[(($2474)>>2)];
      var $2476=(($2475)|0)==0;
      var $2477=(($2476)&1);
      var $2478=HEAP32[(($41)>>2)];
      var $2479=(($2478)|0);
      var $2480=HEAP32[(($2479)>>2)];
      var $2481=(($2480)|0)==0;
      var $2482=(($2481)&1);
      var $2483=(($2477)|0)==(($2482)|0);
      var $2484=$40;
      var $2485=$41;
      var $2486=$2483 ^ 1;
      var $2487=$42;
      var $2488=$43;
      __label__ = 248; break;
    case 248: // $2489
      if ($2486) { __label__ = 249; break; } else { __label__ = 289; break; }
    case 249: // $2490
      var $2491=$462;
      var $2492=$35;
      HEAP32[(($35)>>2)]=$2491;
      var $2493=HEAP32[(($35)>>2)];
      var $2494=(($2493)|0);
      var $2495=HEAP32[(($2494)>>2)];
      var $2496=$33;
      var $2497=$34;
      HEAP32[(($34)>>2)]=$2495;
      var $2498=HEAP32[(($34)>>2)];
      var $2499=(($2498+12)|0);
      var $2500=HEAP32[(($2499)>>2)];
      var $2501=(($2498+16)|0);
      var $2502=HEAP32[(($2501)>>2)];
      var $2503=(($2500)|0)==(($2502)|0);
      if ($2503) { __label__ = 250; break; } else { __label__ = 252; break; }
    case 250: // $2504
      var $2505=$2498;
      var $2506=HEAP32[(($2505)>>2)];
      var $2507=(($2506+36)|0);
      var $2508=HEAP32[(($2507)>>2)];
      var $2509=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2508]($2498) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 251; break; } else { __label__ = 27; break; };
    case 251: // $_noexc97
      HEAP32[(($33)>>2)]=$2509;
      __label__ = 253; break;
    case 252: // $2510
      var $2511=(($2498+12)|0);
      var $2512=HEAP32[(($2511)>>2)];
      var $2513=HEAP32[(($2512)>>2)];
      var $2514=$32;
      HEAP32[(($32)>>2)]=$2513;
      var $2515=HEAP32[(($32)>>2)];
      var $2516=$32;
      HEAP32[(($33)>>2)]=$2515;
      __label__ = 253; break;
    case 253: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit98
      var $2517=HEAP32[(($33)>>2)];
      var $2518=$33;
      var $2519=$34;
      var $2520=$35;
      __label__ = 254; break;
    case 254: // $2521
      $__c=$2517;
      var $2522=$468;
      var $2523=$__c;
      var $2524=$29;
      var $2525=$30;
      var $2526=$31;
      HEAP32[(($29)>>2)]=$2522;
      HEAP32[(($30)>>2)]=1024;
      HEAP32[(($31)>>2)]=$2523;
      var $2527=HEAP32[(($29)>>2)];
      var $2528=$2527;
      var $2529=HEAP32[(($2528)>>2)];
      var $2530=(($2529+12)|0);
      var $2531=HEAP32[(($2530)>>2)];
      var $2532=HEAP32[(($30)>>2)];
      var $2533=HEAP32[(($31)>>2)];
      var $2534=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2531]($2527, $2532, $2533) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 255; break; } else { __label__ = 27; break; };
    case 255: // $_ZNKSt3__15ctypeIwE2isEjw_exit100
      var $2535=$29;
      var $2536=$30;
      var $2537=$31;
      __label__ = 256; break;
    case 256: // $2538
      if ($2534) { __label__ = 257; break; } else { __label__ = 261; break; }
    case 257: // $2539
      var $2540=$470;
      var $2541=HEAP32[(($2540)>>2)];
      var $2542=HEAP32[(($471)>>2)];
      var $2543=(($2541)|0)==(($2542)|0);
      if ($2543) { __label__ = 258; break; } else { __label__ = 260; break; }
    case 258: // $2544
      var $2545=$469;
      var $2546=$470;
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($2545, $2546, $471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 259; break; } else { __label__ = 27; break; }
    case 259: // $2547
      __label__ = 260; break;
    case 260: // $2548
      var $2549=$__c;
      var $2550=$470;
      var $2551=HEAP32[(($2550)>>2)];
      var $2552=(($2551+4)|0);
      HEAP32[(($2550)>>2)]=$2552;
      HEAP32[(($2551)>>2)]=$2549;
      var $2553=$__ng;
      var $2554=(($2553+1)|0);
      $__ng=$2554;
      __label__ = 273; break;
    case 261: // $2555
      var $2556=$28;
      HEAP32[(($28)>>2)]=$__grp;
      var $2557=HEAPU32[(($28)>>2)];
      var $2558=$27;
      HEAP32[(($27)>>2)]=$2557;
      var $2559=HEAP32[(($27)>>2)];
      var $2560=(($2559)|0);
      var $2561=$26;
      HEAP32[(($26)>>2)]=$2560;
      var $2562=HEAP32[(($26)>>2)];
      var $2563=$2562;
      var $2564=$25;
      HEAP32[(($25)>>2)]=$2563;
      var $2565=HEAP32[(($25)>>2)];
      var $2566=(($2565)|0);
      var $2567=$25;
      var $2568=$26;
      var $2569=(($2566)|0);
      var $2570=$2569;
      var $2571=(($2570)|0);
      var $2572=$2571;
      var $2573=HEAPU8[($2572)];
      var $2574=(($2573)&255);
      var $2575=$2574 & 1;
      var $2576=(($2575)|0)!=0;
      var $2577=$27;
      if ($2576) { __label__ = 262; break; } else { __label__ = 263; break; }
    case 262: // $2578
      var $2579=$21;
      HEAP32[(($21)>>2)]=$2557;
      var $2580=HEAP32[(($21)>>2)];
      var $2581=(($2580)|0);
      var $2582=$20;
      HEAP32[(($20)>>2)]=$2581;
      var $2583=HEAP32[(($20)>>2)];
      var $2584=$2583;
      var $2585=$19;
      HEAP32[(($19)>>2)]=$2584;
      var $2586=HEAP32[(($19)>>2)];
      var $2587=(($2586)|0);
      var $2588=$19;
      var $2589=$20;
      var $2590=(($2587)|0);
      var $2591=$2590;
      var $2592=(($2591+4)|0);
      var $2593=HEAP32[(($2592)>>2)];
      var $2594=$21;
      var $2615 = $2593;__label__ = 264; break;
    case 263: // $2595
      var $2596=$24;
      HEAP32[(($24)>>2)]=$2557;
      var $2597=HEAP32[(($24)>>2)];
      var $2598=(($2597)|0);
      var $2599=$23;
      HEAP32[(($23)>>2)]=$2598;
      var $2600=HEAP32[(($23)>>2)];
      var $2601=$2600;
      var $2602=$22;
      HEAP32[(($22)>>2)]=$2601;
      var $2603=HEAP32[(($22)>>2)];
      var $2604=(($2603)|0);
      var $2605=$22;
      var $2606=$23;
      var $2607=(($2604)|0);
      var $2608=$2607;
      var $2609=(($2608)|0);
      var $2610=$2609;
      var $2611=HEAPU8[($2610)];
      var $2612=(($2611)&255);
      var $2613=$2612 >> 1;
      var $2614=$24;
      var $2615 = $2613;__label__ = 264; break;
    case 264: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $2615;
      var $2616=$28;
      var $2617=(($2615)>>>0) > 0;
      if ($2617) { __label__ = 265; break; } else { __label__ = 271; break; }
    case 265: // $2618
      var $2619=$__ng;
      var $2620=(($2619)>>>0) > 0;
      if ($2620) { __label__ = 266; break; } else { __label__ = 271; break; }
    case 266: // $2621
      var $2622=$__c;
      var $2623=HEAP32[(($__ts)>>2)];
      var $2624=(($2622)|0)==(($2623)|0);
      if ($2624) { __label__ = 267; break; } else { __label__ = 271; break; }
    case 267: // $2625
      var $2626=HEAP32[(($__gn)>>2)];
      var $2627=HEAP32[(($__ge)>>2)];
      var $2628=(($2626)|0)==(($2627)|0);
      if ($2628) { __label__ = 268; break; } else { __label__ = 270; break; }
    case 268: // $2629
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__gb, $__gn, $__ge) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 269; break; } else { __label__ = 27; break; }
    case 269: // $2630
      __label__ = 270; break;
    case 270: // $2631
      var $2632=$__ng;
      var $2633=HEAP32[(($__gn)>>2)];
      var $2634=(($2633+4)|0);
      HEAP32[(($__gn)>>2)]=$2634;
      HEAP32[(($2633)>>2)]=$2632;
      $__ng=0;
      __label__ = 272; break;
    case 271: // $2635
      __label__ = 289; break;
    case 272: // $2636
      __label__ = 273; break;
    case 273: // $2637
      __label__ = 274; break;
    case 274: // $2638
      var $2639=$462;
      var $2640=$14;
      HEAP32[(($14)>>2)]=$2639;
      var $2641=HEAPU32[(($14)>>2)];
      var $2642=(($2641)|0);
      var $2643=HEAP32[(($2642)>>2)];
      var $2644=$12;
      var $2645=$13;
      HEAP32[(($13)>>2)]=$2643;
      var $2646=HEAPU32[(($13)>>2)];
      var $2647=$10;
      var $2648=$11;
      HEAP32[(($11)>>2)]=$2646;
      var $2649=HEAP32[(($11)>>2)];
      var $2650=(($2649+12)|0);
      var $2651=HEAP32[(($2650)>>2)];
      var $2652=(($2649+16)|0);
      var $2653=HEAP32[(($2652)>>2)];
      var $2654=(($2651)|0)==(($2653)|0);
      if ($2654) { __label__ = 275; break; } else { __label__ = 277; break; }
    case 275: // $2655
      var $2656=$2649;
      var $2657=HEAP32[(($2656)>>2)];
      var $2658=(($2657+40)|0);
      var $2659=HEAP32[(($2658)>>2)];
      var $2660=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2659]($2649) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 276; break; } else { __label__ = 27; break; };
    case 276: // $_noexc104
      HEAP32[(($10)>>2)]=$2660;
      __label__ = 278; break;
    case 277: // $2661
      var $2662=(($2649+12)|0);
      var $2663=HEAP32[(($2662)>>2)];
      var $2664=(($2663+4)|0);
      HEAP32[(($2662)>>2)]=$2664;
      var $2665=HEAP32[(($2663)>>2)];
      var $2666=$9;
      HEAP32[(($9)>>2)]=$2665;
      var $2667=HEAP32[(($9)>>2)];
      var $2668=$9;
      HEAP32[(($10)>>2)]=$2667;
      __label__ = 278; break;
    case 278: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i101
      var $2669=HEAP32[(($10)>>2)];
      var $2670=$10;
      var $2671=$11;
      var $2672=(($2669)|0)==-1;
      if ($2672) { __label__ = 279; break; } else { __label__ = 280; break; }
    case 279: // $2673
      HEAP32[(($12)>>2)]=-1;
      __label__ = 285; break;
    case 280: // $2674
      var $2675=$7;
      var $2676=$8;
      HEAP32[(($8)>>2)]=$2646;
      var $2677=HEAP32[(($8)>>2)];
      var $2678=(($2677+12)|0);
      var $2679=HEAP32[(($2678)>>2)];
      var $2680=(($2677+16)|0);
      var $2681=HEAP32[(($2680)>>2)];
      var $2682=(($2679)|0)==(($2681)|0);
      if ($2682) { __label__ = 281; break; } else { __label__ = 283; break; }
    case 281: // $2683
      var $2684=$2677;
      var $2685=HEAP32[(($2684)>>2)];
      var $2686=(($2685+36)|0);
      var $2687=HEAP32[(($2686)>>2)];
      var $2688=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2687]($2677) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 282; break; } else { __label__ = 27; break; };
    case 282: // $_noexc105
      HEAP32[(($7)>>2)]=$2688;
      __label__ = 284; break;
    case 283: // $2689
      var $2690=(($2677+12)|0);
      var $2691=HEAP32[(($2690)>>2)];
      var $2692=HEAP32[(($2691)>>2)];
      var $2693=$6;
      HEAP32[(($6)>>2)]=$2692;
      var $2694=HEAP32[(($6)>>2)];
      var $2695=$6;
      HEAP32[(($7)>>2)]=$2694;
      __label__ = 284; break;
    case 284: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i102
      var $2696=HEAP32[(($7)>>2)];
      var $2697=$7;
      var $2698=$8;
      HEAP32[(($12)>>2)]=$2696;
      __label__ = 285; break;
    case 285: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i103
      var $2699=HEAP32[(($12)>>2)];
      var $2700=$12;
      var $2701=$13;
      var $2702=$4;
      var $2703=$5;
      HEAP32[(($4)>>2)]=$2699;
      HEAP32[(($5)>>2)]=-1;
      var $2704=HEAP32[(($4)>>2)];
      var $2705=HEAP32[(($5)>>2)];
      var $2706=(($2704)|0)==(($2705)|0);
      var $2707=$4;
      var $2708=$5;
      if ($2706) { __label__ = 286; break; } else { __label__ = 287; break; }
    case 286: // $2709
      var $2710=(($2641)|0);
      HEAP32[(($2710)>>2)]=0;
      __label__ = 287; break;
    case 287: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit106
      var $2711=$14;
      __label__ = 288; break;
    case 288: // $2712
      __label__ = 247; break;
    case 289: // $2713
      var $2714=$3;
      HEAP32[(($3)>>2)]=$__gb;
      var $2715=HEAP32[(($3)>>2)];
      var $2716=(($2715)|0);
      var $2717=$2;
      HEAP32[(($2)>>2)]=$2716;
      var $2718=HEAP32[(($2)>>2)];
      var $2719=$2718;
      var $2720=$1;
      HEAP32[(($1)>>2)]=$2719;
      var $2721=HEAP32[(($1)>>2)];
      var $2722=(($2721)|0);
      var $2723=$1;
      var $2724=$2;
      var $2725=HEAP32[(($2722)>>2)];
      var $2726=$3;
      var $2727=HEAP32[(($__gn)>>2)];
      var $2728=(($2725)|0)!=(($2727)|0);
      if ($2728) { __label__ = 290; break; } else { __label__ = 295; break; }
    case 290: // $2729
      var $2730=$__ng;
      var $2731=(($2730)>>>0) > 0;
      if ($2731) { __label__ = 291; break; } else { __label__ = 295; break; }
    case 291: // $2732
      var $2733=HEAP32[(($__gn)>>2)];
      var $2734=HEAP32[(($__ge)>>2)];
      var $2735=(($2733)|0)==(($2734)|0);
      if ($2735) { __label__ = 292; break; } else { __label__ = 294; break; }
    case 292: // $2736
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__gb, $__gn, $__ge) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 293; break; } else { __label__ = 27; break; }
    case 293: // $2737
      __label__ = 294; break;
    case 294: // $2738
      var $2739=$__ng;
      var $2740=HEAP32[(($__gn)>>2)];
      var $2741=(($2740+4)|0);
      HEAP32[(($__gn)>>2)]=$2741;
      HEAP32[(($2740)>>2)]=$2739;
      __label__ = 295; break;
    case 295: // $2742
      var $2743=HEAP32[(($__fd)>>2)];
      var $2744=(($2743)|0) > 0;
      if ($2744) { __label__ = 296; break; } else { __label__ = 357; break; }
    case 296: // $2745
      var $2746=$462;
      var $2747=$17;
      var $2748=$18;
      HEAP32[(($17)>>2)]=$2746;
      HEAP32[(($18)>>2)]=$__e;
      var $2749=HEAP32[(($17)>>2)];
      var $2750=HEAP32[(($18)>>2)];
      var $2751=$15;
      var $2752=$16;
      HEAP32[(($15)>>2)]=$2749;
      HEAP32[(($16)>>2)]=$2750;
      var $2753=HEAP32[(($15)>>2)];
      var $2754=(($2753)|0);
      var $2755=HEAP32[(($2754)>>2)];
      var $2756=(($2755)|0)==0;
      var $2757=(($2756)&1);
      var $2758=HEAP32[(($16)>>2)];
      var $2759=(($2758)|0);
      var $2760=HEAP32[(($2759)>>2)];
      var $2761=(($2760)|0)==0;
      var $2762=(($2761)&1);
      var $2763=(($2757)|0)==(($2762)|0);
      var $2764=$15;
      var $2765=$16;
      var $2766=$17;
      var $2767=$18;
      __label__ = 297; break;
    case 297: // $2768
      if ($2763) { __label__ = 304; break; } else { __label__ = 298; break; }
    case 298: // $2769
      var $2770=$462;
      var $2771=$39;
      HEAP32[(($39)>>2)]=$2770;
      var $2772=HEAP32[(($39)>>2)];
      var $2773=(($2772)|0);
      var $2774=HEAP32[(($2773)>>2)];
      var $2775=$37;
      var $2776=$38;
      HEAP32[(($38)>>2)]=$2774;
      var $2777=HEAP32[(($38)>>2)];
      var $2778=(($2777+12)|0);
      var $2779=HEAP32[(($2778)>>2)];
      var $2780=(($2777+16)|0);
      var $2781=HEAP32[(($2780)>>2)];
      var $2782=(($2779)|0)==(($2781)|0);
      if ($2782) { __label__ = 299; break; } else { __label__ = 301; break; }
    case 299: // $2783
      var $2784=$2777;
      var $2785=HEAP32[(($2784)>>2)];
      var $2786=(($2785+36)|0);
      var $2787=HEAP32[(($2786)>>2)];
      var $2788=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2787]($2777) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 300; break; } else { __label__ = 27; break; };
    case 300: // $_noexc95
      HEAP32[(($37)>>2)]=$2788;
      __label__ = 302; break;
    case 301: // $2789
      var $2790=(($2777+12)|0);
      var $2791=HEAP32[(($2790)>>2)];
      var $2792=HEAP32[(($2791)>>2)];
      var $2793=$36;
      HEAP32[(($36)>>2)]=$2792;
      var $2794=HEAP32[(($36)>>2)];
      var $2795=$36;
      HEAP32[(($37)>>2)]=$2794;
      __label__ = 302; break;
    case 302: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit96
      var $2796=HEAP32[(($37)>>2)];
      var $2797=$37;
      var $2798=$38;
      var $2799=$39;
      __label__ = 303; break;
    case 303: // $2800
      var $2801=HEAP32[(($__dp)>>2)];
      var $2802=(($2796)|0)!=(($2801)|0);
      if ($2802) { __label__ = 304; break; } else { __label__ = 305; break; }
    case 304: // $2803
      var $2804=$466;
      var $2805=HEAP32[(($2804)>>2)];
      var $2806=$2805 | 4;
      HEAP32[(($2804)>>2)]=$2806;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 305: // $2807
      var $2808=$462;
      var $2809=$112;
      HEAP32[(($112)>>2)]=$2808;
      var $2810=HEAPU32[(($112)>>2)];
      var $2811=(($2810)|0);
      var $2812=HEAP32[(($2811)>>2)];
      var $2813=$110;
      var $2814=$111;
      HEAP32[(($111)>>2)]=$2812;
      var $2815=HEAP32[(($111)>>2)];
      var $2816=$108;
      var $2817=$109;
      HEAP32[(($109)>>2)]=$2815;
      var $2818=HEAP32[(($109)>>2)];
      var $2819=(($2818+12)|0);
      var $2820=HEAP32[(($2819)>>2)];
      var $2821=(($2818+16)|0);
      var $2822=HEAP32[(($2821)>>2)];
      var $2823=(($2820)|0)==(($2822)|0);
      if ($2823) { __label__ = 306; break; } else { __label__ = 308; break; }
    case 306: // $2824
      var $2825=$2818;
      var $2826=HEAP32[(($2825)>>2)];
      var $2827=(($2826+40)|0);
      var $2828=HEAP32[(($2827)>>2)];
      var $2829=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2828]($2818) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 307; break; } else { __label__ = 27; break; };
    case 307: // $_noexc75
      HEAP32[(($108)>>2)]=$2829;
      __label__ = 309; break;
    case 308: // $2830
      var $2831=(($2818+12)|0);
      var $2832=HEAP32[(($2831)>>2)];
      var $2833=(($2832+4)|0);
      HEAP32[(($2831)>>2)]=$2833;
      var $2834=HEAP32[(($2832)>>2)];
      var $2835=$107;
      HEAP32[(($107)>>2)]=$2834;
      var $2836=HEAP32[(($107)>>2)];
      var $2837=$107;
      HEAP32[(($108)>>2)]=$2836;
      __label__ = 309; break;
    case 309: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i72
      var $2838=HEAP32[(($108)>>2)];
      var $2839=$108;
      var $2840=$109;
      var $2841=(($2838)|0)==-1;
      if ($2841) { __label__ = 310; break; } else { __label__ = 311; break; }
    case 310: // $2842
      HEAP32[(($110)>>2)]=-1;
      __label__ = 316; break;
    case 311: // $2843
      var $2844=$105;
      var $2845=$106;
      HEAP32[(($106)>>2)]=$2815;
      var $2846=HEAP32[(($106)>>2)];
      var $2847=(($2846+12)|0);
      var $2848=HEAP32[(($2847)>>2)];
      var $2849=(($2846+16)|0);
      var $2850=HEAP32[(($2849)>>2)];
      var $2851=(($2848)|0)==(($2850)|0);
      if ($2851) { __label__ = 312; break; } else { __label__ = 314; break; }
    case 312: // $2852
      var $2853=$2846;
      var $2854=HEAP32[(($2853)>>2)];
      var $2855=(($2854+36)|0);
      var $2856=HEAP32[(($2855)>>2)];
      var $2857=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2856]($2846) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 313; break; } else { __label__ = 27; break; };
    case 313: // $_noexc76
      HEAP32[(($105)>>2)]=$2857;
      __label__ = 315; break;
    case 314: // $2858
      var $2859=(($2846+12)|0);
      var $2860=HEAP32[(($2859)>>2)];
      var $2861=HEAP32[(($2860)>>2)];
      var $2862=$104;
      HEAP32[(($104)>>2)]=$2861;
      var $2863=HEAP32[(($104)>>2)];
      var $2864=$104;
      HEAP32[(($105)>>2)]=$2863;
      __label__ = 315; break;
    case 315: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i73
      var $2865=HEAP32[(($105)>>2)];
      var $2866=$105;
      var $2867=$106;
      HEAP32[(($110)>>2)]=$2865;
      __label__ = 316; break;
    case 316: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i74
      var $2868=HEAP32[(($110)>>2)];
      var $2869=$110;
      var $2870=$111;
      var $2871=$102;
      var $2872=$103;
      HEAP32[(($102)>>2)]=$2868;
      HEAP32[(($103)>>2)]=-1;
      var $2873=HEAP32[(($102)>>2)];
      var $2874=HEAP32[(($103)>>2)];
      var $2875=(($2873)|0)==(($2874)|0);
      var $2876=$102;
      var $2877=$103;
      if ($2875) { __label__ = 317; break; } else { __label__ = 318; break; }
    case 317: // $2878
      var $2879=(($2810)|0);
      HEAP32[(($2879)>>2)]=0;
      __label__ = 318; break;
    case 318: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit77
      var $2880=$112;
      __label__ = 319; break;
    case 319: // $2881
      __label__ = 320; break;
    case 320: // $2882
      var $2883=HEAP32[(($__fd)>>2)];
      var $2884=(($2883)|0) > 0;
      if ($2884) { __label__ = 321; break; } else { __label__ = 356; break; }
    case 321: // $2885
      var $2886=$462;
      var $2887=$115;
      var $2888=$116;
      HEAP32[(($115)>>2)]=$2886;
      HEAP32[(($116)>>2)]=$__e;
      var $2889=HEAP32[(($115)>>2)];
      var $2890=HEAP32[(($116)>>2)];
      var $2891=$113;
      var $2892=$114;
      HEAP32[(($113)>>2)]=$2889;
      HEAP32[(($114)>>2)]=$2890;
      var $2893=HEAP32[(($113)>>2)];
      var $2894=(($2893)|0);
      var $2895=HEAP32[(($2894)>>2)];
      var $2896=(($2895)|0)==0;
      var $2897=(($2896)&1);
      var $2898=HEAP32[(($114)>>2)];
      var $2899=(($2898)|0);
      var $2900=HEAP32[(($2899)>>2)];
      var $2901=(($2900)|0)==0;
      var $2902=(($2901)&1);
      var $2903=(($2897)|0)==(($2902)|0);
      var $2904=$113;
      var $2905=$114;
      var $2906=$115;
      var $2907=$116;
      __label__ = 322; break;
    case 322: // $2908
      if ($2903) { __label__ = 331; break; } else { __label__ = 323; break; }
    case 323: // $2909
      var $2910=$468;
      var $2911=$462;
      var $2912=$157;
      HEAP32[(($157)>>2)]=$2911;
      var $2913=HEAP32[(($157)>>2)];
      var $2914=(($2913)|0);
      var $2915=HEAP32[(($2914)>>2)];
      var $2916=$155;
      var $2917=$156;
      HEAP32[(($156)>>2)]=$2915;
      var $2918=HEAP32[(($156)>>2)];
      var $2919=(($2918+12)|0);
      var $2920=HEAP32[(($2919)>>2)];
      var $2921=(($2918+16)|0);
      var $2922=HEAP32[(($2921)>>2)];
      var $2923=(($2920)|0)==(($2922)|0);
      if ($2923) { __label__ = 324; break; } else { __label__ = 326; break; }
    case 324: // $2924
      var $2925=$2918;
      var $2926=HEAP32[(($2925)>>2)];
      var $2927=(($2926+36)|0);
      var $2928=HEAP32[(($2927)>>2)];
      var $2929=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2928]($2918) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 325; break; } else { __label__ = 27; break; };
    case 325: // $_noexc60
      HEAP32[(($155)>>2)]=$2929;
      __label__ = 327; break;
    case 326: // $2930
      var $2931=(($2918+12)|0);
      var $2932=HEAP32[(($2931)>>2)];
      var $2933=HEAP32[(($2932)>>2)];
      var $2934=$154;
      HEAP32[(($154)>>2)]=$2933;
      var $2935=HEAP32[(($154)>>2)];
      var $2936=$154;
      HEAP32[(($155)>>2)]=$2935;
      __label__ = 327; break;
    case 327: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit61
      var $2937=HEAP32[(($155)>>2)];
      var $2938=$155;
      var $2939=$156;
      var $2940=$157;
      __label__ = 328; break;
    case 328: // $2941
      var $2942=$195;
      var $2943=$196;
      var $2944=$197;
      HEAP32[(($195)>>2)]=$2910;
      HEAP32[(($196)>>2)]=1024;
      HEAP32[(($197)>>2)]=$2937;
      var $2945=HEAP32[(($195)>>2)];
      var $2946=$2945;
      var $2947=HEAP32[(($2946)>>2)];
      var $2948=(($2947+12)|0);
      var $2949=HEAP32[(($2948)>>2)];
      var $2950=HEAP32[(($196)>>2)];
      var $2951=HEAP32[(($197)>>2)];
      var $2952=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2949]($2945, $2950, $2951) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 329; break; } else { __label__ = 27; break; };
    case 329: // $_ZNKSt3__15ctypeIwE2isEjw_exit49
      var $2953=$195;
      var $2954=$196;
      var $2955=$197;
      __label__ = 330; break;
    case 330: // $2956
      if ($2952) { __label__ = 332; break; } else { __label__ = 331; break; }
    case 331: // $2957
      var $2958=$466;
      var $2959=HEAP32[(($2958)>>2)];
      var $2960=$2959 | 4;
      HEAP32[(($2958)>>2)]=$2960;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 332: // $2961
      var $2962=$470;
      var $2963=HEAP32[(($2962)>>2)];
      var $2964=HEAP32[(($471)>>2)];
      var $2965=(($2963)|0)==(($2964)|0);
      if ($2965) { __label__ = 333; break; } else { __label__ = 335; break; }
    case 333: // $2966
      var $2967=$469;
      var $2968=$470;
      (function() { try { __THREW__ = false; return __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($2967, $2968, $471) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 334; break; } else { __label__ = 27; break; }
    case 334: // $2969
      __label__ = 335; break;
    case 335: // $2970
      var $2971=$462;
      var $2972=$227;
      HEAP32[(($227)>>2)]=$2971;
      var $2973=HEAP32[(($227)>>2)];
      var $2974=(($2973)|0);
      var $2975=HEAP32[(($2974)>>2)];
      var $2976=$225;
      var $2977=$226;
      HEAP32[(($226)>>2)]=$2975;
      var $2978=HEAP32[(($226)>>2)];
      var $2979=(($2978+12)|0);
      var $2980=HEAP32[(($2979)>>2)];
      var $2981=(($2978+16)|0);
      var $2982=HEAP32[(($2981)>>2)];
      var $2983=(($2980)|0)==(($2982)|0);
      if ($2983) { __label__ = 336; break; } else { __label__ = 338; break; }
    case 336: // $2984
      var $2985=$2978;
      var $2986=HEAP32[(($2985)>>2)];
      var $2987=(($2986+36)|0);
      var $2988=HEAP32[(($2987)>>2)];
      var $2989=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$2988]($2978) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 337; break; } else { __label__ = 27; break; };
    case 337: // $_noexc43
      HEAP32[(($225)>>2)]=$2989;
      __label__ = 339; break;
    case 338: // $2990
      var $2991=(($2978+12)|0);
      var $2992=HEAP32[(($2991)>>2)];
      var $2993=HEAP32[(($2992)>>2)];
      var $2994=$224;
      HEAP32[(($224)>>2)]=$2993;
      var $2995=HEAP32[(($224)>>2)];
      var $2996=$224;
      HEAP32[(($225)>>2)]=$2995;
      __label__ = 339; break;
    case 339: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit44
      var $2997=HEAP32[(($225)>>2)];
      var $2998=$225;
      var $2999=$226;
      var $3000=$227;
      __label__ = 340; break;
    case 340: // $3001
      var $3002=$470;
      var $3003=HEAP32[(($3002)>>2)];
      var $3004=(($3003+4)|0);
      HEAP32[(($3002)>>2)]=$3004;
      HEAP32[(($3003)>>2)]=$2997;
      __label__ = 341; break;
    case 341: // $3005
      var $3006=HEAP32[(($__fd)>>2)];
      var $3007=(($3006-1)|0);
      HEAP32[(($__fd)>>2)]=$3007;
      var $3008=$462;
      var $3009=$258;
      HEAP32[(($258)>>2)]=$3008;
      var $3010=HEAP32[(($258)>>2)];
      var $3011=(($3010)|0);
      var $3012=HEAP32[(($3011)>>2)];
      var $3013=$256;
      var $3014=$257;
      HEAP32[(($257)>>2)]=$3012;
      var $3015=HEAP32[(($257)>>2)];
      var $3016=$254;
      var $3017=$255;
      HEAP32[(($255)>>2)]=$3015;
      var $3018=HEAP32[(($255)>>2)];
      var $3019=(($3018+12)|0);
      var $3020=HEAP32[(($3019)>>2)];
      var $3021=(($3018+16)|0);
      var $3022=HEAP32[(($3021)>>2)];
      var $3023=(($3020)|0)==(($3022)|0);
      if ($3023) { __label__ = 342; break; } else { __label__ = 344; break; }
    case 342: // $3024
      var $3025=$3018;
      var $3026=HEAP32[(($3025)>>2)];
      var $3027=(($3026+40)|0);
      var $3028=HEAP32[(($3027)>>2)];
      var $3029=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3028]($3018) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 343; break; } else { __label__ = 27; break; };
    case 343: // $_noexc38
      HEAP32[(($254)>>2)]=$3029;
      __label__ = 345; break;
    case 344: // $3030
      var $3031=(($3018+12)|0);
      var $3032=HEAP32[(($3031)>>2)];
      var $3033=(($3032+4)|0);
      HEAP32[(($3031)>>2)]=$3033;
      var $3034=HEAP32[(($3032)>>2)];
      var $3035=$253;
      HEAP32[(($253)>>2)]=$3034;
      var $3036=HEAP32[(($253)>>2)];
      var $3037=$253;
      HEAP32[(($254)>>2)]=$3036;
      __label__ = 345; break;
    case 345: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i35
      var $3038=HEAP32[(($254)>>2)];
      var $3039=$254;
      var $3040=$255;
      var $3041=(($3038)|0)==-1;
      if ($3041) { __label__ = 346; break; } else { __label__ = 347; break; }
    case 346: // $3042
      HEAP32[(($256)>>2)]=-1;
      __label__ = 352; break;
    case 347: // $3043
      var $3044=$251;
      var $3045=$252;
      HEAP32[(($252)>>2)]=$3015;
      var $3046=HEAP32[(($252)>>2)];
      var $3047=(($3046+12)|0);
      var $3048=HEAP32[(($3047)>>2)];
      var $3049=(($3046+16)|0);
      var $3050=HEAP32[(($3049)>>2)];
      var $3051=(($3048)|0)==(($3050)|0);
      if ($3051) { __label__ = 348; break; } else { __label__ = 350; break; }
    case 348: // $3052
      var $3053=$3046;
      var $3054=HEAP32[(($3053)>>2)];
      var $3055=(($3054+36)|0);
      var $3056=HEAP32[(($3055)>>2)];
      var $3057=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3056]($3046) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 349; break; } else { __label__ = 27; break; };
    case 349: // $_noexc39
      HEAP32[(($251)>>2)]=$3057;
      __label__ = 351; break;
    case 350: // $3058
      var $3059=(($3046+12)|0);
      var $3060=HEAP32[(($3059)>>2)];
      var $3061=HEAP32[(($3060)>>2)];
      var $3062=$250;
      HEAP32[(($250)>>2)]=$3061;
      var $3063=HEAP32[(($250)>>2)];
      var $3064=$250;
      HEAP32[(($251)>>2)]=$3063;
      __label__ = 351; break;
    case 351: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i36
      var $3065=HEAP32[(($251)>>2)];
      var $3066=$251;
      var $3067=$252;
      HEAP32[(($256)>>2)]=$3065;
      __label__ = 352; break;
    case 352: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i37
      var $3068=HEAP32[(($256)>>2)];
      var $3069=$256;
      var $3070=$257;
      var $3071=$248;
      var $3072=$249;
      HEAP32[(($248)>>2)]=$3068;
      HEAP32[(($249)>>2)]=-1;
      var $3073=HEAP32[(($248)>>2)];
      var $3074=HEAP32[(($249)>>2)];
      var $3075=(($3073)|0)==(($3074)|0);
      var $3076=$248;
      var $3077=$249;
      if ($3075) { __label__ = 353; break; } else { __label__ = 354; break; }
    case 353: // $3078
      var $3079=(($3010)|0);
      HEAP32[(($3079)>>2)]=0;
      __label__ = 354; break;
    case 354: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit40
      var $3080=$258;
      __label__ = 355; break;
    case 355: // $3081
      __label__ = 320; break;
    case 356: // $3082
      __label__ = 357; break;
    case 357: // $3083
      var $3084=$470;
      var $3085=HEAP32[(($3084)>>2)];
      var $3086=$469;
      var $3087=$261;
      HEAP32[(($261)>>2)]=$3086;
      var $3088=HEAP32[(($261)>>2)];
      var $3089=(($3088)|0);
      var $3090=$260;
      HEAP32[(($260)>>2)]=$3089;
      var $3091=HEAP32[(($260)>>2)];
      var $3092=$3091;
      var $3093=$259;
      HEAP32[(($259)>>2)]=$3092;
      var $3094=HEAP32[(($259)>>2)];
      var $3095=(($3094)|0);
      var $3096=$259;
      var $3097=$260;
      var $3098=HEAP32[(($3095)>>2)];
      var $3099=$261;
      var $3100=(($3085)|0)==(($3098)|0);
      if ($3100) { __label__ = 358; break; } else { __label__ = 359; break; }
    case 358: // $3101
      var $3102=$466;
      var $3103=HEAP32[(($3102)>>2)];
      var $3104=$3103 | 4;
      HEAP32[(($3102)>>2)]=$3104;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 359: // $3105
      __label__ = 360; break;
    case 360: // $3106
      __label__ = 361; break;
    case 361: // $3107
      var $3108=$__p;
      var $3109=(($3108+1)|0);
      $__p=$3109;
      __label__ = 18; break;
    case 362: // $3110
      var $3111=$__trailing_sign;
      var $3112=(($3111)|0)!=0;
      if ($3112) { __label__ = 363; break; } else { __label__ = 398; break; }
    case 363: // $3113
      $__i=1;
      __label__ = 364; break;
    case 364: // $3114
      var $3115=$__i;
      var $3116=$__trailing_sign;
      var $3117=$271;
      HEAP32[(($271)>>2)]=$3116;
      var $3118=HEAPU32[(($271)>>2)];
      var $3119=$270;
      HEAP32[(($270)>>2)]=$3118;
      var $3120=HEAP32[(($270)>>2)];
      var $3121=(($3120)|0);
      var $3122=$269;
      HEAP32[(($269)>>2)]=$3121;
      var $3123=HEAP32[(($269)>>2)];
      var $3124=$3123;
      var $3125=$268;
      HEAP32[(($268)>>2)]=$3124;
      var $3126=HEAP32[(($268)>>2)];
      var $3127=(($3126)|0);
      var $3128=$268;
      var $3129=$269;
      var $3130=(($3127)|0);
      var $3131=$3130;
      var $3132=(($3131)|0);
      var $3133=$3132;
      var $3134=HEAPU8[($3133)];
      var $3135=(($3134)&255);
      var $3136=$3135 & 1;
      var $3137=(($3136)|0)!=0;
      var $3138=$270;
      if ($3137) { __label__ = 365; break; } else { __label__ = 366; break; }
    case 365: // $3139
      var $3140=$264;
      HEAP32[(($264)>>2)]=$3118;
      var $3141=HEAP32[(($264)>>2)];
      var $3142=(($3141)|0);
      var $3143=$263;
      HEAP32[(($263)>>2)]=$3142;
      var $3144=HEAP32[(($263)>>2)];
      var $3145=$3144;
      var $3146=$262;
      HEAP32[(($262)>>2)]=$3145;
      var $3147=HEAP32[(($262)>>2)];
      var $3148=(($3147)|0);
      var $3149=$262;
      var $3150=$263;
      var $3151=(($3148)|0);
      var $3152=$3151;
      var $3153=(($3152+4)|0);
      var $3154=HEAP32[(($3153)>>2)];
      var $3155=$264;
      var $3176 = $3154;__label__ = 367; break;
    case 366: // $3156
      var $3157=$267;
      HEAP32[(($267)>>2)]=$3118;
      var $3158=HEAP32[(($267)>>2)];
      var $3159=(($3158)|0);
      var $3160=$266;
      HEAP32[(($266)>>2)]=$3159;
      var $3161=HEAP32[(($266)>>2)];
      var $3162=$3161;
      var $3163=$265;
      HEAP32[(($265)>>2)]=$3162;
      var $3164=HEAP32[(($265)>>2)];
      var $3165=(($3164)|0);
      var $3166=$265;
      var $3167=$266;
      var $3168=(($3165)|0);
      var $3169=$3168;
      var $3170=(($3169)|0);
      var $3171=$3170;
      var $3172=HEAPU8[($3171)];
      var $3173=(($3172)&255);
      var $3174=$3173 >> 1;
      var $3175=$267;
      var $3176 = $3174;__label__ = 367; break;
    case 367: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit34
      var $3176;
      var $3177=$271;
      var $3178=(($3115)>>>0) < (($3176)>>>0);
      if ($3178) { __label__ = 368; break; } else { __label__ = 397; break; }
    case 368: // $3179
      var $3180=$462;
      var $3181=$274;
      var $3182=$275;
      HEAP32[(($274)>>2)]=$3180;
      HEAP32[(($275)>>2)]=$__e;
      var $3183=HEAP32[(($274)>>2)];
      var $3184=HEAP32[(($275)>>2)];
      var $3185=$272;
      var $3186=$273;
      HEAP32[(($272)>>2)]=$3183;
      HEAP32[(($273)>>2)]=$3184;
      var $3187=HEAP32[(($272)>>2)];
      var $3188=(($3187)|0);
      var $3189=HEAP32[(($3188)>>2)];
      var $3190=(($3189)|0)==0;
      var $3191=(($3190)&1);
      var $3192=HEAP32[(($273)>>2)];
      var $3193=(($3192)|0);
      var $3194=HEAP32[(($3193)>>2)];
      var $3195=(($3194)|0)==0;
      var $3196=(($3195)&1);
      var $3197=(($3191)|0)==(($3196)|0);
      var $3198=$272;
      var $3199=$273;
      var $3200=$274;
      var $3201=$275;
      __label__ = 369; break;
    case 369: // $3202
      if ($3197) { __label__ = 380; break; } else { __label__ = 370; break; }
    case 370: // $3203
      var $3204=$462;
      var $3205=$339;
      HEAP32[(($339)>>2)]=$3204;
      var $3206=HEAP32[(($339)>>2)];
      var $3207=(($3206)|0);
      var $3208=HEAP32[(($3207)>>2)];
      var $3209=$337;
      var $3210=$338;
      HEAP32[(($338)>>2)]=$3208;
      var $3211=HEAP32[(($338)>>2)];
      var $3212=(($3211+12)|0);
      var $3213=HEAP32[(($3212)>>2)];
      var $3214=(($3211+16)|0);
      var $3215=HEAP32[(($3214)>>2)];
      var $3216=(($3213)|0)==(($3215)|0);
      if ($3216) { __label__ = 371; break; } else { __label__ = 373; break; }
    case 371: // $3217
      var $3218=$3211;
      var $3219=HEAP32[(($3218)>>2)];
      var $3220=(($3219+36)|0);
      var $3221=HEAP32[(($3220)>>2)];
      var $3222=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3221]($3211) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 372; break; } else { __label__ = 27; break; };
    case 372: // $_noexc13
      HEAP32[(($337)>>2)]=$3222;
      __label__ = 374; break;
    case 373: // $3223
      var $3224=(($3211+12)|0);
      var $3225=HEAP32[(($3224)>>2)];
      var $3226=HEAP32[(($3225)>>2)];
      var $3227=$336;
      HEAP32[(($336)>>2)]=$3226;
      var $3228=HEAP32[(($336)>>2)];
      var $3229=$336;
      HEAP32[(($337)>>2)]=$3228;
      __label__ = 374; break;
    case 374: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $3230=HEAP32[(($337)>>2)];
      var $3231=$337;
      var $3232=$338;
      var $3233=$339;
      __label__ = 375; break;
    case 375: // $3234
      var $3235=$__trailing_sign;
      var $3236=$__i;
      var $3237=$351;
      var $3238=$352;
      HEAP32[(($351)>>2)]=$3235;
      HEAP32[(($352)>>2)]=$3236;
      var $3239=HEAP32[(($351)>>2)];
      var $3240=$350;
      HEAP32[(($350)>>2)]=$3239;
      var $3241=HEAP32[(($350)>>2)];
      var $3242=$349;
      HEAP32[(($349)>>2)]=$3241;
      var $3243=HEAPU32[(($349)>>2)];
      var $3244=$348;
      HEAP32[(($348)>>2)]=$3243;
      var $3245=HEAP32[(($348)>>2)];
      var $3246=(($3245)|0);
      var $3247=$347;
      HEAP32[(($347)>>2)]=$3246;
      var $3248=HEAP32[(($347)>>2)];
      var $3249=$3248;
      var $3250=$346;
      HEAP32[(($346)>>2)]=$3249;
      var $3251=HEAP32[(($346)>>2)];
      var $3252=(($3251)|0);
      var $3253=$346;
      var $3254=$347;
      var $3255=(($3252)|0);
      var $3256=$3255;
      var $3257=(($3256)|0);
      var $3258=$3257;
      var $3259=HEAPU8[($3258)];
      var $3260=(($3259)&255);
      var $3261=$3260 & 1;
      var $3262=(($3261)|0)!=0;
      var $3263=$348;
      if ($3262) { __label__ = 376; break; } else { __label__ = 377; break; }
    case 376: // $3264
      var $3265=$342;
      HEAP32[(($342)>>2)]=$3243;
      var $3266=HEAP32[(($342)>>2)];
      var $3267=(($3266)|0);
      var $3268=$341;
      HEAP32[(($341)>>2)]=$3267;
      var $3269=HEAP32[(($341)>>2)];
      var $3270=$3269;
      var $3271=$340;
      HEAP32[(($340)>>2)]=$3270;
      var $3272=HEAP32[(($340)>>2)];
      var $3273=(($3272)|0);
      var $3274=$340;
      var $3275=$341;
      var $3276=(($3273)|0);
      var $3277=$3276;
      var $3278=(($3277+8)|0);
      var $3279=HEAP32[(($3278)>>2)];
      var $3280=$342;
      var $3298 = $3279;__label__ = 378; break;
    case 377: // $3281
      var $3282=$345;
      HEAP32[(($345)>>2)]=$3243;
      var $3283=HEAP32[(($345)>>2)];
      var $3284=(($3283)|0);
      var $3285=$344;
      HEAP32[(($344)>>2)]=$3284;
      var $3286=HEAP32[(($344)>>2)];
      var $3287=$3286;
      var $3288=$343;
      HEAP32[(($343)>>2)]=$3287;
      var $3289=HEAP32[(($343)>>2)];
      var $3290=(($3289)|0);
      var $3291=$343;
      var $3292=$344;
      var $3293=(($3290)|0);
      var $3294=$3293;
      var $3295=(($3294+4)|0);
      var $3296=(($3295)|0);
      var $3297=$345;
      var $3298 = $3296;__label__ = 378; break;
    case 378: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit
      var $3298;
      var $3299=$349;
      var $3300=$350;
      var $3301=HEAP32[(($352)>>2)];
      var $3302=(($3298+($3301<<2))|0);
      var $3303=$351;
      var $3304=$352;
      __label__ = 379; break;
    case 379: // $3305
      var $3306=HEAP32[(($3302)>>2)];
      var $3307=(($3230)|0)!=(($3306)|0);
      if ($3307) { __label__ = 380; break; } else { __label__ = 381; break; }
    case 380: // $3308
      var $3309=$466;
      var $3310=HEAP32[(($3309)>>2)];
      var $3311=$3310 | 4;
      HEAP32[(($3309)>>2)]=$3311;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 381: // $3312
      __label__ = 382; break;
    case 382: // $3313
      var $3314=$__i;
      var $3315=(($3314+1)|0);
      $__i=$3315;
      var $3316=$462;
      var $3317=$370;
      HEAP32[(($370)>>2)]=$3316;
      var $3318=HEAPU32[(($370)>>2)];
      var $3319=(($3318)|0);
      var $3320=HEAP32[(($3319)>>2)];
      var $3321=$368;
      var $3322=$369;
      HEAP32[(($369)>>2)]=$3320;
      var $3323=HEAP32[(($369)>>2)];
      var $3324=$366;
      var $3325=$367;
      HEAP32[(($367)>>2)]=$3323;
      var $3326=HEAP32[(($367)>>2)];
      var $3327=(($3326+12)|0);
      var $3328=HEAP32[(($3327)>>2)];
      var $3329=(($3326+16)|0);
      var $3330=HEAP32[(($3329)>>2)];
      var $3331=(($3328)|0)==(($3330)|0);
      if ($3331) { __label__ = 383; break; } else { __label__ = 385; break; }
    case 383: // $3332
      var $3333=$3326;
      var $3334=HEAP32[(($3333)>>2)];
      var $3335=(($3334+40)|0);
      var $3336=HEAP32[(($3335)>>2)];
      var $3337=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3336]($3326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 384; break; } else { __label__ = 27; break; };
    case 384: // $_noexc
      HEAP32[(($366)>>2)]=$3337;
      __label__ = 386; break;
    case 385: // $3338
      var $3339=(($3326+12)|0);
      var $3340=HEAP32[(($3339)>>2)];
      var $3341=(($3340+4)|0);
      HEAP32[(($3339)>>2)]=$3341;
      var $3342=HEAP32[(($3340)>>2)];
      var $3343=$365;
      HEAP32[(($365)>>2)]=$3342;
      var $3344=HEAP32[(($365)>>2)];
      var $3345=$365;
      HEAP32[(($366)>>2)]=$3344;
      __label__ = 386; break;
    case 386: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $3346=HEAP32[(($366)>>2)];
      var $3347=$366;
      var $3348=$367;
      var $3349=(($3346)|0)==-1;
      if ($3349) { __label__ = 387; break; } else { __label__ = 388; break; }
    case 387: // $3350
      HEAP32[(($368)>>2)]=-1;
      __label__ = 393; break;
    case 388: // $3351
      var $3352=$363;
      var $3353=$364;
      HEAP32[(($364)>>2)]=$3323;
      var $3354=HEAP32[(($364)>>2)];
      var $3355=(($3354+12)|0);
      var $3356=HEAP32[(($3355)>>2)];
      var $3357=(($3354+16)|0);
      var $3358=HEAP32[(($3357)>>2)];
      var $3359=(($3356)|0)==(($3358)|0);
      if ($3359) { __label__ = 389; break; } else { __label__ = 391; break; }
    case 389: // $3360
      var $3361=$3354;
      var $3362=HEAP32[(($3361)>>2)];
      var $3363=(($3362+36)|0);
      var $3364=HEAP32[(($3363)>>2)];
      var $3365=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$3364]($3354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 390; break; } else { __label__ = 27; break; };
    case 390: // $_noexc12
      HEAP32[(($363)>>2)]=$3365;
      __label__ = 392; break;
    case 391: // $3366
      var $3367=(($3354+12)|0);
      var $3368=HEAP32[(($3367)>>2)];
      var $3369=HEAP32[(($3368)>>2)];
      var $3370=$362;
      HEAP32[(($362)>>2)]=$3369;
      var $3371=HEAP32[(($362)>>2)];
      var $3372=$362;
      HEAP32[(($363)>>2)]=$3371;
      __label__ = 392; break;
    case 392: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $3373=HEAP32[(($363)>>2)];
      var $3374=$363;
      var $3375=$364;
      HEAP32[(($368)>>2)]=$3373;
      __label__ = 393; break;
    case 393: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $3376=HEAP32[(($368)>>2)];
      var $3377=$368;
      var $3378=$369;
      var $3379=$360;
      var $3380=$361;
      HEAP32[(($360)>>2)]=$3376;
      HEAP32[(($361)>>2)]=-1;
      var $3381=HEAP32[(($360)>>2)];
      var $3382=HEAP32[(($361)>>2)];
      var $3383=(($3381)|0)==(($3382)|0);
      var $3384=$360;
      var $3385=$361;
      if ($3383) { __label__ = 394; break; } else { __label__ = 395; break; }
    case 394: // $3386
      var $3387=(($3318)|0);
      HEAP32[(($3387)>>2)]=0;
      __label__ = 395; break;
    case 395: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $3388=$370;
      __label__ = 396; break;
    case 396: // $3389
      __label__ = 364; break;
    case 397: // $3390
      __label__ = 398; break;
    case 398: // $3391
      var $3392=$373;
      HEAP32[(($373)>>2)]=$__gb;
      var $3393=HEAP32[(($373)>>2)];
      var $3394=(($3393)|0);
      var $3395=$372;
      HEAP32[(($372)>>2)]=$3394;
      var $3396=HEAP32[(($372)>>2)];
      var $3397=$3396;
      var $3398=$371;
      HEAP32[(($371)>>2)]=$3397;
      var $3399=HEAP32[(($371)>>2)];
      var $3400=(($3399)|0);
      var $3401=$371;
      var $3402=$372;
      var $3403=HEAP32[(($3400)>>2)];
      var $3404=$373;
      var $3405=HEAP32[(($__gn)>>2)];
      var $3406=(($3403)|0)!=(($3405)|0);
      if ($3406) { __label__ = 399; break; } else { __label__ = 403; break; }
    case 399: // $3407
      HEAP32[(($__et1)>>2)]=0;
      var $3408=$376;
      HEAP32[(($376)>>2)]=$__gb;
      var $3409=HEAP32[(($376)>>2)];
      var $3410=(($3409)|0);
      var $3411=$375;
      HEAP32[(($375)>>2)]=$3410;
      var $3412=HEAP32[(($375)>>2)];
      var $3413=$3412;
      var $3414=$374;
      HEAP32[(($374)>>2)]=$3413;
      var $3415=HEAP32[(($374)>>2)];
      var $3416=(($3415)|0);
      var $3417=$374;
      var $3418=$375;
      var $3419=HEAP32[(($3416)>>2)];
      var $3420=$376;
      var $3421=HEAP32[(($__gn)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj($__grp, $3419, $3421, $__et1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 400; break; } else { __label__ = 27; break; }
    case 400: // $3422
      var $3423=HEAP32[(($__et1)>>2)];
      var $3424=(($3423)|0)!=0;
      if ($3424) { __label__ = 401; break; } else { __label__ = 402; break; }
    case 401: // $3425
      var $3426=$466;
      var $3427=HEAP32[(($3426)>>2)];
      var $3428=$3427 | 4;
      HEAP32[(($3426)>>2)]=$3428;
      $461=0;
      $474=1;
      __label__ = 404; break;
    case 402: // $3429
      __label__ = 403; break;
    case 403: // $3430
      $461=1;
      $474=1;
      __label__ = 404; break;
    case 404: // $3431
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__nsn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 405; break; } else { __label__ = 26; break; }
    case 405: // $3432
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__psn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 407; break; } else { __label__ = 25; break; }
    case 406: // $3433
      __label__ = 408; break;
    case 407: // $3434
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 410; break; } else { __label__ = 24; break; }
    case 408: // $3435
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__psn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 409; break; } else { __label__ = 427; break; }
    case 409: // $3436
      __label__ = 411; break;
    case 410: // $3437
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 413; break; } else { __label__ = 23; break; }
    case 411: // $3438
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 412; break; } else { __label__ = 427; break; }
    case 412: // $3439
      __label__ = 418; break;
    case 413: // $3440
      var $3441=$415;
      HEAP32[(($415)>>2)]=$__gb;
      var $3442=HEAP32[(($415)>>2)];
      var $3443=$414;
      HEAP32[(($414)>>2)]=$3442;
      var $3444=HEAP32[(($414)>>2)];
      var $3445=$410;
      var $3446=$411;
      var $3447=$__tmp_i_i_i2;
      var $3448=$412;
      var $3449=$413;
      HEAP32[(($410)>>2)]=$3444;
      HEAP32[(($411)>>2)]=0;
      var $3450=HEAP32[(($410)>>2)];
      var $3451=(($3450)|0);
      var $3452=$409;
      HEAP32[(($409)>>2)]=$3451;
      var $3453=HEAP32[(($409)>>2)];
      var $3454=$3453;
      var $3455=$408;
      HEAP32[(($408)>>2)]=$3454;
      var $3456=HEAP32[(($408)>>2)];
      var $3457=(($3456)|0);
      var $3458=$408;
      var $3459=$409;
      var $3460=HEAP32[(($3457)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$3460;
      var $3461=HEAP32[(($411)>>2)];
      var $3462=(($3450)|0);
      var $3463=$407;
      HEAP32[(($407)>>2)]=$3462;
      var $3464=HEAP32[(($407)>>2)];
      var $3465=$3464;
      var $3466=$406;
      HEAP32[(($406)>>2)]=$3465;
      var $3467=HEAP32[(($406)>>2)];
      var $3468=(($3467)|0);
      var $3469=$406;
      var $3470=$407;
      HEAP32[(($3468)>>2)]=$3461;
      var $3471=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $3472=(($3471)|0)!=0;
      if ($3472) { __label__ = 414; break; } else { __label__ = 417; break; }
    case 414: // $3473
      var $3474=(($3450)|0);
      var $3475=$405;
      HEAP32[(($405)>>2)]=$3474;
      var $3476=HEAP32[(($405)>>2)];
      var $3477=$3476;
      var $3478=$404;
      HEAP32[(($404)>>2)]=$3477;
      var $3479=HEAP32[(($404)>>2)];
      var $3480=(($3479+4)|0);
      var $3481=$404;
      var $3482=$405;
      var $3483=HEAP32[(($3480)>>2)];
      var $3484=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $3485=$3484;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$3483]($3485) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 415; break; } else { __label__ = 416; break; }
    case 415: // $3486
      __label__ = 417; break;
    case 416: // $3487
      var $3488=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $3489=$3488.f0;
      HEAP32[(($412)>>2)]=$3489;
      var $3490=$3488.f1;
      HEAP32[(($413)>>2)]=$3490;
      var $3491=HEAP32[(($412)>>2)];
      ___cxa_call_unexpected($3491);
      throw "Reached an unreachable!"
    case 417: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit3
      var $3492=$410;
      var $3493=$411;
      var $3494=$__tmp_i_i_i2;
      var $3495=$412;
      var $3496=$413;
      var $3497=$414;
      var $3498=$415;
      var $3499=$461;
      STACKTOP = __stackBase__;
      return $3499;
    case 418: // $3500
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 419; break; } else { __label__ = 427; break; }
    case 419: // $3501
      __label__ = 420; break;
    case 420: // $3502
      var $3503=$439;
      HEAP32[(($439)>>2)]=$__gb;
      var $3504=HEAP32[(($439)>>2)];
      var $3505=$438;
      HEAP32[(($438)>>2)]=$3504;
      var $3506=HEAP32[(($438)>>2)];
      var $3507=$434;
      var $3508=$435;
      var $3509=$__tmp_i_i_i;
      var $3510=$436;
      var $3511=$437;
      HEAP32[(($434)>>2)]=$3506;
      HEAP32[(($435)>>2)]=0;
      var $3512=HEAP32[(($434)>>2)];
      var $3513=(($3512)|0);
      var $3514=$433;
      HEAP32[(($433)>>2)]=$3513;
      var $3515=HEAP32[(($433)>>2)];
      var $3516=$3515;
      var $3517=$432;
      HEAP32[(($432)>>2)]=$3516;
      var $3518=HEAP32[(($432)>>2)];
      var $3519=(($3518)|0);
      var $3520=$432;
      var $3521=$433;
      var $3522=HEAP32[(($3519)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$3522;
      var $3523=HEAP32[(($435)>>2)];
      var $3524=(($3512)|0);
      var $3525=$431;
      HEAP32[(($431)>>2)]=$3524;
      var $3526=HEAP32[(($431)>>2)];
      var $3527=$3526;
      var $3528=$430;
      HEAP32[(($430)>>2)]=$3527;
      var $3529=HEAP32[(($430)>>2)];
      var $3530=(($3529)|0);
      var $3531=$430;
      var $3532=$431;
      HEAP32[(($3530)>>2)]=$3523;
      var $3533=HEAP32[(($__tmp_i_i_i)>>2)];
      var $3534=(($3533)|0)!=0;
      if ($3534) { __label__ = 421; break; } else { __label__ = 424; break; }
    case 421: // $3535
      var $3536=(($3512)|0);
      var $3537=$429;
      HEAP32[(($429)>>2)]=$3536;
      var $3538=HEAP32[(($429)>>2)];
      var $3539=$3538;
      var $3540=$428;
      HEAP32[(($428)>>2)]=$3539;
      var $3541=HEAP32[(($428)>>2)];
      var $3542=(($3541+4)|0);
      var $3543=$428;
      var $3544=$429;
      var $3545=HEAP32[(($3542)>>2)];
      var $3546=HEAP32[(($__tmp_i_i_i)>>2)];
      var $3547=$3546;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$3545]($3547) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 422; break; } else { __label__ = 423; break; }
    case 422: // $3548
      __label__ = 424; break;
    case 423: // $3549
      var $3550=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $3551=$3550.f0;
      HEAP32[(($436)>>2)]=$3551;
      var $3552=$3550.f1;
      HEAP32[(($437)>>2)]=$3552;
      var $3553=HEAP32[(($436)>>2)];
      ___cxa_call_unexpected($3553);
      throw "Reached an unreachable!"
    case 424: // $_ZNSt3__110unique_ptrIjPFvPvEED1Ev_exit
      var $3554=$434;
      var $3555=$435;
      var $3556=$__tmp_i_i_i;
      var $3557=$436;
      var $3558=$437;
      var $3559=$438;
      var $3560=$439;
      __label__ = 425; break;
    case 425: // $3561
      __label__ = 426; break;
    case 426: // $3562
      var $3563=$472;
      var $3564=$472;
      var $3565=$473;
      var $3566=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $3564, tempValue);
      var $3567=($3566.f1 = $3565, $3566);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 427: // $3568
      var $3569=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_["X"]=1;

function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE($agg_result, $this, $__b, $__e, $__intl, $__iob, $__err, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 764; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__b; $__b = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__b)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      var $10=__stackBase__+32;
      var $11;
      var $12=__stackBase__+36;
      var $13=__stackBase__+40;
      var $14=__stackBase__+44;
      var $15=__stackBase__+48;
      var $16=__stackBase__+52;
      var $17=__stackBase__+56;
      var $18=__stackBase__+60;
      var $19=__stackBase__+64;
      var $__tmp_i_i_i1=__stackBase__+68;
      var $20=__stackBase__+72;
      var $21=__stackBase__+76;
      var $22=__stackBase__+80;
      var $23=__stackBase__+84;
      var $24=__stackBase__+88;
      var $25=__stackBase__+92;
      var $26=__stackBase__+96;
      var $27=__stackBase__+100;
      var $28=__stackBase__+104;
      var $29=__stackBase__+108;
      var $30=__stackBase__+112;
      var $31=__stackBase__+116;
      var $32=__stackBase__+120;
      var $33=__stackBase__+124;
      var $34=__stackBase__+128;
      var $35=__stackBase__+132;
      var $36=__stackBase__+136;
      var $37=__stackBase__+140;
      var $38=__stackBase__+144;
      var $39=__stackBase__+148;
      var $40=__stackBase__+152;
      var $41=__stackBase__+156;
      var $42=__stackBase__+160;
      var $43=__stackBase__+164;
      var $44=__stackBase__+168;
      var $45=__stackBase__+172;
      var $46=__stackBase__+176;
      var $47=__stackBase__+180;
      var $48=__stackBase__+184;
      var $49=__stackBase__+188;
      var $50=__stackBase__+192;
      var $51=__stackBase__+196;
      var $52=__stackBase__+200;
      var $53=__stackBase__+204;
      var $54=__stackBase__+208;
      var $55=__stackBase__+212;
      var $56=__stackBase__+216;
      var $57=__stackBase__+220;
      var $58=__stackBase__+224;
      var $59=__stackBase__+228;
      var $60=__stackBase__+232;
      var $__tmp_i_i_i=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79=__stackBase__+312;
      var $80=__stackBase__+316;
      var $81=__stackBase__+320;
      var $82=__stackBase__+324;
      var $83=__stackBase__+328;
      var $84=__stackBase__+332;
      var $85=__stackBase__+336;
      var $86;
      var $87;
      var $88;
      var $89;
      var $90;
      var $__bz;
      var $__wbuf=__stackBase__+340;
      var $__wb=__stackBase__+740;
      var $__wn=__stackBase__+748;
      var $__we;
      var $__loc=__stackBase__+752;
      var $91;
      var $92;
      var $__ct;
      var $__neg=__stackBase__+756;
      var $93=__stackBase__+760;
      var $__z;
      var $__w;
      var $94;
      $86=$this;
      var $95=(($__intl)&1);
      $87=$95;
      $88=$__iob;
      $89=$__err;
      $90=$__v;
      var $96=$86;
      $__bz=100;
      var $97=(($__wbuf)|0);
      var $98=$83;
      var $99=$84;
      var $100=$85;
      HEAP32[(($83)>>2)]=$__wb;
      HEAP32[(($84)>>2)]=$97;
      HEAP32[(($85)>>2)]=1682;
      var $101=HEAP32[(($83)>>2)];
      var $102=HEAP32[(($84)>>2)];
      var $103=HEAP32[(($85)>>2)];
      var $104=$80;
      var $105=$81;
      var $106=$82;
      HEAP32[(($80)>>2)]=$101;
      HEAP32[(($81)>>2)]=$102;
      HEAP32[(($82)>>2)]=$103;
      var $107=HEAP32[(($80)>>2)];
      var $108=(($107)|0);
      var $109=$79;
      HEAP32[(($79)>>2)]=$81;
      var $110=HEAP32[(($79)>>2)];
      var $111=$79;
      var $112=HEAP32[(($110)>>2)];
      var $113=$65;
      HEAP32[(($65)>>2)]=$82;
      var $114=HEAP32[(($65)>>2)];
      var $115=$65;
      var $116=HEAP32[(($114)>>2)];
      var $117=$76;
      var $118=$77;
      var $119=$78;
      HEAP32[(($76)>>2)]=$108;
      HEAP32[(($77)>>2)]=$112;
      HEAP32[(($78)>>2)]=$116;
      var $120=HEAP32[(($76)>>2)];
      var $121=HEAP32[(($77)>>2)];
      var $122=HEAP32[(($78)>>2)];
      var $123=$73;
      var $124=$74;
      var $125=$75;
      HEAP32[(($73)>>2)]=$120;
      HEAP32[(($74)>>2)]=$121;
      HEAP32[(($75)>>2)]=$122;
      var $126=HEAP32[(($73)>>2)];
      var $127=$126;
      var $128=$72;
      HEAP32[(($72)>>2)]=$74;
      var $129=HEAP32[(($72)>>2)];
      var $130=$72;
      var $131=HEAP32[(($129)>>2)];
      var $132=$66;
      HEAP32[(($66)>>2)]=$75;
      var $133=HEAP32[(($66)>>2)];
      var $134=$66;
      var $135=HEAP32[(($133)>>2)];
      var $136=$69;
      var $137=$70;
      var $138=$71;
      HEAP32[(($69)>>2)]=$127;
      HEAP32[(($70)>>2)]=$131;
      HEAP32[(($71)>>2)]=$135;
      var $139=HEAP32[(($69)>>2)];
      var $140=(($139)|0);
      var $141=$68;
      HEAP32[(($68)>>2)]=$70;
      var $142=HEAP32[(($68)>>2)];
      var $143=$68;
      var $144=HEAP32[(($142)>>2)];
      HEAP32[(($140)>>2)]=$144;
      var $145=(($139+4)|0);
      var $146=$67;
      HEAP32[(($67)>>2)]=$71;
      var $147=HEAP32[(($67)>>2)];
      var $148=$67;
      var $149=HEAP32[(($147)>>2)];
      HEAP32[(($145)>>2)]=$149;
      var $150=$69;
      var $151=$70;
      var $152=$71;
      var $153=$73;
      var $154=$74;
      var $155=$75;
      var $156=$76;
      var $157=$77;
      var $158=$78;
      var $159=$80;
      var $160=$81;
      var $161=$82;
      var $162=$83;
      var $163=$84;
      var $164=$85;
      var $165=(($__wbuf)|0);
      var $166=(($165+400)|0);
      $__we=$166;
      var $167=$88;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($__loc, $167) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $168
      var $169=$52;
      HEAP32[(($52)>>2)]=$__loc;
      var $170=HEAP32[(($52)>>2)];
      var $171=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($170, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 15; break; };
    case 2: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $172=$171;
      var $173=$52;
      __label__ = 3; break;
    case 3: // $174
      $__ct=$172;
      HEAP8[($__neg)]=0;
      var $175=$93;
      var $176=$__e;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($175)>>2)]=HEAP32[(($176)>>2)];
      var $177=$87;
      var $178=(($177) & 1);
      var $179=$88;
      var $180=$51;
      HEAP32[(($51)>>2)]=$179;
      var $181=HEAP32[(($51)>>2)];
      var $182=(($181+4)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$51;
      __label__ = 4; break;
    case 4: // $185
      var $186=$89;
      var $187=$__ct;
      var $188=$__we;
      var $189=(function() { try { __THREW__ = false; return __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_($__b, $93, $178, $__loc, $183, $186, $__neg, $187, $__wb, $__wn, $188) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 15; break; };
    case 5: // $190
      if ($189) { __label__ = 6; break; } else { __label__ = 26; break; }
    case 6: // $191
      var $192=$90;
      var $193=$46;
      var $194=$47;
      var $195=$48;
      var $196=$49;
      var $197=$50;
      HEAP32[(($46)>>2)]=$192;
      var $198=HEAPU32[(($46)>>2)];
      var $199=$45;
      HEAP32[(($45)>>2)]=$198;
      var $200=HEAP32[(($45)>>2)];
      var $201=$45;
      var $202=$26;
      HEAP32[(($26)>>2)]=$198;
      var $203=HEAP32[(($26)>>2)];
      var $204=(($203)|0);
      var $205=$25;
      HEAP32[(($25)>>2)]=$204;
      var $206=HEAP32[(($25)>>2)];
      var $207=$206;
      var $208=$24;
      HEAP32[(($24)>>2)]=$207;
      var $209=HEAP32[(($24)>>2)];
      var $210=(($209)|0);
      var $211=$24;
      var $212=$25;
      var $213=(($210)|0);
      var $214=$213;
      var $215=(($214)|0);
      var $216=$215;
      var $217=HEAPU8[($216)];
      var $218=(($217)&255);
      var $219=$218 & 1;
      var $220=(($219)|0)!=0;
      var $221=$26;
      if ($220) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $222
      var $223=$29;
      HEAP32[(($29)>>2)]=$198;
      var $224=HEAP32[(($29)>>2)];
      var $225=(($224)|0);
      var $226=$28;
      HEAP32[(($28)>>2)]=$225;
      var $227=HEAP32[(($28)>>2)];
      var $228=$227;
      var $229=$27;
      HEAP32[(($27)>>2)]=$228;
      var $230=HEAP32[(($27)>>2)];
      var $231=(($230)|0);
      var $232=$27;
      var $233=$28;
      var $234=(($231)|0);
      var $235=$234;
      var $236=(($235+8)|0);
      var $237=HEAP32[(($236)>>2)];
      var $238=$29;
      HEAP32[(($49)>>2)]=0;
      var $239=$30;
      var $240=$31;
      HEAP32[(($30)>>2)]=$237;
      HEAP32[(($31)>>2)]=$49;
      var $241=HEAP32[(($31)>>2)];
      var $242=HEAP32[(($241)>>2)];
      var $243=HEAP32[(($30)>>2)];
      HEAP32[(($243)>>2)]=$242;
      var $244=$30;
      var $245=$31;
      var $246=$34;
      var $247=$35;
      HEAP32[(($34)>>2)]=$198;
      HEAP32[(($35)>>2)]=0;
      var $248=HEAP32[(($34)>>2)];
      var $249=HEAP32[(($35)>>2)];
      var $250=(($248)|0);
      var $251=$33;
      HEAP32[(($33)>>2)]=$250;
      var $252=HEAP32[(($33)>>2)];
      var $253=$252;
      var $254=$32;
      HEAP32[(($32)>>2)]=$253;
      var $255=HEAP32[(($32)>>2)];
      var $256=(($255)|0);
      var $257=$32;
      var $258=$33;
      var $259=(($256)|0);
      var $260=$259;
      var $261=(($260+4)|0);
      HEAP32[(($261)>>2)]=$249;
      var $262=$34;
      var $263=$35;
      __label__ = 9; break;
    case 8: // $264
      var $265=$38;
      HEAP32[(($38)>>2)]=$198;
      var $266=HEAP32[(($38)>>2)];
      var $267=(($266)|0);
      var $268=$37;
      HEAP32[(($37)>>2)]=$267;
      var $269=HEAP32[(($37)>>2)];
      var $270=$269;
      var $271=$36;
      HEAP32[(($36)>>2)]=$270;
      var $272=HEAP32[(($36)>>2)];
      var $273=(($272)|0);
      var $274=$36;
      var $275=$37;
      var $276=(($273)|0);
      var $277=$276;
      var $278=(($277+4)|0);
      var $279=(($278)|0);
      var $280=$38;
      HEAP32[(($50)>>2)]=0;
      var $281=$39;
      var $282=$40;
      HEAP32[(($39)>>2)]=$279;
      HEAP32[(($40)>>2)]=$50;
      var $283=HEAP32[(($40)>>2)];
      var $284=HEAP32[(($283)>>2)];
      var $285=HEAP32[(($39)>>2)];
      HEAP32[(($285)>>2)]=$284;
      var $286=$39;
      var $287=$40;
      var $288=$43;
      var $289=$44;
      HEAP32[(($43)>>2)]=$198;
      HEAP32[(($44)>>2)]=0;
      var $290=HEAP32[(($43)>>2)];
      var $291=HEAP32[(($44)>>2)];
      var $292=$291 << 1;
      var $293=(($292) & 255);
      var $294=(($290)|0);
      var $295=$42;
      HEAP32[(($42)>>2)]=$294;
      var $296=HEAP32[(($42)>>2)];
      var $297=$296;
      var $298=$41;
      HEAP32[(($41)>>2)]=$297;
      var $299=HEAP32[(($41)>>2)];
      var $300=(($299)|0);
      var $301=$41;
      var $302=$42;
      var $303=(($300)|0);
      var $304=$303;
      var $305=(($304)|0);
      var $306=$305;
      HEAP8[($306)]=$293;
      var $307=$43;
      var $308=$44;
      __label__ = 9; break;
    case 9: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5clearEv_exit
      var $309=$46;
      var $310=$47;
      var $311=$48;
      var $312=$49;
      var $313=$50;
      var $314=HEAP8[($__neg)];
      var $315=(($314) & 1);
      if ($315) { __label__ = 10; break; } else { __label__ = 16; break; }
    case 10: // $316
      var $317=$90;
      var $318=$__ct;
      var $319=$10;
      HEAP32[(($10)>>2)]=$318;
      $11=45;
      var $320=HEAP32[(($10)>>2)];
      var $321=$320;
      var $322=HEAP32[(($321)>>2)];
      var $323=(($322+44)|0);
      var $324=HEAP32[(($323)>>2)];
      var $325=$11;
      var $326=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$324]($320, $325) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $_ZNKSt3__15ctypeIwE5widenEc_exit
      var $327=$10;
      __label__ = 12; break;
    case 12: // $328
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($317, $326) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $329
      __label__ = 16; break;
    case 14: // $330
      var $331=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $332=$331.f0;
      $91=$332;
      var $333=$331.f1;
      $92=$333;
      __label__ = 36; break;
    case 15: // $334
      var $335=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $336=$335.f0;
      $91=$336;
      var $337=$335.f1;
      $92=$337;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 43; break; }
    case 16: // $338
      var $339=$__ct;
      var $340=$8;
      HEAP32[(($8)>>2)]=$339;
      $9=48;
      var $341=HEAP32[(($8)>>2)];
      var $342=$341;
      var $343=HEAP32[(($342)>>2)];
      var $344=(($343+44)|0);
      var $345=HEAP32[(($344)>>2)];
      var $346=$9;
      var $347=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$345]($341, $346) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 15; break; };
    case 17: // $_ZNKSt3__15ctypeIwE5widenEc_exit3
      var $348=$8;
      __label__ = 18; break;
    case 18: // $349
      $__z=$347;
      var $350=$7;
      HEAP32[(($7)>>2)]=$__wb;
      var $351=HEAP32[(($7)>>2)];
      var $352=(($351)|0);
      var $353=$6;
      HEAP32[(($6)>>2)]=$352;
      var $354=HEAP32[(($6)>>2)];
      var $355=$354;
      var $356=$5;
      HEAP32[(($5)>>2)]=$355;
      var $357=HEAP32[(($5)>>2)];
      var $358=(($357)|0);
      var $359=$5;
      var $360=$6;
      var $361=HEAP32[(($358)>>2)];
      var $362=$7;
      $__w=$361;
      __label__ = 19; break;
    case 19: // $363
      var $364=$__w;
      var $365=HEAP32[(($__wn)>>2)];
      var $366=(($365-4)|0);
      var $367=(($364)>>>0) < (($366)>>>0);
      if ($367) { __label__ = 20; break; } else { __label__ = 24; break; }
    case 20: // $368
      var $369=$__w;
      var $370=HEAP32[(($369)>>2)];
      var $371=$__z;
      var $372=(($370)|0)!=(($371)|0);
      if ($372) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $373
      __label__ = 24; break;
    case 22: // $374
      __label__ = 23; break;
    case 23: // $375
      var $376=$__w;
      var $377=(($376+4)|0);
      $__w=$377;
      __label__ = 19; break;
    case 24: // $378
      var $379=$90;
      var $380=$__w;
      var $381=HEAP32[(($__wn)>>2)];
      var $382=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($379, $380, $381) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 15; break; };
    case 25: // $383
      __label__ = 26; break;
    case 26: // $384
      var $385=$3;
      var $386=$4;
      HEAP32[(($3)>>2)]=$__b;
      HEAP32[(($4)>>2)]=$__e;
      var $387=HEAP32[(($3)>>2)];
      var $388=HEAP32[(($4)>>2)];
      var $389=$1;
      var $390=$2;
      HEAP32[(($1)>>2)]=$387;
      HEAP32[(($2)>>2)]=$388;
      var $391=HEAP32[(($1)>>2)];
      var $392=(($391)|0);
      var $393=HEAP32[(($392)>>2)];
      var $394=(($393)|0)==0;
      var $395=(($394)&1);
      var $396=HEAP32[(($2)>>2)];
      var $397=(($396)|0);
      var $398=HEAP32[(($397)>>2)];
      var $399=(($398)|0)==0;
      var $400=(($399)&1);
      var $401=(($395)|0)==(($400)|0);
      var $402=$1;
      var $403=$2;
      var $404=$3;
      var $405=$4;
      __label__ = 27; break;
    case 27: // $406
      if ($401) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $407
      var $408=$89;
      var $409=HEAP32[(($408)>>2)];
      var $410=$409 | 2;
      HEAP32[(($408)>>2)]=$410;
      __label__ = 29; break;
    case 29: // $411
      var $412=$agg_result;
      var $413=$__b;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($412)>>2)]=HEAP32[(($413)>>2)];
      $94=1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 14; break; }
    case 30: // $414
      var $415=$23;
      HEAP32[(($23)>>2)]=$__wb;
      var $416=HEAP32[(($23)>>2)];
      var $417=$22;
      HEAP32[(($22)>>2)]=$416;
      var $418=HEAP32[(($22)>>2)];
      var $419=$18;
      var $420=$19;
      var $421=$__tmp_i_i_i1;
      var $422=$20;
      var $423=$21;
      HEAP32[(($18)>>2)]=$418;
      HEAP32[(($19)>>2)]=0;
      var $424=HEAP32[(($18)>>2)];
      var $425=(($424)|0);
      var $426=$17;
      HEAP32[(($17)>>2)]=$425;
      var $427=HEAP32[(($17)>>2)];
      var $428=$427;
      var $429=$16;
      HEAP32[(($16)>>2)]=$428;
      var $430=HEAP32[(($16)>>2)];
      var $431=(($430)|0);
      var $432=$16;
      var $433=$17;
      var $434=HEAP32[(($431)>>2)];
      HEAP32[(($__tmp_i_i_i1)>>2)]=$434;
      var $435=HEAP32[(($19)>>2)];
      var $436=(($424)|0);
      var $437=$15;
      HEAP32[(($15)>>2)]=$436;
      var $438=HEAP32[(($15)>>2)];
      var $439=$438;
      var $440=$14;
      HEAP32[(($14)>>2)]=$439;
      var $441=HEAP32[(($14)>>2)];
      var $442=(($441)|0);
      var $443=$14;
      var $444=$15;
      HEAP32[(($442)>>2)]=$435;
      var $445=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $446=(($445)|0)!=0;
      if ($446) { __label__ = 31; break; } else { __label__ = 34; break; }
    case 31: // $447
      var $448=(($424)|0);
      var $449=$13;
      HEAP32[(($13)>>2)]=$448;
      var $450=HEAP32[(($13)>>2)];
      var $451=$450;
      var $452=$12;
      HEAP32[(($12)>>2)]=$451;
      var $453=HEAP32[(($12)>>2)];
      var $454=(($453+4)|0);
      var $455=$12;
      var $456=$13;
      var $457=HEAP32[(($454)>>2)];
      var $458=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $459=$458;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$457]($459) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $460
      __label__ = 34; break;
    case 33: // $461
      var $462=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $463=$462.f0;
      HEAP32[(($20)>>2)]=$463;
      var $464=$462.f1;
      HEAP32[(($21)>>2)]=$464;
      var $465=HEAP32[(($20)>>2)];
      ___cxa_call_unexpected($465);
      throw "Reached an unreachable!"
    case 34: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit2
      var $466=$18;
      var $467=$19;
      var $468=$__tmp_i_i_i1;
      var $469=$20;
      var $470=$21;
      var $471=$22;
      var $472=$23;
      STACKTOP = __stackBase__;
      return;
    case 35: // $473
      __label__ = 36; break;
    case 36: // $474
      var $475=$64;
      HEAP32[(($64)>>2)]=$__wb;
      var $476=HEAP32[(($64)>>2)];
      var $477=$63;
      HEAP32[(($63)>>2)]=$476;
      var $478=HEAP32[(($63)>>2)];
      var $479=$59;
      var $480=$60;
      var $481=$__tmp_i_i_i;
      var $482=$61;
      var $483=$62;
      HEAP32[(($59)>>2)]=$478;
      HEAP32[(($60)>>2)]=0;
      var $484=HEAP32[(($59)>>2)];
      var $485=(($484)|0);
      var $486=$58;
      HEAP32[(($58)>>2)]=$485;
      var $487=HEAP32[(($58)>>2)];
      var $488=$487;
      var $489=$57;
      HEAP32[(($57)>>2)]=$488;
      var $490=HEAP32[(($57)>>2)];
      var $491=(($490)|0);
      var $492=$57;
      var $493=$58;
      var $494=HEAP32[(($491)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$494;
      var $495=HEAP32[(($60)>>2)];
      var $496=(($484)|0);
      var $497=$56;
      HEAP32[(($56)>>2)]=$496;
      var $498=HEAP32[(($56)>>2)];
      var $499=$498;
      var $500=$55;
      HEAP32[(($55)>>2)]=$499;
      var $501=HEAP32[(($55)>>2)];
      var $502=(($501)|0);
      var $503=$55;
      var $504=$56;
      HEAP32[(($502)>>2)]=$495;
      var $505=HEAP32[(($__tmp_i_i_i)>>2)];
      var $506=(($505)|0)!=0;
      if ($506) { __label__ = 37; break; } else { __label__ = 40; break; }
    case 37: // $507
      var $508=(($484)|0);
      var $509=$54;
      HEAP32[(($54)>>2)]=$508;
      var $510=HEAP32[(($54)>>2)];
      var $511=$510;
      var $512=$53;
      HEAP32[(($53)>>2)]=$511;
      var $513=HEAP32[(($53)>>2)];
      var $514=(($513+4)|0);
      var $515=$53;
      var $516=$54;
      var $517=HEAP32[(($514)>>2)];
      var $518=HEAP32[(($__tmp_i_i_i)>>2)];
      var $519=$518;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$517]($519) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $520
      __label__ = 40; break;
    case 39: // $521
      var $522=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $523=$522.f0;
      HEAP32[(($61)>>2)]=$523;
      var $524=$522.f1;
      HEAP32[(($62)>>2)]=$524;
      var $525=HEAP32[(($61)>>2)];
      ___cxa_call_unexpected($525);
      throw "Reached an unreachable!"
    case 40: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $526=$59;
      var $527=$60;
      var $528=$__tmp_i_i_i;
      var $529=$61;
      var $530=$62;
      var $531=$63;
      var $532=$64;
      __label__ = 41; break;
    case 41: // $533
      __label__ = 42; break;
    case 42: // $534
      var $535=$91;
      var $536=$91;
      var $537=$92;
      var $538=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $536, tempValue);
      var $539=($538.f1 = $537, $538);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 43: // $540
      var $541=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_($this, $__first, $__last) {
  var __stackBase__  = STACKTOP; STACKTOP += 204; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51;
      var $52;
      var $53;
      var $__sz;
      var $__cap;
      var $__n;
      var $__p;
      var $54=__stackBase__+200;
      $51=$this;
      $52=$__first;
      $53=$__last;
      var $55=$51;
      var $56=$50;
      HEAP32[(($50)>>2)]=$55;
      var $57=HEAPU32[(($50)>>2)];
      var $58=$49;
      HEAP32[(($49)>>2)]=$57;
      var $59=HEAP32[(($49)>>2)];
      var $60=(($59)|0);
      var $61=$48;
      HEAP32[(($48)>>2)]=$60;
      var $62=HEAP32[(($48)>>2)];
      var $63=$62;
      var $64=$47;
      HEAP32[(($47)>>2)]=$63;
      var $65=HEAP32[(($47)>>2)];
      var $66=(($65)|0);
      var $67=$47;
      var $68=$48;
      var $69=(($66)|0);
      var $70=$69;
      var $71=(($70)|0);
      var $72=$71;
      var $73=HEAPU8[($72)];
      var $74=(($73)&255);
      var $75=$74 & 1;
      var $76=(($75)|0)!=0;
      var $77=$49;
      if ($76) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $78
      var $79=$43;
      HEAP32[(($43)>>2)]=$57;
      var $80=HEAP32[(($43)>>2)];
      var $81=(($80)|0);
      var $82=$42;
      HEAP32[(($42)>>2)]=$81;
      var $83=HEAP32[(($42)>>2)];
      var $84=$83;
      var $85=$41;
      HEAP32[(($41)>>2)]=$84;
      var $86=HEAP32[(($41)>>2)];
      var $87=(($86)|0);
      var $88=$41;
      var $89=$42;
      var $90=(($87)|0);
      var $91=$90;
      var $92=(($91+4)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$43;
      var $115 = $93;__label__ = 3; break;
    case 2: // $95
      var $96=$46;
      HEAP32[(($46)>>2)]=$57;
      var $97=HEAP32[(($46)>>2)];
      var $98=(($97)|0);
      var $99=$45;
      HEAP32[(($45)>>2)]=$98;
      var $100=HEAP32[(($45)>>2)];
      var $101=$100;
      var $102=$44;
      HEAP32[(($44)>>2)]=$101;
      var $103=HEAP32[(($44)>>2)];
      var $104=(($103)|0);
      var $105=$44;
      var $106=$45;
      var $107=(($104)|0);
      var $108=$107;
      var $109=(($108)|0);
      var $110=$109;
      var $111=HEAPU8[($110)];
      var $112=(($111)&255);
      var $113=$112 >> 1;
      var $114=$46;
      var $115 = $113;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $115;
      var $116=$50;
      $__sz=$115;
      var $117=$7;
      HEAP32[(($7)>>2)]=$55;
      var $118=HEAPU32[(($7)>>2)];
      var $119=$6;
      HEAP32[(($6)>>2)]=$118;
      var $120=HEAP32[(($6)>>2)];
      var $121=(($120)|0);
      var $122=$5;
      HEAP32[(($5)>>2)]=$121;
      var $123=HEAP32[(($5)>>2)];
      var $124=$123;
      var $125=$4;
      HEAP32[(($4)>>2)]=$124;
      var $126=HEAP32[(($4)>>2)];
      var $127=(($126)|0);
      var $128=$4;
      var $129=$5;
      var $130=(($127)|0);
      var $131=$130;
      var $132=(($131)|0);
      var $133=$132;
      var $134=HEAPU8[($133)];
      var $135=(($134)&255);
      var $136=$135 & 1;
      var $137=(($136)|0)!=0;
      var $138=$6;
      if ($137) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $139
      var $140=$3;
      HEAP32[(($3)>>2)]=$118;
      var $141=HEAP32[(($3)>>2)];
      var $142=(($141)|0);
      var $143=$2;
      HEAP32[(($2)>>2)]=$142;
      var $144=HEAP32[(($2)>>2)];
      var $145=$144;
      var $146=$1;
      HEAP32[(($1)>>2)]=$145;
      var $147=HEAP32[(($1)>>2)];
      var $148=(($147)|0);
      var $149=$1;
      var $150=$2;
      var $151=(($148)|0);
      var $152=$151;
      var $153=(($152)|0);
      var $154=HEAP32[(($153)>>2)];
      var $155=$154 & -2;
      var $156=$3;
      var $158 = $155;__label__ = 6; break;
    case 5: // $157
      var $158 = 2;__label__ = 6; break;
    case 6: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8capacityEv_exit
      var $158;
      var $159=(($158-1)|0);
      var $160=$7;
      $__cap=$159;
      var $161=$52;
      var $162=$53;
      var $163=$10;
      var $164=$11;
      var $165=$12;
      var $166=$13;
      HEAP32[(($11)>>2)]=$161;
      HEAP32[(($12)>>2)]=$162;
      var $167=HEAP32[(($11)>>2)];
      var $168=HEAP32[(($12)>>2)];
      var $tmp_i=$10;
      var $tmp1_i=$13;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $169=$8;
      var $170=$9;
      HEAP32[(($8)>>2)]=$167;
      HEAP32[(($9)>>2)]=$168;
      var $171=HEAP32[(($9)>>2)];
      var $172=HEAP32[(($8)>>2)];
      var $173=$171;
      var $174=$172;
      var $175=(($173-$174)|0);
      var $176=(((($175)|0)/4)|0);
      var $177=$8;
      var $178=$9;
      var $179=$10;
      var $180=$11;
      var $181=$12;
      var $182=$13;
      $__n=$176;
      var $183=$__n;
      var $184=(($183)|0)!=0;
      if ($184) { __label__ = 7; break; } else { __label__ = 20; break; }
    case 7: // $185
      var $186=$__cap;
      var $187=$__sz;
      var $188=(($186-$187)|0);
      var $189=$__n;
      var $190=(($188)>>>0) < (($189)>>>0);
      if ($190) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $191
      var $192=$__cap;
      var $193=$__sz;
      var $194=$__n;
      var $195=(($193+$194)|0);
      var $196=$__cap;
      var $197=(($195-$196)|0);
      var $198=$__sz;
      var $199=$__sz;
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj($55, $192, $197, $198, $199, 0, 0);
      __label__ = 9; break;
    case 9: // $200
      var $201=$23;
      HEAP32[(($23)>>2)]=$55;
      var $202=HEAPU32[(($23)>>2)];
      var $203=$22;
      HEAP32[(($22)>>2)]=$202;
      var $204=HEAP32[(($22)>>2)];
      var $205=(($204)|0);
      var $206=$21;
      HEAP32[(($21)>>2)]=$205;
      var $207=HEAP32[(($21)>>2)];
      var $208=$207;
      var $209=$20;
      HEAP32[(($20)>>2)]=$208;
      var $210=HEAP32[(($20)>>2)];
      var $211=(($210)|0);
      var $212=$20;
      var $213=$21;
      var $214=(($211)|0);
      var $215=$214;
      var $216=(($215)|0);
      var $217=$216;
      var $218=HEAPU8[($217)];
      var $219=(($218)&255);
      var $220=$219 & 1;
      var $221=(($220)|0)!=0;
      var $222=$22;
      if ($221) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $223
      var $224=$16;
      HEAP32[(($16)>>2)]=$202;
      var $225=HEAP32[(($16)>>2)];
      var $226=(($225)|0);
      var $227=$15;
      HEAP32[(($15)>>2)]=$226;
      var $228=HEAP32[(($15)>>2)];
      var $229=$228;
      var $230=$14;
      HEAP32[(($14)>>2)]=$229;
      var $231=HEAP32[(($14)>>2)];
      var $232=(($231)|0);
      var $233=$14;
      var $234=$15;
      var $235=(($232)|0);
      var $236=$235;
      var $237=(($236+8)|0);
      var $238=HEAP32[(($237)>>2)];
      var $239=$16;
      var $257 = $238;__label__ = 12; break;
    case 11: // $240
      var $241=$19;
      HEAP32[(($19)>>2)]=$202;
      var $242=HEAP32[(($19)>>2)];
      var $243=(($242)|0);
      var $244=$18;
      HEAP32[(($18)>>2)]=$243;
      var $245=HEAP32[(($18)>>2)];
      var $246=$245;
      var $247=$17;
      HEAP32[(($17)>>2)]=$246;
      var $248=HEAP32[(($17)>>2)];
      var $249=(($248)|0);
      var $250=$17;
      var $251=$18;
      var $252=(($249)|0);
      var $253=$252;
      var $254=(($253+4)|0);
      var $255=(($254)|0);
      var $256=$19;
      var $257 = $255;__label__ = 12; break;
    case 12: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv_exit
      var $257;
      var $258=$23;
      var $259=$__sz;
      var $260=(($257+($259<<2))|0);
      $__p=$260;
      __label__ = 13; break;
    case 13: // $261
      var $262=$52;
      var $263=$53;
      var $264=(($262)|0)!=(($263)|0);
      if ($264) { __label__ = 14; break; } else { __label__ = 16; break; }
    case 14: // $265
      var $266=$__p;
      var $267=$52;
      var $268=$24;
      var $269=$25;
      HEAP32[(($24)>>2)]=$266;
      HEAP32[(($25)>>2)]=$267;
      var $270=HEAP32[(($25)>>2)];
      var $271=HEAP32[(($270)>>2)];
      var $272=HEAP32[(($24)>>2)];
      HEAP32[(($272)>>2)]=$271;
      var $273=$24;
      var $274=$25;
      __label__ = 15; break;
    case 15: // $275
      var $276=$__p;
      var $277=(($276+4)|0);
      $__p=$277;
      var $278=$52;
      var $279=(($278+4)|0);
      $52=$279;
      __label__ = 13; break;
    case 16: // $280
      var $281=$__p;
      HEAP32[(($54)>>2)]=0;
      var $282=$26;
      var $283=$27;
      HEAP32[(($26)>>2)]=$281;
      HEAP32[(($27)>>2)]=$54;
      var $284=HEAP32[(($27)>>2)];
      var $285=HEAP32[(($284)>>2)];
      var $286=HEAP32[(($26)>>2)];
      HEAP32[(($286)>>2)]=$285;
      var $287=$26;
      var $288=$27;
      var $289=$__sz;
      var $290=$__n;
      var $291=(($289+$290)|0);
      var $292=$39;
      var $293=$40;
      HEAP32[(($39)>>2)]=$55;
      HEAP32[(($40)>>2)]=$291;
      var $294=HEAPU32[(($39)>>2)];
      var $295=$38;
      HEAP32[(($38)>>2)]=$294;
      var $296=HEAP32[(($38)>>2)];
      var $297=(($296)|0);
      var $298=$37;
      HEAP32[(($37)>>2)]=$297;
      var $299=HEAP32[(($37)>>2)];
      var $300=$299;
      var $301=$36;
      HEAP32[(($36)>>2)]=$300;
      var $302=HEAP32[(($36)>>2)];
      var $303=(($302)|0);
      var $304=$36;
      var $305=$37;
      var $306=(($303)|0);
      var $307=$306;
      var $308=(($307)|0);
      var $309=$308;
      var $310=HEAPU8[($309)];
      var $311=(($310)&255);
      var $312=$311 & 1;
      var $313=(($312)|0)!=0;
      var $314=$38;
      if ($313) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $315
      var $316=HEAP32[(($40)>>2)];
      var $317=$30;
      var $318=$31;
      HEAP32[(($30)>>2)]=$294;
      HEAP32[(($31)>>2)]=$316;
      var $319=HEAP32[(($30)>>2)];
      var $320=HEAP32[(($31)>>2)];
      var $321=(($319)|0);
      var $322=$29;
      HEAP32[(($29)>>2)]=$321;
      var $323=HEAP32[(($29)>>2)];
      var $324=$323;
      var $325=$28;
      HEAP32[(($28)>>2)]=$324;
      var $326=HEAP32[(($28)>>2)];
      var $327=(($326)|0);
      var $328=$28;
      var $329=$29;
      var $330=(($327)|0);
      var $331=$330;
      var $332=(($331+4)|0);
      HEAP32[(($332)>>2)]=$320;
      var $333=$30;
      var $334=$31;
      __label__ = 19; break;
    case 18: // $335
      var $336=HEAP32[(($40)>>2)];
      var $337=$34;
      var $338=$35;
      HEAP32[(($34)>>2)]=$294;
      HEAP32[(($35)>>2)]=$336;
      var $339=HEAP32[(($34)>>2)];
      var $340=HEAP32[(($35)>>2)];
      var $341=$340 << 1;
      var $342=(($341) & 255);
      var $343=(($339)|0);
      var $344=$33;
      HEAP32[(($33)>>2)]=$343;
      var $345=HEAP32[(($33)>>2)];
      var $346=$345;
      var $347=$32;
      HEAP32[(($32)>>2)]=$346;
      var $348=HEAP32[(($32)>>2)];
      var $349=(($348)|0);
      var $350=$32;
      var $351=$33;
      var $352=(($349)|0);
      var $353=$352;
      var $354=(($353)|0);
      var $355=$354;
      HEAP8[($355)]=$342;
      var $356=$34;
      var $357=$35;
      __label__ = 19; break;
    case 19: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE10__set_sizeEj_exit
      var $358=$39;
      var $359=$40;
      __label__ = 20; break;
    case 20: // $360
      STACKTOP = __stackBase__;
      return $55;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_["X"]=1;

function __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri($__intl, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__psn, $__nsn, $__fd) {
  var __stackBase__  = STACKTOP; STACKTOP += 176; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19;
      var $20;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $26;
      var $27;
      var $28;
      var $__mp;
      var $29=__stackBase__+72;
      var $30=__stackBase__+76;
      var $31;
      var $32;
      var $33=__stackBase__+88;
      var $34=__stackBase__+100;
      var $35=__stackBase__+112;
      var $__mp1;
      var $36=__stackBase__+124;
      var $37=__stackBase__+128;
      var $38=__stackBase__+140;
      var $39=__stackBase__+152;
      var $40=__stackBase__+164;
      var $41=(($__intl)&1);
      $19=$41;
      $20=$__loc;
      $21=$__pat;
      $22=$__dp;
      $23=$__ts;
      $24=$__grp;
      $25=$__sym;
      $26=$__psn;
      $27=$__nsn;
      $28=$__fd;
      var $42=$19;
      var $43=(($42) & 1);
      if ($43) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $44
      var $45=$20;
      var $46=$18;
      HEAP32[(($18)>>2)]=$45;
      var $47=HEAP32[(($18)>>2)];
      var $48=__ZNKSt3__16locale9use_facetERNS0_2idE($47, __ZNSt3__110moneypunctIwLb1EE2idE);
      var $49=$48;
      var $50=$18;
      $__mp=$49;
      var $51=$21;
      var $52=$__mp;
      var $53=$17;
      HEAP32[(($17)>>2)]=$52;
      var $54=HEAP32[(($17)>>2)];
      var $55=$54;
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+44)|0);
      var $58=HEAP32[(($57)>>2)];
      FUNCTION_TABLE[$58]($29, $54);
      var $59=$17;
      var $60=$51;
      var $61=$29;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($60)]=HEAP8[($61)];HEAP8[($60+1)]=HEAP8[($61+1)];HEAP8[($60+2)]=HEAP8[($61+2)];HEAP8[($60+3)]=HEAP8[($61+3)];
      var $62=$27;
      var $63=$__mp;
      var $64=$16;
      HEAP32[(($16)>>2)]=$63;
      var $65=HEAP32[(($16)>>2)];
      var $66=$65;
      var $67=HEAP32[(($66)>>2)];
      var $68=(($67+32)|0);
      var $69=HEAP32[(($68)>>2)];
      FUNCTION_TABLE[$69]($30, $65);
      var $70=$16;
      var $71=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($62, $30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $72
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($30);
      var $73=$26;
      var $74=$__mp;
      var $75=$15;
      HEAP32[(($15)>>2)]=$74;
      var $76=HEAP32[(($15)>>2)];
      var $77=$76;
      var $78=HEAP32[(($77)>>2)];
      var $79=(($78+28)|0);
      var $80=HEAP32[(($79)>>2)];
      FUNCTION_TABLE[$80]($33, $76);
      var $81=$15;
      var $82=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($73, $33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 8; break; };
    case 3: // $83
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($33);
      var $84=$__mp;
      var $85=$14;
      HEAP32[(($14)>>2)]=$84;
      var $86=HEAP32[(($14)>>2)];
      var $87=$86;
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88+12)|0);
      var $90=HEAP32[(($89)>>2)];
      var $91=FUNCTION_TABLE[$90]($86);
      var $92=$14;
      var $93=$22;
      HEAP32[(($93)>>2)]=$91;
      var $94=$__mp;
      var $95=$13;
      HEAP32[(($13)>>2)]=$94;
      var $96=HEAP32[(($13)>>2)];
      var $97=$96;
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+16)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=FUNCTION_TABLE[$100]($96);
      var $102=$13;
      var $103=$23;
      HEAP32[(($103)>>2)]=$101;
      var $104=$24;
      var $105=$__mp;
      var $106=$12;
      HEAP32[(($12)>>2)]=$105;
      var $107=HEAP32[(($12)>>2)];
      var $108=$107;
      var $109=HEAP32[(($108)>>2)];
      var $110=(($109+20)|0);
      var $111=HEAP32[(($110)>>2)];
      FUNCTION_TABLE[$111]($34, $107);
      var $112=$12;
      var $113=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($104, $34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 10; break; };
    case 4: // $114
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($34);
      var $115=$25;
      var $116=$__mp;
      var $117=$11;
      HEAP32[(($11)>>2)]=$116;
      var $118=HEAP32[(($11)>>2)];
      var $119=$118;
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+24)|0);
      var $122=HEAP32[(($121)>>2)];
      FUNCTION_TABLE[$122]($35, $118);
      var $123=$11;
      var $124=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($115, $35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 12; break; };
    case 5: // $125
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($35);
      var $126=$__mp;
      var $127=$10;
      HEAP32[(($10)>>2)]=$126;
      var $128=HEAP32[(($10)>>2)];
      var $129=$128;
      var $130=HEAP32[(($129)>>2)];
      var $131=(($130+36)|0);
      var $132=HEAP32[(($131)>>2)];
      var $133=FUNCTION_TABLE[$132]($128);
      var $134=$10;
      var $135=$28;
      HEAP32[(($135)>>2)]=$133;
      __label__ = 27; break;
    case 6: // $136
      var $137=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $138=$137.f0;
      $31=$138;
      var $139=$137.f1;
      $32=$139;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($30) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 29; break; }
    case 7: // $140
      __label__ = 28; break;
    case 8: // $141
      var $142=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $143=$142.f0;
      $31=$143;
      var $144=$142.f1;
      $32=$144;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($33) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 29; break; }
    case 9: // $145
      __label__ = 28; break;
    case 10: // $146
      var $147=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $148=$147.f0;
      $31=$148;
      var $149=$147.f1;
      $32=$149;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($34) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 29; break; }
    case 11: // $150
      __label__ = 28; break;
    case 12: // $151
      var $152=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $153=$152.f0;
      $31=$153;
      var $154=$152.f1;
      $32=$154;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($35) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 29; break; }
    case 13: // $155
      __label__ = 28; break;
    case 14: // $156
      var $157=$20;
      var $158=$9;
      HEAP32[(($9)>>2)]=$157;
      var $159=HEAP32[(($9)>>2)];
      var $160=__ZNKSt3__16locale9use_facetERNS0_2idE($159, __ZNSt3__110moneypunctIwLb0EE2idE);
      var $161=$160;
      var $162=$9;
      $__mp1=$161;
      var $163=$21;
      var $164=$__mp1;
      var $165=$8;
      HEAP32[(($8)>>2)]=$164;
      var $166=HEAP32[(($8)>>2)];
      var $167=$166;
      var $168=HEAP32[(($167)>>2)];
      var $169=(($168+44)|0);
      var $170=HEAP32[(($169)>>2)];
      FUNCTION_TABLE[$170]($36, $166);
      var $171=$8;
      var $172=$163;
      var $173=$36;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($172)]=HEAP8[($173)];HEAP8[($172+1)]=HEAP8[($173+1)];HEAP8[($172+2)]=HEAP8[($173+2)];HEAP8[($172+3)]=HEAP8[($173+3)];
      var $174=$27;
      var $175=$__mp1;
      var $176=$7;
      HEAP32[(($7)>>2)]=$175;
      var $177=HEAP32[(($7)>>2)];
      var $178=$177;
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+32)|0);
      var $181=HEAP32[(($180)>>2)];
      FUNCTION_TABLE[$181]($37, $177);
      var $182=$7;
      var $183=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($174, $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; };
    case 15: // $184
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($37);
      var $185=$26;
      var $186=$__mp1;
      var $187=$6;
      HEAP32[(($6)>>2)]=$186;
      var $188=HEAP32[(($6)>>2)];
      var $189=$188;
      var $190=HEAP32[(($189)>>2)];
      var $191=(($190+28)|0);
      var $192=HEAP32[(($191)>>2)];
      FUNCTION_TABLE[$192]($38, $188);
      var $193=$6;
      var $194=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($185, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 21; break; };
    case 16: // $195
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($38);
      var $196=$__mp1;
      var $197=$5;
      HEAP32[(($5)>>2)]=$196;
      var $198=HEAP32[(($5)>>2)];
      var $199=$198;
      var $200=HEAP32[(($199)>>2)];
      var $201=(($200+12)|0);
      var $202=HEAP32[(($201)>>2)];
      var $203=FUNCTION_TABLE[$202]($198);
      var $204=$5;
      var $205=$22;
      HEAP32[(($205)>>2)]=$203;
      var $206=$__mp1;
      var $207=$4;
      HEAP32[(($4)>>2)]=$206;
      var $208=HEAP32[(($4)>>2)];
      var $209=$208;
      var $210=HEAP32[(($209)>>2)];
      var $211=(($210+16)|0);
      var $212=HEAP32[(($211)>>2)];
      var $213=FUNCTION_TABLE[$212]($208);
      var $214=$4;
      var $215=$23;
      HEAP32[(($215)>>2)]=$213;
      var $216=$24;
      var $217=$__mp1;
      var $218=$3;
      HEAP32[(($3)>>2)]=$217;
      var $219=HEAP32[(($3)>>2)];
      var $220=$219;
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+20)|0);
      var $223=HEAP32[(($222)>>2)];
      FUNCTION_TABLE[$223]($39, $219);
      var $224=$3;
      var $225=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($216, $39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 23; break; };
    case 17: // $226
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($39);
      var $227=$25;
      var $228=$__mp1;
      var $229=$2;
      HEAP32[(($2)>>2)]=$228;
      var $230=HEAP32[(($2)>>2)];
      var $231=$230;
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232+24)|0);
      var $234=HEAP32[(($233)>>2)];
      FUNCTION_TABLE[$234]($40, $230);
      var $235=$2;
      var $236=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($227, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 25; break; };
    case 18: // $237
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($40);
      var $238=$__mp1;
      var $239=$1;
      HEAP32[(($1)>>2)]=$238;
      var $240=HEAP32[(($1)>>2)];
      var $241=$240;
      var $242=HEAP32[(($241)>>2)];
      var $243=(($242+36)|0);
      var $244=HEAP32[(($243)>>2)];
      var $245=FUNCTION_TABLE[$244]($240);
      var $246=$1;
      var $247=$28;
      HEAP32[(($247)>>2)]=$245;
      __label__ = 27; break;
    case 19: // $248
      var $249=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $250=$249.f0;
      $31=$250;
      var $251=$249.f1;
      $32=$251;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 29; break; }
    case 20: // $252
      __label__ = 28; break;
    case 21: // $253
      var $254=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $255=$254.f0;
      $31=$255;
      var $256=$254.f1;
      $32=$256;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 29; break; }
    case 22: // $257
      __label__ = 28; break;
    case 23: // $258
      var $259=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $260=$259.f0;
      $31=$260;
      var $261=$259.f1;
      $32=$261;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($39) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 29; break; }
    case 24: // $262
      __label__ = 28; break;
    case 25: // $263
      var $264=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $265=$264.f0;
      $31=$265;
      var $266=$264.f1;
      $32=$266;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 29; break; }
    case 26: // $267
      __label__ = 28; break;
    case 27: // $268
      STACKTOP = __stackBase__;
      return;
    case 28: // $269
      var $270=$31;
      var $271=$31;
      var $272=$32;
      var $273=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $271, tempValue);
      var $274=($273.f1 = $272, $273);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 29: // $275
      var $276=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri["X"]=1;

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SD_SC_SC_RKT1_Rjb($__b, $__e, $__kb, $__ke, $__ct, $__err, $__case_sensitive) {
  var __stackBase__  = STACKTOP; STACKTOP += 644; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__e; $__e = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__e)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $__tmp_i=__stackBase__+312;
      var $79=__stackBase__+316;
      var $80=__stackBase__+320;
      var $81=__stackBase__+324;
      var $82=__stackBase__+328;
      var $83=__stackBase__+332;
      var $84=__stackBase__+336;
      var $85=__stackBase__+340;
      var $86=__stackBase__+344;
      var $87=__stackBase__+348;
      var $88=__stackBase__+352;
      var $__tmp_i_i_i3=__stackBase__+356;
      var $89=__stackBase__+360;
      var $90=__stackBase__+364;
      var $91=__stackBase__+368;
      var $92=__stackBase__+372;
      var $93=__stackBase__+376;
      var $94=__stackBase__+380;
      var $95=__stackBase__+384;
      var $96=__stackBase__+388;
      var $97=__stackBase__+392;
      var $98=__stackBase__+396;
      var $99=__stackBase__+400;
      var $100=__stackBase__+404;
      var $101=__stackBase__+408;
      var $102=__stackBase__+412;
      var $103=__stackBase__+416;
      var $104=__stackBase__+420;
      var $105=__stackBase__+424;
      var $106=__stackBase__+428;
      var $107=__stackBase__+432;
      var $108=__stackBase__+436;
      var $109=__stackBase__+440;
      var $110=__stackBase__+444;
      var $111=__stackBase__+448;
      var $112=__stackBase__+452;
      var $113=__stackBase__+456;
      var $114=__stackBase__+460;
      var $115=__stackBase__+464;
      var $116=__stackBase__+468;
      var $117=__stackBase__+472;
      var $118=__stackBase__+476;
      var $119=__stackBase__+480;
      var $120=__stackBase__+484;
      var $121=__stackBase__+488;
      var $__tmp_i_i_i=__stackBase__+492;
      var $122=__stackBase__+496;
      var $123=__stackBase__+500;
      var $124=__stackBase__+504;
      var $125=__stackBase__+508;
      var $126=__stackBase__+512;
      var $127=__stackBase__+516;
      var $128=__stackBase__+520;
      var $129=__stackBase__+524;
      var $130=__stackBase__+528;
      var $131=__stackBase__+532;
      var $132;
      var $133;
      var $134;
      var $135;
      var $136;
      var $137;
      var $138;
      var $__nkw;
      var $__doesnt_match;
      var $__might_match;
      var $__does_match;
      var $__statbuf=__stackBase__+536;
      var $__status;
      var $__stat_hold=__stackBase__+636;
      var $139;
      var $140;
      var $__n_might_match;
      var $__n_does_match;
      var $__st;
      var $__ky;
      var $__indx;
      var $__c;
      var $__consume;
      var $__ky1;
      var $__kc;
      var $__ky2;
      var $141;
      $133=$__b;
      $134=$__kb;
      $135=$__ke;
      $136=$__ct;
      $137=$__err;
      var $142=(($__case_sensitive)&1);
      $138=$142;
      var $143=$134;
      var $144=$135;
      var $145=$128;
      var $146=$129;
      var $147=$130;
      var $148=$131;
      HEAP32[(($129)>>2)]=$143;
      HEAP32[(($130)>>2)]=$144;
      var $149=HEAP32[(($129)>>2)];
      var $150=HEAP32[(($130)>>2)];
      var $tmp_i=$128;
      var $tmp1_i=$131;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $151=$126;
      var $152=$127;
      HEAP32[(($126)>>2)]=$149;
      HEAP32[(($127)>>2)]=$150;
      var $153=HEAP32[(($127)>>2)];
      var $154=HEAP32[(($126)>>2)];
      var $155=$153;
      var $156=$154;
      var $157=(($155-$156)|0);
      var $158=(((($157)|0)/12)|0);
      var $159=$126;
      var $160=$127;
      var $161=$128;
      var $162=$129;
      var $163=$130;
      var $164=$131;
      $__nkw=$158;
      $__doesnt_match=0;
      $__might_match=1;
      $__does_match=2;
      var $165=(($__statbuf)|0);
      $__status=$165;
      var $166=$111;
      var $167=$112;
      var $168=$113;
      HEAP32[(($111)>>2)]=$__stat_hold;
      HEAP32[(($112)>>2)]=0;
      HEAP32[(($113)>>2)]=1496;
      var $169=HEAP32[(($111)>>2)];
      var $170=HEAP32[(($112)>>2)];
      var $171=HEAP32[(($113)>>2)];
      var $172=$108;
      var $173=$109;
      var $174=$110;
      HEAP32[(($108)>>2)]=$169;
      HEAP32[(($109)>>2)]=$170;
      HEAP32[(($110)>>2)]=$171;
      var $175=HEAP32[(($108)>>2)];
      var $176=(($175)|0);
      var $177=$107;
      HEAP32[(($107)>>2)]=$109;
      var $178=HEAP32[(($107)>>2)];
      var $179=$107;
      var $180=HEAP32[(($178)>>2)];
      var $181=$93;
      HEAP32[(($93)>>2)]=$110;
      var $182=HEAP32[(($93)>>2)];
      var $183=$93;
      var $184=HEAP32[(($182)>>2)];
      var $185=$104;
      var $186=$105;
      var $187=$106;
      HEAP32[(($104)>>2)]=$176;
      HEAP32[(($105)>>2)]=$180;
      HEAP32[(($106)>>2)]=$184;
      var $188=HEAP32[(($104)>>2)];
      var $189=HEAP32[(($105)>>2)];
      var $190=HEAP32[(($106)>>2)];
      var $191=$101;
      var $192=$102;
      var $193=$103;
      HEAP32[(($101)>>2)]=$188;
      HEAP32[(($102)>>2)]=$189;
      HEAP32[(($103)>>2)]=$190;
      var $194=HEAP32[(($101)>>2)];
      var $195=$194;
      var $196=$100;
      HEAP32[(($100)>>2)]=$102;
      var $197=HEAP32[(($100)>>2)];
      var $198=$100;
      var $199=HEAP32[(($197)>>2)];
      var $200=$94;
      HEAP32[(($94)>>2)]=$103;
      var $201=HEAP32[(($94)>>2)];
      var $202=$94;
      var $203=HEAP32[(($201)>>2)];
      var $204=$97;
      var $205=$98;
      var $206=$99;
      HEAP32[(($97)>>2)]=$195;
      HEAP32[(($98)>>2)]=$199;
      HEAP32[(($99)>>2)]=$203;
      var $207=HEAP32[(($97)>>2)];
      var $208=(($207)|0);
      var $209=$96;
      HEAP32[(($96)>>2)]=$98;
      var $210=HEAP32[(($96)>>2)];
      var $211=$96;
      var $212=HEAP32[(($210)>>2)];
      HEAP32[(($208)>>2)]=$212;
      var $213=(($207+4)|0);
      var $214=$95;
      HEAP32[(($95)>>2)]=$99;
      var $215=HEAP32[(($95)>>2)];
      var $216=$95;
      var $217=HEAP32[(($215)>>2)];
      HEAP32[(($213)>>2)]=$217;
      var $218=$97;
      var $219=$98;
      var $220=$99;
      var $221=$101;
      var $222=$102;
      var $223=$103;
      var $224=$104;
      var $225=$105;
      var $226=$106;
      var $227=$108;
      var $228=$109;
      var $229=$110;
      var $230=$111;
      var $231=$112;
      var $232=$113;
      var $233=$__nkw;
      var $234=(($233)>>>0) > 100;
      if ($234) { __label__ = 1; break; } else { __label__ = 14; break; }
    case 1: // $235
      var $236=$__nkw;
      var $237=_malloc($236);
      $__status=$237;
      var $238=$__status;
      var $239=(($238)|0)==0;
      if ($239) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $240
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $241
      __label__ = 9; break;
    case 4: // $242
      var $243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $244=$243.f0;
      $139=$244;
      var $245=$243.f1;
      $140=$245;
      var $246=$92;
      HEAP32[(($92)>>2)]=$__stat_hold;
      var $247=HEAP32[(($92)>>2)];
      var $248=$91;
      HEAP32[(($91)>>2)]=$247;
      var $249=HEAP32[(($91)>>2)];
      var $250=$87;
      var $251=$88;
      var $252=$__tmp_i_i_i3;
      var $253=$89;
      var $254=$90;
      HEAP32[(($87)>>2)]=$249;
      HEAP32[(($88)>>2)]=0;
      var $255=HEAPU32[(($87)>>2)];
      var $256=(($255)|0);
      var $257=$86;
      HEAP32[(($86)>>2)]=$256;
      var $258=HEAP32[(($86)>>2)];
      var $259=$258;
      var $260=$85;
      HEAP32[(($85)>>2)]=$259;
      var $261=HEAP32[(($85)>>2)];
      var $262=(($261)|0);
      var $263=$85;
      var $264=$86;
      var $265=HEAP32[(($262)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$265;
      var $266=HEAP32[(($88)>>2)];
      var $267=(($255)|0);
      var $268=$84;
      HEAP32[(($84)>>2)]=$267;
      var $269=HEAP32[(($84)>>2)];
      var $270=$269;
      var $271=$83;
      HEAP32[(($83)>>2)]=$270;
      var $272=HEAP32[(($83)>>2)];
      var $273=(($272)|0);
      var $274=$83;
      var $275=$84;
      HEAP32[(($273)>>2)]=$266;
      var $276=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $277=(($276)|0)!=0;
      if ($277) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $278
      var $279=(($255)|0);
      var $280=$82;
      HEAP32[(($82)>>2)]=$279;
      var $281=HEAP32[(($82)>>2)];
      var $282=$281;
      var $283=$81;
      HEAP32[(($81)>>2)]=$282;
      var $284=HEAP32[(($81)>>2)];
      var $285=(($284+4)|0);
      var $286=$81;
      var $287=$82;
      var $288=HEAP32[(($285)>>2)];
      var $289=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$288]($289) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $290
      __label__ = 8; break;
    case 7: // $291
      var $292=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $293=$292.f0;
      HEAP32[(($89)>>2)]=$293;
      var $294=$292.f1;
      HEAP32[(($90)>>2)]=$294;
      var $295=HEAP32[(($89)>>2)];
      ___cxa_call_unexpected($295);
      throw "Reached an unreachable!"
    case 8: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit4
      var $296=$87;
      var $297=$88;
      var $298=$__tmp_i_i_i3;
      var $299=$89;
      var $300=$90;
      var $301=$91;
      var $302=$92;
      __label__ = 106; break;
    case 9: // $303
      var $304=$__status;
      var $305=$77;
      var $306=$78;
      var $307=$__tmp_i;
      var $308=$79;
      var $309=$80;
      HEAP32[(($77)>>2)]=$__stat_hold;
      HEAP32[(($78)>>2)]=$304;
      var $310=HEAP32[(($77)>>2)];
      var $311=(($310)|0);
      var $312=$76;
      HEAP32[(($76)>>2)]=$311;
      var $313=HEAP32[(($76)>>2)];
      var $314=$313;
      var $315=$75;
      HEAP32[(($75)>>2)]=$314;
      var $316=HEAP32[(($75)>>2)];
      var $317=(($316)|0);
      var $318=$75;
      var $319=$76;
      var $320=HEAP32[(($317)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$320;
      var $321=HEAP32[(($78)>>2)];
      var $322=(($310)|0);
      var $323=$74;
      HEAP32[(($74)>>2)]=$322;
      var $324=HEAP32[(($74)>>2)];
      var $325=$324;
      var $326=$73;
      HEAP32[(($73)>>2)]=$325;
      var $327=HEAP32[(($73)>>2)];
      var $328=(($327)|0);
      var $329=$73;
      var $330=$74;
      HEAP32[(($328)>>2)]=$321;
      var $331=HEAP32[(($__tmp_i)>>2)];
      var $332=(($331)|0)!=0;
      if ($332) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $333
      var $334=(($310)|0);
      var $335=$72;
      HEAP32[(($72)>>2)]=$334;
      var $336=HEAP32[(($72)>>2)];
      var $337=$336;
      var $338=$71;
      HEAP32[(($71)>>2)]=$337;
      var $339=HEAP32[(($71)>>2)];
      var $340=(($339+4)|0);
      var $341=$71;
      var $342=$72;
      var $343=HEAP32[(($340)>>2)];
      var $344=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$343]($344) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $345
      __label__ = 13; break;
    case 12: // $346
      var $347=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $348=$347.f0;
      HEAP32[(($79)>>2)]=$348;
      var $349=$347.f1;
      HEAP32[(($80)>>2)]=$349;
      var $350=HEAP32[(($79)>>2)];
      ___cxa_call_unexpected($350);
      throw "Reached an unreachable!"
    case 13: // $_ZNSt3__110unique_ptrIhPFvPvEE5resetEPh_exit
      var $351=$77;
      var $352=$78;
      var $353=$__tmp_i;
      var $354=$79;
      var $355=$80;
      __label__ = 14; break;
    case 14: // $356
      var $357=$__nkw;
      $__n_might_match=$357;
      $__n_does_match=0;
      var $358=$__status;
      $__st=$358;
      var $359=$134;
      $__ky=$359;
      __label__ = 15; break;
    case 15: // $360
      var $361=$__ky;
      var $362=$135;
      var $363=(($361)|0)!=(($362)|0);
      if ($363) { __label__ = 16; break; } else { __label__ = 24; break; }
    case 16: // $364
      var $365=$__ky;
      var $366=$70;
      HEAP32[(($70)>>2)]=$365;
      var $367=HEAP32[(($70)>>2)];
      var $368=$69;
      HEAP32[(($69)>>2)]=$367;
      var $369=HEAPU32[(($69)>>2)];
      var $370=$68;
      HEAP32[(($68)>>2)]=$369;
      var $371=HEAP32[(($68)>>2)];
      var $372=(($371)|0);
      var $373=$67;
      HEAP32[(($67)>>2)]=$372;
      var $374=HEAP32[(($67)>>2)];
      var $375=$374;
      var $376=$66;
      HEAP32[(($66)>>2)]=$375;
      var $377=HEAP32[(($66)>>2)];
      var $378=(($377)|0);
      var $379=$66;
      var $380=$67;
      var $381=(($378)|0);
      var $382=$381;
      var $383=(($382)|0);
      var $384=$383;
      var $385=HEAPU8[($384)];
      var $386=(($385)&255);
      var $387=$386 & 1;
      var $388=(($387)|0)!=0;
      var $389=$68;
      if ($388) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $390
      var $391=$62;
      HEAP32[(($62)>>2)]=$369;
      var $392=HEAP32[(($62)>>2)];
      var $393=(($392)|0);
      var $394=$61;
      HEAP32[(($61)>>2)]=$393;
      var $395=HEAP32[(($61)>>2)];
      var $396=$395;
      var $397=$60;
      HEAP32[(($60)>>2)]=$396;
      var $398=HEAP32[(($60)>>2)];
      var $399=(($398)|0);
      var $400=$60;
      var $401=$61;
      var $402=(($399)|0);
      var $403=$402;
      var $404=(($403+4)|0);
      var $405=HEAP32[(($404)>>2)];
      var $406=$62;
      var $427 = $405;__label__ = 19; break;
    case 18: // $407
      var $408=$65;
      HEAP32[(($65)>>2)]=$369;
      var $409=HEAP32[(($65)>>2)];
      var $410=(($409)|0);
      var $411=$64;
      HEAP32[(($64)>>2)]=$410;
      var $412=HEAP32[(($64)>>2)];
      var $413=$412;
      var $414=$63;
      HEAP32[(($63)>>2)]=$413;
      var $415=HEAP32[(($63)>>2)];
      var $416=(($415)|0);
      var $417=$63;
      var $418=$64;
      var $419=(($416)|0);
      var $420=$419;
      var $421=(($420)|0);
      var $422=$421;
      var $423=HEAPU8[($422)];
      var $424=(($423)&255);
      var $425=$424 >> 1;
      var $426=$65;
      var $427 = $425;__label__ = 19; break;
    case 19: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv_exit
      var $427;
      var $428=$69;
      var $429=(($427)|0)==0;
      var $430=$70;
      if ($429) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $431
      var $432=$__st;
      HEAP8[($432)]=1;
      __label__ = 22; break;
    case 21: // $433
      var $434=$__st;
      HEAP8[($434)]=2;
      var $435=$__n_might_match;
      var $436=(($435-1)|0);
      $__n_might_match=$436;
      var $437=$__n_does_match;
      var $438=(($437+1)|0);
      $__n_does_match=$438;
      __label__ = 22; break;
    case 22: // $439
      __label__ = 23; break;
    case 23: // $440
      var $441=$__ky;
      var $442=(($441+12)|0);
      $__ky=$442;
      var $443=$__st;
      var $444=(($443+1)|0);
      $__st=$444;
      __label__ = 15; break;
    case 24: // $445
      $__indx=0;
      __label__ = 25; break;
    case 25: // $446
      var $447=$133;
      var $448=$58;
      var $449=$59;
      HEAP32[(($58)>>2)]=$447;
      HEAP32[(($59)>>2)]=$__e;
      var $450=HEAP32[(($58)>>2)];
      var $451=HEAP32[(($59)>>2)];
      var $452=$56;
      var $453=$57;
      HEAP32[(($56)>>2)]=$450;
      HEAP32[(($57)>>2)]=$451;
      var $454=HEAP32[(($56)>>2)];
      var $455=(($454)|0);
      var $456=HEAP32[(($455)>>2)];
      var $457=(($456)|0)==0;
      var $458=(($457)&1);
      var $459=HEAP32[(($57)>>2)];
      var $460=(($459)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=(($461)|0)==0;
      var $463=(($462)&1);
      var $464=(($458)|0)==(($463)|0);
      var $465=$56;
      var $466=$57;
      var $467=$464 ^ 1;
      var $468=$58;
      var $469=$59;
      __label__ = 26; break;
    case 26: // $470
      if ($467) { __label__ = 27; break; } else { var $475 = 0;__label__ = 28; break; }
    case 27: // $471
      var $472=$__n_might_match;
      var $473=(($472)>>>0) > 0;
      var $475 = $473;__label__ = 28; break;
    case 28: // $474
      var $475;
      if ($475) { __label__ = 29; break; } else { __label__ = 90; break; }
    case 29: // $476
      var $477=$133;
      var $478=$55;
      HEAP32[(($55)>>2)]=$477;
      var $479=HEAP32[(($55)>>2)];
      var $480=(($479)|0);
      var $481=HEAP32[(($480)>>2)];
      var $482=$53;
      var $483=$54;
      HEAP32[(($54)>>2)]=$481;
      var $484=HEAPU32[(($54)>>2)];
      var $485=(($484+12)|0);
      var $486=HEAP32[(($485)>>2)];
      var $487=(($484+16)|0);
      var $488=HEAP32[(($487)>>2)];
      var $489=(($486)|0)==(($488)|0);
      if ($489) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $490
      var $491=$484;
      var $492=HEAP32[(($491)>>2)];
      var $493=(($492+36)|0);
      var $494=HEAP32[(($493)>>2)];
      var $495=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$494]($484) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 4; break; };
    case 31: // $_noexc
      HEAP32[(($53)>>2)]=$495;
      __label__ = 33; break;
    case 32: // $496
      var $497=(($484+12)|0);
      var $498=HEAP32[(($497)>>2)];
      var $499=HEAP32[(($498)>>2)];
      var $500=$52;
      HEAP32[(($52)>>2)]=$499;
      var $501=HEAP32[(($52)>>2)];
      var $502=$52;
      HEAP32[(($53)>>2)]=$501;
      __label__ = 33; break;
    case 33: // $_ZNKSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEdeEv_exit
      var $503=HEAP32[(($53)>>2)];
      var $504=$53;
      var $505=$54;
      var $506=$55;
      __label__ = 34; break;
    case 34: // $507
      $__c=$503;
      var $508=$138;
      var $509=(($508) & 1);
      if ($509) { __label__ = 38; break; } else { __label__ = 35; break; }
    case 35: // $510
      var $511=$136;
      var $512=$__c;
      var $513=$50;
      var $514=$51;
      HEAP32[(($50)>>2)]=$511;
      HEAP32[(($51)>>2)]=$512;
      var $515=HEAP32[(($50)>>2)];
      var $516=$515;
      var $517=HEAP32[(($516)>>2)];
      var $518=(($517+28)|0);
      var $519=HEAP32[(($518)>>2)];
      var $520=HEAP32[(($51)>>2)];
      var $521=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$519]($515, $520) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 4; break; };
    case 36: // $_ZNKSt3__15ctypeIwE7toupperEw_exit
      var $522=$50;
      var $523=$51;
      __label__ = 37; break;
    case 37: // $524
      $__c=$521;
      __label__ = 38; break;
    case 38: // $525
      $__consume=0;
      var $526=$__status;
      $__st=$526;
      var $527=$134;
      $__ky1=$527;
      __label__ = 39; break;
    case 39: // $528
      var $529=$__ky1;
      var $530=$135;
      var $531=(($529)|0)!=(($530)|0);
      if ($531) { __label__ = 40; break; } else { __label__ = 60; break; }
    case 40: // $532
      var $533=$__st;
      var $534=HEAPU8[($533)];
      var $535=(($534)&255);
      var $536=(($535)|0)==1;
      if ($536) { __label__ = 41; break; } else { __label__ = 58; break; }
    case 41: // $537
      var $538=$__ky1;
      var $539=$__indx;
      var $540=$48;
      var $541=$49;
      HEAP32[(($48)>>2)]=$538;
      HEAP32[(($49)>>2)]=$539;
      var $542=HEAP32[(($48)>>2)];
      var $543=$47;
      HEAP32[(($47)>>2)]=$542;
      var $544=HEAPU32[(($47)>>2)];
      var $545=$46;
      HEAP32[(($46)>>2)]=$544;
      var $546=HEAP32[(($46)>>2)];
      var $547=(($546)|0);
      var $548=$45;
      HEAP32[(($45)>>2)]=$547;
      var $549=HEAP32[(($45)>>2)];
      var $550=$549;
      var $551=$44;
      HEAP32[(($44)>>2)]=$550;
      var $552=HEAP32[(($44)>>2)];
      var $553=(($552)|0);
      var $554=$44;
      var $555=$45;
      var $556=(($553)|0);
      var $557=$556;
      var $558=(($557)|0);
      var $559=$558;
      var $560=HEAPU8[($559)];
      var $561=(($560)&255);
      var $562=$561 & 1;
      var $563=(($562)|0)!=0;
      var $564=$46;
      if ($563) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $565
      var $566=$40;
      HEAP32[(($40)>>2)]=$544;
      var $567=HEAP32[(($40)>>2)];
      var $568=(($567)|0);
      var $569=$39;
      HEAP32[(($39)>>2)]=$568;
      var $570=HEAP32[(($39)>>2)];
      var $571=$570;
      var $572=$38;
      HEAP32[(($38)>>2)]=$571;
      var $573=HEAP32[(($38)>>2)];
      var $574=(($573)|0);
      var $575=$38;
      var $576=$39;
      var $577=(($574)|0);
      var $578=$577;
      var $579=(($578+8)|0);
      var $580=HEAP32[(($579)>>2)];
      var $581=$40;
      var $599 = $580;__label__ = 44; break;
    case 43: // $582
      var $583=$43;
      HEAP32[(($43)>>2)]=$544;
      var $584=HEAP32[(($43)>>2)];
      var $585=(($584)|0);
      var $586=$42;
      HEAP32[(($42)>>2)]=$585;
      var $587=HEAP32[(($42)>>2)];
      var $588=$587;
      var $589=$41;
      HEAP32[(($41)>>2)]=$588;
      var $590=HEAP32[(($41)>>2)];
      var $591=(($590)|0);
      var $592=$41;
      var $593=$42;
      var $594=(($591)|0);
      var $595=$594;
      var $596=(($595+4)|0);
      var $597=(($596)|0);
      var $598=$43;
      var $599 = $597;__label__ = 44; break;
    case 44: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit
      var $599;
      var $600=$47;
      var $601=HEAP32[(($49)>>2)];
      var $602=(($599+($601<<2))|0);
      var $603=$48;
      var $604=$49;
      __label__ = 45; break;
    case 45: // $605
      var $606=HEAP32[(($602)>>2)];
      $__kc=$606;
      var $607=$138;
      var $608=(($607) & 1);
      if ($608) { __label__ = 49; break; } else { __label__ = 46; break; }
    case 46: // $609
      var $610=$136;
      var $611=$__kc;
      var $612=$11;
      var $613=$12;
      HEAP32[(($11)>>2)]=$610;
      HEAP32[(($12)>>2)]=$611;
      var $614=HEAP32[(($11)>>2)];
      var $615=$614;
      var $616=HEAP32[(($615)>>2)];
      var $617=(($616+28)|0);
      var $618=HEAP32[(($617)>>2)];
      var $619=HEAP32[(($12)>>2)];
      var $620=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$618]($614, $619) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 4; break; };
    case 47: // $_ZNKSt3__15ctypeIwE7toupperEw_exit9
      var $621=$11;
      var $622=$12;
      __label__ = 48; break;
    case 48: // $623
      $__kc=$620;
      __label__ = 49; break;
    case 49: // $624
      var $625=$__c;
      var $626=$__kc;
      var $627=(($625)|0)==(($626)|0);
      if ($627) { __label__ = 50; break; } else { __label__ = 56; break; }
    case 50: // $628
      $__consume=1;
      var $629=$__ky1;
      var $630=$10;
      HEAP32[(($10)>>2)]=$629;
      var $631=HEAPU32[(($10)>>2)];
      var $632=$9;
      HEAP32[(($9)>>2)]=$631;
      var $633=HEAP32[(($9)>>2)];
      var $634=(($633)|0);
      var $635=$8;
      HEAP32[(($8)>>2)]=$634;
      var $636=HEAP32[(($8)>>2)];
      var $637=$636;
      var $638=$7;
      HEAP32[(($7)>>2)]=$637;
      var $639=HEAP32[(($7)>>2)];
      var $640=(($639)|0);
      var $641=$7;
      var $642=$8;
      var $643=(($640)|0);
      var $644=$643;
      var $645=(($644)|0);
      var $646=$645;
      var $647=HEAPU8[($646)];
      var $648=(($647)&255);
      var $649=$648 & 1;
      var $650=(($649)|0)!=0;
      var $651=$9;
      if ($650) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $652
      var $653=$3;
      HEAP32[(($3)>>2)]=$631;
      var $654=HEAP32[(($3)>>2)];
      var $655=(($654)|0);
      var $656=$2;
      HEAP32[(($2)>>2)]=$655;
      var $657=HEAP32[(($2)>>2)];
      var $658=$657;
      var $659=$1;
      HEAP32[(($1)>>2)]=$658;
      var $660=HEAP32[(($1)>>2)];
      var $661=(($660)|0);
      var $662=$1;
      var $663=$2;
      var $664=(($661)|0);
      var $665=$664;
      var $666=(($665+4)|0);
      var $667=HEAP32[(($666)>>2)];
      var $668=$3;
      var $689 = $667;__label__ = 53; break;
    case 52: // $669
      var $670=$6;
      HEAP32[(($6)>>2)]=$631;
      var $671=HEAP32[(($6)>>2)];
      var $672=(($671)|0);
      var $673=$5;
      HEAP32[(($5)>>2)]=$672;
      var $674=HEAP32[(($5)>>2)];
      var $675=$674;
      var $676=$4;
      HEAP32[(($4)>>2)]=$675;
      var $677=HEAP32[(($4)>>2)];
      var $678=(($677)|0);
      var $679=$4;
      var $680=$5;
      var $681=(($678)|0);
      var $682=$681;
      var $683=(($682)|0);
      var $684=$683;
      var $685=HEAPU8[($684)];
      var $686=(($685)&255);
      var $687=$686 >> 1;
      var $688=$6;
      var $689 = $687;__label__ = 53; break;
    case 53: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit10
      var $689;
      var $690=$10;
      var $691=$__indx;
      var $692=(($691+1)|0);
      var $693=(($689)|0)==(($692)|0);
      if ($693) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $694
      var $695=$__st;
      HEAP8[($695)]=2;
      var $696=$__n_might_match;
      var $697=(($696-1)|0);
      $__n_might_match=$697;
      var $698=$__n_does_match;
      var $699=(($698+1)|0);
      $__n_does_match=$699;
      __label__ = 55; break;
    case 55: // $700
      __label__ = 57; break;
    case 56: // $701
      var $702=$__st;
      HEAP8[($702)]=0;
      var $703=$__n_might_match;
      var $704=(($703-1)|0);
      $__n_might_match=$704;
      __label__ = 57; break;
    case 57: // $705
      __label__ = 58; break;
    case 58: // $706
      __label__ = 59; break;
    case 59: // $707
      var $708=$__ky1;
      var $709=(($708+12)|0);
      $__ky1=$709;
      var $710=$__st;
      var $711=(($710+1)|0);
      $__st=$711;
      __label__ = 39; break;
    case 60: // $712
      var $713=$__consume;
      var $714=(($713) & 1);
      if ($714) { __label__ = 61; break; } else { __label__ = 88; break; }
    case 61: // $715
      var $716=$133;
      var $717=$23;
      HEAP32[(($23)>>2)]=$716;
      var $718=HEAPU32[(($23)>>2)];
      var $719=(($718)|0);
      var $720=HEAP32[(($719)>>2)];
      var $721=$21;
      var $722=$22;
      HEAP32[(($22)>>2)]=$720;
      var $723=HEAP32[(($22)>>2)];
      var $724=$19;
      var $725=$20;
      HEAP32[(($20)>>2)]=$723;
      var $726=HEAP32[(($20)>>2)];
      var $727=(($726+12)|0);
      var $728=HEAP32[(($727)>>2)];
      var $729=(($726+16)|0);
      var $730=HEAP32[(($729)>>2)];
      var $731=(($728)|0)==(($730)|0);
      if ($731) { __label__ = 62; break; } else { __label__ = 64; break; }
    case 62: // $732
      var $733=$726;
      var $734=HEAP32[(($733)>>2)];
      var $735=(($734+40)|0);
      var $736=HEAP32[(($735)>>2)];
      var $737=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$736]($726) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 63; break; } else { __label__ = 4; break; };
    case 63: // $_noexc6
      HEAP32[(($19)>>2)]=$737;
      __label__ = 65; break;
    case 64: // $738
      var $739=(($726+12)|0);
      var $740=HEAP32[(($739)>>2)];
      var $741=(($740+4)|0);
      HEAP32[(($739)>>2)]=$741;
      var $742=HEAP32[(($740)>>2)];
      var $743=$18;
      HEAP32[(($18)>>2)]=$742;
      var $744=HEAP32[(($18)>>2)];
      var $745=$18;
      HEAP32[(($19)>>2)]=$744;
      __label__ = 65; break;
    case 65: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv_exit_i_i
      var $746=HEAP32[(($19)>>2)];
      var $747=$19;
      var $748=$20;
      var $749=(($746)|0)==-1;
      if ($749) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $750
      HEAP32[(($21)>>2)]=-1;
      __label__ = 72; break;
    case 67: // $751
      var $752=$16;
      var $753=$17;
      HEAP32[(($17)>>2)]=$723;
      var $754=HEAP32[(($17)>>2)];
      var $755=(($754+12)|0);
      var $756=HEAP32[(($755)>>2)];
      var $757=(($754+16)|0);
      var $758=HEAP32[(($757)>>2)];
      var $759=(($756)|0)==(($758)|0);
      if ($759) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $760
      var $761=$754;
      var $762=HEAP32[(($761)>>2)];
      var $763=(($762+36)|0);
      var $764=HEAP32[(($763)>>2)];
      var $765=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$764]($754) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 69; break; } else { __label__ = 4; break; };
    case 69: // $_noexc7
      HEAP32[(($16)>>2)]=$765;
      __label__ = 71; break;
    case 70: // $766
      var $767=(($754+12)|0);
      var $768=HEAP32[(($767)>>2)];
      var $769=HEAP32[(($768)>>2)];
      var $770=$15;
      HEAP32[(($15)>>2)]=$769;
      var $771=HEAP32[(($15)>>2)];
      var $772=$15;
      HEAP32[(($16)>>2)]=$771;
      __label__ = 71; break;
    case 71: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5sgetcEv_exit_i_i
      var $773=HEAP32[(($16)>>2)];
      var $774=$16;
      var $775=$17;
      HEAP32[(($21)>>2)]=$773;
      __label__ = 72; break;
    case 72: // $_ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6snextcEv_exit_i
      var $776=HEAP32[(($21)>>2)];
      var $777=$21;
      var $778=$22;
      var $779=$13;
      var $780=$14;
      HEAP32[(($13)>>2)]=$776;
      HEAP32[(($14)>>2)]=-1;
      var $781=HEAP32[(($13)>>2)];
      var $782=HEAP32[(($14)>>2)];
      var $783=(($781)|0)==(($782)|0);
      var $784=$13;
      var $785=$14;
      if ($783) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $786
      var $787=(($718)|0);
      HEAP32[(($787)>>2)]=0;
      __label__ = 74; break;
    case 74: // $_ZNSt3__119istreambuf_iteratorIwNS_11char_traitsIwEEEppEv_exit
      var $788=$23;
      __label__ = 75; break;
    case 75: // $789
      var $790=$__n_might_match;
      var $791=$__n_does_match;
      var $792=(($790+$791)|0);
      var $793=(($792)>>>0) > 1;
      if ($793) { __label__ = 76; break; } else { __label__ = 87; break; }
    case 76: // $794
      var $795=$__status;
      $__st=$795;
      var $796=$134;
      $__ky2=$796;
      __label__ = 77; break;
    case 77: // $797
      var $798=$__ky2;
      var $799=$135;
      var $800=(($798)|0)!=(($799)|0);
      if ($800) { __label__ = 78; break; } else { __label__ = 86; break; }
    case 78: // $801
      var $802=$__st;
      var $803=HEAPU8[($802)];
      var $804=(($803)&255);
      var $805=(($804)|0)==2;
      if ($805) { __label__ = 79; break; } else { __label__ = 84; break; }
    case 79: // $806
      var $807=$__ky2;
      var $808=$33;
      HEAP32[(($33)>>2)]=$807;
      var $809=HEAPU32[(($33)>>2)];
      var $810=$32;
      HEAP32[(($32)>>2)]=$809;
      var $811=HEAP32[(($32)>>2)];
      var $812=(($811)|0);
      var $813=$31;
      HEAP32[(($31)>>2)]=$812;
      var $814=HEAP32[(($31)>>2)];
      var $815=$814;
      var $816=$30;
      HEAP32[(($30)>>2)]=$815;
      var $817=HEAP32[(($30)>>2)];
      var $818=(($817)|0);
      var $819=$30;
      var $820=$31;
      var $821=(($818)|0);
      var $822=$821;
      var $823=(($822)|0);
      var $824=$823;
      var $825=HEAPU8[($824)];
      var $826=(($825)&255);
      var $827=$826 & 1;
      var $828=(($827)|0)!=0;
      var $829=$32;
      if ($828) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $830
      var $831=$26;
      HEAP32[(($26)>>2)]=$809;
      var $832=HEAP32[(($26)>>2)];
      var $833=(($832)|0);
      var $834=$25;
      HEAP32[(($25)>>2)]=$833;
      var $835=HEAP32[(($25)>>2)];
      var $836=$835;
      var $837=$24;
      HEAP32[(($24)>>2)]=$836;
      var $838=HEAP32[(($24)>>2)];
      var $839=(($838)|0);
      var $840=$24;
      var $841=$25;
      var $842=(($839)|0);
      var $843=$842;
      var $844=(($843+4)|0);
      var $845=HEAP32[(($844)>>2)];
      var $846=$26;
      var $867 = $845;__label__ = 82; break;
    case 81: // $847
      var $848=$29;
      HEAP32[(($29)>>2)]=$809;
      var $849=HEAP32[(($29)>>2)];
      var $850=(($849)|0);
      var $851=$28;
      HEAP32[(($28)>>2)]=$850;
      var $852=HEAP32[(($28)>>2)];
      var $853=$852;
      var $854=$27;
      HEAP32[(($27)>>2)]=$853;
      var $855=HEAP32[(($27)>>2)];
      var $856=(($855)|0);
      var $857=$27;
      var $858=$28;
      var $859=(($856)|0);
      var $860=$859;
      var $861=(($860)|0);
      var $862=$861;
      var $863=HEAPU8[($862)];
      var $864=(($863)&255);
      var $865=$864 >> 1;
      var $866=$29;
      var $867 = $865;__label__ = 82; break;
    case 82: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $867;
      var $868=$33;
      var $869=$__indx;
      var $870=(($869+1)|0);
      var $871=(($867)|0)!=(($870)|0);
      if ($871) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $872
      var $873=$__st;
      HEAP8[($873)]=0;
      var $874=$__n_does_match;
      var $875=(($874-1)|0);
      $__n_does_match=$875;
      __label__ = 84; break;
    case 84: // $876
      __label__ = 85; break;
    case 85: // $877
      var $878=$__ky2;
      var $879=(($878+12)|0);
      $__ky2=$879;
      var $880=$__st;
      var $881=(($880+1)|0);
      $__st=$881;
      __label__ = 77; break;
    case 86: // $882
      __label__ = 87; break;
    case 87: // $883
      __label__ = 88; break;
    case 88: // $884
      __label__ = 89; break;
    case 89: // $885
      var $886=$__indx;
      var $887=(($886+1)|0);
      $__indx=$887;
      __label__ = 25; break;
    case 90: // $888
      var $889=$133;
      var $890=$36;
      var $891=$37;
      HEAP32[(($36)>>2)]=$889;
      HEAP32[(($37)>>2)]=$__e;
      var $892=HEAP32[(($36)>>2)];
      var $893=HEAP32[(($37)>>2)];
      var $894=$34;
      var $895=$35;
      HEAP32[(($34)>>2)]=$892;
      HEAP32[(($35)>>2)]=$893;
      var $896=HEAP32[(($34)>>2)];
      var $897=(($896)|0);
      var $898=HEAP32[(($897)>>2)];
      var $899=(($898)|0)==0;
      var $900=(($899)&1);
      var $901=HEAP32[(($35)>>2)];
      var $902=(($901)|0);
      var $903=HEAP32[(($902)>>2)];
      var $904=(($903)|0)==0;
      var $905=(($904)&1);
      var $906=(($900)|0)==(($905)|0);
      var $907=$34;
      var $908=$35;
      var $909=$36;
      var $910=$37;
      __label__ = 91; break;
    case 91: // $911
      if ($906) { __label__ = 92; break; } else { __label__ = 93; break; }
    case 92: // $912
      var $913=$137;
      var $914=HEAP32[(($913)>>2)];
      var $915=$914 | 2;
      HEAP32[(($913)>>2)]=$915;
      __label__ = 93; break;
    case 93: // $916
      var $917=$__status;
      $__st=$917;
      __label__ = 94; break;
    case 94: // $918
      var $919=$134;
      var $920=$135;
      var $921=(($919)|0)!=(($920)|0);
      if ($921) { __label__ = 95; break; } else { __label__ = 99; break; }
    case 95: // $922
      var $923=$__st;
      var $924=HEAPU8[($923)];
      var $925=(($924)&255);
      var $926=(($925)|0)==2;
      if ($926) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $927
      __label__ = 99; break;
    case 97: // $928
      __label__ = 98; break;
    case 98: // $929
      var $930=$134;
      var $931=(($930+12)|0);
      $134=$931;
      var $932=$__st;
      var $933=(($932+1)|0);
      $__st=$933;
      __label__ = 94; break;
    case 99: // $934
      var $935=$134;
      var $936=$135;
      var $937=(($935)|0)==(($936)|0);
      if ($937) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $938
      var $939=$137;
      var $940=HEAP32[(($939)>>2)];
      var $941=$940 | 4;
      HEAP32[(($939)>>2)]=$941;
      __label__ = 101; break;
    case 101: // $942
      var $943=$134;
      $132=$943;
      $141=1;
      var $944=$125;
      HEAP32[(($125)>>2)]=$__stat_hold;
      var $945=HEAP32[(($125)>>2)];
      var $946=$124;
      HEAP32[(($124)>>2)]=$945;
      var $947=HEAP32[(($124)>>2)];
      var $948=$120;
      var $949=$121;
      var $950=$__tmp_i_i_i;
      var $951=$122;
      var $952=$123;
      HEAP32[(($120)>>2)]=$947;
      HEAP32[(($121)>>2)]=0;
      var $953=HEAP32[(($120)>>2)];
      var $954=(($953)|0);
      var $955=$119;
      HEAP32[(($119)>>2)]=$954;
      var $956=HEAP32[(($119)>>2)];
      var $957=$956;
      var $958=$118;
      HEAP32[(($118)>>2)]=$957;
      var $959=HEAP32[(($118)>>2)];
      var $960=(($959)|0);
      var $961=$118;
      var $962=$119;
      var $963=HEAP32[(($960)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$963;
      var $964=HEAP32[(($121)>>2)];
      var $965=(($953)|0);
      var $966=$117;
      HEAP32[(($117)>>2)]=$965;
      var $967=HEAP32[(($117)>>2)];
      var $968=$967;
      var $969=$116;
      HEAP32[(($116)>>2)]=$968;
      var $970=HEAP32[(($116)>>2)];
      var $971=(($970)|0);
      var $972=$116;
      var $973=$117;
      HEAP32[(($971)>>2)]=$964;
      var $974=HEAP32[(($__tmp_i_i_i)>>2)];
      var $975=(($974)|0)!=0;
      if ($975) { __label__ = 102; break; } else { __label__ = 105; break; }
    case 102: // $976
      var $977=(($953)|0);
      var $978=$115;
      HEAP32[(($115)>>2)]=$977;
      var $979=HEAP32[(($115)>>2)];
      var $980=$979;
      var $981=$114;
      HEAP32[(($114)>>2)]=$980;
      var $982=HEAP32[(($114)>>2)];
      var $983=(($982+4)|0);
      var $984=$114;
      var $985=$115;
      var $986=HEAP32[(($983)>>2)];
      var $987=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$986]($987) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $988
      __label__ = 105; break;
    case 104: // $989
      var $990=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $991=$990.f0;
      HEAP32[(($122)>>2)]=$991;
      var $992=$990.f1;
      HEAP32[(($123)>>2)]=$992;
      var $993=HEAP32[(($122)>>2)];
      ___cxa_call_unexpected($993);
      throw "Reached an unreachable!"
    case 105: // $_ZNSt3__110unique_ptrIhPFvPvEED1Ev_exit
      var $994=$120;
      var $995=$121;
      var $996=$__tmp_i_i_i;
      var $997=$122;
      var $998=$123;
      var $999=$124;
      var $1000=$125;
      var $1001=$132;
      STACKTOP = __stackBase__;
      return $1001;
    case 106: // $1002
      __label__ = 107; break;
    case 107: // $1003
      var $1004=$139;
      var $1005=$139;
      var $1006=$140;
      var $1007=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1005, tempValue);
      var $1008=($1007.f1 = $1006, $1007);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $1010=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SD_SC_SC_RKT1_Rjb["X"]=1;
// WARNING: content after a branch in a label, line: 886909
// WARNING: content after a branch in a label, line: 886911
// WARNING: content after a branch in a label, line: 886912
// WARNING: content after a branch in a label, line: 886913
// WARNING: content after a branch in a label, line: 886914
// WARNING: content after a branch in a label, line: 886915
// WARNING: content after a branch in a label, line: 886917
// WARNING: content after a branch in a label, line: 886918
// WARNING: content after a branch in a label, line: 886919
// WARNING: content after a branch in a label, line: 886921
// WARNING: content after a branch in a label, line: 886922
// WARNING: content after a branch in a label, line: 886923
// WARNING: content after a branch in a label, line: 886925
// WARNING: content after a branch in a label, line: 886927
// WARNING: content after a branch in a label, line: 886929
// WARNING: content after a branch in a label, line: 886931
// WARNING: content after a branch in a label, line: 886933
// WARNING: content after a branch in a label, line: 886934
// WARNING: content after a branch in a label, line: 886935
// WARNING: content after a branch in a label, line: 886936
// WARNING: content after a branch in a label, line: 886937
// WARNING: content after a branch in a label, line: 886939
// WARNING: content after a branch in a label, line: 886940
// WARNING: content after a branch in a label, line: 886941
// WARNING: content after a branch in a label, line: 886942
// WARNING: content after a branch in a label, line: 886944
// WARNING: content after a branch in a label, line: 886945
// WARNING: content after a branch in a label, line: 886946
// WARNING: content after a branch in a label, line: 886947
// WARNING: content after a branch in a label, line: 886949
// WARNING: content after a branch in a label, line: 886951
// WARNING: content after a branch in a label, line: 886952
// WARNING: content after a branch in a label, line: 886953
// WARNING: content after a branch in a label, line: 886954
// WARNING: content after a branch in a label, line: 886955
// WARNING: content after a branch in a label, line: 886957
// WARNING: content after a branch in a label, line: 886958
// WARNING: content after a branch in a label, line: 886959
// WARNING: content after a branch in a label, line: 886960
// WARNING: content after a branch in a label, line: 886962
// WARNING: content after a branch in a label, line: 886963
// WARNING: content after a branch in a label, line: 886964
// WARNING: content after a branch in a label, line: 886965
// WARNING: content after a branch in a label, line: 886967
// WARNING: content after a branch in a label, line: 886969
// WARNING: content after a branch in a label, line: 886970
// WARNING: content after a branch in a label, line: 886971
// WARNING: content after a branch in a label, line: 886972

function __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_($__b, $__n, $__e) {
  var __stackBase__  = STACKTOP; STACKTOP += 624; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i_i_i=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $22=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $__u1_i=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $__tmp_i_i=__stackBase__+148;
      var $36=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $__t_i_i=__stackBase__+204;
      var $49=__stackBase__+208;
      var $50=__stackBase__+212;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55=__stackBase__+232;
      var $56=__stackBase__+236;
      var $57=__stackBase__+240;
      var $58=__stackBase__+244;
      var $59=__stackBase__+248;
      var $60=__stackBase__+252;
      var $61=__stackBase__+256;
      var $62=__stackBase__+260;
      var $63=__stackBase__+264;
      var $64=__stackBase__+268;
      var $65=__stackBase__+272;
      var $66=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $__tmp_i_i_i5=__stackBase__+348;
      var $84=__stackBase__+352;
      var $85=__stackBase__+356;
      var $86=__stackBase__+360;
      var $87=__stackBase__+364;
      var $88=__stackBase__+368;
      var $89=__stackBase__+372;
      var $90=__stackBase__+376;
      var $91=__stackBase__+380;
      var $92=__stackBase__+384;
      var $__t_i=__stackBase__+388;
      var $93=__stackBase__+392;
      var $94=__stackBase__+396;
      var $95=__stackBase__+400;
      var $96=__stackBase__+404;
      var $97=__stackBase__+408;
      var $98=__stackBase__+412;
      var $99=__stackBase__+416;
      var $100=__stackBase__+420;
      var $101=__stackBase__+424;
      var $102=__stackBase__+428;
      var $103=__stackBase__+432;
      var $__tmp_i_i_i3=__stackBase__+436;
      var $104=__stackBase__+440;
      var $105=__stackBase__+444;
      var $106=__stackBase__+448;
      var $107=__stackBase__+452;
      var $108=__stackBase__+456;
      var $109=__stackBase__+460;
      var $110=__stackBase__+464;
      var $111=__stackBase__+468;
      var $112=__stackBase__+472;
      var $113=__stackBase__+476;
      var $114=__stackBase__+480;
      var $115=__stackBase__+484;
      var $116=__stackBase__+488;
      var $117=__stackBase__+492;
      var $118=__stackBase__+496;
      var $119;
      var $120;
      var $121;
      var $122;
      var $123=__stackBase__+500;
      var $124=__stackBase__+504;
      var $__tmp_i_i_i1=__stackBase__+508;
      var $125=__stackBase__+512;
      var $126=__stackBase__+516;
      var $127=__stackBase__+520;
      var $128=__stackBase__+524;
      var $129=__stackBase__+528;
      var $130=__stackBase__+532;
      var $131=__stackBase__+536;
      var $132=__stackBase__+540;
      var $133=__stackBase__+544;
      var $134=__stackBase__+548;
      var $135=__stackBase__+552;
      var $136=__stackBase__+556;
      var $137=__stackBase__+560;
      var $138=__stackBase__+564;
      var $139=__stackBase__+568;
      var $__tmp_i_i_i=__stackBase__+572;
      var $140=__stackBase__+576;
      var $141=__stackBase__+580;
      var $142=__stackBase__+584;
      var $143=__stackBase__+588;
      var $144=__stackBase__+592;
      var $145=__stackBase__+596;
      var $146=__stackBase__+600;
      var $147;
      var $148;
      var $149;
      var $__owns;
      var $__cur_cap;
      var $__new_cap;
      var $__n_off;
      var $__t;
      var $150=__stackBase__+604;
      var $151=__stackBase__+612;
      var $152=__stackBase__+616;
      var $153;
      var $154;
      $147=$__b;
      $148=$__n;
      $149=$__e;
      var $155=$147;
      var $156=$146;
      HEAP32[(($146)>>2)]=$155;
      var $157=HEAP32[(($146)>>2)];
      var $158=(($157)|0);
      var $159=$145;
      HEAP32[(($145)>>2)]=$158;
      var $160=HEAP32[(($145)>>2)];
      var $161=$160;
      var $162=$144;
      HEAP32[(($144)>>2)]=$161;
      var $163=HEAP32[(($144)>>2)];
      var $164=(($163+4)|0);
      var $165=$144;
      var $166=$145;
      var $167=$146;
      var $168=HEAP32[(($164)>>2)];
      var $169=(($168)|0)!=1682;
      var $170=(($169)&1);
      $__owns=$170;
      var $171=$149;
      var $172=HEAP32[(($171)>>2)];
      var $173=$147;
      var $174=$131;
      HEAP32[(($131)>>2)]=$173;
      var $175=HEAP32[(($131)>>2)];
      var $176=(($175)|0);
      var $177=$130;
      HEAP32[(($130)>>2)]=$176;
      var $178=HEAP32[(($130)>>2)];
      var $179=$178;
      var $180=$129;
      HEAP32[(($129)>>2)]=$179;
      var $181=HEAP32[(($129)>>2)];
      var $182=(($181)|0);
      var $183=$129;
      var $184=$130;
      var $185=HEAP32[(($182)>>2)];
      var $186=$131;
      var $187=$172;
      var $188=$185;
      var $189=(($187-$188)|0);
      var $190=(((($189)|0)/4)|0);
      var $191=((($190<<2))|0);
      $__cur_cap=$191;
      var $192=$__cur_cap;
      var $193=Math.floor(2147483647.5);
      var $194=(($192)>>>0) < (($193)>>>0);
      if ($194) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $195
      var $196=$__cur_cap;
      var $197=((($196<<1))|0);
      var $200 = $197;__label__ = 3; break;
    case 2: // $198
      var $200 = -1;__label__ = 3; break;
    case 3: // $199
      var $200;
      $__new_cap=$200;
      var $201=$148;
      var $202=HEAP32[(($201)>>2)];
      var $203=$147;
      var $204=$116;
      HEAP32[(($116)>>2)]=$203;
      var $205=HEAP32[(($116)>>2)];
      var $206=(($205)|0);
      var $207=$115;
      HEAP32[(($115)>>2)]=$206;
      var $208=HEAP32[(($115)>>2)];
      var $209=$208;
      var $210=$114;
      HEAP32[(($114)>>2)]=$209;
      var $211=HEAP32[(($114)>>2)];
      var $212=(($211)|0);
      var $213=$114;
      var $214=$115;
      var $215=HEAP32[(($212)>>2)];
      var $216=$116;
      var $217=$202;
      var $218=$215;
      var $219=(($217-$218)|0);
      var $220=(((($219)|0)/4)|0);
      $__n_off=$220;
      var $221=$__owns;
      var $222=(($221) & 1);
      if ($222) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $223
      var $224=$147;
      var $225=$95;
      HEAP32[(($95)>>2)]=$224;
      var $226=HEAP32[(($95)>>2)];
      var $227=(($226)|0);
      var $228=$94;
      HEAP32[(($94)>>2)]=$227;
      var $229=HEAP32[(($94)>>2)];
      var $230=$229;
      var $231=$93;
      HEAP32[(($93)>>2)]=$230;
      var $232=HEAP32[(($93)>>2)];
      var $233=(($232)|0);
      var $234=$93;
      var $235=$94;
      var $236=HEAP32[(($233)>>2)];
      var $237=$95;
      var $240 = $236;__label__ = 6; break;
    case 5: // $238
      var $240 = 0;__label__ = 6; break;
    case 6: // $239
      var $240;
      var $241=$240;
      var $242=$__new_cap;
      var $243=_realloc($241, $242);
      var $244=$243;
      $__t=$244;
      var $245=$__t;
      var $246=(($245)|0)==0;
      if ($246) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $247
      __ZSt17__throw_bad_allocv();
      __label__ = 8; break;
    case 8: // $248
      var $249=$__owns;
      var $250=(($249) & 1);
      if ($250) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $251
      var $252=$147;
      var $253=$92;
      var $254=$__t_i;
      HEAP32[(($92)>>2)]=$252;
      var $255=HEAP32[(($92)>>2)];
      var $256=(($255)|0);
      var $257=$91;
      HEAP32[(($91)>>2)]=$256;
      var $258=HEAP32[(($91)>>2)];
      var $259=$258;
      var $260=$90;
      HEAP32[(($90)>>2)]=$259;
      var $261=HEAP32[(($90)>>2)];
      var $262=(($261)|0);
      var $263=$90;
      var $264=$91;
      var $265=HEAP32[(($262)>>2)];
      HEAP32[(($__t_i)>>2)]=$265;
      var $266=(($255)|0);
      var $267=$89;
      HEAP32[(($89)>>2)]=$266;
      var $268=HEAP32[(($89)>>2)];
      var $269=$268;
      var $270=$88;
      HEAP32[(($88)>>2)]=$269;
      var $271=HEAP32[(($88)>>2)];
      var $272=(($271)|0);
      var $273=$88;
      var $274=$89;
      HEAP32[(($272)>>2)]=0;
      var $275=HEAP32[(($__t_i)>>2)];
      var $276=$92;
      var $277=$__t_i;
      __label__ = 10; break;
    case 10: // $278
      var $279=$147;
      var $280=$__t;
      var $281=$73;
      var $282=$74;
      var $283=$75;
      HEAP32[(($73)>>2)]=$152;
      HEAP32[(($74)>>2)]=$280;
      HEAP32[(($75)>>2)]=1496;
      var $284=HEAP32[(($73)>>2)];
      var $285=HEAP32[(($74)>>2)];
      var $286=HEAP32[(($75)>>2)];
      var $287=$70;
      var $288=$71;
      var $289=$72;
      HEAP32[(($70)>>2)]=$284;
      HEAP32[(($71)>>2)]=$285;
      HEAP32[(($72)>>2)]=$286;
      var $290=HEAP32[(($70)>>2)];
      var $291=(($290)|0);
      var $292=$69;
      HEAP32[(($69)>>2)]=$71;
      var $293=HEAP32[(($69)>>2)];
      var $294=$69;
      var $295=HEAP32[(($293)>>2)];
      var $296=$55;
      HEAP32[(($55)>>2)]=$72;
      var $297=HEAP32[(($55)>>2)];
      var $298=$55;
      var $299=HEAP32[(($297)>>2)];
      var $300=$66;
      var $301=$67;
      var $302=$68;
      HEAP32[(($66)>>2)]=$291;
      HEAP32[(($67)>>2)]=$295;
      HEAP32[(($68)>>2)]=$299;
      var $303=HEAP32[(($66)>>2)];
      var $304=HEAP32[(($67)>>2)];
      var $305=HEAP32[(($68)>>2)];
      var $306=$63;
      var $307=$64;
      var $308=$65;
      HEAP32[(($63)>>2)]=$303;
      HEAP32[(($64)>>2)]=$304;
      HEAP32[(($65)>>2)]=$305;
      var $309=HEAP32[(($63)>>2)];
      var $310=$309;
      var $311=$62;
      HEAP32[(($62)>>2)]=$64;
      var $312=HEAP32[(($62)>>2)];
      var $313=$62;
      var $314=HEAP32[(($312)>>2)];
      var $315=$56;
      HEAP32[(($56)>>2)]=$65;
      var $316=HEAP32[(($56)>>2)];
      var $317=$56;
      var $318=HEAP32[(($316)>>2)];
      var $319=$59;
      var $320=$60;
      var $321=$61;
      HEAP32[(($59)>>2)]=$310;
      HEAP32[(($60)>>2)]=$314;
      HEAP32[(($61)>>2)]=$318;
      var $322=HEAP32[(($59)>>2)];
      var $323=(($322)|0);
      var $324=$58;
      HEAP32[(($58)>>2)]=$60;
      var $325=HEAP32[(($58)>>2)];
      var $326=$58;
      var $327=HEAP32[(($325)>>2)];
      HEAP32[(($323)>>2)]=$327;
      var $328=(($322+4)|0);
      var $329=$57;
      HEAP32[(($57)>>2)]=$61;
      var $330=HEAP32[(($57)>>2)];
      var $331=$57;
      var $332=HEAP32[(($330)>>2)];
      HEAP32[(($328)>>2)]=$332;
      var $333=$59;
      var $334=$60;
      var $335=$61;
      var $336=$63;
      var $337=$64;
      var $338=$65;
      var $339=$66;
      var $340=$67;
      var $341=$68;
      var $342=$70;
      var $343=$71;
      var $344=$72;
      var $345=$73;
      var $346=$74;
      var $347=$75;
      var $348=$54;
      HEAP32[(($54)>>2)]=$152;
      var $349=HEAP32[(($54)>>2)];
      var $350=$52;
      var $351=$53;
      HEAP32[(($52)>>2)]=$151;
      HEAP32[(($53)>>2)]=$349;
      var $352=HEAP32[(($52)>>2)];
      var $353=HEAP32[(($53)>>2)];
      var $354=$50;
      var $355=$51;
      HEAP32[(($50)>>2)]=$352;
      HEAP32[(($51)>>2)]=$353;
      var $356=HEAP32[(($50)>>2)];
      var $357=(($356)|0);
      var $358=HEAP32[(($51)>>2)];
      HEAP32[(($357)>>2)]=$358;
      var $359=$50;
      var $360=$51;
      var $361=$52;
      var $362=$53;
      var $363=$54;
      __label__ = 11; break;
    case 11: // $364
      var $tmp=$27;
      var $tmp7=$151;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp7)];HEAP8[($tmp+1)]=HEAP8[($tmp7+1)];HEAP8[($tmp+2)]=HEAP8[($tmp7+2)];HEAP8[($tmp+3)]=HEAP8[($tmp7+3)];
      var $365=$__u1_i;
      var $366=$26;
      HEAP32[(($26)>>2)]=$150;
      var $367=HEAP32[(($26)>>2)];
      var $tmp_i=$__u1_i;
      var $tmp2_i=$27;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp2_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp2_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp2_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp2_i+3)];
      var $368=$25;
      HEAP32[(($25)>>2)]=$367;
      var $369=HEAP32[(($25)>>2)];
      var $370=(($369)|0);
      var $371=$24;
      HEAP32[(($24)>>2)]=$__u1_i;
      var $372=HEAP32[(($24)>>2)];
      var $373=(($372)|0);
      var $374=HEAP32[(($373)>>2)];
      var $375=$24;
      var $376=$5;
      var $377=$__t_i_i_i;
      HEAP32[(($5)>>2)]=$374;
      var $378=HEAP32[(($5)>>2)];
      var $379=(($378)|0);
      var $380=$4;
      HEAP32[(($4)>>2)]=$379;
      var $381=HEAP32[(($4)>>2)];
      var $382=$381;
      var $383=$3;
      HEAP32[(($3)>>2)]=$382;
      var $384=HEAP32[(($3)>>2)];
      var $385=(($384)|0);
      var $386=$3;
      var $387=$4;
      var $388=HEAP32[(($385)>>2)];
      HEAP32[(($__t_i_i_i)>>2)]=$388;
      var $389=(($378)|0);
      var $390=$2;
      HEAP32[(($2)>>2)]=$389;
      var $391=HEAP32[(($2)>>2)];
      var $392=$391;
      var $393=$1;
      HEAP32[(($1)>>2)]=$392;
      var $394=HEAP32[(($1)>>2)];
      var $395=(($394)|0);
      var $396=$1;
      var $397=$2;
      HEAP32[(($395)>>2)]=0;
      var $398=HEAP32[(($__t_i_i_i)>>2)];
      var $399=$5;
      var $400=$__t_i_i_i;
      var $401=$6;
      HEAP32[(($6)>>2)]=$__u1_i;
      var $402=HEAP32[(($6)>>2)];
      var $403=(($402)|0);
      var $404=HEAP32[(($403)>>2)];
      var $405=$6;
      var $406=$9;
      HEAP32[(($9)>>2)]=$404;
      var $407=HEAP32[(($9)>>2)];
      var $408=(($407)|0);
      var $409=$8;
      HEAP32[(($8)>>2)]=$408;
      var $410=HEAP32[(($8)>>2)];
      var $411=$410;
      var $412=$7;
      HEAP32[(($7)>>2)]=$411;
      var $413=HEAP32[(($7)>>2)];
      var $414=(($413+4)|0);
      var $415=$7;
      var $416=$8;
      var $417=$9;
      var $418=$10;
      HEAP32[(($10)>>2)]=$414;
      var $419=HEAP32[(($10)>>2)];
      var $420=$10;
      var $421=HEAP32[(($419)>>2)];
      var $422=$21;
      var $423=$22;
      var $424=$23;
      HEAP32[(($21)>>2)]=$370;
      HEAP32[(($22)>>2)]=$398;
      HEAP32[(($23)>>2)]=$421;
      var $425=HEAP32[(($21)>>2)];
      var $426=HEAP32[(($22)>>2)];
      var $427=HEAP32[(($23)>>2)];
      var $428=$18;
      var $429=$19;
      var $430=$20;
      HEAP32[(($18)>>2)]=$425;
      HEAP32[(($19)>>2)]=$426;
      HEAP32[(($20)>>2)]=$427;
      var $431=HEAP32[(($18)>>2)];
      var $432=$431;
      var $433=$17;
      HEAP32[(($17)>>2)]=$19;
      var $434=HEAP32[(($17)>>2)];
      var $435=$17;
      var $436=HEAP32[(($434)>>2)];
      var $437=$11;
      HEAP32[(($11)>>2)]=$20;
      var $438=HEAP32[(($11)>>2)];
      var $439=$11;
      var $440=HEAP32[(($438)>>2)];
      var $441=$14;
      var $442=$15;
      var $443=$16;
      HEAP32[(($14)>>2)]=$432;
      HEAP32[(($15)>>2)]=$436;
      HEAP32[(($16)>>2)]=$440;
      var $444=HEAP32[(($14)>>2)];
      var $445=(($444)|0);
      var $446=$13;
      HEAP32[(($13)>>2)]=$15;
      var $447=HEAP32[(($13)>>2)];
      var $448=$13;
      var $449=HEAP32[(($447)>>2)];
      HEAP32[(($445)>>2)]=$449;
      var $450=(($444+4)|0);
      var $451=$12;
      HEAP32[(($12)>>2)]=$16;
      var $452=HEAP32[(($12)>>2)];
      var $453=$12;
      var $454=HEAP32[(($452)>>2)];
      HEAP32[(($450)>>2)]=$454;
      var $455=$14;
      var $456=$15;
      var $457=$16;
      var $458=$18;
      var $459=$19;
      var $460=$20;
      var $461=$21;
      var $462=$22;
      var $463=$23;
      var $464=$25;
      var $465=$__u1_i;
      var $466=$26;
      __label__ = 12; break;
    case 12: // $467
      var $468=$49;
      HEAP32[(($49)>>2)]=$279;
      var $469=HEAP32[(($49)>>2)];
      var $470=$48;
      var $471=$__t_i_i;
      HEAP32[(($48)>>2)]=$150;
      var $472=HEAP32[(($48)>>2)];
      var $473=(($472)|0);
      var $474=$47;
      HEAP32[(($47)>>2)]=$473;
      var $475=HEAP32[(($47)>>2)];
      var $476=$475;
      var $477=$46;
      HEAP32[(($46)>>2)]=$476;
      var $478=HEAP32[(($46)>>2)];
      var $479=(($478)|0);
      var $480=$46;
      var $481=$47;
      var $482=HEAP32[(($479)>>2)];
      HEAP32[(($__t_i_i)>>2)]=$482;
      var $483=(($472)|0);
      var $484=$45;
      HEAP32[(($45)>>2)]=$483;
      var $485=HEAP32[(($45)>>2)];
      var $486=$485;
      var $487=$44;
      HEAP32[(($44)>>2)]=$486;
      var $488=HEAP32[(($44)>>2)];
      var $489=(($488)|0);
      var $490=$44;
      var $491=$45;
      HEAP32[(($489)>>2)]=0;
      var $492=HEAP32[(($__t_i_i)>>2)];
      var $493=$48;
      var $494=$__t_i_i;
      var $495=$34;
      var $496=$35;
      var $497=$__tmp_i_i;
      var $498=$36;
      var $499=$37;
      HEAP32[(($34)>>2)]=$469;
      HEAP32[(($35)>>2)]=$492;
      var $500=HEAP32[(($34)>>2)];
      var $501=(($500)|0);
      var $502=$33;
      HEAP32[(($33)>>2)]=$501;
      var $503=HEAP32[(($33)>>2)];
      var $504=$503;
      var $505=$32;
      HEAP32[(($32)>>2)]=$504;
      var $506=HEAP32[(($32)>>2)];
      var $507=(($506)|0);
      var $508=$32;
      var $509=$33;
      var $510=HEAP32[(($507)>>2)];
      HEAP32[(($__tmp_i_i)>>2)]=$510;
      var $511=HEAP32[(($35)>>2)];
      var $512=(($500)|0);
      var $513=$31;
      HEAP32[(($31)>>2)]=$512;
      var $514=HEAP32[(($31)>>2)];
      var $515=$514;
      var $516=$30;
      HEAP32[(($30)>>2)]=$515;
      var $517=HEAP32[(($30)>>2)];
      var $518=(($517)|0);
      var $519=$30;
      var $520=$31;
      HEAP32[(($518)>>2)]=$511;
      var $521=HEAP32[(($__tmp_i_i)>>2)];
      var $522=(($521)|0)!=0;
      if ($522) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $523
      var $524=(($500)|0);
      var $525=$29;
      HEAP32[(($29)>>2)]=$524;
      var $526=HEAP32[(($29)>>2)];
      var $527=$526;
      var $528=$28;
      HEAP32[(($28)>>2)]=$527;
      var $529=HEAP32[(($28)>>2)];
      var $530=(($529+4)|0);
      var $531=$28;
      var $532=$29;
      var $533=HEAP32[(($530)>>2)];
      var $534=HEAP32[(($__tmp_i_i)>>2)];
      var $535=$534;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$533]($535) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $536
      __label__ = 16; break;
    case 15: // $537
      var $538=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $539=$538.f0;
      HEAP32[(($36)>>2)]=$539;
      var $540=$538.f1;
      HEAP32[(($37)>>2)]=$540;
      var $541=HEAP32[(($36)>>2)];
      ___cxa_call_unexpected($541);
      throw "Reached an unreachable!"
    case 16: // $_ZNSt3__110unique_ptrIwPFvPvEEaSIwS3_EERS4_NS0_IT_T0_EE_exit
      var $542=$34;
      var $543=$35;
      var $544=$__tmp_i_i;
      var $545=$36;
      var $546=$37;
      var $547=$40;
      HEAP32[(($40)>>2)]=$150;
      var $548=HEAP32[(($40)>>2)];
      var $549=(($548)|0);
      var $550=$39;
      HEAP32[(($39)>>2)]=$549;
      var $551=HEAP32[(($39)>>2)];
      var $552=$551;
      var $553=$38;
      HEAP32[(($38)>>2)]=$552;
      var $554=HEAP32[(($38)>>2)];
      var $555=(($554+4)|0);
      var $556=$38;
      var $557=$39;
      var $558=$40;
      var $559=$41;
      HEAP32[(($41)>>2)]=$555;
      var $560=HEAP32[(($41)>>2)];
      var $561=$41;
      var $562=HEAP32[(($560)>>2)];
      var $563=(($469)|0);
      var $564=$43;
      HEAP32[(($43)>>2)]=$563;
      var $565=HEAP32[(($43)>>2)];
      var $566=$565;
      var $567=$42;
      HEAP32[(($42)>>2)]=$566;
      var $568=HEAP32[(($42)>>2)];
      var $569=(($568+4)|0);
      var $570=$42;
      var $571=$43;
      HEAP32[(($569)>>2)]=$562;
      var $572=$49;
      __label__ = 17; break;
    case 17: // $573
      var $574=$87;
      HEAP32[(($87)>>2)]=$150;
      var $575=HEAP32[(($87)>>2)];
      var $576=$86;
      HEAP32[(($86)>>2)]=$575;
      var $577=HEAP32[(($86)>>2)];
      var $578=$82;
      var $579=$83;
      var $580=$__tmp_i_i_i5;
      var $581=$84;
      var $582=$85;
      HEAP32[(($82)>>2)]=$577;
      HEAP32[(($83)>>2)]=0;
      var $583=HEAP32[(($82)>>2)];
      var $584=(($583)|0);
      var $585=$81;
      HEAP32[(($81)>>2)]=$584;
      var $586=HEAP32[(($81)>>2)];
      var $587=$586;
      var $588=$80;
      HEAP32[(($80)>>2)]=$587;
      var $589=HEAP32[(($80)>>2)];
      var $590=(($589)|0);
      var $591=$80;
      var $592=$81;
      var $593=HEAP32[(($590)>>2)];
      HEAP32[(($__tmp_i_i_i5)>>2)]=$593;
      var $594=HEAP32[(($83)>>2)];
      var $595=(($583)|0);
      var $596=$79;
      HEAP32[(($79)>>2)]=$595;
      var $597=HEAP32[(($79)>>2)];
      var $598=$597;
      var $599=$78;
      HEAP32[(($78)>>2)]=$598;
      var $600=HEAP32[(($78)>>2)];
      var $601=(($600)|0);
      var $602=$78;
      var $603=$79;
      HEAP32[(($601)>>2)]=$594;
      var $604=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $605=(($604)|0)!=0;
      if ($605) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $606
      var $607=(($583)|0);
      var $608=$77;
      HEAP32[(($77)>>2)]=$607;
      var $609=HEAP32[(($77)>>2)];
      var $610=$609;
      var $611=$76;
      HEAP32[(($76)>>2)]=$610;
      var $612=HEAP32[(($76)>>2)];
      var $613=(($612+4)|0);
      var $614=$76;
      var $615=$77;
      var $616=HEAP32[(($613)>>2)];
      var $617=HEAP32[(($__tmp_i_i_i5)>>2)];
      var $618=$617;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$616]($618) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $619
      __label__ = 21; break;
    case 20: // $620
      var $621=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $622=$621.f0;
      HEAP32[(($84)>>2)]=$622;
      var $623=$621.f1;
      HEAP32[(($85)>>2)]=$623;
      var $624=HEAP32[(($84)>>2)];
      ___cxa_call_unexpected($624);
      throw "Reached an unreachable!"
    case 21: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit6
      var $625=$82;
      var $626=$83;
      var $627=$__tmp_i_i_i5;
      var $628=$84;
      var $629=$85;
      var $630=$86;
      var $631=$87;
      __label__ = 22; break;
    case 22: // $632
      var $633=$107;
      HEAP32[(($107)>>2)]=$152;
      var $634=HEAP32[(($107)>>2)];
      var $635=$106;
      HEAP32[(($106)>>2)]=$634;
      var $636=HEAP32[(($106)>>2)];
      var $637=$102;
      var $638=$103;
      var $639=$__tmp_i_i_i3;
      var $640=$104;
      var $641=$105;
      HEAP32[(($102)>>2)]=$636;
      HEAP32[(($103)>>2)]=0;
      var $642=HEAP32[(($102)>>2)];
      var $643=(($642)|0);
      var $644=$101;
      HEAP32[(($101)>>2)]=$643;
      var $645=HEAP32[(($101)>>2)];
      var $646=$645;
      var $647=$100;
      HEAP32[(($100)>>2)]=$646;
      var $648=HEAP32[(($100)>>2)];
      var $649=(($648)|0);
      var $650=$100;
      var $651=$101;
      var $652=HEAP32[(($649)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$652;
      var $653=HEAP32[(($103)>>2)];
      var $654=(($642)|0);
      var $655=$99;
      HEAP32[(($99)>>2)]=$654;
      var $656=HEAP32[(($99)>>2)];
      var $657=$656;
      var $658=$98;
      HEAP32[(($98)>>2)]=$657;
      var $659=HEAP32[(($98)>>2)];
      var $660=(($659)|0);
      var $661=$98;
      var $662=$99;
      HEAP32[(($660)>>2)]=$653;
      var $663=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $664=(($663)|0)!=0;
      if ($664) { __label__ = 23; break; } else { __label__ = 26; break; }
    case 23: // $665
      var $666=(($642)|0);
      var $667=$97;
      HEAP32[(($97)>>2)]=$666;
      var $668=HEAP32[(($97)>>2)];
      var $669=$668;
      var $670=$96;
      HEAP32[(($96)>>2)]=$669;
      var $671=HEAP32[(($96)>>2)];
      var $672=(($671+4)|0);
      var $673=$96;
      var $674=$97;
      var $675=HEAP32[(($672)>>2)];
      var $676=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $677=$676;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$675]($677) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $678
      __label__ = 26; break;
    case 25: // $679
      var $680=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $681=$680.f0;
      HEAP32[(($104)>>2)]=$681;
      var $682=$680.f1;
      HEAP32[(($105)>>2)]=$682;
      var $683=HEAP32[(($104)>>2)];
      ___cxa_call_unexpected($683);
      throw "Reached an unreachable!"
    case 26: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit4
      var $684=$102;
      var $685=$103;
      var $686=$__tmp_i_i_i3;
      var $687=$104;
      var $688=$105;
      var $689=$106;
      var $690=$107;
      var $691=$__new_cap;
      var $692=Math.floor((($691)>>>0)/4);
      $__new_cap=$692;
      var $693=$147;
      var $694=$110;
      HEAP32[(($110)>>2)]=$693;
      var $695=HEAP32[(($110)>>2)];
      var $696=(($695)|0);
      var $697=$109;
      HEAP32[(($109)>>2)]=$696;
      var $698=HEAP32[(($109)>>2)];
      var $699=$698;
      var $700=$108;
      HEAP32[(($108)>>2)]=$699;
      var $701=HEAP32[(($108)>>2)];
      var $702=(($701)|0);
      var $703=$108;
      var $704=$109;
      var $705=HEAP32[(($702)>>2)];
      var $706=$110;
      var $707=$__n_off;
      var $708=(($705+($707<<2))|0);
      var $709=$148;
      HEAP32[(($709)>>2)]=$708;
      var $710=$147;
      var $711=$113;
      HEAP32[(($113)>>2)]=$710;
      var $712=HEAP32[(($113)>>2)];
      var $713=(($712)|0);
      var $714=$112;
      HEAP32[(($112)>>2)]=$713;
      var $715=HEAP32[(($112)>>2)];
      var $716=$715;
      var $717=$111;
      HEAP32[(($111)>>2)]=$716;
      var $718=HEAP32[(($111)>>2)];
      var $719=(($718)|0);
      var $720=$111;
      var $721=$112;
      var $722=HEAP32[(($719)>>2)];
      var $723=$113;
      var $724=$__new_cap;
      var $725=(($722+($724<<2))|0);
      var $726=$149;
      HEAP32[(($726)>>2)]=$725;
      STACKTOP = __stackBase__;
      return;
      var $728=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $729=$728.f0;
      $153=$729;
      var $730=$728.f1;
      $154=$730;
      __label__ = 32; break;
    case 27: // $767
      var $768=(($744)|0);
      var $769=$118;
      HEAP32[(($118)>>2)]=$768;
      var $770=HEAP32[(($118)>>2)];
      var $771=$770;
      var $772=$117;
      HEAP32[(($117)>>2)]=$771;
      var $773=HEAP32[(($117)>>2)];
      var $774=(($773+4)|0);
      var $775=$117;
      var $776=$118;
      var $777=HEAP32[(($774)>>2)];
      var $778=HEAP32[(($__tmp_i_i_i1)>>2)];
      var $779=$778;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$777]($779) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $780
      __label__ = 30; break;
    case 29: // $781
      var $782=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $783=$782.f0;
      HEAP32[(($125)>>2)]=$783;
      var $784=$782.f1;
      HEAP32[(($126)>>2)]=$784;
      var $785=HEAP32[(($125)>>2)];
      ___cxa_call_unexpected($785);
      throw "Reached an unreachable!"
    case 30: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit2
      var $786=$123;
      var $787=$124;
      var $788=$__tmp_i_i_i1;
      var $789=$125;
      var $790=$126;
      var $791=$127;
      var $792=$128;
      __label__ = 31; break;
    case 31: // $793
      __label__ = 32; break;
    case 32: // $794
      var $795=$143;
      HEAP32[(($143)>>2)]=$152;
      var $796=HEAP32[(($143)>>2)];
      var $797=$142;
      HEAP32[(($142)>>2)]=$796;
      var $798=HEAP32[(($142)>>2)];
      var $799=$138;
      var $800=$139;
      var $801=$__tmp_i_i_i;
      var $802=$140;
      var $803=$141;
      HEAP32[(($138)>>2)]=$798;
      HEAP32[(($139)>>2)]=0;
      var $804=HEAP32[(($138)>>2)];
      var $805=(($804)|0);
      var $806=$137;
      HEAP32[(($137)>>2)]=$805;
      var $807=HEAP32[(($137)>>2)];
      var $808=$807;
      var $809=$136;
      HEAP32[(($136)>>2)]=$808;
      var $810=HEAP32[(($136)>>2)];
      var $811=(($810)|0);
      var $812=$136;
      var $813=$137;
      var $814=HEAP32[(($811)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$814;
      var $815=HEAP32[(($139)>>2)];
      var $816=(($804)|0);
      var $817=$135;
      HEAP32[(($135)>>2)]=$816;
      var $818=HEAP32[(($135)>>2)];
      var $819=$818;
      var $820=$134;
      HEAP32[(($134)>>2)]=$819;
      var $821=HEAP32[(($134)>>2)];
      var $822=(($821)|0);
      var $823=$134;
      var $824=$135;
      HEAP32[(($822)>>2)]=$815;
      var $825=HEAP32[(($__tmp_i_i_i)>>2)];
      var $826=(($825)|0)!=0;
      if ($826) { __label__ = 33; break; } else { __label__ = 36; break; }
    case 33: // $827
      var $828=(($804)|0);
      var $829=$133;
      HEAP32[(($133)>>2)]=$828;
      var $830=HEAP32[(($133)>>2)];
      var $831=$830;
      var $832=$132;
      HEAP32[(($132)>>2)]=$831;
      var $833=HEAP32[(($132)>>2)];
      var $834=(($833+4)|0);
      var $835=$132;
      var $836=$133;
      var $837=HEAP32[(($834)>>2)];
      var $838=HEAP32[(($__tmp_i_i_i)>>2)];
      var $839=$838;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$837]($839) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $840
      __label__ = 36; break;
    case 35: // $841
      var $842=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $843=$842.f0;
      HEAP32[(($140)>>2)]=$843;
      var $844=$842.f1;
      HEAP32[(($141)>>2)]=$844;
      var $845=HEAP32[(($140)>>2)];
      ___cxa_call_unexpected($845);
      throw "Reached an unreachable!"
    case 36: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $846=$138;
      var $847=$139;
      var $848=$__tmp_i_i_i;
      var $849=$140;
      var $850=$141;
      var $851=$142;
      var $852=$143;
      __label__ = 37; break;
    case 37: // $853
      __label__ = 38; break;
    case 38: // $854
      var $855=$153;
      var $856=$153;
      var $857=$154;
      var $858=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $856, tempValue);
      var $859=($858.f1 = $857, $858);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
      var $861=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_["X"]=1;

function ___cxx_global_var_init30() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}

// WARNING: content after a branch in a label, line: 887877
// WARNING: content after a branch in a label, line: 887879
// WARNING: content after a branch in a label, line: 887880
// WARNING: content after a branch in a label, line: 887881
// WARNING: content after a branch in a label, line: 887882
// WARNING: content after a branch in a label, line: 887883

function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce($agg_result, $this, $__s, $__intl, $__iob, $__fl, $__units) {
  var __stackBase__  = STACKTOP; STACKTOP += 1444; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i22=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $__tmp_i_i_i20=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $__tmp_i18=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $49=__stackBase__+204;
      var $50=__stackBase__+208;
      var $51=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $62=__stackBase__+256;
      var $63=__stackBase__+260;
      var $64=__stackBase__+264;
      var $65=__stackBase__+268;
      var $66=__stackBase__+272;
      var $__tmp_i_i_i14=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $84=__stackBase__+348;
      var $85=__stackBase__+352;
      var $86=__stackBase__+356;
      var $87=__stackBase__+360;
      var $88=__stackBase__+364;
      var $89=__stackBase__+368;
      var $90=__stackBase__+372;
      var $91=__stackBase__+376;
      var $92=__stackBase__+380;
      var $93=__stackBase__+384;
      var $94=__stackBase__+388;
      var $95=__stackBase__+392;
      var $96=__stackBase__+396;
      var $97=__stackBase__+400;
      var $98=__stackBase__+404;
      var $99=__stackBase__+408;
      var $100=__stackBase__+412;
      var $101=__stackBase__+416;
      var $102=__stackBase__+420;
      var $103=__stackBase__+424;
      var $104=__stackBase__+428;
      var $105=__stackBase__+432;
      var $106=__stackBase__+436;
      var $107=__stackBase__+440;
      var $108=__stackBase__+444;
      var $109=__stackBase__+448;
      var $110=__stackBase__+452;
      var $111=__stackBase__+456;
      var $112=__stackBase__+460;
      var $113=__stackBase__+464;
      var $114=__stackBase__+468;
      var $115=__stackBase__+472;
      var $116=__stackBase__+476;
      var $117=__stackBase__+480;
      var $118=__stackBase__+484;
      var $119=__stackBase__+488;
      var $__tmp_i_i_i11=__stackBase__+492;
      var $120=__stackBase__+496;
      var $121=__stackBase__+500;
      var $122=__stackBase__+504;
      var $123=__stackBase__+508;
      var $124=__stackBase__+512;
      var $125=__stackBase__+516;
      var $126=__stackBase__+520;
      var $__a_i_i_i8=__stackBase__+524;
      var $__i_i_i_i9=__stackBase__+528;
      var $127=__stackBase__+532;
      var $128=__stackBase__+536;
      var $129=__stackBase__+540;
      var $130=__stackBase__+544;
      var $131=__stackBase__+548;
      var $132=__stackBase__+552;
      var $133=__stackBase__+556;
      var $134=__stackBase__+560;
      var $135=__stackBase__+564;
      var $__a_i_i_i5=__stackBase__+568;
      var $__i_i_i_i6=__stackBase__+572;
      var $136=__stackBase__+576;
      var $137=__stackBase__+580;
      var $138=__stackBase__+584;
      var $139=__stackBase__+588;
      var $140=__stackBase__+592;
      var $141=__stackBase__+596;
      var $142=__stackBase__+600;
      var $143=__stackBase__+604;
      var $144=__stackBase__+608;
      var $145=__stackBase__+612;
      var $146=__stackBase__+616;
      var $147=__stackBase__+620;
      var $148=__stackBase__+624;
      var $149=__stackBase__+628;
      var $__tmp_i_i_i3=__stackBase__+632;
      var $150=__stackBase__+636;
      var $151=__stackBase__+640;
      var $152=__stackBase__+644;
      var $153=__stackBase__+648;
      var $154=__stackBase__+652;
      var $155=__stackBase__+656;
      var $156=__stackBase__+660;
      var $__a_i_i_i=__stackBase__+664;
      var $__i_i_i_i=__stackBase__+668;
      var $157=__stackBase__+672;
      var $158=__stackBase__+676;
      var $159=__stackBase__+680;
      var $160=__stackBase__+684;
      var $161=__stackBase__+688;
      var $162=__stackBase__+692;
      var $163=__stackBase__+696;
      var $164=__stackBase__+700;
      var $165=__stackBase__+704;
      var $166=__stackBase__+708;
      var $167=__stackBase__+712;
      var $168=__stackBase__+716;
      var $169=__stackBase__+720;
      var $170=__stackBase__+724;
      var $171=__stackBase__+728;
      var $172=__stackBase__+732;
      var $173=__stackBase__+736;
      var $174=__stackBase__+740;
      var $175=__stackBase__+744;
      var $176=__stackBase__+748;
      var $177=__stackBase__+752;
      var $178=__stackBase__+756;
      var $179=__stackBase__+760;
      var $180=__stackBase__+764;
      var $181=__stackBase__+768;
      var $__tmp_i1=__stackBase__+772;
      var $182=__stackBase__+776;
      var $183=__stackBase__+780;
      var $184=__stackBase__+784;
      var $185=__stackBase__+788;
      var $186=__stackBase__+792;
      var $187=__stackBase__+796;
      var $188=__stackBase__+800;
      var $189=__stackBase__+804;
      var $190=__stackBase__+808;
      var $191=__stackBase__+812;
      var $__tmp_i=__stackBase__+816;
      var $192=__stackBase__+820;
      var $193=__stackBase__+824;
      var $194=__stackBase__+828;
      var $195=__stackBase__+832;
      var $196=__stackBase__+836;
      var $197=__stackBase__+840;
      var $198=__stackBase__+844;
      var $199=__stackBase__+848;
      var $200=__stackBase__+852;
      var $201=__stackBase__+856;
      var $202=__stackBase__+860;
      var $203=__stackBase__+864;
      var $204=__stackBase__+868;
      var $205=__stackBase__+872;
      var $206=__stackBase__+876;
      var $207=__stackBase__+880;
      var $208=__stackBase__+884;
      var $209=__stackBase__+888;
      var $210=__stackBase__+892;
      var $211=__stackBase__+896;
      var $212=__stackBase__+900;
      var $213=__stackBase__+904;
      var $214=__stackBase__+908;
      var $215=__stackBase__+912;
      var $216=__stackBase__+916;
      var $217=__stackBase__+920;
      var $218=__stackBase__+924;
      var $219=__stackBase__+928;
      var $220=__stackBase__+932;
      var $221=__stackBase__+936;
      var $222=__stackBase__+940;
      var $__tmp_i_i_i=__stackBase__+944;
      var $223=__stackBase__+948;
      var $224=__stackBase__+952;
      var $225=__stackBase__+956;
      var $226=__stackBase__+960;
      var $227=__stackBase__+964;
      var $228=__stackBase__+968;
      var $229=__stackBase__+972;
      var $230=__stackBase__+976;
      var $231=__stackBase__+980;
      var $232=__stackBase__+984;
      var $233=__stackBase__+988;
      var $234=__stackBase__+992;
      var $235=__stackBase__+996;
      var $236=__stackBase__+1000;
      var $237=__stackBase__+1004;
      var $238=__stackBase__+1008;
      var $239=__stackBase__+1012;
      var $240=__stackBase__+1016;
      var $241=__stackBase__+1020;
      var $242=__stackBase__+1024;
      var $243=__stackBase__+1028;
      var $244=__stackBase__+1032;
      var $245=__stackBase__+1036;
      var $246=__stackBase__+1040;
      var $247=__stackBase__+1044;
      var $248;
      var $249;
      var $250;
      var $251;
      var $252;
      var $__bs;
      var $__buf=__stackBase__+1048;
      var $__bb=__stackBase__+1148;
      var $__digits=__stackBase__+1152;
      var $__db;
      var $__n;
      var $__hn=__stackBase__+1252;
      var $__hd=__stackBase__+1260;
      var $253;
      var $254;
      var $__loc=__stackBase__+1268;
      var $__ct;
      var $__neg;
      var $__pat=__stackBase__+1272;
      var $__dp=__stackBase__+1276;
      var $__ts=__stackBase__+1280;
      var $__grp=__stackBase__+1284;
      var $__sym=__stackBase__+1296;
      var $__sn=__stackBase__+1308;
      var $__fd=__stackBase__+1320;
      var $__mbuf=__stackBase__+1324;
      var $__mb;
      var $__hw=__stackBase__+1424;
      var $__exn;
      var $__mi=__stackBase__+1432;
      var $__me=__stackBase__+1436;
      var $255=__stackBase__+1440;
      var $256;
      $248=$this;
      var $257=(($__intl)&1);
      $249=$257;
      $250=$__iob;
      $251=$__fl;
      $252=$__units;
      var $258=$248;
      $__bs=100;
      var $259=(($__buf)|0);
      HEAP32[(($__bb)>>2)]=$259;
      var $260=(($__digits)|0);
      $__db=$260;
      var $261=HEAP32[(($__bb)>>2)];
      var $262=$252;
      var $263=_snprintf($261, 100, ((STRING_TABLE.__str31250)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$262,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__n=$263;
      var $264=$245;
      var $265=$246;
      var $266=$247;
      HEAP32[(($245)>>2)]=$__hn;
      HEAP32[(($246)>>2)]=0;
      HEAP32[(($247)>>2)]=1496;
      var $267=HEAP32[(($245)>>2)];
      var $268=HEAP32[(($246)>>2)];
      var $269=HEAP32[(($247)>>2)];
      var $270=$242;
      var $271=$243;
      var $272=$244;
      HEAP32[(($242)>>2)]=$267;
      HEAP32[(($243)>>2)]=$268;
      HEAP32[(($244)>>2)]=$269;
      var $273=HEAP32[(($242)>>2)];
      var $274=(($273)|0);
      var $275=$241;
      HEAP32[(($241)>>2)]=$243;
      var $276=HEAP32[(($241)>>2)];
      var $277=$241;
      var $278=HEAP32[(($276)>>2)];
      var $279=$227;
      HEAP32[(($227)>>2)]=$244;
      var $280=HEAP32[(($227)>>2)];
      var $281=$227;
      var $282=HEAP32[(($280)>>2)];
      var $283=$238;
      var $284=$239;
      var $285=$240;
      HEAP32[(($238)>>2)]=$274;
      HEAP32[(($239)>>2)]=$278;
      HEAP32[(($240)>>2)]=$282;
      var $286=HEAP32[(($238)>>2)];
      var $287=HEAP32[(($239)>>2)];
      var $288=HEAP32[(($240)>>2)];
      var $289=$235;
      var $290=$236;
      var $291=$237;
      HEAP32[(($235)>>2)]=$286;
      HEAP32[(($236)>>2)]=$287;
      HEAP32[(($237)>>2)]=$288;
      var $292=HEAP32[(($235)>>2)];
      var $293=$292;
      var $294=$234;
      HEAP32[(($234)>>2)]=$236;
      var $295=HEAP32[(($234)>>2)];
      var $296=$234;
      var $297=HEAP32[(($295)>>2)];
      var $298=$228;
      HEAP32[(($228)>>2)]=$237;
      var $299=HEAP32[(($228)>>2)];
      var $300=$228;
      var $301=HEAP32[(($299)>>2)];
      var $302=$231;
      var $303=$232;
      var $304=$233;
      HEAP32[(($231)>>2)]=$293;
      HEAP32[(($232)>>2)]=$297;
      HEAP32[(($233)>>2)]=$301;
      var $305=HEAP32[(($231)>>2)];
      var $306=(($305)|0);
      var $307=$230;
      HEAP32[(($230)>>2)]=$232;
      var $308=HEAP32[(($230)>>2)];
      var $309=$230;
      var $310=HEAP32[(($308)>>2)];
      HEAP32[(($306)>>2)]=$310;
      var $311=(($305+4)|0);
      var $312=$229;
      HEAP32[(($229)>>2)]=$233;
      var $313=HEAP32[(($229)>>2)];
      var $314=$229;
      var $315=HEAP32[(($313)>>2)];
      HEAP32[(($311)>>2)]=$315;
      var $316=$231;
      var $317=$232;
      var $318=$233;
      var $319=$235;
      var $320=$236;
      var $321=$237;
      var $322=$238;
      var $323=$239;
      var $324=$240;
      var $325=$242;
      var $326=$243;
      var $327=$244;
      var $328=$245;
      var $329=$246;
      var $330=$247;
      var $331=$212;
      var $332=$213;
      var $333=$214;
      HEAP32[(($212)>>2)]=$__hd;
      HEAP32[(($213)>>2)]=0;
      HEAP32[(($214)>>2)]=1496;
      var $334=HEAP32[(($212)>>2)];
      var $335=HEAP32[(($213)>>2)];
      var $336=HEAP32[(($214)>>2)];
      var $337=$209;
      var $338=$210;
      var $339=$211;
      HEAP32[(($209)>>2)]=$334;
      HEAP32[(($210)>>2)]=$335;
      HEAP32[(($211)>>2)]=$336;
      var $340=HEAP32[(($209)>>2)];
      var $341=(($340)|0);
      var $342=$208;
      HEAP32[(($208)>>2)]=$210;
      var $343=HEAP32[(($208)>>2)];
      var $344=$208;
      var $345=HEAP32[(($343)>>2)];
      var $346=$194;
      HEAP32[(($194)>>2)]=$211;
      var $347=HEAP32[(($194)>>2)];
      var $348=$194;
      var $349=HEAP32[(($347)>>2)];
      var $350=$205;
      var $351=$206;
      var $352=$207;
      HEAP32[(($205)>>2)]=$341;
      HEAP32[(($206)>>2)]=$345;
      HEAP32[(($207)>>2)]=$349;
      var $353=HEAP32[(($205)>>2)];
      var $354=HEAP32[(($206)>>2)];
      var $355=HEAP32[(($207)>>2)];
      var $356=$202;
      var $357=$203;
      var $358=$204;
      HEAP32[(($202)>>2)]=$353;
      HEAP32[(($203)>>2)]=$354;
      HEAP32[(($204)>>2)]=$355;
      var $359=HEAP32[(($202)>>2)];
      var $360=$359;
      var $361=$201;
      HEAP32[(($201)>>2)]=$203;
      var $362=HEAP32[(($201)>>2)];
      var $363=$201;
      var $364=HEAP32[(($362)>>2)];
      var $365=$195;
      HEAP32[(($195)>>2)]=$204;
      var $366=HEAP32[(($195)>>2)];
      var $367=$195;
      var $368=HEAP32[(($366)>>2)];
      var $369=$198;
      var $370=$199;
      var $371=$200;
      HEAP32[(($198)>>2)]=$360;
      HEAP32[(($199)>>2)]=$364;
      HEAP32[(($200)>>2)]=$368;
      var $372=HEAP32[(($198)>>2)];
      var $373=(($372)|0);
      var $374=$197;
      HEAP32[(($197)>>2)]=$199;
      var $375=HEAP32[(($197)>>2)];
      var $376=$197;
      var $377=HEAP32[(($375)>>2)];
      HEAP32[(($373)>>2)]=$377;
      var $378=(($372+4)|0);
      var $379=$196;
      HEAP32[(($196)>>2)]=$200;
      var $380=HEAP32[(($196)>>2)];
      var $381=$196;
      var $382=HEAP32[(($380)>>2)];
      HEAP32[(($378)>>2)]=$382;
      var $383=$198;
      var $384=$199;
      var $385=$200;
      var $386=$202;
      var $387=$203;
      var $388=$204;
      var $389=$205;
      var $390=$206;
      var $391=$207;
      var $392=$209;
      var $393=$210;
      var $394=$211;
      var $395=$212;
      var $396=$213;
      var $397=$214;
      __label__ = 1; break;
    case 1: // $398
      var $399=$__n;
      var $400=(($399)>>>0) > 99;
      if ($400) { __label__ = 2; break; } else { __label__ = 23; break; }
    case 2: // $401
      var $402=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $403
      var $404=$252;
      var $405=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__bb, $402, ((STRING_TABLE.__str31250)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$404,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $406
      $__n=$405;
      var $407=HEAP32[(($__bb)>>2)];
      var $408=(($407)|0)==0;
      if ($408) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $409
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $410
      __label__ = 8; break;
    case 7: // $415
      var $416=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $417=$416.f0;
      $253=$417;
      var $418=$416.f1;
      $254=$418;
      __label__ = 108; break;
    case 8: // $419
      var $420=HEAP32[(($__bb)>>2)];
      var $421=$190;
      var $422=$191;
      var $423=$__tmp_i;
      var $424=$192;
      var $425=$193;
      HEAP32[(($190)>>2)]=$__hn;
      HEAP32[(($191)>>2)]=$420;
      var $426=HEAPU32[(($190)>>2)];
      var $427=(($426)|0);
      var $428=$189;
      HEAP32[(($189)>>2)]=$427;
      var $429=HEAP32[(($189)>>2)];
      var $430=$429;
      var $431=$188;
      HEAP32[(($188)>>2)]=$430;
      var $432=HEAP32[(($188)>>2)];
      var $433=(($432)|0);
      var $434=$188;
      var $435=$189;
      var $436=HEAP32[(($433)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$436;
      var $437=HEAP32[(($191)>>2)];
      var $438=(($426)|0);
      var $439=$187;
      HEAP32[(($187)>>2)]=$438;
      var $440=HEAP32[(($187)>>2)];
      var $441=$440;
      var $442=$186;
      HEAP32[(($186)>>2)]=$441;
      var $443=HEAP32[(($186)>>2)];
      var $444=(($443)|0);
      var $445=$186;
      var $446=$187;
      HEAP32[(($444)>>2)]=$437;
      var $447=HEAP32[(($__tmp_i)>>2)];
      var $448=(($447)|0)!=0;
      if ($448) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $449
      var $450=(($426)|0);
      var $451=$185;
      HEAP32[(($185)>>2)]=$450;
      var $452=HEAP32[(($185)>>2)];
      var $453=$452;
      var $454=$184;
      HEAP32[(($184)>>2)]=$453;
      var $455=HEAP32[(($184)>>2)];
      var $456=(($455+4)|0);
      var $457=$184;
      var $458=$185;
      var $459=HEAP32[(($456)>>2)];
      var $460=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$459]($460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $461
      __label__ = 12; break;
    case 11: // $462
      var $463=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $464=$463.f0;
      HEAP32[(($192)>>2)]=$464;
      var $465=$463.f1;
      HEAP32[(($193)>>2)]=$465;
      var $466=HEAP32[(($192)>>2)];
      ___cxa_call_unexpected($466);
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $467=$190;
      var $468=$191;
      var $469=$__tmp_i;
      var $470=$192;
      var $471=$193;
      var $472=$__n;
      var $473=(($472)|0);
      var $474=_malloc($473);
      var $475=$180;
      var $476=$181;
      var $477=$__tmp_i1;
      var $478=$182;
      var $479=$183;
      HEAP32[(($180)>>2)]=$__hd;
      HEAP32[(($181)>>2)]=$474;
      var $480=HEAP32[(($180)>>2)];
      var $481=(($480)|0);
      var $482=$179;
      HEAP32[(($179)>>2)]=$481;
      var $483=HEAP32[(($179)>>2)];
      var $484=$483;
      var $485=$178;
      HEAP32[(($178)>>2)]=$484;
      var $486=HEAP32[(($178)>>2)];
      var $487=(($486)|0);
      var $488=$178;
      var $489=$179;
      var $490=HEAP32[(($487)>>2)];
      HEAP32[(($__tmp_i1)>>2)]=$490;
      var $491=HEAP32[(($181)>>2)];
      var $492=(($480)|0);
      var $493=$177;
      HEAP32[(($177)>>2)]=$492;
      var $494=HEAP32[(($177)>>2)];
      var $495=$494;
      var $496=$176;
      HEAP32[(($176)>>2)]=$495;
      var $497=HEAP32[(($176)>>2)];
      var $498=(($497)|0);
      var $499=$176;
      var $500=$177;
      HEAP32[(($498)>>2)]=$491;
      var $501=HEAP32[(($__tmp_i1)>>2)];
      var $502=(($501)|0)!=0;
      if ($502) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $503
      var $504=(($480)|0);
      var $505=$175;
      HEAP32[(($175)>>2)]=$504;
      var $506=HEAP32[(($175)>>2)];
      var $507=$506;
      var $508=$174;
      HEAP32[(($174)>>2)]=$507;
      var $509=HEAP32[(($174)>>2)];
      var $510=(($509+4)|0);
      var $511=$174;
      var $512=$175;
      var $513=HEAP32[(($510)>>2)];
      var $514=HEAP32[(($__tmp_i1)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$513]($514) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $515
      __label__ = 16; break;
    case 15: // $516
      var $517=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $518=$517.f0;
      HEAP32[(($182)>>2)]=$518;
      var $519=$517.f1;
      HEAP32[(($183)>>2)]=$519;
      var $520=HEAP32[(($182)>>2)];
      ___cxa_call_unexpected($520);
      throw "Reached an unreachable!"
    case 16: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit2
      var $521=$180;
      var $522=$181;
      var $523=$__tmp_i1;
      var $524=$182;
      var $525=$183;
      var $526=$173;
      HEAP32[(($173)>>2)]=$__hd;
      var $527=HEAP32[(($173)>>2)];
      var $528=(($527)|0);
      var $529=$172;
      HEAP32[(($172)>>2)]=$528;
      var $530=HEAP32[(($172)>>2)];
      var $531=$530;
      var $532=$171;
      HEAP32[(($171)>>2)]=$531;
      var $533=HEAP32[(($171)>>2)];
      var $534=(($533)|0);
      var $535=$171;
      var $536=$172;
      var $537=HEAP32[(($534)>>2)];
      var $538=(($537)|0)!=0;
      if ($538) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $539
      var $541 = 0;__label__ = 19; break;
    case 18: // $540
      var $541 = -1;__label__ = 19; break;
    case 19: // $_ZNKSt3__110unique_ptrIcPFvPvEEcvMNS4_5__natEiEv_exit
      var $541;
      var $542=$173;
      var $543=(($541)|0)==-1;
      if ($543) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $544
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 7; break; }
    case 21: // $545
      __label__ = 22; break;
    case 22: // $546
      var $547=$170;
      HEAP32[(($170)>>2)]=$__hd;
      var $548=HEAP32[(($170)>>2)];
      var $549=(($548)|0);
      var $550=$169;
      HEAP32[(($169)>>2)]=$549;
      var $551=HEAP32[(($169)>>2)];
      var $552=$551;
      var $553=$168;
      HEAP32[(($168)>>2)]=$552;
      var $554=HEAP32[(($168)>>2)];
      var $555=(($554)|0);
      var $556=$168;
      var $557=$169;
      var $558=HEAP32[(($555)>>2)];
      var $559=$170;
      $__db=$558;
      __label__ = 23; break;
    case 23: // $560
      var $561=$250;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($__loc, $561) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 7; break; }
    case 24: // $562
      var $563=$167;
      HEAP32[(($167)>>2)]=$__loc;
      var $564=HEAP32[(($167)>>2)];
      var $565=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($564, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 67; break; };
    case 25: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $566=$565;
      var $567=$167;
      __label__ = 26; break;
    case 26: // $568
      $__ct=$566;
      var $569=$__ct;
      var $570=HEAP32[(($__bb)>>2)];
      var $571=HEAP32[(($__bb)>>2)];
      var $572=$__n;
      var $573=(($571+$572)|0);
      var $574=$__db;
      var $575=$163;
      var $576=$164;
      var $577=$165;
      var $578=$166;
      HEAP32[(($163)>>2)]=$569;
      HEAP32[(($164)>>2)]=$570;
      HEAP32[(($165)>>2)]=$573;
      HEAP32[(($166)>>2)]=$574;
      var $579=HEAP32[(($163)>>2)];
      var $580=$579;
      var $581=HEAP32[(($580)>>2)];
      var $582=(($581+32)|0);
      var $583=HEAP32[(($582)>>2)];
      var $584=HEAP32[(($164)>>2)];
      var $585=HEAP32[(($165)>>2)];
      var $586=HEAP32[(($166)>>2)];
      var $587=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$583]($579, $584, $585, $586) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 67; break; };
    case 27: // $_ZNKSt3__15ctypeIcE5widenEPKcS3_Pc_exit
      var $588=$163;
      var $589=$164;
      var $590=$165;
      var $591=$166;
      __label__ = 28; break;
    case 28: // $592
      var $593=$__n;
      var $594=(($593)>>>0) > 0;
      if ($594) { __label__ = 29; break; } else { var $602 = 0;__label__ = 30; break; }
    case 29: // $595
      var $596=HEAP32[(($__bb)>>2)];
      var $597=(($596)|0);
      var $598=HEAP8[($597)];
      var $599=(($598 << 24) >> 24);
      var $600=(($599)|0)==45;
      var $602 = $600;__label__ = 30; break;
    case 30: // $601
      var $602;
      var $603=(($602)&1);
      $__neg=$603;
      var $604=$162;
      HEAP32[(($162)>>2)]=$__grp;
      var $605=HEAP32[(($162)>>2)];
      var $606=$161;
      HEAP32[(($161)>>2)]=$605;
      var $607=HEAPU32[(($161)>>2)];
      var $608=$607;
      var $609=(($607)|0);
      var $610=$160;
      HEAP32[(($160)>>2)]=$609;
      var $611=HEAP32[(($160)>>2)];
      var $612=$159;
      HEAP32[(($159)>>2)]=$611;
      var $613=HEAP32[(($159)>>2)];
      var $614=$613;
      var $615=$158;
      HEAP32[(($158)>>2)]=$614;
      var $616=HEAP32[(($158)>>2)];
      var $617=$616;
      var $618=$157;
      HEAP32[(($157)>>2)]=$617;
      var $619=HEAP32[(($157)>>2)];
      var $620=$157;
      var $621=(($616)|0);
      var $622=$158;
      var $623=$159;
      var $624=$160;
      var $625=$156;
      var $626=$__a_i_i_i;
      var $627=$__i_i_i_i;
      HEAP32[(($156)>>2)]=$607;
      var $628=HEAP32[(($156)>>2)];
      var $629=(($628)|0);
      var $630=$155;
      HEAP32[(($155)>>2)]=$629;
      var $631=HEAP32[(($155)>>2)];
      var $632=$631;
      var $633=$154;
      HEAP32[(($154)>>2)]=$632;
      var $634=HEAP32[(($154)>>2)];
      var $635=(($634)|0);
      var $636=$154;
      var $637=$155;
      var $638=(($635)|0);
      var $639=$638;
      var $640=(($639)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$640;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 31; break;
    case 31: // $641
      var $642=HEAPU32[(($__i_i_i_i)>>2)];
      var $643=(($642)>>>0) < 3;
      if ($643) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $644
      var $645=HEAP32[(($__i_i_i_i)>>2)];
      var $646=HEAP32[(($__a_i_i_i)>>2)];
      var $647=(($646+($645<<2))|0);
      HEAP32[(($647)>>2)]=0;
      var $648=HEAP32[(($__i_i_i_i)>>2)];
      var $649=(($648+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$649;
      __label__ = 31; break;
    case 33: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $650=$156;
      var $651=$__a_i_i_i;
      var $652=$__i_i_i_i;
      var $653=$161;
      var $654=$162;
      __label__ = 34; break;
    case 34: // $655
      var $656=$141;
      HEAP32[(($141)>>2)]=$__sym;
      var $657=HEAP32[(($141)>>2)];
      var $658=$140;
      HEAP32[(($140)>>2)]=$657;
      var $659=HEAPU32[(($140)>>2)];
      var $660=$659;
      var $661=(($659)|0);
      var $662=$139;
      HEAP32[(($139)>>2)]=$661;
      var $663=HEAP32[(($139)>>2)];
      var $664=$138;
      HEAP32[(($138)>>2)]=$663;
      var $665=HEAP32[(($138)>>2)];
      var $666=$665;
      var $667=$137;
      HEAP32[(($137)>>2)]=$666;
      var $668=HEAP32[(($137)>>2)];
      var $669=$668;
      var $670=$136;
      HEAP32[(($136)>>2)]=$669;
      var $671=HEAP32[(($136)>>2)];
      var $672=$136;
      var $673=(($668)|0);
      var $674=$137;
      var $675=$138;
      var $676=$139;
      var $677=$135;
      var $678=$__a_i_i_i5;
      var $679=$__i_i_i_i6;
      HEAP32[(($135)>>2)]=$659;
      var $680=HEAP32[(($135)>>2)];
      var $681=(($680)|0);
      var $682=$134;
      HEAP32[(($134)>>2)]=$681;
      var $683=HEAP32[(($134)>>2)];
      var $684=$683;
      var $685=$133;
      HEAP32[(($133)>>2)]=$684;
      var $686=HEAP32[(($133)>>2)];
      var $687=(($686)|0);
      var $688=$133;
      var $689=$134;
      var $690=(($687)|0);
      var $691=$690;
      var $692=(($691)|0);
      HEAP32[(($__a_i_i_i5)>>2)]=$692;
      HEAP32[(($__i_i_i_i6)>>2)]=0;
      __label__ = 35; break;
    case 35: // $693
      var $694=HEAPU32[(($__i_i_i_i6)>>2)];
      var $695=(($694)>>>0) < 3;
      if ($695) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $696
      var $697=HEAP32[(($__i_i_i_i6)>>2)];
      var $698=HEAP32[(($__a_i_i_i5)>>2)];
      var $699=(($698+($697<<2))|0);
      HEAP32[(($699)>>2)]=0;
      var $700=HEAP32[(($__i_i_i_i6)>>2)];
      var $701=(($700+1)|0);
      HEAP32[(($__i_i_i_i6)>>2)]=$701;
      __label__ = 35; break;
    case 37: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit7
      var $702=$135;
      var $703=$__a_i_i_i5;
      var $704=$__i_i_i_i6;
      var $705=$140;
      var $706=$141;
      __label__ = 38; break;
    case 38: // $707
      var $708=$132;
      HEAP32[(($132)>>2)]=$__sn;
      var $709=HEAP32[(($132)>>2)];
      var $710=$131;
      HEAP32[(($131)>>2)]=$709;
      var $711=HEAPU32[(($131)>>2)];
      var $712=$711;
      var $713=(($711)|0);
      var $714=$130;
      HEAP32[(($130)>>2)]=$713;
      var $715=HEAP32[(($130)>>2)];
      var $716=$129;
      HEAP32[(($129)>>2)]=$715;
      var $717=HEAP32[(($129)>>2)];
      var $718=$717;
      var $719=$128;
      HEAP32[(($128)>>2)]=$718;
      var $720=HEAP32[(($128)>>2)];
      var $721=$720;
      var $722=$127;
      HEAP32[(($127)>>2)]=$721;
      var $723=HEAP32[(($127)>>2)];
      var $724=$127;
      var $725=(($720)|0);
      var $726=$128;
      var $727=$129;
      var $728=$130;
      var $729=$126;
      var $730=$__a_i_i_i8;
      var $731=$__i_i_i_i9;
      HEAP32[(($126)>>2)]=$711;
      var $732=HEAP32[(($126)>>2)];
      var $733=(($732)|0);
      var $734=$125;
      HEAP32[(($125)>>2)]=$733;
      var $735=HEAP32[(($125)>>2)];
      var $736=$735;
      var $737=$124;
      HEAP32[(($124)>>2)]=$736;
      var $738=HEAP32[(($124)>>2)];
      var $739=(($738)|0);
      var $740=$124;
      var $741=$125;
      var $742=(($739)|0);
      var $743=$742;
      var $744=(($743)|0);
      HEAP32[(($__a_i_i_i8)>>2)]=$744;
      HEAP32[(($__i_i_i_i9)>>2)]=0;
      __label__ = 39; break;
    case 39: // $745
      var $746=HEAPU32[(($__i_i_i_i9)>>2)];
      var $747=(($746)>>>0) < 3;
      if ($747) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $748
      var $749=HEAP32[(($__i_i_i_i9)>>2)];
      var $750=HEAP32[(($__a_i_i_i8)>>2)];
      var $751=(($750+($749<<2))|0);
      HEAP32[(($751)>>2)]=0;
      var $752=HEAP32[(($__i_i_i_i9)>>2)];
      var $753=(($752+1)|0);
      HEAP32[(($__i_i_i_i9)>>2)]=$753;
      __label__ = 39; break;
    case 41: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit10
      var $754=$126;
      var $755=$__a_i_i_i8;
      var $756=$__i_i_i_i9;
      var $757=$131;
      var $758=$132;
      __label__ = 42; break;
    case 42: // $759
      var $760=$249;
      var $761=(($760) & 1);
      var $762=$__neg;
      var $763=(($762) & 1);
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri($761, $763, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 70; break; }
    case 43: // $764
      var $765=(($__mbuf)|0);
      $__mb=$765;
      var $766=$109;
      var $767=$110;
      var $768=$111;
      HEAP32[(($109)>>2)]=$__hw;
      HEAP32[(($110)>>2)]=0;
      HEAP32[(($111)>>2)]=1496;
      var $769=HEAP32[(($109)>>2)];
      var $770=HEAP32[(($110)>>2)];
      var $771=HEAP32[(($111)>>2)];
      var $772=$106;
      var $773=$107;
      var $774=$108;
      HEAP32[(($106)>>2)]=$769;
      HEAP32[(($107)>>2)]=$770;
      HEAP32[(($108)>>2)]=$771;
      var $775=HEAP32[(($106)>>2)];
      var $776=(($775)|0);
      var $777=$105;
      HEAP32[(($105)>>2)]=$107;
      var $778=HEAP32[(($105)>>2)];
      var $779=$105;
      var $780=HEAP32[(($778)>>2)];
      var $781=$91;
      HEAP32[(($91)>>2)]=$108;
      var $782=HEAP32[(($91)>>2)];
      var $783=$91;
      var $784=HEAP32[(($782)>>2)];
      var $785=$102;
      var $786=$103;
      var $787=$104;
      HEAP32[(($102)>>2)]=$776;
      HEAP32[(($103)>>2)]=$780;
      HEAP32[(($104)>>2)]=$784;
      var $788=HEAP32[(($102)>>2)];
      var $789=HEAP32[(($103)>>2)];
      var $790=HEAP32[(($104)>>2)];
      var $791=$99;
      var $792=$100;
      var $793=$101;
      HEAP32[(($99)>>2)]=$788;
      HEAP32[(($100)>>2)]=$789;
      HEAP32[(($101)>>2)]=$790;
      var $794=HEAP32[(($99)>>2)];
      var $795=$794;
      var $796=$98;
      HEAP32[(($98)>>2)]=$100;
      var $797=HEAP32[(($98)>>2)];
      var $798=$98;
      var $799=HEAP32[(($797)>>2)];
      var $800=$92;
      HEAP32[(($92)>>2)]=$101;
      var $801=HEAP32[(($92)>>2)];
      var $802=$92;
      var $803=HEAP32[(($801)>>2)];
      var $804=$95;
      var $805=$96;
      var $806=$97;
      HEAP32[(($95)>>2)]=$795;
      HEAP32[(($96)>>2)]=$799;
      HEAP32[(($97)>>2)]=$803;
      var $807=HEAP32[(($95)>>2)];
      var $808=(($807)|0);
      var $809=$94;
      HEAP32[(($94)>>2)]=$96;
      var $810=HEAP32[(($94)>>2)];
      var $811=$94;
      var $812=HEAP32[(($810)>>2)];
      HEAP32[(($808)>>2)]=$812;
      var $813=(($807+4)|0);
      var $814=$93;
      HEAP32[(($93)>>2)]=$97;
      var $815=HEAP32[(($93)>>2)];
      var $816=$93;
      var $817=HEAP32[(($815)>>2)];
      HEAP32[(($813)>>2)]=$817;
      var $818=$95;
      var $819=$96;
      var $820=$97;
      var $821=$99;
      var $822=$100;
      var $823=$101;
      var $824=$102;
      var $825=$103;
      var $826=$104;
      var $827=$106;
      var $828=$107;
      var $829=$108;
      var $830=$109;
      var $831=$110;
      var $832=$111;
      __label__ = 44; break;
    case 44: // $833
      var $834=$__n;
      var $835=HEAP32[(($__fd)>>2)];
      var $836=(($834)|0) > (($835)|0);
      if ($836) { __label__ = 45; break; } else { __label__ = 52; break; }
    case 45: // $837
      var $838=$__n;
      var $839=HEAP32[(($__fd)>>2)];
      var $840=(($838-$839)|0);
      var $841=((($840<<1))|0);
      var $842=$90;
      HEAP32[(($90)>>2)]=$__sn;
      var $843=HEAPU32[(($90)>>2)];
      var $844=$89;
      HEAP32[(($89)>>2)]=$843;
      var $845=HEAP32[(($89)>>2)];
      var $846=(($845)|0);
      var $847=$88;
      HEAP32[(($88)>>2)]=$846;
      var $848=HEAP32[(($88)>>2)];
      var $849=$848;
      var $850=$87;
      HEAP32[(($87)>>2)]=$849;
      var $851=HEAP32[(($87)>>2)];
      var $852=(($851)|0);
      var $853=$87;
      var $854=$88;
      var $855=(($852)|0);
      var $856=$855;
      var $857=(($856)|0);
      var $858=$857;
      var $859=HEAPU8[($858)];
      var $860=(($859)&255);
      var $861=$860 & 1;
      var $862=(($861)|0)!=0;
      var $863=$89;
      if ($862) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $864
      var $865=$83;
      HEAP32[(($83)>>2)]=$843;
      var $866=HEAP32[(($83)>>2)];
      var $867=(($866)|0);
      var $868=$82;
      HEAP32[(($82)>>2)]=$867;
      var $869=HEAP32[(($82)>>2)];
      var $870=$869;
      var $871=$81;
      HEAP32[(($81)>>2)]=$870;
      var $872=HEAP32[(($81)>>2)];
      var $873=(($872)|0);
      var $874=$81;
      var $875=$82;
      var $876=(($873)|0);
      var $877=$876;
      var $878=(($877+4)|0);
      var $879=HEAP32[(($878)>>2)];
      var $880=$83;
      var $901 = $879;__label__ = 48; break;
    case 47: // $881
      var $882=$86;
      HEAP32[(($86)>>2)]=$843;
      var $883=HEAP32[(($86)>>2)];
      var $884=(($883)|0);
      var $885=$85;
      HEAP32[(($85)>>2)]=$884;
      var $886=HEAP32[(($85)>>2)];
      var $887=$886;
      var $888=$84;
      HEAP32[(($84)>>2)]=$887;
      var $889=HEAP32[(($84)>>2)];
      var $890=(($889)|0);
      var $891=$84;
      var $892=$85;
      var $893=(($890)|0);
      var $894=$893;
      var $895=(($894)|0);
      var $896=$895;
      var $897=HEAPU8[($896)];
      var $898=(($897)&255);
      var $899=$898 >> 1;
      var $900=$86;
      var $901 = $899;__label__ = 48; break;
    case 48: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $901;
      var $902=$90;
      var $903=(($841+$901)|0);
      var $904=$80;
      HEAP32[(($80)>>2)]=$__sym;
      var $905=HEAPU32[(($80)>>2)];
      var $906=$79;
      HEAP32[(($79)>>2)]=$905;
      var $907=HEAP32[(($79)>>2)];
      var $908=(($907)|0);
      var $909=$78;
      HEAP32[(($78)>>2)]=$908;
      var $910=HEAP32[(($78)>>2)];
      var $911=$910;
      var $912=$77;
      HEAP32[(($77)>>2)]=$911;
      var $913=HEAP32[(($77)>>2)];
      var $914=(($913)|0);
      var $915=$77;
      var $916=$78;
      var $917=(($914)|0);
      var $918=$917;
      var $919=(($918)|0);
      var $920=$919;
      var $921=HEAPU8[($920)];
      var $922=(($921)&255);
      var $923=$922 & 1;
      var $924=(($923)|0)!=0;
      var $925=$79;
      if ($924) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $926
      var $927=$73;
      HEAP32[(($73)>>2)]=$905;
      var $928=HEAP32[(($73)>>2)];
      var $929=(($928)|0);
      var $930=$72;
      HEAP32[(($72)>>2)]=$929;
      var $931=HEAP32[(($72)>>2)];
      var $932=$931;
      var $933=$71;
      HEAP32[(($71)>>2)]=$932;
      var $934=HEAP32[(($71)>>2)];
      var $935=(($934)|0);
      var $936=$71;
      var $937=$72;
      var $938=(($935)|0);
      var $939=$938;
      var $940=(($939+4)|0);
      var $941=HEAP32[(($940)>>2)];
      var $942=$73;
      var $963 = $941;__label__ = 51; break;
    case 50: // $943
      var $944=$76;
      HEAP32[(($76)>>2)]=$905;
      var $945=HEAP32[(($76)>>2)];
      var $946=(($945)|0);
      var $947=$75;
      HEAP32[(($75)>>2)]=$946;
      var $948=HEAP32[(($75)>>2)];
      var $949=$948;
      var $950=$74;
      HEAP32[(($74)>>2)]=$949;
      var $951=HEAP32[(($74)>>2)];
      var $952=(($951)|0);
      var $953=$74;
      var $954=$75;
      var $955=(($952)|0);
      var $956=$955;
      var $957=(($956)|0);
      var $958=$957;
      var $959=HEAPU8[($958)];
      var $960=(($959)&255);
      var $961=$960 >> 1;
      var $962=$76;
      var $963 = $961;__label__ = 51; break;
    case 51: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit13
      var $963;
      var $964=$80;
      var $965=(($903+$963)|0);
      var $966=HEAP32[(($__fd)>>2)];
      var $967=(($965+$966)|0);
      var $968=(($967+1)|0);
      var $1097 = $968;__label__ = 59; break;
    case 52: // $969
      var $970=$58;
      HEAP32[(($58)>>2)]=$__sn;
      var $971=HEAPU32[(($58)>>2)];
      var $972=$57;
      HEAP32[(($57)>>2)]=$971;
      var $973=HEAP32[(($57)>>2)];
      var $974=(($973)|0);
      var $975=$56;
      HEAP32[(($56)>>2)]=$974;
      var $976=HEAP32[(($56)>>2)];
      var $977=$976;
      var $978=$55;
      HEAP32[(($55)>>2)]=$977;
      var $979=HEAP32[(($55)>>2)];
      var $980=(($979)|0);
      var $981=$55;
      var $982=$56;
      var $983=(($980)|0);
      var $984=$983;
      var $985=(($984)|0);
      var $986=$985;
      var $987=HEAPU8[($986)];
      var $988=(($987)&255);
      var $989=$988 & 1;
      var $990=(($989)|0)!=0;
      var $991=$57;
      if ($990) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $992
      var $993=$51;
      HEAP32[(($51)>>2)]=$971;
      var $994=HEAP32[(($51)>>2)];
      var $995=(($994)|0);
      var $996=$50;
      HEAP32[(($50)>>2)]=$995;
      var $997=HEAP32[(($50)>>2)];
      var $998=$997;
      var $999=$49;
      HEAP32[(($49)>>2)]=$998;
      var $1000=HEAP32[(($49)>>2)];
      var $1001=(($1000)|0);
      var $1002=$49;
      var $1003=$50;
      var $1004=(($1001)|0);
      var $1005=$1004;
      var $1006=(($1005+4)|0);
      var $1007=HEAP32[(($1006)>>2)];
      var $1008=$51;
      var $1029 = $1007;__label__ = 55; break;
    case 54: // $1009
      var $1010=$54;
      HEAP32[(($54)>>2)]=$971;
      var $1011=HEAP32[(($54)>>2)];
      var $1012=(($1011)|0);
      var $1013=$53;
      HEAP32[(($53)>>2)]=$1012;
      var $1014=HEAP32[(($53)>>2)];
      var $1015=$1014;
      var $1016=$52;
      HEAP32[(($52)>>2)]=$1015;
      var $1017=HEAP32[(($52)>>2)];
      var $1018=(($1017)|0);
      var $1019=$52;
      var $1020=$53;
      var $1021=(($1018)|0);
      var $1022=$1021;
      var $1023=(($1022)|0);
      var $1024=$1023;
      var $1025=HEAPU8[($1024)];
      var $1026=(($1025)&255);
      var $1027=$1026 >> 1;
      var $1028=$54;
      var $1029 = $1027;__label__ = 55; break;
    case 55: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit16
      var $1029;
      var $1030=$58;
      var $1031=$48;
      HEAP32[(($48)>>2)]=$__sym;
      var $1032=HEAPU32[(($48)>>2)];
      var $1033=$47;
      HEAP32[(($47)>>2)]=$1032;
      var $1034=HEAP32[(($47)>>2)];
      var $1035=(($1034)|0);
      var $1036=$46;
      HEAP32[(($46)>>2)]=$1035;
      var $1037=HEAP32[(($46)>>2)];
      var $1038=$1037;
      var $1039=$45;
      HEAP32[(($45)>>2)]=$1038;
      var $1040=HEAP32[(($45)>>2)];
      var $1041=(($1040)|0);
      var $1042=$45;
      var $1043=$46;
      var $1044=(($1041)|0);
      var $1045=$1044;
      var $1046=(($1045)|0);
      var $1047=$1046;
      var $1048=HEAPU8[($1047)];
      var $1049=(($1048)&255);
      var $1050=$1049 & 1;
      var $1051=(($1050)|0)!=0;
      var $1052=$47;
      if ($1051) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $1053
      var $1054=$41;
      HEAP32[(($41)>>2)]=$1032;
      var $1055=HEAP32[(($41)>>2)];
      var $1056=(($1055)|0);
      var $1057=$40;
      HEAP32[(($40)>>2)]=$1056;
      var $1058=HEAP32[(($40)>>2)];
      var $1059=$1058;
      var $1060=$39;
      HEAP32[(($39)>>2)]=$1059;
      var $1061=HEAP32[(($39)>>2)];
      var $1062=(($1061)|0);
      var $1063=$39;
      var $1064=$40;
      var $1065=(($1062)|0);
      var $1066=$1065;
      var $1067=(($1066+4)|0);
      var $1068=HEAP32[(($1067)>>2)];
      var $1069=$41;
      var $1090 = $1068;__label__ = 58; break;
    case 57: // $1070
      var $1071=$44;
      HEAP32[(($44)>>2)]=$1032;
      var $1072=HEAP32[(($44)>>2)];
      var $1073=(($1072)|0);
      var $1074=$43;
      HEAP32[(($43)>>2)]=$1073;
      var $1075=HEAP32[(($43)>>2)];
      var $1076=$1075;
      var $1077=$42;
      HEAP32[(($42)>>2)]=$1076;
      var $1078=HEAP32[(($42)>>2)];
      var $1079=(($1078)|0);
      var $1080=$42;
      var $1081=$43;
      var $1082=(($1079)|0);
      var $1083=$1082;
      var $1084=(($1083)|0);
      var $1085=$1084;
      var $1086=HEAPU8[($1085)];
      var $1087=(($1086)&255);
      var $1088=$1087 >> 1;
      var $1089=$44;
      var $1090 = $1088;__label__ = 58; break;
    case 58: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit17
      var $1090;
      var $1091=$48;
      var $1092=(($1029+$1090)|0);
      var $1093=HEAP32[(($__fd)>>2)];
      var $1094=(($1092+$1093)|0);
      var $1095=(($1094+2)|0);
      var $1097 = $1095;__label__ = 59; break;
    case 59: // $1096
      var $1097;
      $__exn=$1097;
      var $1098=$__exn;
      var $1099=(($1098)>>>0) > 100;
      if ($1099) { __label__ = 60; break; } else { __label__ = 77; break; }
    case 60: // $1100
      var $1101=$__exn;
      var $1102=(($1101)|0);
      var $1103=_malloc($1102);
      var $1104=$35;
      var $1105=$36;
      var $1106=$__tmp_i18;
      var $1107=$37;
      var $1108=$38;
      HEAP32[(($35)>>2)]=$__hw;
      HEAP32[(($36)>>2)]=$1103;
      var $1109=HEAPU32[(($35)>>2)];
      var $1110=(($1109)|0);
      var $1111=$34;
      HEAP32[(($34)>>2)]=$1110;
      var $1112=HEAP32[(($34)>>2)];
      var $1113=$1112;
      var $1114=$33;
      HEAP32[(($33)>>2)]=$1113;
      var $1115=HEAP32[(($33)>>2)];
      var $1116=(($1115)|0);
      var $1117=$33;
      var $1118=$34;
      var $1119=HEAP32[(($1116)>>2)];
      HEAP32[(($__tmp_i18)>>2)]=$1119;
      var $1120=HEAP32[(($36)>>2)];
      var $1121=(($1109)|0);
      var $1122=$32;
      HEAP32[(($32)>>2)]=$1121;
      var $1123=HEAP32[(($32)>>2)];
      var $1124=$1123;
      var $1125=$31;
      HEAP32[(($31)>>2)]=$1124;
      var $1126=HEAP32[(($31)>>2)];
      var $1127=(($1126)|0);
      var $1128=$31;
      var $1129=$32;
      HEAP32[(($1127)>>2)]=$1120;
      var $1130=HEAP32[(($__tmp_i18)>>2)];
      var $1131=(($1130)|0)!=0;
      if ($1131) { __label__ = 61; break; } else { __label__ = 64; break; }
    case 61: // $1132
      var $1133=(($1109)|0);
      var $1134=$30;
      HEAP32[(($30)>>2)]=$1133;
      var $1135=HEAP32[(($30)>>2)];
      var $1136=$1135;
      var $1137=$29;
      HEAP32[(($29)>>2)]=$1136;
      var $1138=HEAP32[(($29)>>2)];
      var $1139=(($1138+4)|0);
      var $1140=$29;
      var $1141=$30;
      var $1142=HEAP32[(($1139)>>2)];
      var $1143=HEAP32[(($__tmp_i18)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1142]($1143) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $1144
      __label__ = 64; break;
    case 63: // $1145
      var $1146=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1147=$1146.f0;
      HEAP32[(($37)>>2)]=$1147;
      var $1148=$1146.f1;
      HEAP32[(($38)>>2)]=$1148;
      var $1149=HEAP32[(($37)>>2)];
      ___cxa_call_unexpected($1149);
      throw "Reached an unreachable!"
    case 64: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit19
      var $1150=$35;
      var $1151=$36;
      var $1152=$__tmp_i18;
      var $1153=$37;
      var $1154=$38;
      var $1155=$28;
      HEAP32[(($28)>>2)]=$__hw;
      var $1156=HEAP32[(($28)>>2)];
      var $1157=(($1156)|0);
      var $1158=$27;
      HEAP32[(($27)>>2)]=$1157;
      var $1159=HEAP32[(($27)>>2)];
      var $1160=$1159;
      var $1161=$26;
      HEAP32[(($26)>>2)]=$1160;
      var $1162=HEAP32[(($26)>>2)];
      var $1163=(($1162)|0);
      var $1164=$26;
      var $1165=$27;
      var $1166=HEAP32[(($1163)>>2)];
      var $1167=$28;
      $__mb=$1166;
      var $1168=$__mb;
      var $1169=(($1168)|0)==0;
      if ($1169) { __label__ = 65; break; } else { __label__ = 76; break; }
    case 65: // $1170
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 71; break; }
    case 66: // $1171
      __label__ = 76; break;
    case 67: // $1172
      var $1173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1174=$1173.f0;
      $253=$1174;
      var $1175=$1173.f1;
      $254=$1175;
      __label__ = 101; break;
    case 68: // $1176
      var $1177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1178=$1177.f0;
      $253=$1178;
      var $1179=$1177.f1;
      $254=$1179;
      __label__ = 94; break;
    case 69: // $1180
      var $1181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1182=$1181.f0;
      $253=$1182;
      var $1183=$1181.f1;
      $254=$1183;
      __label__ = 91; break;
    case 70: // $1184
      var $1185=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1186=$1185.f0;
      $253=$1186;
      var $1187=$1185.f1;
      $254=$1187;
      __label__ = 88; break;
    case 71: // $1188
      var $1189=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1190=$1189.f0;
      $253=$1190;
      var $1191=$1189.f1;
      $254=$1191;
      var $1192=$25;
      HEAP32[(($25)>>2)]=$__hw;
      var $1193=HEAP32[(($25)>>2)];
      var $1194=$24;
      HEAP32[(($24)>>2)]=$1193;
      var $1195=HEAP32[(($24)>>2)];
      var $1196=$20;
      var $1197=$21;
      var $1198=$__tmp_i_i_i20;
      var $1199=$22;
      var $1200=$23;
      HEAP32[(($20)>>2)]=$1195;
      HEAP32[(($21)>>2)]=0;
      var $1201=HEAP32[(($20)>>2)];
      var $1202=(($1201)|0);
      var $1203=$19;
      HEAP32[(($19)>>2)]=$1202;
      var $1204=HEAP32[(($19)>>2)];
      var $1205=$1204;
      var $1206=$18;
      HEAP32[(($18)>>2)]=$1205;
      var $1207=HEAP32[(($18)>>2)];
      var $1208=(($1207)|0);
      var $1209=$18;
      var $1210=$19;
      var $1211=HEAP32[(($1208)>>2)];
      HEAP32[(($__tmp_i_i_i20)>>2)]=$1211;
      var $1212=HEAP32[(($21)>>2)];
      var $1213=(($1201)|0);
      var $1214=$17;
      HEAP32[(($17)>>2)]=$1213;
      var $1215=HEAP32[(($17)>>2)];
      var $1216=$1215;
      var $1217=$16;
      HEAP32[(($16)>>2)]=$1216;
      var $1218=HEAP32[(($16)>>2)];
      var $1219=(($1218)|0);
      var $1220=$16;
      var $1221=$17;
      HEAP32[(($1219)>>2)]=$1212;
      var $1222=HEAP32[(($__tmp_i_i_i20)>>2)];
      var $1223=(($1222)|0)!=0;
      if ($1223) { __label__ = 72; break; } else { __label__ = 75; break; }
    case 72: // $1224
      var $1225=(($1201)|0);
      var $1226=$15;
      HEAP32[(($15)>>2)]=$1225;
      var $1227=HEAP32[(($15)>>2)];
      var $1228=$1227;
      var $1229=$14;
      HEAP32[(($14)>>2)]=$1228;
      var $1230=HEAP32[(($14)>>2)];
      var $1231=(($1230+4)|0);
      var $1232=$14;
      var $1233=$15;
      var $1234=HEAP32[(($1231)>>2)];
      var $1235=HEAP32[(($__tmp_i_i_i20)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1234]($1235) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $1236
      __label__ = 75; break;
    case 74: // $1237
      var $1238=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1239=$1238.f0;
      HEAP32[(($22)>>2)]=$1239;
      var $1240=$1238.f1;
      HEAP32[(($23)>>2)]=$1240;
      var $1241=HEAP32[(($22)>>2)];
      ___cxa_call_unexpected($1241);
      throw "Reached an unreachable!"
    case 75: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit21
      var $1242=$20;
      var $1243=$21;
      var $1244=$__tmp_i_i_i20;
      var $1245=$22;
      var $1246=$23;
      var $1247=$24;
      var $1248=$25;
      __label__ = 86; break;
    case 76: // $1249
      __label__ = 77; break;
    case 77: // $1250
      var $1251=$__mb;
      var $1252=$250;
      var $1253=$13;
      HEAP32[(($13)>>2)]=$1252;
      var $1254=HEAP32[(($13)>>2)];
      var $1255=(($1254+4)|0);
      var $1256=HEAP32[(($1255)>>2)];
      var $1257=$13;
      __label__ = 78; break;
    case 78: // $1258
      var $1259=$__db;
      var $1260=$__db;
      var $1261=$__n;
      var $1262=(($1260+$1261)|0);
      var $1263=$__ct;
      var $1264=$__neg;
      var $1265=(($1264) & 1);
      var $1266=HEAP8[($__dp)];
      var $1267=HEAP8[($__ts)];
      var $1268=HEAP32[(($__fd)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i($1251, $__mi, $__me, $1256, $1259, $1262, $1263, $1265, $__pat, $1266, $1267, $__grp, $__sym, $__sn, $1268) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 71; break; }
    case 79: // $1269
      var $1270=$255;
      var $1271=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1270)>>2)]=HEAP32[(($1271)>>2)];
      var $1272=$__mb;
      var $1273=HEAP32[(($__mi)>>2)];
      var $1274=HEAP32[(($__me)>>2)];
      var $1275=$250;
      var $1276=$251;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $255, $1272, $1273, $1274, $1275, $1276) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 71; break; }
    case 80: // $1277
      $256=1;
      var $1278=$12;
      HEAP32[(($12)>>2)]=$__hw;
      var $1279=HEAP32[(($12)>>2)];
      var $1280=$11;
      HEAP32[(($11)>>2)]=$1279;
      var $1281=HEAP32[(($11)>>2)];
      var $1282=$7;
      var $1283=$8;
      var $1284=$__tmp_i_i_i22;
      var $1285=$9;
      var $1286=$10;
      HEAP32[(($7)>>2)]=$1281;
      HEAP32[(($8)>>2)]=0;
      var $1287=HEAP32[(($7)>>2)];
      var $1288=(($1287)|0);
      var $1289=$6;
      HEAP32[(($6)>>2)]=$1288;
      var $1290=HEAP32[(($6)>>2)];
      var $1291=$1290;
      var $1292=$5;
      HEAP32[(($5)>>2)]=$1291;
      var $1293=HEAP32[(($5)>>2)];
      var $1294=(($1293)|0);
      var $1295=$5;
      var $1296=$6;
      var $1297=HEAP32[(($1294)>>2)];
      HEAP32[(($__tmp_i_i_i22)>>2)]=$1297;
      var $1298=HEAP32[(($8)>>2)];
      var $1299=(($1287)|0);
      var $1300=$4;
      HEAP32[(($4)>>2)]=$1299;
      var $1301=HEAP32[(($4)>>2)];
      var $1302=$1301;
      var $1303=$3;
      HEAP32[(($3)>>2)]=$1302;
      var $1304=HEAP32[(($3)>>2)];
      var $1305=(($1304)|0);
      var $1306=$3;
      var $1307=$4;
      HEAP32[(($1305)>>2)]=$1298;
      var $1308=HEAP32[(($__tmp_i_i_i22)>>2)];
      var $1309=(($1308)|0)!=0;
      if ($1309) { __label__ = 81; break; } else { __label__ = 84; break; }
    case 81: // $1310
      var $1311=(($1287)|0);
      var $1312=$2;
      HEAP32[(($2)>>2)]=$1311;
      var $1313=HEAP32[(($2)>>2)];
      var $1314=$1313;
      var $1315=$1;
      HEAP32[(($1)>>2)]=$1314;
      var $1316=HEAP32[(($1)>>2)];
      var $1317=(($1316+4)|0);
      var $1318=$1;
      var $1319=$2;
      var $1320=HEAP32[(($1317)>>2)];
      var $1321=HEAP32[(($__tmp_i_i_i22)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1320]($1321) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 83; break; }
    case 82: // $1322
      __label__ = 84; break;
    case 83: // $1323
      var $1324=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1325=$1324.f0;
      HEAP32[(($9)>>2)]=$1325;
      var $1326=$1324.f1;
      HEAP32[(($10)>>2)]=$1326;
      var $1327=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($1327);
      throw "Reached an unreachable!"
    case 84: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit23
      var $1328=$7;
      var $1329=$8;
      var $1330=$__tmp_i_i_i22;
      var $1331=$9;
      var $1332=$10;
      var $1333=$11;
      var $1334=$12;
      __label__ = 85; break;
    case 85: // $1335
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 69; break; }
    case 86: // $1336
      __label__ = 88; break;
    case 87: // $1337
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 68; break; }
    case 88: // $1338
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 121; break; }
    case 89: // $1339
      __label__ = 91; break;
    case 90: // $1340
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 67; break; }
    case 91: // $1341
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 121; break; }
    case 92: // $1342
      __label__ = 94; break;
    case 93: // $1343
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 7; break; }
    case 94: // $1344
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 121; break; }
    case 95: // $1345
      __label__ = 101; break;
    case 96: // $1346
      var $1347=$70;
      HEAP32[(($70)>>2)]=$__hd;
      var $1348=HEAP32[(($70)>>2)];
      var $1349=$69;
      HEAP32[(($69)>>2)]=$1348;
      var $1350=HEAP32[(($69)>>2)];
      var $1351=$65;
      var $1352=$66;
      var $1353=$__tmp_i_i_i14;
      var $1354=$67;
      var $1355=$68;
      HEAP32[(($65)>>2)]=$1350;
      HEAP32[(($66)>>2)]=0;
      var $1356=HEAP32[(($65)>>2)];
      var $1357=(($1356)|0);
      var $1358=$64;
      HEAP32[(($64)>>2)]=$1357;
      var $1359=HEAP32[(($64)>>2)];
      var $1360=$1359;
      var $1361=$63;
      HEAP32[(($63)>>2)]=$1360;
      var $1362=HEAP32[(($63)>>2)];
      var $1363=(($1362)|0);
      var $1364=$63;
      var $1365=$64;
      var $1366=HEAP32[(($1363)>>2)];
      HEAP32[(($__tmp_i_i_i14)>>2)]=$1366;
      var $1367=HEAP32[(($66)>>2)];
      var $1368=(($1356)|0);
      var $1369=$62;
      HEAP32[(($62)>>2)]=$1368;
      var $1370=HEAP32[(($62)>>2)];
      var $1371=$1370;
      var $1372=$61;
      HEAP32[(($61)>>2)]=$1371;
      var $1373=HEAP32[(($61)>>2)];
      var $1374=(($1373)|0);
      var $1375=$61;
      var $1376=$62;
      HEAP32[(($1374)>>2)]=$1367;
      var $1377=HEAP32[(($__tmp_i_i_i14)>>2)];
      var $1378=(($1377)|0)!=0;
      if ($1378) { __label__ = 97; break; } else { __label__ = 100; break; }
    case 97: // $1379
      var $1380=(($1356)|0);
      var $1381=$60;
      HEAP32[(($60)>>2)]=$1380;
      var $1382=HEAP32[(($60)>>2)];
      var $1383=$1382;
      var $1384=$59;
      HEAP32[(($59)>>2)]=$1383;
      var $1385=HEAP32[(($59)>>2)];
      var $1386=(($1385+4)|0);
      var $1387=$59;
      var $1388=$60;
      var $1389=HEAP32[(($1386)>>2)];
      var $1390=HEAP32[(($__tmp_i_i_i14)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1389]($1390) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $1391
      __label__ = 100; break;
    case 99: // $1392
      var $1393=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1394=$1393.f0;
      HEAP32[(($67)>>2)]=$1394;
      var $1395=$1393.f1;
      HEAP32[(($68)>>2)]=$1395;
      var $1396=HEAP32[(($67)>>2)];
      ___cxa_call_unexpected($1396);
      throw "Reached an unreachable!"
    case 100: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit15
      var $1397=$65;
      var $1398=$66;
      var $1399=$__tmp_i_i_i14;
      var $1400=$67;
      var $1401=$68;
      var $1402=$69;
      var $1403=$70;
      __label__ = 103; break;
    case 101: // $1404
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 121; break; }
    case 102: // $1405
      __label__ = 108; break;
    case 103: // $1406
      var $1407=$123;
      HEAP32[(($123)>>2)]=$__hn;
      var $1408=HEAP32[(($123)>>2)];
      var $1409=$122;
      HEAP32[(($122)>>2)]=$1408;
      var $1410=HEAP32[(($122)>>2)];
      var $1411=$118;
      var $1412=$119;
      var $1413=$__tmp_i_i_i11;
      var $1414=$120;
      var $1415=$121;
      HEAP32[(($118)>>2)]=$1410;
      HEAP32[(($119)>>2)]=0;
      var $1416=HEAP32[(($118)>>2)];
      var $1417=(($1416)|0);
      var $1418=$117;
      HEAP32[(($117)>>2)]=$1417;
      var $1419=HEAP32[(($117)>>2)];
      var $1420=$1419;
      var $1421=$116;
      HEAP32[(($116)>>2)]=$1420;
      var $1422=HEAP32[(($116)>>2)];
      var $1423=(($1422)|0);
      var $1424=$116;
      var $1425=$117;
      var $1426=HEAP32[(($1423)>>2)];
      HEAP32[(($__tmp_i_i_i11)>>2)]=$1426;
      var $1427=HEAP32[(($119)>>2)];
      var $1428=(($1416)|0);
      var $1429=$115;
      HEAP32[(($115)>>2)]=$1428;
      var $1430=HEAP32[(($115)>>2)];
      var $1431=$1430;
      var $1432=$114;
      HEAP32[(($114)>>2)]=$1431;
      var $1433=HEAP32[(($114)>>2)];
      var $1434=(($1433)|0);
      var $1435=$114;
      var $1436=$115;
      HEAP32[(($1434)>>2)]=$1427;
      var $1437=HEAP32[(($__tmp_i_i_i11)>>2)];
      var $1438=(($1437)|0)!=0;
      if ($1438) { __label__ = 104; break; } else { __label__ = 107; break; }
    case 104: // $1439
      var $1440=(($1416)|0);
      var $1441=$113;
      HEAP32[(($113)>>2)]=$1440;
      var $1442=HEAP32[(($113)>>2)];
      var $1443=$1442;
      var $1444=$112;
      HEAP32[(($112)>>2)]=$1443;
      var $1445=HEAP32[(($112)>>2)];
      var $1446=(($1445+4)|0);
      var $1447=$112;
      var $1448=$113;
      var $1449=HEAP32[(($1446)>>2)];
      var $1450=HEAP32[(($__tmp_i_i_i11)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1449]($1450) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $1451
      __label__ = 107; break;
    case 106: // $1452
      var $1453=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1454=$1453.f0;
      HEAP32[(($120)>>2)]=$1454;
      var $1455=$1453.f1;
      HEAP32[(($121)>>2)]=$1455;
      var $1456=HEAP32[(($120)>>2)];
      ___cxa_call_unexpected($1456);
      throw "Reached an unreachable!"
    case 107: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit12
      var $1457=$118;
      var $1458=$119;
      var $1459=$__tmp_i_i_i11;
      var $1460=$120;
      var $1461=$121;
      var $1462=$122;
      var $1463=$123;
      STACKTOP = __stackBase__;
      return;
    case 108: // $1464
      var $1465=$153;
      HEAP32[(($153)>>2)]=$__hd;
      var $1466=HEAP32[(($153)>>2)];
      var $1467=$152;
      HEAP32[(($152)>>2)]=$1466;
      var $1468=HEAP32[(($152)>>2)];
      var $1469=$148;
      var $1470=$149;
      var $1471=$__tmp_i_i_i3;
      var $1472=$150;
      var $1473=$151;
      HEAP32[(($148)>>2)]=$1468;
      HEAP32[(($149)>>2)]=0;
      var $1474=HEAP32[(($148)>>2)];
      var $1475=(($1474)|0);
      var $1476=$147;
      HEAP32[(($147)>>2)]=$1475;
      var $1477=HEAP32[(($147)>>2)];
      var $1478=$1477;
      var $1479=$146;
      HEAP32[(($146)>>2)]=$1478;
      var $1480=HEAP32[(($146)>>2)];
      var $1481=(($1480)|0);
      var $1482=$146;
      var $1483=$147;
      var $1484=HEAP32[(($1481)>>2)];
      HEAP32[(($__tmp_i_i_i3)>>2)]=$1484;
      var $1485=HEAP32[(($149)>>2)];
      var $1486=(($1474)|0);
      var $1487=$145;
      HEAP32[(($145)>>2)]=$1486;
      var $1488=HEAP32[(($145)>>2)];
      var $1489=$1488;
      var $1490=$144;
      HEAP32[(($144)>>2)]=$1489;
      var $1491=HEAP32[(($144)>>2)];
      var $1492=(($1491)|0);
      var $1493=$144;
      var $1494=$145;
      HEAP32[(($1492)>>2)]=$1485;
      var $1495=HEAP32[(($__tmp_i_i_i3)>>2)];
      var $1496=(($1495)|0)!=0;
      if ($1496) { __label__ = 109; break; } else { __label__ = 112; break; }
    case 109: // $1497
      var $1498=(($1474)|0);
      var $1499=$143;
      HEAP32[(($143)>>2)]=$1498;
      var $1500=HEAP32[(($143)>>2)];
      var $1501=$1500;
      var $1502=$142;
      HEAP32[(($142)>>2)]=$1501;
      var $1503=HEAP32[(($142)>>2)];
      var $1504=(($1503+4)|0);
      var $1505=$142;
      var $1506=$143;
      var $1507=HEAP32[(($1504)>>2)];
      var $1508=HEAP32[(($__tmp_i_i_i3)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1507]($1508) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 111; break; }
    case 110: // $1509
      __label__ = 112; break;
    case 111: // $1510
      var $1511=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1512=$1511.f0;
      HEAP32[(($150)>>2)]=$1512;
      var $1513=$1511.f1;
      HEAP32[(($151)>>2)]=$1513;
      var $1514=HEAP32[(($150)>>2)];
      ___cxa_call_unexpected($1514);
      throw "Reached an unreachable!"
    case 112: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit4
      var $1515=$148;
      var $1516=$149;
      var $1517=$__tmp_i_i_i3;
      var $1518=$150;
      var $1519=$151;
      var $1520=$152;
      var $1521=$153;
      __label__ = 113; break;
    case 113: // $1522
      __label__ = 114; break;
    case 114: // $1523
      var $1524=$226;
      HEAP32[(($226)>>2)]=$__hn;
      var $1525=HEAP32[(($226)>>2)];
      var $1526=$225;
      HEAP32[(($225)>>2)]=$1525;
      var $1527=HEAP32[(($225)>>2)];
      var $1528=$221;
      var $1529=$222;
      var $1530=$__tmp_i_i_i;
      var $1531=$223;
      var $1532=$224;
      HEAP32[(($221)>>2)]=$1527;
      HEAP32[(($222)>>2)]=0;
      var $1533=HEAP32[(($221)>>2)];
      var $1534=(($1533)|0);
      var $1535=$220;
      HEAP32[(($220)>>2)]=$1534;
      var $1536=HEAP32[(($220)>>2)];
      var $1537=$1536;
      var $1538=$219;
      HEAP32[(($219)>>2)]=$1537;
      var $1539=HEAP32[(($219)>>2)];
      var $1540=(($1539)|0);
      var $1541=$219;
      var $1542=$220;
      var $1543=HEAP32[(($1540)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$1543;
      var $1544=HEAP32[(($222)>>2)];
      var $1545=(($1533)|0);
      var $1546=$218;
      HEAP32[(($218)>>2)]=$1545;
      var $1547=HEAP32[(($218)>>2)];
      var $1548=$1547;
      var $1549=$217;
      HEAP32[(($217)>>2)]=$1548;
      var $1550=HEAP32[(($217)>>2)];
      var $1551=(($1550)|0);
      var $1552=$217;
      var $1553=$218;
      HEAP32[(($1551)>>2)]=$1544;
      var $1554=HEAP32[(($__tmp_i_i_i)>>2)];
      var $1555=(($1554)|0)!=0;
      if ($1555) { __label__ = 115; break; } else { __label__ = 118; break; }
    case 115: // $1556
      var $1557=(($1533)|0);
      var $1558=$216;
      HEAP32[(($216)>>2)]=$1557;
      var $1559=HEAP32[(($216)>>2)];
      var $1560=$1559;
      var $1561=$215;
      HEAP32[(($215)>>2)]=$1560;
      var $1562=HEAP32[(($215)>>2)];
      var $1563=(($1562+4)|0);
      var $1564=$215;
      var $1565=$216;
      var $1566=HEAP32[(($1563)>>2)];
      var $1567=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1566]($1567) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 117; break; }
    case 116: // $1568
      __label__ = 118; break;
    case 117: // $1569
      var $1570=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1571=$1570.f0;
      HEAP32[(($223)>>2)]=$1571;
      var $1572=$1570.f1;
      HEAP32[(($224)>>2)]=$1572;
      var $1573=HEAP32[(($223)>>2)];
      ___cxa_call_unexpected($1573);
      throw "Reached an unreachable!"
    case 118: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $1574=$221;
      var $1575=$222;
      var $1576=$__tmp_i_i_i;
      var $1577=$223;
      var $1578=$224;
      var $1579=$225;
      var $1580=$226;
      __label__ = 119; break;
    case 119: // $1581
      __label__ = 120; break;
    case 120: // $1582
      var $1583=$253;
      var $1584=$253;
      var $1585=$254;
      var $1586=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1584, tempValue);
      var $1587=($1586.f1 = $1585, $1586);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 121: // $1588
      var $1589=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce["X"]=1;

function __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri($__intl, $__neg, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $26;
      var $27;
      var $28;
      var $29;
      var $30;
      var $__mp;
      var $31=__stackBase__+80;
      var $32=__stackBase__+84;
      var $33;
      var $34;
      var $35=__stackBase__+96;
      var $36=__stackBase__+100;
      var $37=__stackBase__+112;
      var $38=__stackBase__+124;
      var $__mp1;
      var $39=__stackBase__+136;
      var $40=__stackBase__+140;
      var $41=__stackBase__+152;
      var $42=__stackBase__+156;
      var $43=__stackBase__+168;
      var $44=__stackBase__+180;
      var $45=(($__intl)&1);
      $21=$45;
      var $46=(($__neg)&1);
      $22=$46;
      $23=$__loc;
      $24=$__pat;
      $25=$__dp;
      $26=$__ts;
      $27=$__grp;
      $28=$__sym;
      $29=$__sn;
      $30=$__fd;
      var $47=$21;
      var $48=(($47) & 1);
      if ($48) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $49
      var $50=$23;
      var $51=$20;
      HEAP32[(($20)>>2)]=$50;
      var $52=HEAP32[(($20)>>2)];
      var $53=__ZNKSt3__16locale9use_facetERNS0_2idE($52, __ZNSt3__110moneypunctIcLb1EE2idE);
      var $54=$53;
      var $55=$20;
      $__mp=$54;
      var $56=$22;
      var $57=(($56) & 1);
      if ($57) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $58
      var $59=$24;
      var $60=$__mp;
      var $61=$19;
      HEAP32[(($19)>>2)]=$60;
      var $62=HEAP32[(($19)>>2)];
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+44)|0);
      var $66=HEAP32[(($65)>>2)];
      FUNCTION_TABLE[$66]($31, $62);
      var $67=$19;
      var $68=$59;
      var $69=$31;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($68)]=HEAP8[($69)];HEAP8[($68+1)]=HEAP8[($69+1)];HEAP8[($68+2)]=HEAP8[($69+2)];HEAP8[($68+3)]=HEAP8[($69+3)];
      var $70=$29;
      var $71=$__mp;
      var $72=$18;
      HEAP32[(($18)>>2)]=$71;
      var $73=HEAP32[(($18)>>2)];
      var $74=$73;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+32)|0);
      var $77=HEAP32[(($76)>>2)];
      FUNCTION_TABLE[$77]($32, $73);
      var $78=$18;
      var $79=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($70, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $80
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($32);
      __label__ = 10; break;
    case 4: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      $33=$83;
      var $84=$82.f1;
      $34=$84;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 35; break; }
    case 5: // $85
      __label__ = 34; break;
    case 6: // $86
      var $87=$24;
      var $88=$__mp;
      var $89=$17;
      HEAP32[(($17)>>2)]=$88;
      var $90=HEAP32[(($17)>>2)];
      var $91=$90;
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92+40)|0);
      var $94=HEAP32[(($93)>>2)];
      FUNCTION_TABLE[$94]($35, $90);
      var $95=$17;
      var $96=$87;
      var $97=$35;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($96)]=HEAP8[($97)];HEAP8[($96+1)]=HEAP8[($97+1)];HEAP8[($96+2)]=HEAP8[($97+2)];HEAP8[($96+3)]=HEAP8[($97+3)];
      var $98=$29;
      var $99=$__mp;
      var $100=$16;
      HEAP32[(($16)>>2)]=$99;
      var $101=HEAP32[(($16)>>2)];
      var $102=$101;
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+28)|0);
      var $105=HEAP32[(($104)>>2)];
      FUNCTION_TABLE[$105]($36, $101);
      var $106=$16;
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($98, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $108
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($36);
      __label__ = 10; break;
    case 8: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $33=$111;
      var $112=$110.f1;
      $34=$112;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 35; break; }
    case 9: // $113
      __label__ = 34; break;
    case 10: // $114
      var $115=$__mp;
      var $116=$15;
      HEAP32[(($15)>>2)]=$115;
      var $117=HEAP32[(($15)>>2)];
      var $118=$117;
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+12)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=FUNCTION_TABLE[$121]($117);
      var $123=$15;
      var $124=$25;
      HEAP8[($124)]=$122;
      var $125=$__mp;
      var $126=$14;
      HEAP32[(($14)>>2)]=$125;
      var $127=HEAP32[(($14)>>2)];
      var $128=$127;
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+16)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=FUNCTION_TABLE[$131]($127);
      var $133=$14;
      var $134=$26;
      HEAP8[($134)]=$132;
      var $135=$27;
      var $136=$__mp;
      var $137=$13;
      HEAP32[(($13)>>2)]=$136;
      var $138=HEAP32[(($13)>>2)];
      var $139=$138;
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+20)|0);
      var $142=HEAP32[(($141)>>2)];
      FUNCTION_TABLE[$142]($37, $138);
      var $143=$13;
      var $144=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($135, $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $145
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($37);
      var $146=$28;
      var $147=$__mp;
      var $148=$12;
      HEAP32[(($12)>>2)]=$147;
      var $149=HEAP32[(($12)>>2)];
      var $150=$149;
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+24)|0);
      var $153=HEAP32[(($152)>>2)];
      FUNCTION_TABLE[$153]($38, $149);
      var $154=$12;
      var $155=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($146, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $156
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($38);
      var $157=$__mp;
      var $158=$11;
      HEAP32[(($11)>>2)]=$157;
      var $159=HEAP32[(($11)>>2)];
      var $160=$159;
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+36)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=FUNCTION_TABLE[$163]($159);
      var $165=$11;
      var $166=$30;
      HEAP32[(($166)>>2)]=$164;
      __label__ = 33; break;
    case 13: // $167
      var $168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $169=$168.f0;
      $33=$169;
      var $170=$168.f1;
      $34=$170;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 35; break; }
    case 14: // $171
      __label__ = 34; break;
    case 15: // $172
      var $173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $174=$173.f0;
      $33=$174;
      var $175=$173.f1;
      $34=$175;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 35; break; }
    case 16: // $176
      __label__ = 34; break;
    case 17: // $177
      var $178=$23;
      var $179=$10;
      HEAP32[(($10)>>2)]=$178;
      var $180=HEAP32[(($10)>>2)];
      var $181=__ZNKSt3__16locale9use_facetERNS0_2idE($180, __ZNSt3__110moneypunctIcLb0EE2idE);
      var $182=$181;
      var $183=$10;
      $__mp1=$182;
      var $184=$22;
      var $185=(($184) & 1);
      if ($185) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $186
      var $187=$24;
      var $188=$__mp1;
      var $189=$9;
      HEAP32[(($9)>>2)]=$188;
      var $190=HEAP32[(($9)>>2)];
      var $191=$190;
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+44)|0);
      var $194=HEAP32[(($193)>>2)];
      FUNCTION_TABLE[$194]($39, $190);
      var $195=$9;
      var $196=$187;
      var $197=$39;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($196)]=HEAP8[($197)];HEAP8[($196+1)]=HEAP8[($197+1)];HEAP8[($196+2)]=HEAP8[($197+2)];HEAP8[($196+3)]=HEAP8[($197+3)];
      var $198=$29;
      var $199=$__mp1;
      var $200=$8;
      HEAP32[(($8)>>2)]=$199;
      var $201=HEAP32[(($8)>>2)];
      var $202=$201;
      var $203=HEAP32[(($202)>>2)];
      var $204=(($203+32)|0);
      var $205=HEAP32[(($204)>>2)];
      FUNCTION_TABLE[$205]($40, $201);
      var $206=$8;
      var $207=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($198, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; };
    case 19: // $208
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($40);
      __label__ = 26; break;
    case 20: // $209
      var $210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $211=$210.f0;
      $33=$211;
      var $212=$210.f1;
      $34=$212;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 35; break; }
    case 21: // $213
      __label__ = 34; break;
    case 22: // $214
      var $215=$24;
      var $216=$__mp1;
      var $217=$7;
      HEAP32[(($7)>>2)]=$216;
      var $218=HEAP32[(($7)>>2)];
      var $219=$218;
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220+40)|0);
      var $222=HEAP32[(($221)>>2)];
      FUNCTION_TABLE[$222]($41, $218);
      var $223=$7;
      var $224=$215;
      var $225=$41;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($224)]=HEAP8[($225)];HEAP8[($224+1)]=HEAP8[($225+1)];HEAP8[($224+2)]=HEAP8[($225+2)];HEAP8[($224+3)]=HEAP8[($225+3)];
      var $226=$29;
      var $227=$__mp1;
      var $228=$6;
      HEAP32[(($6)>>2)]=$227;
      var $229=HEAP32[(($6)>>2)];
      var $230=$229;
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231+28)|0);
      var $233=HEAP32[(($232)>>2)];
      FUNCTION_TABLE[$233]($42, $229);
      var $234=$6;
      var $235=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($226, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; };
    case 23: // $236
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($42);
      __label__ = 26; break;
    case 24: // $237
      var $238=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $239=$238.f0;
      $33=$239;
      var $240=$238.f1;
      $34=$240;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 35; break; }
    case 25: // $241
      __label__ = 34; break;
    case 26: // $242
      var $243=$__mp1;
      var $244=$5;
      HEAP32[(($5)>>2)]=$243;
      var $245=HEAP32[(($5)>>2)];
      var $246=$245;
      var $247=HEAP32[(($246)>>2)];
      var $248=(($247+12)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=FUNCTION_TABLE[$249]($245);
      var $251=$5;
      var $252=$25;
      HEAP8[($252)]=$250;
      var $253=$__mp1;
      var $254=$4;
      HEAP32[(($4)>>2)]=$253;
      var $255=HEAP32[(($4)>>2)];
      var $256=$255;
      var $257=HEAP32[(($256)>>2)];
      var $258=(($257+16)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=FUNCTION_TABLE[$259]($255);
      var $261=$4;
      var $262=$26;
      HEAP8[($262)]=$260;
      var $263=$27;
      var $264=$__mp1;
      var $265=$3;
      HEAP32[(($3)>>2)]=$264;
      var $266=HEAP32[(($3)>>2)];
      var $267=$266;
      var $268=HEAP32[(($267)>>2)];
      var $269=(($268+20)|0);
      var $270=HEAP32[(($269)>>2)];
      FUNCTION_TABLE[$270]($43, $266);
      var $271=$3;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($263, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $273
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($43);
      var $274=$28;
      var $275=$__mp1;
      var $276=$2;
      HEAP32[(($2)>>2)]=$275;
      var $277=HEAP32[(($2)>>2)];
      var $278=$277;
      var $279=HEAP32[(($278)>>2)];
      var $280=(($279+24)|0);
      var $281=HEAP32[(($280)>>2)];
      FUNCTION_TABLE[$281]($44, $277);
      var $282=$2;
      var $283=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($274, $44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 31; break; };
    case 28: // $284
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($44);
      var $285=$__mp1;
      var $286=$1;
      HEAP32[(($1)>>2)]=$285;
      var $287=HEAP32[(($1)>>2)];
      var $288=$287;
      var $289=HEAP32[(($288)>>2)];
      var $290=(($289+36)|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=FUNCTION_TABLE[$291]($287);
      var $293=$1;
      var $294=$30;
      HEAP32[(($294)>>2)]=$292;
      __label__ = 33; break;
    case 29: // $295
      var $296=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $297=$296.f0;
      $33=$297;
      var $298=$296.f1;
      $34=$298;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $299
      __label__ = 34; break;
    case 31: // $300
      var $301=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $302=$301.f0;
      $33=$302;
      var $303=$301.f1;
      $34=$303;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $304
      __label__ = 34; break;
    case 33: // $305
      STACKTOP = __stackBase__;
      return;
    case 34: // $306
      var $307=$33;
      var $308=$33;
      var $309=$34;
      var $310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $308, tempValue);
      var $311=($310.f1 = $309, $310);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $312
      var $313=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri["X"]=1;

function __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i($__mb, $__mi, $__me, $__flags, $__db, $__de, $__ct, $__neg, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) {
  var __stackBase__  = STACKTOP; STACKTOP += 1028; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66;
      var $67=__stackBase__+260;
      var $68=__stackBase__+264;
      var $69=__stackBase__+268;
      var $70=__stackBase__+272;
      var $71=__stackBase__+276;
      var $72=__stackBase__+280;
      var $73=__stackBase__+284;
      var $74=__stackBase__+288;
      var $75=__stackBase__+292;
      var $76=__stackBase__+296;
      var $77=__stackBase__+300;
      var $78=__stackBase__+304;
      var $79;
      var $80=__stackBase__+308;
      var $81=__stackBase__+312;
      var $82=__stackBase__+316;
      var $83=__stackBase__+320;
      var $84=__stackBase__+324;
      var $85=__stackBase__+328;
      var $86=__stackBase__+332;
      var $87=__stackBase__+336;
      var $88=__stackBase__+340;
      var $89=__stackBase__+344;
      var $90=__stackBase__+348;
      var $91=__stackBase__+352;
      var $92=__stackBase__+356;
      var $93=__stackBase__+360;
      var $94;
      var $95=__stackBase__+364;
      var $96=__stackBase__+368;
      var $97=__stackBase__+372;
      var $98=__stackBase__+376;
      var $99=__stackBase__+380;
      var $100=__stackBase__+384;
      var $101=__stackBase__+388;
      var $102=__stackBase__+392;
      var $103=__stackBase__+396;
      var $104=__stackBase__+400;
      var $105=__stackBase__+404;
      var $106=__stackBase__+408;
      var $107=__stackBase__+412;
      var $108=__stackBase__+416;
      var $109=__stackBase__+420;
      var $110=__stackBase__+424;
      var $111=__stackBase__+428;
      var $112=__stackBase__+432;
      var $113=__stackBase__+436;
      var $114=__stackBase__+440;
      var $115=__stackBase__+444;
      var $116=__stackBase__+448;
      var $117=__stackBase__+452;
      var $118=__stackBase__+456;
      var $119=__stackBase__+460;
      var $120=__stackBase__+464;
      var $121=__stackBase__+468;
      var $122=__stackBase__+472;
      var $123=__stackBase__+476;
      var $124=__stackBase__+480;
      var $125=__stackBase__+484;
      var $126=__stackBase__+488;
      var $127=__stackBase__+492;
      var $128=__stackBase__+496;
      var $129=__stackBase__+500;
      var $130=__stackBase__+504;
      var $131=__stackBase__+508;
      var $132=__stackBase__+512;
      var $133=__stackBase__+516;
      var $134=__stackBase__+520;
      var $135=__stackBase__+524;
      var $136=__stackBase__+528;
      var $137=__stackBase__+532;
      var $138=__stackBase__+536;
      var $139=__stackBase__+540;
      var $140=__stackBase__+544;
      var $141=__stackBase__+548;
      var $142=__stackBase__+552;
      var $143=__stackBase__+556;
      var $144=__stackBase__+560;
      var $145=__stackBase__+564;
      var $146=__stackBase__+568;
      var $147=__stackBase__+572;
      var $148=__stackBase__+576;
      var $149=__stackBase__+580;
      var $150=__stackBase__+584;
      var $151=__stackBase__+588;
      var $152=__stackBase__+592;
      var $153=__stackBase__+596;
      var $154=__stackBase__+600;
      var $155=__stackBase__+604;
      var $156=__stackBase__+608;
      var $157=__stackBase__+612;
      var $158=__stackBase__+616;
      var $159=__stackBase__+620;
      var $__t_i_i_i=__stackBase__+624;
      var $160=__stackBase__+628;
      var $161=__stackBase__+632;
      var $162=__stackBase__+636;
      var $163=__stackBase__+640;
      var $164=__stackBase__+644;
      var $165=__stackBase__+648;
      var $166=__stackBase__+652;
      var $167=__stackBase__+656;
      var $168=__stackBase__+660;
      var $169=__stackBase__+664;
      var $170=__stackBase__+668;
      var $171=__stackBase__+672;
      var $172=__stackBase__+676;
      var $173=__stackBase__+680;
      var $174=__stackBase__+684;
      var $175=__stackBase__+688;
      var $176=__stackBase__+692;
      var $177=__stackBase__+696;
      var $178=__stackBase__+700;
      var $179=__stackBase__+704;
      var $180=__stackBase__+708;
      var $181=__stackBase__+712;
      var $182=__stackBase__+716;
      var $183=__stackBase__+720;
      var $184=__stackBase__+724;
      var $185=__stackBase__+728;
      var $186=__stackBase__+732;
      var $187=__stackBase__+736;
      var $188=__stackBase__+740;
      var $189=__stackBase__+744;
      var $190=__stackBase__+748;
      var $191=__stackBase__+752;
      var $192=__stackBase__+756;
      var $193=__stackBase__+760;
      var $194=__stackBase__+764;
      var $195=__stackBase__+768;
      var $196=__stackBase__+772;
      var $197=__stackBase__+776;
      var $198=__stackBase__+780;
      var $199=__stackBase__+784;
      var $200=__stackBase__+788;
      var $201=__stackBase__+792;
      var $202=__stackBase__+796;
      var $203=__stackBase__+800;
      var $204=__stackBase__+804;
      var $205=__stackBase__+808;
      var $206=__stackBase__+812;
      var $207=__stackBase__+816;
      var $208=__stackBase__+820;
      var $209=__stackBase__+824;
      var $210=__stackBase__+828;
      var $211=__stackBase__+832;
      var $212=__stackBase__+836;
      var $213=__stackBase__+840;
      var $214=__stackBase__+844;
      var $215=__stackBase__+848;
      var $216=__stackBase__+852;
      var $217=__stackBase__+856;
      var $218=__stackBase__+860;
      var $219=__stackBase__+864;
      var $220=__stackBase__+868;
      var $221=__stackBase__+872;
      var $222=__stackBase__+876;
      var $223=__stackBase__+880;
      var $224=__stackBase__+884;
      var $225=__stackBase__+888;
      var $226=__stackBase__+892;
      var $227=__stackBase__+896;
      var $228=__stackBase__+900;
      var $229=__stackBase__+904;
      var $230=__stackBase__+908;
      var $231=__stackBase__+912;
      var $232=__stackBase__+916;
      var $233=__stackBase__+920;
      var $234=__stackBase__+924;
      var $235=__stackBase__+928;
      var $236=__stackBase__+932;
      var $237=__stackBase__+936;
      var $238=__stackBase__+940;
      var $239=__stackBase__+944;
      var $240=__stackBase__+948;
      var $241=__stackBase__+952;
      var $242=__stackBase__+956;
      var $243=__stackBase__+960;
      var $244=__stackBase__+964;
      var $245=__stackBase__+968;
      var $246=__stackBase__+972;
      var $247=__stackBase__+976;
      var $248=__stackBase__+980;
      var $249=__stackBase__+984;
      var $250=__stackBase__+988;
      var $251=__stackBase__+992;
      var $252=__stackBase__+996;
      var $253=__stackBase__+1000;
      var $254=__stackBase__+1004;
      var $255;
      var $256;
      var $257;
      var $258;
      var $259;
      var $260;
      var $261;
      var $262;
      var $263;
      var $264;
      var $265;
      var $266;
      var $267;
      var $268;
      var $269;
      var $270;
      var $__p;
      var $271=__stackBase__+1008;
      var $272=__stackBase__+1012;
      var $__t;
      var $__d;
      var $__f;
      var $__z;
      var $__ng;
      var $__ig;
      var $__gl;
      var $273=__stackBase__+1016;
      var $274=__stackBase__+1020;
      var $275=__stackBase__+1024;
      $256=$__mb;
      $257=$__mi;
      $258=$__me;
      $259=$__flags;
      $260=$__db;
      $261=$__de;
      $262=$__ct;
      var $276=(($__neg)&1);
      $263=$276;
      $264=$__pat;
      $265=$__dp;
      $266=$__ts;
      $267=$__grp;
      $268=$__sym;
      $269=$__sn;
      $270=$__fd;
      var $277=$256;
      var $278=$258;
      HEAP32[(($278)>>2)]=$277;
      $__p=0;
      __label__ = 1; break;
    case 1: // $279
      var $280=$__p;
      var $281=(($280)>>>0) < 4;
      if ($281) { __label__ = 2; break; } else { __label__ = 98; break; }
    case 2: // $282
      var $283=$__p;
      var $284=$264;
      var $285=(($284)|0);
      var $286=(($285+$283)|0);
      var $287=HEAP8[($286)];
      var $288=(($287 << 24) >> 24);
      if ($288 == 0) {
        __label__ = 3; break;
      }
      else if ($288 == 1) {
        __label__ = 4; break;
      }
      else if ($288 == 3) {
        __label__ = 5; break;
      }
      else if ($288 == 2) {
        __label__ = 14; break;
      }
      else if ($288 == 4) {
        __label__ = 33; break;
      }
      else {
      __label__ = 96; break;
      }
      
    case 3: // $289
      var $290=$258;
      var $291=HEAP32[(($290)>>2)];
      var $292=$257;
      HEAP32[(($292)>>2)]=$291;
      __label__ = 96; break;
    case 4: // $293
      var $294=$258;
      var $295=HEAP32[(($294)>>2)];
      var $296=$257;
      HEAP32[(($296)>>2)]=$295;
      var $297=$262;
      var $298=$254;
      HEAP32[(($254)>>2)]=$297;
      $255=32;
      var $299=HEAP32[(($254)>>2)];
      var $300=$299;
      var $301=HEAP32[(($300)>>2)];
      var $302=(($301+28)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=$255;
      var $305=FUNCTION_TABLE[$303]($299, $304);
      var $306=$254;
      var $307=$258;
      var $308=HEAP32[(($307)>>2)];
      var $309=(($308+1)|0);
      HEAP32[(($307)>>2)]=$309;
      HEAP8[($308)]=$305;
      __label__ = 96; break;
    case 5: // $310
      var $311=$269;
      var $312=$253;
      HEAP32[(($253)>>2)]=$311;
      var $313=HEAP32[(($253)>>2)];
      var $314=$252;
      HEAP32[(($252)>>2)]=$313;
      var $315=HEAPU32[(($252)>>2)];
      var $316=$251;
      HEAP32[(($251)>>2)]=$315;
      var $317=HEAP32[(($251)>>2)];
      var $318=(($317)|0);
      var $319=$250;
      HEAP32[(($250)>>2)]=$318;
      var $320=HEAP32[(($250)>>2)];
      var $321=$320;
      var $322=$249;
      HEAP32[(($249)>>2)]=$321;
      var $323=HEAP32[(($249)>>2)];
      var $324=(($323)|0);
      var $325=$249;
      var $326=$250;
      var $327=(($324)|0);
      var $328=$327;
      var $329=(($328)|0);
      var $330=$329;
      var $331=HEAPU8[($330)];
      var $332=(($331)&255);
      var $333=$332 & 1;
      var $334=(($333)|0)!=0;
      var $335=$251;
      if ($334) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $336
      var $337=$245;
      HEAP32[(($245)>>2)]=$315;
      var $338=HEAP32[(($245)>>2)];
      var $339=(($338)|0);
      var $340=$244;
      HEAP32[(($244)>>2)]=$339;
      var $341=HEAP32[(($244)>>2)];
      var $342=$341;
      var $343=$243;
      HEAP32[(($243)>>2)]=$342;
      var $344=HEAP32[(($243)>>2)];
      var $345=(($344)|0);
      var $346=$243;
      var $347=$244;
      var $348=(($345)|0);
      var $349=$348;
      var $350=(($349+4)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=$245;
      var $373 = $351;__label__ = 8; break;
    case 7: // $353
      var $354=$248;
      HEAP32[(($248)>>2)]=$315;
      var $355=HEAP32[(($248)>>2)];
      var $356=(($355)|0);
      var $357=$247;
      HEAP32[(($247)>>2)]=$356;
      var $358=HEAP32[(($247)>>2)];
      var $359=$358;
      var $360=$246;
      HEAP32[(($246)>>2)]=$359;
      var $361=HEAP32[(($246)>>2)];
      var $362=(($361)|0);
      var $363=$246;
      var $364=$247;
      var $365=(($362)|0);
      var $366=$365;
      var $367=(($366)|0);
      var $368=$367;
      var $369=HEAPU8[($368)];
      var $370=(($369)&255);
      var $371=$370 >> 1;
      var $372=$248;
      var $373 = $371;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $373;
      var $374=$252;
      var $375=(($373)|0)==0;
      var $376=$253;
      if ($375) { __label__ = 13; break; } else { __label__ = 9; break; }
    case 9: // $377
      var $378=$269;
      var $379=$91;
      var $380=$92;
      HEAP32[(($91)>>2)]=$378;
      HEAP32[(($92)>>2)]=0;
      var $381=HEAP32[(($91)>>2)];
      var $382=$90;
      HEAP32[(($90)>>2)]=$381;
      var $383=HEAP32[(($90)>>2)];
      var $384=$89;
      HEAP32[(($89)>>2)]=$383;
      var $385=HEAPU32[(($89)>>2)];
      var $386=$88;
      HEAP32[(($88)>>2)]=$385;
      var $387=HEAP32[(($88)>>2)];
      var $388=(($387)|0);
      var $389=$87;
      HEAP32[(($87)>>2)]=$388;
      var $390=HEAP32[(($87)>>2)];
      var $391=$390;
      var $392=$86;
      HEAP32[(($86)>>2)]=$391;
      var $393=HEAP32[(($86)>>2)];
      var $394=(($393)|0);
      var $395=$86;
      var $396=$87;
      var $397=(($394)|0);
      var $398=$397;
      var $399=(($398)|0);
      var $400=$399;
      var $401=HEAPU8[($400)];
      var $402=(($401)&255);
      var $403=$402 & 1;
      var $404=(($403)|0)!=0;
      var $405=$88;
      if ($404) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $406
      var $407=$82;
      HEAP32[(($82)>>2)]=$385;
      var $408=HEAP32[(($82)>>2)];
      var $409=(($408)|0);
      var $410=$81;
      HEAP32[(($81)>>2)]=$409;
      var $411=HEAP32[(($81)>>2)];
      var $412=$411;
      var $413=$80;
      HEAP32[(($80)>>2)]=$412;
      var $414=HEAP32[(($80)>>2)];
      var $415=(($414)|0);
      var $416=$80;
      var $417=$81;
      var $418=(($415)|0);
      var $419=$418;
      var $420=(($419+8)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=$82;
      var $440 = $421;__label__ = 12; break;
    case 11: // $423
      var $424=$85;
      HEAP32[(($85)>>2)]=$385;
      var $425=HEAP32[(($85)>>2)];
      var $426=(($425)|0);
      var $427=$84;
      HEAP32[(($84)>>2)]=$426;
      var $428=HEAP32[(($84)>>2)];
      var $429=$428;
      var $430=$83;
      HEAP32[(($83)>>2)]=$429;
      var $431=HEAP32[(($83)>>2)];
      var $432=(($431)|0);
      var $433=$83;
      var $434=$84;
      var $435=(($432)|0);
      var $436=$435;
      var $437=(($436+1)|0);
      var $438=(($437)|0);
      var $439=$85;
      var $440 = $438;__label__ = 12; break;
    case 12: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit15
      var $440;
      var $441=$89;
      var $442=$90;
      var $443=HEAP32[(($92)>>2)];
      var $444=(($440+$443)|0);
      var $445=$91;
      var $446=$92;
      var $447=HEAP8[($444)];
      var $448=$258;
      var $449=HEAP32[(($448)>>2)];
      var $450=(($449+1)|0);
      HEAP32[(($448)>>2)]=$450;
      HEAP8[($449)]=$447;
      __label__ = 13; break;
    case 13: // $451
      __label__ = 96; break;
    case 14: // $452
      var $453=$268;
      var $454=$77;
      HEAP32[(($77)>>2)]=$453;
      var $455=HEAP32[(($77)>>2)];
      var $456=$76;
      HEAP32[(($76)>>2)]=$455;
      var $457=HEAPU32[(($76)>>2)];
      var $458=$75;
      HEAP32[(($75)>>2)]=$457;
      var $459=HEAP32[(($75)>>2)];
      var $460=(($459)|0);
      var $461=$74;
      HEAP32[(($74)>>2)]=$460;
      var $462=HEAP32[(($74)>>2)];
      var $463=$462;
      var $464=$73;
      HEAP32[(($73)>>2)]=$463;
      var $465=HEAP32[(($73)>>2)];
      var $466=(($465)|0);
      var $467=$73;
      var $468=$74;
      var $469=(($466)|0);
      var $470=$469;
      var $471=(($470)|0);
      var $472=$471;
      var $473=HEAPU8[($472)];
      var $474=(($473)&255);
      var $475=$474 & 1;
      var $476=(($475)|0)!=0;
      var $477=$75;
      if ($476) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $478
      var $479=$69;
      HEAP32[(($69)>>2)]=$457;
      var $480=HEAP32[(($69)>>2)];
      var $481=(($480)|0);
      var $482=$68;
      HEAP32[(($68)>>2)]=$481;
      var $483=HEAP32[(($68)>>2)];
      var $484=$483;
      var $485=$67;
      HEAP32[(($67)>>2)]=$484;
      var $486=HEAP32[(($67)>>2)];
      var $487=(($486)|0);
      var $488=$67;
      var $489=$68;
      var $490=(($487)|0);
      var $491=$490;
      var $492=(($491+4)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=$69;
      var $515 = $493;__label__ = 17; break;
    case 16: // $495
      var $496=$72;
      HEAP32[(($72)>>2)]=$457;
      var $497=HEAP32[(($72)>>2)];
      var $498=(($497)|0);
      var $499=$71;
      HEAP32[(($71)>>2)]=$498;
      var $500=HEAP32[(($71)>>2)];
      var $501=$500;
      var $502=$70;
      HEAP32[(($70)>>2)]=$501;
      var $503=HEAP32[(($70)>>2)];
      var $504=(($503)|0);
      var $505=$70;
      var $506=$71;
      var $507=(($504)|0);
      var $508=$507;
      var $509=(($508)|0);
      var $510=$509;
      var $511=HEAPU8[($510)];
      var $512=(($511)&255);
      var $513=$512 >> 1;
      var $514=$72;
      var $515 = $513;__label__ = 17; break;
    case 17: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit16
      var $515;
      var $516=$76;
      var $517=(($515)|0)==0;
      var $518=$77;
      if ($517) { __label__ = 32; break; } else { __label__ = 18; break; }
    case 18: // $519
      var $520=$259;
      var $521=$520 & 512;
      var $522=(($521)|0)!=0;
      if ($522) { __label__ = 19; break; } else { __label__ = 32; break; }
    case 19: // $523
      var $524=$268;
      var $525=$16;
      HEAP32[(($16)>>2)]=$524;
      var $526=HEAP32[(($16)>>2)];
      var $527=$15;
      HEAP32[(($15)>>2)]=$526;
      var $528=HEAP32[(($15)>>2)];
      var $529=$14;
      HEAP32[(($14)>>2)]=$528;
      var $530=HEAPU32[(($14)>>2)];
      var $531=$13;
      HEAP32[(($13)>>2)]=$530;
      var $532=HEAP32[(($13)>>2)];
      var $533=(($532)|0);
      var $534=$12;
      HEAP32[(($12)>>2)]=$533;
      var $535=HEAP32[(($12)>>2)];
      var $536=$535;
      var $537=$11;
      HEAP32[(($11)>>2)]=$536;
      var $538=HEAP32[(($11)>>2)];
      var $539=(($538)|0);
      var $540=$11;
      var $541=$12;
      var $542=(($539)|0);
      var $543=$542;
      var $544=(($543)|0);
      var $545=$544;
      var $546=HEAPU8[($545)];
      var $547=(($546)&255);
      var $548=$547 & 1;
      var $549=(($548)|0)!=0;
      var $550=$13;
      if ($549) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $551
      var $552=$7;
      HEAP32[(($7)>>2)]=$530;
      var $553=HEAP32[(($7)>>2)];
      var $554=(($553)|0);
      var $555=$6;
      HEAP32[(($6)>>2)]=$554;
      var $556=HEAP32[(($6)>>2)];
      var $557=$556;
      var $558=$5;
      HEAP32[(($5)>>2)]=$557;
      var $559=HEAP32[(($5)>>2)];
      var $560=(($559)|0);
      var $561=$5;
      var $562=$6;
      var $563=(($560)|0);
      var $564=$563;
      var $565=(($564+8)|0);
      var $566=HEAP32[(($565)>>2)];
      var $567=$7;
      var $585 = $566;__label__ = 22; break;
    case 21: // $568
      var $569=$10;
      HEAP32[(($10)>>2)]=$530;
      var $570=HEAP32[(($10)>>2)];
      var $571=(($570)|0);
      var $572=$9;
      HEAP32[(($9)>>2)]=$571;
      var $573=HEAP32[(($9)>>2)];
      var $574=$573;
      var $575=$8;
      HEAP32[(($8)>>2)]=$574;
      var $576=HEAP32[(($8)>>2)];
      var $577=(($576)|0);
      var $578=$8;
      var $579=$9;
      var $580=(($577)|0);
      var $581=$580;
      var $582=(($581+1)|0);
      var $583=(($582)|0);
      var $584=$10;
      var $585 = $583;__label__ = 22; break;
    case 22: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv_exit33
      var $585;
      var $586=$14;
      var $587=$15;
      var $588=$3;
      var $589=$4;
      HEAP32[(($3)>>2)]=$271;
      HEAP32[(($4)>>2)]=$585;
      var $590=HEAP32[(($3)>>2)];
      var $591=HEAP32[(($4)>>2)];
      var $592=$1;
      var $593=$2;
      HEAP32[(($1)>>2)]=$590;
      HEAP32[(($2)>>2)]=$591;
      var $594=HEAP32[(($1)>>2)];
      var $595=(($594)|0);
      var $596=HEAP32[(($2)>>2)];
      HEAP32[(($595)>>2)]=$596;
      var $597=$1;
      var $598=$2;
      var $599=$3;
      var $600=$4;
      var $601=$16;
      var $602=$268;
      var $603=$42;
      HEAP32[(($42)>>2)]=$602;
      var $604=HEAPU32[(($42)>>2)];
      var $605=$41;
      HEAP32[(($41)>>2)]=$604;
      var $606=HEAP32[(($41)>>2)];
      var $607=$40;
      HEAP32[(($40)>>2)]=$606;
      var $608=HEAPU32[(($40)>>2)];
      var $609=$39;
      HEAP32[(($39)>>2)]=$608;
      var $610=HEAP32[(($39)>>2)];
      var $611=(($610)|0);
      var $612=$38;
      HEAP32[(($38)>>2)]=$611;
      var $613=HEAP32[(($38)>>2)];
      var $614=$613;
      var $615=$37;
      HEAP32[(($37)>>2)]=$614;
      var $616=HEAP32[(($37)>>2)];
      var $617=(($616)|0);
      var $618=$37;
      var $619=$38;
      var $620=(($617)|0);
      var $621=$620;
      var $622=(($621)|0);
      var $623=$622;
      var $624=HEAPU8[($623)];
      var $625=(($624)&255);
      var $626=$625 & 1;
      var $627=(($626)|0)!=0;
      var $628=$39;
      if ($627) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $629
      var $630=$33;
      HEAP32[(($33)>>2)]=$608;
      var $631=HEAP32[(($33)>>2)];
      var $632=(($631)|0);
      var $633=$32;
      HEAP32[(($32)>>2)]=$632;
      var $634=HEAP32[(($32)>>2)];
      var $635=$634;
      var $636=$31;
      HEAP32[(($31)>>2)]=$635;
      var $637=HEAP32[(($31)>>2)];
      var $638=(($637)|0);
      var $639=$31;
      var $640=$32;
      var $641=(($638)|0);
      var $642=$641;
      var $643=(($642+8)|0);
      var $644=HEAP32[(($643)>>2)];
      var $645=$33;
      var $663 = $644;__label__ = 25; break;
    case 24: // $646
      var $647=$36;
      HEAP32[(($36)>>2)]=$608;
      var $648=HEAP32[(($36)>>2)];
      var $649=(($648)|0);
      var $650=$35;
      HEAP32[(($35)>>2)]=$649;
      var $651=HEAP32[(($35)>>2)];
      var $652=$651;
      var $653=$34;
      HEAP32[(($34)>>2)]=$652;
      var $654=HEAP32[(($34)>>2)];
      var $655=(($654)|0);
      var $656=$34;
      var $657=$35;
      var $658=(($655)|0);
      var $659=$658;
      var $660=(($659+1)|0);
      var $661=(($660)|0);
      var $662=$36;
      var $663 = $661;__label__ = 25; break;
    case 25: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit_i30
      var $663;
      var $664=$40;
      var $665=$41;
      var $666=$26;
      HEAP32[(($26)>>2)]=$604;
      var $667=HEAPU32[(($26)>>2)];
      var $668=$25;
      HEAP32[(($25)>>2)]=$667;
      var $669=HEAP32[(($25)>>2)];
      var $670=(($669)|0);
      var $671=$24;
      HEAP32[(($24)>>2)]=$670;
      var $672=HEAP32[(($24)>>2)];
      var $673=$672;
      var $674=$23;
      HEAP32[(($23)>>2)]=$673;
      var $675=HEAP32[(($23)>>2)];
      var $676=(($675)|0);
      var $677=$23;
      var $678=$24;
      var $679=(($676)|0);
      var $680=$679;
      var $681=(($680)|0);
      var $682=$681;
      var $683=HEAPU8[($682)];
      var $684=(($683)&255);
      var $685=$684 & 1;
      var $686=(($685)|0)!=0;
      var $687=$25;
      if ($686) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $688
      var $689=$19;
      HEAP32[(($19)>>2)]=$667;
      var $690=HEAP32[(($19)>>2)];
      var $691=(($690)|0);
      var $692=$18;
      HEAP32[(($18)>>2)]=$691;
      var $693=HEAP32[(($18)>>2)];
      var $694=$693;
      var $695=$17;
      HEAP32[(($17)>>2)]=$694;
      var $696=HEAP32[(($17)>>2)];
      var $697=(($696)|0);
      var $698=$17;
      var $699=$18;
      var $700=(($697)|0);
      var $701=$700;
      var $702=(($701+4)|0);
      var $703=HEAP32[(($702)>>2)];
      var $704=$19;
      var $725 = $703;__label__ = 28; break;
    case 27: // $705
      var $706=$22;
      HEAP32[(($22)>>2)]=$667;
      var $707=HEAP32[(($22)>>2)];
      var $708=(($707)|0);
      var $709=$21;
      HEAP32[(($21)>>2)]=$708;
      var $710=HEAP32[(($21)>>2)];
      var $711=$710;
      var $712=$20;
      HEAP32[(($20)>>2)]=$711;
      var $713=HEAP32[(($20)>>2)];
      var $714=(($713)|0);
      var $715=$20;
      var $716=$21;
      var $717=(($714)|0);
      var $718=$717;
      var $719=(($718)|0);
      var $720=$719;
      var $721=HEAPU8[($720)];
      var $722=(($721)&255);
      var $723=$722 >> 1;
      var $724=$22;
      var $725 = $723;__label__ = 28; break;
    case 28: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv_exit31
      var $725;
      var $726=$26;
      var $727=(($663+$725)|0);
      var $728=$29;
      var $729=$30;
      HEAP32[(($29)>>2)]=$272;
      HEAP32[(($30)>>2)]=$727;
      var $730=HEAP32[(($29)>>2)];
      var $731=HEAP32[(($30)>>2)];
      var $732=$27;
      var $733=$28;
      HEAP32[(($27)>>2)]=$730;
      HEAP32[(($28)>>2)]=$731;
      var $734=HEAP32[(($27)>>2)];
      var $735=(($734)|0);
      var $736=HEAP32[(($28)>>2)];
      HEAP32[(($735)>>2)]=$736;
      var $737=$27;
      var $738=$28;
      var $739=$29;
      var $740=$30;
      var $741=$42;
      var $742=$258;
      var $743=HEAP32[(($742)>>2)];
      var $tmp17=$63;
      var $tmp18=$271;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp17)]=HEAP8[($tmp18)];HEAP8[($tmp17+1)]=HEAP8[($tmp18+1)];HEAP8[($tmp17+2)]=HEAP8[($tmp18+2)];HEAP8[($tmp17+3)]=HEAP8[($tmp18+3)];
      var $tmp19=$62;
      var $tmp20=$272;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp19)]=HEAP8[($tmp20)];HEAP8[($tmp19+1)]=HEAP8[($tmp20+1)];HEAP8[($tmp19+2)]=HEAP8[($tmp20+2)];HEAP8[($tmp19+3)]=HEAP8[($tmp20+3)];
      var $744=$43;
      var $745=$54;
      var $746=$55;
      var $747=$56;
      var $748=$57;
      var $749=$58;
      var $750=$59;
      var $751=$60;
      var $752=$61;
      HEAP32[(($57)>>2)]=$743;
      var $753=$59;
      var $754=$63;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($753)>>2)]=HEAP32[(($754)>>2)];
      var $tmp_i21=$56;
      var $tmp1_i22=$59;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i21)]=HEAP8[($tmp1_i22)];HEAP8[($tmp_i21+1)]=HEAP8[($tmp1_i22+1)];HEAP8[($tmp_i21+2)]=HEAP8[($tmp1_i22+2)];HEAP8[($tmp_i21+3)]=HEAP8[($tmp1_i22+3)];
      var $755=$58;
      var $756=$56;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($755)>>2)]=HEAP32[(($756)>>2)];
      var $757=$61;
      var $758=$62;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($757)>>2)]=HEAP32[(($758)>>2)];
      var $tmp6_i23=$43;
      var $tmp7_i24=$61;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp6_i23)]=HEAP8[($tmp7_i24)];HEAP8[($tmp6_i23+1)]=HEAP8[($tmp7_i24+1)];HEAP8[($tmp6_i23+2)]=HEAP8[($tmp7_i24+2)];HEAP8[($tmp6_i23+3)]=HEAP8[($tmp7_i24+3)];
      var $759=$60;
      var $760=$43;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($759)>>2)]=HEAP32[(($760)>>2)];
      var $761=HEAP32[(($57)>>2)];
      var $762=$44;
      HEAP32[(($44)>>2)]=$761;
      var $763=HEAP32[(($44)>>2)];
      var $764=$44;
      var $tmp2_i25=$55;
      var $tmp3_i26=$58;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2_i25)]=HEAP8[($tmp3_i26)];HEAP8[($tmp2_i25+1)]=HEAP8[($tmp3_i26+1)];HEAP8[($tmp2_i25+2)]=HEAP8[($tmp3_i26+2)];HEAP8[($tmp2_i25+3)]=HEAP8[($tmp3_i26+3)];
      var $tmp4_i27=$54;
      var $tmp5_i28=$60;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp4_i27)]=HEAP8[($tmp5_i28)];HEAP8[($tmp4_i27+1)]=HEAP8[($tmp5_i28+1)];HEAP8[($tmp4_i27+2)]=HEAP8[($tmp5_i28+2)];HEAP8[($tmp4_i27+3)]=HEAP8[($tmp5_i28+3)];
      var $765=$53;
      HEAP32[(($53)>>2)]=$763;
      __label__ = 29; break;
    case 29: // $766
      var $767=$51;
      var $768=$52;
      HEAP32[(($51)>>2)]=$55;
      HEAP32[(($52)>>2)]=$54;
      var $769=HEAP32[(($51)>>2)];
      var $770=HEAP32[(($52)>>2)];
      var $771=$49;
      var $772=$50;
      HEAP32[(($49)>>2)]=$769;
      HEAP32[(($50)>>2)]=$770;
      var $773=HEAP32[(($49)>>2)];
      var $774=$48;
      HEAP32[(($48)>>2)]=$773;
      var $775=HEAP32[(($48)>>2)];
      var $776=(($775)|0);
      var $777=HEAP32[(($776)>>2)];
      var $778=$48;
      var $779=HEAP32[(($50)>>2)];
      var $780=$47;
      HEAP32[(($47)>>2)]=$779;
      var $781=HEAP32[(($47)>>2)];
      var $782=(($781)|0);
      var $783=HEAP32[(($782)>>2)];
      var $784=$47;
      var $785=(($777)|0)==(($783)|0);
      var $786=$49;
      var $787=$50;
      var $788=$785 ^ 1;
      var $789=$51;
      var $790=$52;
      if ($788) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $791
      var $792=$45;
      HEAP32[(($45)>>2)]=$55;
      var $793=HEAP32[(($45)>>2)];
      var $794=(($793)|0);
      var $795=HEAP32[(($794)>>2)];
      var $796=$45;
      var $797=HEAP8[($795)];
      var $798=HEAP32[(($53)>>2)];
      HEAP8[($798)]=$797;
      var $799=$46;
      HEAP32[(($46)>>2)]=$55;
      var $800=HEAP32[(($46)>>2)];
      var $801=(($800)|0);
      var $802=HEAP32[(($801)>>2)];
      var $803=(($802+1)|0);
      HEAP32[(($801)>>2)]=$803;
      var $804=$46;
      var $805=HEAP32[(($53)>>2)];
      var $806=(($805+1)|0);
      HEAP32[(($53)>>2)]=$806;
      __label__ = 29; break;
    case 31: // $_ZNSt3__14copyINS_11__wrap_iterIPKcEEPcEET0_T_S7_S6__exit29
      var $807=HEAP32[(($53)>>2)];
      var $808=$53;
      var $809=$43;
      var $810=$54;
      var $811=$55;
      var $812=$56;
      var $813=$57;
      var $814=$58;
      var $815=$59;
      var $816=$60;
      var $817=$61;
      var $818=$258;
      HEAP32[(($818)>>2)]=$807;
      __label__ = 32; break;
    case 32: // $819
      __label__ = 96; break;
    case 33: // $820
      var $821=$258;
      var $822=HEAP32[(($821)>>2)];
      $__t=$822;
      var $823=$263;
      var $824=(($823) & 1);
      if ($824) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $825
      var $826=$260;
      var $827=(($826+1)|0);
      $260=$827;
      __label__ = 35; break;
    case 35: // $828
      var $829=$260;
      $__d=$829;
      __label__ = 36; break;
    case 36: // $830
      var $831=$__d;
      var $832=$261;
      var $833=(($831)>>>0) < (($832)>>>0);
      if ($833) { __label__ = 37; break; } else { __label__ = 44; break; }
    case 37: // $834
      var $835=$262;
      var $836=$__d;
      var $837=HEAP8[($836)];
      var $838=$64;
      var $839=$65;
      HEAP32[(($64)>>2)]=$835;
      HEAP32[(($65)>>2)]=1024;
      $66=$837;
      var $840=HEAP32[(($64)>>2)];
      var $841=$66;
      var $842=(($841 << 24) >> 24);
      var $843=(($842)>>>0) <= 127;
      if ($843) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $844
      var $845=$66;
      var $846=(($845 << 24) >> 24);
      var $847=(($840+8)|0);
      var $848=HEAP32[(($847)>>2)];
      var $849=(($848+($846<<2))|0);
      var $850=HEAP32[(($849)>>2)];
      var $851=HEAP32[(($65)>>2)];
      var $852=$850 & $851;
      var $854 = $852;__label__ = 40; break;
    case 39: // $853
      var $854 = 0;__label__ = 40; break;
    case 40: // $_ZNKSt3__15ctypeIcE2isEjc_exit
      var $854;
      var $855=(($854)|0)!=0;
      var $856=$64;
      var $857=$65;
      if ($855) { __label__ = 42; break; } else { __label__ = 41; break; }
    case 41: // $858
      __label__ = 44; break;
    case 42: // $859
      __label__ = 43; break;
    case 43: // $860
      var $861=$__d;
      var $862=(($861+1)|0);
      $__d=$862;
      __label__ = 36; break;
    case 44: // $863
      var $864=$270;
      var $865=(($864)|0) > 0;
      if ($865) { __label__ = 45; break; } else { __label__ = 59; break; }
    case 45: // $866
      var $867=$270;
      $__f=$867;
      __label__ = 46; break;
    case 46: // $868
      var $869=$__d;
      var $870=$260;
      var $871=(($869)>>>0) > (($870)>>>0);
      if ($871) { __label__ = 47; break; } else { var $876 = 0;__label__ = 48; break; }
    case 47: // $872
      var $873=$__f;
      var $874=(($873)|0) > 0;
      var $876 = $874;__label__ = 48; break;
    case 48: // $875
      var $876;
      if ($876) { __label__ = 49; break; } else { __label__ = 51; break; }
    case 49: // $877
      var $878=$__d;
      var $879=(($878-1)|0);
      $__d=$879;
      var $880=HEAP8[($879)];
      var $881=$258;
      var $882=HEAP32[(($881)>>2)];
      var $883=(($882+1)|0);
      HEAP32[(($881)>>2)]=$883;
      HEAP8[($882)]=$880;
      __label__ = 50; break;
    case 50: // $884
      var $885=$__f;
      var $886=(($885-1)|0);
      $__f=$886;
      __label__ = 46; break;
    case 51: // $887
      var $888=$__f;
      var $889=(($888)|0) > 0;
      if ($889) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $890
      var $891=$262;
      var $892=$78;
      HEAP32[(($78)>>2)]=$891;
      $79=48;
      var $893=HEAP32[(($78)>>2)];
      var $894=$893;
      var $895=HEAP32[(($894)>>2)];
      var $896=(($895+28)|0);
      var $897=HEAP32[(($896)>>2)];
      var $898=$79;
      var $899=FUNCTION_TABLE[$897]($893, $898);
      var $900=$78;
      var $903 = $899;__label__ = 54; break;
    case 53: // $901
      var $903 = 0;__label__ = 54; break;
    case 54: // $902
      var $903;
      $__z=$903;
      __label__ = 55; break;
    case 55: // $904
      var $905=$__f;
      var $906=(($905)|0) > 0;
      if ($906) { __label__ = 56; break; } else { __label__ = 58; break; }
    case 56: // $907
      var $908=$__z;
      var $909=$258;
      var $910=HEAP32[(($909)>>2)];
      var $911=(($910+1)|0);
      HEAP32[(($909)>>2)]=$911;
      HEAP8[($910)]=$908;
      __label__ = 57; break;
    case 57: // $912
      var $913=$__f;
      var $914=(($913-1)|0);
      $__f=$914;
      __label__ = 55; break;
    case 58: // $915
      var $916=$265;
      var $917=$258;
      var $918=HEAP32[(($917)>>2)];
      var $919=(($918+1)|0);
      HEAP32[(($917)>>2)]=$919;
      HEAP8[($918)]=$916;
      __label__ = 59; break;
    case 59: // $920
      var $921=$__d;
      var $922=$260;
      var $923=(($921)|0)==(($922)|0);
      if ($923) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $924
      var $925=$262;
      var $926=$93;
      HEAP32[(($93)>>2)]=$925;
      $94=48;
      var $927=HEAP32[(($93)>>2)];
      var $928=$927;
      var $929=HEAP32[(($928)>>2)];
      var $930=(($929+28)|0);
      var $931=HEAP32[(($930)>>2)];
      var $932=$94;
      var $933=FUNCTION_TABLE[$931]($927, $932);
      var $934=$93;
      var $935=$258;
      var $936=HEAP32[(($935)>>2)];
      var $937=(($936+1)|0);
      HEAP32[(($935)>>2)]=$937;
      HEAP8[($936)]=$933;
      __label__ = 90; break;
    case 61: // $938
      $__ng=0;
      $__ig=0;
      var $939=$267;
      var $940=$105;
      HEAP32[(($105)>>2)]=$939;
      var $941=HEAP32[(($105)>>2)];
      var $942=$104;
      HEAP32[(($104)>>2)]=$941;
      var $943=HEAPU32[(($104)>>2)];
      var $944=$103;
      HEAP32[(($103)>>2)]=$943;
      var $945=HEAP32[(($103)>>2)];
      var $946=(($945)|0);
      var $947=$102;
      HEAP32[(($102)>>2)]=$946;
      var $948=HEAP32[(($102)>>2)];
      var $949=$948;
      var $950=$101;
      HEAP32[(($101)>>2)]=$949;
      var $951=HEAP32[(($101)>>2)];
      var $952=(($951)|0);
      var $953=$101;
      var $954=$102;
      var $955=(($952)|0);
      var $956=$955;
      var $957=(($956)|0);
      var $958=$957;
      var $959=HEAPU8[($958)];
      var $960=(($959)&255);
      var $961=$960 & 1;
      var $962=(($961)|0)!=0;
      var $963=$103;
      if ($962) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $964
      var $965=$97;
      HEAP32[(($97)>>2)]=$943;
      var $966=HEAP32[(($97)>>2)];
      var $967=(($966)|0);
      var $968=$96;
      HEAP32[(($96)>>2)]=$967;
      var $969=HEAP32[(($96)>>2)];
      var $970=$969;
      var $971=$95;
      HEAP32[(($95)>>2)]=$970;
      var $972=HEAP32[(($95)>>2)];
      var $973=(($972)|0);
      var $974=$95;
      var $975=$96;
      var $976=(($973)|0);
      var $977=$976;
      var $978=(($977+4)|0);
      var $979=HEAP32[(($978)>>2)];
      var $980=$97;
      var $1001 = $979;__label__ = 64; break;
    case 63: // $981
      var $982=$100;
      HEAP32[(($100)>>2)]=$943;
      var $983=HEAP32[(($100)>>2)];
      var $984=(($983)|0);
      var $985=$99;
      HEAP32[(($99)>>2)]=$984;
      var $986=HEAP32[(($99)>>2)];
      var $987=$986;
      var $988=$98;
      HEAP32[(($98)>>2)]=$987;
      var $989=HEAP32[(($98)>>2)];
      var $990=(($989)|0);
      var $991=$98;
      var $992=$99;
      var $993=(($990)|0);
      var $994=$993;
      var $995=(($994)|0);
      var $996=$995;
      var $997=HEAPU8[($996)];
      var $998=(($997)&255);
      var $999=$998 >> 1;
      var $1000=$100;
      var $1001 = $999;__label__ = 64; break;
    case 64: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit13
      var $1001;
      var $1002=$104;
      var $1003=(($1001)|0)==0;
      var $1004=$105;
      if ($1003) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $1005
      var $1080 = -1;__label__ = 70; break;
    case 66: // $1006
      var $1007=$267;
      var $1008=$__ig;
      var $1009=$117;
      var $1010=$118;
      HEAP32[(($117)>>2)]=$1007;
      HEAP32[(($118)>>2)]=$1008;
      var $1011=HEAP32[(($117)>>2)];
      var $1012=$116;
      HEAP32[(($116)>>2)]=$1011;
      var $1013=HEAP32[(($116)>>2)];
      var $1014=$115;
      HEAP32[(($115)>>2)]=$1013;
      var $1015=HEAPU32[(($115)>>2)];
      var $1016=$114;
      HEAP32[(($114)>>2)]=$1015;
      var $1017=HEAP32[(($114)>>2)];
      var $1018=(($1017)|0);
      var $1019=$113;
      HEAP32[(($113)>>2)]=$1018;
      var $1020=HEAP32[(($113)>>2)];
      var $1021=$1020;
      var $1022=$112;
      HEAP32[(($112)>>2)]=$1021;
      var $1023=HEAP32[(($112)>>2)];
      var $1024=(($1023)|0);
      var $1025=$112;
      var $1026=$113;
      var $1027=(($1024)|0);
      var $1028=$1027;
      var $1029=(($1028)|0);
      var $1030=$1029;
      var $1031=HEAPU8[($1030)];
      var $1032=(($1031)&255);
      var $1033=$1032 & 1;
      var $1034=(($1033)|0)!=0;
      var $1035=$114;
      if ($1034) { __label__ = 67; break; } else { __label__ = 68; break; }
    case 67: // $1036
      var $1037=$108;
      HEAP32[(($108)>>2)]=$1015;
      var $1038=HEAP32[(($108)>>2)];
      var $1039=(($1038)|0);
      var $1040=$107;
      HEAP32[(($107)>>2)]=$1039;
      var $1041=HEAP32[(($107)>>2)];
      var $1042=$1041;
      var $1043=$106;
      HEAP32[(($106)>>2)]=$1042;
      var $1044=HEAP32[(($106)>>2)];
      var $1045=(($1044)|0);
      var $1046=$106;
      var $1047=$107;
      var $1048=(($1045)|0);
      var $1049=$1048;
      var $1050=(($1049+8)|0);
      var $1051=HEAP32[(($1050)>>2)];
      var $1052=$108;
      var $1070 = $1051;__label__ = 69; break;
    case 68: // $1053
      var $1054=$111;
      HEAP32[(($111)>>2)]=$1015;
      var $1055=HEAP32[(($111)>>2)];
      var $1056=(($1055)|0);
      var $1057=$110;
      HEAP32[(($110)>>2)]=$1056;
      var $1058=HEAP32[(($110)>>2)];
      var $1059=$1058;
      var $1060=$109;
      HEAP32[(($109)>>2)]=$1059;
      var $1061=HEAP32[(($109)>>2)];
      var $1062=(($1061)|0);
      var $1063=$109;
      var $1064=$110;
      var $1065=(($1062)|0);
      var $1066=$1065;
      var $1067=(($1066+1)|0);
      var $1068=(($1067)|0);
      var $1069=$111;
      var $1070 = $1068;__label__ = 69; break;
    case 69: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit12
      var $1070;
      var $1071=$115;
      var $1072=$116;
      var $1073=HEAP32[(($118)>>2)];
      var $1074=(($1070+$1073)|0);
      var $1075=$117;
      var $1076=$118;
      var $1077=HEAP8[($1074)];
      var $1078=(($1077 << 24) >> 24);
      var $1080 = $1078;__label__ = 70; break;
    case 70: // $1079
      var $1080;
      $__gl=$1080;
      __label__ = 71; break;
    case 71: // $1081
      var $1082=$__d;
      var $1083=$260;
      var $1084=(($1082)|0)!=(($1083)|0);
      if ($1084) { __label__ = 72; break; } else { __label__ = 89; break; }
    case 72: // $1085
      var $1086=$__ng;
      var $1087=$__gl;
      var $1088=(($1086)|0)==(($1087)|0);
      if ($1088) { __label__ = 73; break; } else { __label__ = 88; break; }
    case 73: // $1089
      var $1090=$266;
      var $1091=$258;
      var $1092=HEAP32[(($1091)>>2)];
      var $1093=(($1092+1)|0);
      HEAP32[(($1091)>>2)]=$1093;
      HEAP8[($1092)]=$1090;
      $__ng=0;
      var $1094=$__ig;
      var $1095=(($1094+1)|0);
      $__ig=$1095;
      var $1096=$267;
      var $1097=$128;
      HEAP32[(($128)>>2)]=$1096;
      var $1098=HEAPU32[(($128)>>2)];
      var $1099=$127;
      HEAP32[(($127)>>2)]=$1098;
      var $1100=HEAP32[(($127)>>2)];
      var $1101=(($1100)|0);
      var $1102=$126;
      HEAP32[(($126)>>2)]=$1101;
      var $1103=HEAP32[(($126)>>2)];
      var $1104=$1103;
      var $1105=$125;
      HEAP32[(($125)>>2)]=$1104;
      var $1106=HEAP32[(($125)>>2)];
      var $1107=(($1106)|0);
      var $1108=$125;
      var $1109=$126;
      var $1110=(($1107)|0);
      var $1111=$1110;
      var $1112=(($1111)|0);
      var $1113=$1112;
      var $1114=HEAPU8[($1113)];
      var $1115=(($1114)&255);
      var $1116=$1115 & 1;
      var $1117=(($1116)|0)!=0;
      var $1118=$127;
      if ($1117) { __label__ = 74; break; } else { __label__ = 75; break; }
    case 74: // $1119
      var $1120=$121;
      HEAP32[(($121)>>2)]=$1098;
      var $1121=HEAP32[(($121)>>2)];
      var $1122=(($1121)|0);
      var $1123=$120;
      HEAP32[(($120)>>2)]=$1122;
      var $1124=HEAP32[(($120)>>2)];
      var $1125=$1124;
      var $1126=$119;
      HEAP32[(($119)>>2)]=$1125;
      var $1127=HEAP32[(($119)>>2)];
      var $1128=(($1127)|0);
      var $1129=$119;
      var $1130=$120;
      var $1131=(($1128)|0);
      var $1132=$1131;
      var $1133=(($1132+4)|0);
      var $1134=HEAP32[(($1133)>>2)];
      var $1135=$121;
      var $1156 = $1134;__label__ = 76; break;
    case 75: // $1136
      var $1137=$124;
      HEAP32[(($124)>>2)]=$1098;
      var $1138=HEAP32[(($124)>>2)];
      var $1139=(($1138)|0);
      var $1140=$123;
      HEAP32[(($123)>>2)]=$1139;
      var $1141=HEAP32[(($123)>>2)];
      var $1142=$1141;
      var $1143=$122;
      HEAP32[(($122)>>2)]=$1142;
      var $1144=HEAP32[(($122)>>2)];
      var $1145=(($1144)|0);
      var $1146=$122;
      var $1147=$123;
      var $1148=(($1145)|0);
      var $1149=$1148;
      var $1150=(($1149)|0);
      var $1151=$1150;
      var $1152=HEAPU8[($1151)];
      var $1153=(($1152)&255);
      var $1154=$1153 >> 1;
      var $1155=$124;
      var $1156 = $1154;__label__ = 76; break;
    case 76: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit10
      var $1156;
      var $1157=$128;
      var $1158=(($1095)>>>0) < (($1156)>>>0);
      if ($1158) { __label__ = 77; break; } else { __label__ = 87; break; }
    case 77: // $1159
      var $1160=$267;
      var $1161=$__ig;
      var $1162=$140;
      var $1163=$141;
      HEAP32[(($140)>>2)]=$1160;
      HEAP32[(($141)>>2)]=$1161;
      var $1164=HEAP32[(($140)>>2)];
      var $1165=$139;
      HEAP32[(($139)>>2)]=$1164;
      var $1166=HEAP32[(($139)>>2)];
      var $1167=$138;
      HEAP32[(($138)>>2)]=$1166;
      var $1168=HEAPU32[(($138)>>2)];
      var $1169=$137;
      HEAP32[(($137)>>2)]=$1168;
      var $1170=HEAP32[(($137)>>2)];
      var $1171=(($1170)|0);
      var $1172=$136;
      HEAP32[(($136)>>2)]=$1171;
      var $1173=HEAP32[(($136)>>2)];
      var $1174=$1173;
      var $1175=$135;
      HEAP32[(($135)>>2)]=$1174;
      var $1176=HEAP32[(($135)>>2)];
      var $1177=(($1176)|0);
      var $1178=$135;
      var $1179=$136;
      var $1180=(($1177)|0);
      var $1181=$1180;
      var $1182=(($1181)|0);
      var $1183=$1182;
      var $1184=HEAPU8[($1183)];
      var $1185=(($1184)&255);
      var $1186=$1185 & 1;
      var $1187=(($1186)|0)!=0;
      var $1188=$137;
      if ($1187) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $1189
      var $1190=$131;
      HEAP32[(($131)>>2)]=$1168;
      var $1191=HEAP32[(($131)>>2)];
      var $1192=(($1191)|0);
      var $1193=$130;
      HEAP32[(($130)>>2)]=$1192;
      var $1194=HEAP32[(($130)>>2)];
      var $1195=$1194;
      var $1196=$129;
      HEAP32[(($129)>>2)]=$1195;
      var $1197=HEAP32[(($129)>>2)];
      var $1198=(($1197)|0);
      var $1199=$129;
      var $1200=$130;
      var $1201=(($1198)|0);
      var $1202=$1201;
      var $1203=(($1202+8)|0);
      var $1204=HEAP32[(($1203)>>2)];
      var $1205=$131;
      var $1223 = $1204;__label__ = 80; break;
    case 79: // $1206
      var $1207=$134;
      HEAP32[(($134)>>2)]=$1168;
      var $1208=HEAP32[(($134)>>2)];
      var $1209=(($1208)|0);
      var $1210=$133;
      HEAP32[(($133)>>2)]=$1209;
      var $1211=HEAP32[(($133)>>2)];
      var $1212=$1211;
      var $1213=$132;
      HEAP32[(($132)>>2)]=$1212;
      var $1214=HEAP32[(($132)>>2)];
      var $1215=(($1214)|0);
      var $1216=$132;
      var $1217=$133;
      var $1218=(($1215)|0);
      var $1219=$1218;
      var $1220=(($1219+1)|0);
      var $1221=(($1220)|0);
      var $1222=$134;
      var $1223 = $1221;__label__ = 80; break;
    case 80: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit9
      var $1223;
      var $1224=$138;
      var $1225=$139;
      var $1226=HEAP32[(($141)>>2)];
      var $1227=(($1223+$1226)|0);
      var $1228=$140;
      var $1229=$141;
      var $1230=HEAP8[($1227)];
      var $1231=(($1230 << 24) >> 24);
      var $1232=127;
      var $1233=(($1231)|0)==(($1232)|0);
      if ($1233) { __label__ = 81; break; } else { __label__ = 82; break; }
    case 81: // $1234
      var $1309 = -1;__label__ = 86; break;
    case 82: // $1235
      var $1236=$267;
      var $1237=$__ig;
      var $1238=$153;
      var $1239=$154;
      HEAP32[(($153)>>2)]=$1236;
      HEAP32[(($154)>>2)]=$1237;
      var $1240=HEAP32[(($153)>>2)];
      var $1241=$152;
      HEAP32[(($152)>>2)]=$1240;
      var $1242=HEAP32[(($152)>>2)];
      var $1243=$151;
      HEAP32[(($151)>>2)]=$1242;
      var $1244=HEAPU32[(($151)>>2)];
      var $1245=$150;
      HEAP32[(($150)>>2)]=$1244;
      var $1246=HEAP32[(($150)>>2)];
      var $1247=(($1246)|0);
      var $1248=$149;
      HEAP32[(($149)>>2)]=$1247;
      var $1249=HEAP32[(($149)>>2)];
      var $1250=$1249;
      var $1251=$148;
      HEAP32[(($148)>>2)]=$1250;
      var $1252=HEAP32[(($148)>>2)];
      var $1253=(($1252)|0);
      var $1254=$148;
      var $1255=$149;
      var $1256=(($1253)|0);
      var $1257=$1256;
      var $1258=(($1257)|0);
      var $1259=$1258;
      var $1260=HEAPU8[($1259)];
      var $1261=(($1260)&255);
      var $1262=$1261 & 1;
      var $1263=(($1262)|0)!=0;
      var $1264=$150;
      if ($1263) { __label__ = 83; break; } else { __label__ = 84; break; }
    case 83: // $1265
      var $1266=$144;
      HEAP32[(($144)>>2)]=$1244;
      var $1267=HEAP32[(($144)>>2)];
      var $1268=(($1267)|0);
      var $1269=$143;
      HEAP32[(($143)>>2)]=$1268;
      var $1270=HEAP32[(($143)>>2)];
      var $1271=$1270;
      var $1272=$142;
      HEAP32[(($142)>>2)]=$1271;
      var $1273=HEAP32[(($142)>>2)];
      var $1274=(($1273)|0);
      var $1275=$142;
      var $1276=$143;
      var $1277=(($1274)|0);
      var $1278=$1277;
      var $1279=(($1278+8)|0);
      var $1280=HEAP32[(($1279)>>2)];
      var $1281=$144;
      var $1299 = $1280;__label__ = 85; break;
    case 84: // $1282
      var $1283=$147;
      HEAP32[(($147)>>2)]=$1244;
      var $1284=HEAP32[(($147)>>2)];
      var $1285=(($1284)|0);
      var $1286=$146;
      HEAP32[(($146)>>2)]=$1285;
      var $1287=HEAP32[(($146)>>2)];
      var $1288=$1287;
      var $1289=$145;
      HEAP32[(($145)>>2)]=$1288;
      var $1290=HEAP32[(($145)>>2)];
      var $1291=(($1290)|0);
      var $1292=$145;
      var $1293=$146;
      var $1294=(($1291)|0);
      var $1295=$1294;
      var $1296=(($1295+1)|0);
      var $1297=(($1296)|0);
      var $1298=$147;
      var $1299 = $1297;__label__ = 85; break;
    case 85: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $1299;
      var $1300=$151;
      var $1301=$152;
      var $1302=HEAP32[(($154)>>2)];
      var $1303=(($1299+$1302)|0);
      var $1304=$153;
      var $1305=$154;
      var $1306=HEAP8[($1303)];
      var $1307=(($1306 << 24) >> 24);
      var $1309 = $1307;__label__ = 86; break;
    case 86: // $1308
      var $1309;
      $__gl=$1309;
      __label__ = 87; break;
    case 87: // $1310
      __label__ = 88; break;
    case 88: // $1311
      var $1312=$__d;
      var $1313=(($1312-1)|0);
      $__d=$1313;
      var $1314=HEAP8[($1313)];
      var $1315=$258;
      var $1316=HEAP32[(($1315)>>2)];
      var $1317=(($1316+1)|0);
      HEAP32[(($1315)>>2)]=$1317;
      HEAP8[($1316)]=$1314;
      var $1318=$__ng;
      var $1319=(($1318+1)|0);
      $__ng=$1319;
      __label__ = 71; break;
    case 89: // $1320
      __label__ = 90; break;
    case 90: // $1321
      var $1322=$__t;
      var $1323=$258;
      var $1324=HEAP32[(($1323)>>2)];
      var $1325=$162;
      var $1326=$163;
      var $1327=$164;
      var $1328=$165;
      HEAP32[(($163)>>2)]=$1322;
      HEAP32[(($164)>>2)]=$1324;
      var $1329=HEAP32[(($163)>>2)];
      var $1330=HEAP32[(($164)>>2)];
      var $tmp_i5=$162;
      var $tmp1_i6=$165;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i5)]=HEAP8[($tmp1_i6)];
      var $1331=$160;
      var $1332=$161;
      HEAP32[(($160)>>2)]=$1329;
      HEAP32[(($161)>>2)]=$1330;
      var $1333=HEAP32[(($160)>>2)];
      var $1334=HEAP32[(($161)>>2)];
      var $1335=(($1333)|0)!=(($1334)|0);
      if ($1335) { __label__ = 91; break; } else { __label__ = 95; break; }
    case 91: // $1336
      __label__ = 92; break;
    case 92: // $1337
      var $1338=HEAPU32[(($160)>>2)];
      var $1339=HEAP32[(($161)>>2)];
      var $1340=(($1339-1)|0);
      HEAP32[(($161)>>2)]=$1340;
      var $1341=(($1338)>>>0) < (($1340)>>>0);
      if ($1341) { __label__ = 93; break; } else { __label__ = 94; break; }
    case 93: // $1342
      var $1343=HEAP32[(($160)>>2)];
      var $1344=HEAP32[(($161)>>2)];
      var $1345=$158;
      var $1346=$159;
      HEAP32[(($158)>>2)]=$1343;
      HEAP32[(($159)>>2)]=$1344;
      var $1347=HEAP32[(($158)>>2)];
      var $1348=$157;
      HEAP32[(($157)>>2)]=$1347;
      var $1349=HEAP32[(($157)>>2)];
      var $1350=$157;
      var $1351=HEAP8[($1349)];
      HEAP8[($__t_i_i_i)]=$1351;
      var $1352=HEAP32[(($159)>>2)];
      var $1353=$155;
      HEAP32[(($155)>>2)]=$1352;
      var $1354=HEAP32[(($155)>>2)];
      var $1355=$155;
      var $1356=HEAP8[($1354)];
      var $1357=HEAP32[(($158)>>2)];
      HEAP8[($1357)]=$1356;
      var $1358=$156;
      HEAP32[(($156)>>2)]=$__t_i_i_i;
      var $1359=HEAP32[(($156)>>2)];
      var $1360=$156;
      var $1361=HEAP8[($1359)];
      var $1362=HEAP32[(($159)>>2)];
      HEAP8[($1362)]=$1361;
      var $1363=$158;
      var $1364=$159;
      var $1365=HEAP32[(($160)>>2)];
      var $1366=(($1365+1)|0);
      HEAP32[(($160)>>2)]=$1366;
      __label__ = 92; break;
    case 94: // $1367
      __label__ = 95; break;
    case 95: // $_ZNSt3__17reverseIPcEEvT_S2__exit
      var $1368=$160;
      var $1369=$161;
      var $1370=$162;
      var $1371=$163;
      var $1372=$164;
      var $1373=$165;
      __label__ = 96; break;
    case 96: // $1374
      __label__ = 97; break;
    case 97: // $1375
      var $1376=$__p;
      var $1377=(($1376+1)|0);
      $__p=$1377;
      __label__ = 1; break;
    case 98: // $1378
      var $1379=$269;
      var $1380=$175;
      HEAP32[(($175)>>2)]=$1379;
      var $1381=HEAPU32[(($175)>>2)];
      var $1382=$174;
      HEAP32[(($174)>>2)]=$1381;
      var $1383=HEAP32[(($174)>>2)];
      var $1384=(($1383)|0);
      var $1385=$173;
      HEAP32[(($173)>>2)]=$1384;
      var $1386=HEAP32[(($173)>>2)];
      var $1387=$1386;
      var $1388=$172;
      HEAP32[(($172)>>2)]=$1387;
      var $1389=HEAP32[(($172)>>2)];
      var $1390=(($1389)|0);
      var $1391=$172;
      var $1392=$173;
      var $1393=(($1390)|0);
      var $1394=$1393;
      var $1395=(($1394)|0);
      var $1396=$1395;
      var $1397=HEAPU8[($1396)];
      var $1398=(($1397)&255);
      var $1399=$1398 & 1;
      var $1400=(($1399)|0)!=0;
      var $1401=$174;
      if ($1400) { __label__ = 99; break; } else { __label__ = 100; break; }
    case 99: // $1402
      var $1403=$168;
      HEAP32[(($168)>>2)]=$1381;
      var $1404=HEAP32[(($168)>>2)];
      var $1405=(($1404)|0);
      var $1406=$167;
      HEAP32[(($167)>>2)]=$1405;
      var $1407=HEAP32[(($167)>>2)];
      var $1408=$1407;
      var $1409=$166;
      HEAP32[(($166)>>2)]=$1408;
      var $1410=HEAP32[(($166)>>2)];
      var $1411=(($1410)|0);
      var $1412=$166;
      var $1413=$167;
      var $1414=(($1411)|0);
      var $1415=$1414;
      var $1416=(($1415+4)|0);
      var $1417=HEAP32[(($1416)>>2)];
      var $1418=$168;
      var $1439 = $1417;__label__ = 101; break;
    case 100: // $1419
      var $1420=$171;
      HEAP32[(($171)>>2)]=$1381;
      var $1421=HEAP32[(($171)>>2)];
      var $1422=(($1421)|0);
      var $1423=$170;
      HEAP32[(($170)>>2)]=$1422;
      var $1424=HEAP32[(($170)>>2)];
      var $1425=$1424;
      var $1426=$169;
      HEAP32[(($169)>>2)]=$1425;
      var $1427=HEAP32[(($169)>>2)];
      var $1428=(($1427)|0);
      var $1429=$169;
      var $1430=$170;
      var $1431=(($1428)|0);
      var $1432=$1431;
      var $1433=(($1432)|0);
      var $1434=$1433;
      var $1435=HEAPU8[($1434)];
      var $1436=(($1435)&255);
      var $1437=$1436 >> 1;
      var $1438=$171;
      var $1439 = $1437;__label__ = 101; break;
    case 101: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $1439;
      var $1440=$175;
      var $1441=(($1439)>>>0) > 1;
      if ($1441) { __label__ = 102; break; } else { __label__ = 115; break; }
    case 102: // $1442
      var $1443=$269;
      var $1444=$191;
      HEAP32[(($191)>>2)]=$1443;
      var $1445=HEAP32[(($191)>>2)];
      var $1446=$190;
      HEAP32[(($190)>>2)]=$1445;
      var $1447=HEAP32[(($190)>>2)];
      var $1448=$189;
      HEAP32[(($189)>>2)]=$1447;
      var $1449=HEAPU32[(($189)>>2)];
      var $1450=$188;
      HEAP32[(($188)>>2)]=$1449;
      var $1451=HEAP32[(($188)>>2)];
      var $1452=(($1451)|0);
      var $1453=$187;
      HEAP32[(($187)>>2)]=$1452;
      var $1454=HEAP32[(($187)>>2)];
      var $1455=$1454;
      var $1456=$186;
      HEAP32[(($186)>>2)]=$1455;
      var $1457=HEAP32[(($186)>>2)];
      var $1458=(($1457)|0);
      var $1459=$186;
      var $1460=$187;
      var $1461=(($1458)|0);
      var $1462=$1461;
      var $1463=(($1462)|0);
      var $1464=$1463;
      var $1465=HEAPU8[($1464)];
      var $1466=(($1465)&255);
      var $1467=$1466 & 1;
      var $1468=(($1467)|0)!=0;
      var $1469=$188;
      if ($1468) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $1470
      var $1471=$182;
      HEAP32[(($182)>>2)]=$1449;
      var $1472=HEAP32[(($182)>>2)];
      var $1473=(($1472)|0);
      var $1474=$181;
      HEAP32[(($181)>>2)]=$1473;
      var $1475=HEAP32[(($181)>>2)];
      var $1476=$1475;
      var $1477=$180;
      HEAP32[(($180)>>2)]=$1476;
      var $1478=HEAP32[(($180)>>2)];
      var $1479=(($1478)|0);
      var $1480=$180;
      var $1481=$181;
      var $1482=(($1479)|0);
      var $1483=$1482;
      var $1484=(($1483+8)|0);
      var $1485=HEAP32[(($1484)>>2)];
      var $1486=$182;
      var $1504 = $1485;__label__ = 105; break;
    case 104: // $1487
      var $1488=$185;
      HEAP32[(($185)>>2)]=$1449;
      var $1489=HEAP32[(($185)>>2)];
      var $1490=(($1489)|0);
      var $1491=$184;
      HEAP32[(($184)>>2)]=$1490;
      var $1492=HEAP32[(($184)>>2)];
      var $1493=$1492;
      var $1494=$183;
      HEAP32[(($183)>>2)]=$1493;
      var $1495=HEAP32[(($183)>>2)];
      var $1496=(($1495)|0);
      var $1497=$183;
      var $1498=$184;
      var $1499=(($1496)|0);
      var $1500=$1499;
      var $1501=(($1500+1)|0);
      var $1502=(($1501)|0);
      var $1503=$185;
      var $1504 = $1502;__label__ = 105; break;
    case 105: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv_exit
      var $1504;
      var $1505=$189;
      var $1506=$190;
      var $1507=$178;
      var $1508=$179;
      HEAP32[(($178)>>2)]=$274;
      HEAP32[(($179)>>2)]=$1504;
      var $1509=HEAP32[(($178)>>2)];
      var $1510=HEAP32[(($179)>>2)];
      var $1511=$176;
      var $1512=$177;
      HEAP32[(($176)>>2)]=$1509;
      HEAP32[(($177)>>2)]=$1510;
      var $1513=HEAP32[(($176)>>2)];
      var $1514=(($1513)|0);
      var $1515=HEAP32[(($177)>>2)];
      HEAP32[(($1514)>>2)]=$1515;
      var $1516=$176;
      var $1517=$177;
      var $1518=$178;
      var $1519=$179;
      var $1520=$191;
      var $1521=$194;
      var $1522=$195;
      HEAP32[(($194)>>2)]=$274;
      HEAP32[(($195)>>2)]=1;
      var $1523=HEAP32[(($194)>>2)];
      var $1524=$273;
      var $1525=$1523;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1524)>>2)]=HEAP32[(($1525)>>2)];
      var $1526=HEAP32[(($195)>>2)];
      var $1527=$192;
      var $1528=$193;
      HEAP32[(($192)>>2)]=$273;
      HEAP32[(($193)>>2)]=$1526;
      var $1529=HEAP32[(($192)>>2)];
      var $1530=HEAP32[(($193)>>2)];
      var $1531=(($1529)|0);
      var $1532=HEAP32[(($1531)>>2)];
      var $1533=(($1532+$1530)|0);
      HEAP32[(($1531)>>2)]=$1533;
      var $1534=$192;
      var $1535=$193;
      var $1536=$194;
      var $1537=$195;
      var $1538=$269;
      var $1539=$221;
      HEAP32[(($221)>>2)]=$1538;
      var $1540=HEAPU32[(($221)>>2)];
      var $1541=$220;
      HEAP32[(($220)>>2)]=$1540;
      var $1542=HEAP32[(($220)>>2)];
      var $1543=$219;
      HEAP32[(($219)>>2)]=$1542;
      var $1544=HEAPU32[(($219)>>2)];
      var $1545=$218;
      HEAP32[(($218)>>2)]=$1544;
      var $1546=HEAP32[(($218)>>2)];
      var $1547=(($1546)|0);
      var $1548=$217;
      HEAP32[(($217)>>2)]=$1547;
      var $1549=HEAP32[(($217)>>2)];
      var $1550=$1549;
      var $1551=$216;
      HEAP32[(($216)>>2)]=$1550;
      var $1552=HEAP32[(($216)>>2)];
      var $1553=(($1552)|0);
      var $1554=$216;
      var $1555=$217;
      var $1556=(($1553)|0);
      var $1557=$1556;
      var $1558=(($1557)|0);
      var $1559=$1558;
      var $1560=HEAPU8[($1559)];
      var $1561=(($1560)&255);
      var $1562=$1561 & 1;
      var $1563=(($1562)|0)!=0;
      var $1564=$218;
      if ($1563) { __label__ = 106; break; } else { __label__ = 107; break; }
    case 106: // $1565
      var $1566=$212;
      HEAP32[(($212)>>2)]=$1544;
      var $1567=HEAP32[(($212)>>2)];
      var $1568=(($1567)|0);
      var $1569=$211;
      HEAP32[(($211)>>2)]=$1568;
      var $1570=HEAP32[(($211)>>2)];
      var $1571=$1570;
      var $1572=$210;
      HEAP32[(($210)>>2)]=$1571;
      var $1573=HEAP32[(($210)>>2)];
      var $1574=(($1573)|0);
      var $1575=$210;
      var $1576=$211;
      var $1577=(($1574)|0);
      var $1578=$1577;
      var $1579=(($1578+8)|0);
      var $1580=HEAP32[(($1579)>>2)];
      var $1581=$212;
      var $1599 = $1580;__label__ = 108; break;
    case 107: // $1582
      var $1583=$215;
      HEAP32[(($215)>>2)]=$1544;
      var $1584=HEAP32[(($215)>>2)];
      var $1585=(($1584)|0);
      var $1586=$214;
      HEAP32[(($214)>>2)]=$1585;
      var $1587=HEAP32[(($214)>>2)];
      var $1588=$1587;
      var $1589=$213;
      HEAP32[(($213)>>2)]=$1588;
      var $1590=HEAP32[(($213)>>2)];
      var $1591=(($1590)|0);
      var $1592=$213;
      var $1593=$214;
      var $1594=(($1591)|0);
      var $1595=$1594;
      var $1596=(($1595+1)|0);
      var $1597=(($1596)|0);
      var $1598=$215;
      var $1599 = $1597;__label__ = 108; break;
    case 108: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit_i
      var $1599;
      var $1600=$219;
      var $1601=$220;
      var $1602=$205;
      HEAP32[(($205)>>2)]=$1540;
      var $1603=HEAPU32[(($205)>>2)];
      var $1604=$204;
      HEAP32[(($204)>>2)]=$1603;
      var $1605=HEAP32[(($204)>>2)];
      var $1606=(($1605)|0);
      var $1607=$203;
      HEAP32[(($203)>>2)]=$1606;
      var $1608=HEAP32[(($203)>>2)];
      var $1609=$1608;
      var $1610=$202;
      HEAP32[(($202)>>2)]=$1609;
      var $1611=HEAP32[(($202)>>2)];
      var $1612=(($1611)|0);
      var $1613=$202;
      var $1614=$203;
      var $1615=(($1612)|0);
      var $1616=$1615;
      var $1617=(($1616)|0);
      var $1618=$1617;
      var $1619=HEAPU8[($1618)];
      var $1620=(($1619)&255);
      var $1621=$1620 & 1;
      var $1622=(($1621)|0)!=0;
      var $1623=$204;
      if ($1622) { __label__ = 109; break; } else { __label__ = 110; break; }
    case 109: // $1624
      var $1625=$198;
      HEAP32[(($198)>>2)]=$1603;
      var $1626=HEAP32[(($198)>>2)];
      var $1627=(($1626)|0);
      var $1628=$197;
      HEAP32[(($197)>>2)]=$1627;
      var $1629=HEAP32[(($197)>>2)];
      var $1630=$1629;
      var $1631=$196;
      HEAP32[(($196)>>2)]=$1630;
      var $1632=HEAP32[(($196)>>2)];
      var $1633=(($1632)|0);
      var $1634=$196;
      var $1635=$197;
      var $1636=(($1633)|0);
      var $1637=$1636;
      var $1638=(($1637+4)|0);
      var $1639=HEAP32[(($1638)>>2)];
      var $1640=$198;
      var $1661 = $1639;__label__ = 111; break;
    case 110: // $1641
      var $1642=$201;
      HEAP32[(($201)>>2)]=$1603;
      var $1643=HEAP32[(($201)>>2)];
      var $1644=(($1643)|0);
      var $1645=$200;
      HEAP32[(($200)>>2)]=$1644;
      var $1646=HEAP32[(($200)>>2)];
      var $1647=$1646;
      var $1648=$199;
      HEAP32[(($199)>>2)]=$1647;
      var $1649=HEAP32[(($199)>>2)];
      var $1650=(($1649)|0);
      var $1651=$199;
      var $1652=$200;
      var $1653=(($1650)|0);
      var $1654=$1653;
      var $1655=(($1654)|0);
      var $1656=$1655;
      var $1657=HEAPU8[($1656)];
      var $1658=(($1657)&255);
      var $1659=$1658 >> 1;
      var $1660=$201;
      var $1661 = $1659;__label__ = 111; break;
    case 111: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv_exit
      var $1661;
      var $1662=$205;
      var $1663=(($1599+$1661)|0);
      var $1664=$208;
      var $1665=$209;
      HEAP32[(($208)>>2)]=$275;
      HEAP32[(($209)>>2)]=$1663;
      var $1666=HEAP32[(($208)>>2)];
      var $1667=HEAP32[(($209)>>2)];
      var $1668=$206;
      var $1669=$207;
      HEAP32[(($206)>>2)]=$1666;
      HEAP32[(($207)>>2)]=$1667;
      var $1670=HEAP32[(($206)>>2)];
      var $1671=(($1670)|0);
      var $1672=HEAP32[(($207)>>2)];
      HEAP32[(($1671)>>2)]=$1672;
      var $1673=$206;
      var $1674=$207;
      var $1675=$208;
      var $1676=$209;
      var $1677=$221;
      var $1678=$258;
      var $1679=HEAP32[(($1678)>>2)];
      var $tmp=$242;
      var $tmp1=$273;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $tmp2=$241;
      var $tmp3=$275;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2)]=HEAP8[($tmp3)];HEAP8[($tmp2+1)]=HEAP8[($tmp3+1)];HEAP8[($tmp2+2)]=HEAP8[($tmp3+2)];HEAP8[($tmp2+3)]=HEAP8[($tmp3+3)];
      var $1680=$222;
      var $1681=$233;
      var $1682=$234;
      var $1683=$235;
      var $1684=$236;
      var $1685=$237;
      var $1686=$238;
      var $1687=$239;
      var $1688=$240;
      HEAP32[(($236)>>2)]=$1679;
      var $1689=$238;
      var $1690=$242;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1689)>>2)]=HEAP32[(($1690)>>2)];
      var $tmp_i=$235;
      var $tmp1_i=$238;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp1_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp1_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp1_i+3)];
      var $1691=$237;
      var $1692=$235;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1691)>>2)]=HEAP32[(($1692)>>2)];
      var $1693=$240;
      var $1694=$241;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1693)>>2)]=HEAP32[(($1694)>>2)];
      var $tmp6_i=$222;
      var $tmp7_i=$240;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp6_i)]=HEAP8[($tmp7_i)];HEAP8[($tmp6_i+1)]=HEAP8[($tmp7_i+1)];HEAP8[($tmp6_i+2)]=HEAP8[($tmp7_i+2)];HEAP8[($tmp6_i+3)]=HEAP8[($tmp7_i+3)];
      var $1695=$239;
      var $1696=$222;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1695)>>2)]=HEAP32[(($1696)>>2)];
      var $1697=HEAP32[(($236)>>2)];
      var $1698=$223;
      HEAP32[(($223)>>2)]=$1697;
      var $1699=HEAP32[(($223)>>2)];
      var $1700=$223;
      var $tmp2_i=$234;
      var $tmp3_i=$237;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2_i)]=HEAP8[($tmp3_i)];HEAP8[($tmp2_i+1)]=HEAP8[($tmp3_i+1)];HEAP8[($tmp2_i+2)]=HEAP8[($tmp3_i+2)];HEAP8[($tmp2_i+3)]=HEAP8[($tmp3_i+3)];
      var $tmp4_i=$233;
      var $tmp5_i=$239;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp4_i)]=HEAP8[($tmp5_i)];HEAP8[($tmp4_i+1)]=HEAP8[($tmp5_i+1)];HEAP8[($tmp4_i+2)]=HEAP8[($tmp5_i+2)];HEAP8[($tmp4_i+3)]=HEAP8[($tmp5_i+3)];
      var $1701=$232;
      HEAP32[(($232)>>2)]=$1699;
      __label__ = 112; break;
    case 112: // $1702
      var $1703=$230;
      var $1704=$231;
      HEAP32[(($230)>>2)]=$234;
      HEAP32[(($231)>>2)]=$233;
      var $1705=HEAP32[(($230)>>2)];
      var $1706=HEAP32[(($231)>>2)];
      var $1707=$228;
      var $1708=$229;
      HEAP32[(($228)>>2)]=$1705;
      HEAP32[(($229)>>2)]=$1706;
      var $1709=HEAP32[(($228)>>2)];
      var $1710=$227;
      HEAP32[(($227)>>2)]=$1709;
      var $1711=HEAP32[(($227)>>2)];
      var $1712=(($1711)|0);
      var $1713=HEAP32[(($1712)>>2)];
      var $1714=$227;
      var $1715=HEAP32[(($229)>>2)];
      var $1716=$226;
      HEAP32[(($226)>>2)]=$1715;
      var $1717=HEAP32[(($226)>>2)];
      var $1718=(($1717)|0);
      var $1719=HEAP32[(($1718)>>2)];
      var $1720=$226;
      var $1721=(($1713)|0)==(($1719)|0);
      var $1722=$228;
      var $1723=$229;
      var $1724=$1721 ^ 1;
      var $1725=$230;
      var $1726=$231;
      if ($1724) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $1727
      var $1728=$224;
      HEAP32[(($224)>>2)]=$234;
      var $1729=HEAP32[(($224)>>2)];
      var $1730=(($1729)|0);
      var $1731=HEAP32[(($1730)>>2)];
      var $1732=$224;
      var $1733=HEAP8[($1731)];
      var $1734=HEAP32[(($232)>>2)];
      HEAP8[($1734)]=$1733;
      var $1735=$225;
      HEAP32[(($225)>>2)]=$234;
      var $1736=HEAP32[(($225)>>2)];
      var $1737=(($1736)|0);
      var $1738=HEAP32[(($1737)>>2)];
      var $1739=(($1738+1)|0);
      HEAP32[(($1737)>>2)]=$1739;
      var $1740=$225;
      var $1741=HEAP32[(($232)>>2)];
      var $1742=(($1741+1)|0);
      HEAP32[(($232)>>2)]=$1742;
      __label__ = 112; break;
    case 114: // $_ZNSt3__14copyINS_11__wrap_iterIPKcEEPcEET0_T_S7_S6__exit
      var $1743=HEAP32[(($232)>>2)];
      var $1744=$232;
      var $1745=$222;
      var $1746=$233;
      var $1747=$234;
      var $1748=$235;
      var $1749=$236;
      var $1750=$237;
      var $1751=$238;
      var $1752=$239;
      var $1753=$240;
      var $1754=$258;
      HEAP32[(($1754)>>2)]=$1743;
      __label__ = 115; break;
    case 115: // $1755
      var $1756=$259;
      var $1757=$1756 & 176;
      var $1758=(($1757)|0)==32;
      if ($1758) { __label__ = 116; break; } else { __label__ = 117; break; }
    case 116: // $1759
      var $1760=$258;
      var $1761=HEAP32[(($1760)>>2)];
      var $1762=$257;
      HEAP32[(($1762)>>2)]=$1761;
      __label__ = 120; break;
    case 117: // $1763
      var $1764=$259;
      var $1765=$1764 & 176;
      var $1766=(($1765)|0)!=16;
      if ($1766) { __label__ = 118; break; } else { __label__ = 119; break; }
    case 118: // $1767
      var $1768=$256;
      var $1769=$257;
      HEAP32[(($1769)>>2)]=$1768;
      __label__ = 119; break;
    case 119: // $1770
      __label__ = 120; break;
    case 120: // $1771
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i["X"]=1;

function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE($agg_result, $this, $__s, $__intl, $__iob, $__fl, $__digits) {
  var __stackBase__  = STACKTOP; STACKTOP += 1024; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $__tmp_i=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48=__stackBase__+192;
      var $49=__stackBase__+196;
      var $50=__stackBase__+200;
      var $51=__stackBase__+204;
      var $52=__stackBase__+208;
      var $53=__stackBase__+212;
      var $54=__stackBase__+216;
      var $55=__stackBase__+220;
      var $56=__stackBase__+224;
      var $57=__stackBase__+228;
      var $58=__stackBase__+232;
      var $59=__stackBase__+236;
      var $60=__stackBase__+240;
      var $61=__stackBase__+244;
      var $62=__stackBase__+248;
      var $63=__stackBase__+252;
      var $64=__stackBase__+256;
      var $65=__stackBase__+260;
      var $66=__stackBase__+264;
      var $67=__stackBase__+268;
      var $68=__stackBase__+272;
      var $69=__stackBase__+276;
      var $70=__stackBase__+280;
      var $71=__stackBase__+284;
      var $__tmp_i_i_i10=__stackBase__+288;
      var $72=__stackBase__+292;
      var $73=__stackBase__+296;
      var $74=__stackBase__+300;
      var $75=__stackBase__+304;
      var $76=__stackBase__+308;
      var $77=__stackBase__+312;
      var $78=__stackBase__+316;
      var $79=__stackBase__+320;
      var $80=__stackBase__+324;
      var $81=__stackBase__+328;
      var $82=__stackBase__+332;
      var $83=__stackBase__+336;
      var $84=__stackBase__+340;
      var $85=__stackBase__+344;
      var $86=__stackBase__+348;
      var $87=__stackBase__+352;
      var $88=__stackBase__+356;
      var $89=__stackBase__+360;
      var $90=__stackBase__+364;
      var $91=__stackBase__+368;
      var $92=__stackBase__+372;
      var $93=__stackBase__+376;
      var $94=__stackBase__+380;
      var $95=__stackBase__+384;
      var $96=__stackBase__+388;
      var $97=__stackBase__+392;
      var $98=__stackBase__+396;
      var $99=__stackBase__+400;
      var $100=__stackBase__+404;
      var $101=__stackBase__+408;
      var $102=__stackBase__+412;
      var $103=__stackBase__+416;
      var $104=__stackBase__+420;
      var $105=__stackBase__+424;
      var $106=__stackBase__+428;
      var $107=__stackBase__+432;
      var $108=__stackBase__+436;
      var $109=__stackBase__+440;
      var $110=__stackBase__+444;
      var $111=__stackBase__+448;
      var $112=__stackBase__+452;
      var $113=__stackBase__+456;
      var $114=__stackBase__+460;
      var $115=__stackBase__+464;
      var $116=__stackBase__+468;
      var $117=__stackBase__+472;
      var $118=__stackBase__+476;
      var $119=__stackBase__+480;
      var $120=__stackBase__+484;
      var $121=__stackBase__+488;
      var $122=__stackBase__+492;
      var $123=__stackBase__+496;
      var $124=__stackBase__+500;
      var $125=__stackBase__+504;
      var $126=__stackBase__+508;
      var $127=__stackBase__+512;
      var $128=__stackBase__+516;
      var $129=__stackBase__+520;
      var $130=__stackBase__+524;
      var $131=__stackBase__+528;
      var $132=__stackBase__+532;
      var $133=__stackBase__+536;
      var $134=__stackBase__+540;
      var $135=__stackBase__+544;
      var $136=__stackBase__+548;
      var $137=__stackBase__+552;
      var $138=__stackBase__+556;
      var $139=__stackBase__+560;
      var $140=__stackBase__+564;
      var $141=__stackBase__+568;
      var $142=__stackBase__+572;
      var $__a_i_i_i4=__stackBase__+576;
      var $__i_i_i_i5=__stackBase__+580;
      var $143=__stackBase__+584;
      var $144=__stackBase__+588;
      var $145=__stackBase__+592;
      var $146=__stackBase__+596;
      var $147=__stackBase__+600;
      var $148=__stackBase__+604;
      var $149=__stackBase__+608;
      var $150=__stackBase__+612;
      var $151=__stackBase__+616;
      var $__a_i_i_i1=__stackBase__+620;
      var $__i_i_i_i2=__stackBase__+624;
      var $152=__stackBase__+628;
      var $153=__stackBase__+632;
      var $154=__stackBase__+636;
      var $155=__stackBase__+640;
      var $156=__stackBase__+644;
      var $157=__stackBase__+648;
      var $158=__stackBase__+652;
      var $159=__stackBase__+656;
      var $160=__stackBase__+660;
      var $161=__stackBase__+664;
      var $162=__stackBase__+668;
      var $163=__stackBase__+672;
      var $164=__stackBase__+676;
      var $165=__stackBase__+680;
      var $__tmp_i_i_i=__stackBase__+684;
      var $166=__stackBase__+688;
      var $167=__stackBase__+692;
      var $168=__stackBase__+696;
      var $169=__stackBase__+700;
      var $170=__stackBase__+704;
      var $171=__stackBase__+708;
      var $172=__stackBase__+712;
      var $__a_i_i_i=__stackBase__+716;
      var $__i_i_i_i=__stackBase__+720;
      var $173=__stackBase__+724;
      var $174=__stackBase__+728;
      var $175=__stackBase__+732;
      var $176=__stackBase__+736;
      var $177=__stackBase__+740;
      var $178=__stackBase__+744;
      var $179=__stackBase__+748;
      var $180;
      var $181=__stackBase__+752;
      var $182=__stackBase__+756;
      var $183=__stackBase__+760;
      var $184=__stackBase__+764;
      var $185=__stackBase__+768;
      var $186=__stackBase__+772;
      var $187=__stackBase__+776;
      var $188=__stackBase__+780;
      var $189=__stackBase__+784;
      var $190=__stackBase__+788;
      var $191=__stackBase__+792;
      var $192=__stackBase__+796;
      var $193=__stackBase__+800;
      var $194=__stackBase__+804;
      var $195=__stackBase__+808;
      var $196=__stackBase__+812;
      var $197=__stackBase__+816;
      var $198=__stackBase__+820;
      var $199=__stackBase__+824;
      var $200=__stackBase__+828;
      var $201=__stackBase__+832;
      var $202=__stackBase__+836;
      var $203=__stackBase__+840;
      var $204=__stackBase__+844;
      var $205;
      var $206;
      var $207;
      var $208;
      var $209;
      var $__loc=__stackBase__+848;
      var $__ct;
      var $210;
      var $211;
      var $__neg;
      var $__pat=__stackBase__+852;
      var $__dp=__stackBase__+856;
      var $__ts=__stackBase__+860;
      var $__grp=__stackBase__+864;
      var $__sym=__stackBase__+876;
      var $__sn=__stackBase__+888;
      var $__fd=__stackBase__+900;
      var $__mbuf=__stackBase__+904;
      var $__mb;
      var $__h=__stackBase__+1004;
      var $__exn;
      var $__mi=__stackBase__+1012;
      var $__me=__stackBase__+1016;
      var $212=__stackBase__+1020;
      var $213;
      $205=$this;
      var $214=(($__intl)&1);
      $206=$214;
      $207=$__iob;
      $208=$__fl;
      $209=$__digits;
      var $215=$205;
      var $216=$207;
      __ZNKSt3__18ios_base6getlocEv($__loc, $216);
      var $217=$204;
      HEAP32[(($204)>>2)]=$__loc;
      var $218=HEAP32[(($204)>>2)];
      var $219=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($218, __ZNSt3__15ctypeIcE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 56; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIcEEEERKT_RKNS_6localeE_exit
      var $220=$219;
      var $221=$204;
      __label__ = 2; break;
    case 2: // $222
      $__ct=$220;
      var $223=$209;
      var $224=$203;
      HEAP32[(($203)>>2)]=$223;
      var $225=HEAPU32[(($203)>>2)];
      var $226=$202;
      HEAP32[(($202)>>2)]=$225;
      var $227=HEAP32[(($202)>>2)];
      var $228=(($227)|0);
      var $229=$201;
      HEAP32[(($201)>>2)]=$228;
      var $230=HEAP32[(($201)>>2)];
      var $231=$230;
      var $232=$200;
      HEAP32[(($200)>>2)]=$231;
      var $233=HEAP32[(($200)>>2)];
      var $234=(($233)|0);
      var $235=$200;
      var $236=$201;
      var $237=(($234)|0);
      var $238=$237;
      var $239=(($238)|0);
      var $240=$239;
      var $241=HEAPU8[($240)];
      var $242=(($241)&255);
      var $243=$242 & 1;
      var $244=(($243)|0)!=0;
      var $245=$202;
      if ($244) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $246
      var $247=$196;
      HEAP32[(($196)>>2)]=$225;
      var $248=HEAP32[(($196)>>2)];
      var $249=(($248)|0);
      var $250=$195;
      HEAP32[(($195)>>2)]=$249;
      var $251=HEAP32[(($195)>>2)];
      var $252=$251;
      var $253=$194;
      HEAP32[(($194)>>2)]=$252;
      var $254=HEAP32[(($194)>>2)];
      var $255=(($254)|0);
      var $256=$194;
      var $257=$195;
      var $258=(($255)|0);
      var $259=$258;
      var $260=(($259+4)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$196;
      var $283 = $261;__label__ = 5; break;
    case 4: // $263
      var $264=$199;
      HEAP32[(($199)>>2)]=$225;
      var $265=HEAP32[(($199)>>2)];
      var $266=(($265)|0);
      var $267=$198;
      HEAP32[(($198)>>2)]=$266;
      var $268=HEAP32[(($198)>>2)];
      var $269=$268;
      var $270=$197;
      HEAP32[(($197)>>2)]=$269;
      var $271=HEAP32[(($197)>>2)];
      var $272=(($271)|0);
      var $273=$197;
      var $274=$198;
      var $275=(($272)|0);
      var $276=$275;
      var $277=(($276)|0);
      var $278=$277;
      var $279=HEAPU8[($278)];
      var $280=(($279)&255);
      var $281=$280 >> 1;
      var $282=$199;
      var $283 = $281;__label__ = 5; break;
    case 5: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $283;
      var $284=$203;
      var $285=(($283)>>>0) > 0;
      if ($285) { __label__ = 6; break; } else { var $373 = 0;__label__ = 13; break; }
    case 6: // $286
      var $287=$209;
      var $288=$192;
      var $289=$193;
      HEAP32[(($192)>>2)]=$287;
      HEAP32[(($193)>>2)]=0;
      var $290=HEAP32[(($192)>>2)];
      var $291=$191;
      HEAP32[(($191)>>2)]=$290;
      var $292=HEAP32[(($191)>>2)];
      var $293=$190;
      HEAP32[(($190)>>2)]=$292;
      var $294=HEAPU32[(($190)>>2)];
      var $295=$189;
      HEAP32[(($189)>>2)]=$294;
      var $296=HEAP32[(($189)>>2)];
      var $297=(($296)|0);
      var $298=$188;
      HEAP32[(($188)>>2)]=$297;
      var $299=HEAP32[(($188)>>2)];
      var $300=$299;
      var $301=$187;
      HEAP32[(($187)>>2)]=$300;
      var $302=HEAP32[(($187)>>2)];
      var $303=(($302)|0);
      var $304=$187;
      var $305=$188;
      var $306=(($303)|0);
      var $307=$306;
      var $308=(($307)|0);
      var $309=$308;
      var $310=HEAPU8[($309)];
      var $311=(($310)&255);
      var $312=$311 & 1;
      var $313=(($312)|0)!=0;
      var $314=$189;
      if ($313) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $315
      var $316=$183;
      HEAP32[(($183)>>2)]=$294;
      var $317=HEAP32[(($183)>>2)];
      var $318=(($317)|0);
      var $319=$182;
      HEAP32[(($182)>>2)]=$318;
      var $320=HEAP32[(($182)>>2)];
      var $321=$320;
      var $322=$181;
      HEAP32[(($181)>>2)]=$321;
      var $323=HEAP32[(($181)>>2)];
      var $324=(($323)|0);
      var $325=$181;
      var $326=$182;
      var $327=(($324)|0);
      var $328=$327;
      var $329=(($328+8)|0);
      var $330=HEAP32[(($329)>>2)];
      var $331=$183;
      var $349 = $330;__label__ = 9; break;
    case 8: // $332
      var $333=$186;
      HEAP32[(($186)>>2)]=$294;
      var $334=HEAP32[(($186)>>2)];
      var $335=(($334)|0);
      var $336=$185;
      HEAP32[(($185)>>2)]=$335;
      var $337=HEAP32[(($185)>>2)];
      var $338=$337;
      var $339=$184;
      HEAP32[(($184)>>2)]=$338;
      var $340=HEAP32[(($184)>>2)];
      var $341=(($340)|0);
      var $342=$184;
      var $343=$185;
      var $344=(($341)|0);
      var $345=$344;
      var $346=(($345+1)|0);
      var $347=(($346)|0);
      var $348=$186;
      var $349 = $347;__label__ = 9; break;
    case 9: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $349;
      var $350=$190;
      var $351=$191;
      var $352=HEAP32[(($193)>>2)];
      var $353=(($349+$352)|0);
      var $354=$192;
      var $355=$193;
      __label__ = 10; break;
    case 10: // $356
      var $357=HEAP8[($353)];
      var $358=(($357 << 24) >> 24);
      var $359=$__ct;
      var $360=$179;
      HEAP32[(($179)>>2)]=$359;
      $180=45;
      var $361=HEAP32[(($179)>>2)];
      var $362=$361;
      var $363=HEAP32[(($362)>>2)];
      var $364=(($363+28)|0);
      var $365=HEAP32[(($364)>>2)];
      var $366=$180;
      var $367=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$365]($361, $366) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 56; break; };
    case 11: // $_ZNKSt3__15ctypeIcE5widenEc_exit
      var $368=$179;
      __label__ = 12; break;
    case 12: // $369
      var $370=(($367 << 24) >> 24);
      var $371=(($358)|0)==(($370)|0);
      var $373 = $371;__label__ = 13; break;
    case 13: // $372
      var $373;
      var $374=(($373)&1);
      $__neg=$374;
      var $375=$178;
      HEAP32[(($178)>>2)]=$__grp;
      var $376=HEAP32[(($178)>>2)];
      var $377=$177;
      HEAP32[(($177)>>2)]=$376;
      var $378=HEAPU32[(($177)>>2)];
      var $379=$378;
      var $380=(($378)|0);
      var $381=$176;
      HEAP32[(($176)>>2)]=$380;
      var $382=HEAP32[(($176)>>2)];
      var $383=$175;
      HEAP32[(($175)>>2)]=$382;
      var $384=HEAP32[(($175)>>2)];
      var $385=$384;
      var $386=$174;
      HEAP32[(($174)>>2)]=$385;
      var $387=HEAP32[(($174)>>2)];
      var $388=$387;
      var $389=$173;
      HEAP32[(($173)>>2)]=$388;
      var $390=HEAP32[(($173)>>2)];
      var $391=$173;
      var $392=(($387)|0);
      var $393=$174;
      var $394=$175;
      var $395=$176;
      var $396=$172;
      var $397=$__a_i_i_i;
      var $398=$__i_i_i_i;
      HEAP32[(($172)>>2)]=$378;
      var $399=HEAP32[(($172)>>2)];
      var $400=(($399)|0);
      var $401=$171;
      HEAP32[(($171)>>2)]=$400;
      var $402=HEAP32[(($171)>>2)];
      var $403=$402;
      var $404=$170;
      HEAP32[(($170)>>2)]=$403;
      var $405=HEAP32[(($170)>>2)];
      var $406=(($405)|0);
      var $407=$170;
      var $408=$171;
      var $409=(($406)|0);
      var $410=$409;
      var $411=(($410)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$411;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 14; break;
    case 14: // $412
      var $413=HEAPU32[(($__i_i_i_i)>>2)];
      var $414=(($413)>>>0) < 3;
      if ($414) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $415
      var $416=HEAP32[(($__i_i_i_i)>>2)];
      var $417=HEAP32[(($__a_i_i_i)>>2)];
      var $418=(($417+($416<<2))|0);
      HEAP32[(($418)>>2)]=0;
      var $419=HEAP32[(($__i_i_i_i)>>2)];
      var $420=(($419+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$420;
      __label__ = 14; break;
    case 16: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $421=$172;
      var $422=$__a_i_i_i;
      var $423=$__i_i_i_i;
      var $424=$177;
      var $425=$178;
      __label__ = 17; break;
    case 17: // $426
      var $427=$157;
      HEAP32[(($157)>>2)]=$__sym;
      var $428=HEAP32[(($157)>>2)];
      var $429=$156;
      HEAP32[(($156)>>2)]=$428;
      var $430=HEAPU32[(($156)>>2)];
      var $431=$430;
      var $432=(($430)|0);
      var $433=$155;
      HEAP32[(($155)>>2)]=$432;
      var $434=HEAP32[(($155)>>2)];
      var $435=$154;
      HEAP32[(($154)>>2)]=$434;
      var $436=HEAP32[(($154)>>2)];
      var $437=$436;
      var $438=$153;
      HEAP32[(($153)>>2)]=$437;
      var $439=HEAP32[(($153)>>2)];
      var $440=$439;
      var $441=$152;
      HEAP32[(($152)>>2)]=$440;
      var $442=HEAP32[(($152)>>2)];
      var $443=$152;
      var $444=(($439)|0);
      var $445=$153;
      var $446=$154;
      var $447=$155;
      var $448=$151;
      var $449=$__a_i_i_i1;
      var $450=$__i_i_i_i2;
      HEAP32[(($151)>>2)]=$430;
      var $451=HEAP32[(($151)>>2)];
      var $452=(($451)|0);
      var $453=$150;
      HEAP32[(($150)>>2)]=$452;
      var $454=HEAP32[(($150)>>2)];
      var $455=$454;
      var $456=$149;
      HEAP32[(($149)>>2)]=$455;
      var $457=HEAP32[(($149)>>2)];
      var $458=(($457)|0);
      var $459=$149;
      var $460=$150;
      var $461=(($458)|0);
      var $462=$461;
      var $463=(($462)|0);
      HEAP32[(($__a_i_i_i1)>>2)]=$463;
      HEAP32[(($__i_i_i_i2)>>2)]=0;
      __label__ = 18; break;
    case 18: // $464
      var $465=HEAPU32[(($__i_i_i_i2)>>2)];
      var $466=(($465)>>>0) < 3;
      if ($466) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $467
      var $468=HEAP32[(($__i_i_i_i2)>>2)];
      var $469=HEAP32[(($__a_i_i_i1)>>2)];
      var $470=(($469+($468<<2))|0);
      HEAP32[(($470)>>2)]=0;
      var $471=HEAP32[(($__i_i_i_i2)>>2)];
      var $472=(($471+1)|0);
      HEAP32[(($__i_i_i_i2)>>2)]=$472;
      __label__ = 18; break;
    case 20: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit3
      var $473=$151;
      var $474=$__a_i_i_i1;
      var $475=$__i_i_i_i2;
      var $476=$156;
      var $477=$157;
      __label__ = 21; break;
    case 21: // $478
      var $479=$148;
      HEAP32[(($148)>>2)]=$__sn;
      var $480=HEAP32[(($148)>>2)];
      var $481=$147;
      HEAP32[(($147)>>2)]=$480;
      var $482=HEAPU32[(($147)>>2)];
      var $483=$482;
      var $484=(($482)|0);
      var $485=$146;
      HEAP32[(($146)>>2)]=$484;
      var $486=HEAP32[(($146)>>2)];
      var $487=$145;
      HEAP32[(($145)>>2)]=$486;
      var $488=HEAP32[(($145)>>2)];
      var $489=$488;
      var $490=$144;
      HEAP32[(($144)>>2)]=$489;
      var $491=HEAP32[(($144)>>2)];
      var $492=$491;
      var $493=$143;
      HEAP32[(($143)>>2)]=$492;
      var $494=HEAP32[(($143)>>2)];
      var $495=$143;
      var $496=(($491)|0);
      var $497=$144;
      var $498=$145;
      var $499=$146;
      var $500=$142;
      var $501=$__a_i_i_i4;
      var $502=$__i_i_i_i5;
      HEAP32[(($142)>>2)]=$482;
      var $503=HEAP32[(($142)>>2)];
      var $504=(($503)|0);
      var $505=$141;
      HEAP32[(($141)>>2)]=$504;
      var $506=HEAP32[(($141)>>2)];
      var $507=$506;
      var $508=$140;
      HEAP32[(($140)>>2)]=$507;
      var $509=HEAP32[(($140)>>2)];
      var $510=(($509)|0);
      var $511=$140;
      var $512=$141;
      var $513=(($510)|0);
      var $514=$513;
      var $515=(($514)|0);
      HEAP32[(($__a_i_i_i4)>>2)]=$515;
      HEAP32[(($__i_i_i_i5)>>2)]=0;
      __label__ = 22; break;
    case 22: // $516
      var $517=HEAPU32[(($__i_i_i_i5)>>2)];
      var $518=(($517)>>>0) < 3;
      if ($518) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $519
      var $520=HEAP32[(($__i_i_i_i5)>>2)];
      var $521=HEAP32[(($__a_i_i_i4)>>2)];
      var $522=(($521+($520<<2))|0);
      HEAP32[(($522)>>2)]=0;
      var $523=HEAP32[(($__i_i_i_i5)>>2)];
      var $524=(($523+1)|0);
      HEAP32[(($__i_i_i_i5)>>2)]=$524;
      __label__ = 22; break;
    case 24: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit6
      var $525=$142;
      var $526=$__a_i_i_i4;
      var $527=$__i_i_i_i5;
      var $528=$147;
      var $529=$148;
      __label__ = 25; break;
    case 25: // $530
      var $531=$206;
      var $532=(($531) & 1);
      var $533=$__neg;
      var $534=(($533) & 1);
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri($532, $534, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 59; break; }
    case 26: // $535
      var $536=(($__mbuf)|0);
      $__mb=$536;
      var $537=$137;
      var $538=$138;
      var $539=$139;
      HEAP32[(($137)>>2)]=$__h;
      HEAP32[(($138)>>2)]=0;
      HEAP32[(($139)>>2)]=1496;
      var $540=HEAP32[(($137)>>2)];
      var $541=HEAP32[(($138)>>2)];
      var $542=HEAP32[(($139)>>2)];
      var $543=$134;
      var $544=$135;
      var $545=$136;
      HEAP32[(($134)>>2)]=$540;
      HEAP32[(($135)>>2)]=$541;
      HEAP32[(($136)>>2)]=$542;
      var $546=HEAP32[(($134)>>2)];
      var $547=(($546)|0);
      var $548=$133;
      HEAP32[(($133)>>2)]=$135;
      var $549=HEAP32[(($133)>>2)];
      var $550=$133;
      var $551=HEAP32[(($549)>>2)];
      var $552=$119;
      HEAP32[(($119)>>2)]=$136;
      var $553=HEAP32[(($119)>>2)];
      var $554=$119;
      var $555=HEAP32[(($553)>>2)];
      var $556=$130;
      var $557=$131;
      var $558=$132;
      HEAP32[(($130)>>2)]=$547;
      HEAP32[(($131)>>2)]=$551;
      HEAP32[(($132)>>2)]=$555;
      var $559=HEAP32[(($130)>>2)];
      var $560=HEAP32[(($131)>>2)];
      var $561=HEAP32[(($132)>>2)];
      var $562=$127;
      var $563=$128;
      var $564=$129;
      HEAP32[(($127)>>2)]=$559;
      HEAP32[(($128)>>2)]=$560;
      HEAP32[(($129)>>2)]=$561;
      var $565=HEAP32[(($127)>>2)];
      var $566=$565;
      var $567=$126;
      HEAP32[(($126)>>2)]=$128;
      var $568=HEAP32[(($126)>>2)];
      var $569=$126;
      var $570=HEAP32[(($568)>>2)];
      var $571=$120;
      HEAP32[(($120)>>2)]=$129;
      var $572=HEAP32[(($120)>>2)];
      var $573=$120;
      var $574=HEAP32[(($572)>>2)];
      var $575=$123;
      var $576=$124;
      var $577=$125;
      HEAP32[(($123)>>2)]=$566;
      HEAP32[(($124)>>2)]=$570;
      HEAP32[(($125)>>2)]=$574;
      var $578=HEAP32[(($123)>>2)];
      var $579=(($578)|0);
      var $580=$122;
      HEAP32[(($122)>>2)]=$124;
      var $581=HEAP32[(($122)>>2)];
      var $582=$122;
      var $583=HEAP32[(($581)>>2)];
      HEAP32[(($579)>>2)]=$583;
      var $584=(($578+4)|0);
      var $585=$121;
      HEAP32[(($121)>>2)]=$125;
      var $586=HEAP32[(($121)>>2)];
      var $587=$121;
      var $588=HEAP32[(($586)>>2)];
      HEAP32[(($584)>>2)]=$588;
      var $589=$123;
      var $590=$124;
      var $591=$125;
      var $592=$127;
      var $593=$128;
      var $594=$129;
      var $595=$130;
      var $596=$131;
      var $597=$132;
      var $598=$134;
      var $599=$135;
      var $600=$136;
      var $601=$137;
      var $602=$138;
      var $603=$139;
      __label__ = 27; break;
    case 27: // $604
      var $605=$209;
      var $606=$118;
      HEAP32[(($118)>>2)]=$605;
      var $607=HEAPU32[(($118)>>2)];
      var $608=$117;
      HEAP32[(($117)>>2)]=$607;
      var $609=HEAP32[(($117)>>2)];
      var $610=(($609)|0);
      var $611=$116;
      HEAP32[(($116)>>2)]=$610;
      var $612=HEAP32[(($116)>>2)];
      var $613=$612;
      var $614=$115;
      HEAP32[(($115)>>2)]=$613;
      var $615=HEAP32[(($115)>>2)];
      var $616=(($615)|0);
      var $617=$115;
      var $618=$116;
      var $619=(($616)|0);
      var $620=$619;
      var $621=(($620)|0);
      var $622=$621;
      var $623=HEAPU8[($622)];
      var $624=(($623)&255);
      var $625=$624 & 1;
      var $626=(($625)|0)!=0;
      var $627=$117;
      if ($626) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $628
      var $629=$111;
      HEAP32[(($111)>>2)]=$607;
      var $630=HEAP32[(($111)>>2)];
      var $631=(($630)|0);
      var $632=$110;
      HEAP32[(($110)>>2)]=$631;
      var $633=HEAP32[(($110)>>2)];
      var $634=$633;
      var $635=$109;
      HEAP32[(($109)>>2)]=$634;
      var $636=HEAP32[(($109)>>2)];
      var $637=(($636)|0);
      var $638=$109;
      var $639=$110;
      var $640=(($637)|0);
      var $641=$640;
      var $642=(($641+4)|0);
      var $643=HEAP32[(($642)>>2)];
      var $644=$111;
      var $665 = $643;__label__ = 30; break;
    case 29: // $645
      var $646=$114;
      HEAP32[(($114)>>2)]=$607;
      var $647=HEAP32[(($114)>>2)];
      var $648=(($647)|0);
      var $649=$113;
      HEAP32[(($113)>>2)]=$648;
      var $650=HEAP32[(($113)>>2)];
      var $651=$650;
      var $652=$112;
      HEAP32[(($112)>>2)]=$651;
      var $653=HEAP32[(($112)>>2)];
      var $654=(($653)|0);
      var $655=$112;
      var $656=$113;
      var $657=(($654)|0);
      var $658=$657;
      var $659=(($658)|0);
      var $660=$659;
      var $661=HEAPU8[($660)];
      var $662=(($661)&255);
      var $663=$662 >> 1;
      var $664=$114;
      var $665 = $663;__label__ = 30; break;
    case 30: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit7
      var $665;
      var $666=$118;
      var $667=HEAPU32[(($__fd)>>2)];
      var $668=(($665)>>>0) > (($667)>>>0);
      if ($668) { __label__ = 31; break; } else { __label__ = 41; break; }
    case 31: // $669
      var $670=$209;
      var $671=$63;
      HEAP32[(($63)>>2)]=$670;
      var $672=HEAPU32[(($63)>>2)];
      var $673=$62;
      HEAP32[(($62)>>2)]=$672;
      var $674=HEAP32[(($62)>>2)];
      var $675=(($674)|0);
      var $676=$61;
      HEAP32[(($61)>>2)]=$675;
      var $677=HEAP32[(($61)>>2)];
      var $678=$677;
      var $679=$60;
      HEAP32[(($60)>>2)]=$678;
      var $680=HEAP32[(($60)>>2)];
      var $681=(($680)|0);
      var $682=$60;
      var $683=$61;
      var $684=(($681)|0);
      var $685=$684;
      var $686=(($685)|0);
      var $687=$686;
      var $688=HEAPU8[($687)];
      var $689=(($688)&255);
      var $690=$689 & 1;
      var $691=(($690)|0)!=0;
      var $692=$62;
      if ($691) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $693
      var $694=$56;
      HEAP32[(($56)>>2)]=$672;
      var $695=HEAP32[(($56)>>2)];
      var $696=(($695)|0);
      var $697=$55;
      HEAP32[(($55)>>2)]=$696;
      var $698=HEAP32[(($55)>>2)];
      var $699=$698;
      var $700=$54;
      HEAP32[(($54)>>2)]=$699;
      var $701=HEAP32[(($54)>>2)];
      var $702=(($701)|0);
      var $703=$54;
      var $704=$55;
      var $705=(($702)|0);
      var $706=$705;
      var $707=(($706+4)|0);
      var $708=HEAP32[(($707)>>2)];
      var $709=$56;
      var $730 = $708;__label__ = 34; break;
    case 33: // $710
      var $711=$59;
      HEAP32[(($59)>>2)]=$672;
      var $712=HEAP32[(($59)>>2)];
      var $713=(($712)|0);
      var $714=$58;
      HEAP32[(($58)>>2)]=$713;
      var $715=HEAP32[(($58)>>2)];
      var $716=$715;
      var $717=$57;
      HEAP32[(($57)>>2)]=$716;
      var $718=HEAP32[(($57)>>2)];
      var $719=(($718)|0);
      var $720=$57;
      var $721=$58;
      var $722=(($719)|0);
      var $723=$722;
      var $724=(($723)|0);
      var $725=$724;
      var $726=HEAPU8[($725)];
      var $727=(($726)&255);
      var $728=$727 >> 1;
      var $729=$59;
      var $730 = $728;__label__ = 34; break;
    case 34: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit12
      var $730;
      var $731=$63;
      var $732=HEAP32[(($__fd)>>2)];
      var $733=(($730-$732)|0);
      var $734=((($733<<1))|0);
      var $735=$53;
      HEAP32[(($53)>>2)]=$__sn;
      var $736=HEAPU32[(($53)>>2)];
      var $737=$52;
      HEAP32[(($52)>>2)]=$736;
      var $738=HEAP32[(($52)>>2)];
      var $739=(($738)|0);
      var $740=$51;
      HEAP32[(($51)>>2)]=$739;
      var $741=HEAP32[(($51)>>2)];
      var $742=$741;
      var $743=$50;
      HEAP32[(($50)>>2)]=$742;
      var $744=HEAP32[(($50)>>2)];
      var $745=(($744)|0);
      var $746=$50;
      var $747=$51;
      var $748=(($745)|0);
      var $749=$748;
      var $750=(($749)|0);
      var $751=$750;
      var $752=HEAPU8[($751)];
      var $753=(($752)&255);
      var $754=$753 & 1;
      var $755=(($754)|0)!=0;
      var $756=$52;
      if ($755) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $757
      var $758=$46;
      HEAP32[(($46)>>2)]=$736;
      var $759=HEAP32[(($46)>>2)];
      var $760=(($759)|0);
      var $761=$45;
      HEAP32[(($45)>>2)]=$760;
      var $762=HEAP32[(($45)>>2)];
      var $763=$762;
      var $764=$44;
      HEAP32[(($44)>>2)]=$763;
      var $765=HEAP32[(($44)>>2)];
      var $766=(($765)|0);
      var $767=$44;
      var $768=$45;
      var $769=(($766)|0);
      var $770=$769;
      var $771=(($770+4)|0);
      var $772=HEAP32[(($771)>>2)];
      var $773=$46;
      var $794 = $772;__label__ = 37; break;
    case 36: // $774
      var $775=$49;
      HEAP32[(($49)>>2)]=$736;
      var $776=HEAP32[(($49)>>2)];
      var $777=(($776)|0);
      var $778=$48;
      HEAP32[(($48)>>2)]=$777;
      var $779=HEAP32[(($48)>>2)];
      var $780=$779;
      var $781=$47;
      HEAP32[(($47)>>2)]=$780;
      var $782=HEAP32[(($47)>>2)];
      var $783=(($782)|0);
      var $784=$47;
      var $785=$48;
      var $786=(($783)|0);
      var $787=$786;
      var $788=(($787)|0);
      var $789=$788;
      var $790=HEAPU8[($789)];
      var $791=(($790)&255);
      var $792=$791 >> 1;
      var $793=$49;
      var $794 = $792;__label__ = 37; break;
    case 37: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit13
      var $794;
      var $795=$53;
      var $796=(($734+$794)|0);
      var $797=$30;
      HEAP32[(($30)>>2)]=$__sym;
      var $798=HEAPU32[(($30)>>2)];
      var $799=$29;
      HEAP32[(($29)>>2)]=$798;
      var $800=HEAP32[(($29)>>2)];
      var $801=(($800)|0);
      var $802=$28;
      HEAP32[(($28)>>2)]=$801;
      var $803=HEAP32[(($28)>>2)];
      var $804=$803;
      var $805=$27;
      HEAP32[(($27)>>2)]=$804;
      var $806=HEAP32[(($27)>>2)];
      var $807=(($806)|0);
      var $808=$27;
      var $809=$28;
      var $810=(($807)|0);
      var $811=$810;
      var $812=(($811)|0);
      var $813=$812;
      var $814=HEAPU8[($813)];
      var $815=(($814)&255);
      var $816=$815 & 1;
      var $817=(($816)|0)!=0;
      var $818=$29;
      if ($817) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $819
      var $820=$23;
      HEAP32[(($23)>>2)]=$798;
      var $821=HEAP32[(($23)>>2)];
      var $822=(($821)|0);
      var $823=$22;
      HEAP32[(($22)>>2)]=$822;
      var $824=HEAP32[(($22)>>2)];
      var $825=$824;
      var $826=$21;
      HEAP32[(($21)>>2)]=$825;
      var $827=HEAP32[(($21)>>2)];
      var $828=(($827)|0);
      var $829=$21;
      var $830=$22;
      var $831=(($828)|0);
      var $832=$831;
      var $833=(($832+4)|0);
      var $834=HEAP32[(($833)>>2)];
      var $835=$23;
      var $856 = $834;__label__ = 40; break;
    case 39: // $836
      var $837=$26;
      HEAP32[(($26)>>2)]=$798;
      var $838=HEAP32[(($26)>>2)];
      var $839=(($838)|0);
      var $840=$25;
      HEAP32[(($25)>>2)]=$839;
      var $841=HEAP32[(($25)>>2)];
      var $842=$841;
      var $843=$24;
      HEAP32[(($24)>>2)]=$842;
      var $844=HEAP32[(($24)>>2)];
      var $845=(($844)|0);
      var $846=$24;
      var $847=$25;
      var $848=(($845)|0);
      var $849=$848;
      var $850=(($849)|0);
      var $851=$850;
      var $852=HEAPU8[($851)];
      var $853=(($852)&255);
      var $854=$853 >> 1;
      var $855=$26;
      var $856 = $854;__label__ = 40; break;
    case 40: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit14
      var $856;
      var $857=$30;
      var $858=(($796+$856)|0);
      var $859=HEAP32[(($__fd)>>2)];
      var $860=(($858+$859)|0);
      var $861=(($860+1)|0);
      var $990 = $861;__label__ = 48; break;
    case 41: // $862
      var $863=$20;
      HEAP32[(($20)>>2)]=$__sn;
      var $864=HEAPU32[(($20)>>2)];
      var $865=$19;
      HEAP32[(($19)>>2)]=$864;
      var $866=HEAP32[(($19)>>2)];
      var $867=(($866)|0);
      var $868=$18;
      HEAP32[(($18)>>2)]=$867;
      var $869=HEAP32[(($18)>>2)];
      var $870=$869;
      var $871=$17;
      HEAP32[(($17)>>2)]=$870;
      var $872=HEAP32[(($17)>>2)];
      var $873=(($872)|0);
      var $874=$17;
      var $875=$18;
      var $876=(($873)|0);
      var $877=$876;
      var $878=(($877)|0);
      var $879=$878;
      var $880=HEAPU8[($879)];
      var $881=(($880)&255);
      var $882=$881 & 1;
      var $883=(($882)|0)!=0;
      var $884=$19;
      if ($883) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $885
      var $886=$13;
      HEAP32[(($13)>>2)]=$864;
      var $887=HEAP32[(($13)>>2)];
      var $888=(($887)|0);
      var $889=$12;
      HEAP32[(($12)>>2)]=$888;
      var $890=HEAP32[(($12)>>2)];
      var $891=$890;
      var $892=$11;
      HEAP32[(($11)>>2)]=$891;
      var $893=HEAP32[(($11)>>2)];
      var $894=(($893)|0);
      var $895=$11;
      var $896=$12;
      var $897=(($894)|0);
      var $898=$897;
      var $899=(($898+4)|0);
      var $900=HEAP32[(($899)>>2)];
      var $901=$13;
      var $922 = $900;__label__ = 44; break;
    case 43: // $902
      var $903=$16;
      HEAP32[(($16)>>2)]=$864;
      var $904=HEAP32[(($16)>>2)];
      var $905=(($904)|0);
      var $906=$15;
      HEAP32[(($15)>>2)]=$905;
      var $907=HEAP32[(($15)>>2)];
      var $908=$907;
      var $909=$14;
      HEAP32[(($14)>>2)]=$908;
      var $910=HEAP32[(($14)>>2)];
      var $911=(($910)|0);
      var $912=$14;
      var $913=$15;
      var $914=(($911)|0);
      var $915=$914;
      var $916=(($915)|0);
      var $917=$916;
      var $918=HEAPU8[($917)];
      var $919=(($918)&255);
      var $920=$919 >> 1;
      var $921=$16;
      var $922 = $920;__label__ = 44; break;
    case 44: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit15
      var $922;
      var $923=$20;
      var $924=$10;
      HEAP32[(($10)>>2)]=$__sym;
      var $925=HEAPU32[(($10)>>2)];
      var $926=$9;
      HEAP32[(($9)>>2)]=$925;
      var $927=HEAP32[(($9)>>2)];
      var $928=(($927)|0);
      var $929=$8;
      HEAP32[(($8)>>2)]=$928;
      var $930=HEAP32[(($8)>>2)];
      var $931=$930;
      var $932=$7;
      HEAP32[(($7)>>2)]=$931;
      var $933=HEAP32[(($7)>>2)];
      var $934=(($933)|0);
      var $935=$7;
      var $936=$8;
      var $937=(($934)|0);
      var $938=$937;
      var $939=(($938)|0);
      var $940=$939;
      var $941=HEAPU8[($940)];
      var $942=(($941)&255);
      var $943=$942 & 1;
      var $944=(($943)|0)!=0;
      var $945=$9;
      if ($944) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $946
      var $947=$3;
      HEAP32[(($3)>>2)]=$925;
      var $948=HEAP32[(($3)>>2)];
      var $949=(($948)|0);
      var $950=$2;
      HEAP32[(($2)>>2)]=$949;
      var $951=HEAP32[(($2)>>2)];
      var $952=$951;
      var $953=$1;
      HEAP32[(($1)>>2)]=$952;
      var $954=HEAP32[(($1)>>2)];
      var $955=(($954)|0);
      var $956=$1;
      var $957=$2;
      var $958=(($955)|0);
      var $959=$958;
      var $960=(($959+4)|0);
      var $961=HEAP32[(($960)>>2)];
      var $962=$3;
      var $983 = $961;__label__ = 47; break;
    case 46: // $963
      var $964=$6;
      HEAP32[(($6)>>2)]=$925;
      var $965=HEAP32[(($6)>>2)];
      var $966=(($965)|0);
      var $967=$5;
      HEAP32[(($5)>>2)]=$966;
      var $968=HEAP32[(($5)>>2)];
      var $969=$968;
      var $970=$4;
      HEAP32[(($4)>>2)]=$969;
      var $971=HEAP32[(($4)>>2)];
      var $972=(($971)|0);
      var $973=$4;
      var $974=$5;
      var $975=(($972)|0);
      var $976=$975;
      var $977=(($976)|0);
      var $978=$977;
      var $979=HEAPU8[($978)];
      var $980=(($979)&255);
      var $981=$980 >> 1;
      var $982=$6;
      var $983 = $981;__label__ = 47; break;
    case 47: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit16
      var $983;
      var $984=$10;
      var $985=(($922+$983)|0);
      var $986=HEAP32[(($__fd)>>2)];
      var $987=(($985+$986)|0);
      var $988=(($987+2)|0);
      var $990 = $988;__label__ = 48; break;
    case 48: // $989
      var $990;
      $__exn=$990;
      var $991=$__exn;
      var $992=(($991)>>>0) > 100;
      if ($992) { __label__ = 49; break; } else { __label__ = 66; break; }
    case 49: // $993
      var $994=$__exn;
      var $995=(($994)|0);
      var $996=_malloc($995);
      var $997=$37;
      var $998=$38;
      var $999=$__tmp_i;
      var $1000=$39;
      var $1001=$40;
      HEAP32[(($37)>>2)]=$__h;
      HEAP32[(($38)>>2)]=$996;
      var $1002=HEAPU32[(($37)>>2)];
      var $1003=(($1002)|0);
      var $1004=$36;
      HEAP32[(($36)>>2)]=$1003;
      var $1005=HEAP32[(($36)>>2)];
      var $1006=$1005;
      var $1007=$35;
      HEAP32[(($35)>>2)]=$1006;
      var $1008=HEAP32[(($35)>>2)];
      var $1009=(($1008)|0);
      var $1010=$35;
      var $1011=$36;
      var $1012=HEAP32[(($1009)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$1012;
      var $1013=HEAP32[(($38)>>2)];
      var $1014=(($1002)|0);
      var $1015=$34;
      HEAP32[(($34)>>2)]=$1014;
      var $1016=HEAP32[(($34)>>2)];
      var $1017=$1016;
      var $1018=$33;
      HEAP32[(($33)>>2)]=$1017;
      var $1019=HEAP32[(($33)>>2)];
      var $1020=(($1019)|0);
      var $1021=$33;
      var $1022=$34;
      HEAP32[(($1020)>>2)]=$1013;
      var $1023=HEAP32[(($__tmp_i)>>2)];
      var $1024=(($1023)|0)!=0;
      if ($1024) { __label__ = 50; break; } else { __label__ = 53; break; }
    case 50: // $1025
      var $1026=(($1002)|0);
      var $1027=$32;
      HEAP32[(($32)>>2)]=$1026;
      var $1028=HEAP32[(($32)>>2)];
      var $1029=$1028;
      var $1030=$31;
      HEAP32[(($31)>>2)]=$1029;
      var $1031=HEAP32[(($31)>>2)];
      var $1032=(($1031+4)|0);
      var $1033=$31;
      var $1034=$32;
      var $1035=HEAP32[(($1032)>>2)];
      var $1036=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1035]($1036) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $1037
      __label__ = 53; break;
    case 52: // $1038
      var $1039=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1040=$1039.f0;
      HEAP32[(($39)>>2)]=$1040;
      var $1041=$1039.f1;
      HEAP32[(($40)>>2)]=$1041;
      var $1042=HEAP32[(($39)>>2)];
      ___cxa_call_unexpected($1042);
      throw "Reached an unreachable!"
    case 53: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $1043=$37;
      var $1044=$38;
      var $1045=$__tmp_i;
      var $1046=$39;
      var $1047=$40;
      var $1048=$43;
      HEAP32[(($43)>>2)]=$__h;
      var $1049=HEAP32[(($43)>>2)];
      var $1050=(($1049)|0);
      var $1051=$42;
      HEAP32[(($42)>>2)]=$1050;
      var $1052=HEAP32[(($42)>>2)];
      var $1053=$1052;
      var $1054=$41;
      HEAP32[(($41)>>2)]=$1053;
      var $1055=HEAP32[(($41)>>2)];
      var $1056=(($1055)|0);
      var $1057=$41;
      var $1058=$42;
      var $1059=HEAP32[(($1056)>>2)];
      var $1060=$43;
      $__mb=$1059;
      var $1061=$__mb;
      var $1062=(($1061)|0)==0;
      if ($1062) { __label__ = 54; break; } else { __label__ = 65; break; }
    case 54: // $1063
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 60; break; }
    case 55: // $1064
      __label__ = 65; break;
    case 56: // $1065
      var $1066=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1067=$1066.f0;
      $210=$1067;
      var $1068=$1066.f1;
      $211=$1068;
      __label__ = 94; break;
    case 57: // $1069
      var $1070=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1071=$1070.f0;
      $210=$1071;
      var $1072=$1070.f1;
      $211=$1072;
      __label__ = 92; break;
    case 58: // $1073
      var $1074=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1075=$1074.f0;
      $210=$1075;
      var $1076=$1074.f1;
      $211=$1076;
      __label__ = 89; break;
    case 59: // $1077
      var $1078=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1079=$1078.f0;
      $210=$1079;
      var $1080=$1078.f1;
      $211=$1080;
      __label__ = 86; break;
    case 60: // $1081
      var $1082=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1083=$1082.f0;
      $210=$1083;
      var $1084=$1082.f1;
      $211=$1084;
      var $1085=$75;
      HEAP32[(($75)>>2)]=$__h;
      var $1086=HEAP32[(($75)>>2)];
      var $1087=$74;
      HEAP32[(($74)>>2)]=$1086;
      var $1088=HEAP32[(($74)>>2)];
      var $1089=$70;
      var $1090=$71;
      var $1091=$__tmp_i_i_i10;
      var $1092=$72;
      var $1093=$73;
      HEAP32[(($70)>>2)]=$1088;
      HEAP32[(($71)>>2)]=0;
      var $1094=HEAP32[(($70)>>2)];
      var $1095=(($1094)|0);
      var $1096=$69;
      HEAP32[(($69)>>2)]=$1095;
      var $1097=HEAP32[(($69)>>2)];
      var $1098=$1097;
      var $1099=$68;
      HEAP32[(($68)>>2)]=$1098;
      var $1100=HEAP32[(($68)>>2)];
      var $1101=(($1100)|0);
      var $1102=$68;
      var $1103=$69;
      var $1104=HEAP32[(($1101)>>2)];
      HEAP32[(($__tmp_i_i_i10)>>2)]=$1104;
      var $1105=HEAP32[(($71)>>2)];
      var $1106=(($1094)|0);
      var $1107=$67;
      HEAP32[(($67)>>2)]=$1106;
      var $1108=HEAP32[(($67)>>2)];
      var $1109=$1108;
      var $1110=$66;
      HEAP32[(($66)>>2)]=$1109;
      var $1111=HEAP32[(($66)>>2)];
      var $1112=(($1111)|0);
      var $1113=$66;
      var $1114=$67;
      HEAP32[(($1112)>>2)]=$1105;
      var $1115=HEAP32[(($__tmp_i_i_i10)>>2)];
      var $1116=(($1115)|0)!=0;
      if ($1116) { __label__ = 61; break; } else { __label__ = 64; break; }
    case 61: // $1117
      var $1118=(($1094)|0);
      var $1119=$65;
      HEAP32[(($65)>>2)]=$1118;
      var $1120=HEAP32[(($65)>>2)];
      var $1121=$1120;
      var $1122=$64;
      HEAP32[(($64)>>2)]=$1121;
      var $1123=HEAP32[(($64)>>2)];
      var $1124=(($1123+4)|0);
      var $1125=$64;
      var $1126=$65;
      var $1127=HEAP32[(($1124)>>2)];
      var $1128=HEAP32[(($__tmp_i_i_i10)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1127]($1128) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $1129
      __label__ = 64; break;
    case 63: // $1130
      var $1131=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1132=$1131.f0;
      HEAP32[(($72)>>2)]=$1132;
      var $1133=$1131.f1;
      HEAP32[(($73)>>2)]=$1133;
      var $1134=HEAP32[(($72)>>2)];
      ___cxa_call_unexpected($1134);
      throw "Reached an unreachable!"
    case 64: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit11
      var $1135=$70;
      var $1136=$71;
      var $1137=$__tmp_i_i_i10;
      var $1138=$72;
      var $1139=$73;
      var $1140=$74;
      var $1141=$75;
      __label__ = 84; break;
    case 65: // $1142
      __label__ = 66; break;
    case 66: // $1143
      var $1144=$__mb;
      var $1145=$207;
      var $1146=$76;
      HEAP32[(($76)>>2)]=$1145;
      var $1147=HEAP32[(($76)>>2)];
      var $1148=(($1147+4)|0);
      var $1149=HEAP32[(($1148)>>2)];
      var $1150=$76;
      __label__ = 67; break;
    case 67: // $1151
      var $1152=$209;
      var $1153=$87;
      HEAP32[(($87)>>2)]=$1152;
      var $1154=HEAP32[(($87)>>2)];
      var $1155=$86;
      HEAP32[(($86)>>2)]=$1154;
      var $1156=HEAPU32[(($86)>>2)];
      var $1157=$85;
      HEAP32[(($85)>>2)]=$1156;
      var $1158=HEAP32[(($85)>>2)];
      var $1159=(($1158)|0);
      var $1160=$84;
      HEAP32[(($84)>>2)]=$1159;
      var $1161=HEAP32[(($84)>>2)];
      var $1162=$1161;
      var $1163=$83;
      HEAP32[(($83)>>2)]=$1162;
      var $1164=HEAP32[(($83)>>2)];
      var $1165=(($1164)|0);
      var $1166=$83;
      var $1167=$84;
      var $1168=(($1165)|0);
      var $1169=$1168;
      var $1170=(($1169)|0);
      var $1171=$1170;
      var $1172=HEAPU8[($1171)];
      var $1173=(($1172)&255);
      var $1174=$1173 & 1;
      var $1175=(($1174)|0)!=0;
      var $1176=$85;
      if ($1175) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $1177
      var $1178=$79;
      HEAP32[(($79)>>2)]=$1156;
      var $1179=HEAP32[(($79)>>2)];
      var $1180=(($1179)|0);
      var $1181=$78;
      HEAP32[(($78)>>2)]=$1180;
      var $1182=HEAP32[(($78)>>2)];
      var $1183=$1182;
      var $1184=$77;
      HEAP32[(($77)>>2)]=$1183;
      var $1185=HEAP32[(($77)>>2)];
      var $1186=(($1185)|0);
      var $1187=$77;
      var $1188=$78;
      var $1189=(($1186)|0);
      var $1190=$1189;
      var $1191=(($1190+8)|0);
      var $1192=HEAP32[(($1191)>>2)];
      var $1193=$79;
      var $1211 = $1192;__label__ = 70; break;
    case 69: // $1194
      var $1195=$82;
      HEAP32[(($82)>>2)]=$1156;
      var $1196=HEAP32[(($82)>>2)];
      var $1197=(($1196)|0);
      var $1198=$81;
      HEAP32[(($81)>>2)]=$1197;
      var $1199=HEAP32[(($81)>>2)];
      var $1200=$1199;
      var $1201=$80;
      HEAP32[(($80)>>2)]=$1200;
      var $1202=HEAP32[(($80)>>2)];
      var $1203=(($1202)|0);
      var $1204=$80;
      var $1205=$81;
      var $1206=(($1203)|0);
      var $1207=$1206;
      var $1208=(($1207+1)|0);
      var $1209=(($1208)|0);
      var $1210=$82;
      var $1211 = $1209;__label__ = 70; break;
    case 70: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit9
      var $1211;
      var $1212=$86;
      var $1213=$87;
      var $1214=$209;
      var $1215=$98;
      HEAP32[(($98)>>2)]=$1214;
      var $1216=HEAP32[(($98)>>2)];
      var $1217=$97;
      HEAP32[(($97)>>2)]=$1216;
      var $1218=HEAPU32[(($97)>>2)];
      var $1219=$96;
      HEAP32[(($96)>>2)]=$1218;
      var $1220=HEAP32[(($96)>>2)];
      var $1221=(($1220)|0);
      var $1222=$95;
      HEAP32[(($95)>>2)]=$1221;
      var $1223=HEAP32[(($95)>>2)];
      var $1224=$1223;
      var $1225=$94;
      HEAP32[(($94)>>2)]=$1224;
      var $1226=HEAP32[(($94)>>2)];
      var $1227=(($1226)|0);
      var $1228=$94;
      var $1229=$95;
      var $1230=(($1227)|0);
      var $1231=$1230;
      var $1232=(($1231)|0);
      var $1233=$1232;
      var $1234=HEAPU8[($1233)];
      var $1235=(($1234)&255);
      var $1236=$1235 & 1;
      var $1237=(($1236)|0)!=0;
      var $1238=$96;
      if ($1237) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $1239
      var $1240=$90;
      HEAP32[(($90)>>2)]=$1218;
      var $1241=HEAP32[(($90)>>2)];
      var $1242=(($1241)|0);
      var $1243=$89;
      HEAP32[(($89)>>2)]=$1242;
      var $1244=HEAP32[(($89)>>2)];
      var $1245=$1244;
      var $1246=$88;
      HEAP32[(($88)>>2)]=$1245;
      var $1247=HEAP32[(($88)>>2)];
      var $1248=(($1247)|0);
      var $1249=$88;
      var $1250=$89;
      var $1251=(($1248)|0);
      var $1252=$1251;
      var $1253=(($1252+8)|0);
      var $1254=HEAP32[(($1253)>>2)];
      var $1255=$90;
      var $1273 = $1254;__label__ = 73; break;
    case 72: // $1256
      var $1257=$93;
      HEAP32[(($93)>>2)]=$1218;
      var $1258=HEAP32[(($93)>>2)];
      var $1259=(($1258)|0);
      var $1260=$92;
      HEAP32[(($92)>>2)]=$1259;
      var $1261=HEAP32[(($92)>>2)];
      var $1262=$1261;
      var $1263=$91;
      HEAP32[(($91)>>2)]=$1262;
      var $1264=HEAP32[(($91)>>2)];
      var $1265=(($1264)|0);
      var $1266=$91;
      var $1267=$92;
      var $1268=(($1265)|0);
      var $1269=$1268;
      var $1270=(($1269+1)|0);
      var $1271=(($1270)|0);
      var $1272=$93;
      var $1273 = $1271;__label__ = 73; break;
    case 73: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv_exit
      var $1273;
      var $1274=$97;
      var $1275=$98;
      var $1276=$209;
      var $1277=$108;
      HEAP32[(($108)>>2)]=$1276;
      var $1278=HEAPU32[(($108)>>2)];
      var $1279=$107;
      HEAP32[(($107)>>2)]=$1278;
      var $1280=HEAP32[(($107)>>2)];
      var $1281=(($1280)|0);
      var $1282=$106;
      HEAP32[(($106)>>2)]=$1281;
      var $1283=HEAP32[(($106)>>2)];
      var $1284=$1283;
      var $1285=$105;
      HEAP32[(($105)>>2)]=$1284;
      var $1286=HEAP32[(($105)>>2)];
      var $1287=(($1286)|0);
      var $1288=$105;
      var $1289=$106;
      var $1290=(($1287)|0);
      var $1291=$1290;
      var $1292=(($1291)|0);
      var $1293=$1292;
      var $1294=HEAPU8[($1293)];
      var $1295=(($1294)&255);
      var $1296=$1295 & 1;
      var $1297=(($1296)|0)!=0;
      var $1298=$107;
      if ($1297) { __label__ = 74; break; } else { __label__ = 75; break; }
    case 74: // $1299
      var $1300=$101;
      HEAP32[(($101)>>2)]=$1278;
      var $1301=HEAP32[(($101)>>2)];
      var $1302=(($1301)|0);
      var $1303=$100;
      HEAP32[(($100)>>2)]=$1302;
      var $1304=HEAP32[(($100)>>2)];
      var $1305=$1304;
      var $1306=$99;
      HEAP32[(($99)>>2)]=$1305;
      var $1307=HEAP32[(($99)>>2)];
      var $1308=(($1307)|0);
      var $1309=$99;
      var $1310=$100;
      var $1311=(($1308)|0);
      var $1312=$1311;
      var $1313=(($1312+4)|0);
      var $1314=HEAP32[(($1313)>>2)];
      var $1315=$101;
      var $1336 = $1314;__label__ = 76; break;
    case 75: // $1316
      var $1317=$104;
      HEAP32[(($104)>>2)]=$1278;
      var $1318=HEAP32[(($104)>>2)];
      var $1319=(($1318)|0);
      var $1320=$103;
      HEAP32[(($103)>>2)]=$1319;
      var $1321=HEAP32[(($103)>>2)];
      var $1322=$1321;
      var $1323=$102;
      HEAP32[(($102)>>2)]=$1322;
      var $1324=HEAP32[(($102)>>2)];
      var $1325=(($1324)|0);
      var $1326=$102;
      var $1327=$103;
      var $1328=(($1325)|0);
      var $1329=$1328;
      var $1330=(($1329)|0);
      var $1331=$1330;
      var $1332=HEAPU8[($1331)];
      var $1333=(($1332)&255);
      var $1334=$1333 >> 1;
      var $1335=$104;
      var $1336 = $1334;__label__ = 76; break;
    case 76: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit8
      var $1336;
      var $1337=$108;
      var $1338=(($1273+$1336)|0);
      var $1339=$__ct;
      var $1340=$__neg;
      var $1341=(($1340) & 1);
      var $1342=HEAP8[($__dp)];
      var $1343=HEAP8[($__ts)];
      var $1344=HEAP32[(($__fd)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i($1144, $__mi, $__me, $1149, $1211, $1338, $1339, $1341, $__pat, $1342, $1343, $__grp, $__sym, $__sn, $1344) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 60; break; }
    case 77: // $1345
      var $1346=$212;
      var $1347=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1346)>>2)]=HEAP32[(($1347)>>2)];
      var $1348=$__mb;
      var $1349=HEAP32[(($__mi)>>2)];
      var $1350=HEAP32[(($__me)>>2)];
      var $1351=$207;
      var $1352=$208;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $212, $1348, $1349, $1350, $1351, $1352) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 60; break; }
    case 78: // $1353
      $213=1;
      var $1354=$169;
      HEAP32[(($169)>>2)]=$__h;
      var $1355=HEAP32[(($169)>>2)];
      var $1356=$168;
      HEAP32[(($168)>>2)]=$1355;
      var $1357=HEAP32[(($168)>>2)];
      var $1358=$164;
      var $1359=$165;
      var $1360=$__tmp_i_i_i;
      var $1361=$166;
      var $1362=$167;
      HEAP32[(($164)>>2)]=$1357;
      HEAP32[(($165)>>2)]=0;
      var $1363=HEAP32[(($164)>>2)];
      var $1364=(($1363)|0);
      var $1365=$163;
      HEAP32[(($163)>>2)]=$1364;
      var $1366=HEAP32[(($163)>>2)];
      var $1367=$1366;
      var $1368=$162;
      HEAP32[(($162)>>2)]=$1367;
      var $1369=HEAP32[(($162)>>2)];
      var $1370=(($1369)|0);
      var $1371=$162;
      var $1372=$163;
      var $1373=HEAP32[(($1370)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$1373;
      var $1374=HEAP32[(($165)>>2)];
      var $1375=(($1363)|0);
      var $1376=$161;
      HEAP32[(($161)>>2)]=$1375;
      var $1377=HEAP32[(($161)>>2)];
      var $1378=$1377;
      var $1379=$160;
      HEAP32[(($160)>>2)]=$1378;
      var $1380=HEAP32[(($160)>>2)];
      var $1381=(($1380)|0);
      var $1382=$160;
      var $1383=$161;
      HEAP32[(($1381)>>2)]=$1374;
      var $1384=HEAP32[(($__tmp_i_i_i)>>2)];
      var $1385=(($1384)|0)!=0;
      if ($1385) { __label__ = 79; break; } else { __label__ = 82; break; }
    case 79: // $1386
      var $1387=(($1363)|0);
      var $1388=$159;
      HEAP32[(($159)>>2)]=$1387;
      var $1389=HEAP32[(($159)>>2)];
      var $1390=$1389;
      var $1391=$158;
      HEAP32[(($158)>>2)]=$1390;
      var $1392=HEAP32[(($158)>>2)];
      var $1393=(($1392+4)|0);
      var $1394=$158;
      var $1395=$159;
      var $1396=HEAP32[(($1393)>>2)];
      var $1397=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1396]($1397) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $1398
      __label__ = 82; break;
    case 81: // $1399
      var $1400=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1401=$1400.f0;
      HEAP32[(($166)>>2)]=$1401;
      var $1402=$1400.f1;
      HEAP32[(($167)>>2)]=$1402;
      var $1403=HEAP32[(($166)>>2)];
      ___cxa_call_unexpected($1403);
      throw "Reached an unreachable!"
    case 82: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $1404=$164;
      var $1405=$165;
      var $1406=$__tmp_i_i_i;
      var $1407=$166;
      var $1408=$167;
      var $1409=$168;
      var $1410=$169;
      __label__ = 83; break;
    case 83: // $1411
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 58; break; }
    case 84: // $1412
      __label__ = 86; break;
    case 85: // $1413
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 57; break; }
    case 86: // $1414
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 97; break; }
    case 87: // $1415
      __label__ = 89; break;
    case 88: // $1416
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 56; break; }
    case 89: // $1417
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 97; break; }
    case 90: // $1418
      __label__ = 92; break;
    case 91: // $1419
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc);
      STACKTOP = __stackBase__;
      return;
    case 92: // $1420
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 97; break; }
    case 93: // $1421
      __label__ = 94; break;
    case 94: // $1422
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 97; break; }
    case 95: // $1423
      __label__ = 96; break;
    case 96: // $1424
      var $1425=$210;
      var $1426=$210;
      var $1427=$211;
      var $1428=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1426, tempValue);
      var $1429=($1428.f1 = $1427, $1428);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 97: // $1430
      var $1431=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE["X"]=1;

function ___cxx_global_var_init32() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}

// WARNING: content after a branch in a label, line: 896581
// WARNING: content after a branch in a label, line: 896583
// WARNING: content after a branch in a label, line: 896584
// WARNING: content after a branch in a label, line: 896585
// WARNING: content after a branch in a label, line: 896586
// WARNING: content after a branch in a label, line: 896587

function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe($agg_result, $this, $__s, $__intl, $__iob, $__fl, $__units) {
  var __stackBase__  = STACKTOP; STACKTOP += 2044; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i19=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $21=__stackBase__+84;
      var $__tmp_i_i_i17=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $__tmp_i15=__stackBase__+152;
      var $37=__stackBase__+156;
      var $38=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $49=__stackBase__+204;
      var $50=__stackBase__+208;
      var $51=__stackBase__+212;
      var $52=__stackBase__+216;
      var $53=__stackBase__+220;
      var $54=__stackBase__+224;
      var $55=__stackBase__+228;
      var $56=__stackBase__+232;
      var $57=__stackBase__+236;
      var $58=__stackBase__+240;
      var $59=__stackBase__+244;
      var $60=__stackBase__+248;
      var $61=__stackBase__+252;
      var $62=__stackBase__+256;
      var $63=__stackBase__+260;
      var $64=__stackBase__+264;
      var $65=__stackBase__+268;
      var $66=__stackBase__+272;
      var $__tmp_i_i_i11=__stackBase__+276;
      var $67=__stackBase__+280;
      var $68=__stackBase__+284;
      var $69=__stackBase__+288;
      var $70=__stackBase__+292;
      var $71=__stackBase__+296;
      var $72=__stackBase__+300;
      var $73=__stackBase__+304;
      var $74=__stackBase__+308;
      var $75=__stackBase__+312;
      var $76=__stackBase__+316;
      var $77=__stackBase__+320;
      var $78=__stackBase__+324;
      var $79=__stackBase__+328;
      var $80=__stackBase__+332;
      var $81=__stackBase__+336;
      var $82=__stackBase__+340;
      var $83=__stackBase__+344;
      var $84=__stackBase__+348;
      var $85=__stackBase__+352;
      var $86=__stackBase__+356;
      var $87=__stackBase__+360;
      var $88=__stackBase__+364;
      var $89=__stackBase__+368;
      var $90=__stackBase__+372;
      var $91=__stackBase__+376;
      var $92=__stackBase__+380;
      var $93=__stackBase__+384;
      var $94=__stackBase__+388;
      var $95=__stackBase__+392;
      var $96=__stackBase__+396;
      var $97=__stackBase__+400;
      var $98=__stackBase__+404;
      var $99=__stackBase__+408;
      var $100=__stackBase__+412;
      var $101=__stackBase__+416;
      var $102=__stackBase__+420;
      var $103=__stackBase__+424;
      var $104=__stackBase__+428;
      var $105=__stackBase__+432;
      var $106=__stackBase__+436;
      var $107=__stackBase__+440;
      var $108=__stackBase__+444;
      var $109=__stackBase__+448;
      var $110=__stackBase__+452;
      var $111=__stackBase__+456;
      var $112=__stackBase__+460;
      var $113=__stackBase__+464;
      var $114=__stackBase__+468;
      var $115=__stackBase__+472;
      var $116=__stackBase__+476;
      var $117=__stackBase__+480;
      var $118=__stackBase__+484;
      var $119=__stackBase__+488;
      var $__tmp_i_i_i8=__stackBase__+492;
      var $120=__stackBase__+496;
      var $121=__stackBase__+500;
      var $122=__stackBase__+504;
      var $123=__stackBase__+508;
      var $124=__stackBase__+512;
      var $125=__stackBase__+516;
      var $126=__stackBase__+520;
      var $__a_i_i_i5=__stackBase__+524;
      var $__i_i_i_i6=__stackBase__+528;
      var $127=__stackBase__+532;
      var $128=__stackBase__+536;
      var $129=__stackBase__+540;
      var $130=__stackBase__+544;
      var $131=__stackBase__+548;
      var $132=__stackBase__+552;
      var $133=__stackBase__+556;
      var $134=__stackBase__+560;
      var $135=__stackBase__+564;
      var $__a_i_i_i3=__stackBase__+568;
      var $__i_i_i_i4=__stackBase__+572;
      var $136=__stackBase__+576;
      var $137=__stackBase__+580;
      var $138=__stackBase__+584;
      var $139=__stackBase__+588;
      var $140=__stackBase__+592;
      var $141=__stackBase__+596;
      var $142=__stackBase__+600;
      var $143=__stackBase__+604;
      var $144=__stackBase__+608;
      var $145=__stackBase__+612;
      var $146=__stackBase__+616;
      var $147=__stackBase__+620;
      var $148=__stackBase__+624;
      var $149=__stackBase__+628;
      var $__tmp_i_i_i2=__stackBase__+632;
      var $150=__stackBase__+636;
      var $151=__stackBase__+640;
      var $152=__stackBase__+644;
      var $153=__stackBase__+648;
      var $154=__stackBase__+652;
      var $155=__stackBase__+656;
      var $156=__stackBase__+660;
      var $__a_i_i_i=__stackBase__+664;
      var $__i_i_i_i=__stackBase__+668;
      var $157=__stackBase__+672;
      var $158=__stackBase__+676;
      var $159=__stackBase__+680;
      var $160=__stackBase__+684;
      var $161=__stackBase__+688;
      var $162=__stackBase__+692;
      var $163=__stackBase__+696;
      var $164=__stackBase__+700;
      var $165=__stackBase__+704;
      var $166=__stackBase__+708;
      var $167=__stackBase__+712;
      var $168=__stackBase__+716;
      var $169=__stackBase__+720;
      var $170=__stackBase__+724;
      var $171=__stackBase__+728;
      var $172=__stackBase__+732;
      var $173=__stackBase__+736;
      var $174=__stackBase__+740;
      var $175=__stackBase__+744;
      var $176=__stackBase__+748;
      var $177=__stackBase__+752;
      var $178=__stackBase__+756;
      var $179=__stackBase__+760;
      var $180=__stackBase__+764;
      var $181=__stackBase__+768;
      var $__tmp_i1=__stackBase__+772;
      var $182=__stackBase__+776;
      var $183=__stackBase__+780;
      var $184=__stackBase__+784;
      var $185=__stackBase__+788;
      var $186=__stackBase__+792;
      var $187=__stackBase__+796;
      var $188=__stackBase__+800;
      var $189=__stackBase__+804;
      var $190=__stackBase__+808;
      var $191=__stackBase__+812;
      var $__tmp_i=__stackBase__+816;
      var $192=__stackBase__+820;
      var $193=__stackBase__+824;
      var $194=__stackBase__+828;
      var $195=__stackBase__+832;
      var $196=__stackBase__+836;
      var $197=__stackBase__+840;
      var $198=__stackBase__+844;
      var $199=__stackBase__+848;
      var $200=__stackBase__+852;
      var $201=__stackBase__+856;
      var $202=__stackBase__+860;
      var $203=__stackBase__+864;
      var $204=__stackBase__+868;
      var $205=__stackBase__+872;
      var $206=__stackBase__+876;
      var $207=__stackBase__+880;
      var $208=__stackBase__+884;
      var $209=__stackBase__+888;
      var $210=__stackBase__+892;
      var $211=__stackBase__+896;
      var $212=__stackBase__+900;
      var $213=__stackBase__+904;
      var $214=__stackBase__+908;
      var $215=__stackBase__+912;
      var $216=__stackBase__+916;
      var $217=__stackBase__+920;
      var $218=__stackBase__+924;
      var $219=__stackBase__+928;
      var $220=__stackBase__+932;
      var $221=__stackBase__+936;
      var $222=__stackBase__+940;
      var $__tmp_i_i_i=__stackBase__+944;
      var $223=__stackBase__+948;
      var $224=__stackBase__+952;
      var $225=__stackBase__+956;
      var $226=__stackBase__+960;
      var $227=__stackBase__+964;
      var $228=__stackBase__+968;
      var $229=__stackBase__+972;
      var $230=__stackBase__+976;
      var $231=__stackBase__+980;
      var $232=__stackBase__+984;
      var $233=__stackBase__+988;
      var $234=__stackBase__+992;
      var $235=__stackBase__+996;
      var $236=__stackBase__+1000;
      var $237=__stackBase__+1004;
      var $238=__stackBase__+1008;
      var $239=__stackBase__+1012;
      var $240=__stackBase__+1016;
      var $241=__stackBase__+1020;
      var $242=__stackBase__+1024;
      var $243=__stackBase__+1028;
      var $244=__stackBase__+1032;
      var $245=__stackBase__+1036;
      var $246=__stackBase__+1040;
      var $247=__stackBase__+1044;
      var $248;
      var $249;
      var $250;
      var $251;
      var $252;
      var $__bs;
      var $__buf=__stackBase__+1048;
      var $__bb=__stackBase__+1148;
      var $__digits=__stackBase__+1152;
      var $__db;
      var $__n;
      var $__hn=__stackBase__+1552;
      var $__hd=__stackBase__+1560;
      var $253;
      var $254;
      var $__loc=__stackBase__+1568;
      var $__ct;
      var $__neg;
      var $__pat=__stackBase__+1572;
      var $__dp=__stackBase__+1576;
      var $__ts=__stackBase__+1580;
      var $__grp=__stackBase__+1584;
      var $__sym=__stackBase__+1596;
      var $__sn=__stackBase__+1608;
      var $__fd=__stackBase__+1620;
      var $__mbuf=__stackBase__+1624;
      var $__mb;
      var $__hw=__stackBase__+2024;
      var $__exn;
      var $__mi=__stackBase__+2032;
      var $__me=__stackBase__+2036;
      var $255=__stackBase__+2040;
      var $256;
      $248=$this;
      var $257=(($__intl)&1);
      $249=$257;
      $250=$__iob;
      $251=$__fl;
      $252=$__units;
      var $258=$248;
      $__bs=100;
      var $259=(($__buf)|0);
      HEAP32[(($__bb)>>2)]=$259;
      var $260=(($__digits)|0);
      $__db=$260;
      var $261=HEAP32[(($__bb)>>2)];
      var $262=$252;
      var $263=_snprintf($261, 100, ((STRING_TABLE.__str31250)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$262,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt));
      $__n=$263;
      var $264=$245;
      var $265=$246;
      var $266=$247;
      HEAP32[(($245)>>2)]=$__hn;
      HEAP32[(($246)>>2)]=0;
      HEAP32[(($247)>>2)]=1496;
      var $267=HEAP32[(($245)>>2)];
      var $268=HEAP32[(($246)>>2)];
      var $269=HEAP32[(($247)>>2)];
      var $270=$242;
      var $271=$243;
      var $272=$244;
      HEAP32[(($242)>>2)]=$267;
      HEAP32[(($243)>>2)]=$268;
      HEAP32[(($244)>>2)]=$269;
      var $273=HEAP32[(($242)>>2)];
      var $274=(($273)|0);
      var $275=$241;
      HEAP32[(($241)>>2)]=$243;
      var $276=HEAP32[(($241)>>2)];
      var $277=$241;
      var $278=HEAP32[(($276)>>2)];
      var $279=$227;
      HEAP32[(($227)>>2)]=$244;
      var $280=HEAP32[(($227)>>2)];
      var $281=$227;
      var $282=HEAP32[(($280)>>2)];
      var $283=$238;
      var $284=$239;
      var $285=$240;
      HEAP32[(($238)>>2)]=$274;
      HEAP32[(($239)>>2)]=$278;
      HEAP32[(($240)>>2)]=$282;
      var $286=HEAP32[(($238)>>2)];
      var $287=HEAP32[(($239)>>2)];
      var $288=HEAP32[(($240)>>2)];
      var $289=$235;
      var $290=$236;
      var $291=$237;
      HEAP32[(($235)>>2)]=$286;
      HEAP32[(($236)>>2)]=$287;
      HEAP32[(($237)>>2)]=$288;
      var $292=HEAP32[(($235)>>2)];
      var $293=$292;
      var $294=$234;
      HEAP32[(($234)>>2)]=$236;
      var $295=HEAP32[(($234)>>2)];
      var $296=$234;
      var $297=HEAP32[(($295)>>2)];
      var $298=$228;
      HEAP32[(($228)>>2)]=$237;
      var $299=HEAP32[(($228)>>2)];
      var $300=$228;
      var $301=HEAP32[(($299)>>2)];
      var $302=$231;
      var $303=$232;
      var $304=$233;
      HEAP32[(($231)>>2)]=$293;
      HEAP32[(($232)>>2)]=$297;
      HEAP32[(($233)>>2)]=$301;
      var $305=HEAP32[(($231)>>2)];
      var $306=(($305)|0);
      var $307=$230;
      HEAP32[(($230)>>2)]=$232;
      var $308=HEAP32[(($230)>>2)];
      var $309=$230;
      var $310=HEAP32[(($308)>>2)];
      HEAP32[(($306)>>2)]=$310;
      var $311=(($305+4)|0);
      var $312=$229;
      HEAP32[(($229)>>2)]=$233;
      var $313=HEAP32[(($229)>>2)];
      var $314=$229;
      var $315=HEAP32[(($313)>>2)];
      HEAP32[(($311)>>2)]=$315;
      var $316=$231;
      var $317=$232;
      var $318=$233;
      var $319=$235;
      var $320=$236;
      var $321=$237;
      var $322=$238;
      var $323=$239;
      var $324=$240;
      var $325=$242;
      var $326=$243;
      var $327=$244;
      var $328=$245;
      var $329=$246;
      var $330=$247;
      var $331=$212;
      var $332=$213;
      var $333=$214;
      HEAP32[(($212)>>2)]=$__hd;
      HEAP32[(($213)>>2)]=0;
      HEAP32[(($214)>>2)]=1496;
      var $334=HEAP32[(($212)>>2)];
      var $335=HEAP32[(($213)>>2)];
      var $336=HEAP32[(($214)>>2)];
      var $337=$209;
      var $338=$210;
      var $339=$211;
      HEAP32[(($209)>>2)]=$334;
      HEAP32[(($210)>>2)]=$335;
      HEAP32[(($211)>>2)]=$336;
      var $340=HEAP32[(($209)>>2)];
      var $341=(($340)|0);
      var $342=$208;
      HEAP32[(($208)>>2)]=$210;
      var $343=HEAP32[(($208)>>2)];
      var $344=$208;
      var $345=HEAP32[(($343)>>2)];
      var $346=$194;
      HEAP32[(($194)>>2)]=$211;
      var $347=HEAP32[(($194)>>2)];
      var $348=$194;
      var $349=HEAP32[(($347)>>2)];
      var $350=$205;
      var $351=$206;
      var $352=$207;
      HEAP32[(($205)>>2)]=$341;
      HEAP32[(($206)>>2)]=$345;
      HEAP32[(($207)>>2)]=$349;
      var $353=HEAP32[(($205)>>2)];
      var $354=HEAP32[(($206)>>2)];
      var $355=HEAP32[(($207)>>2)];
      var $356=$202;
      var $357=$203;
      var $358=$204;
      HEAP32[(($202)>>2)]=$353;
      HEAP32[(($203)>>2)]=$354;
      HEAP32[(($204)>>2)]=$355;
      var $359=HEAP32[(($202)>>2)];
      var $360=$359;
      var $361=$201;
      HEAP32[(($201)>>2)]=$203;
      var $362=HEAP32[(($201)>>2)];
      var $363=$201;
      var $364=HEAP32[(($362)>>2)];
      var $365=$195;
      HEAP32[(($195)>>2)]=$204;
      var $366=HEAP32[(($195)>>2)];
      var $367=$195;
      var $368=HEAP32[(($366)>>2)];
      var $369=$198;
      var $370=$199;
      var $371=$200;
      HEAP32[(($198)>>2)]=$360;
      HEAP32[(($199)>>2)]=$364;
      HEAP32[(($200)>>2)]=$368;
      var $372=HEAP32[(($198)>>2)];
      var $373=(($372)|0);
      var $374=$197;
      HEAP32[(($197)>>2)]=$199;
      var $375=HEAP32[(($197)>>2)];
      var $376=$197;
      var $377=HEAP32[(($375)>>2)];
      HEAP32[(($373)>>2)]=$377;
      var $378=(($372+4)|0);
      var $379=$196;
      HEAP32[(($196)>>2)]=$200;
      var $380=HEAP32[(($196)>>2)];
      var $381=$196;
      var $382=HEAP32[(($380)>>2)];
      HEAP32[(($378)>>2)]=$382;
      var $383=$198;
      var $384=$199;
      var $385=$200;
      var $386=$202;
      var $387=$203;
      var $388=$204;
      var $389=$205;
      var $390=$206;
      var $391=$207;
      var $392=$209;
      var $393=$210;
      var $394=$211;
      var $395=$212;
      var $396=$213;
      var $397=$214;
      __label__ = 1; break;
    case 1: // $398
      var $399=$__n;
      var $400=(($399)>>>0) > 99;
      if ($400) { __label__ = 2; break; } else { __label__ = 23; break; }
    case 2: // $401
      var $402=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $403
      var $404=$252;
      var $405=(function() { try { __THREW__ = false; return __ZNSt3__112__asprintf_lEPPcPvPKcz($__bb, $402, ((STRING_TABLE.__str31250)|0), (tempInt=STACKTOP,STACKTOP += 8,assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack"),(tempDoubleF64[0]=$404,HEAP32[((tempInt)>>2)]=tempDoubleI32[0],HEAP32[((tempInt+4)>>2)]=tempDoubleI32[1]),tempInt)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; };
    case 4: // $406
      $__n=$405;
      var $407=HEAP32[(($__bb)>>2)];
      var $408=(($407)|0)==0;
      if ($408) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $409
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $410
      __label__ = 8; break;
    case 7: // $415
      var $416=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $417=$416.f0;
      $253=$417;
      var $418=$416.f1;
      $254=$418;
      __label__ = 108; break;
    case 8: // $419
      var $420=HEAP32[(($__bb)>>2)];
      var $421=$190;
      var $422=$191;
      var $423=$__tmp_i;
      var $424=$192;
      var $425=$193;
      HEAP32[(($190)>>2)]=$__hn;
      HEAP32[(($191)>>2)]=$420;
      var $426=HEAPU32[(($190)>>2)];
      var $427=(($426)|0);
      var $428=$189;
      HEAP32[(($189)>>2)]=$427;
      var $429=HEAP32[(($189)>>2)];
      var $430=$429;
      var $431=$188;
      HEAP32[(($188)>>2)]=$430;
      var $432=HEAP32[(($188)>>2)];
      var $433=(($432)|0);
      var $434=$188;
      var $435=$189;
      var $436=HEAP32[(($433)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$436;
      var $437=HEAP32[(($191)>>2)];
      var $438=(($426)|0);
      var $439=$187;
      HEAP32[(($187)>>2)]=$438;
      var $440=HEAP32[(($187)>>2)];
      var $441=$440;
      var $442=$186;
      HEAP32[(($186)>>2)]=$441;
      var $443=HEAP32[(($186)>>2)];
      var $444=(($443)|0);
      var $445=$186;
      var $446=$187;
      HEAP32[(($444)>>2)]=$437;
      var $447=HEAP32[(($__tmp_i)>>2)];
      var $448=(($447)|0)!=0;
      if ($448) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $449
      var $450=(($426)|0);
      var $451=$185;
      HEAP32[(($185)>>2)]=$450;
      var $452=HEAP32[(($185)>>2)];
      var $453=$452;
      var $454=$184;
      HEAP32[(($184)>>2)]=$453;
      var $455=HEAP32[(($184)>>2)];
      var $456=(($455+4)|0);
      var $457=$184;
      var $458=$185;
      var $459=HEAP32[(($456)>>2)];
      var $460=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$459]($460) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $461
      __label__ = 12; break;
    case 11: // $462
      var $463=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $464=$463.f0;
      HEAP32[(($192)>>2)]=$464;
      var $465=$463.f1;
      HEAP32[(($193)>>2)]=$465;
      var $466=HEAP32[(($192)>>2)];
      ___cxa_call_unexpected($466);
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__110unique_ptrIcPFvPvEE5resetEPc_exit
      var $467=$190;
      var $468=$191;
      var $469=$__tmp_i;
      var $470=$192;
      var $471=$193;
      var $472=$__n;
      var $473=((($472<<2))|0);
      var $474=_malloc($473);
      var $475=$474;
      var $476=$180;
      var $477=$181;
      var $478=$__tmp_i1;
      var $479=$182;
      var $480=$183;
      HEAP32[(($180)>>2)]=$__hd;
      HEAP32[(($181)>>2)]=$475;
      var $481=HEAP32[(($180)>>2)];
      var $482=(($481)|0);
      var $483=$179;
      HEAP32[(($179)>>2)]=$482;
      var $484=HEAP32[(($179)>>2)];
      var $485=$484;
      var $486=$178;
      HEAP32[(($178)>>2)]=$485;
      var $487=HEAP32[(($178)>>2)];
      var $488=(($487)|0);
      var $489=$178;
      var $490=$179;
      var $491=HEAP32[(($488)>>2)];
      HEAP32[(($__tmp_i1)>>2)]=$491;
      var $492=HEAP32[(($181)>>2)];
      var $493=(($481)|0);
      var $494=$177;
      HEAP32[(($177)>>2)]=$493;
      var $495=HEAP32[(($177)>>2)];
      var $496=$495;
      var $497=$176;
      HEAP32[(($176)>>2)]=$496;
      var $498=HEAP32[(($176)>>2)];
      var $499=(($498)|0);
      var $500=$176;
      var $501=$177;
      HEAP32[(($499)>>2)]=$492;
      var $502=HEAP32[(($__tmp_i1)>>2)];
      var $503=(($502)|0)!=0;
      if ($503) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $504
      var $505=(($481)|0);
      var $506=$175;
      HEAP32[(($175)>>2)]=$505;
      var $507=HEAP32[(($175)>>2)];
      var $508=$507;
      var $509=$174;
      HEAP32[(($174)>>2)]=$508;
      var $510=HEAP32[(($174)>>2)];
      var $511=(($510+4)|0);
      var $512=$174;
      var $513=$175;
      var $514=HEAP32[(($511)>>2)];
      var $515=HEAP32[(($__tmp_i1)>>2)];
      var $516=$515;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$514]($516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $517
      __label__ = 16; break;
    case 15: // $518
      var $519=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $520=$519.f0;
      HEAP32[(($182)>>2)]=$520;
      var $521=$519.f1;
      HEAP32[(($183)>>2)]=$521;
      var $522=HEAP32[(($182)>>2)];
      ___cxa_call_unexpected($522);
      throw "Reached an unreachable!"
    case 16: // $_ZNSt3__110unique_ptrIwPFvPvEE5resetEPw_exit
      var $523=$180;
      var $524=$181;
      var $525=$__tmp_i1;
      var $526=$182;
      var $527=$183;
      var $528=$173;
      HEAP32[(($173)>>2)]=$__hd;
      var $529=HEAP32[(($173)>>2)];
      var $530=(($529)|0);
      var $531=$172;
      HEAP32[(($172)>>2)]=$530;
      var $532=HEAP32[(($172)>>2)];
      var $533=$532;
      var $534=$171;
      HEAP32[(($171)>>2)]=$533;
      var $535=HEAP32[(($171)>>2)];
      var $536=(($535)|0);
      var $537=$171;
      var $538=$172;
      var $539=HEAP32[(($536)>>2)];
      var $540=(($539)|0)!=0;
      if ($540) { __label__ = 17; break; } else { __label__ = 18; break; }
    case 17: // $541
      var $543 = 0;__label__ = 19; break;
    case 18: // $542
      var $543 = -1;__label__ = 19; break;
    case 19: // $_ZNKSt3__110unique_ptrIwPFvPvEEcvMNS4_5__natEiEv_exit
      var $543;
      var $544=$173;
      var $545=(($543)|0)==-1;
      if ($545) { __label__ = 20; break; } else { __label__ = 22; break; }
    case 20: // $546
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 7; break; }
    case 21: // $547
      __label__ = 22; break;
    case 22: // $548
      var $549=$170;
      HEAP32[(($170)>>2)]=$__hd;
      var $550=HEAP32[(($170)>>2)];
      var $551=(($550)|0);
      var $552=$169;
      HEAP32[(($169)>>2)]=$551;
      var $553=HEAP32[(($169)>>2)];
      var $554=$553;
      var $555=$168;
      HEAP32[(($168)>>2)]=$554;
      var $556=HEAP32[(($168)>>2)];
      var $557=(($556)|0);
      var $558=$168;
      var $559=$169;
      var $560=HEAP32[(($557)>>2)];
      var $561=$170;
      $__db=$560;
      __label__ = 23; break;
    case 23: // $562
      var $563=$250;
      (function() { try { __THREW__ = false; return __ZNKSt3__18ios_base6getlocEv($__loc, $563) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 7; break; }
    case 24: // $564
      var $565=$167;
      HEAP32[(($167)>>2)]=$__loc;
      var $566=HEAP32[(($167)>>2)];
      var $567=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($566, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 67; break; };
    case 25: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $568=$567;
      var $569=$167;
      __label__ = 26; break;
    case 26: // $570
      $__ct=$568;
      var $571=$__ct;
      var $572=HEAP32[(($__bb)>>2)];
      var $573=HEAP32[(($__bb)>>2)];
      var $574=$__n;
      var $575=(($573+$574)|0);
      var $576=$__db;
      var $577=$163;
      var $578=$164;
      var $579=$165;
      var $580=$166;
      HEAP32[(($163)>>2)]=$571;
      HEAP32[(($164)>>2)]=$572;
      HEAP32[(($165)>>2)]=$575;
      HEAP32[(($166)>>2)]=$576;
      var $581=HEAP32[(($163)>>2)];
      var $582=$581;
      var $583=HEAP32[(($582)>>2)];
      var $584=(($583+48)|0);
      var $585=HEAP32[(($584)>>2)];
      var $586=HEAP32[(($164)>>2)];
      var $587=HEAP32[(($165)>>2)];
      var $588=HEAP32[(($166)>>2)];
      var $589=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$585]($581, $586, $587, $588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 67; break; };
    case 27: // $_ZNKSt3__15ctypeIwE5widenEPKcS3_Pw_exit
      var $590=$163;
      var $591=$164;
      var $592=$165;
      var $593=$166;
      __label__ = 28; break;
    case 28: // $594
      var $595=$__n;
      var $596=(($595)>>>0) > 0;
      if ($596) { __label__ = 29; break; } else { var $604 = 0;__label__ = 30; break; }
    case 29: // $597
      var $598=HEAP32[(($__bb)>>2)];
      var $599=(($598)|0);
      var $600=HEAP8[($599)];
      var $601=(($600 << 24) >> 24);
      var $602=(($601)|0)==45;
      var $604 = $602;__label__ = 30; break;
    case 30: // $603
      var $604;
      var $605=(($604)&1);
      $__neg=$605;
      var $606=$162;
      HEAP32[(($162)>>2)]=$__grp;
      var $607=HEAP32[(($162)>>2)];
      var $608=$161;
      HEAP32[(($161)>>2)]=$607;
      var $609=HEAPU32[(($161)>>2)];
      var $610=$609;
      var $611=(($609)|0);
      var $612=$160;
      HEAP32[(($160)>>2)]=$611;
      var $613=HEAP32[(($160)>>2)];
      var $614=$159;
      HEAP32[(($159)>>2)]=$613;
      var $615=HEAP32[(($159)>>2)];
      var $616=$615;
      var $617=$158;
      HEAP32[(($158)>>2)]=$616;
      var $618=HEAP32[(($158)>>2)];
      var $619=$618;
      var $620=$157;
      HEAP32[(($157)>>2)]=$619;
      var $621=HEAP32[(($157)>>2)];
      var $622=$157;
      var $623=(($618)|0);
      var $624=$158;
      var $625=$159;
      var $626=$160;
      var $627=$156;
      var $628=$__a_i_i_i;
      var $629=$__i_i_i_i;
      HEAP32[(($156)>>2)]=$609;
      var $630=HEAP32[(($156)>>2)];
      var $631=(($630)|0);
      var $632=$155;
      HEAP32[(($155)>>2)]=$631;
      var $633=HEAP32[(($155)>>2)];
      var $634=$633;
      var $635=$154;
      HEAP32[(($154)>>2)]=$634;
      var $636=HEAP32[(($154)>>2)];
      var $637=(($636)|0);
      var $638=$154;
      var $639=$155;
      var $640=(($637)|0);
      var $641=$640;
      var $642=(($641)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$642;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 31; break;
    case 31: // $643
      var $644=HEAPU32[(($__i_i_i_i)>>2)];
      var $645=(($644)>>>0) < 3;
      if ($645) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $646
      var $647=HEAP32[(($__i_i_i_i)>>2)];
      var $648=HEAP32[(($__a_i_i_i)>>2)];
      var $649=(($648+($647<<2))|0);
      HEAP32[(($649)>>2)]=0;
      var $650=HEAP32[(($__i_i_i_i)>>2)];
      var $651=(($650+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$651;
      __label__ = 31; break;
    case 33: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $652=$156;
      var $653=$__a_i_i_i;
      var $654=$__i_i_i_i;
      var $655=$161;
      var $656=$162;
      __label__ = 34; break;
    case 34: // $657
      var $658=$141;
      HEAP32[(($141)>>2)]=$__sym;
      var $659=HEAP32[(($141)>>2)];
      var $660=$140;
      HEAP32[(($140)>>2)]=$659;
      var $661=HEAPU32[(($140)>>2)];
      var $662=$661;
      var $663=(($661)|0);
      var $664=$139;
      HEAP32[(($139)>>2)]=$663;
      var $665=HEAP32[(($139)>>2)];
      var $666=$138;
      HEAP32[(($138)>>2)]=$665;
      var $667=HEAP32[(($138)>>2)];
      var $668=$667;
      var $669=$137;
      HEAP32[(($137)>>2)]=$668;
      var $670=HEAP32[(($137)>>2)];
      var $671=$670;
      var $672=$136;
      HEAP32[(($136)>>2)]=$671;
      var $673=HEAP32[(($136)>>2)];
      var $674=$136;
      var $675=(($670)|0);
      var $676=$137;
      var $677=$138;
      var $678=$139;
      var $679=$135;
      var $680=$__a_i_i_i3;
      var $681=$__i_i_i_i4;
      HEAP32[(($135)>>2)]=$661;
      var $682=HEAP32[(($135)>>2)];
      var $683=(($682)|0);
      var $684=$134;
      HEAP32[(($134)>>2)]=$683;
      var $685=HEAP32[(($134)>>2)];
      var $686=$685;
      var $687=$133;
      HEAP32[(($133)>>2)]=$686;
      var $688=HEAP32[(($133)>>2)];
      var $689=(($688)|0);
      var $690=$133;
      var $691=$134;
      var $692=(($689)|0);
      var $693=$692;
      var $694=(($693)|0);
      HEAP32[(($__a_i_i_i3)>>2)]=$694;
      HEAP32[(($__i_i_i_i4)>>2)]=0;
      __label__ = 35; break;
    case 35: // $695
      var $696=HEAPU32[(($__i_i_i_i4)>>2)];
      var $697=(($696)>>>0) < 3;
      if ($697) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $698
      var $699=HEAP32[(($__i_i_i_i4)>>2)];
      var $700=HEAP32[(($__a_i_i_i3)>>2)];
      var $701=(($700+($699<<2))|0);
      HEAP32[(($701)>>2)]=0;
      var $702=HEAP32[(($__i_i_i_i4)>>2)];
      var $703=(($702+1)|0);
      HEAP32[(($__i_i_i_i4)>>2)]=$703;
      __label__ = 35; break;
    case 37: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $704=$135;
      var $705=$__a_i_i_i3;
      var $706=$__i_i_i_i4;
      var $707=$140;
      var $708=$141;
      __label__ = 38; break;
    case 38: // $709
      var $710=$132;
      HEAP32[(($132)>>2)]=$__sn;
      var $711=HEAP32[(($132)>>2)];
      var $712=$131;
      HEAP32[(($131)>>2)]=$711;
      var $713=HEAPU32[(($131)>>2)];
      var $714=$713;
      var $715=(($713)|0);
      var $716=$130;
      HEAP32[(($130)>>2)]=$715;
      var $717=HEAP32[(($130)>>2)];
      var $718=$129;
      HEAP32[(($129)>>2)]=$717;
      var $719=HEAP32[(($129)>>2)];
      var $720=$719;
      var $721=$128;
      HEAP32[(($128)>>2)]=$720;
      var $722=HEAP32[(($128)>>2)];
      var $723=$722;
      var $724=$127;
      HEAP32[(($127)>>2)]=$723;
      var $725=HEAP32[(($127)>>2)];
      var $726=$127;
      var $727=(($722)|0);
      var $728=$128;
      var $729=$129;
      var $730=$130;
      var $731=$126;
      var $732=$__a_i_i_i5;
      var $733=$__i_i_i_i6;
      HEAP32[(($126)>>2)]=$713;
      var $734=HEAP32[(($126)>>2)];
      var $735=(($734)|0);
      var $736=$125;
      HEAP32[(($125)>>2)]=$735;
      var $737=HEAP32[(($125)>>2)];
      var $738=$737;
      var $739=$124;
      HEAP32[(($124)>>2)]=$738;
      var $740=HEAP32[(($124)>>2)];
      var $741=(($740)|0);
      var $742=$124;
      var $743=$125;
      var $744=(($741)|0);
      var $745=$744;
      var $746=(($745)|0);
      HEAP32[(($__a_i_i_i5)>>2)]=$746;
      HEAP32[(($__i_i_i_i6)>>2)]=0;
      __label__ = 39; break;
    case 39: // $747
      var $748=HEAPU32[(($__i_i_i_i6)>>2)];
      var $749=(($748)>>>0) < 3;
      if ($749) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $750
      var $751=HEAP32[(($__i_i_i_i6)>>2)];
      var $752=HEAP32[(($__a_i_i_i5)>>2)];
      var $753=(($752+($751<<2))|0);
      HEAP32[(($753)>>2)]=0;
      var $754=HEAP32[(($__i_i_i_i6)>>2)];
      var $755=(($754+1)|0);
      HEAP32[(($__i_i_i_i6)>>2)]=$755;
      __label__ = 39; break;
    case 41: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit7
      var $756=$126;
      var $757=$__a_i_i_i5;
      var $758=$__i_i_i_i6;
      var $759=$131;
      var $760=$132;
      __label__ = 42; break;
    case 42: // $761
      var $762=$249;
      var $763=(($762) & 1);
      var $764=$__neg;
      var $765=(($764) & 1);
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri($763, $765, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 70; break; }
    case 43: // $766
      var $767=(($__mbuf)|0);
      $__mb=$767;
      var $768=$109;
      var $769=$110;
      var $770=$111;
      HEAP32[(($109)>>2)]=$__hw;
      HEAP32[(($110)>>2)]=0;
      HEAP32[(($111)>>2)]=1496;
      var $771=HEAP32[(($109)>>2)];
      var $772=HEAP32[(($110)>>2)];
      var $773=HEAP32[(($111)>>2)];
      var $774=$106;
      var $775=$107;
      var $776=$108;
      HEAP32[(($106)>>2)]=$771;
      HEAP32[(($107)>>2)]=$772;
      HEAP32[(($108)>>2)]=$773;
      var $777=HEAP32[(($106)>>2)];
      var $778=(($777)|0);
      var $779=$105;
      HEAP32[(($105)>>2)]=$107;
      var $780=HEAP32[(($105)>>2)];
      var $781=$105;
      var $782=HEAP32[(($780)>>2)];
      var $783=$91;
      HEAP32[(($91)>>2)]=$108;
      var $784=HEAP32[(($91)>>2)];
      var $785=$91;
      var $786=HEAP32[(($784)>>2)];
      var $787=$102;
      var $788=$103;
      var $789=$104;
      HEAP32[(($102)>>2)]=$778;
      HEAP32[(($103)>>2)]=$782;
      HEAP32[(($104)>>2)]=$786;
      var $790=HEAP32[(($102)>>2)];
      var $791=HEAP32[(($103)>>2)];
      var $792=HEAP32[(($104)>>2)];
      var $793=$99;
      var $794=$100;
      var $795=$101;
      HEAP32[(($99)>>2)]=$790;
      HEAP32[(($100)>>2)]=$791;
      HEAP32[(($101)>>2)]=$792;
      var $796=HEAP32[(($99)>>2)];
      var $797=$796;
      var $798=$98;
      HEAP32[(($98)>>2)]=$100;
      var $799=HEAP32[(($98)>>2)];
      var $800=$98;
      var $801=HEAP32[(($799)>>2)];
      var $802=$92;
      HEAP32[(($92)>>2)]=$101;
      var $803=HEAP32[(($92)>>2)];
      var $804=$92;
      var $805=HEAP32[(($803)>>2)];
      var $806=$95;
      var $807=$96;
      var $808=$97;
      HEAP32[(($95)>>2)]=$797;
      HEAP32[(($96)>>2)]=$801;
      HEAP32[(($97)>>2)]=$805;
      var $809=HEAP32[(($95)>>2)];
      var $810=(($809)|0);
      var $811=$94;
      HEAP32[(($94)>>2)]=$96;
      var $812=HEAP32[(($94)>>2)];
      var $813=$94;
      var $814=HEAP32[(($812)>>2)];
      HEAP32[(($810)>>2)]=$814;
      var $815=(($809+4)|0);
      var $816=$93;
      HEAP32[(($93)>>2)]=$97;
      var $817=HEAP32[(($93)>>2)];
      var $818=$93;
      var $819=HEAP32[(($817)>>2)];
      HEAP32[(($815)>>2)]=$819;
      var $820=$95;
      var $821=$96;
      var $822=$97;
      var $823=$99;
      var $824=$100;
      var $825=$101;
      var $826=$102;
      var $827=$103;
      var $828=$104;
      var $829=$106;
      var $830=$107;
      var $831=$108;
      var $832=$109;
      var $833=$110;
      var $834=$111;
      __label__ = 44; break;
    case 44: // $835
      var $836=$__n;
      var $837=HEAP32[(($__fd)>>2)];
      var $838=(($836)|0) > (($837)|0);
      if ($838) { __label__ = 45; break; } else { __label__ = 52; break; }
    case 45: // $839
      var $840=$__n;
      var $841=HEAP32[(($__fd)>>2)];
      var $842=(($840-$841)|0);
      var $843=((($842<<1))|0);
      var $844=$90;
      HEAP32[(($90)>>2)]=$__sn;
      var $845=HEAPU32[(($90)>>2)];
      var $846=$89;
      HEAP32[(($89)>>2)]=$845;
      var $847=HEAP32[(($89)>>2)];
      var $848=(($847)|0);
      var $849=$88;
      HEAP32[(($88)>>2)]=$848;
      var $850=HEAP32[(($88)>>2)];
      var $851=$850;
      var $852=$87;
      HEAP32[(($87)>>2)]=$851;
      var $853=HEAP32[(($87)>>2)];
      var $854=(($853)|0);
      var $855=$87;
      var $856=$88;
      var $857=(($854)|0);
      var $858=$857;
      var $859=(($858)|0);
      var $860=$859;
      var $861=HEAPU8[($860)];
      var $862=(($861)&255);
      var $863=$862 & 1;
      var $864=(($863)|0)!=0;
      var $865=$89;
      if ($864) { __label__ = 46; break; } else { __label__ = 47; break; }
    case 46: // $866
      var $867=$83;
      HEAP32[(($83)>>2)]=$845;
      var $868=HEAP32[(($83)>>2)];
      var $869=(($868)|0);
      var $870=$82;
      HEAP32[(($82)>>2)]=$869;
      var $871=HEAP32[(($82)>>2)];
      var $872=$871;
      var $873=$81;
      HEAP32[(($81)>>2)]=$872;
      var $874=HEAP32[(($81)>>2)];
      var $875=(($874)|0);
      var $876=$81;
      var $877=$82;
      var $878=(($875)|0);
      var $879=$878;
      var $880=(($879+4)|0);
      var $881=HEAP32[(($880)>>2)];
      var $882=$83;
      var $903 = $881;__label__ = 48; break;
    case 47: // $883
      var $884=$86;
      HEAP32[(($86)>>2)]=$845;
      var $885=HEAP32[(($86)>>2)];
      var $886=(($885)|0);
      var $887=$85;
      HEAP32[(($85)>>2)]=$886;
      var $888=HEAP32[(($85)>>2)];
      var $889=$888;
      var $890=$84;
      HEAP32[(($84)>>2)]=$889;
      var $891=HEAP32[(($84)>>2)];
      var $892=(($891)|0);
      var $893=$84;
      var $894=$85;
      var $895=(($892)|0);
      var $896=$895;
      var $897=(($896)|0);
      var $898=$897;
      var $899=HEAPU8[($898)];
      var $900=(($899)&255);
      var $901=$900 >> 1;
      var $902=$86;
      var $903 = $901;__label__ = 48; break;
    case 48: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $903;
      var $904=$90;
      var $905=(($843+$903)|0);
      var $906=$80;
      HEAP32[(($80)>>2)]=$__sym;
      var $907=HEAPU32[(($80)>>2)];
      var $908=$79;
      HEAP32[(($79)>>2)]=$907;
      var $909=HEAP32[(($79)>>2)];
      var $910=(($909)|0);
      var $911=$78;
      HEAP32[(($78)>>2)]=$910;
      var $912=HEAP32[(($78)>>2)];
      var $913=$912;
      var $914=$77;
      HEAP32[(($77)>>2)]=$913;
      var $915=HEAP32[(($77)>>2)];
      var $916=(($915)|0);
      var $917=$77;
      var $918=$78;
      var $919=(($916)|0);
      var $920=$919;
      var $921=(($920)|0);
      var $922=$921;
      var $923=HEAPU8[($922)];
      var $924=(($923)&255);
      var $925=$924 & 1;
      var $926=(($925)|0)!=0;
      var $927=$79;
      if ($926) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $928
      var $929=$73;
      HEAP32[(($73)>>2)]=$907;
      var $930=HEAP32[(($73)>>2)];
      var $931=(($930)|0);
      var $932=$72;
      HEAP32[(($72)>>2)]=$931;
      var $933=HEAP32[(($72)>>2)];
      var $934=$933;
      var $935=$71;
      HEAP32[(($71)>>2)]=$934;
      var $936=HEAP32[(($71)>>2)];
      var $937=(($936)|0);
      var $938=$71;
      var $939=$72;
      var $940=(($937)|0);
      var $941=$940;
      var $942=(($941+4)|0);
      var $943=HEAP32[(($942)>>2)];
      var $944=$73;
      var $965 = $943;__label__ = 51; break;
    case 50: // $945
      var $946=$76;
      HEAP32[(($76)>>2)]=$907;
      var $947=HEAP32[(($76)>>2)];
      var $948=(($947)|0);
      var $949=$75;
      HEAP32[(($75)>>2)]=$948;
      var $950=HEAP32[(($75)>>2)];
      var $951=$950;
      var $952=$74;
      HEAP32[(($74)>>2)]=$951;
      var $953=HEAP32[(($74)>>2)];
      var $954=(($953)|0);
      var $955=$74;
      var $956=$75;
      var $957=(($954)|0);
      var $958=$957;
      var $959=(($958)|0);
      var $960=$959;
      var $961=HEAPU8[($960)];
      var $962=(($961)&255);
      var $963=$962 >> 1;
      var $964=$76;
      var $965 = $963;__label__ = 51; break;
    case 51: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit10
      var $965;
      var $966=$80;
      var $967=(($905+$965)|0);
      var $968=HEAP32[(($__fd)>>2)];
      var $969=(($967+$968)|0);
      var $970=(($969+1)|0);
      var $1099 = $970;__label__ = 59; break;
    case 52: // $971
      var $972=$58;
      HEAP32[(($58)>>2)]=$__sn;
      var $973=HEAPU32[(($58)>>2)];
      var $974=$57;
      HEAP32[(($57)>>2)]=$973;
      var $975=HEAP32[(($57)>>2)];
      var $976=(($975)|0);
      var $977=$56;
      HEAP32[(($56)>>2)]=$976;
      var $978=HEAP32[(($56)>>2)];
      var $979=$978;
      var $980=$55;
      HEAP32[(($55)>>2)]=$979;
      var $981=HEAP32[(($55)>>2)];
      var $982=(($981)|0);
      var $983=$55;
      var $984=$56;
      var $985=(($982)|0);
      var $986=$985;
      var $987=(($986)|0);
      var $988=$987;
      var $989=HEAPU8[($988)];
      var $990=(($989)&255);
      var $991=$990 & 1;
      var $992=(($991)|0)!=0;
      var $993=$57;
      if ($992) { __label__ = 53; break; } else { __label__ = 54; break; }
    case 53: // $994
      var $995=$51;
      HEAP32[(($51)>>2)]=$973;
      var $996=HEAP32[(($51)>>2)];
      var $997=(($996)|0);
      var $998=$50;
      HEAP32[(($50)>>2)]=$997;
      var $999=HEAP32[(($50)>>2)];
      var $1000=$999;
      var $1001=$49;
      HEAP32[(($49)>>2)]=$1000;
      var $1002=HEAP32[(($49)>>2)];
      var $1003=(($1002)|0);
      var $1004=$49;
      var $1005=$50;
      var $1006=(($1003)|0);
      var $1007=$1006;
      var $1008=(($1007+4)|0);
      var $1009=HEAP32[(($1008)>>2)];
      var $1010=$51;
      var $1031 = $1009;__label__ = 55; break;
    case 54: // $1011
      var $1012=$54;
      HEAP32[(($54)>>2)]=$973;
      var $1013=HEAP32[(($54)>>2)];
      var $1014=(($1013)|0);
      var $1015=$53;
      HEAP32[(($53)>>2)]=$1014;
      var $1016=HEAP32[(($53)>>2)];
      var $1017=$1016;
      var $1018=$52;
      HEAP32[(($52)>>2)]=$1017;
      var $1019=HEAP32[(($52)>>2)];
      var $1020=(($1019)|0);
      var $1021=$52;
      var $1022=$53;
      var $1023=(($1020)|0);
      var $1024=$1023;
      var $1025=(($1024)|0);
      var $1026=$1025;
      var $1027=HEAPU8[($1026)];
      var $1028=(($1027)&255);
      var $1029=$1028 >> 1;
      var $1030=$54;
      var $1031 = $1029;__label__ = 55; break;
    case 55: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit13
      var $1031;
      var $1032=$58;
      var $1033=$48;
      HEAP32[(($48)>>2)]=$__sym;
      var $1034=HEAPU32[(($48)>>2)];
      var $1035=$47;
      HEAP32[(($47)>>2)]=$1034;
      var $1036=HEAP32[(($47)>>2)];
      var $1037=(($1036)|0);
      var $1038=$46;
      HEAP32[(($46)>>2)]=$1037;
      var $1039=HEAP32[(($46)>>2)];
      var $1040=$1039;
      var $1041=$45;
      HEAP32[(($45)>>2)]=$1040;
      var $1042=HEAP32[(($45)>>2)];
      var $1043=(($1042)|0);
      var $1044=$45;
      var $1045=$46;
      var $1046=(($1043)|0);
      var $1047=$1046;
      var $1048=(($1047)|0);
      var $1049=$1048;
      var $1050=HEAPU8[($1049)];
      var $1051=(($1050)&255);
      var $1052=$1051 & 1;
      var $1053=(($1052)|0)!=0;
      var $1054=$47;
      if ($1053) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $1055
      var $1056=$41;
      HEAP32[(($41)>>2)]=$1034;
      var $1057=HEAP32[(($41)>>2)];
      var $1058=(($1057)|0);
      var $1059=$40;
      HEAP32[(($40)>>2)]=$1058;
      var $1060=HEAP32[(($40)>>2)];
      var $1061=$1060;
      var $1062=$39;
      HEAP32[(($39)>>2)]=$1061;
      var $1063=HEAP32[(($39)>>2)];
      var $1064=(($1063)|0);
      var $1065=$39;
      var $1066=$40;
      var $1067=(($1064)|0);
      var $1068=$1067;
      var $1069=(($1068+4)|0);
      var $1070=HEAP32[(($1069)>>2)];
      var $1071=$41;
      var $1092 = $1070;__label__ = 58; break;
    case 57: // $1072
      var $1073=$44;
      HEAP32[(($44)>>2)]=$1034;
      var $1074=HEAP32[(($44)>>2)];
      var $1075=(($1074)|0);
      var $1076=$43;
      HEAP32[(($43)>>2)]=$1075;
      var $1077=HEAP32[(($43)>>2)];
      var $1078=$1077;
      var $1079=$42;
      HEAP32[(($42)>>2)]=$1078;
      var $1080=HEAP32[(($42)>>2)];
      var $1081=(($1080)|0);
      var $1082=$42;
      var $1083=$43;
      var $1084=(($1081)|0);
      var $1085=$1084;
      var $1086=(($1085)|0);
      var $1087=$1086;
      var $1088=HEAPU8[($1087)];
      var $1089=(($1088)&255);
      var $1090=$1089 >> 1;
      var $1091=$44;
      var $1092 = $1090;__label__ = 58; break;
    case 58: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit14
      var $1092;
      var $1093=$48;
      var $1094=(($1031+$1092)|0);
      var $1095=HEAP32[(($__fd)>>2)];
      var $1096=(($1094+$1095)|0);
      var $1097=(($1096+2)|0);
      var $1099 = $1097;__label__ = 59; break;
    case 59: // $1098
      var $1099;
      $__exn=$1099;
      var $1100=$__exn;
      var $1101=(($1100)>>>0) > 100;
      if ($1101) { __label__ = 60; break; } else { __label__ = 77; break; }
    case 60: // $1102
      var $1103=$__exn;
      var $1104=((($1103<<2))|0);
      var $1105=_malloc($1104);
      var $1106=$1105;
      var $1107=$35;
      var $1108=$36;
      var $1109=$__tmp_i15;
      var $1110=$37;
      var $1111=$38;
      HEAP32[(($35)>>2)]=$__hw;
      HEAP32[(($36)>>2)]=$1106;
      var $1112=HEAPU32[(($35)>>2)];
      var $1113=(($1112)|0);
      var $1114=$34;
      HEAP32[(($34)>>2)]=$1113;
      var $1115=HEAP32[(($34)>>2)];
      var $1116=$1115;
      var $1117=$33;
      HEAP32[(($33)>>2)]=$1116;
      var $1118=HEAP32[(($33)>>2)];
      var $1119=(($1118)|0);
      var $1120=$33;
      var $1121=$34;
      var $1122=HEAP32[(($1119)>>2)];
      HEAP32[(($__tmp_i15)>>2)]=$1122;
      var $1123=HEAP32[(($36)>>2)];
      var $1124=(($1112)|0);
      var $1125=$32;
      HEAP32[(($32)>>2)]=$1124;
      var $1126=HEAP32[(($32)>>2)];
      var $1127=$1126;
      var $1128=$31;
      HEAP32[(($31)>>2)]=$1127;
      var $1129=HEAP32[(($31)>>2)];
      var $1130=(($1129)|0);
      var $1131=$31;
      var $1132=$32;
      HEAP32[(($1130)>>2)]=$1123;
      var $1133=HEAP32[(($__tmp_i15)>>2)];
      var $1134=(($1133)|0)!=0;
      if ($1134) { __label__ = 61; break; } else { __label__ = 64; break; }
    case 61: // $1135
      var $1136=(($1112)|0);
      var $1137=$30;
      HEAP32[(($30)>>2)]=$1136;
      var $1138=HEAP32[(($30)>>2)];
      var $1139=$1138;
      var $1140=$29;
      HEAP32[(($29)>>2)]=$1139;
      var $1141=HEAP32[(($29)>>2)];
      var $1142=(($1141+4)|0);
      var $1143=$29;
      var $1144=$30;
      var $1145=HEAP32[(($1142)>>2)];
      var $1146=HEAP32[(($__tmp_i15)>>2)];
      var $1147=$1146;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1145]($1147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $1148
      __label__ = 64; break;
    case 63: // $1149
      var $1150=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1151=$1150.f0;
      HEAP32[(($37)>>2)]=$1151;
      var $1152=$1150.f1;
      HEAP32[(($38)>>2)]=$1152;
      var $1153=HEAP32[(($37)>>2)];
      ___cxa_call_unexpected($1153);
      throw "Reached an unreachable!"
    case 64: // $_ZNSt3__110unique_ptrIwPFvPvEE5resetEPw_exit16
      var $1154=$35;
      var $1155=$36;
      var $1156=$__tmp_i15;
      var $1157=$37;
      var $1158=$38;
      var $1159=$28;
      HEAP32[(($28)>>2)]=$__hw;
      var $1160=HEAP32[(($28)>>2)];
      var $1161=(($1160)|0);
      var $1162=$27;
      HEAP32[(($27)>>2)]=$1161;
      var $1163=HEAP32[(($27)>>2)];
      var $1164=$1163;
      var $1165=$26;
      HEAP32[(($26)>>2)]=$1164;
      var $1166=HEAP32[(($26)>>2)];
      var $1167=(($1166)|0);
      var $1168=$26;
      var $1169=$27;
      var $1170=HEAP32[(($1167)>>2)];
      var $1171=$28;
      $__mb=$1170;
      var $1172=$__mb;
      var $1173=(($1172)|0)==0;
      if ($1173) { __label__ = 65; break; } else { __label__ = 76; break; }
    case 65: // $1174
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 71; break; }
    case 66: // $1175
      __label__ = 76; break;
    case 67: // $1176
      var $1177=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1178=$1177.f0;
      $253=$1178;
      var $1179=$1177.f1;
      $254=$1179;
      __label__ = 101; break;
    case 68: // $1180
      var $1181=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1182=$1181.f0;
      $253=$1182;
      var $1183=$1181.f1;
      $254=$1183;
      __label__ = 94; break;
    case 69: // $1184
      var $1185=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1186=$1185.f0;
      $253=$1186;
      var $1187=$1185.f1;
      $254=$1187;
      __label__ = 91; break;
    case 70: // $1188
      var $1189=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1190=$1189.f0;
      $253=$1190;
      var $1191=$1189.f1;
      $254=$1191;
      __label__ = 88; break;
    case 71: // $1192
      var $1193=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1194=$1193.f0;
      $253=$1194;
      var $1195=$1193.f1;
      $254=$1195;
      var $1196=$25;
      HEAP32[(($25)>>2)]=$__hw;
      var $1197=HEAP32[(($25)>>2)];
      var $1198=$24;
      HEAP32[(($24)>>2)]=$1197;
      var $1199=HEAP32[(($24)>>2)];
      var $1200=$20;
      var $1201=$21;
      var $1202=$__tmp_i_i_i17;
      var $1203=$22;
      var $1204=$23;
      HEAP32[(($20)>>2)]=$1199;
      HEAP32[(($21)>>2)]=0;
      var $1205=HEAP32[(($20)>>2)];
      var $1206=(($1205)|0);
      var $1207=$19;
      HEAP32[(($19)>>2)]=$1206;
      var $1208=HEAP32[(($19)>>2)];
      var $1209=$1208;
      var $1210=$18;
      HEAP32[(($18)>>2)]=$1209;
      var $1211=HEAP32[(($18)>>2)];
      var $1212=(($1211)|0);
      var $1213=$18;
      var $1214=$19;
      var $1215=HEAP32[(($1212)>>2)];
      HEAP32[(($__tmp_i_i_i17)>>2)]=$1215;
      var $1216=HEAP32[(($21)>>2)];
      var $1217=(($1205)|0);
      var $1218=$17;
      HEAP32[(($17)>>2)]=$1217;
      var $1219=HEAP32[(($17)>>2)];
      var $1220=$1219;
      var $1221=$16;
      HEAP32[(($16)>>2)]=$1220;
      var $1222=HEAP32[(($16)>>2)];
      var $1223=(($1222)|0);
      var $1224=$16;
      var $1225=$17;
      HEAP32[(($1223)>>2)]=$1216;
      var $1226=HEAP32[(($__tmp_i_i_i17)>>2)];
      var $1227=(($1226)|0)!=0;
      if ($1227) { __label__ = 72; break; } else { __label__ = 75; break; }
    case 72: // $1228
      var $1229=(($1205)|0);
      var $1230=$15;
      HEAP32[(($15)>>2)]=$1229;
      var $1231=HEAP32[(($15)>>2)];
      var $1232=$1231;
      var $1233=$14;
      HEAP32[(($14)>>2)]=$1232;
      var $1234=HEAP32[(($14)>>2)];
      var $1235=(($1234+4)|0);
      var $1236=$14;
      var $1237=$15;
      var $1238=HEAP32[(($1235)>>2)];
      var $1239=HEAP32[(($__tmp_i_i_i17)>>2)];
      var $1240=$1239;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1238]($1240) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 74; break; }
    case 73: // $1241
      __label__ = 75; break;
    case 74: // $1242
      var $1243=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1244=$1243.f0;
      HEAP32[(($22)>>2)]=$1244;
      var $1245=$1243.f1;
      HEAP32[(($23)>>2)]=$1245;
      var $1246=HEAP32[(($22)>>2)];
      ___cxa_call_unexpected($1246);
      throw "Reached an unreachable!"
    case 75: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit18
      var $1247=$20;
      var $1248=$21;
      var $1249=$__tmp_i_i_i17;
      var $1250=$22;
      var $1251=$23;
      var $1252=$24;
      var $1253=$25;
      __label__ = 86; break;
    case 76: // $1254
      __label__ = 77; break;
    case 77: // $1255
      var $1256=$__mb;
      var $1257=$250;
      var $1258=$13;
      HEAP32[(($13)>>2)]=$1257;
      var $1259=HEAP32[(($13)>>2)];
      var $1260=(($1259+4)|0);
      var $1261=HEAP32[(($1260)>>2)];
      var $1262=$13;
      __label__ = 78; break;
    case 78: // $1263
      var $1264=$__db;
      var $1265=$__db;
      var $1266=$__n;
      var $1267=(($1265+($1266<<2))|0);
      var $1268=$__ct;
      var $1269=$__neg;
      var $1270=(($1269) & 1);
      var $1271=HEAP32[(($__dp)>>2)];
      var $1272=HEAP32[(($__ts)>>2)];
      var $1273=HEAP32[(($__fd)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i($1256, $__mi, $__me, $1261, $1264, $1267, $1268, $1270, $__pat, $1271, $1272, $__grp, $__sym, $__sn, $1273) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 79; break; } else { __label__ = 71; break; }
    case 79: // $1274
      var $1275=$255;
      var $1276=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1275)>>2)]=HEAP32[(($1276)>>2)];
      var $1277=$__mb;
      var $1278=HEAP32[(($__mi)>>2)];
      var $1279=HEAP32[(($__me)>>2)];
      var $1280=$250;
      var $1281=$251;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $255, $1277, $1278, $1279, $1280, $1281) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 71; break; }
    case 80: // $1282
      $256=1;
      var $1283=$12;
      HEAP32[(($12)>>2)]=$__hw;
      var $1284=HEAP32[(($12)>>2)];
      var $1285=$11;
      HEAP32[(($11)>>2)]=$1284;
      var $1286=HEAP32[(($11)>>2)];
      var $1287=$7;
      var $1288=$8;
      var $1289=$__tmp_i_i_i19;
      var $1290=$9;
      var $1291=$10;
      HEAP32[(($7)>>2)]=$1286;
      HEAP32[(($8)>>2)]=0;
      var $1292=HEAP32[(($7)>>2)];
      var $1293=(($1292)|0);
      var $1294=$6;
      HEAP32[(($6)>>2)]=$1293;
      var $1295=HEAP32[(($6)>>2)];
      var $1296=$1295;
      var $1297=$5;
      HEAP32[(($5)>>2)]=$1296;
      var $1298=HEAP32[(($5)>>2)];
      var $1299=(($1298)|0);
      var $1300=$5;
      var $1301=$6;
      var $1302=HEAP32[(($1299)>>2)];
      HEAP32[(($__tmp_i_i_i19)>>2)]=$1302;
      var $1303=HEAP32[(($8)>>2)];
      var $1304=(($1292)|0);
      var $1305=$4;
      HEAP32[(($4)>>2)]=$1304;
      var $1306=HEAP32[(($4)>>2)];
      var $1307=$1306;
      var $1308=$3;
      HEAP32[(($3)>>2)]=$1307;
      var $1309=HEAP32[(($3)>>2)];
      var $1310=(($1309)|0);
      var $1311=$3;
      var $1312=$4;
      HEAP32[(($1310)>>2)]=$1303;
      var $1313=HEAP32[(($__tmp_i_i_i19)>>2)];
      var $1314=(($1313)|0)!=0;
      if ($1314) { __label__ = 81; break; } else { __label__ = 84; break; }
    case 81: // $1315
      var $1316=(($1292)|0);
      var $1317=$2;
      HEAP32[(($2)>>2)]=$1316;
      var $1318=HEAP32[(($2)>>2)];
      var $1319=$1318;
      var $1320=$1;
      HEAP32[(($1)>>2)]=$1319;
      var $1321=HEAP32[(($1)>>2)];
      var $1322=(($1321+4)|0);
      var $1323=$1;
      var $1324=$2;
      var $1325=HEAP32[(($1322)>>2)];
      var $1326=HEAP32[(($__tmp_i_i_i19)>>2)];
      var $1327=$1326;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1325]($1327) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 82; break; } else { __label__ = 83; break; }
    case 82: // $1328
      __label__ = 84; break;
    case 83: // $1329
      var $1330=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1331=$1330.f0;
      HEAP32[(($9)>>2)]=$1331;
      var $1332=$1330.f1;
      HEAP32[(($10)>>2)]=$1332;
      var $1333=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($1333);
      throw "Reached an unreachable!"
    case 84: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit20
      var $1334=$7;
      var $1335=$8;
      var $1336=$__tmp_i_i_i19;
      var $1337=$9;
      var $1338=$10;
      var $1339=$11;
      var $1340=$12;
      __label__ = 85; break;
    case 85: // $1341
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 69; break; }
    case 86: // $1342
      __label__ = 88; break;
    case 87: // $1343
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 68; break; }
    case 88: // $1344
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 89; break; } else { __label__ = 121; break; }
    case 89: // $1345
      __label__ = 91; break;
    case 90: // $1346
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 67; break; }
    case 91: // $1347
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 92; break; } else { __label__ = 121; break; }
    case 92: // $1348
      __label__ = 94; break;
    case 93: // $1349
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 96; break; } else { __label__ = 7; break; }
    case 94: // $1350
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 121; break; }
    case 95: // $1351
      __label__ = 101; break;
    case 96: // $1352
      var $1353=$70;
      HEAP32[(($70)>>2)]=$__hd;
      var $1354=HEAP32[(($70)>>2)];
      var $1355=$69;
      HEAP32[(($69)>>2)]=$1354;
      var $1356=HEAP32[(($69)>>2)];
      var $1357=$65;
      var $1358=$66;
      var $1359=$__tmp_i_i_i11;
      var $1360=$67;
      var $1361=$68;
      HEAP32[(($65)>>2)]=$1356;
      HEAP32[(($66)>>2)]=0;
      var $1362=HEAP32[(($65)>>2)];
      var $1363=(($1362)|0);
      var $1364=$64;
      HEAP32[(($64)>>2)]=$1363;
      var $1365=HEAP32[(($64)>>2)];
      var $1366=$1365;
      var $1367=$63;
      HEAP32[(($63)>>2)]=$1366;
      var $1368=HEAP32[(($63)>>2)];
      var $1369=(($1368)|0);
      var $1370=$63;
      var $1371=$64;
      var $1372=HEAP32[(($1369)>>2)];
      HEAP32[(($__tmp_i_i_i11)>>2)]=$1372;
      var $1373=HEAP32[(($66)>>2)];
      var $1374=(($1362)|0);
      var $1375=$62;
      HEAP32[(($62)>>2)]=$1374;
      var $1376=HEAP32[(($62)>>2)];
      var $1377=$1376;
      var $1378=$61;
      HEAP32[(($61)>>2)]=$1377;
      var $1379=HEAP32[(($61)>>2)];
      var $1380=(($1379)|0);
      var $1381=$61;
      var $1382=$62;
      HEAP32[(($1380)>>2)]=$1373;
      var $1383=HEAP32[(($__tmp_i_i_i11)>>2)];
      var $1384=(($1383)|0)!=0;
      if ($1384) { __label__ = 97; break; } else { __label__ = 100; break; }
    case 97: // $1385
      var $1386=(($1362)|0);
      var $1387=$60;
      HEAP32[(($60)>>2)]=$1386;
      var $1388=HEAP32[(($60)>>2)];
      var $1389=$1388;
      var $1390=$59;
      HEAP32[(($59)>>2)]=$1389;
      var $1391=HEAP32[(($59)>>2)];
      var $1392=(($1391+4)|0);
      var $1393=$59;
      var $1394=$60;
      var $1395=HEAP32[(($1392)>>2)];
      var $1396=HEAP32[(($__tmp_i_i_i11)>>2)];
      var $1397=$1396;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1395]($1397) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 98; break; } else { __label__ = 99; break; }
    case 98: // $1398
      __label__ = 100; break;
    case 99: // $1399
      var $1400=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1401=$1400.f0;
      HEAP32[(($67)>>2)]=$1401;
      var $1402=$1400.f1;
      HEAP32[(($68)>>2)]=$1402;
      var $1403=HEAP32[(($67)>>2)];
      ___cxa_call_unexpected($1403);
      throw "Reached an unreachable!"
    case 100: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit12
      var $1404=$65;
      var $1405=$66;
      var $1406=$__tmp_i_i_i11;
      var $1407=$67;
      var $1408=$68;
      var $1409=$69;
      var $1410=$70;
      __label__ = 103; break;
    case 101: // $1411
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 102; break; } else { __label__ = 121; break; }
    case 102: // $1412
      __label__ = 108; break;
    case 103: // $1413
      var $1414=$123;
      HEAP32[(($123)>>2)]=$__hn;
      var $1415=HEAP32[(($123)>>2)];
      var $1416=$122;
      HEAP32[(($122)>>2)]=$1415;
      var $1417=HEAP32[(($122)>>2)];
      var $1418=$118;
      var $1419=$119;
      var $1420=$__tmp_i_i_i8;
      var $1421=$120;
      var $1422=$121;
      HEAP32[(($118)>>2)]=$1417;
      HEAP32[(($119)>>2)]=0;
      var $1423=HEAP32[(($118)>>2)];
      var $1424=(($1423)|0);
      var $1425=$117;
      HEAP32[(($117)>>2)]=$1424;
      var $1426=HEAP32[(($117)>>2)];
      var $1427=$1426;
      var $1428=$116;
      HEAP32[(($116)>>2)]=$1427;
      var $1429=HEAP32[(($116)>>2)];
      var $1430=(($1429)|0);
      var $1431=$116;
      var $1432=$117;
      var $1433=HEAP32[(($1430)>>2)];
      HEAP32[(($__tmp_i_i_i8)>>2)]=$1433;
      var $1434=HEAP32[(($119)>>2)];
      var $1435=(($1423)|0);
      var $1436=$115;
      HEAP32[(($115)>>2)]=$1435;
      var $1437=HEAP32[(($115)>>2)];
      var $1438=$1437;
      var $1439=$114;
      HEAP32[(($114)>>2)]=$1438;
      var $1440=HEAP32[(($114)>>2)];
      var $1441=(($1440)|0);
      var $1442=$114;
      var $1443=$115;
      HEAP32[(($1441)>>2)]=$1434;
      var $1444=HEAP32[(($__tmp_i_i_i8)>>2)];
      var $1445=(($1444)|0)!=0;
      if ($1445) { __label__ = 104; break; } else { __label__ = 107; break; }
    case 104: // $1446
      var $1447=(($1423)|0);
      var $1448=$113;
      HEAP32[(($113)>>2)]=$1447;
      var $1449=HEAP32[(($113)>>2)];
      var $1450=$1449;
      var $1451=$112;
      HEAP32[(($112)>>2)]=$1450;
      var $1452=HEAP32[(($112)>>2)];
      var $1453=(($1452+4)|0);
      var $1454=$112;
      var $1455=$113;
      var $1456=HEAP32[(($1453)>>2)];
      var $1457=HEAP32[(($__tmp_i_i_i8)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1456]($1457) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 105; break; } else { __label__ = 106; break; }
    case 105: // $1458
      __label__ = 107; break;
    case 106: // $1459
      var $1460=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1461=$1460.f0;
      HEAP32[(($120)>>2)]=$1461;
      var $1462=$1460.f1;
      HEAP32[(($121)>>2)]=$1462;
      var $1463=HEAP32[(($120)>>2)];
      ___cxa_call_unexpected($1463);
      throw "Reached an unreachable!"
    case 107: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit9
      var $1464=$118;
      var $1465=$119;
      var $1466=$__tmp_i_i_i8;
      var $1467=$120;
      var $1468=$121;
      var $1469=$122;
      var $1470=$123;
      STACKTOP = __stackBase__;
      return;
    case 108: // $1471
      var $1472=$153;
      HEAP32[(($153)>>2)]=$__hd;
      var $1473=HEAP32[(($153)>>2)];
      var $1474=$152;
      HEAP32[(($152)>>2)]=$1473;
      var $1475=HEAP32[(($152)>>2)];
      var $1476=$148;
      var $1477=$149;
      var $1478=$__tmp_i_i_i2;
      var $1479=$150;
      var $1480=$151;
      HEAP32[(($148)>>2)]=$1475;
      HEAP32[(($149)>>2)]=0;
      var $1481=HEAP32[(($148)>>2)];
      var $1482=(($1481)|0);
      var $1483=$147;
      HEAP32[(($147)>>2)]=$1482;
      var $1484=HEAP32[(($147)>>2)];
      var $1485=$1484;
      var $1486=$146;
      HEAP32[(($146)>>2)]=$1485;
      var $1487=HEAP32[(($146)>>2)];
      var $1488=(($1487)|0);
      var $1489=$146;
      var $1490=$147;
      var $1491=HEAP32[(($1488)>>2)];
      HEAP32[(($__tmp_i_i_i2)>>2)]=$1491;
      var $1492=HEAP32[(($149)>>2)];
      var $1493=(($1481)|0);
      var $1494=$145;
      HEAP32[(($145)>>2)]=$1493;
      var $1495=HEAP32[(($145)>>2)];
      var $1496=$1495;
      var $1497=$144;
      HEAP32[(($144)>>2)]=$1496;
      var $1498=HEAP32[(($144)>>2)];
      var $1499=(($1498)|0);
      var $1500=$144;
      var $1501=$145;
      HEAP32[(($1499)>>2)]=$1492;
      var $1502=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $1503=(($1502)|0)!=0;
      if ($1503) { __label__ = 109; break; } else { __label__ = 112; break; }
    case 109: // $1504
      var $1505=(($1481)|0);
      var $1506=$143;
      HEAP32[(($143)>>2)]=$1505;
      var $1507=HEAP32[(($143)>>2)];
      var $1508=$1507;
      var $1509=$142;
      HEAP32[(($142)>>2)]=$1508;
      var $1510=HEAP32[(($142)>>2)];
      var $1511=(($1510+4)|0);
      var $1512=$142;
      var $1513=$143;
      var $1514=HEAP32[(($1511)>>2)];
      var $1515=HEAP32[(($__tmp_i_i_i2)>>2)];
      var $1516=$1515;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1514]($1516) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 110; break; } else { __label__ = 111; break; }
    case 110: // $1517
      __label__ = 112; break;
    case 111: // $1518
      var $1519=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1520=$1519.f0;
      HEAP32[(($150)>>2)]=$1520;
      var $1521=$1519.f1;
      HEAP32[(($151)>>2)]=$1521;
      var $1522=HEAP32[(($150)>>2)];
      ___cxa_call_unexpected($1522);
      throw "Reached an unreachable!"
    case 112: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $1523=$148;
      var $1524=$149;
      var $1525=$__tmp_i_i_i2;
      var $1526=$150;
      var $1527=$151;
      var $1528=$152;
      var $1529=$153;
      __label__ = 113; break;
    case 113: // $1530
      __label__ = 114; break;
    case 114: // $1531
      var $1532=$226;
      HEAP32[(($226)>>2)]=$__hn;
      var $1533=HEAP32[(($226)>>2)];
      var $1534=$225;
      HEAP32[(($225)>>2)]=$1533;
      var $1535=HEAP32[(($225)>>2)];
      var $1536=$221;
      var $1537=$222;
      var $1538=$__tmp_i_i_i;
      var $1539=$223;
      var $1540=$224;
      HEAP32[(($221)>>2)]=$1535;
      HEAP32[(($222)>>2)]=0;
      var $1541=HEAP32[(($221)>>2)];
      var $1542=(($1541)|0);
      var $1543=$220;
      HEAP32[(($220)>>2)]=$1542;
      var $1544=HEAP32[(($220)>>2)];
      var $1545=$1544;
      var $1546=$219;
      HEAP32[(($219)>>2)]=$1545;
      var $1547=HEAP32[(($219)>>2)];
      var $1548=(($1547)|0);
      var $1549=$219;
      var $1550=$220;
      var $1551=HEAP32[(($1548)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$1551;
      var $1552=HEAP32[(($222)>>2)];
      var $1553=(($1541)|0);
      var $1554=$218;
      HEAP32[(($218)>>2)]=$1553;
      var $1555=HEAP32[(($218)>>2)];
      var $1556=$1555;
      var $1557=$217;
      HEAP32[(($217)>>2)]=$1556;
      var $1558=HEAP32[(($217)>>2)];
      var $1559=(($1558)|0);
      var $1560=$217;
      var $1561=$218;
      HEAP32[(($1559)>>2)]=$1552;
      var $1562=HEAP32[(($__tmp_i_i_i)>>2)];
      var $1563=(($1562)|0)!=0;
      if ($1563) { __label__ = 115; break; } else { __label__ = 118; break; }
    case 115: // $1564
      var $1565=(($1541)|0);
      var $1566=$216;
      HEAP32[(($216)>>2)]=$1565;
      var $1567=HEAP32[(($216)>>2)];
      var $1568=$1567;
      var $1569=$215;
      HEAP32[(($215)>>2)]=$1568;
      var $1570=HEAP32[(($215)>>2)];
      var $1571=(($1570+4)|0);
      var $1572=$215;
      var $1573=$216;
      var $1574=HEAP32[(($1571)>>2)];
      var $1575=HEAP32[(($__tmp_i_i_i)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1574]($1575) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 116; break; } else { __label__ = 117; break; }
    case 116: // $1576
      __label__ = 118; break;
    case 117: // $1577
      var $1578=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1579=$1578.f0;
      HEAP32[(($223)>>2)]=$1579;
      var $1580=$1578.f1;
      HEAP32[(($224)>>2)]=$1580;
      var $1581=HEAP32[(($223)>>2)];
      ___cxa_call_unexpected($1581);
      throw "Reached an unreachable!"
    case 118: // $_ZNSt3__110unique_ptrIcPFvPvEED1Ev_exit
      var $1582=$221;
      var $1583=$222;
      var $1584=$__tmp_i_i_i;
      var $1585=$223;
      var $1586=$224;
      var $1587=$225;
      var $1588=$226;
      __label__ = 119; break;
    case 119: // $1589
      __label__ = 120; break;
    case 120: // $1590
      var $1591=$253;
      var $1592=$253;
      var $1593=$254;
      var $1594=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1592, tempValue);
      var $1595=($1594.f1 = $1593, $1594);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 121: // $1596
      var $1597=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe["X"]=1;

function __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri($__intl, $__neg, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) {
  var __stackBase__  = STACKTOP; STACKTOP += 192; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21;
      var $22;
      var $23;
      var $24;
      var $25;
      var $26;
      var $27;
      var $28;
      var $29;
      var $30;
      var $__mp;
      var $31=__stackBase__+80;
      var $32=__stackBase__+84;
      var $33;
      var $34;
      var $35=__stackBase__+96;
      var $36=__stackBase__+100;
      var $37=__stackBase__+112;
      var $38=__stackBase__+124;
      var $__mp1;
      var $39=__stackBase__+136;
      var $40=__stackBase__+140;
      var $41=__stackBase__+152;
      var $42=__stackBase__+156;
      var $43=__stackBase__+168;
      var $44=__stackBase__+180;
      var $45=(($__intl)&1);
      $21=$45;
      var $46=(($__neg)&1);
      $22=$46;
      $23=$__loc;
      $24=$__pat;
      $25=$__dp;
      $26=$__ts;
      $27=$__grp;
      $28=$__sym;
      $29=$__sn;
      $30=$__fd;
      var $47=$21;
      var $48=(($47) & 1);
      if ($48) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $49
      var $50=$23;
      var $51=$20;
      HEAP32[(($20)>>2)]=$50;
      var $52=HEAP32[(($20)>>2)];
      var $53=__ZNKSt3__16locale9use_facetERNS0_2idE($52, __ZNSt3__110moneypunctIwLb1EE2idE);
      var $54=$53;
      var $55=$20;
      $__mp=$54;
      var $56=$22;
      var $57=(($56) & 1);
      if ($57) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $58
      var $59=$24;
      var $60=$__mp;
      var $61=$19;
      HEAP32[(($19)>>2)]=$60;
      var $62=HEAP32[(($19)>>2)];
      var $63=$62;
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64+44)|0);
      var $66=HEAP32[(($65)>>2)];
      FUNCTION_TABLE[$66]($31, $62);
      var $67=$19;
      var $68=$59;
      var $69=$31;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($68)]=HEAP8[($69)];HEAP8[($68+1)]=HEAP8[($69+1)];HEAP8[($68+2)]=HEAP8[($69+2)];HEAP8[($68+3)]=HEAP8[($69+3)];
      var $70=$29;
      var $71=$__mp;
      var $72=$18;
      HEAP32[(($18)>>2)]=$71;
      var $73=HEAP32[(($18)>>2)];
      var $74=$73;
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+32)|0);
      var $77=HEAP32[(($76)>>2)];
      FUNCTION_TABLE[$77]($32, $73);
      var $78=$18;
      var $79=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($70, $32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $80
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($32);
      __label__ = 10; break;
    case 4: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      $33=$83;
      var $84=$82.f1;
      $34=$84;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($32) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 35; break; }
    case 5: // $85
      __label__ = 34; break;
    case 6: // $86
      var $87=$24;
      var $88=$__mp;
      var $89=$17;
      HEAP32[(($17)>>2)]=$88;
      var $90=HEAP32[(($17)>>2)];
      var $91=$90;
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92+40)|0);
      var $94=HEAP32[(($93)>>2)];
      FUNCTION_TABLE[$94]($35, $90);
      var $95=$17;
      var $96=$87;
      var $97=$35;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($96)]=HEAP8[($97)];HEAP8[($96+1)]=HEAP8[($97+1)];HEAP8[($96+2)]=HEAP8[($97+2)];HEAP8[($96+3)]=HEAP8[($97+3)];
      var $98=$29;
      var $99=$__mp;
      var $100=$16;
      HEAP32[(($16)>>2)]=$99;
      var $101=HEAP32[(($16)>>2)];
      var $102=$101;
      var $103=HEAP32[(($102)>>2)];
      var $104=(($103+28)|0);
      var $105=HEAP32[(($104)>>2)];
      FUNCTION_TABLE[$105]($36, $101);
      var $106=$16;
      var $107=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($98, $36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $108
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($36);
      __label__ = 10; break;
    case 8: // $109
      var $110=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $111=$110.f0;
      $33=$111;
      var $112=$110.f1;
      $34=$112;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($36) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 35; break; }
    case 9: // $113
      __label__ = 34; break;
    case 10: // $114
      var $115=$__mp;
      var $116=$15;
      HEAP32[(($15)>>2)]=$115;
      var $117=HEAP32[(($15)>>2)];
      var $118=$117;
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+12)|0);
      var $121=HEAP32[(($120)>>2)];
      var $122=FUNCTION_TABLE[$121]($117);
      var $123=$15;
      var $124=$25;
      HEAP32[(($124)>>2)]=$122;
      var $125=$__mp;
      var $126=$14;
      HEAP32[(($14)>>2)]=$125;
      var $127=HEAP32[(($14)>>2)];
      var $128=$127;
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+16)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=FUNCTION_TABLE[$131]($127);
      var $133=$14;
      var $134=$26;
      HEAP32[(($134)>>2)]=$132;
      var $135=$27;
      var $136=$__mp;
      var $137=$13;
      HEAP32[(($13)>>2)]=$136;
      var $138=HEAP32[(($13)>>2)];
      var $139=$138;
      var $140=HEAP32[(($139)>>2)];
      var $141=(($140+20)|0);
      var $142=HEAP32[(($141)>>2)];
      FUNCTION_TABLE[$142]($37, $138);
      var $143=$13;
      var $144=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($135, $37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; };
    case 11: // $145
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($37);
      var $146=$28;
      var $147=$__mp;
      var $148=$12;
      HEAP32[(($12)>>2)]=$147;
      var $149=HEAP32[(($12)>>2)];
      var $150=$149;
      var $151=HEAP32[(($150)>>2)];
      var $152=(($151+24)|0);
      var $153=HEAP32[(($152)>>2)];
      FUNCTION_TABLE[$153]($38, $149);
      var $154=$12;
      var $155=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($146, $38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 15; break; };
    case 12: // $156
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($38);
      var $157=$__mp;
      var $158=$11;
      HEAP32[(($11)>>2)]=$157;
      var $159=HEAP32[(($11)>>2)];
      var $160=$159;
      var $161=HEAP32[(($160)>>2)];
      var $162=(($161+36)|0);
      var $163=HEAP32[(($162)>>2)];
      var $164=FUNCTION_TABLE[$163]($159);
      var $165=$11;
      var $166=$30;
      HEAP32[(($166)>>2)]=$164;
      __label__ = 33; break;
    case 13: // $167
      var $168=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $169=$168.f0;
      $33=$169;
      var $170=$168.f1;
      $34=$170;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($37) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 35; break; }
    case 14: // $171
      __label__ = 34; break;
    case 15: // $172
      var $173=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $174=$173.f0;
      $33=$174;
      var $175=$173.f1;
      $34=$175;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($38) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 35; break; }
    case 16: // $176
      __label__ = 34; break;
    case 17: // $177
      var $178=$23;
      var $179=$10;
      HEAP32[(($10)>>2)]=$178;
      var $180=HEAP32[(($10)>>2)];
      var $181=__ZNKSt3__16locale9use_facetERNS0_2idE($180, __ZNSt3__110moneypunctIwLb0EE2idE);
      var $182=$181;
      var $183=$10;
      $__mp1=$182;
      var $184=$22;
      var $185=(($184) & 1);
      if ($185) { __label__ = 18; break; } else { __label__ = 22; break; }
    case 18: // $186
      var $187=$24;
      var $188=$__mp1;
      var $189=$9;
      HEAP32[(($9)>>2)]=$188;
      var $190=HEAP32[(($9)>>2)];
      var $191=$190;
      var $192=HEAP32[(($191)>>2)];
      var $193=(($192+44)|0);
      var $194=HEAP32[(($193)>>2)];
      FUNCTION_TABLE[$194]($39, $190);
      var $195=$9;
      var $196=$187;
      var $197=$39;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($196)]=HEAP8[($197)];HEAP8[($196+1)]=HEAP8[($197+1)];HEAP8[($196+2)]=HEAP8[($197+2)];HEAP8[($196+3)]=HEAP8[($197+3)];
      var $198=$29;
      var $199=$__mp1;
      var $200=$8;
      HEAP32[(($8)>>2)]=$199;
      var $201=HEAP32[(($8)>>2)];
      var $202=$201;
      var $203=HEAP32[(($202)>>2)];
      var $204=(($203+32)|0);
      var $205=HEAP32[(($204)>>2)];
      FUNCTION_TABLE[$205]($40, $201);
      var $206=$8;
      var $207=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($198, $40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 20; break; };
    case 19: // $208
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($40);
      __label__ = 26; break;
    case 20: // $209
      var $210=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $211=$210.f0;
      $33=$211;
      var $212=$210.f1;
      $34=$212;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($40) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 35; break; }
    case 21: // $213
      __label__ = 34; break;
    case 22: // $214
      var $215=$24;
      var $216=$__mp1;
      var $217=$7;
      HEAP32[(($7)>>2)]=$216;
      var $218=HEAP32[(($7)>>2)];
      var $219=$218;
      var $220=HEAP32[(($219)>>2)];
      var $221=(($220+40)|0);
      var $222=HEAP32[(($221)>>2)];
      FUNCTION_TABLE[$222]($41, $218);
      var $223=$7;
      var $224=$215;
      var $225=$41;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($224)]=HEAP8[($225)];HEAP8[($224+1)]=HEAP8[($225+1)];HEAP8[($224+2)]=HEAP8[($225+2)];HEAP8[($224+3)]=HEAP8[($225+3)];
      var $226=$29;
      var $227=$__mp1;
      var $228=$6;
      HEAP32[(($6)>>2)]=$227;
      var $229=HEAP32[(($6)>>2)];
      var $230=$229;
      var $231=HEAP32[(($230)>>2)];
      var $232=(($231+28)|0);
      var $233=HEAP32[(($232)>>2)];
      FUNCTION_TABLE[$233]($42, $229);
      var $234=$6;
      var $235=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($226, $42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 24; break; };
    case 23: // $236
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($42);
      __label__ = 26; break;
    case 24: // $237
      var $238=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $239=$238.f0;
      $33=$239;
      var $240=$238.f1;
      $34=$240;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($42) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 35; break; }
    case 25: // $241
      __label__ = 34; break;
    case 26: // $242
      var $243=$__mp1;
      var $244=$5;
      HEAP32[(($5)>>2)]=$243;
      var $245=HEAP32[(($5)>>2)];
      var $246=$245;
      var $247=HEAP32[(($246)>>2)];
      var $248=(($247+12)|0);
      var $249=HEAP32[(($248)>>2)];
      var $250=FUNCTION_TABLE[$249]($245);
      var $251=$5;
      var $252=$25;
      HEAP32[(($252)>>2)]=$250;
      var $253=$__mp1;
      var $254=$4;
      HEAP32[(($4)>>2)]=$253;
      var $255=HEAP32[(($4)>>2)];
      var $256=$255;
      var $257=HEAP32[(($256)>>2)];
      var $258=(($257+16)|0);
      var $259=HEAP32[(($258)>>2)];
      var $260=FUNCTION_TABLE[$259]($255);
      var $261=$4;
      var $262=$26;
      HEAP32[(($262)>>2)]=$260;
      var $263=$27;
      var $264=$__mp1;
      var $265=$3;
      HEAP32[(($3)>>2)]=$264;
      var $266=HEAP32[(($3)>>2)];
      var $267=$266;
      var $268=HEAP32[(($267)>>2)];
      var $269=(($268+20)|0);
      var $270=HEAP32[(($269)>>2)];
      FUNCTION_TABLE[$270]($43, $266);
      var $271=$3;
      var $272=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_($263, $43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 29; break; };
    case 27: // $273
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($43);
      var $274=$28;
      var $275=$__mp1;
      var $276=$2;
      HEAP32[(($2)>>2)]=$275;
      var $277=HEAP32[(($2)>>2)];
      var $278=$277;
      var $279=HEAP32[(($278)>>2)];
      var $280=(($279+24)|0);
      var $281=HEAP32[(($280)>>2)];
      FUNCTION_TABLE[$281]($44, $277);
      var $282=$2;
      var $283=(function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_($274, $44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 31; break; };
    case 28: // $284
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($44);
      var $285=$__mp1;
      var $286=$1;
      HEAP32[(($1)>>2)]=$285;
      var $287=HEAP32[(($1)>>2)];
      var $288=$287;
      var $289=HEAP32[(($288)>>2)];
      var $290=(($289+36)|0);
      var $291=HEAP32[(($290)>>2)];
      var $292=FUNCTION_TABLE[$291]($287);
      var $293=$1;
      var $294=$30;
      HEAP32[(($294)>>2)]=$292;
      __label__ = 33; break;
    case 29: // $295
      var $296=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $297=$296.f0;
      $33=$297;
      var $298=$296.f1;
      $34=$298;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($43) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 35; break; }
    case 30: // $299
      __label__ = 34; break;
    case 31: // $300
      var $301=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $302=$301.f0;
      $33=$302;
      var $303=$301.f1;
      $34=$303;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($44) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 35; break; }
    case 32: // $304
      __label__ = 34; break;
    case 33: // $305
      STACKTOP = __stackBase__;
      return;
    case 34: // $306
      var $307=$33;
      var $308=$33;
      var $309=$34;
      var $310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $308, tempValue);
      var $311=($310.f1 = $309, $310);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 35: // $312
      var $313=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri["X"]=1;

function __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i($__mb, $__mi, $__me, $__flags, $__db, $__de, $__ct, $__neg, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) {
  var __stackBase__  = STACKTOP; STACKTOP += 1032; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $58=__stackBase__+228;
      var $59=__stackBase__+232;
      var $60=__stackBase__+236;
      var $61=__stackBase__+240;
      var $62=__stackBase__+244;
      var $63=__stackBase__+248;
      var $64=__stackBase__+252;
      var $65=__stackBase__+256;
      var $66=__stackBase__+260;
      var $67=__stackBase__+264;
      var $68=__stackBase__+268;
      var $69=__stackBase__+272;
      var $70=__stackBase__+276;
      var $71=__stackBase__+280;
      var $72=__stackBase__+284;
      var $73=__stackBase__+288;
      var $74=__stackBase__+292;
      var $75=__stackBase__+296;
      var $76=__stackBase__+300;
      var $77=__stackBase__+304;
      var $78=__stackBase__+308;
      var $79;
      var $80=__stackBase__+312;
      var $81=__stackBase__+316;
      var $82=__stackBase__+320;
      var $83=__stackBase__+324;
      var $84=__stackBase__+328;
      var $85=__stackBase__+332;
      var $86=__stackBase__+336;
      var $87=__stackBase__+340;
      var $88=__stackBase__+344;
      var $89=__stackBase__+348;
      var $90=__stackBase__+352;
      var $91=__stackBase__+356;
      var $92=__stackBase__+360;
      var $93=__stackBase__+364;
      var $94;
      var $95=__stackBase__+368;
      var $96=__stackBase__+372;
      var $97=__stackBase__+376;
      var $98=__stackBase__+380;
      var $99=__stackBase__+384;
      var $100=__stackBase__+388;
      var $101=__stackBase__+392;
      var $102=__stackBase__+396;
      var $103=__stackBase__+400;
      var $104=__stackBase__+404;
      var $105=__stackBase__+408;
      var $106=__stackBase__+412;
      var $107=__stackBase__+416;
      var $108=__stackBase__+420;
      var $109=__stackBase__+424;
      var $110=__stackBase__+428;
      var $111=__stackBase__+432;
      var $112=__stackBase__+436;
      var $113=__stackBase__+440;
      var $114=__stackBase__+444;
      var $115=__stackBase__+448;
      var $116=__stackBase__+452;
      var $117=__stackBase__+456;
      var $118=__stackBase__+460;
      var $119=__stackBase__+464;
      var $120=__stackBase__+468;
      var $121=__stackBase__+472;
      var $122=__stackBase__+476;
      var $123=__stackBase__+480;
      var $124=__stackBase__+484;
      var $125=__stackBase__+488;
      var $126=__stackBase__+492;
      var $127=__stackBase__+496;
      var $128=__stackBase__+500;
      var $129=__stackBase__+504;
      var $130=__stackBase__+508;
      var $131=__stackBase__+512;
      var $132=__stackBase__+516;
      var $133=__stackBase__+520;
      var $134=__stackBase__+524;
      var $135=__stackBase__+528;
      var $136=__stackBase__+532;
      var $137=__stackBase__+536;
      var $138=__stackBase__+540;
      var $139=__stackBase__+544;
      var $140=__stackBase__+548;
      var $141=__stackBase__+552;
      var $142=__stackBase__+556;
      var $143=__stackBase__+560;
      var $144=__stackBase__+564;
      var $145=__stackBase__+568;
      var $146=__stackBase__+572;
      var $147=__stackBase__+576;
      var $148=__stackBase__+580;
      var $149=__stackBase__+584;
      var $150=__stackBase__+588;
      var $151=__stackBase__+592;
      var $152=__stackBase__+596;
      var $153=__stackBase__+600;
      var $154=__stackBase__+604;
      var $155=__stackBase__+608;
      var $156=__stackBase__+612;
      var $157=__stackBase__+616;
      var $158=__stackBase__+620;
      var $159=__stackBase__+624;
      var $__t_i_i_i=__stackBase__+628;
      var $160=__stackBase__+632;
      var $161=__stackBase__+636;
      var $162=__stackBase__+640;
      var $163=__stackBase__+644;
      var $164=__stackBase__+648;
      var $165=__stackBase__+652;
      var $166=__stackBase__+656;
      var $167=__stackBase__+660;
      var $168=__stackBase__+664;
      var $169=__stackBase__+668;
      var $170=__stackBase__+672;
      var $171=__stackBase__+676;
      var $172=__stackBase__+680;
      var $173=__stackBase__+684;
      var $174=__stackBase__+688;
      var $175=__stackBase__+692;
      var $176=__stackBase__+696;
      var $177=__stackBase__+700;
      var $178=__stackBase__+704;
      var $179=__stackBase__+708;
      var $180=__stackBase__+712;
      var $181=__stackBase__+716;
      var $182=__stackBase__+720;
      var $183=__stackBase__+724;
      var $184=__stackBase__+728;
      var $185=__stackBase__+732;
      var $186=__stackBase__+736;
      var $187=__stackBase__+740;
      var $188=__stackBase__+744;
      var $189=__stackBase__+748;
      var $190=__stackBase__+752;
      var $191=__stackBase__+756;
      var $192=__stackBase__+760;
      var $193=__stackBase__+764;
      var $194=__stackBase__+768;
      var $195=__stackBase__+772;
      var $196=__stackBase__+776;
      var $197=__stackBase__+780;
      var $198=__stackBase__+784;
      var $199=__stackBase__+788;
      var $200=__stackBase__+792;
      var $201=__stackBase__+796;
      var $202=__stackBase__+800;
      var $203=__stackBase__+804;
      var $204=__stackBase__+808;
      var $205=__stackBase__+812;
      var $206=__stackBase__+816;
      var $207=__stackBase__+820;
      var $208=__stackBase__+824;
      var $209=__stackBase__+828;
      var $210=__stackBase__+832;
      var $211=__stackBase__+836;
      var $212=__stackBase__+840;
      var $213=__stackBase__+844;
      var $214=__stackBase__+848;
      var $215=__stackBase__+852;
      var $216=__stackBase__+856;
      var $217=__stackBase__+860;
      var $218=__stackBase__+864;
      var $219=__stackBase__+868;
      var $220=__stackBase__+872;
      var $221=__stackBase__+876;
      var $222=__stackBase__+880;
      var $223=__stackBase__+884;
      var $224=__stackBase__+888;
      var $225=__stackBase__+892;
      var $226=__stackBase__+896;
      var $227=__stackBase__+900;
      var $228=__stackBase__+904;
      var $229=__stackBase__+908;
      var $230=__stackBase__+912;
      var $231=__stackBase__+916;
      var $232=__stackBase__+920;
      var $233=__stackBase__+924;
      var $234=__stackBase__+928;
      var $235=__stackBase__+932;
      var $236=__stackBase__+936;
      var $237=__stackBase__+940;
      var $238=__stackBase__+944;
      var $239=__stackBase__+948;
      var $240=__stackBase__+952;
      var $241=__stackBase__+956;
      var $242=__stackBase__+960;
      var $243=__stackBase__+964;
      var $244=__stackBase__+968;
      var $245=__stackBase__+972;
      var $246=__stackBase__+976;
      var $247=__stackBase__+980;
      var $248=__stackBase__+984;
      var $249=__stackBase__+988;
      var $250=__stackBase__+992;
      var $251=__stackBase__+996;
      var $252=__stackBase__+1000;
      var $253=__stackBase__+1004;
      var $254=__stackBase__+1008;
      var $255;
      var $256;
      var $257;
      var $258;
      var $259;
      var $260;
      var $261;
      var $262;
      var $263;
      var $264;
      var $265;
      var $266;
      var $267;
      var $268;
      var $269;
      var $270;
      var $__p;
      var $271=__stackBase__+1012;
      var $272=__stackBase__+1016;
      var $__t;
      var $__d;
      var $__f;
      var $__z;
      var $__ng;
      var $__ig;
      var $__gl;
      var $273=__stackBase__+1020;
      var $274=__stackBase__+1024;
      var $275=__stackBase__+1028;
      $256=$__mb;
      $257=$__mi;
      $258=$__me;
      $259=$__flags;
      $260=$__db;
      $261=$__de;
      $262=$__ct;
      var $276=(($__neg)&1);
      $263=$276;
      $264=$__pat;
      $265=$__dp;
      $266=$__ts;
      $267=$__grp;
      $268=$__sym;
      $269=$__sn;
      $270=$__fd;
      var $277=$256;
      var $278=$258;
      HEAP32[(($278)>>2)]=$277;
      $__p=0;
      __label__ = 1; break;
    case 1: // $279
      var $280=$__p;
      var $281=(($280)>>>0) < 4;
      if ($281) { __label__ = 2; break; } else { __label__ = 95; break; }
    case 2: // $282
      var $283=$__p;
      var $284=$264;
      var $285=(($284)|0);
      var $286=(($285+$283)|0);
      var $287=HEAP8[($286)];
      var $288=(($287 << 24) >> 24);
      if ($288 == 0) {
        __label__ = 3; break;
      }
      else if ($288 == 1) {
        __label__ = 4; break;
      }
      else if ($288 == 3) {
        __label__ = 5; break;
      }
      else if ($288 == 2) {
        __label__ = 14; break;
      }
      else if ($288 == 4) {
        __label__ = 33; break;
      }
      else {
      __label__ = 93; break;
      }
      
    case 3: // $289
      var $290=$258;
      var $291=HEAP32[(($290)>>2)];
      var $292=$257;
      HEAP32[(($292)>>2)]=$291;
      __label__ = 93; break;
    case 4: // $293
      var $294=$258;
      var $295=HEAP32[(($294)>>2)];
      var $296=$257;
      HEAP32[(($296)>>2)]=$295;
      var $297=$262;
      var $298=$254;
      HEAP32[(($254)>>2)]=$297;
      $255=32;
      var $299=HEAP32[(($254)>>2)];
      var $300=$299;
      var $301=HEAP32[(($300)>>2)];
      var $302=(($301+44)|0);
      var $303=HEAP32[(($302)>>2)];
      var $304=$255;
      var $305=FUNCTION_TABLE[$303]($299, $304);
      var $306=$254;
      var $307=$258;
      var $308=HEAP32[(($307)>>2)];
      var $309=(($308+4)|0);
      HEAP32[(($307)>>2)]=$309;
      HEAP32[(($308)>>2)]=$305;
      __label__ = 93; break;
    case 5: // $310
      var $311=$269;
      var $312=$253;
      HEAP32[(($253)>>2)]=$311;
      var $313=HEAP32[(($253)>>2)];
      var $314=$252;
      HEAP32[(($252)>>2)]=$313;
      var $315=HEAPU32[(($252)>>2)];
      var $316=$251;
      HEAP32[(($251)>>2)]=$315;
      var $317=HEAP32[(($251)>>2)];
      var $318=(($317)|0);
      var $319=$250;
      HEAP32[(($250)>>2)]=$318;
      var $320=HEAP32[(($250)>>2)];
      var $321=$320;
      var $322=$249;
      HEAP32[(($249)>>2)]=$321;
      var $323=HEAP32[(($249)>>2)];
      var $324=(($323)|0);
      var $325=$249;
      var $326=$250;
      var $327=(($324)|0);
      var $328=$327;
      var $329=(($328)|0);
      var $330=$329;
      var $331=HEAPU8[($330)];
      var $332=(($331)&255);
      var $333=$332 & 1;
      var $334=(($333)|0)!=0;
      var $335=$251;
      if ($334) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $336
      var $337=$245;
      HEAP32[(($245)>>2)]=$315;
      var $338=HEAP32[(($245)>>2)];
      var $339=(($338)|0);
      var $340=$244;
      HEAP32[(($244)>>2)]=$339;
      var $341=HEAP32[(($244)>>2)];
      var $342=$341;
      var $343=$243;
      HEAP32[(($243)>>2)]=$342;
      var $344=HEAP32[(($243)>>2)];
      var $345=(($344)|0);
      var $346=$243;
      var $347=$244;
      var $348=(($345)|0);
      var $349=$348;
      var $350=(($349+4)|0);
      var $351=HEAP32[(($350)>>2)];
      var $352=$245;
      var $373 = $351;__label__ = 8; break;
    case 7: // $353
      var $354=$248;
      HEAP32[(($248)>>2)]=$315;
      var $355=HEAP32[(($248)>>2)];
      var $356=(($355)|0);
      var $357=$247;
      HEAP32[(($247)>>2)]=$356;
      var $358=HEAP32[(($247)>>2)];
      var $359=$358;
      var $360=$246;
      HEAP32[(($246)>>2)]=$359;
      var $361=HEAP32[(($246)>>2)];
      var $362=(($361)|0);
      var $363=$246;
      var $364=$247;
      var $365=(($362)|0);
      var $366=$365;
      var $367=(($366)|0);
      var $368=$367;
      var $369=HEAPU8[($368)];
      var $370=(($369)&255);
      var $371=$370 >> 1;
      var $372=$248;
      var $373 = $371;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv_exit
      var $373;
      var $374=$252;
      var $375=(($373)|0)==0;
      var $376=$253;
      if ($375) { __label__ = 13; break; } else { __label__ = 9; break; }
    case 9: // $377
      var $378=$269;
      var $379=$91;
      var $380=$92;
      HEAP32[(($91)>>2)]=$378;
      HEAP32[(($92)>>2)]=0;
      var $381=HEAP32[(($91)>>2)];
      var $382=$90;
      HEAP32[(($90)>>2)]=$381;
      var $383=HEAP32[(($90)>>2)];
      var $384=$89;
      HEAP32[(($89)>>2)]=$383;
      var $385=HEAPU32[(($89)>>2)];
      var $386=$88;
      HEAP32[(($88)>>2)]=$385;
      var $387=HEAP32[(($88)>>2)];
      var $388=(($387)|0);
      var $389=$87;
      HEAP32[(($87)>>2)]=$388;
      var $390=HEAP32[(($87)>>2)];
      var $391=$390;
      var $392=$86;
      HEAP32[(($86)>>2)]=$391;
      var $393=HEAP32[(($86)>>2)];
      var $394=(($393)|0);
      var $395=$86;
      var $396=$87;
      var $397=(($394)|0);
      var $398=$397;
      var $399=(($398)|0);
      var $400=$399;
      var $401=HEAPU8[($400)];
      var $402=(($401)&255);
      var $403=$402 & 1;
      var $404=(($403)|0)!=0;
      var $405=$88;
      if ($404) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $406
      var $407=$82;
      HEAP32[(($82)>>2)]=$385;
      var $408=HEAP32[(($82)>>2)];
      var $409=(($408)|0);
      var $410=$81;
      HEAP32[(($81)>>2)]=$409;
      var $411=HEAP32[(($81)>>2)];
      var $412=$411;
      var $413=$80;
      HEAP32[(($80)>>2)]=$412;
      var $414=HEAP32[(($80)>>2)];
      var $415=(($414)|0);
      var $416=$80;
      var $417=$81;
      var $418=(($415)|0);
      var $419=$418;
      var $420=(($419+8)|0);
      var $421=HEAP32[(($420)>>2)];
      var $422=$82;
      var $440 = $421;__label__ = 12; break;
    case 11: // $423
      var $424=$85;
      HEAP32[(($85)>>2)]=$385;
      var $425=HEAP32[(($85)>>2)];
      var $426=(($425)|0);
      var $427=$84;
      HEAP32[(($84)>>2)]=$426;
      var $428=HEAP32[(($84)>>2)];
      var $429=$428;
      var $430=$83;
      HEAP32[(($83)>>2)]=$429;
      var $431=HEAP32[(($83)>>2)];
      var $432=(($431)|0);
      var $433=$83;
      var $434=$84;
      var $435=(($432)|0);
      var $436=$435;
      var $437=(($436+4)|0);
      var $438=(($437)|0);
      var $439=$85;
      var $440 = $438;__label__ = 12; break;
    case 12: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit
      var $440;
      var $441=$89;
      var $442=$90;
      var $443=HEAP32[(($92)>>2)];
      var $444=(($440+($443<<2))|0);
      var $445=$91;
      var $446=$92;
      var $447=HEAP32[(($444)>>2)];
      var $448=$258;
      var $449=HEAP32[(($448)>>2)];
      var $450=(($449+4)|0);
      HEAP32[(($448)>>2)]=$450;
      HEAP32[(($449)>>2)]=$447;
      __label__ = 13; break;
    case 13: // $451
      __label__ = 93; break;
    case 14: // $452
      var $453=$268;
      var $454=$77;
      HEAP32[(($77)>>2)]=$453;
      var $455=HEAP32[(($77)>>2)];
      var $456=$76;
      HEAP32[(($76)>>2)]=$455;
      var $457=HEAPU32[(($76)>>2)];
      var $458=$75;
      HEAP32[(($75)>>2)]=$457;
      var $459=HEAP32[(($75)>>2)];
      var $460=(($459)|0);
      var $461=$74;
      HEAP32[(($74)>>2)]=$460;
      var $462=HEAP32[(($74)>>2)];
      var $463=$462;
      var $464=$73;
      HEAP32[(($73)>>2)]=$463;
      var $465=HEAP32[(($73)>>2)];
      var $466=(($465)|0);
      var $467=$73;
      var $468=$74;
      var $469=(($466)|0);
      var $470=$469;
      var $471=(($470)|0);
      var $472=$471;
      var $473=HEAPU8[($472)];
      var $474=(($473)&255);
      var $475=$474 & 1;
      var $476=(($475)|0)!=0;
      var $477=$75;
      if ($476) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $478
      var $479=$69;
      HEAP32[(($69)>>2)]=$457;
      var $480=HEAP32[(($69)>>2)];
      var $481=(($480)|0);
      var $482=$68;
      HEAP32[(($68)>>2)]=$481;
      var $483=HEAP32[(($68)>>2)];
      var $484=$483;
      var $485=$67;
      HEAP32[(($67)>>2)]=$484;
      var $486=HEAP32[(($67)>>2)];
      var $487=(($486)|0);
      var $488=$67;
      var $489=$68;
      var $490=(($487)|0);
      var $491=$490;
      var $492=(($491+4)|0);
      var $493=HEAP32[(($492)>>2)];
      var $494=$69;
      var $515 = $493;__label__ = 17; break;
    case 16: // $495
      var $496=$72;
      HEAP32[(($72)>>2)]=$457;
      var $497=HEAP32[(($72)>>2)];
      var $498=(($497)|0);
      var $499=$71;
      HEAP32[(($71)>>2)]=$498;
      var $500=HEAP32[(($71)>>2)];
      var $501=$500;
      var $502=$70;
      HEAP32[(($70)>>2)]=$501;
      var $503=HEAP32[(($70)>>2)];
      var $504=(($503)|0);
      var $505=$70;
      var $506=$71;
      var $507=(($504)|0);
      var $508=$507;
      var $509=(($508)|0);
      var $510=$509;
      var $511=HEAPU8[($510)];
      var $512=(($511)&255);
      var $513=$512 >> 1;
      var $514=$72;
      var $515 = $513;__label__ = 17; break;
    case 17: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv_exit10
      var $515;
      var $516=$76;
      var $517=(($515)|0)==0;
      var $518=$77;
      if ($517) { __label__ = 32; break; } else { __label__ = 18; break; }
    case 18: // $519
      var $520=$259;
      var $521=$520 & 512;
      var $522=(($521)|0)!=0;
      if ($522) { __label__ = 19; break; } else { __label__ = 32; break; }
    case 19: // $523
      var $524=$268;
      var $525=$63;
      HEAP32[(($63)>>2)]=$524;
      var $526=HEAP32[(($63)>>2)];
      var $527=$62;
      HEAP32[(($62)>>2)]=$526;
      var $528=HEAP32[(($62)>>2)];
      var $529=$61;
      HEAP32[(($61)>>2)]=$528;
      var $530=HEAPU32[(($61)>>2)];
      var $531=$60;
      HEAP32[(($60)>>2)]=$530;
      var $532=HEAP32[(($60)>>2)];
      var $533=(($532)|0);
      var $534=$59;
      HEAP32[(($59)>>2)]=$533;
      var $535=HEAP32[(($59)>>2)];
      var $536=$535;
      var $537=$58;
      HEAP32[(($58)>>2)]=$536;
      var $538=HEAP32[(($58)>>2)];
      var $539=(($538)|0);
      var $540=$58;
      var $541=$59;
      var $542=(($539)|0);
      var $543=$542;
      var $544=(($543)|0);
      var $545=$544;
      var $546=HEAPU8[($545)];
      var $547=(($546)&255);
      var $548=$547 & 1;
      var $549=(($548)|0)!=0;
      var $550=$60;
      if ($549) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $551
      var $552=$54;
      HEAP32[(($54)>>2)]=$530;
      var $553=HEAP32[(($54)>>2)];
      var $554=(($553)|0);
      var $555=$53;
      HEAP32[(($53)>>2)]=$554;
      var $556=HEAP32[(($53)>>2)];
      var $557=$556;
      var $558=$52;
      HEAP32[(($52)>>2)]=$557;
      var $559=HEAP32[(($52)>>2)];
      var $560=(($559)|0);
      var $561=$52;
      var $562=$53;
      var $563=(($560)|0);
      var $564=$563;
      var $565=(($564+8)|0);
      var $566=HEAP32[(($565)>>2)];
      var $567=$54;
      var $585 = $566;__label__ = 22; break;
    case 21: // $568
      var $569=$57;
      HEAP32[(($57)>>2)]=$530;
      var $570=HEAP32[(($57)>>2)];
      var $571=(($570)|0);
      var $572=$56;
      HEAP32[(($56)>>2)]=$571;
      var $573=HEAP32[(($56)>>2)];
      var $574=$573;
      var $575=$55;
      HEAP32[(($55)>>2)]=$574;
      var $576=HEAP32[(($55)>>2)];
      var $577=(($576)|0);
      var $578=$55;
      var $579=$56;
      var $580=(($577)|0);
      var $581=$580;
      var $582=(($581+4)|0);
      var $583=(($582)|0);
      var $584=$57;
      var $585 = $583;__label__ = 22; break;
    case 22: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv_exit12
      var $585;
      var $586=$61;
      var $587=$62;
      var $588=$50;
      var $589=$51;
      HEAP32[(($50)>>2)]=$271;
      HEAP32[(($51)>>2)]=$585;
      var $590=HEAP32[(($50)>>2)];
      var $591=HEAP32[(($51)>>2)];
      var $592=$48;
      var $593=$49;
      HEAP32[(($48)>>2)]=$590;
      HEAP32[(($49)>>2)]=$591;
      var $594=HEAP32[(($48)>>2)];
      var $595=(($594)|0);
      var $596=HEAP32[(($49)>>2)];
      HEAP32[(($595)>>2)]=$596;
      var $597=$48;
      var $598=$49;
      var $599=$50;
      var $600=$51;
      var $601=$63;
      var $602=$268;
      var $603=$26;
      HEAP32[(($26)>>2)]=$602;
      var $604=HEAPU32[(($26)>>2)];
      var $605=$25;
      HEAP32[(($25)>>2)]=$604;
      var $606=HEAP32[(($25)>>2)];
      var $607=$24;
      HEAP32[(($24)>>2)]=$606;
      var $608=HEAPU32[(($24)>>2)];
      var $609=$23;
      HEAP32[(($23)>>2)]=$608;
      var $610=HEAP32[(($23)>>2)];
      var $611=(($610)|0);
      var $612=$22;
      HEAP32[(($22)>>2)]=$611;
      var $613=HEAP32[(($22)>>2)];
      var $614=$613;
      var $615=$21;
      HEAP32[(($21)>>2)]=$614;
      var $616=HEAP32[(($21)>>2)];
      var $617=(($616)|0);
      var $618=$21;
      var $619=$22;
      var $620=(($617)|0);
      var $621=$620;
      var $622=(($621)|0);
      var $623=$622;
      var $624=HEAPU8[($623)];
      var $625=(($624)&255);
      var $626=$625 & 1;
      var $627=(($626)|0)!=0;
      var $628=$23;
      if ($627) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $629
      var $630=$17;
      HEAP32[(($17)>>2)]=$608;
      var $631=HEAP32[(($17)>>2)];
      var $632=(($631)|0);
      var $633=$16;
      HEAP32[(($16)>>2)]=$632;
      var $634=HEAP32[(($16)>>2)];
      var $635=$634;
      var $636=$15;
      HEAP32[(($15)>>2)]=$635;
      var $637=HEAP32[(($15)>>2)];
      var $638=(($637)|0);
      var $639=$15;
      var $640=$16;
      var $641=(($638)|0);
      var $642=$641;
      var $643=(($642+8)|0);
      var $644=HEAP32[(($643)>>2)];
      var $645=$17;
      var $663 = $644;__label__ = 25; break;
    case 24: // $646
      var $647=$20;
      HEAP32[(($20)>>2)]=$608;
      var $648=HEAP32[(($20)>>2)];
      var $649=(($648)|0);
      var $650=$19;
      HEAP32[(($19)>>2)]=$649;
      var $651=HEAP32[(($19)>>2)];
      var $652=$651;
      var $653=$18;
      HEAP32[(($18)>>2)]=$652;
      var $654=HEAP32[(($18)>>2)];
      var $655=(($654)|0);
      var $656=$18;
      var $657=$19;
      var $658=(($655)|0);
      var $659=$658;
      var $660=(($659+4)|0);
      var $661=(($660)|0);
      var $662=$20;
      var $663 = $661;__label__ = 25; break;
    case 25: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit_i26
      var $663;
      var $664=$24;
      var $665=$25;
      var $666=$10;
      HEAP32[(($10)>>2)]=$604;
      var $667=HEAPU32[(($10)>>2)];
      var $668=$9;
      HEAP32[(($9)>>2)]=$667;
      var $669=HEAP32[(($9)>>2)];
      var $670=(($669)|0);
      var $671=$8;
      HEAP32[(($8)>>2)]=$670;
      var $672=HEAP32[(($8)>>2)];
      var $673=$672;
      var $674=$7;
      HEAP32[(($7)>>2)]=$673;
      var $675=HEAP32[(($7)>>2)];
      var $676=(($675)|0);
      var $677=$7;
      var $678=$8;
      var $679=(($676)|0);
      var $680=$679;
      var $681=(($680)|0);
      var $682=$681;
      var $683=HEAPU8[($682)];
      var $684=(($683)&255);
      var $685=$684 & 1;
      var $686=(($685)|0)!=0;
      var $687=$9;
      if ($686) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $688
      var $689=$3;
      HEAP32[(($3)>>2)]=$667;
      var $690=HEAP32[(($3)>>2)];
      var $691=(($690)|0);
      var $692=$2;
      HEAP32[(($2)>>2)]=$691;
      var $693=HEAP32[(($2)>>2)];
      var $694=$693;
      var $695=$1;
      HEAP32[(($1)>>2)]=$694;
      var $696=HEAP32[(($1)>>2)];
      var $697=(($696)|0);
      var $698=$1;
      var $699=$2;
      var $700=(($697)|0);
      var $701=$700;
      var $702=(($701+4)|0);
      var $703=HEAP32[(($702)>>2)];
      var $704=$3;
      var $725 = $703;__label__ = 28; break;
    case 27: // $705
      var $706=$6;
      HEAP32[(($6)>>2)]=$667;
      var $707=HEAP32[(($6)>>2)];
      var $708=(($707)|0);
      var $709=$5;
      HEAP32[(($5)>>2)]=$708;
      var $710=HEAP32[(($5)>>2)];
      var $711=$710;
      var $712=$4;
      HEAP32[(($4)>>2)]=$711;
      var $713=HEAP32[(($4)>>2)];
      var $714=(($713)|0);
      var $715=$4;
      var $716=$5;
      var $717=(($714)|0);
      var $718=$717;
      var $719=(($718)|0);
      var $720=$719;
      var $721=HEAPU8[($720)];
      var $722=(($721)&255);
      var $723=$722 >> 1;
      var $724=$6;
      var $725 = $723;__label__ = 28; break;
    case 28: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv_exit27
      var $725;
      var $726=$10;
      var $727=(($663+($725<<2))|0);
      var $728=$13;
      var $729=$14;
      HEAP32[(($13)>>2)]=$272;
      HEAP32[(($14)>>2)]=$727;
      var $730=HEAP32[(($13)>>2)];
      var $731=HEAP32[(($14)>>2)];
      var $732=$11;
      var $733=$12;
      HEAP32[(($11)>>2)]=$730;
      HEAP32[(($12)>>2)]=$731;
      var $734=HEAP32[(($11)>>2)];
      var $735=(($734)|0);
      var $736=HEAP32[(($12)>>2)];
      HEAP32[(($735)>>2)]=$736;
      var $737=$11;
      var $738=$12;
      var $739=$13;
      var $740=$14;
      var $741=$26;
      var $742=$258;
      var $743=HEAP32[(($742)>>2)];
      var $tmp13=$47;
      var $tmp14=$271;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp13)]=HEAP8[($tmp14)];HEAP8[($tmp13+1)]=HEAP8[($tmp14+1)];HEAP8[($tmp13+2)]=HEAP8[($tmp14+2)];HEAP8[($tmp13+3)]=HEAP8[($tmp14+3)];
      var $tmp15=$46;
      var $tmp16=$272;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp15)]=HEAP8[($tmp16)];HEAP8[($tmp15+1)]=HEAP8[($tmp16+1)];HEAP8[($tmp15+2)]=HEAP8[($tmp16+2)];HEAP8[($tmp15+3)]=HEAP8[($tmp16+3)];
      var $744=$27;
      var $745=$38;
      var $746=$39;
      var $747=$40;
      var $748=$41;
      var $749=$42;
      var $750=$43;
      var $751=$44;
      var $752=$45;
      HEAP32[(($41)>>2)]=$743;
      var $753=$43;
      var $754=$47;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($753)>>2)]=HEAP32[(($754)>>2)];
      var $tmp_i17=$40;
      var $tmp1_i18=$43;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i17)]=HEAP8[($tmp1_i18)];HEAP8[($tmp_i17+1)]=HEAP8[($tmp1_i18+1)];HEAP8[($tmp_i17+2)]=HEAP8[($tmp1_i18+2)];HEAP8[($tmp_i17+3)]=HEAP8[($tmp1_i18+3)];
      var $755=$42;
      var $756=$40;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($755)>>2)]=HEAP32[(($756)>>2)];
      var $757=$45;
      var $758=$46;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($757)>>2)]=HEAP32[(($758)>>2)];
      var $tmp6_i19=$27;
      var $tmp7_i20=$45;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp6_i19)]=HEAP8[($tmp7_i20)];HEAP8[($tmp6_i19+1)]=HEAP8[($tmp7_i20+1)];HEAP8[($tmp6_i19+2)]=HEAP8[($tmp7_i20+2)];HEAP8[($tmp6_i19+3)]=HEAP8[($tmp7_i20+3)];
      var $759=$44;
      var $760=$27;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($759)>>2)]=HEAP32[(($760)>>2)];
      var $761=HEAP32[(($41)>>2)];
      var $762=$28;
      HEAP32[(($28)>>2)]=$761;
      var $763=HEAP32[(($28)>>2)];
      var $764=$28;
      var $tmp2_i21=$39;
      var $tmp3_i22=$42;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2_i21)]=HEAP8[($tmp3_i22)];HEAP8[($tmp2_i21+1)]=HEAP8[($tmp3_i22+1)];HEAP8[($tmp2_i21+2)]=HEAP8[($tmp3_i22+2)];HEAP8[($tmp2_i21+3)]=HEAP8[($tmp3_i22+3)];
      var $tmp4_i23=$38;
      var $tmp5_i24=$44;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp4_i23)]=HEAP8[($tmp5_i24)];HEAP8[($tmp4_i23+1)]=HEAP8[($tmp5_i24+1)];HEAP8[($tmp4_i23+2)]=HEAP8[($tmp5_i24+2)];HEAP8[($tmp4_i23+3)]=HEAP8[($tmp5_i24+3)];
      var $765=$37;
      HEAP32[(($37)>>2)]=$763;
      __label__ = 29; break;
    case 29: // $766
      var $767=$35;
      var $768=$36;
      HEAP32[(($35)>>2)]=$39;
      HEAP32[(($36)>>2)]=$38;
      var $769=HEAP32[(($35)>>2)];
      var $770=HEAP32[(($36)>>2)];
      var $771=$33;
      var $772=$34;
      HEAP32[(($33)>>2)]=$769;
      HEAP32[(($34)>>2)]=$770;
      var $773=HEAP32[(($33)>>2)];
      var $774=$32;
      HEAP32[(($32)>>2)]=$773;
      var $775=HEAP32[(($32)>>2)];
      var $776=(($775)|0);
      var $777=HEAP32[(($776)>>2)];
      var $778=$32;
      var $779=HEAP32[(($34)>>2)];
      var $780=$31;
      HEAP32[(($31)>>2)]=$779;
      var $781=HEAP32[(($31)>>2)];
      var $782=(($781)|0);
      var $783=HEAP32[(($782)>>2)];
      var $784=$31;
      var $785=(($777)|0)==(($783)|0);
      var $786=$33;
      var $787=$34;
      var $788=$785 ^ 1;
      var $789=$35;
      var $790=$36;
      if ($788) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $791
      var $792=$29;
      HEAP32[(($29)>>2)]=$39;
      var $793=HEAP32[(($29)>>2)];
      var $794=(($793)|0);
      var $795=HEAP32[(($794)>>2)];
      var $796=$29;
      var $797=HEAP32[(($795)>>2)];
      var $798=HEAP32[(($37)>>2)];
      HEAP32[(($798)>>2)]=$797;
      var $799=$30;
      HEAP32[(($30)>>2)]=$39;
      var $800=HEAP32[(($30)>>2)];
      var $801=(($800)|0);
      var $802=HEAP32[(($801)>>2)];
      var $803=(($802+4)|0);
      HEAP32[(($801)>>2)]=$803;
      var $804=$30;
      var $805=HEAP32[(($37)>>2)];
      var $806=(($805+4)|0);
      HEAP32[(($37)>>2)]=$806;
      __label__ = 29; break;
    case 31: // $_ZNSt3__14copyINS_11__wrap_iterIPKwEEPwEET0_T_S7_S6__exit25
      var $807=HEAP32[(($37)>>2)];
      var $808=$37;
      var $809=$27;
      var $810=$38;
      var $811=$39;
      var $812=$40;
      var $813=$41;
      var $814=$42;
      var $815=$43;
      var $816=$44;
      var $817=$45;
      var $818=$258;
      HEAP32[(($818)>>2)]=$807;
      __label__ = 32; break;
    case 32: // $819
      __label__ = 93; break;
    case 33: // $820
      var $821=$258;
      var $822=HEAP32[(($821)>>2)];
      $__t=$822;
      var $823=$263;
      var $824=(($823) & 1);
      if ($824) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $825
      var $826=$260;
      var $827=(($826+4)|0);
      $260=$827;
      __label__ = 35; break;
    case 35: // $828
      var $829=$260;
      $__d=$829;
      __label__ = 36; break;
    case 36: // $830
      var $831=$__d;
      var $832=$261;
      var $833=(($831)>>>0) < (($832)>>>0);
      if ($833) { __label__ = 37; break; } else { __label__ = 41; break; }
    case 37: // $834
      var $835=$262;
      var $836=$__d;
      var $837=HEAP32[(($836)>>2)];
      var $838=$64;
      var $839=$65;
      var $840=$66;
      HEAP32[(($64)>>2)]=$835;
      HEAP32[(($65)>>2)]=1024;
      HEAP32[(($66)>>2)]=$837;
      var $841=HEAP32[(($64)>>2)];
      var $842=$841;
      var $843=HEAP32[(($842)>>2)];
      var $844=(($843+12)|0);
      var $845=HEAP32[(($844)>>2)];
      var $846=HEAP32[(($65)>>2)];
      var $847=HEAP32[(($66)>>2)];
      var $848=FUNCTION_TABLE[$845]($841, $846, $847);
      var $849=$64;
      var $850=$65;
      var $851=$66;
      if ($848) { __label__ = 39; break; } else { __label__ = 38; break; }
    case 38: // $852
      __label__ = 41; break;
    case 39: // $853
      __label__ = 40; break;
    case 40: // $854
      var $855=$__d;
      var $856=(($855+4)|0);
      $__d=$856;
      __label__ = 36; break;
    case 41: // $857
      var $858=$270;
      var $859=(($858)|0) > 0;
      if ($859) { __label__ = 42; break; } else { __label__ = 56; break; }
    case 42: // $860
      var $861=$270;
      $__f=$861;
      __label__ = 43; break;
    case 43: // $862
      var $863=$__d;
      var $864=$260;
      var $865=(($863)>>>0) > (($864)>>>0);
      if ($865) { __label__ = 44; break; } else { var $870 = 0;__label__ = 45; break; }
    case 44: // $866
      var $867=$__f;
      var $868=(($867)|0) > 0;
      var $870 = $868;__label__ = 45; break;
    case 45: // $869
      var $870;
      if ($870) { __label__ = 46; break; } else { __label__ = 48; break; }
    case 46: // $871
      var $872=$__d;
      var $873=(($872-4)|0);
      $__d=$873;
      var $874=HEAP32[(($873)>>2)];
      var $875=$258;
      var $876=HEAP32[(($875)>>2)];
      var $877=(($876+4)|0);
      HEAP32[(($875)>>2)]=$877;
      HEAP32[(($876)>>2)]=$874;
      __label__ = 47; break;
    case 47: // $878
      var $879=$__f;
      var $880=(($879-1)|0);
      $__f=$880;
      __label__ = 43; break;
    case 48: // $881
      var $882=$__f;
      var $883=(($882)|0) > 0;
      if ($883) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $884
      var $885=$262;
      var $886=$78;
      HEAP32[(($78)>>2)]=$885;
      $79=48;
      var $887=HEAP32[(($78)>>2)];
      var $888=$887;
      var $889=HEAP32[(($888)>>2)];
      var $890=(($889+44)|0);
      var $891=HEAP32[(($890)>>2)];
      var $892=$79;
      var $893=FUNCTION_TABLE[$891]($887, $892);
      var $894=$78;
      var $897 = $893;__label__ = 51; break;
    case 50: // $895
      var $897 = 0;__label__ = 51; break;
    case 51: // $896
      var $897;
      $__z=$897;
      __label__ = 52; break;
    case 52: // $898
      var $899=$__f;
      var $900=(($899)|0) > 0;
      if ($900) { __label__ = 53; break; } else { __label__ = 55; break; }
    case 53: // $901
      var $902=$__z;
      var $903=$258;
      var $904=HEAP32[(($903)>>2)];
      var $905=(($904+4)|0);
      HEAP32[(($903)>>2)]=$905;
      HEAP32[(($904)>>2)]=$902;
      __label__ = 54; break;
    case 54: // $906
      var $907=$__f;
      var $908=(($907-1)|0);
      $__f=$908;
      __label__ = 52; break;
    case 55: // $909
      var $910=$265;
      var $911=$258;
      var $912=HEAP32[(($911)>>2)];
      var $913=(($912+4)|0);
      HEAP32[(($911)>>2)]=$913;
      HEAP32[(($912)>>2)]=$910;
      __label__ = 56; break;
    case 56: // $914
      var $915=$__d;
      var $916=$260;
      var $917=(($915)|0)==(($916)|0);
      if ($917) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $918
      var $919=$262;
      var $920=$93;
      HEAP32[(($93)>>2)]=$919;
      $94=48;
      var $921=HEAP32[(($93)>>2)];
      var $922=$921;
      var $923=HEAP32[(($922)>>2)];
      var $924=(($923+44)|0);
      var $925=HEAP32[(($924)>>2)];
      var $926=$94;
      var $927=FUNCTION_TABLE[$925]($921, $926);
      var $928=$93;
      var $929=$258;
      var $930=HEAP32[(($929)>>2)];
      var $931=(($930+4)|0);
      HEAP32[(($929)>>2)]=$931;
      HEAP32[(($930)>>2)]=$927;
      __label__ = 87; break;
    case 58: // $932
      $__ng=0;
      $__ig=0;
      var $933=$267;
      var $934=$105;
      HEAP32[(($105)>>2)]=$933;
      var $935=HEAP32[(($105)>>2)];
      var $936=$104;
      HEAP32[(($104)>>2)]=$935;
      var $937=HEAPU32[(($104)>>2)];
      var $938=$103;
      HEAP32[(($103)>>2)]=$937;
      var $939=HEAP32[(($103)>>2)];
      var $940=(($939)|0);
      var $941=$102;
      HEAP32[(($102)>>2)]=$940;
      var $942=HEAP32[(($102)>>2)];
      var $943=$942;
      var $944=$101;
      HEAP32[(($101)>>2)]=$943;
      var $945=HEAP32[(($101)>>2)];
      var $946=(($945)|0);
      var $947=$101;
      var $948=$102;
      var $949=(($946)|0);
      var $950=$949;
      var $951=(($950)|0);
      var $952=$951;
      var $953=HEAPU8[($952)];
      var $954=(($953)&255);
      var $955=$954 & 1;
      var $956=(($955)|0)!=0;
      var $957=$103;
      if ($956) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $958
      var $959=$97;
      HEAP32[(($97)>>2)]=$937;
      var $960=HEAP32[(($97)>>2)];
      var $961=(($960)|0);
      var $962=$96;
      HEAP32[(($96)>>2)]=$961;
      var $963=HEAP32[(($96)>>2)];
      var $964=$963;
      var $965=$95;
      HEAP32[(($95)>>2)]=$964;
      var $966=HEAP32[(($95)>>2)];
      var $967=(($966)|0);
      var $968=$95;
      var $969=$96;
      var $970=(($967)|0);
      var $971=$970;
      var $972=(($971+4)|0);
      var $973=HEAP32[(($972)>>2)];
      var $974=$97;
      var $995 = $973;__label__ = 61; break;
    case 60: // $975
      var $976=$100;
      HEAP32[(($100)>>2)]=$937;
      var $977=HEAP32[(($100)>>2)];
      var $978=(($977)|0);
      var $979=$99;
      HEAP32[(($99)>>2)]=$978;
      var $980=HEAP32[(($99)>>2)];
      var $981=$980;
      var $982=$98;
      HEAP32[(($98)>>2)]=$981;
      var $983=HEAP32[(($98)>>2)];
      var $984=(($983)|0);
      var $985=$98;
      var $986=$99;
      var $987=(($984)|0);
      var $988=$987;
      var $989=(($988)|0);
      var $990=$989;
      var $991=HEAPU8[($990)];
      var $992=(($991)&255);
      var $993=$992 >> 1;
      var $994=$100;
      var $995 = $993;__label__ = 61; break;
    case 61: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv_exit
      var $995;
      var $996=$104;
      var $997=(($995)|0)==0;
      var $998=$105;
      if ($997) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $999
      var $1074 = -1;__label__ = 67; break;
    case 63: // $1000
      var $1001=$267;
      var $1002=$__ig;
      var $1003=$117;
      var $1004=$118;
      HEAP32[(($117)>>2)]=$1001;
      HEAP32[(($118)>>2)]=$1002;
      var $1005=HEAP32[(($117)>>2)];
      var $1006=$116;
      HEAP32[(($116)>>2)]=$1005;
      var $1007=HEAP32[(($116)>>2)];
      var $1008=$115;
      HEAP32[(($115)>>2)]=$1007;
      var $1009=HEAPU32[(($115)>>2)];
      var $1010=$114;
      HEAP32[(($114)>>2)]=$1009;
      var $1011=HEAP32[(($114)>>2)];
      var $1012=(($1011)|0);
      var $1013=$113;
      HEAP32[(($113)>>2)]=$1012;
      var $1014=HEAP32[(($113)>>2)];
      var $1015=$1014;
      var $1016=$112;
      HEAP32[(($112)>>2)]=$1015;
      var $1017=HEAP32[(($112)>>2)];
      var $1018=(($1017)|0);
      var $1019=$112;
      var $1020=$113;
      var $1021=(($1018)|0);
      var $1022=$1021;
      var $1023=(($1022)|0);
      var $1024=$1023;
      var $1025=HEAPU8[($1024)];
      var $1026=(($1025)&255);
      var $1027=$1026 & 1;
      var $1028=(($1027)|0)!=0;
      var $1029=$114;
      if ($1028) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $1030
      var $1031=$108;
      HEAP32[(($108)>>2)]=$1009;
      var $1032=HEAP32[(($108)>>2)];
      var $1033=(($1032)|0);
      var $1034=$107;
      HEAP32[(($107)>>2)]=$1033;
      var $1035=HEAP32[(($107)>>2)];
      var $1036=$1035;
      var $1037=$106;
      HEAP32[(($106)>>2)]=$1036;
      var $1038=HEAP32[(($106)>>2)];
      var $1039=(($1038)|0);
      var $1040=$106;
      var $1041=$107;
      var $1042=(($1039)|0);
      var $1043=$1042;
      var $1044=(($1043+8)|0);
      var $1045=HEAP32[(($1044)>>2)];
      var $1046=$108;
      var $1064 = $1045;__label__ = 66; break;
    case 65: // $1047
      var $1048=$111;
      HEAP32[(($111)>>2)]=$1009;
      var $1049=HEAP32[(($111)>>2)];
      var $1050=(($1049)|0);
      var $1051=$110;
      HEAP32[(($110)>>2)]=$1050;
      var $1052=HEAP32[(($110)>>2)];
      var $1053=$1052;
      var $1054=$109;
      HEAP32[(($109)>>2)]=$1053;
      var $1055=HEAP32[(($109)>>2)];
      var $1056=(($1055)|0);
      var $1057=$109;
      var $1058=$110;
      var $1059=(($1056)|0);
      var $1060=$1059;
      var $1061=(($1060+1)|0);
      var $1062=(($1061)|0);
      var $1063=$111;
      var $1064 = $1062;__label__ = 66; break;
    case 66: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit8
      var $1064;
      var $1065=$115;
      var $1066=$116;
      var $1067=HEAP32[(($118)>>2)];
      var $1068=(($1064+$1067)|0);
      var $1069=$117;
      var $1070=$118;
      var $1071=HEAP8[($1068)];
      var $1072=(($1071 << 24) >> 24);
      var $1074 = $1072;__label__ = 67; break;
    case 67: // $1073
      var $1074;
      $__gl=$1074;
      __label__ = 68; break;
    case 68: // $1075
      var $1076=$__d;
      var $1077=$260;
      var $1078=(($1076)|0)!=(($1077)|0);
      if ($1078) { __label__ = 69; break; } else { __label__ = 86; break; }
    case 69: // $1079
      var $1080=$__ng;
      var $1081=$__gl;
      var $1082=(($1080)|0)==(($1081)|0);
      if ($1082) { __label__ = 70; break; } else { __label__ = 85; break; }
    case 70: // $1083
      var $1084=$266;
      var $1085=$258;
      var $1086=HEAP32[(($1085)>>2)];
      var $1087=(($1086+4)|0);
      HEAP32[(($1085)>>2)]=$1087;
      HEAP32[(($1086)>>2)]=$1084;
      $__ng=0;
      var $1088=$__ig;
      var $1089=(($1088+1)|0);
      $__ig=$1089;
      var $1090=$267;
      var $1091=$128;
      HEAP32[(($128)>>2)]=$1090;
      var $1092=HEAPU32[(($128)>>2)];
      var $1093=$127;
      HEAP32[(($127)>>2)]=$1092;
      var $1094=HEAP32[(($127)>>2)];
      var $1095=(($1094)|0);
      var $1096=$126;
      HEAP32[(($126)>>2)]=$1095;
      var $1097=HEAP32[(($126)>>2)];
      var $1098=$1097;
      var $1099=$125;
      HEAP32[(($125)>>2)]=$1098;
      var $1100=HEAP32[(($125)>>2)];
      var $1101=(($1100)|0);
      var $1102=$125;
      var $1103=$126;
      var $1104=(($1101)|0);
      var $1105=$1104;
      var $1106=(($1105)|0);
      var $1107=$1106;
      var $1108=HEAPU8[($1107)];
      var $1109=(($1108)&255);
      var $1110=$1109 & 1;
      var $1111=(($1110)|0)!=0;
      var $1112=$127;
      if ($1111) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $1113
      var $1114=$121;
      HEAP32[(($121)>>2)]=$1092;
      var $1115=HEAP32[(($121)>>2)];
      var $1116=(($1115)|0);
      var $1117=$120;
      HEAP32[(($120)>>2)]=$1116;
      var $1118=HEAP32[(($120)>>2)];
      var $1119=$1118;
      var $1120=$119;
      HEAP32[(($119)>>2)]=$1119;
      var $1121=HEAP32[(($119)>>2)];
      var $1122=(($1121)|0);
      var $1123=$119;
      var $1124=$120;
      var $1125=(($1122)|0);
      var $1126=$1125;
      var $1127=(($1126+4)|0);
      var $1128=HEAP32[(($1127)>>2)];
      var $1129=$121;
      var $1150 = $1128;__label__ = 73; break;
    case 72: // $1130
      var $1131=$124;
      HEAP32[(($124)>>2)]=$1092;
      var $1132=HEAP32[(($124)>>2)];
      var $1133=(($1132)|0);
      var $1134=$123;
      HEAP32[(($123)>>2)]=$1133;
      var $1135=HEAP32[(($123)>>2)];
      var $1136=$1135;
      var $1137=$122;
      HEAP32[(($122)>>2)]=$1136;
      var $1138=HEAP32[(($122)>>2)];
      var $1139=(($1138)|0);
      var $1140=$122;
      var $1141=$123;
      var $1142=(($1139)|0);
      var $1143=$1142;
      var $1144=(($1143)|0);
      var $1145=$1144;
      var $1146=HEAPU8[($1145)];
      var $1147=(($1146)&255);
      var $1148=$1147 >> 1;
      var $1149=$124;
      var $1150 = $1148;__label__ = 73; break;
    case 73: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $1150;
      var $1151=$128;
      var $1152=(($1089)>>>0) < (($1150)>>>0);
      if ($1152) { __label__ = 74; break; } else { __label__ = 84; break; }
    case 74: // $1153
      var $1154=$267;
      var $1155=$__ig;
      var $1156=$140;
      var $1157=$141;
      HEAP32[(($140)>>2)]=$1154;
      HEAP32[(($141)>>2)]=$1155;
      var $1158=HEAP32[(($140)>>2)];
      var $1159=$139;
      HEAP32[(($139)>>2)]=$1158;
      var $1160=HEAP32[(($139)>>2)];
      var $1161=$138;
      HEAP32[(($138)>>2)]=$1160;
      var $1162=HEAPU32[(($138)>>2)];
      var $1163=$137;
      HEAP32[(($137)>>2)]=$1162;
      var $1164=HEAP32[(($137)>>2)];
      var $1165=(($1164)|0);
      var $1166=$136;
      HEAP32[(($136)>>2)]=$1165;
      var $1167=HEAP32[(($136)>>2)];
      var $1168=$1167;
      var $1169=$135;
      HEAP32[(($135)>>2)]=$1168;
      var $1170=HEAP32[(($135)>>2)];
      var $1171=(($1170)|0);
      var $1172=$135;
      var $1173=$136;
      var $1174=(($1171)|0);
      var $1175=$1174;
      var $1176=(($1175)|0);
      var $1177=$1176;
      var $1178=HEAPU8[($1177)];
      var $1179=(($1178)&255);
      var $1180=$1179 & 1;
      var $1181=(($1180)|0)!=0;
      var $1182=$137;
      if ($1181) { __label__ = 75; break; } else { __label__ = 76; break; }
    case 75: // $1183
      var $1184=$131;
      HEAP32[(($131)>>2)]=$1162;
      var $1185=HEAP32[(($131)>>2)];
      var $1186=(($1185)|0);
      var $1187=$130;
      HEAP32[(($130)>>2)]=$1186;
      var $1188=HEAP32[(($130)>>2)];
      var $1189=$1188;
      var $1190=$129;
      HEAP32[(($129)>>2)]=$1189;
      var $1191=HEAP32[(($129)>>2)];
      var $1192=(($1191)|0);
      var $1193=$129;
      var $1194=$130;
      var $1195=(($1192)|0);
      var $1196=$1195;
      var $1197=(($1196+8)|0);
      var $1198=HEAP32[(($1197)>>2)];
      var $1199=$131;
      var $1217 = $1198;__label__ = 77; break;
    case 76: // $1200
      var $1201=$134;
      HEAP32[(($134)>>2)]=$1162;
      var $1202=HEAP32[(($134)>>2)];
      var $1203=(($1202)|0);
      var $1204=$133;
      HEAP32[(($133)>>2)]=$1203;
      var $1205=HEAP32[(($133)>>2)];
      var $1206=$1205;
      var $1207=$132;
      HEAP32[(($132)>>2)]=$1206;
      var $1208=HEAP32[(($132)>>2)];
      var $1209=(($1208)|0);
      var $1210=$132;
      var $1211=$133;
      var $1212=(($1209)|0);
      var $1213=$1212;
      var $1214=(($1213+1)|0);
      var $1215=(($1214)|0);
      var $1216=$134;
      var $1217 = $1215;__label__ = 77; break;
    case 77: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit7
      var $1217;
      var $1218=$138;
      var $1219=$139;
      var $1220=HEAP32[(($141)>>2)];
      var $1221=(($1217+$1220)|0);
      var $1222=$140;
      var $1223=$141;
      var $1224=HEAP8[($1221)];
      var $1225=(($1224 << 24) >> 24);
      var $1226=127;
      var $1227=(($1225)|0)==(($1226)|0);
      if ($1227) { __label__ = 78; break; } else { __label__ = 79; break; }
    case 78: // $1228
      var $1303 = -1;__label__ = 83; break;
    case 79: // $1229
      var $1230=$267;
      var $1231=$__ig;
      var $1232=$153;
      var $1233=$154;
      HEAP32[(($153)>>2)]=$1230;
      HEAP32[(($154)>>2)]=$1231;
      var $1234=HEAP32[(($153)>>2)];
      var $1235=$152;
      HEAP32[(($152)>>2)]=$1234;
      var $1236=HEAP32[(($152)>>2)];
      var $1237=$151;
      HEAP32[(($151)>>2)]=$1236;
      var $1238=HEAPU32[(($151)>>2)];
      var $1239=$150;
      HEAP32[(($150)>>2)]=$1238;
      var $1240=HEAP32[(($150)>>2)];
      var $1241=(($1240)|0);
      var $1242=$149;
      HEAP32[(($149)>>2)]=$1241;
      var $1243=HEAP32[(($149)>>2)];
      var $1244=$1243;
      var $1245=$148;
      HEAP32[(($148)>>2)]=$1244;
      var $1246=HEAP32[(($148)>>2)];
      var $1247=(($1246)|0);
      var $1248=$148;
      var $1249=$149;
      var $1250=(($1247)|0);
      var $1251=$1250;
      var $1252=(($1251)|0);
      var $1253=$1252;
      var $1254=HEAPU8[($1253)];
      var $1255=(($1254)&255);
      var $1256=$1255 & 1;
      var $1257=(($1256)|0)!=0;
      var $1258=$150;
      if ($1257) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $1259
      var $1260=$144;
      HEAP32[(($144)>>2)]=$1238;
      var $1261=HEAP32[(($144)>>2)];
      var $1262=(($1261)|0);
      var $1263=$143;
      HEAP32[(($143)>>2)]=$1262;
      var $1264=HEAP32[(($143)>>2)];
      var $1265=$1264;
      var $1266=$142;
      HEAP32[(($142)>>2)]=$1265;
      var $1267=HEAP32[(($142)>>2)];
      var $1268=(($1267)|0);
      var $1269=$142;
      var $1270=$143;
      var $1271=(($1268)|0);
      var $1272=$1271;
      var $1273=(($1272+8)|0);
      var $1274=HEAP32[(($1273)>>2)];
      var $1275=$144;
      var $1293 = $1274;__label__ = 82; break;
    case 81: // $1276
      var $1277=$147;
      HEAP32[(($147)>>2)]=$1238;
      var $1278=HEAP32[(($147)>>2)];
      var $1279=(($1278)|0);
      var $1280=$146;
      HEAP32[(($146)>>2)]=$1279;
      var $1281=HEAP32[(($146)>>2)];
      var $1282=$1281;
      var $1283=$145;
      HEAP32[(($145)>>2)]=$1282;
      var $1284=HEAP32[(($145)>>2)];
      var $1285=(($1284)|0);
      var $1286=$145;
      var $1287=$146;
      var $1288=(($1285)|0);
      var $1289=$1288;
      var $1290=(($1289+1)|0);
      var $1291=(($1290)|0);
      var $1292=$147;
      var $1293 = $1291;__label__ = 82; break;
    case 82: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj_exit
      var $1293;
      var $1294=$151;
      var $1295=$152;
      var $1296=HEAP32[(($154)>>2)];
      var $1297=(($1293+$1296)|0);
      var $1298=$153;
      var $1299=$154;
      var $1300=HEAP8[($1297)];
      var $1301=(($1300 << 24) >> 24);
      var $1303 = $1301;__label__ = 83; break;
    case 83: // $1302
      var $1303;
      $__gl=$1303;
      __label__ = 84; break;
    case 84: // $1304
      __label__ = 85; break;
    case 85: // $1305
      var $1306=$__d;
      var $1307=(($1306-4)|0);
      $__d=$1307;
      var $1308=HEAP32[(($1307)>>2)];
      var $1309=$258;
      var $1310=HEAP32[(($1309)>>2)];
      var $1311=(($1310+4)|0);
      HEAP32[(($1309)>>2)]=$1311;
      HEAP32[(($1310)>>2)]=$1308;
      var $1312=$__ng;
      var $1313=(($1312+1)|0);
      $__ng=$1313;
      __label__ = 68; break;
    case 86: // $1314
      __label__ = 87; break;
    case 87: // $1315
      var $1316=$__t;
      var $1317=$258;
      var $1318=HEAP32[(($1317)>>2)];
      var $1319=$162;
      var $1320=$163;
      var $1321=$164;
      var $1322=$165;
      HEAP32[(($163)>>2)]=$1316;
      HEAP32[(($164)>>2)]=$1318;
      var $1323=HEAP32[(($163)>>2)];
      var $1324=HEAP32[(($164)>>2)];
      var $tmp_i5=$162;
      var $tmp1_i6=$165;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i5)]=HEAP8[($tmp1_i6)];
      var $1325=$160;
      var $1326=$161;
      HEAP32[(($160)>>2)]=$1323;
      HEAP32[(($161)>>2)]=$1324;
      var $1327=HEAP32[(($160)>>2)];
      var $1328=HEAP32[(($161)>>2)];
      var $1329=(($1327)|0)!=(($1328)|0);
      if ($1329) { __label__ = 88; break; } else { __label__ = 92; break; }
    case 88: // $1330
      __label__ = 89; break;
    case 89: // $1331
      var $1332=HEAPU32[(($160)>>2)];
      var $1333=HEAP32[(($161)>>2)];
      var $1334=(($1333-4)|0);
      HEAP32[(($161)>>2)]=$1334;
      var $1335=(($1332)>>>0) < (($1334)>>>0);
      if ($1335) { __label__ = 90; break; } else { __label__ = 91; break; }
    case 90: // $1336
      var $1337=HEAP32[(($160)>>2)];
      var $1338=HEAP32[(($161)>>2)];
      var $1339=$158;
      var $1340=$159;
      var $1341=$__t_i_i_i;
      HEAP32[(($158)>>2)]=$1337;
      HEAP32[(($159)>>2)]=$1338;
      var $1342=HEAP32[(($158)>>2)];
      var $1343=$157;
      HEAP32[(($157)>>2)]=$1342;
      var $1344=HEAP32[(($157)>>2)];
      var $1345=$157;
      var $1346=HEAP32[(($1344)>>2)];
      HEAP32[(($__t_i_i_i)>>2)]=$1346;
      var $1347=HEAP32[(($159)>>2)];
      var $1348=$155;
      HEAP32[(($155)>>2)]=$1347;
      var $1349=HEAP32[(($155)>>2)];
      var $1350=$155;
      var $1351=HEAP32[(($1349)>>2)];
      var $1352=HEAP32[(($158)>>2)];
      HEAP32[(($1352)>>2)]=$1351;
      var $1353=$156;
      HEAP32[(($156)>>2)]=$__t_i_i_i;
      var $1354=HEAP32[(($156)>>2)];
      var $1355=$156;
      var $1356=HEAP32[(($1354)>>2)];
      var $1357=HEAP32[(($159)>>2)];
      HEAP32[(($1357)>>2)]=$1356;
      var $1358=$158;
      var $1359=$159;
      var $1360=$__t_i_i_i;
      var $1361=HEAP32[(($160)>>2)];
      var $1362=(($1361+4)|0);
      HEAP32[(($160)>>2)]=$1362;
      __label__ = 89; break;
    case 91: // $1363
      __label__ = 92; break;
    case 92: // $_ZNSt3__17reverseIPwEEvT_S2__exit
      var $1364=$160;
      var $1365=$161;
      var $1366=$162;
      var $1367=$163;
      var $1368=$164;
      var $1369=$165;
      __label__ = 93; break;
    case 93: // $1370
      __label__ = 94; break;
    case 94: // $1371
      var $1372=$__p;
      var $1373=(($1372+1)|0);
      $__p=$1373;
      __label__ = 1; break;
    case 95: // $1374
      var $1375=$269;
      var $1376=$175;
      HEAP32[(($175)>>2)]=$1375;
      var $1377=HEAPU32[(($175)>>2)];
      var $1378=$174;
      HEAP32[(($174)>>2)]=$1377;
      var $1379=HEAP32[(($174)>>2)];
      var $1380=(($1379)|0);
      var $1381=$173;
      HEAP32[(($173)>>2)]=$1380;
      var $1382=HEAP32[(($173)>>2)];
      var $1383=$1382;
      var $1384=$172;
      HEAP32[(($172)>>2)]=$1383;
      var $1385=HEAP32[(($172)>>2)];
      var $1386=(($1385)|0);
      var $1387=$172;
      var $1388=$173;
      var $1389=(($1386)|0);
      var $1390=$1389;
      var $1391=(($1390)|0);
      var $1392=$1391;
      var $1393=HEAPU8[($1392)];
      var $1394=(($1393)&255);
      var $1395=$1394 & 1;
      var $1396=(($1395)|0)!=0;
      var $1397=$174;
      if ($1396) { __label__ = 96; break; } else { __label__ = 97; break; }
    case 96: // $1398
      var $1399=$168;
      HEAP32[(($168)>>2)]=$1377;
      var $1400=HEAP32[(($168)>>2)];
      var $1401=(($1400)|0);
      var $1402=$167;
      HEAP32[(($167)>>2)]=$1401;
      var $1403=HEAP32[(($167)>>2)];
      var $1404=$1403;
      var $1405=$166;
      HEAP32[(($166)>>2)]=$1404;
      var $1406=HEAP32[(($166)>>2)];
      var $1407=(($1406)|0);
      var $1408=$166;
      var $1409=$167;
      var $1410=(($1407)|0);
      var $1411=$1410;
      var $1412=(($1411+4)|0);
      var $1413=HEAP32[(($1412)>>2)];
      var $1414=$168;
      var $1435 = $1413;__label__ = 98; break;
    case 97: // $1415
      var $1416=$171;
      HEAP32[(($171)>>2)]=$1377;
      var $1417=HEAP32[(($171)>>2)];
      var $1418=(($1417)|0);
      var $1419=$170;
      HEAP32[(($170)>>2)]=$1418;
      var $1420=HEAP32[(($170)>>2)];
      var $1421=$1420;
      var $1422=$169;
      HEAP32[(($169)>>2)]=$1421;
      var $1423=HEAP32[(($169)>>2)];
      var $1424=(($1423)|0);
      var $1425=$169;
      var $1426=$170;
      var $1427=(($1424)|0);
      var $1428=$1427;
      var $1429=(($1428)|0);
      var $1430=$1429;
      var $1431=HEAPU8[($1430)];
      var $1432=(($1431)&255);
      var $1433=$1432 >> 1;
      var $1434=$171;
      var $1435 = $1433;__label__ = 98; break;
    case 98: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $1435;
      var $1436=$175;
      var $1437=(($1435)>>>0) > 1;
      if ($1437) { __label__ = 99; break; } else { __label__ = 112; break; }
    case 99: // $1438
      var $1439=$269;
      var $1440=$191;
      HEAP32[(($191)>>2)]=$1439;
      var $1441=HEAP32[(($191)>>2)];
      var $1442=$190;
      HEAP32[(($190)>>2)]=$1441;
      var $1443=HEAP32[(($190)>>2)];
      var $1444=$189;
      HEAP32[(($189)>>2)]=$1443;
      var $1445=HEAPU32[(($189)>>2)];
      var $1446=$188;
      HEAP32[(($188)>>2)]=$1445;
      var $1447=HEAP32[(($188)>>2)];
      var $1448=(($1447)|0);
      var $1449=$187;
      HEAP32[(($187)>>2)]=$1448;
      var $1450=HEAP32[(($187)>>2)];
      var $1451=$1450;
      var $1452=$186;
      HEAP32[(($186)>>2)]=$1451;
      var $1453=HEAP32[(($186)>>2)];
      var $1454=(($1453)|0);
      var $1455=$186;
      var $1456=$187;
      var $1457=(($1454)|0);
      var $1458=$1457;
      var $1459=(($1458)|0);
      var $1460=$1459;
      var $1461=HEAPU8[($1460)];
      var $1462=(($1461)&255);
      var $1463=$1462 & 1;
      var $1464=(($1463)|0)!=0;
      var $1465=$188;
      if ($1464) { __label__ = 100; break; } else { __label__ = 101; break; }
    case 100: // $1466
      var $1467=$182;
      HEAP32[(($182)>>2)]=$1445;
      var $1468=HEAP32[(($182)>>2)];
      var $1469=(($1468)|0);
      var $1470=$181;
      HEAP32[(($181)>>2)]=$1469;
      var $1471=HEAP32[(($181)>>2)];
      var $1472=$1471;
      var $1473=$180;
      HEAP32[(($180)>>2)]=$1472;
      var $1474=HEAP32[(($180)>>2)];
      var $1475=(($1474)|0);
      var $1476=$180;
      var $1477=$181;
      var $1478=(($1475)|0);
      var $1479=$1478;
      var $1480=(($1479+8)|0);
      var $1481=HEAP32[(($1480)>>2)];
      var $1482=$182;
      var $1500 = $1481;__label__ = 102; break;
    case 101: // $1483
      var $1484=$185;
      HEAP32[(($185)>>2)]=$1445;
      var $1485=HEAP32[(($185)>>2)];
      var $1486=(($1485)|0);
      var $1487=$184;
      HEAP32[(($184)>>2)]=$1486;
      var $1488=HEAP32[(($184)>>2)];
      var $1489=$1488;
      var $1490=$183;
      HEAP32[(($183)>>2)]=$1489;
      var $1491=HEAP32[(($183)>>2)];
      var $1492=(($1491)|0);
      var $1493=$183;
      var $1494=$184;
      var $1495=(($1492)|0);
      var $1496=$1495;
      var $1497=(($1496+4)|0);
      var $1498=(($1497)|0);
      var $1499=$185;
      var $1500 = $1498;__label__ = 102; break;
    case 102: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv_exit
      var $1500;
      var $1501=$189;
      var $1502=$190;
      var $1503=$178;
      var $1504=$179;
      HEAP32[(($178)>>2)]=$274;
      HEAP32[(($179)>>2)]=$1500;
      var $1505=HEAP32[(($178)>>2)];
      var $1506=HEAP32[(($179)>>2)];
      var $1507=$176;
      var $1508=$177;
      HEAP32[(($176)>>2)]=$1505;
      HEAP32[(($177)>>2)]=$1506;
      var $1509=HEAP32[(($176)>>2)];
      var $1510=(($1509)|0);
      var $1511=HEAP32[(($177)>>2)];
      HEAP32[(($1510)>>2)]=$1511;
      var $1512=$176;
      var $1513=$177;
      var $1514=$178;
      var $1515=$179;
      var $1516=$191;
      var $1517=$194;
      var $1518=$195;
      HEAP32[(($194)>>2)]=$274;
      HEAP32[(($195)>>2)]=1;
      var $1519=HEAP32[(($194)>>2)];
      var $1520=$273;
      var $1521=$1519;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1520)>>2)]=HEAP32[(($1521)>>2)];
      var $1522=HEAP32[(($195)>>2)];
      var $1523=$192;
      var $1524=$193;
      HEAP32[(($192)>>2)]=$273;
      HEAP32[(($193)>>2)]=$1522;
      var $1525=HEAP32[(($192)>>2)];
      var $1526=HEAP32[(($193)>>2)];
      var $1527=(($1525)|0);
      var $1528=HEAP32[(($1527)>>2)];
      var $1529=(($1528+($1526<<2))|0);
      HEAP32[(($1527)>>2)]=$1529;
      var $1530=$192;
      var $1531=$193;
      var $1532=$194;
      var $1533=$195;
      var $1534=$269;
      var $1535=$221;
      HEAP32[(($221)>>2)]=$1534;
      var $1536=HEAPU32[(($221)>>2)];
      var $1537=$220;
      HEAP32[(($220)>>2)]=$1536;
      var $1538=HEAP32[(($220)>>2)];
      var $1539=$219;
      HEAP32[(($219)>>2)]=$1538;
      var $1540=HEAPU32[(($219)>>2)];
      var $1541=$218;
      HEAP32[(($218)>>2)]=$1540;
      var $1542=HEAP32[(($218)>>2)];
      var $1543=(($1542)|0);
      var $1544=$217;
      HEAP32[(($217)>>2)]=$1543;
      var $1545=HEAP32[(($217)>>2)];
      var $1546=$1545;
      var $1547=$216;
      HEAP32[(($216)>>2)]=$1546;
      var $1548=HEAP32[(($216)>>2)];
      var $1549=(($1548)|0);
      var $1550=$216;
      var $1551=$217;
      var $1552=(($1549)|0);
      var $1553=$1552;
      var $1554=(($1553)|0);
      var $1555=$1554;
      var $1556=HEAPU8[($1555)];
      var $1557=(($1556)&255);
      var $1558=$1557 & 1;
      var $1559=(($1558)|0)!=0;
      var $1560=$218;
      if ($1559) { __label__ = 103; break; } else { __label__ = 104; break; }
    case 103: // $1561
      var $1562=$212;
      HEAP32[(($212)>>2)]=$1540;
      var $1563=HEAP32[(($212)>>2)];
      var $1564=(($1563)|0);
      var $1565=$211;
      HEAP32[(($211)>>2)]=$1564;
      var $1566=HEAP32[(($211)>>2)];
      var $1567=$1566;
      var $1568=$210;
      HEAP32[(($210)>>2)]=$1567;
      var $1569=HEAP32[(($210)>>2)];
      var $1570=(($1569)|0);
      var $1571=$210;
      var $1572=$211;
      var $1573=(($1570)|0);
      var $1574=$1573;
      var $1575=(($1574+8)|0);
      var $1576=HEAP32[(($1575)>>2)];
      var $1577=$212;
      var $1595 = $1576;__label__ = 105; break;
    case 104: // $1578
      var $1579=$215;
      HEAP32[(($215)>>2)]=$1540;
      var $1580=HEAP32[(($215)>>2)];
      var $1581=(($1580)|0);
      var $1582=$214;
      HEAP32[(($214)>>2)]=$1581;
      var $1583=HEAP32[(($214)>>2)];
      var $1584=$1583;
      var $1585=$213;
      HEAP32[(($213)>>2)]=$1584;
      var $1586=HEAP32[(($213)>>2)];
      var $1587=(($1586)|0);
      var $1588=$213;
      var $1589=$214;
      var $1590=(($1587)|0);
      var $1591=$1590;
      var $1592=(($1591+4)|0);
      var $1593=(($1592)|0);
      var $1594=$215;
      var $1595 = $1593;__label__ = 105; break;
    case 105: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit_i
      var $1595;
      var $1596=$219;
      var $1597=$220;
      var $1598=$205;
      HEAP32[(($205)>>2)]=$1536;
      var $1599=HEAPU32[(($205)>>2)];
      var $1600=$204;
      HEAP32[(($204)>>2)]=$1599;
      var $1601=HEAP32[(($204)>>2)];
      var $1602=(($1601)|0);
      var $1603=$203;
      HEAP32[(($203)>>2)]=$1602;
      var $1604=HEAP32[(($203)>>2)];
      var $1605=$1604;
      var $1606=$202;
      HEAP32[(($202)>>2)]=$1605;
      var $1607=HEAP32[(($202)>>2)];
      var $1608=(($1607)|0);
      var $1609=$202;
      var $1610=$203;
      var $1611=(($1608)|0);
      var $1612=$1611;
      var $1613=(($1612)|0);
      var $1614=$1613;
      var $1615=HEAPU8[($1614)];
      var $1616=(($1615)&255);
      var $1617=$1616 & 1;
      var $1618=(($1617)|0)!=0;
      var $1619=$204;
      if ($1618) { __label__ = 106; break; } else { __label__ = 107; break; }
    case 106: // $1620
      var $1621=$198;
      HEAP32[(($198)>>2)]=$1599;
      var $1622=HEAP32[(($198)>>2)];
      var $1623=(($1622)|0);
      var $1624=$197;
      HEAP32[(($197)>>2)]=$1623;
      var $1625=HEAP32[(($197)>>2)];
      var $1626=$1625;
      var $1627=$196;
      HEAP32[(($196)>>2)]=$1626;
      var $1628=HEAP32[(($196)>>2)];
      var $1629=(($1628)|0);
      var $1630=$196;
      var $1631=$197;
      var $1632=(($1629)|0);
      var $1633=$1632;
      var $1634=(($1633+4)|0);
      var $1635=HEAP32[(($1634)>>2)];
      var $1636=$198;
      var $1657 = $1635;__label__ = 108; break;
    case 107: // $1637
      var $1638=$201;
      HEAP32[(($201)>>2)]=$1599;
      var $1639=HEAP32[(($201)>>2)];
      var $1640=(($1639)|0);
      var $1641=$200;
      HEAP32[(($200)>>2)]=$1640;
      var $1642=HEAP32[(($200)>>2)];
      var $1643=$1642;
      var $1644=$199;
      HEAP32[(($199)>>2)]=$1643;
      var $1645=HEAP32[(($199)>>2)];
      var $1646=(($1645)|0);
      var $1647=$199;
      var $1648=$200;
      var $1649=(($1646)|0);
      var $1650=$1649;
      var $1651=(($1650)|0);
      var $1652=$1651;
      var $1653=HEAPU8[($1652)];
      var $1654=(($1653)&255);
      var $1655=$1654 >> 1;
      var $1656=$201;
      var $1657 = $1655;__label__ = 108; break;
    case 108: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv_exit
      var $1657;
      var $1658=$205;
      var $1659=(($1595+($1657<<2))|0);
      var $1660=$208;
      var $1661=$209;
      HEAP32[(($208)>>2)]=$275;
      HEAP32[(($209)>>2)]=$1659;
      var $1662=HEAP32[(($208)>>2)];
      var $1663=HEAP32[(($209)>>2)];
      var $1664=$206;
      var $1665=$207;
      HEAP32[(($206)>>2)]=$1662;
      HEAP32[(($207)>>2)]=$1663;
      var $1666=HEAP32[(($206)>>2)];
      var $1667=(($1666)|0);
      var $1668=HEAP32[(($207)>>2)];
      HEAP32[(($1667)>>2)]=$1668;
      var $1669=$206;
      var $1670=$207;
      var $1671=$208;
      var $1672=$209;
      var $1673=$221;
      var $1674=$258;
      var $1675=HEAP32[(($1674)>>2)];
      var $tmp=$242;
      var $tmp1=$273;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $tmp2=$241;
      var $tmp3=$275;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2)]=HEAP8[($tmp3)];HEAP8[($tmp2+1)]=HEAP8[($tmp3+1)];HEAP8[($tmp2+2)]=HEAP8[($tmp3+2)];HEAP8[($tmp2+3)]=HEAP8[($tmp3+3)];
      var $1676=$222;
      var $1677=$233;
      var $1678=$234;
      var $1679=$235;
      var $1680=$236;
      var $1681=$237;
      var $1682=$238;
      var $1683=$239;
      var $1684=$240;
      HEAP32[(($236)>>2)]=$1675;
      var $1685=$238;
      var $1686=$242;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1685)>>2)]=HEAP32[(($1686)>>2)];
      var $tmp_i=$235;
      var $tmp1_i=$238;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];HEAP8[($tmp_i+1)]=HEAP8[($tmp1_i+1)];HEAP8[($tmp_i+2)]=HEAP8[($tmp1_i+2)];HEAP8[($tmp_i+3)]=HEAP8[($tmp1_i+3)];
      var $1687=$237;
      var $1688=$235;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1687)>>2)]=HEAP32[(($1688)>>2)];
      var $1689=$240;
      var $1690=$241;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1689)>>2)]=HEAP32[(($1690)>>2)];
      var $tmp6_i=$222;
      var $tmp7_i=$240;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp6_i)]=HEAP8[($tmp7_i)];HEAP8[($tmp6_i+1)]=HEAP8[($tmp7_i+1)];HEAP8[($tmp6_i+2)]=HEAP8[($tmp7_i+2)];HEAP8[($tmp6_i+3)]=HEAP8[($tmp7_i+3)];
      var $1691=$239;
      var $1692=$222;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1691)>>2)]=HEAP32[(($1692)>>2)];
      var $1693=HEAP32[(($236)>>2)];
      var $1694=$223;
      HEAP32[(($223)>>2)]=$1693;
      var $1695=HEAP32[(($223)>>2)];
      var $1696=$223;
      var $tmp2_i=$234;
      var $tmp3_i=$237;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp2_i)]=HEAP8[($tmp3_i)];HEAP8[($tmp2_i+1)]=HEAP8[($tmp3_i+1)];HEAP8[($tmp2_i+2)]=HEAP8[($tmp3_i+2)];HEAP8[($tmp2_i+3)]=HEAP8[($tmp3_i+3)];
      var $tmp4_i=$233;
      var $tmp5_i=$239;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp4_i)]=HEAP8[($tmp5_i)];HEAP8[($tmp4_i+1)]=HEAP8[($tmp5_i+1)];HEAP8[($tmp4_i+2)]=HEAP8[($tmp5_i+2)];HEAP8[($tmp4_i+3)]=HEAP8[($tmp5_i+3)];
      var $1697=$232;
      HEAP32[(($232)>>2)]=$1695;
      __label__ = 109; break;
    case 109: // $1698
      var $1699=$230;
      var $1700=$231;
      HEAP32[(($230)>>2)]=$234;
      HEAP32[(($231)>>2)]=$233;
      var $1701=HEAP32[(($230)>>2)];
      var $1702=HEAP32[(($231)>>2)];
      var $1703=$228;
      var $1704=$229;
      HEAP32[(($228)>>2)]=$1701;
      HEAP32[(($229)>>2)]=$1702;
      var $1705=HEAP32[(($228)>>2)];
      var $1706=$227;
      HEAP32[(($227)>>2)]=$1705;
      var $1707=HEAP32[(($227)>>2)];
      var $1708=(($1707)|0);
      var $1709=HEAP32[(($1708)>>2)];
      var $1710=$227;
      var $1711=HEAP32[(($229)>>2)];
      var $1712=$226;
      HEAP32[(($226)>>2)]=$1711;
      var $1713=HEAP32[(($226)>>2)];
      var $1714=(($1713)|0);
      var $1715=HEAP32[(($1714)>>2)];
      var $1716=$226;
      var $1717=(($1709)|0)==(($1715)|0);
      var $1718=$228;
      var $1719=$229;
      var $1720=$1717 ^ 1;
      var $1721=$230;
      var $1722=$231;
      if ($1720) { __label__ = 110; break; } else { __label__ = 111; break; }
    case 110: // $1723
      var $1724=$224;
      HEAP32[(($224)>>2)]=$234;
      var $1725=HEAP32[(($224)>>2)];
      var $1726=(($1725)|0);
      var $1727=HEAP32[(($1726)>>2)];
      var $1728=$224;
      var $1729=HEAP32[(($1727)>>2)];
      var $1730=HEAP32[(($232)>>2)];
      HEAP32[(($1730)>>2)]=$1729;
      var $1731=$225;
      HEAP32[(($225)>>2)]=$234;
      var $1732=HEAP32[(($225)>>2)];
      var $1733=(($1732)|0);
      var $1734=HEAP32[(($1733)>>2)];
      var $1735=(($1734+4)|0);
      HEAP32[(($1733)>>2)]=$1735;
      var $1736=$225;
      var $1737=HEAP32[(($232)>>2)];
      var $1738=(($1737+4)|0);
      HEAP32[(($232)>>2)]=$1738;
      __label__ = 109; break;
    case 111: // $_ZNSt3__14copyINS_11__wrap_iterIPKwEEPwEET0_T_S7_S6__exit
      var $1739=HEAP32[(($232)>>2)];
      var $1740=$232;
      var $1741=$222;
      var $1742=$233;
      var $1743=$234;
      var $1744=$235;
      var $1745=$236;
      var $1746=$237;
      var $1747=$238;
      var $1748=$239;
      var $1749=$240;
      var $1750=$258;
      HEAP32[(($1750)>>2)]=$1739;
      __label__ = 112; break;
    case 112: // $1751
      var $1752=$259;
      var $1753=$1752 & 176;
      var $1754=(($1753)|0)==32;
      if ($1754) { __label__ = 113; break; } else { __label__ = 114; break; }
    case 113: // $1755
      var $1756=$258;
      var $1757=HEAP32[(($1756)>>2)];
      var $1758=$257;
      HEAP32[(($1758)>>2)]=$1757;
      __label__ = 117; break;
    case 114: // $1759
      var $1760=$259;
      var $1761=$1760 & 176;
      var $1762=(($1761)|0)!=16;
      if ($1762) { __label__ = 115; break; } else { __label__ = 116; break; }
    case 115: // $1763
      var $1764=$256;
      var $1765=$257;
      HEAP32[(($1765)>>2)]=$1764;
      __label__ = 116; break;
    case 116: // $1766
      __label__ = 117; break;
    case 117: // $1767
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i["X"]=1;

function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE($agg_result, $this, $__s, $__intl, $__iob, $__fl, $__digits) {
  var __stackBase__  = STACKTOP; STACKTOP += 1324; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__s; $__s = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__s)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $__tmp_i=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48=__stackBase__+192;
      var $49=__stackBase__+196;
      var $50=__stackBase__+200;
      var $51=__stackBase__+204;
      var $52=__stackBase__+208;
      var $53=__stackBase__+212;
      var $54=__stackBase__+216;
      var $55=__stackBase__+220;
      var $56=__stackBase__+224;
      var $57=__stackBase__+228;
      var $58=__stackBase__+232;
      var $59=__stackBase__+236;
      var $60=__stackBase__+240;
      var $61=__stackBase__+244;
      var $62=__stackBase__+248;
      var $63=__stackBase__+252;
      var $64=__stackBase__+256;
      var $65=__stackBase__+260;
      var $66=__stackBase__+264;
      var $67=__stackBase__+268;
      var $68=__stackBase__+272;
      var $69=__stackBase__+276;
      var $70=__stackBase__+280;
      var $71=__stackBase__+284;
      var $__tmp_i_i_i9=__stackBase__+288;
      var $72=__stackBase__+292;
      var $73=__stackBase__+296;
      var $74=__stackBase__+300;
      var $75=__stackBase__+304;
      var $76=__stackBase__+308;
      var $77=__stackBase__+312;
      var $78=__stackBase__+316;
      var $79=__stackBase__+320;
      var $80=__stackBase__+324;
      var $81=__stackBase__+328;
      var $82=__stackBase__+332;
      var $83=__stackBase__+336;
      var $84=__stackBase__+340;
      var $85=__stackBase__+344;
      var $86=__stackBase__+348;
      var $87=__stackBase__+352;
      var $88=__stackBase__+356;
      var $89=__stackBase__+360;
      var $90=__stackBase__+364;
      var $91=__stackBase__+368;
      var $92=__stackBase__+372;
      var $93=__stackBase__+376;
      var $94=__stackBase__+380;
      var $95=__stackBase__+384;
      var $96=__stackBase__+388;
      var $97=__stackBase__+392;
      var $98=__stackBase__+396;
      var $99=__stackBase__+400;
      var $100=__stackBase__+404;
      var $101=__stackBase__+408;
      var $102=__stackBase__+412;
      var $103=__stackBase__+416;
      var $104=__stackBase__+420;
      var $105=__stackBase__+424;
      var $106=__stackBase__+428;
      var $107=__stackBase__+432;
      var $108=__stackBase__+436;
      var $109=__stackBase__+440;
      var $110=__stackBase__+444;
      var $111=__stackBase__+448;
      var $112=__stackBase__+452;
      var $113=__stackBase__+456;
      var $114=__stackBase__+460;
      var $115=__stackBase__+464;
      var $116=__stackBase__+468;
      var $117=__stackBase__+472;
      var $118=__stackBase__+476;
      var $119=__stackBase__+480;
      var $120=__stackBase__+484;
      var $121=__stackBase__+488;
      var $122=__stackBase__+492;
      var $123=__stackBase__+496;
      var $124=__stackBase__+500;
      var $125=__stackBase__+504;
      var $126=__stackBase__+508;
      var $127=__stackBase__+512;
      var $128=__stackBase__+516;
      var $129=__stackBase__+520;
      var $130=__stackBase__+524;
      var $131=__stackBase__+528;
      var $132=__stackBase__+532;
      var $133=__stackBase__+536;
      var $134=__stackBase__+540;
      var $135=__stackBase__+544;
      var $136=__stackBase__+548;
      var $137=__stackBase__+552;
      var $138=__stackBase__+556;
      var $139=__stackBase__+560;
      var $140=__stackBase__+564;
      var $141=__stackBase__+568;
      var $142=__stackBase__+572;
      var $__a_i_i_i3=__stackBase__+576;
      var $__i_i_i_i4=__stackBase__+580;
      var $143=__stackBase__+584;
      var $144=__stackBase__+588;
      var $145=__stackBase__+592;
      var $146=__stackBase__+596;
      var $147=__stackBase__+600;
      var $148=__stackBase__+604;
      var $149=__stackBase__+608;
      var $150=__stackBase__+612;
      var $151=__stackBase__+616;
      var $__a_i_i_i1=__stackBase__+620;
      var $__i_i_i_i2=__stackBase__+624;
      var $152=__stackBase__+628;
      var $153=__stackBase__+632;
      var $154=__stackBase__+636;
      var $155=__stackBase__+640;
      var $156=__stackBase__+644;
      var $157=__stackBase__+648;
      var $158=__stackBase__+652;
      var $159=__stackBase__+656;
      var $160=__stackBase__+660;
      var $161=__stackBase__+664;
      var $162=__stackBase__+668;
      var $163=__stackBase__+672;
      var $164=__stackBase__+676;
      var $165=__stackBase__+680;
      var $__tmp_i_i_i=__stackBase__+684;
      var $166=__stackBase__+688;
      var $167=__stackBase__+692;
      var $168=__stackBase__+696;
      var $169=__stackBase__+700;
      var $170=__stackBase__+704;
      var $171=__stackBase__+708;
      var $172=__stackBase__+712;
      var $__a_i_i_i=__stackBase__+716;
      var $__i_i_i_i=__stackBase__+720;
      var $173=__stackBase__+724;
      var $174=__stackBase__+728;
      var $175=__stackBase__+732;
      var $176=__stackBase__+736;
      var $177=__stackBase__+740;
      var $178=__stackBase__+744;
      var $179=__stackBase__+748;
      var $180;
      var $181=__stackBase__+752;
      var $182=__stackBase__+756;
      var $183=__stackBase__+760;
      var $184=__stackBase__+764;
      var $185=__stackBase__+768;
      var $186=__stackBase__+772;
      var $187=__stackBase__+776;
      var $188=__stackBase__+780;
      var $189=__stackBase__+784;
      var $190=__stackBase__+788;
      var $191=__stackBase__+792;
      var $192=__stackBase__+796;
      var $193=__stackBase__+800;
      var $194=__stackBase__+804;
      var $195=__stackBase__+808;
      var $196=__stackBase__+812;
      var $197=__stackBase__+816;
      var $198=__stackBase__+820;
      var $199=__stackBase__+824;
      var $200=__stackBase__+828;
      var $201=__stackBase__+832;
      var $202=__stackBase__+836;
      var $203=__stackBase__+840;
      var $204=__stackBase__+844;
      var $205;
      var $206;
      var $207;
      var $208;
      var $209;
      var $__loc=__stackBase__+848;
      var $__ct;
      var $210;
      var $211;
      var $__neg;
      var $__pat=__stackBase__+852;
      var $__dp=__stackBase__+856;
      var $__ts=__stackBase__+860;
      var $__grp=__stackBase__+864;
      var $__sym=__stackBase__+876;
      var $__sn=__stackBase__+888;
      var $__fd=__stackBase__+900;
      var $__mbuf=__stackBase__+904;
      var $__mb;
      var $__h=__stackBase__+1304;
      var $__exn;
      var $__mi=__stackBase__+1312;
      var $__me=__stackBase__+1316;
      var $212=__stackBase__+1320;
      var $213;
      $205=$this;
      var $214=(($__intl)&1);
      $206=$214;
      $207=$__iob;
      $208=$__fl;
      $209=$__digits;
      var $215=$205;
      var $216=$207;
      __ZNKSt3__18ios_base6getlocEv($__loc, $216);
      var $217=$204;
      HEAP32[(($204)>>2)]=$__loc;
      var $218=HEAP32[(($204)>>2)];
      var $219=(function() { try { __THREW__ = false; return __ZNKSt3__16locale9use_facetERNS0_2idE($218, __ZNSt3__15ctypeIwE2idE) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 56; break; };
    case 1: // $_ZNSt3__19use_facetINS_5ctypeIwEEEERKT_RKNS_6localeE_exit
      var $220=$219;
      var $221=$204;
      __label__ = 2; break;
    case 2: // $222
      $__ct=$220;
      var $223=$209;
      var $224=$203;
      HEAP32[(($203)>>2)]=$223;
      var $225=HEAPU32[(($203)>>2)];
      var $226=$202;
      HEAP32[(($202)>>2)]=$225;
      var $227=HEAP32[(($202)>>2)];
      var $228=(($227)|0);
      var $229=$201;
      HEAP32[(($201)>>2)]=$228;
      var $230=HEAP32[(($201)>>2)];
      var $231=$230;
      var $232=$200;
      HEAP32[(($200)>>2)]=$231;
      var $233=HEAP32[(($200)>>2)];
      var $234=(($233)|0);
      var $235=$200;
      var $236=$201;
      var $237=(($234)|0);
      var $238=$237;
      var $239=(($238)|0);
      var $240=$239;
      var $241=HEAPU8[($240)];
      var $242=(($241)&255);
      var $243=$242 & 1;
      var $244=(($243)|0)!=0;
      var $245=$202;
      if ($244) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $246
      var $247=$196;
      HEAP32[(($196)>>2)]=$225;
      var $248=HEAP32[(($196)>>2)];
      var $249=(($248)|0);
      var $250=$195;
      HEAP32[(($195)>>2)]=$249;
      var $251=HEAP32[(($195)>>2)];
      var $252=$251;
      var $253=$194;
      HEAP32[(($194)>>2)]=$252;
      var $254=HEAP32[(($194)>>2)];
      var $255=(($254)|0);
      var $256=$194;
      var $257=$195;
      var $258=(($255)|0);
      var $259=$258;
      var $260=(($259+4)|0);
      var $261=HEAP32[(($260)>>2)];
      var $262=$196;
      var $283 = $261;__label__ = 5; break;
    case 4: // $263
      var $264=$199;
      HEAP32[(($199)>>2)]=$225;
      var $265=HEAP32[(($199)>>2)];
      var $266=(($265)|0);
      var $267=$198;
      HEAP32[(($198)>>2)]=$266;
      var $268=HEAP32[(($198)>>2)];
      var $269=$268;
      var $270=$197;
      HEAP32[(($197)>>2)]=$269;
      var $271=HEAP32[(($197)>>2)];
      var $272=(($271)|0);
      var $273=$197;
      var $274=$198;
      var $275=(($272)|0);
      var $276=$275;
      var $277=(($276)|0);
      var $278=$277;
      var $279=HEAPU8[($278)];
      var $280=(($279)&255);
      var $281=$280 >> 1;
      var $282=$199;
      var $283 = $281;__label__ = 5; break;
    case 5: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $283;
      var $284=$203;
      var $285=(($283)>>>0) > 0;
      if ($285) { __label__ = 6; break; } else { var $371 = 0;__label__ = 13; break; }
    case 6: // $286
      var $287=$209;
      var $288=$192;
      var $289=$193;
      HEAP32[(($192)>>2)]=$287;
      HEAP32[(($193)>>2)]=0;
      var $290=HEAP32[(($192)>>2)];
      var $291=$191;
      HEAP32[(($191)>>2)]=$290;
      var $292=HEAP32[(($191)>>2)];
      var $293=$190;
      HEAP32[(($190)>>2)]=$292;
      var $294=HEAPU32[(($190)>>2)];
      var $295=$189;
      HEAP32[(($189)>>2)]=$294;
      var $296=HEAP32[(($189)>>2)];
      var $297=(($296)|0);
      var $298=$188;
      HEAP32[(($188)>>2)]=$297;
      var $299=HEAP32[(($188)>>2)];
      var $300=$299;
      var $301=$187;
      HEAP32[(($187)>>2)]=$300;
      var $302=HEAP32[(($187)>>2)];
      var $303=(($302)|0);
      var $304=$187;
      var $305=$188;
      var $306=(($303)|0);
      var $307=$306;
      var $308=(($307)|0);
      var $309=$308;
      var $310=HEAPU8[($309)];
      var $311=(($310)&255);
      var $312=$311 & 1;
      var $313=(($312)|0)!=0;
      var $314=$189;
      if ($313) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $315
      var $316=$183;
      HEAP32[(($183)>>2)]=$294;
      var $317=HEAP32[(($183)>>2)];
      var $318=(($317)|0);
      var $319=$182;
      HEAP32[(($182)>>2)]=$318;
      var $320=HEAP32[(($182)>>2)];
      var $321=$320;
      var $322=$181;
      HEAP32[(($181)>>2)]=$321;
      var $323=HEAP32[(($181)>>2)];
      var $324=(($323)|0);
      var $325=$181;
      var $326=$182;
      var $327=(($324)|0);
      var $328=$327;
      var $329=(($328+8)|0);
      var $330=HEAP32[(($329)>>2)];
      var $331=$183;
      var $349 = $330;__label__ = 9; break;
    case 8: // $332
      var $333=$186;
      HEAP32[(($186)>>2)]=$294;
      var $334=HEAP32[(($186)>>2)];
      var $335=(($334)|0);
      var $336=$185;
      HEAP32[(($185)>>2)]=$335;
      var $337=HEAP32[(($185)>>2)];
      var $338=$337;
      var $339=$184;
      HEAP32[(($184)>>2)]=$338;
      var $340=HEAP32[(($184)>>2)];
      var $341=(($340)|0);
      var $342=$184;
      var $343=$185;
      var $344=(($341)|0);
      var $345=$344;
      var $346=(($345+4)|0);
      var $347=(($346)|0);
      var $348=$186;
      var $349 = $347;__label__ = 9; break;
    case 9: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj_exit
      var $349;
      var $350=$190;
      var $351=$191;
      var $352=HEAP32[(($193)>>2)];
      var $353=(($349+($352<<2))|0);
      var $354=$192;
      var $355=$193;
      __label__ = 10; break;
    case 10: // $356
      var $357=HEAP32[(($353)>>2)];
      var $358=$__ct;
      var $359=$179;
      HEAP32[(($179)>>2)]=$358;
      $180=45;
      var $360=HEAP32[(($179)>>2)];
      var $361=$360;
      var $362=HEAP32[(($361)>>2)];
      var $363=(($362+44)|0);
      var $364=HEAP32[(($363)>>2)];
      var $365=$180;
      var $366=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$364]($360, $365) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 56; break; };
    case 11: // $_ZNKSt3__15ctypeIwE5widenEc_exit
      var $367=$179;
      __label__ = 12; break;
    case 12: // $368
      var $369=(($357)|0)==(($366)|0);
      var $371 = $369;__label__ = 13; break;
    case 13: // $370
      var $371;
      var $372=(($371)&1);
      $__neg=$372;
      var $373=$178;
      HEAP32[(($178)>>2)]=$__grp;
      var $374=HEAP32[(($178)>>2)];
      var $375=$177;
      HEAP32[(($177)>>2)]=$374;
      var $376=HEAPU32[(($177)>>2)];
      var $377=$376;
      var $378=(($376)|0);
      var $379=$176;
      HEAP32[(($176)>>2)]=$378;
      var $380=HEAP32[(($176)>>2)];
      var $381=$175;
      HEAP32[(($175)>>2)]=$380;
      var $382=HEAP32[(($175)>>2)];
      var $383=$382;
      var $384=$174;
      HEAP32[(($174)>>2)]=$383;
      var $385=HEAP32[(($174)>>2)];
      var $386=$385;
      var $387=$173;
      HEAP32[(($173)>>2)]=$386;
      var $388=HEAP32[(($173)>>2)];
      var $389=$173;
      var $390=(($385)|0);
      var $391=$174;
      var $392=$175;
      var $393=$176;
      var $394=$172;
      var $395=$__a_i_i_i;
      var $396=$__i_i_i_i;
      HEAP32[(($172)>>2)]=$376;
      var $397=HEAP32[(($172)>>2)];
      var $398=(($397)|0);
      var $399=$171;
      HEAP32[(($171)>>2)]=$398;
      var $400=HEAP32[(($171)>>2)];
      var $401=$400;
      var $402=$170;
      HEAP32[(($170)>>2)]=$401;
      var $403=HEAP32[(($170)>>2)];
      var $404=(($403)|0);
      var $405=$170;
      var $406=$171;
      var $407=(($404)|0);
      var $408=$407;
      var $409=(($408)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$409;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 14; break;
    case 14: // $410
      var $411=HEAPU32[(($__i_i_i_i)>>2)];
      var $412=(($411)>>>0) < 3;
      if ($412) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $413
      var $414=HEAP32[(($__i_i_i_i)>>2)];
      var $415=HEAP32[(($__a_i_i_i)>>2)];
      var $416=(($415+($414<<2))|0);
      HEAP32[(($416)>>2)]=0;
      var $417=HEAP32[(($__i_i_i_i)>>2)];
      var $418=(($417+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$418;
      __label__ = 14; break;
    case 16: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $419=$172;
      var $420=$__a_i_i_i;
      var $421=$__i_i_i_i;
      var $422=$177;
      var $423=$178;
      __label__ = 17; break;
    case 17: // $424
      var $425=$157;
      HEAP32[(($157)>>2)]=$__sym;
      var $426=HEAP32[(($157)>>2)];
      var $427=$156;
      HEAP32[(($156)>>2)]=$426;
      var $428=HEAPU32[(($156)>>2)];
      var $429=$428;
      var $430=(($428)|0);
      var $431=$155;
      HEAP32[(($155)>>2)]=$430;
      var $432=HEAP32[(($155)>>2)];
      var $433=$154;
      HEAP32[(($154)>>2)]=$432;
      var $434=HEAP32[(($154)>>2)];
      var $435=$434;
      var $436=$153;
      HEAP32[(($153)>>2)]=$435;
      var $437=HEAP32[(($153)>>2)];
      var $438=$437;
      var $439=$152;
      HEAP32[(($152)>>2)]=$438;
      var $440=HEAP32[(($152)>>2)];
      var $441=$152;
      var $442=(($437)|0);
      var $443=$153;
      var $444=$154;
      var $445=$155;
      var $446=$151;
      var $447=$__a_i_i_i1;
      var $448=$__i_i_i_i2;
      HEAP32[(($151)>>2)]=$428;
      var $449=HEAP32[(($151)>>2)];
      var $450=(($449)|0);
      var $451=$150;
      HEAP32[(($150)>>2)]=$450;
      var $452=HEAP32[(($150)>>2)];
      var $453=$452;
      var $454=$149;
      HEAP32[(($149)>>2)]=$453;
      var $455=HEAP32[(($149)>>2)];
      var $456=(($455)|0);
      var $457=$149;
      var $458=$150;
      var $459=(($456)|0);
      var $460=$459;
      var $461=(($460)|0);
      HEAP32[(($__a_i_i_i1)>>2)]=$461;
      HEAP32[(($__i_i_i_i2)>>2)]=0;
      __label__ = 18; break;
    case 18: // $462
      var $463=HEAPU32[(($__i_i_i_i2)>>2)];
      var $464=(($463)>>>0) < 3;
      if ($464) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $465
      var $466=HEAP32[(($__i_i_i_i2)>>2)];
      var $467=HEAP32[(($__a_i_i_i1)>>2)];
      var $468=(($467+($466<<2))|0);
      HEAP32[(($468)>>2)]=0;
      var $469=HEAP32[(($__i_i_i_i2)>>2)];
      var $470=(($469+1)|0);
      HEAP32[(($__i_i_i_i2)>>2)]=$470;
      __label__ = 18; break;
    case 20: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $471=$151;
      var $472=$__a_i_i_i1;
      var $473=$__i_i_i_i2;
      var $474=$156;
      var $475=$157;
      __label__ = 21; break;
    case 21: // $476
      var $477=$148;
      HEAP32[(($148)>>2)]=$__sn;
      var $478=HEAP32[(($148)>>2)];
      var $479=$147;
      HEAP32[(($147)>>2)]=$478;
      var $480=HEAPU32[(($147)>>2)];
      var $481=$480;
      var $482=(($480)|0);
      var $483=$146;
      HEAP32[(($146)>>2)]=$482;
      var $484=HEAP32[(($146)>>2)];
      var $485=$145;
      HEAP32[(($145)>>2)]=$484;
      var $486=HEAP32[(($145)>>2)];
      var $487=$486;
      var $488=$144;
      HEAP32[(($144)>>2)]=$487;
      var $489=HEAP32[(($144)>>2)];
      var $490=$489;
      var $491=$143;
      HEAP32[(($143)>>2)]=$490;
      var $492=HEAP32[(($143)>>2)];
      var $493=$143;
      var $494=(($489)|0);
      var $495=$144;
      var $496=$145;
      var $497=$146;
      var $498=$142;
      var $499=$__a_i_i_i3;
      var $500=$__i_i_i_i4;
      HEAP32[(($142)>>2)]=$480;
      var $501=HEAP32[(($142)>>2)];
      var $502=(($501)|0);
      var $503=$141;
      HEAP32[(($141)>>2)]=$502;
      var $504=HEAP32[(($141)>>2)];
      var $505=$504;
      var $506=$140;
      HEAP32[(($140)>>2)]=$505;
      var $507=HEAP32[(($140)>>2)];
      var $508=(($507)|0);
      var $509=$140;
      var $510=$141;
      var $511=(($508)|0);
      var $512=$511;
      var $513=(($512)|0);
      HEAP32[(($__a_i_i_i3)>>2)]=$513;
      HEAP32[(($__i_i_i_i4)>>2)]=0;
      __label__ = 22; break;
    case 22: // $514
      var $515=HEAPU32[(($__i_i_i_i4)>>2)];
      var $516=(($515)>>>0) < 3;
      if ($516) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $517
      var $518=HEAP32[(($__i_i_i_i4)>>2)];
      var $519=HEAP32[(($__a_i_i_i3)>>2)];
      var $520=(($519+($518<<2))|0);
      HEAP32[(($520)>>2)]=0;
      var $521=HEAP32[(($__i_i_i_i4)>>2)];
      var $522=(($521+1)|0);
      HEAP32[(($__i_i_i_i4)>>2)]=$522;
      __label__ = 22; break;
    case 24: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit5
      var $523=$142;
      var $524=$__a_i_i_i3;
      var $525=$__i_i_i_i4;
      var $526=$147;
      var $527=$148;
      __label__ = 25; break;
    case 25: // $528
      var $529=$206;
      var $530=(($529) & 1);
      var $531=$__neg;
      var $532=(($531) & 1);
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri($530, $532, $__loc, $__pat, $__dp, $__ts, $__grp, $__sym, $__sn, $__fd) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 59; break; }
    case 26: // $533
      var $534=(($__mbuf)|0);
      $__mb=$534;
      var $535=$137;
      var $536=$138;
      var $537=$139;
      HEAP32[(($137)>>2)]=$__h;
      HEAP32[(($138)>>2)]=0;
      HEAP32[(($139)>>2)]=1496;
      var $538=HEAP32[(($137)>>2)];
      var $539=HEAP32[(($138)>>2)];
      var $540=HEAP32[(($139)>>2)];
      var $541=$134;
      var $542=$135;
      var $543=$136;
      HEAP32[(($134)>>2)]=$538;
      HEAP32[(($135)>>2)]=$539;
      HEAP32[(($136)>>2)]=$540;
      var $544=HEAP32[(($134)>>2)];
      var $545=(($544)|0);
      var $546=$133;
      HEAP32[(($133)>>2)]=$135;
      var $547=HEAP32[(($133)>>2)];
      var $548=$133;
      var $549=HEAP32[(($547)>>2)];
      var $550=$119;
      HEAP32[(($119)>>2)]=$136;
      var $551=HEAP32[(($119)>>2)];
      var $552=$119;
      var $553=HEAP32[(($551)>>2)];
      var $554=$130;
      var $555=$131;
      var $556=$132;
      HEAP32[(($130)>>2)]=$545;
      HEAP32[(($131)>>2)]=$549;
      HEAP32[(($132)>>2)]=$553;
      var $557=HEAP32[(($130)>>2)];
      var $558=HEAP32[(($131)>>2)];
      var $559=HEAP32[(($132)>>2)];
      var $560=$127;
      var $561=$128;
      var $562=$129;
      HEAP32[(($127)>>2)]=$557;
      HEAP32[(($128)>>2)]=$558;
      HEAP32[(($129)>>2)]=$559;
      var $563=HEAP32[(($127)>>2)];
      var $564=$563;
      var $565=$126;
      HEAP32[(($126)>>2)]=$128;
      var $566=HEAP32[(($126)>>2)];
      var $567=$126;
      var $568=HEAP32[(($566)>>2)];
      var $569=$120;
      HEAP32[(($120)>>2)]=$129;
      var $570=HEAP32[(($120)>>2)];
      var $571=$120;
      var $572=HEAP32[(($570)>>2)];
      var $573=$123;
      var $574=$124;
      var $575=$125;
      HEAP32[(($123)>>2)]=$564;
      HEAP32[(($124)>>2)]=$568;
      HEAP32[(($125)>>2)]=$572;
      var $576=HEAP32[(($123)>>2)];
      var $577=(($576)|0);
      var $578=$122;
      HEAP32[(($122)>>2)]=$124;
      var $579=HEAP32[(($122)>>2)];
      var $580=$122;
      var $581=HEAP32[(($579)>>2)];
      HEAP32[(($577)>>2)]=$581;
      var $582=(($576+4)|0);
      var $583=$121;
      HEAP32[(($121)>>2)]=$125;
      var $584=HEAP32[(($121)>>2)];
      var $585=$121;
      var $586=HEAP32[(($584)>>2)];
      HEAP32[(($582)>>2)]=$586;
      var $587=$123;
      var $588=$124;
      var $589=$125;
      var $590=$127;
      var $591=$128;
      var $592=$129;
      var $593=$130;
      var $594=$131;
      var $595=$132;
      var $596=$134;
      var $597=$135;
      var $598=$136;
      var $599=$137;
      var $600=$138;
      var $601=$139;
      __label__ = 27; break;
    case 27: // $602
      var $603=$209;
      var $604=$118;
      HEAP32[(($118)>>2)]=$603;
      var $605=HEAPU32[(($118)>>2)];
      var $606=$117;
      HEAP32[(($117)>>2)]=$605;
      var $607=HEAP32[(($117)>>2)];
      var $608=(($607)|0);
      var $609=$116;
      HEAP32[(($116)>>2)]=$608;
      var $610=HEAP32[(($116)>>2)];
      var $611=$610;
      var $612=$115;
      HEAP32[(($115)>>2)]=$611;
      var $613=HEAP32[(($115)>>2)];
      var $614=(($613)|0);
      var $615=$115;
      var $616=$116;
      var $617=(($614)|0);
      var $618=$617;
      var $619=(($618)|0);
      var $620=$619;
      var $621=HEAPU8[($620)];
      var $622=(($621)&255);
      var $623=$622 & 1;
      var $624=(($623)|0)!=0;
      var $625=$117;
      if ($624) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $626
      var $627=$111;
      HEAP32[(($111)>>2)]=$605;
      var $628=HEAP32[(($111)>>2)];
      var $629=(($628)|0);
      var $630=$110;
      HEAP32[(($110)>>2)]=$629;
      var $631=HEAP32[(($110)>>2)];
      var $632=$631;
      var $633=$109;
      HEAP32[(($109)>>2)]=$632;
      var $634=HEAP32[(($109)>>2)];
      var $635=(($634)|0);
      var $636=$109;
      var $637=$110;
      var $638=(($635)|0);
      var $639=$638;
      var $640=(($639+4)|0);
      var $641=HEAP32[(($640)>>2)];
      var $642=$111;
      var $663 = $641;__label__ = 30; break;
    case 29: // $643
      var $644=$114;
      HEAP32[(($114)>>2)]=$605;
      var $645=HEAP32[(($114)>>2)];
      var $646=(($645)|0);
      var $647=$113;
      HEAP32[(($113)>>2)]=$646;
      var $648=HEAP32[(($113)>>2)];
      var $649=$648;
      var $650=$112;
      HEAP32[(($112)>>2)]=$649;
      var $651=HEAP32[(($112)>>2)];
      var $652=(($651)|0);
      var $653=$112;
      var $654=$113;
      var $655=(($652)|0);
      var $656=$655;
      var $657=(($656)|0);
      var $658=$657;
      var $659=HEAPU8[($658)];
      var $660=(($659)&255);
      var $661=$660 >> 1;
      var $662=$114;
      var $663 = $661;__label__ = 30; break;
    case 30: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit6
      var $663;
      var $664=$118;
      var $665=HEAPU32[(($__fd)>>2)];
      var $666=(($663)>>>0) > (($665)>>>0);
      if ($666) { __label__ = 31; break; } else { __label__ = 41; break; }
    case 31: // $667
      var $668=$209;
      var $669=$63;
      HEAP32[(($63)>>2)]=$668;
      var $670=HEAPU32[(($63)>>2)];
      var $671=$62;
      HEAP32[(($62)>>2)]=$670;
      var $672=HEAP32[(($62)>>2)];
      var $673=(($672)|0);
      var $674=$61;
      HEAP32[(($61)>>2)]=$673;
      var $675=HEAP32[(($61)>>2)];
      var $676=$675;
      var $677=$60;
      HEAP32[(($60)>>2)]=$676;
      var $678=HEAP32[(($60)>>2)];
      var $679=(($678)|0);
      var $680=$60;
      var $681=$61;
      var $682=(($679)|0);
      var $683=$682;
      var $684=(($683)|0);
      var $685=$684;
      var $686=HEAPU8[($685)];
      var $687=(($686)&255);
      var $688=$687 & 1;
      var $689=(($688)|0)!=0;
      var $690=$62;
      if ($689) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $691
      var $692=$56;
      HEAP32[(($56)>>2)]=$670;
      var $693=HEAP32[(($56)>>2)];
      var $694=(($693)|0);
      var $695=$55;
      HEAP32[(($55)>>2)]=$694;
      var $696=HEAP32[(($55)>>2)];
      var $697=$696;
      var $698=$54;
      HEAP32[(($54)>>2)]=$697;
      var $699=HEAP32[(($54)>>2)];
      var $700=(($699)|0);
      var $701=$54;
      var $702=$55;
      var $703=(($700)|0);
      var $704=$703;
      var $705=(($704+4)|0);
      var $706=HEAP32[(($705)>>2)];
      var $707=$56;
      var $728 = $706;__label__ = 34; break;
    case 33: // $708
      var $709=$59;
      HEAP32[(($59)>>2)]=$670;
      var $710=HEAP32[(($59)>>2)];
      var $711=(($710)|0);
      var $712=$58;
      HEAP32[(($58)>>2)]=$711;
      var $713=HEAP32[(($58)>>2)];
      var $714=$713;
      var $715=$57;
      HEAP32[(($57)>>2)]=$714;
      var $716=HEAP32[(($57)>>2)];
      var $717=(($716)|0);
      var $718=$57;
      var $719=$58;
      var $720=(($717)|0);
      var $721=$720;
      var $722=(($721)|0);
      var $723=$722;
      var $724=HEAPU8[($723)];
      var $725=(($724)&255);
      var $726=$725 >> 1;
      var $727=$59;
      var $728 = $726;__label__ = 34; break;
    case 34: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit11
      var $728;
      var $729=$63;
      var $730=HEAP32[(($__fd)>>2)];
      var $731=(($728-$730)|0);
      var $732=((($731<<1))|0);
      var $733=$53;
      HEAP32[(($53)>>2)]=$__sn;
      var $734=HEAPU32[(($53)>>2)];
      var $735=$52;
      HEAP32[(($52)>>2)]=$734;
      var $736=HEAP32[(($52)>>2)];
      var $737=(($736)|0);
      var $738=$51;
      HEAP32[(($51)>>2)]=$737;
      var $739=HEAP32[(($51)>>2)];
      var $740=$739;
      var $741=$50;
      HEAP32[(($50)>>2)]=$740;
      var $742=HEAP32[(($50)>>2)];
      var $743=(($742)|0);
      var $744=$50;
      var $745=$51;
      var $746=(($743)|0);
      var $747=$746;
      var $748=(($747)|0);
      var $749=$748;
      var $750=HEAPU8[($749)];
      var $751=(($750)&255);
      var $752=$751 & 1;
      var $753=(($752)|0)!=0;
      var $754=$52;
      if ($753) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $755
      var $756=$46;
      HEAP32[(($46)>>2)]=$734;
      var $757=HEAP32[(($46)>>2)];
      var $758=(($757)|0);
      var $759=$45;
      HEAP32[(($45)>>2)]=$758;
      var $760=HEAP32[(($45)>>2)];
      var $761=$760;
      var $762=$44;
      HEAP32[(($44)>>2)]=$761;
      var $763=HEAP32[(($44)>>2)];
      var $764=(($763)|0);
      var $765=$44;
      var $766=$45;
      var $767=(($764)|0);
      var $768=$767;
      var $769=(($768+4)|0);
      var $770=HEAP32[(($769)>>2)];
      var $771=$46;
      var $792 = $770;__label__ = 37; break;
    case 36: // $772
      var $773=$49;
      HEAP32[(($49)>>2)]=$734;
      var $774=HEAP32[(($49)>>2)];
      var $775=(($774)|0);
      var $776=$48;
      HEAP32[(($48)>>2)]=$775;
      var $777=HEAP32[(($48)>>2)];
      var $778=$777;
      var $779=$47;
      HEAP32[(($47)>>2)]=$778;
      var $780=HEAP32[(($47)>>2)];
      var $781=(($780)|0);
      var $782=$47;
      var $783=$48;
      var $784=(($781)|0);
      var $785=$784;
      var $786=(($785)|0);
      var $787=$786;
      var $788=HEAPU8[($787)];
      var $789=(($788)&255);
      var $790=$789 >> 1;
      var $791=$49;
      var $792 = $790;__label__ = 37; break;
    case 37: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit12
      var $792;
      var $793=$53;
      var $794=(($732+$792)|0);
      var $795=$30;
      HEAP32[(($30)>>2)]=$__sym;
      var $796=HEAPU32[(($30)>>2)];
      var $797=$29;
      HEAP32[(($29)>>2)]=$796;
      var $798=HEAP32[(($29)>>2)];
      var $799=(($798)|0);
      var $800=$28;
      HEAP32[(($28)>>2)]=$799;
      var $801=HEAP32[(($28)>>2)];
      var $802=$801;
      var $803=$27;
      HEAP32[(($27)>>2)]=$802;
      var $804=HEAP32[(($27)>>2)];
      var $805=(($804)|0);
      var $806=$27;
      var $807=$28;
      var $808=(($805)|0);
      var $809=$808;
      var $810=(($809)|0);
      var $811=$810;
      var $812=HEAPU8[($811)];
      var $813=(($812)&255);
      var $814=$813 & 1;
      var $815=(($814)|0)!=0;
      var $816=$29;
      if ($815) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $817
      var $818=$23;
      HEAP32[(($23)>>2)]=$796;
      var $819=HEAP32[(($23)>>2)];
      var $820=(($819)|0);
      var $821=$22;
      HEAP32[(($22)>>2)]=$820;
      var $822=HEAP32[(($22)>>2)];
      var $823=$822;
      var $824=$21;
      HEAP32[(($21)>>2)]=$823;
      var $825=HEAP32[(($21)>>2)];
      var $826=(($825)|0);
      var $827=$21;
      var $828=$22;
      var $829=(($826)|0);
      var $830=$829;
      var $831=(($830+4)|0);
      var $832=HEAP32[(($831)>>2)];
      var $833=$23;
      var $854 = $832;__label__ = 40; break;
    case 39: // $834
      var $835=$26;
      HEAP32[(($26)>>2)]=$796;
      var $836=HEAP32[(($26)>>2)];
      var $837=(($836)|0);
      var $838=$25;
      HEAP32[(($25)>>2)]=$837;
      var $839=HEAP32[(($25)>>2)];
      var $840=$839;
      var $841=$24;
      HEAP32[(($24)>>2)]=$840;
      var $842=HEAP32[(($24)>>2)];
      var $843=(($842)|0);
      var $844=$24;
      var $845=$25;
      var $846=(($843)|0);
      var $847=$846;
      var $848=(($847)|0);
      var $849=$848;
      var $850=HEAPU8[($849)];
      var $851=(($850)&255);
      var $852=$851 >> 1;
      var $853=$26;
      var $854 = $852;__label__ = 40; break;
    case 40: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit13
      var $854;
      var $855=$30;
      var $856=(($794+$854)|0);
      var $857=HEAP32[(($__fd)>>2)];
      var $858=(($856+$857)|0);
      var $859=(($858+1)|0);
      var $988 = $859;__label__ = 48; break;
    case 41: // $860
      var $861=$20;
      HEAP32[(($20)>>2)]=$__sn;
      var $862=HEAPU32[(($20)>>2)];
      var $863=$19;
      HEAP32[(($19)>>2)]=$862;
      var $864=HEAP32[(($19)>>2)];
      var $865=(($864)|0);
      var $866=$18;
      HEAP32[(($18)>>2)]=$865;
      var $867=HEAP32[(($18)>>2)];
      var $868=$867;
      var $869=$17;
      HEAP32[(($17)>>2)]=$868;
      var $870=HEAP32[(($17)>>2)];
      var $871=(($870)|0);
      var $872=$17;
      var $873=$18;
      var $874=(($871)|0);
      var $875=$874;
      var $876=(($875)|0);
      var $877=$876;
      var $878=HEAPU8[($877)];
      var $879=(($878)&255);
      var $880=$879 & 1;
      var $881=(($880)|0)!=0;
      var $882=$19;
      if ($881) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $883
      var $884=$13;
      HEAP32[(($13)>>2)]=$862;
      var $885=HEAP32[(($13)>>2)];
      var $886=(($885)|0);
      var $887=$12;
      HEAP32[(($12)>>2)]=$886;
      var $888=HEAP32[(($12)>>2)];
      var $889=$888;
      var $890=$11;
      HEAP32[(($11)>>2)]=$889;
      var $891=HEAP32[(($11)>>2)];
      var $892=(($891)|0);
      var $893=$11;
      var $894=$12;
      var $895=(($892)|0);
      var $896=$895;
      var $897=(($896+4)|0);
      var $898=HEAP32[(($897)>>2)];
      var $899=$13;
      var $920 = $898;__label__ = 44; break;
    case 43: // $900
      var $901=$16;
      HEAP32[(($16)>>2)]=$862;
      var $902=HEAP32[(($16)>>2)];
      var $903=(($902)|0);
      var $904=$15;
      HEAP32[(($15)>>2)]=$903;
      var $905=HEAP32[(($15)>>2)];
      var $906=$905;
      var $907=$14;
      HEAP32[(($14)>>2)]=$906;
      var $908=HEAP32[(($14)>>2)];
      var $909=(($908)|0);
      var $910=$14;
      var $911=$15;
      var $912=(($909)|0);
      var $913=$912;
      var $914=(($913)|0);
      var $915=$914;
      var $916=HEAPU8[($915)];
      var $917=(($916)&255);
      var $918=$917 >> 1;
      var $919=$16;
      var $920 = $918;__label__ = 44; break;
    case 44: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit14
      var $920;
      var $921=$20;
      var $922=$10;
      HEAP32[(($10)>>2)]=$__sym;
      var $923=HEAPU32[(($10)>>2)];
      var $924=$9;
      HEAP32[(($9)>>2)]=$923;
      var $925=HEAP32[(($9)>>2)];
      var $926=(($925)|0);
      var $927=$8;
      HEAP32[(($8)>>2)]=$926;
      var $928=HEAP32[(($8)>>2)];
      var $929=$928;
      var $930=$7;
      HEAP32[(($7)>>2)]=$929;
      var $931=HEAP32[(($7)>>2)];
      var $932=(($931)|0);
      var $933=$7;
      var $934=$8;
      var $935=(($932)|0);
      var $936=$935;
      var $937=(($936)|0);
      var $938=$937;
      var $939=HEAPU8[($938)];
      var $940=(($939)&255);
      var $941=$940 & 1;
      var $942=(($941)|0)!=0;
      var $943=$9;
      if ($942) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $944
      var $945=$3;
      HEAP32[(($3)>>2)]=$923;
      var $946=HEAP32[(($3)>>2)];
      var $947=(($946)|0);
      var $948=$2;
      HEAP32[(($2)>>2)]=$947;
      var $949=HEAP32[(($2)>>2)];
      var $950=$949;
      var $951=$1;
      HEAP32[(($1)>>2)]=$950;
      var $952=HEAP32[(($1)>>2)];
      var $953=(($952)|0);
      var $954=$1;
      var $955=$2;
      var $956=(($953)|0);
      var $957=$956;
      var $958=(($957+4)|0);
      var $959=HEAP32[(($958)>>2)];
      var $960=$3;
      var $981 = $959;__label__ = 47; break;
    case 46: // $961
      var $962=$6;
      HEAP32[(($6)>>2)]=$923;
      var $963=HEAP32[(($6)>>2)];
      var $964=(($963)|0);
      var $965=$5;
      HEAP32[(($5)>>2)]=$964;
      var $966=HEAP32[(($5)>>2)];
      var $967=$966;
      var $968=$4;
      HEAP32[(($4)>>2)]=$967;
      var $969=HEAP32[(($4)>>2)];
      var $970=(($969)|0);
      var $971=$4;
      var $972=$5;
      var $973=(($970)|0);
      var $974=$973;
      var $975=(($974)|0);
      var $976=$975;
      var $977=HEAPU8[($976)];
      var $978=(($977)&255);
      var $979=$978 >> 1;
      var $980=$6;
      var $981 = $979;__label__ = 47; break;
    case 47: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit15
      var $981;
      var $982=$10;
      var $983=(($920+$981)|0);
      var $984=HEAP32[(($__fd)>>2)];
      var $985=(($983+$984)|0);
      var $986=(($985+2)|0);
      var $988 = $986;__label__ = 48; break;
    case 48: // $987
      var $988;
      $__exn=$988;
      var $989=$__exn;
      var $990=(($989)>>>0) > 100;
      if ($990) { __label__ = 49; break; } else { __label__ = 66; break; }
    case 49: // $991
      var $992=$__exn;
      var $993=((($992<<2))|0);
      var $994=_malloc($993);
      var $995=$994;
      var $996=$37;
      var $997=$38;
      var $998=$__tmp_i;
      var $999=$39;
      var $1000=$40;
      HEAP32[(($37)>>2)]=$__h;
      HEAP32[(($38)>>2)]=$995;
      var $1001=HEAPU32[(($37)>>2)];
      var $1002=(($1001)|0);
      var $1003=$36;
      HEAP32[(($36)>>2)]=$1002;
      var $1004=HEAP32[(($36)>>2)];
      var $1005=$1004;
      var $1006=$35;
      HEAP32[(($35)>>2)]=$1005;
      var $1007=HEAP32[(($35)>>2)];
      var $1008=(($1007)|0);
      var $1009=$35;
      var $1010=$36;
      var $1011=HEAP32[(($1008)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$1011;
      var $1012=HEAP32[(($38)>>2)];
      var $1013=(($1001)|0);
      var $1014=$34;
      HEAP32[(($34)>>2)]=$1013;
      var $1015=HEAP32[(($34)>>2)];
      var $1016=$1015;
      var $1017=$33;
      HEAP32[(($33)>>2)]=$1016;
      var $1018=HEAP32[(($33)>>2)];
      var $1019=(($1018)|0);
      var $1020=$33;
      var $1021=$34;
      HEAP32[(($1019)>>2)]=$1012;
      var $1022=HEAP32[(($__tmp_i)>>2)];
      var $1023=(($1022)|0)!=0;
      if ($1023) { __label__ = 50; break; } else { __label__ = 53; break; }
    case 50: // $1024
      var $1025=(($1001)|0);
      var $1026=$32;
      HEAP32[(($32)>>2)]=$1025;
      var $1027=HEAP32[(($32)>>2)];
      var $1028=$1027;
      var $1029=$31;
      HEAP32[(($31)>>2)]=$1028;
      var $1030=HEAP32[(($31)>>2)];
      var $1031=(($1030+4)|0);
      var $1032=$31;
      var $1033=$32;
      var $1034=HEAP32[(($1031)>>2)];
      var $1035=HEAP32[(($__tmp_i)>>2)];
      var $1036=$1035;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1034]($1036) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $1037
      __label__ = 53; break;
    case 52: // $1038
      var $1039=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1040=$1039.f0;
      HEAP32[(($39)>>2)]=$1040;
      var $1041=$1039.f1;
      HEAP32[(($40)>>2)]=$1041;
      var $1042=HEAP32[(($39)>>2)];
      ___cxa_call_unexpected($1042);
      throw "Reached an unreachable!"
    case 53: // $_ZNSt3__110unique_ptrIwPFvPvEE5resetEPw_exit
      var $1043=$37;
      var $1044=$38;
      var $1045=$__tmp_i;
      var $1046=$39;
      var $1047=$40;
      var $1048=$43;
      HEAP32[(($43)>>2)]=$__h;
      var $1049=HEAP32[(($43)>>2)];
      var $1050=(($1049)|0);
      var $1051=$42;
      HEAP32[(($42)>>2)]=$1050;
      var $1052=HEAP32[(($42)>>2)];
      var $1053=$1052;
      var $1054=$41;
      HEAP32[(($41)>>2)]=$1053;
      var $1055=HEAP32[(($41)>>2)];
      var $1056=(($1055)|0);
      var $1057=$41;
      var $1058=$42;
      var $1059=HEAP32[(($1056)>>2)];
      var $1060=$43;
      $__mb=$1059;
      var $1061=$__mb;
      var $1062=(($1061)|0)==0;
      if ($1062) { __label__ = 54; break; } else { __label__ = 65; break; }
    case 54: // $1063
      (function() { try { __THREW__ = false; return __ZSt17__throw_bad_allocv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 60; break; }
    case 55: // $1064
      __label__ = 65; break;
    case 56: // $1065
      var $1066=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1067=$1066.f0;
      $210=$1067;
      var $1068=$1066.f1;
      $211=$1068;
      __label__ = 94; break;
    case 57: // $1069
      var $1070=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1071=$1070.f0;
      $210=$1071;
      var $1072=$1070.f1;
      $211=$1072;
      __label__ = 92; break;
    case 58: // $1073
      var $1074=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1075=$1074.f0;
      $210=$1075;
      var $1076=$1074.f1;
      $211=$1076;
      __label__ = 89; break;
    case 59: // $1077
      var $1078=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1079=$1078.f0;
      $210=$1079;
      var $1080=$1078.f1;
      $211=$1080;
      __label__ = 86; break;
    case 60: // $1081
      var $1082=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1083=$1082.f0;
      $210=$1083;
      var $1084=$1082.f1;
      $211=$1084;
      var $1085=$75;
      HEAP32[(($75)>>2)]=$__h;
      var $1086=HEAP32[(($75)>>2)];
      var $1087=$74;
      HEAP32[(($74)>>2)]=$1086;
      var $1088=HEAP32[(($74)>>2)];
      var $1089=$70;
      var $1090=$71;
      var $1091=$__tmp_i_i_i9;
      var $1092=$72;
      var $1093=$73;
      HEAP32[(($70)>>2)]=$1088;
      HEAP32[(($71)>>2)]=0;
      var $1094=HEAP32[(($70)>>2)];
      var $1095=(($1094)|0);
      var $1096=$69;
      HEAP32[(($69)>>2)]=$1095;
      var $1097=HEAP32[(($69)>>2)];
      var $1098=$1097;
      var $1099=$68;
      HEAP32[(($68)>>2)]=$1098;
      var $1100=HEAP32[(($68)>>2)];
      var $1101=(($1100)|0);
      var $1102=$68;
      var $1103=$69;
      var $1104=HEAP32[(($1101)>>2)];
      HEAP32[(($__tmp_i_i_i9)>>2)]=$1104;
      var $1105=HEAP32[(($71)>>2)];
      var $1106=(($1094)|0);
      var $1107=$67;
      HEAP32[(($67)>>2)]=$1106;
      var $1108=HEAP32[(($67)>>2)];
      var $1109=$1108;
      var $1110=$66;
      HEAP32[(($66)>>2)]=$1109;
      var $1111=HEAP32[(($66)>>2)];
      var $1112=(($1111)|0);
      var $1113=$66;
      var $1114=$67;
      HEAP32[(($1112)>>2)]=$1105;
      var $1115=HEAP32[(($__tmp_i_i_i9)>>2)];
      var $1116=(($1115)|0)!=0;
      if ($1116) { __label__ = 61; break; } else { __label__ = 64; break; }
    case 61: // $1117
      var $1118=(($1094)|0);
      var $1119=$65;
      HEAP32[(($65)>>2)]=$1118;
      var $1120=HEAP32[(($65)>>2)];
      var $1121=$1120;
      var $1122=$64;
      HEAP32[(($64)>>2)]=$1121;
      var $1123=HEAP32[(($64)>>2)];
      var $1124=(($1123+4)|0);
      var $1125=$64;
      var $1126=$65;
      var $1127=HEAP32[(($1124)>>2)];
      var $1128=HEAP32[(($__tmp_i_i_i9)>>2)];
      var $1129=$1128;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1127]($1129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 62; break; } else { __label__ = 63; break; }
    case 62: // $1130
      __label__ = 64; break;
    case 63: // $1131
      var $1132=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $1133=$1132.f0;
      HEAP32[(($72)>>2)]=$1133;
      var $1134=$1132.f1;
      HEAP32[(($73)>>2)]=$1134;
      var $1135=HEAP32[(($72)>>2)];
      ___cxa_call_unexpected($1135);
      throw "Reached an unreachable!"
    case 64: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit10
      var $1136=$70;
      var $1137=$71;
      var $1138=$__tmp_i_i_i9;
      var $1139=$72;
      var $1140=$73;
      var $1141=$74;
      var $1142=$75;
      __label__ = 84; break;
    case 65: // $1143
      __label__ = 66; break;
    case 66: // $1144
      var $1145=$__mb;
      var $1146=$207;
      var $1147=$76;
      HEAP32[(($76)>>2)]=$1146;
      var $1148=HEAP32[(($76)>>2)];
      var $1149=(($1148+4)|0);
      var $1150=HEAP32[(($1149)>>2)];
      var $1151=$76;
      __label__ = 67; break;
    case 67: // $1152
      var $1153=$209;
      var $1154=$87;
      HEAP32[(($87)>>2)]=$1153;
      var $1155=HEAP32[(($87)>>2)];
      var $1156=$86;
      HEAP32[(($86)>>2)]=$1155;
      var $1157=HEAPU32[(($86)>>2)];
      var $1158=$85;
      HEAP32[(($85)>>2)]=$1157;
      var $1159=HEAP32[(($85)>>2)];
      var $1160=(($1159)|0);
      var $1161=$84;
      HEAP32[(($84)>>2)]=$1160;
      var $1162=HEAP32[(($84)>>2)];
      var $1163=$1162;
      var $1164=$83;
      HEAP32[(($83)>>2)]=$1163;
      var $1165=HEAP32[(($83)>>2)];
      var $1166=(($1165)|0);
      var $1167=$83;
      var $1168=$84;
      var $1169=(($1166)|0);
      var $1170=$1169;
      var $1171=(($1170)|0);
      var $1172=$1171;
      var $1173=HEAPU8[($1172)];
      var $1174=(($1173)&255);
      var $1175=$1174 & 1;
      var $1176=(($1175)|0)!=0;
      var $1177=$85;
      if ($1176) { __label__ = 68; break; } else { __label__ = 69; break; }
    case 68: // $1178
      var $1179=$79;
      HEAP32[(($79)>>2)]=$1157;
      var $1180=HEAP32[(($79)>>2)];
      var $1181=(($1180)|0);
      var $1182=$78;
      HEAP32[(($78)>>2)]=$1181;
      var $1183=HEAP32[(($78)>>2)];
      var $1184=$1183;
      var $1185=$77;
      HEAP32[(($77)>>2)]=$1184;
      var $1186=HEAP32[(($77)>>2)];
      var $1187=(($1186)|0);
      var $1188=$77;
      var $1189=$78;
      var $1190=(($1187)|0);
      var $1191=$1190;
      var $1192=(($1191+8)|0);
      var $1193=HEAP32[(($1192)>>2)];
      var $1194=$79;
      var $1212 = $1193;__label__ = 70; break;
    case 69: // $1195
      var $1196=$82;
      HEAP32[(($82)>>2)]=$1157;
      var $1197=HEAP32[(($82)>>2)];
      var $1198=(($1197)|0);
      var $1199=$81;
      HEAP32[(($81)>>2)]=$1198;
      var $1200=HEAP32[(($81)>>2)];
      var $1201=$1200;
      var $1202=$80;
      HEAP32[(($80)>>2)]=$1201;
      var $1203=HEAP32[(($80)>>2)];
      var $1204=(($1203)|0);
      var $1205=$80;
      var $1206=$81;
      var $1207=(($1204)|0);
      var $1208=$1207;
      var $1209=(($1208+4)|0);
      var $1210=(($1209)|0);
      var $1211=$82;
      var $1212 = $1210;__label__ = 70; break;
    case 70: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit8
      var $1212;
      var $1213=$86;
      var $1214=$87;
      var $1215=$209;
      var $1216=$98;
      HEAP32[(($98)>>2)]=$1215;
      var $1217=HEAP32[(($98)>>2)];
      var $1218=$97;
      HEAP32[(($97)>>2)]=$1217;
      var $1219=HEAPU32[(($97)>>2)];
      var $1220=$96;
      HEAP32[(($96)>>2)]=$1219;
      var $1221=HEAP32[(($96)>>2)];
      var $1222=(($1221)|0);
      var $1223=$95;
      HEAP32[(($95)>>2)]=$1222;
      var $1224=HEAP32[(($95)>>2)];
      var $1225=$1224;
      var $1226=$94;
      HEAP32[(($94)>>2)]=$1225;
      var $1227=HEAP32[(($94)>>2)];
      var $1228=(($1227)|0);
      var $1229=$94;
      var $1230=$95;
      var $1231=(($1228)|0);
      var $1232=$1231;
      var $1233=(($1232)|0);
      var $1234=$1233;
      var $1235=HEAPU8[($1234)];
      var $1236=(($1235)&255);
      var $1237=$1236 & 1;
      var $1238=(($1237)|0)!=0;
      var $1239=$96;
      if ($1238) { __label__ = 71; break; } else { __label__ = 72; break; }
    case 71: // $1240
      var $1241=$90;
      HEAP32[(($90)>>2)]=$1219;
      var $1242=HEAP32[(($90)>>2)];
      var $1243=(($1242)|0);
      var $1244=$89;
      HEAP32[(($89)>>2)]=$1243;
      var $1245=HEAP32[(($89)>>2)];
      var $1246=$1245;
      var $1247=$88;
      HEAP32[(($88)>>2)]=$1246;
      var $1248=HEAP32[(($88)>>2)];
      var $1249=(($1248)|0);
      var $1250=$88;
      var $1251=$89;
      var $1252=(($1249)|0);
      var $1253=$1252;
      var $1254=(($1253+8)|0);
      var $1255=HEAP32[(($1254)>>2)];
      var $1256=$90;
      var $1274 = $1255;__label__ = 73; break;
    case 72: // $1257
      var $1258=$93;
      HEAP32[(($93)>>2)]=$1219;
      var $1259=HEAP32[(($93)>>2)];
      var $1260=(($1259)|0);
      var $1261=$92;
      HEAP32[(($92)>>2)]=$1260;
      var $1262=HEAP32[(($92)>>2)];
      var $1263=$1262;
      var $1264=$91;
      HEAP32[(($91)>>2)]=$1263;
      var $1265=HEAP32[(($91)>>2)];
      var $1266=(($1265)|0);
      var $1267=$91;
      var $1268=$92;
      var $1269=(($1266)|0);
      var $1270=$1269;
      var $1271=(($1270+4)|0);
      var $1272=(($1271)|0);
      var $1273=$93;
      var $1274 = $1272;__label__ = 73; break;
    case 73: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv_exit
      var $1274;
      var $1275=$97;
      var $1276=$98;
      var $1277=$209;
      var $1278=$108;
      HEAP32[(($108)>>2)]=$1277;
      var $1279=HEAPU32[(($108)>>2)];
      var $1280=$107;
      HEAP32[(($107)>>2)]=$1279;
      var $1281=HEAP32[(($107)>>2)];
      var $1282=(($1281)|0);
      var $1283=$106;
      HEAP32[(($106)>>2)]=$1282;
      var $1284=HEAP32[(($106)>>2)];
      var $1285=$1284;
      var $1286=$105;
      HEAP32[(($105)>>2)]=$1285;
      var $1287=HEAP32[(($105)>>2)];
      var $1288=(($1287)|0);
      var $1289=$105;
      var $1290=$106;
      var $1291=(($1288)|0);
      var $1292=$1291;
      var $1293=(($1292)|0);
      var $1294=$1293;
      var $1295=HEAPU8[($1294)];
      var $1296=(($1295)&255);
      var $1297=$1296 & 1;
      var $1298=(($1297)|0)!=0;
      var $1299=$107;
      if ($1298) { __label__ = 74; break; } else { __label__ = 75; break; }
    case 74: // $1300
      var $1301=$101;
      HEAP32[(($101)>>2)]=$1279;
      var $1302=HEAP32[(($101)>>2)];
      var $1303=(($1302)|0);
      var $1304=$100;
      HEAP32[(($100)>>2)]=$1303;
      var $1305=HEAP32[(($100)>>2)];
      var $1306=$1305;
      var $1307=$99;
      HEAP32[(($99)>>2)]=$1306;
      var $1308=HEAP32[(($99)>>2)];
      var $1309=(($1308)|0);
      var $1310=$99;
      var $1311=$100;
      var $1312=(($1309)|0);
      var $1313=$1312;
      var $1314=(($1313+4)|0);
      var $1315=HEAP32[(($1314)>>2)];
      var $1316=$101;
      var $1337 = $1315;__label__ = 76; break;
    case 75: // $1317
      var $1318=$104;
      HEAP32[(($104)>>2)]=$1279;
      var $1319=HEAP32[(($104)>>2)];
      var $1320=(($1319)|0);
      var $1321=$103;
      HEAP32[(($103)>>2)]=$1320;
      var $1322=HEAP32[(($103)>>2)];
      var $1323=$1322;
      var $1324=$102;
      HEAP32[(($102)>>2)]=$1323;
      var $1325=HEAP32[(($102)>>2)];
      var $1326=(($1325)|0);
      var $1327=$102;
      var $1328=$103;
      var $1329=(($1326)|0);
      var $1330=$1329;
      var $1331=(($1330)|0);
      var $1332=$1331;
      var $1333=HEAPU8[($1332)];
      var $1334=(($1333)&255);
      var $1335=$1334 >> 1;
      var $1336=$104;
      var $1337 = $1335;__label__ = 76; break;
    case 76: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit7
      var $1337;
      var $1338=$108;
      var $1339=(($1274+($1337<<2))|0);
      var $1340=$__ct;
      var $1341=$__neg;
      var $1342=(($1341) & 1);
      var $1343=HEAP32[(($__dp)>>2)];
      var $1344=HEAP32[(($__ts)>>2)];
      var $1345=HEAP32[(($__fd)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i($1145, $__mi, $__me, $1150, $1212, $1339, $1340, $1342, $__pat, $1343, $1344, $__grp, $__sym, $__sn, $1345) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 77; break; } else { __label__ = 60; break; }
    case 77: // $1346
      var $1347=$212;
      var $1348=$__s;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($1347)>>2)]=HEAP32[(($1348)>>2)];
      var $1349=$__mb;
      var $1350=HEAP32[(($__mi)>>2)];
      var $1351=HEAP32[(($__me)>>2)];
      var $1352=$207;
      var $1353=$208;
      (function() { try { __THREW__ = false; return __ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_($agg_result, $212, $1349, $1350, $1351, $1352, $1353) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 78; break; } else { __label__ = 60; break; }
    case 78: // $1354
      $213=1;
      var $1355=$169;
      HEAP32[(($169)>>2)]=$__h;
      var $1356=HEAP32[(($169)>>2)];
      var $1357=$168;
      HEAP32[(($168)>>2)]=$1356;
      var $1358=HEAP32[(($168)>>2)];
      var $1359=$164;
      var $1360=$165;
      var $1361=$__tmp_i_i_i;
      var $1362=$166;
      var $1363=$167;
      HEAP32[(($164)>>2)]=$1358;
      HEAP32[(($165)>>2)]=0;
      var $1364=HEAP32[(($164)>>2)];
      var $1365=(($1364)|0);
      var $1366=$163;
      HEAP32[(($163)>>2)]=$1365;
      var $1367=HEAP32[(($163)>>2)];
      var $1368=$1367;
      var $1369=$162;
      HEAP32[(($162)>>2)]=$1368;
      var $1370=HEAP32[(($162)>>2)];
      var $1371=(($1370)|0);
      var $1372=$162;
      var $1373=$163;
      var $1374=HEAP32[(($1371)>>2)];
      HEAP32[(($__tmp_i_i_i)>>2)]=$1374;
      var $1375=HEAP32[(($165)>>2)];
      var $1376=(($1364)|0);
      var $1377=$161;
      HEAP32[(($161)>>2)]=$1376;
      var $1378=HEAP32[(($161)>>2)];
      var $1379=$1378;
      var $1380=$160;
      HEAP32[(($160)>>2)]=$1379;
      var $1381=HEAP32[(($160)>>2)];
      var $1382=(($1381)|0);
      var $1383=$160;
      var $1384=$161;
      HEAP32[(($1382)>>2)]=$1375;
      var $1385=HEAP32[(($__tmp_i_i_i)>>2)];
      var $1386=(($1385)|0)!=0;
      if ($1386) { __label__ = 79; break; } else { __label__ = 82; break; }
    case 79: // $1387
      var $1388=(($1364)|0);
      var $1389=$159;
      HEAP32[(($159)>>2)]=$1388;
      var $1390=HEAP32[(($159)>>2)];
      var $1391=$1390;
      var $1392=$158;
      HEAP32[(($158)>>2)]=$1391;
      var $1393=HEAP32[(($158)>>2)];
      var $1394=(($1393+4)|0);
      var $1395=$158;
      var $1396=$159;
      var $1397=HEAP32[(($1394)>>2)];
      var $1398=HEAP32[(($__tmp_i_i_i)>>2)];
      var $1399=$1398;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$1397]($1399) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 80; break; } else { __label__ = 81; break; }
    case 80: // $1400
      __label__ = 82; break;
    case 81: // $1401
      var $1402=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $1403=$1402.f0;
      HEAP32[(($166)>>2)]=$1403;
      var $1404=$1402.f1;
      HEAP32[(($167)>>2)]=$1404;
      var $1405=HEAP32[(($166)>>2)];
      ___cxa_call_unexpected($1405);
      throw "Reached an unreachable!"
    case 82: // $_ZNSt3__110unique_ptrIwPFvPvEED1Ev_exit
      var $1406=$164;
      var $1407=$165;
      var $1408=$__tmp_i_i_i;
      var $1409=$166;
      var $1410=$167;
      var $1411=$168;
      var $1412=$169;
      __label__ = 83; break;
    case 83: // $1413
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 85; break; } else { __label__ = 58; break; }
    case 84: // $1414
      __label__ = 86; break;
    case 85: // $1415
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 88; break; } else { __label__ = 57; break; }
    case 86: // $1416
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sn) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 87; break; } else { __label__ = 97; break; }
    case 87: // $1417
      __label__ = 89; break;
    case 88: // $1418
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 91; break; } else { __label__ = 56; break; }
    case 89: // $1419
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($__sym) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 90; break; } else { __label__ = 97; break; }
    case 90: // $1420
      __label__ = 92; break;
    case 91: // $1421
      FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc);
      STACKTOP = __stackBase__;
      return;
    case 92: // $1422
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__grp) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 93; break; } else { __label__ = 97; break; }
    case 93: // $1423
      __label__ = 94; break;
    case 94: // $1424
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16localeD1Ev]($__loc) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 95; break; } else { __label__ = 97; break; }
    case 95: // $1425
      __label__ = 96; break;
    case 96: // $1426
      var $1427=$210;
      var $1428=$210;
      var $1429=$211;
      var $1430=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $1428, tempValue);
      var $1431=($1430.f1 = $1429, $1430);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 97: // $1432
      var $1433=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE["X"]=1;

function ___cxx_global_var_init33() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__18messagesIcE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__18messagesIcE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__18messagesIcE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__18messagesIcE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18messagesIcED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__18messagesIcED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18messagesIcED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE($this, $__nm, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14;
      var $15;
      var $16;
      var $__cat;
      $14=$this;
      $15=$__nm;
      $16=$0;
      var $17=$14;
      var $18=$15;
      var $19=$13;
      HEAP32[(($13)>>2)]=$18;
      var $20=HEAP32[(($13)>>2)];
      var $21=$12;
      HEAP32[(($12)>>2)]=$20;
      var $22=HEAP32[(($12)>>2)];
      var $23=$11;
      HEAP32[(($11)>>2)]=$22;
      var $24=HEAPU32[(($11)>>2)];
      var $25=$10;
      HEAP32[(($10)>>2)]=$24;
      var $26=HEAP32[(($10)>>2)];
      var $27=(($26)|0);
      var $28=$9;
      HEAP32[(($9)>>2)]=$27;
      var $29=HEAP32[(($9)>>2)];
      var $30=$29;
      var $31=$8;
      HEAP32[(($8)>>2)]=$30;
      var $32=HEAP32[(($8)>>2)];
      var $33=(($32)|0);
      var $34=$8;
      var $35=$9;
      var $36=(($33)|0);
      var $37=$36;
      var $38=(($37)|0);
      var $39=$38;
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$41 & 1;
      var $43=(($42)|0)!=0;
      var $44=$10;
      if ($43) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $46=$4;
      HEAP32[(($4)>>2)]=$24;
      var $47=HEAP32[(($4)>>2)];
      var $48=(($47)|0);
      var $49=$3;
      HEAP32[(($3)>>2)]=$48;
      var $50=HEAP32[(($3)>>2)];
      var $51=$50;
      var $52=$2;
      HEAP32[(($2)>>2)]=$51;
      var $53=HEAP32[(($2)>>2)];
      var $54=(($53)|0);
      var $55=$2;
      var $56=$3;
      var $57=(($54)|0);
      var $58=$57;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$4;
      var $79 = $60;__label__ = 3; break;
    case 2: // $62
      var $63=$7;
      HEAP32[(($7)>>2)]=$24;
      var $64=HEAP32[(($7)>>2)];
      var $65=(($64)|0);
      var $66=$6;
      HEAP32[(($6)>>2)]=$65;
      var $67=HEAP32[(($6)>>2)];
      var $68=$67;
      var $69=$5;
      HEAP32[(($5)>>2)]=$68;
      var $70=HEAP32[(($5)>>2)];
      var $71=(($70)|0);
      var $72=$5;
      var $73=$6;
      var $74=(($71)|0);
      var $75=$74;
      var $76=(($75+1)|0);
      var $77=(($76)|0);
      var $78=$7;
      var $79 = $77;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit
      var $79;
      var $80=$11;
      var $81=$12;
      var $82=$13;
      var $83=__Z7catopenPKci($79, 200);
      var $84=$83;
      $__cat=$84;
      var $85=$__cat;
      var $86=(($85)|0)!=-1;
      if ($86) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $87
      var $88=$__cat;
      var $89=$88 >>> 1;
      $__cat=$89;
      __label__ = 5; break;
    case 5: // $90
      var $91=$__cat;
      STACKTOP = __stackBase__;
      return $91;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE["X"]=1;

function __ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE($agg_result, $this, $__c, $__set, $__msgid, $__dflt) {
  var __stackBase__  = STACKTOP; STACKTOP += 412; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $52=__stackBase__+204;
      var $53=__stackBase__+208;
      var $54=__stackBase__+212;
      var $55=__stackBase__+216;
      var $56=__stackBase__+220;
      var $57=__stackBase__+224;
      var $__a_i_i_i2=__stackBase__+228;
      var $__i_i_i_i3=__stackBase__+232;
      var $58=__stackBase__+236;
      var $59=__stackBase__+240;
      var $60=__stackBase__+244;
      var $61=__stackBase__+248;
      var $62=__stackBase__+252;
      var $63=__stackBase__+256;
      var $64=__stackBase__+260;
      var $65=__stackBase__+264;
      var $66=__stackBase__+268;
      var $67=__stackBase__+272;
      var $68=__stackBase__+276;
      var $69=__stackBase__+280;
      var $70=__stackBase__+284;
      var $71=__stackBase__+288;
      var $72=__stackBase__+292;
      var $73=__stackBase__+296;
      var $74=__stackBase__+300;
      var $75=__stackBase__+304;
      var $76=__stackBase__+308;
      var $77=__stackBase__+312;
      var $78=__stackBase__+316;
      var $79=__stackBase__+320;
      var $80=__stackBase__+324;
      var $81=__stackBase__+328;
      var $82=__stackBase__+332;
      var $83=__stackBase__+336;
      var $84=__stackBase__+340;
      var $__a_i_i_i=__stackBase__+344;
      var $__i_i_i_i=__stackBase__+348;
      var $85=__stackBase__+352;
      var $86=__stackBase__+356;
      var $87=__stackBase__+360;
      var $88=__stackBase__+364;
      var $89=__stackBase__+368;
      var $90=__stackBase__+372;
      var $91;
      var $92;
      var $93;
      var $94;
      var $95;
      var $__ndflt=__stackBase__+376;
      var $96=__stackBase__+388;
      var $97=__stackBase__+392;
      var $98;
      var $99;
      var $100=__stackBase__+396;
      var $__cat;
      var $__n;
      var $101;
      var $102=__stackBase__+400;
      var $103=__stackBase__+404;
      var $104=__stackBase__+408;
      var $105;
      $91=$this;
      $92=$__c;
      $93=$__set;
      $94=$__msgid;
      $95=$__dflt;
      var $106=$91;
      var $107=$90;
      HEAP32[(($90)>>2)]=$__ndflt;
      var $108=HEAP32[(($90)>>2)];
      var $109=$89;
      HEAP32[(($89)>>2)]=$108;
      var $110=HEAP32[(($89)>>2)];
      var $111=$110;
      var $112=(($110)|0);
      var $113=$88;
      HEAP32[(($88)>>2)]=$112;
      var $114=HEAP32[(($88)>>2)];
      var $115=$87;
      HEAP32[(($87)>>2)]=$114;
      var $116=HEAP32[(($87)>>2)];
      var $117=$116;
      var $118=$86;
      HEAP32[(($86)>>2)]=$117;
      var $119=HEAP32[(($86)>>2)];
      var $120=$119;
      var $121=$85;
      HEAP32[(($85)>>2)]=$120;
      var $122=HEAP32[(($85)>>2)];
      var $123=$85;
      var $124=(($119)|0);
      var $125=$86;
      var $126=$87;
      var $127=$88;
      var $128=$84;
      var $129=$__a_i_i_i;
      var $130=$__i_i_i_i;
      HEAP32[(($84)>>2)]=$110;
      var $131=HEAP32[(($84)>>2)];
      var $132=(($131)|0);
      var $133=$83;
      HEAP32[(($83)>>2)]=$132;
      var $134=HEAP32[(($83)>>2)];
      var $135=$134;
      var $136=$82;
      HEAP32[(($82)>>2)]=$135;
      var $137=HEAP32[(($82)>>2)];
      var $138=(($137)|0);
      var $139=$82;
      var $140=$83;
      var $141=(($138)|0);
      var $142=$141;
      var $143=(($142)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$143;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $144
      var $145=HEAPU32[(($__i_i_i_i)>>2)];
      var $146=(($145)>>>0) < 3;
      if ($146) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $147
      var $148=HEAP32[(($__i_i_i_i)>>2)];
      var $149=HEAP32[(($__a_i_i_i)>>2)];
      var $150=(($149+($148<<2))|0);
      HEAP32[(($150)>>2)]=0;
      var $151=HEAP32[(($__i_i_i_i)>>2)];
      var $152=(($151+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$152;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $153=$84;
      var $154=$__a_i_i_i;
      var $155=$__i_i_i_i;
      var $156=$89;
      var $157=$90;
      var $158=$73;
      HEAP32[(($73)>>2)]=$__ndflt;
      var $159=HEAP32[(($73)>>2)];
      var $160=$71;
      var $161=$72;
      HEAP32[(($71)>>2)]=$97;
      HEAP32[(($72)>>2)]=$159;
      var $162=HEAP32[(($71)>>2)];
      var $163=HEAP32[(($72)>>2)];
      var $164=$69;
      var $165=$70;
      HEAP32[(($69)>>2)]=$162;
      HEAP32[(($70)>>2)]=$163;
      var $166=HEAP32[(($69)>>2)];
      var $167=$166;
      var $168=(($166)|0);
      var $169=HEAP32[(($70)>>2)];
      HEAP32[(($168)>>2)]=$169;
      var $170=$69;
      var $171=$70;
      var $172=$71;
      var $173=$72;
      var $174=$73;
      __label__ = 4; break;
    case 4: // $175
      var $176=$95;
      var $177=$34;
      HEAP32[(($34)>>2)]=$176;
      var $178=HEAP32[(($34)>>2)];
      var $179=$33;
      HEAP32[(($33)>>2)]=$178;
      var $180=HEAP32[(($33)>>2)];
      var $181=$32;
      HEAP32[(($32)>>2)]=$180;
      var $182=HEAPU32[(($32)>>2)];
      var $183=$31;
      HEAP32[(($31)>>2)]=$182;
      var $184=HEAP32[(($31)>>2)];
      var $185=(($184)|0);
      var $186=$30;
      HEAP32[(($30)>>2)]=$185;
      var $187=HEAP32[(($30)>>2)];
      var $188=$187;
      var $189=$29;
      HEAP32[(($29)>>2)]=$188;
      var $190=HEAP32[(($29)>>2)];
      var $191=(($190)|0);
      var $192=$29;
      var $193=$30;
      var $194=(($191)|0);
      var $195=$194;
      var $196=(($195)|0);
      var $197=$196;
      var $198=HEAPU8[($197)];
      var $199=(($198)&255);
      var $200=$199 & 1;
      var $201=(($200)|0)!=0;
      var $202=$31;
      if ($201) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $203
      var $204=$25;
      HEAP32[(($25)>>2)]=$182;
      var $205=HEAP32[(($25)>>2)];
      var $206=(($205)|0);
      var $207=$24;
      HEAP32[(($24)>>2)]=$206;
      var $208=HEAP32[(($24)>>2)];
      var $209=$208;
      var $210=$23;
      HEAP32[(($23)>>2)]=$209;
      var $211=HEAP32[(($23)>>2)];
      var $212=(($211)|0);
      var $213=$23;
      var $214=$24;
      var $215=(($212)|0);
      var $216=$215;
      var $217=(($216+8)|0);
      var $218=HEAP32[(($217)>>2)];
      var $219=$25;
      var $237 = $218;__label__ = 7; break;
    case 6: // $220
      var $221=$28;
      HEAP32[(($28)>>2)]=$182;
      var $222=HEAP32[(($28)>>2)];
      var $223=(($222)|0);
      var $224=$27;
      HEAP32[(($27)>>2)]=$223;
      var $225=HEAP32[(($27)>>2)];
      var $226=$225;
      var $227=$26;
      HEAP32[(($26)>>2)]=$226;
      var $228=HEAP32[(($26)>>2)];
      var $229=(($228)|0);
      var $230=$26;
      var $231=$27;
      var $232=(($229)|0);
      var $233=$232;
      var $234=(($233+1)|0);
      var $235=(($234)|0);
      var $236=$28;
      var $237 = $235;__label__ = 7; break;
    case 7: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit8
      var $237;
      var $238=$32;
      var $239=$33;
      var $240=$34;
      var $241=$95;
      var $242=$12;
      HEAP32[(($12)>>2)]=$241;
      var $243=HEAP32[(($12)>>2)];
      var $244=$11;
      HEAP32[(($11)>>2)]=$243;
      var $245=HEAP32[(($11)>>2)];
      var $246=$10;
      HEAP32[(($10)>>2)]=$245;
      var $247=HEAPU32[(($10)>>2)];
      var $248=$9;
      HEAP32[(($9)>>2)]=$247;
      var $249=HEAP32[(($9)>>2)];
      var $250=(($249)|0);
      var $251=$8;
      HEAP32[(($8)>>2)]=$250;
      var $252=HEAP32[(($8)>>2)];
      var $253=$252;
      var $254=$7;
      HEAP32[(($7)>>2)]=$253;
      var $255=HEAP32[(($7)>>2)];
      var $256=(($255)|0);
      var $257=$7;
      var $258=$8;
      var $259=(($256)|0);
      var $260=$259;
      var $261=(($260)|0);
      var $262=$261;
      var $263=HEAPU8[($262)];
      var $264=(($263)&255);
      var $265=$264 & 1;
      var $266=(($265)|0)!=0;
      var $267=$9;
      if ($266) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $268
      var $269=$3;
      HEAP32[(($3)>>2)]=$247;
      var $270=HEAP32[(($3)>>2)];
      var $271=(($270)|0);
      var $272=$2;
      HEAP32[(($2)>>2)]=$271;
      var $273=HEAP32[(($2)>>2)];
      var $274=$273;
      var $275=$1;
      HEAP32[(($1)>>2)]=$274;
      var $276=HEAP32[(($1)>>2)];
      var $277=(($276)|0);
      var $278=$1;
      var $279=$2;
      var $280=(($277)|0);
      var $281=$280;
      var $282=(($281+8)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=$3;
      var $302 = $283;__label__ = 10; break;
    case 9: // $285
      var $286=$6;
      HEAP32[(($6)>>2)]=$247;
      var $287=HEAP32[(($6)>>2)];
      var $288=(($287)|0);
      var $289=$5;
      HEAP32[(($5)>>2)]=$288;
      var $290=HEAP32[(($5)>>2)];
      var $291=$290;
      var $292=$4;
      HEAP32[(($4)>>2)]=$291;
      var $293=HEAP32[(($4)>>2)];
      var $294=(($293)|0);
      var $295=$4;
      var $296=$5;
      var $297=(($294)|0);
      var $298=$297;
      var $299=(($298+1)|0);
      var $300=(($299)|0);
      var $301=$6;
      var $302 = $300;__label__ = 10; break;
    case 10: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit9
      var $302;
      var $303=$10;
      var $304=$11;
      var $305=$12;
      var $306=$95;
      var $307=$22;
      HEAP32[(($22)>>2)]=$306;
      var $308=HEAPU32[(($22)>>2)];
      var $309=$21;
      HEAP32[(($21)>>2)]=$308;
      var $310=HEAP32[(($21)>>2)];
      var $311=(($310)|0);
      var $312=$20;
      HEAP32[(($20)>>2)]=$311;
      var $313=HEAP32[(($20)>>2)];
      var $314=$313;
      var $315=$19;
      HEAP32[(($19)>>2)]=$314;
      var $316=HEAP32[(($19)>>2)];
      var $317=(($316)|0);
      var $318=$19;
      var $319=$20;
      var $320=(($317)|0);
      var $321=$320;
      var $322=(($321)|0);
      var $323=$322;
      var $324=HEAPU8[($323)];
      var $325=(($324)&255);
      var $326=$325 & 1;
      var $327=(($326)|0)!=0;
      var $328=$21;
      if ($327) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $329
      var $330=$15;
      HEAP32[(($15)>>2)]=$308;
      var $331=HEAP32[(($15)>>2)];
      var $332=(($331)|0);
      var $333=$14;
      HEAP32[(($14)>>2)]=$332;
      var $334=HEAP32[(($14)>>2)];
      var $335=$334;
      var $336=$13;
      HEAP32[(($13)>>2)]=$335;
      var $337=HEAP32[(($13)>>2)];
      var $338=(($337)|0);
      var $339=$13;
      var $340=$14;
      var $341=(($338)|0);
      var $342=$341;
      var $343=(($342+4)|0);
      var $344=HEAP32[(($343)>>2)];
      var $345=$15;
      var $366 = $344;__label__ = 13; break;
    case 12: // $346
      var $347=$18;
      HEAP32[(($18)>>2)]=$308;
      var $348=HEAP32[(($18)>>2)];
      var $349=(($348)|0);
      var $350=$17;
      HEAP32[(($17)>>2)]=$349;
      var $351=HEAP32[(($17)>>2)];
      var $352=$351;
      var $353=$16;
      HEAP32[(($16)>>2)]=$352;
      var $354=HEAP32[(($16)>>2)];
      var $355=(($354)|0);
      var $356=$16;
      var $357=$17;
      var $358=(($355)|0);
      var $359=$358;
      var $360=(($359)|0);
      var $361=$360;
      var $362=HEAPU8[($361)];
      var $363=(($362)&255);
      var $364=$363 >> 1;
      var $365=$18;
      var $366 = $364;__label__ = 13; break;
    case 13: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv_exit
      var $366;
      var $367=$22;
      var $368=(($302+$366)|0);
      var $tmp5=$42;
      var $tmp6=$97;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp5)]=HEAP8[($tmp6)];HEAP8[($tmp5+1)]=HEAP8[($tmp6+1)];HEAP8[($tmp5+2)]=HEAP8[($tmp6+2)];HEAP8[($tmp5+3)]=HEAP8[($tmp6+3)];
      var $369=$39;
      var $370=$40;
      var $371=$41;
      HEAP32[(($39)>>2)]=$96;
      HEAP32[(($40)>>2)]=$237;
      HEAP32[(($41)>>2)]=$368;
      var $372=HEAP32[(($39)>>2)];
      __label__ = 14; break;
    case 14: // $373
      var $374=HEAPU32[(($40)>>2)];
      var $375=HEAPU32[(($41)>>2)];
      var $376=(($374)>>>0) < (($375)>>>0);
      if ($376) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $377
      var $378=$38;
      HEAP32[(($38)>>2)]=$42;
      var $379=HEAP32[(($38)>>2)];
      var $380=$38;
      var $381=HEAP32[(($40)>>2)];
      var $382=$35;
      var $383=$36;
      HEAP32[(($35)>>2)]=$379;
      HEAP32[(($36)>>2)]=$381;
      var $384=HEAP32[(($35)>>2)];
      var $385=(($384)|0);
      var $386=HEAP32[(($385)>>2)];
      var $387=HEAP32[(($36)>>2)];
      var $388=HEAP8[($387)];
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($386, $388) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; }
    case 16: // $_noexc7
      var $389=$35;
      var $390=$36;
      var $391=HEAP32[(($40)>>2)];
      var $392=(($391+1)|0);
      HEAP32[(($40)>>2)]=$392;
      var $393=$37;
      HEAP32[(($37)>>2)]=$42;
      var $394=HEAP32[(($37)>>2)];
      var $395=$37;
      __label__ = 14; break;
    case 17: // $_ZNKSt3__116__narrow_to_utf8ILj8EEclINS_20back_insert_iteratorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEEcEET_SB_PKT0_SE__exit
      var $396=$100;
      var $397=$42;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($396)>>2)]=HEAP32[(($397)>>2)];
      var $398=$39;
      var $399=$40;
      var $400=$41;
      __label__ = 18; break;
    case 18: // $401
      var $402=$92;
      var $403=(($402)|0)!=-1;
      if ($403) { __label__ = 19; break; } else { __label__ = 21; break; }
    case 19: // $404
      var $405=$92;
      var $406=$405 << 1;
      $92=$406;
      __label__ = 21; break;
    case 20: // $407
      var $408=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $409=$408.f0;
      $98=$409;
      var $410=$408.f1;
      $99=$410;
      __label__ = 42; break;
    case 21: // $411
      var $412=$92;
      var $413=$412;
      $__cat=$413;
      var $414=$__cat;
      var $415=$93;
      var $416=$94;
      var $417=$54;
      HEAP32[(($54)>>2)]=$__ndflt;
      var $418=HEAP32[(($54)>>2)];
      var $419=$53;
      HEAP32[(($53)>>2)]=$418;
      var $420=HEAP32[(($53)>>2)];
      var $421=$52;
      HEAP32[(($52)>>2)]=$420;
      var $422=HEAPU32[(($52)>>2)];
      var $423=$51;
      HEAP32[(($51)>>2)]=$422;
      var $424=HEAP32[(($51)>>2)];
      var $425=(($424)|0);
      var $426=$50;
      HEAP32[(($50)>>2)]=$425;
      var $427=HEAP32[(($50)>>2)];
      var $428=$427;
      var $429=$49;
      HEAP32[(($49)>>2)]=$428;
      var $430=HEAP32[(($49)>>2)];
      var $431=(($430)|0);
      var $432=$49;
      var $433=$50;
      var $434=(($431)|0);
      var $435=$434;
      var $436=(($435)|0);
      var $437=$436;
      var $438=HEAPU8[($437)];
      var $439=(($438)&255);
      var $440=$439 & 1;
      var $441=(($440)|0)!=0;
      var $442=$51;
      if ($441) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $443
      var $444=$45;
      HEAP32[(($45)>>2)]=$422;
      var $445=HEAP32[(($45)>>2)];
      var $446=(($445)|0);
      var $447=$44;
      HEAP32[(($44)>>2)]=$446;
      var $448=HEAP32[(($44)>>2)];
      var $449=$448;
      var $450=$43;
      HEAP32[(($43)>>2)]=$449;
      var $451=HEAP32[(($43)>>2)];
      var $452=(($451)|0);
      var $453=$43;
      var $454=$44;
      var $455=(($452)|0);
      var $456=$455;
      var $457=(($456+8)|0);
      var $458=HEAP32[(($457)>>2)];
      var $459=$45;
      var $477 = $458;__label__ = 24; break;
    case 23: // $460
      var $461=$48;
      HEAP32[(($48)>>2)]=$422;
      var $462=HEAP32[(($48)>>2)];
      var $463=(($462)|0);
      var $464=$47;
      HEAP32[(($47)>>2)]=$463;
      var $465=HEAP32[(($47)>>2)];
      var $466=$465;
      var $467=$46;
      HEAP32[(($46)>>2)]=$466;
      var $468=HEAP32[(($46)>>2)];
      var $469=(($468)|0);
      var $470=$46;
      var $471=$47;
      var $472=(($469)|0);
      var $473=$472;
      var $474=(($473+1)|0);
      var $475=(($474)|0);
      var $476=$48;
      var $477 = $475;__label__ = 24; break;
    case 24: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit
      var $477;
      var $478=$52;
      var $479=$53;
      var $480=$54;
      var $481=(function() { try { __THREW__ = false; return __Z7catgetsP8_nl_catdiiPKc($414, $415, $416, $477) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 20; break; };
    case 25: // $482
      $__n=$481;
      $101=0;
      var $483=$63;
      HEAP32[(($63)>>2)]=$agg_result;
      var $484=HEAP32[(($63)>>2)];
      var $485=$62;
      HEAP32[(($62)>>2)]=$484;
      var $486=HEAP32[(($62)>>2)];
      var $487=$486;
      var $488=(($486)|0);
      var $489=$61;
      HEAP32[(($61)>>2)]=$488;
      var $490=HEAP32[(($61)>>2)];
      var $491=$60;
      HEAP32[(($60)>>2)]=$490;
      var $492=HEAP32[(($60)>>2)];
      var $493=$492;
      var $494=$59;
      HEAP32[(($59)>>2)]=$493;
      var $495=HEAP32[(($59)>>2)];
      var $496=$495;
      var $497=$58;
      HEAP32[(($58)>>2)]=$496;
      var $498=HEAP32[(($58)>>2)];
      var $499=$58;
      var $500=(($495)|0);
      var $501=$59;
      var $502=$60;
      var $503=$61;
      var $504=$57;
      var $505=$__a_i_i_i2;
      var $506=$__i_i_i_i3;
      HEAP32[(($57)>>2)]=$486;
      var $507=HEAP32[(($57)>>2)];
      var $508=(($507)|0);
      var $509=$56;
      HEAP32[(($56)>>2)]=$508;
      var $510=HEAP32[(($56)>>2)];
      var $511=$510;
      var $512=$55;
      HEAP32[(($55)>>2)]=$511;
      var $513=HEAP32[(($55)>>2)];
      var $514=(($513)|0);
      var $515=$55;
      var $516=$56;
      var $517=(($514)|0);
      var $518=$517;
      var $519=(($518)|0);
      HEAP32[(($__a_i_i_i2)>>2)]=$519;
      HEAP32[(($__i_i_i_i3)>>2)]=0;
      __label__ = 26; break;
    case 26: // $520
      var $521=HEAPU32[(($__i_i_i_i3)>>2)];
      var $522=(($521)>>>0) < 3;
      if ($522) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $523
      var $524=HEAP32[(($__i_i_i_i3)>>2)];
      var $525=HEAP32[(($__a_i_i_i2)>>2)];
      var $526=(($525+($524<<2))|0);
      HEAP32[(($526)>>2)]=0;
      var $527=HEAP32[(($__i_i_i_i3)>>2)];
      var $528=(($527+1)|0);
      HEAP32[(($__i_i_i_i3)>>2)]=$528;
      __label__ = 26; break;
    case 28: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit4
      var $529=$57;
      var $530=$__a_i_i_i2;
      var $531=$__i_i_i_i3;
      var $532=$62;
      var $533=$63;
      __label__ = 29; break;
    case 29: // $534
      var $535=$68;
      HEAP32[(($68)>>2)]=$agg_result;
      var $536=HEAP32[(($68)>>2)];
      var $537=$66;
      var $538=$67;
      HEAP32[(($66)>>2)]=$103;
      HEAP32[(($67)>>2)]=$536;
      var $539=HEAP32[(($66)>>2)];
      var $540=HEAP32[(($67)>>2)];
      var $541=$64;
      var $542=$65;
      HEAP32[(($64)>>2)]=$539;
      HEAP32[(($65)>>2)]=$540;
      var $543=HEAP32[(($64)>>2)];
      var $544=$543;
      var $545=(($543)|0);
      var $546=HEAP32[(($65)>>2)];
      HEAP32[(($545)>>2)]=$546;
      var $547=$64;
      var $548=$65;
      var $549=$66;
      var $550=$67;
      var $551=$68;
      __label__ = 30; break;
    case 30: // $552
      var $553=$__n;
      var $554=$__n;
      var $555=$__n;
      var $556=(function() { try { __THREW__ = false; return _strlen($555) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 37; break; };
    case 31: // $557
      var $558=(($554+$556)|0);
      var $tmp=$81;
      var $tmp1=$103;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $559=$78;
      var $560=$79;
      var $561=$80;
      HEAP32[(($78)>>2)]=$102;
      HEAP32[(($79)>>2)]=$553;
      HEAP32[(($80)>>2)]=$558;
      var $562=HEAP32[(($78)>>2)];
      __label__ = 32; break;
    case 32: // $563
      var $564=HEAPU32[(($79)>>2)];
      var $565=HEAPU32[(($80)>>2)];
      var $566=(($564)>>>0) < (($565)>>>0);
      if ($566) { __label__ = 33; break; } else { __label__ = 35; break; }
    case 33: // $567
      var $568=$77;
      HEAP32[(($77)>>2)]=$81;
      var $569=HEAP32[(($77)>>2)];
      var $570=$77;
      var $571=HEAP32[(($79)>>2)];
      var $572=$74;
      var $573=$75;
      HEAP32[(($74)>>2)]=$569;
      HEAP32[(($75)>>2)]=$571;
      var $574=HEAP32[(($74)>>2)];
      var $575=(($574)|0);
      var $576=HEAP32[(($575)>>2)];
      var $577=HEAP32[(($75)>>2)];
      var $578=HEAP8[($577)];
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($576, $578) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 37; break; }
    case 34: // $_noexc
      var $579=$74;
      var $580=$75;
      var $581=HEAP32[(($79)>>2)];
      var $582=(($581+1)|0);
      HEAP32[(($79)>>2)]=$582;
      var $583=$76;
      HEAP32[(($76)>>2)]=$81;
      var $584=HEAP32[(($76)>>2)];
      var $585=$76;
      __label__ = 32; break;
    case 35: // $_ZNKSt3__117__widen_from_utf8ILj8EEclINS_20back_insert_iteratorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEEEET_SB_PKcSD__exit
      var $586=$104;
      var $587=$81;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($586)>>2)]=HEAP32[(($587)>>2)];
      var $588=$78;
      var $589=$79;
      var $590=$80;
      __label__ = 36; break;
    case 36: // $591
      $101=1;
      $105=1;
      var $592=$101;
      if ($592) { __label__ = 40; break; } else { __label__ = 38; break; }
    case 37: // $593
      var $594=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $595=$594.f0;
      $98=$595;
      var $596=$594.f1;
      $99=$596;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($agg_result) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 45; break; }
    case 38: // $597
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($agg_result) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 20; break; }
    case 39: // $598
      __label__ = 40; break;
    case 40: // $599
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt);
      STACKTOP = __stackBase__;
      return;
    case 41: // $600
      __label__ = 42; break;
    case 42: // $601
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 45; break; }
    case 43: // $602
      __label__ = 44; break;
    case 44: // $603
      var $604=$98;
      var $605=$98;
      var $606=$99;
      var $607=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $605, tempValue);
      var $608=($607.f1 = $606, $607);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 45: // $609
      var $610=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE["X"]=1;

function ___cxx_global_var_init34() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=HEAP8[(__ZGVNSt3__18messagesIwE2idE)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      HEAP32[(($4)>>2)]=__ZNSt3__18messagesIwE2idE;
      var $9=HEAP32[(($4)>>2)];
      var $10=$3;
      HEAP32[(($3)>>2)]=$9;
      var $11=HEAP32[(($3)>>2)];
      var $12=(($11)|0);
      var $13=$2;
      HEAP32[(($2)>>2)]=$12;
      var $14=HEAP32[(($2)>>2)];
      var $15=$1;
      HEAP32[(($1)>>2)]=$14;
      var $16=HEAP32[(($1)>>2)];
      var $17=$1;
      var $18=$2;
      var $19=$3;
      var $20=$4;
      var $$emscripten$temp$0$0=1;
      var $$emscripten$temp$0$1=0;
      var $st$19$0=((__ZGVNSt3__18messagesIwE2idE)|0);
      HEAP32[(($st$19$0)>>2)]=$$emscripten$temp$0$0;
      var $st$19$1=((__ZGVNSt3__18messagesIwE2idE+4)|0);
      HEAP32[(($st$19$1)>>2)]=$$emscripten$temp$0$1;
      __label__ = 2; break;
    case 2: // $21
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18messagesIcE8do_closeEi($this, $__c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $__cat;
      $1=$this;
      $2=$__c;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)!=-1;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=$7 << 1;
      $2=$8;
      __label__ = 2; break;
    case 2: // $9
      var $10=$2;
      var $11=$10;
      $__cat=$11;
      var $12=$__cat;
      var $13=__Z8catcloseP8_nl_catd($12);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18messagesIwED0Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      var $5;
      $3=$this;
      var $6=$3;
      var $7=$2;
      HEAP32[(($2)>>2)]=$6;
      var $8=HEAP32[(($2)>>2)];
      var $9=$1;
      HEAP32[(($1)>>2)]=$8;
      var $10=HEAP32[(($1)>>2)];
      var $11=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt3__18messagesIwED1Ev_exit
      var $12=$1;
      var $13=$2;
      __label__ = 2; break;
    case 2: // $14
      var $15=$6;
      __ZdlPv($15);
      STACKTOP = __stackBase__;
      return;
    case 3: // $16
      var $17=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $18=$17.f0;
      $4=$18;
      var $19=$17.f1;
      $5=$19;
      var $20=$6;
      __ZdlPv($20);
      __label__ = 4; break;
    case 4: // $21
      var $22=$4;
      var $23=$4;
      var $24=$5;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18messagesIwED1Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$1;
  HEAP32[(($1)>>2)]=$3;
  var $5=HEAP32[(($1)>>2)];
  var $6=$5;
  __ZNSt3__16locale5facetD2Ev($6);
  var $7=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE($this, $__nm, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11=__stackBase__+36;
      var $12=__stackBase__+40;
      var $13=__stackBase__+44;
      var $14;
      var $15;
      var $16;
      var $__cat;
      $14=$this;
      $15=$__nm;
      $16=$0;
      var $17=$14;
      var $18=$15;
      var $19=$13;
      HEAP32[(($13)>>2)]=$18;
      var $20=HEAP32[(($13)>>2)];
      var $21=$12;
      HEAP32[(($12)>>2)]=$20;
      var $22=HEAP32[(($12)>>2)];
      var $23=$11;
      HEAP32[(($11)>>2)]=$22;
      var $24=HEAPU32[(($11)>>2)];
      var $25=$10;
      HEAP32[(($10)>>2)]=$24;
      var $26=HEAP32[(($10)>>2)];
      var $27=(($26)|0);
      var $28=$9;
      HEAP32[(($9)>>2)]=$27;
      var $29=HEAP32[(($9)>>2)];
      var $30=$29;
      var $31=$8;
      HEAP32[(($8)>>2)]=$30;
      var $32=HEAP32[(($8)>>2)];
      var $33=(($32)|0);
      var $34=$8;
      var $35=$9;
      var $36=(($33)|0);
      var $37=$36;
      var $38=(($37)|0);
      var $39=$38;
      var $40=HEAPU8[($39)];
      var $41=(($40)&255);
      var $42=$41 & 1;
      var $43=(($42)|0)!=0;
      var $44=$10;
      if ($43) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $46=$4;
      HEAP32[(($4)>>2)]=$24;
      var $47=HEAP32[(($4)>>2)];
      var $48=(($47)|0);
      var $49=$3;
      HEAP32[(($3)>>2)]=$48;
      var $50=HEAP32[(($3)>>2)];
      var $51=$50;
      var $52=$2;
      HEAP32[(($2)>>2)]=$51;
      var $53=HEAP32[(($2)>>2)];
      var $54=(($53)|0);
      var $55=$2;
      var $56=$3;
      var $57=(($54)|0);
      var $58=$57;
      var $59=(($58+8)|0);
      var $60=HEAP32[(($59)>>2)];
      var $61=$4;
      var $79 = $60;__label__ = 3; break;
    case 2: // $62
      var $63=$7;
      HEAP32[(($7)>>2)]=$24;
      var $64=HEAP32[(($7)>>2)];
      var $65=(($64)|0);
      var $66=$6;
      HEAP32[(($6)>>2)]=$65;
      var $67=HEAP32[(($6)>>2)];
      var $68=$67;
      var $69=$5;
      HEAP32[(($5)>>2)]=$68;
      var $70=HEAP32[(($5)>>2)];
      var $71=(($70)|0);
      var $72=$5;
      var $73=$6;
      var $74=(($71)|0);
      var $75=$74;
      var $76=(($75+1)|0);
      var $77=(($76)|0);
      var $78=$7;
      var $79 = $77;__label__ = 3; break;
    case 3: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit
      var $79;
      var $80=$11;
      var $81=$12;
      var $82=$13;
      var $83=__Z7catopenPKci($79, 200);
      var $84=$83;
      $__cat=$84;
      var $85=$__cat;
      var $86=(($85)|0)!=-1;
      if ($86) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $87
      var $88=$__cat;
      var $89=$88 >>> 1;
      $__cat=$89;
      __label__ = 5; break;
    case 5: // $90
      var $91=$__cat;
      STACKTOP = __stackBase__;
      return $91;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE["X"]=1;

function __ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE($agg_result, $this, $__c, $__set, $__msgid, $__dflt) {
  var __stackBase__  = STACKTOP; STACKTOP += 728; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $__r_i9=__stackBase__+28;
      var $__mb_i10=__stackBase__+32;
      var $__sz_i11=__stackBase__+40;
      var $__buf_i12=__stackBase__+44;
      var $__bn_i13=__stackBase__+76;
      var $__wn_i=__stackBase__+80;
      var $__p_i14=__stackBase__+84;
      var $8=__stackBase__+88;
      var $9=__stackBase__+92;
      var $10=__stackBase__+96;
      var $11=__stackBase__+100;
      var $12=__stackBase__+104;
      var $13=__stackBase__+108;
      var $14=__stackBase__+112;
      var $15=__stackBase__+116;
      var $16=__stackBase__+120;
      var $17=__stackBase__+124;
      var $18=__stackBase__+128;
      var $19=__stackBase__+132;
      var $20=__stackBase__+136;
      var $21=__stackBase__+140;
      var $22=__stackBase__+144;
      var $23=__stackBase__+148;
      var $__a_i_i_i5=__stackBase__+152;
      var $__i_i_i_i6=__stackBase__+156;
      var $24=__stackBase__+160;
      var $25=__stackBase__+164;
      var $26=__stackBase__+168;
      var $27=__stackBase__+172;
      var $28=__stackBase__+176;
      var $29=__stackBase__+180;
      var $30=__stackBase__+184;
      var $31=__stackBase__+188;
      var $32=__stackBase__+192;
      var $33=__stackBase__+196;
      var $34=__stackBase__+200;
      var $35=__stackBase__+204;
      var $36=__stackBase__+208;
      var $37=__stackBase__+212;
      var $38=__stackBase__+216;
      var $39=__stackBase__+220;
      var $40=__stackBase__+224;
      var $41=__stackBase__+228;
      var $42=__stackBase__+232;
      var $43=__stackBase__+236;
      var $44=__stackBase__+240;
      var $45=__stackBase__+244;
      var $46=__stackBase__+248;
      var $47=__stackBase__+252;
      var $48=__stackBase__+256;
      var $49=__stackBase__+260;
      var $50=__stackBase__+264;
      var $51=__stackBase__+268;
      var $52=__stackBase__+272;
      var $53=__stackBase__+276;
      var $54=__stackBase__+280;
      var $55=__stackBase__+284;
      var $56=__stackBase__+288;
      var $57=__stackBase__+292;
      var $58=__stackBase__+296;
      var $59=__stackBase__+300;
      var $60=__stackBase__+304;
      var $61=__stackBase__+308;
      var $62=__stackBase__+312;
      var $63=__stackBase__+316;
      var $64=__stackBase__+320;
      var $65=__stackBase__+324;
      var $66=__stackBase__+328;
      var $67=__stackBase__+332;
      var $68=__stackBase__+336;
      var $69=__stackBase__+340;
      var $70=__stackBase__+344;
      var $71=__stackBase__+348;
      var $72=__stackBase__+352;
      var $73=__stackBase__+356;
      var $74=__stackBase__+360;
      var $75=__stackBase__+364;
      var $76=__stackBase__+368;
      var $77=__stackBase__+372;
      var $78=__stackBase__+376;
      var $79=__stackBase__+380;
      var $80=__stackBase__+384;
      var $81=__stackBase__+388;
      var $82=__stackBase__+392;
      var $83=__stackBase__+396;
      var $84=__stackBase__+400;
      var $85=__stackBase__+404;
      var $86=__stackBase__+408;
      var $__r_i=__stackBase__+412;
      var $__mb_i=__stackBase__+416;
      var $__sz_i=__stackBase__+424;
      var $__buf_i=__stackBase__+428;
      var $__bn_i=__stackBase__+556;
      var $__nn_i=__stackBase__+560;
      var $__p_i=__stackBase__+564;
      var $87=__stackBase__+568;
      var $88=__stackBase__+572;
      var $89=__stackBase__+576;
      var $90=__stackBase__+580;
      var $91=__stackBase__+584;
      var $92=__stackBase__+588;
      var $93=__stackBase__+592;
      var $94=__stackBase__+596;
      var $95=__stackBase__+600;
      var $96=__stackBase__+604;
      var $97=__stackBase__+608;
      var $98=__stackBase__+612;
      var $99=__stackBase__+616;
      var $100=__stackBase__+620;
      var $101=__stackBase__+624;
      var $102=__stackBase__+628;
      var $103=__stackBase__+632;
      var $104=__stackBase__+636;
      var $105=__stackBase__+640;
      var $106=__stackBase__+644;
      var $107=__stackBase__+648;
      var $__a_i_i_i=__stackBase__+652;
      var $__i_i_i_i=__stackBase__+656;
      var $108=__stackBase__+660;
      var $109=__stackBase__+664;
      var $110=__stackBase__+668;
      var $111=__stackBase__+672;
      var $112=__stackBase__+676;
      var $113=__stackBase__+680;
      var $114;
      var $115;
      var $116;
      var $117;
      var $118;
      var $__ndflt=__stackBase__+684;
      var $119=__stackBase__+696;
      var $120;
      var $121;
      var $122=__stackBase__+704;
      var $123=__stackBase__+708;
      var $__cat;
      var $__n;
      var $124;
      var $125=__stackBase__+712;
      var $126=__stackBase__+720;
      var $127=__stackBase__+724;
      var $128;
      $114=$this;
      $115=$__c;
      $116=$__set;
      $117=$__msgid;
      $118=$__dflt;
      var $129=$114;
      var $130=$113;
      HEAP32[(($113)>>2)]=$__ndflt;
      var $131=HEAP32[(($113)>>2)];
      var $132=$112;
      HEAP32[(($112)>>2)]=$131;
      var $133=HEAP32[(($112)>>2)];
      var $134=$133;
      var $135=(($133)|0);
      var $136=$111;
      HEAP32[(($111)>>2)]=$135;
      var $137=HEAP32[(($111)>>2)];
      var $138=$110;
      HEAP32[(($110)>>2)]=$137;
      var $139=HEAP32[(($110)>>2)];
      var $140=$139;
      var $141=$109;
      HEAP32[(($109)>>2)]=$140;
      var $142=HEAP32[(($109)>>2)];
      var $143=$142;
      var $144=$108;
      HEAP32[(($108)>>2)]=$143;
      var $145=HEAP32[(($108)>>2)];
      var $146=$108;
      var $147=(($142)|0);
      var $148=$109;
      var $149=$110;
      var $150=$111;
      var $151=$107;
      var $152=$__a_i_i_i;
      var $153=$__i_i_i_i;
      HEAP32[(($107)>>2)]=$133;
      var $154=HEAP32[(($107)>>2)];
      var $155=(($154)|0);
      var $156=$106;
      HEAP32[(($106)>>2)]=$155;
      var $157=HEAP32[(($106)>>2)];
      var $158=$157;
      var $159=$105;
      HEAP32[(($105)>>2)]=$158;
      var $160=HEAP32[(($105)>>2)];
      var $161=(($160)|0);
      var $162=$105;
      var $163=$106;
      var $164=(($161)|0);
      var $165=$164;
      var $166=(($165)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$166;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $167
      var $168=HEAPU32[(($__i_i_i_i)>>2)];
      var $169=(($168)>>>0) < 3;
      if ($169) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $170
      var $171=HEAP32[(($__i_i_i_i)>>2)];
      var $172=HEAP32[(($__a_i_i_i)>>2)];
      var $173=(($172+($171<<2))|0);
      HEAP32[(($173)>>2)]=0;
      var $174=HEAP32[(($__i_i_i_i)>>2)];
      var $175=(($174+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$175;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $176=$107;
      var $177=$__a_i_i_i;
      var $178=$__i_i_i_i;
      var $179=$112;
      var $180=$113;
      var $181=$104;
      HEAP32[(($104)>>2)]=$119;
      var $182=HEAP32[(($104)>>2)];
      var $183=$103;
      HEAP32[(($103)>>2)]=$182;
      var $184=HEAPU32[(($103)>>2)];
      var $185=$184;
      var $186=$99;
      var $187=$100;
      var $188=$101;
      var $189=$102;
      HEAP32[(($99)>>2)]=$185;
      HEAP32[(($100)>>2)]=1;
      var $190=HEAPU32[(($99)>>2)];
      var $191=$190;
      var $192=HEAP32[(($100)>>2)];
      var $193=$97;
      var $194=$98;
      HEAP32[(($97)>>2)]=$191;
      HEAP32[(($98)>>2)]=$192;
      var $195=HEAP32[(($97)>>2)];
      var $196=$195;
      var $197=HEAP32[(($98)>>2)];
      var $198=(($197-1)|0);
      var $199=$95;
      var $200=$96;
      HEAP32[(($95)>>2)]=$196;
      HEAP32[(($96)>>2)]=$198;
      var $201=HEAP32[(($95)>>2)];
      var $202=$201;
      HEAP32[(($202)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $203=(($201+4)|0);
      var $204=HEAP32[(($96)>>2)];
      HEAP32[(($203)>>2)]=$204;
      var $205=$95;
      var $206=$96;
      var $207=$195;
      HEAP32[(($207)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $208=$97;
      var $209=$98;
      var $210=$190;
      var $211=$94;
      HEAP32[(($94)>>2)]=$210;
      var $212=HEAP32[(($94)>>2)];
      var $213=$94;
      var $214=$190;
      HEAP32[(($214)>>2)]=((__ZTVNSt3__17codecvtIjc10_mbstate_tEE+8)|0);
      var $215=$99;
      var $216=$100;
      var $217=$101;
      var $218=$102;
      var $219=$184;
      HEAP32[(($219)>>2)]=((__ZTVNSt3__116__narrow_to_utf8ILj32EEE+8)|0);
      var $220=$103;
      var $221=$104;
      __label__ = 4; break;
    case 4: // $222
      var $223=$93;
      HEAP32[(($93)>>2)]=$__ndflt;
      var $224=HEAP32[(($93)>>2)];
      var $225=$91;
      var $226=$92;
      HEAP32[(($91)>>2)]=$122;
      HEAP32[(($92)>>2)]=$224;
      var $227=HEAP32[(($91)>>2)];
      var $228=HEAP32[(($92)>>2)];
      var $229=$89;
      var $230=$90;
      HEAP32[(($89)>>2)]=$227;
      HEAP32[(($90)>>2)]=$228;
      var $231=HEAP32[(($89)>>2)];
      var $232=$231;
      var $233=(($231)|0);
      var $234=HEAP32[(($90)>>2)];
      HEAP32[(($233)>>2)]=$234;
      var $235=$89;
      var $236=$90;
      var $237=$91;
      var $238=$92;
      var $239=$93;
      __label__ = 5; break;
    case 5: // $240
      var $241=$118;
      var $242=$79;
      HEAP32[(($79)>>2)]=$241;
      var $243=HEAP32[(($79)>>2)];
      var $244=$78;
      HEAP32[(($78)>>2)]=$243;
      var $245=HEAP32[(($78)>>2)];
      var $246=$77;
      HEAP32[(($77)>>2)]=$245;
      var $247=HEAPU32[(($77)>>2)];
      var $248=$76;
      HEAP32[(($76)>>2)]=$247;
      var $249=HEAP32[(($76)>>2)];
      var $250=(($249)|0);
      var $251=$75;
      HEAP32[(($75)>>2)]=$250;
      var $252=HEAP32[(($75)>>2)];
      var $253=$252;
      var $254=$74;
      HEAP32[(($74)>>2)]=$253;
      var $255=HEAP32[(($74)>>2)];
      var $256=(($255)|0);
      var $257=$74;
      var $258=$75;
      var $259=(($256)|0);
      var $260=$259;
      var $261=(($260)|0);
      var $262=$261;
      var $263=HEAPU8[($262)];
      var $264=(($263)&255);
      var $265=$264 & 1;
      var $266=(($265)|0)!=0;
      var $267=$76;
      if ($266) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $268
      var $269=$70;
      HEAP32[(($70)>>2)]=$247;
      var $270=HEAP32[(($70)>>2)];
      var $271=(($270)|0);
      var $272=$69;
      HEAP32[(($69)>>2)]=$271;
      var $273=HEAP32[(($69)>>2)];
      var $274=$273;
      var $275=$68;
      HEAP32[(($68)>>2)]=$274;
      var $276=HEAP32[(($68)>>2)];
      var $277=(($276)|0);
      var $278=$68;
      var $279=$69;
      var $280=(($277)|0);
      var $281=$280;
      var $282=(($281+8)|0);
      var $283=HEAP32[(($282)>>2)];
      var $284=$70;
      var $302 = $283;__label__ = 8; break;
    case 7: // $285
      var $286=$73;
      HEAP32[(($73)>>2)]=$247;
      var $287=HEAP32[(($73)>>2)];
      var $288=(($287)|0);
      var $289=$72;
      HEAP32[(($72)>>2)]=$288;
      var $290=HEAP32[(($72)>>2)];
      var $291=$290;
      var $292=$71;
      HEAP32[(($71)>>2)]=$291;
      var $293=HEAP32[(($71)>>2)];
      var $294=(($293)|0);
      var $295=$71;
      var $296=$72;
      var $297=(($294)|0);
      var $298=$297;
      var $299=(($298+4)|0);
      var $300=(($299)|0);
      var $301=$73;
      var $302 = $300;__label__ = 8; break;
    case 8: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5c_strEv_exit
      var $302;
      var $303=$77;
      var $304=$78;
      var $305=$79;
      var $306=$118;
      var $307=$67;
      HEAP32[(($67)>>2)]=$306;
      var $308=HEAP32[(($67)>>2)];
      var $309=$66;
      HEAP32[(($66)>>2)]=$308;
      var $310=HEAP32[(($66)>>2)];
      var $311=$65;
      HEAP32[(($65)>>2)]=$310;
      var $312=HEAPU32[(($65)>>2)];
      var $313=$64;
      HEAP32[(($64)>>2)]=$312;
      var $314=HEAP32[(($64)>>2)];
      var $315=(($314)|0);
      var $316=$63;
      HEAP32[(($63)>>2)]=$315;
      var $317=HEAP32[(($63)>>2)];
      var $318=$317;
      var $319=$62;
      HEAP32[(($62)>>2)]=$318;
      var $320=HEAP32[(($62)>>2)];
      var $321=(($320)|0);
      var $322=$62;
      var $323=$63;
      var $324=(($321)|0);
      var $325=$324;
      var $326=(($325)|0);
      var $327=$326;
      var $328=HEAPU8[($327)];
      var $329=(($328)&255);
      var $330=$329 & 1;
      var $331=(($330)|0)!=0;
      var $332=$64;
      if ($331) { __label__ = 9; break; } else { __label__ = 10; break; }
    case 9: // $333
      var $334=$58;
      HEAP32[(($58)>>2)]=$312;
      var $335=HEAP32[(($58)>>2)];
      var $336=(($335)|0);
      var $337=$57;
      HEAP32[(($57)>>2)]=$336;
      var $338=HEAP32[(($57)>>2)];
      var $339=$338;
      var $340=$56;
      HEAP32[(($56)>>2)]=$339;
      var $341=HEAP32[(($56)>>2)];
      var $342=(($341)|0);
      var $343=$56;
      var $344=$57;
      var $345=(($342)|0);
      var $346=$345;
      var $347=(($346+8)|0);
      var $348=HEAP32[(($347)>>2)];
      var $349=$58;
      var $367 = $348;__label__ = 11; break;
    case 10: // $350
      var $351=$61;
      HEAP32[(($61)>>2)]=$312;
      var $352=HEAP32[(($61)>>2)];
      var $353=(($352)|0);
      var $354=$60;
      HEAP32[(($60)>>2)]=$353;
      var $355=HEAP32[(($60)>>2)];
      var $356=$355;
      var $357=$59;
      HEAP32[(($59)>>2)]=$356;
      var $358=HEAP32[(($59)>>2)];
      var $359=(($358)|0);
      var $360=$59;
      var $361=$60;
      var $362=(($359)|0);
      var $363=$362;
      var $364=(($363+4)|0);
      var $365=(($364)|0);
      var $366=$61;
      var $367 = $365;__label__ = 11; break;
    case 11: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5c_strEv_exit4
      var $367;
      var $368=$65;
      var $369=$66;
      var $370=$67;
      var $371=$118;
      var $372=$55;
      HEAP32[(($55)>>2)]=$371;
      var $373=HEAPU32[(($55)>>2)];
      var $374=$54;
      HEAP32[(($54)>>2)]=$373;
      var $375=HEAP32[(($54)>>2)];
      var $376=(($375)|0);
      var $377=$53;
      HEAP32[(($53)>>2)]=$376;
      var $378=HEAP32[(($53)>>2)];
      var $379=$378;
      var $380=$52;
      HEAP32[(($52)>>2)]=$379;
      var $381=HEAP32[(($52)>>2)];
      var $382=(($381)|0);
      var $383=$52;
      var $384=$53;
      var $385=(($382)|0);
      var $386=$385;
      var $387=(($386)|0);
      var $388=$387;
      var $389=HEAPU8[($388)];
      var $390=(($389)&255);
      var $391=$390 & 1;
      var $392=(($391)|0)!=0;
      var $393=$54;
      if ($392) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $394
      var $395=$48;
      HEAP32[(($48)>>2)]=$373;
      var $396=HEAP32[(($48)>>2)];
      var $397=(($396)|0);
      var $398=$47;
      HEAP32[(($47)>>2)]=$397;
      var $399=HEAP32[(($47)>>2)];
      var $400=$399;
      var $401=$46;
      HEAP32[(($46)>>2)]=$400;
      var $402=HEAP32[(($46)>>2)];
      var $403=(($402)|0);
      var $404=$46;
      var $405=$47;
      var $406=(($403)|0);
      var $407=$406;
      var $408=(($407+4)|0);
      var $409=HEAP32[(($408)>>2)];
      var $410=$48;
      var $431 = $409;__label__ = 14; break;
    case 13: // $411
      var $412=$51;
      HEAP32[(($51)>>2)]=$373;
      var $413=HEAP32[(($51)>>2)];
      var $414=(($413)|0);
      var $415=$50;
      HEAP32[(($50)>>2)]=$414;
      var $416=HEAP32[(($50)>>2)];
      var $417=$416;
      var $418=$49;
      HEAP32[(($49)>>2)]=$417;
      var $419=HEAP32[(($49)>>2)];
      var $420=(($419)|0);
      var $421=$49;
      var $422=$50;
      var $423=(($420)|0);
      var $424=$423;
      var $425=(($424)|0);
      var $426=$425;
      var $427=HEAPU8[($426)];
      var $428=(($427)&255);
      var $429=$428 >> 1;
      var $430=$51;
      var $431 = $429;__label__ = 14; break;
    case 14: // $_ZNKSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv_exit
      var $431;
      var $432=$55;
      var $433=(($367+($431<<2))|0);
      var $tmp7=$8;
      var $tmp8=$122;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp7)]=HEAP8[($tmp8)];HEAP8[($tmp7+1)]=HEAP8[($tmp8+1)];HEAP8[($tmp7+2)]=HEAP8[($tmp8+2)];HEAP8[($tmp7+3)]=HEAP8[($tmp8+3)];
      var $434=$5;
      var $435=$6;
      var $436=$7;
      var $437=$__r_i9;
      var $438=$__mb_i10;
      var $439=$__sz_i11;
      var $440=$__buf_i12;
      var $441=$__bn_i13;
      var $442=$__wn_i;
      var $443=$__p_i14;
      HEAP32[(($5)>>2)]=$119;
      HEAP32[(($6)>>2)]=$302;
      HEAP32[(($7)>>2)]=$433;
      var $444=HEAP32[(($5)>>2)];
      HEAP32[(($__r_i9)>>2)]=0;
      __label__ = 15; break;
    case 15: // $445
      var $446=HEAPU32[(($6)>>2)];
      var $447=HEAPU32[(($7)>>2)];
      var $448=(($446)>>>0) < (($447)>>>0);
      if ($448) { __label__ = 16; break; } else { var $453 = 0;__label__ = 17; break; }
    case 16: // $449
      var $450=HEAP32[(($__r_i9)>>2)];
      var $451=(($450)|0)!=2;
      var $453 = $451;__label__ = 17; break;
    case 17: // $452
      var $453;
      if ($453) { __label__ = 18; break; } else { __label__ = 28; break; }
    case 18: // $454
      HEAP32[(($__sz_i11)>>2)]=32;
      var $455=HEAP32[(($6)>>2)];
      HEAP32[(($__wn_i)>>2)]=$455;
      var $456=$444;
      var $457=$456;
      var $458=HEAP32[(($457)>>2)];
      var $459=(($458+12)|0);
      var $460=HEAP32[(($459)>>2)];
      var $461=HEAP32[(($6)>>2)];
      var $462=HEAP32[(($7)>>2)];
      var $463=(($__buf_i12)|0);
      var $464=(($__buf_i12)|0);
      var $465=(($464+32)|0);
      var $466=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$460]($456, $__mb_i10, $461, $462, $__wn_i, $463, $465, $__bn_i13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 33; break; };
    case 19: // $_noexc15
      HEAP32[(($__r_i9)>>2)]=$466;
      var $467=HEAP32[(($__r_i9)>>2)];
      var $468=(($467)|0)==2;
      if ($468) { __label__ = 21; break; } else { __label__ = 20; break; }
    case 20: // $469
      var $470=HEAP32[(($__wn_i)>>2)];
      var $471=HEAP32[(($6)>>2)];
      var $472=(($470)|0)==(($471)|0);
      if ($472) { __label__ = 21; break; } else { __label__ = 23; break; }
    case 21: // $473
      (function() { try { __THREW__ = false; return __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str66262)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 33; break; }
    case 22: // $_noexc16
      __label__ = 23; break;
    case 23: // $474
      var $475=(($__buf_i12)|0);
      HEAP32[(($__p_i14)>>2)]=$475;
      __label__ = 24; break;
    case 24: // $476
      var $477=HEAPU32[(($__p_i14)>>2)];
      var $478=HEAPU32[(($__bn_i13)>>2)];
      var $479=(($477)>>>0) < (($478)>>>0);
      if ($479) { __label__ = 25; break; } else { __label__ = 27; break; }
    case 25: // $480
      var $481=$4;
      HEAP32[(($4)>>2)]=$8;
      var $482=HEAP32[(($4)>>2)];
      var $483=$4;
      var $484=HEAP32[(($__p_i14)>>2)];
      var $485=$1;
      var $486=$2;
      HEAP32[(($1)>>2)]=$482;
      HEAP32[(($2)>>2)]=$484;
      var $487=HEAP32[(($1)>>2)];
      var $488=(($487)|0);
      var $489=HEAP32[(($488)>>2)];
      var $490=HEAP32[(($2)>>2)];
      var $491=HEAP8[($490)];
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc($489, $491) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 33; break; }
    case 26: // $_noexc17
      var $492=$1;
      var $493=$2;
      var $494=HEAP32[(($__p_i14)>>2)];
      var $495=(($494+1)|0);
      HEAP32[(($__p_i14)>>2)]=$495;
      var $496=$3;
      HEAP32[(($3)>>2)]=$8;
      var $497=HEAP32[(($3)>>2)];
      var $498=$3;
      __label__ = 24; break;
    case 27: // $499
      var $500=HEAP32[(($__wn_i)>>2)];
      HEAP32[(($6)>>2)]=$500;
      __label__ = 15; break;
    case 28: // $_ZNKSt3__116__narrow_to_utf8ILj32EEclINS_20back_insert_iteratorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEEEwEET_SB_PKT0_SE__exit
      var $501=$123;
      var $502=$8;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($501)>>2)]=HEAP32[(($502)>>2)];
      var $503=$5;
      var $504=$6;
      var $505=$7;
      var $506=$__r_i9;
      var $507=$__mb_i10;
      var $508=$__sz_i11;
      var $509=$__buf_i12;
      var $510=$__bn_i13;
      var $511=$__wn_i;
      var $512=$__p_i14;
      __label__ = 29; break;
    case 29: // $513
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__116__narrow_to_utf8ILj32EED1Ev]($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 32; break; }
    case 30: // $514
      var $515=$115;
      var $516=(($515)|0)!=-1;
      if ($516) { __label__ = 31; break; } else { __label__ = 35; break; }
    case 31: // $517
      var $518=$115;
      var $519=$518 << 1;
      $115=$519;
      __label__ = 35; break;
    case 32: // $520
      var $521=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $522=$521.f0;
      $120=$522;
      var $523=$521.f1;
      $121=$523;
      __label__ = 74; break;
    case 33: // $524
      var $525=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $526=$525.f0;
      $120=$526;
      var $527=$525.f1;
      $121=$527;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__116__narrow_to_utf8ILj32EED1Ev]($119) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 77; break; }
    case 34: // $528
      __label__ = 74; break;
    case 35: // $529
      var $530=$115;
      var $531=$530;
      $__cat=$531;
      var $532=$__cat;
      var $533=$116;
      var $534=$117;
      var $535=$20;
      HEAP32[(($20)>>2)]=$__ndflt;
      var $536=HEAP32[(($20)>>2)];
      var $537=$19;
      HEAP32[(($19)>>2)]=$536;
      var $538=HEAP32[(($19)>>2)];
      var $539=$18;
      HEAP32[(($18)>>2)]=$538;
      var $540=HEAPU32[(($18)>>2)];
      var $541=$17;
      HEAP32[(($17)>>2)]=$540;
      var $542=HEAP32[(($17)>>2)];
      var $543=(($542)|0);
      var $544=$16;
      HEAP32[(($16)>>2)]=$543;
      var $545=HEAP32[(($16)>>2)];
      var $546=$545;
      var $547=$15;
      HEAP32[(($15)>>2)]=$546;
      var $548=HEAP32[(($15)>>2)];
      var $549=(($548)|0);
      var $550=$15;
      var $551=$16;
      var $552=(($549)|0);
      var $553=$552;
      var $554=(($553)|0);
      var $555=$554;
      var $556=HEAPU8[($555)];
      var $557=(($556)&255);
      var $558=$557 & 1;
      var $559=(($558)|0)!=0;
      var $560=$17;
      if ($559) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $561
      var $562=$11;
      HEAP32[(($11)>>2)]=$540;
      var $563=HEAP32[(($11)>>2)];
      var $564=(($563)|0);
      var $565=$10;
      HEAP32[(($10)>>2)]=$564;
      var $566=HEAP32[(($10)>>2)];
      var $567=$566;
      var $568=$9;
      HEAP32[(($9)>>2)]=$567;
      var $569=HEAP32[(($9)>>2)];
      var $570=(($569)|0);
      var $571=$9;
      var $572=$10;
      var $573=(($570)|0);
      var $574=$573;
      var $575=(($574+8)|0);
      var $576=HEAP32[(($575)>>2)];
      var $577=$11;
      var $595 = $576;__label__ = 38; break;
    case 37: // $578
      var $579=$14;
      HEAP32[(($14)>>2)]=$540;
      var $580=HEAP32[(($14)>>2)];
      var $581=(($580)|0);
      var $582=$13;
      HEAP32[(($13)>>2)]=$581;
      var $583=HEAP32[(($13)>>2)];
      var $584=$583;
      var $585=$12;
      HEAP32[(($12)>>2)]=$584;
      var $586=HEAP32[(($12)>>2)];
      var $587=(($586)|0);
      var $588=$12;
      var $589=$13;
      var $590=(($587)|0);
      var $591=$590;
      var $592=(($591+1)|0);
      var $593=(($592)|0);
      var $594=$14;
      var $595 = $593;__label__ = 38; break;
    case 38: // $_ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv_exit
      var $595;
      var $596=$18;
      var $597=$19;
      var $598=$20;
      var $599=(function() { try { __THREW__ = false; return __Z7catgetsP8_nl_catdiiPKc($532, $533, $534, $595) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 32; break; };
    case 39: // $600
      $__n=$599;
      $124=0;
      var $601=$29;
      HEAP32[(($29)>>2)]=$agg_result;
      var $602=HEAP32[(($29)>>2)];
      var $603=$28;
      HEAP32[(($28)>>2)]=$602;
      var $604=HEAP32[(($28)>>2)];
      var $605=$604;
      var $606=(($604)|0);
      var $607=$27;
      HEAP32[(($27)>>2)]=$606;
      var $608=HEAP32[(($27)>>2)];
      var $609=$26;
      HEAP32[(($26)>>2)]=$608;
      var $610=HEAP32[(($26)>>2)];
      var $611=$610;
      var $612=$25;
      HEAP32[(($25)>>2)]=$611;
      var $613=HEAP32[(($25)>>2)];
      var $614=$613;
      var $615=$24;
      HEAP32[(($24)>>2)]=$614;
      var $616=HEAP32[(($24)>>2)];
      var $617=$24;
      var $618=(($613)|0);
      var $619=$25;
      var $620=$26;
      var $621=$27;
      var $622=$23;
      var $623=$__a_i_i_i5;
      var $624=$__i_i_i_i6;
      HEAP32[(($23)>>2)]=$604;
      var $625=HEAP32[(($23)>>2)];
      var $626=(($625)|0);
      var $627=$22;
      HEAP32[(($22)>>2)]=$626;
      var $628=HEAP32[(($22)>>2)];
      var $629=$628;
      var $630=$21;
      HEAP32[(($21)>>2)]=$629;
      var $631=HEAP32[(($21)>>2)];
      var $632=(($631)|0);
      var $633=$21;
      var $634=$22;
      var $635=(($632)|0);
      var $636=$635;
      var $637=(($636)|0);
      HEAP32[(($__a_i_i_i5)>>2)]=$637;
      HEAP32[(($__i_i_i_i6)>>2)]=0;
      __label__ = 40; break;
    case 40: // $638
      var $639=HEAPU32[(($__i_i_i_i6)>>2)];
      var $640=(($639)>>>0) < 3;
      if ($640) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $641
      var $642=HEAP32[(($__i_i_i_i6)>>2)];
      var $643=HEAP32[(($__a_i_i_i5)>>2)];
      var $644=(($643+($642<<2))|0);
      HEAP32[(($644)>>2)]=0;
      var $645=HEAP32[(($__i_i_i_i6)>>2)];
      var $646=(($645+1)|0);
      HEAP32[(($__i_i_i_i6)>>2)]=$646;
      __label__ = 40; break;
    case 42: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $647=$23;
      var $648=$__a_i_i_i5;
      var $649=$__i_i_i_i6;
      var $650=$28;
      var $651=$29;
      __label__ = 43; break;
    case 43: // $652
      var $653=$40;
      HEAP32[(($40)>>2)]=$125;
      var $654=HEAP32[(($40)>>2)];
      var $655=$39;
      HEAP32[(($39)>>2)]=$654;
      var $656=HEAPU32[(($39)>>2)];
      var $657=$656;
      var $658=$35;
      var $659=$36;
      var $660=$37;
      var $661=$38;
      HEAP32[(($35)>>2)]=$657;
      HEAP32[(($36)>>2)]=1;
      var $662=HEAPU32[(($35)>>2)];
      var $663=$662;
      var $664=HEAP32[(($36)>>2)];
      var $665=$33;
      var $666=$34;
      HEAP32[(($33)>>2)]=$663;
      HEAP32[(($34)>>2)]=$664;
      var $667=HEAP32[(($33)>>2)];
      var $668=$667;
      var $669=HEAP32[(($34)>>2)];
      var $670=(($669-1)|0);
      var $671=$31;
      var $672=$32;
      HEAP32[(($31)>>2)]=$668;
      HEAP32[(($32)>>2)]=$670;
      var $673=HEAP32[(($31)>>2)];
      var $674=$673;
      HEAP32[(($674)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $675=(($673+4)|0);
      var $676=HEAP32[(($32)>>2)];
      HEAP32[(($675)>>2)]=$676;
      var $677=$31;
      var $678=$32;
      var $679=$667;
      HEAP32[(($679)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $680=$33;
      var $681=$34;
      var $682=$662;
      var $683=$30;
      HEAP32[(($30)>>2)]=$682;
      var $684=HEAP32[(($30)>>2)];
      var $685=$30;
      var $686=$662;
      HEAP32[(($686)>>2)]=((__ZTVNSt3__17codecvtIjc10_mbstate_tEE+8)|0);
      var $687=$35;
      var $688=$36;
      var $689=$37;
      var $690=$38;
      var $691=$656;
      HEAP32[(($691)>>2)]=((__ZTVNSt3__117__widen_from_utf8ILj32EEE+8)|0);
      var $692=$39;
      var $693=$40;
      __label__ = 44; break;
    case 44: // $694
      var $695=$45;
      HEAP32[(($45)>>2)]=$agg_result;
      var $696=HEAP32[(($45)>>2)];
      var $697=$43;
      var $698=$44;
      HEAP32[(($43)>>2)]=$126;
      HEAP32[(($44)>>2)]=$696;
      var $699=HEAP32[(($43)>>2)];
      var $700=HEAP32[(($44)>>2)];
      var $701=$41;
      var $702=$42;
      HEAP32[(($41)>>2)]=$699;
      HEAP32[(($42)>>2)]=$700;
      var $703=HEAP32[(($41)>>2)];
      var $704=$703;
      var $705=(($703)|0);
      var $706=HEAP32[(($42)>>2)];
      HEAP32[(($705)>>2)]=$706;
      var $707=$41;
      var $708=$42;
      var $709=$43;
      var $710=$44;
      var $711=$45;
      __label__ = 45; break;
    case 45: // $712
      var $713=$__n;
      var $714=$__n;
      var $715=$__n;
      var $716=(function() { try { __THREW__ = false; return _strlen($715) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 67; break; };
    case 46: // $717
      var $718=(($714+$716)|0);
      var $tmp=$88;
      var $tmp1=$126;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp)]=HEAP8[($tmp1)];HEAP8[($tmp+1)]=HEAP8[($tmp1+1)];HEAP8[($tmp+2)]=HEAP8[($tmp1+2)];HEAP8[($tmp+3)]=HEAP8[($tmp1+3)];
      var $719=$84;
      var $720=$85;
      var $721=$86;
      var $722=$__r_i;
      var $723=$__mb_i;
      var $724=$__sz_i;
      var $725=$__buf_i;
      var $726=$__bn_i;
      var $727=$__nn_i;
      var $728=$__p_i;
      var $729=$87;
      HEAP32[(($84)>>2)]=$125;
      HEAP32[(($85)>>2)]=$713;
      HEAP32[(($86)>>2)]=$718;
      var $730=HEAP32[(($84)>>2)];
      HEAP32[(($__r_i)>>2)]=0;
      __label__ = 47; break;
    case 47: // $731
      var $732=HEAPU32[(($85)>>2)];
      var $733=HEAPU32[(($86)>>2)];
      var $734=(($732)>>>0) < (($733)>>>0);
      if ($734) { __label__ = 48; break; } else { var $739 = 0;__label__ = 49; break; }
    case 48: // $735
      var $736=HEAP32[(($__r_i)>>2)];
      var $737=(($736)|0)!=2;
      var $739 = $737;__label__ = 49; break;
    case 49: // $738
      var $739;
      if ($739) { __label__ = 50; break; } else { __label__ = 63; break; }
    case 50: // $740
      HEAP32[(($__sz_i)>>2)]=32;
      var $741=HEAP32[(($85)>>2)];
      HEAP32[(($__nn_i)>>2)]=$741;
      var $742=$730;
      var $743=$742;
      var $744=HEAP32[(($743)>>2)];
      var $745=(($744+16)|0);
      var $746=HEAP32[(($745)>>2)];
      var $747=HEAP32[(($85)>>2)];
      var $748=HEAP32[(($86)>>2)];
      var $749=HEAP32[(($85)>>2)];
      var $750=$748;
      var $751=$749;
      var $752=(($750-$751)|0);
      var $753=(($752)|0) > 32;
      if ($753) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $754
      var $755=HEAP32[(($85)>>2)];
      var $756=(($755+32)|0);
      var $760 = $756;__label__ = 53; break;
    case 52: // $757
      var $758=HEAP32[(($86)>>2)];
      var $760 = $758;__label__ = 53; break;
    case 53: // $759
      var $760;
      var $761=(($__buf_i)|0);
      var $762=(($__buf_i)|0);
      var $763=(($762+128)|0);
      var $764=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$746]($742, $__mb_i, $747, $760, $__nn_i, $761, $763, $__bn_i) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 67; break; };
    case 54: // $_noexc
      HEAP32[(($__r_i)>>2)]=$764;
      var $765=HEAP32[(($__r_i)>>2)];
      var $766=(($765)|0)==2;
      if ($766) { __label__ = 56; break; } else { __label__ = 55; break; }
    case 55: // $767
      var $768=HEAP32[(($__nn_i)>>2)];
      var $769=HEAP32[(($85)>>2)];
      var $770=(($768)|0)==(($769)|0);
      if ($770) { __label__ = 56; break; } else { __label__ = 58; break; }
    case 56: // $771
      (function() { try { __THREW__ = false; return __ZNSt3__121__throw_runtime_errorEPKc(((STRING_TABLE.__str66262)|0)) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 67; break; }
    case 57: // $_noexc2
      __label__ = 58; break;
    case 58: // $772
      var $773=(($__buf_i)|0);
      HEAP32[(($__p_i)>>2)]=$773;
      __label__ = 59; break;
    case 59: // $774
      var $775=HEAPU32[(($__p_i)>>2)];
      var $776=HEAPU32[(($__bn_i)>>2)];
      var $777=(($775)>>>0) < (($776)>>>0);
      if ($777) { __label__ = 60; break; } else { __label__ = 62; break; }
    case 60: // $778
      var $779=$83;
      HEAP32[(($83)>>2)]=$88;
      var $780=HEAP32[(($83)>>2)];
      var $781=$83;
      var $782=HEAP32[(($__p_i)>>2)];
      var $783=HEAP32[(($782)>>2)];
      HEAP32[(($87)>>2)]=$783;
      var $784=$80;
      var $785=$81;
      HEAP32[(($80)>>2)]=$780;
      HEAP32[(($81)>>2)]=$87;
      var $786=HEAP32[(($80)>>2)];
      var $787=(($786)|0);
      var $788=HEAP32[(($787)>>2)];
      var $789=HEAP32[(($81)>>2)];
      var $790=HEAP32[(($789)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw($788, $790) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 61; break; } else { __label__ = 67; break; }
    case 61: // $_noexc3
      var $791=$80;
      var $792=$81;
      var $793=HEAP32[(($__p_i)>>2)];
      var $794=(($793+4)|0);
      HEAP32[(($__p_i)>>2)]=$794;
      var $795=$82;
      HEAP32[(($82)>>2)]=$88;
      var $796=HEAP32[(($82)>>2)];
      var $797=$82;
      __label__ = 59; break;
    case 62: // $798
      var $799=HEAP32[(($__nn_i)>>2)];
      HEAP32[(($85)>>2)]=$799;
      __label__ = 47; break;
    case 63: // $_ZNKSt3__117__widen_from_utf8ILj32EEclINS_20back_insert_iteratorINS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEEEEET_SB_PKcSD__exit
      var $800=$127;
      var $801=$88;
      assert(4 % 1 === 0, 'memcpy given ' + 4 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($800)>>2)]=HEAP32[(($801)>>2)];
      var $802=$84;
      var $803=$85;
      var $804=$86;
      var $805=$__r_i;
      var $806=$__mb_i;
      var $807=$__sz_i;
      var $808=$__buf_i;
      var $809=$__bn_i;
      var $810=$__nn_i;
      var $811=$__p_i;
      var $812=$87;
      __label__ = 64; break;
    case 64: // $813
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__117__widen_from_utf8ILj32EED1Ev]($125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 65; break; } else { __label__ = 66; break; }
    case 65: // $814
      $124=1;
      $128=1;
      var $815=$124;
      if ($815) { __label__ = 71; break; } else { __label__ = 69; break; }
    case 66: // $816
      var $817=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $818=$817.f0;
      $120=$818;
      var $819=$817.f1;
      $121=$819;
      __label__ = 72; break;
    case 67: // $820
      var $821=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $822=$821.f0;
      $120=$822;
      var $823=$821.f1;
      $121=$823;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__117__widen_from_utf8ILj32EED1Ev]($125) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 77; break; }
    case 68: // $824
      __label__ = 72; break;
    case 69: // $825
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($agg_result) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 70; break; } else { __label__ = 32; break; }
    case 70: // $826
      __label__ = 71; break;
    case 71: // $827
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt);
      STACKTOP = __stackBase__;
      return;
    case 72: // $828
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($agg_result) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 73; break; } else { __label__ = 77; break; }
    case 73: // $829
      __label__ = 74; break;
    case 74: // $830
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($__ndflt) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 75; break; } else { __label__ = 77; break; }
    case 75: // $831
      __label__ = 76; break;
    case 76: // $832
      var $833=$120;
      var $834=$120;
      var $835=$121;
      var $836=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $834, tempValue);
      var $837=($836.f1 = $835, $836);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 77: // $838
      var $839=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE["X"]=1;
// WARNING: content after a branch in a label, line: 907770

function __ZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $44 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      HEAP32[(($38)>>2)]=((__ZTVNSt3__17collateIcEE+8)|0);
      var $39=$5;
      var $40=$6;
      var $41=$7;
      var $42=$8;
      var $44 = __ZZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $43
      var $44;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $44 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      HEAP32[(($38)>>2)]=((__ZTVNSt3__17collateIwEE+8)|0);
      var $39=$5;
      var $40=$6;
      var $41=$7;
      var $42=$8;
      var $44 = __ZZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $43
      var $44;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__15ctypeIwEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_["X"]=1;

function __ZNKSt3__18messagesIwE8do_closeEi($this, $__c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $__cat;
      $1=$this;
      $2=$__c;
      var $3=$1;
      var $4=$2;
      var $5=(($4)|0)!=-1;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=$7 << 1;
      $2=$8;
      __label__ = 2; break;
    case 2: // $9
      var $10=$2;
      var $11=$10;
      $__cat=$11;
      var $12=$__cat;
      var $13=__Z8catcloseP8_nl_catd($12);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC1Ej($this, $__n) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__n;
  var $3=$1;
  var $4=$2;
  __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej($3, $4);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17collateIcE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17collateIwE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__15ctypeIcE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_($a0, $a1, $a2) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$a0;
      var $4=(($a1)&1);
      $2=$4;
      $3=$a2;
      if (0) { var $11 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $5
      var $6=$1;
      var $7=$2;
      var $8=(($7) & 1);
      var $9=$3;
      FUNCTION_TABLE[__ZNSt3__15ctypeIcEC1EPKjbj](__ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_E3buf, $6, $8, $9);
      var $11 = __ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_E3buf;__label__ = 2; break;
    case 2: // $10
      var $11;
      ;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__15ctypeIwE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__17codecvtIwc10_mbstate_tED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTVNSt3__17codecvtIwc10_mbstate_tEE+8)|0);
      var $6=(($4+8)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=(($7)|0)!=0;
      if ($8) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $9
      var $10=(($4+8)|0);
      var $11=HEAP32[(($10)>>2)];
      (function() { try { __THREW__ = false; return _freelocale($11) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $12
      __label__ = 4; break;
    case 3: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      var $17=$4;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($17) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 4: // $18
      var $19=$4;
      __ZNSt3__16locale5facetD2Ev($19);
      ;
      return;
    case 5: // $20
      __label__ = 6; break;
    case 6: // $21
      var $22=$2;
      var $23=$2;
      var $24=$3;
      var $25=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $23, tempValue);
      var $26=($25.f1 = $24, $25);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $27
      var $28=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5;
      var $6;
      var $7;
      $5=$this;
      var $8=$5;
      var $9=___cxa_allocate_exception(8);
      var $10=$9;
      var $11=$3;
      var $12=$4;
      HEAP32[(($3)>>2)]=$10;
      HEAP32[(($4)>>2)]=((STRING_TABLE.__str351659)|0);
      var $13=HEAP32[(($3)>>2)];
      var $14=HEAP32[(($4)>>2)];
      var $15=$1;
      var $16=$2;
      HEAP32[(($1)>>2)]=$13;
      HEAP32[(($2)>>2)]=$14;
      var $17=HEAP32[(($1)>>2)];
      var $18=$17;
      var $19=HEAP32[(($2)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt11logic_errorC2EPKc($18, $19) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 3; break; }
    case 1: // $_ZNSt12length_errorC1EPKc_exit
      var $20=$17;
      HEAP32[(($20)>>2)]=((__ZTVSt12length_error+8)|0);
      var $21=$1;
      var $22=$2;
      var $23=$3;
      var $24=$4;
      __label__ = 2; break;
    case 2: // $25
      ___cxa_throw($9, __ZTISt12length_error, 1674);
      throw "Reached an unreachable!"
    case 3: // $26
      var $27=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $28=$27.f0;
      $6=$28;
      var $29=$27.f1;
      $7=$29;
      ___cxa_free_exception($9);
      __label__ = 4; break;
    case 4: // $31
      var $32=$6;
      var $33=$6;
      var $34=$7;
      var $35=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $33, tempValue);
      var $36=($35.f1 = $34, $35);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__impC2Ej($this, $refs) {
  var __stackBase__  = STACKTOP; STACKTOP += 100; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26;
      var $27;
      var $28;
      var $29;
      $26=$this;
      $27=$refs;
      var $30=$26;
      var $31=$30;
      var $32=$27;
      var $33=$24;
      var $34=$25;
      HEAP32[(($24)>>2)]=$31;
      HEAP32[(($25)>>2)]=$32;
      var $35=HEAP32[(($24)>>2)];
      var $36=$35;
      var $37=HEAP32[(($25)>>2)];
      var $38=(($37-1)|0);
      var $39=$22;
      var $40=$23;
      HEAP32[(($22)>>2)]=$36;
      HEAP32[(($23)>>2)]=$38;
      var $41=HEAP32[(($22)>>2)];
      var $42=$41;
      HEAP32[(($42)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $43=(($41+4)|0);
      var $44=HEAP32[(($23)>>2)];
      HEAP32[(($43)>>2)]=$44;
      var $45=$22;
      var $46=$23;
      var $47=$35;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $48=$24;
      var $49=$25;
      var $50=$30;
      HEAP32[(($50)>>2)]=((__ZTVNSt3__16locale5__impE+8)|0);
      var $51=(($30+8)|0);
      var $52=$20;
      var $53=$21;
      HEAP32[(($20)>>2)]=$51;
      HEAP32[(($21)>>2)]=((STRING_TABLE.__str361660)|0);
      var $54=HEAP32[(($20)>>2)];
      var $55=HEAP32[(($21)>>2)];
      var $56=$18;
      var $57=$19;
      HEAP32[(($18)>>2)]=$54;
      HEAP32[(($19)>>2)]=$55;
      var $58=HEAP32[(($18)>>2)];
      var $59=$58;
      var $60=(($58)|0);
      var $61=$17;
      HEAP32[(($17)>>2)]=$60;
      var $62=HEAP32[(($17)>>2)];
      var $63=$16;
      HEAP32[(($16)>>2)]=$62;
      var $64=HEAP32[(($16)>>2)];
      var $65=$64;
      var $66=$15;
      HEAP32[(($15)>>2)]=$65;
      var $67=HEAP32[(($15)>>2)];
      var $68=$67;
      var $69=$14;
      HEAP32[(($14)>>2)]=$68;
      var $70=HEAP32[(($14)>>2)];
      var $71=$14;
      var $72=(($67)|0);
      var $73=$15;
      var $74=$16;
      var $75=$17;
      var $76=HEAP32[(($19)>>2)];
      var $77=HEAP32[(($19)>>2)];
      var $78=$13;
      HEAP32[(($13)>>2)]=$77;
      var $79=HEAP32[(($13)>>2)];
      var $80=(function() { try { __THREW__ = false; return _strlen($79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 61; break; };
    case 1: // $_noexc
      var $81=$13;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($58, $76, $80) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 61; break; }
    case 2: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1EPKc_exit
      var $82=$18;
      var $83=$19;
      var $84=$20;
      var $85=$21;
      __label__ = 3; break;
    case 3: // $86
      var $87=(($30+20)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC1Ej($87, 28) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 62; break; }
    case 4: // $88
      var $89=(($30+20)|0);
      var $90=$10;
      var $91=$11;
      var $92=$12;
      HEAP32[(($10)>>2)]=$89;
      var $93=HEAP32[(($10)>>2)];
      var $94=$93;
      var $95=$9;
      HEAP32[(($9)>>2)]=$94;
      var $96=HEAP32[(($9)>>2)];
      var $97=(($96)|0);
      var $98=HEAP32[(($97)>>2)];
      var $99=$4;
      var $100=$5;
      var $101=$6;
      var $102=$7;
      var $103=$8;
      HEAP32[(($5)>>2)]=$96;
      HEAP32[(($6)>>2)]=$98;
      var $104=HEAP32[(($5)>>2)];
      var $105=HEAP32[(($6)>>2)];
      var $106=$8;
      var $tmp_i_i_i=$4;
      var $tmp1_i_i_i=$7;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i_i)]=HEAP8[($tmp1_i_i_i)];
      var $107=$2;
      var $108=$3;
      HEAP32[(($2)>>2)]=$104;
      HEAP32[(($3)>>2)]=$105;
      var $109=HEAP32[(($2)>>2)];
      var $110=HEAP32[(($3)>>2)];
      var $111=(($109+4)|0);
      HEAP32[(($111)>>2)]=$110;
      var $112=$2;
      var $113=$3;
      var $114=$4;
      var $115=$5;
      var $116=$6;
      var $117=$7;
      var $118=$8;
      var $119=$9;
      var $120=$1;
      HEAP32[(($1)>>2)]=$93;
      var $121=HEAP32[(($1)>>2)];
      var $122=$1;
      var $123=$10;
      var $124=$11;
      var $125=$12;
      var $126=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 63; break; };
    case 5: // $127
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_($30, $126) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 63; break; }
    case 6: // $128
      var $129=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 63; break; };
    case 7: // $130
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_($30, $129) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 63; break; }
    case 8: // $131
      var $132=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_(0, 0, 1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 63; break; };
    case 9: // $133
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_($30, $132) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 63; break; }
    case 10: // $134
      var $135=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 63; break; };
    case 11: // $136
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_($30, $135) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 63; break; }
    case 12: // $137
      var $138=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 63; break; };
    case 13: // $139
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7codecvtIcc10_mbstate_tEEEEvPT_($30, $138) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 63; break; }
    case 14: // $140
      var $141=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 63; break; };
    case 15: // $142
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7codecvtIwc10_mbstate_tEEEEvPT_($30, $141) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 63; break; }
    case 16: // $143
      var $144=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 63; break; };
    case 17: // $145
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7codecvtItc10_mbstate_tEEEEvPT_($30, $144) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 63; break; }
    case 18: // $146
      var $147=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 19; break; } else { __label__ = 63; break; };
    case 19: // $148
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7codecvtIjc10_mbstate_tEEEEvPT_($30, $147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 20; break; } else { __label__ = 63; break; }
    case 20: // $149
      var $150=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 21; break; } else { __label__ = 63; break; };
    case 21: // $151
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_($30, $150) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 63; break; }
    case 22: // $152
      var $153=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 23; break; } else { __label__ = 63; break; };
    case 23: // $154
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_($30, $153) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 63; break; }
    case 24: // $155
      var $156=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 25; break; } else { __label__ = 63; break; };
    case 25: // $157
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($30, $156) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 63; break; }
    case 26: // $158
      var $159=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 27; break; } else { __label__ = 63; break; };
    case 27: // $160
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($30, $159) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 28; break; } else { __label__ = 63; break; }
    case 28: // $161
      var $162=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 29; break; } else { __label__ = 63; break; };
    case 29: // $163
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($30, $162) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 63; break; }
    case 30: // $164
      var $165=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 31; break; } else { __label__ = 63; break; };
    case 31: // $166
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($30, $165) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 32; break; } else { __label__ = 63; break; }
    case 32: // $167
      var $168=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 33; break; } else { __label__ = 63; break; };
    case 33: // $169
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_($30, $168) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 34; break; } else { __label__ = 63; break; }
    case 34: // $170
      var $171=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 35; break; } else { __label__ = 63; break; };
    case 35: // $172
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_($30, $171) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 36; break; } else { __label__ = 63; break; }
    case 36: // $173
      var $174=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 37; break; } else { __label__ = 63; break; };
    case 37: // $175
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_($30, $174) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 38; break; } else { __label__ = 63; break; }
    case 38: // $176
      var $177=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 39; break; } else { __label__ = 63; break; };
    case 39: // $178
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_($30, $177) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 40; break; } else { __label__ = 63; break; }
    case 40: // $179
      var $180=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 41; break; } else { __label__ = 63; break; };
    case 41: // $181
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($30, $180) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 42; break; } else { __label__ = 63; break; }
    case 42: // $182
      var $183=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 43; break; } else { __label__ = 63; break; };
    case 43: // $184
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($30, $183) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 63; break; }
    case 44: // $185
      var $186=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 45; break; } else { __label__ = 63; break; };
    case 45: // $187
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($30, $186) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 63; break; }
    case 46: // $188
      var $189=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 63; break; };
    case 47: // $190
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($30, $189) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 48; break; } else { __label__ = 63; break; }
    case 48: // $191
      var $192=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 63; break; };
    case 49: // $193
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($30, $192) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 63; break; }
    case 50: // $194
      var $195=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 51; break; } else { __label__ = 63; break; };
    case 51: // $196
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($30, $195) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 52; break; } else { __label__ = 63; break; }
    case 52: // $197
      var $198=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 63; break; };
    case 53: // $199
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($30, $198) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 54; break; } else { __label__ = 63; break; }
    case 54: // $200
      var $201=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 55; break; } else { __label__ = 63; break; };
    case 55: // $202
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($30, $201) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 56; break; } else { __label__ = 63; break; }
    case 56: // $203
      var $204=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 57; break; } else { __label__ = 63; break; };
    case 57: // $205
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_($30, $204) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 58; break; } else { __label__ = 63; break; }
    case 58: // $206
      var $207=(function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_(1) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 59; break; } else { __label__ = 63; break; };
    case 59: // $208
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_($30, $207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 60; break; } else { __label__ = 63; break; }
    case 60: // $209
      STACKTOP = __stackBase__;
      return;
    case 61: // $210
      var $211=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $212=$211.f0;
      $28=$212;
      var $213=$211.f1;
      $29=$213;
      __label__ = 67; break;
    case 62: // $214
      var $215=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $216=$215.f0;
      $28=$216;
      var $217=$215.f1;
      $29=$217;
      __label__ = 65; break;
    case 63: // $218
      var $219=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $220=$219.f0;
      $28=$220;
      var $221=$219.f1;
      $29=$221;
      var $222=(($30+20)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED1Ev($222) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 64; break; } else { __label__ = 70; break; }
    case 64: // $223
      __label__ = 65; break;
    case 65: // $224
      var $225=(($30+8)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($225) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 66; break; } else { __label__ = 70; break; }
    case 66: // $226
      __label__ = 67; break;
    case 67: // $227
      var $228=$30;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($228) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 68; break; } else { __label__ = 70; break; }
    case 68: // $229
      __label__ = 69; break;
    case 69: // $230
      var $231=$28;
      var $232=$28;
      var $233=$29;
      var $234=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $232, tempValue);
      var $235=($234.f1 = $233, $234);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 70: // $236
      var $237=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16locale5__impC2Ej["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__17codecvtIcc10_mbstate_tEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__17codecvtItc10_mbstate_tEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__17codecvtIjc10_mbstate_tEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $45 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      var $39=$18;
      HEAP32[(($39)>>2)]=((__ZTVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+8)|0);
      var $40=$5;
      var $41=$6;
      var $42=$7;
      var $43=$8;
      var $45 = __ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $44
      var $45;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $45 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      var $39=$18;
      HEAP32[(($39)>>2)]=((__ZTVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+8)|0);
      var $40=$5;
      var $41=$6;
      var $42=$7;
      var $43=$8;
      var $45 = __ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $44
      var $45;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $45 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      var $39=$18;
      HEAP32[(($39)>>2)]=((__ZTVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+8)|0);
      var $40=$5;
      var $41=$6;
      var $42=$7;
      var $43=$8;
      var $45 = __ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $44
      var $45;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $45 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      var $39=$18;
      HEAP32[(($39)>>2)]=((__ZTVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+8)|0);
      var $40=$5;
      var $41=$6;
      var $42=$7;
      var $43=$8;
      var $45 = __ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $44
      var $45;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__110moneypunctIcLb0EEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_["X"]=1;

function __ZNSt3__16locale5__imp7installINS_7codecvtIcc10_mbstate_tEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17codecvtIcc10_mbstate_tE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7codecvtIwc10_mbstate_tEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17codecvtIwc10_mbstate_tE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_($a0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$a0;
      if (0) { var $5 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $2
      var $3=$1;
      FUNCTION_TABLE[__ZNSt3__17codecvtIwc10_mbstate_tEC1Ej](__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_E3buf, $3);
      var $5 = __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $4
      var $5;
      ;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__imp7installINS_7codecvtItc10_mbstate_tEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17codecvtItc10_mbstate_tE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7codecvtIjc10_mbstate_tEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17codecvtIjc10_mbstate_tE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18numpunctIcE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_($a0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$a0;
      if (0) { var $5 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $2
      var $3=$1;
      FUNCTION_TABLE[__ZNSt3__18numpunctIcEC1Ej](__ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_E3buf, $3);
      var $5 = __ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $4
      var $5;
      ;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18numpunctIwE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_($a0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$a0;
      if (0) { var $5 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $2
      var $3=$1;
      FUNCTION_TABLE[__ZNSt3__18numpunctIwEC1Ej](__ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_E3buf, $3);
      var $5 = __ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $4
      var $5;
      ;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__110moneypunctIcLb0EE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__110moneypunctIcLb1EE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__110moneypunctIcLb1EEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__110moneypunctIwLb0EEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__110moneypunctIwLb1EEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__110moneypunctIwLb0EE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__110moneypunctIwLb1EE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $51 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      var $39=$18;
      var $40=(($39+8)|0);
      var $41=$40;
      __ZNSt3__120__time_get_c_storageIcEC2Ev($41);
      var $42=$18;
      HEAP32[(($42)>>2)]=((__ZTVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+8)|0);
      var $43=$18;
      var $44=(($43+8)|0);
      var $45=$44;
      HEAP32[(($45)>>2)]=((__ZTVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+56)|0);
      var $46=$5;
      var $47=$6;
      var $48=$7;
      var $49=$8;
      var $51 = __ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $50
      var $51;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 32; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9;
      $9=$a0;
      if (0) { var $51 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $10
      var $11=$9;
      var $12=$7;
      var $13=$8;
      HEAP32[(($7)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
      HEAP32[(($8)>>2)]=$11;
      var $14=HEAP32[(($7)>>2)];
      var $15=HEAP32[(($8)>>2)];
      var $16=$5;
      var $17=$6;
      HEAP32[(($5)>>2)]=$14;
      HEAP32[(($6)>>2)]=$15;
      var $18=HEAP32[(($5)>>2)];
      var $19=$18;
      var $20=HEAP32[(($6)>>2)];
      var $21=$3;
      var $22=$4;
      HEAP32[(($3)>>2)]=$19;
      HEAP32[(($4)>>2)]=$20;
      var $23=HEAP32[(($3)>>2)];
      var $24=$23;
      var $25=HEAP32[(($4)>>2)];
      var $26=(($25-1)|0);
      var $27=$1;
      var $28=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$26;
      var $29=HEAP32[(($1)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($2)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$1;
      var $34=$2;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$3;
      var $37=$4;
      var $38=$18;
      var $39=$18;
      var $40=(($39+8)|0);
      var $41=$40;
      __ZNSt3__120__time_get_c_storageIwEC2Ev($41);
      var $42=$18;
      HEAP32[(($42)>>2)]=((__ZTVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+8)|0);
      var $43=$18;
      var $44=(($43+8)|0);
      var $45=$44;
      HEAP32[(($45)>>2)]=((__ZTVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+56)|0);
      var $46=$5;
      var $47=$6;
      var $48=$7;
      var $49=$8;
      var $51 = __ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $50
      var $51;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}

// WARNING: content after a branch in a label, line: 911470
// WARNING: content after a branch in a label, line: 911472
// WARNING: content after a branch in a label, line: 911473
// WARNING: content after a branch in a label, line: 911474
// WARNING: content after a branch in a label, line: 911475
// WARNING: content after a branch in a label, line: 911476
// WARNING: content after a branch in a label, line: 911477

function __ZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__18messagesIcEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $55 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=$1;
      HEAP32[(($1)>>2)]=$43;
      var $45=HEAP32[(($1)>>2)];
      var $46=$1;
      var $47=$23;
      HEAP32[(($47)>>2)]=((__ZTVNSt3__18messagesIwEE+8)|0);
      var $48=$6;
      var $49=$7;
      var $50=$8;
      var $51=$9;
      var $52=$10;
      var $53=$11;
      var $55 = __ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $54
      var $55;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_["X"]=1;

function __ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18messagesIcE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_($this, $f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$f;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv(__ZNSt3__18messagesIwE2idE);
  __ZNSt3__16locale5__imp7installEPNS0_5facetEl($3, $5, $7);
  ;
  return;
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__16locale7classicEv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=HEAP8[(__ZGVZNSt3__16locale7classicEvE1c)];
      var $4=(($3 << 24) >> 24)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $5
      var $6=___cxa_guard_acquire(__ZGVZNSt3__16locale7classicEvE1c);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp12make_classicEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $10
      HEAP32[((__ZZNSt3__16locale7classicEvE1c)>>2)]=$9;
      ;
      __label__ = 4; break;
    case 4: // $11
      var $12=HEAP32[((__ZZNSt3__16locale7classicEvE1c)>>2)];
      ;
      return $12;
    case 5: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $1=$15;
      var $16=$14.f1;
      $2=$16;
      ;
      __label__ = 6; break;
    case 6: // $17
      var $18=$1;
      var $19=$1;
      var $20=$2;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__impD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16locale5__impD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $72 = 0;__label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=(($43+8)|0);
      var $45=$44;
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(($47)|0);
      var $49=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 2; break; };
    case 2: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      HEAP32[(($8)>>2)]=$52;
      var $53=$51.f1;
      HEAP32[(($9)>>2)]=$53;
      var $54=$23;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $55
      var $56=HEAP32[(($8)>>2)];
      var $57=HEAP32[(($8)>>2)];
      var $58=HEAP32[(($9)>>2)];
      var $59=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $57, tempValue);
      var $60=($59.f1 = $58, $59);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC1Ej_exit
      HEAP32[(($48)>>2)]=$49;
      var $63=$1;
      var $64=$23;
      HEAP32[(($64)>>2)]=((__ZTVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+8)|0);
      var $65=$6;
      var $66=$7;
      var $67=$8;
      var $68=$9;
      var $69=$10;
      var $70=$11;
      var $72 = __ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;__label__ = 6; break;
    case 6: // $71
      var $72;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_($a0) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12;
      $12=$a0;
      if (0) { var $72 = 0;__label__ = 6; break; } else { __label__ = 1; break; }
    case 1: // $13
      var $14=$12;
      var $15=$10;
      var $16=$11;
      HEAP32[(($10)>>2)]=__ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
      HEAP32[(($11)>>2)]=$14;
      var $17=HEAP32[(($10)>>2)];
      var $18=HEAP32[(($11)>>2)];
      var $19=$6;
      var $20=$7;
      var $21=$8;
      var $22=$9;
      HEAP32[(($6)>>2)]=$17;
      HEAP32[(($7)>>2)]=$18;
      var $23=HEAP32[(($6)>>2)];
      var $24=$23;
      var $25=HEAP32[(($7)>>2)];
      var $26=$4;
      var $27=$5;
      HEAP32[(($4)>>2)]=$24;
      HEAP32[(($5)>>2)]=$25;
      var $28=HEAP32[(($4)>>2)];
      var $29=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=(($30-1)|0);
      var $32=$2;
      var $33=$3;
      HEAP32[(($2)>>2)]=$29;
      HEAP32[(($3)>>2)]=$31;
      var $34=HEAP32[(($2)>>2)];
      var $35=$34;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $36=(($34+4)|0);
      var $37=HEAP32[(($3)>>2)];
      HEAP32[(($36)>>2)]=$37;
      var $38=$2;
      var $39=$3;
      var $40=$28;
      HEAP32[(($40)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $41=$4;
      var $42=$5;
      var $43=$23;
      var $44=(($43+8)|0);
      var $45=$44;
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(($47)|0);
      var $49=(function() { try { __THREW__ = false; return __ZNSt3__16__clocEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 2; break; };
    case 2: // $50
      var $51=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $52=$51.f0;
      HEAP32[(($8)>>2)]=$52;
      var $53=$51.f1;
      HEAP32[(($9)>>2)]=$53;
      var $54=$23;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($54) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $55
      var $56=HEAP32[(($8)>>2)];
      var $57=HEAP32[(($8)>>2)];
      var $58=HEAP32[(($9)>>2)];
      var $59=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $57, tempValue);
      var $60=($59.f1 = $58, $59);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4: // $61
      var $62=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    case 5: // $_ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC1Ej_exit
      HEAP32[(($48)>>2)]=$49;
      var $63=$1;
      var $64=$23;
      HEAP32[(($64)>>2)]=((__ZTVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+8)|0);
      var $65=$6;
      var $66=$7;
      var $67=$8;
      var $68=$9;
      var $69=$10;
      var $70=$11;
      var $72 = __ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;__label__ = 6; break;
    case 6: // $71
      var $72;
      STACKTOP = __stackBase__;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_["X"]=1;

function __ZNSt3__16locale5__imp7installEPNS0_5facetEl($this, $f, $id) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $__t_i=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13;
      var $14;
      var $15;
      var $hold=__stackBase__+52;
      var $16;
      var $17;
      $13=$this;
      $14=$f;
      $15=$id;
      var $18=$13;
      var $19=$14;
      var $20=$19;
      __ZNSt3__114__shared_count12__add_sharedEv($20);
      var $21=$14;
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEEC1EPS2_]($hold, $21);
      var $22=$15;
      var $23=(($18+20)|0);
      var $24=$12;
      HEAP32[(($12)>>2)]=$23;
      var $25=HEAP32[(($12)>>2)];
      var $26=$25;
      var $27=(($26+4)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$25;
      var $30=(($29)|0);
      var $31=HEAP32[(($30)>>2)];
      var $32=$28;
      var $33=$31;
      var $34=(($32-$33)|0);
      var $35=(((($34)|0)/4)|0);
      var $36=$12;
      var $37=(($22)>>>0) >= (($35)>>>0);
      if ($37) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $38
      var $39=(($18+20)|0);
      var $40=$15;
      var $41=(($40+1)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj($39, $41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $42
      __label__ = 4; break;
    case 3: // $43
      var $44=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $45=$44.f0;
      $16=$45;
      var $46=$44.f1;
      $17=$46;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED1Ev]($hold) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 4: // $47
      var $48=(($18+20)|0);
      var $49=$15;
      var $50=$10;
      var $51=$11;
      HEAP32[(($10)>>2)]=$48;
      HEAP32[(($11)>>2)]=$49;
      var $52=HEAP32[(($10)>>2)];
      var $53=HEAP32[(($11)>>2)];
      var $54=$52;
      var $55=(($54)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56+($53<<2))|0);
      var $58=$10;
      var $59=$11;
      __label__ = 5; break;
    case 5: // $60
      var $61=HEAP32[(($57)>>2)];
      var $62=(($61)|0)!=0;
      if ($62) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 6: // $63
      var $64=(($18+20)|0);
      var $65=$15;
      var $66=$1;
      var $67=$2;
      HEAP32[(($1)>>2)]=$64;
      HEAP32[(($2)>>2)]=$65;
      var $68=HEAP32[(($1)>>2)];
      var $69=HEAP32[(($2)>>2)];
      var $70=$68;
      var $71=(($70)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72+($69<<2))|0);
      var $74=$1;
      var $75=$2;
      __label__ = 7; break;
    case 7: // $76
      var $77=HEAP32[(($73)>>2)];
      var $78=$77;
      var $79=__ZNSt3__114__shared_count16__release_sharedEv($78);
      __label__ = 8; break;
    case 8: // $80
      var $81=$7;
      var $82=$__t_i;
      HEAP32[(($7)>>2)]=$hold;
      var $83=HEAP32[(($7)>>2)];
      var $84=(($83)|0);
      var $85=$6;
      HEAP32[(($6)>>2)]=$84;
      var $86=HEAP32[(($6)>>2)];
      var $87=$86;
      var $88=$5;
      HEAP32[(($5)>>2)]=$87;
      var $89=HEAP32[(($5)>>2)];
      var $90=(($89)|0);
      var $91=$5;
      var $92=$6;
      var $93=HEAP32[(($90)>>2)];
      HEAP32[(($__t_i)>>2)]=$93;
      var $94=(($83)|0);
      var $95=$4;
      HEAP32[(($4)>>2)]=$94;
      var $96=HEAP32[(($4)>>2)];
      var $97=$96;
      var $98=$3;
      HEAP32[(($3)>>2)]=$97;
      var $99=HEAP32[(($3)>>2)];
      var $100=(($99)|0);
      var $101=$3;
      var $102=$4;
      HEAP32[(($100)>>2)]=0;
      var $103=HEAP32[(($__t_i)>>2)];
      var $104=$7;
      var $105=$__t_i;
      var $106=(($18+20)|0);
      var $107=$15;
      var $108=$8;
      var $109=$9;
      HEAP32[(($8)>>2)]=$106;
      HEAP32[(($9)>>2)]=$107;
      var $110=HEAP32[(($8)>>2)];
      var $111=HEAP32[(($9)>>2)];
      var $112=$110;
      var $113=(($112)|0);
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114+($111<<2))|0);
      var $116=$8;
      var $117=$9;
      __label__ = 9; break;
    case 9: // $118
      HEAP32[(($115)>>2)]=$103;
      FUNCTION_TABLE[__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED1Ev]($hold);
      STACKTOP = __stackBase__;
      return;
    case 10: // $119
      __label__ = 11; break;
    case 11: // $120
      var $121=$16;
      var $122=$16;
      var $123=$17;
      var $124=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $122, tempValue);
      var $125=($124.f1 = $123, $124);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 12: // $126
      var $127=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16locale5__imp7installEPNS0_5facetEl["X"]=1;

function __ZNSt3__16locale5__impD2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $i;
      var $7;
      var $8;
      $6=$this;
      var $9=$6;
      var $10=$9;
      HEAP32[(($10)>>2)]=((__ZTVNSt3__16locale5__impE+8)|0);
      $i=0;
      __label__ = 1; break;
    case 1: // $11
      var $12=$i;
      var $13=(($9+20)|0);
      var $14=$5;
      HEAP32[(($5)>>2)]=$13;
      var $15=HEAP32[(($5)>>2)];
      var $16=$15;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$15;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$18;
      var $23=$21;
      var $24=(($22-$23)|0);
      var $25=(((($24)|0)/4)|0);
      var $26=$5;
      var $27=(($12)>>>0) < (($25)>>>0);
      if ($27) { __label__ = 2; break; } else { __label__ = 8; break; }
    case 2: // $28
      var $29=(($9+20)|0);
      var $30=$i;
      var $31=$3;
      var $32=$4;
      HEAP32[(($3)>>2)]=$29;
      HEAP32[(($4)>>2)]=$30;
      var $33=HEAP32[(($3)>>2)];
      var $34=HEAP32[(($4)>>2)];
      var $35=$33;
      var $36=(($35)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37+($34<<2))|0);
      var $39=$3;
      var $40=$4;
      __label__ = 3; break;
    case 3: // $41
      var $42=HEAP32[(($38)>>2)];
      var $43=(($42)|0)!=0;
      if ($43) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $44
      var $45=(($9+20)|0);
      var $46=$i;
      var $47=$1;
      var $48=$2;
      HEAP32[(($1)>>2)]=$45;
      HEAP32[(($2)>>2)]=$46;
      var $49=HEAP32[(($1)>>2)];
      var $50=HEAP32[(($2)>>2)];
      var $51=$49;
      var $52=(($51)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($53+($50<<2))|0);
      var $55=$1;
      var $56=$2;
      __label__ = 5; break;
    case 5: // $57
      var $58=HEAP32[(($54)>>2)];
      var $59=$58;
      var $60=__ZNSt3__114__shared_count16__release_sharedEv($59);
      __label__ = 6; break;
    case 6: // $66
      __label__ = 7; break;
    case 7: // $67
      var $68=$i;
      var $69=(($68+1)|0);
      $i=$69;
      __label__ = 1; break;
    case 8: // $70
      var $71=(($9+20)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED1Ev($71) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $72
      var $73=(($9+8)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($73) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $74
      var $75=$9;
      __ZNSt3__16locale5facetD2Ev($75);
      STACKTOP = __stackBase__;
      return;
    case 11: // $76
      var $77=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $78=$77.f0;
      $7=$78;
      var $79=$77.f1;
      $8=$79;
      __label__ = 14; break;
    case 12: // $80
      __label__ = 14; break;
    case 13: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      $7=$83;
      var $84=$82.f1;
      $8=$84;
      __label__ = 16; break;
    case 14: // $85
      var $86=(($9+8)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($86) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 19; break; }
    case 15: // $87
      __label__ = 16; break;
    case 16: // $88
      var $89=$9;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($89) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $90
      __label__ = 18; break;
    case 18: // $91
      var $92=$7;
      var $93=$7;
      var $94=$8;
      var $95=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $93, tempValue);
      var $96=($95.f1 = $94, $95);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 19: // $97
      var $98=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16locale5__impD2Ev["X"]=1;

function __ZNSt3__15ctypeIcE13classic_tableEv() {
  ;
  var __label__;

  ;
  return 0;
}


function __ZNSt3__15ctypeIcE21__classic_upper_tableEv() {
  ;
  var __label__;

  ;
  return 0;
}


function __ZNSt3__15ctypeIcE21__classic_lower_tableEv() {
  ;
  var __label__;

  ;
  return 0;
}


function __ZNKSt3__15ctypeIwE8do_widenEc($this, $c) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$c;
  var $3=$1;
  var $4=$2;
  var $5=(($4 << 24) >> 24);
  ;
  return $5;
}


function __ZNKSt3__15ctypeIwE9do_narrowEwc($this, $c, $dfault) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$c;
      $4=$dfault;
      var $5=$2;
      var $6=$3;
      var $7=(($6)>>>0) <= 127;
      if ($7) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $8
      var $9=$3;
      var $10=(($9) & 255);
      $1=$10;
      __label__ = 3; break;
    case 2: // $11
      var $12=$4;
      $1=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__16locale5__imp9has_facetEl($this, $id) {
  var __stackBase__  = STACKTOP; STACKTOP += 12; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4;
      var $5;
      $4=$this;
      $5=$id;
      var $6=$4;
      var $7=$5;
      var $8=(($6+20)|0);
      var $9=$3;
      HEAP32[(($3)>>2)]=$8;
      var $10=HEAP32[(($3)>>2)];
      var $11=$10;
      var $12=(($11+4)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=$10;
      var $15=(($14)|0);
      var $16=HEAP32[(($15)>>2)];
      var $17=$13;
      var $18=$16;
      var $19=(($17-$18)|0);
      var $20=(((($19)|0)/4)|0);
      var $21=$3;
      var $22=(($7)>>>0) < (($20)>>>0);
      if ($22) { __label__ = 1; break; } else { var $39 = 0;__label__ = 2; break; }
    case 1: // $23
      var $24=(($6+20)|0);
      var $25=$5;
      var $26=$1;
      var $27=$2;
      HEAP32[(($1)>>2)]=$24;
      HEAP32[(($2)>>2)]=$25;
      var $28=HEAP32[(($1)>>2)];
      var $29=HEAP32[(($2)>>2)];
      var $30=$28;
      var $31=(($30)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+($29<<2))|0);
      var $34=$1;
      var $35=$2;
      var $36=HEAP32[(($33)>>2)];
      var $37=(($36)|0)!=0;
      var $39 = $37;__label__ = 2; break;
    case 2: // $38
      var $39;
      STACKTOP = __stackBase__;
      return $39;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale2id6__initEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(tempValue=HEAP32[((__ZNSt3__16locale2id9__next_idE)>>2)],HEAP32[((__ZNSt3__16locale2id9__next_idE)>>2)]=tempValue+1,tempValue);
  var $4=(($3+1)|0);
  var $5=(($2+4)|0);
  HEAP32[(($5)>>2)]=$4;
  ;
  return;
}


function ___cxx_global_var_init41() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__15ctypeIwE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw($this, $low, $high, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$low;
      $3=$high;
      $4=$dest;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=$3;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$2;
      var $12=HEAP8[($11)];
      var $13=(($12 << 24) >> 24);
      var $14=$4;
      HEAP32[(($14)>>2)]=$13;
      __label__ = 3; break;
    case 3: // $15
      var $16=$2;
      var $17=(($16+1)|0);
      $2=$17;
      var $18=$4;
      var $19=(($18+4)|0);
      $4=$19;
      __label__ = 1; break;
    case 4: // $20
      var $21=$2;
      ;
      return $21;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj($this, $__sz) {
  var __stackBase__  = STACKTOP; STACKTOP += 40; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11;
      var $12;
      var $__cs;
      $11=$this;
      $12=$__sz;
      var $13=$11;
      var $14=$10;
      HEAP32[(($10)>>2)]=$13;
      var $15=HEAP32[(($10)>>2)];
      var $16=$15;
      var $17=(($16+4)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$15;
      var $20=(($19)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=$18;
      var $23=$21;
      var $24=(($22-$23)|0);
      var $25=(((($24)|0)/4)|0);
      var $26=$10;
      $__cs=$25;
      var $27=$__cs;
      var $28=$12;
      var $29=(($27)>>>0) < (($28)>>>0);
      if ($29) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $30
      var $31=$12;
      var $32=$__cs;
      var $33=(($31-$32)|0);
      __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj($13, $33);
      __label__ = 5; break;
    case 2: // $34
      var $35=$__cs;
      var $36=$12;
      var $37=(($35)>>>0) > (($36)>>>0);
      if ($37) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $38
      var $39=$13;
      var $40=(($39)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=$12;
      var $43=(($41+($42<<2))|0);
      var $44=$8;
      var $45=$9;
      HEAP32[(($8)>>2)]=$13;
      HEAP32[(($9)>>2)]=$43;
      var $46=HEAP32[(($8)>>2)];
      var $47=$46;
      var $48=HEAP32[(($9)>>2)];
      var $49=$3;
      var $50=$4;
      var $51=$5;
      var $52=$6;
      var $53=$7;
      HEAP32[(($4)>>2)]=$47;
      HEAP32[(($5)>>2)]=$48;
      var $54=HEAP32[(($4)>>2)];
      var $55=HEAP32[(($5)>>2)];
      var $56=$7;
      var $tmp_i_i=$3;
      var $tmp1_i_i=$6;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $57=$1;
      var $58=$2;
      HEAP32[(($1)>>2)]=$54;
      HEAP32[(($2)>>2)]=$55;
      var $59=HEAP32[(($1)>>2)];
      var $60=HEAP32[(($2)>>2)];
      var $61=(($59+4)|0);
      HEAP32[(($61)>>2)]=$60;
      var $62=$1;
      var $63=$2;
      var $64=$3;
      var $65=$4;
      var $66=$5;
      var $67=$6;
      var $68=$7;
      var $69=$8;
      var $70=$9;
      __label__ = 4; break;
    case 4: // $71
      __label__ = 5; break;
    case 5: // $72
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj["X"]=1;

function __ZNSt3__16locale5__imp12make_classicEv() {
  ;
  var __label__;

  var $c;
  $c=__ZZNSt3__16locale5__imp12make_classicEvE3buf;
  var $1=__ZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_(1);
  var $2=$c;
  var $3=(($2)|0);
  HEAP32[(($3)>>2)]=$1;
  var $4=$c;
  ;
  return $4;
}


function __ZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_($a0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$a0;
      if (0) { var $5 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $2
      var $3=$1;
      FUNCTION_TABLE[__ZNSt3__16locale5__impC1Ej](__ZZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_E3buf, $3);
      var $5 = __ZZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_E3buf;__label__ = 2; break;
    case 2: // $4
      var $5;
      ;
      return __ZZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_E3buf;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5__imp11make_globalEv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $g;
      $g=__ZZNSt3__16locale5__imp11make_globalEvE3buf;
      if (0) { var $4 = 0;__label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $1
      var $2=__ZNSt3__16locale7classicEv();
      FUNCTION_TABLE[__ZNSt3__16localeC1ERKS0_](__ZZNSt3__16locale5__imp11make_globalEvE3buf, $2);
      var $4 = __ZZNSt3__16locale5__imp11make_globalEvE3buf;__label__ = 2; break;
    case 2: // $3
      var $4;
      ;
      return __ZZNSt3__16locale5__imp11make_globalEvE3buf;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale8__globalEv() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3=HEAP8[(__ZGVZNSt3__16locale8__globalEvE1g)];
      var $4=(($3 << 24) >> 24)==0;
      if ($4) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $5
      var $6=___cxa_guard_acquire(__ZGVZNSt3__16locale8__globalEvE1g);
      var $7=(($6)|0)!=0;
      if ($7) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(function() { try { __THREW__ = false; return __ZNSt3__16locale5__imp11make_globalEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $10
      HEAP32[((__ZZNSt3__16locale8__globalEvE1g)>>2)]=$9;
      ;
      __label__ = 4; break;
    case 4: // $11
      var $12=HEAP32[((__ZZNSt3__16locale8__globalEvE1g)>>2)];
      ;
      return $12;
    case 5: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $1=$15;
      var $16=$14.f1;
      $2=$16;
      ;
      __label__ = 6; break;
    case 6: // $17
      var $18=$1;
      var $19=$1;
      var $20=$2;
      var $21=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $19, tempValue);
      var $22=($21.f1 = $20, $21);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16localeC2ERKS0_($this, $l) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$l;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=(($5)|0);
  var $7=HEAP32[(($6)>>2)];
  HEAP32[(($4)>>2)]=$7;
  var $8=(($3)|0);
  var $9=HEAP32[(($8)>>2)];
  var $10=$9;
  __ZNSt3__114__shared_count12__add_sharedEv($10);
  ;
  return;
}


function __ZNSt3__16localeD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2)|0);
  var $4=HEAP32[(($3)>>2)];
  var $5=$4;
  var $6=__ZNSt3__114__shared_count16__release_sharedEv($5);
  ;
  return;
}


function __ZNSt3__16locale2id5__getEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $__p_i=__stackBase__+4;
      var $2=__stackBase__+16;
      var $3;
      var $4=__stackBase__+28;
      var $5=__stackBase__+40;
      $3=$this;
      var $6=$3;
      var $7=(($6)|0);
      HEAP32[(($5)>>2)]={ f0: 1686, f1: 0 }.f0; HEAP32[(($5+4)>>2)]={ f0: 1686, f1: 0 }.f1;
      FUNCTION_TABLE[__ZNSt3__112_GLOBAL__N_111__fake_bindC1EMNS_6locale2idEFvvEPS3_]($4, $5, $6);
      var $tmp=$2;
      var $tmp1=$4;
      assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');for (var $$src = $tmp1, $$dest = $tmp, $$stop = $$src + 12; $$src < $$stop; $$src++, $$dest++) {
        HEAP8[$$dest] = HEAP8[$$src]
      };
      var $8=$1;
      var $9=$__p_i;
      HEAP32[(($1)>>2)]=$7;
      var $10=HEAP32[(($1)>>2)];
      var $11=(($10)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($12)|0)!=-1;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      FUNCTION_TABLE[__ZNSt3__117__call_once_paramINS_12_GLOBAL__N_111__fake_bindEEC1ERKS2_]($__p_i, $2);
      var $15=HEAP32[(($1)>>2)];
      var $16=(($15)|0);
      var $17=$__p_i;
      __ZNSt3__111__call_onceERVmPvPFvS2_E($16, $17, 1690);
      __label__ = 2; break;
    case 2: // $_ZNSt3__19call_onceINS_12_GLOBAL__N_111__fake_bindEEEvRNS_9once_flagET__exit
      var $18=$1;
      var $19=$__p_i;
      var $20=(($6+4)|0);
      var $21=HEAP32[(($20)>>2)];
      var $22=(($21-1)|0);
      STACKTOP = __stackBase__;
      return $22;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__16locale9use_facetERNS0_2idE($this, $x) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$x;
  var $3=$1;
  var $4=(($3)|0);
  var $5=HEAP32[(($4)>>2)];
  var $6=$2;
  var $7=__ZNSt3__16locale2id5__getEv($6);
  var $8=__ZNKSt3__16locale5__imp9use_facetEl($5, $7);
  ;
  return $8;
}


function __ZNSt3__16locale5facetD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__16locale5facetD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__15ctypeIwED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__15ctypeIwED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE5do_isEjw($this, $m, $c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$m;
      $3=$c;
      var $4=$1;
      var $5=$3;
      var $6=(($5)>>>0) <= 127;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$3;
      var $9=__ZNSt3__15ctypeIcE13classic_tableEv();
      var $10=(($9+($8<<2))|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$2;
      var $13=$11 & $12;
      var $16 = $13;__label__ = 3; break;
    case 2: // $14
      var $16 = 0;__label__ = 3; break;
    case 3: // $15
      var $16;
      var $17=(($16)|0)!=0;
      ;
      return $17;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE5do_isEPKwS3_Pj($this, $low, $high, $vec) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$low;
      $3=$high;
      $4=$vec;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=$3;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$2;
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($12)>>>0) <= 127;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNSt3__15ctypeIcE13classic_tableEv();
      var $18=(($17+($16<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      var $22 = $19;__label__ = 5; break;
    case 4: // $20
      var $22 = 0;__label__ = 5; break;
    case 5: // $21
      var $22;
      var $23=$4;
      HEAP32[(($23)>>2)]=$22;
      __label__ = 6; break;
    case 6: // $24
      var $25=$2;
      var $26=(($25+4)|0);
      $2=$26;
      var $27=$4;
      var $28=(($27+4)|0);
      $4=$28;
      __label__ = 1; break;
    case 7: // $29
      var $30=$2;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE10do_scan_isEjPKwS3_($this, $m, $low, $high) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$m;
      $3=$low;
      $4=$high;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      var $7=$3;
      var $8=$4;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$3;
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($12)>>>0) <= 127;
      if ($13) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      var $15=$3;
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNSt3__15ctypeIcE13classic_tableEv();
      var $18=(($17+($16<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=$19 & $20;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $23
      __label__ = 7; break;
    case 5: // $24
      __label__ = 6; break;
    case 6: // $25
      var $26=$3;
      var $27=(($26+4)|0);
      $3=$27;
      __label__ = 1; break;
    case 7: // $28
      var $29=$3;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE11do_scan_notEjPKwS3_($this, $m, $low, $high) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$m;
      $3=$low;
      $4=$high;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      var $7=$3;
      var $8=$4;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $10
      var $11=$3;
      var $12=HEAPU32[(($11)>>2)];
      var $13=(($12)>>>0) <= 127;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$3;
      var $16=HEAP32[(($15)>>2)];
      var $17=__ZNSt3__15ctypeIcE13classic_tableEv();
      var $18=(($17+($16<<2))|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$2;
      var $21=$19 & $20;
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $23
      __label__ = 7; break;
    case 5: // $24
      __label__ = 6; break;
    case 6: // $25
      var $26=$3;
      var $27=(($26+4)|0);
      $3=$27;
      __label__ = 1; break;
    case 7: // $28
      var $29=$3;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE10do_toupperEw($this, $c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$c;
      var $3=$1;
      var $4=$2;
      var $5=(($4)>>>0) <= 127;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=__ZNSt3__15ctypeIcE21__classic_upper_tableEv();
      var $9=(($8+($7<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      var $14 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE10do_toupperEPwPKw($this, $low, $high) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$low;
      $3=$high;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$2;
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($11)>>>0) <= 127;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$2;
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNSt3__15ctypeIcE21__classic_upper_tableEv();
      var $17=(($16+($15<<2))|0);
      var $18=HEAP32[(($17)>>2)];
      var $23 = $18;__label__ = 5; break;
    case 4: // $19
      var $20=$2;
      var $21=HEAP32[(($20)>>2)];
      var $23 = $21;__label__ = 5; break;
    case 5: // $22
      var $23;
      var $24=$2;
      HEAP32[(($24)>>2)]=$23;
      __label__ = 6; break;
    case 6: // $25
      var $26=$2;
      var $27=(($26+4)|0);
      $2=$27;
      __label__ = 1; break;
    case 7: // $28
      var $29=$2;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE10do_tolowerEw($this, $c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$c;
      var $3=$1;
      var $4=$2;
      var $5=(($4)>>>0) <= 127;
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $6
      var $7=$2;
      var $8=__ZNSt3__15ctypeIcE21__classic_lower_tableEv();
      var $9=(($8+($7<<2))|0);
      var $10=HEAP32[(($9)>>2)];
      var $14 = $10;__label__ = 3; break;
    case 2: // $11
      var $12=$2;
      var $14 = $12;__label__ = 3; break;
    case 3: // $13
      var $14;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE10do_tolowerEPwPKw($this, $low, $high) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$low;
      $3=$high;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$2;
      var $11=HEAPU32[(($10)>>2)];
      var $12=(($11)>>>0) <= 127;
      if ($12) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $13
      var $14=$2;
      var $15=HEAP32[(($14)>>2)];
      var $16=__ZNSt3__15ctypeIcE21__classic_lower_tableEv();
      var $17=(($16+($15<<2))|0);
      var $18=HEAP32[(($17)>>2)];
      var $23 = $18;__label__ = 5; break;
    case 4: // $19
      var $20=$2;
      var $21=HEAP32[(($20)>>2)];
      var $23 = $21;__label__ = 5; break;
    case 5: // $22
      var $23;
      var $24=$2;
      HEAP32[(($24)>>2)]=$23;
      __label__ = 6; break;
    case 6: // $25
      var $26=$2;
      var $27=(($26+4)|0);
      $2=$27;
      __label__ = 1; break;
    case 7: // $28
      var $29=$2;
      ;
      return $29;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__16locale5__imp9use_facetEl($this, $id) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3;
      var $4;
      $3=$this;
      $4=$id;
      var $5=$3;
      var $6=$4;
      var $7=__ZNKSt3__16locale5__imp9has_facetEl($5, $6);
      if ($7) { __label__ = 2; break; } else { __label__ = 1; break; }
    case 1: // $8
      var $9=___cxa_allocate_exception(4);
      var $10=$9;
      FUNCTION_TABLE[__ZNSt8bad_castC1Ev]($10);
      ___cxa_throw($9, __ZTISt8bad_cast, 1688);
      throw "Reached an unreachable!"
    case 2: // $11
      var $12=(($5+20)|0);
      var $13=$4;
      var $14=$1;
      var $15=$2;
      HEAP32[(($1)>>2)]=$12;
      HEAP32[(($2)>>2)]=$13;
      var $16=HEAP32[(($1)>>2)];
      var $17=HEAP32[(($2)>>2)];
      var $18=$16;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+($17<<2))|0);
      var $22=$1;
      var $23=$2;
      var $24=HEAP32[(($21)>>2)];
      STACKTOP = __stackBase__;
      return $24;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16localeC2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0);
      var $6=(function() { try { __THREW__ = false; return __ZNSt3__16locale8__globalEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $7
      var $8=(($6)|0);
      var $9=HEAP32[(($8)>>2)];
      HEAP32[(($5)>>2)]=$9;
      var $10=(($4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11;
      __ZNSt3__114__shared_count12__add_sharedEv($12);
      ;
      return;
    case 2: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      __label__ = 3; break;
    case 3: // $17
      var $18=$2;
      ___cxa_call_unexpected($18);
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16locale5facet16__on_zero_sharedEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=(($4)|0)==0;
      if ($5) { __label__ = 3; break; } else { __label__ = 1; break; }
    case 1: // $6
      var $7=$4;
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8+4)|0);
      var $10=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$10]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $11
      __label__ = 3; break;
    case 3: // $12
      ;
      return;
    case 4: // $13
      var $14=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $15=$14.f0;
      $2=$15;
      var $16=$14.f1;
      $3=$16;
      __label__ = 5; break;
    case 5: // $17
      var $18=$2;
      ___cxa_call_unexpected($18);
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}

// WARNING: content after a branch in a label, line: 912748
// WARNING: content after a branch in a label, line: 912750
// WARNING: content after a branch in a label, line: 912751
// WARNING: content after a branch in a label, line: 912752
// WARNING: content after a branch in a label, line: 912753
// WARNING: content after a branch in a label, line: 912754
// WARNING: content after a branch in a label, line: 912755

function __ZNKSt3__15ctypeIcE8do_widenEc($this, $c) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$c;
  var $3=$1;
  var $4=$2;
  ;
  return $4;
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_($this, $0, $frm, $1, $frm_nxt, $to, $2, $to_nxt) {
  ;
  var __label__;

  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $10;
  var $11;
  $4=$this;
  $5=$0;
  $6=$frm;
  $7=$1;
  $8=$frm_nxt;
  $9=$to;
  $10=$2;
  $11=$to_nxt;
  var $12=$4;
  var $13=$6;
  var $14=$8;
  HEAP32[(($14)>>2)]=$13;
  var $15=$9;
  var $16=$11;
  HEAP32[(($16)>>2)]=$15;
  ;
  return 3;
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_($this, $0, $frm, $1, $frm_nxt, $to, $2, $to_nxt) {
  ;
  var __label__;

  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $10;
  var $11;
  $4=$this;
  $5=$0;
  $6=$frm;
  $7=$1;
  $8=$frm_nxt;
  $9=$to;
  $10=$2;
  $11=$to_nxt;
  var $12=$4;
  var $13=$6;
  var $14=$8;
  HEAP32[(($14)>>2)]=$13;
  var $15=$9;
  var $16=$11;
  HEAP32[(($16)>>2)]=$15;
  ;
  return 3;
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_($this, $0, $to, $1, $to_nxt) {
  ;
  var __label__;

  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $3=$this;
  $4=$0;
  $5=$to;
  $6=$1;
  $7=$to_nxt;
  var $8=$3;
  var $9=$5;
  var $10=$7;
  HEAP32[(($10)>>2)]=$9;
  ;
  return 3;
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE11do_encodingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE16do_always_noconvEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE13do_max_lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 1;
}


function __ZNKSt3__15ctypeIcE9do_narrowEcc($this, $c, $dfault) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $2=$this;
      $3=$c;
      $4=$dfault;
      var $5=$2;
      var $6=$3;
      var $7=(($6 << 24) >> 24);
      var $8=(($7)>>>0) <= 127;
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      var $10=$3;
      $1=$10;
      __label__ = 3; break;
    case 2: // $11
      var $12=$4;
      $1=$12;
      __label__ = 3; break;
    case 3: // $13
      var $14=$1;
      ;
      return $14;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc($this, $low, $high, $dfault, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$low;
      $3=$high;
      $4=$dfault;
      $5=$dest;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      var $8=$2;
      var $9=$3;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$2;
      var $13=HEAPU32[(($12)>>2)];
      var $14=(($13)>>>0) <= 127;
      if ($14) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $15
      var $16=$2;
      var $17=HEAP32[(($16)>>2)];
      var $18=(($17) & 255);
      var $19=$5;
      HEAP8[($19)]=$18;
      __label__ = 5; break;
    case 4: // $20
      var $21=$4;
      var $22=$5;
      HEAP8[($22)]=$21;
      __label__ = 5; break;
    case 5: // $23
      __label__ = 6; break;
    case 6: // $24
      var $25=$2;
      var $26=(($25+4)|0);
      $2=$26;
      var $27=$5;
      var $28=(($27+1)|0);
      $5=$28;
      __label__ = 1; break;
    case 7: // $29
      var $30=$2;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_var_init42() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__15ctypeIcE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc($this, $low, $high, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$low;
      $3=$high;
      $4=$dest;
      var $5=$1;
      __label__ = 1; break;
    case 1: // $6
      var $7=$2;
      var $8=$3;
      var $9=(($7)|0)!=(($8)|0);
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=$2;
      var $12=HEAP8[($11)];
      var $13=$4;
      HEAP8[($13)]=$12;
      __label__ = 3; break;
    case 3: // $14
      var $15=$2;
      var $16=(($15+1)|0);
      $2=$16;
      var $17=$4;
      var $18=(($17+1)|0);
      $4=$18;
      __label__ = 1; break;
    case 4: // $19
      var $20=$2;
      ;
      return $20;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc($this, $low, $high, $dfault, $dest) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$low;
      $3=$high;
      $4=$dfault;
      $5=$dest;
      var $6=$1;
      __label__ = 1; break;
    case 1: // $7
      var $8=$2;
      var $9=$3;
      var $10=(($8)|0)!=(($9)|0);
      if ($10) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $11
      var $12=$2;
      var $13=HEAP8[($12)];
      var $14=(($13 << 24) >> 24);
      var $15=(($14)>>>0) <= 127;
      if ($15) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $16
      var $17=$2;
      var $18=HEAP8[($17)];
      var $19=$5;
      HEAP8[($19)]=$18;
      __label__ = 5; break;
    case 4: // $20
      var $21=$4;
      var $22=$5;
      HEAP8[($22)]=$21;
      __label__ = 5; break;
    case 5: // $23
      __label__ = 6; break;
    case 6: // $24
      var $25=$2;
      var $26=(($25+1)|0);
      $2=$26;
      var $27=$5;
      var $28=(($27+1)|0);
      $5=$28;
      __label__ = 1; break;
    case 7: // $29
      var $30=$2;
      ;
      return $30;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_var_init45() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__17codecvtIcc10_mbstate_tE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function ___cxx_global_var_init46() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__17codecvtIwc10_mbstate_tE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__15ctypeIcED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__15ctypeIcED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__15ctypeIcED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=$2;
      HEAP32[(($3)>>2)]=((__ZTVNSt3__15ctypeIcEE+8)|0);
      var $4=(($2+8)|0);
      var $5=HEAP32[(($4)>>2)];
      var $6=(($5)|0)!=0;
      if ($6) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $7
      var $8=(($2+12)|0);
      var $9=HEAP8[($8)];
      var $10=(($9) & 1);
      if ($10) { __label__ = 2; break; } else { __label__ = 5; break; }
    case 2: // $11
      var $12=(($2+8)|0);
      var $13=HEAP32[(($12)>>2)];
      var $14=(($13)|0)==0;
      if ($14) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $15
      var $16=$13;
      __ZdaPv($16);
      __label__ = 4; break;
    case 4: // $17
      __label__ = 5; break;
    case 5: // $18
      var $19=$2;
      __ZNSt3__16locale5facetD2Ev($19);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIcE10do_toupperEc($this, $c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$c;
      var $3=$1;
      var $4=$2;
      var $5=(($4 << 24) >> 24);
      var $6=(($5)>>>0) <= 127;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8 << 24) >> 24);
      var $10=__ZNSt3__15ctypeIcE21__classic_upper_tableEv();
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $17 = $12;__label__ = 3; break;
    case 2: // $13
      var $14=$2;
      var $15=(($14 << 24) >> 24);
      var $17 = $15;__label__ = 3; break;
    case 3: // $16
      var $17;
      var $18=(($17) & 255);
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIcE10do_toupperEPcPKc($this, $low, $high) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$low;
      $3=$high;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$2;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)>>>0) <= 127;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=__ZNSt3__15ctypeIcE21__classic_upper_tableEv();
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $26 = $20;__label__ = 5; break;
    case 4: // $21
      var $22=$2;
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $26 = $24;__label__ = 5; break;
    case 5: // $25
      var $26;
      var $27=(($26) & 255);
      var $28=$2;
      HEAP8[($28)]=$27;
      __label__ = 6; break;
    case 6: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      __label__ = 1; break;
    case 7: // $32
      var $33=$2;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIcE10do_tolowerEc($this, $c) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      $1=$this;
      $2=$c;
      var $3=$1;
      var $4=$2;
      var $5=(($4 << 24) >> 24);
      var $6=(($5)>>>0) <= 127;
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$2;
      var $9=(($8 << 24) >> 24);
      var $10=__ZNSt3__15ctypeIcE21__classic_lower_tableEv();
      var $11=(($10+($9<<2))|0);
      var $12=HEAP32[(($11)>>2)];
      var $17 = $12;__label__ = 3; break;
    case 2: // $13
      var $14=$2;
      var $15=(($14 << 24) >> 24);
      var $17 = $15;__label__ = 3; break;
    case 3: // $16
      var $17;
      var $18=(($17) & 255);
      ;
      return $18;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__15ctypeIcE10do_tolowerEPcPKc($this, $low, $high) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      $2=$low;
      $3=$high;
      var $4=$1;
      __label__ = 1; break;
    case 1: // $5
      var $6=$2;
      var $7=$3;
      var $8=(($6)|0)!=(($7)|0);
      if ($8) { __label__ = 2; break; } else { __label__ = 7; break; }
    case 2: // $9
      var $10=$2;
      var $11=HEAP8[($10)];
      var $12=(($11 << 24) >> 24);
      var $13=(($12)>>>0) <= 127;
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $14
      var $15=$2;
      var $16=HEAP8[($15)];
      var $17=(($16 << 24) >> 24);
      var $18=__ZNSt3__15ctypeIcE21__classic_lower_tableEv();
      var $19=(($18+($17<<2))|0);
      var $20=HEAP32[(($19)>>2)];
      var $26 = $20;__label__ = 5; break;
    case 4: // $21
      var $22=$2;
      var $23=HEAP8[($22)];
      var $24=(($23 << 24) >> 24);
      var $26 = $24;__label__ = 5; break;
    case 5: // $25
      var $26;
      var $27=(($26) & 255);
      var $28=$2;
      HEAP8[($28)]=$27;
      __label__ = 6; break;
    case 6: // $29
      var $30=$2;
      var $31=(($30+1)|0);
      $2=$31;
      __label__ = 1; break;
    case 7: // $32
      var $33=$2;
      ;
      return $33;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__17codecvtIcc10_mbstate_tED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__17codecvtIcc10_mbstate_tED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17codecvtIcc10_mbstate_tE9do_lengthERS1_PKcS5_j($this, $0, $frm, $end, $mx) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2=__stackBase__;
      var $3=__stackBase__+4;
      var $4=__stackBase__+8;
      var $5=__stackBase__+12;
      var $6=__stackBase__+16;
      var $7=__stackBase__+20;
      var $8=__stackBase__+24;
      var $9=__stackBase__+28;
      var $10=__stackBase__+32;
      var $11;
      var $12;
      var $13;
      var $14;
      var $15=__stackBase__+36;
      var $16=__stackBase__+40;
      $11=$this;
      $12=$0;
      $13=$frm;
      $14=$end;
      HEAP32[(($15)>>2)]=$mx;
      var $17=$11;
      var $18=$14;
      var $19=$13;
      var $20=$18;
      var $21=$19;
      var $22=(($20-$21)|0);
      HEAP32[(($16)>>2)]=$22;
      var $23=$7;
      var $24=$8;
      var $25=$9;
      var $26=$10;
      HEAP32[(($8)>>2)]=$15;
      HEAP32[(($9)>>2)]=$16;
      var $27=HEAP32[(($8)>>2)];
      var $28=HEAP32[(($9)>>2)];
      var $tmp_i=$7;
      var $tmp1_i=$10;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $29=$5;
      var $30=$6;
      HEAP32[(($5)>>2)]=$27;
      HEAP32[(($6)>>2)]=$28;
      var $31=HEAP32[(($6)>>2)];
      var $32=HEAP32[(($5)>>2)];
      var $33=$2;
      var $34=$3;
      var $35=$4;
      HEAP32[(($2)>>2)]=$7;
      HEAP32[(($3)>>2)]=$31;
      HEAP32[(($4)>>2)]=$32;
      var $36=HEAP32[(($2)>>2)];
      var $37=HEAP32[(($3)>>2)];
      var $38=HEAPU32[(($37)>>2)];
      var $39=HEAP32[(($4)>>2)];
      var $40=HEAPU32[(($39)>>2)];
      var $41=(($38)>>>0) < (($40)>>>0);
      var $42=$2;
      var $43=$3;
      var $44=$4;
      if ($41) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $45
      var $46=HEAP32[(($6)>>2)];
      var $49 = $46;__label__ = 3; break;
    case 2: // $47
      var $48=HEAP32[(($5)>>2)];
      var $49 = $48;__label__ = 3; break;
    case 3: // $_ZNSt3__13minIjEERKT_S3_S3__exit
      var $49;
      var $50=$5;
      var $51=$6;
      var $52=$7;
      var $53=$8;
      var $54=$9;
      var $55=$10;
      var $56=HEAP32[(($49)>>2)];
      STACKTOP = __stackBase__;
      return $56;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIcc10_mbstate_tE9do_lengthERS1_PKcS5_j["X"]=1;

function __ZNSt3__17codecvtIwc10_mbstate_tED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__17codecvtIwc10_mbstate_tED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__15ctypeIcEC2EPKjbj($this, $tab, $del, $refs) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $8;
      var $9;
      var $10;
      var $11;
      $6=$this;
      $7=$tab;
      var $12=(($del)&1);
      $8=$12;
      $9=$refs;
      var $13=$6;
      var $14=$13;
      var $15=$9;
      var $16=$4;
      var $17=$5;
      HEAP32[(($4)>>2)]=$14;
      HEAP32[(($5)>>2)]=$15;
      var $18=HEAPU32[(($4)>>2)];
      var $19=$18;
      var $20=HEAP32[(($5)>>2)];
      var $21=(($20-1)|0);
      var $22=$2;
      var $23=$3;
      HEAP32[(($2)>>2)]=$19;
      HEAP32[(($3)>>2)]=$21;
      var $24=HEAP32[(($2)>>2)];
      var $25=$24;
      HEAP32[(($25)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $26=(($24+4)|0);
      var $27=HEAP32[(($3)>>2)];
      HEAP32[(($26)>>2)]=$27;
      var $28=$2;
      var $29=$3;
      var $30=$18;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $31=$4;
      var $32=$5;
      var $33=$13;
      var $34=$1;
      HEAP32[(($1)>>2)]=$33;
      var $35=HEAP32[(($1)>>2)];
      var $36=$1;
      __label__ = 1; break;
    case 1: // $37
      var $38=$13;
      HEAP32[(($38)>>2)]=((__ZTVNSt3__15ctypeIcEE+8)|0);
      var $39=(($13+8)|0);
      var $40=$7;
      HEAP32[(($39)>>2)]=$40;
      var $41=(($13+12)|0);
      var $42=$8;
      var $43=(($42) & 1);
      var $44=(($43)&1);
      HEAP8[($41)]=$44;
      var $45=(($13+8)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46)|0)==0;
      if ($47) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $48
      var $49=__ZNSt3__15ctypeIcE13classic_tableEv();
      var $50=(($13+8)|0);
      HEAP32[(($50)>>2)]=$49;
      __label__ = 3; break;
    case 3: // $56
      STACKTOP = __stackBase__;
      return;
    case 4: // $57
      __label__ = 5; break;
    case 5: // $58
      var $59=$10;
      var $60=$10;
      var $61=$11;
      var $62=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $60, tempValue);
      var $63=($62.f1 = $61, $62);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 6: // $64
      var $65=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__15ctypeIcEC2EPKjbj["X"]=1;

function __ZNSt3__17codecvtIwc10_mbstate_tEC2Ej($this, $refs) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6;
      var $7;
      var $8;
      var $9;
      $6=$this;
      $7=$refs;
      var $10=$6;
      var $11=$10;
      var $12=$7;
      var $13=$4;
      var $14=$5;
      HEAP32[(($4)>>2)]=$11;
      HEAP32[(($5)>>2)]=$12;
      var $15=HEAP32[(($4)>>2)];
      var $16=$15;
      var $17=HEAP32[(($5)>>2)];
      var $18=(($17-1)|0);
      var $19=$2;
      var $20=$3;
      HEAP32[(($2)>>2)]=$16;
      HEAP32[(($3)>>2)]=$18;
      var $21=HEAP32[(($2)>>2)];
      var $22=$21;
      HEAP32[(($22)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $23=(($21+4)|0);
      var $24=HEAP32[(($3)>>2)];
      HEAP32[(($23)>>2)]=$24;
      var $25=$2;
      var $26=$3;
      var $27=$15;
      HEAP32[(($27)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $28=$4;
      var $29=$5;
      var $30=$10;
      var $31=$1;
      HEAP32[(($1)>>2)]=$30;
      var $32=HEAP32[(($1)>>2)];
      var $33=$1;
      __label__ = 1; break;
    case 1: // $34
      var $35=$10;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__17codecvtIwc10_mbstate_tEE+8)|0);
      var $36=(($10+8)|0);
      HEAP32[(($36)>>2)]=0;
      STACKTOP = __stackBase__;
      return;
      var $38=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $39=$38.f0;
      $8=$39;
      var $40=$38.f1;
      $9=$40;
      var $41=$10;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($41) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $42
      __label__ = 3; break;
    case 3: // $43
      var $44=$8;
      var $45=$8;
      var $46=$9;
      var $47=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $45, tempValue);
      var $48=($47.f1 = $46, $47);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 4: // $49
      var $50=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__17codecvtIwc10_mbstate_tEC2Ej["X"]=1;

function __ZNKSt3__17codecvtIwc10_mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_($this, $st, $frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 704; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i5=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i6=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $__current_i7=__stackBase__+208;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55=__stackBase__+232;
      var $56=__stackBase__+236;
      var $57=__stackBase__+240;
      var $58=__stackBase__+244;
      var $59=__stackBase__+248;
      var $60=__stackBase__+252;
      var $61=__stackBase__+256;
      var $__tmp_i_i_i1_i1=__stackBase__+260;
      var $62=__stackBase__+264;
      var $63=__stackBase__+268;
      var $64=__stackBase__+272;
      var $65=__stackBase__+276;
      var $66=__stackBase__+280;
      var $67=__stackBase__+284;
      var $68=__stackBase__+288;
      var $69=__stackBase__+292;
      var $70=__stackBase__+296;
      var $71=__stackBase__+300;
      var $72=__stackBase__+304;
      var $73=__stackBase__+308;
      var $__tmp_i_i_i_i2=__stackBase__+312;
      var $74=__stackBase__+316;
      var $75=__stackBase__+320;
      var $76=__stackBase__+324;
      var $77=__stackBase__+328;
      var $78=__stackBase__+332;
      var $79=__stackBase__+336;
      var $80=__stackBase__+340;
      var $81=__stackBase__+344;
      var $82=__stackBase__+348;
      var $83=__stackBase__+352;
      var $84=__stackBase__+356;
      var $85=__stackBase__+360;
      var $86=__stackBase__+364;
      var $87=__stackBase__+368;
      var $88=__stackBase__+372;
      var $89=__stackBase__+376;
      var $90=__stackBase__+380;
      var $91=__stackBase__+384;
      var $92=__stackBase__+388;
      var $93=__stackBase__+392;
      var $94=__stackBase__+396;
      var $95=__stackBase__+400;
      var $96=__stackBase__+404;
      var $97=__stackBase__+408;
      var $98=__stackBase__+412;
      var $99=__stackBase__+416;
      var $100=__stackBase__+420;
      var $101=__stackBase__+424;
      var $102=__stackBase__+428;
      var $103=__stackBase__+432;
      var $__current_i3=__stackBase__+436;
      var $104=__stackBase__+444;
      var $105=__stackBase__+448;
      var $106=__stackBase__+452;
      var $107=__stackBase__+456;
      var $108=__stackBase__+460;
      var $109=__stackBase__+464;
      var $110=__stackBase__+468;
      var $111=__stackBase__+472;
      var $112=__stackBase__+476;
      var $113=__stackBase__+480;
      var $114=__stackBase__+484;
      var $__tmp_i_i_i1_i=__stackBase__+488;
      var $115=__stackBase__+492;
      var $116=__stackBase__+496;
      var $117=__stackBase__+500;
      var $118=__stackBase__+504;
      var $119=__stackBase__+508;
      var $120=__stackBase__+512;
      var $121=__stackBase__+516;
      var $122=__stackBase__+520;
      var $123=__stackBase__+524;
      var $124=__stackBase__+528;
      var $125=__stackBase__+532;
      var $126=__stackBase__+536;
      var $__tmp_i_i_i_i=__stackBase__+540;
      var $127=__stackBase__+544;
      var $128=__stackBase__+548;
      var $129=__stackBase__+552;
      var $130=__stackBase__+556;
      var $131=__stackBase__+560;
      var $132=__stackBase__+564;
      var $133=__stackBase__+568;
      var $134=__stackBase__+572;
      var $135=__stackBase__+576;
      var $136=__stackBase__+580;
      var $137=__stackBase__+584;
      var $138=__stackBase__+588;
      var $139=__stackBase__+592;
      var $140=__stackBase__+596;
      var $141=__stackBase__+600;
      var $142=__stackBase__+604;
      var $143=__stackBase__+608;
      var $144=__stackBase__+612;
      var $145=__stackBase__+616;
      var $146=__stackBase__+620;
      var $147=__stackBase__+624;
      var $148=__stackBase__+628;
      var $149=__stackBase__+632;
      var $150=__stackBase__+636;
      var $151=__stackBase__+640;
      var $152=__stackBase__+644;
      var $153=__stackBase__+648;
      var $154=__stackBase__+652;
      var $155=__stackBase__+656;
      var $156=__stackBase__+660;
      var $157=__stackBase__+664;
      var $158=__stackBase__+668;
      var $__current_i=__stackBase__+672;
      var $159=__stackBase__+680;
      var $160=__stackBase__+684;
      var $161=__stackBase__+688;
      var $162;
      var $163;
      var $164;
      var $165;
      var $166;
      var $167;
      var $168;
      var $169;
      var $170;
      var $fend;
      var $save_state=__stackBase__+692;
      var $n;
      var $tmp=__stackBase__+700;
      var $p;
      $163=$this;
      $164=$st;
      $165=$frm;
      $166=$frm_end;
      $167=$frm_nxt;
      $168=$to;
      $169=$to_end;
      $170=$to_nxt;
      var $171=$163;
      var $172=$165;
      $fend=$172;
      __label__ = 1; break;
    case 1: // $173
      var $174=$fend;
      var $175=$166;
      var $176=(($174)|0)!=(($175)|0);
      if ($176) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $177
      var $178=$fend;
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179)|0)==0;
      if ($180) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $181
      __label__ = 6; break;
    case 4: // $182
      __label__ = 5; break;
    case 5: // $183
      var $184=$fend;
      var $185=(($184+4)|0);
      $fend=$185;
      __label__ = 1; break;
    case 6: // $186
      var $187=$168;
      var $188=$170;
      HEAP32[(($188)>>2)]=$187;
      var $189=$165;
      var $190=$167;
      HEAP32[(($190)>>2)]=$189;
      __label__ = 7; break;
    case 7: // $191
      var $192=$165;
      var $193=$166;
      var $194=(($192)|0)!=(($193)|0);
      if ($194) { __label__ = 8; break; } else { var $200 = 0;__label__ = 9; break; }
    case 8: // $195
      var $196=$168;
      var $197=$169;
      var $198=(($196)|0)!=(($197)|0);
      var $200 = $198;__label__ = 9; break;
    case 9: // $199
      var $200;
      if ($200) { __label__ = 10; break; } else { __label__ = 70; break; }
    case 10: // $201
      var $202=$164;
      var $203=$save_state;
      var $204=$202;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($203)>>2)]=HEAP32[(($204)>>2)];HEAP32[(($203+4)>>2)]=HEAP32[(($204+4)>>2)];
      var $205=$168;
      var $206=$167;
      var $207=$fend;
      var $208=$165;
      var $209=$207;
      var $210=$208;
      var $211=(($209-$210)|0);
      var $212=(((($211)|0)/4)|0);
      var $213=$169;
      var $214=$168;
      var $215=$213;
      var $216=$214;
      var $217=(($215-$216)|0);
      var $218=$164;
      var $219=(($171+8)|0);
      var $220=HEAP32[(($219)>>2)];
      var $221=$152;
      var $222=$153;
      var $223=$154;
      var $224=$155;
      var $225=$156;
      var $226=$157;
      var $227=$158;
      var $228=$__current_i;
      var $229=$159;
      var $230=$160;
      var $231=$161;
      HEAP32[(($153)>>2)]=$205;
      HEAP32[(($154)>>2)]=$206;
      HEAP32[(($155)>>2)]=$212;
      HEAP32[(($156)>>2)]=$217;
      HEAP32[(($157)>>2)]=$218;
      HEAP32[(($158)>>2)]=$220;
      var $232=HEAP32[(($158)>>2)];
      var $233=_uselocale($232);
      var $234=$149;
      var $235=$150;
      var $236=$151;
      HEAP32[(($149)>>2)]=$__current_i;
      HEAP32[(($150)>>2)]=$233;
      HEAP32[(($151)>>2)]=1680;
      var $237=HEAP32[(($149)>>2)];
      var $238=HEAP32[(($150)>>2)];
      var $239=HEAP32[(($151)>>2)];
      var $240=$146;
      var $241=$147;
      var $242=$148;
      HEAP32[(($146)>>2)]=$237;
      HEAP32[(($147)>>2)]=$238;
      HEAP32[(($148)>>2)]=$239;
      var $243=HEAP32[(($146)>>2)];
      var $244=(($243)|0);
      var $245=$145;
      HEAP32[(($145)>>2)]=$147;
      var $246=HEAP32[(($145)>>2)];
      var $247=$145;
      var $248=HEAP32[(($246)>>2)];
      var $249=$131;
      HEAP32[(($131)>>2)]=$148;
      var $250=HEAP32[(($131)>>2)];
      var $251=$131;
      var $252=HEAP32[(($250)>>2)];
      var $253=$142;
      var $254=$143;
      var $255=$144;
      HEAP32[(($142)>>2)]=$244;
      HEAP32[(($143)>>2)]=$248;
      HEAP32[(($144)>>2)]=$252;
      var $256=HEAP32[(($142)>>2)];
      var $257=HEAP32[(($143)>>2)];
      var $258=HEAP32[(($144)>>2)];
      var $259=$139;
      var $260=$140;
      var $261=$141;
      HEAP32[(($139)>>2)]=$256;
      HEAP32[(($140)>>2)]=$257;
      HEAP32[(($141)>>2)]=$258;
      var $262=HEAP32[(($139)>>2)];
      var $263=$262;
      var $264=$138;
      HEAP32[(($138)>>2)]=$140;
      var $265=HEAP32[(($138)>>2)];
      var $266=$138;
      var $267=HEAP32[(($265)>>2)];
      var $268=$132;
      HEAP32[(($132)>>2)]=$141;
      var $269=HEAP32[(($132)>>2)];
      var $270=$132;
      var $271=HEAP32[(($269)>>2)];
      var $272=$135;
      var $273=$136;
      var $274=$137;
      HEAP32[(($135)>>2)]=$263;
      HEAP32[(($136)>>2)]=$267;
      HEAP32[(($137)>>2)]=$271;
      var $275=HEAP32[(($135)>>2)];
      var $276=(($275)|0);
      var $277=$134;
      HEAP32[(($134)>>2)]=$136;
      var $278=HEAP32[(($134)>>2)];
      var $279=$134;
      var $280=HEAP32[(($278)>>2)];
      HEAP32[(($276)>>2)]=$280;
      var $281=(($275+4)|0);
      var $282=$133;
      HEAP32[(($133)>>2)]=$137;
      var $283=HEAP32[(($133)>>2)];
      var $284=$133;
      var $285=HEAP32[(($283)>>2)];
      HEAP32[(($281)>>2)]=$285;
      var $286=$135;
      var $287=$136;
      var $288=$137;
      var $289=$139;
      var $290=$140;
      var $291=$141;
      var $292=$142;
      var $293=$143;
      var $294=$144;
      var $295=$146;
      var $296=$147;
      var $297=$148;
      var $298=$149;
      var $299=$150;
      var $300=$151;
      var $301=HEAP32[(($153)>>2)];
      var $302=HEAP32[(($154)>>2)];
      var $303=HEAP32[(($155)>>2)];
      var $304=HEAP32[(($156)>>2)];
      var $305=HEAP32[(($157)>>2)];
      var $306=(function() { try { __THREW__ = false; return _wcsnrtombs($301, $302, $303, $304, $305) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $307
      HEAP32[(($152)>>2)]=$306;
      HEAP32[(($161)>>2)]=1;
      var $308=$118;
      HEAP32[(($118)>>2)]=$__current_i;
      var $309=HEAP32[(($118)>>2)];
      var $310=$117;
      HEAP32[(($117)>>2)]=$309;
      var $311=HEAP32[(($117)>>2)];
      var $312=$113;
      var $313=$114;
      var $314=$__tmp_i_i_i1_i;
      var $315=$115;
      var $316=$116;
      HEAP32[(($113)>>2)]=$311;
      HEAP32[(($114)>>2)]=0;
      var $317=HEAP32[(($113)>>2)];
      var $318=(($317)|0);
      var $319=$112;
      HEAP32[(($112)>>2)]=$318;
      var $320=HEAP32[(($112)>>2)];
      var $321=$320;
      var $322=$111;
      HEAP32[(($111)>>2)]=$321;
      var $323=HEAP32[(($111)>>2)];
      var $324=(($323)|0);
      var $325=$111;
      var $326=$112;
      var $327=HEAP32[(($324)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$327;
      var $328=HEAP32[(($114)>>2)];
      var $329=(($317)|0);
      var $330=$110;
      HEAP32[(($110)>>2)]=$329;
      var $331=HEAP32[(($110)>>2)];
      var $332=$331;
      var $333=$109;
      HEAP32[(($109)>>2)]=$332;
      var $334=HEAP32[(($109)>>2)];
      var $335=(($334)|0);
      var $336=$109;
      var $337=$110;
      HEAP32[(($335)>>2)]=$328;
      var $338=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $339=(($338)|0)!=0;
      if ($339) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $340
      var $341=(($317)|0);
      var $342=$108;
      HEAP32[(($108)>>2)]=$341;
      var $343=HEAP32[(($108)>>2)];
      var $344=$343;
      var $345=$107;
      HEAP32[(($107)>>2)]=$344;
      var $346=HEAP32[(($107)>>2)];
      var $347=(($346+4)|0);
      var $348=$107;
      var $349=$108;
      var $350=HEAP32[(($347)>>2)];
      var $351=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $352=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$350]($351) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $353
      __label__ = 20; break;
    case 14: // $354
      var $355=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $356=$355.f0;
      HEAP32[(($115)>>2)]=$356;
      var $357=$355.f1;
      HEAP32[(($116)>>2)]=$357;
      var $358=HEAP32[(($115)>>2)];
      ___cxa_call_unexpected($358);
      throw "Reached an unreachable!"
    case 15: // $359
      var $360=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $361=$360.f0;
      HEAP32[(($159)>>2)]=$361;
      var $362=$360.f1;
      HEAP32[(($160)>>2)]=$362;
      var $363=$130;
      HEAP32[(($130)>>2)]=$__current_i;
      var $364=HEAP32[(($130)>>2)];
      var $365=$129;
      HEAP32[(($129)>>2)]=$364;
      var $366=HEAP32[(($129)>>2)];
      var $367=$125;
      var $368=$126;
      var $369=$__tmp_i_i_i_i;
      var $370=$127;
      var $371=$128;
      HEAP32[(($125)>>2)]=$366;
      HEAP32[(($126)>>2)]=0;
      var $372=HEAP32[(($125)>>2)];
      var $373=(($372)|0);
      var $374=$124;
      HEAP32[(($124)>>2)]=$373;
      var $375=HEAP32[(($124)>>2)];
      var $376=$375;
      var $377=$123;
      HEAP32[(($123)>>2)]=$376;
      var $378=HEAP32[(($123)>>2)];
      var $379=(($378)|0);
      var $380=$123;
      var $381=$124;
      var $382=HEAP32[(($379)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$382;
      var $383=HEAP32[(($126)>>2)];
      var $384=(($372)|0);
      var $385=$122;
      HEAP32[(($122)>>2)]=$384;
      var $386=HEAP32[(($122)>>2)];
      var $387=$386;
      var $388=$121;
      HEAP32[(($121)>>2)]=$387;
      var $389=HEAP32[(($121)>>2)];
      var $390=(($389)|0);
      var $391=$121;
      var $392=$122;
      HEAP32[(($390)>>2)]=$383;
      var $393=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $394=(($393)|0)!=0;
      if ($394) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $395
      var $396=(($372)|0);
      var $397=$120;
      HEAP32[(($120)>>2)]=$396;
      var $398=HEAP32[(($120)>>2)];
      var $399=$398;
      var $400=$119;
      HEAP32[(($119)>>2)]=$399;
      var $401=HEAP32[(($119)>>2)];
      var $402=(($401+4)|0);
      var $403=$119;
      var $404=$120;
      var $405=HEAP32[(($402)>>2)];
      var $406=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $407=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$405]($406) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; };
    case 17: // $408
      __label__ = 19; break;
    case 18: // $409
      var $410=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $411=$410.f0;
      HEAP32[(($127)>>2)]=$411;
      var $412=$410.f1;
      HEAP32[(($128)>>2)]=$412;
      var $413=HEAP32[(($127)>>2)];
      ___cxa_call_unexpected($413);
      throw "Reached an unreachable!"
    case 19: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $414=$125;
      var $415=$126;
      var $416=$__tmp_i_i_i_i;
      var $417=$127;
      var $418=$128;
      var $419=$129;
      var $420=$130;
      var $421=HEAP32[(($159)>>2)];
      var $422=HEAP32[(($159)>>2)];
      var $423=HEAP32[(($160)>>2)];
      var $424=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $422, tempValue);
      var $425=($424.f1 = $423, $424);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $_ZNSt3__114__wcsnrtombs_lEPcPPKwjjP10_mbstate_tPv_exit
      var $426=$113;
      var $427=$114;
      var $428=$__tmp_i_i_i1_i;
      var $429=$115;
      var $430=$116;
      var $431=$117;
      var $432=$118;
      var $433=HEAP32[(($152)>>2)];
      var $434=$152;
      var $435=$153;
      var $436=$154;
      var $437=$155;
      var $438=$156;
      var $439=$157;
      var $440=$158;
      var $441=$__current_i;
      var $442=$159;
      var $443=$160;
      var $444=$161;
      $n=$433;
      var $445=$n;
      var $446=(($445)|0)==-1;
      if ($446) { __label__ = 21; break; } else { __label__ = 38; break; }
    case 21: // $447
      var $448=$168;
      var $449=$170;
      HEAP32[(($449)>>2)]=$448;
      __label__ = 22; break;
    case 22: // $450
      var $451=$165;
      var $452=$167;
      var $453=HEAP32[(($452)>>2)];
      var $454=(($451)|0)!=(($453)|0);
      if ($454) { __label__ = 23; break; } else { __label__ = 37; break; }
    case 23: // $455
      var $456=$170;
      var $457=HEAP32[(($456)>>2)];
      var $458=$165;
      var $459=HEAP32[(($458)>>2)];
      var $460=(($171+8)|0);
      var $461=HEAP32[(($460)>>2)];
      var $462=$99;
      var $463=$100;
      var $464=$101;
      var $465=$102;
      var $466=$103;
      var $467=$__current_i3;
      var $468=$104;
      var $469=$105;
      var $470=$106;
      HEAP32[(($100)>>2)]=$457;
      HEAP32[(($101)>>2)]=$459;
      HEAP32[(($102)>>2)]=$save_state;
      HEAP32[(($103)>>2)]=$461;
      var $471=HEAP32[(($103)>>2)];
      var $472=_uselocale($471);
      var $473=$96;
      var $474=$97;
      var $475=$98;
      HEAP32[(($96)>>2)]=$__current_i3;
      HEAP32[(($97)>>2)]=$472;
      HEAP32[(($98)>>2)]=1680;
      var $476=HEAP32[(($96)>>2)];
      var $477=HEAP32[(($97)>>2)];
      var $478=HEAP32[(($98)>>2)];
      var $479=$93;
      var $480=$94;
      var $481=$95;
      HEAP32[(($93)>>2)]=$476;
      HEAP32[(($94)>>2)]=$477;
      HEAP32[(($95)>>2)]=$478;
      var $482=HEAP32[(($93)>>2)];
      var $483=(($482)|0);
      var $484=$92;
      HEAP32[(($92)>>2)]=$94;
      var $485=HEAP32[(($92)>>2)];
      var $486=$92;
      var $487=HEAP32[(($485)>>2)];
      var $488=$78;
      HEAP32[(($78)>>2)]=$95;
      var $489=HEAP32[(($78)>>2)];
      var $490=$78;
      var $491=HEAP32[(($489)>>2)];
      var $492=$89;
      var $493=$90;
      var $494=$91;
      HEAP32[(($89)>>2)]=$483;
      HEAP32[(($90)>>2)]=$487;
      HEAP32[(($91)>>2)]=$491;
      var $495=HEAP32[(($89)>>2)];
      var $496=HEAP32[(($90)>>2)];
      var $497=HEAP32[(($91)>>2)];
      var $498=$86;
      var $499=$87;
      var $500=$88;
      HEAP32[(($86)>>2)]=$495;
      HEAP32[(($87)>>2)]=$496;
      HEAP32[(($88)>>2)]=$497;
      var $501=HEAP32[(($86)>>2)];
      var $502=$501;
      var $503=$85;
      HEAP32[(($85)>>2)]=$87;
      var $504=HEAP32[(($85)>>2)];
      var $505=$85;
      var $506=HEAP32[(($504)>>2)];
      var $507=$79;
      HEAP32[(($79)>>2)]=$88;
      var $508=HEAP32[(($79)>>2)];
      var $509=$79;
      var $510=HEAP32[(($508)>>2)];
      var $511=$82;
      var $512=$83;
      var $513=$84;
      HEAP32[(($82)>>2)]=$502;
      HEAP32[(($83)>>2)]=$506;
      HEAP32[(($84)>>2)]=$510;
      var $514=HEAP32[(($82)>>2)];
      var $515=(($514)|0);
      var $516=$81;
      HEAP32[(($81)>>2)]=$83;
      var $517=HEAP32[(($81)>>2)];
      var $518=$81;
      var $519=HEAP32[(($517)>>2)];
      HEAP32[(($515)>>2)]=$519;
      var $520=(($514+4)|0);
      var $521=$80;
      HEAP32[(($80)>>2)]=$84;
      var $522=HEAP32[(($80)>>2)];
      var $523=$80;
      var $524=HEAP32[(($522)>>2)];
      HEAP32[(($520)>>2)]=$524;
      var $525=$82;
      var $526=$83;
      var $527=$84;
      var $528=$86;
      var $529=$87;
      var $530=$88;
      var $531=$89;
      var $532=$90;
      var $533=$91;
      var $534=$93;
      var $535=$94;
      var $536=$95;
      var $537=$96;
      var $538=$97;
      var $539=$98;
      var $540=HEAP32[(($100)>>2)];
      var $541=HEAP32[(($101)>>2)];
      var $542=HEAP32[(($102)>>2)];
      var $543=(function() { try { __THREW__ = false; return _wcrtomb($540, $541, $542) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 28; break; };
    case 24: // $544
      HEAP32[(($99)>>2)]=$543;
      HEAP32[(($106)>>2)]=1;
      var $545=$65;
      HEAP32[(($65)>>2)]=$__current_i3;
      var $546=HEAP32[(($65)>>2)];
      var $547=$64;
      HEAP32[(($64)>>2)]=$546;
      var $548=HEAP32[(($64)>>2)];
      var $549=$60;
      var $550=$61;
      var $551=$__tmp_i_i_i1_i1;
      var $552=$62;
      var $553=$63;
      HEAP32[(($60)>>2)]=$548;
      HEAP32[(($61)>>2)]=0;
      var $554=HEAP32[(($60)>>2)];
      var $555=(($554)|0);
      var $556=$59;
      HEAP32[(($59)>>2)]=$555;
      var $557=HEAP32[(($59)>>2)];
      var $558=$557;
      var $559=$58;
      HEAP32[(($58)>>2)]=$558;
      var $560=HEAP32[(($58)>>2)];
      var $561=(($560)|0);
      var $562=$58;
      var $563=$59;
      var $564=HEAP32[(($561)>>2)];
      HEAP32[(($__tmp_i_i_i1_i1)>>2)]=$564;
      var $565=HEAP32[(($61)>>2)];
      var $566=(($554)|0);
      var $567=$57;
      HEAP32[(($57)>>2)]=$566;
      var $568=HEAP32[(($57)>>2)];
      var $569=$568;
      var $570=$56;
      HEAP32[(($56)>>2)]=$569;
      var $571=HEAP32[(($56)>>2)];
      var $572=(($571)|0);
      var $573=$56;
      var $574=$57;
      HEAP32[(($572)>>2)]=$565;
      var $575=HEAP32[(($__tmp_i_i_i1_i1)>>2)];
      var $576=(($575)|0)!=0;
      if ($576) { __label__ = 25; break; } else { __label__ = 33; break; }
    case 25: // $577
      var $578=(($554)|0);
      var $579=$55;
      HEAP32[(($55)>>2)]=$578;
      var $580=HEAP32[(($55)>>2)];
      var $581=$580;
      var $582=$54;
      HEAP32[(($54)>>2)]=$581;
      var $583=HEAP32[(($54)>>2)];
      var $584=(($583+4)|0);
      var $585=$54;
      var $586=$55;
      var $587=HEAP32[(($584)>>2)];
      var $588=HEAP32[(($__tmp_i_i_i1_i1)>>2)];
      var $589=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$587]($588) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 27; break; };
    case 26: // $590
      __label__ = 33; break;
    case 27: // $591
      var $592=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $593=$592.f0;
      HEAP32[(($62)>>2)]=$593;
      var $594=$592.f1;
      HEAP32[(($63)>>2)]=$594;
      var $595=HEAP32[(($62)>>2)];
      ___cxa_call_unexpected($595);
      throw "Reached an unreachable!"
    case 28: // $596
      var $597=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $598=$597.f0;
      HEAP32[(($104)>>2)]=$598;
      var $599=$597.f1;
      HEAP32[(($105)>>2)]=$599;
      var $600=$77;
      HEAP32[(($77)>>2)]=$__current_i3;
      var $601=HEAP32[(($77)>>2)];
      var $602=$76;
      HEAP32[(($76)>>2)]=$601;
      var $603=HEAP32[(($76)>>2)];
      var $604=$72;
      var $605=$73;
      var $606=$__tmp_i_i_i_i2;
      var $607=$74;
      var $608=$75;
      HEAP32[(($72)>>2)]=$603;
      HEAP32[(($73)>>2)]=0;
      var $609=HEAP32[(($72)>>2)];
      var $610=(($609)|0);
      var $611=$71;
      HEAP32[(($71)>>2)]=$610;
      var $612=HEAP32[(($71)>>2)];
      var $613=$612;
      var $614=$70;
      HEAP32[(($70)>>2)]=$613;
      var $615=HEAP32[(($70)>>2)];
      var $616=(($615)|0);
      var $617=$70;
      var $618=$71;
      var $619=HEAP32[(($616)>>2)];
      HEAP32[(($__tmp_i_i_i_i2)>>2)]=$619;
      var $620=HEAP32[(($73)>>2)];
      var $621=(($609)|0);
      var $622=$69;
      HEAP32[(($69)>>2)]=$621;
      var $623=HEAP32[(($69)>>2)];
      var $624=$623;
      var $625=$68;
      HEAP32[(($68)>>2)]=$624;
      var $626=HEAP32[(($68)>>2)];
      var $627=(($626)|0);
      var $628=$68;
      var $629=$69;
      HEAP32[(($627)>>2)]=$620;
      var $630=HEAP32[(($__tmp_i_i_i_i2)>>2)];
      var $631=(($630)|0)!=0;
      if ($631) { __label__ = 29; break; } else { __label__ = 32; break; }
    case 29: // $632
      var $633=(($609)|0);
      var $634=$67;
      HEAP32[(($67)>>2)]=$633;
      var $635=HEAP32[(($67)>>2)];
      var $636=$635;
      var $637=$66;
      HEAP32[(($66)>>2)]=$636;
      var $638=HEAP32[(($66)>>2)];
      var $639=(($638+4)|0);
      var $640=$66;
      var $641=$67;
      var $642=HEAP32[(($639)>>2)];
      var $643=HEAP32[(($__tmp_i_i_i_i2)>>2)];
      var $644=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$642]($643) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 31; break; };
    case 30: // $645
      __label__ = 32; break;
    case 31: // $646
      var $647=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $648=$647.f0;
      HEAP32[(($74)>>2)]=$648;
      var $649=$647.f1;
      HEAP32[(($75)>>2)]=$649;
      var $650=HEAP32[(($74)>>2)];
      ___cxa_call_unexpected($650);
      throw "Reached an unreachable!"
    case 32: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i4
      var $651=$72;
      var $652=$73;
      var $653=$__tmp_i_i_i_i2;
      var $654=$74;
      var $655=$75;
      var $656=$76;
      var $657=$77;
      var $658=HEAP32[(($104)>>2)];
      var $659=HEAP32[(($104)>>2)];
      var $660=HEAP32[(($105)>>2)];
      var $661=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $659, tempValue);
      var $662=($661.f1 = $660, $661);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $_ZNSt3__111__wcrtomb_lEPcwP10_mbstate_tPv_exit
      var $663=$60;
      var $664=$61;
      var $665=$__tmp_i_i_i1_i1;
      var $666=$62;
      var $667=$63;
      var $668=$64;
      var $669=$65;
      var $670=HEAP32[(($99)>>2)];
      var $671=$99;
      var $672=$100;
      var $673=$101;
      var $674=$102;
      var $675=$103;
      var $676=$__current_i3;
      var $677=$104;
      var $678=$105;
      var $679=$106;
      $n=$670;
      var $680=$n;
      var $681=(($680)|0)==-1;
      if ($681) { __label__ = 34; break; } else { __label__ = 35; break; }
    case 34: // $682
      __label__ = 37; break;
    case 35: // $683
      var $684=$n;
      var $685=$170;
      var $686=HEAP32[(($685)>>2)];
      var $687=(($686+$684)|0);
      HEAP32[(($685)>>2)]=$687;
      __label__ = 36; break;
    case 36: // $688
      var $689=$165;
      var $690=(($689+4)|0);
      $165=$690;
      __label__ = 22; break;
    case 37: // $691
      var $692=$165;
      var $693=$167;
      HEAP32[(($693)>>2)]=$692;
      $162=2;
      __label__ = 71; break;
    case 38: // $694
      var $695=$n;
      var $696=(($695)|0)==0;
      if ($696) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $697
      $162=1;
      __label__ = 71; break;
    case 40: // $698
      var $699=$n;
      var $700=$170;
      var $701=HEAP32[(($700)>>2)];
      var $702=(($701+$699)|0);
      HEAP32[(($700)>>2)]=$702;
      var $703=$170;
      var $704=HEAP32[(($703)>>2)];
      var $705=$169;
      var $706=(($704)|0)==(($705)|0);
      if ($706) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $707
      __label__ = 70; break;
    case 42: // $708
      var $709=$fend;
      var $710=$166;
      var $711=(($709)|0)!=(($710)|0);
      if ($711) { __label__ = 43; break; } else { __label__ = 68; break; }
    case 43: // $712
      var $713=(($tmp)|0);
      var $714=$164;
      var $715=(($171+8)|0);
      var $716=HEAP32[(($715)>>2)];
      var $717=$46;
      var $718=$47;
      var $719=$48;
      var $720=$49;
      var $721=$50;
      var $722=$__current_i7;
      var $723=$51;
      var $724=$52;
      var $725=$53;
      HEAP32[(($47)>>2)]=$713;
      HEAP32[(($48)>>2)]=0;
      HEAP32[(($49)>>2)]=$714;
      HEAP32[(($50)>>2)]=$716;
      var $726=HEAP32[(($50)>>2)];
      var $727=_uselocale($726);
      var $728=$43;
      var $729=$44;
      var $730=$45;
      HEAP32[(($43)>>2)]=$__current_i7;
      HEAP32[(($44)>>2)]=$727;
      HEAP32[(($45)>>2)]=1680;
      var $731=HEAP32[(($43)>>2)];
      var $732=HEAP32[(($44)>>2)];
      var $733=HEAP32[(($45)>>2)];
      var $734=$40;
      var $735=$41;
      var $736=$42;
      HEAP32[(($40)>>2)]=$731;
      HEAP32[(($41)>>2)]=$732;
      HEAP32[(($42)>>2)]=$733;
      var $737=HEAP32[(($40)>>2)];
      var $738=(($737)|0);
      var $739=$39;
      HEAP32[(($39)>>2)]=$41;
      var $740=HEAP32[(($39)>>2)];
      var $741=$39;
      var $742=HEAP32[(($740)>>2)];
      var $743=$25;
      HEAP32[(($25)>>2)]=$42;
      var $744=HEAP32[(($25)>>2)];
      var $745=$25;
      var $746=HEAP32[(($744)>>2)];
      var $747=$36;
      var $748=$37;
      var $749=$38;
      HEAP32[(($36)>>2)]=$738;
      HEAP32[(($37)>>2)]=$742;
      HEAP32[(($38)>>2)]=$746;
      var $750=HEAP32[(($36)>>2)];
      var $751=HEAP32[(($37)>>2)];
      var $752=HEAP32[(($38)>>2)];
      var $753=$33;
      var $754=$34;
      var $755=$35;
      HEAP32[(($33)>>2)]=$750;
      HEAP32[(($34)>>2)]=$751;
      HEAP32[(($35)>>2)]=$752;
      var $756=HEAP32[(($33)>>2)];
      var $757=$756;
      var $758=$32;
      HEAP32[(($32)>>2)]=$34;
      var $759=HEAP32[(($32)>>2)];
      var $760=$32;
      var $761=HEAP32[(($759)>>2)];
      var $762=$26;
      HEAP32[(($26)>>2)]=$35;
      var $763=HEAP32[(($26)>>2)];
      var $764=$26;
      var $765=HEAP32[(($763)>>2)];
      var $766=$29;
      var $767=$30;
      var $768=$31;
      HEAP32[(($29)>>2)]=$757;
      HEAP32[(($30)>>2)]=$761;
      HEAP32[(($31)>>2)]=$765;
      var $769=HEAP32[(($29)>>2)];
      var $770=(($769)|0);
      var $771=$28;
      HEAP32[(($28)>>2)]=$30;
      var $772=HEAP32[(($28)>>2)];
      var $773=$28;
      var $774=HEAP32[(($772)>>2)];
      HEAP32[(($770)>>2)]=$774;
      var $775=(($769+4)|0);
      var $776=$27;
      HEAP32[(($27)>>2)]=$31;
      var $777=HEAP32[(($27)>>2)];
      var $778=$27;
      var $779=HEAP32[(($777)>>2)];
      HEAP32[(($775)>>2)]=$779;
      var $780=$29;
      var $781=$30;
      var $782=$31;
      var $783=$33;
      var $784=$34;
      var $785=$35;
      var $786=$36;
      var $787=$37;
      var $788=$38;
      var $789=$40;
      var $790=$41;
      var $791=$42;
      var $792=$43;
      var $793=$44;
      var $794=$45;
      var $795=HEAP32[(($47)>>2)];
      var $796=HEAP32[(($48)>>2)];
      var $797=HEAP32[(($49)>>2)];
      var $798=(function() { try { __THREW__ = false; return _wcrtomb($795, $796, $797) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 44; break; } else { __label__ = 48; break; };
    case 44: // $799
      HEAP32[(($46)>>2)]=$798;
      HEAP32[(($53)>>2)]=1;
      var $800=$12;
      HEAP32[(($12)>>2)]=$__current_i7;
      var $801=HEAP32[(($12)>>2)];
      var $802=$11;
      HEAP32[(($11)>>2)]=$801;
      var $803=HEAP32[(($11)>>2)];
      var $804=$7;
      var $805=$8;
      var $806=$__tmp_i_i_i1_i5;
      var $807=$9;
      var $808=$10;
      HEAP32[(($7)>>2)]=$803;
      HEAP32[(($8)>>2)]=0;
      var $809=HEAP32[(($7)>>2)];
      var $810=(($809)|0);
      var $811=$6;
      HEAP32[(($6)>>2)]=$810;
      var $812=HEAP32[(($6)>>2)];
      var $813=$812;
      var $814=$5;
      HEAP32[(($5)>>2)]=$813;
      var $815=HEAP32[(($5)>>2)];
      var $816=(($815)|0);
      var $817=$5;
      var $818=$6;
      var $819=HEAP32[(($816)>>2)];
      HEAP32[(($__tmp_i_i_i1_i5)>>2)]=$819;
      var $820=HEAP32[(($8)>>2)];
      var $821=(($809)|0);
      var $822=$4;
      HEAP32[(($4)>>2)]=$821;
      var $823=HEAP32[(($4)>>2)];
      var $824=$823;
      var $825=$3;
      HEAP32[(($3)>>2)]=$824;
      var $826=HEAP32[(($3)>>2)];
      var $827=(($826)|0);
      var $828=$3;
      var $829=$4;
      HEAP32[(($827)>>2)]=$820;
      var $830=HEAP32[(($__tmp_i_i_i1_i5)>>2)];
      var $831=(($830)|0)!=0;
      if ($831) { __label__ = 45; break; } else { __label__ = 53; break; }
    case 45: // $832
      var $833=(($809)|0);
      var $834=$2;
      HEAP32[(($2)>>2)]=$833;
      var $835=HEAP32[(($2)>>2)];
      var $836=$835;
      var $837=$1;
      HEAP32[(($1)>>2)]=$836;
      var $838=HEAP32[(($1)>>2)];
      var $839=(($838+4)|0);
      var $840=$1;
      var $841=$2;
      var $842=HEAP32[(($839)>>2)];
      var $843=HEAP32[(($__tmp_i_i_i1_i5)>>2)];
      var $844=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$842]($843) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 46; break; } else { __label__ = 47; break; };
    case 46: // $845
      __label__ = 53; break;
    case 47: // $846
      var $847=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $848=$847.f0;
      HEAP32[(($9)>>2)]=$848;
      var $849=$847.f1;
      HEAP32[(($10)>>2)]=$849;
      var $850=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($850);
      throw "Reached an unreachable!"
    case 48: // $851
      var $852=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $853=$852.f0;
      HEAP32[(($51)>>2)]=$853;
      var $854=$852.f1;
      HEAP32[(($52)>>2)]=$854;
      var $855=$24;
      HEAP32[(($24)>>2)]=$__current_i7;
      var $856=HEAP32[(($24)>>2)];
      var $857=$23;
      HEAP32[(($23)>>2)]=$856;
      var $858=HEAP32[(($23)>>2)];
      var $859=$19;
      var $860=$20;
      var $861=$__tmp_i_i_i_i6;
      var $862=$21;
      var $863=$22;
      HEAP32[(($19)>>2)]=$858;
      HEAP32[(($20)>>2)]=0;
      var $864=HEAP32[(($19)>>2)];
      var $865=(($864)|0);
      var $866=$18;
      HEAP32[(($18)>>2)]=$865;
      var $867=HEAP32[(($18)>>2)];
      var $868=$867;
      var $869=$17;
      HEAP32[(($17)>>2)]=$868;
      var $870=HEAP32[(($17)>>2)];
      var $871=(($870)|0);
      var $872=$17;
      var $873=$18;
      var $874=HEAP32[(($871)>>2)];
      HEAP32[(($__tmp_i_i_i_i6)>>2)]=$874;
      var $875=HEAP32[(($20)>>2)];
      var $876=(($864)|0);
      var $877=$16;
      HEAP32[(($16)>>2)]=$876;
      var $878=HEAP32[(($16)>>2)];
      var $879=$878;
      var $880=$15;
      HEAP32[(($15)>>2)]=$879;
      var $881=HEAP32[(($15)>>2)];
      var $882=(($881)|0);
      var $883=$15;
      var $884=$16;
      HEAP32[(($882)>>2)]=$875;
      var $885=HEAP32[(($__tmp_i_i_i_i6)>>2)];
      var $886=(($885)|0)!=0;
      if ($886) { __label__ = 49; break; } else { __label__ = 52; break; }
    case 49: // $887
      var $888=(($864)|0);
      var $889=$14;
      HEAP32[(($14)>>2)]=$888;
      var $890=HEAP32[(($14)>>2)];
      var $891=$890;
      var $892=$13;
      HEAP32[(($13)>>2)]=$891;
      var $893=HEAP32[(($13)>>2)];
      var $894=(($893+4)|0);
      var $895=$13;
      var $896=$14;
      var $897=HEAP32[(($894)>>2)];
      var $898=HEAP32[(($__tmp_i_i_i_i6)>>2)];
      var $899=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$897]($898) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 50; break; } else { __label__ = 51; break; };
    case 50: // $900
      __label__ = 52; break;
    case 51: // $901
      var $902=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $903=$902.f0;
      HEAP32[(($21)>>2)]=$903;
      var $904=$902.f1;
      HEAP32[(($22)>>2)]=$904;
      var $905=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($905);
      throw "Reached an unreachable!"
    case 52: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i8
      var $906=$19;
      var $907=$20;
      var $908=$__tmp_i_i_i_i6;
      var $909=$21;
      var $910=$22;
      var $911=$23;
      var $912=$24;
      var $913=HEAP32[(($51)>>2)];
      var $914=HEAP32[(($51)>>2)];
      var $915=HEAP32[(($52)>>2)];
      var $916=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $914, tempValue);
      var $917=($916.f1 = $915, $916);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 53: // $_ZNSt3__111__wcrtomb_lEPcwP10_mbstate_tPv_exit9
      var $918=$7;
      var $919=$8;
      var $920=$__tmp_i_i_i1_i5;
      var $921=$9;
      var $922=$10;
      var $923=$11;
      var $924=$12;
      var $925=HEAP32[(($46)>>2)];
      var $926=$46;
      var $927=$47;
      var $928=$48;
      var $929=$49;
      var $930=$50;
      var $931=$__current_i7;
      var $932=$51;
      var $933=$52;
      var $934=$53;
      $n=$925;
      var $935=$n;
      var $936=(($935)|0)==-1;
      if ($936) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $937
      $162=2;
      __label__ = 71; break;
    case 55: // $938
      var $939=$n;
      var $940=$169;
      var $941=$170;
      var $942=HEAP32[(($941)>>2)];
      var $943=$940;
      var $944=$942;
      var $945=(($943-$944)|0);
      var $946=(($939)>>>0) > (($945)>>>0);
      if ($946) { __label__ = 56; break; } else { __label__ = 57; break; }
    case 56: // $947
      $162=1;
      __label__ = 71; break;
    case 57: // $948
      var $949=(($tmp)|0);
      $p=$949;
      __label__ = 58; break;
    case 58: // $950
      var $951=$n;
      var $952=(($951)|0)!=0;
      if ($952) { __label__ = 59; break; } else { __label__ = 61; break; }
    case 59: // $953
      var $954=$p;
      var $955=(($954+1)|0);
      $p=$955;
      var $956=HEAP8[($954)];
      var $957=$170;
      var $958=HEAP32[(($957)>>2)];
      var $959=(($958+1)|0);
      HEAP32[(($957)>>2)]=$959;
      HEAP8[($958)]=$956;
      __label__ = 60; break;
    case 60: // $960
      var $961=$n;
      var $962=(($961-1)|0);
      $n=$962;
      __label__ = 58; break;
    case 61: // $963
      var $964=$167;
      var $965=HEAP32[(($964)>>2)];
      var $966=(($965+4)|0);
      HEAP32[(($964)>>2)]=$966;
      var $967=$167;
      var $968=HEAP32[(($967)>>2)];
      $fend=$968;
      __label__ = 62; break;
    case 62: // $969
      var $970=$fend;
      var $971=$166;
      var $972=(($970)|0)!=(($971)|0);
      if ($972) { __label__ = 63; break; } else { __label__ = 67; break; }
    case 63: // $973
      var $974=$fend;
      var $975=HEAP32[(($974)>>2)];
      var $976=(($975)|0)==0;
      if ($976) { __label__ = 64; break; } else { __label__ = 65; break; }
    case 64: // $977
      __label__ = 67; break;
    case 65: // $978
      __label__ = 66; break;
    case 66: // $979
      var $980=$fend;
      var $981=(($980+4)|0);
      $fend=$981;
      __label__ = 62; break;
    case 67: // $982
      __label__ = 68; break;
    case 68: // $983
      __label__ = 69; break;
    case 69: // $984
      var $985=$167;
      var $986=HEAP32[(($985)>>2)];
      $165=$986;
      var $987=$170;
      var $988=HEAP32[(($987)>>2)];
      $168=$988;
      __label__ = 7; break;
    case 70: // $989
      var $990=$167;
      var $991=HEAP32[(($990)>>2)];
      var $992=$166;
      var $993=(($991)|0)==(($992)|0);
      var $994=$993 ? 0 : 1;
      $162=$994;
      __label__ = 71; break;
    case 71: // $995
      var $996=$162;
      STACKTOP = __stackBase__;
      return $996;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIwc10_mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_["X"]=1;

function __ZNKSt3__17codecvtIwc10_mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_($this, $st, $frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 708; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i5=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i6=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $51=__stackBase__+208;
      var $__current_i7=__stackBase__+212;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55=__stackBase__+232;
      var $56=__stackBase__+236;
      var $57=__stackBase__+240;
      var $58=__stackBase__+244;
      var $59=__stackBase__+248;
      var $60=__stackBase__+252;
      var $61=__stackBase__+256;
      var $62=__stackBase__+260;
      var $__tmp_i_i_i1_i1=__stackBase__+264;
      var $63=__stackBase__+268;
      var $64=__stackBase__+272;
      var $65=__stackBase__+276;
      var $66=__stackBase__+280;
      var $67=__stackBase__+284;
      var $68=__stackBase__+288;
      var $69=__stackBase__+292;
      var $70=__stackBase__+296;
      var $71=__stackBase__+300;
      var $72=__stackBase__+304;
      var $73=__stackBase__+308;
      var $74=__stackBase__+312;
      var $__tmp_i_i_i_i2=__stackBase__+316;
      var $75=__stackBase__+320;
      var $76=__stackBase__+324;
      var $77=__stackBase__+328;
      var $78=__stackBase__+332;
      var $79=__stackBase__+336;
      var $80=__stackBase__+340;
      var $81=__stackBase__+344;
      var $82=__stackBase__+348;
      var $83=__stackBase__+352;
      var $84=__stackBase__+356;
      var $85=__stackBase__+360;
      var $86=__stackBase__+364;
      var $87=__stackBase__+368;
      var $88=__stackBase__+372;
      var $89=__stackBase__+376;
      var $90=__stackBase__+380;
      var $91=__stackBase__+384;
      var $92=__stackBase__+388;
      var $93=__stackBase__+392;
      var $94=__stackBase__+396;
      var $95=__stackBase__+400;
      var $96=__stackBase__+404;
      var $97=__stackBase__+408;
      var $98=__stackBase__+412;
      var $99=__stackBase__+416;
      var $100=__stackBase__+420;
      var $101=__stackBase__+424;
      var $102=__stackBase__+428;
      var $103=__stackBase__+432;
      var $104=__stackBase__+436;
      var $105=__stackBase__+440;
      var $__current_i3=__stackBase__+444;
      var $106=__stackBase__+452;
      var $107=__stackBase__+456;
      var $108=__stackBase__+460;
      var $109=__stackBase__+464;
      var $110=__stackBase__+468;
      var $111=__stackBase__+472;
      var $112=__stackBase__+476;
      var $113=__stackBase__+480;
      var $114=__stackBase__+484;
      var $115=__stackBase__+488;
      var $116=__stackBase__+492;
      var $__tmp_i_i_i1_i=__stackBase__+496;
      var $117=__stackBase__+500;
      var $118=__stackBase__+504;
      var $119=__stackBase__+508;
      var $120=__stackBase__+512;
      var $121=__stackBase__+516;
      var $122=__stackBase__+520;
      var $123=__stackBase__+524;
      var $124=__stackBase__+528;
      var $125=__stackBase__+532;
      var $126=__stackBase__+536;
      var $127=__stackBase__+540;
      var $128=__stackBase__+544;
      var $__tmp_i_i_i_i=__stackBase__+548;
      var $129=__stackBase__+552;
      var $130=__stackBase__+556;
      var $131=__stackBase__+560;
      var $132=__stackBase__+564;
      var $133=__stackBase__+568;
      var $134=__stackBase__+572;
      var $135=__stackBase__+576;
      var $136=__stackBase__+580;
      var $137=__stackBase__+584;
      var $138=__stackBase__+588;
      var $139=__stackBase__+592;
      var $140=__stackBase__+596;
      var $141=__stackBase__+600;
      var $142=__stackBase__+604;
      var $143=__stackBase__+608;
      var $144=__stackBase__+612;
      var $145=__stackBase__+616;
      var $146=__stackBase__+620;
      var $147=__stackBase__+624;
      var $148=__stackBase__+628;
      var $149=__stackBase__+632;
      var $150=__stackBase__+636;
      var $151=__stackBase__+640;
      var $152=__stackBase__+644;
      var $153=__stackBase__+648;
      var $154=__stackBase__+652;
      var $155=__stackBase__+656;
      var $156=__stackBase__+660;
      var $157=__stackBase__+664;
      var $158=__stackBase__+668;
      var $159=__stackBase__+672;
      var $160=__stackBase__+676;
      var $__current_i=__stackBase__+680;
      var $161=__stackBase__+688;
      var $162=__stackBase__+692;
      var $163=__stackBase__+696;
      var $164;
      var $165;
      var $166;
      var $167;
      var $168;
      var $169;
      var $170;
      var $171;
      var $172;
      var $fend;
      var $save_state=__stackBase__+700;
      var $n;
      $165=$this;
      $166=$st;
      $167=$frm;
      $168=$frm_end;
      $169=$frm_nxt;
      $170=$to;
      $171=$to_end;
      $172=$to_nxt;
      var $173=$165;
      var $174=$167;
      $fend=$174;
      __label__ = 1; break;
    case 1: // $175
      var $176=$fend;
      var $177=$168;
      var $178=(($176)|0)!=(($177)|0);
      if ($178) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $179
      var $180=$fend;
      var $181=HEAP8[($180)];
      var $182=(($181 << 24) >> 24);
      var $183=(($182)|0)==0;
      if ($183) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $184
      __label__ = 6; break;
    case 4: // $185
      __label__ = 5; break;
    case 5: // $186
      var $187=$fend;
      var $188=(($187+1)|0);
      $fend=$188;
      __label__ = 1; break;
    case 6: // $189
      var $190=$170;
      var $191=$172;
      HEAP32[(($191)>>2)]=$190;
      var $192=$167;
      var $193=$169;
      HEAP32[(($193)>>2)]=$192;
      __label__ = 7; break;
    case 7: // $194
      var $195=$167;
      var $196=$168;
      var $197=(($195)|0)!=(($196)|0);
      if ($197) { __label__ = 8; break; } else { var $203 = 0;__label__ = 9; break; }
    case 8: // $198
      var $199=$170;
      var $200=$171;
      var $201=(($199)|0)!=(($200)|0);
      var $203 = $201;__label__ = 9; break;
    case 9: // $202
      var $203;
      if ($203) { __label__ = 10; break; } else { __label__ = 67; break; }
    case 10: // $204
      var $205=$166;
      var $206=$save_state;
      var $207=$205;
      assert(8 % 1 === 0, 'memcpy given ' + 8 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($206)>>2)]=HEAP32[(($207)>>2)];HEAP32[(($206+4)>>2)]=HEAP32[(($207+4)>>2)];
      var $208=$170;
      var $209=$169;
      var $210=$fend;
      var $211=$167;
      var $212=$210;
      var $213=$211;
      var $214=(($212-$213)|0);
      var $215=$171;
      var $216=$170;
      var $217=$215;
      var $218=$216;
      var $219=(($217-$218)|0);
      var $220=(((($219)|0)/4)|0);
      var $221=$166;
      var $222=(($173+8)|0);
      var $223=HEAP32[(($222)>>2)];
      var $224=$154;
      var $225=$155;
      var $226=$156;
      var $227=$157;
      var $228=$158;
      var $229=$159;
      var $230=$160;
      var $231=$__current_i;
      var $232=$161;
      var $233=$162;
      var $234=$163;
      HEAP32[(($155)>>2)]=$208;
      HEAP32[(($156)>>2)]=$209;
      HEAP32[(($157)>>2)]=$214;
      HEAP32[(($158)>>2)]=$220;
      HEAP32[(($159)>>2)]=$221;
      HEAP32[(($160)>>2)]=$223;
      var $235=HEAP32[(($160)>>2)];
      var $236=_uselocale($235);
      var $237=$151;
      var $238=$152;
      var $239=$153;
      HEAP32[(($151)>>2)]=$__current_i;
      HEAP32[(($152)>>2)]=$236;
      HEAP32[(($153)>>2)]=1680;
      var $240=HEAP32[(($151)>>2)];
      var $241=HEAP32[(($152)>>2)];
      var $242=HEAP32[(($153)>>2)];
      var $243=$148;
      var $244=$149;
      var $245=$150;
      HEAP32[(($148)>>2)]=$240;
      HEAP32[(($149)>>2)]=$241;
      HEAP32[(($150)>>2)]=$242;
      var $246=HEAP32[(($148)>>2)];
      var $247=(($246)|0);
      var $248=$147;
      HEAP32[(($147)>>2)]=$149;
      var $249=HEAP32[(($147)>>2)];
      var $250=$147;
      var $251=HEAP32[(($249)>>2)];
      var $252=$133;
      HEAP32[(($133)>>2)]=$150;
      var $253=HEAP32[(($133)>>2)];
      var $254=$133;
      var $255=HEAP32[(($253)>>2)];
      var $256=$144;
      var $257=$145;
      var $258=$146;
      HEAP32[(($144)>>2)]=$247;
      HEAP32[(($145)>>2)]=$251;
      HEAP32[(($146)>>2)]=$255;
      var $259=HEAP32[(($144)>>2)];
      var $260=HEAP32[(($145)>>2)];
      var $261=HEAP32[(($146)>>2)];
      var $262=$141;
      var $263=$142;
      var $264=$143;
      HEAP32[(($141)>>2)]=$259;
      HEAP32[(($142)>>2)]=$260;
      HEAP32[(($143)>>2)]=$261;
      var $265=HEAP32[(($141)>>2)];
      var $266=$265;
      var $267=$140;
      HEAP32[(($140)>>2)]=$142;
      var $268=HEAP32[(($140)>>2)];
      var $269=$140;
      var $270=HEAP32[(($268)>>2)];
      var $271=$134;
      HEAP32[(($134)>>2)]=$143;
      var $272=HEAP32[(($134)>>2)];
      var $273=$134;
      var $274=HEAP32[(($272)>>2)];
      var $275=$137;
      var $276=$138;
      var $277=$139;
      HEAP32[(($137)>>2)]=$266;
      HEAP32[(($138)>>2)]=$270;
      HEAP32[(($139)>>2)]=$274;
      var $278=HEAP32[(($137)>>2)];
      var $279=(($278)|0);
      var $280=$136;
      HEAP32[(($136)>>2)]=$138;
      var $281=HEAP32[(($136)>>2)];
      var $282=$136;
      var $283=HEAP32[(($281)>>2)];
      HEAP32[(($279)>>2)]=$283;
      var $284=(($278+4)|0);
      var $285=$135;
      HEAP32[(($135)>>2)]=$139;
      var $286=HEAP32[(($135)>>2)];
      var $287=$135;
      var $288=HEAP32[(($286)>>2)];
      HEAP32[(($284)>>2)]=$288;
      var $289=$137;
      var $290=$138;
      var $291=$139;
      var $292=$141;
      var $293=$142;
      var $294=$143;
      var $295=$144;
      var $296=$145;
      var $297=$146;
      var $298=$148;
      var $299=$149;
      var $300=$150;
      var $301=$151;
      var $302=$152;
      var $303=$153;
      var $304=HEAP32[(($155)>>2)];
      var $305=HEAP32[(($156)>>2)];
      var $306=HEAP32[(($157)>>2)];
      var $307=HEAP32[(($158)>>2)];
      var $308=HEAP32[(($159)>>2)];
      var $309=(function() { try { __THREW__ = false; return _mbsnrtowcs($304, $305, $306, $307, $308) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 15; break; };
    case 11: // $310
      HEAP32[(($154)>>2)]=$309;
      HEAP32[(($163)>>2)]=1;
      var $311=$120;
      HEAP32[(($120)>>2)]=$__current_i;
      var $312=HEAP32[(($120)>>2)];
      var $313=$119;
      HEAP32[(($119)>>2)]=$312;
      var $314=HEAP32[(($119)>>2)];
      var $315=$115;
      var $316=$116;
      var $317=$__tmp_i_i_i1_i;
      var $318=$117;
      var $319=$118;
      HEAP32[(($115)>>2)]=$314;
      HEAP32[(($116)>>2)]=0;
      var $320=HEAP32[(($115)>>2)];
      var $321=(($320)|0);
      var $322=$114;
      HEAP32[(($114)>>2)]=$321;
      var $323=HEAP32[(($114)>>2)];
      var $324=$323;
      var $325=$113;
      HEAP32[(($113)>>2)]=$324;
      var $326=HEAP32[(($113)>>2)];
      var $327=(($326)|0);
      var $328=$113;
      var $329=$114;
      var $330=HEAP32[(($327)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$330;
      var $331=HEAP32[(($116)>>2)];
      var $332=(($320)|0);
      var $333=$112;
      HEAP32[(($112)>>2)]=$332;
      var $334=HEAP32[(($112)>>2)];
      var $335=$334;
      var $336=$111;
      HEAP32[(($111)>>2)]=$335;
      var $337=HEAP32[(($111)>>2)];
      var $338=(($337)|0);
      var $339=$111;
      var $340=$112;
      HEAP32[(($338)>>2)]=$331;
      var $341=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $342=(($341)|0)!=0;
      if ($342) { __label__ = 12; break; } else { __label__ = 20; break; }
    case 12: // $343
      var $344=(($320)|0);
      var $345=$110;
      HEAP32[(($110)>>2)]=$344;
      var $346=HEAP32[(($110)>>2)];
      var $347=$346;
      var $348=$109;
      HEAP32[(($109)>>2)]=$347;
      var $349=HEAP32[(($109)>>2)];
      var $350=(($349+4)|0);
      var $351=$109;
      var $352=$110;
      var $353=HEAP32[(($350)>>2)];
      var $354=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $355=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$353]($354) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 13; break; } else { __label__ = 14; break; };
    case 13: // $356
      __label__ = 20; break;
    case 14: // $357
      var $358=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $359=$358.f0;
      HEAP32[(($117)>>2)]=$359;
      var $360=$358.f1;
      HEAP32[(($118)>>2)]=$360;
      var $361=HEAP32[(($117)>>2)];
      ___cxa_call_unexpected($361);
      throw "Reached an unreachable!"
    case 15: // $362
      var $363=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $364=$363.f0;
      HEAP32[(($161)>>2)]=$364;
      var $365=$363.f1;
      HEAP32[(($162)>>2)]=$365;
      var $366=$132;
      HEAP32[(($132)>>2)]=$__current_i;
      var $367=HEAP32[(($132)>>2)];
      var $368=$131;
      HEAP32[(($131)>>2)]=$367;
      var $369=HEAP32[(($131)>>2)];
      var $370=$127;
      var $371=$128;
      var $372=$__tmp_i_i_i_i;
      var $373=$129;
      var $374=$130;
      HEAP32[(($127)>>2)]=$369;
      HEAP32[(($128)>>2)]=0;
      var $375=HEAP32[(($127)>>2)];
      var $376=(($375)|0);
      var $377=$126;
      HEAP32[(($126)>>2)]=$376;
      var $378=HEAP32[(($126)>>2)];
      var $379=$378;
      var $380=$125;
      HEAP32[(($125)>>2)]=$379;
      var $381=HEAP32[(($125)>>2)];
      var $382=(($381)|0);
      var $383=$125;
      var $384=$126;
      var $385=HEAP32[(($382)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$385;
      var $386=HEAP32[(($128)>>2)];
      var $387=(($375)|0);
      var $388=$124;
      HEAP32[(($124)>>2)]=$387;
      var $389=HEAP32[(($124)>>2)];
      var $390=$389;
      var $391=$123;
      HEAP32[(($123)>>2)]=$390;
      var $392=HEAP32[(($123)>>2)];
      var $393=(($392)|0);
      var $394=$123;
      var $395=$124;
      HEAP32[(($393)>>2)]=$386;
      var $396=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $397=(($396)|0)!=0;
      if ($397) { __label__ = 16; break; } else { __label__ = 19; break; }
    case 16: // $398
      var $399=(($375)|0);
      var $400=$122;
      HEAP32[(($122)>>2)]=$399;
      var $401=HEAP32[(($122)>>2)];
      var $402=$401;
      var $403=$121;
      HEAP32[(($121)>>2)]=$402;
      var $404=HEAP32[(($121)>>2)];
      var $405=(($404+4)|0);
      var $406=$121;
      var $407=$122;
      var $408=HEAP32[(($405)>>2)];
      var $409=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $410=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$408]($409) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 17; break; } else { __label__ = 18; break; };
    case 17: // $411
      __label__ = 19; break;
    case 18: // $412
      var $413=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $414=$413.f0;
      HEAP32[(($129)>>2)]=$414;
      var $415=$413.f1;
      HEAP32[(($130)>>2)]=$415;
      var $416=HEAP32[(($129)>>2)];
      ___cxa_call_unexpected($416);
      throw "Reached an unreachable!"
    case 19: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $417=$127;
      var $418=$128;
      var $419=$__tmp_i_i_i_i;
      var $420=$129;
      var $421=$130;
      var $422=$131;
      var $423=$132;
      var $424=HEAP32[(($161)>>2)];
      var $425=HEAP32[(($161)>>2)];
      var $426=HEAP32[(($162)>>2)];
      var $427=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $425, tempValue);
      var $428=($427.f1 = $426, $427);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 20: // $_ZNSt3__114__mbsnrtowcs_lEPwPPKcjjP10_mbstate_tPv_exit
      var $429=$115;
      var $430=$116;
      var $431=$__tmp_i_i_i1_i;
      var $432=$117;
      var $433=$118;
      var $434=$119;
      var $435=$120;
      var $436=HEAP32[(($154)>>2)];
      var $437=$154;
      var $438=$155;
      var $439=$156;
      var $440=$157;
      var $441=$158;
      var $442=$159;
      var $443=$160;
      var $444=$__current_i;
      var $445=$161;
      var $446=$162;
      var $447=$163;
      $n=$436;
      var $448=$n;
      var $449=(($448)|0)==-1;
      if ($449) { __label__ = 21; break; } else { __label__ = 41; break; }
    case 21: // $450
      var $451=$170;
      var $452=$172;
      HEAP32[(($452)>>2)]=$451;
      __label__ = 22; break;
    case 22: // $453
      var $454=$167;
      var $455=$169;
      var $456=HEAP32[(($455)>>2)];
      var $457=(($454)|0)!=(($456)|0);
      if ($457) { __label__ = 23; break; } else { __label__ = 40; break; }
    case 23: // $458
      var $459=$172;
      var $460=HEAP32[(($459)>>2)];
      var $461=$167;
      var $462=$fend;
      var $463=$167;
      var $464=$462;
      var $465=$463;
      var $466=(($464-$465)|0);
      var $467=(($173+8)|0);
      var $468=HEAP32[(($467)>>2)];
      var $469=$100;
      var $470=$101;
      var $471=$102;
      var $472=$103;
      var $473=$104;
      var $474=$105;
      var $475=$__current_i3;
      var $476=$106;
      var $477=$107;
      var $478=$108;
      HEAP32[(($101)>>2)]=$460;
      HEAP32[(($102)>>2)]=$461;
      HEAP32[(($103)>>2)]=$466;
      HEAP32[(($104)>>2)]=$save_state;
      HEAP32[(($105)>>2)]=$468;
      var $479=HEAP32[(($105)>>2)];
      var $480=_uselocale($479);
      var $481=$97;
      var $482=$98;
      var $483=$99;
      HEAP32[(($97)>>2)]=$__current_i3;
      HEAP32[(($98)>>2)]=$480;
      HEAP32[(($99)>>2)]=1680;
      var $484=HEAP32[(($97)>>2)];
      var $485=HEAP32[(($98)>>2)];
      var $486=HEAP32[(($99)>>2)];
      var $487=$94;
      var $488=$95;
      var $489=$96;
      HEAP32[(($94)>>2)]=$484;
      HEAP32[(($95)>>2)]=$485;
      HEAP32[(($96)>>2)]=$486;
      var $490=HEAP32[(($94)>>2)];
      var $491=(($490)|0);
      var $492=$93;
      HEAP32[(($93)>>2)]=$95;
      var $493=HEAP32[(($93)>>2)];
      var $494=$93;
      var $495=HEAP32[(($493)>>2)];
      var $496=$79;
      HEAP32[(($79)>>2)]=$96;
      var $497=HEAP32[(($79)>>2)];
      var $498=$79;
      var $499=HEAP32[(($497)>>2)];
      var $500=$90;
      var $501=$91;
      var $502=$92;
      HEAP32[(($90)>>2)]=$491;
      HEAP32[(($91)>>2)]=$495;
      HEAP32[(($92)>>2)]=$499;
      var $503=HEAP32[(($90)>>2)];
      var $504=HEAP32[(($91)>>2)];
      var $505=HEAP32[(($92)>>2)];
      var $506=$87;
      var $507=$88;
      var $508=$89;
      HEAP32[(($87)>>2)]=$503;
      HEAP32[(($88)>>2)]=$504;
      HEAP32[(($89)>>2)]=$505;
      var $509=HEAP32[(($87)>>2)];
      var $510=$509;
      var $511=$86;
      HEAP32[(($86)>>2)]=$88;
      var $512=HEAP32[(($86)>>2)];
      var $513=$86;
      var $514=HEAP32[(($512)>>2)];
      var $515=$80;
      HEAP32[(($80)>>2)]=$89;
      var $516=HEAP32[(($80)>>2)];
      var $517=$80;
      var $518=HEAP32[(($516)>>2)];
      var $519=$83;
      var $520=$84;
      var $521=$85;
      HEAP32[(($83)>>2)]=$510;
      HEAP32[(($84)>>2)]=$514;
      HEAP32[(($85)>>2)]=$518;
      var $522=HEAP32[(($83)>>2)];
      var $523=(($522)|0);
      var $524=$82;
      HEAP32[(($82)>>2)]=$84;
      var $525=HEAP32[(($82)>>2)];
      var $526=$82;
      var $527=HEAP32[(($525)>>2)];
      HEAP32[(($523)>>2)]=$527;
      var $528=(($522+4)|0);
      var $529=$81;
      HEAP32[(($81)>>2)]=$85;
      var $530=HEAP32[(($81)>>2)];
      var $531=$81;
      var $532=HEAP32[(($530)>>2)];
      HEAP32[(($528)>>2)]=$532;
      var $533=$83;
      var $534=$84;
      var $535=$85;
      var $536=$87;
      var $537=$88;
      var $538=$89;
      var $539=$90;
      var $540=$91;
      var $541=$92;
      var $542=$94;
      var $543=$95;
      var $544=$96;
      var $545=$97;
      var $546=$98;
      var $547=$99;
      var $548=HEAP32[(($101)>>2)];
      var $549=HEAP32[(($102)>>2)];
      var $550=HEAP32[(($103)>>2)];
      var $551=HEAP32[(($104)>>2)];
      var $552=(function() { try { __THREW__ = false; return _mbrtowc($548, $549, $550, $551) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 24; break; } else { __label__ = 28; break; };
    case 24: // $553
      HEAP32[(($100)>>2)]=$552;
      HEAP32[(($108)>>2)]=1;
      var $554=$66;
      HEAP32[(($66)>>2)]=$__current_i3;
      var $555=HEAP32[(($66)>>2)];
      var $556=$65;
      HEAP32[(($65)>>2)]=$555;
      var $557=HEAP32[(($65)>>2)];
      var $558=$61;
      var $559=$62;
      var $560=$__tmp_i_i_i1_i1;
      var $561=$63;
      var $562=$64;
      HEAP32[(($61)>>2)]=$557;
      HEAP32[(($62)>>2)]=0;
      var $563=HEAP32[(($61)>>2)];
      var $564=(($563)|0);
      var $565=$60;
      HEAP32[(($60)>>2)]=$564;
      var $566=HEAP32[(($60)>>2)];
      var $567=$566;
      var $568=$59;
      HEAP32[(($59)>>2)]=$567;
      var $569=HEAP32[(($59)>>2)];
      var $570=(($569)|0);
      var $571=$59;
      var $572=$60;
      var $573=HEAP32[(($570)>>2)];
      HEAP32[(($__tmp_i_i_i1_i1)>>2)]=$573;
      var $574=HEAP32[(($62)>>2)];
      var $575=(($563)|0);
      var $576=$58;
      HEAP32[(($58)>>2)]=$575;
      var $577=HEAP32[(($58)>>2)];
      var $578=$577;
      var $579=$57;
      HEAP32[(($57)>>2)]=$578;
      var $580=HEAP32[(($57)>>2)];
      var $581=(($580)|0);
      var $582=$57;
      var $583=$58;
      HEAP32[(($581)>>2)]=$574;
      var $584=HEAP32[(($__tmp_i_i_i1_i1)>>2)];
      var $585=(($584)|0)!=0;
      if ($585) { __label__ = 25; break; } else { __label__ = 33; break; }
    case 25: // $586
      var $587=(($563)|0);
      var $588=$56;
      HEAP32[(($56)>>2)]=$587;
      var $589=HEAP32[(($56)>>2)];
      var $590=$589;
      var $591=$55;
      HEAP32[(($55)>>2)]=$590;
      var $592=HEAP32[(($55)>>2)];
      var $593=(($592+4)|0);
      var $594=$55;
      var $595=$56;
      var $596=HEAP32[(($593)>>2)];
      var $597=HEAP32[(($__tmp_i_i_i1_i1)>>2)];
      var $598=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$596]($597) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 26; break; } else { __label__ = 27; break; };
    case 26: // $599
      __label__ = 33; break;
    case 27: // $600
      var $601=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $602=$601.f0;
      HEAP32[(($63)>>2)]=$602;
      var $603=$601.f1;
      HEAP32[(($64)>>2)]=$603;
      var $604=HEAP32[(($63)>>2)];
      ___cxa_call_unexpected($604);
      throw "Reached an unreachable!"
    case 28: // $605
      var $606=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $607=$606.f0;
      HEAP32[(($106)>>2)]=$607;
      var $608=$606.f1;
      HEAP32[(($107)>>2)]=$608;
      var $609=$78;
      HEAP32[(($78)>>2)]=$__current_i3;
      var $610=HEAP32[(($78)>>2)];
      var $611=$77;
      HEAP32[(($77)>>2)]=$610;
      var $612=HEAP32[(($77)>>2)];
      var $613=$73;
      var $614=$74;
      var $615=$__tmp_i_i_i_i2;
      var $616=$75;
      var $617=$76;
      HEAP32[(($73)>>2)]=$612;
      HEAP32[(($74)>>2)]=0;
      var $618=HEAP32[(($73)>>2)];
      var $619=(($618)|0);
      var $620=$72;
      HEAP32[(($72)>>2)]=$619;
      var $621=HEAP32[(($72)>>2)];
      var $622=$621;
      var $623=$71;
      HEAP32[(($71)>>2)]=$622;
      var $624=HEAP32[(($71)>>2)];
      var $625=(($624)|0);
      var $626=$71;
      var $627=$72;
      var $628=HEAP32[(($625)>>2)];
      HEAP32[(($__tmp_i_i_i_i2)>>2)]=$628;
      var $629=HEAP32[(($74)>>2)];
      var $630=(($618)|0);
      var $631=$70;
      HEAP32[(($70)>>2)]=$630;
      var $632=HEAP32[(($70)>>2)];
      var $633=$632;
      var $634=$69;
      HEAP32[(($69)>>2)]=$633;
      var $635=HEAP32[(($69)>>2)];
      var $636=(($635)|0);
      var $637=$69;
      var $638=$70;
      HEAP32[(($636)>>2)]=$629;
      var $639=HEAP32[(($__tmp_i_i_i_i2)>>2)];
      var $640=(($639)|0)!=0;
      if ($640) { __label__ = 29; break; } else { __label__ = 32; break; }
    case 29: // $641
      var $642=(($618)|0);
      var $643=$68;
      HEAP32[(($68)>>2)]=$642;
      var $644=HEAP32[(($68)>>2)];
      var $645=$644;
      var $646=$67;
      HEAP32[(($67)>>2)]=$645;
      var $647=HEAP32[(($67)>>2)];
      var $648=(($647+4)|0);
      var $649=$67;
      var $650=$68;
      var $651=HEAP32[(($648)>>2)];
      var $652=HEAP32[(($__tmp_i_i_i_i2)>>2)];
      var $653=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$651]($652) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 30; break; } else { __label__ = 31; break; };
    case 30: // $654
      __label__ = 32; break;
    case 31: // $655
      var $656=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $657=$656.f0;
      HEAP32[(($75)>>2)]=$657;
      var $658=$656.f1;
      HEAP32[(($76)>>2)]=$658;
      var $659=HEAP32[(($75)>>2)];
      ___cxa_call_unexpected($659);
      throw "Reached an unreachable!"
    case 32: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i4
      var $660=$73;
      var $661=$74;
      var $662=$__tmp_i_i_i_i2;
      var $663=$75;
      var $664=$76;
      var $665=$77;
      var $666=$78;
      var $667=HEAP32[(($106)>>2)];
      var $668=HEAP32[(($106)>>2)];
      var $669=HEAP32[(($107)>>2)];
      var $670=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $668, tempValue);
      var $671=($670.f1 = $669, $670);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 33: // $_ZNSt3__111__mbrtowc_lEPwPKcjP10_mbstate_tPv_exit
      var $672=$61;
      var $673=$62;
      var $674=$__tmp_i_i_i1_i1;
      var $675=$63;
      var $676=$64;
      var $677=$65;
      var $678=$66;
      var $679=HEAP32[(($100)>>2)];
      var $680=$100;
      var $681=$101;
      var $682=$102;
      var $683=$103;
      var $684=$104;
      var $685=$105;
      var $686=$__current_i3;
      var $687=$106;
      var $688=$107;
      var $689=$108;
      $n=$679;
      var $690=$n;
      if ($690 == 0) {
        __label__ = 34; break;
      }
      else if ($690 == -1) {
        __label__ = 35; break;
      }
      else if ($690 == -2) {
        __label__ = 36; break;
      }
      else {
      __label__ = 37; break;
      }
      
    case 34: // $691
      var $692=$167;
      var $693=(($692+1)|0);
      $167=$693;
      __label__ = 38; break;
    case 35: // $694
      var $695=$167;
      var $696=$169;
      HEAP32[(($696)>>2)]=$695;
      $164=2;
      __label__ = 68; break;
    case 36: // $697
      var $698=$167;
      var $699=$169;
      HEAP32[(($699)>>2)]=$698;
      $164=1;
      __label__ = 68; break;
    case 37: // $700
      var $701=$n;
      var $702=$167;
      var $703=(($702+$701)|0);
      $167=$703;
      __label__ = 38; break;
    case 38: // $704
      __label__ = 39; break;
    case 39: // $705
      var $706=$172;
      var $707=HEAP32[(($706)>>2)];
      var $708=(($707+4)|0);
      HEAP32[(($706)>>2)]=$708;
      __label__ = 22; break;
    case 40: // $709
      var $710=$167;
      var $711=$169;
      HEAP32[(($711)>>2)]=$710;
      var $712=$169;
      var $713=HEAP32[(($712)>>2)];
      var $714=$168;
      var $715=(($713)|0)==(($714)|0);
      var $716=$715 ? 0 : 1;
      $164=$716;
      __label__ = 68; break;
    case 41: // $717
      var $718=$n;
      var $719=(($718)|0)==0;
      if ($719) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $720
      $164=2;
      __label__ = 68; break;
    case 43: // $721
      var $722=$n;
      var $723=$172;
      var $724=HEAP32[(($723)>>2)];
      var $725=(($724+($722<<2))|0);
      HEAP32[(($723)>>2)]=$725;
      var $726=$172;
      var $727=HEAP32[(($726)>>2)];
      var $728=$171;
      var $729=(($727)|0)==(($728)|0);
      if ($729) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $730
      __label__ = 67; break;
    case 45: // $731
      var $732=$fend;
      var $733=$168;
      var $734=(($732)|0)!=(($733)|0);
      if ($734) { __label__ = 46; break; } else { __label__ = 65; break; }
    case 46: // $735
      var $736=$172;
      var $737=HEAP32[(($736)>>2)];
      var $738=$169;
      var $739=HEAP32[(($738)>>2)];
      var $740=$166;
      var $741=(($173+8)|0);
      var $742=HEAP32[(($741)>>2)];
      var $743=$46;
      var $744=$47;
      var $745=$48;
      var $746=$49;
      var $747=$50;
      var $748=$51;
      var $749=$__current_i7;
      var $750=$52;
      var $751=$53;
      var $752=$54;
      HEAP32[(($47)>>2)]=$737;
      HEAP32[(($48)>>2)]=$739;
      HEAP32[(($49)>>2)]=1;
      HEAP32[(($50)>>2)]=$740;
      HEAP32[(($51)>>2)]=$742;
      var $753=HEAP32[(($51)>>2)];
      var $754=_uselocale($753);
      var $755=$43;
      var $756=$44;
      var $757=$45;
      HEAP32[(($43)>>2)]=$__current_i7;
      HEAP32[(($44)>>2)]=$754;
      HEAP32[(($45)>>2)]=1680;
      var $758=HEAP32[(($43)>>2)];
      var $759=HEAP32[(($44)>>2)];
      var $760=HEAP32[(($45)>>2)];
      var $761=$40;
      var $762=$41;
      var $763=$42;
      HEAP32[(($40)>>2)]=$758;
      HEAP32[(($41)>>2)]=$759;
      HEAP32[(($42)>>2)]=$760;
      var $764=HEAP32[(($40)>>2)];
      var $765=(($764)|0);
      var $766=$39;
      HEAP32[(($39)>>2)]=$41;
      var $767=HEAP32[(($39)>>2)];
      var $768=$39;
      var $769=HEAP32[(($767)>>2)];
      var $770=$25;
      HEAP32[(($25)>>2)]=$42;
      var $771=HEAP32[(($25)>>2)];
      var $772=$25;
      var $773=HEAP32[(($771)>>2)];
      var $774=$36;
      var $775=$37;
      var $776=$38;
      HEAP32[(($36)>>2)]=$765;
      HEAP32[(($37)>>2)]=$769;
      HEAP32[(($38)>>2)]=$773;
      var $777=HEAP32[(($36)>>2)];
      var $778=HEAP32[(($37)>>2)];
      var $779=HEAP32[(($38)>>2)];
      var $780=$33;
      var $781=$34;
      var $782=$35;
      HEAP32[(($33)>>2)]=$777;
      HEAP32[(($34)>>2)]=$778;
      HEAP32[(($35)>>2)]=$779;
      var $783=HEAP32[(($33)>>2)];
      var $784=$783;
      var $785=$32;
      HEAP32[(($32)>>2)]=$34;
      var $786=HEAP32[(($32)>>2)];
      var $787=$32;
      var $788=HEAP32[(($786)>>2)];
      var $789=$26;
      HEAP32[(($26)>>2)]=$35;
      var $790=HEAP32[(($26)>>2)];
      var $791=$26;
      var $792=HEAP32[(($790)>>2)];
      var $793=$29;
      var $794=$30;
      var $795=$31;
      HEAP32[(($29)>>2)]=$784;
      HEAP32[(($30)>>2)]=$788;
      HEAP32[(($31)>>2)]=$792;
      var $796=HEAP32[(($29)>>2)];
      var $797=(($796)|0);
      var $798=$28;
      HEAP32[(($28)>>2)]=$30;
      var $799=HEAP32[(($28)>>2)];
      var $800=$28;
      var $801=HEAP32[(($799)>>2)];
      HEAP32[(($797)>>2)]=$801;
      var $802=(($796+4)|0);
      var $803=$27;
      HEAP32[(($27)>>2)]=$31;
      var $804=HEAP32[(($27)>>2)];
      var $805=$27;
      var $806=HEAP32[(($804)>>2)];
      HEAP32[(($802)>>2)]=$806;
      var $807=$29;
      var $808=$30;
      var $809=$31;
      var $810=$33;
      var $811=$34;
      var $812=$35;
      var $813=$36;
      var $814=$37;
      var $815=$38;
      var $816=$40;
      var $817=$41;
      var $818=$42;
      var $819=$43;
      var $820=$44;
      var $821=$45;
      var $822=HEAP32[(($47)>>2)];
      var $823=HEAP32[(($48)>>2)];
      var $824=HEAP32[(($49)>>2)];
      var $825=HEAP32[(($50)>>2)];
      var $826=(function() { try { __THREW__ = false; return _mbrtowc($822, $823, $824, $825) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 47; break; } else { __label__ = 51; break; };
    case 47: // $827
      HEAP32[(($46)>>2)]=$826;
      HEAP32[(($54)>>2)]=1;
      var $828=$12;
      HEAP32[(($12)>>2)]=$__current_i7;
      var $829=HEAP32[(($12)>>2)];
      var $830=$11;
      HEAP32[(($11)>>2)]=$829;
      var $831=HEAP32[(($11)>>2)];
      var $832=$7;
      var $833=$8;
      var $834=$__tmp_i_i_i1_i5;
      var $835=$9;
      var $836=$10;
      HEAP32[(($7)>>2)]=$831;
      HEAP32[(($8)>>2)]=0;
      var $837=HEAP32[(($7)>>2)];
      var $838=(($837)|0);
      var $839=$6;
      HEAP32[(($6)>>2)]=$838;
      var $840=HEAP32[(($6)>>2)];
      var $841=$840;
      var $842=$5;
      HEAP32[(($5)>>2)]=$841;
      var $843=HEAP32[(($5)>>2)];
      var $844=(($843)|0);
      var $845=$5;
      var $846=$6;
      var $847=HEAP32[(($844)>>2)];
      HEAP32[(($__tmp_i_i_i1_i5)>>2)]=$847;
      var $848=HEAP32[(($8)>>2)];
      var $849=(($837)|0);
      var $850=$4;
      HEAP32[(($4)>>2)]=$849;
      var $851=HEAP32[(($4)>>2)];
      var $852=$851;
      var $853=$3;
      HEAP32[(($3)>>2)]=$852;
      var $854=HEAP32[(($3)>>2)];
      var $855=(($854)|0);
      var $856=$3;
      var $857=$4;
      HEAP32[(($855)>>2)]=$848;
      var $858=HEAP32[(($__tmp_i_i_i1_i5)>>2)];
      var $859=(($858)|0)!=0;
      if ($859) { __label__ = 48; break; } else { __label__ = 56; break; }
    case 48: // $860
      var $861=(($837)|0);
      var $862=$2;
      HEAP32[(($2)>>2)]=$861;
      var $863=HEAP32[(($2)>>2)];
      var $864=$863;
      var $865=$1;
      HEAP32[(($1)>>2)]=$864;
      var $866=HEAP32[(($1)>>2)];
      var $867=(($866+4)|0);
      var $868=$1;
      var $869=$2;
      var $870=HEAP32[(($867)>>2)];
      var $871=HEAP32[(($__tmp_i_i_i1_i5)>>2)];
      var $872=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$870]($871) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 49; break; } else { __label__ = 50; break; };
    case 49: // $873
      __label__ = 56; break;
    case 50: // $874
      var $875=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $876=$875.f0;
      HEAP32[(($9)>>2)]=$876;
      var $877=$875.f1;
      HEAP32[(($10)>>2)]=$877;
      var $878=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($878);
      throw "Reached an unreachable!"
    case 51: // $879
      var $880=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $881=$880.f0;
      HEAP32[(($52)>>2)]=$881;
      var $882=$880.f1;
      HEAP32[(($53)>>2)]=$882;
      var $883=$24;
      HEAP32[(($24)>>2)]=$__current_i7;
      var $884=HEAP32[(($24)>>2)];
      var $885=$23;
      HEAP32[(($23)>>2)]=$884;
      var $886=HEAP32[(($23)>>2)];
      var $887=$19;
      var $888=$20;
      var $889=$__tmp_i_i_i_i6;
      var $890=$21;
      var $891=$22;
      HEAP32[(($19)>>2)]=$886;
      HEAP32[(($20)>>2)]=0;
      var $892=HEAP32[(($19)>>2)];
      var $893=(($892)|0);
      var $894=$18;
      HEAP32[(($18)>>2)]=$893;
      var $895=HEAP32[(($18)>>2)];
      var $896=$895;
      var $897=$17;
      HEAP32[(($17)>>2)]=$896;
      var $898=HEAP32[(($17)>>2)];
      var $899=(($898)|0);
      var $900=$17;
      var $901=$18;
      var $902=HEAP32[(($899)>>2)];
      HEAP32[(($__tmp_i_i_i_i6)>>2)]=$902;
      var $903=HEAP32[(($20)>>2)];
      var $904=(($892)|0);
      var $905=$16;
      HEAP32[(($16)>>2)]=$904;
      var $906=HEAP32[(($16)>>2)];
      var $907=$906;
      var $908=$15;
      HEAP32[(($15)>>2)]=$907;
      var $909=HEAP32[(($15)>>2)];
      var $910=(($909)|0);
      var $911=$15;
      var $912=$16;
      HEAP32[(($910)>>2)]=$903;
      var $913=HEAP32[(($__tmp_i_i_i_i6)>>2)];
      var $914=(($913)|0)!=0;
      if ($914) { __label__ = 52; break; } else { __label__ = 55; break; }
    case 52: // $915
      var $916=(($892)|0);
      var $917=$14;
      HEAP32[(($14)>>2)]=$916;
      var $918=HEAP32[(($14)>>2)];
      var $919=$918;
      var $920=$13;
      HEAP32[(($13)>>2)]=$919;
      var $921=HEAP32[(($13)>>2)];
      var $922=(($921+4)|0);
      var $923=$13;
      var $924=$14;
      var $925=HEAP32[(($922)>>2)];
      var $926=HEAP32[(($__tmp_i_i_i_i6)>>2)];
      var $927=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$925]($926) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 53; break; } else { __label__ = 54; break; };
    case 53: // $928
      __label__ = 55; break;
    case 54: // $929
      var $930=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $931=$930.f0;
      HEAP32[(($21)>>2)]=$931;
      var $932=$930.f1;
      HEAP32[(($22)>>2)]=$932;
      var $933=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($933);
      throw "Reached an unreachable!"
    case 55: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i8
      var $934=$19;
      var $935=$20;
      var $936=$__tmp_i_i_i_i6;
      var $937=$21;
      var $938=$22;
      var $939=$23;
      var $940=$24;
      var $941=HEAP32[(($52)>>2)];
      var $942=HEAP32[(($52)>>2)];
      var $943=HEAP32[(($53)>>2)];
      var $944=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $942, tempValue);
      var $945=($944.f1 = $943, $944);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 56: // $_ZNSt3__111__mbrtowc_lEPwPKcjP10_mbstate_tPv_exit9
      var $946=$7;
      var $947=$8;
      var $948=$__tmp_i_i_i1_i5;
      var $949=$9;
      var $950=$10;
      var $951=$11;
      var $952=$12;
      var $953=HEAP32[(($46)>>2)];
      var $954=$46;
      var $955=$47;
      var $956=$48;
      var $957=$49;
      var $958=$50;
      var $959=$51;
      var $960=$__current_i7;
      var $961=$52;
      var $962=$53;
      var $963=$54;
      $n=$953;
      var $964=$n;
      var $965=(($964)|0)!=0;
      if ($965) { __label__ = 57; break; } else { __label__ = 58; break; }
    case 57: // $966
      $164=2;
      __label__ = 68; break;
    case 58: // $967
      var $968=$172;
      var $969=HEAP32[(($968)>>2)];
      var $970=(($969+4)|0);
      HEAP32[(($968)>>2)]=$970;
      var $971=$169;
      var $972=HEAP32[(($971)>>2)];
      var $973=(($972+1)|0);
      HEAP32[(($971)>>2)]=$973;
      var $974=$169;
      var $975=HEAP32[(($974)>>2)];
      $fend=$975;
      __label__ = 59; break;
    case 59: // $976
      var $977=$fend;
      var $978=$168;
      var $979=(($977)|0)!=(($978)|0);
      if ($979) { __label__ = 60; break; } else { __label__ = 64; break; }
    case 60: // $980
      var $981=$fend;
      var $982=HEAP8[($981)];
      var $983=(($982 << 24) >> 24);
      var $984=(($983)|0)==0;
      if ($984) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $985
      __label__ = 64; break;
    case 62: // $986
      __label__ = 63; break;
    case 63: // $987
      var $988=$fend;
      var $989=(($988+1)|0);
      $fend=$989;
      __label__ = 59; break;
    case 64: // $990
      __label__ = 65; break;
    case 65: // $991
      __label__ = 66; break;
    case 66: // $992
      var $993=$169;
      var $994=HEAP32[(($993)>>2)];
      $167=$994;
      var $995=$172;
      var $996=HEAP32[(($995)>>2)];
      $170=$996;
      __label__ = 7; break;
    case 67: // $997
      var $998=$169;
      var $999=HEAP32[(($998)>>2)];
      var $1000=$168;
      var $1001=(($999)|0)==(($1000)|0);
      var $1002=$1001 ? 0 : 1;
      $164=$1002;
      __label__ = 68; break;
    case 68: // $1003
      var $1004=$164;
      STACKTOP = __stackBase__;
      return $1004;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIwc10_mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_["X"]=1;

function __ZNKSt3__17codecvtIwc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_($this, $st, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 232; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $__current_i=__stackBase__+208;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54;
      var $55;
      var $56;
      var $57;
      var $58;
      var $59;
      var $tmp=__stackBase__+228;
      var $n;
      var $p;
      $55=$this;
      $56=$st;
      $57=$to;
      $58=$to_end;
      $59=$to_nxt;
      var $60=$55;
      var $61=$57;
      var $62=$59;
      HEAP32[(($62)>>2)]=$61;
      var $63=(($tmp)|0);
      var $64=$56;
      var $65=(($60+8)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=$46;
      var $68=$47;
      var $69=$48;
      var $70=$49;
      var $71=$50;
      var $72=$__current_i;
      var $73=$51;
      var $74=$52;
      var $75=$53;
      HEAP32[(($47)>>2)]=$63;
      HEAP32[(($48)>>2)]=0;
      HEAP32[(($49)>>2)]=$64;
      HEAP32[(($50)>>2)]=$66;
      var $76=HEAP32[(($50)>>2)];
      var $77=_uselocale($76);
      var $78=$43;
      var $79=$44;
      var $80=$45;
      HEAP32[(($43)>>2)]=$__current_i;
      HEAP32[(($44)>>2)]=$77;
      HEAP32[(($45)>>2)]=1680;
      var $81=HEAP32[(($43)>>2)];
      var $82=HEAP32[(($44)>>2)];
      var $83=HEAP32[(($45)>>2)];
      var $84=$40;
      var $85=$41;
      var $86=$42;
      HEAP32[(($40)>>2)]=$81;
      HEAP32[(($41)>>2)]=$82;
      HEAP32[(($42)>>2)]=$83;
      var $87=HEAP32[(($40)>>2)];
      var $88=(($87)|0);
      var $89=$39;
      HEAP32[(($39)>>2)]=$41;
      var $90=HEAP32[(($39)>>2)];
      var $91=$39;
      var $92=HEAP32[(($90)>>2)];
      var $93=$25;
      HEAP32[(($25)>>2)]=$42;
      var $94=HEAP32[(($25)>>2)];
      var $95=$25;
      var $96=HEAP32[(($94)>>2)];
      var $97=$36;
      var $98=$37;
      var $99=$38;
      HEAP32[(($36)>>2)]=$88;
      HEAP32[(($37)>>2)]=$92;
      HEAP32[(($38)>>2)]=$96;
      var $100=HEAP32[(($36)>>2)];
      var $101=HEAP32[(($37)>>2)];
      var $102=HEAP32[(($38)>>2)];
      var $103=$33;
      var $104=$34;
      var $105=$35;
      HEAP32[(($33)>>2)]=$100;
      HEAP32[(($34)>>2)]=$101;
      HEAP32[(($35)>>2)]=$102;
      var $106=HEAP32[(($33)>>2)];
      var $107=$106;
      var $108=$32;
      HEAP32[(($32)>>2)]=$34;
      var $109=HEAP32[(($32)>>2)];
      var $110=$32;
      var $111=HEAP32[(($109)>>2)];
      var $112=$26;
      HEAP32[(($26)>>2)]=$35;
      var $113=HEAP32[(($26)>>2)];
      var $114=$26;
      var $115=HEAP32[(($113)>>2)];
      var $116=$29;
      var $117=$30;
      var $118=$31;
      HEAP32[(($29)>>2)]=$107;
      HEAP32[(($30)>>2)]=$111;
      HEAP32[(($31)>>2)]=$115;
      var $119=HEAP32[(($29)>>2)];
      var $120=(($119)|0);
      var $121=$28;
      HEAP32[(($28)>>2)]=$30;
      var $122=HEAP32[(($28)>>2)];
      var $123=$28;
      var $124=HEAP32[(($122)>>2)];
      HEAP32[(($120)>>2)]=$124;
      var $125=(($119+4)|0);
      var $126=$27;
      HEAP32[(($27)>>2)]=$31;
      var $127=HEAP32[(($27)>>2)];
      var $128=$27;
      var $129=HEAP32[(($127)>>2)];
      HEAP32[(($125)>>2)]=$129;
      var $130=$29;
      var $131=$30;
      var $132=$31;
      var $133=$33;
      var $134=$34;
      var $135=$35;
      var $136=$36;
      var $137=$37;
      var $138=$38;
      var $139=$40;
      var $140=$41;
      var $141=$42;
      var $142=$43;
      var $143=$44;
      var $144=$45;
      var $145=HEAP32[(($47)>>2)];
      var $146=HEAP32[(($48)>>2)];
      var $147=HEAP32[(($49)>>2)];
      var $148=(function() { try { __THREW__ = false; return _wcrtomb($145, $146, $147) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 5; break; };
    case 1: // $149
      HEAP32[(($46)>>2)]=$148;
      HEAP32[(($53)>>2)]=1;
      var $150=$12;
      HEAP32[(($12)>>2)]=$__current_i;
      var $151=HEAP32[(($12)>>2)];
      var $152=$11;
      HEAP32[(($11)>>2)]=$151;
      var $153=HEAP32[(($11)>>2)];
      var $154=$7;
      var $155=$8;
      var $156=$__tmp_i_i_i1_i;
      var $157=$9;
      var $158=$10;
      HEAP32[(($7)>>2)]=$153;
      HEAP32[(($8)>>2)]=0;
      var $159=HEAP32[(($7)>>2)];
      var $160=(($159)|0);
      var $161=$6;
      HEAP32[(($6)>>2)]=$160;
      var $162=HEAP32[(($6)>>2)];
      var $163=$162;
      var $164=$5;
      HEAP32[(($5)>>2)]=$163;
      var $165=HEAP32[(($5)>>2)];
      var $166=(($165)|0);
      var $167=$5;
      var $168=$6;
      var $169=HEAP32[(($166)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$169;
      var $170=HEAP32[(($8)>>2)];
      var $171=(($159)|0);
      var $172=$4;
      HEAP32[(($4)>>2)]=$171;
      var $173=HEAP32[(($4)>>2)];
      var $174=$173;
      var $175=$3;
      HEAP32[(($3)>>2)]=$174;
      var $176=HEAP32[(($3)>>2)];
      var $177=(($176)|0);
      var $178=$3;
      var $179=$4;
      HEAP32[(($177)>>2)]=$170;
      var $180=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $181=(($180)|0)!=0;
      if ($181) { __label__ = 2; break; } else { __label__ = 10; break; }
    case 2: // $182
      var $183=(($159)|0);
      var $184=$2;
      HEAP32[(($2)>>2)]=$183;
      var $185=HEAP32[(($2)>>2)];
      var $186=$185;
      var $187=$1;
      HEAP32[(($1)>>2)]=$186;
      var $188=HEAP32[(($1)>>2)];
      var $189=(($188+4)|0);
      var $190=$1;
      var $191=$2;
      var $192=HEAP32[(($189)>>2)];
      var $193=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $194=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$192]($193) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; };
    case 3: // $195
      __label__ = 10; break;
    case 4: // $196
      var $197=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $198=$197.f0;
      HEAP32[(($9)>>2)]=$198;
      var $199=$197.f1;
      HEAP32[(($10)>>2)]=$199;
      var $200=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($200);
      throw "Reached an unreachable!"
    case 5: // $201
      var $202=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $203=$202.f0;
      HEAP32[(($51)>>2)]=$203;
      var $204=$202.f1;
      HEAP32[(($52)>>2)]=$204;
      var $205=$24;
      HEAP32[(($24)>>2)]=$__current_i;
      var $206=HEAP32[(($24)>>2)];
      var $207=$23;
      HEAP32[(($23)>>2)]=$206;
      var $208=HEAP32[(($23)>>2)];
      var $209=$19;
      var $210=$20;
      var $211=$__tmp_i_i_i_i;
      var $212=$21;
      var $213=$22;
      HEAP32[(($19)>>2)]=$208;
      HEAP32[(($20)>>2)]=0;
      var $214=HEAP32[(($19)>>2)];
      var $215=(($214)|0);
      var $216=$18;
      HEAP32[(($18)>>2)]=$215;
      var $217=HEAP32[(($18)>>2)];
      var $218=$217;
      var $219=$17;
      HEAP32[(($17)>>2)]=$218;
      var $220=HEAP32[(($17)>>2)];
      var $221=(($220)|0);
      var $222=$17;
      var $223=$18;
      var $224=HEAP32[(($221)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$224;
      var $225=HEAP32[(($20)>>2)];
      var $226=(($214)|0);
      var $227=$16;
      HEAP32[(($16)>>2)]=$226;
      var $228=HEAP32[(($16)>>2)];
      var $229=$228;
      var $230=$15;
      HEAP32[(($15)>>2)]=$229;
      var $231=HEAP32[(($15)>>2)];
      var $232=(($231)|0);
      var $233=$15;
      var $234=$16;
      HEAP32[(($232)>>2)]=$225;
      var $235=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $236=(($235)|0)!=0;
      if ($236) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $237
      var $238=(($214)|0);
      var $239=$14;
      HEAP32[(($14)>>2)]=$238;
      var $240=HEAP32[(($14)>>2)];
      var $241=$240;
      var $242=$13;
      HEAP32[(($13)>>2)]=$241;
      var $243=HEAP32[(($13)>>2)];
      var $244=(($243+4)|0);
      var $245=$13;
      var $246=$14;
      var $247=HEAP32[(($244)>>2)];
      var $248=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $249=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$247]($248) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $250
      __label__ = 9; break;
    case 8: // $251
      var $252=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $253=$252.f0;
      HEAP32[(($21)>>2)]=$253;
      var $254=$252.f1;
      HEAP32[(($22)>>2)]=$254;
      var $255=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($255);
      throw "Reached an unreachable!"
    case 9: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $256=$19;
      var $257=$20;
      var $258=$__tmp_i_i_i_i;
      var $259=$21;
      var $260=$22;
      var $261=$23;
      var $262=$24;
      var $263=HEAP32[(($51)>>2)];
      var $264=HEAP32[(($51)>>2)];
      var $265=HEAP32[(($52)>>2)];
      var $266=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $264, tempValue);
      var $267=($266.f1 = $265, $266);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 10: // $_ZNSt3__111__wcrtomb_lEPcwP10_mbstate_tPv_exit
      var $268=$7;
      var $269=$8;
      var $270=$__tmp_i_i_i1_i;
      var $271=$9;
      var $272=$10;
      var $273=$11;
      var $274=$12;
      var $275=HEAP32[(($46)>>2)];
      var $276=$46;
      var $277=$47;
      var $278=$48;
      var $279=$49;
      var $280=$50;
      var $281=$__current_i;
      var $282=$51;
      var $283=$52;
      var $284=$53;
      $n=$275;
      var $285=$n;
      var $286=(($285)|0)==-1;
      if ($286) { __label__ = 12; break; } else { __label__ = 11; break; }
    case 11: // $287
      var $288=$n;
      var $289=(($288)|0)==0;
      if ($289) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $290
      $54=2;
      __label__ = 20; break;
    case 13: // $291
      var $292=$n;
      var $293=(($292-1)|0);
      $n=$293;
      var $294=$n;
      var $295=$58;
      var $296=$59;
      var $297=HEAP32[(($296)>>2)];
      var $298=$295;
      var $299=$297;
      var $300=(($298-$299)|0);
      var $301=(($294)>>>0) > (($300)>>>0);
      if ($301) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $302
      $54=1;
      __label__ = 20; break;
    case 15: // $303
      var $304=(($tmp)|0);
      $p=$304;
      __label__ = 16; break;
    case 16: // $305
      var $306=$n;
      var $307=(($306)|0)!=0;
      if ($307) { __label__ = 17; break; } else { __label__ = 19; break; }
    case 17: // $308
      var $309=$p;
      var $310=(($309+1)|0);
      $p=$310;
      var $311=HEAP8[($309)];
      var $312=$59;
      var $313=HEAP32[(($312)>>2)];
      var $314=(($313+1)|0);
      HEAP32[(($312)>>2)]=$314;
      HEAP8[($313)]=$311;
      __label__ = 18; break;
    case 18: // $315
      var $316=$n;
      var $317=(($316-1)|0);
      $n=$317;
      __label__ = 16; break;
    case 19: // $318
      $54=0;
      __label__ = 20; break;
    case 20: // $319
      var $320=$54;
      STACKTOP = __stackBase__;
      return $320;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIwc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_["X"]=1;

function __ZNKSt3__17codecvtIwc10_mbstate_tE11do_encodingEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 444; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i1=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i2=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $__current_i3=__stackBase__+196;
      var $48=__stackBase__+204;
      var $49=__stackBase__+208;
      var $50=__stackBase__+212;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $55=__stackBase__+232;
      var $56=__stackBase__+236;
      var $57=__stackBase__+240;
      var $58=__stackBase__+244;
      var $__tmp_i_i_i1_i=__stackBase__+248;
      var $59=__stackBase__+252;
      var $60=__stackBase__+256;
      var $61=__stackBase__+260;
      var $62=__stackBase__+264;
      var $63=__stackBase__+268;
      var $64=__stackBase__+272;
      var $65=__stackBase__+276;
      var $66=__stackBase__+280;
      var $67=__stackBase__+284;
      var $68=__stackBase__+288;
      var $69=__stackBase__+292;
      var $70=__stackBase__+296;
      var $__tmp_i_i_i_i=__stackBase__+300;
      var $71=__stackBase__+304;
      var $72=__stackBase__+308;
      var $73=__stackBase__+312;
      var $74=__stackBase__+316;
      var $75=__stackBase__+320;
      var $76=__stackBase__+324;
      var $77=__stackBase__+328;
      var $78=__stackBase__+332;
      var $79=__stackBase__+336;
      var $80=__stackBase__+340;
      var $81=__stackBase__+344;
      var $82=__stackBase__+348;
      var $83=__stackBase__+352;
      var $84=__stackBase__+356;
      var $85=__stackBase__+360;
      var $86=__stackBase__+364;
      var $87=__stackBase__+368;
      var $88=__stackBase__+372;
      var $89=__stackBase__+376;
      var $90=__stackBase__+380;
      var $91=__stackBase__+384;
      var $92=__stackBase__+388;
      var $93=__stackBase__+392;
      var $94=__stackBase__+396;
      var $95=__stackBase__+400;
      var $96=__stackBase__+404;
      var $97=__stackBase__+408;
      var $98=__stackBase__+412;
      var $99=__stackBase__+416;
      var $100=__stackBase__+420;
      var $__current_i=__stackBase__+424;
      var $101=__stackBase__+432;
      var $102=__stackBase__+436;
      var $103=__stackBase__+440;
      var $104;
      var $105;
      var $106;
      var $107;
      $105=$this;
      var $108=$105;
      var $109=(($108+8)|0);
      var $110=HEAP32[(($109)>>2)];
      var $111=$96;
      var $112=$97;
      var $113=$98;
      var $114=$99;
      var $115=$100;
      var $116=$__current_i;
      var $117=$101;
      var $118=$102;
      var $119=$103;
      HEAP32[(($97)>>2)]=0;
      HEAP32[(($98)>>2)]=0;
      HEAP32[(($99)>>2)]=1;
      HEAP32[(($100)>>2)]=$110;
      var $120=HEAP32[(($100)>>2)];
      var $121=(function() { try { __THREW__ = false; return _uselocale($120) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 28; break; };
    case 1: // $_noexc
      var $122=$93;
      var $123=$94;
      var $124=$95;
      HEAP32[(($93)>>2)]=$__current_i;
      HEAP32[(($94)>>2)]=$121;
      HEAP32[(($95)>>2)]=1680;
      var $125=HEAP32[(($93)>>2)];
      var $126=HEAP32[(($94)>>2)];
      var $127=HEAP32[(($95)>>2)];
      var $128=$90;
      var $129=$91;
      var $130=$92;
      HEAP32[(($90)>>2)]=$125;
      HEAP32[(($91)>>2)]=$126;
      HEAP32[(($92)>>2)]=$127;
      var $131=HEAP32[(($90)>>2)];
      var $132=(($131)|0);
      var $133=$89;
      HEAP32[(($89)>>2)]=$91;
      var $134=HEAP32[(($89)>>2)];
      var $135=$89;
      var $136=HEAP32[(($134)>>2)];
      var $137=$75;
      HEAP32[(($75)>>2)]=$92;
      var $138=HEAP32[(($75)>>2)];
      var $139=$75;
      var $140=HEAP32[(($138)>>2)];
      var $141=$86;
      var $142=$87;
      var $143=$88;
      HEAP32[(($86)>>2)]=$132;
      HEAP32[(($87)>>2)]=$136;
      HEAP32[(($88)>>2)]=$140;
      var $144=HEAP32[(($86)>>2)];
      var $145=HEAP32[(($87)>>2)];
      var $146=HEAP32[(($88)>>2)];
      var $147=$83;
      var $148=$84;
      var $149=$85;
      HEAP32[(($83)>>2)]=$144;
      HEAP32[(($84)>>2)]=$145;
      HEAP32[(($85)>>2)]=$146;
      var $150=HEAP32[(($83)>>2)];
      var $151=$150;
      var $152=$82;
      HEAP32[(($82)>>2)]=$84;
      var $153=HEAP32[(($82)>>2)];
      var $154=$82;
      var $155=HEAP32[(($153)>>2)];
      var $156=$76;
      HEAP32[(($76)>>2)]=$85;
      var $157=HEAP32[(($76)>>2)];
      var $158=$76;
      var $159=HEAP32[(($157)>>2)];
      var $160=$79;
      var $161=$80;
      var $162=$81;
      HEAP32[(($79)>>2)]=$151;
      HEAP32[(($80)>>2)]=$155;
      HEAP32[(($81)>>2)]=$159;
      var $163=HEAP32[(($79)>>2)];
      var $164=(($163)|0);
      var $165=$78;
      HEAP32[(($78)>>2)]=$80;
      var $166=HEAP32[(($78)>>2)];
      var $167=$78;
      var $168=HEAP32[(($166)>>2)];
      HEAP32[(($164)>>2)]=$168;
      var $169=(($163+4)|0);
      var $170=$77;
      HEAP32[(($77)>>2)]=$81;
      var $171=HEAP32[(($77)>>2)];
      var $172=$77;
      var $173=HEAP32[(($171)>>2)];
      HEAP32[(($169)>>2)]=$173;
      var $174=$79;
      var $175=$80;
      var $176=$81;
      var $177=$83;
      var $178=$84;
      var $179=$85;
      var $180=$86;
      var $181=$87;
      var $182=$88;
      var $183=$90;
      var $184=$91;
      var $185=$92;
      var $186=$93;
      var $187=$94;
      var $188=$95;
      var $189=HEAP32[(($97)>>2)];
      var $190=HEAP32[(($98)>>2)];
      var $191=HEAP32[(($99)>>2)];
      var $192=(function() { try { __THREW__ = false; return _mbtowc($189, $190, $191) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 6; break; };
    case 2: // $193
      HEAP32[(($96)>>2)]=$192;
      HEAP32[(($103)>>2)]=1;
      var $194=$62;
      HEAP32[(($62)>>2)]=$__current_i;
      var $195=HEAP32[(($62)>>2)];
      var $196=$61;
      HEAP32[(($61)>>2)]=$195;
      var $197=HEAP32[(($61)>>2)];
      var $198=$57;
      var $199=$58;
      var $200=$__tmp_i_i_i1_i;
      var $201=$59;
      var $202=$60;
      HEAP32[(($57)>>2)]=$197;
      HEAP32[(($58)>>2)]=0;
      var $203=HEAP32[(($57)>>2)];
      var $204=(($203)|0);
      var $205=$56;
      HEAP32[(($56)>>2)]=$204;
      var $206=HEAP32[(($56)>>2)];
      var $207=$206;
      var $208=$55;
      HEAP32[(($55)>>2)]=$207;
      var $209=HEAP32[(($55)>>2)];
      var $210=(($209)|0);
      var $211=$55;
      var $212=$56;
      var $213=HEAP32[(($210)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$213;
      var $214=HEAP32[(($58)>>2)];
      var $215=(($203)|0);
      var $216=$54;
      HEAP32[(($54)>>2)]=$215;
      var $217=HEAP32[(($54)>>2)];
      var $218=$217;
      var $219=$53;
      HEAP32[(($53)>>2)]=$218;
      var $220=HEAP32[(($53)>>2)];
      var $221=(($220)|0);
      var $222=$53;
      var $223=$54;
      HEAP32[(($221)>>2)]=$214;
      var $224=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 3; break; } else { __label__ = 11; break; }
    case 3: // $226
      var $227=(($203)|0);
      var $228=$52;
      HEAP32[(($52)>>2)]=$227;
      var $229=HEAP32[(($52)>>2)];
      var $230=$229;
      var $231=$51;
      HEAP32[(($51)>>2)]=$230;
      var $232=HEAP32[(($51)>>2)];
      var $233=(($232+4)|0);
      var $234=$51;
      var $235=$52;
      var $236=HEAP32[(($233)>>2)];
      var $237=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $238=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$236]($237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 5; break; };
    case 4: // $239
      __label__ = 11; break;
    case 5: // $240
      var $241=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $242=$241.f0;
      HEAP32[(($59)>>2)]=$242;
      var $243=$241.f1;
      HEAP32[(($60)>>2)]=$243;
      var $244=HEAP32[(($59)>>2)];
      ___cxa_call_unexpected($244);
      throw "Reached an unreachable!"
    case 6: // $245
      var $246=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $247=$246.f0;
      HEAP32[(($101)>>2)]=$247;
      var $248=$246.f1;
      HEAP32[(($102)>>2)]=$248;
      var $249=$74;
      HEAP32[(($74)>>2)]=$__current_i;
      var $250=HEAP32[(($74)>>2)];
      var $251=$73;
      HEAP32[(($73)>>2)]=$250;
      var $252=HEAP32[(($73)>>2)];
      var $253=$69;
      var $254=$70;
      var $255=$__tmp_i_i_i_i;
      var $256=$71;
      var $257=$72;
      HEAP32[(($69)>>2)]=$252;
      HEAP32[(($70)>>2)]=0;
      var $258=HEAP32[(($69)>>2)];
      var $259=(($258)|0);
      var $260=$68;
      HEAP32[(($68)>>2)]=$259;
      var $261=HEAP32[(($68)>>2)];
      var $262=$261;
      var $263=$67;
      HEAP32[(($67)>>2)]=$262;
      var $264=HEAP32[(($67)>>2)];
      var $265=(($264)|0);
      var $266=$67;
      var $267=$68;
      var $268=HEAP32[(($265)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$268;
      var $269=HEAP32[(($70)>>2)];
      var $270=(($258)|0);
      var $271=$66;
      HEAP32[(($66)>>2)]=$270;
      var $272=HEAP32[(($66)>>2)];
      var $273=$272;
      var $274=$65;
      HEAP32[(($65)>>2)]=$273;
      var $275=HEAP32[(($65)>>2)];
      var $276=(($275)|0);
      var $277=$65;
      var $278=$66;
      HEAP32[(($276)>>2)]=$269;
      var $279=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $280=(($279)|0)!=0;
      if ($280) { __label__ = 7; break; } else { __label__ = 10; break; }
    case 7: // $281
      var $282=(($258)|0);
      var $283=$64;
      HEAP32[(($64)>>2)]=$282;
      var $284=HEAP32[(($64)>>2)];
      var $285=$284;
      var $286=$63;
      HEAP32[(($63)>>2)]=$285;
      var $287=HEAP32[(($63)>>2)];
      var $288=(($287+4)|0);
      var $289=$63;
      var $290=$64;
      var $291=HEAP32[(($288)>>2)];
      var $292=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $293=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$291]($292) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 8; break; } else { __label__ = 9; break; };
    case 8: // $294
      __label__ = 10; break;
    case 9: // $295
      var $296=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[filter]);
      var $297=$296.f0;
      HEAP32[(($71)>>2)]=$297;
      var $298=$296.f1;
      HEAP32[(($72)>>2)]=$298;
      var $299=HEAP32[(($71)>>2)];
      ___cxa_call_unexpected($299);
      throw "Reached an unreachable!"
    case 10: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $300=$69;
      var $301=$70;
      var $302=$__tmp_i_i_i_i;
      var $303=$71;
      var $304=$72;
      var $305=$73;
      var $306=$74;
      var $307=HEAP32[(($101)>>2)];
      var $308=HEAP32[(($101)>>2)];
      var $309=HEAP32[(($102)>>2)];
      var $310=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $308, tempValue);
      var $311=($310.f1 = $309, $310);
      var $eh_lpad_body = $311;__label__ = 30; break;
    case 11: // $_ZNSt3__110__mbtowc_lEPwPKcjPv_exit
      var $312=$57;
      var $313=$58;
      var $314=$__tmp_i_i_i1_i;
      var $315=$59;
      var $316=$60;
      var $317=$61;
      var $318=$62;
      var $319=HEAP32[(($96)>>2)];
      var $320=$96;
      var $321=$97;
      var $322=$98;
      var $323=$99;
      var $324=$100;
      var $325=$__current_i;
      var $326=$101;
      var $327=$102;
      var $328=$103;
      __label__ = 12; break;
    case 12: // $329
      var $330=(($319)|0)==0;
      if ($330) { __label__ = 13; break; } else { __label__ = 33; break; }
    case 13: // $331
      var $332=(($108+8)|0);
      var $333=HEAP32[(($332)>>2)];
      var $334=(($333)|0)==0;
      if ($334) { __label__ = 27; break; } else { __label__ = 14; break; }
    case 14: // $335
      var $336=(($108+8)|0);
      var $337=HEAP32[(($336)>>2)];
      var $338=$46;
      var $339=$47;
      var $340=$__current_i3;
      var $341=$48;
      var $342=$49;
      var $343=$50;
      HEAP32[(($47)>>2)]=$337;
      var $344=HEAP32[(($47)>>2)];
      var $345=(function() { try { __THREW__ = false; return _uselocale($344) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 28; break; };
    case 15: // $_noexc5
      var $346=$43;
      var $347=$44;
      var $348=$45;
      HEAP32[(($43)>>2)]=$__current_i3;
      HEAP32[(($44)>>2)]=$345;
      HEAP32[(($45)>>2)]=1680;
      var $349=HEAP32[(($43)>>2)];
      var $350=HEAP32[(($44)>>2)];
      var $351=HEAP32[(($45)>>2)];
      var $352=$40;
      var $353=$41;
      var $354=$42;
      HEAP32[(($40)>>2)]=$349;
      HEAP32[(($41)>>2)]=$350;
      HEAP32[(($42)>>2)]=$351;
      var $355=HEAP32[(($40)>>2)];
      var $356=(($355)|0);
      var $357=$39;
      HEAP32[(($39)>>2)]=$41;
      var $358=HEAP32[(($39)>>2)];
      var $359=$39;
      var $360=HEAP32[(($358)>>2)];
      var $361=$25;
      HEAP32[(($25)>>2)]=$42;
      var $362=HEAP32[(($25)>>2)];
      var $363=$25;
      var $364=HEAP32[(($362)>>2)];
      var $365=$36;
      var $366=$37;
      var $367=$38;
      HEAP32[(($36)>>2)]=$356;
      HEAP32[(($37)>>2)]=$360;
      HEAP32[(($38)>>2)]=$364;
      var $368=HEAP32[(($36)>>2)];
      var $369=HEAP32[(($37)>>2)];
      var $370=HEAP32[(($38)>>2)];
      var $371=$33;
      var $372=$34;
      var $373=$35;
      HEAP32[(($33)>>2)]=$368;
      HEAP32[(($34)>>2)]=$369;
      HEAP32[(($35)>>2)]=$370;
      var $374=HEAP32[(($33)>>2)];
      var $375=$374;
      var $376=$32;
      HEAP32[(($32)>>2)]=$34;
      var $377=HEAP32[(($32)>>2)];
      var $378=$32;
      var $379=HEAP32[(($377)>>2)];
      var $380=$26;
      HEAP32[(($26)>>2)]=$35;
      var $381=HEAP32[(($26)>>2)];
      var $382=$26;
      var $383=HEAP32[(($381)>>2)];
      var $384=$29;
      var $385=$30;
      var $386=$31;
      HEAP32[(($29)>>2)]=$375;
      HEAP32[(($30)>>2)]=$379;
      HEAP32[(($31)>>2)]=$383;
      var $387=HEAP32[(($29)>>2)];
      var $388=(($387)|0);
      var $389=$28;
      HEAP32[(($28)>>2)]=$30;
      var $390=HEAP32[(($28)>>2)];
      var $391=$28;
      var $392=HEAP32[(($390)>>2)];
      HEAP32[(($388)>>2)]=$392;
      var $393=(($387+4)|0);
      var $394=$27;
      HEAP32[(($27)>>2)]=$31;
      var $395=HEAP32[(($27)>>2)];
      var $396=$27;
      var $397=HEAP32[(($395)>>2)];
      HEAP32[(($393)>>2)]=$397;
      var $398=$29;
      var $399=$30;
      var $400=$31;
      var $401=$33;
      var $402=$34;
      var $403=$35;
      var $404=$36;
      var $405=$37;
      var $406=$38;
      var $407=$40;
      var $408=$41;
      var $409=$42;
      var $410=$43;
      var $411=$44;
      var $412=$45;
      var $413=(function() { try { __THREW__ = false; return ___locale_mb_cur_max() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 16; break; } else { __label__ = 20; break; };
    case 16: // $414
      HEAP32[(($46)>>2)]=$413;
      HEAP32[(($50)>>2)]=1;
      var $415=$12;
      HEAP32[(($12)>>2)]=$__current_i3;
      var $416=HEAP32[(($12)>>2)];
      var $417=$11;
      HEAP32[(($11)>>2)]=$416;
      var $418=HEAP32[(($11)>>2)];
      var $419=$7;
      var $420=$8;
      var $421=$__tmp_i_i_i1_i1;
      var $422=$9;
      var $423=$10;
      HEAP32[(($7)>>2)]=$418;
      HEAP32[(($8)>>2)]=0;
      var $424=HEAP32[(($7)>>2)];
      var $425=(($424)|0);
      var $426=$6;
      HEAP32[(($6)>>2)]=$425;
      var $427=HEAP32[(($6)>>2)];
      var $428=$427;
      var $429=$5;
      HEAP32[(($5)>>2)]=$428;
      var $430=HEAP32[(($5)>>2)];
      var $431=(($430)|0);
      var $432=$5;
      var $433=$6;
      var $434=HEAP32[(($431)>>2)];
      HEAP32[(($__tmp_i_i_i1_i1)>>2)]=$434;
      var $435=HEAP32[(($8)>>2)];
      var $436=(($424)|0);
      var $437=$4;
      HEAP32[(($4)>>2)]=$436;
      var $438=HEAP32[(($4)>>2)];
      var $439=$438;
      var $440=$3;
      HEAP32[(($3)>>2)]=$439;
      var $441=HEAP32[(($3)>>2)];
      var $442=(($441)|0);
      var $443=$3;
      var $444=$4;
      HEAP32[(($442)>>2)]=$435;
      var $445=HEAP32[(($__tmp_i_i_i1_i1)>>2)];
      var $446=(($445)|0)!=0;
      if ($446) { __label__ = 17; break; } else { __label__ = 25; break; }
    case 17: // $447
      var $448=(($424)|0);
      var $449=$2;
      HEAP32[(($2)>>2)]=$448;
      var $450=HEAP32[(($2)>>2)];
      var $451=$450;
      var $452=$1;
      HEAP32[(($1)>>2)]=$451;
      var $453=HEAP32[(($1)>>2)];
      var $454=(($453+4)|0);
      var $455=$1;
      var $456=$2;
      var $457=HEAP32[(($454)>>2)];
      var $458=HEAP32[(($__tmp_i_i_i1_i1)>>2)];
      var $459=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$457]($458) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 18; break; } else { __label__ = 19; break; };
    case 18: // $460
      __label__ = 25; break;
    case 19: // $461
      var $462=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $463=$462.f0;
      HEAP32[(($9)>>2)]=$463;
      var $464=$462.f1;
      HEAP32[(($10)>>2)]=$464;
      var $465=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($465);
      throw "Reached an unreachable!"
    case 20: // $466
      var $467=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $468=$467.f0;
      HEAP32[(($48)>>2)]=$468;
      var $469=$467.f1;
      HEAP32[(($49)>>2)]=$469;
      var $470=$24;
      HEAP32[(($24)>>2)]=$__current_i3;
      var $471=HEAP32[(($24)>>2)];
      var $472=$23;
      HEAP32[(($23)>>2)]=$471;
      var $473=HEAP32[(($23)>>2)];
      var $474=$19;
      var $475=$20;
      var $476=$__tmp_i_i_i_i2;
      var $477=$21;
      var $478=$22;
      HEAP32[(($19)>>2)]=$473;
      HEAP32[(($20)>>2)]=0;
      var $479=HEAP32[(($19)>>2)];
      var $480=(($479)|0);
      var $481=$18;
      HEAP32[(($18)>>2)]=$480;
      var $482=HEAP32[(($18)>>2)];
      var $483=$482;
      var $484=$17;
      HEAP32[(($17)>>2)]=$483;
      var $485=HEAP32[(($17)>>2)];
      var $486=(($485)|0);
      var $487=$17;
      var $488=$18;
      var $489=HEAP32[(($486)>>2)];
      HEAP32[(($__tmp_i_i_i_i2)>>2)]=$489;
      var $490=HEAP32[(($20)>>2)];
      var $491=(($479)|0);
      var $492=$16;
      HEAP32[(($16)>>2)]=$491;
      var $493=HEAP32[(($16)>>2)];
      var $494=$493;
      var $495=$15;
      HEAP32[(($15)>>2)]=$494;
      var $496=HEAP32[(($15)>>2)];
      var $497=(($496)|0);
      var $498=$15;
      var $499=$16;
      HEAP32[(($497)>>2)]=$490;
      var $500=HEAP32[(($__tmp_i_i_i_i2)>>2)];
      var $501=(($500)|0)!=0;
      if ($501) { __label__ = 21; break; } else { __label__ = 24; break; }
    case 21: // $502
      var $503=(($479)|0);
      var $504=$14;
      HEAP32[(($14)>>2)]=$503;
      var $505=HEAP32[(($14)>>2)];
      var $506=$505;
      var $507=$13;
      HEAP32[(($13)>>2)]=$506;
      var $508=HEAP32[(($13)>>2)];
      var $509=(($508+4)|0);
      var $510=$13;
      var $511=$14;
      var $512=HEAP32[(($509)>>2)];
      var $513=HEAP32[(($__tmp_i_i_i_i2)>>2)];
      var $514=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$512]($513) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 22; break; } else { __label__ = 23; break; };
    case 22: // $515
      __label__ = 24; break;
    case 23: // $516
      var $517=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[filter]);
      var $518=$517.f0;
      HEAP32[(($21)>>2)]=$518;
      var $519=$517.f1;
      HEAP32[(($22)>>2)]=$519;
      var $520=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($520);
      throw "Reached an unreachable!"
    case 24: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i4
      var $521=$19;
      var $522=$20;
      var $523=$__tmp_i_i_i_i2;
      var $524=$21;
      var $525=$22;
      var $526=$23;
      var $527=$24;
      var $528=HEAP32[(($48)>>2)];
      var $529=HEAP32[(($48)>>2)];
      var $530=HEAP32[(($49)>>2)];
      var $531=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $529, tempValue);
      var $532=($531.f1 = $530, $531);
      var $eh_lpad_body7 = $532;__label__ = 29; break;
    case 25: // $_ZNSt3__114__mb_cur_max_lEPv_exit
      var $533=$7;
      var $534=$8;
      var $535=$__tmp_i_i_i1_i1;
      var $536=$9;
      var $537=$10;
      var $538=$11;
      var $539=$12;
      var $540=HEAP32[(($46)>>2)];
      var $541=$46;
      var $542=$47;
      var $543=$__current_i3;
      var $544=$48;
      var $545=$49;
      var $546=$50;
      __label__ = 26; break;
    case 26: // $547
      var $548=(($540)|0)==1;
      if ($548) { __label__ = 27; break; } else { __label__ = 32; break; }
    case 27: // $549
      $104=1;
      __label__ = 34; break;
    case 28: // $550
      var $551=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body7 = $551;__label__ = 29; break;
    case 29: // $_body6
      var $eh_lpad_body7;
      var $eh_lpad_body = $eh_lpad_body7;__label__ = 30; break;
    case 30: // $_body
      var $eh_lpad_body;
      var $552=$eh_lpad_body.f0;
      $106=$552;
      var $553=$eh_lpad_body.f1;
      $107=$553;
      __label__ = 31; break;
    case 31: // $554
      var $555=$106;
      ___cxa_call_unexpected($555);
      throw "Reached an unreachable!"
    case 32: // $556
      $104=0;
      __label__ = 34; break;
    case 33: // $557
      $104=-1;
      __label__ = 34; break;
    case 34: // $558
      var $559=$104;
      STACKTOP = __stackBase__;
      return $559;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIwc10_mbstate_tE11do_encodingEv["X"]=1;

function __ZNKSt3__17codecvtIwc10_mbstate_tE16do_always_noconvEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__17codecvtIwc10_mbstate_tE9do_lengthERS1_PKcS5_j($this, $st, $frm, $frm_end, $mx) {
  var __stackBase__  = STACKTOP; STACKTOP += 228; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $48=__stackBase__+196;
      var $49=__stackBase__+200;
      var $50=__stackBase__+204;
      var $__current_i=__stackBase__+208;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54;
      var $55;
      var $56;
      var $57;
      var $58;
      var $59;
      var $nbytes;
      var $nwchar_t;
      var $n;
      $55=$this;
      $56=$st;
      $57=$frm;
      $58=$frm_end;
      $59=$mx;
      var $60=$55;
      $nbytes=0;
      $nwchar_t=0;
      __label__ = 1; break;
    case 1: // $61
      var $62=$nwchar_t;
      var $63=$59;
      var $64=(($62)>>>0) < (($63)>>>0);
      if ($64) { __label__ = 2; break; } else { var $70 = 0;__label__ = 3; break; }
    case 2: // $65
      var $66=$57;
      var $67=$58;
      var $68=(($66)|0)!=(($67)|0);
      var $70 = $68;__label__ = 3; break;
    case 3: // $69
      var $70;
      if ($70) { __label__ = 4; break; } else { __label__ = 20; break; }
    case 4: // $71
      var $72=$57;
      var $73=$58;
      var $74=$57;
      var $75=$73;
      var $76=$74;
      var $77=(($75-$76)|0);
      var $78=$56;
      var $79=(($60+8)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=$46;
      var $82=$47;
      var $83=$48;
      var $84=$49;
      var $85=$50;
      var $86=$__current_i;
      var $87=$51;
      var $88=$52;
      var $89=$53;
      HEAP32[(($47)>>2)]=$72;
      HEAP32[(($48)>>2)]=$77;
      HEAP32[(($49)>>2)]=$78;
      HEAP32[(($50)>>2)]=$80;
      var $90=HEAP32[(($50)>>2)];
      var $91=_uselocale($90);
      var $92=$43;
      var $93=$44;
      var $94=$45;
      HEAP32[(($43)>>2)]=$__current_i;
      HEAP32[(($44)>>2)]=$91;
      HEAP32[(($45)>>2)]=1680;
      var $95=HEAP32[(($43)>>2)];
      var $96=HEAP32[(($44)>>2)];
      var $97=HEAP32[(($45)>>2)];
      var $98=$40;
      var $99=$41;
      var $100=$42;
      HEAP32[(($40)>>2)]=$95;
      HEAP32[(($41)>>2)]=$96;
      HEAP32[(($42)>>2)]=$97;
      var $101=HEAP32[(($40)>>2)];
      var $102=(($101)|0);
      var $103=$39;
      HEAP32[(($39)>>2)]=$41;
      var $104=HEAP32[(($39)>>2)];
      var $105=$39;
      var $106=HEAP32[(($104)>>2)];
      var $107=$25;
      HEAP32[(($25)>>2)]=$42;
      var $108=HEAP32[(($25)>>2)];
      var $109=$25;
      var $110=HEAP32[(($108)>>2)];
      var $111=$36;
      var $112=$37;
      var $113=$38;
      HEAP32[(($36)>>2)]=$102;
      HEAP32[(($37)>>2)]=$106;
      HEAP32[(($38)>>2)]=$110;
      var $114=HEAP32[(($36)>>2)];
      var $115=HEAP32[(($37)>>2)];
      var $116=HEAP32[(($38)>>2)];
      var $117=$33;
      var $118=$34;
      var $119=$35;
      HEAP32[(($33)>>2)]=$114;
      HEAP32[(($34)>>2)]=$115;
      HEAP32[(($35)>>2)]=$116;
      var $120=HEAP32[(($33)>>2)];
      var $121=$120;
      var $122=$32;
      HEAP32[(($32)>>2)]=$34;
      var $123=HEAP32[(($32)>>2)];
      var $124=$32;
      var $125=HEAP32[(($123)>>2)];
      var $126=$26;
      HEAP32[(($26)>>2)]=$35;
      var $127=HEAP32[(($26)>>2)];
      var $128=$26;
      var $129=HEAP32[(($127)>>2)];
      var $130=$29;
      var $131=$30;
      var $132=$31;
      HEAP32[(($29)>>2)]=$121;
      HEAP32[(($30)>>2)]=$125;
      HEAP32[(($31)>>2)]=$129;
      var $133=HEAP32[(($29)>>2)];
      var $134=(($133)|0);
      var $135=$28;
      HEAP32[(($28)>>2)]=$30;
      var $136=HEAP32[(($28)>>2)];
      var $137=$28;
      var $138=HEAP32[(($136)>>2)];
      HEAP32[(($134)>>2)]=$138;
      var $139=(($133+4)|0);
      var $140=$27;
      HEAP32[(($27)>>2)]=$31;
      var $141=HEAP32[(($27)>>2)];
      var $142=$27;
      var $143=HEAP32[(($141)>>2)];
      HEAP32[(($139)>>2)]=$143;
      var $144=$29;
      var $145=$30;
      var $146=$31;
      var $147=$33;
      var $148=$34;
      var $149=$35;
      var $150=$36;
      var $151=$37;
      var $152=$38;
      var $153=$40;
      var $154=$41;
      var $155=$42;
      var $156=$43;
      var $157=$44;
      var $158=$45;
      var $159=HEAP32[(($47)>>2)];
      var $160=HEAP32[(($48)>>2)];
      var $161=HEAP32[(($49)>>2)];
      var $162=(function() { try { __THREW__ = false; return _mbrlen($159, $160, $161) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 9; break; };
    case 5: // $163
      HEAP32[(($46)>>2)]=$162;
      HEAP32[(($53)>>2)]=1;
      var $164=$12;
      HEAP32[(($12)>>2)]=$__current_i;
      var $165=HEAP32[(($12)>>2)];
      var $166=$11;
      HEAP32[(($11)>>2)]=$165;
      var $167=HEAP32[(($11)>>2)];
      var $168=$7;
      var $169=$8;
      var $170=$__tmp_i_i_i1_i;
      var $171=$9;
      var $172=$10;
      HEAP32[(($7)>>2)]=$167;
      HEAP32[(($8)>>2)]=0;
      var $173=HEAP32[(($7)>>2)];
      var $174=(($173)|0);
      var $175=$6;
      HEAP32[(($6)>>2)]=$174;
      var $176=HEAP32[(($6)>>2)];
      var $177=$176;
      var $178=$5;
      HEAP32[(($5)>>2)]=$177;
      var $179=HEAP32[(($5)>>2)];
      var $180=(($179)|0);
      var $181=$5;
      var $182=$6;
      var $183=HEAP32[(($180)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$183;
      var $184=HEAP32[(($8)>>2)];
      var $185=(($173)|0);
      var $186=$4;
      HEAP32[(($4)>>2)]=$185;
      var $187=HEAP32[(($4)>>2)];
      var $188=$187;
      var $189=$3;
      HEAP32[(($3)>>2)]=$188;
      var $190=HEAP32[(($3)>>2)];
      var $191=(($190)|0);
      var $192=$3;
      var $193=$4;
      HEAP32[(($191)>>2)]=$184;
      var $194=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $195=(($194)|0)!=0;
      if ($195) { __label__ = 6; break; } else { __label__ = 14; break; }
    case 6: // $196
      var $197=(($173)|0);
      var $198=$2;
      HEAP32[(($2)>>2)]=$197;
      var $199=HEAP32[(($2)>>2)];
      var $200=$199;
      var $201=$1;
      HEAP32[(($1)>>2)]=$200;
      var $202=HEAP32[(($1)>>2)];
      var $203=(($202+4)|0);
      var $204=$1;
      var $205=$2;
      var $206=HEAP32[(($203)>>2)];
      var $207=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $208=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$206]($207) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 7; break; } else { __label__ = 8; break; };
    case 7: // $209
      __label__ = 14; break;
    case 8: // $210
      var $211=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $212=$211.f0;
      HEAP32[(($9)>>2)]=$212;
      var $213=$211.f1;
      HEAP32[(($10)>>2)]=$213;
      var $214=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($214);
      throw "Reached an unreachable!"
    case 9: // $215
      var $216=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $217=$216.f0;
      HEAP32[(($51)>>2)]=$217;
      var $218=$216.f1;
      HEAP32[(($52)>>2)]=$218;
      var $219=$24;
      HEAP32[(($24)>>2)]=$__current_i;
      var $220=HEAP32[(($24)>>2)];
      var $221=$23;
      HEAP32[(($23)>>2)]=$220;
      var $222=HEAP32[(($23)>>2)];
      var $223=$19;
      var $224=$20;
      var $225=$__tmp_i_i_i_i;
      var $226=$21;
      var $227=$22;
      HEAP32[(($19)>>2)]=$222;
      HEAP32[(($20)>>2)]=0;
      var $228=HEAP32[(($19)>>2)];
      var $229=(($228)|0);
      var $230=$18;
      HEAP32[(($18)>>2)]=$229;
      var $231=HEAP32[(($18)>>2)];
      var $232=$231;
      var $233=$17;
      HEAP32[(($17)>>2)]=$232;
      var $234=HEAP32[(($17)>>2)];
      var $235=(($234)|0);
      var $236=$17;
      var $237=$18;
      var $238=HEAP32[(($235)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$238;
      var $239=HEAP32[(($20)>>2)];
      var $240=(($228)|0);
      var $241=$16;
      HEAP32[(($16)>>2)]=$240;
      var $242=HEAP32[(($16)>>2)];
      var $243=$242;
      var $244=$15;
      HEAP32[(($15)>>2)]=$243;
      var $245=HEAP32[(($15)>>2)];
      var $246=(($245)|0);
      var $247=$15;
      var $248=$16;
      HEAP32[(($246)>>2)]=$239;
      var $249=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $250=(($249)|0)!=0;
      if ($250) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $251
      var $252=(($228)|0);
      var $253=$14;
      HEAP32[(($14)>>2)]=$252;
      var $254=HEAP32[(($14)>>2)];
      var $255=$254;
      var $256=$13;
      HEAP32[(($13)>>2)]=$255;
      var $257=HEAP32[(($13)>>2)];
      var $258=(($257+4)|0);
      var $259=$13;
      var $260=$14;
      var $261=HEAP32[(($258)>>2)];
      var $262=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $263=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$261]($262) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 12; break; };
    case 11: // $264
      __label__ = 13; break;
    case 12: // $265
      var $266=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      var $267=$266.f0;
      HEAP32[(($21)>>2)]=$267;
      var $268=$266.f1;
      HEAP32[(($22)>>2)]=$268;
      var $269=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($269);
      throw "Reached an unreachable!"
    case 13: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $270=$19;
      var $271=$20;
      var $272=$__tmp_i_i_i_i;
      var $273=$21;
      var $274=$22;
      var $275=$23;
      var $276=$24;
      var $277=HEAP32[(($51)>>2)];
      var $278=HEAP32[(($51)>>2)];
      var $279=HEAP32[(($52)>>2)];
      var $280=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $278, tempValue);
      var $281=($280.f1 = $279, $280);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $_ZNSt3__110__mbrlen_lEPKcjP10_mbstate_tPv_exit
      var $282=$7;
      var $283=$8;
      var $284=$__tmp_i_i_i1_i;
      var $285=$9;
      var $286=$10;
      var $287=$11;
      var $288=$12;
      var $289=HEAP32[(($46)>>2)];
      var $290=$46;
      var $291=$47;
      var $292=$48;
      var $293=$49;
      var $294=$50;
      var $295=$__current_i;
      var $296=$51;
      var $297=$52;
      var $298=$53;
      $n=$289;
      var $299=$n;
      if ($299 == 0) {
        __label__ = 15; break;
      }
      else if ($299 == -1 || $299 == -2) {
        __label__ = 16; break;
      }
      else {
      __label__ = 17; break;
      }
      
    case 15: // $300
      var $301=$nbytes;
      var $302=(($301+1)|0);
      $nbytes=$302;
      var $303=$57;
      var $304=(($303+1)|0);
      $57=$304;
      __label__ = 18; break;
    case 16: // $305
      var $306=$nbytes;
      $54=$306;
      __label__ = 21; break;
    case 17: // $307
      var $308=$n;
      var $309=$nbytes;
      var $310=(($309+$308)|0);
      $nbytes=$310;
      var $311=$n;
      var $312=$57;
      var $313=(($312+$311)|0);
      $57=$313;
      __label__ = 18; break;
    case 18: // $314
      __label__ = 19; break;
    case 19: // $315
      var $316=$nwchar_t;
      var $317=(($316+1)|0);
      $nwchar_t=$317;
      __label__ = 1; break;
    case 20: // $318
      var $319=$nbytes;
      $54=$319;
      __label__ = 21; break;
    case 21: // $320
      var $321=$54;
      STACKTOP = __stackBase__;
      return $321;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIwc10_mbstate_tE9do_lengthERS1_PKcS5_j["X"]=1;

function ___cxx_global_var_init48() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__17codecvtItc10_mbstate_tE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__17codecvtItc10_mbstate_tED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__17codecvtItc10_mbstate_tED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17codecvtItc10_mbstate_tE6do_outERS1_PKtS5_RS5_PcS7_RS7_($this, $0, $frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $_frm;
  var $_frm_end;
  var $_frm_nxt=__stackBase__;
  var $_to;
  var $_to_end;
  var $_to_nxt=__stackBase__+4;
  var $r;
  $2=$this;
  $3=$0;
  $4=$frm;
  $5=$frm_end;
  $6=$frm_nxt;
  $7=$to;
  $8=$to_end;
  $9=$to_nxt;
  var $10=$2;
  var $11=$4;
  $_frm=$11;
  var $12=$5;
  $_frm_end=$12;
  var $13=$_frm;
  HEAP32[(($_frm_nxt)>>2)]=$13;
  var $14=$7;
  $_to=$14;
  var $15=$8;
  $_to_end=$15;
  var $16=$_to;
  HEAP32[(($_to_nxt)>>2)]=$16;
  var $17=$_frm;
  var $18=$_frm_end;
  var $19=$_to;
  var $20=$_to_end;
  var $21=__ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($17, $18, $_frm_nxt, $19, $20, $_to_nxt, 1114111, 0);
  $r=$21;
  var $22=$4;
  var $23=HEAP32[(($_frm_nxt)>>2)];
  var $24=$_frm;
  var $25=$23;
  var $26=$24;
  var $27=(($25-$26)|0);
  var $28=(((($27)|0)/2)|0);
  var $29=(($22+($28<<1))|0);
  var $30=$6;
  HEAP32[(($30)>>2)]=$29;
  var $31=$7;
  var $32=HEAP32[(($_to_nxt)>>2)];
  var $33=$_to;
  var $34=$32;
  var $35=$33;
  var $36=(($34-$35)|0);
  var $37=(($31+$36)|0);
  var $38=$9;
  HEAP32[(($38)>>2)]=$37;
  var $39=$r;
  STACKTOP = __stackBase__;
  return $39;
}
__ZNKSt3__17codecvtItc10_mbstate_tE6do_outERS1_PKtS5_RS5_PcS7_RS7_["X"]=1;

function __ZNKSt3__17codecvtIwc10_mbstate_tE13do_max_lengthEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 216; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i_i_i1_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11=__stackBase__+44;
      var $12=__stackBase__+48;
      var $13=__stackBase__+52;
      var $14=__stackBase__+56;
      var $15=__stackBase__+60;
      var $16=__stackBase__+64;
      var $17=__stackBase__+68;
      var $18=__stackBase__+72;
      var $19=__stackBase__+76;
      var $20=__stackBase__+80;
      var $__tmp_i_i_i_i=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27=__stackBase__+112;
      var $28=__stackBase__+116;
      var $29=__stackBase__+120;
      var $30=__stackBase__+124;
      var $31=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $39=__stackBase__+160;
      var $40=__stackBase__+164;
      var $41=__stackBase__+168;
      var $42=__stackBase__+172;
      var $43=__stackBase__+176;
      var $44=__stackBase__+180;
      var $45=__stackBase__+184;
      var $46=__stackBase__+188;
      var $47=__stackBase__+192;
      var $__current_i=__stackBase__+196;
      var $48=__stackBase__+204;
      var $49=__stackBase__+208;
      var $50=__stackBase__+212;
      var $51;
      var $52;
      var $53;
      $51=$this;
      var $54=$51;
      var $55=(($54+8)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==0;
      if ($57) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $58
      var $273 = 1;__label__ = 15; break;
    case 2: // $59
      var $60=(($54+8)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=$46;
      var $63=$47;
      var $64=$__current_i;
      var $65=$48;
      var $66=$49;
      var $67=$50;
      HEAP32[(($47)>>2)]=$61;
      var $68=HEAP32[(($47)>>2)];
      var $69=(function() { try { __THREW__ = false; return _uselocale($68) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 16; break; };
    case 3: // $_noexc
      var $70=$43;
      var $71=$44;
      var $72=$45;
      HEAP32[(($43)>>2)]=$__current_i;
      HEAP32[(($44)>>2)]=$69;
      HEAP32[(($45)>>2)]=1680;
      var $73=HEAP32[(($43)>>2)];
      var $74=HEAP32[(($44)>>2)];
      var $75=HEAP32[(($45)>>2)];
      var $76=$40;
      var $77=$41;
      var $78=$42;
      HEAP32[(($40)>>2)]=$73;
      HEAP32[(($41)>>2)]=$74;
      HEAP32[(($42)>>2)]=$75;
      var $79=HEAP32[(($40)>>2)];
      var $80=(($79)|0);
      var $81=$39;
      HEAP32[(($39)>>2)]=$41;
      var $82=HEAP32[(($39)>>2)];
      var $83=$39;
      var $84=HEAP32[(($82)>>2)];
      var $85=$25;
      HEAP32[(($25)>>2)]=$42;
      var $86=HEAP32[(($25)>>2)];
      var $87=$25;
      var $88=HEAP32[(($86)>>2)];
      var $89=$36;
      var $90=$37;
      var $91=$38;
      HEAP32[(($36)>>2)]=$80;
      HEAP32[(($37)>>2)]=$84;
      HEAP32[(($38)>>2)]=$88;
      var $92=HEAP32[(($36)>>2)];
      var $93=HEAP32[(($37)>>2)];
      var $94=HEAP32[(($38)>>2)];
      var $95=$33;
      var $96=$34;
      var $97=$35;
      HEAP32[(($33)>>2)]=$92;
      HEAP32[(($34)>>2)]=$93;
      HEAP32[(($35)>>2)]=$94;
      var $98=HEAP32[(($33)>>2)];
      var $99=$98;
      var $100=$32;
      HEAP32[(($32)>>2)]=$34;
      var $101=HEAP32[(($32)>>2)];
      var $102=$32;
      var $103=HEAP32[(($101)>>2)];
      var $104=$26;
      HEAP32[(($26)>>2)]=$35;
      var $105=HEAP32[(($26)>>2)];
      var $106=$26;
      var $107=HEAP32[(($105)>>2)];
      var $108=$29;
      var $109=$30;
      var $110=$31;
      HEAP32[(($29)>>2)]=$99;
      HEAP32[(($30)>>2)]=$103;
      HEAP32[(($31)>>2)]=$107;
      var $111=HEAP32[(($29)>>2)];
      var $112=(($111)|0);
      var $113=$28;
      HEAP32[(($28)>>2)]=$30;
      var $114=HEAP32[(($28)>>2)];
      var $115=$28;
      var $116=HEAP32[(($114)>>2)];
      HEAP32[(($112)>>2)]=$116;
      var $117=(($111+4)|0);
      var $118=$27;
      HEAP32[(($27)>>2)]=$31;
      var $119=HEAP32[(($27)>>2)];
      var $120=$27;
      var $121=HEAP32[(($119)>>2)];
      HEAP32[(($117)>>2)]=$121;
      var $122=$29;
      var $123=$30;
      var $124=$31;
      var $125=$33;
      var $126=$34;
      var $127=$35;
      var $128=$36;
      var $129=$37;
      var $130=$38;
      var $131=$40;
      var $132=$41;
      var $133=$42;
      var $134=$43;
      var $135=$44;
      var $136=$45;
      var $137=(function() { try { __THREW__ = false; return ___locale_mb_cur_max() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 8; break; };
    case 4: // $138
      HEAP32[(($46)>>2)]=$137;
      HEAP32[(($50)>>2)]=1;
      var $139=$12;
      HEAP32[(($12)>>2)]=$__current_i;
      var $140=HEAP32[(($12)>>2)];
      var $141=$11;
      HEAP32[(($11)>>2)]=$140;
      var $142=HEAP32[(($11)>>2)];
      var $143=$7;
      var $144=$8;
      var $145=$__tmp_i_i_i1_i;
      var $146=$9;
      var $147=$10;
      HEAP32[(($7)>>2)]=$142;
      HEAP32[(($8)>>2)]=0;
      var $148=HEAP32[(($7)>>2)];
      var $149=(($148)|0);
      var $150=$6;
      HEAP32[(($6)>>2)]=$149;
      var $151=HEAP32[(($6)>>2)];
      var $152=$151;
      var $153=$5;
      HEAP32[(($5)>>2)]=$152;
      var $154=HEAP32[(($5)>>2)];
      var $155=(($154)|0);
      var $156=$5;
      var $157=$6;
      var $158=HEAP32[(($155)>>2)];
      HEAP32[(($__tmp_i_i_i1_i)>>2)]=$158;
      var $159=HEAP32[(($8)>>2)];
      var $160=(($148)|0);
      var $161=$4;
      HEAP32[(($4)>>2)]=$160;
      var $162=HEAP32[(($4)>>2)];
      var $163=$162;
      var $164=$3;
      HEAP32[(($3)>>2)]=$163;
      var $165=HEAP32[(($3)>>2)];
      var $166=(($165)|0);
      var $167=$3;
      var $168=$4;
      HEAP32[(($166)>>2)]=$159;
      var $169=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $170=(($169)|0)!=0;
      if ($170) { __label__ = 5; break; } else { __label__ = 13; break; }
    case 5: // $171
      var $172=(($148)|0);
      var $173=$2;
      HEAP32[(($2)>>2)]=$172;
      var $174=HEAP32[(($2)>>2)];
      var $175=$174;
      var $176=$1;
      HEAP32[(($1)>>2)]=$175;
      var $177=HEAP32[(($1)>>2)];
      var $178=(($177+4)|0);
      var $179=$1;
      var $180=$2;
      var $181=HEAP32[(($178)>>2)];
      var $182=HEAP32[(($__tmp_i_i_i1_i)>>2)];
      var $183=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$181]($182) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; };
    case 6: // $184
      __label__ = 13; break;
    case 7: // $185
      var $186=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $187=$186.f0;
      HEAP32[(($9)>>2)]=$187;
      var $188=$186.f1;
      HEAP32[(($10)>>2)]=$188;
      var $189=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($189);
      throw "Reached an unreachable!"
    case 8: // $190
      var $191=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $192=$191.f0;
      HEAP32[(($48)>>2)]=$192;
      var $193=$191.f1;
      HEAP32[(($49)>>2)]=$193;
      var $194=$24;
      HEAP32[(($24)>>2)]=$__current_i;
      var $195=HEAP32[(($24)>>2)];
      var $196=$23;
      HEAP32[(($23)>>2)]=$195;
      var $197=HEAP32[(($23)>>2)];
      var $198=$19;
      var $199=$20;
      var $200=$__tmp_i_i_i_i;
      var $201=$21;
      var $202=$22;
      HEAP32[(($19)>>2)]=$197;
      HEAP32[(($20)>>2)]=0;
      var $203=HEAP32[(($19)>>2)];
      var $204=(($203)|0);
      var $205=$18;
      HEAP32[(($18)>>2)]=$204;
      var $206=HEAP32[(($18)>>2)];
      var $207=$206;
      var $208=$17;
      HEAP32[(($17)>>2)]=$207;
      var $209=HEAP32[(($17)>>2)];
      var $210=(($209)|0);
      var $211=$17;
      var $212=$18;
      var $213=HEAP32[(($210)>>2)];
      HEAP32[(($__tmp_i_i_i_i)>>2)]=$213;
      var $214=HEAP32[(($20)>>2)];
      var $215=(($203)|0);
      var $216=$16;
      HEAP32[(($16)>>2)]=$215;
      var $217=HEAP32[(($16)>>2)];
      var $218=$217;
      var $219=$15;
      HEAP32[(($15)>>2)]=$218;
      var $220=HEAP32[(($15)>>2)];
      var $221=(($220)|0);
      var $222=$15;
      var $223=$16;
      HEAP32[(($221)>>2)]=$214;
      var $224=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $225=(($224)|0)!=0;
      if ($225) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $226
      var $227=(($203)|0);
      var $228=$14;
      HEAP32[(($14)>>2)]=$227;
      var $229=HEAP32[(($14)>>2)];
      var $230=$229;
      var $231=$13;
      HEAP32[(($13)>>2)]=$230;
      var $232=HEAP32[(($13)>>2)];
      var $233=(($232+4)|0);
      var $234=$13;
      var $235=$14;
      var $236=HEAP32[(($233)>>2)];
      var $237=HEAP32[(($__tmp_i_i_i_i)>>2)];
      var $238=(function() { try { __THREW__ = false; return FUNCTION_TABLE[$236]($237) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 10; break; } else { __label__ = 11; break; };
    case 10: // $239
      __label__ = 12; break;
    case 11: // $240
      var $241=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[filter]);
      var $242=$241.f0;
      HEAP32[(($21)>>2)]=$242;
      var $243=$241.f1;
      HEAP32[(($22)>>2)]=$243;
      var $244=HEAP32[(($21)>>2)];
      ___cxa_call_unexpected($244);
      throw "Reached an unreachable!"
    case 12: // $_ZNSt3__110unique_ptrIvPFPvS1_EED1Ev_exit_i
      var $245=$19;
      var $246=$20;
      var $247=$__tmp_i_i_i_i;
      var $248=$21;
      var $249=$22;
      var $250=$23;
      var $251=$24;
      var $252=HEAP32[(($48)>>2)];
      var $253=HEAP32[(($48)>>2)];
      var $254=HEAP32[(($49)>>2)];
      var $255=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $253, tempValue);
      var $256=($255.f1 = $254, $255);
      var $eh_lpad_body = $256;__label__ = 17; break;
    case 13: // $_ZNSt3__114__mb_cur_max_lEPv_exit
      var $257=$7;
      var $258=$8;
      var $259=$__tmp_i_i_i1_i;
      var $260=$9;
      var $261=$10;
      var $262=$11;
      var $263=$12;
      var $264=HEAP32[(($46)>>2)];
      var $265=$46;
      var $266=$47;
      var $267=$__current_i;
      var $268=$48;
      var $269=$49;
      var $270=$50;
      __label__ = 14; break;
    case 14: // $271
      var $273 = $264;__label__ = 15; break;
    case 15: // $272
      var $273;
      STACKTOP = __stackBase__;
      return $273;
    case 16: // $274
      var $275=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $eh_lpad_body = $275;__label__ = 17; break;
    case 17: // $_body
      var $eh_lpad_body;
      var $276=$eh_lpad_body.f0;
      $52=$276;
      var $277=$eh_lpad_body.f1;
      $53=$277;
      __label__ = 18; break;
    case 18: // $278
      var $279=$52;
      ___cxa_call_unexpected($279);
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__17codecvtIwc10_mbstate_tE13do_max_lengthEv["X"]=1;

function __ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt, $Maxcode, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $wc1;
      var $wc2;
      var $z;
      $2=$frm;
      $3=$frm_end;
      $4=$frm_nxt;
      $5=$to;
      $6=$to_end;
      $7=$to_nxt;
      $8=$Maxcode;
      $9=$mode;
      var $10=$2;
      var $11=$4;
      HEAP32[(($11)>>2)]=$10;
      var $12=$5;
      var $13=$7;
      HEAP32[(($13)>>2)]=$12;
      var $14=$9;
      var $15=$14 & 2;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $17
      var $18=$6;
      var $19=$7;
      var $20=HEAP32[(($19)>>2)];
      var $21=$18;
      var $22=$20;
      var $23=(($21-$22)|0);
      var $24=(($23)|0) < 3;
      if ($24) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $25
      $1=1;
      __label__ = 42; break;
    case 3: // $26
      var $27=$7;
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+1)|0);
      HEAP32[(($27)>>2)]=$29;
      HEAP8[($28)]=-17;
      var $30=$7;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+1)|0);
      HEAP32[(($30)>>2)]=$32;
      HEAP8[($31)]=-69;
      var $33=$7;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      HEAP32[(($33)>>2)]=$35;
      HEAP8[($34)]=-65;
      __label__ = 4; break;
    case 4: // $36
      __label__ = 5; break;
    case 5: // $37
      var $38=$4;
      var $39=HEAPU32[(($38)>>2)];
      var $40=$3;
      var $41=(($39)>>>0) < (($40)>>>0);
      if ($41) { __label__ = 6; break; } else { __label__ = 41; break; }
    case 6: // $42
      var $43=$4;
      var $44=HEAP32[(($43)>>2)];
      var $45=HEAP16[(($44)>>1)];
      $wc1=$45;
      var $46=$wc1;
      var $47=(($46)&65535);
      var $48=$8;
      var $49=(($47)>>>0) > (($48)>>>0);
      if ($49) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $50
      $1=2;
      __label__ = 42; break;
    case 8: // $51
      var $52=$wc1;
      var $53=(($52)&65535);
      var $54=(($53)|0) < 128;
      if ($54) { __label__ = 9; break; } else { __label__ = 12; break; }
    case 9: // $55
      var $56=$6;
      var $57=$7;
      var $58=HEAP32[(($57)>>2)];
      var $59=$56;
      var $60=$58;
      var $61=(($59-$60)|0);
      var $62=(($61)|0) < 1;
      if ($62) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $63
      $1=1;
      __label__ = 42; break;
    case 11: // $64
      var $65=$wc1;
      var $66=(($65) & 255);
      var $67=$7;
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68+1)|0);
      HEAP32[(($67)>>2)]=$69;
      HEAP8[($68)]=$66;
      __label__ = 39; break;
    case 12: // $70
      var $71=$wc1;
      var $72=(($71)&65535);
      var $73=(($72)|0) < 2048;
      if ($73) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $74
      var $75=$6;
      var $76=$7;
      var $77=HEAP32[(($76)>>2)];
      var $78=$75;
      var $79=$77;
      var $80=(($78-$79)|0);
      var $81=(($80)|0) < 2;
      if ($81) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $82
      $1=1;
      __label__ = 42; break;
    case 15: // $83
      var $84=$wc1;
      var $85=(($84)&65535);
      var $86=$85 >> 6;
      var $87=192 | $86;
      var $88=(($87) & 255);
      var $89=$7;
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+1)|0);
      HEAP32[(($89)>>2)]=$91;
      HEAP8[($90)]=$88;
      var $92=$wc1;
      var $93=(($92)&65535);
      var $94=$93 & 63;
      var $95=128 | $94;
      var $96=(($95) & 255);
      var $97=$7;
      var $98=HEAP32[(($97)>>2)];
      var $99=(($98+1)|0);
      HEAP32[(($97)>>2)]=$99;
      HEAP8[($98)]=$96;
      __label__ = 38; break;
    case 16: // $100
      var $101=$wc1;
      var $102=(($101)&65535);
      var $103=(($102)|0) < 55296;
      if ($103) { __label__ = 17; break; } else { __label__ = 20; break; }
    case 17: // $104
      var $105=$6;
      var $106=$7;
      var $107=HEAP32[(($106)>>2)];
      var $108=$105;
      var $109=$107;
      var $110=(($108-$109)|0);
      var $111=(($110)|0) < 3;
      if ($111) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $112
      $1=1;
      __label__ = 42; break;
    case 19: // $113
      var $114=$wc1;
      var $115=(($114)&65535);
      var $116=$115 >> 12;
      var $117=224 | $116;
      var $118=(($117) & 255);
      var $119=$7;
      var $120=HEAP32[(($119)>>2)];
      var $121=(($120+1)|0);
      HEAP32[(($119)>>2)]=$121;
      HEAP8[($120)]=$118;
      var $122=$wc1;
      var $123=(($122)&65535);
      var $124=$123 & 4032;
      var $125=$124 >> 6;
      var $126=128 | $125;
      var $127=(($126) & 255);
      var $128=$7;
      var $129=HEAP32[(($128)>>2)];
      var $130=(($129+1)|0);
      HEAP32[(($128)>>2)]=$130;
      HEAP8[($129)]=$127;
      var $131=$wc1;
      var $132=(($131)&65535);
      var $133=$132 & 63;
      var $134=128 | $133;
      var $135=(($134) & 255);
      var $136=$7;
      var $137=HEAP32[(($136)>>2)];
      var $138=(($137+1)|0);
      HEAP32[(($136)>>2)]=$138;
      HEAP8[($137)]=$135;
      __label__ = 37; break;
    case 20: // $139
      var $140=$wc1;
      var $141=(($140)&65535);
      var $142=(($141)|0) < 56320;
      if ($142) { __label__ = 21; break; } else { __label__ = 30; break; }
    case 21: // $143
      var $144=$3;
      var $145=$4;
      var $146=HEAP32[(($145)>>2)];
      var $147=$144;
      var $148=$146;
      var $149=(($147-$148)|0);
      var $150=(((($149)|0)/2)|0);
      var $151=(($150)|0) < 2;
      if ($151) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $152
      $1=1;
      __label__ = 42; break;
    case 23: // $153
      var $154=$4;
      var $155=HEAP32[(($154)>>2)];
      var $156=(($155+2)|0);
      var $157=HEAP16[(($156)>>1)];
      $wc2=$157;
      var $158=$wc2;
      var $159=(($158)&65535);
      var $160=$159 & 64512;
      var $161=(($160)|0)!=56320;
      if ($161) { __label__ = 24; break; } else { __label__ = 25; break; }
    case 24: // $162
      $1=2;
      __label__ = 42; break;
    case 25: // $163
      var $164=$6;
      var $165=$7;
      var $166=HEAP32[(($165)>>2)];
      var $167=$164;
      var $168=$166;
      var $169=(($167-$168)|0);
      var $170=(($169)|0) < 4;
      if ($170) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $171
      $1=1;
      __label__ = 42; break;
    case 27: // $172
      var $173=$wc1;
      var $174=(($173)&65535);
      var $175=$174 & 960;
      var $176=$175 >>> 6;
      var $177=(($176+1)|0);
      var $178=$177 << 16;
      var $179=$wc1;
      var $180=(($179)&65535);
      var $181=$180 & 63;
      var $182=$181 << 10;
      var $183=(($178+$182)|0);
      var $184=$wc2;
      var $185=(($184)&65535);
      var $186=$185 & 1023;
      var $187=(($183+$186)|0);
      var $188=$8;
      var $189=(($187)>>>0) > (($188)>>>0);
      if ($189) { __label__ = 28; break; } else { __label__ = 29; break; }
    case 28: // $190
      $1=2;
      __label__ = 42; break;
    case 29: // $191
      var $192=$4;
      var $193=HEAP32[(($192)>>2)];
      var $194=(($193+2)|0);
      HEAP32[(($192)>>2)]=$194;
      var $195=$wc1;
      var $196=(($195)&65535);
      var $197=$196 & 960;
      var $198=$197 >> 6;
      var $199=(($198+1)|0);
      var $200=(($199) & 255);
      $z=$200;
      var $201=$z;
      var $202=(($201)&255);
      var $203=$202 >> 2;
      var $204=240 | $203;
      var $205=(($204) & 255);
      var $206=$7;
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207+1)|0);
      HEAP32[(($206)>>2)]=$208;
      HEAP8[($207)]=$205;
      var $209=$z;
      var $210=(($209)&255);
      var $211=$210 & 3;
      var $212=$211 << 4;
      var $213=128 | $212;
      var $214=$wc1;
      var $215=(($214)&65535);
      var $216=$215 & 60;
      var $217=$216 >> 2;
      var $218=$213 | $217;
      var $219=(($218) & 255);
      var $220=$7;
      var $221=HEAP32[(($220)>>2)];
      var $222=(($221+1)|0);
      HEAP32[(($220)>>2)]=$222;
      HEAP8[($221)]=$219;
      var $223=$wc1;
      var $224=(($223)&65535);
      var $225=$224 & 3;
      var $226=$225 << 4;
      var $227=128 | $226;
      var $228=$wc2;
      var $229=(($228)&65535);
      var $230=$229 & 960;
      var $231=$230 >> 6;
      var $232=$227 | $231;
      var $233=(($232) & 255);
      var $234=$7;
      var $235=HEAP32[(($234)>>2)];
      var $236=(($235+1)|0);
      HEAP32[(($234)>>2)]=$236;
      HEAP8[($235)]=$233;
      var $237=$wc2;
      var $238=(($237)&65535);
      var $239=$238 & 63;
      var $240=128 | $239;
      var $241=(($240) & 255);
      var $242=$7;
      var $243=HEAP32[(($242)>>2)];
      var $244=(($243+1)|0);
      HEAP32[(($242)>>2)]=$244;
      HEAP8[($243)]=$241;
      __label__ = 36; break;
    case 30: // $245
      var $246=$wc1;
      var $247=(($246)&65535);
      var $248=(($247)|0) < 57344;
      if ($248) { __label__ = 31; break; } else { __label__ = 32; break; }
    case 31: // $249
      $1=2;
      __label__ = 42; break;
    case 32: // $250
      var $251=$6;
      var $252=$7;
      var $253=HEAP32[(($252)>>2)];
      var $254=$251;
      var $255=$253;
      var $256=(($254-$255)|0);
      var $257=(($256)|0) < 3;
      if ($257) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $258
      $1=1;
      __label__ = 42; break;
    case 34: // $259
      var $260=$wc1;
      var $261=(($260)&65535);
      var $262=$261 >> 12;
      var $263=224 | $262;
      var $264=(($263) & 255);
      var $265=$7;
      var $266=HEAP32[(($265)>>2)];
      var $267=(($266+1)|0);
      HEAP32[(($265)>>2)]=$267;
      HEAP8[($266)]=$264;
      var $268=$wc1;
      var $269=(($268)&65535);
      var $270=$269 & 4032;
      var $271=$270 >> 6;
      var $272=128 | $271;
      var $273=(($272) & 255);
      var $274=$7;
      var $275=HEAP32[(($274)>>2)];
      var $276=(($275+1)|0);
      HEAP32[(($274)>>2)]=$276;
      HEAP8[($275)]=$273;
      var $277=$wc1;
      var $278=(($277)&65535);
      var $279=$278 & 63;
      var $280=128 | $279;
      var $281=(($280) & 255);
      var $282=$7;
      var $283=HEAP32[(($282)>>2)];
      var $284=(($283+1)|0);
      HEAP32[(($282)>>2)]=$284;
      HEAP8[($283)]=$281;
      __label__ = 35; break;
    case 35: // $285
      __label__ = 36; break;
    case 36: // $286
      __label__ = 37; break;
    case 37: // $287
      __label__ = 38; break;
    case 38: // $288
      __label__ = 39; break;
    case 39: // $289
      __label__ = 40; break;
    case 40: // $290
      var $291=$4;
      var $292=HEAP32[(($291)>>2)];
      var $293=(($292+2)|0);
      HEAP32[(($291)>>2)]=$293;
      __label__ = 5; break;
    case 41: // $294
      $1=0;
      __label__ = 42; break;
    case 42: // $295
      var $296=$1;
      ;
      return $296;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE["X"]=1;

function __ZNKSt3__17codecvtItc10_mbstate_tE5do_inERS1_PKcS5_RS5_PtS7_RS7_($this, $0, $frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $_frm;
  var $_frm_end;
  var $_frm_nxt=__stackBase__;
  var $_to;
  var $_to_end;
  var $_to_nxt=__stackBase__+4;
  var $r;
  $2=$this;
  $3=$0;
  $4=$frm;
  $5=$frm_end;
  $6=$frm_nxt;
  $7=$to;
  $8=$to_end;
  $9=$to_nxt;
  var $10=$2;
  var $11=$4;
  $_frm=$11;
  var $12=$5;
  $_frm_end=$12;
  var $13=$_frm;
  HEAP32[(($_frm_nxt)>>2)]=$13;
  var $14=$7;
  $_to=$14;
  var $15=$8;
  $_to_end=$15;
  var $16=$_to;
  HEAP32[(($_to_nxt)>>2)]=$16;
  var $17=$_frm;
  var $18=$_frm_end;
  var $19=$_to;
  var $20=$_to_end;
  var $21=__ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE($17, $18, $_frm_nxt, $19, $20, $_to_nxt, 1114111, 0);
  $r=$21;
  var $22=$4;
  var $23=HEAP32[(($_frm_nxt)>>2)];
  var $24=$_frm;
  var $25=$23;
  var $26=$24;
  var $27=(($25-$26)|0);
  var $28=(($22+$27)|0);
  var $29=$6;
  HEAP32[(($29)>>2)]=$28;
  var $30=$7;
  var $31=HEAP32[(($_to_nxt)>>2)];
  var $32=$_to;
  var $33=$31;
  var $34=$32;
  var $35=(($33-$34)|0);
  var $36=(((($35)|0)/2)|0);
  var $37=(($30+($36<<1))|0);
  var $38=$9;
  HEAP32[(($38)>>2)]=$37;
  var $39=$r;
  STACKTOP = __stackBase__;
  return $39;
}
__ZNKSt3__17codecvtItc10_mbstate_tE5do_inERS1_PKcS5_RS5_PtS7_RS7_["X"]=1;

function __ZNKSt3__17codecvtItc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_($this, $0, $to, $1, $to_nxt) {
  ;
  var __label__;

  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $3=$this;
  $4=$0;
  $5=$to;
  $6=$1;
  $7=$to_nxt;
  var $8=$3;
  var $9=$5;
  var $10=$7;
  HEAP32[(($10)>>2)]=$9;
  ;
  return 3;
}


function __ZNKSt3__17codecvtItc10_mbstate_tE11do_encodingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__17codecvtItc10_mbstate_tE16do_always_noconvEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE($frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt, $Maxcode, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $c1;
      var $c2;
      var $t;
      var $c21;
      var $c3;
      var $t2;
      var $c23;
      var $c34;
      var $c4;
      $2=$frm;
      $3=$frm_end;
      $4=$frm_nxt;
      $5=$to;
      $6=$to_end;
      $7=$to_nxt;
      $8=$Maxcode;
      $9=$mode;
      var $10=$2;
      var $11=$4;
      HEAP32[(($11)>>2)]=$10;
      var $12=$5;
      var $13=$7;
      HEAP32[(($13)>>2)]=$12;
      var $14=$9;
      var $15=$14 & 4;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $17
      var $18=$3;
      var $19=$4;
      var $20=HEAP32[(($19)>>2)];
      var $21=$18;
      var $22=$20;
      var $23=(($21-$22)|0);
      var $24=(($23)|0) >= 3;
      if ($24) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=(($30)|0)==239;
      if ($31) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $32
      var $33=$4;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=(($37)|0)==187;
      if ($38) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $39
      var $40=$4;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+2)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==191;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$4;
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+3)|0);
      HEAP32[(($47)>>2)]=$49;
      __label__ = 6; break;
    case 6: // $50
      __label__ = 7; break;
    case 7: // $51
      __label__ = 8; break;
    case 8: // $52
      var $53=$4;
      var $54=HEAPU32[(($53)>>2)];
      var $55=$3;
      var $56=(($54)>>>0) < (($55)>>>0);
      if ($56) { __label__ = 9; break; } else { var $63 = 0;__label__ = 10; break; }
    case 9: // $57
      var $58=$7;
      var $59=HEAPU32[(($58)>>2)];
      var $60=$6;
      var $61=(($59)>>>0) < (($60)>>>0);
      var $63 = $61;__label__ = 10; break;
    case 10: // $62
      var $63;
      if ($63) { __label__ = 11; break; } else { __label__ = 72; break; }
    case 11: // $64
      var $65=$4;
      var $66=HEAP32[(($65)>>2)];
      var $67=HEAP8[($66)];
      $c1=$67;
      var $68=$c1;
      var $69=(($68)&255);
      var $70=$8;
      var $71=(($69)>>>0) > (($70)>>>0);
      if ($71) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $72
      $1=2;
      __label__ = 73; break;
    case 13: // $73
      var $74=$c1;
      var $75=(($74)&255);
      var $76=(($75)|0) < 128;
      if ($76) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $77
      var $78=$c1;
      var $79=(($78)&255);
      var $80=$7;
      var $81=HEAP32[(($80)>>2)];
      HEAP16[(($81)>>1)]=$79;
      var $82=$4;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+1)|0);
      HEAP32[(($82)>>2)]=$84;
      __label__ = 70; break;
    case 15: // $85
      var $86=$c1;
      var $87=(($86)&255);
      var $88=(($87)|0) < 194;
      if ($88) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $89
      $1=2;
      __label__ = 73; break;
    case 17: // $90
      var $91=$c1;
      var $92=(($91)&255);
      var $93=(($92)|0) < 224;
      if ($93) { __label__ = 18; break; } else { __label__ = 25; break; }
    case 18: // $94
      var $95=$3;
      var $96=$4;
      var $97=HEAP32[(($96)>>2)];
      var $98=$95;
      var $99=$97;
      var $100=(($98-$99)|0);
      var $101=(($100)|0) < 2;
      if ($101) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $102
      $1=1;
      __label__ = 73; break;
    case 20: // $103
      var $104=$4;
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+1)|0);
      var $107=HEAP8[($106)];
      $c2=$107;
      var $108=$c2;
      var $109=(($108)&255);
      var $110=$109 & 192;
      var $111=(($110)|0)!=128;
      if ($111) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $112
      $1=2;
      __label__ = 73; break;
    case 22: // $113
      var $114=$c1;
      var $115=(($114)&255);
      var $116=$115 & 31;
      var $117=$116 << 6;
      var $118=$c2;
      var $119=(($118)&255);
      var $120=$119 & 63;
      var $121=$117 | $120;
      var $122=(($121) & 65535);
      $t=$122;
      var $123=$t;
      var $124=(($123)&65535);
      var $125=$8;
      var $126=(($124)>>>0) > (($125)>>>0);
      if ($126) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $127
      $1=2;
      __label__ = 73; break;
    case 24: // $128
      var $129=$t;
      var $130=$7;
      var $131=HEAP32[(($130)>>2)];
      HEAP16[(($131)>>1)]=$129;
      var $132=$4;
      var $133=HEAP32[(($132)>>2)];
      var $134=(($133+2)|0);
      HEAP32[(($132)>>2)]=$134;
      __label__ = 68; break;
    case 25: // $135
      var $136=$c1;
      var $137=(($136)&255);
      var $138=(($137)|0) < 240;
      if ($138) { __label__ = 26; break; } else { __label__ = 43; break; }
    case 26: // $139
      var $140=$3;
      var $141=$4;
      var $142=HEAP32[(($141)>>2)];
      var $143=$140;
      var $144=$142;
      var $145=(($143-$144)|0);
      var $146=(($145)|0) < 3;
      if ($146) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $147
      $1=1;
      __label__ = 73; break;
    case 28: // $148
      var $149=$4;
      var $150=HEAP32[(($149)>>2)];
      var $151=(($150+1)|0);
      var $152=HEAP8[($151)];
      $c21=$152;
      var $153=$4;
      var $154=HEAP32[(($153)>>2)];
      var $155=(($154+2)|0);
      var $156=HEAP8[($155)];
      $c3=$156;
      var $157=$c1;
      var $158=(($157)&255);
      if ($158 == 224) {
        __label__ = 29; break;
      }
      else if ($158 == 237) {
        __label__ = 32; break;
      }
      else {
      __label__ = 35; break;
      }
      
    case 29: // $159
      var $160=$c21;
      var $161=(($160)&255);
      var $162=$161 & 224;
      var $163=(($162)|0)!=160;
      if ($163) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $164
      $1=2;
      __label__ = 73; break;
    case 31: // $165
      __label__ = 38; break;
    case 32: // $166
      var $167=$c21;
      var $168=(($167)&255);
      var $169=$168 & 224;
      var $170=(($169)|0)!=128;
      if ($170) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $171
      $1=2;
      __label__ = 73; break;
    case 34: // $172
      __label__ = 38; break;
    case 35: // $173
      var $174=$c21;
      var $175=(($174)&255);
      var $176=$175 & 192;
      var $177=(($176)|0)!=128;
      if ($177) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $178
      $1=2;
      __label__ = 73; break;
    case 37: // $179
      __label__ = 38; break;
    case 38: // $180
      var $181=$c3;
      var $182=(($181)&255);
      var $183=$182 & 192;
      var $184=(($183)|0)!=128;
      if ($184) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $185
      $1=2;
      __label__ = 73; break;
    case 40: // $186
      var $187=$c1;
      var $188=(($187)&255);
      var $189=$188 & 15;
      var $190=$189 << 12;
      var $191=$c21;
      var $192=(($191)&255);
      var $193=$192 & 63;
      var $194=$193 << 6;
      var $195=$190 | $194;
      var $196=$c3;
      var $197=(($196)&255);
      var $198=$197 & 63;
      var $199=$195 | $198;
      var $200=(($199) & 65535);
      $t2=$200;
      var $201=$t2;
      var $202=(($201)&65535);
      var $203=$8;
      var $204=(($202)>>>0) > (($203)>>>0);
      if ($204) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $205
      $1=2;
      __label__ = 73; break;
    case 42: // $206
      var $207=$t2;
      var $208=$7;
      var $209=HEAP32[(($208)>>2)];
      HEAP16[(($209)>>1)]=$207;
      var $210=$4;
      var $211=HEAP32[(($210)>>2)];
      var $212=(($211+3)|0);
      HEAP32[(($210)>>2)]=$212;
      __label__ = 67; break;
    case 43: // $213
      var $214=$c1;
      var $215=(($214)&255);
      var $216=(($215)|0) < 245;
      if ($216) { __label__ = 44; break; } else { __label__ = 65; break; }
    case 44: // $217
      var $218=$3;
      var $219=$4;
      var $220=HEAP32[(($219)>>2)];
      var $221=$218;
      var $222=$220;
      var $223=(($221-$222)|0);
      var $224=(($223)|0) < 4;
      if ($224) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $225
      $1=1;
      __label__ = 73; break;
    case 46: // $226
      var $227=$4;
      var $228=HEAP32[(($227)>>2)];
      var $229=(($228+1)|0);
      var $230=HEAP8[($229)];
      $c23=$230;
      var $231=$4;
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232+2)|0);
      var $234=HEAP8[($233)];
      $c34=$234;
      var $235=$4;
      var $236=HEAP32[(($235)>>2)];
      var $237=(($236+3)|0);
      var $238=HEAP8[($237)];
      $c4=$238;
      var $239=$c1;
      var $240=(($239)&255);
      if ($240 == 240) {
        __label__ = 47; break;
      }
      else if ($240 == 244) {
        __label__ = 51; break;
      }
      else {
      __label__ = 54; break;
      }
      
    case 47: // $241
      var $242=$c23;
      var $243=(($242)&255);
      var $244=144 <= (($243)|0);
      if ($244) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $245
      var $246=$c23;
      var $247=(($246)&255);
      var $248=(($247)|0) <= 191;
      if ($248) { __label__ = 50; break; } else { __label__ = 49; break; }
    case 49: // $249
      $1=2;
      __label__ = 73; break;
    case 50: // $250
      __label__ = 57; break;
    case 51: // $251
      var $252=$c23;
      var $253=(($252)&255);
      var $254=$253 & 240;
      var $255=(($254)|0)!=128;
      if ($255) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $256
      $1=2;
      __label__ = 73; break;
    case 53: // $257
      __label__ = 57; break;
    case 54: // $258
      var $259=$c23;
      var $260=(($259)&255);
      var $261=$260 & 192;
      var $262=(($261)|0)!=128;
      if ($262) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $263
      $1=2;
      __label__ = 73; break;
    case 56: // $264
      __label__ = 57; break;
    case 57: // $265
      var $266=$c34;
      var $267=(($266)&255);
      var $268=$267 & 192;
      var $269=(($268)|0)!=128;
      if ($269) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $270
      var $271=$c4;
      var $272=(($271)&255);
      var $273=$272 & 192;
      var $274=(($273)|0)!=128;
      if ($274) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $275
      $1=2;
      __label__ = 73; break;
    case 60: // $276
      var $277=$6;
      var $278=$7;
      var $279=HEAP32[(($278)>>2)];
      var $280=$277;
      var $281=$279;
      var $282=(($280-$281)|0);
      var $283=(((($282)|0)/2)|0);
      var $284=(($283)|0) < 2;
      if ($284) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $285
      $1=1;
      __label__ = 73; break;
    case 62: // $286
      var $287=$c1;
      var $288=(($287)&255);
      var $289=$288 & 7;
      var $290=$289 << 18;
      var $291=$c23;
      var $292=(($291)&255);
      var $293=$292 & 63;
      var $294=$293 << 12;
      var $295=(($290+$294)|0);
      var $296=$c34;
      var $297=(($296)&255);
      var $298=$297 & 63;
      var $299=$298 << 6;
      var $300=(($295+$299)|0);
      var $301=$c4;
      var $302=(($301)&255);
      var $303=$302 & 63;
      var $304=(($300+$303)|0);
      var $305=$8;
      var $306=(($304)>>>0) > (($305)>>>0);
      if ($306) { __label__ = 63; break; } else { __label__ = 64; break; }
    case 63: // $307
      $1=2;
      __label__ = 73; break;
    case 64: // $308
      var $309=$c1;
      var $310=(($309)&255);
      var $311=$310 & 7;
      var $312=$311 << 2;
      var $313=$c23;
      var $314=(($313)&255);
      var $315=$314 & 48;
      var $316=$315 >> 4;
      var $317=$312 | $316;
      var $318=(($317-1)|0);
      var $319=$318 << 6;
      var $320=55296 | $319;
      var $321=$c23;
      var $322=(($321)&255);
      var $323=$322 & 15;
      var $324=$323 << 2;
      var $325=$320 | $324;
      var $326=$c34;
      var $327=(($326)&255);
      var $328=$327 & 48;
      var $329=$328 >> 4;
      var $330=$325 | $329;
      var $331=(($330) & 65535);
      var $332=$7;
      var $333=HEAP32[(($332)>>2)];
      HEAP16[(($333)>>1)]=$331;
      var $334=$c34;
      var $335=(($334)&255);
      var $336=$335 & 15;
      var $337=$336 << 6;
      var $338=56320 | $337;
      var $339=$c4;
      var $340=(($339)&255);
      var $341=$340 & 63;
      var $342=$338 | $341;
      var $343=(($342) & 65535);
      var $344=$7;
      var $345=HEAP32[(($344)>>2)];
      var $346=(($345+2)|0);
      HEAP32[(($344)>>2)]=$346;
      HEAP16[(($346)>>1)]=$343;
      var $347=$4;
      var $348=HEAP32[(($347)>>2)];
      var $349=(($348+4)|0);
      HEAP32[(($347)>>2)]=$349;
      __label__ = 66; break;
    case 65: // $350
      $1=2;
      __label__ = 73; break;
    case 66: // $351
      __label__ = 67; break;
    case 67: // $352
      __label__ = 68; break;
    case 68: // $353
      __label__ = 69; break;
    case 69: // $354
      __label__ = 70; break;
    case 70: // $355
      __label__ = 71; break;
    case 71: // $356
      var $357=$7;
      var $358=HEAP32[(($357)>>2)];
      var $359=(($358+2)|0);
      HEAP32[(($357)>>2)]=$359;
      __label__ = 8; break;
    case 72: // $360
      var $361=$4;
      var $362=HEAPU32[(($361)>>2)];
      var $363=$3;
      var $364=(($362)>>>0) < (($363)>>>0);
      var $365=$364 ? 1 : 0;
      $1=$365;
      __label__ = 73; break;
    case 73: // $366
      var $367=$1;
      ;
      return $367;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE["X"]=1;

function __ZNKSt3__17codecvtItc10_mbstate_tE9do_lengthERS1_PKcS5_j($this, $0, $frm, $frm_end, $mx) {
  ;
  var __label__;

  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $_frm;
  var $_frm_end;
  $2=$this;
  $3=$0;
  $4=$frm;
  $5=$frm_end;
  $6=$mx;
  var $7=$2;
  var $8=$4;
  $_frm=$8;
  var $9=$5;
  $_frm_end=$9;
  var $10=$_frm;
  var $11=$_frm_end;
  var $12=$6;
  var $13=__ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE($10, $11, $12, 1114111, 0);
  ;
  return $13;
}


function __ZNKSt3__17codecvtItc10_mbstate_tE13do_max_lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 4;
}


function __ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE($frm, $frm_end, $mx, $Maxcode, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $frm_nxt;
      var $nchar16_t;
      var $c1;
      var $t;
      var $c2;
      var $c3;
      var $t1;
      var $c22;
      var $c33;
      var $c4;
      $2=$frm;
      $3=$frm_end;
      $4=$mx;
      $5=$Maxcode;
      $6=$mode;
      var $7=$2;
      $frm_nxt=$7;
      var $8=$6;
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $11
      var $12=$3;
      var $13=$frm_nxt;
      var $14=$12;
      var $15=$13;
      var $16=(($14-$15)|0);
      var $17=(($16)|0) >= 3;
      if ($17) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $18
      var $19=$frm_nxt;
      var $20=(($19)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($22)|0)==239;
      if ($23) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $24
      var $25=$frm_nxt;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)==187;
      if ($29) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      var $31=$frm_nxt;
      var $32=(($31+2)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=(($34)|0)==191;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      var $37=$frm_nxt;
      var $38=(($37+3)|0);
      $frm_nxt=$38;
      __label__ = 6; break;
    case 6: // $39
      __label__ = 7; break;
    case 7: // $40
      $nchar16_t=0;
      __label__ = 8; break;
    case 8: // $41
      var $42=$frm_nxt;
      var $43=$3;
      var $44=(($42)>>>0) < (($43)>>>0);
      if ($44) { __label__ = 9; break; } else { var $50 = 0;__label__ = 10; break; }
    case 9: // $45
      var $46=$nchar16_t;
      var $47=$4;
      var $48=(($46)>>>0) < (($47)>>>0);
      var $50 = $48;__label__ = 10; break;
    case 10: // $49
      var $50;
      if ($50) { __label__ = 11; break; } else { __label__ = 70; break; }
    case 11: // $51
      var $52=$frm_nxt;
      var $53=HEAP8[($52)];
      $c1=$53;
      var $54=$c1;
      var $55=(($54)&255);
      var $56=$5;
      var $57=(($55)>>>0) > (($56)>>>0);
      if ($57) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $58
      __label__ = 70; break;
    case 13: // $59
      var $60=$c1;
      var $61=(($60)&255);
      var $62=(($61)|0) < 128;
      if ($62) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $63
      var $64=$frm_nxt;
      var $65=(($64+1)|0);
      $frm_nxt=$65;
      __label__ = 68; break;
    case 15: // $66
      var $67=$c1;
      var $68=(($67)&255);
      var $69=(($68)|0) < 194;
      if ($69) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $70
      __label__ = 70; break;
    case 17: // $71
      var $72=$c1;
      var $73=(($72)&255);
      var $74=(($73)|0) < 224;
      if ($74) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $75
      var $76=$3;
      var $77=$frm_nxt;
      var $78=$76;
      var $79=$77;
      var $80=(($78-$79)|0);
      var $81=(($80)|0) < 2;
      if ($81) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $82
      var $83=$frm_nxt;
      var $84=(($83+1)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$86 & 192;
      var $88=(($87)|0)!=128;
      if ($88) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $89
      __label__ = 70; break;
    case 21: // $90
      var $91=$c1;
      var $92=(($91)&255);
      var $93=$92 & 31;
      var $94=$93 << 6;
      var $95=$frm_nxt;
      var $96=(($95+1)|0);
      var $97=HEAPU8[($96)];
      var $98=(($97)&255);
      var $99=$98 & 63;
      var $100=$94 | $99;
      var $101=(($100) & 65535);
      $t=$101;
      var $102=$t;
      var $103=(($102)&65535);
      var $104=$5;
      var $105=(($103)>>>0) > (($104)>>>0);
      if ($105) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $106
      __label__ = 70; break;
    case 23: // $107
      var $108=$frm_nxt;
      var $109=(($108+2)|0);
      $frm_nxt=$109;
      __label__ = 66; break;
    case 24: // $110
      var $111=$c1;
      var $112=(($111)&255);
      var $113=(($112)|0) < 240;
      if ($113) { __label__ = 25; break; } else { __label__ = 42; break; }
    case 25: // $114
      var $115=$3;
      var $116=$frm_nxt;
      var $117=$115;
      var $118=$116;
      var $119=(($117-$118)|0);
      var $120=(($119)|0) < 3;
      if ($120) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $121
      __label__ = 70; break;
    case 27: // $122
      var $123=$frm_nxt;
      var $124=(($123+1)|0);
      var $125=HEAP8[($124)];
      $c2=$125;
      var $126=$frm_nxt;
      var $127=(($126+2)|0);
      var $128=HEAP8[($127)];
      $c3=$128;
      var $129=$c1;
      var $130=(($129)&255);
      var $131=$130 & 15;
      var $132=$131 << 12;
      var $133=$c2;
      var $134=(($133)&255);
      var $135=$134 & 63;
      var $136=$135 << 6;
      var $137=$132 | $136;
      var $138=$c3;
      var $139=(($138)&255);
      var $140=$139 & 63;
      var $141=$137 | $140;
      var $142=(($141) & 65535);
      $t1=$142;
      var $143=$c1;
      var $144=(($143)&255);
      if ($144 == 224) {
        __label__ = 28; break;
      }
      else if ($144 == 237) {
        __label__ = 31; break;
      }
      else {
      __label__ = 34; break;
      }
      
    case 28: // $145
      var $146=$c2;
      var $147=(($146)&255);
      var $148=$147 & 224;
      var $149=(($148)|0)!=160;
      if ($149) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $150
      var $151=$frm_nxt;
      var $152=$2;
      var $153=$151;
      var $154=$152;
      var $155=(($153-$154)|0);
      $1=$155;
      __label__ = 71; break;
    case 30: // $156
      __label__ = 37; break;
    case 31: // $157
      var $158=$c2;
      var $159=(($158)&255);
      var $160=$159 & 224;
      var $161=(($160)|0)!=128;
      if ($161) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $162
      var $163=$frm_nxt;
      var $164=$2;
      var $165=$163;
      var $166=$164;
      var $167=(($165-$166)|0);
      $1=$167;
      __label__ = 71; break;
    case 33: // $168
      __label__ = 37; break;
    case 34: // $169
      var $170=$c2;
      var $171=(($170)&255);
      var $172=$171 & 192;
      var $173=(($172)|0)!=128;
      if ($173) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $174
      var $175=$frm_nxt;
      var $176=$2;
      var $177=$175;
      var $178=$176;
      var $179=(($177-$178)|0);
      $1=$179;
      __label__ = 71; break;
    case 36: // $180
      __label__ = 37; break;
    case 37: // $181
      var $182=$c3;
      var $183=(($182)&255);
      var $184=$183 & 192;
      var $185=(($184)|0)!=128;
      if ($185) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $186
      __label__ = 70; break;
    case 39: // $187
      var $188=$c1;
      var $189=(($188)&255);
      var $190=$189 & 15;
      var $191=$190 << 12;
      var $192=$c2;
      var $193=(($192)&255);
      var $194=$193 & 63;
      var $195=$194 << 6;
      var $196=$191 | $195;
      var $197=$c3;
      var $198=(($197)&255);
      var $199=$198 & 63;
      var $200=$196 | $199;
      var $201=$5;
      var $202=(($200)>>>0) > (($201)>>>0);
      if ($202) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $203
      __label__ = 70; break;
    case 41: // $204
      var $205=$frm_nxt;
      var $206=(($205+3)|0);
      $frm_nxt=$206;
      __label__ = 65; break;
    case 42: // $207
      var $208=$c1;
      var $209=(($208)&255);
      var $210=(($209)|0) < 245;
      if ($210) { __label__ = 43; break; } else { __label__ = 63; break; }
    case 43: // $211
      var $212=$3;
      var $213=$frm_nxt;
      var $214=$212;
      var $215=$213;
      var $216=(($214-$215)|0);
      var $217=(($216)|0) < 4;
      if ($217) { __label__ = 45; break; } else { __label__ = 44; break; }
    case 44: // $218
      var $219=$4;
      var $220=$nchar16_t;
      var $221=(($219-$220)|0);
      var $222=(($221)>>>0) < 2;
      if ($222) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $223
      __label__ = 70; break;
    case 46: // $224
      var $225=$frm_nxt;
      var $226=(($225+1)|0);
      var $227=HEAP8[($226)];
      $c22=$227;
      var $228=$frm_nxt;
      var $229=(($228+2)|0);
      var $230=HEAP8[($229)];
      $c33=$230;
      var $231=$frm_nxt;
      var $232=(($231+3)|0);
      var $233=HEAP8[($232)];
      $c4=$233;
      var $234=$c1;
      var $235=(($234)&255);
      if ($235 == 240) {
        __label__ = 47; break;
      }
      else if ($235 == 244) {
        __label__ = 51; break;
      }
      else {
      __label__ = 54; break;
      }
      
    case 47: // $236
      var $237=$c22;
      var $238=(($237)&255);
      var $239=144 <= (($238)|0);
      if ($239) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $240
      var $241=$c22;
      var $242=(($241)&255);
      var $243=(($242)|0) <= 191;
      if ($243) { __label__ = 50; break; } else { __label__ = 49; break; }
    case 49: // $244
      var $245=$frm_nxt;
      var $246=$2;
      var $247=$245;
      var $248=$246;
      var $249=(($247-$248)|0);
      $1=$249;
      __label__ = 71; break;
    case 50: // $250
      __label__ = 57; break;
    case 51: // $251
      var $252=$c22;
      var $253=(($252)&255);
      var $254=$253 & 240;
      var $255=(($254)|0)!=128;
      if ($255) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $256
      var $257=$frm_nxt;
      var $258=$2;
      var $259=$257;
      var $260=$258;
      var $261=(($259-$260)|0);
      $1=$261;
      __label__ = 71; break;
    case 53: // $262
      __label__ = 57; break;
    case 54: // $263
      var $264=$c22;
      var $265=(($264)&255);
      var $266=$265 & 192;
      var $267=(($266)|0)!=128;
      if ($267) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $268
      var $269=$frm_nxt;
      var $270=$2;
      var $271=$269;
      var $272=$270;
      var $273=(($271-$272)|0);
      $1=$273;
      __label__ = 71; break;
    case 56: // $274
      __label__ = 57; break;
    case 57: // $275
      var $276=$c33;
      var $277=(($276)&255);
      var $278=$277 & 192;
      var $279=(($278)|0)!=128;
      if ($279) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $280
      var $281=$c4;
      var $282=(($281)&255);
      var $283=$282 & 192;
      var $284=(($283)|0)!=128;
      if ($284) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $285
      __label__ = 70; break;
    case 60: // $286
      var $287=$c1;
      var $288=(($287)&255);
      var $289=$288 & 7;
      var $290=$289 << 18;
      var $291=$c22;
      var $292=(($291)&255);
      var $293=$292 & 63;
      var $294=$293 << 12;
      var $295=(($290+$294)|0);
      var $296=$c33;
      var $297=(($296)&255);
      var $298=$297 & 63;
      var $299=$298 << 6;
      var $300=(($295+$299)|0);
      var $301=$c4;
      var $302=(($301)&255);
      var $303=$302 & 63;
      var $304=(($300+$303)|0);
      var $305=$5;
      var $306=(($304)>>>0) > (($305)>>>0);
      if ($306) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $307
      __label__ = 70; break;
    case 62: // $308
      var $309=$nchar16_t;
      var $310=(($309+1)|0);
      $nchar16_t=$310;
      var $311=$frm_nxt;
      var $312=(($311+4)|0);
      $frm_nxt=$312;
      __label__ = 64; break;
    case 63: // $313
      __label__ = 70; break;
    case 64: // $314
      __label__ = 65; break;
    case 65: // $315
      __label__ = 66; break;
    case 66: // $316
      __label__ = 67; break;
    case 67: // $317
      __label__ = 68; break;
    case 68: // $318
      __label__ = 69; break;
    case 69: // $319
      var $320=$nchar16_t;
      var $321=(($320+1)|0);
      $nchar16_t=$321;
      __label__ = 8; break;
    case 70: // $322
      var $323=$frm_nxt;
      var $324=$2;
      var $325=$323;
      var $326=$324;
      var $327=(($325-$326)|0);
      $1=$327;
      __label__ = 71; break;
    case 71: // $328
      var $329=$1;
      ;
      return $329;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE["X"]=1;

function ___cxx_global_var_init49() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__17codecvtIjc10_mbstate_tE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt, $Maxcode, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $wc;
      $2=$frm;
      $3=$frm_end;
      $4=$frm_nxt;
      $5=$to;
      $6=$to_end;
      $7=$to_nxt;
      $8=$Maxcode;
      $9=$mode;
      var $10=$2;
      var $11=$4;
      HEAP32[(($11)>>2)]=$10;
      var $12=$5;
      var $13=$7;
      HEAP32[(($13)>>2)]=$12;
      var $14=$9;
      var $15=$14 & 2;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $17
      var $18=$6;
      var $19=$7;
      var $20=HEAP32[(($19)>>2)];
      var $21=$18;
      var $22=$20;
      var $23=(($21-$22)|0);
      var $24=(($23)|0) < 3;
      if ($24) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $25
      $1=1;
      __label__ = 29; break;
    case 3: // $26
      var $27=$7;
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28+1)|0);
      HEAP32[(($27)>>2)]=$29;
      HEAP8[($28)]=-17;
      var $30=$7;
      var $31=HEAP32[(($30)>>2)];
      var $32=(($31+1)|0);
      HEAP32[(($30)>>2)]=$32;
      HEAP8[($31)]=-69;
      var $33=$7;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      HEAP32[(($33)>>2)]=$35;
      HEAP8[($34)]=-65;
      __label__ = 4; break;
    case 4: // $36
      __label__ = 5; break;
    case 5: // $37
      var $38=$4;
      var $39=HEAPU32[(($38)>>2)];
      var $40=$3;
      var $41=(($39)>>>0) < (($40)>>>0);
      if ($41) { __label__ = 6; break; } else { __label__ = 28; break; }
    case 6: // $42
      var $43=$4;
      var $44=HEAP32[(($43)>>2)];
      var $45=HEAP32[(($44)>>2)];
      $wc=$45;
      var $46=$wc;
      var $47=$46 & -2048;
      var $48=(($47)|0)==55296;
      if ($48) { __label__ = 8; break; } else { __label__ = 7; break; }
    case 7: // $49
      var $50=$wc;
      var $51=$8;
      var $52=(($50)>>>0) > (($51)>>>0);
      if ($52) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $53
      $1=2;
      __label__ = 29; break;
    case 9: // $54
      var $55=$wc;
      var $56=(($55)>>>0) < 128;
      if ($56) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $57
      var $58=$6;
      var $59=$7;
      var $60=HEAP32[(($59)>>2)];
      var $61=$58;
      var $62=$60;
      var $63=(($61-$62)|0);
      var $64=(($63)|0) < 1;
      if ($64) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $65
      $1=1;
      __label__ = 29; break;
    case 12: // $66
      var $67=$wc;
      var $68=(($67) & 255);
      var $69=$7;
      var $70=HEAP32[(($69)>>2)];
      var $71=(($70+1)|0);
      HEAP32[(($69)>>2)]=$71;
      HEAP8[($70)]=$68;
      __label__ = 26; break;
    case 13: // $72
      var $73=$wc;
      var $74=(($73)>>>0) < 2048;
      if ($74) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $75
      var $76=$6;
      var $77=$7;
      var $78=HEAP32[(($77)>>2)];
      var $79=$76;
      var $80=$78;
      var $81=(($79-$80)|0);
      var $82=(($81)|0) < 2;
      if ($82) { __label__ = 15; break; } else { __label__ = 16; break; }
    case 15: // $83
      $1=1;
      __label__ = 29; break;
    case 16: // $84
      var $85=$wc;
      var $86=$85 >>> 6;
      var $87=192 | $86;
      var $88=(($87) & 255);
      var $89=$7;
      var $90=HEAP32[(($89)>>2)];
      var $91=(($90+1)|0);
      HEAP32[(($89)>>2)]=$91;
      HEAP8[($90)]=$88;
      var $92=$wc;
      var $93=$92 & 63;
      var $94=128 | $93;
      var $95=(($94) & 255);
      var $96=$7;
      var $97=HEAP32[(($96)>>2)];
      var $98=(($97+1)|0);
      HEAP32[(($96)>>2)]=$98;
      HEAP8[($97)]=$95;
      __label__ = 25; break;
    case 17: // $99
      var $100=$wc;
      var $101=(($100)>>>0) < 65536;
      if ($101) { __label__ = 18; break; } else { __label__ = 21; break; }
    case 18: // $102
      var $103=$6;
      var $104=$7;
      var $105=HEAP32[(($104)>>2)];
      var $106=$103;
      var $107=$105;
      var $108=(($106-$107)|0);
      var $109=(($108)|0) < 3;
      if ($109) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $110
      $1=1;
      __label__ = 29; break;
    case 20: // $111
      var $112=$wc;
      var $113=$112 >>> 12;
      var $114=224 | $113;
      var $115=(($114) & 255);
      var $116=$7;
      var $117=HEAP32[(($116)>>2)];
      var $118=(($117+1)|0);
      HEAP32[(($116)>>2)]=$118;
      HEAP8[($117)]=$115;
      var $119=$wc;
      var $120=$119 & 4032;
      var $121=$120 >>> 6;
      var $122=128 | $121;
      var $123=(($122) & 255);
      var $124=$7;
      var $125=HEAP32[(($124)>>2)];
      var $126=(($125+1)|0);
      HEAP32[(($124)>>2)]=$126;
      HEAP8[($125)]=$123;
      var $127=$wc;
      var $128=$127 & 63;
      var $129=128 | $128;
      var $130=(($129) & 255);
      var $131=$7;
      var $132=HEAP32[(($131)>>2)];
      var $133=(($132+1)|0);
      HEAP32[(($131)>>2)]=$133;
      HEAP8[($132)]=$130;
      __label__ = 24; break;
    case 21: // $134
      var $135=$6;
      var $136=$7;
      var $137=HEAP32[(($136)>>2)];
      var $138=$135;
      var $139=$137;
      var $140=(($138-$139)|0);
      var $141=(($140)|0) < 4;
      if ($141) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $142
      $1=1;
      __label__ = 29; break;
    case 23: // $143
      var $144=$wc;
      var $145=$144 >>> 18;
      var $146=240 | $145;
      var $147=(($146) & 255);
      var $148=$7;
      var $149=HEAP32[(($148)>>2)];
      var $150=(($149+1)|0);
      HEAP32[(($148)>>2)]=$150;
      HEAP8[($149)]=$147;
      var $151=$wc;
      var $152=$151 & 258048;
      var $153=$152 >>> 12;
      var $154=128 | $153;
      var $155=(($154) & 255);
      var $156=$7;
      var $157=HEAP32[(($156)>>2)];
      var $158=(($157+1)|0);
      HEAP32[(($156)>>2)]=$158;
      HEAP8[($157)]=$155;
      var $159=$wc;
      var $160=$159 & 4032;
      var $161=$160 >>> 6;
      var $162=128 | $161;
      var $163=(($162) & 255);
      var $164=$7;
      var $165=HEAP32[(($164)>>2)];
      var $166=(($165+1)|0);
      HEAP32[(($164)>>2)]=$166;
      HEAP8[($165)]=$163;
      var $167=$wc;
      var $168=$167 & 63;
      var $169=128 | $168;
      var $170=(($169) & 255);
      var $171=$7;
      var $172=HEAP32[(($171)>>2)];
      var $173=(($172+1)|0);
      HEAP32[(($171)>>2)]=$173;
      HEAP8[($172)]=$170;
      __label__ = 24; break;
    case 24: // $174
      __label__ = 25; break;
    case 25: // $175
      __label__ = 26; break;
    case 26: // $176
      __label__ = 27; break;
    case 27: // $177
      var $178=$4;
      var $179=HEAP32[(($178)>>2)];
      var $180=(($179+4)|0);
      HEAP32[(($178)>>2)]=$180;
      __label__ = 5; break;
    case 28: // $181
      $1=0;
      __label__ = 29; break;
    case 29: // $182
      var $183=$1;
      ;
      return $183;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE["X"]=1;

function __ZNSt3__17codecvtIjc10_mbstate_tED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__17codecvtIjc10_mbstate_tED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__17codecvtIjc10_mbstate_tE6do_outERS1_PKjS5_RS5_PcS7_RS7_($this, $0, $frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $_frm;
  var $_frm_end;
  var $_frm_nxt=__stackBase__;
  var $_to;
  var $_to_end;
  var $_to_nxt=__stackBase__+4;
  var $r;
  $2=$this;
  $3=$0;
  $4=$frm;
  $5=$frm_end;
  $6=$frm_nxt;
  $7=$to;
  $8=$to_end;
  $9=$to_nxt;
  var $10=$2;
  var $11=$4;
  $_frm=$11;
  var $12=$5;
  $_frm_end=$12;
  var $13=$_frm;
  HEAP32[(($_frm_nxt)>>2)]=$13;
  var $14=$7;
  $_to=$14;
  var $15=$8;
  $_to_end=$15;
  var $16=$_to;
  HEAP32[(($_to_nxt)>>2)]=$16;
  var $17=$_frm;
  var $18=$_frm_end;
  var $19=$_to;
  var $20=$_to_end;
  var $21=__ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE($17, $18, $_frm_nxt, $19, $20, $_to_nxt, 1114111, 0);
  $r=$21;
  var $22=$4;
  var $23=HEAP32[(($_frm_nxt)>>2)];
  var $24=$_frm;
  var $25=$23;
  var $26=$24;
  var $27=(($25-$26)|0);
  var $28=(((($27)|0)/4)|0);
  var $29=(($22+($28<<2))|0);
  var $30=$6;
  HEAP32[(($30)>>2)]=$29;
  var $31=$7;
  var $32=HEAP32[(($_to_nxt)>>2)];
  var $33=$_to;
  var $34=$32;
  var $35=$33;
  var $36=(($34-$35)|0);
  var $37=(($31+$36)|0);
  var $38=$9;
  HEAP32[(($38)>>2)]=$37;
  var $39=$r;
  STACKTOP = __stackBase__;
  return $39;
}
__ZNKSt3__17codecvtIjc10_mbstate_tE6do_outERS1_PKjS5_RS5_PcS7_RS7_["X"]=1;

function __ZNKSt3__17codecvtIjc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_($this, $0, $to, $1, $to_nxt) {
  ;
  var __label__;

  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  $3=$this;
  $4=$0;
  $5=$to;
  $6=$1;
  $7=$to_nxt;
  var $8=$3;
  var $9=$5;
  var $10=$7;
  HEAP32[(($10)>>2)]=$9;
  ;
  return 3;
}


function __ZNKSt3__17codecvtIjc10_mbstate_tE11do_encodingEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNKSt3__17codecvtIjc10_mbstate_tE16do_always_noconvEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 0;
}


function __ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE($frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt, $Maxcode, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $7;
      var $8;
      var $9;
      var $c1;
      var $c2;
      var $t;
      var $c21;
      var $c3;
      var $t2;
      var $c23;
      var $c34;
      var $c4;
      var $t5;
      $2=$frm;
      $3=$frm_end;
      $4=$frm_nxt;
      $5=$to;
      $6=$to_end;
      $7=$to_nxt;
      $8=$Maxcode;
      $9=$mode;
      var $10=$2;
      var $11=$4;
      HEAP32[(($11)>>2)]=$10;
      var $12=$5;
      var $13=$7;
      HEAP32[(($13)>>2)]=$12;
      var $14=$9;
      var $15=$14 & 4;
      var $16=(($15)|0)!=0;
      if ($16) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $17
      var $18=$3;
      var $19=$4;
      var $20=HEAP32[(($19)>>2)];
      var $21=$18;
      var $22=$20;
      var $23=(($21-$22)|0);
      var $24=(($23)|0) >= 3;
      if ($24) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $25
      var $26=$4;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0);
      var $29=HEAPU8[($28)];
      var $30=(($29)&255);
      var $31=(($30)|0)==239;
      if ($31) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $32
      var $33=$4;
      var $34=HEAP32[(($33)>>2)];
      var $35=(($34+1)|0);
      var $36=HEAPU8[($35)];
      var $37=(($36)&255);
      var $38=(($37)|0)==187;
      if ($38) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $39
      var $40=$4;
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+2)|0);
      var $43=HEAPU8[($42)];
      var $44=(($43)&255);
      var $45=(($44)|0)==191;
      if ($45) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $46
      var $47=$4;
      var $48=HEAP32[(($47)>>2)];
      var $49=(($48+3)|0);
      HEAP32[(($47)>>2)]=$49;
      __label__ = 6; break;
    case 6: // $50
      __label__ = 7; break;
    case 7: // $51
      __label__ = 8; break;
    case 8: // $52
      var $53=$4;
      var $54=HEAPU32[(($53)>>2)];
      var $55=$3;
      var $56=(($54)>>>0) < (($55)>>>0);
      if ($56) { __label__ = 9; break; } else { var $63 = 0;__label__ = 10; break; }
    case 9: // $57
      var $58=$7;
      var $59=HEAPU32[(($58)>>2)];
      var $60=$6;
      var $61=(($59)>>>0) < (($60)>>>0);
      var $63 = $61;__label__ = 10; break;
    case 10: // $62
      var $63;
      if ($63) { __label__ = 11; break; } else { __label__ = 70; break; }
    case 11: // $64
      var $65=$4;
      var $66=HEAP32[(($65)>>2)];
      var $67=HEAP8[($66)];
      $c1=$67;
      var $68=$c1;
      var $69=(($68)&255);
      var $70=(($69)|0) < 128;
      if ($70) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $71
      var $72=$c1;
      var $73=(($72)&255);
      var $74=$8;
      var $75=(($73)>>>0) > (($74)>>>0);
      if ($75) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $76
      $1=2;
      __label__ = 71; break;
    case 14: // $77
      var $78=$c1;
      var $79=(($78)&255);
      var $80=$7;
      var $81=HEAP32[(($80)>>2)];
      HEAP32[(($81)>>2)]=$79;
      var $82=$4;
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+1)|0);
      HEAP32[(($82)>>2)]=$84;
      __label__ = 68; break;
    case 15: // $85
      var $86=$c1;
      var $87=(($86)&255);
      var $88=(($87)|0) < 194;
      if ($88) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $89
      $1=2;
      __label__ = 71; break;
    case 17: // $90
      var $91=$c1;
      var $92=(($91)&255);
      var $93=(($92)|0) < 224;
      if ($93) { __label__ = 18; break; } else { __label__ = 25; break; }
    case 18: // $94
      var $95=$3;
      var $96=$4;
      var $97=HEAP32[(($96)>>2)];
      var $98=$95;
      var $99=$97;
      var $100=(($98-$99)|0);
      var $101=(($100)|0) < 2;
      if ($101) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $102
      $1=1;
      __label__ = 71; break;
    case 20: // $103
      var $104=$4;
      var $105=HEAP32[(($104)>>2)];
      var $106=(($105+1)|0);
      var $107=HEAP8[($106)];
      $c2=$107;
      var $108=$c2;
      var $109=(($108)&255);
      var $110=$109 & 192;
      var $111=(($110)|0)!=128;
      if ($111) { __label__ = 21; break; } else { __label__ = 22; break; }
    case 21: // $112
      $1=2;
      __label__ = 71; break;
    case 22: // $113
      var $114=$c1;
      var $115=(($114)&255);
      var $116=$115 & 31;
      var $117=$116 << 6;
      var $118=$c2;
      var $119=(($118)&255);
      var $120=$119 & 63;
      var $121=$117 | $120;
      $t=$121;
      var $122=$t;
      var $123=$8;
      var $124=(($122)>>>0) > (($123)>>>0);
      if ($124) { __label__ = 23; break; } else { __label__ = 24; break; }
    case 23: // $125
      $1=2;
      __label__ = 71; break;
    case 24: // $126
      var $127=$t;
      var $128=$7;
      var $129=HEAP32[(($128)>>2)];
      HEAP32[(($129)>>2)]=$127;
      var $130=$4;
      var $131=HEAP32[(($130)>>2)];
      var $132=(($131+2)|0);
      HEAP32[(($130)>>2)]=$132;
      __label__ = 66; break;
    case 25: // $133
      var $134=$c1;
      var $135=(($134)&255);
      var $136=(($135)|0) < 240;
      if ($136) { __label__ = 26; break; } else { __label__ = 43; break; }
    case 26: // $137
      var $138=$3;
      var $139=$4;
      var $140=HEAP32[(($139)>>2)];
      var $141=$138;
      var $142=$140;
      var $143=(($141-$142)|0);
      var $144=(($143)|0) < 3;
      if ($144) { __label__ = 27; break; } else { __label__ = 28; break; }
    case 27: // $145
      $1=1;
      __label__ = 71; break;
    case 28: // $146
      var $147=$4;
      var $148=HEAP32[(($147)>>2)];
      var $149=(($148+1)|0);
      var $150=HEAP8[($149)];
      $c21=$150;
      var $151=$4;
      var $152=HEAP32[(($151)>>2)];
      var $153=(($152+2)|0);
      var $154=HEAP8[($153)];
      $c3=$154;
      var $155=$c1;
      var $156=(($155)&255);
      if ($156 == 224) {
        __label__ = 29; break;
      }
      else if ($156 == 237) {
        __label__ = 32; break;
      }
      else {
      __label__ = 35; break;
      }
      
    case 29: // $157
      var $158=$c21;
      var $159=(($158)&255);
      var $160=$159 & 224;
      var $161=(($160)|0)!=160;
      if ($161) { __label__ = 30; break; } else { __label__ = 31; break; }
    case 30: // $162
      $1=2;
      __label__ = 71; break;
    case 31: // $163
      __label__ = 38; break;
    case 32: // $164
      var $165=$c21;
      var $166=(($165)&255);
      var $167=$166 & 224;
      var $168=(($167)|0)!=128;
      if ($168) { __label__ = 33; break; } else { __label__ = 34; break; }
    case 33: // $169
      $1=2;
      __label__ = 71; break;
    case 34: // $170
      __label__ = 38; break;
    case 35: // $171
      var $172=$c21;
      var $173=(($172)&255);
      var $174=$173 & 192;
      var $175=(($174)|0)!=128;
      if ($175) { __label__ = 36; break; } else { __label__ = 37; break; }
    case 36: // $176
      $1=2;
      __label__ = 71; break;
    case 37: // $177
      __label__ = 38; break;
    case 38: // $178
      var $179=$c3;
      var $180=(($179)&255);
      var $181=$180 & 192;
      var $182=(($181)|0)!=128;
      if ($182) { __label__ = 39; break; } else { __label__ = 40; break; }
    case 39: // $183
      $1=2;
      __label__ = 71; break;
    case 40: // $184
      var $185=$c1;
      var $186=(($185)&255);
      var $187=$186 & 15;
      var $188=$187 << 12;
      var $189=$c21;
      var $190=(($189)&255);
      var $191=$190 & 63;
      var $192=$191 << 6;
      var $193=$188 | $192;
      var $194=$c3;
      var $195=(($194)&255);
      var $196=$195 & 63;
      var $197=$193 | $196;
      $t2=$197;
      var $198=$t2;
      var $199=$8;
      var $200=(($198)>>>0) > (($199)>>>0);
      if ($200) { __label__ = 41; break; } else { __label__ = 42; break; }
    case 41: // $201
      $1=2;
      __label__ = 71; break;
    case 42: // $202
      var $203=$t2;
      var $204=$7;
      var $205=HEAP32[(($204)>>2)];
      HEAP32[(($205)>>2)]=$203;
      var $206=$4;
      var $207=HEAP32[(($206)>>2)];
      var $208=(($207+3)|0);
      HEAP32[(($206)>>2)]=$208;
      __label__ = 65; break;
    case 43: // $209
      var $210=$c1;
      var $211=(($210)&255);
      var $212=(($211)|0) < 245;
      if ($212) { __label__ = 44; break; } else { __label__ = 63; break; }
    case 44: // $213
      var $214=$3;
      var $215=$4;
      var $216=HEAP32[(($215)>>2)];
      var $217=$214;
      var $218=$216;
      var $219=(($217-$218)|0);
      var $220=(($219)|0) < 4;
      if ($220) { __label__ = 45; break; } else { __label__ = 46; break; }
    case 45: // $221
      $1=1;
      __label__ = 71; break;
    case 46: // $222
      var $223=$4;
      var $224=HEAP32[(($223)>>2)];
      var $225=(($224+1)|0);
      var $226=HEAP8[($225)];
      $c23=$226;
      var $227=$4;
      var $228=HEAP32[(($227)>>2)];
      var $229=(($228+2)|0);
      var $230=HEAP8[($229)];
      $c34=$230;
      var $231=$4;
      var $232=HEAP32[(($231)>>2)];
      var $233=(($232+3)|0);
      var $234=HEAP8[($233)];
      $c4=$234;
      var $235=$c1;
      var $236=(($235)&255);
      if ($236 == 240) {
        __label__ = 47; break;
      }
      else if ($236 == 244) {
        __label__ = 51; break;
      }
      else {
      __label__ = 54; break;
      }
      
    case 47: // $237
      var $238=$c23;
      var $239=(($238)&255);
      var $240=144 <= (($239)|0);
      if ($240) { __label__ = 48; break; } else { __label__ = 49; break; }
    case 48: // $241
      var $242=$c23;
      var $243=(($242)&255);
      var $244=(($243)|0) <= 191;
      if ($244) { __label__ = 50; break; } else { __label__ = 49; break; }
    case 49: // $245
      $1=2;
      __label__ = 71; break;
    case 50: // $246
      __label__ = 57; break;
    case 51: // $247
      var $248=$c23;
      var $249=(($248)&255);
      var $250=$249 & 240;
      var $251=(($250)|0)!=128;
      if ($251) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $252
      $1=2;
      __label__ = 71; break;
    case 53: // $253
      __label__ = 57; break;
    case 54: // $254
      var $255=$c23;
      var $256=(($255)&255);
      var $257=$256 & 192;
      var $258=(($257)|0)!=128;
      if ($258) { __label__ = 55; break; } else { __label__ = 56; break; }
    case 55: // $259
      $1=2;
      __label__ = 71; break;
    case 56: // $260
      __label__ = 57; break;
    case 57: // $261
      var $262=$c34;
      var $263=(($262)&255);
      var $264=$263 & 192;
      var $265=(($264)|0)!=128;
      if ($265) { __label__ = 59; break; } else { __label__ = 58; break; }
    case 58: // $266
      var $267=$c4;
      var $268=(($267)&255);
      var $269=$268 & 192;
      var $270=(($269)|0)!=128;
      if ($270) { __label__ = 59; break; } else { __label__ = 60; break; }
    case 59: // $271
      $1=2;
      __label__ = 71; break;
    case 60: // $272
      var $273=$c1;
      var $274=(($273)&255);
      var $275=$274 & 7;
      var $276=$275 << 18;
      var $277=$c23;
      var $278=(($277)&255);
      var $279=$278 & 63;
      var $280=$279 << 12;
      var $281=$276 | $280;
      var $282=$c34;
      var $283=(($282)&255);
      var $284=$283 & 63;
      var $285=$284 << 6;
      var $286=$281 | $285;
      var $287=$c4;
      var $288=(($287)&255);
      var $289=$288 & 63;
      var $290=$286 | $289;
      $t5=$290;
      var $291=$t5;
      var $292=$8;
      var $293=(($291)>>>0) > (($292)>>>0);
      if ($293) { __label__ = 61; break; } else { __label__ = 62; break; }
    case 61: // $294
      $1=2;
      __label__ = 71; break;
    case 62: // $295
      var $296=$t5;
      var $297=$7;
      var $298=HEAP32[(($297)>>2)];
      HEAP32[(($298)>>2)]=$296;
      var $299=$4;
      var $300=HEAP32[(($299)>>2)];
      var $301=(($300+4)|0);
      HEAP32[(($299)>>2)]=$301;
      __label__ = 64; break;
    case 63: // $302
      $1=2;
      __label__ = 71; break;
    case 64: // $303
      __label__ = 65; break;
    case 65: // $304
      __label__ = 66; break;
    case 66: // $305
      __label__ = 67; break;
    case 67: // $306
      __label__ = 68; break;
    case 68: // $307
      __label__ = 69; break;
    case 69: // $308
      var $309=$7;
      var $310=HEAP32[(($309)>>2)];
      var $311=(($310+4)|0);
      HEAP32[(($309)>>2)]=$311;
      __label__ = 8; break;
    case 70: // $312
      var $313=$4;
      var $314=HEAPU32[(($313)>>2)];
      var $315=$3;
      var $316=(($314)>>>0) < (($315)>>>0);
      var $317=$316 ? 1 : 0;
      $1=$317;
      __label__ = 71; break;
    case 71: // $318
      var $319=$1;
      ;
      return $319;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE["X"]=1;

function __ZNKSt3__17codecvtIjc10_mbstate_tE5do_inERS1_PKcS5_RS5_PjS7_RS7_($this, $0, $frm, $frm_end, $frm_nxt, $to, $to_end, $to_nxt) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $7;
  var $8;
  var $9;
  var $_frm;
  var $_frm_end;
  var $_frm_nxt=__stackBase__;
  var $_to;
  var $_to_end;
  var $_to_nxt=__stackBase__+4;
  var $r;
  $2=$this;
  $3=$0;
  $4=$frm;
  $5=$frm_end;
  $6=$frm_nxt;
  $7=$to;
  $8=$to_end;
  $9=$to_nxt;
  var $10=$2;
  var $11=$4;
  $_frm=$11;
  var $12=$5;
  $_frm_end=$12;
  var $13=$_frm;
  HEAP32[(($_frm_nxt)>>2)]=$13;
  var $14=$7;
  $_to=$14;
  var $15=$8;
  $_to_end=$15;
  var $16=$_to;
  HEAP32[(($_to_nxt)>>2)]=$16;
  var $17=$_frm;
  var $18=$_frm_end;
  var $19=$_to;
  var $20=$_to_end;
  var $21=__ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE($17, $18, $_frm_nxt, $19, $20, $_to_nxt, 1114111, 0);
  $r=$21;
  var $22=$4;
  var $23=HEAP32[(($_frm_nxt)>>2)];
  var $24=$_frm;
  var $25=$23;
  var $26=$24;
  var $27=(($25-$26)|0);
  var $28=(($22+$27)|0);
  var $29=$6;
  HEAP32[(($29)>>2)]=$28;
  var $30=$7;
  var $31=HEAP32[(($_to_nxt)>>2)];
  var $32=$_to;
  var $33=$31;
  var $34=$32;
  var $35=(($33-$34)|0);
  var $36=(((($35)|0)/4)|0);
  var $37=(($30+($36<<2))|0);
  var $38=$9;
  HEAP32[(($38)>>2)]=$37;
  var $39=$r;
  STACKTOP = __stackBase__;
  return $39;
}
__ZNKSt3__17codecvtIjc10_mbstate_tE5do_inERS1_PKcS5_RS5_PjS7_RS7_["X"]=1;

function __ZNKSt3__17codecvtIjc10_mbstate_tE9do_lengthERS1_PKcS5_j($this, $0, $frm, $frm_end, $mx) {
  ;
  var __label__;

  var $2;
  var $3;
  var $4;
  var $5;
  var $6;
  var $_frm;
  var $_frm_end;
  $2=$this;
  $3=$0;
  $4=$frm;
  $5=$frm_end;
  $6=$mx;
  var $7=$2;
  var $8=$4;
  $_frm=$8;
  var $9=$5;
  $_frm_end=$9;
  var $10=$_frm;
  var $11=$_frm_end;
  var $12=$6;
  var $13=__ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE($10, $11, $12, 1114111, 0);
  ;
  return $13;
}


function __ZNKSt3__17codecvtIjc10_mbstate_tE13do_max_lengthEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return 4;
}


function __ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE($frm, $frm_end, $mx, $Maxcode, $mode) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $6;
      var $frm_nxt;
      var $nchar32_t;
      var $c1;
      var $c2;
      var $c3;
      var $c21;
      var $c32;
      var $c4;
      var $t;
      $2=$frm;
      $3=$frm_end;
      $4=$mx;
      $5=$Maxcode;
      $6=$mode;
      var $7=$2;
      $frm_nxt=$7;
      var $8=$6;
      var $9=$8 & 4;
      var $10=(($9)|0)!=0;
      if ($10) { __label__ = 1; break; } else { __label__ = 7; break; }
    case 1: // $11
      var $12=$3;
      var $13=$frm_nxt;
      var $14=$12;
      var $15=$13;
      var $16=(($14-$15)|0);
      var $17=(($16)|0) >= 3;
      if ($17) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $18
      var $19=$frm_nxt;
      var $20=(($19)|0);
      var $21=HEAPU8[($20)];
      var $22=(($21)&255);
      var $23=(($22)|0)==239;
      if ($23) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $24
      var $25=$frm_nxt;
      var $26=(($25+1)|0);
      var $27=HEAPU8[($26)];
      var $28=(($27)&255);
      var $29=(($28)|0)==187;
      if ($29) { __label__ = 4; break; } else { __label__ = 6; break; }
    case 4: // $30
      var $31=$frm_nxt;
      var $32=(($31+2)|0);
      var $33=HEAPU8[($32)];
      var $34=(($33)&255);
      var $35=(($34)|0)==191;
      if ($35) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $36
      var $37=$frm_nxt;
      var $38=(($37+3)|0);
      $frm_nxt=$38;
      __label__ = 6; break;
    case 6: // $39
      __label__ = 7; break;
    case 7: // $40
      $nchar32_t=0;
      __label__ = 8; break;
    case 8: // $41
      var $42=$frm_nxt;
      var $43=$3;
      var $44=(($42)>>>0) < (($43)>>>0);
      if ($44) { __label__ = 9; break; } else { var $50 = 0;__label__ = 10; break; }
    case 9: // $45
      var $46=$nchar32_t;
      var $47=$4;
      var $48=(($46)>>>0) < (($47)>>>0);
      var $50 = $48;__label__ = 10; break;
    case 10: // $49
      var $50;
      if ($50) { __label__ = 11; break; } else { __label__ = 69; break; }
    case 11: // $51
      var $52=$frm_nxt;
      var $53=HEAP8[($52)];
      $c1=$53;
      var $54=$c1;
      var $55=(($54)&255);
      var $56=(($55)|0) < 128;
      if ($56) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $57
      var $58=$c1;
      var $59=(($58)&255);
      var $60=$5;
      var $61=(($59)>>>0) > (($60)>>>0);
      if ($61) { __label__ = 13; break; } else { __label__ = 14; break; }
    case 13: // $62
      __label__ = 69; break;
    case 14: // $63
      var $64=$frm_nxt;
      var $65=(($64+1)|0);
      $frm_nxt=$65;
      __label__ = 67; break;
    case 15: // $66
      var $67=$c1;
      var $68=(($67)&255);
      var $69=(($68)|0) < 194;
      if ($69) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $70
      __label__ = 69; break;
    case 17: // $71
      var $72=$c1;
      var $73=(($72)&255);
      var $74=(($73)|0) < 224;
      if ($74) { __label__ = 18; break; } else { __label__ = 24; break; }
    case 18: // $75
      var $76=$3;
      var $77=$frm_nxt;
      var $78=$76;
      var $79=$77;
      var $80=(($78-$79)|0);
      var $81=(($80)|0) < 2;
      if ($81) { __label__ = 20; break; } else { __label__ = 19; break; }
    case 19: // $82
      var $83=$frm_nxt;
      var $84=(($83+1)|0);
      var $85=HEAPU8[($84)];
      var $86=(($85)&255);
      var $87=$86 & 192;
      var $88=(($87)|0)!=128;
      if ($88) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $89
      __label__ = 69; break;
    case 21: // $90
      var $91=$c1;
      var $92=(($91)&255);
      var $93=$92 & 31;
      var $94=$93 << 6;
      var $95=$frm_nxt;
      var $96=(($95+1)|0);
      var $97=HEAPU8[($96)];
      var $98=(($97)&255);
      var $99=$98 & 63;
      var $100=$94 | $99;
      var $101=$5;
      var $102=(($100)>>>0) > (($101)>>>0);
      if ($102) { __label__ = 22; break; } else { __label__ = 23; break; }
    case 22: // $103
      __label__ = 69; break;
    case 23: // $104
      var $105=$frm_nxt;
      var $106=(($105+2)|0);
      $frm_nxt=$106;
      __label__ = 65; break;
    case 24: // $107
      var $108=$c1;
      var $109=(($108)&255);
      var $110=(($109)|0) < 240;
      if ($110) { __label__ = 25; break; } else { __label__ = 42; break; }
    case 25: // $111
      var $112=$3;
      var $113=$frm_nxt;
      var $114=$112;
      var $115=$113;
      var $116=(($114-$115)|0);
      var $117=(($116)|0) < 3;
      if ($117) { __label__ = 26; break; } else { __label__ = 27; break; }
    case 26: // $118
      __label__ = 69; break;
    case 27: // $119
      var $120=$frm_nxt;
      var $121=(($120+1)|0);
      var $122=HEAP8[($121)];
      $c2=$122;
      var $123=$frm_nxt;
      var $124=(($123+2)|0);
      var $125=HEAP8[($124)];
      $c3=$125;
      var $126=$c1;
      var $127=(($126)&255);
      if ($127 == 224) {
        __label__ = 28; break;
      }
      else if ($127 == 237) {
        __label__ = 31; break;
      }
      else {
      __label__ = 34; break;
      }
      
    case 28: // $128
      var $129=$c2;
      var $130=(($129)&255);
      var $131=$130 & 224;
      var $132=(($131)|0)!=160;
      if ($132) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $133
      var $134=$frm_nxt;
      var $135=$2;
      var $136=$134;
      var $137=$135;
      var $138=(($136-$137)|0);
      $1=$138;
      __label__ = 70; break;
    case 30: // $139
      __label__ = 37; break;
    case 31: // $140
      var $141=$c2;
      var $142=(($141)&255);
      var $143=$142 & 224;
      var $144=(($143)|0)!=128;
      if ($144) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $145
      var $146=$frm_nxt;
      var $147=$2;
      var $148=$146;
      var $149=$147;
      var $150=(($148-$149)|0);
      $1=$150;
      __label__ = 70; break;
    case 33: // $151
      __label__ = 37; break;
    case 34: // $152
      var $153=$c2;
      var $154=(($153)&255);
      var $155=$154 & 192;
      var $156=(($155)|0)!=128;
      if ($156) { __label__ = 35; break; } else { __label__ = 36; break; }
    case 35: // $157
      var $158=$frm_nxt;
      var $159=$2;
      var $160=$158;
      var $161=$159;
      var $162=(($160-$161)|0);
      $1=$162;
      __label__ = 70; break;
    case 36: // $163
      __label__ = 37; break;
    case 37: // $164
      var $165=$c3;
      var $166=(($165)&255);
      var $167=$166 & 192;
      var $168=(($167)|0)!=128;
      if ($168) { __label__ = 38; break; } else { __label__ = 39; break; }
    case 38: // $169
      __label__ = 69; break;
    case 39: // $170
      var $171=$c1;
      var $172=(($171)&255);
      var $173=$172 & 15;
      var $174=$173 << 12;
      var $175=$c2;
      var $176=(($175)&255);
      var $177=$176 & 63;
      var $178=$177 << 6;
      var $179=$174 | $178;
      var $180=$c3;
      var $181=(($180)&255);
      var $182=$181 & 63;
      var $183=$179 | $182;
      var $184=$5;
      var $185=(($183)>>>0) > (($184)>>>0);
      if ($185) { __label__ = 40; break; } else { __label__ = 41; break; }
    case 40: // $186
      __label__ = 69; break;
    case 41: // $187
      var $188=$frm_nxt;
      var $189=(($188+3)|0);
      $frm_nxt=$189;
      __label__ = 64; break;
    case 42: // $190
      var $191=$c1;
      var $192=(($191)&255);
      var $193=(($192)|0) < 245;
      if ($193) { __label__ = 43; break; } else { __label__ = 62; break; }
    case 43: // $194
      var $195=$3;
      var $196=$frm_nxt;
      var $197=$195;
      var $198=$196;
      var $199=(($197-$198)|0);
      var $200=(($199)|0) < 4;
      if ($200) { __label__ = 44; break; } else { __label__ = 45; break; }
    case 44: // $201
      __label__ = 69; break;
    case 45: // $202
      var $203=$frm_nxt;
      var $204=(($203+1)|0);
      var $205=HEAP8[($204)];
      $c21=$205;
      var $206=$frm_nxt;
      var $207=(($206+2)|0);
      var $208=HEAP8[($207)];
      $c32=$208;
      var $209=$frm_nxt;
      var $210=(($209+3)|0);
      var $211=HEAP8[($210)];
      $c4=$211;
      var $212=$c1;
      var $213=(($212)&255);
      if ($213 == 240) {
        __label__ = 46; break;
      }
      else if ($213 == 244) {
        __label__ = 50; break;
      }
      else {
      __label__ = 53; break;
      }
      
    case 46: // $214
      var $215=$c21;
      var $216=(($215)&255);
      var $217=144 <= (($216)|0);
      if ($217) { __label__ = 47; break; } else { __label__ = 48; break; }
    case 47: // $218
      var $219=$c21;
      var $220=(($219)&255);
      var $221=(($220)|0) <= 191;
      if ($221) { __label__ = 49; break; } else { __label__ = 48; break; }
    case 48: // $222
      var $223=$frm_nxt;
      var $224=$2;
      var $225=$223;
      var $226=$224;
      var $227=(($225-$226)|0);
      $1=$227;
      __label__ = 70; break;
    case 49: // $228
      __label__ = 56; break;
    case 50: // $229
      var $230=$c21;
      var $231=(($230)&255);
      var $232=$231 & 240;
      var $233=(($232)|0)!=128;
      if ($233) { __label__ = 51; break; } else { __label__ = 52; break; }
    case 51: // $234
      var $235=$frm_nxt;
      var $236=$2;
      var $237=$235;
      var $238=$236;
      var $239=(($237-$238)|0);
      $1=$239;
      __label__ = 70; break;
    case 52: // $240
      __label__ = 56; break;
    case 53: // $241
      var $242=$c21;
      var $243=(($242)&255);
      var $244=$243 & 192;
      var $245=(($244)|0)!=128;
      if ($245) { __label__ = 54; break; } else { __label__ = 55; break; }
    case 54: // $246
      var $247=$frm_nxt;
      var $248=$2;
      var $249=$247;
      var $250=$248;
      var $251=(($249-$250)|0);
      $1=$251;
      __label__ = 70; break;
    case 55: // $252
      __label__ = 56; break;
    case 56: // $253
      var $254=$c32;
      var $255=(($254)&255);
      var $256=$255 & 192;
      var $257=(($256)|0)!=128;
      if ($257) { __label__ = 58; break; } else { __label__ = 57; break; }
    case 57: // $258
      var $259=$c4;
      var $260=(($259)&255);
      var $261=$260 & 192;
      var $262=(($261)|0)!=128;
      if ($262) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $263
      __label__ = 69; break;
    case 59: // $264
      var $265=$c1;
      var $266=(($265)&255);
      var $267=$266 & 7;
      var $268=$267 << 18;
      var $269=$c21;
      var $270=(($269)&255);
      var $271=$270 & 63;
      var $272=$271 << 12;
      var $273=$268 | $272;
      var $274=$c32;
      var $275=(($274)&255);
      var $276=$275 & 63;
      var $277=$276 << 6;
      var $278=$273 | $277;
      var $279=$c4;
      var $280=(($279)&255);
      var $281=$280 & 63;
      var $282=$278 | $281;
      $t=$282;
      var $283=$c1;
      var $284=(($283)&255);
      var $285=$284 & 7;
      var $286=$285 << 18;
      var $287=$c21;
      var $288=(($287)&255);
      var $289=$288 & 63;
      var $290=$289 << 12;
      var $291=$286 | $290;
      var $292=$c32;
      var $293=(($292)&255);
      var $294=$293 & 63;
      var $295=$294 << 6;
      var $296=$291 | $295;
      var $297=$c4;
      var $298=(($297)&255);
      var $299=$298 & 63;
      var $300=$296 | $299;
      var $301=$5;
      var $302=(($300)>>>0) > (($301)>>>0);
      if ($302) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $303
      __label__ = 69; break;
    case 61: // $304
      var $305=$frm_nxt;
      var $306=(($305+4)|0);
      $frm_nxt=$306;
      __label__ = 63; break;
    case 62: // $307
      __label__ = 69; break;
    case 63: // $308
      __label__ = 64; break;
    case 64: // $309
      __label__ = 65; break;
    case 65: // $310
      __label__ = 66; break;
    case 66: // $311
      __label__ = 67; break;
    case 67: // $312
      __label__ = 68; break;
    case 68: // $313
      var $314=$nchar32_t;
      var $315=(($314+1)|0);
      $nchar32_t=$315;
      __label__ = 8; break;
    case 69: // $316
      var $317=$frm_nxt;
      var $318=$2;
      var $319=$317;
      var $320=$318;
      var $321=(($319-$320)|0);
      $1=$321;
      __label__ = 70; break;
    case 70: // $322
      var $323=$1;
      ;
      return $323;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE["X"]=1;

function ___cxx_global_var_init50() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__18numpunctIcE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function ___cxx_global_var_init51() {
  var __stackBase__  = STACKTOP; STACKTOP += 16; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=$4;
  HEAP32[(($4)>>2)]=__ZNSt3__18numpunctIwE2idE;
  var $6=HEAP32[(($4)>>2)];
  var $7=$3;
  HEAP32[(($3)>>2)]=$6;
  var $8=HEAP32[(($3)>>2)];
  var $9=(($8)|0);
  var $10=$2;
  HEAP32[(($2)>>2)]=$9;
  var $11=HEAP32[(($2)>>2)];
  var $12=$1;
  HEAP32[(($1)>>2)]=$11;
  var $13=HEAP32[(($1)>>2)];
  var $14=$1;
  var $15=$2;
  var $16=$3;
  var $17=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__116__narrow_to_utf8ILj32EED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__116__narrow_to_utf8ILj32EED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__117__widen_from_utf8ILj32EED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__117__widen_from_utf8ILj32EED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18numpunctIcEC2Ej($this, $refs) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14;
      var $15;
      var $16;
      var $17;
      $14=$this;
      $15=$refs;
      var $18=$14;
      var $19=$18;
      var $20=$15;
      var $21=$12;
      var $22=$13;
      HEAP32[(($12)>>2)]=$19;
      HEAP32[(($13)>>2)]=$20;
      var $23=HEAP32[(($12)>>2)];
      var $24=$23;
      var $25=HEAP32[(($13)>>2)];
      var $26=(($25-1)|0);
      var $27=$10;
      var $28=$11;
      HEAP32[(($10)>>2)]=$24;
      HEAP32[(($11)>>2)]=$26;
      var $29=HEAP32[(($10)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($11)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$10;
      var $34=$11;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$12;
      var $37=$13;
      var $38=$18;
      HEAP32[(($38)>>2)]=((__ZTVNSt3__18numpunctIcEE+8)|0);
      var $39=(($18+8)|0);
      HEAP8[($39)]=46;
      var $40=(($18+9)|0);
      HEAP8[($40)]=44;
      var $41=(($18+12)|0);
      var $42=$9;
      HEAP32[(($9)>>2)]=$41;
      var $43=HEAP32[(($9)>>2)];
      var $44=$8;
      HEAP32[(($8)>>2)]=$43;
      var $45=HEAP32[(($8)>>2)];
      var $46=$45;
      var $47=(($45)|0);
      var $48=$7;
      HEAP32[(($7)>>2)]=$47;
      var $49=HEAP32[(($7)>>2)];
      var $50=$6;
      HEAP32[(($6)>>2)]=$49;
      var $51=HEAP32[(($6)>>2)];
      var $52=$51;
      var $53=$5;
      HEAP32[(($5)>>2)]=$52;
      var $54=HEAP32[(($5)>>2)];
      var $55=$54;
      var $56=$4;
      HEAP32[(($4)>>2)]=$55;
      var $57=HEAP32[(($4)>>2)];
      var $58=$4;
      var $59=(($54)|0);
      var $60=$5;
      var $61=$6;
      var $62=$7;
      var $63=$3;
      var $64=$__a_i_i_i;
      var $65=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$45;
      var $66=HEAP32[(($3)>>2)];
      var $67=(($66)|0);
      var $68=$2;
      HEAP32[(($2)>>2)]=$67;
      var $69=HEAP32[(($2)>>2)];
      var $70=$69;
      var $71=$1;
      HEAP32[(($1)>>2)]=$70;
      var $72=HEAP32[(($1)>>2)];
      var $73=(($72)|0);
      var $74=$1;
      var $75=$2;
      var $76=(($73)|0);
      var $77=$76;
      var $78=(($77)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$78;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $79
      var $80=HEAPU32[(($__i_i_i_i)>>2)];
      var $81=(($80)>>>0) < 3;
      if ($81) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $82
      var $83=HEAP32[(($__i_i_i_i)>>2)];
      var $84=HEAP32[(($__a_i_i_i)>>2)];
      var $85=(($84+($83<<2))|0);
      HEAP32[(($85)>>2)]=0;
      var $86=HEAP32[(($__i_i_i_i)>>2)];
      var $87=(($86+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$87;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $88=$3;
      var $89=$__a_i_i_i;
      var $90=$__i_i_i_i;
      var $91=$8;
      var $92=$9;
      __label__ = 4; break;
    case 4: // $93
      STACKTOP = __stackBase__;
      return;
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      $16=$96;
      var $97=$95.f1;
      $17=$97;
      var $98=$18;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $99
      __label__ = 6; break;
    case 6: // $100
      var $101=$16;
      var $102=$16;
      var $103=$17;
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__18numpunctIcEC2Ej["X"]=1;

function __ZNKSt3__18numpunctIcE16do_decimal_pointEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZNKSt3__18numpunctIwE16do_decimal_pointEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+8)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNKSt3__18numpunctIcE16do_thousands_sepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+9)|0);
  var $4=HEAP8[($3)];
  ;
  return $4;
}


function __ZNKSt3__18numpunctIwE16do_thousands_sepEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  var $4=HEAP32[(($3)>>2)];
  ;
  return $4;
}


function __ZNSt3__18numpunctIcED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__18numpunctIcED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18numpunctIwED0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__18numpunctIwED1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__18numpunctIcE11do_groupingEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+12)|0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($agg_result, $3);
  ;
  return;
}


function __ZNKSt3__18numpunctIwE11do_groupingEv($agg_result, $this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=(($2+16)|0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_($agg_result, $3);
  ;
  return;
}


function __ZNKSt3__18numpunctIcE11do_truenameEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10;
  $10=$this;
  var $11=$10;
  var $12=$8;
  var $13=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=((STRING_TABLE.__str521667)|0);
  var $14=HEAP32[(($8)>>2)];
  var $15=HEAP32[(($9)>>2)];
  var $16=$6;
  var $17=$7;
  HEAP32[(($6)>>2)]=$14;
  HEAP32[(($7)>>2)]=$15;
  var $18=HEAP32[(($6)>>2)];
  var $19=$18;
  var $20=(($18)|0);
  var $21=$5;
  HEAP32[(($5)>>2)]=$20;
  var $22=HEAP32[(($5)>>2)];
  var $23=$4;
  HEAP32[(($4)>>2)]=$22;
  var $24=HEAP32[(($4)>>2)];
  var $25=$24;
  var $26=$3;
  HEAP32[(($3)>>2)]=$25;
  var $27=HEAP32[(($3)>>2)];
  var $28=$27;
  var $29=$2;
  HEAP32[(($2)>>2)]=$28;
  var $30=HEAP32[(($2)>>2)];
  var $31=$2;
  var $32=(($27)|0);
  var $33=$3;
  var $34=$4;
  var $35=$5;
  var $36=HEAP32[(($7)>>2)];
  var $37=HEAP32[(($7)>>2)];
  var $38=$1;
  HEAP32[(($1)>>2)]=$37;
  var $39=HEAP32[(($1)>>2)];
  var $40=_strlen($39);
  var $41=$1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($18, $36, $40);
  var $42=$6;
  var $43=$7;
  var $44=$8;
  var $45=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__18numpunctIcE11do_truenameEv["X"]=1;

function __ZNKSt3__18numpunctIwE11do_truenameEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10;
  $10=$this;
  var $11=$10;
  var $12=$8;
  var $13=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=(((STRING_TABLE.__str531668))|0);
  var $14=HEAP32[(($8)>>2)];
  var $15=HEAP32[(($9)>>2)];
  var $16=$6;
  var $17=$7;
  HEAP32[(($6)>>2)]=$14;
  HEAP32[(($7)>>2)]=$15;
  var $18=HEAP32[(($6)>>2)];
  var $19=$18;
  var $20=(($18)|0);
  var $21=$5;
  HEAP32[(($5)>>2)]=$20;
  var $22=HEAP32[(($5)>>2)];
  var $23=$4;
  HEAP32[(($4)>>2)]=$22;
  var $24=HEAP32[(($4)>>2)];
  var $25=$24;
  var $26=$3;
  HEAP32[(($3)>>2)]=$25;
  var $27=HEAP32[(($3)>>2)];
  var $28=$27;
  var $29=$2;
  HEAP32[(($2)>>2)]=$28;
  var $30=HEAP32[(($2)>>2)];
  var $31=$2;
  var $32=(($27)|0);
  var $33=$3;
  var $34=$4;
  var $35=$5;
  var $36=HEAP32[(($7)>>2)];
  var $37=HEAP32[(($7)>>2)];
  var $38=$1;
  HEAP32[(($1)>>2)]=$37;
  var $39=HEAP32[(($1)>>2)];
  var $40=_wcslen($39);
  var $41=$1;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($18, $36, $40);
  var $42=$6;
  var $43=$7;
  var $44=$8;
  var $45=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__18numpunctIwE11do_truenameEv["X"]=1;

function __ZNKSt3__18numpunctIcE12do_falsenameEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10;
  $10=$this;
  var $11=$10;
  var $12=$8;
  var $13=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=((STRING_TABLE.__str54260)|0);
  var $14=HEAP32[(($8)>>2)];
  var $15=HEAP32[(($9)>>2)];
  var $16=$6;
  var $17=$7;
  HEAP32[(($6)>>2)]=$14;
  HEAP32[(($7)>>2)]=$15;
  var $18=HEAP32[(($6)>>2)];
  var $19=$18;
  var $20=(($18)|0);
  var $21=$5;
  HEAP32[(($5)>>2)]=$20;
  var $22=HEAP32[(($5)>>2)];
  var $23=$4;
  HEAP32[(($4)>>2)]=$22;
  var $24=HEAP32[(($4)>>2)];
  var $25=$24;
  var $26=$3;
  HEAP32[(($3)>>2)]=$25;
  var $27=HEAP32[(($3)>>2)];
  var $28=$27;
  var $29=$2;
  HEAP32[(($2)>>2)]=$28;
  var $30=HEAP32[(($2)>>2)];
  var $31=$2;
  var $32=(($27)|0);
  var $33=$3;
  var $34=$4;
  var $35=$5;
  var $36=HEAP32[(($7)>>2)];
  var $37=HEAP32[(($7)>>2)];
  var $38=$1;
  HEAP32[(($1)>>2)]=$37;
  var $39=HEAP32[(($1)>>2)];
  var $40=_strlen($39);
  var $41=$1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($18, $36, $40);
  var $42=$6;
  var $43=$7;
  var $44=$8;
  var $45=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__18numpunctIcE12do_falsenameEv["X"]=1;

function __ZNKSt3__18numpunctIwE12do_falsenameEv($agg_result, $this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2=__stackBase__+4;
  var $3=__stackBase__+8;
  var $4=__stackBase__+12;
  var $5=__stackBase__+16;
  var $6=__stackBase__+20;
  var $7=__stackBase__+24;
  var $8=__stackBase__+28;
  var $9=__stackBase__+32;
  var $10;
  $10=$this;
  var $11=$10;
  var $12=$8;
  var $13=$9;
  HEAP32[(($8)>>2)]=$agg_result;
  HEAP32[(($9)>>2)]=(((STRING_TABLE.__str551669))|0);
  var $14=HEAP32[(($8)>>2)];
  var $15=HEAP32[(($9)>>2)];
  var $16=$6;
  var $17=$7;
  HEAP32[(($6)>>2)]=$14;
  HEAP32[(($7)>>2)]=$15;
  var $18=HEAP32[(($6)>>2)];
  var $19=$18;
  var $20=(($18)|0);
  var $21=$5;
  HEAP32[(($5)>>2)]=$20;
  var $22=HEAP32[(($5)>>2)];
  var $23=$4;
  HEAP32[(($4)>>2)]=$22;
  var $24=HEAP32[(($4)>>2)];
  var $25=$24;
  var $26=$3;
  HEAP32[(($3)>>2)]=$25;
  var $27=HEAP32[(($3)>>2)];
  var $28=$27;
  var $29=$2;
  HEAP32[(($2)>>2)]=$28;
  var $30=HEAP32[(($2)>>2)];
  var $31=$2;
  var $32=(($27)|0);
  var $33=$3;
  var $34=$4;
  var $35=$5;
  var $36=HEAP32[(($7)>>2)];
  var $37=HEAP32[(($7)>>2)];
  var $38=$1;
  HEAP32[(($1)>>2)]=$37;
  var $39=HEAP32[(($1)>>2)];
  var $40=_wcslen($39);
  var $41=$1;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($18, $36, $40);
  var $42=$6;
  var $43=$7;
  var $44=$8;
  var $45=$9;
  STACKTOP = __stackBase__;
  return;
}
__ZNKSt3__18numpunctIwE12do_falsenameEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIcE7__weeksEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNSt3__1L10init_weeksEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $12
      HEAP32[((__ZZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks)>>2)]=$11;
      ;
      __label__ = 4; break;
    case 4: // $13
      var $14=HEAP32[((__ZZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks)>>2)];
      ;
      return $14;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ;
      __label__ = 6; break;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18numpunctIwEC2Ej($this, $refs) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $__a_i_i_i=__stackBase__+12;
      var $__i_i_i_i=__stackBase__+16;
      var $4=__stackBase__+20;
      var $5=__stackBase__+24;
      var $6=__stackBase__+28;
      var $7=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14;
      var $15;
      var $16;
      var $17;
      $14=$this;
      $15=$refs;
      var $18=$14;
      var $19=$18;
      var $20=$15;
      var $21=$12;
      var $22=$13;
      HEAP32[(($12)>>2)]=$19;
      HEAP32[(($13)>>2)]=$20;
      var $23=HEAP32[(($12)>>2)];
      var $24=$23;
      var $25=HEAP32[(($13)>>2)];
      var $26=(($25-1)|0);
      var $27=$10;
      var $28=$11;
      HEAP32[(($10)>>2)]=$24;
      HEAP32[(($11)>>2)]=$26;
      var $29=HEAP32[(($10)>>2)];
      var $30=$29;
      HEAP32[(($30)>>2)]=((__ZTVNSt3__114__shared_countE+8)|0);
      var $31=(($29+4)|0);
      var $32=HEAP32[(($11)>>2)];
      HEAP32[(($31)>>2)]=$32;
      var $33=$10;
      var $34=$11;
      var $35=$23;
      HEAP32[(($35)>>2)]=((__ZTVNSt3__16locale5facetE+8)|0);
      var $36=$12;
      var $37=$13;
      var $38=$18;
      HEAP32[(($38)>>2)]=((__ZTVNSt3__18numpunctIwEE+8)|0);
      var $39=(($18+8)|0);
      HEAP32[(($39)>>2)]=46;
      var $40=(($18+12)|0);
      HEAP32[(($40)>>2)]=44;
      var $41=(($18+16)|0);
      var $42=$9;
      HEAP32[(($9)>>2)]=$41;
      var $43=HEAP32[(($9)>>2)];
      var $44=$8;
      HEAP32[(($8)>>2)]=$43;
      var $45=HEAP32[(($8)>>2)];
      var $46=$45;
      var $47=(($45)|0);
      var $48=$7;
      HEAP32[(($7)>>2)]=$47;
      var $49=HEAP32[(($7)>>2)];
      var $50=$6;
      HEAP32[(($6)>>2)]=$49;
      var $51=HEAP32[(($6)>>2)];
      var $52=$51;
      var $53=$5;
      HEAP32[(($5)>>2)]=$52;
      var $54=HEAP32[(($5)>>2)];
      var $55=$54;
      var $56=$4;
      HEAP32[(($4)>>2)]=$55;
      var $57=HEAP32[(($4)>>2)];
      var $58=$4;
      var $59=(($54)|0);
      var $60=$5;
      var $61=$6;
      var $62=$7;
      var $63=$3;
      var $64=$__a_i_i_i;
      var $65=$__i_i_i_i;
      HEAP32[(($3)>>2)]=$45;
      var $66=HEAP32[(($3)>>2)];
      var $67=(($66)|0);
      var $68=$2;
      HEAP32[(($2)>>2)]=$67;
      var $69=HEAP32[(($2)>>2)];
      var $70=$69;
      var $71=$1;
      HEAP32[(($1)>>2)]=$70;
      var $72=HEAP32[(($1)>>2)];
      var $73=(($72)|0);
      var $74=$1;
      var $75=$2;
      var $76=(($73)|0);
      var $77=$76;
      var $78=(($77)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$78;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 1; break;
    case 1: // $79
      var $80=HEAPU32[(($__i_i_i_i)>>2)];
      var $81=(($80)>>>0) < 3;
      if ($81) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $82
      var $83=HEAP32[(($__i_i_i_i)>>2)];
      var $84=HEAP32[(($__a_i_i_i)>>2)];
      var $85=(($84+($83<<2))|0);
      HEAP32[(($85)>>2)]=0;
      var $86=HEAP32[(($__i_i_i_i)>>2)];
      var $87=(($86+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$87;
      __label__ = 1; break;
    case 3: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $88=$3;
      var $89=$__a_i_i_i;
      var $90=$__i_i_i_i;
      var $91=$8;
      var $92=$9;
      __label__ = 4; break;
    case 4: // $93
      STACKTOP = __stackBase__;
      return;
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $96=$95.f0;
      $16=$96;
      var $97=$95.f1;
      $17=$97;
      var $98=$18;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($98) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 5; break; } else { __label__ = 7; break; }
    case 5: // $99
      __label__ = 6; break;
    case 6: // $100
      var $101=$16;
      var $102=$16;
      var $103=$17;
      var $104=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $102, tempValue);
      var $105=($104.f1 = $103, $104);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 7: // $106
      var $107=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__18numpunctIwEC2Ej["X"]=1;

function __ZNSt3__18numpunctIcED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTVNSt3__18numpunctIcEE+8)|0);
      var $6=(($4+12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      __ZNSt3__16locale5facetD2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__18numpunctIwED2Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=$4;
      HEAP32[(($5)>>2)]=((__ZTVNSt3__18numpunctIwEE+8)|0);
      var $6=(($4+16)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($6) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $7
      var $8=$4;
      __ZNSt3__16locale5facetD2Ev($8);
      ;
      return;
    case 2: // $9
      var $10=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $11=$10.f0;
      $2=$11;
      var $12=$10.f1;
      $3=$12;
      var $13=$4;
      (function() { try { __THREW__ = false; return __ZNSt3__16locale5facetD2Ev($13) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $14
      __label__ = 4; break;
    case 4: // $15
      var $16=$2;
      var $17=$2;
      var $18=$3;
      var $19=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $17, tempValue);
      var $20=($19.f1 = $18, $19);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 5: // $21
      var $22=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__120__time_get_c_storageIwE7__weeksEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNSt3__1L11init_wweeksEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $12
      HEAP32[((__ZZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks)>>2)]=$11;
      ;
      __label__ = 4; break;
    case 4: // $13
      var $14=HEAP32[((__ZZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks)>>2)];
      ;
      return $14;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ;
      __label__ = 6; break;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__120__time_get_c_storageIcE8__monthsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNSt3__1L11init_monthsEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $12
      HEAP32[((__ZZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months)>>2)]=$11;
      ;
      __label__ = 4; break;
    case 4: // $13
      var $14=HEAP32[((__ZZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months)>>2)];
      ;
      return $14;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ;
      __label__ = 6; break;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__1L10init_weeksEv() {
  var __stackBase__  = STACKTOP; STACKTOP += 156; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $__a_i_i_i=__stackBase__+124;
      var $__i_i_i_i=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38;
      var $39;
      var $40=HEAP8[(__ZGVZNSt3__1L10init_weeksEvE5weeks)];
      var $41=(($40 << 24) >> 24)==0;
      if ($41) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $42
      var $43=___cxa_guard_acquire(__ZGVZNSt3__1L10init_weeksEvE5weeks);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $45
      var $47 = ((__ZZNSt3__1L10init_weeksEvE5weeks)|0);__label__ = 3; break;
    case 3: // $46
      var $47;
      var $48=$37;
      HEAP32[(($37)>>2)]=$47;
      var $49=HEAP32[(($37)>>2)];
      var $50=$36;
      HEAP32[(($36)>>2)]=$49;
      var $51=HEAP32[(($36)>>2)];
      var $52=$51;
      var $53=(($51)|0);
      var $54=$35;
      HEAP32[(($35)>>2)]=$53;
      var $55=HEAP32[(($35)>>2)];
      var $56=$34;
      HEAP32[(($34)>>2)]=$55;
      var $57=HEAP32[(($34)>>2)];
      var $58=$57;
      var $59=$33;
      HEAP32[(($33)>>2)]=$58;
      var $60=HEAP32[(($33)>>2)];
      var $61=$60;
      var $62=$32;
      HEAP32[(($32)>>2)]=$61;
      var $63=HEAP32[(($32)>>2)];
      var $64=$32;
      var $65=(($60)|0);
      var $66=$33;
      var $67=$34;
      var $68=$35;
      var $69=$31;
      var $70=$__a_i_i_i;
      var $71=$__i_i_i_i;
      HEAP32[(($31)>>2)]=$51;
      var $72=HEAP32[(($31)>>2)];
      var $73=(($72)|0);
      var $74=$30;
      HEAP32[(($30)>>2)]=$73;
      var $75=HEAP32[(($30)>>2)];
      var $76=$75;
      var $77=$29;
      HEAP32[(($29)>>2)]=$76;
      var $78=HEAP32[(($29)>>2)];
      var $79=(($78)|0);
      var $80=$29;
      var $81=$30;
      var $82=(($79)|0);
      var $83=$82;
      var $84=(($83)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$84;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 4; break;
    case 4: // $85
      var $86=HEAPU32[(($__i_i_i_i)>>2)];
      var $87=(($86)>>>0) < 3;
      if ($87) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $88
      var $89=HEAP32[(($__i_i_i_i)>>2)];
      var $90=HEAP32[(($__a_i_i_i)>>2)];
      var $91=(($90+($89<<2))|0);
      HEAP32[(($91)>>2)]=0;
      var $92=HEAP32[(($__i_i_i_i)>>2)];
      var $93=(($92+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$93;
      __label__ = 4; break;
    case 6: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $94=$31;
      var $95=$__a_i_i_i;
      var $96=$__i_i_i_i;
      var $97=$36;
      var $98=$37;
      __label__ = 7; break;
    case 7: // $99
      var $100=(($47+12)|0);
      var $101=(($100)|0)==(((((__ZZNSt3__1L10init_weeksEvE5weeks+168)|0)))|0);
      if ($101) { __label__ = 8; break; } else { var $47 = $100;__label__ = 3; break; }
    case 8: // $102
      var $103=___cxa_atexit(1692, 0, ___dso_handle);
      ;
      __label__ = 9; break;
    case 9: // $104
      var $105=$25;
      var $106=$26;
      HEAP32[(($25)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks)|0);
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str1441747)|0);
      var $107=HEAP32[(($25)>>2)];
      var $108=HEAP32[(($26)>>2)];
      var $109=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($107, $108);
      var $110=$25;
      var $111=$26;
      var $112=$23;
      var $113=$24;
      HEAP32[(($23)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+12)|0);
      HEAP32[(($24)>>2)]=((STRING_TABLE.__str1451748)|0);
      var $114=HEAP32[(($23)>>2)];
      var $115=HEAP32[(($24)>>2)];
      var $116=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($114, $115);
      var $117=$23;
      var $118=$24;
      var $119=$21;
      var $120=$22;
      HEAP32[(($21)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+24)|0);
      HEAP32[(($22)>>2)]=((STRING_TABLE.__str1461749)|0);
      var $121=HEAP32[(($21)>>2)];
      var $122=HEAP32[(($22)>>2)];
      var $123=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($121, $122);
      var $124=$21;
      var $125=$22;
      var $126=$19;
      var $127=$20;
      HEAP32[(($19)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+36)|0);
      HEAP32[(($20)>>2)]=((STRING_TABLE.__str1471750)|0);
      var $128=HEAP32[(($19)>>2)];
      var $129=HEAP32[(($20)>>2)];
      var $130=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($128, $129);
      var $131=$19;
      var $132=$20;
      var $133=$17;
      var $134=$18;
      HEAP32[(($17)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+48)|0);
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str1481751)|0);
      var $135=HEAP32[(($17)>>2)];
      var $136=HEAP32[(($18)>>2)];
      var $137=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($135, $136);
      var $138=$17;
      var $139=$18;
      var $140=$15;
      var $141=$16;
      HEAP32[(($15)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+60)|0);
      HEAP32[(($16)>>2)]=((STRING_TABLE.__str1491752)|0);
      var $142=HEAP32[(($15)>>2)];
      var $143=HEAP32[(($16)>>2)];
      var $144=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($142, $143);
      var $145=$15;
      var $146=$16;
      var $147=$13;
      var $148=$14;
      HEAP32[(($13)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+72)|0);
      HEAP32[(($14)>>2)]=((STRING_TABLE.__str1501753)|0);
      var $149=HEAP32[(($13)>>2)];
      var $150=HEAP32[(($14)>>2)];
      var $151=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($149, $150);
      var $152=$13;
      var $153=$14;
      var $154=$11;
      var $155=$12;
      HEAP32[(($11)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+84)|0);
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str1511754)|0);
      var $156=HEAP32[(($11)>>2)];
      var $157=HEAP32[(($12)>>2)];
      var $158=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($156, $157);
      var $159=$11;
      var $160=$12;
      var $161=$9;
      var $162=$10;
      HEAP32[(($9)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+96)|0);
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str1521755)|0);
      var $163=HEAP32[(($9)>>2)];
      var $164=HEAP32[(($10)>>2)];
      var $165=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($163, $164);
      var $166=$9;
      var $167=$10;
      var $168=$7;
      var $169=$8;
      HEAP32[(($7)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+108)|0);
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str1531756)|0);
      var $170=HEAP32[(($7)>>2)];
      var $171=HEAP32[(($8)>>2)];
      var $172=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($170, $171);
      var $173=$7;
      var $174=$8;
      var $175=$5;
      var $176=$6;
      HEAP32[(($5)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+120)|0);
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str154267)|0);
      var $177=HEAP32[(($5)>>2)];
      var $178=HEAP32[(($6)>>2)];
      var $179=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($177, $178);
      var $180=$5;
      var $181=$6;
      var $182=$3;
      var $183=$4;
      HEAP32[(($3)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+132)|0);
      HEAP32[(($4)>>2)]=((STRING_TABLE.__str155268)|0);
      var $184=HEAP32[(($3)>>2)];
      var $185=HEAP32[(($4)>>2)];
      var $186=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($184, $185);
      var $187=$3;
      var $188=$4;
      var $189=$1;
      var $190=$2;
      HEAP32[(($1)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+144)|0);
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1561757)|0);
      var $191=HEAP32[(($1)>>2)];
      var $192=HEAP32[(($2)>>2)];
      var $193=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($191, $192);
      var $194=$1;
      var $195=$2;
      var $196=$27;
      var $197=$28;
      HEAP32[(($27)>>2)]=((__ZZNSt3__1L10init_weeksEvE5weeks+156)|0);
      HEAP32[(($28)>>2)]=((STRING_TABLE.__str1571758)|0);
      var $198=HEAP32[(($27)>>2)];
      var $199=HEAP32[(($28)>>2)];
      var $200=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($198, $199);
      var $201=$27;
      var $202=$28;
      STACKTOP = __stackBase__;
      return ((__ZZNSt3__1L10init_weeksEvE5weeks)|0);
      var $204=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $205=$204.f0;
      $38=$205;
      var $206=$204.f1;
      $39=$206;
      var $207=(((((__ZZNSt3__1L10init_weeksEvE5weeks)|0)))|0)==(($47)|0);
      if ($207) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $208
      var $209;
      var $210=(($209-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $211
      var $212=(($210)|0)==(((((__ZZNSt3__1L10init_weeksEvE5weeks)|0)))|0);
      if ($212) { __label__ = 12; break; } else { var $209 = $210;__label__ = 10; break; }
    case 12: // $213
      ;
      __label__ = 13; break;
    case 13: // $214
      var $215=$38;
      var $216=$38;
      var $217=$39;
      var $218=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $216, tempValue);
      var $219=($218.f1 = $217, $218);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $220
      var $221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L10init_weeksEv["X"]=1;

function __ZNSt3__1L11init_wweeksEv() {
  var __stackBase__  = STACKTOP; STACKTOP += 156; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $__a_i_i_i=__stackBase__+124;
      var $__i_i_i_i=__stackBase__+128;
      var $32=__stackBase__+132;
      var $33=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38;
      var $39;
      var $40=HEAP8[(__ZGVZNSt3__1L11init_wweeksEvE5weeks)];
      var $41=(($40 << 24) >> 24)==0;
      if ($41) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $42
      var $43=___cxa_guard_acquire(__ZGVZNSt3__1L11init_wweeksEvE5weeks);
      var $44=(($43)|0)!=0;
      if ($44) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $45
      var $47 = ((__ZZNSt3__1L11init_wweeksEvE5weeks)|0);__label__ = 3; break;
    case 3: // $46
      var $47;
      var $48=$37;
      HEAP32[(($37)>>2)]=$47;
      var $49=HEAP32[(($37)>>2)];
      var $50=$36;
      HEAP32[(($36)>>2)]=$49;
      var $51=HEAP32[(($36)>>2)];
      var $52=$51;
      var $53=(($51)|0);
      var $54=$35;
      HEAP32[(($35)>>2)]=$53;
      var $55=HEAP32[(($35)>>2)];
      var $56=$34;
      HEAP32[(($34)>>2)]=$55;
      var $57=HEAP32[(($34)>>2)];
      var $58=$57;
      var $59=$33;
      HEAP32[(($33)>>2)]=$58;
      var $60=HEAP32[(($33)>>2)];
      var $61=$60;
      var $62=$32;
      HEAP32[(($32)>>2)]=$61;
      var $63=HEAP32[(($32)>>2)];
      var $64=$32;
      var $65=(($60)|0);
      var $66=$33;
      var $67=$34;
      var $68=$35;
      var $69=$31;
      var $70=$__a_i_i_i;
      var $71=$__i_i_i_i;
      HEAP32[(($31)>>2)]=$51;
      var $72=HEAP32[(($31)>>2)];
      var $73=(($72)|0);
      var $74=$30;
      HEAP32[(($30)>>2)]=$73;
      var $75=HEAP32[(($30)>>2)];
      var $76=$75;
      var $77=$29;
      HEAP32[(($29)>>2)]=$76;
      var $78=HEAP32[(($29)>>2)];
      var $79=(($78)|0);
      var $80=$29;
      var $81=$30;
      var $82=(($79)|0);
      var $83=$82;
      var $84=(($83)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$84;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 4; break;
    case 4: // $85
      var $86=HEAPU32[(($__i_i_i_i)>>2)];
      var $87=(($86)>>>0) < 3;
      if ($87) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $88
      var $89=HEAP32[(($__i_i_i_i)>>2)];
      var $90=HEAP32[(($__a_i_i_i)>>2)];
      var $91=(($90+($89<<2))|0);
      HEAP32[(($91)>>2)]=0;
      var $92=HEAP32[(($__i_i_i_i)>>2)];
      var $93=(($92+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$93;
      __label__ = 4; break;
    case 6: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $94=$31;
      var $95=$__a_i_i_i;
      var $96=$__i_i_i_i;
      var $97=$36;
      var $98=$37;
      __label__ = 7; break;
    case 7: // $99
      var $100=(($47+12)|0);
      var $101=(($100)|0)==(((((__ZZNSt3__1L11init_wweeksEvE5weeks+168)|0)))|0);
      if ($101) { __label__ = 8; break; } else { var $47 = $100;__label__ = 3; break; }
    case 8: // $102
      var $103=___cxa_atexit(1694, 0, ___dso_handle);
      ;
      __label__ = 9; break;
    case 9: // $104
      var $105=$25;
      var $106=$26;
      HEAP32[(($25)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks)|0);
      HEAP32[(($26)>>2)]=(((STRING_TABLE.__str1291734))|0);
      var $107=HEAP32[(($25)>>2)];
      var $108=HEAP32[(($26)>>2)];
      var $109=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($107, $108);
      var $110=$25;
      var $111=$26;
      var $112=$23;
      var $113=$24;
      HEAP32[(($23)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+12)|0);
      HEAP32[(($24)>>2)]=(((STRING_TABLE.__str1301735))|0);
      var $114=HEAP32[(($23)>>2)];
      var $115=HEAP32[(($24)>>2)];
      var $116=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($114, $115);
      var $117=$23;
      var $118=$24;
      var $119=$21;
      var $120=$22;
      HEAP32[(($21)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+24)|0);
      HEAP32[(($22)>>2)]=(((STRING_TABLE.__str1311736))|0);
      var $121=HEAP32[(($21)>>2)];
      var $122=HEAP32[(($22)>>2)];
      var $123=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($121, $122);
      var $124=$21;
      var $125=$22;
      var $126=$19;
      var $127=$20;
      HEAP32[(($19)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+36)|0);
      HEAP32[(($20)>>2)]=(((STRING_TABLE.__str1321737))|0);
      var $128=HEAP32[(($19)>>2)];
      var $129=HEAP32[(($20)>>2)];
      var $130=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($128, $129);
      var $131=$19;
      var $132=$20;
      var $133=$17;
      var $134=$18;
      HEAP32[(($17)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+48)|0);
      HEAP32[(($18)>>2)]=(((STRING_TABLE.__str133266))|0);
      var $135=HEAP32[(($17)>>2)];
      var $136=HEAP32[(($18)>>2)];
      var $137=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($135, $136);
      var $138=$17;
      var $139=$18;
      var $140=$15;
      var $141=$16;
      HEAP32[(($15)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+60)|0);
      HEAP32[(($16)>>2)]=(((STRING_TABLE.__str1341738))|0);
      var $142=HEAP32[(($15)>>2)];
      var $143=HEAP32[(($16)>>2)];
      var $144=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($142, $143);
      var $145=$15;
      var $146=$16;
      var $147=$13;
      var $148=$14;
      HEAP32[(($13)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+72)|0);
      HEAP32[(($14)>>2)]=(((STRING_TABLE.__str1351739))|0);
      var $149=HEAP32[(($13)>>2)];
      var $150=HEAP32[(($14)>>2)];
      var $151=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($149, $150);
      var $152=$13;
      var $153=$14;
      var $154=$11;
      var $155=$12;
      HEAP32[(($11)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+84)|0);
      HEAP32[(($12)>>2)]=(((STRING_TABLE.__str1361740))|0);
      var $156=HEAP32[(($11)>>2)];
      var $157=HEAP32[(($12)>>2)];
      var $158=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($156, $157);
      var $159=$11;
      var $160=$12;
      var $161=$9;
      var $162=$10;
      HEAP32[(($9)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+96)|0);
      HEAP32[(($10)>>2)]=(((STRING_TABLE.__str1371741))|0);
      var $163=HEAP32[(($9)>>2)];
      var $164=HEAP32[(($10)>>2)];
      var $165=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($163, $164);
      var $166=$9;
      var $167=$10;
      var $168=$7;
      var $169=$8;
      HEAP32[(($7)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+108)|0);
      HEAP32[(($8)>>2)]=(((STRING_TABLE.__str1381742))|0);
      var $170=HEAP32[(($7)>>2)];
      var $171=HEAP32[(($8)>>2)];
      var $172=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($170, $171);
      var $173=$7;
      var $174=$8;
      var $175=$5;
      var $176=$6;
      HEAP32[(($5)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+120)|0);
      HEAP32[(($6)>>2)]=(((STRING_TABLE.__str1391743))|0);
      var $177=HEAP32[(($5)>>2)];
      var $178=HEAP32[(($6)>>2)];
      var $179=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($177, $178);
      var $180=$5;
      var $181=$6;
      var $182=$3;
      var $183=$4;
      HEAP32[(($3)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+132)|0);
      HEAP32[(($4)>>2)]=(((STRING_TABLE.__str1401744))|0);
      var $184=HEAP32[(($3)>>2)];
      var $185=HEAP32[(($4)>>2)];
      var $186=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($184, $185);
      var $187=$3;
      var $188=$4;
      var $189=$1;
      var $190=$2;
      HEAP32[(($1)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+144)|0);
      HEAP32[(($2)>>2)]=(((STRING_TABLE.__str1411745))|0);
      var $191=HEAP32[(($1)>>2)];
      var $192=HEAP32[(($2)>>2)];
      var $193=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($191, $192);
      var $194=$1;
      var $195=$2;
      var $196=$27;
      var $197=$28;
      HEAP32[(($27)>>2)]=((__ZZNSt3__1L11init_wweeksEvE5weeks+156)|0);
      HEAP32[(($28)>>2)]=(((STRING_TABLE.__str1421746))|0);
      var $198=HEAP32[(($27)>>2)];
      var $199=HEAP32[(($28)>>2)];
      var $200=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($198, $199);
      var $201=$27;
      var $202=$28;
      STACKTOP = __stackBase__;
      return ((__ZZNSt3__1L11init_wweeksEvE5weeks)|0);
      var $204=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $205=$204.f0;
      $38=$205;
      var $206=$204.f1;
      $39=$206;
      var $207=(((((__ZZNSt3__1L11init_wweeksEvE5weeks)|0)))|0)==(($47)|0);
      if ($207) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $208
      var $209;
      var $210=(($209-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($210) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $211
      var $212=(($210)|0)==(((((__ZZNSt3__1L11init_wweeksEvE5weeks)|0)))|0);
      if ($212) { __label__ = 12; break; } else { var $209 = $210;__label__ = 10; break; }
    case 12: // $213
      ;
      __label__ = 13; break;
    case 13: // $214
      var $215=$38;
      var $216=$38;
      var $217=$39;
      var $218=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $216, tempValue);
      var $219=($218.f1 = $217, $218);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $220
      var $221=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L11init_wweeksEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIwE8__monthsEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNSt3__1L12init_wmonthsEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $12
      HEAP32[((__ZZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months)>>2)]=$11;
      ;
      __label__ = 4; break;
    case 4: // $13
      var $14=HEAP32[((__ZZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months)>>2)];
      ;
      return $14;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ;
      __label__ = 6; break;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__1L11init_monthsEv() {
  var __stackBase__  = STACKTOP; STACKTOP += 236; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $__a_i_i_i=__stackBase__+204;
      var $__i_i_i_i=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+216;
      var $54=__stackBase__+220;
      var $55=__stackBase__+224;
      var $56=__stackBase__+228;
      var $57=__stackBase__+232;
      var $58;
      var $59;
      var $60=HEAP8[(__ZGVZNSt3__1L11init_monthsEvE6months)];
      var $61=(($60 << 24) >> 24)==0;
      if ($61) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $62
      var $63=___cxa_guard_acquire(__ZGVZNSt3__1L11init_monthsEvE6months);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $65
      var $67 = ((__ZZNSt3__1L11init_monthsEvE6months)|0);__label__ = 3; break;
    case 3: // $66
      var $67;
      var $68=$57;
      HEAP32[(($57)>>2)]=$67;
      var $69=HEAP32[(($57)>>2)];
      var $70=$56;
      HEAP32[(($56)>>2)]=$69;
      var $71=HEAP32[(($56)>>2)];
      var $72=$71;
      var $73=(($71)|0);
      var $74=$55;
      HEAP32[(($55)>>2)]=$73;
      var $75=HEAP32[(($55)>>2)];
      var $76=$54;
      HEAP32[(($54)>>2)]=$75;
      var $77=HEAP32[(($54)>>2)];
      var $78=$77;
      var $79=$53;
      HEAP32[(($53)>>2)]=$78;
      var $80=HEAP32[(($53)>>2)];
      var $81=$80;
      var $82=$52;
      HEAP32[(($52)>>2)]=$81;
      var $83=HEAP32[(($52)>>2)];
      var $84=$52;
      var $85=(($80)|0);
      var $86=$53;
      var $87=$54;
      var $88=$55;
      var $89=$51;
      var $90=$__a_i_i_i;
      var $91=$__i_i_i_i;
      HEAP32[(($51)>>2)]=$71;
      var $92=HEAP32[(($51)>>2)];
      var $93=(($92)|0);
      var $94=$50;
      HEAP32[(($50)>>2)]=$93;
      var $95=HEAP32[(($50)>>2)];
      var $96=$95;
      var $97=$49;
      HEAP32[(($49)>>2)]=$96;
      var $98=HEAP32[(($49)>>2)];
      var $99=(($98)|0);
      var $100=$49;
      var $101=$50;
      var $102=(($99)|0);
      var $103=$102;
      var $104=(($103)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$104;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 4; break;
    case 4: // $105
      var $106=HEAPU32[(($__i_i_i_i)>>2)];
      var $107=(($106)>>>0) < 3;
      if ($107) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $108
      var $109=HEAP32[(($__i_i_i_i)>>2)];
      var $110=HEAP32[(($__a_i_i_i)>>2)];
      var $111=(($110+($109<<2))|0);
      HEAP32[(($111)>>2)]=0;
      var $112=HEAP32[(($__i_i_i_i)>>2)];
      var $113=(($112+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$113;
      __label__ = 4; break;
    case 6: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $114=$51;
      var $115=$__a_i_i_i;
      var $116=$__i_i_i_i;
      var $117=$56;
      var $118=$57;
      __label__ = 7; break;
    case 7: // $119
      var $120=(($67+12)|0);
      var $121=(($120)|0)==(((((__ZZNSt3__1L11init_monthsEvE6months+288)|0)))|0);
      if ($121) { __label__ = 8; break; } else { var $67 = $120;__label__ = 3; break; }
    case 8: // $122
      var $123=___cxa_atexit(1696, 0, ___dso_handle);
      ;
      __label__ = 9; break;
    case 9: // $124
      var $125=$45;
      var $126=$46;
      HEAP32[(($45)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months)|0);
      HEAP32[(($46)>>2)]=((STRING_TABLE.__str1051714)|0);
      var $127=HEAP32[(($45)>>2)];
      var $128=HEAP32[(($46)>>2)];
      var $129=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($127, $128);
      var $130=$45;
      var $131=$46;
      var $132=$43;
      var $133=$44;
      HEAP32[(($43)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+12)|0);
      HEAP32[(($44)>>2)]=((STRING_TABLE.__str1061715)|0);
      var $134=HEAP32[(($43)>>2)];
      var $135=HEAP32[(($44)>>2)];
      var $136=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($134, $135);
      var $137=$43;
      var $138=$44;
      var $139=$41;
      var $140=$42;
      HEAP32[(($41)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+24)|0);
      HEAP32[(($42)>>2)]=((STRING_TABLE.__str1071716)|0);
      var $141=HEAP32[(($41)>>2)];
      var $142=HEAP32[(($42)>>2)];
      var $143=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($141, $142);
      var $144=$41;
      var $145=$42;
      var $146=$39;
      var $147=$40;
      HEAP32[(($39)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+36)|0);
      HEAP32[(($40)>>2)]=((STRING_TABLE.__str1081717)|0);
      var $148=HEAP32[(($39)>>2)];
      var $149=HEAP32[(($40)>>2)];
      var $150=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($148, $149);
      var $151=$39;
      var $152=$40;
      var $153=$37;
      var $154=$38;
      HEAP32[(($37)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+48)|0);
      HEAP32[(($38)>>2)]=((STRING_TABLE.__str1091718)|0);
      var $155=HEAP32[(($37)>>2)];
      var $156=HEAP32[(($38)>>2)];
      var $157=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($155, $156);
      var $158=$37;
      var $159=$38;
      var $160=$35;
      var $161=$36;
      HEAP32[(($35)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+60)|0);
      HEAP32[(($36)>>2)]=((STRING_TABLE.__str1101719)|0);
      var $162=HEAP32[(($35)>>2)];
      var $163=HEAP32[(($36)>>2)];
      var $164=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($162, $163);
      var $165=$35;
      var $166=$36;
      var $167=$33;
      var $168=$34;
      HEAP32[(($33)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+72)|0);
      HEAP32[(($34)>>2)]=((STRING_TABLE.__str1111720)|0);
      var $169=HEAP32[(($33)>>2)];
      var $170=HEAP32[(($34)>>2)];
      var $171=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($169, $170);
      var $172=$33;
      var $173=$34;
      var $174=$31;
      var $175=$32;
      HEAP32[(($31)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+84)|0);
      HEAP32[(($32)>>2)]=((STRING_TABLE.__str112263)|0);
      var $176=HEAP32[(($31)>>2)];
      var $177=HEAP32[(($32)>>2)];
      var $178=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($176, $177);
      var $179=$31;
      var $180=$32;
      var $181=$29;
      var $182=$30;
      HEAP32[(($29)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+96)|0);
      HEAP32[(($30)>>2)]=((STRING_TABLE.__str1131721)|0);
      var $183=HEAP32[(($29)>>2)];
      var $184=HEAP32[(($30)>>2)];
      var $185=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($183, $184);
      var $186=$29;
      var $187=$30;
      var $188=$27;
      var $189=$28;
      HEAP32[(($27)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+108)|0);
      HEAP32[(($28)>>2)]=((STRING_TABLE.__str1141722)|0);
      var $190=HEAP32[(($27)>>2)];
      var $191=HEAP32[(($28)>>2)];
      var $192=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($190, $191);
      var $193=$27;
      var $194=$28;
      var $195=$25;
      var $196=$26;
      HEAP32[(($25)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+120)|0);
      HEAP32[(($26)>>2)]=((STRING_TABLE.__str1151723)|0);
      var $197=HEAP32[(($25)>>2)];
      var $198=HEAP32[(($26)>>2)];
      var $199=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($197, $198);
      var $200=$25;
      var $201=$26;
      var $202=$23;
      var $203=$24;
      HEAP32[(($23)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+132)|0);
      HEAP32[(($24)>>2)]=((STRING_TABLE.__str1161724)|0);
      var $204=HEAP32[(($23)>>2)];
      var $205=HEAP32[(($24)>>2)];
      var $206=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($204, $205);
      var $207=$23;
      var $208=$24;
      var $209=$21;
      var $210=$22;
      HEAP32[(($21)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+144)|0);
      HEAP32[(($22)>>2)]=((STRING_TABLE.__str1171725)|0);
      var $211=HEAP32[(($21)>>2)];
      var $212=HEAP32[(($22)>>2)];
      var $213=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($211, $212);
      var $214=$21;
      var $215=$22;
      var $216=$19;
      var $217=$20;
      HEAP32[(($19)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+156)|0);
      HEAP32[(($20)>>2)]=((STRING_TABLE.__str1181726)|0);
      var $218=HEAP32[(($19)>>2)];
      var $219=HEAP32[(($20)>>2)];
      var $220=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($218, $219);
      var $221=$19;
      var $222=$20;
      var $223=$17;
      var $224=$18;
      HEAP32[(($17)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+168)|0);
      HEAP32[(($18)>>2)]=((STRING_TABLE.__str1191727)|0);
      var $225=HEAP32[(($17)>>2)];
      var $226=HEAP32[(($18)>>2)];
      var $227=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($225, $226);
      var $228=$17;
      var $229=$18;
      var $230=$15;
      var $231=$16;
      HEAP32[(($15)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+180)|0);
      HEAP32[(($16)>>2)]=((STRING_TABLE.__str1201728)|0);
      var $232=HEAP32[(($15)>>2)];
      var $233=HEAP32[(($16)>>2)];
      var $234=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($232, $233);
      var $235=$15;
      var $236=$16;
      var $237=$13;
      var $238=$14;
      HEAP32[(($13)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+192)|0);
      HEAP32[(($14)>>2)]=((STRING_TABLE.__str1091718)|0);
      var $239=HEAP32[(($13)>>2)];
      var $240=HEAP32[(($14)>>2)];
      var $241=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($239, $240);
      var $242=$13;
      var $243=$14;
      var $244=$11;
      var $245=$12;
      HEAP32[(($11)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+204)|0);
      HEAP32[(($12)>>2)]=((STRING_TABLE.__str121264)|0);
      var $246=HEAP32[(($11)>>2)];
      var $247=HEAP32[(($12)>>2)];
      var $248=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($246, $247);
      var $249=$11;
      var $250=$12;
      var $251=$9;
      var $252=$10;
      HEAP32[(($9)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+216)|0);
      HEAP32[(($10)>>2)]=((STRING_TABLE.__str122265)|0);
      var $253=HEAP32[(($9)>>2)];
      var $254=HEAP32[(($10)>>2)];
      var $255=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($253, $254);
      var $256=$9;
      var $257=$10;
      var $258=$7;
      var $259=$8;
      HEAP32[(($7)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+228)|0);
      HEAP32[(($8)>>2)]=((STRING_TABLE.__str1231729)|0);
      var $260=HEAP32[(($7)>>2)];
      var $261=HEAP32[(($8)>>2)];
      var $262=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($260, $261);
      var $263=$7;
      var $264=$8;
      var $265=$5;
      var $266=$6;
      HEAP32[(($5)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+240)|0);
      HEAP32[(($6)>>2)]=((STRING_TABLE.__str1241730)|0);
      var $267=HEAP32[(($5)>>2)];
      var $268=HEAP32[(($6)>>2)];
      var $269=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($267, $268);
      var $270=$5;
      var $271=$6;
      var $272=$3;
      var $273=$4;
      HEAP32[(($3)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+252)|0);
      HEAP32[(($4)>>2)]=((STRING_TABLE.__str1251731)|0);
      var $274=HEAP32[(($3)>>2)];
      var $275=HEAP32[(($4)>>2)];
      var $276=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($274, $275);
      var $277=$3;
      var $278=$4;
      var $279=$1;
      var $280=$2;
      HEAP32[(($1)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+264)|0);
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str1261732)|0);
      var $281=HEAP32[(($1)>>2)];
      var $282=HEAP32[(($2)>>2)];
      var $283=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($281, $282);
      var $284=$1;
      var $285=$2;
      var $286=$47;
      var $287=$48;
      HEAP32[(($47)>>2)]=((__ZZNSt3__1L11init_monthsEvE6months+276)|0);
      HEAP32[(($48)>>2)]=((STRING_TABLE.__str1271733)|0);
      var $288=HEAP32[(($47)>>2)];
      var $289=HEAP32[(($48)>>2)];
      var $290=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($288, $289);
      var $291=$47;
      var $292=$48;
      STACKTOP = __stackBase__;
      return ((__ZZNSt3__1L11init_monthsEvE6months)|0);
      var $294=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $295=$294.f0;
      $58=$295;
      var $296=$294.f1;
      $59=$296;
      var $297=(((((__ZZNSt3__1L11init_monthsEvE6months)|0)))|0)==(($67)|0);
      if ($297) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $298
      var $299;
      var $300=(($299-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $301
      var $302=(($300)|0)==(((((__ZZNSt3__1L11init_monthsEvE6months)|0)))|0);
      if ($302) { __label__ = 12; break; } else { var $299 = $300;__label__ = 10; break; }
    case 12: // $303
      ;
      __label__ = 13; break;
    case 13: // $304
      var $305=$58;
      var $306=$58;
      var $307=$59;
      var $308=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $306, tempValue);
      var $309=($308.f1 = $307, $308);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $310
      var $311=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L11init_monthsEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIcE7__am_pmEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNSt3__1L10init_am_pmEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $12
      HEAP32[((__ZZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm)>>2)]=$11;
      ;
      __label__ = 4; break;
    case 4: // $13
      var $14=HEAP32[((__ZZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm)>>2)];
      ;
      return $14;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ;
      __label__ = 6; break;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNKSt3__120__time_get_c_storageIwE7__am_pmEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      var $5=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm)];
      var $6=(($5 << 24) >> 24)==0;
      if ($6) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $7
      var $8=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm);
      var $9=(($8)|0)!=0;
      if ($9) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $10
      var $11=(function() { try { __THREW__ = false; return __ZNSt3__1L11init_wam_pmEv() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 5; break; };
    case 3: // $12
      HEAP32[((__ZZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm)>>2)]=$11;
      ;
      __label__ = 4; break;
    case 4: // $13
      var $14=HEAP32[((__ZZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm)>>2)];
      ;
      return $14;
    case 5: // $15
      var $16=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $17=$16.f0;
      $2=$17;
      var $18=$16.f1;
      $3=$18;
      ;
      __label__ = 6; break;
    case 6: // $19
      var $20=$2;
      var $21=$2;
      var $22=$3;
      var $23=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $21, tempValue);
      var $24=($23.f1 = $22, $23);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__1L12init_wmonthsEv() {
  var __stackBase__  = STACKTOP; STACKTOP += 236; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31=__stackBase__+120;
      var $32=__stackBase__+124;
      var $33=__stackBase__+128;
      var $34=__stackBase__+132;
      var $35=__stackBase__+136;
      var $36=__stackBase__+140;
      var $37=__stackBase__+144;
      var $38=__stackBase__+148;
      var $39=__stackBase__+152;
      var $40=__stackBase__+156;
      var $41=__stackBase__+160;
      var $42=__stackBase__+164;
      var $43=__stackBase__+168;
      var $44=__stackBase__+172;
      var $45=__stackBase__+176;
      var $46=__stackBase__+180;
      var $47=__stackBase__+184;
      var $48=__stackBase__+188;
      var $49=__stackBase__+192;
      var $50=__stackBase__+196;
      var $51=__stackBase__+200;
      var $__a_i_i_i=__stackBase__+204;
      var $__i_i_i_i=__stackBase__+208;
      var $52=__stackBase__+212;
      var $53=__stackBase__+216;
      var $54=__stackBase__+220;
      var $55=__stackBase__+224;
      var $56=__stackBase__+228;
      var $57=__stackBase__+232;
      var $58;
      var $59;
      var $60=HEAP8[(__ZGVZNSt3__1L12init_wmonthsEvE6months)];
      var $61=(($60 << 24) >> 24)==0;
      if ($61) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $62
      var $63=___cxa_guard_acquire(__ZGVZNSt3__1L12init_wmonthsEvE6months);
      var $64=(($63)|0)!=0;
      if ($64) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $65
      var $67 = ((__ZZNSt3__1L12init_wmonthsEvE6months)|0);__label__ = 3; break;
    case 3: // $66
      var $67;
      var $68=$57;
      HEAP32[(($57)>>2)]=$67;
      var $69=HEAP32[(($57)>>2)];
      var $70=$56;
      HEAP32[(($56)>>2)]=$69;
      var $71=HEAP32[(($56)>>2)];
      var $72=$71;
      var $73=(($71)|0);
      var $74=$55;
      HEAP32[(($55)>>2)]=$73;
      var $75=HEAP32[(($55)>>2)];
      var $76=$54;
      HEAP32[(($54)>>2)]=$75;
      var $77=HEAP32[(($54)>>2)];
      var $78=$77;
      var $79=$53;
      HEAP32[(($53)>>2)]=$78;
      var $80=HEAP32[(($53)>>2)];
      var $81=$80;
      var $82=$52;
      HEAP32[(($52)>>2)]=$81;
      var $83=HEAP32[(($52)>>2)];
      var $84=$52;
      var $85=(($80)|0);
      var $86=$53;
      var $87=$54;
      var $88=$55;
      var $89=$51;
      var $90=$__a_i_i_i;
      var $91=$__i_i_i_i;
      HEAP32[(($51)>>2)]=$71;
      var $92=HEAP32[(($51)>>2)];
      var $93=(($92)|0);
      var $94=$50;
      HEAP32[(($50)>>2)]=$93;
      var $95=HEAP32[(($50)>>2)];
      var $96=$95;
      var $97=$49;
      HEAP32[(($49)>>2)]=$96;
      var $98=HEAP32[(($49)>>2)];
      var $99=(($98)|0);
      var $100=$49;
      var $101=$50;
      var $102=(($99)|0);
      var $103=$102;
      var $104=(($103)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$104;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 4; break;
    case 4: // $105
      var $106=HEAPU32[(($__i_i_i_i)>>2)];
      var $107=(($106)>>>0) < 3;
      if ($107) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $108
      var $109=HEAP32[(($__i_i_i_i)>>2)];
      var $110=HEAP32[(($__a_i_i_i)>>2)];
      var $111=(($110+($109<<2))|0);
      HEAP32[(($111)>>2)]=0;
      var $112=HEAP32[(($__i_i_i_i)>>2)];
      var $113=(($112+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$113;
      __label__ = 4; break;
    case 6: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $114=$51;
      var $115=$__a_i_i_i;
      var $116=$__i_i_i_i;
      var $117=$56;
      var $118=$57;
      __label__ = 7; break;
    case 7: // $119
      var $120=(($67+12)|0);
      var $121=(($120)|0)==(((((__ZZNSt3__1L12init_wmonthsEvE6months+288)|0)))|0);
      if ($121) { __label__ = 8; break; } else { var $67 = $120;__label__ = 3; break; }
    case 8: // $122
      var $123=___cxa_atexit(1698, 0, ___dso_handle);
      ;
      __label__ = 9; break;
    case 9: // $124
      var $125=$45;
      var $126=$46;
      HEAP32[(($45)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months)|0);
      HEAP32[(($46)>>2)]=(((STRING_TABLE.__str811691))|0);
      var $127=HEAP32[(($45)>>2)];
      var $128=HEAP32[(($46)>>2)];
      var $129=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($127, $128);
      var $130=$45;
      var $131=$46;
      var $132=$43;
      var $133=$44;
      HEAP32[(($43)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+12)|0);
      HEAP32[(($44)>>2)]=(((STRING_TABLE.__str821692))|0);
      var $134=HEAP32[(($43)>>2)];
      var $135=HEAP32[(($44)>>2)];
      var $136=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($134, $135);
      var $137=$43;
      var $138=$44;
      var $139=$41;
      var $140=$42;
      HEAP32[(($41)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+24)|0);
      HEAP32[(($42)>>2)]=(((STRING_TABLE.__str831693))|0);
      var $141=HEAP32[(($41)>>2)];
      var $142=HEAP32[(($42)>>2)];
      var $143=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($141, $142);
      var $144=$41;
      var $145=$42;
      var $146=$39;
      var $147=$40;
      HEAP32[(($39)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+36)|0);
      HEAP32[(($40)>>2)]=(((STRING_TABLE.__str841694))|0);
      var $148=HEAP32[(($39)>>2)];
      var $149=HEAP32[(($40)>>2)];
      var $150=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($148, $149);
      var $151=$39;
      var $152=$40;
      var $153=$37;
      var $154=$38;
      HEAP32[(($37)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+48)|0);
      HEAP32[(($38)>>2)]=(((STRING_TABLE.__str851695))|0);
      var $155=HEAP32[(($37)>>2)];
      var $156=HEAP32[(($38)>>2)];
      var $157=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($155, $156);
      var $158=$37;
      var $159=$38;
      var $160=$35;
      var $161=$36;
      HEAP32[(($35)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+60)|0);
      HEAP32[(($36)>>2)]=(((STRING_TABLE.__str861696))|0);
      var $162=HEAP32[(($35)>>2)];
      var $163=HEAP32[(($36)>>2)];
      var $164=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($162, $163);
      var $165=$35;
      var $166=$36;
      var $167=$33;
      var $168=$34;
      HEAP32[(($33)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+72)|0);
      HEAP32[(($34)>>2)]=(((STRING_TABLE.__str871697))|0);
      var $169=HEAP32[(($33)>>2)];
      var $170=HEAP32[(($34)>>2)];
      var $171=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($169, $170);
      var $172=$33;
      var $173=$34;
      var $174=$31;
      var $175=$32;
      HEAP32[(($31)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+84)|0);
      HEAP32[(($32)>>2)]=(((STRING_TABLE.__str881698))|0);
      var $176=HEAP32[(($31)>>2)];
      var $177=HEAP32[(($32)>>2)];
      var $178=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($176, $177);
      var $179=$31;
      var $180=$32;
      var $181=$29;
      var $182=$30;
      HEAP32[(($29)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+96)|0);
      HEAP32[(($30)>>2)]=(((STRING_TABLE.__str891699))|0);
      var $183=HEAP32[(($29)>>2)];
      var $184=HEAP32[(($30)>>2)];
      var $185=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($183, $184);
      var $186=$29;
      var $187=$30;
      var $188=$27;
      var $189=$28;
      HEAP32[(($27)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+108)|0);
      HEAP32[(($28)>>2)]=(((STRING_TABLE.__str901700))|0);
      var $190=HEAP32[(($27)>>2)];
      var $191=HEAP32[(($28)>>2)];
      var $192=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($190, $191);
      var $193=$27;
      var $194=$28;
      var $195=$25;
      var $196=$26;
      HEAP32[(($25)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+120)|0);
      HEAP32[(($26)>>2)]=(((STRING_TABLE.__str911701))|0);
      var $197=HEAP32[(($25)>>2)];
      var $198=HEAP32[(($26)>>2)];
      var $199=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($197, $198);
      var $200=$25;
      var $201=$26;
      var $202=$23;
      var $203=$24;
      HEAP32[(($23)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+132)|0);
      HEAP32[(($24)>>2)]=(((STRING_TABLE.__str921702))|0);
      var $204=HEAP32[(($23)>>2)];
      var $205=HEAP32[(($24)>>2)];
      var $206=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($204, $205);
      var $207=$23;
      var $208=$24;
      var $209=$21;
      var $210=$22;
      HEAP32[(($21)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+144)|0);
      HEAP32[(($22)>>2)]=(((STRING_TABLE.__str931703))|0);
      var $211=HEAP32[(($21)>>2)];
      var $212=HEAP32[(($22)>>2)];
      var $213=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($211, $212);
      var $214=$21;
      var $215=$22;
      var $216=$19;
      var $217=$20;
      HEAP32[(($19)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+156)|0);
      HEAP32[(($20)>>2)]=(((STRING_TABLE.__str941704))|0);
      var $218=HEAP32[(($19)>>2)];
      var $219=HEAP32[(($20)>>2)];
      var $220=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($218, $219);
      var $221=$19;
      var $222=$20;
      var $223=$17;
      var $224=$18;
      HEAP32[(($17)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+168)|0);
      HEAP32[(($18)>>2)]=(((STRING_TABLE.__str951705))|0);
      var $225=HEAP32[(($17)>>2)];
      var $226=HEAP32[(($18)>>2)];
      var $227=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($225, $226);
      var $228=$17;
      var $229=$18;
      var $230=$15;
      var $231=$16;
      HEAP32[(($15)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+180)|0);
      HEAP32[(($16)>>2)]=(((STRING_TABLE.__str961706))|0);
      var $232=HEAP32[(($15)>>2)];
      var $233=HEAP32[(($16)>>2)];
      var $234=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($232, $233);
      var $235=$15;
      var $236=$16;
      var $237=$13;
      var $238=$14;
      HEAP32[(($13)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+192)|0);
      HEAP32[(($14)>>2)]=(((STRING_TABLE.__str851695))|0);
      var $239=HEAP32[(($13)>>2)];
      var $240=HEAP32[(($14)>>2)];
      var $241=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($239, $240);
      var $242=$13;
      var $243=$14;
      var $244=$11;
      var $245=$12;
      HEAP32[(($11)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+204)|0);
      HEAP32[(($12)>>2)]=(((STRING_TABLE.__str971707))|0);
      var $246=HEAP32[(($11)>>2)];
      var $247=HEAP32[(($12)>>2)];
      var $248=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($246, $247);
      var $249=$11;
      var $250=$12;
      var $251=$9;
      var $252=$10;
      HEAP32[(($9)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+216)|0);
      HEAP32[(($10)>>2)]=(((STRING_TABLE.__str981708))|0);
      var $253=HEAP32[(($9)>>2)];
      var $254=HEAP32[(($10)>>2)];
      var $255=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($253, $254);
      var $256=$9;
      var $257=$10;
      var $258=$7;
      var $259=$8;
      HEAP32[(($7)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+228)|0);
      HEAP32[(($8)>>2)]=(((STRING_TABLE.__str991709))|0);
      var $260=HEAP32[(($7)>>2)];
      var $261=HEAP32[(($8)>>2)];
      var $262=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($260, $261);
      var $263=$7;
      var $264=$8;
      var $265=$5;
      var $266=$6;
      HEAP32[(($5)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+240)|0);
      HEAP32[(($6)>>2)]=(((STRING_TABLE.__str1001710))|0);
      var $267=HEAP32[(($5)>>2)];
      var $268=HEAP32[(($6)>>2)];
      var $269=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($267, $268);
      var $270=$5;
      var $271=$6;
      var $272=$3;
      var $273=$4;
      HEAP32[(($3)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+252)|0);
      HEAP32[(($4)>>2)]=(((STRING_TABLE.__str1011711))|0);
      var $274=HEAP32[(($3)>>2)];
      var $275=HEAP32[(($4)>>2)];
      var $276=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($274, $275);
      var $277=$3;
      var $278=$4;
      var $279=$1;
      var $280=$2;
      HEAP32[(($1)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+264)|0);
      HEAP32[(($2)>>2)]=(((STRING_TABLE.__str1021712))|0);
      var $281=HEAP32[(($1)>>2)];
      var $282=HEAP32[(($2)>>2)];
      var $283=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($281, $282);
      var $284=$1;
      var $285=$2;
      var $286=$47;
      var $287=$48;
      HEAP32[(($47)>>2)]=((__ZZNSt3__1L12init_wmonthsEvE6months+276)|0);
      HEAP32[(($48)>>2)]=(((STRING_TABLE.__str1031713))|0);
      var $288=HEAP32[(($47)>>2)];
      var $289=HEAP32[(($48)>>2)];
      var $290=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($288, $289);
      var $291=$47;
      var $292=$48;
      STACKTOP = __stackBase__;
      return ((__ZZNSt3__1L12init_wmonthsEvE6months)|0);
      var $294=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $295=$294.f0;
      $58=$295;
      var $296=$294.f1;
      $59=$296;
      var $297=(((((__ZZNSt3__1L12init_wmonthsEvE6months)|0)))|0)==(($67)|0);
      if ($297) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $298
      var $299;
      var $300=(($299-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($300) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $301
      var $302=(($300)|0)==(((((__ZZNSt3__1L12init_wmonthsEvE6months)|0)))|0);
      if ($302) { __label__ = 12; break; } else { var $299 = $300;__label__ = 10; break; }
    case 12: // $303
      ;
      __label__ = 13; break;
    case 13: // $304
      var $305=$58;
      var $306=$58;
      var $307=$59;
      var $308=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $306, tempValue);
      var $309=($308.f1 = $307, $308);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $310
      var $311=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L12init_wmonthsEv["X"]=1;

function __ZNSt3__1L10init_am_pmEv() {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $__a_i_i_i=__stackBase__+28;
      var $__i_i_i_i=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14;
      var $15;
      var $16=HEAP8[(__ZGVZNSt3__1L10init_am_pmEvE5am_pm)];
      var $17=(($16 << 24) >> 24)==0;
      if ($17) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $18
      var $19=___cxa_guard_acquire(__ZGVZNSt3__1L10init_am_pmEvE5am_pm);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $21
      var $23 = ((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0);__label__ = 3; break;
    case 3: // $22
      var $23;
      var $24=$13;
      HEAP32[(($13)>>2)]=$23;
      var $25=HEAP32[(($13)>>2)];
      var $26=$12;
      HEAP32[(($12)>>2)]=$25;
      var $27=HEAP32[(($12)>>2)];
      var $28=$27;
      var $29=(($27)|0);
      var $30=$11;
      HEAP32[(($11)>>2)]=$29;
      var $31=HEAP32[(($11)>>2)];
      var $32=$10;
      HEAP32[(($10)>>2)]=$31;
      var $33=HEAP32[(($10)>>2)];
      var $34=$33;
      var $35=$9;
      HEAP32[(($9)>>2)]=$34;
      var $36=HEAP32[(($9)>>2)];
      var $37=$36;
      var $38=$8;
      HEAP32[(($8)>>2)]=$37;
      var $39=HEAP32[(($8)>>2)];
      var $40=$8;
      var $41=(($36)|0);
      var $42=$9;
      var $43=$10;
      var $44=$11;
      var $45=$7;
      var $46=$__a_i_i_i;
      var $47=$__i_i_i_i;
      HEAP32[(($7)>>2)]=$27;
      var $48=HEAP32[(($7)>>2)];
      var $49=(($48)|0);
      var $50=$6;
      HEAP32[(($6)>>2)]=$49;
      var $51=HEAP32[(($6)>>2)];
      var $52=$51;
      var $53=$5;
      HEAP32[(($5)>>2)]=$52;
      var $54=HEAP32[(($5)>>2)];
      var $55=(($54)|0);
      var $56=$5;
      var $57=$6;
      var $58=(($55)|0);
      var $59=$58;
      var $60=(($59)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$60;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 4; break;
    case 4: // $61
      var $62=HEAPU32[(($__i_i_i_i)>>2)];
      var $63=(($62)>>>0) < 3;
      if ($63) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $64
      var $65=HEAP32[(($__i_i_i_i)>>2)];
      var $66=HEAP32[(($__a_i_i_i)>>2)];
      var $67=(($66+($65<<2))|0);
      HEAP32[(($67)>>2)]=0;
      var $68=HEAP32[(($__i_i_i_i)>>2)];
      var $69=(($68+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$69;
      __label__ = 4; break;
    case 6: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1Ev_exit
      var $70=$7;
      var $71=$__a_i_i_i;
      var $72=$__i_i_i_i;
      var $73=$12;
      var $74=$13;
      __label__ = 7; break;
    case 7: // $75
      var $76=(($23+12)|0);
      var $77=(($76)|0)==(((((__ZZNSt3__1L10init_am_pmEvE5am_pm+288)|0)))|0);
      if ($77) { __label__ = 8; break; } else { var $23 = $76;__label__ = 3; break; }
    case 8: // $78
      var $79=___cxa_atexit(1700, 0, ___dso_handle);
      ;
      __label__ = 9; break;
    case 9: // $80
      var $81=$1;
      var $82=$2;
      HEAP32[(($1)>>2)]=((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0);
      HEAP32[(($2)>>2)]=((STRING_TABLE.__str781689)|0);
      var $83=HEAP32[(($1)>>2)];
      var $84=HEAP32[(($2)>>2)];
      var $85=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($83, $84);
      var $86=$1;
      var $87=$2;
      var $88=$3;
      var $89=$4;
      HEAP32[(($3)>>2)]=((__ZZNSt3__1L10init_am_pmEvE5am_pm+12)|0);
      HEAP32[(($4)>>2)]=((STRING_TABLE.__str791690)|0);
      var $90=HEAP32[(($3)>>2)];
      var $91=HEAP32[(($4)>>2)];
      var $92=__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc($90, $91);
      var $93=$3;
      var $94=$4;
      STACKTOP = __stackBase__;
      return ((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0);
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $97=$96.f0;
      $14=$97;
      var $98=$96.f1;
      $15=$98;
      var $99=(((((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0)))|0)==(($23)|0);
      if ($99) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $100
      var $101;
      var $102=(($101-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $103
      var $104=(($102)|0)==(((((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0)))|0);
      if ($104) { __label__ = 12; break; } else { var $101 = $102;__label__ = 10; break; }
    case 12: // $105
      ;
      __label__ = 13; break;
    case 13: // $106
      var $107=$14;
      var $108=$14;
      var $109=$15;
      var $110=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $108, tempValue);
      var $111=($110.f1 = $109, $110);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $112
      var $113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L10init_am_pmEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIcE3__xEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE3__xEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE3__xEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIcE3__xEvE1s;
      HEAP32[(($9)>>2)]=((STRING_TABLE.__str571671)|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _strlen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1EPKc_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1704, __ZZNKSt3__120__time_get_c_storageIcE3__xEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIcE3__xEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIcE3__xEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIwE3__xEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE3__xEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE3__xEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIwE3__xEvE1s;
      HEAP32[(($9)>>2)]=(((STRING_TABLE.__str581672))|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _wcslen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1EPKw_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1706, __ZZNKSt3__120__time_get_c_storageIwE3__xEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIwE3__xEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIwE3__xEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIcE3__XEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE3__XEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE3__XEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIcE3__XEvE1s;
      HEAP32[(($9)>>2)]=((STRING_TABLE.__str591673)|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _strlen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1EPKc_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1704, __ZZNKSt3__120__time_get_c_storageIcE3__XEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIcE3__XEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIcE3__XEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIwE3__XEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE3__XEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE3__XEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIwE3__XEvE1s;
      HEAP32[(($9)>>2)]=(((STRING_TABLE.__str601674))|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _wcslen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1EPKw_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1706, __ZZNKSt3__120__time_get_c_storageIwE3__XEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIwE3__XEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIwE3__XEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIcE3__cEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE3__cEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE3__cEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIcE3__cEvE1s;
      HEAP32[(($9)>>2)]=((STRING_TABLE.__str611675)|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _strlen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1EPKc_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1704, __ZZNKSt3__120__time_get_c_storageIcE3__cEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIcE3__cEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIcE3__cEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIwE3__cEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE3__cEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE3__cEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIwE3__cEvE1s;
      HEAP32[(($9)>>2)]=(((STRING_TABLE.__str621676))|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _wcslen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1EPKw_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1706, __ZZNKSt3__120__time_get_c_storageIwE3__cEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIwE3__cEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIwE3__cEv["X"]=1;

function __ZNSt3__1L11init_wam_pmEv() {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $__a_i_i_i=__stackBase__+28;
      var $__i_i_i_i=__stackBase__+32;
      var $8=__stackBase__+36;
      var $9=__stackBase__+40;
      var $10=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14;
      var $15;
      var $16=HEAP8[(__ZGVZNSt3__1L11init_wam_pmEvE5am_pm)];
      var $17=(($16 << 24) >> 24)==0;
      if ($17) { __label__ = 1; break; } else { __label__ = 9; break; }
    case 1: // $18
      var $19=___cxa_guard_acquire(__ZGVZNSt3__1L11init_wam_pmEvE5am_pm);
      var $20=(($19)|0)!=0;
      if ($20) { __label__ = 2; break; } else { __label__ = 9; break; }
    case 2: // $21
      var $23 = ((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0);__label__ = 3; break;
    case 3: // $22
      var $23;
      var $24=$13;
      HEAP32[(($13)>>2)]=$23;
      var $25=HEAP32[(($13)>>2)];
      var $26=$12;
      HEAP32[(($12)>>2)]=$25;
      var $27=HEAP32[(($12)>>2)];
      var $28=$27;
      var $29=(($27)|0);
      var $30=$11;
      HEAP32[(($11)>>2)]=$29;
      var $31=HEAP32[(($11)>>2)];
      var $32=$10;
      HEAP32[(($10)>>2)]=$31;
      var $33=HEAP32[(($10)>>2)];
      var $34=$33;
      var $35=$9;
      HEAP32[(($9)>>2)]=$34;
      var $36=HEAP32[(($9)>>2)];
      var $37=$36;
      var $38=$8;
      HEAP32[(($8)>>2)]=$37;
      var $39=HEAP32[(($8)>>2)];
      var $40=$8;
      var $41=(($36)|0);
      var $42=$9;
      var $43=$10;
      var $44=$11;
      var $45=$7;
      var $46=$__a_i_i_i;
      var $47=$__i_i_i_i;
      HEAP32[(($7)>>2)]=$27;
      var $48=HEAP32[(($7)>>2)];
      var $49=(($48)|0);
      var $50=$6;
      HEAP32[(($6)>>2)]=$49;
      var $51=HEAP32[(($6)>>2)];
      var $52=$51;
      var $53=$5;
      HEAP32[(($5)>>2)]=$52;
      var $54=HEAP32[(($5)>>2)];
      var $55=(($54)|0);
      var $56=$5;
      var $57=$6;
      var $58=(($55)|0);
      var $59=$58;
      var $60=(($59)|0);
      HEAP32[(($__a_i_i_i)>>2)]=$60;
      HEAP32[(($__i_i_i_i)>>2)]=0;
      __label__ = 4; break;
    case 4: // $61
      var $62=HEAPU32[(($__i_i_i_i)>>2)];
      var $63=(($62)>>>0) < 3;
      if ($63) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $64
      var $65=HEAP32[(($__i_i_i_i)>>2)];
      var $66=HEAP32[(($__a_i_i_i)>>2)];
      var $67=(($66+($65<<2))|0);
      HEAP32[(($67)>>2)]=0;
      var $68=HEAP32[(($__i_i_i_i)>>2)];
      var $69=(($68+1)|0);
      HEAP32[(($__i_i_i_i)>>2)]=$69;
      __label__ = 4; break;
    case 6: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1Ev_exit
      var $70=$7;
      var $71=$__a_i_i_i;
      var $72=$__i_i_i_i;
      var $73=$12;
      var $74=$13;
      __label__ = 7; break;
    case 7: // $75
      var $76=(($23+12)|0);
      var $77=(($76)|0)==(((((__ZZNSt3__1L11init_wam_pmEvE5am_pm+288)|0)))|0);
      if ($77) { __label__ = 8; break; } else { var $23 = $76;__label__ = 3; break; }
    case 8: // $78
      var $79=___cxa_atexit(1702, 0, ___dso_handle);
      ;
      __label__ = 9; break;
    case 9: // $80
      var $81=$1;
      var $82=$2;
      HEAP32[(($1)>>2)]=((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0);
      HEAP32[(($2)>>2)]=(((STRING_TABLE.__str751687))|0);
      var $83=HEAP32[(($1)>>2)];
      var $84=HEAP32[(($2)>>2)];
      var $85=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($83, $84);
      var $86=$1;
      var $87=$2;
      var $88=$3;
      var $89=$4;
      HEAP32[(($3)>>2)]=((__ZZNSt3__1L11init_wam_pmEvE5am_pm+12)|0);
      HEAP32[(($4)>>2)]=(((STRING_TABLE.__str761688))|0);
      var $90=HEAP32[(($3)>>2)];
      var $91=HEAP32[(($4)>>2)];
      var $92=__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw($90, $91);
      var $93=$3;
      var $94=$4;
      STACKTOP = __stackBase__;
      return ((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0);
      var $96=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $97=$96.f0;
      $14=$97;
      var $98=$96.f1;
      $15=$98;
      var $99=(((((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0)))|0)==(($23)|0);
      if ($99) { __label__ = 12; break; } else { __label__ = 10; break; }
    case 10: // $100
      var $101;
      var $102=(($101-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($102) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 14; break; }
    case 11: // $103
      var $104=(($102)|0)==(((((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0)))|0);
      if ($104) { __label__ = 12; break; } else { var $101 = $102;__label__ = 10; break; }
    case 12: // $105
      ;
      __label__ = 13; break;
    case 13: // $106
      var $107=$14;
      var $108=$14;
      var $109=$15;
      var $110=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $108, tempValue);
      var $111=($110.f1 = $109, $110);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 14: // $112
      var $113=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__1L11init_wam_pmEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIcE3__rEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIcE3__rEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIcE3__rEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIcE3__rEvE1s;
      HEAP32[(($9)>>2)]=((STRING_TABLE.__str63261)|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _strlen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1EPKc_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1704, __ZZNKSt3__120__time_get_c_storageIcE3__rEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIcE3__rEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIcE3__rEv["X"]=1;

function __ZNKSt3__120__time_get_c_storageIwE3__rEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 36; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10;
      var $11;
      var $12;
      $10=$this;
      var $13=$10;
      var $14=HEAP8[(__ZGVZNKSt3__120__time_get_c_storageIwE3__rEvE1s)];
      var $15=(($14 << 24) >> 24)==0;
      if ($15) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $16
      var $17=___cxa_guard_acquire(__ZGVZNKSt3__120__time_get_c_storageIwE3__rEvE1s);
      var $18=(($17)|0)!=0;
      if ($18) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $19
      var $20=$8;
      var $21=$9;
      HEAP32[(($8)>>2)]=__ZZNKSt3__120__time_get_c_storageIwE3__rEvE1s;
      HEAP32[(($9)>>2)]=(((STRING_TABLE.__str641677))|0);
      var $22=HEAP32[(($8)>>2)];
      var $23=HEAP32[(($9)>>2)];
      var $24=$6;
      var $25=$7;
      HEAP32[(($6)>>2)]=$22;
      HEAP32[(($7)>>2)]=$23;
      var $26=HEAP32[(($6)>>2)];
      var $27=$26;
      var $28=(($26)|0);
      var $29=$5;
      HEAP32[(($5)>>2)]=$28;
      var $30=HEAP32[(($5)>>2)];
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=$35;
      var $37=$2;
      HEAP32[(($2)>>2)]=$36;
      var $38=HEAP32[(($2)>>2)];
      var $39=$2;
      var $40=(($35)|0);
      var $41=$3;
      var $42=$4;
      var $43=$5;
      var $44=HEAP32[(($7)>>2)];
      var $45=HEAP32[(($7)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=(function() { try { __THREW__ = false; return _wcslen($47) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 7; break; };
    case 3: // $_noexc
      var $49=$1;
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj($26, $44, $48) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 4; break; } else { __label__ = 7; break; }
    case 4: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC1EPKw_exit
      var $50=$6;
      var $51=$7;
      var $52=$8;
      var $53=$9;
      __label__ = 5; break;
    case 5: // $54
      var $55=___cxa_atexit(1706, __ZZNKSt3__120__time_get_c_storageIwE3__rEvE1s, ___dso_handle);
      ;
      __label__ = 6; break;
    case 6: // $56
      STACKTOP = __stackBase__;
      return __ZZNKSt3__120__time_get_c_storageIwE3__rEvE1s;
    case 7: // $57
      var $58=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $59=$58.f0;
      $11=$59;
      var $60=$58.f1;
      $12=$60;
      ;
      __label__ = 8; break;
    case 8: // $61
      var $62=$11;
      var $63=$11;
      var $64=$12;
      var $65=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $63, tempValue);
      var $66=($65.f1 = $64, $65);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__120__time_get_c_storageIwE3__rEv["X"]=1;

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_($this, $__first, $__last) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $__m_i=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $34=__stackBase__+136;
      var $35=__stackBase__+140;
      var $36=__stackBase__+144;
      var $37=__stackBase__+148;
      var $38=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48=__stackBase__+192;
      var $49=__stackBase__+196;
      var $50=__stackBase__+200;
      var $51=__stackBase__+204;
      var $52;
      var $53;
      var $54;
      var $__sz;
      var $__p;
      var $__cap;
      var $55=__stackBase__+208;
      $52=$this;
      $53=$__first;
      $54=$__last;
      var $56=$52;
      var $57=$53;
      var $58=$54;
      var $59=$48;
      var $60=$49;
      var $61=$50;
      var $62=$51;
      HEAP32[(($49)>>2)]=$57;
      HEAP32[(($50)>>2)]=$58;
      var $63=HEAP32[(($49)>>2)];
      var $64=HEAP32[(($50)>>2)];
      var $tmp_i=$48;
      var $tmp1_i=$51;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $65=$46;
      var $66=$47;
      HEAP32[(($46)>>2)]=$63;
      HEAP32[(($47)>>2)]=$64;
      var $67=HEAP32[(($47)>>2)];
      var $68=HEAP32[(($46)>>2)];
      var $69=$67;
      var $70=$68;
      var $71=(($69-$70)|0);
      var $72=(((($71)|0)/4)|0);
      var $73=$46;
      var $74=$47;
      var $75=$48;
      var $76=$49;
      var $77=$50;
      var $78=$51;
      $__sz=$72;
      var $79=$__sz;
      var $80=$22;
      var $81=$__m_i;
      var $82=$23;
      var $83=$24;
      HEAP32[(($22)>>2)]=$56;
      var $84=HEAP32[(($22)>>2)];
      var $85=$21;
      HEAP32[(($21)>>2)]=$84;
      var $86=HEAP32[(($21)>>2)];
      var $87=(($86)|0);
      var $88=$20;
      HEAP32[(($20)>>2)]=$87;
      var $89=HEAP32[(($20)>>2)];
      var $90=$89;
      var $91=$19;
      HEAP32[(($19)>>2)]=$90;
      var $92=HEAP32[(($19)>>2)];
      var $93=$92;
      var $94=$19;
      var $95=$20;
      var $96=$21;
      var $97=$15;
      var $98=$16;
      var $99=$17;
      var $100=$18;
      HEAP32[(($16)>>2)]=$93;
      var $101=$18;
      var $102=HEAP32[(($16)>>2)];
      var $tmp_i_i=$15;
      var $tmp1_i_i=$17;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $103=$14;
      HEAP32[(($14)>>2)]=$102;
      var $104=HEAP32[(($14)>>2)];
      var $105=$13;
      HEAP32[(($13)>>2)]=$104;
      var $106=HEAP32[(($13)>>2)];
      var $107=$13;
      var $108=$14;
      var $109=$15;
      var $110=$16;
      var $111=$17;
      var $112=$18;
      HEAP32[(($__m_i)>>2)]=1073741823;
      var $113=HEAP32[(($__m_i)>>2)];
      var $114=(($113-1)|0);
      var $115=$22;
      var $116=$__m_i;
      var $117=$23;
      var $118=$24;
      var $119=(($79)>>>0) > (($114)>>>0);
      if ($119) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $120
      var $121=$56;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($121);
      __label__ = 2; break;
    case 2: // $122
      var $123=$__sz;
      var $124=(($123)>>>0) < 2;
      if ($124) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $125
      var $126=$__sz;
      var $127=$3;
      var $128=$4;
      HEAP32[(($3)>>2)]=$56;
      HEAP32[(($4)>>2)]=$126;
      var $129=HEAP32[(($3)>>2)];
      var $130=HEAP32[(($4)>>2)];
      var $131=$130 << 1;
      var $132=(($131) & 255);
      var $133=(($129)|0);
      var $134=$2;
      HEAP32[(($2)>>2)]=$133;
      var $135=HEAP32[(($2)>>2)];
      var $136=$135;
      var $137=$1;
      HEAP32[(($1)>>2)]=$136;
      var $138=HEAP32[(($1)>>2)];
      var $139=(($138)|0);
      var $140=$1;
      var $141=$2;
      var $142=(($139)|0);
      var $143=$142;
      var $144=(($143)|0);
      var $145=$144;
      HEAP8[($145)]=$132;
      var $146=$3;
      var $147=$4;
      var $148=$7;
      HEAP32[(($7)>>2)]=$56;
      var $149=HEAP32[(($7)>>2)];
      var $150=(($149)|0);
      var $151=$6;
      HEAP32[(($6)>>2)]=$150;
      var $152=HEAP32[(($6)>>2)];
      var $153=$152;
      var $154=$5;
      HEAP32[(($5)>>2)]=$153;
      var $155=HEAP32[(($5)>>2)];
      var $156=(($155)|0);
      var $157=$5;
      var $158=$6;
      var $159=(($156)|0);
      var $160=$159;
      var $161=(($160+4)|0);
      var $162=(($161)|0);
      var $163=$7;
      $__p=$162;
      __label__ = 8; break;
    case 4: // $164
      var $165=$__sz;
      var $166=$9;
      HEAP32[(($9)>>2)]=$165;
      var $167=HEAPU32[(($9)>>2)];
      var $168=(($167)>>>0) < 2;
      if ($168) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $169
      var $178 = 2;__label__ = 7; break;
    case 6: // $170
      var $171=HEAP32[(($9)>>2)];
      var $172=(($171+1)|0);
      var $173=$8;
      HEAP32[(($8)>>2)]=$172;
      var $174=HEAP32[(($8)>>2)];
      var $175=(($174+3)|0);
      var $176=$175 & -4;
      var $177=$8;
      var $178 = $176;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj_exit
      var $178;
      var $179=(($178-1)|0);
      var $180=$9;
      $__cap=$179;
      var $181=$12;
      HEAP32[(($12)>>2)]=$56;
      var $182=HEAP32[(($12)>>2)];
      var $183=(($182)|0);
      var $184=$11;
      HEAP32[(($11)>>2)]=$183;
      var $185=HEAP32[(($11)>>2)];
      var $186=$185;
      var $187=$10;
      HEAP32[(($10)>>2)]=$186;
      var $188=HEAP32[(($10)>>2)];
      var $189=$188;
      var $190=$10;
      var $191=$11;
      var $192=$12;
      var $193=$__cap;
      var $194=(($193+1)|0);
      var $195=$28;
      var $196=$29;
      HEAP32[(($28)>>2)]=$189;
      HEAP32[(($29)>>2)]=$194;
      var $197=HEAP32[(($28)>>2)];
      var $198=HEAP32[(($29)>>2)];
      var $199=$25;
      var $200=$26;
      var $201=$27;
      HEAP32[(($25)>>2)]=$197;
      HEAP32[(($26)>>2)]=$198;
      HEAP32[(($27)>>2)]=0;
      var $202=HEAP32[(($25)>>2)];
      var $203=HEAP32[(($26)>>2)];
      var $204=((($203<<2))|0);
      var $205=__Znwj($204);
      var $206=$205;
      var $207=$25;
      var $208=$26;
      var $209=$27;
      var $210=$28;
      var $211=$29;
      $__p=$206;
      var $212=$__p;
      var $213=$32;
      var $214=$33;
      HEAP32[(($32)>>2)]=$56;
      HEAP32[(($33)>>2)]=$212;
      var $215=HEAP32[(($32)>>2)];
      var $216=HEAP32[(($33)>>2)];
      var $217=(($215)|0);
      var $218=$31;
      HEAP32[(($31)>>2)]=$217;
      var $219=HEAP32[(($31)>>2)];
      var $220=$219;
      var $221=$30;
      HEAP32[(($30)>>2)]=$220;
      var $222=HEAP32[(($30)>>2)];
      var $223=(($222)|0);
      var $224=$30;
      var $225=$31;
      var $226=(($223)|0);
      var $227=$226;
      var $228=(($227+8)|0);
      HEAP32[(($228)>>2)]=$216;
      var $229=$32;
      var $230=$33;
      var $231=$__cap;
      var $232=(($231+1)|0);
      var $233=$36;
      var $234=$37;
      HEAP32[(($36)>>2)]=$56;
      HEAP32[(($37)>>2)]=$232;
      var $235=HEAP32[(($36)>>2)];
      var $236=HEAP32[(($37)>>2)];
      var $237=1 | $236;
      var $238=(($235)|0);
      var $239=$35;
      HEAP32[(($35)>>2)]=$238;
      var $240=HEAP32[(($35)>>2)];
      var $241=$240;
      var $242=$34;
      HEAP32[(($34)>>2)]=$241;
      var $243=HEAP32[(($34)>>2)];
      var $244=(($243)|0);
      var $245=$34;
      var $246=$35;
      var $247=(($244)|0);
      var $248=$247;
      var $249=(($248)|0);
      HEAP32[(($249)>>2)]=$237;
      var $250=$36;
      var $251=$37;
      var $252=$__sz;
      var $253=$40;
      var $254=$41;
      HEAP32[(($40)>>2)]=$56;
      HEAP32[(($41)>>2)]=$252;
      var $255=HEAP32[(($40)>>2)];
      var $256=HEAP32[(($41)>>2)];
      var $257=(($255)|0);
      var $258=$39;
      HEAP32[(($39)>>2)]=$257;
      var $259=HEAP32[(($39)>>2)];
      var $260=$259;
      var $261=$38;
      HEAP32[(($38)>>2)]=$260;
      var $262=HEAP32[(($38)>>2)];
      var $263=(($262)|0);
      var $264=$38;
      var $265=$39;
      var $266=(($263)|0);
      var $267=$266;
      var $268=(($267+4)|0);
      HEAP32[(($268)>>2)]=$256;
      var $269=$40;
      var $270=$41;
      __label__ = 8; break;
    case 8: // $271
      __label__ = 9; break;
    case 9: // $272
      var $273=$53;
      var $274=$54;
      var $275=(($273)|0)!=(($274)|0);
      if ($275) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $276
      var $277=$__p;
      var $278=$53;
      var $279=$42;
      var $280=$43;
      HEAP32[(($42)>>2)]=$277;
      HEAP32[(($43)>>2)]=$278;
      var $281=HEAP32[(($43)>>2)];
      var $282=HEAP32[(($281)>>2)];
      var $283=HEAP32[(($42)>>2)];
      HEAP32[(($283)>>2)]=$282;
      var $284=$42;
      var $285=$43;
      __label__ = 11; break;
    case 11: // $286
      var $287=$53;
      var $288=(($287+4)|0);
      $53=$288;
      var $289=$__p;
      var $290=(($289+4)|0);
      $__p=$290;
      __label__ = 9; break;
    case 12: // $291
      var $292=$__p;
      HEAP32[(($55)>>2)]=0;
      var $293=$44;
      var $294=$45;
      HEAP32[(($44)>>2)]=$292;
      HEAP32[(($45)>>2)]=$55;
      var $295=HEAP32[(($45)>>2)];
      var $296=HEAP32[(($295)>>2)];
      var $297=HEAP32[(($44)>>2)];
      HEAP32[(($297)>>2)]=$296;
      var $298=$44;
      var $299=$45;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_["X"]=1;

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_($this, $__first, $__last) {
  var __stackBase__  = STACKTOP; STACKTOP += 212; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $__m_i=__stackBase__+88;
      var $23=__stackBase__+92;
      var $24=__stackBase__+96;
      var $25=__stackBase__+100;
      var $26=__stackBase__+104;
      var $27=__stackBase__+108;
      var $28=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $34=__stackBase__+136;
      var $35=__stackBase__+140;
      var $36=__stackBase__+144;
      var $37=__stackBase__+148;
      var $38=__stackBase__+152;
      var $39=__stackBase__+156;
      var $40=__stackBase__+160;
      var $41=__stackBase__+164;
      var $42=__stackBase__+168;
      var $43=__stackBase__+172;
      var $44=__stackBase__+176;
      var $45=__stackBase__+180;
      var $46=__stackBase__+184;
      var $47=__stackBase__+188;
      var $48=__stackBase__+192;
      var $49=__stackBase__+196;
      var $50=__stackBase__+200;
      var $51=__stackBase__+204;
      var $52;
      var $53;
      var $54;
      var $__sz;
      var $__p;
      var $__cap;
      var $55=__stackBase__+208;
      $52=$this;
      $53=$__first;
      $54=$__last;
      var $56=$52;
      var $57=$53;
      var $58=$54;
      var $59=$48;
      var $60=$49;
      var $61=$50;
      var $62=$51;
      HEAP32[(($49)>>2)]=$57;
      HEAP32[(($50)>>2)]=$58;
      var $63=HEAP32[(($49)>>2)];
      var $64=HEAP32[(($50)>>2)];
      var $tmp_i=$48;
      var $tmp1_i=$51;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $65=$46;
      var $66=$47;
      HEAP32[(($46)>>2)]=$63;
      HEAP32[(($47)>>2)]=$64;
      var $67=HEAP32[(($47)>>2)];
      var $68=HEAP32[(($46)>>2)];
      var $69=$67;
      var $70=$68;
      var $71=(($69-$70)|0);
      var $72=$46;
      var $73=$47;
      var $74=$48;
      var $75=$49;
      var $76=$50;
      var $77=$51;
      $__sz=$71;
      var $78=$__sz;
      var $79=$22;
      var $80=$__m_i;
      var $81=$23;
      var $82=$24;
      HEAP32[(($22)>>2)]=$56;
      var $83=HEAP32[(($22)>>2)];
      var $84=$21;
      HEAP32[(($21)>>2)]=$83;
      var $85=HEAP32[(($21)>>2)];
      var $86=(($85)|0);
      var $87=$20;
      HEAP32[(($20)>>2)]=$86;
      var $88=HEAP32[(($20)>>2)];
      var $89=$88;
      var $90=$19;
      HEAP32[(($19)>>2)]=$89;
      var $91=HEAP32[(($19)>>2)];
      var $92=$91;
      var $93=$19;
      var $94=$20;
      var $95=$21;
      var $96=$15;
      var $97=$16;
      var $98=$17;
      var $99=$18;
      HEAP32[(($16)>>2)]=$92;
      var $100=$18;
      var $101=HEAP32[(($16)>>2)];
      var $tmp_i_i=$15;
      var $tmp1_i_i=$17;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $102=$14;
      HEAP32[(($14)>>2)]=$101;
      var $103=HEAP32[(($14)>>2)];
      var $104=$13;
      HEAP32[(($13)>>2)]=$103;
      var $105=HEAP32[(($13)>>2)];
      var $106=$13;
      var $107=$14;
      var $108=$15;
      var $109=$16;
      var $110=$17;
      var $111=$18;
      HEAP32[(($__m_i)>>2)]=-1;
      var $112=HEAP32[(($__m_i)>>2)];
      var $113=(($112-1)|0);
      var $114=$22;
      var $115=$__m_i;
      var $116=$23;
      var $117=$24;
      var $118=(($78)>>>0) > (($113)>>>0);
      if ($118) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $119
      var $120=$56;
      __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv($120);
      __label__ = 2; break;
    case 2: // $121
      var $122=$__sz;
      var $123=(($122)>>>0) < 11;
      if ($123) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $124
      var $125=$__sz;
      var $126=$3;
      var $127=$4;
      HEAP32[(($3)>>2)]=$56;
      HEAP32[(($4)>>2)]=$125;
      var $128=HEAP32[(($3)>>2)];
      var $129=HEAP32[(($4)>>2)];
      var $130=$129 << 1;
      var $131=(($130) & 255);
      var $132=(($128)|0);
      var $133=$2;
      HEAP32[(($2)>>2)]=$132;
      var $134=HEAP32[(($2)>>2)];
      var $135=$134;
      var $136=$1;
      HEAP32[(($1)>>2)]=$135;
      var $137=HEAP32[(($1)>>2)];
      var $138=(($137)|0);
      var $139=$1;
      var $140=$2;
      var $141=(($138)|0);
      var $142=$141;
      var $143=(($142)|0);
      var $144=$143;
      HEAP8[($144)]=$131;
      var $145=$3;
      var $146=$4;
      var $147=$7;
      HEAP32[(($7)>>2)]=$56;
      var $148=HEAP32[(($7)>>2)];
      var $149=(($148)|0);
      var $150=$6;
      HEAP32[(($6)>>2)]=$149;
      var $151=HEAP32[(($6)>>2)];
      var $152=$151;
      var $153=$5;
      HEAP32[(($5)>>2)]=$152;
      var $154=HEAP32[(($5)>>2)];
      var $155=(($154)|0);
      var $156=$5;
      var $157=$6;
      var $158=(($155)|0);
      var $159=$158;
      var $160=(($159+1)|0);
      var $161=(($160)|0);
      var $162=$7;
      $__p=$161;
      __label__ = 8; break;
    case 4: // $163
      var $164=$__sz;
      var $165=$9;
      HEAP32[(($9)>>2)]=$164;
      var $166=HEAPU32[(($9)>>2)];
      var $167=(($166)>>>0) < 11;
      if ($167) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $168
      var $177 = 11;__label__ = 7; break;
    case 6: // $169
      var $170=HEAP32[(($9)>>2)];
      var $171=(($170+1)|0);
      var $172=$8;
      HEAP32[(($8)>>2)]=$171;
      var $173=HEAP32[(($8)>>2)];
      var $174=(($173+15)|0);
      var $175=$174 & -16;
      var $176=$8;
      var $177 = $175;__label__ = 7; break;
    case 7: // $_ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj_exit
      var $177;
      var $178=(($177-1)|0);
      var $179=$9;
      $__cap=$178;
      var $180=$12;
      HEAP32[(($12)>>2)]=$56;
      var $181=HEAP32[(($12)>>2)];
      var $182=(($181)|0);
      var $183=$11;
      HEAP32[(($11)>>2)]=$182;
      var $184=HEAP32[(($11)>>2)];
      var $185=$184;
      var $186=$10;
      HEAP32[(($10)>>2)]=$185;
      var $187=HEAP32[(($10)>>2)];
      var $188=$187;
      var $189=$10;
      var $190=$11;
      var $191=$12;
      var $192=$__cap;
      var $193=(($192+1)|0);
      var $194=$28;
      var $195=$29;
      HEAP32[(($28)>>2)]=$188;
      HEAP32[(($29)>>2)]=$193;
      var $196=HEAP32[(($28)>>2)];
      var $197=HEAP32[(($29)>>2)];
      var $198=$25;
      var $199=$26;
      var $200=$27;
      HEAP32[(($25)>>2)]=$196;
      HEAP32[(($26)>>2)]=$197;
      HEAP32[(($27)>>2)]=0;
      var $201=HEAP32[(($25)>>2)];
      var $202=HEAP32[(($26)>>2)];
      var $203=(($202)|0);
      var $204=__Znwj($203);
      var $205=$25;
      var $206=$26;
      var $207=$27;
      var $208=$28;
      var $209=$29;
      $__p=$204;
      var $210=$__p;
      var $211=$32;
      var $212=$33;
      HEAP32[(($32)>>2)]=$56;
      HEAP32[(($33)>>2)]=$210;
      var $213=HEAP32[(($32)>>2)];
      var $214=HEAP32[(($33)>>2)];
      var $215=(($213)|0);
      var $216=$31;
      HEAP32[(($31)>>2)]=$215;
      var $217=HEAP32[(($31)>>2)];
      var $218=$217;
      var $219=$30;
      HEAP32[(($30)>>2)]=$218;
      var $220=HEAP32[(($30)>>2)];
      var $221=(($220)|0);
      var $222=$30;
      var $223=$31;
      var $224=(($221)|0);
      var $225=$224;
      var $226=(($225+8)|0);
      HEAP32[(($226)>>2)]=$214;
      var $227=$32;
      var $228=$33;
      var $229=$__cap;
      var $230=(($229+1)|0);
      var $231=$36;
      var $232=$37;
      HEAP32[(($36)>>2)]=$56;
      HEAP32[(($37)>>2)]=$230;
      var $233=HEAP32[(($36)>>2)];
      var $234=HEAP32[(($37)>>2)];
      var $235=1 | $234;
      var $236=(($233)|0);
      var $237=$35;
      HEAP32[(($35)>>2)]=$236;
      var $238=HEAP32[(($35)>>2)];
      var $239=$238;
      var $240=$34;
      HEAP32[(($34)>>2)]=$239;
      var $241=HEAP32[(($34)>>2)];
      var $242=(($241)|0);
      var $243=$34;
      var $244=$35;
      var $245=(($242)|0);
      var $246=$245;
      var $247=(($246)|0);
      HEAP32[(($247)>>2)]=$235;
      var $248=$36;
      var $249=$37;
      var $250=$__sz;
      var $251=$40;
      var $252=$41;
      HEAP32[(($40)>>2)]=$56;
      HEAP32[(($41)>>2)]=$250;
      var $253=HEAP32[(($40)>>2)];
      var $254=HEAP32[(($41)>>2)];
      var $255=(($253)|0);
      var $256=$39;
      HEAP32[(($39)>>2)]=$255;
      var $257=HEAP32[(($39)>>2)];
      var $258=$257;
      var $259=$38;
      HEAP32[(($38)>>2)]=$258;
      var $260=HEAP32[(($38)>>2)];
      var $261=(($260)|0);
      var $262=$38;
      var $263=$39;
      var $264=(($261)|0);
      var $265=$264;
      var $266=(($265+4)|0);
      HEAP32[(($266)>>2)]=$254;
      var $267=$40;
      var $268=$41;
      __label__ = 8; break;
    case 8: // $269
      __label__ = 9; break;
    case 9: // $270
      var $271=$53;
      var $272=$54;
      var $273=(($271)|0)!=(($272)|0);
      if ($273) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $274
      var $275=$__p;
      var $276=$53;
      var $277=$42;
      var $278=$43;
      HEAP32[(($42)>>2)]=$275;
      HEAP32[(($43)>>2)]=$276;
      var $279=HEAP32[(($43)>>2)];
      var $280=HEAP8[($279)];
      var $281=HEAP32[(($42)>>2)];
      HEAP8[($281)]=$280;
      var $282=$42;
      var $283=$43;
      __label__ = 11; break;
    case 11: // $284
      var $285=$53;
      var $286=(($285+1)|0);
      $53=$286;
      var $287=$__p;
      var $288=(($287+1)|0);
      $__p=$288;
      __label__ = 9; break;
    case 12: // $289
      var $290=$__p;
      HEAP8[($55)]=0;
      var $291=$44;
      var $292=$45;
      HEAP32[(($44)>>2)]=$290;
      HEAP32[(($45)>>2)]=$55;
      var $293=HEAP32[(($45)>>2)];
      var $294=HEAP8[($293)];
      var $295=HEAP32[(($44)>>2)];
      HEAP8[($295)]=$294;
      var $296=$44;
      var $297=$45;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_["X"]=1;

function __ZNSt3__117__call_once_proxyINS_12_GLOBAL__N_111__fake_bindEEEvPv($__vp) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  var $__p;
  $2=$__vp;
  var $3=$2;
  var $4=$3;
  $__p=$4;
  var $5=$__p;
  var $6=$1;
  HEAP32[(($1)>>2)]=$5;
  var $7=HEAP32[(($1)>>2)];
  var $8=(($7)|0);
  __ZNKSt3__112_GLOBAL__N_111__fake_bindclEv($8);
  var $9=$1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNKSt3__112_GLOBAL__N_111__fake_bindclEv($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$this;
      var $2=$1;
      var $3=(($2+4)|0);
      var $4={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
      var $5=(($2)|0);
      var $6=HEAP32[(($5)>>2)];
      var $7=$4.f1;
      var $8=$6;
      var $9=(($8+$7)|0);
      var $10=$9;
      var $11=$4.f0;
      var $12=$11 & 1;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$10;
      var $16=HEAP32[(($15)>>2)];
      var $17=(($11-1)|0);
      var $18=(($16+$17)|0);
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $24 = $20;__label__ = 3; break;
    case 2: // $21
      var $22=$11;
      var $24 = $22;__label__ = 3; break;
    case 3: // $23
      var $24;
      FUNCTION_TABLE[$24]($10);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__117__call_once_paramINS_12_GLOBAL__N_111__fake_bindEEC2ERKS2_($this, $__f) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$__f;
  var $3=$1;
  var $4=(($3)|0);
  var $5=$2;
  var $6=$4;
  var $7=$5;
  assert(12 % 1 === 0, 'memcpy given ' + 12 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($6)>>2)]=HEAP32[(($7)>>2)];HEAP32[(($6+4)>>2)]=HEAP32[(($7+4)>>2)];HEAP32[(($6+8)>>2)]=HEAP32[(($7+8)>>2)];
  ;
  return;
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj($this, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 132; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $__ms_i=__stackBase__+72;
      var $__cap_i=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $22=__stackBase__+92;
      var $23=__stackBase__+96;
      var $24=__stackBase__+100;
      var $25=__stackBase__+104;
      var $26=__stackBase__+108;
      var $27;
      var $28;
      var $__a;
      var $__v=__stackBase__+112;
      var $29;
      var $30;
      $27=$this;
      $28=$__n;
      var $31=$27;
      var $32=$31;
      var $33=$26;
      HEAP32[(($26)>>2)]=$32;
      var $34=HEAP32[(($26)>>2)];
      var $35=(($34+8)|0);
      var $36=$25;
      HEAP32[(($25)>>2)]=$35;
      var $37=HEAP32[(($25)>>2)];
      var $38=$37;
      var $39=$24;
      HEAP32[(($24)>>2)]=$38;
      var $40=HEAP32[(($24)>>2)];
      var $41=(($40)|0);
      var $42=$24;
      var $43=$25;
      var $44=$26;
      var $45=HEAP32[(($41)>>2)];
      var $46=$31;
      var $47=(($46+4)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$45;
      var $50=$48;
      var $51=(($49-$50)|0);
      var $52=(((($51)|0)/4)|0);
      var $53=$28;
      var $54=(($52)>>>0) >= (($53)>>>0);
      if ($54) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $55
      var $56=$28;
      __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj($31, $56);
      __label__ = 15; break;
    case 2: // $57
      var $58=$31;
      var $59=$23;
      HEAP32[(($23)>>2)]=$58;
      var $60=HEAP32[(($23)>>2)];
      var $61=(($60+8)|0);
      var $62=$22;
      HEAP32[(($22)>>2)]=$61;
      var $63=HEAP32[(($22)>>2)];
      var $64=$63;
      var $65=$21;
      HEAP32[(($21)>>2)]=$64;
      var $66=HEAP32[(($21)>>2)];
      var $67=(($66+4)|0);
      var $68=$21;
      var $69=$22;
      var $70=$23;
      $__a=$67;
      var $71=$20;
      HEAP32[(($20)>>2)]=$31;
      var $72=HEAP32[(($20)>>2)];
      var $73=$72;
      var $74=(($73+4)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=$72;
      var $77=(($76)|0);
      var $78=HEAP32[(($77)>>2)];
      var $79=$75;
      var $80=$78;
      var $81=(($79-$80)|0);
      var $82=(((($81)|0)/4)|0);
      var $83=$20;
      var $84=$28;
      var $85=(($82+$84)|0);
      var $86=$16;
      var $87=$17;
      var $88=$18;
      var $89=$__ms_i;
      var $90=$__cap_i;
      var $91=$19;
      HEAP32[(($17)>>2)]=$31;
      HEAP32[(($18)>>2)]=$85;
      var $92=HEAPU32[(($17)>>2)];
      var $93=__ZNKSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8max_sizeEv($92);
      HEAP32[(($__ms_i)>>2)]=$93;
      var $94=HEAPU32[(($18)>>2)];
      var $95=HEAPU32[(($__ms_i)>>2)];
      var $96=(($94)>>>0) > (($95)>>>0);
      if ($96) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $97
      var $98=$92;
      __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv($98);
      __label__ = 4; break;
    case 4: // $99
      var $100=$15;
      HEAP32[(($15)>>2)]=$92;
      var $101=HEAP32[(($15)>>2)];
      var $102=$101;
      var $103=$14;
      HEAP32[(($14)>>2)]=$102;
      var $104=HEAPU32[(($14)>>2)];
      var $105=$13;
      HEAP32[(($13)>>2)]=$104;
      var $106=HEAP32[(($13)>>2)];
      var $107=(($106+8)|0);
      var $108=$12;
      HEAP32[(($12)>>2)]=$107;
      var $109=HEAP32[(($12)>>2)];
      var $110=$109;
      var $111=$11;
      HEAP32[(($11)>>2)]=$110;
      var $112=HEAP32[(($11)>>2)];
      var $113=(($112)|0);
      var $114=$11;
      var $115=$12;
      var $116=$13;
      var $117=HEAP32[(($113)>>2)];
      var $118=(($104)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=$117;
      var $121=$119;
      var $122=(($120-$121)|0);
      var $123=(((($122)|0)/4)|0);
      var $124=$14;
      var $125=$15;
      HEAP32[(($__cap_i)>>2)]=$123;
      var $126=HEAPU32[(($__cap_i)>>2)];
      var $127=HEAPU32[(($__ms_i)>>2)];
      var $128=Math.floor((($127)>>>0)/2);
      var $129=(($126)>>>0) >= (($128)>>>0);
      if ($129) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $130
      var $131=HEAP32[(($__ms_i)>>2)];
      HEAP32[(($16)>>2)]=$131;
      __label__ = 10; break;
    case 6: // $132
      var $133=HEAP32[(($__cap_i)>>2)];
      var $134=((($133<<1))|0);
      HEAP32[(($19)>>2)]=$134;
      var $135=$7;
      var $136=$8;
      var $137=$9;
      var $138=$10;
      HEAP32[(($8)>>2)]=$19;
      HEAP32[(($9)>>2)]=$18;
      var $139=HEAP32[(($8)>>2)];
      var $140=HEAP32[(($9)>>2)];
      var $tmp_i_i=$7;
      var $tmp1_i_i=$10;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $141=$5;
      var $142=$6;
      HEAP32[(($5)>>2)]=$139;
      HEAP32[(($6)>>2)]=$140;
      var $143=HEAP32[(($5)>>2)];
      var $144=HEAP32[(($6)>>2)];
      var $145=$2;
      var $146=$3;
      var $147=$4;
      HEAP32[(($2)>>2)]=$7;
      HEAP32[(($3)>>2)]=$143;
      HEAP32[(($4)>>2)]=$144;
      var $148=HEAP32[(($2)>>2)];
      var $149=HEAP32[(($3)>>2)];
      var $150=HEAPU32[(($149)>>2)];
      var $151=HEAP32[(($4)>>2)];
      var $152=HEAPU32[(($151)>>2)];
      var $153=(($150)>>>0) < (($152)>>>0);
      var $154=$2;
      var $155=$3;
      var $156=$4;
      if ($153) { __label__ = 7; break; } else { __label__ = 8; break; }
    case 7: // $157
      var $158=HEAP32[(($6)>>2)];
      var $161 = $158;__label__ = 9; break;
    case 8: // $159
      var $160=HEAP32[(($5)>>2)];
      var $161 = $160;__label__ = 9; break;
    case 9: // $_ZNSt3__13maxIjEERKT_S3_S3__exit_i
      var $161;
      var $162=$5;
      var $163=$6;
      var $164=$7;
      var $165=$8;
      var $166=$9;
      var $167=$10;
      var $168=HEAP32[(($161)>>2)];
      HEAP32[(($16)>>2)]=$168;
      __label__ = 10; break;
    case 10: // $_ZNKSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE11__recommendEj_exit
      var $169=HEAP32[(($16)>>2)];
      var $170=$16;
      var $171=$17;
      var $172=$18;
      var $173=$__ms_i;
      var $174=$__cap_i;
      var $175=$19;
      var $176=$1;
      HEAP32[(($1)>>2)]=$31;
      var $177=HEAP32[(($1)>>2)];
      var $178=$177;
      var $179=(($178+4)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=$177;
      var $182=(($181)|0);
      var $183=HEAP32[(($182)>>2)];
      var $184=$180;
      var $185=$183;
      var $186=(($184-$185)|0);
      var $187=(((($186)|0)/4)|0);
      var $188=$1;
      var $189=$__a;
      __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC1EjjS6_($__v, $169, $187, $189);
      var $190=$28;
      (function() { try { __THREW__ = false; return __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj($__v, $190) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 11; break; } else { __label__ = 13; break; }
    case 11: // $191
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE($31, $__v) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $192
      __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED1Ev($__v);
      __label__ = 15; break;
    case 13: // $193
      var $194=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $195=$194.f0;
      $29=$195;
      var $196=$194.f1;
      $30=$196;
      (function() { try { __THREW__ = false; return __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED1Ev($__v) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 17; break; }
    case 14: // $197
      __label__ = 16; break;
    case 15: // $198
      STACKTOP = __stackBase__;
      return;
    case 16: // $199
      var $200=$29;
      var $201=$29;
      var $202=$30;
      var $203=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $201, tempValue);
      var $204=($203.f1 = $202, $203);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 17: // $205
      var $206=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj["X"]=1;

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj($this, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $__a;
      $7=$this;
      $8=$__n;
      var $9=$7;
      var $10=$9;
      var $11=$6;
      HEAP32[(($6)>>2)]=$10;
      var $12=HEAP32[(($6)>>2)];
      var $13=(($12+8)|0);
      var $14=$5;
      HEAP32[(($5)>>2)]=$13;
      var $15=HEAP32[(($5)>>2)];
      var $16=$15;
      var $17=$4;
      HEAP32[(($4)>>2)]=$16;
      var $18=HEAP32[(($4)>>2)];
      var $19=(($18+4)|0);
      var $20=$4;
      var $21=$5;
      var $22=$6;
      $__a=$19;
      __label__ = 1; break;
    case 1: // $23
      var $24=$__a;
      var $25=$9;
      var $26=(($25+4)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=$1;
      HEAP32[(($1)>>2)]=$27;
      var $29=HEAP32[(($1)>>2)];
      var $30=$1;
      var $31=$2;
      var $32=$3;
      HEAP32[(($2)>>2)]=$24;
      HEAP32[(($3)>>2)]=$29;
      var $33=HEAP32[(($3)>>2)];
      var $34=$33;
      var $35=(($34)|0)==0;
      if ($35) { var $38 = 0;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $36
      var $37=$34;
      HEAP32[(($37)>>2)]=0;
      var $38 = $37;__label__ = 3; break;
    case 3: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE9constructIS4_EEvRS5_PT__exit
      var $38;
      var $39=$2;
      var $40=$3;
      var $41=$9;
      var $42=(($41+4)|0);
      var $43=HEAP32[(($42)>>2)];
      var $44=(($43+4)|0);
      HEAP32[(($42)>>2)]=$44;
      var $45=$8;
      var $46=(($45-1)|0);
      $8=$46;
      __label__ = 4; break;
    case 4: // $47
      var $48=$8;
      var $49=(($48)>>>0) > 0;
      if ($49) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 5: // $50
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj["X"]=1;

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj($this, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 24; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7;
      var $8;
      var $__a;
      $7=$this;
      $8=$__n;
      var $9=$7;
      var $10=$6;
      HEAP32[(($6)>>2)]=$9;
      var $11=HEAP32[(($6)>>2)];
      var $12=(($11+12)|0);
      var $13=$5;
      HEAP32[(($5)>>2)]=$12;
      var $14=HEAP32[(($5)>>2)];
      var $15=$14;
      var $16=$4;
      HEAP32[(($4)>>2)]=$15;
      var $17=HEAP32[(($4)>>2)];
      var $18=(($17+4)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=$4;
      var $21=$5;
      var $22=$6;
      $__a=$19;
      __label__ = 1; break;
    case 1: // $23
      var $24=$__a;
      var $25=(($9+8)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=$1;
      HEAP32[(($1)>>2)]=$26;
      var $28=HEAP32[(($1)>>2)];
      var $29=$1;
      var $30=$2;
      var $31=$3;
      HEAP32[(($2)>>2)]=$24;
      HEAP32[(($3)>>2)]=$28;
      var $32=HEAP32[(($3)>>2)];
      var $33=$32;
      var $34=(($33)|0)==0;
      if ($34) { var $37 = 0;__label__ = 3; break; } else { __label__ = 2; break; }
    case 2: // $35
      var $36=$33;
      HEAP32[(($36)>>2)]=0;
      var $37 = $36;__label__ = 3; break;
    case 3: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE9constructIS4_EEvRS5_PT__exit
      var $37;
      var $38=$2;
      var $39=$3;
      var $40=(($9+8)|0);
      var $41=HEAP32[(($40)>>2)];
      var $42=(($41+4)|0);
      HEAP32[(($40)>>2)]=$42;
      var $43=$8;
      var $44=(($43-1)|0);
      $8=$44;
      __label__ = 4; break;
    case 4: // $45
      var $46=$8;
      var $47=(($46)>>>0) > 0;
      if ($47) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 5: // $48
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj["X"]=1;

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC1EjjS6_($this, $__cap, $__start, $__a) {
  ;
  var __label__;

  var $1;
  var $2;
  var $3;
  var $4;
  $1=$this;
  $2=$__cap;
  $3=$__start;
  $4=$__a;
  var $5=$1;
  var $6=$2;
  var $7=$3;
  var $8=$4;
  __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_($5, $6, $7, $8);
  ;
  return;
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE($this, $__v) {
  var __stackBase__  = STACKTOP; STACKTOP += 116; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $__t_i2=__stackBase__+20;
      var $6=__stackBase__+24;
      var $7=__stackBase__+28;
      var $8=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $__t_i1=__stackBase__+44;
      var $11=__stackBase__+48;
      var $12=__stackBase__+52;
      var $13=__stackBase__+56;
      var $14=__stackBase__+60;
      var $15=__stackBase__+64;
      var $16=__stackBase__+68;
      var $17=__stackBase__+72;
      var $18=__stackBase__+76;
      var $19=__stackBase__+80;
      var $20=__stackBase__+84;
      var $21=__stackBase__+88;
      var $__t_i=__stackBase__+92;
      var $22=__stackBase__+96;
      var $23=__stackBase__+100;
      var $24=__stackBase__+104;
      var $25=__stackBase__+108;
      var $26=__stackBase__+112;
      var $27;
      var $28;
      var $__p;
      $27=$this;
      $28=$__v;
      var $29=$27;
      var $30=$29;
      var $31=(($30+4)|0);
      var $32=HEAP32[(($31)>>2)];
      $__p=$32;
      __label__ = 1; break;
    case 1: // $33
      var $34=$29;
      var $35=(($34)|0);
      var $36=HEAPU32[(($35)>>2)];
      var $37=$__p;
      var $38=(($36)>>>0) < (($37)>>>0);
      if ($38) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $39
      var $40=$28;
      var $41=$__p;
      var $42=(($41-4)|0);
      $__p=$42;
      var $43=$24;
      var $44=$25;
      var $45=$26;
      HEAP32[(($24)>>2)]=$42;
      var $46=HEAP32[(($24)>>2)];
      var $47=$23;
      HEAP32[(($23)>>2)]=$46;
      var $48=HEAP32[(($23)>>2)];
      var $49=$23;
      var $50=$24;
      var $51=$25;
      var $52=$26;
      __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE10push_frontERKS3_($40, $48);
      __label__ = 1; break;
    case 3: // $53
      var $54=$29;
      var $55=(($54)|0);
      var $56=$28;
      var $57=(($56+4)|0);
      var $58=$4;
      var $59=$5;
      var $60=$__t_i2;
      HEAP32[(($4)>>2)]=$55;
      HEAP32[(($5)>>2)]=$57;
      var $61=HEAP32[(($4)>>2)];
      var $62=$3;
      HEAP32[(($3)>>2)]=$61;
      var $63=HEAP32[(($3)>>2)];
      var $64=$3;
      var $65=HEAP32[(($63)>>2)];
      HEAP32[(($__t_i2)>>2)]=$65;
      var $66=HEAP32[(($5)>>2)];
      var $67=$1;
      HEAP32[(($1)>>2)]=$66;
      var $68=HEAP32[(($1)>>2)];
      var $69=$1;
      var $70=HEAP32[(($68)>>2)];
      var $71=HEAP32[(($4)>>2)];
      HEAP32[(($71)>>2)]=$70;
      var $72=$2;
      HEAP32[(($2)>>2)]=$__t_i2;
      var $73=HEAP32[(($2)>>2)];
      var $74=$2;
      var $75=HEAP32[(($73)>>2)];
      var $76=HEAP32[(($5)>>2)];
      HEAP32[(($76)>>2)]=$75;
      var $77=$4;
      var $78=$5;
      var $79=$__t_i2;
      var $80=$29;
      var $81=(($80+4)|0);
      var $82=$28;
      var $83=(($82+8)|0);
      var $84=$9;
      var $85=$10;
      var $86=$__t_i1;
      HEAP32[(($9)>>2)]=$81;
      HEAP32[(($10)>>2)]=$83;
      var $87=HEAP32[(($9)>>2)];
      var $88=$8;
      HEAP32[(($8)>>2)]=$87;
      var $89=HEAP32[(($8)>>2)];
      var $90=$8;
      var $91=HEAP32[(($89)>>2)];
      HEAP32[(($__t_i1)>>2)]=$91;
      var $92=HEAP32[(($10)>>2)];
      var $93=$6;
      HEAP32[(($6)>>2)]=$92;
      var $94=HEAP32[(($6)>>2)];
      var $95=$6;
      var $96=HEAP32[(($94)>>2)];
      var $97=HEAP32[(($9)>>2)];
      HEAP32[(($97)>>2)]=$96;
      var $98=$7;
      HEAP32[(($7)>>2)]=$__t_i1;
      var $99=HEAP32[(($7)>>2)];
      var $100=$7;
      var $101=HEAP32[(($99)>>2)];
      var $102=HEAP32[(($10)>>2)];
      HEAP32[(($102)>>2)]=$101;
      var $103=$9;
      var $104=$10;
      var $105=$__t_i1;
      var $106=$29;
      var $107=$13;
      HEAP32[(($13)>>2)]=$106;
      var $108=HEAP32[(($13)>>2)];
      var $109=(($108+8)|0);
      var $110=$12;
      HEAP32[(($12)>>2)]=$109;
      var $111=HEAP32[(($12)>>2)];
      var $112=$111;
      var $113=$11;
      HEAP32[(($11)>>2)]=$112;
      var $114=HEAP32[(($11)>>2)];
      var $115=(($114)|0);
      var $116=$11;
      var $117=$12;
      var $118=$13;
      var $119=$28;
      var $120=$16;
      HEAP32[(($16)>>2)]=$119;
      var $121=HEAP32[(($16)>>2)];
      var $122=(($121+12)|0);
      var $123=$15;
      HEAP32[(($15)>>2)]=$122;
      var $124=HEAP32[(($15)>>2)];
      var $125=$124;
      var $126=$14;
      HEAP32[(($14)>>2)]=$125;
      var $127=HEAP32[(($14)>>2)];
      var $128=(($127)|0);
      var $129=$14;
      var $130=$15;
      var $131=$16;
      var $132=$20;
      var $133=$21;
      var $134=$__t_i;
      HEAP32[(($20)>>2)]=$115;
      HEAP32[(($21)>>2)]=$128;
      var $135=HEAP32[(($20)>>2)];
      var $136=$19;
      HEAP32[(($19)>>2)]=$135;
      var $137=HEAP32[(($19)>>2)];
      var $138=$19;
      var $139=HEAP32[(($137)>>2)];
      HEAP32[(($__t_i)>>2)]=$139;
      var $140=HEAP32[(($21)>>2)];
      var $141=$17;
      HEAP32[(($17)>>2)]=$140;
      var $142=HEAP32[(($17)>>2)];
      var $143=$17;
      var $144=HEAP32[(($142)>>2)];
      var $145=HEAP32[(($20)>>2)];
      HEAP32[(($145)>>2)]=$144;
      var $146=$18;
      HEAP32[(($18)>>2)]=$__t_i;
      var $147=HEAP32[(($18)>>2)];
      var $148=$18;
      var $149=HEAP32[(($147)>>2)];
      var $150=HEAP32[(($21)>>2)];
      HEAP32[(($150)>>2)]=$149;
      var $151=$20;
      var $152=$21;
      var $153=$__t_i;
      var $154=$28;
      var $155=(($154+4)|0);
      var $156=HEAP32[(($155)>>2)];
      var $157=$28;
      var $158=(($157)|0);
      HEAP32[(($158)>>2)]=$156;
      var $159=$22;
      HEAP32[(($22)>>2)]=$29;
      var $160=HEAP32[(($22)>>2)];
      var $161=$22;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE["X"]=1;

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED1Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev($2);
  ;
  return;
}


function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24;
      $24=$this;
      var $25=$24;
      var $26=$23;
      HEAP32[(($23)>>2)]=$25;
      var $27=HEAP32[(($23)>>2)];
      var $28=(($27+4)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$18;
      var $31=$19;
      var $32=$20;
      var $33=$21;
      var $34=$22;
      HEAP32[(($19)>>2)]=$27;
      HEAP32[(($20)>>2)]=$29;
      var $35=HEAP32[(($19)>>2)];
      var $36=HEAP32[(($20)>>2)];
      var $37=$22;
      var $tmp_i_i=$18;
      var $tmp1_i_i=$21;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $38=$16;
      var $39=$17;
      HEAP32[(($16)>>2)]=$35;
      HEAP32[(($17)>>2)]=$36;
      var $40=HEAP32[(($16)>>2)];
      var $41=HEAP32[(($17)>>2)];
      var $42=(($40+8)|0);
      HEAP32[(($42)>>2)]=$41;
      var $43=$16;
      var $44=$17;
      var $45=$18;
      var $46=$19;
      var $47=$20;
      var $48=$21;
      var $49=$22;
      var $50=$23;
      var $51=(($25)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)!=0;
      if ($53) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $54
      var $55=$7;
      HEAP32[(($7)>>2)]=$25;
      var $56=HEAP32[(($7)>>2)];
      var $57=(($56+12)|0);
      var $58=$6;
      HEAP32[(($6)>>2)]=$57;
      var $59=HEAP32[(($6)>>2)];
      var $60=$59;
      var $61=$5;
      HEAP32[(($5)>>2)]=$60;
      var $62=HEAP32[(($5)>>2)];
      var $63=(($62+4)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=$5;
      var $66=$6;
      var $67=$7;
      var $68=(($25)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$4;
      HEAP32[(($4)>>2)]=$25;
      var $71=HEAP32[(($4)>>2)];
      var $72=$3;
      HEAP32[(($3)>>2)]=$71;
      var $73=HEAP32[(($3)>>2)];
      var $74=(($73+12)|0);
      var $75=$2;
      HEAP32[(($2)>>2)]=$74;
      var $76=HEAP32[(($2)>>2)];
      var $77=$76;
      var $78=$1;
      HEAP32[(($1)>>2)]=$77;
      var $79=HEAP32[(($1)>>2)];
      var $80=(($79)|0);
      var $81=$1;
      var $82=$2;
      var $83=$3;
      var $84=HEAP32[(($80)>>2)];
      var $85=(($71)|0);
      var $86=HEAP32[(($85)>>2)];
      var $87=$84;
      var $88=$86;
      var $89=(($87-$88)|0);
      var $90=(((($89)|0)/4)|0);
      var $91=$4;
      var $92=$11;
      var $93=$12;
      var $94=$13;
      var $95=$14;
      var $96=$15;
      HEAP32[(($11)>>2)]=$64;
      HEAP32[(($12)>>2)]=$69;
      HEAP32[(($13)>>2)]=$90;
      var $97=HEAP32[(($11)>>2)];
      var $98=HEAP32[(($12)>>2)];
      var $99=HEAP32[(($13)>>2)];
      var $100=$8;
      var $101=$9;
      var $102=$10;
      HEAP32[(($8)>>2)]=$97;
      HEAP32[(($9)>>2)]=$98;
      HEAP32[(($10)>>2)]=$99;
      var $103=HEAP32[(($8)>>2)];
      var $104=HEAP32[(($9)>>2)];
      var $105=(($103)|0);
      var $106=$105;
      var $107=(($104)|0)==(($106)|0);
      if ($107) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $108
      var $109=(($103+112)|0);
      HEAP8[($109)]=0;
      __label__ = 4; break;
    case 3: // $110
      var $111=HEAP32[(($9)>>2)];
      var $112=$111;
      __ZdlPv($112);
      __label__ = 4; break;
    case 4: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE10deallocateERS5_PS4_j_exit
      var $113=$8;
      var $114=$9;
      var $115=$10;
      var $116=$11;
      var $117=$12;
      var $118=$13;
      var $119=$14;
      var $120=$15;
      __label__ = 5; break;
    case 5: // $121
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev["X"]=1;

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endINS_13move_iteratorIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESD_SD_($this, $__first, $__last) {
  var __stackBase__  = STACKTOP; STACKTOP += 52; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $__first; $__first = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__first)>>2)]=HEAP32[((tempParam)>>2)];
  var tempParam = $__last; $__last = STACKTOP;STACKTOP += 4;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($__last)>>2)]=HEAP32[((tempParam)>>2)];
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14;
      var $__a;
      $14=$this;
      var $15=$14;
      var $16=$13;
      HEAP32[(($13)>>2)]=$15;
      var $17=HEAP32[(($13)>>2)];
      var $18=(($17+12)|0);
      var $19=$12;
      HEAP32[(($12)>>2)]=$18;
      var $20=HEAP32[(($12)>>2)];
      var $21=$20;
      var $22=$11;
      HEAP32[(($11)>>2)]=$21;
      var $23=HEAP32[(($11)>>2)];
      var $24=(($23+4)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$11;
      var $27=$12;
      var $28=$13;
      $__a=$25;
      __label__ = 1; break;
    case 1: // $29
      var $30=$3;
      var $31=$4;
      HEAP32[(($3)>>2)]=$__first;
      HEAP32[(($4)>>2)]=$__last;
      var $32=HEAP32[(($3)>>2)];
      var $33=$2;
      HEAP32[(($2)>>2)]=$32;
      var $34=HEAP32[(($2)>>2)];
      var $35=(($34)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$2;
      var $38=HEAP32[(($4)>>2)];
      var $39=$1;
      HEAP32[(($1)>>2)]=$38;
      var $40=HEAP32[(($1)>>2)];
      var $41=(($40)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$1;
      var $44=(($36)|0)!=(($42)|0);
      var $45=$3;
      var $46=$4;
      if ($44) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $47
      var $48=$__a;
      var $49=(($15+8)|0);
      var $50=HEAP32[(($49)>>2)];
      var $51=$5;
      HEAP32[(($5)>>2)]=$50;
      var $52=HEAP32[(($5)>>2)];
      var $53=$5;
      var $54=$6;
      HEAP32[(($6)>>2)]=$__first;
      var $55=HEAP32[(($6)>>2)];
      var $56=(($55)|0);
      var $57=HEAP32[(($56)>>2)];
      var $58=$6;
      var $59=$7;
      var $60=$8;
      var $61=$9;
      HEAP32[(($7)>>2)]=$48;
      HEAP32[(($8)>>2)]=$52;
      HEAP32[(($9)>>2)]=$57;
      var $62=HEAP32[(($8)>>2)];
      var $63=$62;
      var $64=(($63)|0)==0;
      if ($64) { var $69 = 0;__label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $65
      var $66=$63;
      var $67=HEAP32[(($9)>>2)];
      var $68=HEAP32[(($67)>>2)];
      HEAP32[(($66)>>2)]=$68;
      var $69 = $66;__label__ = 4; break;
    case 4: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE9constructIS4_S4_EEvRS5_PT_RKT0__exit
      var $69;
      var $70=$7;
      var $71=$8;
      var $72=$9;
      var $73=(($15+8)|0);
      var $74=HEAP32[(($73)>>2)];
      var $75=(($74+4)|0);
      HEAP32[(($73)>>2)]=$75;
      __label__ = 5; break;
    case 5: // $76
      var $77=$10;
      HEAP32[(($10)>>2)]=$__first;
      var $78=HEAP32[(($10)>>2)];
      var $79=(($78)|0);
      var $80=HEAP32[(($79)>>2)];
      var $81=(($80+4)|0);
      HEAP32[(($79)>>2)]=$81;
      var $82=$10;
      __label__ = 1; break;
    case 6: // $83
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endINS_13move_iteratorIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESD_SD_["X"]=1;

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE10push_frontERKS3_($this, $__x) {
  var __stackBase__  = STACKTOP; STACKTOP += 340; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $__t_i3=__stackBase__+112;
      var $29=__stackBase__+116;
      var $30=__stackBase__+120;
      var $31=__stackBase__+124;
      var $32=__stackBase__+128;
      var $33=__stackBase__+132;
      var $__t_i2=__stackBase__+136;
      var $34=__stackBase__+140;
      var $35=__stackBase__+144;
      var $36=__stackBase__+148;
      var $37=__stackBase__+152;
      var $38=__stackBase__+156;
      var $__t_i1=__stackBase__+160;
      var $39=__stackBase__+164;
      var $40=__stackBase__+168;
      var $41=__stackBase__+172;
      var $42=__stackBase__+176;
      var $43=__stackBase__+180;
      var $44=__stackBase__+184;
      var $45=__stackBase__+188;
      var $46=__stackBase__+192;
      var $47=__stackBase__+196;
      var $48=__stackBase__+200;
      var $49=__stackBase__+204;
      var $__t_i=__stackBase__+208;
      var $50=__stackBase__+212;
      var $51=__stackBase__+216;
      var $52=__stackBase__+220;
      var $53=__stackBase__+224;
      var $54=__stackBase__+228;
      var $__n_i_i=__stackBase__+232;
      var $55=__stackBase__+236;
      var $56=__stackBase__+240;
      var $57=__stackBase__+244;
      var $58=__stackBase__+248;
      var $59=__stackBase__+252;
      var $60=__stackBase__+256;
      var $61=__stackBase__+260;
      var $62=__stackBase__+264;
      var $63=__stackBase__+268;
      var $64=__stackBase__+272;
      var $65=__stackBase__+276;
      var $66=__stackBase__+280;
      var $67=__stackBase__+284;
      var $68=__stackBase__+288;
      var $69=__stackBase__+292;
      var $70=__stackBase__+296;
      var $71=__stackBase__+300;
      var $72;
      var $73;
      var $__d;
      var $__c;
      var $74=__stackBase__+304;
      var $75=__stackBase__+308;
      var $__t=__stackBase__+312;
      var $76=__stackBase__+332;
      var $77;
      var $78;
      var $79=__stackBase__+336;
      $72=$this;
      $73=$__x;
      var $80=$72;
      var $81=(($80+4)|0);
      var $82=HEAP32[(($81)>>2)];
      var $83=(($80)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($82)|0)==(($84)|0);
      if ($85) { __label__ = 1; break; } else { __label__ = 17; break; }
    case 1: // $86
      var $87=(($80+8)|0);
      var $88=HEAPU32[(($87)>>2)];
      var $89=$71;
      HEAP32[(($71)>>2)]=$80;
      var $90=HEAP32[(($71)>>2)];
      var $91=(($90+12)|0);
      var $92=$70;
      HEAP32[(($70)>>2)]=$91;
      var $93=HEAP32[(($70)>>2)];
      var $94=$93;
      var $95=$69;
      HEAP32[(($69)>>2)]=$94;
      var $96=HEAP32[(($69)>>2)];
      var $97=(($96)|0);
      var $98=$69;
      var $99=$70;
      var $100=$71;
      var $101=HEAPU32[(($97)>>2)];
      var $102=(($88)>>>0) < (($101)>>>0);
      if ($102) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $103
      var $104=$61;
      HEAP32[(($61)>>2)]=$80;
      var $105=HEAP32[(($61)>>2)];
      var $106=(($105+12)|0);
      var $107=$60;
      HEAP32[(($60)>>2)]=$106;
      var $108=HEAP32[(($60)>>2)];
      var $109=$108;
      var $110=$59;
      HEAP32[(($59)>>2)]=$109;
      var $111=HEAP32[(($59)>>2)];
      var $112=(($111)|0);
      var $113=$59;
      var $114=$60;
      var $115=$61;
      var $116=HEAP32[(($112)>>2)];
      var $117=(($80+8)|0);
      var $118=HEAP32[(($117)>>2)];
      var $119=$116;
      var $120=$118;
      var $121=(($119-$120)|0);
      var $122=(((($121)|0)/4)|0);
      $__d=$122;
      var $123=$__d;
      var $124=(($123+1)|0);
      var $125=(((($124)|0)/2)|0);
      $__d=$125;
      var $126=(($80+4)|0);
      var $127=HEAP32[(($126)>>2)];
      var $128=(($80+8)|0);
      var $129=HEAP32[(($128)>>2)];
      var $130=(($80+8)|0);
      var $131=HEAP32[(($130)>>2)];
      var $132=$__d;
      var $133=(($131+($132<<2))|0);
      var $134=$56;
      var $135=$57;
      var $136=$58;
      HEAP32[(($56)>>2)]=$127;
      HEAP32[(($57)>>2)]=$129;
      HEAP32[(($58)>>2)]=$133;
      var $137=HEAP32[(($56)>>2)];
      var $138=$55;
      HEAP32[(($55)>>2)]=$137;
      var $139=HEAP32[(($55)>>2)];
      var $140=$55;
      var $141=HEAP32[(($57)>>2)];
      var $142=$50;
      HEAP32[(($50)>>2)]=$141;
      var $143=HEAP32[(($50)>>2)];
      var $144=$50;
      var $145=HEAP32[(($58)>>2)];
      var $146=$51;
      HEAP32[(($51)>>2)]=$145;
      var $147=HEAP32[(($51)>>2)];
      var $148=$51;
      var $149=$52;
      var $150=$53;
      var $151=$54;
      var $152=$__n_i_i;
      HEAP32[(($52)>>2)]=$139;
      HEAP32[(($53)>>2)]=$143;
      HEAP32[(($54)>>2)]=$147;
      var $153=HEAP32[(($53)>>2)];
      var $154=HEAP32[(($52)>>2)];
      var $155=$153;
      var $156=$154;
      var $157=(($155-$156)|0);
      var $158=(((($157)|0)/4)|0);
      HEAP32[(($__n_i_i)>>2)]=$158;
      var $159=HEAP32[(($__n_i_i)>>2)];
      var $160=HEAP32[(($54)>>2)];
      var $161=(((-$159))|0);
      var $162=(($160+($161<<2))|0);
      HEAP32[(($54)>>2)]=$162;
      var $163=HEAP32[(($54)>>2)];
      var $164=$163;
      var $165=HEAP32[(($52)>>2)];
      var $166=$165;
      var $167=HEAP32[(($__n_i_i)>>2)];
      var $168=((($167<<2))|0);
      _llvm_memmove_p0i8_p0i8_i32($164, $166, $168, 1, 0);
      var $169=HEAP32[(($54)>>2)];
      var $170=$52;
      var $171=$53;
      var $172=$54;
      var $173=$__n_i_i;
      var $174=$56;
      var $175=$57;
      var $176=$58;
      var $177=(($80+4)|0);
      HEAP32[(($177)>>2)]=$169;
      var $178=$__d;
      var $179=(($80+8)|0);
      var $180=HEAP32[(($179)>>2)];
      var $181=(($180+($178<<2))|0);
      HEAP32[(($179)>>2)]=$181;
      __label__ = 16; break;
    case 3: // $182
      var $183=$23;
      HEAP32[(($23)>>2)]=$80;
      var $184=HEAP32[(($23)>>2)];
      var $185=(($184+12)|0);
      var $186=$22;
      HEAP32[(($22)>>2)]=$185;
      var $187=HEAP32[(($22)>>2)];
      var $188=$187;
      var $189=$21;
      HEAP32[(($21)>>2)]=$188;
      var $190=HEAP32[(($21)>>2)];
      var $191=(($190)|0);
      var $192=$21;
      var $193=$22;
      var $194=$23;
      var $195=HEAP32[(($191)>>2)];
      var $196=(($80)|0);
      var $197=HEAP32[(($196)>>2)];
      var $198=$195;
      var $199=$197;
      var $200=(($198-$199)|0);
      var $201=(((($200)|0)/4)|0);
      var $202=((($201<<1))|0);
      HEAP32[(($74)>>2)]=$202;
      HEAP32[(($75)>>2)]=1;
      var $203=$9;
      var $204=$10;
      var $205=$11;
      var $206=$12;
      HEAP32[(($10)>>2)]=$74;
      HEAP32[(($11)>>2)]=$75;
      var $207=HEAP32[(($10)>>2)];
      var $208=HEAP32[(($11)>>2)];
      var $tmp_i=$9;
      var $tmp1_i=$12;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $209=$7;
      var $210=$8;
      HEAP32[(($7)>>2)]=$207;
      HEAP32[(($8)>>2)]=$208;
      var $211=HEAP32[(($7)>>2)];
      var $212=HEAP32[(($8)>>2)];
      var $213=$4;
      var $214=$5;
      var $215=$6;
      HEAP32[(($4)>>2)]=$9;
      HEAP32[(($5)>>2)]=$211;
      HEAP32[(($6)>>2)]=$212;
      var $216=HEAP32[(($4)>>2)];
      var $217=HEAP32[(($5)>>2)];
      var $218=HEAPU32[(($217)>>2)];
      var $219=HEAP32[(($6)>>2)];
      var $220=HEAPU32[(($219)>>2)];
      var $221=(($218)>>>0) < (($220)>>>0);
      var $222=$4;
      var $223=$5;
      var $224=$6;
      if ($221) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $225
      var $226=HEAP32[(($8)>>2)];
      var $229 = $226;__label__ = 6; break;
    case 5: // $227
      var $228=HEAP32[(($7)>>2)];
      var $229 = $228;__label__ = 6; break;
    case 6: // $_ZNSt3__13maxIjEERKT_S3_S3__exit
      var $229;
      var $230=$7;
      var $231=$8;
      var $232=$9;
      var $233=$10;
      var $234=$11;
      var $235=$12;
      var $236=HEAP32[(($229)>>2)];
      $__c=$236;
      var $237=$__c;
      var $238=$__c;
      var $239=(($238+3)|0);
      var $240=Math.floor((($239)>>>0)/4);
      var $241=$3;
      HEAP32[(($3)>>2)]=$80;
      var $242=HEAP32[(($3)>>2)];
      var $243=(($242+12)|0);
      var $244=$2;
      HEAP32[(($2)>>2)]=$243;
      var $245=HEAP32[(($2)>>2)];
      var $246=$245;
      var $247=$1;
      HEAP32[(($1)>>2)]=$246;
      var $248=HEAP32[(($1)>>2)];
      var $249=(($248+4)|0);
      var $250=HEAP32[(($249)>>2)];
      var $251=$1;
      var $252=$2;
      var $253=$3;
      __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC1EjjS6_($__t, $237, $240, $250);
      var $254=(($80+4)|0);
      var $255=HEAP32[(($254)>>2)];
      var $256=$15;
      var $257=$16;
      HEAP32[(($15)>>2)]=$76;
      HEAP32[(($16)>>2)]=$255;
      var $258=HEAP32[(($15)>>2)];
      var $259=HEAP32[(($16)>>2)];
      var $260=$13;
      var $261=$14;
      HEAP32[(($13)>>2)]=$258;
      HEAP32[(($14)>>2)]=$259;
      var $262=HEAP32[(($13)>>2)];
      var $263=(($262)|0);
      var $264=HEAP32[(($14)>>2)];
      HEAP32[(($263)>>2)]=$264;
      var $265=$13;
      var $266=$14;
      var $267=$15;
      var $268=$16;
      __label__ = 7; break;
    case 7: // $269
      var $270=(($80+8)|0);
      var $271=HEAP32[(($270)>>2)];
      var $272=$19;
      var $273=$20;
      HEAP32[(($19)>>2)]=$79;
      HEAP32[(($20)>>2)]=$271;
      var $274=HEAP32[(($19)>>2)];
      var $275=HEAP32[(($20)>>2)];
      var $276=$17;
      var $277=$18;
      HEAP32[(($17)>>2)]=$274;
      HEAP32[(($18)>>2)]=$275;
      var $278=HEAP32[(($17)>>2)];
      var $279=(($278)|0);
      var $280=HEAP32[(($18)>>2)];
      HEAP32[(($279)>>2)]=$280;
      var $281=$17;
      var $282=$18;
      var $283=$19;
      var $284=$20;
      __label__ = 8; break;
    case 8: // $285
      (function() { try { __THREW__ = false; return __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endINS_13move_iteratorIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESD_SD_($__t, $76, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 9; break; } else { __label__ = 14; break; }
    case 9: // $286
      var $287=(($80)|0);
      var $288=(($__t)|0);
      var $289=$27;
      var $290=$28;
      var $291=$__t_i3;
      HEAP32[(($27)>>2)]=$287;
      HEAP32[(($28)>>2)]=$288;
      var $292=HEAP32[(($27)>>2)];
      var $293=$26;
      HEAP32[(($26)>>2)]=$292;
      var $294=HEAP32[(($26)>>2)];
      var $295=$26;
      var $296=HEAP32[(($294)>>2)];
      HEAP32[(($__t_i3)>>2)]=$296;
      var $297=HEAP32[(($28)>>2)];
      var $298=$24;
      HEAP32[(($24)>>2)]=$297;
      var $299=HEAP32[(($24)>>2)];
      var $300=$24;
      var $301=HEAP32[(($299)>>2)];
      var $302=HEAP32[(($27)>>2)];
      HEAP32[(($302)>>2)]=$301;
      var $303=$25;
      HEAP32[(($25)>>2)]=$__t_i3;
      var $304=HEAP32[(($25)>>2)];
      var $305=$25;
      var $306=HEAP32[(($304)>>2)];
      var $307=HEAP32[(($28)>>2)];
      HEAP32[(($307)>>2)]=$306;
      var $308=$27;
      var $309=$28;
      var $310=$__t_i3;
      __label__ = 10; break;
    case 10: // $311
      var $312=(($80+4)|0);
      var $313=(($__t+4)|0);
      var $314=$32;
      var $315=$33;
      var $316=$__t_i2;
      HEAP32[(($32)>>2)]=$312;
      HEAP32[(($33)>>2)]=$313;
      var $317=HEAP32[(($32)>>2)];
      var $318=$31;
      HEAP32[(($31)>>2)]=$317;
      var $319=HEAP32[(($31)>>2)];
      var $320=$31;
      var $321=HEAP32[(($319)>>2)];
      HEAP32[(($__t_i2)>>2)]=$321;
      var $322=HEAP32[(($33)>>2)];
      var $323=$29;
      HEAP32[(($29)>>2)]=$322;
      var $324=HEAP32[(($29)>>2)];
      var $325=$29;
      var $326=HEAP32[(($324)>>2)];
      var $327=HEAP32[(($32)>>2)];
      HEAP32[(($327)>>2)]=$326;
      var $328=$30;
      HEAP32[(($30)>>2)]=$__t_i2;
      var $329=HEAP32[(($30)>>2)];
      var $330=$30;
      var $331=HEAP32[(($329)>>2)];
      var $332=HEAP32[(($33)>>2)];
      HEAP32[(($332)>>2)]=$331;
      var $333=$32;
      var $334=$33;
      var $335=$__t_i2;
      __label__ = 11; break;
    case 11: // $336
      var $337=(($80+8)|0);
      var $338=(($__t+8)|0);
      var $339=$37;
      var $340=$38;
      var $341=$__t_i1;
      HEAP32[(($37)>>2)]=$337;
      HEAP32[(($38)>>2)]=$338;
      var $342=HEAP32[(($37)>>2)];
      var $343=$36;
      HEAP32[(($36)>>2)]=$342;
      var $344=HEAP32[(($36)>>2)];
      var $345=$36;
      var $346=HEAP32[(($344)>>2)];
      HEAP32[(($__t_i1)>>2)]=$346;
      var $347=HEAP32[(($38)>>2)];
      var $348=$34;
      HEAP32[(($34)>>2)]=$347;
      var $349=HEAP32[(($34)>>2)];
      var $350=$34;
      var $351=HEAP32[(($349)>>2)];
      var $352=HEAP32[(($37)>>2)];
      HEAP32[(($352)>>2)]=$351;
      var $353=$35;
      HEAP32[(($35)>>2)]=$__t_i1;
      var $354=HEAP32[(($35)>>2)];
      var $355=$35;
      var $356=HEAP32[(($354)>>2)];
      var $357=HEAP32[(($38)>>2)];
      HEAP32[(($357)>>2)]=$356;
      var $358=$37;
      var $359=$38;
      var $360=$__t_i1;
      __label__ = 12; break;
    case 12: // $361
      var $362=$41;
      HEAP32[(($41)>>2)]=$80;
      var $363=HEAP32[(($41)>>2)];
      var $364=(($363+12)|0);
      var $365=$40;
      HEAP32[(($40)>>2)]=$364;
      var $366=HEAP32[(($40)>>2)];
      var $367=$366;
      var $368=$39;
      HEAP32[(($39)>>2)]=$367;
      var $369=HEAP32[(($39)>>2)];
      var $370=(($369)|0);
      var $371=$39;
      var $372=$40;
      var $373=$41;
      var $374=$44;
      HEAP32[(($44)>>2)]=$__t;
      var $375=HEAP32[(($44)>>2)];
      var $376=(($375+12)|0);
      var $377=$43;
      HEAP32[(($43)>>2)]=$376;
      var $378=HEAP32[(($43)>>2)];
      var $379=$378;
      var $380=$42;
      HEAP32[(($42)>>2)]=$379;
      var $381=HEAP32[(($42)>>2)];
      var $382=(($381)|0);
      var $383=$42;
      var $384=$43;
      var $385=$44;
      var $386=$48;
      var $387=$49;
      var $388=$__t_i;
      HEAP32[(($48)>>2)]=$370;
      HEAP32[(($49)>>2)]=$382;
      var $389=HEAP32[(($48)>>2)];
      var $390=$47;
      HEAP32[(($47)>>2)]=$389;
      var $391=HEAP32[(($47)>>2)];
      var $392=$47;
      var $393=HEAP32[(($391)>>2)];
      HEAP32[(($__t_i)>>2)]=$393;
      var $394=HEAP32[(($49)>>2)];
      var $395=$45;
      HEAP32[(($45)>>2)]=$394;
      var $396=HEAP32[(($45)>>2)];
      var $397=$45;
      var $398=HEAP32[(($396)>>2)];
      var $399=HEAP32[(($48)>>2)];
      HEAP32[(($399)>>2)]=$398;
      var $400=$46;
      HEAP32[(($46)>>2)]=$__t_i;
      var $401=HEAP32[(($46)>>2)];
      var $402=$46;
      var $403=HEAP32[(($401)>>2)];
      var $404=HEAP32[(($49)>>2)];
      HEAP32[(($404)>>2)]=$403;
      var $405=$48;
      var $406=$49;
      var $407=$__t_i;
      __label__ = 13; break;
    case 13: // $408
      __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED1Ev($__t);
      __label__ = 16; break;
    case 14: // $409
      var $410=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $411=$410.f0;
      $77=$411;
      var $412=$410.f1;
      $78=$412;
      (function() { try { __THREW__ = false; return __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED1Ev($__t) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 15; break; } else { __label__ = 21; break; }
    case 15: // $413
      __label__ = 20; break;
    case 16: // $414
      __label__ = 17; break;
    case 17: // $415
      var $416=$64;
      HEAP32[(($64)>>2)]=$80;
      var $417=HEAP32[(($64)>>2)];
      var $418=(($417+12)|0);
      var $419=$63;
      HEAP32[(($63)>>2)]=$418;
      var $420=HEAP32[(($63)>>2)];
      var $421=$420;
      var $422=$62;
      HEAP32[(($62)>>2)]=$421;
      var $423=HEAP32[(($62)>>2)];
      var $424=(($423+4)|0);
      var $425=HEAP32[(($424)>>2)];
      var $426=$62;
      var $427=$63;
      var $428=$64;
      var $429=(($80+4)|0);
      var $430=HEAP32[(($429)>>2)];
      var $431=(($430-4)|0);
      var $432=$65;
      HEAP32[(($65)>>2)]=$431;
      var $433=HEAP32[(($65)>>2)];
      var $434=$65;
      var $435=$73;
      var $436=$66;
      var $437=$67;
      var $438=$68;
      HEAP32[(($66)>>2)]=$425;
      HEAP32[(($67)>>2)]=$433;
      HEAP32[(($68)>>2)]=$435;
      var $439=HEAP32[(($67)>>2)];
      var $440=$439;
      var $441=(($440)|0)==0;
      if ($441) { var $446 = 0;__label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $442
      var $443=$440;
      var $444=HEAP32[(($68)>>2)];
      var $445=HEAP32[(($444)>>2)];
      HEAP32[(($443)>>2)]=$445;
      var $446 = $443;__label__ = 19; break;
    case 19: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE9constructIS4_S4_EEvRS5_PT_RKT0__exit
      var $446;
      var $447=$66;
      var $448=$67;
      var $449=$68;
      var $450=(($80+4)|0);
      var $451=HEAP32[(($450)>>2)];
      var $452=(($451-4)|0);
      HEAP32[(($450)>>2)]=$452;
      STACKTOP = __stackBase__;
      return;
    case 20: // $453
      var $454=$77;
      var $455=$77;
      var $456=$78;
      var $457=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $455, tempValue);
      var $458=($457.f1 = $456, $457);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 21: // $459
      var $460=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE10push_frontERKS3_["X"]=1;

function __ZNSt3__117__compressed_pairIPNS_6locale5facetENS_12_GLOBAL__N_17releaseEEC2ES3_i($this, $__t1, $0) {
  var __stackBase__  = STACKTOP; STACKTOP += 20; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $2=__stackBase__;
  var $3=__stackBase__+4;
  var $4=__stackBase__+8;
  var $5=__stackBase__+12;
  var $6;
  var $7=__stackBase__+16;
  var $8;
  $6=$this;
  HEAP32[(($7)>>2)]=$__t1;
  $8=$0;
  var $9=$6;
  var $10=$9;
  var $11=$5;
  HEAP32[(($5)>>2)]=$7;
  var $12=HEAP32[(($5)>>2)];
  var $13=$5;
  var $14=HEAP32[(($12)>>2)];
  var $15=$3;
  var $16=$4;
  HEAP32[(($3)>>2)]=$10;
  HEAP32[(($4)>>2)]=$14;
  var $17=HEAP32[(($3)>>2)];
  var $18=$17;
  var $19=(($17)|0);
  var $20=$2;
  HEAP32[(($2)>>2)]=$4;
  var $21=HEAP32[(($2)>>2)];
  var $22=$2;
  var $23=HEAP32[(($21)>>2)];
  HEAP32[(($19)>>2)]=$23;
  var $24=$3;
  var $25=$4;
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_($this, $__cap, $__start, $__a) {
  var __stackBase__  = STACKTOP; STACKTOP += 124; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24=__stackBase__+92;
      var $25=__stackBase__+96;
      var $26=__stackBase__+100;
      var $27=__stackBase__+104;
      var $28=__stackBase__+108;
      var $29=__stackBase__+112;
      var $30=__stackBase__+116;
      var $31;
      var $32;
      var $33;
      var $34;
      var $35=__stackBase__+120;
      $31=$this;
      $32=$__cap;
      $33=$__start;
      $34=$__a;
      var $36=$31;
      var $37=$36;
      var $38=(($36+12)|0);
      var $39=$34;
      var $40=$28;
      var $41=$29;
      var $42=$30;
      HEAP32[(($28)>>2)]=$38;
      HEAP32[(($29)>>2)]=0;
      HEAP32[(($30)>>2)]=$39;
      var $43=HEAP32[(($28)>>2)];
      var $44=HEAP32[(($29)>>2)];
      var $45=HEAP32[(($30)>>2)];
      var $46=$25;
      var $47=$26;
      var $48=$27;
      HEAP32[(($25)>>2)]=$43;
      HEAP32[(($26)>>2)]=$44;
      HEAP32[(($27)>>2)]=$45;
      var $49=HEAP32[(($25)>>2)];
      var $50=$49;
      var $51=$24;
      HEAP32[(($24)>>2)]=$26;
      var $52=HEAP32[(($24)>>2)];
      var $53=$24;
      var $54=HEAP32[(($52)>>2)];
      var $55=HEAP32[(($27)>>2)];
      var $56=$18;
      HEAP32[(($18)>>2)]=$55;
      var $57=HEAP32[(($18)>>2)];
      var $58=$18;
      var $59=$21;
      var $60=$22;
      var $61=$23;
      HEAP32[(($21)>>2)]=$50;
      HEAP32[(($22)>>2)]=$54;
      HEAP32[(($23)>>2)]=$57;
      var $62=HEAP32[(($21)>>2)];
      var $63=(($62)|0);
      var $64=$20;
      HEAP32[(($20)>>2)]=$22;
      var $65=HEAP32[(($20)>>2)];
      var $66=$20;
      var $67=HEAP32[(($65)>>2)];
      HEAP32[(($63)>>2)]=$67;
      var $68=(($62+4)|0);
      var $69=HEAP32[(($23)>>2)];
      var $70=$19;
      HEAP32[(($19)>>2)]=$69;
      var $71=HEAP32[(($19)>>2)];
      var $72=$19;
      HEAP32[(($68)>>2)]=$71;
      var $73=$21;
      var $74=$22;
      var $75=$23;
      var $76=$25;
      var $77=$26;
      var $78=$27;
      var $79=$28;
      var $80=$29;
      var $81=$30;
      var $82=$32;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 1; break; } else { __label__ = 6; break; }
    case 1: // $84
      var $85=$3;
      HEAP32[(($3)>>2)]=$36;
      var $86=HEAP32[(($3)>>2)];
      var $87=(($86+12)|0);
      var $88=$2;
      HEAP32[(($2)>>2)]=$87;
      var $89=HEAP32[(($2)>>2)];
      var $90=$89;
      var $91=$1;
      HEAP32[(($1)>>2)]=$90;
      var $92=HEAP32[(($1)>>2)];
      var $93=(($92+4)|0);
      var $94=HEAP32[(($93)>>2)];
      var $95=$1;
      var $96=$2;
      var $97=$3;
      var $98=$32;
      var $99=$8;
      var $100=$9;
      HEAP32[(($8)>>2)]=$94;
      HEAP32[(($9)>>2)]=$98;
      var $101=HEAP32[(($8)>>2)];
      var $102=HEAP32[(($9)>>2)];
      var $103=$4;
      var $104=$5;
      var $105=$6;
      var $106=$7;
      HEAP32[(($5)>>2)]=$101;
      HEAP32[(($6)>>2)]=$102;
      HEAP32[(($7)>>2)]=0;
      var $107=HEAPU32[(($5)>>2)];
      var $108=(($107+112)|0);
      var $109=HEAP8[($108)];
      var $110=(($109) & 1);
      if ($110) { __label__ = 4; break; } else { __label__ = 2; break; }
    case 2: // $111
      var $112=HEAPU32[(($6)>>2)];
      var $113=(($112)>>>0) <= 28;
      if ($113) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $114
      var $115=(($107+112)|0);
      HEAP8[($115)]=1;
      var $116=(($107)|0);
      var $117=$116;
      HEAP32[(($4)>>2)]=$117;
      __label__ = 5; break;
    case 4: // $118
      var $119=HEAP32[(($6)>>2)];
      var $120=((($119<<2))|0);
      var $121=__Znwj($120);
      var $122=$121;
      HEAP32[(($4)>>2)]=$122;
      __label__ = 5; break;
    case 5: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE8allocateERS5_j_exit
      var $123=HEAP32[(($4)>>2)];
      var $124=$4;
      var $125=$5;
      var $126=$6;
      var $127=$7;
      var $128=$8;
      var $129=$9;
      var $146 = $123;__label__ = 7; break;
    case 6: // $130
      var $131=$12;
      var $132=$13;
      HEAP32[(($12)>>2)]=$35;
      HEAP32[(($13)>>2)]=-1;
      var $133=HEAP32[(($12)>>2)];
      var $134=HEAP32[(($13)>>2)];
      var $135=$10;
      var $136=$11;
      HEAP32[(($10)>>2)]=$133;
      HEAP32[(($11)>>2)]=$134;
      var $137=HEAP32[(($10)>>2)];
      var $138=$10;
      var $139=$11;
      var $140=$12;
      var $141=$13;
      var $142=$14;
      HEAP32[(($14)>>2)]=$35;
      var $143=HEAP32[(($14)>>2)];
      var $144=$14;
      var $146 = 0;__label__ = 7; break;
    case 7: // $145
      var $146;
      var $147=(($36)|0);
      HEAP32[(($147)>>2)]=$146;
      var $148=(($36)|0);
      var $149=HEAP32[(($148)>>2)];
      var $150=$33;
      var $151=(($149+($150<<2))|0);
      var $152=(($36+8)|0);
      HEAP32[(($152)>>2)]=$151;
      var $153=(($36+4)|0);
      HEAP32[(($153)>>2)]=$151;
      var $154=(($36)|0);
      var $155=HEAP32[(($154)>>2)];
      var $156=$32;
      var $157=(($155+($156<<2))|0);
      var $158=$17;
      HEAP32[(($17)>>2)]=$36;
      var $159=HEAP32[(($17)>>2)];
      var $160=(($159+12)|0);
      var $161=$16;
      HEAP32[(($16)>>2)]=$160;
      var $162=HEAP32[(($16)>>2)];
      var $163=$162;
      var $164=$15;
      HEAP32[(($15)>>2)]=$163;
      var $165=HEAP32[(($15)>>2)];
      var $166=(($165)|0);
      var $167=$15;
      var $168=$16;
      var $169=$17;
      HEAP32[(($166)>>2)]=$157;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_["X"]=1;

function __ZNSt3__112_GLOBAL__N_17releaseclEPNS_6locale5facetE($this, $p) {
  ;
  var __label__;

  var $1;
  var $2;
  $1=$this;
  $2=$p;
  var $3=$1;
  var $4=$2;
  var $5=$4;
  var $6=__ZNSt3__114__shared_count16__release_sharedEv($5);
  ;
  return;
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj($this, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 48; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13;
      var $14;
      $13=$this;
      $14=$__n;
      var $15=$13;
      var $16=$14;
      var $17=__ZNKSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8max_sizeEv($15);
      var $18=(($16)>>>0) > (($17)>>>0);
      if ($18) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $19
      var $20=$15;
      __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv($20);
      __label__ = 2; break;
    case 2: // $21
      var $22=$15;
      var $23=$12;
      HEAP32[(($12)>>2)]=$22;
      var $24=HEAP32[(($12)>>2)];
      var $25=(($24+8)|0);
      var $26=$11;
      HEAP32[(($11)>>2)]=$25;
      var $27=HEAP32[(($11)>>2)];
      var $28=$27;
      var $29=$10;
      HEAP32[(($10)>>2)]=$28;
      var $30=HEAP32[(($10)>>2)];
      var $31=(($30+4)|0);
      var $32=$10;
      var $33=$11;
      var $34=$12;
      var $35=$14;
      var $36=$5;
      var $37=$6;
      HEAP32[(($5)>>2)]=$31;
      HEAP32[(($6)>>2)]=$35;
      var $38=HEAP32[(($5)>>2)];
      var $39=HEAP32[(($6)>>2)];
      var $40=$1;
      var $41=$2;
      var $42=$3;
      var $43=$4;
      HEAP32[(($2)>>2)]=$38;
      HEAP32[(($3)>>2)]=$39;
      HEAP32[(($4)>>2)]=0;
      var $44=HEAPU32[(($2)>>2)];
      var $45=(($44+112)|0);
      var $46=HEAP8[($45)];
      var $47=(($46) & 1);
      if ($47) { __label__ = 5; break; } else { __label__ = 3; break; }
    case 3: // $48
      var $49=HEAPU32[(($3)>>2)];
      var $50=(($49)>>>0) <= 28;
      if ($50) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $51
      var $52=(($44+112)|0);
      HEAP8[($52)]=1;
      var $53=(($44)|0);
      var $54=$53;
      HEAP32[(($1)>>2)]=$54;
      __label__ = 6; break;
    case 5: // $55
      var $56=HEAP32[(($3)>>2)];
      var $57=((($56<<2))|0);
      var $58=__Znwj($57);
      var $59=$58;
      HEAP32[(($1)>>2)]=$59;
      __label__ = 6; break;
    case 6: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE8allocateERS5_j_exit
      var $60=HEAP32[(($1)>>2)];
      var $61=$1;
      var $62=$2;
      var $63=$3;
      var $64=$4;
      var $65=$5;
      var $66=$6;
      var $67=$15;
      var $68=(($67+4)|0);
      HEAP32[(($68)>>2)]=$60;
      var $69=$15;
      var $70=(($69)|0);
      HEAP32[(($70)>>2)]=$60;
      var $71=$15;
      var $72=(($71)|0);
      var $73=HEAP32[(($72)>>2)];
      var $74=$14;
      var $75=(($73+($74<<2))|0);
      var $76=$15;
      var $77=$9;
      HEAP32[(($9)>>2)]=$76;
      var $78=HEAP32[(($9)>>2)];
      var $79=(($78+8)|0);
      var $80=$8;
      HEAP32[(($8)>>2)]=$79;
      var $81=HEAP32[(($8)>>2)];
      var $82=$81;
      var $83=$7;
      HEAP32[(($7)>>2)]=$82;
      var $84=HEAP32[(($7)>>2)];
      var $85=(($84)|0);
      var $86=$7;
      var $87=$8;
      var $88=$9;
      HEAP32[(($85)>>2)]=$75;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj["X"]=1;

function __ZNKSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8max_sizeEv($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 80; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19;
      var $20;
      var $21;
      var $22=__stackBase__+72;
      var $23=__stackBase__+76;
      $19=$this;
      var $24=$19;
      var $25=$24;
      var $26=$18;
      HEAP32[(($18)>>2)]=$25;
      var $27=HEAP32[(($18)>>2)];
      var $28=(($27+8)|0);
      var $29=$17;
      HEAP32[(($17)>>2)]=$28;
      var $30=HEAP32[(($17)>>2)];
      var $31=$30;
      var $32=$16;
      HEAP32[(($16)>>2)]=$31;
      var $33=HEAP32[(($16)>>2)];
      var $34=(($33+4)|0);
      var $35=$16;
      var $36=$17;
      var $37=$18;
      var $38=$3;
      var $39=$4;
      var $40=$5;
      var $41=$6;
      HEAP32[(($4)>>2)]=$34;
      var $42=$6;
      var $43=HEAP32[(($4)>>2)];
      var $tmp_i1=$3;
      var $tmp1_i2=$5;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i1)]=HEAP8[($tmp1_i2)];
      var $44=$2;
      HEAP32[(($2)>>2)]=$43;
      var $45=HEAP32[(($2)>>2)];
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=$1;
      var $49=$2;
      var $50=$3;
      var $51=$4;
      var $52=$5;
      var $53=$6;
      __label__ = 1; break;
    case 1: // $54
      HEAP32[(($22)>>2)]=1073741823;
      var $55=Math.floor(2147483647.5);
      HEAP32[(($23)>>2)]=$55;
      var $56=$12;
      var $57=$13;
      var $58=$14;
      var $59=$15;
      HEAP32[(($13)>>2)]=$22;
      HEAP32[(($14)>>2)]=$23;
      var $60=HEAP32[(($13)>>2)];
      var $61=HEAP32[(($14)>>2)];
      var $tmp_i=$12;
      var $tmp1_i=$15;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i)]=HEAP8[($tmp1_i)];
      var $62=$10;
      var $63=$11;
      HEAP32[(($10)>>2)]=$60;
      HEAP32[(($11)>>2)]=$61;
      var $64=HEAP32[(($11)>>2)];
      var $65=HEAP32[(($10)>>2)];
      var $66=$7;
      var $67=$8;
      var $68=$9;
      HEAP32[(($7)>>2)]=$12;
      HEAP32[(($8)>>2)]=$64;
      HEAP32[(($9)>>2)]=$65;
      var $69=HEAP32[(($7)>>2)];
      var $70=HEAP32[(($8)>>2)];
      var $71=HEAPU32[(($70)>>2)];
      var $72=HEAP32[(($9)>>2)];
      var $73=HEAPU32[(($72)>>2)];
      var $74=(($71)>>>0) < (($73)>>>0);
      var $75=$7;
      var $76=$8;
      var $77=$9;
      if ($74) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $78
      var $79=HEAP32[(($11)>>2)];
      var $82 = $79;__label__ = 4; break;
    case 3: // $80
      var $81=HEAP32[(($10)>>2)];
      var $82 = $81;__label__ = 4; break;
    case 4: // $_ZNSt3__13minIjEERKT_S3_S3__exit
      var $82;
      var $83=$10;
      var $84=$11;
      var $85=$12;
      var $86=$13;
      var $87=$14;
      var $88=$15;
      __label__ = 5; break;
    case 5: // $89
      var $90=HEAP32[(($82)>>2)];
      STACKTOP = __stackBase__;
      return $90;
      var $92=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $93=$92.f0;
      $20=$93;
      var $94=$92.f1;
      $21=$94;
      __label__ = 6; break;
    case 6: // $95
      var $96=$20;
      ___cxa_call_unexpected($96);
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNKSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8max_sizeEv["X"]=1;

function __ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 44; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $__tmp_i=__stackBase__+32;
      var $9=__stackBase__+36;
      var $10=__stackBase__+40;
      var $11;
      $11=$this;
      var $12=$11;
      var $13=$7;
      var $14=$8;
      var $15=$__tmp_i;
      var $16=$9;
      var $17=$10;
      HEAP32[(($7)>>2)]=$12;
      HEAP32[(($8)>>2)]=0;
      var $18=HEAP32[(($7)>>2)];
      var $19=(($18)|0);
      var $20=$6;
      HEAP32[(($6)>>2)]=$19;
      var $21=HEAP32[(($6)>>2)];
      var $22=$21;
      var $23=$5;
      HEAP32[(($5)>>2)]=$22;
      var $24=HEAP32[(($5)>>2)];
      var $25=(($24)|0);
      var $26=$5;
      var $27=$6;
      var $28=HEAP32[(($25)>>2)];
      HEAP32[(($__tmp_i)>>2)]=$28;
      var $29=HEAP32[(($8)>>2)];
      var $30=(($18)|0);
      var $31=$4;
      HEAP32[(($4)>>2)]=$30;
      var $32=HEAP32[(($4)>>2)];
      var $33=$32;
      var $34=$3;
      HEAP32[(($3)>>2)]=$33;
      var $35=HEAP32[(($3)>>2)];
      var $36=(($35)|0);
      var $37=$3;
      var $38=$4;
      HEAP32[(($36)>>2)]=$29;
      var $39=HEAP32[(($__tmp_i)>>2)];
      var $40=(($39)|0)!=0;
      if ($40) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $41
      var $42=(($18)|0);
      var $43=$2;
      HEAP32[(($2)>>2)]=$42;
      var $44=HEAP32[(($2)>>2)];
      var $45=$44;
      var $46=$1;
      HEAP32[(($1)>>2)]=$45;
      var $47=HEAP32[(($1)>>2)];
      var $48=$47;
      var $49=$1;
      var $50=$2;
      var $51=HEAP32[(($__tmp_i)>>2)];
      (function() { try { __THREW__ = false; return __ZNSt3__112_GLOBAL__N_17releaseclEPNS_6locale5facetE($48, $51) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $52
      __label__ = 4; break;
    case 3: // $53
      var $54=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $55=$54.f0;
      HEAP32[(($9)>>2)]=$55;
      var $56=$54.f1;
      HEAP32[(($10)>>2)]=$56;
      var $57=HEAP32[(($9)>>2)];
      ___cxa_call_unexpected($57);
      throw "Reached an unreachable!"
    case 4: // $_ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEE5resetEPS2__exit
      var $58=$7;
      var $59=$8;
      var $60=$__tmp_i;
      var $61=$9;
      var $62=$10;
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED2Ev["X"]=1;

function __ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEEC2EPS2_($this, $__p) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2;
      var $3=__stackBase__+4;
      var $4;
      var $5;
      $2=$this;
      HEAP32[(($3)>>2)]=$__p;
      var $6=$2;
      var $7=(($6)|0);
      var $8=$1;
      HEAP32[(($1)>>2)]=$3;
      var $9=HEAP32[(($1)>>2)];
      var $10=$1;
      __label__ = 1; break;
    case 1: // $11
      var $12=HEAP32[(($9)>>2)];
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZNSt3__117__compressed_pairIPNS_6locale5facetENS_12_GLOBAL__N_17releaseEEC1ES3_i]($7, $12, 0) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $13
      STACKTOP = __stackBase__;
      return;
    case 3: // $14
      var $15=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $16=$15.f0;
      $4=$16;
      var $17=$15.f1;
      $5=$17;
      __label__ = 4; break;
    case 4: // $18
      var $19=$4;
      ___cxa_call_unexpected($19);
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej($this, $__n) {
  var __stackBase__  = STACKTOP; STACKTOP += 60; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16;
      var $17;
      var $18;
      var $19;
      $16=$this;
      $17=$__n;
      var $20=$16;
      var $21=$20;
      var $22=$15;
      HEAP32[(($15)>>2)]=$21;
      var $23=HEAP32[(($15)>>2)];
      var $24=$23;
      var $25=$14;
      HEAP32[(($14)>>2)]=$24;
      var $26=HEAP32[(($14)>>2)];
      var $27=$14;
      var $28=(($23)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($23+4)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($23+8)|0);
      var $31=$11;
      var $32=$12;
      var $33=$13;
      HEAP32[(($11)>>2)]=$30;
      HEAP32[(($12)>>2)]=0;
      HEAP32[(($13)>>2)]=0;
      var $34=HEAP32[(($11)>>2)];
      var $35=HEAP32[(($12)>>2)];
      var $36=HEAP32[(($13)>>2)];
      var $37=$8;
      var $38=$9;
      var $39=$10;
      HEAP32[(($8)>>2)]=$34;
      HEAP32[(($9)>>2)]=$35;
      HEAP32[(($10)>>2)]=$36;
      var $40=HEAP32[(($8)>>2)];
      var $41=$40;
      var $42=$7;
      HEAP32[(($7)>>2)]=$9;
      var $43=HEAP32[(($7)>>2)];
      var $44=$7;
      var $45=HEAP32[(($43)>>2)];
      var $46=$4;
      var $47=$5;
      var $48=$6;
      HEAP32[(($4)>>2)]=$41;
      HEAP32[(($5)>>2)]=$45;
      HEAP32[(($6)>>2)]=0;
      var $49=HEAP32[(($4)>>2)];
      var $50=(($49)|0);
      var $51=$3;
      HEAP32[(($3)>>2)]=$5;
      var $52=HEAP32[(($3)>>2)];
      var $53=$3;
      var $54=HEAP32[(($52)>>2)];
      HEAP32[(($50)>>2)]=$54;
      var $55=(($49+4)|0);
      var $56=$2;
      HEAP32[(($2)>>2)]=$55;
      var $57=HEAP32[(($2)>>2)];
      var $58=$1;
      HEAP32[(($1)>>2)]=$57;
      var $59=HEAP32[(($1)>>2)];
      var $60=(($59)|0);
      var $61=(($59+112)|0);
      HEAP8[($61)]=0;
      var $62=$1;
      var $63=$2;
      var $64=$4;
      var $65=$5;
      var $66=$6;
      var $67=$8;
      var $68=$9;
      var $69=$10;
      var $70=$11;
      var $71=$12;
      var $72=$13;
      var $73=$15;
      var $74=$17;
      var $75=(($74)>>>0) > 0;
      if ($75) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $76
      var $77=$17;
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj($20, $77) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $78
      var $79=$17;
      (function() { try { __THREW__ = false; return __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj($20, $79) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $80
      __label__ = 5; break;
    case 4: // $81
      var $82=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $83=$82.f0;
      $18=$83;
      var $84=$82.f1;
      $19=$84;
      var $85=$20;
      (function() { try { __THREW__ = false; return __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev($85) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 8; break; }
    case 5: // $86
      STACKTOP = __stackBase__;
      return;
    case 6: // $87
      __label__ = 7; break;
    case 7: // $88
      var $89=$18;
      var $90=$18;
      var $91=$19;
      var $92=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $90, tempValue);
      var $93=($92.f1 = $91, $92);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 8: // $94
      var $95=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej["X"]=1;

function __ZNKSt8bad_cast4whatEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return ((STRING_TABLE.__str4181773)|0);
}


function __ZNSt8bad_castC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$3;
  var $5=$1;
  HEAP32[(($1)>>2)]=$4;
  var $6=HEAP32[(($1)>>2)];
  var $7=$6;
  HEAP32[(($7)>>2)]=((__ZTVSt9exception+8)|0);
  var $8=$1;
  var $9=$3;
  HEAP32[(($9)>>2)]=((__ZTVSt8bad_cast+8)|0);
  STACKTOP = __stackBase__;
  return;
}


function __ZNSt3__112_GLOBAL__N_111__fake_bindC2EMNS_6locale2idEFvvEPS3_($this, $0, $id) {
  var __stackBase__  = STACKTOP; STACKTOP += 8; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var tempParam = $0; $0 = STACKTOP;STACKTOP += 8;assert(STACKTOP < STACK_ROOT + STACK_MAX, "Ran out of stack");HEAP32[(($0)>>2)]=HEAP32[((tempParam)>>2)];HEAP32[(($0+4)>>2)]=HEAP32[((tempParam+4)>>2)];
  var __label__;

  var $2;
  var $3=__stackBase__;
  var $4;
  $2=$this;
  var $pmf={ f0: HEAP32[(($0)>>2)], f1: HEAP32[(($0+4)>>2)] };
  HEAP32[(($3)>>2)]=$pmf.f0; HEAP32[(($3+4)>>2)]=$pmf.f1;
  $4=$id;
  var $5=$2;
  var $6=(($5)|0);
  var $7=$4;
  HEAP32[(($6)>>2)]=$7;
  var $8=(($5+4)|0);
  var $9={ f0: HEAP32[(($3)>>2)], f1: HEAP32[(($3+4)>>2)] };
  HEAP32[(($8)>>2)]=$9.f0; HEAP32[(($8+4)>>2)]=$9.f1;
  STACKTOP = __stackBase__;
  return;
}


function __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi($this, $info, $adjustedPtr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$info;
      $3=$adjustedPtr;
      $4=$path_below;
      var $5=$1;
      var $6=$2;
      var $7=(($6+16)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($8)|0)==0;
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$3;
      var $12=$2;
      var $13=(($12+16)|0);
      HEAP32[(($13)>>2)]=$11;
      var $14=$4;
      var $15=$2;
      var $16=(($15+24)|0);
      HEAP32[(($16)>>2)]=$14;
      var $17=$2;
      var $18=(($17+36)|0);
      HEAP32[(($18)>>2)]=1;
      __label__ = 8; break;
    case 2: // $19
      var $20=$2;
      var $21=(($20+16)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$3;
      var $24=(($22)|0)==(($23)|0);
      if ($24) { __label__ = 3; break; } else { __label__ = 6; break; }
    case 3: // $25
      var $26=$2;
      var $27=(($26+24)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=(($28)|0)==2;
      if ($29) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $30
      var $31=$4;
      var $32=$2;
      var $33=(($32+24)|0);
      HEAP32[(($33)>>2)]=$31;
      __label__ = 5; break;
    case 5: // $34
      __label__ = 7; break;
    case 6: // $35
      var $36=$2;
      var $37=(($36+36)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38+1)|0);
      HEAP32[(($37)>>2)]=$39;
      var $40=$2;
      var $41=(($40+24)|0);
      HEAP32[(($41)>>2)]=2;
      var $42=$2;
      var $43=(($42+54)|0);
      HEAP8[($43)]=1;
      __label__ = 7; break;
    case 7: // $44
      __label__ = 8; break;
    case 8: // $45
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi["X"]=1;

function __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 92; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1=__stackBase__;
      var $2=__stackBase__+4;
      var $3=__stackBase__+8;
      var $4=__stackBase__+12;
      var $5=__stackBase__+16;
      var $6=__stackBase__+20;
      var $7=__stackBase__+24;
      var $8=__stackBase__+28;
      var $9=__stackBase__+32;
      var $10=__stackBase__+36;
      var $11=__stackBase__+40;
      var $12=__stackBase__+44;
      var $13=__stackBase__+48;
      var $14=__stackBase__+52;
      var $15=__stackBase__+56;
      var $16=__stackBase__+60;
      var $17=__stackBase__+64;
      var $18=__stackBase__+68;
      var $19=__stackBase__+72;
      var $20=__stackBase__+76;
      var $21=__stackBase__+80;
      var $22=__stackBase__+84;
      var $23=__stackBase__+88;
      var $24;
      $24=$this;
      var $25=$24;
      var $26=(($25)|0);
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27)|0)!=0;
      if ($28) { __label__ = 1; break; } else { __label__ = 5; break; }
    case 1: // $29
      var $30=$23;
      HEAP32[(($23)>>2)]=$25;
      var $31=HEAP32[(($23)>>2)];
      var $32=(($31)|0);
      var $33=HEAP32[(($32)>>2)];
      var $34=$18;
      var $35=$19;
      var $36=$20;
      var $37=$21;
      var $38=$22;
      HEAP32[(($19)>>2)]=$31;
      HEAP32[(($20)>>2)]=$33;
      var $39=HEAP32[(($19)>>2)];
      var $40=HEAP32[(($20)>>2)];
      var $41=$22;
      var $tmp_i_i=$18;
      var $tmp1_i_i=$21;
      assert(1 % 1 === 0, 'memcpy given ' + 1 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP8[($tmp_i_i)]=HEAP8[($tmp1_i_i)];
      var $42=$16;
      var $43=$17;
      HEAP32[(($16)>>2)]=$39;
      HEAP32[(($17)>>2)]=$40;
      var $44=HEAP32[(($16)>>2)];
      var $45=HEAP32[(($17)>>2)];
      var $46=(($44+4)|0);
      HEAP32[(($46)>>2)]=$45;
      var $47=$16;
      var $48=$17;
      var $49=$18;
      var $50=$19;
      var $51=$20;
      var $52=$21;
      var $53=$22;
      var $54=$23;
      var $55=$7;
      HEAP32[(($7)>>2)]=$25;
      var $56=HEAP32[(($7)>>2)];
      var $57=(($56+8)|0);
      var $58=$6;
      HEAP32[(($6)>>2)]=$57;
      var $59=HEAP32[(($6)>>2)];
      var $60=$59;
      var $61=$5;
      HEAP32[(($5)>>2)]=$60;
      var $62=HEAP32[(($5)>>2)];
      var $63=(($62+4)|0);
      var $64=$5;
      var $65=$6;
      var $66=$7;
      var $67=(($25)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=$4;
      HEAP32[(($4)>>2)]=$25;
      var $70=HEAP32[(($4)>>2)];
      var $71=$3;
      HEAP32[(($3)>>2)]=$70;
      var $72=HEAP32[(($3)>>2)];
      var $73=(($72+8)|0);
      var $74=$2;
      HEAP32[(($2)>>2)]=$73;
      var $75=HEAP32[(($2)>>2)];
      var $76=$75;
      var $77=$1;
      HEAP32[(($1)>>2)]=$76;
      var $78=HEAP32[(($1)>>2)];
      var $79=(($78)|0);
      var $80=$1;
      var $81=$2;
      var $82=$3;
      var $83=HEAP32[(($79)>>2)];
      var $84=(($70)|0);
      var $85=HEAP32[(($84)>>2)];
      var $86=$83;
      var $87=$85;
      var $88=(($86-$87)|0);
      var $89=(((($88)|0)/4)|0);
      var $90=$4;
      var $91=$11;
      var $92=$12;
      var $93=$13;
      var $94=$14;
      var $95=$15;
      HEAP32[(($11)>>2)]=$63;
      HEAP32[(($12)>>2)]=$68;
      HEAP32[(($13)>>2)]=$89;
      var $96=HEAP32[(($11)>>2)];
      var $97=HEAP32[(($12)>>2)];
      var $98=HEAP32[(($13)>>2)];
      var $99=$8;
      var $100=$9;
      var $101=$10;
      HEAP32[(($8)>>2)]=$96;
      HEAP32[(($9)>>2)]=$97;
      HEAP32[(($10)>>2)]=$98;
      var $102=HEAP32[(($8)>>2)];
      var $103=HEAP32[(($9)>>2)];
      var $104=(($102)|0);
      var $105=$104;
      var $106=(($103)|0)==(($105)|0);
      if ($106) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $107
      var $108=(($102+112)|0);
      HEAP8[($108)]=0;
      __label__ = 4; break;
    case 3: // $109
      var $110=HEAP32[(($9)>>2)];
      var $111=$110;
      __ZdlPv($111);
      __label__ = 4; break;
    case 4: // $_ZNSt3__116allocator_traitsINS_15__sso_allocatorIPNS_6locale5facetELj28EEEE10deallocateERS5_PS4_j_exit
      var $112=$8;
      var $113=$9;
      var $114=$10;
      var $115=$11;
      var $116=$12;
      var $117=$13;
      var $118=$14;
      var $119=$15;
      __label__ = 5; break;
    case 5: // $120
      STACKTOP = __stackBase__;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev["X"]=1;

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev($3);
  ;
  return;
}


function __GLOBAL__I_a285() {
  ;
  var __label__;

  ___cxx_global_var_init270();
  ___cxx_global_var_init1271();
  ___cxx_global_var_init2272();
  ___cxx_global_var_init3273();
  ___cxx_global_var_init4274();
  ___cxx_global_var_init9275();
  ___cxx_global_var_init10276();
  ___cxx_global_var_init15();
  ___cxx_global_var_init20();
  ___cxx_global_var_init21();
  ___cxx_global_var_init22();
  ___cxx_global_var_init23();
  ___cxx_global_var_init24();
  ___cxx_global_var_init25();
  ___cxx_global_var_init26();
  ___cxx_global_var_init29();
  ___cxx_global_var_init30();
  ___cxx_global_var_init32();
  ___cxx_global_var_init33();
  ___cxx_global_var_init34();
  ___cxx_global_var_init41();
  ___cxx_global_var_init42();
  ___cxx_global_var_init45();
  ___cxx_global_var_init46();
  ___cxx_global_var_init48();
  ___cxx_global_var_init49();
  ___cxx_global_var_init50();
  ___cxx_global_var_init51();
  ;
  return;
}


function __ZNSt8bad_castD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt8bad_castD1Ev]($2);
  var $3=$2;
  __ZdlPv($3);
  ;
  return;
}


function __ZNSt8bad_castD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt9exceptionD2Ev($3);
  ;
  return;
}


function __ZN10__cxxabiv116__shim_type_infoD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2;
  __ZNSt9type_infoD2Ev($3);
  ;
  return;
}


function __ZN10__cxxabiv117__class_type_infoD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10__cxxabiv117__class_type_infoD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10__cxxabiv120__si_class_type_infoD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10__cxxabiv120__si_class_type_infoD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZN10__cxxabiv121__vmi_class_type_infoD0Ev($this) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$this;
      var $4=$1;
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[__ZN10__cxxabiv121__vmi_class_type_infoD1Ev]($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $5
      var $6=$4;
      __ZdlPv($6);
      ;
      return;
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0;
      $2=$9;
      var $10=$8.f1;
      $3=$10;
      var $11=$4;
      __ZdlPv($11);
      __label__ = 3; break;
    case 3: // $12
      var $13=$2;
      var $14=$2;
      var $15=$3;
      var $16=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $14, tempValue);
      var $17=($16.f1 = $15, $16);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv($this, $thrown_type, $adjustedPtr) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $thrown_class_type;
      var $info=__stackBase__;
      $2=$this;
      $3=$thrown_type;
      $4=$adjustedPtr;
      var $5=$2;
      var $6=$5;
      var $7=$3;
      var $8=(($6)|0)==(($7)|0);
      if ($8) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $9
      $1=1;
      __label__ = 10; break;
    case 2: // $10
      var $11=$3;
      var $12=(($11)|0)==0;
      if ($12) { __label__ = 4; break; } else { __label__ = 3; break; }
    case 3: // $13
      var $14=$11;
      var $15=___dynamic_cast($14, __ZTIN10__cxxabiv116__shim_type_infoE, __ZTIN10__cxxabiv117__class_type_infoE, -1);
      var $16=$15;
      var $19 = $16;__label__ = 5; break;
    case 4: // $17
      var $19 = 0;__label__ = 5; break;
    case 5: // $18
      var $19;
      $thrown_class_type=$19;
      var $20=$thrown_class_type;
      var $21=(($20)|0)==0;
      if ($21) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $22
      $1=0;
      __label__ = 10; break;
    case 7: // $23
      var $24=$info;
      for (var $$dest = $24>>2, $$stop = $$dest + 14; $$dest < $$stop; $$dest++) {
        HEAP32[$$dest] = 0
      };
      var $25=(($info)|0);
      var $26=$thrown_class_type;
      HEAP32[(($25)>>2)]=$26;
      var $27=(($info+8)|0);
      HEAP32[(($27)>>2)]=$5;
      var $28=(($info+12)|0);
      HEAP32[(($28)>>2)]=-1;
      var $29=(($info+48)|0);
      HEAP32[(($29)>>2)]=1;
      var $30=$thrown_class_type;
      var $31=$30;
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32+20)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$4;
      var $36=HEAP32[(($35)>>2)];
      FUNCTION_TABLE[$34]($30, $info, $36, 1);
      var $37=(($info+24)|0);
      var $38=HEAP32[(($37)>>2)];
      var $39=(($38)|0)==1;
      if ($39) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $40
      var $41=(($info+16)|0);
      var $42=HEAP32[(($41)>>2)];
      var $43=$4;
      HEAP32[(($43)>>2)]=$42;
      $1=1;
      __label__ = 10; break;
    case 9: // $44
      $1=0;
      __label__ = 10; break;
    case 10: // $45
      var $46=$1;
      STACKTOP = __stackBase__;
      return $46;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv["X"]=1;

function __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this, $info, $adjustedPtr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$info;
      $3=$adjustedPtr;
      $4=$path_below;
      var $5=$1;
      var $6=$2;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=$3;
      var $13=$4;
      __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi($5, $11, $12, $13);
      __label__ = 2; break;
    case 2: // $14
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this, $info, $adjustedPtr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$info;
      $3=$adjustedPtr;
      $4=$path_below;
      var $5=$1;
      var $6=$5;
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$5;
      var $13=$2;
      var $14=$3;
      var $15=$4;
      __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi($12, $13, $14, $15);
      __label__ = 3; break;
    case 2: // $16
      var $17=(($5+8)|0);
      var $18=HEAP32[(($17)>>2)];
      var $19=$18;
      var $20=HEAP32[(($19)>>2)];
      var $21=(($20+20)|0);
      var $22=HEAP32[(($21)>>2)];
      var $23=$2;
      var $24=$3;
      var $25=$4;
      FUNCTION_TABLE[$22]($18, $23, $24, $25);
      __label__ = 3; break;
    case 3: // $26
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_array_dtor($0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3;
      var $4;
      $2=$0;
      var $6 = ((__ZZNSt3__1L11init_wam_pmEvE5am_pm+288)|0);__label__ = 1; break;
    case 1: // $5
      var $6;
      var $7=(($6-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($7)|0)==(((((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0)))|0);
      if ($9) { __label__ = 3; break; } else { var $6 = $7;__label__ = 1; break; }
    case 3: // $10
      ;
      return;
    case 4: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $3=$13;
      var $14=$12.f1;
      $4=$14;
      var $15=(((((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0)))|0)==(($7)|0);
      if ($15) { __label__ = 7; break; } else { var $17 = $7;__label__ = 5; break; }
    case 5: // $16
      var $17;
      var $18=(($17-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $19
      var $20=(($18)|0)==(((((__ZZNSt3__1L11init_wam_pmEvE5am_pm)|0)))|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      __label__ = 8; break;
    case 8: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_array_dtor77($0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3;
      var $4;
      $2=$0;
      var $6 = ((__ZZNSt3__1L10init_am_pmEvE5am_pm+288)|0);__label__ = 1; break;
    case 1: // $5
      var $6;
      var $7=(($6-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($7)|0)==(((((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0)))|0);
      if ($9) { __label__ = 3; break; } else { var $6 = $7;__label__ = 1; break; }
    case 3: // $10
      ;
      return;
    case 4: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $3=$13;
      var $14=$12.f1;
      $4=$14;
      var $15=(((((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0)))|0)==(($7)|0);
      if ($15) { __label__ = 7; break; } else { var $17 = $7;__label__ = 5; break; }
    case 5: // $16
      var $17;
      var $18=(($17-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $19
      var $20=(($18)|0)==(((((__ZZNSt3__1L10init_am_pmEvE5am_pm)|0)))|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      __label__ = 8; break;
    case 8: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_array_dtor80($0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3;
      var $4;
      $2=$0;
      var $6 = ((__ZZNSt3__1L12init_wmonthsEvE6months+288)|0);__label__ = 1; break;
    case 1: // $5
      var $6;
      var $7=(($6-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($7)|0)==(((((__ZZNSt3__1L12init_wmonthsEvE6months)|0)))|0);
      if ($9) { __label__ = 3; break; } else { var $6 = $7;__label__ = 1; break; }
    case 3: // $10
      ;
      return;
    case 4: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $3=$13;
      var $14=$12.f1;
      $4=$14;
      var $15=(((((__ZZNSt3__1L12init_wmonthsEvE6months)|0)))|0)==(($7)|0);
      if ($15) { __label__ = 7; break; } else { var $17 = $7;__label__ = 5; break; }
    case 5: // $16
      var $17;
      var $18=(($17-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $19
      var $20=(($18)|0)==(((((__ZZNSt3__1L12init_wmonthsEvE6months)|0)))|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      __label__ = 8; break;
    case 8: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_array_dtor104($0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3;
      var $4;
      $2=$0;
      var $6 = ((__ZZNSt3__1L11init_monthsEvE6months+288)|0);__label__ = 1; break;
    case 1: // $5
      var $6;
      var $7=(($6-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($7)|0)==(((((__ZZNSt3__1L11init_monthsEvE6months)|0)))|0);
      if ($9) { __label__ = 3; break; } else { var $6 = $7;__label__ = 1; break; }
    case 3: // $10
      ;
      return;
    case 4: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $3=$13;
      var $14=$12.f1;
      $4=$14;
      var $15=(((((__ZZNSt3__1L11init_monthsEvE6months)|0)))|0)==(($7)|0);
      if ($15) { __label__ = 7; break; } else { var $17 = $7;__label__ = 5; break; }
    case 5: // $16
      var $17;
      var $18=(($17-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $19
      var $20=(($18)|0)==(((((__ZZNSt3__1L11init_monthsEvE6months)|0)))|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      __label__ = 8; break;
    case 8: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_array_dtor128($0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3;
      var $4;
      $2=$0;
      var $6 = ((__ZZNSt3__1L11init_wweeksEvE5weeks+168)|0);__label__ = 1; break;
    case 1: // $5
      var $6;
      var $7=(($6-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($7)|0)==(((((__ZZNSt3__1L11init_wweeksEvE5weeks)|0)))|0);
      if ($9) { __label__ = 3; break; } else { var $6 = $7;__label__ = 1; break; }
    case 3: // $10
      ;
      return;
    case 4: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $3=$13;
      var $14=$12.f1;
      $4=$14;
      var $15=(((((__ZZNSt3__1L11init_wweeksEvE5weeks)|0)))|0)==(($7)|0);
      if ($15) { __label__ = 7; break; } else { var $17 = $7;__label__ = 5; break; }
    case 5: // $16
      var $17;
      var $18=(($17-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $19
      var $20=(($18)|0)==(((((__ZZNSt3__1L11init_wweeksEvE5weeks)|0)))|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      __label__ = 8; break;
    case 8: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function ___cxx_global_array_dtor143($0) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $2;
      var $3;
      var $4;
      $2=$0;
      var $6 = ((__ZZNSt3__1L10init_weeksEvE5weeks+168)|0);__label__ = 1; break;
    case 1: // $5
      var $6;
      var $7=(($6-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($7) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 2; break; } else { __label__ = 4; break; }
    case 2: // $8
      var $9=(($7)|0)==(((((__ZZNSt3__1L10init_weeksEvE5weeks)|0)))|0);
      if ($9) { __label__ = 3; break; } else { var $6 = $7;__label__ = 1; break; }
    case 3: // $10
      ;
      return;
    case 4: // $11
      var $12=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $13=$12.f0;
      $3=$13;
      var $14=$12.f1;
      $4=$14;
      var $15=(((((__ZZNSt3__1L10init_weeksEvE5weeks)|0)))|0)==(($7)|0);
      if ($15) { __label__ = 7; break; } else { var $17 = $7;__label__ = 5; break; }
    case 5: // $16
      var $17;
      var $18=(($17-12)|0);
      (function() { try { __THREW__ = false; return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev($18) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $19
      var $20=(($18)|0)==(((((__ZZNSt3__1L10init_weeksEvE5weeks)|0)))|0);
      if ($20) { __label__ = 7; break; } else { var $17 = $18;__label__ = 5; break; }
    case 7: // $21
      __label__ = 8; break;
    case 8: // $22
      var $23=$3;
      var $24=$3;
      var $25=$4;
      var $26=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $24, tempValue);
      var $27=($26.f1 = $25, $26);
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    case 9: // $28
      var $29=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[0]);
      __ZSt9terminatev();
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($this, $info, $dst_ptr, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$info;
      $3=$dst_ptr;
      $4=$current_ptr;
      $5=$path_below;
      var $6=$1;
      var $7=$2;
      var $8=(($7+53)|0);
      HEAP8[($8)]=1;
      var $9=$4;
      var $10=$2;
      var $11=(($10+4)|0);
      var $12=HEAP32[(($11)>>2)];
      var $13=(($9)|0)==(($12)|0);
      if ($13) { __label__ = 1; break; } else { __label__ = 16; break; }
    case 1: // $14
      var $15=$2;
      var $16=(($15+52)|0);
      HEAP8[($16)]=1;
      var $17=$2;
      var $18=(($17+16)|0);
      var $19=HEAP32[(($18)>>2)];
      var $20=(($19)|0)==0;
      if ($20) { __label__ = 2; break; } else { __label__ = 6; break; }
    case 2: // $21
      var $22=$3;
      var $23=$2;
      var $24=(($23+16)|0);
      HEAP32[(($24)>>2)]=$22;
      var $25=$5;
      var $26=$2;
      var $27=(($26+24)|0);
      HEAP32[(($27)>>2)]=$25;
      var $28=$2;
      var $29=(($28+36)|0);
      HEAP32[(($29)>>2)]=1;
      var $30=$2;
      var $31=(($30+48)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($32)|0)==1;
      if ($33) { __label__ = 3; break; } else { __label__ = 5; break; }
    case 3: // $34
      var $35=$2;
      var $36=(($35+24)|0);
      var $37=HEAP32[(($36)>>2)];
      var $38=(($37)|0)==1;
      if ($38) { __label__ = 4; break; } else { __label__ = 5; break; }
    case 4: // $39
      var $40=$2;
      var $41=(($40+54)|0);
      HEAP8[($41)]=1;
      __label__ = 5; break;
    case 5: // $42
      __label__ = 15; break;
    case 6: // $43
      var $44=$2;
      var $45=(($44+16)|0);
      var $46=HEAP32[(($45)>>2)];
      var $47=$3;
      var $48=(($46)|0)==(($47)|0);
      if ($48) { __label__ = 7; break; } else { __label__ = 13; break; }
    case 7: // $49
      var $50=$2;
      var $51=(($50+24)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==2;
      if ($53) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $54
      var $55=$5;
      var $56=$2;
      var $57=(($56+24)|0);
      HEAP32[(($57)>>2)]=$55;
      __label__ = 9; break;
    case 9: // $58
      var $59=$2;
      var $60=(($59+48)|0);
      var $61=HEAP32[(($60)>>2)];
      var $62=(($61)|0)==1;
      if ($62) { __label__ = 10; break; } else { __label__ = 12; break; }
    case 10: // $63
      var $64=$2;
      var $65=(($64+24)|0);
      var $66=HEAP32[(($65)>>2)];
      var $67=(($66)|0)==1;
      if ($67) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $68
      var $69=$2;
      var $70=(($69+54)|0);
      HEAP8[($70)]=1;
      __label__ = 12; break;
    case 12: // $71
      __label__ = 14; break;
    case 13: // $72
      var $73=$2;
      var $74=(($73+36)|0);
      var $75=HEAP32[(($74)>>2)];
      var $76=(($75+1)|0);
      HEAP32[(($74)>>2)]=$76;
      var $77=$2;
      var $78=(($77+54)|0);
      HEAP8[($78)]=1;
      __label__ = 14; break;
    case 14: // $79
      __label__ = 15; break;
    case 15: // $80
      __label__ = 16; break;
    case 16: // $81
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i["X"]=1;

function __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi($this, $info, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$info;
      $3=$current_ptr;
      $4=$path_below;
      var $5=$1;
      var $6=$3;
      var $7=$2;
      var $8=(($7+4)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $11
      var $12=$2;
      var $13=(($12+28)|0);
      var $14=HEAP32[(($13)>>2)];
      var $15=(($14)|0)!=1;
      if ($15) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $16
      var $17=$4;
      var $18=$2;
      var $19=(($18+28)|0);
      HEAP32[(($19)>>2)]=$17;
      __label__ = 3; break;
    case 3: // $20
      __label__ = 4; break;
    case 4: // $21
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this, $info, $adjustedPtr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset_to_base;
      var $vtable;
      $1=$this;
      $2=$info;
      $3=$adjustedPtr;
      $4=$path_below;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 >> 8;
      $offset_to_base=$8;
      var $9=(($5+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 1;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$3;
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      $vtable=$16;
      var $17=$vtable;
      var $18=$offset_to_base;
      var $19=(($17+$18)|0);
      var $20=$19;
      var $21=HEAP32[(($20)>>2)];
      $offset_to_base=$21;
      __label__ = 2; break;
    case 2: // $22
      var $23=(($5)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$24;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+20)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=$3;
      var $31=$offset_to_base;
      var $32=(($30+$31)|0);
      var $33=(($5+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34 & 2;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $37
      var $38=$4;
      var $41 = $38;__label__ = 5; break;
    case 4: // $39
      var $41 = 2;__label__ = 5; break;
    case 5: // $40
      var $41;
      FUNCTION_TABLE[$28]($24, $29, $32, $41);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi["X"]=1;

function __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($this, $info, $adjustedPtr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $e;
      var $p;
      $1=$this;
      $2=$info;
      $3=$adjustedPtr;
      $4=$path_below;
      var $5=$1;
      var $6=$5;
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$5;
      var $13=$2;
      var $14=$3;
      var $15=$4;
      __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi($12, $13, $14, $15);
      __label__ = 10; break;
    case 2: // $16
      var $17=(($5+16)|0);
      var $18=(($17)|0);
      var $19=(($5+12)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($18+($20<<3))|0);
      $e=$21;
      var $22=(($5+16)|0);
      var $23=(($22)|0);
      $p=$23;
      var $24=$p;
      var $25=$2;
      var $26=$3;
      var $27=$4;
      __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($24, $25, $26, $27);
      var $28=$p;
      var $29=(($28+8)|0);
      $p=$29;
      var $30=$e;
      var $31=(($29)>>>0) < (($30)>>>0);
      if ($31) { __label__ = 3; break; } else { __label__ = 9; break; }
    case 3: // $32
      __label__ = 4; break;
    case 4: // $33
      var $34=$p;
      var $35=$2;
      var $36=$3;
      var $37=$4;
      __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi($34, $35, $36, $37);
      var $38=$2;
      var $39=(($38+54)|0);
      var $40=HEAP8[($39)];
      var $41=(($40) & 1);
      if ($41) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $42
      __label__ = 8; break;
    case 6: // $43
      __label__ = 7; break;
    case 7: // $44
      var $45=$p;
      var $46=(($45+8)|0);
      $p=$46;
      var $47=$e;
      var $48=(($46)>>>0) < (($47)>>>0);
      if ($48) { __label__ = 4; break; } else { __label__ = 8; break; }
    case 8: // $49
      __label__ = 9; break;
    case 9: // $50
      __label__ = 10; break;
    case 10: // $51
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi["X"]=1;

function ___dynamic_cast($static_ptr, $static_type, $dst_type, $src2dst_offset) {
  var __stackBase__  = STACKTOP; STACKTOP += 56; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $vtable;
      var $offset_to_derived;
      var $dynamic_ptr;
      var $dynamic_type;
      var $dst_ptr;
      var $info=__stackBase__;
      $1=$static_ptr;
      $2=$static_type;
      $3=$dst_type;
      $4=$src2dst_offset;
      var $5=$1;
      var $6=$5;
      var $7=HEAP32[(($6)>>2)];
      $vtable=$7;
      var $8=$vtable;
      var $9=(($8-8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10;
      $offset_to_derived=$11;
      var $12=$1;
      var $13=$offset_to_derived;
      var $14=(($12+$13)|0);
      $dynamic_ptr=$14;
      var $15=$vtable;
      var $16=(($15-4)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=$17;
      $dynamic_type=$18;
      $dst_ptr=0;
      var $19=(($info)|0);
      var $20=$3;
      HEAP32[(($19)>>2)]=$20;
      var $21=(($info+4)|0);
      var $22=$1;
      HEAP32[(($21)>>2)]=$22;
      var $23=(($info+8)|0);
      var $24=$2;
      HEAP32[(($23)>>2)]=$24;
      var $25=(($info+12)|0);
      var $26=$4;
      HEAP32[(($25)>>2)]=$26;
      var $27=(($info+16)|0);
      HEAP32[(($27)>>2)]=0;
      var $28=(($info+20)|0);
      HEAP32[(($28)>>2)]=0;
      var $29=(($info+24)|0);
      HEAP32[(($29)>>2)]=0;
      var $30=(($info+28)|0);
      HEAP32[(($30)>>2)]=0;
      var $31=(($info+32)|0);
      HEAP32[(($31)>>2)]=0;
      var $32=(($info+36)|0);
      HEAP32[(($32)>>2)]=0;
      var $33=(($info+40)|0);
      HEAP32[(($33)>>2)]=0;
      var $34=(($info+44)|0);
      HEAP32[(($34)>>2)]=0;
      var $35=(($info+48)|0);
      HEAP32[(($35)>>2)]=0;
      var $36=(($info+52)|0);
      HEAP8[($36)]=0;
      var $37=(($info+53)|0);
      HEAP8[($37)]=0;
      var $38=(($info+54)|0);
      HEAP8[($38)]=0;
      var $39=$dynamic_type;
      var $40=$3;
      var $41=(($39)|0)==(($40)|0);
      if ($41) { __label__ = 1; break; } else { __label__ = 4; break; }
    case 1: // $42
      var $43=(($info+48)|0);
      HEAP32[(($43)>>2)]=1;
      var $44=$dynamic_type;
      var $45=$44;
      var $46=HEAP32[(($45)>>2)];
      var $47=(($46+12)|0);
      var $48=HEAP32[(($47)>>2)];
      var $49=$dynamic_ptr;
      var $50=$dynamic_ptr;
      FUNCTION_TABLE[$48]($44, $info, $49, $50, 1);
      var $51=(($info+24)|0);
      var $52=HEAP32[(($51)>>2)];
      var $53=(($52)|0)==1;
      if ($53) { __label__ = 2; break; } else { __label__ = 3; break; }
    case 2: // $54
      var $55=$dynamic_ptr;
      $dst_ptr=$55;
      __label__ = 3; break;
    case 3: // $56
      __label__ = 17; break;
    case 4: // $57
      var $58=$dynamic_type;
      var $59=$58;
      var $60=HEAP32[(($59)>>2)];
      var $61=(($60+16)|0);
      var $62=HEAP32[(($61)>>2)];
      var $63=$dynamic_ptr;
      FUNCTION_TABLE[$62]($58, $info, $63, 1);
      var $64=(($info+36)|0);
      var $65=HEAP32[(($64)>>2)];
      if ($65 == 0) {
        __label__ = 5; break;
      }
      else if ($65 == 1) {
        __label__ = 10; break;
      }
      else {
      __label__ = 16; break;
      }
      
    case 5: // $66
      var $67=(($info+40)|0);
      var $68=HEAP32[(($67)>>2)];
      var $69=(($68)|0)==1;
      if ($69) { __label__ = 6; break; } else { __label__ = 9; break; }
    case 6: // $70
      var $71=(($info+28)|0);
      var $72=HEAP32[(($71)>>2)];
      var $73=(($72)|0)==1;
      if ($73) { __label__ = 7; break; } else { __label__ = 9; break; }
    case 7: // $74
      var $75=(($info+32)|0);
      var $76=HEAP32[(($75)>>2)];
      var $77=(($76)|0)==1;
      if ($77) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $78
      var $79=(($info+20)|0);
      var $80=HEAP32[(($79)>>2)];
      $dst_ptr=$80;
      __label__ = 9; break;
    case 9: // $81
      __label__ = 16; break;
    case 10: // $82
      var $83=(($info+24)|0);
      var $84=HEAP32[(($83)>>2)];
      var $85=(($84)|0)==1;
      if ($85) { __label__ = 14; break; } else { __label__ = 11; break; }
    case 11: // $86
      var $87=(($info+40)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)==0;
      if ($89) { __label__ = 12; break; } else { __label__ = 15; break; }
    case 12: // $90
      var $91=(($info+28)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92)|0)==1;
      if ($93) { __label__ = 13; break; } else { __label__ = 15; break; }
    case 13: // $94
      var $95=(($info+32)|0);
      var $96=HEAP32[(($95)>>2)];
      var $97=(($96)|0)==1;
      if ($97) { __label__ = 14; break; } else { __label__ = 15; break; }
    case 14: // $98
      var $99=(($info+16)|0);
      var $100=HEAP32[(($99)>>2)];
      $dst_ptr=$100;
      __label__ = 15; break;
    case 15: // $101
      __label__ = 16; break;
    case 16: // $102
      __label__ = 17; break;
    case 17: // $103
      var $104=$dst_ptr;
      STACKTOP = __stackBase__;
      return $104;
    default: assert(0, "bad label: " + __label__);
  }
}
___dynamic_cast["X"]=1;

function __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($this, $info, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $is_dst_type_derived_from_static_type;
      var $does_dst_type_point_to_our_static_type;
      var $e;
      var $p;
      var $e1;
      var $p2;
      $1=$this;
      $2=$info;
      $3=$current_ptr;
      $4=$path_below;
      var $5=$1;
      var $6=$5;
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$5;
      var $13=$2;
      var $14=$3;
      var $15=$4;
      __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi($12, $13, $14, $15);
      __label__ = 68; break;
    case 2: // $16
      var $17=$5;
      var $18=$2;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17)|0)==(($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 37; break; }
    case 3: // $22
      var $23=$3;
      var $24=$2;
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($23)|0)==(($26)|0);
      if ($27) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $28
      var $29=$3;
      var $30=$2;
      var $31=(($30+20)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($29)|0)==(($32)|0);
      if ($33) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $34
      var $35=$4;
      var $36=(($35)|0)==1;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$2;
      var $39=(($38+32)|0);
      HEAP32[(($39)>>2)]=1;
      __label__ = 7; break;
    case 7: // $40
      __label__ = 36; break;
    case 8: // $41
      var $42=$4;
      var $43=$2;
      var $44=(($43+32)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$2;
      var $46=(($45+44)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=4;
      if ($48) { __label__ = 9; break; } else { __label__ = 35; break; }
    case 9: // $49
      $is_dst_type_derived_from_static_type=0;
      $does_dst_type_point_to_our_static_type=0;
      var $50=(($5+16)|0);
      var $51=(($50)|0);
      var $52=(($5+12)|0);
      var $53=HEAP32[(($52)>>2)];
      var $54=(($51+($53<<3))|0);
      $e=$54;
      var $55=(($5+16)|0);
      var $56=(($55)|0);
      $p=$56;
      __label__ = 10; break;
    case 10: // $57
      var $58=$p;
      var $59=$e;
      var $60=(($58)>>>0) < (($59)>>>0);
      if ($60) { __label__ = 11; break; } else { __label__ = 26; break; }
    case 11: // $61
      var $62=$2;
      var $63=(($62+52)|0);
      HEAP8[($63)]=0;
      var $64=$2;
      var $65=(($64+53)|0);
      HEAP8[($65)]=0;
      var $66=$p;
      var $67=$2;
      var $68=$3;
      var $69=$3;
      __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($66, $67, $68, $69, 1);
      var $70=$2;
      var $71=(($70+54)|0);
      var $72=HEAP8[($71)];
      var $73=(($72) & 1);
      if ($73) { __label__ = 12; break; } else { __label__ = 13; break; }
    case 12: // $74
      __label__ = 26; break;
    case 13: // $75
      var $76=$2;
      var $77=(($76+53)|0);
      var $78=HEAP8[($77)];
      var $79=(($78) & 1);
      if ($79) { __label__ = 14; break; } else { __label__ = 24; break; }
    case 14: // $80
      $is_dst_type_derived_from_static_type=1;
      var $81=$2;
      var $82=(($81+52)|0);
      var $83=HEAP8[($82)];
      var $84=(($83) & 1);
      if ($84) { __label__ = 15; break; } else { __label__ = 20; break; }
    case 15: // $85
      $does_dst_type_point_to_our_static_type=1;
      var $86=$2;
      var $87=(($86+24)|0);
      var $88=HEAP32[(($87)>>2)];
      var $89=(($88)|0)==1;
      if ($89) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $90
      __label__ = 26; break;
    case 17: // $91
      var $92=(($5+8)|0);
      var $93=HEAP32[(($92)>>2)];
      var $94=$93 & 2;
      var $95=(($94)|0)!=0;
      if ($95) { __label__ = 19; break; } else { __label__ = 18; break; }
    case 18: // $96
      __label__ = 26; break;
    case 19: // $97
      __label__ = 23; break;
    case 20: // $98
      var $99=(($5+8)|0);
      var $100=HEAP32[(($99)>>2)];
      var $101=$100 & 1;
      var $102=(($101)|0)!=0;
      if ($102) { __label__ = 22; break; } else { __label__ = 21; break; }
    case 21: // $103
      __label__ = 26; break;
    case 22: // $104
      __label__ = 23; break;
    case 23: // $105
      __label__ = 24; break;
    case 24: // $106
      __label__ = 25; break;
    case 25: // $107
      var $108=$p;
      var $109=(($108+8)|0);
      $p=$109;
      __label__ = 10; break;
    case 26: // $110
      var $111=$does_dst_type_point_to_our_static_type;
      var $112=(($111) & 1);
      if ($112) { __label__ = 31; break; } else { __label__ = 27; break; }
    case 27: // $113
      var $114=$3;
      var $115=$2;
      var $116=(($115+20)|0);
      HEAP32[(($116)>>2)]=$114;
      var $117=$2;
      var $118=(($117+40)|0);
      var $119=HEAP32[(($118)>>2)];
      var $120=(($119+1)|0);
      HEAP32[(($118)>>2)]=$120;
      var $121=$2;
      var $122=(($121+36)|0);
      var $123=HEAP32[(($122)>>2)];
      var $124=(($123)|0)==1;
      if ($124) { __label__ = 28; break; } else { __label__ = 30; break; }
    case 28: // $125
      var $126=$2;
      var $127=(($126+24)|0);
      var $128=HEAP32[(($127)>>2)];
      var $129=(($128)|0)==2;
      if ($129) { __label__ = 29; break; } else { __label__ = 30; break; }
    case 29: // $130
      var $131=$2;
      var $132=(($131+54)|0);
      HEAP8[($132)]=1;
      __label__ = 30; break;
    case 30: // $133
      __label__ = 31; break;
    case 31: // $134
      var $135=$is_dst_type_derived_from_static_type;
      var $136=(($135) & 1);
      if ($136) { __label__ = 32; break; } else { __label__ = 33; break; }
    case 32: // $137
      var $138=$2;
      var $139=(($138+44)|0);
      HEAP32[(($139)>>2)]=3;
      __label__ = 34; break;
    case 33: // $140
      var $141=$2;
      var $142=(($141+44)|0);
      HEAP32[(($142)>>2)]=4;
      __label__ = 34; break;
    case 34: // $143
      __label__ = 35; break;
    case 35: // $144
      __label__ = 36; break;
    case 36: // $145
      __label__ = 67; break;
    case 37: // $146
      var $147=(($5+16)|0);
      var $148=(($147)|0);
      var $149=(($5+12)|0);
      var $150=HEAP32[(($149)>>2)];
      var $151=(($148+($150<<3))|0);
      $e1=$151;
      var $152=(($5+16)|0);
      var $153=(($152)|0);
      $p2=$153;
      var $154=$p2;
      var $155=$2;
      var $156=$3;
      var $157=$4;
      __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($154, $155, $156, $157);
      var $158=$p2;
      var $159=(($158+8)|0);
      $p2=$159;
      var $160=$e1;
      var $161=(($159)>>>0) < (($160)>>>0);
      if ($161) { __label__ = 38; break; } else { __label__ = 66; break; }
    case 38: // $162
      var $163=(($5+8)|0);
      var $164=HEAP32[(($163)>>2)];
      var $165=$164 & 2;
      var $166=(($165)|0)!=0;
      if ($166) { __label__ = 40; break; } else { __label__ = 39; break; }
    case 39: // $167
      var $168=$2;
      var $169=(($168+36)|0);
      var $170=HEAP32[(($169)>>2)];
      var $171=(($170)|0)==1;
      if ($171) { __label__ = 40; break; } else { __label__ = 46; break; }
    case 40: // $172
      __label__ = 41; break;
    case 41: // $173
      var $174=$2;
      var $175=(($174+54)|0);
      var $176=HEAP8[($175)];
      var $177=(($176) & 1);
      if ($177) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $178
      __label__ = 45; break;
    case 43: // $179
      var $180=$p2;
      var $181=$2;
      var $182=$3;
      var $183=$4;
      __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($180, $181, $182, $183);
      __label__ = 44; break;
    case 44: // $184
      var $185=$p2;
      var $186=(($185+8)|0);
      $p2=$186;
      var $187=$e1;
      var $188=(($186)>>>0) < (($187)>>>0);
      if ($188) { __label__ = 41; break; } else { __label__ = 45; break; }
    case 45: // $189
      __label__ = 65; break;
    case 46: // $190
      var $191=(($5+8)|0);
      var $192=HEAP32[(($191)>>2)];
      var $193=$192 & 1;
      var $194=(($193)|0)!=0;
      if ($194) { __label__ = 47; break; } else { __label__ = 56; break; }
    case 47: // $195
      __label__ = 48; break;
    case 48: // $196
      var $197=$2;
      var $198=(($197+54)|0);
      var $199=HEAP8[($198)];
      var $200=(($199) & 1);
      if ($200) { __label__ = 49; break; } else { __label__ = 50; break; }
    case 49: // $201
      __label__ = 55; break;
    case 50: // $202
      var $203=$2;
      var $204=(($203+36)|0);
      var $205=HEAP32[(($204)>>2)];
      var $206=(($205)|0)==1;
      if ($206) { __label__ = 51; break; } else { __label__ = 53; break; }
    case 51: // $207
      var $208=$2;
      var $209=(($208+24)|0);
      var $210=HEAP32[(($209)>>2)];
      var $211=(($210)|0)==1;
      if ($211) { __label__ = 52; break; } else { __label__ = 53; break; }
    case 52: // $212
      __label__ = 55; break;
    case 53: // $213
      var $214=$p2;
      var $215=$2;
      var $216=$3;
      var $217=$4;
      __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($214, $215, $216, $217);
      __label__ = 54; break;
    case 54: // $218
      var $219=$p2;
      var $220=(($219+8)|0);
      $p2=$220;
      var $221=$e1;
      var $222=(($220)>>>0) < (($221)>>>0);
      if ($222) { __label__ = 48; break; } else { __label__ = 55; break; }
    case 55: // $223
      __label__ = 64; break;
    case 56: // $224
      __label__ = 57; break;
    case 57: // $225
      var $226=$2;
      var $227=(($226+54)|0);
      var $228=HEAP8[($227)];
      var $229=(($228) & 1);
      if ($229) { __label__ = 58; break; } else { __label__ = 59; break; }
    case 58: // $230
      __label__ = 63; break;
    case 59: // $231
      var $232=$2;
      var $233=(($232+36)|0);
      var $234=HEAP32[(($233)>>2)];
      var $235=(($234)|0)==1;
      if ($235) { __label__ = 60; break; } else { __label__ = 61; break; }
    case 60: // $236
      __label__ = 63; break;
    case 61: // $237
      var $238=$p2;
      var $239=$2;
      var $240=$3;
      var $241=$4;
      __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($238, $239, $240, $241);
      __label__ = 62; break;
    case 62: // $242
      var $243=$p2;
      var $244=(($243+8)|0);
      $p2=$244;
      var $245=$e1;
      var $246=(($244)>>>0) < (($245)>>>0);
      if ($246) { __label__ = 57; break; } else { __label__ = 63; break; }
    case 63: // $247
      __label__ = 64; break;
    case 64: // $248
      __label__ = 65; break;
    case 65: // $249
      __label__ = 66; break;
    case 66: // $250
      __label__ = 67; break;
    case 67: // $251
      __label__ = 68; break;
    case 68: // $252
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi["X"]=1;

function __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($this, $info, $dst_ptr, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $offset_to_base;
      var $vtable;
      $1=$this;
      $2=$info;
      $3=$dst_ptr;
      $4=$current_ptr;
      $5=$path_below;
      var $6=$1;
      var $7=(($6+4)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=$8 >> 8;
      $offset_to_base=$9;
      var $10=(($6+4)|0);
      var $11=HEAP32[(($10)>>2)];
      var $12=$11 & 1;
      var $13=(($12)|0)!=0;
      if ($13) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $14
      var $15=$4;
      var $16=$15;
      var $17=HEAP32[(($16)>>2)];
      $vtable=$17;
      var $18=$vtable;
      var $19=$offset_to_base;
      var $20=(($18+$19)|0);
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      $offset_to_base=$22;
      __label__ = 2; break;
    case 2: // $23
      var $24=(($6)|0);
      var $25=HEAP32[(($24)>>2)];
      var $26=$25;
      var $27=HEAP32[(($26)>>2)];
      var $28=(($27+12)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=$2;
      var $31=$3;
      var $32=$4;
      var $33=$offset_to_base;
      var $34=(($32+$33)|0);
      var $35=(($6+4)|0);
      var $36=HEAP32[(($35)>>2)];
      var $37=$36 & 2;
      var $38=(($37)|0)!=0;
      if ($38) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $39
      var $40=$5;
      var $43 = $40;__label__ = 5; break;
    case 4: // $41
      var $43 = 2;__label__ = 5; break;
    case 5: // $42
      var $43;
      FUNCTION_TABLE[$29]($25, $30, $31, $34, $43);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i["X"]=1;

function __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($this, $info, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $offset_to_base;
      var $vtable;
      $1=$this;
      $2=$info;
      $3=$current_ptr;
      $4=$path_below;
      var $5=$1;
      var $6=(($5+4)|0);
      var $7=HEAP32[(($6)>>2)];
      var $8=$7 >> 8;
      $offset_to_base=$8;
      var $9=(($5+4)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=$10 & 1;
      var $12=(($11)|0)!=0;
      if ($12) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $13
      var $14=$3;
      var $15=$14;
      var $16=HEAP32[(($15)>>2)];
      $vtable=$16;
      var $17=$vtable;
      var $18=$offset_to_base;
      var $19=(($17+$18)|0);
      var $20=$19;
      var $21=HEAP32[(($20)>>2)];
      $offset_to_base=$21;
      __label__ = 2; break;
    case 2: // $22
      var $23=(($5)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$24;
      var $26=HEAP32[(($25)>>2)];
      var $27=(($26+16)|0);
      var $28=HEAP32[(($27)>>2)];
      var $29=$2;
      var $30=$3;
      var $31=$offset_to_base;
      var $32=(($30+$31)|0);
      var $33=(($5+4)|0);
      var $34=HEAP32[(($33)>>2)];
      var $35=$34 & 2;
      var $36=(($35)|0)!=0;
      if ($36) { __label__ = 3; break; } else { __label__ = 4; break; }
    case 3: // $37
      var $38=$4;
      var $41 = $38;__label__ = 5; break;
    case 4: // $39
      var $41 = 2;__label__ = 5; break;
    case 5: // $40
      var $41;
      FUNCTION_TABLE[$28]($24, $29, $32, $41);
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi["X"]=1;

function __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($this, $info, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $is_dst_type_derived_from_static_type;
      var $does_dst_type_point_to_our_static_type;
      $1=$this;
      $2=$info;
      $3=$current_ptr;
      $4=$path_below;
      var $5=$1;
      var $6=$5;
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$5;
      var $13=$2;
      var $14=$3;
      var $15=$4;
      __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi($12, $13, $14, $15);
      __label__ = 26; break;
    case 2: // $16
      var $17=$5;
      var $18=$2;
      var $19=(($18)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=(($17)|0)==(($20)|0);
      if ($21) { __label__ = 3; break; } else { __label__ = 24; break; }
    case 3: // $22
      var $23=$3;
      var $24=$2;
      var $25=(($24+16)|0);
      var $26=HEAP32[(($25)>>2)];
      var $27=(($23)|0)==(($26)|0);
      if ($27) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $28
      var $29=$3;
      var $30=$2;
      var $31=(($30+20)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($29)|0)==(($32)|0);
      if ($33) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $34
      var $35=$4;
      var $36=(($35)|0)==1;
      if ($36) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $37
      var $38=$2;
      var $39=(($38+32)|0);
      HEAP32[(($39)>>2)]=1;
      __label__ = 7; break;
    case 7: // $40
      __label__ = 23; break;
    case 8: // $41
      var $42=$4;
      var $43=$2;
      var $44=(($43+32)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$2;
      var $46=(($45+44)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47)|0)!=4;
      if ($48) { __label__ = 9; break; } else { __label__ = 22; break; }
    case 9: // $49
      $is_dst_type_derived_from_static_type=0;
      $does_dst_type_point_to_our_static_type=0;
      var $50=$2;
      var $51=(($50+52)|0);
      HEAP8[($51)]=0;
      var $52=$2;
      var $53=(($52+53)|0);
      HEAP8[($53)]=0;
      var $54=(($5+8)|0);
      var $55=HEAP32[(($54)>>2)];
      var $56=$55;
      var $57=HEAP32[(($56)>>2)];
      var $58=(($57+12)|0);
      var $59=HEAP32[(($58)>>2)];
      var $60=$2;
      var $61=$3;
      var $62=$3;
      FUNCTION_TABLE[$59]($55, $60, $61, $62, 1);
      var $63=$2;
      var $64=(($63+53)|0);
      var $65=HEAP8[($64)];
      var $66=(($65) & 1);
      if ($66) { __label__ = 10; break; } else { __label__ = 13; break; }
    case 10: // $67
      $is_dst_type_derived_from_static_type=1;
      var $68=$2;
      var $69=(($68+52)|0);
      var $70=HEAP8[($69)];
      var $71=(($70) & 1);
      if ($71) { __label__ = 11; break; } else { __label__ = 12; break; }
    case 11: // $72
      $does_dst_type_point_to_our_static_type=1;
      __label__ = 12; break;
    case 12: // $73
      __label__ = 13; break;
    case 13: // $74
      var $75=$does_dst_type_point_to_our_static_type;
      var $76=(($75) & 1);
      if ($76) { __label__ = 18; break; } else { __label__ = 14; break; }
    case 14: // $77
      var $78=$3;
      var $79=$2;
      var $80=(($79+20)|0);
      HEAP32[(($80)>>2)]=$78;
      var $81=$2;
      var $82=(($81+40)|0);
      var $83=HEAP32[(($82)>>2)];
      var $84=(($83+1)|0);
      HEAP32[(($82)>>2)]=$84;
      var $85=$2;
      var $86=(($85+36)|0);
      var $87=HEAP32[(($86)>>2)];
      var $88=(($87)|0)==1;
      if ($88) { __label__ = 15; break; } else { __label__ = 17; break; }
    case 15: // $89
      var $90=$2;
      var $91=(($90+24)|0);
      var $92=HEAP32[(($91)>>2)];
      var $93=(($92)|0)==2;
      if ($93) { __label__ = 16; break; } else { __label__ = 17; break; }
    case 16: // $94
      var $95=$2;
      var $96=(($95+54)|0);
      HEAP8[($96)]=1;
      __label__ = 17; break;
    case 17: // $97
      __label__ = 18; break;
    case 18: // $98
      var $99=$is_dst_type_derived_from_static_type;
      var $100=(($99) & 1);
      if ($100) { __label__ = 19; break; } else { __label__ = 20; break; }
    case 19: // $101
      var $102=$2;
      var $103=(($102+44)|0);
      HEAP32[(($103)>>2)]=3;
      __label__ = 21; break;
    case 20: // $104
      var $105=$2;
      var $106=(($105+44)|0);
      HEAP32[(($106)>>2)]=4;
      __label__ = 21; break;
    case 21: // $107
      __label__ = 22; break;
    case 22: // $108
      __label__ = 23; break;
    case 23: // $109
      __label__ = 25; break;
    case 24: // $110
      var $111=(($5+8)|0);
      var $112=HEAP32[(($111)>>2)];
      var $113=$112;
      var $114=HEAP32[(($113)>>2)];
      var $115=(($114+16)|0);
      var $116=HEAP32[(($115)>>2)];
      var $117=$2;
      var $118=$3;
      var $119=$4;
      FUNCTION_TABLE[$116]($112, $117, $118, $119);
      __label__ = 25; break;
    case 25: // $120
      __label__ = 26; break;
    case 26: // $121
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi["X"]=1;

function __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi($this, $info, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      $1=$this;
      $2=$info;
      $3=$current_ptr;
      $4=$path_below;
      var $5=$1;
      var $6=$2;
      var $7=(($6+8)|0);
      var $8=HEAP32[(($7)>>2)];
      var $9=(($5)|0)==(($8)|0);
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $10
      var $11=$2;
      var $12=$3;
      var $13=$4;
      __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi($5, $11, $12, $13);
      __label__ = 14; break;
    case 2: // $14
      var $15=$2;
      var $16=(($15)|0);
      var $17=HEAP32[(($16)>>2)];
      var $18=(($5)|0)==(($17)|0);
      if ($18) { __label__ = 3; break; } else { __label__ = 13; break; }
    case 3: // $19
      var $20=$3;
      var $21=$2;
      var $22=(($21+16)|0);
      var $23=HEAP32[(($22)>>2)];
      var $24=(($20)|0)==(($23)|0);
      if ($24) { __label__ = 5; break; } else { __label__ = 4; break; }
    case 4: // $25
      var $26=$3;
      var $27=$2;
      var $28=(($27+20)|0);
      var $29=HEAP32[(($28)>>2)];
      var $30=(($26)|0)==(($29)|0);
      if ($30) { __label__ = 5; break; } else { __label__ = 8; break; }
    case 5: // $31
      var $32=$4;
      var $33=(($32)|0)==1;
      if ($33) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $34
      var $35=$2;
      var $36=(($35+32)|0);
      HEAP32[(($36)>>2)]=1;
      __label__ = 7; break;
    case 7: // $37
      __label__ = 12; break;
    case 8: // $38
      var $39=$4;
      var $40=$2;
      var $41=(($40+32)|0);
      HEAP32[(($41)>>2)]=$39;
      var $42=$3;
      var $43=$2;
      var $44=(($43+20)|0);
      HEAP32[(($44)>>2)]=$42;
      var $45=$2;
      var $46=(($45+40)|0);
      var $47=HEAP32[(($46)>>2)];
      var $48=(($47+1)|0);
      HEAP32[(($46)>>2)]=$48;
      var $49=$2;
      var $50=(($49+36)|0);
      var $51=HEAP32[(($50)>>2)];
      var $52=(($51)|0)==1;
      if ($52) { __label__ = 9; break; } else { __label__ = 11; break; }
    case 9: // $53
      var $54=$2;
      var $55=(($54+24)|0);
      var $56=HEAP32[(($55)>>2)];
      var $57=(($56)|0)==2;
      if ($57) { __label__ = 10; break; } else { __label__ = 11; break; }
    case 10: // $58
      var $59=$2;
      var $60=(($59+54)|0);
      HEAP8[($60)]=1;
      __label__ = 11; break;
    case 11: // $61
      var $62=$2;
      var $63=(($62+44)|0);
      HEAP32[(($63)>>2)]=4;
      __label__ = 12; break;
    case 12: // $64
      __label__ = 13; break;
    case 13: // $65
      __label__ = 14; break;
    case 14: // $66
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi["X"]=1;

function __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($this, $info, $dst_ptr, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      var $found_our_static_ptr;
      var $found_any_static_type;
      var $e;
      var $p;
      $1=$this;
      $2=$info;
      $3=$dst_ptr;
      $4=$current_ptr;
      $5=$path_below;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($7)|0)==(($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$6;
      var $14=$2;
      var $15=$3;
      var $16=$4;
      var $17=$5;
      __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($13, $14, $15, $16, $17);
      __label__ = 21; break;
    case 2: // $18
      var $19=$2;
      var $20=(($19+52)|0);
      var $21=HEAP8[($20)];
      var $22=(($21) & 1);
      var $23=(($22)&1);
      $found_our_static_ptr=$23;
      var $24=$2;
      var $25=(($24+53)|0);
      var $26=HEAP8[($25)];
      var $27=(($26) & 1);
      var $28=(($27)&1);
      $found_any_static_type=$28;
      var $29=(($6+16)|0);
      var $30=(($29)|0);
      var $31=(($6+12)|0);
      var $32=HEAP32[(($31)>>2)];
      var $33=(($30+($32<<3))|0);
      $e=$33;
      var $34=(($6+16)|0);
      var $35=(($34)|0);
      $p=$35;
      var $36=$2;
      var $37=(($36+52)|0);
      HEAP8[($37)]=0;
      var $38=$2;
      var $39=(($38+53)|0);
      HEAP8[($39)]=0;
      var $40=$p;
      var $41=$2;
      var $42=$3;
      var $43=$4;
      var $44=$5;
      __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($40, $41, $42, $43, $44);
      var $45=$p;
      var $46=(($45+8)|0);
      $p=$46;
      var $47=$e;
      var $48=(($46)>>>0) < (($47)>>>0);
      if ($48) { __label__ = 3; break; } else { __label__ = 20; break; }
    case 3: // $49
      __label__ = 4; break;
    case 4: // $50
      var $51=$2;
      var $52=(($51+54)|0);
      var $53=HEAP8[($52)];
      var $54=(($53) & 1);
      if ($54) { __label__ = 5; break; } else { __label__ = 6; break; }
    case 5: // $55
      __label__ = 19; break;
    case 6: // $56
      var $57=$2;
      var $58=(($57+52)|0);
      var $59=HEAP8[($58)];
      var $60=(($59) & 1);
      if ($60) { __label__ = 7; break; } else { __label__ = 12; break; }
    case 7: // $61
      var $62=$2;
      var $63=(($62+24)|0);
      var $64=HEAP32[(($63)>>2)];
      var $65=(($64)|0)==1;
      if ($65) { __label__ = 8; break; } else { __label__ = 9; break; }
    case 8: // $66
      __label__ = 19; break;
    case 9: // $67
      var $68=(($6+8)|0);
      var $69=HEAP32[(($68)>>2)];
      var $70=$69 & 2;
      var $71=(($70)|0)!=0;
      if ($71) { __label__ = 11; break; } else { __label__ = 10; break; }
    case 10: // $72
      __label__ = 19; break;
    case 11: // $73
      __label__ = 17; break;
    case 12: // $74
      var $75=$2;
      var $76=(($75+53)|0);
      var $77=HEAP8[($76)];
      var $78=(($77) & 1);
      if ($78) { __label__ = 13; break; } else { __label__ = 16; break; }
    case 13: // $79
      var $80=(($6+8)|0);
      var $81=HEAP32[(($80)>>2)];
      var $82=$81 & 1;
      var $83=(($82)|0)!=0;
      if ($83) { __label__ = 15; break; } else { __label__ = 14; break; }
    case 14: // $84
      __label__ = 19; break;
    case 15: // $85
      __label__ = 16; break;
    case 16: // $86
      __label__ = 17; break;
    case 17: // $87
      var $88=$2;
      var $89=(($88+52)|0);
      HEAP8[($89)]=0;
      var $90=$2;
      var $91=(($90+53)|0);
      HEAP8[($91)]=0;
      var $92=$p;
      var $93=$2;
      var $94=$3;
      var $95=$4;
      var $96=$5;
      __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($92, $93, $94, $95, $96);
      __label__ = 18; break;
    case 18: // $97
      var $98=$p;
      var $99=(($98+8)|0);
      $p=$99;
      var $100=$e;
      var $101=(($99)>>>0) < (($100)>>>0);
      if ($101) { __label__ = 4; break; } else { __label__ = 19; break; }
    case 19: // $102
      __label__ = 20; break;
    case 20: // $103
      var $104=$found_our_static_ptr;
      var $105=(($104) & 1);
      var $106=$2;
      var $107=(($106+52)|0);
      var $108=(($105)&1);
      HEAP8[($107)]=$108;
      var $109=$found_any_static_type;
      var $110=(($109) & 1);
      var $111=$2;
      var $112=(($111+53)|0);
      var $113=(($110)&1);
      HEAP8[($112)]=$113;
      __label__ = 21; break;
    case 21: // $114
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}
__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i["X"]=1;

function __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($this, $info, $dst_ptr, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$info;
      $3=$dst_ptr;
      $4=$current_ptr;
      $5=$path_below;
      var $6=$1;
      var $7=$6;
      var $8=$2;
      var $9=(($8+8)|0);
      var $10=HEAP32[(($9)>>2)];
      var $11=(($7)|0)==(($10)|0);
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $12
      var $13=$6;
      var $14=$2;
      var $15=$3;
      var $16=$4;
      var $17=$5;
      __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($13, $14, $15, $16, $17);
      __label__ = 3; break;
    case 2: // $18
      var $19=(($6+8)|0);
      var $20=HEAP32[(($19)>>2)];
      var $21=$20;
      var $22=HEAP32[(($21)>>2)];
      var $23=(($22+12)|0);
      var $24=HEAP32[(($23)>>2)];
      var $25=$2;
      var $26=$3;
      var $27=$4;
      var $28=$5;
      FUNCTION_TABLE[$24]($20, $25, $26, $27, $28);
      __label__ = 3; break;
    case 3: // $29
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($this, $info, $dst_ptr, $current_ptr, $path_below) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $5;
      $1=$this;
      $2=$info;
      $3=$dst_ptr;
      $4=$current_ptr;
      $5=$path_below;
      var $6=$1;
      var $7=$2;
      var $8=(($7+8)|0);
      var $9=HEAP32[(($8)>>2)];
      var $10=(($6)|0)==(($9)|0);
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; }
    case 1: // $11
      var $12=$2;
      var $13=$3;
      var $14=$4;
      var $15=$5;
      __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i($6, $12, $13, $14, $15);
      __label__ = 2; break;
    case 2: // $16
      ;
      return;
    default: assert(0, "bad label: " + __label__);
  }
}


function _malloc($bytes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $mem;
      var $nb;
      var $idx;
      var $smallbits;
      var $b;
      var $p;
      var $F;
      var $b1;
      var $p2;
      var $r;
      var $rsize;
      var $i;
      var $leftbits;
      var $leastbit;
      var $Y;
      var $K;
      var $N;
      var $F3;
      var $DVS;
      var $DV;
      var $I;
      var $B;
      var $F4;
      var $rsize5;
      var $p6;
      var $r7;
      var $dvs;
      var $rsize8;
      var $p9;
      var $r10;
      $1=$bytes;
      var $2=$1; //@line 4628 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $3=(($2)>>>0) <= 244; //@line 4628 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($3) { __label__ = 1; break; } else { __label__ = 36; break; } //@line 4628 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $4
      var $5=$1; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5)>>>0) < 11; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($6) { __label__ = 2; break; } else { __label__ = 3; break; } //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $7
      var $14 = 16;__label__ = 4; break; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $8
      var $9=$1; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=(($9+4)|0); //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=(($10+7)|0); //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$11 & -8; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14 = $12;__label__ = 4; break; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $13
      var $14; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nb=$14; //@line 4631 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$nb; //@line 4632 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$15 >>> 3; //@line 4632 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $idx=$16; //@line 4632 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=HEAPU32[((((__gm_)|0))>>2)]; //@line 4633 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=$idx; //@line 4633 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=$17 >>> (($18)>>>0); //@line 4633 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $smallbits=$19; //@line 4633 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$smallbits; //@line 4635 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=$20 & 3; //@line 4635 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=(($21)|0)!=0; //@line 4635 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($22) { __label__ = 5; break; } else { __label__ = 12; break; } //@line 4635 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $23
      var $24=$smallbits; //@line 4637 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$24 ^ -1; //@line 4637 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=$25 & 1; //@line 4637 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$idx; //@line 4637 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=(($27+$26)|0); //@line 4637 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $idx=$28; //@line 4637 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=$idx; //@line 4638 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$29 << 1; //@line 4638 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=((((__gm_+40)|0)+($30<<2))|0); //@line 4638 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=$31; //@line 4638 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$32; //@line 4638 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $b=$33; //@line 4638 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=$b; //@line 4639 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=(($34+8)|0); //@line 4639 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=HEAP32[(($35)>>2)]; //@line 4639 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$36; //@line 4639 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$p; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=(($37+8)|0); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=HEAP32[(($38)>>2)]; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$39; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=$b; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$F; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=(($40)|0)==(($41)|0); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($42) { __label__ = 6; break; } else { __label__ = 7; break; } //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $43
      var $44=$idx; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=1 << $44; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=$45 ^ -1; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=HEAP32[((((__gm_)|0))>>2)]; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $48=$47 & $46; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_)|0))>>2)]=$48; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 11; break; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $49
      var $50=$F; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=$50; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=(($51)>>>0) >= (($52)>>>0); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=(($53)&1); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=(($54)==(1)); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=(($55)|0)!=0; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($56) { __label__ = 8; break; } else { __label__ = 9; break; } //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $57
      var $58=$F; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$b; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=(($59+8)|0); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($60)>>2)]=$58; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=$b; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=$F; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=(($62+12)|0); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($63)>>2)]=$61; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 10; break; //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $64
      _abort(); //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4641 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $65
      __label__ = 11; break;
    case 11: // $66
      var $67=$idx; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=$67 << 3; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=$68 | 1; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=$69 | 2; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=$p; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=(($71+4)|0); //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($72)>>2)]=$70; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=$p; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=$73; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=$idx; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=$75 << 3; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=(($74+$76)|0); //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=$77; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=(($78+4)|0); //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=HEAP32[(($79)>>2)]; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=$80 | 1; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($79)>>2)]=$81; //@line 4642 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=$p; //@line 4643 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=$82; //@line 4643 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=(($83+8)|0); //@line 4643 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$84; //@line 4643 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 52; break; //@line 4645 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $85
      var $86=$nb; //@line 4648 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=HEAPU32[((((__gm_+8)|0))>>2)]; //@line 4648 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=(($86)>>>0) > (($87)>>>0); //@line 4648 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($88) { __label__ = 13; break; } else { __label__ = 34; break; } //@line 4648 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $89
      var $90=$smallbits; //@line 4649 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=(($90)|0)!=0; //@line 4649 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($91) { __label__ = 14; break; } else { __label__ = 29; break; } //@line 4649 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $92
      var $93=$smallbits; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=$idx; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=$93 << $94; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=$idx; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=1 << $96; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=$97 << 1; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=$idx; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=1 << $99; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$100 << 1; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=(((-$101))|0); //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=$98 | $102; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=$95 & $103; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $leftbits=$104; //@line 4653 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $105=$leftbits; //@line 4654 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=$leftbits; //@line 4654 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=(((-$106))|0); //@line 4654 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=$105 & $107; //@line 4654 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $leastbit=$108; //@line 4654 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $109=$leastbit; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $110=(($109-1)|0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$110; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=$111 >>> 12; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=$112 & 16; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$113; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=$K; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$114; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=$K; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=$116 >>> (($115)>>>0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$117; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $119=$118 >>> 5; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=$119 & 8; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$120; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=$N; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=(($121+$120)|0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$122; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $123=$K; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $124=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=$124 >>> (($123)>>>0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$125; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=$126 >>> 2; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=$127 & 4; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$128; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=$N; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=(($129+$128)|0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$130; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=$K; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $132=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=$132 >>> (($131)>>>0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$133; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=$134 >>> 1; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=$135 & 2; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$136; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $137=$N; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $138=(($137+$136)|0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$138; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=$K; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $140=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=$140 >>> (($139)>>>0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$141; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=$142 >>> 1; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=$143 & 1; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$144; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=$N; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=(($145+$144)|0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$146; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=$K; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $149=$148 >>> (($147)>>>0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$149; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $150=$N; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=$Y; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=(($150+$151)|0); //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $i=$152; //@line 4655 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=$i; //@line 4656 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=$153 << 1; //@line 4656 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=((((__gm_+40)|0)+($154<<2))|0); //@line 4656 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=$155; //@line 4656 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=$156; //@line 4656 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $b1=$157; //@line 4656 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=$b1; //@line 4657 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=(($158+8)|0); //@line 4657 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=HEAP32[(($159)>>2)]; //@line 4657 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p2=$160; //@line 4657 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=$p2; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=(($161+8)|0); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=HEAP32[(($162)>>2)]; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F3=$163; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $164=$b1; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=$F3; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $166=(($164)|0)==(($165)|0); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($166) { __label__ = 15; break; } else { __label__ = 16; break; } //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $167
      var $168=$i; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=1 << $168; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=$169 ^ -1; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $171=HEAP32[((((__gm_)|0))>>2)]; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=$171 & $170; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_)|0))>>2)]=$172; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 20; break; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $173
      var $174=$F3; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $175=$174; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $177=(($175)>>>0) >= (($176)>>>0); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $178=(($177)&1); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $179=(($178)==(1)); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $180=(($179)|0)!=0; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($180) { __label__ = 17; break; } else { __label__ = 18; break; } //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $181
      var $182=$F3; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=$b1; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $184=(($183+8)|0); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($184)>>2)]=$182; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $185=$b1; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $186=$F3; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $187=(($186+12)|0); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($187)>>2)]=$185; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 19; break; //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $188
      _abort(); //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4659 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $189
      __label__ = 20; break;
    case 20: // $190
      var $191=$i; //@line 4660 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $192=$191 << 3; //@line 4660 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $193=$nb; //@line 4660 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=(($192-$193)|0); //@line 4660 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$194; //@line 4660 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $195=$nb; //@line 4665 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=$195 | 1; //@line 4665 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $197=$196 | 2; //@line 4665 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $198=$p2; //@line 4665 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=(($198+4)|0); //@line 4665 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($199)>>2)]=$197; //@line 4665 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $200=$p2; //@line 4666 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $201=$200; //@line 4666 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $202=$nb; //@line 4666 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $203=(($201+$202)|0); //@line 4666 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=$203; //@line 4666 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $r=$204; //@line 4666 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=$rsize; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=$205 | 1; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=$r; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=(($207+4)|0); //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($208)>>2)]=$206; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=$rsize; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=$r; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=$210; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=$rsize; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $213=(($211+$212)|0); //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $214=$213; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $215=(($214)|0); //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($215)>>2)]=$209; //@line 4667 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $216=HEAP32[((((__gm_+8)|0))>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $DVS=$216; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $217=$DVS; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $218=(($217)|0)!=0; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($218) { __label__ = 21; break; } else { __label__ = 28; break; } //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $219
      var $220=HEAP32[((((__gm_+20)|0))>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $DV=$220; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $221=$DVS; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $222=$221 >>> 3; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$222; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $223=$I; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $224=$223 << 1; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $225=((((__gm_+40)|0)+($224<<2))|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $226=$225; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=$226; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B=$227; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=$B; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F4=$228; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $229=HEAP32[((((__gm_)|0))>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230=$I; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $231=1 << $230; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $232=$229 & $231; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $233=(($232)|0)!=0; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($233) { __label__ = 23; break; } else { __label__ = 22; break; } //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $234
      var $235=$I; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $236=1 << $235; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=HEAP32[((((__gm_)|0))>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $238=$237 | $236; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_)|0))>>2)]=$238; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 27; break; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $239
      var $240=$B; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $241=(($240+8)|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $242=HEAP32[(($241)>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=$242; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $245=(($243)>>>0) >= (($244)>>>0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=(($245)&1); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=(($246)==(1)); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=(($247)|0)!=0; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($248) { __label__ = 24; break; } else { __label__ = 25; break; } //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $249
      var $250=$B; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $251=(($250+8)|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $252=HEAP32[(($251)>>2)]; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F4=$252; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 26; break; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $253
      _abort(); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $254
      __label__ = 27; break;
    case 27: // $255
      var $256=$DV; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $257=$B; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $258=(($257+8)|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($258)>>2)]=$256; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=$DV; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=$F4; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $261=(($260+12)|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($261)>>2)]=$259; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $262=$F4; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $263=$DV; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $264=(($263+8)|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($264)>>2)]=$262; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $265=$B; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $266=$DV; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $267=(($266+12)|0); //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($267)>>2)]=$265; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 28; break; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $268
      var $269=$rsize; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=$269; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $270=$r; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+20)|0))>>2)]=$270; //@line 4668 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $271=$p2; //@line 4670 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $272=$271; //@line 4670 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $273=(($272+8)|0); //@line 4670 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$273; //@line 4670 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 52; break; //@line 4672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $274
      var $275=HEAP32[((((__gm_+4)|0))>>2)]; //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=(($275)|0)!=0; //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($276) { __label__ = 30; break; } else { __label__ = 32; break; } //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $277
      var $278=$nb; //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=_tmalloc_small(__gm_, $278); //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$279; //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $280=(($279)|0)!=0; //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($280) { __label__ = 31; break; } else { __label__ = 32; break; } //@line 4675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $281
      __label__ = 52; break; //@line 4677 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $282
      __label__ = 33; break;
    case 33: // $283
      __label__ = 34; break; //@line 4679 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $284
      __label__ = 35; break;
    case 35: // $285
      __label__ = 43; break; //@line 4680 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $286
      var $287=$1; //@line 4681 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=(($287)>>>0) >= 4294967232; //@line 4681 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($288) { __label__ = 37; break; } else { __label__ = 38; break; } //@line 4681 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $289
      $nb=-1; //@line 4682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 42; break; //@line 4682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $290
      var $291=$1; //@line 4684 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $292=(($291+4)|0); //@line 4684 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $293=(($292+7)|0); //@line 4684 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $294=$293 & -8; //@line 4684 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nb=$294; //@line 4684 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $295=HEAP32[((((__gm_+4)|0))>>2)]; //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $296=(($295)|0)!=0; //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($296) { __label__ = 39; break; } else { __label__ = 41; break; } //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 39: // $297
      var $298=$nb; //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $299=_tmalloc_large(__gm_, $298); //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$299; //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $300=(($299)|0)!=0; //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($300) { __label__ = 40; break; } else { __label__ = 41; break; } //@line 4685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $301
      __label__ = 52; break; //@line 4687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 41: // $302
      __label__ = 42; break;
    case 42: // $303
      __label__ = 43; break;
    case 43: // $304
      var $305=$nb; //@line 4691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $306=HEAPU32[((((__gm_+8)|0))>>2)]; //@line 4691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $307=(($305)>>>0) <= (($306)>>>0); //@line 4691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($307) { __label__ = 44; break; } else { __label__ = 48; break; } //@line 4691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $308
      var $309=HEAP32[((((__gm_+8)|0))>>2)]; //@line 4692 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $310=$nb; //@line 4692 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $311=(($309-$310)|0); //@line 4692 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize5=$311; //@line 4692 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $312=HEAP32[((((__gm_+20)|0))>>2)]; //@line 4693 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p6=$312; //@line 4693 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $313=$rsize5; //@line 4694 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $314=(($313)>>>0) >= 16; //@line 4694 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($314) { __label__ = 45; break; } else { __label__ = 46; break; } //@line 4694 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $315
      var $316=$p6; //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=$316; //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $318=$nb; //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $319=(($317+$318)|0); //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $320=$319; //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+20)|0))>>2)]=$320; //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $r7=$320; //@line 4695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=$rsize5; //@line 4696 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=$321; //@line 4696 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $322=$rsize5; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=$322 | 1; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=$r7; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=(($324+4)|0); //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($325)>>2)]=$323; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=$rsize5; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $327=$r7; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $328=$327; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $329=$rsize5; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $330=(($328+$329)|0); //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $331=$330; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $332=(($331)|0); //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($332)>>2)]=$326; //@line 4697 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $333=$nb; //@line 4698 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $334=$333 | 1; //@line 4698 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $335=$334 | 2; //@line 4698 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $336=$p6; //@line 4698 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $337=(($336+4)|0); //@line 4698 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($337)>>2)]=$335; //@line 4698 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 47; break; //@line 4699 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $338
      var $339=HEAP32[((((__gm_+8)|0))>>2)]; //@line 4701 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $dvs=$339; //@line 4701 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=0; //@line 4702 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+20)|0))>>2)]=0; //@line 4703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=$dvs; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=$340 | 1; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=$341 | 2; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $343=$p6; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $344=(($343+4)|0); //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($344)>>2)]=$342; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $345=$p6; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=$345; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=$dvs; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348=(($346+$347)|0); //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $349=$348; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=(($349+4)|0); //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=HEAP32[(($350)>>2)]; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=$351 | 1; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($350)>>2)]=$352; //@line 4704 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 47; break;
    case 47: // $353
      var $354=$p6; //@line 4706 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $355=$354; //@line 4706 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $356=(($355+8)|0); //@line 4706 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$356; //@line 4706 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 52; break; //@line 4708 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $357
      var $358=$nb; //@line 4711 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=HEAPU32[((((__gm_+12)|0))>>2)]; //@line 4711 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $360=(($358)>>>0) < (($359)>>>0); //@line 4711 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($360) { __label__ = 49; break; } else { __label__ = 50; break; } //@line 4711 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $361
      var $362=$nb; //@line 4712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $363=HEAP32[((((__gm_+12)|0))>>2)]; //@line 4712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $364=(($363-$362)|0); //@line 4712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+12)|0))>>2)]=$364; //@line 4712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize8=$364; //@line 4712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $365=HEAP32[((((__gm_+24)|0))>>2)]; //@line 4713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p9=$365; //@line 4713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $366=$p9; //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=$366; //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=$nb; //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=(($367+$368)|0); //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $370=$369; //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+24)|0))>>2)]=$370; //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $r10=$370; //@line 4714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $371=$rsize8; //@line 4715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $372=$371 | 1; //@line 4715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $373=$r10; //@line 4715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374=(($373+4)|0); //@line 4715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($374)>>2)]=$372; //@line 4715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $375=$nb; //@line 4716 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $376=$375 | 1; //@line 4716 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $377=$376 | 2; //@line 4716 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $378=$p9; //@line 4716 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $379=(($378+4)|0); //@line 4716 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($379)>>2)]=$377; //@line 4716 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=$p9; //@line 4717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=$380; //@line 4717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=(($381+8)|0); //@line 4717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$382; //@line 4717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 52; break; //@line 4720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 50: // $383
      __label__ = 51; break;
    case 51: // $384
      var $385=$nb; //@line 4723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=_sys_alloc(__gm_, $385); //@line 4723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$386; //@line 4723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 52; break; //@line 4723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $387
      var $388=$mem; //@line 4727 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $388; //@line 4727 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_malloc["X"]=1;

function _tmalloc_small($m, $nb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $t;
      var $v;
      var $rsize;
      var $i;
      var $leastbit;
      var $Y;
      var $K;
      var $N;
      var $trem;
      var $r;
      var $XP;
      var $R;
      var $F;
      var $RP;
      var $CP;
      var $H;
      var $C0;
      var $C1;
      var $DVS;
      var $DV;
      var $I;
      var $B;
      var $F1;
      $1=$m;
      $2=$nb;
      var $3=$1; //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $4=(($3+4)|0); //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=HEAP32[(($4)>>2)]; //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=$1; //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=(($6+4)|0); //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=HEAP32[(($7)>>2)]; //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(((-$8))|0); //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=$5 & $9; //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $leastbit=$10; //@line 4268 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=$leastbit; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=(($11-1)|0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$12; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=$13 >>> 12; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$14 & 16; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$15; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$K; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$16; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=$K; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=$18 >>> (($17)>>>0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$19; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=$20 >>> 5; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=$21 & 8; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$22; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$N; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=(($23+$22)|0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$24; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$K; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$26 >>> (($25)>>>0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$27; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=$28 >>> 2; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$29 & 4; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$30; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=$N; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=(($31+$30)|0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$32; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$K; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=$34 >>> (($33)>>>0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$35; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$36 >>> 1; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=$37 & 2; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$38; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=$N; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=(($39+$38)|0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$40; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$K; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$42 >>> (($41)>>>0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$43; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$44 >>> 1; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=$45 & 1; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$46; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=$N; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $48=(($47+$46)|0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$48; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=$K; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=$50 >>> (($49)>>>0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$51; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=$N; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=$Y; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=(($52+$53)|0); //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $i=$54; //@line 4269 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=$i; //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$1; //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56+304)|0); //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=(($57+($55<<2))|0); //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=HEAP32[(($58)>>2)]; //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$59; //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $v=$59; //@line 4270 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=$t; //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=(($60+4)|0); //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=HEAP32[(($61)>>2)]; //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$62 & -8; //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=$2; //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=(($63-$64)|0); //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$65; //@line 4271 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 1; break; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $66
      var $67=$t; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=(($67+16)|0); //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68)|0); //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=HEAP32[(($69)>>2)]; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=(($70)|0)!=0; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($71) { __label__ = 2; break; } else { __label__ = 3; break; } //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $72
      var $73=$t; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=(($73+16)|0); //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=(($74)|0); //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=HEAP32[(($75)>>2)]; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83 = $76;__label__ = 4; break; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $77
      var $78=$t; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=(($78+16)|0); //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=(($79+4)|0); //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=HEAP32[(($80)>>2)]; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83 = $81;__label__ = 4; break; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $82
      var $83; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$83; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=(($83)|0)!=0; //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($84) { __label__ = 5; break; } else { __label__ = 8; break; } //@line 4273 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $85
      var $86=$t; //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=(($86+4)|0); //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=HEAP32[(($87)>>2)]; //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=$88 & -8; //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=$2; //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=(($89-$90)|0); //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $trem=$91; //@line 4274 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=$trem; //@line 4275 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $93=$rsize; //@line 4275 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=(($92)>>>0) < (($93)>>>0); //@line 4275 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($94) { __label__ = 6; break; } else { __label__ = 7; break; } //@line 4275 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $95
      var $96=$trem; //@line 4276 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$96; //@line 4276 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=$t; //@line 4277 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $v=$97; //@line 4277 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 7; break; //@line 4278 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $98
      __label__ = 1; break; //@line 4279 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $99
      var $100=$v; //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$100; //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=$1; //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=(($102+16)|0); //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=HEAPU32[(($103)>>2)]; //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $105=(($101)>>>0) >= (($104)>>>0); //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=(($105)&1); //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=(($106)==(1)); //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=(($107)|0)!=0; //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($108) { __label__ = 9; break; } else { __label__ = 68; break; } //@line 4281 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $109
      var $110=$v; //@line 4282 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=$110; //@line 4282 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=$2; //@line 4282 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=(($111+$112)|0); //@line 4282 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=$113; //@line 4282 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $r=$114; //@line 4282 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=$v; //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=$115; //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=$r; //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=$117; //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $119=(($116)>>>0) < (($118)>>>0); //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=(($119)&1); //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=(($120)==(1)); //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=(($121)|0)!=0; //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($122) { __label__ = 10; break; } else { __label__ = 67; break; } //@line 4284 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $123
      var $124=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=(($124+24)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=HEAP32[(($125)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $XP=$126; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=(($127+12)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=HEAP32[(($128)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=(($129)|0)!=(($130)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($131) { __label__ = 11; break; } else { __label__ = 15; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $132
      var $133=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=(($133+8)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=HEAP32[(($134)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$135; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $137=(($136+12)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $138=HEAP32[(($137)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$138; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=$F; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $140=$139; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=(($141+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=HEAPU32[(($142)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=(($140)>>>0) >= (($143)>>>0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=(($144)&1); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=(($145)==(1)); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=(($146)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($147) { __label__ = 12; break; } else { __label__ = 13; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $148
      var $149=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $150=$F; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=(($150+12)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($151)>>2)]=$149; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=$F; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=(($153+8)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($154)>>2)]=$152; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 14; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $155
      _abort(); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $156
      __label__ = 27; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $157
      var $158=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=(($158+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=(($159+4)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$160; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=HEAP32[(($160)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$161; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=(($161)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($162) { __label__ = 17; break; } else { __label__ = 16; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $163
      var $164=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=(($164+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $166=(($165)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$166; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $167=HEAP32[(($166)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$167; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=(($167)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($168) { __label__ = 17; break; } else { __label__ = 26; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $169
      __label__ = 18; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $170
      var $171=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=(($171+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $173=(($172+4)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$173; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $174=HEAP32[(($173)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $175=(($174)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($175) { var $183 = 1;__label__ = 20; break; } else { __label__ = 19; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $176
      var $177=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $178=(($177+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $179=(($178)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$179; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $180=HEAP32[(($179)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $181=(($180)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183 = $181;__label__ = 20; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $182
      var $183;
      if ($183) { __label__ = 21; break; } else { __label__ = 22; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $184
      var $185=$CP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$185; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $186=HEAP32[(($185)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$186; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 18; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $187
      var $188=$RP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $189=$188; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $190=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $191=(($190+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $192=HEAPU32[(($191)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $193=(($189)>>>0) >= (($192)>>>0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=(($193)&1); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $195=(($194)==(1)); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=(($195)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($196) { __label__ = 23; break; } else { __label__ = 24; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $197
      var $198=$RP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($198)>>2)]=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 25; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $199
      _abort(); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $200
      __label__ = 26; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $201
      __label__ = 27; break;
    case 27: // $202
      var $203=$XP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=(($203)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($204) { __label__ = 28; break; } else { __label__ = 55; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $205
      var $206=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=(($206+28)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=HEAP32[(($207)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=(($209+304)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=(($210+($208<<2))|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H=$211; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $213=$H; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $214=HEAP32[(($213)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $215=(($212)|0)==(($214)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($215) { __label__ = 29; break; } else { __label__ = 32; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $216
      var $217=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $218=$H; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($218)>>2)]=$217; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $219=(($217)|0)==0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($219) { __label__ = 30; break; } else { __label__ = 31; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $220
      var $221=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $222=(($221+28)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $223=HEAP32[(($222)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $224=1 << $223; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $225=$224 ^ -1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $226=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=(($226+4)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=HEAP32[(($227)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $229=$228 & $225; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($227)>>2)]=$229; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 31; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $230
      __label__ = 39; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $231
      var $232=$XP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $233=$232; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $234=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $235=(($234+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $236=HEAPU32[(($235)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=(($233)>>>0) >= (($236)>>>0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $238=(($237)&1); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $239=(($238)==(1)); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $240=(($239)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($240) { __label__ = 33; break; } else { __label__ = 37; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $241
      var $242=$XP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=(($242+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=(($243)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $245=HEAP32[(($244)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=(($245)|0)==(($246)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($247) { __label__ = 34; break; } else { __label__ = 35; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $248
      var $249=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $250=$XP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $251=(($250+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $252=(($251)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($252)>>2)]=$249; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 36; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $253
      var $254=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $255=$XP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $256=(($255+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $257=(($256+4)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($257)>>2)]=$254; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 36; break;
    case 36: // $258
      __label__ = 38; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $259
      _abort(); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $260
      __label__ = 39; break;
    case 39: // $261
      var $262=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $263=(($262)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($263) { __label__ = 40; break; } else { __label__ = 54; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $264
      var $265=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $266=$265; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $267=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $268=(($267+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $269=HEAPU32[(($268)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $270=(($266)>>>0) >= (($269)>>>0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $271=(($270)&1); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $272=(($271)==(1)); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $273=(($272)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($273) { __label__ = 41; break; } else { __label__ = 52; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 41: // $274
      var $275=$XP; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $277=(($276+24)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($277)>>2)]=$275; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $278=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=(($278+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $280=(($279)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $281=HEAP32[(($280)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C0=$281; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=(($281)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($282) { __label__ = 42; break; } else { __label__ = 46; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 42: // $283
      var $284=$C0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $285=$284; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $286=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=(($286+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=HEAPU32[(($287)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $289=(($285)>>>0) >= (($288)>>>0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $290=(($289)&1); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $291=(($290)==(1)); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $292=(($291)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($292) { __label__ = 43; break; } else { __label__ = 44; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $293
      var $294=$C0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $295=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $296=(($295+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $297=(($296)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($297)>>2)]=$294; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $298=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $299=$C0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $300=(($299+24)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($300)>>2)]=$298; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 45; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $301
      _abort(); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $302
      __label__ = 46; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $303
      var $304=$v; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $305=(($304+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $306=(($305+4)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $307=HEAP32[(($306)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C1=$307; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $308=(($307)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($308) { __label__ = 47; break; } else { __label__ = 51; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 47: // $309
      var $310=$C1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $311=$310; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $312=$1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $313=(($312+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $314=HEAPU32[(($313)>>2)]; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=(($311)>>>0) >= (($314)>>>0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=(($315)&1); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=(($316)==(1)); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $318=(($317)|0)!=0; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($318) { __label__ = 48; break; } else { __label__ = 49; break; } //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $319
      var $320=$C1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $322=(($321+16)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=(($322+4)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($323)>>2)]=$320; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=$R; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=$C1; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=(($325+24)|0); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($326)>>2)]=$324; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 50; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $327
      _abort(); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 50: // $328
      __label__ = 51; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 51: // $329
      __label__ = 53; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $330
      _abort(); //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 53: // $331
      __label__ = 54; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 54: // $332
      __label__ = 55; break; //@line 4285 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 55: // $333
      var $334=$rsize; //@line 4286 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $335=(($334)>>>0) < 16; //@line 4286 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($335) { __label__ = 56; break; } else { __label__ = 57; break; } //@line 4286 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 56: // $336
      var $337=$rsize; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $338=$2; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=(($337+$338)|0); //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=$339 | 1; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=$340 | 2; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=$v; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $343=(($342+4)|0); //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($343)>>2)]=$341; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $344=$v; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $345=$344; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=$rsize; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=$2; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348=(($346+$347)|0); //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $349=(($345+$348)|0); //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=$349; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=(($350+4)|0); //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=HEAP32[(($351)>>2)]; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $353=$352 | 1; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($351)>>2)]=$353; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 66; break; //@line 4287 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 57: // $354
      var $355=$2; //@line 4289 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $356=$355 | 1; //@line 4289 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $357=$356 | 2; //@line 4289 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=$v; //@line 4289 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=(($358+4)|0); //@line 4289 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($359)>>2)]=$357; //@line 4289 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $360=$rsize; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $361=$360 | 1; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $362=$r; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $363=(($362+4)|0); //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($363)>>2)]=$361; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $364=$rsize; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $365=$r; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $366=$365; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=$rsize; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=(($366+$367)|0); //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=$368; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $370=(($369)|0); //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($370)>>2)]=$364; //@line 4290 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $371=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $372=(($371+8)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $373=HEAP32[(($372)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $DVS=$373; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374=$DVS; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $375=(($374)|0)!=0; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($375) { __label__ = 58; break; } else { __label__ = 65; break; } //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 58: // $376
      var $377=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $378=(($377+20)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $379=HEAP32[(($378)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $DV=$379; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=$DVS; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=$380 >>> 3; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$381; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=$I; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $383=$382 << 1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $384=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $385=(($384+40)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=(($385+($383<<2))|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=$386; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $388=$387; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B=$388; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $389=$B; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F1=$389; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $390=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $391=(($390)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $392=HEAP32[(($391)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $393=$I; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $394=1 << $393; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $395=$392 & $394; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $396=(($395)|0)!=0; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($396) { __label__ = 60; break; } else { __label__ = 59; break; } //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 59: // $397
      var $398=$I; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $399=1 << $398; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $400=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $401=(($400)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $402=HEAP32[(($401)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $403=$402 | $399; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($401)>>2)]=$403; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 64; break; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 60: // $404
      var $405=$B; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $406=(($405+8)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $407=HEAP32[(($406)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $408=$407; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $409=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $410=(($409+16)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $411=HEAPU32[(($410)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $412=(($408)>>>0) >= (($411)>>>0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $413=(($412)&1); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $414=(($413)==(1)); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $415=(($414)|0)!=0; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($415) { __label__ = 61; break; } else { __label__ = 62; break; } //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 61: // $416
      var $417=$B; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $418=(($417+8)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $419=HEAP32[(($418)>>2)]; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F1=$419; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 63; break; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 62: // $420
      _abort(); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 63: // $421
      __label__ = 64; break;
    case 64: // $422
      var $423=$DV; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $424=$B; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $425=(($424+8)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($425)>>2)]=$423; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $426=$DV; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $427=$F1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $428=(($427+12)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($428)>>2)]=$426; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $429=$F1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $430=$DV; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $431=(($430+8)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($431)>>2)]=$429; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $432=$B; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $433=$DV; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $434=(($433+12)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($434)>>2)]=$432; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 65; break; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 65: // $435
      var $436=$rsize; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $437=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $438=(($437+8)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($438)>>2)]=$436; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $439=$r; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $440=$1; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $441=(($440+20)|0); //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($441)>>2)]=$439; //@line 4291 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 66; break;
    case 66: // $442
      var $443=$v; //@line 4293 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $444=$443; //@line 4293 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $445=(($444+8)|0); //@line 4293 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $445; //@line 4293 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 67: // $446
      __label__ = 68; break; //@line 4295 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 68: // $447
      _abort(); //@line 4297 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4297 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_tmalloc_small["X"]=1;

function _tmalloc_large($m, $nb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $v;
      var $rsize;
      var $t;
      var $idx;
      var $X;
      var $Y;
      var $N;
      var $K;
      var $sizebits;
      var $rst;
      var $rt;
      var $trem;
      var $leftbits;
      var $i;
      var $leastbit;
      var $Y1;
      var $K2;
      var $N3;
      var $trem4;
      var $r;
      var $XP;
      var $R;
      var $F;
      var $RP;
      var $CP;
      var $H;
      var $C0;
      var $C1;
      var $I;
      var $B;
      var $F5;
      var $TP;
      var $H6;
      var $I7;
      var $X8;
      var $Y9;
      var $N10;
      var $K11;
      var $T;
      var $K12;
      var $C;
      var $F13;
      $2=$m;
      $3=$nb;
      $v=0; //@line 4194 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $4=$3; //@line 4195 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=(((-$4))|0); //@line 4195 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$5; //@line 4195 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=$3; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=$6 >>> 8; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $X=$7; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$X; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(($8)|0)==0; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $10
      $idx=0; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 6; break; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $11
      var $12=$X; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=(($12)>>>0) > 65535; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($13) { __label__ = 3; break; } else { __label__ = 4; break; } //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $14
      $idx=31; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 5; break; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $15
      var $16=$X; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$16; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=$Y; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=(($17-256)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=$18 >>> 16; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$19 & 8; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$20; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=$N; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=$Y; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$22 << $21; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$23; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=(($23-4096)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$24 >>> 16; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=$25 & 4; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$26; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$K; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$N; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=(($28+$27)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$29; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$K; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=$Y; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=$31 << $30; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$32; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=(($32-16384)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=$33 >>> 16; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=$34 & 2; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$35; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$N; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=(($36+$35)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$37; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=$N; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=((14-$38)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=$K; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$Y; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=$41 << $40; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$42; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$42 >>> 15; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=(($39+$43)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$44; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$K; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=$45 << 1; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=$3; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $48=$K; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=(($48+7)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=$47 >>> (($49)>>>0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=$50 & 1; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=(($46+$51)|0); //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $idx=$52; //@line 4198 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 5; break;
    case 5: // $53
      __label__ = 6; break;
    case 6: // $54
      var $55=$idx; //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$2; //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56+304)|0); //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=(($57+($55<<2))|0); //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=HEAP32[(($58)>>2)]; //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$59; //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=(($59)|0)!=0; //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($60) { __label__ = 7; break; } else { __label__ = 22; break; } //@line 4199 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $61
      var $62=$3; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$idx; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=(($63)|0)==31; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($64) { __label__ = 8; break; } else { __label__ = 9; break; } //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $65
      var $73 = 0;__label__ = 10; break; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $66
      var $67=$idx; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=$67 >>> 1; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68+8)|0); //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=(($69-2)|0); //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=((31-$70)|0); //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73 = $71;__label__ = 10; break; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $72
      var $73; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=$62 << $73; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sizebits=$74; //@line 4201 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rst=0; //@line 4202 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 11; break; //@line 4203 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $75
      var $76=$t; //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=(($76+4)|0); //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=HEAP32[(($77)>>2)]; //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=$78 & -8; //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=$3; //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=(($79-$80)|0); //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $trem=$81; //@line 4205 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=$trem; //@line 4206 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=$rsize; //@line 4206 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=(($82)>>>0) < (($83)>>>0); //@line 4206 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($84) { __label__ = 12; break; } else { __label__ = 15; break; } //@line 4206 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $85
      var $86=$t; //@line 4207 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $v=$86; //@line 4207 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=$trem; //@line 4208 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$87; //@line 4208 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=(($87)|0)==0; //@line 4208 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($88) { __label__ = 13; break; } else { __label__ = 14; break; } //@line 4208 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $89
      __label__ = 21; break; //@line 4209 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $90
      __label__ = 15; break; //@line 4210 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $91
      var $92=$t; //@line 4211 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $93=(($92+16)|0); //@line 4211 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=(($93+4)|0); //@line 4211 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=HEAP32[(($94)>>2)]; //@line 4211 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rt=$95; //@line 4211 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=$sizebits; //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=$96 >>> 31; //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=$97 & 1; //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=$t; //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=(($99+16)|0); //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=(($100+($98<<2))|0); //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=HEAP32[(($101)>>2)]; //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$102; //@line 4212 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=$rt; //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=(($103)|0)!=0; //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($104) { __label__ = 16; break; } else { __label__ = 18; break; } //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $105
      var $106=$rt; //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=$t; //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=(($106)|0)!=(($107)|0); //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($108) { __label__ = 17; break; } else { __label__ = 18; break; } //@line 4213 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $109
      var $110=$rt; //@line 4214 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rst=$110; //@line 4214 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 18; break; //@line 4214 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $111
      var $112=$t; //@line 4215 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=(($112)|0)==0; //@line 4215 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($113) { __label__ = 19; break; } else { __label__ = 20; break; } //@line 4215 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $114
      var $115=$rst; //@line 4216 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$115; //@line 4216 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 21; break; //@line 4217 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $116
      var $117=$sizebits; //@line 4219 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=$117 << 1; //@line 4219 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sizebits=$118; //@line 4219 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 11; break; //@line 4220 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $119
      __label__ = 22; break; //@line 4221 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $120
      var $121=$t; //@line 4222 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=(($121)|0)==0; //@line 4222 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($122) { __label__ = 23; break; } else { __label__ = 27; break; } //@line 4222 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $123
      var $124=$v; //@line 4222 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=(($124)|0)==0; //@line 4222 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($125) { __label__ = 24; break; } else { __label__ = 27; break; } //@line 4222 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $126
      var $127=$idx; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=1 << $127; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=$128 << 1; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=$idx; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=1 << $130; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $132=$131 << 1; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=(((-$132))|0); //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=$129 | $133; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=$2; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=(($135+4)|0); //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $137=HEAP32[(($136)>>2)]; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $138=$134 & $137; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $leftbits=$138; //@line 4223 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=$leftbits; //@line 4224 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $140=(($139)|0)!=0; //@line 4224 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($140) { __label__ = 25; break; } else { __label__ = 26; break; } //@line 4224 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $141
      var $142=$leftbits; //@line 4226 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=$leftbits; //@line 4226 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=(((-$143))|0); //@line 4226 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=$142 & $144; //@line 4226 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $leastbit=$145; //@line 4226 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=$leastbit; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=(($146-1)|0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y1=$147; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $149=$148 >>> 12; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $150=$149 & 16; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$150; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=$K2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N3=$151; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=$K2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=$153 >>> (($152)>>>0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y1=$154; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=$155 >>> 5; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=$156 & 8; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$157; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=$N3; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=(($158+$157)|0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N3=$159; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=$K2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=$161 >>> (($160)>>>0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y1=$162; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $164=$163 >>> 2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=$164 & 4; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$165; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $166=$N3; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $167=(($166+$165)|0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N3=$167; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=$K2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=$169 >>> (($168)>>>0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y1=$170; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $171=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=$171 >>> 1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $173=$172 & 2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$173; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $174=$N3; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $175=(($174+$173)|0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N3=$175; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=$K2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $177=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $178=$177 >>> (($176)>>>0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y1=$178; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $179=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $180=$179 >>> 1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $181=$180 & 1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$181; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $182=$N3; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=(($182+$181)|0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N3=$183; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $184=$K2; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $185=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $186=$185 >>> (($184)>>>0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y1=$186; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $187=$N3; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $188=$Y1; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $189=(($187+$188)|0); //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $i=$189; //@line 4227 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $190=$i; //@line 4228 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $191=$2; //@line 4228 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $192=(($191+304)|0); //@line 4228 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $193=(($192+($190<<2))|0); //@line 4228 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=HEAP32[(($193)>>2)]; //@line 4228 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$194; //@line 4228 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 26; break; //@line 4229 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $195
      __label__ = 27; break; //@line 4230 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $196
      __label__ = 28; break; //@line 4232 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $197
      var $198=$t; //@line 4232 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=(($198)|0)!=0; //@line 4232 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($199) { __label__ = 29; break; } else { __label__ = 35; break; } //@line 4232 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $200
      var $201=$t; //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $202=(($201+4)|0); //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $203=HEAP32[(($202)>>2)]; //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=$203 & -8; //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=$3; //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=(($204-$205)|0); //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $trem4=$206; //@line 4233 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=$trem4; //@line 4234 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=$rsize; //@line 4234 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=(($207)>>>0) < (($208)>>>0); //@line 4234 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($209) { __label__ = 30; break; } else { __label__ = 31; break; } //@line 4234 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $210
      var $211=$trem4; //@line 4235 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$211; //@line 4235 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=$t; //@line 4236 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $v=$212; //@line 4236 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 31; break; //@line 4237 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $213
      var $214=$t; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $215=(($214+16)|0); //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $216=(($215)|0); //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $217=HEAP32[(($216)>>2)]; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $218=(($217)|0)!=0; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($218) { __label__ = 32; break; } else { __label__ = 33; break; } //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $219
      var $220=$t; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $221=(($220+16)|0); //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $222=(($221)|0); //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $223=HEAP32[(($222)>>2)]; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230 = $223;__label__ = 34; break; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $224
      var $225=$t; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $226=(($225+16)|0); //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=(($226+4)|0); //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=HEAP32[(($227)>>2)]; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230 = $228;__label__ = 34; break; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $229
      var $230; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $t=$230; //@line 4238 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 28; break; //@line 4239 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $231
      var $232=$v; //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $233=(($232)|0)!=0; //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($233) { __label__ = 36; break; } else { __label__ = 125; break; } //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $234
      var $235=$rsize; //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $236=$2; //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=(($236+8)|0); //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $238=HEAP32[(($237)>>2)]; //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $239=$3; //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $240=(($238-$239)|0); //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $241=(($235)>>>0) < (($240)>>>0); //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($241) { __label__ = 37; break; } else { __label__ = 125; break; } //@line 4242 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $242
      var $243=$v; //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=$243; //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $245=$2; //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=(($245+16)|0); //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=HEAPU32[(($246)>>2)]; //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=(($244)>>>0) >= (($247)>>>0); //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $249=(($248)&1); //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $250=(($249)==(1)); //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $251=(($250)|0)!=0; //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($251) { __label__ = 38; break; } else { __label__ = 124; break; } //@line 4243 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $252
      var $253=$v; //@line 4244 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $254=$253; //@line 4244 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $255=$3; //@line 4244 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $256=(($254+$255)|0); //@line 4244 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $257=$256; //@line 4244 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $r=$257; //@line 4244 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $258=$v; //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=$258; //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=$r; //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $261=$260; //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $262=(($259)>>>0) < (($261)>>>0); //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $263=(($262)&1); //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $264=(($263)==(1)); //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $265=(($264)|0)!=0; //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($265) { __label__ = 39; break; } else { __label__ = 123; break; } //@line 4246 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 39: // $266
      var $267=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $268=(($267+24)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $269=HEAP32[(($268)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $XP=$269; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $270=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $271=(($270+12)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $272=HEAP32[(($271)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $273=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $274=(($272)|0)!=(($273)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($274) { __label__ = 40; break; } else { __label__ = 44; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $275
      var $276=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $277=(($276+8)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $278=HEAP32[(($277)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$278; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $280=(($279+12)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $281=HEAP32[(($280)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$281; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=$F; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $283=$282; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $284=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $285=(($284+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $286=HEAPU32[(($285)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=(($283)>>>0) >= (($286)>>>0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=(($287)&1); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $289=(($288)==(1)); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $290=(($289)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($290) { __label__ = 41; break; } else { __label__ = 42; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 41: // $291
      var $292=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $293=$F; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $294=(($293+12)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($294)>>2)]=$292; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $295=$F; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $296=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $297=(($296+8)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($297)>>2)]=$295; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 43; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 42: // $298
      _abort(); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $299
      __label__ = 56; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $300
      var $301=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $302=(($301+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $303=(($302+4)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$303; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $304=HEAP32[(($303)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$304; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $305=(($304)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($305) { __label__ = 46; break; } else { __label__ = 45; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $306
      var $307=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $308=(($307+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $309=(($308)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$309; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $310=HEAP32[(($309)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$310; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $311=(($310)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($311) { __label__ = 46; break; } else { __label__ = 55; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $312
      __label__ = 47; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 47: // $313
      var $314=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=(($314+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=(($315+4)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$316; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=HEAP32[(($316)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $318=(($317)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($318) { var $326 = 1;__label__ = 49; break; } else { __label__ = 48; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $319
      var $320=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=(($320+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $322=(($321)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$322; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=HEAP32[(($322)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=(($323)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326 = $324;__label__ = 49; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $325
      var $326;
      if ($326) { __label__ = 50; break; } else { __label__ = 51; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 50: // $327
      var $328=$CP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$328; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $329=HEAP32[(($328)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$329; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 47; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 51: // $330
      var $331=$RP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $332=$331; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $333=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $334=(($333+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $335=HEAPU32[(($334)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $336=(($332)>>>0) >= (($335)>>>0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $337=(($336)&1); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $338=(($337)==(1)); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=(($338)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($339) { __label__ = 52; break; } else { __label__ = 53; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $340
      var $341=$RP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($341)>>2)]=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 54; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 53: // $342
      _abort(); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 54: // $343
      __label__ = 55; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 55: // $344
      __label__ = 56; break;
    case 56: // $345
      var $346=$XP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=(($346)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($347) { __label__ = 57; break; } else { __label__ = 84; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 57: // $348
      var $349=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=(($349+28)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=HEAP32[(($350)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $353=(($352+304)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $354=(($353+($351<<2))|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H=$354; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $355=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $356=$H; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $357=HEAP32[(($356)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=(($355)|0)==(($357)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($358) { __label__ = 58; break; } else { __label__ = 61; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 58: // $359
      var $360=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $361=$H; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($361)>>2)]=$360; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $362=(($360)|0)==0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($362) { __label__ = 59; break; } else { __label__ = 60; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 59: // $363
      var $364=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $365=(($364+28)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $366=HEAP32[(($365)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=1 << $366; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=$367 ^ -1; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $370=(($369+4)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $371=HEAP32[(($370)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $372=$371 & $368; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($370)>>2)]=$372; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 60; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 60: // $373
      __label__ = 68; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 61: // $374
      var $375=$XP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $376=$375; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $377=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $378=(($377+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $379=HEAPU32[(($378)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=(($376)>>>0) >= (($379)>>>0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=(($380)&1); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=(($381)==(1)); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $383=(($382)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($383) { __label__ = 62; break; } else { __label__ = 66; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 62: // $384
      var $385=$XP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=(($385+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=(($386)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $388=HEAP32[(($387)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $389=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $390=(($388)|0)==(($389)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($390) { __label__ = 63; break; } else { __label__ = 64; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 63: // $391
      var $392=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $393=$XP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $394=(($393+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $395=(($394)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($395)>>2)]=$392; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 65; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 64: // $396
      var $397=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $398=$XP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $399=(($398+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $400=(($399+4)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($400)>>2)]=$397; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 65; break;
    case 65: // $401
      __label__ = 67; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 66: // $402
      _abort(); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 67: // $403
      __label__ = 68; break;
    case 68: // $404
      var $405=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $406=(($405)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($406) { __label__ = 69; break; } else { __label__ = 83; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 69: // $407
      var $408=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $409=$408; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $410=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $411=(($410+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $412=HEAPU32[(($411)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $413=(($409)>>>0) >= (($412)>>>0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $414=(($413)&1); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $415=(($414)==(1)); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $416=(($415)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($416) { __label__ = 70; break; } else { __label__ = 81; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 70: // $417
      var $418=$XP; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $419=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $420=(($419+24)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($420)>>2)]=$418; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $421=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $422=(($421+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $423=(($422)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $424=HEAP32[(($423)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C0=$424; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $425=(($424)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($425) { __label__ = 71; break; } else { __label__ = 75; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 71: // $426
      var $427=$C0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $428=$427; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $429=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $430=(($429+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $431=HEAPU32[(($430)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $432=(($428)>>>0) >= (($431)>>>0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $433=(($432)&1); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $434=(($433)==(1)); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $435=(($434)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($435) { __label__ = 72; break; } else { __label__ = 73; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 72: // $436
      var $437=$C0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $438=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $439=(($438+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $440=(($439)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($440)>>2)]=$437; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $441=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $442=$C0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $443=(($442+24)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($443)>>2)]=$441; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 74; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 73: // $444
      _abort(); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 74: // $445
      __label__ = 75; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 75: // $446
      var $447=$v; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $448=(($447+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $449=(($448+4)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $450=HEAP32[(($449)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C1=$450; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $451=(($450)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($451) { __label__ = 76; break; } else { __label__ = 80; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 76: // $452
      var $453=$C1; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $454=$453; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $455=$2; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $456=(($455+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $457=HEAPU32[(($456)>>2)]; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $458=(($454)>>>0) >= (($457)>>>0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $459=(($458)&1); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $460=(($459)==(1)); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $461=(($460)|0)!=0; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($461) { __label__ = 77; break; } else { __label__ = 78; break; } //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 77: // $462
      var $463=$C1; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $464=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $465=(($464+16)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $466=(($465+4)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($466)>>2)]=$463; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $467=$R; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $468=$C1; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $469=(($468+24)|0); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($469)>>2)]=$467; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 79; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 78: // $470
      _abort(); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 79: // $471
      __label__ = 80; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 80: // $472
      __label__ = 82; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 81: // $473
      _abort(); //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 82: // $474
      __label__ = 83; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 83: // $475
      __label__ = 84; break; //@line 4247 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 84: // $476
      var $477=$rsize; //@line 4248 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $478=(($477)>>>0) < 16; //@line 4248 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($478) { __label__ = 85; break; } else { __label__ = 86; break; } //@line 4248 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 85: // $479
      var $480=$rsize; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $481=$3; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $482=(($480+$481)|0); //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $483=$482 | 1; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $484=$483 | 2; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $485=$v; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $486=(($485+4)|0); //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($486)>>2)]=$484; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $487=$v; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $488=$487; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $489=$rsize; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $490=$3; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $491=(($489+$490)|0); //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $492=(($488+$491)|0); //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $493=$492; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $494=(($493+4)|0); //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $495=HEAP32[(($494)>>2)]; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $496=$495 | 1; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($494)>>2)]=$496; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 122; break; //@line 4249 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 86: // $497
      var $498=$3; //@line 4251 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $499=$498 | 1; //@line 4251 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $500=$499 | 2; //@line 4251 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $501=$v; //@line 4251 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $502=(($501+4)|0); //@line 4251 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($502)>>2)]=$500; //@line 4251 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $503=$rsize; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $504=$503 | 1; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $505=$r; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $506=(($505+4)|0); //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($506)>>2)]=$504; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $507=$rsize; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $508=$r; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $509=$508; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $510=$rsize; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $511=(($509+$510)|0); //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $512=$511; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $513=(($512)|0); //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($513)>>2)]=$507; //@line 4252 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $514=$rsize; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $515=$514 >>> 3; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $516=(($515)>>>0) < 32; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($516) { __label__ = 87; break; } else { __label__ = 94; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 87: // $517
      var $518=$rsize; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $519=$518 >>> 3; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$519; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $520=$I; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $521=$520 << 1; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $522=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $523=(($522+40)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $524=(($523+($521<<2))|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $525=$524; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $526=$525; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B=$526; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $527=$B; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F5=$527; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $528=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $529=(($528)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $530=HEAP32[(($529)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $531=$I; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $532=1 << $531; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $533=$530 & $532; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $534=(($533)|0)!=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($534) { __label__ = 89; break; } else { __label__ = 88; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 88: // $535
      var $536=$I; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $537=1 << $536; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $538=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $539=(($538)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $540=HEAP32[(($539)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $541=$540 | $537; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($539)>>2)]=$541; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 93; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 89: // $542
      var $543=$B; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $544=(($543+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $545=HEAP32[(($544)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $546=$545; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $547=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $548=(($547+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $549=HEAPU32[(($548)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $550=(($546)>>>0) >= (($549)>>>0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $551=(($550)&1); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $552=(($551)==(1)); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $553=(($552)|0)!=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($553) { __label__ = 90; break; } else { __label__ = 91; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 90: // $554
      var $555=$B; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $556=(($555+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $557=HEAP32[(($556)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F5=$557; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 92; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 91: // $558
      _abort(); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 92: // $559
      __label__ = 93; break;
    case 93: // $560
      var $561=$r; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $562=$B; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $563=(($562+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($563)>>2)]=$561; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $564=$r; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $565=$F5; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $566=(($565+12)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($566)>>2)]=$564; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $567=$F5; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $568=$r; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $569=(($568+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($569)>>2)]=$567; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $570=$B; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $571=$r; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $572=(($571+12)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($572)>>2)]=$570; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 121; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 94: // $573
      var $574=$r; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $575=$574; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $TP=$575; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $576=$rsize; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $577=$576 >>> 8; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $X8=$577; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $578=$X8; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $579=(($578)|0)==0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($579) { __label__ = 95; break; } else { __label__ = 96; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 95: // $580
      $I7=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 100; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 96: // $581
      var $582=$X8; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $583=(($582)>>>0) > 65535; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($583) { __label__ = 97; break; } else { __label__ = 98; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 97: // $584
      $I7=31; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 99; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 98: // $585
      var $586=$X8; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y9=$586; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $587=$Y9; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $588=(($587-256)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $589=$588 >>> 16; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $590=$589 & 8; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N10=$590; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $591=$N10; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $592=$Y9; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $593=$592 << $591; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y9=$593; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $594=(($593-4096)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $595=$594 >>> 16; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $596=$595 & 4; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K11=$596; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $597=$K11; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $598=$N10; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $599=(($598+$597)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N10=$599; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $600=$K11; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $601=$Y9; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $602=$601 << $600; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y9=$602; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $603=(($602-16384)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $604=$603 >>> 16; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $605=$604 & 2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K11=$605; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $606=$N10; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $607=(($606+$605)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N10=$607; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $608=$N10; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $609=((14-$608)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $610=$K11; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $611=$Y9; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $612=$611 << $610; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y9=$612; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $613=$612 >>> 15; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $614=(($609+$613)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K11=$614; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $615=$K11; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $616=$615 << 1; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $617=$rsize; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $618=$K11; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $619=(($618+7)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $620=$617 >>> (($619)>>>0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $621=$620 & 1; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $622=(($616+$621)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I7=$622; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 99; break;
    case 99: // $623
      __label__ = 100; break;
    case 100: // $624
      var $625=$I7; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $626=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $627=(($626+304)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $628=(($627+($625<<2))|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H6=$628; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $629=$I7; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $630=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $631=(($630+28)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($631)>>2)]=$629; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $632=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $633=(($632+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $634=(($633+4)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($634)>>2)]=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $635=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $636=(($635+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $637=(($636)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($637)>>2)]=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $638=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $639=(($638+4)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $640=HEAP32[(($639)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $641=$I7; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $642=1 << $641; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $643=$640 & $642; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $644=(($643)|0)!=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($644) { __label__ = 102; break; } else { __label__ = 101; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 101: // $645
      var $646=$I7; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $647=1 << $646; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $648=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $649=(($648+4)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $650=HEAP32[(($649)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $651=$650 | $647; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($649)>>2)]=$651; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $652=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $653=$H6; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($653)>>2)]=$652; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $654=$H6; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $655=$654; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $656=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $657=(($656+24)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($657)>>2)]=$655; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $658=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $659=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $660=(($659+12)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($660)>>2)]=$658; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $661=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $662=(($661+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($662)>>2)]=$658; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 120; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 102: // $663
      var $664=$H6; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $665=HEAP32[(($664)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$665; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $666=$rsize; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $667=$I7; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $668=(($667)|0)==31; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($668) { __label__ = 103; break; } else { __label__ = 104; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 103: // $669
      var $677 = 0;__label__ = 105; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 104: // $670
      var $671=$I7; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $672=$671 >>> 1; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $673=(($672+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $674=(($673-2)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $675=((31-$674)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $677 = $675;__label__ = 105; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 105: // $676
      var $677; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $678=$666 << $677; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K12=$678; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 106; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 106: // $679
      var $680=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $681=(($680+4)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $682=HEAP32[(($681)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $683=$682 & -8; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $684=$rsize; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $685=(($683)|0)!=(($684)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($685) { __label__ = 107; break; } else { __label__ = 113; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 107: // $686
      var $687=$K12; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $688=$687 >>> 31; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $689=$688 & 1; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $690=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $691=(($690+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $692=(($691+($689<<2))|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C=$692; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $693=$K12; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $694=$693 << 1; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K12=$694; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $695=$C; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $696=HEAP32[(($695)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $697=(($696)|0)!=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($697) { __label__ = 108; break; } else { __label__ = 109; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 108: // $698
      var $699=$C; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $700=HEAP32[(($699)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$700; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 112; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 109: // $701
      var $702=$C; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $703=$702; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $704=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $705=(($704+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $706=HEAPU32[(($705)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $707=(($703)>>>0) >= (($706)>>>0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $708=(($707)&1); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $709=(($708)==(1)); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $710=(($709)|0)!=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($710) { __label__ = 110; break; } else { __label__ = 111; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 110: // $711
      var $712=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $713=$C; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($713)>>2)]=$712; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $714=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $715=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $716=(($715+24)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($716)>>2)]=$714; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $717=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $718=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $719=(($718+12)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($719)>>2)]=$717; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $720=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $721=(($720+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($721)>>2)]=$717; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 119; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 111: // $722
      _abort(); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 112: // $723
      __label__ = 118; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 113: // $724
      var $725=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $726=(($725+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $727=HEAP32[(($726)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F13=$727; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $728=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $729=$728; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $730=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $731=(($730+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $732=HEAPU32[(($731)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $733=(($729)>>>0) >= (($732)>>>0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($733) { __label__ = 114; break; } else { var $742 = 0;__label__ = 115; break; } //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 114: // $734
      var $735=$F13; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $736=$735; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $737=$2; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $738=(($737+16)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $739=HEAPU32[(($738)>>2)]; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $740=(($736)>>>0) >= (($739)>>>0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $742 = $740;__label__ = 115; break;
    case 115: // $741
      var $742;
      var $743=(($742)&1);
      var $744=(($743)==(1));
      var $745=(($744)|0)!=0;
      if ($745) { __label__ = 116; break; } else { __label__ = 117; break; }
    case 116: // $746
      var $747=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $748=$F13; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $749=(($748+12)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($749)>>2)]=$747; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $750=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $751=(($750+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($751)>>2)]=$747; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $752=$F13; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $753=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $754=(($753+8)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($754)>>2)]=$752; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $755=$T; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $756=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $757=(($756+12)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($757)>>2)]=$755; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $758=$TP; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $759=(($758+24)|0); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($759)>>2)]=0; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 119; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 117: // $760
      _abort(); //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 118: // $761
      __label__ = 106; break; //@line 4253 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 119: // $762
      __label__ = 120; break;
    case 120: // $763
      __label__ = 121; break;
    case 121: // $764
      __label__ = 122; break;
    case 122: // $765
      var $766=$v; //@line 4255 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $767=$766; //@line 4255 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $768=(($767+8)|0); //@line 4255 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$768; //@line 4255 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 126; break; //@line 4255 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 123: // $769
      __label__ = 124; break; //@line 4257 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 124: // $770
      _abort(); //@line 4258 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4258 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 125: // $771
      $1=0; //@line 4260 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 126; break; //@line 4260 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 126: // $772
      var $773=$1; //@line 4261 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $773; //@line 4261 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_tmalloc_large["X"]=1;

function _sys_alloc($m, $nb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $tbase;
      var $tsize;
      var $mmap_flag;
      var $mem;
      var $br;
      var $ss;
      var $asize;
      var $base;
      var $esize;
      var $end;
      var $asize1;
      var $br2;
      var $end3;
      var $ssize;
      var $mn;
      var $sp;
      var $oldbase;
      var $rsize;
      var $p;
      var $r;
      $2=$m;
      $3=$nb;
      $tbase=-1; //@line 3876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=0; //@line 3877 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mmap_flag=0; //@line 3878 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $4=HEAP32[((((_mparams)|0))>>2)]; //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=(($4)|0)!=0; //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($5) { var $10 = 1;__label__ = 2; break; } else { __label__ = 1; break; } //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $6
      var $7=_init_mparams(); //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=(($7)|0)!=0; //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10 = $8;__label__ = 2; break; //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $9
      var $10;
      var $11=(($10)&1); //@line 3880 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$2; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=(($12+440)|0); //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=HEAP32[(($13)>>2)]; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$14 & 0; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=(($15)|0)!=0; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($16) { __label__ = 3; break; } else { __label__ = 8; break; } //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $17
      var $18=$3; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=HEAPU32[((((_mparams+12)|0))>>2)]; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=(($18)>>>0) >= (($19)>>>0); //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($20) { __label__ = 4; break; } else { __label__ = 8; break; } //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $21
      var $22=$2; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=(($22+12)|0); //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=HEAP32[(($23)>>2)]; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=(($24)|0)!=0; //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($25) { __label__ = 5; break; } else { __label__ = 8; break; } //@line 3883 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $26
      var $27=$2; //@line 3884 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$3; //@line 3884 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=_mmap_alloc($27, $28); //@line 3884 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mem=$29; //@line 3884 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$mem; //@line 3885 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=(($30)|0)!=0; //@line 3885 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($31) { __label__ = 6; break; } else { __label__ = 7; break; } //@line 3885 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $32
      var $33=$mem; //@line 3886 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$33; //@line 3886 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 91; break; //@line 3886 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $34
      __label__ = 8; break; //@line 3887 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $35
      var $36=$2; //@line 3911 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=(($36+440)|0); //@line 3911 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=HEAP32[(($37)>>2)]; //@line 3911 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=$38 & 4; //@line 3911 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=(($39)|0)!=0; //@line 3911 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($40) { __label__ = 41; break; } else { __label__ = 9; break; } //@line 3911 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $41
      $br=-1; //@line 3912 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=$2; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=(($42+24)|0); //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=HEAP32[(($43)>>2)]; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=(($44)|0)==0; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($45) { __label__ = 10; break; } else { __label__ = 11; break; } //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $46
      var $55 = 0;__label__ = 12; break; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $47
      var $48=$2; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=$2; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=(($49+24)|0); //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=HEAP32[(($50)>>2)]; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=$51; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=_segment_holding($48, $52); //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55 = $53;__label__ = 12; break; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $54
      var $55; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $ss=$55; //@line 3913 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asize=0; //@line 3914 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$ss; //@line 3917 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56)|0)==0; //@line 3917 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($57) { __label__ = 13; break; } else { __label__ = 21; break; } //@line 3917 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $58
      var $59=_sbrk(0); //@line 3918 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $base=$59; //@line 3918 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=$base; //@line 3919 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=(($60)|0)!=-1; //@line 3919 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($61) { __label__ = 14; break; } else { __label__ = 20; break; } //@line 3919 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $62
      var $63=$3; //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=(($63+48)|0); //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=(($65-1)|0); //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $67=(($64+$66)|0); //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68-1)|0); //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=$69 ^ -1; //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=$67 & $70; //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asize=$71; //@line 3920 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=$base; //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=$72; //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=(($74-1)|0); //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=$73 & $75; //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=(($76)|0)==0; //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($77) { __label__ = 16; break; } else { __label__ = 15; break; } //@line 3922 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $78
      var $79=$base; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=$79; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=(($81-1)|0); //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=(($80+$82)|0); //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=(($84-1)|0); //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=$85 ^ -1; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=$83 & $86; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=$base; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=$88; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=(($87-$89)|0); //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=$asize; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=(($91+$90)|0); //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asize=$92; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 16; break; //@line 3923 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $93
      var $94=$asize; //@line 3925 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=(($94)>>>0) < 2147483647; //@line 3925 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($95) { __label__ = 17; break; } else { __label__ = 19; break; } //@line 3925 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $96
      var $97=$asize; //@line 3926 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=_sbrk($97); //@line 3926 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $br=$98; //@line 3926 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=$base; //@line 3926 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=(($98)|0)==(($99)|0); //@line 3926 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($100) { __label__ = 18; break; } else { __label__ = 19; break; } //@line 3926 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $101
      var $102=$base; //@line 3927 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tbase=$102; //@line 3927 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=$asize; //@line 3928 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=$103; //@line 3928 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 19; break; //@line 3929 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $104
      __label__ = 20; break; //@line 3930 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $105
      __label__ = 25; break; //@line 3931 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $106
      var $107=$3; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=$2; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $109=(($108+12)|0); //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $110=HEAP32[(($109)>>2)]; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=(($107-$110)|0); //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=(($111+48)|0); //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=(($113-1)|0); //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=(($112+$114)|0); //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=(($116-1)|0); //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=$117 ^ -1; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $119=$115 & $118; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asize=$119; //@line 3934 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=$asize; //@line 3936 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=(($120)>>>0) < 2147483647; //@line 3936 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($121) { __label__ = 22; break; } else { __label__ = 24; break; } //@line 3936 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $122
      var $123=$asize; //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $124=_sbrk($123); //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $br=$124; //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=$ss; //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=(($125)|0); //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=HEAP32[(($126)>>2)]; //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=$ss; //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=(($128+4)|0); //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=HEAP32[(($129)>>2)]; //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=(($127+$130)|0); //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $132=(($124)|0)==(($131)|0); //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($132) { __label__ = 23; break; } else { __label__ = 24; break; } //@line 3937 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $133
      var $134=$br; //@line 3938 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tbase=$134; //@line 3938 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=$asize; //@line 3939 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=$135; //@line 3939 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 24; break; //@line 3940 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $136
      __label__ = 25; break;
    case 25: // $137
      var $138=$tbase; //@line 3943 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=(($138)|0)==-1; //@line 3943 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($139) { __label__ = 26; break; } else { __label__ = 40; break; } //@line 3943 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $140
      var $141=$br; //@line 3944 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=(($141)|0)!=-1; //@line 3944 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($142) { __label__ = 27; break; } else { __label__ = 36; break; } //@line 3944 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $143
      var $144=$asize; //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=(($144)>>>0) < 2147483647; //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($145) { __label__ = 28; break; } else { __label__ = 35; break; } //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $146
      var $147=$asize; //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=$3; //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $149=(($148+48)|0); //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $150=(($147)>>>0) < (($149)>>>0); //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($150) { __label__ = 29; break; } else { __label__ = 35; break; } //@line 3945 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $151
      var $152=$3; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=(($152+48)|0); //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=$asize; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=(($153-$154)|0); //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=(($156-1)|0); //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=(($155+$157)|0); //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=(($159-1)|0); //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=$160 ^ -1; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=$158 & $161; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $esize=$162; //@line 3947 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=$esize; //@line 3948 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $164=(($163)>>>0) < 2147483647; //@line 3948 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($164) { __label__ = 30; break; } else { __label__ = 34; break; } //@line 3948 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $165
      var $166=$esize; //@line 3949 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $167=_sbrk($166); //@line 3949 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $end=$167; //@line 3949 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=$end; //@line 3950 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=(($168)|0)!=-1; //@line 3950 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($169) { __label__ = 31; break; } else { __label__ = 32; break; } //@line 3950 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $170
      var $171=$esize; //@line 3951 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=$asize; //@line 3951 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $173=(($172+$171)|0); //@line 3951 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asize=$173; //@line 3951 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 33; break; //@line 3951 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $174
      var $175=$asize; //@line 3953 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=(((-$175))|0); //@line 3953 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $177=_sbrk($176); //@line 3953 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $br=-1; //@line 3954 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 33; break;
    case 33: // $178
      __label__ = 34; break; //@line 3956 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $179
      __label__ = 35; break; //@line 3957 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $180
      __label__ = 36; break; //@line 3958 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $181
      var $182=$br; //@line 3959 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=(($182)|0)!=-1; //@line 3959 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($183) { __label__ = 37; break; } else { __label__ = 38; break; } //@line 3959 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $184
      var $185=$br; //@line 3960 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tbase=$185; //@line 3960 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $186=$asize; //@line 3961 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=$186; //@line 3961 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 39; break; //@line 3962 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $187
      var $188=$2; //@line 3964 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $189=(($188+440)|0); //@line 3964 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $190=HEAP32[(($189)>>2)]; //@line 3964 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $191=$190 | 4; //@line 3964 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($189)>>2)]=$191; //@line 3964 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 39; break;
    case 39: // $192
      __label__ = 40; break; //@line 3965 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $193
      __label__ = 41; break; //@line 3968 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 41: // $194
      var $195=$tbase; //@line 3982 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=(($195)|0)==-1; //@line 3982 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($196) { __label__ = 42; break; } else { __label__ = 51; break; } //@line 3982 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 42: // $197
      var $198=$3; //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=(($198+48)|0); //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $200=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $201=(($200-1)|0); //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $202=(($199+$201)|0); //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $203=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=(($203-1)|0); //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=$204 ^ -1; //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=$202 & $205; //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asize1=$206; //@line 3983 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=$asize1; //@line 3984 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=(($207)>>>0) < 2147483647; //@line 3984 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($208) { __label__ = 43; break; } else { __label__ = 50; break; } //@line 3984 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $209
      $br2=-1; //@line 3985 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $end3=-1; //@line 3986 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=$asize1; //@line 3988 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=_sbrk($210); //@line 3988 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $br2=$211; //@line 3988 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=_sbrk(0); //@line 3989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $end3=$212; //@line 3989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $213=$br2; //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $214=(($213)|0)!=-1; //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($214) { __label__ = 44; break; } else { __label__ = 49; break; } //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $215
      var $216=$end3; //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $217=(($216)|0)!=-1; //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($217) { __label__ = 45; break; } else { __label__ = 49; break; } //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $218
      var $219=$br2; //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $220=$end3; //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $221=(($219)>>>0) < (($220)>>>0); //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($221) { __label__ = 46; break; } else { __label__ = 49; break; } //@line 3991 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $222
      var $223=$end3; //@line 3992 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $224=$br2; //@line 3992 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $225=$223; //@line 3992 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $226=$224; //@line 3992 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=(($225-$226)|0); //@line 3992 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $ssize=$227; //@line 3992 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=$ssize; //@line 3993 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $229=$3; //@line 3993 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230=(($229+40)|0); //@line 3993 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $231=(($228)>>>0) > (($230)>>>0); //@line 3993 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($231) { __label__ = 47; break; } else { __label__ = 48; break; } //@line 3993 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 47: // $232
      var $233=$br2; //@line 3994 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tbase=$233; //@line 3994 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $234=$ssize; //@line 3995 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=$234; //@line 3995 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 48; break; //@line 3996 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $235
      __label__ = 49; break; //@line 3997 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $236
      __label__ = 50; break; //@line 3998 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 50: // $237
      __label__ = 51; break; //@line 3999 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 51: // $238
      var $239=$tbase; //@line 4001 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $240=(($239)|0)!=-1; //@line 4001 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($240) { __label__ = 52; break; } else { __label__ = 90; break; } //@line 4001 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $241
      var $242=$tsize; //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=$2; //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=(($243+432)|0); //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $245=HEAP32[(($244)>>2)]; //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=(($245+$242)|0); //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($244)>>2)]=$246; //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=$2; //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=(($247+436)|0); //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $249=HEAPU32[(($248)>>2)]; //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $250=(($246)>>>0) > (($249)>>>0); //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($250) { __label__ = 53; break; } else { __label__ = 54; break; } //@line 4003 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 53: // $251
      var $252=$2; //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $253=(($252+432)|0); //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $254=HEAP32[(($253)>>2)]; //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $255=$2; //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $256=(($255+436)|0); //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($256)>>2)]=$254; //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 54; break; //@line 4004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 54: // $257
      var $258=$2; //@line 4006 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=(($258+24)|0); //@line 4006 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=HEAP32[(($259)>>2)]; //@line 4006 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $261=(($260)|0)!=0; //@line 4006 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($261) { __label__ = 62; break; } else { __label__ = 55; break; } //@line 4006 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 55: // $262
      var $263=$2; //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $264=(($263+16)|0); //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $265=HEAP32[(($264)>>2)]; //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $266=(($265)|0)==0; //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($266) { __label__ = 57; break; } else { __label__ = 56; break; } //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 56: // $267
      var $268=$tbase; //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $269=$2; //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $270=(($269+16)|0); //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $271=HEAPU32[(($270)>>2)]; //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $272=(($268)>>>0) < (($271)>>>0); //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($272) { __label__ = 57; break; } else { __label__ = 58; break; } //@line 4007 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 57: // $273
      var $274=$tbase; //@line 4008 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $275=$2; //@line 4008 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=(($275+16)|0); //@line 4008 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($276)>>2)]=$274; //@line 4008 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 58; break; //@line 4008 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 58: // $277
      var $278=$tbase; //@line 4009 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=$2; //@line 4009 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $280=(($279+444)|0); //@line 4009 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $281=(($280)|0); //@line 4009 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($281)>>2)]=$278; //@line 4009 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=$tsize; //@line 4010 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $283=$2; //@line 4010 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $284=(($283+444)|0); //@line 4010 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $285=(($284+4)|0); //@line 4010 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($285)>>2)]=$282; //@line 4010 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $286=$mmap_flag; //@line 4011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=$2; //@line 4011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=(($287+444)|0); //@line 4011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $289=(($288+12)|0); //@line 4011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($289)>>2)]=$286; //@line 4011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $290=HEAP32[((((_mparams)|0))>>2)]; //@line 4012 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $291=$2; //@line 4012 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $292=(($291+36)|0); //@line 4012 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($292)>>2)]=$290; //@line 4012 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $293=$2; //@line 4013 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $294=(($293+32)|0); //@line 4013 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($294)>>2)]=-1; //@line 4013 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $295=$2; //@line 4014 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _init_bins($295); //@line 4014 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $296=$2; //@line 4016 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $297=(($296)|0)==((__gm_)|0); //@line 4016 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($297) { __label__ = 59; break; } else { __label__ = 60; break; } //@line 4016 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 59: // $298
      var $299=$2; //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $300=$tbase; //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $301=$300; //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $302=$tsize; //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $303=(($302-40)|0); //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _init_top($299, $301, $303); //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 61; break; //@line 4017 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 60: // $304
      var $305=$2; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $306=$305; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $307=(($306-8)|0); //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $308=$307; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $309=$308; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $310=$2; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $311=$310; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $312=(($311-8)|0); //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $313=$312; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $314=(($313+4)|0); //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=HEAP32[(($314)>>2)]; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=$315 & -8; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=(($309+$316)|0); //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $318=$317; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mn=$318; //@line 4022 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $319=$2; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $320=$mn; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=$tbase; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $322=$tsize; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=(($321+$322)|0); //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=$mn; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=$324; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=$323; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $327=$325; //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $328=(($326-$327)|0); //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $329=(($328-40)|0); //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _init_top($319, $320, $329); //@line 4023 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 61; break;
    case 61: // $330
      __label__ = 87; break; //@line 4025 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 62: // $331
      var $332=$2; //@line 4029 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $333=(($332+444)|0); //@line 4029 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$333; //@line 4029 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 63; break; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 63: // $334
      var $335=$sp; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $336=(($335)|0)!=0; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($336) { __label__ = 64; break; } else { var $348 = 0;__label__ = 65; break; } //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 64: // $337
      var $338=$tbase; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=$sp; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=(($339)|0); //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=HEAP32[(($340)>>2)]; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=$sp; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $343=(($342+4)|0); //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $344=HEAP32[(($343)>>2)]; //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $345=(($341+$344)|0); //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=(($338)|0)!=(($345)|0); //@line 4031 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348 = $346;__label__ = 65; break;
    case 65: // $347
      var $348;
      if ($348) { __label__ = 66; break; } else { __label__ = 67; break; }
    case 66: // $349
      var $350=$sp; //@line 4032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=(($350+8)|0); //@line 4032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=HEAP32[(($351)>>2)]; //@line 4032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$352; //@line 4032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 63; break; //@line 4032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 67: // $353
      var $354=$sp; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $355=(($354)|0)!=0; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($355) { __label__ = 68; break; } else { __label__ = 73; break; } //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 68: // $356
      var $357=$sp; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=(($357+12)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=HEAP32[(($358)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $360=$359 & 8; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $361=(($360)|0)!=0; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($361) { __label__ = 73; break; } else { __label__ = 69; break; } //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 69: // $362
      var $363=$sp; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $364=(($363+12)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $365=HEAP32[(($364)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $366=$365 & 0; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=$mmap_flag; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=(($366)|0)==(($367)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($368) { __label__ = 70; break; } else { __label__ = 73; break; } //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 70: // $369
      var $370=$2; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $371=(($370+24)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $372=HEAP32[(($371)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $373=$372; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374=$sp; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $375=(($374)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $376=HEAPU32[(($375)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $377=(($373)>>>0) >= (($376)>>>0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($377) { __label__ = 71; break; } else { __label__ = 73; break; } //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 71: // $378
      var $379=$2; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=(($379+24)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=HEAP32[(($380)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=$381; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $383=$sp; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $384=(($383)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $385=HEAP32[(($384)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=$sp; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=(($386+4)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $388=HEAP32[(($387)>>2)]; //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $389=(($385+$388)|0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $390=(($382)>>>0) < (($389)>>>0); //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($390) { __label__ = 72; break; } else { __label__ = 73; break; } //@line 4033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 72: // $391
      var $392=$tsize; //@line 4037 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $393=$sp; //@line 4037 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $394=(($393+4)|0); //@line 4037 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $395=HEAP32[(($394)>>2)]; //@line 4037 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $396=(($395+$392)|0); //@line 4037 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($394)>>2)]=$396; //@line 4037 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $397=$2; //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $398=$2; //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $399=(($398+24)|0); //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $400=HEAP32[(($399)>>2)]; //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $401=$2; //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $402=(($401+12)|0); //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $403=HEAP32[(($402)>>2)]; //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $404=$tsize; //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $405=(($403+$404)|0); //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _init_top($397, $400, $405); //@line 4038 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 86; break; //@line 4039 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 73: // $406
      var $407=$tbase; //@line 4041 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $408=$2; //@line 4041 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $409=(($408+16)|0); //@line 4041 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $410=HEAPU32[(($409)>>2)]; //@line 4041 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $411=(($407)>>>0) < (($410)>>>0); //@line 4041 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($411) { __label__ = 74; break; } else { __label__ = 75; break; } //@line 4041 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 74: // $412
      var $413=$tbase; //@line 4042 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $414=$2; //@line 4042 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $415=(($414+16)|0); //@line 4042 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($415)>>2)]=$413; //@line 4042 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 75; break; //@line 4042 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 75: // $416
      var $417=$2; //@line 4043 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $418=(($417+444)|0); //@line 4043 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$418; //@line 4043 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 76; break; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 76: // $419
      var $420=$sp; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $421=(($420)|0)!=0; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($421) { __label__ = 77; break; } else { var $431 = 0;__label__ = 78; break; } //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 77: // $422
      var $423=$sp; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $424=(($423)|0); //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $425=HEAP32[(($424)>>2)]; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $426=$tbase; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $427=$tsize; //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $428=(($426+$427)|0); //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $429=(($425)|0)!=(($428)|0); //@line 4044 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $431 = $429;__label__ = 78; break;
    case 78: // $430
      var $431;
      if ($431) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $432
      var $433=$sp; //@line 4045 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $434=(($433+8)|0); //@line 4045 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $435=HEAP32[(($434)>>2)]; //@line 4045 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$435; //@line 4045 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 76; break; //@line 4045 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 80: // $436
      var $437=$sp; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $438=(($437)|0)!=0; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($438) { __label__ = 81; break; } else { __label__ = 84; break; } //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 81: // $439
      var $440=$sp; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $441=(($440+12)|0); //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $442=HEAP32[(($441)>>2)]; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $443=$442 & 8; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $444=(($443)|0)!=0; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($444) { __label__ = 84; break; } else { __label__ = 82; break; } //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 82: // $445
      var $446=$sp; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $447=(($446+12)|0); //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $448=HEAP32[(($447)>>2)]; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $449=$448 & 0; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $450=$mmap_flag; //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $451=(($449)|0)==(($450)|0); //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($451) { __label__ = 83; break; } else { __label__ = 84; break; } //@line 4046 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 83: // $452
      var $453=$sp; //@line 4049 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $454=(($453)|0); //@line 4049 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $455=HEAP32[(($454)>>2)]; //@line 4049 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldbase=$455; //@line 4049 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $456=$tbase; //@line 4050 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $457=$sp; //@line 4050 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $458=(($457)|0); //@line 4050 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($458)>>2)]=$456; //@line 4050 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $459=$tsize; //@line 4051 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $460=$sp; //@line 4051 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $461=(($460+4)|0); //@line 4051 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $462=HEAP32[(($461)>>2)]; //@line 4051 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $463=(($462+$459)|0); //@line 4051 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($461)>>2)]=$463; //@line 4051 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $464=$2; //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $465=$tbase; //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $466=$oldbase; //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $467=$3; //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $468=_prepend_alloc($464, $465, $466, $467); //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$468; //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 91; break; //@line 4052 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 84: // $469
      var $470=$2; //@line 4055 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $471=$tbase; //@line 4055 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $472=$tsize; //@line 4055 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $473=$mmap_flag; //@line 4055 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _add_segment($470, $471, $472, $473); //@line 4055 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 85; break;
    case 85: // $474
      __label__ = 86; break;
    case 86: // $475
      __label__ = 87; break;
    case 87: // $476
      var $477=$3; //@line 4059 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $478=$2; //@line 4059 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $479=(($478+12)|0); //@line 4059 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $480=HEAPU32[(($479)>>2)]; //@line 4059 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $481=(($477)>>>0) < (($480)>>>0); //@line 4059 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($481) { __label__ = 88; break; } else { __label__ = 89; break; } //@line 4059 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 88: // $482
      var $483=$3; //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $484=$2; //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $485=(($484+12)|0); //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $486=HEAP32[(($485)>>2)]; //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $487=(($486-$483)|0); //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($485)>>2)]=$487; //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$487; //@line 4060 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $488=$2; //@line 4061 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $489=(($488+24)|0); //@line 4061 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $490=HEAP32[(($489)>>2)]; //@line 4061 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$490; //@line 4061 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $491=$p; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $492=$491; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $493=$3; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $494=(($492+$493)|0); //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $495=$494; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $496=$2; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $497=(($496+24)|0); //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($497)>>2)]=$495; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $r=$495; //@line 4062 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $498=$rsize; //@line 4063 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $499=$498 | 1; //@line 4063 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $500=$r; //@line 4063 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $501=(($500+4)|0); //@line 4063 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($501)>>2)]=$499; //@line 4063 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $502=$3; //@line 4064 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $503=$502 | 1; //@line 4064 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $504=$503 | 2; //@line 4064 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $505=$p; //@line 4064 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $506=(($505+4)|0); //@line 4064 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($506)>>2)]=$504; //@line 4064 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $507=$p; //@line 4067 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $508=$507; //@line 4067 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $509=(($508+8)|0); //@line 4067 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$509; //@line 4067 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 91; break; //@line 4067 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 89: // $510
      __label__ = 90; break; //@line 4069 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 90: // $511
      var $512=___errno(); //@line 4071 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($512)>>2)]=12; //@line 4071 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=0; //@line 4072 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 91; break; //@line 4072 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 91: // $513
      var $514=$1; //@line 4073 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $514; //@line 4073 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_sys_alloc["X"]=1;

function _free($mem) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $p;
      var $psize;
      var $next;
      var $prevsize;
      var $prev;
      var $F;
      var $B;
      var $I;
      var $TP;
      var $XP;
      var $R;
      var $F1;
      var $RP;
      var $CP;
      var $H;
      var $C0;
      var $C1;
      var $tsize;
      var $dsize;
      var $nsize;
      var $F2;
      var $B3;
      var $I4;
      var $TP5;
      var $XP6;
      var $R7;
      var $F8;
      var $RP9;
      var $CP10;
      var $H11;
      var $C012;
      var $C113;
      var $I14;
      var $B15;
      var $F16;
      var $tp;
      var $H17;
      var $I18;
      var $X;
      var $Y;
      var $N;
      var $K;
      var $T;
      var $K19;
      var $C;
      var $F20;
      $1=$mem;
      var $2=$1; //@line 4740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $3=(($2)|0)!=0; //@line 4740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($3) { __label__ = 1; break; } else { __label__ = 195; break; } //@line 4740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $4
      var $5=$1; //@line 4741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5-8)|0); //@line 4741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=$6; //@line 4741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$7; //@line 4741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$p; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=$8; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=(($9)>>>0) >= (($10)>>>0); //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($11) { __label__ = 2; break; } else { var $19 = 0;__label__ = 3; break; } //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $12
      var $13=$p; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=(($13+4)|0); //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=HEAP32[(($14)>>2)]; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$15 & 3; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=(($16)|0)!=1; //@line 4753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19 = $17;__label__ = 3; break;
    case 3: // $18
      var $19;
      var $20=(($19)&1);
      var $21=(($20)==(1));
      var $22=(($21)|0)!=0;
      if ($22) { __label__ = 4; break; } else { __label__ = 192; break; }
    case 4: // $23
      var $24=$p; //@line 4754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=(($24+4)|0); //@line 4754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=HEAP32[(($25)>>2)]; //@line 4754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$26 & -8; //@line 4754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$27; //@line 4754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$p; //@line 4755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=$28; //@line 4755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$psize; //@line 4755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=(($29+$30)|0); //@line 4755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=$31; //@line 4755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $next=$32; //@line 4755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$p; //@line 4756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=(($33+4)|0); //@line 4756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=HEAP32[(($34)>>2)]; //@line 4756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$35 & 1; //@line 4756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=(($36)|0)!=0; //@line 4756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($37) { __label__ = 76; break; } else { __label__ = 5; break; } //@line 4756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $38
      var $39=$p; //@line 4757 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=(($39)|0); //@line 4757 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=HEAP32[(($40)>>2)]; //@line 4757 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $prevsize=$41; //@line 4757 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=$p; //@line 4758 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=(($42+4)|0); //@line 4758 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=HEAP32[(($43)>>2)]; //@line 4758 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$44 & 3; //@line 4758 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=(($45)|0)==0; //@line 4758 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($46) { __label__ = 6; break; } else { __label__ = 7; break; } //@line 4758 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $47
      var $48=$prevsize; //@line 4759 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=(($48+16)|0); //@line 4759 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=$psize; //@line 4759 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=(($50+$49)|0); //@line 4759 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$51; //@line 4759 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 194; break; //@line 4762 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $52
      var $53=$p; //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=$53; //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=$prevsize; //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=(((-$55))|0); //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($54+$56)|0); //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=$57; //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $prev=$58; //@line 4765 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$prevsize; //@line 4766 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=$psize; //@line 4766 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=(($60+$59)|0); //@line 4766 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$61; //@line 4766 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=$prev; //@line 4767 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$62; //@line 4767 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$prev; //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=$63; //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=(($64)>>>0) >= (($65)>>>0); //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $67=(($66)&1); //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=(($67)==(1)); //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68)|0)!=0; //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($69) { __label__ = 8; break; } else { __label__ = 73; break; } //@line 4768 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $70
      var $71=$p; //@line 4769 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=HEAP32[((((__gm_+20)|0))>>2)]; //@line 4769 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=(($71)|0)!=(($72)|0); //@line 4769 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($73) { __label__ = 9; break; } else { __label__ = 69; break; } //@line 4769 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $74
      var $75=$prevsize; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=$75 >>> 3; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=(($76)>>>0) < 32; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($77) { __label__ = 10; break; } else { __label__ = 22; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $78
      var $79=$p; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=(($79+8)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=HEAP32[(($80)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$81; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=$p; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=(($82+12)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=HEAP32[(($83)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B=$84; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=$prevsize; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=$85 >>> 3; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$86; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=$F; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=$B; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=(($87)|0)==(($88)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($89) { __label__ = 11; break; } else { __label__ = 12; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $90
      var $91=$I; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=1 << $91; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $93=$92 ^ -1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=HEAP32[((((__gm_)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=$94 & $93; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_)|0))>>2)]=$95; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 21; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $96
      var $97=$F; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=$I; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=$98 << 1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=((((__gm_+40)|0)+($99<<2))|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$100; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=$101; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=(($97)|0)==(($102)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($103) { __label__ = 14; break; } else { __label__ = 13; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $104
      var $105=$F; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=$105; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=(($106)>>>0) >= (($107)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($108) { __label__ = 14; break; } else { var $125 = 0;__label__ = 17; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $109
      var $110=$B; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=$I; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=$111 << 1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=((((__gm_+40)|0)+($112<<2))|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=$113; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=$114; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=(($110)|0)==(($115)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($116) { var $123 = 1;__label__ = 16; break; } else { __label__ = 15; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $117
      var $118=$B; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $119=$118; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=(($119)>>>0) >= (($120)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $123 = $121;__label__ = 16; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $122
      var $123;
      var $125 = $123;__label__ = 17; break;
    case 17: // $124
      var $125;
      var $126=(($125)&1);
      var $127=(($126)==(1));
      var $128=(($127)|0)!=0;
      if ($128) { __label__ = 18; break; } else { __label__ = 19; break; }
    case 18: // $129
      var $130=$B; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=$F; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $132=(($131+12)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($132)>>2)]=$130; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=$F; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=$B; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=(($134+8)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($135)>>2)]=$133; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 20; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $136
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $137
      __label__ = 21; break;
    case 21: // $138
      __label__ = 68; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $139
      var $140=$p; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=$140; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $TP=$141; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=(($142+24)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=HEAP32[(($143)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $XP=$144; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=(($145+12)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=HEAP32[(($146)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $149=(($147)|0)!=(($148)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($149) { __label__ = 23; break; } else { __label__ = 27; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $150
      var $151=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=(($151+8)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=HEAP32[(($152)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F1=$153; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=(($154+12)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=HEAP32[(($155)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$156; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=$F1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=$157; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=(($158)>>>0) >= (($159)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=(($160)&1); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=(($161)==(1)); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=(($162)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($163) { __label__ = 24; break; } else { __label__ = 25; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $164
      var $165=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $166=$F1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $167=(($166+12)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($167)>>2)]=$165; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=$F1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=(($169+8)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($170)>>2)]=$168; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 26; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $171
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $172
      __label__ = 39; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $173
      var $174=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $175=(($174+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=(($175+4)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$176; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $177=HEAP32[(($176)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$177; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $178=(($177)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($178) { __label__ = 29; break; } else { __label__ = 28; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $179
      var $180=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $181=(($180+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $182=(($181)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$182; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=HEAP32[(($182)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$183; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $184=(($183)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($184) { __label__ = 29; break; } else { __label__ = 38; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $185
      __label__ = 30; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $186
      var $187=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $188=(($187+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $189=(($188+4)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$189; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $190=HEAP32[(($189)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $191=(($190)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($191) { var $199 = 1;__label__ = 32; break; } else { __label__ = 31; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $192
      var $193=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=(($193+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $195=(($194)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$195; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=HEAP32[(($195)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $197=(($196)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199 = $197;__label__ = 32; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $198
      var $199;
      if ($199) { __label__ = 33; break; } else { __label__ = 34; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $200
      var $201=$CP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$201; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $202=HEAP32[(($201)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$202; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 30; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $203
      var $204=$RP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=$204; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=(($205)>>>0) >= (($206)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=(($207)&1); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=(($208)==(1)); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=(($209)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($210) { __label__ = 35; break; } else { __label__ = 36; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $211
      var $212=$RP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($212)>>2)]=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 37; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $213
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $214
      __label__ = 38; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $215
      __label__ = 39; break;
    case 39: // $216
      var $217=$XP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $218=(($217)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($218) { __label__ = 40; break; } else { __label__ = 67; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $219
      var $220=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $221=(($220+28)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $222=HEAP32[(($221)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $223=((((__gm_+304)|0)+($222<<2))|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H=$223; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $224=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $225=$H; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $226=HEAP32[(($225)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=(($224)|0)==(($226)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($227) { __label__ = 41; break; } else { __label__ = 44; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 41: // $228
      var $229=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230=$H; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($230)>>2)]=$229; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $231=(($229)|0)==0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($231) { __label__ = 42; break; } else { __label__ = 43; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 42: // $232
      var $233=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $234=(($233+28)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $235=HEAP32[(($234)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $236=1 << $235; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=$236 ^ -1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $238=HEAP32[((((__gm_+4)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $239=$238 & $237; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+4)|0))>>2)]=$239; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 43; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $240
      __label__ = 51; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $241
      var $242=$XP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=$242; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $245=(($243)>>>0) >= (($244)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=(($245)&1); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=(($246)==(1)); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=(($247)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($248) { __label__ = 45; break; } else { __label__ = 49; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $249
      var $250=$XP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $251=(($250+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $252=(($251)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $253=HEAP32[(($252)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $254=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $255=(($253)|0)==(($254)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($255) { __label__ = 46; break; } else { __label__ = 47; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $256
      var $257=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $258=$XP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=(($258+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=(($259)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($260)>>2)]=$257; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 48; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 47: // $261
      var $262=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $263=$XP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $264=(($263+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $265=(($264+4)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($265)>>2)]=$262; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 48; break;
    case 48: // $266
      __label__ = 50; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $267
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 50: // $268
      __label__ = 51; break;
    case 51: // $269
      var $270=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $271=(($270)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($271) { __label__ = 52; break; } else { __label__ = 66; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $272
      var $273=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $274=$273; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $275=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=(($274)>>>0) >= (($275)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $277=(($276)&1); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $278=(($277)==(1)); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=(($278)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($279) { __label__ = 53; break; } else { __label__ = 64; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 53: // $280
      var $281=$XP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $283=(($282+24)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($283)>>2)]=$281; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $284=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $285=(($284+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $286=(($285)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=HEAP32[(($286)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C0=$287; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=(($287)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($288) { __label__ = 54; break; } else { __label__ = 58; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 54: // $289
      var $290=$C0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $291=$290; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $292=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $293=(($291)>>>0) >= (($292)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $294=(($293)&1); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $295=(($294)==(1)); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $296=(($295)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($296) { __label__ = 55; break; } else { __label__ = 56; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 55: // $297
      var $298=$C0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $299=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $300=(($299+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $301=(($300)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($301)>>2)]=$298; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $302=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $303=$C0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $304=(($303+24)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($304)>>2)]=$302; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 57; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 56: // $305
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 57: // $306
      __label__ = 58; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 58: // $307
      var $308=$TP; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $309=(($308+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $310=(($309+4)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $311=HEAP32[(($310)>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C1=$311; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $312=(($311)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($312) { __label__ = 59; break; } else { __label__ = 63; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 59: // $313
      var $314=$C1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=$314; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=(($315)>>>0) >= (($316)>>>0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $318=(($317)&1); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $319=(($318)==(1)); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $320=(($319)|0)!=0; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($320) { __label__ = 60; break; } else { __label__ = 61; break; } //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 60: // $321
      var $322=$C1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=(($323+16)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=(($324+4)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($325)>>2)]=$322; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=$R; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $327=$C1; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $328=(($327+24)|0); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($328)>>2)]=$326; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 62; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 61: // $329
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 62: // $330
      __label__ = 63; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 63: // $331
      __label__ = 65; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 64: // $332
      _abort(); //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 65: // $333
      __label__ = 66; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 66: // $334
      __label__ = 67; break; //@line 4770 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 67: // $335
      __label__ = 68; break;
    case 68: // $336
      __label__ = 72; break; //@line 4771 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 69: // $337
      var $338=$next; //@line 4772 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=(($338+4)|0); //@line 4772 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=HEAP32[(($339)>>2)]; //@line 4772 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=$340 & 3; //@line 4772 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=(($341)|0)==3; //@line 4772 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($342) { __label__ = 70; break; } else { __label__ = 71; break; } //@line 4772 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 70: // $343
      var $344=$psize; //@line 4773 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=$344; //@line 4773 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $345=$next; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=(($345+4)|0); //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=HEAP32[(($346)>>2)]; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348=$347 & -2; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($346)>>2)]=$348; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $349=$psize; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=$349 | 1; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=$p; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=(($351+4)|0); //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($352)>>2)]=$350; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $353=$psize; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $354=$p; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $355=$354; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $356=$psize; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $357=(($355+$356)|0); //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=$357; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=(($358)|0); //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($359)>>2)]=$353; //@line 4774 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 194; break; //@line 4775 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 71: // $360
      __label__ = 72; break;
    case 72: // $361
      __label__ = 74; break; //@line 4777 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 73: // $362
      __label__ = 193; break; //@line 4779 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 74: // $363
      __label__ = 75; break;
    case 75: // $364
      __label__ = 76; break; //@line 4781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 76: // $365
      var $366=$p; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=$366; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=$next; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=$368; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $370=(($367)>>>0) < (($369)>>>0); //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($370) { __label__ = 77; break; } else { var $378 = 0;__label__ = 78; break; } //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 77: // $371
      var $372=$next; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $373=(($372+4)|0); //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374=HEAP32[(($373)>>2)]; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $375=$374 & 1; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $376=(($375)|0)!=0; //@line 4783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $378 = $376;__label__ = 78; break;
    case 78: // $377
      var $378;
      var $379=(($378)&1);
      var $380=(($379)==(1));
      var $381=(($380)|0)!=0;
      if ($381) { __label__ = 79; break; } else { __label__ = 191; break; }
    case 79: // $382
      var $383=$next; //@line 4784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $384=(($383+4)|0); //@line 4784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $385=HEAP32[(($384)>>2)]; //@line 4784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=$385 & 2; //@line 4784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=(($386)|0)!=0; //@line 4784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($387) { __label__ = 152; break; } else { __label__ = 80; break; } //@line 4784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 80: // $388
      var $389=$next; //@line 4785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $390=HEAP32[((((__gm_+24)|0))>>2)]; //@line 4785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $391=(($389)|0)==(($390)|0); //@line 4785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($391) { __label__ = 81; break; } else { __label__ = 86; break; } //@line 4785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 81: // $392
      var $393=$psize; //@line 4786 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $394=HEAP32[((((__gm_+12)|0))>>2)]; //@line 4786 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $395=(($394+$393)|0); //@line 4786 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+12)|0))>>2)]=$395; //@line 4786 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=$395; //@line 4786 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $396=$p; //@line 4787 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+24)|0))>>2)]=$396; //@line 4787 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $397=$tsize; //@line 4788 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $398=$397 | 1; //@line 4788 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $399=$p; //@line 4788 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $400=(($399+4)|0); //@line 4788 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($400)>>2)]=$398; //@line 4788 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $401=$p; //@line 4789 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $402=HEAP32[((((__gm_+20)|0))>>2)]; //@line 4789 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $403=(($401)|0)==(($402)|0); //@line 4789 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($403) { __label__ = 82; break; } else { __label__ = 83; break; } //@line 4789 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 82: // $404
      HEAP32[((((__gm_+20)|0))>>2)]=0; //@line 4790 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=0; //@line 4791 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 83; break; //@line 4792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 83: // $405
      var $406=$tsize; //@line 4793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $407=HEAPU32[((((__gm_+28)|0))>>2)]; //@line 4793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $408=(($406)>>>0) > (($407)>>>0); //@line 4793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($408) { __label__ = 84; break; } else { __label__ = 85; break; } //@line 4793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 84: // $409
      var $410=_sys_trim(__gm_, 0); //@line 4794 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 85; break; //@line 4794 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 85: // $411
      __label__ = 194; break; //@line 4795 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 86: // $412
      var $413=$next; //@line 4797 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $414=HEAP32[((((__gm_+20)|0))>>2)]; //@line 4797 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $415=(($413)|0)==(($414)|0); //@line 4797 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($415) { __label__ = 87; break; } else { __label__ = 88; break; } //@line 4797 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 87: // $416
      var $417=$psize; //@line 4798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $418=HEAP32[((((__gm_+8)|0))>>2)]; //@line 4798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $419=(($418+$417)|0); //@line 4798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=$419; //@line 4798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $dsize=$419; //@line 4798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $420=$p; //@line 4799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+20)|0))>>2)]=$420; //@line 4799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $421=$dsize; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $422=$421 | 1; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $423=$p; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $424=(($423+4)|0); //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($424)>>2)]=$422; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $425=$dsize; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $426=$p; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $427=$426; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $428=$dsize; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $429=(($427+$428)|0); //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $430=$429; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $431=(($430)|0); //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($431)>>2)]=$425; //@line 4800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 194; break; //@line 4801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 88: // $432
      var $433=$next; //@line 4804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $434=(($433+4)|0); //@line 4804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $435=HEAP32[(($434)>>2)]; //@line 4804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $436=$435 & -8; //@line 4804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nsize=$436; //@line 4804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $437=$nsize; //@line 4805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $438=$psize; //@line 4805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $439=(($438+$437)|0); //@line 4805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$439; //@line 4805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $440=$nsize; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $441=$440 >>> 3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $442=(($441)>>>0) < 32; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($442) { __label__ = 89; break; } else { __label__ = 101; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 89: // $443
      var $444=$next; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $445=(($444+8)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $446=HEAP32[(($445)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F2=$446; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $447=$next; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $448=(($447+12)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $449=HEAP32[(($448)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B3=$449; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $450=$nsize; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $451=$450 >>> 3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I4=$451; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $452=$F2; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $453=$B3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $454=(($452)|0)==(($453)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($454) { __label__ = 90; break; } else { __label__ = 91; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 90: // $455
      var $456=$I4; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $457=1 << $456; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $458=$457 ^ -1; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $459=HEAP32[((((__gm_)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $460=$459 & $458; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_)|0))>>2)]=$460; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 100; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 91: // $461
      var $462=$F2; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $463=$I4; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $464=$463 << 1; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $465=((((__gm_+40)|0)+($464<<2))|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $466=$465; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $467=$466; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $468=(($462)|0)==(($467)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($468) { __label__ = 93; break; } else { __label__ = 92; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 92: // $469
      var $470=$F2; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $471=$470; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $472=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $473=(($471)>>>0) >= (($472)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($473) { __label__ = 93; break; } else { var $490 = 0;__label__ = 96; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 93: // $474
      var $475=$B3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $476=$I4; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $477=$476 << 1; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $478=((((__gm_+40)|0)+($477<<2))|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $479=$478; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $480=$479; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $481=(($475)|0)==(($480)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($481) { var $488 = 1;__label__ = 95; break; } else { __label__ = 94; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 94: // $482
      var $483=$B3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $484=$483; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $485=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $486=(($484)>>>0) >= (($485)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $488 = $486;__label__ = 95; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 95: // $487
      var $488;
      var $490 = $488;__label__ = 96; break;
    case 96: // $489
      var $490;
      var $491=(($490)&1);
      var $492=(($491)==(1));
      var $493=(($492)|0)!=0;
      if ($493) { __label__ = 97; break; } else { __label__ = 98; break; }
    case 97: // $494
      var $495=$B3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $496=$F2; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $497=(($496+12)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($497)>>2)]=$495; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $498=$F2; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $499=$B3; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $500=(($499+8)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($500)>>2)]=$498; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 99; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 98: // $501
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 99: // $502
      __label__ = 100; break;
    case 100: // $503
      __label__ = 147; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 101: // $504
      var $505=$next; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $506=$505; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $TP5=$506; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $507=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $508=(($507+24)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $509=HEAP32[(($508)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $XP6=$509; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $510=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $511=(($510+12)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $512=HEAP32[(($511)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $513=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $514=(($512)|0)!=(($513)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($514) { __label__ = 102; break; } else { __label__ = 106; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 102: // $515
      var $516=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $517=(($516+8)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $518=HEAP32[(($517)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F8=$518; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $519=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $520=(($519+12)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $521=HEAP32[(($520)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R7=$521; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $522=$F8; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $523=$522; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $524=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $525=(($523)>>>0) >= (($524)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $526=(($525)&1); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $527=(($526)==(1)); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $528=(($527)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($528) { __label__ = 103; break; } else { __label__ = 104; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 103: // $529
      var $530=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $531=$F8; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $532=(($531+12)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($532)>>2)]=$530; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $533=$F8; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $534=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $535=(($534+8)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($535)>>2)]=$533; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 105; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 104: // $536
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 105: // $537
      __label__ = 118; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 106: // $538
      var $539=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $540=(($539+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $541=(($540+4)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP9=$541; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $542=HEAP32[(($541)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R7=$542; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $543=(($542)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($543) { __label__ = 108; break; } else { __label__ = 107; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 107: // $544
      var $545=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $546=(($545+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $547=(($546)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP9=$547; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $548=HEAP32[(($547)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R7=$548; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $549=(($548)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($549) { __label__ = 108; break; } else { __label__ = 117; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 108: // $550
      __label__ = 109; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 109: // $551
      var $552=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $553=(($552+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $554=(($553+4)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP10=$554; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $555=HEAP32[(($554)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $556=(($555)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($556) { var $564 = 1;__label__ = 111; break; } else { __label__ = 110; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 110: // $557
      var $558=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $559=(($558+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $560=(($559)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP10=$560; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $561=HEAP32[(($560)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $562=(($561)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $564 = $562;__label__ = 111; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 111: // $563
      var $564;
      if ($564) { __label__ = 112; break; } else { __label__ = 113; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 112: // $565
      var $566=$CP10; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP9=$566; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $567=HEAP32[(($566)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R7=$567; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 109; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 113: // $568
      var $569=$RP9; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $570=$569; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $571=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $572=(($570)>>>0) >= (($571)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $573=(($572)&1); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $574=(($573)==(1)); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $575=(($574)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($575) { __label__ = 114; break; } else { __label__ = 115; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 114: // $576
      var $577=$RP9; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($577)>>2)]=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 116; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 115: // $578
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 116: // $579
      __label__ = 117; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 117: // $580
      __label__ = 118; break;
    case 118: // $581
      var $582=$XP6; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $583=(($582)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($583) { __label__ = 119; break; } else { __label__ = 146; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 119: // $584
      var $585=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $586=(($585+28)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $587=HEAP32[(($586)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $588=((((__gm_+304)|0)+($587<<2))|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H11=$588; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $589=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $590=$H11; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $591=HEAP32[(($590)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $592=(($589)|0)==(($591)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($592) { __label__ = 120; break; } else { __label__ = 123; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 120: // $593
      var $594=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $595=$H11; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($595)>>2)]=$594; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $596=(($594)|0)==0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($596) { __label__ = 121; break; } else { __label__ = 122; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 121: // $597
      var $598=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $599=(($598+28)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $600=HEAP32[(($599)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $601=1 << $600; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $602=$601 ^ -1; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $603=HEAP32[((((__gm_+4)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $604=$603 & $602; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+4)|0))>>2)]=$604; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 122; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 122: // $605
      __label__ = 130; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 123: // $606
      var $607=$XP6; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $608=$607; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $609=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $610=(($608)>>>0) >= (($609)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $611=(($610)&1); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $612=(($611)==(1)); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $613=(($612)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($613) { __label__ = 124; break; } else { __label__ = 128; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 124: // $614
      var $615=$XP6; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $616=(($615+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $617=(($616)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $618=HEAP32[(($617)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $619=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $620=(($618)|0)==(($619)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($620) { __label__ = 125; break; } else { __label__ = 126; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 125: // $621
      var $622=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $623=$XP6; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $624=(($623+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $625=(($624)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($625)>>2)]=$622; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 127; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 126: // $626
      var $627=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $628=$XP6; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $629=(($628+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $630=(($629+4)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($630)>>2)]=$627; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 127; break;
    case 127: // $631
      __label__ = 129; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 128: // $632
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 129: // $633
      __label__ = 130; break;
    case 130: // $634
      var $635=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $636=(($635)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($636) { __label__ = 131; break; } else { __label__ = 145; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 131: // $637
      var $638=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $639=$638; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $640=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $641=(($639)>>>0) >= (($640)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $642=(($641)&1); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $643=(($642)==(1)); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $644=(($643)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($644) { __label__ = 132; break; } else { __label__ = 143; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 132: // $645
      var $646=$XP6; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $647=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $648=(($647+24)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($648)>>2)]=$646; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $649=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $650=(($649+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $651=(($650)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $652=HEAP32[(($651)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C012=$652; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $653=(($652)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($653) { __label__ = 133; break; } else { __label__ = 137; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 133: // $654
      var $655=$C012; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $656=$655; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $657=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $658=(($656)>>>0) >= (($657)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $659=(($658)&1); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $660=(($659)==(1)); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $661=(($660)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($661) { __label__ = 134; break; } else { __label__ = 135; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 134: // $662
      var $663=$C012; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $664=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $665=(($664+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $666=(($665)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($666)>>2)]=$663; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $667=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $668=$C012; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $669=(($668+24)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($669)>>2)]=$667; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 136; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 135: // $670
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 136: // $671
      __label__ = 137; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 137: // $672
      var $673=$TP5; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $674=(($673+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $675=(($674+4)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $676=HEAP32[(($675)>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C113=$676; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $677=(($676)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($677) { __label__ = 138; break; } else { __label__ = 142; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 138: // $678
      var $679=$C113; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $680=$679; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $681=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $682=(($680)>>>0) >= (($681)>>>0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $683=(($682)&1); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $684=(($683)==(1)); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $685=(($684)|0)!=0; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($685) { __label__ = 139; break; } else { __label__ = 140; break; } //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 139: // $686
      var $687=$C113; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $688=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $689=(($688+16)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $690=(($689+4)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($690)>>2)]=$687; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $691=$R7; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $692=$C113; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $693=(($692+24)|0); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($693)>>2)]=$691; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 141; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 140: // $694
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 141: // $695
      __label__ = 142; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 142: // $696
      __label__ = 144; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 143: // $697
      _abort(); //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 144: // $698
      __label__ = 145; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 145: // $699
      __label__ = 146; break; //@line 4806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 146: // $700
      __label__ = 147; break;
    case 147: // $701
      var $702=$psize; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $703=$702 | 1; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $704=$p; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $705=(($704+4)|0); //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($705)>>2)]=$703; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $706=$psize; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $707=$p; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $708=$707; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $709=$psize; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $710=(($708+$709)|0); //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $711=$710; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $712=(($711)|0); //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($712)>>2)]=$706; //@line 4807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $713=$p; //@line 4808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $714=HEAP32[((((__gm_+20)|0))>>2)]; //@line 4808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $715=(($713)|0)==(($714)|0); //@line 4808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($715) { __label__ = 148; break; } else { __label__ = 149; break; } //@line 4808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 148: // $716
      var $717=$psize; //@line 4809 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+8)|0))>>2)]=$717; //@line 4809 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 194; break; //@line 4810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 149: // $718
      __label__ = 150; break;
    case 150: // $719
      __label__ = 151; break;
    case 151: // $720
      __label__ = 153; break; //@line 4813 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 152: // $721
      var $722=$next; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $723=(($722+4)|0); //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $724=HEAP32[(($723)>>2)]; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $725=$724 & -2; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($723)>>2)]=$725; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $726=$psize; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $727=$726 | 1; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $728=$p; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $729=(($728+4)|0); //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($729)>>2)]=$727; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $730=$psize; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $731=$p; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $732=$731; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $733=$psize; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $734=(($732+$733)|0); //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $735=$734; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $736=(($735)|0); //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($736)>>2)]=$730; //@line 4815 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 153; break;
    case 153: // $737
      var $738=$psize; //@line 4817 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $739=$738 >>> 3; //@line 4817 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $740=(($739)>>>0) < 32; //@line 4817 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($740) { __label__ = 154; break; } else { __label__ = 161; break; } //@line 4817 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 154: // $741
      var $742=$psize; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $743=$742 >>> 3; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I14=$743; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $744=$I14; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $745=$744 << 1; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $746=((((__gm_+40)|0)+($745<<2))|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $747=$746; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $748=$747; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B15=$748; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $749=$B15; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F16=$749; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $750=HEAP32[((((__gm_)|0))>>2)]; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $751=$I14; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $752=1 << $751; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $753=$750 & $752; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $754=(($753)|0)!=0; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($754) { __label__ = 156; break; } else { __label__ = 155; break; } //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 155: // $755
      var $756=$I14; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $757=1 << $756; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $758=HEAP32[((((__gm_)|0))>>2)]; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $759=$758 | $757; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_)|0))>>2)]=$759; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 160; break; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 156: // $760
      var $761=$B15; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $762=(($761+8)|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $763=HEAP32[(($762)>>2)]; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $764=$763; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $765=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $766=(($764)>>>0) >= (($765)>>>0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $767=(($766)&1); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $768=(($767)==(1)); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $769=(($768)|0)!=0; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($769) { __label__ = 157; break; } else { __label__ = 158; break; } //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 157: // $770
      var $771=$B15; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $772=(($771+8)|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $773=HEAP32[(($772)>>2)]; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F16=$773; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 159; break; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 158: // $774
      _abort(); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 159: // $775
      __label__ = 160; break;
    case 160: // $776
      var $777=$p; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $778=$B15; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $779=(($778+8)|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($779)>>2)]=$777; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $780=$p; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $781=$F16; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $782=(($781+12)|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($782)>>2)]=$780; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $783=$F16; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $784=$p; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $785=(($784+8)|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($785)>>2)]=$783; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $786=$B15; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $787=$p; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $788=(($787+12)|0); //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($788)>>2)]=$786; //@line 4818 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 190; break; //@line 4820 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 161: // $789
      var $790=$p; //@line 4822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $791=$790; //@line 4822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tp=$791; //@line 4822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $792=$psize; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $793=$792 >>> 8; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $X=$793; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $794=$X; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $795=(($794)|0)==0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($795) { __label__ = 162; break; } else { __label__ = 163; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 162: // $796
      $I18=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 167; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 163: // $797
      var $798=$X; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $799=(($798)>>>0) > 65535; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($799) { __label__ = 164; break; } else { __label__ = 165; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 164: // $800
      $I18=31; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 166; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 165: // $801
      var $802=$X; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$802; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $803=$Y; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $804=(($803-256)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $805=$804 >>> 16; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $806=$805 & 8; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$806; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $807=$N; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $808=$Y; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $809=$808 << $807; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$809; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $810=(($809-4096)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $811=$810 >>> 16; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $812=$811 & 4; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$812; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $813=$K; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $814=$N; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $815=(($814+$813)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$815; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $816=$K; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $817=$Y; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $818=$817 << $816; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$818; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $819=(($818-16384)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $820=$819 >>> 16; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $821=$820 & 2; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$821; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $822=$N; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $823=(($822+$821)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$823; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $824=$N; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $825=((14-$824)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $826=$K; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $827=$Y; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $828=$827 << $826; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$828; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $829=$828 >>> 15; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $830=(($825+$829)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$830; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $831=$K; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $832=$831 << 1; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $833=$psize; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $834=$K; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $835=(($834+7)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $836=$833 >>> (($835)>>>0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $837=$836 & 1; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $838=(($832+$837)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I18=$838; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 166; break;
    case 166: // $839
      __label__ = 167; break;
    case 167: // $840
      var $841=$I18; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $842=((((__gm_+304)|0)+($841<<2))|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H17=$842; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $843=$I18; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $844=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $845=(($844+28)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($845)>>2)]=$843; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $846=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $847=(($846+16)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $848=(($847+4)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($848)>>2)]=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $849=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $850=(($849+16)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $851=(($850)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($851)>>2)]=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $852=HEAP32[((((__gm_+4)|0))>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $853=$I18; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $854=1 << $853; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $855=$852 & $854; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $856=(($855)|0)!=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($856) { __label__ = 169; break; } else { __label__ = 168; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 168: // $857
      var $858=$I18; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $859=1 << $858; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $860=HEAP32[((((__gm_+4)|0))>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $861=$860 | $859; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+4)|0))>>2)]=$861; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $862=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $863=$H17; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($863)>>2)]=$862; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $864=$H17; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $865=$864; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $866=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $867=(($866+24)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($867)>>2)]=$865; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $868=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $869=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $870=(($869+12)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($870)>>2)]=$868; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $871=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $872=(($871+8)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($872)>>2)]=$868; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 187; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 169: // $873
      var $874=$H17; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $875=HEAP32[(($874)>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$875; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $876=$psize; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $877=$I18; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $878=(($877)|0)==31; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($878) { __label__ = 170; break; } else { __label__ = 171; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 170: // $879
      var $887 = 0;__label__ = 172; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 171: // $880
      var $881=$I18; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $882=$881 >>> 1; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $883=(($882+8)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $884=(($883-2)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $885=((31-$884)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $887 = $885;__label__ = 172; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 172: // $886
      var $887; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $888=$876 << $887; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K19=$888; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 173; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 173: // $889
      var $890=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $891=(($890+4)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $892=HEAP32[(($891)>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $893=$892 & -8; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $894=$psize; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $895=(($893)|0)!=(($894)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($895) { __label__ = 174; break; } else { __label__ = 180; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 174: // $896
      var $897=$K19; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $898=$897 >>> 31; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $899=$898 & 1; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $900=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $901=(($900+16)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $902=(($901+($899<<2))|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C=$902; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $903=$K19; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $904=$903 << 1; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K19=$904; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $905=$C; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $906=HEAP32[(($905)>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $907=(($906)|0)!=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($907) { __label__ = 175; break; } else { __label__ = 176; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 175: // $908
      var $909=$C; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $910=HEAP32[(($909)>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$910; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 179; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 176: // $911
      var $912=$C; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $913=$912; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $914=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $915=(($913)>>>0) >= (($914)>>>0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $916=(($915)&1); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $917=(($916)==(1)); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $918=(($917)|0)!=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($918) { __label__ = 177; break; } else { __label__ = 178; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 177: // $919
      var $920=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $921=$C; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($921)>>2)]=$920; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $922=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $923=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $924=(($923+24)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($924)>>2)]=$922; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $925=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $926=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $927=(($926+12)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($927)>>2)]=$925; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $928=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $929=(($928+8)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($929)>>2)]=$925; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 186; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 178: // $930
      _abort(); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 179: // $931
      __label__ = 185; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 180: // $932
      var $933=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $934=(($933+8)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $935=HEAP32[(($934)>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F20=$935; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $936=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $937=$936; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $938=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $939=(($937)>>>0) >= (($938)>>>0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($939) { __label__ = 181; break; } else { var $946 = 0;__label__ = 182; break; } //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 181: // $940
      var $941=$F20; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $942=$941; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $943=HEAPU32[((((__gm_+16)|0))>>2)]; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $944=(($942)>>>0) >= (($943)>>>0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $946 = $944;__label__ = 182; break;
    case 182: // $945
      var $946;
      var $947=(($946)&1);
      var $948=(($947)==(1));
      var $949=(($948)|0)!=0;
      if ($949) { __label__ = 183; break; } else { __label__ = 184; break; }
    case 183: // $950
      var $951=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $952=$F20; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $953=(($952+12)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($953)>>2)]=$951; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $954=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $955=(($954+8)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($955)>>2)]=$951; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $956=$F20; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $957=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $958=(($957+8)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($958)>>2)]=$956; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $959=$T; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $960=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $961=(($960+12)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($961)>>2)]=$959; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $962=$tp; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $963=(($962+24)|0); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($963)>>2)]=0; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 186; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 184: // $964
      _abort(); //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 185: // $965
      __label__ = 173; break; //@line 4823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 186: // $966
      __label__ = 187; break;
    case 187: // $967
      var $968=HEAP32[((((__gm_+32)|0))>>2)]; //@line 4825 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $969=(($968-1)|0); //@line 4825 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+32)|0))>>2)]=$969; //@line 4825 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $970=(($969)|0)==0; //@line 4825 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($970) { __label__ = 188; break; } else { __label__ = 189; break; } //@line 4825 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 188: // $971
      var $972=_release_unused_segments(__gm_); //@line 4826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 189; break; //@line 4826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 189: // $973
      __label__ = 190; break;
    case 190: // $974
      __label__ = 194; break; //@line 4828 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 191: // $975
      __label__ = 192; break; //@line 4830 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 192: // $976
      __label__ = 193; break; //@line 4830 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 193: // $977
      _abort(); //@line 4832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 194: // $978
      __label__ = 195; break; //@line 4836 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 195: // $979
      ;
      return; //@line 4840 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_free["X"]=1;

function _sys_trim($m, $pad) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $released;
      var $unit;
      var $extra;
      var $sp;
      var $old_br;
      var $rel_br;
      var $new_br;
      $1=$m;
      $2=$pad;
      $released=0; //@line 4126 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $3=HEAP32[((((_mparams)|0))>>2)]; //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $4=(($3)|0)!=0; //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($4) { var $9 = 1;__label__ = 2; break; } else { __label__ = 1; break; } //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $5
      var $6=_init_mparams(); //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=(($6)|0)!=0; //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9 = $7;__label__ = 2; break; //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $8
      var $9;
      var $10=(($9)&1); //@line 4127 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=$2; //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=(($11)>>>0) < 4294967232; //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($12) { __label__ = 3; break; } else { __label__ = 24; break; } //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $13
      var $14=$1; //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=(($14+24)|0); //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=HEAP32[(($15)>>2)]; //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=(($16)|0)!=0; //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($17) { __label__ = 4; break; } else { __label__ = 24; break; } //@line 4128 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $18
      var $19=$2; //@line 4129 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=(($19+40)|0); //@line 4129 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $2=$20; //@line 4129 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=$1; //@line 4131 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=(($21+12)|0); //@line 4131 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=HEAPU32[(($22)>>2)]; //@line 4131 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=$2; //@line 4131 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=(($23)>>>0) > (($24)>>>0); //@line 4131 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($25) { __label__ = 5; break; } else { __label__ = 20; break; } //@line 4131 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $26
      var $27=HEAP32[((((_mparams+8)|0))>>2)]; //@line 4133 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $unit=$27; //@line 4133 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$1; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=(($28+12)|0); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=HEAP32[(($29)>>2)]; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=$2; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=(($30-$31)|0); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$unit; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=(($33-1)|0); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=(($32+$34)|0); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$unit; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=Math.floor((($35)>>>0)/(($36)>>>0)); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=(($37-1)|0); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=$unit; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=(($38*$39)|0); //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $extra=$40; //@line 4135 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$1; //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=$1; //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=(($42+24)|0); //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=HEAP32[(($43)>>2)]; //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$44; //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=_segment_holding($41, $45); //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$46; //@line 4136 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=$sp; //@line 4138 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $48=(($47+12)|0); //@line 4138 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=HEAP32[(($48)>>2)]; //@line 4138 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=$49 & 8; //@line 4138 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=(($50)|0)!=0; //@line 4138 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($51) { __label__ = 17; break; } else { __label__ = 6; break; } //@line 4138 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $52
      var $53=$sp; //@line 4139 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=(($53+12)|0); //@line 4139 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=HEAP32[(($54)>>2)]; //@line 4139 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$55 & 0; //@line 4139 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56)|0)!=0; //@line 4139 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($57) { __label__ = 7; break; } else { __label__ = 8; break; } //@line 4139 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $58
      __label__ = 16; break; //@line 4150 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $59
      var $60=$extra; //@line 4152 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=(($60)>>>0) >= 2147483647; //@line 4152 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($61) { __label__ = 9; break; } else { __label__ = 10; break; } //@line 4152 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $62
      var $63=$unit; //@line 4153 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=((-2147483648-$63)|0); //@line 4153 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $extra=$64; //@line 4153 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 10; break; //@line 4153 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $65
      var $66=_sbrk(0); //@line 4157 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $old_br=$66; //@line 4157 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $67=$old_br; //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=$sp; //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68)|0); //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=HEAP32[(($69)>>2)]; //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=$sp; //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=(($71+4)|0); //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=HEAP32[(($72)>>2)]; //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=(($70+$73)|0); //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=(($67)|0)==(($74)|0); //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($75) { __label__ = 11; break; } else { __label__ = 15; break; } //@line 4158 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $76
      var $77=$extra; //@line 4159 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=(((-$77))|0); //@line 4159 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=_sbrk($78); //@line 4159 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rel_br=$79; //@line 4159 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=_sbrk(0); //@line 4160 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $new_br=$80; //@line 4160 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=$rel_br; //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=(($81)|0)!=-1; //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($82) { __label__ = 12; break; } else { __label__ = 14; break; } //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $83
      var $84=$new_br; //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=$old_br; //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=(($84)>>>0) < (($85)>>>0); //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($86) { __label__ = 13; break; } else { __label__ = 14; break; } //@line 4161 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $87
      var $88=$old_br; //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=$new_br; //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=$88; //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=$89; //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=(($90-$91)|0); //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $released=$92; //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 14; break; //@line 4162 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $93
      __label__ = 15; break; //@line 4163 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $94
      __label__ = 16; break;
    case 16: // $95
      __label__ = 17; break; //@line 4167 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $96
      var $97=$released; //@line 4169 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=(($97)|0)!=0; //@line 4169 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($98) { __label__ = 18; break; } else { __label__ = 19; break; } //@line 4169 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $99
      var $100=$released; //@line 4170 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$sp; //@line 4170 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=(($101+4)|0); //@line 4170 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=HEAP32[(($102)>>2)]; //@line 4170 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=(($103-$100)|0); //@line 4170 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($102)>>2)]=$104; //@line 4170 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $105=$released; //@line 4171 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=$1; //@line 4171 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=(($106+432)|0); //@line 4171 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=HEAP32[(($107)>>2)]; //@line 4171 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $109=(($108-$105)|0); //@line 4171 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($107)>>2)]=$109; //@line 4171 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $110=$1; //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=$1; //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=(($111+24)|0); //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=HEAP32[(($112)>>2)]; //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=$1; //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=(($114+12)|0); //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=HEAP32[(($115)>>2)]; //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=$released; //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=(($116-$117)|0); //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _init_top($110, $113, $118); //@line 4172 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 19; break; //@line 4174 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $119
      __label__ = 20; break; //@line 4175 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $120
      var $121=$released; //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=(($121)|0)==0; //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($122) { __label__ = 21; break; } else { __label__ = 23; break; } //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $123
      var $124=$1; //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=(($124+12)|0); //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=HEAPU32[(($125)>>2)]; //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=$1; //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=(($127+28)|0); //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=HEAPU32[(($128)>>2)]; //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=(($126)>>>0) > (($129)>>>0); //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($130) { __label__ = 22; break; } else { __label__ = 23; break; } //@line 4182 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $131
      var $132=$1; //@line 4183 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=(($132+28)|0); //@line 4183 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($133)>>2)]=-1; //@line 4183 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 23; break; //@line 4183 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $134
      __label__ = 24; break; //@line 4184 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $135
      var $136=$released; //@line 4186 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $137=(($136)|0)!=0; //@line 4186 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $138=$137 ? 1 : 0; //@line 4186 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $138; //@line 4186 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_sys_trim["X"]=1;

function _realloc($oldmem, $bytes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $m;
      $2=$oldmem;
      $3=$bytes;
      var $4=$2; //@line 4858 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=(($4)|0)==0; //@line 4858 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 4858 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $6
      var $7=$3; //@line 4859 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=_malloc($7); //@line 4859 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$8; //@line 4859 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 3; break; //@line 4859 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $9
      $m=__gm_; //@line 4868 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=$m; //@line 4876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=$2; //@line 4876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$3; //@line 4876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=_internal_realloc($10, $11, $12); //@line 4876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$13; //@line 4876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 3; break; //@line 4876 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $14
      var $15=$1; //@line 4878 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $15; //@line 4878 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}


function _release_unused_segments($m) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $released;
      var $nsegs;
      var $pred;
      var $sp;
      var $base;
      var $size;
      var $next;
      var $p;
      var $psize;
      var $tp;
      var $XP;
      var $R;
      var $F;
      var $RP;
      var $CP;
      var $H;
      var $C0;
      var $C1;
      var $H1;
      var $I;
      var $X;
      var $Y;
      var $N;
      var $K;
      var $T;
      var $K2;
      var $C;
      var $F3;
      $1=$m;
      $released=0; //@line 4079 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nsegs=0; //@line 4080 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $2=$1; //@line 4081 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $3=(($2+444)|0); //@line 4081 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $pred=$3; //@line 4081 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $4=$pred; //@line 4082 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=(($4+8)|0); //@line 4082 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=HEAP32[(($5)>>2)]; //@line 4082 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$6; //@line 4082 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 1; break; //@line 4083 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $7
      var $8=$sp; //@line 4083 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(($8)|0)!=0; //@line 4083 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($9) { __label__ = 2; break; } else { __label__ = 86; break; } //@line 4083 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $10
      var $11=$sp; //@line 4084 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=(($11)|0); //@line 4084 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=HEAP32[(($12)>>2)]; //@line 4084 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $base=$13; //@line 4084 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=$sp; //@line 4085 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=(($14+4)|0); //@line 4085 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=HEAP32[(($15)>>2)]; //@line 4085 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $size=$16; //@line 4085 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=$sp; //@line 4086 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=(($17+8)|0); //@line 4086 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=HEAP32[(($18)>>2)]; //@line 4086 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $next=$19; //@line 4086 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$nsegs; //@line 4087 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=(($20+1)|0); //@line 4087 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nsegs=$21; //@line 4087 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=$sp; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=(($22+12)|0); //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=HEAP32[(($23)>>2)]; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$24 & 0; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=(($25)|0)!=0; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($26) { __label__ = 3; break; } else { __label__ = 85; break; } //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $27
      var $28=$sp; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=(($28+12)|0); //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=HEAP32[(($29)>>2)]; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=$30 & 8; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=(($31)|0)!=0; //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($32) { __label__ = 85; break; } else { __label__ = 4; break; } //@line 4088 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $33
      var $34=$base; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=$base; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=(($35+8)|0); //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$36; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=$37 & 7; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=(($38)|0)==0; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($39) { __label__ = 5; break; } else { __label__ = 6; break; } //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $40
      var $49 = 0;__label__ = 7; break; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $41
      var $42=$base; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=(($42+8)|0); //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$43; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$44 & 7; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=((8-$45)|0); //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=$46 & 7; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49 = $47;__label__ = 7; break; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $48
      var $49; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=(($34+$49)|0); //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=$50; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$51; //@line 4089 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=$p; //@line 4090 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=(($52+4)|0); //@line 4090 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=HEAP32[(($53)>>2)]; //@line 4090 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=$54 & -8; //@line 4090 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$55; //@line 4090 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$p; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56+4)|0); //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=HEAP32[(($57)>>2)]; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$58 & 3; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=(($59)|0)!=1; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($60) { __label__ = 84; break; } else { __label__ = 8; break; } //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $61
      var $62=$p; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$62; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=$psize; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=(($63+$64)|0); //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=$base; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $67=$size; //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=(($66+$67)|0); //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68-40)|0); //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=(($65)>>>0) >= (($69)>>>0); //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($70) { __label__ = 9; break; } else { __label__ = 84; break; } //@line 4092 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $71
      var $72=$p; //@line 4093 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=$72; //@line 4093 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tp=$73; //@line 4093 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=$p; //@line 4095 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=$1; //@line 4095 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=(($75+20)|0); //@line 4095 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=HEAP32[(($76)>>2)]; //@line 4095 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=(($74)|0)==(($77)|0); //@line 4095 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($78) { __label__ = 10; break; } else { __label__ = 11; break; } //@line 4095 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $79
      var $80=$1; //@line 4096 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=(($80+20)|0); //@line 4096 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($81)>>2)]=0; //@line 4096 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=$1; //@line 4097 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=(($82+8)|0); //@line 4097 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($83)>>2)]=0; //@line 4097 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 57; break; //@line 4098 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $84
      var $85=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=(($85+24)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=HEAP32[(($86)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $XP=$87; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=(($88+12)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=HEAP32[(($89)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=(($90)|0)!=(($91)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($92) { __label__ = 12; break; } else { __label__ = 16; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $93
      var $94=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=(($94+8)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=HEAP32[(($95)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$96; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=(($97+12)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=HEAP32[(($98)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$99; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=$F; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$100; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=(($102+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=HEAPU32[(($103)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $105=(($101)>>>0) >= (($104)>>>0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=(($105)&1); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=(($106)==(1)); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=(($107)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($108) { __label__ = 13; break; } else { __label__ = 14; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $109
      var $110=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=$F; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=(($111+12)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($112)>>2)]=$110; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=$F; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=(($114+8)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($115)>>2)]=$113; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 15; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $116
      _abort(); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $117
      __label__ = 28; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $118
      var $119=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=(($119+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=(($120+4)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$121; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=HEAP32[(($121)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$122; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $123=(($122)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($123) { __label__ = 18; break; } else { __label__ = 17; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $124
      var $125=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=(($125+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=(($126)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$127; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=HEAP32[(($127)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$128; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=(($128)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($129) { __label__ = 18; break; } else { __label__ = 27; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $130
      __label__ = 19; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $131
      var $132=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=(($132+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=(($133+4)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$134; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=HEAP32[(($134)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=(($135)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($136) { var $144 = 1;__label__ = 21; break; } else { __label__ = 20; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $137
      var $138=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=(($138+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $140=(($139)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$140; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=HEAP32[(($140)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=(($141)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144 = $142;__label__ = 21; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $143
      var $144;
      if ($144) { __label__ = 22; break; } else { __label__ = 23; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $145
      var $146=$CP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$146; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=HEAP32[(($146)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$147; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 19; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $148
      var $149=$RP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $150=$149; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=(($151+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=HEAPU32[(($152)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=(($150)>>>0) >= (($153)>>>0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=(($154)&1); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=(($155)==(1)); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=(($156)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($157) { __label__ = 24; break; } else { __label__ = 25; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $158
      var $159=$RP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($159)>>2)]=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 26; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $160
      _abort(); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $161
      __label__ = 27; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $162
      __label__ = 28; break;
    case 28: // $163
      var $164=$XP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=(($164)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($165) { __label__ = 29; break; } else { __label__ = 56; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $166
      var $167=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=(($167+28)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=HEAP32[(($168)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $171=(($170+304)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=(($171+($169<<2))|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H=$172; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $173=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $174=$H; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $175=HEAP32[(($174)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=(($173)|0)==(($175)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($176) { __label__ = 30; break; } else { __label__ = 33; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $177
      var $178=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $179=$H; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($179)>>2)]=$178; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $180=(($178)|0)==0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($180) { __label__ = 31; break; } else { __label__ = 32; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $181
      var $182=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=(($182+28)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $184=HEAP32[(($183)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $185=1 << $184; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $186=$185 ^ -1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $187=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $188=(($187+4)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $189=HEAP32[(($188)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $190=$189 & $186; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($188)>>2)]=$190; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 32; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $191
      __label__ = 40; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $192
      var $193=$XP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=$193; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $195=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=(($195+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $197=HEAPU32[(($196)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $198=(($194)>>>0) >= (($197)>>>0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=(($198)&1); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $200=(($199)==(1)); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $201=(($200)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($201) { __label__ = 34; break; } else { __label__ = 38; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $202
      var $203=$XP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=(($203+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=(($204)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=HEAP32[(($205)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=(($206)|0)==(($207)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($208) { __label__ = 35; break; } else { __label__ = 36; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $209
      var $210=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=$XP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=(($211+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $213=(($212)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($213)>>2)]=$210; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 37; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $214
      var $215=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $216=$XP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $217=(($216+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $218=(($217+4)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($218)>>2)]=$215; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 37; break;
    case 37: // $219
      __label__ = 39; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $220
      _abort(); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 39: // $221
      __label__ = 40; break;
    case 40: // $222
      var $223=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $224=(($223)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($224) { __label__ = 41; break; } else { __label__ = 55; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 41: // $225
      var $226=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=$226; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $229=(($228+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230=HEAPU32[(($229)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $231=(($227)>>>0) >= (($230)>>>0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $232=(($231)&1); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $233=(($232)==(1)); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $234=(($233)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($234) { __label__ = 42; break; } else { __label__ = 53; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 42: // $235
      var $236=$XP; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $238=(($237+24)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($238)>>2)]=$236; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $239=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $240=(($239+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $241=(($240)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $242=HEAP32[(($241)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C0=$242; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=(($242)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($243) { __label__ = 43; break; } else { __label__ = 47; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $244
      var $245=$C0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=$245; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=(($247+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $249=HEAPU32[(($248)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $250=(($246)>>>0) >= (($249)>>>0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $251=(($250)&1); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $252=(($251)==(1)); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $253=(($252)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($253) { __label__ = 44; break; } else { __label__ = 45; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $254
      var $255=$C0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $256=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $257=(($256+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $258=(($257)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($258)>>2)]=$255; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=$C0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $261=(($260+24)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($261)>>2)]=$259; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 46; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $262
      _abort(); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $263
      __label__ = 47; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 47: // $264
      var $265=$tp; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $266=(($265+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $267=(($266+4)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $268=HEAP32[(($267)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C1=$268; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $269=(($268)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($269) { __label__ = 48; break; } else { __label__ = 52; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $270
      var $271=$C1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $272=$271; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $273=$1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $274=(($273+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $275=HEAPU32[(($274)>>2)]; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=(($272)>>>0) >= (($275)>>>0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $277=(($276)&1); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $278=(($277)==(1)); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=(($278)|0)!=0; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($279) { __label__ = 49; break; } else { __label__ = 50; break; } //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $280
      var $281=$C1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $283=(($282+16)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $284=(($283+4)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($284)>>2)]=$281; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $285=$R; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $286=$C1; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=(($286+24)|0); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($287)>>2)]=$285; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 51; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 50: // $288
      _abort(); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 51: // $289
      __label__ = 52; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $290
      __label__ = 54; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 53: // $291
      _abort(); //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 54: // $292
      __label__ = 55; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 55: // $293
      __label__ = 56; break; //@line 4100 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 56: // $294
      __label__ = 57; break;
    case 57: // $295
      var $296=$psize; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $297=$296 >>> 8; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $X=$297; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $298=$X; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $299=(($298)|0)==0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($299) { __label__ = 58; break; } else { __label__ = 59; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 58: // $300
      $I=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 63; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 59: // $301
      var $302=$X; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $303=(($302)>>>0) > 65535; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($303) { __label__ = 60; break; } else { __label__ = 61; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 60: // $304
      $I=31; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 62; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 61: // $305
      var $306=$X; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$306; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $307=$Y; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $308=(($307-256)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $309=$308 >>> 16; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $310=$309 & 8; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$310; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $311=$N; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $312=$Y; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $313=$312 << $311; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$313; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $314=(($313-4096)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=$314 >>> 16; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=$315 & 4; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$316; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=$K; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $318=$N; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $319=(($318+$317)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$319; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $320=$K; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=$Y; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $322=$321 << $320; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$322; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=(($322-16384)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=$323 >>> 16; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=$324 & 2; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$325; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=$N; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $327=(($326+$325)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$327; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $328=$N; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $329=((14-$328)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $330=$K; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $331=$Y; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $332=$331 << $330; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$332; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $333=$332 >>> 15; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $334=(($329+$333)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$334; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $335=$K; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $336=$335 << 1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $337=$psize; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $338=$K; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=(($338+7)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=$337 >>> (($339)>>>0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=$340 & 1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=(($336+$341)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$342; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 62; break;
    case 62: // $343
      __label__ = 63; break;
    case 63: // $344
      var $345=$I; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=$1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=(($346+304)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348=(($347+($345<<2))|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H1=$348; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $349=$I; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=(($350+28)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($351)>>2)]=$349; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $353=(($352+16)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $354=(($353+4)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($354)>>2)]=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $355=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $356=(($355+16)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $357=(($356)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($357)>>2)]=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=$1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=(($358+4)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $360=HEAP32[(($359)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $361=$I; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $362=1 << $361; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $363=$360 & $362; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $364=(($363)|0)!=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($364) { __label__ = 65; break; } else { __label__ = 64; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 64: // $365
      var $366=$I; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=1 << $366; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=$1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=(($368+4)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $370=HEAP32[(($369)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $371=$370 | $367; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($369)>>2)]=$371; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $372=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $373=$H1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($373)>>2)]=$372; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374=$H1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $375=$374; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $376=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $377=(($376+24)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($377)>>2)]=$375; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $378=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $379=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=(($379+12)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($380)>>2)]=$378; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=(($381+8)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($382)>>2)]=$378; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 83; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 65: // $383
      var $384=$H1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $385=HEAP32[(($384)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$385; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=$psize; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=$I; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $388=(($387)|0)==31; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($388) { __label__ = 66; break; } else { __label__ = 67; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 66: // $389
      var $397 = 0;__label__ = 68; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 67: // $390
      var $391=$I; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $392=$391 >>> 1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $393=(($392+8)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $394=(($393-2)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $395=((31-$394)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $397 = $395;__label__ = 68; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 68: // $396
      var $397; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $398=$386 << $397; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$398; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 69; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 69: // $399
      var $400=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $401=(($400+4)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $402=HEAP32[(($401)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $403=$402 & -8; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $404=$psize; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $405=(($403)|0)!=(($404)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($405) { __label__ = 70; break; } else { __label__ = 76; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 70: // $406
      var $407=$K2; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $408=$407 >>> 31; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $409=$408 & 1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $410=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $411=(($410+16)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $412=(($411+($409<<2))|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C=$412; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $413=$K2; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $414=$413 << 1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$414; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $415=$C; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $416=HEAP32[(($415)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $417=(($416)|0)!=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($417) { __label__ = 71; break; } else { __label__ = 72; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 71: // $418
      var $419=$C; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $420=HEAP32[(($419)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$420; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 75; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 72: // $421
      var $422=$C; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $423=$422; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $424=$1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $425=(($424+16)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $426=HEAPU32[(($425)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $427=(($423)>>>0) >= (($426)>>>0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $428=(($427)&1); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $429=(($428)==(1)); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $430=(($429)|0)!=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($430) { __label__ = 73; break; } else { __label__ = 74; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 73: // $431
      var $432=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $433=$C; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($433)>>2)]=$432; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $434=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $435=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $436=(($435+24)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($436)>>2)]=$434; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $437=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $438=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $439=(($438+12)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($439)>>2)]=$437; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $440=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $441=(($440+8)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($441)>>2)]=$437; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 82; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 74: // $442
      _abort(); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 75: // $443
      __label__ = 81; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 76: // $444
      var $445=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $446=(($445+8)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $447=HEAP32[(($446)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F3=$447; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $448=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $449=$448; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $450=$1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $451=(($450+16)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $452=HEAPU32[(($451)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $453=(($449)>>>0) >= (($452)>>>0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($453) { __label__ = 77; break; } else { var $462 = 0;__label__ = 78; break; } //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 77: // $454
      var $455=$F3; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $456=$455; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $457=$1; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $458=(($457+16)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $459=HEAPU32[(($458)>>2)]; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $460=(($456)>>>0) >= (($459)>>>0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $462 = $460;__label__ = 78; break;
    case 78: // $461
      var $462;
      var $463=(($462)&1);
      var $464=(($463)==(1));
      var $465=(($464)|0)!=0;
      if ($465) { __label__ = 79; break; } else { __label__ = 80; break; }
    case 79: // $466
      var $467=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $468=$F3; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $469=(($468+12)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($469)>>2)]=$467; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $470=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $471=(($470+8)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($471)>>2)]=$467; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $472=$F3; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $473=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $474=(($473+8)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($474)>>2)]=$472; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $475=$T; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $476=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $477=(($476+12)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($477)>>2)]=$475; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $478=$tp; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $479=(($478+24)|0); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($479)>>2)]=0; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 82; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 80: // $480
      _abort(); //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 81: // $481
      __label__ = 69; break; //@line 4110 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 82: // $482
      __label__ = 83; break;
    case 83: // $483
      __label__ = 84; break; //@line 4112 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 84: // $484
      __label__ = 85; break; //@line 4113 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 85: // $485
      var $486=$sp; //@line 4116 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $pred=$486; //@line 4116 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $487=$next; //@line 4117 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$487; //@line 4117 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 1; break; //@line 4118 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 86: // $488
      var $489=$nsegs; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $490=(($489)>>>0) > 4294967295; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($490) { __label__ = 87; break; } else { __label__ = 88; break; } //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 87: // $491
      var $492=$nsegs; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $495 = $492;__label__ = 89; break; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 88: // $493
      var $495 = -1;__label__ = 89; break; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 89: // $494
      var $495; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $496=$1; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $497=(($496+32)|0); //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($497)>>2)]=$495; //@line 4120 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $498=$released; //@line 4122 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $498; //@line 4122 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_release_unused_segments["X"]=1;

function _mmap_resize($m, $oldp, $nb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $oldsize;
      var $offset;
      var $oldmmsize;
      var $newmmsize;
      var $cp;
      var $newp;
      var $psize;
      $2=$m;
      $3=$oldp;
      $4=$nb;
      var $5=$3; //@line 3699 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5+4)|0); //@line 3699 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=HEAP32[(($6)>>2)]; //@line 3699 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$7 & -8; //@line 3699 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldsize=$8; //@line 3699 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=$4; //@line 3700 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=$9 >>> 3; //@line 3700 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=(($10)>>>0) < 32; //@line 3700 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($11) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 3700 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $12
      $1=0; //@line 3701 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 13; break; //@line 3701 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $13
      var $14=$oldsize; //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$4; //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=(($15+4)|0); //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=(($14)>>>0) >= (($16)>>>0); //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($17) { __label__ = 3; break; } else { __label__ = 5; break; } //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $18
      var $19=$oldsize; //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$4; //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=(($19-$20)|0); //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=HEAP32[((((_mparams+8)|0))>>2)]; //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$22 << 1; //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=(($21)>>>0) <= (($23)>>>0); //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($24) { __label__ = 4; break; } else { __label__ = 5; break; } //@line 3703 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $25
      var $26=$3; //@line 3705 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$26; //@line 3705 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 13; break; //@line 3705 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $27
      var $28=$3; //@line 3707 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=(($28)|0); //@line 3707 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=HEAP32[(($29)>>2)]; //@line 3707 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $offset=$30; //@line 3707 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=$oldsize; //@line 3708 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=$offset; //@line 3708 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=(($31+$32)|0); //@line 3708 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=(($33+16)|0); //@line 3708 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldmmsize=$34; //@line 3708 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=$4; //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=(($35+24)|0); //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=(($36+7)|0); //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=(($38-1)|0); //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=(($37+$39)|0); //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=(($41-1)|0); //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$42 ^ -1; //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$40 & $43; //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newmmsize=$44; //@line 3709 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $cp=-1; //@line 3711 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$cp; //@line 3712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=(($45)|0)!=-1; //@line 3712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($46) { __label__ = 6; break; } else { __label__ = 11; break; } //@line 3712 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $47
      var $48=$cp; //@line 3713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=$offset; //@line 3713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=(($48+$49)|0); //@line 3713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=$50; //@line 3713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newp=$51; //@line 3713 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=$newmmsize; //@line 3714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=$offset; //@line 3714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=(($52-$53)|0); //@line 3714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=(($54-16)|0); //@line 3714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$55; //@line 3714 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$psize; //@line 3715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=$newp; //@line 3715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=(($57+4)|0); //@line 3715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($58)>>2)]=$56; //@line 3715 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$newp; //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=$59; //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=$psize; //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=(($60+$61)|0); //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$62; //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=(($63+4)|0); //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($64)>>2)]=7; //@line 3717 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=$newp; //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=$65; //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $67=$psize; //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=(($67+4)|0); //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($66+$68)|0); //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=$69; //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=(($70+4)|0); //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($71)>>2)]=0; //@line 3718 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=$cp; //@line 3720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=$2; //@line 3720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=(($73+16)|0); //@line 3720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=HEAPU32[(($74)>>2)]; //@line 3720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=(($72)>>>0) < (($75)>>>0); //@line 3720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($76) { __label__ = 7; break; } else { __label__ = 8; break; } //@line 3720 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $77
      var $78=$cp; //@line 3721 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=$2; //@line 3721 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=(($79+16)|0); //@line 3721 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($80)>>2)]=$78; //@line 3721 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 8; break; //@line 3721 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $81
      var $82=$newmmsize; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=$oldmmsize; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=(($82-$83)|0); //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=$2; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=(($85+432)|0); //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=HEAP32[(($86)>>2)]; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=(($87+$84)|0); //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($86)>>2)]=$88; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=$2; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=(($89+436)|0); //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=HEAPU32[(($90)>>2)]; //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=(($88)>>>0) > (($91)>>>0); //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($92) { __label__ = 9; break; } else { __label__ = 10; break; } //@line 3722 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $93
      var $94=$2; //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=(($94+432)|0); //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=HEAP32[(($95)>>2)]; //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=$2; //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=(($97+436)|0); //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($98)>>2)]=$96; //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 10; break; //@line 3723 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $99
      var $100=$newp; //@line 3725 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$100; //@line 3725 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 13; break; //@line 3725 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $101
      __label__ = 12; break;
    case 12: // $102
      $1=0; //@line 3728 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 13; break; //@line 3728 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $103
      var $104=$1; //@line 3729 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $104; //@line 3729 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_mmap_resize["X"]=1;

function _segment_holding($m, $addr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $sp;
      $2=$m;
      $3=$addr;
      var $4=$2; //@line 2562 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=(($4+444)|0); //@line 2562 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$5; //@line 2562 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 1; break; //@line 2563 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $6
      var $7=$3; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$sp; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(($8)|0); //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=HEAPU32[(($9)>>2)]; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=(($7)>>>0) >= (($10)>>>0); //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($11) { __label__ = 2; break; } else { __label__ = 4; break; } //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $12
      var $13=$3; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=$sp; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=(($14)|0); //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=HEAP32[(($15)>>2)]; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=$sp; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=(($17+4)|0); //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=HEAP32[(($18)>>2)]; //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=(($16+$19)|0); //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=(($13)>>>0) < (($20)>>>0); //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($21) { __label__ = 3; break; } else { __label__ = 4; break; } //@line 2564 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $22
      var $23=$sp; //@line 2565 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$23; //@line 2565 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 7; break; //@line 2565 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $24
      var $25=$sp; //@line 2566 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=(($25+8)|0); //@line 2566 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=HEAP32[(($26)>>2)]; //@line 2566 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$27; //@line 2566 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=(($27)|0)==0; //@line 2566 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($28) { __label__ = 5; break; } else { __label__ = 6; break; } //@line 2566 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $29
      $1=0; //@line 2567 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 7; break; //@line 2567 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $30
      __label__ = 1; break; //@line 2568 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $31
      var $32=$1; //@line 2569 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $32; //@line 2569 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}


function _init_top($m, $p, $psize) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $offset;
      $1=$m;
      $2=$p;
      $3=$psize;
      var $4=$2; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=$4; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5+8)|0); //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=$6; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$7 & 7; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(($8)|0)==0; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($9) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $10
      var $20 = 0;__label__ = 3; break; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $11
      var $12=$2; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=$12; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=(($13+8)|0); //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$14; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$15 & 7; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=((8-$16)|0); //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=$17 & 7; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20 = $18;__label__ = 3; break; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $19
      var $20; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $offset=$20; //@line 3736 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=$2; //@line 3737 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=$21; //@line 3737 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$offset; //@line 3737 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=(($22+$23)|0); //@line 3737 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$24; //@line 3737 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $2=$25; //@line 3737 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=$offset; //@line 3738 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$3; //@line 3738 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=(($27-$26)|0); //@line 3738 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $3=$28; //@line 3738 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=$2; //@line 3740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$1; //@line 3740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=(($30+24)|0); //@line 3740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($31)>>2)]=$29; //@line 3740 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=$3; //@line 3741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$1; //@line 3741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=(($33+12)|0); //@line 3741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($34)>>2)]=$32; //@line 3741 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=$3; //@line 3742 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$35 | 1; //@line 3742 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$2; //@line 3742 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=(($37+4)|0); //@line 3742 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($38)>>2)]=$36; //@line 3742 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=$2; //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=$39; //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$3; //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=(($40+$41)|0); //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$42; //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=(($43+4)|0); //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($44)>>2)]=40; //@line 3744 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=HEAP32[((((_mparams+16)|0))>>2)]; //@line 3745 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=$1; //@line 3745 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=(($46+28)|0); //@line 3745 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($47)>>2)]=$45; //@line 3745 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return; //@line 3746 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_init_top["X"]=1;

function _mmap_alloc($m, $nb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $mmsize;
      var $mm;
      var $offset;
      var $psize;
      var $p;
      $2=$m;
      $3=$nb;
      var $4=$3; //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=(($4+24)|0); //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5+7)|0); //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=(($7-1)|0); //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(($6+$8)|0); //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=HEAP32[((((_mparams+4)|0))>>2)]; //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=(($10-1)|0); //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$11 ^ -1; //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=$9 & $12; //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $mmsize=$13; //@line 3672 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=$mmsize; //@line 3673 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$3; //@line 3673 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=(($14)>>>0) > (($15)>>>0); //@line 3673 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($16) { __label__ = 1; break; } else { __label__ = 12; break; } //@line 3673 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $17
      $mm=-1; //@line 3674 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=$mm; //@line 3675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=(($18)|0)!=-1; //@line 3675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($19) { __label__ = 2; break; } else { __label__ = 11; break; } //@line 3675 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $20
      var $21=$mm; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=(($21+8)|0); //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$22; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=$23 & 7; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=(($24)|0)==0; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($25) { __label__ = 3; break; } else { __label__ = 4; break; } //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $26
      var $35 = 0;__label__ = 5; break; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $27
      var $28=$mm; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=(($28+8)|0); //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=$29; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=$30 & 7; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=((8-$31)|0); //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$32 & 7; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35 = $33;__label__ = 5; break; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $34
      var $35; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $offset=$35; //@line 3676 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$mmsize; //@line 3677 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$offset; //@line 3677 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=(($36-$37)|0); //@line 3677 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=(($38-16)|0); //@line 3677 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$39; //@line 3677 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=$mm; //@line 3678 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$offset; //@line 3678 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=(($40+$41)|0); //@line 3678 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$42; //@line 3678 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$43; //@line 3678 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$offset; //@line 3679 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$p; //@line 3679 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=(($45)|0); //@line 3679 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($46)>>2)]=$44; //@line 3679 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=$psize; //@line 3680 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $48=$p; //@line 3680 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=(($48+4)|0); //@line 3680 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($49)>>2)]=$47; //@line 3680 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=$p; //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=$50; //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=$psize; //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=(($51+$52)|0); //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=$53; //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=(($54+4)|0); //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($55)>>2)]=7; //@line 3682 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$p; //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=$56; //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=$psize; //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=(($58+4)|0); //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=(($57+$59)|0); //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=$60; //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=(($61+4)|0); //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($62)>>2)]=0; //@line 3683 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$2; //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=(($63+16)|0); //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=HEAP32[(($64)>>2)]; //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=(($65)|0)==0; //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($66) { __label__ = 7; break; } else { __label__ = 6; break; } //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $67
      var $68=$mm; //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=$2; //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=(($69+16)|0); //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=HEAPU32[(($70)>>2)]; //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=(($68)>>>0) < (($71)>>>0); //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($72) { __label__ = 7; break; } else { __label__ = 8; break; } //@line 3685 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $73
      var $74=$mm; //@line 3686 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=$2; //@line 3686 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=(($75+16)|0); //@line 3686 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($76)>>2)]=$74; //@line 3686 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 8; break; //@line 3686 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $77
      var $78=$mmsize; //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=$2; //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=(($79+432)|0); //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=HEAP32[(($80)>>2)]; //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=(($81+$78)|0); //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($80)>>2)]=$82; //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=$2; //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=(($83+436)|0); //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=HEAPU32[(($84)>>2)]; //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=(($82)>>>0) > (($85)>>>0); //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($86) { __label__ = 9; break; } else { __label__ = 10; break; } //@line 3687 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $87
      var $88=$2; //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=(($88+432)|0); //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=HEAP32[(($89)>>2)]; //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=$2; //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=(($91+436)|0); //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($92)>>2)]=$90; //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 10; break; //@line 3688 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $93
      var $94=$p; //@line 3691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=$94; //@line 3691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=(($95+8)|0); //@line 3691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$96; //@line 3691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 13; break; //@line 3691 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $97
      __label__ = 12; break; //@line 3693 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $98
      $1=0; //@line 3694 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 13; break; //@line 3694 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $99
      var $100=$1; //@line 3695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $100; //@line 3695 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_mmap_alloc["X"]=1;

function _init_bins($m) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $i;
      var $bin;
      $1=$m;
      $i=0; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 1; break; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $2
      var $3=$i; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $4=(($3)>>>0) < 32; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($4) { __label__ = 2; break; } else { __label__ = 4; break; } //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $5
      var $6=$i; //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=$6 << 1; //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$1; //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=(($8+40)|0); //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=(($9+($7<<2))|0); //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=$10; //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$11; //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $bin=$12; //@line 3753 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=$bin; //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=$bin; //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=(($14+12)|0); //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($15)>>2)]=$13; //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$bin; //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=(($16+8)|0); //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($17)>>2)]=$13; //@line 3754 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 3; break; //@line 3755 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $18
      var $19=$i; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=(($19+1)|0); //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $i=$20; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 1; break; //@line 3752 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $21
      ;
      return; //@line 3756 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}


function _internal_realloc($m, $oldmem, $bytes) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $oldp;
      var $oldsize;
      var $next;
      var $newp;
      var $extra;
      var $nb;
      var $rsize;
      var $remainder;
      var $newsize;
      var $newtopsize;
      var $newtop;
      var $newmem;
      var $oc;
      $2=$m;
      $3=$oldmem;
      $4=$bytes;
      var $5=$4; //@line 4304 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5)>>>0) >= 4294967232; //@line 4304 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($6) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 4304 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $7
      var $8=___errno(); //@line 4305 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($8)>>2)]=12; //@line 4305 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=0; //@line 4306 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 33; break; //@line 4306 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $9
      var $10=$3; //@line 4309 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=(($10-8)|0); //@line 4309 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$11; //@line 4309 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldp=$12; //@line 4309 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=$oldp; //@line 4310 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=(($13+4)|0); //@line 4310 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=HEAP32[(($14)>>2)]; //@line 4310 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$15 & -8; //@line 4310 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldsize=$16; //@line 4310 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=$oldp; //@line 4311 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=$17; //@line 4311 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=$oldsize; //@line 4311 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=(($18+$19)|0); //@line 4311 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=$20; //@line 4311 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $next=$21; //@line 4311 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newp=0; //@line 4312 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $extra=0; //@line 4313 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=$oldp; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$22; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=$2; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=(($24+16)|0); //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=HEAPU32[(($25)>>2)]; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=(($23)>>>0) >= (($26)>>>0); //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($27) { __label__ = 3; break; } else { var $47 = 0;__label__ = 6; break; } //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $28
      var $29=$oldp; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $30=(($29+4)|0); //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $31=HEAP32[(($30)>>2)]; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=$31 & 3; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=(($32)|0)!=1; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($33) { __label__ = 4; break; } else { var $47 = 0;__label__ = 6; break; } //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $34
      var $35=$oldp; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$35; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$next; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38=$37; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=(($36)>>>0) < (($38)>>>0); //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($39) { __label__ = 5; break; } else { var $47 = 0;__label__ = 6; break; } //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $40
      var $41=$next; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=(($41+4)|0); //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=HEAP32[(($42)>>2)]; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$43 & 1; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=(($44)|0)!=0; //@line 4317 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47 = $45;__label__ = 6; break;
    case 6: // $46
      var $47;
      var $48=(($47)&1);
      var $49=(($48)==(1));
      var $50=(($49)|0)!=0;
      if ($50) { __label__ = 7; break; } else { __label__ = 22; break; }
    case 7: // $51
      var $52=$4; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=(($52)>>>0) < 11; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($53) { __label__ = 8; break; } else { __label__ = 9; break; } //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $54
      var $61 = 16;__label__ = 10; break; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $55
      var $56=$4; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56+4)|0); //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=(($57+7)|0); //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$58 & -8; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61 = $59;__label__ = 10; break; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $60
      var $61; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nb=$61; //@line 4319 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=$oldp; //@line 4320 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=(($62+4)|0); //@line 4320 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=HEAP32[(($63)>>2)]; //@line 4320 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=$64 & 3; //@line 4320 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=(($65)|0)==0; //@line 4320 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($66) { __label__ = 11; break; } else { __label__ = 12; break; } //@line 4320 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $67
      var $68=$2; //@line 4321 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=$oldp; //@line 4321 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=$nb; //@line 4321 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=_mmap_resize($68, $69, $70); //@line 4321 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newp=$71; //@line 4321 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 21; break; //@line 4321 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $72
      var $73=$oldsize; //@line 4322 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=$nb; //@line 4322 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=(($73)>>>0) >= (($74)>>>0); //@line 4322 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($75) { __label__ = 13; break; } else { __label__ = 16; break; } //@line 4322 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $76
      var $77=$oldsize; //@line 4323 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=$nb; //@line 4323 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=(($77-$78)|0); //@line 4323 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rsize=$79; //@line 4323 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=$oldp; //@line 4324 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newp=$80; //@line 4324 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=$rsize; //@line 4325 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=(($81)>>>0) >= 16; //@line 4325 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($82) { __label__ = 14; break; } else { __label__ = 15; break; } //@line 4325 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $83
      var $84=$newp; //@line 4326 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=$84; //@line 4326 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=$nb; //@line 4326 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=(($85+$86)|0); //@line 4326 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=$87; //@line 4326 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $remainder=$88; //@line 4326 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=$newp; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=(($89+4)|0); //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=HEAP32[(($90)>>2)]; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=$91 & 1; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $93=$nb; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=$92 | $93; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=$94 | 2; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=$newp; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=(($96+4)|0); //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($97)>>2)]=$95; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=$newp; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=$98; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=$nb; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=(($99+$100)|0); //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=$101; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=(($102+4)|0); //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=HEAP32[(($103)>>2)]; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $105=$104 | 1; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($103)>>2)]=$105; //@line 4327 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=$rsize; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=$106 | 1; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=$107 | 2; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $109=$remainder; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $110=(($109+4)|0); //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($110)>>2)]=$108; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $111=$remainder; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $112=$111; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=$rsize; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=(($112+$113)|0); //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=$114; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=(($115+4)|0); //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=HEAP32[(($116)>>2)]; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=$117 | 1; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($116)>>2)]=$118; //@line 4328 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $119=$remainder; //@line 4329 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=$119; //@line 4329 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=(($120+8)|0); //@line 4329 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $extra=$121; //@line 4329 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 15; break; //@line 4330 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $122
      __label__ = 20; break; //@line 4331 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $123
      var $124=$next; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=$2; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=(($125+24)|0); //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=HEAP32[(($126)>>2)]; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=(($124)|0)==(($127)|0); //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($128) { __label__ = 17; break; } else { __label__ = 19; break; } //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $129
      var $130=$oldsize; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=$2; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $132=(($131+12)|0); //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=HEAP32[(($132)>>2)]; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=(($130+$133)|0); //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=$nb; //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=(($134)>>>0) > (($135)>>>0); //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($136) { __label__ = 18; break; } else { __label__ = 19; break; } //@line 4332 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $137
      var $138=$oldsize; //@line 4334 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=$2; //@line 4334 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $140=(($139+12)|0); //@line 4334 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=HEAP32[(($140)>>2)]; //@line 4334 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=(($138+$141)|0); //@line 4334 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newsize=$142; //@line 4334 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=$newsize; //@line 4335 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=$nb; //@line 4335 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=(($143-$144)|0); //@line 4335 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newtopsize=$145; //@line 4335 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=$oldp; //@line 4336 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=$146; //@line 4336 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=$nb; //@line 4336 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $149=(($147+$148)|0); //@line 4336 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $150=$149; //@line 4336 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newtop=$150; //@line 4336 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=$oldp; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=(($151+4)|0); //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=HEAP32[(($152)>>2)]; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=$153 & 1; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=$nb; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=$154 | $155; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=$156 | 2; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=$oldp; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=(($158+4)|0); //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($159)>>2)]=$157; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=$oldp; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=$160; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=$nb; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=(($161+$162)|0); //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $164=$163; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=(($164+4)|0); //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $166=HEAP32[(($165)>>2)]; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $167=$166 | 1; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($165)>>2)]=$167; //@line 4337 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=$newtopsize; //@line 4338 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=$168 | 1; //@line 4338 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=$newtop; //@line 4338 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $171=(($170+4)|0); //@line 4338 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($171)>>2)]=$169; //@line 4338 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=$newtop; //@line 4339 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $173=$2; //@line 4339 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $174=(($173+24)|0); //@line 4339 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($174)>>2)]=$172; //@line 4339 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $175=$newtopsize; //@line 4340 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=$2; //@line 4340 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $177=(($176+12)|0); //@line 4340 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($177)>>2)]=$175; //@line 4340 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $178=$oldp; //@line 4341 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newp=$178; //@line 4341 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 19; break; //@line 4342 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 19: // $179
      __label__ = 20; break;
    case 20: // $180
      __label__ = 21; break;
    case 21: // $181
      __label__ = 23; break; //@line 4343 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $182
      _abort(); //@line 4345 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 4345 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $183
      var $184=$newp; //@line 4357 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $185=(($184)|0)!=0; //@line 4357 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($185) { __label__ = 24; break; } else { __label__ = 27; break; } //@line 4357 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $186
      var $187=$extra; //@line 4358 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $188=(($187)|0)!=0; //@line 4358 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($188) { __label__ = 25; break; } else { __label__ = 26; break; } //@line 4358 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $189
      var $190=$extra; //@line 4359 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _free($190); //@line 4359 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 26; break; //@line 4360 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $191
      var $192=$newp; //@line 4361 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $193=$192; //@line 4361 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=(($193+8)|0); //@line 4361 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$194; //@line 4361 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 33; break; //@line 4361 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $195
      var $196=$4; //@line 4364 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $197=_malloc($196); //@line 4364 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $newmem=$197; //@line 4364 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $198=$newmem; //@line 4365 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=(($198)|0)!=0; //@line 4365 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($199) { __label__ = 28; break; } else { __label__ = 32; break; } //@line 4365 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $200
      var $201=$oldsize; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $202=$oldp; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $203=(($202+4)|0); //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=HEAP32[(($203)>>2)]; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=$204 & 3; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=(($205)|0)==0; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=$206 ? 8 : 4; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=(($201-$207)|0); //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oc=$208; //@line 4366 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=$newmem; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=$3; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=$oc; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=$4; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $213=(($211)>>>0) < (($212)>>>0); //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($213) { __label__ = 29; break; } else { __label__ = 30; break; } //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $214
      var $215=$oc; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $219 = $215;__label__ = 31; break; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $216
      var $217=$4; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $219 = $217;__label__ = 31; break; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $218
      var $219; //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      assert($219 % 1 === 0, 'memcpy given ' + $219 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');_memcpy($209, $210, $219, 1); //@line 4367 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $220=$3; //@line 4368 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _free($220); //@line 4368 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 32; break; //@line 4369 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $221
      var $222=$newmem; //@line 4370 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $1=$222; //@line 4370 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 33; break; //@line 4370 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $223
      var $224=$1; //@line 4374 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $224; //@line 4374 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_internal_realloc["X"]=1;

function _init_mparams() {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $magic;
      var $psize;
      var $gsize;
      var $1=HEAP32[((((_mparams)|0))>>2)]; //@line 2965 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $2=(($1)|0)==0; //@line 2965 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($2) { __label__ = 1; break; } else { __label__ = 5; break; } //@line 2965 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $3
      var $4=_sysconf(8); //@line 2971 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$4; //@line 2971 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $5=$psize; //@line 2972 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $gsize=$5; //@line 2972 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=$gsize; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=$gsize; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=(($7-1)|0); //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=$6 & $8; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=(($9)|0)!=0; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($10) { __label__ = 3; break; } else { __label__ = 2; break; } //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $11
      var $12=$psize; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=$psize; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=(($13-1)|0); //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$12 & $14; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=(($15)|0)!=0; //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($16) { __label__ = 3; break; } else { __label__ = 4; break; } //@line 2989 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $17
      _abort(); //@line 2997 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 2997 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $18
      var $19=$gsize; //@line 2999 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((_mparams+8)|0))>>2)]=$19; //@line 2999 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$psize; //@line 3000 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((_mparams+4)|0))>>2)]=$20; //@line 3000 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((_mparams+12)|0))>>2)]=-1; //@line 3001 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((_mparams+16)|0))>>2)]=2097152; //@line 3002 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((_mparams+20)|0))>>2)]=0; //@line 3004 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=HEAP32[((((_mparams+20)|0))>>2)]; //@line 3011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((__gm_+440)|0))>>2)]=$21; //@line 3011 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=_time(0); //@line 3030 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$22 ^ 1431655765; //@line 3030 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $magic=$23; //@line 3030 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=$magic; //@line 3032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$24 | 8; //@line 3032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $magic=$25; //@line 3032 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=$magic; //@line 3033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$26 & -8; //@line 3033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $magic=$27; //@line 3033 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$magic; //@line 3034 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[((((_mparams)|0))>>2)]=$28; //@line 3034 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 5; break; //@line 3036 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $29
      ;
      return 1; //@line 3039 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}


function _prepend_alloc($m, $newbase, $oldbase, $nb) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $p;
      var $oldfirst;
      var $psize;
      var $q;
      var $qsize;
      var $tsize;
      var $dsize;
      var $nsize;
      var $F;
      var $B;
      var $I;
      var $TP;
      var $XP;
      var $R;
      var $F1;
      var $RP;
      var $CP;
      var $H;
      var $C0;
      var $C1;
      var $I2;
      var $B3;
      var $F4;
      var $TP5;
      var $H6;
      var $I7;
      var $X;
      var $Y;
      var $N;
      var $K;
      var $T;
      var $K8;
      var $C;
      var $F9;
      $1=$m;
      $2=$newbase;
      $3=$oldbase;
      $4=$nb;
      var $5=$2; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=$2; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=(($6+8)|0); //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$7; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=$8 & 7; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=(($9)|0)==0; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($10) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $11
      var $20 = 0;__label__ = 3; break; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $12
      var $13=$2; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=(($13+8)|0); //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$14; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=$15 & 7; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=((8-$16)|0); //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=$17 & 7; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20 = $18;__label__ = 3; break; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $19
      var $20; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=(($5+$20)|0); //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=$21; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$22; //@line 3780 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=$3; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=$3; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=(($24+8)|0); //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=$25; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$26 & 7; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=(($27)|0)==0; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($28) { __label__ = 4; break; } else { __label__ = 5; break; } //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $29
      var $38 = 0;__label__ = 6; break; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $30
      var $31=$3; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $32=(($31+8)|0); //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=$32; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=$33 & 7; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=((8-$34)|0); //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=$35 & 7; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $38 = $36;__label__ = 6; break; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $37
      var $38; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39=(($23+$38)|0); //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=$39; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldfirst=$40; //@line 3781 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$oldfirst; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=$41; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$p; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$43; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=$42; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=$44; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $47=(($45-$46)|0); //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$47; //@line 3782 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $48=$p; //@line 3783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $49=$48; //@line 3783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $50=$4; //@line 3783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $51=(($49+$50)|0); //@line 3783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52=$51; //@line 3783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $q=$52; //@line 3783 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=$psize; //@line 3784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=$4; //@line 3784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=(($53-$54)|0); //@line 3784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $qsize=$55; //@line 3784 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$4; //@line 3785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=$56 | 1; //@line 3785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=$57 | 2; //@line 3785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$p; //@line 3785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=(($59+4)|0); //@line 3785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($60)>>2)]=$58; //@line 3785 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=$oldfirst; //@line 3792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=$1; //@line 3792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=(($62+24)|0); //@line 3792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=HEAP32[(($63)>>2)]; //@line 3792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=(($61)|0)==(($64)|0); //@line 3792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($65) { __label__ = 7; break; } else { __label__ = 8; break; } //@line 3792 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $66
      var $67=$qsize; //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=$1; //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68+12)|0); //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=HEAP32[(($69)>>2)]; //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=(($70+$67)|0); //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($69)>>2)]=$71; //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tsize=$71; //@line 3793 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=$q; //@line 3794 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=$1; //@line 3794 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=(($73+24)|0); //@line 3794 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($74)>>2)]=$72; //@line 3794 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=$tsize; //@line 3795 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=$75 | 1; //@line 3795 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=$q; //@line 3795 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=(($77+4)|0); //@line 3795 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($78)>>2)]=$76; //@line 3795 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 108; break; //@line 3797 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $79
      var $80=$oldfirst; //@line 3798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=$1; //@line 3798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=(($81+20)|0); //@line 3798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=HEAP32[(($82)>>2)]; //@line 3798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=(($80)|0)==(($83)|0); //@line 3798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($84) { __label__ = 9; break; } else { __label__ = 10; break; } //@line 3798 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $85
      var $86=$qsize; //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=$1; //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=(($87+8)|0); //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=HEAP32[(($88)>>2)]; //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=(($89+$86)|0); //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($88)>>2)]=$90; //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $dsize=$90; //@line 3799 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=$q; //@line 3800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=$1; //@line 3800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $93=(($92+20)|0); //@line 3800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($93)>>2)]=$91; //@line 3800 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=$dsize; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=$94 | 1; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $96=$q; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $97=(($96+4)|0); //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($97)>>2)]=$95; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=$dsize; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=$q; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=$99; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$dsize; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=(($100+$101)|0); //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=$102; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=(($103)|0); //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($104)>>2)]=$98; //@line 3801 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 107; break; //@line 3802 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $105
      var $106=$oldfirst; //@line 3804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=(($106+4)|0); //@line 3804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=HEAP32[(($107)>>2)]; //@line 3804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $109=$108 & 3; //@line 3804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $110=(($109)|0)!=1; //@line 3804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($110) { __label__ = 71; break; } else { __label__ = 11; break; } //@line 3804 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $111
      var $112=$oldfirst; //@line 3805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $113=(($112+4)|0); //@line 3805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $114=HEAP32[(($113)>>2)]; //@line 3805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $115=$114 & -8; //@line 3805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nsize=$115; //@line 3805 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=$nsize; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=$116 >>> 3; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $118=(($117)>>>0) < 32; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($118) { __label__ = 12; break; } else { __label__ = 24; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $119
      var $120=$oldfirst; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=(($120+8)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=HEAP32[(($121)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$122; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $123=$oldfirst; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $124=(($123+12)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=HEAP32[(($124)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B=$125; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=$nsize; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=$126 >>> 3; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$127; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=$F; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=$B; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=(($128)|0)==(($129)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($130) { __label__ = 13; break; } else { __label__ = 14; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $131
      var $132=$I; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=1 << $132; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=$133 ^ -1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=(($135)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $137=HEAP32[(($136)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $138=$137 & $134; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($136)>>2)]=$138; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 23; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $139
      var $140=$F; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=$I; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=$141 << 1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=(($143+40)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=(($144+($142<<2))|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=$145; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=$146; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=(($140)|0)==(($147)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($148) { __label__ = 16; break; } else { __label__ = 15; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $149
      var $150=$F; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=$150; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=(($152+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=HEAPU32[(($153)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=(($151)>>>0) >= (($154)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($155) { __label__ = 16; break; } else { var $176 = 0;__label__ = 19; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $156
      var $157=$B; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=$I; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=$158 << 1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=(($160+40)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=(($161+($159<<2))|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=$162; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $164=$163; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=(($157)|0)==(($164)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($165) { var $174 = 1;__label__ = 18; break; } else { __label__ = 17; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $166
      var $167=$B; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $168=$167; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=(($169+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $171=HEAPU32[(($170)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=(($168)>>>0) >= (($171)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $174 = $172;__label__ = 18; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $173
      var $174;
      var $176 = $174;__label__ = 19; break;
    case 19: // $175
      var $176;
      var $177=(($176)&1);
      var $178=(($177)==(1));
      var $179=(($178)|0)!=0;
      if ($179) { __label__ = 20; break; } else { __label__ = 21; break; }
    case 20: // $180
      var $181=$B; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $182=$F; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=(($182+12)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($183)>>2)]=$181; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $184=$F; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $185=$B; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $186=(($185+8)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($186)>>2)]=$184; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 22; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $187
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $188
      __label__ = 23; break;
    case 23: // $189
      __label__ = 70; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $190
      var $191=$oldfirst; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $192=$191; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $TP=$192; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $193=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=(($193+24)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $195=HEAP32[(($194)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $XP=$195; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $197=(($196+12)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $198=HEAP32[(($197)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $200=(($198)|0)!=(($199)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($200) { __label__ = 25; break; } else { __label__ = 29; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 25: // $201
      var $202=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $203=(($202+8)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=HEAP32[(($203)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F1=$204; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $205=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $206=(($205+12)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=HEAP32[(($206)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$207; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=$F1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=$208; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=(($210+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $212=HEAPU32[(($211)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $213=(($209)>>>0) >= (($212)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $214=(($213)&1); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $215=(($214)==(1)); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $216=(($215)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($216) { __label__ = 26; break; } else { __label__ = 27; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 26: // $217
      var $218=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $219=$F1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $220=(($219+12)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($220)>>2)]=$218; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $221=$F1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $222=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $223=(($222+8)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($223)>>2)]=$221; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 28; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $224
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $225
      __label__ = 41; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $226
      var $227=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=(($227+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $229=(($228+4)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$229; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230=HEAP32[(($229)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$230; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $231=(($230)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($231) { __label__ = 31; break; } else { __label__ = 30; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $232
      var $233=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $234=(($233+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $235=(($234)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$235; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $236=HEAP32[(($235)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$236; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=(($236)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($237) { __label__ = 31; break; } else { __label__ = 40; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $238
      __label__ = 32; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $239
      var $240=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $241=(($240+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $242=(($241+4)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$242; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=HEAP32[(($242)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=(($243)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($244) { var $252 = 1;__label__ = 34; break; } else { __label__ = 33; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $245
      var $246=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=(($246+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=(($247)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $CP=$248; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $249=HEAP32[(($248)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $250=(($249)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $252 = $250;__label__ = 34; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $251
      var $252;
      if ($252) { __label__ = 35; break; } else { __label__ = 36; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $253
      var $254=$CP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $RP=$254; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $255=HEAP32[(($254)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $R=$255; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 32; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $256
      var $257=$RP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $258=$257; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=(($259+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $261=HEAPU32[(($260)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $262=(($258)>>>0) >= (($261)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $263=(($262)&1); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $264=(($263)==(1)); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $265=(($264)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($265) { __label__ = 37; break; } else { __label__ = 38; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $266
      var $267=$RP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($267)>>2)]=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 39; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $268
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 39: // $269
      __label__ = 40; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $270
      __label__ = 41; break;
    case 41: // $271
      var $272=$XP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $273=(($272)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($273) { __label__ = 42; break; } else { __label__ = 69; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 42: // $274
      var $275=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=(($275+28)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $277=HEAP32[(($276)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $278=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=(($278+304)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $280=(($279+($277<<2))|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H=$280; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $281=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=$H; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $283=HEAP32[(($282)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $284=(($281)|0)==(($283)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($284) { __label__ = 43; break; } else { __label__ = 46; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $285
      var $286=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=$H; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($287)>>2)]=$286; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=(($286)|0)==0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($288) { __label__ = 44; break; } else { __label__ = 45; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $289
      var $290=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $291=(($290+28)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $292=HEAP32[(($291)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $293=1 << $292; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $294=$293 ^ -1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $295=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $296=(($295+4)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $297=HEAP32[(($296)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $298=$297 & $294; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($296)>>2)]=$298; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 45; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $299
      __label__ = 53; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 46: // $300
      var $301=$XP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $302=$301; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $303=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $304=(($303+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $305=HEAPU32[(($304)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $306=(($302)>>>0) >= (($305)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $307=(($306)&1); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $308=(($307)==(1)); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $309=(($308)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($309) { __label__ = 47; break; } else { __label__ = 51; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 47: // $310
      var $311=$XP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $312=(($311+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $313=(($312)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $314=HEAP32[(($313)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=(($314)|0)==(($315)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($316) { __label__ = 48; break; } else { __label__ = 49; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $317
      var $318=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $319=$XP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $320=(($319+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=(($320)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($321)>>2)]=$318; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 50; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 49: // $322
      var $323=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=$XP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=(($324+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=(($325+4)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($326)>>2)]=$323; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 50; break;
    case 50: // $327
      __label__ = 52; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 51: // $328
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 52: // $329
      __label__ = 53; break;
    case 53: // $330
      var $331=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $332=(($331)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($332) { __label__ = 54; break; } else { __label__ = 68; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 54: // $333
      var $334=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $335=$334; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $336=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $337=(($336+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $338=HEAPU32[(($337)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=(($335)>>>0) >= (($338)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=(($339)&1); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=(($340)==(1)); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=(($341)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($342) { __label__ = 55; break; } else { __label__ = 66; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 55: // $343
      var $344=$XP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $345=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=(($345+24)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($346)>>2)]=$344; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348=(($347+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $349=(($348)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=HEAP32[(($349)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C0=$350; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=(($350)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($351) { __label__ = 56; break; } else { __label__ = 60; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 56: // $352
      var $353=$C0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $354=$353; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $355=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $356=(($355+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $357=HEAPU32[(($356)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=(($354)>>>0) >= (($357)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=(($358)&1); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $360=(($359)==(1)); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $361=(($360)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($361) { __label__ = 57; break; } else { __label__ = 58; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 57: // $362
      var $363=$C0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $364=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $365=(($364+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $366=(($365)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($366)>>2)]=$363; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $367=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=$C0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=(($368+24)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($369)>>2)]=$367; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 59; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 58: // $370
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 59: // $371
      __label__ = 60; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 60: // $372
      var $373=$TP; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374=(($373+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $375=(($374+4)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $376=HEAP32[(($375)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C1=$376; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $377=(($376)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($377) { __label__ = 61; break; } else { __label__ = 65; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 61: // $378
      var $379=$C1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=$379; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=$1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=(($381+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $383=HEAPU32[(($382)>>2)]; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $384=(($380)>>>0) >= (($383)>>>0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $385=(($384)&1); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=(($385)==(1)); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=(($386)|0)!=0; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($387) { __label__ = 62; break; } else { __label__ = 63; break; } //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 62: // $388
      var $389=$C1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $390=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $391=(($390+16)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $392=(($391+4)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($392)>>2)]=$389; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $393=$R; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $394=$C1; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $395=(($394+24)|0); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($395)>>2)]=$393; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 64; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 63: // $396
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 64: // $397
      __label__ = 65; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 65: // $398
      __label__ = 67; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 66: // $399
      _abort(); //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 67: // $400
      __label__ = 68; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 68: // $401
      __label__ = 69; break; //@line 3806 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 69: // $402
      __label__ = 70; break;
    case 70: // $403
      var $404=$oldfirst; //@line 3807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $405=$404; //@line 3807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $406=$nsize; //@line 3807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $407=(($405+$406)|0); //@line 3807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $408=$407; //@line 3807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldfirst=$408; //@line 3807 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $409=$nsize; //@line 3808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $410=$qsize; //@line 3808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $411=(($410+$409)|0); //@line 3808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $qsize=$411; //@line 3808 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 71; break; //@line 3809 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 71: // $412
      var $413=$oldfirst; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $414=(($413+4)|0); //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $415=HEAP32[(($414)>>2)]; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $416=$415 & -2; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($414)>>2)]=$416; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $417=$qsize; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $418=$417 | 1; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $419=$q; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $420=(($419+4)|0); //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($420)>>2)]=$418; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $421=$qsize; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $422=$q; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $423=$422; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $424=$qsize; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $425=(($423+$424)|0); //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $426=$425; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $427=(($426)|0); //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($427)>>2)]=$421; //@line 3810 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $428=$qsize; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $429=$428 >>> 3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $430=(($429)>>>0) < 32; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($430) { __label__ = 72; break; } else { __label__ = 79; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 72: // $431
      var $432=$qsize; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $433=$432 >>> 3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I2=$433; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $434=$I2; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $435=$434 << 1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $436=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $437=(($436+40)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $438=(($437+($435<<2))|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $439=$438; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $440=$439; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B3=$440; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $441=$B3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F4=$441; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $442=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $443=(($442)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $444=HEAP32[(($443)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $445=$I2; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $446=1 << $445; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $447=$444 & $446; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $448=(($447)|0)!=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($448) { __label__ = 74; break; } else { __label__ = 73; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 73: // $449
      var $450=$I2; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $451=1 << $450; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $452=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $453=(($452)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $454=HEAP32[(($453)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $455=$454 | $451; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($453)>>2)]=$455; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 78; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 74: // $456
      var $457=$B3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $458=(($457+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $459=HEAP32[(($458)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $460=$459; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $461=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $462=(($461+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $463=HEAPU32[(($462)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $464=(($460)>>>0) >= (($463)>>>0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $465=(($464)&1); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $466=(($465)==(1)); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $467=(($466)|0)!=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($467) { __label__ = 75; break; } else { __label__ = 76; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 75: // $468
      var $469=$B3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $470=(($469+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $471=HEAP32[(($470)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F4=$471; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 77; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 76: // $472
      _abort(); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 77: // $473
      __label__ = 78; break;
    case 78: // $474
      var $475=$q; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $476=$B3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $477=(($476+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($477)>>2)]=$475; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $478=$q; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $479=$F4; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $480=(($479+12)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($480)>>2)]=$478; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $481=$F4; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $482=$q; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $483=(($482+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($483)>>2)]=$481; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $484=$B3; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $485=$q; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $486=(($485+12)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($486)>>2)]=$484; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 106; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 79: // $487
      var $488=$q; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $489=$488; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $TP5=$489; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $490=$qsize; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $491=$490 >>> 8; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $X=$491; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $492=$X; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $493=(($492)|0)==0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($493) { __label__ = 80; break; } else { __label__ = 81; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 80: // $494
      $I7=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 85; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 81: // $495
      var $496=$X; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $497=(($496)>>>0) > 65535; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($497) { __label__ = 82; break; } else { __label__ = 83; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 82: // $498
      $I7=31; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 84; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 83: // $499
      var $500=$X; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$500; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $501=$Y; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $502=(($501-256)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $503=$502 >>> 16; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $504=$503 & 8; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$504; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $505=$N; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $506=$Y; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $507=$506 << $505; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$507; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $508=(($507-4096)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $509=$508 >>> 16; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $510=$509 & 4; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$510; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $511=$K; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $512=$N; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $513=(($512+$511)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$513; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $514=$K; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $515=$Y; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $516=$515 << $514; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$516; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $517=(($516-16384)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $518=$517 >>> 16; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $519=$518 & 2; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$519; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $520=$N; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $521=(($520+$519)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$521; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $522=$N; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $523=((14-$522)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $524=$K; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $525=$Y; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $526=$525 << $524; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$526; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $527=$526 >>> 15; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $528=(($523+$527)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$528; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $529=$K; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $530=$529 << 1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $531=$qsize; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $532=$K; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $533=(($532+7)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $534=$531 >>> (($533)>>>0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $535=$534 & 1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $536=(($530+$535)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I7=$536; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 84; break;
    case 84: // $537
      __label__ = 85; break;
    case 85: // $538
      var $539=$I7; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $540=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $541=(($540+304)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $542=(($541+($539<<2))|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H6=$542; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $543=$I7; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $544=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $545=(($544+28)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($545)>>2)]=$543; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $546=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $547=(($546+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $548=(($547+4)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($548)>>2)]=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $549=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $550=(($549+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $551=(($550)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($551)>>2)]=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $552=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $553=(($552+4)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $554=HEAP32[(($553)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $555=$I7; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $556=1 << $555; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $557=$554 & $556; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $558=(($557)|0)!=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($558) { __label__ = 87; break; } else { __label__ = 86; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 86: // $559
      var $560=$I7; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $561=1 << $560; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $562=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $563=(($562+4)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $564=HEAP32[(($563)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $565=$564 | $561; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($563)>>2)]=$565; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $566=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $567=$H6; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($567)>>2)]=$566; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $568=$H6; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $569=$568; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $570=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $571=(($570+24)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($571)>>2)]=$569; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $572=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $573=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $574=(($573+12)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($574)>>2)]=$572; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $575=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $576=(($575+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($576)>>2)]=$572; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 105; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 87: // $577
      var $578=$H6; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $579=HEAP32[(($578)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$579; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $580=$qsize; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $581=$I7; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $582=(($581)|0)==31; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($582) { __label__ = 88; break; } else { __label__ = 89; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 88: // $583
      var $591 = 0;__label__ = 90; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 89: // $584
      var $585=$I7; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $586=$585 >>> 1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $587=(($586+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $588=(($587-2)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $589=((31-$588)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $591 = $589;__label__ = 90; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 90: // $590
      var $591; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $592=$580 << $591; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K8=$592; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 91; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 91: // $593
      var $594=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $595=(($594+4)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $596=HEAP32[(($595)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $597=$596 & -8; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $598=$qsize; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $599=(($597)|0)!=(($598)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($599) { __label__ = 92; break; } else { __label__ = 98; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 92: // $600
      var $601=$K8; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $602=$601 >>> 31; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $603=$602 & 1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $604=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $605=(($604+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $606=(($605+($603<<2))|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C=$606; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $607=$K8; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $608=$607 << 1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K8=$608; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $609=$C; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $610=HEAP32[(($609)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $611=(($610)|0)!=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($611) { __label__ = 93; break; } else { __label__ = 94; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 93: // $612
      var $613=$C; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $614=HEAP32[(($613)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$614; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 97; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 94: // $615
      var $616=$C; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $617=$616; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $618=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $619=(($618+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $620=HEAPU32[(($619)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $621=(($617)>>>0) >= (($620)>>>0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $622=(($621)&1); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $623=(($622)==(1)); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $624=(($623)|0)!=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($624) { __label__ = 95; break; } else { __label__ = 96; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 95: // $625
      var $626=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $627=$C; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($627)>>2)]=$626; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $628=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $629=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $630=(($629+24)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($630)>>2)]=$628; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $631=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $632=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $633=(($632+12)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($633)>>2)]=$631; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $634=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $635=(($634+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($635)>>2)]=$631; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 104; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 96: // $636
      _abort(); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 97: // $637
      __label__ = 103; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 98: // $638
      var $639=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $640=(($639+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $641=HEAP32[(($640)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F9=$641; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $642=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $643=$642; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $644=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $645=(($644+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $646=HEAPU32[(($645)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $647=(($643)>>>0) >= (($646)>>>0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($647) { __label__ = 99; break; } else { var $656 = 0;__label__ = 100; break; } //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 99: // $648
      var $649=$F9; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $650=$649; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $651=$1; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $652=(($651+16)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $653=HEAPU32[(($652)>>2)]; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $654=(($650)>>>0) >= (($653)>>>0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $656 = $654;__label__ = 100; break;
    case 100: // $655
      var $656;
      var $657=(($656)&1);
      var $658=(($657)==(1));
      var $659=(($658)|0)!=0;
      if ($659) { __label__ = 101; break; } else { __label__ = 102; break; }
    case 101: // $660
      var $661=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $662=$F9; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $663=(($662+12)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($663)>>2)]=$661; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $664=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $665=(($664+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($665)>>2)]=$661; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $666=$F9; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $667=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $668=(($667+8)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($668)>>2)]=$666; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $669=$T; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $670=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $671=(($670+12)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($671)>>2)]=$669; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $672=$TP5; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $673=(($672+24)|0); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($673)>>2)]=0; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 104; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 102: // $674
      _abort(); //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 103: // $675
      __label__ = 91; break; //@line 3811 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 104: // $676
      __label__ = 105; break;
    case 105: // $677
      __label__ = 106; break;
    case 106: // $678
      __label__ = 107; break;
    case 107: // $679
      __label__ = 108; break;
    case 108: // $680
      var $681=$p; //@line 3816 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $682=$681; //@line 3816 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $683=(($682+8)|0); //@line 3816 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      ;
      return $683; //@line 3816 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_prepend_alloc["X"]=1;

function __ZNKSt9bad_alloc4whatEv($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  ;
  return ((STRING_TABLE.__str31798)|0); //@line 160 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
}


function __ZSt15get_new_handlerv() {
  ;
  var __label__;

  var $1=(tempValue=HEAP32[((__ZL13__new_handler)>>2)],HEAP32[((__ZL13__new_handler)>>2)]=tempValue+0,tempValue); //@line 146 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  var $2=$1; //@line 146 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  ;
  return $2; //@line 146 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
}


function __ZNSt9bad_allocC2Ev($this) {
  var __stackBase__  = STACKTOP; STACKTOP += 4; assert(STACKTOP % 4 == 0, "Stack is unaligned"); assert(STACKTOP < STACK_MAX, "Ran out of stack");
  var __label__;

  var $1=__stackBase__;
  var $2;
  $2=$this;
  var $3=$2;
  var $4=$3; //@line 150 "/home/jkerk/emscripten/system/include/libcxx/new"
  var $5=$1;
  HEAP32[(($1)>>2)]=$4;
  var $6=HEAP32[(($1)>>2)];
  var $7=$6; //@line 90 "/home/jkerk/emscripten/system/include/libcxx/exception"
  HEAP32[(($7)>>2)]=((__ZTVSt9exception+8)|0); //@line 90 "/home/jkerk/emscripten/system/include/libcxx/exception"
  var $8=$1; //@line 90 "/home/jkerk/emscripten/system/include/libcxx/exception"
  var $9=$3; //@line 150 "/home/jkerk/emscripten/system/include/libcxx/new"
  HEAP32[(($9)>>2)]=((__ZTVSt9bad_alloc+8)|0); //@line 150 "/home/jkerk/emscripten/system/include/libcxx/new"
  STACKTOP = __stackBase__;
  return; //@line 151 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
}


function __ZdlPv($ptr) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      $1=$ptr;
      var $2=$1; //@line 107 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $3=(($2)|0)!=0; //@line 107 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      if ($3) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 107 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 1: // $4
      var $5=$1; //@line 108 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      _free($5); //@line 108 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      __label__ = 2; break; //@line 108 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 2: // $6
      ;
      return; //@line 109 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZdaPv($ptr) {
  ;
  var __label__;

  var $1;
  $1=$ptr;
  var $2=$1; //@line 122 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  __ZdlPv($2); //@line 122 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  ;
  return; //@line 123 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
}


function __ZNSt9bad_allocD0Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  FUNCTION_TABLE[__ZNSt9bad_allocD1Ev]($2); //@line 154 "/home/jkerk/emscripten/system/include/libcxx/new"
  var $3=$2; //@line 154 "/home/jkerk/emscripten/system/include/libcxx/new"
  __ZdlPv($3); //@line 154 "/home/jkerk/emscripten/system/include/libcxx/new"
  ;
  return; //@line 155 "/home/jkerk/emscripten/system/include/libcxx/new"
}


function __ZNSt9bad_allocD2Ev($this) {
  ;
  var __label__;

  var $1;
  $1=$this;
  var $2=$1;
  var $3=$2; //@line 155 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  __ZNSt9exceptionD2Ev($3); //@line 155 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  ;
  return; //@line 155 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
}


function _add_segment($m, $tbase, $tsize, $mmapped) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      var $4;
      var $old_top;
      var $oldsp;
      var $old_end;
      var $ssize;
      var $rawsp;
      var $offset;
      var $asp;
      var $csp;
      var $sp;
      var $ss;
      var $tnext;
      var $p;
      var $nfences;
      var $nextp;
      var $q;
      var $psize;
      var $tn;
      var $I;
      var $B;
      var $F;
      var $TP;
      var $H;
      var $I1;
      var $X;
      var $Y;
      var $N;
      var $K;
      var $T;
      var $K2;
      var $C;
      var $F3;
      $1=$m;
      $2=$tbase;
      $3=$tsize;
      $4=$mmapped;
      var $5=$1; //@line 3822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $6=(($5+24)|0); //@line 3822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $7=HEAP32[(($6)>>2)]; //@line 3822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $8=$7; //@line 3822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $old_top=$8; //@line 3822 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $9=$1; //@line 3823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $10=$old_top; //@line 3823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $11=_segment_holding($9, $10); //@line 3823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $oldsp=$11; //@line 3823 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $12=$oldsp; //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $13=(($12)|0); //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $14=HEAP32[(($13)>>2)]; //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $15=$oldsp; //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $16=(($15+4)|0); //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $17=HEAP32[(($16)>>2)]; //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $18=(($14+$17)|0); //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $old_end=$18; //@line 3824 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $ssize=24; //@line 3825 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $19=$old_end; //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $20=$ssize; //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $21=(($20+16)|0); //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $22=(($21+7)|0); //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $23=(((-$22))|0); //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $24=(($19+$23)|0); //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $rawsp=$24; //@line 3826 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $25=$rawsp; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $26=(($25+8)|0); //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $27=$26; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $28=$27 & 7; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $29=(($28)|0)==0; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($29) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 1: // $30
      var $39 = 0;__label__ = 3; break; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 2: // $31
      var $32=$rawsp; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $33=(($32+8)|0); //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $34=$33; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $35=$34 & 7; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $36=((8-$35)|0); //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $37=$36 & 7; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $39 = $37;__label__ = 3; break; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 3: // $38
      var $39; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $offset=$39; //@line 3827 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $40=$rawsp; //@line 3828 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $41=$offset; //@line 3828 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $42=(($40+$41)|0); //@line 3828 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $asp=$42; //@line 3828 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $43=$asp; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $44=$old_top; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $45=(($44+16)|0); //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $46=(($43)>>>0) < (($45)>>>0); //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($46) { __label__ = 4; break; } else { __label__ = 5; break; } //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 4: // $47
      var $48=$old_top; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52 = $48;__label__ = 6; break; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 5: // $49
      var $50=$asp; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $52 = $50;__label__ = 6; break; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 6: // $51
      var $52; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $csp=$52; //@line 3829 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $53=$csp; //@line 3830 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $54=$53; //@line 3830 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $sp=$54; //@line 3830 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $55=$sp; //@line 3831 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $56=$55; //@line 3831 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $57=(($56+8)|0); //@line 3831 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $58=$57; //@line 3831 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $ss=$58; //@line 3831 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $59=$sp; //@line 3832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $60=$59; //@line 3832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $61=$ssize; //@line 3832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $62=(($60+$61)|0); //@line 3832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $63=$62; //@line 3832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tnext=$63; //@line 3832 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $64=$tnext; //@line 3833 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$64; //@line 3833 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nfences=0; //@line 3834 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $65=$1; //@line 3837 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $66=$2; //@line 3837 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $67=$66; //@line 3837 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $68=$3; //@line 3837 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $69=(($68-40)|0); //@line 3837 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      _init_top($65, $67, $69); //@line 3837 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $70=$ssize; //@line 3841 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $71=$70 | 1; //@line 3841 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $72=$71 | 2; //@line 3841 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $73=$sp; //@line 3841 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $74=(($73+4)|0); //@line 3841 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($74)>>2)]=$72; //@line 3841 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $75=$ss; //@line 3842 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $76=$1; //@line 3842 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $77=(($76+444)|0); //@line 3842 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $78=$75; //@line 3842 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $79=$77; //@line 3842 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      assert(16 % 1 === 0, 'memcpy given ' + 16 + ' bytes to copy. Problem with quantum=1 corrections perhaps?');HEAP32[(($78)>>2)]=HEAP32[(($79)>>2)];HEAP32[(($78+4)>>2)]=HEAP32[(($79+4)>>2)];HEAP32[(($78+8)>>2)]=HEAP32[(($79+8)>>2)];HEAP32[(($78+12)>>2)]=HEAP32[(($79+12)>>2)]; //@line 3842 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $80=$2; //@line 3843 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $81=$1; //@line 3843 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $82=(($81+444)|0); //@line 3843 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $83=(($82)|0); //@line 3843 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($83)>>2)]=$80; //@line 3843 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $84=$3; //@line 3844 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $85=$1; //@line 3844 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $86=(($85+444)|0); //@line 3844 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $87=(($86+4)|0); //@line 3844 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($87)>>2)]=$84; //@line 3844 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $88=$4; //@line 3845 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $89=$1; //@line 3845 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $90=(($89+444)|0); //@line 3845 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $91=(($90+12)|0); //@line 3845 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($91)>>2)]=$88; //@line 3845 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $92=$ss; //@line 3846 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $93=$1; //@line 3846 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $94=(($93+444)|0); //@line 3846 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $95=(($94+8)|0); //@line 3846 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($95)>>2)]=$92; //@line 3846 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 7; break; //@line 3849 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 7: // $96
      var $97=$p; //@line 3850 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $98=$97; //@line 3850 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $99=(($98+4)|0); //@line 3850 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $100=$99; //@line 3850 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nextp=$100; //@line 3850 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $101=$p; //@line 3851 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $102=(($101+4)|0); //@line 3851 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($102)>>2)]=7; //@line 3851 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $103=$nfences; //@line 3852 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $104=(($103+1)|0); //@line 3852 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $nfences=$104; //@line 3852 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $105=$nextp; //@line 3853 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $106=(($105+4)|0); //@line 3853 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $107=$106; //@line 3853 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $108=$old_end; //@line 3853 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $109=(($107)>>>0) < (($108)>>>0); //@line 3853 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($109) { __label__ = 8; break; } else { __label__ = 9; break; } //@line 3853 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 8: // $110
      var $111=$nextp; //@line 3854 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $p=$111; //@line 3854 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 10; break; //@line 3854 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 9: // $112
      __label__ = 11; break; //@line 3856 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 10: // $113
      __label__ = 7; break; //@line 3857 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 11: // $114
      var $115=$csp; //@line 3861 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $116=$old_top; //@line 3861 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $117=(($115)|0)!=(($116)|0); //@line 3861 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($117) { __label__ = 12; break; } else { __label__ = 48; break; } //@line 3861 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 12: // $118
      var $119=$old_top; //@line 3862 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $120=$119; //@line 3862 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $q=$120; //@line 3862 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $121=$csp; //@line 3863 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $122=$old_top; //@line 3863 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $123=$121; //@line 3863 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $124=$122; //@line 3863 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $125=(($123-$124)|0); //@line 3863 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $psize=$125; //@line 3863 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $126=$q; //@line 3864 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $127=$126; //@line 3864 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $128=$psize; //@line 3864 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $129=(($127+$128)|0); //@line 3864 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $130=$129; //@line 3864 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $tn=$130; //@line 3864 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $131=$tn; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $132=(($131+4)|0); //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $133=HEAP32[(($132)>>2)]; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $134=$133 & -2; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($132)>>2)]=$134; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $135=$psize; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $136=$135 | 1; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $137=$q; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $138=(($137+4)|0); //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($138)>>2)]=$136; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $139=$psize; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $140=$q; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $141=$140; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $142=$psize; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $143=(($141+$142)|0); //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $144=$143; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $145=(($144)|0); //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($145)>>2)]=$139; //@line 3865 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $146=$psize; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $147=$146 >>> 3; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $148=(($147)>>>0) < 32; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($148) { __label__ = 13; break; } else { __label__ = 20; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 13: // $149
      var $150=$psize; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $151=$150 >>> 3; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I=$151; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $152=$I; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $153=$152 << 1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $154=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $155=(($154+40)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $156=(($155+($153<<2))|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $157=$156; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $158=$157; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $B=$158; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $159=$B; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$159; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $160=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $161=(($160)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $162=HEAP32[(($161)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $163=$I; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $164=1 << $163; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $165=$162 & $164; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $166=(($165)|0)!=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($166) { __label__ = 15; break; } else { __label__ = 14; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 14: // $167
      var $168=$I; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $169=1 << $168; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $170=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $171=(($170)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $172=HEAP32[(($171)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $173=$172 | $169; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($171)>>2)]=$173; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 19; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 15: // $174
      var $175=$B; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $176=(($175+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $177=HEAP32[(($176)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $178=$177; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $179=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $180=(($179+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $181=HEAPU32[(($180)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $182=(($178)>>>0) >= (($181)>>>0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $183=(($182)&1); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $184=(($183)==(1)); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $185=(($184)|0)!=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($185) { __label__ = 16; break; } else { __label__ = 17; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 16: // $186
      var $187=$B; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $188=(($187+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $189=HEAP32[(($188)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F=$189; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 18; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 17: // $190
      _abort(); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 18: // $191
      __label__ = 19; break;
    case 19: // $192
      var $193=$q; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $194=$B; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $195=(($194+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($195)>>2)]=$193; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $196=$q; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $197=$F; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $198=(($197+12)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($198)>>2)]=$196; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $199=$F; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $200=$q; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $201=(($200+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($201)>>2)]=$199; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $202=$B; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $203=$q; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $204=(($203+12)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($204)>>2)]=$202; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 47; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 20: // $205
      var $206=$q; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $207=$206; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $TP=$207; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $208=$psize; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $209=$208 >>> 8; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $X=$209; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $210=$X; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $211=(($210)|0)==0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($211) { __label__ = 21; break; } else { __label__ = 22; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 21: // $212
      $I1=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 26; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 22: // $213
      var $214=$X; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $215=(($214)>>>0) > 65535; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($215) { __label__ = 23; break; } else { __label__ = 24; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 23: // $216
      $I1=31; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 25; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 24: // $217
      var $218=$X; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$218; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $219=$Y; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $220=(($219-256)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $221=$220 >>> 16; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $222=$221 & 8; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$222; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $223=$N; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $224=$Y; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $225=$224 << $223; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$225; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $226=(($225-4096)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $227=$226 >>> 16; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $228=$227 & 4; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$228; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $229=$K; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $230=$N; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $231=(($230+$229)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$231; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $232=$K; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $233=$Y; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $234=$233 << $232; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$234; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $235=(($234-16384)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $236=$235 >>> 16; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $237=$236 & 2; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$237; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $238=$N; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $239=(($238+$237)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $N=$239; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $240=$N; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $241=((14-$240)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $242=$K; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $243=$Y; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $244=$243 << $242; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $Y=$244; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $245=$244 >>> 15; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $246=(($241+$245)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K=$246; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $247=$K; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $248=$247 << 1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $249=$psize; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $250=$K; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $251=(($250+7)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $252=$249 >>> (($251)>>>0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $253=$252 & 1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $254=(($248+$253)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $I1=$254; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 25; break;
    case 25: // $255
      __label__ = 26; break;
    case 26: // $256
      var $257=$I1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $258=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $259=(($258+304)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $260=(($259+($257<<2))|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $H=$260; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $261=$I1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $262=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $263=(($262+28)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($263)>>2)]=$261; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $264=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $265=(($264+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $266=(($265+4)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($266)>>2)]=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $267=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $268=(($267+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $269=(($268)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($269)>>2)]=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $270=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $271=(($270+4)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $272=HEAP32[(($271)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $273=$I1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $274=1 << $273; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $275=$272 & $274; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $276=(($275)|0)!=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($276) { __label__ = 28; break; } else { __label__ = 27; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 27: // $277
      var $278=$I1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $279=1 << $278; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $280=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $281=(($280+4)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $282=HEAP32[(($281)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $283=$282 | $279; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($281)>>2)]=$283; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $284=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $285=$H; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($285)>>2)]=$284; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $286=$H; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $287=$286; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $288=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $289=(($288+24)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($289)>>2)]=$287; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $290=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $291=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $292=(($291+12)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($292)>>2)]=$290; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $293=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $294=(($293+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($294)>>2)]=$290; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 46; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 28: // $295
      var $296=$H; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $297=HEAP32[(($296)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$297; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $298=$psize; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $299=$I1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $300=(($299)|0)==31; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($300) { __label__ = 29; break; } else { __label__ = 30; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 29: // $301
      var $309 = 0;__label__ = 31; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 30: // $302
      var $303=$I1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $304=$303 >>> 1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $305=(($304+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $306=(($305-2)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $307=((31-$306)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $309 = $307;__label__ = 31; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 31: // $308
      var $309; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $310=$298 << $309; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$310; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 32; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 32: // $311
      var $312=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $313=(($312+4)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $314=HEAP32[(($313)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $315=$314 & -8; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $316=$psize; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $317=(($315)|0)!=(($316)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($317) { __label__ = 33; break; } else { __label__ = 39; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 33: // $318
      var $319=$K2; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $320=$319 >>> 31; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $321=$320 & 1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $322=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $323=(($322+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $324=(($323+($321<<2))|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $C=$324; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $325=$K2; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $326=$325 << 1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $K2=$326; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $327=$C; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $328=HEAP32[(($327)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $329=(($328)|0)!=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($329) { __label__ = 34; break; } else { __label__ = 35; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 34: // $330
      var $331=$C; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $332=HEAP32[(($331)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $T=$332; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 38; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 35: // $333
      var $334=$C; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $335=$334; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $336=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $337=(($336+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $338=HEAPU32[(($337)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $339=(($335)>>>0) >= (($338)>>>0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $340=(($339)&1); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $341=(($340)==(1)); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $342=(($341)|0)!=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($342) { __label__ = 36; break; } else { __label__ = 37; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 36: // $343
      var $344=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $345=$C; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($345)>>2)]=$344; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $346=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $347=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $348=(($347+24)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($348)>>2)]=$346; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $349=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $350=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $351=(($350+12)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($351)>>2)]=$349; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $352=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $353=(($352+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($353)>>2)]=$349; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 45; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 37: // $354
      _abort(); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 38: // $355
      __label__ = 44; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 39: // $356
      var $357=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $358=(($357+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $359=HEAP32[(($358)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      $F3=$359; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $360=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $361=$360; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $362=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $363=(($362+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $364=HEAPU32[(($363)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $365=(($361)>>>0) >= (($364)>>>0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      if ($365) { __label__ = 40; break; } else { var $374 = 0;__label__ = 41; break; } //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 40: // $366
      var $367=$F3; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $368=$367; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $369=$1; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $370=(($369+16)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $371=HEAPU32[(($370)>>2)]; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $372=(($368)>>>0) >= (($371)>>>0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $374 = $372;__label__ = 41; break;
    case 41: // $373
      var $374;
      var $375=(($374)&1);
      var $376=(($375)==(1));
      var $377=(($376)|0)!=0;
      if ($377) { __label__ = 42; break; } else { __label__ = 43; break; }
    case 42: // $378
      var $379=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $380=$F3; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $381=(($380+12)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($381)>>2)]=$379; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $382=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $383=(($382+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($383)>>2)]=$379; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $384=$F3; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $385=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $386=(($385+8)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($386)>>2)]=$384; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $387=$T; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $388=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $389=(($388+12)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($389)>>2)]=$387; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $390=$TP; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      var $391=(($390+24)|0); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      HEAP32[(($391)>>2)]=0; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      __label__ = 45; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 43: // $392
      _abort(); //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
      throw "Reached an unreachable!" //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 44: // $393
      __label__ = 32; break; //@line 3866 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 45: // $394
      __label__ = 46; break;
    case 46: // $395
      __label__ = 47; break;
    case 47: // $396
      __label__ = 48; break; //@line 3867 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    case 48: // $397
      ;
      return; //@line 3870 "/home/jkerk/emscripten/system/lib/dlmalloc.c"
    default: assert(0, "bad label: " + __label__);
  }
}
_add_segment["X"]=1;

function __Znwj($size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $p;
      var $nh;
      var $2;
      var $3;
      $1=$size;
      var $4=$1; //@line 35 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $5=(($4)|0)==0; //@line 35 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      if ($5) { __label__ = 1; break; } else { __label__ = 2; break; } //@line 35 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 1: // $6
      $1=1; //@line 36 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      __label__ = 2; break; //@line 36 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 2: // $7
      __label__ = 3; break; //@line 38 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 3: // $8
      var $9=$1; //@line 38 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $10=_malloc($9); //@line 38 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      $p=$10; //@line 38 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $11=(($10)|0)==0; //@line 38 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      if ($11) { __label__ = 4; break; } else { __label__ = 12; break; } //@line 38 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 4: // $12
      var $13=__ZSt15get_new_handlerv(); //@line 42 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      $nh=$13; //@line 42 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $14=$nh; //@line 43 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $15=(($14)|0)!=0; //@line 43 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      if ($15) { __label__ = 5; break; } else { __label__ = 10; break; } //@line 43 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 5: // $16
      var $17=$nh; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      (function() { try { __THREW__ = false; return FUNCTION_TABLE[$17]() } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 6; break; } else { __label__ = 7; break; }
    case 6: // $18
      __label__ = 11; break; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 7: // $19
      var $20=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $21=$20.f0; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      $2=$21; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $22=$20.f1; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      $3=$22; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      __label__ = 8; break; //@line 44 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 8: // $23
      var $24=$3; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $25=(($24)|0) < 0; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      if ($25) { __label__ = 9; break; } else { __label__ = 13; break; } //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 9: // $26
      var $27=$2; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      ___cxa_call_unexpected($27); //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      throw "Reached an unreachable!" //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 10: // $28
      var $29=___cxa_allocate_exception(4); //@line 47 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $30=$29; //@line 47 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($30); //@line 47 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      (function() { try { __THREW__ = false; return ___cxa_throw($29, __ZTISt9bad_alloc, 2) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 14; break; } else { __label__ = 7; break; }
    case 11: // $31
      __label__ = 3; break; //@line 51 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 12: // $32
      var $33=$p; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      ;
      return $33; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 13: // $34
      var $35=$2; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $36=$2; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $37=$3; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $38=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $36, tempValue); //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $39=($38.f1 = $37, $38); //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)]; //@line 52 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 14: // $40
      throw "Reached an unreachable!"
    default: assert(0, "bad label: " + __label__);
  }
}
__Znwj["X"]=1;

function __Znaj($size) {
  ;
  var __label__;
  __label__ = -1; 
  while(1) switch(__label__) {
    case -1: // $0
      var $1;
      var $2;
      var $3;
      $1=$size;
      var $4=$1; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $5=(function() { try { __THREW__ = false; return __Znwj($4) } catch(e) { if (typeof e != "number") throw e; if (ABORT) throw e; __THREW__ = true; print("Exception: " + e + ", currently at: " + (new Error().stack)); return null } })(); if (!__THREW__) { __label__ = 1; break; } else { __label__ = 2; break; };
    case 1: // $6
      ;
      return $5; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 2: // $7
      var $8=___cxa_find_matching_catch(HEAP32[((_llvm_eh_exception.buf)>>2)],HEAP32[((_llvm_eh_exception.buf+4)>>2)],[]);
      var $9=$8.f0; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      $2=$9; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $10=$8.f1; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      $3=$10; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      __label__ = 3; break; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 3: // $11
      var $12=$3; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $13=(($12)|0) < 0; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      if ($13) { __label__ = 4; break; } else { __label__ = 5; break; } //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 4: // $14
      var $15=$2; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      ___cxa_call_unexpected($15); //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      throw "Reached an unreachable!" //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    case 5: // $16
      var $17=$2; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $18=$2; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $19=$3; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $20=(tempValue = [0,0,0,0,0,0,0,0], tempValue.f0 = $18, tempValue); //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      var $21=($20.f1 = $19, $20); //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
      print("Resuming exception");throw HEAP32[((_llvm_eh_exception.buf)>>2)]; //@line 81 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
    default: assert(0, "bad label: " + __label__);
  }
}


function __ZSt17__throw_bad_allocv() {
  ;
  var __label__;

  var $1=___cxa_allocate_exception(4); //@line 181 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  var $2=$1; //@line 181 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  FUNCTION_TABLE[__ZNSt9bad_allocC1Ev]($2); //@line 181 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  ___cxa_throw($1, __ZTISt9bad_alloc, 2); //@line 181 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  throw "Reached an unreachable!" //@line 181 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
  ;
  return; //@line 183 "/home/jkerk/emscripten/system/lib/libcxx/new.cpp"
}


  function ___gxx_personality_v0() {
    }

  function ___cxa_allocate_exception(size) {
      return _malloc(size);
    }

  
  function _llvm_eh_exception() {
      return HEAP32[((_llvm_eh_exception.buf)>>2)];
    }
  
  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  function ___cxa_find_matching_catch(thrown, throwntype, typeArray) {
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return { 'f0':thrown, 'f1':typeArray[i]};
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return {'f0':thrown,'f1':throwntype};
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      print('Compiled code throwing an exception, ' + [ptr,type,destructor] + ', at ' + new Error().stack);
      HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr
      HEAP32[((_llvm_eh_exception.buf+4)>>2)]=type
      HEAP32[((_llvm_eh_exception.buf+8)>>2)]=destructor
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr;
    }

  
  function _memset(ptr, value, num, align) {
      // TODO: make these settings, and in memcpy, {{'s
      if (num >= 20) {
        // This is unaligned, but quite large, so work hard to get to aligned settings
        var stop = ptr + num;
        while (ptr % 4) { // no need to check for stop, since we have large num
          HEAP8[ptr++] = value;
        }
        if (value < 0) value += 256; // make it unsigned
        var ptr4 = ptr >> 2, stop4 = stop >> 2, value4 = value | (value << 8) | (value << 16) | (value << 24);
        while (ptr4 < stop4) {
          HEAP32[ptr4++] = value4;
        }
        ptr = ptr4 << 2;
        while (ptr < stop) {
          HEAP8[ptr++] = value;
        }
      } else {
        while (num--) {
          HEAP8[ptr++] = value;
        }
      }
    }var _llvm_memset_p0i8_i32=_memset;

  function ___cxa_call_unexpected(exception) {
      ABORT = true;
      throw exception;
    }

  function _llvm_lifetime_start() {}

  function _llvm_lifetime_end() {}

  
  function _memcpy(dest, src, num, align) {
      assert(num % 1 === 0, 'memcpy given ' + num + ' bytes to copy. Problem with quantum=1 corrections perhaps?');
      if (num >= 20 && src % 2 == dest % 2) {
        // This is unaligned, but quite large, and potentially alignable, so work hard to get to aligned settings
        if (src % 4 == dest % 4) {
          var stop = src + num;
          while (src % 4) { // no need to check for stop, since we have large num
            HEAP8[dest++] = HEAP8[src++];
          }
          var src4 = src >> 2, dest4 = dest >> 2, stop4 = stop >> 2;
          while (src4 < stop4) {
            HEAP32[dest4++] = HEAP32[src4++];
          }
          src = src4 << 2;
          dest = dest4 << 2;
          while (src < stop) {
            HEAP8[dest++] = HEAP8[src++];
          }
        } else {
          var stop = src + num;
          if (src % 2) { // no need to check for stop, since we have large num
            HEAP8[dest++] = HEAP8[src++];
          }
          var src2 = src >> 1, dest2 = dest >> 1, stop2 = stop >> 1;
          while (src2 < stop2) {
            HEAP16[dest2++] = HEAP16[src2++];
          }
          src = src2 << 1;
          dest = dest2 << 1;
          if (src < stop) {
            HEAP8[dest++] = HEAP8[src++];
          }
        }
      } else {
        while (num--) {
          HEAP8[dest++] = HEAP8[src++];
        }
      }
    }var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___cxa_free_exception(ptr) {
      return _free(ptr);
    }
var _llvm_va_start; // stub for _llvm_va_start

  
  
  
  function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (tempDoubleI32[0]=HEAP32[((varargs+argIndex)>>2)],tempDoubleI32[1]=HEAP32[((varargs+argIndex+4)>>2)],tempDoubleF64[0]);
        } else if (type == 'i64') {
          ret = [HEAP32[((varargs+argIndex)>>2)],
                 HEAP32[((varargs+argIndex+4)>>2)]];
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[((varargs+argIndex)>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[(textIndex+1)];
        if (curr == '%'.charCodeAt(0)) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          flagsLoop: while (1) {
            switch (next) {
              case '+'.charCodeAt(0):
                flagAlwaysSigned = true;
                break;
              case '-'.charCodeAt(0):
                flagLeftAlign = true;
                break;
              case '#'.charCodeAt(0):
                flagAlternative = true;
                break;
              case '0'.charCodeAt(0):
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[(textIndex+1)];
          }
  
          // Handle width.
          var width = 0;
          if (next == '*'.charCodeAt(0)) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[(textIndex+1)];
          } else {
            while (next >= '0'.charCodeAt(0) && next <= '9'.charCodeAt(0)) {
              width = width * 10 + (next - '0'.charCodeAt(0));
              textIndex++;
              next = HEAP8[(textIndex+1)];
            }
          }
  
          // Handle precision.
          var precisionSet = false;
          if (next == '.'.charCodeAt(0)) {
            var precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[(textIndex+1)];
            if (next == '*'.charCodeAt(0)) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[(textIndex+1)];
                if (precisionChr < '0'.charCodeAt(0) ||
                    precisionChr > '9'.charCodeAt(0)) break;
                precision = precision * 10 + (precisionChr - '0'.charCodeAt(0));
                textIndex++;
              }
            }
            next = HEAP8[(textIndex+1)];
          } else {
            var precision = 6; // Standard default.
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[(textIndex+2)];
              if (nextNext == 'h'.charCodeAt(0)) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[(textIndex+2)];
              if (nextNext == 'l'.charCodeAt(0)) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[(textIndex+1)];
  
          // Handle type specifier.
          if (['d', 'i', 'u', 'o', 'x', 'X', 'p'].indexOf(String.fromCharCode(next)) != -1) {
            // Integer.
            var signed = next == 'd'.charCodeAt(0) || next == 'i'.charCodeAt(0);
            argSize = argSize || 4;
            var currArg = getNextArg('i' + (argSize * 8));
            // Flatten i64-1 [low, high] into a (slightly rounded) double
            if (argSize == 8) {
              currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 'u'.charCodeAt(0));
            }
            // Truncate to requested size.
            if (argSize <= 4) {
              var limit = Math.pow(256, argSize) - 1;
              currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
            }
            // Format the number.
            var currAbsArg = Math.abs(currArg);
            var argText;
            var prefix = '';
            if (next == 'd'.charCodeAt(0) || next == 'i'.charCodeAt(0)) {
              argText = reSign(currArg, 8 * argSize, 1).toString(10);
            } else if (next == 'u'.charCodeAt(0)) {
              argText = unSign(currArg, 8 * argSize, 1).toString(10);
              currArg = Math.abs(currArg);
            } else if (next == 'o'.charCodeAt(0)) {
              argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
            } else if (next == 'x'.charCodeAt(0) || next == 'X'.charCodeAt(0)) {
              prefix = flagAlternative ? '0x' : '';
              if (currArg < 0) {
                // Represent negative numbers in hex as 2's complement.
                currArg = -currArg;
                argText = (currAbsArg - 1).toString(16);
                var buffer = [];
                for (var i = 0; i < argText.length; i++) {
                  buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                }
                argText = buffer.join('');
                while (argText.length < argSize * 2) argText = 'f' + argText;
              } else {
                argText = currAbsArg.toString(16);
              }
              if (next == 'X'.charCodeAt(0)) {
                prefix = prefix.toUpperCase();
                argText = argText.toUpperCase();
              }
            } else if (next == 'p'.charCodeAt(0)) {
              if (currAbsArg === 0) {
                argText = '(nil)';
              } else {
                prefix = '0x';
                argText = currAbsArg.toString(16);
              }
            }
            if (precisionSet) {
              while (argText.length < precision) {
                argText = '0' + argText;
              }
            }
  
            // Add sign if needed
            if (flagAlwaysSigned) {
              if (currArg < 0) {
                prefix = '-' + prefix;
              } else {
                prefix = '+' + prefix;
              }
            }
  
            // Add padding.
            while (prefix.length + argText.length < width) {
              if (flagLeftAlign) {
                argText += ' ';
              } else {
                if (flagZeroPad) {
                  argText = '0' + argText;
                } else {
                  prefix = ' ' + prefix;
                }
              }
            }
  
            // Insert the result into the buffer.
            argText = prefix + argText;
            argText.split('').forEach(function(chr) {
              ret.push(chr.charCodeAt(0));
            });
          } else if (['f', 'F', 'e', 'E', 'g', 'G'].indexOf(String.fromCharCode(next)) != -1) {
            // Float.
            var currArg = getNextArg('double');
            var argText;
  
            if (isNaN(currArg)) {
              argText = 'nan';
              flagZeroPad = false;
            } else if (!isFinite(currArg)) {
              argText = (currArg < 0 ? '-' : '') + 'inf';
              flagZeroPad = false;
            } else {
              var isGeneral = false;
              var effectivePrecision = Math.min(precision, 20);
  
              // Convert g/G to f/F or e/E, as per:
              // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
              if (next == 'g'.charCodeAt(0) || next == 'G'.charCodeAt(0)) {
                isGeneral = true;
                precision = precision || 1;
                var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                if (precision > exponent && exponent >= -4) {
                  next = ((next == 'g'.charCodeAt(0)) ? 'f' : 'F').charCodeAt(0);
                  precision -= exponent + 1;
                } else {
                  next = ((next == 'g'.charCodeAt(0)) ? 'e' : 'E').charCodeAt(0);
                  precision--;
                }
                effectivePrecision = Math.min(precision, 20);
              }
  
              if (next == 'e'.charCodeAt(0) || next == 'E'.charCodeAt(0)) {
                argText = currArg.toExponential(effectivePrecision);
                // Make sure the exponent has at least 2 digits.
                if (/[eE][-+]\d$/.test(argText)) {
                  argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                }
              } else if (next == 'f'.charCodeAt(0) || next == 'F'.charCodeAt(0)) {
                argText = currArg.toFixed(effectivePrecision);
              }
  
              var parts = argText.split('e');
              if (isGeneral && !flagAlternative) {
                // Discard trailing zeros and periods.
                while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                       (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                  parts[0] = parts[0].slice(0, -1);
                }
              } else {
                // Make sure we have a period in alternative mode.
                if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                // Zero pad until required precision.
                while (precision > effectivePrecision++) parts[0] += '0';
              }
              argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
              // Capitalize 'E' if needed.
              if (next == 'E'.charCodeAt(0)) argText = argText.toUpperCase();
  
              // Add sign.
              if (flagAlwaysSigned && currArg >= 0) {
                argText = '+' + argText;
              }
            }
  
            // Add padding.
            while (argText.length < width) {
              if (flagLeftAlign) {
                argText += ' ';
              } else {
                if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                  argText = argText[0] + '0' + argText.slice(1);
                } else {
                  argText = (flagZeroPad ? '0' : ' ') + argText;
                }
              }
            }
  
            // Adjust case.
            if (next < 'a'.charCodeAt(0)) argText = argText.toUpperCase();
  
            // Insert the result into the buffer.
            argText.split('').forEach(function(chr) {
              ret.push(chr.charCodeAt(0));
            });
          } else if (next == 's'.charCodeAt(0)) {
            // String.
            var arg = getNextArg('i8*');
            var copiedString;
            if (arg) {
              copiedString = String_copy(arg);
              if (precisionSet && copiedString.length > precision) {
                copiedString = copiedString.slice(0, precision);
              }
            } else {
              copiedString = intArrayFromString('(null)', true);
            }
            if (!flagLeftAlign) {
              while (copiedString.length < width--) {
                ret.push(' '.charCodeAt(0));
              }
            }
            ret = ret.concat(copiedString);
            if (flagLeftAlign) {
              while (copiedString.length < width--) {
                ret.push(' '.charCodeAt(0));
              }
            }
          } else if (next == 'c'.charCodeAt(0)) {
            // Character.
            if (flagLeftAlign) ret.push(getNextArg('i8'));
            while (--width > 0) {
              ret.push(' '.charCodeAt(0));
            }
            if (!flagLeftAlign) ret.push(getNextArg('i8'));
          } else if (next == 'n'.charCodeAt(0)) {
            // Write the length written so far to the next parameter.
            var ptr = getNextArg('i32*');
            HEAP32[((ptr)>>2)]=ret.length
          } else if (next == '%'.charCodeAt(0)) {
            // Literal percent sign.
            ret.push(curr);
          } else {
            // Unknown specifiers remain untouched.
            for (var i = startTextIndex; i < textIndex + 2; i++) {
              ret.push(HEAP8[(i)]);
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, n - 1);
      for (var i = 0; i < limit; i++) {
        HEAP8[(s+i)]=result[i];
      }
      HEAP8[(s+i)]=0;
      return result.length;
    }function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }
  var _vsprintf=_sprintf;

  function _llvm_va_end() {}

  function ___cxa_pure_virtual() {
      ABORT = true;
      throw 'Pure virtual function called!';
    }

  function _strcpy(pdest, psrc) {
      var i = 0;
      do {
        HEAP8[(pdest+i)]=HEAP8[(psrc+i)];
        i ++;
      } while (HEAP8[(psrc+i-1)] != 0);
      return pdest;
    }
var _llvm_expect_i32; // stub for _llvm_expect_i32

  
  function _strncmp(px, py, n) {
      var i = 0;
      while (i < n) {
        var x = HEAP8[(px+i)];
        var y = HEAP8[(py+i)];
        if (x == y && x == 0) return 0;
        if (x == 0) return -1;
        if (y == 0) return 1;
        if (x == y) {
          i ++;
          continue;
        } else {
          return x > y ? 1 : -1;
        }
      }
      return 0;
    }function _strcmp(px, py) {
      return _strncmp(px, py, TOTAL_MEMORY);
    }

  function _strchr(ptr, chr) {
      ptr--;
      do {
        ptr++;
        var val = HEAP8[(ptr)];
        if (val == chr) return ptr;
      } while (val);
      return 0;
    }

  function _strlen(ptr) {
      return String_len(ptr);
    }

  
  
  function __isFloat(text) {
      return !!(/^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?$/.exec(text));
    }function __scanString(format, get, unget, varargs) {
      // Supports %x, %4x, %d.%d, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      for (var formatIndex = 0; formatIndex < format.length; formatIndex++) {
        if (next <= 0) return fields;
        var next = get();
        if (next <= 0) return fields;  // End of input.
        if (format[formatIndex] === '%') {
          formatIndex++;
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= '0'.charCodeAt(0) &&
                 format[formatIndex].charCodeAt(0) <= '9'.charCodeAt(0)) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          // TODO: Handle type size modifier.
          var long_ = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f') {
            var last = -1;
            while (next > 0) {
              buffer.push(String.fromCharCode(next));
              if (__isFloat(buffer.join(''))) {
                last = buffer.length;
              }
              next = get();
            }
            while (buffer.length > last) {
              buffer.pop();
              unget();
            }
          } else {
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if ((type === 'd' && next >= '0'.charCodeAt(0) && next <= '9'.charCodeAt(0)) ||
                  (type === 'x' && (next >= '0'.charCodeAt(0) && next <= '9'.charCodeAt(0) ||
                                    next >= 'a'.charCodeAt(0) && next <= 'f'.charCodeAt(0) ||
                                    next >= 'A'.charCodeAt(0) && next <= 'F'.charCodeAt(0))) ||
                  (type === 's') &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
              } else {
                break;
              }
            }
          }
          if (buffer.length === 0) return 0;  // Failure.
          var text = buffer.join('');
          var argPtr = HEAP32[((varargs+argIndex)>>2)];
          argIndex += Runtime.getNativeFieldSize('void*');
          switch (type) {
            case 'd':
              HEAP32[((argPtr)>>2)]=parseInt(text, 10)
              break;
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16)
              break;
            case 'f':
              if (long_) {
                (tempDoubleF64[0]=parseFloat(text),HEAP32[((argPtr)>>2)]=tempDoubleI32[0],HEAP32[((argPtr+4)>>2)]=tempDoubleI32[1])
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text)
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(argPtr+j)]=array[j]
              }
              break;
          }
          fields++;
        } else {
          // Not a specifier.
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            return fields;
          }
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      var get = function() { return HEAP8[(s+index++)]; };
      var unget = function() { index--; };
      return __scanString(format, get, unget, varargs);
    }

  
  
  var ERRNO_CODES={E2BIG:7,EACCES:13,EADDRINUSE:98,EADDRNOTAVAIL:99,EAFNOSUPPORT:97,EAGAIN:11,EALREADY:114,EBADF:9,EBADMSG:74,EBUSY:16,ECANCELED:125,ECHILD:10,ECONNABORTED:103,ECONNREFUSED:111,ECONNRESET:104,EDEADLK:35,EDESTADDRREQ:89,EDOM:33,EDQUOT:122,EEXIST:17,EFAULT:14,EFBIG:27,EHOSTUNREACH:113,EIDRM:43,EILSEQ:84,EINPROGRESS:115,EINTR:4,EINVAL:22,EIO:5,EISCONN:106,EISDIR:21,ELOOP:40,EMFILE:24,EMLINK:31,EMSGSIZE:90,EMULTIHOP:72,ENAMETOOLONG:36,ENETDOWN:100,ENETRESET:102,ENETUNREACH:101,ENFILE:23,ENOBUFS:105,ENODATA:61,ENODEV:19,ENOENT:2,ENOEXEC:8,ENOLCK:37,ENOLINK:67,ENOMEM:12,ENOMSG:42,ENOPROTOOPT:92,ENOSPC:28,ENOSR:63,ENOSTR:60,ENOSYS:38,ENOTCONN:107,ENOTDIR:20,ENOTEMPTY:39,ENOTRECOVERABLE:131,ENOTSOCK:88,ENOTSUP:95,ENOTTY:25,ENXIO:6,EOVERFLOW:75,EOWNERDEAD:130,EPERM:1,EPIPE:32,EPROTO:71,EPROTONOSUPPORT:93,EPROTOTYPE:91,ERANGE:34,EROFS:30,ESPIPE:29,ESRCH:3,ESTALE:116,ETIME:62,ETIMEDOUT:110,ETXTBSY:26,EWOULDBLOCK:11,EXDEV:18};
  
  function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      if (!___setErrNo.ret) ___setErrNo.ret = allocate([0], 'i32', ALLOC_STATIC);
      HEAP32[((___setErrNo.ret)>>2)]=value
      return value;
    }
  
  var _stdin=0;
  
  var _stdout=0;
  
  var _stderr=0;
  
  var __impure_ptr=0;var FS={currentPath:"/",nextInode:2,streams:[null],ignorePermissions:true,absolutePath:function (relative, base) {
        if (typeof relative !== 'string') return null;
        if (base === undefined) base = FS.currentPath;
        if (relative && relative[0] == '/') base = '';
        var full = base + '/' + relative;
        var parts = full.split('/').reverse();
        var absolute = [''];
        while (parts.length) {
          var part = parts.pop();
          if (part == '' || part == '.') {
            // Nothing.
          } else if (part == '..') {
            if (absolute.length > 1) absolute.pop();
          } else {
            absolute.push(part);
          }
        }
        return absolute.length == 1 ? '/' : absolute.join('/');
      },analyzePath:function (path, dontResolveLastLink, linksVisited) {
        var ret = {
          isRoot: false,
          exists: false,
          error: 0,
          name: null,
          path: null,
          object: null,
          parentExists: false,
          parentPath: null,
          parentObject: null
        };
        path = FS.absolutePath(path);
        if (path == '/') {
          ret.isRoot = true;
          ret.exists = ret.parentExists = true;
          ret.name = '/';
          ret.path = ret.parentPath = '/';
          ret.object = ret.parentObject = FS.root;
        } else if (path !== null) {
          linksVisited = linksVisited || 0;
          path = path.slice(1).split('/');
          var current = FS.root;
          var traversed = [''];
          while (path.length) {
            if (path.length == 1 && current.isFolder) {
              ret.parentExists = true;
              ret.parentPath = traversed.length == 1 ? '/' : traversed.join('/');
              ret.parentObject = current;
              ret.name = path[0];
            }
            var target = path.shift();
            if (!current.isFolder) {
              ret.error = ERRNO_CODES.ENOTDIR;
              break;
            } else if (!current.read) {
              ret.error = ERRNO_CODES.EACCES;
              break;
            } else if (!current.contents.hasOwnProperty(target)) {
              ret.error = ERRNO_CODES.ENOENT;
              break;
            }
            current = current.contents[target];
            if (current.link && !(dontResolveLastLink && path.length == 0)) {
              if (linksVisited > 40) { // Usual Linux SYMLOOP_MAX.
                ret.error = ERRNO_CODES.ELOOP;
                break;
              }
              var link = FS.absolutePath(current.link, traversed.join('/'));
              return FS.analyzePath([link].concat(path).join('/'),
                                    dontResolveLastLink, linksVisited + 1);
            }
            traversed.push(target);
            if (path.length == 0) {
              ret.exists = true;
              ret.path = traversed.join('/');
              ret.object = current;
            }
          }
          return ret;
        }
        return ret;
      },findObject:function (path, dontResolveLastLink) {
        FS.ensureRoot();
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },createObject:function (parent, name, properties, canRead, canWrite) {
        if (!parent) parent = '/';
        if (typeof parent === 'string') parent = FS.findObject(parent);
  
        if (!parent) {
          ___setErrNo(ERRNO_CODES.EACCES);
          throw new Error('Parent path must exist.');
        }
        if (!parent.isFolder) {
          ___setErrNo(ERRNO_CODES.ENOTDIR);
          throw new Error('Parent must be a folder.');
        }
        if (!parent.write && !FS.ignorePermissions) {
          ___setErrNo(ERRNO_CODES.EACCES);
          throw new Error('Parent folder must be writeable.');
        }
        if (!name || name == '.' || name == '..') {
          ___setErrNo(ERRNO_CODES.ENOENT);
          throw new Error('Name must not be empty.');
        }
        if (parent.contents.hasOwnProperty(name)) {
          ___setErrNo(ERRNO_CODES.EEXIST);
          throw new Error("Can't overwrite object.");
        }
  
        parent.contents[name] = {
          read: canRead === undefined ? true : canRead,
          write: canWrite === undefined ? false : canWrite,
          timestamp: Date.now(),
          inodeNumber: FS.nextInode++
        };
        for (var key in properties) {
          if (properties.hasOwnProperty(key)) {
            parent.contents[name][key] = properties[key];
          }
        }
  
        return parent.contents[name];
      },createFolder:function (parent, name, canRead, canWrite) {
        var properties = {isFolder: true, isDevice: false, contents: {}};
        return FS.createObject(parent, name, properties, canRead, canWrite);
      },createPath:function (parent, path, canRead, canWrite) {
        var current = FS.findObject(parent);
        if (current === null) throw new Error('Invalid parent.');
        path = path.split('/').reverse();
        while (path.length) {
          var part = path.pop();
          if (!part) continue;
          if (!current.contents.hasOwnProperty(part)) {
            FS.createFolder(current, part, canRead, canWrite);
          }
          current = current.contents[part];
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        properties.isFolder = false;
        return FS.createObject(parent, name, properties, canRead, canWrite);
      },createDataFile:function (parent, name, data, canRead, canWrite) {
        if (typeof data === 'string') {
          var dataArray = [];
          for (var i = 0; i < data.length; i++) dataArray.push(data.charCodeAt(i));
          data = dataArray;
        }
        var properties = {isDevice: false, contents: data};
        return FS.createFile(parent, name, properties, canRead, canWrite);
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        var properties = {isDevice: false, url: url};
        return FS.createFile(parent, name, properties, canRead, canWrite);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var properties = {isDevice: false, link: target};
        return FS.createFile(parent, name, properties, canRead, canWrite);
      },createDevice:function (parent, name, input, output) {
        if (!(input || output)) {
          throw new Error('A device must have at least one callback defined.');
        }
        var ops = {isDevice: true, input: input, output: output};
        return FS.createFile(parent, name, ops, Boolean(input), Boolean(output));
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          // Browser.
          // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
          var xhr = new XMLHttpRequest();
          xhr.open('GET', obj.url, false);
  
          // Some hints to the browser that we want binary data.
          if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
          if (xhr.overrideMimeType) {
            xhr.overrideMimeType('text/plain; charset=x-user-defined');
          }
  
          xhr.send(null);
          if (xhr.status != 200 && xhr.status != 0) success = false;
          if (xhr.response !== undefined) {
            obj.contents = new Uint8Array(xhr.response || []);
          } else {
            obj.contents = intArrayFromString(xhr.responseText || '', true);
          }
        } else if (typeof read !== 'undefined') {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(read(obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },ensureRoot:function () {
        if (FS.root) return;
        // The main file system tree. All the contents are inside this.
        FS.root = {
          read: true,
          write: true,
          isFolder: true,
          isDevice: false,
          timestamp: Date.now(),
          inodeNumber: 1,
          contents: {}
        };
      },init:function (input, output, error) {
        // Make sure we initialize only once.
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureRoot();
  
        // Default handlers.
        if (!input) input = function() {
          if (!input.cache || !input.cache.length) {
            var result;
            if (typeof window != 'undefined' &&
                typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
            }
            if (!result) result = '';
            input.cache = intArrayFromString(result + '\n', true);
          }
          return input.cache.shift();
        };
        if (!output) output = function(val) {
          if (val === null || val === '\n'.charCodeAt(0)) {
            output.printer(output.buffer.join(''));
            output.buffer = [];
          } else {
            output.buffer.push(String.fromCharCode(val));
          }
        };
        if (!output.printer) output.printer = print;
        if (!output.buffer) output.buffer = [];
        if (!error) error = output;
  
        // Create the temporary folder.
        FS.createFolder('/', 'tmp', true, true);
  
        // Create the I/O devices.
        var devFolder = FS.createFolder('/', 'dev', true, true);
        var stdin = FS.createDevice(devFolder, 'stdin', input);
        var stdout = FS.createDevice(devFolder, 'stdout', null, output);
        var stderr = FS.createDevice(devFolder, 'stderr', null, error);
        FS.createDevice(devFolder, 'tty', input, output);
  
        // Create default streams.
        FS.streams[1] = {
          path: '/dev/stdin',
          object: stdin,
          position: 0,
          isRead: true,
          isWrite: false,
          isAppend: false,
          error: false,
          eof: false,
          ungotten: []
        };
        FS.streams[2] = {
          path: '/dev/stdout',
          object: stdout,
          position: 0,
          isRead: false,
          isWrite: true,
          isAppend: false,
          error: false,
          eof: false,
          ungotten: []
        };
        FS.streams[3] = {
          path: '/dev/stderr',
          object: stderr,
          position: 0,
          isRead: false,
          isWrite: true,
          isAppend: false,
          error: false,
          eof: false,
          ungotten: []
        };
        _stdin = allocate([1], 'void*', ALLOC_STATIC);
        _stdout = allocate([2], 'void*', ALLOC_STATIC);
        _stderr = allocate([3], 'void*', ALLOC_STATIC);
  
        // Other system paths
        FS.createPath('/', 'dev/shm/tmp', true, true); // temp files
  
        // Newlib initialization
        FS.streams[_stdin] = FS.streams[1];
        FS.streams[_stdout] = FS.streams[2];
        FS.streams[_stderr] = FS.streams[3];
        __impure_ptr = allocate([ allocate(
          [0, 0, 0, 0, _stdin, 0, 0, 0, _stdout, 0, 0, 0, _stderr, 0, 0, 0],
          'void*', ALLOC_STATIC) ], 'void*', ALLOC_STATIC);
      },quit:function () {
        if (!FS.init.initialized) return;
        // Flush any partially-printed lines in stdout and stderr
        if (FS.streams[2].object.output.buffer.length > 0) FS.streams[2].object.output('\n'.charCodeAt(0));
        if (FS.streams[3].object.output.buffer.length > 0) FS.streams[3].object.output('\n'.charCodeAt(0));
      }};
  
  
  
  
  
  
  
  var ___dirent_struct_layout=null;function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      // NOTE: This implementation tries to mimic glibc rather that strictly
      // following the POSIX standard.
  
      var mode = HEAP32[((varargs)>>2)];
  
      // Simplify flags.
      var accessMode = oflag & 3;
      var isWrite = accessMode != 0;
      var isRead = accessMode != 1;
      var isCreate = Boolean(oflag & 512);
      var isExistCheck = Boolean(oflag & 2048);
      var isTruncate = Boolean(oflag & 1024);
      var isAppend = Boolean(oflag & 8);
  
      // Verify path.
      var origPath = path;
      path = FS.analyzePath(Pointer_stringify(path));
      if (!path.parentExists) {
        ___setErrNo(path.error);
        return -1;
      }
      var target = path.object || null;
      var finalPath;
  
      // Verify the file exists, create if needed and allowed.
      if (target) {
        if (isCreate && isExistCheck) {
          ___setErrNo(ERRNO_CODES.EEXIST);
          return -1;
        }
        if ((isWrite || isCreate || isTruncate) && target.isFolder) {
          ___setErrNo(ERRNO_CODES.EISDIR);
          return -1;
        }
        if (isRead && !target.read || isWrite && !target.write) {
          ___setErrNo(ERRNO_CODES.EACCES);
          return -1;
        }
        if (isTruncate && !target.isDevice) {
          target.contents = [];
        } else {
          if (!FS.forceLoadFile(target)) {
            ___setErrNo(ERRNO_CODES.EIO);
            return -1;
          }
        }
        finalPath = path.path;
      } else {
        if (!isCreate) {
          ___setErrNo(ERRNO_CODES.ENOENT);
          return -1;
        }
        if (!path.parentObject.write) {
          ___setErrNo(ERRNO_CODES.EACCES);
          return -1;
        }
        target = FS.createDataFile(path.parentObject, path.name, [],
                                   mode & 0x100, mode & 0x80);  // S_IRUSR, S_IWUSR.
        finalPath = path.parentPath + '/' + path.name;
      }
      // Actually create an open stream.
      var id = FS.streams.length;
      if (target.isFolder) {
        var entryBuffer = 0;
        if (___dirent_struct_layout) {
          entryBuffer = _malloc(___dirent_struct_layout.__size__);
        }
        var contents = [];
        for (var key in target.contents) contents.push(key);
        FS.streams[id] = {
          path: finalPath,
          object: target,
          // An index into contents. Special values: -2 is ".", -1 is "..".
          position: -2,
          isRead: true,
          isWrite: false,
          isAppend: false,
          error: false,
          eof: false,
          ungotten: [],
          // Folder-specific properties:
          // Remember the contents at the time of opening in an array, so we can
          // seek between them relying on a single order.
          contents: contents,
          // Each stream has its own area for readdir() returns.
          currentEntry: entryBuffer
        };
      } else {
        FS.streams[id] = {
          path: finalPath,
          object: target,
          position: 0,
          isRead: isRead,
          isWrite: isWrite,
          isAppend: isAppend,
          error: false,
          eof: false,
          ungotten: []
        };
      }
      return id;
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 512;
        flags |= 1024;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 512;
        flags |= 8;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var ret = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return (ret == -1) ? 0 : ret;
    }


  
  
  
  
  
  
  
  
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.streams[fildes];
      if (!stream || stream.object.isDevice) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      } else if (!stream.isWrite) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      } else if (stream.object.isFolder) {
        ___setErrNo(ERRNO_CODES.EISDIR);
        return -1;
      } else if (nbyte < 0 || offset < 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      } else {
        var contents = stream.object.contents;
        while (contents.length < offset) contents.push(0);
        for (var i = 0; i < nbyte; i++) {
          contents[offset + i] = HEAPU8[(buf+i)];
        }
        stream.object.timestamp = Date.now();
        return i;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.streams[fildes];
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      } else if (!stream.isWrite) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      } else if (nbyte < 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      } else {
        if (stream.object.isDevice) {
          if (stream.object.output) {
            for (var i = 0; i < nbyte; i++) {
              try {
                stream.object.output(HEAP8[(buf+i)]);
              } catch (e) {
                ___setErrNo(ERRNO_CODES.EIO);
                return -1;
              }
            }
            stream.object.timestamp = Date.now();
            return i;
          } else {
            ___setErrNo(ERRNO_CODES.ENXIO);
            return -1;
          }
        } else {
          var bytesWritten = _pwrite(fildes, buf, nbyte, stream.position);
          if (bytesWritten != -1) stream.position += bytesWritten;
          return bytesWritten;
        }
      }
    }function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var bytesWritten = _write(stream, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        if (FS.streams[stream]) FS.streams[stream].error = true;
        return -1;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }

  
  
  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      if (FS.streams[fildes]) {
        if (FS.streams[fildes].currentEntry) {
          _free(FS.streams[fildes].currentEntry);
        }
        delete FS.streams[fildes];
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }
  
  
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      if (FS.streams[fildes]) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      _fsync(stream);
      return _close(stream);
    }

  function _memcmp(p1, p2, num) {
      for (var i = 0; i < num; i++) {
        var v1 = HEAP8[(p1+i)];
        var v2 = HEAP8[(p2+i)];
        if (v1 != v2) return v1 > v2 ? 1 : -1;
      }
      return 0;
    }

  function _llvm_umul_with_overflow_i32(x, y) {
      return {
        f0: x*y,
        f1: 0 // We never overflow... for now
      };
    }


  
  
  
  var ___tm_struct_layout={__size__:44,tm_sec:0,tm_min:4,tm_hour:8,tm_mday:12,tm_mon:16,tm_year:20,tm_wday:24,tm_yday:28,tm_isdst:32,tm_gmtoff:36,tm_zone:40};
  
  var ___tm_current=0;
  
  
  
  var ___tm_timezones={};
  
  
  var __tzname=null;
  
  var __daylight=null;
  
  var __timezone=null;function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (__tzname) return; // glibc does not need the double __
  
      __timezone = _malloc(4);
      HEAP32[((__timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60
  
      __daylight = _malloc(4);
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((__daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset())
  
      var winterName = winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      __tzname = _malloc(2 * 4); // glibc does not need the double __
      HEAP32[((__tzname)>>2)]=winterNamePtr
      HEAP32[((__tzname+4)>>2)]=summerNamePtr
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var offsets = ___tm_struct_layout;
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr+offsets.tm_sec)>>2)]=date.getSeconds()
      HEAP32[((tmPtr+offsets.tm_min)>>2)]=date.getMinutes()
      HEAP32[((tmPtr+offsets.tm_hour)>>2)]=date.getHours()
      HEAP32[((tmPtr+offsets.tm_mday)>>2)]=date.getDate()
      HEAP32[((tmPtr+offsets.tm_mon)>>2)]=date.getMonth()
      HEAP32[((tmPtr+offsets.tm_year)>>2)]=date.getFullYear()-1900
      HEAP32[((tmPtr+offsets.tm_wday)>>2)]=date.getDay()
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[((tmPtr+offsets.tm_yday)>>2)]=yday
      HEAP32[((tmPtr+offsets.tm_gmtoff)>>2)]=start.getTimezoneOffset() * 60
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[((tmPtr+offsets.tm_isdst)>>2)]=dst
  
      var timezone = date.toString().match(/\(([A-Z]+)\)/)[1];
      if (!(timezone in ___tm_timezones)) {
        ___tm_timezones[timezone] = allocate(intArrayFromString(timezone), 'i8', ALLOC_NORMAL);
      }
      HEAP32[((tmPtr+offsets.tm_zone)>>2)]=___tm_timezones[timezone]
  
      return tmPtr;
    }function _localtime(time) {
      if (!___tm_current) ___tm_current = _malloc(___tm_struct_layout.__size__);
      return _localtime_r(time, ___tm_current);
    }
  
  
  
  var ___tm_formatted=0;
  
  
  
  
  function _mktime(tmPtr) {
      _tzset();
      var offsets = ___tm_struct_layout;
      var year = HEAP32[((tmPtr+offsets.tm_year)>>2)];
      var timestamp = new Date(year >= 1900 ? year : year + 1900,
                               HEAP32[((tmPtr+offsets.tm_mon)>>2)],
                               HEAP32[((tmPtr+offsets.tm_mday)>>2)],
                               HEAP32[((tmPtr+offsets.tm_hour)>>2)],
                               HEAP32[((tmPtr+offsets.tm_min)>>2)],
                               HEAP32[((tmPtr+offsets.tm_sec)>>2)],
                               0).getTime() / 1000;
      HEAP32[((tmPtr+offsets.tm_wday)>>2)]=new Date(timestamp).getDay()
      var yday = Math.round((timestamp - (new Date(year, 0, 1)).getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[((tmPtr+offsets.tm_yday)>>2)]=yday
      return timestamp;
    }function _asctime_r(tmPtr, buf) {
      var date = new Date(_mktime(tmPtr)*1000);
      var formatted = date.toString();
      var datePart = formatted.replace(/\d{4}.*/, '').replace(/ 0/, '  ');
      var timePart = formatted.match(/\d{2}:\d{2}:\d{2}/)[0];
      formatted = datePart + timePart + ' ' + date.getFullYear() + '\n';
      formatted.split('').forEach(function(chr, index) {
        HEAP8[(buf+index)]=chr.charCodeAt(0)
      });
      HEAP8[(buf+25)]=0
      return buf;
    }function _asctime(tmPtr) {
      if (!___tm_formatted) ___tm_formatted = _malloc(26);
      return _asctime_r(tmPtr, ___tm_formatted);
    }function _ctime(timer) {
      return _asctime(_localtime(timer));
    }

  
  function _isspace(chr) {
      return chr in { 32: 0, 9: 0, 10: 0, 11: 0, 12: 0, 13: 0 };
    }
  
  function _isdigit(chr) {
      return chr >= '0'.charCodeAt(0) && chr <= '9'.charCodeAt(0);
    }function _atoi(s) {
      var c;
      while ((c = HEAP8[(s)]) && _isspace(c)) s++;
      if (!c || !_isdigit(c)) return 0;
      var e = s;
      while ((c = HEAP8[(e)]) && _isdigit(c)) e++;
      return Math.floor(Number(Pointer_stringify(s).substr(0, e-s)));
    }

  function _isprint(chr) {
      return 0x1F < chr && chr < 0x7F;
    }

  
  
  var _vfprintf=_fprintf;

  function _llvm_eh_typeid_for(type) {
      return type;
    }

  function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      return ptr;
    }

  
  function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      __THREW__ = false;
      // Clear type.
      HEAP32[((_llvm_eh_exception.buf+4)>>2)]=0
      // Call destructor if one is registered then clear it.
      var ptr = HEAP32[((_llvm_eh_exception.buf)>>2)];
      var destructor = HEAP32[((_llvm_eh_exception.buf+8)>>2)];
      if (destructor) {
        FUNCTION_TABLE[destructor](ptr);
        HEAP32[((_llvm_eh_exception.buf+8)>>2)]=0
      }
      // Free ptr if it isn't null.
      if (ptr) {
        ___cxa_free_exception(ptr);
        HEAP32[((_llvm_eh_exception.buf)>>2)]=0
      }
    }


  function _tolower(chr) {
      if (chr >= 'A'.charCodeAt(0) && chr <= 'Z'.charCodeAt(0)) {
        return chr - 'A'.charCodeAt(0) + 'a'.charCodeAt(0);
      } else {
        return chr;
      }
    }

  
  var _vsnprintf=_snprintf;

  
  
  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == '-'.charCodeAt(0)) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == '+'.charCodeAt(0)) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == '0'.charCodeAt(0)) {
          if (HEAP8[(str+1)] == 'x'.charCodeAt(0) ||
              HEAP8[(str+1)] == 'X'.charCodeAt(0)) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        ret = [ret>>>0,Math.min(Math.floor((ret)/4294967296), 4294967295)];
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _llvm_uadd_with_overflow_i32(x, y) {
      return {
        f0: x+y,
        f1: 0 // We never overflow... for now
      };
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }


  function _toupper(chr) {
      if (chr >= 'a'.charCodeAt(0) && chr <= 'z'.charCodeAt(0)) {
        return chr - 'a'.charCodeAt(0) + 'A'.charCodeAt(0);
      } else {
        return chr;
      }
    }

  function _atof(ptr) {
      var str = Pointer_stringify(ptr);
      var ret = parseFloat(str);
      return isNaN(ret) ? 0 : ret;
    }

  
  function _memmove(dest, src, num, align) {
      if (src < dest && dest < src + num) {
        // Copy backwards in a safe manner
        src += num;
        dest += num;
        while (num--) {
          dest--;
          src--;
          HEAP8[(dest)]=HEAP8[(src)];
        }
      } else {
        _memcpy(dest, src, num, align);
      }
    }
  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      var flush = function(filedes) {
        // Right now we write all data directly, except for output devices.
        if (filedes in FS.streams && FS.streams[filedes].object.output) {
          FS.streams[filedes].object.output(null);
        }
      };
      try {
        if (stream === 0) {
          for (var i in FS.streams) flush(i);
        } else {
          flush(stream);
        }
        return 0;
      } catch (e) {
        ___setErrNo(ERRNO_CODES.EIO);
        return -1;
      }
    }

  function _feof(stream) {
      // int feof(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/feof.html
      return Number(stream in FS.streams && FS.streams[stream].eof);
    }

  
  
  
  
  
  
  
  
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.streams[fildes];
      if (!stream || stream.object.isDevice) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      } else if (!stream.isRead) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      } else if (stream.object.isFolder) {
        ___setErrNo(ERRNO_CODES.EISDIR);
        return -1;
      } else if (nbyte < 0 || offset < 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      } else {
        var bytesRead = 0;
        while (stream.ungotten.length && nbyte > 0) {
          HEAP8[(buf++)]=stream.ungotten.pop()
          nbyte--;
          bytesRead++;
        }
        var contents = stream.object.contents;
        var size = Math.min(contents.length - offset, nbyte);
        for (var i = 0; i < size; i++) {
          HEAP8[(buf+i)]=contents[offset + i]
          bytesRead++;
        }
        return bytesRead;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.streams[fildes];
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      } else if (!stream.isRead) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      } else if (nbyte < 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      } else {
        var bytesRead;
        if (stream.object.isDevice) {
          if (stream.object.input) {
            bytesRead = 0;
            while (stream.ungotten.length && nbyte > 0) {
              HEAP8[(buf++)]=stream.ungotten.pop()
              nbyte--;
              bytesRead++;
            }
            for (var i = 0; i < nbyte; i++) {
              try {
                var result = stream.object.input();
              } catch (e) {
                ___setErrNo(ERRNO_CODES.EIO);
                return -1;
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              HEAP8[(buf+i)]=result
            }
            return bytesRead;
          } else {
            ___setErrNo(ERRNO_CODES.ENXIO);
            return -1;
          }
        } else {
          var ungotSize = stream.ungotten.length;
          bytesRead = _pread(fildes, buf, nbyte, stream.position);
          if (bytesRead != -1) {
            stream.position += (stream.ungotten.length - ungotSize) + bytesRead;
          }
          return bytesRead;
        }
      }
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      if (!(stream in FS.streams)) return -1;
      var streamObj = FS.streams[stream];
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _read(stream, _fgetc.ret, 1);
      if (ret == 0) {
        streamObj.eof = true;
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAP8[(_fgetc.ret)];
      }
    }function _fgets(s, n, stream) {
      // char *fgets(char *restrict s, int n, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgets.html
      if (!(stream in FS.streams)) return 0;
      var streamObj = FS.streams[stream];
      if (streamObj.error || streamObj.eof) return 0;
      var byte_;
      for (var i = 0; i < n - 1 && byte_ != '\n'.charCodeAt(0); i++) {
        byte_ = _fgetc(stream);
        if (byte_ == -1) {
          if (streamObj.error) return 0;
          else if (streamObj.eof) break;
        }
        HEAP8[(s+i)]=byte_
      }
      HEAP8[(s+i)]=0
      return s;
    }

  function _strstr(ptr1, ptr2) {
      var str1 = Pointer_stringify(ptr1);
      var str2 = Pointer_stringify(ptr2);
      var ret = str1.search(str2);
      return ret >= 0 ? ptr1 + ret : 0;
    }

  function _strncpy(pdest, psrc, num) {
      var padding = false, curr;
      for (var i = 0; i < num; i++) {
        curr = padding ? 0 : HEAP8[(psrc+i)];
        HEAP8[(pdest+i)]=curr
        padding = padding || HEAP8[(psrc+i)] == 0;
      }
      return pdest;
    }


  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret
      }
      return ret;
    }


  
  
  
  
  
  function _gmtime_r(time, tmPtr) {
      var date = new Date(HEAP32[((time)>>2)]*1000);
      var offsets = ___tm_struct_layout;
      HEAP32[((tmPtr+offsets.tm_sec)>>2)]=date.getUTCSeconds()
      HEAP32[((tmPtr+offsets.tm_min)>>2)]=date.getUTCMinutes()
      HEAP32[((tmPtr+offsets.tm_hour)>>2)]=date.getUTCHours()
      HEAP32[((tmPtr+offsets.tm_mday)>>2)]=date.getUTCDate()
      HEAP32[((tmPtr+offsets.tm_mon)>>2)]=date.getUTCMonth()
      HEAP32[((tmPtr+offsets.tm_year)>>2)]=date.getUTCFullYear()-1900
      HEAP32[((tmPtr+offsets.tm_wday)>>2)]=date.getUTCDay()
      HEAP32[((tmPtr+offsets.tm_gmtoff)>>2)]=0
      HEAP32[((tmPtr+offsets.tm_isdst)>>2)]=0
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.round((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[((tmPtr+offsets.tm_yday)>>2)]=yday
  
      var timezone = "GMT";
      if (!(timezone in ___tm_timezones)) {
        ___tm_timezones[timezone] = allocate(intArrayFromString(timezone), 'i8', ALLOC_NORMAL);
      }
      HEAP32[((tmPtr+offsets.tm_zone)>>2)]=___tm_timezones[timezone]
  
      return tmPtr;
    }function _gmtime(time) {
      if (!___tm_current) ___tm_current = _malloc(___tm_struct_layout.__size__);
      return _gmtime_r(time, ___tm_current);
    }

  var _ceil=Math.ceil;

  var _floor=Math.floor;

  var _llvm_pow_f64=Math.pow;

  
  var ___rand_state=42;function _rand() {
      // int rand(void);
      ___rand_state = (1103515245 * ___rand_state + 12345) % 0x100000000;
      return ___rand_state & 0x7FFFFFFF;
    }

  var _llvm_memcpy_p0i8_p0i8_i64=_memcpy;

  
  function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      throw HEAP32[((_llvm_eh_exception.buf)>>2)];
    }

  var _fabs=Math.abs;

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }


  function _strtoul(str, endptr, base) {
      return __parseInt(str, endptr, base, 0, 4294967295, 32, true);  // ULONG_MAX.
    }

  var _sqrt=Math.sqrt;

  function _qsort(base, num, size, comparator) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      comparator = FUNCTION_TABLE[comparator];
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return comparator(base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _bsearch(key, base, num, size, compar) {
      var cmp = FUNCTION_TABLE[compar];
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
  
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _srand(seed) {
      // void srand(unsigned seed);
      ___rand_state = seed;
    }

  var _cos=Math.cos;

  var _atan=Math.atan;

  var _abs=Math.abs;

  function _strspn(pstr, pset) {
      var str = String_copy(pstr, true);
      var set = String_copy(pset);
      var i = 0;
      while (set.indexOf(str[i]) != -1) i++; // Must halt, as 0 is in str but not set
      return i;
    }


  
  
  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      if (stream in FS.streams) {
        stream = FS.streams[stream];
        if (stream.object.isDevice) {
          ___setErrNo(ERRNO_CODES.ESPIPE);
          return -1;
        } else {
          return stream.position;
        }
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }

  
  
  
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      if (FS.streams[fildes] && !FS.streams[fildes].isDevice) {
        var stream = FS.streams[fildes];
        var position = offset;
        if (whence === 1) {  // SEEK_CUR.
          position += stream.position;
        } else if (whence === 2) {  // SEEK_END.
          position += stream.object.contents.length;
        }
        if (position < 0) {
          ___setErrNo(ERRNO_CODES.EINVAL);
          return -1;
        } else {
          stream.ungotten = [];
          stream.position = position;
          return position;
        }
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var ret = _lseek(stream, offset, whence);
      if (ret == -1) {
        return -1;
      } else {
        FS.streams[stream].eof = false;
        return 0;
      }
    }

  
  function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) return 0;
      var bytesRead = _read(stream, ptr, bytesToRead);
      var streamObj = FS.streams[stream];
      if (bytesRead == -1) {
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        if (bytesRead < bytesToRead) streamObj.eof = true;
        return Math.floor(bytesRead / size);
      }
    }

  function _isalpha(chr) {
      return (chr >= 'a'.charCodeAt(0) && chr <= 'z'.charCodeAt(0)) ||
             (chr >= 'A'.charCodeAt(0) && chr <= 'Z'.charCodeAt(0));
    }

  
  
  
  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = FS.analyzePath(Pointer_stringify(path));
      if (!path.parentExists || !path.exists) {
        ___setErrNo(path.error);
        return -1;
      } else if (path.object.isFolder) {
        ___setErrNo(ERRNO_CODES.EISDIR);
        return -1;
      } else if (!path.object.write) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      } else {
        delete path.parentObject.contents[path.name];
        return 0;
      }
    }
  
  
  
  function _rmdir(path) {
      // int rmdir(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rmdir.html
      path = FS.analyzePath(Pointer_stringify(path));
      if (!path.parentExists || !path.exists) {
        ___setErrNo(path.error);
        return -1;
      } else if (!path.object.write || path.isRoot) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      } else if (!path.object.isFolder) {
        ___setErrNo(ERRNO_CODES.ENOTDIR);
        return -1;
      } else {
        for (var i in path.object.contents) {
          ___setErrNo(ERRNO_CODES.ENOTEMPTY);
          return -1;
        }
        if (path.path == FS.currentPath) {
          ___setErrNo(ERRNO_CODES.EBUSY);
          return -1;
        } else {
          delete path.parentObject.contents[path.name];
          return 0;
        }
      }
    }function _remove(path) {
      // int remove(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/remove.html
      var ret = _unlink(path);
      if (ret == -1) ret = _rmdir(path);
      return ret;
    }

  function _strdup(ptr) {
      var len = String_len(ptr);
      var newStr = _malloc(len + 1);
      _memcpy(newStr, ptr, len, 1);
      HEAP8[(newStr+len)]=0;
      return newStr;
    }

  function _clock() {
      if (_clock.start === undefined) _clock.start = Date.now();
      return Math.floor((Date.now() - _clock.start) * (1000/1000));
    }

  function _pthread_mutex_lock() {}

  function _pthread_mutex_unlock() {}

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function ___cxa_guard_abort() {}

  function ___cxa_guard_release() {}

  function _pthread_cond_broadcast() {}
var _pthread_cond_wait; // stub for _pthread_cond_wait

  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      if (stream in FS.streams) {
        c = unSign(c & 0xFF);
        FS.streams[stream].ungotten.push(c);
        return c;
      } else {
        return -1;
      }
    }

  
  
  var _getc=_fgetc;

  
  function ___errno_location() {
      return ___setErrNo.ret;
    }
  var ___errno=___errno_location;

  
  
  
  var ERRNO_MESSAGES={1:"Operation not permitted",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"Input/output error",6:"No such device or address",8:"Exec format error",9:"Bad file descriptor",10:"No child processes",11:"Resource temporarily unavailable",12:"Cannot allocate memory",13:"Permission denied",14:"Bad address",16:"Device or resource busy",17:"File exists",18:"Invalid cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Inappropriate ioctl for device",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read-only file system",31:"Too many links",32:"Broken pipe",33:"Numerical argument out of domain",34:"Numerical result out of range",35:"Resource deadlock avoided",36:"File name too long",37:"No locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many levels of symbolic links",42:"No message of desired type",43:"Identifier removed",60:"Device not a stream",61:"No data available",62:"Timer expired",63:"Out of streams resources",67:"Link has been severed",71:"Protocol error",72:"Multihop attempted",74:"Bad message",75:"Value too large for defined data type",84:"Invalid or incomplete multibyte or wide character",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Protocol not supported",95:"Operation not supported",97:"Address family not supported by protocol",98:"Address already in use",99:"Cannot assign requested address",100:"Network is down",101:"Network is unreachable",102:"Network dropped connection on reset",103:"Software caused connection abort",104:"Connection reset by peer",105:"No buffer space available",106:"Transport endpoint is already connected",107:"Transport endpoint is not connected",110:"Connection timed out",111:"Connection refused",113:"No route to host",114:"Operation already in progress",115:"Operation now in progress",116:"Stale NFS file handle",122:"Disk quota exceeded",125:"Operation canceled",130:"Owner died",131:"State not recoverable"};
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          for (var i = 0; i < msg.length; i++) {
            HEAP8[(strerrbuf+i)]=msg.charCodeAt(i)
          }
          HEAP8[(strerrbuf+i)]=0
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }

  function _abort(code) {
      ABORT = true;
      throw 'ABORT: ' + code + ', at ' + (new Error().stack);
    }
var _wmemmove; // stub for _wmemmove
var _wmemset; // stub for _wmemset
var _wmemcpy; // stub for _wmemcpy
var _wcslen; // stub for _wcslen
var _isxdigit_l; // stub for _isxdigit_l
var _isdigit_l; // stub for _isdigit_l
var __Z7catopenPKci; // stub for __Z7catopenPKci
var __Z7catgetsP8_nl_catdiiPKc; // stub for __Z7catgetsP8_nl_catdiiPKc
var __Z8catcloseP8_nl_catd; // stub for __Z8catcloseP8_nl_catd

  function _newlocale(mask, locale, base) {
      return 0;
    }
var _freelocale; // stub for _freelocale
var _strftime_l; // stub for _strftime_l
var _strtold_l; // stub for _strtold_l

  
  function _strtoull(str, endptr, base) {
      return __parseInt(str, endptr, base, 0, 18446744073709551615, 64, true);  // ULONG_MAX; imprecise.
    }
  var _strtoull_l=_strtoull;

  
  function _strtoll(str, endptr, base) {
      return __parseInt(str, endptr, base, -9223372036854775200, 9223372036854775200, 64);  // LLONG_MIN, LLONG_MAX; imprecise.
    }
  var _strtoll_l=_strtoll;

  function _uselocale(locale) {
      return 0;
    }
var _mbsrtowcs; // stub for _mbsrtowcs
var _mbrlen; // stub for _mbrlen
var ___locale_mb_cur_max; // stub for ___locale_mb_cur_max

  function _mbtowc(pwc, pmb, maxx) {
      // XXX doesn't really handle multibyte at all
      if (!pmb) return 0;
      maxx = Math.min(85, maxx);
      var i;
      for (i = 0; i < maxx; i++) {
        var curr = HEAP8[(pmb)];
        if (pwc) {
          HEAP8[(pwc)]=curr;
          HEAP8[(pwc+1)]=0;
          pwc += 2;
        }
        pmb++;
        if (!curr) break;
      }
      return i;
    }
var _mbrtowc; // stub for _mbrtowc
var _mbsnrtowcs; // stub for _mbsnrtowcs

  function _wcrtomb(s, wc, ps) {
      // XXX doesn't really handle multibyte at all
      if (s) {
        HEAP8[(s)]=wc;
      }
      return 1;
    }
var _wcsnrtombs; // stub for _wcsnrtombs
var _vasprintf; // stub for _vasprintf

  
  var _vsscanf=_sscanf;
var __ZNSt9type_infoD2Ev; // stub for __ZNSt9type_infoD2Ev

  var _llvm_memset_p0i8_i64=_memset;
var _llvm_dbg_declare; // stub for _llvm_dbg_declare

  
  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 8: return PAGE_SIZE;
        case 54:
        case 56:
        case 21:
        case 61:
        case 63:
        case 22:
        case 67:
        case 23:
        case 24:
        case 25:
        case 26:
        case 27:
        case 69:
        case 28:
        case 101:
        case 70:
        case 71:
        case 29:
        case 30:
        case 199:
        case 75:
        case 76:
        case 32:
        case 43:
        case 44:
        case 80:
        case 46:
        case 47:
        case 45:
        case 48:
        case 49:
        case 42:
        case 82:
        case 33:
        case 7:
        case 108:
        case 109:
        case 107:
        case 112:
        case 119:
        case 121:
          return 200809;
        case 13:
        case 104:
        case 94:
        case 95:
        case 34:
        case 35:
        case 77:
        case 81:
        case 83:
        case 84:
        case 85:
        case 86:
        case 87:
        case 88:
        case 89:
        case 90:
        case 91:
        case 94:
        case 95:
        case 110:
        case 111:
        case 113:
        case 114:
        case 115:
        case 116:
        case 117:
        case 118:
        case 120:
        case 40:
        case 16:
        case 79:
        case 19:
          return -1;
        case 92:
        case 93:
        case 5:
        case 72:
        case 6:
        case 74:
        case 92:
        case 93:
        case 96:
        case 97:
        case 98:
        case 99:
        case 102:
        case 103:
        case 105:
          return 1;
        case 38:
        case 66:
        case 50:
        case 51:
        case 4:
          return 1024;
        case 15:
        case 64:
        case 41:
          return 32;
        case 55:
        case 37:
        case 17:
          return 2147483647;
        case 18:
        case 1:
          return 47839;
        case 59:
        case 57:
          return 99;
        case 68:
        case 58:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 14: return 32768;
        case 73: return 32767;
        case 39: return 16384;
        case 60: return 1000;
        case 106: return 700;
        case 52: return 256;
        case 62: return 255;
        case 2: return 100;
        case 65: return 64;
        case 36: return 20;
        case 100: return 16;
        case 20: return 6;
        case 53: return 4;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
  
      // We need to make sure no one else allocates unfreeable memory!
      // We must control this entirely. So we don't even need to do
      // unfreeable allocations - the HEAP is ours, from STATICTOP up.
      // TODO: We could in theory slice off the top of the HEAP when
      //       sbrk gets a negative increment in |bytes|...
      var self = _sbrk;
      if (!self.called) {
        STATICTOP = alignMemoryPage(STATICTOP); // make sure we start out aligned
        self.called = true;
      }
      var ret = STATICTOP;
      if (bytes != 0) Runtime.staticAlloc(bytes);
      return ret;  // Previous break location.
    }




_llvm_eh_exception.buf = allocate(12, "void*", ALLOC_STATIC);
__ATINIT__.unshift({ func: function() { FS.ignorePermissions = false; if (!FS.init.initialized) FS.init() } });__ATEXIT__.push({ func: function() { FS.quit() } });
___setErrNo(0);
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);

// === Auto-generated postamble setup entry stuff ===

Module.callMain = function callMain(args) {
  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_STATIC) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_STATIC));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_STATIC);

  return _main(argc, argv, 0);
}



var __ZN11driver_list16s_drivers_sortedE;
var __ZN11driver_list14s_driver_countE;

var __ZTV20resource_pool_objectI13driver_deviceE;


var __ZTI18resource_pool_item;
var __ZTI20resource_pool_objectI13driver_deviceE;
var __ZTV18resource_pool_item;
var __ZL18tms9928a_interface;




var __ZL10rom_coleco;


var __ZL11rom_colecoa;


var __ZL11rom_colecob;






var _driver_coleco;


var _driver_colecoa;




var _driver_colecob;
var __ZTV12coleco_state;

var __ZTI12coleco_state;











var __ZTI13emu_exception;
var __ZTI14emu_fatalerror;
var __ZTV14emu_fatalerror;
var __ZTV13emu_exception;
var __ZL11DEVICE_SELF;









var __ZTI18delegate_late_bind;

var __ZTVN8device_t15required_deviceI10cpu_deviceEE;


var __ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE;
var __ZTIN8device_t15required_deviceI10cpu_deviceEE;

var __ZTVN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE;
var __ZTV20resource_pool_objectI12coleco_stateE;

var __ZTI20resource_pool_objectI12coleco_stateE;













































































var __ZTV18mini_osd_interface;
var __ZL10our_target;

var __ZL15keyboard_device;


var __ZL14keyboard_state;









var __ZTI18mini_osd_interface;


var __ZTV12i8748_device;
var _I8748;
var __ZTV12i8049_device;
var _I8049;

var __ZTI12i8049_device;

var __ZTI12i8748_device;

var __ZTV20resource_pool_objectI12i8049_deviceE;

var __ZTI20resource_pool_objectI12i8049_deviceE;
var __ZTV20resource_pool_objectI12i8748_deviceE;

var __ZTI20resource_pool_objectI12i8748_deviceE;









var __ZL12opcode_table;










































var __ZTI15running_machine;











var __ZTV10z80_device;
var _Z80;

var __ZTI10z80_device;

var __ZTV20resource_pool_objectI10z80_deviceE;

var __ZTI20resource_pool_objectI10z80_deviceE;
var __ZL9SZHVC_sub;
var __ZL5Z80fd;

var __ZL7Z80xycb;
var __ZL6SZ_BIT;
var __ZL3SZP;
var __ZL9SZHVC_add;
var __ZL8SZHV_dec;
var __ZL8SZHV_inc;
var __ZL5Z80ed;

var __ZL2SZ;
var __ZL5Z80dd;
var __ZL5Z80cb;




























































var __ZTV19resource_pool_arrayIhE;

var __ZTI19resource_pool_arrayIhE;
var __ZTV25device_z80daisy_interface;





var __ZTI25device_z80daisy_interface;
var __ZTV20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE;

var __ZTI20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE;































































































































































































var __ZL8charinfo;






































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































var __ZL26input_port_default_strings;

var __ZL11DEVICE_SELF431;





var __ZTV20resource_pool_objectI20input_setting_configE;

var __ZTI20resource_pool_objectI20input_setting_configE;
var __ZTV20resource_pool_objectI18input_field_configE;

var __ZTI20resource_pool_objectI18input_field_configE;
var __ZTV20resource_pool_objectI17input_port_configE;

var __ZTI20resource_pool_objectI17input_port_configE;

var __ZTV11simple_listI23input_field_diplocationE;

var __ZTI11simple_listI23input_field_diplocationE;
var __ZTV11simple_listI20input_setting_configE;

var __ZTI11simple_listI20input_setting_configE;
var __ZTV11simple_listI18input_field_configE;

var __ZTI11simple_listI18input_field_configE;
var __ZTV20resource_pool_objectI19_input_port_privateE;

var __ZTI20resource_pool_objectI19_input_port_privateE;
var __ZTV11simple_listI16input_type_entryE;

var __ZTI11simple_listI16input_type_entryE;
var __ZTV20resource_pool_objectI16input_type_entryE;

var __ZTI20resource_pool_objectI16input_type_entryE;




var __str1366;


var __ZZL17code_point_stringR15running_machinejE3buf;






var __ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes;


















var __ZTV20resource_pool_objectI11_key_bufferE;

var __ZTI20resource_pool_objectI11_key_bufferE;
var __ZTV19resource_pool_arrayI12_inputx_codeE;

var __ZTI19resource_pool_arrayI12_inputx_codeE;




var __ZTV20resource_pool_objectI8emu_fileE;

var __ZTI20resource_pool_objectI8emu_fileE;

























var __ZL14seqtypestrings;



var __ZZL25input_field_type_to_tokenR15running_machineiiE7tempbuf;




var __ZTV19resource_pool_arrayI10input_codeE;

var __ZTI19resource_pool_arrayI10input_codeE;































var __ZTV19resource_pool_arrayIcE;

var __ZTI19resource_pool_arrayIcE;


var __ZZL15inputx_key_namejE3buf;

var __ZTV20resource_pool_objectI18_device_field_infoE;

var __ZTI20resource_pool_objectI18_device_field_infoE;

var __ZTV20resource_pool_objectI19_analog_field_stateE;

var __ZTI20resource_pool_objectI19_analog_field_stateE;
var __ZTV20resource_pool_objectI18_input_field_stateE;

var __ZTI20resource_pool_objectI18_input_field_stateE;
var __ZTV20resource_pool_objectI17_input_port_stateE;

var __ZTI20resource_pool_objectI17_input_port_stateE;
















































































































var __ZL13print_verbose;
var __ZL14global_machine;
var __ZL13started_empty;
var __ZL9output_cb;
var __ZL15output_cb_param;
var __impure_ptr;




var __ZL3tms;
var __ZL16TMS9928A_palette;
var __ZL12ModeHandlers;
var __ZL5sIntf;



















var __ZTV20resource_pool_objectI8bitmap_tE;

var __ZTI20resource_pool_objectI8bitmap_tE;

var __ZZL15change_registerR15running_machineihE5modes;










var _TIMER;

var __ZTV12timer_device;












var __ZTI12timer_device;

var __ZTV20resource_pool_objectI12timer_deviceE;

var __ZTI20resource_pool_objectI12timer_deviceE;



var __ZTV15cartslot_device;
var _CARTSLOT;

var __ZTI15cartslot_device;

var __ZTV20resource_pool_objectI15cartslot_deviceE;

var __ZTI20resource_pool_objectI15cartslot_deviceE;








var _SOFTWARE_LIST;









var __ZTV20software_list_device;

var __ZTI20software_list_device;

var __ZTV20resource_pool_objectI20software_list_deviceE;

var __ZTI20resource_pool_objectI20software_list_deviceE;
var __ZTV20resource_pool_objectI12feature_listE;

var __ZTI20resource_pool_objectI12feature_listE;
var __ZTV20resource_pool_objectI13software_partE;

var __ZTI20resource_pool_objectI13software_partE;
var __ZTV20resource_pool_objectI13software_infoE;

var __ZTI20resource_pool_objectI13software_infoE;
var __ZTV19resource_pool_arrayIiE;

var __ZTI19resource_pool_arrayIiE;



















































var __str651733;









var _global_resource_pool;
var ___dso_handle;
var _zeromem;
var __ZN12memory_entry7s_curidE;
var __ZN12memory_entry6s_lockE;
var __ZN12memory_entry12s_lock_allocE;
var __ZN12memory_entry10s_trackingE;
var __ZN12memory_entry6s_hashE;
var __ZN12memory_entry10s_freeheadE;



__ATINIT__ = __ATINIT__.concat([
  { func: __GLOBAL__I_a },
  { func: __GLOBAL__I_a2487 },
  { func: __GLOBAL__I_a2842 },
  { func: __GLOBAL__I_a3379 },
  { func: __GLOBAL__I_a3574 },
  { func: __GLOBAL__I_a4036 },
  { func: __GLOBAL__I_a4608 },
  { func: __GLOBAL__I_a4702 },
  { func: __GLOBAL__I_a5328 },
  { func: __GLOBAL__I_a7177 },
  { func: __GLOBAL__I_a1780 },
  { func: __GLOBAL__I_a285 }
]);













































var __ZN11cli_options16s_option_entriesE;
var __ZTV11cli_options;







var __str511814;











































































































var __ZZN12cli_frontend16execute_commandsEPKcE13info_commands;




















var __ZZN16media_identifier13identify_fileEPKcE8nullhash;









var __ZTI11emu_options;
var __ZTI11cli_options;
var __ZTV19resource_pool_arrayI7astringE;

var __ZTI19resource_pool_arrayI7astringE;
var __ZTV11simple_listI12audit_recordE;

var __ZTI11simple_listI12audit_recordE;




var __ZTV11simple_listI8device_tE;

var __ZTI11simple_listI8device_tE;
var __ZL22temp_string_pool_index;
var __ZL16temp_string_pool;





var __ZTI27device_missing_dependencies;



var __ZTV8device_t;






var __ZTVN8device_t16auto_finder_baseE;
var __ZTV16device_interface;

var __ZTI8device_t;

var __ZTIN8device_t16auto_finder_baseE;

var __ZTI16device_interface;
var __ZTV20resource_pool_objectI12device_debugE;

var __ZTI20resource_pool_objectI12device_debugE;


var __ZTI11tagged_listI8device_tE;
var __ZTI11device_list;
var __ZTV18delegate_late_bind;



var __ZTV20resource_pool_objectI18address_map_entry8E;

var __ZTI20resource_pool_objectI18address_map_entry8E;
var __ZTV11simple_listI17address_map_entryE;

var __ZTI11simple_listI17address_map_entryE;
var __ZL11DEVICE_SELF2076;































var __ZN22device_image_interface19m_device_info_arrayE;
var __ZTV22device_image_interface;
var __str302123;
var __ZL8messages;



















var __ZTI22device_image_interface;








var __ZTV23device_memory_interface;














var __ZTI23device_memory_interface;
var __ZTV20resource_pool_objectI11address_mapE;

var __ZTI20resource_pool_objectI11address_mapE;
var __ZN9input_seq8end_codeE;
var __ZN9input_seq12default_codeE;
var __ZN9input_seq8not_codeE;
var __ZN9input_seq7or_codeE;
var __ZN9input_seq9empty_seqE;







































































































































































































var __ZL18itemid_token_table;



















var __ZL21devclass_string_table;

var __str2182416;
var __ZL21modifier_string_table;

var __ZL20devclass_token_table;

var __ZL20modifier_token_table;
var __ZL21itemclass_token_table;









var __ZTV17input_device_item;
var __ZTV24input_device_switch_item;
var __ZTV26input_device_relative_item;
var __ZTV26input_device_absolute_item;


var __ZTI17input_device_item;
var __ZTI24input_device_switch_item;

var __ZTI26input_device_relative_item;

var __ZTI26input_device_absolute_item;
var __ZTV20resource_pool_objectI12input_deviceE;

var __ZTI20resource_pool_objectI12input_deviceE;

var __ZTI11input_class;
var __ZTV20resource_pool_objectI26input_device_absolute_itemE;

var __ZTI20resource_pool_objectI26input_device_absolute_itemE;
var __ZTV20resource_pool_objectI26input_device_relative_itemE;

var __ZTI20resource_pool_objectI26input_device_relative_itemE;
var __ZTV20resource_pool_objectI24input_device_switch_itemE;

var __ZTI20resource_pool_objectI24input_device_switch_itemE;


















































var __str202508;

















var __ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes;

















var __ZTI16expression_error;


var __ZTV20resource_pool_objectIN12device_debug6tracerEE;

var __ZTI20resource_pool_objectIN12device_debug6tracerEE;
var __ZTV20resource_pool_objectIN12device_debug12dasm_commentEE;

var __ZTI20resource_pool_objectIN12device_debug12dasm_commentEE;
var __ZTV19resource_pool_arrayIN12device_debug13hotspot_entryEE;

var __ZTI19resource_pool_arrayIN12device_debug13hotspot_entryEE;
var __ZTV20resource_pool_objectIN12device_debug10watchpointEE;

var __ZTI20resource_pool_objectIN12device_debug10watchpointEE;
var __ZTV20resource_pool_objectIN12device_debug10breakpointEE;

var __ZTI20resource_pool_objectIN12device_debug10breakpointEE;
var __ZTV11simple_listIN12device_debug12dasm_commentEE;

var __ZTI11simple_listIN12device_debug12dasm_commentEE;
var __ZTV20resource_pool_objectI12symbol_tableE;

var __ZTI20resource_pool_objectI12symbol_tableE;
var __ZTV20resource_pool_objectI17_debugcpu_privateE;

var __ZTI20resource_pool_objectI17_debugcpu_privateE;
var __ZTV11simple_listIN17parsed_expression11parse_tokenEE;

var __ZTI11simple_listIN17parsed_expression11parse_tokenEE;
var __ZTV11simple_listIN17parsed_expression17expression_stringEE;

var __ZTI11simple_listIN17parsed_expression17expression_stringEE;

var __ZTV11simple_listI12symbol_entryE;

var __ZTI11simple_listI12symbol_entryE;














var __ZTV20resource_pool_objectIN12save_manager11state_entryEE;

var __ZTI20resource_pool_objectIN12save_manager11state_entryEE;
var __ZTV20resource_pool_objectIN12save_manager14state_callbackEE;

var __ZTI20resource_pool_objectIN12save_manager14state_callbackEE;
var __ZTV11simple_listIN12save_manager14state_callbackEE;

var __ZTI11simple_listIN12save_manager14state_callbackEE;
var __ZTV11simple_listIN12save_manager11state_entryEE;

var __ZTI11simple_listIN12save_manager11state_entryEE;
var __ZL19giant_string_buffer;














var __str142593;




















var __ZTV13driver_device;



var __ZTI13driver_device;
var __ZTV20resource_pool_objectIN15running_machine22logerror_callback_itemEE;

var __ZTI20resource_pool_objectIN15running_machine22logerror_callback_itemEE;
var __ZTV20resource_pool_objectIN15running_machine22notifier_callback_itemEE;

var __ZTI20resource_pool_objectIN15running_machine22notifier_callback_itemEE;
var __ZTV20resource_pool_objectI13memory_regionE;

var __ZTI20resource_pool_objectI13memory_regionE;

var __ZTV20resource_pool_objectI13cheat_managerE;

var __ZTI20resource_pool_objectI13cheat_managerE;
var __ZTV11simple_listI11cheat_entryE;

var __ZTI11simple_listI11cheat_entryE;
var __ZTV20resource_pool_objectI13sound_managerE;

var __ZTI20resource_pool_objectI13sound_managerE;
var __ZTV20resource_pool_objectI13video_managerE;

var __ZTI20resource_pool_objectI13video_managerE;
var __ZTV20resource_pool_objectI14render_managerE;

var __ZTI20resource_pool_objectI14render_managerE;
var __ZTV20resource_pool_objectI13input_managerE;

var __ZTI20resource_pool_objectI13input_managerE;
var __ZTV11simple_listIN15running_machine22logerror_callback_itemEE;

var __ZTI11simple_listIN15running_machine22logerror_callback_itemEE;
var __ZTV11simple_listIN15running_machine22notifier_callback_itemEE;

var __ZTI11simple_listIN15running_machine22notifier_callback_itemEE;
var __ZTV11simple_listI17input_port_configE;

var __ZTI11simple_listI17input_port_configE;
var __ZTV11simple_listI13memory_regionE;

var __ZTI11simple_listI13memory_regionE;
var __ZTV27device_missing_dependencies;







var __ZTV13osd_interface;

var __ZTI13osd_interface;
var __ZZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePvE5color;





var __ZZN13render_target20compute_minimum_sizeERiS0_E9vectorvis;








var __ZL18oriented_texcoords;
























var __ZTV20resource_pool_objectI11render_fontE;

var __ZTI20resource_pool_objectI11render_fontE;
var __ZTV20resource_pool_objectI14render_textureE;

var __ZTI20resource_pool_objectI14render_textureE;
var __ZTV20resource_pool_objectI13render_targetE;

var __ZTI20resource_pool_objectI13render_targetE;

var __ZTI14render_manager;
var __ZTV11simple_listI13render_targetE;

var __ZTI11simple_listI13render_targetE;
var __ZTV20resource_pool_objectI16render_containerE;

var __ZTI20resource_pool_objectI16render_containerE;
var __ZTV11simple_listI14render_textureE;

var __ZTI11simple_listI14render_textureE;
var __ZTV20resource_pool_objectI11layout_fileE;

var __ZTI20resource_pool_objectI11layout_fileE;
var __ZTV11simple_listI16render_containerE;

var __ZTI11simple_listI16render_containerE;
var __ZTV20resource_pool_objectI11simple_listI11layout_fileEE;

var __ZTI20resource_pool_objectI11simple_listI11layout_fileEE;
var __ZTV11simple_listI11layout_fileE;

var __ZTI11simple_listI11layout_fileE;
var __ZTV20resource_pool_objectIN16render_container4itemEE;

var __ZTI20resource_pool_objectIN16render_container4itemEE;
var __ZTV11simple_listIN16render_container4itemEE;

var __ZTI11simple_listIN16render_container4itemEE;
var __ZTV19resource_pool_arrayIjE;

var __ZTI19resource_pool_arrayIjE;
var __ZTV11simple_listIN21render_primitive_list9referenceEE;

var __ZTI11simple_listIN21render_primitive_list9referenceEE;
var __ZTV11simple_listI16render_primitiveE;

var __ZTI11simple_listI16render_primitiveE;

var __ZTV20resource_pool_objectI16render_primitiveE;

var __ZTI20resource_pool_objectI16render_primitiveE;
var __ZL20layer_order_standard;
var __ZL21layer_order_alternate;












var __ZTV20resource_pool_objectIN21render_primitive_list9referenceEE;

var __ZTI20resource_pool_objectIN21render_primitive_list9referenceEE;
var _SCREEN;
var __ZN13screen_device20DEFAULT_FRAME_PERIODE;

var __ZTV13screen_device;



































var __ZTI13screen_device;
var __ZTV20resource_pool_objectIN13screen_device13callback_itemEE;

var __ZTI20resource_pool_objectIN13screen_device13callback_itemEE;


var __ZTV11simple_listIN13screen_device13callback_itemEE;

var __ZTI11simple_listIN13screen_device13callback_itemEE;

var __ZTV20resource_pool_objectI13screen_deviceE;

var __ZTI20resource_pool_objectI13screen_deviceE;
























var __ZTV20resource_pool_objectIN16device_scheduler12quantum_slotEE;

var __ZTI20resource_pool_objectIN16device_scheduler12quantum_slotEE;
var __ZTV11simple_listI9emu_timerE;

var __ZTI11simple_listI9emu_timerE;

var __ZTI16device_scheduler;

var __ZTV20resource_pool_objectI9emu_timerE;

var __ZTI20resource_pool_objectI9emu_timerE;
var __ZTV11simple_listIN16device_scheduler12quantum_slotEE;

var __ZTI11simple_listIN16device_scheduler12quantum_slotEE;
var __ZN13address_table18s_watchpoint_tableE;




var __ZTV13address_space;














var __ZTV13address_table;












var __ZZNK13address_table12handler_nameEhE7strings;
































































































































var __ZZNK13address_table12handler_nameEhE4desc;

var __ZTV18address_table_read;












var __ZTV19address_table_write;






















var __ZTV13handler_entry;



var __ZTI13address_space;

var __ZTI13handler_entry;
var __ZTV18handler_entry_read;

var __ZTI18handler_entry_read;
var __ZTV19handler_entry_write;

var __ZTI19handler_entry_write;

var __ZTI13address_table;

var __ZTI18address_table_read;

var __ZTI19address_table_write;
var __ZTV20resource_pool_objectIN11memory_bank14bank_referenceEE;

var __ZTI20resource_pool_objectIN11memory_bank14bank_referenceEE;
var __ZTV11simple_listIN11memory_bank14bank_referenceEE;

var __ZTI11simple_listIN11memory_bank14bank_referenceEE;
var __ZTV20resource_pool_objectIN16direct_read_data12direct_rangeEE;

var __ZTI20resource_pool_objectIN16direct_read_data12direct_rangeEE;
var __ZTV11simple_listIN16direct_read_data12direct_rangeEE;

var __ZTI11simple_listIN16direct_read_data12direct_rangeEE;

var __ZTV20resource_pool_objectI19handler_entry_writeE;

var __ZTI20resource_pool_objectI19handler_entry_writeE;

var __ZTV20resource_pool_objectI18handler_entry_readE;

var __ZTI20resource_pool_objectI18handler_entry_readE;
var __ZTV19resource_pool_arrayIN13address_table13subtable_dataEE;

var __ZTI19resource_pool_arrayIN13address_table13subtable_dataEE;
var __ZTV20resource_pool_objectI11memory_bankE;

var __ZTI20resource_pool_objectI11memory_bankE;
var __ZTV20resource_pool_objectI12memory_blockE;

var __ZTI20resource_pool_objectI12memory_blockE;
var __ZTV20resource_pool_objectI12memory_shareE;

var __ZTI20resource_pool_objectI12memory_shareE;
var __ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE;
var __ZTV22address_space_specificIyL12endianness_t1ELb0EE;

var __ZTI22address_space_specificIyL12endianness_t1ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE;
var __ZTV22address_space_specificIyL12endianness_t1ELb1EE;

var __ZTI22address_space_specificIyL12endianness_t1ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE;
var __ZTV22address_space_specificIyL12endianness_t0ELb0EE;

var __ZTI22address_space_specificIyL12endianness_t0ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE;
var __ZTV22address_space_specificIyL12endianness_t0ELb1EE;

var __ZTI22address_space_specificIyL12endianness_t0ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE;
var __ZTV22address_space_specificIjL12endianness_t1ELb0EE;

var __ZTI22address_space_specificIjL12endianness_t1ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE;
var __ZTV22address_space_specificIjL12endianness_t1ELb1EE;

var __ZTI22address_space_specificIjL12endianness_t1ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE;
var __ZTV22address_space_specificIjL12endianness_t0ELb0EE;

var __ZTI22address_space_specificIjL12endianness_t0ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE;
var __ZTV22address_space_specificIjL12endianness_t0ELb1EE;

var __ZTI22address_space_specificIjL12endianness_t0ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE;
var __ZTV22address_space_specificItL12endianness_t1ELb0EE;

var __ZTI22address_space_specificItL12endianness_t1ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE;
var __ZTV22address_space_specificItL12endianness_t1ELb1EE;

var __ZTI22address_space_specificItL12endianness_t1ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE;
var __ZTV22address_space_specificItL12endianness_t0ELb0EE;

var __ZTI22address_space_specificItL12endianness_t0ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE;
var __ZTV22address_space_specificItL12endianness_t0ELb1EE;

var __ZTI22address_space_specificItL12endianness_t0ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE;
var __ZTV22address_space_specificIhL12endianness_t1ELb0EE;

var __ZTI22address_space_specificIhL12endianness_t1ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE;
var __ZTV22address_space_specificIhL12endianness_t1ELb1EE;

var __ZTI22address_space_specificIhL12endianness_t1ELb1EE;
var __ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE;

var __ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE;
var __ZTV22address_space_specificIhL12endianness_t0ELb0EE;

var __ZTI22address_space_specificIhL12endianness_t0ELb0EE;
var __ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE;

var __ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE;
var __ZTV22address_space_specificIhL12endianness_t0ELb1EE;

var __ZTI22address_space_specificIhL12endianness_t0ELb1EE;
var __ZTV20resource_pool_objectI16direct_read_dataE;

var __ZTI20resource_pool_objectI16direct_read_dataE;
var __ZTV20resource_pool_objectI15_memory_privateE;

var __ZTI20resource_pool_objectI15_memory_privateE;
var __ZTV11simple_listI13address_spaceE;

var __ZTI11simple_listI13address_spaceE;
var __ZTV11simple_listI12memory_blockE;

var __ZTI11simple_listI12memory_blockE;
var __ZTV11simple_listI11memory_bankE;

var __ZTI11simple_listI11memory_bankE;
var __ZTV10cpu_device;

var __ZTV17legacy_cpu_device;















var __ZTI10cpu_device;

var __ZTI17legacy_cpu_device;
var __ZN18device_state_entry17k_decimal_divisorE;
















var __ZTV22device_state_interface;

var __str153214;



var __ZTI22device_state_interface;
var __ZTV20resource_pool_objectI18device_state_entryE;

var __ZTI20resource_pool_objectI18device_state_entryE;
var __ZTV11simple_listI18device_state_entryE;

var __ZTI11simple_listI18device_state_entryE;

var __ZTV18legacy_device_base;


var __ZTV24legacy_sound_device_base;


var __ZTI18legacy_device_base;

var __ZTI24legacy_sound_device_base;
var __ZTV24device_execute_interface;






























var __ZTI24device_execute_interface;

var __ZN8attotime4zeroE;
var __ZN8attotime5neverE;
var __ZZNK8attotime9as_stringEiE7buffers;
var __ZZNK8attotime9as_stringEiE7nextbuf;






var __ZL12rom____empty;






var _driver____empty;










































































































































var __ZTV20resource_pool_objectI11cheat_entryE;

var __ZTI20resource_pool_objectI11cheat_entryE;

var __ZTI13cheat_manager;
var __ZTV20resource_pool_objectI12cheat_scriptE;

var __ZTI20resource_pool_objectI12cheat_scriptE;
var __ZTV20resource_pool_objectI15cheat_parameterE;

var __ZTI20resource_pool_objectI15cheat_parameterE;
var __ZTV20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE;

var __ZTI20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE;
var __ZTV11simple_listIN12cheat_script12script_entry15output_argumentEE;

var __ZTI11simple_listIN12cheat_script12script_entry15output_argumentEE;
var __ZTV20resource_pool_objectIN12cheat_script12script_entryEE;

var __ZTI20resource_pool_objectIN12cheat_script12script_entryEE;
var __ZTV11simple_listIN12cheat_script12script_entryEE;

var __ZTI11simple_listIN12cheat_script12script_entryEE;
var __ZTV20resource_pool_objectIN15cheat_parameter4itemEE;

var __ZTI20resource_pool_objectIN15cheat_parameter4itemEE;
var __ZTV11simple_listIN15cheat_parameter4itemEE;

var __ZTI11simple_listIN15cheat_parameter4itemEE;





var __ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE;

























var __ZTV20resource_pool_objectI12sound_streamE;

var __ZTI20resource_pool_objectI12sound_streamE;

var __ZTI13sound_manager;
var __ZTV19resource_pool_arrayIsE;

var __ZTI19resource_pool_arrayIsE;
var __ZTV11simple_listI12sound_streamE;

var __ZTI11simple_listI12sound_streamE;

var __ZTI12sound_stream;
var __ZTV19resource_pool_arrayIN12sound_stream13stream_outputEE;

var __ZTI19resource_pool_arrayIN12sound_stream13stream_outputEE;
var __ZTV19resource_pool_arrayIPiE;

var __ZTI19resource_pool_arrayIPiE;
var __ZTV19resource_pool_arrayIN12sound_stream12stream_inputEE;

var __ZTI19resource_pool_arrayIN12sound_stream12stream_inputEE;





var __ZTV20resource_pool_objectI11gfx_elementE;

var __ZTI20resource_pool_objectI11gfx_elementE;
var __ZL8typelist;




var __ZTV20resource_pool_objectI12_config_typeE;

var __ZTI20resource_pool_objectI12_config_typeE;





var __str93595;

















var __ZTV20resource_pool_objectI24_generic_machine_privateE;

var __ZTI20resource_pool_objectI24_generic_machine_privateE;










var __ZL9itemtable;
var __ZL17global_notifylist;

var __ZL8uniqueid;
var __ZTV20resource_pool_objectI12_output_itemE;

var __ZTI20resource_pool_objectI12_output_itemE;









var __ZTV19resource_pool_arrayIfE;

var __ZTI19resource_pool_arrayIfE;
var __ZTV20resource_pool_objectI16_palette_privateE;

var __ZTI20resource_pool_objectI16_palette_privateE;



var _image_ioprocs;



















var __ZZL10stripspacePKcE4buff;



var __str233692;
























var __str183750;




















































































var __ZL12machine_list;
var __ZL17atexit_registered;
var __ZTV20resource_pool_objectI14_machine_entryE;

var __ZTI20resource_pool_objectI14_machine_entryE;
var __ZTV20resource_pool_objectI18debug_view_managerE;

var __ZTI20resource_pool_objectI18debug_view_managerE;

var __str13852;







var __ZTV20resource_pool_objectI16_romload_privateE;

var __ZTI20resource_pool_objectI16_romload_privateE;





































var __ZTV20resource_pool_objectI9_open_chdE;

var __ZTI20resource_pool_objectI9_open_chdE;



var __ZTV20resource_pool_objectI17_ui_input_privateE;

var __ZTI20resource_pool_objectI17_ui_input_privateE;
var __ZL15messagebox_text;

var __ZL11single_step;
var __ZL23ui_use_natural_keyboard;
var __ZL14slider_current;
var __ZL11slider_list;
var __ZL20messagebox_backcolor;
var __ZL19ui_handler_callback;
var __ZZ19ui_set_startup_textR15running_machinePKciE14lastupdatetime;
var __ZL16ui_handler_param;
var __ZL14popup_text_end;
var __ZL7ui_font;
var __ZL7showfps;
var __ZL11showfps_end;
var __ZL13show_profiler;














var __ZZL22slider_get_screen_descR13screen_deviceE7descbuf;

















var __ZZL25slider_get_laserdisc_descP8device_tE7descbuf;





























var __ZL13non_char_keys;
var __ZL18non_char_keys_down;
var __str623993;

























var __ZL14watchdog_timer;

var __ZL16watchdog_enabled;

var __ZL16watchdog_counter;




var __ZL6global;











var __str114060;
var __ZL16crosshair_colors;









var __str34070;
























var __ZTV20resource_pool_objectI22_generic_audio_privateE;

var __ZTI20resource_pool_objectI22_generic_audio_privateE;








var __ZTV20resource_pool_objectI22_generic_video_privateE;

var __ZTI20resource_pool_objectI22_generic_video_privateE;
var __ZL15console_textbuf;
var __ZL16errorlog_textbuf;





var __str54138;





var __ZL11commandlist;








var __ZTV20resource_pool_objectI14_debug_commandE;

var __ZTI20resource_pool_objectI14_debug_commandE;

var __ZL14hilight_bitmap;
var __ZL15hilight_texture;
var __ZL13arrow_texture;




var __ZL10menu_stack;
var __ZL9menu_free;
var __str24166;
var __ZTV19resource_pool_arrayI13_ui_menu_itemE;

var __ZTI19resource_pool_arrayI13_ui_menu_itemE;
var __ZTV20resource_pool_objectI7ui_menuE;

var __ZTI20resource_pool_objectI7ui_menuE;











var __ZL8drivlist;
















var __ZTV20resource_pool_objectI17driver_enumeratorE;

var __ZTI20resource_pool_objectI17driver_enumeratorE;



































var __ZZL23menu_crosshair_populateR15running_machineP7ui_menuE8vis_text;










































var __ZL10debug_font;
var __ZL16debug_font_width;
var __ZL17debug_font_height;
var __ZL4menu;
var __ZL10cur_editor;
var __ZL4list;
var __ZL10focus_view;
var __ZL17debug_font_aspect;





var __str64292;





























var __ZTV20resource_pool_objectI5DViewE;

var __ZTI20resource_pool_objectI5DViewE;


var __ZTV20resource_pool_objectIN17driver_enumerator12config_entryEE;

var __ZTI20resource_pool_objectIN17driver_enumerator12config_entryEE;
var __ZTV20resource_pool_objectI14machine_configE;

var __ZTI20resource_pool_objectI14machine_configE;
var __ZTV11simple_listIN17driver_enumerator12config_entryEE;

var __ZTI11simple_listIN17driver_enumerator12config_entryEE;
var __ZTV19resource_pool_arrayIP14machine_configE;

var __ZTI19resource_pool_arrayIP14machine_configE;
var __ZN11emu_options16s_option_entriesE;








































































































































































































































var __ZTV11emu_options;














var __ZN13render_target19s_empty_screen_listE;















var __ZTV14layout_element;









var __str244639;
















var __ZTV11layout_view;






var __ZTVN11layout_view4itemE;








var __ZTV11layout_file;






var __ZTI14layout_element;

var __ZTIN11layout_view4itemE;

var __ZTI11layout_view;

var __ZTI11layout_file;
var __ZTV20resource_pool_objectI11layout_viewE;

var __ZTI20resource_pool_objectI11layout_viewE;
var __ZTV20resource_pool_objectI14layout_elementE;

var __ZTI20resource_pool_objectI14layout_elementE;
var __ZTV11simple_listI11layout_viewE;

var __ZTI11simple_listI11layout_viewE;
var __ZTV11simple_listI14layout_elementE;

var __ZTI11simple_listI14layout_elementE;
var __ZTV20resource_pool_objectIN11layout_view4itemEE;

var __ZTI20resource_pool_objectIN11layout_view4itemEE;
var __ZTV11simple_listIN11layout_view4itemEE;

var __ZTI11simple_listIN11layout_view4itemEE;
var __ZTV19resource_pool_arrayIN14layout_element7textureEE;

var __ZTI19resource_pool_arrayIN14layout_element7textureEE;
var __ZTV20resource_pool_objectIN14layout_element9componentEE;

var __ZTI20resource_pool_objectIN14layout_element9componentEE;
var __ZTV11simple_listIN14layout_element9componentEE;

var __ZTI11simple_listIN14layout_element9componentEE;








var __ZTV20resource_pool_objectIN18render_screen_list4itemEE;

var __ZTI20resource_pool_objectIN18render_screen_list4itemEE;


var __ZZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_E6buffer;





var __ZTV11simple_listIN18render_screen_list4itemEE;

var __ZTI11simple_listIN18render_screen_list4itemEE;

var __ZTV11render_font;



















var __ZTI11render_font;
var __ZTV19resource_pool_arrayIN11render_font5glyphEE;

var __ZTI19resource_pool_arrayIN11render_font5glyphEE;

var __ZZN11render_font8get_charEjE11dummy_glyph;




















var __ZTV12symbol_entry;
var __ZTV20integer_symbol_entry;

var __ZTV21function_symbol_entry;





























var __ZTI12symbol_entry;

var __ZTI20integer_symbol_entry;

var __ZTI21function_symbol_entry;
var __ZTV20resource_pool_objectIN17parsed_expression17expression_stringEE;

var __ZTI20resource_pool_objectIN17parsed_expression17expression_stringEE;
var __ZTV20resource_pool_objectIN17parsed_expression11parse_tokenEE;

var __ZTI20resource_pool_objectIN17parsed_expression11parse_tokenEE;
var __ZTV20resource_pool_objectI21function_symbol_entryE;

var __ZTI20resource_pool_objectI21function_symbol_entryE;
var __ZTV20resource_pool_objectI20integer_symbol_entryE;

var __ZTI20resource_pool_objectI20integer_symbol_entryE;



















var __ZZN13media_auditor14audit_one_diskEPK9rom_entryE8nullhash;
var __ZTV20resource_pool_objectI12audit_recordE;

var __ZTI20resource_pool_objectI12audit_recordE;







































var __ZTI13video_manager;


var __ZL12cosine_table;











var __ZN15hash_collection19HASH_TYPES_CRC_SHA1E;

var __ZN15hash_collection14HASH_TYPES_ALLE;
var __ZTV9hash_base;

var __ZTV8hash_crc;

var __ZTV8hash_md5;

var __ZTV9hash_sha1;








var __ZTI9hash_base;
var __ZTI8hash_crc;

var __ZTI8hash_md5;

var __ZTI9hash_sha1;
var __ZTV20resource_pool_objectI9hash_sha1E;

var __ZTI20resource_pool_objectI9hash_sha1E;
var __ZTV20resource_pool_objectI8hash_md5E;

var __ZTI20resource_pool_objectI8hash_md5E;
var __ZTV20resource_pool_objectI8hash_crcE;

var __ZTI20resource_pool_objectI8hash_crcE;
var __ZTV11simple_listI9hash_baseE;

var __ZTI11simple_listI9hash_baseE;























































































var __str865040;




























































var __ZTV17debug_view_source;
var __ZTV10debug_view;




var __ZTI10debug_view;

var __ZTI17debug_view_source;
var __ZTV20resource_pool_objectI14debug_view_logE;

var __ZTI20resource_pool_objectI14debug_view_logE;
var __ZTV20resource_pool_objectI17debug_view_memoryE;

var __ZTI20resource_pool_objectI17debug_view_memoryE;
var __ZTV20resource_pool_objectI17debug_view_disasmE;

var __ZTI20resource_pool_objectI17debug_view_disasmE;
var __ZTV20resource_pool_objectI16debug_view_stateE;

var __ZTI20resource_pool_objectI16debug_view_stateE;
var __ZTV20resource_pool_objectI18debug_view_consoleE;

var __ZTI20resource_pool_objectI18debug_view_consoleE;
var __ZTV19resource_pool_arrayI15debug_view_charE;

var __ZTI19resource_pool_arrayI15debug_view_charE;

var __ZTI22device_nvram_interface;
var __ZTV22device_sound_interface;





var __ZTI22device_sound_interface;
var __ZTV11simple_listIN22device_sound_interface11sound_routeEE;

var __ZTI11simple_listIN22device_sound_interface11sound_routeEE;
var __ZTV23device_disasm_interface;

var __ZTI23device_disasm_interface;
var __ZTV24legacy_image_device_base;


var __ZTI24legacy_image_device_base;
var __ZTV20resource_pool_objectI19image_device_formatE;

var __ZTI20resource_pool_objectI19image_device_formatE;

var __ZTV8emu_file;
var __str15224;






var __ZTI8emu_file;

var __ZTI21device_slot_interface;
var _g_profiler;





var __ZTV10ram_device;
var _RAM;

var __ZTI10ram_device;

var __ZTV20resource_pool_objectI10ram_deviceE;

var __ZTI20resource_pool_objectI10ram_deviceE;











var _SPEAKER;

var __ZTV14speaker_device;


var __ZTI14speaker_device;

var __ZTV20resource_pool_objectI14speaker_deviceE;

var __ZTI20resource_pool_objectI14speaker_deviceE;
var __ZL6ui_gfx;









var __ZZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiiiE15default_palette;


var _CASSETTE;

var __ZTV21cassette_image_device;




var __ZTI18cassette_interface;
var __ZTI21cassette_image_device;

var __ZTV20resource_pool_objectI21cassette_image_deviceE;

var __ZTI20resource_pool_objectI21cassette_image_deviceE;
var __ZZ21bitbanger_mode_stringP8device_tE5modes;


var __ZZ21bitbanger_tune_stringP8device_tE5tunes;

















var __ZZ21bitbanger_baud_stringP8device_tE5bauds;















var __ZTV16bitbanger_device;
var _BITBANGER;

var __ZTI16bitbanger_device;

var __ZTV20resource_pool_objectI16bitbanger_deviceE;

var __ZTI20resource_pool_objectI16bitbanger_deviceE;





var __ZZL20bitbanger_baud_valueP8device_tE5bauds;
var __ZZL20bitbanger_tune_valueP8device_tE5tunes;

var _LASERDISC;





var __ZTV16laserdisc_device;

var __ZTI16laserdisc_device;

var __ZTV20resource_pool_objectI16laserdisc_deviceE;

var __ZTI20resource_pool_objectI16laserdisc_deviceE;
var __ZL17player_interfaces;











var __str195447;











var __ZTV20resource_pool_objectI12_ldcore_dataE;

var __ZTI20resource_pool_objectI12_ldcore_dataE;
var __ZL18flicker_correction;
var __ZL7flicker;
var __ZL10beam_width;





var __ZL12global_array;
var __ZL5cheat;


































































































var __str985596;




















var __ZZL11execute_mapR15running_machineiiPPKcE8intnames;




































































var __ZTV19resource_pool_arrayI10_cheat_mapE;

var __ZTI19resource_pool_arrayI10_cheat_mapE;














var __ZZL14execute_wplistR15running_machineiiPPKcE5types;


















































var __str5754;












































var __ZTV18debug_view_textbuf;
var __ZTV18debug_view_console;
var __ZTV14debug_view_log;

var __ZTI18debug_view_textbuf;

var __ZTI14debug_view_log;

var __ZTI18debug_view_console;
var __ZTV23debug_view_state_source;
var __ZTV16debug_view_state;







var __str75819;





var __ZTI16debug_view_state;

var __ZTI23debug_view_state_source;
var __ZTV20resource_pool_objectIN16debug_view_state10state_itemEE;

var __ZTI20resource_pool_objectIN16debug_view_state10state_itemEE;
var __ZTV20resource_pool_objectI23debug_view_state_sourceE;

var __ZTI20resource_pool_objectI23debug_view_state_sourceE;
var __ZTV24debug_view_disasm_source;
var __ZTV17debug_view_disasm;









var __ZTI17debug_view_disasm;

var __ZTI24debug_view_disasm_source;
var __ZTV20resource_pool_objectI24debug_view_disasm_sourceE;

var __ZTI20resource_pool_objectI24debug_view_disasm_sourceE;

var __ZN17debug_view_memory18s_memory_pos_tableE;
var __ZTV24debug_view_memory_source;
var __ZTV17debug_view_memory;








var __str75850;


var __ZTI17debug_view_memory;

var __ZTI24debug_view_memory_source;
var __ZTV20resource_pool_objectI24debug_view_memory_sourceE;

var __ZTI20resource_pool_objectI24debug_view_memory_sourceE;




var __ZL8ppi0intf;



var __ZL8ppi1intf;

var __ZL7ctcintf;

var __ZL11daisy_chain;



var __ZL11rom_ldv1000;

var _ldv1000_interface;






















var __str95894;



var __ZZ14debug_get_helpPKcE13ambig_message;
var __ZL16static_help_list;


var __str25902;





































































































































var __ZL10rom_pr8210;

var _pr8210_interface;



var __ZL12rom_simutrek;


var _simutrek_interface;






























var __ZL9rom_vp931;


var _vp931_interface;




















var _PPI8255;

var __ZTV14ppi8255_device;




















var __ZTI17ppi8255_interface;
var __ZTI14ppi8255_device;

var __ZTV20resource_pool_objectI14ppi8255_deviceE;

var __ZTI20resource_pool_objectI14ppi8255_deviceE;
var _Z80CTC;

var __ZTV13z80ctc_device;













var __ZTI16z80ctc_interface;
var __ZTI13z80ctc_device;

var __ZTV20resource_pool_objectI13z80ctc_deviceE;

var __ZTI20resource_pool_objectI13z80ctc_deviceE;
var __ZN25devcb_resolved_write_line6s_nullE;
var __ZN20devcb_resolved_read86s_nullE;
var __ZN21devcb_resolved_write86s_nullE;












var __ZTI13delegate_baseIvjh8_noparamS0_E;
var __ZTI8delegateIFvjhEE;
var __ZTI21devcb_resolved_write8;



var __ZTI13delegate_baseIhj8_noparamS0_S0_E;
var __ZTI8delegateIFhjEE;
var __ZTI20devcb_resolved_read8;



var __ZTI13delegate_baseIvi8_noparamS0_S0_E;
var __ZTI8delegateIFviEE;
var __ZTI25devcb_resolved_write_line;

var __ZL11mnemonic_cb;
var __ZL11mnemonic_ed;

var __ZL14mnemonic_xx_cb;
var __ZL11mnemonic_xx;

var __ZL13mnemonic_main;

var __ZL10s_mnemonic;





var __ZL7s_flags;




























































































































































































































































































































































































































































































































































































































































































var __ZTV14samples_device;
var _SAMPLES;

var __ZTI14samples_device;

var __ZTV20resource_pool_objectI14samples_deviceE;

var __ZTI20resource_pool_objectI14samples_deviceE;









var __ZTI13_samples_info;
var __ZTV19resource_pool_arrayI15_sample_channelE;

var __ZTI19resource_pool_arrayI15_sample_channelE;







var __ZL7samples;



















var __str7032;





var __ZL9zip_cache;

var __ZL13dummy_astring;

var __ZZ19core_i64_hex_formatyhE6buffer;
var __ZZ19core_i64_hex_formatyhE5index;










var __ZZ20xml_normalize_stringPKcE6buffer;





var __str107229;





















var __ZN12core_options18s_option_unadornedE;
var __ZTV12core_options;












var __str287302;










var __ZTI12core_options;
var __ZL7nullmd5;
var __ZL8nullsha1;




var __ZL16codec_interfaces;




































var __ZZ15XML_ErrorStringE7message;































































var __ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types;

















var __ZL12namingBitmap;


var __ZL11encodingsNS;







var __ZL9encodings;








var __ZZL16getEncodingIndexPKcE13encodingNames;








var _cassette_default_formats;
var __ZZ15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_imageE15default_options;




var _wavfile_format;




var _crc_table;

var _inflate_order;

















var _fixedtables_lenfix;
var _fixedtables_distfix;

var _configuration_table;



var _inflate_table_lbase;
var _inflate_table_lext;
var _inflate_table_dbase;
var _inflate_table_dext;


var __str27648;






var _z_errmsg;


var _static_l_desc;
var _static_d_desc;
var _static_bl_desc;
var _static_ltree;
var _static_dtree;
var _extra_lbits;
var _base_length;
var _extra_dbits;
var _base_dist;

var _extra_blbits;




var __ZNSt3__1L5__cinE;
var __ZNSt3__1L6__coutE;
var __ZNSt3__1L6__cerrE;
var __ZNSt3__1L6__wcinE;
var __ZNSt3__1L7__wcoutE;
var __ZNSt3__1L7__wcerrE;
var __ZNSt3__13cinE;
var __ZNSt3__14coutE;
var __ZNSt3__14cerrE;
var __ZNSt3__14clogE;
var __ZNSt3__14wcinE;
var __ZNSt3__15wcoutE;
var __ZNSt3__15wcerrE;
var __ZNSt3__15wclogE;
var __ZNSt3__119__start_std_streamsE;
var __ZTVNSt3__111__stdoutbufIwEE;

var __ZTINSt3__111__stdoutbufIwEE;
var __ZTVNSt3__110__stdinbufIwEE;

var __ZTINSt3__110__stdinbufIwEE;

var __ZTVNSt3__111__stdoutbufIcEE;

var __ZTINSt3__111__stdoutbufIcEE;
var __ZTVNSt3__110__stdinbufIcEE;

var __ZTINSt3__110__stdinbufIcEE;
var __ZTVNSt3__114__shared_countE;

var __ZTINSt3__114__shared_countE;
var __ZTVSt11logic_error;
var __ZTVSt13runtime_error;

var __ZTISt11logic_error;
var __ZTVSt12length_error;

var __ZTISt12length_error;

var __ZTISt13runtime_error;
var __ZTVNSt3__114error_categoryE;

var __ZTVNSt3__112system_errorE;

var __ZTINSt3__112system_errorE;

var __ZTINSt3__114error_categoryE;
var __ZTVNSt3__112__do_messageE;

var __ZTINSt3__112__do_messageE;
var __ZNSt3__1L3mutE;
var __ZNSt3__1L2cvE;

var __ZL19__terminate_handler;

var __ZTVSt9exception;

var __ZTISt9exception;
var __ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE;
var __ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE;
var __ZTVNSt3__115basic_streambufIcNS_11char_traitsIcEEEE;
var __ZTVNSt3__115basic_streambufIwNS_11char_traitsIwEEEE;
var __ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE;
var __ZTTNSt3__113basic_istreamIcNS_11char_traitsIcEEEE;
var __ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE;
var __ZTTNSt3__113basic_istreamIwNS_11char_traitsIwEEEE;
var __ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE;
var __ZTTNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE;
var __ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE;
var __ZTTNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE;


var __ZZNSt3__117iostream_categoryEvE1s;
var __ZGVZNSt3__117iostream_categoryEvE1s;
var __ZTVNSt3__18ios_base7failureE;
var __ZTVNSt3__18ios_baseE;


var __ZTINSt3__18ios_base7failureE;

var __ZTINSt3__18ios_baseE;

var __ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE;

var __ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE;

var __ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE;

var __ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE;

var __ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE;

var __ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE;

var __ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE;

var __ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE;
var __ZTVNSt3__119__iostream_categoryE;

var __ZTINSt3__119__iostream_categoryE;
var __ZTVNSt3__17collateIcEE;
var __ZNSt3__17collateIcE2idE;
var __ZGVNSt3__17collateIcE2idE;
var __ZTVNSt3__17collateIwEE;
var __ZNSt3__17collateIwE2idE;
var __ZGVNSt3__17collateIwE2idE;
var __ZTVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
var __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZGVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;


var __ZTVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZGVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZTVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
var __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZGVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;







var __str7244;



var __ZTVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZGVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;







var __ZTVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
var __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZGVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;






var __ZTVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZGVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt;
var __ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt;
var __ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt16;
var __ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt17;
var __ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt18;
var __ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt19;
var __ZTVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
var __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZGVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZTVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZGVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZTVNSt3__110moneypunctIcLb0EEE;
var __ZNSt3__110moneypunctIcLb0EE2idE;
var __ZGVNSt3__110moneypunctIcLb0EE2idE;
var __ZZNKSt3__110moneypunctIcLb0EE13do_pos_formatEvE3__p;
var __ZZNKSt3__110moneypunctIcLb0EE13do_neg_formatEvE3__p;
var __ZTVNSt3__110moneypunctIcLb1EEE;
var __ZNSt3__110moneypunctIcLb1EE2idE;
var __ZGVNSt3__110moneypunctIcLb1EE2idE;
var __ZZNKSt3__110moneypunctIcLb1EE13do_pos_formatEvE3__p;
var __ZZNKSt3__110moneypunctIcLb1EE13do_neg_formatEvE3__p;
var __ZTVNSt3__110moneypunctIwLb0EEE;
var __ZNSt3__110moneypunctIwLb0EE2idE;
var __ZGVNSt3__110moneypunctIwLb0EE2idE;
var __ZZNKSt3__110moneypunctIwLb0EE13do_pos_formatEvE3__p;
var __ZZNKSt3__110moneypunctIwLb0EE13do_neg_formatEvE3__p;
var __ZTVNSt3__110moneypunctIwLb1EEE;
var __ZNSt3__110moneypunctIwLb1EE2idE;
var __ZGVNSt3__110moneypunctIwLb1EE2idE;
var __ZZNKSt3__110moneypunctIwLb1EE13do_pos_formatEvE3__p;
var __ZZNKSt3__110moneypunctIwLb1EE13do_neg_formatEvE3__p;
var __ZTVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
var __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZGVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;



var __ZTVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZGVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;

var __ZTVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
var __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;
var __ZGVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE;

var __ZTVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZGVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE;
var __ZTVNSt3__18messagesIcEE;
var __ZNSt3__18messagesIcE2idE;
var __ZGVNSt3__18messagesIcE2idE;
var __ZTVNSt3__18messagesIwEE;
var __ZNSt3__18messagesIwE2idE;
var __ZGVNSt3__18messagesIwE2idE;

var __ZZNSt3__16__clocEvE6result;
var __ZGVZNSt3__16__clocEvE6result;

var __ZTVNSt3__16locale5__impE;
var __ZZNSt3__16locale5__imp12make_classicEvE3buf;
var __ZZNSt3__16locale7classicEvE1c;
var __ZGVZNSt3__16locale7classicEvE1c;
var __ZZNSt3__16locale5__imp11make_globalEvE3buf;
var __ZZNSt3__16locale8__globalEvE1g;
var __ZGVZNSt3__16locale8__globalEvE1g;
var __ZNSt3__16locale2id9__next_idE;
var __ZNSt3__15ctypeIwE2idE;
var __ZNSt3__15ctypeIcE2idE;
var __ZTVNSt3__15ctypeIcEE;
var __ZNSt3__17codecvtIcc10_mbstate_tE2idE;
var __ZNSt3__17codecvtIwc10_mbstate_tE2idE;
var __ZTVNSt3__17codecvtIwc10_mbstate_tEE;
var __ZNSt3__17codecvtItc10_mbstate_tE2idE;
var __ZNSt3__17codecvtIjc10_mbstate_tE2idE;
var __ZNSt3__18numpunctIcE2idE;
var __ZNSt3__18numpunctIwE2idE;
var __ZTVNSt3__18numpunctIcEE;
var __ZTVNSt3__18numpunctIwEE;




var __ZZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks;
var __ZGVZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks;
var __ZZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks;
var __ZGVZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks;
var __ZZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months;
var __ZGVZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months;
var __ZZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months;
var __ZGVZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months;
var __ZZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm;
var __ZGVZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm;
var __ZZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm;
var __ZGVZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm;
var __ZZNKSt3__120__time_get_c_storageIcE3__xEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIcE3__xEvE1s;

var __ZZNKSt3__120__time_get_c_storageIwE3__xEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIwE3__xEvE1s;

var __ZZNKSt3__120__time_get_c_storageIcE3__XEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIcE3__XEvE1s;

var __ZZNKSt3__120__time_get_c_storageIwE3__XEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIwE3__XEvE1s;

var __ZZNKSt3__120__time_get_c_storageIcE3__cEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIcE3__cEvE1s;

var __ZZNKSt3__120__time_get_c_storageIwE3__cEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIwE3__cEvE1s;

var __ZZNKSt3__120__time_get_c_storageIcE3__rEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIcE3__rEvE1s;

var __ZZNKSt3__120__time_get_c_storageIwE3__rEvE1s;
var __ZGVZNKSt3__120__time_get_c_storageIwE3__rEvE1s;


var __ZTVNSt3__16locale5facetE;

var __ZTINSt3__16locale5facetE;
var __ZTVNSt3__15ctypeIwEE;


var __ZTINSt3__110ctype_baseE;
var __ZTINSt3__15ctypeIwEE;

var __ZTINSt3__15ctypeIcEE;
var __ZTVNSt3__17codecvtIcc10_mbstate_tEE;


var __ZTINSt3__112codecvt_baseE;
var __ZTINSt3__17codecvtIcc10_mbstate_tEE;

var __ZTINSt3__17codecvtIwc10_mbstate_tEE;
var __ZTVNSt3__17codecvtItc10_mbstate_tEE;

var __ZTINSt3__17codecvtItc10_mbstate_tEE;
var __ZTVNSt3__17codecvtIjc10_mbstate_tEE;

var __ZTINSt3__17codecvtIjc10_mbstate_tEE;
var __ZTVNSt3__116__narrow_to_utf8ILj32EEE;

var __ZTINSt3__116__narrow_to_utf8ILj32EEE;
var __ZTVNSt3__117__widen_from_utf8ILj32EEE;

var __ZTINSt3__117__widen_from_utf8ILj32EEE;

var __ZTINSt3__18numpunctIcEE;

var __ZTINSt3__18numpunctIwEE;

var __ZTINSt3__16locale5__impE;

var __ZTINSt3__17collateIcEE;

var __ZTINSt3__17collateIwEE;


var __ZTINSt3__110money_baseE;
var __ZTINSt3__110moneypunctIcLb0EEE;

var __ZTINSt3__110moneypunctIcLb1EEE;

var __ZTINSt3__110moneypunctIwLb0EEE;

var __ZTINSt3__110moneypunctIwLb1EEE;


var __ZTINSt3__19time_baseE;

var __ZTINSt3__120__time_get_c_storageIcEE;
var __ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;


var __ZTINSt3__120__time_get_c_storageIwEE;
var __ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;


var __ZTINSt3__110__time_putE;
var __ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;

var __ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;


var __ZTINSt3__113messages_baseE;
var __ZTINSt3__18messagesIcEE;

var __ZTINSt3__18messagesIwEE;



var __ZTINSt3__114__num_get_baseE;
var __ZTINSt3__19__num_getIcEE;
var __ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;


var __ZTINSt3__19__num_getIwEE;
var __ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;



var __ZTINSt3__114__num_put_baseE;
var __ZTINSt3__19__num_putIcEE;
var __ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;


var __ZTINSt3__19__num_putIwEE;
var __ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;


var __ZTINSt3__111__money_getIcEE;
var __ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;


var __ZTINSt3__111__money_getIwEE;
var __ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;


var __ZTINSt3__111__money_putIcEE;
var __ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;


var __ZTINSt3__111__money_putIwEE;
var __ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
var __ZZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_E3buf;
var __ZZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_E3buf;
var __ZZNSt3__1L11init_wam_pmEvE5am_pm;
var __ZGVZNSt3__1L11init_wam_pmEvE5am_pm;


var __ZZNSt3__1L10init_am_pmEvE5am_pm;
var __ZGVZNSt3__1L10init_am_pmEvE5am_pm;


var __ZZNSt3__1L12init_wmonthsEvE6months;
var __ZGVZNSt3__1L12init_wmonthsEvE6months;























var __ZZNSt3__1L11init_monthsEvE6months;
var __ZGVZNSt3__1L11init_monthsEvE6months;























var __ZZNSt3__1L11init_wweeksEvE5weeks;
var __ZGVZNSt3__1L11init_wweeksEvE5weeks;














var __ZZNSt3__1L10init_weeksEvE5weeks;
var __ZGVZNSt3__1L10init_weeksEvE5weeks;














var __ZTVNSt3__120__time_get_c_storageIwEE;
var __ZTVNSt3__120__time_get_c_storageIcEE;
var __ZTVSt8bad_cast;


var __ZTISt8bad_cast;

var __ZTISt9type_info;
var __ZTIN10__cxxabiv116__shim_type_infoE;

var __ZTIN10__cxxabiv117__class_type_infoE;
var __ZTVN10__cxxabiv117__class_type_infoE;
var __ZTVN10__cxxabiv120__si_class_type_infoE;

var __ZTIN10__cxxabiv120__si_class_type_infoE;
var __ZTVN10__cxxabiv121__vmi_class_type_infoE;

var __ZTIN10__cxxabiv121__vmi_class_type_infoE;
var __gm_;
var _mparams;
var __ZL13__new_handler;
var __ZTVSt9bad_alloc;


var __ZTISt9bad_alloc;
var __ZN18mini_osd_interfaceC1Ev;
var __ZN18mini_osd_interfaceD1Ev;
var __ZN12i8748_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN12i8049_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN10z80_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN25device_z80daisy_interfaceD1Ev;
var __ZN15z80_daisy_chain11daisy_entryC1EP8device_t;
var __ZN17input_port_configC1ER8device_tPKc;
var __ZN18input_field_configC1ER17input_port_configijjPKc;
var __ZN20input_setting_configC1ER18input_field_configjPKc;
var __ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq;
var __ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_;
var __ZN12timer_deviceC1ERK14machine_configPKcP8device_tj;
var __ZN15cartslot_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN20software_list_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN13resource_poolC1Ei;
var __ZN13resource_poolD1Ev;
var __ZN11cli_optionsC1Ev;
var __ZN12cli_frontendC1ER11cli_optionsR13osd_interface;
var __ZN12cli_frontendD1Ev;
var __ZN16media_identifierC1ER11cli_options;
var __ZN14machine_configC1ERK11game_driverR11emu_options;
var __ZN14machine_configD1Ev;
var __ZN11device_listC1ER13resource_pool;
var __ZN8device_tD1Ev;
var __ZN8device_t16auto_finder_baseD1Ev;
var __ZN16device_interfaceD1Ev;
var __ZN18address_map_entry8C1ER11address_mapjj;
var __ZN11address_mapC1ERK8device_t16address_spacenum;
var __ZN11address_mapD1Ev;
var __ZN22device_image_interfaceD1Ev;
var __ZN20address_space_configC1Ev;
var __ZN23device_memory_interfaceD1Ev;
var __ZN12joystick_mapC1Ev;
var __ZN10input_codeC1ER12input_device13input_item_id;
var __ZN12input_deviceC1ER11input_classiPKcPv;
var __ZN11input_classC1ER13input_manager18input_device_classbb;
var __ZN13input_managerC1ER15running_machine;
var __ZN24input_device_switch_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E;
var __ZN26input_device_relative_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E;
var __ZN26input_device_absolute_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E;
var __ZN12device_debugC1ER8device_t;
var __ZN12device_debugD1Ev;
var __ZN12device_debug10breakpointC1ER12symbol_tableijPKcS4_;
var __ZN12device_debug10watchpointC1ER12symbol_tableiR13address_spaceijjPKcS6_;
var __ZN12device_debug6tracerC1ERS_R7__sFILEbPKc;
var __ZN12device_debug6tracerD1Ev;
var __ZN12device_debug12dasm_commentC1EPKcjjj;
var __ZN12save_managerC1ER15running_machine;
var __ZN12save_manager14state_callbackC1E8delegateIFvvEE;
var __ZN12save_manager11state_entryC1EPvPKchj;
var __ZN15running_machineC1ERK14machine_configR13osd_interfaceb;
var __ZN15running_machineD1Ev;
var __ZN13memory_regionC1ER15running_machinePKcjh12endianness_t;
var __ZN13memory_regionD1Ev;
var __ZN15running_machine22notifier_callback_itemC1E8delegateIFvvEE;
var __ZN15running_machine22logerror_callback_itemC1EPFvRS_PKcE;
var __ZN13driver_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_;
var __ZN13driver_deviceD1Ev;
var __ZN11system_timeC1Ev;
var __ZN13osd_interfaceD1Ev;
var __ZN21render_primitive_listC1Ev;
var __ZN21render_primitive_listD1Ev;
var __ZN14render_textureC1Ev;
var __ZN14render_textureD1Ev;
var __ZN16render_containerC1ER14render_managerP13screen_device;
var __ZN16render_containerD1Ev;
var __ZN16render_container13user_settingsC1Ev;
var __ZN13render_targetC1ER14render_managerPKcj;
var __ZN13render_targetD1Ev;
var __ZN14render_managerC1ER15running_machine;
var __ZN14render_managerD1Ev;
var __ZN13screen_deviceC1ERK14machine_configPKcP8device_tj;
var __ZN13screen_deviceD1Ev;
var __ZN9emu_timerC1Ev;
var __ZN9emu_timerD1Ev;
var __ZN16device_schedulerC1ER15running_machine;
var __ZN16device_schedulerD1Ev;
var __ZN13address_spaceD1Ev;
var __ZN13address_tableD1Ev;
var __ZN18address_table_readC1ER13address_spaceb;
var __ZN18address_table_readD1Ev;
var __ZN19address_table_writeC1ER13address_spaceb;
var __ZN19address_table_writeD1Ev;
var __ZN16direct_read_dataC1ER13address_space;
var __ZN16direct_read_dataD1Ev;
var __ZN12memory_blockC1ER13address_spacejjPv;
var __ZN12memory_blockD1Ev;
var __ZN11memory_bankC1ER13address_spaceijjPKc;
var __ZN11memory_bankD1Ev;
var __ZN13handler_entryD1Ev;
var __ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPKNS_11__list_nodeIS2_S3_EE;
var __ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC1ESC_;
var __ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC1ESE_;
var __ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC1ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE;
var __ZNSt3__121__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPKNS_11__tree_nodeIS8_PvEEiEC1ENS_15__tree_iteratorIS8_PSB_iEE;
var __ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPNS_11__list_nodeIS2_S3_EE;
var __ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1ENS_15__list_iteratorIS2_S3_EE;
var __ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev;
var __ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC1ERSG_;
var __ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEC1ERSC_;
var __ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1EPSB_SE_;
var __ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ESC_SF_;
var __ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ENS_4__rvISF_EE;
var __ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev;
var __ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC1ERS7_j;
var __ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC1EPS5_S9_;
var __ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC1ES6_SA_;
var __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEC1ERKS8_;
var __ZNSt3__119__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEELb1EEC1ES8_;
var __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC1ERKSC_;
var __ZNSt3__117__compressed_pairIjNS_19__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEENS_4lessIhEELb1EEEEC1EjSA_;
var __ZNSt3__117__compressed_pairINS_15__tree_end_nodeIPNS_16__tree_node_baseIPvEEEENS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS7_ISC_EEEEEES3_EEEEEC1Ev;
var __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC1Ev;
var __ZNSt3__117__compressed_pairIjNS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC1Eji;
var __ZNSt3__116__list_node_baseIN12_GLOBAL__N_18subrangeEPvEC1Ev;
var __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED1Ev;
var __ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED2Ev;
var __ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED1Ev;
var __ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEED1Ev;
var __ZNSt3__14pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEEED1Ev;
var __ZN12_GLOBAL__N_18subrangeC1Ejj;
var __ZN10cpu_deviceD1Ev;
var __ZN17legacy_cpu_deviceD1Ev;
var __ZN18device_state_entryC1EiPKcPvh;
var __ZN22device_state_interfaceD1Ev;
var __ZN18legacy_device_baseD1Ev;
var __ZN24device_execute_interfaceD1Ev;
var __ZN24device_execute_interface12device_inputC1Ev;
var __ZN15cheat_parameterC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node;
var __ZN12cheat_scriptC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node;
var __ZN12cheat_script12script_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb;
var __ZN12cheat_script12script_entry15output_argumentC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node;
var __ZN11cheat_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node;
var __ZN11cheat_entryD1Ev;
var __ZN13cheat_managerC1ER15running_machine;
var __ZN12sound_streamC1ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE;
var __ZN12sound_stream12stream_inputC1Ev;
var __ZN12sound_stream13stream_outputC1Ev;
var __ZN13sound_managerC1ER15running_machine;
var __ZN13sound_managerD1Ev;
var __ZN17driver_enumeratorC1ER11emu_options;
var __ZN17driver_enumeratorC1ER11emu_optionsPKc;
var __ZN17driver_enumeratorC1ER11emu_optionsRK11game_driver;
var __ZN17driver_enumeratorD1Ev;
var __ZN17driver_enumerator12config_entryC1ER14machine_configi;
var __ZN17driver_enumerator12config_entryD1Ev;
var __ZN14layout_elementC1ER15running_machineR14_xml_data_nodePKc;
var __ZN14layout_elementD1Ev;
var __ZN14layout_element7textureC1Ev;
var __ZN14layout_element7textureD1Ev;
var __ZN14layout_element9componentC1ER15running_machineR14_xml_data_nodePKc;
var __ZN14layout_element9componentD1Ev;
var __ZN11layout_viewC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE;
var __ZN11layout_viewD1Ev;
var __ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE;
var __ZN11layout_view4itemD1Ev;
var __ZN11layout_fileC1ER15running_machineR14_xml_data_nodePKc;
var __ZN11layout_fileD1Ev;
var __ZN11render_fontC1ER14render_managerPKc;
var __ZN11render_fontD1Ev;
var __ZN12symbol_entryD1Ev;
var __ZN20integer_symbol_entryC1ER12symbol_tablePKcNS0_10read_writeEPy;
var __ZN20integer_symbol_entryC1ER12symbol_tablePKcPvPFyS1_S4_EPFvS1_S4_yE;
var __ZN21function_symbol_entryC1ER12symbol_tablePKcPviiPFyS1_S4_iPKyE;
var __ZN12symbol_tableC1EPvPS_;
var __ZN17parsed_expressionC1EP12symbol_tablePKcPy;
var __ZN17parsed_expression11parse_tokenC1Ei;
var __ZN13media_auditorC1ERK17driver_enumerator;
var __ZN12audit_recordC1ERK9rom_entryNS_10media_typeE;
var __ZN12audit_recordC1EPKcNS_10media_typeE;
var __ZN13video_managerC1ER15running_machine;
var __ZN8hash_crcC1Ev;
var __ZN8hash_md5C1Ev;
var __ZN9hash_sha1C1Ev;
var __ZN15hash_collectionC1Ev;
var __ZN15hash_collectionC1EPKc;
var __ZN15hash_collectionD1Ev;
var __ZN16info_xml_creatorC1ER17driver_enumerator;
var __ZN17debug_view_sourceD1Ev;
var __ZN22debug_view_source_listC1ER15running_machine;
var __ZN22debug_view_source_listD1Ev;
var __ZN10debug_viewD1Ev;
var __ZN18debug_view_managerC1ER15running_machine;
var __ZN18debug_view_managerD1Ev;
var __ZN21debug_view_expressionC1ER15running_machine;
var __ZN21debug_view_expressionD1Ev;
var __ZN22device_sound_interfaceD1Ev;
var __ZN23device_disasm_interfaceD1Ev;
var __ZN24legacy_image_device_baseD1Ev;
var __ZN13path_iteratorC1EPKc;
var __ZN15file_enumeratorC1EPKc;
var __ZN15file_enumeratorD1Ev;
var __ZN8emu_fileC1Ej;
var __ZN8emu_fileC1EPKcj;
var __ZN8emu_fileD1Ev;
var __ZN20dummy_profiler_stateC1Ev;
var __ZN10ram_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN14speaker_deviceC1ERK14machine_configPKcP8device_tj;
var __ZN14speaker_deviceD1Ev;
var __ZN21cassette_image_deviceC1ERK14machine_configPKcP8device_tj;
var __ZN21cassette_image_deviceD1Ev;
var __ZN16bitbanger_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN16laserdisc_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN18debug_view_textbufD1Ev;
var __ZN18debug_view_consoleC1ER15running_machinePFvR10debug_viewPvES4_;
var __ZN14debug_view_logC1ER15running_machinePFvR10debug_viewPvES4_;
var __ZN23debug_view_state_sourceC1EPKcR8device_t;
var __ZN16debug_view_stateC1ER15running_machinePFvR10debug_viewPvES4_;
var __ZN16debug_view_stateD1Ev;
var __ZN16debug_view_state10state_itemC1EiPKch;
var __ZN24debug_view_disasm_sourceC1EPKcR8device_t;
var __ZN17debug_view_disasmC1ER15running_machinePFvR10debug_viewPvES4_;
var __ZN17debug_view_disasmD1Ev;
var __ZN24debug_view_memory_sourceC1EPKcR13address_space;
var __ZN24debug_view_memory_sourceC1EPKcRK13memory_region;
var __ZN24debug_view_memory_sourceC1EPKcPvii;
var __ZN17debug_view_memoryC1ER15running_machinePFvR10debug_viewPvES4_;
var __ZN14ppi8255_deviceC1ERK14machine_configPKcP8device_tj;
var __ZN13z80ctc_deviceC1ERK14machine_configPKcP8device_tj;
var __ZN13z80ctc_device11ctc_channelC1Ev;
var __ZN25devcb_resolved_write_lineC1Ev;
var __ZN20devcb_resolved_read8C1Ev;
var __ZN21devcb_resolved_write8C1Ev;
var __ZN14samples_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j;
var __ZN8bitmap_tC1Ev;
var __ZN8bitmap_tC1Eii14_bitmap_formatii;
var __ZN8bitmap_tC1EPviii14_bitmap_format;
var __ZN8bitmap_tD1Ev;
var __ZN7astringD1Ev;
var __ZN12core_options5entryC1ERK13options_entry;
var __ZN12core_optionsD1Ev;
var __ZNSt3__18ios_base4InitC1Ev;
var __ZNSt3__18ios_base4InitD1Ev;
var __ZNSt3__114__shared_countD1Ev;
var __ZNSt11logic_errorD1Ev;
var __ZNSt13runtime_errorC1EPKc;
var __ZNSt13runtime_errorD1Ev;
var __ZNSt12length_errorD1Ev;
var __ZNSt12length_errorD2Ev;
var __ZN12_GLOBAL__N_114__libcpp_nmstrD1Ev;
var __ZN12_GLOBAL__N_114__libcpp_nmstrC1EPKc;
var __ZNSt3__114error_categoryD1Ev;
var __ZNSt3__112system_errorD1Ev;
var __ZNSt9exceptionD1Ev;
var __ZNSt3__18ios_base7failureC1EPKcRKNS_10error_codeE;
var __ZNSt3__18ios_base7failureD1Ev;
var __ZNSt3__18ios_baseD1Ev;
var __ZNSt3__16locale5__impC1Ej;
var __ZNSt3__16locale5__impD1Ev;
var __ZNSt3__16localeC1Ev;
var __ZNSt3__16localeC1ERKS0_;
var __ZNSt3__16localeD1Ev;
var __ZNSt3__16locale5facetD1Ev;
var __ZNSt3__15ctypeIwED1Ev;
var __ZNSt3__15ctypeIwED2Ev;
var __ZNSt3__15ctypeIcEC1EPKjbj;
var __ZNSt3__15ctypeIcED1Ev;
var __ZNSt3__17codecvtIcc10_mbstate_tED1Ev;
var __ZNSt3__17codecvtIcc10_mbstate_tED2Ev;
var __ZNSt3__17codecvtIwc10_mbstate_tEC1Ej;
var __ZNSt3__17codecvtIwc10_mbstate_tED1Ev;
var __ZNSt3__17codecvtItc10_mbstate_tED1Ev;
var __ZNSt3__17codecvtItc10_mbstate_tED2Ev;
var __ZNSt3__17codecvtIjc10_mbstate_tED1Ev;
var __ZNSt3__17codecvtIjc10_mbstate_tED2Ev;
var __ZNSt3__116__narrow_to_utf8ILj32EED1Ev;
var __ZNSt3__116__narrow_to_utf8ILj32EED2Ev;
var __ZNSt3__117__widen_from_utf8ILj32EED1Ev;
var __ZNSt3__117__widen_from_utf8ILj32EED2Ev;
var __ZNSt3__18numpunctIcEC1Ej;
var __ZNSt3__18numpunctIwEC1Ej;
var __ZNSt3__18numpunctIcED1Ev;
var __ZNSt3__18numpunctIwED1Ev;
var __ZNSt3__117__call_once_paramINS_12_GLOBAL__N_111__fake_bindEEC1ERKS2_;
var __ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED1Ev;
var __ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEEC1EPS2_;
var __ZNSt3__117__compressed_pairIPNS_6locale5facetENS_12_GLOBAL__N_17releaseEEC1ES3_i;
var __ZNSt3__112_GLOBAL__N_111__fake_bindC1EMNS_6locale2idEFvvEPS3_;
var __ZNSt8bad_castC1Ev;
var __ZNSt8bad_castD1Ev;
var __ZN10__cxxabiv117__class_type_infoD1Ev;
var __ZN10__cxxabiv117__class_type_infoD2Ev;
var __ZN10__cxxabiv120__si_class_type_infoD1Ev;
var __ZN10__cxxabiv120__si_class_type_infoD2Ev;
var __ZN10__cxxabiv121__vmi_class_type_infoD1Ev;
var __ZN10__cxxabiv121__vmi_class_type_infoD2Ev;
var __ZNSt9bad_allocC1Ev;
var __ZNSt9bad_allocD1Ev;
STRING_TABLE._build_version=allocate([48,46,49,52,50,117,54,32,40,70,101,98,32,50,56,32,50,48,49,50,41,0] /* 0.142u6 (Feb 28 2012 */, "i8", ALLOC_STATIC);
__ZN11driver_list16s_drivers_sortedE=allocate(16, "*", ALLOC_STATIC);
__ZN11driver_list14s_driver_countE=allocate([4], ["i32",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str10=allocate([115,114,99,47,101,109,117,47,109,97,99,104,105,110,101,46,104,0] /* src/emu/machine.h\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI13driver_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1708, 0, 0, 0, 1710, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13driver_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,100,114,105,118,101,114,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS18resource_pool_item=allocate([49,56,114,101,115,111,117,114,99,101,95,112,111,111,108,95,105,116,101,109,0] /* 18resource_pool_item */, "i8", ALLOC_STATIC);
__ZTI18resource_pool_item=allocate(8, "*", ALLOC_STATIC);
__ZTI20resource_pool_objectI13driver_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZTV18resource_pool_item=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1712, 0, 0, 0, 1714, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZL18tms9928a_interface=allocate([3, 0, 0, 0, 16384, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1716, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str11=allocate([122,56,48,0] /* z80\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112=allocate([99,111,108,101,99,111,46,114,111,109,0] /* coleco.rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213=allocate([82,51,97,97,57,51,101,102,51,83,52,53,98,101,100,99,52,99,98,100,101,97,99,54,54,99,55,100,102,53,57,101,57,101,53,57,57,49,57,53,99,55,55,56,100,56,54,97,57,50,0] /* R3aa93ef3S45bedc4cbd */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314=allocate([99,97,114,116,0] /* cart\00 */, "i8", ALLOC_STATIC);
__ZL10rom_coleco=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65536, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32768, 0, 0, 0, 32768, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str415=allocate([99,111,108,101,99,111,97,46,114,111,109,0] /* colecoa.rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str516=allocate([82,51,57,98,98,49,54,102,99,83,57,57,98,97,57,98,101,50,52,97,100,97,51,101,56,54,101,53,99,49,55,97,101,101,99,98,55,97,50,100,54,56,99,53,101,100,102,101,53,57,0] /* R39bb16fcS99ba9be24a */, "i8", ALLOC_STATIC);
__ZL11rom_colecoa=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65536, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32768, 0, 0, 0, 32768, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str617=allocate([115,118,105,54,48,51,46,114,111,109,0] /* svi603.rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str718=allocate([82,49,57,101,57,49,98,56,50,83,56,97,51,48,97,98,101,53,102,102,101,102,56,49,48,98,48,102,57,57,98,56,54,100,98,51,56,98,49,98,51,99,57,100,50,53,57,98,55,56,0] /* R19e91b82S8a30abe5ff */, "i8", ALLOC_STATIC);
__ZL11rom_colecob=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65536, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32768, 0, 0, 0, 32768, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1021=allocate([115,114,99,47,109,101,115,115,47,100,114,105,118,101,114,115,47,99,111,108,101,99,111,46,99,0] /* src/mess/drivers/col */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1122=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12=allocate([99,111,108,101,99,111,0] /* coleco\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13=allocate([67,111,108,101,99,111,86,105,115,105,111,110,0] /* ColecoVision\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14=allocate([49,57,56,50,0] /* 1982\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15=allocate([67,111,108,101,99,111,0] /* Coleco\00 */, "i8", ALLOC_STATIC);
_driver_coleco=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1718, 0, 0, 0, 1720, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 524800, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str16=allocate([99,111,108,101,99,111,97,0] /* colecoa\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17=allocate([67,111,108,101,99,111,86,105,115,105,111,110,32,40,84,104,105,99,107,32,67,104,97,114,97,99,116,101,114,115,41,0] /* ColecoVision (Thick  */, "i8", ALLOC_STATIC);
_driver_colecoa=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1718, 0, 0, 0, 1720, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 524800, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str18=allocate([99,111,108,101,99,111,98,0] /* colecob\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str19=allocate([83,86,73,45,54,48,51,32,67,111,108,101,99,111,32,71,97,109,101,32,65,100,97,112,116,101,114,0] /* SVI-603 Coleco Game  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str20=allocate([49,57,56,51,0] /* 1983\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21=allocate([83,112,101,99,116,114,97,118,105,100,101,111,0] /* Spectravideo\00 */, "i8", ALLOC_STATIC);
_driver_colecob=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1718, 0, 0, 0, 1720, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 524800, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZTV12coleco_state=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1722, 0, 0, 0, 1724, 0, 0, 0, 1726, 0, 0, 0, 1728, 0, 0, 0, 1730, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1736, 0, 0, 0, 1738, 0, 0, 0, 1740, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 1752, 0, 0, 0, 1754, 0, 0, 0, 1756, 0, 0, 0, 1758, 0, 0, 0, 1760, 0, 0, 0, 1762, 0, 0, 0, 1764, 0, 0, 0, 1766, 0, 0, 0, 1768, 0, 0, 0, 1770, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS12coleco_state=allocate([49,50,99,111,108,101,99,111,95,115,116,97,116,101,0] /* 12coleco_state\00 */, "i8", ALLOC_STATIC);
__ZTI12coleco_state=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str32=allocate([115,99,114,101,101,110,0] /* screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str48=allocate([114,111,111,116,0] /* root\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str49=allocate([114,111,109,44,99,111,108,44,98,105,110,0] /* rom,col,bin\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str50=allocate([99,111,108,101,99,111,95,99,97,114,116,0] /* coleco_cart\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51=allocate([99,97,114,116,95,108,105,115,116,0] /* cart_list\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52=allocate([112,97,100,100,108,101,95,116,105,109,101,114,0] /* paddle_timer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55=allocate([73,108,108,101,103,97,108,32,111,112,101,114,97,116,105,111,110,32,111,110,32,117,110,109,111,117,110,116,101,100,32,105,109,97,103,101,0] /* Illegal operation on */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56=allocate([115,114,99,47,101,109,117,47,100,105,105,109,97,103,101,46,104,0] /* src/emu/diimage.h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS14emu_fatalerror=allocate([49,52,101,109,117,95,102,97,116,97,108,101,114,114,111,114,0] /* 14emu_fatalerror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13emu_exception=allocate([49,51,101,109,117,95,101,120,99,101,112,116,105,111,110,0] /* 13emu_exception\00 */, "i8", ALLOC_STATIC);
__ZTI13emu_exception=allocate(12, "*", ALLOC_STATIC);
__ZTI14emu_fatalerror=allocate(12, "*", ALLOC_STATIC);
__ZTV14emu_fatalerror=allocate([0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 1772, 0, 0, 0, 1774, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV13emu_exception=allocate([0, 0, 0, 0, 0, 0, 0, 0, 210, 0, 0, 0, 1776, 0, 0, 0, 1774, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZL11DEVICE_SELF=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str57=allocate([100,114,105,118,101,114,95,100,97,116,97,58,58,112,97,100,100,108,101,95,111,102,102,95,119,0] /* driver_data::paddle_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str58=allocate([84,77,83,57,57,50,56,65,95,118,114,97,109,95,114,0] /* TMS9928A_vram_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str59=allocate([84,77,83,57,57,50,56,65,95,118,114,97,109,95,119,0] /* TMS9928A_vram_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str60=allocate([84,77,83,57,57,50,56,65,95,114,101,103,105,115,116,101,114,95,114,0] /* TMS9928A_register_r\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61=allocate([84,77,83,57,57,50,56,65,95,114,101,103,105,115,116,101,114,95,119,0] /* TMS9928A_register_w\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62=allocate([100,114,105,118,101,114,95,100,97,116,97,58,58,112,97,100,100,108,101,95,111,110,95,119,0] /* driver_data::paddle_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65=allocate([100,114,105,118,101,114,95,100,97,116,97,58,58,112,97,100,100,108,101,95,49,95,114,0] /* driver_data::paddle_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66=allocate([100,114,105,118,101,114,95,100,97,116,97,58,58,112,97,100,100,108,101,95,50,95,114,0] /* driver_data::paddle_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS18delegate_late_bind=allocate([49,56,100,101,108,101,103,97,116,101,95,108,97,116,101,95,98,105,110,100,0] /* 18delegate_late_bind */, "i8", ALLOC_STATIC);
__ZTI18delegate_late_bind=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str67=allocate([115,114,99,47,101,109,117,47,109,97,99,104,105,110,101,46,104,0] /* src/emu/machine.h\00 */, "i8", ALLOC_STATIC);
__ZTVN8device_t15required_deviceI10cpu_deviceEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1778, 0, 0, 0, 1780, 0, 0, 0, 1782, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSN8device_t15required_deviceI10cpu_deviceEE=allocate([78,56,100,101,118,105,99,101,95,116,49,53,114,101,113,117,105,114,101,100,95,100,101,118,105,99,101,73,49,48,99,112,117,95,100,101,118,105,99,101,69,69,0] /* N8device_t15required */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE=allocate([78,56,100,101,118,105,99,101,95,116,49,54,97,117,116,111,95,102,105,110,100,101,114,95,116,121,112,101,73,80,49,48,99,112,117,95,100,101,118,105,99,101,76,98,49,69,69,69,0] /* N8device_t16auto_fin */, "i8", ALLOC_STATIC);
__ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTIN8device_t15required_deviceI10cpu_deviceEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str68=allocate([85,110,97,98,108,101,32,116,111,32,102,105,110,100,32,114,101,113,117,105,114,101,100,32,111,98,106,101,99,116,32,39,37,115,39,0] /* Unable to find requi */, "i8", ALLOC_STATIC);
__ZTVN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1784, 0, 0, 0, 1786, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12coleco_stateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1790, 0, 0, 0, 1792, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12coleco_stateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,99,111,108,101,99,111,95,115,116,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12coleco_stateE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str69=allocate([67,84,82,76,83,69,76,0] /* CTRLSEL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str170=allocate([68,82,73,86,0] /* DRIV\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str271=allocate([83,65,67,95,83,76,73,68,69,49,0] /* SAC_SLIDE1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str372=allocate([83,65,67,95,83,76,73,68,69,50,0] /* SAC_SLIDE2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str473=allocate([82,79,76,76,69,82,95,88,0] /* ROLLER_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str574=allocate([82,79,76,76,69,82,95,89,0] /* ROLLER_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str675=allocate([75,69,89,80,65,68,49,0] /* KEYPAD1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str776=allocate([83,65,67,95,75,80,68,49,0] /* SAC_KPD1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str877=allocate([74,79,89,49,0] /* JOY1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str978=allocate([83,65,67,95,74,79,89,49,0] /* SAC_JOY1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1079=allocate([75,69,89,80,65,68,50,0] /* KEYPAD2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1180=allocate([83,65,67,95,75,80,68,50,0] /* SAC_KPD2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1281=allocate([74,79,89,50,0] /* JOY2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1382=allocate([83,65,67,95,74,79,89,50,0] /* SAC_JOY2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1483=allocate([80,111,114,116,32,49,32,67,111,110,116,114,111,108,108,101,114,0] /* Port 1 Controller\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1584=allocate([67,111,108,101,99,111,86,105,115,105,111,110,32,67,111,110,116,114,111,108,108,101,114,0] /* ColecoVision Control */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1685=allocate([83,117,112,101,114,32,65,99,116,105,111,110,32,67,111,110,116,114,111,108,108,101,114,0] /* Super Action Control */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1786=allocate([68,114,105,118,105,110,103,32,67,111,110,116,114,111,108,108,101,114,0] /* Driving Controller\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1887=allocate([80,111,114,116,32,50,32,67,111,110,116,114,111,108,108,101,114,0] /* Port 2 Controller\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1988=allocate([69,120,116,114,97,32,67,111,110,116,114,111,108,108,101,114,0] /* Extra Controller\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2089=allocate([82,111,108,108,101,114,32,67,111,110,116,114,111,108,108,101,114,0] /* Roller Controller\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2190=allocate([48,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 0 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2291=allocate([49,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 1 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2392=allocate([50,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 2 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2493=allocate([51,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 3 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2594=allocate([52,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 4 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2695=allocate([53,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 5 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2796=allocate([54,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 6 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2897=allocate([55,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 7 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2998=allocate([56,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 8 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3099=allocate([57,32,40,83,65,67,32,112,97,100,32,50,41,0] /* 9 (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31100=allocate([35,32,40,83,65,67,32,112,97,100,32,50,41,0] /* # (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32101=allocate([46,32,40,83,65,67,32,112,97,100,32,50,41,0] /* . (SAC pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33102=allocate([66,108,117,101,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,50,0] /* Blue Action Button P */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34103=allocate([80,117,114,112,108,101,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,50,0] /* Purple Action Button */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35104=allocate([79,114,97,110,103,101,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,50,0] /* Orange Action Button */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36105=allocate([89,101,108,108,111,119,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,50,0] /* Yellow Action Button */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37106=allocate([48,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 0 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str38107=allocate([49,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 1 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str39108=allocate([50,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 2 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str40109=allocate([51,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 3 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41110=allocate([52,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 4 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42111=allocate([53,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 5 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43112=allocate([54,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 6 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44113=allocate([55,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 7 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45114=allocate([56,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 8 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46115=allocate([57,32,40,83,65,67,32,112,97,100,32,49,41,0] /* 9 (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47116=allocate([35,32,40,83,65,67,32,112,97,100,32,49,41,0] /* # (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str48117=allocate([46,32,40,83,65,67,32,112,97,100,32,49,41,0] /* . (SAC pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str49118=allocate([66,108,117,101,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,49,0] /* Blue Action Button P */, "i8", ALLOC_STATIC);
STRING_TABLE.__str50119=allocate([80,117,114,112,108,101,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,49,0] /* Purple Action Button */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51120=allocate([79,114,97,110,103,101,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,49,0] /* Orange Action Button */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52121=allocate([89,101,108,108,111,119,32,65,99,116,105,111,110,32,66,117,116,116,111,110,32,80,49,0] /* Yellow Action Button */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53122=allocate([48,32,40,112,97,100,32,50,41,0] /* 0 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54123=allocate([49,32,40,112,97,100,32,50,41,0] /* 1 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55124=allocate([50,32,40,112,97,100,32,50,41,0] /* 2 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56125=allocate([51,32,40,112,97,100,32,50,41,0] /* 3 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57126=allocate([52,32,40,112,97,100,32,50,41,0] /* 4 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str58127=allocate([53,32,40,112,97,100,32,50,41,0] /* 5 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str59128=allocate([54,32,40,112,97,100,32,50,41,0] /* 6 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str60129=allocate([55,32,40,112,97,100,32,50,41,0] /* 7 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61130=allocate([56,32,40,112,97,100,32,50,41,0] /* 8 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62131=allocate([57,32,40,112,97,100,32,50,41,0] /* 9 (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63132=allocate([35,32,40,112,97,100,32,50,41,0] /* # (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64133=allocate([46,32,40,112,97,100,32,50,41,0] /* . (pad 2)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65134=allocate([48,32,40,112,97,100,32,49,41,0] /* 0 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66135=allocate([49,32,40,112,97,100,32,49,41,0] /* 1 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67136=allocate([50,32,40,112,97,100,32,49,41,0] /* 2 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str68137=allocate([51,32,40,112,97,100,32,49,41,0] /* 3 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str69138=allocate([52,32,40,112,97,100,32,49,41,0] /* 4 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str70=allocate([53,32,40,112,97,100,32,49,41,0] /* 5 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71=allocate([54,32,40,112,97,100,32,49,41,0] /* 6 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72=allocate([55,32,40,112,97,100,32,49,41,0] /* 7 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73=allocate([56,32,40,112,97,100,32,49,41,0] /* 8 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74=allocate([57,32,40,112,97,100,32,49,41,0] /* 9 (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75=allocate([35,32,40,112,97,100,32,49,41,0] /* # (pad 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76=allocate([46,32,40,112,97,100,32,49,41,0] /* . (pad 1)\00 */, "i8", ALLOC_STATIC);
__ZTV18mini_osd_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1794, 0, 0, 0, 1796, 0, 0, 0, 1798, 0, 0, 0, 1800, 0, 0, 0, 1802, 0, 0, 0, 1804, 0, 0, 0, 1806, 0, 0, 0, 1808, 0, 0, 0, 1810, 0, 0, 0, 1812, 0, 0, 0, 1814, 0, 0, 0, 1816, 0, 0, 0, 1818, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZL10our_target=allocate(1, "%class.render_target.665*", ALLOC_STATIC);
STRING_TABLE.__str147=allocate([75,101,121,98,111,97,114,100,0] /* Keyboard\00 */, "i8", ALLOC_STATIC);
__ZL15keyboard_device=allocate(1, "%class.input_device.634*", ALLOC_STATIC);
STRING_TABLE.__str1148=allocate([69,114,114,111,114,32,99,114,101,97,116,105,110,103,32,107,101,121,98,111,97,114,100,32,100,101,118,105,99,101,0] /* Error creating keybo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2149=allocate([69,115,99,0] /* Esc\00 */, "i8", ALLOC_STATIC);
__ZL14keyboard_state=allocate(9, "i8", ALLOC_STATIC);
STRING_TABLE.__str3150=allocate([80,49,0] /* P1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4151=allocate([66,49,0] /* B1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str5152=allocate([66,50,0] /* B2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6153=allocate([66,51,0] /* B3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7154=allocate([74,111,121,85,0] /* JoyU\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str8155=allocate([74,111,121,68,0] /* JoyD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str9156=allocate([74,111,121,76,0] /* JoyL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str10157=allocate([74,111,121,82,0] /* JoyR\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS18mini_osd_interface=allocate([49,56,109,105,110,105,95,111,115,100,95,105,110,116,101,114,102,97,99,101,0] /* 18mini_osd_interface */, "i8", ALLOC_STATIC);
__ZTI18mini_osd_interface=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str6164=allocate([73,56,55,52,56,0] /* I8748\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str8166=allocate([73,56,48,52,57,0] /* I8049\00 */, "i8", ALLOC_STATIC);
__ZTV12i8748_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1820, 0, 0, 0, 1822, 0, 0, 0, 1824, 0, 0, 0, 1826, 0, 0, 0, 1828, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1830, 0, 0, 0, 1832, 0, 0, 0, 1834, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1836, 0, 0, 0, 1750, 0, 0, 0, 1838, 0, 0, 0, 1840, 0, 0, 0, 1842, 0, 0, 0, 1844, 0, 0, 0, 1846, 0, 0, 0, 1848, 0, 0, 0, 1850, 0, 0, 0, 1852, 0, 0, 0, 1854, 0, 0, 0, 1856, 0, 0, 0, 1858, 0, 0, 0, 1860, 0, 0, 0, 1862, 0, 0, 0, 1864, 0, 0, 0, 1866, 0, 0, 0, 1868, 0, 0, 0, 1870, 0, 0, 0, 1872, 0, 0, 0, 1874, 0, 0, 0, 1876, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 1878, 0, 0, 0, 1880, 0, 0, 0, 1882, 0, 0, 0, 1884, 0, 0, 0, 1886, 0, 0, 0, 1888, 0, 0, 0, 1890, 0, 0, 0, 1892, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1902, 0, 0, 0, 1904, 0, 0, 0, 1906, 0, 0, 0, 1908, 0, 0, 0, 1910, 0, 0, 0, 1912, 0, 0, 0, 1914, 0, 0, 0, 1916, 0, 0, 0, 1918, 0, 0, 0, 1920, 0, 0, 0, 1922, 0, 0, 0, -5968, 0, 0, 0, 0, 0, 0, 0, 1924, 0, 0, 0, 1926, 0, 0, 0, 1882, 0, 0, 0, 1928, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1940, 0, 0, 0, 1942, 0, 0, 0, 1944, 0, 0, 0, 1946, 0, 0, 0, 1948, 0, 0, 0, -6012, 0, 0, 0, 0, 0, 0, 0, 1950, 0, 0, 0, 1952, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1956, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1958, 0, 0, 0, 1960, 0, 0, 0, 1962, 0, 0, 0, 1964, 0, 0, 0, -7088, 0, 0, 0, 0, 0, 0, 0, 1966, 0, 0, 0, 1968, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1970, 0, 0, 0, 1972, 0, 0, 0, 1974, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_I8748=allocate([66], ["%class.device_t.852* (%class.machine_config.802*, i8*, %class.device_t.852*, i32)*",0,0,0,0], ALLOC_STATIC);
__ZTV12i8049_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1976, 0, 0, 0, 1978, 0, 0, 0, 1824, 0, 0, 0, 1826, 0, 0, 0, 1828, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1830, 0, 0, 0, 1832, 0, 0, 0, 1834, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1836, 0, 0, 0, 1750, 0, 0, 0, 1838, 0, 0, 0, 1840, 0, 0, 0, 1842, 0, 0, 0, 1844, 0, 0, 0, 1846, 0, 0, 0, 1848, 0, 0, 0, 1850, 0, 0, 0, 1852, 0, 0, 0, 1854, 0, 0, 0, 1856, 0, 0, 0, 1858, 0, 0, 0, 1860, 0, 0, 0, 1862, 0, 0, 0, 1864, 0, 0, 0, 1866, 0, 0, 0, 1868, 0, 0, 0, 1870, 0, 0, 0, 1872, 0, 0, 0, 1874, 0, 0, 0, 1876, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 1980, 0, 0, 0, 1982, 0, 0, 0, 1882, 0, 0, 0, 1884, 0, 0, 0, 1886, 0, 0, 0, 1888, 0, 0, 0, 1890, 0, 0, 0, 1892, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1902, 0, 0, 0, 1904, 0, 0, 0, 1906, 0, 0, 0, 1908, 0, 0, 0, 1910, 0, 0, 0, 1912, 0, 0, 0, 1914, 0, 0, 0, 1916, 0, 0, 0, 1918, 0, 0, 0, 1920, 0, 0, 0, 1922, 0, 0, 0, -5968, 0, 0, 0, 0, 0, 0, 0, 1984, 0, 0, 0, 1986, 0, 0, 0, 1882, 0, 0, 0, 1928, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1940, 0, 0, 0, 1942, 0, 0, 0, 1944, 0, 0, 0, 1946, 0, 0, 0, 1948, 0, 0, 0, -6012, 0, 0, 0, 0, 0, 0, 0, 1988, 0, 0, 0, 1990, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1956, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1958, 0, 0, 0, 1960, 0, 0, 0, 1962, 0, 0, 0, 1964, 0, 0, 0, -7088, 0, 0, 0, 0, 0, 0, 0, 1992, 0, 0, 0, 1994, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1970, 0, 0, 0, 1972, 0, 0, 0, 1974, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_I8049=allocate([72], ["%class.device_t.852* (%class.machine_config.802*, i8*, %class.device_t.852*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS12i8049_device=allocate([49,50,105,56,48,52,57,95,100,101,118,105,99,101,0] /* 12i8049_device\00 */, "i8", ALLOC_STATIC);
__ZTI12i8049_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS12i8748_device=allocate([49,50,105,56,55,52,56,95,100,101,118,105,99,101,0] /* 12i8748_device\00 */, "i8", ALLOC_STATIC);
__ZTI12i8748_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str20182=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI12i8049_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1996, 0, 0, 0, 1998, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12i8049_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,105,56,48,52,57,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12i8049_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12i8748_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 2000, 0, 0, 0, 2002, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12i8748_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,105,56,55,52,56,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12i8748_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str21183=allocate([109,99,115,52,56,95,103,101,110,101,114,105,99,95,103,101,116,95,105,110,102,111,58,32,73,110,118,97,108,105,100,32,82,65,77,32,115,105,122,101,0] /* mcs48_generic_get_in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22184=allocate([109,99,115,52,56,95,103,101,110,101,114,105,99,95,103,101,116,95,105,110,102,111,58,32,73,110,118,97,108,105,100,32,82,79,77,32,115,105,122,101,0] /* mcs48_generic_get_in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23185=allocate([73,110,116,101,108,32,56,48,51,57,0] /* Intel 8039\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24186=allocate([49,46,50,0] /* 1.2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25187=allocate([115,114,99,47,101,109,117,47,99,112,117,47,109,99,115,52,56,47,109,99,115,52,56,46,99,0] /* src/emu/cpu/mcs48/mc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26188=allocate([67,111,112,121,114,105,103,104,116,32,77,105,114,107,111,32,66,117,102,102,111,110,105,10,66,97,115,101,100,32,111,110,32,116,104,101,32,111,114,105,103,105,110,97,108,32,119,111,114,107,32,67,111,112,121,114,105,103,104,116,32,68,97,110,32,66,111,114,105,115,0] /* Copyright Mirko Buff */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27189=allocate([37,99,37,99,32,37,99,37,99,37,99,37,99,37,99,37,99,37,99,37,99,0] /* %c%c %c%c%c%c%c%c%c% */, "i8", ALLOC_STATIC);
STRING_TABLE.__str28190=allocate([67,80,85,95,69,88,80,79,82,84,95,83,84,65,84,69,40,109,99,115,52,56,41,32,99,97,108,108,101,100,32,102,111,114,32,117,110,101,120,112,101,99,116,101,100,32,118,97,108,117,101,10,0] /* CPU_EXPORT_STATE(mcs */, "i8", ALLOC_STATIC);
STRING_TABLE.__str29191=allocate([67,80,85,95,73,77,80,79,82,84,95,83,84,65,84,69,40,109,99,115,52,56,41,32,99,97,108,108,101,100,32,102,111,114,32,117,110,101,120,112,101,99,116,101,100,32,118,97,108,117,101,10,0] /* CPU_IMPORT_STATE(mcs */, "i8", ALLOC_STATIC);
__ZL12opcode_table=allocate([2004, 0, 0, 0, 2006, 0, 0, 0, 2008, 0, 0, 0, 2010, 0, 0, 0, 2012, 0, 0, 0, 2014, 0, 0, 0, 2006, 0, 0, 0, 2016, 0, 0, 0, 2018, 0, 0, 0, 2020, 0, 0, 0, 2022, 0, 0, 0, 2006, 0, 0, 0, 2024, 0, 0, 0, 2026, 0, 0, 0, 2028, 0, 0, 0, 2030, 0, 0, 0, 2032, 0, 0, 0, 2034, 0, 0, 0, 2036, 0, 0, 0, 2038, 0, 0, 0, 2040, 0, 0, 0, 2042, 0, 0, 0, 2044, 0, 0, 0, 2046, 0, 0, 0, 2048, 0, 0, 0, 2050, 0, 0, 0, 2052, 0, 0, 0, 2054, 0, 0, 0, 2056, 0, 0, 0, 2058, 0, 0, 0, 2060, 0, 0, 0, 2062, 0, 0, 0, 2064, 0, 0, 0, 2066, 0, 0, 0, 2068, 0, 0, 0, 2070, 0, 0, 0, 2072, 0, 0, 0, 2074, 0, 0, 0, 2076, 0, 0, 0, 2078, 0, 0, 0, 2080, 0, 0, 0, 2082, 0, 0, 0, 2084, 0, 0, 0, 2086, 0, 0, 0, 2088, 0, 0, 0, 2090, 0, 0, 0, 2092, 0, 0, 0, 2094, 0, 0, 0, 2096, 0, 0, 0, 2098, 0, 0, 0, 2100, 0, 0, 0, 2006, 0, 0, 0, 2102, 0, 0, 0, 2104, 0, 0, 0, 2106, 0, 0, 0, 2108, 0, 0, 0, 2006, 0, 0, 0, 2110, 0, 0, 0, 2112, 0, 0, 0, 2006, 0, 0, 0, 2114, 0, 0, 0, 2116, 0, 0, 0, 2118, 0, 0, 0, 2120, 0, 0, 0, 2122, 0, 0, 0, 2124, 0, 0, 0, 2126, 0, 0, 0, 2128, 0, 0, 0, 2130, 0, 0, 0, 2132, 0, 0, 0, 2134, 0, 0, 0, 2136, 0, 0, 0, 2138, 0, 0, 0, 2140, 0, 0, 0, 2142, 0, 0, 0, 2144, 0, 0, 0, 2146, 0, 0, 0, 2148, 0, 0, 0, 2150, 0, 0, 0, 2152, 0, 0, 0, 2154, 0, 0, 0, 2156, 0, 0, 0, 2158, 0, 0, 0, 2160, 0, 0, 0, 2162, 0, 0, 0, 2164, 0, 0, 0, 2166, 0, 0, 0, 2168, 0, 0, 0, 2170, 0, 0, 0, 2172, 0, 0, 0, 2174, 0, 0, 0, 2176, 0, 0, 0, 2178, 0, 0, 0, 2180, 0, 0, 0, 2182, 0, 0, 0, 2184, 0, 0, 0, 2186, 0, 0, 0, 2188, 0, 0, 0, 2190, 0, 0, 0, 2006, 0, 0, 0, 2192, 0, 0, 0, 2194, 0, 0, 0, 2006, 0, 0, 0, 2196, 0, 0, 0, 2198, 0, 0, 0, 2200, 0, 0, 0, 2202, 0, 0, 0, 2204, 0, 0, 0, 2206, 0, 0, 0, 2208, 0, 0, 0, 2210, 0, 0, 0, 2212, 0, 0, 0, 2214, 0, 0, 0, 2216, 0, 0, 0, 2218, 0, 0, 0, 2006, 0, 0, 0, 2220, 0, 0, 0, 2222, 0, 0, 0, 2224, 0, 0, 0, 2226, 0, 0, 0, 2228, 0, 0, 0, 2230, 0, 0, 0, 2232, 0, 0, 0, 2234, 0, 0, 0, 2236, 0, 0, 0, 2238, 0, 0, 0, 2240, 0, 0, 0, 2242, 0, 0, 0, 2244, 0, 0, 0, 2246, 0, 0, 0, 2006, 0, 0, 0, 2248, 0, 0, 0, 2250, 0, 0, 0, 2252, 0, 0, 0, 2254, 0, 0, 0, 2006, 0, 0, 0, 2256, 0, 0, 0, 2258, 0, 0, 0, 2260, 0, 0, 0, 2006, 0, 0, 0, 2262, 0, 0, 0, 2264, 0, 0, 0, 2266, 0, 0, 0, 2268, 0, 0, 0, 2270, 0, 0, 0, 2272, 0, 0, 0, 2274, 0, 0, 0, 2276, 0, 0, 0, 2278, 0, 0, 0, 2280, 0, 0, 0, 2282, 0, 0, 0, 2284, 0, 0, 0, 2286, 0, 0, 0, 2288, 0, 0, 0, 2290, 0, 0, 0, 2006, 0, 0, 0, 2292, 0, 0, 0, 2294, 0, 0, 0, 2296, 0, 0, 0, 2298, 0, 0, 0, 2300, 0, 0, 0, 2302, 0, 0, 0, 2006, 0, 0, 0, 2304, 0, 0, 0, 2306, 0, 0, 0, 2308, 0, 0, 0, 2006, 0, 0, 0, 2310, 0, 0, 0, 2312, 0, 0, 0, 2314, 0, 0, 0, 2316, 0, 0, 0, 2318, 0, 0, 0, 2320, 0, 0, 0, 2322, 0, 0, 0, 2324, 0, 0, 0, 2326, 0, 0, 0, 2328, 0, 0, 0, 2330, 0, 0, 0, 2332, 0, 0, 0, 2334, 0, 0, 0, 2336, 0, 0, 0, 2338, 0, 0, 0, 2340, 0, 0, 0, 2006, 0, 0, 0, 2342, 0, 0, 0, 2344, 0, 0, 0, 2346, 0, 0, 0, 2348, 0, 0, 0, 2350, 0, 0, 0, 2352, 0, 0, 0, 2354, 0, 0, 0, 2356, 0, 0, 0, 2006, 0, 0, 0, 2006, 0, 0, 0, 2006, 0, 0, 0, 2006, 0, 0, 0, 2358, 0, 0, 0, 2360, 0, 0, 0, 2362, 0, 0, 0, 2364, 0, 0, 0, 2366, 0, 0, 0, 2368, 0, 0, 0, 2370, 0, 0, 0, 2372, 0, 0, 0, 2374, 0, 0, 0, 2376, 0, 0, 0, 2378, 0, 0, 0, 2380, 0, 0, 0, 2382, 0, 0, 0, 2384, 0, 0, 0, 2386, 0, 0, 0, 2388, 0, 0, 0, 2390, 0, 0, 0, 2392, 0, 0, 0, 2394, 0, 0, 0, 2396, 0, 0, 0, 2398, 0, 0, 0, 2400, 0, 0, 0, 2402, 0, 0, 0, 2404, 0, 0, 0, 2406, 0, 0, 0, 2408, 0, 0, 0, 2410, 0, 0, 0, 2412, 0, 0, 0, 2006, 0, 0, 0, 2006, 0, 0, 0, 2006, 0, 0, 0, 2414, 0, 0, 0, 2416, 0, 0, 0, 2418, 0, 0, 0, 2420, 0, 0, 0, 2422, 0, 0, 0, 2424, 0, 0, 0, 2426, 0, 0, 0, 2428, 0, 0, 0, 2430, 0, 0, 0, 2432, 0, 0, 0, 2434, 0, 0, 0, 2436, 0, 0, 0, 2438, 0, 0, 0, 2440, 0, 0, 0, 2442, 0, 0, 0, 2444, 0, 0, 0, 2006, 0, 0, 0, 2446, 0, 0, 0, 2448, 0, 0, 0, 2450, 0, 0, 0, 2452, 0, 0, 0, 2454, 0, 0, 0, 2456, 0, 0, 0, 2458, 0, 0, 0, 2460, 0, 0, 0, 2462, 0, 0, 0, 2464, 0, 0, 0, 2466, 0, 0, 0, 2468, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str30192=allocate([77,67,83,45,52,56,32,80,67,58,37,48,52,88,32,45,32,85,110,105,109,112,108,101,109,101,110,116,101,100,32,111,112,99,111,100,101,32,61,32,37,48,50,120,10,0] /* MCS-48 PC:%04X - Uni */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31193=allocate([77,67,83,45,52,56,32,80,67,58,37,48,52,88,32,45,32,73,108,108,101,103,97,108,32,111,112,99,111,100,101,32,61,32,37,48,50,120,10,0] /* MCS-48 PC:%04X - Ill */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32194=allocate([80,67,0] /* PC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33195=allocate([71,69,78,80,67,0] /* GENPC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34196=allocate([71,69,78,80,67,66,65,83,69,0] /* GENPCBASE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35197=allocate([71,69,78,83,80,0] /* GENSP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36198=allocate([71,69,78,70,76,65,71,83,0] /* GENFLAGS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37199=allocate([37,49,48,115,0] /* %10s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str38200=allocate([65,0] /* A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str39201=allocate([84,67,0] /* TC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str40202=allocate([84,80,82,69,0] /* TPRE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41203=allocate([80,49,0] /* P1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42204=allocate([80,50,0] /* P2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43205=allocate([82,37,100,0] /* R%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44206=allocate([69,65,0] /* EA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45207=allocate([83,84,83,0] /* STS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46208=allocate([68,66,66,73,0] /* DBBI\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47209=allocate([68,66,66,79,0] /* DBBO\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str48210=allocate([99,112,117,115,116,97,116,101,45,62,112,114,101,118,112,99,0] /* cpustate->prevpc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str49211=allocate([99,112,117,115,116,97,116,101,45,62,112,99,0] /* cpustate->pc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str50212=allocate([99,112,117,115,116,97,116,101,45,62,97,0] /* cpustate->a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51213=allocate([99,112,117,115,116,97,116,101,45,62,112,115,119,0] /* cpustate->psw\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52214=allocate([99,112,117,115,116,97,116,101,45,62,112,49,0] /* cpustate->p1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53215=allocate([99,112,117,115,116,97,116,101,45,62,112,50,0] /* cpustate->p2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54216=allocate([99,112,117,115,116,97,116,101,45,62,101,97,0] /* cpustate->ea\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55217=allocate([99,112,117,115,116,97,116,101,45,62,116,105,109,101,114,0] /* cpustate->timer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56218=allocate([99,112,117,115,116,97,116,101,45,62,112,114,101,115,99,97,108,101,114,0] /* cpustate->prescaler\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57219=allocate([99,112,117,115,116,97,116,101,45,62,116,49,95,104,105,115,116,111,114,121,0] /* cpustate->t1_history */, "i8", ALLOC_STATIC);
STRING_TABLE.__str58220=allocate([99,112,117,115,116,97,116,101,45,62,115,116,115,0] /* cpustate->sts\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str59221=allocate([99,112,117,115,116,97,116,101,45,62,100,98,98,105,0] /* cpustate->dbbi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str60222=allocate([99,112,117,115,116,97,116,101,45,62,100,98,98,111,0] /* cpustate->dbbo\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61223=allocate([99,112,117,115,116,97,116,101,45,62,105,114,113,95,115,116,97,116,101,0] /* cpustate->irq_state\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62224=allocate([99,112,117,115,116,97,116,101,45,62,105,114,113,95,105,110,95,112,114,111,103,114,101,115,115,0] /* cpustate->irq_in_pro */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63225=allocate([99,112,117,115,116,97,116,101,45,62,116,105,109,101,114,95,111,118,101,114,102,108,111,119,0] /* cpustate->timer_over */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64226=allocate([99,112,117,115,116,97,116,101,45,62,116,105,109,101,114,95,102,108,97,103,0] /* cpustate->timer_flag */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65227=allocate([99,112,117,115,116,97,116,101,45,62,116,105,114,113,95,101,110,97,98,108,101,100,0] /* cpustate->tirq_enabl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66228=allocate([99,112,117,115,116,97,116,101,45,62,120,105,114,113,95,101,110,97,98,108,101,100,0] /* cpustate->xirq_enabl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67229=allocate([99,112,117,115,116,97,116,101,45,62,116,105,109,101,99,111,117,110,116,95,101,110,97,98,108,101,100,0] /* cpustate->timecount_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str68230=allocate([99,112,117,115,116,97,116,101,45,62,102,108,97,103,115,95,101,110,97,98,108,101,100,0] /* cpustate->flags_enab */, "i8", ALLOC_STATIC);
STRING_TABLE.__str69231=allocate([99,112,117,115,116,97,116,101,45,62,100,109,97,95,101,110,97,98,108,101,100,0] /* cpustate->dma_enable */, "i8", ALLOC_STATIC);
STRING_TABLE.__str70232=allocate([99,112,117,115,116,97,116,101,45,62,97,49,49,0] /* cpustate->a11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS15running_machine=allocate([49,53,114,117,110,110,105,110,103,95,109,97,99,104,105,110,101,0] /* 15running_machine\00 */, "i8", ALLOC_STATIC);
__ZTI15running_machine=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZL5cc_op=allocate([4,10,7,6,4,4,7,4,4,11,7,6,4,4,7,4,8,10,7,6,4,4,7,4,12,11,7,6,4,4,7,4,7,10,16,6,4,4,7,4,7,11,16,6,4,4,7,4,7,10,13,6,11,11,10,4,7,11,13,6,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,7,7,7,7,7,7,4,7,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,5,10,10,10,10,11,7,11,5,10,10,0,10,17,7,11,5,10,10,11,10,11,7,11,5,4,10,11,10,0,7,11,5,10,10,19,10,11,7,11,5,4,10,4,10,0,7,11,5,10,10,4,10,11,7,11,5,6,10,4,10,0,7,11] /* \04\0A\07\06\04\04\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL5cc_cb=allocate([8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8] /* \08\08\08\08\08\08\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL5cc_ed=allocate([8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,18,12,12,15,20,8,14,8,18,12,12,15,20,8,14,8,8,12,12,15,20,8,14,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,16,16,16,16,8,8,8,8,16,16,16,16,8,8,8,8,16,16,16,16,8,8,8,8,16,16,16,16,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8] /* \08\08\08\08\08\08\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL5cc_xy=allocate([4,4,4,4,4,4,4,4,4,15,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,15,4,4,4,4,4,4,4,14,20,10,9,9,11,4,4,15,20,10,9,9,11,4,4,4,4,4,23,23,19,4,4,15,4,4,4,4,4,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,9,9,9,9,9,9,19,9,9,9,9,9,9,9,19,9,19,19,19,19,19,19,4,19,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,9,9,19,4,4,4,4,4,4,4,4,4,4,4,4,0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,14,4,23,4,15,4,4,4,8,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,10,4,4,4,4,4,4] /* \04\04\04\04\04\04\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL7cc_xycb=allocate([23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23] /* \17\17\17\17\17\17\1 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL5cc_ex=allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,0,0,0,0,5,5,5,5,0,0,0,0,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2,6,0,0,0,7,0,0,2] /* \00\00\00\00\00\00\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233=allocate([90,56,48,0] /* Z80\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1234=allocate([90,105,108,111,103,32,90,56,48,0] /* Zilog Z80\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2235=allocate([51,46,57,0] /* 3.9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3236=allocate([115,114,99,47,101,109,117,47,99,112,117,47,122,56,48,47,122,56,48,46,99,0] /* src/emu/cpu/z80/z80. */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4237=allocate([67,111,112,121,114,105,103,104,116,32,74,117,101,114,103,101,110,32,66,117,99,104,109,117,101,108,108,101,114,44,32,97,108,108,32,114,105,103,104,116,115,32,114,101,115,101,114,118,101,100,46,0] /* Copyright Juergen Bu */, "i8", ALLOC_STATIC);
__ZTV10z80_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 2470, 0, 0, 0, 2472, 0, 0, 0, 1824, 0, 0, 0, 1826, 0, 0, 0, 1828, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1830, 0, 0, 0, 1832, 0, 0, 0, 1834, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1836, 0, 0, 0, 1750, 0, 0, 0, 1838, 0, 0, 0, 1840, 0, 0, 0, 1842, 0, 0, 0, 1844, 0, 0, 0, 1846, 0, 0, 0, 1848, 0, 0, 0, 1850, 0, 0, 0, 1852, 0, 0, 0, 1854, 0, 0, 0, 1856, 0, 0, 0, 1858, 0, 0, 0, 1860, 0, 0, 0, 1862, 0, 0, 0, 1864, 0, 0, 0, 1866, 0, 0, 0, 1868, 0, 0, 0, 1870, 0, 0, 0, 1872, 0, 0, 0, 1874, 0, 0, 0, 1876, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 2474, 0, 0, 0, 2476, 0, 0, 0, 1882, 0, 0, 0, 1884, 0, 0, 0, 1886, 0, 0, 0, 1888, 0, 0, 0, 1890, 0, 0, 0, 1892, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1902, 0, 0, 0, 1904, 0, 0, 0, 1906, 0, 0, 0, 1908, 0, 0, 0, 1910, 0, 0, 0, 1912, 0, 0, 0, 1914, 0, 0, 0, 1916, 0, 0, 0, 1918, 0, 0, 0, 1920, 0, 0, 0, 1922, 0, 0, 0, -5968, 0, 0, 0, 0, 0, 0, 0, 2478, 0, 0, 0, 2480, 0, 0, 0, 1882, 0, 0, 0, 1928, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1940, 0, 0, 0, 1942, 0, 0, 0, 1944, 0, 0, 0, 1946, 0, 0, 0, 1948, 0, 0, 0, -6012, 0, 0, 0, 0, 0, 0, 0, 2482, 0, 0, 0, 2484, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1956, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1958, 0, 0, 0, 1960, 0, 0, 0, 1962, 0, 0, 0, 1964, 0, 0, 0, -7088, 0, 0, 0, 0, 0, 0, 0, 2486, 0, 0, 0, 2488, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1970, 0, 0, 0, 1972, 0, 0, 0, 1974, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_Z80=allocate([108], ["%class.device_t.852* (%class.machine_config.802*, i8*, %class.device_t.852*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS10z80_device=allocate([49,48,122,56,48,95,100,101,118,105,99,101,0] /* 10z80_device\00 */, "i8", ALLOC_STATIC);
__ZTI10z80_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str6241=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI10z80_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 2490, 0, 0, 0, 2492, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI10z80_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,48,122,56,48,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI10z80_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZL9SZHVC_sub=allocate(1, "i8*", ALLOC_STATIC);
__ZL5Z80fd=allocate([2494, 0, 0, 0, 2496, 0, 0, 0, 2498, 0, 0, 0, 2500, 0, 0, 0, 2502, 0, 0, 0, 2504, 0, 0, 0, 2506, 0, 0, 0, 2508, 0, 0, 0, 2510, 0, 0, 0, 2512, 0, 0, 0, 2514, 0, 0, 0, 2516, 0, 0, 0, 2518, 0, 0, 0, 2520, 0, 0, 0, 2522, 0, 0, 0, 2524, 0, 0, 0, 2526, 0, 0, 0, 2528, 0, 0, 0, 2530, 0, 0, 0, 2532, 0, 0, 0, 2534, 0, 0, 0, 2536, 0, 0, 0, 2538, 0, 0, 0, 2540, 0, 0, 0, 2542, 0, 0, 0, 2544, 0, 0, 0, 2546, 0, 0, 0, 2548, 0, 0, 0, 2550, 0, 0, 0, 2552, 0, 0, 0, 2554, 0, 0, 0, 2556, 0, 0, 0, 2558, 0, 0, 0, 2560, 0, 0, 0, 2562, 0, 0, 0, 2564, 0, 0, 0, 2566, 0, 0, 0, 2568, 0, 0, 0, 2570, 0, 0, 0, 2572, 0, 0, 0, 2574, 0, 0, 0, 2576, 0, 0, 0, 2578, 0, 0, 0, 2580, 0, 0, 0, 2582, 0, 0, 0, 2584, 0, 0, 0, 2586, 0, 0, 0, 2588, 0, 0, 0, 2590, 0, 0, 0, 2592, 0, 0, 0, 2594, 0, 0, 0, 2596, 0, 0, 0, 2598, 0, 0, 0, 2600, 0, 0, 0, 2602, 0, 0, 0, 2604, 0, 0, 0, 2606, 0, 0, 0, 2608, 0, 0, 0, 2610, 0, 0, 0, 2612, 0, 0, 0, 2614, 0, 0, 0, 2616, 0, 0, 0, 2618, 0, 0, 0, 2620, 0, 0, 0, 2622, 0, 0, 0, 2624, 0, 0, 0, 2626, 0, 0, 0, 2628, 0, 0, 0, 2630, 0, 0, 0, 2632, 0, 0, 0, 2634, 0, 0, 0, 2636, 0, 0, 0, 2638, 0, 0, 0, 2640, 0, 0, 0, 2642, 0, 0, 0, 2644, 0, 0, 0, 2646, 0, 0, 0, 2648, 0, 0, 0, 2650, 0, 0, 0, 2652, 0, 0, 0, 2654, 0, 0, 0, 2656, 0, 0, 0, 2658, 0, 0, 0, 2660, 0, 0, 0, 2662, 0, 0, 0, 2664, 0, 0, 0, 2666, 0, 0, 0, 2668, 0, 0, 0, 2670, 0, 0, 0, 2672, 0, 0, 0, 2674, 0, 0, 0, 2676, 0, 0, 0, 2678, 0, 0, 0, 2680, 0, 0, 0, 2682, 0, 0, 0, 2684, 0, 0, 0, 2686, 0, 0, 0, 2688, 0, 0, 0, 2690, 0, 0, 0, 2692, 0, 0, 0, 2694, 0, 0, 0, 2696, 0, 0, 0, 2698, 0, 0, 0, 2700, 0, 0, 0, 2702, 0, 0, 0, 2704, 0, 0, 0, 2706, 0, 0, 0, 2708, 0, 0, 0, 2710, 0, 0, 0, 2712, 0, 0, 0, 2714, 0, 0, 0, 2716, 0, 0, 0, 2718, 0, 0, 0, 2720, 0, 0, 0, 2722, 0, 0, 0, 2724, 0, 0, 0, 2726, 0, 0, 0, 2728, 0, 0, 0, 2730, 0, 0, 0, 2732, 0, 0, 0, 2734, 0, 0, 0, 2736, 0, 0, 0, 2738, 0, 0, 0, 2740, 0, 0, 0, 2742, 0, 0, 0, 2744, 0, 0, 0, 2746, 0, 0, 0, 2748, 0, 0, 0, 2750, 0, 0, 0, 2752, 0, 0, 0, 2754, 0, 0, 0, 2756, 0, 0, 0, 2758, 0, 0, 0, 2760, 0, 0, 0, 2762, 0, 0, 0, 2764, 0, 0, 0, 2766, 0, 0, 0, 2768, 0, 0, 0, 2770, 0, 0, 0, 2772, 0, 0, 0, 2774, 0, 0, 0, 2776, 0, 0, 0, 2778, 0, 0, 0, 2780, 0, 0, 0, 2782, 0, 0, 0, 2784, 0, 0, 0, 2786, 0, 0, 0, 2788, 0, 0, 0, 2790, 0, 0, 0, 2792, 0, 0, 0, 2794, 0, 0, 0, 2796, 0, 0, 0, 2798, 0, 0, 0, 2800, 0, 0, 0, 2802, 0, 0, 0, 2804, 0, 0, 0, 2806, 0, 0, 0, 2808, 0, 0, 0, 2810, 0, 0, 0, 2812, 0, 0, 0, 2814, 0, 0, 0, 2816, 0, 0, 0, 2818, 0, 0, 0, 2820, 0, 0, 0, 2822, 0, 0, 0, 2824, 0, 0, 0, 2826, 0, 0, 0, 2828, 0, 0, 0, 2830, 0, 0, 0, 2832, 0, 0, 0, 2834, 0, 0, 0, 2836, 0, 0, 0, 2838, 0, 0, 0, 2840, 0, 0, 0, 2842, 0, 0, 0, 2844, 0, 0, 0, 2846, 0, 0, 0, 2848, 0, 0, 0, 2850, 0, 0, 0, 2852, 0, 0, 0, 2854, 0, 0, 0, 2856, 0, 0, 0, 2858, 0, 0, 0, 2860, 0, 0, 0, 2862, 0, 0, 0, 2864, 0, 0, 0, 2866, 0, 0, 0, 2868, 0, 0, 0, 2870, 0, 0, 0, 2872, 0, 0, 0, 2874, 0, 0, 0, 2876, 0, 0, 0, 2878, 0, 0, 0, 2880, 0, 0, 0, 2882, 0, 0, 0, 2884, 0, 0, 0, 2886, 0, 0, 0, 2888, 0, 0, 0, 2890, 0, 0, 0, 2892, 0, 0, 0, 2894, 0, 0, 0, 2896, 0, 0, 0, 2898, 0, 0, 0, 2900, 0, 0, 0, 2902, 0, 0, 0, 2904, 0, 0, 0, 2906, 0, 0, 0, 2908, 0, 0, 0, 2910, 0, 0, 0, 2912, 0, 0, 0, 2914, 0, 0, 0, 2916, 0, 0, 0, 2918, 0, 0, 0, 2920, 0, 0, 0, 2922, 0, 0, 0, 2924, 0, 0, 0, 2926, 0, 0, 0, 2928, 0, 0, 0, 2930, 0, 0, 0, 2932, 0, 0, 0, 2934, 0, 0, 0, 2936, 0, 0, 0, 2938, 0, 0, 0, 2940, 0, 0, 0, 2942, 0, 0, 0, 2944, 0, 0, 0, 2946, 0, 0, 0, 2948, 0, 0, 0, 2950, 0, 0, 0, 2952, 0, 0, 0, 2954, 0, 0, 0, 2956, 0, 0, 0, 2958, 0, 0, 0, 2960, 0, 0, 0, 2962, 0, 0, 0, 2964, 0, 0, 0, 2966, 0, 0, 0, 2968, 0, 0, 0, 2970, 0, 0, 0, 2972, 0, 0, 0, 2974, 0, 0, 0, 2976, 0, 0, 0, 2978, 0, 0, 0, 2980, 0, 0, 0, 2982, 0, 0, 0, 2984, 0, 0, 0, 2986, 0, 0, 0, 2988, 0, 0, 0, 2990, 0, 0, 0, 2992, 0, 0, 0, 2994, 0, 0, 0, 2996, 0, 0, 0, 2998, 0, 0, 0, 3000, 0, 0, 0, 3002, 0, 0, 0, 3004, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str7242=allocate([90,56,48,32,39,37,115,39,32,105,108,108,46,32,111,112,99,111,100,101,32,36,37,48,50,120,32,36,37,48,50,120,10,0] /* Z80 '%s' ill. opcode */, "i8", ALLOC_STATIC);
__ZL7Z80xycb=allocate([3006, 0, 0, 0, 3008, 0, 0, 0, 3010, 0, 0, 0, 3012, 0, 0, 0, 3014, 0, 0, 0, 3016, 0, 0, 0, 3018, 0, 0, 0, 3020, 0, 0, 0, 3022, 0, 0, 0, 3024, 0, 0, 0, 3026, 0, 0, 0, 3028, 0, 0, 0, 3030, 0, 0, 0, 3032, 0, 0, 0, 3034, 0, 0, 0, 3036, 0, 0, 0, 3038, 0, 0, 0, 3040, 0, 0, 0, 3042, 0, 0, 0, 3044, 0, 0, 0, 3046, 0, 0, 0, 3048, 0, 0, 0, 3050, 0, 0, 0, 3052, 0, 0, 0, 3054, 0, 0, 0, 3056, 0, 0, 0, 3058, 0, 0, 0, 3060, 0, 0, 0, 3062, 0, 0, 0, 3064, 0, 0, 0, 3066, 0, 0, 0, 3068, 0, 0, 0, 3070, 0, 0, 0, 3072, 0, 0, 0, 3074, 0, 0, 0, 3076, 0, 0, 0, 3078, 0, 0, 0, 3080, 0, 0, 0, 3082, 0, 0, 0, 3084, 0, 0, 0, 3086, 0, 0, 0, 3088, 0, 0, 0, 3090, 0, 0, 0, 3092, 0, 0, 0, 3094, 0, 0, 0, 3096, 0, 0, 0, 3098, 0, 0, 0, 3100, 0, 0, 0, 3102, 0, 0, 0, 3104, 0, 0, 0, 3106, 0, 0, 0, 3108, 0, 0, 0, 3110, 0, 0, 0, 3112, 0, 0, 0, 3114, 0, 0, 0, 3116, 0, 0, 0, 3118, 0, 0, 0, 3120, 0, 0, 0, 3122, 0, 0, 0, 3124, 0, 0, 0, 3126, 0, 0, 0, 3128, 0, 0, 0, 3130, 0, 0, 0, 3132, 0, 0, 0, 3134, 0, 0, 0, 3136, 0, 0, 0, 3138, 0, 0, 0, 3140, 0, 0, 0, 3142, 0, 0, 0, 3144, 0, 0, 0, 3146, 0, 0, 0, 3148, 0, 0, 0, 3150, 0, 0, 0, 3152, 0, 0, 0, 3154, 0, 0, 0, 3156, 0, 0, 0, 3158, 0, 0, 0, 3160, 0, 0, 0, 3162, 0, 0, 0, 3164, 0, 0, 0, 3166, 0, 0, 0, 3168, 0, 0, 0, 3170, 0, 0, 0, 3172, 0, 0, 0, 3174, 0, 0, 0, 3176, 0, 0, 0, 3178, 0, 0, 0, 3180, 0, 0, 0, 3182, 0, 0, 0, 3184, 0, 0, 0, 3186, 0, 0, 0, 3188, 0, 0, 0, 3190, 0, 0, 0, 3192, 0, 0, 0, 3194, 0, 0, 0, 3196, 0, 0, 0, 3198, 0, 0, 0, 3200, 0, 0, 0, 3202, 0, 0, 0, 3204, 0, 0, 0, 3206, 0, 0, 0, 3208, 0, 0, 0, 3210, 0, 0, 0, 3212, 0, 0, 0, 3214, 0, 0, 0, 3216, 0, 0, 0, 3218, 0, 0, 0, 3220, 0, 0, 0, 3222, 0, 0, 0, 3224, 0, 0, 0, 3226, 0, 0, 0, 3228, 0, 0, 0, 3230, 0, 0, 0, 3232, 0, 0, 0, 3234, 0, 0, 0, 3236, 0, 0, 0, 3238, 0, 0, 0, 3240, 0, 0, 0, 3242, 0, 0, 0, 3244, 0, 0, 0, 3246, 0, 0, 0, 3248, 0, 0, 0, 3250, 0, 0, 0, 3252, 0, 0, 0, 3254, 0, 0, 0, 3256, 0, 0, 0, 3258, 0, 0, 0, 3260, 0, 0, 0, 3262, 0, 0, 0, 3264, 0, 0, 0, 3266, 0, 0, 0, 3268, 0, 0, 0, 3270, 0, 0, 0, 3272, 0, 0, 0, 3274, 0, 0, 0, 3276, 0, 0, 0, 3278, 0, 0, 0, 3280, 0, 0, 0, 3282, 0, 0, 0, 3284, 0, 0, 0, 3286, 0, 0, 0, 3288, 0, 0, 0, 3290, 0, 0, 0, 3292, 0, 0, 0, 3294, 0, 0, 0, 3296, 0, 0, 0, 3298, 0, 0, 0, 3300, 0, 0, 0, 3302, 0, 0, 0, 3304, 0, 0, 0, 3306, 0, 0, 0, 3308, 0, 0, 0, 3310, 0, 0, 0, 3312, 0, 0, 0, 3314, 0, 0, 0, 3316, 0, 0, 0, 3318, 0, 0, 0, 3320, 0, 0, 0, 3322, 0, 0, 0, 3324, 0, 0, 0, 3326, 0, 0, 0, 3328, 0, 0, 0, 3330, 0, 0, 0, 3332, 0, 0, 0, 3334, 0, 0, 0, 3336, 0, 0, 0, 3338, 0, 0, 0, 3340, 0, 0, 0, 3342, 0, 0, 0, 3344, 0, 0, 0, 3346, 0, 0, 0, 3348, 0, 0, 0, 3350, 0, 0, 0, 3352, 0, 0, 0, 3354, 0, 0, 0, 3356, 0, 0, 0, 3358, 0, 0, 0, 3360, 0, 0, 0, 3362, 0, 0, 0, 3364, 0, 0, 0, 3366, 0, 0, 0, 3368, 0, 0, 0, 3370, 0, 0, 0, 3372, 0, 0, 0, 3374, 0, 0, 0, 3376, 0, 0, 0, 3378, 0, 0, 0, 3380, 0, 0, 0, 3382, 0, 0, 0, 3384, 0, 0, 0, 3386, 0, 0, 0, 3388, 0, 0, 0, 3390, 0, 0, 0, 3392, 0, 0, 0, 3394, 0, 0, 0, 3396, 0, 0, 0, 3398, 0, 0, 0, 3400, 0, 0, 0, 3402, 0, 0, 0, 3404, 0, 0, 0, 3406, 0, 0, 0, 3408, 0, 0, 0, 3410, 0, 0, 0, 3412, 0, 0, 0, 3414, 0, 0, 0, 3416, 0, 0, 0, 3418, 0, 0, 0, 3420, 0, 0, 0, 3422, 0, 0, 0, 3424, 0, 0, 0, 3426, 0, 0, 0, 3428, 0, 0, 0, 3430, 0, 0, 0, 3432, 0, 0, 0, 3434, 0, 0, 0, 3436, 0, 0, 0, 3438, 0, 0, 0, 3440, 0, 0, 0, 3442, 0, 0, 0, 3444, 0, 0, 0, 3446, 0, 0, 0, 3448, 0, 0, 0, 3450, 0, 0, 0, 3452, 0, 0, 0, 3454, 0, 0, 0, 3456, 0, 0, 0, 3458, 0, 0, 0, 3460, 0, 0, 0, 3462, 0, 0, 0, 3464, 0, 0, 0, 3466, 0, 0, 0, 3468, 0, 0, 0, 3470, 0, 0, 0, 3472, 0, 0, 0, 3474, 0, 0, 0, 3476, 0, 0, 0, 3478, 0, 0, 0, 3480, 0, 0, 0, 3482, 0, 0, 0, 3484, 0, 0, 0, 3486, 0, 0, 0, 3488, 0, 0, 0, 3490, 0, 0, 0, 3492, 0, 0, 0, 3494, 0, 0, 0, 3496, 0, 0, 0, 3498, 0, 0, 0, 3500, 0, 0, 0, 3502, 0, 0, 0, 3504, 0, 0, 0, 3506, 0, 0, 0, 3508, 0, 0, 0, 3510, 0, 0, 0, 3512, 0, 0, 0, 3514, 0, 0, 0, 3516, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL6SZ_BIT=allocate(256, "i8", ALLOC_STATIC);
__ZL3SZP=allocate(256, "i8", ALLOC_STATIC);
__ZL9SZHVC_add=allocate(1, "i8*", ALLOC_STATIC);
__ZL8SZHV_dec=allocate(256, "i8", ALLOC_STATIC);
__ZL8SZHV_inc=allocate(256, "i8", ALLOC_STATIC);
__ZL5Z80ed=allocate([3518, 0, 0, 0, 3520, 0, 0, 0, 3522, 0, 0, 0, 3524, 0, 0, 0, 3526, 0, 0, 0, 3528, 0, 0, 0, 3530, 0, 0, 0, 3532, 0, 0, 0, 3534, 0, 0, 0, 3536, 0, 0, 0, 3538, 0, 0, 0, 3540, 0, 0, 0, 3542, 0, 0, 0, 3544, 0, 0, 0, 3546, 0, 0, 0, 3548, 0, 0, 0, 3550, 0, 0, 0, 3552, 0, 0, 0, 3554, 0, 0, 0, 3556, 0, 0, 0, 3558, 0, 0, 0, 3560, 0, 0, 0, 3562, 0, 0, 0, 3564, 0, 0, 0, 3566, 0, 0, 0, 3568, 0, 0, 0, 3570, 0, 0, 0, 3572, 0, 0, 0, 3574, 0, 0, 0, 3576, 0, 0, 0, 3578, 0, 0, 0, 3580, 0, 0, 0, 3582, 0, 0, 0, 3584, 0, 0, 0, 3586, 0, 0, 0, 3588, 0, 0, 0, 3590, 0, 0, 0, 3592, 0, 0, 0, 3594, 0, 0, 0, 3596, 0, 0, 0, 3598, 0, 0, 0, 3600, 0, 0, 0, 3602, 0, 0, 0, 3604, 0, 0, 0, 3606, 0, 0, 0, 3608, 0, 0, 0, 3610, 0, 0, 0, 3612, 0, 0, 0, 3614, 0, 0, 0, 3616, 0, 0, 0, 3618, 0, 0, 0, 3620, 0, 0, 0, 3622, 0, 0, 0, 3624, 0, 0, 0, 3626, 0, 0, 0, 3628, 0, 0, 0, 3630, 0, 0, 0, 3632, 0, 0, 0, 3634, 0, 0, 0, 3636, 0, 0, 0, 3638, 0, 0, 0, 3640, 0, 0, 0, 3642, 0, 0, 0, 3644, 0, 0, 0, 3646, 0, 0, 0, 3648, 0, 0, 0, 3650, 0, 0, 0, 3652, 0, 0, 0, 3654, 0, 0, 0, 3656, 0, 0, 0, 3658, 0, 0, 0, 3660, 0, 0, 0, 3662, 0, 0, 0, 3664, 0, 0, 0, 3666, 0, 0, 0, 3668, 0, 0, 0, 3670, 0, 0, 0, 3672, 0, 0, 0, 3674, 0, 0, 0, 3676, 0, 0, 0, 3678, 0, 0, 0, 3680, 0, 0, 0, 3682, 0, 0, 0, 3684, 0, 0, 0, 3686, 0, 0, 0, 3688, 0, 0, 0, 3690, 0, 0, 0, 3692, 0, 0, 0, 3694, 0, 0, 0, 3696, 0, 0, 0, 3698, 0, 0, 0, 3700, 0, 0, 0, 3702, 0, 0, 0, 3704, 0, 0, 0, 3706, 0, 0, 0, 3708, 0, 0, 0, 3710, 0, 0, 0, 3712, 0, 0, 0, 3714, 0, 0, 0, 3716, 0, 0, 0, 3718, 0, 0, 0, 3720, 0, 0, 0, 3722, 0, 0, 0, 3724, 0, 0, 0, 3726, 0, 0, 0, 3728, 0, 0, 0, 3730, 0, 0, 0, 3732, 0, 0, 0, 3734, 0, 0, 0, 3736, 0, 0, 0, 3738, 0, 0, 0, 3740, 0, 0, 0, 3742, 0, 0, 0, 3744, 0, 0, 0, 3746, 0, 0, 0, 3748, 0, 0, 0, 3750, 0, 0, 0, 3752, 0, 0, 0, 3754, 0, 0, 0, 3756, 0, 0, 0, 3758, 0, 0, 0, 3760, 0, 0, 0, 3762, 0, 0, 0, 3764, 0, 0, 0, 3766, 0, 0, 0, 3768, 0, 0, 0, 3770, 0, 0, 0, 3772, 0, 0, 0, 3774, 0, 0, 0, 3776, 0, 0, 0, 3778, 0, 0, 0, 3780, 0, 0, 0, 3782, 0, 0, 0, 3784, 0, 0, 0, 3786, 0, 0, 0, 3788, 0, 0, 0, 3790, 0, 0, 0, 3792, 0, 0, 0, 3794, 0, 0, 0, 3796, 0, 0, 0, 3798, 0, 0, 0, 3800, 0, 0, 0, 3802, 0, 0, 0, 3804, 0, 0, 0, 3806, 0, 0, 0, 3808, 0, 0, 0, 3810, 0, 0, 0, 3812, 0, 0, 0, 3814, 0, 0, 0, 3816, 0, 0, 0, 3818, 0, 0, 0, 3820, 0, 0, 0, 3822, 0, 0, 0, 3824, 0, 0, 0, 3826, 0, 0, 0, 3828, 0, 0, 0, 3830, 0, 0, 0, 3832, 0, 0, 0, 3834, 0, 0, 0, 3836, 0, 0, 0, 3838, 0, 0, 0, 3840, 0, 0, 0, 3842, 0, 0, 0, 3844, 0, 0, 0, 3846, 0, 0, 0, 3848, 0, 0, 0, 3850, 0, 0, 0, 3852, 0, 0, 0, 3854, 0, 0, 0, 3856, 0, 0, 0, 3858, 0, 0, 0, 3860, 0, 0, 0, 3862, 0, 0, 0, 3864, 0, 0, 0, 3866, 0, 0, 0, 3868, 0, 0, 0, 3870, 0, 0, 0, 3872, 0, 0, 0, 3874, 0, 0, 0, 3876, 0, 0, 0, 3878, 0, 0, 0, 3880, 0, 0, 0, 3882, 0, 0, 0, 3884, 0, 0, 0, 3886, 0, 0, 0, 3888, 0, 0, 0, 3890, 0, 0, 0, 3892, 0, 0, 0, 3894, 0, 0, 0, 3896, 0, 0, 0, 3898, 0, 0, 0, 3900, 0, 0, 0, 3902, 0, 0, 0, 3904, 0, 0, 0, 3906, 0, 0, 0, 3908, 0, 0, 0, 3910, 0, 0, 0, 3912, 0, 0, 0, 3914, 0, 0, 0, 3916, 0, 0, 0, 3918, 0, 0, 0, 3920, 0, 0, 0, 3922, 0, 0, 0, 3924, 0, 0, 0, 3926, 0, 0, 0, 3928, 0, 0, 0, 3930, 0, 0, 0, 3932, 0, 0, 0, 3934, 0, 0, 0, 3936, 0, 0, 0, 3938, 0, 0, 0, 3940, 0, 0, 0, 3942, 0, 0, 0, 3944, 0, 0, 0, 3946, 0, 0, 0, 3948, 0, 0, 0, 3950, 0, 0, 0, 3952, 0, 0, 0, 3954, 0, 0, 0, 3956, 0, 0, 0, 3958, 0, 0, 0, 3960, 0, 0, 0, 3962, 0, 0, 0, 3964, 0, 0, 0, 3966, 0, 0, 0, 3968, 0, 0, 0, 3970, 0, 0, 0, 3972, 0, 0, 0, 3974, 0, 0, 0, 3976, 0, 0, 0, 3978, 0, 0, 0, 3980, 0, 0, 0, 3982, 0, 0, 0, 3984, 0, 0, 0, 3986, 0, 0, 0, 3988, 0, 0, 0, 3990, 0, 0, 0, 3992, 0, 0, 0, 3994, 0, 0, 0, 3996, 0, 0, 0, 3998, 0, 0, 0, 4000, 0, 0, 0, 4002, 0, 0, 0, 4004, 0, 0, 0, 4006, 0, 0, 0, 4008, 0, 0, 0, 4010, 0, 0, 0, 4012, 0, 0, 0, 4014, 0, 0, 0, 4016, 0, 0, 0, 4018, 0, 0, 0, 4020, 0, 0, 0, 4022, 0, 0, 0, 4024, 0, 0, 0, 4026, 0, 0, 0, 4028, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str8243=allocate([90,56,48,32,39,37,115,39,32,105,108,108,46,32,111,112,99,111,100,101,32,36,101,100,32,36,37,48,50,120,10,0] /* Z80 '%s' ill. opcode */, "i8", ALLOC_STATIC);
__ZL2SZ=allocate(256, "i8", ALLOC_STATIC);
__ZL5Z80dd=allocate([4030, 0, 0, 0, 4032, 0, 0, 0, 4034, 0, 0, 0, 4036, 0, 0, 0, 4038, 0, 0, 0, 4040, 0, 0, 0, 4042, 0, 0, 0, 4044, 0, 0, 0, 4046, 0, 0, 0, 4048, 0, 0, 0, 4050, 0, 0, 0, 4052, 0, 0, 0, 4054, 0, 0, 0, 4056, 0, 0, 0, 4058, 0, 0, 0, 4060, 0, 0, 0, 4062, 0, 0, 0, 4064, 0, 0, 0, 4066, 0, 0, 0, 4068, 0, 0, 0, 4070, 0, 0, 0, 4072, 0, 0, 0, 4074, 0, 0, 0, 4076, 0, 0, 0, 4078, 0, 0, 0, 4080, 0, 0, 0, 4082, 0, 0, 0, 4084, 0, 0, 0, 4086, 0, 0, 0, 4088, 0, 0, 0, 4090, 0, 0, 0, 4092, 0, 0, 0, 4094, 0, 0, 0, 4096, 0, 0, 0, 4098, 0, 0, 0, 4100, 0, 0, 0, 4102, 0, 0, 0, 4104, 0, 0, 0, 4106, 0, 0, 0, 4108, 0, 0, 0, 4110, 0, 0, 0, 4112, 0, 0, 0, 4114, 0, 0, 0, 4116, 0, 0, 0, 4118, 0, 0, 0, 4120, 0, 0, 0, 4122, 0, 0, 0, 4124, 0, 0, 0, 4126, 0, 0, 0, 4128, 0, 0, 0, 4130, 0, 0, 0, 4132, 0, 0, 0, 4134, 0, 0, 0, 4136, 0, 0, 0, 4138, 0, 0, 0, 4140, 0, 0, 0, 4142, 0, 0, 0, 4144, 0, 0, 0, 4146, 0, 0, 0, 4148, 0, 0, 0, 4150, 0, 0, 0, 4152, 0, 0, 0, 4154, 0, 0, 0, 4156, 0, 0, 0, 4158, 0, 0, 0, 4160, 0, 0, 0, 4162, 0, 0, 0, 4164, 0, 0, 0, 4166, 0, 0, 0, 4168, 0, 0, 0, 4170, 0, 0, 0, 4172, 0, 0, 0, 4174, 0, 0, 0, 4176, 0, 0, 0, 4178, 0, 0, 0, 4180, 0, 0, 0, 4182, 0, 0, 0, 4184, 0, 0, 0, 4186, 0, 0, 0, 4188, 0, 0, 0, 4190, 0, 0, 0, 4192, 0, 0, 0, 4194, 0, 0, 0, 4196, 0, 0, 0, 4198, 0, 0, 0, 4200, 0, 0, 0, 4202, 0, 0, 0, 4204, 0, 0, 0, 4206, 0, 0, 0, 4208, 0, 0, 0, 4210, 0, 0, 0, 4212, 0, 0, 0, 4214, 0, 0, 0, 4216, 0, 0, 0, 4218, 0, 0, 0, 4220, 0, 0, 0, 4222, 0, 0, 0, 4224, 0, 0, 0, 4226, 0, 0, 0, 4228, 0, 0, 0, 4230, 0, 0, 0, 4232, 0, 0, 0, 4234, 0, 0, 0, 4236, 0, 0, 0, 4238, 0, 0, 0, 4240, 0, 0, 0, 4242, 0, 0, 0, 4244, 0, 0, 0, 4246, 0, 0, 0, 4248, 0, 0, 0, 4250, 0, 0, 0, 4252, 0, 0, 0, 4254, 0, 0, 0, 4256, 0, 0, 0, 4258, 0, 0, 0, 4260, 0, 0, 0, 4262, 0, 0, 0, 4264, 0, 0, 0, 4266, 0, 0, 0, 4268, 0, 0, 0, 4270, 0, 0, 0, 4272, 0, 0, 0, 4274, 0, 0, 0, 4276, 0, 0, 0, 4278, 0, 0, 0, 4280, 0, 0, 0, 4282, 0, 0, 0, 4284, 0, 0, 0, 4286, 0, 0, 0, 4288, 0, 0, 0, 4290, 0, 0, 0, 4292, 0, 0, 0, 4294, 0, 0, 0, 4296, 0, 0, 0, 4298, 0, 0, 0, 4300, 0, 0, 0, 4302, 0, 0, 0, 4304, 0, 0, 0, 4306, 0, 0, 0, 4308, 0, 0, 0, 4310, 0, 0, 0, 4312, 0, 0, 0, 4314, 0, 0, 0, 4316, 0, 0, 0, 4318, 0, 0, 0, 4320, 0, 0, 0, 4322, 0, 0, 0, 4324, 0, 0, 0, 4326, 0, 0, 0, 4328, 0, 0, 0, 4330, 0, 0, 0, 4332, 0, 0, 0, 4334, 0, 0, 0, 4336, 0, 0, 0, 4338, 0, 0, 0, 4340, 0, 0, 0, 4342, 0, 0, 0, 4344, 0, 0, 0, 4346, 0, 0, 0, 4348, 0, 0, 0, 4350, 0, 0, 0, 4352, 0, 0, 0, 4354, 0, 0, 0, 4356, 0, 0, 0, 4358, 0, 0, 0, 4360, 0, 0, 0, 4362, 0, 0, 0, 4364, 0, 0, 0, 4366, 0, 0, 0, 4368, 0, 0, 0, 4370, 0, 0, 0, 4372, 0, 0, 0, 4374, 0, 0, 0, 4376, 0, 0, 0, 4378, 0, 0, 0, 4380, 0, 0, 0, 4382, 0, 0, 0, 4384, 0, 0, 0, 4386, 0, 0, 0, 4388, 0, 0, 0, 4390, 0, 0, 0, 4392, 0, 0, 0, 4394, 0, 0, 0, 4396, 0, 0, 0, 4398, 0, 0, 0, 4400, 0, 0, 0, 4402, 0, 0, 0, 4404, 0, 0, 0, 4406, 0, 0, 0, 4408, 0, 0, 0, 4410, 0, 0, 0, 4412, 0, 0, 0, 4414, 0, 0, 0, 4416, 0, 0, 0, 4418, 0, 0, 0, 4420, 0, 0, 0, 4422, 0, 0, 0, 4424, 0, 0, 0, 4426, 0, 0, 0, 4428, 0, 0, 0, 4430, 0, 0, 0, 4432, 0, 0, 0, 4434, 0, 0, 0, 4436, 0, 0, 0, 4438, 0, 0, 0, 4440, 0, 0, 0, 4442, 0, 0, 0, 4444, 0, 0, 0, 4446, 0, 0, 0, 4448, 0, 0, 0, 4450, 0, 0, 0, 4452, 0, 0, 0, 4454, 0, 0, 0, 4456, 0, 0, 0, 4458, 0, 0, 0, 4460, 0, 0, 0, 4462, 0, 0, 0, 4464, 0, 0, 0, 4466, 0, 0, 0, 4468, 0, 0, 0, 4470, 0, 0, 0, 4472, 0, 0, 0, 4474, 0, 0, 0, 4476, 0, 0, 0, 4478, 0, 0, 0, 4480, 0, 0, 0, 4482, 0, 0, 0, 4484, 0, 0, 0, 4486, 0, 0, 0, 4488, 0, 0, 0, 4490, 0, 0, 0, 4492, 0, 0, 0, 4494, 0, 0, 0, 4496, 0, 0, 0, 4498, 0, 0, 0, 4500, 0, 0, 0, 4502, 0, 0, 0, 4504, 0, 0, 0, 4506, 0, 0, 0, 4508, 0, 0, 0, 4510, 0, 0, 0, 4512, 0, 0, 0, 4514, 0, 0, 0, 4516, 0, 0, 0, 4518, 0, 0, 0, 4520, 0, 0, 0, 4522, 0, 0, 0, 4524, 0, 0, 0, 4526, 0, 0, 0, 4528, 0, 0, 0, 4530, 0, 0, 0, 4532, 0, 0, 0, 4534, 0, 0, 0, 4536, 0, 0, 0, 4538, 0, 0, 0, 4540, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL5Z80cb=allocate([4542, 0, 0, 0, 4544, 0, 0, 0, 4546, 0, 0, 0, 4548, 0, 0, 0, 4550, 0, 0, 0, 4552, 0, 0, 0, 4554, 0, 0, 0, 4556, 0, 0, 0, 4558, 0, 0, 0, 4560, 0, 0, 0, 4562, 0, 0, 0, 4564, 0, 0, 0, 4566, 0, 0, 0, 4568, 0, 0, 0, 4570, 0, 0, 0, 4572, 0, 0, 0, 4574, 0, 0, 0, 4576, 0, 0, 0, 4578, 0, 0, 0, 4580, 0, 0, 0, 4582, 0, 0, 0, 4584, 0, 0, 0, 4586, 0, 0, 0, 4588, 0, 0, 0, 4590, 0, 0, 0, 4592, 0, 0, 0, 4594, 0, 0, 0, 4596, 0, 0, 0, 4598, 0, 0, 0, 4600, 0, 0, 0, 4602, 0, 0, 0, 4604, 0, 0, 0, 4606, 0, 0, 0, 4608, 0, 0, 0, 4610, 0, 0, 0, 4612, 0, 0, 0, 4614, 0, 0, 0, 4616, 0, 0, 0, 4618, 0, 0, 0, 4620, 0, 0, 0, 4622, 0, 0, 0, 4624, 0, 0, 0, 4626, 0, 0, 0, 4628, 0, 0, 0, 4630, 0, 0, 0, 4632, 0, 0, 0, 4634, 0, 0, 0, 4636, 0, 0, 0, 4638, 0, 0, 0, 4640, 0, 0, 0, 4642, 0, 0, 0, 4644, 0, 0, 0, 4646, 0, 0, 0, 4648, 0, 0, 0, 4650, 0, 0, 0, 4652, 0, 0, 0, 4654, 0, 0, 0, 4656, 0, 0, 0, 4658, 0, 0, 0, 4660, 0, 0, 0, 4662, 0, 0, 0, 4664, 0, 0, 0, 4666, 0, 0, 0, 4668, 0, 0, 0, 4670, 0, 0, 0, 4672, 0, 0, 0, 4674, 0, 0, 0, 4676, 0, 0, 0, 4678, 0, 0, 0, 4680, 0, 0, 0, 4682, 0, 0, 0, 4684, 0, 0, 0, 4686, 0, 0, 0, 4688, 0, 0, 0, 4690, 0, 0, 0, 4692, 0, 0, 0, 4694, 0, 0, 0, 4696, 0, 0, 0, 4698, 0, 0, 0, 4700, 0, 0, 0, 4702, 0, 0, 0, 4704, 0, 0, 0, 4706, 0, 0, 0, 4708, 0, 0, 0, 4710, 0, 0, 0, 4712, 0, 0, 0, 4714, 0, 0, 0, 4716, 0, 0, 0, 4718, 0, 0, 0, 4720, 0, 0, 0, 4722, 0, 0, 0, 4724, 0, 0, 0, 4726, 0, 0, 0, 4728, 0, 0, 0, 4730, 0, 0, 0, 4732, 0, 0, 0, 4734, 0, 0, 0, 4736, 0, 0, 0, 4738, 0, 0, 0, 4740, 0, 0, 0, 4742, 0, 0, 0, 4744, 0, 0, 0, 4746, 0, 0, 0, 4748, 0, 0, 0, 4750, 0, 0, 0, 4752, 0, 0, 0, 4754, 0, 0, 0, 4756, 0, 0, 0, 4758, 0, 0, 0, 4760, 0, 0, 0, 4762, 0, 0, 0, 4764, 0, 0, 0, 4766, 0, 0, 0, 4768, 0, 0, 0, 4770, 0, 0, 0, 4772, 0, 0, 0, 4774, 0, 0, 0, 4776, 0, 0, 0, 4778, 0, 0, 0, 4780, 0, 0, 0, 4782, 0, 0, 0, 4784, 0, 0, 0, 4786, 0, 0, 0, 4788, 0, 0, 0, 4790, 0, 0, 0, 4792, 0, 0, 0, 4794, 0, 0, 0, 4796, 0, 0, 0, 4798, 0, 0, 0, 4800, 0, 0, 0, 4802, 0, 0, 0, 4804, 0, 0, 0, 4806, 0, 0, 0, 4808, 0, 0, 0, 4810, 0, 0, 0, 4812, 0, 0, 0, 4814, 0, 0, 0, 4816, 0, 0, 0, 4818, 0, 0, 0, 4820, 0, 0, 0, 4822, 0, 0, 0, 4824, 0, 0, 0, 4826, 0, 0, 0, 4828, 0, 0, 0, 4830, 0, 0, 0, 4832, 0, 0, 0, 4834, 0, 0, 0, 4836, 0, 0, 0, 4838, 0, 0, 0, 4840, 0, 0, 0, 4842, 0, 0, 0, 4844, 0, 0, 0, 4846, 0, 0, 0, 4848, 0, 0, 0, 4850, 0, 0, 0, 4852, 0, 0, 0, 4854, 0, 0, 0, 4856, 0, 0, 0, 4858, 0, 0, 0, 4860, 0, 0, 0, 4862, 0, 0, 0, 4864, 0, 0, 0, 4866, 0, 0, 0, 4868, 0, 0, 0, 4870, 0, 0, 0, 4872, 0, 0, 0, 4874, 0, 0, 0, 4876, 0, 0, 0, 4878, 0, 0, 0, 4880, 0, 0, 0, 4882, 0, 0, 0, 4884, 0, 0, 0, 4886, 0, 0, 0, 4888, 0, 0, 0, 4890, 0, 0, 0, 4892, 0, 0, 0, 4894, 0, 0, 0, 4896, 0, 0, 0, 4898, 0, 0, 0, 4900, 0, 0, 0, 4902, 0, 0, 0, 4904, 0, 0, 0, 4906, 0, 0, 0, 4908, 0, 0, 0, 4910, 0, 0, 0, 4912, 0, 0, 0, 4914, 0, 0, 0, 4916, 0, 0, 0, 4918, 0, 0, 0, 4920, 0, 0, 0, 4922, 0, 0, 0, 4924, 0, 0, 0, 4926, 0, 0, 0, 4928, 0, 0, 0, 4930, 0, 0, 0, 4932, 0, 0, 0, 4934, 0, 0, 0, 4936, 0, 0, 0, 4938, 0, 0, 0, 4940, 0, 0, 0, 4942, 0, 0, 0, 4944, 0, 0, 0, 4946, 0, 0, 0, 4948, 0, 0, 0, 4950, 0, 0, 0, 4952, 0, 0, 0, 4954, 0, 0, 0, 4956, 0, 0, 0, 4958, 0, 0, 0, 4960, 0, 0, 0, 4962, 0, 0, 0, 4964, 0, 0, 0, 4966, 0, 0, 0, 4968, 0, 0, 0, 4970, 0, 0, 0, 4972, 0, 0, 0, 4974, 0, 0, 0, 4976, 0, 0, 0, 4978, 0, 0, 0, 4980, 0, 0, 0, 4982, 0, 0, 0, 4984, 0, 0, 0, 4986, 0, 0, 0, 4988, 0, 0, 0, 4990, 0, 0, 0, 4992, 0, 0, 0, 4994, 0, 0, 0, 4996, 0, 0, 0, 4998, 0, 0, 0, 5000, 0, 0, 0, 5002, 0, 0, 0, 5004, 0, 0, 0, 5006, 0, 0, 0, 5008, 0, 0, 0, 5010, 0, 0, 0, 5012, 0, 0, 0, 5014, 0, 0, 0, 5016, 0, 0, 0, 5018, 0, 0, 0, 5020, 0, 0, 0, 5022, 0, 0, 0, 5024, 0, 0, 0, 5026, 0, 0, 0, 5028, 0, 0, 0, 5030, 0, 0, 0, 5032, 0, 0, 0, 5034, 0, 0, 0, 5036, 0, 0, 0, 5038, 0, 0, 0, 5040, 0, 0, 0, 5042, 0, 0, 0, 5044, 0, 0, 0, 5046, 0, 0, 0, 5048, 0, 0, 0, 5050, 0, 0, 0, 5052, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str10245=allocate([37,99,37,99,37,99,37,99,37,99,37,99,37,99,37,99,0] /* %c%c%c%c%c%c%c%c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11246=allocate([67,80,85,95,69,88,80,79,82,84,95,83,84,65,84,69,40,122,56,48,41,32,99,97,108,108,101,100,32,102,111,114,32,117,110,101,120,112,101,99,116,101,100,32,118,97,108,117,101,10,0] /* CPU_EXPORT_STATE(z80 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12247=allocate([67,80,85,95,73,77,80,79,82,84,95,83,84,65,84,69,40,122,56,48,41,32,99,97,108,108,101,100,32,102,111,114,32,117,110,101,120,112,101,99,116,101,100,32,118,97,108,117,101,10,0] /* CPU_IMPORT_STATE(z80 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13248=allocate([122,56,48,45,62,112,114,118,112,99,46,119,46,108,0] /* z80->prvpc.w.l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14249=allocate([122,56,48,45,62,80,67,0] /* z80->PC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15250=allocate([122,56,48,45,62,83,80,0] /* z80->SP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16251=allocate([122,56,48,45,62,65,70,0] /* z80->AF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17252=allocate([122,56,48,45,62,66,67,0] /* z80->BC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str18253=allocate([122,56,48,45,62,68,69,0] /* z80->DE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str19254=allocate([122,56,48,45,62,72,76,0] /* z80->HL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str20255=allocate([122,56,48,45,62,73,88,0] /* z80->IX\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21256=allocate([122,56,48,45,62,73,89,0] /* z80->IY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22257=allocate([122,56,48,45,62,87,90,0] /* z80->WZ\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23258=allocate([122,56,48,45,62,97,102,50,46,119,46,108,0] /* z80->af2.w.l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24259=allocate([122,56,48,45,62,98,99,50,46,119,46,108,0] /* z80->bc2.w.l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25260=allocate([122,56,48,45,62,100,101,50,46,119,46,108,0] /* z80->de2.w.l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26261=allocate([122,56,48,45,62,104,108,50,46,119,46,108,0] /* z80->hl2.w.l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27262=allocate([122,56,48,45,62,114,0] /* z80->r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str28263=allocate([122,56,48,45,62,114,50,0] /* z80->r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str29264=allocate([122,56,48,45,62,105,102,102,49,0] /* z80->iff1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str30265=allocate([122,56,48,45,62,105,102,102,50,0] /* z80->iff2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31266=allocate([122,56,48,45,62,104,97,108,116,0] /* z80->halt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32267=allocate([122,56,48,45,62,105,109,0] /* z80->im\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33268=allocate([122,56,48,45,62,105,0] /* z80->i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34269=allocate([122,56,48,45,62,110,109,105,95,115,116,97,116,101,0] /* z80->nmi_state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35270=allocate([122,56,48,45,62,110,109,105,95,112,101,110,100,105,110,103,0] /* z80->nmi_pending\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36271=allocate([122,56,48,45,62,105,114,113,95,115,116,97,116,101,0] /* z80->irq_state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37272=allocate([122,56,48,45,62,97,102,116,101,114,95,101,105,0] /* z80->after_ei\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str38273=allocate([122,56,48,45,62,97,102,116,101,114,95,108,100,97,105,114,0] /* z80->after_ldair\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str39274=allocate([80,67,0] /* PC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str40275=allocate([71,69,78,80,67,0] /* GENPC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41276=allocate([71,69,78,80,67,66,65,83,69,0] /* GENPCBASE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42277=allocate([83,80,0] /* SP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43278=allocate([71,69,78,83,80,0] /* GENSP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44279=allocate([71,69,78,70,76,65,71,83,0] /* GENFLAGS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45280=allocate([37,56,115,0] /* %8s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46281=allocate([65,0] /* A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47282=allocate([66,0] /* B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str48283=allocate([67,0] /* C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str49284=allocate([68,0] /* D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str50285=allocate([69,0] /* E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51286=allocate([72,0] /* H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52287=allocate([76,0] /* L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53288=allocate([65,70,0] /* AF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54289=allocate([66,67,0] /* BC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55290=allocate([68,69,0] /* DE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56291=allocate([72,76,0] /* HL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57292=allocate([73,88,0] /* IX\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str58293=allocate([73,89,0] /* IY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str59294=allocate([65,70,50,0] /* AF2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str60295=allocate([66,67,50,0] /* BC2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61296=allocate([68,69,50,0] /* DE2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62297=allocate([72,76,50,0] /* HL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63298=allocate([87,90,0] /* WZ\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64299=allocate([82,0] /* R\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65300=allocate([73,0] /* I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66301=allocate([73,77,0] /* IM\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67302=allocate([73,70,70,49,0] /* IFF1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str68303=allocate([73,70,70,50,0] /* IFF2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str69304=allocate([72,65,76,84,0] /* HALT\00 */, "i8", ALLOC_STATIC);
__ZTV19resource_pool_arrayIhE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5054, 0, 0, 0, 5056, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIhE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,104,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIhE=allocate(12, "*", ALLOC_STATIC);
__ZTV25device_z80daisy_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5058, 0, 0, 0, 5060, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str307=allocate([85,110,97,98,108,101,32,116,111,32,108,111,99,97,116,101,32,100,101,118,105,99,101,32,39,37,115,39,0] /* Unable to locate dev */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1308=allocate([68,101,118,105,99,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,32,116,104,101,32,122,56,48,100,97,105,115,121,32,105,110,116,101,114,102,97,99,101,33,0] /* Device '%s' does not */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2309=allocate([115,114,99,47,101,109,117,47,99,112,117,47,122,56,48,47,122,56,48,100,97,105,115,121,46,99,0] /* src/emu/cpu/z80/z80d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3310=allocate([122,56,48,100,97,105,115,121,95,99,97,108,108,95,97,99,107,95,100,101,118,105,99,101,58,32,102,97,105,108,101,100,32,116,111,32,102,105,110,100,32,97,110,32,100,101,118,105,99,101,32,116,111,32,97,99,107,33,10,0] /* z80daisy_call_ack_de */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS25device_z80daisy_interface=allocate([50,53,100,101,118,105,99,101,95,122,56,48,100,97,105,115,121,95,105,110,116,101,114,102,97,99,101,0] /* 25device_z80daisy_in */, "i8", ALLOC_STATIC);
__ZTI25device_z80daisy_interface=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5062, 0, 0, 0, 5064, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,53,122,56,48,95,100,97,105,115,121,95,99,104,97,105,110,49,49,100,97,105,115,121,95,101,110,116,114,121,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str321=allocate([66,97,99,107,115,112,97,99,101,0] /* Backspace\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1322=allocate([84,97,98,0] /* Tab\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2323=allocate([32,32,32,32,0] /*     \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3324=allocate([67,108,101,97,114,0] /* Clear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4325=allocate([69,110,116,101,114,0] /* Enter\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str5326=allocate([69,115,99,0] /* Esc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6327=allocate([83,112,97,99,101,0] /* Space\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7328=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str8329=allocate([65,0] /* A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str9330=allocate([66,0] /* B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str10331=allocate([67,0] /* C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11332=allocate([68,0] /* D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12333=allocate([69,0] /* E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13334=allocate([70,0] /* F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14335=allocate([71,0] /* G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15336=allocate([72,0] /* H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16337=allocate([73,0] /* I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17338=allocate([74,0] /* J\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str18339=allocate([75,0] /* K\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str19340=allocate([76,0] /* L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str20341=allocate([77,0] /* M\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21342=allocate([78,0] /* N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22343=allocate([79,0] /* O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23344=allocate([80,0] /* P\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24345=allocate([81,0] /* Q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25346=allocate([82,0] /* R\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26347=allocate([83,0] /* S\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27348=allocate([84,0] /* T\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str28349=allocate([85,0] /* U\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str29350=allocate([86,0] /* V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str30351=allocate([87,0] /* W\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31352=allocate([88,0] /* X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32353=allocate([89,0] /* Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33354=allocate([90,0] /* Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34355=allocate([33,0] /* !\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35356=allocate([124,0] /* |\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36357=allocate([40,99,41,0] /* (c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37358=allocate([60,60,0] /* <<\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str38359=allocate([40,114,41,0] /* (r)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str39360=allocate([62,62,0] /* >>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str40361=allocate([49,47,52,0] /* 1/4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41362=allocate([49,47,50,0] /* 1/2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42363=allocate([51,47,52,0] /* 3/4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43364=allocate([63,0] /* ?\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44365=allocate([65,69,0] /* AE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45366=allocate([83,83,0] /* SS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46367=allocate([97,0] /* a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47368=allocate([97,101,0] /* ae\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str48369=allocate([99,0] /* c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str49370=allocate([101,0] /* e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str50371=allocate([105,0] /* i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51372=allocate([100,0] /* d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52373=allocate([110,0] /* n\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53374=allocate([111,0] /* o\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54375=allocate([117,0] /* u\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55376=allocate([121,0] /* y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56377=allocate([45,0] /* -\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57378=allocate([39,0] /* '\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str58379=allocate([34,0] /* \22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str59380=allocate([46,0] /* .\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str60381=allocate([46,46,0] /* ..\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61382=allocate([46,46,46,0] /* ...\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62383=allocate([63,63,0] /* ??\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63384=allocate([63,33,0] /* ?!\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64385=allocate([33,63,0] /* !?\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65386=allocate([35,0] /* #\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66387=allocate([36,0] /* $\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67388=allocate([37,0] /* %\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str68389=allocate([38,0] /* &\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str69390=allocate([40,0] /* (\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str70391=allocate([41,0] /* )\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71392=allocate([42,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72393=allocate([43,0] /* +\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73394=allocate([44,0] /* ,\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74395=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75396=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76397=allocate([49,0] /* 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77=allocate([50,0] /* 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str78=allocate([51,0] /* 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str79=allocate([52,0] /* 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str80=allocate([53,0] /* 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str81=allocate([54,0] /* 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82=allocate([55,0] /* 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83=allocate([56,0] /* 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84=allocate([57,0] /* 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85=allocate([58,0] /* :\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86=allocate([59,0] /* ;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87=allocate([60,0] /* <\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str88=allocate([61,0] /* =\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str89=allocate([62,0] /* >\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str90=allocate([64,0] /* @\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str91=allocate([91,0] /* [\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92=allocate([92,0] /* \5C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93=allocate([93,0] /* ]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94=allocate([94,0] /* ^\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95=allocate([95,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str96=allocate([96,0] /* `\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97=allocate([98,0] /* b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str98=allocate([102,0] /* f\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str99=allocate([103,0] /* g\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str100=allocate([104,0] /* h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str101=allocate([106,0] /* j\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102=allocate([107,0] /* k\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103=allocate([108,0] /* l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104=allocate([109,0] /* m\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105=allocate([112,0] /* p\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106=allocate([113,0] /* q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str107=allocate([114,0] /* r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str108=allocate([115,0] /* s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str109=allocate([116,0] /* t\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str110=allocate([118,0] /* v\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str111=allocate([119,0] /* w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112398=allocate([120,0] /* x\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113=allocate([122,0] /* z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114=allocate([123,0] /* {\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115=allocate([125,0] /* }\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116=allocate([126,0] /* ~\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str117=allocate([40,40,0] /* ((\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str118=allocate([41,41,0] /* ))\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str119=allocate([194,162,0] /* \C2\A2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str120=allocate([194,163,0] /* \C2\A3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str121=allocate([194,164,0] /* \C2\A4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122=allocate([194,165,0] /* \C2\A5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123=allocate([226,130,169,0] /* \E2\82\A9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124=allocate([226,134,144,0] /* \E2\86\90\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125=allocate([226,134,145,0] /* \E2\86\91\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126=allocate([226,134,146,0] /* \E2\86\92\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127=allocate([226,134,147,0] /* \E2\86\93\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str128=allocate([226,150,170,0] /* \E2\96\AA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str129=allocate([226,151,166,0] /* \E2\97\A6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str130=allocate([83,104,105,102,116,0] /* Shift\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str131=allocate([67,116,114,108,0] /* Ctrl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132=allocate([70,49,0] /* F1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133=allocate([70,50,0] /* F2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134=allocate([70,51,0] /* F3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135=allocate([70,52,0] /* F4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136=allocate([70,53,0] /* F5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137=allocate([70,54,0] /* F6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str138=allocate([70,55,0] /* F7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str139=allocate([70,56,0] /* F8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str140=allocate([70,57,0] /* F9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str141=allocate([70,49,48,0] /* F10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142=allocate([70,49,49,0] /* F11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143=allocate([70,49,50,0] /* F12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144=allocate([70,49,51,0] /* F13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145=allocate([70,49,52,0] /* F14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146=allocate([70,49,53,0] /* F15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147399=allocate([27,0] /* \1B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str148=allocate([73,110,115,101,114,116,0] /* Insert\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str149=allocate([68,101,108,101,116,101,0] /* Delete\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str150=allocate([8,0] /* \08\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str151=allocate([72,111,109,101,0] /* Home\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152=allocate([12,0] /* \0C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153=allocate([69,110,100,0] /* End\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154=allocate([80,97,103,101,32,85,112,0] /* Page Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155=allocate([80,97,103,101,32,68,111,119,110,0] /* Page Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str156=allocate([67,117,114,115,111,114,32,76,101,102,116,0] /* Cursor Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157=allocate([67,117,114,115,111,114,32,82,105,103,104,116,0] /* Cursor Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str158400=allocate([67,117,114,115,111,114,32,85,112,0] /* Cursor Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str159=allocate([67,117,114,115,111,114,32,68,111,119,110,0] /* Cursor Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str160=allocate([75,101,121,112,97,100,32,48,0] /* Keypad 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str161=allocate([75,101,121,112,97,100,32,49,0] /* Keypad 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162=allocate([75,101,121,112,97,100,32,50,0] /* Keypad 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163=allocate([75,101,121,112,97,100,32,51,0] /* Keypad 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164=allocate([75,101,121,112,97,100,32,52,0] /* Keypad 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165=allocate([75,101,121,112,97,100,32,53,0] /* Keypad 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166=allocate([75,101,121,112,97,100,32,54,0] /* Keypad 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str167=allocate([75,101,121,112,97,100,32,55,0] /* Keypad 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str168=allocate([75,101,121,112,97,100,32,56,0] /* Keypad 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str169=allocate([75,101,121,112,97,100,32,57,0] /* Keypad 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str170401=allocate([75,101,121,112,97,100,32,47,0] /* Keypad /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str171=allocate([75,101,121,112,97,100,32,42,0] /* Keypad _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172=allocate([75,101,121,112,97,100,32,45,0] /* Keypad -\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173=allocate([75,101,121,112,97,100,32,43,0] /* Keypad +\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174=allocate([75,101,121,112,97,100,32,46,0] /* Keypad .\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175=allocate([75,101,121,112,97,100,32,69,110,116,101,114,0] /* Keypad Enter\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176=allocate([80,114,105,110,116,32,83,99,114,101,101,110,0] /* Print Screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str177=allocate([80,97,117,115,101,0] /* Pause\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str178=allocate([76,101,102,116,32,83,104,105,102,116,0] /* Left Shift\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str179=allocate([82,105,103,104,116,32,83,104,105,102,116,0] /* Right Shift\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str180=allocate([76,101,102,116,32,67,116,114,108,0] /* Left Ctrl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str181=allocate([82,105,103,104,116,32,67,116,114,108,0] /* Right Ctrl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182=allocate([76,101,102,116,32,65,108,116,0] /* Left Alt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183=allocate([82,105,103,104,116,32,65,108,116,0] /* Right Alt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184=allocate([83,99,114,111,108,108,32,76,111,99,107,0] /* Scroll Lock\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185=allocate([78,117,109,32,76,111,99,107,0] /* Num Lock\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186=allocate([67,97,112,115,32,76,111,99,107,0] /* Caps Lock\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str187=allocate([76,101,102,116,32,87,105,110,0] /* Left Win\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str188=allocate([82,105,103,104,116,32,87,105,110,0] /* Right Win\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str189=allocate([77,101,110,117,0] /* Menu\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str190=allocate([66,114,101,97,107,0] /* Break\00 */, "i8", ALLOC_STATIC);
__ZL8charinfo=allocate([8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8209, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8210, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8211, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8212, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8213, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8217, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8218, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8222, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8229, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8230, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8263, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8264, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8265, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65281, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65282, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65283, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65284, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65285, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65286, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65287, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65288, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65289, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65290, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65291, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65292, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65293, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65294, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65295, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65296, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65297, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65298, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65299, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65300, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65301, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65302, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65303, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65304, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65305, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65306, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65307, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65308, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65309, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65310, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65311, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65312, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65313, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65315, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65316, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65317, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65318, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65319, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65320, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65321, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65322, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65323, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65324, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65325, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65326, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65327, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65328, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65329, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65330, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65331, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65332, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65333, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65334, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65335, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65336, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65337, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65338, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65339, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65340, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65341, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65342, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65343, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65344, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65345, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65346, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65347, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65348, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65349, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65350, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65351, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65352, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65353, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65354, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65355, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65356, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65357, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65358, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65359, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65360, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65361, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65362, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65363, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65364, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65365, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65366, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65367, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65368, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65369, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65370, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65371, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65372, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65373, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65374, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65375, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65376, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65504, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65505, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65508, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65509, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65510, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65513, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65514, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65515, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65516, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65517, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65518, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048576, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048577, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048615, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048616, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048617, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048618, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048619, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048620, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048621, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048622, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048623, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048624, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048625, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048626, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048627, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048628, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048629, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048630, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048647, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048648, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048649, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048650, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048651, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048652, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048653, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048654, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048655, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048656, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048657, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048658, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048659, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048660, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048661, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048662, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048663, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048664, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048665, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048666, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048667, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048668, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048669, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048670, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048671, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048672, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048673, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048674, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048675, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048676, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048677, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048678, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048679, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048680, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048681, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048682, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048683, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048684, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048685, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048686, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048687, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str191=allocate([115,114,99,47,101,109,117,47,105,110,112,116,116,121,112,101,46,104,0] /* src/emu/inpttype.h\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192=allocate([80,49,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P1_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str193=allocate([80,49,32,85,112,0] /* P1 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194=allocate([80,49,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P1_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str195=allocate([80,49,32,68,111,119,110,0] /* P1 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str196=allocate([80,49,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P1_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str197=allocate([80,49,32,76,101,102,116,0] /* P1 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str198=allocate([80,49,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P1_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str199=allocate([80,49,32,82,105,103,104,116,0] /* P1 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str200=allocate([80,49,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P1_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str201=allocate([80,49,32,82,105,103,104,116,47,85,112,0] /* P1 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202=allocate([80,49,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P1_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203=allocate([80,49,32,82,105,103,104,116,47,68,111,119,110,0] /* P1 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204=allocate([80,49,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P1_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str205=allocate([80,49,32,82,105,103,104,116,47,76,101,102,116,0] /* P1 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str206=allocate([80,49,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P1_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str207=allocate([80,49,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P1 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str208=allocate([80,49,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P1_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str209=allocate([80,49,32,76,101,102,116,47,85,112,0] /* P1 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str210=allocate([80,49,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P1_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str211=allocate([80,49,32,76,101,102,116,47,68,111,119,110,0] /* P1 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212=allocate([80,49,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P1_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213402=allocate([80,49,32,76,101,102,116,47,76,101,102,116,0] /* P1 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214=allocate([80,49,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P1_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215=allocate([80,49,32,76,101,102,116,47,82,105,103,104,116,0] /* P1 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str216=allocate([80,49,95,66,85,84,84,79,78,49,0] /* P1_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str217=allocate([80,49,32,66,117,116,116,111,110,32,49,0] /* P1 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str218=allocate([80,49,95,66,85,84,84,79,78,50,0] /* P1_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str219=allocate([80,49,32,66,117,116,116,111,110,32,50,0] /* P1 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str220=allocate([80,49,95,66,85,84,84,79,78,51,0] /* P1_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str221=allocate([80,49,32,66,117,116,116,111,110,32,51,0] /* P1 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222=allocate([80,49,95,66,85,84,84,79,78,52,0] /* P1_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223=allocate([80,49,32,66,117,116,116,111,110,32,52,0] /* P1 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224=allocate([80,49,95,66,85,84,84,79,78,53,0] /* P1_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225=allocate([80,49,32,66,117,116,116,111,110,32,53,0] /* P1 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str226=allocate([80,49,95,66,85,84,84,79,78,54,0] /* P1_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str227=allocate([80,49,32,66,117,116,116,111,110,32,54,0] /* P1 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str228=allocate([80,49,95,66,85,84,84,79,78,55,0] /* P1_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str229=allocate([80,49,32,66,117,116,116,111,110,32,55,0] /* P1 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str230=allocate([80,49,95,66,85,84,84,79,78,56,0] /* P1_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str231=allocate([80,49,32,66,117,116,116,111,110,32,56,0] /* P1 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232=allocate([80,49,95,66,85,84,84,79,78,57,0] /* P1_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233403=allocate([80,49,32,66,117,116,116,111,110,32,57,0] /* P1 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234=allocate([80,49,95,66,85,84,84,79,78,49,48,0] /* P1_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235=allocate([80,49,32,66,117,116,116,111,110,32,49,48,0] /* P1 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str236=allocate([80,49,95,66,85,84,84,79,78,49,49,0] /* P1_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str237=allocate([80,49,32,66,117,116,116,111,110,32,49,49,0] /* P1 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str238=allocate([80,49,95,66,85,84,84,79,78,49,50,0] /* P1_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str239=allocate([80,49,32,66,117,116,116,111,110,32,49,50,0] /* P1 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str240=allocate([80,49,95,66,85,84,84,79,78,49,51,0] /* P1_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str241=allocate([80,49,32,66,117,116,116,111,110,32,49,51,0] /* P1 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242=allocate([80,49,95,66,85,84,84,79,78,49,52,0] /* P1_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243=allocate([80,49,32,66,117,116,116,111,110,32,49,52,0] /* P1 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244=allocate([80,49,95,66,85,84,84,79,78,49,53,0] /* P1_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245=allocate([80,49,32,66,117,116,116,111,110,32,49,53,0] /* P1 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str246=allocate([80,49,95,66,85,84,84,79,78,49,54,0] /* P1_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str247=allocate([80,49,32,66,117,116,116,111,110,32,49,54,0] /* P1 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str248=allocate([80,49,95,83,84,65,82,84,0] /* P1_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str249=allocate([80,49,32,83,116,97,114,116,0] /* P1 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str250=allocate([80,49,95,83,69,76,69,67,84,0] /* P1_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str251=allocate([80,49,32,83,101,108,101,99,116,0] /* P1 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252=allocate([80,49,95,77,65,72,74,79,78,71,95,65,0] /* P1_MAHJONG_A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253=allocate([80,49,32,77,97,104,106,111,110,103,32,65,0] /* P1 Mahjong A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254=allocate([80,49,95,77,65,72,74,79,78,71,95,66,0] /* P1_MAHJONG_B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255=allocate([80,49,32,77,97,104,106,111,110,103,32,66,0] /* P1 Mahjong B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str256=allocate([80,49,95,77,65,72,74,79,78,71,95,67,0] /* P1_MAHJONG_C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str257=allocate([80,49,32,77,97,104,106,111,110,103,32,67,0] /* P1 Mahjong C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str258=allocate([80,49,95,77,65,72,74,79,78,71,95,68,0] /* P1_MAHJONG_D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str259=allocate([80,49,32,77,97,104,106,111,110,103,32,68,0] /* P1 Mahjong D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str260=allocate([80,49,95,77,65,72,74,79,78,71,95,69,0] /* P1_MAHJONG_E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str261=allocate([80,49,32,77,97,104,106,111,110,103,32,69,0] /* P1 Mahjong E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262=allocate([80,49,95,77,65,72,74,79,78,71,95,70,0] /* P1_MAHJONG_F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263=allocate([80,49,32,77,97,104,106,111,110,103,32,70,0] /* P1 Mahjong F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264=allocate([80,49,95,77,65,72,74,79,78,71,95,71,0] /* P1_MAHJONG_G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265=allocate([80,49,32,77,97,104,106,111,110,103,32,71,0] /* P1 Mahjong G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str266=allocate([80,49,95,77,65,72,74,79,78,71,95,72,0] /* P1_MAHJONG_H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str267=allocate([80,49,32,77,97,104,106,111,110,103,32,72,0] /* P1 Mahjong H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str268=allocate([80,49,95,77,65,72,74,79,78,71,95,73,0] /* P1_MAHJONG_I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str269=allocate([80,49,32,77,97,104,106,111,110,103,32,73,0] /* P1 Mahjong I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str270=allocate([80,49,95,77,65,72,74,79,78,71,95,74,0] /* P1_MAHJONG_J\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str271404=allocate([80,49,32,77,97,104,106,111,110,103,32,74,0] /* P1 Mahjong J\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272=allocate([80,49,95,77,65,72,74,79,78,71,95,75,0] /* P1_MAHJONG_K\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str273=allocate([80,49,32,77,97,104,106,111,110,103,32,75,0] /* P1 Mahjong K\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274=allocate([80,49,95,77,65,72,74,79,78,71,95,76,0] /* P1_MAHJONG_L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str275=allocate([80,49,32,77,97,104,106,111,110,103,32,76,0] /* P1 Mahjong L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str276=allocate([80,49,95,77,65,72,74,79,78,71,95,77,0] /* P1_MAHJONG_M\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str277=allocate([80,49,32,77,97,104,106,111,110,103,32,77,0] /* P1 Mahjong M\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str278=allocate([80,49,95,77,65,72,74,79,78,71,95,78,0] /* P1_MAHJONG_N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str279=allocate([80,49,32,77,97,104,106,111,110,103,32,78,0] /* P1 Mahjong N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str280=allocate([80,49,95,77,65,72,74,79,78,71,95,79,0] /* P1_MAHJONG_O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str281=allocate([80,49,32,77,97,104,106,111,110,103,32,79,0] /* P1 Mahjong O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282=allocate([80,49,95,77,65,72,74,79,78,71,95,80,0] /* P1_MAHJONG_P\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str283=allocate([80,49,32,77,97,104,106,111,110,103,32,80,0] /* P1 Mahjong P\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284=allocate([80,49,95,77,65,72,74,79,78,71,95,81,0] /* P1_MAHJONG_Q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str285=allocate([80,49,32,77,97,104,106,111,110,103,32,81,0] /* P1 Mahjong Q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str286=allocate([80,49,95,77,65,72,74,79,78,71,95,75,65,78,0] /* P1_MAHJONG_KAN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str287=allocate([80,49,32,77,97,104,106,111,110,103,32,75,97,110,0] /* P1 Mahjong Kan\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str288=allocate([80,49,95,77,65,72,74,79,78,71,95,80,79,78,0] /* P1_MAHJONG_PON\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str289=allocate([80,49,32,77,97,104,106,111,110,103,32,80,111,110,0] /* P1 Mahjong Pon\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str290=allocate([80,49,95,77,65,72,74,79,78,71,95,67,72,73,0] /* P1_MAHJONG_CHI\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str291=allocate([80,49,32,77,97,104,106,111,110,103,32,67,104,105,0] /* P1 Mahjong Chi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292=allocate([80,49,95,77,65,72,74,79,78,71,95,82,69,65,67,72,0] /* P1_MAHJONG_REACH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293=allocate([80,49,32,77,97,104,106,111,110,103,32,82,101,97,99,104,0] /* P1 Mahjong Reach\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294=allocate([80,49,95,77,65,72,74,79,78,71,95,82,79,78,0] /* P1_MAHJONG_RON\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str295=allocate([80,49,32,77,97,104,106,111,110,103,32,82,111,110,0] /* P1 Mahjong Ron\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str296=allocate([80,49,95,77,65,72,74,79,78,71,95,66,69,84,0] /* P1_MAHJONG_BET\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str297=allocate([80,49,32,77,97,104,106,111,110,103,32,66,101,116,0] /* P1 Mahjong Bet\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str298=allocate([80,49,95,77,65,72,74,79,78,71,95,76,65,83,84,95,67,72,65,78,67,69,0] /* P1_MAHJONG_LAST_CHAN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str299=allocate([80,49,32,77,97,104,106,111,110,103,32,76,97,115,116,32,67,104,97,110,99,101,0] /* P1 Mahjong Last Chan */, "i8", ALLOC_STATIC);
STRING_TABLE.__str300=allocate([80,49,95,77,65,72,74,79,78,71,95,83,67,79,82,69,0] /* P1_MAHJONG_SCORE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str301=allocate([80,49,32,77,97,104,106,111,110,103,32,83,99,111,114,101,0] /* P1 Mahjong Score\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str302=allocate([80,49,95,77,65,72,74,79,78,71,95,68,79,85,66,76,69,95,85,80,0] /* P1_MAHJONG_DOUBLE_UP */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303=allocate([80,49,32,77,97,104,106,111,110,103,32,68,111,117,98,108,101,32,85,112,0] /* P1 Mahjong Double Up */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304=allocate([80,49,95,77,65,72,74,79,78,71,95,70,76,73,80,95,70,76,79,80,0] /* P1_MAHJONG_FLIP_FLOP */, "i8", ALLOC_STATIC);
STRING_TABLE.__str305=allocate([80,49,32,77,97,104,106,111,110,103,32,70,108,105,112,32,70,108,111,112,0] /* P1 Mahjong Flip Flop */, "i8", ALLOC_STATIC);
STRING_TABLE.__str306=allocate([80,49,95,77,65,72,74,79,78,71,95,66,73,71,0] /* P1_MAHJONG_BIG\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str307405=allocate([80,49,32,77,97,104,106,111,110,103,32,66,105,103,0] /* P1 Mahjong Big\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str308=allocate([80,49,95,77,65,72,74,79,78,71,95,83,77,65,76,76,0] /* P1_MAHJONG_SMALL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str309=allocate([80,49,32,77,97,104,106,111,110,103,32,83,109,97,108,108,0] /* P1 Mahjong Small\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str310=allocate([80,49,95,72,65,78,65,70,85,68,65,95,65,0] /* P1_HANAFUDA_A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str311=allocate([80,49,32,72,97,110,97,102,117,100,97,32,65,32,47,32,49,0] /* P1 Hanafuda A / 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312=allocate([80,49,95,72,65,78,65,70,85,68,65,95,66,0] /* P1_HANAFUDA_B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313=allocate([80,49,32,72,97,110,97,102,117,100,97,32,66,32,47,32,50,0] /* P1 Hanafuda B / 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314406=allocate([80,49,95,72,65,78,65,70,85,68,65,95,67,0] /* P1_HANAFUDA_C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str315=allocate([80,49,32,72,97,110,97,102,117,100,97,32,67,32,47,32,51,0] /* P1 Hanafuda C / 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str316=allocate([80,49,95,72,65,78,65,70,85,68,65,95,68,0] /* P1_HANAFUDA_D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str317=allocate([80,49,32,72,97,110,97,102,117,100,97,32,68,32,47,32,52,0] /* P1 Hanafuda D / 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str318=allocate([80,49,95,72,65,78,65,70,85,68,65,95,69,0] /* P1_HANAFUDA_E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str319=allocate([80,49,32,72,97,110,97,102,117,100,97,32,69,32,47,32,53,0] /* P1 Hanafuda E / 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str320=allocate([80,49,95,72,65,78,65,70,85,68,65,95,70,0] /* P1_HANAFUDA_F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str321407=allocate([80,49,32,72,97,110,97,102,117,100,97,32,70,32,47,32,54,0] /* P1 Hanafuda F / 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322=allocate([80,49,95,72,65,78,65,70,85,68,65,95,71,0] /* P1_HANAFUDA_G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str323=allocate([80,49,32,72,97,110,97,102,117,100,97,32,71,32,47,32,55,0] /* P1 Hanafuda G / 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324=allocate([80,49,95,72,65,78,65,70,85,68,65,95,72,0] /* P1_HANAFUDA_H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str325=allocate([80,49,32,72,97,110,97,102,117,100,97,32,72,32,47,32,56,0] /* P1 Hanafuda H / 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str326=allocate([80,49,95,72,65,78,65,70,85,68,65,95,89,69,83,0] /* P1_HANAFUDA_YES\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str327=allocate([80,49,32,72,97,110,97,102,117,100,97,32,89,101,115,0] /* P1 Hanafuda Yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str328=allocate([80,49,95,72,65,78,65,70,85,68,65,95,78,79,0] /* P1_HANAFUDA_NO\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str329=allocate([80,49,32,72,97,110,97,102,117,100,97,32,78,111,0] /* P1 Hanafuda No\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str330=allocate([80,49,95,71,65,77,66,76,69,95,72,73,71,72,0] /* P1_GAMBLE_HIGH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str331=allocate([72,105,103,104,0] /* High\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332=allocate([80,49,95,71,65,77,66,76,69,95,76,79,87,0] /* P1_GAMBLE_LOW\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str333=allocate([76,111,119,0] /* Low\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334=allocate([80,49,95,71,65,77,66,76,69,95,72,65,76,70,0] /* P1_GAMBLE_HALF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str335=allocate([72,97,108,102,32,71,97,109,98,108,101,0] /* Half Gamble\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str336=allocate([80,49,95,71,65,77,66,76,69,95,68,69,65,76,0] /* P1_GAMBLE_DEAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str337=allocate([68,101,97,108,0] /* Deal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str338=allocate([80,49,95,71,65,77,66,76,69,95,68,95,85,80,0] /* P1_GAMBLE_D_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str339=allocate([68,111,117,98,108,101,32,85,112,0] /* Double Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str340=allocate([80,49,95,71,65,77,66,76,69,95,84,65,75,69,0] /* P1_GAMBLE_TAKE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str341=allocate([84,97,107,101,0] /* Take\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342=allocate([80,49,95,71,65,77,66,76,69,95,83,84,65,78,68,0] /* P1_GAMBLE_STAND\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str343=allocate([83,116,97,110,100,0] /* Stand\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344=allocate([80,49,95,71,65,77,66,76,69,95,66,69,84,0] /* P1_GAMBLE_BET\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str345=allocate([66,101,116,0] /* Bet\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str346=allocate([80,49,95,71,65,77,66,76,69,95,75,69,89,73,78,0] /* P1_GAMBLE_KEYIN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str347=allocate([75,101,121,32,73,110,0] /* Key In\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str348=allocate([80,49,95,71,65,77,66,76,69,95,75,69,89,79,85,84,0] /* P1_GAMBLE_KEYOUT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str349=allocate([75,101,121,32,79,117,116,0] /* Key Out\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str350=allocate([80,49,95,71,65,77,66,76,69,95,80,65,89,79,85,84,0] /* P1_GAMBLE_PAYOUT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str351=allocate([80,97,121,111,117,116,0] /* Payout\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str352=allocate([80,49,95,71,65,77,66,76,69,95,68,79,79,82,0] /* P1_GAMBLE_DOOR\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str353=allocate([68,111,111,114,0] /* Door\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354=allocate([80,49,95,71,65,77,66,76,69,95,83,69,82,86,73,67,69,0] /* P1_GAMBLE_SERVICE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str355=allocate([83,101,114,118,105,99,101,0] /* Service\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str356=allocate([80,49,95,71,65,77,66,76,69,95,66,79,79,75,0] /* P1_GAMBLE_BOOK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str357=allocate([66,111,111,107,45,75,101,101,112,105,110,103,0] /* Book-Keeping\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str358=allocate([80,49,95,80,79,75,69,82,95,72,79,76,68,49,0] /* P1_POKER_HOLD1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str359=allocate([72,111,108,100,32,49,0] /* Hold 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str360=allocate([80,49,95,80,79,75,69,82,95,72,79,76,68,50,0] /* P1_POKER_HOLD2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str361=allocate([72,111,108,100,32,50,0] /* Hold 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362=allocate([80,49,95,80,79,75,69,82,95,72,79,76,68,51,0] /* P1_POKER_HOLD3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str363=allocate([72,111,108,100,32,51,0] /* Hold 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str364=allocate([80,49,95,80,79,75,69,82,95,72,79,76,68,52,0] /* P1_POKER_HOLD4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str365=allocate([72,111,108,100,32,52,0] /* Hold 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str366=allocate([80,49,95,80,79,75,69,82,95,72,79,76,68,53,0] /* P1_POKER_HOLD5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str367=allocate([72,111,108,100,32,53,0] /* Hold 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str368=allocate([80,49,95,80,79,75,69,82,95,67,65,78,67,69,76,0] /* P1_POKER_CANCEL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str369=allocate([67,97,110,99,101,108,0] /* Cancel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str370=allocate([80,49,95,80,79,75,69,82,95,66,69,84,0] /* P1_POKER_BET\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str371=allocate([80,49,95,83,76,79,84,95,83,84,79,80,49,0] /* P1_SLOT_STOP1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str372408=allocate([83,116,111,112,32,82,101,101,108,32,49,0] /* Stop Reel 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str373=allocate([80,49,95,83,76,79,84,95,83,84,79,80,50,0] /* P1_SLOT_STOP2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374=allocate([83,116,111,112,32,82,101,101,108,32,50,0] /* Stop Reel 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str375=allocate([80,49,95,83,76,79,84,95,83,84,79,80,51,0] /* P1_SLOT_STOP3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str376=allocate([83,116,111,112,32,82,101,101,108,32,51,0] /* Stop Reel 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str377=allocate([80,49,95,83,76,79,84,95,83,84,79,80,52,0] /* P1_SLOT_STOP4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str378=allocate([83,116,111,112,32,82,101,101,108,32,52,0] /* Stop Reel 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str379=allocate([80,49,95,83,76,79,84,95,83,84,79,80,95,65,76,76,0] /* P1_SLOT_STOP_ALL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str380=allocate([83,116,111,112,32,65,108,108,32,82,101,101,108,115,0] /* Stop All Reels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str381=allocate([80,50,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P2_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str382=allocate([80,50,32,85,112,0] /* P2 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str383=allocate([80,50,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P2_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384=allocate([80,50,32,68,111,119,110,0] /* P2 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str385=allocate([80,50,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P2_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str386=allocate([80,50,32,76,101,102,116,0] /* P2 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str387=allocate([80,50,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P2_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str388=allocate([80,50,32,82,105,103,104,116,0] /* P2 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str389=allocate([80,50,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P2_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str390=allocate([80,50,32,82,105,103,104,116,47,85,112,0] /* P2 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str391=allocate([80,50,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P2_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str392=allocate([80,50,32,82,105,103,104,116,47,68,111,119,110,0] /* P2 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str393=allocate([80,50,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P2_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394=allocate([80,50,32,82,105,103,104,116,47,76,101,102,116,0] /* P2 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str395=allocate([80,50,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P2_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str396=allocate([80,50,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P2 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str397=allocate([80,50,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P2_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str398=allocate([80,50,32,76,101,102,116,47,85,112,0] /* P2 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str399=allocate([80,50,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P2_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str400=allocate([80,50,32,76,101,102,116,47,68,111,119,110,0] /* P2 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str401=allocate([80,50,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P2_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402=allocate([80,50,32,76,101,102,116,47,76,101,102,116,0] /* P2 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str403=allocate([80,50,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P2_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str404=allocate([80,50,32,76,101,102,116,47,82,105,103,104,116,0] /* P2 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str405=allocate([80,50,95,66,85,84,84,79,78,49,0] /* P2_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str406=allocate([80,50,32,66,117,116,116,111,110,32,49,0] /* P2 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str407=allocate([80,50,95,66,85,84,84,79,78,50,0] /* P2_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str408=allocate([80,50,32,66,117,116,116,111,110,32,50,0] /* P2 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str409=allocate([80,50,95,66,85,84,84,79,78,51,0] /* P2_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str410=allocate([80,50,32,66,117,116,116,111,110,32,51,0] /* P2 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str411=allocate([80,50,95,66,85,84,84,79,78,52,0] /* P2_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412=allocate([80,50,32,66,117,116,116,111,110,32,52,0] /* P2 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str413=allocate([80,50,95,66,85,84,84,79,78,53,0] /* P2_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str414=allocate([80,50,32,66,117,116,116,111,110,32,53,0] /* P2 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str415409=allocate([80,50,95,66,85,84,84,79,78,54,0] /* P2_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str416=allocate([80,50,32,66,117,116,116,111,110,32,54,0] /* P2 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str417=allocate([80,50,95,66,85,84,84,79,78,55,0] /* P2_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str418=allocate([80,50,32,66,117,116,116,111,110,32,55,0] /* P2 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str419=allocate([80,50,95,66,85,84,84,79,78,56,0] /* P2_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str420=allocate([80,50,32,66,117,116,116,111,110,32,56,0] /* P2 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str421=allocate([80,50,95,66,85,84,84,79,78,57,0] /* P2_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422=allocate([80,50,32,66,117,116,116,111,110,32,57,0] /* P2 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str423=allocate([80,50,95,66,85,84,84,79,78,49,48,0] /* P2_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424=allocate([80,50,32,66,117,116,116,111,110,32,49,48,0] /* P2 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str425=allocate([80,50,95,66,85,84,84,79,78,49,49,0] /* P2_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str426=allocate([80,50,32,66,117,116,116,111,110,32,49,49,0] /* P2 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str427=allocate([80,50,95,66,85,84,84,79,78,49,50,0] /* P2_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str428=allocate([80,50,32,66,117,116,116,111,110,32,49,50,0] /* P2 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str429=allocate([80,50,95,66,85,84,84,79,78,49,51,0] /* P2_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str430=allocate([80,50,32,66,117,116,116,111,110,32,49,51,0] /* P2 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str431=allocate([80,50,95,66,85,84,84,79,78,49,52,0] /* P2_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432=allocate([80,50,32,66,117,116,116,111,110,32,49,52,0] /* P2 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str433=allocate([80,50,95,66,85,84,84,79,78,49,53,0] /* P2_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str434=allocate([80,50,32,66,117,116,116,111,110,32,49,53,0] /* P2 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str435=allocate([80,50,95,66,85,84,84,79,78,49,54,0] /* P2_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str436=allocate([80,50,32,66,117,116,116,111,110,32,49,54,0] /* P2 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str437=allocate([80,50,95,83,84,65,82,84,0] /* P2_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str438=allocate([80,50,32,83,116,97,114,116,0] /* P2 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str439=allocate([80,50,95,83,69,76,69,67,84,0] /* P2_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str440=allocate([80,50,32,83,101,108,101,99,116,0] /* P2 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str441=allocate([80,50,95,77,65,72,74,79,78,71,95,65,0] /* P2_MAHJONG_A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442=allocate([80,50,32,77,97,104,106,111,110,103,32,65,0] /* P2 Mahjong A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str443=allocate([80,50,95,77,65,72,74,79,78,71,95,66,0] /* P2_MAHJONG_B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444=allocate([80,50,32,77,97,104,106,111,110,103,32,66,0] /* P2 Mahjong B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str445=allocate([80,50,95,77,65,72,74,79,78,71,95,67,0] /* P2_MAHJONG_C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str446=allocate([80,50,32,77,97,104,106,111,110,103,32,67,0] /* P2 Mahjong C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str447=allocate([80,50,95,77,65,72,74,79,78,71,95,68,0] /* P2_MAHJONG_D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str448=allocate([80,50,32,77,97,104,106,111,110,103,32,68,0] /* P2 Mahjong D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str449=allocate([80,50,95,77,65,72,74,79,78,71,95,69,0] /* P2_MAHJONG_E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str450=allocate([80,50,32,77,97,104,106,111,110,103,32,69,0] /* P2 Mahjong E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str451=allocate([80,50,95,77,65,72,74,79,78,71,95,70,0] /* P2_MAHJONG_F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452=allocate([80,50,32,77,97,104,106,111,110,103,32,70,0] /* P2 Mahjong F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str453=allocate([80,50,95,77,65,72,74,79,78,71,95,71,0] /* P2_MAHJONG_G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str454=allocate([80,50,32,77,97,104,106,111,110,103,32,71,0] /* P2 Mahjong G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str455=allocate([80,50,95,77,65,72,74,79,78,71,95,72,0] /* P2_MAHJONG_H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str456=allocate([80,50,32,77,97,104,106,111,110,103,32,72,0] /* P2 Mahjong H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str457=allocate([80,50,95,77,65,72,74,79,78,71,95,73,0] /* P2_MAHJONG_I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str458=allocate([80,50,32,77,97,104,106,111,110,103,32,73,0] /* P2 Mahjong I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str459=allocate([80,50,95,77,65,72,74,79,78,71,95,74,0] /* P2_MAHJONG_J\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str460=allocate([80,50,32,77,97,104,106,111,110,103,32,74,0] /* P2 Mahjong J\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str461=allocate([80,50,95,77,65,72,74,79,78,71,95,75,0] /* P2_MAHJONG_K\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str462=allocate([80,50,32,77,97,104,106,111,110,103,32,75,0] /* P2 Mahjong K\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str463=allocate([80,50,95,77,65,72,74,79,78,71,95,76,0] /* P2_MAHJONG_L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str464=allocate([80,50,32,77,97,104,106,111,110,103,32,76,0] /* P2 Mahjong L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str465=allocate([80,50,95,77,65,72,74,79,78,71,95,77,0] /* P2_MAHJONG_M\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str466=allocate([80,50,32,77,97,104,106,111,110,103,32,77,0] /* P2 Mahjong M\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str467=allocate([80,50,95,77,65,72,74,79,78,71,95,78,0] /* P2_MAHJONG_N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str468=allocate([80,50,32,77,97,104,106,111,110,103,32,78,0] /* P2 Mahjong N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str469=allocate([80,50,95,77,65,72,74,79,78,71,95,79,0] /* P2_MAHJONG_O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str470=allocate([80,50,32,77,97,104,106,111,110,103,32,79,0] /* P2 Mahjong O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str471=allocate([80,50,95,77,65,72,74,79,78,71,95,80,0] /* P2_MAHJONG_P\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str472=allocate([80,50,32,77,97,104,106,111,110,103,32,80,0] /* P2 Mahjong P\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str473410=allocate([80,50,95,77,65,72,74,79,78,71,95,81,0] /* P2_MAHJONG_Q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str474=allocate([80,50,32,77,97,104,106,111,110,103,32,81,0] /* P2 Mahjong Q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str475=allocate([80,50,95,77,65,72,74,79,78,71,95,75,65,78,0] /* P2_MAHJONG_KAN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str476=allocate([80,50,32,77,97,104,106,111,110,103,32,75,97,110,0] /* P2 Mahjong Kan\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str477=allocate([80,50,95,77,65,72,74,79,78,71,95,80,79,78,0] /* P2_MAHJONG_PON\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str478=allocate([80,50,32,77,97,104,106,111,110,103,32,80,111,110,0] /* P2 Mahjong Pon\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str479=allocate([80,50,95,77,65,72,74,79,78,71,95,67,72,73,0] /* P2_MAHJONG_CHI\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str480=allocate([80,50,32,77,97,104,106,111,110,103,32,67,104,105,0] /* P2 Mahjong Chi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str481=allocate([80,50,95,77,65,72,74,79,78,71,95,82,69,65,67,72,0] /* P2_MAHJONG_REACH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str482=allocate([80,50,32,77,97,104,106,111,110,103,32,82,101,97,99,104,0] /* P2 Mahjong Reach\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str483=allocate([80,50,95,77,65,72,74,79,78,71,95,82,79,78,0] /* P2_MAHJONG_RON\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str484=allocate([80,50,32,77,97,104,106,111,110,103,32,82,111,110,0] /* P2 Mahjong Ron\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str485=allocate([80,50,95,77,65,72,74,79,78,71,95,66,69,84,0] /* P2_MAHJONG_BET\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str486=allocate([80,50,32,77,97,104,106,111,110,103,32,66,101,116,0] /* P2 Mahjong Bet\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str487=allocate([80,50,95,77,65,72,74,79,78,71,95,76,65,83,84,95,67,72,65,78,67,69,0] /* P2_MAHJONG_LAST_CHAN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str488=allocate([80,50,32,77,97,104,106,111,110,103,32,76,97,115,116,32,67,104,97,110,99,101,0] /* P2 Mahjong Last Chan */, "i8", ALLOC_STATIC);
STRING_TABLE.__str489=allocate([80,50,95,77,65,72,74,79,78,71,95,83,67,79,82,69,0] /* P2_MAHJONG_SCORE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str490=allocate([80,50,32,77,97,104,106,111,110,103,32,83,99,111,114,101,0] /* P2 Mahjong Score\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str491=allocate([80,50,95,77,65,72,74,79,78,71,95,68,79,85,66,76,69,95,85,80,0] /* P2_MAHJONG_DOUBLE_UP */, "i8", ALLOC_STATIC);
STRING_TABLE.__str492=allocate([80,50,32,77,97,104,106,111,110,103,32,68,111,117,98,108,101,32,85,112,0] /* P2 Mahjong Double Up */, "i8", ALLOC_STATIC);
STRING_TABLE.__str493=allocate([80,50,95,77,65,72,74,79,78,71,95,70,76,73,80,95,70,76,79,80,0] /* P2_MAHJONG_FLIP_FLOP */, "i8", ALLOC_STATIC);
STRING_TABLE.__str494=allocate([80,50,32,77,97,104,106,111,110,103,32,70,108,105,112,32,70,108,111,112,0] /* P2 Mahjong Flip Flop */, "i8", ALLOC_STATIC);
STRING_TABLE.__str495=allocate([80,50,95,77,65,72,74,79,78,71,95,66,73,71,0] /* P2_MAHJONG_BIG\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str496=allocate([80,50,32,77,97,104,106,111,110,103,32,66,105,103,0] /* P2 Mahjong Big\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str497=allocate([80,50,95,77,65,72,74,79,78,71,95,83,77,65,76,76,0] /* P2_MAHJONG_SMALL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str498=allocate([80,50,32,77,97,104,106,111,110,103,32,83,109,97,108,108,0] /* P2 Mahjong Small\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str499=allocate([80,50,95,72,65,78,65,70,85,68,65,95,65,0] /* P2_HANAFUDA_A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str500=allocate([80,50,32,72,97,110,97,102,117,100,97,32,65,32,47,32,49,0] /* P2 Hanafuda A / 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str501=allocate([80,50,95,72,65,78,65,70,85,68,65,95,66,0] /* P2_HANAFUDA_B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str502=allocate([80,50,32,72,97,110,97,102,117,100,97,32,66,32,47,32,50,0] /* P2 Hanafuda B / 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str503=allocate([80,50,95,72,65,78,65,70,85,68,65,95,67,0] /* P2_HANAFUDA_C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str504=allocate([80,50,32,72,97,110,97,102,117,100,97,32,67,32,47,32,51,0] /* P2 Hanafuda C / 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str505=allocate([80,50,95,72,65,78,65,70,85,68,65,95,68,0] /* P2_HANAFUDA_D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str506=allocate([80,50,32,72,97,110,97,102,117,100,97,32,68,32,47,32,52,0] /* P2 Hanafuda D / 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str507=allocate([80,50,95,72,65,78,65,70,85,68,65,95,69,0] /* P2_HANAFUDA_E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str508=allocate([80,50,32,72,97,110,97,102,117,100,97,32,69,32,47,32,53,0] /* P2 Hanafuda E / 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str509=allocate([80,50,95,72,65,78,65,70,85,68,65,95,70,0] /* P2_HANAFUDA_F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str510=allocate([80,50,32,72,97,110,97,102,117,100,97,32,70,32,47,32,54,0] /* P2 Hanafuda F / 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str511=allocate([80,50,95,72,65,78,65,70,85,68,65,95,71,0] /* P2_HANAFUDA_G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str512=allocate([80,50,32,72,97,110,97,102,117,100,97,32,71,32,47,32,55,0] /* P2 Hanafuda G / 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str513=allocate([80,50,95,72,65,78,65,70,85,68,65,95,72,0] /* P2_HANAFUDA_H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str514=allocate([80,50,32,72,97,110,97,102,117,100,97,32,72,32,47,32,56,0] /* P2 Hanafuda H / 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str515=allocate([80,50,95,72,65,78,65,70,85,68,65,95,89,69,83,0] /* P2_HANAFUDA_YES\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str516411=allocate([80,50,32,72,97,110,97,102,117,100,97,32,89,101,115,0] /* P2 Hanafuda Yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str517=allocate([80,50,95,72,65,78,65,70,85,68,65,95,78,79,0] /* P2_HANAFUDA_NO\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str518=allocate([80,50,32,72,97,110,97,102,117,100,97,32,78,111,0] /* P2 Hanafuda No\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str519=allocate([80,51,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P3_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str520=allocate([80,51,32,85,112,0] /* P3 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str521=allocate([80,51,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P3_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str522=allocate([80,51,32,68,111,119,110,0] /* P3 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str523=allocate([80,51,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P3_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str524=allocate([80,51,32,76,101,102,116,0] /* P3 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str525=allocate([80,51,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P3_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str526=allocate([80,51,32,82,105,103,104,116,0] /* P3 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str527=allocate([80,51,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P3_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str528=allocate([80,51,32,82,105,103,104,116,47,85,112,0] /* P3 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str529=allocate([80,51,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P3_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str530=allocate([80,51,32,82,105,103,104,116,47,68,111,119,110,0] /* P3 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str531=allocate([80,51,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P3_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str532=allocate([80,51,32,82,105,103,104,116,47,76,101,102,116,0] /* P3 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str533=allocate([80,51,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P3_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str534=allocate([80,51,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P3 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str535=allocate([80,51,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P3_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str536=allocate([80,51,32,76,101,102,116,47,85,112,0] /* P3 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str537=allocate([80,51,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P3_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str538=allocate([80,51,32,76,101,102,116,47,68,111,119,110,0] /* P3 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str539=allocate([80,51,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P3_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str540=allocate([80,51,32,76,101,102,116,47,76,101,102,116,0] /* P3 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str541=allocate([80,51,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P3_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str542=allocate([80,51,32,76,101,102,116,47,82,105,103,104,116,0] /* P3 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str543=allocate([80,51,95,66,85,84,84,79,78,49,0] /* P3_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str544=allocate([80,51,32,66,117,116,116,111,110,32,49,0] /* P3 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str545=allocate([80,51,95,66,85,84,84,79,78,50,0] /* P3_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str546=allocate([80,51,32,66,117,116,116,111,110,32,50,0] /* P3 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str547=allocate([80,51,95,66,85,84,84,79,78,51,0] /* P3_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str548=allocate([80,51,32,66,117,116,116,111,110,32,51,0] /* P3 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str549=allocate([80,51,95,66,85,84,84,79,78,52,0] /* P3_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str550=allocate([80,51,32,66,117,116,116,111,110,32,52,0] /* P3 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str551=allocate([80,51,95,66,85,84,84,79,78,53,0] /* P3_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str552=allocate([80,51,32,66,117,116,116,111,110,32,53,0] /* P3 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str553=allocate([80,51,95,66,85,84,84,79,78,54,0] /* P3_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str554=allocate([80,51,32,66,117,116,116,111,110,32,54,0] /* P3 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str555=allocate([80,51,95,66,85,84,84,79,78,55,0] /* P3_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str556=allocate([80,51,32,66,117,116,116,111,110,32,55,0] /* P3 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str557=allocate([80,51,95,66,85,84,84,79,78,56,0] /* P3_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str558=allocate([80,51,32,66,117,116,116,111,110,32,56,0] /* P3 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str559=allocate([80,51,95,66,85,84,84,79,78,57,0] /* P3_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str560=allocate([80,51,32,66,117,116,116,111,110,32,57,0] /* P3 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str561=allocate([80,51,95,66,85,84,84,79,78,49,48,0] /* P3_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str562=allocate([80,51,32,66,117,116,116,111,110,32,49,48,0] /* P3 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str563=allocate([80,51,95,66,85,84,84,79,78,49,49,0] /* P3_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str564=allocate([80,51,32,66,117,116,116,111,110,32,49,49,0] /* P3 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str565=allocate([80,51,95,66,85,84,84,79,78,49,50,0] /* P3_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str566=allocate([80,51,32,66,117,116,116,111,110,32,49,50,0] /* P3 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str567=allocate([80,51,95,66,85,84,84,79,78,49,51,0] /* P3_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str568=allocate([80,51,32,66,117,116,116,111,110,32,49,51,0] /* P3 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str569=allocate([80,51,95,66,85,84,84,79,78,49,52,0] /* P3_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str570=allocate([80,51,32,66,117,116,116,111,110,32,49,52,0] /* P3 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str571=allocate([80,51,95,66,85,84,84,79,78,49,53,0] /* P3_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str572=allocate([80,51,32,66,117,116,116,111,110,32,49,53,0] /* P3 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str573=allocate([80,51,95,66,85,84,84,79,78,49,54,0] /* P3_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str574412=allocate([80,51,32,66,117,116,116,111,110,32,49,54,0] /* P3 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str575=allocate([80,51,95,83,84,65,82,84,0] /* P3_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str576=allocate([80,51,32,83,116,97,114,116,0] /* P3 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str577=allocate([80,51,95,83,69,76,69,67,84,0] /* P3_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str578=allocate([80,51,32,83,101,108,101,99,116,0] /* P3 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str579=allocate([80,52,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P4_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str580=allocate([80,52,32,85,112,0] /* P4 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str581=allocate([80,52,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P4_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str582=allocate([80,52,32,68,111,119,110,0] /* P4 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str583=allocate([80,52,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P4_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str584=allocate([80,52,32,76,101,102,116,0] /* P4 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str585=allocate([80,52,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P4_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str586=allocate([80,52,32,82,105,103,104,116,0] /* P4 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str587=allocate([80,52,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P4_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str588=allocate([80,52,32,82,105,103,104,116,47,85,112,0] /* P4 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str589=allocate([80,52,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P4_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str590=allocate([80,52,32,82,105,103,104,116,47,68,111,119,110,0] /* P4 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str591=allocate([80,52,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P4_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str592=allocate([80,52,32,82,105,103,104,116,47,76,101,102,116,0] /* P4 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str593=allocate([80,52,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P4_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str594=allocate([80,52,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P4 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str595=allocate([80,52,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P4_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str596=allocate([80,52,32,76,101,102,116,47,85,112,0] /* P4 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str597=allocate([80,52,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P4_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str598=allocate([80,52,32,76,101,102,116,47,68,111,119,110,0] /* P4 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str599=allocate([80,52,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P4_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str600=allocate([80,52,32,76,101,102,116,47,76,101,102,116,0] /* P4 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str601=allocate([80,52,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P4_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str602=allocate([80,52,32,76,101,102,116,47,82,105,103,104,116,0] /* P4 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str603=allocate([80,52,95,66,85,84,84,79,78,49,0] /* P4_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str604=allocate([80,52,32,66,117,116,116,111,110,32,49,0] /* P4 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str605=allocate([80,52,95,66,85,84,84,79,78,50,0] /* P4_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str606=allocate([80,52,32,66,117,116,116,111,110,32,50,0] /* P4 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str607=allocate([80,52,95,66,85,84,84,79,78,51,0] /* P4_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str608=allocate([80,52,32,66,117,116,116,111,110,32,51,0] /* P4 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str609=allocate([80,52,95,66,85,84,84,79,78,52,0] /* P4_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str610=allocate([80,52,32,66,117,116,116,111,110,32,52,0] /* P4 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str611=allocate([80,52,95,66,85,84,84,79,78,53,0] /* P4_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str612=allocate([80,52,32,66,117,116,116,111,110,32,53,0] /* P4 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str613=allocate([80,52,95,66,85,84,84,79,78,54,0] /* P4_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str614=allocate([80,52,32,66,117,116,116,111,110,32,54,0] /* P4 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str615=allocate([80,52,95,66,85,84,84,79,78,55,0] /* P4_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str616=allocate([80,52,32,66,117,116,116,111,110,32,55,0] /* P4 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str617413=allocate([80,52,95,66,85,84,84,79,78,56,0] /* P4_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str618=allocate([80,52,32,66,117,116,116,111,110,32,56,0] /* P4 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str619=allocate([80,52,95,66,85,84,84,79,78,57,0] /* P4_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str620=allocate([80,52,32,66,117,116,116,111,110,32,57,0] /* P4 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str621=allocate([80,52,95,66,85,84,84,79,78,49,48,0] /* P4_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str622=allocate([80,52,32,66,117,116,116,111,110,32,49,48,0] /* P4 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str623=allocate([80,52,95,66,85,84,84,79,78,49,49,0] /* P4_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str624=allocate([80,52,32,66,117,116,116,111,110,32,49,49,0] /* P4 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str625=allocate([80,52,95,66,85,84,84,79,78,49,50,0] /* P4_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str626=allocate([80,52,32,66,117,116,116,111,110,32,49,50,0] /* P4 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str627=allocate([80,52,95,66,85,84,84,79,78,49,51,0] /* P4_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str628=allocate([80,52,32,66,117,116,116,111,110,32,49,51,0] /* P4 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str629=allocate([80,52,95,66,85,84,84,79,78,49,52,0] /* P4_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str630=allocate([80,52,32,66,117,116,116,111,110,32,49,52,0] /* P4 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str631=allocate([80,52,95,66,85,84,84,79,78,49,53,0] /* P4_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str632=allocate([80,52,32,66,117,116,116,111,110,32,49,53,0] /* P4 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str633=allocate([80,52,95,66,85,84,84,79,78,49,54,0] /* P4_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str634=allocate([80,52,32,66,117,116,116,111,110,32,49,54,0] /* P4 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str635=allocate([80,52,95,83,84,65,82,84,0] /* P4_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str636=allocate([80,52,32,83,116,97,114,116,0] /* P4 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str637=allocate([80,52,95,83,69,76,69,67,84,0] /* P4_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str638=allocate([80,52,32,83,101,108,101,99,116,0] /* P4 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str639=allocate([80,53,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P5_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str640=allocate([80,53,32,85,112,0] /* P5 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str641=allocate([80,53,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P5_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str642=allocate([80,53,32,68,111,119,110,0] /* P5 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str643=allocate([80,53,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P5_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str644=allocate([80,53,32,76,101,102,116,0] /* P5 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str645=allocate([80,53,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P5_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str646=allocate([80,53,32,82,105,103,104,116,0] /* P5 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str647=allocate([80,53,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P5_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str648=allocate([80,53,32,82,105,103,104,116,47,85,112,0] /* P5 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str649=allocate([80,53,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P5_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str650=allocate([80,53,32,82,105,103,104,116,47,68,111,119,110,0] /* P5 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str651=allocate([80,53,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P5_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str652=allocate([80,53,32,82,105,103,104,116,47,76,101,102,116,0] /* P5 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str653=allocate([80,53,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P5_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str654=allocate([80,53,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P5 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str655=allocate([80,53,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P5_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str656=allocate([80,53,32,76,101,102,116,47,85,112,0] /* P5 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str657=allocate([80,53,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P5_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str658=allocate([80,53,32,76,101,102,116,47,68,111,119,110,0] /* P5 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str659=allocate([80,53,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P5_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str660=allocate([80,53,32,76,101,102,116,47,76,101,102,116,0] /* P5 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str661=allocate([80,53,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P5_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str662=allocate([80,53,32,76,101,102,116,47,82,105,103,104,116,0] /* P5 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str663=allocate([80,53,95,66,85,84,84,79,78,49,0] /* P5_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str664=allocate([80,53,32,66,117,116,116,111,110,32,49,0] /* P5 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str665=allocate([80,53,95,66,85,84,84,79,78,50,0] /* P5_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str666=allocate([80,53,32,66,117,116,116,111,110,32,50,0] /* P5 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str667=allocate([80,53,95,66,85,84,84,79,78,51,0] /* P5_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str668=allocate([80,53,32,66,117,116,116,111,110,32,51,0] /* P5 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str669=allocate([80,53,95,66,85,84,84,79,78,52,0] /* P5_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str670=allocate([80,53,32,66,117,116,116,111,110,32,52,0] /* P5 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str671=allocate([80,53,95,66,85,84,84,79,78,53,0] /* P5_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str672=allocate([80,53,32,66,117,116,116,111,110,32,53,0] /* P5 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str673=allocate([80,53,95,66,85,84,84,79,78,54,0] /* P5_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str674=allocate([80,53,32,66,117,116,116,111,110,32,54,0] /* P5 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str675414=allocate([80,53,95,66,85,84,84,79,78,55,0] /* P5_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str676=allocate([80,53,32,66,117,116,116,111,110,32,55,0] /* P5 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str677=allocate([80,53,95,66,85,84,84,79,78,56,0] /* P5_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str678=allocate([80,53,32,66,117,116,116,111,110,32,56,0] /* P5 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str679=allocate([80,53,95,66,85,84,84,79,78,57,0] /* P5_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str680=allocate([80,53,32,66,117,116,116,111,110,32,57,0] /* P5 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str681=allocate([80,53,95,66,85,84,84,79,78,49,48,0] /* P5_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str682=allocate([80,53,32,66,117,116,116,111,110,32,49,48,0] /* P5 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str683=allocate([80,53,95,66,85,84,84,79,78,49,49,0] /* P5_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str684=allocate([80,53,32,66,117,116,116,111,110,32,49,49,0] /* P5 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str685=allocate([80,53,95,66,85,84,84,79,78,49,50,0] /* P5_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str686=allocate([80,53,32,66,117,116,116,111,110,32,49,50,0] /* P5 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str687=allocate([80,53,95,66,85,84,84,79,78,49,51,0] /* P5_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str688=allocate([80,53,32,66,117,116,116,111,110,32,49,51,0] /* P5 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str689=allocate([80,53,95,66,85,84,84,79,78,49,52,0] /* P5_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str690=allocate([80,53,32,66,117,116,116,111,110,32,49,52,0] /* P5 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str691=allocate([80,53,95,66,85,84,84,79,78,49,53,0] /* P5_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str692=allocate([80,53,32,66,117,116,116,111,110,32,49,53,0] /* P5 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str693=allocate([80,53,95,66,85,84,84,79,78,49,54,0] /* P5_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str694=allocate([80,53,32,66,117,116,116,111,110,32,49,54,0] /* P5 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str695=allocate([80,53,95,83,84,65,82,84,0] /* P5_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str696=allocate([80,53,32,83,116,97,114,116,0] /* P5 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str697=allocate([80,53,95,83,69,76,69,67,84,0] /* P5_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str698=allocate([80,53,32,83,101,108,101,99,116,0] /* P5 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str699=allocate([80,54,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P6_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str700=allocate([80,54,32,85,112,0] /* P6 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str701=allocate([80,54,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P6_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str702=allocate([80,54,32,68,111,119,110,0] /* P6 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str703=allocate([80,54,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P6_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str704=allocate([80,54,32,76,101,102,116,0] /* P6 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str705=allocate([80,54,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P6_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str706=allocate([80,54,32,82,105,103,104,116,0] /* P6 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str707=allocate([80,54,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P6_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str708=allocate([80,54,32,82,105,103,104,116,47,85,112,0] /* P6 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str709=allocate([80,54,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P6_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str710=allocate([80,54,32,82,105,103,104,116,47,68,111,119,110,0] /* P6 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str711=allocate([80,54,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P6_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str712=allocate([80,54,32,82,105,103,104,116,47,76,101,102,116,0] /* P6 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str713=allocate([80,54,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P6_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str714=allocate([80,54,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P6 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str715=allocate([80,54,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P6_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str716=allocate([80,54,32,76,101,102,116,47,85,112,0] /* P6 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str717=allocate([80,54,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P6_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str718415=allocate([80,54,32,76,101,102,116,47,68,111,119,110,0] /* P6 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str719=allocate([80,54,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P6_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str720=allocate([80,54,32,76,101,102,116,47,76,101,102,116,0] /* P6 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str721=allocate([80,54,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P6_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str722=allocate([80,54,32,76,101,102,116,47,82,105,103,104,116,0] /* P6 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str723=allocate([80,54,95,66,85,84,84,79,78,49,0] /* P6_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str724=allocate([80,54,32,66,117,116,116,111,110,32,49,0] /* P6 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str725=allocate([80,54,95,66,85,84,84,79,78,50,0] /* P6_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str726=allocate([80,54,32,66,117,116,116,111,110,32,50,0] /* P6 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str727=allocate([80,54,95,66,85,84,84,79,78,51,0] /* P6_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str728=allocate([80,54,32,66,117,116,116,111,110,32,51,0] /* P6 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str729=allocate([80,54,95,66,85,84,84,79,78,52,0] /* P6_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str730=allocate([80,54,32,66,117,116,116,111,110,32,52,0] /* P6 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str731=allocate([80,54,95,66,85,84,84,79,78,53,0] /* P6_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str732=allocate([80,54,32,66,117,116,116,111,110,32,53,0] /* P6 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str733=allocate([80,54,95,66,85,84,84,79,78,54,0] /* P6_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str734=allocate([80,54,32,66,117,116,116,111,110,32,54,0] /* P6 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str735=allocate([80,54,95,66,85,84,84,79,78,55,0] /* P6_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str736=allocate([80,54,32,66,117,116,116,111,110,32,55,0] /* P6 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str737=allocate([80,54,95,66,85,84,84,79,78,56,0] /* P6_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str738=allocate([80,54,32,66,117,116,116,111,110,32,56,0] /* P6 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str739=allocate([80,54,95,66,85,84,84,79,78,57,0] /* P6_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str740=allocate([80,54,32,66,117,116,116,111,110,32,57,0] /* P6 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str741=allocate([80,54,95,66,85,84,84,79,78,49,48,0] /* P6_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str742=allocate([80,54,32,66,117,116,116,111,110,32,49,48,0] /* P6 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str743=allocate([80,54,95,66,85,84,84,79,78,49,49,0] /* P6_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str744=allocate([80,54,32,66,117,116,116,111,110,32,49,49,0] /* P6 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str745=allocate([80,54,95,66,85,84,84,79,78,49,50,0] /* P6_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str746=allocate([80,54,32,66,117,116,116,111,110,32,49,50,0] /* P6 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str747=allocate([80,54,95,66,85,84,84,79,78,49,51,0] /* P6_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str748=allocate([80,54,32,66,117,116,116,111,110,32,49,51,0] /* P6 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str749=allocate([80,54,95,66,85,84,84,79,78,49,52,0] /* P6_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str750=allocate([80,54,32,66,117,116,116,111,110,32,49,52,0] /* P6 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str751=allocate([80,54,95,66,85,84,84,79,78,49,53,0] /* P6_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str752=allocate([80,54,32,66,117,116,116,111,110,32,49,53,0] /* P6 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str753=allocate([80,54,95,66,85,84,84,79,78,49,54,0] /* P6_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str754=allocate([80,54,32,66,117,116,116,111,110,32,49,54,0] /* P6 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str755=allocate([80,54,95,83,84,65,82,84,0] /* P6_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str756=allocate([80,54,32,83,116,97,114,116,0] /* P6 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str757=allocate([80,54,95,83,69,76,69,67,84,0] /* P6_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str758=allocate([80,54,32,83,101,108,101,99,116,0] /* P6 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str759=allocate([80,55,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P7_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str760=allocate([80,55,32,85,112,0] /* P7 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str761=allocate([80,55,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P7_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str762=allocate([80,55,32,68,111,119,110,0] /* P7 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str763=allocate([80,55,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P7_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str764=allocate([80,55,32,76,101,102,116,0] /* P7 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str765=allocate([80,55,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P7_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str766=allocate([80,55,32,82,105,103,104,116,0] /* P7 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str767=allocate([80,55,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P7_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str768=allocate([80,55,32,82,105,103,104,116,47,85,112,0] /* P7 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str769=allocate([80,55,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P7_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str770=allocate([80,55,32,82,105,103,104,116,47,68,111,119,110,0] /* P7 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str771=allocate([80,55,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P7_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str772=allocate([80,55,32,82,105,103,104,116,47,76,101,102,116,0] /* P7 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str773=allocate([80,55,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P7_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str774=allocate([80,55,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P7 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str775=allocate([80,55,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P7_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str776416=allocate([80,55,32,76,101,102,116,47,85,112,0] /* P7 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str777=allocate([80,55,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P7_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str778=allocate([80,55,32,76,101,102,116,47,68,111,119,110,0] /* P7 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str779=allocate([80,55,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P7_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str780=allocate([80,55,32,76,101,102,116,47,76,101,102,116,0] /* P7 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str781=allocate([80,55,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P7_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str782=allocate([80,55,32,76,101,102,116,47,82,105,103,104,116,0] /* P7 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str783=allocate([80,55,95,66,85,84,84,79,78,49,0] /* P7_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str784=allocate([80,55,32,66,117,116,116,111,110,32,49,0] /* P7 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str785=allocate([80,55,95,66,85,84,84,79,78,50,0] /* P7_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str786=allocate([80,55,32,66,117,116,116,111,110,32,50,0] /* P7 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str787=allocate([80,55,95,66,85,84,84,79,78,51,0] /* P7_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str788=allocate([80,55,32,66,117,116,116,111,110,32,51,0] /* P7 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str789=allocate([80,55,95,66,85,84,84,79,78,52,0] /* P7_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str790=allocate([80,55,32,66,117,116,116,111,110,32,52,0] /* P7 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str791=allocate([80,55,95,66,85,84,84,79,78,53,0] /* P7_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str792=allocate([80,55,32,66,117,116,116,111,110,32,53,0] /* P7 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str793=allocate([80,55,95,66,85,84,84,79,78,54,0] /* P7_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str794=allocate([80,55,32,66,117,116,116,111,110,32,54,0] /* P7 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str795=allocate([80,55,95,66,85,84,84,79,78,55,0] /* P7_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str796=allocate([80,55,32,66,117,116,116,111,110,32,55,0] /* P7 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str797=allocate([80,55,95,66,85,84,84,79,78,56,0] /* P7_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str798=allocate([80,55,32,66,117,116,116,111,110,32,56,0] /* P7 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str799=allocate([80,55,95,66,85,84,84,79,78,57,0] /* P7_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str800=allocate([80,55,32,66,117,116,116,111,110,32,57,0] /* P7 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str801=allocate([80,55,95,66,85,84,84,79,78,49,48,0] /* P7_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str802=allocate([80,55,32,66,117,116,116,111,110,32,49,48,0] /* P7 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str803=allocate([80,55,95,66,85,84,84,79,78,49,49,0] /* P7_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str804=allocate([80,55,32,66,117,116,116,111,110,32,49,49,0] /* P7 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str805=allocate([80,55,95,66,85,84,84,79,78,49,50,0] /* P7_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str806=allocate([80,55,32,66,117,116,116,111,110,32,49,50,0] /* P7 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str807=allocate([80,55,95,66,85,84,84,79,78,49,51,0] /* P7_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str808=allocate([80,55,32,66,117,116,116,111,110,32,49,51,0] /* P7 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str809=allocate([80,55,95,66,85,84,84,79,78,49,52,0] /* P7_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str810=allocate([80,55,32,66,117,116,116,111,110,32,49,52,0] /* P7 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str811=allocate([80,55,95,66,85,84,84,79,78,49,53,0] /* P7_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str812=allocate([80,55,32,66,117,116,116,111,110,32,49,53,0] /* P7 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str813=allocate([80,55,95,66,85,84,84,79,78,49,54,0] /* P7_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str814=allocate([80,55,32,66,117,116,116,111,110,32,49,54,0] /* P7 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str815=allocate([80,55,95,83,84,65,82,84,0] /* P7_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str816=allocate([80,55,32,83,116,97,114,116,0] /* P7 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str817=allocate([80,55,95,83,69,76,69,67,84,0] /* P7_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str818=allocate([80,55,32,83,101,108,101,99,116,0] /* P7 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str819417=allocate([80,56,95,74,79,89,83,84,73,67,75,95,85,80,0] /* P8_JOYSTICK_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str820=allocate([80,56,32,85,112,0] /* P8 Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str821=allocate([80,56,95,74,79,89,83,84,73,67,75,95,68,79,87,78,0] /* P8_JOYSTICK_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str822=allocate([80,56,32,68,111,119,110,0] /* P8 Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str823=allocate([80,56,95,74,79,89,83,84,73,67,75,95,76,69,70,84,0] /* P8_JOYSTICK_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str824=allocate([80,56,32,76,101,102,116,0] /* P8 Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str825=allocate([80,56,95,74,79,89,83,84,73,67,75,95,82,73,71,72,84,0] /* P8_JOYSTICK_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str826=allocate([80,56,32,82,105,103,104,116,0] /* P8 Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str827=allocate([80,56,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,85,80,0] /* P8_JOYSTICKRIGHT_UP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str828=allocate([80,56,32,82,105,103,104,116,47,85,112,0] /* P8 Right/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str829=allocate([80,56,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,68,79,87,78,0] /* P8_JOYSTICKRIGHT_DOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str830=allocate([80,56,32,82,105,103,104,116,47,68,111,119,110,0] /* P8 Right/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str831=allocate([80,56,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,76,69,70,84,0] /* P8_JOYSTICKRIGHT_LEF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str832=allocate([80,56,32,82,105,103,104,116,47,76,101,102,116,0] /* P8 Right/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str833=allocate([80,56,95,74,79,89,83,84,73,67,75,82,73,71,72,84,95,82,73,71,72,84,0] /* P8_JOYSTICKRIGHT_RIG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str834=allocate([80,56,32,82,105,103,104,116,47,82,105,103,104,116,0] /* P8 Right/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str835=allocate([80,56,95,74,79,89,83,84,73,67,75,76,69,70,84,95,85,80,0] /* P8_JOYSTICKLEFT_UP\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str836=allocate([80,56,32,76,101,102,116,47,85,112,0] /* P8 Left/Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str837=allocate([80,56,95,74,79,89,83,84,73,67,75,76,69,70,84,95,68,79,87,78,0] /* P8_JOYSTICKLEFT_DOWN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str838=allocate([80,56,32,76,101,102,116,47,68,111,119,110,0] /* P8 Left/Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str839=allocate([80,56,95,74,79,89,83,84,73,67,75,76,69,70,84,95,76,69,70,84,0] /* P8_JOYSTICKLEFT_LEFT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str840=allocate([80,56,32,76,101,102,116,47,76,101,102,116,0] /* P8 Left/Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str841=allocate([80,56,95,74,79,89,83,84,73,67,75,76,69,70,84,95,82,73,71,72,84,0] /* P8_JOYSTICKLEFT_RIGH */, "i8", ALLOC_STATIC);
STRING_TABLE.__str842=allocate([80,56,32,76,101,102,116,47,82,105,103,104,116,0] /* P8 Left/Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str843=allocate([80,56,95,66,85,84,84,79,78,49,0] /* P8_BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str844=allocate([80,56,32,66,117,116,116,111,110,32,49,0] /* P8 Button 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str845=allocate([80,56,95,66,85,84,84,79,78,50,0] /* P8_BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str846=allocate([80,56,32,66,117,116,116,111,110,32,50,0] /* P8 Button 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str847=allocate([80,56,95,66,85,84,84,79,78,51,0] /* P8_BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str848=allocate([80,56,32,66,117,116,116,111,110,32,51,0] /* P8 Button 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str849=allocate([80,56,95,66,85,84,84,79,78,52,0] /* P8_BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str850=allocate([80,56,32,66,117,116,116,111,110,32,52,0] /* P8 Button 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str851=allocate([80,56,95,66,85,84,84,79,78,53,0] /* P8_BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str852=allocate([80,56,32,66,117,116,116,111,110,32,53,0] /* P8 Button 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str853=allocate([80,56,95,66,85,84,84,79,78,54,0] /* P8_BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str854=allocate([80,56,32,66,117,116,116,111,110,32,54,0] /* P8 Button 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str855=allocate([80,56,95,66,85,84,84,79,78,55,0] /* P8_BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str856=allocate([80,56,32,66,117,116,116,111,110,32,55,0] /* P8 Button 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str857=allocate([80,56,95,66,85,84,84,79,78,56,0] /* P8_BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str858=allocate([80,56,32,66,117,116,116,111,110,32,56,0] /* P8 Button 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str859=allocate([80,56,95,66,85,84,84,79,78,57,0] /* P8_BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str860=allocate([80,56,32,66,117,116,116,111,110,32,57,0] /* P8 Button 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str861=allocate([80,56,95,66,85,84,84,79,78,49,48,0] /* P8_BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str862=allocate([80,56,32,66,117,116,116,111,110,32,49,48,0] /* P8 Button 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str863=allocate([80,56,95,66,85,84,84,79,78,49,49,0] /* P8_BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str864=allocate([80,56,32,66,117,116,116,111,110,32,49,49,0] /* P8 Button 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str865=allocate([80,56,95,66,85,84,84,79,78,49,50,0] /* P8_BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str866=allocate([80,56,32,66,117,116,116,111,110,32,49,50,0] /* P8 Button 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str867=allocate([80,56,95,66,85,84,84,79,78,49,51,0] /* P8_BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str868=allocate([80,56,32,66,117,116,116,111,110,32,49,51,0] /* P8 Button 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str869=allocate([80,56,95,66,85,84,84,79,78,49,52,0] /* P8_BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str870=allocate([80,56,32,66,117,116,116,111,110,32,49,52,0] /* P8 Button 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str871=allocate([80,56,95,66,85,84,84,79,78,49,53,0] /* P8_BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str872=allocate([80,56,32,66,117,116,116,111,110,32,49,53,0] /* P8 Button 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str873=allocate([80,56,95,66,85,84,84,79,78,49,54,0] /* P8_BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str874=allocate([80,56,32,66,117,116,116,111,110,32,49,54,0] /* P8 Button 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str875=allocate([80,56,95,83,84,65,82,84,0] /* P8_START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str876=allocate([80,56,32,83,116,97,114,116,0] /* P8 Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str877418=allocate([80,56,95,83,69,76,69,67,84,0] /* P8_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str878=allocate([80,56,32,83,101,108,101,99,116,0] /* P8 Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str879=allocate([83,84,65,82,84,49,0] /* START1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str880=allocate([49,32,80,108,97,121,101,114,32,83,116,97,114,116,0] /* 1 Player Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str881=allocate([83,84,65,82,84,50,0] /* START2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str882=allocate([50,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 2 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str883=allocate([83,84,65,82,84,51,0] /* START3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str884=allocate([51,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 3 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str885=allocate([83,84,65,82,84,52,0] /* START4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str886=allocate([52,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 4 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str887=allocate([83,84,65,82,84,53,0] /* START5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str888=allocate([53,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 5 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str889=allocate([83,84,65,82,84,54,0] /* START6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str890=allocate([54,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 6 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str891=allocate([83,84,65,82,84,55,0] /* START7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str892=allocate([55,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 7 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str893=allocate([83,84,65,82,84,56,0] /* START8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str894=allocate([56,32,80,108,97,121,101,114,115,32,83,116,97,114,116,0] /* 8 Players Start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str895=allocate([67,79,73,78,49,0] /* COIN1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str896=allocate([67,111,105,110,32,49,0] /* Coin 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str897=allocate([67,79,73,78,50,0] /* COIN2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str898=allocate([67,111,105,110,32,50,0] /* Coin 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str899=allocate([67,79,73,78,51,0] /* COIN3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str900=allocate([67,111,105,110,32,51,0] /* Coin 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str901=allocate([67,79,73,78,52,0] /* COIN4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str902=allocate([67,111,105,110,32,52,0] /* Coin 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str903=allocate([67,79,73,78,53,0] /* COIN5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str904=allocate([67,111,105,110,32,53,0] /* Coin 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str905=allocate([67,79,73,78,54,0] /* COIN6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str906=allocate([67,111,105,110,32,54,0] /* Coin 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str907=allocate([67,79,73,78,55,0] /* COIN7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str908=allocate([67,111,105,110,32,55,0] /* Coin 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str909=allocate([67,79,73,78,56,0] /* COIN8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str910=allocate([67,111,105,110,32,56,0] /* Coin 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str911=allocate([67,79,73,78,57,0] /* COIN9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str912=allocate([67,111,105,110,32,57,0] /* Coin 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str913=allocate([67,79,73,78,49,48,0] /* COIN10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str914=allocate([67,111,105,110,32,49,48,0] /* Coin 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str915=allocate([67,79,73,78,49,49,0] /* COIN11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str916=allocate([67,111,105,110,32,49,49,0] /* Coin 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str917=allocate([67,79,73,78,49,50,0] /* COIN12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str918=allocate([67,111,105,110,32,49,50,0] /* Coin 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str919=allocate([66,73,76,76,49,0] /* BILL1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str920419=allocate([66,105,108,108,32,49,0] /* Bill 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str921=allocate([83,69,82,86,73,67,69,49,0] /* SERVICE1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str922=allocate([83,101,114,118,105,99,101,32,49,0] /* Service 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str923=allocate([83,69,82,86,73,67,69,50,0] /* SERVICE2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str924=allocate([83,101,114,118,105,99,101,32,50,0] /* Service 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str925=allocate([83,69,82,86,73,67,69,51,0] /* SERVICE3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str926=allocate([83,101,114,118,105,99,101,32,51,0] /* Service 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str927=allocate([83,69,82,86,73,67,69,52,0] /* SERVICE4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str928=allocate([83,101,114,118,105,99,101,32,52,0] /* Service 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str929=allocate([84,73,76,84,49,0] /* TILT1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str930=allocate([84,105,108,116,32,49,0] /* Tilt 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str931=allocate([84,73,76,84,50,0] /* TILT2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str932=allocate([84,105,108,116,32,50,0] /* Tilt 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str933=allocate([84,73,76,84,51,0] /* TILT3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str934=allocate([84,105,108,116,32,51,0] /* Tilt 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str935=allocate([84,73,76,84,52,0] /* TILT4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str936=allocate([84,105,108,116,32,52,0] /* Tilt 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str937=allocate([83,69,82,86,73,67,69,0] /* SERVICE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str938=allocate([84,73,76,84,0] /* TILT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str939=allocate([84,105,108,116,0] /* Tilt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str940=allocate([73,78,84,69,82,76,79,67,75,0] /* INTERLOCK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str941=allocate([68,111,111,114,32,73,110,116,101,114,108,111,99,107,0] /* Door Interlock\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str942=allocate([86,79,76,85,77,69,95,68,79,87,78,0] /* VOLUME_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str943=allocate([86,111,108,117,109,101,32,68,111,119,110,0] /* Volume Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str944=allocate([86,79,76,85,77,69,95,85,80,0] /* VOLUME_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str945=allocate([86,111,108,117,109,101,32,85,112,0] /* Volume Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str946=allocate([80,49,95,80,69,68,65,76,0] /* P1_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str947=allocate([80,49,32,80,101,100,97,108,32,49,0] /* P1 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str948=allocate([80,50,95,80,69,68,65,76,0] /* P2_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str949=allocate([80,50,32,80,101,100,97,108,32,49,0] /* P2 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str950=allocate([80,51,95,80,69,68,65,76,0] /* P3_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str951=allocate([80,51,32,80,101,100,97,108,32,49,0] /* P3 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str952=allocate([80,52,95,80,69,68,65,76,0] /* P4_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str953=allocate([80,52,32,80,101,100,97,108,32,49,0] /* P4 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str954=allocate([80,53,95,80,69,68,65,76,0] /* P5_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str955=allocate([80,53,32,80,101,100,97,108,32,49,0] /* P5 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str956=allocate([80,54,95,80,69,68,65,76,0] /* P6_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str957=allocate([80,54,32,80,101,100,97,108,32,49,0] /* P6 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str958=allocate([80,55,95,80,69,68,65,76,0] /* P7_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str959=allocate([80,55,32,80,101,100,97,108,32,49,0] /* P7 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str960=allocate([80,56,95,80,69,68,65,76,0] /* P8_PEDAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str961=allocate([80,56,32,80,101,100,97,108,32,49,0] /* P8 Pedal 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str962=allocate([80,49,95,80,69,68,65,76,50,0] /* P1_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str963=allocate([80,49,32,80,101,100,97,108,32,50,0] /* P1 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str964=allocate([80,50,95,80,69,68,65,76,50,0] /* P2_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str965=allocate([80,50,32,80,101,100,97,108,32,50,0] /* P2 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str966=allocate([80,51,95,80,69,68,65,76,50,0] /* P3_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str967=allocate([80,51,32,80,101,100,97,108,32,50,0] /* P3 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str968=allocate([80,52,95,80,69,68,65,76,50,0] /* P4_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str969=allocate([80,52,32,80,101,100,97,108,32,50,0] /* P4 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str970=allocate([80,53,95,80,69,68,65,76,50,0] /* P5_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str971=allocate([80,53,32,80,101,100,97,108,32,50,0] /* P5 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str972=allocate([80,54,95,80,69,68,65,76,50,0] /* P6_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str973=allocate([80,54,32,80,101,100,97,108,32,50,0] /* P6 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str974=allocate([80,55,95,80,69,68,65,76,50,0] /* P7_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str975=allocate([80,55,32,80,101,100,97,108,32,50,0] /* P7 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str976=allocate([80,56,95,80,69,68,65,76,50,0] /* P8_PEDAL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str977=allocate([80,56,32,80,101,100,97,108,32,50,0] /* P8 Pedal 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str978420=allocate([80,49,95,80,69,68,65,76,51,0] /* P1_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str979=allocate([80,49,32,80,101,100,97,108,32,51,0] /* P1 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str980=allocate([80,50,95,80,69,68,65,76,51,0] /* P2_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str981=allocate([80,50,32,80,101,100,97,108,32,51,0] /* P2 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str982=allocate([80,51,95,80,69,68,65,76,51,0] /* P3_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str983=allocate([80,51,32,80,101,100,97,108,32,51,0] /* P3 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str984=allocate([80,52,95,80,69,68,65,76,51,0] /* P4_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str985=allocate([80,52,32,80,101,100,97,108,32,51,0] /* P4 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str986=allocate([80,53,95,80,69,68,65,76,51,0] /* P5_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str987=allocate([80,53,32,80,101,100,97,108,32,51,0] /* P5 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str988=allocate([80,54,95,80,69,68,65,76,51,0] /* P6_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str989=allocate([80,54,32,80,101,100,97,108,32,51,0] /* P6 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str990=allocate([80,55,95,80,69,68,65,76,51,0] /* P7_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str991=allocate([80,55,32,80,101,100,97,108,32,51,0] /* P7 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str992=allocate([80,56,95,80,69,68,65,76,51,0] /* P8_PEDAL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str993=allocate([80,56,32,80,101,100,97,108,32,51,0] /* P8 Pedal 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str994=allocate([80,49,95,80,65,68,68,76,69,0] /* P1_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str995=allocate([80,97,100,100,108,101,0] /* Paddle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str996=allocate([80,50,95,80,65,68,68,76,69,0] /* P2_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str997=allocate([80,97,100,100,108,101,32,50,0] /* Paddle 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str998=allocate([80,51,95,80,65,68,68,76,69,0] /* P3_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str999=allocate([80,97,100,100,108,101,32,51,0] /* Paddle 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1000=allocate([80,52,95,80,65,68,68,76,69,0] /* P4_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1001=allocate([80,97,100,100,108,101,32,52,0] /* Paddle 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1002=allocate([80,53,95,80,65,68,68,76,69,0] /* P5_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1003=allocate([80,97,100,100,108,101,32,53,0] /* Paddle 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1004=allocate([80,54,95,80,65,68,68,76,69,0] /* P6_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1005=allocate([80,97,100,100,108,101,32,54,0] /* Paddle 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1006=allocate([80,55,95,80,65,68,68,76,69,0] /* P7_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1007=allocate([80,97,100,100,108,101,32,55,0] /* Paddle 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1008=allocate([80,56,95,80,65,68,68,76,69,0] /* P8_PADDLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1009=allocate([80,97,100,100,108,101,32,56,0] /* Paddle 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1010=allocate([80,49,95,80,65,68,68,76,69,95,86,0] /* P1_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1011=allocate([80,97,100,100,108,101,32,86,0] /* Paddle V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1012=allocate([80,50,95,80,65,68,68,76,69,95,86,0] /* P2_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1013=allocate([80,97,100,100,108,101,32,86,32,50,0] /* Paddle V 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1014=allocate([80,51,95,80,65,68,68,76,69,95,86,0] /* P3_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1015=allocate([80,97,100,100,108,101,32,86,32,51,0] /* Paddle V 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1016=allocate([80,52,95,80,65,68,68,76,69,95,86,0] /* P4_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1017=allocate([80,97,100,100,108,101,32,86,32,52,0] /* Paddle V 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1018=allocate([80,53,95,80,65,68,68,76,69,95,86,0] /* P5_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1019=allocate([80,97,100,100,108,101,32,86,32,53,0] /* Paddle V 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1020=allocate([80,54,95,80,65,68,68,76,69,95,86,0] /* P6_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1021421=allocate([80,97,100,100,108,101,32,86,32,54,0] /* Paddle V 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1022=allocate([80,55,95,80,65,68,68,76,69,95,86,0] /* P7_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1023=allocate([80,97,100,100,108,101,32,86,32,55,0] /* Paddle V 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1024=allocate([80,56,95,80,65,68,68,76,69,95,86,0] /* P8_PADDLE_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1025=allocate([80,97,100,100,108,101,32,86,32,56,0] /* Paddle V 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1026=allocate([80,49,95,80,79,83,73,84,73,79,78,65,76,0] /* P1_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1027=allocate([80,111,115,105,116,105,111,110,97,108,0] /* Positional\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1028=allocate([80,50,95,80,79,83,73,84,73,79,78,65,76,0] /* P2_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1029=allocate([80,111,115,105,116,105,111,110,97,108,32,50,0] /* Positional 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1030=allocate([80,51,95,80,79,83,73,84,73,79,78,65,76,0] /* P3_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1031=allocate([80,111,115,105,116,105,111,110,97,108,32,51,0] /* Positional 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1032=allocate([80,52,95,80,79,83,73,84,73,79,78,65,76,0] /* P4_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1033=allocate([80,111,115,105,116,105,111,110,97,108,32,52,0] /* Positional 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1034=allocate([80,53,95,80,79,83,73,84,73,79,78,65,76,0] /* P5_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1035=allocate([80,111,115,105,116,105,111,110,97,108,32,53,0] /* Positional 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1036=allocate([80,54,95,80,79,83,73,84,73,79,78,65,76,0] /* P6_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1037=allocate([80,111,115,105,116,105,111,110,97,108,32,54,0] /* Positional 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1038=allocate([80,55,95,80,79,83,73,84,73,79,78,65,76,0] /* P7_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1039=allocate([80,111,115,105,116,105,111,110,97,108,32,55,0] /* Positional 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1040=allocate([80,56,95,80,79,83,73,84,73,79,78,65,76,0] /* P8_POSITIONAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1041=allocate([80,111,115,105,116,105,111,110,97,108,32,56,0] /* Positional 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1042=allocate([80,49,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P1_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1043=allocate([80,111,115,105,116,105,111,110,97,108,32,86,0] /* Positional V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1044=allocate([80,50,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P2_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1045=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,50,0] /* Positional V 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1046=allocate([80,51,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P3_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1047=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,51,0] /* Positional V 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1048=allocate([80,52,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P4_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1049=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,52,0] /* Positional V 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1050=allocate([80,53,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P5_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1051=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,53,0] /* Positional V 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1052=allocate([80,54,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P6_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1053=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,54,0] /* Positional V 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1054=allocate([80,55,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P7_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1055=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,55,0] /* Positional V 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1056=allocate([80,56,95,80,79,83,73,84,73,79,78,65,76,95,86,0] /* P8_POSITIONAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1057=allocate([80,111,115,105,116,105,111,110,97,108,32,86,32,56,0] /* Positional V 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1058=allocate([80,49,95,68,73,65,76,0] /* P1_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1059=allocate([68,105,97,108,0] /* Dial\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1060=allocate([80,50,95,68,73,65,76,0] /* P2_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1061=allocate([68,105,97,108,32,50,0] /* Dial 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1062=allocate([80,51,95,68,73,65,76,0] /* P3_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1063=allocate([68,105,97,108,32,51,0] /* Dial 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1064=allocate([80,52,95,68,73,65,76,0] /* P4_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1065=allocate([68,105,97,108,32,52,0] /* Dial 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1066=allocate([80,53,95,68,73,65,76,0] /* P5_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1067=allocate([68,105,97,108,32,53,0] /* Dial 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1068=allocate([80,54,95,68,73,65,76,0] /* P6_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1069=allocate([68,105,97,108,32,54,0] /* Dial 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1070=allocate([80,55,95,68,73,65,76,0] /* P7_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1071=allocate([68,105,97,108,32,55,0] /* Dial 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1072=allocate([80,56,95,68,73,65,76,0] /* P8_DIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1073=allocate([68,105,97,108,32,56,0] /* Dial 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1074=allocate([80,49,95,68,73,65,76,95,86,0] /* P1_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1075=allocate([68,105,97,108,32,86,0] /* Dial V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1076=allocate([80,50,95,68,73,65,76,95,86,0] /* P2_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1077=allocate([68,105,97,108,32,86,32,50,0] /* Dial V 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1078=allocate([80,51,95,68,73,65,76,95,86,0] /* P3_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1079422=allocate([68,105,97,108,32,86,32,51,0] /* Dial V 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1080=allocate([80,52,95,68,73,65,76,95,86,0] /* P4_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1081=allocate([68,105,97,108,32,86,32,52,0] /* Dial V 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1082=allocate([80,53,95,68,73,65,76,95,86,0] /* P5_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1083=allocate([68,105,97,108,32,86,32,53,0] /* Dial V 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1084=allocate([80,54,95,68,73,65,76,95,86,0] /* P6_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1085=allocate([68,105,97,108,32,86,32,54,0] /* Dial V 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1086=allocate([80,55,95,68,73,65,76,95,86,0] /* P7_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1087=allocate([68,105,97,108,32,86,32,55,0] /* Dial V 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1088=allocate([80,56,95,68,73,65,76,95,86,0] /* P8_DIAL_V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1089=allocate([68,105,97,108,32,86,32,56,0] /* Dial V 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1090=allocate([80,49,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P1_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1091=allocate([84,114,97,99,107,32,88,0] /* Track X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1092=allocate([80,50,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P2_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1093=allocate([84,114,97,99,107,32,88,32,50,0] /* Track X 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1094=allocate([80,51,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P3_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1095=allocate([84,114,97,99,107,32,88,32,51,0] /* Track X 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1096=allocate([80,52,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P4_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1097=allocate([84,114,97,99,107,32,88,32,52,0] /* Track X 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1098=allocate([80,53,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P5_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1099=allocate([84,114,97,99,107,32,88,32,53,0] /* Track X 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1100=allocate([80,54,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P6_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1101=allocate([84,114,97,99,107,32,88,32,54,0] /* Track X 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1102=allocate([80,55,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P7_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1103=allocate([84,114,97,99,107,32,88,32,55,0] /* Track X 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1104=allocate([80,56,95,84,82,65,67,75,66,65,76,76,95,88,0] /* P8_TRACKBALL_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1105=allocate([84,114,97,99,107,32,88,32,56,0] /* Track X 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1106=allocate([80,49,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P1_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1107=allocate([84,114,97,99,107,32,89,0] /* Track Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1108=allocate([80,50,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P2_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1109=allocate([84,114,97,99,107,32,89,32,50,0] /* Track Y 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1110=allocate([80,51,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P3_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1111=allocate([84,114,97,99,107,32,89,32,51,0] /* Track Y 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1112=allocate([80,52,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P4_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1113=allocate([84,114,97,99,107,32,89,32,52,0] /* Track Y 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1114=allocate([80,53,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P5_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1115=allocate([84,114,97,99,107,32,89,32,53,0] /* Track Y 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1116=allocate([80,54,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P6_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1117=allocate([84,114,97,99,107,32,89,32,54,0] /* Track Y 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1118=allocate([80,55,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P7_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1119=allocate([84,114,97,99,107,32,89,32,55,0] /* Track Y 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1120=allocate([80,56,95,84,82,65,67,75,66,65,76,76,95,89,0] /* P8_TRACKBALL_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1121=allocate([84,114,97,99,107,32,89,32,56,0] /* Track Y 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1122423=allocate([80,49,95,65,68,95,83,84,73,67,75,95,88,0] /* P1_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1123=allocate([65,68,32,83,116,105,99,107,32,88,0] /* AD Stick X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1124=allocate([80,50,95,65,68,95,83,84,73,67,75,95,88,0] /* P2_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1125=allocate([65,68,32,83,116,105,99,107,32,88,32,50,0] /* AD Stick X 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1126=allocate([80,51,95,65,68,95,83,84,73,67,75,95,88,0] /* P3_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1127=allocate([65,68,32,83,116,105,99,107,32,88,32,51,0] /* AD Stick X 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1128=allocate([80,52,95,65,68,95,83,84,73,67,75,95,88,0] /* P4_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1129=allocate([65,68,32,83,116,105,99,107,32,88,32,52,0] /* AD Stick X 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1130=allocate([80,53,95,65,68,95,83,84,73,67,75,95,88,0] /* P5_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1131=allocate([65,68,32,83,116,105,99,107,32,88,32,53,0] /* AD Stick X 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1132=allocate([80,54,95,65,68,95,83,84,73,67,75,95,88,0] /* P6_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1133=allocate([65,68,32,83,116,105,99,107,32,88,32,54,0] /* AD Stick X 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1134=allocate([80,55,95,65,68,95,83,84,73,67,75,95,88,0] /* P7_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1135=allocate([65,68,32,83,116,105,99,107,32,88,32,55,0] /* AD Stick X 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1136=allocate([80,56,95,65,68,95,83,84,73,67,75,95,88,0] /* P8_AD_STICK_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1137=allocate([65,68,32,83,116,105,99,107,32,88,32,56,0] /* AD Stick X 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1138=allocate([80,49,95,65,68,95,83,84,73,67,75,95,89,0] /* P1_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1139=allocate([65,68,32,83,116,105,99,107,32,89,0] /* AD Stick Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1140=allocate([80,50,95,65,68,95,83,84,73,67,75,95,89,0] /* P2_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1141=allocate([65,68,32,83,116,105,99,107,32,89,32,50,0] /* AD Stick Y 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1142=allocate([80,51,95,65,68,95,83,84,73,67,75,95,89,0] /* P3_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1143=allocate([65,68,32,83,116,105,99,107,32,89,32,51,0] /* AD Stick Y 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1144=allocate([80,52,95,65,68,95,83,84,73,67,75,95,89,0] /* P4_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1145=allocate([65,68,32,83,116,105,99,107,32,89,32,52,0] /* AD Stick Y 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1146=allocate([80,53,95,65,68,95,83,84,73,67,75,95,89,0] /* P5_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1147=allocate([65,68,32,83,116,105,99,107,32,89,32,53,0] /* AD Stick Y 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1148424=allocate([80,54,95,65,68,95,83,84,73,67,75,95,89,0] /* P6_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1149=allocate([65,68,32,83,116,105,99,107,32,89,32,54,0] /* AD Stick Y 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1150=allocate([80,55,95,65,68,95,83,84,73,67,75,95,89,0] /* P7_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1151=allocate([65,68,32,83,116,105,99,107,32,89,32,55,0] /* AD Stick Y 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1152=allocate([80,56,95,65,68,95,83,84,73,67,75,95,89,0] /* P8_AD_STICK_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1153=allocate([65,68,32,83,116,105,99,107,32,89,32,56,0] /* AD Stick Y 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1154=allocate([80,49,95,65,68,95,83,84,73,67,75,95,90,0] /* P1_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1155=allocate([65,68,32,83,116,105,99,107,32,90,0] /* AD Stick Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1156=allocate([80,50,95,65,68,95,83,84,73,67,75,95,90,0] /* P2_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1157=allocate([65,68,32,83,116,105,99,107,32,90,32,50,0] /* AD Stick Z 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1158=allocate([80,51,95,65,68,95,83,84,73,67,75,95,90,0] /* P3_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1159425=allocate([65,68,32,83,116,105,99,107,32,90,32,51,0] /* AD Stick Z 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1160=allocate([80,52,95,65,68,95,83,84,73,67,75,95,90,0] /* P4_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1161=allocate([65,68,32,83,116,105,99,107,32,90,32,52,0] /* AD Stick Z 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1162=allocate([80,53,95,65,68,95,83,84,73,67,75,95,90,0] /* P5_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1163=allocate([65,68,32,83,116,105,99,107,32,90,32,53,0] /* AD Stick Z 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1164=allocate([80,54,95,65,68,95,83,84,73,67,75,95,90,0] /* P6_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1165=allocate([65,68,32,83,116,105,99,107,32,90,32,54,0] /* AD Stick Z 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1166=allocate([80,55,95,65,68,95,83,84,73,67,75,95,90,0] /* P7_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1167=allocate([65,68,32,83,116,105,99,107,32,90,32,55,0] /* AD Stick Z 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1168=allocate([80,56,95,65,68,95,83,84,73,67,75,95,90,0] /* P8_AD_STICK_Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1169=allocate([65,68,32,83,116,105,99,107,32,90,32,56,0] /* AD Stick Z 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1170=allocate([80,49,95,76,73,71,72,84,71,85,78,95,88,0] /* P1_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1171=allocate([76,105,103,104,116,103,117,110,32,88,0] /* Lightgun X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1172=allocate([80,50,95,76,73,71,72,84,71,85,78,95,88,0] /* P2_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1173=allocate([76,105,103,104,116,103,117,110,32,88,32,50,0] /* Lightgun X 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1174=allocate([80,51,95,76,73,71,72,84,71,85,78,95,88,0] /* P3_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1175=allocate([76,105,103,104,116,103,117,110,32,88,32,51,0] /* Lightgun X 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1176=allocate([80,52,95,76,73,71,72,84,71,85,78,95,88,0] /* P4_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1177=allocate([76,105,103,104,116,103,117,110,32,88,32,52,0] /* Lightgun X 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1178=allocate([80,53,95,76,73,71,72,84,71,85,78,95,88,0] /* P5_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1179=allocate([76,105,103,104,116,103,117,110,32,88,32,53,0] /* Lightgun X 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1180426=allocate([80,54,95,76,73,71,72,84,71,85,78,95,88,0] /* P6_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1181=allocate([76,105,103,104,116,103,117,110,32,88,32,54,0] /* Lightgun X 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1182=allocate([80,55,95,76,73,71,72,84,71,85,78,95,88,0] /* P7_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1183=allocate([76,105,103,104,116,103,117,110,32,88,32,55,0] /* Lightgun X 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1184=allocate([80,56,95,76,73,71,72,84,71,85,78,95,88,0] /* P8_LIGHTGUN_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1185=allocate([76,105,103,104,116,103,117,110,32,88,32,56,0] /* Lightgun X 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1186=allocate([80,49,95,76,73,71,72,84,71,85,78,95,89,0] /* P1_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1187=allocate([76,105,103,104,116,103,117,110,32,89,0] /* Lightgun Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1188=allocate([80,50,95,76,73,71,72,84,71,85,78,95,89,0] /* P2_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1189=allocate([76,105,103,104,116,103,117,110,32,89,32,50,0] /* Lightgun Y 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1190=allocate([80,51,95,76,73,71,72,84,71,85,78,95,89,0] /* P3_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1191=allocate([76,105,103,104,116,103,117,110,32,89,32,51,0] /* Lightgun Y 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1192=allocate([80,52,95,76,73,71,72,84,71,85,78,95,89,0] /* P4_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1193=allocate([76,105,103,104,116,103,117,110,32,89,32,52,0] /* Lightgun Y 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1194=allocate([80,53,95,76,73,71,72,84,71,85,78,95,89,0] /* P5_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1195=allocate([76,105,103,104,116,103,117,110,32,89,32,53,0] /* Lightgun Y 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1196=allocate([80,54,95,76,73,71,72,84,71,85,78,95,89,0] /* P6_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1197=allocate([76,105,103,104,116,103,117,110,32,89,32,54,0] /* Lightgun Y 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1198=allocate([80,55,95,76,73,71,72,84,71,85,78,95,89,0] /* P7_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1199=allocate([76,105,103,104,116,103,117,110,32,89,32,55,0] /* Lightgun Y 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1200=allocate([80,56,95,76,73,71,72,84,71,85,78,95,89,0] /* P8_LIGHTGUN_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1201=allocate([76,105,103,104,116,103,117,110,32,89,32,56,0] /* Lightgun Y 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1202=allocate([80,49,95,77,79,85,83,69,95,88,0] /* P1_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1203=allocate([77,111,117,115,101,32,88,0] /* Mouse X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1204=allocate([80,50,95,77,79,85,83,69,95,88,0] /* P2_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1205=allocate([77,111,117,115,101,32,88,32,50,0] /* Mouse X 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1206=allocate([80,51,95,77,79,85,83,69,95,88,0] /* P3_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1207=allocate([77,111,117,115,101,32,88,32,51,0] /* Mouse X 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1208=allocate([80,52,95,77,79,85,83,69,95,88,0] /* P4_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1209=allocate([77,111,117,115,101,32,88,32,52,0] /* Mouse X 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1210=allocate([80,53,95,77,79,85,83,69,95,88,0] /* P5_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1211=allocate([77,111,117,115,101,32,88,32,53,0] /* Mouse X 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1212=allocate([80,54,95,77,79,85,83,69,95,88,0] /* P6_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1213=allocate([77,111,117,115,101,32,88,32,54,0] /* Mouse X 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1214=allocate([80,55,95,77,79,85,83,69,95,88,0] /* P7_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1215=allocate([77,111,117,115,101,32,88,32,55,0] /* Mouse X 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1216=allocate([80,56,95,77,79,85,83,69,95,88,0] /* P8_MOUSE_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1217=allocate([77,111,117,115,101,32,88,32,56,0] /* Mouse X 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1218=allocate([80,49,95,77,79,85,83,69,95,89,0] /* P1_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1219=allocate([77,111,117,115,101,32,89,0] /* Mouse Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1220=allocate([80,50,95,77,79,85,83,69,95,89,0] /* P2_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1221=allocate([77,111,117,115,101,32,89,32,50,0] /* Mouse Y 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1222=allocate([80,51,95,77,79,85,83,69,95,89,0] /* P3_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1223=allocate([77,111,117,115,101,32,89,32,51,0] /* Mouse Y 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1224=allocate([80,52,95,77,79,85,83,69,95,89,0] /* P4_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1225=allocate([77,111,117,115,101,32,89,32,52,0] /* Mouse Y 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1226=allocate([80,53,95,77,79,85,83,69,95,89,0] /* P5_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1227=allocate([77,111,117,115,101,32,89,32,53,0] /* Mouse Y 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1228=allocate([80,54,95,77,79,85,83,69,95,89,0] /* P6_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1229=allocate([77,111,117,115,101,32,89,32,54,0] /* Mouse Y 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1230=allocate([80,55,95,77,79,85,83,69,95,89,0] /* P7_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1231=allocate([77,111,117,115,101,32,89,32,55,0] /* Mouse Y 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1232=allocate([80,56,95,77,79,85,83,69,95,89,0] /* P8_MOUSE_Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1233=allocate([77,111,117,115,101,32,89,32,56,0] /* Mouse Y 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1234427=allocate([75,69,89,80,65,68,0] /* KEYPAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1235=allocate([75,101,121,112,97,100,0] /* Keypad\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1236=allocate([75,69,89,66,79,65,82,68,0] /* KEYBOARD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1237=allocate([75,101,121,98,111,97,114,100,0] /* Keyboard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1238=allocate([85,73,95,79,78,95,83,67,82,69,69,78,95,68,73,83,80,76,65,89,0] /* UI_ON_SCREEN_DISPLAY */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1239=allocate([79,110,32,83,99,114,101,101,110,32,68,105,115,112,108,97,121,0] /* On Screen Display\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1240=allocate([85,73,95,68,69,66,85,71,95,66,82,69,65,75,0] /* UI_DEBUG_BREAK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1241=allocate([66,114,101,97,107,32,105,110,32,68,101,98,117,103,103,101,114,0] /* Break in Debugger\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1242=allocate([85,73,95,67,79,78,70,73,71,85,82,69,0] /* UI_CONFIGURE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1243=allocate([67,111,110,102,105,103,32,77,101,110,117,0] /* Config Menu\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1244=allocate([85,73,95,80,65,85,83,69,0] /* UI_PAUSE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1245=allocate([85,73,95,82,69,83,69,84,95,77,65,67,72,73,78,69,0] /* UI_RESET_MACHINE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1246=allocate([82,101,115,101,116,32,71,97,109,101,0] /* Reset Game\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1247=allocate([85,73,95,83,79,70,84,95,82,69,83,69,84,0] /* UI_SOFT_RESET\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1248=allocate([83,111,102,116,32,82,101,115,101,116,0] /* Soft Reset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1249=allocate([85,73,95,83,72,79,87,95,71,70,88,0] /* UI_SHOW_GFX\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1250=allocate([83,104,111,119,32,71,102,120,0] /* Show Gfx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1251=allocate([85,73,95,70,82,65,77,69,83,75,73,80,95,68,69,67,0] /* UI_FRAMESKIP_DEC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1252=allocate([70,114,97,109,101,115,107,105,112,32,68,101,99,0] /* Frameskip Dec\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1253=allocate([85,73,95,70,82,65,77,69,83,75,73,80,95,73,78,67,0] /* UI_FRAMESKIP_INC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1254=allocate([70,114,97,109,101,115,107,105,112,32,73,110,99,0] /* Frameskip Inc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1255=allocate([85,73,95,84,72,82,79,84,84,76,69,0] /* UI_THROTTLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1256=allocate([84,104,114,111,116,116,108,101,0] /* Throttle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1257=allocate([85,73,95,70,65,83,84,95,70,79,82,87,65,82,68,0] /* UI_FAST_FORWARD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1258=allocate([70,97,115,116,32,70,111,114,119,97,114,100,0] /* Fast Forward\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1259=allocate([85,73,95,83,72,79,87,95,70,80,83,0] /* UI_SHOW_FPS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1260=allocate([83,104,111,119,32,70,80,83,0] /* Show FPS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1261=allocate([85,73,95,83,78,65,80,83,72,79,84,0] /* UI_SNAPSHOT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1262=allocate([83,97,118,101,32,83,110,97,112,115,104,111,116,0] /* Save Snapshot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1263=allocate([85,73,95,82,69,67,79,82,68,95,77,79,86,73,69,0] /* UI_RECORD_MOVIE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1264=allocate([82,101,99,111,114,100,32,77,111,118,105,101,0] /* Record Movie\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1265=allocate([85,73,95,84,79,71,71,76,69,95,67,72,69,65,84,0] /* UI_TOGGLE_CHEAT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1266=allocate([84,111,103,103,108,101,32,67,104,101,97,116,0] /* Toggle Cheat\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1267=allocate([85,73,95,85,80,0] /* UI_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1268=allocate([85,73,32,85,112,0] /* UI Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1269=allocate([85,73,95,68,79,87,78,0] /* UI_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1270=allocate([85,73,32,68,111,119,110,0] /* UI Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1271=allocate([85,73,95,76,69,70,84,0] /* UI_LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1272=allocate([85,73,32,76,101,102,116,0] /* UI Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1273=allocate([85,73,95,82,73,71,72,84,0] /* UI_RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1274=allocate([85,73,32,82,105,103,104,116,0] /* UI Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1275=allocate([85,73,95,72,79,77,69,0] /* UI_HOME\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1276=allocate([85,73,32,72,111,109,101,0] /* UI Home\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1277=allocate([85,73,95,69,78,68,0] /* UI_END\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1278=allocate([85,73,32,69,110,100,0] /* UI End\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1279=allocate([85,73,95,80,65,71,69,95,85,80,0] /* UI_PAGE_UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1280=allocate([85,73,32,80,97,103,101,32,85,112,0] /* UI Page Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1281428=allocate([85,73,95,80,65,71,69,95,68,79,87,78,0] /* UI_PAGE_DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1282=allocate([85,73,32,80,97,103,101,32,68,111,119,110,0] /* UI Page Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1283=allocate([85,73,95,83,69,76,69,67,84,0] /* UI_SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1284=allocate([85,73,32,83,101,108,101,99,116,0] /* UI Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1285=allocate([85,73,95,67,65,78,67,69,76,0] /* UI_CANCEL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1286=allocate([85,73,32,67,97,110,99,101,108,0] /* UI Cancel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1287=allocate([85,73,95,68,73,83,80,76,65,89,95,67,79,77,77,69,78,84,0] /* UI_DISPLAY_COMMENT\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1288=allocate([85,73,32,68,105,115,112,108,97,121,32,67,111,109,109,101,110,116,0] /* UI Display Comment\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1289=allocate([85,73,95,67,76,69,65,82,0] /* UI_CLEAR\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1290=allocate([85,73,32,67,108,101,97,114,0] /* UI Clear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1291=allocate([85,73,95,90,79,79,77,95,73,78,0] /* UI_ZOOM_IN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1292=allocate([85,73,32,90,111,111,109,32,73,110,0] /* UI Zoom In\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1293=allocate([85,73,95,90,79,79,77,95,79,85,84,0] /* UI_ZOOM_OUT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1294=allocate([85,73,32,90,111,111,109,32,79,117,116,0] /* UI Zoom Out\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1295=allocate([85,73,95,80,82,69,86,95,71,82,79,85,80,0] /* UI_PREV_GROUP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1296=allocate([85,73,32,80,114,101,118,105,111,117,115,32,71,114,111,117,112,0] /* UI Previous Group\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1297=allocate([85,73,95,78,69,88,84,95,71,82,79,85,80,0] /* UI_NEXT_GROUP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1298=allocate([85,73,32,78,101,120,116,32,71,114,111,117,112,0] /* UI Next Group\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1299=allocate([85,73,95,82,79,84,65,84,69,0] /* UI_ROTATE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1300=allocate([85,73,32,82,111,116,97,116,101,0] /* UI Rotate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1301=allocate([85,73,95,83,72,79,87,95,80,82,79,70,73,76,69,82,0] /* UI_SHOW_PROFILER\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1302=allocate([83,104,111,119,32,80,114,111,102,105,108,101,114,0] /* Show Profiler\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1303=allocate([85,73,95,84,79,71,71,76,69,95,85,73,0] /* UI_TOGGLE_UI\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1304=allocate([85,73,32,84,111,103,103,108,101,0] /* UI Toggle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1305=allocate([85,73,95,80,65,83,84,69,0] /* UI_PASTE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1306=allocate([85,73,32,80,97,115,116,101,32,84,101,120,116,0] /* UI Paste Text\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1307=allocate([85,73,95,84,79,71,71,76,69,95,68,69,66,85,71,0] /* UI_TOGGLE_DEBUG\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1308429=allocate([84,111,103,103,108,101,32,68,101,98,117,103,103,101,114,0] /* Toggle Debugger\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1309=allocate([85,73,95,83,65,86,69,95,83,84,65,84,69,0] /* UI_SAVE_STATE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1310=allocate([83,97,118,101,32,83,116,97,116,101,0] /* Save State\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1311=allocate([85,73,95,76,79,65,68,95,83,84,65,84,69,0] /* UI_LOAD_STATE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1312=allocate([76,111,97,100,32,83,116,97,116,101,0] /* Load State\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1313=allocate([79,83,68,95,49,0] /* OSD_1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1314=allocate([79,83,68,95,50,0] /* OSD_2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1315=allocate([79,83,68,95,51,0] /* OSD_3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1316=allocate([79,83,68,95,52,0] /* OSD_4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1317=allocate([79,83,68,95,53,0] /* OSD_5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1318=allocate([79,83,68,95,54,0] /* OSD_6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1319=allocate([79,83,68,95,55,0] /* OSD_7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1320=allocate([79,83,68,95,56,0] /* OSD_8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1321=allocate([79,83,68,95,57,0] /* OSD_9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1322430=allocate([79,83,68,95,49,48,0] /* OSD_10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1323=allocate([79,83,68,95,49,49,0] /* OSD_11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1324=allocate([79,83,68,95,49,50,0] /* OSD_12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1325=allocate([79,83,68,95,49,51,0] /* OSD_13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1326=allocate([79,83,68,95,49,52,0] /* OSD_14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1327=allocate([79,83,68,95,49,53,0] /* OSD_15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1328=allocate([79,83,68,95,49,54,0] /* OSD_16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1329=allocate([85,78,75,78,79,87,78,0] /* UNKNOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1330=allocate([85,78,85,83,69,68,0] /* UNUSED\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1331=allocate([83,80,69,67,73,65,76,0] /* SPECIAL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1332=allocate([79,84,72,69,82,0] /* OTHER\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1333=allocate([65,68,74,85,83,84,69,82,0] /* ADJUSTER\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1334=allocate([68,73,80,83,87,73,84,67,72,0] /* DIPSWITCH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1335=allocate([67,79,78,70,73,71,0] /* CONFIG\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1336=allocate([67,65,84,69,71,79,82,89,0] /* CATEGORY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1337=allocate([115,114,99,47,101,109,117,47,105,110,112,116,112,111,114,116,46,99,0] /* src/emu/inptport.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1338=allocate([105,110,112,117,116,95,112,111,114,116,95,101,120,105,116,0] /* input_port_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1339=allocate([102,114,97,109,101,95,117,112,100,97,116,101,95,99,97,108,108,98,97,99,107,0] /* frame_update_callbac */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1340=allocate([73,110,112,117,116,32,112,111,114,116,32,101,114,114,111,114,115,58,10,37,115,0] /* Input port errors:\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1341=allocate([105,110,112,117,116,0] /* input\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1342=allocate([108,111,97,100,95,99,111,110,102,105,103,95,99,97,108,108,98,97,99,107,0] /* load_config_callback */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1343=allocate([115,97,118,101,95,99,111,110,102,105,103,95,99,97,108,108,98,97,99,107,0] /* save_config_callback */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1344=allocate([73,78,86,65,76,73,68,0] /* INVALID\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1345=allocate([63,63,63,0] /* ???\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1346=allocate([85,110,97,98,108,101,32,116,111,32,108,111,99,97,116,101,32,105,110,112,117,116,32,112,111,114,116,32,39,37,115,39,0] /* Unable to locate inp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1347=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1348=allocate([73,110,112,117,116,32,112,111,114,116,115,32,99,97,110,110,111,116,32,98,101,32,114,101,97,100,32,97,116,32,105,110,105,116,32,116,105,109,101,33,0] /* Input ports cannot b */, "i8", ALLOC_STATIC);
__ZL26input_port_default_strings=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 33, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 0, 0, 53, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 57, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 61, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 0, 0, 0, 0, 71, 0, 0, 0, 0, 0, 0, 0, 72, 0, 0, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0, 0, 0, 0, 76, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 0, 0, 78, 0, 0, 0, 0, 0, 0, 0, 79, 0, 0, 0, 0, 0, 0, 0, 80, 0, 0, 0, 0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 0, 0, 0, 0, 85, 0, 0, 0, 0, 0, 0, 0, 86, 0, 0, 0, 0, 0, 0, 0, 87, 0, 0, 0, 0, 0, 0, 0, 88, 0, 0, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 0, 0, 90, 0, 0, 0, 0, 0, 0, 0, 91, 0, 0, 0, 0, 0, 0, 0, 92, 0, 0, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 0, 0, 94, 0, 0, 0, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 0, 0, 99, 0, 0, 0, 0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 102, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 0, 0, 106, 0, 0, 0, 0, 0, 0, 0, 107, 0, 0, 0, 0, 0, 0, 0, 108, 0, 0, 0, 0, 0, 0, 0, 109, 0, 0, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 113, 0, 0, 0, 0, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 115, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1349=allocate([40,85,110,107,110,111,119,110,32,68,101,102,97,117,108,116,41,0] /* (Unknown Default)\00 */, "i8", ALLOC_STATIC);
__ZL11DEVICE_SELF431=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str1350=allocate([73,78,80,85,84,95,84,79,75,69,78,95,70,73,69,76,68,32,115,112,101,99,105,102,105,101,115,32,100,117,112,108,105,99,97,116,101,32,112,111,114,116,32,98,105,116,115,32,40,112,111,114,116,61,37,115,32,109,97,115,107,61,37,88,41,10,0] /* INPUT_TOKEN_FIELD sp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1356=allocate([105,110,112,117,116,120,58,32,99,104,97,114,105,110,102,111,32,105,115,32,111,117,116,32,111,102,32,111,114,100,101,114,59,32,48,120,37,48,56,120,32,115,104,111,117,108,100,32,98,101,32,104,105,103,104,101,114,32,116,104,97,110,32,48,120,37,48,56,120,10,0] /* inputx: charinfo is  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1357=allocate([105,110,112,117,116,120,58,32,101,120,112,101,99,116,101,100,32,102,105,110,100,95,99,104,97,114,105,110,102,111,40,48,120,37,48,56,120,41,32,116,111,32,119,111,114,107,32,112,114,111,112,101,114,108,121,10,0] /* inputx: expected fin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1358=allocate([100,117,109,112,107,98,100,0] /* dumpkbd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1360=allocate([73,78,80,85,84,95,84,79,75,69,78,95,70,73,69,76,68,32,101,110,99,111,117,110,116,101,114,101,100,32,119,105,116,104,32,110,111,32,97,99,116,105,118,101,32,112,111,114,116,32,40,109,97,115,107,61,37,88,32,100,101,102,118,97,108,61,37,88,41,10,0] /* INPUT_TOKEN_FIELD en */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI20input_setting_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5066, 0, 0, 0, 5068, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI20input_setting_configE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,48,105,110,112,117,116,95,115,101,116,116,105,110,103,95,99,111,110,102,105,103,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI20input_setting_configE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI18input_field_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5070, 0, 0, 0, 5072, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18input_field_configE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,105,110,112,117,116,95,102,105,101,108,100,95,99,111,110,102,105,103,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18input_field_configE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI17input_port_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5074, 0, 0, 0, 5076, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17input_port_configE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,105,110,112,117,116,95,112,111,114,116,95,99,111,110,102,105,103,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17input_port_configE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1361=allocate([69,114,114,111,114,32,97,100,100,105,110,103,32,111,98,106,101,99,116,32,110,97,109,101,100,32,39,37,115,39,0] /* Error adding object  */, "i8", ALLOC_STATIC);
__ZTV11simple_listI23input_field_diplocationE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5078, 0, 0, 0, 5080, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI23input_field_diplocationE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,50,51,105,110,112,117,116,95,102,105,101,108,100,95,100,105,112,108,111,99,97,116,105,111,110,69,0] /* 11simple_listI23inpu */, "i8", ALLOC_STATIC);
__ZTI11simple_listI23input_field_diplocationE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI20input_setting_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5082, 0, 0, 0, 5084, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI20input_setting_configE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,50,48,105,110,112,117,116,95,115,101,116,116,105,110,103,95,99,111,110,102,105,103,69,0] /* 11simple_listI20inpu */, "i8", ALLOC_STATIC);
__ZTI11simple_listI20input_setting_configE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI18input_field_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5086, 0, 0, 0, 5088, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI18input_field_configE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,56,105,110,112,117,116,95,102,105,101,108,100,95,99,111,110,102,105,103,69,0] /* 11simple_listI18inpu */, "i8", ALLOC_STATIC);
__ZTI11simple_listI18input_field_configE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI19_input_port_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5090, 0, 0, 0, 5092, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI19_input_port_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,57,95,105,110,112,117,116,95,112,111,114,116,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI19_input_port_privateE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI16input_type_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5094, 0, 0, 0, 5096, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI16input_type_entryE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,54,105,110,112,117,116,95,116,121,112,101,95,101,110,116,114,121,69,0] /* 11simple_listI16inpu */, "i8", ALLOC_STATIC);
__ZTI11simple_listI16input_type_entryE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI16input_type_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5098, 0, 0, 0, 5100, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16input_type_entryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,105,110,112,117,116,95,116,121,112,101,95,101,110,116,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16input_type_entryE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1362=allocate([67,97,110,110,111,116,32,111,112,101,110,32,34,37,115,34,10,0] /* Cannot open \22%s\22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1363=allocate([37,48,56,88,32,40,37,115,41,32,0] /* %08X (%s) \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1364=allocate([37,115,39,37,115,39,0] /* %s'%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1365=allocate([44,32,0] /* , \00 */, "i8", ALLOC_STATIC);
__str1366=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str1367=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1368=allocate([78,111,32,110,97,116,117,114,97,108,32,107,101,121,98,111,97,114,100,32,115,117,112,112,111,114,116,10,0] /* No natural keyboard  */, "i8", ALLOC_STATIC);
__ZZL17code_point_stringR15running_machinejE3buf=allocate(16, "i8", ALLOC_STATIC);
STRING_TABLE.__str1369=allocate([92,48,0] /* \5C0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1370=allocate([92,114,0] /* \5Cr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1371=allocate([92,110,0] /* \5Cn\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1372=allocate([92,116,0] /* \5Ct\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1373=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1374=allocate([85,43,37,48,52,88,0] /* U+%04X\00 */, "i8", ALLOC_STATIC);
__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes=allocate([0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 1048648, 0, 0, 0, 0, 0, 0, 0, 1048648, 0, 0, 0, 0, 0, 0, 0, 1048650, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 0, 0, 1048649, 0, 0, 0, 0, 0, 0, 0, 1048647, 0, 0, 0, 0, 0, 0, 0, 1048647, 0, 0, 0, 0, 0, 0, 0, 1048652, 0, 0, 0, 0, 0, 0, 0, 1048651, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 1048615, 0, 0, 0, 0, 0, 0, 0, 1048616, 0, 0, 0, 0, 0, 0, 0, 1048617, 0, 0, 0, 0, 0, 0, 0, 1048618, 0, 0, 0, 0, 0, 0, 0, 1048619, 0, 0, 0, 0, 0, 0, 0, 1048620, 0, 0, 0, 0, 0, 0, 0, 1048621, 0, 0, 0, 0, 0, 0, 0, 1048622, 0, 0, 0, 0, 0, 0, 0, 1048623, 0, 0, 0, 0, 0, 0, 0, 1048624, 0, 0, 0, 0, 0, 0, 0, 1048625, 0, 0, 0, 0, 0, 0, 0, 1048626, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0], ["*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1375=allocate([66,65,67,75,83,80,65,67,69,0] /* BACKSPACE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1376=allocate([66,83,0] /* BS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1377=allocate([66,75,83,80,0] /* BKSP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1378=allocate([68,69,76,0] /* DEL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1379=allocate([68,69,76,69,84,69,0] /* DELETE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1380=allocate([69,78,68,0] /* END\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1381=allocate([69,78,84,69,82,0] /* ENTER\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1382432=allocate([69,83,67,0] /* ESC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1383=allocate([72,79,77,69,0] /* HOME\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1384=allocate([73,78,83,0] /* INS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1385=allocate([73,78,83,69,82,84,0] /* INSERT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1386=allocate([80,71,68,78,0] /* PGDN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1387=allocate([80,71,85,80,0] /* PGUP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1388=allocate([83,80,65,67,69,0] /* SPACE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1389=allocate([84,65,66,0] /* TAB\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1390=allocate([81,85,79,84,69,0] /* QUOTE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1391=allocate([105,110,112,117,116,120,95,116,105,109,101,114,112,114,111,99,0] /* inputx_timerproc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1392=allocate([99,108,101,97,114,95,107,101,121,98,117,102,102,101,114,0] /* clear_keybuffer\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI11_key_bufferE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5102, 0, 0, 0, 5104, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11_key_bufferE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,95,107,101,121,95,98,117,102,102,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11_key_bufferE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayI12_inputx_codeE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5106, 0, 0, 0, 5108, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI12_inputx_codeE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,49,50,95,105,110,112,117,116,120,95,99,111,100,101,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI12_inputx_codeE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1393=allocate([70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,102,111,114,32,114,101,99,111,114,100,105,110,103,0] /* Failed to open file  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1394=allocate([77,65,77,69,73,78,80,0,0] /* MAMEINP\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1395=allocate([77,69,83,83,32,37,115,0] /* MESS %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1396=allocate([105,110,112,117,116,95,100,105,114,101,99,116,111,114,121,0] /* input_directory\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI8emu_fileE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5110, 0, 0, 0, 5112, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI8emu_fileE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,56,101,109,117,95,102,105,108,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI8emu_fileE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1397=allocate([114,101,99,111,114,100,0] /* record\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1398=allocate([70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,102,111,114,32,112,108,97,121,98,97,99,107,0] /* Failed to open file  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1399=allocate([73,110,112,117,116,32,102,105,108,101,32,105,115,32,99,111,114,114,117,112,116,32,111,114,32,105,110,118,97,108,105,100,32,40,109,105,115,115,105,110,103,32,104,101,97,100,101,114,41,0] /* Input file is corrup */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1400=allocate([73,110,112,117,116,32,102,105,108,101,32,105,110,118,97,108,105,100,32,111,114,32,105,110,32,97,110,32,111,108,100,101,114,44,32,117,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,0] /* Input file invalid o */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1401=allocate([73,110,112,117,116,32,102,105,108,101,32,102,111,114,109,97,116,32,118,101,114,115,105,111,110,32,109,105,115,109,97,116,99,104,0] /* Input file format ve */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1402=allocate([73,110,112,117,116,32,102,105,108,101,58,32,37,115,10,0] /* Input file: %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1403=allocate([73,78,80,32,118,101,114,115,105,111,110,32,37,100,46,37,100,10,0] /* INP version %d.%d\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1404=allocate([67,114,101,97,116,101,100,32,37,115,0] /* Created %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1405=allocate([82,101,99,111,114,100,101,100,32,117,115,105,110,103,32,37,115,10,0] /* Recorded using %s\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1406=allocate([73,110,112,117,116,32,102,105,108,101,32,105,115,32,102,111,114,32,115,121,115,116,101,109,32,39,37,115,39,44,32,110,111,116,32,102,111,114,32,99,117,114,114,101,110,116,32,115,121,115,116,101,109,32,39,37,115,39,10,0] /* Input file is for sy */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1407=allocate([112,108,97,121,98,97,99,107,0] /* playback\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1408=allocate([112,111,114,116,0] /* port\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1409=allocate([116,97,103,0] /* tag\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1410=allocate([116,121,112,101,0] /* type\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1411=allocate([109,97,115,107,0] /* mask\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1412=allocate([100,101,102,118,97,108,117,101,0] /* defvalue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1413=allocate([118,97,108,117,101,0] /* value\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1414=allocate([107,101,121,100,101,108,116,97,0] /* keydelta\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1415=allocate([99,101,110,116,101,114,100,101,108,116,97,0] /* centerdelta\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1416=allocate([115,101,110,115,105,116,105,118,105,116,121,0] /* sensitivity\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1417=allocate([114,101,118,101,114,115,101,0] /* reverse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1418=allocate([121,101,115,0] /* yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1419=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1420=allocate([78,79,78,69,0] /* NONE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1421=allocate([110,101,119,115,101,113,0] /* newseq\00 */, "i8", ALLOC_STATIC);
__ZL14seqtypestrings=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1422=allocate([115,116,97,110,100,97,114,100,0] /* standard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1423=allocate([100,101,99,114,101,109,101,110,116,0] /* decrement\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1424=allocate([105,110,99,114,101,109,101,110,116,0] /* increment\00 */, "i8", ALLOC_STATIC);
__ZZL25input_field_type_to_tokenR15running_machineiiE7tempbuf=allocate(32, "i8", ALLOC_STATIC);
STRING_TABLE.__str1425=allocate([84,89,80,69,95,79,84,72,69,82,40,37,100,44,37,100,41,0] /* TYPE_OTHER(%d,%d)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1426=allocate([114,101,109,97,112,0] /* remap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1427=allocate([111,114,105,103,99,111,100,101,0] /* origcode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1428=allocate([110,101,119,99,111,100,101,0] /* newcode\00 */, "i8", ALLOC_STATIC);
__ZTV19resource_pool_arrayI10input_codeE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5114, 0, 0, 0, 5116, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI10input_codeE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,49,48,105,110,112,117,116,95,99,111,100,101,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI10input_codeE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1429=allocate([79,117,116,32,111,102,32,115,112,97,99,101,0] /* Out of space\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1430=allocate([82,101,99,111,114,100,105,110,103,32,69,110,100,101,100,10,82,101,97,115,111,110,58,32,37,115,0] /* Recording Ended\0ARe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1431=allocate([69,110,100,32,111,102,32,102,105,108,101,0] /* End of file\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1432=allocate([80,108,97,121,98,97,99,107,32,69,110,100,101,100,10,82,101,97,115,111,110,58,32,37,115,0] /* Playback Ended\0ARea */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1433=allocate([84,111,116,97,108,32,112,108,97,121,98,97,99,107,32,102,114,97,109,101,115,58,32,37,100,10,0] /* Total playback frame */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1434=allocate([65,118,101,114,97,103,101,32,114,101,99,111,114,100,101,100,32,115,112,101,101,100,58,32,37,100,37,37,10,0] /* Average recorded spe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1435=allocate([67,111,105,110,108,111,99,107,32,100,105,115,97,98,108,101,100,32,37,115,46,0] /* Coinlock disabled %s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1436=allocate([99,111,105,110,95,108,111,99,107,111,117,116,0] /* coin_lockout\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1437=allocate([79,117,116,32,111,102,32,115,121,110,99,0] /* Out of sync\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1438=allocate([112,97,100,100,108,101,95,100,101,118,105,99,101,0] /* paddle_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1439=allocate([112,97,100,100,108,101,0] /* paddle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1440=allocate([97,100,115,116,105,99,107,95,100,101,118,105,99,101,0] /* adstick_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1441=allocate([97,110,97,108,111,103,32,106,111,121,115,116,105,99,107,0] /* analog joystick\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1442=allocate([108,105,103,104,116,103,117,110,95,100,101,118,105,99,101,0] /* lightgun_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1443=allocate([108,105,103,104,116,103,117,110,0] /* lightgun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1444=allocate([112,101,100,97,108,95,100,101,118,105,99,101,0] /* pedal_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1445=allocate([112,101,100,97,108,0] /* pedal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1446=allocate([100,105,97,108,95,100,101,118,105,99,101,0] /* dial_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1447=allocate([100,105,97,108,0] /* dial\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1448=allocate([116,114,97,99,107,98,97,108,108,95,100,101,118,105,99,101,0] /* trackball_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1449=allocate([116,114,97,99,107,98,97,108,108,0] /* trackball\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1450=allocate([112,111,115,105,116,105,111,110,97,108,95,100,101,118,105,99,101,0] /* positional_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1451=allocate([112,111,115,105,116,105,111,110,97,108,0] /* positional\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1452=allocate([109,111,117,115,101,95,100,101,118,105,99,101,0] /* mouse_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1453=allocate([109,111,117,115,101,0] /* mouse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1454=allocate([97,117,116,111,0] /* auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1455=allocate([107,101,121,98,111,97,114,100,0] /* keyboard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1456=allocate([106,111,121,115,116,105,99,107,0] /* joystick\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1457=allocate([110,111,110,101,0] /* none\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1458=allocate([73,110,118,97,108,105,100,32,37,115,32,118,97,108,117,101,32,37,115,59,32,114,101,118,101,114,116,105,110,103,32,116,111,32,107,101,121,98,111,97,114,100,10,0] /* Invalid %s value %s; */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1459=allocate([73,110,112,117,116,58,32,65,117,116,111,101,110,97,98,108,105,110,103,32,37,115,32,100,117,101,32,116,111,32,112,114,101,115,101,110,99,101,32,111,102,32,97,32,37,115,10,0] /* Input: Autoenabling  */, "i8", ALLOC_STATIC);
__ZTV19resource_pool_arrayIcE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5118, 0, 0, 0, 5120, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIcE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,99,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIcE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1460=allocate([37,115,37,45,42,115,32,0] /* %s%-_s \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1461=allocate([85,110,110,97,109,101,100,32,75,101,121,0] /* Unnamed Key\00 */, "i8", ALLOC_STATIC);
__ZZL15inputx_key_namejE3buf=allocate(7, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL17DEVICE_SELF_OWNER=allocate([94,0] /* ^\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI18_device_field_infoE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5122, 0, 0, 0, 5124, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18_device_field_infoE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,95,100,101,118,105,99,101,95,102,105,101,108,100,95,105,110,102,111,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18_device_field_infoE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1462=allocate([85,110,107,110,111,119,110,32,97,110,97,108,111,103,32,112,111,114,116,32,116,121,112,101,32,45,45,32,100,111,110,39,116,32,107,110,111,119,32,105,102,32,105,116,32,105,115,32,97,98,115,111,108,117,116,101,32,111,114,32,110,111,116,0] /* Unknown analog port  */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI19_analog_field_stateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5126, 0, 0, 0, 5128, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI19_analog_field_stateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,57,95,97,110,97,108,111,103,95,102,105,101,108,100,95,115,116,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI19_analog_field_stateE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI18_input_field_stateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5130, 0, 0, 0, 5132, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18_input_field_stateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,95,105,110,112,117,116,95,102,105,101,108,100,95,115,116,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18_input_field_stateE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI17_input_port_stateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5134, 0, 0, 0, 5136, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17_input_port_stateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,95,105,110,112,117,116,95,112,111,114,116,95,115,116,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17_input_port_stateE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1463=allocate([106,111,121,115,116,105,99,107,95,109,97,112,0] /* joystick_map\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1464=allocate([79,102,102,0] /* Off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1465=allocate([79,110,0] /* On\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1466=allocate([78,111,0] /* No\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1467=allocate([89,101,115,0] /* Yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1468=allocate([76,105,118,101,115,0] /* Lives\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1469=allocate([66,111,110,117,115,32,76,105,102,101,0] /* Bonus Life\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1470=allocate([68,105,102,102,105,99,117,108,116,121,0] /* Difficulty\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1471=allocate([68,101,109,111,32,83,111,117,110,100,115,0] /* Demo Sounds\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1472=allocate([67,111,105,110,97,103,101,0] /* Coinage\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1473=allocate([67,111,105,110,32,65,0] /* Coin A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1474=allocate([67,111,105,110,32,66,0] /* Coin B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1475=allocate([57,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 9 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1476=allocate([56,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 8 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1477=allocate([55,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 7 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1478=allocate([54,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 6 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1479=allocate([53,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 5 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1480=allocate([52,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 4 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1481=allocate([51,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 3 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1482=allocate([56,32,67,111,105,110,115,47,51,32,67,114,101,100,105,116,115,0] /* 8 Coins/3 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1483433=allocate([52,32,67,111,105,110,115,47,50,32,67,114,101,100,105,116,115,0] /* 4 Coins/2 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1484=allocate([50,32,67,111,105,110,115,47,49,32,67,114,101,100,105,116,0] /* 2 Coins/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1485=allocate([53,32,67,111,105,110,115,47,51,32,67,114,101,100,105,116,115,0] /* 5 Coins/3 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1486=allocate([51,32,67,111,105,110,115,47,50,32,67,114,101,100,105,116,115,0] /* 3 Coins/2 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1487=allocate([52,32,67,111,105,110,115,47,51,32,67,114,101,100,105,116,115,0] /* 4 Coins/3 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1488=allocate([52,32,67,111,105,110,115,47,52,32,67,114,101,100,105,116,115,0] /* 4 Coins/4 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1489=allocate([51,32,67,111,105,110,115,47,51,32,67,114,101,100,105,116,115,0] /* 3 Coins/3 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1490=allocate([50,32,67,111,105,110,115,47,50,32,67,114,101,100,105,116,115,0] /* 2 Coins/2 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1491=allocate([49,32,67,111,105,110,47,49,32,67,114,101,100,105,116,0] /* 1 Coin/1 Credit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1492=allocate([52,32,67,111,105,110,115,47,53,32,67,114,101,100,105,116,115,0] /* 4 Coins/5 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1493=allocate([51,32,67,111,105,110,115,47,52,32,67,114,101,100,105,116,115,0] /* 3 Coins/4 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1494=allocate([50,32,67,111,105,110,115,47,51,32,67,114,101,100,105,116,115,0] /* 2 Coins/3 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1495=allocate([52,32,67,111,105,110,115,47,55,32,67,114,101,100,105,116,115,0] /* 4 Coins/7 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1496=allocate([50,32,67,111,105,110,115,47,52,32,67,114,101,100,105,116,115,0] /* 2 Coins/4 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1497=allocate([49,32,67,111,105,110,47,50,32,67,114,101,100,105,116,115,0] /* 1 Coin/2 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1498=allocate([50,32,67,111,105,110,115,47,53,32,67,114,101,100,105,116,115,0] /* 2 Coins/5 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1499=allocate([50,32,67,111,105,110,115,47,54,32,67,114,101,100,105,116,115,0] /* 2 Coins/6 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1500=allocate([49,32,67,111,105,110,47,51,32,67,114,101,100,105,116,115,0] /* 1 Coin/3 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1501=allocate([50,32,67,111,105,110,115,47,55,32,67,114,101,100,105,116,115,0] /* 2 Coins/7 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1502=allocate([50,32,67,111,105,110,115,47,56,32,67,114,101,100,105,116,115,0] /* 2 Coins/8 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1503=allocate([49,32,67,111,105,110,47,52,32,67,114,101,100,105,116,115,0] /* 1 Coin/4 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1504=allocate([49,32,67,111,105,110,47,53,32,67,114,101,100,105,116,115,0] /* 1 Coin/5 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1505=allocate([49,32,67,111,105,110,47,54,32,67,114,101,100,105,116,115,0] /* 1 Coin/6 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1506=allocate([49,32,67,111,105,110,47,55,32,67,114,101,100,105,116,115,0] /* 1 Coin/7 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1507=allocate([49,32,67,111,105,110,47,56,32,67,114,101,100,105,116,115,0] /* 1 Coin/8 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1508=allocate([49,32,67,111,105,110,47,57,32,67,114,101,100,105,116,115,0] /* 1 Coin/9 Credits\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1509=allocate([70,114,101,101,32,80,108,97,121,0] /* Free Play\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1510=allocate([67,97,98,105,110,101,116,0] /* Cabinet\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1511=allocate([85,112,114,105,103,104,116,0] /* Upright\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1512=allocate([67,111,99,107,116,97,105,108,0] /* Cocktail\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1513=allocate([70,108,105,112,32,83,99,114,101,101,110,0] /* Flip Screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1514=allocate([83,101,114,118,105,99,101,32,77,111,100,101,0] /* Service Mode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1515=allocate([84,101,115,116,0] /* Test\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1516=allocate([86,101,114,115,105,111,110,0] /* Version\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1517=allocate([82,101,103,105,111,110,0] /* Region\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1518=allocate([73,110,116,101,114,110,97,116,105,111,110,97,108,0] /* International\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1519=allocate([74,97,112,97,110,0] /* Japan\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1520=allocate([85,83,65,0] /* USA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1521=allocate([69,117,114,111,112,101,0] /* Europe\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1522=allocate([65,115,105,97,0] /* Asia\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1523=allocate([87,111,114,108,100,0] /* World\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1524=allocate([72,105,115,112,97,110,105,99,0] /* Hispanic\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1525=allocate([76,97,110,103,117,97,103,101,0] /* Language\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1526=allocate([69,110,103,108,105,115,104,0] /* English\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1527=allocate([74,97,112,97,110,101,115,101,0] /* Japanese\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1528=allocate([71,101,114,109,97,110,0] /* German\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1529=allocate([70,114,101,110,99,104,0] /* French\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1530=allocate([73,116,97,108,105,97,110,0] /* Italian\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1531=allocate([83,112,97,110,105,115,104,0] /* Spanish\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1532=allocate([86,101,114,121,32,69,97,115,121,0] /* Very Easy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1533=allocate([69,97,115,105,101,115,116,0] /* Easiest\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1534=allocate([69,97,115,105,101,114,0] /* Easier\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1535=allocate([69,97,115,121,0] /* Easy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1536=allocate([77,101,100,105,117,109,32,69,97,115,121,0] /* Medium Easy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1537=allocate([78,111,114,109,97,108,0] /* Normal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1538=allocate([77,101,100,105,117,109,0] /* Medium\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1539=allocate([77,101,100,105,117,109,32,72,97,114,100,0] /* Medium Hard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1540=allocate([72,97,114,100,0] /* Hard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1541=allocate([72,97,114,100,101,114,0] /* Harder\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1542=allocate([72,97,114,100,101,115,116,0] /* Hardest\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1543=allocate([86,101,114,121,32,72,97,114,100,0] /* Very Hard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1544=allocate([77,101,100,105,117,109,32,68,105,102,102,105,99,117,108,116,0] /* Medium Difficult\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1545=allocate([68,105,102,102,105,99,117,108,116,0] /* Difficult\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1546=allocate([77,111,114,101,32,68,105,102,102,105,99,117,108,116,0] /* More Difficult\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1547=allocate([77,111,115,116,32,68,105,102,102,105,99,117,108,116,0] /* Most Difficult\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1548=allocate([86,101,114,121,32,68,105,102,102,105,99,117,108,116,0] /* Very Difficult\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1549=allocate([86,101,114,121,32,76,111,119,0] /* Very Low\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1550=allocate([72,105,103,104,101,114,0] /* Higher\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1551=allocate([72,105,103,104,101,115,116,0] /* Highest\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1552=allocate([86,101,114,121,32,72,105,103,104,0] /* Very High\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1553=allocate([80,108,97,121,101,114,115,0] /* Players\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1554=allocate([67,111,110,116,114,111,108,115,0] /* Controls\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1555=allocate([68,117,97,108,0] /* Dual\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1556=allocate([83,105,110,103,108,101,0] /* Single\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1557=allocate([71,97,109,101,32,84,105,109,101,0] /* Game Time\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1558=allocate([67,111,110,116,105,110,117,101,32,80,114,105,99,101,0] /* Continue Price\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1559=allocate([67,111,110,116,114,111,108,108,101,114,0] /* Controller\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1560=allocate([76,105,103,104,116,32,71,117,110,0] /* Light Gun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1561=allocate([74,111,121,115,116,105,99,107,0] /* Joystick\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1562=allocate([84,114,97,99,107,98,97,108,108,0] /* Trackball\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1563=allocate([67,111,110,116,105,110,117,101,115,0] /* Continues\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1564=allocate([65,108,108,111,119,32,67,111,110,116,105,110,117,101,0] /* Allow Continue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1565=allocate([76,101,118,101,108,32,83,101,108,101,99,116,0] /* Level Select\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1566=allocate([73,110,102,105,110,105,116,101,0] /* Infinite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1567=allocate([83,116,101,114,101,111,0] /* Stereo\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1568=allocate([77,111,110,111,0] /* Mono\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1569=allocate([85,110,117,115,101,100,0] /* Unused\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1570=allocate([85,110,107,110,111,119,110,0] /* Unknown\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1571=allocate([83,116,97,110,100,97,114,100,0] /* Standard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1572=allocate([82,101,118,101,114,115,101,0] /* Reverse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1573=allocate([65,108,116,101,114,110,97,116,101,0] /* Alternate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1574=allocate([78,111,110,101,0] /* None\00 */, "i8", ALLOC_STATIC);
__ZL13print_verbose=allocate(1, "i8", ALLOC_STATIC);
__ZL14global_machine=allocate(1, "%class.running_machine*", ALLOC_STATIC);
__ZL13started_empty=allocate(1, "i8", ALLOC_STATIC);
__ZL9output_cb=allocate(24, "*", ALLOC_STATIC);
__ZL15output_cb_param=allocate(24, "*", ALLOC_STATIC);
STRING_TABLE.__str1575=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11576=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21577=allocate([114,101,97,100,99,111,110,102,105,103,0] /* readconfig\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31578=allocate([118,101,114,98,111,115,101,0] /* verbose\00 */, "i8", ALLOC_STATIC);
__ZL3tms=allocate(96, ["i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL16TMS9928A_palette=allocate([-16777216, 0, 0, 0, -16777216, 0, 0, 0, -14563262, 0, 0, 0, -10560392, 0, 0, 0, -11250195, 0, 0, 0, -8554756, 0, 0, 0, -2862515, 0, 0, 0, -12391435, 0, 0, 0, -240300, 0, 0, 0, -34440, 0, 0, 0, -2834092, 0, 0, 0, -1651072, 0, 0, 0, -14569413, 0, 0, 0, -3580998, 0, 0, 0, -3355444, 0, 0, 0, -1, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL12ModeHandlers=allocate([5138, 0, 0, 0, 5140, 0, 0, 0, 5142, 0, 0, 0, 5144, 0, 0, 0, 5146, 0, 0, 0, 5148, 0, 0, 0, 5150, 0, 0, 0, 5148, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL5sIntf=allocate(20, ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1589=allocate([115,99,114,101,101,110,0] /* screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11590=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21591=allocate([52,44,32,56,32,111,114,32,49,54,32,107,66,32,118,114,97,109,32,112,108,101,97,115,101,0] /* 4, 8 or 16 kB vram p */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31592=allocate([115,114,99,47,101,109,117,47,118,105,100,101,111,47,116,109,115,57,57,50,56,97,46,99,0] /* src/emu/video/tms992 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41593=allocate([116,109,115,57,57,50,56,97,0] /* tms9928a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51594=allocate([116,109,115,46,82,101,103,115,91,48,93,0] /* tms.Regs[0]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61595=allocate([116,109,115,46,82,101,103,115,91,49,93,0] /* tms.Regs[1]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71596=allocate([116,109,115,46,82,101,103,115,91,50,93,0] /* tms.Regs[2]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str81597=allocate([116,109,115,46,82,101,103,115,91,51,93,0] /* tms.Regs[3]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str91598=allocate([116,109,115,46,82,101,103,115,91,52,93,0] /* tms.Regs[4]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str101599=allocate([116,109,115,46,82,101,103,115,91,53,93,0] /* tms.Regs[5]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str111600=allocate([116,109,115,46,82,101,103,115,91,54,93,0] /* tms.Regs[6]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str121601=allocate([116,109,115,46,82,101,103,115,91,55,93,0] /* tms.Regs[7]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str131602=allocate([116,109,115,46,83,116,97,116,117,115,82,101,103,0] /* tms.StatusReg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str141603=allocate([116,109,115,46,82,101,97,100,65,104,101,97,100,0] /* tms.ReadAhead\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str151604=allocate([116,109,115,46,108,97,116,99,104,0] /* tms.latch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str161605=allocate([116,109,115,46,65,100,100,114,0] /* tms.Addr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str171606=allocate([116,109,115,46,73,78,84,0] /* tms.INT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str181607=allocate([116,109,115,46,118,77,101,109,0] /* tms.vMem\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI8bitmap_tE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5152, 0, 0, 0, 5154, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI8bitmap_tE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,56,98,105,116,109,97,112,95,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI8bitmap_tE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZZL15change_registerR15running_machineihE4Mask=allocate([3,251,15,255,7,127,7,255] /* \03\FB\0F\FF\07\7F\0 */, "i8", ALLOC_STATIC);
__ZZL15change_registerR15running_machineihE5modes=allocate(32, "*", ALLOC_STATIC);
STRING_TABLE.__str191608=allocate([77,111,100,101,32,48,32,40,71,82,65,80,72,73,67,32,49,41,0] /* Mode 0 (GRAPHIC 1)\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str201609=allocate([77,111,100,101,32,49,32,40,84,69,88,84,32,49,41,0] /* Mode 1 (TEXT 1)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str211610=allocate([77,111,100,101,32,50,32,40,71,82,65,80,72,73,67,32,50,41,0] /* Mode 2 (GRAPHIC 2)\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str221611=allocate([77,111,100,101,32,49,43,50,32,40,84,69,88,84,32,49,32,118,97,114,105,97,116,105,111,110,41,0] /* Mode 1+2 (TEXT 1 var */, "i8", ALLOC_STATIC);
STRING_TABLE.__str231612=allocate([77,111,100,101,32,51,32,40,77,85,76,84,73,67,79,76,79,82,41,0] /* Mode 3 (MULTICOLOR)\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str241613=allocate([77,111,100,101,32,49,43,51,32,40,66,79,71,85,83,41,0] /* Mode 1+3 (BOGUS)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str251614=allocate([77,111,100,101,32,50,43,51,32,40,77,85,76,84,73,67,79,76,79,82,32,118,97,114,105,97,116,105,111,110,41,0] /* Mode 2+3 (MULTICOLOR */, "i8", ALLOC_STATIC);
STRING_TABLE.__str261615=allocate([77,111,100,101,32,49,43,50,43,51,32,40,66,79,71,85,83,41,0] /* Mode 1+2+3 (BOGUS)\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str271616=allocate([84,77,83,57,57,50,56,65,58,32,82,101,103,32,37,100,32,61,32,37,48,50,120,104,10,0] /* TMS9928A: Reg %d = % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str281617=allocate([84,77,83,57,57,50,56,65,58,32,37,115,10,0] /* TMS9928A: %s\0A\00 */, "i8", ALLOC_STATIC);
_TIMER=allocate([5156], ["%class.device_t.1819* (%class.machine_config.1773*, i8*, %class.device_t.1819*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1634=allocate([84,105,109,101,114,0] /* Timer\00 */, "i8", ALLOC_STATIC);
__ZTV12timer_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5158, 0, 0, 0, 5160, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 1732, 0, 0, 0, 5166, 0, 0, 0, 5168, 0, 0, 0, 1738, 0, 0, 0, 5170, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 5172, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str11635=allocate([37,115,58,32,37,115,32,103,101,110,101,114,105,99,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,97,32,115,99,97,110,108,105,110,101,32,116,105,109,101,114,10,0] /* %s: %s generic timer */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21636=allocate([37,115,58,32,37,115,32,103,101,110,101,114,105,99,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,97,32,112,101,114,105,111,100,105,99,32,116,105,109,101,114,10,0] /* %s: %s generic timer */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31637=allocate([37,115,58,32,37,115,32,112,101,114,105,111,100,105,99,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,97,32,115,99,97,110,108,105,110,101,32,116,105,109,101,114,10,0] /* %s: %s periodic time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41638=allocate([37,115,58,32,37,115,32,112,101,114,105,111,100,105,99,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,105,110,118,97,108,105,100,32,112,101,114,105,111,100,10,0] /* %s: %s periodic time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51639=allocate([37,115,58,32,37,115,32,115,99,97,110,108,105,110,101,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,97,32,112,101,114,105,111,100,105,99,32,116,105,109,101,114,10,0] /* %s: %s scanline time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61640=allocate([37,115,58,32,37,115,32,115,99,97,110,108,105,110,101,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,112,97,114,97,109,101,116,101,114,32,119,104,105,99,104,32,105,115,32,105,103,110,111,114,101,100,10,0] /* %s: %s scanline time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71641=allocate([37,115,58,32,37,115,32,115,99,97,110,108,105,110,101,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,105,110,118,97,108,105,100,32,105,110,105,116,105,97,108,32,112,111,115,105,116,105,111,110,10,0] /* %s: %s scanline time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str81642=allocate([37,115,58,32,37,115,32,115,99,97,110,108,105,110,101,32,116,105,109,101,114,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,105,110,118,97,108,105,100,32,105,110,99,114,101,109,101,110,116,10,0] /* %s: %s scanline time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str91643=allocate([37,115,58,32,37,115,32,116,105,109,101,114,32,39,37,115,39,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0] /* %s: %s timer '%s' ha */, "i8", ALLOC_STATIC);
STRING_TABLE.__str101644=allocate([109,95,102,105,114,115,116,95,116,105,109,101,0] /* m_first_time\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str111645=allocate([116,105,109,101,114,32,39,37,115,39,58,32,117,110,97,98,108,101,32,116,111,32,102,105,110,100,32,115,99,114,101,101,110,32,39,37,115,39,10,0] /* timer '%s': unable t */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS12timer_device=allocate([49,50,116,105,109,101,114,95,100,101,118,105,99,101,0] /* 12timer_device\00 */, "i8", ALLOC_STATIC);
__ZTI12timer_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str121646=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,104,0] /* src/emu/devintrf.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI12timer_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5174, 0, 0, 0, 5176, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12timer_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,116,105,109,101,114,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12timer_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1651=allocate([67,97,114,116,115,108,111,116,0] /* Cartslot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11652=allocate([115,114,99,47,101,109,117,47,105,109,97,103,101,100,101,118,47,99,97,114,116,115,108,111,116,46,99,0] /* src/emu/imagedev/car */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21653=allocate([98,105,110,0] /* bin\00 */, "i8", ALLOC_STATIC);
__ZTV15cartslot_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5178, 0, 0, 0, 5180, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 5188, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 5198, 0, 0, 0, 5200, 0, 0, 0, 5202, 0, 0, 0, 5204, 0, 0, 0, 5206, 0, 0, 0, 5208, 0, 0, 0, 5210, 0, 0, 0, 5212, 0, 0, 0, 5214, 0, 0, 0, 5216, 0, 0, 0, 5218, 0, 0, 0, 5220, 0, 0, 0, 5222, 0, 0, 0, 5224, 0, 0, 0, 5226, 0, 0, 0, 5228, 0, 0, 0, 5230, 0, 0, 0, 5232, 0, 0, 0, -368, 0, 0, 0, 0, 0, 0, 0, 5234, 0, 0, 0, 5236, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 5238, 0, 0, 0, 5240, 0, 0, 0, 5242, 0, 0, 0, 5244, 0, 0, 0, 5246, 0, 0, 0, 5248, 0, 0, 0, 5250, 0, 0, 0, 5252, 0, 0, 0, 5254, 0, 0, 0, 5256, 0, 0, 0, 5258, 0, 0, 0, 5260, 0, 0, 0, 5262, 0, 0, 0, 5264, 0, 0, 0, 5266, 0, 0, 0, 5268, 0, 0, 0, 5270, 0, 0, 0, 5272, 0, 0, 0, 5274, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_CARTSLOT=allocate([152], ["%class.device_t* (%class.machine_config*, i8*, %class.device_t*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS15cartslot_device=allocate([49,53,99,97,114,116,115,108,111,116,95,100,101,118,105,99,101,0] /* 15cartslot_device\00 */, "i8", ALLOC_STATIC);
__ZTI15cartslot_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str31656=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI15cartslot_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5276, 0, 0, 0, 5278, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI15cartslot_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,53,99,97,114,116,115,108,111,116,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI15cartslot_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str41657=allocate([112,99,98,0] /* pcb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51658=allocate([109,117,108,116,105,99,97,114,116,32,101,114,114,111,114,58,32,37,115,0] /* multicart error: %s\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61659=allocate([85,110,107,110,111,119,110,32,80,67,66,32,116,121,112,101,32,34,37,115,34,0] /* Unknown PCB type \22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71660=allocate([114,111,109,0] /* rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1666=allocate([91,37,108,117,58,37,108,117,93,58,32,37,115,10,0] /* [%lu:%lu]: %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11667=allocate([115,114,99,47,101,109,117,47,115,111,102,116,108,105,115,116,46,99,0] /* src/emu/softlist.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21668=allocate([46,120,109,108,0] /* .xml\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31669=allocate([42,0] /* _\00 */, "i8", ALLOC_STATIC);
_SOFTWARE_LIST=allocate([172], ["%class.device_t.2113* (%class.machine_config.2104*, i8*, %class.device_t.2113*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str41672=allocate([10,34,37,115,34,32,97,112,112,114,111,120,105,109,97,116,101,108,121,32,109,97,116,99,104,101,115,32,116,104,101,32,102,111,108,108,111,119,105,110,103,10,115,117,112,112,111,114,116,101,100,32,115,111,102,116,119,97,114,101,32,105,116,101,109,115,32,40,98,101,115,116,32,109,97,116,99,104,32,102,105,114,115,116,41,58,10,10,0] /* \0A\22%s\22 approxim */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51673=allocate([42,32,83,111,102,116,119,97,114,101,32,108,105,115,116,32,34,37,115,34,32,40,37,115,41,32,109,97,116,99,104,101,115,58,32,10,0] /* _ Software list \22% */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61674=allocate([42,32,67,111,109,112,97,116,105,98,108,101,32,115,111,102,116,119,97,114,101,32,108,105,115,116,32,34,37,115,34,32,40,37,115,41,32,109,97,116,99,104,101,115,58,32,10,0] /* _ Compatible softwar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71675=allocate([37,45,49,56,115,37,115,10,0] /* %-18s%s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str81676=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str91677=allocate([37,115,58,37,115,58,37,115,0] /* %s:%s:%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str101678=allocate([83,111,102,116,119,97,114,101,32,108,105,115,116,115,0] /* Software lists\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str111679=allocate([49,46,48,0] /* 1.0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str121680=allocate([67,111,112,121,114,105,103,104,116,32,77,69,83,83,32,84,101,97,109,0] /* Copyright MESS Team\ */, "i8", ALLOC_STATIC);
__ZTV20software_list_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5280, 0, 0, 0, 5282, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 1732, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20software_list_device=allocate([50,48,115,111,102,116,119,97,114,101,95,108,105,115,116,95,100,101,118,105,99,101,0] /* 20software_list_devi */, "i8", ALLOC_STATIC);
__ZTI20software_list_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str131681=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI20software_list_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5284, 0, 0, 0, 5286, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI20software_list_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,48,115,111,102,116,119,97,114,101,95,108,105,115,116,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI20software_list_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12feature_listE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5288, 0, 0, 0, 5290, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12feature_listE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,102,101,97,116,117,114,101,95,108,105,115,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12feature_listE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13software_partE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5292, 0, 0, 0, 5294, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13software_partE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,115,111,102,116,119,97,114,101,95,112,97,114,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13software_partE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13software_infoE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5296, 0, 0, 0, 5298, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13software_infoE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,115,111,102,116,119,97,114,101,95,105,110,102,111,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13software_infoE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIiE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5300, 0, 0, 0, 5302, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIiE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,105,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIiE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str141682=allocate([37,115,58,32,37,115,32,104,97,115,32,110,111,32,100,101,115,99,114,105,112,116,105,111,110,10,0] /* %s: %s has no descri */, "i8", ALLOC_STATIC);
STRING_TABLE.__str151683=allocate([37,115,58,32,37,115,32,104,97,115,32,110,111,32,121,101,97,114,10,0] /* %s: %s has no year\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str161684=allocate([37,115,58,32,37,115,32,104,97,115,32,110,111,32,112,117,98,108,105,115,104,101,114,10,0] /* %s: %s has no publis */, "i8", ALLOC_STATIC);
STRING_TABLE.__str171685=allocate([37,115,58,32,37,115,32,105,115,32,97,32,100,117,112,108,105,99,97,116,101,32,110,97,109,101,32,40,37,115,41,10,0] /* %s: %s is a duplicat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str181686=allocate([37,115,58,32,37,115,32,105,115,32,97,32,100,117,112,108,105,99,97,116,101,32,100,101,115,99,114,105,112,116,105,111,110,32,40,37,115,41,10,0] /* %s: %s is a duplicat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str191687=allocate([37,115,58,32,37,115,32,105,115,32,115,101,116,32,97,115,32,97,32,99,108,111,110,101,32,111,102,32,105,116,115,101,108,102,10,0] /* %s: %s is set as a c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str201688=allocate([37,115,58,32,112,97,114,101,110,116,32,39,37,115,39,32,115,111,102,116,119,97,114,101,32,102,111,114,32,39,37,115,39,32,110,111,116,32,102,111,117,110,100,10,0] /* %s: parent '%s' soft */, "i8", ALLOC_STATIC);
STRING_TABLE.__str211689=allocate([37,115,58,32,37,115,32,105,115,32,97,32,99,108,111,110,101,32,111,102,32,97,32,99,108,111,110,101,10,0] /* %s: %s is a clone of */, "i8", ALLOC_STATIC);
STRING_TABLE.__str221690=allocate([37,115,58,32,37,115,32,37,115,32,100,114,105,118,101,114,32,110,97,109,101,32,109,117,115,116,32,98,101,32,37,100,32,99,104,97,114,97,99,116,101,114,115,32,111,114,32,108,101,115,115,10,0] /* %s: %s %s driver nam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str231691=allocate([99,108,111,110,101,0] /* clone\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str241692=allocate([112,97,114,101,110,116,0] /* parent\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str251693=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,121,101,97,114,32,39,37,115,39,10,0] /* %s: %s has an invali */, "i8", ALLOC_STATIC);
STRING_TABLE.__str261694=allocate([37,115,58,32,37,115,32,104,97,115,32,97,32,112,97,114,116,32,40,37,115,41,32,119,105,116,104,111,117,116,32,105,110,116,101,114,102,97,99,101,10,0] /* %s: %s has a part (% */, "i8", ALLOC_STATIC);
STRING_TABLE.__str271695=allocate([37,115,58,32,37,115,32,104,97,115,32,97,32,112,97,114,116,32,40,37,115,41,32,119,105,116,104,32,110,111,32,100,97,116,97,10,0] /* %s: %s has a part (% */, "i8", ALLOC_STATIC);
STRING_TABLE.__str281696=allocate([37,115,58,32,37,115,32,104,97,115,32,117,112,112,101,114,32,99,97,115,101,32,82,79,77,32,110,97,109,101,32,37,115,10,0] /* %s: %s has upper cas */, "i8", ALLOC_STATIC);
STRING_TABLE.__str291697=allocate([37,115,58,32,37,115,32,104,97,115,32,114,111,109,32,39,37,115,39,32,119,105,116,104,32,97,110,32,105,110,118,97,108,105,100,32,104,97,115,104,32,115,116,114,105,110,103,32,39,37,115,39,10,0] /* %s: %s has rom '%s'  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str301698=allocate([104,97,115,104,112,97,116,104,0] /* hashpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str311699=allocate([112,97,114,116,0] /* part\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str321700=allocate([115,111,102,116,119,97,114,101,108,105,115,116,0] /* softwarelist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str331701=allocate([110,97,109,101,0] /* name\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str341702=allocate([100,101,115,99,114,105,112,116,105,111,110,0] /* description\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str351703=allocate([115,111,102,116,119,97,114,101,0] /* software\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str361704=allocate([99,108,111,110,101,111,102,0] /* cloneof\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str371705=allocate([115,117,112,112,111,114,116,101,100,0] /* supported\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str381706=allocate([112,97,114,116,105,97,108,0] /* partial\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str391707=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str401708=allocate([121,101,97,114,0] /* year\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str411709=allocate([112,117,98,108,105,115,104,101,114,0] /* publisher\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str421710=allocate([105,110,102,111,0] /* info\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str431711=allocate([115,104,97,114,101,100,102,101,97,116,0] /* sharedfeat\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str441712=allocate([118,97,108,117,101,0] /* value\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str451713=allocate([105,110,116,101,114,102,97,99,101,0] /* interface\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str461714=allocate([100,97,116,97,97,114,101,97,0] /* dataarea\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str471715=allocate([115,105,122,101,0] /* size\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str481716=allocate([100,105,115,107,97,114,101,97,0] /* diskarea\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str491717=allocate([102,101,97,116,117,114,101,0] /* feature\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str501718=allocate([114,111,109,0] /* rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str511719=allocate([99,114,99,0] /* crc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str521720=allocate([115,104,97,49,0] /* sha1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str531721=allocate([111,102,102,115,101,116,0] /* offset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str541722=allocate([115,116,97,116,117,115,0] /* status\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str551723=allocate([108,111,97,100,102,108,97,103,0] /* loadflag\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str561724=allocate([114,101,108,111,97,100,0] /* reload\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str571725=allocate([114,101,108,111,97,100,95,112,108,97,105,110,0] /* reload_plain\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str581726=allocate([99,111,110,116,105,110,117,101,0] /* continue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str591727=allocate([102,105,108,108,0] /* fill\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str601728=allocate([98,97,100,100,117,109,112,0] /* baddump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str611729=allocate([110,111,100,117,109,112,0] /* nodump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str621730=allocate([37,99,37,115,37,99,37,115,37,115,0] /* %c%s%c%s%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str631731=allocate([33,0] /* !\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str641732=allocate([94,0] /* ^\00 */, "i8", ALLOC_STATIC);
__str651733=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str661734=allocate([108,111,97,100,49,54,95,119,111,114,100,95,115,119,97,112,0] /* load16_word_swap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str671735=allocate([108,111,97,100,49,54,95,98,121,116,101,0] /* load16_byte\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str681736=allocate([108,111,97,100,51,50,95,119,111,114,100,95,115,119,97,112,0] /* load32_word_swap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str691737=allocate([108,111,97,100,51,50,95,119,111,114,100,0] /* load32_word\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str701738=allocate([100,105,115,107,0] /* disk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str711739=allocate([119,114,105,116,101,97,98,108,101,0] /* writeable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str721740=allocate([121,101,115,0] /* yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str731741=allocate([37,99,37,115,37,115,0] /* %c%s%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str741742=allocate([91,37,108,117,58,37,108,117,93,58,32,85,110,107,110,111,119,110,32,116,97,103,58,32,37,115,10,0] /* [%lu:%lu]: Unknown t */, "i8", ALLOC_STATIC);
_global_resource_pool=allocate(20, ["i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
_zeromem=allocate([undef], "i8", ALLOC_STATIC);
__ZN12memory_entry7s_curidE=allocate([1], ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZN12memory_entry6s_lockE=allocate(1, "%struct._osd_lock.5*", ALLOC_STATIC);
__ZN12memory_entry12s_lock_allocE=allocate(1, "i8", ALLOC_STATIC);
__ZN12memory_entry10s_trackingE=allocate(1, "i8", ALLOC_STATIC);
__ZN12memory_entry6s_hashE=allocate(24604, "*", ALLOC_STATIC);
__ZN12memory_entry10s_freeheadE=allocate(1, "%class.memory_entry*", ALLOC_STATIC);
STRING_TABLE.__str1748=allocate([69,114,114,111,114,58,32,97,116,116,101,109,112,116,32,116,111,32,102,114,101,101,32,117,110,116,114,97,99,107,101,100,32,109,101,109,111,114,121,32,105,110,32,37,115,40,37,100,41,33,10,0] /* Error: attempt to fr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11749=allocate([69,114,114,111,114,58,32,97,116,116,101,109,112,116,32,116,111,32,102,114,101,101,32,117,110,116,114,97,99,107,101,100,32,109,101,109,111,114,121,0] /* Error: attempt to fr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1763=allocate([67,79,82,69,32,67,79,77,77,65,78,68,83,0] /* CORE COMMANDS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11764=allocate([104,101,108,112,59,104,59,63,0] /* help;h;?\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21765=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31766=allocate([115,104,111,119,32,104,101,108,112,32,109,101,115,115,97,103,101,0] /* show help message\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41767=allocate([118,97,108,105,100,97,116,101,59,118,97,108,105,100,0] /* validate;valid\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51768=allocate([112,101,114,102,111,114,109,32,100,114,105,118,101,114,32,118,97,108,105,100,97,116,105,111,110,32,111,110,32,97,108,108,32,103,97,109,101,32,100,114,105,118,101,114,115,0] /* perform driver valid */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61769=allocate([67,79,78,70,73,71,85,82,65,84,73,79,78,32,67,79,77,77,65,78,68,83,0] /* CONFIGURATION COMMAN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str71770=allocate([99,114,101,97,116,101,99,111,110,102,105,103,59,99,99,0] /* createconfig;cc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str81771=allocate([99,114,101,97,116,101,32,116,104,101,32,100,101,102,97,117,108,116,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,105,108,101,0] /* create the default c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str91772=allocate([115,104,111,119,99,111,110,102,105,103,59,115,99,0] /* showconfig;sc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str101773=allocate([100,105,115,112,108,97,121,32,114,117,110,110,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0] /* display running para */, "i8", ALLOC_STATIC);
STRING_TABLE.__str111774=allocate([115,104,111,119,117,115,97,103,101,59,115,117,0] /* showusage;su\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str121775=allocate([115,104,111,119,32,116,104,105,115,32,104,101,108,112,0] /* show this help\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str131776=allocate([70,82,79,78,84,69,78,68,32,67,79,77,77,65,78,68,83,0] /* FRONTEND COMMANDS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str141777=allocate([108,105,115,116,120,109,108,59,108,120,0] /* listxml;lx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str151778=allocate([97,108,108,32,97,118,97,105,108,97,98,108,101,32,105,110,102,111,32,111,110,32,100,114,105,118,101,114,32,105,110,32,88,77,76,32,102,111,114,109,97,116,0] /* all available info o */, "i8", ALLOC_STATIC);
STRING_TABLE.__str161779=allocate([108,105,115,116,102,117,108,108,59,108,108,0] /* listfull;ll\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str171780=allocate([115,104,111,114,116,32,110,97,109,101,44,32,102,117,108,108,32,110,97,109,101,0] /* short name, full nam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str181781=allocate([108,105,115,116,115,111,117,114,99,101,59,108,115,0] /* listsource;ls\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str191782=allocate([100,114,105,118,101,114,32,115,111,117,114,99,101,102,105,108,101,0] /* driver sourcefile\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str201783=allocate([108,105,115,116,99,108,111,110,101,115,59,108,99,0] /* listclones;lc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str211784=allocate([115,104,111,119,32,99,108,111,110,101,115,0] /* show clones\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str221785=allocate([108,105,115,116,98,114,111,116,104,101,114,115,59,108,98,0] /* listbrothers;lb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str231786=allocate([115,104,111,119,32,34,98,114,111,116,104,101,114,115,34,44,32,111,114,32,111,116,104,101,114,32,100,114,105,118,101,114,115,32,102,114,111,109,32,115,97,109,101,32,115,111,117,114,99,101,102,105,108,101,0] /* show \22brothers\22, */, "i8", ALLOC_STATIC);
STRING_TABLE.__str241787=allocate([108,105,115,116,99,114,99,0] /* listcrc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str251788=allocate([67,82,67,45,51,50,115,0] /* CRC-32s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str261789=allocate([108,105,115,116,114,111,109,115,0] /* listroms\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str271790=allocate([108,105,115,116,32,114,101,113,117,105,114,101,100,32,114,111,109,115,32,102,111,114,32,97,32,100,114,105,118,101,114,0] /* list required roms f */, "i8", ALLOC_STATIC);
STRING_TABLE.__str281791=allocate([108,105,115,116,115,97,109,112,108,101,115,0] /* listsamples\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str291792=allocate([108,105,115,116,32,111,112,116,105,111,110,97,108,32,115,97,109,112,108,101,115,32,102,111,114,32,97,32,100,114,105,118,101,114,0] /* list optional sample */, "i8", ALLOC_STATIC);
STRING_TABLE.__str301793=allocate([118,101,114,105,102,121,114,111,109,115,0] /* verifyroms\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str311794=allocate([114,101,112,111,114,116,32,114,111,109,115,101,116,115,32,116,104,97,116,32,104,97,118,101,32,112,114,111,98,108,101,109,115,0] /* report romsets that  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str321795=allocate([118,101,114,105,102,121,115,97,109,112,108,101,115,0] /* verifysamples\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str331796=allocate([114,101,112,111,114,116,32,115,97,109,112,108,101,115,101,116,115,32,116,104,97,116,32,104,97,118,101,32,112,114,111,98,108,101,109,115,0] /* report samplesets th */, "i8", ALLOC_STATIC);
STRING_TABLE.__str341797=allocate([114,111,109,105,100,101,110,116,0] /* romident\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str351798=allocate([99,111,109,112,97,114,101,32,102,105,108,101,115,32,119,105,116,104,32,107,110,111,119,110,32,77,65,77,69,32,114,111,109,115,0] /* compare files with k */, "i8", ALLOC_STATIC);
STRING_TABLE.__str361799=allocate([108,105,115,116,100,101,118,105,99,101,115,59,108,100,0] /* listdevices;ld\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str371800=allocate([108,105,115,116,32,97,118,97,105,108,97,98,108,101,32,100,101,118,105,99,101,115,0] /* list available devic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str381801=allocate([108,105,115,116,115,108,111,116,115,59,108,115,108,111,116,0] /* listslots;lslot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str391802=allocate([108,105,115,116,32,97,118,97,105,108,97,98,108,101,32,115,108,111,116,115,32,97,110,100,32,115,108,111,116,32,100,101,118,105,99,101,115,0] /* list available slots */, "i8", ALLOC_STATIC);
STRING_TABLE.__str401803=allocate([108,105,115,116,109,101,100,105,97,59,108,109,0] /* listmedia;lm\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str411804=allocate([108,105,115,116,32,97,118,97,105,108,97,98,108,101,32,109,101,100,105,97,32,102,111,114,32,116,104,101,32,115,121,115,116,101,109,0] /* list available media */, "i8", ALLOC_STATIC);
STRING_TABLE.__str421805=allocate([108,105,115,116,115,111,102,116,119,97,114,101,59,108,115,111,102,116,0] /* listsoftware;lsoft\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str431806=allocate([108,105,115,116,32,107,110,111,119,110,32,115,111,102,116,119,97,114,101,32,102,111,114,32,116,104,101,32,115,121,115,116,101,109,0] /* list known software  */, "i8", ALLOC_STATIC);
__ZN11cli_options16s_option_entriesE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZTV11cli_options=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5304, 0, 0, 0, 5306, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str441807=allocate([85,110,107,110,111,119,110,32,115,121,115,116,101,109,32,39,37,115,39,0] /* Unknown system '%s'\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str451808=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str461809=allocate([69,114,114,111,114,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,58,10,37,115,10,0] /* Error in command lin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str471810=allocate([78,111,32,115,111,102,116,119,97,114,101,32,108,105,115,116,115,32,100,101,102,105,110,101,100,32,102,111,114,32,116,104,105,115,32,115,121,115,116,101,109,10,0] /* No software lists de */, "i8", ALLOC_STATIC);
STRING_TABLE.__str481811=allocate([97,117,116,111,109,111,117,110,116,0] /* automount\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str491812=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str501813=allocate([37,115,58,37,115,0] /* %s:%s\00 */, "i8", ALLOC_STATIC);
__str511814=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str521815=allocate([67,97,117,103,104,116,32,117,110,104,97,110,100,108,101,100,32,101,120,99,101,112,116,105,111,110,10,0] /* Caught unhandled exc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str531816=allocate([79,117,116,32,111,102,32,109,101,109,111,114,121,33,10,0] /* Out of memory!\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str541817=allocate([67,97,117,103,104,116,32,117,110,104,97,110,100,108,101,100,32,101,109,117,108,97,116,111,114,32,101,120,99,101,112,116,105,111,110,10,0] /* Caught unhandled emu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str551818=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str561819=allocate([10,34,37,115,34,32,97,112,112,114,111,120,105,109,97,116,101,108,121,32,109,97,116,99,104,101,115,32,116,104,101,32,102,111,108,108,111,119,105,110,103,10,115,117,112,112,111,114,116,101,100,32,115,121,115,116,101,109,115,32,40,98,101,115,116,32,109,97,116,99,104,32,102,105,114,115,116,41,58,10,10,0] /* \0A\22%s\22 approxim */, "i8", ALLOC_STATIC);
STRING_TABLE.__str571820=allocate([37,45,49,56,115,37,115,10,0] /* %-18s%s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str581821=allocate([78,111,32,109,97,116,99,104,105,110,103,32,103,97,109,101,115,32,102,111,117,110,100,32,102,111,114,32,39,37,115,39,0] /* No matching games fo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str591822=allocate([78,97,109,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,68,101,115,99,114,105,112,116,105,111,110,58,10,0] /* Name:             De */, "i8", ALLOC_STATIC);
STRING_TABLE.__str601823=allocate([37,45,49,56,115,34,37,115,34,10,0] /* %-18s\22%s\22\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str611824=allocate([37,45,49,54,115,32,37,115,10,0] /* %-16s %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str621825=allocate([70,111,117,110,100,32,37,100,32,109,97,116,99,104,101,115,32,102,111,114,32,39,37,115,39,32,98,117,116,32,110,111,110,101,32,119,101,114,101,32,99,108,111,110,101,115,10,0] /* Found %d matches for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str631826=allocate([78,97,109,101,58,32,32,32,32,32,32,32,32,32,32,32,32,67,108,111,110,101,32,111,102,58,10,0] /* Name:            Clo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str641827=allocate([37,45,49,54,115,32,37,45,56,115,10,0] /* %-16s %-8s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str651828=allocate([83,111,117,114,99,101,32,102,105,108,101,58,32,32,32,32,32,78,97,109,101,58,32,32,32,32,32,32,32,32,32,32,32,32,80,97,114,101,110,116,58,10,0] /* Source file:     Nam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str661829=allocate([37,45,49,54,115,32,37,45,49,54,115,32,37,45,49,54,115,10,0] /* %-16s %-16s %-16s\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str671830=allocate([37,48,56,120,32,37,45,49,54,115,32,37,115,10,0] /* %08x %-16s %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str681831=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str691832=allocate([82,79,77,115,32,114,101,113,117,105,114,101,100,32,102,111,114,32,100,114,105,118,101,114,32,34,37,115,34,46,10,78,97,109,101,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,83,105,122,101,32,67,104,101,99,107,115,117,109,10,0] /* ROMs required for dr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str701833=allocate([37,45,50,48,115,32,0] /* %-20s \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str711834=allocate([37,55,100,0] /* %7d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str721835=allocate([32,32,32,32,32,32,32,0] /*        \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str731836=allocate([32,66,65,68,0] /*  BAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str741837=allocate([32,37,115,0] /*  %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str751838=allocate([32,78,79,32,71,79,79,68,32,68,85,77,80,32,75,78,79,87,78,0] /*  NO GOOD DUMP KNOWN\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str761839=allocate([83,97,109,112,108,101,115,32,114,101,113,117,105,114,101,100,32,102,111,114,32,100,114,105,118,101,114,32,34,37,115,34,46,10,0] /* Samples required for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str771840=allocate([68,114,105,118,101,114,32,37,115,32,40,37,115,41,58,10,0] /* Driver %s (%s):\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str781841=allocate([32,32,32,37,115,32,40,39,37,115,39,41,0] /*    %s ('%s')\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str791842=allocate([32,64,32,37,100,46,37,48,50,100,32,71,72,122,10,0] /*  @ %d.%02d GHz\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str801843=allocate([32,64,32,37,100,46,37,48,50,100,32,77,72,122,10,0] /*  @ %d.%02d MHz\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str811844=allocate([32,64,32,37,100,46,37,48,50,100,32,107,72,122,10,0] /*  @ %d.%02d kHz\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str821845=allocate([32,64,32,37,100,32,72,122,10,0] /*  @ %d Hz\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str831846=allocate([32,83,89,83,84,69,77,32,32,32,32,32,32,83,76,79,84,32,78,65,77,69,32,32,32,32,32,32,32,32,32,32,32,32,32,83,76,79,84,32,79,80,84,73,79,78,83,32,83,85,80,80,79,82,84,69,68,32,32,32,32,32,10,0] /*  SYSTEM      SLOT NA */, "i8", ALLOC_STATIC);
STRING_TABLE.__str841847=allocate([45,45,45,45,45,45,45,45,45,45,32,32,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,32,32,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,0] /* ----------  -------- */, "i8", ALLOC_STATIC);
STRING_TABLE.__str851848=allocate([37,45,49,51,115,37,45,50,48,115,32,32,32,0] /* %-13s%-20s   \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str861849=allocate([37,45,51,51,115,32,32,32,37,115,10,0] /* %-33s   %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str871850=allocate([37,45,49,51,115,40,110,111,110,101,41,10,0] /* %-13s(none)\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str881851=allocate([32,83,89,83,84,69,77,32,32,32,32,32,32,77,69,68,73,65,32,78,65,77,69,32,40,98,114,105,101,102,41,32,32,32,73,77,65,71,69,32,70,73,76,69,32,69,88,84,69,78,83,73,79,78,83,32,83,85,80,80,79,82,84,69,68,32,32,32,32,32,10,0] /*  SYSTEM      MEDIA N */, "i8", ALLOC_STATIC);
STRING_TABLE.__str891852=allocate([40,37,115,41,0] /* (%s)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str901853=allocate([37,45,49,51,115,37,45,49,50,115,37,45,56,115,32,32,32,0] /* %-13s%-12s%-8s   \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str911854=allocate([46,37,45,53,115,0] /* .%-5s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str921855=allocate([82,0] /* R\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str931856=allocate([114,111,109,115,101,116,32,37,115,32,0] /* romset %s \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str941857=allocate([91,37,115,93,32,0] /* [%s] \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str951858=allocate([105,115,32,98,97,100,10,0] /* is bad\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str961859=allocate([105,115,32,103,111,111,100,10,0] /* is good\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str971860=allocate([105,115,32,98,101,115,116,32,97,118,97,105,108,97,98,108,101,10,0] /* is best available\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str981861=allocate([114,111,109,115,101,116,32,34,37,115,34,32,110,111,116,32,102,111,117,110,100,33,10,0] /* romset \22%s\22 not  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str991862=allocate([114,111,109,115,101,116,32,34,37,115,34,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,10,0] /* romset \22%s\22 not  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1001863=allocate([37,100,32,114,111,109,115,101,116,115,32,102,111,117,110,100,44,32,37,100,32,119,101,114,101,32,79,75,46,10,0] /* %d romsets found, %d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1011864=allocate([115,97,109,112,108,101,115,101,116,32,34,37,115,34,32,110,111,116,32,102,111,117,110,100,33,10,0] /* sampleset \22%s\22 n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1021865=allocate([115,97,109,112,108,101,115,101,116,32,37,115,32,0] /* sampleset %s \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1031866=allocate([115,97,109,112,108,101,115,101,116,32,34,37,115,34,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,10,0] /* sampleset \22%s\22 n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1041867=allocate([37,100,32,115,97,109,112,108,101,115,101,116,115,32,102,111,117,110,100,44,32,37,100,32,119,101,114,101,32,79,75,46,10,0] /* %d samplesets found, */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1051868=allocate([115,114,99,47,101,109,117,47,99,108,105,102,114,111,110,116,46,99,0] /* src/emu/clifront.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1061869=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,60,33,68,79,67,84,89,80,69,32,115,111,102,116,119,97,114,101,108,105,115,116,32,91,10,60,33,69,76,69,77,69,78,84,32,115,111,102,116,119,97,114,101,108,105,115,116,115,32,40,115,111,102,116,119,97,114,101,108,105,115,116,42,41,62,10,9,60,33,69,76,69,77,69,78,84,32,115,111,102,116,119,97,114,101,108,105,115,116,32,40,115,111,102,116,119,97,114,101,43,41,62,10,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,108,105,115,116,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,108,105,115,116,32,100,101,115,99,114,105,112,116,105,111,110,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,115,111,102,116,119,97,114,101,32,40,100,101,115,99,114,105,112,116,105,111,110,44,32,121,101,97,114,63,44,32,112,117,98,108,105,115,104,101,114,44,32,105,110,102,111,42,44,32,115,104,97,114,101,100,102,101,97,116,42,44,32,112,97,114,116,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,32,99,108,111,110,101,111,102,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,32,115,117,112,112,111,114,116,101,100,32,40,121,101,115,124,112,97,114,116,105,97,108,124,110,111,41,32,34,121,101,115,34,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,100,101,115,99,114,105,112,116,105,111,110,32,40,35,80,67,68,65,84,65,41,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,121,101,97,114,32,40,35,80,67,68,65,84,65,41,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,112,117,98,108,105,115,104,101,114,32,40,35,80,67,68,65,84,65,41,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,105,110,102,111,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,102,111,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,102,111,32,118,97,108,117,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,115,104,97,114,101,100,102,101,97,116,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,115,104,97,114,101,100,102,101,97,116,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,115,104,97,114,101,100,102,101,97,116,32,118,97,108,117,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,112,97,114,116,32,40,102,101,97,116,117,114,101,42,44,32,100,97,116,97,97,114,101,97,42,44,32,100,105,115,107,97,114,101,97,42,44,32,100,105,112,115,119,105,116,99,104,42,41,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,112,97,114,116,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,112,97,114,116,32,105,110,116,101,114,102,97,99,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,69,76,69,77,69,78,84,32,102,101,97,116,117,114,101,32,69,77,80,84,89,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,102,101,97,116,117,114,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,102,101,97,116,117,114,101,32,118,97,108,117,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,60,33,69,76,69,77,69,78,84,32,100,97,116,97,97,114,101,97,32,40,114,111,109,42,41,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,97,116,97,97,114,101,97,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,97,116,97,97,114,101,97,32,115,105,122,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,97,116,97,97,114,101,97,32,100,97,116,97,98,105,116,115,32,40,56,124,49,54,124,51,50,124,54,52,41,32,34,56,34,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,97,116,97,97,114,101,97,32,101,110,100,105,97,110,32,40,98,105,103,124,108,105,116,116,108,101,41,32,34,108,105,116,116,108,101,34,62,10,9,9,9,9,9,60,33,69,76,69,77,69,78,84,32,114,111,109,32,69,77,80,84,89,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,110,97,109,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,115,105,122,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,108,101,110,103,116,104,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,99,114,99,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,109,100,53,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,115,104,97,49,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,111,102,102,115,101,116,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,118,97,108,117,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,115,116,97,116,117,115,32,40,98,97,100,100,117,109,112,124,110,111,100,117,109,112,124,103,111,111,100,41,32,34,103,111,111,100,34,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,108,111,97,100,102,108,97,103,32,40,108,111,97,100,49,54,95,98,121,116,101,124,108,111,97,100,49,54,95,119,111,114,100,124,108,111,97,100,49,54,95,119,111,114,100,95,115,119,97,112,124,108,111,97,100,51,50,95,98,121,116,101,124,108,111,97,100,51,50,95,119,111,114,100,124,108,111,97,100,51,50,95,119,111,114,100,95,115,119,97,112,124,108,111,97,100,51,50,95,100,119,111,114,100,124,108,111,97,100,54,52,95,119,111,114,100,124,108,111,97,100,54,52,95,119,111,114,100,95,115,119,97,112,124,114,101,108,111,97,100,124,102,105,108,108,124,99,111,110,116,105,110,117,101,41,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,60,33,69,76,69,77,69,78,84,32,100,105,115,107,97,114,101,97,32,40,100,105,115,107,42,41,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,97,114,101,97,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,69,76,69,77,69,78,84,32,100,105,115,107,32,69,77,80,84,89,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,109,100,53,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,115,104,97,49,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,115,116,97,116,117,115,32,40,98,97,100,100,117,109,112,124,110,111,100,117,109,112,124,103,111,111,100,41,32,34,103,111,111,100,34,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,119,114,105,116,101,97,98,108,101,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,9,9,60,33,69,76,69,77,69,78,84,32,100,105,112,115,119,105,116,99,104,32,40,100,105,112,118,97,108,117,101,42,41,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,115,119,105,116,99,104,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,115,119,105,116,99,104,32,116,97,103,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,115,119,105,116,99,104,32,109,97,115,107,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,60,33,69,76,69,77,69,78,84,32,100,105,112,118,97,108,117,101,32,69,77,80,84,89,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,118,97,108,117,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,118,97,108,117,101,32,118,97,108,117,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,118,97,108,117,101,32,100,101,102,97,117,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,93,62,10,10,60,115,111,102,116,119,97,114,101,108,105,115,116,115,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1071870=allocate([9,60,115,111,102,116,119,97,114,101,108,105,115,116,32,110,97,109,101,61,34,37,115,34,32,100,101,115,99,114,105,112,116,105,111,110,61,34,37,115,34,62,10,0] /* \09<softwarelist nam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1081871=allocate([42,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1091872=allocate([9,9,60,115,111,102,116,119,97,114,101,32,110,97,109,101,61,34,37,115,34,0] /* \09\09<software name */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1101873=allocate([32,99,108,111,110,101,111,102,61,34,37,115,34,0] /*  cloneof=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1111874=allocate([32,115,117,112,112,111,114,116,101,100,61,34,112,97,114,116,105,97,108,34,0] /*  supported=\22partia */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1121875=allocate([32,115,117,112,112,111,114,116,101,100,61,34,110,111,34,0] /*  supported=\22no\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1131876=allocate([62,10,0] /* >\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1141877=allocate([9,9,9,60,100,101,115,99,114,105,112,116,105,111,110,62,37,115,60,47,100,101,115,99,114,105,112,116,105,111,110,62,10,0] /* \09\09\09<descriptio */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1151878=allocate([9,9,9,60,121,101,97,114,62,37,115,60,47,121,101,97,114,62,10,0] /* \09\09\09<year>%s</y */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1161879=allocate([9,9,9,60,112,117,98,108,105,115,104,101,114,62,37,115,60,47,112,117,98,108,105,115,104,101,114,62,10,0] /* \09\09\09<publisher> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1171880=allocate([9,9,9,60,112,97,114,116,32,110,97,109,101,61,34,37,115,34,0] /* \09\09\09<part name= */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1181881=allocate([32,105,110,116,101,114,102,97,99,101,61,34,37,115,34,0] /*  interface=\22%s\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1191882=allocate([9,9,9,9,60,102,101,97,116,117,114,101,32,110,97,109,101,61,34,37,115,34,32,118,97,108,117,101,61,34,37,115,34,32,47,62,10,0] /* \09\09\09\09<feature */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1201883=allocate([9,9,9,9,60,100,97,116,97,97,114,101,97,32,110,97,109,101,61,34,37,115,34,32,115,105,122,101,61,34,37,100,34,62,10,0] /* \09\09\09\09<dataare */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1211884=allocate([9,9,9,9,60,100,105,115,107,97,114,101,97,32,110,97,109,101,61,34,37,115,34,62,10,0] /* \09\09\09\09<diskare */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1221885=allocate([9,9,9,9,9,60,114,111,109,32,110,97,109,101,61,34,37,115,34,32,115,105,122,101,61,34,37,100,34,0] /* \09\09\09\09\09<rom  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1231886=allocate([9,9,9,9,9,60,100,105,115,107,32,110,97,109,101,61,34,37,115,34,0] /* \09\09\09\09\09<disk */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1241887=allocate([32,37,115,61,34,37,115,34,0] /*  %s=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1251888=allocate([32,111,102,102,115,101,116,61,34,48,120,37,120,34,0] /*  offset=\220x%x\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1261889=allocate([32,115,116,97,116,117,115,61,34,98,97,100,100,117,109,112,34,0] /*  status=\22baddump\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1271890=allocate([32,115,116,97,116,117,115,61,34,110,111,100,117,109,112,34,0] /*  status=\22nodump\22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1281891=allocate([32,119,114,105,116,101,97,98,108,101,61,34,37,115,34,0] /*  writeable=\22%s\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1291892=allocate([121,101,115,0] /* yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1301893=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,49,54,95,98,121,116,101,34,0] /*  loadflag=\22load16_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1311894=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,51,50,95,98,121,116,101,34,0] /*  loadflag=\22load32_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1321895=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,51,50,95,119,111,114,100,34,0] /*  loadflag=\22load32_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1331896=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,51,50,95,119,111,114,100,95,115,119,97,112,34,0] /*  loadflag=\22load32_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1341897=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,54,52,95,119,111,114,100,34,0] /*  loadflag=\22load64_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1351898=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,54,52,95,119,111,114,100,95,115,119,97,112,34,0] /*  loadflag=\22load64_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1361899=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,51,50,95,100,119,111,114,100,34,0] /*  loadflag=\22load32_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1371900=allocate([32,108,111,97,100,102,108,97,103,61,34,108,111,97,100,49,54,95,119,111,114,100,95,115,119,97,112,34,0] /*  loadflag=\22load16_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1381901=allocate([47,62,10,0] /* />\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1391902=allocate([9,9,9,9,9,60,114,111,109,32,115,105,122,101,61,34,37,100,34,32,111,102,102,115,101,116,61,34,48,120,37,120,34,32,108,111,97,100,102,108,97,103,61,34,114,101,108,111,97,100,34,32,47,62,10,0] /* \09\09\09\09\09<rom  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1401903=allocate([9,9,9,9,9,60,114,111,109,32,115,105,122,101,61,34,37,100,34,32,111,102,102,115,101,116,61,34,48,120,37,120,34,32,108,111,97,100,102,108,97,103,61,34,99,111,110,116,105,110,117,101,34,32,47,62,10,0] /* \09\09\09\09\09<rom  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1411904=allocate([9,9,9,9,9,60,114,111,109,32,115,105,122,101,61,34,37,100,34,32,111,102,102,115,101,116,61,34,48,120,37,120,34,32,108,111,97,100,102,108,97,103,61,34,102,105,108,108,34,32,47,62,10,0] /* \09\09\09\09\09<rom  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1421905=allocate([9,9,9,9,60,47,100,97,116,97,97,114,101,97,62,10,0] /* \09\09\09\09</dataar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1431906=allocate([9,9,9,9,60,47,100,105,115,107,97,114,101,97,62,10,0] /* \09\09\09\09</diskar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1441907=allocate([9,9,9,60,47,112,97,114,116,62,10,0] /* \09\09\09</part>\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1451908=allocate([9,9,60,47,115,111,102,116,119,97,114,101,62,10,0] /* \09\09</software>\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1461909=allocate([9,60,47,115,111,102,116,119,97,114,101,108,105,115,116,62,10,0] /* \09</softwarelist>\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1471910=allocate([60,47,115,111,102,116,119,97,114,101,108,105,115,116,115,62,10,0] /* </softwarelists>\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1481911=allocate([78,111,32,115,111,102,116,119,97,114,101,32,108,105,115,116,115,32,102,111,117,110,100,32,102,111,114,32,116,104,105,115,32,115,121,115,116,101,109,10,0] /* No software lists fo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1491912=allocate([73,100,101,110,116,105,102,121,105,110,103,32,37,115,46,46,46,46,10,0] /* Identifying %s....\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1501913=allocate([104,101,108,112,0] /* help\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1511914=allocate([115,104,111,119,117,115,97,103,101,0] /* showusage\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1521915=allocate([85,115,97,103,101,58,32,32,37,115,32,91,37,115,93,32,91,109,101,100,105,97,93,32,91,115,111,102,116,119,97,114,101,93,32,91,111,112,116,105,111,110,115,93,10,10,79,112,116,105,111,110,115,58,10,37,115,0] /* Usage:  %s [%s] [med */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1531916=allocate([115,121,115,116,101,109,0] /* system\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1541917=allocate([118,97,108,105,100,97,116,101,0] /* validate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1551918=allocate([99,114,101,97,116,101,99,111,110,102,105,103,0] /* createconfig\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1561919=allocate([109,101,115,115,46,105,110,105,0] /* mess.ini\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1571920=allocate([85,110,97,98,108,101,32,116,111,32,99,114,101,97,116,101,32,102,105,108,101,32,109,101,115,115,46,105,110,105,10,0] /* Unable to create fil */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1581921=allocate([115,104,111,119,99,111,110,102,105,103,0] /* showconfig\00 */, "i8", ALLOC_STATIC);
__ZZN12cli_frontend16execute_commandsEPKcE13info_commands=allocate([0, 0, 0, 0, 5308, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5310, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5312, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5316, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5318, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5320, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5322, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5324, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5326, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5328, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5330, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5332, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5334, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5336, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1591922=allocate([108,105,115,116,120,109,108,0] /* listxml\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1601923=allocate([108,105,115,116,102,117,108,108,0] /* listfull\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1611924=allocate([108,105,115,116,115,111,117,114,99,101,0] /* listsource\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1621925=allocate([108,105,115,116,99,108,111,110,101,115,0] /* listclones\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1631926=allocate([108,105,115,116,98,114,111,116,104,101,114,115,0] /* listbrothers\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1641927=allocate([108,105,115,116,100,101,118,105,99,101,115,0] /* listdevices\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1651928=allocate([108,105,115,116,115,108,111,116,115,0] /* listslots\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1661929=allocate([108,105,115,116,109,101,100,105,97,0] /* listmedia\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1671930=allocate([108,105,115,116,115,111,102,116,119,97,114,101,0] /* listsoftware\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1681931=allocate([85,110,107,110,111,119,110,32,99,111,109,109,97,110,100,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,0] /* Unknown command '%s' */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1691932=allocate([77,46,69,46,83,46,83,46,32,118,37,115,32,45,32,77,117,108,116,105,32,69,109,117,108,97,116,111,114,32,83,117,112,101,114,32,83,121,115,116,101,109,10,67,111,112,121,114,105,103,104,116,32,116,104,101,32,77,69,83,83,32,116,101,97,109,10,10,77,69,83,83,32,105,115,32,98,97,115,101,100,32,111,110,32,77,65,77,69,32,83,111,117,114,99,101,32,99,111,100,101,10,67,111,112,121,114,105,103,104,116,32,78,105,99,111,108,97,32,83,97,108,109,111,114,105,97,32,97,110,100,32,116,104,101,32,77,65,77,69,32,116,101,97,109,10,10,0] /* M.E.S.S. v%s - Multi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1701933=allocate([77,69,83,83,32,105,115,32,97,110,32,101,109,117,108,97,116,111,114,58,32,105,116,32,114,101,112,114,111,100,117,99,101,115,44,32,109,111,114,101,32,111,114,32,108,101,115,115,32,102,97,105,116,104,102,117,108,108,121,44,32,116,104,101,32,98,101,104,97,118,105,111,117,114,32,111,102,10,115,101,118,101,114,97,108,32,99,111,109,112,117,116,101,114,32,97,110,100,32,99,111,110,115,111,108,101,32,115,121,115,116,101,109,115,46,32,66,117,116,32,104,97,114,100,119,97,114,101,32,105,115,32,117,115,101,108,101,115,115,32,119,105,116,104,111,117,116,32,115,111,102,116,119,97,114,101,10,115,111,32,97,32,102,105,108,101,32,100,117,109,112,32,111,102,32,116,104,101,32,82,79,77,44,32,99,97,114,116,114,105,100,103,101,115,44,32,100,105,115,99,115,44,32,97,110,100,32,99,97,115,115,101,116,116,101,115,32,119,104,105,99,104,32,114,117,110,32,111,110,32,116,104,97,116,10,104,97,114,100,119,97,114,101,32,105,115,32,114,101,113,117,105,114,101,100,46,32,83,117,99,104,32,102,105,108,101,115,44,32,108,105,107,101,32,97,110,121,32,111,116,104,101,114,32,99,111,109,109,101,114,99,105,97,108,32,115,111,102,116,119,97,114,101,44,32,97,114,101,10,99,111,112,121,114,105,103,104,116,101,100,32,109,97,116,101,114,105,97,108,32,97,110,100,32,105,116,32,105,115,32,116,104,101,114,101,102,111,114,101,32,105,108,108,101,103,97,108,32,116,111,32,117,115,101,32,116,104,101,109,32,105,102,32,121,111,117,32,100,111,110,39,116,32,111,119,110,10,116,104,101,32,111,114,105,103,105,110,97,108,32,109,101,100,105,97,32,102,114,111,109,32,119,104,105,99,104,32,116,104,101,32,102,105,108,101,115,32,97,114,101,32,100,101,114,105,118,101,100,46,32,78,101,101,100,108,101,115,115,32,116,111,32,115,97,121,44,32,116,104,101,115,101,10,102,105,108,101,115,32,97,114,101,32,110,111,116,32,100,105,115,116,114,105,98,117,116,101,100,32,116,111,103,101,116,104,101,114,32,119,105,116,104,32,77,69,83,83,46,32,68,105,115,116,114,105,98,117,116,105,111,110,32,111,102,32,77,69,83,83,32,116,111,103,101,116,104,101,114,10,119,105,116,104,32,116,104,101,115,101,32,102,105,108,101,115,32,105,115,32,97,32,118,105,111,108,97,116,105,111,110,32,111,102,32,99,111,112,121,114,105,103,104,116,32,108,97,119,32,97,110,100,32,115,104,111,117,108,100,32,98,101,32,112,114,111,109,112,116,108,121,10,114,101,112,111,114,116,101,100,32,116,111,32,116,104,101,32,97,117,116,104,111,114,115,32,115,111,32,116,104,97,116,32,97,112,112,114,111,112,114,105,97,116,101,32,108,101,103,97,108,32,97,99,116,105,111,110,32,99,97,110,32,98,101,32,116,97,107,101,110,46,10,0] /* MESS is an emulator: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1711934=allocate([85,115,97,103,101,58,32,32,37,115,32,91,37,115,93,32,91,109,101,100,105,97,93,32,91,115,111,102,116,119,97,114,101,93,32,91,111,112,116,105,111,110,115,93,10,10,32,32,32,32,32,32,32,32,77,69,83,83,32,45,115,104,111,119,117,115,97,103,101,32,32,32,32,102,111,114,32,97,32,98,114,105,101,102,32,108,105,115,116,32,111,102,32,111,112,116,105,111,110,115,10,32,32,32,32,32,32,32,32,77,69,83,83,32,45,115,104,111,119,99,111,110,102,105,103,32,32,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,111,112,116,105,111,110,115,10,32,32,32,32,32,32,32,32,77,69,83,83,32,45,108,105,115,116,109,101,100,105,97,32,32,32,32,102,111,114,32,97,32,102,117,108,108,32,108,105,115,116,32,111,102,32,115,117,112,112,111,114,116,101,100,32,109,101,100,105,97,10,32,32,32,32,32,32,32,32,77,69,83,83,32,45,99,114,101,97,116,101,99,111,110,102,105,103,32,116,111,32,99,114,101,97,116,101,32,97,32,109,101,115,115,46,105,110,105,10,10,70,111,114,32,117,115,97,103,101,32,105,110,115,116,114,117,99,116,105,111,110,115,44,32,112,108,101,97,115,101,32,99,111,110,115,117,108,116,32,116,104,101,32,102,105,108,101,115,32,99,111,110,102,105,103,46,116,120,116,32,97,110,100,32,119,105,110,100,111,119,115,46,116,120,116,46,10,0] /* Usage:  %s [%s] [med */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1721935=allocate([77,69,83,83,0] /* MESS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1731936=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1741937=allocate([46,122,105,112,0] /* .zip\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1751938=allocate([46,99,104,100,0] /* .chd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1761939=allocate([37,45,50,48,115,0] /* %-20s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1771940=allocate([78,79,84,32,65,32,67,72,68,10,0] /* NOT A CHD\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1781941=allocate([105,115,32,97,32,119,114,105,116,101,97,98,108,101,32,67,72,68,10,0] /* is a writeable CHD\0 */, "i8", ALLOC_STATIC);
__ZZN16media_identifier13identify_fileEPKcE8nullhash=allocate(20, "i8", ALLOC_STATIC);
STRING_TABLE.__str1791942=allocate([78,79,32,77,65,84,67,72,10,0] /* NO MATCH\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1801943=allocate([46,106,101,100,0] /* .jed\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1811944=allocate([78,79,84,32,65,32,82,79,77,10,0] /* NOT A ROM\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1821945=allocate([32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0] /*                      */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1831946=allocate([61,32,37,115,37,45,50,48,115,32,32,37,45,49,48,115,32,37,115,10,0] /* = %s%-20s  %-10s %s\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1841947=allocate([40,66,65,68,41,32,0] /* (BAD) \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1851948=allocate([61,32,37,115,37,45,50,48,115,32,32,37,115,58,37,115,32,37,115,10,0] /* = %s%-20s  %s:%s %s\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS11cli_options=allocate([49,49,99,108,105,95,111,112,116,105,111,110,115,0] /* 11cli_options\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS11emu_options=allocate([49,49,101,109,117,95,111,112,116,105,111,110,115,0] /* 11emu_options\00 */, "i8", ALLOC_STATIC);
__ZTI11emu_options=allocate(12, "*", ALLOC_STATIC);
__ZTI11cli_options=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayI7astringE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5338, 0, 0, 0, 5340, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI7astringE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,55,97,115,116,114,105,110,103,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI7astringE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI12audit_recordE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5342, 0, 0, 0, 5344, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI12audit_recordE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,50,97,117,100,105,116,95,114,101,99,111,114,100,69,0] /* 11simple_listI12audi */, "i8", ALLOC_STATIC);
__ZTI11simple_listI12audit_recordE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str1957=allocate([114,111,111,116,0] /* root\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11958=allocate([77,97,99,104,105,110,101,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,109,105,115,115,105,110,103,32,100,114,105,118,101,114,95,100,101,118,105,99,101,0] /* Machine configuratio */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21959=allocate([85,110,97,98,108,101,32,116,111,32,102,105,110,100,32,100,101,118,105,99,101,58,32,116,97,103,61,37,115,10,0] /* Unable to find devic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str41961=allocate([69,114,114,111,114,32,97,100,100,105,110,103,32,111,98,106,101,99,116,32,110,97,109,101,100,32,39,37,115,39,0] /* Error adding object  */, "i8", ALLOC_STATIC);
__ZTV11simple_listI8device_tE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5346, 0, 0, 0, 5348, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI8device_tE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,56,100,101,118,105,99,101,95,116,69,0] /* 11simple_listI8devic */, "i8", ALLOC_STATIC);
__ZTI11simple_listI8device_tE=allocate(8, "*", ALLOC_STATIC);
__ZL22temp_string_pool_index=allocate(1, "i32", ALLOC_STATIC);
__ZL16temp_string_pool=allocate(4096, "i8", ALLOC_STATIC);
STRING_TABLE.__str1973=allocate([100,101,118,105,99,101,95,108,105,115,116,58,58,114,101,115,101,116,95,97,108,108,0] /* device_list::reset_a */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11974=allocate([100,101,118,105,99,101,95,108,105,115,116,58,58,101,120,105,116,0] /* device_list::exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str21975=allocate([100,101,118,105,99,101,95,108,105,115,116,58,58,112,114,101,115,97,118,101,95,97,108,108,0] /* device_list::presave */, "i8", ALLOC_STATIC);
STRING_TABLE.__str31976=allocate([100,101,118,105,99,101,95,108,105,115,116,58,58,112,111,115,116,108,111,97,100,95,97,108,108,0] /* device_list::postloa */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS27device_missing_dependencies=allocate([50,55,100,101,118,105,99,101,95,109,105,115,115,105,110,103,95,100,101,112,101,110,100,101,110,99,105,101,115,0] /* 27device_missing_dep */, "i8", ALLOC_STATIC);
__ZTI27device_missing_dependencies=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str41977=allocate([83,116,97,114,116,105,110,103,32,37,115,32,39,37,115,39,10,0] /* Starting %s '%s'\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str51978=allocate([32,32,40,109,105,115,115,105,110,103,32,100,101,112,101,110,100,101,110,99,105,101,115,59,32,114,101,115,99,104,101,100,117,108,105,110,103,41,10,0] /*   (missing dependenc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str61979=allocate([67,105,114,99,117,108,97,114,32,100,101,112,101,110,100,101,110,99,121,32,105,110,32,100,101,118,105,99,101,32,115,116,97,114,116,117,112,59,32,117,110,97,98,108,101,32,116,111,32,115,116,97,114,116,32,37,115,32,39,37,115,39,10,0] /* Circular dependency  */, "i8", ALLOC_STATIC);
__ZTV8device_t=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5350, 0, 0, 0, 5352, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1788, 0, 0, 0, 1738, 0, 0, 0, 5354, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str71980=allocate([68,101,118,105,99,101,32,39,37,115,39,32,100,105,100,32,110,111,116,32,114,101,103,105,115,116,101,114,32,97,110,121,32,115,116,97,116,101,32,116,111,32,115,97,118,101,33,10,0] /* Device '%s' did not  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str81981=allocate([68,101,118,105,99,101,32,39,37,115,39,32,100,105,100,32,110,111,116,32,114,101,103,105,115,116,101,114,32,97,110,121,32,115,116,97,116,101,32,116,111,32,115,97,118,101,33,0] /* Device '%s' did not  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str91982=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,99,0] /* src/emu/devintrf.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str101983=allocate([109,95,99,108,111,99,107,0] /* m_clock\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str111984=allocate([109,95,117,110,115,99,97,108,101,100,95,99,108,111,99,107,0] /* m_unscaled_clock\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str121985=allocate([109,95,99,108,111,99,107,95,115,99,97,108,101,0] /* m_clock_scale\00 */, "i8", ALLOC_STATIC);
__ZTVN8device_t16auto_finder_baseE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5356, 0, 0, 0, 5358, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV16device_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5360, 0, 0, 0, 5362, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS8device_t=allocate([56,100,101,118,105,99,101,95,116,0] /* 8device_t\00 */, "i8", ALLOC_STATIC);
__ZTI8device_t=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSN8device_t16auto_finder_baseE=allocate([78,56,100,101,118,105,99,101,95,116,49,54,97,117,116,111,95,102,105,110,100,101,114,95,98,97,115,101,69,0] /* N8device_t16auto_fin */, "i8", ALLOC_STATIC);
__ZTIN8device_t16auto_finder_baseE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS16device_interface=allocate([49,54,100,101,118,105,99,101,95,105,110,116,101,114,102,97,99,101,0] /* 16device_interface\0 */, "i8", ALLOC_STATIC);
__ZTI16device_interface=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12device_debugE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5364, 0, 0, 0, 5366, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12device_debugE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,100,101,118,105,99,101,95,100,101,98,117,103,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12device_debugE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS11device_list=allocate([49,49,100,101,118,105,99,101,95,108,105,115,116,0] /* 11device_list\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS11tagged_listI8device_tE=allocate([49,49,116,97,103,103,101,100,95,108,105,115,116,73,56,100,101,118,105,99,101,95,116,69,0] /* 11tagged_listI8devic */, "i8", ALLOC_STATIC);
__ZTI11tagged_listI8device_tE=allocate(8, "*", ALLOC_STATIC);
__ZTI11device_list=allocate(12, "*", ALLOC_STATIC);
__ZTV18delegate_late_bind=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5368, 0, 0, 0, 5370, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str32073=allocate([78,111,32,109,101,109,111,114,121,32,105,110,116,101,114,102,97,99,101,32,100,101,102,105,110,101,100,32,102,111,114,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* No memory interface  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42074=allocate([78,111,32,109,101,109,111,114,121,32,97,100,100,114,101,115,115,32,115,112,97,99,101,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,111,117,110,100,32,102,111,114,32,100,101,118,105,99,101,32,39,37,115,39,44,32,115,112,97,99,101,32,37,100,10,0] /* No memory address sp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52075=allocate([115,114,99,47,101,109,117,47,97,100,100,114,109,97,112,46,99,0] /* src/emu/addrmap.c\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI18address_map_entry8E=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5372, 0, 0, 0, 5374, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18address_map_entry8E=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,97,100,100,114,101,115,115,95,109,97,112,95,101,110,116,114,121,56,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18address_map_entry8E=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI17address_map_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5376, 0, 0, 0, 5378, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI17address_map_entryE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,55,97,100,100,114,101,115,115,95,109,97,112,95,101,110,116,114,121,69,0] /* 11simple_listI17addr */, "i8", ALLOC_STATIC);
__ZTI11simple_listI17address_map_entryE=allocate(8, "*", ALLOC_STATIC);
__ZL11DEVICE_SELF2076=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL17DEVICE_SELF_OWNER2077=allocate([94,0] /* ^\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2093=allocate([99,97,114,116,114,105,100,103,101,0] /* cartridge\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12094=allocate([99,97,114,116,0] /* cart\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22095=allocate([102,108,111,112,112,121,100,105,115,107,0] /* floppydisk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32096=allocate([102,108,111,112,0] /* flop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42097=allocate([104,97,114,100,100,105,115,107,0] /* harddisk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52098=allocate([104,97,114,100,0] /* hard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62099=allocate([99,121,108,105,110,100,101,114,0] /* cylinder\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72100=allocate([99,121,108,110,0] /* cyln\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82101=allocate([99,97,115,115,101,116,116,101,0] /* cassette\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92102=allocate([99,97,115,115,0] /* cass\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102103=allocate([112,117,110,99,104,99,97,114,100,0] /* punchcard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112104=allocate([112,99,114,100,0] /* pcrd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122105=allocate([112,117,110,99,104,116,97,112,101,0] /* punchtape\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132106=allocate([112,116,97,112,0] /* ptap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142107=allocate([112,114,105,110,116,101,114,0] /* printer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152108=allocate([112,114,105,110,0] /* prin\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162109=allocate([115,101,114,105,97,108,0] /* serial\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172110=allocate([115,101,114,108,0] /* serl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182111=allocate([112,97,114,97,108,108,101,108,0] /* parallel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192112=allocate([112,97,114,108,0] /* parl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202113=allocate([115,110,97,112,115,104,111,116,0] /* snapshot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212114=allocate([100,117,109,112,0] /* dump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222115=allocate([113,117,105,99,107,108,111,97,100,0] /* quickload\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232116=allocate([113,117,105,107,0] /* quik\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242117=allocate([109,101,109,99,97,114,100,0] /* memcard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252118=allocate([109,101,109,99,0] /* memc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262119=allocate([99,100,114,111,109,0] /* cdrom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272120=allocate([99,100,114,109,0] /* cdrm\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282121=allocate([109,97,103,116,97,112,101,0] /* magtape\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292122=allocate([109,97,103,116,0] /* magt\00 */, "i8", ALLOC_STATIC);
__ZN22device_image_interface19m_device_info_arrayE=allocate([1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZTV22device_image_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5380, 0, 0, 0, 5382, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 5238, 0, 0, 0, 5384, 0, 0, 0, 5386, 0, 0, 0, 5388, 0, 0, 0, 5390, 0, 0, 0, 5392, 0, 0, 0, 5394, 0, 0, 0, 5396, 0, 0, 0, 5398, 0, 0, 0, 5400, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 5402, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__str302123=allocate(1, "i8", ALLOC_STATIC);
__ZL8messages=allocate(32, "*", ALLOC_STATIC);
STRING_TABLE.__str322125=allocate([46,0] /* .\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332126=allocate([115,111,102,116,119,97,114,101,0] /* software\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342127=allocate([37,115,58,37,115,0] /* %s:%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str352128=allocate([115,114,99,47,101,109,117,47,100,105,105,109,97,103,101,46,99,0] /* src/emu/diimage.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362129=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str392132=allocate([37,0] /* %\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402133=allocate([87,65,82,78,73,78,71,58,32,115,117,112,112,111,114,116,32,102,111,114,32,115,111,102,116,119,97,114,101,32,37,115,32,40,105,110,32,108,105,115,116,32,37,115,41,32,105,115,32,111,110,108,121,32,112,97,114,116,105,97,108,10,0] /* WARNING: support for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412134=allocate([87,65,82,78,73,78,71,58,32,115,117,112,112,111,114,116,32,102,111,114,32,115,111,102,116,119,97,114,101,32,37,115,32,40,105,110,32,108,105,115,116,32,37,115,41,32,105,115,32,111,110,108,121,32,112,114,101,108,105,109,105,110,97,114,121,10,0] /* WARNING: support for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422135=allocate([87,101,32,100,111,32,110,111,116,32,115,117,112,112,111,114,116,32,99,108,111,110,101,115,32,111,102,32,99,108,111,110,101,115,33,10,0] /* We do not support cl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432136=allocate([69,114,114,111,114,58,32,85,110,97,98,108,101,32,116,111,32,37,115,32,105,109,97,103,101,32,39,37,115,39,58,32,37,115,10,0] /* Error: Unable to %s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442137=allocate([99,114,101,97,116,101,0] /* create\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452138=allocate([108,111,97,100,0] /* load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str462139=allocate([69,114,114,111,114,58,32,85,110,97,98,108,101,32,116,111,32,37,115,32,105,109,97,103,101,32,39,37,115,39,58,32,37,115,0] /* Error: Unable to %s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str472140=allocate([73,109,97,103,101,32,39,37,115,39,32,119,97,115,32,115,117,99,99,101,115,115,102,117,108,108,121,32,37,115,46,0] /* Image '%s' was succe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str482141=allocate([99,114,101,97,116,101,100,0] /* created\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str492142=allocate([108,111,97,100,101,100,0] /* loaded\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str502143=allocate([73,109,97,103,101,32,39,37,115,39,32,119,97,115,32,115,117,99,99,101,115,115,102,117,108,108,121,32,37,115,46,10,0] /* Image '%s' was succe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str512144=allocate([37,115,37,100,0] /* %s%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS22device_image_interface=allocate([50,50,100,101,118,105,99,101,95,105,109,97,103,101,95,105,110,116,101,114,102,97,99,101,0] /* 22device_image_inter */, "i8", ALLOC_STATIC);
__ZTI22device_image_interface=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str552150=allocate([73,110,116,101,114,110,97,108,32,101,114,114,111,114,0] /* Internal error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str562151=allocate([85,110,115,117,112,112,111,114,116,101,100,32,111,112,101,114,97,116,105,111,110,0] /* Unsupported operatio */, "i8", ALLOC_STATIC);
STRING_TABLE.__str572152=allocate([79,117,116,32,111,102,32,109,101,109,111,114,121,0] /* Out of memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str582153=allocate([70,105,108,101,32,110,111,116,32,102,111,117,110,100,0] /* File not found\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str592154=allocate([73,110,118,97,108,105,100,32,105,109,97,103,101,0] /* Invalid image\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str602155=allocate([70,105,108,101,32,97,108,114,101,97,100,121,32,111,112,101,110,0] /* File already open\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str612156=allocate([85,110,115,112,101,99,105,102,105,101,100,32,101,114,114,111,114,0] /* Unspecified error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2165=allocate([117,110,107,110,111,119,110,0] /* unknown\00 */, "i8", ALLOC_STATIC);
__ZTV23device_memory_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5404, 0, 0, 0, 5406, 0, 0, 0, 1882, 0, 0, 0, 1928, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1788, 0, 0, 0, 5408, 0, 0, 0, 5410, 0, 0, 0, 5412, 0, 0, 0, 5414, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str12166=allocate([77,67,70,71,95,68,69,86,73,67,69,95,65,68,68,82,69,83,83,95,77,65,80,32,99,97,108,108,101,100,32,111,110,32,100,101,118,105,99,101,32,39,37,115,39,32,119,105,116,104,32,110,111,32,109,101,109,111,114,121,32,105,110,116,101,114,102,97,99,101,0] /* MCFG_DEVICE_ADDRESS_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22167=allocate([77,67,70,71,95,68,69,86,73,67,69,95,65,68,68,82,69,83,83,95,77,65,80,32,99,97,108,108,101,100,32,119,105,116,104,32,111,117,116,45,111,102,45,114,97,110,103,101,32,115,112,97,99,101,32,110,117,109,98,101,114,32,37,100,0] /* MCFG_DEVICE_ADDRESS_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32168=allocate([115,114,99,47,101,109,117,47,100,105,109,101,109,111,114,121,46,99,0] /* src/emu/dimemory.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42169=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,115,112,97,99,101,32,37,100,32,104,97,115,32,97,100,100,114,101,115,115,32,115,112,97,99,101,32,37,100,32,104,97,110,100,108,101,114,115,33,10,0] /* %s: %s device '%s' s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52170=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,117,115,101,115,32,119,114,111,110,103,32,109,101,109,111,114,121,32,104,97,110,100,108,101,114,115,32,102,111,114,32,37,115,32,115,112,97,99,101,33,32,40,119,105,100,116,104,32,61,32,37,100,44,32,109,101,109,111,114,121,32,61,32,37,48,56,120,41,10,0] /* %s: %s device '%s' u */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62171=allocate([37,115,58,32,37,115,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,104,97,115,32,111,118,101,114,108,97,112,112,105,110,103,32,109,101,109,111,114,121,32,40,37,88,45,37,88,44,37,100,44,37,100,41,32,118,115,32,40,37,88,45,37,88,44,37,100,44,37,100,41,10,0] /* %s: %s '%s' %s space */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72172=allocate([37,115,58,32,37,115,32,119,114,111,110,103,32,37,115,32,109,101,109,111,114,121,32,114,101,97,100,32,104,97,110,100,108,101,114,32,115,116,97,114,116,32,61,32,37,48,56,120,32,62,32,101,110,100,32,61,32,37,48,56,120,10,0] /* %s: %s wrong %s memo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82173=allocate([37,115,58,32,37,115,32,119,114,111,110,103,32,37,115,32,109,101,109,111,114,121,32,114,101,97,100,32,104,97,110,100,108,101,114,32,115,116,97,114,116,32,61,32,37,48,56,120,44,32,101,110,100,32,61,32,37,48,56,120,32,65,76,73,71,78,32,61,32,37,100,10,0] /* %s: %s wrong %s memo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92174=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,109,101,109,111,114,121,32,109,97,112,32,101,110,116,114,121,32,37,88,45,37,88,32,101,120,116,101,110,100,115,32,98,101,121,111,110,100,32,114,101,103,105,111,110,32,39,37,115,39,32,115,105,122,101,32,40,37,88,41,10,0] /* %s: %s device '%s' % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102175=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,109,101,109,111,114,121,32,109,97,112,32,101,110,116,114,121,32,37,88,45,37,88,32,114,101,102,101,114,101,110,99,101,115,32,110,111,110,45,101,120,105,115,116,97,110,116,32,114,101,103,105,111,110,32,39,37,115,39,10,0] /* %s: %s device '%s' % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112176=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,109,101,109,111,114,121,32,109,97,112,32,101,110,116,114,121,32,114,101,102,101,114,101,110,99,101,115,32,110,111,110,101,120,105,115,116,97,110,116,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* %s: %s device '%s' % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122177=allocate([98,97,110,107,0] /* bank\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132178=allocate([115,104,97,114,101,0] /* share\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS23device_memory_interface=allocate([50,51,100,101,118,105,99,101,95,109,101,109,111,114,121,95,105,110,116,101,114,102,97,99,101,0] /* 23device_memory_inte */, "i8", ALLOC_STATIC);
__ZTI23device_memory_interface=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI11address_mapE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5416, 0, 0, 0, 5418, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11address_mapE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,97,100,100,114,101,115,115,95,109,97,112,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11address_mapE=allocate(12, "*", ALLOC_STATIC);
__ZN9input_seq8end_codeE=allocate(4, "i32", ALLOC_STATIC);
__ZN9input_seq12default_codeE=allocate(4, "i32", ALLOC_STATIC);
__ZN9input_seq8not_codeE=allocate(4, "i32", ALLOC_STATIC);
__ZN9input_seq7or_codeE=allocate(4, "i32", ALLOC_STATIC);
__ZN9input_seq9empty_seqE=allocate(64, "i32", ALLOC_STATIC);
STRING_TABLE.__str2198=allocate([65,0] /* A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52199=allocate([66,0] /* B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62200=allocate([67,0] /* C\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72201=allocate([68,0] /* D\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82202=allocate([69,0] /* E\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92203=allocate([70,0] /* F\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102204=allocate([71,0] /* G\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112205=allocate([72,0] /* H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122206=allocate([73,0] /* I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132207=allocate([74,0] /* J\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142208=allocate([75,0] /* K\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152209=allocate([76,0] /* L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162210=allocate([77,0] /* M\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172211=allocate([78,0] /* N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182212=allocate([79,0] /* O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192213=allocate([80,0] /* P\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202214=allocate([81,0] /* Q\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212215=allocate([82,0] /* R\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222216=allocate([83,0] /* S\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232217=allocate([84,0] /* T\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242218=allocate([85,0] /* U\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252219=allocate([86,0] /* V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262220=allocate([87,0] /* W\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272221=allocate([88,0] /* X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282222=allocate([89,0] /* Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292223=allocate([90,0] /* Z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str302224=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312225=allocate([49,0] /* 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322226=allocate([50,0] /* 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332227=allocate([51,0] /* 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342228=allocate([52,0] /* 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str352229=allocate([53,0] /* 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362230=allocate([54,0] /* 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str372231=allocate([55,0] /* 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str382232=allocate([56,0] /* 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str392233=allocate([57,0] /* 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402234=allocate([70,49,0] /* F1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412235=allocate([70,50,0] /* F2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422236=allocate([70,51,0] /* F3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432237=allocate([70,52,0] /* F4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442238=allocate([70,53,0] /* F5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452239=allocate([70,54,0] /* F6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str462240=allocate([70,55,0] /* F7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str472241=allocate([70,56,0] /* F8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str482242=allocate([70,57,0] /* F9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str492243=allocate([70,49,48,0] /* F10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str502244=allocate([70,49,49,0] /* F11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str512245=allocate([70,49,50,0] /* F12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str522246=allocate([70,49,51,0] /* F13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str532247=allocate([70,49,52,0] /* F14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str542248=allocate([70,49,53,0] /* F15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str552249=allocate([69,83,67,0] /* ESC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str562250=allocate([84,73,76,68,69,0] /* TILDE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str572251=allocate([77,73,78,85,83,0] /* MINUS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str582252=allocate([69,81,85,65,76,83,0] /* EQUALS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str592253=allocate([66,65,67,75,83,80,65,67,69,0] /* BACKSPACE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str602254=allocate([84,65,66,0] /* TAB\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str612255=allocate([79,80,69,78,66,82,65,67,69,0] /* OPENBRACE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str622256=allocate([67,76,79,83,69,66,82,65,67,69,0] /* CLOSEBRACE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str632257=allocate([69,78,84,69,82,0] /* ENTER\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str642258=allocate([67,79,76,79,78,0] /* COLON\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str652259=allocate([81,85,79,84,69,0] /* QUOTE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str662260=allocate([66,65,67,75,83,76,65,83,72,0] /* BACKSLASH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str672261=allocate([66,65,67,75,83,76,65,83,72,50,0] /* BACKSLASH2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str682262=allocate([67,79,77,77,65,0] /* COMMA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str692263=allocate([83,84,79,80,0] /* STOP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str702264=allocate([83,76,65,83,72,0] /* SLASH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str712265=allocate([83,80,65,67,69,0] /* SPACE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str722266=allocate([73,78,83,69,82,84,0] /* INSERT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str732267=allocate([68,69,76,0] /* DEL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str742268=allocate([72,79,77,69,0] /* HOME\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str752269=allocate([69,78,68,0] /* END\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str762270=allocate([80,71,85,80,0] /* PGUP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str772271=allocate([80,71,68,78,0] /* PGDN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str782272=allocate([76,69,70,84,0] /* LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str792273=allocate([82,73,71,72,84,0] /* RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str802274=allocate([85,80,0] /* UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str812275=allocate([68,79,87,78,0] /* DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str822276=allocate([48,80,65,68,0] /* 0PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str832277=allocate([49,80,65,68,0] /* 1PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str842278=allocate([50,80,65,68,0] /* 2PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str852279=allocate([51,80,65,68,0] /* 3PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str862280=allocate([52,80,65,68,0] /* 4PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str872281=allocate([53,80,65,68,0] /* 5PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str882282=allocate([54,80,65,68,0] /* 6PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str892283=allocate([55,80,65,68,0] /* 7PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str902284=allocate([56,80,65,68,0] /* 8PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str912285=allocate([57,80,65,68,0] /* 9PAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str922286=allocate([83,76,65,83,72,80,65,68,0] /* SLASHPAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str932287=allocate([65,83,84,69,82,73,83,75,0] /* ASTERISK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str942288=allocate([77,73,78,85,83,80,65,68,0] /* MINUSPAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str952289=allocate([80,76,85,83,80,65,68,0] /* PLUSPAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str962290=allocate([68,69,76,80,65,68,0] /* DELPAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str972291=allocate([69,78,84,69,82,80,65,68,0] /* ENTERPAD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str982292=allocate([80,82,84,83,67,82,0] /* PRTSCR\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str992293=allocate([80,65,85,83,69,0] /* PAUSE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1002294=allocate([76,83,72,73,70,84,0] /* LSHIFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1012295=allocate([82,83,72,73,70,84,0] /* RSHIFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1022296=allocate([76,67,79,78,84,82,79,76,0] /* LCONTROL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1032297=allocate([82,67,79,78,84,82,79,76,0] /* RCONTROL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1042298=allocate([76,65,76,84,0] /* LALT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1052299=allocate([82,65,76,84,0] /* RALT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1062300=allocate([83,67,82,76,79,67,75,0] /* SCRLOCK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1072301=allocate([78,85,77,76,79,67,75,0] /* NUMLOCK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1082302=allocate([67,65,80,83,76,79,67,75,0] /* CAPSLOCK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1092303=allocate([76,87,73,78,0] /* LWIN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1102304=allocate([82,87,73,78,0] /* RWIN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1112305=allocate([77,69,78,85,0] /* MENU\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1122306=allocate([67,65,78,67,69,76,0] /* CANCEL\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1132307=allocate([88,65,88,73,83,0] /* XAXIS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1142308=allocate([89,65,88,73,83,0] /* YAXIS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1152309=allocate([90,65,88,73,83,0] /* ZAXIS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1162310=allocate([82,88,65,88,73,83,0] /* RXAXIS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1172311=allocate([82,89,65,88,73,83,0] /* RYAXIS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1182312=allocate([82,90,65,88,73,83,0] /* RZAXIS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1192313=allocate([83,76,73,68,69,82,49,0] /* SLIDER1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1202314=allocate([83,76,73,68,69,82,50,0] /* SLIDER2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1212315=allocate([66,85,84,84,79,78,49,0] /* BUTTON1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1222316=allocate([66,85,84,84,79,78,50,0] /* BUTTON2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1232317=allocate([66,85,84,84,79,78,51,0] /* BUTTON3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1242318=allocate([66,85,84,84,79,78,52,0] /* BUTTON4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1252319=allocate([66,85,84,84,79,78,53,0] /* BUTTON5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1262320=allocate([66,85,84,84,79,78,54,0] /* BUTTON6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1272321=allocate([66,85,84,84,79,78,55,0] /* BUTTON7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1282322=allocate([66,85,84,84,79,78,56,0] /* BUTTON8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1292323=allocate([66,85,84,84,79,78,57,0] /* BUTTON9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1302324=allocate([66,85,84,84,79,78,49,48,0] /* BUTTON10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1312325=allocate([66,85,84,84,79,78,49,49,0] /* BUTTON11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1322326=allocate([66,85,84,84,79,78,49,50,0] /* BUTTON12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1332327=allocate([66,85,84,84,79,78,49,51,0] /* BUTTON13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1342328=allocate([66,85,84,84,79,78,49,52,0] /* BUTTON14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1352329=allocate([66,85,84,84,79,78,49,53,0] /* BUTTON15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1362330=allocate([66,85,84,84,79,78,49,54,0] /* BUTTON16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1372331=allocate([83,84,65,82,84,0] /* START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1382332=allocate([83,69,76,69,67,84,0] /* SELECT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1392333=allocate([72,65,84,49,85,80,0] /* HAT1UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1402334=allocate([72,65,84,49,68,79,87,78,0] /* HAT1DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1412335=allocate([72,65,84,49,76,69,70,84,0] /* HAT1LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1422336=allocate([72,65,84,49,82,73,71,72,84,0] /* HAT1RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1432337=allocate([72,65,84,50,85,80,0] /* HAT2UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1442338=allocate([72,65,84,50,68,79,87,78,0] /* HAT2DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1452339=allocate([72,65,84,50,76,69,70,84,0] /* HAT2LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1462340=allocate([72,65,84,50,82,73,71,72,84,0] /* HAT2RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1472341=allocate([72,65,84,51,85,80,0] /* HAT3UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1482342=allocate([72,65,84,51,68,79,87,78,0] /* HAT3DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1492343=allocate([72,65,84,51,76,69,70,84,0] /* HAT3LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1502344=allocate([72,65,84,51,82,73,71,72,84,0] /* HAT3RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1512345=allocate([72,65,84,52,85,80,0] /* HAT4UP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1522346=allocate([72,65,84,52,68,79,87,78,0] /* HAT4DOWN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1532347=allocate([72,65,84,52,76,69,70,84,0] /* HAT4LEFT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1542348=allocate([72,65,84,52,82,73,71,72,84,0] /* HAT4RIGHT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1552349=allocate([65,68,68,83,87,49,0] /* ADDSW1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1562350=allocate([65,68,68,83,87,50,0] /* ADDSW2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1572351=allocate([65,68,68,83,87,51,0] /* ADDSW3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1582352=allocate([65,68,68,83,87,52,0] /* ADDSW4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1592353=allocate([65,68,68,83,87,53,0] /* ADDSW5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1602354=allocate([65,68,68,83,87,54,0] /* ADDSW6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1612355=allocate([65,68,68,83,87,55,0] /* ADDSW7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1622356=allocate([65,68,68,83,87,56,0] /* ADDSW8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1632357=allocate([65,68,68,83,87,57,0] /* ADDSW9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1642358=allocate([65,68,68,83,87,49,48,0] /* ADDSW10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1652359=allocate([65,68,68,83,87,49,49,0] /* ADDSW11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1662360=allocate([65,68,68,83,87,49,50,0] /* ADDSW12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1672361=allocate([65,68,68,83,87,49,51,0] /* ADDSW13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1682362=allocate([65,68,68,83,87,49,52,0] /* ADDSW14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1692363=allocate([65,68,68,83,87,49,53,0] /* ADDSW15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1702364=allocate([65,68,68,83,87,49,54,0] /* ADDSW16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1712365=allocate([65,68,68,65,88,73,83,49,0] /* ADDAXIS1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1722366=allocate([65,68,68,65,88,73,83,50,0] /* ADDAXIS2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1732367=allocate([65,68,68,65,88,73,83,51,0] /* ADDAXIS3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1742368=allocate([65,68,68,65,88,73,83,52,0] /* ADDAXIS4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1752369=allocate([65,68,68,65,88,73,83,53,0] /* ADDAXIS5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1762370=allocate([65,68,68,65,88,73,83,54,0] /* ADDAXIS6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1772371=allocate([65,68,68,65,88,73,83,55,0] /* ADDAXIS7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1782372=allocate([65,68,68,65,88,73,83,56,0] /* ADDAXIS8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1792373=allocate([65,68,68,65,88,73,83,57,0] /* ADDAXIS9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1802374=allocate([65,68,68,65,88,73,83,49,48,0] /* ADDAXIS10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1812375=allocate([65,68,68,65,88,73,83,49,49,0] /* ADDAXIS11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1822376=allocate([65,68,68,65,88,73,83,49,50,0] /* ADDAXIS12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1832377=allocate([65,68,68,65,88,73,83,49,51,0] /* ADDAXIS13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1842378=allocate([65,68,68,65,88,73,83,49,52,0] /* ADDAXIS14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1852379=allocate([65,68,68,65,88,73,83,49,53,0] /* ADDAXIS15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1862380=allocate([65,68,68,65,88,73,83,49,54,0] /* ADDAXIS16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1872381=allocate([65,68,68,82,69,76,49,0] /* ADDREL1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1882382=allocate([65,68,68,82,69,76,50,0] /* ADDREL2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1892383=allocate([65,68,68,82,69,76,51,0] /* ADDREL3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1902384=allocate([65,68,68,82,69,76,52,0] /* ADDREL4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1912385=allocate([65,68,68,82,69,76,53,0] /* ADDREL5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1922386=allocate([65,68,68,82,69,76,54,0] /* ADDREL6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1932387=allocate([65,68,68,82,69,76,55,0] /* ADDREL7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1942388=allocate([65,68,68,82,69,76,56,0] /* ADDREL8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1952389=allocate([65,68,68,82,69,76,57,0] /* ADDREL9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1962390=allocate([65,68,68,82,69,76,49,48,0] /* ADDREL10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1972391=allocate([65,68,68,82,69,76,49,49,0] /* ADDREL11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1982392=allocate([65,68,68,82,69,76,49,50,0] /* ADDREL12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1992393=allocate([65,68,68,82,69,76,49,51,0] /* ADDREL13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2002394=allocate([65,68,68,82,69,76,49,52,0] /* ADDREL14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2012395=allocate([65,68,68,82,69,76,49,53,0] /* ADDREL15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2022396=allocate([65,68,68,82,69,76,49,54,0] /* ADDREL16\00 */, "i8", ALLOC_STATIC);
__ZL18itemid_token_table=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 33, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 0, 0, 53, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 57, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 61, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 0, 0, 0, 0, 71, 0, 0, 0, 0, 0, 0, 0, 72, 0, 0, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0, 0, 0, 0, 76, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 0, 0, 78, 0, 0, 0, 0, 0, 0, 0, 79, 0, 0, 0, 0, 0, 0, 0, 80, 0, 0, 0, 0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 0, 0, 0, 0, 85, 0, 0, 0, 0, 0, 0, 0, 86, 0, 0, 0, 0, 0, 0, 0, 87, 0, 0, 0, 0, 0, 0, 0, 88, 0, 0, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 0, 0, 90, 0, 0, 0, 0, 0, 0, 0, 91, 0, 0, 0, 0, 0, 0, 0, 92, 0, 0, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 0, 0, 94, 0, 0, 0, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 0, 0, 99, 0, 0, 0, 0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 102, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 0, 0, 106, 0, 0, 0, 0, 0, 0, 0, 107, 0, 0, 0, 0, 0, 0, 0, 108, 0, 0, 0, 0, 0, 0, 0, 109, 0, 0, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 113, 0, 0, 0, 0, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 115, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 0, 0, 117, 0, 0, 0, 0, 0, 0, 0, 118, 0, 0, 0, 0, 0, 0, 0, 119, 0, 0, 0, 0, 0, 0, 0, 120, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 122, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, 0, 0, 0, 0, 0, 124, 0, 0, 0, 0, 0, 0, 0, 125, 0, 0, 0, 0, 0, 0, 0, 126, 0, 0, 0, 0, 0, 0, 0, 127, 0, 0, 0, 0, 0, 0, 0, 128, 0, 0, 0, 0, 0, 0, 0, 129, 0, 0, 0, 0, 0, 0, 0, 130, 0, 0, 0, 0, 0, 0, 0, 131, 0, 0, 0, 0, 0, 0, 0, 132, 0, 0, 0, 0, 0, 0, 0, 133, 0, 0, 0, 0, 0, 0, 0, 134, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, 0, 0, 0, 0, 0, 136, 0, 0, 0, 0, 0, 0, 0, 137, 0, 0, 0, 0, 0, 0, 0, 138, 0, 0, 0, 0, 0, 0, 0, 139, 0, 0, 0, 0, 0, 0, 0, 140, 0, 0, 0, 0, 0, 0, 0, 141, 0, 0, 0, 0, 0, 0, 0, 142, 0, 0, 0, 0, 0, 0, 0, 143, 0, 0, 0, 0, 0, 0, 0, 144, 0, 0, 0, 0, 0, 0, 0, 145, 0, 0, 0, 0, 0, 0, 0, 146, 0, 0, 0, 0, 0, 0, 0, 147, 0, 0, 0, 0, 0, 0, 0, 148, 0, 0, 0, 0, 0, 0, 0, 149, 0, 0, 0, 0, 0, 0, 0, 150, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, 0, 0, 0, 0, 0, 153, 0, 0, 0, 0, 0, 0, 0, 154, 0, 0, 0, 0, 0, 0, 0, 155, 0, 0, 0, 0, 0, 0, 0, 156, 0, 0, 0, 0, 0, 0, 0, 157, 0, 0, 0, 0, 0, 0, 0, 158, 0, 0, 0, 0, 0, 0, 0, 159, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, 0, 0, 0, 0, 0, 162, 0, 0, 0, 0, 0, 0, 0, 163, 0, 0, 0, 0, 0, 0, 0, 164, 0, 0, 0, 0, 0, 0, 0, 165, 0, 0, 0, 0, 0, 0, 0, 166, 0, 0, 0, 0, 0, 0, 0, 167, 0, 0, 0, 0, 0, 0, 0, 168, 0, 0, 0, 0, 0, 0, 0, 169, 0, 0, 0, 0, 0, 0, 0, 170, 0, 0, 0, 0, 0, 0, 0, 171, 0, 0, 0, 0, 0, 0, 0, 172, 0, 0, 0, 0, 0, 0, 0, 173, 0, 0, 0, 0, 0, 0, 0, 174, 0, 0, 0, 0, 0, 0, 0, 175, 0, 0, 0, 0, 0, 0, 0, 176, 0, 0, 0, 0, 0, 0, 0, 177, 0, 0, 0, 0, 0, 0, 0, 178, 0, 0, 0, 0, 0, 0, 0, 179, 0, 0, 0, 0, 0, 0, 0, 180, 0, 0, 0, 0, 0, 0, 0, 181, 0, 0, 0, 0, 0, 0, 0, 182, 0, 0, 0, 0, 0, 0, 0, 183, 0, 0, 0, 0, 0, 0, 0, 184, 0, 0, 0, 0, 0, 0, 0, 185, 0, 0, 0, 0, 0, 0, 0, 186, 0, 0, 0, 0, 0, 0, 0, 187, 0, 0, 0, 0, 0, 0, 0, 188, 0, 0, 0, 0, 0, 0, 0, 189, 0, 0, 0, 0, 0, 0, 0, 190, 0, 0, 0, 0, 0, 0, 0, 191, 0, 0, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 193, 0, 0, 0, 0, 0, 0, 0, 194, 0, 0, 0, 0, 0, 0, 0, 195, 0, 0, 0, 0, 0, 0, 0, 196, 0, 0, 0, 0, 0, 0, 0, 197, 0, 0, 0, 0, 0, 0, 0, 198, 0, 0, 0, 0, 0, 0, 0, 199, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE._joystick_map_8way=allocate([55,55,55,56,46,46,46,52,52,52,53,0] /* 7778...4445\00 */, "i8", ALLOC_STATIC);
STRING_TABLE._joystick_map_4way_sticky=allocate([115,56,46,52,115,56,46,52,52,115,56,46,52,52,52,53,0] /* s8.4s8.44s8.4445\00 */, "i8", ALLOC_STATIC);
STRING_TABLE._joystick_map_4way_diagonal=allocate([52,52,52,52,115,56,56,56,56,46,46,52,52,52,52,53,56,56,56,56,46,52,52,52,53,53,53,56,56,56,46,115,115,53,46,50,50,50,53,53,53,54,54,54,46,50,50,50,50,53,54,54,54,54,46,50,50,50,50,115,54,54,54,54,46,50,50,50,50,115,54,54,54,54,0] /* 4444s8888..444458888 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZN12joystick_map5parseEPKcE7charmap=allocate([5,4,6,1,0,2,9,8,10,15] /* \05\04\06\01\00\02\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZN12joystick_map5parseEPKcE10validchars=allocate([55,56,57,52,53,54,49,50,51,115,0] /* 789456123s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2032401=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2042402=allocate([32,32,0] /*   \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2052403=allocate([115,0] /* s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2062404=allocate([63,0] /* ?\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2072405=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2082406=allocate([97,117,116,111,0] /* auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2092407=allocate([73,110,118,97,108,105,100,32,106,111,121,115,116,105,99,107,32,109,97,112,58,32,37,115,10,0] /* Invalid joystick map */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2102408=allocate([73,110,112,117,116,58,32,68,101,102,97,117,108,116,32,106,111,121,115,116,105,99,107,32,109,97,112,32,61,32,37,115,0] /* Input: Default joyst */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2112409=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2122410=allocate([67,97,110,32,111,110,108,121,32,99,97,108,108,32,105,110,112,117,116,95,100,101,118,105,99,101,58,58,97,100,100,95,105,116,101,109,32,97,116,32,105,110,105,116,32,116,105,109,101,33,0] /* Can only call input_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2132411=allocate([115,114,99,47,101,109,117,47,105,110,112,117,116,46,99,0] /* src/emu/input.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2142412=allocate([105,110,112,117,116,95,99,108,97,115,115,58,58,102,114,97,109,101,95,99,97,108,108,98,97,99,107,0] /* input_class::frame_c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2152413=allocate([67,97,110,32,111,110,108,121,32,99,97,108,108,32,105,110,112,117,116,95,99,108,97,115,115,58,58,97,100,100,95,100,101,118,105,99,101,32,97,116,32,105,110,105,116,32,116,105,109,101,33,0] /* Can only call input_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2162414=allocate([73,110,112,117,116,58,32,65,100,100,105,110,103,32,37,115,32,35,37,100,58,32,37,115,10,0] /* Input: Adding %s #%d */, "i8", ALLOC_STATIC);
__ZL21devclass_string_table=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str2172415=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
__str2182416=allocate(1, "i8", ALLOC_STATIC);
__ZL21modifier_string_table=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str2192417=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
__ZL20devclass_token_table=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str2202418=allocate([85,78,75,78,79,87,78,0] /* UNKNOWN\00 */, "i8", ALLOC_STATIC);
__ZL20modifier_token_table=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL21itemclass_token_table=allocate([1, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str2212419=allocate([95,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2222420=allocate([78,111,110,101,0] /* None\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2232421=allocate([110,47,97,0] /* n/a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2242422=allocate([111,114,0] /* or\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2252423=allocate([110,111,116,0] /* not\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2262424=allocate([79,82,0] /* OR\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2272425=allocate([78,79,84,0] /* NOT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2282426=allocate([68,69,70,65,85,76,84,0] /* DEFAULT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2292427=allocate([73,110,112,117,116,58,32,67,104,97,110,103,105,110,103,32,100,101,102,97,117,108,116,32,106,111,121,115,116,105,99,107,32,109,97,112,32,61,32,37,115,0] /* Input: Changing defa */, "i8", ALLOC_STATIC);
__ZTV17input_device_item=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5420, 0, 0, 0, 5422, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV24input_device_switch_item=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5424, 0, 0, 0, 5426, 0, 0, 0, 5428, 0, 0, 0, 5430, 0, 0, 0, 5432, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV26input_device_relative_item=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5434, 0, 0, 0, 5436, 0, 0, 0, 5438, 0, 0, 0, 5440, 0, 0, 0, 5442, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV26input_device_absolute_item=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5444, 0, 0, 0, 5446, 0, 0, 0, 5448, 0, 0, 0, 5450, 0, 0, 0, 5452, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS24input_device_switch_item=allocate([50,52,105,110,112,117,116,95,100,101,118,105,99,101,95,115,119,105,116,99,104,95,105,116,101,109,0] /* 24input_device_switc */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS17input_device_item=allocate([49,55,105,110,112,117,116,95,100,101,118,105,99,101,95,105,116,101,109,0] /* 17input_device_item\ */, "i8", ALLOC_STATIC);
__ZTI17input_device_item=allocate(8, "*", ALLOC_STATIC);
__ZTI24input_device_switch_item=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS26input_device_relative_item=allocate([50,54,105,110,112,117,116,95,100,101,118,105,99,101,95,114,101,108,97,116,105,118,101,95,105,116,101,109,0] /* 26input_device_relat */, "i8", ALLOC_STATIC);
__ZTI26input_device_relative_item=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS26input_device_absolute_item=allocate([50,54,105,110,112,117,116,95,100,101,118,105,99,101,95,97,98,115,111,108,117,116,101,95,105,116,101,109,0] /* 26input_device_absol */, "i8", ALLOC_STATIC);
__ZTI26input_device_absolute_item=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12input_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5454, 0, 0, 0, 5456, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12input_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,105,110,112,117,116,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12input_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS11input_class=allocate([49,49,105,110,112,117,116,95,99,108,97,115,115,0] /* 11input_class\00 */, "i8", ALLOC_STATIC);
__ZTI11input_class=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI26input_device_absolute_itemE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5458, 0, 0, 0, 5460, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI26input_device_absolute_itemE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,54,105,110,112,117,116,95,100,101,118,105,99,101,95,97,98,115,111,108,117,116,101,95,105,116,101,109,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI26input_device_absolute_itemE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI26input_device_relative_itemE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5462, 0, 0, 0, 5464, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI26input_device_relative_itemE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,54,105,110,112,117,116,95,100,101,118,105,99,101,95,114,101,108,97,116,105,118,101,95,105,116,101,109,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI26input_device_relative_itemE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI24input_device_switch_itemE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5466, 0, 0, 0, 5468, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI24input_device_switch_itemE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,52,105,110,112,117,116,95,100,101,118,105,99,101,95,115,119,105,116,99,104,95,105,116,101,109,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI24input_device_switch_itemE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str2302428=allocate([83,87,73,84,67,72,0] /* SWITCH\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2312429=allocate([65,66,83,79,76,85,84,69,0] /* ABSOLUTE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2322430=allocate([82,69,76,65,84,73,86,69,0] /* RELATIVE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2332431=allocate([80,79,83,0] /* POS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2342432=allocate([78,69,71,0] /* NEG\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2352433=allocate([75,69,89,67,79,68,69,0] /* KEYCODE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2362434=allocate([77,79,85,83,69,67,79,68,69,0] /* MOUSECODE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2372435=allocate([71,85,78,67,79,68,69,0] /* GUNCODE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2382436=allocate([74,79,89,67,79,68,69,0] /* JOYCODE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2392437=allocate([85,78,75,67,79,68,69,0] /* UNKCODE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2402438=allocate([43,0] /* +\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2412439=allocate([45,0] /* -\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2422440=allocate([76,101,102,116,0] /* Left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2432441=allocate([82,105,103,104,116,0] /* Right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2442442=allocate([85,112,0] /* Up\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2452443=allocate([68,111,119,110,0] /* Down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2462444=allocate([108,105,103,104,116,103,117,110,0] /* lightgun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2472445=allocate([106,111,121,115,116,105,99,107,0] /* joystick\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2482446=allocate([109,117,108,116,105,109,111,117,115,101,0] /* multimouse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2492447=allocate([109,111,117,115,101,0] /* mouse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2502448=allocate([109,117,108,116,105,107,101,121,98,111,97,114,100,0] /* multikeyboard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2512449=allocate([75,98,100,0] /* Kbd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2522450=allocate([77,111,117,115,101,0] /* Mouse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2532451=allocate([71,117,110,0] /* Gun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2542452=allocate([74,111,121,0] /* Joy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2552453=allocate([85,110,107,0] /* Unk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2572455=allocate([111,102,102,115,99,114,101,101,110,95,114,101,108,111,97,100,0] /* offscreen_reload\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2582456=allocate([115,116,101,97,100,121,107,101,121,0] /* steadykey\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2592457=allocate([106,111,121,115,116,105,99,107,95,115,97,116,117,114,97,116,105,111,110,0] /* joystick_saturation\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2602458=allocate([106,111,121,115,116,105,99,107,95,100,101,97,100,122,111,110,101,0] /* joystick_deadzone\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2488=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,101,98,117,103,99,112,117,46,99,0] /* src/emu/debug/debugc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12489=allocate([119,112,97,100,100,114,0] /* wpaddr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22490=allocate([119,112,100,97,116,97,0] /* wpdata\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32491=allocate([99,112,117,110,117,109,0] /* cpunum\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42492=allocate([98,101,97,109,120,0] /* beamx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52493=allocate([98,101,97,109,121,0] /* beamy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62494=allocate([102,114,97,109,101,0] /* frame\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72495=allocate([116,101,109,112,37,100,0] /* temp%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82496=allocate([111,110,95,118,98,108,97,110,107,0] /* on_vblank\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92497=allocate([100,101,98,117,103,95,99,112,117,95,101,120,105,116,0] /* debug_cpu_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102498=allocate([114,0] /* r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112499=allocate([67,97,110,110,111,116,32,111,112,101,110,32,99,111,109,109,97,110,100,32,102,105,108,101,32,39,37,115,39,10,0] /* Cannot open command  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122500=allocate([67,97,110,110,111,116,32,111,112,101,110,32,99,111,109,109,97,110,100,32,102,105,108,101,32,39,37,115,39,0] /* Cannot open command  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132501=allocate([109,97,109,101,99,111,109,109,101,110,116,102,105,108,101,0] /* mamecommentfile\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142502=allocate([118,101,114,115,105,111,110,0] /* version\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152503=allocate([115,121,115,116,101,109,0] /* system\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162504=allocate([110,97,109,101,0] /* name\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172505=allocate([99,112,117,0] /* cpu\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182506=allocate([116,97,103,0] /* tag\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192507=allocate([46,99,109,116,0] /* .cmt\00 */, "i8", ALLOC_STATIC);
__str202508=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str212509=allocate([100,101,98,117,103,95,114,101,97,100,95,111,112,99,111,100,101,58,32,117,110,107,110,111,119,110,32,116,121,112,101,32,61,32,37,100,0] /* debug_read_opcode: u */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222510=allocate([99,121,99,108,101,115,0] /* cycles\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232511=allocate([108,111,103,117,110,109,97,112,0] /* logunmap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242512=allocate([108,111,103,117,110,109,97,112,100,0] /* logunmapd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252513=allocate([108,111,103,117,110,109,97,112,105,0] /* logunmapi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262514=allocate([99,117,114,112,99,0] /* curpc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272515=allocate([83,116,111,112,112,101,100,32,97,116,32,86,66,76,65,78,75,10,0] /* Stopped at VBLANK\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282516=allocate([85,115,101,114,45,105,110,105,116,105,97,116,101,100,32,98,114,101,97,107,10,0] /* User-initiated break */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292517=allocate([83,116,111,112,112,101,100,32,111,110,32,105,110,116,101,114,114,117,112,116,32,40,67,80,85,32,39,37,115,39,44,32,73,82,81,32,37,100,41,10,0] /* Stopped on interrupt */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312519=allocate([83,116,111,112,112,101,100,32,97,116,32,116,105,109,101,32,105,110,116,101,114,118,97,108,32,37,46,49,103,10,0] /* Stopped at time inte */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322520=allocate([83,116,111,112,112,101,100,32,97,116,32,116,101,109,112,111,114,97,114,121,32,98,114,101,97,107,112,111,105,110,116,32,37,88,32,111,110,32,67,80,85,32,39,37,115,39,10,0] /* Stopped at temporary */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332521=allocate([99,111,109,109,101,110,116,0] /* comment\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342522=allocate([97,100,100,114,101,115,115,0] /* address\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str352523=allocate([99,111,108,111,114,0] /* color\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362524=allocate([37,48,56,88,0] /* %08X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str372525=allocate([99,114,99,0] /* crc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402528=allocate([83,116,111,112,112,101,100,32,97,116,32,98,114,101,97,107,112,111,105,110,116,32,37,88,10,0] /* Stopped at breakpoin */, "i8", ALLOC_STATIC);
__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes=allocate(36, "*", ALLOC_STATIC);
STRING_TABLE.__str412529=allocate([48,98,121,116,101,115,0] /* 0bytes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422530=allocate([98,121,116,101,0] /* byte\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432531=allocate([119,111,114,100,0] /* word\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442532=allocate([51,98,121,116,101,115,0] /* 3bytes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452533=allocate([100,119,111,114,100,0] /* dword\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str462534=allocate([53,98,121,116,101,115,0] /* 5bytes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str472535=allocate([54,98,121,116,101,115,0] /* 6bytes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str482536=allocate([55,98,121,116,101,115,0] /* 7bytes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str492537=allocate([113,119,111,114,100,0] /* qword\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str502538=allocate([83,116,111,112,112,101,100,32,97,116,32,119,97,116,99,104,112,111,105,110,116,32,37,88,32,119,114,105,116,105,110,103,32,37,115,32,116,111,32,37,48,56,88,32,40,80,67,61,37,88,41,0] /* Stopped at watchpoin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str512539=allocate([32,40,100,97,116,97,61,37,88,37,48,56,88,41,0] /*  (data=%X%08X)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str522540=allocate([32,40,100,97,116,97,61,37,88,41,0] /*  (data=%X)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str532541=allocate([83,116,111,112,112,101,100,32,97,116,32,119,97,116,99,104,112,111,105,110,116,32,37,88,32,114,101,97,100,105,110,103,32,37,115,32,102,114,111,109,32,37,48,56,88,32,40,80,67,61,37,88,41,0] /* Stopped at watchpoin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str542542=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str552543=allocate([72,111,116,115,112,111,116,32,64,32,37,115,32,37,48,56,88,32,40,80,67,61,37,48,56,88,41,32,104,105,116,32,37,100,32,116,105,109,101,115,32,40,102,101,108,108,32,111,102,102,32,98,111,116,116,111,109,41,10,0] /* Hotspot @ %s %08X (P */, "i8", ALLOC_STATIC);
STRING_TABLE.__str562544=allocate([49,0] /* 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS16expression_error=allocate([49,54,101,120,112,114,101,115,115,105,111,110,95,101,114,114,111,114,0] /* 16expression_error\0 */, "i8", ALLOC_STATIC);
__ZTI16expression_error=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str572545=allocate([10,32,32,32,40,108,111,111,112,115,32,102,111,114,32,37,100,32,105,110,115,116,114,117,99,116,105,111,110,115,41,10,10,0] /* \0A   (loops for %d  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str582546=allocate([37,48,42,88,58,32,0] /* %0_X: \00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12device_debug6tracerEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5470, 0, 0, 0, 5472, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug6tracerEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,100,101,118,105,99,101,95,100,101,98,117,103,54,116,114,97,99,101,114,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12device_debug6tracerEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12device_debug12dasm_commentEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5474, 0, 0, 0, 5476, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug12dasm_commentEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,100,101,118,105,99,101,95,100,101,98,117,103,49,50,100,97,115,109,95,99,111,109,109,101,110,116,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12device_debug12dasm_commentEE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIN12device_debug13hotspot_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5478, 0, 0, 0, 5480, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIN12device_debug13hotspot_entryEE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,78,49,50,100,101,118,105,99,101,95,100,101,98,117,103,49,51,104,111,116,115,112,111,116,95,101,110,116,114,121,69,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIN12device_debug13hotspot_entryEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12device_debug10watchpointEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5482, 0, 0, 0, 5484, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug10watchpointEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,100,101,118,105,99,101,95,100,101,98,117,103,49,48,119,97,116,99,104,112,111,105,110,116,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12device_debug10watchpointEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12device_debug10breakpointEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5486, 0, 0, 0, 5488, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug10breakpointEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,100,101,118,105,99,101,95,100,101,98,117,103,49,48,98,114,101,97,107,112,111,105,110,116,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12device_debug10breakpointEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN12device_debug12dasm_commentEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5490, 0, 0, 0, 5492, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN12device_debug12dasm_commentEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,50,100,101,118,105,99,101,95,100,101,98,117,103,49,50,100,97,115,109,95,99,111,109,109,101,110,116,69,69,0] /* 11simple_listIN12dev */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN12device_debug12dasm_commentEE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12symbol_tableE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5494, 0, 0, 0, 5496, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12symbol_tableE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,115,121,109,98,111,108,95,116,97,98,108,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12symbol_tableE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI17_debugcpu_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5498, 0, 0, 0, 5500, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17_debugcpu_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,95,100,101,98,117,103,99,112,117,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17_debugcpu_privateE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN17parsed_expression11parse_tokenEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5502, 0, 0, 0, 5504, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN17parsed_expression11parse_tokenEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,55,112,97,114,115,101,100,95,101,120,112,114,101,115,115,105,111,110,49,49,112,97,114,115,101,95,116,111,107,101,110,69,69,0] /* 11simple_listIN17par */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN17parsed_expression11parse_tokenEE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listIN17parsed_expression17expression_stringEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5506, 0, 0, 0, 5508, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN17parsed_expression17expression_stringEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,55,112,97,114,115,101,100,95,101,120,112,114,101,115,115,105,111,110,49,55,101,120,112,114,101,115,115,105,111,110,95,115,116,114,105,110,103,69,69,0] /* 11simple_listIN17par */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN17parsed_expression17expression_stringEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str592547=allocate([47,47,0] /* //\00 */, "i8", ALLOC_STATIC);
__ZTV11simple_listI12symbol_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5510, 0, 0, 0, 5512, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI12symbol_entryE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,50,115,121,109,98,111,108,95,101,110,116,114,121,69,0] /* 11simple_listI12symb */, "i8", ALLOC_STATIC);
__ZTI11simple_listI12symbol_entryE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str602548=allocate([99,111,109,109,101,110,116,95,100,105,114,101,99,116,111,114,121,0] /* comment_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZN12save_manager11s_magic_numE=allocate([77,69,83,83,83,65,86,69] /* MESSSAVE */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2559=allocate([65,116,116,101,109,112,116,32,116,111,32,114,101,103,105,115,116,101,114,32,99,97,108,108,98,97,99,107,32,102,117,110,99,116,105,111,110,32,97,102,116,101,114,32,115,116,97,116,101,32,114,101,103,105,115,116,114,97,116,105,111,110,32,105,115,32,99,108,111,115,101,100,33,0] /* Attempt to register  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12560=allocate([68,117,112,108,105,99,97,116,101,32,115,97,118,101,32,115,116,97,116,101,32,102,117,110,99,116,105,111,110,32,40,37,115,47,37,115,41,0] /* Duplicate save state */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22561=allocate([115,114,99,47,101,109,117,47,115,97,118,101,46,99,0] /* src/emu/save.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32562=allocate([65,116,116,101,109,112,116,32,116,111,32,114,101,103,105,115,116,101,114,32,115,97,118,101,32,115,116,97,116,101,32,101,110,116,114,121,32,97,102,116,101,114,32,115,116,97,116,101,32,114,101,103,105,115,116,114,97,116,105,111,110,32,105,115,32,99,108,111,115,101,100,33,10,77,111,100,117,108,101,32,37,115,32,116,97,103,32,37,115,32,110,97,109,101,32,37,115,10,0] /* Attempt to register  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42563=allocate([37,115,47,37,115,47,37,88,47,37,115,0] /* %s/%s/%X/%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52564=allocate([37,115,47,37,88,47,37,115,0] /* %s/%X/%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62565=allocate([68,117,112,108,105,99,97,116,101,32,115,97,118,101,32,115,116,97,116,101,32,114,101,103,105,115,116,114,97,116,105,111,110,32,101,110,116,114,121,32,40,37,115,41,0] /* Duplicate save state */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92568=allocate([69,114,114,111,114,58,32,0] /* Error: \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102569=allocate([37,115,84,104,105,115,32,105,115,32,110,111,116,32,97,32,77,69,83,83,32,115,97,118,101,32,102,105,108,101,0] /* %sThis is not a MESS */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112570=allocate([37,115,87,114,111,110,103,32,118,101,114,115,105,111,110,32,105,110,32,115,97,118,101,32,102,105,108,101,32,40,118,101,114,115,105,111,110,32,37,100,44,32,101,120,112,101,99,116,101,100,32,37,100,41,0] /* %sWrong version in s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122571=allocate([37,115,39,70,105,108,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,97,118,101,115,116,97,116,101,32,102,105,108,101,32,102,111,114,32,103,97,109,101,32,39,37,115,39,46,0] /* %s'File is not a val */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132572=allocate([37,115,73,110,99,111,109,112,97,116,105,98,108,101,32,115,97,118,101,32,102,105,108,101,32,40,115,105,103,110,97,116,117,114,101,32,37,48,56,120,44,32,101,120,112,101,99,116,101,100,32,37,48,56,120,41,0] /* %sIncompatible save  */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12save_manager11state_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5514, 0, 0, 0, 5516, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12save_manager11state_entryEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,115,97,118,101,95,109,97,110,97,103,101,114,49,49,115,116,97,116,101,95,101,110,116,114,121,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12save_manager11state_entryEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12save_manager14state_callbackEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5518, 0, 0, 0, 5520, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12save_manager14state_callbackEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,115,97,118,101,95,109,97,110,97,103,101,114,49,52,115,116,97,116,101,95,99,97,108,108,98,97,99,107,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12save_manager14state_callbackEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN12save_manager14state_callbackEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5522, 0, 0, 0, 5524, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN12save_manager14state_callbackEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,50,115,97,118,101,95,109,97,110,97,103,101,114,49,52,115,116,97,116,101,95,99,97,108,108,98,97,99,107,69,69,0] /* 11simple_listIN12sav */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN12save_manager14state_callbackEE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listIN12save_manager11state_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5526, 0, 0, 0, 5528, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN12save_manager11state_entryEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,50,115,97,118,101,95,109,97,110,97,103,101,114,49,49,115,116,97,116,101,95,101,110,116,114,121,69,69,0] /* 11simple_listIN12sav */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN12save_manager11state_entryEE=allocate(8, "*", ALLOC_STATIC);
__ZL19giant_string_buffer=allocate(65536, "i8", ALLOC_STATIC);
STRING_TABLE.__str2579=allocate([114,111,111,116,0] /* root\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12580=allocate([77,97,99,104,105,110,101,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,109,105,115,115,105,110,103,32,100,114,105,118,101,114,95,100,101,118,105,99,101,0] /* Machine configuratio */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22581=allocate([39,37,115,39,32,40,37,115,41,0] /* '%s' (%s)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32582=allocate([40,110,111,32,99,111,110,116,101,120,116,41,0] /* (no context)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42583=allocate([115,114,99,47,101,109,117,47,109,97,99,104,105,110,101,46,99,0] /* src/emu/machine.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52584=allocate([114,117,110,110,105,110,103,95,109,97,99,104,105,110,101,58,58,115,111,102,116,95,114,101,115,101,116,0] /* running_machine::sof */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62585=allocate([73,110,105,116,105,97,108,105,122,105,110,103,46,46,46,0] /* Initializing...\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72586=allocate([97,117,116,111,0] /* auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82587=allocate([101,114,114,111,114,46,108,111,103,0] /* error.log\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92588=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102589=allocate([117,110,97,98,108,101,32,116,111,32,111,112,101,110,32,108,111,103,32,102,105,108,101,0] /* unable to open log f */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112590=allocate([79,117,116,32,111,102,32,109,101,109,111,114,121,33,10,0] /* Out of memory!\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122591=allocate([67,97,117,103,104,116,32,117,110,104,97,110,100,108,101,100,32,101,109,117,108,97,116,111,114,32,101,120,99,101,112,116,105,111,110,10,0] /* Caught unhandled emu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132592=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
__str142593=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str152594=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162595=allocate([46,115,116,97,0] /* .sta\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172596=allocate([114,101,103,105,111,110,95,97,108,108,111,99,32,99,97,108,108,101,100,32,119,105,116,104,32,100,117,112,108,105,99,97,116,101,32,114,101,103,105,111,110,32,110,97,109,101,32,34,37,115,34,10,0] /* region_alloc called  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182597=allocate([67,97,110,32,111,110,108,121,32,99,97,108,108,32,97,100,100,95,110,111,116,105,102,105,101,114,32,97,116,32,105,110,105,116,32,116,105,109,101,33,0] /* Can only call add_no */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192598=allocate([67,97,110,32,111,110,108,121,32,99,97,108,108,32,97,100,100,95,108,111,103,101,114,114,111,114,95,99,97,108,108,98,97,99,107,32,97,116,32,105,110,105,116,32,116,105,109,101,33,0] /* Can only call add_lo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202599=allocate([108,111,97,100,101,100,0] /* loaded\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212600=allocate([115,97,118,101,100,0] /* saved\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222601=allocate([108,111,97,100,0] /* load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232602=allocate([115,97,118,101,0] /* save\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242603=allocate([85,110,97,98,108,101,32,116,111,32,37,115,32,100,117,101,32,116,111,32,112,101,110,100,105,110,103,32,97,110,111,110,121,109,111,117,115,32,116,105,109,101,114,115,46,32,83,101,101,32,101,114,114,111,114,46,108,111,103,32,102,111,114,32,100,101,116,97,105,108,115,46,0] /* Unable to %s due to  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252604=allocate([69,114,114,111,114,58,32,85,110,97,98,108,101,32,116,111,32,37,115,32,115,116,97,116,101,32,100,117,101,32,116,111,32,105,108,108,101,103,97,108,32,114,101,103,105,115,116,114,97,116,105,111,110,115,46,32,83,101,101,32,101,114,114,111,114,46,108,111,103,32,102,111,114,32,100,101,116,97,105,108,115,46,0] /* Error: Unable to %s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262605=allocate([69,114,114,111,114,58,32,85,110,97,98,108,101,32,116,111,32,37,115,32,115,116,97,116,101,32,100,117,101,32,116,111,32,97,110,32,105,110,118,97,108,105,100,32,104,101,97,100,101,114,46,32,77,97,107,101,32,115,117,114,101,32,116,104,101,32,115,97,118,101,32,115,116,97,116,101,32,105,115,32,99,111,114,114,101,99,116,32,102,111,114,32,116,104,105,115,32,103,97,109,101,46,0] /* Error: Unable to %s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272606=allocate([69,114,114,111,114,58,32,85,110,97,98,108,101,32,116,111,32,37,115,32,115,116,97,116,101,32,100,117,101,32,116,111,32,97,32,114,101,97,100,32,101,114,114,111,114,32,40,102,105,108,101,32,105,115,32,108,105,107,101,108,121,32,99,111,114,114,117,112,116,41,46,0] /* Error: Unable to %s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282607=allocate([69,114,114,111,114,58,32,85,110,97,98,108,101,32,116,111,32,37,115,32,115,116,97,116,101,32,100,117,101,32,116,111,32,97,32,119,114,105,116,101,32,101,114,114,111,114,46,32,86,101,114,105,102,121,32,116,104,101,114,101,32,105,115,32,101,110,111,117,103,104,32,100,105,115,107,32,115,112,97,99,101,46,0] /* Error: Unable to %s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292608=allocate([83,116,97,116,101,32,115,117,99,99,101,115,115,102,117,108,108,121,32,37,115,46,10,87,97,114,110,105,110,103,58,32,83,97,118,101,32,115,116,97,116,101,115,32,97,114,101,32,110,111,116,32,111,102,102,105,99,105,97,108,108,121,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,116,104,105,115,32,103,97,109,101,46,0] /* State successfully % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str302609=allocate([83,116,97,116,101,32,115,117,99,99,101,115,115,102,117,108,108,121,32,37,115,46,0] /* State successfully % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312610=allocate([69,114,114,111,114,58,32,85,110,107,110,111,119,110,32,101,114,114,111,114,32,100,117,114,105,110,103,32,115,116,97,116,101,32,37,115,46,0] /* Error: Unknown error */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322611=allocate([69,114,114,111,114,58,32,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,102,111,114,32,37,115,32,111,112,101,114,97,116,105,111,110,46,0] /* Error: Failed to ope */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332612=allocate([83,111,102,116,32,114,101,115,101,116,10,0] /* Soft reset\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342613=allocate([68,114,105,118,101,114,32,68,101,118,105,99,101,0] /* Driver Device\00 */, "i8", ALLOC_STATIC);
__ZTV13driver_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5530, 0, 0, 0, 5532, 0, 0, 0, 1726, 0, 0, 0, 1728, 0, 0, 0, 1730, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1736, 0, 0, 0, 1738, 0, 0, 0, 1740, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 1752, 0, 0, 0, 1754, 0, 0, 0, 1756, 0, 0, 0, 5534, 0, 0, 0, 1760, 0, 0, 0, 1762, 0, 0, 0, 1764, 0, 0, 0, 5536, 0, 0, 0, 1768, 0, 0, 0, 1770, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str352614=allocate([59,0] /* ;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362615=allocate([112,114,111,109,115,0] /* proms\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13driver_device=allocate([49,51,100,114,105,118,101,114,95,100,101,118,105,99,101,0] /* 13driver_device\00 */, "i8", ALLOC_STATIC);
__ZTI13driver_device=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN15running_machine22logerror_callback_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5538, 0, 0, 0, 5540, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN15running_machine22logerror_callback_itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,53,114,117,110,110,105,110,103,95,109,97,99,104,105,110,101,50,50,108,111,103,101,114,114,111,114,95,99,97,108,108,98,97,99,107,95,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN15running_machine22logerror_callback_itemEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN15running_machine22notifier_callback_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5542, 0, 0, 0, 5544, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN15running_machine22notifier_callback_itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,53,114,117,110,110,105,110,103,95,109,97,99,104,105,110,101,50,50,110,111,116,105,102,105,101,114,95,99,97,108,108,98,97,99,107,95,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN15running_machine22notifier_callback_itemEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13memory_regionE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5546, 0, 0, 0, 5548, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13memory_regionE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,109,101,109,111,114,121,95,114,101,103,105,111,110,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13memory_regionE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str372618=allocate([69,114,114,111,114,32,97,100,100,105,110,103,32,111,98,106,101,99,116,32,110,97,109,101,100,32,39,37,115,39,0] /* Error adding object  */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI13cheat_managerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5550, 0, 0, 0, 5552, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13cheat_managerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,99,104,101,97,116,95,109,97,110,97,103,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13cheat_managerE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI11cheat_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5554, 0, 0, 0, 5556, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI11cheat_entryE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,49,99,104,101,97,116,95,101,110,116,114,121,69,0] /* 11simple_listI11chea */, "i8", ALLOC_STATIC);
__ZTI11simple_listI11cheat_entryE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13sound_managerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5558, 0, 0, 0, 5560, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13sound_managerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,115,111,117,110,100,95,109,97,110,97,103,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13sound_managerE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13video_managerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5562, 0, 0, 0, 5564, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13video_managerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,118,105,100,101,111,95,109,97,110,97,103,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13video_managerE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI14render_managerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5566, 0, 0, 0, 5568, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14render_managerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,114,101,110,100,101,114,95,109,97,110,97,103,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14render_managerE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13input_managerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5570, 0, 0, 0, 5572, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13input_managerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,105,110,112,117,116,95,109,97,110,97,103,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13input_managerE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN15running_machine22logerror_callback_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5574, 0, 0, 0, 5576, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN15running_machine22logerror_callback_itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,53,114,117,110,110,105,110,103,95,109,97,99,104,105,110,101,50,50,108,111,103,101,114,114,111,114,95,99,97,108,108,98,97,99,107,95,105,116,101,109,69,69,0] /* 11simple_listIN15run */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN15running_machine22logerror_callback_itemEE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listIN15running_machine22notifier_callback_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5578, 0, 0, 0, 5580, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN15running_machine22notifier_callback_itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,53,114,117,110,110,105,110,103,95,109,97,99,104,105,110,101,50,50,110,111,116,105,102,105,101,114,95,99,97,108,108,98,97,99,107,95,105,116,101,109,69,69,0] /* 11simple_listIN15run */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN15running_machine22notifier_callback_itemEE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI17input_port_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5582, 0, 0, 0, 5584, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI17input_port_configE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,55,105,110,112,117,116,95,112,111,114,116,95,99,111,110,102,105,103,69,0] /* 11simple_listI17inpu */, "i8", ALLOC_STATIC);
__ZTI11simple_listI17input_port_configE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI13memory_regionE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5586, 0, 0, 0, 5588, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI13memory_regionE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,51,109,101,109,111,114,121,95,114,101,103,105,111,110,69,0] /* 11simple_listI13memo */, "i8", ALLOC_STATIC);
__ZTI11simple_listI13memory_regionE=allocate(8, "*", ALLOC_STATIC);
__ZTV27device_missing_dependencies=allocate([0, 0, 0, 0, 0, 0, 0, 0, 232, 0, 0, 0, 5590, 0, 0, 0, 1774, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str382619=allocate([115,116,97,116,101,95,100,105,114,101,99,116,111,114,121,0] /* state_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str392620=allocate([108,111,103,0] /* log\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412622=allocate([97,117,116,111,115,97,118,101,0] /* autosave\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422623=allocate([115,116,97,116,101,0] /* state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432624=allocate([100,101,98,117,103,95,105,110,116,101,114,110,97,108,0] /* debug_internal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442625=allocate([100,101,98,117,103,0] /* debug\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452626=allocate([115,97,109,112,108,101,114,97,116,101,0] /* samplerate\00 */, "i8", ALLOC_STATIC);
__ZTV13osd_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5592, 0, 0, 0, 5594, 0, 0, 0, 5596, 0, 0, 0, 5598, 0, 0, 0, 1802, 0, 0, 0, 1804, 0, 0, 0, 5600, 0, 0, 0, 5602, 0, 0, 0, 5604, 0, 0, 0, 1812, 0, 0, 0, 1814, 0, 0, 0, 1816, 0, 0, 0, 1818, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS13osd_interface=allocate([49,51,111,115,100,95,105,110,116,101,114,102,97,99,101,0] /* 13osd_interface\00 */, "i8", ALLOC_STATIC);
__ZTI13osd_interface=allocate(8, "*", ALLOC_STATIC);
__ZZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePvE5color=allocate([1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0], ["float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str2705=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12706=allocate([84,111,111,32,109,97,110,121,32,108,105,118,101,32,116,101,120,116,117,114,101,32,105,110,115,116,97,110,99,101,115,33,0] /* Too many live textur */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22707=allocate([115,114,99,47,101,109,117,47,114,101,110,100,101,114,46,99,0] /* src/emu/render.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32708=allocate([97,117,116,111,0] /* auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42709=allocate([77,97,110,100,97,116,111,114,121,32,97,114,116,119,111,114,107,32,105,115,32,109,105,115,115,105,110,103,0] /* Mandatory artwork is */, "i8", ALLOC_STATIC);
__ZZN13render_target20compute_minimum_sizeERiS0_E9vectorvis=allocate([0, 0, 0, 0, 639, 0, 0, 0, 0, 0, 0, 0, 479, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str52710=allocate([100,101,102,97,117,108,116,0] /* default\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62711=allocate([67,111,117,108,100,110,39,116,32,112,97,114,115,101,32,100,101,102,97,117,108,116,32,108,97,121,111,117,116,63,63,0] /* Couldn't parse defau */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72712=allocate([46,108,97,121,0] /* .lay\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82713=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92714=allocate([73,109,112,114,111,112,101,114,108,121,32,102,111,114,109,97,116,116,101,100,32,88,77,76,32,102,105,108,101,32,39,37,115,39,44,32,105,103,110,111,114,110,105,110,103,10,0] /* Improperly formatted */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102715=allocate([73,109,112,114,111,112,101,114,108,121,32,102,111,114,109,97,116,116,101,100,32,88,77,76,32,115,116,114,105,110,103,44,32,105,103,110,111,114,110,105,110,103,0] /* Improperly formatted */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112716=allocate([69,114,114,111,114,32,105,110,32,88,77,76,32,102,105,108,101,32,39,37,115,39,58,32,37,115,10,0] /* Error in XML file '% */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122717=allocate([69,114,114,111,114,32,105,110,32,88,77,76,32,115,116,114,105,110,103,58,32,37,115,0] /* Error in XML string: */, "i8", ALLOC_STATIC);
__ZL18oriented_texcoords=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str132718=allocate([118,105,101,119,0] /* view\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142719=allocate([98,97,99,107,100,114,111,112,115,0] /* backdrops\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152720=allocate([111,118,101,114,108,97,121,115,0] /* overlays\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162721=allocate([98,101,122,101,108,115,0] /* bezels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172722=allocate([99,112,97,110,101,108,115,0] /* cpanels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182723=allocate([109,97,114,113,117,101,101,115,0] /* marquees\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192724=allocate([122,111,111,109,0] /* zoom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202725=allocate([114,111,116,97,116,101,0] /* rotate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212726=allocate([105,110,100,101,120,0] /* index\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222727=allocate([82,97,110,32,111,117,116,32,111,102,32,99,108,101,97,114,32,101,120,116,101,110,116,115,33,10,0] /* Ran out of clear ext */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232728=allocate([85,110,101,120,112,101,99,116,101,100,32,112,114,105,109,105,116,105,118,101,32,116,121,112,101,0] /* Unexpected primitive */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242729=allocate([118,105,100,101,111,0] /* video\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252730=allocate([114,101,110,100,101,114,95,109,97,110,97,103,101,114,58,58,99,111,110,102,105,103,95,108,111,97,100,0] /* render_manager::conf */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262731=allocate([114,101,110,100,101,114,95,109,97,110,97,103,101,114,58,58,99,111,110,102,105,103,95,115,97,118,101,0] /* render_manager::conf */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272732=allocate([105,110,116,101,114,102,97,99,101,0] /* interface\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282733=allocate([116,97,114,103,101,116,0] /* target\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292734=allocate([115,99,114,101,101,110,0] /* screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str302735=allocate([98,114,105,103,104,116,110,101,115,115,0] /* brightness\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312736=allocate([99,111,110,116,114,97,115,116,0] /* contrast\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322737=allocate([103,97,109,109,97,0] /* gamma\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332738=allocate([104,111,102,102,115,101,116,0] /* hoffset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342739=allocate([104,115,116,114,101,116,99,104,0] /* hstretch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str352740=allocate([118,111,102,102,115,101,116,0] /* voffset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362741=allocate([118,115,116,114,101,116,99,104,0] /* vstretch\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI11render_fontE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5606, 0, 0, 0, 5608, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11render_fontE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,114,101,110,100,101,114,95,102,111,110,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11render_fontE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI14render_textureE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5610, 0, 0, 0, 5612, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14render_textureE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,114,101,110,100,101,114,95,116,101,120,116,117,114,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14render_textureE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI13render_targetE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5614, 0, 0, 0, 5616, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13render_targetE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,114,101,110,100,101,114,95,116,97,114,103,101,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13render_targetE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS14render_manager=allocate([49,52,114,101,110,100,101,114,95,109,97,110,97,103,101,114,0] /* 14render_manager\00 */, "i8", ALLOC_STATIC);
__ZTI14render_manager=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI13render_targetE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5618, 0, 0, 0, 5620, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI13render_targetE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,51,114,101,110,100,101,114,95,116,97,114,103,101,116,69,0] /* 11simple_listI13rend */, "i8", ALLOC_STATIC);
__ZTI11simple_listI13render_targetE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI16render_containerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5622, 0, 0, 0, 5624, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16render_containerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,114,101,110,100,101,114,95,99,111,110,116,97,105,110,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16render_containerE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI14render_textureE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5626, 0, 0, 0, 5628, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI14render_textureE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,52,114,101,110,100,101,114,95,116,101,120,116,117,114,101,69,0] /* 11simple_listI14rend */, "i8", ALLOC_STATIC);
__ZTI11simple_listI14render_textureE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI11layout_fileE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5630, 0, 0, 0, 5632, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11layout_fileE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,108,97,121,111,117,116,95,102,105,108,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11layout_fileE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI16render_containerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5634, 0, 0, 0, 5636, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI16render_containerE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,54,114,101,110,100,101,114,95,99,111,110,116,97,105,110,101,114,69,0] /* 11simple_listI16rend */, "i8", ALLOC_STATIC);
__ZTI11simple_listI16render_containerE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI11simple_listI11layout_fileEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5638, 0, 0, 0, 5640, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11simple_listI11layout_fileEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,49,108,97,121,111,117,116,95,102,105,108,101,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11simple_listI11layout_fileEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI11layout_fileE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5642, 0, 0, 0, 5644, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI11layout_fileE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,49,108,97,121,111,117,116,95,102,105,108,101,69,0] /* 11simple_listI11layo */, "i8", ALLOC_STATIC);
__ZTI11simple_listI11layout_fileE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN16render_container4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5646, 0, 0, 0, 5648, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN16render_container4itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,54,114,101,110,100,101,114,95,99,111,110,116,97,105,110,101,114,52,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN16render_container4itemEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN16render_container4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5650, 0, 0, 0, 5652, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN16render_container4itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,54,114,101,110,100,101,114,95,99,111,110,116,97,105,110,101,114,52,105,116,101,109,69,69,0] /* 11simple_listIN16ren */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN16render_container4itemEE=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIjE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5654, 0, 0, 0, 5656, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIjE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,106,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIjE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN21render_primitive_list9referenceEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5658, 0, 0, 0, 5660, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN21render_primitive_list9referenceEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,50,49,114,101,110,100,101,114,95,112,114,105,109,105,116,105,118,101,95,108,105,115,116,57,114,101,102,101,114,101,110,99,101,69,69,0] /* 11simple_listIN21ren */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN21render_primitive_list9referenceEE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI16render_primitiveE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5662, 0, 0, 0, 5664, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI16render_primitiveE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,54,114,101,110,100,101,114,95,112,114,105,109,105,116,105,118,101,69,0] /* 11simple_listI16rend */, "i8", ALLOC_STATIC);
__ZTI11simple_listI16render_primitiveE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str372742=allocate([97,114,116,112,97,116,104,0] /* artpath\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI16render_primitiveE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5666, 0, 0, 0, 5668, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16render_primitiveE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,114,101,110,100,101,114,95,112,114,105,109,105,116,105,118,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16render_primitiveE=allocate(12, "*", ALLOC_STATIC);
__ZL20layer_order_standard=allocate([1, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL21layer_order_alternate=allocate([0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str382743=allocate([102,108,105,112,121,0] /* flipy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str392744=allocate([102,108,105,112,120,0] /* flipx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402745=allocate([97,117,116,111,114,111,108,0] /* autorol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412746=allocate([114,111,108,0] /* rol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422747=allocate([97,117,116,111,114,111,114,0] /* autoror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432748=allocate([114,111,114,0] /* ror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442749=allocate([97,114,116,119,111,114,107,95,99,114,111,112,0] /* artwork_crop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452750=allocate([117,115,101,95,109,97,114,113,117,101,101,115,0] /* use_marquees\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str462751=allocate([117,115,101,95,99,112,97,110,101,108,115,0] /* use_cpanels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str472752=allocate([117,115,101,95,98,101,122,101,108,115,0] /* use_bezels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str482753=allocate([117,115,101,95,111,118,101,114,108,97,121,115,0] /* use_overlays\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str492754=allocate([117,115,101,95,98,97,99,107,100,114,111,112,115,0] /* use_backdrops\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectIN21render_primitive_list9referenceEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5670, 0, 0, 0, 5672, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN21render_primitive_list9referenceEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,50,49,114,101,110,100,101,114,95,112,114,105,109,105,116,105,118,101,95,108,105,115,116,57,114,101,102,101,114,101,110,99,101,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN21render_primitive_list9referenceEE=allocate(12, "*", ALLOC_STATIC);
_SCREEN=allocate([5674], ["%class.device_t.4054* (%class.machine_config.4012*, i8*, %class.device_t.4054*, i32)*",0,0,0,0], ALLOC_STATIC);
__ZN13screen_device20DEFAULT_FRAME_PERIODE=allocate(12, ["i32",0,0,0,"i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str2773=allocate([86,105,100,101,111,32,83,99,114,101,101,110,0] /* Video Screen\00 */, "i8", ALLOC_STATIC);
__ZTV13screen_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5676, 0, 0, 0, 5678, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 1732, 0, 0, 0, 5680, 0, 0, 0, 5682, 0, 0, 0, 5684, 0, 0, 0, 5354, 0, 0, 0, 1742, 0, 0, 0, 5686, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str12774=allocate([37,115,58,32,37,115,32,115,99,114,101,101,110,32,39,37,115,39,32,104,97,115,32,105,110,118,97,108,105,100,32,100,105,115,112,108,97,121,32,100,105,109,101,110,115,105,111,110,115,10,0] /* %s: %s screen '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22775=allocate([37,115,58,32,37,115,32,115,99,114,101,101,110,32,39,37,115,39,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,100,105,115,112,108,97,121,32,97,114,101,97,10,0] /* %s: %s screen '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32776=allocate([37,115,58,32,37,115,32,115,99,114,101,101,110,32,39,37,115,39,32,104,97,115,32,117,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,10,0] /* %s: %s screen '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42777=allocate([37,115,58,32,37,115,32,115,99,114,101,101,110,32,39,37,115,39,32,104,97,115,32,97,32,122,101,114,111,32,114,101,102,114,101,115,104,32,114,97,116,101,10,0] /* %s: %s screen '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52778=allocate([115,116,97,116,105,99,95,118,98,108,97,110,107,95,98,101,103,105,110,95,99,97,108,108,98,97,99,107,0] /* static_vblank_begin_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62779=allocate([115,116,97,116,105,99,95,118,98,108,97,110,107,95,101,110,100,95,99,97,108,108,98,97,99,107,0] /* static_vblank_end_ca */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72780=allocate([115,116,97,116,105,99,95,115,99,97,110,108,105,110,101,48,95,99,97,108,108,98,97,99,107,0] /* static_scanline0_cal */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82781=allocate([115,116,97,116,105,99,95,115,99,97,110,108,105,110,101,95,117,112,100,97,116,101,95,99,97,108,108,98,97,99,107,0] /* static_scanline_upda */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92782=allocate([37,100,120,37,100,0] /* %dx%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102783=allocate([115,114,99,47,101,109,117,47,115,99,114,101,101,110,46,99,0] /* src/emu/screen.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112784=allocate([69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,98,117,114,110,45,105,110,32,98,105,116,109,97,112,32,102,111,114,32,115,99,114,101,101,110,32,97,116,32,40,37,100,120,37,100,41,10,0] /* Error allocating bur */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122785=allocate([110,111,110,101,0] /* none\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132786=allocate([109,95,119,105,100,116,104,0] /* m_width\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142787=allocate([109,95,104,101,105,103,104,116,0] /* m_height\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152788=allocate([109,95,118,105,115,97,114,101,97,46,109,105,110,95,120,0] /* m_visarea.min_x\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162789=allocate([109,95,118,105,115,97,114,101,97,46,109,105,110,95,121,0] /* m_visarea.min_y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172790=allocate([109,95,118,105,115,97,114,101,97,46,109,97,120,95,120,0] /* m_visarea.max_x\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182791=allocate([109,95,118,105,115,97,114,101,97,46,109,97,120,95,121,0] /* m_visarea.max_y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192792=allocate([109,95,108,97,115,116,95,112,97,114,116,105,97,108,95,115,99,97,110,0] /* m_last_partial_scan\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202793=allocate([109,95,102,114,97,109,101,95,112,101,114,105,111,100,0] /* m_frame_period\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212794=allocate([109,95,115,99,97,110,116,105,109,101,0] /* m_scantime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222795=allocate([109,95,112,105,120,101,108,116,105,109,101,0] /* m_pixeltime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232796=allocate([109,95,118,98,108,97,110,107,95,112,101,114,105,111,100,0] /* m_vblank_period\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242797=allocate([109,95,118,98,108,97,110,107,95,115,116,97,114,116,95,116,105,109,101,0] /* m_vblank_start_time\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252798=allocate([109,95,118,98,108,97,110,107,95,101,110,100,95,116,105,109,101,0] /* m_vblank_end_time\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262799=allocate([109,95,102,114,97,109,101,95,110,117,109,98,101,114,0] /* m_frame_number\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str272800=allocate([73,110,118,97,108,105,100,32,98,105,116,109,97,112,32,102,111,114,109,97,116,33,0] /* Invalid bitmap forma */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282801=allocate([47,98,117,114,110,105,110,45,0] /* /burnin-\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292802=allocate([46,112,110,103,0] /* .png\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str302803=allocate([77,69,83,83,32,37,115,0] /* MESS %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312804=allocate([83,111,102,116,119,97,114,101,0] /* Software\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322805=allocate([37,115,32,37,115,0] /* %s %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332806=allocate([83,121,115,116,101,109,0] /* System\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342807=allocate([85,110,97,98,108,101,32,116,111,32,108,111,97,100,32,101,102,102,101,99,116,32,80,78,71,32,102,105,108,101,32,39,37,115,39,10,0] /* Unable to load effec */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13screen_device=allocate([49,51,115,99,114,101,101,110,95,100,101,118,105,99,101,0] /* 13screen_device\00 */, "i8", ALLOC_STATIC);
__ZTI13screen_device=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN13screen_device13callback_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5688, 0, 0, 0, 5690, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN13screen_device13callback_itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,51,115,99,114,101,101,110,95,100,101,118,105,99,101,49,51,99,97,108,108,98,97,99,107,95,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN13screen_device13callback_itemEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str352808=allocate([46,97,116,116,111,115,101,99,111,110,100,115,0] /* .attoseconds\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str362809=allocate([46,115,101,99,111,110,100,115,0] /* .seconds\00 */, "i8", ALLOC_STATIC);
__ZTV11simple_listIN13screen_device13callback_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5692, 0, 0, 0, 5694, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN13screen_device13callback_itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,51,115,99,114,101,101,110,95,100,101,118,105,99,101,49,51,99,97,108,108,98,97,99,107,95,105,116,101,109,69,69,0] /* 11simple_listIN13scr */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN13screen_device13callback_itemEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str372810=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,104,0] /* src/emu/devintrf.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI13screen_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5696, 0, 0, 0, 5698, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13screen_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,115,99,114,101,101,110,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13screen_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str392812=allocate([115,110,97,112,115,104,111,116,95,100,105,114,101,99,116,111,114,121,0] /* snapshot_directory\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402813=allocate([101,102,102,101,99,116,0] /* effect\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412814=allocate([115,110,97,112,115,105,122,101,0] /* snapsize\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str422815=allocate([98,117,114,110,105,110,0] /* burnin\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2843=allocate([37,115,47,37,100,0] /* %s/%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12844=allocate([116,105,109,101,114,0] /* timer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str22845=allocate([109,95,112,97,114,97,109,0] /* m_param\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str32846=allocate([109,95,101,110,97,98,108,101,100,0] /* m_enabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str42847=allocate([109,95,112,101,114,105,111,100,0] /* m_period\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str52848=allocate([109,95,115,116,97,114,116,0] /* m_start\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str62849=allocate([109,95,101,120,112,105,114,101,0] /* m_expire\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str72850=allocate([37,112,58,32,101,110,61,37,100,32,116,101,109,112,61,37,100,32,101,120,112,61,37,49,53,115,32,115,116,97,114,116,61,37,49,53,115,32,112,101,114,61,37,49,53,115,32,112,97,114,97,109,61,37,100,32,112,116,114,61,37,112,0] /* %p: en=%d temp=%d ex */, "i8", ALLOC_STATIC);
STRING_TABLE.__str82851=allocate([32,99,98,61,37,115,10,0] /*  cb=%s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92852=allocate([32,100,101,118,61,37,115,32,105,100,61,37,100,10,0] /*  dev=%s id=%d\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102853=allocate([109,95,98,97,115,101,116,105,109,101,0] /* m_basetime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112854=allocate([100,101,118,105,99,101,95,115,99,104,101,100,117,108,101,114,58,58,112,114,101,115,97,118,101,0] /* device_scheduler::pr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122855=allocate([100,101,118,105,99,101,95,115,99,104,101,100,117,108,101,114,58,58,112,111,115,116,108,111,97,100,0] /* device_scheduler::po */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132856=allocate([70,97,105,108,101,100,32,115,97,118,101,32,115,116,97,116,101,32,97,116,116,101,109,112,116,32,100,117,101,32,116,111,32,97,110,111,110,121,109,111,117,115,32,116,105,109,101,114,115,58,10,0] /* Failed save state at */, "i8", ALLOC_STATIC);
STRING_TABLE.__str152858=allocate([80,114,105,111,114,32,116,111,32,115,97,118,105,110,103,32,115,116,97,116,101,58,10,0] /* Prior to saving stat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str162859=allocate([65,102,116,101,114,32,114,101,115,101,116,116,105,110,103,47,114,101,111,114,100,101,114,105,110,103,32,116,105,109,101,114,115,58,10,0] /* After resetting/reor */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172860=allocate([68,101,118,105,99,101,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,112,101,114,102,101,99,116,32,105,110,116,101,114,108,101,97,118,101,32,105,115,32,110,111,116,32,112,114,101,115,101,110,116,33,0] /* Device '%s' specifie */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182861=allocate([68,101,118,105,99,101,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,112,101,114,102,101,99,116,32,105,110,116,101,114,108,101,97,118,101,32,105,115,32,110,111,116,32,97,110,32,101,120,101,99,117,116,105,110,103,32,100,101,118,105,99,101,33,0] /* Device '%s' specifie */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192862=allocate([61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,0] /* ==================== */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202863=allocate([84,105,109,101,114,32,68,117,109,112,58,32,84,105,109,101,32,61,32,37,49,53,115,10,0] /* Timer Dump: Time = % */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectIN16device_scheduler12quantum_slotEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5700, 0, 0, 0, 5702, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN16device_scheduler12quantum_slotEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,54,100,101,118,105,99,101,95,115,99,104,101,100,117,108,101,114,49,50,113,117,97,110,116,117,109,95,115,108,111,116,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN16device_scheduler12quantum_slotEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI9emu_timerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5704, 0, 0, 0, 5706, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI9emu_timerE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,57,101,109,117,95,116,105,109,101,114,69,0] /* 11simple_listI9emu_t */, "i8", ALLOC_STATIC);
__ZTI11simple_listI9emu_timerE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS16device_scheduler=allocate([49,54,100,101,118,105,99,101,95,115,99,104,101,100,117,108,101,114,0] /* 16device_scheduler\0 */, "i8", ALLOC_STATIC);
__ZTI16device_scheduler=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str212864=allocate([103,108,111,98,97,108,0] /* global\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI9emu_timerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5708, 0, 0, 0, 5710, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI9emu_timerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,57,101,109,117,95,116,105,109,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI9emu_timerE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN16device_scheduler12quantum_slotEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5712, 0, 0, 0, 5714, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN16device_scheduler12quantum_slotEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,54,100,101,118,105,99,101,95,115,99,104,101,100,117,108,101,114,49,50,113,117,97,110,116,117,109,95,115,108,111,116,69,69,0] /* 11simple_listIN16dev */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN16device_scheduler12quantum_slotEE=allocate(8, "*", ALLOC_STATIC);
__ZN13address_table18s_watchpoint_tableE=allocate(262144, "i8", ALLOC_STATIC);
STRING_TABLE.__str2891=allocate([115,114,99,47,101,109,117,47,109,101,109,111,114,121,46,99,0] /* src/emu/memory.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str12892=allocate([98,97,110,107,95,114,101,97,116,116,97,99,104,0] /* bank_reattach\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str92900=allocate([10,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,68,101,118,105,99,101,32,39,37,115,39,32,37,115,32,97,100,100,114,101,115,115,32,115,112,97,99,101,32,114,101,97,100,32,104,97,110,100,108,101,114,32,100,117,109,112,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,0] /* \0A\0A============== */, "i8", ALLOC_STATIC);
STRING_TABLE.__str102901=allocate([10,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,68,101,118,105,99,101,32,39,37,115,39,32,37,115,32,97,100,100,114,101,115,115,32,115,112,97,99,101,32,119,114,105,116,101,32,104,97,110,100,108,101,114,32,100,117,109,112,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,0] /* \0A\0A============== */, "i8", ALLOC_STATIC);
__ZTV13address_space=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5716, 0, 0, 0, 5718, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str112902=allocate([73,110,118,97,108,105,100,32,119,105,100,116,104,32,37,100,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,97,100,100,114,101,115,115,95,115,112,97,99,101,58,58,97,108,108,111,99,97,116,101,0] /* Invalid width %d spe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122903=allocate([69,114,114,111,114,58,32,100,101,118,105,99,101,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,109,101,109,111,114,121,32,109,97,112,32,101,110,116,114,121,32,37,88,45,37,88,32,114,101,102,101,114,101,110,99,101,115,32,110,111,110,45,101,120,105,115,116,97,110,116,32,114,101,103,105,111,110,32,34,37,115,34,0] /* Error: device '%s' % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str132904=allocate([69,114,114,111,114,58,32,100,101,118,105,99,101,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,109,101,109,111,114,121,32,109,97,112,32,101,110,116,114,121,32,37,88,45,37,88,32,101,120,116,101,110,100,115,32,98,101,121,111,110,100,32,114,101,103,105,111,110,32,34,37,115,34,32,115,105,122,101,32,40,37,88,41,0] /* Error: device '%s' % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str142905=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,109,97,112,32,97,32,110,111,110,45,101,120,105,115,116,101,110,116,32,100,101,118,105,99,101,32,39,37,115,39,32,105,110,32,115,112,97,99,101,32,37,115,32,111,102,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* Attempted to map a n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str172908=allocate([32,32,65,100,100,114,101,115,115,32,98,105,116,115,32,61,32,37,100,10,0] /*   Address bits = %d\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str182909=allocate([32,32,32,32,32,68,97,116,97,32,98,105,116,115,32,61,32,37,100,10,0] /*      Data bits = %d\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str192910=allocate([32,32,65,100,100,114,101,115,115,32,109,97,115,107,32,61,32,37,88,10,0] /*   Address mask = %X\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str202911=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str212912=allocate([37,48,56,88,45,37,48,56,88,32,32,32,32,61,32,37,48,50,88,58,32,37,115,32,91,111,102,102,115,101,116,61,37,48,56,88,93,10,0] /* %08X-%08X    = %02X: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str222913=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,109,97,112,32,110,111,110,45,101,120,105,115,116,101,110,116,32,112,111,114,116,32,39,37,115,39,32,102,111,114,32,114,101,97,100,32,105,110,32,115,112,97,99,101,32,37,115,32,111,102,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* Attempted to map non */, "i8", ALLOC_STATIC);
STRING_TABLE.__str232914=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,109,97,112,32,110,111,110,45,101,120,105,115,116,101,110,116,32,112,111,114,116,32,39,37,115,39,32,102,111,114,32,119,114,105,116,101,32,105,110,32,115,112,97,99,101,32,37,115,32,111,102,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* Attempted to map non */, "i8", ALLOC_STATIC);
STRING_TABLE.__str242915=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,99,97,108,108,32,105,110,115,116,97,108,108,95,114,97,109,95,103,101,110,101,114,105,99,40,41,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,116,105,109,101,32,119,105,116,104,111,117,116,32,97,32,98,97,115,101,112,116,114,33,0] /* Attempted to call in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str252916=allocate([85,110,97,98,108,101,32,116,111,32,97,108,108,111,99,97,116,101,32,110,101,119,32,98,97,110,107,32,39,37,115,39,0] /* Unable to allocate n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str262917=allocate([85,110,97,98,108,101,32,116,111,32,97,108,108,111,99,97,116,101,32,98,97,110,107,32,102,111,114,32,82,65,77,47,82,79,77,32,97,114,101,97,32,37,88,45,37,88,10,0] /* Unable to allocate b */, "i8", ALLOC_STATIC);
__ZTV13address_table=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5720, 0, 0, 0, 5722, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str272918=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str282919=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,58,58,109,97,112,95,114,97,110,103,101,32,99,97,108,108,101,100,32,119,105,116,104,32,115,116,97,114,116,32,103,114,101,97,116,101,114,32,116,104,97,110,32,101,110,100,0] /* address_table::map_r */, "i8", ALLOC_STATIC);
STRING_TABLE.__str292920=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,58,58,109,97,112,95,114,97,110,103,101,32,99,97,108,108,101,100,32,119,105,116,104,32,109,105,115,97,108,105,103,110,101,100,32,115,116,97,114,116,32,97,100,100,114,101,115,115,0] /* address_table::map_r */, "i8", ALLOC_STATIC);
STRING_TABLE.__str302921=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,58,58,109,97,112,95,114,97,110,103,101,32,99,97,108,108,101,100,32,119,105,116,104,32,109,105,115,97,108,105,103,110,101,100,32,101,110,100,32,97,100,100,114,101,115,115,0] /* address_table::map_r */, "i8", ALLOC_STATIC);
STRING_TABLE.__str312922=allocate([79,117,116,32,111,102,32,104,97,110,100,108,101,114,32,101,110,116,114,105,101,115,32,105,110,32,97,100,100,114,101,115,115,32,116,97,98,108,101,0] /* Out of handler entri */, "i8", ALLOC_STATIC);
STRING_TABLE.__str322923=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,58,58,115,101,116,117,112,95,114,97,110,103,101,32,99,97,108,108,101,100,32,119,105,116,104,32,115,116,97,114,116,32,103,114,101,97,116,101,114,32,116,104,97,110,32,101,110,100,0] /* address_table::setup */, "i8", ALLOC_STATIC);
STRING_TABLE.__str332924=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,58,58,115,101,116,117,112,95,114,97,110,103,101,32,99,97,108,108,101,100,32,119,105,116,104,32,109,105,115,97,108,105,103,110,101,100,32,115,116,97,114,116,32,97,100,100,114,101,115,115,0] /* address_table::setup */, "i8", ALLOC_STATIC);
STRING_TABLE.__str342925=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,58,58,115,101,116,117,112,95,114,97,110,103,101,32,99,97,108,108,101,100,32,119,105,116,104,32,109,105,115,97,108,105,103,110,101,100,32,101,110,100,32,97,100,100,114,101,115,115,0] /* address_table::setup */, "i8", ALLOC_STATIC);
STRING_TABLE.__str352926=allocate([72,97,110,100,108,101,114,115,32,111,110,32,100,105,102,102,101,114,101,110,116,32,115,117,98,117,110,105,116,115,32,111,102,32,116,104,101,32,115,97,109,101,32,97,100,100,114,101,115,115,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,97,100,100,114,101,115,115,32,109,97,115,107,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,0] /* Handlers on differen */, "i8", ALLOC_STATIC);
STRING_TABLE.__str392930=allocate([82,97,110,32,111,117,116,32,111,102,32,115,117,98,116,97,98,108,101,115,33,0] /* Ran out of subtables */, "i8", ALLOC_STATIC);
STRING_TABLE.__str402931=allocate([67,97,108,108,101,100,32,115,117,98,116,97,98,108,101,95,114,101,97,108,108,111,99,32,111,110,32,97,32,116,97,98,108,101,32,119,105,116,104,32,97,32,117,115,101,99,111,117,110,116,32,111,102,32,48,0] /* Called subtable_real */, "i8", ALLOC_STATIC);
STRING_TABLE.__str412932=allocate([67,97,108,108,101,100,32,115,117,98,116,97,98,108,101,95,114,101,108,101,97,115,101,32,111,110,32,97,32,116,97,98,108,101,32,119,105,116,104,32,97,32,117,115,101,99,111,117,110,116,32,111,102,32,48,0] /* Called subtable_rele */, "i8", ALLOC_STATIC);
__ZZNK13address_table12handler_nameEhE7strings=allocate(512, "*", ALLOC_STATIC);
STRING_TABLE.__str422933=allocate([105,110,118,97,108,105,100,0] /* invalid\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str432934=allocate([98,97,110,107,32,49,0] /* bank 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str442935=allocate([98,97,110,107,32,50,0] /* bank 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str452936=allocate([98,97,110,107,32,51,0] /* bank 3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str462937=allocate([98,97,110,107,32,52,0] /* bank 4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str472938=allocate([98,97,110,107,32,53,0] /* bank 5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str482939=allocate([98,97,110,107,32,54,0] /* bank 6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str492940=allocate([98,97,110,107,32,55,0] /* bank 7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str502941=allocate([98,97,110,107,32,56,0] /* bank 8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str512942=allocate([98,97,110,107,32,57,0] /* bank 9\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str522943=allocate([98,97,110,107,32,49,48,0] /* bank 10\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str532944=allocate([98,97,110,107,32,49,49,0] /* bank 11\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str542945=allocate([98,97,110,107,32,49,50,0] /* bank 12\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str552946=allocate([98,97,110,107,32,49,51,0] /* bank 13\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str562947=allocate([98,97,110,107,32,49,52,0] /* bank 14\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str572948=allocate([98,97,110,107,32,49,53,0] /* bank 15\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str582949=allocate([98,97,110,107,32,49,54,0] /* bank 16\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str592950=allocate([98,97,110,107,32,49,55,0] /* bank 17\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str602951=allocate([98,97,110,107,32,49,56,0] /* bank 18\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str612952=allocate([98,97,110,107,32,49,57,0] /* bank 19\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str622953=allocate([98,97,110,107,32,50,48,0] /* bank 20\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str632954=allocate([98,97,110,107,32,50,49,0] /* bank 21\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str642955=allocate([98,97,110,107,32,50,50,0] /* bank 22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str652956=allocate([98,97,110,107,32,50,51,0] /* bank 23\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str662957=allocate([98,97,110,107,32,50,52,0] /* bank 24\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str672958=allocate([98,97,110,107,32,50,53,0] /* bank 25\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str682959=allocate([98,97,110,107,32,50,54,0] /* bank 26\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str692960=allocate([98,97,110,107,32,50,55,0] /* bank 27\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str702961=allocate([98,97,110,107,32,50,56,0] /* bank 28\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str712962=allocate([98,97,110,107,32,50,57,0] /* bank 29\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str722963=allocate([98,97,110,107,32,51,48,0] /* bank 30\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str732964=allocate([98,97,110,107,32,51,49,0] /* bank 31\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str742965=allocate([98,97,110,107,32,51,50,0] /* bank 32\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str752966=allocate([98,97,110,107,32,51,51,0] /* bank 33\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str762967=allocate([98,97,110,107,32,51,52,0] /* bank 34\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str772968=allocate([98,97,110,107,32,51,53,0] /* bank 35\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str782969=allocate([98,97,110,107,32,51,54,0] /* bank 36\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str792970=allocate([98,97,110,107,32,51,55,0] /* bank 37\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str802971=allocate([98,97,110,107,32,51,56,0] /* bank 38\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str812972=allocate([98,97,110,107,32,51,57,0] /* bank 39\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str822973=allocate([98,97,110,107,32,52,48,0] /* bank 40\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str832974=allocate([98,97,110,107,32,52,49,0] /* bank 41\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str842975=allocate([98,97,110,107,32,52,50,0] /* bank 42\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str852976=allocate([98,97,110,107,32,52,51,0] /* bank 43\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str862977=allocate([98,97,110,107,32,52,52,0] /* bank 44\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str872978=allocate([98,97,110,107,32,52,53,0] /* bank 45\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str882979=allocate([98,97,110,107,32,52,54,0] /* bank 46\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str892980=allocate([98,97,110,107,32,52,55,0] /* bank 47\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str902981=allocate([98,97,110,107,32,52,56,0] /* bank 48\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str912982=allocate([98,97,110,107,32,52,57,0] /* bank 49\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str922983=allocate([98,97,110,107,32,53,48,0] /* bank 50\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str932984=allocate([98,97,110,107,32,53,49,0] /* bank 51\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str942985=allocate([98,97,110,107,32,53,50,0] /* bank 52\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str952986=allocate([98,97,110,107,32,53,51,0] /* bank 53\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str962987=allocate([98,97,110,107,32,53,52,0] /* bank 54\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str972988=allocate([98,97,110,107,32,53,53,0] /* bank 55\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str982989=allocate([98,97,110,107,32,53,54,0] /* bank 56\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str992990=allocate([98,97,110,107,32,53,55,0] /* bank 57\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1002991=allocate([98,97,110,107,32,53,56,0] /* bank 58\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1012992=allocate([98,97,110,107,32,53,57,0] /* bank 59\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1022993=allocate([98,97,110,107,32,54,48,0] /* bank 60\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1032994=allocate([98,97,110,107,32,54,49,0] /* bank 61\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1042995=allocate([98,97,110,107,32,54,50,0] /* bank 62\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1052996=allocate([98,97,110,107,32,54,51,0] /* bank 63\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1062997=allocate([98,97,110,107,32,54,52,0] /* bank 64\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1072998=allocate([98,97,110,107,32,54,53,0] /* bank 65\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1082999=allocate([98,97,110,107,32,54,54,0] /* bank 66\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1093000=allocate([98,97,110,107,32,54,55,0] /* bank 67\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1103001=allocate([98,97,110,107,32,54,56,0] /* bank 68\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1113002=allocate([98,97,110,107,32,54,57,0] /* bank 69\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1123003=allocate([98,97,110,107,32,55,48,0] /* bank 70\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1133004=allocate([98,97,110,107,32,55,49,0] /* bank 71\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1143005=allocate([98,97,110,107,32,55,50,0] /* bank 72\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1153006=allocate([98,97,110,107,32,55,51,0] /* bank 73\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1163007=allocate([98,97,110,107,32,55,52,0] /* bank 74\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1173008=allocate([98,97,110,107,32,55,53,0] /* bank 75\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1183009=allocate([98,97,110,107,32,55,54,0] /* bank 76\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1193010=allocate([98,97,110,107,32,55,55,0] /* bank 77\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1203011=allocate([98,97,110,107,32,55,56,0] /* bank 78\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1213012=allocate([98,97,110,107,32,55,57,0] /* bank 79\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1223013=allocate([98,97,110,107,32,56,48,0] /* bank 80\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1233014=allocate([98,97,110,107,32,56,49,0] /* bank 81\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1243015=allocate([98,97,110,107,32,56,50,0] /* bank 82\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1253016=allocate([98,97,110,107,32,56,51,0] /* bank 83\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1263017=allocate([98,97,110,107,32,56,52,0] /* bank 84\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1273018=allocate([98,97,110,107,32,56,53,0] /* bank 85\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1283019=allocate([98,97,110,107,32,56,54,0] /* bank 86\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1293020=allocate([98,97,110,107,32,56,55,0] /* bank 87\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1303021=allocate([98,97,110,107,32,56,56,0] /* bank 88\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1313022=allocate([98,97,110,107,32,56,57,0] /* bank 89\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1323023=allocate([98,97,110,107,32,57,48,0] /* bank 90\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1333024=allocate([98,97,110,107,32,57,49,0] /* bank 91\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1343025=allocate([98,97,110,107,32,57,50,0] /* bank 92\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1353026=allocate([98,97,110,107,32,57,51,0] /* bank 93\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1363027=allocate([98,97,110,107,32,57,52,0] /* bank 94\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1373028=allocate([98,97,110,107,32,57,53,0] /* bank 95\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1383029=allocate([98,97,110,107,32,57,54,0] /* bank 96\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1393030=allocate([98,97,110,107,32,57,55,0] /* bank 97\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1403031=allocate([98,97,110,107,32,57,56,0] /* bank 98\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1413032=allocate([98,97,110,107,32,57,57,0] /* bank 99\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1423033=allocate([98,97,110,107,32,49,48,48,0] /* bank 100\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1433034=allocate([98,97,110,107,32,49,48,49,0] /* bank 101\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1443035=allocate([98,97,110,107,32,49,48,50,0] /* bank 102\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1453036=allocate([98,97,110,107,32,49,48,51,0] /* bank 103\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1463037=allocate([98,97,110,107,32,49,48,52,0] /* bank 104\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1473038=allocate([98,97,110,107,32,49,48,53,0] /* bank 105\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1483039=allocate([98,97,110,107,32,49,48,54,0] /* bank 106\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1493040=allocate([98,97,110,107,32,49,48,55,0] /* bank 107\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1503041=allocate([98,97,110,107,32,49,48,56,0] /* bank 108\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1513042=allocate([98,97,110,107,32,49,48,57,0] /* bank 109\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1523043=allocate([98,97,110,107,32,49,49,48,0] /* bank 110\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1533044=allocate([98,97,110,107,32,49,49,49,0] /* bank 111\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1543045=allocate([98,97,110,107,32,49,49,50,0] /* bank 112\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1553046=allocate([98,97,110,107,32,49,49,51,0] /* bank 113\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1563047=allocate([98,97,110,107,32,49,49,52,0] /* bank 114\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1573048=allocate([98,97,110,107,32,49,49,53,0] /* bank 115\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1583049=allocate([98,97,110,107,32,49,49,54,0] /* bank 116\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1593050=allocate([98,97,110,107,32,49,49,55,0] /* bank 117\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1603051=allocate([98,97,110,107,32,49,49,56,0] /* bank 118\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1613052=allocate([98,97,110,107,32,49,49,57,0] /* bank 119\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1623053=allocate([98,97,110,107,32,49,50,48,0] /* bank 120\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1633054=allocate([98,97,110,107,32,49,50,49,0] /* bank 121\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1643055=allocate([98,97,110,107,32,49,50,50,0] /* bank 122\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1653056=allocate([114,97,109,0] /* ram\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1663057=allocate([114,111,109,0] /* rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1673058=allocate([110,111,112,0] /* nop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1683059=allocate([117,110,109,97,112,112,101,100,0] /* unmapped\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1693060=allocate([119,97,116,99,104,112,111,105,110,116,0] /* watchpoint\00 */, "i8", ALLOC_STATIC);
__ZZNK13address_table12handler_nameEhE4desc=allocate(4096, "i8", ALLOC_STATIC);
STRING_TABLE.__str1703061=allocate([63,63,63,0] /* ???\00 */, "i8", ALLOC_STATIC);
__ZTV18address_table_read=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5724, 0, 0, 0, 5726, 0, 0, 0, 5728, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str1713062=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,117,110,109,97,112,95,114,60,85,73,78,84,56,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1723063=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,110,111,112,95,114,60,85,73,78,84,56,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1733064=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,119,97,116,99,104,112,111,105,110,116,95,114,60,85,73,78,84,56,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1743065=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,117,110,109,97,112,95,114,60,85,73,78,84,49,54,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1753066=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,110,111,112,95,114,60,85,73,78,84,49,54,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1763067=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,119,97,116,99,104,112,111,105,110,116,95,114,60,85,73,78,84,49,54,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1773068=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,117,110,109,97,112,95,114,60,85,73,78,84,51,50,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1783069=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,110,111,112,95,114,60,85,73,78,84,51,50,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1793070=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,119,97,116,99,104,112,111,105,110,116,95,114,60,85,73,78,84,51,50,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1803071=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,117,110,109,97,112,95,114,60,85,73,78,84,54,52,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1813072=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,110,111,112,95,114,60,85,73,78,84,54,52,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1823073=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,58,58,119,97,116,99,104,112,111,105,110,116,95,114,60,85,73,78,84,54,52,62,0] /* address_table_read:: */, "i8", ALLOC_STATIC);
__ZTV19address_table_write=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5730, 0, 0, 0, 5732, 0, 0, 0, 5734, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str1833074=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,117,110,109,97,112,95,119,60,85,73,78,84,56,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1843075=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,110,111,112,95,119,60,85,73,78,84,56,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1853076=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,119,97,116,99,104,112,111,105,110,116,95,119,60,85,73,78,84,56,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1863077=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,117,110,109,97,112,95,119,60,85,73,78,84,49,54,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1873078=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,110,111,112,95,119,60,85,73,78,84,49,54,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1883079=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,119,97,116,99,104,112,111,105,110,116,95,119,60,85,73,78,84,49,54,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1893080=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,117,110,109,97,112,95,119,60,85,73,78,84,51,50,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1903081=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,110,111,112,95,119,60,85,73,78,84,51,50,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1913082=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,119,97,116,99,104,112,111,105,110,116,95,119,60,85,73,78,84,51,50,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1923083=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,117,110,109,97,112,95,119,60,85,73,78,84,54,52,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1933084=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,110,111,112,95,119,60,85,73,78,84,54,52,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1943085=allocate([97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,58,58,119,97,116,99,104,112,111,105,110,116,95,119,60,85,73,78,84,54,52,62,0] /* address_table_write: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1953086=allocate([37,48,56,120,45,37,48,56,120,0] /* %08x-%08x\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1963087=allocate([109,101,109,111,114,121,0] /* memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1973088=allocate([126,37,100,126,0] /* ~%d~\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1983089=allocate([73,110,116,101,114,110,97,108,32,98,97,110,107,32,35,37,100,0] /* Internal bank #%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1993090=allocate([66,97,110,107,32,39,37,115,39,0] /* Bank '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2003091=allocate([109,95,99,117,114,101,110,116,114,121,0] /* m_curentry\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2013092=allocate([109,101,109,111,114,121,95,98,97,110,107,58,58,115,101,116,95,98,97,115,101,32,99,97,108,108,101,100,32,78,85,76,76,32,98,97,115,101,0] /* memory_bank::set_bas */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2023093=allocate([109,101,109,111,114,121,95,98,97,110,107,58,58,115,101,116,95,101,110,116,114,121,32,99,97,108,108,101,100,32,102,111,114,32,97,110,111,110,121,109,111,117,115,32,98,97,110,107,0] /* memory_bank::set_ent */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2033094=allocate([109,101,109,111,114,121,95,98,97,110,107,58,58,115,101,116,95,101,110,116,114,121,32,99,97,108,108,101,100,32,119,105,116,104,32,111,117,116,45,111,102,45,114,97,110,103,101,32,101,110,116,114,121,32,37,100,0] /* memory_bank::set_ent */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2043095=allocate([109,101,109,111,114,121,95,98,97,110,107,58,58,115,101,116,95,101,110,116,114,121,32,99,97,108,108,101,100,32,102,111,114,32,98,97,110,107,32,39,37,115,39,32,119,105,116,104,32,105,110,118,97,108,105,100,32,98,97,110,107,32,101,110,116,114,121,32,37,100,0] /* memory_bank::set_ent */, "i8", ALLOC_STATIC);
__ZTV13handler_entry=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5736, 0, 0, 0, 5738, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 5740, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str2063097=allocate([37,100,58,37,100,58,37,120,58,37,100,58,37,115,0] /* %d:%d:%x:%d:%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2073098=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,105,110,115,116,97,108,108,32,100,101,108,101,103,97,116,101,32,39,37,115,39,32,119,105,116,104,111,117,116,32,97,32,98,111,117,110,100,32,111,98,106,101,99,116,0] /* Attempted to install */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13address_space=allocate([49,51,97,100,100,114,101,115,115,95,115,112,97,99,101,0] /* 13address_space\00 */, "i8", ALLOC_STATIC);
__ZTI13address_space=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS13handler_entry=allocate([49,51,104,97,110,100,108,101,114,95,101,110,116,114,121,0] /* 13handler_entry\00 */, "i8", ALLOC_STATIC);
__ZTI13handler_entry=allocate(8, "*", ALLOC_STATIC);
__ZTV18handler_entry_read=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5742, 0, 0, 0, 5744, 0, 0, 0, 5746, 0, 0, 0, 5748, 0, 0, 0, 5750, 0, 0, 0, 5752, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS18handler_entry_read=allocate([49,56,104,97,110,100,108,101,114,95,101,110,116,114,121,95,114,101,97,100,0] /* 18handler_entry_read */, "i8", ALLOC_STATIC);
__ZTI18handler_entry_read=allocate(12, "*", ALLOC_STATIC);
__ZTV19handler_entry_write=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5754, 0, 0, 0, 5756, 0, 0, 0, 5758, 0, 0, 0, 5760, 0, 0, 0, 5762, 0, 0, 0, 5764, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19handler_entry_write=allocate([49,57,104,97,110,100,108,101,114,95,101,110,116,114,121,95,119,114,105,116,101,0] /* 19handler_entry_writ */, "i8", ALLOC_STATIC);
__ZTI19handler_entry_write=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS13address_table=allocate([49,51,97,100,100,114,101,115,115,95,116,97,98,108,101,0] /* 13address_table\00 */, "i8", ALLOC_STATIC);
__ZTI13address_table=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS18address_table_read=allocate([49,56,97,100,100,114,101,115,115,95,116,97,98,108,101,95,114,101,97,100,0] /* 18address_table_read */, "i8", ALLOC_STATIC);
__ZTI18address_table_read=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS19address_table_write=allocate([49,57,97,100,100,114,101,115,115,95,116,97,98,108,101,95,119,114,105,116,101,0] /* 19address_table_writ */, "i8", ALLOC_STATIC);
__ZTI19address_table_write=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN11memory_bank14bank_referenceEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5766, 0, 0, 0, 5768, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN11memory_bank14bank_referenceEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,49,109,101,109,111,114,121,95,98,97,110,107,49,52,98,97,110,107,95,114,101,102,101,114,101,110,99,101,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN11memory_bank14bank_referenceEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN11memory_bank14bank_referenceEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5770, 0, 0, 0, 5772, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN11memory_bank14bank_referenceEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,49,109,101,109,111,114,121,95,98,97,110,107,49,52,98,97,110,107,95,114,101,102,101,114,101,110,99,101,69,69,0] /* 11simple_listIN11mem */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN11memory_bank14bank_referenceEE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN16direct_read_data12direct_rangeEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5774, 0, 0, 0, 5776, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN16direct_read_data12direct_rangeEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,54,100,105,114,101,99,116,95,114,101,97,100,95,100,97,116,97,49,50,100,105,114,101,99,116,95,114,97,110,103,101,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN16direct_read_data12direct_rangeEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN16direct_read_data12direct_rangeEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5778, 0, 0, 0, 5780, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN16direct_read_data12direct_rangeEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,54,100,105,114,101,99,116,95,114,101,97,100,95,100,97,116,97,49,50,100,105,114,101,99,116,95,114,97,110,103,101,69,69,0] /* 11simple_listIN16dir */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN16direct_read_data12direct_rangeEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str2083099=allocate([37,115,58,32,117,110,109,97,112,112,101,100,32,37,115,32,109,101,109,111,114,121,32,119,114,105,116,101,32,116,111,32,37,115,32,61,32,37,115,32,38,32,37,115,10,0] /* %s: unmapped %s memo */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI19handler_entry_writeE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5782, 0, 0, 0, 5784, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI19handler_entry_writeE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,57,104,97,110,100,108,101,114,95,101,110,116,114,121,95,119,114,105,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI19handler_entry_writeE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str2093100=allocate([37,115,58,32,117,110,109,97,112,112,101,100,32,37,115,32,109,101,109,111,114,121,32,114,101,97,100,32,102,114,111,109,32,37,115,32,38,32,37,115,10,0] /* %s: unmapped %s memo */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI18handler_entry_readE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5786, 0, 0, 0, 5788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18handler_entry_readE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,104,97,110,100,108,101,114,95,101,110,116,114,121,95,114,101,97,100,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18handler_entry_readE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIN13address_table13subtable_dataEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5790, 0, 0, 0, 5792, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIN13address_table13subtable_dataEE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,78,49,51,97,100,100,114,101,115,115,95,116,97,98,108,101,49,51,115,117,98,116,97,98,108,101,95,100,97,116,97,69,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIN13address_table13subtable_dataEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI11memory_bankE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5794, 0, 0, 0, 5796, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11memory_bankE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,109,101,109,111,114,121,95,98,97,110,107,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11memory_bankE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12memory_blockE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5798, 0, 0, 0, 5800, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12memory_blockE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,109,101,109,111,114,121,95,98,108,111,99,107,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12memory_blockE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12memory_shareE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5802, 0, 0, 0, 5804, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12memory_shareE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,109,101,109,111,114,121,95,115,104,97,114,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12memory_shareE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5806, 0, 0, 0, 5808, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIyL12endianness_t1ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5810, 0, 0, 0, 5812, 0, 0, 0, 5814, 0, 0, 0, 5816, 0, 0, 0, 5818, 0, 0, 0, 5820, 0, 0, 0, 5822, 0, 0, 0, 5824, 0, 0, 0, 5826, 0, 0, 0, 5828, 0, 0, 0, 5830, 0, 0, 0, 5832, 0, 0, 0, 5834, 0, 0, 0, 5836, 0, 0, 0, 5838, 0, 0, 0, 5840, 0, 0, 0, 5842, 0, 0, 0, 5844, 0, 0, 0, 5846, 0, 0, 0, 5848, 0, 0, 0, 5850, 0, 0, 0, 5852, 0, 0, 0, 5854, 0, 0, 0, 5856, 0, 0, 0, 5858, 0, 0, 0, 5860, 0, 0, 0, 5862, 0, 0, 0, 5864, 0, 0, 0, 5866, 0, 0, 0, 5868, 0, 0, 0, 5870, 0, 0, 0, 5872, 0, 0, 0, 5874, 0, 0, 0, 5876, 0, 0, 0, 5878, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t1ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIyL12endianness_t1ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5880, 0, 0, 0, 5882, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIyL12endianness_t1ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5884, 0, 0, 0, 5886, 0, 0, 0, 5888, 0, 0, 0, 5890, 0, 0, 0, 5892, 0, 0, 0, 5894, 0, 0, 0, 5896, 0, 0, 0, 5898, 0, 0, 0, 5900, 0, 0, 0, 5902, 0, 0, 0, 5904, 0, 0, 0, 5906, 0, 0, 0, 5908, 0, 0, 0, 5910, 0, 0, 0, 5912, 0, 0, 0, 5914, 0, 0, 0, 5916, 0, 0, 0, 5918, 0, 0, 0, 5920, 0, 0, 0, 5922, 0, 0, 0, 5924, 0, 0, 0, 5926, 0, 0, 0, 5928, 0, 0, 0, 5930, 0, 0, 0, 5932, 0, 0, 0, 5934, 0, 0, 0, 5936, 0, 0, 0, 5938, 0, 0, 0, 5940, 0, 0, 0, 5942, 0, 0, 0, 5944, 0, 0, 0, 5946, 0, 0, 0, 5948, 0, 0, 0, 5950, 0, 0, 0, 5952, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t1ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIyL12endianness_t1ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5954, 0, 0, 0, 5956, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIyL12endianness_t0ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 5958, 0, 0, 0, 5960, 0, 0, 0, 5962, 0, 0, 0, 5964, 0, 0, 0, 5966, 0, 0, 0, 5968, 0, 0, 0, 5970, 0, 0, 0, 5972, 0, 0, 0, 5974, 0, 0, 0, 5976, 0, 0, 0, 5978, 0, 0, 0, 5980, 0, 0, 0, 5982, 0, 0, 0, 5984, 0, 0, 0, 5986, 0, 0, 0, 5988, 0, 0, 0, 5990, 0, 0, 0, 5992, 0, 0, 0, 5994, 0, 0, 0, 5996, 0, 0, 0, 5998, 0, 0, 0, 6000, 0, 0, 0, 6002, 0, 0, 0, 6004, 0, 0, 0, 6006, 0, 0, 0, 6008, 0, 0, 0, 6010, 0, 0, 0, 6012, 0, 0, 0, 6014, 0, 0, 0, 6016, 0, 0, 0, 6018, 0, 0, 0, 6020, 0, 0, 0, 6022, 0, 0, 0, 6024, 0, 0, 0, 6026, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t0ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIyL12endianness_t0ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6028, 0, 0, 0, 6030, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIyL12endianness_t0ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6032, 0, 0, 0, 6034, 0, 0, 0, 6036, 0, 0, 0, 6038, 0, 0, 0, 6040, 0, 0, 0, 6042, 0, 0, 0, 6044, 0, 0, 0, 6046, 0, 0, 0, 6048, 0, 0, 0, 6050, 0, 0, 0, 6052, 0, 0, 0, 6054, 0, 0, 0, 6056, 0, 0, 0, 6058, 0, 0, 0, 6060, 0, 0, 0, 6062, 0, 0, 0, 6064, 0, 0, 0, 6066, 0, 0, 0, 6068, 0, 0, 0, 6070, 0, 0, 0, 6072, 0, 0, 0, 6074, 0, 0, 0, 6076, 0, 0, 0, 6078, 0, 0, 0, 6080, 0, 0, 0, 6082, 0, 0, 0, 6084, 0, 0, 0, 6086, 0, 0, 0, 6088, 0, 0, 0, 6090, 0, 0, 0, 6092, 0, 0, 0, 6094, 0, 0, 0, 6096, 0, 0, 0, 6098, 0, 0, 0, 6100, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t0ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,121,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIyL12endianness_t0ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6102, 0, 0, 0, 6104, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIjL12endianness_t1ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6106, 0, 0, 0, 6108, 0, 0, 0, 6110, 0, 0, 0, 6112, 0, 0, 0, 6114, 0, 0, 0, 6116, 0, 0, 0, 6118, 0, 0, 0, 6120, 0, 0, 0, 6122, 0, 0, 0, 6124, 0, 0, 0, 6126, 0, 0, 0, 6128, 0, 0, 0, 6130, 0, 0, 0, 6132, 0, 0, 0, 6134, 0, 0, 0, 6136, 0, 0, 0, 6138, 0, 0, 0, 6140, 0, 0, 0, 6142, 0, 0, 0, 6144, 0, 0, 0, 6146, 0, 0, 0, 6148, 0, 0, 0, 6150, 0, 0, 0, 6152, 0, 0, 0, 6154, 0, 0, 0, 6156, 0, 0, 0, 6158, 0, 0, 0, 6160, 0, 0, 0, 6162, 0, 0, 0, 6164, 0, 0, 0, 6166, 0, 0, 0, 6168, 0, 0, 0, 6170, 0, 0, 0, 6172, 0, 0, 0, 6174, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t1ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIjL12endianness_t1ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6176, 0, 0, 0, 6178, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIjL12endianness_t1ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6180, 0, 0, 0, 6182, 0, 0, 0, 6184, 0, 0, 0, 6186, 0, 0, 0, 6188, 0, 0, 0, 6190, 0, 0, 0, 6192, 0, 0, 0, 6194, 0, 0, 0, 6196, 0, 0, 0, 6198, 0, 0, 0, 6200, 0, 0, 0, 6202, 0, 0, 0, 6204, 0, 0, 0, 6206, 0, 0, 0, 6208, 0, 0, 0, 6210, 0, 0, 0, 6212, 0, 0, 0, 6214, 0, 0, 0, 6216, 0, 0, 0, 6218, 0, 0, 0, 6220, 0, 0, 0, 6222, 0, 0, 0, 6224, 0, 0, 0, 6226, 0, 0, 0, 6228, 0, 0, 0, 6230, 0, 0, 0, 6232, 0, 0, 0, 6234, 0, 0, 0, 6236, 0, 0, 0, 6238, 0, 0, 0, 6240, 0, 0, 0, 6242, 0, 0, 0, 6244, 0, 0, 0, 6246, 0, 0, 0, 6248, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t1ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIjL12endianness_t1ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6250, 0, 0, 0, 6252, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIjL12endianness_t0ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6254, 0, 0, 0, 6256, 0, 0, 0, 6258, 0, 0, 0, 6260, 0, 0, 0, 6262, 0, 0, 0, 6264, 0, 0, 0, 6266, 0, 0, 0, 6268, 0, 0, 0, 6270, 0, 0, 0, 6272, 0, 0, 0, 6274, 0, 0, 0, 6276, 0, 0, 0, 6278, 0, 0, 0, 6280, 0, 0, 0, 6282, 0, 0, 0, 6284, 0, 0, 0, 6286, 0, 0, 0, 6288, 0, 0, 0, 6290, 0, 0, 0, 6292, 0, 0, 0, 6294, 0, 0, 0, 6296, 0, 0, 0, 6298, 0, 0, 0, 6300, 0, 0, 0, 6302, 0, 0, 0, 6304, 0, 0, 0, 6306, 0, 0, 0, 6308, 0, 0, 0, 6310, 0, 0, 0, 6312, 0, 0, 0, 6314, 0, 0, 0, 6316, 0, 0, 0, 6318, 0, 0, 0, 6320, 0, 0, 0, 6322, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t0ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIjL12endianness_t0ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6324, 0, 0, 0, 6326, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIjL12endianness_t0ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6328, 0, 0, 0, 6330, 0, 0, 0, 6332, 0, 0, 0, 6334, 0, 0, 0, 6336, 0, 0, 0, 6338, 0, 0, 0, 6340, 0, 0, 0, 6342, 0, 0, 0, 6344, 0, 0, 0, 6346, 0, 0, 0, 6348, 0, 0, 0, 6350, 0, 0, 0, 6352, 0, 0, 0, 6354, 0, 0, 0, 6356, 0, 0, 0, 6358, 0, 0, 0, 6360, 0, 0, 0, 6362, 0, 0, 0, 6364, 0, 0, 0, 6366, 0, 0, 0, 6368, 0, 0, 0, 6370, 0, 0, 0, 6372, 0, 0, 0, 6374, 0, 0, 0, 6376, 0, 0, 0, 6378, 0, 0, 0, 6380, 0, 0, 0, 6382, 0, 0, 0, 6384, 0, 0, 0, 6386, 0, 0, 0, 6388, 0, 0, 0, 6390, 0, 0, 0, 6392, 0, 0, 0, 6394, 0, 0, 0, 6396, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t0ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,106,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIjL12endianness_t0ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6398, 0, 0, 0, 6400, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificItL12endianness_t1ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6402, 0, 0, 0, 6404, 0, 0, 0, 6406, 0, 0, 0, 6408, 0, 0, 0, 6410, 0, 0, 0, 6412, 0, 0, 0, 6414, 0, 0, 0, 6416, 0, 0, 0, 6418, 0, 0, 0, 6420, 0, 0, 0, 6422, 0, 0, 0, 6424, 0, 0, 0, 6426, 0, 0, 0, 6428, 0, 0, 0, 6430, 0, 0, 0, 6432, 0, 0, 0, 6434, 0, 0, 0, 6436, 0, 0, 0, 6438, 0, 0, 0, 6440, 0, 0, 0, 6442, 0, 0, 0, 6444, 0, 0, 0, 6446, 0, 0, 0, 6448, 0, 0, 0, 6450, 0, 0, 0, 6452, 0, 0, 0, 6454, 0, 0, 0, 6456, 0, 0, 0, 6458, 0, 0, 0, 6460, 0, 0, 0, 6462, 0, 0, 0, 6464, 0, 0, 0, 6466, 0, 0, 0, 6468, 0, 0, 0, 6470, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificItL12endianness_t1ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificItL12endianness_t1ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6472, 0, 0, 0, 6474, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificItL12endianness_t1ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6476, 0, 0, 0, 6478, 0, 0, 0, 6480, 0, 0, 0, 6482, 0, 0, 0, 6484, 0, 0, 0, 6486, 0, 0, 0, 6488, 0, 0, 0, 6490, 0, 0, 0, 6492, 0, 0, 0, 6494, 0, 0, 0, 6496, 0, 0, 0, 6498, 0, 0, 0, 6500, 0, 0, 0, 6502, 0, 0, 0, 6504, 0, 0, 0, 6506, 0, 0, 0, 6508, 0, 0, 0, 6510, 0, 0, 0, 6512, 0, 0, 0, 6514, 0, 0, 0, 6516, 0, 0, 0, 6518, 0, 0, 0, 6520, 0, 0, 0, 6522, 0, 0, 0, 6524, 0, 0, 0, 6526, 0, 0, 0, 6528, 0, 0, 0, 6530, 0, 0, 0, 6532, 0, 0, 0, 6534, 0, 0, 0, 6536, 0, 0, 0, 6538, 0, 0, 0, 6540, 0, 0, 0, 6542, 0, 0, 0, 6544, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificItL12endianness_t1ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificItL12endianness_t1ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6546, 0, 0, 0, 6548, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificItL12endianness_t0ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6550, 0, 0, 0, 6552, 0, 0, 0, 6554, 0, 0, 0, 6556, 0, 0, 0, 6558, 0, 0, 0, 6560, 0, 0, 0, 6562, 0, 0, 0, 6564, 0, 0, 0, 6566, 0, 0, 0, 6568, 0, 0, 0, 6570, 0, 0, 0, 6572, 0, 0, 0, 6574, 0, 0, 0, 6576, 0, 0, 0, 6578, 0, 0, 0, 6580, 0, 0, 0, 6582, 0, 0, 0, 6584, 0, 0, 0, 6586, 0, 0, 0, 6588, 0, 0, 0, 6590, 0, 0, 0, 6592, 0, 0, 0, 6594, 0, 0, 0, 6596, 0, 0, 0, 6598, 0, 0, 0, 6600, 0, 0, 0, 6602, 0, 0, 0, 6604, 0, 0, 0, 6606, 0, 0, 0, 6608, 0, 0, 0, 6610, 0, 0, 0, 6612, 0, 0, 0, 6614, 0, 0, 0, 6616, 0, 0, 0, 6618, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificItL12endianness_t0ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificItL12endianness_t0ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6620, 0, 0, 0, 6622, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificItL12endianness_t0ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6624, 0, 0, 0, 6626, 0, 0, 0, 6628, 0, 0, 0, 6630, 0, 0, 0, 6632, 0, 0, 0, 6634, 0, 0, 0, 6636, 0, 0, 0, 6638, 0, 0, 0, 6640, 0, 0, 0, 6642, 0, 0, 0, 6644, 0, 0, 0, 6646, 0, 0, 0, 6648, 0, 0, 0, 6650, 0, 0, 0, 6652, 0, 0, 0, 6654, 0, 0, 0, 6656, 0, 0, 0, 6658, 0, 0, 0, 6660, 0, 0, 0, 6662, 0, 0, 0, 6664, 0, 0, 0, 6666, 0, 0, 0, 6668, 0, 0, 0, 6670, 0, 0, 0, 6672, 0, 0, 0, 6674, 0, 0, 0, 6676, 0, 0, 0, 6678, 0, 0, 0, 6680, 0, 0, 0, 6682, 0, 0, 0, 6684, 0, 0, 0, 6686, 0, 0, 0, 6688, 0, 0, 0, 6690, 0, 0, 0, 6692, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificItL12endianness_t0ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,116,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificItL12endianness_t0ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6694, 0, 0, 0, 6696, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIhL12endianness_t1ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6698, 0, 0, 0, 6700, 0, 0, 0, 6702, 0, 0, 0, 6704, 0, 0, 0, 6706, 0, 0, 0, 6708, 0, 0, 0, 6710, 0, 0, 0, 6712, 0, 0, 0, 6714, 0, 0, 0, 6716, 0, 0, 0, 6718, 0, 0, 0, 6720, 0, 0, 0, 6722, 0, 0, 0, 6724, 0, 0, 0, 6726, 0, 0, 0, 6728, 0, 0, 0, 6730, 0, 0, 0, 6732, 0, 0, 0, 6734, 0, 0, 0, 6736, 0, 0, 0, 6738, 0, 0, 0, 6740, 0, 0, 0, 6742, 0, 0, 0, 6744, 0, 0, 0, 6746, 0, 0, 0, 6748, 0, 0, 0, 6750, 0, 0, 0, 6752, 0, 0, 0, 6754, 0, 0, 0, 6756, 0, 0, 0, 6758, 0, 0, 0, 6760, 0, 0, 0, 6762, 0, 0, 0, 6764, 0, 0, 0, 6766, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t1ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIhL12endianness_t1ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6768, 0, 0, 0, 6770, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIhL12endianness_t1ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6772, 0, 0, 0, 6774, 0, 0, 0, 6776, 0, 0, 0, 6778, 0, 0, 0, 6780, 0, 0, 0, 6782, 0, 0, 0, 6784, 0, 0, 0, 6786, 0, 0, 0, 6788, 0, 0, 0, 6790, 0, 0, 0, 6792, 0, 0, 0, 6794, 0, 0, 0, 6796, 0, 0, 0, 6798, 0, 0, 0, 6800, 0, 0, 0, 6802, 0, 0, 0, 6804, 0, 0, 0, 6806, 0, 0, 0, 6808, 0, 0, 0, 6810, 0, 0, 0, 6812, 0, 0, 0, 6814, 0, 0, 0, 6816, 0, 0, 0, 6818, 0, 0, 0, 6820, 0, 0, 0, 6822, 0, 0, 0, 6824, 0, 0, 0, 6826, 0, 0, 0, 6828, 0, 0, 0, 6830, 0, 0, 0, 6832, 0, 0, 0, 6834, 0, 0, 0, 6836, 0, 0, 0, 6838, 0, 0, 0, 6840, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t1ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,49,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIhL12endianness_t1ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6842, 0, 0, 0, 6844, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIhL12endianness_t0ELb0EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6846, 0, 0, 0, 6848, 0, 0, 0, 6850, 0, 0, 0, 6852, 0, 0, 0, 6854, 0, 0, 0, 6856, 0, 0, 0, 6858, 0, 0, 0, 6860, 0, 0, 0, 6862, 0, 0, 0, 6864, 0, 0, 0, 6866, 0, 0, 0, 6868, 0, 0, 0, 6870, 0, 0, 0, 6872, 0, 0, 0, 6874, 0, 0, 0, 6876, 0, 0, 0, 6878, 0, 0, 0, 6880, 0, 0, 0, 6882, 0, 0, 0, 6884, 0, 0, 0, 6886, 0, 0, 0, 6888, 0, 0, 0, 6890, 0, 0, 0, 6892, 0, 0, 0, 6894, 0, 0, 0, 6896, 0, 0, 0, 6898, 0, 0, 0, 6900, 0, 0, 0, 6902, 0, 0, 0, 6904, 0, 0, 0, 6906, 0, 0, 0, 6908, 0, 0, 0, 6910, 0, 0, 0, 6912, 0, 0, 0, 6914, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t0ELb0EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,48,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIhL12endianness_t0ELb0EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6916, 0, 0, 0, 6918, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE=allocate(12, "*", ALLOC_STATIC);
__ZTV22address_space_specificIhL12endianness_t0ELb1EE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6920, 0, 0, 0, 6922, 0, 0, 0, 6924, 0, 0, 0, 6926, 0, 0, 0, 6928, 0, 0, 0, 6930, 0, 0, 0, 6932, 0, 0, 0, 6934, 0, 0, 0, 6936, 0, 0, 0, 6938, 0, 0, 0, 6940, 0, 0, 0, 6942, 0, 0, 0, 6944, 0, 0, 0, 6946, 0, 0, 0, 6948, 0, 0, 0, 6950, 0, 0, 0, 6952, 0, 0, 0, 6954, 0, 0, 0, 6956, 0, 0, 0, 6958, 0, 0, 0, 6960, 0, 0, 0, 6962, 0, 0, 0, 6964, 0, 0, 0, 6966, 0, 0, 0, 6968, 0, 0, 0, 6970, 0, 0, 0, 6972, 0, 0, 0, 6974, 0, 0, 0, 6976, 0, 0, 0, 6978, 0, 0, 0, 6980, 0, 0, 0, 6982, 0, 0, 0, 6984, 0, 0, 0, 6986, 0, 0, 0, 6988, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t0ELb1EE=allocate([50,50,97,100,100,114,101,115,115,95,115,112,97,99,101,95,115,112,101,99,105,102,105,99,73,104,76,49,50,101,110,100,105,97,110,110,101,115,115,95,116,48,69,76,98,49,69,69,0] /* 22address_space_spec */, "i8", ALLOC_STATIC);
__ZTI22address_space_specificIhL12endianness_t0ELb1EE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI16direct_read_dataE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6990, 0, 0, 0, 6992, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16direct_read_dataE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,100,105,114,101,99,116,95,114,101,97,100,95,100,97,116,97,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16direct_read_dataE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI15_memory_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6994, 0, 0, 0, 6996, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI15_memory_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,53,95,109,101,109,111,114,121,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI15_memory_privateE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI13address_spaceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 6998, 0, 0, 0, 7000, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI13address_spaceE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,51,97,100,100,114,101,115,115,95,115,112,97,99,101,69,0] /* 11simple_listI13addr */, "i8", ALLOC_STATIC);
__ZTI11simple_listI13address_spaceE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI12memory_blockE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7002, 0, 0, 0, 7004, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI12memory_blockE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,50,109,101,109,111,114,121,95,98,108,111,99,107,69,0] /* 11simple_listI12memo */, "i8", ALLOC_STATIC);
__ZTI11simple_listI12memory_blockE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI11memory_bankE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7006, 0, 0, 0, 7008, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI11memory_bankE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,49,109,101,109,111,114,121,95,98,97,110,107,69,0] /* 11simple_listI11memo */, "i8", ALLOC_STATIC);
__ZTI11simple_listI11memory_bankE=allocate(8, "*", ALLOC_STATIC);
__ZTV10cpu_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7010, 0, 0, 0, 7012, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1788, 0, 0, 0, 1738, 0, 0, 0, 5354, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 7014, 0, 0, 0, 7016, 0, 0, 0, 1882, 0, 0, 0, 1884, 0, 0, 0, 1886, 0, 0, 0, 1888, 0, 0, 0, 1890, 0, 0, 0, 1892, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1902, 0, 0, 0, 1904, 0, 0, 0, 7018, 0, 0, 0, 7020, 0, 0, 0, 7022, 0, 0, 0, 7024, 0, 0, 0, 7026, 0, 0, 0, 7028, 0, 0, 0, 1788, 0, 0, 0, 7030, 0, 0, 0, 7032, 0, 0, 0, -5968, 0, 0, 0, 0, 0, 0, 0, 7034, 0, 0, 0, 7036, 0, 0, 0, 1882, 0, 0, 0, 1928, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1788, 0, 0, 0, 5408, 0, 0, 0, 5410, 0, 0, 0, 5412, 0, 0, 0, 5414, 0, 0, 0, -6012, 0, 0, 0, 0, 0, 0, 0, 7038, 0, 0, 0, 7040, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1956, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 7042, 0, 0, 0, 7044, 0, 0, 0, 1962, 0, 0, 0, 7046, 0, 0, 0, -7088, 0, 0, 0, 0, 0, 0, 0, 7048, 0, 0, 0, 7050, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str3114=allocate([67,80,85,0] /* CPU\00 */, "i8", ALLOC_STATIC);
__ZTV17legacy_cpu_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7052, 0, 0, 0, 7054, 0, 0, 0, 1824, 0, 0, 0, 1826, 0, 0, 0, 1828, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 1830, 0, 0, 0, 1832, 0, 0, 0, 1834, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1836, 0, 0, 0, 1750, 0, 0, 0, 1838, 0, 0, 0, 1840, 0, 0, 0, 1842, 0, 0, 0, 1844, 0, 0, 0, 1846, 0, 0, 0, 1848, 0, 0, 0, 1850, 0, 0, 0, 1852, 0, 0, 0, 1854, 0, 0, 0, 1856, 0, 0, 0, 1858, 0, 0, 0, 1860, 0, 0, 0, 1862, 0, 0, 0, 1864, 0, 0, 0, 1866, 0, 0, 0, 1868, 0, 0, 0, 1870, 0, 0, 0, 1872, 0, 0, 0, 1874, 0, 0, 0, 1876, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 7056, 0, 0, 0, 7058, 0, 0, 0, 1882, 0, 0, 0, 1884, 0, 0, 0, 1886, 0, 0, 0, 1888, 0, 0, 0, 1890, 0, 0, 0, 1892, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1902, 0, 0, 0, 1904, 0, 0, 0, 1906, 0, 0, 0, 1908, 0, 0, 0, 1910, 0, 0, 0, 1912, 0, 0, 0, 1914, 0, 0, 0, 1916, 0, 0, 0, 1918, 0, 0, 0, 1920, 0, 0, 0, 1922, 0, 0, 0, -5968, 0, 0, 0, 0, 0, 0, 0, 7060, 0, 0, 0, 7062, 0, 0, 0, 1882, 0, 0, 0, 1928, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1940, 0, 0, 0, 1942, 0, 0, 0, 1944, 0, 0, 0, 1946, 0, 0, 0, 1948, 0, 0, 0, -6012, 0, 0, 0, 0, 0, 0, 0, 7064, 0, 0, 0, 7066, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1956, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1958, 0, 0, 0, 1960, 0, 0, 0, 1962, 0, 0, 0, 1964, 0, 0, 0, -7088, 0, 0, 0, 0, 0, 0, 0, 7068, 0, 0, 0, 7070, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1970, 0, 0, 0, 1972, 0, 0, 0, 1974, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str13115=allocate([100,97,116,97,0] /* data\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23116=allocate([105,47,111,0] /* i/o\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33117=allocate([112,114,111,103,114,97,109,0] /* program\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43118=allocate([68,101,118,105,99,101,32,37,115,32,115,112,101,99,105,102,105,101,115,32,97,32,48,32,99,111,110,116,101,120,116,32,115,105,122,101,33,10,0] /* Device %s specifies  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53119=allocate([115,114,99,47,101,109,117,47,100,101,118,99,112,117,46,99,0] /* src/emu/devcpu.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63120=allocate([37,37,37,100,115,0] /* %%%ds\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73121=allocate([99,117,114,112,99,0] /* curpc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83122=allocate([37,56,115,0] /* %8s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93123=allocate([99,117,114,112,99,98,97,115,101,0] /* curpcbase\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103124=allocate([71,69,78,70,76,65,71,83,0] /* GENFLAGS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113125=allocate([36,37,48,50,88,0] /* $%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123126=allocate([36,37,48,52,88,0] /* $%04X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133127=allocate([36,37,48,56,88,0] /* $%08X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143128=allocate([36,37,48,56,88,37,48,56,88,0] /* $%08X%08X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS10cpu_device=allocate([49,48,99,112,117,95,100,101,118,105,99,101,0] /* 10cpu_device\00 */, "i8", ALLOC_STATIC);
__ZTI10cpu_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 91138, 0, 0, 0, 0, 0, 0, 0, 1527810, 0, 0, 0, 0, 0, 0, 0, 1539074, 0, 0, 0, 0, 0, 0, 0, 1814530, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS17legacy_cpu_device=allocate([49,55,108,101,103,97,99,121,95,99,112,117,95,100,101,118,105,99,101,0] /* 17legacy_cpu_device\ */, "i8", ALLOC_STATIC);
__ZTI17legacy_cpu_device=allocate(12, "*", ALLOC_STATIC);
__ZN18device_state_entry17k_decimal_divisorE=allocate([1, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, 0, 1000, 0, 0, 0, 0, 0, 0, 0, 10000, 0, 0, 0, 0, 0, 0, 0, 100000, 0, 0, 0, 0, 0, 0, 0, 1000000, 0, 0, 0, 0, 0, 0, 0, 10000000, 0, 0, 0, 0, 0, 0, 0, 100000000, 0, 0, 0, 0, 0, 0, 0, 1000000000, 0, 0, 0, 0, 0, 0, 0, 1410065408, 0, 0, 0, 2, 0, 0, 0, 1215752192, 0, 0, 0, 23, 0, 0, 0, 3567587328, 0, 0, 0, 232, 0, 0, 0, 1316134912, 0, 0, 0, 2328, 0, 0, 0, 276447232, 0, 0, 0, 23283, 0, 0, 0, 2764472320, 0, 0, 0, 232830, 0, 0, 0, 1874919424, 0, 0, 0, 2328306, 0, 0, 0, 1569325056, 0, 0, 0, 23283064, 0, 0, 0, 2808348672, 0, 0, 0, 232830643, 0, 0, 0, 2313682944, 0, 0, 0, -1966660860, 0, 0, 0], ["i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0,"i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str3199=allocate([67,85,82,80,67,0] /* CURPC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13200=allocate([67,85,82,80,67,66,65,83,69,0] /* CURPCBASE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23201=allocate([67,85,82,83,80,0] /* CURSP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33202=allocate([67,85,82,70,76,65,71,83,0] /* CURFLAGS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43203=allocate([37,37,48,37,100,88,0] /* %%0%dX\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53204=allocate([87,105,100,116,104,32,114,101,113,117,105,114,101,100,32,102,111,114,32,37,37,88,32,102,111,114,109,97,116,115,10,0] /* Width required for % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63205=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNK18device_state_entry6formatER7astringPKcbE8hexchars=allocate([48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0] /* 0123456789ABCDEF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73206=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83207=allocate([87,105,100,116,104,32,114,101,113,117,105,114,101,100,32,102,111,114,32,37,37,100,32,102,111,114,109,97,116,115,10,0] /* Width required for % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93208=allocate([45,0] /* -\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103209=allocate([43,0] /* +\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113210=allocate([87,105,100,116,104,32,114,101,113,117,105,114,101,100,32,102,111,114,32,37,37,117,32,102,111,114,109,97,116,115,10,0] /* Width required for % */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNK18device_state_entry6formatER7astringPKcbE8decchars=allocate([48,49,50,51,52,53,54,55,56,57,0] /* 0123456789\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123211=allocate([87,105,100,116,104,32,114,101,113,117,105,114,101,100,32,102,111,114,32,37,37,115,32,102,111,114,109,97,116,115,10,0] /* Width required for % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133212=allocate([85,110,107,110,111,119,110,32,102,111,114,109,97,116,32,99,104,97,114,97,99,116,101,114,32,39,37,99,39,10,0] /* Unknown format chara */, "i8", ALLOC_STATIC);
__ZTV22device_state_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7072, 0, 0, 0, 7074, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1956, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 7042, 0, 0, 0, 7044, 0, 0, 0, 1962, 0, 0, 0, 7046, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str143213=allocate([63,63,63,0] /* ???\00 */, "i8", ALLOC_STATIC);
__str153214=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str163215=allocate([115,114,99,47,101,109,117,47,100,105,115,116,97,116,101,46,99,0] /* src/emu/distate.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173216=allocate([78,111,32,115,116,97,116,101,32,114,101,103,105,115,116,101,114,101,100,32,102,111,114,32,100,101,118,105,99,101,32,39,37,115,39,32,116,104,97,116,32,115,117,112,112,111,114,116,115,32,105,116,33,0] /* No state registered  */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS22device_state_interface=allocate([50,50,100,101,118,105,99,101,95,115,116,97,116,101,95,105,110,116,101,114,102,97,99,101,0] /* 22device_state_inter */, "i8", ALLOC_STATIC);
__ZTI22device_state_interface=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI18device_state_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7076, 0, 0, 0, 7078, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18device_state_entryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,100,101,118,105,99,101,95,115,116,97,116,101,95,101,110,116,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18device_state_entryE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI18device_state_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7080, 0, 0, 0, 7082, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI18device_state_entryE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,56,100,101,118,105,99,101,95,115,116,97,116,101,95,101,110,116,114,121,69,0] /* 11simple_listI18devi */, "i8", ALLOC_STATIC);
__ZTI11simple_listI18device_state_entryE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str3243=allocate([76,101,103,97,99,121,32,68,101,118,105,99,101,0] /* Legacy Device\00 */, "i8", ALLOC_STATIC);
__ZTV18legacy_device_base=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7084, 0, 0, 0, 7086, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 1732, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str13244=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,99,0] /* src/emu/devlegcy.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23245=allocate([85,110,101,120,112,101,99,116,101,100,32,115,105,122,101,32,37,100,32,105,110,32,108,101,103,97,99,121,95,100,101,118,105,99,101,95,98,97,115,101,58,58,115,116,97,116,105,99,95,115,101,116,95,105,110,108,105,110,101,51,50,0] /* Unexpected size %d i */, "i8", ALLOC_STATIC);
__ZTV24legacy_sound_device_base=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7088, 0, 0, 0, 7090, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 1732, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 7092, 0, 0, 0, -368, 0, 0, 0, 0, 0, 0, 0, 7094, 0, 0, 0, 7096, 0, 0, 0, 1882, 0, 0, 0, 7098, 0, 0, 0, 7100, 0, 0, 0, 7102, 0, 0, 0, 7104, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 7106, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str53248=allocate([108,101,103,97,99,121,95,115,111,117,110,100,95,100,101,118,105,99,101,95,98,97,115,101,58,58,115,111,117,110,100,95,115,116,114,101,97,109,95,117,112,100,97,116,101,32,99,97,108,108,101,100,59,32,110,111,116,32,97,112,112,108,105,99,97,98,108,101,32,116,111,32,108,101,103,97,99,121,32,115,111,117,110,100,32,100,101,118,105,99,101,115,10,0] /* legacy_sound_device_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS18legacy_device_base=allocate([49,56,108,101,103,97,99,121,95,100,101,118,105,99,101,95,98,97,115,101,0] /* 18legacy_device_base */, "i8", ALLOC_STATIC);
__ZTI18legacy_device_base=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS24legacy_sound_device_base=allocate([50,52,108,101,103,97,99,121,95,115,111,117,110,100,95,100,101,118,105,99,101,95,98,97,115,101,0] /* 24legacy_sound_devic */, "i8", ALLOC_STATIC);
__ZTI24legacy_sound_device_base=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 94210, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTV24device_execute_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7108, 0, 0, 0, 7110, 0, 0, 0, 1882, 0, 0, 0, 1884, 0, 0, 0, 1886, 0, 0, 0, 1888, 0, 0, 0, 1890, 0, 0, 0, 1892, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1902, 0, 0, 0, 1904, 0, 0, 0, 7018, 0, 0, 0, 7020, 0, 0, 0, 7022, 0, 0, 0, 7024, 0, 0, 0, 7026, 0, 0, 0, 7028, 0, 0, 0, 1788, 0, 0, 0, 7030, 0, 0, 0, 7032, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str13273=allocate([77,67,70,71,95,68,69,86,73,67,69,95,86,66,76,65,78,75,95,73,78,84,32,99,97,108,108,101,100,32,111,110,32,100,101,118,105,99,101,32,39,37,115,39,32,119,105,116,104,32,110,111,32,101,120,101,99,117,116,101,32,105,110,116,101,114,102,97,99,101,0] /* MCFG_DEVICE_VBLANK_I */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43276=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,104,97,115,32,97,32,86,66,76,65,78,75,32,105,110,116,101,114,114,117,112,116,44,32,98,117,116,32,116,104,101,32,100,114,105,118,101,114,32,105,115,32,115,99,114,101,101,110,108,101,115,115,33,10,0] /* %s: %s device '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53277=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,104,97,115,32,97,32,110,101,119,32,86,66,76,65,78,75,32,105,110,116,101,114,114,117,112,116,32,104,97,110,100,108,101,114,32,119,105,116,104,32,62,49,32,105,110,116,101,114,114,117,112,116,115,33,10,0] /* %s: %s device '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63278=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,86,66,76,65,78,75,32,105,110,116,101,114,114,117,112,116,32,119,105,116,104,32,97,32,110,111,110,45,101,120,105,115,116,97,110,116,32,115,99,114,101,101,110,32,116,97,103,32,40,37,115,41,33,10,0] /* %s: %s device '%s' V */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73279=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,104,97,115,32,97,32,86,66,76,65,78,75,32,105,110,116,101,114,114,117,112,116,32,104,97,110,100,108,101,114,32,119,105,116,104,32,48,32,105,110,116,101,114,114,117,112,116,115,33,10,0] /* %s: %s device '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83280=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,104,97,115,32,110,111,32,86,66,76,65,78,75,32,105,110,116,101,114,114,117,112,116,32,104,97,110,100,108,101,114,32,98,117,116,32,97,32,110,111,110,45,48,32,105,110,116,101,114,114,117,112,116,32,99,111,117,110,116,32,105,115,32,103,105,118,101,110,33,10,0] /* %s: %s device '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93281=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,104,97,115,32,97,32,116,105,109,101,114,32,105,110,116,101,114,114,117,112,116,32,104,97,110,100,108,101,114,32,119,105,116,104,32,48,32,112,101,114,105,111,100,33,10,0] /* %s: %s device '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103282=allocate([37,115,58,32,37,115,32,100,101,118,105,99,101,32,39,37,115,39,32,104,97,115,32,97,32,110,111,32,116,105,109,101,114,32,105,110,116,101,114,114,117,112,116,32,104,97,110,100,108,101,114,32,98,117,116,32,104,97,115,32,97,32,110,111,110,45,48,32,112,101,114,105,111,100,32,103,105,118,101,110,33,10,0] /* %s: %s device '%s' h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113283=allocate([115,116,97,116,105,99,95,116,114,105,103,103,101,114,95,112,97,114,116,105,97,108,95,102,114,97,109,101,95,105,110,116,101,114,114,117,112,116,0] /* static_trigger_parti */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123284=allocate([115,116,97,116,105,99,95,116,114,105,103,103,101,114,95,112,101,114,105,111,100,105,99,95,105,110,116,101,114,114,117,112,116,0] /* static_trigger_perio */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133285=allocate([109,95,115,117,115,112,101,110,100,0] /* m_suspend\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143286=allocate([109,95,110,101,120,116,115,117,115,112,101,110,100,0] /* m_nextsuspend\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153287=allocate([109,95,101,97,116,99,121,99,108,101,115,0] /* m_eatcycles\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163288=allocate([109,95,110,101,120,116,101,97,116,99,121,99,108,101,115,0] /* m_nexteatcycles\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173289=allocate([109,95,116,114,105,103,103,101,114,0] /* m_trigger\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183290=allocate([109,95,116,111,116,97,108,99,121,99,108,101,115,0] /* m_totalcycles\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str193291=allocate([109,95,108,111,99,97,108,116,105,109,101,0] /* m_localtime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203292=allocate([109,95,105,108,111,111,112,115,0] /* m_iloops\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213293=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223294=allocate([109,95,105,99,111,117,110,116,112,116,114,32,110,101,118,101,114,32,105,110,105,116,105,97,108,105,122,101,100,33,0] /* m_icountptr never in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233295=allocate([115,114,99,47,101,109,117,47,100,105,101,120,101,99,46,99,0] /* src/emu/diexec.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243296=allocate([100,101,118,105,99,101,95,101,120,101,99,117,116,101,95,105,110,116,101,114,102,97,99,101,58,58,111,110,95,118,98,108,97,110,107,0] /* device_execute_inter */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253297=allocate([109,95,115,116,111,114,101,100,95,118,101,99,116,111,114,0] /* m_stored_vector\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263298=allocate([109,95,99,117,114,118,101,99,116,111,114,0] /* m_curvector\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str273299=allocate([109,95,99,117,114,115,116,97,116,101,0] /* m_curstate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str283300=allocate([100,101,118,105,99,101,32,39,37,115,39,58,32,80,85,76,83,69,95,76,73,78,69,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,102,111,114,32,78,77,73,32,97,110,100,32,82,69,83,69,84,32,108,105,110,101,115,10,0] /* device '%s': PULSE_L */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293301=allocate([69,120,99,101,101,100,101,100,32,112,101,110,100,105,110,103,32,105,110,112,117,116,32,108,105,110,101,32,101,118,101,110,116,32,113,117,101,117,101,32,111,110,32,100,101,118,105,99,101,32,39,37,115,39,33,10,0] /* Exceeded pending inp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303302=allocate([115,116,97,116,105,99,95,101,109,112,116,121,95,101,118,101,110,116,95,113,117,101,117,101,0] /* static_empty_event_q */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313303=allocate([101,109,112,116,121,95,101,118,101,110,116,95,113,117,101,117,101,32,100,101,118,105,99,101,32,39,37,115,39,44,32,108,105,110,101,32,37,100,44,32,117,110,107,110,111,119,110,32,115,116,97,116,101,32,37,100,10,0] /* empty_event_queue de */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS24device_execute_interface=allocate([50,52,100,101,118,105,99,101,95,101,120,101,99,117,116,101,95,105,110,116,101,114,102,97,99,101,0] /* 24device_execute_int */, "i8", ALLOC_STATIC);
__ZTI24device_execute_interface=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str343308=allocate([68,101,118,105,99,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,101,120,101,99,117,116,101,32,105,110,116,101,114,102,97,99,101,0] /* Device '%s' does not */, "i8", ALLOC_STATIC);
__ZN8attotime4zeroE=allocate(12, ["i32",0,0,0,"i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZN8attotime5neverE=allocate(12, ["i32",0,0,0,"i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNK8attotime9as_stringEiE7buffers=allocate(240, "i8", ALLOC_STATIC);
__ZZNK8attotime9as_stringEiE7nextbuf=allocate(1, "i32", ALLOC_STATIC);
STRING_TABLE.__str3365=allocate([37,45,42,115,0] /* %-_s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23366=allocate([40,110,101,118,101,114,41,0] /* (never)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33367=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43368=allocate([37,100,46,37,48,42,100,0] /* %d.%0_d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53369=allocate([37,100,46,37,48,57,100,37,48,42,100,0] /* %d.%09d%0_d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3382=allocate([117,115,101,114,49,0] /* user1\00 */, "i8", ALLOC_STATIC);
__ZL12rom____empty=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 16719873, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str13383=allocate([115,114,99,47,101,109,117,47,100,114,105,118,101,114,115,47,101,109,112,116,121,46,99,0] /* src/emu/drivers/empt */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23384=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33385=allocate([95,95,95,101,109,112,116,121,0] /* ___empty\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43386=allocate([78,111,32,68,114,105,118,101,114,32,76,111,97,100,101,100,0] /* No Driver Loaded\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53387=allocate([50,48,48,55,0] /* 2007\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63388=allocate([77,65,77,69,0] /* MAME\00 */, "i8", ALLOC_STATIC);
_driver____empty=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 262656, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str73391=allocate([114,111,111,116,0] /* root\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83392=allocate([115,99,114,101,101,110,0] /* screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3394=allocate([109,105,110,0] /* min\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13395=allocate([109,97,120,0] /* max\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23396=allocate([115,116,101,112,0] /* step\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33397=allocate([105,116,101,109,0] /* item\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43398=allocate([37,115,46,120,109,108,40,37,100,41,58,32,105,116,101,109,32,105,115,32,109,105,115,115,105,110,103,32,116,101,120,116,10,0] /* %s.xml(%d): item is  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53399=allocate([118,97,108,117,101,0] /* value\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63400=allocate([37,115,46,120,109,108,40,37,100,41,58,32,105,116,101,109,32,105,115,32,118,97,108,117,101,10,0] /* %s.xml(%d): item is  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73401=allocate([115,114,99,47,101,109,117,47,99,104,101,97,116,46,99,0] /* src/emu/cheat.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83402=allocate([112,97,114,97,109,0] /* param\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93403=allocate([37,100,32,40,48,120,37,88,41,0] /* %d (0x%X)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103404=allocate([63,63,63,32,40,37,100,41,0] /* ??? (%d)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113405=allocate([9,9,60,112,97,114,97,109,101,116,101,114,0] /* \09\09<parameter\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123406=allocate([32,109,105,110,61,34,37,115,34,0] /*  min=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133407=allocate([32,109,97,120,61,34,37,115,34,0] /*  max=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143408=allocate([32,115,116,101,112,61,34,37,115,34,0] /*  step=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153409=allocate([47,62,10,0] /* />\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163410=allocate([9,9,9,60,105,116,101,109,32,118,97,108,117,101,61,34,37,115,34,62,37,115,60,47,105,116,101,109,62,10,0] /* \09\09\09<item value */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173411=allocate([9,9,60,47,112,97,114,97,109,101,116,101,114,62,10,0] /* \09\09</parameter>\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183412=allocate([115,116,97,116,101,0] /* state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str193413=allocate([114,117,110,0] /* run\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203414=allocate([111,110,0] /* on\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213415=allocate([111,102,102,0] /* off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223416=allocate([99,104,97,110,103,101,0] /* change\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233417=allocate([37,115,46,120,109,108,40,37,100,41,58,32,105,110,118,97,108,105,100,32,115,99,114,105,112,116,32,115,116,97,116,101,32,39,37,115,39,10,0] /* %s.xml(%d): invalid  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243418=allocate([97,99,116,105,111,110,0] /* action\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253419=allocate([111,117,116,112,117,116,0] /* output\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263420=allocate([37,115,46,120,109,108,40,37,100,41,58,32,117,110,107,110,111,119,110,32,115,99,114,105,112,116,32,105,116,101,109,32,39,37,115,39,32,119,105,108,108,32,98,101,32,108,111,115,116,32,105,102,32,115,97,118,101,100,10,0] /* %s.xml(%d): unknown  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str273421=allocate([9,9,60,115,99,114,105,112,116,0] /* \09\09<script\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str283422=allocate([32,115,116,97,116,101,61,34,111,102,102,34,0] /*  state=\22off\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293423=allocate([32,115,116,97,116,101,61,34,111,110,34,0] /*  state=\22on\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303424=allocate([32,115,116,97,116,101,61,34,114,117,110,34,0] /*  state=\22run\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313425=allocate([32,115,116,97,116,101,61,34,99,104,97,110,103,101,34,0] /*  state=\22change\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str323426=allocate([62,10,0] /* >\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str333427=allocate([9,9,60,47,115,99,114,105,112,116,62,10,0] /* \09\09</script>\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str343428=allocate([99,111,110,100,105,116,105,111,110,0] /* condition\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str353429=allocate([37,115,46,120,109,108,40,37,100,41,58,32,109,105,115,115,105,110,103,32,101,120,112,114,101,115,115,105,111,110,32,105,110,32,97,99,116,105,111,110,32,116,97,103,10,0] /* %s.xml(%d): missing  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str363430=allocate([102,111,114,109,97,116,0] /* format\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str373431=allocate([37,115,46,120,109,108,40,37,100,41,58,32,109,105,115,115,105,110,103,32,102,111,114,109,97,116,32,105,110,32,111,117,116,112,117,116,32,116,97,103,10,0] /* %s.xml(%d): missing  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str383432=allocate([108,105,110,101,0] /* line\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str393433=allocate([97,108,105,103,110,0] /* align\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str403434=allocate([108,101,102,116,0] /* left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str413435=allocate([99,101,110,116,101,114,0] /* center\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str423436=allocate([114,105,103,104,116,0] /* right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str433437=allocate([37,115,46,120,109,108,40,37,100,41,58,32,105,110,118,97,108,105,100,32,97,108,105,103,110,109,101,110,116,32,39,37,115,39,32,115,112,101,99,105,102,105,101,100,10,0] /* %s.xml(%d): invalid  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str443438=allocate([97,114,103,117,109,101,110,116,0] /* argument\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str453439=allocate([37,115,46,120,109,108,40,37,100,41,58,32,116,111,111,32,109,97,110,121,32,97,114,103,117,109,101,110,116,115,32,40,102,111,117,110,100,32,37,100,44,32,109,97,120,32,105,115,32,37,100,41,10,0] /* %s.xml(%d): too many */, "i8", ALLOC_STATIC);
STRING_TABLE.__str463440=allocate([37,115,46,120,109,108,40,37,100,41,58,32,101,114,114,111,114,32,112,97,114,115,105,110,103,32,99,104,101,97,116,32,101,120,112,114,101,115,115,105,111,110,32,34,37,115,34,32,40,37,115,41,10,0] /* %s.xml(%d): error pa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str473441=allocate([69,114,114,111,114,32,101,120,101,99,117,116,105,110,103,32,99,111,110,100,105,116,105,111,110,97,108,32,101,120,112,114,101,115,115,105,111,110,32,34,37,115,34,58,32,37,115,10,0] /* Error executing cond */, "i8", ALLOC_STATIC);
STRING_TABLE.__str483442=allocate([69,114,114,111,114,32,101,120,101,99,117,116,105,110,103,32,101,120,112,114,101,115,115,105,111,110,32,34,37,115,34,58,32,37,115,10,0] /* Error executing expr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str493443=allocate([9,9,9,60,97,99,116,105,111,110,0] /* \09\09\09<action\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str503444=allocate([32,99,111,110,100,105,116,105,111,110,61,34,37,115,34,0] /*  condition=\22%s\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str513445=allocate([62,37,115,60,47,97,99,116,105,111,110,62,10,0] /* >%s</action>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str523446=allocate([9,9,9,60,111,117,116,112,117,116,32,102,111,114,109,97,116,61,34,37,115,34,0] /* \09\09\09<output for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str533447=allocate([32,108,105,110,101,61,34,37,100,34,0] /*  line=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str543448=allocate([32,97,108,105,103,110,61,34,99,101,110,116,101,114,34,0] /*  align=\22center\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str553449=allocate([32,97,108,105,103,110,61,34,114,105,103,104,116,34,0] /*  align=\22right\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str563450=allocate([32,47,62,10,0] /*  />\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str573451=allocate([9,9,9,60,47,111,117,116,112,117,116,62,10,0] /* \09\09\09</output>\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str583452=allocate([108,104,48,49,50,51,52,53,54,55,56,57,46,45,43,32,35,0] /* lh0123456789.-+ #\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str593453=allocate([99,100,105,111,117,120,88,0] /* cdiouxX\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str603454=allocate([37,115,46,120,109,108,40,37,100,41,58,32,105,110,118,97,108,105,100,32,102,111,114,109,97,116,32,115,112,101,99,105,102,105,99,97,116,105,111,110,32,34,37,115,34,10,0] /* %s.xml(%d): invalid  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str613455=allocate([37,115,46,120,109,108,40,37,100,41,58,32,116,111,111,32,109,97,110,121,32,97,114,103,117,109,101,110,116,115,32,112,114,111,118,105,100,101,100,32,40,37,100,41,32,102,111,114,32,102,111,114,109,97,116,32,34,37,115,34,10,0] /* %s.xml(%d): too many */, "i8", ALLOC_STATIC);
STRING_TABLE.__str623456=allocate([37,115,46,120,109,108,40,37,100,41,58,32,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,112,114,111,118,105,100,101,100,32,40,37,100,41,32,102,111,114,32,102,111,114,109,97,116,32,34,37,115,34,10,0] /* %s.xml(%d): not enou */, "i8", ALLOC_STATIC);
STRING_TABLE.__str633457=allocate([99,111,117,110,116,0] /* count\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str643458=allocate([37,115,46,120,109,108,40,37,100,41,58,32,109,105,115,115,105,110,103,32,101,120,112,114,101,115,115,105,111,110,32,105,110,32,97,114,103,117,109,101,110,116,32,116,97,103,10,0] /* %s.xml(%d): missing  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str653459=allocate([69,114,114,111,114,32,101,120,101,99,117,116,105,110,103,32,97,114,103,117,109,101,110,116,32,101,120,112,114,101,115,115,105,111,110,32,34,37,115,34,58,32,37,115,10,0] /* Error executing argu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str663460=allocate([9,9,9,9,60,97,114,103,117,109,101,110,116,0] /* \09\09\09\09<argumen */, "i8", ALLOC_STATIC);
STRING_TABLE.__str673461=allocate([32,99,111,117,110,116,61,34,37,100,34,0] /*  count=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str683462=allocate([62,37,115,60,47,97,114,103,117,109,101,110,116,62,10,0] /* >%s</argument>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str693463=allocate([116,101,109,112,118,97,114,105,97,98,108,101,115,0] /* tempvariables\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str703464=allocate([37,115,46,120,109,108,40,37,100,41,58,32,105,110,118,97,108,105,100,32,116,101,109,112,118,97,114,105,97,98,108,101,115,32,97,116,116,114,105,98,117,116,101,32,40,37,100,41,10,0] /* %s.xml(%d): invalid  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str713465=allocate([100,101,115,99,0] /* desc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str723466=allocate([37,115,46,120,109,108,40,37,100,41,58,32,101,109,112,116,121,32,111,114,32,109,105,115,115,105,110,103,32,100,101,115,99,32,97,116,116,114,105,98,117,116,101,32,111,110,32,99,104,101,97,116,10,0] /* %s.xml(%d): empty or */, "i8", ALLOC_STATIC);
STRING_TABLE.__str733467=allocate([97,114,103,105,110,100,101,120,0] /* argindex\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str743468=allocate([116,101,109,112,37,100,0] /* temp%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str753469=allocate([99,111,109,109,101,110,116,0] /* comment\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str763470=allocate([37,115,46,120,109,108,40,37,100,41,58,32,111,110,108,121,32,111,110,101,32,99,111,109,109,101,110,116,32,110,111,100,101,32,105,115,32,114,101,116,97,105,110,101,100,59,32,105,103,110,111,114,105,110,103,32,97,100,100,105,116,105,111,110,97,108,32,110,111,100,101,115,10,0] /* %s.xml(%d): only one */, "i8", ALLOC_STATIC);
STRING_TABLE.__str773471=allocate([112,97,114,97,109,101,116,101,114,0] /* parameter\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str783472=allocate([37,115,46,120,109,108,40,37,100,41,58,32,111,110,108,121,32,111,110,101,32,112,97,114,97,109,101,116,101,114,32,110,111,100,101,32,97,108,108,111,119,101,100,59,32,105,103,110,111,114,105,110,103,32,97,100,100,105,116,105,111,110,97,108,32,110,111,100,101,115,10,0] /* %s.xml(%d): only one */, "i8", ALLOC_STATIC);
STRING_TABLE.__str793473=allocate([115,99,114,105,112,116,0] /* script\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str803474=allocate([37,115,46,120,109,108,40,37,100,41,58,32,111,110,108,121,32,111,110,101,32,111,110,32,115,99,114,105,112,116,32,97,108,108,111,119,101,100,59,32,105,103,110,111,114,105,110,103,32,97,100,100,105,116,105,111,110,97,108,32,115,99,114,105,112,116,115,10,0] /* %s.xml(%d): only one */, "i8", ALLOC_STATIC);
STRING_TABLE.__str813475=allocate([9,60,99,104,101,97,116,32,100,101,115,99,61,34,37,115,34,0] /* \09<cheat desc=\22%s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str823476=allocate([32,116,101,109,112,118,97,114,105,97,98,108,101,115,61,34,37,100,34,0] /*  tempvariables=\22%d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str833477=allocate([9,9,60,99,111,109,109,101,110,116,62,60,33,91,67,68,65,84,65,91,10,37,115,10,9,9,93,93,62,60,47,99,111,109,109,101,110,116,62,10,0] /* \09\09<comment><![CD */, "i8", ALLOC_STATIC);
STRING_TABLE.__str843478=allocate([9,60,47,99,104,101,97,116,62,10,0] /* \09</cheat>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str853479=allocate([65,99,116,105,118,97,116,101,100,32,37,115,0] /* Activated %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str863480=allocate([65,99,116,105,118,97,116,101,100,10,32,37,115,32,61,32,37,115,0] /* Activated\0A %s = %s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str873481=allocate([45,45,45,0] /* ---\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str883482=allocate([83,101,116,0] /* Set\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str893483=allocate([79,110,0] /* On\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str903484=allocate([79,102,102,0] /* Off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str913485=allocate([99,104,101,97,116,95,109,97,110,97,103,101,114,58,58,102,114,97,109,101,95,117,112,100,97,116,101,0] /* cheat_manager::frame */, "i8", ALLOC_STATIC);
STRING_TABLE.__str923486=allocate([102,114,97,109,101,0] /* frame\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str933487=allocate([102,114,111,109,98,99,100,0] /* frombcd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str943488=allocate([116,111,98,99,100,0] /* tobcd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str953489=allocate([67,104,101,97,116,115,32,68,105,115,97,98,108,101,100,0] /* Cheats Disabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str963490=allocate([67,104,101,97,116,115,32,69,110,97,98,108,101,100,0] /* Cheats Enabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str973491=allocate([37,48,56,88,0] /* %08X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str983492=allocate([46,120,109,108,0] /* .xml\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str993493=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1003494=allocate([60,33,45,45,32,84,104,105,115,32,102,105,108,101,32,105,115,32,97,117,116,111,103,101,110,101,114,97,116,101,100,59,32,99,111,109,109,101,110,116,115,32,97,110,100,32,117,110,107,110,111,119,110,32,116,97,103,115,32,119,105,108,108,32,98,101,32,115,116,114,105,112,112,101,100,32,45,45,62,10,0] /* <!-- This file is au */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1013495=allocate([60,109,97,109,101,99,104,101,97,116,32,118,101,114,115,105,111,110,61,34,37,100,34,62,10,0] /* <mamecheat version=\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1023496=allocate([60,47,109,97,109,101,99,104,101,97,116,62,10,0] /* </mamecheat>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1033497=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1043498=allocate([32,38,38,32,0] /*  && \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1053499=allocate([32,97,110,100,32,0] /*  and \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1063500=allocate([32,38,38,0] /*  &&\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1073501=allocate([38,38,32,0] /* && \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1083502=allocate([38,38,0] /* &&\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1093503=allocate([32,38,32,0] /*  & \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1103504=allocate([32,98,97,110,100,32,0] /*  band \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1113505=allocate([32,38,0] /*  &\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1123506=allocate([38,32,0] /* & \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1133507=allocate([38,0] /* &\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1143508=allocate([32,60,61,32,0] /*  <= \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1153509=allocate([32,108,101,32,0] /*  le \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1163510=allocate([32,60,61,0] /*  <=\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1173511=allocate([60,61,32,0] /* <= \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1183512=allocate([60,61,0] /* <=\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1193513=allocate([32,60,32,0] /*  < \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1203514=allocate([32,108,116,32,0] /*  lt \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1213515=allocate([32,60,0] /*  <\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1223516=allocate([60,32,0] /* < \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1233517=allocate([60,0] /* <\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1243518=allocate([32,60,60,32,0] /*  << \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1253519=allocate([32,108,115,104,105,102,116,32,0] /*  lshift \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1263520=allocate([32,60,60,0] /*  <<\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1273521=allocate([60,60,32,0] /* << \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1283522=allocate([60,60,0] /* <<\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1293523=allocate([76,111,97,100,105,110,103,32,99,104,101,97,116,115,32,102,105,108,101,32,102,114,111,109,32,37,115,10,0] /* Loading cheats file  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1303524=allocate([37,115,46,120,109,108,40,37,100,41,58,32,101,114,114,111,114,32,112,97,114,115,105,110,103,32,88,77,76,32,40,37,115,41,10,0] /* %s.xml(%d): error pa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1313525=allocate([109,97,109,101,99,104,101,97,116,0] /* mamecheat\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1323526=allocate([37,115,46,120,109,108,58,32,109,105,115,115,105,110,103,32,109,97,109,101,99,104,101,97,116,110,111,100,101,32,110,111,100,101,0] /* %s.xml: missing mame */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1333527=allocate([118,101,114,115,105,111,110,0] /* version\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1343528=allocate([37,115,46,120,109,108,40,37,100,41,58,32,73,110,118,97,108,105,100,32,99,104,101,97,116,32,88,77,76,32,102,105,108,101,58,32,117,110,115,117,112,112,111,114,116,101,100,32,118,101,114,115,105,111,110,0] /* %s.xml(%d): Invalid  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1353529=allocate([99,104,101,97,116,0] /* cheat\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI11cheat_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7114, 0, 0, 0, 7116, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11cheat_entryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,99,104,101,97,116,95,101,110,116,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11cheat_entryE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS13cheat_manager=allocate([49,51,99,104,101,97,116,95,109,97,110,97,103,101,114,0] /* 13cheat_manager\00 */, "i8", ALLOC_STATIC);
__ZTI13cheat_manager=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI12cheat_scriptE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7118, 0, 0, 0, 7120, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12cheat_scriptE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,99,104,101,97,116,95,115,99,114,105,112,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12cheat_scriptE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI15cheat_parameterE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7122, 0, 0, 0, 7124, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI15cheat_parameterE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,53,99,104,101,97,116,95,112,97,114,97,109,101,116,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI15cheat_parameterE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7126, 0, 0, 0, 7128, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,99,104,101,97,116,95,115,99,114,105,112,116,49,50,115,99,114,105,112,116,95,101,110,116,114,121,49,53,111,117,116,112,117,116,95,97,114,103,117,109,101,110,116,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN12cheat_script12script_entry15output_argumentEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7130, 0, 0, 0, 7132, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN12cheat_script12script_entry15output_argumentEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,50,99,104,101,97,116,95,115,99,114,105,112,116,49,50,115,99,114,105,112,116,95,101,110,116,114,121,49,53,111,117,116,112,117,116,95,97,114,103,117,109,101,110,116,69,69,0] /* 11simple_listIN12che */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN12cheat_script12script_entry15output_argumentEE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN12cheat_script12script_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7134, 0, 0, 0, 7136, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN12cheat_script12script_entryEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,50,99,104,101,97,116,95,115,99,114,105,112,116,49,50,115,99,114,105,112,116,95,101,110,116,114,121,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN12cheat_script12script_entryEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN12cheat_script12script_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7138, 0, 0, 0, 7140, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN12cheat_script12script_entryEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,50,99,104,101,97,116,95,115,99,114,105,112,116,49,50,115,99,114,105,112,116,95,101,110,116,114,121,69,69,0] /* 11simple_listIN12che */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN12cheat_script12script_entryEE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN15cheat_parameter4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7142, 0, 0, 0, 7144, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN15cheat_parameter4itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,53,99,104,101,97,116,95,112,97,114,97,109,101,116,101,114,52,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN15cheat_parameter4itemEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN15cheat_parameter4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7146, 0, 0, 0, 7148, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN15cheat_parameter4itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,53,99,104,101,97,116,95,112,97,114,97,109,101,116,101,114,52,105,116,101,109,69,69,0] /* 11simple_listIN15che */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN15cheat_parameter4itemEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str1363530=allocate([99,104,101,97,116,112,97,116,104,0] /* cheatpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1383532=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1393533=allocate([35,37,100,0] /* #%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1403534=allocate([36,37,88,0] /* $%X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1413535=allocate([48,120,37,88,0] /* 0x%X\00 */, "i8", ALLOC_STATIC);
__ZN13sound_manager23STREAMS_UPDATE_ATTOTIMEE=allocate(12, ["i32",0,0,0,"i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str3538=allocate([115,114,99,47,101,109,117,47,115,111,117,110,100,46,99,0] /* src/emu/sound.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13539=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,115,111,117,110,100,95,115,116,114,101,97,109,32,119,105,116,104,32,97,32,110,111,110,45,115,111,117,110,100,32,100,101,118,105,99,101,0] /* Attempted to create  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23540=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33541=allocate([115,116,114,101,97,109,0] /* stream\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43542=allocate([109,95,115,97,109,112,108,101,95,114,97,116,101,0] /* m_sample_rate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53543=allocate([115,111,117,110,100,95,115,116,114,101,97,109,58,58,112,111,115,116,108,111,97,100,0] /* sound_stream::postlo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63544=allocate([109,95,105,110,112,117,116,91,105,110,112,117,116,110,117,109,93,46,109,95,103,97,105,110,0] /* m_input[inputnum].m_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73545=allocate([109,95,111,117,116,112,117,116,91,111,117,116,112,117,116,110,117,109,93,46,109,95,103,97,105,110,0] /* m_output[outputnum]. */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83546=allocate([37,115,32,39,37,115,39,58,32,0] /* %s '%s': \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93547=allocate([37,115,32,39,37,115,39,0] /* %s '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103548=allocate([32,67,104,46,37,100,0] /*  Ch.%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113549=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,115,116,114,101,97,109,95,115,101,116,95,105,110,112,117,116,32,97,116,116,101,109,112,116,101,100,32,116,111,32,99,111,110,102,105,103,117,114,101,32,110,111,110,45,101,120,105,115,116,97,110,116,32,105,110,112,117,116,32,37,100,32,40,37,100,32,109,97,120,41,0] /* Fatal error: stream_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123550=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,115,116,114,101,97,109,95,115,101,116,95,105,110,112,117,116,32,97,116,116,101,109,112,116,101,100,32,116,111,32,117,115,101,32,97,32,110,111,110,45,101,120,105,115,116,97,110,116,32,111,117,116,112,117,116,32,37,100,32,40,37,100,32,109,97,120,41,0] /* Fatal error: stream_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133551=allocate([117,112,100,97,116,101,95,115,116,97,116,105,99,0] /* update_static\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143552=allocate([109,105,120,101,114,0] /* mixer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153553=allocate([115,111,117,110,100,95,109,97,110,97,103,101,114,58,58,99,111,110,102,105,103,95,108,111,97,100,0] /* sound_manager::confi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163554=allocate([115,111,117,110,100,95,109,97,110,97,103,101,114,58,58,99,111,110,102,105,103,95,115,97,118,101,0] /* sound_manager::confi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173555=allocate([115,111,117,110,100,95,109,97,110,97,103,101,114,58,58,112,97,117,115,101,0] /* sound_manager::pause */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183556=allocate([115,111,117,110,100,95,109,97,110,97,103,101,114,58,58,114,101,115,117,109,101,0] /* sound_manager::resum */, "i8", ALLOC_STATIC);
STRING_TABLE.__str193557=allocate([115,111,117,110,100,95,109,97,110,97,103,101,114,58,58,114,101,115,101,116,0] /* sound_manager::reset */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203558=allocate([109,95,108,97,115,116,95,117,112,100,97,116,101,0] /* m_last_update\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213559=allocate([99,104,97,110,110,101,108,0] /* channel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223560=allocate([105,110,100,101,120,0] /* index\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233561=allocate([100,101,102,118,111,108,0] /* defvol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243562=allocate([110,101,119,118,111,108,0] /* newvol\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI12sound_streamE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7150, 0, 0, 0, 7152, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12sound_streamE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,115,111,117,110,100,95,115,116,114,101,97,109,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12sound_streamE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS13sound_manager=allocate([49,51,115,111,117,110,100,95,109,97,110,97,103,101,114,0] /* 13sound_manager\00 */, "i8", ALLOC_STATIC);
__ZTI13sound_manager=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIsE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7154, 0, 0, 0, 7156, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIsE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,115,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIsE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI12sound_streamE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7158, 0, 0, 0, 7160, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI12sound_streamE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,50,115,111,117,110,100,95,115,116,114,101,97,109,69,0] /* 11simple_listI12soun */, "i8", ALLOC_STATIC);
__ZTI11simple_listI12sound_streamE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS12sound_stream=allocate([49,50,115,111,117,110,100,95,115,116,114,101,97,109,0] /* 12sound_stream\00 */, "i8", ALLOC_STATIC);
__ZTI12sound_stream=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIN12sound_stream13stream_outputEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7162, 0, 0, 0, 7164, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIN12sound_stream13stream_outputEE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,78,49,50,115,111,117,110,100,95,115,116,114,101,97,109,49,51,115,116,114,101,97,109,95,111,117,116,112,117,116,69,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIN12sound_stream13stream_outputEE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIPiE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7166, 0, 0, 0, 7168, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIPiE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,80,105,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIPiE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIN12sound_stream12stream_inputEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7170, 0, 0, 0, 7172, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIN12sound_stream12stream_inputEE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,78,49,50,115,111,117,110,100,95,115,116,114,101,97,109,49,50,115,116,114,101,97,109,95,105,110,112,117,116,69,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIN12sound_stream12stream_inputEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str283566=allocate([118,111,108,117,109,101,0] /* volume\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293567=allocate([97,118,105,119,114,105,116,101,0] /* aviwrite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303568=allocate([119,97,118,119,114,105,116,101,0] /* wavwrite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313569=allocate([115,111,117,110,100,0] /* sound\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3579=allocate([115,114,99,47,101,109,117,47,100,114,97,119,103,102,120,46,99,0] /* src/emu/drawgfx.c\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI11gfx_elementE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7174, 0, 0, 0, 7176, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11gfx_elementE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,103,102,120,95,101,108,101,109,101,110,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11gfx_elementE=allocate(12, "*", ALLOC_STATIC);
__ZL8typelist=allocate(1, "%struct._config_type*", ALLOC_STATIC);
STRING_TABLE.__str3586=allocate([115,114,99,47,101,109,117,47,99,111,110,102,105,103,46,99,0] /* src/emu/config.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13587=allocate([46,99,102,103,0] /* .cfg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23588=allocate([67,111,117,108,100,32,110,111,116,32,108,111,97,100,32,99,111,110,116,114,111,108,108,101,114,32,102,105,108,101,32,37,115,46,99,102,103,0] /* Could not load contr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33589=allocate([100,101,102,97,117,108,116,46,99,102,103,0] /* default.cfg\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI12_config_typeE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7178, 0, 0, 0, 7180, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12_config_typeE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,95,99,111,110,102,105,103,95,116,121,112,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12_config_typeE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str43590=allocate([109,97,109,101,99,111,110,102,105,103,0] /* mameconfig\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53591=allocate([118,101,114,115,105,111,110,0] /* version\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63592=allocate([115,121,115,116,101,109,0] /* system\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73593=allocate([110,97,109,101,0] /* name\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83594=allocate([100,101,102,97,117,108,116,0] /* default\00 */, "i8", ALLOC_STATIC);
__str93595=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str103596=allocate([99,102,103,95,100,105,114,101,99,116,111,114,121,0] /* cfg_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113597=allocate([99,116,114,108,114,112,97,116,104,0] /* ctrlrpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123598=allocate([99,116,114,108,114,0] /* ctrlr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3607=allocate([115,114,99,47,101,109,117,47,109,97,99,104,105,110,101,47,103,101,110,101,114,105,99,46,99,0] /* src/emu/machine/gene */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13608=allocate([115,116,97,116,101,45,62,99,111,105,110,95,99,111,117,110,116,0] /* state->coin_count\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23609=allocate([115,116,97,116,101,45,62,99,111,105,110,108,111,99,107,101,100,111,117,116,0] /* state->coinlockedout */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33610=allocate([115,116,97,116,101,45,62,108,97,115,116,99,111,105,110,0] /* state->lastcoin\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43611=allocate([105,110,116,101,114,114,117,112,116,95,114,101,115,101,116,0] /* interrupt_reset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53612=allocate([115,116,97,116,101,45,62,105,110,116,101,114,114,117,112,116,95,101,110,97,98,108,101,0] /* state->interrupt_ena */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63613=allocate([99,111,117,110,116,101,114,115,0] /* counters\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73614=allocate([99,111,117,110,116,101,114,115,95,108,111,97,100,0] /* counters_load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83615=allocate([99,111,117,110,116,101,114,115,95,115,97,118,101,0] /* counters_save\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93616=allocate([115,116,97,116,101,45,62,109,101,109,99,97,114,100,95,105,110,115,101,114,116,101,100,0] /* state->memcard_inser */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103617=allocate([109,101,109,99,97,114,100,95,101,106,101,99,116,0] /* memcard_eject\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113618=allocate([46,110,118,0] /* .nv\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123619=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173624=allocate([103,108,111,98,97,108,0] /* global\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI24_generic_machine_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7182, 0, 0, 0, 7184, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI24_generic_machine_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,52,95,103,101,110,101,114,105,99,95,109,97,99,104,105,110,101,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI24_generic_machine_privateE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str203627=allocate([109,101,109,99,97,114,100,95,100,105,114,101,99,116,111,114,121,0] /* memcard_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213628=allocate([109,101,109,99,97,114,100,46,37,48,51,100,0] /* memcard.%03d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223629=allocate([110,118,114,97,109,95,100,105,114,101,99,116,111,114,121,0] /* nvram_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233630=allocate([99,111,105,110,115,0] /* coins\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243631=allocate([105,110,100,101,120,0] /* index\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253632=allocate([110,117,109,98,101,114,0] /* number\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263633=allocate([116,105,99,107,101,116,115,0] /* tickets\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3642=allocate([111,117,116,112,117,116,95,112,97,117,115,101,0] /* output_pause\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13643=allocate([111,117,116,112,117,116,95,114,101,115,117,109,101,0] /* output_resume\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23644=allocate([111,117,116,112,117,116,95,101,120,105,116,0] /* output_exit\00 */, "i8", ALLOC_STATIC);
__ZL9itemtable=allocate(212, "*", ALLOC_STATIC);
__ZL17global_notifylist=allocate(1, "%struct._output_notify*", ALLOC_STATIC);
STRING_TABLE.__str33645=allocate([115,114,99,47,101,109,117,47,111,117,116,112,117,116,46,99,0] /* src/emu/output.c\00 */, "i8", ALLOC_STATIC);
__ZL8uniqueid=allocate([12345], ["i32",0,0,0,0], ALLOC_STATIC);
__ZTV20resource_pool_objectI12_output_itemE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7186, 0, 0, 0, 7188, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12_output_itemE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,95,111,117,116,112,117,116,95,105,116,101,109,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12_output_itemE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str43646=allocate([112,97,117,115,101,0] /* pause\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3651=allocate([115,114,99,47,101,109,117,47,101,109,117,112,97,108,46,99,0] /* src/emu/emupal.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13652=allocate([112,97,108,101,116,116,101,95,101,120,105,116,0] /* palette_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23653=allocate([85,110,115,117,112,112,111,114,116,101,100,32,115,99,114,101,101,110,32,98,105,116,109,97,112,32,102,111,114,109,97,116,33,0] /* Unsupported screen b */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33654=allocate([112,97,108,101,116,116,101,45,62,115,97,118,101,95,112,101,110,0] /* palette->save_pen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43655=allocate([112,97,108,101,116,116,101,45,62,115,97,118,101,95,98,114,105,103,104,116,0] /* palette->save_bright */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53656=allocate([112,97,108,101,116,116,101,95,112,114,101,115,97,118,101,0] /* palette_presave\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63657=allocate([112,97,108,101,116,116,101,95,112,111,115,116,108,111,97,100,0] /* palette_postload\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93660=allocate([103,108,111,98,97,108,0] /* global\00 */, "i8", ALLOC_STATIC);
__ZTV19resource_pool_arrayIfE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7190, 0, 0, 0, 7192, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIfE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,102,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIfE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI16_palette_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7194, 0, 0, 0, 7196, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16_palette_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,95,112,97,108,101,116,116,101,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16_palette_privateE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str103661=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113662=allocate([69,114,114,111,114,58,32,112,97,108,101,116,116,101,32,104,97,115,32,109,111,114,101,32,116,104,97,110,32,54,53,53,51,54,32,99,111,108,111,114,115,46,0] /* Error: palette has m */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123663=allocate([70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,115,121,115,116,101,109,32,112,97,108,101,116,116,101,0] /* Failed to allocate s */, "i8", ALLOC_STATIC);
_image_ioprocs=allocate([0, 0, 0, 0, 7198, 0, 0, 0, 7200, 0, 0, 0, 7202, 0, 0, 0, 7204, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str3669=allocate([68,101,118,105,99,101,32,37,115,32,108,111,97,100,32,40,37,115,41,32,102,97,105,108,101,100,58,32,37,115,0] /* Device %s load (%s)  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13670=allocate([68,114,105,118,101,114,32,114,101,113,117,105,114,101,115,32,116,104,97,116,32,100,101,118,105,99,101,32,34,37,115,34,32,109,117,115,116,32,104,97,118,101,32,97,110,32,105,109,97,103,101,32,116,111,32,108,111,97,100,0] /* Driver requires that */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23671=allocate([68,101,118,105,99,101,32,37,115,32,108,111,97,100,32,102,97,105,108,101,100,58,32,37,115,0] /* Device %s load faile */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33672=allocate([105,109,97,103,101,95,117,110,108,111,97,100,95,97,108,108,0] /* image_unload_all\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43673=allocate([105,109,97,103,101,95,100,105,114,101,99,116,111,114,105,101,115,0] /* image_directories\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53674=allocate([105,109,97,103,101,95,100,105,114,115,95,108,111,97,100,0] /* image_dirs_load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63675=allocate([105,109,97,103,101,95,100,105,114,115,95,115,97,118,101,0] /* image_dirs_save\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73676=allocate([37,115,10,10,0] /* %s\0A\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83677=allocate([37,115,58,32,37,115,10,0] /* %s: %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93678=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103679=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113680=allocate([44,32,37,115,0] /* , %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123681=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133682=allocate([78,111,116,32,115,117,112,112,111,114,116,101,100,10,0] /* Not supported\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143683=allocate([80,97,114,116,105,97,108,121,32,115,117,112,112,111,114,116,101,100,10,0] /* Partialy supported\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153684=allocate([115,114,99,47,101,109,117,47,105,109,97,103,101,46,99,0] /* src/emu/image.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163685=allocate([37,115,58,32,45,45,45,10,0] /* %s: ---\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173686=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183687=allocate([77,117,115,116,32,115,112,101,99,105,102,121,32,115,101,110,115,105,99,97,108,32,98,117,102,102,101,114,47,108,101,110,103,116,104,0] /* Must specify sensica */, "i8", ALLOC_STATIC);
__ZZL10stripspacePKcE4buff=allocate(512, "i8", ALLOC_STATIC);
STRING_TABLE.__str203689=allocate([100,101,118,105,99,101,0] /* device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213690=allocate([105,110,115,116,97,110,99,101,0] /* instance\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223691=allocate([100,105,114,101,99,116,111,114,121,0] /* directory\00 */, "i8", ALLOC_STATIC);
__str233692=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str243693=allocate([37,115,46,105,110,105,0] /* %s.ini\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253694=allocate([105,110,105,112,97,116,104,0] /* inipath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263695=allocate([119,114,105,116,101,99,111,110,102,105,103,0] /* writeconfig\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3708=allocate([115,114,99,47,101,109,117,47,116,105,108,101,109,97,112,46,99,0] /* src/emu/tilemap.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13709=allocate([116,105,108,101,109,97,112,95,101,120,105,116,0] /* tilemap_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23710=allocate([116,105,108,101,109,97,112,95,100,114,97,119,95,112,114,105,109,97,115,107,58,32,73,110,118,97,108,105,100,32,98,105,116,109,97,112,32,102,111,114,109,97,116,0] /* tilemap_draw_primask */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3732=allocate([97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,95,46,58,0] /* abcdefghijklmnopqrst */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13733=allocate([109,97,105,110,0] /* main\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23734=allocate([97,117,100,105,111,0] /* audio\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33735=allocate([115,111,117,110,100,0] /* sound\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43736=allocate([108,101,102,116,0] /* left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53737=allocate([114,105,103,104,116,0] /* right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63738=allocate([37,115,58,32,37,115,32,104,97,115,32,105,110,118,97,108,105,100,32,103,101,110,101,114,105,99,32,116,97,103,32,39,37,115,39,10,0] /* %s: %s has invalid g */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73739=allocate([37,115,58,32,37,115,32,104,97,115,32,37,115,32,119,105,116,104,32,116,97,103,32,39,37,115,39,32,99,111,110,116,97,105,110,105,110,103,32,117,112,112,101,114,45,99,97,115,101,32,99,104,97,114,97,99,116,101,114,115,10,0] /* %s: %s has %s with t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83740=allocate([37,115,58,32,37,115,32,104,97,115,32,37,115,32,119,105,116,104,32,116,97,103,32,39,37,115,39,32,99,111,110,116,97,105,110,105,110,103,32,115,112,97,99,101,115,10,0] /* %s: %s has %s with t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93741=allocate([37,115,58,32,37,115,32,104,97,115,32,37,115,32,119,105,116,104,32,116,97,103,32,39,37,115,39,32,99,111,110,116,97,105,110,105,110,103,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,39,37,99,39,10,0] /* %s: %s has %s with t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103742=allocate([37,115,58,32,37,115,32,104,97,115,32,37,115,32,119,105,116,104,32,48,45,108,101,110,103,116,104,32,116,97,103,10,0] /* %s: %s has %s with 0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113743=allocate([37,115,58,32,37,115,32,104,97,115,32,37,115,32,119,105,116,104,32,116,97,103,32,39,37,115,39,32,60,32,37,100,32,99,104,97,114,97,99,116,101,114,115,10,0] /* %s: %s has %s with t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123744=allocate([37,115,58,32,37,115,32,104,97,115,32,37,115,32,119,105,116,104,32,116,97,103,32,39,37,115,39,32,62,32,37,100,32,99,104,97,114,97,99,116,101,114,115,10,0] /* %s: %s has %s with t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133745=allocate([85,73,78,84,56,32,109,117,115,116,32,98,101,32,56,32,98,105,116,115,10,0] /* UINT8 must be 8 bits */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143746=allocate([76,83,66,95,70,73,82,83,84,32,115,112,101,99,105,102,105,101,100,44,32,98,117,116,32,114,117,110,110,105,110,103,32,111,110,32,97,32,98,105,103,45,101,110,100,105,97,110,32,109,97,99,104,105,110,101,10,0] /* LSB_FIRST specified, */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153747=allocate([86,97,108,105,100,97,116,105,110,103,32,37,115,32,40,37,115,41,58,32,37,115,0] /* Validating %s (%s):  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163748=allocate([86,97,108,105,100,105,116,121,32,99,104,101,99,107,115,32,102,97,105,108,101,100,0] /* Validity checks fail */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173749=allocate([37,115,58,32,37,115,32,104,97,115,32,109,117,108,116,105,112,108,101,32,100,101,118,105,99,101,115,32,119,105,116,104,32,116,104,101,32,116,97,103,32,39,37,115,39,10,0] /* %s: %s has multiple  */, "i8", ALLOC_STATIC);
__str183750=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str193751=allocate([68,101,118,105,99,101,32,37,115,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,115,104,111,114,116,32,110,97,109,101,32,100,101,102,105,110,101,100,10,0] /* Device %s does not h */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203752=allocate([37,115,58,32,37,115,32,104,97,115,32,103,102,120,91,37,100,93,32,114,101,102,101,114,101,110,99,105,110,103,32,110,111,110,45,101,120,105,115,116,101,110,116,32,114,101,103,105,111,110,32,39,37,115,39,10,0] /* %s: %s has gfx[%d] r */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213753=allocate([37,115,58,32,37,115,32,104,97,115,32,103,102,120,91,37,100,93,32,101,120,116,101,110,100,105,110,103,32,112,97,115,116,32,97,108,108,111,99,97,116,101,100,32,109,101,109,111,114,121,32,111,102,32,114,101,103,105,111,110,32,39,37,115,39,10,0] /* %s: %s has gfx[%d] e */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223754=allocate([37,115,58,32,37,115,32,104,97,115,32,103,102,120,91,37,100,93,32,119,105,116,104,32,117,110,115,117,112,112,111,114,116,101,100,32,108,97,121,111,117,116,32,116,111,116,97,108,10,0] /* %s: %s has gfx[%d] w */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233755=allocate([37,115,58,32,37,115,32,104,97,115,32,103,102,120,91,37,100,93,32,119,105,116,104,32,117,110,115,117,112,112,111,114,116,101,100,32,120,115,99,97,108,101,47,121,115,99,97,108,101,10,0] /* %s: %s has gfx[%d] w */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243756=allocate([37,115,58,32,37,115,32,104,97,115,32,103,102,120,91,37,100,93,32,119,105,116,104,32,105,110,118,97,108,105,100,32,112,108,97,110,101,115,10,0] /* %s: %s has gfx[%d] w */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253757=allocate([37,115,58,32,37,115,32,104,97,115,32,103,102,120,91,37,100,93,32,119,105,116,104,32,105,110,118,97,108,105,100,32,120,115,99,97,108,101,47,121,115,99,97,108,101,10,0] /* %s: %s has gfx[%d] w */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263758=allocate([37,115,58,32,37,115,32,104,97,115,32,122,101,114,111,32,112,97,108,101,116,116,101,32,101,110,116,114,105,101,115,10,0] /* %s: %s has zero pale */, "i8", ALLOC_STATIC);
STRING_TABLE.__str273759=allocate([37,115,58,32,37,115,32,104,97,115,32,105,110,112,117,116,32,112,111,114,116,32,101,114,114,111,114,115,58,10,37,115,10,0] /* %s: %s has input por */, "i8", ALLOC_STATIC);
STRING_TABLE.__str283760=allocate([37,115,58,32,37,115,32,104,97,115,32,97,32,100,117,112,108,105,99,97,116,101,32,105,110,112,117,116,32,112,111,114,116,32,116,97,103,32,39,37,115,39,10,0] /* %s: %s has a duplica */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293761=allocate([37,115,58,32,37,115,32,104,97,115,32,97,32,68,73,80,32,115,119,105,116,99,104,32,110,97,109,101,32,111,114,32,115,101,116,116,105,110,103,32,119,105,116,104,32,110,111,32,110,97,109,101,10,0] /* %s: %s has a DIP swi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303762=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,105,110,112,117,116,32,112,111,114,116,32,119,105,116,104,32,97,110,32,105,110,118,97,108,105,100,32,116,121,112,101,32,40,48,41,59,32,117,115,101,32,73,80,84,95,79,84,72,69,82,32,105,110,115,116,101,97,100,10,0] /* %s: %s has an input  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313763=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,105,110,112,117,116,32,119,105,116,104,32,97,110,32,101,109,112,116,121,32,115,116,114,105,110,103,10,0] /* %s: %s has an input  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str323764=allocate([37,115,58,32,37,115,32,105,110,112,117,116,32,39,37,115,39,32,104,97,115,32,116,114,97,105,108,105,110,103,32,115,112,97,99,101,115,10,0] /* %s: %s input '%s' ha */, "i8", ALLOC_STATIC);
STRING_TABLE.__str333765=allocate([37,115,58,32,37,115,32,105,110,112,117,116,32,39,37,115,39,32,104,97,115,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,115,10,0] /* %s: %s input '%s' ha */, "i8", ALLOC_STATIC);
STRING_TABLE.__str343766=allocate([37,115,58,32,37,115,32,104,97,115,32,97,32,99,111,110,100,105,116,105,111,110,32,114,101,102,101,114,101,110,99,105,110,103,32,110,111,110,45,101,120,105,115,116,101,110,116,32,105,110,112,117,116,32,112,111,114,116,32,116,97,103,32,39,37,115,39,10,0] /* %s: %s has a conditi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str363768=allocate([37,115,58,32,37,115,32,109,117,115,116,32,117,115,101,32,68,69,70,95,83,84,82,40,32,37,115,32,41,10,0] /* %s: %s must use DEF_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str373769=allocate([37,115,58,32,37,115,32,68,101,109,111,32,83,111,117,110,100,115,32,109,117,115,116,32,100,101,102,97,117,108,116,32,116,111,32,79,110,10,0] /* %s: %s Demo Sounds m */, "i8", ALLOC_STATIC);
STRING_TABLE.__str383770=allocate([37,115,58,32,37,115,32,104,97,115,32,119,114,111,110,103,32,68,101,109,111,32,83,111,117,110,100,115,32,111,112,116,105,111,110,32,37,115,32,40,109,117,115,116,32,98,101,32,79,102,102,47,79,110,41,10,0] /* %s: %s has wrong Dem */, "i8", ALLOC_STATIC);
STRING_TABLE.__str393771=allocate([37,115,58,32,37,115,32,104,97,115,32,119,114,111,110,103,32,70,108,105,112,32,83,99,114,101,101,110,32,111,112,116,105,111,110,32,37,115,32,40,109,117,115,116,32,98,101,32,79,102,102,47,79,110,41,10,0] /* %s: %s has wrong Fli */, "i8", ALLOC_STATIC);
STRING_TABLE.__str403772=allocate([37,115,58,32,37,115,32,104,97,115,32,105,110,118,101,114,116,101,100,32,79,102,102,47,79,110,32,100,105,112,115,119,105,116,99,104,32,111,114,100,101,114,10,0] /* %s: %s has inverted  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str413773=allocate([37,115,58,32,37,115,32,104,97,115,32,105,110,118,101,114,116,101,100,32,78,111,47,89,101,115,32,100,105,112,115,119,105,116,99,104,32,111,114,100,101,114,10,0] /* %s: %s has inverted  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str423774=allocate([37,115,58,32,37,115,32,104,97,115,32,105,110,118,101,114,116,101,100,32,85,112,114,105,103,104,116,47,67,111,99,107,116,97,105,108,32,100,105,112,115,119,105,116,99,104,32,111,114,100,101,114,10,0] /* %s: %s has inverted  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str433775=allocate([37,115,58,32,37,115,32,104,97,115,32,117,110,115,111,114,116,101,100,32,99,111,105,110,97,103,101,32,37,115,32,62,32,37,115,10,0] /* %s: %s has unsorted  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str443776=allocate([37,115,58,32,37,115,32,112,114,111,112,101,114,32,99,111,105,110,32,115,111,114,116,32,111,114,100,101,114,32,115,104,111,117,108,100,32,98,101,58,10,0] /* %s: %s proper coin s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str453777=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str463778=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,97,110,97,108,111,103,32,112,111,114,116,32,119,105,116,104,32,97,32,112,111,115,105,116,105,111,110,97,108,32,112,111,114,116,32,115,105,122,101,32,98,105,103,103,101,114,32,116,104,101,110,32,116,104,101,32,109,97,115,107,32,115,105,122,101,10,0] /* %s: %s has an analog */, "i8", ALLOC_STATIC);
STRING_TABLE.__str473779=allocate([37,115,58,32,37,115,32,111,110,108,121,32,112,111,115,105,116,105,111,110,97,108,32,97,110,97,108,111,103,32,112,111,114,116,115,32,117,115,101,32,80,79,82,84,95,87,82,65,80,83,10,0] /* %s: %s only position */, "i8", ALLOC_STATIC);
STRING_TABLE.__str483780=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,97,110,97,108,111,103,32,112,111,114,116,32,119,105,116,104,32,122,101,114,111,32,115,101,110,115,105,116,105,118,105,116,121,10,0] /* %s: %s has an analog */, "i8", ALLOC_STATIC);
STRING_TABLE.__str493781=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,97,110,97,108,111,103,32,112,111,114,116,32,119,105,116,104,32,97,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,111,117,116,32,111,102,32,116,104,101,32,98,105,116,109,97,115,107,32,114,97,110,103,101,10,0] /* %s: %s has an analog */, "i8", ALLOC_STATIC);
STRING_TABLE.__str503782=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,97,110,97,108,111,103,32,112,111,114,116,32,119,105,116,104,32,97,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,111,117,116,32,80,79,82,84,95,77,73,78,77,65,88,32,114,97,110,103,101,10,0] /* %s: %s has an analog */, "i8", ALLOC_STATIC);
STRING_TABLE.__str513783=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,97,110,97,108,111,103,32,112,111,114,116,32,119,105,116,104,32,97,32,80,79,82,84,95,77,73,78,77,65,88,32,118,97,108,117,101,32,111,117,116,32,111,102,32,116,104,101,32,98,105,116,109,97,115,107,32,114,97,110,103,101,10,0] /* %s: %s has an analog */, "i8", ALLOC_STATIC);
STRING_TABLE.__str523784=allocate([37,115,58,32,37,115,32,45,32,97,98,115,111,108,117,116,101,32,97,110,97,108,111,103,32,112,111,114,116,115,32,100,111,32,110,111,116,32,117,115,101,32,80,79,82,84,95,82,69,83,69,84,10,0] /* %s: %s - absolute an */, "i8", ALLOC_STATIC);
STRING_TABLE.__str533785=allocate([37,115,58,32,37,115,32,45,32,114,101,108,97,116,105,118,101,32,112,111,114,116,115,32,100,111,32,110,111,116,32,117,115,101,32,80,79,82,84,95,77,73,78,77,65,88,10,0] /* %s: %s - relative po */, "i8", ALLOC_STATIC);
STRING_TABLE.__str543786=allocate([37,115,58,32,37,115,32,45,32,114,101,108,97,116,105,118,101,32,112,111,114,116,115,32,100,111,32,110,111,116,32,117,115,101,32,97,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,111,116,104,101,114,32,116,104,101,110,32,48,10,0] /* %s: %s - relative po */, "i8", ALLOC_STATIC);
STRING_TABLE.__str553787=allocate([63,63,63,0] /* ???\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str563788=allocate([37,115,58,32,37,115,32,104,97,115,32,101,109,112,116,121,32,82,79,77,32,114,101,103,105,111,110,32,39,37,115,39,32,40,119,97,114,110,105,110,103,41,10,0] /* %s: %s has empty ROM */, "i8", ALLOC_STATIC);
STRING_TABLE.__str573789=allocate([37,115,58,32,37,115,32,104,97,115,32,78,85,76,76,32,82,79,77,95,82,69,71,73,79,78,32,116,97,103,10,0] /* %s: %s has NULL ROM_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str583790=allocate([37,115,58,32,37,115,32,104,97,115,32,108,111,97,100,45,98,121,45,110,97,109,101,32,114,101,103,105,111,110,32,39,37,115,39,32,119,105,116,104,32,110,97,109,101,32,62,56,32,99,104,97,114,97,99,116,101,114,115,10,0] /* %s: %s has load-by-n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str593791=allocate([37,115,58,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,82,79,77,95,82,69,71,73,79,78,32,116,97,103,32,39,37,115,39,10,0] /* %s: %s has duplicate */, "i8", ALLOC_STATIC);
STRING_TABLE.__str603792=allocate([114,101,103,105,111,110,0] /* region\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str613793=allocate([37,115,58,32,37,115,32,104,97,115,32,110,111,110,45,115,101,113,117,101,110,116,105,97,108,32,98,105,111,115,32,37,115,10,0] /* %s: %s has non-seque */, "i8", ALLOC_STATIC);
STRING_TABLE.__str623794=allocate([37,115,58,32,37,115,32,104,97,115,32,117,112,112,101,114,32,99,97,115,101,32,82,79,77,32,110,97,109,101,32,37,115,10,0] /* %s: %s has upper cas */, "i8", ALLOC_STATIC);
STRING_TABLE.__str633795=allocate([37,115,58,32,114,111,109,32,39,37,115,39,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,104,97,115,104,32,115,116,114,105,110,103,32,39,37,115,39,10,0] /* %s: rom '%s' has an  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str643796=allocate([37,115,58,32,37,115,32,104,97,115,32,82,79,77,32,37,115,32,101,120,116,101,110,100,105,110,103,32,112,97,115,116,32,116,104,101,32,100,101,102,105,110,101,100,32,109,101,109,111,114,121,32,114,101,103,105,111,110,10,0] /* %s: %s has ROM %s ex */, "i8", ALLOC_STATIC);
STRING_TABLE.__str653797=allocate([37,115,58,32,37,115,32,104,97,115,32,101,109,112,116,121,32,82,79,77,32,114,101,103,105,111,110,32,40,119,97,114,110,105,110,103,41,10,0] /* %s: %s has empty ROM */, "i8", ALLOC_STATIC);
STRING_TABLE.__str663798=allocate([37,115,58,32,37,115,32,105,115,32,97,32,100,117,112,108,105,99,97,116,101,32,110,97,109,101,32,40,37,115,44,32,37,115,41,10,0] /* %s: %s is a duplicat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str673799=allocate([37,115,58,32,37,115,32,105,115,32,97,32,100,117,112,108,105,99,97,116,101,32,100,101,115,99,114,105,112,116,105,111,110,32,40,37,115,44,32,37,115,41,10,0] /* %s: %s is a duplicat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str683800=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str693801=allocate([37,115,58,32,37,115,32,105,115,32,97,32,110,111,110,45,101,120,105,115,116,97,110,116,32,99,108,111,110,101,10,0] /* %s: %s is a non-exis */, "i8", ALLOC_STATIC);
STRING_TABLE.__str703802=allocate([37,115,58,32,37,115,32,105,115,32,115,101,116,32,97,115,32,97,32,99,108,111,110,101,32,111,102,32,105,116,115,101,108,102,10,0] /* %s: %s is set as a c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str713803=allocate([37,115,58,32,37,115,32,105,115,32,97,32,99,108,111,110,101,32,111,102,32,97,32,99,108,111,110,101,10,0] /* %s: %s is a clone of */, "i8", ALLOC_STATIC);
STRING_TABLE.__str723804=allocate([37,115,58,32,37,115,32,37,115,32,100,114,105,118,101,114,32,110,97,109,101,32,109,117,115,116,32,98,101,32,37,100,32,99,104,97,114,97,99,116,101,114,115,32,111,114,32,108,101,115,115,10,0] /* %s: %s %s driver nam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str733805=allocate([99,108,111,110,101,0] /* clone\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str743806=allocate([112,97,114,101,110,116,0] /* parent\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str753807=allocate([37,115,58,32,37,115,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,121,101,97,114,32,39,37,115,39,10,0] /* %s: %s has an invali */, "i8", ALLOC_STATIC);
STRING_TABLE.__str763808=allocate([37,115,58,32,105,115,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,37,115,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,105,110,32,100,114,105,118,101,114,115,91,93,10,0] /* %s: is compatible wi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str773809=allocate([37,115,58,32,98,111,116,104,32,99,111,109,112,97,116,105,98,108,101,95,119,105,116,104,32,97,110,100,32,99,108,111,110,101,95,111,102,32,97,114,101,32,115,112,101,99,105,102,105,101,100,10,0] /* %s: both compatible_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str783810=allocate([37,115,58,32,114,101,99,117,114,115,105,118,101,32,99,111,109,112,97,116,105,98,105,108,105,116,121,10,0] /* %s: recursive compat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str793811=allocate([37,115,58,32,37,115,32,109,105,115,115,105,110,103,32,71,65,77,69,95,78,79,95,83,79,85,78,68,32,102,108,97,103,10,0] /* %s: %s missing GAME_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str803812=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,117,108,95,51,50,120,51,50,32,40,37,48,56,88,32,120,32,37,48,56,88,41,32,61,32,37,48,56,88,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,37,48,56,88,41,10,0] /* Error testing mul_32 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str813813=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,117,108,117,95,51,50,120,51,50,32,40,37,48,56,88,32,120,32,37,48,56,88,41,32,61,32,37,48,56,88,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,37,48,56,88,41,10,0] /* Error testing mulu_3 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str823814=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,117,108,95,51,50,120,51,50,95,104,105,32,40,37,48,56,88,32,120,32,37,48,56,88,41,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing mul_32 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str833815=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,117,108,117,95,51,50,120,51,50,95,104,105,32,40,37,48,56,88,32,120,32,37,48,56,88,41,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing mulu_3 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str843816=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,117,108,95,51,50,120,51,50,95,115,104,105,102,116,32,40,37,48,56,88,32,120,32,37,48,56,88,41,32,62,62,32,55,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing mul_32 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str853817=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,117,108,117,95,51,50,120,51,50,95,115,104,105,102,116,32,40,37,48,56,88,32,120,32,37,48,56,88,41,32,62,62,32,55,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing mulu_3 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str863818=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,100,105,118,95,54,52,120,51,50,32,40,37,48,56,88,37,48,56,88,32,47,32,37,48,56,88,41,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing div_64 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str873819=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,100,105,118,117,95,54,52,120,51,50,32,40,37,48,56,88,37,48,56,88,32,47,32,37,48,56,88,41,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing divu_6 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str883820=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,100,105,118,95,54,52,120,51,50,95,114,101,109,32,40,37,48,56,88,37,48,56,88,32,47,32,37,48,56,88,41,32,61,32,37,48,56,88,44,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,44,37,48,56,88,41,10,0] /* Error testing div_64 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str893821=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,100,105,118,117,95,54,52,120,51,50,95,114,101,109,32,40,37,48,56,88,37,48,56,88,32,47,32,37,48,56,88,41,32,61,32,37,48,56,88,44,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,44,37,48,56,88,41,10,0] /* Error testing divu_6 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str903822=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,111,100,95,54,52,120,51,50,32,40,37,48,56,88,37,48,56,88,32,47,32,37,48,56,88,41,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing mod_64 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str913823=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,109,111,100,117,95,54,52,120,51,50,32,40,37,48,56,88,37,48,56,88,32,47,32,37,48,56,88,41,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing modu_6 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str923824=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,100,105,118,95,51,50,120,51,50,95,115,104,105,102,116,32,40,37,48,56,88,32,60,60,32,51,41,32,47,32,37,48,56,88,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing div_32 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str933825=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,100,105,118,117,95,51,50,120,51,50,95,115,104,105,102,116,32,40,37,48,56,88,32,60,60,32,51,41,32,47,32,37,48,56,88,32,61,32,37,48,56,88,32,40,101,120,112,101,99,116,101,100,32,37,48,56,88,41,10,0] /* Error testing divu_3 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str943826=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,114,101,99,105,112,95,97,112,112,114,111,120,10,0] /* Error testing recip_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str953827=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,99,111,117,110,116,95,108,101,97,100,105,110,103,95,122,101,114,111,115,10,0] /* Error testing count_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str963828=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,99,111,117,110,116,95,108,101,97,100,105,110,103,95,111,110,101,115,10,0] /* Error testing count_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str973829=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,99,111,109,112,97,114,101,95,101,120,99,104,97,110,103,101,51,50,10,0] /* Error testing compar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str983830=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,97,116,111,109,105,99,95,101,120,99,104,97,110,103,101,51,50,10,0] /* Error testing atomic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str993831=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,97,116,111,109,105,99,95,97,100,100,51,50,10,0] /* Error testing atomic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1003832=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,97,116,111,109,105,99,95,105,110,99,114,101,109,101,110,116,51,50,10,0] /* Error testing atomic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1013833=allocate([69,114,114,111,114,32,116,101,115,116,105,110,103,32,97,116,111,109,105,99,95,100,101,99,114,101,109,101,110,116,51,50,10,0] /* Error testing atomic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3845=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,103,101,114,46,99,0] /* src/emu/debugger.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13846=allocate([100,101,98,117,103,103,101,114,95,101,120,105,116,0] /* debugger_exit\00 */, "i8", ALLOC_STATIC);
__ZL12machine_list=allocate(1, "%struct._machine_entry*", ALLOC_STATIC);
__ZL17atexit_registered=allocate(1, "i32", ALLOC_STATIC);
__ZTV20resource_pool_objectI14_machine_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7206, 0, 0, 0, 7208, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14_machine_entryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,95,109,97,99,104,105,110,101,95,101,110,116,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14_machine_entryE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI18debug_view_managerE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7210, 0, 0, 0, 7212, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18debug_view_managerE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,100,101,98,117,103,95,118,105,101,119,95,109,97,110,97,103,101,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18debug_view_managerE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str3851=allocate([115,114,99,47,101,109,117,47,114,111,109,108,111,97,100,46,99,0] /* src/emu/romload.c\00 */, "i8", ALLOC_STATIC);
__str13852=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str23853=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33854=allocate([46,99,104,100,0] /* .chd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43855=allocate([87,101,32,100,111,32,110,111,116,32,115,117,112,112,111,114,116,32,99,108,111,110,101,115,32,111,102,32,99,108,111,110,101,115,33,10,0] /* We do not support cl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53856=allocate([37,0] /* %\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63857=allocate([87,65,82,78,73,78,71,58,32,115,117,112,112,111,114,116,32,102,111,114,32,115,111,102,116,119,97,114,101,32,37,115,32,40,105,110,32,108,105,115,116,32,37,115,41,32,105,115,32,111,110,108,121,32,112,97,114,116,105,97,108,10,0] /* WARNING: support for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73858=allocate([87,65,82,78,73,78,71,58,32,115,117,112,112,111,114,116,32,102,111,114,32,115,111,102,116,119,97,114,101,32,37,115,32,40,105,110,32,108,105,115,116,32,37,115,41,32,105,115,32,111,110,108,121,32,112,114,101,108,105,109,105,110,97,114,121,10,0] /* WARNING: support for */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83859=allocate([114,111,109,95,101,120,105,116,0] /* rom_exit\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI16_romload_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7214, 0, 0, 0, 7216, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16_romload_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,95,114,111,109,108,111,97,100,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16_romload_privateE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str93860=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103861=allocate([100,101,102,97,117,108,116,0] /* default\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113862=allocate([37,115,58,32,105,110,118,97,108,105,100,32,98,105,111,115,10,0] /* %s: invalid bios\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123863=allocate([98,105,111,115,0] /* bios\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133864=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143865=allocate([69,82,82,79,82,58,32,114,101,113,117,105,114,101,100,32,102,105,108,101,115,32,97,114,101,32,109,105,115,115,105,110,103,44,32,116,104,101,32,115,121,115,116,101,109,32,99,97,110,110,111,116,32,98,101,32,114,117,110,46,0] /* ERROR: required file */, "i8", ALLOC_STATIC);
STRING_TABLE.__str153866=allocate([87,65,82,78,73,78,71,58,32,116,104,101,32,115,121,115,116,101,109,32,109,105,103,104,116,32,110,111,116,32,114,117,110,32,99,111,114,114,101,99,116,108,121,46,0] /* WARNING: the system  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163867=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173868=allocate([76,111,97,100,105,110,103,32,40,37,100,37,37,41,0] /* Loading (%d%%)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183869=allocate([76,111,97,100,105,110,103,32,67,111,109,112,108,101,116,101,0] /* Loading Complete\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str193870=allocate([37,115,32,78,79,84,32,70,79,85,78,68,10,0] /* %s NOT FOUND\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203871=allocate([37,115,32,67,72,68,32,69,82,82,79,82,58,32,37,115,10,0] /* %s CHD ERROR: %s\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213872=allocate([37,115,32,87,82,79,78,71,32,67,72,69,67,75,83,85,77,83,58,10,0] /* %s WRONG CHECKSUMS:\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223873=allocate([37,115,32,67,72,68,32,78,69,69,68,83,32,82,69,68,85,77,80,10,0] /* %s CHD NEEDS REDUMP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233874=allocate([37,115,32,68,73,70,70,32,67,72,68,32,69,82,82,79,82,58,32,37,115,10,0] /* %s DIFF CHD ERROR: % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243875=allocate([46,100,105,102,0] /* .dif\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253876=allocate([100,105,102,102,95,100,105,114,101,99,116,111,114,121,0] /* diff_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263877=allocate([32,32,32,32,69,88,80,69,67,84,69,68,58,32,37,115,10,0] /*     EXPECTED: %s\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str273878=allocate([32,32,32,32,32,32,32,70,79,85,78,68,58,32,37,115,10,0] /*        FOUND: %s\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str283879=allocate([9,73,110,118,97,108,105,100,32,37,115,32,99,104,101,99,107,115,117,109,32,116,114,101,97,116,101,100,32,97,115,32,48,32,40,99,104,101,99,107,32,108,101,97,100,105,110,103,32,122,101,114,111,115,41,10,0] /* \09Invalid %s checks */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293880=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,82,79,77,95,67,79,78,84,73,78,85,69,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,82,79,77,95,76,79,65,68,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303881=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,82,79,77,95,73,71,78,79,82,69,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,82,79,77,95,76,79,65,68,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313882=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,82,79,77,95,82,69,76,79,65,68,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,82,79,77,95,76,79,65,68,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str323883=allocate([37,115,32,87,82,79,78,71,32,76,69,78,71,84,72,32,40,101,120,112,101,99,116,101,100,58,32,37,48,56,120,32,102,111,117,110,100,58,32,37,48,56,120,41,10,0] /* %s WRONG LENGTH (exp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str333884=allocate([37,115,32,78,79,32,71,79,79,68,32,68,85,77,80,32,75,78,79,87,78,10,0] /* %s NO GOOD DUMP KNOW */, "i8", ALLOC_STATIC);
STRING_TABLE.__str343885=allocate([37,115,32,82,79,77,32,78,69,69,68,83,32,82,69,68,85,77,80,10,0] /* %s ROM NEEDS REDUMP\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str353886=allocate([87,97,114,110,105,110,103,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,37,115,32,108,101,110,103,116,104,32,110,111,116,32,97,110,32,101,118,101,110,32,109,117,108,116,105,112,108,101,32,111,102,32,103,114,111,117,112,32,115,105,122,101,10,0] /* Warning in RomModule */, "i8", ALLOC_STATIC);
STRING_TABLE.__str363887=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,37,115,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,114,101,103,105,111,110,32,115,112,97,99,101,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str373888=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,37,115,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,108,101,110,103,116,104,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str383889=allocate([79,80,84,73,79,78,65,76,32,37,115,32,78,79,84,32,70,79,85,78,68,10,0] /* OPTIONAL %s NOT FOUN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str393890=allocate([37,115,32,78,79,84,32,70,79,85,78,68,32,40,78,79,32,71,79,79,68,32,68,85,77,80,32,75,78,79,87,78,41,10,0] /* %s NOT FOUND (NO GOO */, "i8", ALLOC_STATIC);
STRING_TABLE.__str403891=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,67,79,80,89,32,111,117,116,32,111,102,32,116,97,114,103,101,116,32,109,101,109,111,114,121,32,114,101,103,105,111,110,32,115,112,97,99,101,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str413892=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,67,79,80,89,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,108,101,110,103,116,104,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str423893=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,67,79,80,89,32,102,114,111,109,32,97,110,32,105,110,118,97,108,105,100,32,114,101,103,105,111,110,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str433894=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,67,79,80,89,32,111,117,116,32,111,102,32,115,111,117,114,99,101,32,109,101,109,111,114,121,32,114,101,103,105,111,110,32,115,112,97,99,101,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str443895=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,70,73,76,76,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,114,101,103,105,111,110,32,115,112,97,99,101,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str453896=allocate([69,114,114,111,114,32,105,110,32,82,111,109,77,111,100,117,108,101,32,100,101,102,105,110,105,116,105,111,110,58,32,70,73,76,76,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,108,101,110,103,116,104,10,0] /* Error in RomModule d */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI9_open_chdE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7218, 0, 0, 0, 7220, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI9_open_chdE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,57,95,111,112,101,110,95,99,104,100,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI9_open_chdE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str473898=allocate([114,111,109,112,97,116,104,0] /* rompath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3923=allocate([115,114,99,47,101,109,117,47,117,105,105,110,112,117,116,46,99,0] /* src/emu/uiinput.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str13924=allocate([117,105,95,105,110,112,117,116,95,102,114,97,109,101,95,117,112,100,97,116,101,0] /* ui_input_frame_updat */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI17_ui_input_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7222, 0, 0, 0, 7224, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17_ui_input_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,95,117,105,95,105,110,112,117,116,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17_ui_input_privateE=allocate(12, "*", ALLOC_STATIC);
__ZL15messagebox_text=allocate(64, ["*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8"], ALLOC_STATIC);
STRING_TABLE.__str3931=allocate([117,105,95,101,120,105,116,0] /* ui_exit\00 */, "i8", ALLOC_STATIC);
__ZL11single_step=allocate(1, "i32", ALLOC_STATIC);
__ZL23ui_use_natural_keyboard=allocate(1, "i32", ALLOC_STATIC);
__ZL14slider_current=allocate(1, "%struct._slider_state*", ALLOC_STATIC);
__ZL11slider_list=allocate(1, "%struct._slider_state*", ALLOC_STATIC);
__ZL20messagebox_backcolor=allocate(1, "i32", ALLOC_STATIC);
__ZL19ui_handler_callback=allocate(1, "i32 (%class.running_machine.8645*, %class.render_container.8552*, i32)*", ALLOC_STATIC);
__ZZ19ui_set_startup_textR15running_machinePKciE14lastupdatetime=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL16ui_handler_param=allocate(1, "i32", ALLOC_STATIC);
__ZL14popup_text_end=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL7ui_font=allocate(1, "%class.render_font.8656*", ALLOC_STATIC);
__ZL7showfps=allocate(1, "i32", ALLOC_STATIC);
__ZL11showfps_end=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL13show_profiler=allocate(1, "i32", ALLOC_STATIC);
STRING_TABLE.__str13932=allocate([37,115,10,37,115,32,37,115,10,10,67,80,85,58,10,0] /* %s\0A%s %s\0A\0ACPU: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str23933=allocate([37,100,195,151,0] /* %d\C3\97\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str33934=allocate([32,37,100,46,37,48,54,100,194,160,77,72,122,10,0] /*  %d.%06d\C2\A0MHz\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str43935=allocate([32,37,100,46,37,48,51,100,194,160,107,72,122,10,0] /*  %d.%03d\C2\A0kHz\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str53936=allocate([10,83,111,117,110,100,58,10,0] /* \0ASound:\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str63937=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str73938=allocate([10,86,105,100,101,111,58,10,0] /* \0AVideo:\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str83939=allocate([78,111,110,101,10,0] /* None\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str93940=allocate([58,32,0] /* : \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str103941=allocate([86,101,99,116,111,114,10,0] /* Vector\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str113942=allocate([37,100,32,195,151,32,37,100,32,40,37,115,41,32,37,102,194,160,72,122,10,0] /* %d \C3\97 %d (%s) %f */, "i8", ALLOC_STATIC);
STRING_TABLE.__str123943=allocate([86,0] /* V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133944=allocate([72,0] /* H\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str143945=allocate([110,97,116,117,114,97,108,0] /* natural\00 */, "i8", ALLOC_STATIC);
__ZZL22slider_get_screen_descR13screen_deviceE7descbuf=allocate(256, "i8", ALLOC_STATIC);
STRING_TABLE.__str153946=allocate([83,99,114,101,101,110,32,39,37,115,39,0] /* Screen '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str163947=allocate([83,99,114,101,101,110,0] /* Screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str173948=allocate([77,97,115,116,101,114,32,86,111,108,117,109,101,0] /* Master Volume\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str183949=allocate([32,86,111,108,117,109,101,0] /*  Volume\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str193950=allocate([79,118,101,114,99,108,111,99,107,32,67,80,85,32,37,115,0] /* Overclock CPU %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str203951=allocate([37,115,32,82,101,102,114,101,115,104,32,82,97,116,101,0] /* %s Refresh Rate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str213952=allocate([37,115,32,66,114,105,103,104,116,110,101,115,115,0] /* %s Brightness\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str223953=allocate([37,115,32,67,111,110,116,114,97,115,116,0] /* %s Contrast\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str233954=allocate([37,115,32,71,97,109,109,97,0] /* %s Gamma\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str243955=allocate([37,115,32,72,111,114,105,122,32,83,116,114,101,116,99,104,0] /* %s Horiz Stretch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str253956=allocate([37,115,32,72,111,114,105,122,32,80,111,115,105,116,105,111,110,0] /* %s Horiz Position\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str263957=allocate([37,115,32,86,101,114,116,32,83,116,114,101,116,99,104,0] /* %s Vert Stretch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str273958=allocate([37,115,32,86,101,114,116,32,80,111,115,105,116,105,111,110,0] /* %s Vert Position\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str283959=allocate([86,101,99,116,111,114,32,70,108,105,99,107,101,114,0] /* Vector Flicker\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str293960=allocate([66,101,97,109,32,87,105,100,116,104,0] /* Beam Width\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str303961=allocate([37,49,46,50,102,0] /* %1.2f\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str313962=allocate([37,46,51,102,0] /* %.3f\00 */, "i8", ALLOC_STATIC);
__ZZL25slider_get_laserdisc_descP8device_tE7descbuf=allocate(256, "i8", ALLOC_STATIC);
STRING_TABLE.__str323963=allocate([76,97,115,101,114,100,105,115,99,32,39,37,115,39,0] /* Laserdisc '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str333964=allocate([76,97,115,101,114,100,105,115,99,0] /* Laserdisc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str343965=allocate([37,46,51,102,102,112,115,0] /* %.3ffps\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str353966=allocate([37,51,46,48,102,37,37,0] /* %3.0f%%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str373968=allocate([37,100,37,37,0] /* %d%%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str383969=allocate([37,52,46,50,102,0] /* %4.2f\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str393970=allocate([37,51,100,100,66,0] /* %3ddB\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str403971=allocate([115,114,99,47,101,109,117,47,117,105,46,99,0] /* src/emu/ui.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str413972=allocate([37,115,10,37,115,10,37,115,10,37,115,10,37,115,10,37,115,10,0] /* %s\0A%s\0A%s\0A%s\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str423973=allocate([75,101,121,98,111,97,114,100,32,69,109,117,108,97,116,105,111,110,32,83,116,97,116,117,115,0] /* Keyboard Emulation S */, "i8", ALLOC_STATIC);
STRING_TABLE.__str433974=allocate([45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,0] /* -------------------- */, "i8", ALLOC_STATIC);
STRING_TABLE.__str443975=allocate([77,111,100,101,58,32,80,65,82,84,73,65,76,32,69,109,117,108,97,116,105,111,110,0] /* Mode: PARTIAL Emulat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str453976=allocate([85,73,58,32,32,32,69,110,97,98,108,101,100,0] /* UI:   Enabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str463977=allocate([42,42,85,115,101,32,83,99,114,76,111,99,107,32,116,111,32,116,111,103,103,108,101,42,42,0] /* __Use ScrLock to tog */, "i8", ALLOC_STATIC);
STRING_TABLE.__str473978=allocate([77,111,100,101,58,32,70,85,76,76,32,69,109,117,108,97,116,105,111,110,0] /* Mode: FULL Emulation */, "i8", ALLOC_STATIC);
STRING_TABLE.__str483979=allocate([85,73,58,32,32,32,68,105,115,97,98,108,101,100,0] /* UI:   Disabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str493980=allocate([82,69,67,32,83,84,65,82,84,0] /* REC START\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str503981=allocate([82,69,67,32,83,84,79,80,0] /* REC STOP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str513982=allocate([83,101,108,101,99,116,32,112,111,115,105,116,105,111,110,32,116,111,32,115,97,118,101,32,116,111,0] /* Select position to s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str523983=allocate([83,101,108,101,99,116,32,112,111,115,105,116,105,111,110,32,116,111,32,108,111,97,100,32,102,114,111,109,0] /* Select position to l */, "i8", ALLOC_STATIC);
STRING_TABLE.__str533984=allocate([83,97,118,101,32,99,97,110,99,101,108,108,101,100,0] /* Save cancelled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str543985=allocate([76,111,97,100,32,99,97,110,99,101,108,108,101,100,0] /* Load cancelled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str553986=allocate([37,99,0] /* %c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str563987=allocate([83,97,118,101,32,116,111,32,112,111,115,105,116,105,111,110,32,37,99,0] /* Save to position %c\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str573988=allocate([76,111,97,100,32,102,114,111,109,32,112,111,115,105,116,105,111,110,32,37,99,0] /* Load from position % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str583989=allocate([65,114,101,32,121,111,117,32,115,117,114,101,32,121,111,117,32,119,97,110,116,32,116,111,32,113,117,105,116,63,10,10,0] /* Are you sure you wan */, "i8", ALLOC_STATIC);
STRING_TABLE.__str593990=allocate([80,114,101,115,115,32,39,39,85,73,32,83,101,108,101,99,116,39,39,32,40,100,101,102,97,117,108,116,58,32,69,110,116,101,114,41,32,116,111,32,113,117,105,116,44,10,0] /* Press ''UI Select''  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str603991=allocate([80,114,101,115,115,32,39,39,85,73,32,67,97,110,99,101,108,39,39,32,40,100,101,102,97,117,108,116,58,32,69,115,99,41,32,116,111,32,114,101,116,117,114,110,32,116,111,32,101,109,117,108,97,116,105,111,110,46,0] /* Press ''UI Cancel''  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str613992=allocate([99,111,110,102,105,114,109,95,113,117,105,116,0] /* confirm_quit\00 */, "i8", ALLOC_STATIC);
__ZL13non_char_keys=allocate([52, 0, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 39, 0, 0, 0, 40, 0, 0, 0, 41, 0, 0, 0, 42, 0, 0, 0, 43, 0, 0, 0, 44, 0, 0, 0, 45, 0, 0, 0, 46, 0, 0, 0, 47, 0, 0, 0, 48, 0, 0, 0, 104, 0, 0, 0, 79, 0, 0, 0, 80, 0, 0, 0, 81, 0, 0, 0, 82, 0, 0, 0, 83, 0, 0, 0, 84, 0, 0, 0, 85, 0, 0, 0, 86, 0, 0, 0, 87, 0, 0, 0, 88, 0, 0, 0, 93, 0, 0, 0, 92, 0, 0, 0, 91, 0, 0, 0, 69, 0, 0, 0, 70, 0, 0, 0, 71, 0, 0, 0, 72, 0, 0, 0, 73, 0, 0, 0, 74, 0, 0, 0, 77, 0, 0, 0, 78, 0, 0, 0, 75, 0, 0, 0, 76, 0, 0, 0, 96, 0, 0, 0, 109, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL18non_char_keys_down=allocate(5, "i8", ALLOC_STATIC);
__str623993=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str633994=allocate([79,110,101,32,111,114,32,109,111,114,101,32,82,79,77,115,47,67,72,68,115,32,102,111,114,32,116,104,105,115,32,103,97,109,101,32,97,114,101,32,105,110,99,111,114,114,101,99,116,46,32,84,104,101,32,115,121,115,116,101,109,32,109,97,121,32,110,111,116,32,114,117,110,32,99,111,114,114,101,99,116,108,121,46,10,0] /* One or more ROMs/CHD */, "i8", ALLOC_STATIC);
STRING_TABLE.__str643995=allocate([84,104,101,114,101,32,97,114,101,32,107,110,111,119,110,32,112,114,111,98,108,101,109,115,32,119,105,116,104,32,116,104,105,115,32,115,121,115,116,101,109,10,10,0] /* There are known prob */, "i8", ALLOC_STATIC);
STRING_TABLE.__str653996=allocate([79,110,101,32,111,114,32,109,111,114,101,32,82,79,77,115,47,67,72,68,115,32,102,111,114,32,116,104,105,115,32,115,121,115,116,101,109,32,104,97,118,101,32,110,111,116,32,98,101,101,110,32,99,111,114,114,101,99,116,108,121,32,100,117,109,112,101,100,46,10,0] /* One or more ROMs/CHD */, "i8", ALLOC_STATIC);
STRING_TABLE.__str663997=allocate([84,104,101,32,107,101,121,98,111,97,114,100,32,101,109,117,108,97,116,105,111,110,32,109,97,121,32,110,111,116,32,98,101,32,49,48,48,37,32,97,99,99,117,114,97,116,101,46,10,0] /* The keyboard emulati */, "i8", ALLOC_STATIC);
STRING_TABLE.__str673998=allocate([84,104,101,32,99,111,108,111,114,115,32,97,114,101,110,39,116,32,49,48,48,37,32,97,99,99,117,114,97,116,101,46,10,0] /* The colors aren't 10 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str683999=allocate([84,104,101,32,99,111,108,111,114,115,32,97,114,101,32,99,111,109,112,108,101,116,101,108,121,32,119,114,111,110,103,46,10,0] /* The colors are compl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str694000=allocate([84,104,101,32,118,105,100,101,111,32,101,109,117,108,97,116,105,111,110,32,105,115,110,39,116,32,49,48,48,37,32,97,99,99,117,114,97,116,101,46,10,0] /* The video emulation  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str704001=allocate([84,104,101,32,115,111,117,110,100,32,101,109,117,108,97,116,105,111,110,32,105,115,110,39,116,32,49,48,48,37,32,97,99,99,117,114,97,116,101,46,10,0] /* The sound emulation  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str714002=allocate([84,104,101,32,103,97,109,101,32,108,97,99,107,115,32,115,111,117,110,100,46,10,0] /* The game lacks sound */, "i8", ALLOC_STATIC);
STRING_TABLE.__str724003=allocate([83,99,114,101,101,110,32,102,108,105,112,112,105,110,103,32,105,110,32,99,111,99,107,116,97,105,108,32,109,111,100,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,10,0] /* Screen flipping in c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str734004=allocate([84,104,101,32,103,97,109,101,32,114,101,113,117,105,114,101,115,32,101,120,116,101,114,110,97,108,32,97,114,116,119,111,114,107,32,102,105,108,101,115,10,0] /* The game requires ex */, "i8", ALLOC_STATIC);
STRING_TABLE.__str744005=allocate([84,104,101,32,103,97,109,101,32,104,97,115,32,112,114,111,116,101,99,116,105,111,110,32,119,104,105,99,104,32,105,115,110,39,116,32,102,117,108,108,121,32,101,109,117,108,97,116,101,100,46,10,0] /* The game has protect */, "i8", ALLOC_STATIC);
STRING_TABLE.__str754006=allocate([10,84,72,73,83,32,83,89,83,84,69,77,32,68,79,69,83,78,39,84,32,87,79,82,75,46,32,84,104,101,32,101,109,117,108,97,116,105,111,110,32,102,111,114,32,116,104,105,115,32,103,97,109,101,32,105,115,32,110,111,116,32,121,101,116,32,99,111,109,112,108,101,116,101,46,32,84,104,101,114,101,32,105,115,32,110,111,116,104,105,110,103,32,121,111,117,32,99,97,110,32,100,111,32,116,111,32,102,105,120,32,116,104,105,115,32,112,114,111,98,108,101,109,32,101,120,99,101,112,116,32,119,97,105,116,32,102,111,114,32,116,104,101,32,100,101,118,101,108,111,112,101,114,115,32,116,111,32,105,109,112,114,111,118,101,32,116,104,101,32,101,109,117,108,97,116,105,111,110,46,10,0] /* \0ATHIS SYSTEM DOESN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str764007=allocate([10,67,101,114,116,97,105,110,32,101,108,101,109,101,110,116,115,32,111,102,32,116,104,105,115,32,115,121,115,116,101,109,32,99,97,110,110,111,116,32,98,101,32,101,109,117,108,97,116,101,100,32,97,115,32,105,116,32,114,101,113,117,105,114,101,115,32,97,99,116,117,97,108,32,112,104,121,115,105,99,97,108,32,105,110,116,101,114,97,99,116,105,111,110,32,111,114,32,99,111,110,115,105,115,116,115,32,111,102,32,109,101,99,104,97,110,105,99,97,108,32,100,101,118,105,99,101,115,46,32,73,116,32,105,115,32,110,111,116,32,112,111,115,115,105,98,108,101,32,116,111,32,102,117,108,108,121,32,112,108,97,121,32,116,104,105,115,32,115,121,115,116,101,109,46,10,0] /* \0ACertain elements  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str774008=allocate([10,10,84,104,101,114,101,32,97,114,101,32,119,111,114,107,105,110,103,32,99,108,111,110,101,115,32,111,102,32,116,104,105,115,32,103,97,109,101,58,32,0] /* \0A\0AThere are work */, "i8", ALLOC_STATIC);
STRING_TABLE.__str784009=allocate([44,32,0] /* , \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str794010=allocate([10,10,84,121,112,101,32,79,75,32,111,114,32,109,111,118,101,32,116,104,101,32,106,111,121,115,116,105,99,107,32,108,101,102,116,32,116,104,101,110,32,114,105,103,104,116,32,116,111,32,99,111,110,116,105,110,117,101,0] /* \0A\0AType OK or mov */, "i8", ALLOC_STATIC);
STRING_TABLE.__str804011=allocate([85,115,97,103,101,32,111,102,32,101,109,117,108,97,116,111,114,115,32,105,110,32,99,111,110,106,117,110,99,116,105,111,110,32,119,105,116,104,32,82,79,77,115,32,121,111,117,32,100,111,110,39,116,32,111,119,110,32,105,115,32,102,111,114,98,105,100,100,101,110,32,98,121,32,99,111,112,121,114,105,103,104,116,32,108,97,119,46,10,10,0] /* Usage of emulators i */, "i8", ALLOC_STATIC);
STRING_TABLE.__str814012=allocate([73,70,32,89,79,85,32,65,82,69,32,78,79,84,32,76,69,71,65,76,76,89,32,69,78,84,73,84,76,69,68,32,84,79,32,80,76,65,89,32,34,37,115,34,32,79,78,32,84,72,73,83,32,69,77,85,76,65,84,79,82,44,32,80,82,69,83,83,32,69,83,67,46,10,10,0] /* IF YOU ARE NOT LEGAL */, "i8", ALLOC_STATIC);
STRING_TABLE.__str824013=allocate([79,116,104,101,114,119,105,115,101,44,32,116,121,112,101,32,79,75,32,111,114,32,109,111,118,101,32,116,104,101,32,106,111,121,115,116,105,99,107,32,108,101,102,116,32,116,104,101,110,32,114,105,103,104,116,32,116,111,32,99,111,110,116,105,110,117,101,0] /* Otherwise, type OK o */, "i8", ALLOC_STATIC);
STRING_TABLE.__str834014=allocate([117,105,102,111,110,116,0] /* uifont\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str844015=allocate([112,97,117,115,101,95,98,114,105,103,104,116,110,101,115,115,0] /* pause_brightness\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str854016=allocate([115,107,105,112,95,103,97,109,101,105,110,102,111,0] /* skip_gameinfo\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str864017=allocate([115,101,99,111,110,100,115,95,116,111,95,114,117,110,0] /* seconds_to_run\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4037=allocate([119,97,116,99,104,100,111,103,95,99,97,108,108,98,97,99,107,0] /* watchdog_callback\00 */, "i8", ALLOC_STATIC);
__ZL14watchdog_timer=allocate(1, "%class.emu_timer.6678*", ALLOC_STATIC);
STRING_TABLE.__str14038=allocate([119,97,116,99,104,100,111,103,95,105,110,116,101,114,110,97,108,95,114,101,115,101,116,0] /* watchdog_internal_re */, "i8", ALLOC_STATIC);
__ZL16watchdog_enabled=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str24039=allocate([119,97,116,99,104,100,111,103,95,101,110,97,98,108,101,100,0] /* watchdog_enabled\00 */, "i8", ALLOC_STATIC);
__ZL16watchdog_counter=allocate(1, "i32", ALLOC_STATIC);
STRING_TABLE.__str34040=allocate([119,97,116,99,104,100,111,103,95,99,111,117,110,116,101,114,0] /* watchdog_counter\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44041=allocate([111,110,95,118,98,108,97,110,107,0] /* on_vblank\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54042=allocate([103,108,111,98,97,108,0] /* global\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64043=allocate([82,101,115,101,116,32,99,97,117,115,101,100,32,98,121,32,116,104,101,32,119,97,116,99,104,100,111,103,33,33,33,10,0] /* Reset caused by the  */, "i8", ALLOC_STATIC);
__ZL6global=allocate(376, ["i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"i8","i8","i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8"], ALLOC_STATIC);
STRING_TABLE.__str4049=allocate([99,114,111,115,115,104,97,105,114,95,101,120,105,116,0] /* crosshair_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14050=allocate([99,114,111,115,115,104,97,105,114,115,0] /* crosshairs\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24051=allocate([99,114,111,115,115,104,97,105,114,95,108,111,97,100,0] /* crosshair_load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34052=allocate([99,114,111,115,115,104,97,105,114,95,115,97,118,101,0] /* crosshair_save\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44053=allocate([97,110,105,109,97,116,101,0] /* animate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54054=allocate([99,114,111,115,115,104,97,105,114,0] /* crosshair\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64055=allocate([112,108,97,121,101,114,0] /* player\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74056=allocate([109,111,100,101,0] /* mode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84057=allocate([112,105,99,0] /* pic\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94058=allocate([97,117,116,111,116,105,109,101,0] /* autotime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104059=allocate([118,97,108,0] /* val\00 */, "i8", ALLOC_STATIC);
__str114060=allocate(1, "i8", ALLOC_STATIC);
__ZL16crosshair_colors=allocate([-12566273, 0, 0, 0, -49088, 0, 0, 0, -12517568, 0, 0, 0, -192, 0, 0, 0, -48897, 0, 0, 0, -12517377, 0, 0, 0, -1, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str124061=allocate([37,115,46,112,110,103,0] /* %s.png\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134062=allocate([99,114,111,115,115,37,100,46,112,110,103,0] /* cross%d.png\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144063=allocate([115,114,99,47,101,109,117,47,99,114,115,115,104,97,105,114,46,99,0] /* src/emu/crsshair.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL17crosshair_raw_top=allocate([0,32,0,0,0,0,0,0,0,0,0,64,0,0,112,0,0,0,0,0,0,0,0,0,224,0,0,248,0,0,0,0,0,0,0,0,1,240,0,1,248,0,0,0,0,0,0,0,0,1,248,0,3,252,0,0,0,0,0,0,0,0,3,252,0,7,254,0,0,0,15,254,0,0,0,7,254,0,15,255,0,0,1,255,255,240,0,0,15,255,0,31,255,128,0,31,255,255,255,0,0,31,255,128,63,255,128,0,255,255,255,255,224,0,31,255,192,127,255,192,3,255,255,255,255,248,0,63,255,224,255,255,224,7,255,255,255,255,252,0,127,255,240,127,255,240,31,255,255,255,255,255,0,255,255,224,63,255,248,127,255,255,255,255,255,193,255,255,192,15,255,248,255,255,255,255,255,255,225,255,255,0,7,255,255,255,255,255,255,255,255,251,255,254,0,3,255,255,255,255,255,255,255,255,255,255,252,0,1,255,255,255,255,240,1,255,255,255,255,248,0,0,127,255,255,255,0,0,31,255,255,255,224,0,0,63,255,255,248,0,0,3,255,255,255,192,0,0,31,255,255,224,0,0,0,255,255,255,128,0,0,15,255,255,128,0,0,0,63,255,255,0,0,0,3,255,254,0,0,0,0,15,255,252,0,0,0,1,255,252,0,0,0,0,7,255,248,0,0,0,3,255,248,0,0,0,0,1,255,248,0,0,0,7,255,252,0,0,0,0,3,255,252,0,0,0,15,255,254,0,0,0,0,7,255,254,0,0,0,15,255,255,0,0,0,0,15,255,254,0,0,0,31,255,255,128,0,0,0,31,255,255,0,0,0,31,255,255,128,0,0,0,31,255,255,0,0,0,63,254,255,192,0,0,0,63,255,255,128,0,0,127,252,127,224,0,0,0,127,231,255,192,0,0,127,248,63,240,0,0,0,255,195,255,192,0,0,255,248,31,248,0,0,1,255,131,255,224,0,0,255,240,7,248,0,0,1,254,1,255,224,0,0,255,240,3,252,0,0,3,252,1,255,224,0,1,255,224,1,254,0,0,7,248,0,255,240,0,1,255,224,0,255,0,0,15,240,0,255,240,0,1,255,192,0,63,128,0,31,192,0,127,240,0,1,255,192,0,31,128,0,31,128,0,127,240,0,3,255,192,0,15,192,0,63,0,0,127,248,0,3,255,128,0,7,224,0,126,0,0,63,248,0,3,255,128,0,1,240,0,248,0,0,63,248,0,3,255,128,0,0,248,1,240,0,0,63,248,0,3,255,128,0,0,120,1,224,0,0,63,248,0,7,255,0,0,0,60,3,192,0,0,63,252,0,7,255,0,0,0,14,7,0,0,0,31,252,0,7,255,0,0,0,7,14,0,0,0,31,252,0,7,255,0,0,0,3,156,0,0,0,31,252,0,7,255,0,0,0,1,152,0,0,0,31,252,0,7,255,0,0,0,0,96,0,0,0,31,252,0] /* \00 \00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154064=allocate([99,114,111,115,115,104,97,105,114,112,97,116,104,0] /* crosshairpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10error_text=allocate([110, 111, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 116, 32, 97, 32, 109, 117, 108, 116, 105, 99, 97, 114, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 111, 100, 117, 108, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 99, 111, 114, 114, 117, 112, 116, 0, 0, 0, 0, 0, 111, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 109, 108, 32, 102, 111, 114, 109, 97, 116, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 102, 105, 108, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 0, 0, 0, 0, 0, 0, 0, 0, 122, 105, 112, 32, 102, 105, 108, 101, 32, 101, 114, 114, 111, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 105, 115, 115, 105, 110, 103, 32, 114, 97, 109, 32, 108, 101, 110, 103, 116, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 114, 97, 109, 32, 115, 112, 101, 99, 105, 102, 105, 99, 97, 116, 105, 111, 110, 0, 0, 0, 0, 0, 117, 110, 107, 110, 111, 119, 110, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 116, 121, 112, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 0, 0, 0, 0, 105, 110, 118, 97, 108, 105, 100, 32, 102, 105, 108, 101, 32, 102, 111, 114, 109, 97, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 105, 115, 115, 105, 110, 103, 32, 108, 97, 121, 111, 117, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 111, 32, 112, 99, 98, 32, 111, 114, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 102, 111, 117, 110, 100, 0, 0, 0, 0, 0, 0], "i8", ALLOC_STATIC);
STRING_TABLE.__str4067=allocate([115,114,99,47,101,109,117,47,105,109,97,103,101,100,101,118,47,109,117,108,116,99,97,114,116,46,99,0] /* src/emu/imagedev/mul */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14068=allocate([108,97,121,111,117,116,46,120,109,108,0] /* layout.xml\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24069=allocate([116,121,112,101,0] /* type\00 */, "i8", ALLOC_STATIC);
__str34070=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str44071=allocate([115,111,99,107,101,116,0] /* socket\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54072=allocate([105,100,0] /* id\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64073=allocate([117,115,101,115,0] /* uses\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74074=allocate([108,101,110,103,116,104,0] /* length\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84075=allocate([112,101,114,115,105,115,116,101,110,116,0] /* persistent\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94076=allocate([102,105,108,101,0] /* file\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104077=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114078=allocate([99,114,99,0] /* crc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124079=allocate([115,104,97,49,0] /* sha1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134080=allocate([114,111,109,0] /* rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144081=allocate([114,97,109,0] /* ram\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154082=allocate([114,111,109,115,101,116,0] /* romset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164083=allocate([99,111,110,102,105,103,117,114,97,116,105,111,110,0] /* configuration\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174084=allocate([112,99,98,0] /* pcb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184085=allocate([114,101,115,111,117,114,99,101,115,0] /* resources\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4095=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14096=allocate([37,115,58,32,85,110,115,117,112,112,111,114,116,101,100,32,98,105,116,32,100,101,112,116,104,32,37,100,32,40,56,32,98,105,116,32,109,97,120,41,10,0] /* %s: Unsupported bit  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24097=allocate([37,115,58,32,73,110,116,101,114,108,97,99,101,32,117,110,115,117,112,112,111,114,116,101,100,10,0] /* %s: Interlace unsupp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34098=allocate([37,115,58,32,85,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,116,121,112,101,32,37,100,10,0] /* %s: Unsupported colo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44099=allocate([115,114,99,47,101,109,117,47,114,101,110,100,117,116,105,108,46,99,0] /* src/emu/rendutil.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4108=allocate([115,114,99,47,101,109,117,47,97,117,100,105,111,47,103,101,110,101,114,105,99,46,99,0] /* src/emu/audio/generi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14109=allocate([115,116,97,116,101,45,62,108,97,116,99,104,101,100,95,118,97,108,117,101,0] /* state->latched_value */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24110=allocate([115,116,97,116,101,45,62,108,97,116,99,104,95,114,101,97,100,0] /* state->latch_read\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54113=allocate([103,108,111,98,97,108,0] /* global\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI22_generic_audio_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7226, 0, 0, 0, 7228, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22_generic_audio_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,95,103,101,110,101,114,105,99,95,97,117,100,105,111,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22_generic_audio_privateE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str4118=allocate([115,114,99,47,101,109,117,47,118,105,100,101,111,47,103,101,110,101,114,105,99,46,99,0] /* src/emu/video/generi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14119=allocate([115,116,97,116,101,45,62,102,108,105,112,95,115,99,114,101,101,110,95,120,0] /* state->flip_screen_x */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24120=allocate([115,116,97,116,101,45,62,102,108,105,112,95,115,99,114,101,101,110,95,121,0] /* state->flip_screen_y */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34121=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44122=allocate([86,105,100,101,111,32,98,117,102,102,101,114,115,32,115,112,114,105,116,101,114,97,109,32,98,117,116,32,115,112,114,105,116,101,114,97,109,32,115,105,122,101,32,105,115,32,48,0] /* Video buffers sprite */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54124=allocate([109,97,99,104,105,110,101,46,103,101,110,101,114,105,99,46,98,117,102,102,101,114,101,100,95,115,112,114,105,116,101,114,97,109,46,117,56,0] /* machine.generic.buff */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64125=allocate([109,97,99,104,105,110,101,46,103,101,110,101,114,105,99,46,98,117,102,102,101,114,101,100,95,115,112,114,105,116,101,114,97,109,50,46,117,56,0] /* machine.generic.buff */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84127=allocate([103,108,111,98,97,108,0] /* global\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI22_generic_video_privateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7230, 0, 0, 0, 7232, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI22_generic_video_privateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,50,95,103,101,110,101,114,105,99,95,118,105,100,101,111,95,112,114,105,118,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI22_generic_video_privateE=allocate(12, "*", ALLOC_STATIC);
__ZL15console_textbuf=allocate(1, "%struct._text_buffer*", ALLOC_STATIC);
__ZL16errorlog_textbuf=allocate(1, "%struct._text_buffer*", ALLOC_STATIC);
STRING_TABLE.__str4133=allocate([77,65,77,69,32,110,101,119,32,100,101,98,117,103,103,101,114,32,118,101,114,115,105,111,110,32,37,115,10,0] /* MAME new debugger ve */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14134=allocate([67,117,114,114,101,110,116,108,121,32,116,97,114,103,101,116,105,110,103,32,37,115,32,40,37,115,41,10,0] /* Currently targeting  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24135=allocate([100,101,98,117,103,95,99,111,110,115,111,108,101,95,101,120,105,116,0] /* debug_console_exit\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34136=allocate([62,37,115,10,0] /* >%s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44137=allocate([32,37,42,115,94,10,0] /*  %_s^\0A\00 */, "i8", ALLOC_STATIC);
__str54138=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str64139=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74140=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84141=allocate([67,97,110,32,111,110,108,121,32,99,97,108,108,32,100,101,98,117,103,95,99,111,110,115,111,108,101,95,114,101,103,105,115,116,101,114,95,99,111,109,109,97,110,100,40,41,32,97,116,32,105,110,105,116,32,116,105,109,101,33,0] /* Can only call debug_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94142=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,101,98,117,103,99,111,110,46,99,0] /* src/emu/debug/debugc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104143=allocate([67,97,110,110,111,116,32,99,97,108,108,32,100,101,98,117,103,95,99,111,110,115,111,108,101,95,114,101,103,105,115,116,101,114,95,99,111,109,109,97,110,100,40,41,32,119,104,101,110,32,100,101,98,117,103,103,101,114,32,105,115,32,110,111,116,32,114,117,110,110,105,110,103,0] /* Cannot call debug_co */, "i8", ALLOC_STATIC);
__ZL11commandlist=allocate(1, "%struct._debug_command*", ALLOC_STATIC);
STRING_TABLE.__str114144=allocate([117,110,107,110,111,119,110,32,99,111,109,109,97,110,100,0] /* unknown command\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124145=allocate([97,109,98,105,103,117,111,117,115,32,99,111,109,109,97,110,100,0] /* ambiguous command\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134146=allocate([117,110,98,97,108,97,110,99,101,100,32,112,97,114,101,110,116,104,101,115,101,115,0] /* unbalanced parenthes */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144147=allocate([117,110,98,97,108,97,110,99,101,100,32,113,117,111,116,101,115,0] /* unbalanced quotes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154148=allocate([110,111,116,32,101,110,111,117,103,104,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,99,111,109,109,97,110,100,0] /* not enough parameter */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164149=allocate([116,111,111,32,109,97,110,121,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,99,111,109,109,97,110,100,0] /* too many parameters  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174150=allocate([101,114,114,111,114,32,105,110,32,97,115,115,105,103,110,109,101,110,116,32,101,120,112,114,101,115,115,105,111,110,0] /* error in assignment  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184151=allocate([117,110,107,110,111,119,110,32,101,114,114,111,114,0] /* unknown error\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI14_debug_commandE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7234, 0, 0, 0, 7236, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14_debug_commandE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,95,100,101,98,117,103,95,99,111,109,109,97,110,100,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14_debug_commandE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str4164=allocate([115,114,99,47,101,109,117,47,117,105,109,101,110,117,46,99,0] /* src/emu/uimenu.c\00 */, "i8", ALLOC_STATIC);
__ZL14hilight_bitmap=allocate(1, "%class.bitmap_t*", ALLOC_STATIC);
__ZL15hilight_texture=allocate(1, "%class.render_texture.9915*", ALLOC_STATIC);
__ZL13arrow_texture=allocate(1, "%class.render_texture.9915*", ALLOC_STATIC);
STRING_TABLE.__str14165=allocate([117,105,95,109,101,110,117,95,101,120,105,116,0] /* ui_menu_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8backtext=allocate([82,101,116,117,114,110,32,116,111,32,83,121,115,116,101,109,0] /* Return to System\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8exittext=allocate([69,120,105,116,0] /* Exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9priortext=allocate([82,101,116,117,114,110,32,116,111,32,80,114,105,111,114,32,77,101,110,117,0] /* Return to Prior Menu */, "i8", ALLOC_STATIC);
__ZL10menu_stack=allocate(1, "%class.ui_menu*", ALLOC_STATIC);
__ZL9menu_free=allocate(1, "%class.ui_menu*", ALLOC_STATIC);
__str24166=allocate(1, "i8", ALLOC_STATIC);
__ZTV19resource_pool_arrayI13_ui_menu_itemE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7238, 0, 0, 0, 7240, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI13_ui_menu_itemE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,49,51,95,117,105,95,109,101,110,117,95,105,116,101,109,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI13_ui_menu_itemE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI7ui_menuE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7242, 0, 0, 0, 7244, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI7ui_menuE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,55,117,105,95,109,101,110,117,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI7ui_menuE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str34167=allocate([82,0] /* R\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44168=allocate([84,104,101,32,115,101,108,101,99,116,101,100,32,103,97,109,101,32,105,115,32,109,105,115,115,105,110,103,32,111,110,101,32,111,114,32,109,111,114,101,32,114,101,113,117,105,114,101,100,32,82,79,77,32,111,114,32,67,72,68,32,105,109,97,103,101,115,46,32,80,108,101,97,115,101,32,115,101,108,101,99,116,32,97,32,100,105,102,102,101,114,101,110,116,32,103,97,109,101,46,10,10,80,114,101,115,115,32,97,110,121,32,107,101,121,32,116,111,32,99,111,110,116,105,110,117,101,46,0] /* The selected game is */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54169=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64170=allocate([37,115,32,65,110,97,108,111,103,0] /* %s Analog\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74171=allocate([37,115,32,65,110,97,108,111,103,32,73,110,99,0] /* %s Analog Inc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84172=allocate([37,115,32,65,110,97,108,111,103,32,68,101,99,0] /* %s Analog Dec\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94173=allocate([32,32,32,0] /*    \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104174=allocate([85,115,101,114,32,73,110,116,101,114,102,97,99,101,0] /* User Interface\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114175=allocate([80,108,97,121,101,114,32,37,100,32,67,111,110,116,114,111,108,115,0] /* Player %d Controls\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124176=allocate([79,116,104,101,114,32,67,111,110,116,114,111,108,115,0] /* Other Controls\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134177=allocate([78,111,32,115,121,115,116,101,109,115,32,102,111,117,110,100,46,32,80,108,101,97,115,101,32,99,104,101,99,107,32,116,104,101,32,114,111,109,112,97,116,104,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,109,101,115,115,46,105,110,105,32,102,105,108,101,46,10,10,73,102,32,116,104,105,115,32,105,115,32,121,111,117,114,32,102,105,114,115,116,32,116,105,109,101,32,117,115,105,110,103,32,77,69,83,83,44,32,112,108,101,97,115,101,32,115,101,101,32,116,104,101,32,99,111,110,102,105,103,46,116,120,116,32,102,105,108,101,32,105,110,32,116,104,101,32,100,111,99,115,32,100,105,114,101,99,116,111,114,121,32,102,111,114,32,105,110,102,111,114,109,97,116,105,111,110,32,111,110,32,99,111,110,102,105,103,117,114,105,110,103,32,77,69,83,83,46,0] /* No systems found. Pl */, "i8", ALLOC_STATIC);
__ZL8drivlist=allocate(1, "%class.driver_enumerator.9918*", ALLOC_STATIC);
STRING_TABLE.__str144178=allocate([45,45,45,0] /* ---\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154179=allocate([67,111,110,102,105,103,117,114,101,32,71,101,110,101,114,97,108,32,73,110,112,117,116,115,0] /* Configure General In */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164180=allocate([84,121,112,101,32,110,97,109,101,32,111,114,32,115,101,108,101,99,116,58,32,37,115,95,0] /* Type name or select: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174181=allocate([84,121,112,101,32,110,97,109,101,32,111,114,32,115,101,108,101,99,116,58,32,40,114,97,110,100,111,109,41,0] /* Type name or select: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184182=allocate([37,45,46,49,48,48,115,0] /* %-.100s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194183=allocate([37,115,44,32,37,45,46,49,48,48,115,0] /* %s, %-.100s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204184=allocate([79,118,101,114,97,108,108,58,32,78,79,84,32,87,79,82,75,73,78,71,0] /* Overall: NOT WORKING */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214185=allocate([79,118,101,114,97,108,108,58,32,85,110,101,109,117,108,97,116,101,100,32,80,114,111,116,101,99,116,105,111,110,0] /* Overall: Unemulated  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224186=allocate([79,118,101,114,97,108,108,58,32,87,111,114,107,105,110,103,0] /* Overall: Working\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234187=allocate([73,109,112,101,114,102,101,99,116,0] /* Imperfect\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244188=allocate([79,75,0] /* OK\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254189=allocate([85,110,105,109,112,108,101,109,101,110,116,101,100,0] /* Unimplemented\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264190=allocate([71,102,120,58,32,37,115,44,32,83,111,117,110,100,58,32,37,115,0] /* Gfx: %s, Sound: %s\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274191=allocate([67,111,112,121,114,105,103,104,116,32,116,104,101,32,77,69,83,83,32,116,101,97,109,10,104,116,116,112,58,47,47,109,101,115,115,46,111,114,103,0] /* Copyright the MESS t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284192=allocate([37,115,32,37,115,0] /* %s %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294193=allocate([77,46,69,46,83,46,83,46,0] /* M.E.S.S.\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI17driver_enumeratorE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7246, 0, 0, 0, 7248, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17driver_enumeratorE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,100,114,105,118,101,114,95,101,110,117,109,101,114,97,116,111,114,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17driver_enumeratorE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str314195=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324196=allocate([73,110,112,117,116,32,40,103,101,110,101,114,97,108,41,0] /* Input (general)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334197=allocate([73,110,112,117,116,32,40,116,104,105,115,32,83,121,115,116,101,109,41,0] /* Input (this System)\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344198=allocate([68,105,112,32,83,119,105,116,99,104,101,115,0] /* Dip Switches\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354199=allocate([68,114,105,118,101,114,32,67,111,110,102,105,103,117,114,97,116,105,111,110,0] /* Driver Configuration */, "i8", ALLOC_STATIC);
STRING_TABLE.__str364200=allocate([67,97,116,101,103,111,114,105,101,115,0] /* Categories\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374201=allocate([65,110,97,108,111,103,32,67,111,110,116,114,111,108,115,0] /* Analog Controls\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384202=allocate([66,111,111,107,107,101,101,112,105,110,103,32,73,110,102,111,0] /* Bookkeeping Info\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394203=allocate([83,121,115,116,101,109,32,73,110,102,111,114,109,97,116,105,111,110,0] /* System Information\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str404204=allocate([73,109,97,103,101,32,73,110,102,111,114,109,97,116,105,111,110,0] /* Image Information\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str414205=allocate([70,105,108,101,32,77,97,110,97,103,101,114,0] /* File Manager\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424206=allocate([84,97,112,101,32,67,111,110,116,114,111,108,0] /* Tape Control\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str434207=allocate([66,105,116,98,97,110,103,101,114,32,67,111,110,116,114,111,108,0] /* Bitbanger Control\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444208=allocate([83,108,111,116,32,68,101,118,105,99,101,115,0] /* Slot Devices\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str454209=allocate([75,101,121,98,111,97,114,100,32,77,111,100,101,0] /* Keyboard Mode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str464210=allocate([83,108,105,100,101,114,32,67,111,110,116,114,111,108,115,0] /* Slider Controls\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str474211=allocate([86,105,100,101,111,32,79,112,116,105,111,110,115,0] /* Video Options\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str484212=allocate([67,114,111,115,115,104,97,105,114,32,79,112,116,105,111,110,115,0] /* Crosshair Options\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str494213=allocate([67,104,101,97,116,0] /* Cheat\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str504214=allocate([77,101,109,111,114,121,32,67,97,114,100,0] /* Memory Card\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str514215=allocate([83,101,108,101,99,116,32,78,101,119,32,83,121,115,116,101,109,0] /* Select New System\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str524216=allocate([77,101,109,111,114,121,32,99,97,114,100,32,108,111,97,100,101,100,0] /* Memory card loaded\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str534217=allocate([69,114,114,111,114,32,108,111,97,100,105,110,103,32,109,101,109,111,114,121,32,99,97,114,100,0] /* Error loading memory */, "i8", ALLOC_STATIC);
STRING_TABLE.__str544218=allocate([77,101,109,111,114,121,32,99,97,114,100,32,101,106,101,99,116,101,100,0] /* Memory card ejected\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str554219=allocate([77,101,109,111,114,121,32,99,97,114,100,32,99,114,101,97,116,101,100,0] /* Memory card created\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str564220=allocate([69,114,114,111,114,32,99,114,101,97,116,105,110,103,32,109,101,109,111,114,121,32,99,97,114,100,10,40,67,97,114,100,32,109,97,121,32,97,108,114,101,97,100,121,32,101,120,105,115,116,41,0] /* Error creating memor */, "i8", ALLOC_STATIC);
STRING_TABLE.__str574221=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str584222=allocate([67,97,114,100,32,78,117,109,98,101,114,58,0] /* Card Number:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str594223=allocate([76,111,97,100,32,83,101,108,101,99,116,101,100,32,67,97,114,100,0] /* Load Selected Card\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str604224=allocate([69,106,101,99,116,32,67,117,114,114,101,110,116,32,67,97,114,100,0] /* Eject Current Card\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str614225=allocate([67,114,101,97,116,101,32,78,101,119,32,67,97,114,100,0] /* Create New Card\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str624226=allocate([67,104,101,97,116,32,67,111,109,109,101,110,116,58,10,37,115,0] /* Cheat Comment:\0A%s\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str634227=allocate([65,108,108,32,99,104,101,97,116,115,32,114,101,108,111,97,100,101,100,0] /* All cheats reloaded\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str644228=allocate([82,101,115,101,116,32,65,108,108,0] /* Reset All\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str654229=allocate([82,101,108,111,97,100,32,65,108,108,0] /* Reload All\00 */, "i8", ALLOC_STATIC);
__ZZL23menu_crosshair_populateR15running_machineP7ui_menuE8vis_text=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str674231=allocate([79,102,102,0] /* Off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str684232=allocate([79,110,0] /* On\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str694233=allocate([65,117,116,111,0] /* Auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str704234=allocate([80,37,100,32,86,105,115,105,98,105,108,105,116,121,0] /* P%d Visibility\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str714235=allocate([80,37,100,32,67,114,111,115,115,104,97,105,114,0] /* P%d Crosshair\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str724236=allocate([68,69,70,65,85,76,84,0] /* DEFAULT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str734237=allocate([86,105,115,105,98,108,101,32,68,101,108,97,121,0] /* Visible Delay\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str754239=allocate([95,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str764240=allocate([78,111,110,101,0] /* None\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str774241=allocate([67,87,32,57,48,194,176,0] /* CW 90\C2\B0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str784242=allocate([49,56,48,194,176,0] /* 180\C2\B0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str794243=allocate([67,67,87,32,57,48,194,176,0] /* CCW 90\C2\B0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str804244=allocate([82,111,116,97,116,101,0] /* Rotate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str814245=allocate([66,97,99,107,100,114,111,112,115,0] /* Backdrops\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str824246=allocate([69,110,97,98,108,101,100,0] /* Enabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str834247=allocate([68,105,115,97,98,108,101,100,0] /* Disabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str844248=allocate([79,118,101,114,108,97,121,115,0] /* Overlays\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str854249=allocate([66,101,122,101,108,115,0] /* Bezels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str864250=allocate([67,80,97,110,101,108,115,0] /* CPanels\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str874251=allocate([77,97,114,113,117,101,101,115,0] /* Marquees\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str884252=allocate([86,105,101,119,0] /* View\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str894253=allocate([67,114,111,112,112,101,100,0] /* Cropped\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str904254=allocate([70,117,108,108,0] /* Full\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str914255=allocate([83,99,114,101,101,110,32,35,37,100,0] /* Screen #%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str924256=allocate([75,101,121,98,111,97,114,100,32,77,111,100,101,58,0] /* Keyboard Mode:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str934257=allocate([78,97,116,117,114,97,108,0] /* Natural\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str944258=allocate([69,109,117,108,97,116,101,100,0] /* Emulated\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str954259=allocate([45,45,45,45,45,45,0] /* ------\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str964260=allocate([82,101,115,101,116,0] /* Reset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str974261=allocate([85,112,116,105,109,101,58,32,37,100,58,37,48,50,100,58,37,48,50,100,10,10,0] /* Uptime: %d:%02d:%02d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str984262=allocate([85,112,116,105,109,101,58,32,37,100,58,37,48,50,100,10,10,0] /* Uptime: %d:%02d\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str994263=allocate([84,105,99,107,101,116,115,32,100,105,115,112,101,110,115,101,100,58,32,37,100,10,10,0] /* Tickets dispensed: % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1004264=allocate([67,111,105,110,32,37,99,58,32,0] /* Coin %c: \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1014265=allocate([78,65,0] /* NA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1024266=allocate([32,40,108,111,99,107,101,100,41,0] /*  (locked)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1034267=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1044268=allocate([37,115,32,68,105,103,105,116,97,108,32,83,112,101,101,100,0] /* %s Digital Speed\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1054269=allocate([37,115,32,65,117,116,111,99,101,110,116,101,114,32,83,112,101,101,100,0] /* %s Autocenter Speed\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1064270=allocate([37,115,32,82,101,118,101,114,115,101,0] /* %s Reverse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1074271=allocate([37,115,32,83,101,110,115,105,116,105,118,105,116,121,0] /* %s Sensitivity\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1084272=allocate([46,46,46,0] /* ...\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4286=allocate([117,105,46,98,100,102,0] /* ui.bdf\00 */, "i8", ALLOC_STATIC);
__ZL10debug_font=allocate(1, "%class.render_font.10159*", ALLOC_STATIC);
__ZL16debug_font_width=allocate(1, "i32", ALLOC_STATIC);
__ZL17debug_font_height=allocate(1, "i32", ALLOC_STATIC);
__ZL4menu=allocate(1, "%class.ui_menu*", ALLOC_STATIC);
__ZL10cur_editor=allocate(1, "%class.DView_edit*", ALLOC_STATIC);
__ZL4list=allocate(1, "%class.DView*", ALLOC_STATIC);
__ZL10focus_view=allocate(1, "%class.DView*", ALLOC_STATIC);
__ZL17debug_font_aspect=allocate(1, "float", ALLOC_STATIC);
STRING_TABLE.__str14287=allocate([100,101,98,117,103,105,110,116,95,101,120,105,116,0] /* debugint_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24288=allocate([67,111,110,115,111,108,101,0] /* Console\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34289=allocate([70,97,116,97,108,32,101,114,114,111,114,58,32,37,115,32,40,37,115,58,37,100,41,0] /* Fatal error: %s (%s: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44290=allocate([117,110,107,110,111,119,110,32,114,101,99,116,97,110,103,108,101,32,116,121,112,101,0] /* unknown rectangle ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54291=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,105,110,116,47,100,101,98,117,103,105,110,116,46,99,0] /* src/emu/debugint/deb */, "i8", ALLOC_STATIC);
__str64292=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str74293=allocate([68,105,115,97,115,115,101,109,98,108,121,58,0] /* Disassembly:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84294=allocate([67,111,110,115,111,108,101,58,0] /* Console:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94295=allocate([76,111,103,58,0] /* Log:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104296=allocate([77,101,109,111,114,121,58,0] /* Memory:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114297=allocate([83,116,97,116,101,58,0] /* State:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124298=allocate([45,45,45,0] /* ---\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134299=allocate([82,97,119,32,79,112,99,111,100,101,115,0] /* Raw Opcodes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144300=allocate([69,110,99,32,79,112,99,111,100,101,115,0] /* Enc Opcodes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154301=allocate([67,111,109,109,101,110,116,115,0] /* Comments\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164302=allocate([86,105,101,119,0] /* View\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174303=allocate([82,117,110,32,116,111,32,99,117,114,115,111,114,0] /* Run to cursor\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184304=allocate([67,80,85,0] /* CPU\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194305=allocate([78,101,119,32,77,101,109,111,114,121,32,87,105,110,100,111,119,0] /* New Memory Window\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204306=allocate([78,101,119,32,68,105,115,97,115,115,101,109,98,108,121,32,87,105,110,100,111,119,0] /* New Disassembly Wind */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214307=allocate([78,101,119,32,69,114,114,111,114,32,76,111,103,32,87,105,110,100,111,119,0] /* New Error Log Window */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224308=allocate([82,117,110,0] /* Run\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234309=allocate([82,117,110,32,116,111,32,78,101,120,116,32,67,80,85,0] /* Run to Next CPU\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244310=allocate([82,117,110,32,117,110,116,105,108,32,78,101,120,116,32,73,110,116,101,114,114,117,112,116,32,111,110,32,84,104,105,115,32,67,80,85,0] /* Run until Next Inter */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254311=allocate([82,117,110,32,117,110,116,105,108,32,78,101,120,116,32,86,66,76,65,78,75,0] /* Run until Next VBLAN */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264312=allocate([83,116,101,112,32,73,110,116,111,0] /* Step Into\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274313=allocate([83,116,101,112,32,79,118,101,114,0] /* Step Over\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284314=allocate([83,111,102,116,32,82,101,115,101,116,0] /* Soft Reset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294315=allocate([72,97,114,100,32,82,101,115,101,116,0] /* Hard Reset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304316=allocate([67,108,111,115,101,32,87,105,110,100,111,119,0] /* Close Window\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314317=allocate([69,120,105,116,0] /* Exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324318=allocate([76,111,103,0] /* Log\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334319=allocate([103,111,32,37,88,0] /* go %X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344320=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354321=allocate([99,117,114,112,99,0] /* curpc\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI5DViewE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7250, 0, 0, 0, 7252, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI5DViewE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,53,68,86,105,101,119,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI5DViewE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str4326=allocate([115,114,99,47,101,109,117,47,100,114,105,118,101,114,46,99,0] /* src/emu/driver.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14327=allocate([95,95,95,101,109,112,116,121,0] /* ___empty\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectIN17driver_enumerator12config_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7254, 0, 0, 0, 7256, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN17driver_enumerator12config_entryEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,55,100,114,105,118,101,114,95,101,110,117,109,101,114,97,116,111,114,49,50,99,111,110,102,105,103,95,101,110,116,114,121,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN17driver_enumerator12config_entryEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI14machine_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7258, 0, 0, 0, 7260, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14machine_configE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,109,97,99,104,105,110,101,95,99,111,110,102,105,103,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14machine_configE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN17driver_enumerator12config_entryEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7262, 0, 0, 0, 7264, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN17driver_enumerator12config_entryEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,55,100,114,105,118,101,114,95,101,110,117,109,101,114,97,116,111,114,49,50,99,111,110,102,105,103,95,101,110,116,114,121,69,69,0] /* 11simple_listIN17dri */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN17driver_enumerator12config_entryEE=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIP14machine_configE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7266, 0, 0, 0, 7268, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIP14machine_configE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,80,49,52,109,97,99,104,105,110,101,95,99,111,110,102,105,103,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIP14machine_configE=allocate(12, "*", ALLOC_STATIC);
__ZN11emu_options16s_option_entriesE=allocate(1792, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str4348=allocate([67,79,82,69,32,67,79,78,70,73,71,85,82,65,84,73,79,78,32,79,80,84,73,79,78,83,0] /* CORE CONFIGURATION O */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14349=allocate([114,101,97,100,99,111,110,102,105,103,59,114,99,0] /* readconfig;rc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24350=allocate([49,0] /* 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34351=allocate([101,110,97,98,108,101,32,108,111,97,100,105,110,103,32,111,102,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,105,108,101,115,0] /* enable loading of co */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44352=allocate([119,114,105,116,101,99,111,110,102,105,103,59,119,99,0] /* writeconfig;wc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54353=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64354=allocate([119,114,105,116,101,115,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,116,111,32,40,100,114,105,118,101,114,41,46,105,110,105,32,111,110,32,101,120,105,116,0] /* writes configuration */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74355=allocate([67,79,82,69,32,83,69,65,82,67,72,32,80,65,84,72,32,79,80,84,73,79,78,83,0] /* CORE SEARCH PATH OPT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84356=allocate([114,111,109,112,97,116,104,59,114,112,59,98,105,111,115,112,97,116,104,59,98,112,0] /* rompath;rp;biospath; */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94357=allocate([114,111,109,115,0] /* roms\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104358=allocate([112,97,116,104,32,116,111,32,82,79,77,115,101,116,115,32,97,110,100,32,104,97,114,100,32,100,105,115,107,32,105,109,97,103,101,115,0] /* path to ROMsets and  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114359=allocate([104,97,115,104,112,97,116,104,59,104,97,115,104,95,100,105,114,101,99,116,111,114,121,59,104,97,115,104,0] /* hashpath;hash_direct */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124360=allocate([104,97,115,104,0] /* hash\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134361=allocate([112,97,116,104,32,116,111,32,104,97,115,104,32,102,105,108,101,115,0] /* path to hash files\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144362=allocate([115,97,109,112,108,101,112,97,116,104,59,115,112,0] /* samplepath;sp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154363=allocate([115,97,109,112,108,101,115,0] /* samples\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164364=allocate([112,97,116,104,32,116,111,32,115,97,109,112,108,101,115,101,116,115,0] /* path to samplesets\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174365=allocate([97,114,116,112,97,116,104,0] /* artpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184366=allocate([97,114,116,119,111,114,107,0] /* artwork\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194367=allocate([112,97,116,104,32,116,111,32,97,114,116,119,111,114,107,32,102,105,108,101,115,0] /* path to artwork file */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204368=allocate([99,116,114,108,114,112,97,116,104,0] /* ctrlrpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214369=allocate([99,116,114,108,114,0] /* ctrlr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224370=allocate([112,97,116,104,32,116,111,32,99,111,110,116,114,111,108,108,101,114,32,100,101,102,105,110,105,116,105,111,110,115,0] /* path to controller d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234371=allocate([105,110,105,112,97,116,104,0] /* inipath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244372=allocate([46,59,105,110,105,0] /* .;ini\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254373=allocate([112,97,116,104,32,116,111,32,105,110,105,32,102,105,108,101,115,0] /* path to ini files\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264374=allocate([102,111,110,116,112,97,116,104,0] /* fontpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274375=allocate([46,0] /* .\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284376=allocate([112,97,116,104,32,116,111,32,102,111,110,116,32,102,105,108,101,115,0] /* path to font files\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294377=allocate([99,104,101,97,116,112,97,116,104,0] /* cheatpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304378=allocate([99,104,101,97,116,0] /* cheat\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314379=allocate([112,97,116,104,32,116,111,32,99,104,101,97,116,32,102,105,108,101,115,0] /* path to cheat files\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324380=allocate([99,114,111,115,115,104,97,105,114,112,97,116,104,0] /* crosshairpath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334381=allocate([99,114,111,115,115,104,97,105,114,0] /* crosshair\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344382=allocate([112,97,116,104,32,116,111,32,99,114,111,115,115,104,97,105,114,32,102,105,108,101,115,0] /* path to crosshair fi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354383=allocate([67,79,82,69,32,79,85,84,80,85,84,32,68,73,82,69,67,84,79,82,89,32,79,80,84,73,79,78,83,0] /* CORE OUTPUT DIRECTOR */, "i8", ALLOC_STATIC);
STRING_TABLE.__str364384=allocate([99,102,103,95,100,105,114,101,99,116,111,114,121,0] /* cfg_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374385=allocate([99,102,103,0] /* cfg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384386=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,99,111,110,102,105,103,117,114,97,116,105,111,110,115,0] /* directory to save co */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394387=allocate([110,118,114,97,109,95,100,105,114,101,99,116,111,114,121,0] /* nvram_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str404388=allocate([110,118,114,97,109,0] /* nvram\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str414389=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,110,118,114,97,109,32,99,111,110,116,101,110,116,115,0] /* directory to save nv */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424390=allocate([109,101,109,99,97,114,100,95,100,105,114,101,99,116,111,114,121,0] /* memcard_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str434391=allocate([109,101,109,99,97,114,100,0] /* memcard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444392=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,109,101,109,111,114,121,32,99,97,114,100,32,99,111,110,116,101,110,116,115,0] /* directory to save me */, "i8", ALLOC_STATIC);
STRING_TABLE.__str454393=allocate([105,110,112,117,116,95,100,105,114,101,99,116,111,114,121,0] /* input_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str464394=allocate([105,110,112,0] /* inp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str474395=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,105,110,112,117,116,32,100,101,118,105,99,101,32,108,111,103,115,0] /* directory to save in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str484396=allocate([115,116,97,116,101,95,100,105,114,101,99,116,111,114,121,0] /* state_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str494397=allocate([115,116,97,0] /* sta\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str504398=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,115,116,97,116,101,115,0] /* directory to save st */, "i8", ALLOC_STATIC);
STRING_TABLE.__str514399=allocate([115,110,97,112,115,104,111,116,95,100,105,114,101,99,116,111,114,121,0] /* snapshot_directory\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str524400=allocate([115,110,97,112,0] /* snap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str534401=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,115,99,114,101,101,110,115,104,111,116,115,0] /* directory to save sc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str544402=allocate([100,105,102,102,95,100,105,114,101,99,116,111,114,121,0] /* diff_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str554403=allocate([100,105,102,102,0] /* diff\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str564404=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,104,97,114,100,32,100,114,105,118,101,32,105,109,97,103,101,32,100,105,102,102,101,114,101,110,99,101,32,102,105,108,101,115,0] /* directory to save ha */, "i8", ALLOC_STATIC);
STRING_TABLE.__str574405=allocate([99,111,109,109,101,110,116,95,100,105,114,101,99,116,111,114,121,0] /* comment_directory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str584406=allocate([99,111,109,109,101,110,116,115,0] /* comments\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str594407=allocate([100,105,114,101,99,116,111,114,121,32,116,111,32,115,97,118,101,32,100,101,98,117,103,103,101,114,32,99,111,109,109,101,110,116,115,0] /* directory to save de */, "i8", ALLOC_STATIC);
STRING_TABLE.__str604408=allocate([67,79,82,69,32,83,84,65,84,69,47,80,76,65,89,66,65,67,75,32,79,80,84,73,79,78,83,0] /* CORE STATE/PLAYBACK  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str614409=allocate([115,116,97,116,101,0] /* state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str624410=allocate([115,97,118,101,100,32,115,116,97,116,101,32,116,111,32,108,111,97,100,0] /* saved state to load\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str634411=allocate([97,117,116,111,115,97,118,101,0] /* autosave\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str644412=allocate([101,110,97,98,108,101,32,97,117,116,111,109,97,116,105,99,32,114,101,115,116,111,114,101,32,97,116,32,115,116,97,114,116,117,112,44,32,97,110,100,32,97,117,116,111,109,97,116,105,99,32,115,97,118,101,32,97,116,32,101,120,105,116,32,116,105,109,101,0] /* enable automatic res */, "i8", ALLOC_STATIC);
STRING_TABLE.__str654413=allocate([112,108,97,121,98,97,99,107,59,112,98,0] /* playback;pb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str664414=allocate([112,108,97,121,98,97,99,107,32,97,110,32,105,110,112,117,116,32,102,105,108,101,0] /* playback an input fi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str674415=allocate([114,101,99,111,114,100,59,114,101,99,0] /* record;rec\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str684416=allocate([114,101,99,111,114,100,32,97,110,32,105,110,112,117,116,32,102,105,108,101,0] /* record an input file */, "i8", ALLOC_STATIC);
STRING_TABLE.__str694417=allocate([109,110,103,119,114,105,116,101,0] /* mngwrite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str704418=allocate([111,112,116,105,111,110,97,108,32,102,105,108,101,110,97,109,101,32,116,111,32,119,114,105,116,101,32,97,32,77,78,71,32,109,111,118,105,101,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,115,101,115,115,105,111,110,0] /* optional filename to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str714419=allocate([97,118,105,119,114,105,116,101,0] /* aviwrite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str724420=allocate([111,112,116,105,111,110,97,108,32,102,105,108,101,110,97,109,101,32,116,111,32,119,114,105,116,101,32,97,110,32,65,86,73,32,109,111,118,105,101,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,115,101,115,115,105,111,110,0] /* optional filename to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str734421=allocate([119,97,118,119,114,105,116,101,0] /* wavwrite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str744422=allocate([111,112,116,105,111,110,97,108,32,102,105,108,101,110,97,109,101,32,116,111,32,119,114,105,116,101,32,97,32,87,65,86,32,102,105,108,101,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,115,101,115,115,105,111,110,0] /* optional filename to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str754423=allocate([115,110,97,112,110,97,109,101,0] /* snapname\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str764424=allocate([37,103,47,37,105,0] /* %g/%i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str774425=allocate([111,118,101,114,114,105,100,101,32,111,102,32,116,104,101,32,100,101,102,97,117,108,116,32,115,110,97,112,115,104,111,116,47,109,111,118,105,101,32,110,97,109,105,110,103,59,32,37,103,32,61,61,32,103,97,109,101,110,97,109,101,44,32,37,105,32,61,61,32,105,110,100,101,120,0] /* override of the defa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str784426=allocate([115,110,97,112,115,105,122,101,0] /* snapsize\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str794427=allocate([97,117,116,111,0] /* auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str804428=allocate([115,112,101,99,105,102,121,32,115,110,97,112,115,104,111,116,47,109,111,118,105,101,32,114,101,115,111,108,117,116,105,111,110,32,40,60,119,105,100,116,104,62,120,60,104,101,105,103,104,116,62,41,32,111,114,32,39,97,117,116,111,39,32,116,111,32,117,115,101,32,109,105,110,105,109,97,108,32,115,105,122,101,32,0] /* specify snapshot/mov */, "i8", ALLOC_STATIC);
STRING_TABLE.__str814429=allocate([115,110,97,112,118,105,101,119,0] /* snapview\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str824430=allocate([105,110,116,101,114,110,97,108,0] /* internal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str834431=allocate([115,112,101,99,105,102,121,32,115,110,97,112,115,104,111,116,47,109,111,118,105,101,32,118,105,101,119,32,111,114,32,39,105,110,116,101,114,110,97,108,39,32,116,111,32,117,115,101,32,105,110,116,101,114,110,97,108,32,112,105,120,101,108,45,97,115,112,101,99,116,32,118,105,101,119,115,0] /* specify snapshot/mov */, "i8", ALLOC_STATIC);
STRING_TABLE.__str844432=allocate([98,117,114,110,105,110,0] /* burnin\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str854433=allocate([99,114,101,97,116,101,32,98,117,114,110,45,105,110,32,115,110,97,112,115,104,111,116,115,32,102,111,114,32,101,97,99,104,32,115,99,114,101,101,110,0] /* create burn-in snaps */, "i8", ALLOC_STATIC);
STRING_TABLE.__str864434=allocate([67,79,82,69,32,80,69,82,70,79,82,77,65,78,67,69,32,79,80,84,73,79,78,83,0] /* CORE PERFORMANCE OPT */, "i8", ALLOC_STATIC);
STRING_TABLE.__str874435=allocate([97,117,116,111,102,114,97,109,101,115,107,105,112,59,97,102,115,0] /* autoframeskip;afs\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str884436=allocate([101,110,97,98,108,101,32,97,117,116,111,109,97,116,105,99,32,102,114,97,109,101,115,107,105,112,32,115,101,108,101,99,116,105,111,110,0] /* enable automatic fra */, "i8", ALLOC_STATIC);
STRING_TABLE.__str894437=allocate([102,114,97,109,101,115,107,105,112,59,102,115,40,48,45,49,48,41,0] /* frameskip;fs(0-10)\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str904438=allocate([115,101,116,32,102,114,97,109,101,115,107,105,112,32,116,111,32,102,105,120,101,100,32,118,97,108,117,101,44,32,48,45,49,48,32,40,97,117,116,111,102,114,97,109,101,115,107,105,112,32,109,117,115,116,32,98,101,32,100,105,115,97,98,108,101,100,41,0] /* set frameskip to fix */, "i8", ALLOC_STATIC);
STRING_TABLE.__str914439=allocate([115,101,99,111,110,100,115,95,116,111,95,114,117,110,59,115,116,114,0] /* seconds_to_run;str\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str924440=allocate([110,117,109,98,101,114,32,111,102,32,101,109,117,108,97,116,101,100,32,115,101,99,111,110,100,115,32,116,111,32,114,117,110,32,98,101,102,111,114,101,32,97,117,116,111,109,97,116,105,99,97,108,108,121,32,101,120,105,116,105,110,103,0] /* number of emulated s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str934441=allocate([116,104,114,111,116,116,108,101,0] /* throttle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str944442=allocate([101,110,97,98,108,101,32,116,104,114,111,116,116,108,105,110,103,32,116,111,32,107,101,101,112,32,103,97,109,101,32,114,117,110,110,105,110,103,32,105,110,32,115,121,110,99,32,119,105,116,104,32,114,101,97,108,32,116,105,109,101,0] /* enable throttling to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str954443=allocate([115,108,101,101,112,0] /* sleep\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str964444=allocate([101,110,97,98,108,101,32,115,108,101,101,112,105,110,103,44,32,119,104,105,99,104,32,103,105,118,101,115,32,116,105,109,101,32,98,97,99,107,32,116,111,32,111,116,104,101,114,32,97,112,112,108,105,99,97,116,105,111,110,115,32,119,104,101,110,32,105,100,108,101,0] /* enable sleeping, whi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str974445=allocate([115,112,101,101,100,40,48,46,48,49,45,49,48,48,41,0] /* speed(0.01-100)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str984446=allocate([49,46,48,0] /* 1.0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str994447=allocate([99,111,110,116,114,111,108,115,32,116,104,101,32,115,112,101,101,100,32,111,102,32,103,97,109,101,112,108,97,121,44,32,114,101,108,97,116,105,118,101,32,116,111,32,114,101,97,108,116,105,109,101,59,32,115,109,97,108,108,101,114,32,110,117,109,98,101,114,115,32,97,114,101,32,115,108,111,119,101,114,0] /* controls the speed o */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1004448=allocate([114,101,102,114,101,115,104,115,112,101,101,100,59,114,115,0] /* refreshspeed;rs\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1014449=allocate([97,117,116,111,109,97,116,105,99,97,108,108,121,32,97,100,106,117,115,116,115,32,116,104,101,32,115,112,101,101,100,32,111,102,32,103,97,109,101,112,108,97,121,32,116,111,32,107,101,101,112,32,116,104,101,32,114,101,102,114,101,115,104,32,114,97,116,101,32,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,115,99,114,101,101,110,0] /* automatically adjust */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1024450=allocate([67,79,82,69,32,82,79,84,65,84,73,79,78,32,79,80,84,73,79,78,83,0] /* CORE ROTATION OPTION */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1034451=allocate([114,111,116,97,116,101,0] /* rotate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1044452=allocate([114,111,116,97,116,101,32,116,104,101,32,103,97,109,101,32,115,99,114,101,101,110,32,97,99,99,111,114,100,105,110,103,32,116,111,32,116,104,101,32,103,97,109,101,39,115,32,111,114,105,101,110,116,97,116,105,111,110,32,110,101,101,100,115,32,105,116,0] /* rotate the game scre */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1054453=allocate([114,111,114,0] /* ror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1064454=allocate([114,111,116,97,116,101,32,115,99,114,101,101,110,32,99,108,111,99,107,119,105,115,101,32,57,48,32,100,101,103,114,101,101,115,0] /* rotate screen clockw */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1074455=allocate([114,111,108,0] /* rol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1084456=allocate([114,111,116,97,116,101,32,115,99,114,101,101,110,32,99,111,117,110,116,101,114,99,108,111,99,107,119,105,115,101,32,57,48,32,100,101,103,114,101,101,115,0] /* rotate screen counte */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1094457=allocate([97,117,116,111,114,111,114,0] /* autoror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1104458=allocate([97,117,116,111,109,97,116,105,99,97,108,108,121,32,114,111,116,97,116,101,32,115,99,114,101,101,110,32,99,108,111,99,107,119,105,115,101,32,57,48,32,100,101,103,114,101,101,115,32,105,102,32,118,101,114,116,105,99,97,108,0] /* automatically rotate */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1114459=allocate([97,117,116,111,114,111,108,0] /* autorol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1124460=allocate([97,117,116,111,109,97,116,105,99,97,108,108,121,32,114,111,116,97,116,101,32,115,99,114,101,101,110,32,99,111,117,110,116,101,114,99,108,111,99,107,119,105,115,101,32,57,48,32,100,101,103,114,101,101,115,32,105,102,32,118,101,114,116,105,99,97,108,0] /* automatically rotate */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1134461=allocate([102,108,105,112,120,0] /* flipx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1144462=allocate([102,108,105,112,32,115,99,114,101,101,110,32,108,101,102,116,45,114,105,103,104,116,0] /* flip screen left-rig */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1154463=allocate([102,108,105,112,121,0] /* flipy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1164464=allocate([102,108,105,112,32,115,99,114,101,101,110,32,117,112,115,105,100,101,45,100,111,119,110,0] /* flip screen upside-d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1174465=allocate([67,79,82,69,32,65,82,84,87,79,82,75,32,79,80,84,73,79,78,83,0] /* CORE ARTWORK OPTIONS */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1184466=allocate([97,114,116,119,111,114,107,95,99,114,111,112,59,97,114,116,99,114,111,112,0] /* artwork_crop;artcrop */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1194467=allocate([99,114,111,112,32,97,114,116,119,111,114,107,32,116,111,32,103,97,109,101,32,115,99,114,101,101,110,32,115,105,122,101,0] /* crop artwork to game */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1204468=allocate([117,115,101,95,98,97,99,107,100,114,111,112,115,59,98,97,99,107,100,114,111,112,0] /* use_backdrops;backdr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1214469=allocate([101,110,97,98,108,101,32,98,97,99,107,100,114,111,112,115,32,105,102,32,97,114,116,119,111,114,107,32,105,115,32,101,110,97,98,108,101,100,32,97,110,100,32,97,118,97,105,108,97,98,108,101,0] /* enable backdrops if  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1224470=allocate([117,115,101,95,111,118,101,114,108,97,121,115,59,111,118,101,114,108,97,121,0] /* use_overlays;overlay */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1234471=allocate([101,110,97,98,108,101,32,111,118,101,114,108,97,121,115,32,105,102,32,97,114,116,119,111,114,107,32,105,115,32,101,110,97,98,108,101,100,32,97,110,100,32,97,118,97,105,108,97,98,108,101,0] /* enable overlays if a */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1244472=allocate([117,115,101,95,98,101,122,101,108,115,59,98,101,122,101,108,0] /* use_bezels;bezel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1254473=allocate([101,110,97,98,108,101,32,98,101,122,101,108,115,32,105,102,32,97,114,116,119,111,114,107,32,105,115,32,101,110,97,98,108,101,100,32,97,110,100,32,97,118,97,105,108,97,98,108,101,0] /* enable bezels if art */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1264474=allocate([117,115,101,95,99,112,97,110,101,108,115,59,99,112,97,110,101,108,0] /* use_cpanels;cpanel\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1274475=allocate([101,110,97,98,108,101,32,99,112,97,110,101,108,115,32,105,102,32,97,114,116,119,111,114,107,32,105,115,32,101,110,97,98,108,101,100,32,97,110,100,32,97,118,97,105,108,97,98,108,101,0] /* enable cpanels if ar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1284476=allocate([117,115,101,95,109,97,114,113,117,101,101,115,59,109,97,114,113,117,101,101,0] /* use_marquees;marquee */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1294477=allocate([101,110,97,98,108,101,32,109,97,114,113,117,101,101,115,32,105,102,32,97,114,116,119,111,114,107,32,105,115,32,101,110,97,98,108,101,100,32,97,110,100,32,97,118,97,105,108,97,98,108,101,0] /* enable marquees if a */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1304478=allocate([67,79,82,69,32,83,67,82,69,69,78,32,79,80,84,73,79,78,83,0] /* CORE SCREEN OPTIONS\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1314479=allocate([98,114,105,103,104,116,110,101,115,115,40,48,46,49,45,50,46,48,41,0] /* brightness(0.1-2.0)\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1324480=allocate([100,101,102,97,117,108,116,32,103,97,109,101,32,115,99,114,101,101,110,32,98,114,105,103,104,116,110,101,115,115,32,99,111,114,114,101,99,116,105,111,110,0] /* default game screen  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1334481=allocate([99,111,110,116,114,97,115,116,40,48,46,49,45,50,46,48,41,0] /* contrast(0.1-2.0)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1344482=allocate([100,101,102,97,117,108,116,32,103,97,109,101,32,115,99,114,101,101,110,32,99,111,110,116,114,97,115,116,32,99,111,114,114,101,99,116,105,111,110,0] /* default game screen  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1354483=allocate([103,97,109,109,97,40,48,46,49,45,51,46,48,41,0] /* gamma(0.1-3.0)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1364484=allocate([100,101,102,97,117,108,116,32,103,97,109,101,32,115,99,114,101,101,110,32,103,97,109,109,97,32,99,111,114,114,101,99,116,105,111,110,0] /* default game screen  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1374485=allocate([112,97,117,115,101,95,98,114,105,103,104,116,110,101,115,115,40,48,46,48,45,49,46,48,41,0] /* pause_brightness(0.0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1384486=allocate([48,46,54,53,0] /* 0.65\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1394487=allocate([97,109,111,117,110,116,32,116,111,32,115,99,97,108,101,32,116,104,101,32,115,99,114,101,101,110,32,98,114,105,103,104,116,110,101,115,115,32,119,104,101,110,32,112,97,117,115,101,100,0] /* amount to scale the  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1404488=allocate([101,102,102,101,99,116,0] /* effect\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1414489=allocate([110,111,110,101,0] /* none\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1424490=allocate([110,97,109,101,32,111,102,32,97,32,80,78,71,32,102,105,108,101,32,116,111,32,117,115,101,32,102,111,114,32,118,105,115,117,97,108,32,101,102,102,101,99,116,115,44,32,111,114,32,39,110,111,110,101,39,0] /* name of a PNG file t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1434491=allocate([67,79,82,69,32,86,69,67,84,79,82,32,79,80,84,73,79,78,83,0] /* CORE VECTOR OPTIONS\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1444492=allocate([97,110,116,105,97,108,105,97,115,59,97,97,0] /* antialias;aa\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1454493=allocate([117,115,101,32,97,110,116,105,97,108,105,97,115,105,110,103,32,119,104,101,110,32,100,114,97,119,105,110,103,32,118,101,99,116,111,114,115,0] /* use antialiasing whe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1464494=allocate([98,101,97,109,0] /* beam\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1474495=allocate([115,101,116,32,118,101,99,116,111,114,32,98,101,97,109,32,119,105,100,116,104,0] /* set vector beam widt */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1484496=allocate([102,108,105,99,107,101,114,0] /* flicker\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1494497=allocate([115,101,116,32,118,101,99,116,111,114,32,102,108,105,99,107,101,114,32,101,102,102,101,99,116,0] /* set vector flicker e */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1504498=allocate([67,79,82,69,32,83,79,85,78,68,32,79,80,84,73,79,78,83,0] /* CORE SOUND OPTIONS\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1514499=allocate([115,111,117,110,100,0] /* sound\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1524500=allocate([101,110,97,98,108,101,32,115,111,117,110,100,32,111,117,116,112,117,116,0] /* enable sound output\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1534501=allocate([115,97,109,112,108,101,114,97,116,101,59,115,114,40,49,48,48,48,45,49,48,48,48,48,48,48,41,0] /* samplerate;sr(1000-1 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1544502=allocate([52,56,48,48,48,0] /* 48000\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1554503=allocate([115,101,116,32,115,111,117,110,100,32,111,117,116,112,117,116,32,115,97,109,112,108,101,32,114,97,116,101,0] /* set sound output sam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1564504=allocate([101,110,97,98,108,101,32,116,104,101,32,117,115,101,32,111,102,32,101,120,116,101,114,110,97,108,32,115,97,109,112,108,101,115,32,105,102,32,97,118,97,105,108,97,98,108,101,0] /* enable the use of ex */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1574505=allocate([118,111,108,117,109,101,59,118,111,108,0] /* volume;vol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1584506=allocate([115,111,117,110,100,32,118,111,108,117,109,101,32,105,110,32,100,101,99,105,98,101,108,115,32,40,45,51,50,32,109,105,110,44,32,48,32,109,97,120,41,0] /* sound volume in deci */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1594507=allocate([67,79,82,69,32,73,78,80,85,84,32,79,80,84,73,79,78,83,0] /* CORE INPUT OPTIONS\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1604508=allocate([99,111,105,110,95,108,111,99,107,111,117,116,59,99,111,105,110,108,111,99,107,0] /* coin_lockout;coinloc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1614509=allocate([101,110,97,98,108,101,32,99,111,105,110,32,108,111,99,107,111,117,116,115,32,116,111,32,97,99,116,117,97,108,108,121,32,108,111,99,107,32,111,117,116,32,99,111,105,110,115,0] /* enable coin lockouts */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1624510=allocate([112,114,101,99,111,110,102,105,103,117,114,101,32,102,111,114,32,115,112,101,99,105,102,105,101,100,32,99,111,110,116,114,111,108,108,101,114,0] /* preconfigure for spe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1634511=allocate([109,111,117,115,101,0] /* mouse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1644512=allocate([101,110,97,98,108,101,32,109,111,117,115,101,32,105,110,112,117,116,0] /* enable mouse input\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1654513=allocate([106,111,121,115,116,105,99,107,59,106,111,121,0] /* joystick;joy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1664514=allocate([101,110,97,98,108,101,32,106,111,121,115,116,105,99,107,32,105,110,112,117,116,0] /* enable joystick inpu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1674515=allocate([108,105,103,104,116,103,117,110,59,103,117,110,0] /* lightgun;gun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1684516=allocate([101,110,97,98,108,101,32,108,105,103,104,116,103,117,110,32,105,110,112,117,116,0] /* enable lightgun inpu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1694517=allocate([109,117,108,116,105,107,101,121,98,111,97,114,100,59,109,117,108,116,105,107,101,121,0] /* multikeyboard;multik */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1704518=allocate([101,110,97,98,108,101,32,115,101,112,97,114,97,116,101,32,105,110,112,117,116,32,102,114,111,109,32,101,97,99,104,32,107,101,121,98,111,97,114,100,32,100,101,118,105,99,101,32,40,105,102,32,112,114,101,115,101,110,116,41,0] /* enable separate inpu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1714519=allocate([109,117,108,116,105,109,111,117,115,101,0] /* multimouse\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1724520=allocate([101,110,97,98,108,101,32,115,101,112,97,114,97,116,101,32,105,110,112,117,116,32,102,114,111,109,32,101,97,99,104,32,109,111,117,115,101,32,100,101,118,105,99,101,32,40,105,102,32,112,114,101,115,101,110,116,41,0] /* enable separate inpu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1734521=allocate([115,116,101,97,100,121,107,101,121,59,115,116,101,97,100,121,0] /* steadykey;steady\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1744522=allocate([101,110,97,98,108,101,32,115,116,101,97,100,121,107,101,121,32,115,117,112,112,111,114,116,0] /* enable steadykey sup */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1754523=allocate([111,102,102,115,99,114,101,101,110,95,114,101,108,111,97,100,59,114,101,108,111,97,100,0] /* offscreen_reload;rel */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1764524=allocate([99,111,110,118,101,114,116,32,108,105,103,104,116,103,117,110,32,98,117,116,116,111,110,32,50,32,105,110,116,111,32,111,102,102,115,99,114,101,101,110,32,114,101,108,111,97,100,0] /* convert lightgun but */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1774525=allocate([106,111,121,115,116,105,99,107,95,109,97,112,59,106,111,121,109,97,112,0] /* joystick_map;joymap\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1784526=allocate([101,120,112,108,105,99,105,116,32,106,111,121,115,116,105,99,107,32,109,97,112,44,32,111,114,32,97,117,116,111,32,116,111,32,97,117,116,111,45,115,101,108,101,99,116,0] /* explicit joystick ma */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1794527=allocate([106,111,121,115,116,105,99,107,95,100,101,97,100,122,111,110,101,59,106,111,121,95,100,101,97,100,122,111,110,101,59,106,100,122,0] /* joystick_deadzone;jo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1804528=allocate([48,46,51,0] /* 0.3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1814529=allocate([99,101,110,116,101,114,32,100,101,97,100,122,111,110,101,32,114,97,110,103,101,32,102,111,114,32,106,111,121,115,116,105,99,107,32,119,104,101,114,101,32,99,104,97,110,103,101,32,105,115,32,105,103,110,111,114,101,100,32,40,48,46,48,32,99,101,110,116,101,114,44,32,49,46,48,32,101,110,100,41,0] /* center deadzone rang */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1824530=allocate([106,111,121,115,116,105,99,107,95,115,97,116,117,114,97,116,105,111,110,59,106,111,121,95,115,97,116,117,114,97,116,105,111,110,59,106,115,97,116,0] /* joystick_saturation; */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1834531=allocate([48,46,56,53,0] /* 0.85\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1844532=allocate([101,110,100,32,111,102,32,97,120,105,115,32,115,97,116,117,114,97,116,105,111,110,32,114,97,110,103,101,32,102,111,114,32,106,111,121,115,116,105,99,107,32,119,104,101,114,101,32,99,104,97,110,103,101,32,105,115,32,105,103,110,111,114,101,100,32,40,48,46,48,32,99,101,110,116,101,114,44,32,49,46,48,32,101,110,100,41,0] /* end of axis saturati */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1854533=allocate([110,97,116,117,114,97,108,59,110,97,116,0] /* natural;nat\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1864534=allocate([115,112,101,99,105,102,105,101,115,32,119,104,101,116,104,101,114,32,116,111,32,117,115,101,32,97,32,110,97,116,117,114,97,108,32,107,101,121,98,111,97,114,100,32,111,114,32,110,111,116,0] /* specifies whether to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1874535=allocate([67,79,82,69,32,73,78,80,85,84,32,65,85,84,79,77,65,84,73,67,32,69,78,65,66,76,69,32,79,80,84,73,79,78,83,0] /* CORE INPUT AUTOMATIC */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1884536=allocate([112,97,100,100,108,101,95,100,101,118,105,99,101,59,112,97,100,100,108,101,0] /* paddle_device;paddle */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1894537=allocate([107,101,121,98,111,97,114,100,0] /* keyboard\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1904538=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,112,97,100,100,108,101,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1914539=allocate([97,100,115,116,105,99,107,95,100,101,118,105,99,101,59,97,100,115,116,105,99,107,0] /* adstick_device;adsti */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1924540=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,110,32,97,110,97,108,111,103,32,106,111,121,115,116,105,99,107,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1934541=allocate([112,101,100,97,108,95,100,101,118,105,99,101,59,112,101,100,97,108,0] /* pedal_device;pedal\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1944542=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,112,101,100,97,108,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1954543=allocate([100,105,97,108,95,100,101,118,105,99,101,59,100,105,97,108,0] /* dial_device;dial\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1964544=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,100,105,97,108,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1974545=allocate([116,114,97,99,107,98,97,108,108,95,100,101,118,105,99,101,59,116,114,97,99,107,98,97,108,108,0] /* trackball_device;tra */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1984546=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,116,114,97,99,107,98,97,108,108,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1994547=allocate([108,105,103,104,116,103,117,110,95,100,101,118,105,99,101,0] /* lightgun_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2004548=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,108,105,103,104,116,103,117,110,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2014549=allocate([112,111,115,105,116,105,111,110,97,108,95,100,101,118,105,99,101,0] /* positional_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2024550=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,112,111,115,105,116,105,111,110,97,108,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2034551=allocate([109,111,117,115,101,95,100,101,118,105,99,101,0] /* mouse_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2044552=allocate([101,110,97,98,108,101,32,40,110,111,110,101,124,107,101,121,98,111,97,114,100,124,109,111,117,115,101,124,108,105,103,104,116,103,117,110,124,106,111,121,115,116,105,99,107,41,32,105,102,32,97,32,109,111,117,115,101,32,99,111,110,116,114,111,108,32,105,115,32,112,114,101,115,101,110,116,0] /* enable (none|keyboar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2054553=allocate([67,79,82,69,32,68,69,66,85,71,71,73,78,71,32,79,80,84,73,79,78,83,0] /* CORE DEBUGGING OPTIO */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2064554=allocate([108,111,103,0] /* log\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2074555=allocate([103,101,110,101,114,97,116,101,32,97,110,32,101,114,114,111,114,46,108,111,103,32,102,105,108,101,0] /* generate an error.lo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2084556=allocate([118,101,114,98,111,115,101,59,118,0] /* verbose;v\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2094557=allocate([100,105,115,112,108,97,121,32,97,100,100,105,116,105,111,110,97,108,32,100,105,97,103,110,111,115,116,105,99,32,105,110,102,111,114,109,97,116,105,111,110,0] /* display additional d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2104558=allocate([117,112,100,97,116,101,95,105,110,95,112,97,117,115,101,0] /* update_in_pause\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2114559=allocate([107,101,101,112,32,99,97,108,108,105,110,103,32,118,105,100,101,111,32,117,112,100,97,116,101,115,32,119,104,105,108,101,32,105,110,32,112,97,117,115,101,0] /* keep calling video u */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2124560=allocate([100,101,98,117,103,59,100,0] /* debug;d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2134561=allocate([101,110,97,98,108,101,47,100,105,115,97,98,108,101,32,100,101,98,117,103,103,101,114,0] /* enable/disable debug */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2144562=allocate([100,101,98,117,103,115,99,114,105,112,116,0] /* debugscript\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2154563=allocate([115,99,114,105,112,116,32,102,111,114,32,100,101,98,117,103,103,101,114,0] /* script for debugger\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2164564=allocate([100,101,98,117,103,95,105,110,116,101,114,110,97,108,59,100,105,0] /* debug_internal;di\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2174565=allocate([117,115,101,32,116,104,101,32,105,110,116,101,114,110,97,108,32,100,101,98,117,103,103,101,114,32,102,111,114,32,100,101,98,117,103,103,105,110,103,0] /* use the internal deb */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2184566=allocate([67,79,82,69,32,77,73,83,67,32,79,80,84,73,79,78,83,0] /* CORE MISC OPTIONS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2194567=allocate([98,105,111,115,0] /* bios\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2204568=allocate([115,101,108,101,99,116,32,116,104,101,32,115,121,115,116,101,109,32,66,73,79,83,32,116,111,32,117,115,101,0] /* select the system BI */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2214569=allocate([99,104,101,97,116,59,99,0] /* cheat;c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2224570=allocate([101,110,97,98,108,101,32,99,104,101,97,116,32,115,117,98,115,121,115,116,101,109,0] /* enable cheat subsyst */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2234571=allocate([115,107,105,112,95,103,97,109,101,105,110,102,111,0] /* skip_gameinfo\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2244572=allocate([115,107,105,112,32,100,105,115,112,108,97,121,105,110,103,32,116,104,101,32,105,110,102,111,114,109,97,116,105,111,110,32,115,99,114,101,101,110,32,97,116,32,115,116,97,114,116,117,112,0] /* skip displaying the  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2254573=allocate([117,105,102,111,110,116,0] /* uifont\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2264574=allocate([100,101,102,97,117,108,116,0] /* default\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2274575=allocate([115,112,101,99,105,102,121,32,97,32,102,111,110,116,32,116,111,32,117,115,101,0] /* specify a font to us */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2284576=allocate([114,97,109,115,105,122,101,59,114,97,109,0] /* ramsize;ram\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2294577=allocate([115,105,122,101,32,111,102,32,82,65,77,32,40,105,102,32,115,117,112,112,111,114,116,101,100,32,98,121,32,100,114,105,118,101,114,41,0] /* size of RAM (if supp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2304578=allocate([99,111,110,102,105,114,109,95,113,117,105,116,0] /* confirm_quit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2314579=allocate([100,105,115,112,108,97,121,32,99,111,110,102,105,114,109,32,113,117,105,116,32,115,99,114,101,101,110,32,111,110,32,101,120,105,116,0] /* display confirm quit */, "i8", ALLOC_STATIC);
__ZTV11emu_options=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7270, 0, 0, 0, 7272, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str2324580=allocate([83,76,79,84,32,68,69,86,73,67,69,83,0] /* SLOT DEVICES\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2334581=allocate([37,115,59,37,115,0] /* %s;%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2344582=allocate([73,77,65,71,69,32,68,69,86,73,67,69,83,0] /* IMAGE DEVICES\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2354583=allocate([109,101,115,115,0] /* mess\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2364584=allocate([100,101,98,117,103,0] /* debug\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2374585=allocate([118,101,114,116,105,99,97,108,0] /* vertical\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2384586=allocate([104,111,114,105,122,111,110,116,0] /* horizont\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2394587=allocate([118,101,99,116,111,114,0] /* vector\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2404588=allocate([115,111,117,114,99,101,47,0] /* source/\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2414589=allocate([46,105,110,105,0] /* .ini\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2424590=allocate([80,97,114,115,105,110,103,32,37,115,46,105,110,105,10,0] /* Parsing %s.ini\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2434591=allocate([87,104,105,108,101,32,112,97,114,115,105,110,103,32,37,115,58,10,37,115,10,0] /* While parsing %s:\0A */, "i8", ALLOC_STATIC);
STRING_TABLE._layout_horizont=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,60,109,97,109,101,108,97,121,111,117,116,32,118,101,114,115,105,111,110,61,34,50,34,62,10,9,60,118,105,101,119,32,110,97,109,101,61,34,83,116,97,110,100,97,114,100,32,40,52,58,51,41,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,52,34,32,98,111,116,116,111,109,61,34,51,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,80,105,120,101,108,32,65,115,112,101,99,116,32,40,126,115,99,114,48,110,97,116,105,118,101,120,97,115,112,101,99,116,126,58,126,115,99,114,48,110,97,116,105,118,101,121,97,115,112,101,99,116,126,41,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,126,115,99,114,48,119,105,100,116,104,126,34,32,98,111,116,116,111,109,61,34,126,115,99,114,48,104,101,105,103,104,116,126,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,67,111,99,107,116,97,105,108,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,120,61,34,48,34,32,121,61,34,45,51,46,48,51,34,32,119,105,100,116,104,61,34,52,34,32,104,101,105,103,104,116,61,34,51,34,32,47,62,10,9,9,9,60,111,114,105,101,110,116,97,116,105,111,110,32,114,111,116,97,116,101,61,34,49,56,48,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,120,61,34,48,34,32,121,61,34,48,34,32,119,105,100,116,104,61,34,52,34,32,104,101,105,103,104,116,61,34,51,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,60,47,109,97,109,101,108,97,121,111,117,116,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
STRING_TABLE._layout_vertical=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,60,109,97,109,101,108,97,121,111,117,116,32,118,101,114,115,105,111,110,61,34,50,34,62,10,9,60,118,105,101,119,32,110,97,109,101,61,34,83,116,97,110,100,97,114,100,32,40,51,58,52,41,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,51,34,32,98,111,116,116,111,109,61,34,52,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,80,105,120,101,108,32,65,115,112,101,99,116,32,40,126,115,99,114,48,110,97,116,105,118,101,121,97,115,112,101,99,116,126,58,126,115,99,114,48,110,97,116,105,118,101,120,97,115,112,101,99,116,126,41,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,126,115,99,114,48,104,101,105,103,104,116,126,34,32,98,111,116,116,111,109,61,34,126,115,99,114,48,119,105,100,116,104,126,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,67,111,99,107,116,97,105,108,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,120,61,34,45,51,46,48,51,34,32,121,61,34,48,34,32,119,105,100,116,104,61,34,51,34,32,104,101,105,103,104,116,61,34,52,34,32,47,62,10,9,9,9,60,111,114,105,101,110,116,97,116,105,111,110,32,114,111,116,97,116,101,61,34,49,56,48,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,120,61,34,48,34,32,121,61,34,48,34,32,119,105,100,116,104,61,34,51,34,32,104,101,105,103,104,116,61,34,52,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,101,108,101,109,101,110,116,32,110,97,109,101,61,34,100,98,103,100,105,115,34,62,10,9,60,47,101,108,101,109,101,110,116,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,68,101,98,117,103,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,51,34,32,98,111,116,116,111,109,61,34,52,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,9,60,98,101,122,101,108,32,101,108,101,109,101,110,116,61,34,100,98,103,100,105,115,34,62,10,9,9,9,60,98,111,117,110,100,115,32,120,61,34,45,50,46,53,34,32,121,61,34,48,34,32,119,105,100,116,104,61,34,56,34,32,104,101,105,103,104,116,61,34,54,34,32,47,62,10,9,9,60,47,98,101,122,101,108,62,10,9,60,47,118,105,101,119,62,10,10,60,47,109,97,109,101,108,97,121,111,117,116,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
__ZN13render_target19s_empty_screen_listE=allocate(20, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str4615=allocate([108,101,102,116,0] /* left\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14616=allocate([114,105,103,104,116,0] /* right\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24617=allocate([116,111,112,0] /* top\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34618=allocate([98,111,116,116,111,109,0] /* bottom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44619=allocate([120,0] /* x\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54620=allocate([119,105,100,116,104,0] /* width\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64621=allocate([121,0] /* y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74622=allocate([104,101,105,103,104,116,0] /* height\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84623=allocate([73,108,108,101,103,97,108,32,98,111,117,110,100,115,32,118,97,108,117,101,32,105,110,32,88,77,76,0] /* Illegal bounds value */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94624=allocate([73,108,108,101,103,97,108,32,98,111,117,110,100,115,32,118,97,108,117,101,32,105,110,32,88,77,76,58,32,40,37,102,45,37,102,41,45,40,37,102,45,37,102,41,0] /* Illegal bounds value */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104625=allocate([114,101,100,0] /* red\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114626=allocate([103,114,101,101,110,0] /* green\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124627=allocate([98,108,117,101,0] /* blue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134628=allocate([97,108,112,104,97,0] /* alpha\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144629=allocate([73,108,108,101,103,97,108,32,65,82,71,66,32,99,111,108,111,114,32,118,97,108,117,101,32,105,110,32,88,77,76,58,32,37,102,44,37,102,44,37,102,44,37,102,0] /* Illegal ARGB color v */, "i8", ALLOC_STATIC);
__ZTV14layout_element=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7274, 0, 0, 0, 7276, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str154630=allocate([110,97,109,101,0] /* name\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164631=allocate([65,108,108,32,108,97,121,111,117,116,32,101,108,101,109,101,110,116,115,32,109,117,115,116,32,104,97,118,101,32,97,32,110,97,109,101,33,10,0] /* All layout elements  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174632=allocate([100,101,102,115,116,97,116,101,0] /* defstate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184633=allocate([115,114,99,47,101,109,117,47,114,101,110,100,108,97,121,46,99,0] /* src/emu/rendlay.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194634=allocate([115,116,97,116,101,0] /* state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204635=allocate([98,111,117,110,100,115,0] /* bounds\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214636=allocate([99,111,108,111,114,0] /* color\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224637=allocate([105,109,97,103,101,0] /* image\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234638=allocate([102,105,108,101,0] /* file\00 */, "i8", ALLOC_STATIC);
__str244639=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str254640=allocate([97,108,112,104,97,102,105,108,101,0] /* alphafile\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264641=allocate([116,101,120,116,0] /* text\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274642=allocate([115,116,114,105,110,103,0] /* string\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284643=allocate([100,111,116,109,97,116,114,105,120,0] /* dotmatrix\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294644=allocate([108,101,100,55,115,101,103,0] /* led7seg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304645=allocate([108,101,100,49,52,115,101,103,0] /* led14seg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314646=allocate([108,101,100,49,52,115,101,103,115,99,0] /* led14segsc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324647=allocate([108,101,100,49,54,115,101,103,0] /* led16seg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334648=allocate([108,101,100,49,54,115,101,103,115,99,0] /* led16segsc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344649=allocate([114,101,99,116,0] /* rect\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354650=allocate([100,105,115,107,0] /* disk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str364651=allocate([85,110,107,110,111,119,110,32,101,108,101,109,101,110,116,32,99,111,109,112,111,110,101,110,116,58,32,37,115,0] /* Unknown element comp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374652=allocate([85,110,107,110,111,119,110,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,32,114,101,113,117,101,115,116,101,100,32,100,114,97,119,40,41,0] /* Unknown component ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384653=allocate([100,101,102,97,117,108,116,0] /* default\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394654=allocate([85,110,97,98,108,101,32,116,111,32,108,111,97,100,32,99,111,109,112,111,110,101,110,116,32,98,105,116,109,97,112,32,39,37,115,39,0] /* Unable to load compo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str404655=allocate([85,110,97,98,108,101,32,116,111,32,108,111,97,100,32,99,111,109,112,111,110,101,110,116,32,98,105,116,109,97,112,32,39,37,115,39,47,39,37,115,39,0] /* Unable to load compo */, "i8", ALLOC_STATIC);
__ZTV11layout_view=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7278, 0, 0, 0, 7280, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str414656=allocate([98,97,99,107,100,114,111,112,0] /* backdrop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424657=allocate([115,99,114,101,101,110,0] /* screen\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str434658=allocate([111,118,101,114,108,97,121,0] /* overlay\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444659=allocate([98,101,122,101,108,0] /* bezel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str454660=allocate([99,112,97,110,101,108,0] /* cpanel\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str464661=allocate([109,97,114,113,117,101,101,0] /* marquee\00 */, "i8", ALLOC_STATIC);
__ZTVN11layout_view4itemE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7282, 0, 0, 0, 7284, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str474662=allocate([105,110,112,117,116,116,97,103,0] /* inputtag\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str484663=allocate([101,108,101,109,101,110,116,0] /* element\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str494664=allocate([85,110,97,98,108,101,32,116,111,32,102,105,110,100,32,108,97,121,111,117,116,32,101,108,101,109,101,110,116,32,37,115,0] /* Unable to find layou */, "i8", ALLOC_STATIC);
STRING_TABLE.__str504665=allocate([105,110,100,101,120,0] /* index\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str514666=allocate([105,110,112,117,116,109,97,115,107,0] /* inputmask\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str524667=allocate([111,114,105,101,110,116,97,116,105,111,110,0] /* orientation\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str534668=allocate([76,97,121,111,117,116,32,114,101,102,101,114,101,110,99,101,115,32,105,110,118,97,108,105,100,32,115,99,114,101,101,110,32,105,110,100,101,120,32,37,100,0] /* Layout references in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str544669=allocate([76,97,121,111,117,116,32,105,116,101,109,32,111,102,32,116,121,112,101,32,37,115,32,114,101,113,117,105,114,101,32,97,110,32,101,108,101,109,101,110,116,32,116,97,103,0] /* Layout item of type  */, "i8", ALLOC_STATIC);
__ZTV11layout_file=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7286, 0, 0, 0, 7288, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str554670=allocate([109,97,109,101,108,97,121,111,117,116,0] /* mamelayout\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str564671=allocate([73,110,118,97,108,105,100,32,88,77,76,32,102,105,108,101,58,32,109,105,115,115,105,110,103,32,109,97,109,101,108,97,121,111,117,116,32,110,111,100,101,0] /* Invalid XML file: mi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str574672=allocate([118,101,114,115,105,111,110,0] /* version\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str584673=allocate([73,110,118,97,108,105,100,32,88,77,76,32,102,105,108,101,58,32,117,110,115,117,112,112,111,114,116,101,100,32,118,101,114,115,105,111,110,0] /* Invalid XML file: un */, "i8", ALLOC_STATIC);
STRING_TABLE.__str594674=allocate([118,105,101,119,0] /* view\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS14layout_element=allocate([49,52,108,97,121,111,117,116,95,101,108,101,109,101,110,116,0] /* 14layout_element\00 */, "i8", ALLOC_STATIC);
__ZTI14layout_element=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSN11layout_view4itemE=allocate([78,49,49,108,97,121,111,117,116,95,118,105,101,119,52,105,116,101,109,69,0] /* N11layout_view4itemE */, "i8", ALLOC_STATIC);
__ZTIN11layout_view4itemE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS11layout_view=allocate([49,49,108,97,121,111,117,116,95,118,105,101,119,0] /* 11layout_view\00 */, "i8", ALLOC_STATIC);
__ZTI11layout_view=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS11layout_file=allocate([49,49,108,97,121,111,117,116,95,102,105,108,101,0] /* 11layout_file\00 */, "i8", ALLOC_STATIC);
__ZTI11layout_file=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI11layout_viewE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7290, 0, 0, 0, 7292, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI11layout_viewE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,49,108,97,121,111,117,116,95,118,105,101,119,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI11layout_viewE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI14layout_elementE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7294, 0, 0, 0, 7296, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14layout_elementE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,108,97,121,111,117,116,95,101,108,101,109,101,110,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14layout_elementE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI11layout_viewE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7298, 0, 0, 0, 7300, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI11layout_viewE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,49,108,97,121,111,117,116,95,118,105,101,119,69,0] /* 11simple_listI11layo */, "i8", ALLOC_STATIC);
__ZTI11simple_listI11layout_viewE=allocate(8, "*", ALLOC_STATIC);
__ZTV11simple_listI14layout_elementE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7302, 0, 0, 0, 7304, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI14layout_elementE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,49,52,108,97,121,111,117,116,95,101,108,101,109,101,110,116,69,0] /* 11simple_listI14layo */, "i8", ALLOC_STATIC);
__ZTI11simple_listI14layout_elementE=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN11layout_view4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7306, 0, 0, 0, 7308, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN11layout_view4itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,49,108,97,121,111,117,116,95,118,105,101,119,52,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN11layout_view4itemEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN11layout_view4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7310, 0, 0, 0, 7312, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN11layout_view4itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,49,108,97,121,111,117,116,95,118,105,101,119,52,105,116,101,109,69,69,0] /* 11simple_listIN11lay */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN11layout_view4itemEE=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIN14layout_element7textureEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7314, 0, 0, 0, 7316, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIN14layout_element7textureEE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,78,49,52,108,97,121,111,117,116,95,101,108,101,109,101,110,116,55,116,101,120,116,117,114,101,69,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIN14layout_element7textureEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN14layout_element9componentEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7318, 0, 0, 0, 7320, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN14layout_element9componentEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,52,108,97,121,111,117,116,95,101,108,101,109,101,110,116,57,99,111,109,112,111,110,101,110,116,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN14layout_element9componentEE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN14layout_element9componentEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7322, 0, 0, 0, 7324, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN14layout_element9componentEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,52,108,97,121,111,117,116,95,101,108,101,109,101,110,116,57,99,111,109,112,111,110,101,110,116,69,69,0] /* 11simple_listIN14lay */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN14layout_element9componentEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str604675=allocate([114,111,116,97,116,101,0] /* rotate\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str614676=allocate([73,110,118,97,108,105,100,32,114,111,116,97,116,105,111,110,32,105,110,32,88,77,76,32,111,114,105,101,110,116,97,116,105,111,110,32,110,111,100,101,58,32,37,100,0] /* Invalid rotation in  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str624677=allocate([121,101,115,0] /* yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str634678=allocate([115,119,97,112,120,121,0] /* swapxy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str644679=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str654680=allocate([102,108,105,112,120,0] /* flipx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str664681=allocate([102,108,105,112,121,0] /* flipy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str674682=allocate([115,114,99,47,101,109,117,47,114,101,110,100,101,114,46,104,0] /* src/emu/render.h\00 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectIN18render_screen_list4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7326, 0, 0, 0, 7328, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN18render_screen_list4itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,56,114,101,110,100,101,114,95,115,99,114,101,101,110,95,108,105,115,116,52,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN18render_screen_list4itemEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str694684=allocate([37,88,0] /* %X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str704685=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
__ZZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_E6buffer=allocate(1000, "i8", ALLOC_STATIC);
STRING_TABLE.__str714686=allocate([126,115,99,114,37,100,110,97,116,105,118,101,120,97,115,112,101,99,116,126,0] /* ~scr%dnativexaspect~ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str724687=allocate([126,115,99,114,37,100,110,97,116,105,118,101,121,97,115,112,101,99,116,126,0] /* ~scr%dnativeyaspect~ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str734688=allocate([126,115,99,114,37,100,119,105,100,116,104,126,0] /* ~scr%dwidth~\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str744689=allocate([126,115,99,114,37,100,104,101,105,103,104,116,126,0] /* ~scr%dheight~\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str754690=allocate([37,102,0] /* %f\00 */, "i8", ALLOC_STATIC);
__ZTV11simple_listIN18render_screen_list4itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7330, 0, 0, 0, 7332, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN18render_screen_list4itemEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,49,56,114,101,110,100,101,114,95,115,99,114,101,101,110,95,108,105,115,116,52,105,116,101,109,69,69,0] /* 11simple_listIN18ren */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN18render_screen_list4itemEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE._font_uismall=allocate([102,111,110,116,0,0,0,0,0,11,255,254,0,0,0,191,0,32,0,4,0,0,255,254,0,4,0,11,0,33,0,2,0,0,255,254,0,2,0,11,0,34,0,4,0,0,255,254,0,4,0,11,0,35,0,6,0,0,255,254,0,6,0,11,0,36,0,6,0,0,255,254,0,6,0,11,0,37,0,6,0,0,255,254,0,6,0,11,0,38,0,6,0,0,255,254,0,6,0,11,0,39,0,2,0,0,255,254,0,2,0,11,0,40,0,4,0,0,255,254,0,4,0,11,0,41,0,4,0,0,255,254,0,4,0,11,0,42,0,6,0,0,255,254,0,6,0,11,0,43,0,6,0,0,255,254,0,6,0,11,0,44,0,3,0,0,255,254,0,3,0,11,0,45,0,5,0,0,255,254,0,5,0,11,0,46,0,2,0,0,255,254,0,2,0,11,0,47,0,4,0,0,255,254,0,4,0,11,0,48,0,6,0,0,255,254,0,6,0,11,0,49,0,6,0,0,255,254,0,6,0,11,0,50,0,6,0,0,255,254,0,6,0,11,0,51,0,6,0,0,255,254,0,6,0,11,0,52,0,6,0,0,255,254,0,6,0,11,0,53,0,6,0,0,255,254,0,6,0,11,0,54,0,6,0,0,255,254,0,6,0,11,0,55,0,6,0,0,255,254,0,6,0,11,0,56,0,6,0,0,255,254,0,6,0,11,0,57,0,6,0,0,255,254,0,6,0,11,0,58,0,2,0,0,255,254,0,2,0,11,0,59,0,3,0,0,255,254,0,3,0,11,0,60,0,5,0,0,255,254,0,5,0,11,0,61,0,6,0,0,255,254,0,6,0,11,0,62,0,5,0,0,255,254,0,5,0,11,0,63,0,5,0,0,255,254,0,5,0,11,0,64,0,6,0,0,255,254,0,6,0,11,0,65,0,6,0,0,255,254,0,6,0,11,0,66,0,6,0,0,255,254,0,6,0,11,0,67,0,6,0,0,255,254,0,6,0,11,0,68,0,6,0,0,255,254,0,6,0,11,0,69,0,6,0,0,255,254,0,6,0,11,0,70,0,6,0,0,255,254,0,6,0,11,0,71,0,6,0,0,255,254,0,6,0,11,0,72,0,6,0,0,255,254,0,6,0,11,0,73,0,4,0,0,255,254,0,4,0,11,0,74,0,6,0,0,255,254,0,6,0,11,0,75,0,6,0,0,255,254,0,6,0,11,0,76,0,5,0,0,255,254,0,5,0,11,0,77,0,6,0,0,255,254,0,6,0,11,0,78,0,6,0,0,255,254,0,6,0,11,0,79,0,6,0,0,255,254,0,6,0,11,0,80,0,6,0,0,255,254,0,6,0,11,0,81,0,6,0,0,255,254,0,6,0,11,0,82,0,6,0,0,255,254,0,6,0,11,0,83,0,6,0,0,255,254,0,6,0,11,0,84,0,6,0,0,255,254,0,6,0,11,0,85,0,6,0,0,255,254,0,6,0,11,0,86,0,6,0,0,255,254,0,6,0,11,0,87,0,6,0,0,255,254,0,6,0,11,0,88,0,6,0,0,255,254,0,6,0,11,0,89,0,6,0,0,255,254,0,6,0,11,0,90,0,6,0,0,255,254,0,6,0,11,0,91,0,4,0,0,255,254,0,4,0,11,0,92,0,4,0,0,255,254,0,4,0,11,0,93,0,4,0,0,255,254,0,4,0,11,0,94,0,6,0,0,255,254,0,6,0,11,0,95,0,6,0,0,255,254,0,6,0,11,0,96,0,3,0,0,255,254,0,3,0,11,0,97,0,5,0,0,255,254,0,5,0,11,0,98,0,5,0,0,255,254,0,5,0,11,0,99,0,5,0,0,255,254,0,5,0,11,0,100,0,5,0,0,255,254,0,5,0,11,0,101,0,5,0,0,255,254,0,5,0,11,0,102,0,4,0,0,255,254,0,4,0,11,0,103,0,5,0,0,255,254,0,5,0,11,0,104,0,5,0,0,255,254,0,5,0,11,0,105,0,3,0,0,255,254,0,3,0,11,0,106,0,4,0,0,255,254,0,4,0,11,0,107,0,5,0,0,255,254,0,5,0,11,0,108,0,3,0,0,255,254,0,3,0,11,0,109,0,6,0,0,255,254,0,6,0,11,0,110,0,5,0,0,255,254,0,5,0,11,0,111,0,5,0,0,255,254,0,5,0,11,0,112,0,5,0,0,255,254,0,5,0,11,0,113,0,5,0,0,255,254,0,5,0,11,0,114,0,5,0,0,255,254,0,5,0,11,0,115,0,5,0,0,255,254,0,5,0,11,0,116,0,4,0,0,255,254,0,4,0,11,0,117,0,5,0,0,255,254,0,5,0,11,0,118,0,6,0,0,255,254,0,6,0,11,0,119,0,6,0,0,255,254,0,6,0,11,0,120,0,6,0,0,255,254,0,6,0,11,0,121,0,5,0,0,255,254,0,5,0,11,0,122,0,5,0,0,255,254,0,5,0,11,0,123,0,4,0,0,255,254,0,4,0,11,0,124,0,2,0,0,255,254,0,2,0,11,0,125,0,4,0,0,255,254,0,4,0,11,0,126,0,6,0,0,255,254,0,6,0,11,0,160,0,4,0,0,255,254,0,4,0,11,0,161,0,2,0,0,255,254,0,2,0,11,0,162,0,5,0,0,255,254,0,5,0,11,0,163,0,6,0,0,255,254,0,6,0,11,0,164,0,5,0,0,255,254,0,5,0,11,0,165,0,6,0,0,255,254,0,6,0,11,0,166,0,2,0,0,255,254,0,2,0,11,0,167,0,5,0,0,255,254,0,5,0,11,0,168,0,4,0,0,255,254,0,4,0,11,0,169,0,9,0,0,255,254,0,9,0,11,0,170,0,5,0,0,255,254,0,5,0,11,0,171,0,6,0,0,255,254,0,6,0,11,0,172,0,7,0,0,255,254,0,7,0,11,0,173,0,5,0,0,255,254,0,5,0,11,0,174,0,9,0,0,255,254,0,9,0,11,0,175,0,5,0,0,255,254,0,5,0,11,0,176,0,4,0,0,255,254,0,4,0,11,0,177,0,6,0,0,255,254,0,6,0,11,0,178,0,4,0,0,255,254,0,4,0,11,0,179,0,4,0,0,255,254,0,4,0,11,0,180,0,4,0,0,255,254,0,4,0,11,0,181,0,5,0,0,255,254,0,5,0,11,0,182,0,6,0,0,255,254,0,6,0,11,0,183,0,3,0,0,255,254,0,3,0,11,0,184,0,3,0,0,255,254,0,3,0,11,0,185,0,4,0,0,255,254,0,4,0,11,0,186,0,5,0,0,255,254,0,5,0,11,0,187,0,6,0,0,255,254,0,6,0,11,0,188,0,8,0,0,255,254,0,8,0,11,0,189,0,8,0,0,255,254,0,8,0,11,0,190,0,8,0,0,255,254,0,8,0,11,0,191,0,5,0,0,255,254,0,5,0,11,0,192,0,6,0,0,255,254,0,6,0,11,0,193,0,6,0,0,255,254,0,6,0,11,0,194,0,6,0,0,255,254,0,6,0,11,0,195,0,6,0,0,255,254,0,6,0,11,0,196,0,6,0,0,255,254,0,6,0,11,0,197,0,6,0,0,255,254,0,6,0,11,0,198,0,8,0,0,255,254,0,8,0,11,0,199,0,6,0,0,255,254,0,6,0,11,0,200,0,6,0,0,255,254,0,6,0,11,0,201,0,6,0,0,255,254,0,6,0,11,0,202,0,6,0,0,255,254,0,6,0,11,0,203,0,6,0,0,255,254,0,6,0,11,0,204,0,4,0,0,255,254,0,4,0,11,0,205,0,4,0,0,255,254,0,4,0,11,0,206,0,4,0,0,255,254,0,4,0,11,0,207,0,4,0,0,255,254,0,4,0,11,0,208,0,7,0,0,255,254,0,7,0,11,0,209,0,6,0,0,255,254,0,6,0,11,0,210,0,6,0,0,255,254,0,6,0,11,0,211,0,6,0,0,255,254,0,6,0,11,0,212,0,6,0,0,255,254,0,6,0,11,0,213,0,6,0,0,255,254,0,6,0,11,0,214,0,6,0,0,255,254,0,6,0,11,0,215,0,6,0,0,255,254,0,6,0,11,0,216,0,6,0,0,255,254,0,6,0,11,0,217,0,6,0,0,255,254,0,6,0,11,0,218,0,6,0,0,255,254,0,6,0,11,0,219,0,6,0,0,255,254,0,6,0,11,0,220,0,6,0,0,255,254,0,6,0,11,0,221,0,6,0,0,255,254,0,6,0,11,0,222,0,6,0,0,255,254,0,6,0,11,0,223,0,6,0,0,255,254,0,6,0,11,0,224,0,5,0,0,255,254,0,5,0,11,0,225,0,5,0,0,255,254,0,5,0,11,0,226,0,5,0,0,255,254,0,5,0,11,0,227,0,5,0,0,255,254,0,5,0,11,0,228,0,5,0,0,255,254,0,5,0,11,0,229,0,5,0,0,255,254,0,5,0,11,0,230,0,8,0,0,255,254,0,8,0,11,0,231,0,5,0,0,255,254,0,5,0,11,0,232,0,5,0,0,255,254,0,5,0,11,0,233,0,5,0,0,255,254,0,5,0,11,0,234,0,5,0,0,255,254,0,5,0,11,0,235,0,5,0,0,255,254,0,5,0,11,0,236,0,3,0,0,255,254,0,3,0,11,0,237,0,3,0,0,255,254,0,3,0,11,0,238,0,3,0,0,255,254,0,3,0,11,0,239,0,3,0,0,255,254,0,3,0,11,0,240,0,5,0,0,255,254,0,5,0,11,0,241,0,5,0,0,255,254,0,5,0,11,0,242,0,5,0,0,255,254,0,5,0,11,0,243,0,5,0,0,255,254,0,5,0,11,0,244,0,5,0,0,255,254,0,5,0,11,0,245,0,5,0,0,255,254,0,5,0,11,0,246,0,5,0,0,255,254,0,5,0,11,0,247,0,6,0,0,255,254,0,6,0,11,0,248,0,5,0,0,255,254,0,5,0,11,0,249,0,5,0,0,255,254,0,5,0,11,0,250,0,5,0,0,255,254,0,5,0,11,0,251,0,5,0,0,255,254,0,5,0,11,0,252,0,5,0,0,255,254,0,5,0,11,0,253,0,5,0,0,255,254,0,5,0,11,0,254,0,5,0,0,255,254,0,5,0,11,0,255,0,5,0,0,255,254,0,5,0,11,0,0,0,0,0,0,10,168,128,0,170,160,0,0,0,0,5,62,83,229,0,0,0,0,0,2,30,161,194,188,32,0,0,0,12,178,16,132,38,152,0,0,0,2,20,81,137,164,104,0,0,10,128,0,0,36,136,136,66,0,0,132,34,34,72,0,0,0,20,35,226,20,0,0,0,0,0,8,35,226,8,0,0,0,0,0,2,80,0,0,0,0,120,0,0,0,0,0,128,0,17,34,68,136,0,0,7,34,138,40,162,112,0,0,0,2,24,32,130,8,112,0,0,0,7,34,8,196,32,248,0,0,0,7,34,8,192,162,112,0,0,0,1,12,82,79,132,16,0,0,0,15,160,131,192,162,112,0,0,0,7,34,131,200,162,112,0,0,0,15,162,8,66,8,32,0,0,0,7,34,137,200,162,112,0,0,0,7,34,137,224,162,112,0,0,0,130,0,0,4,2,80,0,0,4,68,65,4,16,0,0,0,0,248,0,62,0,0,0,0,32,130,8,136,128,0,0,25,33,17,0,64,0,0,6,36,138,234,164,129,192,0,0,2,20,82,47,162,136,0,0,0,15,34,139,200,162,240,0,0,0,7,34,130,8,34,112,0,0,0,14,36,138,40,164,224,0,0,0,15,160,131,136,32,248,0,0,0,15,160,131,136,32,128,0,0,0,7,160,130,232,162,120,0,0,0,8,162,139,232,162,136,0,0,0,228,68,68,224,0,0,1,130,8,32,162,112,0,0,0,8,164,163,10,36,136,0,0,0,33,8,66,16,240,0,0,8,182,170,168,162,136,0,0,0,8,178,170,104,162,136,0,0,0,7,34,138,40,162,112,0,0,0,15,34,139,200,32,128,0,0,0,7,34,138,42,164,104,0,0,0,15,34,139,202,36,136,0,0,0,7,34,129,192,162,112,0,0,0,15,136,32,130,8,32,0,0,0,8,162,138,40,162,112,0,0,0,8,162,137,69,8,32,0,0,0,8,162,138,170,182,136,0,0,0,8,162,80,133,34,136,0,0,0,8,162,80,130,8,32,0,0,0,15,130,16,132,32,248,0,0,14,136,136,136,142,0,0,136,68,34,17,0,14,34,34,34,46,0,0,2,20,136,0,0,0,0,0,0,0,0,0,0,0,3,240,0,2,68,0,0,0,0,0,6,9,210,112,0,0,33,14,74,82,224,0,0,0,6,74,16,112,0,0,4,39,74,82,112,0,0,0,6,75,208,112,0,0,52,228,68,64,0,0,0,7,74,82,112,152,0,33,14,74,82,144,0,1,12,146,64,0,0,32,98,34,42,64,0,33,9,83,20,144,0,3,36,146,64,0,0,0,0,242,170,170,168,0,0,0,0,14,74,82,144,0,0,0,6,74,82,96,0,0,0,14,74,82,228,32,0,0,7,74,82,112,132,0,0,14,74,16,128,0,0,0,7,65,130,224,0,0,68,228,68,32,0,0,0,9,74,82,112,0,0,0,0,138,37,20,32,0,0,0,0,0,138,170,170,80,0,0,0,0,0,137,66,20,136,0,0,0,0,9,74,82,112,184,0,0,15,9,144,240,0,2,68,72,68,66,0,42,138,160,8,68,66,68,72,0,0,4,42,16,0,0,0,0,0,0,0,0,0,0,0,2,42,160,0,0,71,66,14,32,0,0,3,144,225,4,56,216,0,0,0,1,38,74,76,144,0,0,8,148,35,226,62,32,0,0,42,138,160,3,37,14,73,194,147,0,10,0,0,0,0,0,0,30,16,147,42,85,10,149,50,66,30,0,0,3,4,233,56,30,0,0,0,0,10,82,133,10,0,0,0,0,0,0,15,192,129,2,0,0,0,0,61,41,74,82,151,128,0,30,16,151,42,85,202,165,74,66,30,0,0,7,128,0,0,0,0,0,0,74,64,0,0,0,0,2,8,248,130,0,248,0,0,12,36,142,0,0,0,12,36,44,0,0,0,0,36,128,0,0,0,0,0,9,74,82,236,32,0,7,250,235,166,138,40,162,128,0,1,176,0,0,0,0,0,11,0,4,196,78,0,0,0,3,37,41,48,30,0,0,0,0,40,80,165,40,0,0,0,0,64,66,68,72,18,38,74,142,2,0,0,64,66,68,72,20,42,68,136,14,0,0,224,34,68,40,210,38,74,142,2,0,0,0,64,17,16,147,0,32,64,8,82,47,162,136,0,0,16,128,8,82,47,162,136,0,0,33,64,8,82,47,162,136,0,0,82,128,8,82,47,162,136,0,0,80,2,20,82,47,162,136,0,0,33,66,0,114,47,162,136,0,0,0,0,62,80,80,156,240,144,158,0,0,0,7,34,130,8,34,112,132,0,32,64,62,131,136,32,248,0,0,33,0,62,131,136,32,248,0,0,33,64,62,131,136,32,248,0,0,80,15,160,131,136,32,248,0,0,132,14,68,68,224,0,36,14,68,68,224,0,74,14,68,68,224,0,160,228,68,68,224,0,0,1,194,68,94,145,36,112,0,0,82,128,34,202,169,162,136,0,0,64,128,28,138,40,162,112,0,0,16,128,28,138,40,162,112,0,0,33,64,28,138,40,162,112,0,0,82,128,28,138,40,162,112,0,0,80,7,34,138,40,162,112,0,0,0,0,34,80,133,34,0,0,0,0,6,164,170,170,146,176,0,0,64,136,162,138,40,162,112,0,0,16,136,162,138,40,162,112,0,0,33,64,34,138,40,162,112,0,0,80,8,162,138,40,162,112,0,0,16,136,162,80,130,8,32,0,0,2,8,60,138,47,32,128,0,0,0,7,34,138,200,170,176,0,0,2,8,6,9,210,112,0,1,16,6,9,210,112,0,1,20,6,9,210,112,0,2,168,6,9,210,112,0,0,20,6,9,210,112,0,34,136,6,9,210,112,0,0,0,0,0,108,18,126,144,110,0,0,0,0,6,74,16,113,16,2,8,6,75,208,112,0,1,16,6,75,208,112,0,1,20,6,75,208,112,0,0,20,6,75,208,112,0,17,12,146,64,0,10,12,146,64,0,10,140,146,64,0,2,140,146,64,0,2,136,161,58,82,96,0,2,168,14,74,82,144,0,2,8,6,74,82,96,0,1,16,6,74,82,96,0,1,20,6,74,82,96,0,2,168,6,74,82,96,0,0,20,6,74,82,96,0,0,0,8,3,224,8,0,0,0,0,0,23,91,90,224,0,2,8,9,74,82,112,0,1,16,9,74,82,112,0,1,20,9,74,82,112,0,0,20,9,74,82,112,0,1,16,9,74,82,112,184,0,0,8,114,82,151,32,0,20,9,74,82,112,184] /* font\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
__ZTV11render_font=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7334, 0, 0, 0, 7336, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str4705=allocate([100,101,102,97,117,108,116,0] /* default\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14706=allocate([117,105,46,98,100,102,0] /* ui.bdf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24707=allocate([115,114,99,47,101,109,117,47,114,101,110,100,102,111,110,116,46,99,0] /* src/emu/rendfont.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34708=allocate([98,100,99,0] /* bdc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44709=allocate([70,79,78,84,66,79,85,78,68,73,78,71,66,79,88,32,0] /* FONTBOUNDINGBOX \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54710=allocate([37,100,32,37,100,32,37,100,32,37,100,0] /* %d %d %d %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64711=allocate([69,78,68,70,79,78,84,0] /* ENDFONT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74712=allocate([83,84,65,82,84,67,72,65,82,32,0] /* STARTCHAR \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84713=allocate([69,78,67,79,68,73,78,71,32,0] /* ENCODING \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94714=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104715=allocate([68,87,73,68,84,72,32,0] /* DWIDTH \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114716=allocate([37,100,32,37,100,0] /* %d %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124717=allocate([66,66,88,32,0] /* BBX \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134718=allocate([66,73,84,77,65,80,0] /* BITMAP\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144719=allocate([69,78,68,67,72,65,82,0] /* ENDCHAR\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154720=allocate([76,111,97,100,105,110,103,32,66,68,70,32,102,111,110,116,46,46,46,32,40,37,100,32,99,104,97,114,97,99,116,101,114,115,32,108,111,97,100,101,100,41,10,0] /* Loading BDF font...  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164721=allocate([71,101,110,101,114,97,116,105,110,103,32,99,97,99,104,101,100,32,66,68,70,32,102,111,110,116,46,46,46,10,0] /* Generating cached BD */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174722=allocate([69,114,114,111,114,32,119,114,105,116,105,110,103,32,99,97,99,104,101,100,32,102,105,108,101,0] /* Error writing cached */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS11render_font=allocate([49,49,114,101,110,100,101,114,95,102,111,110,116,0] /* 11render_font\00 */, "i8", ALLOC_STATIC);
__ZTI11render_font=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayIN11render_font5glyphEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7338, 0, 0, 0, 7340, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayIN11render_font5glyphEE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,78,49,49,114,101,110,100,101,114,95,102,111,110,116,53,103,108,121,112,104,69,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayIN11render_font5glyphEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str184723=allocate([102,111,110,116,112,97,116,104,0] /* fontpath\00 */, "i8", ALLOC_STATIC);
__ZZN11render_font8get_charEjE11dummy_glyph=allocate(32, ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str4736=allocate([110,111,116,32,97,110,32,108,118,97,108,117,101,0] /* not an lvalue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14737=allocate([110,111,116,32,97,110,32,114,118,97,108,117,101,0] /* not an rvalue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24738=allocate([115,121,110,116,97,120,32,101,114,114,111,114,0] /* syntax error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34739=allocate([117,110,107,110,111,119,110,32,115,121,109,98,111,108,0] /* unknown symbol\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44740=allocate([105,110,118,97,108,105,100,32,110,117,109,98,101,114,0] /* invalid number\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54741=allocate([105,110,118,97,108,105,100,32,116,111,107,101,110,0] /* invalid token\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64742=allocate([115,116,97,99,107,32,111,118,101,114,102,108,111,119,0] /* stack overflow\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74743=allocate([115,116,97,99,107,32,117,110,100,101,114,102,108,111,119,0] /* stack underflow\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84744=allocate([117,110,98,97,108,97,110,99,101,100,32,112,97,114,101,110,116,104,101,115,101,115,0] /* unbalanced parenthes */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94745=allocate([100,105,118,105,100,101,32,98,121,32,122,101,114,111,0] /* divide by zero\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104746=allocate([111,117,116,32,111,102,32,109,101,109,111,114,121,0] /* out of memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114747=allocate([105,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,112,97,114,97,109,101,116,101,114,115,0] /* invalid number of pa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124748=allocate([117,110,98,97,108,97,110,99,101,100,32,113,117,111,116,101,115,0] /* unbalanced quotes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134749=allocate([116,111,111,32,109,97,110,121,32,115,116,114,105,110,103,115,0] /* too many strings\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144750=allocate([105,110,118,97,108,105,100,32,109,101,109,111,114,121,32,115,105,122,101,32,40,98,47,119,47,100,47,113,32,101,120,112,101,99,116,101,100,41,0] /* invalid memory size  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154751=allocate([110,111,110,45,101,120,105,115,116,101,110,116,32,109,101,109,111,114,121,32,115,112,97,99,101,0] /* non-existent memory  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164752=allocate([105,110,118,97,108,105,100,32,109,101,109,111,114,121,32,115,112,97,99,101,32,40,112,47,100,47,105,47,111,47,114,47,109,32,101,120,112,101,99,116,101,100,41,0] /* invalid memory space */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174753=allocate([105,110,118,97,108,105,100,32,109,101,109,111,114,121,32,110,97,109,101,0] /* invalid memory name\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184754=allocate([109,105,115,115,105,110,103,32,109,101,109,111,114,121,32,110,97,109,101,0] /* missing memory name\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194755=allocate([117,110,107,110,111,119,110,32,101,114,114,111,114,0] /* unknown error\00 */, "i8", ALLOC_STATIC);
__ZTV12symbol_entry=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7342, 0, 0, 0, 7344, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV20integer_symbol_entry=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7346, 0, 0, 0, 7348, 0, 0, 0, 7350, 0, 0, 0, 7352, 0, 0, 0, 7354, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str204756=allocate([83,121,109,98,111,108,32,39,37,115,39,32,105,115,32,114,101,97,100,45,111,110,108,121,0] /* Symbol '%s' is read- */, "i8", ALLOC_STATIC);
__ZTV21function_symbol_entry=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7356, 0, 0, 0, 7358, 0, 0, 0, 7360, 0, 0, 0, 7362, 0, 0, 0, 7364, 0, 0, 0, 7366, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str214757=allocate([83,121,109,98,111,108,32,39,37,115,39,32,105,115,32,97,32,102,117,110,99,116,105,111,110,32,97,110,100,32,99,97,110,110,111,116,32,98,101,32,117,115,101,100,32,105,110,32,116,104,105,115,32,99,111,110,116,101,120,116,0] /* Symbol '%s' is a fun */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224758=allocate([83,121,109,98,111,108,32,39,37,115,39,32,105,115,32,97,32,102,117,110,99,116,105,111,110,32,97,110,100,32,99,97,110,110,111,116,32,98,101,32,119,114,105,116,116,101,110,0] /* Symbol '%s' is a fun */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234759=allocate([70,117,110,99,116,105,111,110,32,39,37,115,39,32,114,101,113,117,105,114,101,115,32,97,116,32,108,101,97,115,116,32,37,100,32,112,97,114,97,109,101,116,101,114,115,0] /* Function '%s' requir */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244760=allocate([70,117,110,99,116,105,111,110,32,39,37,115,39,32,97,99,99,101,112,116,115,32,110,111,32,109,111,114,101,32,116,104,97,110,32,37,100,32,112,97,114,97,109,101,116,101,114,115,0] /* Function '%s' accept */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254761=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,101,120,112,114,101,115,115,46,99,0] /* src/emu/debug/expres */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZN17parsed_expression22parse_symbol_or_numberERNS_11parse_tokenERPKcE5valid=allocate([97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,95,36,35,46,58,0] /* abcdefghijklmnopqrst */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264762=allocate([98,110,111,116,0] /* bnot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274763=allocate([112,108,117,115,0] /* plus\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284764=allocate([109,105,110,117,115,0] /* minus\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294765=allocate([116,105,109,101,115,0] /* times\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304766=allocate([109,117,108,0] /* mul\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314767=allocate([100,105,118,0] /* div\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324768=allocate([109,111,100,0] /* mod\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334769=allocate([108,116,0] /* lt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344770=allocate([108,101,0] /* le\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354771=allocate([103,116,0] /* gt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str364772=allocate([103,101,0] /* ge\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374773=allocate([101,113,0] /* eq\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384774=allocate([110,101,0] /* ne\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394775=allocate([110,111,116,0] /* not\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str404776=allocate([97,110,100,0] /* and\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str414777=allocate([98,97,110,100,0] /* band\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424778=allocate([111,114,0] /* or\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str434779=allocate([98,111,114,0] /* bor\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444780=allocate([98,120,111,114,0] /* bxor\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str454781=allocate([108,115,104,105,102,116,0] /* lshift\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str464782=allocate([114,115,104,105,102,116,0] /* rshift\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeEE7numbers=allocate([48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0] /* 0123456789abcdef\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS12symbol_entry=allocate([49,50,115,121,109,98,111,108,95,101,110,116,114,121,0] /* 12symbol_entry\00 */, "i8", ALLOC_STATIC);
__ZTI12symbol_entry=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS20integer_symbol_entry=allocate([50,48,105,110,116,101,103,101,114,95,115,121,109,98,111,108,95,101,110,116,114,121,0] /* 20integer_symbol_ent */, "i8", ALLOC_STATIC);
__ZTI20integer_symbol_entry=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS21function_symbol_entry=allocate([50,49,102,117,110,99,116,105,111,110,95,115,121,109,98,111,108,95,101,110,116,114,121,0] /* 21function_symbol_en */, "i8", ALLOC_STATIC);
__ZTI21function_symbol_entry=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN17parsed_expression17expression_stringEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7368, 0, 0, 0, 7370, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN17parsed_expression17expression_stringEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,55,112,97,114,115,101,100,95,101,120,112,114,101,115,115,105,111,110,49,55,101,120,112,114,101,115,115,105,111,110,95,115,116,114,105,110,103,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN17parsed_expression17expression_stringEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN17parsed_expression11parse_tokenEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7372, 0, 0, 0, 7374, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN17parsed_expression11parse_tokenEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,55,112,97,114,115,101,100,95,101,120,112,114,101,115,115,105,111,110,49,49,112,97,114,115,101,95,116,111,107,101,110,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN17parsed_expression11parse_tokenEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI21function_symbol_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7376, 0, 0, 0, 7378, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI21function_symbol_entryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,49,102,117,110,99,116,105,111,110,95,115,121,109,98,111,108,95,101,110,116,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI21function_symbol_entryE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI20integer_symbol_entryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7380, 0, 0, 0, 7382, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI20integer_symbol_entryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,48,105,110,116,101,103,101,114,95,115,121,109,98,111,108,95,101,110,116,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI20integer_symbol_entryE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str474783=allocate([69,114,114,111,114,32,97,100,100,105,110,103,32,111,98,106,101,99,116,32,110,97,109,101,100,32,39,37,115,39,0] /* Error adding object  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4804=allocate([82,83,0] /* RS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14805=allocate([114,111,111,116,0] /* root\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24806=allocate([59,0] /* ;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34807=allocate([115,114,99,47,101,109,117,47,97,117,100,105,116,46,99,0] /* src/emu/audit.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44808=allocate([37,45,49,50,115,58,32,37,115,0] /* %-12s: %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54809=allocate([32,40,37,100,32,98,121,116,101,115,41,0] /*  (%d bytes)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64810=allocate([32,45,32,0] /*  - \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74811=allocate([78,69,69,68,83,32,82,69,68,85,77,80,10,0] /* NEEDS REDUMP\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84812=allocate([78,79,32,71,79,79,68,32,68,85,77,80,32,75,78,79,87,78,10,0] /* NO GOOD DUMP KNOWN\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94813=allocate([73,78,67,79,82,82,69,67,84,32,67,72,69,67,75,83,85,77,58,10,0] /* INCORRECT CHECKSUM:\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104814=allocate([69,88,80,69,67,84,69,68,58,32,37,115,10,0] /* EXPECTED: %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114815=allocate([32,32,32,70,79,85,78,68,58,32,37,115,10,0] /*    FOUND: %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124816=allocate([73,78,67,79,82,82,69,67,84,32,76,69,78,71,84,72,58,32,37,100,32,98,121,116,101,115,10,0] /* INCORRECT LENGTH: %d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134817=allocate([78,79,84,32,70,79,85,78,68,10,0] /* NOT FOUND\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144818=allocate([78,79,84,32,70,79,85,78,68,32,45,32,78,79,32,71,79,79,68,32,68,85,77,80,32,75,78,79,87,78,10,0] /* NOT FOUND - NO GOOD  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154819=allocate([78,79,84,32,70,79,85,78,68,32,66,85,84,32,79,80,84,73,79,78,65,76,10,0] /* NOT FOUND BUT OPTION */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164820=allocate([78,79,84,32,70,79,85,78,68,32,40,115,104,97,114,101,100,32,119,105,116,104,32,112,97,114,101,110,116,41,10,0] /* NOT FOUND (shared wi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174821=allocate([78,79,84,32,70,79,85,78,68,32,40,66,73,79,83,41,10,0] /* NOT FOUND (BIOS)\0A\ */, "i8", ALLOC_STATIC);
__ZZN13media_auditor14audit_one_diskEPK9rom_entryE8nullhash=allocate(20, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI12audit_recordE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7384, 0, 0, 0, 7386, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12audit_recordE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,97,117,100,105,116,95,114,101,99,111,114,100,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12audit_recordE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str194823=allocate([115,97,109,112,108,101,112,97,116,104,0] /* samplepath\00 */, "i8", ALLOC_STATIC);
STRING_TABLE._layout_snap=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,60,109,97,109,101,108,97,121,111,117,116,32,118,101,114,115,105,111,110,61,34,50,34,62,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,48,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,48,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,49,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,49,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,50,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,50,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,51,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,51,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,52,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,52,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,53,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,53,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,54,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,54,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,10,9,60,118,105,101,119,32,110,97,109,101,61,34,115,55,34,62,10,9,9,60,115,99,114,101,101,110,32,105,110,100,101,120,61,34,55,34,62,10,9,9,9,60,98,111,117,110,100,115,32,108,101,102,116,61,34,48,34,32,116,111,112,61,34,48,34,32,114,105,103,104,116,61,34,49,34,32,98,111,116,116,111,109,61,34,49,34,32,47,62,10,9,9,60,47,115,99,114,101,101,110,62,10,9,60,47,118,105,101,119,62,10,60,47,109,97,109,101,108,97,121,111,117,116,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZN13video_manager11s_skiptableE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1], "i8", ALLOC_STATIC);
STRING_TABLE.__str4834=allocate([118,105,100,101,111,95,109,97,110,97,103,101,114,58,58,101,120,105,116,0] /* video_manager::exit\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14835=allocate([118,105,100,101,111,95,109,97,110,97,103,101,114,58,58,112,111,115,116,108,111,97,100,0] /* video_manager::postl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24836=allocate([110,97,116,105,118,101,0] /* native\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34837=allocate([37,100,120,37,100,0] /* %dx%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44838=allocate([118,105,100,101,111,95,109,97,110,97,103,101,114,58,58,115,99,114,101,101,110,108,101,115,115,95,117,112,100,97,116,101,95,99,97,108,108,98,97,99,107,0] /* video_manager::scree */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54839=allocate([112,97,117,115,101,100,0] /* paused\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64840=allocate([102,97,115,116,32,0] /* fast \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74841=allocate([97,117,116,111,37,50,100,47,37,100,0] /* auto%2d/%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84842=allocate([115,107,105,112,32,37,100,47,37,100,0] /* skip %d/%d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94843=allocate([37,52,100,37,37,0] /* %4d%%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104844=allocate([10,37,100,32,112,97,114,116,105,97,108,32,117,112,100,97,116,101,115,0] /* \0A%d partial update */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114845=allocate([77,69,83,83,0] /* MESS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124846=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134847=allocate([83,111,102,116,119,97,114,101,0] /* Software\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144848=allocate([83,121,115,116,101,109,0] /* System\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154849=allocate([69,114,114,111,114,32,103,101,110,101,114,97,116,105,110,103,32,80,78,71,32,102,111,114,32,115,110,97,112,115,104,111,116,58,32,112,110,103,95,101,114,114,111,114,32,61,32,37,100,10,0] /* Error generating PNG */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164850=allocate([112,110,103,0] /* png\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174851=allocate([97,118,105,0] /* avi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184852=allocate([69,114,114,111,114,32,99,114,101,97,116,105,110,103,32,65,86,73,58,32,37,115,10,0] /* Error creating AVI:  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194853=allocate([115,114,99,47,101,109,117,47,118,105,100,101,111,46,99,0] /* src/emu/video.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204854=allocate([109,110,103,0] /* mng\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214855=allocate([69,114,114,111,114,32,99,114,101,97,116,105,110,103,32,77,78,71,10,0] /* Error creating MNG\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224856=allocate([65,118,101,114,97,103,101,32,115,112,101,101,100,58,32,37,46,50,102,37,37,32,40,37,100,32,115,101,99,111,110,100,115,41,10,0] /* Average speed: %.2f% */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZN13video_manager15update_throttleE8attotimeE8popcount=allocate([0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8] /* \00\01\01\02\01\02\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234857=allocate([65,100,106,117,115,116,105,110,103,32,116,97,114,103,101,116,32,115,112,101,101,100,32,116,111,32,37,100,37,37,32,40,104,119,61,37,46,50,102,72,122,44,32,103,97,109,101,61,37,46,50,102,72,122,44,32,97,100,106,117,115,116,101,100,61,37,46,50,102,72,122,41,10,0] /* Adjusting target spe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244858=allocate([47,102,105,110,97,108,46,112,110,103,0] /* /final.png\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254859=allocate([37,103,47,37,105,0] /* %g/%i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264860=allocate([37,100,95,0] /* %d_\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274861=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284862=allocate([37,0] /* %\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294863=allocate([83,111,109,101,116,104,105,110,103,32,118,101,114,121,32,119,114,111,110,103,32,105,115,32,103,111,105,110,103,32,111,110,33,33,33,0] /* Something very wrong */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304864=allocate([46,0] /* .\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314865=allocate([37,103,0] /* %g\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324866=allocate([37,105,0] /* %i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334867=allocate([37,48,52,100,0] /* %04d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13video_manager=allocate([49,51,118,105,100,101,111,95,109,97,110,97,103,101,114,0] /* 13video_manager\00 */, "i8", ALLOC_STATIC);
__ZTI13video_manager=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str344868=allocate([85,110,101,120,112,101,99,116,101,100,32,114,101,110,100,101,114,95,112,114,105,109,105,116,105,118,101,32,116,121,112,101,0] /* Unexpected render_pr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354869=allocate([85,110,107,110,111,119,110,32,116,101,120,102,111,114,109,97,116,40,37,100,41,47,98,108,101,110,100,109,111,100,101,40,37,100,41,32,99,111,109,98,111,10,0] /* Unknown texformat(%d */, "i8", ALLOC_STATIC);
__ZL12cosine_table=allocate(8196, "i32", ALLOC_STATIC);
STRING_TABLE.__str364870=allocate([115,110,97,112,110,97,109,101,0] /* snapname\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374871=allocate([114,101,102,114,101,115,104,115,112,101,101,100,0] /* refreshspeed\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384872=allocate([115,108,101,101,112,0] /* sleep\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394873=allocate([115,112,101,101,100,0] /* speed\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424876=allocate([117,112,100,97,116,101,95,105,110,95,112,97,117,115,101,0] /* update_in_pause\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444878=allocate([109,110,103,119,114,105,116,101,0] /* mngwrite\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str464880=allocate([115,110,97,112,118,105,101,119,0] /* snapview\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str474881=allocate([102,114,97,109,101,115,107,105,112,0] /* frameskip\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str484882=allocate([97,117,116,111,102,114,97,109,101,115,107,105,112,0] /* autoframeskip\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str504884=allocate([116,104,114,111,116,116,108,101,0] /* throttle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14906=allocate([82,83,0] /* RS\00 */, "i8", ALLOC_STATIC);
__ZN15hash_collection19HASH_TYPES_CRC_SHA1E=allocate(1, "i8*", ALLOC_STATIC);
STRING_TABLE.__str24909=allocate([82,83,77,0] /* RSM\00 */, "i8", ALLOC_STATIC);
__ZN15hash_collection14HASH_TYPES_ALLE=allocate(1, "i8*", ALLOC_STATIC);
__ZTV9hash_base=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7388, 0, 0, 0, 7390, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str34912=allocate([37,48,50,120,0] /* %02x\00 */, "i8", ALLOC_STATIC);
__ZTV8hash_crc=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7392, 0, 0, 0, 7394, 0, 0, 0, 7396, 0, 0, 0, 7398, 0, 0, 0, 7400, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str44913=allocate([99,114,99,0] /* crc\00 */, "i8", ALLOC_STATIC);
__ZTV8hash_md5=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7402, 0, 0, 0, 7404, 0, 0, 0, 7406, 0, 0, 0, 7408, 0, 0, 0, 7410, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str54914=allocate([109,100,53,0] /* md5\00 */, "i8", ALLOC_STATIC);
__ZTV9hash_sha1=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7412, 0, 0, 0, 7414, 0, 0, 0, 7416, 0, 0, 0, 7418, 0, 0, 0, 7420, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str64915=allocate([115,104,97,49,0] /* sha1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74916=allocate([40,0] /* (\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84917=allocate([41,32,0] /* ) \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94918=allocate([78,79,95,68,85,77,80,32,0] /* NO_DUMP \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104919=allocate([66,65,68,95,68,85,77,80,32,0] /* BAD_DUMP \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114920=allocate([115,114,99,47,101,109,117,47,104,97,115,104,46,99,0] /* src/emu/hash.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS8hash_crc=allocate([56,104,97,115,104,95,99,114,99,0] /* 8hash_crc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS9hash_base=allocate([57,104,97,115,104,95,98,97,115,101,0] /* 9hash_base\00 */, "i8", ALLOC_STATIC);
__ZTI9hash_base=allocate(8, "*", ALLOC_STATIC);
__ZTI8hash_crc=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS8hash_md5=allocate([56,104,97,115,104,95,109,100,53,0] /* 8hash_md5\00 */, "i8", ALLOC_STATIC);
__ZTI8hash_md5=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS9hash_sha1=allocate([57,104,97,115,104,95,115,104,97,49,0] /* 9hash_sha1\00 */, "i8", ALLOC_STATIC);
__ZTI9hash_sha1=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI9hash_sha1E=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7422, 0, 0, 0, 7424, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI9hash_sha1E=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,57,104,97,115,104,95,115,104,97,49,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI9hash_sha1E=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI8hash_md5E=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7426, 0, 0, 0, 7428, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI8hash_md5E=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,56,104,97,115,104,95,109,100,53,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI8hash_md5E=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI8hash_crcE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7430, 0, 0, 0, 7432, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI8hash_crcE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,56,104,97,115,104,95,99,114,99,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI8hash_crcE=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listI9hash_baseE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7434, 0, 0, 0, 7436, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listI9hash_baseE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,57,104,97,115,104,95,98,97,115,101,69,0] /* 11simple_listI9hash_ */, "i8", ALLOC_STATIC);
__ZTI11simple_listI9hash_baseE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZN16info_xml_creator12s_dtd_stringE=allocate([60,33,68,79,67,84,89,80,69,32,109,101,115,115,32,91,10,60,33,69,76,69,77,69,78,84,32,109,101,115,115,32,40,109,97,99,104,105,110,101,43,41,62,10,9,60,33,65,84,84,76,73,83,84,32,109,101,115,115,32,98,117,105,108,100,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,60,33,65,84,84,76,73,83,84,32,109,101,115,115,32,100,101,98,117,103,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,60,33,65,84,84,76,73,83,84,32,109,101,115,115,32,109,97,109,101,99,111,110,102,105,103,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,60,33,69,76,69,77,69,78,84,32,109,97,99,104,105,110,101,32,40,100,101,115,99,114,105,112,116,105,111,110,44,32,121,101,97,114,63,44,32,109,97,110,117,102,97,99,116,117,114,101,114,44,32,98,105,111,115,115,101,116,42,44,32,114,111,109,42,44,32,100,105,115,107,42,44,32,115,97,109,112,108,101,42,44,32,99,104,105,112,42,44,32,100,105,115,112,108,97,121,42,44,32,115,111,117,110,100,63,44,32,105,110,112,117,116,63,44,32,100,105,112,115,119,105,116,99,104,42,44,32,99,111,110,102,105,103,117,114,97,116,105,111,110,42,44,32,99,97,116,101,103,111,114,121,42,44,32,97,100,106,117,115,116,101,114,42,44,32,100,114,105,118,101,114,63,44,32,100,101,118,105,99,101,42,44,32,115,108,111,116,42,44,32,115,111,102,116,119,97,114,101,108,105,115,116,42,44,32,114,97,109,111,112,116,105,111,110,42,41,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,115,111,117,114,99,101,102,105,108,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,105,115,98,105,111,115,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,105,115,109,101,99,104,97,110,105,99,97,108,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,114,117,110,110,97,98,108,101,32,40,121,101,115,124,110,111,41,32,34,121,101,115,34,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,99,108,111,110,101,111,102,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,114,111,109,111,102,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,65,84,84,76,73,83,84,32,109,97,99,104,105,110,101,32,115,97,109,112,108,101,111,102,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,100,101,115,99,114,105,112,116,105,111,110,32,40,35,80,67,68,65,84,65,41,62,10,9,9,60,33,69,76,69,77,69,78,84,32,121,101,97,114,32,40,35,80,67,68,65,84,65,41,62,10,9,9,60,33,69,76,69,77,69,78,84,32,109,97,110,117,102,97,99,116,117,114,101,114,32,40,35,80,67,68,65,84,65,41,62,10,9,9,60,33,69,76,69,77,69,78,84,32,98,105,111,115,115,101,116,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,98,105,111,115,115,101,116,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,98,105,111,115,115,101,116,32,100,101,115,99,114,105,112,116,105,111,110,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,98,105,111,115,115,101,116,32,100,101,102,97,117,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,114,111,109,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,98,105,111,115,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,115,105,122,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,99,114,99,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,109,100,53,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,115,104,97,49,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,109,101,114,103,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,114,101,103,105,111,110,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,111,102,102,115,101,116,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,115,116,97,116,117,115,32,40,98,97,100,100,117,109,112,124,110,111,100,117,109,112,124,103,111,111,100,41,32,34,103,111,111,100,34,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,111,109,32,111,112,116,105,111,110,97,108,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,100,105,115,107,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,109,100,53,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,115,104,97,49,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,109,101,114,103,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,114,101,103,105,111,110,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,105,110,100,101,120,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,119,114,105,116,97,98,108,101,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,115,116,97,116,117,115,32,40,98,97,100,100,117,109,112,124,110,111,100,117,109,112,124,103,111,111,100,41,32,34,103,111,111,100,34,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,107,32,111,112,116,105,111,110,97,108,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,115,97,109,112,108,101,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,97,109,112,108,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,99,104,105,112,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,104,105,112,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,104,105,112,32,116,97,103,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,104,105,112,32,116,121,112,101,32,40,99,112,117,124,97,117,100,105,111,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,104,105,112,32,99,108,111,99,107,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,100,105,115,112,108,97,121,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,116,121,112,101,32,40,114,97,115,116,101,114,124,118,101,99,116,111,114,124,108,99,100,124,117,110,107,110,111,119,110,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,114,111,116,97,116,101,32,40,48,124,57,48,124,49,56,48,124,50,55,48,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,102,108,105,112,120,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,119,105,100,116,104,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,104,101,105,103,104,116,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,114,101,102,114,101,115,104,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,112,105,120,99,108,111,99,107,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,104,116,111,116,97,108,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,104,98,101,110,100,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,104,98,115,116,97,114,116,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,118,116,111,116,97,108,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,118,98,101,110,100,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,115,112,108,97,121,32,118,98,115,116,97,114,116,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,115,111,117,110,100,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,111,117,110,100,32,99,104,97,110,110,101,108,115,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,105,110,112,117,116,32,40,99,111,110,116,114,111,108,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,112,117,116,32,115,101,114,118,105,99,101,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,112,117,116,32,116,105,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,112,117,116,32,112,108,97,121,101,114,115,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,112,117,116,32,98,117,116,116,111,110,115,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,112,117,116,32,99,111,105,110,115,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,99,111,110,116,114,111,108,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,116,114,111,108,32,116,121,112,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,116,114,111,108,32,109,105,110,105,109,117,109,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,116,114,111,108,32,109,97,120,105,109,117,109,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,116,114,111,108,32,115,101,110,115,105,116,105,118,105,116,121,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,116,114,111,108,32,107,101,121,100,101,108,116,97,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,116,114,111,108,32,114,101,118,101,114,115,101,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,100,105,112,115,119,105,116,99,104,32,40,100,105,112,118,97,108,117,101,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,115,119,105,116,99,104,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,115,119,105,116,99,104,32,116,97,103,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,115,119,105,116,99,104,32,109,97,115,107,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,100,105,112,118,97,108,117,101,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,118,97,108,117,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,118,97,108,117,101,32,118,97,108,117,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,100,105,112,118,97,108,117,101,32,100,101,102,97,117,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,40,99,111,110,102,115,101,116,116,105,110,103,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,116,97,103,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,109,97,115,107,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,99,111,110,102,115,101,116,116,105,110,103,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,102,115,101,116,116,105,110,103,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,102,115,101,116,116,105,110,103,32,118,97,108,117,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,99,111,110,102,115,101,116,116,105,110,103,32,100,101,102,97,117,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,99,97,116,101,103,111,114,121,32,40,105,116,101,109,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,99,97,116,101,103,111,114,121,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,105,116,101,109,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,105,116,101,109,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,105,116,101,109,32,100,101,102,97,117,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,97,100,106,117,115,116,101,114,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,97,100,106,117,115,116,101,114,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,97,100,106,117,115,116,101,114,32,100,101,102,97,117,108,116,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,100,114,105,118,101,114,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,115,116,97,116,117,115,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,101,109,117,108,97,116,105,111,110,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,99,111,108,111,114,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,115,111,117,110,100,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,103,114,97,112,104,105,99,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,99,111,99,107,116,97,105,108,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,112,114,111,116,101,99,116,105,111,110,32,40,103,111,111,100,124,105,109,112,101,114,102,101,99,116,124,112,114,101,108,105,109,105,110,97,114,121,41,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,115,97,118,101,115,116,97,116,101,32,40,115,117,112,112,111,114,116,101,100,124,117,110,115,117,112,112,111,114,116,101,100,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,114,105,118,101,114,32,112,97,108,101,116,116,101,115,105,122,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,100,101,118,105,99,101,32,40,105,110,115,116,97,110,99,101,42,44,32,101,120,116,101,110,115,105,111,110,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,101,118,105,99,101,32,116,121,112,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,101,118,105,99,101,32,116,97,103,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,101,118,105,99,101,32,109,97,110,100,97,116,111,114,121,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,100,101,118,105,99,101,32,105,110,116,101,114,102,97,99,101,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,105,110,115,116,97,110,99,101,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,115,116,97,110,99,101,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,105,110,115,116,97,110,99,101,32,98,114,105,101,102,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,101,120,116,101,110,115,105,111,110,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,101,120,116,101,110,115,105,111,110,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,115,108,111,116,32,40,115,108,111,116,111,112,116,105,111,110,42,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,108,111,116,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,69,76,69,77,69,78,84,32,115,108,111,116,111,112,116,105,111,110,32,69,77,80,84,89,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,115,108,111,116,111,112,116,105,111,110,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,9,60,33,65,84,84,76,73,83,84,32,115,108,111,116,111,112,116,105,111,110,32,100,101,102,97,117,108,116,32,40,121,101,115,124,110,111,41,32,34,110,111,34,62,10,9,9,60,33,69,76,69,77,69,78,84,32,115,111,102,116,119,97,114,101,108,105,115,116,32,69,77,80,84,89,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,108,105,115,116,32,110,97,109,101,32,67,68,65,84,65,32,35,82,69,81,85,73,82,69,68,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,115,111,102,116,119,97,114,101,108,105,115,116,32,115,116,97,116,117,115,32,40,111,114,105,103,105,110,97,108,124,99,111,109,112,97,116,105,98,108,101,41,32,35,82,69,81,85,73,82,69,68,62,10,9,9,60,33,69,76,69,77,69,78,84,32,114,97,109,111,112,116,105,111,110,32,40,35,80,67,68,65,84,65,41,62,10,9,9,9,60,33,65,84,84,76,73,83,84,32,114,97,109,111,112,116,105,111,110,32,100,101,102,97,117,108,116,32,67,68,65,84,65,32,35,73,77,80,76,73,69,68,62,10,93,62,0] /* <!DOCTYPE mess [\0A< */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4954=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str14955=allocate([37,115,10,10,0] /* %s\0A\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str24956=allocate([60,109,101,115,115,32,98,117,105,108,100,61,34,37,115,34,32,100,101,98,117,103,61,34,110,111,34,32,109,97,109,101,99,111,110,102,105,103,61,34,37,100,34,62,10,0] /* <mess build=\22%s\22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str34957=allocate([60,47,109,101,115,115,62,10,0] /* </mess>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str44958=allocate([9,60,109,97,99,104,105,110,101,0] /* \09<machine\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54959=allocate([32,110,97,109,101,61,34,37,115,34,0] /*  name=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str64960=allocate([32,115,111,117,114,99,101,102,105,108,101,61,34,37,115,34,0] /*  sourcefile=\22%s\22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str74961=allocate([32,105,115,98,105,111,115,61,34,121,101,115,34,0] /*  isbios=\22yes\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str84962=allocate([32,114,117,110,110,97,98,108,101,61,34,110,111,34,0] /*  runnable=\22no\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str94963=allocate([32,105,115,109,101,99,104,97,110,105,99,97,108,61,34,121,101,115,34,0] /*  ismechanical=\22yes */, "i8", ALLOC_STATIC);
STRING_TABLE.__str104964=allocate([32,99,108,111,110,101,111,102,61,34,37,115,34,0] /*  cloneof=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str114965=allocate([32,114,111,109,111,102,61,34,37,115,34,0] /*  romof=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str124966=allocate([62,10,0] /* >\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str134967=allocate([9,9,60,100,101,115,99,114,105,112,116,105,111,110,62,37,115,60,47,100,101,115,99,114,105,112,116,105,111,110,62,10,0] /* \09\09<description>% */, "i8", ALLOC_STATIC);
STRING_TABLE.__str144968=allocate([48,49,50,51,52,53,54,55,56,57,63,43,0] /* 0123456789?+\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154969=allocate([9,9,60,121,101,97,114,62,37,115,60,47,121,101,97,114,62,10,0] /* \09\09<year>%s</year */, "i8", ALLOC_STATIC);
STRING_TABLE.__str164970=allocate([9,9,60,109,97,110,117,102,97,99,116,117,114,101,114,62,37,115,60,47,109,97,110,117,102,97,99,116,117,114,101,114,62,10,0] /* \09\09<manufacturer> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str174971=allocate([100,105,112,115,119,105,116,99,104,0] /* dipswitch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str184972=allocate([100,105,112,118,97,108,117,101,0] /* dipvalue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str194973=allocate([99,111,110,102,105,103,117,114,97,116,105,111,110,0] /* configuration\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str204974=allocate([99,111,110,102,115,101,116,116,105,110,103,0] /* confsetting\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str214975=allocate([9,60,47,109,97,99,104,105,110,101,62,10,0] /* \09</machine>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str224976=allocate([32,115,97,109,112,108,101,111,102,61,34,37,115,34,0] /*  sampleof=\22%s\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str234977=allocate([9,9,60,98,105,111,115,115,101,116,0] /* \09\09<biosset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str244978=allocate([32,100,101,115,99,114,105,112,116,105,111,110,61,34,37,115,34,0] /*  description=\22%s\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str254979=allocate([32,100,101,102,97,117,108,116,61,34,121,101,115,34,0] /*  default=\22yes\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str264980=allocate([47,62,10,0] /* />\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str274981=allocate([9,9,60,114,111,109,0] /* \09\09<rom\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str284982=allocate([9,9,60,100,105,115,107,0] /* \09\09<disk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str294983=allocate([32,109,101,114,103,101,61,34,37,115,34,0] /*  merge=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str304984=allocate([32,98,105,111,115,61,34,37,115,34,0] /*  bios=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str314985=allocate([32,115,105,122,101,61,34,37,100,34,0] /*  size=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str324986=allocate([32,37,115,61,34,37,115,34,0] /*  %s=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str334987=allocate([32,114,101,103,105,111,110,61,34,37,115,34,0] /*  region=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str344988=allocate([32,115,116,97,116,117,115,61,34,110,111,100,117,109,112,34,0] /*  status=\22nodump\22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str354989=allocate([32,115,116,97,116,117,115,61,34,98,97,100,100,117,109,112,34,0] /*  status=\22baddump\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str364990=allocate([32,111,102,102,115,101,116,61,34,37,120,34,0] /*  offset=\22%x\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str374991=allocate([32,105,110,100,101,120,61,34,37,120,34,0] /*  index=\22%x\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str384992=allocate([32,119,114,105,116,101,97,98,108,101,61,34,37,115,34,0] /*  writeable=\22%s\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str394993=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str404994=allocate([121,101,115,0] /* yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str414995=allocate([32,111,112,116,105,111,110,97,108,61,34,121,101,115,34,0] /*  optional=\22yes\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str424996=allocate([9,9,60,115,97,109,112,108,101,32,110,97,109,101,61,34,37,115,34,47,62,10,0] /* \09\09<sample name=\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str434997=allocate([9,9,60,99,104,105,112,0] /* \09\09<chip\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str444998=allocate([32,116,121,112,101,61,34,99,112,117,34,0] /*  type=\22cpu\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str454999=allocate([32,116,97,103,61,34,37,115,34,0] /*  tag=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str465000=allocate([32,99,108,111,99,107,61,34,37,100,34,0] /*  clock=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str475001=allocate([32,116,121,112,101,61,34,97,117,100,105,111,34,0] /*  type=\22audio\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str485002=allocate([9,9,60,100,105,115,112,108,97,121,0] /* \09\09<display\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str495003=allocate([32,116,121,112,101,61,34,114,97,115,116,101,114,34,0] /*  type=\22raster\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str505004=allocate([32,116,121,112,101,61,34,118,101,99,116,111,114,34,0] /*  type=\22vector\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str515005=allocate([32,116,121,112,101,61,34,108,99,100,34,0] /*  type=\22lcd\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str525006=allocate([32,116,121,112,101,61,34,117,110,107,110,111,119,110,34,0] /*  type=\22unknown\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str535007=allocate([32,114,111,116,97,116,101,61,34,48,34,32,102,108,105,112,120,61,34,121,101,115,34,0] /*  rotate=\220\22 flip */, "i8", ALLOC_STATIC);
STRING_TABLE.__str545008=allocate([32,114,111,116,97,116,101,61,34,49,56,48,34,32,102,108,105,112,120,61,34,121,101,115,34,0] /*  rotate=\22180\22 fl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str555009=allocate([32,114,111,116,97,116,101,61,34,49,56,48,34,0] /*  rotate=\22180\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str565010=allocate([32,114,111,116,97,116,101,61,34,57,48,34,32,102,108,105,112,120,61,34,121,101,115,34,0] /*  rotate=\2290\22 fli */, "i8", ALLOC_STATIC);
STRING_TABLE.__str575011=allocate([32,114,111,116,97,116,101,61,34,57,48,34,0] /*  rotate=\2290\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str585012=allocate([32,114,111,116,97,116,101,61,34,50,55,48,34,0] /*  rotate=\22270\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str595013=allocate([32,114,111,116,97,116,101,61,34,50,55,48,34,32,102,108,105,112,120,61,34,121,101,115,34,0] /*  rotate=\22270\22 fl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str605014=allocate([32,114,111,116,97,116,101,61,34,48,34,0] /*  rotate=\220\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str615015=allocate([32,119,105,100,116,104,61,34,37,100,34,0] /*  width=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str625016=allocate([32,104,101,105,103,104,116,61,34,37,100,34,0] /*  height=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str635017=allocate([32,114,101,102,114,101,115,104,61,34,37,102,34,0] /*  refresh=\22%f\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str645018=allocate([32,112,105,120,99,108,111,99,107,61,34,37,100,34,0] /*  pixclock=\22%d\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str655019=allocate([32,104,116,111,116,97,108,61,34,37,100,34,0] /*  htotal=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str665020=allocate([32,104,98,101,110,100,61,34,37,100,34,0] /*  hbend=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str675021=allocate([32,104,98,115,116,97,114,116,61,34,37,100,34,0] /*  hbstart=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str685022=allocate([32,118,116,111,116,97,108,61,34,37,100,34,0] /*  vtotal=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str695023=allocate([32,118,98,101,110,100,61,34,37,100,34,0] /*  vbend=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str705024=allocate([32,118,98,115,116,97,114,116,61,34,37,100,34,0] /*  vbstart=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str715025=allocate([32,47,62,10,0] /*  />\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str725026=allocate([9,9,60,115,111,117,110,100,32,99,104,97,110,110,101,108,115,61,34,37,100,34,47,62,10,0] /* \09\09<sound channel */, "i8", ALLOC_STATIC);
STRING_TABLE.__str735027=allocate([112,97,100,100,108,101,0] /* paddle\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str745028=allocate([100,105,97,108,0] /* dial\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str755029=allocate([116,114,97,99,107,98,97,108,108,0] /* trackball\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str765030=allocate([115,116,105,99,107,0] /* stick\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str775031=allocate([108,105,103,104,116,103,117,110,0] /* lightgun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str785032=allocate([112,101,100,97,108,0] /* pedal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str795033=allocate([9,9,60,105,110,112,117,116,0] /* \09\09<input\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str805034=allocate([32,112,108,97,121,101,114,115,61,34,37,100,34,0] /*  players=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str815035=allocate([32,98,117,116,116,111,110,115,61,34,37,100,34,0] /*  buttons=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str825036=allocate([32,99,111,105,110,115,61,34,37,100,34,0] /*  coins=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str835037=allocate([32,115,101,114,118,105,99,101,61,34,121,101,115,34,0] /*  service=\22yes\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str845038=allocate([32,116,105,108,116,61,34,121,101,115,34,0] /*  tilt=\22yes\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str855039=allocate([118,0] /* v\00 */, "i8", ALLOC_STATIC);
__str865040=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str875041=allocate([100,111,117,98,108,101,106,111,121,0] /* doublejoy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str885042=allocate([106,111,121,0] /* joy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str895043=allocate([50,119,97,121,0] /* 2way\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str905044=allocate([52,119,97,121,0] /* 4way\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str915045=allocate([56,119,97,121,0] /* 8way\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str925046=allocate([9,9,9,60,99,111,110,116,114,111,108,32,116,121,112,101,61,34,37,115,37,115,37,115,34,47,62,10,0] /* \09\09\09<control ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str935047=allocate([9,9,9,60,99,111,110,116,114,111,108,32,116,121,112,101,61,34,37,115,34,0] /* \09\09\09<control ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str945048=allocate([32,109,105,110,105,109,117,109,61,34,37,100,34,0] /*  minimum=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str955049=allocate([32,109,97,120,105,109,117,109,61,34,37,100,34,0] /*  maximum=\22%d\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str965050=allocate([32,115,101,110,115,105,116,105,118,105,116,121,61,34,37,100,34,0] /*  sensitivity=\22%d\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str975051=allocate([32,107,101,121,100,101,108,116,97,61,34,37,100,34,0] /*  keydelta=\22%d\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str985052=allocate([32,114,101,118,101,114,115,101,61,34,121,101,115,34,0] /*  reverse=\22yes\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str995053=allocate([9,9,9,60,99,111,110,116,114,111,108,32,116,121,112,101,61,34,107,101,121,112,97,100,34,47,62,10,0] /* \09\09\09<control ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1005054=allocate([9,9,9,60,99,111,110,116,114,111,108,32,116,121,112,101,61,34,107,101,121,98,111,97,114,100,34,47,62,10,0] /* \09\09\09<control ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1015055=allocate([9,9,60,47,105,110,112,117,116,62,10,0] /* \09\09</input>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1025056=allocate([9,9,60,37,115,32,110,97,109,101,61,34,37,115,34,0] /* \09\09<%s name=\22%s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1035057=allocate([32,109,97,115,107,61,34,37,117,34,0] /*  mask=\22%u\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1045058=allocate([9,9,9,60,37,115,32,110,97,109,101,61,34,37,115,34,0] /* \09\09\09<%s name=\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1055059=allocate([32,118,97,108,117,101,61,34,37,117,34,0] /*  value=\22%u\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1065060=allocate([9,9,60,47,37,115,62,10,0] /* \09\09</%s>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1075061=allocate([9,9,60,97,100,106,117,115,116,101,114,32,110,97,109,101,61,34,37,115,34,32,100,101,102,97,117,108,116,61,34,37,100,34,47,62,10,0] /* \09\09<adjuster name */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1085062=allocate([9,9,60,100,114,105,118,101,114,0] /* \09\09<driver\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1095063=allocate([32,115,116,97,116,117,115,61,34,112,114,101,108,105,109,105,110,97,114,121,34,0] /*  status=\22prelimina */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1105064=allocate([32,115,116,97,116,117,115,61,34,105,109,112,101,114,102,101,99,116,34,0] /*  status=\22imperfect */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1115065=allocate([32,115,116,97,116,117,115,61,34,103,111,111,100,34,0] /*  status=\22good\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1125066=allocate([32,101,109,117,108,97,116,105,111,110,61,34,112,114,101,108,105,109,105,110,97,114,121,34,0] /*  emulation=\22prelim */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1135067=allocate([32,101,109,117,108,97,116,105,111,110,61,34,103,111,111,100,34,0] /*  emulation=\22good\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1145068=allocate([32,99,111,108,111,114,61,34,112,114,101,108,105,109,105,110,97,114,121,34,0] /*  color=\22preliminar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1155069=allocate([32,99,111,108,111,114,61,34,105,109,112,101,114,102,101,99,116,34,0] /*  color=\22imperfect\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1165070=allocate([32,99,111,108,111,114,61,34,103,111,111,100,34,0] /*  color=\22good\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1175071=allocate([32,115,111,117,110,100,61,34,112,114,101,108,105,109,105,110,97,114,121,34,0] /*  sound=\22preliminar */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1185072=allocate([32,115,111,117,110,100,61,34,105,109,112,101,114,102,101,99,116,34,0] /*  sound=\22imperfect\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1195073=allocate([32,115,111,117,110,100,61,34,103,111,111,100,34,0] /*  sound=\22good\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1205074=allocate([32,103,114,97,112,104,105,99,61,34,105,109,112,101,114,102,101,99,116,34,0] /*  graphic=\22imperfec */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1215075=allocate([32,103,114,97,112,104,105,99,61,34,103,111,111,100,34,0] /*  graphic=\22good\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1225076=allocate([32,99,111,99,107,116,97,105,108,61,34,112,114,101,108,105,109,105,110,97,114,121,34,0] /*  cocktail=\22prelimi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1235077=allocate([32,112,114,111,116,101,99,116,105,111,110,61,34,112,114,101,108,105,109,105,110,97,114,121,34,0] /*  protection=\22preli */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1245078=allocate([32,115,97,118,101,115,116,97,116,101,61,34,115,117,112,112,111,114,116,101,100,34,0] /*  savestate=\22suppor */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1255079=allocate([32,115,97,118,101,115,116,97,116,101,61,34,117,110,115,117,112,112,111,114,116,101,100,34,0] /*  savestate=\22unsupp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1265080=allocate([32,112,97,108,101,116,116,101,115,105,122,101,61,34,37,100,34,0] /*  palettesize=\22%d\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1275081=allocate([9,9,60,99,97,116,101,103,111,114,121,32,110,97,109,101,61,34,37,115,34,62,10,0] /* \09\09<category name */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1285082=allocate([9,9,9,60,105,116,101,109,32,110,97,109,101,61,34,37,115,34,0] /* \09\09\09<item name= */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1295083=allocate([9,9,60,47,99,97,116,101,103,111,114,121,62,10,0] /* \09\09</category>\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1305084=allocate([9,9,60,100,101,118,105,99,101,32,116,121,112,101,61,34,37,115,34,0] /* \09\09<device type=\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1315085=allocate([32,109,97,110,100,97,116,111,114,121,61,34,49,34,0] /*  mandatory=\221\22\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1325086=allocate([32,105,110,116,101,114,102,97,99,101,61,34,37,115,34,0] /*  interface=\22%s\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1335087=allocate([9,9,9,60,105,110,115,116,97,110,99,101,0] /* \09\09\09<instance\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1345088=allocate([32,98,114,105,101,102,110,97,109,101,61,34,37,115,34,0] /*  briefname=\22%s\22\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1355089=allocate([44,0] /* ,\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1365090=allocate([9,9,9,60,101,120,116,101,110,115,105,111,110,0] /* \09\09\09<extension\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1375091=allocate([9,9,60,47,100,101,118,105,99,101,62,10,0] /* \09\09</device>\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1385092=allocate([9,9,60,115,108,111,116,32,110,97,109,101,61,34,37,115,34,62,10,0] /* \09\09<slot name=\22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1395093=allocate([9,9,9,60,115,108,111,116,111,112,116,105,111,110,0] /* \09\09\09<slotoption */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1405094=allocate([9,9,60,47,115,108,111,116,62,10,0] /* \09\09</slot>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1415095=allocate([9,9,60,115,111,102,116,119,97,114,101,108,105,115,116,32,110,97,109,101,61,34,37,115,34,32,0] /* \09\09<softwarelist  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1425096=allocate([115,116,97,116,117,115,61,34,37,115,34,32,47,62,10,0] /* status=\22%s\22 />\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1435097=allocate([111,114,105,103,105,110,97,108,0] /* original\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1445098=allocate([99,111,109,112,97,116,105,98,108,101,0] /* compatible\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1455099=allocate([9,9,60,114,97,109,111,112,116,105,111,110,32,100,101,102,97,117,108,116,61,34,49,34,62,37,117,60,47,114,97,109,111,112,116,105,111,110,62,10,0] /* \09\09<ramoption def */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1465100=allocate([9,9,60,114,97,109,111,112,116,105,111,110,62,37,117,60,47,114,97,109,111,112,116,105,111,110,62,10,0] /* \09\09<ramoption>%u< */, "i8", ALLOC_STATIC);
__ZTV17debug_view_source=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7438, 0, 0, 0, 7440, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV10debug_view=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7442, 0, 0, 0, 7444, 0, 0, 0, 1788, 0, 0, 0, 7446, 0, 0, 0, 7448, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str5105=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,101,98,117,103,118,119,46,99,0] /* src/emu/debug/debugv */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15106=allocate([65,116,116,101,109,112,116,32,116,111,32,99,114,101,97,116,101,32,105,110,118,97,108,105,100,32,100,101,98,117,103,32,118,105,101,119,32,116,121,112,101,32,37,100,10,0] /* Attempt to create in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25107=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS10debug_view=allocate([49,48,100,101,98,117,103,95,118,105,101,119,0] /* 10debug_view\00 */, "i8", ALLOC_STATIC);
__ZTI10debug_view=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS17debug_view_source=allocate([49,55,100,101,98,117,103,95,118,105,101,119,95,115,111,117,114,99,101,0] /* 17debug_view_source\ */, "i8", ALLOC_STATIC);
__ZTI17debug_view_source=allocate(8, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI14debug_view_logE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7450, 0, 0, 0, 7452, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14debug_view_logE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,100,101,98,117,103,95,118,105,101,119,95,108,111,103,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14debug_view_logE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI17debug_view_memoryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7454, 0, 0, 0, 7456, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17debug_view_memoryE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,100,101,98,117,103,95,118,105,101,119,95,109,101,109,111,114,121,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17debug_view_memoryE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI17debug_view_disasmE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7458, 0, 0, 0, 7460, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI17debug_view_disasmE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,55,100,101,98,117,103,95,118,105,101,119,95,100,105,115,97,115,109,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI17debug_view_disasmE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI16debug_view_stateE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7462, 0, 0, 0, 7464, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16debug_view_stateE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,100,101,98,117,103,95,118,105,101,119,95,115,116,97,116,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16debug_view_stateE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI18debug_view_consoleE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7466, 0, 0, 0, 7468, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI18debug_view_consoleE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,56,100,101,98,117,103,95,118,105,101,119,95,99,111,110,115,111,108,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI18debug_view_consoleE=allocate(12, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayI15debug_view_charE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7470, 0, 0, 0, 7472, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI15debug_view_charE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,49,53,100,101,98,117,103,95,118,105,101,119,95,99,104,97,114,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI15debug_view_charE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS22device_nvram_interface=allocate([50,50,100,101,118,105,99,101,95,110,118,114,97,109,95,105,110,116,101,114,102,97,99,101,0] /* 22device_nvram_inter */, "i8", ALLOC_STATIC);
__ZTI22device_nvram_interface=allocate(12, "*", ALLOC_STATIC);
__ZTV22device_sound_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7474, 0, 0, 0, 7476, 0, 0, 0, 1882, 0, 0, 0, 7098, 0, 0, 0, 7100, 0, 0, 0, 7102, 0, 0, 0, 7104, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str35143=allocate([37,115,58,32,37,115,32,97,116,116,101,109,112,116,105,110,103,32,116,111,32,114,111,117,116,101,32,115,111,117,110,100,32,116,111,32,110,111,110,45,101,120,105,115,116,97,110,116,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* %s: %s attempting to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45144=allocate([37,115,58,32,37,115,32,97,116,116,101,109,112,116,105,110,103,32,116,111,32,114,111,117,116,101,32,115,111,117,110,100,32,116,111,32,97,32,110,111,110,45,115,111,117,110,100,32,100,101,118,105,99,101,32,39,37,115,39,32,40,37,115,41,10,0] /* %s: %s attempting to */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55145=allocate([83,111,117,110,100,32,100,101,118,105,99,101,32,39,37,115,39,32,115,112,101,99,105,102,105,101,115,32,114,111,117,116,101,32,102,111,114,32,110,111,110,45,101,120,105,115,116,97,110,116,32,111,117,116,112,117,116,32,35,37,100,0] /* Sound device '%s' sp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65146=allocate([83,111,117,110,100,32,100,101,118,105,99,101,32,39,37,115,39,32,116,97,114,103,101,116,101,100,32,111,117,116,112,117,116,32,35,37,100,32,116,111,32,110,111,110,45,101,120,105,115,116,97,110,116,32,100,101,118,105,99,101,32,39,37,115,39,32,105,110,112,117,116,32,37,100,0] /* Sound device '%s' ta */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS22device_sound_interface=allocate([50,50,100,101,118,105,99,101,95,115,111,117,110,100,95,105,110,116,101,114,102,97,99,101,0] /* 22device_sound_inter */, "i8", ALLOC_STATIC);
__ZTI22device_sound_interface=allocate(12, "*", ALLOC_STATIC);
__ZTV11simple_listIN22device_sound_interface11sound_routeEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7478, 0, 0, 0, 7480, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS11simple_listIN22device_sound_interface11sound_routeEE=allocate([49,49,115,105,109,112,108,101,95,108,105,115,116,73,78,50,50,100,101,118,105,99,101,95,115,111,117,110,100,95,105,110,116,101,114,102,97,99,101,49,49,115,111,117,110,100,95,114,111,117,116,101,69,69,0] /* 11simple_listIN22dev */, "i8", ALLOC_STATIC);
__ZTI11simple_listIN22device_sound_interface11sound_routeEE=allocate(8, "*", ALLOC_STATIC);
__ZTV23device_disasm_interface=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7482, 0, 0, 0, 7484, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS23device_disasm_interface=allocate([50,51,100,101,118,105,99,101,95,100,105,115,97,115,109,95,105,110,116,101,114,102,97,99,101,0] /* 23device_disasm_inte */, "i8", ALLOC_STATIC);
__ZTI23device_disasm_interface=allocate(12, "*", ALLOC_STATIC);
__ZTV24legacy_image_device_base=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7486, 0, 0, 0, 7488, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 5188, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 5198, 0, 0, 0, 5200, 0, 0, 0, 5202, 0, 0, 0, 5204, 0, 0, 0, 5206, 0, 0, 0, 5208, 0, 0, 0, 5210, 0, 0, 0, 5212, 0, 0, 0, 5214, 0, 0, 0, 5216, 0, 0, 0, 5218, 0, 0, 0, 5220, 0, 0, 0, 5222, 0, 0, 0, 5224, 0, 0, 0, 5226, 0, 0, 0, 5228, 0, 0, 0, 5230, 0, 0, 0, 5232, 0, 0, 0, -368, 0, 0, 0, 0, 0, 0, 0, 7490, 0, 0, 0, 7492, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 5238, 0, 0, 0, 5240, 0, 0, 0, 5242, 0, 0, 0, 5244, 0, 0, 0, 5246, 0, 0, 0, 5248, 0, 0, 0, 5250, 0, 0, 0, 5252, 0, 0, 0, 5254, 0, 0, 0, 5256, 0, 0, 0, 5258, 0, 0, 0, 5260, 0, 0, 0, 5262, 0, 0, 0, 5264, 0, 0, 0, 5266, 0, 0, 0, 5268, 0, 0, 0, 5270, 0, 0, 0, 5272, 0, 0, 0, 5274, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str5178=allocate([115,114,99,47,101,109,117,47,100,101,118,105,109,97,103,101,46,99,0] /* src/emu/devimage.c\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS24legacy_image_device_base=allocate([50,52,108,101,103,97,99,121,95,105,109,97,103,101,95,100,101,118,105,99,101,95,98,97,115,101,0] /* 24legacy_image_devic */, "i8", ALLOC_STATIC);
__ZTI24legacy_image_device_base=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 94210, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTV20resource_pool_objectI19image_device_formatE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7494, 0, 0, 0, 7496, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI19image_device_formatE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,57,105,109,97,103,101,95,100,101,118,105,99,101,95,102,111,114,109,97,116,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI19image_device_formatE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str5223=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
__ZTV8emu_file=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7498, 0, 0, 0, 7500, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__str15224=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str25225=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,111,112,101,110,32,97,32,102,105,108,101,32,102,111,114,32,119,114,105,116,101,32,119,105,116,104,32,79,80,69,78,95,70,76,65,71,95,72,65,83,95,67,82,67,0] /* Attempted to open a  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35226=allocate([111,112,101,114,97,116,111,114,32,99,111,114,101,95,102,105,108,101,32,38,32,117,115,101,100,32,111,110,32,105,110,118,97,108,105,100,32,102,105,108,101,0] /* operator core_file & */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45227=allocate([82,65,77,0] /* RAM\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55228=allocate([46,122,105,112,0] /* .zip\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65229=allocate([115,114,99,47,101,109,117,47,102,105,108,101,105,111,46,99,0] /* src/emu/fileio.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS8emu_file=allocate([56,101,109,117,95,102,105,108,101,0] /* 8emu_file\00 */, "i8", ALLOC_STATIC);
__ZTI8emu_file=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS21device_slot_interface=allocate([50,49,100,101,118,105,99,101,95,115,108,111,116,95,105,110,116,101,114,102,97,99,101,0] /* 21device_slot_interf */, "i8", ALLOC_STATIC);
__ZTI21device_slot_interface=allocate(12, "*", ALLOC_STATIC);
_g_profiler=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str5329=allocate([37,117,37,99,0] /* %u%c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15330=allocate([82,65,77,0] /* RAM\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25331=allocate([49,46,48,48,0] /* 1.00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35332=allocate([115,114,99,47,101,109,117,47,109,97,99,104,105,110,101,47,114,97,109,46,99,0] /* src/emu/machine/ram. */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45333=allocate([67,111,112,121,114,105,103,104,116,32,77,69,83,83,32,84,101,97,109,0] /* Copyright MESS Team\ */, "i8", ALLOC_STATIC);
__ZTV10ram_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7502, 0, 0, 0, 7504, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 1732, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_RAM=allocate([1132], ["%class.device_t.2113* (%class.machine_config.2104*, i8*, %class.device_t.2113*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS10ram_device=allocate([49,48,114,97,109,95,100,101,118,105,99,101,0] /* 10ram_device\00 */, "i8", ALLOC_STATIC);
__ZTI10ram_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str55336=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI10ram_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7506, 0, 0, 0, 7508, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI10ram_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,48,114,97,109,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI10ram_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str65337=allocate([37,115,58,32,39,37,115,39,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,100,101,102,97,117,108,116,32,82,65,77,32,111,112,116,105,111,110,58,32,37,115,10,0] /* %s: '%s' has an inva */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75338=allocate([114,97,109,0] /* ram\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85339=allocate([37,115,58,32,39,37,115,39,32,99,97,110,110,111,116,32,114,101,99,111,103,110,105,122,101,32,116,104,101,32,82,65,77,32,111,112,116,105,111,110,32,37,115,10,0] /* %s: '%s' cannot reco */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95340=allocate([37,115,58,32,39,37,115,39,32,104,97,115,32,97,110,32,105,110,118,97,108,105,100,32,82,65,77,32,111,112,116,105,111,110,58,32,37,115,10,0] /* %s: '%s' has an inva */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105341=allocate([37,115,58,32,39,37,115,39,32,99,97,110,110,111,116,32,114,101,99,111,103,110,105,122,101,32,116,104,101,32,82,65,77,32,111,112,116,105,111,110,32,37,115,0] /* %s: '%s' cannot reco */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115342=allocate([32,40,118,97,108,105,100,32,111,112,116,105,111,110,115,32,97,114,101,32,37,115,0] /*  (valid options are  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125343=allocate([44,37,115,41,46,10,0] /* ,%s).\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135344=allocate([41,46,10,0] /* ).\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145345=allocate([114,97,109,115,105,122,101,0] /* ramsize\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155346=allocate([114,97,109,45,62,115,105,122,101,0] /* ram->size\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165347=allocate([114,97,109,45,62,114,97,109,0] /* ram->ram\00 */, "i8", ALLOC_STATIC);
_SPEAKER=allocate([7510], ["%class.device_t.14471* (%class.machine_config.14425*, i8*, %class.device_t.14471*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str5353=allocate([83,112,101,97,107,101,114,0] /* Speaker\00 */, "i8", ALLOC_STATIC);
__ZTV14speaker_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7512, 0, 0, 0, 7514, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 1732, 0, 0, 0, 1734, 0, 0, 0, 7516, 0, 0, 0, 1738, 0, 0, 0, 5354, 0, 0, 0, 1742, 0, 0, 0, 7518, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 7520, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 7522, 0, 0, 0, 7524, 0, 0, 0, 1882, 0, 0, 0, 7098, 0, 0, 0, 7100, 0, 0, 0, 7102, 0, 0, 0, 7104, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 7526, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str15354=allocate([87,97,114,110,105,110,103,58,32,115,112,101,97,107,101,114,32,34,37,115,34,32,104,97,115,32,110,111,32,105,110,112,117,116,115,10,0] /* Warning: speaker \22 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS14speaker_device=allocate([49,52,115,112,101,97,107,101,114,95,100,101,118,105,99,101,0] /* 14speaker_device\00 */, "i8", ALLOC_STATIC);
__ZTI14speaker_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 91138, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str25355=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,104,0] /* src/emu/devintrf.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI14speaker_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7528, 0, 0, 0, 7530, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14speaker_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,115,112,101,97,107,101,114,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14speaker_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZL6ui_gfx=allocate(464, ["i8","i8",0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str5358=allocate([117,105,95,103,102,120,95,101,120,105,116,0] /* ui_gfx_exit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15359=allocate([84,77,65,80,32,37,100,47,37,100,32,37,100,120,37,100,32,79,70,70,83,32,37,100,44,37,100,0] /* TMAP %d/%d %dx%d OFF */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25360=allocate([90,111,111,109,32,61,32,37,100,0] /* Zoom = %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35361=allocate([90,111,111,109,32,65,117,116,111,0] /* Zoom Auto\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45362=allocate([73,110,118,97,108,105,100,32,98,105,116,109,97,112,32,102,111,114,109,97,116,33,0] /* Invalid bitmap forma */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55363=allocate([115,114,99,47,101,109,117,47,117,105,103,102,120,46,99,0] /* src/emu/uigfx.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65364=allocate([71,70,88,32,37,100,47,37,100,32,37,100,120,37,100,32,67,79,76,79,82,32,37,88,0] /* GFX %d/%d %dx%d COLO */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75365=allocate([48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0] /* 0123456789ABCDEF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85366=allocate([37,53,88,0] /* %5X\00 */, "i8", ALLOC_STATIC);
__ZZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiiiE15default_palette=allocate([-16777216, 0, 0, 0, -16776961, 0, 0, 0, -16711936, 0, 0, 0, -16711681, 0, 0, 0, -65536, 0, 0, 0, -65281, 0, 0, 0, -256, 0, 0, 0, -1, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str95367=allocate([67,79,76,79,82,84,65,66,76,69,0] /* COLORTABLE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105368=allocate([80,65,76,69,84,84,69,0] /* PALETTE\00 */, "i8", ALLOC_STATIC);
_CASSETTE=allocate([7532], ["%class.device_t.852* (%class.machine_config.802*, i8*, %class.device_t.852*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str5378=allocate([67,97,115,115,101,116,116,101,0] /* Cassette\00 */, "i8", ALLOC_STATIC);
__ZTV21cassette_image_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7534, 0, 0, 0, 7536, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 7538, 0, 0, 0, 1734, 0, 0, 0, 7540, 0, 0, 0, 1738, 0, 0, 0, 5354, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 7542, 0, 0, 0, 7544, 0, 0, 0, 7546, 0, 0, 0, 7548, 0, 0, 0, 7550, 0, 0, 0, 7552, 0, 0, 0, 7554, 0, 0, 0, 7556, 0, 0, 0, 7558, 0, 0, 0, 7560, 0, 0, 0, 7562, 0, 0, 0, 7564, 0, 0, 0, 7566, 0, 0, 0, 7568, 0, 0, 0, -376, 0, 0, 0, 0, 0, 0, 0, 7570, 0, 0, 0, 7572, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 5238, 0, 0, 0, 7574, 0, 0, 0, 7576, 0, 0, 0, 5388, 0, 0, 0, 7578, 0, 0, 0, 7580, 0, 0, 0, 7582, 0, 0, 0, 5396, 0, 0, 0, 5398, 0, 0, 0, 5400, 0, 0, 0, 7584, 0, 0, 0, 7586, 0, 0, 0, 7588, 0, 0, 0, 7590, 0, 0, 0, 7592, 0, 0, 0, 7594, 0, 0, 0, 7596, 0, 0, 0, 7598, 0, 0, 0, 7600, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZZN21cassette_image_device12call_displayEvE6shapes=allocate([45,92,124,47,45,32,32,32] /* -\5C|/-    */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15379=allocate([37,99,37,99,32,37,99,32,37,48,50,100,58,37,48,50,100,32,40,37,48,52,100,41,32,91,37,48,50,100,58,37,48,50,100,32,40,37,48,52,100,41,93,0] /* %c%c %c %02d:%02d (% */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS21cassette_image_device=allocate([50,49,99,97,115,115,101,116,116,101,95,105,109,97,103,101,95,100,101,118,105,99,101,0] /* 21cassette_image_dev */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS18cassette_interface=allocate([49,56,99,97,115,115,101,116,116,101,95,105,110,116,101,114,102,97,99,101,0] /* 18cassette_interface */, "i8", ALLOC_STATIC);
__ZTI18cassette_interface=allocate(8, "*", ALLOC_STATIC);
__ZTI21cassette_image_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 91138, 0, 0, 0, 0, 0, 0, 0, 96258, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str25380=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,104,0] /* src/emu/devintrf.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI21cassette_image_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7602, 0, 0, 0, 7604, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI21cassette_image_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,49,99,97,115,115,101,116,116,101,95,105,109,97,103,101,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI21cassette_image_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZZ21bitbanger_mode_stringP8device_tE5modes=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str5381=allocate([80,114,105,110,116,101,114,0] /* Printer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15382=allocate([77,111,100,101,109,0] /* Modem\00 */, "i8", ALLOC_STATIC);
__ZZ21bitbanger_tune_stringP8device_tE5tunes=allocate(68, "*", ALLOC_STATIC);
STRING_TABLE.__str25383=allocate([45,50,46,48,37,0] /* -2.0%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35384=allocate([45,49,46,55,53,37,0] /* -1.75%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45385=allocate([45,49,46,53,37,0] /* -1.5%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55386=allocate([45,49,46,50,53,37,0] /* -1.25%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65387=allocate([45,49,46,48,37,0] /* -1.0%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75388=allocate([45,48,46,55,53,37,0] /* -0.75%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85389=allocate([45,48,46,53,0] /* -0.5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95390=allocate([45,48,46,50,53,37,0] /* -0.25%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105391=allocate([194,177,48,37,0] /* \C2\B10%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115392=allocate([43,48,46,50,53,37,0] /* +0.25%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125393=allocate([43,48,46,53,37,0] /* +0.5%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135394=allocate([43,48,46,55,53,37,0] /* +0.75%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145395=allocate([43,49,46,48,37,0] /* +1.0%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155396=allocate([43,49,46,50,53,37,0] /* +1.25%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165397=allocate([43,49,46,53,37,0] /* +1.5%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175398=allocate([43,49,46,55,53,37,0] /* +1.75%\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185399=allocate([43,50,46,48,37,0] /* +2.0%\00 */, "i8", ALLOC_STATIC);
__ZZ21bitbanger_baud_stringP8device_tE5bauds=allocate(48, "*", ALLOC_STATIC);
STRING_TABLE.__str195400=allocate([49,53,48,0] /* 150\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str205401=allocate([51,48,48,0] /* 300\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215402=allocate([54,48,48,0] /* 600\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225403=allocate([49,50,48,48,0] /* 1200\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235404=allocate([50,52,48,48,0] /* 2400\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245405=allocate([52,56,48,48,0] /* 4800\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255406=allocate([57,54,48,48,0] /* 9600\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265407=allocate([49,52,52,48,48,0] /* 14400\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str275408=allocate([50,56,56,48,48,0] /* 28800\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str285409=allocate([51,56,52,48,48,0] /* 38400\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str295410=allocate([53,55,54,48,48,0] /* 57600\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str305411=allocate([49,49,53,50,48,48,0] /* 115200\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str315412=allocate([66,105,116,98,97,110,103,101,114,0] /* Bitbanger\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str325413=allocate([115,114,99,47,101,109,117,47,105,109,97,103,101,100,101,118,47,98,105,116,98,110,103,114,46,99,0] /* src/emu/imagedev/bit */, "i8", ALLOC_STATIC);
STRING_TABLE.__str335414=allocate([112,114,110,0] /* prn\00 */, "i8", ALLOC_STATIC);
__ZTV16bitbanger_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7606, 0, 0, 0, 7608, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 5188, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 5198, 0, 0, 0, 5200, 0, 0, 0, 5202, 0, 0, 0, 5204, 0, 0, 0, 5206, 0, 0, 0, 5208, 0, 0, 0, 5210, 0, 0, 0, 5212, 0, 0, 0, 5214, 0, 0, 0, 5216, 0, 0, 0, 5218, 0, 0, 0, 5220, 0, 0, 0, 5222, 0, 0, 0, 5224, 0, 0, 0, 5226, 0, 0, 0, 5228, 0, 0, 0, 5230, 0, 0, 0, 5232, 0, 0, 0, -368, 0, 0, 0, 0, 0, 0, 0, 7610, 0, 0, 0, 7612, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 5238, 0, 0, 0, 5240, 0, 0, 0, 5242, 0, 0, 0, 5244, 0, 0, 0, 5246, 0, 0, 0, 5248, 0, 0, 0, 5250, 0, 0, 0, 5252, 0, 0, 0, 5254, 0, 0, 0, 5256, 0, 0, 0, 5258, 0, 0, 0, 5260, 0, 0, 0, 5262, 0, 0, 0, 5264, 0, 0, 0, 5266, 0, 0, 0, 5268, 0, 0, 0, 5270, 0, 0, 0, 5272, 0, 0, 0, 5274, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_BITBANGER=allocate([1144], ["%class.device_t.852* (%class.machine_config.802*, i8*, %class.device_t.852*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS16bitbanger_device=allocate([49,54,98,105,116,98,97,110,103,101,114,95,100,101,118,105,99,101,0] /* 16bitbanger_device\0 */, "i8", ALLOC_STATIC);
__ZTI16bitbanger_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str345417=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI16bitbanger_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7614, 0, 0, 0, 7616, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16bitbanger_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,98,105,116,98,97,110,103,101,114,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16bitbanger_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str355418=allocate([98,105,116,98,97,110,103,101,114,95,111,117,116,112,117,116,95,116,105,109,101,114,0] /* bitbanger_output_tim */, "i8", ALLOC_STATIC);
STRING_TABLE.__str365419=allocate([98,105,116,98,97,110,103,101,114,95,105,110,112,117,116,95,116,105,109,101,114,0] /* bitbanger_input_time */, "i8", ALLOC_STATIC);
STRING_TABLE.__str375420=allocate([77,105,115,99,111,110,102,105,103,117,114,101,100,32,98,105,116,98,97,110,103,101,114,32,100,101,118,105,99,101,58,32,105,110,112,117,116,95,99,97,108,108,98,97,99,107,32,99,97,110,110,111,116,32,98,101,32,78,85,76,76,10,0] /* Misconfigured bitban */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL27bitbanger_bytes_to_bits_81NP8device_tE7bitmask=allocate([1,2,4,8,16,32,64,128] /* \01\02\04\08\10 @\80 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str415424=allocate([66,105,116,98,97,110,103,101,114,58,32,79,117,116,112,117,116,32,102,114,97,109,105,110,103,32,101,114,114,111,114,46,10,0] /* Bitbanger: Output fr */, "i8", ALLOC_STATIC);
__ZZL20bitbanger_baud_valueP8device_tE5bauds=allocate([150, 0, 0, 0, 300, 0, 0, 0, 600, 0, 0, 0, 1200, 0, 0, 0, 2400, 0, 0, 0, 4800, 0, 0, 0, 9600, 0, 0, 0, 14400, 0, 0, 0, 28800, 0, 0, 0, 38400, 0, 0, 0, 57600, 0, 0, 0, 115200, 0, 0, 0], ["float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0], ALLOC_STATIC);
__ZZL20bitbanger_tune_valueP8device_tE5tunes=allocate([0.9700000286102295, 0, 0, 0, 0.9825000166893005, 0, 0, 0, 0.9850000143051147, 0, 0, 0, 0.987500011920929, 0, 0, 0, 0.9900000095367432, 0, 0, 0, 0.9925000071525574, 0, 0, 0, 0.9950000047683716, 0, 0, 0, 0.9975000023841858, 0, 0, 0, 1, 0, 0, 0, 1.002500057220459, 0, 0, 0, 1.0049999952316284, 0, 0, 0, 1.0075000524520874, 0, 0, 0, 1.0099999904632568, 0, 0, 0, 1.0125000476837158, 0, 0, 0, 1.0149999856948853, 0, 0, 0, 1.0175000429153442, 0, 0, 0, 1.0199999809265137, 0, 0, 0], ["float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0,"float",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str15427=allocate([115,114,99,47,101,109,117,47,109,97,99,104,105,110,101,47,108,100,99,111,114,101,46,99,0] /* src/emu/machine/ldco */, "i8", ALLOC_STATIC);
_LASERDISC=allocate([1158], ["%class.device_t.8652* (%class.machine_config.8587*, i8*, %class.device_t.8652*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str25430=allocate([85,110,107,110,111,119,110,32,76,97,115,101,114,100,105,115,99,32,80,108,97,121,101,114,0] /* Unknown Laserdisc Pl */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35431=allocate([117,110,107,108,100,112,108,97,121,0] /* unkldplay\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45432=allocate([76,97,115,101,114,100,105,115,99,32,80,108,97,121,101,114,0] /* Laserdisc Player\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55433=allocate([49,46,48,0] /* 1.0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65434=allocate([67,111,112,121,114,105,103,104,116,32,78,105,99,111,108,97,32,83,97,108,109,111,114,105,97,32,97,110,100,32,116,104,101,32,77,65,77,69,32,84,101,97,109,0] /* Copyright Nicola Sal */, "i8", ALLOC_STATIC);
__ZTV16laserdisc_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7618, 0, 0, 0, 7620, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 1732, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS16laserdisc_device=allocate([49,54,108,97,115,101,114,100,105,115,99,95,100,101,118,105,99,101,0] /* 16laserdisc_device\0 */, "i8", ALLOC_STATIC);
__ZTI16laserdisc_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str75435=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI16laserdisc_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7622, 0, 0, 0, 7624, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI16laserdisc_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,54,108,97,115,101,114,100,105,115,99,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI16laserdisc_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZL17player_interfaces=allocate(16, "*", ALLOC_STATIC);
STRING_TABLE.__str85436=allocate([78,111,32,105,110,116,101,114,102,97,99,101,32,102,111,117,110,100,32,102,111,114,32,108,97,115,101,114,100,105,115,99,32,112,108,97,121,101,114,32,116,121,112,101,32,37,100,10,0] /* No interface found f */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95437=allocate([108,97,115,101,114,100,105,115,99,0] /* laserdisc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105438=allocate([99,111,110,102,105,103,117,114,97,116,105,111,110,95,108,111,97,100,0] /* configuration_load\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115439=allocate([99,111,110,102,105,103,117,114,97,116,105,111,110,95,115,97,118,101,0] /* configuration_save\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125440=allocate([100,101,118,105,99,101,0] /* device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135441=allocate([116,97,103,0] /* tag\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145442=allocate([111,118,101,114,108,97,121,0] /* overlay\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155443=allocate([104,111,102,102,115,101,116,0] /* hoffset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165444=allocate([104,115,116,114,101,116,99,104,0] /* hstretch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175445=allocate([118,111,102,102,115,101,116,0] /* voffset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185446=allocate([118,115,116,114,101,116,99,104,0] /* vstretch\00 */, "i8", ALLOC_STATIC);
__str195447=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str205448=allocate([118,98,108,97,110,107,95,115,116,97,116,101,95,99,104,97,110,103,101,100,0] /* vblank_state_changed */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215449=allocate([79,117,116,32,111,102,32,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,110,103,32,118,105,100,101,111,32,116,101,120,116,117,114,101,0] /* Out of memory alloca */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225450=allocate([79,117,116,32,111,102,32,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,110,103,32,118,105,100,101,111,32,112,97,108,101,116,116,101,0] /* Out of memory alloca */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235451=allocate([79,117,116,32,111,102,32,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,110,103,32,111,118,101,114,108,97,121,32,116,101,120,116,117,114,101,0] /* Out of memory alloca */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245452=allocate([112,101,114,102,111,114,109,95,112,108,97,121,101,114,95,117,112,100,97,116,101,0] /* perform_player_updat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255453=allocate([76,97,115,101,114,100,105,115,99,32,118,105,100,101,111,32,109,117,115,116,32,98,101,32,99,111,109,112,114,101,115,115,101,100,32,119,105,116,104,32,116,104,101,32,65,47,86,32,99,111,100,101,99,33,0] /* Laserdisc video must */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265454=allocate([78,111,110,45,65,47,86,32,67,72,68,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,0] /* Non-A/V CHD file spe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str275455=allocate([70,80,83,58,37,100,46,37,48,54,100,32,87,73,68,84,72,58,37,100,32,72,69,73,71,72,84,58,37,100,32,73,78,84,69,82,76,65,67,69,68,58,37,100,32,67,72,65,78,78,69,76,83,58,37,100,32,83,65,77,80,76,69,82,65,84,69,58,37,100,0] /* FPS:%d.%06d WIDTH:%d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str285456=allocate([73,110,118,97,108,105,100,32,109,101,116,97,100,97,116,97,32,105,110,32,67,72,68,32,102,105,108,101,0] /* Invalid metadata in  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str295457=allocate([76,97,115,101,114,100,105,115,99,32,118,105,100,101,111,32,109,117,115,116,32,98,101,32,105,110,116,101,114,108,97,99,101,100,33,0] /* Laserdisc video must */, "i8", ALLOC_STATIC);
STRING_TABLE.__str305458=allocate([80,114,101,99,111,109,112,117,116,101,100,32,86,66,73,32,109,101,116,97,100,97,116,97,32,109,105,115,115,105,110,103,32,111,114,32,105,110,99,111,114,114,101,99,116,32,115,105,122,101,0] /* Precomputed VBI meta */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI12_ldcore_dataE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7626, 0, 0, 0, 7628, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI12_ldcore_dataE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,50,95,108,100,99,111,114,101,95,100,97,116,97,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI12_ldcore_dataE=allocate(12, "*", ALLOC_STATIC);
__ZL18flicker_correction=allocate(1, "float", ALLOC_STATIC);
__ZL7flicker=allocate(1, "i32", ALLOC_STATIC);
__ZL10beam_width=allocate(1, "float", ALLOC_STATIC);
STRING_TABLE.__str5479=allocate([119,98,0] /* wb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15480=allocate([82,73,70,70,0] /* RIFF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25481=allocate([87,65,86,69,0] /* WAVE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35482=allocate([102,109,116,32,0] /* fmt \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45483=allocate([100,97,116,97,0] /* data\00 */, "i8", ALLOC_STATIC);
__ZL12global_array=allocate(8000, ["*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZL5cheat=allocate(24, ["i8",0,0,0,"i64",0,0,0,"i32",0,0,0,"i8",0,0,0,"*",0,0,0,"i8","i8","i8",0], ALLOC_STATIC);
STRING_TABLE.__str5498=allocate([109,105,110,0] /* min\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15499=allocate([109,97,120,0] /* max\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25500=allocate([105,102,0] /* if\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35501=allocate([47,103,108,111,98,97,108,115,47,0] /* /globals/\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45502=allocate([46,37,115,0] /* .%s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55503=allocate([104,101,108,112,0] /* help\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65504=allocate([112,114,105,110,116,0] /* print\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75505=allocate([112,114,105,110,116,102,0] /* printf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85506=allocate([108,111,103,101,114,114,111,114,0] /* logerror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95507=allocate([116,114,97,99,101,108,111,103,0] /* tracelog\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105508=allocate([113,117,105,116,0] /* quit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115509=allocate([100,111,0] /* do\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125510=allocate([115,116,101,112,0] /* step\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135511=allocate([115,0] /* s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145512=allocate([111,118,101,114,0] /* over\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155513=allocate([111,0] /* o\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165514=allocate([111,117,116,0] /* out\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175515=allocate([103,111,0] /* go\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185516=allocate([103,0] /* g\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str195517=allocate([103,118,98,108,97,110,107,0] /* gvblank\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str205518=allocate([103,118,0] /* gv\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215519=allocate([103,105,110,116,0] /* gint\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225520=allocate([103,105,0] /* gi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235521=allocate([103,116,105,109,101,0] /* gtime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245522=allocate([103,116,0] /* gt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255523=allocate([110,101,120,116,0] /* next\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265524=allocate([110,0] /* n\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str275525=allocate([102,111,99,117,115,0] /* focus\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str285526=allocate([105,103,110,111,114,101,0] /* ignore\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str295527=allocate([111,98,115,101,114,118,101,0] /* observe\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str305528=allocate([99,111,109,97,100,100,0] /* comadd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str315529=allocate([47,47,0] /* //\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str325530=allocate([99,111,109,100,101,108,101,116,101,0] /* comdelete\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str335531=allocate([99,111,109,115,97,118,101,0] /* comsave\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str345532=allocate([98,112,115,101,116,0] /* bpset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str355533=allocate([98,112,0] /* bp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str365534=allocate([98,112,99,108,101,97,114,0] /* bpclear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str375535=allocate([98,112,100,105,115,97,98,108,101,0] /* bpdisable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str385536=allocate([98,112,101,110,97,98,108,101,0] /* bpenable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str395537=allocate([98,112,108,105,115,116,0] /* bplist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str405538=allocate([119,112,115,101,116,0] /* wpset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str415539=allocate([119,112,0] /* wp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str425540=allocate([119,112,100,115,101,116,0] /* wpdset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str435541=allocate([119,112,100,0] /* wpd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str445542=allocate([119,112,105,115,101,116,0] /* wpiset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str455543=allocate([119,112,105,0] /* wpi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str465544=allocate([119,112,99,108,101,97,114,0] /* wpclear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str475545=allocate([119,112,100,105,115,97,98,108,101,0] /* wpdisable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str485546=allocate([119,112,101,110,97,98,108,101,0] /* wpenable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str495547=allocate([119,112,108,105,115,116,0] /* wplist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str505548=allocate([104,111,116,115,112,111,116,0] /* hotspot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str515549=allocate([115,97,118,101,0] /* save\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str525550=allocate([115,97,118,101,100,0] /* saved\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str535551=allocate([115,97,118,101,105,0] /* savei\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str545552=allocate([108,111,97,100,0] /* load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str555553=allocate([108,111,97,100,100,0] /* loadd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str565554=allocate([108,111,97,100,105,0] /* loadi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str575555=allocate([100,117,109,112,0] /* dump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str585556=allocate([100,117,109,112,100,0] /* dumpd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str595557=allocate([100,117,109,112,105,0] /* dumpi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str605558=allocate([99,104,101,97,116,105,110,105,116,0] /* cheatinit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str615559=allocate([99,105,0] /* ci\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str625560=allocate([99,104,101,97,116,114,97,110,103,101,0] /* cheatrange\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str635561=allocate([99,114,0] /* cr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str645562=allocate([99,104,101,97,116,110,101,120,116,0] /* cheatnext\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str655563=allocate([99,110,0] /* cn\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str665564=allocate([99,104,101,97,116,110,101,120,116,102,0] /* cheatnextf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str675565=allocate([99,110,102,0] /* cnf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str685566=allocate([99,104,101,97,116,108,105,115,116,0] /* cheatlist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str695567=allocate([99,108,0] /* cl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str705568=allocate([99,104,101,97,116,117,110,100,111,0] /* cheatundo\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str715569=allocate([99,117,0] /* cu\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str725570=allocate([102,0] /* f\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str735571=allocate([102,105,110,100,0] /* find\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str745572=allocate([102,100,0] /* fd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str755573=allocate([102,105,110,100,100,0] /* findd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str765574=allocate([102,105,0] /* fi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str775575=allocate([102,105,110,100,105,0] /* findi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str785576=allocate([100,97,115,109,0] /* dasm\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str795577=allocate([116,114,97,99,101,0] /* trace\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str805578=allocate([116,114,97,99,101,111,118,101,114,0] /* traceover\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str815579=allocate([116,114,97,99,101,102,108,117,115,104,0] /* traceflush\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str825580=allocate([104,105,115,116,111,114,121,0] /* history\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str835581=allocate([115,110,97,112,0] /* snap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str845582=allocate([115,111,117,114,99,101,0] /* source\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str855583=allocate([109,97,112,0] /* map\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str865584=allocate([109,97,112,100,0] /* mapd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str875585=allocate([109,97,112,105,0] /* mapi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str885586=allocate([109,101,109,100,117,109,112,0] /* memdump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str895587=allocate([115,121,109,108,105,115,116,0] /* symlist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str905588=allocate([115,111,102,116,114,101,115,101,116,0] /* softreset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str915589=allocate([104,97,114,100,114,101,115,101,116,0] /* hardreset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str925590=allocate([105,109,97,103,101,115,0] /* images\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str935591=allocate([109,111,117,110,116,0] /* mount\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str945592=allocate([117,110,109,111,117,110,116,0] /* unmount\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str955593=allocate([100,101,98,117,103,95,99,111,109,109,97,110,100,95,101,120,105,116,0] /* debug_command_exit\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str965594=allocate([69,114,114,111,114,32,105,110,32,101,120,112,114,101,115,115,105,111,110,58,32,37,115,10,0] /* Error in expression: */, "i8", ALLOC_STATIC);
STRING_TABLE.__str975595=allocate([32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,37,42,115,94,0] /*                      */, "i8", ALLOC_STATIC);
__str985596=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str995597=allocate([37,115,10,0] /* %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1005598=allocate([78,111,32,118,97,108,105,100,32,67,80,85,32,105,115,32,99,117,114,114,101,110,116,108,121,32,115,101,108,101,99,116,101,100,10,0] /* No valid CPU is curr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1015599=allocate([85,110,97,98,108,101,32,116,111,32,102,105,110,100,32,67,80,85,32,39,37,115,39,10,0] /* Unable to find CPU ' */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1025600=allocate([73,110,118,97,108,105,100,32,67,80,85,32,105,110,100,101,120,32,37,100,10,0] /* Invalid CPU index %d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1035601=allocate([78,111,32,109,97,116,99,104,105,110,103,32,109,101,109,111,114,121,32,115,112,97,99,101,32,102,111,117,110,100,32,102,111,114,32,67,80,85,32,39,37,115,39,10,0] /* No matching memory s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1045602=allocate([85,110,109,111,117,110,116,101,100,32,102,105,108,101,32,102,114,111,109,32,58,32,37,115,10,0] /* Unmounted file from  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1055603=allocate([84,104,101,114,101,32,105,115,32,110,111,32,105,109,97,103,101,32,100,101,118,105,99,101,32,58,37,115,10,0] /* There is no image de */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1065604=allocate([85,110,97,98,108,101,32,116,111,32,109,111,117,110,116,32,102,105,108,101,32,37,115,32,111,110,32,37,115,10,0] /* Unable to mount file */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1075605=allocate([70,105,108,101,32,37,115,32,109,111,117,110,116,101,100,32,111,110,32,37,115,10,0] /* File %s mounted on % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1085606=allocate([37,115,58,32,37,115,10,0] /* %s: %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1095607=allocate([91,101,109,112,116,121,32,115,108,111,116,93,0] /* [empty slot]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1105608=allocate([78,111,32,105,109,97,103,101,32,100,101,118,105,99,101,115,32,105,110,32,116,104,105,115,32,100,114,105,118,101,114,10,0] /* No image devices in  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1115609=allocate([67,80,85,32,39,37,115,39,32,115,121,109,98,111,108,115,58,10,0] /* CPU '%s' symbols:\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1125610=allocate([71,108,111,98,97,108,32,115,121,109,98,111,108,115,58,10,0] /* Global symbols:\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1135611=allocate([37,115,32,61,32,37,115,0] /* %s = %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1145612=allocate([32,32,40,114,101,97,100,45,111,110,108,121,41,0] /*   (read-only)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1155613=allocate([10,0] /* \0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1165614=allocate([109,101,109,100,117,109,112,46,108,111,103,0] /* memdump.log\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1175615=allocate([68,117,109,112,105,110,103,32,109,101,109,111,114,121,32,116,111,32,37,115,10,0] /* Dumping memory to %s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1185616=allocate([119,0] /* w\00 */, "i8", ALLOC_STATIC);
__ZZL11execute_mapR15running_machineiiPPKcE8intnames=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1195617=allocate([82,101,97,100,0] /* Read\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1205618=allocate([87,114,105,116,101,0] /* Write\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1215619=allocate([70,101,116,99,104,0] /* Fetch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1225620=allocate([37,55,115,58,32,37,115,32,108,111,103,105,99,97,108,32,61,61,32,37,115,32,112,104,121,115,105,99,97,108,32,45,62,32,37,115,10,0] /* %7s: %s logical == % */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1235621=allocate([37,55,115,58,32,37,115,32,108,111,103,105,99,97,108,32,105,115,32,117,110,109,97,112,112,101,100,10,0] /* %7s: %s logical is u */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1245622=allocate([83,97,118,101,100,32,115,110,97,112,115,104,111,116,10,0] /* Saved snapshot\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1255623=allocate([73,110,118,97,108,105,100,32,115,99,114,101,101,110,32,110,117,109,98,101,114,32,39,37,100,39,10,0] /* Invalid screen numbe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1265624=allocate([46,112,110,103,0] /* .png\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1275625=allocate([69,114,114,111,114,32,99,114,101,97,116,105,110,103,32,102,105,108,101,32,39,37,115,39,10,0] /* Error creating file  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1285626=allocate([83,97,118,101,100,32,115,99,114,101,101,110,32,35,37,100,32,115,110,97,112,115,104,111,116,32,97,115,32,39,37,115,39,10,0] /* Saved screen #%d sna */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1305628=allocate([111,102,102,0] /* off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1315629=allocate([97,0] /* a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1325630=allocate([69,114,114,111,114,32,111,112,101,110,105,110,103,32,102,105,108,101,32,39,37,115,39,10,0] /* Error opening file ' */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1335631=allocate([84,114,97,99,105,110,103,32,67,80,85,32,39,37,115,39,32,116,111,32,102,105,108,101,32,37,115,10,0] /* Tracing CPU '%s' to  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1345632=allocate([83,116,111,112,112,101,100,32,116,114,97,99,105,110,103,32,111,110,32,67,80,85,32,39,37,115,39,10,0] /* Stopped tracing on C */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1355633=allocate([69,114,114,111,114,32,105,110,32,99,111,109,109,97,110,100,58,32,37,115,10,0] /* Error in command: %s */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1365634=allocate([32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,37,42,115,94,0] /*                   %_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1375635=allocate([37,115,58,32,0] /* %s: \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1385636=allocate([37,115,32,0] /* %s \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1395637=allocate([37,42,115,0] /* %_s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1405638=allocate([32,32,0] /*   \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1415639=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1425640=allocate([47,47,32,37,115,0] /* // %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1435641=allocate([9,47,47,32,37,115,0] /* \09// %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1445642=allocate([68,97,116,97,32,100,117,109,112,101,100,32,115,117,99,99,101,115,115,102,117,108,108,121,10,0] /* Data dumped successf */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1455643=allocate([63,0] /* ?\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1465644=allocate([70,111,117,110,100,32,97,116,32,37,115,10,0] /* Found at %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1475645=allocate([78,111,116,32,102,111,117,110,100,10,0] /* Not found\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1485646=allocate([37,117,32,99,104,101,97,116,32,114,101,97,99,116,105,118,97,116,101,100,10,0] /* %u cheat reactivated */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1495647=allocate([77,97,120,105,109,117,109,32,117,110,100,111,32,114,101,97,99,104,101,100,10,0] /* Maximum undo reached */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1505648=allocate([32,32,60,99,104,101,97,116,32,100,101,115,99,61,34,80,111,115,115,105,98,105,108,105,116,121,32,37,100,32,58,32,37,115,32,40,37,115,41,34,62,10,0] /*   <cheat desc=\22Pos */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1515649=allocate([32,32,32,32,60,115,99,114,105,112,116,32,115,116,97,116,101,61,34,114,117,110,34,62,10,0] /*     <script state=\2 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1525650=allocate([32,32,32,32,32,32,60,97,99,116,105,111,110,62,37,115,46,112,37,99,37,99,64,37,115,61,37,115,60,47,97,99,116,105,111,110,62,10,0] /*       <action>%s.p%c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1535651=allocate([32,32,32,32,60,47,115,99,114,105,112,116,62,10,0] /*     </script>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1545652=allocate([32,32,60,47,99,104,101,97,116,62,10,10,0] /*   </cheat>\0A\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1555653=allocate([65,100,100,114,101,115,115,61,37,115,32,83,116,97,114,116,61,37,115,32,67,117,114,114,101,110,116,61,37,115,10,0] /* Address=%s Start=%s  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1565654=allocate([85,115,101,32,99,104,101,97,116,105,110,105,116,32,98,101,102,111,114,101,32,99,104,101,97,116,110,101,120,116,10,0] /* Use cheatinit before */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1575655=allocate([97,108,108,0] /* all\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1585656=allocate([101,113,117,97,108,0] /* equal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1595657=allocate([101,113,0] /* eq\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1605658=allocate([110,111,116,101,113,117,97,108,0] /* notequal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1615659=allocate([110,101,0] /* ne\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1625660=allocate([100,101,99,114,101,97,115,101,0] /* decrease\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1635661=allocate([100,101,0] /* de\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1645662=allocate([45,0] /* -\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1655663=allocate([105,110,99,114,101,97,115,101,0] /* increase\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1665664=allocate([105,110,0] /* in\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1675665=allocate([43,0] /* +\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1685666=allocate([100,101,99,114,101,97,115,101,111,114,101,113,117,97,108,0] /* decreaseorequal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1695667=allocate([100,101,101,113,0] /* deeq\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1705668=allocate([105,110,99,114,101,97,115,101,111,114,101,113,117,97,108,0] /* increaseorequal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1715669=allocate([105,110,101,113,0] /* ineq\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1725670=allocate([115,109,97,108,108,101,114,111,102,0] /* smallerof\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1735671=allocate([108,116,0] /* lt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1745672=allocate([60,0] /* <\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1755673=allocate([103,114,101,97,116,101,114,111,102,0] /* greaterof\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1765674=allocate([62,0] /* >\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1775675=allocate([99,104,97,110,103,101,100,98,121,0] /* changedby\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1785676=allocate([99,104,0] /* ch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1795677=allocate([126,0] /* ~\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1805678=allocate([73,110,118,97,108,105,100,32,99,111,110,100,105,116,105,111,110,32,116,121,112,101,10,0] /* Invalid condition ty */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1815679=allocate([37,117,32,99,104,101,97,116,115,32,102,111,117,110,100,10,0] /* %u cheats found\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1825680=allocate([73,110,118,97,108,105,100,32,115,105,103,110,58,32,101,120,112,101,99,116,101,100,32,115,32,111,114,32,117,10,0] /* Invalid sign: expect */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1835681=allocate([73,110,118,97,108,105,100,32,119,105,100,116,104,58,32,101,120,112,101,99,116,101,100,32,98,44,32,119,44,32,100,32,111,114,32,113,10,0] /* Invalid width: expec */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1845682=allocate([78,111,32,119,114,105,116,97,98,108,101,32,98,121,116,101,115,32,102,111,117,110,100,32,105,110,32,116,104,105,115,32,97,114,101,97,10,0] /* No writable bytes fo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1855683=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,101,98,117,103,99,109,100,46,99,0] /* src/emu/debug/debugc */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1865684=allocate([85,115,101,32,99,104,101,97,116,105,110,105,116,32,98,101,102,111,114,101,32,99,104,101,97,116,114,97,110,103,101,10,0] /* Use cheatinit before */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1875685=allocate([37,117,32,99,104,101,97,116,32,105,110,105,116,105,97,108,105,122,101,100,10,0] /* %u cheat initialized */, "i8", ALLOC_STATIC);
__ZTV19resource_pool_arrayI10_cheat_mapE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7630, 0, 0, 0, 7632, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI10_cheat_mapE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,49,48,95,99,104,101,97,116,95,109,97,112,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI10_cheat_mapE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str1885686=allocate([73,110,118,97,108,105,100,32,119,105,100,116,104,33,32,40,109,117,115,116,32,98,101,32,49,44,50,44,52,32,111,114,32,56,41,10,0] /* Invalid width! (must */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1895687=allocate([32,37,115,0] /*  %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1905688=allocate([32,37,46,42,115,0] /*  %._s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1915689=allocate([42,42,42,42,42,42,42,42,42,42,42,42,42,42,42,42,0] /* ________________\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1925690=allocate([32,37,42,115,0] /*  %_s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1935691=allocate([37,99,0] /* %c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1945692=allocate([32,0] /*  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1955693=allocate([114,98,0] /* rb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1965694=allocate([76,101,110,103,116,104,32,115,112,101,99,105,102,105,101,100,32,116,111,111,32,108,97,114,103,101,44,32,108,111,97,100,32,102,97,105,108,101,100,10,0] /* Length specified too */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1975695=allocate([68,97,116,97,32,108,111,97,100,101,100,32,115,117,99,99,101,115,115,102,117,108,108,121,32,116,111,32,109,101,109,111,114,121,32,58,32,48,120,37,115,32,116,111,32,48,120,37,115,10,0] /* Data loaded successf */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1985696=allocate([119,98,0] /* wb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1995697=allocate([68,97,116,97,32,115,97,118,101,100,32,115,117,99,99,101,115,115,102,117,108,108,121,10,0] /* Data saved successfu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2005698=allocate([67,108,101,97,114,101,100,32,104,111,116,115,112,111,116,32,116,114,97,99,107,105,110,103,32,111,110,32,67,80,85,32,39,37,115,39,10,0] /* Cleared hotspot trac */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2015699=allocate([78,111,119,32,116,114,97,99,107,105,110,103,32,104,111,116,115,112,111,116,115,32,111,110,32,67,80,85,32,39,37,115,39,32,117,115,105,110,103,32,37,100,32,115,108,111,116,115,32,119,105,116,104,32,97,32,116,104,114,101,115,104,104,111,108,100,32,111,102,32,37,100,10,0] /* Now tracking hotspot */, "i8", ALLOC_STATIC);
__ZZL14execute_wplistR15running_machineiiPPKcE5types=allocate(16, "*", ALLOC_STATIC);
STRING_TABLE.__str2025700=allocate([117,110,107,110,32,0] /* unkn \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2035701=allocate([114,101,97,100,32,0] /* read \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2045702=allocate([119,114,105,116,101,0] /* write\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2055703=allocate([114,47,119,32,32,0] /* r/w  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2065704=allocate([68,101,118,105,99,101,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,119,97,116,99,104,112,111,105,110,116,115,58,10,0] /* Device '%s' %s space */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2075705=allocate([37,99,37,52,88,32,64,32,37,115,45,37,115,32,37,115,0] /* %c%4X @ %s-%s %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2085706=allocate([32,105,102,32,37,115,0] /*  if %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2095707=allocate([32,100,111,32,37,115,0] /*  do %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2105708=allocate([78,111,32,119,97,116,99,104,112,111,105,110,116,115,32,99,117,114,114,101,110,116,108,121,32,105,110,115,116,97,108,108,101,100,10,0] /* No watchpoints curre */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2115709=allocate([68,105,115,97,98,108,101,100,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,10,0] /* Disabled all watchpo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2125710=allocate([69,110,97,98,108,101,100,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,10,0] /* Enabled all watchpoi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2135711=allocate([87,97,116,99,104,112,111,105,110,116,32,37,88,32,37,115,10,0] /* Watchpoint %X %s\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2145712=allocate([101,110,97,98,108,101,100,0] /* enabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2155713=allocate([100,105,115,97,98,108,101,100,0] /* disabled\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2165714=allocate([73,110,118,97,108,105,100,32,119,97,116,99,104,112,111,105,110,116,32,110,117,109,98,101,114,32,37,88,10,0] /* Invalid watchpoint n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2175715=allocate([67,108,101,97,114,101,100,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,10,0] /* Cleared all watchpoi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2185716=allocate([87,97,116,99,104,112,111,105,110,116,32,37,88,32,99,108,101,97,114,101,100,10,0] /* Watchpoint %X cleare */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2195717=allocate([114,0] /* r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2205718=allocate([114,119,0] /* rw\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2215719=allocate([119,114,0] /* wr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2225720=allocate([73,110,118,97,108,105,100,32,119,97,116,99,104,112,111,105,110,116,32,116,121,112,101,58,32,101,120,112,101,99,116,101,100,32,114,44,32,119,44,32,111,114,32,114,119,10,0] /* Invalid watchpoint t */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2235721=allocate([87,97,116,99,104,112,111,105,110,116,32,37,88,32,115,101,116,10,0] /* Watchpoint %X set\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2245722=allocate([68,101,118,105,99,101,32,39,37,115,39,32,98,114,101,97,107,112,111,105,110,116,115,58,10,0] /* Device '%s' breakpoi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2255723=allocate([37,99,37,52,88,32,64,32,37,115,0] /* %c%4X @ %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2265724=allocate([78,111,32,98,114,101,97,107,112,111,105,110,116,115,32,99,117,114,114,101,110,116,108,121,32,105,110,115,116,97,108,108,101,100,10,0] /* No breakpoints curre */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2275725=allocate([68,105,115,97,98,108,101,100,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,10,0] /* Disabled all breakpo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2285726=allocate([69,110,97,98,108,101,100,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,10,0] /* Enabled all breakpoi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2295727=allocate([66,114,101,97,107,112,111,105,110,116,32,37,88,32,37,115,10,0] /* Breakpoint %X %s\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2305728=allocate([73,110,118,97,108,105,100,32,98,114,101,97,107,112,111,105,110,116,32,110,117,109,98,101,114,32,37,88,10,0] /* Invalid breakpoint n */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2315729=allocate([67,108,101,97,114,101,100,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,10,0] /* Cleared all breakpoi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2325730=allocate([66,114,101,97,107,112,111,105,110,116,32,37,88,32,99,108,101,97,114,101,100,10,0] /* Breakpoint %X cleare */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2335731=allocate([66,114,101,97,107,112,111,105,110,116,32,37,88,32,115,101,116,10,0] /* Breakpoint %X set\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2345732=allocate([67,111,109,109,101,110,116,115,32,115,117,99,99,101,115,115,102,117,108,108,121,32,115,97,118,101,100,10,0] /* Comments successfull */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2355733=allocate([69,114,114,111,114,32,58,32,99,111,109,109,101,110,116,32,116,101,120,116,32,101,109,112,116,121,10,0] /* Error : comment text */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2365734=allocate([67,117,114,114,101,110,116,108,121,32,111,98,115,101,114,118,105,110,103,32,67,80,85,32,39,37,115,39,0] /* Currently observing  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2375735=allocate([44,32,39,37,115,39,0] /* , '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2385736=allocate([78,111,116,32,99,117,114,114,101,110,116,108,121,32,111,98,115,101,114,118,105,110,103,32,97,110,121,32,100,101,118,105,99,101,115,0] /* Not currently observ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2395737=allocate([78,111,119,32,111,98,115,101,114,118,105,110,103,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* Now observing device */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2405738=allocate([67,117,114,114,101,110,116,108,121,32,105,103,110,111,114,105,110,103,32,100,101,118,105,99,101,32,39,37,115,39,0] /* Currently ignoring d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2415739=allocate([78,111,116,32,99,117,114,114,101,110,116,108,121,32,105,103,110,111,114,105,110,103,32,97,110,121,32,100,101,118,105,99,101,115,0] /* Not currently ignori */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2425740=allocate([67,97,110,39,116,32,105,103,110,111,114,101,32,97,108,108,32,100,101,118,105,99,101,115,33,10,0] /* Can't ignore all dev */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2435741=allocate([78,111,119,32,105,103,110,111,114,105,110,103,32,100,101,118,105,99,101,32,39,37,115,39,10,0] /* Now ignoring device  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2445742=allocate([78,111,119,32,102,111,99,117,115,101,100,32,111,110,32,67,80,85,32,39,37,115,39,10,0] /* Now focused on CPU ' */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2455743=allocate([69,120,105,116,101,100,32,118,105,97,32,116,104,101,32,100,101,98,117,103,103,101,114,10,0] /* Exited via the debug */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2465744=allocate([78,111,116,32,101,110,111,117,103,104,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,102,111,114,109,97,116,33,10,0] /* Not enough parameter */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2475745=allocate([37,48,42,88,0] /* %0_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2485746=allocate([37,42,88,0] /* %_X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2495747=allocate([37,48,42,100,0] /* %0_d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2505748=allocate([37,42,100,0] /* %_d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2515749=allocate([100,101,98,117,103,115,99,114,105,112,116,0] /* debugscript\00 */, "i8", ALLOC_STATIC);
__str5754=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str15755=allocate([37,48,52,100,47,37,48,52,100,0] /* %04d/%04d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25756=allocate([68,101,118,105,99,101,32,77,111,100,101,58,0] /* Device Mode:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35757=allocate([66,97,117,100,58,0] /* Baud:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45758=allocate([66,97,117,100,32,84,117,110,101,58,0] /* Baud Tune:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55759=allocate([80,114,111,116,111,99,111,108,58,0] /* Protocol:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65760=allocate([56,45,49,45,78,0] /* 8-1-N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75761=allocate([78,111,32,66,105,116,98,97,110,103,101,114,32,73,109,97,103,101,32,108,111,97,100,101,100,0] /* No Bitbanger Image l */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85762=allocate([115,116,111,112,112,101,100,0] /* stopped\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95763=allocate([112,108,97,121,105,110,103,0] /* playing\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105764=allocate([40,112,108,97,121,105,110,103,41,0] /* (playing)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115765=allocate([114,101,99,111,114,100,105,110,103,0] /* recording\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125766=allocate([40,114,101,99,111,114,100,105,110,103,41,0] /* (recording)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135767=allocate([80,97,117,115,101,47,83,116,111,112,0] /* Pause/Stop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145768=allocate([80,108,97,121,0] /* Play\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155769=allocate([82,101,99,111,114,100,0] /* Record\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165770=allocate([82,101,119,105,110,100,0] /* Rewind\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175771=allocate([70,97,115,116,32,70,111,114,119,97,114,100,0] /* Fast Forward\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185772=allocate([78,111,32,84,97,112,101,32,73,109,97,103,101,32,108,111,97,100,101,100,0] /* No Tape Image loaded */, "i8", ALLOC_STATIC);
STRING_TABLE.__str195773=allocate([69,114,114,111,114,32,97,99,99,101,115,115,105,110,103,32,37,115,0] /* Error accessing %s\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str205774=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL22is_valid_filename_charjE19valid_filename_char=allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0] /* \00\00\00\00\00\00\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215775=allocate([115,114,99,47,101,109,117,47,117,105,105,109,97,103,101,46,99,0] /* src/emu/uiimage.c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225776=allocate([67,97,110,110,111,116,32,115,97,118,101,32,111,118,101,114,32,100,105,114,101,99,116,111,114,121,0] /* Cannot save over dir */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235777=allocate([85,110,101,120,112,101,99,116,101,100,0] /* Unexpected\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245778=allocate([69,114,114,111,114,58,32,37,115,0] /* Error: %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255779=allocate([70,105,108,101,32,65,108,114,101,97,100,121,32,69,120,105,115,116,115,32,45,32,79,118,101,114,105,100,101,63,0] /* File Already Exists  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265780=allocate([45,45,45,0] /* ---\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str275781=allocate([78,111,0] /* No\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str285782=allocate([89,101,115,0] /* Yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str295783=allocate([95,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str305784=allocate([78,101,119,32,73,109,97,103,101,32,78,97,109,101,58,0] /* New Image Name:\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str315785=allocate([67,114,101,97,116,101,0] /* Create\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str325786=allocate([46,46,0] /* ..\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str335787=allocate([91,101,109,112,116,121,32,115,108,111,116,93,0] /* [empty slot]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str345788=allocate([91,99,114,101,97,116,101,93,0] /* [create]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str355789=allocate([91,115,111,102,116,119,97,114,101,32,108,105,115,116,93,0] /* [software list]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str365790=allocate([91,68,82,73,86,69,93,0] /* [DRIVE]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str375791=allocate([91,68,73,82,93,0] /* [DIR]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str385792=allocate([91,70,73,76,69,93,0] /* [FILE]\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str395793=allocate([37,115,32,40,37,115,41,0] /* %s (%s)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str405794=allocate([32,40,0] /*  (\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str415795=allocate([112,97,114,116,95,105,100,0] /* part_id\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str425796=allocate([58,32,0] /* : \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str435797=allocate([41,0] /* )\00 */, "i8", ALLOC_STATIC);
__ZTV18debug_view_textbuf=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7634, 0, 0, 0, 7636, 0, 0, 0, 7638, 0, 0, 0, 7640, 0, 0, 0, 7448, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV18debug_view_console=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7642, 0, 0, 0, 7644, 0, 0, 0, 7638, 0, 0, 0, 7640, 0, 0, 0, 7448, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV14debug_view_log=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7646, 0, 0, 0, 7648, 0, 0, 0, 7638, 0, 0, 0, 7640, 0, 0, 0, 7448, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS18debug_view_textbuf=allocate([49,56,100,101,98,117,103,95,118,105,101,119,95,116,101,120,116,98,117,102,0] /* 18debug_view_textbuf */, "i8", ALLOC_STATIC);
__ZTI18debug_view_textbuf=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS14debug_view_log=allocate([49,52,100,101,98,117,103,95,118,105,101,119,95,108,111,103,0] /* 14debug_view_log\00 */, "i8", ALLOC_STATIC);
__ZTI14debug_view_log=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS18debug_view_console=allocate([49,56,100,101,98,117,103,95,118,105,101,119,95,99,111,110,115,111,108,101,0] /* 18debug_view_console */, "i8", ALLOC_STATIC);
__ZTI18debug_view_console=allocate(12, "*", ALLOC_STATIC);
__ZTV23debug_view_state_source=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7650, 0, 0, 0, 7652, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV16debug_view_state=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7654, 0, 0, 0, 7656, 0, 0, 0, 7658, 0, 0, 0, 7660, 0, 0, 0, 7448, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str5812=allocate([37,115,32,39,37,115,39,0] /* %s '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15813=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,118,115,116,97,116,101,46,99,0] /* src/emu/debug/dvstat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25814=allocate([99,121,99,108,101,115,0] /* cycles\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35815=allocate([98,101,97,109,120,0] /* beamx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45816=allocate([98,101,97,109,121,0] /* beamy\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55817=allocate([102,114,97,109,101,0] /* frame\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65818=allocate([102,108,97,103,115,0] /* flags\00 */, "i8", ALLOC_STATIC);
__str75819=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str85820=allocate([45,0] /* -\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95821=allocate([37,45,56,100,0] /* %-8d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105822=allocate([37,52,100,0] /* %4d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115823=allocate([37,54,100,0] /* %6d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS16debug_view_state=allocate([49,54,100,101,98,117,103,95,118,105,101,119,95,115,116,97,116,101,0] /* 16debug_view_state\0 */, "i8", ALLOC_STATIC);
__ZTI16debug_view_state=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS23debug_view_state_source=allocate([50,51,100,101,98,117,103,95,118,105,101,119,95,115,116,97,116,101,95,115,111,117,114,99,101,0] /* 23debug_view_state_s */, "i8", ALLOC_STATIC);
__ZTI23debug_view_state_source=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectIN16debug_view_state10state_itemEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7662, 0, 0, 0, 7664, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectIN16debug_view_state10state_itemEE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,78,49,54,100,101,98,117,103,95,118,105,101,119,95,115,116,97,116,101,49,48,115,116,97,116,101,95,105,116,101,109,69,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectIN16debug_view_state10state_itemEE=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI23debug_view_state_sourceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7666, 0, 0, 0, 7668, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI23debug_view_state_sourceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,51,100,101,98,117,103,95,118,105,101,119,95,115,116,97,116,101,95,115,111,117,114,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI23debug_view_state_sourceE=allocate(12, "*", ALLOC_STATIC);
__ZTV24debug_view_disasm_source=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7670, 0, 0, 0, 7672, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV17debug_view_disasm=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7674, 0, 0, 0, 7676, 0, 0, 0, 7678, 0, 0, 0, 7680, 0, 0, 0, 7682, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str5826=allocate([37,115,32,39,37,115,39,0] /* %s '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15827=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,118,100,105,115,97,115,109,46,99,0] /* src/emu/debug/dvdisa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25828=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35829=allocate([32,37,115,0] /*  %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45830=allocate([32,37,115,32,32,0] /*  %s  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55831=allocate([60,117,110,109,97,112,112,101,100,62,0] /* <unmapped>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65832=allocate([37,45,42,115,32,32,0] /* %-_s  \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75833=allocate([47,47,32,37,46,42,115,0] /* // %._s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS17debug_view_disasm=allocate([49,55,100,101,98,117,103,95,118,105,101,119,95,100,105,115,97,115,109,0] /* 17debug_view_disasm\ */, "i8", ALLOC_STATIC);
__ZTI17debug_view_disasm=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS24debug_view_disasm_source=allocate([50,52,100,101,98,117,103,95,118,105,101,119,95,100,105,115,97,115,109,95,115,111,117,114,99,101,0] /* 24debug_view_disasm_ */, "i8", ALLOC_STATIC);
__ZTI24debug_view_disasm_source=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI24debug_view_disasm_sourceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7684, 0, 0, 0, 7686, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI24debug_view_disasm_sourceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,52,100,101,98,117,103,95,118,105,101,119,95,100,105,115,97,115,109,95,115,111,117,114,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI24debug_view_disasm_sourceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str85834=allocate([68,101,118,105,99,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,115,116,97,116,101,32,105,110,116,101,114,102,97,99,101,0] /* Device '%s' does not */, "i8", ALLOC_STATIC);
__ZN17debug_view_memory18s_memory_pos_tableE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 4, 0, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 140, 12, 8, 4, 0, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 156, 156, 28, 24, 20, 16, 12, 8, 4, 0, 128, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 188, 188, 188, 188, 60, 56, 52, 48, 44, 40, 36, 32, 28, 24, 20, 16, 12, 8, 4, 0, 128, 128, 128, 128], "i8", ALLOC_STATIC);
__ZTV24debug_view_memory_source=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7688, 0, 0, 0, 7690, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTV17debug_view_memory=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7692, 0, 0, 0, 7694, 0, 0, 0, 7696, 0, 0, 0, 7698, 0, 0, 0, 7700, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str5843=allocate([37,115,32,39,37,115,39,32,37,115,32,115,112,97,99,101,32,109,101,109,111,114,121,0] /* %s '%s' %s space mem */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15844=allocate([115,114,99,47,101,109,117,47,100,101,98,117,103,47,100,118,109,101,109,111,114,121,46,99,0] /* src/emu/debug/dvmemo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25845=allocate([82,101,103,105,111,110,32,39,37,115,39,0] /* Region '%s'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35846=allocate([103,108,111,98,97,108,115,47,0] /* globals/\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45847=allocate([48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0] /* 0123456789ABCDEF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZN17debug_view_memory9view_charEiE7hexvals=allocate([48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0] /* 0123456789abcdef\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55848=allocate([37,88,0] /* %X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65849=allocate([37,42,115,37,37,48,37,100,88,0] /* %_s%%0%dX\00 */, "i8", ALLOC_STATIC);
__str75850=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str85851=allocate([37,37,48,37,100,88,37,42,115,0] /* %%0%dX%_s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS17debug_view_memory=allocate([49,55,100,101,98,117,103,95,118,105,101,119,95,109,101,109,111,114,121,0] /* 17debug_view_memory\ */, "i8", ALLOC_STATIC);
__ZTI17debug_view_memory=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS24debug_view_memory_source=allocate([50,52,100,101,98,117,103,95,118,105,101,119,95,109,101,109,111,114,121,95,115,111,117,114,99,101,0] /* 24debug_view_memory_ */, "i8", ALLOC_STATIC);
__ZTI24debug_view_memory_source=allocate(12, "*", ALLOC_STATIC);
__ZTV20resource_pool_objectI24debug_view_memory_sourceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7702, 0, 0, 0, 7704, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI24debug_view_memory_sourceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,50,52,100,101,98,117,103,95,118,105,101,119,95,109,101,109,111,114,121,95,115,111,117,114,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI24debug_view_memory_sourceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str5856=allocate([112,112,105,48,95,112,111,114,116,98,95,114,0] /* ppi0_portb_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15857=allocate([112,112,105,48,95,112,111,114,116,99,95,114,0] /* ppi0_portc_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25858=allocate([112,112,105,48,95,112,111,114,116,97,95,119,0] /* ppi0_porta_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35859=allocate([112,112,105,48,95,112,111,114,116,99,95,119,0] /* ppi0_portc_w\00 */, "i8", ALLOC_STATIC);
__ZL8ppi0intf=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7706, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7708, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7710, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7712, 0, 0, 0, 0, 0, 0, 0], ["i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str45860=allocate([112,112,105,49,95,112,111,114,116,97,95,114,0] /* ppi1_porta_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55861=allocate([112,112,105,49,95,112,111,114,116,98,95,119,0] /* ppi1_portb_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65862=allocate([112,112,105,49,95,112,111,114,116,99,95,119,0] /* ppi1_portc_w\00 */, "i8", ALLOC_STATIC);
__ZL8ppi1intf=allocate([2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7714, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7716, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7718, 0, 0, 0, 0, 0, 0, 0], ["i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str75863=allocate([99,116,99,95,105,110,116,101,114,114,117,112,116,0] /* ctc_interrupt\00 */, "i8", ALLOC_STATIC);
__ZL7ctcintf=allocate([0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7720, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["i8",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i16",0,"i16",0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str85864=allocate([108,100,118,99,116,99,0] /* ldvctc\00 */, "i8", ALLOC_STATIC);
__ZL11daisy_chain=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str95865=allocate([108,100,118,49,48,48,48,0] /* ldv1000\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105866=allocate([122,48,51,95,49,48,48,49,95,118,121,119,45,48,53,51,95,118,49,45,48,46,98,105,110,0] /* z03_1001_vyw-053_v1- */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115867=allocate([82,51,49,101,99,52,54,56,55,83,53,50,102,57,49,99,51,48,52,97,56,55,56,98,97,48,50,98,50,102,97,49,99,100,97,49,97,57,52,56,57,100,54,100,100,53,97,51,52,102,0] /* R31ec4687S52f91c304a */, "i8", ALLOC_STATIC);
__ZL11rom_ldv1000=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 32769, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str125868=allocate([80,105,111,110,101,101,114,32,76,68,45,86,49,48,48,48,0] /* Pioneer LD-V1000\00 */, "i8", ALLOC_STATIC);
_ldv1000_interface=allocate([4, 0, 0, 0, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7722, 0, 0, 0, 7724, 0, 0, 0, 7726, 0, 0, 0, 7728, 0, 0, 0, 0, 0, 0, 0, 7730, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7732, 0, 0, 0, 0, 0, 0, 0, 7734, 0, 0, 0, 7736, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str145872=allocate([118,115,121,110,99,95,111,102,102,0] /* vsync_off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155873=allocate([118,98,105,95,100,97,116,97,95,102,101,116,99,104,0] /* vbi_data_fetch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165874=allocate([109,117,108,116,105,116,105,109,101,114,0] /* multitimer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175875=allocate([108,100,118,112,112,105,48,0] /* ldvppi0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185876=allocate([108,100,118,112,112,105,49,0] /* ldvppi1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str195877=allocate([100,101,99,111,100,101,114,95,100,105,115,112,108,97,121,95,112,111,114,116,95,114,0] /* decoder_display_port */, "i8", ALLOC_STATIC);
STRING_TABLE.__str205878=allocate([100,101,99,111,100,101,114,95,100,105,115,112,108,97,121,95,112,111,114,116,95,119,0] /* decoder_display_port */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215879=allocate([99,111,110,116,114,111,108,108,101,114,95,114,0] /* controller_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225880=allocate([99,111,110,116,114,111,108,108,101,114,95,119,0] /* controller_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235881=allocate([122,56,48,99,116,99,95,114,0] /* z80ctc_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245882=allocate([122,56,48,99,116,99,95,119,0] /* z80ctc_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255883=allocate([112,112,105,56,50,53,53,95,114,0] /* ppi8255_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265884=allocate([112,112,105,56,50,53,53,95,119,0] /* ppi8255_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str5885=allocate([58,0] /* :\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15886=allocate([83,119,105,116,99,104,101,100,32,79,114,100,101,114,58,32,101,110,116,114,105,101,115,32,110,111,119,32,111,114,100,101,114,101,100,32,98,121,32,37,115,0] /* Switched Order: entr */, "i8", ALLOC_STATIC);
STRING_TABLE.__str25887=allocate([115,104,111,114,116,110,97,109,101,0] /* shortname\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str35888=allocate([100,101,115,99,114,105,112,116,105,111,110,0] /* description\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45889=allocate([78,111,32,109,97,116,99,104,105,110,103,32,100,101,118,105,99,101,32,102,111,117,110,100,32,102,111,114,32,105,110,116,101,114,102,97,99,101,32,39,37,115,39,33,0] /* No matching device f */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55890=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65891=allocate([42,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75892=allocate([91,99,111,109,112,97,116,105,98,108,101,32,108,105,115,116,115,93,0] /* [compatible lists]\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85893=allocate([83,119,105,116,99,104,32,73,116,101,109,32,79,114,100,101,114,105,110,103,0] /* Switch Item Ordering */, "i8", ALLOC_STATIC);
__str95894=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str105895=allocate([112,97,114,116,95,105,100,0] /* part_id\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115896=allocate([32,40,0] /*  (\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125897=allocate([41,0] /* )\00 */, "i8", ALLOC_STATIC);
__ZZ14debug_get_helpPKcE13ambig_message=allocate(1024, "i8", ALLOC_STATIC);
__ZL16static_help_list=allocate(520, "*", ALLOC_STATIC);
STRING_TABLE.__str5900=allocate([65,109,98,105,103,117,111,117,115,32,104,101,108,112,32,114,101,113,117,101,115,116,44,32,100,105,100,32,121,111,117,32,109,101,97,110,58,10,0] /* Ambiguous help reque */, "i8", ALLOC_STATIC);
STRING_TABLE.__str15901=allocate([32,32,104,101,108,112,32,37,115,63,10,0] /*   help %s?\0A\00 */, "i8", ALLOC_STATIC);
__str25902=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str35903=allocate([10,77,65,77,69,32,68,101,98,117,103,103,101,114,32,72,101,108,112,10,32,32,104,101,108,112,32,91,60,116,111,112,105,99,62,93,32,45,45,32,103,101,116,32,104,101,108,112,32,111,110,32,97,32,112,97,114,116,105,99,117,108,97,114,32,116,111,112,105,99,10,10,84,111,112,105,99,115,58,10,32,32,71,101,110,101,114,97,108,10,32,32,77,101,109,111,114,121,10,32,32,69,120,101,99,117,116,105,111,110,10,32,32,66,114,101,97,107,112,111,105,110,116,115,10,32,32,87,97,116,99,104,112,111,105,110,116,115,10,32,32,69,120,112,114,101,115,115,105,111,110,115,10,32,32,67,111,109,109,101,110,116,115,10,32,32,67,104,101,97,116,115,10,32,32,73,109,97,103,101,10,0] /* \0AMAME Debugger Hel */, "i8", ALLOC_STATIC);
STRING_TABLE.__str45904=allocate([103,101,110,101,114,97,108,0] /* general\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str55905=allocate([10,71,101,110,101,114,97,108,32,68,101,98,117,103,103,101,114,32,72,101,108,112,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,104,101,108,112,32,91,60,116,111,112,105,99,62,93,32,45,45,32,103,101,116,32,104,101,108,112,32,111,110,32,97,32,112,97,114,116,105,99,117,108,97,114,32,116,111,112,105,99,10,32,32,100,111,32,60,101,120,112,114,101,115,115,105,111,110,62,32,45,45,32,101,118,97,108,117,97,116,101,115,32,116,104,101,32,103,105,118,101,110,32,101,120,112,114,101,115,115,105,111,110,10,32,32,115,121,109,108,105,115,116,32,91,60,99,112,117,62,93,32,45,45,32,108,105,115,116,115,32,114,101,103,105,115,116,101,114,101,100,32,115,121,109,98,111,108,115,10,32,32,115,111,102,116,114,101,115,101,116,32,45,45,32,101,120,101,99,117,116,101,115,32,97,32,115,111,102,116,32,114,101,115,101,116,10,32,32,104,97,114,100,114,101,115,101,116,32,45,45,32,101,120,101,99,117,116,101,115,32,97,32,104,97,114,100,32,114,101,115,101,116,10,32,32,112,114,105,110,116,32,60,105,116,101,109,62,91,44,46,46,46,93,32,45,45,32,112,114,105,110,116,115,32,111,110,101,32,111,114,32,109,111,114,101,32,60,105,116,101,109,62,115,32,116,111,32,116,104,101,32,99,111,110,115,111,108,101,10,32,32,112,114,105,110,116,102,32,60,102,111,114,109,97,116,62,91,44,60,105,116,101,109,62,91,44,46,46,46,93,93,32,45,45,32,112,114,105,110,116,115,32,111,110,101,32,111,114,32,109,111,114,101,32,60,105,116,101,109,62,115,32,116,111,32,116,104,101,32,99,111,110,115,111,108,101,32,117,115,105,110,103,32,60,102,111,114,109,97,116,62,10,32,32,108,111,103,101,114,114,111,114,32,60,102,111,114,109,97,116,62,91,44,60,105,116,101,109,62,91,44,46,46,46,93,93,32,45,45,32,111,117,116,112,117,116,115,32,111,110,101,32,111,114,32,109,111,114,101,32,60,105,116,101,109,62,115,32,116,111,32,116,104,101,32,101,114,114,111,114,46,108,111,103,10,32,32,116,114,97,99,101,108,111,103,32,60,102,111,114,109,97,116,62,91,44,60,105,116,101,109,62,91,44,46,46,46,93,93,32,45,45,32,111,117,116,112,117,116,115,32,111,110,101,32,111,114,32,109,111,114,101,32,60,105,116,101,109,62,115,32,116,111,32,116,104,101,32,116,114,97,99,101,32,102,105,108,101,32,117,115,105,110,103,32,60,102,111,114,109,97,116,62,10,32,32,115,110,97,112,32,91,60,102,105,108,101,110,97,109,101,62,93,32,45,45,32,115,97,118,101,32,97,32,115,99,114,101,101,110,32,115,110,97,112,115,104,111,116,10,32,32,115,111,117,114,99,101,32,60,102,105,108,101,110,97,109,101,62,32,45,45,32,114,101,97,100,115,32,99,111,109,109,97,110,100,115,32,102,114,111,109,32,60,102,105,108,101,110,97,109,101,62,32,97,110,100,32,101,120,101,99,117,116,101,115,32,116,104,101,109,32,111,110,101,32,98,121,32,111,110,101,10,32,32,113,117,105,116,32,45,45,32,101,120,105,116,115,32,77,65,77,69,32,97,110,100,32,116,104,101,32,100,101,98,117,103,103,101,114,10,0] /* \0AGeneral Debugger  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str65906=allocate([109,101,109,111,114,121,0] /* memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str75907=allocate([10,77,101,109,111,114,121,32,67,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,100,97,115,109,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,111,112,99,111,100,101,115,62,91,44,60,99,112,117,62,93,93,32,45,45,32,100,105,115,97,115,115,101,109,98,108,101,32,116,111,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,102,91,105,110,100,93,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,100,97,116,97,62,91,44,46,46,46,93,93,32,45,45,32,115,101,97,114,99,104,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,32,102,111,114,32,100,97,116,97,10,32,32,102,91,105,110,100,93,100,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,100,97,116,97,62,91,44,46,46,46,93,93,32,45,45,32,115,101,97,114,99,104,32,100,97,116,97,32,109,101,109,111,114,121,32,102,111,114,32,100,97,116,97,10,32,32,102,91,105,110,100,93,105,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,100,97,116,97,62,91,44,46,46,46,93,93,32,45,45,32,115,101,97,114,99,104,32,73,47,79,32,109,101,109,111,114,121,32,102,111,114,32,100,97,116,97,10,32,32,100,117,109,112,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,115,105,122,101,62,91,44,60,97,115,99,105,105,62,91,44,60,99,112,117,62,93,93,93,32,45,45,32,100,117,109,112,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,32,97,115,32,116,101,120,116,10,32,32,100,117,109,112,100,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,115,105,122,101,62,91,44,60,97,115,99,105,105,62,91,44,60,99,112,117,62,93,93,93,32,45,45,32,100,117,109,112,32,100,97,116,97,32,109,101,109,111,114,121,32,97,115,32,116,101,120,116,10,32,32,100,117,109,112,105,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,115,105,122,101,62,91,44,60,97,115,99,105,105,62,91,44,60,99,112,117,62,93,93,93,32,45,45,32,100,117,109,112,32,73,47,79,32,109,101,109,111,114,121,32,97,115,32,116,101,120,116,10,32,32,115,97,118,101,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,32,45,45,32,115,97,118,101,32,98,105,110,97,114,121,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,115,97,118,101,100,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,32,45,45,32,115,97,118,101,32,98,105,110,97,114,121,32,100,97,116,97,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,115,97,118,101,105,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,32,45,45,32,115,97,118,101,32,98,105,110,97,114,121,32,73,47,79,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,108,111,97,100,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,32,45,45,32,108,111,97,100,32,98,105,110,97,114,121,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,32,102,114,111,109,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,108,111,97,100,100,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,32,45,45,32,108,111,97,100,32,98,105,110,97,114,121,32,100,97,116,97,32,109,101,109,111,114,121,32,102,114,111,109,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,108,111,97,100,105,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,32,45,45,32,108,111,97,100,32,98,105,110,97,114,121,32,73,47,79,32,109,101,109,111,114,121,32,102,114,111,109,32,116,104,101,32,103,105,118,101,110,32,102,105,108,101,10,32,32,109,97,112,32,60,97,100,100,114,101,115,115,62,32,45,45,32,109,97,112,32,108,111,103,105,99,97,108,32,112,114,111,103,114,97,109,32,97,100,100,114,101,115,115,32,116,111,32,112,104,121,115,105,99,97,108,32,97,100,100,114,101,115,115,32,97,110,100,32,98,97,110,107,10,32,32,109,97,112,100,32,60,97,100,100,114,101,115,115,62,32,45,45,32,109,97,112,32,108,111,103,105,99,97,108,32,100,97,116,97,32,97,100,100,114,101,115,115,32,116,111,32,112,104,121,115,105,99,97,108,32,97,100,100,114,101,115,115,32,97,110,100,32,98,97,110,107,10,32,32,109,97,112,105,32,60,97,100,100,114,101,115,115,62,32,45,45,32,109,97,112,32,108,111,103,105,99,97,108,32,73,47,79,32,97,100,100,114,101,115,115,32,116,111,32,112,104,121,115,105,99,97,108,32,97,100,100,114,101,115,115,32,97,110,100,32,98,97,110,107,10,32,32,109,101,109,100,117,109,112,32,91,60,102,105,108,101,110,97,109,101,62,93,32,45,45,32,100,117,109,112,32,116,104,101,32,99,117,114,114,101,110,116,32,109,101,109,111,114,121,32,109,97,112,32,116,111,32,60,102,105,108,101,110,97,109,101,62,10,0] /* \0AMemory Commands\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str85908=allocate([101,120,101,99,117,116,105,111,110,0] /* execution\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str95909=allocate([10,69,120,101,99,117,116,105,111,110,32,67,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,115,91,116,101,112,93,32,91,60,99,111,117,110,116,62,61,49,93,32,45,45,32,115,105,110,103,108,101,32,115,116,101,112,115,32,102,111,114,32,60,99,111,117,110,116,62,32,105,110,115,116,114,117,99,116,105,111,110,115,32,40,70,49,49,41,10,32,32,111,91,118,101,114,93,32,91,60,99,111,117,110,116,62,61,49,93,32,45,45,32,115,105,110,103,108,101,32,115,116,101,112,115,32,111,118,101,114,32,60,99,111,117,110,116,62,32,105,110,115,116,114,117,99,116,105,111,110,115,32,40,70,49,48,41,10,32,32,111,117,116,32,45,45,32,115,105,110,103,108,101,32,115,116,101,112,115,32,117,110,116,105,108,32,116,104,101,32,99,117,114,114,101,110,116,32,115,117,98,114,111,117,116,105,110,101,47,101,120,99,101,112,116,105,111,110,32,104,97,110,100,108,101,114,32,105,115,32,101,120,105,116,101,100,32,40,83,104,105,102,116,45,70,49,49,41,10,32,32,103,91,111,93,32,91,60,97,100,100,114,101,115,115,62,93,32,45,45,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,44,32,115,101,116,115,32,116,101,109,112,32,98,114,101,97,107,112,111,105,110,116,32,97,116,32,60,97,100,100,114,101,115,115,62,32,40,70,53,41,10,32,32,103,105,91,110,116,93,32,91,60,105,114,113,108,105,110,101,62,93,32,45,45,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,44,32,115,101,116,116,105,110,103,32,116,101,109,112,32,98,114,101,97,107,112,111,105,110,116,32,105,102,32,60,105,114,113,108,105,110,101,62,32,105,115,32,116,97,107,101,110,32,40,70,55,41,10,32,32,103,116,91,105,109,101,93,32,60,109,105,108,108,105,115,101,99,111,110,100,115,62,32,45,45,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,32,117,110,116,105,108,32,116,104,101,32,103,105,118,101,110,32,100,101,108,97,121,32,104,97,115,32,101,108,97,112,115,101,100,10,32,32,103,118,91,98,108,97,110,107,93,32,45,45,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,44,32,115,101,116,116,105,110,103,32,116,101,109,112,32,98,114,101,97,107,112,111,105,110,116,32,111,110,32,116,104,101,32,110,101,120,116,32,86,66,76,65,78,75,32,40,70,56,41,10,32,32,110,91,101,120,116,93,32,45,45,32,101,120,101,99,117,116,101,115,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,67,80,85,32,115,119,105,116,99,104,32,40,70,54,41,10,32,32,102,111,99,117,115,32,60,99,112,117,62,32,45,45,32,102,111,99,117,115,101,115,32,100,101,98,117,103,103,101,114,32,111,110,108,121,32,111,110,32,60,99,112,117,62,10,32,32,105,103,110,111,114,101,32,91,60,99,112,117,62,91,44,60,99,112,117,62,91,44,46,46,46,93,93,93,32,45,45,32,115,116,111,112,115,32,100,101,98,117,103,103,105,110,103,32,111,110,32,60,99,112,117,62,10,32,32,111,98,115,101,114,118,101,32,91,60,99,112,117,62,91,44,60,99,112,117,62,91,44,46,46,46,93,93,93,32,45,45,32,114,101,115,117,109,101,115,32,100,101,98,117,103,103,105,110,103,32,111,110,32,60,99,112,117,62,10,32,32,116,114,97,99,101,32,123,60,102,105,108,101,110,97,109,101,62,124,79,70,70,125,91,44,60,99,112,117,62,91,44,60,97,99,116,105,111,110,62,93,93,32,45,45,32,116,114,97,99,101,32,116,104,101,32,103,105,118,101,110,32,67,80,85,32,116,111,32,97,32,102,105,108,101,32,40,100,101,102,97,117,108,116,115,32,116,111,32,97,99,116,105,118,101,32,67,80,85,41,10,32,32,116,114,97,99,101,111,118,101,114,32,123,60,102,105,108,101,110,97,109,101,62,124,79,70,70,125,91,44,60,99,112,117,62,91,44,60,97,99,116,105,111,110,62,93,93,32,45,45,32,116,114,97,99,101,32,116,104,101,32,103,105,118,101,110,32,67,80,85,32,116,111,32,97,32,102,105,108,101,44,32,98,117,116,32,115,107,105,112,32,115,117,98,114,111,117,116,105,110,101,115,32,40,100,101,102,97,117,108,116,115,32,116,111,32,97,99,116,105,118,101,32,67,80,85,41,10,32,32,116,114,97,99,101,102,108,117,115,104,32,45,45,32,102,108,117,115,104,101,115,32,97,108,108,32,111,112,101,110,32,116,114,97,99,101,32,102,105,108,101,115,10,0] /* \0AExecution Command */, "i8", ALLOC_STATIC);
STRING_TABLE.__str105910=allocate([98,114,101,97,107,112,111,105,110,116,115,0] /* breakpoints\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str115911=allocate([10,66,114,101,97,107,112,111,105,110,116,32,67,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,98,112,91,115,101,116,93,32,60,97,100,100,114,101,115,115,62,91,44,60,99,111,110,100,105,116,105,111,110,62,91,44,60,97,99,116,105,111,110,62,93,93,32,45,45,32,115,101,116,115,32,98,114,101,97,107,112,111,105,110,116,32,97,116,32,60,97,100,100,114,101,115,115,62,10,32,32,98,112,99,108,101,97,114,32,91,60,98,112,110,117,109,62,93,32,45,45,32,99,108,101,97,114,115,32,97,32,103,105,118,101,110,32,98,114,101,97,107,112,111,105,110,116,32,111,114,32,97,108,108,32,105,102,32,110,111,32,60,98,112,110,117,109,62,32,115,112,101,99,105,102,105,101,100,10,32,32,98,112,100,105,115,97,98,108,101,32,91,60,98,112,110,117,109,62,93,32,45,45,32,100,105,115,97,98,108,101,115,32,97,32,103,105,118,101,110,32,98,114,101,97,107,112,111,105,110,116,32,111,114,32,97,108,108,32,105,102,32,110,111,32,60,98,112,110,117,109,62,32,115,112,101,99,105,102,105,101,100,10,32,32,98,112,101,110,97,98,108,101,32,91,60,98,112,110,117,109,62,93,32,45,45,32,101,110,97,98,108,101,115,32,97,32,103,105,118,101,110,32,98,114,101,97,107,112,111,105,110,116,32,111,114,32,97,108,108,32,105,102,32,110,111,32,60,98,112,110,117,109,62,32,115,112,101,99,105,102,105,101,100,10,32,32,98,112,108,105,115,116,32,45,45,32,108,105,115,116,115,32,97,108,108,32,116,104,101,32,98,114,101,97,107,112,111,105,110,116,115,10,0] /* \0ABreakpoint Comman */, "i8", ALLOC_STATIC);
STRING_TABLE.__str125912=allocate([119,97,116,99,104,112,111,105,110,116,115,0] /* watchpoints\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str135913=allocate([10,87,97,116,99,104,112,111,105,110,116,32,67,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,119,112,91,115,101,116,93,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,44,60,116,121,112,101,62,91,44,60,99,111,110,100,105,116,105,111,110,62,91,44,60,97,99,116,105,111,110,62,93,93,32,45,45,32,115,101,116,115,32,112,114,111,103,114,97,109,32,115,112,97,99,101,32,119,97,116,99,104,112,111,105,110,116,10,32,32,119,112,100,91,115,101,116,93,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,44,60,116,121,112,101,62,91,44,60,99,111,110,100,105,116,105,111,110,62,91,44,60,97,99,116,105,111,110,62,93,93,32,45,45,32,115,101,116,115,32,100,97,116,97,32,115,112,97,99,101,32,119,97,116,99,104,112,111,105,110,116,10,32,32,119,112,105,91,115,101,116,93,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,44,60,116,121,112,101,62,91,44,60,99,111,110,100,105,116,105,111,110,62,91,44,60,97,99,116,105,111,110,62,93,93,32,45,45,32,115,101,116,115,32,73,47,79,32,115,112,97,99,101,32,119,97,116,99,104,112,111,105,110,116,10,32,32,119,112,99,108,101,97,114,32,91,60,119,112,110,117,109,62,93,32,45,45,32,99,108,101,97,114,115,32,97,32,103,105,118,101,110,32,119,97,116,99,104,112,111,105,110,116,32,111,114,32,97,108,108,32,105,102,32,110,111,32,60,119,112,110,117,109,62,32,115,112,101,99,105,102,105,101,100,10,32,32,119,112,100,105,115,97,98,108,101,32,91,60,119,112,110,117,109,62,93,32,45,45,32,100,105,115,97,98,108,101,115,32,97,32,103,105,118,101,110,32,119,97,116,99,104,112,111,105,110,116,32,111,114,32,97,108,108,32,105,102,32,110,111,32,60,119,112,110,117,109,62,32,115,112,101,99,105,102,105,101,100,10,32,32,119,112,101,110,97,98,108,101,32,91,60,119,112,110,117,109,62,93,32,45,45,32,101,110,97,98,108,101,115,32,97,32,103,105,118,101,110,32,119,97,116,99,104,112,111,105,110,116,32,111,114,32,97,108,108,32,105,102,32,110,111,32,60,119,112,110,117,109,62,32,115,112,101,99,105,102,105,101,100,10,32,32,119,112,108,105,115,116,32,45,45,32,108,105,115,116,115,32,97,108,108,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,115,10,32,32,104,111,116,115,112,111,116,32,91,60,99,112,117,62,44,91,60,100,101,112,116,104,62,91,44,60,104,105,116,115,62,93,93,93,32,45,45,32,97,116,116,101,109,112,116,32,116,111,32,102,105,110,100,32,104,111,116,115,112,111,116,115,10,0] /* \0AWatchpoint Comman */, "i8", ALLOC_STATIC);
STRING_TABLE.__str145914=allocate([101,120,112,114,101,115,115,105,111,110,115,0] /* expressions\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155915=allocate([10,69,120,112,114,101,115,115,105,111,110,115,32,99,97,110,32,98,101,32,117,115,101,100,32,97,110,121,119,104,101,114,101,32,97,32,110,117,109,101,114,105,99,32,112,97,114,97,109,101,116,101,114,32,105,115,32,101,120,112,101,99,116,101,100,46,32,84,104,101,32,115,121,110,116,97,120,32,102,111,114,32,101,120,112,114,101,115,115,105,111,110,115,32,105,115,32,118,101,114,121,32,99,108,111,115,101,32,116,111,32,115,116,97,110,100,97,114,100,32,67,45,115,116,121,108,101,32,115,121,110,116,97,120,32,119,105,116,104,32,102,117,108,108,32,111,112,101,114,97,116,111,114,32,111,114,100,101,114,105,110,103,32,97,110,100,32,112,97,114,101,110,116,104,101,115,101,115,46,32,84,104,101,114,101,32,97,114,101,32,97,32,102,101,119,32,111,112,101,114,97,116,111,114,115,32,109,105,115,115,105,110,103,32,40,110,111,116,97,98,108,121,32,116,104,101,32,116,114,105,110,97,114,121,32,63,32,58,32,111,112,101,114,97,116,111,114,41,44,32,97,110,100,32,97,32,102,101,119,32,110,101,119,32,111,110,101,115,32,40,109,101,109,111,114,121,32,97,99,99,101,115,115,111,114,115,41,46,32,84,104,101,32,116,97,98,108,101,32,98,101,108,111,119,32,108,105,115,116,115,32,97,108,108,32,116,104,101,32,111,112,101,114,97,116,111,114,115,32,105,110,32,116,104,101,105,114,32,111,114,100,101,114,44,32,104,105,103,104,101,115,116,32,112,114,101,99,101,100,101,110,99,101,32,111,112,101,114,97,116,111,114,115,32,102,105,114,115,116,46,10,10,32,32,40,32,41,32,58,32,115,116,97,110,100,97,114,100,32,112,97,114,101,110,116,104,101,115,101,115,10,32,32,43,43,32,45,45,32,58,32,112,111,115,116,102,105,120,32,105,110,99,114,101,109,101,110,116,47,100,101,99,114,101,109,101,110,116,10,32,32,43,43,32,45,45,32,126,32,33,32,45,32,43,32,98,64,32,119,64,32,100,64,32,113,64,32,58,32,112,114,101,102,105,120,32,105,110,99,47,100,101,99,44,32,98,105,110,97,114,121,32,78,79,84,44,32,108,111,103,105,99,97,108,32,78,79,84,44,32,117,110,97,114,121,32,43,47,45,44,32,109,101,109,111,114,121,32,97,99,99,101,115,115,10,32,32,42,32,47,32,37,32,58,32,109,117,108,116,105,112,108,121,44,32,100,105,118,105,100,101,44,32,109,111,100,117,108,117,115,10,32,32,43,32,45,32,58,32,97,100,100,44,32,115,117,98,116,114,97,99,116,10,32,32,60,60,32,62,62,32,58,32,115,104,105,102,116,32,108,101,102,116,47,114,105,103,104,116,10,32,32,60,32,60,61,32,62,32,62,61,32,58,32,108,101,115,115,32,116,104,97,110,44,32,108,101,115,115,32,116,104,97,110,32,111,114,32,101,113,117,97,108,44,32,103,114,101,97,116,101,114,32,116,104,97,110,44,32,103,114,101,97,116,101,114,32,116,104,97,110,32,111,114,32,101,113,117,97,108,10,32,32,61,61,32,33,61,32,58,32,101,113,117,97,108,44,32,110,111,116,32,101,113,117,97,108,10,32,32,38,32,58,32,98,105,110,97,114,121,32,65,78,68,10,32,32,94,32,58,32,98,105,110,97,114,121,32,88,79,82,10,32,32,124,32,58,32,98,105,110,97,114,121,32,79,82,10,32,32,38,38,32,58,32,108,111,103,105,99,97,108,32,65,78,68,10,32,32,124,124,32,58,32,108,111,103,105,99,97,108,32,79,82,10,32,32,61,32,42,61,32,47,61,32,37,61,32,43,61,32,45,61,32,60,60,61,32,62,62,61,32,38,61,32,124,61,32,94,61,32,58,32,97,115,115,105,103,110,109,101,110,116,10,32,32,44,32,58,32,115,101,112,97,114,97,116,101,32,116,101,114,109,115,44,32,102,117,110,99,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,10,10,84,104,101,115,101,32,97,114,101,32,116,104,101,32,100,105,102,102,101,114,101,110,99,101,115,32,102,114,111,109,32,67,32,98,101,104,97,118,105,111,114,115,46,32,70,105,114,115,116,44,32,65,108,108,32,109,97,116,104,32,105,115,32,112,101,114,102,111,114,109,101,100,32,111,110,32,102,117,108,108,32,54,52,45,98,105,116,32,117,110,115,105,103,110,101,100,32,118,97,108,117,101,115,44,32,115,111,32,116,104,105,110,103,115,32,108,105,107,101,32,97,32,60,32,48,32,119,111,110,39,116,32,119,111,114,107,32,97,115,32,101,120,112,101,99,116,101,100,46,32,83,101,99,111,110,100,44,32,116,104,101,32,108,111,103,105,99,97,108,32,111,112,101,114,97,116,111,114,115,32,38,38,32,97,110,100,32,124,124,32,100,111,32,110,111,116,32,104,97,118,101,32,115,104,111,114,116,45,99,105,114,99,117,105,116,32,112,114,111,112,101,114,116,105,101,115,32,45,45,32,98,111,116,104,32,104,97,108,118,101,115,32,97,114,101,32,97,108,119,97,121,115,32,101,118,97,108,117,97,116,101,100,46,32,70,105,110,97,108,108,121,44,32,116,104,101,32,110,101,119,32,109,101,109,111,114,121,32,111,112,101,114,97,116,111,114,115,32,119,111,114,107,32,108,105,107,101,32,116,104,105,115,58,32,98,64,60,97,100,100,114,62,32,114,101,102,101,114,115,32,116,111,32,116,104,101,32,98,121,116,101,32,114,101,97,100,32,102,114,111,109,32,60,97,100,100,114,62,46,32,83,105,109,105,108,97,114,108,121,44,32,119,64,32,114,101,102,101,114,115,32,116,111,32,97,32,119,111,114,100,32,105,110,32,109,101,109,111,114,121,44,32,100,64,32,114,101,102,101,114,115,32,116,111,32,97,32,100,119,111,114,100,32,105,110,32,109,101,109,111,114,121,44,32,97,110,100,32,113,64,32,114,101,102,101,114,115,32,116,111,32,97,32,113,119,111,114,100,32,105,110,32,109,101,109,111,114,121,46,32,84,104,101,32,109,101,109,111,114,121,32,111,112,101,114,97,116,111,114,115,32,99,97,110,32,98,101,32,117,115,101,100,32,97,115,32,98,111,116,104,32,108,118,97,108,117,101,115,32,97,110,100,32,114,118,97,108,117,101,115,44,32,115,111,32,121,111,117,32,99,97,110,32,119,114,105,116,101,32,98,64,49,48,48,32,61,32,102,102,32,116,111,32,115,116,111,114,101,32,97,32,98,121,116,101,32,105,110,32,109,101,109,111,114,121,46,32,66,121,32,100,101,102,97,117,108,116,32,116,104,101,115,101,32,111,112,101,114,97,116,111,114,115,32,114,101,97,100,32,102,114,111,109,32,116,104,101,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,32,115,112,97,99,101,44,32,98,117,116,32,121,111,117,32,99,97,110,32,111,118,101,114,114,105,100,101,32,116,104,97,116,32,98,121,32,112,114,101,102,105,120,105,110,103,32,116,104,101,109,32,119,105,116,104,32,97,32,39,100,39,32,111,114,32,97,110,32,39,105,39,46,32,83,111,32,100,119,64,51,48,48,32,114,101,102,101,114,115,32,116,111,32,100,97,116,97,32,109,101,109,111,114,121,32,119,111,114,100,32,97,116,32,97,100,100,114,101,115,115,32,51,48,48,32,97,110,100,32,105,100,64,52,48,48,32,114,101,102,101,114,115,32,116,111,32,97,110,32,73,47,79,32,109,101,109,111,114,121,32,100,119,111,114,100,32,97,116,32,97,100,100,114,101,115,115,32,52,48,48,46,10,0] /* \0AExpressions can b */, "i8", ALLOC_STATIC);
STRING_TABLE.__str165916=allocate([99,111,109,109,101,110,116,115,0] /* comments\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str175917=allocate([10,67,111,100,101,32,97,110,110,111,116,97,116,105,111,110,32,99,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,99,111,109,97,100,100,91,47,47,93,32,60,97,100,100,114,101,115,115,62,44,60,99,111,109,109,101,110,116,62,32,45,45,32,97,100,100,115,32,97,32,99,111,109,109,101,110,116,32,116,111,32,116,104,101,32,100,105,115,97,115,115,101,109,98,108,101,100,32,99,111,100,101,32,97,116,32,103,105,118,101,110,32,97,100,100,114,101,115,115,10,32,32,99,111,109,100,101,108,101,116,101,32,60,97,100,100,114,101,115,115,62,32,45,45,32,114,101,109,111,118,101,115,32,97,32,99,111,109,109,101,110,116,32,102,114,111,109,32,116,104,101,32,103,105,118,101,110,32,97,100,100,114,101,115,115,10,32,32,99,111,109,115,97,118,101,32,45,45,32,115,97,118,101,32,116,104,101,32,99,117,114,114,101,110,116,32,99,111,109,109,101,110,116,115,32,116,111,32,97,32,102,105,108,101,10,10,0] /* \0ACode annotation c */, "i8", ALLOC_STATIC);
STRING_TABLE.__str185918=allocate([99,104,101,97,116,115,0] /* cheats\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str195919=allocate([10,67,104,101,97,116,32,67,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,99,104,101,97,116,105,110,105,116,32,91,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,93,32,45,45,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,116,111,32,116,104,101,32,115,101,108,101,99,116,101,100,32,109,101,109,111,114,121,32,97,114,101,97,10,32,32,99,104,101,97,116,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,32,45,45,32,97,100,100,32,116,111,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,116,104,101,32,115,101,108,101,99,116,101,100,32,109,101,109,111,114,121,32,97,114,101,97,10,32,32,99,104,101,97,116,110,101,120,116,32,60,99,111,110,100,105,116,105,111,110,62,91,44,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,93,32,45,45,32,99,111,110,116,105,110,117,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,99,111,109,112,97,114,105,110,103,32,119,105,116,104,32,116,104,101,32,116,104,101,32,108,97,115,116,32,118,97,108,117,101,10,32,32,99,104,101,97,116,110,101,120,116,102,32,60,99,111,110,100,105,116,105,111,110,62,91,44,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,93,32,45,45,32,99,111,110,116,105,110,117,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,99,111,109,112,97,114,105,110,103,32,119,105,116,104,32,116,104,101,32,116,104,101,32,102,105,114,115,116,32,118,97,108,117,101,10,32,32,99,104,101,97,116,108,105,115,116,32,91,60,102,105,108,101,110,97,109,101,62,93,32,45,45,32,115,104,111,119,32,116,104,101,32,108,105,115,116,32,111,102,32,99,104,101,97,116,32,115,101,97,114,99,104,32,109,97,116,99,104,101,115,32,111,114,32,115,97,118,101,32,116,104,101,109,32,116,111,32,60,102,105,108,101,110,97,109,101,62,10,32,32,99,104,101,97,116,117,110,100,111,32,45,45,32,117,110,100,111,32,116,104,101,32,108,97,115,116,32,99,104,101,97,116,32,115,101,97,114,99,104,32,40,115,116,97,116,101,32,111,110,108,121,41,10,0] /* \0ACheat Commands\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str205920=allocate([105,109,97,103,101,0] /* image\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str215921=allocate([10,73,109,97,103,101,32,67,111,109,109,97,110,100,115,10,84,121,112,101,32,104,101,108,112,32,60,99,111,109,109,97,110,100,62,32,102,111,114,32,102,117,114,116,104,101,114,32,100,101,116,97,105,108,115,32,111,110,32,101,97,99,104,32,99,111,109,109,97,110,100,10,10,32,32,105,109,97,103,101,115,32,45,45,32,108,105,115,116,115,32,97,108,108,32,105,109,97,103,101,32,100,101,118,105,99,101,115,32,97,110,100,32,109,111,117,110,116,101,100,32,102,105,108,101,115,10,32,32,109,111,117,110,116,32,60,100,101,118,105,99,101,62,44,60,102,105,108,101,110,97,109,101,62,32,45,45,32,109,111,117,110,116,115,32,102,105,108,101,32,116,111,32,110,97,109,101,100,32,100,101,118,105,99,101,10,32,32,117,110,109,111,117,110,116,32,60,100,101,118,105,99,101,62,32,45,45,32,117,110,109,111,117,110,116,115,32,102,105,108,101,32,102,114,111,109,32,110,97,109,101,100,32,100,101,118,105,99,101,10,0] /* \0AImage Commands\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str225922=allocate([100,111,0] /* do\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str235923=allocate([10,32,32,100,111,32,60,101,120,112,114,101,115,115,105,111,110,62,10,10,84,104,101,32,100,111,32,99,111,109,109,97,110,100,32,115,105,109,112,108,121,32,101,118,97,108,117,97,116,101,115,32,116,104,101,32,103,105,118,101,110,32,60,101,120,112,114,101,115,115,105,111,110,62,46,32,84,104,105,115,32,105,115,32,116,121,112,105,99,97,108,108,121,32,117,115,101,100,32,116,111,32,115,101,116,32,111,114,32,109,111,100,105,102,121,32,118,97,114,105,97,98,108,101,115,46,10,10,69,120,97,109,112,108,101,115,58,10,10,100,111,32,112,99,32,61,32,48,10,32,32,83,101,116,115,32,116,104,101,32,114,101,103,105,115,116,101,114,32,39,112,99,39,32,116,111,32,48,46,10,0] /* \0A  do <expression> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str245924=allocate([115,121,109,108,105,115,116,0] /* symlist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str255925=allocate([10,32,32,115,121,109,108,105,115,116,32,91,60,99,112,117,62,93,10,10,76,105,115,116,115,32,114,101,103,105,115,116,101,114,101,100,32,115,121,109,98,111,108,115,46,32,73,102,32,60,99,112,117,62,32,105,115,32,110,111,116,32,115,112,101,99,105,102,105,101,100,44,32,116,104,101,110,32,115,121,109,98,111,108,115,32,105,110,32,116,104,101,32,103,108,111,98,97,108,32,115,121,109,98,111,108,32,116,97,98,108,101,32,97,114,101,32,100,105,115,112,108,97,121,101,100,59,32,111,116,104,101,114,119,105,115,101,44,32,116,104,101,32,115,121,109,98,111,108,115,32,102,111,114,32,60,99,112,117,62,39,115,32,115,112,101,99,105,102,105,99,32,67,80,85,32,97,114,101,32,100,105,115,112,108,97,121,101,100,46,32,83,121,109,98,111,108,115,32,97,114,101,32,108,105,115,116,101,100,32,97,108,112,104,97,98,101,116,105,99,97,108,108,121,46,32,82,101,97,100,45,111,110,108,121,32,115,121,109,98,111,108,115,32,97,114,101,32,102,108,97,103,103,101,100,32,119,105,116,104,32,97,110,32,97,115,116,101,114,105,115,107,46,10,10,69,120,97,109,112,108,101,115,58,10,10,115,121,109,108,105,115,116,10,32,32,68,105,115,112,108,97,121,115,32,116,104,101,32,103,108,111,98,97,108,32,115,121,109,98,111,108,32,116,97,98,108,101,46,10,10,115,121,109,108,105,115,116,32,50,10,32,32,68,105,115,112,108,97,121,115,32,116,104,101,32,115,121,109,98,111,108,115,32,115,112,101,99,105,102,105,99,32,116,111,32,67,80,85,32,35,50,46,10,0] /* \0A  symlist [<cpu>] */, "i8", ALLOC_STATIC);
STRING_TABLE.__str265926=allocate([115,111,102,116,114,101,115,101,116,0] /* softreset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str275927=allocate([10,32,32,115,111,102,116,114,101,115,101,116,10,10,69,120,101,99,117,116,101,115,32,97,32,115,111,102,116,32,114,101,115,101,116,46,10,10,69,120,97,109,112,108,101,115,58,10,10,115,111,102,116,114,101,115,101,116,10,32,32,69,120,101,99,117,116,101,115,32,97,32,115,111,102,116,32,114,101,115,101,116,46,10,0] /* \0A  softreset\0A\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str285928=allocate([104,97,114,100,114,101,115,101,116,0] /* hardreset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str295929=allocate([10,32,32,104,97,114,100,114,101,115,101,116,10,10,69,120,101,99,117,116,101,115,32,97,32,104,97,114,100,32,114,101,115,101,116,46,10,10,69,120,97,109,112,108,101,115,58,10,10,104,97,114,100,114,101,115,101,116,10,32,32,69,120,101,99,117,116,101,115,32,97,32,104,97,114,100,32,114,101,115,101,116,46,10,0] /* \0A  hardreset\0A\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str305930=allocate([112,114,105,110,116,0] /* print\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str315931=allocate([10,32,32,112,114,105,110,116,32,60,105,116,101,109,62,91,44,46,46,46,93,10,10,84,104,101,32,112,114,105,110,116,32,99,111,109,109,97,110,100,32,112,114,105,110,116,115,32,116,104,101,32,114,101,115,117,108,116,115,32,111,102,32,111,110,101,32,111,114,32,109,111,114,101,32,101,120,112,114,101,115,115,105,111,110,115,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,99,111,110,115,111,108,101,32,97,115,32,104,101,120,97,100,101,99,105,109,97,108,32,118,97,108,117,101,115,46,10,10,69,120,97,109,112,108,101,115,58,10,10,112,114,105,110,116,32,112,99,10,32,32,80,114,105,110,116,115,32,116,104,101,32,118,97,108,117,101,32,111,102,32,39,112,99,39,32,116,111,32,116,104,101,32,99,111,110,115,111,108,101,32,97,115,32,97,32,104,101,120,32,110,117,109,98,101,114,46,10,10,112,114,105,110,116,32,97,44,98,44,97,43,98,10,32,32,80,114,105,110,116,115,32,97,44,32,98,44,32,97,110,100,32,116,104,101,32,118,97,108,117,101,32,111,102,32,97,43,98,32,116,111,32,116,104,101,32,99,111,110,115,111,108,101,32,97,115,32,104,101,120,32,110,117,109,98,101,114,115,46,10,0] /* \0A  print <item>[,. */, "i8", ALLOC_STATIC);
STRING_TABLE.__str325932=allocate([112,114,105,110,116,102,0] /* printf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str335933=allocate([10,32,32,112,114,105,110,116,102,32,60,102,111,114,109,97,116,62,91,44,60,105,116,101,109,62,91,44,46,46,46,93,93,10,10,84,104,101,32,112,114,105,110,116,102,32,99,111,109,109,97,110,100,32,112,101,114,102,111,114,109,115,32,97,32,67,45,115,116,121,108,101,32,112,114,105,110,116,102,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,99,111,110,115,111,108,101,46,32,79,110,108,121,32,97,32,118,101,114,121,32,108,105,109,105,116,101,100,32,115,101,116,32,111,102,32,102,111,114,109,97,116,116,105,110,103,32,111,112,116,105,111,110,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,58,10,10,32,32,37,91,48,93,91,60,110,62,93,100,32,45,45,32,112,114,105,110,116,115,32,60,105,116,101,109,62,32,97,115,32,97,32,100,101,99,105,109,97,108,32,118,97,108,117,101,32,119,105,116,104,32,111,112,116,105,111,110,97,108,32,100,105,103,105,116,32,99,111,117,110,116,32,97,110,100,32,122,101,114,111,45,102,105,108,108,10,32,32,37,91,48,93,91,60,110,62,93,120,32,45,45,32,112,114,105,110,116,115,32,60,105,116,101,109,62,32,97,115,32,97,32,104,101,120,97,100,101,99,105,109,97,108,32,118,97,108,117,101,32,119,105,116,104,32,111,112,116,105,111,110,97,108,32,100,105,103,105,116,32,99,111,117,110,116,32,97,110,100,32,122,101,114,111,45,102,105,108,108,10,10,65,108,108,32,114,101,109,97,105,110,105,110,103,32,102,111,114,109,97,116,116,105,110,103,32,111,112,116,105,111,110,115,32,97,114,101,32,105,103,110,111,114,101,100,46,32,85,115,101,32,37,37,32,116,111,103,101,116,104,101,114,32,116,111,32,111,117,116,112,117,116,32,97,32,37,32,99,104,97,114,97,99,116,101,114,46,32,77,117,108,116,105,112,108,101,32,108,105,110,101,115,32,99,97,110,32,98,101,32,112,114,105,110,116,101,100,32,98,121,32,101,109,98,101,100,100,105,110,103,32,97,32,92,110,32,105,110,32,116,104,101,32,116,101,120,116,46,10,10,69,120,97,109,112,108,101,115,58,10,10,112,114,105,110,116,102,32,34,80,67,61,37,48,52,88,34,44,112,99,10,32,32,80,114,105,110,116,115,32,80,67,61,60,112,99,118,97,108,62,32,119,104,101,114,101,32,60,112,99,118,97,108,62,32,105,115,32,100,105,115,112,108,97,121,101,100,32,105,110,32,104,101,120,97,100,101,99,105,109,97,108,32,119,105,116,104,32,52,32,100,105,103,105,116,115,32,119,105,116,104,32,122,101,114,111,45,102,105,108,108,46,10,10,112,114,105,110,116,102,32,34,65,61,37,100,44,32,66,61,37,100,92,110,67,61,37,100,34,44,97,44,98,44,97,43,98,10,32,32,80,114,105,110,116,115,32,65,61,60,97,118,97,108,62,44,32,66,61,60,98,118,97,108,62,32,111,110,32,111,110,101,32,108,105,110,101,44,32,97,110,100,32,67,61,60,97,43,98,118,97,108,62,32,111,110,32,97,32,115,101,99,111,110,100,32,108,105,110,101,46,10,0] /* \0A  printf <format> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str345934=allocate([108,111,103,101,114,114,111,114,0] /* logerror\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str355935=allocate([10,32,32,108,111,103,101,114,114,111,114,32,60,102,111,114,109,97,116,62,91,44,60,105,116,101,109,62,91,44,46,46,46,93,93,10,10,84,104,101,32,108,111,103,101,114,114,111,114,32,99,111,109,109,97,110,100,32,112,101,114,102,111,114,109,115,32,97,32,67,45,115,116,121,108,101,32,112,114,105,110,116,102,32,116,111,32,116,104,101,32,101,114,114,111,114,32,108,111,103,46,32,79,110,108,121,32,97,32,118,101,114,121,32,108,105,109,105,116,101,100,32,115,101,116,32,111,102,32,102,111,114,109,97,116,116,105,110,103,32,111,112,116,105,111,110,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,58,10,10,32,32,37,91,48,93,91,60,110,62,93,100,32,45,45,32,108,111,103,115,32,60,105,116,101,109,62,32,97,115,32,97,32,100,101,99,105,109,97,108,32,118,97,108,117,101,32,119,105,116,104,32,111,112,116,105,111,110,97,108,32,100,105,103,105,116,32,99,111,117,110,116,32,97,110,100,32,122,101,114,111,45,102,105,108,108,10,32,32,37,91,48,93,91,60,110,62,93,120,32,45,45,32,108,111,103,115,32,60,105,116,101,109,62,32,97,115,32,97,32,104,101,120,97,100,101,99,105,109,97,108,32,118,97,108,117,101,32,119,105,116,104,32,111,112,116,105,111,110,97,108,32,100,105,103,105,116,32,99,111,117,110,116,32,97,110,100,32,122,101,114,111,45,102,105,108,108,10,10,65,108,108,32,114,101,109,97,105,110,105,110,103,32,102,111,114,109,97,116,116,105,110,103,32,111,112,116,105,111,110,115,32,97,114,101,32,105,103,110,111,114,101,100,46,32,85,115,101,32,37,37,32,116,111,103,101,116,104,101,114,32,116,111,32,111,117,116,112,117,116,32,97,32,37,32,99,104,97,114,97,99,116,101,114,46,32,77,117,108,116,105,112,108,101,32,108,105,110,101,115,32,99,97,110,32,98,101,32,112,114,105,110,116,101,100,32,98,121,32,101,109,98,101,100,100,105,110,103,32,97,32,92,110,32,105,110,32,116,104,101,32,116,101,120,116,46,10,10,69,120,97,109,112,108,101,115,58,10,10,108,111,103,101,114,114,111,114,32,34,80,67,61,37,48,52,88,34,44,112,99,10,32,32,76,111,103,115,32,80,67,61,60,112,99,118,97,108,62,32,119,104,101,114,101,32,60,112,99,118,97,108,62,32,105,115,32,100,105,115,112,108,97,121,101,100,32,105,110,32,104,101,120,97,100,101,99,105,109,97,108,32,119,105,116,104,32,52,32,100,105,103,105,116,115,32,119,105,116,104,32,122,101,114,111,45,102,105,108,108,46,10,10,108,111,103,101,114,114,111,114,32,34,65,61,37,100,44,32,66,61,37,100,92,110,67,61,37,100,34,44,97,44,98,44,97,43,98,10,32,32,76,111,103,115,32,65,61,60,97,118,97,108,62,44,32,66,61,60,98,118,97,108,62,32,111,110,32,111,110,101,32,108,105,110,101,44,32,97,110,100,32,67,61,60,97,43,98,118,97,108,62,32,111,110,32,97,32,115,101,99,111,110,100,32,108,105,110,101,46,10,0] /* \0A  logerror <forma */, "i8", ALLOC_STATIC);
STRING_TABLE.__str365936=allocate([116,114,97,99,101,108,111,103,0] /* tracelog\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str375937=allocate([10,32,32,116,114,97,99,101,108,111,103,32,60,102,111,114,109,97,116,62,91,44,60,105,116,101,109,62,91,44,46,46,46,93,93,10,10,84,104,101,32,116,114,97,99,101,108,111,103,32,99,111,109,109,97,110,100,32,112,101,114,102,111,114,109,115,32,97,32,67,45,115,116,121,108,101,32,112,114,105,110,116,102,32,97,110,100,32,114,111,117,116,101,115,32,116,104,101,32,111,117,116,112,117,116,32,116,111,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,111,112,101,110,32,116,114,97,99,101,32,102,105,108,101,32,40,115,101,101,32,116,104,101,32,39,116,114,97,99,101,39,32,99,111,109,109,97,110,100,32,102,111,114,32,100,101,116,97,105,108,115,41,46,32,73,102,32,110,111,32,102,105,108,101,32,105,115,32,99,117,114,114,101,110,116,108,121,32,111,112,101,110,44,32,116,114,97,99,101,108,111,103,32,100,111,101,115,32,110,111,116,104,105,110,103,46,32,79,110,108,121,32,97,32,118,101,114,121,32,108,105,109,105,116,101,100,32,115,101,116,32,111,102,32,102,111,114,109,97,116,116,105,110,103,32,111,112,116,105,111,110,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,46,32,83,101,101,32,116,104,101,32,39,112,114,105,110,116,102,39,32,104,101,108,112,32,102,111,114,32,100,101,116,97,105,108,115,46,10,10,69,120,97,109,112,108,101,115,58,10,10,116,114,97,99,101,108,111,103,32,34,80,67,61,37,48,52,88,34,44,112,99,10,32,32,79,117,116,112,117,116,115,32,80,67,61,60,112,99,118,97,108,62,32,119,104,101,114,101,32,60,112,99,118,97,108,62,32,105,115,32,100,105,115,112,108,97,121,101,100,32,105,110,32,104,101,120,97,100,101,99,105,109,97,108,32,119,105,116,104,32,52,32,100,105,103,105,116,115,32,119,105,116,104,32,122,101,114,111,45,102,105,108,108,46,10,10,112,114,105,110,116,102,32,34,65,61,37,100,44,32,66,61,37,100,92,110,67,61,37,100,34,44,97,44,98,44,97,43,98,10,32,32,79,117,116,112,117,116,115,32,65,61,60,97,118,97,108,62,44,32,66,61,60,98,118,97,108,62,32,111,110,32,111,110,101,32,108,105,110,101,44,32,97,110,100,32,67,61,60,97,43,98,118,97,108,62,32,111,110,32,97,32,115,101,99,111,110,100,32,108,105,110,101,46,10,0] /* \0A  tracelog <forma */, "i8", ALLOC_STATIC);
STRING_TABLE.__str385938=allocate([115,110,97,112,0] /* snap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str395939=allocate([10,32,32,115,110,97,112,32,91,91,60,102,105,108,101,110,97,109,101,62,93,44,32,60,115,99,114,110,117,109,62,93,10,10,84,104,101,32,115,110,97,112,32,99,111,109,109,97,110,100,32,116,97,107,101,115,32,97,32,115,110,97,112,115,104,111,116,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,118,105,100,101,111,32,100,105,115,112,108,97,121,32,97,110,100,32,115,97,118,101,115,32,105,116,32,116,111,32,116,104,101,32,99,111,110,102,105,103,117,114,101,100,32,115,110,97,112,115,104,111,116,32,100,105,114,101,99,116,111,114,121,46,32,73,102,32,60,102,105,108,101,110,97,109,101,62,32,105,115,32,115,112,101,99,105,102,105,101,100,32,101,120,112,108,105,99,105,116,108,121,44,32,97,32,115,105,110,103,108,101,32,115,99,114,101,101,110,115,104,111,116,32,102,111,114,32,60,115,99,114,110,117,109,62,32,105,115,32,115,97,118,101,100,32,117,110,100,101,114,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,102,105,108,101,110,97,109,101,46,32,73,102,32,60,102,105,108,101,110,97,109,101,62,32,105,115,32,111,109,105,116,116,101,100,44,32,97,108,108,32,115,99,114,101,101,110,115,32,97,114,101,32,115,97,118,101,100,32,117,115,105,110,103,32,116,104,101,32,115,97,109,101,32,100,101,102,97,117,108,116,32,114,117,108,101,115,32,97,115,32,116,104,101,32,34,115,97,118,101,32,115,110,97,112,115,104,111,116,34,32,107,101,121,32,105,110,32,77,65,77,69,32,112,114,111,112,101,114,46,10,10,69,120,97,109,112,108,101,115,58,10,10,115,110,97,112,10,32,32,84,97,107,101,115,32,97,32,115,110,97,112,115,104,111,116,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,118,105,100,101,111,32,115,99,114,101,101,110,32,97,110,100,32,115,97,118,101,115,32,116,111,32,116,104,101,32,110,101,120,116,32,110,111,110,45,99,111,110,102,108,105,99,116,105,110,103,32,102,105,108,101,110,97,109,101,32,32,32,105,110,32,116,104,101,32,99,111,110,102,105,103,117,114,101,100,32,115,110,97,112,115,104,111,116,32,100,105,114,101,99,116,111,114,121,46,10,10,115,110,97,112,32,115,104,105,110,111,98,105,10,32,32,84,97,107,101,115,32,97,32,115,110,97,112,115,104,111,116,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,118,105,100,101,111,32,115,99,114,101,101,110,32,97,110,100,32,115,97,118,101,115,32,105,116,32,97,115,32,39,115,104,105,110,111,98,105,46,112,110,103,39,32,105,110,32,116,104,101,32,99,111,110,102,105,103,117,114,101,100,32,32,32,115,110,97,112,115,104,111,116,32,100,105,114,101,99,116,111,114,121,46,10,0] /* \0A  snap [[<filenam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str405940=allocate([115,111,117,114,99,101,0] /* source\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str415941=allocate([10,32,32,115,111,117,114,99,101,32,60,102,105,108,101,110,97,109,101,62,10,10,84,104,101,32,115,111,117,114,99,101,32,99,111,109,109,97,110,100,32,114,101,97,100,115,32,105,110,32,97,32,115,101,116,32,111,102,32,100,101,98,117,103,103,101,114,32,99,111,109,109,97,110,100,115,32,102,114,111,109,32,97,32,102,105,108,101,32,97,110,100,32,101,120,101,99,117,116,101,115,32,116,104,101,109,32,111,110,101,32,98,121,32,111,110,101,44,32,115,105,109,105,108,97,114,32,116,111,32,97,32,98,97,116,99,104,32,102,105,108,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,115,111,117,114,99,101,32,98,114,101,97,107,95,97,110,100,95,116,114,97,99,101,46,99,109,100,10,32,32,82,101,97,100,115,32,105,110,32,100,101,98,117,103,103,101,114,32,99,111,109,109,97,110,100,115,32,102,114,111,109,32,98,114,101,97,107,95,97,110,100,95,116,114,97,99,101,46,99,109,100,32,97,110,100,32,101,120,101,99,117,116,101,115,32,116,104,101,109,46,10,0] /* \0A  source <filenam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str425942=allocate([113,117,105,116,0] /* quit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str435943=allocate([10,32,32,113,117,105,116,10,10,84,104,101,32,113,117,105,116,32,99,111,109,109,97,110,100,32,101,120,105,116,115,32,77,65,77,69,32,105,109,109,101,100,105,97,116,101,108,121,46,10,0] /* \0A  quit\0A\0AThe q */, "i8", ALLOC_STATIC);
STRING_TABLE.__str445944=allocate([100,97,115,109,0] /* dasm\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str455945=allocate([10,32,32,100,97,115,109,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,111,112,99,111,100,101,115,62,91,44,60,99,112,117,62,93,93,10,10,84,104,101,32,100,97,115,109,32,99,111,109,109,97,110,100,32,100,105,115,97,115,115,101,109,98,108,101,115,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,60,102,105,108,101,110,97,109,101,62,32,112,97,114,97,109,101,116,101,114,46,32,60,97,100,100,114,101,115,115,62,32,105,110,100,105,99,97,116,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,111,102,32,116,104,101,32,115,116,97,114,116,32,111,102,32,100,105,115,97,115,115,101,109,98,108,121,44,32,97,110,100,32,60,108,101,110,103,116,104,62,32,105,110,100,105,99,97,116,101,115,32,104,111,119,32,109,117,99,104,32,109,101,109,111,114,121,32,116,111,32,100,105,115,97,115,115,101,109,98,108,101,46,32,84,104,101,32,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,32,116,104,114,111,117,103,104,32,60,97,100,100,114,101,115,115,62,43,60,108,101,110,103,116,104,62,45,49,32,105,110,99,108,117,115,105,118,101,32,119,105,108,108,32,98,101,32,111,117,116,112,117,116,32,116,111,32,116,104,101,32,102,105,108,101,46,32,66,121,32,100,101,102,97,117,108,116,44,32,116,104,101,32,114,97,119,32,111,112,99,111,100,101,32,100,97,116,97,32,105,115,32,111,117,116,112,117,116,32,119,105,116,104,32,101,97,99,104,32,108,105,110,101,46,32,84,104,101,32,111,112,116,105,111,110,97,108,32,60,111,112,99,111,100,101,115,62,32,112,97,114,97,109,101,116,101,114,32,99,97,110,32,98,101,32,117,115,101,100,32,116,111,32,101,110,97,98,108,101,32,40,49,41,32,111,114,32,100,105,115,97,98,108,101,40,48,41,32,116,104,105,115,32,102,101,97,116,117,114,101,46,32,70,105,110,97,108,108,121,44,32,121,111,117,32,99,97,110,32,100,105,115,97,115,115,101,109,98,108,101,32,99,111,100,101,32,102,114,111,109,32,97,110,111,116,104,101,114,32,67,80,85,32,98,121,32,115,112,101,99,105,102,121,105,110,103,32,116,104,101,32,60,99,112,117,62,32,112,97,114,97,109,101,116,101,114,46,10,10,69,120,97,109,112,108,101,115,58,10,10,100,97,115,109,32,118,101,110,116,117,114,101,46,97,115,109,44,48,44,49,48,48,48,48,10,32,32,68,105,115,97,115,115,101,109,98,108,101,115,32,97,100,100,114,101,115,115,101,115,32,48,45,102,102,102,102,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,44,32,105,110,99,108,117,100,105,110,103,32,114,97,119,32,111,112,99,111,100,101,32,100,97,116,97,44,32,116,111,32,116,104,101,32,102,105,108,101,32,39,118,101,110,116,117,114,101,46,97,115,109,39,46,10,10,100,97,115,109,32,104,97,114,100,100,114,105,118,46,97,115,109,44,51,48,48,48,44,49,48,48,48,44,48,44,50,10,32,32,68,105,115,97,115,115,101,109,98,108,101,115,32,97,100,100,114,101,115,115,101,115,32,51,48,48,48,45,51,102,102,102,32,102,114,111,109,32,67,80,85,32,35,50,44,32,119,105,116,104,32,110,111,32,114,97,119,32,111,112,99,111,100,101,32,100,97,116,97,44,32,116,111,32,116,104,101,32,102,105,108,101,32,39,104,97,114,100,100,114,105,118,46,97,115,109,39,46,10,0] /* \0A  dasm <filename> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str465946=allocate([102,105,110,100,0] /* find\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str475947=allocate([10,32,32,102,91,105,110,100,93,91,123,100,124,105,125,93,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,100,97,116,97,62,91,44,46,46,46,93,93,10,10,84,104,101,32,102,105,110,100,47,102,105,110,100,100,47,102,105,110,100,105,32,99,111,109,109,97,110,100,115,32,115,101,97,114,99,104,32,116,104,114,111,117,103,104,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,115,101,113,117,101,110,99,101,32,111,102,32,100,97,116,97,46,32,39,102,105,110,100,39,32,119,105,108,108,32,115,101,97,114,99,104,32,112,114,111,103,114,97,109,32,115,112,97,99,101,32,109,101,109,111,114,121,44,32,119,104,105,108,101,32,39,102,105,110,100,100,39,32,119,105,108,108,32,115,101,97,114,99,104,32,100,97,116,97,32,115,112,97,99,101,32,109,101,109,111,114,121,32,97,110,100,32,39,102,105,110,100,105,39,32,119,105,108,108,32,115,101,97,114,99,104,32,73,47,79,32,115,112,97,99,101,32,109,101,109,111,114,121,46,32,60,97,100,100,114,101,115,115,62,32,105,110,100,105,99,97,116,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,116,111,32,98,101,103,105,110,32,115,101,97,114,99,104,105,110,103,44,32,97,110,100,32,60,108,101,110,103,116,104,62,32,105,110,100,105,99,97,116,101,115,32,104,111,119,32,109,117,99,104,32,109,101,109,111,114,121,32,116,111,32,115,101,97,114,99,104,46,32,60,100,97,116,97,62,32,99,97,110,32,101,105,116,104,101,114,32,98,101,32,97,32,113,117,111,116,101,100,32,115,116,114,105,110,103,32,111,114,32,97,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,111,114,32,101,120,112,114,101,115,115,105,111,110,32,111,114,32,116,104,101,32,119,105,108,100,99,97,114,100,32,99,104,97,114,97,99,116,101,114,32,39,63,39,46,32,83,116,114,105,110,103,115,32,98,121,32,100,101,102,97,117,108,116,32,105,109,112,108,121,32,97,32,98,121,116,101,45,115,105,122,101,100,32,115,101,97,114,99,104,59,32,110,111,110,45,115,116,114,105,110,103,32,100,97,116,97,32,105,115,32,115,101,97,114,99,104,101,100,32,98,121,32,100,101,102,97,117,108,116,32,105,110,32,116,104,101,32,110,97,116,105,118,101,32,119,111,114,100,32,115,105,122,101,32,111,102,32,116,104,101,32,67,80,85,46,32,84,111,32,111,118,101,114,114,105,100,101,32,116,104,101,32,115,101,97,114,99,104,32,115,105,122,101,32,102,111,114,32,110,111,110,45,115,116,114,105,110,103,115,44,32,121,111,117,32,99,97,110,32,112,114,101,102,105,120,32,116,104,101,32,118,97,108,117,101,32,119,105,116,104,32,98,46,32,116,111,32,102,111,114,99,101,32,98,121,116,101,45,32,115,105,122,101,100,32,115,101,97,114,99,104,44,32,119,46,32,102,111,114,32,119,111,114,100,45,115,105,122,101,100,32,115,101,97,114,99,104,44,32,100,46,32,102,111,114,32,100,119,111,114,100,45,115,105,122,101,100,44,32,97,110,100,32,113,46,32,102,111,114,32,113,119,111,114,100,45,115,105,122,101,100,46,32,79,118,101,114,114,105,100,101,115,32,97,114,101,32,114,101,109,101,109,98,101,114,101,100,44,32,115,111,32,105,102,32,121,111,117,32,119,97,110,116,32,116,111,32,115,101,97,114,99,104,32,102,111,114,32,97,32,115,101,114,105,101,115,32,111,102,32,119,111,114,100,115,44,32,121,111,117,32,110,101,101,100,32,111,110,108,121,32,116,111,32,112,114,101,102,105,120,32,116,104,101,32,102,105,114,115,116,32,118,97,108,117,101,32,119,105,116,104,32,97,32,119,46,32,78,111,116,101,32,97,108,115,111,32,116,104,97,116,32,121,111,117,32,99,97,110,32,105,110,116,101,114,109,105,120,32,115,105,122,101,115,32,105,110,32,111,114,100,101,114,32,116,111,32,112,101,114,102,111,114,109,32,109,111,114,101,32,99,111,109,112,108,101,120,32,115,101,97,114,99,104,101,115,46,32,84,104,101,32,101,110,116,105,114,101,32,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,32,116,104,114,111,117,103,104,32,60,97,100,100,114,101,115,115,62,43,60,108,101,110,103,116,104,62,45,49,32,32,105,110,99,108,117,115,105,118,101,32,119,105,108,108,32,98,101,32,115,101,97,114,99,104,101,100,32,102,111,114,32,116,104,101,32,115,101,113,117,101,110,99,101,44,32,97,110,100,32,97,108,108,32,111,99,99,117,114,114,101,110,99,101,115,32,119,105,108,108,32,98,101,32,100,105,115,112,108,97,121,101,100,46,10,10,69,120,97,109,112,108,101,115,58,10,10,102,105,110,100,32,48,44,49,48,48,48,48,44,34,72,73,71,72,32,83,67,79,82,69,34,44,48,10,32,32,83,101,97,114,99,104,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,114,97,110,103,101,32,48,45,102,102,102,102,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,32,102,111,114,32,116,104,101,32,115,116,114,105,110,103,32,34,72,73,71,72,32,83,67,79,82,69,34,32,102,111,108,108,111,119,101,100,32,98,121,32,97,32,48,32,98,121,116,101,46,10,10,102,105,110,100,100,32,51,48,48,48,44,49,48,48,48,44,119,46,97,98,99,100,44,52,53,54,55,10,32,32,83,101,97,114,99,104,101,115,32,116,104,101,32,100,97,116,97,32,109,101,109,111,114,121,32,97,100,100,114,101,115,115,32,114,97,110,103,101,32,51,48,48,48,45,51,102,102,102,32,102,111,114,32,116,104,101,32,119,111,114,100,45,115,105,122,101,100,32,118,97,108,117,101,32,97,98,99,100,32,102,111,108,108,111,119,101,100,32,98,121,32,116,104,101,32,119,111,114,100,45,115,105,122,101,100,32,118,97,108,117,101,32,52,53,54,55,46,10,10,102,105,110,100,32,48,44,56,48,48,48,44,34,65,65,82,34,44,100,46,48,44,34,66,69,78,34,44,119,46,48,10,32,32,83,101,97,114,99,104,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,114,97,110,103,101,32,48,48,48,48,45,55,102,102,102,32,102,111,114,32,116,104,101,32,115,116,114,105,110,103,32,34,65,65,82,34,32,102,111,108,108,111,119,101,100,32,98,121,32,97,32,100,119,111,114,100,45,115,105,122,101,100,32,48,32,102,111,108,108,111,119,101,100,32,98,121,32,116,104,101,32,115,116,114,105,110,103,32,34,66,69,78,34,44,32,102,111,108,108,111,119,101,100,32,98,121,32,97,32,119,111,114,100,45,115,105,122,101,100,32,48,46,10,0] /* \0A  f[ind][{d|i}] < */, "i8", ALLOC_STATIC);
STRING_TABLE.__str485948=allocate([100,117,109,112,0] /* dump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str495949=allocate([10,32,32,100,117,109,112,91,123,100,124,105,125,93,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,115,105,122,101,62,91,44,60,97,115,99,105,105,62,91,44,60,99,112,117,62,93,93,93,10,10,84,104,101,32,100,117,109,112,47,100,117,109,112,100,47,100,117,109,112,105,32,99,111,109,109,97,110,100,115,32,100,117,109,112,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,116,101,120,116,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,60,102,105,108,101,110,97,109,101,62,32,112,97,114,97,109,101,116,101,114,46,32,39,100,117,109,112,39,32,119,105,108,108,32,100,117,109,112,32,112,114,111,103,114,97,109,32,115,112,97,99,101,32,109,101,109,111,114,121,44,32,119,104,105,108,101,32,39,100,117,109,112,100,39,32,119,105,108,108,32,100,117,109,112,32,100,97,116,97,32,115,112,97,99,101,32,109,101,109,111,114,121,32,97,110,100,32,39,100,117,109,112,105,39,32,119,105,108,108,32,100,117,109,112,32,73,47,79,32,115,112,97,99,101,32,109,101,109,111,114,121,46,32,60,97,100,100,114,101,115,115,62,32,105,110,100,105,99,97,116,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,111,102,32,116,104,101,32,115,116,97,114,116,32,111,102,32,100,117,109,112,105,110,103,44,32,97,110,100,32,60,108,101,110,103,116,104,62,32,105,110,100,105,99,97,116,101,115,32,104,111,119,32,109,117,99,104,32,109,101,109,111,114,121,32,116,111,32,100,117,109,112,46,32,84,104,101,32,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,32,116,104,114,111,117,103,104,32,60,97,100,100,114,101,115,115,62,43,60,108,101,110,103,116,104,62,45,49,32,105,110,99,108,117,115,105,118,101,32,119,105,108,108,32,98,101,32,111,117,116,112,117,116,32,116,111,32,116,104,101,32,102,105,108,101,46,32,66,121,32,100,101,102,97,117,108,116,44,32,116,104,101,32,100,97,116,97,32,119,105,108,108,32,98,101,32,111,117,116,112,117,116,32,105,110,32,98,121,116,101,32,102,111,114,109,97,116,44,32,117,110,108,101,115,115,32,116,104,101,32,117,110,100,101,114,108,121,105,110,103,32,97,100,100,114,101,115,115,32,115,112,97,99,101,32,105,115,32,119,111,114,100,47,100,119,111,114,100,47,113,119,111,114,100,45,111,110,108,121,46,32,89,111,117,32,99,97,110,32,111,118,101,114,114,105,100,101,32,116,104,105,115,32,98,121,32,115,112,101,99,105,102,121,105,110,103,32,116,104,101,32,60,115,105,122,101,62,32,112,97,114,97,109,101,116,101,114,44,32,119,104,105,99,104,32,99,97,110,32,98,101,32,117,115,101,100,32,116,111,32,103,114,111,117,112,32,116,104,101,32,100,97,116,97,32,105,110,32,49,44,32,50,44,32,52,32,111,114,32,56,45,98,121,116,101,32,99,104,117,110,107,115,46,32,84,104,101,32,111,112,116,105,111,110,97,108,32,60,97,115,99,105,105,62,32,112,97,114,97,109,101,116,101,114,32,99,97,110,32,98,101,32,117,115,101,100,32,116,111,32,101,110,97,98,108,101,32,40,49,41,32,111,114,32,100,105,115,97,98,108,101,32,40,48,41,32,116,104,101,32,111,117,116,112,117,116,32,111,102,32,65,83,67,73,73,32,99,104,97,114,97,99,116,101,114,115,32,116,111,32,116,104,101,32,114,105,103,104,116,32,111,102,32,101,97,99,104,32,108,105,110,101,59,32,98,121,32,100,101,102,97,117,108,116,44,32,116,104,105,115,32,105,115,32,101,110,97,98,108,101,100,46,32,70,105,110,97,108,108,121,44,32,121,111,117,32,99,97,110,32,100,117,109,112,32,109,101,109,111,114,121,32,102,114,111,109,32,97,110,111,116,104,101,114,32,67,80,85,32,98,121,32,115,112,101,99,105,102,121,105,110,103,32,116,104,101,32,60,99,112,117,62,32,112,97,114,97,109,101,116,101,114,46,10,10,69,120,97,109,112,108,101,115,58,10,10,100,117,109,112,32,118,101,110,116,117,114,101,46,100,109,112,44,48,44,49,48,48,48,48,10,32,32,68,117,109,112,115,32,97,100,100,114,101,115,115,101,115,32,48,45,102,102,102,102,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,32,105,110,32,49,45,98,121,116,101,32,99,104,117,110,107,115,44,32,105,110,99,108,117,100,105,110,103,32,65,83,67,73,73,32,100,97,116,97,44,32,116,111,32,116,104,101,32,102,105,108,101,32,39,118,101,110,116,117,114,101,46,100,109,112,39,46,10,10,100,117,109,112,100,32,104,97,114,100,100,114,105,118,46,100,109,112,44,51,48,48,48,44,49,48,48,48,44,52,44,48,44,51,10,32,32,68,117,109,112,115,32,100,97,116,97,32,109,101,109,111,114,121,32,97,100,100,114,101,115,115,101,115,32,51,48,48,48,45,51,102,102,102,32,102,114,111,109,32,67,80,85,32,35,51,32,105,110,32,52,45,98,121,116,101,32,99,104,117,110,107,115,44,32,119,105,116,104,32,110,111,32,65,83,67,73,73,32,100,97,116,97,44,32,116,111,32,116,104,101,32,102,105,108,101,32,39,104,97,114,100,100,114,105,118,46,100,109,112,39,46,10,0] /* \0A  dump[{d|i}] <fi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str505950=allocate([115,97,118,101,0] /* save\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str515951=allocate([10,32,32,115,97,118,101,91,123,100,124,105,125,93,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,10,10,84,104,101,32,115,97,118,101,47,115,97,118,101,100,47,115,97,118,101,105,32,99,111,109,109,97,110,100,115,32,115,97,118,101,32,114,97,119,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,98,105,110,97,114,121,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,60,102,105,108,101,110,97,109,101,62,32,112,97,114,97,109,101,116,101,114,46,32,39,115,97,118,101,39,32,119,105,108,108,32,115,97,118,101,32,112,114,111,103,114,97,109,32,115,112,97,99,101,32,109,101,109,111,114,121,44,32,119,104,105,108,101,32,39,115,97,118,101,100,39,32,119,105,108,108,32,115,97,118,101,32,100,97,116,97,32,115,112,97,99,101,32,109,101,109,111,114,121,32,97,110,100,32,39,115,97,118,101,105,39,32,119,105,108,108,32,115,97,118,101,32,73,47,79,32,115,112,97,99,101,32,109,101,109,111,114,121,46,32,60,97,100,100,114,101,115,115,62,32,105,110,100,105,99,97,116,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,111,102,32,116,104,101,32,115,116,97,114,116,32,111,102,32,115,97,118,105,110,103,44,32,97,110,100,32,60,108,101,110,103,116,104,62,32,105,110,100,105,99,97,116,101,115,32,104,111,119,32,109,117,99,104,32,109,101,109,111,114,121,32,116,111,32,115,97,118,101,46,32,84,104,101,32,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,32,116,104,114,111,117,103,104,32,60,97,100,100,114,101,115,115,62,43,60,108,101,110,103,116,104,62,45,49,32,105,110,99,108,117,115,105,118,101,32,119,105,108,108,32,98,101,32,111,117,116,112,117,116,32,116,111,32,116,104,101,32,102,105,108,101,46,32,89,111,117,32,99,97,110,32,97,108,115,111,32,115,97,118,101,32,109,101,109,111,114,121,32,102,114,111,109,32,97,110,111,116,104,101,114,32,67,80,85,32,98,121,32,115,112,101,99,105,102,121,105,110,103,32,116,104,101,32,60,99,112,117,62,32,112,97,114,97,109,101,116,101,114,46,10,10,69,120,97,109,112,108,101,115,58,10,10,115,97,118,101,32,118,101,110,116,117,114,101,46,98,105,110,44,48,44,49,48,48,48,48,10,32,32,83,97,118,101,115,32,97,100,100,114,101,115,115,101,115,32,48,45,102,102,102,102,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,32,116,111,32,116,104,101,32,98,105,110,97,114,121,32,102,105,108,101,32,39,118,101,110,116,117,114,101,46,98,105,110,39,46,10,10,115,97,118,101,100,32,104,97,114,100,100,114,105,118,46,98,105,110,44,51,48,48,48,44,49,48,48,48,44,51,10,32,32,83,97,118,101,115,32,100,97,116,97,32,109,101,109,111,114,121,32,97,100,100,114,101,115,115,101,115,32,51,48,48,48,45,51,102,102,102,32,102,114,111,109,32,67,80,85,32,35,51,32,116,111,32,116,104,101,32,98,105,110,97,114,121,32,102,105,108,101,32,39,104,97,114,100,100,114,105,118,46,98,105,110,39,46,10,0] /* \0A  save[{d|i}] <fi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str525952=allocate([108,111,97,100,0] /* load\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str535953=allocate([10,32,32,108,111,97,100,91,123,100,124,105,125,93,32,60,102,105,108,101,110,97,109,101,62,44,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,10,10,84,104,101,32,108,111,97,100,47,108,111,97,100,100,47,108,111,97,100,105,32,99,111,109,109,97,110,100,115,32,108,111,97,100,32,114,97,119,32,109,101,109,111,114,121,32,102,114,111,109,32,116,104,101,32,98,105,110,97,114,121,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,105,110,32,116,104,101,32,60,102,105,108,101,110,97,109,101,62,32,112,97,114,97,109,101,116,101,114,46,32,39,108,111,97,100,39,32,119,105,108,108,32,108,111,97,100,32,112,114,111,103,114,97,109,32,115,112,97,99,101,32,109,101,109,111,114,121,44,32,119,104,105,108,101,32,39,108,111,97,100,100,39,32,119,105,108,108,32,108,111,97,100,32,100,97,116,97,32,115,112,97,99,101,32,109,101,109,111,114,121,32,97,110,100,32,39,108,111,97,100,105,39,32,119,105,108,108,32,108,111,97,100,32,73,47,79,32,115,112,97,99,101,32,109,101,109,111,114,121,46,32,60,97,100,100,114,101,115,115,62,32,105,110,100,105,99,97,116,101,115,32,116,104,101,32,97,100,100,114,101,115,115,32,111,102,32,116,104,101,32,115,116,97,114,116,32,111,102,32,115,97,118,105,110,103,44,32,97,110,100,32,60,108,101,110,103,116,104,62,32,105,110,100,105,99,97,116,101,115,32,104,111,119,32,109,117,99,104,32,109,101,109,111,114,121,32,116,111,32,108,111,97,100,46,32,84,104,101,32,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,32,116,104,114,111,117,103,104,32,60,97,100,100,114,101,115,115,62,43,60,108,101,110,103,116,104,62,45,49,32,105,110,99,108,117,115,105,118,101,32,119,105,108,108,32,98,101,32,114,101,97,100,32,105,110,32,102,114,111,109,32,116,104,101,32,102,105,108,101,46,32,73,102,32,121,111,117,32,115,112,101,99,105,102,121,32,60,108,101,110,103,116,104,62,32,61,32,48,32,111,114,32,97,32,108,101,110,103,116,104,32,103,114,101,97,116,101,114,32,116,104,97,110,32,116,104,101,32,116,111,116,97,108,32,108,101,110,103,116,104,32,111,102,32,116,104,101,32,102,105,108,101,32,105,116,32,119,105,108,108,32,108,111,97,100,32,116,104,101,32,101,110,116,105,114,101,32,99,111,110,116,101,110,116,115,32,111,102,32,116,104,101,32,102,105,108,101,32,97,110,100,32,110,111,32,109,111,114,101,46,32,89,111,117,32,99,97,110,32,97,108,115,111,32,108,111,97,100,32,109,101,109,111,114,121,32,102,114,111,109,32,97,110,111,116,104,101,114,32,67,80,85,32,98,121,32,115,112,101,99,105,102,121,105,110,103,32,116,104,101,32,60,99,112,117,62,32,112,97,114,97,109,101,116,101,114,46,10,78,79,84,69,58,32,84,104,105,115,32,119,105,108,108,32,111,110,108,121,32,97,99,116,117,97,108,108,121,32,119,114,105,116,101,32,109,101,109,111,114,121,32,116,104,97,116,32,105,115,32,112,111,115,115,105,98,108,101,32,116,111,32,111,118,101,114,119,114,105,116,101,32,105,110,32,116,104,101,32,77,101,109,111,114,121,32,87,105,110,100,111,119,10,10,69,120,97,109,112,108,101,115,58,10,10,108,111,97,100,32,118,101,110,116,117,114,101,46,98,105,110,44,48,44,49,48,48,48,48,10,32,32,76,111,97,100,115,32,97,100,100,114,101,115,115,101,115,32,48,45,102,102,102,102,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,32,102,114,111,109,32,116,104,101,32,98,105,110,97,114,121,32,102,105,108,101,32,39,118,101,110,116,117,114,101,46,98,105,110,39,46,10,10,108,111,97,100,100,32,104,97,114,100,100,114,105,118,46,98,105,110,44,51,48,48,48,44,49,48,48,48,44,51,10,32,32,76,111,97,100,115,32,100,97,116,97,32,109,101,109,111,114,121,32,97,100,100,114,101,115,115,101,115,32,51,48,48,48,45,51,102,102,102,32,102,114,111,109,32,67,80,85,32,35,51,32,102,114,111,109,32,116,104,101,32,98,105,110,97,114,121,32,102,105,108,101,32,39,104,97,114,100,100,114,105,118,46,98,105,110,39,46,10,0] /* \0A  load[{d|i}] <fi */, "i8", ALLOC_STATIC);
STRING_TABLE.__str545954=allocate([115,116,101,112,0] /* step\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str555955=allocate([10,32,32,115,91,116,101,112,93,32,91,60,99,111,117,110,116,62,61,49,93,10,10,84,104,101,32,115,116,101,112,32,99,111,109,109,97,110,100,32,115,105,110,103,108,101,32,115,116,101,112,115,32,111,110,101,32,111,114,32,109,111,114,101,32,105,110,115,116,114,117,99,116,105,111,110,115,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,101,120,101,99,117,116,105,110,103,32,67,80,85,46,32,66,121,32,100,101,102,97,117,108,116,44,32,115,116,101,112,32,101,120,101,99,117,116,101,115,32,111,110,101,32,105,110,115,116,114,117,99,116,105,111,110,32,101,97,99,104,32,116,105,109,101,32,105,116,32,105,115,32,105,115,115,117,101,100,46,32,89,111,117,32,99,97,110,32,97,108,115,111,32,116,101,108,108,32,115,116,101,112,32,116,111,32,115,116,101,112,32,109,117,108,116,105,112,108,101,32,105,110,115,116,114,117,99,116,105,111,110,115,32,98,121,32,105,110,99,108,117,100,105,110,103,32,116,104,101,32,111,112,116,105,111,110,97,108,32,60,99,111,117,110,116,62,32,112,97,114,97,109,101,116,101,114,46,10,10,69,120,97,109,112,108,101,115,58,10,10,115,10,32,32,83,116,101,112,115,32,102,111,114,119,97,114,100,32,111,110,101,32,105,110,115,116,114,117,99,116,105,111,110,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,10,10,115,116,101,112,32,52,10,32,32,83,116,101,112,115,32,102,111,114,119,97,114,100,32,102,111,117,114,32,105,110,115,116,114,117,99,116,105,111,110,115,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,10,0] /* \0A  s[tep] [<count> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str565956=allocate([111,118,101,114,0] /* over\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str575957=allocate([10,32,32,111,91,118,101,114,93,32,91,60,99,111,117,110,116,62,61,49,93,10,10,84,104,101,32,111,118,101,114,32,99,111,109,109,97,110,100,32,115,105,110,103,108,101,32,115,116,101,112,115,32,34,111,118,101,114,34,32,111,110,101,32,111,114,32,109,111,114,101,32,105,110,115,116,114,117,99,116,105,111,110,115,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,101,120,101,99,117,116,105,110,103,32,67,80,85,44,32,115,116,101,112,112,105,110,103,32,111,118,101,114,32,115,117,98,114,111,117,116,105,110,101,32,99,97,108,108,115,32,97,110,100,32,101,120,99,101,112,116,105,111,110,32,104,97,110,100,108,101,114,32,116,114,97,112,115,32,97,110,100,32,99,111,117,110,116,105,110,103,32,116,104,101,109,32,97,115,32,97,32,115,105,110,103,108,101,32,105,110,115,116,114,117,99,116,105,111,110,46,32,78,111,116,101,32,116,104,97,116,32,119,104,101,110,32,115,116,101,112,112,105,110,103,32,111,118,101,114,32,97,32,115,117,98,114,111,117,116,105,110,101,32,99,97,108,108,44,32,99,111,100,101,32,109,97,121,32,101,120,101,99,117,116,101,32,111,110,32,111,116,104,101,114,32,67,80,85,115,32,98,101,102,111,114,101,32,116,104,101,32,115,117,98,114,111,117,116,105,110,101,32,99,97,108,108,32,99,111,109,112,108,101,116,101,115,46,32,66,121,32,100,101,102,97,117,108,116,44,32,111,118,101,114,32,101,120,101,99,117,116,101,115,32,111,110,101,32,105,110,115,116,114,117,99,116,105,111,110,32,101,97,99,104,32,116,105,109,101,32,105,116,32,105,115,32,105,115,115,117,101,100,46,32,89,111,117,32,99,97,110,32,97,108,115,111,32,116,101,108,108,32,115,116,101,112,32,116,111,32,115,116,101,112,32,109,117,108,116,105,112,108,101,32,105,110,115,116,114,117,99,116,105,111,110,115,32,98,121,32,105,110,99,108,117,100,105,110,103,32,116,104,101,32,111,112,116,105,111,110,97,108,32,60,99,111,117,110,116,62,32,112,97,114,97,109,101,116,101,114,46,10,10,78,111,116,101,32,116,104,97,116,32,116,104,101,32,115,116,101,112,32,111,118,101,114,32,102,117,110,99,116,105,111,110,97,108,105,116,121,32,109,97,121,32,110,111,116,32,98,101,32,105,109,112,108,101,109,101,110,116,101,100,32,111,110,32,97,108,108,32,67,80,85,32,116,121,112,101,115,46,32,73,102,32,105,116,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,44,32,116,104,101,110,32,39,111,118,101,114,39,32,119,105,108,108,32,98,101,104,97,118,101,32,101,120,97,99,116,108,121,32,108,105,107,101,32,39,115,116,101,112,39,46,10,10,69,120,97,109,112,108,101,115,58,10,10,111,10,32,32,83,116,101,112,115,32,102,111,114,119,97,114,100,32,111,118,101,114,32,111,110,101,32,105,110,115,116,114,117,99,116,105,111,110,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,10,10,111,118,101,114,32,52,10,32,32,83,116,101,112,115,32,102,111,114,119,97,114,100,32,111,118,101,114,32,102,111,117,114,32,105,110,115,116,114,117,99,116,105,111,110,115,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,10,0] /* \0A  o[ver] [<count> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str585958=allocate([111,117,116,0] /* out\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str595959=allocate([10,32,32,111,117,116,10,10,84,104,101,32,111,117,116,32,99,111,109,109,97,110,100,32,115,105,110,103,108,101,32,115,116,101,112,115,32,117,110,116,105,108,32,105,116,32,101,110,99,111,117,110,116,101,114,115,32,97,32,114,101,116,117,114,110,32,102,114,111,109,32,115,117,98,114,111,117,116,105,110,101,32,111,114,32,114,101,116,117,114,110,32,102,114,111,109,32,101,120,99,101,112,116,105,111,110,32,105,110,115,116,114,117,99,116,105,111,110,46,32,78,111,116,101,32,116,104,97,116,32,98,101,99,97,117,115,101,32,105,116,32,100,101,116,101,99,116,115,32,114,101,116,117,114,110,32,102,114,111,109,32,101,120,99,101,112,116,105,111,110,32,99,111,110,100,105,116,105,111,110,115,44,32,105,102,32,121,111,117,32,97,116,116,101,109,112,116,32,116,111,32,115,116,101,112,32,111,117,116,32,111,102,32,97,32,115,117,98,114,111,117,116,105,110,101,32,97,110,100,32,97,110,32,105,110,116,101,114,114,117,112,116,47,101,120,99,101,112,116,105,111,110,32,111,99,99,117,114,115,32,98,101,102,111,114,101,32,121,111,117,32,104,105,116,32,116,104,101,32,101,110,100,44,32,116,104,101,110,32,121,111,117,32,109,97,121,32,115,116,111,112,32,112,114,101,109,97,116,117,114,101,108,121,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,101,120,99,101,112,116,105,111,110,32,104,97,110,100,108,101,114,46,10,10,78,111,116,101,32,116,104,97,116,32,116,104,101,32,115,116,101,112,32,111,117,116,32,102,117,110,99,116,105,111,110,97,108,105,116,121,32,109,97,121,32,110,111,116,32,98,101,32,105,109,112,108,101,109,101,110,116,101,100,32,111,110,32,97,108,108,32,67,80,85,32,116,121,112,101,115,46,32,73,102,32,105,116,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,44,32,116,104,101,110,32,39,111,117,116,39,32,119,105,108,108,32,98,101,104,97,118,101,32,101,120,97,99,116,108,121,32,108,105,107,101,32,39,115,116,101,112,39,46,10,10,69,120,97,109,112,108,101,115,58,10,10,111,117,116,10,32,32,83,116,101,112,115,32,117,110,116,105,108,32,116,104,101,32,99,117,114,114,101,110,116,32,115,117,98,114,111,117,116,105,110,101,32,111,114,32,101,120,99,101,112,116,105,111,110,32,104,97,110,100,108,101,114,32,114,101,116,117,114,110,115,46,10,0] /* \0A  out\0A\0AThe ou */, "i8", ALLOC_STATIC);
STRING_TABLE.__str605960=allocate([103,111,0] /* go\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str615961=allocate([10,32,32,103,91,111,93,32,91,60,97,100,100,114,101,115,115,62,93,10,10,84,104,101,32,103,111,32,99,111,109,109,97,110,100,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,99,111,100,101,46,32,67,111,110,116,114,111,108,32,119,105,108,108,32,110,111,116,32,98,101,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,117,110,116,105,108,32,97,32,98,114,101,97,107,112,111,105,110,116,32,111,114,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,104,105,116,44,32,111,114,32,117,110,116,105,108,32,121,111,117,32,109,97,110,117,97,108,108,121,32,98,114,101,97,107,32,105,110,32,117,115,105,110,103,32,116,104,101,32,97,115,115,105,103,110,101,100,32,107,101,121,46,32,84,104,101,32,103,111,32,99,111,109,109,97,110,100,32,116,97,107,101,115,32,97,110,32,111,112,116,105,111,110,97,108,32,60,97,100,100,114,101,115,115,62,32,112,97,114,97,109,101,116,101,114,32,119,104,105,99,104,32,105,115,32,97,32,116,101,109,112,111,114,97,114,121,32,117,110,99,111,110,100,105,116,105,111,110,97,108,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,105,115,32,115,101,116,32,98,101,102,111,114,101,32,101,120,101,99,117,116,105,110,103,44,32,97,110,100,32,97,117,116,111,109,97,116,105,99,97,108,108,121,32,114,101,109,111,118,101,100,32,119,104,101,110,32,104,105,116,46,32,10,69,120,97,109,112,108,101,115,58,10,10,103,10,32,32,82,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,98,114,101,97,107,47,119,97,116,99,104,112,111,105,110,116,32,111,114,32,117,110,116,105,108,32,97,32,109,97,110,117,97,108,32,98,114,101,97,107,46,10,10,103,32,49,50,51,52,10,32,32,82,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,44,32,115,116,111,112,112,105,110,103,32,97,116,32,97,100,100,114,101,115,115,32,49,50,51,52,32,117,110,108,101,115,115,32,115,111,109,101,116,104,105,110,103,32,101,108,115,101,32,115,116,111,112,115,32,117,115,32,102,105,114,115,116,46,10,0] /* \0A  g[o] [<address> */, "i8", ALLOC_STATIC);
STRING_TABLE.__str625962=allocate([103,118,98,108,97,110,107,0] /* gvblank\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str635963=allocate([10,32,32,103,118,91,98,108,97,110,107,93,10,10,84,104,101,32,103,118,98,108,97,110,107,32,99,111,109,109,97,110,100,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,99,111,100,101,46,32,67,111,110,116,114,111,108,32,119,105,108,108,32,110,111,116,32,98,101,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,117,110,116,105,108,32,97,32,98,114,101,97,107,112,111,105,110,116,32,111,114,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,104,105,116,44,32,111,114,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,86,66,76,65,78,75,32,111,99,99,117,114,115,32,105,110,32,116,104,101,32,101,109,117,108,97,116,111,114,46,10,10,69,120,97,109,112,108,101,115,58,10,10,103,118,10,32,32,82,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,98,114,101,97,107,47,119,97,116,99,104,112,111,105,110,116,32,111,114,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,86,66,76,65,78,75,46,10,0] /* \0A  gv[blank]\0A\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str645964=allocate([103,105,110,116,0] /* gint\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str655965=allocate([10,32,32,103,105,91,110,116,93,32,91,60,105,114,113,108,105,110,101,62,93,10,10,84,104,101,32,103,105,110,116,32,99,111,109,109,97,110,100,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,99,111,100,101,46,32,67,111,110,116,114,111,108,32,119,105,108,108,32,110,111,116,32,98,101,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,117,110,116,105,108,32,97,32,98,114,101,97,107,112,111,105,110,116,32,111,114,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,104,105,116,44,32,111,114,32,117,110,116,105,108,32,97,110,32,73,82,81,32,105,115,32,97,115,115,101,114,116,101,100,32,97,110,100,32,97,99,107,110,111,119,108,101,100,103,101,100,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,32,89,111,117,32,99,97,110,32,115,112,101,99,105,102,121,32,60,105,114,113,108,105,110,101,62,32,105,102,32,121,111,117,32,119,105,115,104,32,116,111,32,115,116,111,112,32,101,120,101,99,117,116,105,111,110,32,111,110,108,121,32,111,110,32,97,32,112,97,114,116,105,99,117,108,97,114,32,73,82,81,32,108,105,110,101,32,98,101,105,110,103,32,97,115,115,101,114,116,101,100,32,97,110,100,32,97,99,107,110,111,119,108,101,100,103,101,100,46,32,73,102,32,60,105,114,113,108,105,110,101,62,32,105,115,32,111,109,105,116,116,101,100,44,32,116,104,101,110,32,97,110,121,32,73,82,81,32,108,105,110,101,32,119,105,108,108,32,115,116,111,112,32,101,120,101,99,117,116,105,111,110,46,10,10,69,120,97,109,112,108,101,115,58,10,10,103,105,10,32,32,82,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,98,114,101,97,107,47,119,97,116,99,104,112,111,105,110,116,32,111,114,32,117,110,116,105,108,32,97,110,121,32,73,82,81,32,105,115,32,97,115,115,101,114,116,101,100,32,97,110,100,32,97,99,107,110,111,119,108,101,100,103,101,100,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,10,10,103,105,110,116,32,52,10,32,32,82,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,98,114,101,97,107,47,119,97,116,99,104,112,111,105,110,116,32,111,114,32,117,110,116,105,108,32,73,82,81,32,108,105,110,101,32,52,32,105,115,32,97,115,115,101,114,116,101,100,32,97,110,100,32,97,99,107,110,111,119,108,101,100,103,101,100,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,67,80,85,46,10,0] /* \0A  gi[nt] [<irqlin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str665966=allocate([103,116,105,109,101,0] /* gtime\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str675967=allocate([10,32,32,103,116,91,105,109,101,93,32,60,109,105,108,108,105,115,101,99,111,110,100,115,62,10,10,84,104,101,32,103,116,105,109,101,32,99,111,109,109,97,110,100,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,32,111,102,32,116,104,101,32,99,117,114,114,101,110,116,32,99,111,100,101,46,32,67,111,110,116,114,111,108,32,119,105,108,108,32,110,111,116,32,98,101,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,117,110,116,105,108,9,97,32,115,112,101,99,105,102,105,101,100,32,100,101,108,97,121,32,104,97,115,32,101,108,97,112,115,101,100,46,32,84,104,101,32,100,101,108,97,121,32,105,115,32,105,110,32,109,105,108,108,105,115,101,99,111,110,100,115,46,10,10,69,120,97,109,112,108,101,58,10,10,103,116,105,109,101,32,35,49,48,48,48,48,10,32,32,82,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,32,102,111,114,32,116,101,110,32,115,101,99,111,110,100,115,10,0] /* \0A  gt[ime] <millis */, "i8", ALLOC_STATIC);
STRING_TABLE.__str685968=allocate([110,101,120,116,0] /* next\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str695969=allocate([10,32,32,110,91,101,120,116,93,10,10,84,104,101,32,110,101,120,116,32,99,111,109,109,97,110,100,32,114,101,115,117,109,101,115,32,101,120,101,99,117,116,105,111,110,32,97,110,100,32,99,111,110,116,105,110,117,101,115,32,101,120,101,99,117,116,105,110,103,32,117,110,116,105,108,32,116,104,101,32,110,101,120,116,32,116,105,109,101,32,97,32,100,105,102,102,101,114,101,110,116,32,67,80,85,32,105,115,32,115,99,104,101,100,117,108,101,100,46,32,78,111,116,101,32,116,104,97,116,32,105,102,32,121,111,117,32,104,97,118,101,32,117,115,101,100,32,39,105,103,110,111,114,101,39,32,116,111,32,105,103,110,111,114,101,32,99,101,114,116,97,105,110,32,67,80,85,115,44,32,121,111,117,32,119,105,108,108,32,110,111,116,32,115,116,111,112,32,117,110,116,105,108,32,97,32,110,111,110,45,39,105,103,110,111,114,101,39,100,32,67,80,85,32,105,115,32,115,99,104,101,100,117,108,101,100,46,10,0] /* \0A  n[ext]\0A\0AThe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str705970=allocate([102,111,99,117,115,0] /* focus\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str715971=allocate([10,32,32,102,111,99,117,115,32,60,99,112,117,62,10,10,83,101,116,115,32,116,104,101,32,100,101,98,117,103,103,101,114,32,102,111,99,117,115,32,101,120,99,108,117,115,105,118,101,108,121,32,116,111,32,116,104,101,32,103,105,118,101,110,32,60,99,112,117,62,46,32,84,104,105,115,32,105,115,32,101,113,117,105,118,97,108,101,110,116,32,116,111,32,115,112,101,99,105,102,121,105,110,103,32,39,105,103,110,111,114,101,39,32,111,110,32,97,108,108,32,111,116,104,101,114,32,67,80,85,115,46,10,10,69,120,97,109,112,108,101,115,58,10,10,102,111,99,117,115,32,49,10,32,32,70,111,99,117,115,32,101,120,99,108,117,115,105,118,101,108,121,32,67,80,85,32,35,49,32,119,104,105,108,101,32,105,103,110,111,114,105,110,103,32,97,108,108,32,111,116,104,101,114,32,67,80,85,115,32,119,104,101,110,32,117,115,105,110,103,32,116,104,101,32,100,101,98,117,103,103,101,114,46,10,0] /* \0A  focus <cpu>\0A\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str725972=allocate([105,103,110,111,114,101,0] /* ignore\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str735973=allocate([10,32,32,105,103,110,111,114,101,32,91,60,99,112,117,62,91,44,60,99,112,117,62,91,44,46,46,46,93,93,93,10,10,73,103,110,111,114,101,115,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,60,99,112,117,62,32,105,110,32,116,104,101,32,100,101,98,117,103,103,101,114,46,32,84,104,105,115,32,109,101,97,110,115,32,116,104,97,116,32,121,111,117,32,119,111,110,39,116,32,101,118,101,114,32,115,101,101,32,101,120,101,99,117,116,105,111,110,32,111,110,32,116,104,97,116,32,67,80,85,44,32,110,111,114,32,119,105,108,108,32,121,111,117,32,98,101,32,97,98,108,101,32,116,111,32,115,101,116,32,98,114,101,97,107,112,111,105,110,116,115,32,111,110,32,116,104,97,116,32,67,80,85,46,32,84,111,32,117,110,100,111,32,116,104,105,115,32,99,104,97,110,103,101,32,117,115,101,32,116,104,101,32,39,111,98,115,101,114,118,101,39,32,99,111,109,109,97,110,100,46,32,89,111,117,32,99,97,110,32,115,112,101,99,105,102,121,32,109,117,108,116,105,112,108,101,32,60,99,112,117,62,115,32,105,110,32,97,32,115,105,110,103,108,101,32,99,111,109,109,97,110,100,46,32,78,111,116,101,32,97,108,115,111,32,116,104,97,116,32,121,111,117,32,97,114,101,32,110,111,116,32,112,101,114,109,105,116,116,101,100,32,116,111,32,105,103,110,111,114,101,32,97,108,108,32,67,80,85,115,59,32,97,116,32,108,101,97,115,116,32,111,110,101,32,109,117,115,116,32,98,101,32,97,99,116,105,118,101,32,97,116,32,97,108,108,32,116,105,109,101,115,46,10,10,69,120,97,109,112,108,101,115,58,10,10,105,103,110,111,114,101,32,49,10,32,32,73,103,110,111,114,101,32,67,80,85,32,35,49,32,119,104,101,110,32,117,115,105,110,103,32,116,104,101,32,100,101,98,117,103,103,101,114,46,10,10,105,103,110,111,114,101,32,50,44,51,44,52,10,32,32,73,103,110,111,114,101,32,67,80,85,32,35,50,44,32,35,51,32,97,110,100,32,35,52,32,119,104,101,110,32,117,115,105,110,103,32,116,104,101,32,100,101,98,117,103,103,101,114,46,10,10,105,103,110,111,114,101,10,32,32,76,105,115,116,32,116,104,101,32,67,80,85,115,32,116,104,97,116,32,97,114,101,32,99,117,114,114,101,110,116,108,121,32,105,103,110,111,114,101,100,46,10,0] /* \0A  ignore [<cpu>[, */, "i8", ALLOC_STATIC);
STRING_TABLE.__str745974=allocate([111,98,115,101,114,118,101,0] /* observe\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str755975=allocate([10,32,32,111,98,115,101,114,118,101,32,91,60,99,112,117,62,91,44,60,99,112,117,62,91,44,46,46,46,93,93,93,10,10,82,101,45,101,110,97,98,108,101,115,32,105,110,116,101,114,97,99,116,105,111,110,32,119,105,116,104,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,60,99,112,117,62,32,105,110,32,116,104,101,32,100,101,98,117,103,103,101,114,46,32,84,104,105,115,32,99,111,109,109,97,110,100,32,117,110,100,111,101,115,32,116,104,101,32,101,102,102,101,99,116,115,32,111,102,32,116,104,101,32,39,105,103,110,111,114,101,39,32,99,111,109,109,97,110,100,46,32,89,111,117,32,99,97,110,32,115,112,101,99,105,102,121,32,109,117,108,116,105,112,108,101,32,60,99,112,117,62,115,32,105,110,32,97,32,115,105,110,103,108,101,32,99,111,109,109,97,110,100,46,10,10,69,120,97,109,112,108,101,115,58,10,10,111,98,115,101,114,118,101,32,49,10,32,32,83,116,111,112,32,105,103,110,111,114,105,110,103,32,67,80,85,32,35,49,32,119,104,101,110,32,117,115,105,110,103,32,116,104,101,32,100,101,98,117,103,103,101,114,46,10,10,111,98,115,101,114,118,101,32,50,44,51,44,52,10,32,32,83,116,111,112,32,105,103,110,111,114,105,110,103,32,67,80,85,32,35,50,44,32,35,51,32,97,110,100,32,35,52,32,119,104,101,110,32,117,115,105,110,103,32,116,104,101,32,100,101,98,117,103,103,101,114,46,10,10,111,98,115,101,114,118,101,10,32,32,76,105,115,116,32,116,104,101,32,67,80,85,115,32,116,104,97,116,32,97,114,101,32,99,117,114,114,101,110,116,108,121,32,111,98,115,101,114,118,101,100,46,10,0] /* \0A  observe [<cpu>[ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str765976=allocate([116,114,97,99,101,0] /* trace\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str775977=allocate([10,32,32,116,114,97,99,101,32,123,60,102,105,108,101,110,97,109,101,62,124,79,70,70,125,91,44,60,99,112,117,62,91,44,60,97,99,116,105,111,110,62,93,93,10,10,83,116,97,114,116,115,32,111,114,32,115,116,111,112,115,32,116,114,97,99,105,110,103,32,111,102,32,116,104,101,32,101,120,101,99,117,116,105,111,110,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,60,99,112,117,62,46,32,73,102,32,60,99,112,117,62,32,105,115,32,111,109,105,116,116,101,100,44,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,67,80,85,32,105,115,32,115,112,101,99,105,102,105,101,100,46,32,87,104,101,110,32,101,110,97,98,108,105,110,103,32,116,114,97,99,105,110,103,44,32,115,112,101,99,105,102,121,32,116,104,101,32,102,105,108,101,110,97,109,101,32,105,110,32,116,104,101,32,60,102,105,108,101,110,97,109,101,62,32,112,97,114,97,109,101,116,101,114,46,32,84,111,32,100,105,115,97,98,108,101,32,116,114,97,99,105,110,103,44,32,115,117,98,115,116,105,116,117,116,101,32,116,104,101,32,107,101,121,119,111,114,100,32,39,111,102,102,39,32,102,111,114,32,60,102,105,108,101,110,97,109,101,62,46,32,73,102,32,121,111,117,32,119,105,115,104,32,116,111,32,108,111,103,32,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,111,110,32,101,97,99,104,32,116,114,97,99,101,44,32,121,111,117,32,99,97,110,32,97,112,112,101,110,100,32,97,110,32,60,97,99,116,105,111,110,62,32,112,97,114,97,109,101,116,101,114,32,119,104,105,99,104,32,105,115,32,97,32,99,111,109,109,97,110,100,32,116,104,97,116,32,105,115,32,101,120,101,99,117,116,101,100,32,98,101,102,111,114,101,32,101,97,99,104,32,116,114,97,99,101,32,105,115,32,108,111,103,103,101,100,46,32,71,101,110,101,114,97,108,108,121,44,32,116,104,105,115,32,105,115,32,117,115,101,100,32,116,111,32,105,110,99,108,117,100,101,32,97,32,39,116,114,97,99,101,108,111,103,39,32,99,111,109,109,97,110,100,46,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,109,97,121,32,110,101,101,100,32,116,111,32,101,109,98,101,100,32,116,104,101,32,97,99,116,105,111,110,32,119,105,116,104,105,110,32,98,114,97,99,101,115,32,123,32,125,32,105,110,32,111,114,100,101,114,32,116,111,32,112,114,101,118,101,110,116,32,99,111,109,109,97,115,32,97,110,100,32,115,101,109,105,99,111,108,111,110,115,32,102,114,111,109,32,98,101,105,110,103,32,105,110,116,101,114,112,114,101,116,101,100,32,97,115,32,97,112,112,108,121,105,110,103,32,116,111,32,116,104,101,32,116,114,97,99,101,32,99,111,109,109,97,110,100,32,105,116,115,101,108,102,46,10,10,69,120,97,109,112,108,101,115,58,10,10,116,114,97,99,101,32,100,114,105,98,108,105,110,103,46,116,114,44,48,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,101,120,101,99,117,116,105,111,110,32,111,102,32,67,80,85,32,35,48,44,32,108,111,103,103,105,110,103,32,111,117,116,112,117,116,32,116,111,32,100,114,105,98,108,105,110,103,46,116,114,46,10,10,116,114,97,99,101,32,106,111,117,115,116,46,116,114,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,67,80,85,44,32,108,111,103,103,105,110,103,32,111,117,116,112,117,116,32,116,111,32,106,111,117,115,116,46,116,114,46,10,10,116,114,97,99,101,32,62,62,112,105,103,115,107,105,110,46,116,114,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,67,80,85,44,32,97,112,112,101,110,100,105,110,103,32,108,111,103,32,111,117,116,112,117,116,32,116,111,32,112,105,103,115,107,105,110,46,116,114,46,10,10,116,114,97,99,101,32,111,102,102,44,48,10,32,32,84,117,114,110,32,111,102,102,32,116,114,97,99,105,110,103,32,111,110,32,67,80,85,32,35,48,46,10,10,116,114,97,99,101,32,97,115,116,101,114,111,105,100,46,116,114,44,48,44,123,116,114,97,99,101,108,111,103,32,34,65,61,37,48,50,88,32,34,44,97,125,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,101,120,101,99,117,116,105,111,110,32,111,102,32,67,80,85,32,35,48,44,32,108,111,103,103,105,110,103,32,111,117,116,112,117,116,32,116,111,32,97,115,116,101,114,111,105,100,46,116,114,46,32,66,101,102,111,114,101,32,101,97,99,104,32,108,105,110,101,44,32,111,117,116,112,117,116,32,65,61,60,97,118,97,108,62,32,116,111,32,116,104,101,32,116,114,97,99,101,108,111,103,46,10,0] /* \0A  trace {<filenam */, "i8", ALLOC_STATIC);
STRING_TABLE.__str785978=allocate([116,114,97,99,101,111,118,101,114,0] /* traceover\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str795979=allocate([10,32,32,116,114,97,99,101,111,118,101,114,32,123,60,102,105,108,101,110,97,109,101,62,124,79,70,70,125,91,44,60,99,112,117,62,91,44,60,97,99,116,105,111,110,62,93,93,10,10,83,116,97,114,116,115,32,111,114,32,115,116,111,112,115,32,116,114,97,99,105,110,103,32,111,102,32,116,104,101,32,101,120,101,99,117,116,105,111,110,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,60,99,112,117,62,46,32,87,104,101,110,32,116,114,97,99,105,110,103,32,114,101,97,99,104,101,115,32,97,32,115,117,98,114,111,117,116,105,110,101,32,111,114,32,99,97,108,108,44,32,116,114,97,99,105,110,103,32,119,105,108,108,32,115,107,105,112,32,111,118,101,114,32,116,104,101,32,115,117,98,114,111,117,116,105,110,101,46,32,84,104,101,32,115,97,109,101,32,97,108,103,111,114,105,116,104,109,32,105,115,32,117,115,101,100,32,97,115,32,105,115,32,117,115,101,100,32,105,110,32,116,104,101,32,115,116,101,112,32,111,118,101,114,32,99,111,109,109,97,110,100,46,32,84,104,105,115,32,109,101,97,110,115,32,116,104,97,116,32,116,114,97,99,101,111,118,101,114,32,119,105,108,108,32,110,111,116,32,119,111,114,107,32,112,114,111,112,101,114,108,121,32,119,104,101,110,32,99,97,108,108,115,32,97,114,101,32,114,101,99,117,115,105,118,101,32,111,114,32,116,104,101,32,114,101,116,117,114,110,32,97,100,100,114,101,115,115,32,105,115,32,110,111,116,32,105,109,109,101,100,105,97,116,101,108,121,32,102,111,108,108,111,119,105,110,103,32,116,104,101,32,99,97,108,108,32,105,110,115,116,114,117,99,116,105,111,110,46,32,73,102,32,60,99,112,117,62,32,105,115,32,111,109,105,116,116,101,100,44,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,67,80,85,32,105,115,32,115,112,101,99,105,102,105,101,100,46,32,87,104,101,110,32,101,110,97,98,108,105,110,103,32,116,114,97,99,105,110,103,44,32,115,112,101,99,105,102,121,32,116,104,101,32,102,105,108,101,110,97,109,101,32,105,110,32,116,104,101,32,60,102,105,108,101,110,97,109,101,62,32,112,97,114,97,109,101,116,101,114,46,32,84,111,32,100,105,115,97,98,108,101,32,116,114,97,99,105,110,103,44,32,115,117,98,115,116,105,116,117,116,101,32,116,104,101,32,107,101,121,119,111,114,100,32,39,111,102,102,39,32,102,111,114,32,60,102,105,108,101,110,97,109,101,62,46,32,73,102,32,121,111,117,32,119,105,115,104,32,116,111,32,108,111,103,32,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,111,110,32,101,97,99,104,32,116,114,97,99,101,44,32,121,111,117,32,99,97,110,32,97,112,112,101,110,100,32,97,110,32,60,97,99,116,105,111,110,62,32,112,97,114,97,109,101,116,101,114,32,119,104,105,99,104,32,105,115,32,97,32,99,111,109,109,97,110,100,32,116,104,97,116,32,105,115,32,101,120,101,99,117,116,101,100,32,98,101,102,111,114,101,32,101,97,99,104,32,116,114,97,99,101,32,105,115,32,108,111,103,103,101,100,46,32,71,101,110,101,114,97,108,108,121,44,32,116,104,105,115,32,105,115,32,117,115,101,100,32,116,111,32,105,110,99,108,117,100,101,32,97,32,39,116,114,97,99,101,108,111,103,39,32,99,111,109,109,97,110,100,46,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,109,97,121,32,110,101,101,100,32,116,111,32,101,109,98,101,100,32,116,104,101,32,97,99,116,105,111,110,32,119,105,116,104,105,110,32,98,114,97,99,101,115,32,123,32,125,32,105,110,32,111,114,100,101,114,32,116,111,32,112,114,101,118,101,110,116,32,99,111,109,109,97,115,32,97,110,100,32,115,101,109,105,99,111,108,111,110,115,32,102,114,111,109,32,98,101,105,110,103,32,105,110,116,101,114,112,114,101,116,101,100,32,97,115,32,97,112,112,108,121,105,110,103,32,116,111,32,116,104,101,32,116,114,97,99,101,32,99,111,109,109,97,110,100,32,105,116,115,101,108,102,46,10,10,69,120,97,109,112,108,101,115,58,10,10,116,114,97,99,101,111,118,101,114,32,100,114,105,98,108,105,110,103,46,116,114,44,48,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,101,120,101,99,117,116,105,111,110,32,111,102,32,67,80,85,32,35,48,44,32,108,111,103,103,105,110,103,32,111,117,116,112,117,116,32,116,111,32,100,114,105,98,108,105,110,103,46,116,114,46,10,10,116,114,97,99,101,111,118,101,114,32,106,111,117,115,116,46,116,114,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,67,80,85,44,32,108,111,103,103,105,110,103,32,111,117,116,112,117,116,32,116,111,32,106,111,117,115,116,46,116,114,46,10,10,116,114,97,99,101,111,118,101,114,32,111,102,102,44,48,10,32,32,84,117,114,110,32,111,102,102,32,116,114,97,99,105,110,103,32,111,110,32,67,80,85,32,35,48,46,10,10,116,114,97,99,101,111,118,101,114,32,97,115,116,101,114,111,105,100,46,116,114,44,48,44,123,116,114,97,99,101,108,111,103,32,34,65,61,37,48,50,88,32,34,44,97,125,10,32,32,66,101,103,105,110,32,116,114,97,99,105,110,103,32,116,104,101,32,101,120,101,99,117,116,105,111,110,32,111,102,32,67,80,85,32,35,48,44,32,108,111,103,103,105,110,103,32,111,117,116,112,117,116,32,116,111,32,97,115,116,101,114,111,105,100,46,116,114,46,32,66,101,102,111,114,101,32,101,97,99,104,32,108,105,110,101,44,32,111,117,116,112,117,116,32,65,61,60,97,118,97,108,62,32,116,111,32,116,104,101,32,116,114,97,99,101,108,111,103,46,10,0] /* \0A  traceover {<fil */, "i8", ALLOC_STATIC);
STRING_TABLE.__str805980=allocate([116,114,97,99,101,102,108,117,115,104,0] /* traceflush\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str815981=allocate([10,32,32,116,114,97,99,101,102,108,117,115,104,10,10,70,108,117,115,104,101,115,32,97,108,108,32,111,112,101,110,32,116,114,97,99,101,32,102,105,108,101,115,46,10,0] /* \0A  traceflush\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str825982=allocate([98,112,115,101,116,0] /* bpset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str835983=allocate([10,32,32,98,112,91,115,101,116,93,32,60,97,100,100,114,101,115,115,62,91,44,60,99,111,110,100,105,116,105,111,110,62,91,44,60,97,99,116,105,111,110,62,93,93,10,10,83,101,116,115,32,97,32,110,101,119,32,101,120,101,99,117,116,105,111,110,32,98,114,101,97,107,112,111,105,110,116,32,97,116,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,60,97,100,100,114,101,115,115,62,46,32,84,104,101,32,111,112,116,105,111,110,97,108,32,60,99,111,110,100,105,116,105,111,110,62,32,112,97,114,97,109,101,116,101,114,32,108,101,116,115,32,121,111,117,32,115,112,101,99,105,102,121,32,97,110,32,101,120,112,114,101,115,115,105,111,110,32,116,104,97,116,32,119,105,108,108,32,98,101,32,101,118,97,108,117,97,116,101,100,32,101,97,99,104,32,116,105,109,101,32,116,104,101,32,98,114,101,97,107,112,111,105,110,116,32,105,115,32,104,105,116,46,32,73,102,32,116,104,101,32,114,101,115,117,108,116,32,111,102,32,116,104,101,32,101,120,112,114,101,115,115,105,111,110,32,105,115,32,116,114,117,101,32,40,110,111,110,45,122,101,114,111,41,44,32,116,104,101,32,98,114,101,97,107,112,111,105,110,116,32,119,105,108,108,32,97,99,116,117,97,108,108,121,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,59,32,111,116,104,101,114,119,105,115,101,44,32,101,120,101,99,117,116,105,111,110,32,119,105,108,108,32,99,111,110,116,105,110,117,101,32,119,105,116,104,32,110,111,32,110,111,116,105,102,105,99,97,116,105,111,110,46,32,84,104,101,32,111,112,116,105,111,110,97,108,32,60,97,99,116,105,111,110,62,32,112,97,114,97,109,101,116,101,114,32,112,114,111,118,105,100,101,115,32,97,32,99,111,109,109,97,110,100,32,116,104,97,116,32,105,115,32,101,120,101,99,117,116,101,100,32,119,104,101,110,101,118,101,114,32,116,104,101,32,98,114,101,97,107,112,111,105,110,116,32,105,115,32,104,105,116,32,97,110,100,32,116,104,101,32,60,99,111,110,100,105,116,105,111,110,62,32,105,115,32,116,114,117,101,46,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,109,97,121,32,110,101,101,100,32,116,111,32,101,109,98,101,100,32,116,104,101,32,97,99,116,105,111,110,32,119,105,116,104,105,110,32,98,114,97,99,101,115,32,123,32,125,32,105,110,32,111,114,100,101,114,32,116,111,32,112,114,101,118,101,110,116,32,99,111,109,109,97,115,32,97,110,100,32,115,101,109,105,99,111,108,111,110,115,32,102,114,111,109,32,98,101,105,110,103,32,105,110,116,101,114,112,114,101,116,101,100,32,97,115,32,97,112,112,108,121,105,110,103,32,116,111,32,116,104,101,32,98,112,115,101,116,32,99,111,109,109,97,110,100,32,105,116,115,101,108,102,46,32,69,97,99,104,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,105,115,32,115,101,116,32,105,115,32,97,115,115,105,103,110,101,100,32,97,110,32,105,110,100,101,120,32,119,104,105,99,104,32,99,97,110,32,98,101,32,117,115,101,100,32,105,110,32,111,116,104,101,114,32,98,114,101,97,107,112,111,105,110,116,32,99,111,109,109,97,110,100,115,32,116,111,32,114,101,102,101,114,101,110,99,101,32,116,104,105,115,32,98,114,101,97,107,112,111,105,110,116,46,10,10,69,120,97,109,112,108,101,115,58,10,10,98,112,32,49,50,51,52,10,32,32,83,101,116,32,97,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,116,104,101,32,80,67,32,105,115,32,101,113,117,97,108,32,116,111,32,49,50,51,52,46,10,10,98,112,32,50,51,52,53,54,44,97,48,32,61,61,32,48,32,38,38,32,97,49,32,61,61,32,48,10,32,32,83,101,116,32,97,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,116,104,101,32,80,67,32,105,115,32,101,113,117,97,108,32,116,111,32,50,51,52,53,54,32,65,78,68,32,116,104,101,32,101,120,112,114,101,115,115,105,111,110,32,40,97,48,32,61,61,32,48,32,38,38,32,97,49,32,61,61,32,48,41,32,105,115,32,116,114,117,101,46,10,10,98,112,32,51,52,53,54,44,49,44,123,112,114,105,110,116,102,32,34,65,48,61,37,48,56,88,92,110,34,44,97,48,59,32,103,125,10,32,32,83,101,116,32,97,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,116,104,101,32,80,67,32,105,115,32,101,113,117,97,108,32,116,111,32,51,52,53,54,46,32,87,104,101,110,32,116,104,105,115,32,104,97,112,112,101,110,115,44,32,112,114,105,110,116,32,65,48,61,60,97,48,118,97,108,62,32,97,110,100,32,99,111,110,116,105,110,117,101,32,101,120,101,99,117,116,105,110,103,46,10,10,98,112,32,52,53,54,55,56,44,97,48,61,61,49,48,48,44,123,97,48,32,61,32,102,102,59,32,103,125,10,32,32,83,101,116,32,97,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,116,104,101,32,80,67,32,105,115,32,101,113,117,97,108,32,116,111,32,52,53,54,55,56,32,65,78,68,32,116,104,101,32,101,120,112,114,101,115,115,105,111,110,32,40,97,48,32,61,61,32,49,48,48,41,32,105,115,32,116,114,117,101,46,32,87,104,101,110,32,116,104,97,116,32,104,97,112,112,101,110,115,44,32,115,101,116,32,97,48,32,116,111,32,102,102,32,97,110,100,32,114,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,46,10,10,116,101,109,112,48,32,61,32,48,59,32,98,112,32,53,54,55,56,57,48,44,43,43,116,101,109,112,48,32,62,61,32,49,48,10,32,32,83,101,116,32,97,32,98,114,101,97,107,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,116,104,101,32,80,67,32,105,115,32,101,113,117,97,108,32,116,111,32,53,54,55,56,57,48,32,65,78,68,32,116,104,101,32,101,120,112,114,101,115,115,105,111,110,32,40,43,43,116,101,109,112,48,32,62,61,32,49,48,41,32,105,115,32,116,114,117,101,46,32,84,104,105,115,32,101,102,102,101,99,116,105,118,101,108,121,32,98,114,101,97,107,115,32,111,110,108,121,32,97,102,116,101,114,32,116,104,101,32,98,114,101,97,107,112,111,105,110,116,32,104,97,115,32,98,101,101,110,32,104,105,116,32,49,54,32,116,105,109,101,115,46,10,0] /* \0A  bp[set] <addres */, "i8", ALLOC_STATIC);
STRING_TABLE.__str845984=allocate([98,112,99,108,101,97,114,0] /* bpclear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str855985=allocate([10,32,32,98,112,99,108,101,97,114,32,91,60,98,112,110,117,109,62,93,10,10,84,104,101,32,98,112,99,108,101,97,114,32,99,111,109,109,97,110,100,32,99,108,101,97,114,115,32,97,32,98,114,101,97,107,112,111,105,110,116,46,32,73,102,32,60,98,112,110,117,109,62,32,105,115,32,115,112,101,99,105,102,105,101,100,44,32,111,110,108,121,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,98,114,101,97,107,112,111,105,110,116,32,105,115,32,99,108,101,97,114,101,100,44,32,111,116,104,101,114,119,105,115,101,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,32,97,114,101,32,99,108,101,97,114,101,100,46,10,10,69,120,97,109,112,108,101,115,58,10,10,98,112,99,108,101,97,114,32,51,10,32,32,67,108,101,97,114,32,98,114,101,97,107,112,111,105,110,116,32,105,110,100,101,120,32,51,46,10,10,98,112,99,108,101,97,114,10,32,32,67,108,101,97,114,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,46,10,0] /* \0A  bpclear [<bpnum */, "i8", ALLOC_STATIC);
STRING_TABLE.__str865986=allocate([98,112,100,105,115,97,98,108,101,0] /* bpdisable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str875987=allocate([10,32,32,98,112,100,105,115,97,98,108,101,32,91,60,98,112,110,117,109,62,93,10,10,84,104,101,32,98,112,100,105,115,97,98,108,101,32,99,111,109,109,97,110,100,32,100,105,115,97,98,108,101,115,32,97,32,98,114,101,97,107,112,111,105,110,116,46,32,73,102,32,60,98,112,110,117,109,62,32,105,115,32,115,112,101,99,105,102,105,101,100,44,32,111,110,108,121,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,98,114,101,97,107,112,111,105,110,116,32,105,115,32,100,105,115,97,98,108,101,100,44,32,111,116,104,101,114,119,105,115,101,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,32,97,114,101,32,100,105,115,97,98,108,101,100,46,32,78,111,116,101,32,116,104,97,116,32,100,105,115,97,98,108,105,110,103,32,97,32,98,114,101,97,107,112,111,105,110,116,32,100,111,101,115,32,110,111,116,32,100,101,108,101,116,101,32,105,116,44,32,105,116,32,106,117,115,116,32,116,101,109,112,111,114,97,114,105,108,121,32,109,97,114,107,115,32,116,104,101,32,98,114,101,97,107,112,111,105,110,116,32,97,115,32,105,110,97,99,116,105,118,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,98,112,100,105,115,97,98,108,101,32,51,10,32,32,68,105,115,97,98,108,101,32,98,114,101,97,107,112,111,105,110,116,32,105,110,100,101,120,32,51,46,10,10,98,112,100,105,115,97,98,108,101,10,32,32,68,105,115,97,98,108,101,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,46,10,0] /* \0A  bpdisable [<bpn */, "i8", ALLOC_STATIC);
STRING_TABLE.__str885988=allocate([98,112,101,110,97,98,108,101,0] /* bpenable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str895989=allocate([10,32,32,98,112,101,110,97,98,108,101,32,91,60,98,112,110,117,109,62,93,10,10,84,104,101,32,98,112,101,110,97,98,108,101,32,99,111,109,109,97,110,100,32,101,110,97,98,108,101,115,32,97,32,98,114,101,97,107,112,111,105,110,116,46,32,73,102,32,60,98,112,110,117,109,62,32,105,115,32,115,112,101,99,105,102,105,101,100,44,32,111,110,108,121,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,98,114,101,97,107,112,111,105,110,116,32,105,115,32,101,110,97,98,108,101,100,44,32,111,116,104,101,114,119,105,115,101,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,32,97,114,101,32,101,110,97,98,108,101,100,46,10,10,69,120,97,109,112,108,101,115,58,10,10,98,112,101,110,97,98,108,101,32,51,10,32,32,69,110,97,98,108,101,32,98,114,101,97,107,112,111,105,110,116,32,105,110,100,101,120,32,51,46,10,10,98,112,101,110,97,98,108,101,10,32,32,69,110,97,98,108,101,32,97,108,108,32,98,114,101,97,107,112,111,105,110,116,115,46,10,0] /* \0A  bpenable [<bpnu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str905990=allocate([98,112,108,105,115,116,0] /* bplist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str915991=allocate([10,32,32,98,112,108,105,115,116,10,10,84,104,101,32,98,112,108,105,115,116,32,99,111,109,109,97,110,100,32,108,105,115,116,115,32,97,108,108,32,116,104,101,32,99,117,114,114,101,110,116,32,98,114,101,97,107,112,111,105,110,116,115,44,32,97,108,111,110,103,32,119,105,116,104,32,116,104,101,105,114,32,105,110,100,101,120,32,97,110,100,32,97,110,121,32,99,111,110,100,105,116,105,111,110,115,32,111,114,32,97,99,116,105,111,110,115,32,97,116,116,97,99,104,101,100,32,116,111,32,116,104,101,109,46,10,0] /* \0A  bplist\0A\0AThe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str925992=allocate([119,112,115,101,116,0] /* wpset\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str935993=allocate([10,32,32,119,112,91,123,100,124,105,125,93,91,115,101,116,93,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,44,60,116,121,112,101,62,91,44,60,99,111,110,100,105,116,105,111,110,62,91,44,60,97,99,116,105,111,110,62,93,93,10,10,83,101,116,115,32,97,32,110,101,119,32,119,97,116,99,104,112,111,105,110,116,32,115,116,97,114,116,105,110,103,32,97,116,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,60,97,100,100,114,101,115,115,62,32,97,110,100,32,101,120,116,101,110,100,105,110,103,32,102,111,114,32,60,108,101,110,103,116,104,62,46,32,84,104,101,32,105,110,99,108,117,115,105,118,101,32,114,97,110,103,101,32,111,102,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,60,97,100,100,114,101,115,115,62,32,116,104,114,111,117,103,104,32,60,97,100,100,114,101,115,115,62,32,43,32,60,108,101,110,103,116,104,62,32,45,32,49,46,32,84,104,101,32,39,119,112,115,101,116,39,32,99,111,109,109,97,110,100,32,115,101,116,115,32,97,32,119,97,116,99,104,112,111,105,110,116,32,111,110,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,59,32,116,104,101,32,39,119,112,100,115,101,116,39,32,99,111,109,109,97,110,100,32,115,101,116,115,32,97,32,119,97,116,99,104,112,111,105,110,116,32,111,110,32,100,97,116,97,32,109,101,109,111,114,121,59,32,97,110,100,32,116,104,101,32,39,119,112,105,115,101,116,39,32,115,101,116,115,32,97,32,119,97,116,99,104,112,111,105,110,116,32,111,110,32,73,47,79,32,109,101,109,111,114,121,46,32,84,104,101,32,60,116,121,112,101,62,32,112,97,114,97,109,101,116,101,114,32,115,112,101,99,105,102,105,101,115,32,119,104,105,99,104,32,115,111,114,116,32,111,102,32,97,99,99,101,115,115,101,115,32,116,111,32,116,114,97,112,32,111,110,46,32,73,116,32,99,97,110,32,98,101,32,111,110,101,32,111,102,32,116,104,114,101,101,32,118,97,108,117,101,115,58,32,39,114,39,32,102,111,114,32,97,32,114,101,97,100,32,119,97,116,99,104,112,111,105,110,116,32,39,119,39,32,102,111,114,32,97,32,119,114,105,116,101,32,119,97,116,99,104,112,111,105,110,116,44,32,97,110,100,32,39,114,119,39,32,102,111,114,32,97,32,114,101,97,100,47,119,114,105,116,101,32,119,97,116,99,104,112,111,105,110,116,46,10,10,84,104,101,32,111,112,116,105,111,110,97,108,32,60,99,111,110,100,105,116,105,111,110,62,32,112,97,114,97,109,101,116,101,114,32,108,101,116,115,32,121,111,117,32,115,112,101,99,105,102,121,32,97,110,32,101,120,112,114,101,115,115,105,111,110,32,116,104,97,116,32,119,105,108,108,32,98,101,32,101,118,97,108,117,97,116,101,100,32,101,97,99,104,32,116,105,109,101,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,104,105,116,46,32,73,102,32,116,104,101,32,114,101,115,117,108,116,32,111,102,32,116,104,101,32,101,120,112,114,101,115,115,105,111,110,32,105,115,32,116,114,117,101,32,40,110,111,110,45,122,101,114,111,41,44,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,32,119,105,108,108,32,97,99,116,117,97,108,108,121,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,59,32,111,116,104,101,114,119,105,115,101,44,32,101,120,101,99,117,116,105,111,110,32,119,105,108,108,32,99,111,110,116,105,110,117,101,32,119,105,116,104,32,110,111,32,110,111,116,105,102,105,99,97,116,105,111,110,46,32,84,104,101,32,111,112,116,105,111,110,97,108,32,60,97,99,116,105,111,110,62,32,112,97,114,97,109,101,116,101,114,32,112,114,111,118,105,100,101,115,32,97,32,99,111,109,109,97,110,100,32,116,104,97,116,32,105,115,32,101,120,101,99,117,116,101,100,32,119,104,101,110,101,118,101,114,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,104,105,116,32,97,110,100,32,116,104,101,32,60,99,111,110,100,105,116,105,111,110,62,32,105,115,32,116,114,117,101,46,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,109,97,121,32,110,101,101,100,32,116,111,32,101,109,98,101,100,32,116,104,101,32,97,99,116,105,111,110,32,119,105,116,104,105,110,32,98,114,97,99,101,115,32,123,32,125,32,105,110,32,111,114,100,101,114,32,116,111,32,112,114,101,118,101,110,116,32,99,111,109,109,97,115,32,97,110,100,32,115,101,109,105,99,111,108,111,110,115,32,102,114,111,109,32,98,101,105,110,103,32,105,110,116,101,114,112,114,101,116,101,100,32,97,115,32,97,112,112,108,121,105,110,103,32,116,111,32,116,104,101,32,119,112,115,101,116,32,99,111,109,109,97,110,100,32,105,116,115,101,108,102,46,32,69,97,99,104,32,119,97,116,99,104,112,111,105,110,116,32,116,104,97,116,32,105,115,32,115,101,116,32,105,115,32,97,115,115,105,103,110,101,100,32,97,110,32,105,110,100,101,120,32,119,104,105,99,104,32,99,97,110,32,98,101,32,117,115,101,100,32,105,110,32,111,116,104,101,114,32,119,97,116,99,104,112,111,105,110,116,32,99,111,109,109,97,110,100,115,32,116,111,32,114,101,102,101,114,101,110,99,101,32,116,104,105,115,32,119,97,116,99,104,112,111,105,110,116,46,10,10,73,110,32,111,114,100,101,114,32,116,111,32,104,101,108,112,32,60,99,111,110,100,105,116,105,111,110,62,32,101,120,112,114,101,115,115,105,111,110,115,44,32,116,119,111,32,118,97,114,105,97,98,108,101,115,32,97,114,101,32,97,118,97,105,108,97,98,108,101,46,32,70,111,114,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,44,32,116,104,101,32,118,97,114,105,97,98,108,101,32,39,119,112,97,100,100,114,39,32,105,115,32,115,101,116,32,116,111,32,116,104,101,32,97,100,100,114,101,115,115,32,116,104,97,116,32,97,99,116,117,97,108,108,121,32,116,114,105,103,103,101,114,101,100,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,46,32,70,111,114,32,119,114,105,116,101,32,119,97,116,99,104,112,111,105,110,116,115,44,32,116,104,101,32,118,97,114,105,97,98,108,101,32,39,119,112,100,97,116,97,39,32,105,115,32,115,101,116,32,116,111,32,116,104,101,32,100,97,116,97,32,116,104,97,116,32,105,115,32,98,101,105,110,103,32,119,114,105,116,116,101,110,46,10,10,69,120,97,109,112,108,101,115,58,10,10,119,112,32,49,50,51,52,44,54,44,114,119,10,32,32,83,101,116,32,97,32,119,97,116,99,104,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,97,32,114,101,97,100,32,111,114,32,119,114,105,116,101,32,111,99,99,117,114,115,32,105,110,32,116,104,101,32,97,100,100,114,101,115,115,32,114,97,110,103,101,32,49,50,51,52,45,49,50,51,57,32,105,110,99,108,117,115,105,118,101,46,10,10,119,112,32,50,51,52,53,54,44,97,44,119,44,119,112,100,97,116,97,32,61,61,32,49,10,32,32,83,101,116,32,97,32,119,97,116,99,104,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,97,32,119,114,105,116,101,32,111,99,99,117,114,115,32,105,110,32,116,104,101,32,97,100,100,114,101,115,115,32,114,97,110,103,101,32,50,51,52,53,54,45,50,51,52,53,102,32,65,78,68,32,116,104,101,32,100,97,116,97,32,119,114,105,116,116,101,110,32,105,115,32,101,113,117,97,108,32,116,111,32,49,46,10,10,119,112,32,51,52,53,54,44,50,48,44,114,44,49,44,123,112,114,105,110,116,102,32,34,82,101,97,100,32,64,32,37,48,56,88,92,110,34,44,119,112,97,100,100,114,59,32,103,125,10,32,32,83,101,116,32,97,32,119,97,116,99,104,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,97,32,114,101,97,100,32,111,99,99,117,114,115,32,105,110,32,116,104,101,32,97,100,100,114,101,115,115,32,114,97,110,103,101,32,51,52,53,54,45,51,52,55,53,46,32,87,104,101,110,32,116,104,105,115,32,104,97,112,112,101,110,115,44,32,112,114,105,110,116,32,82,101,97,100,32,64,32,60,119,112,97,100,100,114,62,32,97,110,100,32,99,111,110,116,105,110,117,101,32,101,120,101,99,117,116,105,110,103,46,10,10,116,101,109,112,48,32,61,32,48,59,32,119,112,32,52,53,54,55,56,44,49,44,119,44,119,112,100,97,116,97,61,61,102,48,44,123,116,101,109,112,48,43,43,59,32,103,125,10,32,32,83,101,116,32,97,32,119,97,116,99,104,112,111,105,110,116,32,116,104,97,116,32,119,105,108,108,32,104,97,108,116,32,101,120,101,99,117,116,105,111,110,32,119,104,101,110,101,118,101,114,32,97,32,119,114,105,116,101,32,111,99,99,117,114,115,32,116,111,32,116,104,101,32,97,100,100,114,101,115,115,32,52,53,54,55,56,32,65,78,68,32,116,104,101,32,118,97,108,117,101,32,98,101,105,110,103,32,119,114,105,116,116,101,110,32,105,115,32,101,113,117,97,108,32,116,111,32,102,48,46,32,87,104,101,110,32,116,104,97,116,32,104,97,112,112,101,110,115,44,32,105,110,99,114,101,109,101,110,116,32,116,104,101,32,118,97,114,105,97,98,108,101,32,116,101,109,112,48,32,97,110,100,32,114,101,115,117,109,101,32,101,120,101,99,117,116,105,111,110,46,10,0] /* \0A  wp[{d|i}][set]  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str945994=allocate([119,112,99,108,101,97,114,0] /* wpclear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str955995=allocate([10,32,32,119,112,99,108,101,97,114,32,91,60,119,112,110,117,109,62,93,10,10,84,104,101,32,119,112,99,108,101,97,114,32,99,111,109,109,97,110,100,32,99,108,101,97,114,115,32,97,32,119,97,116,99,104,112,111,105,110,116,46,32,73,102,32,60,119,112,110,117,109,62,32,105,115,32,115,112,101,99,105,102,105,101,100,44,32,111,110,108,121,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,99,108,101,97,114,101,100,44,32,111,116,104,101,114,119,105,115,101,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,32,97,114,101,32,99,108,101,97,114,101,100,46,10,10,69,120,97,109,112,108,101,115,58,10,10,119,112,99,108,101,97,114,32,51,10,32,32,67,108,101,97,114,32,119,97,116,99,104,112,111,105,110,116,32,105,110,100,101,120,32,51,46,10,10,119,112,99,108,101,97,114,10,32,32,67,108,101,97,114,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,46,10,0] /* \0A  wpclear [<wpnum */, "i8", ALLOC_STATIC);
STRING_TABLE.__str965996=allocate([119,112,100,105,115,97,98,108,101,0] /* wpdisable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str975997=allocate([10,32,32,119,112,100,105,115,97,98,108,101,32,91,60,119,112,110,117,109,62,93,10,10,84,104,101,32,119,112,100,105,115,97,98,108,101,32,99,111,109,109,97,110,100,32,100,105,115,97,98,108,101,115,32,97,32,119,97,116,99,104,112,111,105,110,116,46,32,73,102,32,60,119,112,110,117,109,62,32,105,115,32,115,112,101,99,105,102,105,101,100,44,32,111,110,108,121,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,100,105,115,97,98,108,101,100,44,32,111,116,104,101,114,119,105,115,101,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,32,97,114,101,32,100,105,115,97,98,108,101,100,46,32,78,111,116,101,32,116,104,97,116,32,100,105,115,97,98,108,105,110,103,32,97,32,119,97,116,99,104,112,111,105,110,116,32,100,111,101,115,32,110,111,116,32,100,101,108,101,116,101,32,105,116,44,32,105,116,32,106,117,115,116,32,116,101,109,112,111,114,97,114,105,108,121,32,109,97,114,107,115,32,116,104,101,32,119,97,116,99,104,112,111,105,110,116,32,97,115,32,105,110,97,99,116,105,118,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,119,112,100,105,115,97,98,108,101,32,51,10,32,32,68,105,115,97,98,108,101,32,119,97,116,99,104,112,111,105,110,116,32,105,110,100,101,120,32,51,46,10,10,119,112,100,105,115,97,98,108,101,10,32,32,68,105,115,97,98,108,101,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,46,10,0] /* \0A  wpdisable [<wpn */, "i8", ALLOC_STATIC);
STRING_TABLE.__str985998=allocate([119,112,101,110,97,98,108,101,0] /* wpenable\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str995999=allocate([10,32,32,119,112,101,110,97,98,108,101,32,91,60,119,112,110,117,109,62,93,10,10,84,104,101,32,119,112,101,110,97,98,108,101,32,99,111,109,109,97,110,100,32,101,110,97,98,108,101,115,32,97,32,119,97,116,99,104,112,111,105,110,116,46,32,73,102,32,60,119,112,110,117,109,62,32,105,115,32,115,112,101,99,105,102,105,101,100,44,32,111,110,108,121,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,119,97,116,99,104,112,111,105,110,116,32,105,115,32,101,110,97,98,108,101,100,44,32,111,116,104,101,114,119,105,115,101,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,32,97,114,101,32,101,110,97,98,108,101,100,46,10,10,69,120,97,109,112,108,101,115,58,10,10,119,112,101,110,97,98,108,101,32,51,10,32,32,69,110,97,98,108,101,32,119,97,116,99,104,112,111,105,110,116,32,105,110,100,101,120,32,51,46,10,10,119,112,101,110,97,98,108,101,10,32,32,69,110,97,98,108,101,32,97,108,108,32,119,97,116,99,104,112,111,105,110,116,115,46,10,0] /* \0A  wpenable [<wpnu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1006000=allocate([119,112,108,105,115,116,0] /* wplist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1016001=allocate([10,32,32,119,112,108,105,115,116,10,10,84,104,101,32,119,112,108,105,115,116,32,99,111,109,109,97,110,100,32,108,105,115,116,115,32,97,108,108,32,116,104,101,32,99,117,114,114,101,110,116,32,119,97,116,99,104,112,111,105,110,116,115,44,32,97,108,111,110,103,32,119,105,116,104,32,116,104,101,105,114,32,105,110,100,101,120,32,97,110,100,32,97,110,121,32,99,111,110,100,105,116,105,111,110,115,32,111,114,32,97,99,116,105,111,110,115,32,97,116,116,97,99,104,101,100,32,116,111,32,116,104,101,109,46,10,0] /* \0A  wplist\0A\0AThe */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1026002=allocate([104,111,116,115,112,111,116,0] /* hotspot\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1036003=allocate([10,32,32,104,111,116,115,112,111,116,32,91,60,99,112,117,62,44,91,60,100,101,112,116,104,62,91,44,60,104,105,116,115,62,93,93,93,10,10,84,104,101,32,104,111,116,115,112,111,116,32,99,111,109,109,97,110,100,32,97,116,116,101,109,112,116,115,32,116,111,32,104,101,108,112,32,108,111,99,97,116,101,32,104,111,116,115,112,111,116,115,32,105,110,32,116,104,101,32,99,111,100,101,32,119,104,101,114,101,32,115,112,101,101,100,117,112,32,111,112,112,111,114,116,117,110,105,116,105,101,115,32,109,105,103,104,116,32,98,101,32,112,114,101,115,101,110,116,46,32,60,99,112,117,62,44,32,119,104,105,99,104,32,100,101,102,97,117,108,116,115,32,116,111,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,67,80,85,44,32,115,112,101,99,105,102,105,101,100,32,119,104,105,99,104,32,112,114,111,99,101,115,115,111,114,39,115,32,109,101,109,111,114,121,32,116,111,32,116,114,97,99,107,46,32,60,100,101,112,116,104,62,44,32,119,104,105,99,104,32,100,101,102,97,117,108,116,115,32,116,111,32,54,52,44,32,99,111,110,116,114,111,108,115,32,116,104,101,32,100,101,112,116,104,32,111,102,32,116,104,101,32,115,101,97,114,99,104,32,98,117,102,102,101,114,46,32,84,104,101,32,115,101,97,114,99,104,32,98,117,102,102,101,114,32,116,114,97,99,107,115,32,116,104,101,32,108,97,115,116,32,60,100,101,112,116,104,62,32,109,101,109,111,114,121,32,114,101,97,100,115,32,102,114,111,109,32,117,110,105,113,117,101,32,80,67,115,46,32,84,104,101,32,60,104,105,116,115,62,32,112,97,114,97,109,101,116,101,114,44,32,119,104,105,99,104,32,100,101,102,97,117,108,116,115,32,116,111,32,50,53,48,44,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,109,105,110,105,109,117,109,32,110,117,109,98,101,114,32,111,102,32,104,105,116,115,32,116,111,32,114,101,112,111,114,116,46,10,10,84,104,101,32,98,97,115,105,99,32,116,104,101,111,114,121,32,111,102,32,111,112,101,114,97,116,105,111,110,32,105,115,32,108,105,107,101,32,116,104,105,115,58,32,101,97,99,104,32,109,101,109,111,114,121,32,114,101,97,100,32,105,115,32,116,114,97,112,112,101,100,32,98,121,32,116,104,101,32,100,101,98,117,103,103,101,114,32,97,110,100,32,108,111,103,103,101,100,32,105,110,32,116,104,101,32,115,101,97,114,99,104,32,98,117,102,102,101,114,32,97,99,99,111,114,100,105,110,103,32,116,111,32,116,104,101,32,97,100,100,114,101,115,115,32,119,104,105,99,104,32,119,97,115,32,114,101,97,100,32,97,110,100,32,116,104,101,32,80,67,32,116,104,97,116,32,101,120,101,99,117,116,101,100,32,116,104,101,32,111,112,99,111,100,101,46,32,73,102,32,116,104,101,32,115,101,97,114,99,104,32,98,117,102,102,101,114,32,97,108,114,101,97,100,121,32,99,111,110,116,97,105,110,115,32,97,32,109,97,116,99,104,105,110,103,32,101,110,116,114,121,44,32,116,104,97,116,32,101,110,116,114,121,39,115,32,99,111,117,110,116,32,105,115,32,105,110,99,114,101,109,101,110,116,101,100,32,97,110,100,32,116,104,101,32,101,110,116,114,121,32,105,115,32,109,111,118,101,100,32,116,111,32,116,104,101,32,116,111,112,32,111,102,32,116,104,101,32,108,105,115,116,46,32,73,102,32,116,104,101,32,115,101,97,114,99,104,32,98,117,102,102,101,114,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,32,109,97,116,99,104,105,110,103,32,101,110,116,114,121,44,32,116,104,101,32,101,110,116,114,121,32,102,114,111,109,32,116,104,101,32,98,111,116,116,111,109,32,111,102,32,116,104,101,32,108,105,115,116,32,105,115,32,114,101,109,111,118,101,100,44,32,97,110,100,32,97,32,110,101,119,32,101,110,116,114,121,32,105,115,32,99,114,101,97,116,101,100,32,97,116,32,116,104,101,32,116,111,112,32,119,105,116,104,32,97,110,32,105,110,105,116,105,97,108,32,99,111,117,110,116,32,111,102,32,49,46,32,69,110,116,114,105,101,115,32,119,104,105,99,104,32,102,97,108,108,32,111,102,102,32,116,104,101,32,98,111,116,116,111,109,32,97,114,101,32,101,120,97,109,105,110,101,100,32,97,110,100,32,105,102,32,116,104,101,105,114,32,99,111,117,110,116,32,105,115,32,108,97,114,103,101,114,32,116,104,97,110,32,60,104,105,116,115,62,44,32,116,104,101,121,32,97,114,101,32,114,101,112,111,114,116,101,100,32,116,111,32,116,104,101,32,100,101,98,117,103,103,101,114,32,99,111,110,115,111,108,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,104,111,116,115,112,111,116,32,48,44,49,48,10,32,32,76,111,111,107,115,32,102,111,114,32,104,111,116,115,112,111,116,115,32,111,110,32,67,80,85,32,48,32,117,115,105,110,103,32,97,32,115,101,97,114,99,104,32,98,117,102,102,101,114,32,111,102,32,49,54,32,101,110,116,114,105,101,115,44,32,114,101,112,111,114,116,105,110,103,32,97,110,121,32,101,110,116,114,105,101,115,32,119,104,105,99,104,32,101,110,100,32,117,112,32,119,105,116,104,32,50,53,48,32,111,114,32,109,111,114,101,32,104,105,116,115,46,10,10,104,111,116,115,112,111,116,32,49,44,52,48,44,35,49,48,48,48,10,32,32,76,111,111,107,115,32,102,111,114,32,104,111,116,115,112,111,116,115,32,111,110,32,67,80,85,32,49,32,117,115,105,110,103,32,97,32,115,101,97,114,99,104,32,98,117,102,102,101,114,32,111,102,32,54,52,32,101,110,116,114,105,101,115,44,32,114,101,112,111,114,116,105,110,103,32,97,110,121,32,101,110,116,114,105,101,115,32,119,104,105,99,104,32,101,110,100,32,117,112,32,119,105,116,104,32,49,48,48,48,32,111,114,32,109,111,114,101,32,104,105,116,115,46,10,0] /* \0A  hotspot [<cpu>, */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1046004=allocate([109,97,112,0] /* map\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1056005=allocate([10,32,32,109,97,112,91,123,100,124,105,125,93,32,60,97,100,100,114,101,115,115,62,10,10,84,104,101,32,109,97,112,47,109,97,112,100,47,109,97,112,105,32,99,111,109,109,97,110,100,115,32,109,97,112,32,97,32,108,111,103,105,99,97,108,32,97,100,100,114,101,115,115,32,105,110,32,109,101,109,111,114,121,32,116,111,32,116,104,101,32,99,111,114,114,101,99,116,32,112,104,121,115,105,99,97,108,32,97,100,100,114,101,115,115,44,32,97,115,32,119,101,108,108,32,97,115,32,115,112,101,99,105,102,121,105,110,103,32,116,104,101,32,98,97,110,107,46,32,39,109,97,112,39,32,119,105,108,108,32,109,97,112,32,112,114,111,103,114,97,109,32,115,112,97,99,101,32,109,101,109,111,114,121,44,32,119,104,105,108,101,32,39,109,97,112,100,39,32,119,105,108,108,32,109,97,112,32,100,97,116,97,32,115,112,97,99,101,32,109,101,109,111,114,121,32,97,110,100,32,39,109,97,112,105,39,32,119,105,108,108,32,109,97,112,32,73,47,79,32,115,112,97,99,101,32,109,101,109,111,114,121,46,10,10,69,120,97,109,112,108,101,58,10,10,109,97,112,32,49,53,50,100,48,10,32,32,71,105,118,101,115,32,112,104,121,115,105,99,97,108,32,97,100,100,114,101,115,115,32,97,110,100,32,98,97,110,107,32,102,111,114,32,108,111,103,105,99,97,108,32,97,100,100,114,101,115,115,32,49,53,50,100,48,32,105,110,32,112,114,111,103,114,97,109,32,109,101,109,111,114,121,10,0] /* \0A  map[{d|i}] <add */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1066006=allocate([109,101,109,100,117,109,112,0] /* memdump\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1076007=allocate([10,32,32,109,101,109,100,117,109,112,32,91,60,102,105,108,101,110,97,109,101,62,93,10,10,68,117,109,112,115,32,116,104,101,32,99,117,114,114,101,110,116,32,109,101,109,111,114,121,32,109,97,112,32,116,111,32,60,102,105,108,101,110,97,109,101,62,46,32,73,102,32,60,102,105,108,101,110,97,109,101,62,32,105,115,32,111,109,105,116,116,101,100,44,32,116,104,101,110,32,100,117,109,112,115,10,116,111,32,109,101,109,100,117,109,112,46,108,111,103,10,69,120,97,109,112,108,101,115,58,10,10,109,101,109,100,117,109,112,32,109,121,108,111,103,46,108,111,103,10,32,32,68,117,109,112,115,32,109,101,109,111,114,121,32,116,111,32,109,121,108,111,103,46,108,111,103,46,10,10,109,101,109,100,117,109,112,10,32,32,68,117,109,112,115,32,109,101,109,111,114,121,32,116,111,32,109,101,109,100,117,109,112,46,108,111,103,46,10,0] /* \0A  memdump [<filen */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1086008=allocate([99,111,109,97,100,100,0] /* comadd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1096009=allocate([10,32,32,99,111,109,97,100,100,91,47,47,93,32,60,97,100,100,114,101,115,115,62,44,60,99,111,109,109,101,110,116,62,10,10,65,100,100,115,32,97,32,115,116,114,105,110,103,32,60,99,111,109,109,101,110,116,62,32,116,111,32,116,104,101,32,100,105,115,97,115,115,101,109,98,108,101,100,32,99,111,100,101,32,97,116,32,60,97,100,100,114,101,115,115,62,46,32,84,104,101,32,115,104,111,114,116,99,117,116,32,102,111,114,32,116,104,105,115,32,99,111,109,109,97,110,100,32,105,115,32,115,105,109,112,108,121,32,39,47,47,39,10,10,69,120,97,109,112,108,101,115,58,10,10,99,111,109,97,100,100,32,48,44,32,104,101,108,108,111,32,119,111,114,108,100,46,10,32,32,65,100,100,115,32,116,104,101,32,99,111,109,109,101,110,116,32,39,104,101,108,108,111,32,119,111,114,108,100,46,39,32,116,111,32,116,104,101,32,99,111,100,101,32,97,116,32,97,100,100,114,101,115,115,32,48,120,48,10,10,47,47,32,49,48,44,32,117,110,100,111,99,117,109,101,110,116,101,100,32,111,112,99,111,100,101,33,10,32,32,65,100,100,115,32,116,104,101,32,99,111,109,109,101,110,116,32,39,117,110,100,111,99,117,109,101,110,116,101,100,32,111,112,99,111,100,101,33,39,32,116,111,32,116,104,101,32,99,111,100,101,32,97,116,32,97,100,100,114,101,115,115,32,48,120,49,48,10,10,0] /* \0A  comadd[//] <add */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1106010=allocate([99,111,109,115,97,118,101,0] /* comsave\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1116011=allocate([10,32,32,99,111,109,115,97,118,101,10,10,83,97,118,101,115,32,116,104,101,32,119,111,114,107,105,110,103,32,99,111,109,109,101,110,116,115,32,116,111,32,116,104,101,32,100,114,105,118,101,114,39,115,32,88,77,76,32,99,111,109,109,101,110,116,32,102,105,108,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,111,109,115,97,118,101,10,32,32,83,97,118,101,115,32,116,104,101,32,99,111,109,109,101,110,116,115,32,116,111,32,116,104,101,32,100,114,105,118,101,114,39,115,32,99,111,109,109,101,110,116,32,102,105,108,101,10,10,0] /* \0A  comsave\0A\0ASa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1126012=allocate([99,111,109,100,101,108,101,116,101,0] /* comdelete\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1136013=allocate([10,32,32,99,111,109,100,101,108,101,116,101,10,10,68,101,108,101,116,101,115,32,116,104,101,32,99,111,109,109,101,110,116,32,97,116,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,109,101,109,111,114,121,32,111,102,102,115,101,116,46,32,84,104,101,32,99,111,109,109,101,110,116,32,119,104,105,99,104,32,105,115,32,100,101,108,101,116,101,100,32,105,115,32,105,110,32,116,104,101,32,99,117,114,114,101,110,116,108,121,32,97,99,116,105,118,101,32,109,101,109,111,114,121,32,98,97,110,107,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,111,109,100,101,108,101,116,101,32,49,48,10,32,32,68,101,108,101,116,101,115,32,116,104,101,32,99,111,109,109,101,110,116,32,97,116,32,99,111,100,101,32,97,100,100,114,101,115,115,32,48,120,49,48,32,40,117,115,105,110,103,32,116,104,101,32,99,117,114,114,101,110,116,32,109,101,109,111,114,121,32,98,97,110,107,32,115,101,116,116,105,110,103,115,41,10,10,0] /* \0A  comdelete\0A\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1146014=allocate([99,104,101,97,116,105,110,105,116,0] /* cheatinit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1156015=allocate([10,32,32,99,104,101,97,116,105,110,105,116,32,91,60,115,105,103,110,62,60,119,105,100,116,104,62,60,115,119,97,112,62,44,91,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,91,44,60,99,112,117,62,93,93,93,10,10,84,104,101,32,99,104,101,97,116,105,110,105,116,32,99,111,109,109,97,110,100,32,105,110,105,116,105,97,108,105,122,101,115,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,116,111,32,116,104,101,32,115,101,108,101,99,116,101,100,32,109,101,109,111,114,121,32,97,114,101,97,46,10,73,102,32,110,111,32,112,97,114,97,109,101,116,101,114,32,105,115,32,115,112,101,99,105,102,105,101,100,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,105,115,32,105,110,105,116,105,97,108,105,122,101,100,32,116,111,32,97,108,108,32,99,104,97,110,103,101,97,98,108,101,32,109,101,109,111,114,121,32,111,102,32,116,104,101,32,109,97,105,110,32,99,112,117,46,10,60,115,105,103,110,62,32,99,97,110,32,98,101,32,115,40,115,105,103,110,101,100,41,32,111,114,32,117,40,117,110,115,105,103,110,101,100,41,10,60,119,105,100,116,104,62,32,99,97,110,32,98,101,32,98,40,56,32,98,105,116,41,44,32,119,40,49,54,32,98,105,116,41,44,32,100,40,51,50,32,98,105,116,41,32,111,114,32,113,40,54,52,32,98,105,116,41,10,60,115,119,97,112,62,32,97,112,112,101,110,100,32,115,32,102,111,114,32,115,119,97,112,112,101,100,32,115,101,97,114,99,104,10,10,69,120,97,109,112,108,101,115,58,10,10,99,104,101,97,116,105,110,105,116,32,117,98,44,48,120,49,48,48,48,44,48,120,49,48,10,32,32,73,110,105,116,105,97,108,105,122,101,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,102,114,111,109,32,48,120,49,48,48,48,32,116,111,32,48,120,49,48,49,48,32,111,102,32,116,104,101,32,102,105,114,115,116,32,67,80,85,46,10,10,99,104,101,97,116,105,110,105,116,32,115,119,44,48,120,50,48,48,48,44,48,120,49,48,48,48,44,49,10,32,32,73,110,105,116,105,97,108,105,122,101,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,119,105,116,104,32,119,105,100,116,104,32,111,102,32,50,32,98,121,116,101,32,105,110,32,115,105,103,110,101,100,32,109,111,100,101,32,102,114,111,109,32,48,120,50,48,48,48,32,116,111,32,48,120,51,48,48,48,32,111,102,32,116,104,101,32,115,101,99,111,110,100,32,67,80,85,46,10,10,99,104,101,97,116,105,110,105,116,32,117,100,115,44,48,120,48,48,48,48,44,48,120,49,48,48,48,10,32,32,73,110,105,116,105,97,108,105,122,101,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,119,105,116,104,32,119,105,100,116,104,32,111,102,32,52,32,98,121,116,101,32,115,119,97,112,112,101,100,32,102,114,111,109,32,48,120,48,48,48,48,32,116,111,32,48,120,49,48,48,48,46,10,0] /* \0A  cheatinit [<sig */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1166016=allocate([99,104,101,97,116,114,97,110,103,101,0] /* cheatrange\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1176017=allocate([10,32,32,99,104,101,97,116,114,97,110,103,101,32,60,97,100,100,114,101,115,115,62,44,60,108,101,110,103,116,104,62,10,10,84,104,101,32,99,104,101,97,116,114,97,110,103,101,32,99,111,109,109,97,110,100,32,97,100,100,115,32,116,104,101,32,115,101,108,101,99,116,101,100,32,109,101,109,111,114,121,32,97,114,101,97,32,116,111,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,46,10,66,101,102,111,114,101,32,117,115,105,110,103,32,99,104,101,97,116,114,97,110,103,101,32,105,116,32,105,115,32,110,101,99,101,115,115,97,114,121,32,116,111,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,32,119,105,116,104,32,99,104,101,97,116,105,110,105,116,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,104,101,97,116,114,97,110,103,101,32,48,120,49,48,48,48,44,48,120,49,48,10,32,32,65,100,100,32,116,104,101,32,98,121,116,101,115,32,102,114,111,109,32,48,120,49,48,48,48,32,116,111,32,48,120,49,48,49,48,32,116,111,32,116,104,101,32,99,104,101,97,116,32,115,101,97,114,99,104,46,10,0] /* \0A  cheatrange <add */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1186018=allocate([99,104,101,97,116,110,101,120,116,0] /* cheatnext\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1196019=allocate([10,32,32,99,104,101,97,116,110,101,120,116,32,60,99,111,110,100,105,116,105,111,110,62,91,44,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,93,10,10,84,104,101,32,99,104,101,97,116,110,101,120,116,32,99,111,109,109,97,110,100,32,119,105,108,108,32,109,97,107,101,32,99,111,109,112,97,114,105,115,111,110,115,32,119,105,116,104,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,32,109,97,116,99,104,101,115,46,10,80,111,115,115,105,98,108,101,32,60,99,111,110,100,105,116,105,111,110,62,58,10,32,32,97,108,108,10,32,32,32,110,111,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,110,101,101,100,101,100,46,10,32,32,32,117,115,101,32,116,111,32,117,112,100,97,116,101,32,116,104,101,32,108,97,115,116,32,118,97,108,117,101,32,119,105,116,104,111,117,116,32,99,104,97,110,103,105,110,103,32,116,104,101,32,99,117,114,114,101,110,116,32,109,97,116,99,104,101,115,46,10,32,32,101,113,117,97,108,32,91,101,113,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,110,111,116,101,113,117,97,108,32,91,110,101,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,101,113,117,97,108,32,116,111,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,101,113,117,97,108,32,116,111,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,100,101,99,114,101,97,115,101,32,91,100,101,44,32,43,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,98,121,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,105,110,99,114,101,97,115,101,32,91,105,110,44,32,45,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,105,110,99,114,101,97,115,101,100,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,105,110,99,114,101,97,115,101,100,32,98,121,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,100,101,99,114,101,97,115,101,111,114,101,113,117,97,108,32,91,100,101,101,113,93,10,32,32,32,110,111,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,110,101,101,100,101,100,46,10,32,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,111,114,32,104,97,118,101,32,115,97,109,101,32,118,97,108,117,101,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,105,110,99,114,101,97,115,101,111,114,101,113,117,97,108,32,91,105,110,101,113,93,10,32,32,32,110,111,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,110,101,101,100,101,100,46,10,32,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,111,114,32,104,97,118,101,32,115,97,109,101,32,118,97,108,117,101,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,32,32,115,109,97,108,108,101,114,111,102,32,91,108,116,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,116,104,105,115,32,99,111,110,100,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,115,109,97,108,108,101,114,32,116,104,97,110,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,103,114,101,97,116,101,114,111,102,32,91,103,116,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,116,104,105,115,32,99,111,110,100,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,108,97,114,103,101,114,32,116,104,97,110,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,99,104,97,110,103,101,100,98,121,32,91,99,104,44,32,126,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,116,104,105,115,32,99,111,110,100,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,99,104,97,110,103,101,100,32,98,121,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,104,101,97,116,110,101,120,116,32,105,110,99,114,101,97,115,101,10,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,105,110,99,114,101,97,115,101,100,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,10,99,104,101,97,116,110,101,120,116,32,100,101,99,114,101,97,115,101,44,32,49,10,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,98,121,32,49,32,115,105,110,99,101,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,0] /* \0A  cheatnext <cond */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1206020=allocate([99,104,101,97,116,110,101,120,116,102,0] /* cheatnextf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1216021=allocate([10,32,32,99,104,101,97,116,110,101,120,116,102,32,60,99,111,110,100,105,116,105,111,110,62,91,44,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,93,10,10,84,104,101,32,99,104,101,97,116,110,101,120,116,102,32,99,111,109,109,97,110,100,32,119,105,108,108,32,109,97,107,101,32,99,111,109,112,97,114,105,115,111,110,115,32,119,105,116,104,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,80,111,115,115,105,98,108,101,32,60,99,111,110,100,105,116,105,111,110,62,58,10,32,32,97,108,108,10,32,32,32,110,111,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,110,101,101,100,101,100,46,10,32,32,32,117,115,101,32,116,111,32,117,112,100,97,116,101,32,116,104,101,32,108,97,115,116,32,118,97,108,117,101,32,119,105,116,104,111,117,116,32,99,104,97,110,103,105,110,103,32,116,104,101,32,99,117,114,114,101,110,116,32,109,97,116,99,104,101,115,46,10,32,32,101,113,117,97,108,32,91,101,113,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,110,111,116,101,113,117,97,108,32,91,110,101,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,101,113,117,97,108,32,116,111,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,110,111,116,32,101,113,117,97,108,32,116,111,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,100,101,99,114,101,97,115,101,32,91,100,101,44,32,43,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,98,121,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,105,110,99,114,101,97,115,101,32,91,105,110,44,32,45,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,105,110,99,114,101,97,115,101,100,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,105,110,99,114,101,97,115,101,100,32,98,121,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,100,101,99,114,101,97,115,101,111,114,101,113,117,97,108,32,91,100,101,101,113,93,10,32,32,32,110,111,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,110,101,101,100,101,100,46,10,32,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,111,114,32,104,97,118,101,32,115,97,109,101,32,118,97,108,117,101,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,105,110,99,114,101,97,115,101,111,114,101,113,117,97,108,32,91,105,110,101,113,93,10,32,32,32,110,111,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,110,101,101,100,101,100,46,10,32,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,111,114,32,104,97,118,101,32,115,97,109,101,32,118,97,108,117,101,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,32,32,115,109,97,108,108,101,114,111,102,32,91,108,116,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,116,104,105,115,32,99,111,110,100,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,115,109,97,108,108,101,114,32,116,104,97,110,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,103,114,101,97,116,101,114,111,102,32,91,103,116,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,116,104,105,115,32,99,111,110,100,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,46,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,97,114,101,32,108,97,114,103,101,114,32,116,104,97,110,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,46,10,32,32,99,104,97,110,103,101,100,98,121,32,91,99,104,44,32,126,93,10,32,32,32,119,105,116,104,111,117,116,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,116,104,105,115,32,99,111,110,100,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,10,32,32,32,119,105,116,104,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,99,104,97,110,103,101,100,32,98,121,32,116,104,101,32,60,99,111,109,112,97,114,105,115,111,110,118,97,108,117,101,62,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,104,101,97,116,110,101,120,116,102,32,105,110,99,114,101,97,115,101,10,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,105,110,99,114,101,97,115,101,100,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,10,99,104,101,97,116,110,101,120,116,102,32,100,101,99,114,101,97,115,101,44,32,49,10,32,32,115,101,97,114,99,104,32,102,111,114,32,97,108,108,32,98,121,116,101,115,32,116,104,97,116,32,104,97,118,101,32,100,101,99,114,101,97,115,101,100,32,98,121,32,49,32,115,105,110,99,101,32,116,104,101,32,105,110,105,116,105,97,108,32,115,101,97,114,99,104,46,10,0] /* \0A  cheatnextf <con */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1226022=allocate([99,104,101,97,116,108,105,115,116,0] /* cheatlist\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1236023=allocate([10,32,32,99,104,101,97,116,108,105,115,116,32,91,60,102,105,108,101,110,97,109,101,62,93,10,10,87,105,116,104,111,117,116,32,60,102,105,108,101,110,97,109,101,62,32,115,104,111,119,32,116,104,101,32,108,105,115,116,32,111,102,32,109,97,116,99,104,101,115,32,105,110,32,116,104,101,32,100,101,98,117,103,32,99,111,110,115,111,108,101,46,10,87,105,116,104,32,60,102,105,108,101,110,97,109,101,62,32,115,97,118,101,32,116,104,101,32,108,105,115,116,32,111,102,32,109,97,116,99,104,101,115,32,105,110,32,98,97,115,105,99,32,120,109,108,32,102,111,114,109,97,116,32,116,111,32,60,102,105,108,101,110,97,109,101,62,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,104,101,97,116,108,105,115,116,10,32,32,83,104,111,119,32,116,104,101,32,99,117,114,114,101,110,116,32,109,97,116,99,104,101,115,32,105,110,32,116,104,101,32,100,101,98,117,103,32,99,111,110,115,111,108,101,46,10,99,104,101,97,116,108,105,115,116,32,99,104,101,97,116,46,116,120,116,10,32,32,83,97,118,101,32,116,104,101,32,99,117,114,114,101,110,116,32,109,97,116,99,104,101,115,32,116,111,32,99,104,101,97,116,46,116,120,116,46,10,0] /* \0A  cheatlist [<fil */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1246024=allocate([99,104,101,97,116,117,110,100,111,0] /* cheatundo\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1256025=allocate([10,32,32,99,104,101,97,116,117,110,100,111,10,10,85,110,100,111,32,116,104,101,32,114,101,115,117,108,116,115,32,111,102,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,46,10,84,104,101,32,117,110,100,111,32,99,111,109,109,97,110,100,32,104,97,115,32,110,111,32,101,102,102,101,99,116,32,111,110,32,116,104,101,32,108,97,115,116,32,118,97,108,117,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,99,104,101,97,116,117,110,100,111,10,32,32,85,110,100,111,32,116,104,101,32,108,97,115,116,32,115,101,97,114,99,104,32,40,115,116,97,116,101,32,111,110,108,121,41,46,10,0] /* \0A  cheatundo\0A\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1266026=allocate([105,109,97,103,101,115,0] /* images\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1276027=allocate([10,32,32,105,109,97,103,101,115,10,10,85,115,101,100,32,116,111,32,100,105,115,112,108,97,121,32,108,105,115,116,32,111,102,32,97,118,97,105,108,97,98,108,101,32,105,109,97,103,101,32,100,101,118,105,99,101,115,46,10,10,69,120,97,109,112,108,101,115,58,10,10,105,109,97,103,101,115,10,32,32,83,104,111,119,32,108,105,115,116,32,111,102,32,100,101,118,105,99,101,115,32,97,110,100,32,109,111,117,110,116,101,100,32,102,105,108,101,115,32,102,111,114,32,99,117,114,114,101,110,116,32,100,114,105,118,101,114,46,10,0] /* \0A  images\0A\0AUse */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1286028=allocate([109,111,117,110,116,0] /* mount\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1296029=allocate([10,32,32,109,111,117,110,116,32,60,100,101,118,105,99,101,62,44,60,102,105,108,101,110,97,109,101,62,10,10,77,111,117,110,116,32,60,102,105,108,101,110,97,109,101,62,32,116,111,32,105,109,97,103,101,32,60,100,101,118,105,99,101,62,46,10,60,102,105,108,101,110,97,109,101,62,32,99,97,110,32,98,101,32,115,111,102,116,108,105,115,116,32,105,116,101,109,32,111,114,32,102,117,108,108,32,112,97,116,104,32,116,111,32,102,105,108,101,46,10,10,69,120,97,109,112,108,101,115,58,10,10,109,111,117,110,116,32,99,97,114,116,44,97,108,97,100,100,105,110,10,32,32,77,111,117,110,116,115,32,115,111,102,116,108,105,115,116,32,105,116,101,109,32,97,108,108,97,100,105,110,32,111,110,32,99,97,114,116,32,100,101,118,105,99,101,46,10,0] /* \0A  mount <device>, */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1306030=allocate([117,110,109,111,117,110,116,0] /* unmount\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1316031=allocate([10,32,32,117,110,109,111,117,110,116,32,60,100,101,118,105,99,101,62,10,10,85,110,109,111,117,110,116,115,32,102,105,108,101,32,102,114,111,109,32,105,109,97,103,101,32,60,100,101,118,105,99,101,62,46,10,10,69,120,97,109,112,108,101,115,58,10,10,117,110,109,111,117,110,116,32,99,97,114,116,10,32,32,85,110,109,111,117,110,116,115,32,97,110,121,32,102,105,108,101,32,109,111,117,110,116,101,100,32,111,110,32,100,101,118,105,99,101,32,110,97,109,101,100,32,99,97,114,116,46,10,0] /* \0A  unmount <device */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11text_bitmap=allocate([0, 0, 0, 0, 0, 0, 0, 32, 80, 136, 136, 248, 136, 136, 0, 0, 0, 0, 0, 0, 0, 112, 136, 128, 128, 128, 136, 112, 0, 0, 0, 0, 0, 0, 0, 248, 128, 128, 240, 128, 128, 248, 248, 128, 128, 240, 128, 128, 128, 0, 0, 0, 0, 0, 0, 0, 136, 136, 136, 248, 136, 136, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 216, 168, 168, 168, 136, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 136, 136, 240, 128, 128, 128, 0, 0, 0, 0, 0, 0, 0, 240, 136, 136, 240, 160, 144, 136, 112, 136, 128, 112, 8, 136, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 112, 136, 136, 136, 136, 136, 112, 32, 96, 32, 32, 32, 32, 112, 112, 136, 8, 112, 128, 128, 248, 248, 8, 16, 48, 8, 136, 112, 16, 48, 80, 144, 248, 16, 16, 248, 128, 240, 8, 8, 136, 112, 120, 128, 128, 240, 136, 136, 112, 248, 8, 8, 16, 32, 64, 128, 112, 136, 136, 112, 136, 136, 112, 112, 136, 136, 120, 8, 8, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], "i8", ALLOC_STATIC);
STRING_TABLE.__str6034=allocate([112,114,56,50,49,48,0] /* pr8210\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16035=allocate([112,114,45,56,50,49,48,95,109,99,117,95,117,100,54,48,48,53,97,46,98,105,110,0] /* pr-8210_mcu_ud6005a. */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26036=allocate([82,49,50,48,102,97,56,51,98,83,98,53,49,52,51,50,54,99,97,49,102,53,50,100,54,100,56,57,48,53,54,56,54,56,102,57,100,49,55,101,97,98,100,52,101,51,102,51,49,100,0] /* R120fa83bSb514326ca1 */, "i8", ALLOC_STATIC);
__ZL10rom_pr8210=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 32769, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str36037=allocate([80,105,111,110,101,101,114,32,80,82,45,56,50,49,48,0] /* Pioneer PR-8210\00 */, "i8", ALLOC_STATIC);
_pr8210_interface=allocate([2, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7738, 0, 0, 0, 7740, 0, 0, 0, 7742, 0, 0, 0, 7744, 0, 0, 0, 7746, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7748, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str46040=allocate([115,105,109,117,116,114,101,107,0] /* simutrek\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56041=allocate([108,97,115,101,114,95,112,108,97,121,101,114,95,105,110,116,101,114,102,97,99,101,95,100,56,55,52,56,95,97,51,48,56,46,98,105,110,0] /* laser_player_interfa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66042=allocate([82,101,101,100,51,101,55,50,56,83,49,101,98,51,52,54,55,102,49,99,52,49,53,53,51,51,55,53,98,50,99,50,49,57,53,50,99,100,53,57,51,98,49,54,55,102,53,52,49,54,0] /* Reed3e728S1eb3467f1c */, "i8", ALLOC_STATIC);
__ZL12rom_simutrek=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 32769, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1024, 0, 0, 0, 32769, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1024, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str76043=allocate([83,105,109,117,116,114,101,107,32,77,111,100,105,102,105,101,100,32,80,82,45,56,50,49,48,0] /* Simutrek Modified PR */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86044=allocate([109,112,114,56,50,49,48,0] /* mpr8210\00 */, "i8", ALLOC_STATIC);
_simutrek_interface=allocate([3, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7750, 0, 0, 0, 7752, 0, 0, 0, 7754, 0, 0, 0, 7756, 0, 0, 0, 7746, 0, 0, 0, 7758, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7760, 0, 0, 0, 7762, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str96047=allocate([115,105,109,117,116,114,101,107,95,108,97,116,99,104,101,100,95,100,97,116,97,95,119,0] /* simutrek_latched_dat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106048=allocate([105,114,113,95,111,102,102,0] /* irq_off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126050=allocate([115,105,109,117,116,114,101,107,95,100,97,116,97,95,114,0] /* simutrek_data_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136051=allocate([115,105,109,117,116,114,101,107,95,112,111,114,116,50,95,114,0] /* simutrek_port2_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146052=allocate([115,105,109,117,116,114,101,107,95,112,111,114,116,50,95,119,0] /* simutrek_port2_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str156053=allocate([115,105,109,117,116,114,101,107,95,116,48,95,114,0] /* simutrek_t0_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166054=allocate([118,115,121,110,99,95,111,102,102,0] /* vsync_off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176055=allocate([118,98,105,95,100,97,116,97,95,102,101,116,99,104,0] /* vbi_data_fetch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186056=allocate([112,114,56,50,49,48,95,112,105,97,95,114,0] /* pr8210_pia_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str196057=allocate([112,114,56,50,49,48,95,112,105,97,95,119,0] /* pr8210_pia_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str206058=allocate([112,114,56,50,49,48,95,98,117,115,95,114,0] /* pr8210_bus_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str216059=allocate([112,114,56,50,49,48,95,112,111,114,116,49,95,119,0] /* pr8210_port1_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str226060=allocate([112,114,56,50,49,48,95,112,111,114,116,50,95,119,0] /* pr8210_port2_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str236061=allocate([112,114,56,50,49,48,95,116,48,95,114,0] /* pr8210_t0_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str246062=allocate([112,114,56,50,49,48,95,116,49,95,114,0] /* pr8210_t1_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str256063=allocate([112,114,56,50,49,48,95,115,116,97,110,100,98,121,0] /* pr8210_standby\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str266064=allocate([112,114,56,50,49,48,95,97,117,100,105,111,49,0] /* pr8210_audio1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str276065=allocate([112,114,56,50,49,48,95,97,117,100,105,111,50,0] /* pr8210_audio2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str286066=allocate([112,114,56,50,49,48,95,99,108,118,0] /* pr8210_clv\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str296067=allocate([112,114,56,50,49,48,95,99,97,118,0] /* pr8210_cav\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str306068=allocate([112,114,56,50,49,48,95,115,114,101,118,0] /* pr8210_srev\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str316069=allocate([112,114,56,50,49,48,95,115,102,119,100,0] /* pr8210_sfwd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str326070=allocate([112,114,56,50,49,48,95,112,108,97,121,0] /* pr8210_play\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str336071=allocate([112,114,56,50,49,48,95,115,116,101,112,0] /* pr8210_step\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str346072=allocate([112,114,56,50,49,48,95,112,97,117,115,101,0] /* pr8210_pause\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str356073=allocate([37,48,51,88,58,85,110,107,110,111,119,110,32,80,82,45,56,50,49,48,32,80,73,65,32,119,114,105,116,101,32,116,111,32,111,102,102,115,101,116,32,37,48,50,88,32,61,32,37,48,50,88,10,0] /* %03X:Unknown PR-8210 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str376075=allocate([37,48,51,88,58,85,110,107,110,111,119,110,32,80,82,45,56,50,49,48,32,80,73,65,32,114,101,97,100,32,102,114,111,109,32,111,102,102,115,101,116,32,37,48,50,88,10,0] /* %03X:Unknown PR-8210 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6078=allocate([118,112,57,51,49,0] /* vp931\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16079=allocate([97,116,45,54,45,49,95,97,46,98,105,110,0] /* at-6-1_a.bin\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26080=allocate([82,101,49,49,98,51,99,56,100,83,101,97,50,100,55,102,54,97,48,52,52,101,100,48,56,53,99,101,53,101,48,57,100,56,98,49,98,49,97,50,49,99,51,55,102,48,101,57,98,56,0] /* Re11b3c8dSea2d7f6a04 */, "i8", ALLOC_STATIC);
__ZL9rom_vp931=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 32769, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str36081=allocate([80,104,105,108,108,105,112,115,32,50,50,86,80,57,51,49,0] /* Phillips 22VP931\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46082=allocate([50,50,118,112,57,51,49,0] /* 22vp931\00 */, "i8", ALLOC_STATIC);
_vp931_interface=allocate([5, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7764, 0, 0, 0, 7766, 0, 0, 0, 7768, 0, 0, 0, 7770, 0, 0, 0, 0, 0, 0, 0, 7772, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7774, 0, 0, 0, 7776, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7778, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str56085=allocate([100,101,102,101,114,114,101,100,95,100,97,116,97,95,119,0] /* deferred_data_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66086=allocate([118,98,105,95,100,97,116,97,95,102,101,116,99,104,0] /* vbi_data_fetch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76087=allocate([105,114,113,95,111,102,102,0] /* irq_off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86088=allocate([100,97,116,97,115,116,114,111,98,101,95,111,102,102,0] /* datastrobe_off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106090=allocate([101,114,112,95,111,102,102,0] /* erp_off\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116091=allocate([116,114,97,99,107,116,105,109,101,114,0] /* tracktimer\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126092=allocate([107,101,121,112,97,100,95,114,0] /* keypad_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136093=allocate([111,117,116,112,117,116,48,95,119,0] /* output0_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146094=allocate([117,110,107,110,111,119,110,95,114,0] /* unknown_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str156095=allocate([111,117,116,112,117,116,49,95,119,0] /* output1_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166096=allocate([100,97,116,105,99,95,114,0] /* datic_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176097=allocate([108,99,100,95,119,0] /* lcd_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186098=allocate([102,114,111,109,95,99,111,110,116,114,111,108,108,101,114,95,114,0] /* from_controller_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str196099=allocate([116,111,95,99,111,110,116,114,111,108,108,101,114,95,119,0] /* to_controller_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str206100=allocate([112,111,114,116,49,95,114,0] /* port1_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str216101=allocate([112,111,114,116,49,95,119,0] /* port1_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str226102=allocate([112,111,114,116,50,95,114,0] /* port2_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str236103=allocate([112,111,114,116,50,95,119,0] /* port2_w\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str246104=allocate([116,48,95,114,0] /* t0_r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str256105=allocate([116,49,95,114,0] /* t1_r\00 */, "i8", ALLOC_STATIC);
_PPI8255=allocate([7780], ["%class.device_t.17112* (%class.machine_config.17066*, i8*, %class.device_t.17112*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str6110=allocate([73,110,116,101,108,32,80,80,73,56,50,53,53,0] /* Intel PPI8255\00 */, "i8", ALLOC_STATIC);
__ZTV14ppi8255_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7782, 0, 0, 0, 7784, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 7786, 0, 0, 0, 1734, 0, 0, 0, 7788, 0, 0, 0, 1738, 0, 0, 0, 7790, 0, 0, 0, 1742, 0, 0, 0, 7792, 0, 0, 0, 7794, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str16111=allocate([109,95,103,114,111,117,112,95,97,95,109,111,100,101,0] /* m_group_a_mode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26112=allocate([109,95,103,114,111,117,112,95,98,95,109,111,100,101,0] /* m_group_b_mode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36113=allocate([109,95,112,111,114,116,95,97,95,100,105,114,0] /* m_port_a_dir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46114=allocate([109,95,112,111,114,116,95,98,95,100,105,114,0] /* m_port_b_dir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56115=allocate([109,95,112,111,114,116,95,99,104,95,100,105,114,0] /* m_port_ch_dir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66116=allocate([109,95,112,111,114,116,95,99,108,95,100,105,114,0] /* m_port_cl_dir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76117=allocate([109,95,111,98,102,95,97,0] /* m_obf_a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86118=allocate([109,95,111,98,102,95,98,0] /* m_obf_b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str96119=allocate([109,95,105,98,102,95,97,0] /* m_ibf_a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106120=allocate([109,95,105,98,102,95,98,0] /* m_ibf_b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116121=allocate([109,95,105,110,116,101,95,97,0] /* m_inte_a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126122=allocate([109,95,105,110,116,101,95,98,0] /* m_inte_b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136123=allocate([109,95,105,110,116,101,95,49,0] /* m_inte_1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146124=allocate([109,95,105,110,116,101,95,50,0] /* m_inte_2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str156125=allocate([109,95,105,110,95,109,97,115,107,0] /* m_in_mask\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166126=allocate([109,95,111,117,116,95,109,97,115,107,0] /* m_out_mask\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176127=allocate([109,95,114,101,97,100,0] /* m_read\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186128=allocate([109,95,108,97,116,99,104,0] /* m_latch\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS14ppi8255_device=allocate([49,52,112,112,105,56,50,53,53,95,100,101,118,105,99,101,0] /* 14ppi8255_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS17ppi8255_interface=allocate([49,55,112,112,105,56,50,53,53,95,105,110,116,101,114,102,97,99,101,0] /* 17ppi8255_interface\ */, "i8", ALLOC_STATIC);
__ZTI17ppi8255_interface=allocate(8, "*", ALLOC_STATIC);
__ZTI14ppi8255_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 91138, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str196129=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,104,0] /* src/emu/devintrf.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI14ppi8255_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7796, 0, 0, 0, 7798, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14ppi8255_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,112,112,105,56,50,53,53,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14ppi8255_deviceE=allocate(12, "*", ALLOC_STATIC);
_Z80CTC=allocate([7800], ["%class.device_t.17306* (%class.machine_config.17260*, i8*, %class.device_t.17306*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str6136=allocate([90,105,108,111,103,32,90,56,48,32,67,84,67,0] /* Zilog Z80 CTC\00 */, "i8", ALLOC_STATIC);
__ZTV13z80ctc_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7802, 0, 0, 0, 7804, 0, 0, 0, 5162, 0, 0, 0, 1728, 0, 0, 0, 5164, 0, 0, 0, 7806, 0, 0, 0, 1734, 0, 0, 0, 7808, 0, 0, 0, 1738, 0, 0, 0, 7810, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 7812, 0, 0, 0, 7814, 0, 0, 0, 7816, 0, 0, 0, -356, 0, 0, 0, 0, 0, 0, 0, 7818, 0, 0, 0, 7820, 0, 0, 0, 1882, 0, 0, 0, 1954, 0, 0, 0, 1930, 0, 0, 0, 1932, 0, 0, 0, 1934, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 7822, 0, 0, 0, 7824, 0, 0, 0, 7826, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str16137=allocate([109,95,118,101,99,116,111,114,0] /* m_vector\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26138=allocate([122,56,48,99,116,99,95,105,114,113,95,97,99,107,58,32,102,97,105,108,101,100,32,116,111,32,102,105,110,100,32,97,110,32,105,110,116,101,114,114,117,112,116,32,116,111,32,97,99,107,33,10,0] /* z80ctc_irq_ack: fail */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36139=allocate([122,56,48,99,116,99,95,105,114,113,95,114,101,116,105,58,32,102,97,105,108,101,100,32,116,111,32,102,105,110,100,32,97,110,32,105,110,116,101,114,114,117,112,116,32,116,111,32,99,108,101,97,114,32,73,69,79,32,111,110,33,10,0] /* z80ctc_irq_reti: fai */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46140=allocate([115,116,97,116,105,99,95,116,105,109,101,114,95,99,97,108,108,98,97,99,107,0] /* static_timer_callbac */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56141=allocate([109,95,109,111,100,101,0] /* m_mode\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66142=allocate([109,95,116,99,111,110,115,116,0] /* m_tconst\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76143=allocate([109,95,100,111,119,110,0] /* m_down\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86144=allocate([109,95,101,120,116,99,108,107,0] /* m_extclk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str96145=allocate([109,95,105,110,116,95,115,116,97,116,101,0] /* m_int_state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106146=allocate([67,84,67,32,37,100,32,105,115,32,67,111,117,110,116,101,114,77,111,100,101,32,58,32,67,97,110,39,116,32,99,97,108,99,117,108,97,116,101,32,112,101,114,105,111,100,10,0] /* CTC %d is CounterMod */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116147=allocate([67,84,67,32,86,101,99,116,111,114,32,61,32,37,48,50,120,10,0] /* CTC Vector = %02x\0A */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13z80ctc_device=allocate([49,51,122,56,48,99,116,99,95,100,101,118,105,99,101,0] /* 13z80ctc_device\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS16z80ctc_interface=allocate([49,54,122,56,48,99,116,99,95,105,110,116,101,114,102,97,99,101,0] /* 16z80ctc_interface\0 */, "i8", ALLOC_STATIC);
__ZTI16z80ctc_interface=allocate(8, "*", ALLOC_STATIC);
__ZTI13z80ctc_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 91138, 0, 0, 0, 0, 0, 0, 0, 94210, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str126148=allocate([115,114,99,47,101,109,117,47,100,101,118,105,110,116,114,102,46,104,0] /* src/emu/devintrf.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI13z80ctc_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7828, 0, 0, 0, 7830, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI13z80ctc_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,51,122,56,48,99,116,99,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI13z80ctc_deviceE=allocate(12, "*", ALLOC_STATIC);
__ZN25devcb_resolved_write_line6s_nullE=allocate(1, "i8", ALLOC_STATIC);
__ZN20devcb_resolved_read86s_nullE=allocate(1, "i8", ALLOC_STATIC);
__ZN21devcb_resolved_write86s_nullE=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str6157=allocate([85,110,97,98,108,101,32,116,111,32,102,105,110,100,32,105,110,112,117,116,32,112,111,114,116,32,39,37,115,39,32,40,114,101,113,117,101,115,116,101,100,32,98,121,32,37,115,32,39,37,115,39,41,0] /* Unable to find input */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL17DEVICE_SELF_OWNER6158=allocate([94,0] /* ^\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16159=allocate([85,110,97,98,108,101,32,116,111,32,114,101,115,111,108,118,101,32,100,101,118,105,99,101,32,39,37,115,39,32,40,114,101,113,117,101,115,116,101,100,32,98,121,32,99,97,108,108,98,97,99,107,32,116,111,32,37,115,32,39,37,115,39,41,0] /* Unable to resolve de */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26160=allocate([85,110,97,98,108,101,32,116,111,32,114,101,115,111,108,118,101,32,100,101,118,105,99,101,32,39,37,115,39,32,40,114,101,113,117,101,115,116,101,100,32,98,121,32,37,115,32,39,37,115,39,41,0] /* Unable to resolve de */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36161=allocate([68,101,118,105,99,101,32,39,37,115,39,32,40,114,101,113,117,101,115,116,101,100,32,98,121,32,37,115,32,39,37,115,39,41,32,104,97,115,32,110,111,32,101,120,101,99,117,116,101,32,105,110,116,101,114,102,97,99,101,0] /* Device '%s' (request */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46162=allocate([68,101,118,105,99,101,32,39,37,115,39,32,40,114,101,113,117,101,115,116,101,100,32,98,121,32,37,115,32,39,37,115,39,41,32,104,97,115,32,110,111,32,109,101,109,111,114,121,32,105,110,116,101,114,102,97,99,101,0] /* Device '%s' (request */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56163=allocate([85,110,97,98,108,101,32,116,111,32,102,105,110,100,32,100,101,118,105,99,101,32,39,37,115,39,32,115,112,97,99,101,32,37,100,32,40,114,101,113,117,101,115,116,101,100,32,98,121,32,37,115,32,39,37,115,39,41,0] /* Unable to find devic */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66164=allocate([40,110,117,108,108,41,0] /* (null)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76165=allocate([99,111,110,115,116,97,110,116,0] /* constant\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS21devcb_resolved_write8=allocate([50,49,100,101,118,99,98,95,114,101,115,111,108,118,101,100,95,119,114,105,116,101,56,0] /* 21devcb_resolved_wri */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS8delegateIFvjhEE=allocate([56,100,101,108,101,103,97,116,101,73,70,118,106,104,69,69,0] /* 8delegateIFvjhEE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13delegate_baseIvjh8_noparamS0_E=allocate([49,51,100,101,108,101,103,97,116,101,95,98,97,115,101,73,118,106,104,56,95,110,111,112,97,114,97,109,83,48,95,69,0] /* 13delegate_baseIvjh8 */, "i8", ALLOC_STATIC);
__ZTI13delegate_baseIvjh8_noparamS0_E=allocate(8, "*", ALLOC_STATIC);
__ZTI8delegateIFvjhEE=allocate(12, "*", ALLOC_STATIC);
__ZTI21devcb_resolved_write8=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS20devcb_resolved_read8=allocate([50,48,100,101,118,99,98,95,114,101,115,111,108,118,101,100,95,114,101,97,100,56,0] /* 20devcb_resolved_rea */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS8delegateIFhjEE=allocate([56,100,101,108,101,103,97,116,101,73,70,104,106,69,69,0] /* 8delegateIFhjEE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13delegate_baseIhj8_noparamS0_S0_E=allocate([49,51,100,101,108,101,103,97,116,101,95,98,97,115,101,73,104,106,56,95,110,111,112,97,114,97,109,83,48,95,83,48,95,69,0] /* 13delegate_baseIhj8_ */, "i8", ALLOC_STATIC);
__ZTI13delegate_baseIhj8_noparamS0_S0_E=allocate(8, "*", ALLOC_STATIC);
__ZTI8delegateIFhjEE=allocate(12, "*", ALLOC_STATIC);
__ZTI20devcb_resolved_read8=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTS25devcb_resolved_write_line=allocate([50,53,100,101,118,99,98,95,114,101,115,111,108,118,101,100,95,119,114,105,116,101,95,108,105,110,101,0] /* 25devcb_resolved_wri */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS8delegateIFviEE=allocate([56,100,101,108,101,103,97,116,101,73,70,118,105,69,69,0] /* 8delegateIFviEE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13delegate_baseIvi8_noparamS0_S0_E=allocate([49,51,100,101,108,101,103,97,116,101,95,98,97,115,101,73,118,105,56,95,110,111,112,97,114,97,109,83,48,95,83,48,95,69,0] /* 13delegate_baseIvi8_ */, "i8", ALLOC_STATIC);
__ZTI13delegate_baseIvi8_noparamS0_S0_E=allocate(8, "*", ALLOC_STATIC);
__ZTI8delegateIFviEE=allocate(12, "*", ALLOC_STATIC);
__ZTI25devcb_resolved_write_line=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str6180=allocate([111,111,112,115,33,33,0] /* oops!!\00 */, "i8", ALLOC_STATIC);
__ZL11mnemonic_cb=allocate([51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0], ["i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL11mnemonic_ed=allocate([13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 53, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 33, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0], ["i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str16181=allocate([105,120,0] /* ix\00 */, "i8", ALLOC_STATIC);
__ZL14mnemonic_xx_cb=allocate([51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 0, 0], ["i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL11mnemonic_xx=allocate([13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0], ["i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str26182=allocate([105,121,0] /* iy\00 */, "i8", ALLOC_STATIC);
__ZL13mnemonic_main=allocate([36, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 57, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 61, 0, 0, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 0, 0], ["i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str36183=allocate([37,45,52,115,32,0] /* %-4s \00 */, "i8", ALLOC_STATIC);
__ZL10s_mnemonic=allocate(276, "*", ALLOC_STATIC);
STRING_TABLE.__str46184=allocate([36,37,48,50,120,44,36,37,48,50,120,0] /* $%02x,$%02x\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56185=allocate([36,37,48,52,88,0] /* $%04X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66186=allocate([36,37,48,50,88,0] /* $%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76187=allocate([40,37,115,37,99,36,37,48,50,120,41,0] /* (%s%c$%02x)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86188=allocate([37,115,0] /* %s\00 */, "i8", ALLOC_STATIC);
__ZL7s_flags=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1073741824, 0, 0, 0, 1073741824, 0, 0, 0, 1073741824, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str96189=allocate([97,100,99,0] /* adc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106190=allocate([97,100,100,0] /* add\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116191=allocate([97,110,100,0] /* and\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126192=allocate([98,105,116,0] /* bit\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136193=allocate([99,97,108,108,0] /* call\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146194=allocate([99,99,102,0] /* ccf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str156195=allocate([99,112,0] /* cp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166196=allocate([99,112,100,0] /* cpd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176197=allocate([99,112,100,114,0] /* cpdr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186198=allocate([99,112,105,0] /* cpi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str196199=allocate([99,112,105,114,0] /* cpir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str206200=allocate([99,112,108,0] /* cpl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str216201=allocate([100,97,97,0] /* daa\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str226202=allocate([100,98,0] /* db\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str236203=allocate([100,101,99,0] /* dec\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str246204=allocate([100,105,0] /* di\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str256205=allocate([100,106,110,122,0] /* djnz\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str266206=allocate([101,105,0] /* ei\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str276207=allocate([101,120,0] /* ex\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str286208=allocate([101,120,120,0] /* exx\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str296209=allocate([104,97,108,116,0] /* halt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str306210=allocate([105,109,0] /* im\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str316211=allocate([105,110,0] /* in\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str326212=allocate([105,110,99,0] /* inc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str336213=allocate([105,110,100,0] /* ind\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str346214=allocate([105,110,100,114,0] /* indr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str356215=allocate([105,110,105,0] /* ini\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str366216=allocate([105,110,105,114,0] /* inir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str376217=allocate([106,112,0] /* jp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str386218=allocate([106,114,0] /* jr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str396219=allocate([108,100,0] /* ld\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str406220=allocate([108,100,100,0] /* ldd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str416221=allocate([108,100,100,114,0] /* lddr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str426222=allocate([108,100,105,0] /* ldi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str436223=allocate([108,100,105,114,0] /* ldir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str446224=allocate([110,101,103,0] /* neg\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str456225=allocate([110,111,112,0] /* nop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str466226=allocate([111,114,0] /* or\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str476227=allocate([111,116,100,114,0] /* otdr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str486228=allocate([111,116,105,114,0] /* otir\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str496229=allocate([111,117,116,0] /* out\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str506230=allocate([111,117,116,100,0] /* outd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str516231=allocate([111,117,116,105,0] /* outi\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str526232=allocate([112,111,112,0] /* pop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str536233=allocate([112,117,115,104,0] /* push\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str546234=allocate([114,101,115,0] /* res\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str556235=allocate([114,101,116,0] /* ret\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str566236=allocate([114,101,116,105,0] /* reti\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str576237=allocate([114,101,116,110,0] /* retn\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str586238=allocate([114,108,0] /* rl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str596239=allocate([114,108,97,0] /* rla\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str606240=allocate([114,108,99,0] /* rlc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str616241=allocate([114,108,99,97,0] /* rlca\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str626242=allocate([114,108,100,0] /* rld\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str636243=allocate([114,114,0] /* rr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str646244=allocate([114,114,97,0] /* rra\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str656245=allocate([114,114,99,0] /* rrc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str666246=allocate([114,114,99,97,0] /* rrca\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str676247=allocate([114,114,100,0] /* rrd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str686248=allocate([114,115,116,0] /* rst\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str696249=allocate([115,98,99,0] /* sbc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str706250=allocate([115,99,102,0] /* scf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str716251=allocate([115,101,116,0] /* set\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str726252=allocate([115,108,97,0] /* sla\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str736253=allocate([115,108,108,0] /* sll\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str746254=allocate([115,114,97,0] /* sra\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str756255=allocate([115,114,108,0] /* srl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str766256=allocate([115,117,98,0] /* sub\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str776257=allocate([120,111,114,32,0] /* xor \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str786258=allocate([98,99,44,78,0] /* bc,N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str796259=allocate([40,98,99,41,44,97,0] /* (bc),a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str806260=allocate([98,99,0] /* bc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str816261=allocate([98,0] /* b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str826262=allocate([98,44,66,0] /* b,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str836263=allocate([97,102,44,97,102,39,0] /* af,af'\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str846264=allocate([104,108,44,98,99,0] /* hl,bc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str856265=allocate([97,44,40,98,99,41,0] /* a,(bc)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str866266=allocate([99,0] /* c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str876267=allocate([99,44,66,0] /* c,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str886268=allocate([79,0] /* O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str896269=allocate([100,101,44,78,0] /* de,N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str906270=allocate([40,100,101,41,44,97,0] /* (de),a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str916271=allocate([100,101,0] /* de\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str926272=allocate([100,0] /* d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str936273=allocate([100,44,66,0] /* d,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str946274=allocate([104,108,44,100,101,0] /* hl,de\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str956275=allocate([97,44,40,100,101,41,0] /* a,(de)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str966276=allocate([101,0] /* e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str976277=allocate([101,44,66,0] /* e,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str986278=allocate([110,122,44,79,0] /* nz,O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str996279=allocate([104,108,44,78,0] /* hl,N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1006280=allocate([40,87,41,44,104,108,0] /* (W),hl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1016281=allocate([104,108,0] /* hl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1026282=allocate([104,0] /* h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1036283=allocate([104,44,66,0] /* h,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1046284=allocate([122,44,79,0] /* z,O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1056285=allocate([104,108,44,104,108,0] /* hl,hl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1066286=allocate([104,108,44,40,87,41,0] /* hl,(W)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1076287=allocate([108,0] /* l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1086288=allocate([108,44,66,0] /* l,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1096289=allocate([110,99,44,79,0] /* nc,O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1106290=allocate([115,112,44,78,0] /* sp,N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1116291=allocate([40,87,41,44,97,0] /* (W),a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1126292=allocate([115,112,0] /* sp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1136293=allocate([40,104,108,41,0] /* (hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1146294=allocate([40,104,108,41,44,66,0] /* (hl),B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1156295=allocate([99,44,79,0] /* c,O\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1166296=allocate([104,108,44,115,112,0] /* hl,sp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1176297=allocate([97,44,40,87,41,0] /* a,(W)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1186298=allocate([97,0] /* a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1196299=allocate([97,44,66,0] /* a,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1206300=allocate([98,44,98,0] /* b,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1216301=allocate([98,44,99,0] /* b,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1226302=allocate([98,44,100,0] /* b,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1236303=allocate([98,44,101,0] /* b,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1246304=allocate([98,44,104,0] /* b,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1256305=allocate([98,44,108,0] /* b,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1266306=allocate([98,44,40,104,108,41,0] /* b,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1276307=allocate([98,44,97,0] /* b,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1286308=allocate([99,44,98,0] /* c,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1296309=allocate([99,44,99,0] /* c,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1306310=allocate([99,44,100,0] /* c,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1316311=allocate([99,44,101,0] /* c,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1326312=allocate([99,44,104,0] /* c,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1336313=allocate([99,44,108,0] /* c,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1346314=allocate([99,44,40,104,108,41,0] /* c,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1356315=allocate([99,44,97,0] /* c,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1366316=allocate([100,44,98,0] /* d,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1376317=allocate([100,44,99,0] /* d,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1386318=allocate([100,44,100,0] /* d,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1396319=allocate([100,44,101,0] /* d,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1406320=allocate([100,44,104,0] /* d,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1416321=allocate([100,44,108,0] /* d,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1426322=allocate([100,44,40,104,108,41,0] /* d,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1436323=allocate([100,44,97,0] /* d,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1446324=allocate([101,44,98,0] /* e,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1456325=allocate([101,44,99,0] /* e,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1466326=allocate([101,44,100,0] /* e,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1476327=allocate([101,44,101,0] /* e,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1486328=allocate([101,44,104,0] /* e,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1496329=allocate([101,44,108,0] /* e,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1506330=allocate([101,44,40,104,108,41,0] /* e,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1516331=allocate([101,44,97,0] /* e,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1526332=allocate([104,44,98,0] /* h,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1536333=allocate([104,44,99,0] /* h,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1546334=allocate([104,44,100,0] /* h,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1556335=allocate([104,44,101,0] /* h,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1566336=allocate([104,44,104,0] /* h,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1576337=allocate([104,44,108,0] /* h,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1586338=allocate([104,44,40,104,108,41,0] /* h,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1596339=allocate([104,44,97,0] /* h,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1606340=allocate([108,44,98,0] /* l,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1616341=allocate([108,44,99,0] /* l,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1626342=allocate([108,44,100,0] /* l,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1636343=allocate([108,44,101,0] /* l,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1646344=allocate([108,44,104,0] /* l,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1656345=allocate([108,44,108,0] /* l,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1666346=allocate([108,44,40,104,108,41,0] /* l,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1676347=allocate([108,44,97,0] /* l,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1686348=allocate([40,104,108,41,44,98,0] /* (hl),b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1696349=allocate([40,104,108,41,44,99,0] /* (hl),c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1706350=allocate([40,104,108,41,44,100,0] /* (hl),d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1716351=allocate([40,104,108,41,44,101,0] /* (hl),e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1726352=allocate([40,104,108,41,44,104,0] /* (hl),h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1736353=allocate([40,104,108,41,44,108,0] /* (hl),l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1746354=allocate([40,104,108,41,44,97,0] /* (hl),a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1756355=allocate([97,44,98,0] /* a,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1766356=allocate([97,44,99,0] /* a,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1776357=allocate([97,44,100,0] /* a,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1786358=allocate([97,44,101,0] /* a,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1796359=allocate([97,44,104,0] /* a,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1806360=allocate([97,44,108,0] /* a,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1816361=allocate([97,44,40,104,108,41,0] /* a,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1826362=allocate([97,44,97,0] /* a,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1836363=allocate([110,122,0] /* nz\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1846364=allocate([110,122,44,65,0] /* nz,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1856365=allocate([65,0] /* A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1866366=allocate([86,0] /* V\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1876367=allocate([122,0] /* z\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1886368=allocate([122,44,65,0] /* z,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1896369=allocate([99,98,0] /* cb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1906370=allocate([110,99,0] /* nc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1916371=allocate([110,99,44,65,0] /* nc,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1926372=allocate([40,80,41,44,97,0] /* (P),a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1936373=allocate([66,0] /* B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1946374=allocate([99,44,65,0] /* c,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1956375=allocate([97,44,40,80,41,0] /* a,(P)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1966376=allocate([100,100,0] /* dd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1976377=allocate([112,111,0] /* po\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1986378=allocate([112,111,44,65,0] /* po,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1996379=allocate([40,115,112,41,44,104,108,0] /* (sp),hl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2006380=allocate([112,101,0] /* pe\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2016381=allocate([112,101,44,65,0] /* pe,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2026382=allocate([100,101,44,104,108,0] /* de,hl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2036383=allocate([101,100,0] /* ed\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2046384=allocate([112,0] /* p\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2056385=allocate([97,102,0] /* af\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2066386=allocate([112,44,65,0] /* p,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2076387=allocate([109,0] /* m\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2086388=allocate([115,112,44,104,108,0] /* sp,hl\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2096389=allocate([109,44,65,0] /* m,A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2106390=allocate([102,100,0] /* fd\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2116391=allocate([63,0] /* ?\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2126392=allocate([73,44,98,99,0] /* I,bc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2136393=allocate([73,44,100,101,0] /* I,de\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2146394=allocate([73,44,78,0] /* I,N\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2156395=allocate([40,87,41,44,73,0] /* (W),I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2166396=allocate([73,0] /* I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2176397=allocate([73,104,0] /* Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2186398=allocate([73,104,44,66,0] /* Ih,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2196399=allocate([73,44,73,0] /* I,I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2206400=allocate([73,44,40,87,41,0] /* I,(W)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2216401=allocate([73,108,0] /* Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2226402=allocate([73,108,44,66,0] /* Il,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2236403=allocate([88,0] /* X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2246404=allocate([88,44,66,0] /* X,B\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2256405=allocate([73,44,115,112,0] /* I,sp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2266406=allocate([98,44,73,104,0] /* b,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2276407=allocate([98,44,73,108,0] /* b,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2286408=allocate([98,44,88,0] /* b,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2296409=allocate([99,44,73,104,0] /* c,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2306410=allocate([99,44,73,108,0] /* c,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2316411=allocate([99,44,88,0] /* c,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2326412=allocate([100,44,73,104,0] /* d,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2336413=allocate([100,44,73,108,0] /* d,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2346414=allocate([100,44,88,0] /* d,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2356415=allocate([101,44,73,104,0] /* e,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2366416=allocate([101,44,73,108,0] /* e,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2376417=allocate([101,44,88,0] /* e,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2386418=allocate([73,104,44,98,0] /* Ih,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2396419=allocate([73,104,44,99,0] /* Ih,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2406420=allocate([73,104,44,100,0] /* Ih,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2416421=allocate([73,104,44,101,0] /* Ih,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2426422=allocate([73,104,44,73,104,0] /* Ih,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2436423=allocate([73,104,44,73,108,0] /* Ih,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2446424=allocate([104,44,88,0] /* h,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2456425=allocate([73,104,44,97,0] /* Ih,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2466426=allocate([73,108,44,98,0] /* Il,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2476427=allocate([73,108,44,99,0] /* Il,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2486428=allocate([73,108,44,100,0] /* Il,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2496429=allocate([73,108,44,101,0] /* Il,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2506430=allocate([73,108,44,73,104,0] /* Il,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2516431=allocate([73,108,44,73,108,0] /* Il,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2526432=allocate([108,44,88,0] /* l,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2536433=allocate([73,108,44,97,0] /* Il,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2546434=allocate([88,44,98,0] /* X,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2556435=allocate([88,44,99,0] /* X,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2566436=allocate([88,44,100,0] /* X,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2576437=allocate([88,44,101,0] /* X,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2586438=allocate([88,44,104,0] /* X,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2596439=allocate([88,44,108,0] /* X,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2606440=allocate([88,44,97,0] /* X,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2616441=allocate([97,44,73,104,0] /* a,Ih\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2626442=allocate([97,44,73,108,0] /* a,Il\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2636443=allocate([97,44,88,0] /* a,X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2646444=allocate([40,115,112,41,44,73,0] /* (sp),I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2656445=allocate([40,73,41,0] /* (I)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2666446=allocate([115,112,44,73,0] /* sp,I\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2676447=allocate([98,61,89,0] /* b=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2686448=allocate([99,61,89,0] /* c=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2696449=allocate([100,61,89,0] /* d=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2706450=allocate([101,61,89,0] /* e=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2716451=allocate([104,61,89,0] /* h=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2726452=allocate([108,61,89,0] /* l=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2736453=allocate([89,0] /* Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2746454=allocate([97,61,89,0] /* a=Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2756455=allocate([98,61,48,44,89,0] /* b=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2766456=allocate([99,61,48,44,89,0] /* c=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2776457=allocate([100,61,48,44,89,0] /* d=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2786458=allocate([101,61,48,44,89,0] /* e=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2796459=allocate([104,61,48,44,89,0] /* h=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2806460=allocate([108,61,48,44,89,0] /* l=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2816461=allocate([48,44,89,0] /* 0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2826462=allocate([97,61,48,44,89,0] /* a=0,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2836463=allocate([98,61,49,44,89,0] /* b=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2846464=allocate([99,61,49,44,89,0] /* c=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2856465=allocate([100,61,49,44,89,0] /* d=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2866466=allocate([101,61,49,44,89,0] /* e=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2876467=allocate([104,61,49,44,89,0] /* h=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2886468=allocate([108,61,49,44,89,0] /* l=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2896469=allocate([49,44,89,0] /* 1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2906470=allocate([97,61,49,44,89,0] /* a=1,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2916471=allocate([98,61,50,44,89,0] /* b=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2926472=allocate([99,61,50,44,89,0] /* c=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2936473=allocate([100,61,50,44,89,0] /* d=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2946474=allocate([101,61,50,44,89,0] /* e=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2956475=allocate([104,61,50,44,89,0] /* h=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2966476=allocate([108,61,50,44,89,0] /* l=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2976477=allocate([50,44,89,0] /* 2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2986478=allocate([97,61,50,44,89,0] /* a=2,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2996479=allocate([98,61,51,44,89,0] /* b=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3006480=allocate([99,61,51,44,89,0] /* c=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3016481=allocate([100,61,51,44,89,0] /* d=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3026482=allocate([101,61,51,44,89,0] /* e=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3036483=allocate([104,61,51,44,89,0] /* h=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3046484=allocate([108,61,51,44,89,0] /* l=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3056485=allocate([51,44,89,0] /* 3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3066486=allocate([97,61,51,44,89,0] /* a=3,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3076487=allocate([98,61,52,44,89,0] /* b=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3086488=allocate([99,61,52,44,89,0] /* c=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3096489=allocate([100,61,52,44,89,0] /* d=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3106490=allocate([101,61,52,44,89,0] /* e=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3116491=allocate([104,61,52,44,89,0] /* h=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3126492=allocate([108,61,52,44,89,0] /* l=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3136493=allocate([52,44,89,0] /* 4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3146494=allocate([97,61,52,44,89,0] /* a=4,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3156495=allocate([98,61,53,44,89,0] /* b=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3166496=allocate([99,61,53,44,89,0] /* c=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3176497=allocate([100,61,53,44,89,0] /* d=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3186498=allocate([101,61,53,44,89,0] /* e=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3196499=allocate([104,61,53,44,89,0] /* h=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3206500=allocate([108,61,53,44,89,0] /* l=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3216501=allocate([53,44,89,0] /* 5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3226502=allocate([97,61,53,44,89,0] /* a=5,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3236503=allocate([98,61,54,44,89,0] /* b=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3246504=allocate([99,61,54,44,89,0] /* c=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3256505=allocate([100,61,54,44,89,0] /* d=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3266506=allocate([101,61,54,44,89,0] /* e=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3276507=allocate([104,61,54,44,89,0] /* h=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3286508=allocate([108,61,54,44,89,0] /* l=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3296509=allocate([54,44,89,0] /* 6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3306510=allocate([97,61,54,44,89,0] /* a=6,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3316511=allocate([98,61,55,44,89,0] /* b=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3326512=allocate([99,61,55,44,89,0] /* c=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3336513=allocate([100,61,55,44,89,0] /* d=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3346514=allocate([101,61,55,44,89,0] /* e=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3356515=allocate([104,61,55,44,89,0] /* h=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3366516=allocate([108,61,55,44,89,0] /* l=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3376517=allocate([55,44,89,0] /* 7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3386518=allocate([97,61,55,44,89,0] /* a=7,Y\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3396519=allocate([98,44,40,99,41,0] /* b,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3406520=allocate([40,99,41,44,98,0] /* (c),b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3416521=allocate([40,87,41,44,98,99,0] /* (W),bc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3426522=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3436523=allocate([105,44,97,0] /* i,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3446524=allocate([99,44,40,99,41,0] /* c,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3456525=allocate([40,99,41,44,99,0] /* (c),c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3466526=allocate([98,99,44,40,87,41,0] /* bc,(W)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3476527=allocate([42,0] /* _\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3486528=allocate([114,44,97,0] /* r,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3496529=allocate([100,44,40,99,41,0] /* d,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3506530=allocate([40,99,41,44,100,0] /* (c),d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3516531=allocate([40,87,41,44,100,101,0] /* (W),de\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3526532=allocate([49,0] /* 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3536533=allocate([97,44,105,0] /* a,i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3546534=allocate([101,44,40,99,41,0] /* e,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3556535=allocate([40,99,41,44,101,0] /* (c),e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3566536=allocate([100,101,44,40,87,41,0] /* de,(W)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3576537=allocate([50,0] /* 2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3586538=allocate([97,44,114,0] /* a,r\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3596539=allocate([104,44,40,99,41,0] /* h,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3606540=allocate([40,99,41,44,104,0] /* (c),h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3616541=allocate([108,44,40,99,41,0] /* l,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3626542=allocate([40,99,41,44,108,0] /* (c),l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3636543=allocate([48,44,40,99,41,0] /* 0,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3646544=allocate([40,99,41,44,48,0] /* (c),0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3656545=allocate([40,87,41,44,115,112,0] /* (W),sp\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3666546=allocate([97,44,40,99,41,0] /* a,(c)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3676547=allocate([40,99,41,44,97,0] /* (c),a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3686548=allocate([115,112,44,40,87,41,0] /* sp,(W)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3696549=allocate([48,44,98,0] /* 0,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3706550=allocate([48,44,99,0] /* 0,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3716551=allocate([48,44,100,0] /* 0,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3726552=allocate([48,44,101,0] /* 0,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3736553=allocate([48,44,104,0] /* 0,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3746554=allocate([48,44,108,0] /* 0,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3756555=allocate([48,44,40,104,108,41,0] /* 0,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3766556=allocate([48,44,97,0] /* 0,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3776557=allocate([49,44,98,0] /* 1,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3786558=allocate([49,44,99,0] /* 1,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3796559=allocate([49,44,100,0] /* 1,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3806560=allocate([49,44,101,0] /* 1,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3816561=allocate([49,44,104,0] /* 1,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3826562=allocate([49,44,108,0] /* 1,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3836563=allocate([49,44,40,104,108,41,0] /* 1,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3846564=allocate([49,44,97,0] /* 1,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3856565=allocate([50,44,98,0] /* 2,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3866566=allocate([50,44,99,0] /* 2,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3876567=allocate([50,44,100,0] /* 2,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3886568=allocate([50,44,101,0] /* 2,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3896569=allocate([50,44,104,0] /* 2,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3906570=allocate([50,44,108,0] /* 2,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3916571=allocate([50,44,40,104,108,41,0] /* 2,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3926572=allocate([50,44,97,0] /* 2,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3936573=allocate([51,44,98,0] /* 3,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3946574=allocate([51,44,99,0] /* 3,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3956575=allocate([51,44,100,0] /* 3,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3966576=allocate([51,44,101,0] /* 3,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3976577=allocate([51,44,104,0] /* 3,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3986578=allocate([51,44,108,0] /* 3,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str3996579=allocate([51,44,40,104,108,41,0] /* 3,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4006580=allocate([51,44,97,0] /* 3,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4016581=allocate([52,44,98,0] /* 4,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4026582=allocate([52,44,99,0] /* 4,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4036583=allocate([52,44,100,0] /* 4,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4046584=allocate([52,44,101,0] /* 4,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4056585=allocate([52,44,104,0] /* 4,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4066586=allocate([52,44,108,0] /* 4,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4076587=allocate([52,44,40,104,108,41,0] /* 4,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4086588=allocate([52,44,97,0] /* 4,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4096589=allocate([53,44,98,0] /* 5,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4106590=allocate([53,44,99,0] /* 5,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4116591=allocate([53,44,100,0] /* 5,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4126592=allocate([53,44,101,0] /* 5,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4136593=allocate([53,44,104,0] /* 5,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4146594=allocate([53,44,108,0] /* 5,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4156595=allocate([53,44,40,104,108,41,0] /* 5,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4166596=allocate([53,44,97,0] /* 5,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4176597=allocate([54,44,98,0] /* 6,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4186598=allocate([54,44,99,0] /* 6,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4196599=allocate([54,44,100,0] /* 6,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4206600=allocate([54,44,101,0] /* 6,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4216601=allocate([54,44,104,0] /* 6,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4226602=allocate([54,44,108,0] /* 6,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4236603=allocate([54,44,40,104,108,41,0] /* 6,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4246604=allocate([54,44,97,0] /* 6,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4256605=allocate([55,44,98,0] /* 7,b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4266606=allocate([55,44,99,0] /* 7,c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4276607=allocate([55,44,100,0] /* 7,d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4286608=allocate([55,44,101,0] /* 7,e\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4296609=allocate([55,44,104,0] /* 7,h\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4306610=allocate([55,44,108,0] /* 7,l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4316611=allocate([55,44,40,104,108,41,0] /* 7,(hl)\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str4326612=allocate([55,44,97,0] /* 7,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6615=allocate([110,111,112,0] /* nop\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16616=allocate([111,117,116,32,32,98,117,115,44,97,0] /* out  bus,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26617=allocate([111,117,116,32,32,100,98,98,44,97,0] /* out  dbb,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36618=allocate([97,100,100,32,32,97,44,35,36,37,48,50,88,0] /* add  a,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46619=allocate([106,109,112,32,32,36,48,37,48,50,88,0] /* jmp  $0%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56620=allocate([101,110,32,32,32,105,0] /* en   i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66621=allocate([100,101,99,32,32,97,0] /* dec  a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str76622=allocate([105,110,32,32,32,97,44,98,117,115,0] /* in   a,bus\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86623=allocate([105,108,108,101,103,97,108,0] /* illegal\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str96624=allocate([105,110,32,32,32,97,44,112,49,0] /* in   a,p1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106625=allocate([105,110,32,32,32,97,44,112,50,0] /* in   a,p2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116626=allocate([109,111,118,100,32,97,44,112,52,0] /* movd a,p4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126627=allocate([109,111,118,100,32,97,44,112,53,0] /* movd a,p5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136628=allocate([109,111,118,100,32,97,44,112,54,0] /* movd a,p6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146629=allocate([109,111,118,100,32,97,44,112,55,0] /* movd a,p7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str156630=allocate([105,110,99,32,32,64,114,48,0] /* inc  @r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166631=allocate([105,110,99,32,32,64,114,49,0] /* inc  @r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176632=allocate([106,98,48,32,32,36,37,48,51,88,0] /* jb0  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186633=allocate([97,100,100,99,32,97,44,35,36,37,48,50,88,0] /* addc a,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str196634=allocate([99,97,108,108,32,36,48,37,48,50,88,0] /* call $0%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str206635=allocate([100,105,115,32,32,105,0] /* dis  i\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str216636=allocate([106,116,102,32,32,36,37,48,51,88,0] /* jtf  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str226637=allocate([105,110,99,32,32,97,0] /* inc  a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str236638=allocate([105,110,99,32,32,114,48,0] /* inc  r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str246639=allocate([105,110,99,32,32,114,49,0] /* inc  r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str256640=allocate([105,110,99,32,32,114,50,0] /* inc  r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str266641=allocate([105,110,99,32,32,114,51,0] /* inc  r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str276642=allocate([105,110,99,32,32,114,52,0] /* inc  r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str286643=allocate([105,110,99,32,32,114,53,0] /* inc  r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str296644=allocate([105,110,99,32,32,114,54,0] /* inc  r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str306645=allocate([105,110,99,32,32,114,55,0] /* inc  r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str316646=allocate([120,99,104,32,32,97,44,64,114,48,0] /* xch  a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str326647=allocate([120,99,104,32,32,97,44,64,114,49,0] /* xch  a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str336648=allocate([105,110,32,32,32,97,44,100,98,98,0] /* in   a,dbb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str346649=allocate([109,111,118,32,32,97,44,35,36,37,48,50,88,0] /* mov  a,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str356650=allocate([106,109,112,32,32,36,49,37,48,50,88,0] /* jmp  $1%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str366651=allocate([101,110,32,32,32,116,99,110,116,105,0] /* en   tcnti\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str376652=allocate([106,110,116,48,32,36,37,48,51,88,0] /* jnt0 $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str386653=allocate([99,108,114,32,32,97,0] /* clr  a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str396654=allocate([120,99,104,32,32,97,44,114,48,0] /* xch  a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str406655=allocate([120,99,104,32,32,97,44,114,49,0] /* xch  a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str416656=allocate([120,99,104,32,32,97,44,114,50,0] /* xch  a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str426657=allocate([120,99,104,32,32,97,44,114,51,0] /* xch  a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str436658=allocate([120,99,104,32,32,97,44,114,52,0] /* xch  a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str446659=allocate([120,99,104,32,32,97,44,114,53,0] /* xch  a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str456660=allocate([120,99,104,32,32,97,44,114,54,0] /* xch  a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str466661=allocate([120,99,104,32,32,97,44,114,55,0] /* xch  a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str476662=allocate([120,99,104,100,32,97,44,64,114,48,0] /* xchd a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str486663=allocate([120,99,104,100,32,97,44,64,114,49,0] /* xchd a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str496664=allocate([106,98,49,32,32,36,37,48,51,88,0] /* jb1  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str506665=allocate([99,97,108,108,32,36,49,37,48,50,88,0] /* call $1%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str516666=allocate([100,105,115,32,32,116,99,110,116,105,0] /* dis  tcnti\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str526667=allocate([106,116,48,32,32,36,37,48,51,88,0] /* jt0  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str536668=allocate([99,112,108,32,32,97,0] /* cpl  a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str546669=allocate([111,117,116,108,32,112,49,44,97,0] /* outl p1,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str556670=allocate([111,117,116,108,32,112,50,44,97,0] /* outl p2,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str566671=allocate([109,111,118,100,32,112,52,44,97,0] /* movd p4,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str576672=allocate([109,111,118,100,32,112,53,44,97,0] /* movd p5,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str586673=allocate([109,111,118,100,32,112,54,44,97,0] /* movd p6,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str596674=allocate([109,111,118,100,32,112,55,44,97,0] /* movd p7,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str606675=allocate([111,114,108,32,32,97,44,64,114,48,0] /* orl  a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str616676=allocate([111,114,108,32,32,97,44,64,114,49,0] /* orl  a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str626677=allocate([109,111,118,32,32,97,44,116,0] /* mov  a,t\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str636678=allocate([111,114,108,32,32,97,44,35,36,37,48,50,88,0] /* orl  a,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str646679=allocate([106,109,112,32,32,36,50,37,48,50,88,0] /* jmp  $2%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str656680=allocate([115,116,114,116,32,99,110,116,0] /* strt cnt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str666681=allocate([106,110,116,49,32,36,37,48,51,88,0] /* jnt1 $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str676682=allocate([115,119,97,112,32,97,0] /* swap a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str686683=allocate([111,114,108,32,32,97,44,114,48,0] /* orl  a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str696684=allocate([111,114,108,32,32,97,44,114,49,0] /* orl  a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str706685=allocate([111,114,108,32,32,97,44,114,50,0] /* orl  a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str716686=allocate([111,114,108,32,32,97,44,114,51,0] /* orl  a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str726687=allocate([111,114,108,32,32,97,44,114,52,0] /* orl  a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str736688=allocate([111,114,108,32,32,97,44,114,53,0] /* orl  a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str746689=allocate([111,114,108,32,32,97,44,114,54,0] /* orl  a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str756690=allocate([111,114,108,32,32,97,44,114,55,0] /* orl  a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str766691=allocate([97,110,108,32,32,97,44,64,114,48,0] /* anl  a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str776692=allocate([97,110,108,32,32,97,44,64,114,49,0] /* anl  a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str786693=allocate([106,98,50,32,32,36,37,48,51,88,0] /* jb2  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str796694=allocate([97,110,108,32,32,97,44,35,36,37,48,50,88,0] /* anl  a,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str806695=allocate([99,97,108,108,32,36,50,37,48,50,88,0] /* call $2%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str816696=allocate([115,116,114,116,32,116,0] /* strt t\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str826697=allocate([106,116,49,32,32,36,37,48,51,88,0] /* jt1  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str836698=allocate([100,97,32,32,32,97,0] /* da   a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str846699=allocate([97,110,108,32,32,97,44,114,48,0] /* anl  a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str856700=allocate([97,110,108,32,32,97,44,114,49,0] /* anl  a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str866701=allocate([97,110,108,32,32,97,44,114,50,0] /* anl  a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str876702=allocate([97,110,108,32,32,97,44,114,51,0] /* anl  a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str886703=allocate([97,110,108,32,32,97,44,114,52,0] /* anl  a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str896704=allocate([97,110,108,32,32,97,44,114,53,0] /* anl  a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str906705=allocate([97,110,108,32,32,97,44,114,54,0] /* anl  a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str916706=allocate([97,110,108,32,32,97,44,114,55,0] /* anl  a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str926707=allocate([97,100,100,32,32,97,44,64,114,48,0] /* add  a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str936708=allocate([97,100,100,32,32,97,44,64,114,49,0] /* add  a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str946709=allocate([109,111,118,32,32,116,44,97,0] /* mov  t,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str956710=allocate([106,109,112,32,32,36,51,37,48,50,88,0] /* jmp  $3%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str966711=allocate([115,116,111,112,32,116,99,110,116,0] /* stop tcnt\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str976712=allocate([114,114,99,32,32,97,0] /* rrc  a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str986713=allocate([97,100,100,32,32,97,44,114,48,0] /* add  a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str996714=allocate([97,100,100,32,32,97,44,114,49,0] /* add  a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1006715=allocate([97,100,100,32,32,97,44,114,50,0] /* add  a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1016716=allocate([97,100,100,32,32,97,44,114,51,0] /* add  a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1026717=allocate([97,100,100,32,32,97,44,114,52,0] /* add  a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1036718=allocate([97,100,100,32,32,97,44,114,53,0] /* add  a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1046719=allocate([97,100,100,32,32,97,44,114,54,0] /* add  a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1056720=allocate([97,100,100,32,32,97,44,114,55,0] /* add  a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1066721=allocate([97,100,100,99,32,97,44,64,114,48,0] /* addc a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1076722=allocate([97,100,100,99,32,97,44,64,114,49,0] /* addc a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1086723=allocate([106,98,51,32,32,36,37,48,51,88,0] /* jb3  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1096724=allocate([99,97,108,108,32,36,51,37,48,50,88,0] /* call $3%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1106725=allocate([101,110,116,48,32,99,108,107,0] /* ent0 clk\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1116726=allocate([106,102,49,32,32,36,37,48,51,88,0] /* jf1  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1126727=allocate([114,114,32,32,32,97,0] /* rr   a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1136728=allocate([97,100,100,99,32,97,44,114,48,0] /* addc a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1146729=allocate([97,100,100,99,32,97,44,114,49,0] /* addc a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1156730=allocate([97,100,100,99,32,97,44,114,50,0] /* addc a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1166731=allocate([97,100,100,99,32,97,44,114,51,0] /* addc a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1176732=allocate([97,100,100,99,32,97,44,114,52,0] /* addc a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1186733=allocate([97,100,100,99,32,97,44,114,53,0] /* addc a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1196734=allocate([97,100,100,99,32,97,44,114,54,0] /* addc a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1206735=allocate([97,100,100,99,32,97,44,114,55,0] /* addc a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1216736=allocate([109,111,118,120,32,97,44,64,114,48,0] /* movx a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1226737=allocate([109,111,118,120,32,97,44,64,114,49,0] /* movx a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1236738=allocate([114,101,116,0] /* ret\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1246739=allocate([106,109,112,32,32,36,52,37,48,50,88,0] /* jmp  $4%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1256740=allocate([99,108,114,32,32,102,48,0] /* clr  f0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1266741=allocate([106,110,105,32,32,36,37,48,51,88,0] /* jni  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1276742=allocate([106,111,98,102,32,36,37,48,51,88,0] /* jobf $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1286743=allocate([111,114,108,32,32,98,117,115,44,35,36,37,48,50,88,0] /* orl  bus,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1296744=allocate([111,114,108,32,32,112,49,44,35,36,37,48,50,88,0] /* orl  p1,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1306745=allocate([111,114,108,32,32,112,50,44,35,36,37,48,50,88,0] /* orl  p2,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1316746=allocate([111,114,108,100,32,112,52,44,97,0] /* orld p4,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1326747=allocate([111,114,108,100,32,112,53,44,97,0] /* orld p5,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1336748=allocate([111,114,108,100,32,112,54,44,97,0] /* orld p6,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1346749=allocate([111,114,108,100,32,112,55,44,97,0] /* orld p7,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1356750=allocate([109,111,118,120,32,64,114,48,44,97,0] /* movx @r0,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1366751=allocate([109,111,118,32,32,115,116,115,44,97,0] /* mov  sts,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1376752=allocate([109,111,118,120,32,64,114,49,44,97,0] /* movx @r1,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1386753=allocate([106,98,52,32,32,36,37,48,51,88,0] /* jb4  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1396754=allocate([114,101,116,114,0] /* retr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1406755=allocate([99,97,108,108,32,36,52,37,48,50,88,0] /* call $4%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1416756=allocate([99,112,108,32,32,102,48,0] /* cpl  f0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1426757=allocate([106,110,122,32,32,36,37,48,51,88,0] /* jnz  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1436758=allocate([99,108,114,32,32,99,0] /* clr  c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1446759=allocate([97,110,108,32,32,98,117,115,44,35,36,37,48,50,88,0] /* anl  bus,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1456760=allocate([97,110,108,32,32,112,49,44,35,36,37,48,50,88,0] /* anl  p1,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1466761=allocate([97,110,108,32,32,112,50,44,35,36,37,48,50,88,0] /* anl  p2,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1476762=allocate([97,110,108,100,32,112,52,44,97,0] /* anld p4,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1486763=allocate([97,110,108,100,32,112,53,44,97,0] /* anld p5,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1496764=allocate([97,110,108,100,32,112,54,44,97,0] /* anld p6,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1506765=allocate([97,110,108,100,32,112,55,44,97,0] /* anld p7,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1516766=allocate([109,111,118,32,32,64,114,48,44,97,0] /* mov  @r0,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1526767=allocate([109,111,118,32,32,64,114,49,44,97,0] /* mov  @r1,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1536768=allocate([109,111,118,112,32,97,44,64,97,0] /* movp a,@a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1546769=allocate([106,109,112,32,32,36,53,37,48,50,88,0] /* jmp  $5%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1556770=allocate([99,108,114,32,32,102,49,0] /* clr  f1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1566771=allocate([99,112,108,32,32,99,0] /* cpl  c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1576772=allocate([109,111,118,32,32,114,48,44,97,0] /* mov  r0,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1586773=allocate([109,111,118,32,32,114,49,44,97,0] /* mov  r1,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1596774=allocate([109,111,118,32,32,114,50,44,97,0] /* mov  r2,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1606775=allocate([109,111,118,32,32,114,51,44,97,0] /* mov  r3,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1616776=allocate([109,111,118,32,32,114,52,44,97,0] /* mov  r4,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1626777=allocate([109,111,118,32,32,114,53,44,97,0] /* mov  r5,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1636778=allocate([109,111,118,32,32,114,54,44,97,0] /* mov  r6,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1646779=allocate([109,111,118,32,32,114,55,44,97,0] /* mov  r7,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1656780=allocate([109,111,118,32,32,64,114,48,44,35,36,37,48,50,88,0] /* mov  @r0,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1666781=allocate([109,111,118,32,32,64,114,49,44,35,36,37,48,50,88,0] /* mov  @r1,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1676782=allocate([106,98,53,32,32,36,37,48,51,88,0] /* jb5  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1686783=allocate([106,109,112,112,32,64,97,0] /* jmpp @a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1696784=allocate([99,97,108,108,32,36,53,37,48,50,88,0] /* call $5%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1706785=allocate([99,112,108,32,32,102,49,0] /* cpl  f1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1716786=allocate([106,102,48,32,32,36,37,48,51,88,0] /* jf0  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1726787=allocate([109,111,118,32,32,114,48,44,35,36,37,48,50,88,0] /* mov  r0,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1736788=allocate([109,111,118,32,32,114,49,44,35,36,37,48,50,88,0] /* mov  r1,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1746789=allocate([109,111,118,32,32,114,50,44,35,36,37,48,50,88,0] /* mov  r2,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1756790=allocate([109,111,118,32,32,114,51,44,35,36,37,48,50,88,0] /* mov  r3,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1766791=allocate([109,111,118,32,32,114,52,44,35,36,37,48,50,88,0] /* mov  r4,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1776792=allocate([109,111,118,32,32,114,53,44,35,36,37,48,50,88,0] /* mov  r5,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1786793=allocate([109,111,118,32,32,114,54,44,35,36,37,48,50,88,0] /* mov  r6,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1796794=allocate([109,111,118,32,32,114,55,44,35,36,37,48,50,88,0] /* mov  r7,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1806795=allocate([106,109,112,32,32,36,54,37,48,50,88,0] /* jmp  $6%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1816796=allocate([115,101,108,32,32,114,98,48,0] /* sel  rb0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1826797=allocate([106,122,32,32,32,36,37,48,51,88,0] /* jz   $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1836798=allocate([109,111,118,32,32,97,44,112,115,119,0] /* mov  a,psw\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1846799=allocate([100,101,99,32,32,114,48,0] /* dec  r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1856800=allocate([100,101,99,32,32,114,49,0] /* dec  r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1866801=allocate([100,101,99,32,32,114,50,0] /* dec  r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1876802=allocate([100,101,99,32,32,114,51,0] /* dec  r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1886803=allocate([100,101,99,32,32,114,52,0] /* dec  r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1896804=allocate([100,101,99,32,32,114,53,0] /* dec  r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1906805=allocate([100,101,99,32,32,114,54,0] /* dec  r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1916806=allocate([100,101,99,32,32,114,55,0] /* dec  r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1926807=allocate([120,114,108,32,32,97,44,64,114,48,0] /* xrl  a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1936808=allocate([120,114,108,32,32,97,44,64,114,49,0] /* xrl  a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1946809=allocate([106,98,54,32,32,36,37,48,51,88,0] /* jb6  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1956810=allocate([120,114,108,32,32,97,44,35,36,37,48,50,88,0] /* xrl  a,#$%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1966811=allocate([99,97,108,108,32,36,54,37,48,50,88,0] /* call $6%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1976812=allocate([115,101,108,32,32,114,98,49,0] /* sel  rb1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1986813=allocate([106,110,105,98,102,32,36,37,48,51,88,0] /* jnibf $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1996814=allocate([109,111,118,32,32,112,115,119,44,97,0] /* mov  psw,a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2006815=allocate([120,114,108,32,32,97,44,114,48,0] /* xrl  a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2016816=allocate([120,114,108,32,32,97,44,114,49,0] /* xrl  a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2026817=allocate([120,114,108,32,32,97,44,114,50,0] /* xrl  a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2036818=allocate([120,114,108,32,32,97,44,114,51,0] /* xrl  a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2046819=allocate([120,114,108,32,32,97,44,114,52,0] /* xrl  a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2056820=allocate([120,114,108,32,32,97,44,114,53,0] /* xrl  a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2066821=allocate([120,114,108,32,32,97,44,114,54,0] /* xrl  a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2076822=allocate([120,114,108,32,32,97,44,114,55,0] /* xrl  a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2086823=allocate([109,111,118,112,51,32,97,44,64,97,0] /* movp3 a,@a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2096824=allocate([106,109,112,32,32,36,55,37,48,50,88,0] /* jmp  $7%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2106825=allocate([115,101,108,32,32,109,98,48,0] /* sel  mb0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2116826=allocate([101,110,32,32,32,100,109,97,0] /* en   dma\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2126827=allocate([106,110,99,32,32,36,37,48,51,88,0] /* jnc  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2136828=allocate([114,108,32,32,32,97,0] /* rl   a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2146829=allocate([100,106,110,122,32,114,48,44,36,37,48,51,88,0] /* djnz r0,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2156830=allocate([100,106,110,122,32,114,49,44,36,37,48,51,88,0] /* djnz r1,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2166831=allocate([100,106,110,122,32,114,50,44,36,37,48,51,88,0] /* djnz r2,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2176832=allocate([100,106,110,122,32,114,51,44,36,37,48,51,88,0] /* djnz r3,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2186833=allocate([100,106,110,122,32,114,52,44,36,37,48,51,88,0] /* djnz r4,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2196834=allocate([100,106,110,122,32,114,53,44,36,37,48,51,88,0] /* djnz r5,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2206835=allocate([100,106,110,122,32,114,54,44,36,37,48,51,88,0] /* djnz r6,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2216836=allocate([100,106,110,122,32,114,55,44,36,37,48,51,88,0] /* djnz r7,$%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2226837=allocate([109,111,118,32,32,97,44,64,114,48,0] /* mov  a,@r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2236838=allocate([109,111,118,32,32,97,44,64,114,49,0] /* mov  a,@r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2246839=allocate([106,98,55,32,32,36,37,48,51,88,0] /* jb7  $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2256840=allocate([99,97,108,108,32,36,55,37,48,50,88,0] /* call $7%02X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2266841=allocate([115,101,108,32,32,109,98,49,0] /* sel  mb1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2276842=allocate([101,110,32,32,32,102,108,97,103,115,0] /* en   flags\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2286843=allocate([106,99,32,32,32,36,37,48,51,88,0] /* jc   $%03X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2296844=allocate([114,108,99,32,32,97,0] /* rlc  a\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2306845=allocate([109,111,118,32,32,97,44,114,48,0] /* mov  a,r0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2316846=allocate([109,111,118,32,32,97,44,114,49,0] /* mov  a,r1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2326847=allocate([109,111,118,32,32,97,44,114,50,0] /* mov  a,r2\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2336848=allocate([109,111,118,32,32,97,44,114,51,0] /* mov  a,r3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2346849=allocate([109,111,118,32,32,97,44,114,52,0] /* mov  a,r4\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2356850=allocate([109,111,118,32,32,97,44,114,53,0] /* mov  a,r5\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2366851=allocate([109,111,118,32,32,97,44,114,54,0] /* mov  a,r6\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2376852=allocate([109,111,118,32,32,97,44,114,55,0] /* mov  a,r7\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6894=allocate([115,114,99,47,101,109,117,47,115,111,117,110,100,47,115,97,109,112,108,101,115,46,99,0] /* src/emu/sound/sample */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16895=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26896=allocate([83,97,109,112,108,101,115,0] /* Samples\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36897=allocate([66,105,103,32,72,97,99,107,0] /* Big Hack\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46898=allocate([49,46,49,0] /* 1.1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str56899=allocate([67,111,112,121,114,105,103,104,116,32,78,105,99,111,108,97,32,83,97,108,109,111,114,105,97,32,97,110,100,32,116,104,101,32,77,65,77,69,32,84,101,97,109,0] /* Copyright Nicola Sal */, "i8", ALLOC_STATIC);
__ZTV14samples_device=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7832, 0, 0, 0, 7834, 0, 0, 0, 5182, 0, 0, 0, 5184, 0, 0, 0, 5186, 0, 0, 0, 1732, 0, 0, 0, 5190, 0, 0, 0, 5192, 0, 0, 0, 5194, 0, 0, 0, 5196, 0, 0, 0, 1742, 0, 0, 0, 1744, 0, 0, 0, 1746, 0, 0, 0, 1748, 0, 0, 0, 1750, 0, 0, 0, 7092, 0, 0, 0, -368, 0, 0, 0, 0, 0, 0, 0, 7836, 0, 0, 0, 7838, 0, 0, 0, 1882, 0, 0, 0, 7098, 0, 0, 0, 7100, 0, 0, 0, 7102, 0, 0, 0, 7104, 0, 0, 0, 1936, 0, 0, 0, 1894, 0, 0, 0, 1896, 0, 0, 0, 1898, 0, 0, 0, 1900, 0, 0, 0, 1938, 0, 0, 0, 1904, 0, 0, 0, 7106, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
_SAMPLES=allocate([1458], ["%class.device_t.2113* (%class.machine_config.2104*, i8*, %class.device_t.2113*, i32)*",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTS14samples_device=allocate([49,52,115,97,109,112,108,101,115,95,100,101,118,105,99,101,0] /* 14samples_device\00 */, "i8", ALLOC_STATIC);
__ZTI14samples_device=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str66902=allocate([115,114,99,47,101,109,117,47,100,101,118,108,101,103,99,121,46,104,0] /* src/emu/devlegcy.h\0 */, "i8", ALLOC_STATIC);
__ZTV20resource_pool_objectI14samples_deviceE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7840, 0, 0, 0, 7842, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS20resource_pool_objectI14samples_deviceE=allocate([50,48,114,101,115,111,117,114,99,101,95,112,111,111,108,95,111,98,106,101,99,116,73,49,52,115,97,109,112,108,101,115,95,100,101,118,105,99,101,69,0] /* 20resource_pool_obje */, "i8", ALLOC_STATIC);
__ZTI20resource_pool_objectI14samples_deviceE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str76903=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,115,111,117,114,99,101,95,108,101,110,103,116,104,0] /* info->channel[i].sou */, "i8", ALLOC_STATIC);
STRING_TABLE.__str86904=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,115,111,117,114,99,101,95,110,117,109,0] /* info->channel[i].sou */, "i8", ALLOC_STATIC);
STRING_TABLE.__str96905=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,112,111,115,0] /* info->channel[i].pos */, "i8", ALLOC_STATIC);
STRING_TABLE.__str106906=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,102,114,97,99,0] /* info->channel[i].fra */, "i8", ALLOC_STATIC);
STRING_TABLE.__str116907=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,115,116,101,112,0] /* info->channel[i].ste */, "i8", ALLOC_STATIC);
STRING_TABLE.__str126908=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,108,111,111,112,0] /* info->channel[i].loo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str136909=allocate([105,110,102,111,45,62,99,104,97,110,110,101,108,91,105,93,46,112,97,117,115,101,100,0] /* info->channel[i].pau */, "i8", ALLOC_STATIC);
STRING_TABLE.__str146910=allocate([115,97,109,112,108,101,115,95,112,111,115,116,108,111,97,100,0] /* samples_postload\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS13_samples_info=allocate([49,51,95,115,97,109,112,108,101,115,95,105,110,102,111,0] /* 13_samples_info\00 */, "i8", ALLOC_STATIC);
__ZTI13_samples_info=allocate(8, "*", ALLOC_STATIC);
__ZTV19resource_pool_arrayI15_sample_channelE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7844, 0, 0, 0, 7846, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTS19resource_pool_arrayI15_sample_channelE=allocate([49,57,114,101,115,111,117,114,99,101,95,112,111,111,108,95,97,114,114,97,121,73,49,53,95,115,97,109,112,108,101,95,99,104,97,110,110,101,108,69,0] /* 19resource_pool_arra */, "i8", ALLOC_STATIC);
__ZTI19resource_pool_arrayI15_sample_channelE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str156911=allocate([82,73,70,70,0] /* RIFF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str166912=allocate([87,65,86,69,0] /* WAVE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str176913=allocate([102,109,116,32,0] /* fmt \00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str186914=allocate([100,97,116,97,0] /* data\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str206916=allocate([115,97,109,112,108,101,115,0] /* samples\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6918=allocate([137,80,78,71,13,10,26,10,0] /* \89PNG\0D\0A\1A\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16919=allocate([138,77,78,71,13,10,26,10,0] /* \8AMNG\0D\0A\1A\0A\0 */, "i8", ALLOC_STATIC);
__ZL7samples=allocate([1, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str26920=allocate([49,46,50,46,51,0] /* 1.2.3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6995=allocate([115,117,99,99,101,115,115,0] /* success\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str16996=allocate([104,105,116,32,101,110,100,32,111,102,32,102,105,108,101,0] /* hit end of file\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str26997=allocate([105,110,118,97,108,105,100,32,100,97,116,97,0] /* invalid data\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str36998=allocate([111,117,116,32,111,102,32,109,101,109,111,114,121,0] /* out of memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str46999=allocate([114,101,97,100,32,101,114,114,111,114,0] /* read error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57000=allocate([119,114,105,116,101,32,101,114,114,111,114,0] /* write error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67001=allocate([115,116,97,99,107,32,111,118,101,114,102,108,111,119,0] /* stack overflow\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77002=allocate([117,110,115,117,112,112,111,114,116,101,100,32,102,101,97,116,117,114,101,0] /* unsupported feature\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87003=allocate([117,110,97,98,108,101,32,116,111,32,111,112,101,110,32,102,105,108,101,0] /* unable to open file\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97004=allocate([102,111,117,110,100,32,105,110,99,111,109,112,97,116,105,98,108,101,32,97,117,100,105,111,32,115,116,114,101,97,109,115,0] /* found incompatible a */, "i8", ALLOC_STATIC);
STRING_TABLE.__str107005=allocate([102,111,117,110,100,32,105,110,118,97,108,105,100,32,115,97,109,112,108,101,32,114,97,116,101,0] /* found invalid sample */, "i8", ALLOC_STATIC);
STRING_TABLE.__str117006=allocate([105,110,118,97,108,105,100,32,115,116,114,101,97,109,0] /* invalid stream\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127007=allocate([105,110,118,97,108,105,100,32,102,114,97,109,101,32,105,110,100,101,120,0] /* invalid frame index\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137008=allocate([105,110,118,97,108,105,100,32,98,105,116,109,97,112,0] /* invalid bitmap\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147009=allocate([117,110,115,117,112,112,111,114,116,101,100,32,118,105,100,101,111,32,102,111,114,109,97,116,0] /* unsupported video fo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157010=allocate([117,110,115,117,112,112,111,114,116,101,100,32,97,117,100,105,111,32,102,111,114,109,97,116,0] /* unsupported audio fo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str167011=allocate([115,111,117,110,100,32,98,117,102,102,101,114,32,111,118,101,114,102,108,111,119,0] /* sound buffer overflo */, "i8", ALLOC_STATIC);
STRING_TABLE.__str177012=allocate([117,110,100,111,99,117,109,101,110,116,101,100,32,101,114,114,111,114,0] /* undocumented error\0 */, "i8", ALLOC_STATIC);
__str7032=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str17033=allocate([46,0] /* .\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27034=allocate([46,46,0] /* ..\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37035=allocate([47,0] /* /\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47036=allocate([46,122,105,112,0] /* .zip\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7054=allocate([49,46,50,46,51,0] /* 1.2.3\00 */, "i8", ALLOC_STATIC);
__ZL9zip_cache=allocate(32, "*", ALLOC_STATIC);
STRING_TABLE.__str7095=allocate([49,46,50,46,51,0] /* 1.2.3\00 */, "i8", ALLOC_STATIC);
__ZL13dummy_astring=allocate(64, ["*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8"], ALLOC_STATIC);
STRING_TABLE.__str7180=allocate([42,0] /* _\00 */, "i8", ALLOC_STATIC);
__ZZ19core_i64_hex_formatyhE6buffer=allocate(1024, "i8", ALLOC_STATIC);
__ZZ19core_i64_hex_formatyhE5index=allocate(1, "i32", ALLOC_STATIC);
STRING_TABLE.__str17181=allocate([48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0] /* 0123456789ABCDEF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7203=allocate([77,101,109,111,114,121,0] /* Memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17204=allocate([69,114,114,111,114,32,97,100,100,105,110,103,32,110,101,119,32,116,121,112,101,32,37,115,10,0] /* Error adding new typ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27205=allocate([112,111,111,108,95,111,98,106,101,99,116,95,97,100,100,32,40,118,105,97,32,37,115,58,37,100,41,58,32,65,116,116,101,109,112,116,101,100,32,116,111,32,97,100,100,32,111,98,106,101,99,116,32,111,102,32,117,110,107,110,111,119,110,32,116,121,112,101,32,119,105,116,104,32,115,105,122,101,32,37,100,0] /* pool_object_add (via */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37206=allocate([112,111,111,108,95,111,98,106,101,99,116,95,97,100,100,32,40,118,105,97,32,37,115,58,37,100,41,58,32,65,116,116,101,109,112,116,101,100,32,116,111,32,97,100,100,32,97,32,78,85,76,76,32,111,98,106,101,99,116,32,111,102,32,115,105,122,101,32,37,100,0] /* pool_object_add (via */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7219=allocate([60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0] /* <?xml version=\221.0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17220=allocate([60,33,45,45,32,84,104,105,115,32,102,105,108,101,32,105,115,32,97,117,116,111,103,101,110,101,114,97,116,101,100,59,32,99,111,109,109,101,110,116,115,32,97,110,100,32,117,110,107,110,111,119,110,32,116,97,103,115,32,119,105,108,108,32,98,101,32,115,116,114,105,112,112,101,100,32,45,45,62,10,0] /* <!-- This file is au */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27221=allocate([37,88,0] /* %X\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37222=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47223=allocate([37,102,0] /* %f\00 */, "i8", ALLOC_STATIC);
__ZZ20xml_normalize_stringPKcE6buffer=allocate(1024, "i8", ALLOC_STATIC);
STRING_TABLE.__str57224=allocate([38,113,117,111,116,59,0] /* &quot;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67225=allocate([38,97,109,112,59,0] /* &amp;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77226=allocate([38,108,116,59,0] /* &lt;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87227=allocate([38,103,116,59,0] /* &gt;\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97228=allocate([37,42,115,60,37,115,0] /* %_s<%s\00 */, "i8", ALLOC_STATIC);
__str107229=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str117230=allocate([32,37,115,61,34,37,115,34,0] /*  %s=\22%s\22\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127231=allocate([32,47,62,10,0] /*  />\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137232=allocate([62,10,0] /* >\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147233=allocate([37,42,115,37,115,10,0] /* %_s%s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157234=allocate([37,42,115,60,47,37,115,62,10,0] /* %_s</%s>\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7272=allocate([60,85,78,65,68,79,82,78,69,68,48,62,0] /* <UNADORNED0>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17273=allocate([60,85,78,65,68,79,82,78,69,68,49,62,0] /* <UNADORNED1>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27274=allocate([60,85,78,65,68,79,82,78,69,68,50,62,0] /* <UNADORNED2>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37275=allocate([60,85,78,65,68,79,82,78,69,68,51,62,0] /* <UNADORNED3>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47276=allocate([60,85,78,65,68,79,82,78,69,68,52,62,0] /* <UNADORNED4>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57277=allocate([60,85,78,65,68,79,82,78,69,68,53,62,0] /* <UNADORNED5>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67278=allocate([60,85,78,65,68,79,82,78,69,68,54,62,0] /* <UNADORNED6>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77279=allocate([60,85,78,65,68,79,82,78,69,68,55,62,0] /* <UNADORNED7>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87280=allocate([60,85,78,65,68,79,82,78,69,68,56,62,0] /* <UNADORNED8>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97281=allocate([60,85,78,65,68,79,82,78,69,68,57,62,0] /* <UNADORNED9>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str107282=allocate([60,85,78,65,68,79,82,78,69,68,49,48,62,0] /* <UNADORNED10>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str117283=allocate([60,85,78,65,68,79,82,78,69,68,49,49,62,0] /* <UNADORNED11>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127284=allocate([60,85,78,65,68,79,82,78,69,68,49,50,62,0] /* <UNADORNED12>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137285=allocate([60,85,78,65,68,79,82,78,69,68,49,51,62,0] /* <UNADORNED13>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147286=allocate([60,85,78,65,68,79,82,78,69,68,49,52,62,0] /* <UNADORNED14>\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157287=allocate([60,85,78,65,68,79,82,78,69,68,49,53,62,0] /* <UNADORNED15>\00 */, "i8", ALLOC_STATIC);
__ZN12core_options18s_option_unadornedE=allocate(64, "*", ALLOC_STATIC);
__ZTV12core_options=allocate([0, 0, 0, 0, 0, 0, 0, 0, 7848, 0, 0, 0, 7850, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str167290=allocate([69,114,114,111,114,58,32,117,110,107,110,111,119,110,32,111,112,116,105,111,110,58,32,37,115,10,0] /* Error: unknown optio */, "i8", ALLOC_STATIC);
STRING_TABLE.__str177291=allocate([69,114,114,111,114,58,32,109,117,108,116,105,112,108,101,32,99,111,109,109,97,110,100,115,32,115,112,101,99,105,102,105,101,100,32,45,37,115,32,97,110,100,32,37,115,10,0] /* Error: multiple comm */, "i8", ALLOC_STATIC);
STRING_TABLE.__str187292=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str197293=allocate([48,0] /* 0\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str207294=allocate([49,0] /* 1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str217295=allocate([69,114,114,111,114,58,32,111,112,116,105,111,110,32,37,115,32,101,120,112,101,99,116,101,100,32,97,32,112,97,114,97,109,101,116,101,114,10,0] /* Error: option %s exp */, "i8", ALLOC_STATIC);
STRING_TABLE.__str227296=allocate([87,97,114,110,105,110,103,58,32,105,110,118,97,108,105,100,32,108,105,110,101,32,105,110,32,73,78,73,58,32,37,115,0] /* Warning: invalid lin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str237297=allocate([87,97,114,110,105,110,103,58,32,117,110,107,110,111,119,110,32,111,112,116,105,111,110,32,105,110,32,73,78,73,58,32,37,115,10,0] /* Warning: unknown opt */, "i8", ALLOC_STATIC);
STRING_TABLE.__str247298=allocate([10,35,10,35,32,37,115,10,35,10,0] /* \0A#\0A# %s\0A#\0A\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str257299=allocate([37,45,50,53,115,32,34,37,115,34,10,0] /* %-25s \22%s\22\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str267300=allocate([37,45,50,53,115,32,37,115,10,0] /* %-25s %s\0A\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str277301=allocate([45,37,45,50,48,115,37,115,10,0] /* -%-20s%s\0A\00 */, "i8", ALLOC_STATIC);
__str287302=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str297303=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,115,101,116,32,117,110,107,110,111,119,110,32,111,112,116,105,111,110,32,37,115,10,0] /* Attempted to set unk */, "i8", ALLOC_STATIC);
STRING_TABLE.__str307304=allocate([37,100,0] /* %d\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str317305=allocate([37,102,0] /* %f\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str327306=allocate([73,108,108,101,103,97,108,32,98,111,111,108,101,97,110,32,118,97,108,117,101,32,102,111,114,32,37,115,58,32,34,37,115,34,59,32,114,101,118,101,114,116,105,110,103,32,116,111,32,37,115,10,0] /* Illegal boolean valu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str337307=allocate([73,108,108,101,103,97,108,32,105,110,116,101,103,101,114,32,118,97,108,117,101,32,102,111,114,32,37,115,58,32,34,37,115,34,59,32,114,101,118,101,114,116,105,110,103,32,116,111,32,37,115,10,0] /* Illegal integer valu */, "i8", ALLOC_STATIC);
STRING_TABLE.__str347308=allocate([79,117,116,45,111,102,45,114,97,110,103,101,32,105,110,116,101,103,101,114,32,118,97,108,117,101,32,102,111,114,32,37,115,58,32,34,37,115,34,32,40,109,117,115,116,32,98,101,32,98,101,116,119,101,101,110,32,37,115,32,97,110,100,32,37,115,41,59,32,114,101,118,101,114,116,105,110,103,32,116,111,32,37,115,10,0] /* Out-of-range integer */, "i8", ALLOC_STATIC);
STRING_TABLE.__str357309=allocate([73,108,108,101,103,97,108,32,102,108,111,97,116,32,118,97,108,117,101,32,102,111,114,32,37,115,58,32,34,37,115,34,59,32,114,101,118,101,114,116,105,110,103,32,116,111,32,37,115,10,0] /* Illegal float value  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str367310=allocate([79,117,116,45,111,102,45,114,97,110,103,101,32,102,108,111,97,116,32,118,97,108,117,101,32,102,111,114,32,37,115,58,32,34,37,115,34,32,40,109,117,115,116,32,98,101,32,98,101,116,119,101,101,110,32,37,115,32,97,110,100,32,37,115,41,59,32,114,101,118,101,114,116,105,110,103,32,116,111,32,37,115,10,0] /* Out-of-range float v */, "i8", ALLOC_STATIC);
STRING_TABLE.__str377311=allocate([65,116,116,101,109,112,116,101,100,32,116,111,32,115,101,116,32,105,110,118,97,108,105,100,32,111,112,116,105,111,110,32,37,115,10,0] /* Attempted to set inv */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTS12core_options=allocate([49,50,99,111,114,101,95,111,112,116,105,111,110,115,0] /* 12core_options\00 */, "i8", ALLOC_STATIC);
__ZTI12core_options=allocate(8, "*", ALLOC_STATIC);
__ZL7nullmd5=allocate(16, "i8", ALLOC_STATIC);
__ZL8nullsha1=allocate(20, "i8", ALLOC_STATIC);
STRING_TABLE.__str7343=allocate([110,111,110,101,0] /* none\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17344=allocate([122,108,105,98,0] /* zlib\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27345=allocate([122,108,105,98,43,0] /* zlib+\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37346=allocate([65,47,86,0] /* A/V\00 */, "i8", ALLOC_STATIC);
__ZL16codec_interfaces=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7852, 0, 0, 0, 7854, 0, 0, 0, 7856, 0, 0, 0, 7858, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7852, 0, 0, 0, 7854, 0, 0, 0, 7856, 0, 0, 0, 7858, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 7860, 0, 0, 0, 7862, 0, 0, 0, 7864, 0, 0, 0, 7866, 0, 0, 0, 7868, 0, 0, 0], ["i32",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str47347=allocate([110,111,32,101,114,114,111,114,0] /* no error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57348=allocate([110,111,32,100,114,105,118,101,32,105,110,116,101,114,102,97,99,101,0] /* no drive interface\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67349=allocate([111,117,116,32,111,102,32,109,101,109,111,114,121,0] /* out of memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77350=allocate([105,110,118,97,108,105,100,32,102,105,108,101,0] /* invalid file\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87351=allocate([105,110,118,97,108,105,100,32,112,97,114,97,109,101,116,101,114,0] /* invalid parameter\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97352=allocate([105,110,118,97,108,105,100,32,100,97,116,97,0] /* invalid data\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str107353=allocate([102,105,108,101,32,110,111,116,32,102,111,117,110,100,0] /* file not found\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str117354=allocate([114,101,113,117,105,114,101,115,32,112,97,114,101,110,116,0] /* requires parent\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127355=allocate([102,105,108,101,32,110,111,116,32,119,114,105,116,101,97,98,108,101,0] /* file not writeable\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137356=allocate([114,101,97,100,32,101,114,114,111,114,0] /* read error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147357=allocate([119,114,105,116,101,32,101,114,114,111,114,0] /* write error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157358=allocate([99,111,100,101,99,32,101,114,114,111,114,0] /* codec error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str167359=allocate([105,110,118,97,108,105,100,32,112,97,114,101,110,116,0] /* invalid parent\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str177360=allocate([104,117,110,107,32,111,117,116,32,111,102,32,114,97,110,103,101,0] /* hunk out of range\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str187361=allocate([100,101,99,111,109,112,114,101,115,115,105,111,110,32,101,114,114,111,114,0] /* decompression error\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str197362=allocate([99,111,109,112,114,101,115,115,105,111,110,32,101,114,114,111,114,0] /* compression error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str207363=allocate([99,97,110,39,116,32,99,114,101,97,116,101,32,102,105,108,101,0] /* can't create file\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str217364=allocate([99,97,110,39,116,32,118,101,114,105,102,121,32,102,105,108,101,0] /* can't verify file\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str227365=allocate([111,112,101,114,97,116,105,111,110,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0] /* operation not suppor */, "i8", ALLOC_STATIC);
STRING_TABLE.__str237366=allocate([99,97,110,39,116,32,102,105,110,100,32,109,101,116,97,100,97,116,97,0] /* can't find metadata\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str247367=allocate([105,110,118,97,108,105,100,32,109,101,116,97,100,97,116,97,32,115,105,122,101,0] /* invalid metadata siz */, "i8", ALLOC_STATIC);
STRING_TABLE.__str257368=allocate([117,110,115,117,112,112,111,114,116,101,100,32,67,72,68,32,118,101,114,115,105,111,110,0] /* unsupported CHD vers */, "i8", ALLOC_STATIC);
STRING_TABLE.__str267369=allocate([105,110,99,111,109,112,108,101,116,101,32,118,101,114,105,102,121,0] /* incomplete verify\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str277370=allocate([105,110,118,97,108,105,100,32,109,101,116,97,100,97,116,97,0] /* invalid metadata\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str287371=allocate([105,110,118,97,108,105,100,32,115,116,97,116,101,0] /* invalid state\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str297372=allocate([111,112,101,114,97,116,105,111,110,32,112,101,110,100,105,110,103,0] /* operation pending\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str307373=allocate([110,111,32,97,115,121,110,99,32,111,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0] /* no async operation i */, "i8", ALLOC_STATIC);
STRING_TABLE.__str317374=allocate([117,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,0] /* unsupported format\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str327375=allocate([117,110,100,111,99,117,109,101,110,116,101,100,32,101,114,114,111,114,0] /* undocumented error\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str337376=allocate([67,89,76,83,58,37,100,44,72,69,65,68,83,58,37,100,44,83,69,67,83,58,37,100,44,66,80,83,58,37,100,0] /* CYLS:%d,HEADS:%d,SEC */, "i8", ALLOC_STATIC);
STRING_TABLE.__str357378=allocate([70,80,83,58,37,100,46,37,48,54,100,32,87,73,68,84,72,58,37,100,32,72,69,73,71,72,84,58,37,100,32,73,78,84,69,82,76,65,67,69,68,58,37,100,32,67,72,65,78,78,69,76,83,58,37,100,32,83,65,77,80,76,69,82,65,84,69,58,37,100,0] /* FPS:%d.%06d WIDTH:%d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str367379=allocate([49,46,50,46,51,0] /* 1.2.3\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str377380=allocate([69,110,100,79,102,76,105,115,116,67,111,111,107,105,101,0] /* EndOfListCookie\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str387381=allocate([77,67,111,109,112,114,72,68,0] /* MComprHD\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str397382=allocate([80,101,110,100,105,110,103,32,97,115,121,110,99,32,111,112,101,114,97,116,105,111,110,32,110,101,118,101,114,32,99,111,109,112,108,101,116,101,100,33,0] /* Pending async operat */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL15implicitContext=allocate([120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0] /* xml=http://www.w3.or */, "i8", ALLOC_STATIC);
__ZZ15XML_ErrorStringE7message=allocate(164, "*", ALLOC_STATIC);
STRING_TABLE.__str7476=allocate([111,117,116,32,111,102,32,109,101,109,111,114,121,0] /* out of memory\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17477=allocate([115,121,110,116,97,120,32,101,114,114,111,114,0] /* syntax error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27478=allocate([110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0] /* no element found\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37479=allocate([110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0] /* not well-formed (inv */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47480=allocate([117,110,99,108,111,115,101,100,32,116,111,107,101,110,0] /* unclosed token\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57481=allocate([112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0] /* partial character\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67482=allocate([109,105,115,109,97,116,99,104,101,100,32,116,97,103,0] /* mismatched tag\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77483=allocate([100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0] /* duplicate attribute\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87484=allocate([106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0] /* junk after document  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97485=allocate([105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0] /* illegal parameter en */, "i8", ALLOC_STATIC);
STRING_TABLE.__str107486=allocate([117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0] /* undefined entity\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str117487=allocate([114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0] /* recursive entity ref */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127488=allocate([97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0] /* asynchronous entity\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137489=allocate([114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0] /* reference to invalid */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147490=allocate([114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0] /* reference to binary  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157491=allocate([114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0] /* reference to externa */, "i8", ALLOC_STATIC);
STRING_TABLE.__str167492=allocate([88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0] /* XML or text declarat */, "i8", ALLOC_STATIC);
STRING_TABLE.__str177493=allocate([117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0] /* unknown encoding\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str187494=allocate([101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0] /* encoding specified i */, "i8", ALLOC_STATIC);
STRING_TABLE.__str197495=allocate([117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0] /* unclosed CDATA secti */, "i8", ALLOC_STATIC);
STRING_TABLE.__str207496=allocate([101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0] /* error in processing  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str217497=allocate([100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0] /* document is not stan */, "i8", ALLOC_STATIC);
STRING_TABLE.__str227498=allocate([117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0] /* unexpected parser st */, "i8", ALLOC_STATIC);
STRING_TABLE.__str237499=allocate([101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0] /* entity declared in p */, "i8", ALLOC_STATIC);
STRING_TABLE.__str247500=allocate([114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0] /* requested feature re */, "i8", ALLOC_STATIC);
STRING_TABLE.__str257501=allocate([99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0] /* cannot change settin */, "i8", ALLOC_STATIC);
STRING_TABLE.__str267502=allocate([117,110,98,111,117,110,100,32,112,114,101,102,105,120,0] /* unbound prefix\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str277503=allocate([109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0] /* must not undeclare p */, "i8", ALLOC_STATIC);
STRING_TABLE.__str287504=allocate([105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0] /* incomplete markup in */, "i8", ALLOC_STATIC);
STRING_TABLE.__str297505=allocate([88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0] /* XML declaration not  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str307506=allocate([116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0] /* text declaration not */, "i8", ALLOC_STATIC);
STRING_TABLE.__str317507=allocate([105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0] /* illegal character(s) */, "i8", ALLOC_STATIC);
STRING_TABLE.__str327508=allocate([112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0] /* parser suspended\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str337509=allocate([112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0] /* parser not suspended */, "i8", ALLOC_STATIC);
STRING_TABLE.__str347510=allocate([112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0] /* parsing aborted\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str357511=allocate([112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0] /* parsing finished\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str367512=allocate([99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0] /* cannot suspend in ex */, "i8", ALLOC_STATIC);
STRING_TABLE.__str377513=allocate([114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0] /* reserved prefix (xml */, "i8", ALLOC_STATIC);
STRING_TABLE.__str387514=allocate([114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0] /* reserved prefix (xml */, "i8", ALLOC_STATIC);
STRING_TABLE.__str397515=allocate([112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0] /* prefix must not be b */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7bindingE12xmlNamespace=allocate([104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0] /* http://www.w3.org/XM */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7bindingE14xmlnsNamespace=allocate([104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0] /* http://www.w3.org/20 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE18externalSubsetName=allocate([35,0] /* #\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE10atypeCDATA=allocate([67,68,65,84,65,0] /* CDATA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE7atypeID=allocate([73,68,0] /* ID\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE10atypeIDREF=allocate([73,68,82,69,70,0] /* IDREF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE11atypeIDREFS=allocate([73,68,82,69,70,83,0] /* IDREFS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE11atypeENTITY=allocate([69,78,84,73,84,89,0] /* ENTITY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE13atypeENTITIES=allocate([69,78,84,73,84,73,69,83,0] /* ENTITIES\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE12atypeNMTOKEN=allocate([78,77,84,79,75,69,78,0] /* NMTOKEN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE13atypeNMTOKENS=allocate([78,77,84,79,75,69,78,83,0] /* NMTOKENS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE14notationPrefix=allocate([78,79,84,65,84,73,79,78,40,0] /* NOTATION(\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE12enumValueSep=allocate([124,0] /* |\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_hE14enumValueStart=allocate([40,0] /* (\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_ENTITY=allocate([69,78,84,73,84,89,0] /* ENTITY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10KW_ATTLIST=allocate([65,84,84,76,73,83,84,0] /* ATTLIST\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10KW_ELEMENT=allocate([69,76,69,77,69,78,84,0] /* ELEMENT\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_NOTATION=allocate([78,79,84,65,84,73,79,78,0] /* NOTATION\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_SYSTEM=allocate([83,89,83,84,69,77,0] /* SYSTEM\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_PUBLIC=allocate([80,85,66,76,73,67,0] /* PUBLIC\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8KW_EMPTY=allocate([69,77,80,84,89,0] /* EMPTY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL6KW_ANY=allocate([65,78,89,0] /* ANY\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_PCDATA=allocate([80,67,68,65,84,65,0] /* PCDATA\00 */, "i8", ALLOC_STATIC);
__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types=allocate(32, "*", ALLOC_STATIC);
STRING_TABLE.__ZL8KW_CDATA=allocate([67,68,65,84,65,0] /* CDATA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL5KW_ID=allocate([73,68,0] /* ID\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8KW_IDREF=allocate([73,68,82,69,70,0] /* IDREF\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_IDREFS=allocate([73,68,82,69,70,83,0] /* IDREFS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_ENTITIES=allocate([69,78,84,73,84,73,69,83,0] /* ENTITIES\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10KW_NMTOKEN=allocate([78,77,84,79,75,69,78,0] /* NMTOKEN\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_NMTOKENS=allocate([78,77,84,79,75,69,78,83,0] /* NMTOKENS\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10KW_IMPLIED=allocate([73,77,80,76,73,69,68,0] /* IMPLIED\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_REQUIRED=allocate([82,69,81,85,73,82,69,68,0] /* REQUIRED\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8KW_FIXED=allocate([70,73,88,69,68,0] /* FIXED\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8KW_NDATA=allocate([78,68,65,84,65,0] /* NDATA\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10KW_INCLUDE=allocate([73,78,67,76,85,68,69,0] /* INCLUDE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_IGNORE=allocate([73,71,78,79,82,69,0] /* IGNORE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL10KW_DOCTYPE=allocate([68,79,67,84,89,80,69,0] /* DOCTYPE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL17ascii_encoding_ns=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7900, 0, 0, 0, 7902, 0, 0, 0, 1, 0, 0, 0, 1, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 23, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL14ascii_encoding=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7900, 0, 0, 0, 7902, 0, 0, 0, 1, 0, 0, 0, 1, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL11nmstrtPages=allocate([2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] /* \02\03\04\05\06\07\0 */, "i8", ALLOC_STATIC);
__ZL12namingBitmap=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 67108864, 0, 0, 0, -2013265922, 0, 0, 0, 134217726, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8388609, 0, 0, 0, -8388609, 0, 0, 0, -1, 0, 0, 0, 2146697215, 0, 0, 0, -514, 0, 0, 0, 2147483647, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -8177, 0, 0, 0, -63832065, 0, 0, 0, 16777215, 0, 0, 0, 0, 0, 0, 0, -65536, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -134217217, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10432, 0, 0, 0, -5, 0, 0, 0, 1417641983, 0, 0, 0, 1048573, 0, 0, 0, -8194, 0, 0, 0, -1, 0, 0, 0, -536936449, 0, 0, 0, -1, 0, 0, 0, -65533, 0, 0, 0, -1, 0, 0, 0, -58977, 0, 0, 0, 54513663, 0, 0, 0, 0, 0, 0, 0, -131072, 0, 0, 0, 41943039, 0, 0, 0, -2, 0, 0, 0, 127, 0, 0, 0, 0, 0, 0, 0, -65536, 0, 0, 0, 460799, 0, 0, 0, 0, 0, 0, 0, 134217726, 0, 0, 0, 2046, 0, 0, 0, -131072, 0, 0, 0, -1, 0, 0, 0, 2097151999, 0, 0, 0, 3112959, 0, 0, 0, 96, 0, 0, 0, -32, 0, 0, 0, 603979775, 0, 0, 0, -16777216, 0, 0, 0, 3, 0, 0, 0, -417824, 0, 0, 0, 63307263, 0, 0, 0, -1342177280, 0, 0, 0, 196611, 0, 0, 0, -423968, 0, 0, 0, 57540095, 0, 0, 0, 1577058304, 0, 0, 0, 1835008, 0, 0, 0, -282656, 0, 0, 0, 602799615, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, -417824, 0, 0, 0, 600702463, 0, 0, 0, -1342177280, 0, 0, 0, 3, 0, 0, 0, -700594208, 0, 0, 0, 62899992, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -139296, 0, 0, 0, 66059775, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, -139296, 0, 0, 0, 66059775, 0, 0, 0, 1073741824, 0, 0, 0, 3, 0, 0, 0, -139296, 0, 0, 0, 67108351, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, 0, 0, 0, 884735, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, -17816170, 0, 0, 0, 537750702, 0, 0, 0, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -257, 0, 0, 0, 1023, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, -65473, 0, 0, 0, 8388607, 0, 0, 0, 514797, 0, 0, 0, 1342177280, 0, 0, 0, -2110697471, 0, 0, 0, 2908843, 0, 0, 0, 1073741824, 0, 0, 0, -176109312, 0, 0, 0, 7, 0, 0, 0, 33622016, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, 268435455, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, 67108863, 0, 0, 0, 1061158911, 0, 0, 0, -1, 0, 0, 0, -1426112705, 0, 0, 0, 1073741823, 0, 0, 0, -1, 0, 0, 0, 1608515583, 0, 0, 0, 265232348, 0, 0, 0, 534519807, 0, 0, 0, 0, 0, 0, 0, 19520, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 0, 0, 0, 1022, 0, 0, 0, -2, 0, 0, 0, -1, 0, 0, 0, 2097151, 0, 0, 0, -2, 0, 0, 0, -1, 0, 0, 0, 134217727, 0, 0, 0, -32, 0, 0, 0, 8191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, 63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134176768, 0, 0, 0, -2013265922, 0, 0, 0, 134217726, 0, 0, 0, 0, 0, 0, 0, 8388608, 0, 0, 0, -8388609, 0, 0, 0, -8388609, 0, 0, 0, 16777215, 0, 0, 0, 0, 0, 0, 0, -65536, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, -134217217, 0, 0, 0, 196611, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, -1, 0, 0, 0, 63, 0, 0, 0, 3, 0, 0, 0, -10304, 0, 0, 0, -5, 0, 0, 0, 1417641983, 0, 0, 0, 1048573, 0, 0, 0, -8194, 0, 0, 0, -1, 0, 0, 0, -536936449, 0, 0, 0, -1, 0, 0, 0, -65413, 0, 0, 0, -1, 0, 0, 0, -58977, 0, 0, 0, 54513663, 0, 0, 0, 0, 0, 0, 0, -131072, 0, 0, 0, 41943039, 0, 0, 0, -2, 0, 0, 0, -130945, 0, 0, 0, -1140850693, 0, 0, 0, -65514, 0, 0, 0, 460799, 0, 0, 0, 0, 0, 0, 0, 134217726, 0, 0, 0, 524287, 0, 0, 0, -64513, 0, 0, 0, -1, 0, 0, 0, 2097151999, 0, 0, 0, -1081345, 0, 0, 0, 67059199, 0, 0, 0, -18, 0, 0, 0, -201326593, 0, 0, 0, -14794753, 0, 0, 0, 65487, 0, 0, 0, -417810, 0, 0, 0, -741999105, 0, 0, 0, -1333773921, 0, 0, 0, 262095, 0, 0, 0, -423964, 0, 0, 0, -747766273, 0, 0, 0, 1577073031, 0, 0, 0, 2097088, 0, 0, 0, -282642, 0, 0, 0, -202506753, 0, 0, 0, 15295, 0, 0, 0, 65473, 0, 0, 0, -417810, 0, 0, 0, -204603905, 0, 0, 0, -1329579633, 0, 0, 0, 65475, 0, 0, 0, -700594196, 0, 0, 0, -1010841832, 0, 0, 0, 8404423, 0, 0, 0, 65408, 0, 0, 0, -139282, 0, 0, 0, -1007682049, 0, 0, 0, 6307295, 0, 0, 0, 65475, 0, 0, 0, -139284, 0, 0, 0, -1007682049, 0, 0, 0, 1080049119, 0, 0, 0, 65475, 0, 0, 0, -139284, 0, 0, 0, -1006633473, 0, 0, 0, 8404431, 0, 0, 0, 65475, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, 0, 0, 0, 134184959, 0, 0, 0, 67076095, 0, 0, 0, 0, 0, 0, 0, -17816170, 0, 0, 0, 1006595246, 0, 0, 0, 67059551, 0, 0, 0, 0, 0, 0, 0, 50331648, 0, 0, 0, -1029700609, 0, 0, 0, -257, 0, 0, 0, -130049, 0, 0, 0, -21032993, 0, 0, 0, 50216959, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536805376, 0, 0, 0, 2, 0, 0, 0, 160, 0, 0, 0, 4128766, 0, 0, 0, -2, 0, 0, 0, -1, 0, 0, 0, 1713373183, 0, 0, 0, -2, 0, 0, 0, -1, 0, 0, 0, 2013265919, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL9namePages=allocate([25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] /* \19\03\1A\1B\1C\1D\1 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL9KW_UTF_16=allocate([85,84,70,45,49,54,0] /* UTF-16\00 */, "i8", ALLOC_STATIC);
__ZL11encodingsNS=allocate(28, "*", ALLOC_STATIC);
STRING_TABLE.__ZL19little2_encoding_ns=allocate([7904, 0, 0, 0, 7906, 0, 0, 0, 7908, 0, 0, 0, 7910, 0, 0, 0, 7912, 0, 0, 0, 7914, 0, 0, 0, 7916, 0, 0, 0, 7918, 0, 0, 0, 7920, 0, 0, 0, 7922, 0, 0, 0, 7924, 0, 0, 0, 7926, 0, 0, 0, 7928, 0, 0, 0, 7930, 0, 0, 0, 7932, 0, 0, 0, 7934, 0, 0, 0, 7936, 0, 0, 0, 2, 0, 0, 0, 0, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 23, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 26, 28, 28, 22, 28, 28, 28, 28, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZL24little2_scanCdataSectionPK8encodingPKcS3_PS3_E10CDATA_LSQB=allocate([67,68,65,84,65,91] /* CDATA[ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL16big2_encoding_ns=allocate([7938, 0, 0, 0, 7940, 0, 0, 0, 7942, 0, 0, 0, 7944, 0, 0, 0, 7946, 0, 0, 0, 7948, 0, 0, 0, 7950, 0, 0, 0, 7952, 0, 0, 0, 7954, 0, 0, 0, 7956, 0, 0, 0, 7958, 0, 0, 0, 7960, 0, 0, 0, 7962, 0, 0, 0, 7964, 0, 0, 0, 7966, 0, 0, 0, 7968, 0, 0, 0, 7970, 0, 0, 0, 2, 0, 0, 0, 0, 1, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 23, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 26, 28, 28, 22, 28, 28, 28, 28, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZL21big2_scanCdataSectionPK8encodingPKcS3_PS3_E10CDATA_LSQB=allocate([67,68,65,84,65,91] /* CDATA[ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL16utf8_encoding_ns=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7972, 0, 0, 0, 7974, 0, 0, 0, 1, 0, 0, 0, 1, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 23, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 7976, 0, 0, 0, 7978, 0, 0, 0, 7980, 0, 0, 0, 7982, 0, 0, 0, 7984, 0, 0, 0, 7980, 0, 0, 0, 7986, 0, 0, 0, 7988, 0, 0, 0, 7990, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL18latin1_encoding_ns=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7992, 0, 0, 0, 7902, 0, 0, 0, 1, 0, 0, 0, 0, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 23, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 26, 28, 28, 22, 28, 28, 28, 28, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL25internal_utf8_encoding_ns=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7972, 0, 0, 0, 7974, 0, 0, 0, 1, 0, 0, 0, 1, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 23, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 7976, 0, 0, 0, 7978, 0, 0, 0, 7980, 0, 0, 0, 7982, 0, 0, 0, 7984, 0, 0, 0, 7980, 0, 0, 0, 7986, 0, 0, 0, 7988, 0, 0, 0, 7990, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZL9encodings=allocate(28, "*", ALLOC_STATIC);
STRING_TABLE.__ZL16little2_encoding=allocate([7904, 0, 0, 0, 7906, 0, 0, 0, 7908, 0, 0, 0, 7910, 0, 0, 0, 7912, 0, 0, 0, 7914, 0, 0, 0, 7916, 0, 0, 0, 7918, 0, 0, 0, 7920, 0, 0, 0, 7922, 0, 0, 0, 7924, 0, 0, 0, 7926, 0, 0, 0, 7928, 0, 0, 0, 7930, 0, 0, 0, 7932, 0, 0, 0, 7934, 0, 0, 0, 7936, 0, 0, 0, 2, 0, 0, 0, 0, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 26, 28, 28, 22, 28, 28, 28, 28, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL13big2_encoding=allocate([7938, 0, 0, 0, 7940, 0, 0, 0, 7942, 0, 0, 0, 7944, 0, 0, 0, 7946, 0, 0, 0, 7948, 0, 0, 0, 7950, 0, 0, 0, 7952, 0, 0, 0, 7954, 0, 0, 0, 7956, 0, 0, 0, 7958, 0, 0, 0, 7960, 0, 0, 0, 7962, 0, 0, 0, 7964, 0, 0, 0, 7966, 0, 0, 0, 7968, 0, 0, 0, 7970, 0, 0, 0, 2, 0, 0, 0, 0, 1, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 26, 28, 28, 22, 28, 28, 28, 28, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL13utf8_encoding=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7972, 0, 0, 0, 7974, 0, 0, 0, 1, 0, 0, 0, 1, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 7976, 0, 0, 0, 7978, 0, 0, 0, 7980, 0, 0, 0, 7982, 0, 0, 0, 7984, 0, 0, 0, 7980, 0, 0, 0, 7986, 0, 0, 0, 7988, 0, 0, 0, 7990, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL10KW_version=allocate([118,101,114,115,105,111,110,0] /* version\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_encoding=allocate([101,110,99,111,100,105,110,103,0] /* encoding\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL13KW_standalone=allocate([115,116,97,110,100,97,108,111,110,101,0] /* standalone\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL6KW_yes=allocate([121,101,115,0] /* yes\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL5KW_no=allocate([110,111,0] /* no\00 */, "i8", ALLOC_STATIC);
__ZZL16getEncodingIndexPKcE13encodingNames=allocate(24, "*", ALLOC_STATIC);
STRING_TABLE.__ZL13KW_ISO_8859_1=allocate([73,83,79,45,56,56,53,57,45,49,0] /* ISO-8859-1\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_US_ASCII=allocate([85,83,45,65,83,67,73,73,0] /* US-ASCII\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL8KW_UTF_8=allocate([85,84,70,45,56,0] /* UTF-8\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_UTF_16BE=allocate([85,84,70,45,49,54,66,69,0] /* UTF-16BE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11KW_UTF_16LE=allocate([85,84,70,45,49,54,76,69,0] /* UTF-16LE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL22internal_utf8_encoding=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7972, 0, 0, 0, 7974, 0, 0, 0, 1, 0, 0, 0, 1, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 7976, 0, 0, 0, 7978, 0, 0, 0, 7980, 0, 0, 0, 7982, 0, 0, 0, 7984, 0, 0, 0, 7980, 0, 0, 0, 7986, 0, 0, 0, 7988, 0, 0, 0, 7990, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL15latin1_encoding=allocate([7870, 0, 0, 0, 7872, 0, 0, 0, 7874, 0, 0, 0, 7876, 0, 0, 0, 7878, 0, 0, 0, 7880, 0, 0, 0, 7882, 0, 0, 0, 7884, 0, 0, 0, 7886, 0, 0, 0, 7888, 0, 0, 0, 7890, 0, 0, 0, 7892, 0, 0, 0, 7894, 0, 0, 0, 7896, 0, 0, 0, 7898, 0, 0, 0, 7992, 0, 0, 0, 7902, 0, 0, 0, 1, 0, 0, 0, 0, 0, undef, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 10, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 16, 12, 19, 28, 30, 3, 13, 31, 32, 33, 34, 35, 27, 26, 17, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 18, 2, 14, 11, 15, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 28, 4, 28, 22, 28, 24, 24, 24, 24, 24, 24, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 36, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28, 26, 28, 28, 22, 28, 28, 28, 28, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 28, 22, 22, 22, 22, 22, 22, 22, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","i8","*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZL23normal_scanCdataSectionPK8encodingPKcS3_PS3_E10CDATA_LSQB=allocate([67,68,65,84,65,91] /* CDATA[ */, "i8", ALLOC_STATIC);
_cassette_default_formats=allocate(8, "*", ALLOC_STATIC);
__ZZ15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_imageE15default_options=allocate([1, 0, 0, 0, 16, 0, 0, 0, 44100, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str17569=allocate([115,114,99,47,108,105,98,47,102,111,114,109,97,116,115,47,99,97,115,115,105,109,103,46,99,0] /* src/lib/formats/cass */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7582=allocate([44,0] /* ,\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17583=allocate([37,99,0] /* %c\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str7588=allocate([119,97,118,0] /* wav\00 */, "i8", ALLOC_STATIC);
_wavfile_format=allocate([0, 0, 0, 0, 7994, 0, 0, 0, 7996, 0, 0, 0, 7998, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZL6magic1=allocate([82,73,70,70] /* RIFF */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL6magic2=allocate([87,65,86,69] /* WAVE */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL13format_tag_id=allocate([102,109,116,32] /* fmt  */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZL11data_tag_id=allocate([100,97,116,97] /* data */, "i8", ALLOC_STATIC);
_crc_table=allocate([0, 0, 0, 0, 1996959894, 0, 0, 0, -301047508, 0, 0, 0, -1727442502, 0, 0, 0, 124634137, 0, 0, 0, 1886057615, 0, 0, 0, -379345611, 0, 0, 0, -1637575261, 0, 0, 0, 249268274, 0, 0, 0, 2044508324, 0, 0, 0, -522852066, 0, 0, 0, -1747789432, 0, 0, 0, 162941995, 0, 0, 0, 2125561021, 0, 0, 0, -407360249, 0, 0, 0, -1866523247, 0, 0, 0, 498536548, 0, 0, 0, 1789927666, 0, 0, 0, -205950648, 0, 0, 0, -2067906082, 0, 0, 0, 450548861, 0, 0, 0, 1843258603, 0, 0, 0, -187386543, 0, 0, 0, -2083289657, 0, 0, 0, 325883990, 0, 0, 0, 1684777152, 0, 0, 0, -43845254, 0, 0, 0, -1973040660, 0, 0, 0, 335633487, 0, 0, 0, 1661365465, 0, 0, 0, -99664541, 0, 0, 0, -1928851979, 0, 0, 0, 997073096, 0, 0, 0, 1281953886, 0, 0, 0, -715111964, 0, 0, 0, -1570279054, 0, 0, 0, 1006888145, 0, 0, 0, 1258607687, 0, 0, 0, -770865667, 0, 0, 0, -1526024853, 0, 0, 0, 901097722, 0, 0, 0, 1119000684, 0, 0, 0, -608450090, 0, 0, 0, -1396901568, 0, 0, 0, 853044451, 0, 0, 0, 1172266101, 0, 0, 0, -589951537, 0, 0, 0, -1412350631, 0, 0, 0, 651767980, 0, 0, 0, 1373503546, 0, 0, 0, -925412992, 0, 0, 0, -1076862698, 0, 0, 0, 565507253, 0, 0, 0, 1454621731, 0, 0, 0, -809855591, 0, 0, 0, -1195530993, 0, 0, 0, 671266974, 0, 0, 0, 1594198024, 0, 0, 0, -972236366, 0, 0, 0, -1324619484, 0, 0, 0, 795835527, 0, 0, 0, 1483230225, 0, 0, 0, -1050600021, 0, 0, 0, -1234817731, 0, 0, 0, 1994146192, 0, 0, 0, 31158534, 0, 0, 0, -1731059524, 0, 0, 0, -271249366, 0, 0, 0, 1907459465, 0, 0, 0, 112637215, 0, 0, 0, -1614814043, 0, 0, 0, -390540237, 0, 0, 0, 2013776290, 0, 0, 0, 251722036, 0, 0, 0, -1777751922, 0, 0, 0, -519137256, 0, 0, 0, 2137656763, 0, 0, 0, 141376813, 0, 0, 0, -1855689577, 0, 0, 0, -429695999, 0, 0, 0, 1802195444, 0, 0, 0, 476864866, 0, 0, 0, -2056965928, 0, 0, 0, -228458418, 0, 0, 0, 1812370925, 0, 0, 0, 453092731, 0, 0, 0, -2113342271, 0, 0, 0, -183516073, 0, 0, 0, 1706088902, 0, 0, 0, 314042704, 0, 0, 0, -1950435094, 0, 0, 0, -54949764, 0, 0, 0, 1658658271, 0, 0, 0, 366619977, 0, 0, 0, -1932296973, 0, 0, 0, -69972891, 0, 0, 0, 1303535960, 0, 0, 0, 984961486, 0, 0, 0, -1547960204, 0, 0, 0, -725929758, 0, 0, 0, 1256170817, 0, 0, 0, 1037604311, 0, 0, 0, -1529756563, 0, 0, 0, -740887301, 0, 0, 0, 1131014506, 0, 0, 0, 879679996, 0, 0, 0, -1385723834, 0, 0, 0, -631195440, 0, 0, 0, 1141124467, 0, 0, 0, 855842277, 0, 0, 0, -1442165665, 0, 0, 0, -586318647, 0, 0, 0, 1342533948, 0, 0, 0, 654459306, 0, 0, 0, -1106571248, 0, 0, 0, -921952122, 0, 0, 0, 1466479909, 0, 0, 0, 544179635, 0, 0, 0, -1184443383, 0, 0, 0, -832445281, 0, 0, 0, 1591671054, 0, 0, 0, 702138776, 0, 0, 0, -1328506846, 0, 0, 0, -942167884, 0, 0, 0, 1504918807, 0, 0, 0, 783551873, 0, 0, 0, -1212326853, 0, 0, 0, -1061524307, 0, 0, 0, -306674912, 0, 0, 0, -1698712650, 0, 0, 0, 62317068, 0, 0, 0, 1957810842, 0, 0, 0, -355121351, 0, 0, 0, -1647151185, 0, 0, 0, 81470997, 0, 0, 0, 1943803523, 0, 0, 0, -480048366, 0, 0, 0, -1805370492, 0, 0, 0, 225274430, 0, 0, 0, 2053790376, 0, 0, 0, -468791541, 0, 0, 0, -1828061283, 0, 0, 0, 167816743, 0, 0, 0, 2097651377, 0, 0, 0, -267414716, 0, 0, 0, -2029476910, 0, 0, 0, 503444072, 0, 0, 0, 1762050814, 0, 0, 0, -144550051, 0, 0, 0, -2140837941, 0, 0, 0, 426522225, 0, 0, 0, 1852507879, 0, 0, 0, -19653770, 0, 0, 0, -1982649376, 0, 0, 0, 282753626, 0, 0, 0, 1742555852, 0, 0, 0, -105259153, 0, 0, 0, -1900089351, 0, 0, 0, 397917763, 0, 0, 0, 1622183637, 0, 0, 0, -690576408, 0, 0, 0, -1580100738, 0, 0, 0, 953729732, 0, 0, 0, 1340076626, 0, 0, 0, -776247311, 0, 0, 0, -1497606297, 0, 0, 0, 1068828381, 0, 0, 0, 1219638859, 0, 0, 0, -670225446, 0, 0, 0, -1358292148, 0, 0, 0, 906185462, 0, 0, 0, 1090812512, 0, 0, 0, -547295293, 0, 0, 0, -1469587627, 0, 0, 0, 829329135, 0, 0, 0, 1181335161, 0, 0, 0, -882789492, 0, 0, 0, -1134132454, 0, 0, 0, 628085408, 0, 0, 0, 1382605366, 0, 0, 0, -871598187, 0, 0, 0, -1156888829, 0, 0, 0, 570562233, 0, 0, 0, 1426400815, 0, 0, 0, -977650754, 0, 0, 0, -1296233688, 0, 0, 0, 733239954, 0, 0, 0, 1555261956, 0, 0, 0, -1026031705, 0, 0, 0, -1244606671, 0, 0, 0, 752459403, 0, 0, 0, 1541320221, 0, 0, 0, -1687895376, 0, 0, 0, -328994266, 0, 0, 0, 1969922972, 0, 0, 0, 40735498, 0, 0, 0, -1677130071, 0, 0, 0, -351390145, 0, 0, 0, 1913087877, 0, 0, 0, 83908371, 0, 0, 0, -1782625662, 0, 0, 0, -491226604, 0, 0, 0, 2075208622, 0, 0, 0, 213261112, 0, 0, 0, -1831694693, 0, 0, 0, -438977011, 0, 0, 0, 2094854071, 0, 0, 0, 198958881, 0, 0, 0, -2032938284, 0, 0, 0, -237706686, 0, 0, 0, 1759359992, 0, 0, 0, 534414190, 0, 0, 0, -2118248755, 0, 0, 0, -155638181, 0, 0, 0, 1873836001, 0, 0, 0, 414664567, 0, 0, 0, -2012718362, 0, 0, 0, -15766928, 0, 0, 0, 1711684554, 0, 0, 0, 285281116, 0, 0, 0, -1889165569, 0, 0, 0, -127750551, 0, 0, 0, 1634467795, 0, 0, 0, 376229701, 0, 0, 0, -1609899400, 0, 0, 0, -686959890, 0, 0, 0, 1308918612, 0, 0, 0, 956543938, 0, 0, 0, -1486412191, 0, 0, 0, -799009033, 0, 0, 0, 1231636301, 0, 0, 0, 1047427035, 0, 0, 0, -1362007478, 0, 0, 0, -640263460, 0, 0, 0, 1088359270, 0, 0, 0, 936918000, 0, 0, 0, -1447252397, 0, 0, 0, -558129467, 0, 0, 0, 1202900863, 0, 0, 0, 817233897, 0, 0, 0, -1111625188, 0, 0, 0, -893730166, 0, 0, 0, 1404277552, 0, 0, 0, 615818150, 0, 0, 0, -1160759803, 0, 0, 0, -841546093, 0, 0, 0, 1423857449, 0, 0, 0, 601450431, 0, 0, 0, -1285129682, 0, 0, 0, -1000256840, 0, 0, 0, 1567103746, 0, 0, 0, 711928724, 0, 0, 0, -1274298825, 0, 0, 0, -1022587231, 0, 0, 0, 1510334235, 0, 0, 0, 755167117, 0, 0, 0, 0, 0, 0, 0, 421212481, 0, 0, 0, 842424962, 0, 0, 0, 724390851, 0, 0, 0, 1684849924, 0, 0, 0, 2105013317, 0, 0, 0, 1448781702, 0, 0, 0, 1329698503, 0, 0, 0, -925267448, 0, 0, 0, -775767223, 0, 0, 0, -84940662, 0, 0, 0, -470492725, 0, 0, 0, -1397403892, 0, 0, 0, -1246855603, 0, 0, 0, -1635570290, 0, 0, 0, -2020074289, 0, 0, 0, 1254232657, 0, 0, 0, 1406739216, 0, 0, 0, 2029285587, 0, 0, 0, 1643069842, 0, 0, 0, 783210325, 0, 0, 0, 934667796, 0, 0, 0, 479770071, 0, 0, 0, 92505238, 0, 0, 0, -2112120743, 0, 0, 0, -1694455528, 0, 0, 0, -1339163941, 0, 0, 0, -1456026726, 0, 0, 0, -428384931, 0, 0, 0, -9671652, 0, 0, 0, -733921313, 0, 0, 0, -849736034, 0, 0, 0, -1786501982, 0, 0, 0, -1935731229, 0, 0, 0, -1481488864, 0, 0, 0, -1096190111, 0, 0, 0, -236396122, 0, 0, 0, -386674457, 0, 0, 0, -1008827612, 0, 0, 0, -624577947, 0, 0, 0, 1566420650, 0, 0, 0, 1145479147, 0, 0, 0, 1869335592, 0, 0, 0, 1987116393, 0, 0, 0, 959540142, 0, 0, 0, 539646703, 0, 0, 0, 185010476, 0, 0, 0, 303839341, 0, 0, 0, -549046541, 0, 0, 0, -966981710, 0, 0, 0, -311405455, 0, 0, 0, -194288336, 0, 0, 0, -1154812937, 0, 0, 0, -1573797194, 0, 0, 0, -1994616459, 0, 0, 0, -1878548428, 0, 0, 0, 396344571, 0, 0, 0, 243568058, 0, 0, 0, 631889529, 0, 0, 0, 1018359608, 0, 0, 0, 1945336319, 0, 0, 0, 1793607870, 0, 0, 0, 1103436669, 0, 0, 0, 1490954812, 0, 0, 0, -260485371, 0, 0, 0, -379421116, 0, 0, 0, -1034998393, 0, 0, 0, -615244602, 0, 0, 0, -1810527743, 0, 0, 0, -1928414400, 0, 0, 0, -1507596157, 0, 0, 0, -1086793278, 0, 0, 0, 950060301, 0, 0, 0, 565965900, 0, 0, 0, 177645455, 0, 0, 0, 328046286, 0, 0, 0, 1556873225, 0, 0, 0, 1171730760, 0, 0, 0, 1861902987, 0, 0, 0, 2011255754, 0, 0, 0, -1162125996, 0, 0, 0, -1549767659, 0, 0, 0, -2004009002, 0, 0, 0, -1852436841, 0, 0, 0, -556296112, 0, 0, 0, -942888687, 0, 0, 0, -320734510, 0, 0, 0, -168113261, 0, 0, 0, 1919080284, 0, 0, 0, 1803150877, 0, 0, 0, 1079293406, 0, 0, 0, 1498383519, 0, 0, 0, 370020952, 0, 0, 0, 253043481, 0, 0, 0, 607678682, 0, 0, 0, 1025720731, 0, 0, 0, 1711106983, 0, 0, 0, 2095471334, 0, 0, 0, 1472923941, 0, 0, 0, 1322268772, 0, 0, 0, 26324643, 0, 0, 0, 411738082, 0, 0, 0, 866634785, 0, 0, 0, 717028704, 0, 0, 0, -1390091857, 0, 0, 0, -1270886162, 0, 0, 0, -1626176723, 0, 0, 0, -2046184852, 0, 0, 0, -918018901, 0, 0, 0, -799861270, 0, 0, 0, -75610583, 0, 0, 0, -496666776, 0, 0, 0, 792689142, 0, 0, 0, 908347575, 0, 0, 0, 487136116, 0, 0, 0, 68299317, 0, 0, 0, 1263779058, 0, 0, 0, 1380486579, 0, 0, 0, 2036719216, 0, 0, 0, 1618931505, 0, 0, 0, -404294658, 0, 0, 0, -16923969, 0, 0, 0, -707751556, 0, 0, 0, -859070403, 0, 0, 0, -2088093958, 0, 0, 0, -1701771333, 0, 0, 0, -1313057672, 0, 0, 0, -1465424583, 0, 0, 0, 998479947, 0, 0, 0, 580430090, 0, 0, 0, 162921161, 0, 0, 0, 279890824, 0, 0, 0, 1609522511, 0, 0, 0, 1190423566, 0, 0, 0, 1842954189, 0, 0, 0, 1958874764, 0, 0, 0, -212200893, 0, 0, 0, -364829950, 0, 0, 0, -1049857855, 0, 0, 0, -663273088, 0, 0, 0, -1758013625, 0, 0, 0, -1909594618, 0, 0, 0, -1526680123, 0, 0, 0, -1139047292, 0, 0, 0, 1900120602, 0, 0, 0, 1750776667, 0, 0, 0, 1131931800, 0, 0, 0, 1517083097, 0, 0, 0, 355290910, 0, 0, 0, 204897887, 0, 0, 0, 656092572, 0, 0, 0, 1040194781, 0, 0, 0, -1181220846, 0, 0, 0, -1602014893, 0, 0, 0, -1951505776, 0, 0, 0, -1833610287, 0, 0, 0, -571161322, 0, 0, 0, -990907305, 0, 0, 0, -272455788, 0, 0, 0, -153512235, 0, 0, 0, -1375224599, 0, 0, 0, -1222865496, 0, 0, 0, -1674453397, 0, 0, 0, -2060783830, 0, 0, 0, -898926099, 0, 0, 0, -747616084, 0, 0, 0, -128115857, 0, 0, 0, -515495378, 0, 0, 0, 1725839073, 0, 0, 0, 2143618976, 0, 0, 0, 1424512099, 0, 0, 0, 1307796770, 0, 0, 0, 45282277, 0, 0, 0, 464110244, 0, 0, 0, 813994343, 0, 0, 0, 698327078, 0, 0, 0, -456806728, 0, 0, 0, -35741703, 0, 0, 0, -688665542, 0, 0, 0, -806814341, 0, 0, 0, -2136380484, 0, 0, 0, -1716364547, 0, 0, 0, -1298200258, 0, 0, 0, -1417398145, 0, 0, 0, 740041904, 0, 0, 0, 889656817, 0, 0, 0, 506086962, 0, 0, 0, 120682355, 0, 0, 0, 1215357364, 0, 0, 0, 1366020341, 0, 0, 0, 2051441462, 0, 0, 0, 1667084919, 0, 0, 0, -872753330, 0, 0, 0, -756947441, 0, 0, 0, -104024628, 0, 0, 0, -522746739, 0, 0, 0, -1349119414, 0, 0, 0, -1232264437, 0, 0, 0, -1650429752, 0, 0, 0, -2068102775, 0, 0, 0, 52649286, 0, 0, 0, 439905287, 0, 0, 0, 823476164, 0, 0, 0, 672009861, 0, 0, 0, 1733269570, 0, 0, 0, 2119477507, 0, 0, 0, 1434057408, 0, 0, 0, 1281543041, 0, 0, 0, -2126985953, 0, 0, 0, -1742474146, 0, 0, 0, -1290885219, 0, 0, 0, -1441425700, 0, 0, 0, -447479781, 0, 0, 0, -61918886, 0, 0, 0, -681418087, 0, 0, 0, -830909480, 0, 0, 0, 1239502615, 0, 0, 0, 1358593622, 0, 0, 0, 2077699477, 0, 0, 0, 1657543892, 0, 0, 0, 764250643, 0, 0, 0, 882293586, 0, 0, 0, 532408465, 0, 0, 0, 111204816, 0, 0, 0, 1585378284, 0, 0, 0, 1197851309, 0, 0, 0, 1816695150, 0, 0, 0, 1968414767, 0, 0, 0, 974272232, 0, 0, 0, 587794345, 0, 0, 0, 136598634, 0, 0, 0, 289367339, 0, 0, 0, -1767409180, 0, 0, 0, -1883486043, 0, 0, 0, -1533994138, 0, 0, 0, -1115018713, 0, 0, 0, -221528864, 0, 0, 0, -338653791, 0, 0, 0, -1057104286, 0, 0, 0, -639176925, 0, 0, 0, 347922877, 0, 0, 0, 229101820, 0, 0, 0, 646611775, 0, 0, 0, 1066513022, 0, 0, 0, 1892689081, 0, 0, 0, 1774917112, 0, 0, 0, 1122387515, 0, 0, 0, 1543337850, 0, 0, 0, -597333067, 0, 0, 0, -981574924, 0, 0, 0, -296548041, 0, 0, 0, -146261898, 0, 0, 0, -1207325007, 0, 0, 0, -1592614928, 0, 0, 0, -1975530445, 0, 0, 0, -1826292366, 0, 0, 0, 0, 0, 0, 0, 29518391, 0, 0, 0, 59036782, 0, 0, 0, 38190681, 0, 0, 0, 118073564, 0, 0, 0, 114017003, 0, 0, 0, 76381362, 0, 0, 0, 89069189, 0, 0, 0, 236147128, 0, 0, 0, 265370511, 0, 0, 0, 228034006, 0, 0, 0, 206958561, 0, 0, 0, 152762724, 0, 0, 0, 148411219, 0, 0, 0, 178138378, 0, 0, 0, 190596925, 0, 0, 0, 472294256, 0, 0, 0, 501532999, 0, 0, 0, 530741022, 0, 0, 0, 509615401, 0, 0, 0, 456068012, 0, 0, 0, 451764635, 0, 0, 0, 413917122, 0, 0, 0, 426358261, 0, 0, 0, 305525448, 0, 0, 0, 334993663, 0, 0, 0, 296822438, 0, 0, 0, 275991697, 0, 0, 0, 356276756, 0, 0, 0, 352202787, 0, 0, 0, 381193850, 0, 0, 0, 393929805, 0, 0, 0, 944588512, 0, 0, 0, 965684439, 0, 0, 0, 1003065998, 0, 0, 0, 973863097, 0, 0, 0, 1061482044, 0, 0, 0, 1049003019, 0, 0, 0, 1019230802, 0, 0, 0, 1023561829, 0, 0, 0, 912136024, 0, 0, 0, 933002607, 0, 0, 0, 903529270, 0, 0, 0, 874031361, 0, 0, 0, 827834244, 0, 0, 0, 815125939, 0, 0, 0, 852716522, 0, 0, 0, 856752605, 0, 0, 0, 611050896, 0, 0, 0, 631869351, 0, 0, 0, 669987326, 0, 0, 0, 640506825, 0, 0, 0, 593644876, 0, 0, 0, 580921211, 0, 0, 0, 551983394, 0, 0, 0, 556069653, 0, 0, 0, 712553512, 0, 0, 0, 733666847, 0, 0, 0, 704405574, 0, 0, 0, 675154545, 0, 0, 0, 762387700, 0, 0, 0, 749958851, 0, 0, 0, 787859610, 0, 0, 0, 792175277, 0, 0, 0, 1889177024, 0, 0, 0, 1901651959, 0, 0, 0, 1931368878, 0, 0, 0, 1927033753, 0, 0, 0, 2006131996, 0, 0, 0, 1985040171, 0, 0, 0, 1947726194, 0, 0, 0, 1976933189, 0, 0, 0, 2122964088, 0, 0, 0, 2135668303, 0, 0, 0, 2098006038, 0, 0, 0, 2093965857, 0, 0, 0, 2038461604, 0, 0, 0, 2017599123, 0, 0, 0, 2047123658, 0, 0, 0, 2076625661, 0, 0, 0, 1824272048, 0, 0, 0, 1836991623, 0, 0, 0, 1866005214, 0, 0, 0, 1861914857, 0, 0, 0, 1807058540, 0, 0, 0, 1786244187, 0, 0, 0, 1748062722, 0, 0, 0, 1777547317, 0, 0, 0, 1655668488, 0, 0, 0, 1668093247, 0, 0, 0, 1630251878, 0, 0, 0, 1625932113, 0, 0, 0, 1705433044, 0, 0, 0, 1684323811, 0, 0, 0, 1713505210, 0, 0, 0, 1742760333, 0, 0, 0, 1222101792, 0, 0, 0, 1226154263, 0, 0, 0, 1263738702, 0, 0, 0, 1251046777, 0, 0, 0, 1339974652, 0, 0, 0, 1310460363, 0, 0, 0, 1281013650, 0, 0, 0, 1301863845, 0, 0, 0, 1187289752, 0, 0, 0, 1191637167, 0, 0, 0, 1161842422, 0, 0, 0, 1149379777, 0, 0, 0, 1103966788, 0, 0, 0, 1074747507, 0, 0, 0, 1112139306, 0, 0, 0, 1133218845, 0, 0, 0, 1425107024, 0, 0, 0, 1429406311, 0, 0, 0, 1467333694, 0, 0, 0, 1454888457, 0, 0, 0, 1408811148, 0, 0, 0, 1379576507, 0, 0, 0, 1350309090, 0, 0, 0, 1371438805, 0, 0, 0, 1524775400, 0, 0, 0, 1528845279, 0, 0, 0, 1499917702, 0, 0, 0, 1487177649, 0, 0, 0, 1575719220, 0, 0, 0, 1546255107, 0, 0, 0, 1584350554, 0, 0, 0, 1605185389, 0, 0, 0, -516613248, 0, 0, 0, -520654409, 0, 0, 0, -491663378, 0, 0, 0, -478960167, 0, 0, 0, -432229540, 0, 0, 0, -402728597, 0, 0, 0, -440899790, 0, 0, 0, -461763323, 0, 0, 0, -282703304, 0, 0, 0, -287039473, 0, 0, 0, -324886954, 0, 0, 0, -312413087, 0, 0, 0, -399514908, 0, 0, 0, -370308909, 0, 0, 0, -341100918, 0, 0, 0, -362193731, 0, 0, 0, -49039120, 0, 0, 0, -53357881, 0, 0, 0, -23630690, 0, 0, 0, -11204951, 0, 0, 0, -98955220, 0, 0, 0, -69699045, 0, 0, 0, -107035582, 0, 0, 0, -128143755, 0, 0, 0, -218044088, 0, 0, 0, -222133377, 0, 0, 0, -259769050, 0, 0, 0, -247048431, 0, 0, 0, -200719980, 0, 0, 0, -171234397, 0, 0, 0, -141715974, 0, 0, 0, -162529331, 0, 0, 0, -646423200, 0, 0, 0, -658884777, 0, 0, 0, -620984050, 0, 0, 0, -616635591, 0, 0, 0, -562956868, 0, 0, 0, -541876341, 0, 0, 0, -571137582, 0, 0, 0, -600355867, 0, 0, 0, -680850216, 0, 0, 0, -693541137, 0, 0, 0, -722478922, 0, 0, 0, -718425471, 0, 0, 0, -798841852, 0, 0, 0, -777990605, 0, 0, 0, -739872662, 0, 0, 0, -769385891, 0, 0, 0, -983630320, 0, 0, 0, -996371417, 0, 0, 0, -958780802, 0, 0, 0, -954711991, 0, 0, 0, -1034463540, 0, 0, 0, -1013629701, 0, 0, 0, -1043103070, 0, 0, 0, -1072568171, 0, 0, 0, -884101208, 0, 0, 0, -896547425, 0, 0, 0, -926319674, 0, 0, 0, -922021391, 0, 0, 0, -867956876, 0, 0, 0, -846828221, 0, 0, 0, -809446630, 0, 0, 0, -838682323, 0, 0, 0, -1850763712, 0, 0, 0, -1871840137, 0, 0, 0, -1842658770, 0, 0, 0, -1813436391, 0, 0, 0, -1767489892, 0, 0, 0, -1755032405, 0, 0, 0, -1792873742, 0, 0, 0, -1797226299, 0, 0, 0, -1615017992, 0, 0, 0, -1635865137, 0, 0, 0, -1674046570, 0, 0, 0, -1644529247, 0, 0, 0, -1732939996, 0, 0, 0, -1720253165, 0, 0, 0, -1691239606, 0, 0, 0, -1695297155, 0, 0, 0, -1920387792, 0, 0, 0, -1941217529, 0, 0, 0, -1911692962, 0, 0, 0, -1882223767, 0, 0, 0, -1971282452, 0, 0, 0, -1958545445, 0, 0, 0, -1996207742, 0, 0, 0, -2000280651, 0, 0, 0, -2087033720, 0, 0, 0, -2108158273, 0, 0, 0, -2145472282, 0, 0, 0, -2116232495, 0, 0, 0, -2070688684, 0, 0, 0, -2058246557, 0, 0, 0, -2028529606, 0, 0, 0, -2032831987, 0, 0, 0, -1444753248, 0, 0, 0, -1474250089, 0, 0, 0, -1436154674, 0, 0, 0, -1415287047, 0, 0, 0, -1360299908, 0, 0, 0, -1356262837, 0, 0, 0, -1385190382, 0, 0, 0, -1397897691, 0, 0, 0, -1477345000, 0, 0, 0, -1506546897, 0, 0, 0, -1535814282, 0, 0, 0, -1514717375, 0, 0, 0, -1594349116, 0, 0, 0, -1590017037, 0, 0, 0, -1552089686, 0, 0, 0, -1564567651, 0, 0, 0, -1245416496, 0, 0, 0, -1274668569, 0, 0, 0, -1237276738, 0, 0, 0, -1216164471, 0, 0, 0, -1295131892, 0, 0, 0, -1290817221, 0, 0, 0, -1320611998, 0, 0, 0, -1333041835, 0, 0, 0, -1143528856, 0, 0, 0, -1173010337, 0, 0, 0, -1202457082, 0, 0, 0, -1181639631, 0, 0, 0, -1126266188, 0, 0, 0, -1122180989, 0, 0, 0, -1084596518, 0, 0, 0, -1097321235, 0, 0, 0, 0, 0, 0, 0, -1195612315, 0, 0, 0, -1442199413, 0, 0, 0, 313896942, 0, 0, 0, -1889364137, 0, 0, 0, 937357362, 0, 0, 0, 627793884, 0, 0, 0, -1646839623, 0, 0, 0, -978048785, 0, 0, 0, 2097696650, 0, 0, 0, 1874714724, 0, 0, 0, -687765759, 0, 0, 0, 1255587768, 0, 0, 0, -227878691, 0, 0, 0, -522225869, 0, 0, 0, 1482887254, 0, 0, 0, 1343838111, 0, 0, 0, -391827206, 0, 0, 0, -99573996, 0, 0, 0, 1118632049, 0, 0, 0, -545537848, 0, 0, 0, 1741137837, 0, 0, 0, 1970407491, 0, 0, 0, -842109146, 0, 0, 0, -1783791760, 0, 0, 0, 756094997, 0, 0, 0, 1067759611, 0, 0, 0, -2028416866, 0, 0, 0, 449832999, 0, 0, 0, -1569484990, 0, 0, 0, -1329192788, 0, 0, 0, 142231497, 0, 0, 0, -1607291074, 0, 0, 0, 412010587, 0, 0, 0, 171665333, 0, 0, 0, -1299775280, 0, 0, 0, 793786473, 0, 0, 0, -1746116852, 0, 0, 0, -2057703198, 0, 0, 0, 1038456711, 0, 0, 0, 1703315409, 0, 0, 0, -583343948, 0, 0, 0, -812691622, 0, 0, 0, 1999841343, 0, 0, 0, -354152314, 0, 0, 0, 1381529571, 0, 0, 0, 1089329165, 0, 0, 0, -128860312, 0, 0, 0, -265553759, 0, 0, 0, 1217896388, 0, 0, 0, 1512189994, 0, 0, 0, -492939441, 0, 0, 0, 2135519222, 0, 0, 0, -940242797, 0, 0, 0, -717183107, 0, 0, 0, 1845280792, 0, 0, 0, 899665998, 0, 0, 0, -1927039189, 0, 0, 0, -1617553211, 0, 0, 0, 657096608, 0, 0, 0, -1157806311, 0, 0, 0, 37822588, 0, 0, 0, 284462994, 0, 0, 0, -1471616777, 0, 0, 0, -1693165507, 0, 0, 0, 598228824, 0, 0, 0, 824021174, 0, 0, 0, -1985873965, 0, 0, 0, 343330666, 0, 0, 0, -1396004849, 0, 0, 0, -1098971167, 0, 0, 0, 113467524, 0, 0, 0, 1587572946, 0, 0, 0, -434366537, 0, 0, 0, -190203815, 0, 0, 0, 1276501820, 0, 0, 0, -775755899, 0, 0, 0, 1769898208, 0, 0, 0, 2076913422, 0, 0, 0, -1015592853, 0, 0, 0, -888336478, 0, 0, 0, 1941006535, 0, 0, 0, 1627703081, 0, 0, 0, -642211764, 0, 0, 0, 1148164341, 0, 0, 0, -53215344, 0, 0, 0, -295284610, 0, 0, 0, 1457141531, 0, 0, 0, 247015245, 0, 0, 0, -1241169880, 0, 0, 0, -1531908154, 0, 0, 0, 470583459, 0, 0, 0, -2116308966, 0, 0, 0, 963106687, 0, 0, 0, 735213713, 0, 0, 0, -1821499404, 0, 0, 0, 992409347, 0, 0, 0, -2087022490, 0, 0, 0, -1859174520, 0, 0, 0, 697522413, 0, 0, 0, -1270587308, 0, 0, 0, 217581361, 0, 0, 0, 508405983, 0, 0, 0, -1494102086, 0, 0, 0, -23928852, 0, 0, 0, 1177467017, 0, 0, 0, 1419450215, 0, 0, 0, -332959742, 0, 0, 0, 1911572667, 0, 0, 0, -917753890, 0, 0, 0, -604405712, 0, 0, 0, 1665525589, 0, 0, 0, 1799331996, 0, 0, 0, -746338311, 0, 0, 0, -1053399017, 0, 0, 0, 2039091058, 0, 0, 0, -463652917, 0, 0, 0, 1558270126, 0, 0, 0, 1314193216, 0, 0, 0, -152528859, 0, 0, 0, -1366587277, 0, 0, 0, 372764438, 0, 0, 0, 75645176, 0, 0, 0, -1136777315, 0, 0, 0, 568925988, 0, 0, 0, -1722451903, 0, 0, 0, -1948198993, 0, 0, 0, 861712586, 0, 0, 0, -312887749, 0, 0, 0, 1441124702, 0, 0, 0, 1196457648, 0, 0, 0, -1304107, 0, 0, 0, 1648042348, 0, 0, 0, -628668919, 0, 0, 0, -936187417, 0, 0, 0, 1888390786, 0, 0, 0, 686661332, 0, 0, 0, -1873675855, 0, 0, 0, -2098964897, 0, 0, 0, 978858298, 0, 0, 0, -1483798141, 0, 0, 0, 523464422, 0, 0, 0, 226935048, 0, 0, 0, -1254447507, 0, 0, 0, -1119821404, 0, 0, 0, 100435649, 0, 0, 0, 390670639, 0, 0, 0, -1342878134, 0, 0, 0, 841119475, 0, 0, 0, -1969352298, 0, 0, 0, -1741963656, 0, 0, 0, 546822429, 0, 0, 0, 2029308235, 0, 0, 0, -1068978642, 0, 0, 0, -755170880, 0, 0, 0, 1782671013, 0, 0, 0, -141140452, 0, 0, 0, 1328167289, 0, 0, 0, 1570739863, 0, 0, 0, -450629134, 0, 0, 0, 1298864389, 0, 0, 0, -170426784, 0, 0, 0, -412954226, 0, 0, 0, 1608431339, 0, 0, 0, -1039561134, 0, 0, 0, 2058742071, 0, 0, 0, 1744848601, 0, 0, 0, -792976964, 0, 0, 0, -1998638614, 0, 0, 0, 811816591, 0, 0, 0, 584513889, 0, 0, 0, -1704288764, 0, 0, 0, 129869501, 0, 0, 0, -1090403880, 0, 0, 0, -1380684234, 0, 0, 0, 352848211, 0, 0, 0, 494030490, 0, 0, 0, -1513215489, 0, 0, 0, -1216641519, 0, 0, 0, 264757620, 0, 0, 0, -1844389427, 0, 0, 0, 715964072, 0, 0, 0, 941166918, 0, 0, 0, -2136639965, 0, 0, 0, -658086283, 0, 0, 0, 1618608400, 0, 0, 0, 1926213374, 0, 0, 0, -898381413, 0, 0, 0, 1470427426, 0, 0, 0, -283601337, 0, 0, 0, -38979159, 0, 0, 0, 1158766284, 0, 0, 0, 1984818694, 0, 0, 0, -823031453, 0, 0, 0, -599513459, 0, 0, 0, 1693991400, 0, 0, 0, -114329263, 0, 0, 0, 1100160564, 0, 0, 0, 1395044826, 0, 0, 0, -342174017, 0, 0, 0, -1275476247, 0, 0, 0, 189112716, 0, 0, 0, 435162722, 0, 0, 0, -1588827897, 0, 0, 0, 1016811966, 0, 0, 0, -2077804837, 0, 0, 0, -1768777419, 0, 0, 0, 774831696, 0, 0, 0, 643086745, 0, 0, 0, -1628905732, 0, 0, 0, -1940033262, 0, 0, 0, 887166583, 0, 0, 0, -1456066866, 0, 0, 0, 294275499, 0, 0, 0, 54519365, 0, 0, 0, -1149009632, 0, 0, 0, -471821962, 0, 0, 0, 1532818963, 0, 0, 0, 1240029693, 0, 0, 0, -246071656, 0, 0, 0, 1820460577, 0, 0, 0, -734109372, 0, 0, 0, -963916118, 0, 0, 0, 2117577167, 0, 0, 0, -696303304, 0, 0, 0, 1858283101, 0, 0, 0, 2088143283, 0, 0, 0, -993333546, 0, 0, 0, 1495127663, 0, 0, 0, -509497078, 0, 0, 0, -216785180, 0, 0, 0, 1269332353, 0, 0, 0, 332098007, 0, 0, 0, -1418260814, 0, 0, 0, -1178427044, 0, 0, 0, 25085497, 0, 0, 0, -1666580864, 0, 0, 0, 605395429, 0, 0, 0, 916469259, 0, 0, 0, -1910746770, 0, 0, 0, -2040129881, 0, 0, 0, 1054503362, 0, 0, 0, 745528876, 0, 0, 0, -1798063799, 0, 0, 0, 151290352, 0, 0, 0, -1313282411, 0, 0, 0, -1559410309, 0, 0, 0, 464596510, 0, 0, 0, 1137851976, 0, 0, 0, -76654291, 0, 0, 0, -371460413, 0, 0, 0, 1365741990, 0, 0, 0, -860837601, 0, 0, 0, 1946996346, 0, 0, 0, 1723425172, 0, 0, 0, -570095887, 0, 0, 0, 0, 0, 0, 0, -1775237257, 0, 0, 0, 744558318, 0, 0, 0, -1169094247, 0, 0, 0, 432303367, 0, 0, 0, -1879807376, 0, 0, 0, 900031465, 0, 0, 0, -1550490466, 0, 0, 0, 847829774, 0, 0, 0, -1531388807, 0, 0, 0, 518641120, 0, 0, 0, -1998990697, 0, 0, 0, 726447625, 0, 0, 0, -1115901570, 0, 0, 0, 120436967, 0, 0, 0, -1860321392, 0, 0, 0, 1678817053, 0, 0, 0, -232738710, 0, 0, 0, 1215412723, 0, 0, 0, -566116732, 0, 0, 0, 2111101466, 0, 0, 0, -337322643, 0, 0, 0, 1370871028, 0, 0, 0, -947530877, 0, 0, 0, 1452829715, 0, 0, 0, -1062704284, 0, 0, 0, 2063164157, 0, 0, 0, -322345590, 0, 0, 0, 1331429652, 0, 0, 0, -647231901, 0, 0, 0, 1664946170, 0, 0, 0, -183695219, 0, 0, 0, -937398725, 0, 0, 0, 1578133836, 0, 0, 0, -465477419, 0, 0, 0, 1920034722, 0, 0, 0, -773586116, 0, 0, 0, 1205077067, 0, 0, 0, -41611822, 0, 0, 0, 1807026853, 0, 0, 0, -89606859, 0, 0, 0, 1821946434, 0, 0, 0, -691422245, 0, 0, 0, 1090108588, 0, 0, 0, -479406030, 0, 0, 0, 1969020741, 0, 0, 0, -821176612, 0, 0, 0, 1497223595, 0, 0, 0, -1406084826, 0, 0, 0, 973135441, 0, 0, 0, -2142119992, 0, 0, 0, 375509183, 0, 0, 0, -1242254303, 0, 0, 0, 600093526, 0, 0, 0, -1718240561, 0, 0, 0, 262520248, 0, 0, 0, -1632107992, 0, 0, 0, 143131999, 0, 0, 0, -1294398266, 0, 0, 0, 619252657, 0, 0, 0, -2021888209, 0, 0, 0, 290220120, 0, 0, 0, -1424137791, 0, 0, 0, 1026385590, 0, 0, 0, -1874731914, 0, 0, 0, 108124929, 0, 0, 0, -1138699624, 0, 0, 0, 705746415, 0, 0, 0, -1987726991, 0, 0, 0, 532002310, 0, 0, 0, -1511735393, 0, 0, 0, 869578984, 0, 0, 0, -1563883656, 0, 0, 0, 888733711, 0, 0, 0, -1901590122, 0, 0, 0, 412618465, 0, 0, 0, -1156748673, 0, 0, 0, 759000328, 0, 0, 0, -1754504047, 0, 0, 0, 22832102, 0, 0, 0, -195990677, 0, 0, 0, 1650551836, 0, 0, 0, -667916923, 0, 0, 0, 1308648178, 0, 0, 0, -309000596, 0, 0, 0, 2074411291, 0, 0, 0, -1040971646, 0, 0, 0, 1472466933, 0, 0, 0, -958812059, 0, 0, 0, 1357494034, 0, 0, 0, -356991349, 0, 0, 0, 2089335292, 0, 0, 0, -551690910, 0, 0, 0, 1227741717, 0, 0, 0, -209923188, 0, 0, 0, 1699534075, 0, 0, 0, 1482797645, 0, 0, 0, -833505990, 0, 0, 0, 1946205347, 0, 0, 0, -500122668, 0, 0, 0, 1101389642, 0, 0, 0, -678045635, 0, 0, 0, 1841615268, 0, 0, 0, -67840301, 0, 0, 0, 1793681731, 0, 0, 0, -52859340, 0, 0, 0, 1183344557, 0, 0, 0, -793222950, 0, 0, 0, 1932330052, 0, 0, 0, -451083469, 0, 0, 0, 1598818986, 0, 0, 0, -914616867, 0, 0, 0, 1014039888, 0, 0, 0, -1438580185, 0, 0, 0, 269487038, 0, 0, 0, -2044719927, 0, 0, 0, 632645719, 0, 0, 0, -1283100896, 0, 0, 0, 164914873, 0, 0, 0, -1612422706, 0, 0, 0, 251256414, 0, 0, 0, -1731602135, 0, 0, 0, 580440240, 0, 0, 0, -1264003129, 0, 0, 0, 389919577, 0, 0, 0, -2129808338, 0, 0, 0, 995933623, 0, 0, 0, -1385383232, 0, 0, 0, 545503469, 0, 0, 0, -1229733990, 0, 0, 0, 216184323, 0, 0, 0, -1697468044, 0, 0, 0, 961009130, 0, 0, 0, -1351101795, 0, 0, 0, 354867972, 0, 0, 0, -2095653773, 0, 0, 0, 302736355, 0, 0, 0, -2076482412, 0, 0, 0, 1047162125, 0, 0, 0, -1470469510, 0, 0, 0, 198119140, 0, 0, 0, -1644230253, 0, 0, 0, 665714698, 0, 0, 0, -1315043459, 0, 0, 0, 1150488560, 0, 0, 0, -761067385, 0, 0, 0, 1760690462, 0, 0, 0, -20838807, 0, 0, 0, 1566008055, 0, 0, 0, -882416256, 0, 0, 0, 1899392025, 0, 0, 0, -419009682, 0, 0, 0, 1981535486, 0, 0, 0, -533998711, 0, 0, 0, 1518000656, 0, 0, 0, -867508889, 0, 0, 0, 1876933113, 0, 0, 0, -101728626, 0, 0, 0, 1136572183, 0, 0, 0, -712069024, 0, 0, 0, -391915818, 0, 0, 0, 2123616673, 0, 0, 0, -993863624, 0, 0, 0, 1391648591, 0, 0, 0, -244859951, 0, 0, 0, 1733803174, 0, 0, 0, -586762945, 0, 0, 0, 1261875784, 0, 0, 0, -634712616, 0, 0, 0, 1276840623, 0, 0, 0, -162921674, 0, 0, 0, 1618609217, 0, 0, 0, -1007722273, 0, 0, 0, 1440704424, 0, 0, 0, -275878351, 0, 0, 0, 2042521926, 0, 0, 0, -1934401077, 0, 0, 0, 444819132, 0, 0, 0, -1596821723, 0, 0, 0, 920807506, 0, 0, 0, -1787360052, 0, 0, 0, 54987707, 0, 0, 0, -1189739998, 0, 0, 0, 791020885, 0, 0, 0, -1103381819, 0, 0, 0, 671858098, 0, 0, 0, -1839549397, 0, 0, 0, 74101596, 0, 0, 0, -1476405310, 0, 0, 0, 835702965, 0, 0, 0, -1952523988, 0, 0, 0, 497999451, 0, 0, 0, -1329437541, 0, 0, 0, 653419500, 0, 0, 0, -1667011979, 0, 0, 0, 177433858, 0, 0, 0, -1459222116, 0, 0, 0, 1060507371, 0, 0, 0, -2056845454, 0, 0, 0, 324468741, 0, 0, 0, -2109030507, 0, 0, 0, 343587042, 0, 0, 0, -1372868229, 0, 0, 0, 941340172, 0, 0, 0, -1685138798, 0, 0, 0, 230610405, 0, 0, 0, -1209017220, 0, 0, 0, 568318731, 0, 0, 0, -724380794, 0, 0, 0, 1122161905, 0, 0, 0, -122430104, 0, 0, 0, 1854134815, 0, 0, 0, -854147455, 0, 0, 0, 1529264630, 0, 0, 0, -512249745, 0, 0, 0, 2001188632, 0, 0, 0, -430307192, 0, 0, 0, 1885999103, 0, 0, 0, -902101402, 0, 0, 0, 1544225041, 0, 0, 0, -6396529, 0, 0, 0, 1773036280, 0, 0, 0, -738235551, 0, 0, 0, 1171221526, 0, 0, 0, 2028079776, 0, 0, 0, -288223785, 0, 0, 0, 1417872462, 0, 0, 0, -1028455623, 0, 0, 0, 1629906855, 0, 0, 0, -149528368, 0, 0, 0, 1296525641, 0, 0, 0, -612929986, 0, 0, 0, 1248514478, 0, 0, 0, -598026535, 0, 0, 0, 1712054080, 0, 0, 0, -264513481, 0, 0, 0, 1403960489, 0, 0, 0, -979452962, 0, 0, 0, 2144318023, 0, 0, 0, -369117904, 0, 0, 0, 485670333, 0, 0, 0, -1966949686, 0, 0, 0, 814986067, 0, 0, 0, -1499220956, 0, 0, 0, 87478458, 0, 0, 0, -1828268083, 0, 0, 0, 693624404, 0, 0, 0, -1083713245, 0, 0, 0, 779773619, 0, 0, 0, -1203084860, 0, 0, 0, 35350621, 0, 0, 0, -1809092822, 0, 0, 0, 935201716, 0, 0, 0, -1584526141, 0, 0, 0, 467600730, 0, 0, 0, -1913716179, 0, 0, 0, 0, 0, 0, 0, 1093737241, 0, 0, 0, -2107492814, 0, 0, 0, -1017959125, 0, 0, 0, 80047204, 0, 0, 0, 1173649277, 0, 0, 0, -2035852714, 0, 0, 0, -946454193, 0, 0, 0, 143317448, 0, 0, 0, 1237041873, 0, 0, 0, -1964445702, 0, 0, 0, -874908445, 0, 0, 0, 206550444, 0, 0, 0, 1300147893, 0, 0, 0, -1909619810, 0, 0, 0, -820209529, 0, 0, 0, 1360183882, 0, 0, 0, 270784851, 0, 0, 0, -747572104, 0, 0, 0, -1841172639, 0, 0, 0, 1440198190, 0, 0, 0, 350663991, 0, 0, 0, -675964900, 0, 0, 0, -1769700603, 0, 0, 0, 1503140738, 0, 0, 0, 413728923, 0, 0, 0, -604361296, 0, 0, 0, -1697958231, 0, 0, 0, 1566406630, 0, 0, 0, 476867839, 0, 0, 0, -549502508, 0, 0, 0, -1643226419, 0, 0, 0, -1574665067, 0, 0, 0, -485122164, 0, 0, 0, 541504167, 0, 0, 0, 1635232190, 0, 0, 0, -1495144207, 0, 0, 0, -405736472, 0, 0, 0, 612622019, 0, 0, 0, 1706214874, 0, 0, 0, -1431413411, 0, 0, 0, -341883324, 0, 0, 0, 684485487, 0, 0, 0, 1778217078, 0, 0, 0, -1368706759, 0, 0, 0, -279303648, 0, 0, 0, 738789131, 0, 0, 0, 1832393746, 0, 0, 0, -214546721, 0, 0, 0, -1308140090, 0, 0, 0, 1901359341, 0, 0, 0, 811953140, 0, 0, 0, -135058757, 0, 0, 0, -1228787294, 0, 0, 0, 1972444297, 0, 0, 0, 882902928, 0, 0, 0, -71524585, 0, 0, 0, -1165130738, 0, 0, 0, 2044635429, 0, 0, 0, 955232828, 0, 0, 0, -8785037, 0, 0, 0, -1102518166, 0, 0, 0, 2098971969, 0, 0, 0, 1009442392, 0, 0, 0, 89094640, 0, 0, 0, 1149133545, 0, 0, 0, -2027073598, 0, 0, 0, -971221797, 0, 0, 0, 25826708, 0, 0, 0, 1086000781, 0, 0, 0, -2081938522, 0, 0, 0, -1025951553, 0, 0, 0, 231055416, 0, 0, 0, 1291107105, 0, 0, 0, -1884842486, 0, 0, 0, -828994285, 0, 0, 0, 151047260, 0, 0, 0, 1211225925, 0, 0, 0, -1956447634, 0, 0, 0, -900472457, 0, 0, 0, 1415429050, 0, 0, 0, 359440547, 0, 0, 0, -700478072, 0, 0, 0, -1760651631, 0, 0, 0, 1352194014, 0, 0, 0, 296340679, 0, 0, 0, -755310100, 0, 0, 0, -1815348491, 0, 0, 0, 1557619314, 0, 0, 0, 501643627, 0, 0, 0, -558541760, 0, 0, 0, -1618718887, 0, 0, 0, 1477578262, 0, 0, 0, 421729551, 0, 0, 0, -630179804, 0, 0, 0, -1690229955, 0, 0, 0, -1486095003, 0, 0, 0, -430250372, 0, 0, 0, 621398871, 0, 0, 0, 1681444942, 0, 0, 0, -1548840703, 0, 0, 0, -492860904, 0, 0, 0, 567060275, 0, 0, 0, 1627241514, 0, 0, 0, -1344199507, 0, 0, 0, -288342092, 0, 0, 0, 763564703, 0, 0, 0, 1823607174, 0, 0, 0, -1423685431, 0, 0, 0, -367701040, 0, 0, 0, 692485883, 0, 0, 0, 1752655330, 0, 0, 0, -159826129, 0, 0, 0, -1220008906, 0, 0, 0, 1947928861, 0, 0, 0, 891949572, 0, 0, 0, -222538933, 0, 0, 0, -1282586542, 0, 0, 0, 1893623161, 0, 0, 0, 837779040, 0, 0, 0, -17570073, 0, 0, 0, -1077740034, 0, 0, 0, 2089930965, 0, 0, 0, 1033948108, 0, 0, 0, -97088893, 0, 0, 0, -1157131878, 0, 0, 0, 2018819249, 0, 0, 0, 962963368, 0, 0, 0, 1268286267, 0, 0, 0, 178886690, 0, 0, 0, -906316535, 0, 0, 0, -1999917552, 0, 0, 0, 1331556191, 0, 0, 0, 242021446, 0, 0, 0, -851453587, 0, 0, 0, -1945189772, 0, 0, 0, 1125276403, 0, 0, 0, 35865066, 0, 0, 0, -1049596735, 0, 0, 0, -2143193128, 0, 0, 0, 1205286551, 0, 0, 0, 115748238, 0, 0, 0, -977993563, 0, 0, 0, -2071716932, 0, 0, 0, 445268337, 0, 0, 0, 1539005032, 0, 0, 0, -1729595581, 0, 0, 0, -640062374, 0, 0, 0, 508505365, 0, 0, 0, 1602106892, 0, 0, 0, -1674765529, 0, 0, 0, -585367490, 0, 0, 0, 302028985, 0, 0, 0, 1395753888, 0, 0, 0, -1872580981, 0, 0, 0, -783043182, 0, 0, 0, 382072029, 0, 0, 0, 1475669956, 0, 0, 0, -1800944913, 0, 0, 0, -711534090, 0, 0, 0, -373553234, 0, 0, 0, -1467147081, 0, 0, 0, 1809723804, 0, 0, 0, 720317061, 0, 0, 0, -310809654, 0, 0, 0, -1404538669, 0, 0, 0, 1864064504, 0, 0, 0, 774522593, 0, 0, 0, -516497818, 0, 0, 0, -1610103425, 0, 0, 0, 1666508884, 0, 0, 0, 577106765, 0, 0, 0, -437014014, 0, 0, 0, -1530746597, 0, 0, 0, 1737589808, 0, 0, 0, 648060713, 0, 0, 0, -1196505628, 0, 0, 0, -106963203, 0, 0, 0, 986510294, 0, 0, 0, 2080237775, 0, 0, 0, -1133794944, 0, 0, 0, -44387687, 0, 0, 0, 1040818098, 0, 0, 0, 2134410411, 0, 0, 0, -1339810772, 0, 0, 0, -250280139, 0, 0, 0, 843459102, 0, 0, 0, 1937191175, 0, 0, 0, -1260294072, 0, 0, 0, -170890415, 0, 0, 0, 914572922, 0, 0, 0, 2008178019, 0, 0, 0, 1322777291, 0, 0, 0, 266789330, 0, 0, 0, -860500743, 0, 0, 0, -1920673824, 0, 0, 0, 1242732207, 0, 0, 0, 186879414, 0, 0, 0, -932142947, 0, 0, 0, -1992180860, 0, 0, 0, 1180508931, 0, 0, 0, 124532762, 0, 0, 0, -1002498767, 0, 0, 0, -2062676440, 0, 0, 0, 1117278055, 0, 0, 0, 61428862, 0, 0, 0, -1057326763, 0, 0, 0, -2117377460, 0, 0, 0, 533018753, 0, 0, 0, 1593058200, 0, 0, 0, -1649996109, 0, 0, 0, -594143830, 0, 0, 0, 453006565, 0, 0, 0, 1513181180, 0, 0, 0, -1721605417, 0, 0, 0, -665617970, 0, 0, 0, 391110985, 0, 0, 0, 1451162192, 0, 0, 0, -1792157829, 0, 0, 0, -736310174, 0, 0, 0, 327847213, 0, 0, 0, 1388025396, 0, 0, 0, -1847018721, 0, 0, 0, -791044090, 0, 0, 0, -319586722, 0, 0, 0, -1379769017, 0, 0, 0, 1855015020, 0, 0, 0, 799036277, 0, 0, 0, -399109574, 0, 0, 0, -1459156701, 0, 0, 0, 1783899144, 0, 0, 0, 728055569, 0, 0, 0, -461789290, 0, 0, 0, -1521959793, 0, 0, 0, 1713082788, 0, 0, 0, 657099453, 0, 0, 0, -524497934, 0, 0, 0, -1584541461, 0, 0, 0, 1658781120, 0, 0, 0, 602924761, 0, 0, 0, -1109279724, 0, 0, 0, -53434611, 0, 0, 0, 1065585190, 0, 0, 0, 2125631807, 0, 0, 0, -1188769680, 0, 0, 0, -132789399, 0, 0, 0, 994502210, 0, 0, 0, 2054683995, 0, 0, 0, -1251252772, 0, 0, 0, -195395899, 0, 0, 0, 923358190, 0, 0, 0, 1983400183, 0, 0, 0, -1313994312, 0, 0, 0, -258010463, 0, 0, 0, 869023626, 0, 0, 0, 1929192595, 0, 0, 0, 0, 0, 0, 0, 929743361, 0, 0, 0, 1859421187, 0, 0, 0, 1505641986, 0, 0, 0, -592967417, 0, 0, 0, -339555578, 0, 0, 0, -1300460284, 0, 0, 0, -2062135547, 0, 0, 0, -1202646258, 0, 0, 0, -1891905265, 0, 0, 0, -695888115, 0, 0, 0, -504408820, 0, 0, 0, 1694046729, 0, 0, 0, 1402198024, 0, 0, 0, 170761738, 0, 0, 0, 1028086795, 0, 0, 0, 1889740316, 0, 0, 0, 1204413469, 0, 0, 0, 511156767, 0, 0, 0, 689791006, 0, 0, 0, -1408553189, 0, 0, 0, -1688081126, 0, 0, 0, -1025529064, 0, 0, 0, -172660455, 0, 0, 0, -923650798, 0, 0, 0, -6752493, 0, 0, 0, -1507413743, 0, 0, 0, -1857260784, 0, 0, 0, 341457941, 0, 0, 0, 590413332, 0, 0, 0, 2056173590, 0, 0, 0, 1306819095, 0, 0, 0, -532263624, 0, 0, 0, -684945607, 0, 0, 0, -1902982853, 0, 0, 0, -1174926534, 0, 0, 0, 1022247999, 0, 0, 0, 193234494, 0, 0, 0, 1379582012, 0, 0, 0, 1699742269, 0, 0, 0, 1477926454, 0, 0, 0, 1870502967, 0, 0, 0, 918805045, 0, 0, 0, 27858996, 0, 0, 0, -2067835087, 0, 0, 0, -1277848272, 0, 0, 0, -362032334, 0, 0, 0, -587132621, 0, 0, 0, -1864013020, 0, 0, 0, -1483757275, 0, 0, 0, -30281945, 0, 0, 0, -916771546, 0, 0, 0, 1280139811, 0, 0, 0, 2066194466, 0, 0, 0, 580511264, 0, 0, 0, 368256033, 0, 0, 0, 682915882, 0, 0, 0, 534690347, 0, 0, 0, 1180761129, 0, 0, 0, 1896496680, 0, 0, 0, -199462611, 0, 0, 0, -1015631060, 0, 0, 0, -1698106066, 0, 0, 0, -1381877969, 0, 0, 0, -1064461712, 0, 0, 0, -135833487, 0, 0, 0, -1369891213, 0, 0, 0, -1724654478, 0, 0, 0, 472224631, 0, 0, 0, 726618486, 0, 0, 0, 1928402804, 0, 0, 0, 1167840629, 0, 0, 0, 2027719038, 0, 0, 0, 1337346943, 0, 0, 0, 369626493, 0, 0, 0, 560123772, 0, 0, 0, -1535868807, 0, 0, 0, -1826733448, 0, 0, 0, -895482758, 0, 0, 0, -37042565, 0, 0, 0, -1339114388, 0, 0, 0, -2025554323, 0, 0, 0, -554026897, 0, 0, 0, -376374674, 0, 0, 0, 1820767595, 0, 0, 0, 1542223722, 0, 0, 0, 38941032, 0, 0, 0, 892924777, 0, 0, 0, 142585698, 0, 0, 0, 1058368867, 0, 0, 0, 1722493793, 0, 0, 0, 1371662688, 0, 0, 0, -724064667, 0, 0, 0, -474127260, 0, 0, 0, -1174199706, 0, 0, 0, -1922441113, 0, 0, 0, 550229832, 0, 0, 0, 396432713, 0, 0, 0, 1310675787, 0, 0, 0, 2037748042, 0, 0, 0, -60563889, 0, 0, 0, -888595378, 0, 0, 0, -1833477556, 0, 0, 0, -1512204211, 0, 0, 0, -1734687674, 0, 0, 0, -1343224249, 0, 0, 0, -162643899, 0, 0, 0, -1054571964, 0, 0, 0, 1144180033, 0, 0, 0, 1935150912, 0, 0, 0, 719735106, 0, 0, 0, 495749955, 0, 0, 0, 1349054804, 0, 0, 0, 1728197461, 0, 0, 0, 1052538199, 0, 0, 0, 165066582, 0, 0, 0, -1933510573, 0, 0, 0, -1146471854, 0, 0, 0, -501973936, 0, 0, 0, -713114031, 0, 0, 0, -398859686, 0, 0, 0, -548200357, 0, 0, 0, -2031262119, 0, 0, 0, -1316510632, 0, 0, 0, 881978205, 0, 0, 0, 66791772, 0, 0, 0, 1514499934, 0, 0, 0, 1831841119, 0, 0, 0, -2145700383, 0, 0, 0, -1217267744, 0, 0, 0, -288378398, 0, 0, 0, -643468317, 0, 0, 0, 1555250406, 0, 0, 0, 1809448679, 0, 0, 0, 845658341, 0, 0, 0, 84769508, 0, 0, 0, 944383727, 0, 0, 0, 253813998, 0, 0, 0, 1453236972, 0, 0, 0, 1643405549, 0, 0, 0, -454938648, 0, 0, 0, -746000919, 0, 0, 0, -1976128533, 0, 0, 0, -1118017046, 0, 0, 0, -256371715, 0, 0, 0, -942484996, 0, 0, 0, -1637050370, 0, 0, 0, -1459202561, 0, 0, 0, 739252986, 0, 0, 0, 461035771, 0, 0, 0, 1120182009, 0, 0, 0, 1974361336, 0, 0, 0, 1223229683, 0, 0, 0, 2139341554, 0, 0, 0, 641565936, 0, 0, 0, 290932465, 0, 0, 0, -1807676940, 0, 0, 0, -1557410827, 0, 0, 0, -90862089, 0, 0, 0, -838905866, 0, 0, 0, 1616738521, 0, 0, 0, 1463270104, 0, 0, 0, 243924186, 0, 0, 0, 971194075, 0, 0, 0, -1124765218, 0, 0, 0, -1952468001, 0, 0, 0, -769526307, 0, 0, 0, -448055332, 0, 0, 0, -670274601, 0, 0, 0, -278484522, 0, 0, 0, -1227296812, 0, 0, 0, -2119029291, 0, 0, 0, 77882064, 0, 0, 0, 869179601, 0, 0, 0, 1785784019, 0, 0, 0, 1561994450, 0, 0, 0, 285105861, 0, 0, 0, 664050884, 0, 0, 0, 2116737734, 0, 0, 0, 1228937415, 0, 0, 0, -866756670, 0, 0, 0, -79915581, 0, 0, 0, -1568484415, 0, 0, 0, -1779953216, 0, 0, 0, -1464906293, 0, 0, 0, -1614442550, 0, 0, 0, -964965944, 0, 0, 0, -250541111, 0, 0, 0, 1946633420, 0, 0, 0, 1131251405, 0, 0, 0, 450085071, 0, 0, 0, 767099598, 0, 0, 0, 1083617169, 0, 0, 0, 2013031824, 0, 0, 0, 776088466, 0, 0, 0, 422111635, 0, 0, 0, -1673615722, 0, 0, 0, -1420532585, 0, 0, 0, -219536747, 0, 0, 0, -981409644, 0, 0, 0, -121127777, 0, 0, 0, -810713442, 0, 0, 0, -1777125220, 0, 0, 0, -1585841507, 0, 0, 0, 611300760, 0, 0, 0, 319125401, 0, 0, 0, 1253781915, 0, 0, 0, 2110911386, 0, 0, 0, 808814989, 0, 0, 0, 123685772, 0, 0, 0, 1591807374, 0, 0, 0, 1770770319, 0, 0, 0, -325222262, 0, 0, 0, -604552565, 0, 0, 0, -2109143927, 0, 0, 0, -1255946616, 0, 0, 0, -2006672765, 0, 0, 0, -1089578878, 0, 0, 0, -424665472, 0, 0, 0, -774185855, 0, 0, 0, 1422693252, 0, 0, 0, 1671844229, 0, 0, 0, 974657415, 0, 0, 0, 225629574, 0, 0, 0, -1596923223, 0, 0, 0, -1749409624, 0, 0, 0, -838572374, 0, 0, 0, -110189397, 0, 0, 0, 2088299438, 0, 0, 0, 1259481519, 0, 0, 0, 313290669, 0, 0, 0, 633777580, 0, 0, 0, 411169191, 0, 0, 0, 803943334, 0, 0, 0, 1985312164, 0, 0, 0, 1094694821, 0, 0, 0, -1003882336, 0, 0, 0, -213697887, 0, 0, 0, -1426228061, 0, 0, 0, -1650999646, 0, 0, 0, -797719371, 0, 0, 0, -417790284, 0, 0, 0, -1096335178, 0, 0, 0, -1983020361, 0, 0, 0, 215731634, 0, 0, 0, 1001459635, 0, 0, 0, 1645169073, 0, 0, 0, 1432718256, 0, 0, 0, 1747113915, 0, 0, 0, 1598559674, 0, 0, 0, 116806584, 0, 0, 0, 832344505, 0, 0, 0, -1265967428, 0, 0, 0, -2082464579, 0, 0, 0, -631350593, 0, 0, 0, -315320130, 0, 0, 0, 0, 0, 0, 0, 1701297336, 0, 0, 0, -1949824598, 0, 0, 0, -290474734, 0, 0, 0, 1469538959, 0, 0, 0, 854646327, 0, 0, 0, -597726427, 0, 0, 0, -1187457123, 0, 0, 0, -282544955, 0, 0, 0, -1974531971, 0, 0, 0, 1692450159, 0, 0, 0, 25625047, 0, 0, 0, -1195387318, 0, 0, 0, -573019406, 0, 0, 0, 863494112, 0, 0, 0, 1443914584, 0, 0, 0, -1621681840, 0, 0, 0, -97475096, 0, 0, 0, 345968890, 0, 0, 0, 1912122434, 0, 0, 0, -926909473, 0, 0, 0, -1381513369, 0, 0, 0, 1124627061, 0, 0, 0, 644861645, 0, 0, 0, 1887415701, 0, 0, 0, 353898797, 0, 0, 0, -71850945, 0, 0, 0, -1630529401, 0, 0, 0, 669568794, 0, 0, 0, 1116697506, 0, 0, 0, -1407138128, 0, 0, 0, -918062584, 0, 0, 0, 1051669152, 0, 0, 0, 1539870232, 0, 0, 0, -1251525878, 0, 0, 0, -805271630, 0, 0, 0, 1765298223, 0, 0, 0, 207613079, 0, 0, 0, -487564923, 0, 0, 0, -2020088515, 0, 0, 0, -779647387, 0, 0, 0, -1260373283, 0, 0, 0, 1515163599, 0, 0, 0, 1059599223, 0, 0, 0, -2045713174, 0, 0, 0, -478717870, 0, 0, 0, 232320320, 0, 0, 0, 1757368824, 0, 0, 0, -1577571344, 0, 0, 0, -996174008, 0, 0, 0, 707797594, 0, 0, 0, 1331142370, 0, 0, 0, -160478849, 0, 0, 0, -1828129337, 0, 0, 0, 2108113109, 0, 0, 0, 415300717, 0, 0, 0, 1322295093, 0, 0, 0, 733422477, 0, 0, 0, -988244321, 0, 0, 0, -1602278873, 0, 0, 0, 424148410, 0, 0, 0, 2082488578, 0, 0, 0, -1836059632, 0, 0, 0, -135771992, 0, 0, 0, 1029182619, 0, 0, 0, 1480566819, 0, 0, 0, -1232069327, 0, 0, 0, -738745975, 0, 0, 0, 1791981076, 0, 0, 0, 262720172, 0, 0, 0, -519602242, 0, 0, 0, -2074033402, 0, 0, 0, -764370850, 0, 0, 0, -1223222042, 0, 0, 0, 1505274356, 0, 0, 0, 1021252940, 0, 0, 0, -2048408879, 0, 0, 0, -528449943, 0, 0, 0, 238013307, 0, 0, 0, 1799911363, 0, 0, 0, -1576071733, 0, 0, 0, -949440141, 0, 0, 0, 700908641, 0, 0, 0, 1285601497, 0, 0, 0, -174559420, 0, 0, 0, -1862282244, 0, 0, 0, 2119198446, 0, 0, 0, 456645206, 0, 0, 0, 1294448910, 0, 0, 0, 675284406, 0, 0, 0, -957370204, 0, 0, 0, -1551365092, 0, 0, 0, 447798145, 0, 0, 0, 2144823097, 0, 0, 0, -1854352853, 0, 0, 0, -199266669, 0, 0, 0, 66528827, 0, 0, 0, 1720752771, 0, 0, 0, -2009124975, 0, 0, 0, -312962263, 0, 0, 0, 1415595188, 0, 0, 0, 822605836, 0, 0, 0, -542618338, 0, 0, 0, -1160777306, 0, 0, 0, -320892162, 0, 0, 0, -1984418234, 0, 0, 0, 1729600340, 0, 0, 0, 40904684, 0, 0, 0, -1152847759, 0, 0, 0, -567325495, 0, 0, 0, 813758939, 0, 0, 0, 1441219939, 0, 0, 0, -1667219605, 0, 0, 0, -104365101, 0, 0, 0, 392705729, 0, 0, 0, 1913621113, 0, 0, 0, -885563932, 0, 0, 0, -1370431140, 0, 0, 0, 1090475086, 0, 0, 0, 630778102, 0, 0, 0, 1938328494, 0, 0, 0, 384775958, 0, 0, 0, -129990140, 0, 0, 0, -1658372420, 0, 0, 0, 606071073, 0, 0, 0, 1098405273, 0, 0, 0, -1344806773, 0, 0, 0, -894411725, 0, 0, 0, 1001806317, 0, 0, 0, 1590814037, 0, 0, 0, -1333899193, 0, 0, 0, -719721217, 0, 0, 0, 1814117218, 0, 0, 0, 155617242, 0, 0, 0, -404147512, 0, 0, 0, -2104586640, 0, 0, 0, -727782104, 0, 0, 0, -1309060720, 0, 0, 0, 1599530114, 0, 0, 0, 976312378, 0, 0, 0, -2096525401, 0, 0, 0, -428985569, 0, 0, 0, 146900493, 0, 0, 0, 1839610549, 0, 0, 0, -1528741699, 0, 0, 0, -1048118267, 0, 0, 0, 791234839, 0, 0, 0, 1246688687, 0, 0, 0, -210361806, 0, 0, 0, -1777230198, 0, 0, 0, 2025728920, 0, 0, 0, 500799264, 0, 0, 0, 1271526520, 0, 0, 0, 783173824, 0, 0, 0, -1073611310, 0, 0, 0, -1520025238, 0, 0, 0, 475961079, 0, 0, 0, 2033789519, 0, 0, 0, -1751736483, 0, 0, 0, -219077659, 0, 0, 0, 85551949, 0, 0, 0, 1618925557, 0, 0, 0, -1898880281, 0, 0, 0, -340337057, 0, 0, 0, 1385040322, 0, 0, 0, 938063226, 0, 0, 0, -649723800, 0, 0, 0, -1138639664, 0, 0, 0, -365830264, 0, 0, 0, -1890163920, 0, 0, 0, 1643763234, 0, 0, 0, 77490842, 0, 0, 0, -1113146105, 0, 0, 0, -658439745, 0, 0, 0, 913224877, 0, 0, 0, 1393100821, 0, 0, 0, -1706135011, 0, 0, 0, -14037339, 0, 0, 0, 294026167, 0, 0, 0, 1960953615, 0, 0, 0, -841412462, 0, 0, 0, -1463899094, 0, 0, 0, 1175525688, 0, 0, 0, 594978176, 0, 0, 0, 1969669848, 0, 0, 0, 268532320, 0, 0, 0, -22098062, 0, 0, 0, -1681296438, 0, 0, 0, 586261591, 0, 0, 0, 1201019119, 0, 0, 0, -1455837699, 0, 0, 0, -866250427, 0, 0, 0, 116280694, 0, 0, 0, 1669984718, 0, 0, 0, -1926871844, 0, 0, 0, -398329756, 0, 0, 0, 1366896633, 0, 0, 0, 874419009, 0, 0, 0, -625924525, 0, 0, 0, -1076454677, 0, 0, 0, -372835917, 0, 0, 0, -1935588085, 0, 0, 0, 1645146137, 0, 0, 0, 124341409, 0, 0, 0, -1101948100, 0, 0, 0, -617207932, 0, 0, 0, 899256982, 0, 0, 0, 1358835246, 0, 0, 0, -1715907546, 0, 0, 0, -52500322, 0, 0, 0, 309419404, 0, 0, 0, 1997988148, 0, 0, 0, -835832151, 0, 0, 0, -1421243887, 0, 0, 0, 1172717315, 0, 0, 0, 545358779, 0, 0, 0, 1989271779, 0, 0, 0, 334912603, 0, 0, 0, -44439223, 0, 0, 0, -1740745231, 0, 0, 0, 554074732, 0, 0, 0, 1147223764, 0, 0, 0, -1429304378, 0, 0, 0, -810993794, 0, 0, 0, 943816662, 0, 0, 0, 1562821486, 0, 0, 0, -1282836868, 0, 0, 0, -688993596, 0, 0, 0, 1876303193, 0, 0, 0, 179413473, 0, 0, 0, -467790605, 0, 0, 0, -2122733493, 0, 0, 0, -680932589, 0, 0, 0, -1307674709, 0, 0, 0, 1554105017, 0, 0, 0, 969309697, 0, 0, 0, -2130794084, 0, 0, 0, -442952412, 0, 0, 0, 188129334, 0, 0, 0, 1850809486, 0, 0, 0, -1491704186, 0, 0, 0, -1032725954, 0, 0, 0, 752774956, 0, 0, 0, 1236915092, 0, 0, 0, -259980279, 0, 0, 0, -1780041551, 0, 0, 0, 2068385187, 0, 0, 0, 506376475, 0, 0, 0, 1212076611, 0, 0, 0, 760835835, 0, 0, 0, -1007232023, 0, 0, 0, -1500420271, 0, 0, 0, 531214540, 0, 0, 0, 2060323956, 0, 0, 0, -1805534874, 0, 0, 0, -251263522, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str7601=allocate([49,46,50,46,51,0] /* 1.2.3\00 */, "i8", ALLOC_STATIC);
_inflate_order=allocate([16, 0, 17, 0, 18, 0, 0, 0, 8, 0, 7, 0, 9, 0, 6, 0, 10, 0, 5, 0, 11, 0, 4, 0, 12, 0, 3, 0, 13, 0, 2, 0, 14, 0, 1, 0, 15, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
STRING_TABLE.__str17602=allocate([105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0] /* incorrect header che */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27603=allocate([117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0] /* unknown compression  */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37604=allocate([105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0] /* invalid window size\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47605=allocate([117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0] /* unknown header flags */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57606=allocate([104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0] /* header crc mismatch\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67607=allocate([105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0] /* invalid block type\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77608=allocate([105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0] /* invalid stored block */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87609=allocate([116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0] /* too many length or d */, "i8", ALLOC_STATIC);
STRING_TABLE.__str97610=allocate([105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0] /* invalid code lengths */, "i8", ALLOC_STATIC);
STRING_TABLE.__str107611=allocate([105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0] /* invalid bit length r */, "i8", ALLOC_STATIC);
STRING_TABLE.__str117612=allocate([105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0] /* invalid literal/leng */, "i8", ALLOC_STATIC);
STRING_TABLE.__str127613=allocate([105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0] /* invalid distances se */, "i8", ALLOC_STATIC);
STRING_TABLE.__str137614=allocate([105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0] /* invalid literal/leng */, "i8", ALLOC_STATIC);
STRING_TABLE.__str147615=allocate([105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0] /* invalid distance cod */, "i8", ALLOC_STATIC);
STRING_TABLE.__str157616=allocate([105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0] /* invalid distance too */, "i8", ALLOC_STATIC);
STRING_TABLE.__str167617=allocate([105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0] /* incorrect data check */, "i8", ALLOC_STATIC);
STRING_TABLE.__str177618=allocate([105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0] /* incorrect length che */, "i8", ALLOC_STATIC);
_fixedtables_lenfix=allocate([96, 7, 0, 0, 0, 8, 80, 0, 0, 8, 16, 0, 20, 8, 115, 0, 18, 7, 31, 0, 0, 8, 112, 0, 0, 8, 48, 0, 0, 9, 192, 0, 16, 7, 10, 0, 0, 8, 96, 0, 0, 8, 32, 0, 0, 9, 160, 0, 0, 8, 0, 0, 0, 8, 128, 0, 0, 8, 64, 0, 0, 9, 224, 0, 16, 7, 6, 0, 0, 8, 88, 0, 0, 8, 24, 0, 0, 9, 144, 0, 19, 7, 59, 0, 0, 8, 120, 0, 0, 8, 56, 0, 0, 9, 208, 0, 17, 7, 17, 0, 0, 8, 104, 0, 0, 8, 40, 0, 0, 9, 176, 0, 0, 8, 8, 0, 0, 8, 136, 0, 0, 8, 72, 0, 0, 9, 240, 0, 16, 7, 4, 0, 0, 8, 84, 0, 0, 8, 20, 0, 21, 8, 227, 0, 19, 7, 43, 0, 0, 8, 116, 0, 0, 8, 52, 0, 0, 9, 200, 0, 17, 7, 13, 0, 0, 8, 100, 0, 0, 8, 36, 0, 0, 9, 168, 0, 0, 8, 4, 0, 0, 8, 132, 0, 0, 8, 68, 0, 0, 9, 232, 0, 16, 7, 8, 0, 0, 8, 92, 0, 0, 8, 28, 0, 0, 9, 152, 0, 20, 7, 83, 0, 0, 8, 124, 0, 0, 8, 60, 0, 0, 9, 216, 0, 18, 7, 23, 0, 0, 8, 108, 0, 0, 8, 44, 0, 0, 9, 184, 0, 0, 8, 12, 0, 0, 8, 140, 0, 0, 8, 76, 0, 0, 9, 248, 0, 16, 7, 3, 0, 0, 8, 82, 0, 0, 8, 18, 0, 21, 8, 163, 0, 19, 7, 35, 0, 0, 8, 114, 0, 0, 8, 50, 0, 0, 9, 196, 0, 17, 7, 11, 0, 0, 8, 98, 0, 0, 8, 34, 0, 0, 9, 164, 0, 0, 8, 2, 0, 0, 8, 130, 0, 0, 8, 66, 0, 0, 9, 228, 0, 16, 7, 7, 0, 0, 8, 90, 0, 0, 8, 26, 0, 0, 9, 148, 0, 20, 7, 67, 0, 0, 8, 122, 0, 0, 8, 58, 0, 0, 9, 212, 0, 18, 7, 19, 0, 0, 8, 106, 0, 0, 8, 42, 0, 0, 9, 180, 0, 0, 8, 10, 0, 0, 8, 138, 0, 0, 8, 74, 0, 0, 9, 244, 0, 16, 7, 5, 0, 0, 8, 86, 0, 0, 8, 22, 0, 64, 8, 0, 0, 19, 7, 51, 0, 0, 8, 118, 0, 0, 8, 54, 0, 0, 9, 204, 0, 17, 7, 15, 0, 0, 8, 102, 0, 0, 8, 38, 0, 0, 9, 172, 0, 0, 8, 6, 0, 0, 8, 134, 0, 0, 8, 70, 0, 0, 9, 236, 0, 16, 7, 9, 0, 0, 8, 94, 0, 0, 8, 30, 0, 0, 9, 156, 0, 20, 7, 99, 0, 0, 8, 126, 0, 0, 8, 62, 0, 0, 9, 220, 0, 18, 7, 27, 0, 0, 8, 110, 0, 0, 8, 46, 0, 0, 9, 188, 0, 0, 8, 14, 0, 0, 8, 142, 0, 0, 8, 78, 0, 0, 9, 252, 0, 96, 7, 0, 0, 0, 8, 81, 0, 0, 8, 17, 0, 21, 8, 131, 0, 18, 7, 31, 0, 0, 8, 113, 0, 0, 8, 49, 0, 0, 9, 194, 0, 16, 7, 10, 0, 0, 8, 97, 0, 0, 8, 33, 0, 0, 9, 162, 0, 0, 8, 1, 0, 0, 8, 129, 0, 0, 8, 65, 0, 0, 9, 226, 0, 16, 7, 6, 0, 0, 8, 89, 0, 0, 8, 25, 0, 0, 9, 146, 0, 19, 7, 59, 0, 0, 8, 121, 0, 0, 8, 57, 0, 0, 9, 210, 0, 17, 7, 17, 0, 0, 8, 105, 0, 0, 8, 41, 0, 0, 9, 178, 0, 0, 8, 9, 0, 0, 8, 137, 0, 0, 8, 73, 0, 0, 9, 242, 0, 16, 7, 4, 0, 0, 8, 85, 0, 0, 8, 21, 0, 16, 8, 258, 0, 19, 7, 43, 0, 0, 8, 117, 0, 0, 8, 53, 0, 0, 9, 202, 0, 17, 7, 13, 0, 0, 8, 101, 0, 0, 8, 37, 0, 0, 9, 170, 0, 0, 8, 5, 0, 0, 8, 133, 0, 0, 8, 69, 0, 0, 9, 234, 0, 16, 7, 8, 0, 0, 8, 93, 0, 0, 8, 29, 0, 0, 9, 154, 0, 20, 7, 83, 0, 0, 8, 125, 0, 0, 8, 61, 0, 0, 9, 218, 0, 18, 7, 23, 0, 0, 8, 109, 0, 0, 8, 45, 0, 0, 9, 186, 0, 0, 8, 13, 0, 0, 8, 141, 0, 0, 8, 77, 0, 0, 9, 250, 0, 16, 7, 3, 0, 0, 8, 83, 0, 0, 8, 19, 0, 21, 8, 195, 0, 19, 7, 35, 0, 0, 8, 115, 0, 0, 8, 51, 0, 0, 9, 198, 0, 17, 7, 11, 0, 0, 8, 99, 0, 0, 8, 35, 0, 0, 9, 166, 0, 0, 8, 3, 0, 0, 8, 131, 0, 0, 8, 67, 0, 0, 9, 230, 0, 16, 7, 7, 0, 0, 8, 91, 0, 0, 8, 27, 0, 0, 9, 150, 0, 20, 7, 67, 0, 0, 8, 123, 0, 0, 8, 59, 0, 0, 9, 214, 0, 18, 7, 19, 0, 0, 8, 107, 0, 0, 8, 43, 0, 0, 9, 182, 0, 0, 8, 11, 0, 0, 8, 139, 0, 0, 8, 75, 0, 0, 9, 246, 0, 16, 7, 5, 0, 0, 8, 87, 0, 0, 8, 23, 0, 64, 8, 0, 0, 19, 7, 51, 0, 0, 8, 119, 0, 0, 8, 55, 0, 0, 9, 206, 0, 17, 7, 15, 0, 0, 8, 103, 0, 0, 8, 39, 0, 0, 9, 174, 0, 0, 8, 7, 0, 0, 8, 135, 0, 0, 8, 71, 0, 0, 9, 238, 0, 16, 7, 9, 0, 0, 8, 95, 0, 0, 8, 31, 0, 0, 9, 158, 0, 20, 7, 99, 0, 0, 8, 127, 0, 0, 8, 63, 0, 0, 9, 222, 0, 18, 7, 27, 0, 0, 8, 111, 0, 0, 8, 47, 0, 0, 9, 190, 0, 0, 8, 15, 0, 0, 8, 143, 0, 0, 8, 79, 0, 0, 9, 254, 0, 96, 7, 0, 0, 0, 8, 80, 0, 0, 8, 16, 0, 20, 8, 115, 0, 18, 7, 31, 0, 0, 8, 112, 0, 0, 8, 48, 0, 0, 9, 193, 0, 16, 7, 10, 0, 0, 8, 96, 0, 0, 8, 32, 0, 0, 9, 161, 0, 0, 8, 0, 0, 0, 8, 128, 0, 0, 8, 64, 0, 0, 9, 225, 0, 16, 7, 6, 0, 0, 8, 88, 0, 0, 8, 24, 0, 0, 9, 145, 0, 19, 7, 59, 0, 0, 8, 120, 0, 0, 8, 56, 0, 0, 9, 209, 0, 17, 7, 17, 0, 0, 8, 104, 0, 0, 8, 40, 0, 0, 9, 177, 0, 0, 8, 8, 0, 0, 8, 136, 0, 0, 8, 72, 0, 0, 9, 241, 0, 16, 7, 4, 0, 0, 8, 84, 0, 0, 8, 20, 0, 21, 8, 227, 0, 19, 7, 43, 0, 0, 8, 116, 0, 0, 8, 52, 0, 0, 9, 201, 0, 17, 7, 13, 0, 0, 8, 100, 0, 0, 8, 36, 0, 0, 9, 169, 0, 0, 8, 4, 0, 0, 8, 132, 0, 0, 8, 68, 0, 0, 9, 233, 0, 16, 7, 8, 0, 0, 8, 92, 0, 0, 8, 28, 0, 0, 9, 153, 0, 20, 7, 83, 0, 0, 8, 124, 0, 0, 8, 60, 0, 0, 9, 217, 0, 18, 7, 23, 0, 0, 8, 108, 0, 0, 8, 44, 0, 0, 9, 185, 0, 0, 8, 12, 0, 0, 8, 140, 0, 0, 8, 76, 0, 0, 9, 249, 0, 16, 7, 3, 0, 0, 8, 82, 0, 0, 8, 18, 0, 21, 8, 163, 0, 19, 7, 35, 0, 0, 8, 114, 0, 0, 8, 50, 0, 0, 9, 197, 0, 17, 7, 11, 0, 0, 8, 98, 0, 0, 8, 34, 0, 0, 9, 165, 0, 0, 8, 2, 0, 0, 8, 130, 0, 0, 8, 66, 0, 0, 9, 229, 0, 16, 7, 7, 0, 0, 8, 90, 0, 0, 8, 26, 0, 0, 9, 149, 0, 20, 7, 67, 0, 0, 8, 122, 0, 0, 8, 58, 0, 0, 9, 213, 0, 18, 7, 19, 0, 0, 8, 106, 0, 0, 8, 42, 0, 0, 9, 181, 0, 0, 8, 10, 0, 0, 8, 138, 0, 0, 8, 74, 0, 0, 9, 245, 0, 16, 7, 5, 0, 0, 8, 86, 0, 0, 8, 22, 0, 64, 8, 0, 0, 19, 7, 51, 0, 0, 8, 118, 0, 0, 8, 54, 0, 0, 9, 205, 0, 17, 7, 15, 0, 0, 8, 102, 0, 0, 8, 38, 0, 0, 9, 173, 0, 0, 8, 6, 0, 0, 8, 134, 0, 0, 8, 70, 0, 0, 9, 237, 0, 16, 7, 9, 0, 0, 8, 94, 0, 0, 8, 30, 0, 0, 9, 157, 0, 20, 7, 99, 0, 0, 8, 126, 0, 0, 8, 62, 0, 0, 9, 221, 0, 18, 7, 27, 0, 0, 8, 110, 0, 0, 8, 46, 0, 0, 9, 189, 0, 0, 8, 14, 0, 0, 8, 142, 0, 0, 8, 78, 0, 0, 9, 253, 0, 96, 7, 0, 0, 0, 8, 81, 0, 0, 8, 17, 0, 21, 8, 131, 0, 18, 7, 31, 0, 0, 8, 113, 0, 0, 8, 49, 0, 0, 9, 195, 0, 16, 7, 10, 0, 0, 8, 97, 0, 0, 8, 33, 0, 0, 9, 163, 0, 0, 8, 1, 0, 0, 8, 129, 0, 0, 8, 65, 0, 0, 9, 227, 0, 16, 7, 6, 0, 0, 8, 89, 0, 0, 8, 25, 0, 0, 9, 147, 0, 19, 7, 59, 0, 0, 8, 121, 0, 0, 8, 57, 0, 0, 9, 211, 0, 17, 7, 17, 0, 0, 8, 105, 0, 0, 8, 41, 0, 0, 9, 179, 0, 0, 8, 9, 0, 0, 8, 137, 0, 0, 8, 73, 0, 0, 9, 243, 0, 16, 7, 4, 0, 0, 8, 85, 0, 0, 8, 21, 0, 16, 8, 258, 0, 19, 7, 43, 0, 0, 8, 117, 0, 0, 8, 53, 0, 0, 9, 203, 0, 17, 7, 13, 0, 0, 8, 101, 0, 0, 8, 37, 0, 0, 9, 171, 0, 0, 8, 5, 0, 0, 8, 133, 0, 0, 8, 69, 0, 0, 9, 235, 0, 16, 7, 8, 0, 0, 8, 93, 0, 0, 8, 29, 0, 0, 9, 155, 0, 20, 7, 83, 0, 0, 8, 125, 0, 0, 8, 61, 0, 0, 9, 219, 0, 18, 7, 23, 0, 0, 8, 109, 0, 0, 8, 45, 0, 0, 9, 187, 0, 0, 8, 13, 0, 0, 8, 141, 0, 0, 8, 77, 0, 0, 9, 251, 0, 16, 7, 3, 0, 0, 8, 83, 0, 0, 8, 19, 0, 21, 8, 195, 0, 19, 7, 35, 0, 0, 8, 115, 0, 0, 8, 51, 0, 0, 9, 199, 0, 17, 7, 11, 0, 0, 8, 99, 0, 0, 8, 35, 0, 0, 9, 167, 0, 0, 8, 3, 0, 0, 8, 131, 0, 0, 8, 67, 0, 0, 9, 231, 0, 16, 7, 7, 0, 0, 8, 91, 0, 0, 8, 27, 0, 0, 9, 151, 0, 20, 7, 67, 0, 0, 8, 123, 0, 0, 8, 59, 0, 0, 9, 215, 0, 18, 7, 19, 0, 0, 8, 107, 0, 0, 8, 43, 0, 0, 9, 183, 0, 0, 8, 11, 0, 0, 8, 139, 0, 0, 8, 75, 0, 0, 9, 247, 0, 16, 7, 5, 0, 0, 8, 87, 0, 0, 8, 23, 0, 64, 8, 0, 0, 19, 7, 51, 0, 0, 8, 119, 0, 0, 8, 55, 0, 0, 9, 207, 0, 17, 7, 15, 0, 0, 8, 103, 0, 0, 8, 39, 0, 0, 9, 175, 0, 0, 8, 7, 0, 0, 8, 135, 0, 0, 8, 71, 0, 0, 9, 239, 0, 16, 7, 9, 0, 0, 8, 95, 0, 0, 8, 31, 0, 0, 9, 159, 0, 20, 7, 99, 0, 0, 8, 127, 0, 0, 8, 63, 0, 0, 9, 223, 0, 18, 7, 27, 0, 0, 8, 111, 0, 0, 8, 47, 0, 0, 9, 191, 0, 0, 8, 15, 0, 0, 8, 143, 0, 0, 8, 79, 0, 0, 9, 255, 0], ["i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0], ALLOC_STATIC);
_fixedtables_distfix=allocate([16, 5, 1, 0, 23, 5, 257, 0, 19, 5, 17, 0, 27, 5, 4097, 0, 17, 5, 5, 0, 25, 5, 1025, 0, 21, 5, 65, 0, 29, 5, 16385, 0, 16, 5, 3, 0, 24, 5, 513, 0, 20, 5, 33, 0, 28, 5, 8193, 0, 18, 5, 9, 0, 26, 5, 2049, 0, 22, 5, 129, 0, 64, 5, 0, 0, 16, 5, 2, 0, 23, 5, 385, 0, 19, 5, 25, 0, 27, 5, 6145, 0, 17, 5, 7, 0, 25, 5, 1537, 0, 21, 5, 97, 0, 29, 5, 24577, 0, 16, 5, 4, 0, 24, 5, 769, 0, 20, 5, 49, 0, 28, 5, 12289, 0, 18, 5, 13, 0, 26, 5, 3073, 0, 22, 5, 193, 0, 64, 5, 0, 0], ["i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0,"i8","i8","i16",0], ALLOC_STATIC);
STRING_TABLE._deflateInit2__my_version=allocate([49,46,50,46,51,0] /* 1.2.3\00 */, "i8", ALLOC_STATIC);
_configuration_table=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8000, 0, 0, 0, 4, 0, 4, 0, 8, 0, 4, 0, 8002, 0, 0, 0, 4, 0, 5, 0, 16, 0, 8, 0, 8002, 0, 0, 0, 4, 0, 6, 0, 32, 0, 32, 0, 8002, 0, 0, 0, 4, 0, 4, 0, 16, 0, 16, 0, 8004, 0, 0, 0, 8, 0, 16, 0, 32, 0, 32, 0, 8004, 0, 0, 0, 8, 0, 16, 0, 128, 0, 128, 0, 8004, 0, 0, 0, 8, 0, 32, 0, 128, 0, 256, 0, 8004, 0, 0, 0, 32, 0, 128, 0, 258, 0, 1024, 0, 8004, 0, 0, 0, 32, 0, 258, 0, 258, 0, 4096, 0, 8004, 0, 0, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0,"i16",0,"i16",0,"i16",0,"i16",0,"*",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str7639=allocate([105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0] /* invalid distance too */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17640=allocate([105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0] /* invalid distance cod */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27641=allocate([105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0] /* invalid literal/leng */, "i8", ALLOC_STATIC);
_inflate_table_lbase=allocate([3, 0, 4, 0, 5, 0, 6, 0, 7, 0, 8, 0, 9, 0, 10, 0, 11, 0, 13, 0, 15, 0, 17, 0, 19, 0, 23, 0, 27, 0, 31, 0, 35, 0, 43, 0, 51, 0, 59, 0, 67, 0, 83, 0, 99, 0, 115, 0, 131, 0, 163, 0, 195, 0, 227, 0, 258, 0, 0, 0, 0, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
_inflate_table_lext=allocate([16, 0, 16, 0, 16, 0, 16, 0, 16, 0, 16, 0, 16, 0, 16, 0, 17, 0, 17, 0, 17, 0, 17, 0, 18, 0, 18, 0, 18, 0, 18, 0, 19, 0, 19, 0, 19, 0, 19, 0, 20, 0, 20, 0, 20, 0, 20, 0, 21, 0, 21, 0, 21, 0, 21, 0, 16, 0, 201, 0, 196, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
_inflate_table_dbase=allocate([1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 7, 0, 9, 0, 13, 0, 17, 0, 25, 0, 33, 0, 49, 0, 65, 0, 97, 0, 129, 0, 193, 0, 257, 0, 385, 0, 513, 0, 769, 0, 1025, 0, 1537, 0, 2049, 0, 3073, 0, 4097, 0, 6145, 0, 8193, 0, 12289, 0, 16385, 0, 24577, 0, 0, 0, 0, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
_inflate_table_dext=allocate([16, 0, 16, 0, 16, 0, 16, 0, 17, 0, 17, 0, 18, 0, 18, 0, 19, 0, 19, 0, 20, 0, 20, 0, 21, 0, 21, 0, 22, 0, 22, 0, 23, 0, 23, 0, 24, 0, 24, 0, 25, 0, 25, 0, 26, 0, 26, 0, 27, 0, 27, 0, 28, 0, 28, 0, 29, 0, 29, 0, 64, 0, 64, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
STRING_TABLE.__str7646=allocate([110,101,101,100,32,100,105,99,116,105,111,110,97,114,121,0] /* need dictionary\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17647=allocate([115,116,114,101,97,109,32,101,110,100,0] /* stream end\00 */, "i8", ALLOC_STATIC);
__str27648=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__str37649=allocate([102,105,108,101,32,101,114,114,111,114,0] /* file error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str47650=allocate([115,116,114,101,97,109,32,101,114,114,111,114,0] /* stream error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str57651=allocate([100,97,116,97,32,101,114,114,111,114,0] /* data error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str67652=allocate([105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0] /* insufficient memory\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str77653=allocate([98,117,102,102,101,114,32,101,114,114,111,114,0] /* buffer error\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str87654=allocate([105,110,99,111,109,112,97,116,105,98,108,101,32,118,101,114,115,105,111,110,0] /* incompatible version */, "i8", ALLOC_STATIC);
_z_errmsg=allocate(40, "*", ALLOC_STATIC);
STRING_TABLE.__dist_code=allocate([0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0,0,16,17,18,18,19,19,20,20,20,20,21,21,21,21,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29] /* \00\01\02\03\04\04\0 */, "i8", ALLOC_STATIC);
STRING_TABLE.__length_code=allocate([0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28] /* \00\01\02\03\04\05\0 */, "i8", ALLOC_STATIC);
_static_l_desc=allocate([0, 0, 0, 0, 0, 0, 0, 0, 257, 0, 0, 0, 286, 0, 0, 0, 15, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_static_d_desc=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 15, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_static_bl_desc=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 0, 0, 0, 7, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_static_ltree=allocate([12, 0, 8, 0, 140, 0, 8, 0, 76, 0, 8, 0, 204, 0, 8, 0, 44, 0, 8, 0, 172, 0, 8, 0, 108, 0, 8, 0, 236, 0, 8, 0, 28, 0, 8, 0, 156, 0, 8, 0, 92, 0, 8, 0, 220, 0, 8, 0, 60, 0, 8, 0, 188, 0, 8, 0, 124, 0, 8, 0, 252, 0, 8, 0, 2, 0, 8, 0, 130, 0, 8, 0, 66, 0, 8, 0, 194, 0, 8, 0, 34, 0, 8, 0, 162, 0, 8, 0, 98, 0, 8, 0, 226, 0, 8, 0, 18, 0, 8, 0, 146, 0, 8, 0, 82, 0, 8, 0, 210, 0, 8, 0, 50, 0, 8, 0, 178, 0, 8, 0, 114, 0, 8, 0, 242, 0, 8, 0, 10, 0, 8, 0, 138, 0, 8, 0, 74, 0, 8, 0, 202, 0, 8, 0, 42, 0, 8, 0, 170, 0, 8, 0, 106, 0, 8, 0, 234, 0, 8, 0, 26, 0, 8, 0, 154, 0, 8, 0, 90, 0, 8, 0, 218, 0, 8, 0, 58, 0, 8, 0, 186, 0, 8, 0, 122, 0, 8, 0, 250, 0, 8, 0, 6, 0, 8, 0, 134, 0, 8, 0, 70, 0, 8, 0, 198, 0, 8, 0, 38, 0, 8, 0, 166, 0, 8, 0, 102, 0, 8, 0, 230, 0, 8, 0, 22, 0, 8, 0, 150, 0, 8, 0, 86, 0, 8, 0, 214, 0, 8, 0, 54, 0, 8, 0, 182, 0, 8, 0, 118, 0, 8, 0, 246, 0, 8, 0, 14, 0, 8, 0, 142, 0, 8, 0, 78, 0, 8, 0, 206, 0, 8, 0, 46, 0, 8, 0, 174, 0, 8, 0, 110, 0, 8, 0, 238, 0, 8, 0, 30, 0, 8, 0, 158, 0, 8, 0, 94, 0, 8, 0, 222, 0, 8, 0, 62, 0, 8, 0, 190, 0, 8, 0, 126, 0, 8, 0, 254, 0, 8, 0, 1, 0, 8, 0, 129, 0, 8, 0, 65, 0, 8, 0, 193, 0, 8, 0, 33, 0, 8, 0, 161, 0, 8, 0, 97, 0, 8, 0, 225, 0, 8, 0, 17, 0, 8, 0, 145, 0, 8, 0, 81, 0, 8, 0, 209, 0, 8, 0, 49, 0, 8, 0, 177, 0, 8, 0, 113, 0, 8, 0, 241, 0, 8, 0, 9, 0, 8, 0, 137, 0, 8, 0, 73, 0, 8, 0, 201, 0, 8, 0, 41, 0, 8, 0, 169, 0, 8, 0, 105, 0, 8, 0, 233, 0, 8, 0, 25, 0, 8, 0, 153, 0, 8, 0, 89, 0, 8, 0, 217, 0, 8, 0, 57, 0, 8, 0, 185, 0, 8, 0, 121, 0, 8, 0, 249, 0, 8, 0, 5, 0, 8, 0, 133, 0, 8, 0, 69, 0, 8, 0, 197, 0, 8, 0, 37, 0, 8, 0, 165, 0, 8, 0, 101, 0, 8, 0, 229, 0, 8, 0, 21, 0, 8, 0, 149, 0, 8, 0, 85, 0, 8, 0, 213, 0, 8, 0, 53, 0, 8, 0, 181, 0, 8, 0, 117, 0, 8, 0, 245, 0, 8, 0, 13, 0, 8, 0, 141, 0, 8, 0, 77, 0, 8, 0, 205, 0, 8, 0, 45, 0, 8, 0, 173, 0, 8, 0, 109, 0, 8, 0, 237, 0, 8, 0, 29, 0, 8, 0, 157, 0, 8, 0, 93, 0, 8, 0, 221, 0, 8, 0, 61, 0, 8, 0, 189, 0, 8, 0, 125, 0, 8, 0, 253, 0, 8, 0, 19, 0, 9, 0, 275, 0, 9, 0, 147, 0, 9, 0, 403, 0, 9, 0, 83, 0, 9, 0, 339, 0, 9, 0, 211, 0, 9, 0, 467, 0, 9, 0, 51, 0, 9, 0, 307, 0, 9, 0, 179, 0, 9, 0, 435, 0, 9, 0, 115, 0, 9, 0, 371, 0, 9, 0, 243, 0, 9, 0, 499, 0, 9, 0, 11, 0, 9, 0, 267, 0, 9, 0, 139, 0, 9, 0, 395, 0, 9, 0, 75, 0, 9, 0, 331, 0, 9, 0, 203, 0, 9, 0, 459, 0, 9, 0, 43, 0, 9, 0, 299, 0, 9, 0, 171, 0, 9, 0, 427, 0, 9, 0, 107, 0, 9, 0, 363, 0, 9, 0, 235, 0, 9, 0, 491, 0, 9, 0, 27, 0, 9, 0, 283, 0, 9, 0, 155, 0, 9, 0, 411, 0, 9, 0, 91, 0, 9, 0, 347, 0, 9, 0, 219, 0, 9, 0, 475, 0, 9, 0, 59, 0, 9, 0, 315, 0, 9, 0, 187, 0, 9, 0, 443, 0, 9, 0, 123, 0, 9, 0, 379, 0, 9, 0, 251, 0, 9, 0, 507, 0, 9, 0, 7, 0, 9, 0, 263, 0, 9, 0, 135, 0, 9, 0, 391, 0, 9, 0, 71, 0, 9, 0, 327, 0, 9, 0, 199, 0, 9, 0, 455, 0, 9, 0, 39, 0, 9, 0, 295, 0, 9, 0, 167, 0, 9, 0, 423, 0, 9, 0, 103, 0, 9, 0, 359, 0, 9, 0, 231, 0, 9, 0, 487, 0, 9, 0, 23, 0, 9, 0, 279, 0, 9, 0, 151, 0, 9, 0, 407, 0, 9, 0, 87, 0, 9, 0, 343, 0, 9, 0, 215, 0, 9, 0, 471, 0, 9, 0, 55, 0, 9, 0, 311, 0, 9, 0, 183, 0, 9, 0, 439, 0, 9, 0, 119, 0, 9, 0, 375, 0, 9, 0, 247, 0, 9, 0, 503, 0, 9, 0, 15, 0, 9, 0, 271, 0, 9, 0, 143, 0, 9, 0, 399, 0, 9, 0, 79, 0, 9, 0, 335, 0, 9, 0, 207, 0, 9, 0, 463, 0, 9, 0, 47, 0, 9, 0, 303, 0, 9, 0, 175, 0, 9, 0, 431, 0, 9, 0, 111, 0, 9, 0, 367, 0, 9, 0, 239, 0, 9, 0, 495, 0, 9, 0, 31, 0, 9, 0, 287, 0, 9, 0, 159, 0, 9, 0, 415, 0, 9, 0, 95, 0, 9, 0, 351, 0, 9, 0, 223, 0, 9, 0, 479, 0, 9, 0, 63, 0, 9, 0, 319, 0, 9, 0, 191, 0, 9, 0, 447, 0, 9, 0, 127, 0, 9, 0, 383, 0, 9, 0, 255, 0, 9, 0, 511, 0, 9, 0, 0, 0, 7, 0, 64, 0, 7, 0, 32, 0, 7, 0, 96, 0, 7, 0, 16, 0, 7, 0, 80, 0, 7, 0, 48, 0, 7, 0, 112, 0, 7, 0, 8, 0, 7, 0, 72, 0, 7, 0, 40, 0, 7, 0, 104, 0, 7, 0, 24, 0, 7, 0, 88, 0, 7, 0, 56, 0, 7, 0, 120, 0, 7, 0, 4, 0, 7, 0, 68, 0, 7, 0, 36, 0, 7, 0, 100, 0, 7, 0, 20, 0, 7, 0, 84, 0, 7, 0, 52, 0, 7, 0, 116, 0, 7, 0, 3, 0, 8, 0, 131, 0, 8, 0, 67, 0, 8, 0, 195, 0, 8, 0, 35, 0, 8, 0, 163, 0, 8, 0, 99, 0, 8, 0, 227, 0, 8, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
_static_dtree=allocate([0, 0, 5, 0, 16, 0, 5, 0, 8, 0, 5, 0, 24, 0, 5, 0, 4, 0, 5, 0, 20, 0, 5, 0, 12, 0, 5, 0, 28, 0, 5, 0, 2, 0, 5, 0, 18, 0, 5, 0, 10, 0, 5, 0, 26, 0, 5, 0, 6, 0, 5, 0, 22, 0, 5, 0, 14, 0, 5, 0, 30, 0, 5, 0, 1, 0, 5, 0, 17, 0, 5, 0, 9, 0, 5, 0, 25, 0, 5, 0, 5, 0, 5, 0, 21, 0, 5, 0, 13, 0, 5, 0, 29, 0, 5, 0, 3, 0, 5, 0, 19, 0, 5, 0, 11, 0, 5, 0, 27, 0, 5, 0, 7, 0, 5, 0, 23, 0, 5, 0], ["i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0,"i16",0], ALLOC_STATIC);
_extra_lbits=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_base_length=allocate([0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 10, 0, 0, 0, 12, 0, 0, 0, 14, 0, 0, 0, 16, 0, 0, 0, 20, 0, 0, 0, 24, 0, 0, 0, 28, 0, 0, 0, 32, 0, 0, 0, 40, 0, 0, 0, 48, 0, 0, 0, 56, 0, 0, 0, 64, 0, 0, 0, 80, 0, 0, 0, 96, 0, 0, 0, 112, 0, 0, 0, 128, 0, 0, 0, 160, 0, 0, 0, 192, 0, 0, 0, 224, 0, 0, 0, 0, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_extra_dbits=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 12, 0, 0, 0, 13, 0, 0, 0, 13, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_base_dist=allocate([0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 6, 0, 0, 0, 8, 0, 0, 0, 12, 0, 0, 0, 16, 0, 0, 0, 24, 0, 0, 0, 32, 0, 0, 0, 48, 0, 0, 0, 64, 0, 0, 0, 96, 0, 0, 0, 128, 0, 0, 0, 192, 0, 0, 0, 256, 0, 0, 0, 384, 0, 0, 0, 512, 0, 0, 0, 768, 0, 0, 0, 1024, 0, 0, 0, 1536, 0, 0, 0, 2048, 0, 0, 0, 3072, 0, 0, 0, 4096, 0, 0, 0, 6144, 0, 0, 0, 8192, 0, 0, 0, 12288, 0, 0, 0, 16384, 0, 0, 0, 24576, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE._bl_order=allocate([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15] /* \10\11\12\00\08\07\0 */, "i8", ALLOC_STATIC);
_extra_blbits=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 7, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str7679=allocate([119,43,98,0] /* w+b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str17680=allocate([114,43,98,0] /* r+b\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27681=allocate([119,98,0] /* wb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str37682=allocate([114,98,0] /* rb\00 */, "i8", ALLOC_STATIC);
__ZNSt3__1L5__cinE=allocate(56, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__1L6__coutE=allocate(52, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__1L6__cerrE=allocate(52, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__1L6__wcinE=allocate(56, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__1L7__wcoutE=allocate(52, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__1L7__wcerrE=allocate(52, ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__13cinE=allocate(88, ["*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__14coutE=allocate(84, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__14cerrE=allocate(84, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__14clogE=allocate(84, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i8",0,0,0], ALLOC_STATIC);
__ZNSt3__14wcinE=allocate(88, ["*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZNSt3__15wcoutE=allocate(84, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZNSt3__15wcerrE=allocate(84, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZNSt3__15wclogE=allocate(84, ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZNSt3__119__start_std_streamsE=allocate(1, "i8", ALLOC_STATIC);
__ZTVNSt3__111__stdoutbufIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1662, 0, 0, 0, 8006, 0, 0, 0, 8008, 0, 0, 0, 8010, 0, 0, 0, 8012, 0, 0, 0, 8014, 0, 0, 0, 8016, 0, 0, 0, 8018, 0, 0, 0, 8020, 0, 0, 0, 8022, 0, 0, 0, 8024, 0, 0, 0, 8026, 0, 0, 0, 8028, 0, 0, 0, 8030, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__111__stdoutbufIwEE=allocate([78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0] /* NSt3__111__stdoutbuf */, "i8", ALLOC_STATIC);
__ZTINSt3__111__stdoutbufIwEE=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__110__stdinbufIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1660, 0, 0, 0, 8032, 0, 0, 0, 8034, 0, 0, 0, 8010, 0, 0, 0, 8012, 0, 0, 0, 8014, 0, 0, 0, 8036, 0, 0, 0, 8018, 0, 0, 0, 8020, 0, 0, 0, 8038, 0, 0, 0, 8040, 0, 0, 0, 8042, 0, 0, 0, 8028, 0, 0, 0, 8044, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110__stdinbufIwEE=allocate([78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0] /* NSt3__110__stdinbufI */, "i8", ALLOC_STATIC);
__ZTINSt3__110__stdinbufIwEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__str91587=allocate([117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0] /* unsupported locale f */, "i8", ALLOC_STATIC);
__ZTVNSt3__111__stdoutbufIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1658, 0, 0, 0, 8046, 0, 0, 0, 8048, 0, 0, 0, 8050, 0, 0, 0, 8052, 0, 0, 0, 8054, 0, 0, 0, 8056, 0, 0, 0, 8058, 0, 0, 0, 8060, 0, 0, 0, 8062, 0, 0, 0, 8064, 0, 0, 0, 8066, 0, 0, 0, 8068, 0, 0, 0, 8070, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__111__stdoutbufIcEE=allocate([78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0] /* NSt3__111__stdoutbuf */, "i8", ALLOC_STATIC);
__ZTINSt3__111__stdoutbufIcEE=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__110__stdinbufIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1656, 0, 0, 0, 8072, 0, 0, 0, 8074, 0, 0, 0, 8050, 0, 0, 0, 8052, 0, 0, 0, 8054, 0, 0, 0, 8076, 0, 0, 0, 8058, 0, 0, 0, 8060, 0, 0, 0, 8078, 0, 0, 0, 8080, 0, 0, 0, 8082, 0, 0, 0, 8068, 0, 0, 0, 8084, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110__stdinbufIcEE=allocate([78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0] /* NSt3__110__stdinbufI */, "i8", ALLOC_STATIC);
__ZTINSt3__110__stdinbufIcEE=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__114__shared_countE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8086, 0, 0, 0, 8088, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__114__shared_countE=allocate([78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0] /* NSt3__114__shared_co */, "i8", ALLOC_STATIC);
__ZTINSt3__114__shared_countE=allocate(8, "*", ALLOC_STATIC);
__ZTVSt11logic_error=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8090, 0, 0, 0, 8092, 0, 0, 0, 8094, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVSt13runtime_error=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1684, 0, 0, 0, 8096, 0, 0, 0, 8098, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSSt11logic_error=allocate([83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0] /* St11logic_error\00 */, "i8", ALLOC_STATIC);
__ZTISt11logic_error=allocate(12, "*", ALLOC_STATIC);
__ZTVSt12length_error=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1674, 0, 0, 0, 8100, 0, 0, 0, 8094, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSSt12length_error=allocate([83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0] /* St12length_error\00 */, "i8", ALLOC_STATIC);
__ZTISt12length_error=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSSt13runtime_error=allocate([83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0] /* St13runtime_error\00 */, "i8", ALLOC_STATIC);
__ZTISt13runtime_error=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__114error_categoryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8102, 0, 0, 0, 8104, 0, 0, 0, 1788, 0, 0, 0, 8106, 0, 0, 0, 8108, 0, 0, 0, 8110, 0, 0, 0, 1788, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str2341593=allocate([58,32,0] /* : \00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__112system_errorE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8112, 0, 0, 0, 8114, 0, 0, 0, 8098, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__112system_errorE=allocate([78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0] /* NSt3__112system_erro */, "i8", ALLOC_STATIC);
__ZTINSt3__112system_errorE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__114error_categoryE=allocate([78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0] /* NSt3__114error_categ */, "i8", ALLOC_STATIC);
__ZTINSt3__114error_categoryE=allocate(8, "*", ALLOC_STATIC);
__ZTVNSt3__112__do_messageE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8116, 0, 0, 0, 8118, 0, 0, 0, 1788, 0, 0, 0, 8106, 0, 0, 0, 8108, 0, 0, 0, 8110, 0, 0, 0, 8120, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__112__do_messageE=allocate([78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0] /* NSt3__112__do_messag */, "i8", ALLOC_STATIC);
__ZTINSt3__112__do_messageE=allocate(12, "*", ALLOC_STATIC);
__ZNSt3__1L3mutE=allocate([-1], ["i32",0,0,0,0], ALLOC_STATIC);
__ZNSt3__1L2cvE=allocate([-1], ["i32",0,0,0,0], ALLOC_STATIC);
STRING_TABLE.__str801618=allocate([98,97,115,105,99,95,115,116,114,105,110,103,0] /* basic_string\00 */, "i8", ALLOC_STATIC);
__ZL19__terminate_handler=allocate(1, "void ()*", ALLOC_STATIC);
STRING_TABLE.__str1221650=allocate([115,116,100,58,58,101,120,99,101,112,116,105,111,110,0] /* std::exception\00 */, "i8", ALLOC_STATIC);
__ZTVSt9exception=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8122, 0, 0, 0, 8124, 0, 0, 0, 1774, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSSt9exception=allocate([83,116,57,101,120,99,101,112,116,105,111,110,0] /* St9exception\00 */, "i8", ALLOC_STATIC);
__ZTISt9exception=allocate(8, "*", ALLOC_STATIC);
__ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8126, 0, 0, 0, 8128, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8130, 0, 0, 0, 8132, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__115basic_streambufIcNS_11char_traitsIcEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8134, 0, 0, 0, 8136, 0, 0, 0, 8138, 0, 0, 0, 8050, 0, 0, 0, 8052, 0, 0, 0, 8054, 0, 0, 0, 8076, 0, 0, 0, 8058, 0, 0, 0, 8060, 0, 0, 0, 8062, 0, 0, 0, 8064, 0, 0, 0, 8066, 0, 0, 0, 8068, 0, 0, 0, 8084, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__115basic_streambufIwNS_11char_traitsIwEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8140, 0, 0, 0, 8142, 0, 0, 0, 8144, 0, 0, 0, 8010, 0, 0, 0, 8012, 0, 0, 0, 8014, 0, 0, 0, 8036, 0, 0, 0, 8018, 0, 0, 0, 8020, 0, 0, 0, 8022, 0, 0, 0, 8024, 0, 0, 0, 8026, 0, 0, 0, 8028, 0, 0, 0, 8044, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE=allocate([8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1664, 0, 0, 0, 8146, 0, 0, 0, -8, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0, 0, 8148, 0, 0, 0, 8150, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTTNSt3__113basic_istreamIcNS_11char_traitsIcEEEE=allocate(8, "*", ALLOC_STATIC);
__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE=allocate([8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1668, 0, 0, 0, 8152, 0, 0, 0, -8, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0, 0, 8154, 0, 0, 0, 8156, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTTNSt3__113basic_istreamIwNS_11char_traitsIwEEEE=allocate(8, "*", ALLOC_STATIC);
__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE=allocate([4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1666, 0, 0, 0, 8158, 0, 0, 0, -4, 0, 0, 0, -4, 0, 0, 0, 0, 0, 0, 0, 8160, 0, 0, 0, 8162, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTTNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE=allocate(8, "*", ALLOC_STATIC);
__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE=allocate([4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1670, 0, 0, 0, 8164, 0, 0, 0, -4, 0, 0, 0, -4, 0, 0, 0, 0, 0, 0, 0, 8166, 0, 0, 0, 8168, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTTNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__str1541656=allocate([105,111,115,116,114,101,97,109,0] /* iostream\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str11551657=allocate([117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0] /* unspecified iostream */, "i8", ALLOC_STATIC);
__ZZNSt3__117iostream_categoryEvE1s=allocate(4, "*", ALLOC_STATIC);
__ZGVZNSt3__117iostream_categoryEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__18ios_base7failureE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1676, 0, 0, 0, 8170, 0, 0, 0, 8098, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__18ios_baseE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8172, 0, 0, 0, 8174, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str2158=allocate([105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0] /* ios_base::clear\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18ios_base7failureE=allocate([78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0] /* NSt3__18ios_base7fai */, "i8", ALLOC_STATIC);
__ZTINSt3__18ios_base7failureE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18ios_baseE=allocate([78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0] /* NSt3__18ios_baseE\00 */, "i8", ALLOC_STATIC);
__ZTINSt3__18ios_baseE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19basic_iosIcNS_11char_traitsIcEEEE=allocate([78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0] /* NSt3__19basic_iosIcN */, "i8", ALLOC_STATIC);
__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19basic_iosIwNS_11char_traitsIwEEEE=allocate([78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0] /* NSt3__19basic_iosIwN */, "i8", ALLOC_STATIC);
__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__115basic_streambufIcNS_11char_traitsIcEEEE=allocate([78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0] /* NSt3__115basic_strea */, "i8", ALLOC_STATIC);
__ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__115basic_streambufIwNS_11char_traitsIwEEEE=allocate([78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0] /* NSt3__115basic_strea */, "i8", ALLOC_STATIC);
__ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__113basic_istreamIcNS_11char_traitsIcEEEE=allocate([78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0] /* NSt3__113basic_istre */, "i8", ALLOC_STATIC);
__ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, -3069, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__113basic_istreamIwNS_11char_traitsIwEEEE=allocate([78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0] /* NSt3__113basic_istre */, "i8", ALLOC_STATIC);
__ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, -3069, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE=allocate([78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0] /* NSt3__113basic_ostre */, "i8", ALLOC_STATIC);
__ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, -3069, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE=allocate([78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0] /* NSt3__113basic_ostre */, "i8", ALLOC_STATIC);
__ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, -3069, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__119__iostream_categoryE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1678, 0, 0, 0, 8176, 0, 0, 0, 8178, 0, 0, 0, 8106, 0, 0, 0, 8108, 0, 0, 0, 8110, 0, 0, 0, 8180, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__119__iostream_categoryE=allocate([78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0] /* NSt3__119__iostream_ */, "i8", ALLOC_STATIC);
__ZTINSt3__119__iostream_categoryE=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__17collateIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8182, 0, 0, 0, 8184, 0, 0, 0, 8186, 0, 0, 0, 8188, 0, 0, 0, 8190, 0, 0, 0, 8192, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17collateIcE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__17collateIcE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__17collateIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8194, 0, 0, 0, 8196, 0, 0, 0, 8186, 0, 0, 0, 8198, 0, 0, 0, 8200, 0, 0, 0, 8202, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17collateIwE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__17collateIwE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8204, 0, 0, 0, 8206, 0, 0, 0, 8186, 0, 0, 0, 8208, 0, 0, 0, 8210, 0, 0, 0, 8212, 0, 0, 0, 8214, 0, 0, 0, 8216, 0, 0, 0, 8218, 0, 0, 0, 8220, 0, 0, 0, 8222, 0, 0, 0, 8224, 0, 0, 0, 8226, 0, 0, 0, 8228, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZNSt3__114__num_get_base5__srcE=allocate([48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0] /* 0123456789abcdefABCD */, "i8", ALLOC_STATIC);
STRING_TABLE.__str2371658=allocate([37,112,0] /* %p\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8230, 0, 0, 0, 8232, 0, 0, 0, 8186, 0, 0, 0, 8234, 0, 0, 0, 8236, 0, 0, 0, 8238, 0, 0, 0, 8240, 0, 0, 0, 8242, 0, 0, 0, 8244, 0, 0, 0, 8246, 0, 0, 0, 8248, 0, 0, 0, 8250, 0, 0, 0, 8252, 0, 0, 0, 8254, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8256, 0, 0, 0, 8258, 0, 0, 0, 8186, 0, 0, 0, 8260, 0, 0, 0, 8262, 0, 0, 0, 8264, 0, 0, 0, 8266, 0, 0, 0, 8268, 0, 0, 0, 8270, 0, 0, 0, 8272, 0, 0, 0, 8274, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEclE5__fmt=allocate([37,0,0,0,0,0] /* %\00\00\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str5242=allocate([108,0] /* l\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcxE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str6243=allocate([108,108,0] /* ll\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcmE5__fmt=allocate([37,0,0,0,0,0] /* %\00\00\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcyE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcdE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
__str7244=allocate(1, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEceE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__str8245=allocate([76,0] /* L\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKvE5__fmt=allocate([37,112,0,0,0,0] /* %p\00\00\00\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8276, 0, 0, 0, 8278, 0, 0, 0, 8186, 0, 0, 0, 8280, 0, 0, 0, 8282, 0, 0, 0, 8284, 0, 0, 0, 8286, 0, 0, 0, 8288, 0, 0, 0, 8290, 0, 0, 0, 8292, 0, 0, 0, 8294, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwlE5__fmt=allocate([37,0,0,0,0,0] /* %\00\00\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwxE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwmE5__fmt=allocate([37,0,0,0,0,0] /* %\00\00\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwyE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwdE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEweE5__fmt=allocate([37,0,0,0,0,0,0,0] /* %\00\00\00\00\00\00\ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKvE5__fmt=allocate([37,112,0,0,0,0] /* %p\00\00\00\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8296, 0, 0, 0, 8298, 0, 0, 0, 8186, 0, 0, 0, 8300, 0, 0, 0, 8302, 0, 0, 0, 8304, 0, 0, 0, 8306, 0, 0, 0, 8308, 0, 0, 0, 8310, 0, 0, 0, 8312, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0, 0, 8314, 0, 0, 0, 8316, 0, 0, 0, 8318, 0, 0, 0, 8320, 0, 0, 0, 8322, 0, 0, 0, 8324, 0, 0, 0, 8326, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt=allocate([37,72,58,37,77,58,37,83] /* %H:%M:%S */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt=allocate([37,109,47,37,100,47,37,121] /* %m/%d/%y */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt11=allocate([37,89,45,37,109,45,37,100] /* %Y-%m-%d */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt12=allocate([37,73,58,37,77,58,37,83,32,37,112] /* %I:%M:%S %p */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt13=allocate([37,72,58,37,77] /* %H:%M */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt14=allocate([37,72,58,37,77,58,37,83] /* %H:%M:%S */, "i8", ALLOC_STATIC);
__ZTVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8328, 0, 0, 0, 8330, 0, 0, 0, 8186, 0, 0, 0, 8332, 0, 0, 0, 8334, 0, 0, 0, 8336, 0, 0, 0, 8338, 0, 0, 0, 8340, 0, 0, 0, 8342, 0, 0, 0, 8344, 0, 0, 0, -8, 0, 0, 0, 0, 0, 0, 0, 8346, 0, 0, 0, 8348, 0, 0, 0, 8350, 0, 0, 0, 8352, 0, 0, 0, 8354, 0, 0, 0, 8356, 0, 0, 0, 8358, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tmE5__fmt=allocate([37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt=allocate([37, 0, 0, 0, 109, 0, 0, 0, 47, 0, 0, 0, 37, 0, 0, 0, 100, 0, 0, 0, 47, 0, 0, 0, 37, 0, 0, 0, 121, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt16=allocate([37, 0, 0, 0, 89, 0, 0, 0, 45, 0, 0, 0, 37, 0, 0, 0, 109, 0, 0, 0, 45, 0, 0, 0, 37, 0, 0, 0, 100, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt17=allocate([37, 0, 0, 0, 73, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 112, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt18=allocate([37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmccE5__fmt19=allocate([37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0], ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8360, 0, 0, 0, 8362, 0, 0, 0, 8186, 0, 0, 0, 8364, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8366, 0, 0, 0, 8368, 0, 0, 0, 8186, 0, 0, 0, 8370, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__110moneypunctIcLb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8372, 0, 0, 0, 8374, 0, 0, 0, 8186, 0, 0, 0, 8376, 0, 0, 0, 8378, 0, 0, 0, 8380, 0, 0, 0, 8382, 0, 0, 0, 8384, 0, 0, 0, 8386, 0, 0, 0, 8388, 0, 0, 0, 8390, 0, 0, 0, 8392, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__110moneypunctIcLb0EE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__110moneypunctIcLb0EE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__110moneypunctIcLb0EE13do_pos_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZZNKSt3__110moneypunctIcLb0EE13do_neg_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZTVNSt3__110moneypunctIcLb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8394, 0, 0, 0, 8396, 0, 0, 0, 8186, 0, 0, 0, 8398, 0, 0, 0, 8400, 0, 0, 0, 8402, 0, 0, 0, 8404, 0, 0, 0, 8406, 0, 0, 0, 8408, 0, 0, 0, 8410, 0, 0, 0, 8412, 0, 0, 0, 8414, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__110moneypunctIcLb1EE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__110moneypunctIcLb1EE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__110moneypunctIcLb1EE13do_pos_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZZNKSt3__110moneypunctIcLb1EE13do_neg_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZTVNSt3__110moneypunctIwLb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8416, 0, 0, 0, 8418, 0, 0, 0, 8186, 0, 0, 0, 8420, 0, 0, 0, 8422, 0, 0, 0, 8424, 0, 0, 0, 8426, 0, 0, 0, 8428, 0, 0, 0, 8430, 0, 0, 0, 8432, 0, 0, 0, 8434, 0, 0, 0, 8436, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__110moneypunctIwLb0EE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__110moneypunctIwLb0EE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__110moneypunctIwLb0EE13do_pos_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZZNKSt3__110moneypunctIwLb0EE13do_neg_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZTVNSt3__110moneypunctIwLb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8438, 0, 0, 0, 8440, 0, 0, 0, 8186, 0, 0, 0, 8442, 0, 0, 0, 8444, 0, 0, 0, 8446, 0, 0, 0, 8448, 0, 0, 0, 8450, 0, 0, 0, 8452, 0, 0, 0, 8454, 0, 0, 0, 8456, 0, 0, 0, 8458, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__110moneypunctIwLb1EE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__110moneypunctIwLb1EE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__110moneypunctIwLb1EE13do_pos_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZZNKSt3__110moneypunctIwLb1EE13do_neg_formatEvE3__p=allocate([2, 3, 0, 4], "i8", ALLOC_STATIC);
__ZTVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8460, 0, 0, 0, 8462, 0, 0, 0, 8186, 0, 0, 0, 8464, 0, 0, 0, 8466, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src=allocate([48,49,50,51,52,53,54,55,56,57,0] /* 0123456789\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str27248=allocate([37,76,102,0] /* %Lf\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str28249=allocate([109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0] /* money_get error\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8468, 0, 0, 0, 8470, 0, 0, 0, 8186, 0, 0, 0, 8472, 0, 0, 0, 8474, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjReE5__src=allocate([48,49,50,51,52,53,54,55,56,57,0] /* 0123456789\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8476, 0, 0, 0, 8478, 0, 0, 0, 8186, 0, 0, 0, 8480, 0, 0, 0, 8482, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str31250=allocate([37,46,48,76,102,0] /* %.0Lf\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8484, 0, 0, 0, 8486, 0, 0, 0, 8186, 0, 0, 0, 8488, 0, 0, 0, 8490, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__18messagesIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8492, 0, 0, 0, 8494, 0, 0, 0, 8186, 0, 0, 0, 8496, 0, 0, 0, 8498, 0, 0, 0, 8500, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__18messagesIcE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__18messagesIcE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__18messagesIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8502, 0, 0, 0, 8504, 0, 0, 0, 8186, 0, 0, 0, 8506, 0, 0, 0, 8508, 0, 0, 0, 8510, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__18messagesIwE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZGVNSt3__18messagesIwE2idE=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str351659=allocate([118,101,99,116,111,114,0] /* vector\00 */, "i8", ALLOC_STATIC);
__ZZNSt3__16__clocEvE6result=allocate(1, "i8*", ALLOC_STATIC);
__ZGVZNSt3__16__clocEvE6result=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str361660=allocate([67,0] /* C\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__16locale5__impE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8512, 0, 0, 0, 8514, 0, 0, 0, 8186, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZZNSt3__16locale5__imp12make_classicEvE3buf=allocate(4, "i8", ALLOC_STATIC);
__ZZNSt3__16locale7classicEvE1c=allocate(1, "%\"class.std::__1::locale\"*", ALLOC_STATIC);
__ZGVZNSt3__16locale7classicEvE1c=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNSt3__16locale5__imp11make_globalEvE3buf=allocate(4, "i8", ALLOC_STATIC);
__ZZNSt3__16locale8__globalEvE1g=allocate(1, "%\"class.std::__1::locale\"*", ALLOC_STATIC);
__ZGVZNSt3__16locale8__globalEvE1g=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZNSt3__16locale2id9__next_idE=allocate(1, "i32", ALLOC_STATIC);
__ZNSt3__15ctypeIwE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZNSt3__15ctypeIcE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZTVNSt3__15ctypeIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8516, 0, 0, 0, 8518, 0, 0, 0, 8186, 0, 0, 0, 8520, 0, 0, 0, 8522, 0, 0, 0, 8524, 0, 0, 0, 8526, 0, 0, 0, 8528, 0, 0, 0, 8530, 0, 0, 0, 8532, 0, 0, 0, 8534, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17codecvtIcc10_mbstate_tE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZNSt3__17codecvtIwc10_mbstate_tE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZTVNSt3__17codecvtIwc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8536, 0, 0, 0, 8538, 0, 0, 0, 8186, 0, 0, 0, 8540, 0, 0, 0, 8542, 0, 0, 0, 8544, 0, 0, 0, 8546, 0, 0, 0, 8548, 0, 0, 0, 8550, 0, 0, 0, 8552, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZNSt3__17codecvtItc10_mbstate_tE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZNSt3__17codecvtIjc10_mbstate_tE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZNSt3__18numpunctIcE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZNSt3__18numpunctIwE2idE=allocate(8, "i32", ALLOC_STATIC);
__ZTVNSt3__18numpunctIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8554, 0, 0, 0, 8556, 0, 0, 0, 8186, 0, 0, 0, 8558, 0, 0, 0, 8560, 0, 0, 0, 8562, 0, 0, 0, 8564, 0, 0, 0, 8566, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__18numpunctIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8568, 0, 0, 0, 8570, 0, 0, 0, 8186, 0, 0, 0, 8572, 0, 0, 0, 8574, 0, 0, 0, 8576, 0, 0, 0, 8578, 0, 0, 0, 8580, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str521667=allocate([116,114,117,101,0] /* true\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str531668=allocate([116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0] /* t\00\00\00r\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str54260=allocate([102,97,108,115,101,0] /* false\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str551669=allocate([102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0] /* f\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks=allocate(1, "%\"class.std::__1::basic_string\"*", ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE7__weeksEvE5weeks=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks=allocate(1, "%\"class.std::__1::basic_string.5\"*", ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE7__weeksEvE5weeks=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months=allocate(1, "%\"class.std::__1::basic_string\"*", ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE8__monthsEvE6months=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months=allocate(1, "%\"class.std::__1::basic_string.5\"*", ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE8__monthsEvE6months=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm=allocate(1, "%\"class.std::__1::basic_string\"*", ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE7__am_pmEvE5am_pm=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm=allocate(1, "%\"class.std::__1::basic_string.5\"*", ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE7__am_pmEvE5am_pm=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE3__xEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE3__xEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str571671=allocate([37,109,47,37,100,47,37,121,0] /* %m/%d/%y\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE3__xEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE3__xEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str581672=allocate([37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0] /* %\00\00\00m\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE3__XEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE3__XEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str591673=allocate([37,72,58,37,77,58,37,83,0] /* %H:%M:%S\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE3__XEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE3__XEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str601674=allocate([37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0] /* %\00\00\00H\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE3__cEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE3__cEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str611675=allocate([37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0] /* %a %b %d %H:%M:%S %Y */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE3__cEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE3__cEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str621676=allocate([37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0] /* %\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIcE3__rEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIcE3__rEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str63261=allocate([37,73,58,37,77,58,37,83,32,37,112,0] /* %I:%M:%S %p\00 */, "i8", ALLOC_STATIC);
__ZZNKSt3__120__time_get_c_storageIwE3__rEvE1s=allocate(12, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNKSt3__120__time_get_c_storageIwE3__rEvE1s=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str641677=allocate([37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0] /* %\00\00\00I\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str66262=allocate([108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0] /* locale not supported */, "i8", ALLOC_STATIC);
__ZTVNSt3__16locale5facetE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8582, 0, 0, 0, 8584, 0, 0, 0, 8186, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__16locale5facetE=allocate([78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0] /* NSt3__16locale5facet */, "i8", ALLOC_STATIC);
__ZTINSt3__16locale5facetE=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__15ctypeIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8586, 0, 0, 0, 8588, 0, 0, 0, 8186, 0, 0, 0, 8590, 0, 0, 0, 8592, 0, 0, 0, 8594, 0, 0, 0, 8596, 0, 0, 0, 8598, 0, 0, 0, 8600, 0, 0, 0, 8602, 0, 0, 0, 8604, 0, 0, 0, 8606, 0, 0, 0, 8608, 0, 0, 0, 8610, 0, 0, 0, 8612, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__15ctypeIwEE=allocate([78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0] /* NSt3__15ctypeIwEE\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110ctype_baseE=allocate([78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0] /* NSt3__110ctype_baseE */, "i8", ALLOC_STATIC);
__ZTINSt3__110ctype_baseE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__15ctypeIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__15ctypeIcEE=allocate([78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0] /* NSt3__15ctypeIcEE\00 */, "i8", ALLOC_STATIC);
__ZTINSt3__15ctypeIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__17codecvtIcc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8614, 0, 0, 0, 8616, 0, 0, 0, 8186, 0, 0, 0, 8618, 0, 0, 0, 8620, 0, 0, 0, 8622, 0, 0, 0, 8624, 0, 0, 0, 8626, 0, 0, 0, 8628, 0, 0, 0, 8630, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17codecvtIcc10_mbstate_tEE=allocate([78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,48,95,109,98,115,116,97,116,101,95,116,69,69,0] /* NSt3__17codecvtIcc10 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__112codecvt_baseE=allocate([78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0] /* NSt3__112codecvt_bas */, "i8", ALLOC_STATIC);
__ZTINSt3__112codecvt_baseE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__17codecvtIcc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17codecvtIwc10_mbstate_tEE=allocate([78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,48,95,109,98,115,116,97,116,101,95,116,69,69,0] /* NSt3__17codecvtIwc10 */, "i8", ALLOC_STATIC);
__ZTINSt3__17codecvtIwc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__17codecvtItc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8632, 0, 0, 0, 8634, 0, 0, 0, 8186, 0, 0, 0, 8636, 0, 0, 0, 8638, 0, 0, 0, 8640, 0, 0, 0, 8642, 0, 0, 0, 8644, 0, 0, 0, 8646, 0, 0, 0, 8648, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17codecvtItc10_mbstate_tEE=allocate([78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,116,99,49,48,95,109,98,115,116,97,116,101,95,116,69,69,0] /* NSt3__17codecvtItc10 */, "i8", ALLOC_STATIC);
__ZTINSt3__17codecvtItc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__17codecvtIjc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8650, 0, 0, 0, 8652, 0, 0, 0, 8186, 0, 0, 0, 8654, 0, 0, 0, 8656, 0, 0, 0, 8658, 0, 0, 0, 8660, 0, 0, 0, 8662, 0, 0, 0, 8664, 0, 0, 0, 8666, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17codecvtIjc10_mbstate_tEE=allocate([78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,106,99,49,48,95,109,98,115,116,97,116,101,95,116,69,69,0] /* NSt3__17codecvtIjc10 */, "i8", ALLOC_STATIC);
__ZTINSt3__17codecvtIjc10_mbstate_tEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTVNSt3__116__narrow_to_utf8ILj32EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8668, 0, 0, 0, 8670, 0, 0, 0, 8186, 0, 0, 0, 8654, 0, 0, 0, 8656, 0, 0, 0, 8658, 0, 0, 0, 8660, 0, 0, 0, 8662, 0, 0, 0, 8664, 0, 0, 0, 8666, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__116__narrow_to_utf8ILj32EEE=allocate([78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0] /* NSt3__116__narrow_to */, "i8", ALLOC_STATIC);
__ZTINSt3__116__narrow_to_utf8ILj32EEE=allocate(12, "*", ALLOC_STATIC);
__ZTVNSt3__117__widen_from_utf8ILj32EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8672, 0, 0, 0, 8674, 0, 0, 0, 8186, 0, 0, 0, 8654, 0, 0, 0, 8656, 0, 0, 0, 8658, 0, 0, 0, 8660, 0, 0, 0, 8662, 0, 0, 0, 8664, 0, 0, 0, 8666, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__117__widen_from_utf8ILj32EEE=allocate([78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0] /* NSt3__117__widen_fro */, "i8", ALLOC_STATIC);
__ZTINSt3__117__widen_from_utf8ILj32EEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18numpunctIcEE=allocate([78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0] /* NSt3__18numpunctIcEE */, "i8", ALLOC_STATIC);
__ZTINSt3__18numpunctIcEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18numpunctIwEE=allocate([78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0] /* NSt3__18numpunctIwEE */, "i8", ALLOC_STATIC);
__ZTINSt3__18numpunctIwEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__16locale5__impE=allocate([78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0] /* NSt3__16locale5__imp */, "i8", ALLOC_STATIC);
__ZTINSt3__16locale5__impE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17collateIcEE=allocate([78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0] /* NSt3__17collateIcEE\ */, "i8", ALLOC_STATIC);
__ZTINSt3__17collateIcEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17collateIwEE=allocate([78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0] /* NSt3__17collateIwEE\ */, "i8", ALLOC_STATIC);
__ZTINSt3__17collateIwEE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110moneypunctIcLb0EEE=allocate([78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0] /* NSt3__110moneypunctI */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110money_baseE=allocate([78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0] /* NSt3__110money_baseE */, "i8", ALLOC_STATIC);
__ZTINSt3__110money_baseE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__110moneypunctIcLb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110moneypunctIcLb1EEE=allocate([78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0] /* NSt3__110moneypunctI */, "i8", ALLOC_STATIC);
__ZTINSt3__110moneypunctIcLb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110moneypunctIwLb0EEE=allocate([78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0] /* NSt3__110moneypunctI */, "i8", ALLOC_STATIC);
__ZTINSt3__110moneypunctIwLb0EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110moneypunctIwLb1EEE=allocate([78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0] /* NSt3__110moneypunctI */, "i8", ALLOC_STATIC);
__ZTINSt3__110moneypunctIwLb1EEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0] /* NSt3__18time_getIcNS */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19time_baseE=allocate([78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0] /* NSt3__19time_baseE\0 */, "i8", ALLOC_STATIC);
__ZTINSt3__19time_baseE=allocate(8, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__120__time_get_c_storageIcEE=allocate([78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0] /* NSt3__120__time_get_ */, "i8", ALLOC_STATIC);
__ZTINSt3__120__time_get_c_storageIcEE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0] /* NSt3__18time_getIwNS */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__120__time_get_c_storageIwEE=allocate([78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0] /* NSt3__120__time_get_ */, "i8", ALLOC_STATIC);
__ZTINSt3__120__time_get_c_storageIwEE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0] /* NSt3__18time_putIcNS */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__110__time_putE=allocate([78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0] /* NSt3__110__time_putE */, "i8", ALLOC_STATIC);
__ZTINSt3__110__time_putE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0] /* NSt3__18time_putIwNS */, "i8", ALLOC_STATIC);
__ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18messagesIcEE=allocate([78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0] /* NSt3__18messagesIcEE */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__113messages_baseE=allocate([78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0] /* NSt3__113messages_ba */, "i8", ALLOC_STATIC);
__ZTINSt3__113messages_baseE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__18messagesIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__18messagesIwEE=allocate([78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0] /* NSt3__18messagesIwEE */, "i8", ALLOC_STATIC);
__ZTINSt3__18messagesIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0] /* NSt3__17num_getIcNS_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19__num_getIcEE=allocate([78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0] /* NSt3__19__num_getIcE */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__114__num_get_baseE=allocate([78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0] /* NSt3__114__num_get_b */, "i8", ALLOC_STATIC);
__ZTINSt3__114__num_get_baseE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__19__num_getIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0] /* NSt3__17num_getIwNS_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19__num_getIwEE=allocate([78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0] /* NSt3__19__num_getIwE */, "i8", ALLOC_STATIC);
__ZTINSt3__19__num_getIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0] /* NSt3__17num_putIcNS_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19__num_putIcEE=allocate([78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0] /* NSt3__19__num_putIcE */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__114__num_put_baseE=allocate([78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0] /* NSt3__114__num_put_b */, "i8", ALLOC_STATIC);
__ZTINSt3__114__num_put_baseE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__19__num_putIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0] /* NSt3__17num_putIwNS_ */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19__num_putIwEE=allocate([78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0] /* NSt3__19__num_putIwE */, "i8", ALLOC_STATIC);
__ZTINSt3__19__num_putIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0] /* NSt3__19money_getIcN */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__111__money_getIcEE=allocate([78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0] /* NSt3__111__money_get */, "i8", ALLOC_STATIC);
__ZTINSt3__111__money_getIcEE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0] /* NSt3__19money_getIwN */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__111__money_getIwEE=allocate([78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0] /* NSt3__111__money_get */, "i8", ALLOC_STATIC);
__ZTINSt3__111__money_getIwEE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0] /* NSt3__19money_putIcN */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__111__money_putIcEE=allocate([78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0] /* NSt3__111__money_put */, "i8", ALLOC_STATIC);
__ZTINSt3__111__money_putIcEE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0] /* NSt3__19money_putIwN */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSNSt3__111__money_putIwEE=allocate([78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0] /* NSt3__111__money_put */, "i8", ALLOC_STATIC);
__ZTINSt3__111__money_putIwEE=allocate(8, "*", ALLOC_STATIC);
__ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_E3buf=allocate(148, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf=allocate(12, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf=allocate(12, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf=allocate(12, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf=allocate(12, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_E3buf=allocate(28, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_E3buf=allocate(24, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_E3buf=allocate(12, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_E3buf=allocate(16, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_E3buf=allocate(8, "i8", ALLOC_STATIC);
__ZZNSt3__1L11init_wam_pmEvE5am_pm=allocate(288, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNSt3__1L11init_wam_pmEvE5am_pm=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str751687=allocate([65,0,0,0,77,0,0,0,0,0,0,0] /* A\00\00\00M\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str761688=allocate([80,0,0,0,77,0,0,0,0,0,0,0] /* P\00\00\00M\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNSt3__1L10init_am_pmEvE5am_pm=allocate(288, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNSt3__1L10init_am_pmEvE5am_pm=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str781689=allocate([65,77,0] /* AM\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str791690=allocate([80,77,0] /* PM\00 */, "i8", ALLOC_STATIC);
__ZZNSt3__1L12init_wmonthsEvE6months=allocate(288, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNSt3__1L12init_wmonthsEvE6months=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str811691=allocate([74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0] /* J\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str821692=allocate([70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0] /* F\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str831693=allocate([77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0] /* M\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str841694=allocate([65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0] /* A\00\00\00p\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str851695=allocate([77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* M\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str861696=allocate([74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0] /* J\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str871697=allocate([74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0] /* J\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str881698=allocate([65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0] /* A\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str891699=allocate([83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0] /* S\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str901700=allocate([79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0] /* O\00\00\00c\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str911701=allocate([78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0] /* N\00\00\00o\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str921702=allocate([68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0] /* D\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str931703=allocate([74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0] /* J\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str941704=allocate([70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0] /* F\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str951705=allocate([77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0] /* M\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str961706=allocate([65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0] /* A\00\00\00p\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str971707=allocate([74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0] /* J\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str981708=allocate([74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0] /* J\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str991709=allocate([65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0] /* A\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1001710=allocate([83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0] /* S\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1011711=allocate([79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0] /* O\00\00\00c\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1021712=allocate([78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0] /* N\00\00\00o\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1031713=allocate([68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0] /* D\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNSt3__1L11init_monthsEvE6months=allocate(288, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNSt3__1L11init_monthsEvE6months=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1051714=allocate([74,97,110,117,97,114,121,0] /* January\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1061715=allocate([70,101,98,114,117,97,114,121,0] /* February\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1071716=allocate([77,97,114,99,104,0] /* March\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1081717=allocate([65,112,114,105,108,0] /* April\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1091718=allocate([77,97,121,0] /* May\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1101719=allocate([74,117,110,101,0] /* June\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1111720=allocate([74,117,108,121,0] /* July\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str112263=allocate([65,117,103,117,115,116,0] /* August\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1131721=allocate([83,101,112,116,101,109,98,101,114,0] /* September\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1141722=allocate([79,99,116,111,98,101,114,0] /* October\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1151723=allocate([78,111,118,101,109,98,101,114,0] /* November\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1161724=allocate([68,101,99,101,109,98,101,114,0] /* December\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1171725=allocate([74,97,110,0] /* Jan\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1181726=allocate([70,101,98,0] /* Feb\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1191727=allocate([77,97,114,0] /* Mar\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1201728=allocate([65,112,114,0] /* Apr\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str121264=allocate([74,117,110,0] /* Jun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str122265=allocate([74,117,108,0] /* Jul\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1231729=allocate([65,117,103,0] /* Aug\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1241730=allocate([83,101,112,0] /* Sep\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1251731=allocate([79,99,116,0] /* Oct\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1261732=allocate([78,111,118,0] /* Nov\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1271733=allocate([68,101,99,0] /* Dec\00 */, "i8", ALLOC_STATIC);
__ZZNSt3__1L11init_wweeksEvE5weeks=allocate(168, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNSt3__1L11init_wweeksEvE5weeks=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1291734=allocate([83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* S\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1301735=allocate([77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* M\00\00\00o\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1311736=allocate([84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* T\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1321737=allocate([87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* W\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str133266=allocate([84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* T\00\00\00h\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1341738=allocate([70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* F\00\00\00r\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1351739=allocate([83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0] /* S\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1361740=allocate([83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0] /* S\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1371741=allocate([77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0] /* M\00\00\00o\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1381742=allocate([84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0] /* T\00\00\00u\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1391743=allocate([87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0] /* W\00\00\00e\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1401744=allocate([84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0] /* T\00\00\00h\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1411745=allocate([70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0] /* F\00\00\00r\00\00\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1421746=allocate([83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0] /* S\00\00\00a\00\00\00 */, "i8", ALLOC_STATIC);
__ZZNSt3__1L10init_weeksEvE5weeks=allocate(168, ["i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0], ALLOC_STATIC);
__ZGVZNSt3__1L10init_weeksEvE5weeks=allocate(1, ["i64",0,0,0,"i32",0,0,0], ALLOC_STATIC);
STRING_TABLE.__str1441747=allocate([83,117,110,100,97,121,0] /* Sunday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1451748=allocate([77,111,110,100,97,121,0] /* Monday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1461749=allocate([84,117,101,115,100,97,121,0] /* Tuesday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1471750=allocate([87,101,100,110,101,115,100,97,121,0] /* Wednesday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1481751=allocate([84,104,117,114,115,100,97,121,0] /* Thursday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1491752=allocate([70,114,105,100,97,121,0] /* Friday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1501753=allocate([83,97,116,117,114,100,97,121,0] /* Saturday\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1511754=allocate([83,117,110,0] /* Sun\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1521755=allocate([77,111,110,0] /* Mon\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1531756=allocate([84,117,101,0] /* Tue\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str154267=allocate([87,101,100,0] /* Wed\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str155268=allocate([84,104,117,0] /* Thu\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1561757=allocate([70,114,105,0] /* Fri\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__str1571758=allocate([83,97,116,0] /* Sat\00 */, "i8", ALLOC_STATIC);
__ZTVNSt3__120__time_get_c_storageIwEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8346, 0, 0, 0, 8348, 0, 0, 0, 8350, 0, 0, 0, 8352, 0, 0, 0, 8354, 0, 0, 0, 8356, 0, 0, 0, 8358, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVNSt3__120__time_get_c_storageIcEE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8314, 0, 0, 0, 8316, 0, 0, 0, 8318, 0, 0, 0, 8320, 0, 0, 0, 8322, 0, 0, 0, 8324, 0, 0, 0, 8326, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVSt8bad_cast=allocate([0, 0, 0, 0, 0, 0, 0, 0, 1688, 0, 0, 0, 8676, 0, 0, 0, 8678, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str4181773=allocate([115,116,100,58,58,98,97,100,95,99,97,115,116,0] /* std::bad_cast\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSSt8bad_cast=allocate([83,116,56,98,97,100,95,99,97,115,116,0] /* St8bad_cast\00 */, "i8", ALLOC_STATIC);
__ZTISt8bad_cast=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSN10__cxxabiv116__shim_type_infoE=allocate([78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0] /* N10__cxxabiv116__shi */, "i8", ALLOC_STATIC);
__ZTIN10__cxxabiv116__shim_type_infoE=allocate(12, "*", ALLOC_STATIC);
STRING_TABLE.__ZTSN10__cxxabiv117__class_type_infoE=allocate([78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0] /* N10__cxxabiv117__cla */, "i8", ALLOC_STATIC);
__ZTIN10__cxxabiv117__class_type_infoE=allocate(12, "*", ALLOC_STATIC);
__ZTVN10__cxxabiv117__class_type_infoE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8680, 0, 0, 0, 8682, 0, 0, 0, 8684, 0, 0, 0, 8686, 0, 0, 0, 8688, 0, 0, 0, 8690, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
__ZTVN10__cxxabiv120__si_class_type_infoE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8692, 0, 0, 0, 8694, 0, 0, 0, 8684, 0, 0, 0, 8696, 0, 0, 0, 8698, 0, 0, 0, 8700, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSN10__cxxabiv120__si_class_type_infoE=allocate([78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0] /* N10__cxxabiv120__si_ */, "i8", ALLOC_STATIC);
__ZTIN10__cxxabiv120__si_class_type_infoE=allocate(12, "*", ALLOC_STATIC);
__ZTVN10__cxxabiv121__vmi_class_type_infoE=allocate([0, 0, 0, 0, 0, 0, 0, 0, 8702, 0, 0, 0, 8704, 0, 0, 0, 8684, 0, 0, 0, 8706, 0, 0, 0, 8708, 0, 0, 0, 8710, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__ZTSN10__cxxabiv121__vmi_class_type_infoE=allocate([78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0] /* N10__cxxabiv121__vmi */, "i8", ALLOC_STATIC);
__ZTIN10__cxxabiv121__vmi_class_type_infoE=allocate(12, "*", ALLOC_STATIC);
__gm_=allocate(468, ["i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"i32",0,0,0,"i32",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0,"*",0,0,0,"i32",0,0,0], ALLOC_STATIC);
_mparams=allocate(24, "i32", ALLOC_STATIC);
__ZL13__new_handler=allocate(1, "void ()*", ALLOC_STATIC);
__ZTVSt9bad_alloc=allocate([0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 8712, 0, 0, 0, 8714, 0, 0, 0], ["*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0,"*",0,0,0], ALLOC_STATIC);
allocate(1, "void*", ALLOC_STATIC);
STRING_TABLE.__str31798=allocate([115,116,100,58,58,98,97,100,95,97,108,108,111,99,0] /* std::bad_alloc\00 */, "i8", ALLOC_STATIC);
STRING_TABLE.__ZTSSt9bad_alloc=allocate([83,116,57,98,97,100,95,97,108,108,111,99,0] /* St9bad_alloc\00 */, "i8", ALLOC_STATIC);
__ZTISt9bad_alloc=allocate(12, "*", ALLOC_STATIC);
HEAP32[((__ZN11driver_list16s_drivers_sortedE)>>2)]=_driver____empty;
HEAP32[((__ZN11driver_list16s_drivers_sortedE+4)>>2)]=_driver_coleco;
HEAP32[((__ZN11driver_list16s_drivers_sortedE+8)>>2)]=_driver_colecoa;
HEAP32[((__ZN11driver_list16s_drivers_sortedE+12)>>2)]=_driver_colecob;
HEAP32[((__ZTV20resource_pool_objectI13driver_deviceE+4)>>2)]=__ZTI20resource_pool_objectI13driver_deviceE;
HEAP32[((__ZTI18resource_pool_item)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI18resource_pool_item+4)>>2)]=((STRING_TABLE.__ZTS18resource_pool_item)|0);
HEAP32[((__ZTI20resource_pool_objectI13driver_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13driver_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13driver_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI13driver_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV18resource_pool_item+4)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZL10rom_coleco)>>2)]=((STRING_TABLE.__str11)|0);
HEAP32[((__ZL10rom_coleco+20)>>2)]=((STRING_TABLE.__str112)|0);
HEAP32[((__ZL10rom_coleco+24)>>2)]=((STRING_TABLE.__str213)|0);
HEAP32[((__ZL10rom_coleco+44)>>2)]=((STRING_TABLE.__str314)|0);
HEAP32[((__ZL11rom_colecoa)>>2)]=((STRING_TABLE.__str11)|0);
HEAP32[((__ZL11rom_colecoa+20)>>2)]=((STRING_TABLE.__str415)|0);
HEAP32[((__ZL11rom_colecoa+24)>>2)]=((STRING_TABLE.__str516)|0);
HEAP32[((__ZL11rom_colecoa+44)>>2)]=((STRING_TABLE.__str314)|0);
HEAP32[((__ZL11rom_colecob)>>2)]=((STRING_TABLE.__str11)|0);
HEAP32[((__ZL11rom_colecob+20)>>2)]=((STRING_TABLE.__str617)|0);
HEAP32[((__ZL11rom_colecob+24)>>2)]=((STRING_TABLE.__str718)|0);
HEAP32[((__ZL11rom_colecob+44)>>2)]=((STRING_TABLE.__str314)|0);
HEAP32[((_driver_coleco)>>2)]=((STRING_TABLE.__str1021)|0);
HEAP32[((_driver_coleco+4)>>2)]=((STRING_TABLE.__str1122)|0);
HEAP32[((_driver_coleco+8)>>2)]=((STRING_TABLE.__str12)|0);
HEAP32[((_driver_coleco+12)>>2)]=((STRING_TABLE.__str13)|0);
HEAP32[((_driver_coleco+16)>>2)]=((STRING_TABLE.__str14)|0);
HEAP32[((_driver_coleco+20)>>2)]=((STRING_TABLE.__str15)|0);
HEAP32[((_driver_coleco+36)>>2)]=((__ZL10rom_coleco)|0);
HEAP32[((_driver_coleco+40)>>2)]=((STRING_TABLE.__str1122)|0);
HEAP32[((_driver_colecoa)>>2)]=((STRING_TABLE.__str1021)|0);
HEAP32[((_driver_colecoa+4)>>2)]=((STRING_TABLE.__str12)|0);
HEAP32[((_driver_colecoa+8)>>2)]=((STRING_TABLE.__str16)|0);
HEAP32[((_driver_colecoa+12)>>2)]=((STRING_TABLE.__str17)|0);
HEAP32[((_driver_colecoa+16)>>2)]=((STRING_TABLE.__str14)|0);
HEAP32[((_driver_colecoa+20)>>2)]=((STRING_TABLE.__str15)|0);
HEAP32[((_driver_colecoa+36)>>2)]=((__ZL11rom_colecoa)|0);
HEAP32[((_driver_colecoa+40)>>2)]=((STRING_TABLE.__str1122)|0);
HEAP32[((_driver_colecob)>>2)]=((STRING_TABLE.__str1021)|0);
HEAP32[((_driver_colecob+4)>>2)]=((STRING_TABLE.__str12)|0);
HEAP32[((_driver_colecob+8)>>2)]=((STRING_TABLE.__str18)|0);
HEAP32[((_driver_colecob+12)>>2)]=((STRING_TABLE.__str19)|0);
HEAP32[((_driver_colecob+16)>>2)]=((STRING_TABLE.__str20)|0);
HEAP32[((_driver_colecob+20)>>2)]=((STRING_TABLE.__str21)|0);
HEAP32[((_driver_colecob+36)>>2)]=((__ZL11rom_colecob)|0);
HEAP32[((_driver_colecob+40)>>2)]=((STRING_TABLE.__str1122)|0);
HEAP32[((__ZTV12coleco_state+4)>>2)]=__ZTI12coleco_state;
HEAP32[((__ZTI12coleco_state)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI12coleco_state+4)>>2)]=((STRING_TABLE.__ZTS12coleco_state)|0);
HEAP32[((__ZTI12coleco_state+8)>>2)]=__ZTI13driver_device;
HEAP32[((__ZTI13emu_exception)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI13emu_exception+4)>>2)]=((STRING_TABLE.__ZTS13emu_exception)|0);
HEAP32[((__ZTI13emu_exception+8)>>2)]=__ZTISt9exception;
HEAP32[((__ZTI14emu_fatalerror)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI14emu_fatalerror+4)>>2)]=((STRING_TABLE.__ZTS14emu_fatalerror)|0);
HEAP32[((__ZTI14emu_fatalerror+8)>>2)]=__ZTI13emu_exception;
HEAP32[((__ZTV14emu_fatalerror+4)>>2)]=__ZTI14emu_fatalerror;
HEAP32[((__ZTV13emu_exception+4)>>2)]=__ZTI13emu_exception;
HEAP32[((__ZTI18delegate_late_bind)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI18delegate_late_bind+4)>>2)]=((STRING_TABLE.__ZTS18delegate_late_bind)|0);
HEAP32[((__ZTVN8device_t15required_deviceI10cpu_deviceEE+4)>>2)]=__ZTIN8device_t15required_deviceI10cpu_deviceEE;
HEAP32[((__ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE+4)>>2)]=((STRING_TABLE.__ZTSN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE)|0);
HEAP32[((__ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE+8)>>2)]=__ZTIN8device_t16auto_finder_baseE;
HEAP32[((__ZTIN8device_t15required_deviceI10cpu_deviceEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTIN8device_t15required_deviceI10cpu_deviceEE+4)>>2)]=((STRING_TABLE.__ZTSN8device_t15required_deviceI10cpu_deviceEE)|0);
HEAP32[((__ZTIN8device_t15required_deviceI10cpu_deviceEE+8)>>2)]=__ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE;
HEAP32[((__ZTVN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE+4)>>2)]=__ZTIN8device_t16auto_finder_typeIP10cpu_deviceLb1EEE;
HEAP32[((__ZTV20resource_pool_objectI12coleco_stateE+4)>>2)]=__ZTI20resource_pool_objectI12coleco_stateE;
HEAP32[((__ZTI20resource_pool_objectI12coleco_stateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12coleco_stateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12coleco_stateE)|0);
HEAP32[((__ZTI20resource_pool_objectI12coleco_stateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV18mini_osd_interface+4)>>2)]=__ZTI18mini_osd_interface;
HEAP32[((__ZTI18mini_osd_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI18mini_osd_interface+4)>>2)]=((STRING_TABLE.__ZTS18mini_osd_interface)|0);
HEAP32[((__ZTI18mini_osd_interface+8)>>2)]=__ZTI13osd_interface;
HEAP32[((__ZTV12i8748_device+4)>>2)]=__ZTI12i8748_device;
HEAP32[((__ZTV12i8748_device+152)>>2)]=__ZTI12i8748_device;
HEAP32[((__ZTV12i8748_device+252)>>2)]=__ZTI12i8748_device;
HEAP32[((__ZTV12i8748_device+336)>>2)]=__ZTI12i8748_device;
HEAP32[((__ZTV12i8748_device+416)>>2)]=__ZTI12i8748_device;
HEAP32[((__ZTV12i8049_device+4)>>2)]=__ZTI12i8049_device;
HEAP32[((__ZTV12i8049_device+152)>>2)]=__ZTI12i8049_device;
HEAP32[((__ZTV12i8049_device+252)>>2)]=__ZTI12i8049_device;
HEAP32[((__ZTV12i8049_device+336)>>2)]=__ZTI12i8049_device;
HEAP32[((__ZTV12i8049_device+416)>>2)]=__ZTI12i8049_device;
HEAP32[((__ZTI12i8049_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI12i8049_device+4)>>2)]=((STRING_TABLE.__ZTS12i8049_device)|0);
HEAP32[((__ZTI12i8049_device+8)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTI12i8748_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI12i8748_device+4)>>2)]=((STRING_TABLE.__ZTS12i8748_device)|0);
HEAP32[((__ZTI12i8748_device+8)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTV20resource_pool_objectI12i8049_deviceE+4)>>2)]=__ZTI20resource_pool_objectI12i8049_deviceE;
HEAP32[((__ZTI20resource_pool_objectI12i8049_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12i8049_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12i8049_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI12i8049_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12i8748_deviceE+4)>>2)]=__ZTI20resource_pool_objectI12i8748_deviceE;
HEAP32[((__ZTI20resource_pool_objectI12i8748_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12i8748_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12i8748_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI12i8748_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI15running_machine)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI15running_machine+4)>>2)]=((STRING_TABLE.__ZTS15running_machine)|0);
HEAP32[((__ZTV10z80_device+4)>>2)]=__ZTI10z80_device;
HEAP32[((__ZTV10z80_device+152)>>2)]=__ZTI10z80_device;
HEAP32[((__ZTV10z80_device+252)>>2)]=__ZTI10z80_device;
HEAP32[((__ZTV10z80_device+336)>>2)]=__ZTI10z80_device;
HEAP32[((__ZTV10z80_device+416)>>2)]=__ZTI10z80_device;
HEAP32[((__ZTI10z80_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI10z80_device+4)>>2)]=((STRING_TABLE.__ZTS10z80_device)|0);
HEAP32[((__ZTI10z80_device+8)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTV20resource_pool_objectI10z80_deviceE+4)>>2)]=__ZTI20resource_pool_objectI10z80_deviceE;
HEAP32[((__ZTI20resource_pool_objectI10z80_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI10z80_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI10z80_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI10z80_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIhE+4)>>2)]=__ZTI19resource_pool_arrayIhE;
HEAP32[((__ZTI19resource_pool_arrayIhE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIhE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIhE)|0);
HEAP32[((__ZTI19resource_pool_arrayIhE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV25device_z80daisy_interface+4)>>2)]=__ZTI25device_z80daisy_interface;
HEAP32[((__ZTI25device_z80daisy_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI25device_z80daisy_interface+4)>>2)]=((STRING_TABLE.__ZTS25device_z80daisy_interface)|0);
HEAP32[((__ZTI25device_z80daisy_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE+4)>>2)]=__ZTI20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE;
HEAP32[((__ZTI20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN15z80_daisy_chain11daisy_entryEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZL8charinfo+4)>>2)]=((STRING_TABLE.__str321)|0);
HEAP32[((__ZL8charinfo+16)>>2)]=((STRING_TABLE.__str1322)|0);
HEAP32[((__ZL8charinfo+20)>>2)]=((STRING_TABLE.__str2323)|0);
HEAP32[((__ZL8charinfo+28)>>2)]=((STRING_TABLE.__str3324)|0);
HEAP32[((__ZL8charinfo+40)>>2)]=((STRING_TABLE.__str4325)|0);
HEAP32[((__ZL8charinfo+52)>>2)]=((STRING_TABLE.__str5326)|0);
HEAP32[((__ZL8charinfo+64)>>2)]=((STRING_TABLE.__str6327)|0);
HEAP32[((__ZL8charinfo+68)>>2)]=((STRING_TABLE.__str7328)|0);
HEAP32[((__ZL8charinfo+80)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+92)>>2)]=((STRING_TABLE.__str9330)|0);
HEAP32[((__ZL8charinfo+104)>>2)]=((STRING_TABLE.__str10331)|0);
HEAP32[((__ZL8charinfo+116)>>2)]=((STRING_TABLE.__str11332)|0);
HEAP32[((__ZL8charinfo+128)>>2)]=((STRING_TABLE.__str12333)|0);
HEAP32[((__ZL8charinfo+140)>>2)]=((STRING_TABLE.__str13334)|0);
HEAP32[((__ZL8charinfo+152)>>2)]=((STRING_TABLE.__str14335)|0);
HEAP32[((__ZL8charinfo+164)>>2)]=((STRING_TABLE.__str15336)|0);
HEAP32[((__ZL8charinfo+176)>>2)]=((STRING_TABLE.__str16337)|0);
HEAP32[((__ZL8charinfo+188)>>2)]=((STRING_TABLE.__str17338)|0);
HEAP32[((__ZL8charinfo+200)>>2)]=((STRING_TABLE.__str18339)|0);
HEAP32[((__ZL8charinfo+212)>>2)]=((STRING_TABLE.__str19340)|0);
HEAP32[((__ZL8charinfo+224)>>2)]=((STRING_TABLE.__str20341)|0);
HEAP32[((__ZL8charinfo+236)>>2)]=((STRING_TABLE.__str21342)|0);
HEAP32[((__ZL8charinfo+248)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+260)>>2)]=((STRING_TABLE.__str23344)|0);
HEAP32[((__ZL8charinfo+272)>>2)]=((STRING_TABLE.__str24345)|0);
HEAP32[((__ZL8charinfo+284)>>2)]=((STRING_TABLE.__str25346)|0);
HEAP32[((__ZL8charinfo+296)>>2)]=((STRING_TABLE.__str26347)|0);
HEAP32[((__ZL8charinfo+308)>>2)]=((STRING_TABLE.__str27348)|0);
HEAP32[((__ZL8charinfo+320)>>2)]=((STRING_TABLE.__str28349)|0);
HEAP32[((__ZL8charinfo+332)>>2)]=((STRING_TABLE.__str29350)|0);
HEAP32[((__ZL8charinfo+344)>>2)]=((STRING_TABLE.__str30351)|0);
HEAP32[((__ZL8charinfo+356)>>2)]=((STRING_TABLE.__str31352)|0);
HEAP32[((__ZL8charinfo+368)>>2)]=((STRING_TABLE.__str32353)|0);
HEAP32[((__ZL8charinfo+380)>>2)]=((STRING_TABLE.__str33354)|0);
HEAP32[((__ZL8charinfo+392)>>2)]=((STRING_TABLE.__str7328)|0);
HEAP32[((__ZL8charinfo+404)>>2)]=((STRING_TABLE.__str34355)|0);
HEAP32[((__ZL8charinfo+416)>>2)]=((STRING_TABLE.__str35356)|0);
HEAP32[((__ZL8charinfo+428)>>2)]=((STRING_TABLE.__str36357)|0);
HEAP32[((__ZL8charinfo+440)>>2)]=((STRING_TABLE.__str37358)|0);
HEAP32[((__ZL8charinfo+452)>>2)]=((STRING_TABLE.__str38359)|0);
HEAP32[((__ZL8charinfo+464)>>2)]=((STRING_TABLE.__str39360)|0);
HEAP32[((__ZL8charinfo+476)>>2)]=((STRING_TABLE.__str40361)|0);
HEAP32[((__ZL8charinfo+488)>>2)]=((STRING_TABLE.__str41362)|0);
HEAP32[((__ZL8charinfo+500)>>2)]=((STRING_TABLE.__str42363)|0);
HEAP32[((__ZL8charinfo+512)>>2)]=((STRING_TABLE.__str43364)|0);
HEAP32[((__ZL8charinfo+524)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+536)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+548)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+560)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+572)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+584)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+596)>>2)]=((STRING_TABLE.__str44365)|0);
HEAP32[((__ZL8charinfo+608)>>2)]=((STRING_TABLE.__str10331)|0);
HEAP32[((__ZL8charinfo+620)>>2)]=((STRING_TABLE.__str12333)|0);
HEAP32[((__ZL8charinfo+632)>>2)]=((STRING_TABLE.__str12333)|0);
HEAP32[((__ZL8charinfo+644)>>2)]=((STRING_TABLE.__str12333)|0);
HEAP32[((__ZL8charinfo+656)>>2)]=((STRING_TABLE.__str12333)|0);
HEAP32[((__ZL8charinfo+668)>>2)]=((STRING_TABLE.__str16337)|0);
HEAP32[((__ZL8charinfo+680)>>2)]=((STRING_TABLE.__str16337)|0);
HEAP32[((__ZL8charinfo+692)>>2)]=((STRING_TABLE.__str16337)|0);
HEAP32[((__ZL8charinfo+704)>>2)]=((STRING_TABLE.__str16337)|0);
HEAP32[((__ZL8charinfo+716)>>2)]=((STRING_TABLE.__str11332)|0);
HEAP32[((__ZL8charinfo+728)>>2)]=((STRING_TABLE.__str21342)|0);
HEAP32[((__ZL8charinfo+740)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+752)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+764)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+776)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+788)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+800)>>2)]=((STRING_TABLE.__str31352)|0);
HEAP32[((__ZL8charinfo+812)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+824)>>2)]=((STRING_TABLE.__str28349)|0);
HEAP32[((__ZL8charinfo+836)>>2)]=((STRING_TABLE.__str28349)|0);
HEAP32[((__ZL8charinfo+848)>>2)]=((STRING_TABLE.__str28349)|0);
HEAP32[((__ZL8charinfo+860)>>2)]=((STRING_TABLE.__str28349)|0);
HEAP32[((__ZL8charinfo+872)>>2)]=((STRING_TABLE.__str32353)|0);
HEAP32[((__ZL8charinfo+884)>>2)]=((STRING_TABLE.__str45366)|0);
HEAP32[((__ZL8charinfo+896)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+908)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+920)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+932)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+944)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+956)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+968)>>2)]=((STRING_TABLE.__str47368)|0);
HEAP32[((__ZL8charinfo+980)>>2)]=((STRING_TABLE.__str48369)|0);
HEAP32[((__ZL8charinfo+992)>>2)]=((STRING_TABLE.__str49370)|0);
HEAP32[((__ZL8charinfo+1004)>>2)]=((STRING_TABLE.__str49370)|0);
HEAP32[((__ZL8charinfo+1016)>>2)]=((STRING_TABLE.__str49370)|0);
HEAP32[((__ZL8charinfo+1028)>>2)]=((STRING_TABLE.__str49370)|0);
HEAP32[((__ZL8charinfo+1040)>>2)]=((STRING_TABLE.__str50371)|0);
HEAP32[((__ZL8charinfo+1052)>>2)]=((STRING_TABLE.__str50371)|0);
HEAP32[((__ZL8charinfo+1064)>>2)]=((STRING_TABLE.__str50371)|0);
HEAP32[((__ZL8charinfo+1076)>>2)]=((STRING_TABLE.__str50371)|0);
HEAP32[((__ZL8charinfo+1088)>>2)]=((STRING_TABLE.__str51372)|0);
HEAP32[((__ZL8charinfo+1100)>>2)]=((STRING_TABLE.__str52373)|0);
HEAP32[((__ZL8charinfo+1112)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+1124)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+1136)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+1148)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+1160)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+1172)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+1184)>>2)]=((STRING_TABLE.__str54375)|0);
HEAP32[((__ZL8charinfo+1196)>>2)]=((STRING_TABLE.__str54375)|0);
HEAP32[((__ZL8charinfo+1208)>>2)]=((STRING_TABLE.__str54375)|0);
HEAP32[((__ZL8charinfo+1220)>>2)]=((STRING_TABLE.__str54375)|0);
HEAP32[((__ZL8charinfo+1232)>>2)]=((STRING_TABLE.__str55376)|0);
HEAP32[((__ZL8charinfo+1244)>>2)]=((STRING_TABLE.__str55376)|0);
HEAP32[((__ZL8charinfo+1256)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1268)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1280)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1292)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1304)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1316)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1328)>>2)]=((STRING_TABLE.__str57378)|0);
HEAP32[((__ZL8charinfo+1340)>>2)]=((STRING_TABLE.__str57378)|0);
HEAP32[((__ZL8charinfo+1352)>>2)]=((STRING_TABLE.__str57378)|0);
HEAP32[((__ZL8charinfo+1364)>>2)]=((STRING_TABLE.__str57378)|0);
HEAP32[((__ZL8charinfo+1376)>>2)]=((STRING_TABLE.__str58379)|0);
HEAP32[((__ZL8charinfo+1388)>>2)]=((STRING_TABLE.__str58379)|0);
HEAP32[((__ZL8charinfo+1400)>>2)]=((STRING_TABLE.__str58379)|0);
HEAP32[((__ZL8charinfo+1412)>>2)]=((STRING_TABLE.__str58379)|0);
HEAP32[((__ZL8charinfo+1424)>>2)]=((STRING_TABLE.__str59380)|0);
HEAP32[((__ZL8charinfo+1436)>>2)]=((STRING_TABLE.__str60381)|0);
HEAP32[((__ZL8charinfo+1448)>>2)]=((STRING_TABLE.__str61382)|0);
HEAP32[((__ZL8charinfo+1460)>>2)]=((STRING_TABLE.__str62383)|0);
HEAP32[((__ZL8charinfo+1472)>>2)]=((STRING_TABLE.__str63384)|0);
HEAP32[((__ZL8charinfo+1484)>>2)]=((STRING_TABLE.__str64385)|0);
HEAP32[((__ZL8charinfo+1496)>>2)]=((STRING_TABLE.__str34355)|0);
HEAP32[((__ZL8charinfo+1508)>>2)]=((STRING_TABLE.__str58379)|0);
HEAP32[((__ZL8charinfo+1520)>>2)]=((STRING_TABLE.__str65386)|0);
HEAP32[((__ZL8charinfo+1532)>>2)]=((STRING_TABLE.__str66387)|0);
HEAP32[((__ZL8charinfo+1544)>>2)]=((STRING_TABLE.__str67388)|0);
HEAP32[((__ZL8charinfo+1556)>>2)]=((STRING_TABLE.__str68389)|0);
HEAP32[((__ZL8charinfo+1568)>>2)]=((STRING_TABLE.__str57378)|0);
HEAP32[((__ZL8charinfo+1580)>>2)]=((STRING_TABLE.__str69390)|0);
HEAP32[((__ZL8charinfo+1592)>>2)]=((STRING_TABLE.__str70391)|0);
HEAP32[((__ZL8charinfo+1604)>>2)]=((STRING_TABLE.__str71392)|0);
HEAP32[((__ZL8charinfo+1616)>>2)]=((STRING_TABLE.__str72393)|0);
HEAP32[((__ZL8charinfo+1628)>>2)]=((STRING_TABLE.__str73394)|0);
HEAP32[((__ZL8charinfo+1640)>>2)]=((STRING_TABLE.__str56377)|0);
HEAP32[((__ZL8charinfo+1652)>>2)]=((STRING_TABLE.__str59380)|0);
HEAP32[((__ZL8charinfo+1664)>>2)]=((STRING_TABLE.__str74395)|0);
HEAP32[((__ZL8charinfo+1676)>>2)]=((STRING_TABLE.__str75396)|0);
HEAP32[((__ZL8charinfo+1688)>>2)]=((STRING_TABLE.__str76397)|0);
HEAP32[((__ZL8charinfo+1700)>>2)]=((STRING_TABLE.__str77)|0);
HEAP32[((__ZL8charinfo+1712)>>2)]=((STRING_TABLE.__str78)|0);
HEAP32[((__ZL8charinfo+1724)>>2)]=((STRING_TABLE.__str79)|0);
HEAP32[((__ZL8charinfo+1736)>>2)]=((STRING_TABLE.__str80)|0);
HEAP32[((__ZL8charinfo+1748)>>2)]=((STRING_TABLE.__str81)|0);
HEAP32[((__ZL8charinfo+1760)>>2)]=((STRING_TABLE.__str82)|0);
HEAP32[((__ZL8charinfo+1772)>>2)]=((STRING_TABLE.__str83)|0);
HEAP32[((__ZL8charinfo+1784)>>2)]=((STRING_TABLE.__str84)|0);
HEAP32[((__ZL8charinfo+1796)>>2)]=((STRING_TABLE.__str85)|0);
HEAP32[((__ZL8charinfo+1808)>>2)]=((STRING_TABLE.__str86)|0);
HEAP32[((__ZL8charinfo+1820)>>2)]=((STRING_TABLE.__str87)|0);
HEAP32[((__ZL8charinfo+1832)>>2)]=((STRING_TABLE.__str88)|0);
HEAP32[((__ZL8charinfo+1844)>>2)]=((STRING_TABLE.__str89)|0);
HEAP32[((__ZL8charinfo+1856)>>2)]=((STRING_TABLE.__str43364)|0);
HEAP32[((__ZL8charinfo+1868)>>2)]=((STRING_TABLE.__str90)|0);
HEAP32[((__ZL8charinfo+1880)>>2)]=((STRING_TABLE.__str8329)|0);
HEAP32[((__ZL8charinfo+1892)>>2)]=((STRING_TABLE.__str9330)|0);
HEAP32[((__ZL8charinfo+1904)>>2)]=((STRING_TABLE.__str10331)|0);
HEAP32[((__ZL8charinfo+1916)>>2)]=((STRING_TABLE.__str11332)|0);
HEAP32[((__ZL8charinfo+1928)>>2)]=((STRING_TABLE.__str12333)|0);
HEAP32[((__ZL8charinfo+1940)>>2)]=((STRING_TABLE.__str13334)|0);
HEAP32[((__ZL8charinfo+1952)>>2)]=((STRING_TABLE.__str14335)|0);
HEAP32[((__ZL8charinfo+1964)>>2)]=((STRING_TABLE.__str15336)|0);
HEAP32[((__ZL8charinfo+1976)>>2)]=((STRING_TABLE.__str16337)|0);
HEAP32[((__ZL8charinfo+1988)>>2)]=((STRING_TABLE.__str17338)|0);
HEAP32[((__ZL8charinfo+2000)>>2)]=((STRING_TABLE.__str18339)|0);
HEAP32[((__ZL8charinfo+2012)>>2)]=((STRING_TABLE.__str19340)|0);
HEAP32[((__ZL8charinfo+2024)>>2)]=((STRING_TABLE.__str20341)|0);
HEAP32[((__ZL8charinfo+2036)>>2)]=((STRING_TABLE.__str21342)|0);
HEAP32[((__ZL8charinfo+2048)>>2)]=((STRING_TABLE.__str22343)|0);
HEAP32[((__ZL8charinfo+2060)>>2)]=((STRING_TABLE.__str23344)|0);
HEAP32[((__ZL8charinfo+2072)>>2)]=((STRING_TABLE.__str24345)|0);
HEAP32[((__ZL8charinfo+2084)>>2)]=((STRING_TABLE.__str25346)|0);
HEAP32[((__ZL8charinfo+2096)>>2)]=((STRING_TABLE.__str26347)|0);
HEAP32[((__ZL8charinfo+2108)>>2)]=((STRING_TABLE.__str27348)|0);
HEAP32[((__ZL8charinfo+2120)>>2)]=((STRING_TABLE.__str28349)|0);
HEAP32[((__ZL8charinfo+2132)>>2)]=((STRING_TABLE.__str29350)|0);
HEAP32[((__ZL8charinfo+2144)>>2)]=((STRING_TABLE.__str30351)|0);
HEAP32[((__ZL8charinfo+2156)>>2)]=((STRING_TABLE.__str31352)|0);
HEAP32[((__ZL8charinfo+2168)>>2)]=((STRING_TABLE.__str32353)|0);
HEAP32[((__ZL8charinfo+2180)>>2)]=((STRING_TABLE.__str33354)|0);
HEAP32[((__ZL8charinfo+2192)>>2)]=((STRING_TABLE.__str91)|0);
HEAP32[((__ZL8charinfo+2204)>>2)]=((STRING_TABLE.__str92)|0);
HEAP32[((__ZL8charinfo+2216)>>2)]=((STRING_TABLE.__str93)|0);
HEAP32[((__ZL8charinfo+2228)>>2)]=((STRING_TABLE.__str94)|0);
HEAP32[((__ZL8charinfo+2240)>>2)]=((STRING_TABLE.__str95)|0);
HEAP32[((__ZL8charinfo+2252)>>2)]=((STRING_TABLE.__str96)|0);
HEAP32[((__ZL8charinfo+2264)>>2)]=((STRING_TABLE.__str46367)|0);
HEAP32[((__ZL8charinfo+2276)>>2)]=((STRING_TABLE.__str97)|0);
HEAP32[((__ZL8charinfo+2288)>>2)]=((STRING_TABLE.__str48369)|0);
HEAP32[((__ZL8charinfo+2300)>>2)]=((STRING_TABLE.__str51372)|0);
HEAP32[((__ZL8charinfo+2312)>>2)]=((STRING_TABLE.__str49370)|0);
HEAP32[((__ZL8charinfo+2324)>>2)]=((STRING_TABLE.__str98)|0);
HEAP32[((__ZL8charinfo+2336)>>2)]=((STRING_TABLE.__str99)|0);
HEAP32[((__ZL8charinfo+2348)>>2)]=((STRING_TABLE.__str100)|0);
HEAP32[((__ZL8charinfo+2360)>>2)]=((STRING_TABLE.__str50371)|0);
HEAP32[((__ZL8charinfo+2372)>>2)]=((STRING_TABLE.__str101)|0);
HEAP32[((__ZL8charinfo+2384)>>2)]=((STRING_TABLE.__str102)|0);
HEAP32[((__ZL8charinfo+2396)>>2)]=((STRING_TABLE.__str103)|0);
HEAP32[((__ZL8charinfo+2408)>>2)]=((STRING_TABLE.__str104)|0);
HEAP32[((__ZL8charinfo+2420)>>2)]=((STRING_TABLE.__str52373)|0);
HEAP32[((__ZL8charinfo+2432)>>2)]=((STRING_TABLE.__str53374)|0);
HEAP32[((__ZL8charinfo+2444)>>2)]=((STRING_TABLE.__str105)|0);
HEAP32[((__ZL8charinfo+2456)>>2)]=((STRING_TABLE.__str106)|0);
HEAP32[((__ZL8charinfo+2468)>>2)]=((STRING_TABLE.__str107)|0);
HEAP32[((__ZL8charinfo+2480)>>2)]=((STRING_TABLE.__str108)|0);
HEAP32[((__ZL8charinfo+2492)>>2)]=((STRING_TABLE.__str109)|0);
HEAP32[((__ZL8charinfo+2504)>>2)]=((STRING_TABLE.__str54375)|0);
HEAP32[((__ZL8charinfo+2516)>>2)]=((STRING_TABLE.__str110)|0);
HEAP32[((__ZL8charinfo+2528)>>2)]=((STRING_TABLE.__str111)|0);
HEAP32[((__ZL8charinfo+2540)>>2)]=((STRING_TABLE.__str112398)|0);
HEAP32[((__ZL8charinfo+2552)>>2)]=((STRING_TABLE.__str55376)|0);
HEAP32[((__ZL8charinfo+2564)>>2)]=((STRING_TABLE.__str113)|0);
HEAP32[((__ZL8charinfo+2576)>>2)]=((STRING_TABLE.__str114)|0);
HEAP32[((__ZL8charinfo+2588)>>2)]=((STRING_TABLE.__str35356)|0);
HEAP32[((__ZL8charinfo+2600)>>2)]=((STRING_TABLE.__str115)|0);
HEAP32[((__ZL8charinfo+2612)>>2)]=((STRING_TABLE.__str116)|0);
HEAP32[((__ZL8charinfo+2624)>>2)]=((STRING_TABLE.__str117)|0);
HEAP32[((__ZL8charinfo+2636)>>2)]=((STRING_TABLE.__str118)|0);
HEAP32[((__ZL8charinfo+2648)>>2)]=((STRING_TABLE.__str119)|0);
HEAP32[((__ZL8charinfo+2660)>>2)]=((STRING_TABLE.__str120)|0);
HEAP32[((__ZL8charinfo+2672)>>2)]=((STRING_TABLE.__str121)|0);
HEAP32[((__ZL8charinfo+2684)>>2)]=((STRING_TABLE.__str122)|0);
HEAP32[((__ZL8charinfo+2696)>>2)]=((STRING_TABLE.__str123)|0);
HEAP32[((__ZL8charinfo+2708)>>2)]=((STRING_TABLE.__str124)|0);
HEAP32[((__ZL8charinfo+2720)>>2)]=((STRING_TABLE.__str125)|0);
HEAP32[((__ZL8charinfo+2732)>>2)]=((STRING_TABLE.__str126)|0);
HEAP32[((__ZL8charinfo+2744)>>2)]=((STRING_TABLE.__str127)|0);
HEAP32[((__ZL8charinfo+2756)>>2)]=((STRING_TABLE.__str128)|0);
HEAP32[((__ZL8charinfo+2768)>>2)]=((STRING_TABLE.__str129)|0);
HEAP32[((__ZL8charinfo+2776)>>2)]=((STRING_TABLE.__str130)|0);
HEAP32[((__ZL8charinfo+2788)>>2)]=((STRING_TABLE.__str131)|0);
HEAP32[((__ZL8charinfo+2800)>>2)]=((STRING_TABLE.__str132)|0);
HEAP32[((__ZL8charinfo+2812)>>2)]=((STRING_TABLE.__str133)|0);
HEAP32[((__ZL8charinfo+2824)>>2)]=((STRING_TABLE.__str134)|0);
HEAP32[((__ZL8charinfo+2836)>>2)]=((STRING_TABLE.__str135)|0);
HEAP32[((__ZL8charinfo+2848)>>2)]=((STRING_TABLE.__str136)|0);
HEAP32[((__ZL8charinfo+2860)>>2)]=((STRING_TABLE.__str137)|0);
HEAP32[((__ZL8charinfo+2872)>>2)]=((STRING_TABLE.__str138)|0);
HEAP32[((__ZL8charinfo+2884)>>2)]=((STRING_TABLE.__str139)|0);
HEAP32[((__ZL8charinfo+2896)>>2)]=((STRING_TABLE.__str140)|0);
HEAP32[((__ZL8charinfo+2908)>>2)]=((STRING_TABLE.__str141)|0);
HEAP32[((__ZL8charinfo+2920)>>2)]=((STRING_TABLE.__str142)|0);
HEAP32[((__ZL8charinfo+2932)>>2)]=((STRING_TABLE.__str143)|0);
HEAP32[((__ZL8charinfo+2944)>>2)]=((STRING_TABLE.__str144)|0);
HEAP32[((__ZL8charinfo+2956)>>2)]=((STRING_TABLE.__str145)|0);
HEAP32[((__ZL8charinfo+2968)>>2)]=((STRING_TABLE.__str146)|0);
HEAP32[((__ZL8charinfo+2980)>>2)]=((STRING_TABLE.__str5326)|0);
HEAP32[((__ZL8charinfo+2984)>>2)]=((STRING_TABLE.__str147399)|0);
HEAP32[((__ZL8charinfo+2992)>>2)]=((STRING_TABLE.__str148)|0);
HEAP32[((__ZL8charinfo+3004)>>2)]=((STRING_TABLE.__str149)|0);
HEAP32[((__ZL8charinfo+3008)>>2)]=((STRING_TABLE.__str150)|0);
HEAP32[((__ZL8charinfo+3016)>>2)]=((STRING_TABLE.__str151)|0);
HEAP32[((__ZL8charinfo+3020)>>2)]=((STRING_TABLE.__str152)|0);
HEAP32[((__ZL8charinfo+3028)>>2)]=((STRING_TABLE.__str153)|0);
HEAP32[((__ZL8charinfo+3040)>>2)]=((STRING_TABLE.__str154)|0);
HEAP32[((__ZL8charinfo+3052)>>2)]=((STRING_TABLE.__str155)|0);
HEAP32[((__ZL8charinfo+3064)>>2)]=((STRING_TABLE.__str156)|0);
HEAP32[((__ZL8charinfo+3076)>>2)]=((STRING_TABLE.__str157)|0);
HEAP32[((__ZL8charinfo+3088)>>2)]=((STRING_TABLE.__str158400)|0);
HEAP32[((__ZL8charinfo+3100)>>2)]=((STRING_TABLE.__str159)|0);
HEAP32[((__ZL8charinfo+3112)>>2)]=((STRING_TABLE.__str160)|0);
HEAP32[((__ZL8charinfo+3124)>>2)]=((STRING_TABLE.__str161)|0);
HEAP32[((__ZL8charinfo+3136)>>2)]=((STRING_TABLE.__str162)|0);
HEAP32[((__ZL8charinfo+3148)>>2)]=((STRING_TABLE.__str163)|0);
HEAP32[((__ZL8charinfo+3160)>>2)]=((STRING_TABLE.__str164)|0);
HEAP32[((__ZL8charinfo+3172)>>2)]=((STRING_TABLE.__str165)|0);
HEAP32[((__ZL8charinfo+3184)>>2)]=((STRING_TABLE.__str166)|0);
HEAP32[((__ZL8charinfo+3196)>>2)]=((STRING_TABLE.__str167)|0);
HEAP32[((__ZL8charinfo+3208)>>2)]=((STRING_TABLE.__str168)|0);
HEAP32[((__ZL8charinfo+3220)>>2)]=((STRING_TABLE.__str169)|0);
HEAP32[((__ZL8charinfo+3232)>>2)]=((STRING_TABLE.__str170401)|0);
HEAP32[((__ZL8charinfo+3244)>>2)]=((STRING_TABLE.__str171)|0);
HEAP32[((__ZL8charinfo+3256)>>2)]=((STRING_TABLE.__str172)|0);
HEAP32[((__ZL8charinfo+3268)>>2)]=((STRING_TABLE.__str173)|0);
HEAP32[((__ZL8charinfo+3280)>>2)]=((STRING_TABLE.__str174)|0);
HEAP32[((__ZL8charinfo+3292)>>2)]=((STRING_TABLE.__str175)|0);
HEAP32[((__ZL8charinfo+3304)>>2)]=((STRING_TABLE.__str176)|0);
HEAP32[((__ZL8charinfo+3316)>>2)]=((STRING_TABLE.__str177)|0);
HEAP32[((__ZL8charinfo+3328)>>2)]=((STRING_TABLE.__str178)|0);
HEAP32[((__ZL8charinfo+3340)>>2)]=((STRING_TABLE.__str179)|0);
HEAP32[((__ZL8charinfo+3352)>>2)]=((STRING_TABLE.__str180)|0);
HEAP32[((__ZL8charinfo+3364)>>2)]=((STRING_TABLE.__str181)|0);
HEAP32[((__ZL8charinfo+3376)>>2)]=((STRING_TABLE.__str182)|0);
HEAP32[((__ZL8charinfo+3388)>>2)]=((STRING_TABLE.__str183)|0);
HEAP32[((__ZL8charinfo+3400)>>2)]=((STRING_TABLE.__str184)|0);
HEAP32[((__ZL8charinfo+3412)>>2)]=((STRING_TABLE.__str185)|0);
HEAP32[((__ZL8charinfo+3424)>>2)]=((STRING_TABLE.__str186)|0);
HEAP32[((__ZL8charinfo+3436)>>2)]=((STRING_TABLE.__str187)|0);
HEAP32[((__ZL8charinfo+3448)>>2)]=((STRING_TABLE.__str188)|0);
HEAP32[((__ZL8charinfo+3460)>>2)]=((STRING_TABLE.__str189)|0);
HEAP32[((__ZL8charinfo+3472)>>2)]=((STRING_TABLE.__str190)|0);
HEAP32[((__ZL26input_port_default_strings+4)>>2)]=((STRING_TABLE.__str1464)|0);
HEAP32[((__ZL26input_port_default_strings+12)>>2)]=((STRING_TABLE.__str1465)|0);
HEAP32[((__ZL26input_port_default_strings+20)>>2)]=((STRING_TABLE.__str1466)|0);
HEAP32[((__ZL26input_port_default_strings+28)>>2)]=((STRING_TABLE.__str1467)|0);
HEAP32[((__ZL26input_port_default_strings+36)>>2)]=((STRING_TABLE.__str1468)|0);
HEAP32[((__ZL26input_port_default_strings+44)>>2)]=((STRING_TABLE.__str1469)|0);
HEAP32[((__ZL26input_port_default_strings+52)>>2)]=((STRING_TABLE.__str1470)|0);
HEAP32[((__ZL26input_port_default_strings+60)>>2)]=((STRING_TABLE.__str1471)|0);
HEAP32[((__ZL26input_port_default_strings+68)>>2)]=((STRING_TABLE.__str1472)|0);
HEAP32[((__ZL26input_port_default_strings+76)>>2)]=((STRING_TABLE.__str1473)|0);
HEAP32[((__ZL26input_port_default_strings+84)>>2)]=((STRING_TABLE.__str1474)|0);
HEAP32[((__ZL26input_port_default_strings+92)>>2)]=((STRING_TABLE.__str1475)|0);
HEAP32[((__ZL26input_port_default_strings+100)>>2)]=((STRING_TABLE.__str1476)|0);
HEAP32[((__ZL26input_port_default_strings+108)>>2)]=((STRING_TABLE.__str1477)|0);
HEAP32[((__ZL26input_port_default_strings+116)>>2)]=((STRING_TABLE.__str1478)|0);
HEAP32[((__ZL26input_port_default_strings+124)>>2)]=((STRING_TABLE.__str1479)|0);
HEAP32[((__ZL26input_port_default_strings+132)>>2)]=((STRING_TABLE.__str1480)|0);
HEAP32[((__ZL26input_port_default_strings+140)>>2)]=((STRING_TABLE.__str1481)|0);
HEAP32[((__ZL26input_port_default_strings+148)>>2)]=((STRING_TABLE.__str1482)|0);
HEAP32[((__ZL26input_port_default_strings+156)>>2)]=((STRING_TABLE.__str1483433)|0);
HEAP32[((__ZL26input_port_default_strings+164)>>2)]=((STRING_TABLE.__str1484)|0);
HEAP32[((__ZL26input_port_default_strings+172)>>2)]=((STRING_TABLE.__str1485)|0);
HEAP32[((__ZL26input_port_default_strings+180)>>2)]=((STRING_TABLE.__str1486)|0);
HEAP32[((__ZL26input_port_default_strings+188)>>2)]=((STRING_TABLE.__str1487)|0);
HEAP32[((__ZL26input_port_default_strings+196)>>2)]=((STRING_TABLE.__str1488)|0);
HEAP32[((__ZL26input_port_default_strings+204)>>2)]=((STRING_TABLE.__str1489)|0);
HEAP32[((__ZL26input_port_default_strings+212)>>2)]=((STRING_TABLE.__str1490)|0);
HEAP32[((__ZL26input_port_default_strings+220)>>2)]=((STRING_TABLE.__str1491)|0);
HEAP32[((__ZL26input_port_default_strings+228)>>2)]=((STRING_TABLE.__str1492)|0);
HEAP32[((__ZL26input_port_default_strings+236)>>2)]=((STRING_TABLE.__str1493)|0);
HEAP32[((__ZL26input_port_default_strings+244)>>2)]=((STRING_TABLE.__str1494)|0);
HEAP32[((__ZL26input_port_default_strings+252)>>2)]=((STRING_TABLE.__str1495)|0);
HEAP32[((__ZL26input_port_default_strings+260)>>2)]=((STRING_TABLE.__str1496)|0);
HEAP32[((__ZL26input_port_default_strings+268)>>2)]=((STRING_TABLE.__str1497)|0);
HEAP32[((__ZL26input_port_default_strings+276)>>2)]=((STRING_TABLE.__str1498)|0);
HEAP32[((__ZL26input_port_default_strings+284)>>2)]=((STRING_TABLE.__str1499)|0);
HEAP32[((__ZL26input_port_default_strings+292)>>2)]=((STRING_TABLE.__str1500)|0);
HEAP32[((__ZL26input_port_default_strings+300)>>2)]=((STRING_TABLE.__str1501)|0);
HEAP32[((__ZL26input_port_default_strings+308)>>2)]=((STRING_TABLE.__str1502)|0);
HEAP32[((__ZL26input_port_default_strings+316)>>2)]=((STRING_TABLE.__str1503)|0);
HEAP32[((__ZL26input_port_default_strings+324)>>2)]=((STRING_TABLE.__str1504)|0);
HEAP32[((__ZL26input_port_default_strings+332)>>2)]=((STRING_TABLE.__str1505)|0);
HEAP32[((__ZL26input_port_default_strings+340)>>2)]=((STRING_TABLE.__str1506)|0);
HEAP32[((__ZL26input_port_default_strings+348)>>2)]=((STRING_TABLE.__str1507)|0);
HEAP32[((__ZL26input_port_default_strings+356)>>2)]=((STRING_TABLE.__str1508)|0);
HEAP32[((__ZL26input_port_default_strings+364)>>2)]=((STRING_TABLE.__str1509)|0);
HEAP32[((__ZL26input_port_default_strings+372)>>2)]=((STRING_TABLE.__str1510)|0);
HEAP32[((__ZL26input_port_default_strings+380)>>2)]=((STRING_TABLE.__str1511)|0);
HEAP32[((__ZL26input_port_default_strings+388)>>2)]=((STRING_TABLE.__str1512)|0);
HEAP32[((__ZL26input_port_default_strings+396)>>2)]=((STRING_TABLE.__str1513)|0);
HEAP32[((__ZL26input_port_default_strings+404)>>2)]=((STRING_TABLE.__str1514)|0);
HEAP32[((__ZL26input_port_default_strings+412)>>2)]=((STRING_TABLE.__str177)|0);
HEAP32[((__ZL26input_port_default_strings+420)>>2)]=((STRING_TABLE.__str1515)|0);
HEAP32[((__ZL26input_port_default_strings+428)>>2)]=((STRING_TABLE.__str939)|0);
HEAP32[((__ZL26input_port_default_strings+436)>>2)]=((STRING_TABLE.__str1516)|0);
HEAP32[((__ZL26input_port_default_strings+444)>>2)]=((STRING_TABLE.__str1517)|0);
HEAP32[((__ZL26input_port_default_strings+452)>>2)]=((STRING_TABLE.__str1518)|0);
HEAP32[((__ZL26input_port_default_strings+460)>>2)]=((STRING_TABLE.__str1519)|0);
HEAP32[((__ZL26input_port_default_strings+468)>>2)]=((STRING_TABLE.__str1520)|0);
HEAP32[((__ZL26input_port_default_strings+476)>>2)]=((STRING_TABLE.__str1521)|0);
HEAP32[((__ZL26input_port_default_strings+484)>>2)]=((STRING_TABLE.__str1522)|0);
HEAP32[((__ZL26input_port_default_strings+492)>>2)]=((STRING_TABLE.__str1523)|0);
HEAP32[((__ZL26input_port_default_strings+500)>>2)]=((STRING_TABLE.__str1524)|0);
HEAP32[((__ZL26input_port_default_strings+508)>>2)]=((STRING_TABLE.__str1525)|0);
HEAP32[((__ZL26input_port_default_strings+516)>>2)]=((STRING_TABLE.__str1526)|0);
HEAP32[((__ZL26input_port_default_strings+524)>>2)]=((STRING_TABLE.__str1527)|0);
HEAP32[((__ZL26input_port_default_strings+532)>>2)]=((STRING_TABLE.__str1528)|0);
HEAP32[((__ZL26input_port_default_strings+540)>>2)]=((STRING_TABLE.__str1529)|0);
HEAP32[((__ZL26input_port_default_strings+548)>>2)]=((STRING_TABLE.__str1530)|0);
HEAP32[((__ZL26input_port_default_strings+556)>>2)]=((STRING_TABLE.__str1531)|0);
HEAP32[((__ZL26input_port_default_strings+564)>>2)]=((STRING_TABLE.__str1532)|0);
HEAP32[((__ZL26input_port_default_strings+572)>>2)]=((STRING_TABLE.__str1533)|0);
HEAP32[((__ZL26input_port_default_strings+580)>>2)]=((STRING_TABLE.__str1534)|0);
HEAP32[((__ZL26input_port_default_strings+588)>>2)]=((STRING_TABLE.__str1535)|0);
HEAP32[((__ZL26input_port_default_strings+596)>>2)]=((STRING_TABLE.__str1536)|0);
HEAP32[((__ZL26input_port_default_strings+604)>>2)]=((STRING_TABLE.__str1537)|0);
HEAP32[((__ZL26input_port_default_strings+612)>>2)]=((STRING_TABLE.__str1538)|0);
HEAP32[((__ZL26input_port_default_strings+620)>>2)]=((STRING_TABLE.__str1539)|0);
HEAP32[((__ZL26input_port_default_strings+628)>>2)]=((STRING_TABLE.__str1540)|0);
HEAP32[((__ZL26input_port_default_strings+636)>>2)]=((STRING_TABLE.__str1541)|0);
HEAP32[((__ZL26input_port_default_strings+644)>>2)]=((STRING_TABLE.__str1542)|0);
HEAP32[((__ZL26input_port_default_strings+652)>>2)]=((STRING_TABLE.__str1543)|0);
HEAP32[((__ZL26input_port_default_strings+660)>>2)]=((STRING_TABLE.__str1544)|0);
HEAP32[((__ZL26input_port_default_strings+668)>>2)]=((STRING_TABLE.__str1545)|0);
HEAP32[((__ZL26input_port_default_strings+676)>>2)]=((STRING_TABLE.__str1546)|0);
HEAP32[((__ZL26input_port_default_strings+684)>>2)]=((STRING_TABLE.__str1547)|0);
HEAP32[((__ZL26input_port_default_strings+692)>>2)]=((STRING_TABLE.__str1548)|0);
HEAP32[((__ZL26input_port_default_strings+700)>>2)]=((STRING_TABLE.__str1549)|0);
HEAP32[((__ZL26input_port_default_strings+708)>>2)]=((STRING_TABLE.__str333)|0);
HEAP32[((__ZL26input_port_default_strings+716)>>2)]=((STRING_TABLE.__str331)|0);
HEAP32[((__ZL26input_port_default_strings+724)>>2)]=((STRING_TABLE.__str1550)|0);
HEAP32[((__ZL26input_port_default_strings+732)>>2)]=((STRING_TABLE.__str1551)|0);
HEAP32[((__ZL26input_port_default_strings+740)>>2)]=((STRING_TABLE.__str1552)|0);
HEAP32[((__ZL26input_port_default_strings+748)>>2)]=((STRING_TABLE.__str1553)|0);
HEAP32[((__ZL26input_port_default_strings+756)>>2)]=((STRING_TABLE.__str1554)|0);
HEAP32[((__ZL26input_port_default_strings+764)>>2)]=((STRING_TABLE.__str1555)|0);
HEAP32[((__ZL26input_port_default_strings+772)>>2)]=((STRING_TABLE.__str1556)|0);
HEAP32[((__ZL26input_port_default_strings+780)>>2)]=((STRING_TABLE.__str1557)|0);
HEAP32[((__ZL26input_port_default_strings+788)>>2)]=((STRING_TABLE.__str1558)|0);
HEAP32[((__ZL26input_port_default_strings+796)>>2)]=((STRING_TABLE.__str1559)|0);
HEAP32[((__ZL26input_port_default_strings+804)>>2)]=((STRING_TABLE.__str1560)|0);
HEAP32[((__ZL26input_port_default_strings+812)>>2)]=((STRING_TABLE.__str1561)|0);
HEAP32[((__ZL26input_port_default_strings+820)>>2)]=((STRING_TABLE.__str1562)|0);
HEAP32[((__ZL26input_port_default_strings+828)>>2)]=((STRING_TABLE.__str1563)|0);
HEAP32[((__ZL26input_port_default_strings+836)>>2)]=((STRING_TABLE.__str1564)|0);
HEAP32[((__ZL26input_port_default_strings+844)>>2)]=((STRING_TABLE.__str1565)|0);
HEAP32[((__ZL26input_port_default_strings+852)>>2)]=((STRING_TABLE.__str1566)|0);
HEAP32[((__ZL26input_port_default_strings+860)>>2)]=((STRING_TABLE.__str1567)|0);
HEAP32[((__ZL26input_port_default_strings+868)>>2)]=((STRING_TABLE.__str1568)|0);
HEAP32[((__ZL26input_port_default_strings+876)>>2)]=((STRING_TABLE.__str1569)|0);
HEAP32[((__ZL26input_port_default_strings+884)>>2)]=((STRING_TABLE.__str1570)|0);
HEAP32[((__ZL26input_port_default_strings+892)>>2)]=((STRING_TABLE.__str1571)|0);
HEAP32[((__ZL26input_port_default_strings+900)>>2)]=((STRING_TABLE.__str1572)|0);
HEAP32[((__ZL26input_port_default_strings+908)>>2)]=((STRING_TABLE.__str1573)|0);
HEAP32[((__ZL26input_port_default_strings+916)>>2)]=((STRING_TABLE.__str1574)|0);
HEAP32[((__ZTV20resource_pool_objectI20input_setting_configE+4)>>2)]=__ZTI20resource_pool_objectI20input_setting_configE;
HEAP32[((__ZTI20resource_pool_objectI20input_setting_configE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI20input_setting_configE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI20input_setting_configE)|0);
HEAP32[((__ZTI20resource_pool_objectI20input_setting_configE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI18input_field_configE+4)>>2)]=__ZTI20resource_pool_objectI18input_field_configE;
HEAP32[((__ZTI20resource_pool_objectI18input_field_configE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18input_field_configE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18input_field_configE)|0);
HEAP32[((__ZTI20resource_pool_objectI18input_field_configE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17input_port_configE+4)>>2)]=__ZTI20resource_pool_objectI17input_port_configE;
HEAP32[((__ZTI20resource_pool_objectI17input_port_configE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17input_port_configE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17input_port_configE)|0);
HEAP32[((__ZTI20resource_pool_objectI17input_port_configE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI23input_field_diplocationE+4)>>2)]=__ZTI11simple_listI23input_field_diplocationE;
HEAP32[((__ZTI11simple_listI23input_field_diplocationE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI23input_field_diplocationE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI23input_field_diplocationE)|0);
HEAP32[((__ZTV11simple_listI20input_setting_configE+4)>>2)]=__ZTI11simple_listI20input_setting_configE;
HEAP32[((__ZTI11simple_listI20input_setting_configE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI20input_setting_configE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI20input_setting_configE)|0);
HEAP32[((__ZTV11simple_listI18input_field_configE+4)>>2)]=__ZTI11simple_listI18input_field_configE;
HEAP32[((__ZTI11simple_listI18input_field_configE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI18input_field_configE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI18input_field_configE)|0);
HEAP32[((__ZTV20resource_pool_objectI19_input_port_privateE+4)>>2)]=__ZTI20resource_pool_objectI19_input_port_privateE;
HEAP32[((__ZTI20resource_pool_objectI19_input_port_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI19_input_port_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI19_input_port_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI19_input_port_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI16input_type_entryE+4)>>2)]=__ZTI11simple_listI16input_type_entryE;
HEAP32[((__ZTI11simple_listI16input_type_entryE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI16input_type_entryE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI16input_type_entryE)|0);
HEAP32[((__ZTV20resource_pool_objectI16input_type_entryE+4)>>2)]=__ZTI20resource_pool_objectI16input_type_entryE;
HEAP32[((__ZTI20resource_pool_objectI16input_type_entryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16input_type_entryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16input_type_entryE)|0);
HEAP32[((__ZTI20resource_pool_objectI16input_type_entryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes)>>2)]=((STRING_TABLE.__str1375)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+8)>>2)]=((STRING_TABLE.__str1376)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+16)>>2)]=((STRING_TABLE.__str1377)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+24)>>2)]=((STRING_TABLE.__str1378)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+32)>>2)]=((STRING_TABLE.__str1379)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+40)>>2)]=((STRING_TABLE.__str1380)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+48)>>2)]=((STRING_TABLE.__str1381)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+56)>>2)]=((STRING_TABLE.__str1382432)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+64)>>2)]=((STRING_TABLE.__str1383)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+72)>>2)]=((STRING_TABLE.__str1384)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+80)>>2)]=((STRING_TABLE.__str1385)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+88)>>2)]=((STRING_TABLE.__str1386)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+96)>>2)]=((STRING_TABLE.__str1387)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+104)>>2)]=((STRING_TABLE.__str1388)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+112)>>2)]=((STRING_TABLE.__str1389)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+120)>>2)]=((STRING_TABLE.__str132)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+128)>>2)]=((STRING_TABLE.__str133)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+136)>>2)]=((STRING_TABLE.__str134)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+144)>>2)]=((STRING_TABLE.__str135)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+152)>>2)]=((STRING_TABLE.__str136)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+160)>>2)]=((STRING_TABLE.__str137)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+168)>>2)]=((STRING_TABLE.__str138)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+176)>>2)]=((STRING_TABLE.__str139)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+184)>>2)]=((STRING_TABLE.__str140)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+192)>>2)]=((STRING_TABLE.__str141)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+200)>>2)]=((STRING_TABLE.__str142)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+208)>>2)]=((STRING_TABLE.__str143)|0);
HEAP32[((__ZZL23inputx_postn_coded_rateR15running_machinePKcj8attotimeE5codes+216)>>2)]=((STRING_TABLE.__str1390)|0);
HEAP32[((__ZTV20resource_pool_objectI11_key_bufferE+4)>>2)]=__ZTI20resource_pool_objectI11_key_bufferE;
HEAP32[((__ZTI20resource_pool_objectI11_key_bufferE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11_key_bufferE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11_key_bufferE)|0);
HEAP32[((__ZTI20resource_pool_objectI11_key_bufferE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayI12_inputx_codeE+4)>>2)]=__ZTI19resource_pool_arrayI12_inputx_codeE;
HEAP32[((__ZTI19resource_pool_arrayI12_inputx_codeE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI12_inputx_codeE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI12_inputx_codeE)|0);
HEAP32[((__ZTI19resource_pool_arrayI12_inputx_codeE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI8emu_fileE+4)>>2)]=__ZTI20resource_pool_objectI8emu_fileE;
HEAP32[((__ZTI20resource_pool_objectI8emu_fileE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI8emu_fileE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI8emu_fileE)|0);
HEAP32[((__ZTI20resource_pool_objectI8emu_fileE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZL14seqtypestrings)>>2)]=((STRING_TABLE.__str1422)|0);
HEAP32[((__ZL14seqtypestrings+4)>>2)]=((STRING_TABLE.__str1423)|0);
HEAP32[((__ZL14seqtypestrings+8)>>2)]=((STRING_TABLE.__str1424)|0);
HEAP32[((__ZTV19resource_pool_arrayI10input_codeE+4)>>2)]=__ZTI19resource_pool_arrayI10input_codeE;
HEAP32[((__ZTI19resource_pool_arrayI10input_codeE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI10input_codeE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI10input_codeE)|0);
HEAP32[((__ZTI19resource_pool_arrayI10input_codeE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIcE+4)>>2)]=__ZTI19resource_pool_arrayIcE;
HEAP32[((__ZTI19resource_pool_arrayIcE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIcE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIcE)|0);
HEAP32[((__ZTI19resource_pool_arrayIcE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI18_device_field_infoE+4)>>2)]=__ZTI20resource_pool_objectI18_device_field_infoE;
HEAP32[((__ZTI20resource_pool_objectI18_device_field_infoE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18_device_field_infoE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18_device_field_infoE)|0);
HEAP32[((__ZTI20resource_pool_objectI18_device_field_infoE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI19_analog_field_stateE+4)>>2)]=__ZTI20resource_pool_objectI19_analog_field_stateE;
HEAP32[((__ZTI20resource_pool_objectI19_analog_field_stateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI19_analog_field_stateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI19_analog_field_stateE)|0);
HEAP32[((__ZTI20resource_pool_objectI19_analog_field_stateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI18_input_field_stateE+4)>>2)]=__ZTI20resource_pool_objectI18_input_field_stateE;
HEAP32[((__ZTI20resource_pool_objectI18_input_field_stateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18_input_field_stateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18_input_field_stateE)|0);
HEAP32[((__ZTI20resource_pool_objectI18_input_field_stateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17_input_port_stateE+4)>>2)]=__ZTI20resource_pool_objectI17_input_port_stateE;
HEAP32[((__ZTI20resource_pool_objectI17_input_port_stateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17_input_port_stateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17_input_port_stateE)|0);
HEAP32[((__ZTI20resource_pool_objectI17_input_port_stateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI8bitmap_tE+4)>>2)]=__ZTI20resource_pool_objectI8bitmap_tE;
HEAP32[((__ZTI20resource_pool_objectI8bitmap_tE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI8bitmap_tE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI8bitmap_tE)|0);
HEAP32[((__ZTI20resource_pool_objectI8bitmap_tE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZL15change_registerR15running_machineihE5modes)>>2)]=((STRING_TABLE.__str191608)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+4)>>2)]=((STRING_TABLE.__str201609)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+8)>>2)]=((STRING_TABLE.__str211610)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+12)>>2)]=((STRING_TABLE.__str221611)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+16)>>2)]=((STRING_TABLE.__str231612)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+20)>>2)]=((STRING_TABLE.__str241613)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+24)>>2)]=((STRING_TABLE.__str251614)|0);
HEAP32[((__ZZL15change_registerR15running_machineihE5modes+28)>>2)]=((STRING_TABLE.__str261615)|0);
HEAP32[((__ZTV12timer_device+4)>>2)]=__ZTI12timer_device;
HEAP32[((__ZTI12timer_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI12timer_device+4)>>2)]=((STRING_TABLE.__ZTS12timer_device)|0);
HEAP32[((__ZTI12timer_device+8)>>2)]=__ZTI8device_t;
HEAP32[((__ZTV20resource_pool_objectI12timer_deviceE+4)>>2)]=__ZTI20resource_pool_objectI12timer_deviceE;
HEAP32[((__ZTI20resource_pool_objectI12timer_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12timer_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12timer_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI12timer_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV15cartslot_device+4)>>2)]=__ZTI15cartslot_device;
HEAP32[((__ZTV15cartslot_device+144)>>2)]=__ZTI15cartslot_device;
HEAP32[((__ZTI15cartslot_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI15cartslot_device+4)>>2)]=((STRING_TABLE.__ZTS15cartslot_device)|0);
HEAP32[((__ZTI15cartslot_device+8)>>2)]=__ZTI24legacy_image_device_base;
HEAP32[((__ZTV20resource_pool_objectI15cartslot_deviceE+4)>>2)]=__ZTI20resource_pool_objectI15cartslot_deviceE;
HEAP32[((__ZTI20resource_pool_objectI15cartslot_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI15cartslot_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI15cartslot_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI15cartslot_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20software_list_device+4)>>2)]=__ZTI20software_list_device;
HEAP32[((__ZTI20software_list_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20software_list_device+4)>>2)]=((STRING_TABLE.__ZTS20software_list_device)|0);
HEAP32[((__ZTI20software_list_device+8)>>2)]=__ZTI18legacy_device_base;
HEAP32[((__ZTV20resource_pool_objectI20software_list_deviceE+4)>>2)]=__ZTI20resource_pool_objectI20software_list_deviceE;
HEAP32[((__ZTI20resource_pool_objectI20software_list_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI20software_list_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI20software_list_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI20software_list_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12feature_listE+4)>>2)]=__ZTI20resource_pool_objectI12feature_listE;
HEAP32[((__ZTI20resource_pool_objectI12feature_listE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12feature_listE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12feature_listE)|0);
HEAP32[((__ZTI20resource_pool_objectI12feature_listE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13software_partE+4)>>2)]=__ZTI20resource_pool_objectI13software_partE;
HEAP32[((__ZTI20resource_pool_objectI13software_partE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13software_partE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13software_partE)|0);
HEAP32[((__ZTI20resource_pool_objectI13software_partE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13software_infoE+4)>>2)]=__ZTI20resource_pool_objectI13software_infoE;
HEAP32[((__ZTI20resource_pool_objectI13software_infoE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13software_infoE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13software_infoE)|0);
HEAP32[((__ZTI20resource_pool_objectI13software_infoE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIiE+4)>>2)]=__ZTI19resource_pool_arrayIiE;
HEAP32[((__ZTI19resource_pool_arrayIiE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIiE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIiE)|0);
HEAP32[((__ZTI19resource_pool_arrayIiE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZN11cli_options16s_option_entriesE+12)>>2)]=((STRING_TABLE.__str1763)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+16)>>2)]=((STRING_TABLE.__str11764)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+20)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+28)>>2)]=((STRING_TABLE.__str31766)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+32)>>2)]=((STRING_TABLE.__str41767)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+36)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+44)>>2)]=((STRING_TABLE.__str51768)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+60)>>2)]=((STRING_TABLE.__str61769)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+64)>>2)]=((STRING_TABLE.__str71770)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+68)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+76)>>2)]=((STRING_TABLE.__str81771)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+80)>>2)]=((STRING_TABLE.__str91772)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+84)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+92)>>2)]=((STRING_TABLE.__str101773)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+96)>>2)]=((STRING_TABLE.__str111774)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+100)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+108)>>2)]=((STRING_TABLE.__str121775)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+124)>>2)]=((STRING_TABLE.__str131776)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+128)>>2)]=((STRING_TABLE.__str141777)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+132)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+140)>>2)]=((STRING_TABLE.__str151778)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+144)>>2)]=((STRING_TABLE.__str161779)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+148)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+156)>>2)]=((STRING_TABLE.__str171780)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+160)>>2)]=((STRING_TABLE.__str181781)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+164)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+172)>>2)]=((STRING_TABLE.__str191782)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+176)>>2)]=((STRING_TABLE.__str201783)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+180)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+188)>>2)]=((STRING_TABLE.__str211784)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+192)>>2)]=((STRING_TABLE.__str221785)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+196)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+204)>>2)]=((STRING_TABLE.__str231786)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+208)>>2)]=((STRING_TABLE.__str241787)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+212)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+220)>>2)]=((STRING_TABLE.__str251788)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+224)>>2)]=((STRING_TABLE.__str261789)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+228)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+236)>>2)]=((STRING_TABLE.__str271790)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+240)>>2)]=((STRING_TABLE.__str281791)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+244)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+252)>>2)]=((STRING_TABLE.__str291792)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+256)>>2)]=((STRING_TABLE.__str301793)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+260)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+268)>>2)]=((STRING_TABLE.__str311794)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+272)>>2)]=((STRING_TABLE.__str321795)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+276)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+284)>>2)]=((STRING_TABLE.__str331796)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+288)>>2)]=((STRING_TABLE.__str341797)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+292)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+300)>>2)]=((STRING_TABLE.__str351798)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+304)>>2)]=((STRING_TABLE.__str361799)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+308)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+316)>>2)]=((STRING_TABLE.__str371800)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+320)>>2)]=((STRING_TABLE.__str381801)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+324)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+332)>>2)]=((STRING_TABLE.__str391802)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+336)>>2)]=((STRING_TABLE.__str401803)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+340)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+348)>>2)]=((STRING_TABLE.__str411804)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+352)>>2)]=((STRING_TABLE.__str421805)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+356)>>2)]=((STRING_TABLE.__str21765)|0);
HEAP32[((__ZN11cli_options16s_option_entriesE+364)>>2)]=((STRING_TABLE.__str431806)|0);
HEAP32[((__ZTV11cli_options+4)>>2)]=__ZTI11cli_options;
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands)>>2)]=((STRING_TABLE.__str1591922)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+12)>>2)]=((STRING_TABLE.__str1601923)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+24)>>2)]=((STRING_TABLE.__str1611924)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+36)>>2)]=((STRING_TABLE.__str1621925)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+48)>>2)]=((STRING_TABLE.__str1631926)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+60)>>2)]=((STRING_TABLE.__str241787)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+72)>>2)]=((STRING_TABLE.__str1641927)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+84)>>2)]=((STRING_TABLE.__str1651928)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+96)>>2)]=((STRING_TABLE.__str261789)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+108)>>2)]=((STRING_TABLE.__str281791)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+120)>>2)]=((STRING_TABLE.__str301793)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+132)>>2)]=((STRING_TABLE.__str321795)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+144)>>2)]=((STRING_TABLE.__str1661929)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+156)>>2)]=((STRING_TABLE.__str1671930)|0);
HEAP32[((__ZZN12cli_frontend16execute_commandsEPKcE13info_commands+168)>>2)]=((STRING_TABLE.__str341797)|0);
HEAP32[((__ZTI11emu_options)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI11emu_options+4)>>2)]=((STRING_TABLE.__ZTS11emu_options)|0);
HEAP32[((__ZTI11emu_options+8)>>2)]=__ZTI12core_options;
HEAP32[((__ZTI11cli_options)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI11cli_options+4)>>2)]=((STRING_TABLE.__ZTS11cli_options)|0);
HEAP32[((__ZTI11cli_options+8)>>2)]=__ZTI11emu_options;
HEAP32[((__ZTV19resource_pool_arrayI7astringE+4)>>2)]=__ZTI19resource_pool_arrayI7astringE;
HEAP32[((__ZTI19resource_pool_arrayI7astringE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI7astringE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI7astringE)|0);
HEAP32[((__ZTI19resource_pool_arrayI7astringE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI12audit_recordE+4)>>2)]=__ZTI11simple_listI12audit_recordE;
HEAP32[((__ZTI11simple_listI12audit_recordE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI12audit_recordE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI12audit_recordE)|0);
HEAP32[((__ZTV11simple_listI8device_tE+4)>>2)]=__ZTI11simple_listI8device_tE;
HEAP32[((__ZTI11simple_listI8device_tE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI8device_tE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI8device_tE)|0);
HEAP32[((__ZTI27device_missing_dependencies)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI27device_missing_dependencies+4)>>2)]=((STRING_TABLE.__ZTS27device_missing_dependencies)|0);
HEAP32[((__ZTI27device_missing_dependencies+8)>>2)]=__ZTI13emu_exception;
HEAP32[((__ZTV8device_t+4)>>2)]=__ZTI8device_t;
HEAP32[((__ZTVN8device_t16auto_finder_baseE+4)>>2)]=__ZTIN8device_t16auto_finder_baseE;
HEAP32[((__ZTV16device_interface+4)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTI8device_t)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI8device_t+4)>>2)]=((STRING_TABLE.__ZTS8device_t)|0);
HEAP32[((__ZTI8device_t+8)>>2)]=__ZTI18delegate_late_bind;
HEAP32[((__ZTIN8device_t16auto_finder_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTIN8device_t16auto_finder_baseE+4)>>2)]=((STRING_TABLE.__ZTSN8device_t16auto_finder_baseE)|0);
HEAP32[((__ZTI16device_interface)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI16device_interface+4)>>2)]=((STRING_TABLE.__ZTS16device_interface)|0);
HEAP32[((__ZTV20resource_pool_objectI12device_debugE+4)>>2)]=__ZTI20resource_pool_objectI12device_debugE;
HEAP32[((__ZTI20resource_pool_objectI12device_debugE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12device_debugE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12device_debugE)|0);
HEAP32[((__ZTI20resource_pool_objectI12device_debugE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI11tagged_listI8device_tE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11tagged_listI8device_tE+4)>>2)]=((STRING_TABLE.__ZTS11tagged_listI8device_tE)|0);
HEAP32[((__ZTI11device_list)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI11device_list+4)>>2)]=((STRING_TABLE.__ZTS11device_list)|0);
HEAP32[((__ZTI11device_list+8)>>2)]=__ZTI11tagged_listI8device_tE;
HEAP32[((__ZTV18delegate_late_bind+4)>>2)]=__ZTI18delegate_late_bind;
HEAP32[((__ZTV20resource_pool_objectI18address_map_entry8E+4)>>2)]=__ZTI20resource_pool_objectI18address_map_entry8E;
HEAP32[((__ZTI20resource_pool_objectI18address_map_entry8E)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18address_map_entry8E+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18address_map_entry8E)|0);
HEAP32[((__ZTI20resource_pool_objectI18address_map_entry8E+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI17address_map_entryE+4)>>2)]=__ZTI11simple_listI17address_map_entryE;
HEAP32[((__ZTI11simple_listI17address_map_entryE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI17address_map_entryE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI17address_map_entryE)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+4)>>2)]=((STRING_TABLE.__str2093)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+8)>>2)]=((STRING_TABLE.__str12094)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+16)>>2)]=((STRING_TABLE.__str22095)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+20)>>2)]=((STRING_TABLE.__str32096)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+28)>>2)]=((STRING_TABLE.__str42097)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+32)>>2)]=((STRING_TABLE.__str52098)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+40)>>2)]=((STRING_TABLE.__str62099)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+44)>>2)]=((STRING_TABLE.__str72100)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+52)>>2)]=((STRING_TABLE.__str82101)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+56)>>2)]=((STRING_TABLE.__str92102)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+64)>>2)]=((STRING_TABLE.__str102103)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+68)>>2)]=((STRING_TABLE.__str112104)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+76)>>2)]=((STRING_TABLE.__str122105)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+80)>>2)]=((STRING_TABLE.__str132106)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+88)>>2)]=((STRING_TABLE.__str142107)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+92)>>2)]=((STRING_TABLE.__str152108)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+100)>>2)]=((STRING_TABLE.__str162109)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+104)>>2)]=((STRING_TABLE.__str172110)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+112)>>2)]=((STRING_TABLE.__str182111)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+116)>>2)]=((STRING_TABLE.__str192112)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+124)>>2)]=((STRING_TABLE.__str202113)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+128)>>2)]=((STRING_TABLE.__str212114)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+136)>>2)]=((STRING_TABLE.__str222115)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+140)>>2)]=((STRING_TABLE.__str232116)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+148)>>2)]=((STRING_TABLE.__str242117)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+152)>>2)]=((STRING_TABLE.__str252118)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+160)>>2)]=((STRING_TABLE.__str262119)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+164)>>2)]=((STRING_TABLE.__str272120)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+172)>>2)]=((STRING_TABLE.__str282121)|0);
HEAP32[((__ZN22device_image_interface19m_device_info_arrayE+176)>>2)]=((STRING_TABLE.__str292122)|0);
HEAP32[((__ZTV22device_image_interface+4)>>2)]=__ZTI22device_image_interface;
HEAP32[((__ZL8messages)>>2)]=((__str302123)|0);
HEAP32[((__ZL8messages+4)>>2)]=((STRING_TABLE.__str552150)|0);
HEAP32[((__ZL8messages+8)>>2)]=((STRING_TABLE.__str562151)|0);
HEAP32[((__ZL8messages+12)>>2)]=((STRING_TABLE.__str572152)|0);
HEAP32[((__ZL8messages+16)>>2)]=((STRING_TABLE.__str582153)|0);
HEAP32[((__ZL8messages+20)>>2)]=((STRING_TABLE.__str592154)|0);
HEAP32[((__ZL8messages+24)>>2)]=((STRING_TABLE.__str602155)|0);
HEAP32[((__ZL8messages+28)>>2)]=((STRING_TABLE.__str612156)|0);
HEAP32[((__ZTI22device_image_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22device_image_interface+4)>>2)]=((STRING_TABLE.__ZTS22device_image_interface)|0);
HEAP32[((__ZTI22device_image_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV23device_memory_interface+4)>>2)]=__ZTI23device_memory_interface;
HEAP32[((__ZTI23device_memory_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI23device_memory_interface+4)>>2)]=((STRING_TABLE.__ZTS23device_memory_interface)|0);
HEAP32[((__ZTI23device_memory_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV20resource_pool_objectI11address_mapE+4)>>2)]=__ZTI20resource_pool_objectI11address_mapE;
HEAP32[((__ZTI20resource_pool_objectI11address_mapE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11address_mapE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11address_mapE)|0);
HEAP32[((__ZTI20resource_pool_objectI11address_mapE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZL18itemid_token_table+4)>>2)]=((STRING_TABLE.__str2198)|0);
HEAP32[((__ZL18itemid_token_table+12)>>2)]=((STRING_TABLE.__str52199)|0);
HEAP32[((__ZL18itemid_token_table+20)>>2)]=((STRING_TABLE.__str62200)|0);
HEAP32[((__ZL18itemid_token_table+28)>>2)]=((STRING_TABLE.__str72201)|0);
HEAP32[((__ZL18itemid_token_table+36)>>2)]=((STRING_TABLE.__str82202)|0);
HEAP32[((__ZL18itemid_token_table+44)>>2)]=((STRING_TABLE.__str92203)|0);
HEAP32[((__ZL18itemid_token_table+52)>>2)]=((STRING_TABLE.__str102204)|0);
HEAP32[((__ZL18itemid_token_table+60)>>2)]=((STRING_TABLE.__str112205)|0);
HEAP32[((__ZL18itemid_token_table+68)>>2)]=((STRING_TABLE.__str122206)|0);
HEAP32[((__ZL18itemid_token_table+76)>>2)]=((STRING_TABLE.__str132207)|0);
HEAP32[((__ZL18itemid_token_table+84)>>2)]=((STRING_TABLE.__str142208)|0);
HEAP32[((__ZL18itemid_token_table+92)>>2)]=((STRING_TABLE.__str152209)|0);
HEAP32[((__ZL18itemid_token_table+100)>>2)]=((STRING_TABLE.__str162210)|0);
HEAP32[((__ZL18itemid_token_table+108)>>2)]=((STRING_TABLE.__str172211)|0);
HEAP32[((__ZL18itemid_token_table+116)>>2)]=((STRING_TABLE.__str182212)|0);
HEAP32[((__ZL18itemid_token_table+124)>>2)]=((STRING_TABLE.__str192213)|0);
HEAP32[((__ZL18itemid_token_table+132)>>2)]=((STRING_TABLE.__str202214)|0);
HEAP32[((__ZL18itemid_token_table+140)>>2)]=((STRING_TABLE.__str212215)|0);
HEAP32[((__ZL18itemid_token_table+148)>>2)]=((STRING_TABLE.__str222216)|0);
HEAP32[((__ZL18itemid_token_table+156)>>2)]=((STRING_TABLE.__str232217)|0);
HEAP32[((__ZL18itemid_token_table+164)>>2)]=((STRING_TABLE.__str242218)|0);
HEAP32[((__ZL18itemid_token_table+172)>>2)]=((STRING_TABLE.__str252219)|0);
HEAP32[((__ZL18itemid_token_table+180)>>2)]=((STRING_TABLE.__str262220)|0);
HEAP32[((__ZL18itemid_token_table+188)>>2)]=((STRING_TABLE.__str272221)|0);
HEAP32[((__ZL18itemid_token_table+196)>>2)]=((STRING_TABLE.__str282222)|0);
HEAP32[((__ZL18itemid_token_table+204)>>2)]=((STRING_TABLE.__str292223)|0);
HEAP32[((__ZL18itemid_token_table+212)>>2)]=((STRING_TABLE.__str302224)|0);
HEAP32[((__ZL18itemid_token_table+220)>>2)]=((STRING_TABLE.__str312225)|0);
HEAP32[((__ZL18itemid_token_table+228)>>2)]=((STRING_TABLE.__str322226)|0);
HEAP32[((__ZL18itemid_token_table+236)>>2)]=((STRING_TABLE.__str332227)|0);
HEAP32[((__ZL18itemid_token_table+244)>>2)]=((STRING_TABLE.__str342228)|0);
HEAP32[((__ZL18itemid_token_table+252)>>2)]=((STRING_TABLE.__str352229)|0);
HEAP32[((__ZL18itemid_token_table+260)>>2)]=((STRING_TABLE.__str362230)|0);
HEAP32[((__ZL18itemid_token_table+268)>>2)]=((STRING_TABLE.__str372231)|0);
HEAP32[((__ZL18itemid_token_table+276)>>2)]=((STRING_TABLE.__str382232)|0);
HEAP32[((__ZL18itemid_token_table+284)>>2)]=((STRING_TABLE.__str392233)|0);
HEAP32[((__ZL18itemid_token_table+292)>>2)]=((STRING_TABLE.__str402234)|0);
HEAP32[((__ZL18itemid_token_table+300)>>2)]=((STRING_TABLE.__str412235)|0);
HEAP32[((__ZL18itemid_token_table+308)>>2)]=((STRING_TABLE.__str422236)|0);
HEAP32[((__ZL18itemid_token_table+316)>>2)]=((STRING_TABLE.__str432237)|0);
HEAP32[((__ZL18itemid_token_table+324)>>2)]=((STRING_TABLE.__str442238)|0);
HEAP32[((__ZL18itemid_token_table+332)>>2)]=((STRING_TABLE.__str452239)|0);
HEAP32[((__ZL18itemid_token_table+340)>>2)]=((STRING_TABLE.__str462240)|0);
HEAP32[((__ZL18itemid_token_table+348)>>2)]=((STRING_TABLE.__str472241)|0);
HEAP32[((__ZL18itemid_token_table+356)>>2)]=((STRING_TABLE.__str482242)|0);
HEAP32[((__ZL18itemid_token_table+364)>>2)]=((STRING_TABLE.__str492243)|0);
HEAP32[((__ZL18itemid_token_table+372)>>2)]=((STRING_TABLE.__str502244)|0);
HEAP32[((__ZL18itemid_token_table+380)>>2)]=((STRING_TABLE.__str512245)|0);
HEAP32[((__ZL18itemid_token_table+388)>>2)]=((STRING_TABLE.__str522246)|0);
HEAP32[((__ZL18itemid_token_table+396)>>2)]=((STRING_TABLE.__str532247)|0);
HEAP32[((__ZL18itemid_token_table+404)>>2)]=((STRING_TABLE.__str542248)|0);
HEAP32[((__ZL18itemid_token_table+412)>>2)]=((STRING_TABLE.__str552249)|0);
HEAP32[((__ZL18itemid_token_table+420)>>2)]=((STRING_TABLE.__str562250)|0);
HEAP32[((__ZL18itemid_token_table+428)>>2)]=((STRING_TABLE.__str572251)|0);
HEAP32[((__ZL18itemid_token_table+436)>>2)]=((STRING_TABLE.__str582252)|0);
HEAP32[((__ZL18itemid_token_table+444)>>2)]=((STRING_TABLE.__str592253)|0);
HEAP32[((__ZL18itemid_token_table+452)>>2)]=((STRING_TABLE.__str602254)|0);
HEAP32[((__ZL18itemid_token_table+460)>>2)]=((STRING_TABLE.__str612255)|0);
HEAP32[((__ZL18itemid_token_table+468)>>2)]=((STRING_TABLE.__str622256)|0);
HEAP32[((__ZL18itemid_token_table+476)>>2)]=((STRING_TABLE.__str632257)|0);
HEAP32[((__ZL18itemid_token_table+484)>>2)]=((STRING_TABLE.__str642258)|0);
HEAP32[((__ZL18itemid_token_table+492)>>2)]=((STRING_TABLE.__str652259)|0);
HEAP32[((__ZL18itemid_token_table+500)>>2)]=((STRING_TABLE.__str662260)|0);
HEAP32[((__ZL18itemid_token_table+508)>>2)]=((STRING_TABLE.__str672261)|0);
HEAP32[((__ZL18itemid_token_table+516)>>2)]=((STRING_TABLE.__str682262)|0);
HEAP32[((__ZL18itemid_token_table+524)>>2)]=((STRING_TABLE.__str692263)|0);
HEAP32[((__ZL18itemid_token_table+532)>>2)]=((STRING_TABLE.__str702264)|0);
HEAP32[((__ZL18itemid_token_table+540)>>2)]=((STRING_TABLE.__str712265)|0);
HEAP32[((__ZL18itemid_token_table+548)>>2)]=((STRING_TABLE.__str722266)|0);
HEAP32[((__ZL18itemid_token_table+556)>>2)]=((STRING_TABLE.__str732267)|0);
HEAP32[((__ZL18itemid_token_table+564)>>2)]=((STRING_TABLE.__str742268)|0);
HEAP32[((__ZL18itemid_token_table+572)>>2)]=((STRING_TABLE.__str752269)|0);
HEAP32[((__ZL18itemid_token_table+580)>>2)]=((STRING_TABLE.__str762270)|0);
HEAP32[((__ZL18itemid_token_table+588)>>2)]=((STRING_TABLE.__str772271)|0);
HEAP32[((__ZL18itemid_token_table+596)>>2)]=((STRING_TABLE.__str782272)|0);
HEAP32[((__ZL18itemid_token_table+604)>>2)]=((STRING_TABLE.__str792273)|0);
HEAP32[((__ZL18itemid_token_table+612)>>2)]=((STRING_TABLE.__str802274)|0);
HEAP32[((__ZL18itemid_token_table+620)>>2)]=((STRING_TABLE.__str812275)|0);
HEAP32[((__ZL18itemid_token_table+628)>>2)]=((STRING_TABLE.__str822276)|0);
HEAP32[((__ZL18itemid_token_table+636)>>2)]=((STRING_TABLE.__str832277)|0);
HEAP32[((__ZL18itemid_token_table+644)>>2)]=((STRING_TABLE.__str842278)|0);
HEAP32[((__ZL18itemid_token_table+652)>>2)]=((STRING_TABLE.__str852279)|0);
HEAP32[((__ZL18itemid_token_table+660)>>2)]=((STRING_TABLE.__str862280)|0);
HEAP32[((__ZL18itemid_token_table+668)>>2)]=((STRING_TABLE.__str872281)|0);
HEAP32[((__ZL18itemid_token_table+676)>>2)]=((STRING_TABLE.__str882282)|0);
HEAP32[((__ZL18itemid_token_table+684)>>2)]=((STRING_TABLE.__str892283)|0);
HEAP32[((__ZL18itemid_token_table+692)>>2)]=((STRING_TABLE.__str902284)|0);
HEAP32[((__ZL18itemid_token_table+700)>>2)]=((STRING_TABLE.__str912285)|0);
HEAP32[((__ZL18itemid_token_table+708)>>2)]=((STRING_TABLE.__str922286)|0);
HEAP32[((__ZL18itemid_token_table+716)>>2)]=((STRING_TABLE.__str932287)|0);
HEAP32[((__ZL18itemid_token_table+724)>>2)]=((STRING_TABLE.__str942288)|0);
HEAP32[((__ZL18itemid_token_table+732)>>2)]=((STRING_TABLE.__str952289)|0);
HEAP32[((__ZL18itemid_token_table+740)>>2)]=((STRING_TABLE.__str962290)|0);
HEAP32[((__ZL18itemid_token_table+748)>>2)]=((STRING_TABLE.__str972291)|0);
HEAP32[((__ZL18itemid_token_table+756)>>2)]=((STRING_TABLE.__str982292)|0);
HEAP32[((__ZL18itemid_token_table+764)>>2)]=((STRING_TABLE.__str992293)|0);
HEAP32[((__ZL18itemid_token_table+772)>>2)]=((STRING_TABLE.__str1002294)|0);
HEAP32[((__ZL18itemid_token_table+780)>>2)]=((STRING_TABLE.__str1012295)|0);
HEAP32[((__ZL18itemid_token_table+788)>>2)]=((STRING_TABLE.__str1022296)|0);
HEAP32[((__ZL18itemid_token_table+796)>>2)]=((STRING_TABLE.__str1032297)|0);
HEAP32[((__ZL18itemid_token_table+804)>>2)]=((STRING_TABLE.__str1042298)|0);
HEAP32[((__ZL18itemid_token_table+812)>>2)]=((STRING_TABLE.__str1052299)|0);
HEAP32[((__ZL18itemid_token_table+820)>>2)]=((STRING_TABLE.__str1062300)|0);
HEAP32[((__ZL18itemid_token_table+828)>>2)]=((STRING_TABLE.__str1072301)|0);
HEAP32[((__ZL18itemid_token_table+836)>>2)]=((STRING_TABLE.__str1082302)|0);
HEAP32[((__ZL18itemid_token_table+844)>>2)]=((STRING_TABLE.__str1092303)|0);
HEAP32[((__ZL18itemid_token_table+852)>>2)]=((STRING_TABLE.__str1102304)|0);
HEAP32[((__ZL18itemid_token_table+860)>>2)]=((STRING_TABLE.__str1112305)|0);
HEAP32[((__ZL18itemid_token_table+868)>>2)]=((STRING_TABLE.__str1122306)|0);
HEAP32[((__ZL18itemid_token_table+876)>>2)]=((STRING_TABLE.__str1132307)|0);
HEAP32[((__ZL18itemid_token_table+884)>>2)]=((STRING_TABLE.__str1142308)|0);
HEAP32[((__ZL18itemid_token_table+892)>>2)]=((STRING_TABLE.__str1152309)|0);
HEAP32[((__ZL18itemid_token_table+900)>>2)]=((STRING_TABLE.__str1162310)|0);
HEAP32[((__ZL18itemid_token_table+908)>>2)]=((STRING_TABLE.__str1172311)|0);
HEAP32[((__ZL18itemid_token_table+916)>>2)]=((STRING_TABLE.__str1182312)|0);
HEAP32[((__ZL18itemid_token_table+924)>>2)]=((STRING_TABLE.__str1192313)|0);
HEAP32[((__ZL18itemid_token_table+932)>>2)]=((STRING_TABLE.__str1202314)|0);
HEAP32[((__ZL18itemid_token_table+940)>>2)]=((STRING_TABLE.__str1212315)|0);
HEAP32[((__ZL18itemid_token_table+948)>>2)]=((STRING_TABLE.__str1222316)|0);
HEAP32[((__ZL18itemid_token_table+956)>>2)]=((STRING_TABLE.__str1232317)|0);
HEAP32[((__ZL18itemid_token_table+964)>>2)]=((STRING_TABLE.__str1242318)|0);
HEAP32[((__ZL18itemid_token_table+972)>>2)]=((STRING_TABLE.__str1252319)|0);
HEAP32[((__ZL18itemid_token_table+980)>>2)]=((STRING_TABLE.__str1262320)|0);
HEAP32[((__ZL18itemid_token_table+988)>>2)]=((STRING_TABLE.__str1272321)|0);
HEAP32[((__ZL18itemid_token_table+996)>>2)]=((STRING_TABLE.__str1282322)|0);
HEAP32[((__ZL18itemid_token_table+1004)>>2)]=((STRING_TABLE.__str1292323)|0);
HEAP32[((__ZL18itemid_token_table+1012)>>2)]=((STRING_TABLE.__str1302324)|0);
HEAP32[((__ZL18itemid_token_table+1020)>>2)]=((STRING_TABLE.__str1312325)|0);
HEAP32[((__ZL18itemid_token_table+1028)>>2)]=((STRING_TABLE.__str1322326)|0);
HEAP32[((__ZL18itemid_token_table+1036)>>2)]=((STRING_TABLE.__str1332327)|0);
HEAP32[((__ZL18itemid_token_table+1044)>>2)]=((STRING_TABLE.__str1342328)|0);
HEAP32[((__ZL18itemid_token_table+1052)>>2)]=((STRING_TABLE.__str1352329)|0);
HEAP32[((__ZL18itemid_token_table+1060)>>2)]=((STRING_TABLE.__str1362330)|0);
HEAP32[((__ZL18itemid_token_table+1068)>>2)]=((STRING_TABLE.__str1372331)|0);
HEAP32[((__ZL18itemid_token_table+1076)>>2)]=((STRING_TABLE.__str1382332)|0);
HEAP32[((__ZL18itemid_token_table+1084)>>2)]=((STRING_TABLE.__str1392333)|0);
HEAP32[((__ZL18itemid_token_table+1092)>>2)]=((STRING_TABLE.__str1402334)|0);
HEAP32[((__ZL18itemid_token_table+1100)>>2)]=((STRING_TABLE.__str1412335)|0);
HEAP32[((__ZL18itemid_token_table+1108)>>2)]=((STRING_TABLE.__str1422336)|0);
HEAP32[((__ZL18itemid_token_table+1116)>>2)]=((STRING_TABLE.__str1432337)|0);
HEAP32[((__ZL18itemid_token_table+1124)>>2)]=((STRING_TABLE.__str1442338)|0);
HEAP32[((__ZL18itemid_token_table+1132)>>2)]=((STRING_TABLE.__str1452339)|0);
HEAP32[((__ZL18itemid_token_table+1140)>>2)]=((STRING_TABLE.__str1462340)|0);
HEAP32[((__ZL18itemid_token_table+1148)>>2)]=((STRING_TABLE.__str1472341)|0);
HEAP32[((__ZL18itemid_token_table+1156)>>2)]=((STRING_TABLE.__str1482342)|0);
HEAP32[((__ZL18itemid_token_table+1164)>>2)]=((STRING_TABLE.__str1492343)|0);
HEAP32[((__ZL18itemid_token_table+1172)>>2)]=((STRING_TABLE.__str1502344)|0);
HEAP32[((__ZL18itemid_token_table+1180)>>2)]=((STRING_TABLE.__str1512345)|0);
HEAP32[((__ZL18itemid_token_table+1188)>>2)]=((STRING_TABLE.__str1522346)|0);
HEAP32[((__ZL18itemid_token_table+1196)>>2)]=((STRING_TABLE.__str1532347)|0);
HEAP32[((__ZL18itemid_token_table+1204)>>2)]=((STRING_TABLE.__str1542348)|0);
HEAP32[((__ZL18itemid_token_table+1212)>>2)]=((STRING_TABLE.__str1552349)|0);
HEAP32[((__ZL18itemid_token_table+1220)>>2)]=((STRING_TABLE.__str1562350)|0);
HEAP32[((__ZL18itemid_token_table+1228)>>2)]=((STRING_TABLE.__str1572351)|0);
HEAP32[((__ZL18itemid_token_table+1236)>>2)]=((STRING_TABLE.__str1582352)|0);
HEAP32[((__ZL18itemid_token_table+1244)>>2)]=((STRING_TABLE.__str1592353)|0);
HEAP32[((__ZL18itemid_token_table+1252)>>2)]=((STRING_TABLE.__str1602354)|0);
HEAP32[((__ZL18itemid_token_table+1260)>>2)]=((STRING_TABLE.__str1612355)|0);
HEAP32[((__ZL18itemid_token_table+1268)>>2)]=((STRING_TABLE.__str1622356)|0);
HEAP32[((__ZL18itemid_token_table+1276)>>2)]=((STRING_TABLE.__str1632357)|0);
HEAP32[((__ZL18itemid_token_table+1284)>>2)]=((STRING_TABLE.__str1642358)|0);
HEAP32[((__ZL18itemid_token_table+1292)>>2)]=((STRING_TABLE.__str1652359)|0);
HEAP32[((__ZL18itemid_token_table+1300)>>2)]=((STRING_TABLE.__str1662360)|0);
HEAP32[((__ZL18itemid_token_table+1308)>>2)]=((STRING_TABLE.__str1672361)|0);
HEAP32[((__ZL18itemid_token_table+1316)>>2)]=((STRING_TABLE.__str1682362)|0);
HEAP32[((__ZL18itemid_token_table+1324)>>2)]=((STRING_TABLE.__str1692363)|0);
HEAP32[((__ZL18itemid_token_table+1332)>>2)]=((STRING_TABLE.__str1702364)|0);
HEAP32[((__ZL18itemid_token_table+1340)>>2)]=((STRING_TABLE.__str1712365)|0);
HEAP32[((__ZL18itemid_token_table+1348)>>2)]=((STRING_TABLE.__str1722366)|0);
HEAP32[((__ZL18itemid_token_table+1356)>>2)]=((STRING_TABLE.__str1732367)|0);
HEAP32[((__ZL18itemid_token_table+1364)>>2)]=((STRING_TABLE.__str1742368)|0);
HEAP32[((__ZL18itemid_token_table+1372)>>2)]=((STRING_TABLE.__str1752369)|0);
HEAP32[((__ZL18itemid_token_table+1380)>>2)]=((STRING_TABLE.__str1762370)|0);
HEAP32[((__ZL18itemid_token_table+1388)>>2)]=((STRING_TABLE.__str1772371)|0);
HEAP32[((__ZL18itemid_token_table+1396)>>2)]=((STRING_TABLE.__str1782372)|0);
HEAP32[((__ZL18itemid_token_table+1404)>>2)]=((STRING_TABLE.__str1792373)|0);
HEAP32[((__ZL18itemid_token_table+1412)>>2)]=((STRING_TABLE.__str1802374)|0);
HEAP32[((__ZL18itemid_token_table+1420)>>2)]=((STRING_TABLE.__str1812375)|0);
HEAP32[((__ZL18itemid_token_table+1428)>>2)]=((STRING_TABLE.__str1822376)|0);
HEAP32[((__ZL18itemid_token_table+1436)>>2)]=((STRING_TABLE.__str1832377)|0);
HEAP32[((__ZL18itemid_token_table+1444)>>2)]=((STRING_TABLE.__str1842378)|0);
HEAP32[((__ZL18itemid_token_table+1452)>>2)]=((STRING_TABLE.__str1852379)|0);
HEAP32[((__ZL18itemid_token_table+1460)>>2)]=((STRING_TABLE.__str1862380)|0);
HEAP32[((__ZL18itemid_token_table+1468)>>2)]=((STRING_TABLE.__str1872381)|0);
HEAP32[((__ZL18itemid_token_table+1476)>>2)]=((STRING_TABLE.__str1882382)|0);
HEAP32[((__ZL18itemid_token_table+1484)>>2)]=((STRING_TABLE.__str1892383)|0);
HEAP32[((__ZL18itemid_token_table+1492)>>2)]=((STRING_TABLE.__str1902384)|0);
HEAP32[((__ZL18itemid_token_table+1500)>>2)]=((STRING_TABLE.__str1912385)|0);
HEAP32[((__ZL18itemid_token_table+1508)>>2)]=((STRING_TABLE.__str1922386)|0);
HEAP32[((__ZL18itemid_token_table+1516)>>2)]=((STRING_TABLE.__str1932387)|0);
HEAP32[((__ZL18itemid_token_table+1524)>>2)]=((STRING_TABLE.__str1942388)|0);
HEAP32[((__ZL18itemid_token_table+1532)>>2)]=((STRING_TABLE.__str1952389)|0);
HEAP32[((__ZL18itemid_token_table+1540)>>2)]=((STRING_TABLE.__str1962390)|0);
HEAP32[((__ZL18itemid_token_table+1548)>>2)]=((STRING_TABLE.__str1972391)|0);
HEAP32[((__ZL18itemid_token_table+1556)>>2)]=((STRING_TABLE.__str1982392)|0);
HEAP32[((__ZL18itemid_token_table+1564)>>2)]=((STRING_TABLE.__str1992393)|0);
HEAP32[((__ZL18itemid_token_table+1572)>>2)]=((STRING_TABLE.__str2002394)|0);
HEAP32[((__ZL18itemid_token_table+1580)>>2)]=((STRING_TABLE.__str2012395)|0);
HEAP32[((__ZL18itemid_token_table+1588)>>2)]=((STRING_TABLE.__str2022396)|0);
HEAP32[((__ZL21devclass_string_table+4)>>2)]=((STRING_TABLE.__str2512449)|0);
HEAP32[((__ZL21devclass_string_table+12)>>2)]=((STRING_TABLE.__str2522450)|0);
HEAP32[((__ZL21devclass_string_table+20)>>2)]=((STRING_TABLE.__str2532451)|0);
HEAP32[((__ZL21devclass_string_table+28)>>2)]=((STRING_TABLE.__str2542452)|0);
HEAP32[((__ZL21devclass_string_table+36)>>2)]=((STRING_TABLE.__str2552453)|0);
HEAP32[((__ZL21modifier_string_table+4)>>2)]=((STRING_TABLE.__str2402438)|0);
HEAP32[((__ZL21modifier_string_table+12)>>2)]=((STRING_TABLE.__str2412439)|0);
HEAP32[((__ZL21modifier_string_table+20)>>2)]=((STRING_TABLE.__str2422440)|0);
HEAP32[((__ZL21modifier_string_table+28)>>2)]=((STRING_TABLE.__str2432441)|0);
HEAP32[((__ZL21modifier_string_table+36)>>2)]=((STRING_TABLE.__str2442442)|0);
HEAP32[((__ZL21modifier_string_table+44)>>2)]=((STRING_TABLE.__str2452443)|0);
HEAP32[((__ZL21modifier_string_table+52)>>2)]=((__str2182416)|0);
HEAP32[((__ZL20devclass_token_table+4)>>2)]=((STRING_TABLE.__str2352433)|0);
HEAP32[((__ZL20devclass_token_table+12)>>2)]=((STRING_TABLE.__str2362434)|0);
HEAP32[((__ZL20devclass_token_table+20)>>2)]=((STRING_TABLE.__str2372435)|0);
HEAP32[((__ZL20devclass_token_table+28)>>2)]=((STRING_TABLE.__str2382436)|0);
HEAP32[((__ZL20devclass_token_table+36)>>2)]=((STRING_TABLE.__str2392437)|0);
HEAP32[((__ZL20modifier_token_table+4)>>2)]=((STRING_TABLE.__str2332431)|0);
HEAP32[((__ZL20modifier_token_table+12)>>2)]=((STRING_TABLE.__str2342432)|0);
HEAP32[((__ZL20modifier_token_table+20)>>2)]=((STRING_TABLE.__str782272)|0);
HEAP32[((__ZL20modifier_token_table+28)>>2)]=((STRING_TABLE.__str792273)|0);
HEAP32[((__ZL20modifier_token_table+36)>>2)]=((STRING_TABLE.__str802274)|0);
HEAP32[((__ZL20modifier_token_table+44)>>2)]=((STRING_TABLE.__str812275)|0);
HEAP32[((__ZL20modifier_token_table+52)>>2)]=((__str2182416)|0);
HEAP32[((__ZL21itemclass_token_table+4)>>2)]=((STRING_TABLE.__str2302428)|0);
HEAP32[((__ZL21itemclass_token_table+12)>>2)]=((STRING_TABLE.__str2312429)|0);
HEAP32[((__ZL21itemclass_token_table+20)>>2)]=((STRING_TABLE.__str2322430)|0);
HEAP32[((__ZL21itemclass_token_table+28)>>2)]=((__str2182416)|0);
HEAP32[((__ZTV17input_device_item+4)>>2)]=__ZTI17input_device_item;
HEAP32[((__ZTV24input_device_switch_item+4)>>2)]=__ZTI24input_device_switch_item;
HEAP32[((__ZTV26input_device_relative_item+4)>>2)]=__ZTI26input_device_relative_item;
HEAP32[((__ZTV26input_device_absolute_item+4)>>2)]=__ZTI26input_device_absolute_item;
HEAP32[((__ZTI17input_device_item)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI17input_device_item+4)>>2)]=((STRING_TABLE.__ZTS17input_device_item)|0);
HEAP32[((__ZTI24input_device_switch_item)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI24input_device_switch_item+4)>>2)]=((STRING_TABLE.__ZTS24input_device_switch_item)|0);
HEAP32[((__ZTI24input_device_switch_item+8)>>2)]=__ZTI17input_device_item;
HEAP32[((__ZTI26input_device_relative_item)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI26input_device_relative_item+4)>>2)]=((STRING_TABLE.__ZTS26input_device_relative_item)|0);
HEAP32[((__ZTI26input_device_relative_item+8)>>2)]=__ZTI17input_device_item;
HEAP32[((__ZTI26input_device_absolute_item)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI26input_device_absolute_item+4)>>2)]=((STRING_TABLE.__ZTS26input_device_absolute_item)|0);
HEAP32[((__ZTI26input_device_absolute_item+8)>>2)]=__ZTI17input_device_item;
HEAP32[((__ZTV20resource_pool_objectI12input_deviceE+4)>>2)]=__ZTI20resource_pool_objectI12input_deviceE;
HEAP32[((__ZTI20resource_pool_objectI12input_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12input_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12input_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI12input_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI11input_class)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11input_class+4)>>2)]=((STRING_TABLE.__ZTS11input_class)|0);
HEAP32[((__ZTV20resource_pool_objectI26input_device_absolute_itemE+4)>>2)]=__ZTI20resource_pool_objectI26input_device_absolute_itemE;
HEAP32[((__ZTI20resource_pool_objectI26input_device_absolute_itemE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI26input_device_absolute_itemE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI26input_device_absolute_itemE)|0);
HEAP32[((__ZTI20resource_pool_objectI26input_device_absolute_itemE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI26input_device_relative_itemE+4)>>2)]=__ZTI20resource_pool_objectI26input_device_relative_itemE;
HEAP32[((__ZTI20resource_pool_objectI26input_device_relative_itemE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI26input_device_relative_itemE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI26input_device_relative_itemE)|0);
HEAP32[((__ZTI20resource_pool_objectI26input_device_relative_itemE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI24input_device_switch_itemE+4)>>2)]=__ZTI20resource_pool_objectI24input_device_switch_itemE;
HEAP32[((__ZTI20resource_pool_objectI24input_device_switch_itemE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI24input_device_switch_itemE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI24input_device_switch_itemE)|0);
HEAP32[((__ZTI20resource_pool_objectI24input_device_switch_itemE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes)>>2)]=((STRING_TABLE.__str412529)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+4)>>2)]=((STRING_TABLE.__str422530)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+8)>>2)]=((STRING_TABLE.__str432531)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+12)>>2)]=((STRING_TABLE.__str442532)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+16)>>2)]=((STRING_TABLE.__str452533)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+20)>>2)]=((STRING_TABLE.__str462534)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+24)>>2)]=((STRING_TABLE.__str472535)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+28)>>2)]=((STRING_TABLE.__str482536)|0);
HEAP32[((__ZZN12device_debug16watchpoint_checkER13address_spaceijyyE5sizes+32)>>2)]=((STRING_TABLE.__str492537)|0);
HEAP32[((__ZTI16expression_error)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI16expression_error+4)>>2)]=((STRING_TABLE.__ZTS16expression_error)|0);
HEAP32[((__ZTV20resource_pool_objectIN12device_debug6tracerEE+4)>>2)]=__ZTI20resource_pool_objectIN12device_debug6tracerEE;
HEAP32[((__ZTI20resource_pool_objectIN12device_debug6tracerEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12device_debug6tracerEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug6tracerEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12device_debug6tracerEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN12device_debug12dasm_commentEE+4)>>2)]=__ZTI20resource_pool_objectIN12device_debug12dasm_commentEE;
HEAP32[((__ZTI20resource_pool_objectIN12device_debug12dasm_commentEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12device_debug12dasm_commentEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug12dasm_commentEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12device_debug12dasm_commentEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIN12device_debug13hotspot_entryEE+4)>>2)]=__ZTI19resource_pool_arrayIN12device_debug13hotspot_entryEE;
HEAP32[((__ZTI19resource_pool_arrayIN12device_debug13hotspot_entryEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIN12device_debug13hotspot_entryEE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIN12device_debug13hotspot_entryEE)|0);
HEAP32[((__ZTI19resource_pool_arrayIN12device_debug13hotspot_entryEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN12device_debug10watchpointEE+4)>>2)]=__ZTI20resource_pool_objectIN12device_debug10watchpointEE;
HEAP32[((__ZTI20resource_pool_objectIN12device_debug10watchpointEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12device_debug10watchpointEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug10watchpointEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12device_debug10watchpointEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN12device_debug10breakpointEE+4)>>2)]=__ZTI20resource_pool_objectIN12device_debug10breakpointEE;
HEAP32[((__ZTI20resource_pool_objectIN12device_debug10breakpointEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12device_debug10breakpointEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12device_debug10breakpointEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12device_debug10breakpointEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN12device_debug12dasm_commentEE+4)>>2)]=__ZTI11simple_listIN12device_debug12dasm_commentEE;
HEAP32[((__ZTI11simple_listIN12device_debug12dasm_commentEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN12device_debug12dasm_commentEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN12device_debug12dasm_commentEE)|0);
HEAP32[((__ZTV20resource_pool_objectI12symbol_tableE+4)>>2)]=__ZTI20resource_pool_objectI12symbol_tableE;
HEAP32[((__ZTI20resource_pool_objectI12symbol_tableE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12symbol_tableE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12symbol_tableE)|0);
HEAP32[((__ZTI20resource_pool_objectI12symbol_tableE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17_debugcpu_privateE+4)>>2)]=__ZTI20resource_pool_objectI17_debugcpu_privateE;
HEAP32[((__ZTI20resource_pool_objectI17_debugcpu_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17_debugcpu_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17_debugcpu_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI17_debugcpu_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN17parsed_expression11parse_tokenEE+4)>>2)]=__ZTI11simple_listIN17parsed_expression11parse_tokenEE;
HEAP32[((__ZTI11simple_listIN17parsed_expression11parse_tokenEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN17parsed_expression11parse_tokenEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN17parsed_expression11parse_tokenEE)|0);
HEAP32[((__ZTV11simple_listIN17parsed_expression17expression_stringEE+4)>>2)]=__ZTI11simple_listIN17parsed_expression17expression_stringEE;
HEAP32[((__ZTI11simple_listIN17parsed_expression17expression_stringEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN17parsed_expression17expression_stringEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN17parsed_expression17expression_stringEE)|0);
HEAP32[((__ZTV11simple_listI12symbol_entryE+4)>>2)]=__ZTI11simple_listI12symbol_entryE;
HEAP32[((__ZTI11simple_listI12symbol_entryE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI12symbol_entryE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI12symbol_entryE)|0);
HEAP32[((__ZTV20resource_pool_objectIN12save_manager11state_entryEE+4)>>2)]=__ZTI20resource_pool_objectIN12save_manager11state_entryEE;
HEAP32[((__ZTI20resource_pool_objectIN12save_manager11state_entryEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12save_manager11state_entryEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12save_manager11state_entryEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12save_manager11state_entryEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN12save_manager14state_callbackEE+4)>>2)]=__ZTI20resource_pool_objectIN12save_manager14state_callbackEE;
HEAP32[((__ZTI20resource_pool_objectIN12save_manager14state_callbackEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12save_manager14state_callbackEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12save_manager14state_callbackEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12save_manager14state_callbackEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN12save_manager14state_callbackEE+4)>>2)]=__ZTI11simple_listIN12save_manager14state_callbackEE;
HEAP32[((__ZTI11simple_listIN12save_manager14state_callbackEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN12save_manager14state_callbackEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN12save_manager14state_callbackEE)|0);
HEAP32[((__ZTV11simple_listIN12save_manager11state_entryEE+4)>>2)]=__ZTI11simple_listIN12save_manager11state_entryEE;
HEAP32[((__ZTI11simple_listIN12save_manager11state_entryEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN12save_manager11state_entryEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN12save_manager11state_entryEE)|0);
HEAP32[((__ZTV13driver_device+4)>>2)]=__ZTI13driver_device;
HEAP32[((__ZTI13driver_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI13driver_device+4)>>2)]=((STRING_TABLE.__ZTS13driver_device)|0);
HEAP32[((__ZTI13driver_device+8)>>2)]=__ZTI8device_t;
HEAP32[((__ZTV20resource_pool_objectIN15running_machine22logerror_callback_itemEE+4)>>2)]=__ZTI20resource_pool_objectIN15running_machine22logerror_callback_itemEE;
HEAP32[((__ZTI20resource_pool_objectIN15running_machine22logerror_callback_itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN15running_machine22logerror_callback_itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN15running_machine22logerror_callback_itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN15running_machine22logerror_callback_itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN15running_machine22notifier_callback_itemEE+4)>>2)]=__ZTI20resource_pool_objectIN15running_machine22notifier_callback_itemEE;
HEAP32[((__ZTI20resource_pool_objectIN15running_machine22notifier_callback_itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN15running_machine22notifier_callback_itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN15running_machine22notifier_callback_itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN15running_machine22notifier_callback_itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13memory_regionE+4)>>2)]=__ZTI20resource_pool_objectI13memory_regionE;
HEAP32[((__ZTI20resource_pool_objectI13memory_regionE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13memory_regionE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13memory_regionE)|0);
HEAP32[((__ZTI20resource_pool_objectI13memory_regionE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13cheat_managerE+4)>>2)]=__ZTI20resource_pool_objectI13cheat_managerE;
HEAP32[((__ZTI20resource_pool_objectI13cheat_managerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13cheat_managerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13cheat_managerE)|0);
HEAP32[((__ZTI20resource_pool_objectI13cheat_managerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI11cheat_entryE+4)>>2)]=__ZTI11simple_listI11cheat_entryE;
HEAP32[((__ZTI11simple_listI11cheat_entryE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI11cheat_entryE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI11cheat_entryE)|0);
HEAP32[((__ZTV20resource_pool_objectI13sound_managerE+4)>>2)]=__ZTI20resource_pool_objectI13sound_managerE;
HEAP32[((__ZTI20resource_pool_objectI13sound_managerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13sound_managerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13sound_managerE)|0);
HEAP32[((__ZTI20resource_pool_objectI13sound_managerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13video_managerE+4)>>2)]=__ZTI20resource_pool_objectI13video_managerE;
HEAP32[((__ZTI20resource_pool_objectI13video_managerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13video_managerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13video_managerE)|0);
HEAP32[((__ZTI20resource_pool_objectI13video_managerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI14render_managerE+4)>>2)]=__ZTI20resource_pool_objectI14render_managerE;
HEAP32[((__ZTI20resource_pool_objectI14render_managerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14render_managerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14render_managerE)|0);
HEAP32[((__ZTI20resource_pool_objectI14render_managerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13input_managerE+4)>>2)]=__ZTI20resource_pool_objectI13input_managerE;
HEAP32[((__ZTI20resource_pool_objectI13input_managerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13input_managerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13input_managerE)|0);
HEAP32[((__ZTI20resource_pool_objectI13input_managerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN15running_machine22logerror_callback_itemEE+4)>>2)]=__ZTI11simple_listIN15running_machine22logerror_callback_itemEE;
HEAP32[((__ZTI11simple_listIN15running_machine22logerror_callback_itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN15running_machine22logerror_callback_itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN15running_machine22logerror_callback_itemEE)|0);
HEAP32[((__ZTV11simple_listIN15running_machine22notifier_callback_itemEE+4)>>2)]=__ZTI11simple_listIN15running_machine22notifier_callback_itemEE;
HEAP32[((__ZTI11simple_listIN15running_machine22notifier_callback_itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN15running_machine22notifier_callback_itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN15running_machine22notifier_callback_itemEE)|0);
HEAP32[((__ZTV11simple_listI17input_port_configE+4)>>2)]=__ZTI11simple_listI17input_port_configE;
HEAP32[((__ZTI11simple_listI17input_port_configE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI17input_port_configE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI17input_port_configE)|0);
HEAP32[((__ZTV11simple_listI13memory_regionE+4)>>2)]=__ZTI11simple_listI13memory_regionE;
HEAP32[((__ZTI11simple_listI13memory_regionE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI13memory_regionE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI13memory_regionE)|0);
HEAP32[((__ZTV27device_missing_dependencies+4)>>2)]=__ZTI27device_missing_dependencies;
HEAP32[((__ZTV13osd_interface+4)>>2)]=__ZTI13osd_interface;
HEAP32[((__ZTI13osd_interface)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13osd_interface+4)>>2)]=((STRING_TABLE.__ZTS13osd_interface)|0);
HEAP32[((__ZTV20resource_pool_objectI11render_fontE+4)>>2)]=__ZTI20resource_pool_objectI11render_fontE;
HEAP32[((__ZTI20resource_pool_objectI11render_fontE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11render_fontE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11render_fontE)|0);
HEAP32[((__ZTI20resource_pool_objectI11render_fontE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI14render_textureE+4)>>2)]=__ZTI20resource_pool_objectI14render_textureE;
HEAP32[((__ZTI20resource_pool_objectI14render_textureE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14render_textureE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14render_textureE)|0);
HEAP32[((__ZTI20resource_pool_objectI14render_textureE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI13render_targetE+4)>>2)]=__ZTI20resource_pool_objectI13render_targetE;
HEAP32[((__ZTI20resource_pool_objectI13render_targetE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13render_targetE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13render_targetE)|0);
HEAP32[((__ZTI20resource_pool_objectI13render_targetE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI14render_manager)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI14render_manager+4)>>2)]=((STRING_TABLE.__ZTS14render_manager)|0);
HEAP32[((__ZTV11simple_listI13render_targetE+4)>>2)]=__ZTI11simple_listI13render_targetE;
HEAP32[((__ZTI11simple_listI13render_targetE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI13render_targetE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI13render_targetE)|0);
HEAP32[((__ZTV20resource_pool_objectI16render_containerE+4)>>2)]=__ZTI20resource_pool_objectI16render_containerE;
HEAP32[((__ZTI20resource_pool_objectI16render_containerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16render_containerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16render_containerE)|0);
HEAP32[((__ZTI20resource_pool_objectI16render_containerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI14render_textureE+4)>>2)]=__ZTI11simple_listI14render_textureE;
HEAP32[((__ZTI11simple_listI14render_textureE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI14render_textureE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI14render_textureE)|0);
HEAP32[((__ZTV20resource_pool_objectI11layout_fileE+4)>>2)]=__ZTI20resource_pool_objectI11layout_fileE;
HEAP32[((__ZTI20resource_pool_objectI11layout_fileE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11layout_fileE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11layout_fileE)|0);
HEAP32[((__ZTI20resource_pool_objectI11layout_fileE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI16render_containerE+4)>>2)]=__ZTI11simple_listI16render_containerE;
HEAP32[((__ZTI11simple_listI16render_containerE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI16render_containerE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI16render_containerE)|0);
HEAP32[((__ZTV20resource_pool_objectI11simple_listI11layout_fileEE+4)>>2)]=__ZTI20resource_pool_objectI11simple_listI11layout_fileEE;
HEAP32[((__ZTI20resource_pool_objectI11simple_listI11layout_fileEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11simple_listI11layout_fileEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11simple_listI11layout_fileEE)|0);
HEAP32[((__ZTI20resource_pool_objectI11simple_listI11layout_fileEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI11layout_fileE+4)>>2)]=__ZTI11simple_listI11layout_fileE;
HEAP32[((__ZTI11simple_listI11layout_fileE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI11layout_fileE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI11layout_fileE)|0);
HEAP32[((__ZTV20resource_pool_objectIN16render_container4itemEE+4)>>2)]=__ZTI20resource_pool_objectIN16render_container4itemEE;
HEAP32[((__ZTI20resource_pool_objectIN16render_container4itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN16render_container4itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN16render_container4itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN16render_container4itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN16render_container4itemEE+4)>>2)]=__ZTI11simple_listIN16render_container4itemEE;
HEAP32[((__ZTI11simple_listIN16render_container4itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN16render_container4itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN16render_container4itemEE)|0);
HEAP32[((__ZTV19resource_pool_arrayIjE+4)>>2)]=__ZTI19resource_pool_arrayIjE;
HEAP32[((__ZTI19resource_pool_arrayIjE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIjE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIjE)|0);
HEAP32[((__ZTI19resource_pool_arrayIjE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN21render_primitive_list9referenceEE+4)>>2)]=__ZTI11simple_listIN21render_primitive_list9referenceEE;
HEAP32[((__ZTI11simple_listIN21render_primitive_list9referenceEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN21render_primitive_list9referenceEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN21render_primitive_list9referenceEE)|0);
HEAP32[((__ZTV11simple_listI16render_primitiveE+4)>>2)]=__ZTI11simple_listI16render_primitiveE;
HEAP32[((__ZTI11simple_listI16render_primitiveE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI16render_primitiveE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI16render_primitiveE)|0);
HEAP32[((__ZTV20resource_pool_objectI16render_primitiveE+4)>>2)]=__ZTI20resource_pool_objectI16render_primitiveE;
HEAP32[((__ZTI20resource_pool_objectI16render_primitiveE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16render_primitiveE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16render_primitiveE)|0);
HEAP32[((__ZTI20resource_pool_objectI16render_primitiveE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN21render_primitive_list9referenceEE+4)>>2)]=__ZTI20resource_pool_objectIN21render_primitive_list9referenceEE;
HEAP32[((__ZTI20resource_pool_objectIN21render_primitive_list9referenceEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN21render_primitive_list9referenceEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN21render_primitive_list9referenceEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN21render_primitive_list9referenceEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV13screen_device+4)>>2)]=__ZTI13screen_device;
HEAP32[((__ZTI13screen_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI13screen_device+4)>>2)]=((STRING_TABLE.__ZTS13screen_device)|0);
HEAP32[((__ZTI13screen_device+8)>>2)]=__ZTI8device_t;
HEAP32[((__ZTV20resource_pool_objectIN13screen_device13callback_itemEE+4)>>2)]=__ZTI20resource_pool_objectIN13screen_device13callback_itemEE;
HEAP32[((__ZTI20resource_pool_objectIN13screen_device13callback_itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN13screen_device13callback_itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN13screen_device13callback_itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN13screen_device13callback_itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN13screen_device13callback_itemEE+4)>>2)]=__ZTI11simple_listIN13screen_device13callback_itemEE;
HEAP32[((__ZTI11simple_listIN13screen_device13callback_itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN13screen_device13callback_itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN13screen_device13callback_itemEE)|0);
HEAP32[((__ZTV20resource_pool_objectI13screen_deviceE+4)>>2)]=__ZTI20resource_pool_objectI13screen_deviceE;
HEAP32[((__ZTI20resource_pool_objectI13screen_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13screen_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13screen_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI13screen_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN16device_scheduler12quantum_slotEE+4)>>2)]=__ZTI20resource_pool_objectIN16device_scheduler12quantum_slotEE;
HEAP32[((__ZTI20resource_pool_objectIN16device_scheduler12quantum_slotEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN16device_scheduler12quantum_slotEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN16device_scheduler12quantum_slotEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN16device_scheduler12quantum_slotEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI9emu_timerE+4)>>2)]=__ZTI11simple_listI9emu_timerE;
HEAP32[((__ZTI11simple_listI9emu_timerE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI9emu_timerE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI9emu_timerE)|0);
HEAP32[((__ZTI16device_scheduler)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI16device_scheduler+4)>>2)]=((STRING_TABLE.__ZTS16device_scheduler)|0);
HEAP32[((__ZTV20resource_pool_objectI9emu_timerE+4)>>2)]=__ZTI20resource_pool_objectI9emu_timerE;
HEAP32[((__ZTI20resource_pool_objectI9emu_timerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI9emu_timerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI9emu_timerE)|0);
HEAP32[((__ZTI20resource_pool_objectI9emu_timerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN16device_scheduler12quantum_slotEE+4)>>2)]=__ZTI11simple_listIN16device_scheduler12quantum_slotEE;
HEAP32[((__ZTI11simple_listIN16device_scheduler12quantum_slotEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN16device_scheduler12quantum_slotEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN16device_scheduler12quantum_slotEE)|0);
HEAP32[((__ZTV13address_space+4)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV13address_table+4)>>2)]=__ZTI13address_table;
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings)>>2)]=((STRING_TABLE.__str422933)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+4)>>2)]=((STRING_TABLE.__str432934)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+8)>>2)]=((STRING_TABLE.__str442935)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+12)>>2)]=((STRING_TABLE.__str452936)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+16)>>2)]=((STRING_TABLE.__str462937)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+20)>>2)]=((STRING_TABLE.__str472938)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+24)>>2)]=((STRING_TABLE.__str482939)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+28)>>2)]=((STRING_TABLE.__str492940)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+32)>>2)]=((STRING_TABLE.__str502941)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+36)>>2)]=((STRING_TABLE.__str512942)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+40)>>2)]=((STRING_TABLE.__str522943)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+44)>>2)]=((STRING_TABLE.__str532944)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+48)>>2)]=((STRING_TABLE.__str542945)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+52)>>2)]=((STRING_TABLE.__str552946)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+56)>>2)]=((STRING_TABLE.__str562947)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+60)>>2)]=((STRING_TABLE.__str572948)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+64)>>2)]=((STRING_TABLE.__str582949)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+68)>>2)]=((STRING_TABLE.__str592950)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+72)>>2)]=((STRING_TABLE.__str602951)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+76)>>2)]=((STRING_TABLE.__str612952)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+80)>>2)]=((STRING_TABLE.__str622953)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+84)>>2)]=((STRING_TABLE.__str632954)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+88)>>2)]=((STRING_TABLE.__str642955)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+92)>>2)]=((STRING_TABLE.__str652956)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+96)>>2)]=((STRING_TABLE.__str662957)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+100)>>2)]=((STRING_TABLE.__str672958)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+104)>>2)]=((STRING_TABLE.__str682959)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+108)>>2)]=((STRING_TABLE.__str692960)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+112)>>2)]=((STRING_TABLE.__str702961)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+116)>>2)]=((STRING_TABLE.__str712962)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+120)>>2)]=((STRING_TABLE.__str722963)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+124)>>2)]=((STRING_TABLE.__str732964)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+128)>>2)]=((STRING_TABLE.__str742965)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+132)>>2)]=((STRING_TABLE.__str752966)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+136)>>2)]=((STRING_TABLE.__str762967)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+140)>>2)]=((STRING_TABLE.__str772968)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+144)>>2)]=((STRING_TABLE.__str782969)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+148)>>2)]=((STRING_TABLE.__str792970)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+152)>>2)]=((STRING_TABLE.__str802971)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+156)>>2)]=((STRING_TABLE.__str812972)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+160)>>2)]=((STRING_TABLE.__str822973)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+164)>>2)]=((STRING_TABLE.__str832974)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+168)>>2)]=((STRING_TABLE.__str842975)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+172)>>2)]=((STRING_TABLE.__str852976)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+176)>>2)]=((STRING_TABLE.__str862977)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+180)>>2)]=((STRING_TABLE.__str872978)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+184)>>2)]=((STRING_TABLE.__str882979)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+188)>>2)]=((STRING_TABLE.__str892980)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+192)>>2)]=((STRING_TABLE.__str902981)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+196)>>2)]=((STRING_TABLE.__str912982)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+200)>>2)]=((STRING_TABLE.__str922983)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+204)>>2)]=((STRING_TABLE.__str932984)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+208)>>2)]=((STRING_TABLE.__str942985)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+212)>>2)]=((STRING_TABLE.__str952986)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+216)>>2)]=((STRING_TABLE.__str962987)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+220)>>2)]=((STRING_TABLE.__str972988)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+224)>>2)]=((STRING_TABLE.__str982989)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+228)>>2)]=((STRING_TABLE.__str992990)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+232)>>2)]=((STRING_TABLE.__str1002991)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+236)>>2)]=((STRING_TABLE.__str1012992)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+240)>>2)]=((STRING_TABLE.__str1022993)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+244)>>2)]=((STRING_TABLE.__str1032994)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+248)>>2)]=((STRING_TABLE.__str1042995)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+252)>>2)]=((STRING_TABLE.__str1052996)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+256)>>2)]=((STRING_TABLE.__str1062997)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+260)>>2)]=((STRING_TABLE.__str1072998)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+264)>>2)]=((STRING_TABLE.__str1082999)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+268)>>2)]=((STRING_TABLE.__str1093000)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+272)>>2)]=((STRING_TABLE.__str1103001)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+276)>>2)]=((STRING_TABLE.__str1113002)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+280)>>2)]=((STRING_TABLE.__str1123003)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+284)>>2)]=((STRING_TABLE.__str1133004)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+288)>>2)]=((STRING_TABLE.__str1143005)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+292)>>2)]=((STRING_TABLE.__str1153006)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+296)>>2)]=((STRING_TABLE.__str1163007)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+300)>>2)]=((STRING_TABLE.__str1173008)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+304)>>2)]=((STRING_TABLE.__str1183009)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+308)>>2)]=((STRING_TABLE.__str1193010)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+312)>>2)]=((STRING_TABLE.__str1203011)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+316)>>2)]=((STRING_TABLE.__str1213012)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+320)>>2)]=((STRING_TABLE.__str1223013)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+324)>>2)]=((STRING_TABLE.__str1233014)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+328)>>2)]=((STRING_TABLE.__str1243015)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+332)>>2)]=((STRING_TABLE.__str1253016)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+336)>>2)]=((STRING_TABLE.__str1263017)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+340)>>2)]=((STRING_TABLE.__str1273018)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+344)>>2)]=((STRING_TABLE.__str1283019)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+348)>>2)]=((STRING_TABLE.__str1293020)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+352)>>2)]=((STRING_TABLE.__str1303021)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+356)>>2)]=((STRING_TABLE.__str1313022)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+360)>>2)]=((STRING_TABLE.__str1323023)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+364)>>2)]=((STRING_TABLE.__str1333024)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+368)>>2)]=((STRING_TABLE.__str1343025)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+372)>>2)]=((STRING_TABLE.__str1353026)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+376)>>2)]=((STRING_TABLE.__str1363027)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+380)>>2)]=((STRING_TABLE.__str1373028)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+384)>>2)]=((STRING_TABLE.__str1383029)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+388)>>2)]=((STRING_TABLE.__str1393030)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+392)>>2)]=((STRING_TABLE.__str1403031)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+396)>>2)]=((STRING_TABLE.__str1413032)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+400)>>2)]=((STRING_TABLE.__str1423033)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+404)>>2)]=((STRING_TABLE.__str1433034)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+408)>>2)]=((STRING_TABLE.__str1443035)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+412)>>2)]=((STRING_TABLE.__str1453036)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+416)>>2)]=((STRING_TABLE.__str1463037)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+420)>>2)]=((STRING_TABLE.__str1473038)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+424)>>2)]=((STRING_TABLE.__str1483039)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+428)>>2)]=((STRING_TABLE.__str1493040)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+432)>>2)]=((STRING_TABLE.__str1503041)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+436)>>2)]=((STRING_TABLE.__str1513042)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+440)>>2)]=((STRING_TABLE.__str1523043)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+444)>>2)]=((STRING_TABLE.__str1533044)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+448)>>2)]=((STRING_TABLE.__str1543045)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+452)>>2)]=((STRING_TABLE.__str1553046)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+456)>>2)]=((STRING_TABLE.__str1563047)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+460)>>2)]=((STRING_TABLE.__str1573048)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+464)>>2)]=((STRING_TABLE.__str1583049)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+468)>>2)]=((STRING_TABLE.__str1593050)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+472)>>2)]=((STRING_TABLE.__str1603051)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+476)>>2)]=((STRING_TABLE.__str1613052)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+480)>>2)]=((STRING_TABLE.__str1623053)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+484)>>2)]=((STRING_TABLE.__str1633054)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+488)>>2)]=((STRING_TABLE.__str1643055)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+492)>>2)]=((STRING_TABLE.__str1653056)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+496)>>2)]=((STRING_TABLE.__str1663057)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+500)>>2)]=((STRING_TABLE.__str1673058)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+504)>>2)]=((STRING_TABLE.__str1683059)|0);
HEAP32[((__ZZNK13address_table12handler_nameEhE7strings+508)>>2)]=((STRING_TABLE.__str1693060)|0);
HEAP32[((__ZTV18address_table_read+4)>>2)]=__ZTI18address_table_read;
HEAP32[((__ZTV19address_table_write+4)>>2)]=__ZTI19address_table_write;
HEAP32[((__ZTV13handler_entry+4)>>2)]=__ZTI13handler_entry;
HEAP32[((__ZTI13address_space)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13address_space+4)>>2)]=((STRING_TABLE.__ZTS13address_space)|0);
HEAP32[((__ZTI13handler_entry)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13handler_entry+4)>>2)]=((STRING_TABLE.__ZTS13handler_entry)|0);
HEAP32[((__ZTV18handler_entry_read+4)>>2)]=__ZTI18handler_entry_read;
HEAP32[((__ZTI18handler_entry_read)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI18handler_entry_read+4)>>2)]=((STRING_TABLE.__ZTS18handler_entry_read)|0);
HEAP32[((__ZTI18handler_entry_read+8)>>2)]=__ZTI13handler_entry;
HEAP32[((__ZTV19handler_entry_write+4)>>2)]=__ZTI19handler_entry_write;
HEAP32[((__ZTI19handler_entry_write)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19handler_entry_write+4)>>2)]=((STRING_TABLE.__ZTS19handler_entry_write)|0);
HEAP32[((__ZTI19handler_entry_write+8)>>2)]=__ZTI13handler_entry;
HEAP32[((__ZTI13address_table)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13address_table+4)>>2)]=((STRING_TABLE.__ZTS13address_table)|0);
HEAP32[((__ZTI18address_table_read)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI18address_table_read+4)>>2)]=((STRING_TABLE.__ZTS18address_table_read)|0);
HEAP32[((__ZTI18address_table_read+8)>>2)]=__ZTI13address_table;
HEAP32[((__ZTI19address_table_write)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19address_table_write+4)>>2)]=((STRING_TABLE.__ZTS19address_table_write)|0);
HEAP32[((__ZTI19address_table_write+8)>>2)]=__ZTI13address_table;
HEAP32[((__ZTV20resource_pool_objectIN11memory_bank14bank_referenceEE+4)>>2)]=__ZTI20resource_pool_objectIN11memory_bank14bank_referenceEE;
HEAP32[((__ZTI20resource_pool_objectIN11memory_bank14bank_referenceEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN11memory_bank14bank_referenceEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN11memory_bank14bank_referenceEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN11memory_bank14bank_referenceEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN11memory_bank14bank_referenceEE+4)>>2)]=__ZTI11simple_listIN11memory_bank14bank_referenceEE;
HEAP32[((__ZTI11simple_listIN11memory_bank14bank_referenceEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN11memory_bank14bank_referenceEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN11memory_bank14bank_referenceEE)|0);
HEAP32[((__ZTV20resource_pool_objectIN16direct_read_data12direct_rangeEE+4)>>2)]=__ZTI20resource_pool_objectIN16direct_read_data12direct_rangeEE;
HEAP32[((__ZTI20resource_pool_objectIN16direct_read_data12direct_rangeEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN16direct_read_data12direct_rangeEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN16direct_read_data12direct_rangeEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN16direct_read_data12direct_rangeEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN16direct_read_data12direct_rangeEE+4)>>2)]=__ZTI11simple_listIN16direct_read_data12direct_rangeEE;
HEAP32[((__ZTI11simple_listIN16direct_read_data12direct_rangeEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN16direct_read_data12direct_rangeEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN16direct_read_data12direct_rangeEE)|0);
HEAP32[((__ZTV20resource_pool_objectI19handler_entry_writeE+4)>>2)]=__ZTI20resource_pool_objectI19handler_entry_writeE;
HEAP32[((__ZTI20resource_pool_objectI19handler_entry_writeE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI19handler_entry_writeE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI19handler_entry_writeE)|0);
HEAP32[((__ZTI20resource_pool_objectI19handler_entry_writeE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI18handler_entry_readE+4)>>2)]=__ZTI20resource_pool_objectI18handler_entry_readE;
HEAP32[((__ZTI20resource_pool_objectI18handler_entry_readE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18handler_entry_readE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18handler_entry_readE)|0);
HEAP32[((__ZTI20resource_pool_objectI18handler_entry_readE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIN13address_table13subtable_dataEE+4)>>2)]=__ZTI19resource_pool_arrayIN13address_table13subtable_dataEE;
HEAP32[((__ZTI19resource_pool_arrayIN13address_table13subtable_dataEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIN13address_table13subtable_dataEE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIN13address_table13subtable_dataEE)|0);
HEAP32[((__ZTI19resource_pool_arrayIN13address_table13subtable_dataEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI11memory_bankE+4)>>2)]=__ZTI20resource_pool_objectI11memory_bankE;
HEAP32[((__ZTI20resource_pool_objectI11memory_bankE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11memory_bankE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11memory_bankE)|0);
HEAP32[((__ZTI20resource_pool_objectI11memory_bankE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12memory_blockE+4)>>2)]=__ZTI20resource_pool_objectI12memory_blockE;
HEAP32[((__ZTI20resource_pool_objectI12memory_blockE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12memory_blockE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12memory_blockE)|0);
HEAP32[((__ZTI20resource_pool_objectI12memory_blockE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12memory_shareE+4)>>2)]=__ZTI20resource_pool_objectI12memory_shareE;
HEAP32[((__ZTI20resource_pool_objectI12memory_shareE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12memory_shareE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12memory_shareE)|0);
HEAP32[((__ZTI20resource_pool_objectI12memory_shareE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIyL12endianness_t1ELb0EE+4)>>2)]=__ZTI22address_space_specificIyL12endianness_t1ELb0EE;
HEAP32[((__ZTI22address_space_specificIyL12endianness_t1ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIyL12endianness_t1ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t1ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificIyL12endianness_t1ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIyL12endianness_t1ELb1EE+4)>>2)]=__ZTI22address_space_specificIyL12endianness_t1ELb1EE;
HEAP32[((__ZTI22address_space_specificIyL12endianness_t1ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIyL12endianness_t1ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t1ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificIyL12endianness_t1ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIyL12endianness_t0ELb0EE+4)>>2)]=__ZTI22address_space_specificIyL12endianness_t0ELb0EE;
HEAP32[((__ZTI22address_space_specificIyL12endianness_t0ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIyL12endianness_t0ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t0ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificIyL12endianness_t0ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIyL12endianness_t0ELb1EE+4)>>2)]=__ZTI22address_space_specificIyL12endianness_t0ELb1EE;
HEAP32[((__ZTI22address_space_specificIyL12endianness_t0ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIyL12endianness_t0ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIyL12endianness_t0ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificIyL12endianness_t0ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIjL12endianness_t1ELb0EE+4)>>2)]=__ZTI22address_space_specificIjL12endianness_t1ELb0EE;
HEAP32[((__ZTI22address_space_specificIjL12endianness_t1ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIjL12endianness_t1ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t1ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificIjL12endianness_t1ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIjL12endianness_t1ELb1EE+4)>>2)]=__ZTI22address_space_specificIjL12endianness_t1ELb1EE;
HEAP32[((__ZTI22address_space_specificIjL12endianness_t1ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIjL12endianness_t1ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t1ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificIjL12endianness_t1ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIjL12endianness_t0ELb0EE+4)>>2)]=__ZTI22address_space_specificIjL12endianness_t0ELb0EE;
HEAP32[((__ZTI22address_space_specificIjL12endianness_t0ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIjL12endianness_t0ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t0ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificIjL12endianness_t0ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIjL12endianness_t0ELb1EE+4)>>2)]=__ZTI22address_space_specificIjL12endianness_t0ELb1EE;
HEAP32[((__ZTI22address_space_specificIjL12endianness_t0ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIjL12endianness_t0ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIjL12endianness_t0ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificIjL12endianness_t0ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificItL12endianness_t1ELb0EE+4)>>2)]=__ZTI22address_space_specificItL12endianness_t1ELb0EE;
HEAP32[((__ZTI22address_space_specificItL12endianness_t1ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificItL12endianness_t1ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificItL12endianness_t1ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificItL12endianness_t1ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificItL12endianness_t1ELb1EE+4)>>2)]=__ZTI22address_space_specificItL12endianness_t1ELb1EE;
HEAP32[((__ZTI22address_space_specificItL12endianness_t1ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificItL12endianness_t1ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificItL12endianness_t1ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificItL12endianness_t1ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificItL12endianness_t0ELb0EE+4)>>2)]=__ZTI22address_space_specificItL12endianness_t0ELb0EE;
HEAP32[((__ZTI22address_space_specificItL12endianness_t0ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificItL12endianness_t0ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificItL12endianness_t0ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificItL12endianness_t0ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificItL12endianness_t0ELb1EE+4)>>2)]=__ZTI22address_space_specificItL12endianness_t0ELb1EE;
HEAP32[((__ZTI22address_space_specificItL12endianness_t0ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificItL12endianness_t0ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificItL12endianness_t0ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificItL12endianness_t0ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIhL12endianness_t1ELb0EE+4)>>2)]=__ZTI22address_space_specificIhL12endianness_t1ELb0EE;
HEAP32[((__ZTI22address_space_specificIhL12endianness_t1ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIhL12endianness_t1ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t1ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificIhL12endianness_t1ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIhL12endianness_t1ELb1EE+4)>>2)]=__ZTI22address_space_specificIhL12endianness_t1ELb1EE;
HEAP32[((__ZTI22address_space_specificIhL12endianness_t1ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIhL12endianness_t1ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t1ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificIhL12endianness_t1ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIhL12endianness_t0ELb0EE+4)>>2)]=__ZTI22address_space_specificIhL12endianness_t0ELb0EE;
HEAP32[((__ZTI22address_space_specificIhL12endianness_t0ELb0EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIhL12endianness_t0ELb0EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t0ELb0EE)|0);
HEAP32[((__ZTI22address_space_specificIhL12endianness_t0ELb0EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE+4)>>2)]=__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE;
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE)|0);
HEAP32[((__ZTI20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV22address_space_specificIhL12endianness_t0ELb1EE+4)>>2)]=__ZTI22address_space_specificIhL12endianness_t0ELb1EE;
HEAP32[((__ZTI22address_space_specificIhL12endianness_t0ELb1EE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22address_space_specificIhL12endianness_t0ELb1EE+4)>>2)]=((STRING_TABLE.__ZTS22address_space_specificIhL12endianness_t0ELb1EE)|0);
HEAP32[((__ZTI22address_space_specificIhL12endianness_t0ELb1EE+8)>>2)]=__ZTI13address_space;
HEAP32[((__ZTV20resource_pool_objectI16direct_read_dataE+4)>>2)]=__ZTI20resource_pool_objectI16direct_read_dataE;
HEAP32[((__ZTI20resource_pool_objectI16direct_read_dataE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16direct_read_dataE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16direct_read_dataE)|0);
HEAP32[((__ZTI20resource_pool_objectI16direct_read_dataE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI15_memory_privateE+4)>>2)]=__ZTI20resource_pool_objectI15_memory_privateE;
HEAP32[((__ZTI20resource_pool_objectI15_memory_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI15_memory_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI15_memory_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI15_memory_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI13address_spaceE+4)>>2)]=__ZTI11simple_listI13address_spaceE;
HEAP32[((__ZTI11simple_listI13address_spaceE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI13address_spaceE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI13address_spaceE)|0);
HEAP32[((__ZTV11simple_listI12memory_blockE+4)>>2)]=__ZTI11simple_listI12memory_blockE;
HEAP32[((__ZTI11simple_listI12memory_blockE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI12memory_blockE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI12memory_blockE)|0);
HEAP32[((__ZTV11simple_listI11memory_bankE+4)>>2)]=__ZTI11simple_listI11memory_bankE;
HEAP32[((__ZTI11simple_listI11memory_bankE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI11memory_bankE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI11memory_bankE)|0);
HEAP32[((__ZTV10cpu_device+4)>>2)]=__ZTI10cpu_device;
HEAP32[((__ZTV10cpu_device+72)>>2)]=__ZTI10cpu_device;
HEAP32[((__ZTV10cpu_device+172)>>2)]=__ZTI10cpu_device;
HEAP32[((__ZTV10cpu_device+256)>>2)]=__ZTI10cpu_device;
HEAP32[((__ZTV10cpu_device+336)>>2)]=__ZTI10cpu_device;
HEAP32[((__ZTV17legacy_cpu_device+4)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTV17legacy_cpu_device+152)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTV17legacy_cpu_device+252)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTV17legacy_cpu_device+336)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTV17legacy_cpu_device+416)>>2)]=__ZTI17legacy_cpu_device;
HEAP32[((__ZTI10cpu_device)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI10cpu_device+4)>>2)]=((STRING_TABLE.__ZTS10cpu_device)|0);
HEAP32[((__ZTI10cpu_device+16)>>2)]=__ZTI8device_t;
HEAP32[((__ZTI10cpu_device+24)>>2)]=__ZTI24device_execute_interface;
HEAP32[((__ZTI10cpu_device+32)>>2)]=__ZTI23device_memory_interface;
HEAP32[((__ZTI10cpu_device+40)>>2)]=__ZTI22device_state_interface;
HEAP32[((__ZTI10cpu_device+48)>>2)]=__ZTI23device_disasm_interface;
HEAP32[((__ZTI17legacy_cpu_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI17legacy_cpu_device+4)>>2)]=((STRING_TABLE.__ZTS17legacy_cpu_device)|0);
HEAP32[((__ZTI17legacy_cpu_device+8)>>2)]=__ZTI10cpu_device;
HEAP32[((__ZTV22device_state_interface+4)>>2)]=__ZTI22device_state_interface;
HEAP32[((__ZTI22device_state_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22device_state_interface+4)>>2)]=((STRING_TABLE.__ZTS22device_state_interface)|0);
HEAP32[((__ZTI22device_state_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV20resource_pool_objectI18device_state_entryE+4)>>2)]=__ZTI20resource_pool_objectI18device_state_entryE;
HEAP32[((__ZTI20resource_pool_objectI18device_state_entryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18device_state_entryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18device_state_entryE)|0);
HEAP32[((__ZTI20resource_pool_objectI18device_state_entryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI18device_state_entryE+4)>>2)]=__ZTI11simple_listI18device_state_entryE;
HEAP32[((__ZTI11simple_listI18device_state_entryE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI18device_state_entryE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI18device_state_entryE)|0);
HEAP32[((__ZTV18legacy_device_base+4)>>2)]=__ZTI18legacy_device_base;
HEAP32[((__ZTV24legacy_sound_device_base+4)>>2)]=__ZTI24legacy_sound_device_base;
HEAP32[((__ZTV24legacy_sound_device_base+76)>>2)]=__ZTI24legacy_sound_device_base;
HEAP32[((__ZTI18legacy_device_base)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI18legacy_device_base+4)>>2)]=((STRING_TABLE.__ZTS18legacy_device_base)|0);
HEAP32[((__ZTI18legacy_device_base+8)>>2)]=__ZTI8device_t;
HEAP32[((__ZTI24legacy_sound_device_base)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI24legacy_sound_device_base+4)>>2)]=((STRING_TABLE.__ZTS24legacy_sound_device_base)|0);
HEAP32[((__ZTI24legacy_sound_device_base+16)>>2)]=__ZTI18legacy_device_base;
HEAP32[((__ZTI24legacy_sound_device_base+24)>>2)]=__ZTI22device_sound_interface;
HEAP32[((__ZTV24device_execute_interface+4)>>2)]=__ZTI24device_execute_interface;
HEAP32[((__ZTI24device_execute_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI24device_execute_interface+4)>>2)]=((STRING_TABLE.__ZTS24device_execute_interface)|0);
HEAP32[((__ZTI24device_execute_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZL12rom____empty)>>2)]=((STRING_TABLE.__str3382)|0);
HEAP32[((_driver____empty)>>2)]=((STRING_TABLE.__str13383)|0);
HEAP32[((_driver____empty+4)>>2)]=((STRING_TABLE.__str23384)|0);
HEAP32[((_driver____empty+8)>>2)]=((STRING_TABLE.__str33385)|0);
HEAP32[((_driver____empty+12)>>2)]=((STRING_TABLE.__str43386)|0);
HEAP32[((_driver____empty+16)>>2)]=((STRING_TABLE.__str53387)|0);
HEAP32[((_driver____empty+20)>>2)]=((STRING_TABLE.__str63388)|0);
HEAP32[((_driver____empty+36)>>2)]=((__ZL12rom____empty)|0);
HEAP32[((__ZTV20resource_pool_objectI11cheat_entryE+4)>>2)]=__ZTI20resource_pool_objectI11cheat_entryE;
HEAP32[((__ZTI20resource_pool_objectI11cheat_entryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11cheat_entryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11cheat_entryE)|0);
HEAP32[((__ZTI20resource_pool_objectI11cheat_entryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI13cheat_manager)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13cheat_manager+4)>>2)]=((STRING_TABLE.__ZTS13cheat_manager)|0);
HEAP32[((__ZTV20resource_pool_objectI12cheat_scriptE+4)>>2)]=__ZTI20resource_pool_objectI12cheat_scriptE;
HEAP32[((__ZTI20resource_pool_objectI12cheat_scriptE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12cheat_scriptE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12cheat_scriptE)|0);
HEAP32[((__ZTI20resource_pool_objectI12cheat_scriptE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI15cheat_parameterE+4)>>2)]=__ZTI20resource_pool_objectI15cheat_parameterE;
HEAP32[((__ZTI20resource_pool_objectI15cheat_parameterE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI15cheat_parameterE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI15cheat_parameterE)|0);
HEAP32[((__ZTI20resource_pool_objectI15cheat_parameterE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE+4)>>2)]=__ZTI20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE;
HEAP32[((__ZTI20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12cheat_script12script_entry15output_argumentEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN12cheat_script12script_entry15output_argumentEE+4)>>2)]=__ZTI11simple_listIN12cheat_script12script_entry15output_argumentEE;
HEAP32[((__ZTI11simple_listIN12cheat_script12script_entry15output_argumentEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN12cheat_script12script_entry15output_argumentEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN12cheat_script12script_entry15output_argumentEE)|0);
HEAP32[((__ZTV20resource_pool_objectIN12cheat_script12script_entryEE+4)>>2)]=__ZTI20resource_pool_objectIN12cheat_script12script_entryEE;
HEAP32[((__ZTI20resource_pool_objectIN12cheat_script12script_entryEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN12cheat_script12script_entryEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN12cheat_script12script_entryEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN12cheat_script12script_entryEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN12cheat_script12script_entryEE+4)>>2)]=__ZTI11simple_listIN12cheat_script12script_entryEE;
HEAP32[((__ZTI11simple_listIN12cheat_script12script_entryEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN12cheat_script12script_entryEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN12cheat_script12script_entryEE)|0);
HEAP32[((__ZTV20resource_pool_objectIN15cheat_parameter4itemEE+4)>>2)]=__ZTI20resource_pool_objectIN15cheat_parameter4itemEE;
HEAP32[((__ZTI20resource_pool_objectIN15cheat_parameter4itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN15cheat_parameter4itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN15cheat_parameter4itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN15cheat_parameter4itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN15cheat_parameter4itemEE+4)>>2)]=__ZTI11simple_listIN15cheat_parameter4itemEE;
HEAP32[((__ZTI11simple_listIN15cheat_parameter4itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN15cheat_parameter4itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN15cheat_parameter4itemEE)|0);
HEAP32[((__ZTV20resource_pool_objectI12sound_streamE+4)>>2)]=__ZTI20resource_pool_objectI12sound_streamE;
HEAP32[((__ZTI20resource_pool_objectI12sound_streamE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12sound_streamE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12sound_streamE)|0);
HEAP32[((__ZTI20resource_pool_objectI12sound_streamE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI13sound_manager)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13sound_manager+4)>>2)]=((STRING_TABLE.__ZTS13sound_manager)|0);
HEAP32[((__ZTV19resource_pool_arrayIsE+4)>>2)]=__ZTI19resource_pool_arrayIsE;
HEAP32[((__ZTI19resource_pool_arrayIsE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIsE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIsE)|0);
HEAP32[((__ZTI19resource_pool_arrayIsE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI12sound_streamE+4)>>2)]=__ZTI11simple_listI12sound_streamE;
HEAP32[((__ZTI11simple_listI12sound_streamE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI12sound_streamE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI12sound_streamE)|0);
HEAP32[((__ZTI12sound_stream)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI12sound_stream+4)>>2)]=((STRING_TABLE.__ZTS12sound_stream)|0);
HEAP32[((__ZTV19resource_pool_arrayIN12sound_stream13stream_outputEE+4)>>2)]=__ZTI19resource_pool_arrayIN12sound_stream13stream_outputEE;
HEAP32[((__ZTI19resource_pool_arrayIN12sound_stream13stream_outputEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIN12sound_stream13stream_outputEE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIN12sound_stream13stream_outputEE)|0);
HEAP32[((__ZTI19resource_pool_arrayIN12sound_stream13stream_outputEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIPiE+4)>>2)]=__ZTI19resource_pool_arrayIPiE;
HEAP32[((__ZTI19resource_pool_arrayIPiE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIPiE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIPiE)|0);
HEAP32[((__ZTI19resource_pool_arrayIPiE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIN12sound_stream12stream_inputEE+4)>>2)]=__ZTI19resource_pool_arrayIN12sound_stream12stream_inputEE;
HEAP32[((__ZTI19resource_pool_arrayIN12sound_stream12stream_inputEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIN12sound_stream12stream_inputEE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIN12sound_stream12stream_inputEE)|0);
HEAP32[((__ZTI19resource_pool_arrayIN12sound_stream12stream_inputEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI11gfx_elementE+4)>>2)]=__ZTI20resource_pool_objectI11gfx_elementE;
HEAP32[((__ZTI20resource_pool_objectI11gfx_elementE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11gfx_elementE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11gfx_elementE)|0);
HEAP32[((__ZTI20resource_pool_objectI11gfx_elementE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12_config_typeE+4)>>2)]=__ZTI20resource_pool_objectI12_config_typeE;
HEAP32[((__ZTI20resource_pool_objectI12_config_typeE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12_config_typeE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12_config_typeE)|0);
HEAP32[((__ZTI20resource_pool_objectI12_config_typeE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI24_generic_machine_privateE+4)>>2)]=__ZTI20resource_pool_objectI24_generic_machine_privateE;
HEAP32[((__ZTI20resource_pool_objectI24_generic_machine_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI24_generic_machine_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI24_generic_machine_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI24_generic_machine_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12_output_itemE+4)>>2)]=__ZTI20resource_pool_objectI12_output_itemE;
HEAP32[((__ZTI20resource_pool_objectI12_output_itemE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12_output_itemE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12_output_itemE)|0);
HEAP32[((__ZTI20resource_pool_objectI12_output_itemE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayIfE+4)>>2)]=__ZTI19resource_pool_arrayIfE;
HEAP32[((__ZTI19resource_pool_arrayIfE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIfE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIfE)|0);
HEAP32[((__ZTI19resource_pool_arrayIfE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI16_palette_privateE+4)>>2)]=__ZTI20resource_pool_objectI16_palette_privateE;
HEAP32[((__ZTI20resource_pool_objectI16_palette_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16_palette_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16_palette_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI16_palette_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI14_machine_entryE+4)>>2)]=__ZTI20resource_pool_objectI14_machine_entryE;
HEAP32[((__ZTI20resource_pool_objectI14_machine_entryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14_machine_entryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14_machine_entryE)|0);
HEAP32[((__ZTI20resource_pool_objectI14_machine_entryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI18debug_view_managerE+4)>>2)]=__ZTI20resource_pool_objectI18debug_view_managerE;
HEAP32[((__ZTI20resource_pool_objectI18debug_view_managerE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18debug_view_managerE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18debug_view_managerE)|0);
HEAP32[((__ZTI20resource_pool_objectI18debug_view_managerE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI16_romload_privateE+4)>>2)]=__ZTI20resource_pool_objectI16_romload_privateE;
HEAP32[((__ZTI20resource_pool_objectI16_romload_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16_romload_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16_romload_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI16_romload_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI9_open_chdE+4)>>2)]=__ZTI20resource_pool_objectI9_open_chdE;
HEAP32[((__ZTI20resource_pool_objectI9_open_chdE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI9_open_chdE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI9_open_chdE)|0);
HEAP32[((__ZTI20resource_pool_objectI9_open_chdE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17_ui_input_privateE+4)>>2)]=__ZTI20resource_pool_objectI17_ui_input_privateE;
HEAP32[((__ZTI20resource_pool_objectI17_ui_input_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17_ui_input_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17_ui_input_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI17_ui_input_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI22_generic_audio_privateE+4)>>2)]=__ZTI20resource_pool_objectI22_generic_audio_privateE;
HEAP32[((__ZTI20resource_pool_objectI22_generic_audio_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22_generic_audio_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22_generic_audio_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI22_generic_audio_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI22_generic_video_privateE+4)>>2)]=__ZTI20resource_pool_objectI22_generic_video_privateE;
HEAP32[((__ZTI20resource_pool_objectI22_generic_video_privateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI22_generic_video_privateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI22_generic_video_privateE)|0);
HEAP32[((__ZTI20resource_pool_objectI22_generic_video_privateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI14_debug_commandE+4)>>2)]=__ZTI20resource_pool_objectI14_debug_commandE;
HEAP32[((__ZTI20resource_pool_objectI14_debug_commandE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14_debug_commandE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14_debug_commandE)|0);
HEAP32[((__ZTI20resource_pool_objectI14_debug_commandE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayI13_ui_menu_itemE+4)>>2)]=__ZTI19resource_pool_arrayI13_ui_menu_itemE;
HEAP32[((__ZTI19resource_pool_arrayI13_ui_menu_itemE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI13_ui_menu_itemE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI13_ui_menu_itemE)|0);
HEAP32[((__ZTI19resource_pool_arrayI13_ui_menu_itemE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI7ui_menuE+4)>>2)]=__ZTI20resource_pool_objectI7ui_menuE;
HEAP32[((__ZTI20resource_pool_objectI7ui_menuE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI7ui_menuE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI7ui_menuE)|0);
HEAP32[((__ZTI20resource_pool_objectI7ui_menuE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17driver_enumeratorE+4)>>2)]=__ZTI20resource_pool_objectI17driver_enumeratorE;
HEAP32[((__ZTI20resource_pool_objectI17driver_enumeratorE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17driver_enumeratorE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17driver_enumeratorE)|0);
HEAP32[((__ZTI20resource_pool_objectI17driver_enumeratorE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZL23menu_crosshair_populateR15running_machineP7ui_menuE8vis_text)>>2)]=((STRING_TABLE.__str674231)|0);
HEAP32[((__ZZL23menu_crosshair_populateR15running_machineP7ui_menuE8vis_text+4)>>2)]=((STRING_TABLE.__str684232)|0);
HEAP32[((__ZZL23menu_crosshair_populateR15running_machineP7ui_menuE8vis_text+8)>>2)]=((STRING_TABLE.__str694233)|0);
HEAP32[((__ZTV20resource_pool_objectI5DViewE+4)>>2)]=__ZTI20resource_pool_objectI5DViewE;
HEAP32[((__ZTI20resource_pool_objectI5DViewE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI5DViewE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI5DViewE)|0);
HEAP32[((__ZTI20resource_pool_objectI5DViewE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN17driver_enumerator12config_entryEE+4)>>2)]=__ZTI20resource_pool_objectIN17driver_enumerator12config_entryEE;
HEAP32[((__ZTI20resource_pool_objectIN17driver_enumerator12config_entryEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN17driver_enumerator12config_entryEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN17driver_enumerator12config_entryEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN17driver_enumerator12config_entryEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI14machine_configE+4)>>2)]=__ZTI20resource_pool_objectI14machine_configE;
HEAP32[((__ZTI20resource_pool_objectI14machine_configE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14machine_configE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14machine_configE)|0);
HEAP32[((__ZTI20resource_pool_objectI14machine_configE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN17driver_enumerator12config_entryEE+4)>>2)]=__ZTI11simple_listIN17driver_enumerator12config_entryEE;
HEAP32[((__ZTI11simple_listIN17driver_enumerator12config_entryEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN17driver_enumerator12config_entryEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN17driver_enumerator12config_entryEE)|0);
HEAP32[((__ZTV19resource_pool_arrayIP14machine_configE+4)>>2)]=__ZTI19resource_pool_arrayIP14machine_configE;
HEAP32[((__ZTI19resource_pool_arrayIP14machine_configE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIP14machine_configE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIP14machine_configE)|0);
HEAP32[((__ZTI19resource_pool_arrayIP14machine_configE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11emu_options+4)>>2)]=__ZTI11emu_options;
HEAP32[((__ZTV14layout_element+4)>>2)]=__ZTI14layout_element;
HEAP32[((__ZTV11layout_view+4)>>2)]=__ZTI11layout_view;
HEAP32[((__ZTVN11layout_view4itemE+4)>>2)]=__ZTIN11layout_view4itemE;
HEAP32[((__ZTV11layout_file+4)>>2)]=__ZTI11layout_file;
HEAP32[((__ZTI14layout_element)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI14layout_element+4)>>2)]=((STRING_TABLE.__ZTS14layout_element)|0);
HEAP32[((__ZTIN11layout_view4itemE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTIN11layout_view4itemE+4)>>2)]=((STRING_TABLE.__ZTSN11layout_view4itemE)|0);
HEAP32[((__ZTI11layout_view)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11layout_view+4)>>2)]=((STRING_TABLE.__ZTS11layout_view)|0);
HEAP32[((__ZTI11layout_file)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11layout_file+4)>>2)]=((STRING_TABLE.__ZTS11layout_file)|0);
HEAP32[((__ZTV20resource_pool_objectI11layout_viewE+4)>>2)]=__ZTI20resource_pool_objectI11layout_viewE;
HEAP32[((__ZTI20resource_pool_objectI11layout_viewE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI11layout_viewE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI11layout_viewE)|0);
HEAP32[((__ZTI20resource_pool_objectI11layout_viewE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI14layout_elementE+4)>>2)]=__ZTI20resource_pool_objectI14layout_elementE;
HEAP32[((__ZTI20resource_pool_objectI14layout_elementE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14layout_elementE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14layout_elementE)|0);
HEAP32[((__ZTI20resource_pool_objectI14layout_elementE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI11layout_viewE+4)>>2)]=__ZTI11simple_listI11layout_viewE;
HEAP32[((__ZTI11simple_listI11layout_viewE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI11layout_viewE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI11layout_viewE)|0);
HEAP32[((__ZTV11simple_listI14layout_elementE+4)>>2)]=__ZTI11simple_listI14layout_elementE;
HEAP32[((__ZTI11simple_listI14layout_elementE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI14layout_elementE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI14layout_elementE)|0);
HEAP32[((__ZTV20resource_pool_objectIN11layout_view4itemEE+4)>>2)]=__ZTI20resource_pool_objectIN11layout_view4itemEE;
HEAP32[((__ZTI20resource_pool_objectIN11layout_view4itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN11layout_view4itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN11layout_view4itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN11layout_view4itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN11layout_view4itemEE+4)>>2)]=__ZTI11simple_listIN11layout_view4itemEE;
HEAP32[((__ZTI11simple_listIN11layout_view4itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN11layout_view4itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN11layout_view4itemEE)|0);
HEAP32[((__ZTV19resource_pool_arrayIN14layout_element7textureEE+4)>>2)]=__ZTI19resource_pool_arrayIN14layout_element7textureEE;
HEAP32[((__ZTI19resource_pool_arrayIN14layout_element7textureEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIN14layout_element7textureEE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIN14layout_element7textureEE)|0);
HEAP32[((__ZTI19resource_pool_arrayIN14layout_element7textureEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN14layout_element9componentEE+4)>>2)]=__ZTI20resource_pool_objectIN14layout_element9componentEE;
HEAP32[((__ZTI20resource_pool_objectIN14layout_element9componentEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN14layout_element9componentEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN14layout_element9componentEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN14layout_element9componentEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN14layout_element9componentEE+4)>>2)]=__ZTI11simple_listIN14layout_element9componentEE;
HEAP32[((__ZTI11simple_listIN14layout_element9componentEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN14layout_element9componentEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN14layout_element9componentEE)|0);
HEAP32[((__ZTV20resource_pool_objectIN18render_screen_list4itemEE+4)>>2)]=__ZTI20resource_pool_objectIN18render_screen_list4itemEE;
HEAP32[((__ZTI20resource_pool_objectIN18render_screen_list4itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN18render_screen_list4itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN18render_screen_list4itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN18render_screen_list4itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listIN18render_screen_list4itemEE+4)>>2)]=__ZTI11simple_listIN18render_screen_list4itemEE;
HEAP32[((__ZTI11simple_listIN18render_screen_list4itemEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN18render_screen_list4itemEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN18render_screen_list4itemEE)|0);
HEAP32[((__ZTV11render_font+4)>>2)]=__ZTI11render_font;
HEAP32[((__ZTI11render_font)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11render_font+4)>>2)]=((STRING_TABLE.__ZTS11render_font)|0);
HEAP32[((__ZTV19resource_pool_arrayIN11render_font5glyphEE+4)>>2)]=__ZTI19resource_pool_arrayIN11render_font5glyphEE;
HEAP32[((__ZTI19resource_pool_arrayIN11render_font5glyphEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayIN11render_font5glyphEE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayIN11render_font5glyphEE)|0);
HEAP32[((__ZTI19resource_pool_arrayIN11render_font5glyphEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV12symbol_entry+4)>>2)]=__ZTI12symbol_entry;
HEAP32[((__ZTV20integer_symbol_entry+4)>>2)]=__ZTI20integer_symbol_entry;
HEAP32[((__ZTV21function_symbol_entry+4)>>2)]=__ZTI21function_symbol_entry;
HEAP32[((__ZTI12symbol_entry)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI12symbol_entry+4)>>2)]=((STRING_TABLE.__ZTS12symbol_entry)|0);
HEAP32[((__ZTI20integer_symbol_entry)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20integer_symbol_entry+4)>>2)]=((STRING_TABLE.__ZTS20integer_symbol_entry)|0);
HEAP32[((__ZTI20integer_symbol_entry+8)>>2)]=__ZTI12symbol_entry;
HEAP32[((__ZTI21function_symbol_entry)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI21function_symbol_entry+4)>>2)]=((STRING_TABLE.__ZTS21function_symbol_entry)|0);
HEAP32[((__ZTI21function_symbol_entry+8)>>2)]=__ZTI12symbol_entry;
HEAP32[((__ZTV20resource_pool_objectIN17parsed_expression17expression_stringEE+4)>>2)]=__ZTI20resource_pool_objectIN17parsed_expression17expression_stringEE;
HEAP32[((__ZTI20resource_pool_objectIN17parsed_expression17expression_stringEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN17parsed_expression17expression_stringEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN17parsed_expression17expression_stringEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN17parsed_expression17expression_stringEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectIN17parsed_expression11parse_tokenEE+4)>>2)]=__ZTI20resource_pool_objectIN17parsed_expression11parse_tokenEE;
HEAP32[((__ZTI20resource_pool_objectIN17parsed_expression11parse_tokenEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN17parsed_expression11parse_tokenEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN17parsed_expression11parse_tokenEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN17parsed_expression11parse_tokenEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI21function_symbol_entryE+4)>>2)]=__ZTI20resource_pool_objectI21function_symbol_entryE;
HEAP32[((__ZTI20resource_pool_objectI21function_symbol_entryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI21function_symbol_entryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI21function_symbol_entryE)|0);
HEAP32[((__ZTI20resource_pool_objectI21function_symbol_entryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI20integer_symbol_entryE+4)>>2)]=__ZTI20resource_pool_objectI20integer_symbol_entryE;
HEAP32[((__ZTI20resource_pool_objectI20integer_symbol_entryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI20integer_symbol_entryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI20integer_symbol_entryE)|0);
HEAP32[((__ZTI20resource_pool_objectI20integer_symbol_entryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI12audit_recordE+4)>>2)]=__ZTI20resource_pool_objectI12audit_recordE;
HEAP32[((__ZTI20resource_pool_objectI12audit_recordE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12audit_recordE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12audit_recordE)|0);
HEAP32[((__ZTI20resource_pool_objectI12audit_recordE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI13video_manager)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13video_manager+4)>>2)]=((STRING_TABLE.__ZTS13video_manager)|0);
HEAP32[((__ZN15hash_collection19HASH_TYPES_CRC_SHA1E)>>2)]=((STRING_TABLE.__str14906)|0);
HEAP32[((__ZN15hash_collection14HASH_TYPES_ALLE)>>2)]=((STRING_TABLE.__str24909)|0);
HEAP32[((__ZTV9hash_base+4)>>2)]=__ZTI9hash_base;
HEAP32[((__ZTV8hash_crc+4)>>2)]=__ZTI8hash_crc;
HEAP32[((__ZTV8hash_md5+4)>>2)]=__ZTI8hash_md5;
HEAP32[((__ZTV9hash_sha1+4)>>2)]=__ZTI9hash_sha1;
HEAP32[((__ZTI9hash_base)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI9hash_base+4)>>2)]=((STRING_TABLE.__ZTS9hash_base)|0);
HEAP32[((__ZTI8hash_crc)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI8hash_crc+4)>>2)]=((STRING_TABLE.__ZTS8hash_crc)|0);
HEAP32[((__ZTI8hash_crc+8)>>2)]=__ZTI9hash_base;
HEAP32[((__ZTI8hash_md5)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI8hash_md5+4)>>2)]=((STRING_TABLE.__ZTS8hash_md5)|0);
HEAP32[((__ZTI8hash_md5+8)>>2)]=__ZTI9hash_base;
HEAP32[((__ZTI9hash_sha1)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI9hash_sha1+4)>>2)]=((STRING_TABLE.__ZTS9hash_sha1)|0);
HEAP32[((__ZTI9hash_sha1+8)>>2)]=__ZTI9hash_base;
HEAP32[((__ZTV20resource_pool_objectI9hash_sha1E+4)>>2)]=__ZTI20resource_pool_objectI9hash_sha1E;
HEAP32[((__ZTI20resource_pool_objectI9hash_sha1E)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI9hash_sha1E+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI9hash_sha1E)|0);
HEAP32[((__ZTI20resource_pool_objectI9hash_sha1E+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI8hash_md5E+4)>>2)]=__ZTI20resource_pool_objectI8hash_md5E;
HEAP32[((__ZTI20resource_pool_objectI8hash_md5E)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI8hash_md5E+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI8hash_md5E)|0);
HEAP32[((__ZTI20resource_pool_objectI8hash_md5E+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI8hash_crcE+4)>>2)]=__ZTI20resource_pool_objectI8hash_crcE;
HEAP32[((__ZTI20resource_pool_objectI8hash_crcE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI8hash_crcE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI8hash_crcE)|0);
HEAP32[((__ZTI20resource_pool_objectI8hash_crcE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV11simple_listI9hash_baseE+4)>>2)]=__ZTI11simple_listI9hash_baseE;
HEAP32[((__ZTI11simple_listI9hash_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listI9hash_baseE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listI9hash_baseE)|0);
HEAP32[((__ZTV17debug_view_source+4)>>2)]=__ZTI17debug_view_source;
HEAP32[((__ZTV10debug_view+4)>>2)]=__ZTI10debug_view;
HEAP32[((__ZTI10debug_view)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI10debug_view+4)>>2)]=((STRING_TABLE.__ZTS10debug_view)|0);
HEAP32[((__ZTI17debug_view_source)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI17debug_view_source+4)>>2)]=((STRING_TABLE.__ZTS17debug_view_source)|0);
HEAP32[((__ZTV20resource_pool_objectI14debug_view_logE+4)>>2)]=__ZTI20resource_pool_objectI14debug_view_logE;
HEAP32[((__ZTI20resource_pool_objectI14debug_view_logE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14debug_view_logE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14debug_view_logE)|0);
HEAP32[((__ZTI20resource_pool_objectI14debug_view_logE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17debug_view_memoryE+4)>>2)]=__ZTI20resource_pool_objectI17debug_view_memoryE;
HEAP32[((__ZTI20resource_pool_objectI17debug_view_memoryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17debug_view_memoryE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17debug_view_memoryE)|0);
HEAP32[((__ZTI20resource_pool_objectI17debug_view_memoryE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI17debug_view_disasmE+4)>>2)]=__ZTI20resource_pool_objectI17debug_view_disasmE;
HEAP32[((__ZTI20resource_pool_objectI17debug_view_disasmE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI17debug_view_disasmE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI17debug_view_disasmE)|0);
HEAP32[((__ZTI20resource_pool_objectI17debug_view_disasmE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI16debug_view_stateE+4)>>2)]=__ZTI20resource_pool_objectI16debug_view_stateE;
HEAP32[((__ZTI20resource_pool_objectI16debug_view_stateE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16debug_view_stateE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16debug_view_stateE)|0);
HEAP32[((__ZTI20resource_pool_objectI16debug_view_stateE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI18debug_view_consoleE+4)>>2)]=__ZTI20resource_pool_objectI18debug_view_consoleE;
HEAP32[((__ZTI20resource_pool_objectI18debug_view_consoleE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI18debug_view_consoleE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI18debug_view_consoleE)|0);
HEAP32[((__ZTI20resource_pool_objectI18debug_view_consoleE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV19resource_pool_arrayI15debug_view_charE+4)>>2)]=__ZTI19resource_pool_arrayI15debug_view_charE;
HEAP32[((__ZTI19resource_pool_arrayI15debug_view_charE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI15debug_view_charE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI15debug_view_charE)|0);
HEAP32[((__ZTI19resource_pool_arrayI15debug_view_charE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI22device_nvram_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22device_nvram_interface+4)>>2)]=((STRING_TABLE.__ZTS22device_nvram_interface)|0);
HEAP32[((__ZTI22device_nvram_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV22device_sound_interface+4)>>2)]=__ZTI22device_sound_interface;
HEAP32[((__ZTI22device_sound_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI22device_sound_interface+4)>>2)]=((STRING_TABLE.__ZTS22device_sound_interface)|0);
HEAP32[((__ZTI22device_sound_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV11simple_listIN22device_sound_interface11sound_routeEE+4)>>2)]=__ZTI11simple_listIN22device_sound_interface11sound_routeEE;
HEAP32[((__ZTI11simple_listIN22device_sound_interface11sound_routeEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI11simple_listIN22device_sound_interface11sound_routeEE+4)>>2)]=((STRING_TABLE.__ZTS11simple_listIN22device_sound_interface11sound_routeEE)|0);
HEAP32[((__ZTV23device_disasm_interface+4)>>2)]=__ZTI23device_disasm_interface;
HEAP32[((__ZTI23device_disasm_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI23device_disasm_interface+4)>>2)]=((STRING_TABLE.__ZTS23device_disasm_interface)|0);
HEAP32[((__ZTI23device_disasm_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV24legacy_image_device_base+4)>>2)]=__ZTI24legacy_image_device_base;
HEAP32[((__ZTV24legacy_image_device_base+144)>>2)]=__ZTI24legacy_image_device_base;
HEAP32[((__ZTI24legacy_image_device_base)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI24legacy_image_device_base+4)>>2)]=((STRING_TABLE.__ZTS24legacy_image_device_base)|0);
HEAP32[((__ZTI24legacy_image_device_base+16)>>2)]=__ZTI18legacy_device_base;
HEAP32[((__ZTI24legacy_image_device_base+24)>>2)]=__ZTI22device_image_interface;
HEAP32[((__ZTV20resource_pool_objectI19image_device_formatE+4)>>2)]=__ZTI20resource_pool_objectI19image_device_formatE;
HEAP32[((__ZTI20resource_pool_objectI19image_device_formatE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI19image_device_formatE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI19image_device_formatE)|0);
HEAP32[((__ZTI20resource_pool_objectI19image_device_formatE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV8emu_file+4)>>2)]=__ZTI8emu_file;
HEAP32[((__ZTI8emu_file)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI8emu_file+4)>>2)]=((STRING_TABLE.__ZTS8emu_file)|0);
HEAP32[((__ZTI21device_slot_interface)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI21device_slot_interface+4)>>2)]=((STRING_TABLE.__ZTS21device_slot_interface)|0);
HEAP32[((__ZTI21device_slot_interface+8)>>2)]=__ZTI16device_interface;
HEAP32[((__ZTV10ram_device+4)>>2)]=__ZTI10ram_device;
HEAP32[((__ZTI10ram_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI10ram_device+4)>>2)]=((STRING_TABLE.__ZTS10ram_device)|0);
HEAP32[((__ZTI10ram_device+8)>>2)]=__ZTI18legacy_device_base;
HEAP32[((__ZTV20resource_pool_objectI10ram_deviceE+4)>>2)]=__ZTI20resource_pool_objectI10ram_deviceE;
HEAP32[((__ZTI20resource_pool_objectI10ram_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI10ram_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI10ram_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI10ram_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV14speaker_device+4)>>2)]=__ZTI14speaker_device;
HEAP32[((__ZTV14speaker_device+76)>>2)]=__ZTI14speaker_device;
HEAP32[((__ZTI14speaker_device)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI14speaker_device+4)>>2)]=((STRING_TABLE.__ZTS14speaker_device)|0);
HEAP32[((__ZTI14speaker_device+16)>>2)]=__ZTI8device_t;
HEAP32[((__ZTI14speaker_device+24)>>2)]=__ZTI22device_sound_interface;
HEAP32[((__ZTV20resource_pool_objectI14speaker_deviceE+4)>>2)]=__ZTI20resource_pool_objectI14speaker_deviceE;
HEAP32[((__ZTI20resource_pool_objectI14speaker_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14speaker_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14speaker_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI14speaker_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV21cassette_image_device+4)>>2)]=__ZTI21cassette_image_device;
HEAP32[((__ZTV21cassette_image_device+128)>>2)]=__ZTI21cassette_image_device;
HEAP32[((__ZTI18cassette_interface)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI18cassette_interface+4)>>2)]=((STRING_TABLE.__ZTS18cassette_interface)|0);
HEAP32[((__ZTI21cassette_image_device)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI21cassette_image_device+4)>>2)]=((STRING_TABLE.__ZTS21cassette_image_device)|0);
HEAP32[((__ZTI21cassette_image_device+16)>>2)]=__ZTI8device_t;
HEAP32[((__ZTI21cassette_image_device+24)>>2)]=__ZTI18cassette_interface;
HEAP32[((__ZTI21cassette_image_device+32)>>2)]=__ZTI22device_image_interface;
HEAP32[((__ZTV20resource_pool_objectI21cassette_image_deviceE+4)>>2)]=__ZTI20resource_pool_objectI21cassette_image_deviceE;
HEAP32[((__ZTI20resource_pool_objectI21cassette_image_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI21cassette_image_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI21cassette_image_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI21cassette_image_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZ21bitbanger_mode_stringP8device_tE5modes)>>2)]=((STRING_TABLE.__str5381)|0);
HEAP32[((__ZZ21bitbanger_mode_stringP8device_tE5modes+4)>>2)]=((STRING_TABLE.__str15382)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes)>>2)]=((STRING_TABLE.__str25383)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+4)>>2)]=((STRING_TABLE.__str35384)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+8)>>2)]=((STRING_TABLE.__str45385)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+12)>>2)]=((STRING_TABLE.__str55386)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+16)>>2)]=((STRING_TABLE.__str65387)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+20)>>2)]=((STRING_TABLE.__str75388)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+24)>>2)]=((STRING_TABLE.__str85389)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+28)>>2)]=((STRING_TABLE.__str95390)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+32)>>2)]=((STRING_TABLE.__str105391)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+36)>>2)]=((STRING_TABLE.__str115392)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+40)>>2)]=((STRING_TABLE.__str125393)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+44)>>2)]=((STRING_TABLE.__str135394)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+48)>>2)]=((STRING_TABLE.__str145395)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+52)>>2)]=((STRING_TABLE.__str155396)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+56)>>2)]=((STRING_TABLE.__str165397)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+60)>>2)]=((STRING_TABLE.__str175398)|0);
HEAP32[((__ZZ21bitbanger_tune_stringP8device_tE5tunes+64)>>2)]=((STRING_TABLE.__str185399)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds)>>2)]=((STRING_TABLE.__str195400)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+4)>>2)]=((STRING_TABLE.__str205401)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+8)>>2)]=((STRING_TABLE.__str215402)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+12)>>2)]=((STRING_TABLE.__str225403)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+16)>>2)]=((STRING_TABLE.__str235404)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+20)>>2)]=((STRING_TABLE.__str245405)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+24)>>2)]=((STRING_TABLE.__str255406)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+28)>>2)]=((STRING_TABLE.__str265407)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+32)>>2)]=((STRING_TABLE.__str275408)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+36)>>2)]=((STRING_TABLE.__str285409)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+40)>>2)]=((STRING_TABLE.__str295410)|0);
HEAP32[((__ZZ21bitbanger_baud_stringP8device_tE5bauds+44)>>2)]=((STRING_TABLE.__str305411)|0);
HEAP32[((__ZTV16bitbanger_device+4)>>2)]=__ZTI16bitbanger_device;
HEAP32[((__ZTV16bitbanger_device+144)>>2)]=__ZTI16bitbanger_device;
HEAP32[((__ZTI16bitbanger_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI16bitbanger_device+4)>>2)]=((STRING_TABLE.__ZTS16bitbanger_device)|0);
HEAP32[((__ZTI16bitbanger_device+8)>>2)]=__ZTI24legacy_image_device_base;
HEAP32[((__ZTV20resource_pool_objectI16bitbanger_deviceE+4)>>2)]=__ZTI20resource_pool_objectI16bitbanger_deviceE;
HEAP32[((__ZTI20resource_pool_objectI16bitbanger_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16bitbanger_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16bitbanger_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI16bitbanger_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV16laserdisc_device+4)>>2)]=__ZTI16laserdisc_device;
HEAP32[((__ZTI16laserdisc_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI16laserdisc_device+4)>>2)]=((STRING_TABLE.__ZTS16laserdisc_device)|0);
HEAP32[((__ZTI16laserdisc_device+8)>>2)]=__ZTI18legacy_device_base;
HEAP32[((__ZTV20resource_pool_objectI16laserdisc_deviceE+4)>>2)]=__ZTI20resource_pool_objectI16laserdisc_deviceE;
HEAP32[((__ZTI20resource_pool_objectI16laserdisc_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI16laserdisc_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI16laserdisc_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI16laserdisc_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZL17player_interfaces)>>2)]=_pr8210_interface;
HEAP32[((__ZL17player_interfaces+4)>>2)]=_simutrek_interface;
HEAP32[((__ZL17player_interfaces+8)>>2)]=_ldv1000_interface;
HEAP32[((__ZL17player_interfaces+12)>>2)]=_vp931_interface;
HEAP32[((__ZTV20resource_pool_objectI12_ldcore_dataE+4)>>2)]=__ZTI20resource_pool_objectI12_ldcore_dataE;
HEAP32[((__ZTI20resource_pool_objectI12_ldcore_dataE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI12_ldcore_dataE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI12_ldcore_dataE)|0);
HEAP32[((__ZTI20resource_pool_objectI12_ldcore_dataE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZL11execute_mapR15running_machineiiPPKcE8intnames)>>2)]=((STRING_TABLE.__str1195617)|0);
HEAP32[((__ZZL11execute_mapR15running_machineiiPPKcE8intnames+4)>>2)]=((STRING_TABLE.__str1205618)|0);
HEAP32[((__ZZL11execute_mapR15running_machineiiPPKcE8intnames+8)>>2)]=((STRING_TABLE.__str1215619)|0);
HEAP32[((__ZTV19resource_pool_arrayI10_cheat_mapE+4)>>2)]=__ZTI19resource_pool_arrayI10_cheat_mapE;
HEAP32[((__ZTI19resource_pool_arrayI10_cheat_mapE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI10_cheat_mapE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI10_cheat_mapE)|0);
HEAP32[((__ZTI19resource_pool_arrayI10_cheat_mapE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZZL14execute_wplistR15running_machineiiPPKcE5types)>>2)]=((STRING_TABLE.__str2025700)|0);
HEAP32[((__ZZL14execute_wplistR15running_machineiiPPKcE5types+4)>>2)]=((STRING_TABLE.__str2035701)|0);
HEAP32[((__ZZL14execute_wplistR15running_machineiiPPKcE5types+8)>>2)]=((STRING_TABLE.__str2045702)|0);
HEAP32[((__ZZL14execute_wplistR15running_machineiiPPKcE5types+12)>>2)]=((STRING_TABLE.__str2055703)|0);
HEAP32[((__ZTV18debug_view_textbuf+4)>>2)]=__ZTI18debug_view_textbuf;
HEAP32[((__ZTV18debug_view_console+4)>>2)]=__ZTI18debug_view_console;
HEAP32[((__ZTV14debug_view_log+4)>>2)]=__ZTI14debug_view_log;
HEAP32[((__ZTI18debug_view_textbuf)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI18debug_view_textbuf+4)>>2)]=((STRING_TABLE.__ZTS18debug_view_textbuf)|0);
HEAP32[((__ZTI18debug_view_textbuf+8)>>2)]=__ZTI10debug_view;
HEAP32[((__ZTI14debug_view_log)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI14debug_view_log+4)>>2)]=((STRING_TABLE.__ZTS14debug_view_log)|0);
HEAP32[((__ZTI14debug_view_log+8)>>2)]=__ZTI18debug_view_textbuf;
HEAP32[((__ZTI18debug_view_console)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI18debug_view_console+4)>>2)]=((STRING_TABLE.__ZTS18debug_view_console)|0);
HEAP32[((__ZTI18debug_view_console+8)>>2)]=__ZTI18debug_view_textbuf;
HEAP32[((__ZTV23debug_view_state_source+4)>>2)]=__ZTI23debug_view_state_source;
HEAP32[((__ZTV16debug_view_state+4)>>2)]=__ZTI16debug_view_state;
HEAP32[((__ZTI16debug_view_state)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI16debug_view_state+4)>>2)]=((STRING_TABLE.__ZTS16debug_view_state)|0);
HEAP32[((__ZTI16debug_view_state+8)>>2)]=__ZTI10debug_view;
HEAP32[((__ZTI23debug_view_state_source)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI23debug_view_state_source+4)>>2)]=((STRING_TABLE.__ZTS23debug_view_state_source)|0);
HEAP32[((__ZTI23debug_view_state_source+8)>>2)]=__ZTI17debug_view_source;
HEAP32[((__ZTV20resource_pool_objectIN16debug_view_state10state_itemEE+4)>>2)]=__ZTI20resource_pool_objectIN16debug_view_state10state_itemEE;
HEAP32[((__ZTI20resource_pool_objectIN16debug_view_state10state_itemEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectIN16debug_view_state10state_itemEE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectIN16debug_view_state10state_itemEE)|0);
HEAP32[((__ZTI20resource_pool_objectIN16debug_view_state10state_itemEE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV20resource_pool_objectI23debug_view_state_sourceE+4)>>2)]=__ZTI20resource_pool_objectI23debug_view_state_sourceE;
HEAP32[((__ZTI20resource_pool_objectI23debug_view_state_sourceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI23debug_view_state_sourceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI23debug_view_state_sourceE)|0);
HEAP32[((__ZTI20resource_pool_objectI23debug_view_state_sourceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV24debug_view_disasm_source+4)>>2)]=__ZTI24debug_view_disasm_source;
HEAP32[((__ZTV17debug_view_disasm+4)>>2)]=__ZTI17debug_view_disasm;
HEAP32[((__ZTI17debug_view_disasm)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI17debug_view_disasm+4)>>2)]=((STRING_TABLE.__ZTS17debug_view_disasm)|0);
HEAP32[((__ZTI17debug_view_disasm+8)>>2)]=__ZTI10debug_view;
HEAP32[((__ZTI24debug_view_disasm_source)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI24debug_view_disasm_source+4)>>2)]=((STRING_TABLE.__ZTS24debug_view_disasm_source)|0);
HEAP32[((__ZTI24debug_view_disasm_source+8)>>2)]=__ZTI17debug_view_source;
HEAP32[((__ZTV20resource_pool_objectI24debug_view_disasm_sourceE+4)>>2)]=__ZTI20resource_pool_objectI24debug_view_disasm_sourceE;
HEAP32[((__ZTI20resource_pool_objectI24debug_view_disasm_sourceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI24debug_view_disasm_sourceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI24debug_view_disasm_sourceE)|0);
HEAP32[((__ZTI20resource_pool_objectI24debug_view_disasm_sourceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV24debug_view_memory_source+4)>>2)]=__ZTI24debug_view_memory_source;
HEAP32[((__ZTV17debug_view_memory+4)>>2)]=__ZTI17debug_view_memory;
HEAP32[((__ZTI17debug_view_memory)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI17debug_view_memory+4)>>2)]=((STRING_TABLE.__ZTS17debug_view_memory)|0);
HEAP32[((__ZTI17debug_view_memory+8)>>2)]=__ZTI10debug_view;
HEAP32[((__ZTI24debug_view_memory_source)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI24debug_view_memory_source+4)>>2)]=((STRING_TABLE.__ZTS24debug_view_memory_source)|0);
HEAP32[((__ZTI24debug_view_memory_source+8)>>2)]=__ZTI17debug_view_source;
HEAP32[((__ZTV20resource_pool_objectI24debug_view_memory_sourceE+4)>>2)]=__ZTI20resource_pool_objectI24debug_view_memory_sourceE;
HEAP32[((__ZTI20resource_pool_objectI24debug_view_memory_sourceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI24debug_view_memory_sourceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI24debug_view_memory_sourceE)|0);
HEAP32[((__ZTI20resource_pool_objectI24debug_view_memory_sourceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZL8ppi0intf+32)>>2)]=((STRING_TABLE.__str5856)|0);
HEAP32[((__ZL8ppi0intf+56)>>2)]=((STRING_TABLE.__str15857)|0);
HEAP32[((__ZL8ppi0intf+80)>>2)]=((STRING_TABLE.__str25858)|0);
HEAP32[((__ZL8ppi0intf+128)>>2)]=((STRING_TABLE.__str35859)|0);
HEAP32[((__ZL8ppi1intf+8)>>2)]=((STRING_TABLE.__str45860)|0);
HEAP32[((__ZL8ppi1intf+104)>>2)]=((STRING_TABLE.__str55861)|0);
HEAP32[((__ZL8ppi1intf+128)>>2)]=((STRING_TABLE.__str65862)|0);
HEAP32[((__ZL7ctcintf+12)>>2)]=((STRING_TABLE.__str75863)|0);
HEAP32[((__ZL11daisy_chain)>>2)]=((STRING_TABLE.__str85864)|0);
HEAP32[((__ZL11rom_ldv1000)>>2)]=((STRING_TABLE.__str95865)|0);
HEAP32[((__ZL11rom_ldv1000+20)>>2)]=((STRING_TABLE.__str105866)|0);
HEAP32[((__ZL11rom_ldv1000+24)>>2)]=((STRING_TABLE.__str115867)|0);
HEAP32[((_ldv1000_interface+8)>>2)]=((STRING_TABLE.__str125868)|0);
HEAP32[((_ldv1000_interface+12)>>2)]=((STRING_TABLE.__str95865)|0);
HEAP32[((_ldv1000_interface+16)>>2)]=((__ZL11rom_ldv1000)|0);
HEAP32[((__ZL16static_help_list)>>2)]=((__str25902)|0);
HEAP32[((__ZL16static_help_list+4)>>2)]=((STRING_TABLE.__str35903)|0);
HEAP32[((__ZL16static_help_list+8)>>2)]=((STRING_TABLE.__str45904)|0);
HEAP32[((__ZL16static_help_list+12)>>2)]=((STRING_TABLE.__str55905)|0);
HEAP32[((__ZL16static_help_list+16)>>2)]=((STRING_TABLE.__str65906)|0);
HEAP32[((__ZL16static_help_list+20)>>2)]=((STRING_TABLE.__str75907)|0);
HEAP32[((__ZL16static_help_list+24)>>2)]=((STRING_TABLE.__str85908)|0);
HEAP32[((__ZL16static_help_list+28)>>2)]=((STRING_TABLE.__str95909)|0);
HEAP32[((__ZL16static_help_list+32)>>2)]=((STRING_TABLE.__str105910)|0);
HEAP32[((__ZL16static_help_list+36)>>2)]=((STRING_TABLE.__str115911)|0);
HEAP32[((__ZL16static_help_list+40)>>2)]=((STRING_TABLE.__str125912)|0);
HEAP32[((__ZL16static_help_list+44)>>2)]=((STRING_TABLE.__str135913)|0);
HEAP32[((__ZL16static_help_list+48)>>2)]=((STRING_TABLE.__str145914)|0);
HEAP32[((__ZL16static_help_list+52)>>2)]=((STRING_TABLE.__str155915)|0);
HEAP32[((__ZL16static_help_list+56)>>2)]=((STRING_TABLE.__str165916)|0);
HEAP32[((__ZL16static_help_list+60)>>2)]=((STRING_TABLE.__str175917)|0);
HEAP32[((__ZL16static_help_list+64)>>2)]=((STRING_TABLE.__str185918)|0);
HEAP32[((__ZL16static_help_list+68)>>2)]=((STRING_TABLE.__str195919)|0);
HEAP32[((__ZL16static_help_list+72)>>2)]=((STRING_TABLE.__str205920)|0);
HEAP32[((__ZL16static_help_list+76)>>2)]=((STRING_TABLE.__str215921)|0);
HEAP32[((__ZL16static_help_list+80)>>2)]=((STRING_TABLE.__str225922)|0);
HEAP32[((__ZL16static_help_list+84)>>2)]=((STRING_TABLE.__str235923)|0);
HEAP32[((__ZL16static_help_list+88)>>2)]=((STRING_TABLE.__str245924)|0);
HEAP32[((__ZL16static_help_list+92)>>2)]=((STRING_TABLE.__str255925)|0);
HEAP32[((__ZL16static_help_list+96)>>2)]=((STRING_TABLE.__str265926)|0);
HEAP32[((__ZL16static_help_list+100)>>2)]=((STRING_TABLE.__str275927)|0);
HEAP32[((__ZL16static_help_list+104)>>2)]=((STRING_TABLE.__str285928)|0);
HEAP32[((__ZL16static_help_list+108)>>2)]=((STRING_TABLE.__str295929)|0);
HEAP32[((__ZL16static_help_list+112)>>2)]=((STRING_TABLE.__str305930)|0);
HEAP32[((__ZL16static_help_list+116)>>2)]=((STRING_TABLE.__str315931)|0);
HEAP32[((__ZL16static_help_list+120)>>2)]=((STRING_TABLE.__str325932)|0);
HEAP32[((__ZL16static_help_list+124)>>2)]=((STRING_TABLE.__str335933)|0);
HEAP32[((__ZL16static_help_list+128)>>2)]=((STRING_TABLE.__str345934)|0);
HEAP32[((__ZL16static_help_list+132)>>2)]=((STRING_TABLE.__str355935)|0);
HEAP32[((__ZL16static_help_list+136)>>2)]=((STRING_TABLE.__str365936)|0);
HEAP32[((__ZL16static_help_list+140)>>2)]=((STRING_TABLE.__str375937)|0);
HEAP32[((__ZL16static_help_list+144)>>2)]=((STRING_TABLE.__str385938)|0);
HEAP32[((__ZL16static_help_list+148)>>2)]=((STRING_TABLE.__str395939)|0);
HEAP32[((__ZL16static_help_list+152)>>2)]=((STRING_TABLE.__str405940)|0);
HEAP32[((__ZL16static_help_list+156)>>2)]=((STRING_TABLE.__str415941)|0);
HEAP32[((__ZL16static_help_list+160)>>2)]=((STRING_TABLE.__str425942)|0);
HEAP32[((__ZL16static_help_list+164)>>2)]=((STRING_TABLE.__str435943)|0);
HEAP32[((__ZL16static_help_list+168)>>2)]=((STRING_TABLE.__str445944)|0);
HEAP32[((__ZL16static_help_list+172)>>2)]=((STRING_TABLE.__str455945)|0);
HEAP32[((__ZL16static_help_list+176)>>2)]=((STRING_TABLE.__str465946)|0);
HEAP32[((__ZL16static_help_list+180)>>2)]=((STRING_TABLE.__str475947)|0);
HEAP32[((__ZL16static_help_list+184)>>2)]=((STRING_TABLE.__str485948)|0);
HEAP32[((__ZL16static_help_list+188)>>2)]=((STRING_TABLE.__str495949)|0);
HEAP32[((__ZL16static_help_list+192)>>2)]=((STRING_TABLE.__str505950)|0);
HEAP32[((__ZL16static_help_list+196)>>2)]=((STRING_TABLE.__str515951)|0);
HEAP32[((__ZL16static_help_list+200)>>2)]=((STRING_TABLE.__str525952)|0);
HEAP32[((__ZL16static_help_list+204)>>2)]=((STRING_TABLE.__str535953)|0);
HEAP32[((__ZL16static_help_list+208)>>2)]=((STRING_TABLE.__str545954)|0);
HEAP32[((__ZL16static_help_list+212)>>2)]=((STRING_TABLE.__str555955)|0);
HEAP32[((__ZL16static_help_list+216)>>2)]=((STRING_TABLE.__str565956)|0);
HEAP32[((__ZL16static_help_list+220)>>2)]=((STRING_TABLE.__str575957)|0);
HEAP32[((__ZL16static_help_list+224)>>2)]=((STRING_TABLE.__str585958)|0);
HEAP32[((__ZL16static_help_list+228)>>2)]=((STRING_TABLE.__str595959)|0);
HEAP32[((__ZL16static_help_list+232)>>2)]=((STRING_TABLE.__str605960)|0);
HEAP32[((__ZL16static_help_list+236)>>2)]=((STRING_TABLE.__str615961)|0);
HEAP32[((__ZL16static_help_list+240)>>2)]=((STRING_TABLE.__str625962)|0);
HEAP32[((__ZL16static_help_list+244)>>2)]=((STRING_TABLE.__str635963)|0);
HEAP32[((__ZL16static_help_list+248)>>2)]=((STRING_TABLE.__str645964)|0);
HEAP32[((__ZL16static_help_list+252)>>2)]=((STRING_TABLE.__str655965)|0);
HEAP32[((__ZL16static_help_list+256)>>2)]=((STRING_TABLE.__str665966)|0);
HEAP32[((__ZL16static_help_list+260)>>2)]=((STRING_TABLE.__str675967)|0);
HEAP32[((__ZL16static_help_list+264)>>2)]=((STRING_TABLE.__str685968)|0);
HEAP32[((__ZL16static_help_list+268)>>2)]=((STRING_TABLE.__str695969)|0);
HEAP32[((__ZL16static_help_list+272)>>2)]=((STRING_TABLE.__str705970)|0);
HEAP32[((__ZL16static_help_list+276)>>2)]=((STRING_TABLE.__str715971)|0);
HEAP32[((__ZL16static_help_list+280)>>2)]=((STRING_TABLE.__str725972)|0);
HEAP32[((__ZL16static_help_list+284)>>2)]=((STRING_TABLE.__str735973)|0);
HEAP32[((__ZL16static_help_list+288)>>2)]=((STRING_TABLE.__str745974)|0);
HEAP32[((__ZL16static_help_list+292)>>2)]=((STRING_TABLE.__str755975)|0);
HEAP32[((__ZL16static_help_list+296)>>2)]=((STRING_TABLE.__str765976)|0);
HEAP32[((__ZL16static_help_list+300)>>2)]=((STRING_TABLE.__str775977)|0);
HEAP32[((__ZL16static_help_list+304)>>2)]=((STRING_TABLE.__str785978)|0);
HEAP32[((__ZL16static_help_list+308)>>2)]=((STRING_TABLE.__str795979)|0);
HEAP32[((__ZL16static_help_list+312)>>2)]=((STRING_TABLE.__str805980)|0);
HEAP32[((__ZL16static_help_list+316)>>2)]=((STRING_TABLE.__str815981)|0);
HEAP32[((__ZL16static_help_list+320)>>2)]=((STRING_TABLE.__str825982)|0);
HEAP32[((__ZL16static_help_list+324)>>2)]=((STRING_TABLE.__str835983)|0);
HEAP32[((__ZL16static_help_list+328)>>2)]=((STRING_TABLE.__str845984)|0);
HEAP32[((__ZL16static_help_list+332)>>2)]=((STRING_TABLE.__str855985)|0);
HEAP32[((__ZL16static_help_list+336)>>2)]=((STRING_TABLE.__str865986)|0);
HEAP32[((__ZL16static_help_list+340)>>2)]=((STRING_TABLE.__str875987)|0);
HEAP32[((__ZL16static_help_list+344)>>2)]=((STRING_TABLE.__str885988)|0);
HEAP32[((__ZL16static_help_list+348)>>2)]=((STRING_TABLE.__str895989)|0);
HEAP32[((__ZL16static_help_list+352)>>2)]=((STRING_TABLE.__str905990)|0);
HEAP32[((__ZL16static_help_list+356)>>2)]=((STRING_TABLE.__str915991)|0);
HEAP32[((__ZL16static_help_list+360)>>2)]=((STRING_TABLE.__str925992)|0);
HEAP32[((__ZL16static_help_list+364)>>2)]=((STRING_TABLE.__str935993)|0);
HEAP32[((__ZL16static_help_list+368)>>2)]=((STRING_TABLE.__str945994)|0);
HEAP32[((__ZL16static_help_list+372)>>2)]=((STRING_TABLE.__str955995)|0);
HEAP32[((__ZL16static_help_list+376)>>2)]=((STRING_TABLE.__str965996)|0);
HEAP32[((__ZL16static_help_list+380)>>2)]=((STRING_TABLE.__str975997)|0);
HEAP32[((__ZL16static_help_list+384)>>2)]=((STRING_TABLE.__str985998)|0);
HEAP32[((__ZL16static_help_list+388)>>2)]=((STRING_TABLE.__str995999)|0);
HEAP32[((__ZL16static_help_list+392)>>2)]=((STRING_TABLE.__str1006000)|0);
HEAP32[((__ZL16static_help_list+396)>>2)]=((STRING_TABLE.__str1016001)|0);
HEAP32[((__ZL16static_help_list+400)>>2)]=((STRING_TABLE.__str1026002)|0);
HEAP32[((__ZL16static_help_list+404)>>2)]=((STRING_TABLE.__str1036003)|0);
HEAP32[((__ZL16static_help_list+408)>>2)]=((STRING_TABLE.__str1046004)|0);
HEAP32[((__ZL16static_help_list+412)>>2)]=((STRING_TABLE.__str1056005)|0);
HEAP32[((__ZL16static_help_list+416)>>2)]=((STRING_TABLE.__str1066006)|0);
HEAP32[((__ZL16static_help_list+420)>>2)]=((STRING_TABLE.__str1076007)|0);
HEAP32[((__ZL16static_help_list+424)>>2)]=((STRING_TABLE.__str1086008)|0);
HEAP32[((__ZL16static_help_list+428)>>2)]=((STRING_TABLE.__str1096009)|0);
HEAP32[((__ZL16static_help_list+432)>>2)]=((STRING_TABLE.__str1106010)|0);
HEAP32[((__ZL16static_help_list+436)>>2)]=((STRING_TABLE.__str1116011)|0);
HEAP32[((__ZL16static_help_list+440)>>2)]=((STRING_TABLE.__str1126012)|0);
HEAP32[((__ZL16static_help_list+444)>>2)]=((STRING_TABLE.__str1136013)|0);
HEAP32[((__ZL16static_help_list+448)>>2)]=((STRING_TABLE.__str1146014)|0);
HEAP32[((__ZL16static_help_list+452)>>2)]=((STRING_TABLE.__str1156015)|0);
HEAP32[((__ZL16static_help_list+456)>>2)]=((STRING_TABLE.__str1166016)|0);
HEAP32[((__ZL16static_help_list+460)>>2)]=((STRING_TABLE.__str1176017)|0);
HEAP32[((__ZL16static_help_list+464)>>2)]=((STRING_TABLE.__str1186018)|0);
HEAP32[((__ZL16static_help_list+468)>>2)]=((STRING_TABLE.__str1196019)|0);
HEAP32[((__ZL16static_help_list+472)>>2)]=((STRING_TABLE.__str1206020)|0);
HEAP32[((__ZL16static_help_list+476)>>2)]=((STRING_TABLE.__str1216021)|0);
HEAP32[((__ZL16static_help_list+480)>>2)]=((STRING_TABLE.__str1226022)|0);
HEAP32[((__ZL16static_help_list+484)>>2)]=((STRING_TABLE.__str1236023)|0);
HEAP32[((__ZL16static_help_list+488)>>2)]=((STRING_TABLE.__str1246024)|0);
HEAP32[((__ZL16static_help_list+492)>>2)]=((STRING_TABLE.__str1256025)|0);
HEAP32[((__ZL16static_help_list+496)>>2)]=((STRING_TABLE.__str1266026)|0);
HEAP32[((__ZL16static_help_list+500)>>2)]=((STRING_TABLE.__str1276027)|0);
HEAP32[((__ZL16static_help_list+504)>>2)]=((STRING_TABLE.__str1286028)|0);
HEAP32[((__ZL16static_help_list+508)>>2)]=((STRING_TABLE.__str1296029)|0);
HEAP32[((__ZL16static_help_list+512)>>2)]=((STRING_TABLE.__str1306030)|0);
HEAP32[((__ZL16static_help_list+516)>>2)]=((STRING_TABLE.__str1316031)|0);
HEAP32[((__ZL10rom_pr8210)>>2)]=((STRING_TABLE.__str6034)|0);
HEAP32[((__ZL10rom_pr8210+20)>>2)]=((STRING_TABLE.__str16035)|0);
HEAP32[((__ZL10rom_pr8210+24)>>2)]=((STRING_TABLE.__str26036)|0);
HEAP32[((_pr8210_interface+8)>>2)]=((STRING_TABLE.__str36037)|0);
HEAP32[((_pr8210_interface+12)>>2)]=((STRING_TABLE.__str6034)|0);
HEAP32[((_pr8210_interface+16)>>2)]=((__ZL10rom_pr8210)|0);
HEAP32[((__ZL12rom_simutrek)>>2)]=((STRING_TABLE.__str6034)|0);
HEAP32[((__ZL12rom_simutrek+20)>>2)]=((STRING_TABLE.__str16035)|0);
HEAP32[((__ZL12rom_simutrek+24)>>2)]=((STRING_TABLE.__str26036)|0);
HEAP32[((__ZL12rom_simutrek+40)>>2)]=((STRING_TABLE.__str46040)|0);
HEAP32[((__ZL12rom_simutrek+60)>>2)]=((STRING_TABLE.__str56041)|0);
HEAP32[((__ZL12rom_simutrek+64)>>2)]=((STRING_TABLE.__str66042)|0);
HEAP32[((_simutrek_interface+8)>>2)]=((STRING_TABLE.__str76043)|0);
HEAP32[((_simutrek_interface+12)>>2)]=((STRING_TABLE.__str86044)|0);
HEAP32[((_simutrek_interface+16)>>2)]=((__ZL12rom_simutrek)|0);
HEAP32[((__ZL9rom_vp931)>>2)]=((STRING_TABLE.__str6078)|0);
HEAP32[((__ZL9rom_vp931+20)>>2)]=((STRING_TABLE.__str16079)|0);
HEAP32[((__ZL9rom_vp931+24)>>2)]=((STRING_TABLE.__str26080)|0);
HEAP32[((_vp931_interface+8)>>2)]=((STRING_TABLE.__str36081)|0);
HEAP32[((_vp931_interface+12)>>2)]=((STRING_TABLE.__str46082)|0);
HEAP32[((_vp931_interface+16)>>2)]=((__ZL9rom_vp931)|0);
HEAP32[((__ZTV14ppi8255_device+4)>>2)]=__ZTI14ppi8255_device;
HEAP32[((__ZTI17ppi8255_interface)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI17ppi8255_interface+4)>>2)]=((STRING_TABLE.__ZTS17ppi8255_interface)|0);
HEAP32[((__ZTI14ppi8255_device)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI14ppi8255_device+4)>>2)]=((STRING_TABLE.__ZTS14ppi8255_device)|0);
HEAP32[((__ZTI14ppi8255_device+16)>>2)]=__ZTI8device_t;
HEAP32[((__ZTI14ppi8255_device+24)>>2)]=__ZTI17ppi8255_interface;
HEAP32[((__ZTV20resource_pool_objectI14ppi8255_deviceE+4)>>2)]=__ZTI20resource_pool_objectI14ppi8255_deviceE;
HEAP32[((__ZTI20resource_pool_objectI14ppi8255_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14ppi8255_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14ppi8255_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI14ppi8255_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTV13z80ctc_device+4)>>2)]=__ZTI13z80ctc_device;
HEAP32[((__ZTV13z80ctc_device+84)>>2)]=__ZTI13z80ctc_device;
HEAP32[((__ZTI16z80ctc_interface)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI16z80ctc_interface+4)>>2)]=((STRING_TABLE.__ZTS16z80ctc_interface)|0);
HEAP32[((__ZTI13z80ctc_device)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTI13z80ctc_device+4)>>2)]=((STRING_TABLE.__ZTS13z80ctc_device)|0);
HEAP32[((__ZTI13z80ctc_device+16)>>2)]=__ZTI8device_t;
HEAP32[((__ZTI13z80ctc_device+24)>>2)]=__ZTI25device_z80daisy_interface;
HEAP32[((__ZTI13z80ctc_device+32)>>2)]=__ZTI16z80ctc_interface;
HEAP32[((__ZTV20resource_pool_objectI13z80ctc_deviceE+4)>>2)]=__ZTI20resource_pool_objectI13z80ctc_deviceE;
HEAP32[((__ZTI20resource_pool_objectI13z80ctc_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI13z80ctc_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI13z80ctc_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI13z80ctc_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI13delegate_baseIvjh8_noparamS0_E)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13delegate_baseIvjh8_noparamS0_E+4)>>2)]=((STRING_TABLE.__ZTS13delegate_baseIvjh8_noparamS0_E)|0);
HEAP32[((__ZTI8delegateIFvjhEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI8delegateIFvjhEE+4)>>2)]=((STRING_TABLE.__ZTS8delegateIFvjhEE)|0);
HEAP32[((__ZTI8delegateIFvjhEE+8)>>2)]=__ZTI13delegate_baseIvjh8_noparamS0_E;
HEAP32[((__ZTI21devcb_resolved_write8)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI21devcb_resolved_write8+4)>>2)]=((STRING_TABLE.__ZTS21devcb_resolved_write8)|0);
HEAP32[((__ZTI21devcb_resolved_write8+8)>>2)]=__ZTI8delegateIFvjhEE;
HEAP32[((__ZTI13delegate_baseIhj8_noparamS0_S0_E)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13delegate_baseIhj8_noparamS0_S0_E+4)>>2)]=((STRING_TABLE.__ZTS13delegate_baseIhj8_noparamS0_S0_E)|0);
HEAP32[((__ZTI8delegateIFhjEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI8delegateIFhjEE+4)>>2)]=((STRING_TABLE.__ZTS8delegateIFhjEE)|0);
HEAP32[((__ZTI8delegateIFhjEE+8)>>2)]=__ZTI13delegate_baseIhj8_noparamS0_S0_E;
HEAP32[((__ZTI20devcb_resolved_read8)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20devcb_resolved_read8+4)>>2)]=((STRING_TABLE.__ZTS20devcb_resolved_read8)|0);
HEAP32[((__ZTI20devcb_resolved_read8+8)>>2)]=__ZTI8delegateIFhjEE;
HEAP32[((__ZTI13delegate_baseIvi8_noparamS0_S0_E)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13delegate_baseIvi8_noparamS0_S0_E+4)>>2)]=((STRING_TABLE.__ZTS13delegate_baseIvi8_noparamS0_S0_E)|0);
HEAP32[((__ZTI8delegateIFviEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI8delegateIFviEE+4)>>2)]=((STRING_TABLE.__ZTS8delegateIFviEE)|0);
HEAP32[((__ZTI8delegateIFviEE+8)>>2)]=__ZTI13delegate_baseIvi8_noparamS0_S0_E;
HEAP32[((__ZTI25devcb_resolved_write_line)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI25devcb_resolved_write_line+4)>>2)]=((STRING_TABLE.__ZTS25devcb_resolved_write_line)|0);
HEAP32[((__ZTI25devcb_resolved_write_line+8)>>2)]=__ZTI8delegateIFviEE;
HEAP32[((__ZL11mnemonic_cb+4)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+12)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+20)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+28)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+36)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+44)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+52)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+60)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+68)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+76)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+84)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+92)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+100)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+108)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+116)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+124)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+132)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+140)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+148)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+156)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+164)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+172)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+180)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+188)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+196)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+204)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+212)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+220)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+228)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+236)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+244)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+252)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+260)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+268)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+276)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+284)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+292)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+300)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+308)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+316)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+324)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+332)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+340)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+348)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+356)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+364)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+372)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+380)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+388)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+396)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+404)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+412)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+420)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+428)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+436)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+444)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+452)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL11mnemonic_cb+460)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL11mnemonic_cb+468)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL11mnemonic_cb+476)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL11mnemonic_cb+484)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL11mnemonic_cb+492)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL11mnemonic_cb+500)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_cb+508)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL11mnemonic_cb+516)>>2)]=((STRING_TABLE.__str3696549)|0);
HEAP32[((__ZL11mnemonic_cb+524)>>2)]=((STRING_TABLE.__str3706550)|0);
HEAP32[((__ZL11mnemonic_cb+532)>>2)]=((STRING_TABLE.__str3716551)|0);
HEAP32[((__ZL11mnemonic_cb+540)>>2)]=((STRING_TABLE.__str3726552)|0);
HEAP32[((__ZL11mnemonic_cb+548)>>2)]=((STRING_TABLE.__str3736553)|0);
HEAP32[((__ZL11mnemonic_cb+556)>>2)]=((STRING_TABLE.__str3746554)|0);
HEAP32[((__ZL11mnemonic_cb+564)>>2)]=((STRING_TABLE.__str3756555)|0);
HEAP32[((__ZL11mnemonic_cb+572)>>2)]=((STRING_TABLE.__str3766556)|0);
HEAP32[((__ZL11mnemonic_cb+580)>>2)]=((STRING_TABLE.__str3776557)|0);
HEAP32[((__ZL11mnemonic_cb+588)>>2)]=((STRING_TABLE.__str3786558)|0);
HEAP32[((__ZL11mnemonic_cb+596)>>2)]=((STRING_TABLE.__str3796559)|0);
HEAP32[((__ZL11mnemonic_cb+604)>>2)]=((STRING_TABLE.__str3806560)|0);
HEAP32[((__ZL11mnemonic_cb+612)>>2)]=((STRING_TABLE.__str3816561)|0);
HEAP32[((__ZL11mnemonic_cb+620)>>2)]=((STRING_TABLE.__str3826562)|0);
HEAP32[((__ZL11mnemonic_cb+628)>>2)]=((STRING_TABLE.__str3836563)|0);
HEAP32[((__ZL11mnemonic_cb+636)>>2)]=((STRING_TABLE.__str3846564)|0);
HEAP32[((__ZL11mnemonic_cb+644)>>2)]=((STRING_TABLE.__str3856565)|0);
HEAP32[((__ZL11mnemonic_cb+652)>>2)]=((STRING_TABLE.__str3866566)|0);
HEAP32[((__ZL11mnemonic_cb+660)>>2)]=((STRING_TABLE.__str3876567)|0);
HEAP32[((__ZL11mnemonic_cb+668)>>2)]=((STRING_TABLE.__str3886568)|0);
HEAP32[((__ZL11mnemonic_cb+676)>>2)]=((STRING_TABLE.__str3896569)|0);
HEAP32[((__ZL11mnemonic_cb+684)>>2)]=((STRING_TABLE.__str3906570)|0);
HEAP32[((__ZL11mnemonic_cb+692)>>2)]=((STRING_TABLE.__str3916571)|0);
HEAP32[((__ZL11mnemonic_cb+700)>>2)]=((STRING_TABLE.__str3926572)|0);
HEAP32[((__ZL11mnemonic_cb+708)>>2)]=((STRING_TABLE.__str3936573)|0);
HEAP32[((__ZL11mnemonic_cb+716)>>2)]=((STRING_TABLE.__str3946574)|0);
HEAP32[((__ZL11mnemonic_cb+724)>>2)]=((STRING_TABLE.__str3956575)|0);
HEAP32[((__ZL11mnemonic_cb+732)>>2)]=((STRING_TABLE.__str3966576)|0);
HEAP32[((__ZL11mnemonic_cb+740)>>2)]=((STRING_TABLE.__str3976577)|0);
HEAP32[((__ZL11mnemonic_cb+748)>>2)]=((STRING_TABLE.__str3986578)|0);
HEAP32[((__ZL11mnemonic_cb+756)>>2)]=((STRING_TABLE.__str3996579)|0);
HEAP32[((__ZL11mnemonic_cb+764)>>2)]=((STRING_TABLE.__str4006580)|0);
HEAP32[((__ZL11mnemonic_cb+772)>>2)]=((STRING_TABLE.__str4016581)|0);
HEAP32[((__ZL11mnemonic_cb+780)>>2)]=((STRING_TABLE.__str4026582)|0);
HEAP32[((__ZL11mnemonic_cb+788)>>2)]=((STRING_TABLE.__str4036583)|0);
HEAP32[((__ZL11mnemonic_cb+796)>>2)]=((STRING_TABLE.__str4046584)|0);
HEAP32[((__ZL11mnemonic_cb+804)>>2)]=((STRING_TABLE.__str4056585)|0);
HEAP32[((__ZL11mnemonic_cb+812)>>2)]=((STRING_TABLE.__str4066586)|0);
HEAP32[((__ZL11mnemonic_cb+820)>>2)]=((STRING_TABLE.__str4076587)|0);
HEAP32[((__ZL11mnemonic_cb+828)>>2)]=((STRING_TABLE.__str4086588)|0);
HEAP32[((__ZL11mnemonic_cb+836)>>2)]=((STRING_TABLE.__str4096589)|0);
HEAP32[((__ZL11mnemonic_cb+844)>>2)]=((STRING_TABLE.__str4106590)|0);
HEAP32[((__ZL11mnemonic_cb+852)>>2)]=((STRING_TABLE.__str4116591)|0);
HEAP32[((__ZL11mnemonic_cb+860)>>2)]=((STRING_TABLE.__str4126592)|0);
HEAP32[((__ZL11mnemonic_cb+868)>>2)]=((STRING_TABLE.__str4136593)|0);
HEAP32[((__ZL11mnemonic_cb+876)>>2)]=((STRING_TABLE.__str4146594)|0);
HEAP32[((__ZL11mnemonic_cb+884)>>2)]=((STRING_TABLE.__str4156595)|0);
HEAP32[((__ZL11mnemonic_cb+892)>>2)]=((STRING_TABLE.__str4166596)|0);
HEAP32[((__ZL11mnemonic_cb+900)>>2)]=((STRING_TABLE.__str4176597)|0);
HEAP32[((__ZL11mnemonic_cb+908)>>2)]=((STRING_TABLE.__str4186598)|0);
HEAP32[((__ZL11mnemonic_cb+916)>>2)]=((STRING_TABLE.__str4196599)|0);
HEAP32[((__ZL11mnemonic_cb+924)>>2)]=((STRING_TABLE.__str4206600)|0);
HEAP32[((__ZL11mnemonic_cb+932)>>2)]=((STRING_TABLE.__str4216601)|0);
HEAP32[((__ZL11mnemonic_cb+940)>>2)]=((STRING_TABLE.__str4226602)|0);
HEAP32[((__ZL11mnemonic_cb+948)>>2)]=((STRING_TABLE.__str4236603)|0);
HEAP32[((__ZL11mnemonic_cb+956)>>2)]=((STRING_TABLE.__str4246604)|0);
HEAP32[((__ZL11mnemonic_cb+964)>>2)]=((STRING_TABLE.__str4256605)|0);
HEAP32[((__ZL11mnemonic_cb+972)>>2)]=((STRING_TABLE.__str4266606)|0);
HEAP32[((__ZL11mnemonic_cb+980)>>2)]=((STRING_TABLE.__str4276607)|0);
HEAP32[((__ZL11mnemonic_cb+988)>>2)]=((STRING_TABLE.__str4286608)|0);
HEAP32[((__ZL11mnemonic_cb+996)>>2)]=((STRING_TABLE.__str4296609)|0);
HEAP32[((__ZL11mnemonic_cb+1004)>>2)]=((STRING_TABLE.__str4306610)|0);
HEAP32[((__ZL11mnemonic_cb+1012)>>2)]=((STRING_TABLE.__str4316611)|0);
HEAP32[((__ZL11mnemonic_cb+1020)>>2)]=((STRING_TABLE.__str4326612)|0);
HEAP32[((__ZL11mnemonic_cb+1028)>>2)]=((STRING_TABLE.__str3696549)|0);
HEAP32[((__ZL11mnemonic_cb+1036)>>2)]=((STRING_TABLE.__str3706550)|0);
HEAP32[((__ZL11mnemonic_cb+1044)>>2)]=((STRING_TABLE.__str3716551)|0);
HEAP32[((__ZL11mnemonic_cb+1052)>>2)]=((STRING_TABLE.__str3726552)|0);
HEAP32[((__ZL11mnemonic_cb+1060)>>2)]=((STRING_TABLE.__str3736553)|0);
HEAP32[((__ZL11mnemonic_cb+1068)>>2)]=((STRING_TABLE.__str3746554)|0);
HEAP32[((__ZL11mnemonic_cb+1076)>>2)]=((STRING_TABLE.__str3756555)|0);
HEAP32[((__ZL11mnemonic_cb+1084)>>2)]=((STRING_TABLE.__str3766556)|0);
HEAP32[((__ZL11mnemonic_cb+1092)>>2)]=((STRING_TABLE.__str3776557)|0);
HEAP32[((__ZL11mnemonic_cb+1100)>>2)]=((STRING_TABLE.__str3786558)|0);
HEAP32[((__ZL11mnemonic_cb+1108)>>2)]=((STRING_TABLE.__str3796559)|0);
HEAP32[((__ZL11mnemonic_cb+1116)>>2)]=((STRING_TABLE.__str3806560)|0);
HEAP32[((__ZL11mnemonic_cb+1124)>>2)]=((STRING_TABLE.__str3816561)|0);
HEAP32[((__ZL11mnemonic_cb+1132)>>2)]=((STRING_TABLE.__str3826562)|0);
HEAP32[((__ZL11mnemonic_cb+1140)>>2)]=((STRING_TABLE.__str3836563)|0);
HEAP32[((__ZL11mnemonic_cb+1148)>>2)]=((STRING_TABLE.__str3846564)|0);
HEAP32[((__ZL11mnemonic_cb+1156)>>2)]=((STRING_TABLE.__str3856565)|0);
HEAP32[((__ZL11mnemonic_cb+1164)>>2)]=((STRING_TABLE.__str3866566)|0);
HEAP32[((__ZL11mnemonic_cb+1172)>>2)]=((STRING_TABLE.__str3876567)|0);
HEAP32[((__ZL11mnemonic_cb+1180)>>2)]=((STRING_TABLE.__str3886568)|0);
HEAP32[((__ZL11mnemonic_cb+1188)>>2)]=((STRING_TABLE.__str3896569)|0);
HEAP32[((__ZL11mnemonic_cb+1196)>>2)]=((STRING_TABLE.__str3906570)|0);
HEAP32[((__ZL11mnemonic_cb+1204)>>2)]=((STRING_TABLE.__str3916571)|0);
HEAP32[((__ZL11mnemonic_cb+1212)>>2)]=((STRING_TABLE.__str3926572)|0);
HEAP32[((__ZL11mnemonic_cb+1220)>>2)]=((STRING_TABLE.__str3936573)|0);
HEAP32[((__ZL11mnemonic_cb+1228)>>2)]=((STRING_TABLE.__str3946574)|0);
HEAP32[((__ZL11mnemonic_cb+1236)>>2)]=((STRING_TABLE.__str3956575)|0);
HEAP32[((__ZL11mnemonic_cb+1244)>>2)]=((STRING_TABLE.__str3966576)|0);
HEAP32[((__ZL11mnemonic_cb+1252)>>2)]=((STRING_TABLE.__str3976577)|0);
HEAP32[((__ZL11mnemonic_cb+1260)>>2)]=((STRING_TABLE.__str3986578)|0);
HEAP32[((__ZL11mnemonic_cb+1268)>>2)]=((STRING_TABLE.__str3996579)|0);
HEAP32[((__ZL11mnemonic_cb+1276)>>2)]=((STRING_TABLE.__str4006580)|0);
HEAP32[((__ZL11mnemonic_cb+1284)>>2)]=((STRING_TABLE.__str4016581)|0);
HEAP32[((__ZL11mnemonic_cb+1292)>>2)]=((STRING_TABLE.__str4026582)|0);
HEAP32[((__ZL11mnemonic_cb+1300)>>2)]=((STRING_TABLE.__str4036583)|0);
HEAP32[((__ZL11mnemonic_cb+1308)>>2)]=((STRING_TABLE.__str4046584)|0);
HEAP32[((__ZL11mnemonic_cb+1316)>>2)]=((STRING_TABLE.__str4056585)|0);
HEAP32[((__ZL11mnemonic_cb+1324)>>2)]=((STRING_TABLE.__str4066586)|0);
HEAP32[((__ZL11mnemonic_cb+1332)>>2)]=((STRING_TABLE.__str4076587)|0);
HEAP32[((__ZL11mnemonic_cb+1340)>>2)]=((STRING_TABLE.__str4086588)|0);
HEAP32[((__ZL11mnemonic_cb+1348)>>2)]=((STRING_TABLE.__str4096589)|0);
HEAP32[((__ZL11mnemonic_cb+1356)>>2)]=((STRING_TABLE.__str4106590)|0);
HEAP32[((__ZL11mnemonic_cb+1364)>>2)]=((STRING_TABLE.__str4116591)|0);
HEAP32[((__ZL11mnemonic_cb+1372)>>2)]=((STRING_TABLE.__str4126592)|0);
HEAP32[((__ZL11mnemonic_cb+1380)>>2)]=((STRING_TABLE.__str4136593)|0);
HEAP32[((__ZL11mnemonic_cb+1388)>>2)]=((STRING_TABLE.__str4146594)|0);
HEAP32[((__ZL11mnemonic_cb+1396)>>2)]=((STRING_TABLE.__str4156595)|0);
HEAP32[((__ZL11mnemonic_cb+1404)>>2)]=((STRING_TABLE.__str4166596)|0);
HEAP32[((__ZL11mnemonic_cb+1412)>>2)]=((STRING_TABLE.__str4176597)|0);
HEAP32[((__ZL11mnemonic_cb+1420)>>2)]=((STRING_TABLE.__str4186598)|0);
HEAP32[((__ZL11mnemonic_cb+1428)>>2)]=((STRING_TABLE.__str4196599)|0);
HEAP32[((__ZL11mnemonic_cb+1436)>>2)]=((STRING_TABLE.__str4206600)|0);
HEAP32[((__ZL11mnemonic_cb+1444)>>2)]=((STRING_TABLE.__str4216601)|0);
HEAP32[((__ZL11mnemonic_cb+1452)>>2)]=((STRING_TABLE.__str4226602)|0);
HEAP32[((__ZL11mnemonic_cb+1460)>>2)]=((STRING_TABLE.__str4236603)|0);
HEAP32[((__ZL11mnemonic_cb+1468)>>2)]=((STRING_TABLE.__str4246604)|0);
HEAP32[((__ZL11mnemonic_cb+1476)>>2)]=((STRING_TABLE.__str4256605)|0);
HEAP32[((__ZL11mnemonic_cb+1484)>>2)]=((STRING_TABLE.__str4266606)|0);
HEAP32[((__ZL11mnemonic_cb+1492)>>2)]=((STRING_TABLE.__str4276607)|0);
HEAP32[((__ZL11mnemonic_cb+1500)>>2)]=((STRING_TABLE.__str4286608)|0);
HEAP32[((__ZL11mnemonic_cb+1508)>>2)]=((STRING_TABLE.__str4296609)|0);
HEAP32[((__ZL11mnemonic_cb+1516)>>2)]=((STRING_TABLE.__str4306610)|0);
HEAP32[((__ZL11mnemonic_cb+1524)>>2)]=((STRING_TABLE.__str4316611)|0);
HEAP32[((__ZL11mnemonic_cb+1532)>>2)]=((STRING_TABLE.__str4326612)|0);
HEAP32[((__ZL11mnemonic_cb+1540)>>2)]=((STRING_TABLE.__str3696549)|0);
HEAP32[((__ZL11mnemonic_cb+1548)>>2)]=((STRING_TABLE.__str3706550)|0);
HEAP32[((__ZL11mnemonic_cb+1556)>>2)]=((STRING_TABLE.__str3716551)|0);
HEAP32[((__ZL11mnemonic_cb+1564)>>2)]=((STRING_TABLE.__str3726552)|0);
HEAP32[((__ZL11mnemonic_cb+1572)>>2)]=((STRING_TABLE.__str3736553)|0);
HEAP32[((__ZL11mnemonic_cb+1580)>>2)]=((STRING_TABLE.__str3746554)|0);
HEAP32[((__ZL11mnemonic_cb+1588)>>2)]=((STRING_TABLE.__str3756555)|0);
HEAP32[((__ZL11mnemonic_cb+1596)>>2)]=((STRING_TABLE.__str3766556)|0);
HEAP32[((__ZL11mnemonic_cb+1604)>>2)]=((STRING_TABLE.__str3776557)|0);
HEAP32[((__ZL11mnemonic_cb+1612)>>2)]=((STRING_TABLE.__str3786558)|0);
HEAP32[((__ZL11mnemonic_cb+1620)>>2)]=((STRING_TABLE.__str3796559)|0);
HEAP32[((__ZL11mnemonic_cb+1628)>>2)]=((STRING_TABLE.__str3806560)|0);
HEAP32[((__ZL11mnemonic_cb+1636)>>2)]=((STRING_TABLE.__str3816561)|0);
HEAP32[((__ZL11mnemonic_cb+1644)>>2)]=((STRING_TABLE.__str3826562)|0);
HEAP32[((__ZL11mnemonic_cb+1652)>>2)]=((STRING_TABLE.__str3836563)|0);
HEAP32[((__ZL11mnemonic_cb+1660)>>2)]=((STRING_TABLE.__str3846564)|0);
HEAP32[((__ZL11mnemonic_cb+1668)>>2)]=((STRING_TABLE.__str3856565)|0);
HEAP32[((__ZL11mnemonic_cb+1676)>>2)]=((STRING_TABLE.__str3866566)|0);
HEAP32[((__ZL11mnemonic_cb+1684)>>2)]=((STRING_TABLE.__str3876567)|0);
HEAP32[((__ZL11mnemonic_cb+1692)>>2)]=((STRING_TABLE.__str3886568)|0);
HEAP32[((__ZL11mnemonic_cb+1700)>>2)]=((STRING_TABLE.__str3896569)|0);
HEAP32[((__ZL11mnemonic_cb+1708)>>2)]=((STRING_TABLE.__str3906570)|0);
HEAP32[((__ZL11mnemonic_cb+1716)>>2)]=((STRING_TABLE.__str3916571)|0);
HEAP32[((__ZL11mnemonic_cb+1724)>>2)]=((STRING_TABLE.__str3926572)|0);
HEAP32[((__ZL11mnemonic_cb+1732)>>2)]=((STRING_TABLE.__str3936573)|0);
HEAP32[((__ZL11mnemonic_cb+1740)>>2)]=((STRING_TABLE.__str3946574)|0);
HEAP32[((__ZL11mnemonic_cb+1748)>>2)]=((STRING_TABLE.__str3956575)|0);
HEAP32[((__ZL11mnemonic_cb+1756)>>2)]=((STRING_TABLE.__str3966576)|0);
HEAP32[((__ZL11mnemonic_cb+1764)>>2)]=((STRING_TABLE.__str3976577)|0);
HEAP32[((__ZL11mnemonic_cb+1772)>>2)]=((STRING_TABLE.__str3986578)|0);
HEAP32[((__ZL11mnemonic_cb+1780)>>2)]=((STRING_TABLE.__str3996579)|0);
HEAP32[((__ZL11mnemonic_cb+1788)>>2)]=((STRING_TABLE.__str4006580)|0);
HEAP32[((__ZL11mnemonic_cb+1796)>>2)]=((STRING_TABLE.__str4016581)|0);
HEAP32[((__ZL11mnemonic_cb+1804)>>2)]=((STRING_TABLE.__str4026582)|0);
HEAP32[((__ZL11mnemonic_cb+1812)>>2)]=((STRING_TABLE.__str4036583)|0);
HEAP32[((__ZL11mnemonic_cb+1820)>>2)]=((STRING_TABLE.__str4046584)|0);
HEAP32[((__ZL11mnemonic_cb+1828)>>2)]=((STRING_TABLE.__str4056585)|0);
HEAP32[((__ZL11mnemonic_cb+1836)>>2)]=((STRING_TABLE.__str4066586)|0);
HEAP32[((__ZL11mnemonic_cb+1844)>>2)]=((STRING_TABLE.__str4076587)|0);
HEAP32[((__ZL11mnemonic_cb+1852)>>2)]=((STRING_TABLE.__str4086588)|0);
HEAP32[((__ZL11mnemonic_cb+1860)>>2)]=((STRING_TABLE.__str4096589)|0);
HEAP32[((__ZL11mnemonic_cb+1868)>>2)]=((STRING_TABLE.__str4106590)|0);
HEAP32[((__ZL11mnemonic_cb+1876)>>2)]=((STRING_TABLE.__str4116591)|0);
HEAP32[((__ZL11mnemonic_cb+1884)>>2)]=((STRING_TABLE.__str4126592)|0);
HEAP32[((__ZL11mnemonic_cb+1892)>>2)]=((STRING_TABLE.__str4136593)|0);
HEAP32[((__ZL11mnemonic_cb+1900)>>2)]=((STRING_TABLE.__str4146594)|0);
HEAP32[((__ZL11mnemonic_cb+1908)>>2)]=((STRING_TABLE.__str4156595)|0);
HEAP32[((__ZL11mnemonic_cb+1916)>>2)]=((STRING_TABLE.__str4166596)|0);
HEAP32[((__ZL11mnemonic_cb+1924)>>2)]=((STRING_TABLE.__str4176597)|0);
HEAP32[((__ZL11mnemonic_cb+1932)>>2)]=((STRING_TABLE.__str4186598)|0);
HEAP32[((__ZL11mnemonic_cb+1940)>>2)]=((STRING_TABLE.__str4196599)|0);
HEAP32[((__ZL11mnemonic_cb+1948)>>2)]=((STRING_TABLE.__str4206600)|0);
HEAP32[((__ZL11mnemonic_cb+1956)>>2)]=((STRING_TABLE.__str4216601)|0);
HEAP32[((__ZL11mnemonic_cb+1964)>>2)]=((STRING_TABLE.__str4226602)|0);
HEAP32[((__ZL11mnemonic_cb+1972)>>2)]=((STRING_TABLE.__str4236603)|0);
HEAP32[((__ZL11mnemonic_cb+1980)>>2)]=((STRING_TABLE.__str4246604)|0);
HEAP32[((__ZL11mnemonic_cb+1988)>>2)]=((STRING_TABLE.__str4256605)|0);
HEAP32[((__ZL11mnemonic_cb+1996)>>2)]=((STRING_TABLE.__str4266606)|0);
HEAP32[((__ZL11mnemonic_cb+2004)>>2)]=((STRING_TABLE.__str4276607)|0);
HEAP32[((__ZL11mnemonic_cb+2012)>>2)]=((STRING_TABLE.__str4286608)|0);
HEAP32[((__ZL11mnemonic_cb+2020)>>2)]=((STRING_TABLE.__str4296609)|0);
HEAP32[((__ZL11mnemonic_cb+2028)>>2)]=((STRING_TABLE.__str4306610)|0);
HEAP32[((__ZL11mnemonic_cb+2036)>>2)]=((STRING_TABLE.__str4316611)|0);
HEAP32[((__ZL11mnemonic_cb+2044)>>2)]=((STRING_TABLE.__str4326612)|0);
HEAP32[((__ZL11mnemonic_ed+4)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+12)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+20)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+28)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+36)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+44)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+52)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+60)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+68)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+76)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+84)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+92)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+100)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+108)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+116)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+124)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+132)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+140)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+148)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+156)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+164)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+172)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+180)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+188)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+196)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+204)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+212)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+220)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+228)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+236)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+244)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+252)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+260)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+268)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+276)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+284)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+292)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+300)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+308)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+316)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+324)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+332)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+340)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+348)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+356)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+364)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+372)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+380)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+388)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+396)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+404)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+412)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+420)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+428)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+436)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+444)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+452)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+460)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+468)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+476)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+484)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+492)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+500)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+508)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+516)>>2)]=((STRING_TABLE.__str3396519)|0);
HEAP32[((__ZL11mnemonic_ed+524)>>2)]=((STRING_TABLE.__str3406520)|0);
HEAP32[((__ZL11mnemonic_ed+532)>>2)]=((STRING_TABLE.__str846264)|0);
HEAP32[((__ZL11mnemonic_ed+540)>>2)]=((STRING_TABLE.__str3416521)|0);
HEAP32[((__ZL11mnemonic_ed+564)>>2)]=((STRING_TABLE.__str3426522)|0);
HEAP32[((__ZL11mnemonic_ed+572)>>2)]=((STRING_TABLE.__str3436523)|0);
HEAP32[((__ZL11mnemonic_ed+580)>>2)]=((STRING_TABLE.__str3446524)|0);
HEAP32[((__ZL11mnemonic_ed+588)>>2)]=((STRING_TABLE.__str3456525)|0);
HEAP32[((__ZL11mnemonic_ed+596)>>2)]=((STRING_TABLE.__str846264)|0);
HEAP32[((__ZL11mnemonic_ed+604)>>2)]=((STRING_TABLE.__str3466526)|0);
HEAP32[((__ZL11mnemonic_ed+612)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+628)>>2)]=((STRING_TABLE.__str3426522)|0);
HEAP32[((__ZL11mnemonic_ed+636)>>2)]=((STRING_TABLE.__str3486528)|0);
HEAP32[((__ZL11mnemonic_ed+644)>>2)]=((STRING_TABLE.__str3496529)|0);
HEAP32[((__ZL11mnemonic_ed+652)>>2)]=((STRING_TABLE.__str3506530)|0);
HEAP32[((__ZL11mnemonic_ed+660)>>2)]=((STRING_TABLE.__str946274)|0);
HEAP32[((__ZL11mnemonic_ed+668)>>2)]=((STRING_TABLE.__str3516531)|0);
HEAP32[((__ZL11mnemonic_ed+676)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+692)>>2)]=((STRING_TABLE.__str3526532)|0);
HEAP32[((__ZL11mnemonic_ed+700)>>2)]=((STRING_TABLE.__str3536533)|0);
HEAP32[((__ZL11mnemonic_ed+708)>>2)]=((STRING_TABLE.__str3546534)|0);
HEAP32[((__ZL11mnemonic_ed+716)>>2)]=((STRING_TABLE.__str3556535)|0);
HEAP32[((__ZL11mnemonic_ed+724)>>2)]=((STRING_TABLE.__str946274)|0);
HEAP32[((__ZL11mnemonic_ed+732)>>2)]=((STRING_TABLE.__str3566536)|0);
HEAP32[((__ZL11mnemonic_ed+740)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+756)>>2)]=((STRING_TABLE.__str3576537)|0);
HEAP32[((__ZL11mnemonic_ed+764)>>2)]=((STRING_TABLE.__str3586538)|0);
HEAP32[((__ZL11mnemonic_ed+772)>>2)]=((STRING_TABLE.__str3596539)|0);
HEAP32[((__ZL11mnemonic_ed+780)>>2)]=((STRING_TABLE.__str3606540)|0);
HEAP32[((__ZL11mnemonic_ed+788)>>2)]=((STRING_TABLE.__str1056285)|0);
HEAP32[((__ZL11mnemonic_ed+796)>>2)]=((STRING_TABLE.__str1006280)|0);
HEAP32[((__ZL11mnemonic_ed+804)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+820)>>2)]=((STRING_TABLE.__str3426522)|0);
HEAP32[((__ZL11mnemonic_ed+828)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_ed+836)>>2)]=((STRING_TABLE.__str3616541)|0);
HEAP32[((__ZL11mnemonic_ed+844)>>2)]=((STRING_TABLE.__str3626542)|0);
HEAP32[((__ZL11mnemonic_ed+852)>>2)]=((STRING_TABLE.__str1056285)|0);
HEAP32[((__ZL11mnemonic_ed+860)>>2)]=((STRING_TABLE.__str1066286)|0);
HEAP32[((__ZL11mnemonic_ed+868)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+884)>>2)]=((STRING_TABLE.__str3426522)|0);
HEAP32[((__ZL11mnemonic_ed+892)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL11mnemonic_ed+900)>>2)]=((STRING_TABLE.__str3636543)|0);
HEAP32[((__ZL11mnemonic_ed+908)>>2)]=((STRING_TABLE.__str3646544)|0);
HEAP32[((__ZL11mnemonic_ed+916)>>2)]=((STRING_TABLE.__str1166296)|0);
HEAP32[((__ZL11mnemonic_ed+924)>>2)]=((STRING_TABLE.__str3656545)|0);
HEAP32[((__ZL11mnemonic_ed+932)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+948)>>2)]=((STRING_TABLE.__str3526532)|0);
HEAP32[((__ZL11mnemonic_ed+956)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+964)>>2)]=((STRING_TABLE.__str3666546)|0);
HEAP32[((__ZL11mnemonic_ed+972)>>2)]=((STRING_TABLE.__str3676547)|0);
HEAP32[((__ZL11mnemonic_ed+980)>>2)]=((STRING_TABLE.__str1166296)|0);
HEAP32[((__ZL11mnemonic_ed+988)>>2)]=((STRING_TABLE.__str3686548)|0);
HEAP32[((__ZL11mnemonic_ed+996)>>2)]=((STRING_TABLE.__str3476527)|0);
HEAP32[((__ZL11mnemonic_ed+1012)>>2)]=((STRING_TABLE.__str3576537)|0);
HEAP32[((__ZL11mnemonic_ed+1020)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1028)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1036)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1044)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1052)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1060)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1068)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1076)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1084)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1092)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1100)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1108)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1116)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1124)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1132)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1140)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1148)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1156)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1164)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1172)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1180)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1188)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1196)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1204)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1212)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1220)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1228)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1236)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1244)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1252)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1260)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1268)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1276)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1316)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1324)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1332)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1340)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1380)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1388)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1396)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1404)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1444)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1452)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1460)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1468)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1508)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1516)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1524)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1532)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1540)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1548)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1556)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1564)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1572)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1580)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1588)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1596)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1604)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1612)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1620)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1628)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1636)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1644)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1652)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1660)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1668)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1676)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1684)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1692)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1700)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1708)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1716)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1724)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1732)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1740)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1748)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1756)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1764)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1772)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1780)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1788)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1796)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1804)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1812)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1820)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1828)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1836)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1844)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1852)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1860)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1868)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1876)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1884)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1892)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1900)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1908)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1916)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1924)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1932)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1940)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1948)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1956)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1964)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1972)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1980)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1988)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+1996)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+2004)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+2012)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+2020)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+2028)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+2036)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_ed+2044)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL14mnemonic_xx_cb+4)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+12)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+20)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+28)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+36)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+44)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+52)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+60)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+68)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+76)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+84)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+92)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+100)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+108)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+116)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+124)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+132)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+140)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+148)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+156)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+164)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+172)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+180)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+188)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+196)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+204)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+212)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+220)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+228)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+236)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+244)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+252)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+260)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+268)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+276)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+284)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+292)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+300)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+308)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+316)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+324)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+332)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+340)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+348)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+356)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+364)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+372)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+380)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+388)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+396)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+404)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+412)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+420)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+428)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+436)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+444)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+452)>>2)]=((STRING_TABLE.__str2676447)|0);
HEAP32[((__ZL14mnemonic_xx_cb+460)>>2)]=((STRING_TABLE.__str2686448)|0);
HEAP32[((__ZL14mnemonic_xx_cb+468)>>2)]=((STRING_TABLE.__str2696449)|0);
HEAP32[((__ZL14mnemonic_xx_cb+476)>>2)]=((STRING_TABLE.__str2706450)|0);
HEAP32[((__ZL14mnemonic_xx_cb+484)>>2)]=((STRING_TABLE.__str2716451)|0);
HEAP32[((__ZL14mnemonic_xx_cb+492)>>2)]=((STRING_TABLE.__str2726452)|0);
HEAP32[((__ZL14mnemonic_xx_cb+500)>>2)]=((STRING_TABLE.__str2736453)|0);
HEAP32[((__ZL14mnemonic_xx_cb+508)>>2)]=((STRING_TABLE.__str2746454)|0);
HEAP32[((__ZL14mnemonic_xx_cb+516)>>2)]=((STRING_TABLE.__str2756455)|0);
HEAP32[((__ZL14mnemonic_xx_cb+524)>>2)]=((STRING_TABLE.__str2766456)|0);
HEAP32[((__ZL14mnemonic_xx_cb+532)>>2)]=((STRING_TABLE.__str2776457)|0);
HEAP32[((__ZL14mnemonic_xx_cb+540)>>2)]=((STRING_TABLE.__str2786458)|0);
HEAP32[((__ZL14mnemonic_xx_cb+548)>>2)]=((STRING_TABLE.__str2796459)|0);
HEAP32[((__ZL14mnemonic_xx_cb+556)>>2)]=((STRING_TABLE.__str2806460)|0);
HEAP32[((__ZL14mnemonic_xx_cb+564)>>2)]=((STRING_TABLE.__str2816461)|0);
HEAP32[((__ZL14mnemonic_xx_cb+572)>>2)]=((STRING_TABLE.__str2826462)|0);
HEAP32[((__ZL14mnemonic_xx_cb+580)>>2)]=((STRING_TABLE.__str2836463)|0);
HEAP32[((__ZL14mnemonic_xx_cb+588)>>2)]=((STRING_TABLE.__str2846464)|0);
HEAP32[((__ZL14mnemonic_xx_cb+596)>>2)]=((STRING_TABLE.__str2856465)|0);
HEAP32[((__ZL14mnemonic_xx_cb+604)>>2)]=((STRING_TABLE.__str2866466)|0);
HEAP32[((__ZL14mnemonic_xx_cb+612)>>2)]=((STRING_TABLE.__str2876467)|0);
HEAP32[((__ZL14mnemonic_xx_cb+620)>>2)]=((STRING_TABLE.__str2886468)|0);
HEAP32[((__ZL14mnemonic_xx_cb+628)>>2)]=((STRING_TABLE.__str2896469)|0);
HEAP32[((__ZL14mnemonic_xx_cb+636)>>2)]=((STRING_TABLE.__str2906470)|0);
HEAP32[((__ZL14mnemonic_xx_cb+644)>>2)]=((STRING_TABLE.__str2916471)|0);
HEAP32[((__ZL14mnemonic_xx_cb+652)>>2)]=((STRING_TABLE.__str2926472)|0);
HEAP32[((__ZL14mnemonic_xx_cb+660)>>2)]=((STRING_TABLE.__str2936473)|0);
HEAP32[((__ZL14mnemonic_xx_cb+668)>>2)]=((STRING_TABLE.__str2946474)|0);
HEAP32[((__ZL14mnemonic_xx_cb+676)>>2)]=((STRING_TABLE.__str2956475)|0);
HEAP32[((__ZL14mnemonic_xx_cb+684)>>2)]=((STRING_TABLE.__str2966476)|0);
HEAP32[((__ZL14mnemonic_xx_cb+692)>>2)]=((STRING_TABLE.__str2976477)|0);
HEAP32[((__ZL14mnemonic_xx_cb+700)>>2)]=((STRING_TABLE.__str2986478)|0);
HEAP32[((__ZL14mnemonic_xx_cb+708)>>2)]=((STRING_TABLE.__str2996479)|0);
HEAP32[((__ZL14mnemonic_xx_cb+716)>>2)]=((STRING_TABLE.__str3006480)|0);
HEAP32[((__ZL14mnemonic_xx_cb+724)>>2)]=((STRING_TABLE.__str3016481)|0);
HEAP32[((__ZL14mnemonic_xx_cb+732)>>2)]=((STRING_TABLE.__str3026482)|0);
HEAP32[((__ZL14mnemonic_xx_cb+740)>>2)]=((STRING_TABLE.__str3036483)|0);
HEAP32[((__ZL14mnemonic_xx_cb+748)>>2)]=((STRING_TABLE.__str3046484)|0);
HEAP32[((__ZL14mnemonic_xx_cb+756)>>2)]=((STRING_TABLE.__str3056485)|0);
HEAP32[((__ZL14mnemonic_xx_cb+764)>>2)]=((STRING_TABLE.__str3066486)|0);
HEAP32[((__ZL14mnemonic_xx_cb+772)>>2)]=((STRING_TABLE.__str3076487)|0);
HEAP32[((__ZL14mnemonic_xx_cb+780)>>2)]=((STRING_TABLE.__str3086488)|0);
HEAP32[((__ZL14mnemonic_xx_cb+788)>>2)]=((STRING_TABLE.__str3096489)|0);
HEAP32[((__ZL14mnemonic_xx_cb+796)>>2)]=((STRING_TABLE.__str3106490)|0);
HEAP32[((__ZL14mnemonic_xx_cb+804)>>2)]=((STRING_TABLE.__str3116491)|0);
HEAP32[((__ZL14mnemonic_xx_cb+812)>>2)]=((STRING_TABLE.__str3126492)|0);
HEAP32[((__ZL14mnemonic_xx_cb+820)>>2)]=((STRING_TABLE.__str3136493)|0);
HEAP32[((__ZL14mnemonic_xx_cb+828)>>2)]=((STRING_TABLE.__str3146494)|0);
HEAP32[((__ZL14mnemonic_xx_cb+836)>>2)]=((STRING_TABLE.__str3156495)|0);
HEAP32[((__ZL14mnemonic_xx_cb+844)>>2)]=((STRING_TABLE.__str3166496)|0);
HEAP32[((__ZL14mnemonic_xx_cb+852)>>2)]=((STRING_TABLE.__str3176497)|0);
HEAP32[((__ZL14mnemonic_xx_cb+860)>>2)]=((STRING_TABLE.__str3186498)|0);
HEAP32[((__ZL14mnemonic_xx_cb+868)>>2)]=((STRING_TABLE.__str3196499)|0);
HEAP32[((__ZL14mnemonic_xx_cb+876)>>2)]=((STRING_TABLE.__str3206500)|0);
HEAP32[((__ZL14mnemonic_xx_cb+884)>>2)]=((STRING_TABLE.__str3216501)|0);
HEAP32[((__ZL14mnemonic_xx_cb+892)>>2)]=((STRING_TABLE.__str3226502)|0);
HEAP32[((__ZL14mnemonic_xx_cb+900)>>2)]=((STRING_TABLE.__str3236503)|0);
HEAP32[((__ZL14mnemonic_xx_cb+908)>>2)]=((STRING_TABLE.__str3246504)|0);
HEAP32[((__ZL14mnemonic_xx_cb+916)>>2)]=((STRING_TABLE.__str3256505)|0);
HEAP32[((__ZL14mnemonic_xx_cb+924)>>2)]=((STRING_TABLE.__str3266506)|0);
HEAP32[((__ZL14mnemonic_xx_cb+932)>>2)]=((STRING_TABLE.__str3276507)|0);
HEAP32[((__ZL14mnemonic_xx_cb+940)>>2)]=((STRING_TABLE.__str3286508)|0);
HEAP32[((__ZL14mnemonic_xx_cb+948)>>2)]=((STRING_TABLE.__str3296509)|0);
HEAP32[((__ZL14mnemonic_xx_cb+956)>>2)]=((STRING_TABLE.__str3306510)|0);
HEAP32[((__ZL14mnemonic_xx_cb+964)>>2)]=((STRING_TABLE.__str3316511)|0);
HEAP32[((__ZL14mnemonic_xx_cb+972)>>2)]=((STRING_TABLE.__str3326512)|0);
HEAP32[((__ZL14mnemonic_xx_cb+980)>>2)]=((STRING_TABLE.__str3336513)|0);
HEAP32[((__ZL14mnemonic_xx_cb+988)>>2)]=((STRING_TABLE.__str3346514)|0);
HEAP32[((__ZL14mnemonic_xx_cb+996)>>2)]=((STRING_TABLE.__str3356515)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1004)>>2)]=((STRING_TABLE.__str3366516)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1012)>>2)]=((STRING_TABLE.__str3376517)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1020)>>2)]=((STRING_TABLE.__str3386518)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1028)>>2)]=((STRING_TABLE.__str2756455)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1036)>>2)]=((STRING_TABLE.__str2766456)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1044)>>2)]=((STRING_TABLE.__str2776457)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1052)>>2)]=((STRING_TABLE.__str2786458)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1060)>>2)]=((STRING_TABLE.__str2796459)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1068)>>2)]=((STRING_TABLE.__str2806460)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1076)>>2)]=((STRING_TABLE.__str2816461)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1084)>>2)]=((STRING_TABLE.__str2826462)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1092)>>2)]=((STRING_TABLE.__str2836463)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1100)>>2)]=((STRING_TABLE.__str2846464)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1108)>>2)]=((STRING_TABLE.__str2856465)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1116)>>2)]=((STRING_TABLE.__str2866466)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1124)>>2)]=((STRING_TABLE.__str2876467)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1132)>>2)]=((STRING_TABLE.__str2886468)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1140)>>2)]=((STRING_TABLE.__str2896469)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1148)>>2)]=((STRING_TABLE.__str2906470)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1156)>>2)]=((STRING_TABLE.__str2916471)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1164)>>2)]=((STRING_TABLE.__str2926472)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1172)>>2)]=((STRING_TABLE.__str2936473)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1180)>>2)]=((STRING_TABLE.__str2946474)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1188)>>2)]=((STRING_TABLE.__str2956475)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1196)>>2)]=((STRING_TABLE.__str2966476)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1204)>>2)]=((STRING_TABLE.__str2976477)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1212)>>2)]=((STRING_TABLE.__str2986478)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1220)>>2)]=((STRING_TABLE.__str2996479)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1228)>>2)]=((STRING_TABLE.__str3006480)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1236)>>2)]=((STRING_TABLE.__str3016481)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1244)>>2)]=((STRING_TABLE.__str3026482)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1252)>>2)]=((STRING_TABLE.__str3036483)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1260)>>2)]=((STRING_TABLE.__str3046484)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1268)>>2)]=((STRING_TABLE.__str3056485)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1276)>>2)]=((STRING_TABLE.__str3066486)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1284)>>2)]=((STRING_TABLE.__str3076487)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1292)>>2)]=((STRING_TABLE.__str3086488)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1300)>>2)]=((STRING_TABLE.__str3096489)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1308)>>2)]=((STRING_TABLE.__str3106490)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1316)>>2)]=((STRING_TABLE.__str3116491)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1324)>>2)]=((STRING_TABLE.__str3126492)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1332)>>2)]=((STRING_TABLE.__str3136493)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1340)>>2)]=((STRING_TABLE.__str3146494)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1348)>>2)]=((STRING_TABLE.__str3156495)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1356)>>2)]=((STRING_TABLE.__str3166496)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1364)>>2)]=((STRING_TABLE.__str3176497)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1372)>>2)]=((STRING_TABLE.__str3186498)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1380)>>2)]=((STRING_TABLE.__str3196499)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1388)>>2)]=((STRING_TABLE.__str3206500)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1396)>>2)]=((STRING_TABLE.__str3216501)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1404)>>2)]=((STRING_TABLE.__str3226502)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1412)>>2)]=((STRING_TABLE.__str3236503)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1420)>>2)]=((STRING_TABLE.__str3246504)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1428)>>2)]=((STRING_TABLE.__str3256505)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1436)>>2)]=((STRING_TABLE.__str3266506)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1444)>>2)]=((STRING_TABLE.__str3276507)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1452)>>2)]=((STRING_TABLE.__str3286508)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1460)>>2)]=((STRING_TABLE.__str3296509)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1468)>>2)]=((STRING_TABLE.__str3306510)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1476)>>2)]=((STRING_TABLE.__str3316511)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1484)>>2)]=((STRING_TABLE.__str3326512)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1492)>>2)]=((STRING_TABLE.__str3336513)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1500)>>2)]=((STRING_TABLE.__str3346514)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1508)>>2)]=((STRING_TABLE.__str3356515)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1516)>>2)]=((STRING_TABLE.__str3366516)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1524)>>2)]=((STRING_TABLE.__str3376517)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1532)>>2)]=((STRING_TABLE.__str3386518)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1540)>>2)]=((STRING_TABLE.__str2756455)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1548)>>2)]=((STRING_TABLE.__str2766456)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1556)>>2)]=((STRING_TABLE.__str2776457)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1564)>>2)]=((STRING_TABLE.__str2786458)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1572)>>2)]=((STRING_TABLE.__str2796459)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1580)>>2)]=((STRING_TABLE.__str2806460)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1588)>>2)]=((STRING_TABLE.__str2816461)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1596)>>2)]=((STRING_TABLE.__str2826462)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1604)>>2)]=((STRING_TABLE.__str2836463)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1612)>>2)]=((STRING_TABLE.__str2846464)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1620)>>2)]=((STRING_TABLE.__str2856465)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1628)>>2)]=((STRING_TABLE.__str2866466)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1636)>>2)]=((STRING_TABLE.__str2876467)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1644)>>2)]=((STRING_TABLE.__str2886468)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1652)>>2)]=((STRING_TABLE.__str2896469)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1660)>>2)]=((STRING_TABLE.__str2906470)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1668)>>2)]=((STRING_TABLE.__str2916471)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1676)>>2)]=((STRING_TABLE.__str2926472)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1684)>>2)]=((STRING_TABLE.__str2936473)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1692)>>2)]=((STRING_TABLE.__str2946474)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1700)>>2)]=((STRING_TABLE.__str2956475)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1708)>>2)]=((STRING_TABLE.__str2966476)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1716)>>2)]=((STRING_TABLE.__str2976477)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1724)>>2)]=((STRING_TABLE.__str2986478)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1732)>>2)]=((STRING_TABLE.__str2996479)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1740)>>2)]=((STRING_TABLE.__str3006480)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1748)>>2)]=((STRING_TABLE.__str3016481)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1756)>>2)]=((STRING_TABLE.__str3026482)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1764)>>2)]=((STRING_TABLE.__str3036483)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1772)>>2)]=((STRING_TABLE.__str3046484)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1780)>>2)]=((STRING_TABLE.__str3056485)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1788)>>2)]=((STRING_TABLE.__str3066486)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1796)>>2)]=((STRING_TABLE.__str3076487)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1804)>>2)]=((STRING_TABLE.__str3086488)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1812)>>2)]=((STRING_TABLE.__str3096489)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1820)>>2)]=((STRING_TABLE.__str3106490)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1828)>>2)]=((STRING_TABLE.__str3116491)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1836)>>2)]=((STRING_TABLE.__str3126492)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1844)>>2)]=((STRING_TABLE.__str3136493)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1852)>>2)]=((STRING_TABLE.__str3146494)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1860)>>2)]=((STRING_TABLE.__str3156495)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1868)>>2)]=((STRING_TABLE.__str3166496)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1876)>>2)]=((STRING_TABLE.__str3176497)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1884)>>2)]=((STRING_TABLE.__str3186498)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1892)>>2)]=((STRING_TABLE.__str3196499)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1900)>>2)]=((STRING_TABLE.__str3206500)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1908)>>2)]=((STRING_TABLE.__str3216501)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1916)>>2)]=((STRING_TABLE.__str3226502)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1924)>>2)]=((STRING_TABLE.__str3236503)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1932)>>2)]=((STRING_TABLE.__str3246504)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1940)>>2)]=((STRING_TABLE.__str3256505)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1948)>>2)]=((STRING_TABLE.__str3266506)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1956)>>2)]=((STRING_TABLE.__str3276507)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1964)>>2)]=((STRING_TABLE.__str3286508)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1972)>>2)]=((STRING_TABLE.__str3296509)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1980)>>2)]=((STRING_TABLE.__str3306510)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1988)>>2)]=((STRING_TABLE.__str3316511)|0);
HEAP32[((__ZL14mnemonic_xx_cb+1996)>>2)]=((STRING_TABLE.__str3326512)|0);
HEAP32[((__ZL14mnemonic_xx_cb+2004)>>2)]=((STRING_TABLE.__str3336513)|0);
HEAP32[((__ZL14mnemonic_xx_cb+2012)>>2)]=((STRING_TABLE.__str3346514)|0);
HEAP32[((__ZL14mnemonic_xx_cb+2020)>>2)]=((STRING_TABLE.__str3356515)|0);
HEAP32[((__ZL14mnemonic_xx_cb+2028)>>2)]=((STRING_TABLE.__str3366516)|0);
HEAP32[((__ZL14mnemonic_xx_cb+2036)>>2)]=((STRING_TABLE.__str3376517)|0);
HEAP32[((__ZL14mnemonic_xx_cb+2044)>>2)]=((STRING_TABLE.__str3386518)|0);
HEAP32[((__ZL11mnemonic_xx+4)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+12)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+20)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+28)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+36)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+44)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+52)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+60)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+68)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+76)>>2)]=((STRING_TABLE.__str2126392)|0);
HEAP32[((__ZL11mnemonic_xx+84)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+92)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+100)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+108)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+116)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+124)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+132)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+140)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+148)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+156)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+164)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+172)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+180)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+188)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+196)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+204)>>2)]=((STRING_TABLE.__str2136393)|0);
HEAP32[((__ZL11mnemonic_xx+212)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+220)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+228)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+236)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+244)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+252)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+260)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+268)>>2)]=((STRING_TABLE.__str2146394)|0);
HEAP32[((__ZL11mnemonic_xx+276)>>2)]=((STRING_TABLE.__str2156395)|0);
HEAP32[((__ZL11mnemonic_xx+284)>>2)]=((STRING_TABLE.__str2166396)|0);
HEAP32[((__ZL11mnemonic_xx+292)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+300)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+308)>>2)]=((STRING_TABLE.__str2186398)|0);
HEAP32[((__ZL11mnemonic_xx+316)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+324)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+332)>>2)]=((STRING_TABLE.__str2196399)|0);
HEAP32[((__ZL11mnemonic_xx+340)>>2)]=((STRING_TABLE.__str2206400)|0);
HEAP32[((__ZL11mnemonic_xx+348)>>2)]=((STRING_TABLE.__str2166396)|0);
HEAP32[((__ZL11mnemonic_xx+356)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+364)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+372)>>2)]=((STRING_TABLE.__str2226402)|0);
HEAP32[((__ZL11mnemonic_xx+380)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+388)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+396)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+404)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+412)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+420)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+428)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+436)>>2)]=((STRING_TABLE.__str2246404)|0);
HEAP32[((__ZL11mnemonic_xx+444)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+452)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+460)>>2)]=((STRING_TABLE.__str2256405)|0);
HEAP32[((__ZL11mnemonic_xx+468)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+476)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+484)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+492)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+500)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+508)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+516)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+524)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+532)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+540)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+548)>>2)]=((STRING_TABLE.__str2266406)|0);
HEAP32[((__ZL11mnemonic_xx+556)>>2)]=((STRING_TABLE.__str2276407)|0);
HEAP32[((__ZL11mnemonic_xx+564)>>2)]=((STRING_TABLE.__str2286408)|0);
HEAP32[((__ZL11mnemonic_xx+572)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+580)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+588)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+596)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+604)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+612)>>2)]=((STRING_TABLE.__str2296409)|0);
HEAP32[((__ZL11mnemonic_xx+620)>>2)]=((STRING_TABLE.__str2306410)|0);
HEAP32[((__ZL11mnemonic_xx+628)>>2)]=((STRING_TABLE.__str2316411)|0);
HEAP32[((__ZL11mnemonic_xx+636)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+644)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+652)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+660)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+668)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+676)>>2)]=((STRING_TABLE.__str2326412)|0);
HEAP32[((__ZL11mnemonic_xx+684)>>2)]=((STRING_TABLE.__str2336413)|0);
HEAP32[((__ZL11mnemonic_xx+692)>>2)]=((STRING_TABLE.__str2346414)|0);
HEAP32[((__ZL11mnemonic_xx+700)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+708)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+716)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+724)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+732)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+740)>>2)]=((STRING_TABLE.__str2356415)|0);
HEAP32[((__ZL11mnemonic_xx+748)>>2)]=((STRING_TABLE.__str2366416)|0);
HEAP32[((__ZL11mnemonic_xx+756)>>2)]=((STRING_TABLE.__str2376417)|0);
HEAP32[((__ZL11mnemonic_xx+764)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+772)>>2)]=((STRING_TABLE.__str2386418)|0);
HEAP32[((__ZL11mnemonic_xx+780)>>2)]=((STRING_TABLE.__str2396419)|0);
HEAP32[((__ZL11mnemonic_xx+788)>>2)]=((STRING_TABLE.__str2406420)|0);
HEAP32[((__ZL11mnemonic_xx+796)>>2)]=((STRING_TABLE.__str2416421)|0);
HEAP32[((__ZL11mnemonic_xx+804)>>2)]=((STRING_TABLE.__str2426422)|0);
HEAP32[((__ZL11mnemonic_xx+812)>>2)]=((STRING_TABLE.__str2436423)|0);
HEAP32[((__ZL11mnemonic_xx+820)>>2)]=((STRING_TABLE.__str2446424)|0);
HEAP32[((__ZL11mnemonic_xx+828)>>2)]=((STRING_TABLE.__str2456425)|0);
HEAP32[((__ZL11mnemonic_xx+836)>>2)]=((STRING_TABLE.__str2466426)|0);
HEAP32[((__ZL11mnemonic_xx+844)>>2)]=((STRING_TABLE.__str2476427)|0);
HEAP32[((__ZL11mnemonic_xx+852)>>2)]=((STRING_TABLE.__str2486428)|0);
HEAP32[((__ZL11mnemonic_xx+860)>>2)]=((STRING_TABLE.__str2496429)|0);
HEAP32[((__ZL11mnemonic_xx+868)>>2)]=((STRING_TABLE.__str2506430)|0);
HEAP32[((__ZL11mnemonic_xx+876)>>2)]=((STRING_TABLE.__str2516431)|0);
HEAP32[((__ZL11mnemonic_xx+884)>>2)]=((STRING_TABLE.__str2526432)|0);
HEAP32[((__ZL11mnemonic_xx+892)>>2)]=((STRING_TABLE.__str2536433)|0);
HEAP32[((__ZL11mnemonic_xx+900)>>2)]=((STRING_TABLE.__str2546434)|0);
HEAP32[((__ZL11mnemonic_xx+908)>>2)]=((STRING_TABLE.__str2556435)|0);
HEAP32[((__ZL11mnemonic_xx+916)>>2)]=((STRING_TABLE.__str2566436)|0);
HEAP32[((__ZL11mnemonic_xx+924)>>2)]=((STRING_TABLE.__str2576437)|0);
HEAP32[((__ZL11mnemonic_xx+932)>>2)]=((STRING_TABLE.__str2586438)|0);
HEAP32[((__ZL11mnemonic_xx+940)>>2)]=((STRING_TABLE.__str2596439)|0);
HEAP32[((__ZL11mnemonic_xx+948)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+956)>>2)]=((STRING_TABLE.__str2606440)|0);
HEAP32[((__ZL11mnemonic_xx+964)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+972)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+980)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+988)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+996)>>2)]=((STRING_TABLE.__str2616441)|0);
HEAP32[((__ZL11mnemonic_xx+1004)>>2)]=((STRING_TABLE.__str2626442)|0);
HEAP32[((__ZL11mnemonic_xx+1012)>>2)]=((STRING_TABLE.__str2636443)|0);
HEAP32[((__ZL11mnemonic_xx+1020)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1028)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1036)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1044)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1052)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1060)>>2)]=((STRING_TABLE.__str2616441)|0);
HEAP32[((__ZL11mnemonic_xx+1068)>>2)]=((STRING_TABLE.__str2626442)|0);
HEAP32[((__ZL11mnemonic_xx+1076)>>2)]=((STRING_TABLE.__str2636443)|0);
HEAP32[((__ZL11mnemonic_xx+1084)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1092)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1100)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1108)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1116)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1124)>>2)]=((STRING_TABLE.__str2616441)|0);
HEAP32[((__ZL11mnemonic_xx+1132)>>2)]=((STRING_TABLE.__str2626442)|0);
HEAP32[((__ZL11mnemonic_xx+1140)>>2)]=((STRING_TABLE.__str2636443)|0);
HEAP32[((__ZL11mnemonic_xx+1148)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1156)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1164)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1172)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1180)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1188)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+1196)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+1204)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+1212)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1220)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1228)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1236)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1244)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1252)>>2)]=((STRING_TABLE.__str2616441)|0);
HEAP32[((__ZL11mnemonic_xx+1260)>>2)]=((STRING_TABLE.__str2626442)|0);
HEAP32[((__ZL11mnemonic_xx+1268)>>2)]=((STRING_TABLE.__str2636443)|0);
HEAP32[((__ZL11mnemonic_xx+1276)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1284)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1292)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1300)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1308)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1316)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+1324)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+1332)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+1340)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1348)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1356)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1364)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1372)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1380)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+1388)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+1396)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+1404)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1412)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1420)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1428)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1436)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1444)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+1452)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+1460)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+1468)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1476)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1484)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1492)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1500)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1508)>>2)]=((STRING_TABLE.__str2176397)|0);
HEAP32[((__ZL11mnemonic_xx+1516)>>2)]=((STRING_TABLE.__str2216401)|0);
HEAP32[((__ZL11mnemonic_xx+1524)>>2)]=((STRING_TABLE.__str2236403)|0);
HEAP32[((__ZL11mnemonic_xx+1532)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1540)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1548)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1556)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1564)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1572)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1580)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1588)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1596)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1604)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1612)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1620)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1628)>>2)]=((STRING_TABLE.__str1896369)|0);
HEAP32[((__ZL11mnemonic_xx+1636)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1644)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1652)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1660)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1668)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1676)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1684)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1692)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1700)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1708)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1716)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1724)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1732)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1740)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1748)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1756)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1764)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1772)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1780)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1788)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1796)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1804)>>2)]=((STRING_TABLE.__str2166396)|0);
HEAP32[((__ZL11mnemonic_xx+1812)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1820)>>2)]=((STRING_TABLE.__str2646444)|0);
HEAP32[((__ZL11mnemonic_xx+1828)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1836)>>2)]=((STRING_TABLE.__str2166396)|0);
HEAP32[((__ZL11mnemonic_xx+1844)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1852)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1860)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1868)>>2)]=((STRING_TABLE.__str2656445)|0);
HEAP32[((__ZL11mnemonic_xx+1876)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1884)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1892)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1900)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1908)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1916)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1924)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1932)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1940)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1948)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1956)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1964)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1972)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1980)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1988)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+1996)>>2)]=((STRING_TABLE.__str2666446)|0);
HEAP32[((__ZL11mnemonic_xx+2004)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+2012)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+2020)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+2028)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+2036)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL11mnemonic_xx+2044)>>2)]=((STRING_TABLE.__str2116391)|0);
HEAP32[((__ZL13mnemonic_main+12)>>2)]=((STRING_TABLE.__str786258)|0);
HEAP32[((__ZL13mnemonic_main+20)>>2)]=((STRING_TABLE.__str796259)|0);
HEAP32[((__ZL13mnemonic_main+28)>>2)]=((STRING_TABLE.__str806260)|0);
HEAP32[((__ZL13mnemonic_main+36)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+44)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+52)>>2)]=((STRING_TABLE.__str826262)|0);
HEAP32[((__ZL13mnemonic_main+68)>>2)]=((STRING_TABLE.__str836263)|0);
HEAP32[((__ZL13mnemonic_main+76)>>2)]=((STRING_TABLE.__str846264)|0);
HEAP32[((__ZL13mnemonic_main+84)>>2)]=((STRING_TABLE.__str856265)|0);
HEAP32[((__ZL13mnemonic_main+92)>>2)]=((STRING_TABLE.__str806260)|0);
HEAP32[((__ZL13mnemonic_main+100)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+108)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+116)>>2)]=((STRING_TABLE.__str876267)|0);
HEAP32[((__ZL13mnemonic_main+132)>>2)]=((STRING_TABLE.__str886268)|0);
HEAP32[((__ZL13mnemonic_main+140)>>2)]=((STRING_TABLE.__str896269)|0);
HEAP32[((__ZL13mnemonic_main+148)>>2)]=((STRING_TABLE.__str906270)|0);
HEAP32[((__ZL13mnemonic_main+156)>>2)]=((STRING_TABLE.__str916271)|0);
HEAP32[((__ZL13mnemonic_main+164)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+172)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+180)>>2)]=((STRING_TABLE.__str936273)|0);
HEAP32[((__ZL13mnemonic_main+196)>>2)]=((STRING_TABLE.__str886268)|0);
HEAP32[((__ZL13mnemonic_main+204)>>2)]=((STRING_TABLE.__str946274)|0);
HEAP32[((__ZL13mnemonic_main+212)>>2)]=((STRING_TABLE.__str956275)|0);
HEAP32[((__ZL13mnemonic_main+220)>>2)]=((STRING_TABLE.__str916271)|0);
HEAP32[((__ZL13mnemonic_main+228)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+236)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+244)>>2)]=((STRING_TABLE.__str976277)|0);
HEAP32[((__ZL13mnemonic_main+260)>>2)]=((STRING_TABLE.__str986278)|0);
HEAP32[((__ZL13mnemonic_main+268)>>2)]=((STRING_TABLE.__str996279)|0);
HEAP32[((__ZL13mnemonic_main+276)>>2)]=((STRING_TABLE.__str1006280)|0);
HEAP32[((__ZL13mnemonic_main+284)>>2)]=((STRING_TABLE.__str1016281)|0);
HEAP32[((__ZL13mnemonic_main+292)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+300)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+308)>>2)]=((STRING_TABLE.__str1036283)|0);
HEAP32[((__ZL13mnemonic_main+324)>>2)]=((STRING_TABLE.__str1046284)|0);
HEAP32[((__ZL13mnemonic_main+332)>>2)]=((STRING_TABLE.__str1056285)|0);
HEAP32[((__ZL13mnemonic_main+340)>>2)]=((STRING_TABLE.__str1066286)|0);
HEAP32[((__ZL13mnemonic_main+348)>>2)]=((STRING_TABLE.__str1016281)|0);
HEAP32[((__ZL13mnemonic_main+356)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+364)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+372)>>2)]=((STRING_TABLE.__str1086288)|0);
HEAP32[((__ZL13mnemonic_main+388)>>2)]=((STRING_TABLE.__str1096289)|0);
HEAP32[((__ZL13mnemonic_main+396)>>2)]=((STRING_TABLE.__str1106290)|0);
HEAP32[((__ZL13mnemonic_main+404)>>2)]=((STRING_TABLE.__str1116291)|0);
HEAP32[((__ZL13mnemonic_main+412)>>2)]=((STRING_TABLE.__str1126292)|0);
HEAP32[((__ZL13mnemonic_main+420)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+428)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+436)>>2)]=((STRING_TABLE.__str1146294)|0);
HEAP32[((__ZL13mnemonic_main+452)>>2)]=((STRING_TABLE.__str1156295)|0);
HEAP32[((__ZL13mnemonic_main+460)>>2)]=((STRING_TABLE.__str1166296)|0);
HEAP32[((__ZL13mnemonic_main+468)>>2)]=((STRING_TABLE.__str1176297)|0);
HEAP32[((__ZL13mnemonic_main+476)>>2)]=((STRING_TABLE.__str1126292)|0);
HEAP32[((__ZL13mnemonic_main+484)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+492)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+500)>>2)]=((STRING_TABLE.__str1196299)|0);
HEAP32[((__ZL13mnemonic_main+516)>>2)]=((STRING_TABLE.__str1206300)|0);
HEAP32[((__ZL13mnemonic_main+524)>>2)]=((STRING_TABLE.__str1216301)|0);
HEAP32[((__ZL13mnemonic_main+532)>>2)]=((STRING_TABLE.__str1226302)|0);
HEAP32[((__ZL13mnemonic_main+540)>>2)]=((STRING_TABLE.__str1236303)|0);
HEAP32[((__ZL13mnemonic_main+548)>>2)]=((STRING_TABLE.__str1246304)|0);
HEAP32[((__ZL13mnemonic_main+556)>>2)]=((STRING_TABLE.__str1256305)|0);
HEAP32[((__ZL13mnemonic_main+564)>>2)]=((STRING_TABLE.__str1266306)|0);
HEAP32[((__ZL13mnemonic_main+572)>>2)]=((STRING_TABLE.__str1276307)|0);
HEAP32[((__ZL13mnemonic_main+580)>>2)]=((STRING_TABLE.__str1286308)|0);
HEAP32[((__ZL13mnemonic_main+588)>>2)]=((STRING_TABLE.__str1296309)|0);
HEAP32[((__ZL13mnemonic_main+596)>>2)]=((STRING_TABLE.__str1306310)|0);
HEAP32[((__ZL13mnemonic_main+604)>>2)]=((STRING_TABLE.__str1316311)|0);
HEAP32[((__ZL13mnemonic_main+612)>>2)]=((STRING_TABLE.__str1326312)|0);
HEAP32[((__ZL13mnemonic_main+620)>>2)]=((STRING_TABLE.__str1336313)|0);
HEAP32[((__ZL13mnemonic_main+628)>>2)]=((STRING_TABLE.__str1346314)|0);
HEAP32[((__ZL13mnemonic_main+636)>>2)]=((STRING_TABLE.__str1356315)|0);
HEAP32[((__ZL13mnemonic_main+644)>>2)]=((STRING_TABLE.__str1366316)|0);
HEAP32[((__ZL13mnemonic_main+652)>>2)]=((STRING_TABLE.__str1376317)|0);
HEAP32[((__ZL13mnemonic_main+660)>>2)]=((STRING_TABLE.__str1386318)|0);
HEAP32[((__ZL13mnemonic_main+668)>>2)]=((STRING_TABLE.__str1396319)|0);
HEAP32[((__ZL13mnemonic_main+676)>>2)]=((STRING_TABLE.__str1406320)|0);
HEAP32[((__ZL13mnemonic_main+684)>>2)]=((STRING_TABLE.__str1416321)|0);
HEAP32[((__ZL13mnemonic_main+692)>>2)]=((STRING_TABLE.__str1426322)|0);
HEAP32[((__ZL13mnemonic_main+700)>>2)]=((STRING_TABLE.__str1436323)|0);
HEAP32[((__ZL13mnemonic_main+708)>>2)]=((STRING_TABLE.__str1446324)|0);
HEAP32[((__ZL13mnemonic_main+716)>>2)]=((STRING_TABLE.__str1456325)|0);
HEAP32[((__ZL13mnemonic_main+724)>>2)]=((STRING_TABLE.__str1466326)|0);
HEAP32[((__ZL13mnemonic_main+732)>>2)]=((STRING_TABLE.__str1476327)|0);
HEAP32[((__ZL13mnemonic_main+740)>>2)]=((STRING_TABLE.__str1486328)|0);
HEAP32[((__ZL13mnemonic_main+748)>>2)]=((STRING_TABLE.__str1496329)|0);
HEAP32[((__ZL13mnemonic_main+756)>>2)]=((STRING_TABLE.__str1506330)|0);
HEAP32[((__ZL13mnemonic_main+764)>>2)]=((STRING_TABLE.__str1516331)|0);
HEAP32[((__ZL13mnemonic_main+772)>>2)]=((STRING_TABLE.__str1526332)|0);
HEAP32[((__ZL13mnemonic_main+780)>>2)]=((STRING_TABLE.__str1536333)|0);
HEAP32[((__ZL13mnemonic_main+788)>>2)]=((STRING_TABLE.__str1546334)|0);
HEAP32[((__ZL13mnemonic_main+796)>>2)]=((STRING_TABLE.__str1556335)|0);
HEAP32[((__ZL13mnemonic_main+804)>>2)]=((STRING_TABLE.__str1566336)|0);
HEAP32[((__ZL13mnemonic_main+812)>>2)]=((STRING_TABLE.__str1576337)|0);
HEAP32[((__ZL13mnemonic_main+820)>>2)]=((STRING_TABLE.__str1586338)|0);
HEAP32[((__ZL13mnemonic_main+828)>>2)]=((STRING_TABLE.__str1596339)|0);
HEAP32[((__ZL13mnemonic_main+836)>>2)]=((STRING_TABLE.__str1606340)|0);
HEAP32[((__ZL13mnemonic_main+844)>>2)]=((STRING_TABLE.__str1616341)|0);
HEAP32[((__ZL13mnemonic_main+852)>>2)]=((STRING_TABLE.__str1626342)|0);
HEAP32[((__ZL13mnemonic_main+860)>>2)]=((STRING_TABLE.__str1636343)|0);
HEAP32[((__ZL13mnemonic_main+868)>>2)]=((STRING_TABLE.__str1646344)|0);
HEAP32[((__ZL13mnemonic_main+876)>>2)]=((STRING_TABLE.__str1656345)|0);
HEAP32[((__ZL13mnemonic_main+884)>>2)]=((STRING_TABLE.__str1666346)|0);
HEAP32[((__ZL13mnemonic_main+892)>>2)]=((STRING_TABLE.__str1676347)|0);
HEAP32[((__ZL13mnemonic_main+900)>>2)]=((STRING_TABLE.__str1686348)|0);
HEAP32[((__ZL13mnemonic_main+908)>>2)]=((STRING_TABLE.__str1696349)|0);
HEAP32[((__ZL13mnemonic_main+916)>>2)]=((STRING_TABLE.__str1706350)|0);
HEAP32[((__ZL13mnemonic_main+924)>>2)]=((STRING_TABLE.__str1716351)|0);
HEAP32[((__ZL13mnemonic_main+932)>>2)]=((STRING_TABLE.__str1726352)|0);
HEAP32[((__ZL13mnemonic_main+940)>>2)]=((STRING_TABLE.__str1736353)|0);
HEAP32[((__ZL13mnemonic_main+956)>>2)]=((STRING_TABLE.__str1746354)|0);
HEAP32[((__ZL13mnemonic_main+964)>>2)]=((STRING_TABLE.__str1756355)|0);
HEAP32[((__ZL13mnemonic_main+972)>>2)]=((STRING_TABLE.__str1766356)|0);
HEAP32[((__ZL13mnemonic_main+980)>>2)]=((STRING_TABLE.__str1776357)|0);
HEAP32[((__ZL13mnemonic_main+988)>>2)]=((STRING_TABLE.__str1786358)|0);
HEAP32[((__ZL13mnemonic_main+996)>>2)]=((STRING_TABLE.__str1796359)|0);
HEAP32[((__ZL13mnemonic_main+1004)>>2)]=((STRING_TABLE.__str1806360)|0);
HEAP32[((__ZL13mnemonic_main+1012)>>2)]=((STRING_TABLE.__str1816361)|0);
HEAP32[((__ZL13mnemonic_main+1020)>>2)]=((STRING_TABLE.__str1826362)|0);
HEAP32[((__ZL13mnemonic_main+1028)>>2)]=((STRING_TABLE.__str1756355)|0);
HEAP32[((__ZL13mnemonic_main+1036)>>2)]=((STRING_TABLE.__str1766356)|0);
HEAP32[((__ZL13mnemonic_main+1044)>>2)]=((STRING_TABLE.__str1776357)|0);
HEAP32[((__ZL13mnemonic_main+1052)>>2)]=((STRING_TABLE.__str1786358)|0);
HEAP32[((__ZL13mnemonic_main+1060)>>2)]=((STRING_TABLE.__str1796359)|0);
HEAP32[((__ZL13mnemonic_main+1068)>>2)]=((STRING_TABLE.__str1806360)|0);
HEAP32[((__ZL13mnemonic_main+1076)>>2)]=((STRING_TABLE.__str1816361)|0);
HEAP32[((__ZL13mnemonic_main+1084)>>2)]=((STRING_TABLE.__str1826362)|0);
HEAP32[((__ZL13mnemonic_main+1092)>>2)]=((STRING_TABLE.__str1756355)|0);
HEAP32[((__ZL13mnemonic_main+1100)>>2)]=((STRING_TABLE.__str1766356)|0);
HEAP32[((__ZL13mnemonic_main+1108)>>2)]=((STRING_TABLE.__str1776357)|0);
HEAP32[((__ZL13mnemonic_main+1116)>>2)]=((STRING_TABLE.__str1786358)|0);
HEAP32[((__ZL13mnemonic_main+1124)>>2)]=((STRING_TABLE.__str1796359)|0);
HEAP32[((__ZL13mnemonic_main+1132)>>2)]=((STRING_TABLE.__str1806360)|0);
HEAP32[((__ZL13mnemonic_main+1140)>>2)]=((STRING_TABLE.__str1816361)|0);
HEAP32[((__ZL13mnemonic_main+1148)>>2)]=((STRING_TABLE.__str1826362)|0);
HEAP32[((__ZL13mnemonic_main+1156)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+1164)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+1172)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+1180)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+1188)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+1196)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+1204)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+1212)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+1220)>>2)]=((STRING_TABLE.__str1756355)|0);
HEAP32[((__ZL13mnemonic_main+1228)>>2)]=((STRING_TABLE.__str1766356)|0);
HEAP32[((__ZL13mnemonic_main+1236)>>2)]=((STRING_TABLE.__str1776357)|0);
HEAP32[((__ZL13mnemonic_main+1244)>>2)]=((STRING_TABLE.__str1786358)|0);
HEAP32[((__ZL13mnemonic_main+1252)>>2)]=((STRING_TABLE.__str1796359)|0);
HEAP32[((__ZL13mnemonic_main+1260)>>2)]=((STRING_TABLE.__str1806360)|0);
HEAP32[((__ZL13mnemonic_main+1268)>>2)]=((STRING_TABLE.__str1816361)|0);
HEAP32[((__ZL13mnemonic_main+1276)>>2)]=((STRING_TABLE.__str1826362)|0);
HEAP32[((__ZL13mnemonic_main+1284)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+1292)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+1300)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+1308)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+1316)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+1324)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+1332)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+1340)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+1348)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+1356)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+1364)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+1372)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+1380)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+1388)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+1396)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+1404)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+1412)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+1420)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+1428)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+1436)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+1444)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+1452)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+1460)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+1468)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+1476)>>2)]=((STRING_TABLE.__str816261)|0);
HEAP32[((__ZL13mnemonic_main+1484)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+1492)>>2)]=((STRING_TABLE.__str926272)|0);
HEAP32[((__ZL13mnemonic_main+1500)>>2)]=((STRING_TABLE.__str966276)|0);
HEAP32[((__ZL13mnemonic_main+1508)>>2)]=((STRING_TABLE.__str1026282)|0);
HEAP32[((__ZL13mnemonic_main+1516)>>2)]=((STRING_TABLE.__str1076287)|0);
HEAP32[((__ZL13mnemonic_main+1524)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+1532)>>2)]=((STRING_TABLE.__str1186298)|0);
HEAP32[((__ZL13mnemonic_main+1540)>>2)]=((STRING_TABLE.__str1836363)|0);
HEAP32[((__ZL13mnemonic_main+1548)>>2)]=((STRING_TABLE.__str806260)|0);
HEAP32[((__ZL13mnemonic_main+1556)>>2)]=((STRING_TABLE.__str1846364)|0);
HEAP32[((__ZL13mnemonic_main+1564)>>2)]=((STRING_TABLE.__str1856365)|0);
HEAP32[((__ZL13mnemonic_main+1572)>>2)]=((STRING_TABLE.__str1846364)|0);
HEAP32[((__ZL13mnemonic_main+1580)>>2)]=((STRING_TABLE.__str806260)|0);
HEAP32[((__ZL13mnemonic_main+1588)>>2)]=((STRING_TABLE.__str1196299)|0);
HEAP32[((__ZL13mnemonic_main+1596)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1604)>>2)]=((STRING_TABLE.__str1876367)|0);
HEAP32[((__ZL13mnemonic_main+1620)>>2)]=((STRING_TABLE.__str1886368)|0);
HEAP32[((__ZL13mnemonic_main+1628)>>2)]=((STRING_TABLE.__str1896369)|0);
HEAP32[((__ZL13mnemonic_main+1636)>>2)]=((STRING_TABLE.__str1886368)|0);
HEAP32[((__ZL13mnemonic_main+1644)>>2)]=((STRING_TABLE.__str1856365)|0);
HEAP32[((__ZL13mnemonic_main+1652)>>2)]=((STRING_TABLE.__str1196299)|0);
HEAP32[((__ZL13mnemonic_main+1660)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1668)>>2)]=((STRING_TABLE.__str1906370)|0);
HEAP32[((__ZL13mnemonic_main+1676)>>2)]=((STRING_TABLE.__str916271)|0);
HEAP32[((__ZL13mnemonic_main+1684)>>2)]=((STRING_TABLE.__str1916371)|0);
HEAP32[((__ZL13mnemonic_main+1692)>>2)]=((STRING_TABLE.__str1926372)|0);
HEAP32[((__ZL13mnemonic_main+1700)>>2)]=((STRING_TABLE.__str1916371)|0);
HEAP32[((__ZL13mnemonic_main+1708)>>2)]=((STRING_TABLE.__str916271)|0);
HEAP32[((__ZL13mnemonic_main+1716)>>2)]=((STRING_TABLE.__str1936373)|0);
HEAP32[((__ZL13mnemonic_main+1724)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1732)>>2)]=((STRING_TABLE.__str866266)|0);
HEAP32[((__ZL13mnemonic_main+1748)>>2)]=((STRING_TABLE.__str1946374)|0);
HEAP32[((__ZL13mnemonic_main+1756)>>2)]=((STRING_TABLE.__str1956375)|0);
HEAP32[((__ZL13mnemonic_main+1764)>>2)]=((STRING_TABLE.__str1946374)|0);
HEAP32[((__ZL13mnemonic_main+1772)>>2)]=((STRING_TABLE.__str1966376)|0);
HEAP32[((__ZL13mnemonic_main+1780)>>2)]=((STRING_TABLE.__str1196299)|0);
HEAP32[((__ZL13mnemonic_main+1788)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1796)>>2)]=((STRING_TABLE.__str1976377)|0);
HEAP32[((__ZL13mnemonic_main+1804)>>2)]=((STRING_TABLE.__str1016281)|0);
HEAP32[((__ZL13mnemonic_main+1812)>>2)]=((STRING_TABLE.__str1986378)|0);
HEAP32[((__ZL13mnemonic_main+1820)>>2)]=((STRING_TABLE.__str1996379)|0);
HEAP32[((__ZL13mnemonic_main+1828)>>2)]=((STRING_TABLE.__str1986378)|0);
HEAP32[((__ZL13mnemonic_main+1836)>>2)]=((STRING_TABLE.__str1016281)|0);
HEAP32[((__ZL13mnemonic_main+1844)>>2)]=((STRING_TABLE.__str1936373)|0);
HEAP32[((__ZL13mnemonic_main+1852)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1860)>>2)]=((STRING_TABLE.__str2006380)|0);
HEAP32[((__ZL13mnemonic_main+1868)>>2)]=((STRING_TABLE.__str1136293)|0);
HEAP32[((__ZL13mnemonic_main+1876)>>2)]=((STRING_TABLE.__str2016381)|0);
HEAP32[((__ZL13mnemonic_main+1884)>>2)]=((STRING_TABLE.__str2026382)|0);
HEAP32[((__ZL13mnemonic_main+1892)>>2)]=((STRING_TABLE.__str2016381)|0);
HEAP32[((__ZL13mnemonic_main+1900)>>2)]=((STRING_TABLE.__str2036383)|0);
HEAP32[((__ZL13mnemonic_main+1908)>>2)]=((STRING_TABLE.__str1936373)|0);
HEAP32[((__ZL13mnemonic_main+1916)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1924)>>2)]=((STRING_TABLE.__str2046384)|0);
HEAP32[((__ZL13mnemonic_main+1932)>>2)]=((STRING_TABLE.__str2056385)|0);
HEAP32[((__ZL13mnemonic_main+1940)>>2)]=((STRING_TABLE.__str2066386)|0);
HEAP32[((__ZL13mnemonic_main+1956)>>2)]=((STRING_TABLE.__str2066386)|0);
HEAP32[((__ZL13mnemonic_main+1964)>>2)]=((STRING_TABLE.__str2056385)|0);
HEAP32[((__ZL13mnemonic_main+1972)>>2)]=((STRING_TABLE.__str1936373)|0);
HEAP32[((__ZL13mnemonic_main+1980)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL13mnemonic_main+1988)>>2)]=((STRING_TABLE.__str2076387)|0);
HEAP32[((__ZL13mnemonic_main+1996)>>2)]=((STRING_TABLE.__str2086388)|0);
HEAP32[((__ZL13mnemonic_main+2004)>>2)]=((STRING_TABLE.__str2096389)|0);
HEAP32[((__ZL13mnemonic_main+2020)>>2)]=((STRING_TABLE.__str2096389)|0);
HEAP32[((__ZL13mnemonic_main+2028)>>2)]=((STRING_TABLE.__str2106390)|0);
HEAP32[((__ZL13mnemonic_main+2036)>>2)]=((STRING_TABLE.__str1936373)|0);
HEAP32[((__ZL13mnemonic_main+2044)>>2)]=((STRING_TABLE.__str1866366)|0);
HEAP32[((__ZL10s_mnemonic)>>2)]=((STRING_TABLE.__str96189)|0);
HEAP32[((__ZL10s_mnemonic+4)>>2)]=((STRING_TABLE.__str106190)|0);
HEAP32[((__ZL10s_mnemonic+8)>>2)]=((STRING_TABLE.__str116191)|0);
HEAP32[((__ZL10s_mnemonic+12)>>2)]=((STRING_TABLE.__str126192)|0);
HEAP32[((__ZL10s_mnemonic+16)>>2)]=((STRING_TABLE.__str136193)|0);
HEAP32[((__ZL10s_mnemonic+20)>>2)]=((STRING_TABLE.__str146194)|0);
HEAP32[((__ZL10s_mnemonic+24)>>2)]=((STRING_TABLE.__str156195)|0);
HEAP32[((__ZL10s_mnemonic+28)>>2)]=((STRING_TABLE.__str166196)|0);
HEAP32[((__ZL10s_mnemonic+32)>>2)]=((STRING_TABLE.__str176197)|0);
HEAP32[((__ZL10s_mnemonic+36)>>2)]=((STRING_TABLE.__str186198)|0);
HEAP32[((__ZL10s_mnemonic+40)>>2)]=((STRING_TABLE.__str196199)|0);
HEAP32[((__ZL10s_mnemonic+44)>>2)]=((STRING_TABLE.__str206200)|0);
HEAP32[((__ZL10s_mnemonic+48)>>2)]=((STRING_TABLE.__str216201)|0);
HEAP32[((__ZL10s_mnemonic+52)>>2)]=((STRING_TABLE.__str226202)|0);
HEAP32[((__ZL10s_mnemonic+56)>>2)]=((STRING_TABLE.__str236203)|0);
HEAP32[((__ZL10s_mnemonic+60)>>2)]=((STRING_TABLE.__str246204)|0);
HEAP32[((__ZL10s_mnemonic+64)>>2)]=((STRING_TABLE.__str256205)|0);
HEAP32[((__ZL10s_mnemonic+68)>>2)]=((STRING_TABLE.__str266206)|0);
HEAP32[((__ZL10s_mnemonic+72)>>2)]=((STRING_TABLE.__str276207)|0);
HEAP32[((__ZL10s_mnemonic+76)>>2)]=((STRING_TABLE.__str286208)|0);
HEAP32[((__ZL10s_mnemonic+80)>>2)]=((STRING_TABLE.__str296209)|0);
HEAP32[((__ZL10s_mnemonic+84)>>2)]=((STRING_TABLE.__str306210)|0);
HEAP32[((__ZL10s_mnemonic+88)>>2)]=((STRING_TABLE.__str316211)|0);
HEAP32[((__ZL10s_mnemonic+92)>>2)]=((STRING_TABLE.__str326212)|0);
HEAP32[((__ZL10s_mnemonic+96)>>2)]=((STRING_TABLE.__str336213)|0);
HEAP32[((__ZL10s_mnemonic+100)>>2)]=((STRING_TABLE.__str346214)|0);
HEAP32[((__ZL10s_mnemonic+104)>>2)]=((STRING_TABLE.__str356215)|0);
HEAP32[((__ZL10s_mnemonic+108)>>2)]=((STRING_TABLE.__str366216)|0);
HEAP32[((__ZL10s_mnemonic+112)>>2)]=((STRING_TABLE.__str376217)|0);
HEAP32[((__ZL10s_mnemonic+116)>>2)]=((STRING_TABLE.__str386218)|0);
HEAP32[((__ZL10s_mnemonic+120)>>2)]=((STRING_TABLE.__str396219)|0);
HEAP32[((__ZL10s_mnemonic+124)>>2)]=((STRING_TABLE.__str406220)|0);
HEAP32[((__ZL10s_mnemonic+128)>>2)]=((STRING_TABLE.__str416221)|0);
HEAP32[((__ZL10s_mnemonic+132)>>2)]=((STRING_TABLE.__str426222)|0);
HEAP32[((__ZL10s_mnemonic+136)>>2)]=((STRING_TABLE.__str436223)|0);
HEAP32[((__ZL10s_mnemonic+140)>>2)]=((STRING_TABLE.__str446224)|0);
HEAP32[((__ZL10s_mnemonic+144)>>2)]=((STRING_TABLE.__str456225)|0);
HEAP32[((__ZL10s_mnemonic+148)>>2)]=((STRING_TABLE.__str466226)|0);
HEAP32[((__ZL10s_mnemonic+152)>>2)]=((STRING_TABLE.__str476227)|0);
HEAP32[((__ZL10s_mnemonic+156)>>2)]=((STRING_TABLE.__str486228)|0);
HEAP32[((__ZL10s_mnemonic+160)>>2)]=((STRING_TABLE.__str496229)|0);
HEAP32[((__ZL10s_mnemonic+164)>>2)]=((STRING_TABLE.__str506230)|0);
HEAP32[((__ZL10s_mnemonic+168)>>2)]=((STRING_TABLE.__str516231)|0);
HEAP32[((__ZL10s_mnemonic+172)>>2)]=((STRING_TABLE.__str526232)|0);
HEAP32[((__ZL10s_mnemonic+176)>>2)]=((STRING_TABLE.__str536233)|0);
HEAP32[((__ZL10s_mnemonic+180)>>2)]=((STRING_TABLE.__str546234)|0);
HEAP32[((__ZL10s_mnemonic+184)>>2)]=((STRING_TABLE.__str556235)|0);
HEAP32[((__ZL10s_mnemonic+188)>>2)]=((STRING_TABLE.__str566236)|0);
HEAP32[((__ZL10s_mnemonic+192)>>2)]=((STRING_TABLE.__str576237)|0);
HEAP32[((__ZL10s_mnemonic+196)>>2)]=((STRING_TABLE.__str586238)|0);
HEAP32[((__ZL10s_mnemonic+200)>>2)]=((STRING_TABLE.__str596239)|0);
HEAP32[((__ZL10s_mnemonic+204)>>2)]=((STRING_TABLE.__str606240)|0);
HEAP32[((__ZL10s_mnemonic+208)>>2)]=((STRING_TABLE.__str616241)|0);
HEAP32[((__ZL10s_mnemonic+212)>>2)]=((STRING_TABLE.__str626242)|0);
HEAP32[((__ZL10s_mnemonic+216)>>2)]=((STRING_TABLE.__str636243)|0);
HEAP32[((__ZL10s_mnemonic+220)>>2)]=((STRING_TABLE.__str646244)|0);
HEAP32[((__ZL10s_mnemonic+224)>>2)]=((STRING_TABLE.__str656245)|0);
HEAP32[((__ZL10s_mnemonic+228)>>2)]=((STRING_TABLE.__str666246)|0);
HEAP32[((__ZL10s_mnemonic+232)>>2)]=((STRING_TABLE.__str676247)|0);
HEAP32[((__ZL10s_mnemonic+236)>>2)]=((STRING_TABLE.__str686248)|0);
HEAP32[((__ZL10s_mnemonic+240)>>2)]=((STRING_TABLE.__str696249)|0);
HEAP32[((__ZL10s_mnemonic+244)>>2)]=((STRING_TABLE.__str706250)|0);
HEAP32[((__ZL10s_mnemonic+248)>>2)]=((STRING_TABLE.__str716251)|0);
HEAP32[((__ZL10s_mnemonic+252)>>2)]=((STRING_TABLE.__str726252)|0);
HEAP32[((__ZL10s_mnemonic+256)>>2)]=((STRING_TABLE.__str736253)|0);
HEAP32[((__ZL10s_mnemonic+260)>>2)]=((STRING_TABLE.__str746254)|0);
HEAP32[((__ZL10s_mnemonic+264)>>2)]=((STRING_TABLE.__str756255)|0);
HEAP32[((__ZL10s_mnemonic+268)>>2)]=((STRING_TABLE.__str766256)|0);
HEAP32[((__ZL10s_mnemonic+272)>>2)]=((STRING_TABLE.__str776257)|0);
HEAP32[((__ZTV14samples_device+4)>>2)]=__ZTI14samples_device;
HEAP32[((__ZTV14samples_device+76)>>2)]=__ZTI14samples_device;
HEAP32[((__ZTI14samples_device)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI14samples_device+4)>>2)]=((STRING_TABLE.__ZTS14samples_device)|0);
HEAP32[((__ZTI14samples_device+8)>>2)]=__ZTI24legacy_sound_device_base;
HEAP32[((__ZTV20resource_pool_objectI14samples_deviceE+4)>>2)]=__ZTI20resource_pool_objectI14samples_deviceE;
HEAP32[((__ZTI20resource_pool_objectI14samples_deviceE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI20resource_pool_objectI14samples_deviceE+4)>>2)]=((STRING_TABLE.__ZTS20resource_pool_objectI14samples_deviceE)|0);
HEAP32[((__ZTI20resource_pool_objectI14samples_deviceE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZTI13_samples_info)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI13_samples_info+4)>>2)]=((STRING_TABLE.__ZTS13_samples_info)|0);
HEAP32[((__ZTV19resource_pool_arrayI15_sample_channelE+4)>>2)]=__ZTI19resource_pool_arrayI15_sample_channelE;
HEAP32[((__ZTI19resource_pool_arrayI15_sample_channelE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTI19resource_pool_arrayI15_sample_channelE+4)>>2)]=((STRING_TABLE.__ZTS19resource_pool_arrayI15_sample_channelE)|0);
HEAP32[((__ZTI19resource_pool_arrayI15_sample_channelE+8)>>2)]=__ZTI18resource_pool_item;
HEAP32[((__ZN12core_options18s_option_unadornedE)>>2)]=((STRING_TABLE.__str7272)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+4)>>2)]=((STRING_TABLE.__str17273)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+8)>>2)]=((STRING_TABLE.__str27274)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+12)>>2)]=((STRING_TABLE.__str37275)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+16)>>2)]=((STRING_TABLE.__str47276)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+20)>>2)]=((STRING_TABLE.__str57277)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+24)>>2)]=((STRING_TABLE.__str67278)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+28)>>2)]=((STRING_TABLE.__str77279)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+32)>>2)]=((STRING_TABLE.__str87280)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+36)>>2)]=((STRING_TABLE.__str97281)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+40)>>2)]=((STRING_TABLE.__str107282)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+44)>>2)]=((STRING_TABLE.__str117283)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+48)>>2)]=((STRING_TABLE.__str127284)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+52)>>2)]=((STRING_TABLE.__str137285)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+56)>>2)]=((STRING_TABLE.__str147286)|0);
HEAP32[((__ZN12core_options18s_option_unadornedE+60)>>2)]=((STRING_TABLE.__str157287)|0);
HEAP32[((__ZTV12core_options+4)>>2)]=__ZTI12core_options;
HEAP32[((__ZTI12core_options)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTI12core_options+4)>>2)]=((STRING_TABLE.__ZTS12core_options)|0);
HEAP32[((__ZL16codec_interfaces+4)>>2)]=((STRING_TABLE.__str7343)|0);
HEAP32[((__ZL16codec_interfaces+36)>>2)]=((STRING_TABLE.__str17344)|0);
HEAP32[((__ZL16codec_interfaces+68)>>2)]=((STRING_TABLE.__str27345)|0);
HEAP32[((__ZL16codec_interfaces+100)>>2)]=((STRING_TABLE.__str37346)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+4)>>2)]=((STRING_TABLE.__str7476)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+8)>>2)]=((STRING_TABLE.__str17477)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+12)>>2)]=((STRING_TABLE.__str27478)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+16)>>2)]=((STRING_TABLE.__str37479)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+20)>>2)]=((STRING_TABLE.__str47480)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+24)>>2)]=((STRING_TABLE.__str57481)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+28)>>2)]=((STRING_TABLE.__str67482)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+32)>>2)]=((STRING_TABLE.__str77483)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+36)>>2)]=((STRING_TABLE.__str87484)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+40)>>2)]=((STRING_TABLE.__str97485)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+44)>>2)]=((STRING_TABLE.__str107486)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+48)>>2)]=((STRING_TABLE.__str117487)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+52)>>2)]=((STRING_TABLE.__str127488)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+56)>>2)]=((STRING_TABLE.__str137489)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+60)>>2)]=((STRING_TABLE.__str147490)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+64)>>2)]=((STRING_TABLE.__str157491)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+68)>>2)]=((STRING_TABLE.__str167492)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+72)>>2)]=((STRING_TABLE.__str177493)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+76)>>2)]=((STRING_TABLE.__str187494)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+80)>>2)]=((STRING_TABLE.__str197495)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+84)>>2)]=((STRING_TABLE.__str207496)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+88)>>2)]=((STRING_TABLE.__str217497)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+92)>>2)]=((STRING_TABLE.__str227498)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+96)>>2)]=((STRING_TABLE.__str237499)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+100)>>2)]=((STRING_TABLE.__str247500)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+104)>>2)]=((STRING_TABLE.__str257501)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+108)>>2)]=((STRING_TABLE.__str267502)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+112)>>2)]=((STRING_TABLE.__str277503)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+116)>>2)]=((STRING_TABLE.__str287504)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+120)>>2)]=((STRING_TABLE.__str297505)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+124)>>2)]=((STRING_TABLE.__str307506)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+128)>>2)]=((STRING_TABLE.__str317507)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+132)>>2)]=((STRING_TABLE.__str327508)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+136)>>2)]=((STRING_TABLE.__str337509)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+140)>>2)]=((STRING_TABLE.__str347510)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+144)>>2)]=((STRING_TABLE.__str357511)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+148)>>2)]=((STRING_TABLE.__str367512)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+152)>>2)]=((STRING_TABLE.__str377513)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+156)>>2)]=((STRING_TABLE.__str387514)|0);
HEAP32[((__ZZ15XML_ErrorStringE7message+160)>>2)]=((STRING_TABLE.__str397515)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types)>>2)]=((STRING_TABLE.__ZL8KW_CDATA)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+4)>>2)]=((STRING_TABLE.__ZL5KW_ID)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+8)>>2)]=((STRING_TABLE.__ZL8KW_IDREF)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+12)>>2)]=((STRING_TABLE.__ZL9KW_IDREFS)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+16)>>2)]=((STRING_TABLE.__ZL9KW_ENTITY)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+20)>>2)]=((STRING_TABLE.__ZL11KW_ENTITIES)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+24)>>2)]=((STRING_TABLE.__ZL10KW_NMTOKEN)|0);
HEAP32[((__ZZL8attlist2P12prolog_stateiPKcS2_PK8encodingE5types+28)>>2)]=((STRING_TABLE.__ZL11KW_NMTOKENS)|0);
HEAP32[((__ZL11encodingsNS)>>2)]=(((STRING_TABLE.__ZL18latin1_encoding_ns))|0);
HEAP32[((__ZL11encodingsNS+4)>>2)]=(STRING_TABLE.__ZL17ascii_encoding_ns);
HEAP32[((__ZL11encodingsNS+8)>>2)]=(((STRING_TABLE.__ZL16utf8_encoding_ns))|0);
HEAP32[((__ZL11encodingsNS+12)>>2)]=(((STRING_TABLE.__ZL16big2_encoding_ns))|0);
HEAP32[((__ZL11encodingsNS+16)>>2)]=(((STRING_TABLE.__ZL16big2_encoding_ns))|0);
HEAP32[((__ZL11encodingsNS+20)>>2)]=(((STRING_TABLE.__ZL19little2_encoding_ns))|0);
HEAP32[((__ZL11encodingsNS+24)>>2)]=(((STRING_TABLE.__ZL16utf8_encoding_ns))|0);
HEAP32[((__ZL9encodings)>>2)]=(((STRING_TABLE.__ZL15latin1_encoding))|0);
HEAP32[((__ZL9encodings+4)>>2)]=(STRING_TABLE.__ZL14ascii_encoding);
HEAP32[((__ZL9encodings+8)>>2)]=(((STRING_TABLE.__ZL13utf8_encoding))|0);
HEAP32[((__ZL9encodings+12)>>2)]=(((STRING_TABLE.__ZL13big2_encoding))|0);
HEAP32[((__ZL9encodings+16)>>2)]=(((STRING_TABLE.__ZL13big2_encoding))|0);
HEAP32[((__ZL9encodings+20)>>2)]=(((STRING_TABLE.__ZL16little2_encoding))|0);
HEAP32[((__ZL9encodings+24)>>2)]=(((STRING_TABLE.__ZL13utf8_encoding))|0);
HEAP32[((__ZZL16getEncodingIndexPKcE13encodingNames)>>2)]=((STRING_TABLE.__ZL13KW_ISO_8859_1)|0);
HEAP32[((__ZZL16getEncodingIndexPKcE13encodingNames+4)>>2)]=((STRING_TABLE.__ZL11KW_US_ASCII)|0);
HEAP32[((__ZZL16getEncodingIndexPKcE13encodingNames+8)>>2)]=((STRING_TABLE.__ZL8KW_UTF_8)|0);
HEAP32[((__ZZL16getEncodingIndexPKcE13encodingNames+12)>>2)]=((STRING_TABLE.__ZL9KW_UTF_16)|0);
HEAP32[((__ZZL16getEncodingIndexPKcE13encodingNames+16)>>2)]=((STRING_TABLE.__ZL11KW_UTF_16BE)|0);
HEAP32[((__ZZL16getEncodingIndexPKcE13encodingNames+20)>>2)]=((STRING_TABLE.__ZL11KW_UTF_16LE)|0);
HEAP32[((_cassette_default_formats)>>2)]=_wavfile_format;
HEAP32[((_wavfile_format)>>2)]=((STRING_TABLE.__str7588)|0);
HEAP32[((_z_errmsg)>>2)]=((STRING_TABLE.__str7646)|0);
HEAP32[((_z_errmsg+4)>>2)]=((STRING_TABLE.__str17647)|0);
HEAP32[((_z_errmsg+8)>>2)]=((__str27648)|0);
HEAP32[((_z_errmsg+12)>>2)]=((STRING_TABLE.__str37649)|0);
HEAP32[((_z_errmsg+16)>>2)]=((STRING_TABLE.__str47650)|0);
HEAP32[((_z_errmsg+20)>>2)]=((STRING_TABLE.__str57651)|0);
HEAP32[((_z_errmsg+24)>>2)]=((STRING_TABLE.__str67652)|0);
HEAP32[((_z_errmsg+28)>>2)]=((STRING_TABLE.__str77653)|0);
HEAP32[((_z_errmsg+32)>>2)]=((STRING_TABLE.__str87654)|0);
HEAP32[((_z_errmsg+36)>>2)]=((__str27648)|0);
HEAP32[((_static_l_desc)>>2)]=((_static_ltree)|0);
HEAP32[((_static_l_desc+4)>>2)]=((_extra_lbits)|0);
HEAP32[((_static_d_desc)>>2)]=((_static_dtree)|0);
HEAP32[((_static_d_desc+4)>>2)]=((_extra_dbits)|0);
HEAP32[((_static_bl_desc+4)>>2)]=((_extra_blbits)|0);
HEAP32[((__ZTVNSt3__111__stdoutbufIwEE+4)>>2)]=__ZTINSt3__111__stdoutbufIwEE;
HEAP32[((__ZTINSt3__111__stdoutbufIwEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__111__stdoutbufIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__111__stdoutbufIwEE)|0);
HEAP32[((__ZTINSt3__111__stdoutbufIwEE+8)>>2)]=__ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__110__stdinbufIwEE+4)>>2)]=__ZTINSt3__110__stdinbufIwEE;
HEAP32[((__ZTINSt3__110__stdinbufIwEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110__stdinbufIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110__stdinbufIwEE)|0);
HEAP32[((__ZTINSt3__110__stdinbufIwEE+8)>>2)]=__ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__111__stdoutbufIcEE+4)>>2)]=__ZTINSt3__111__stdoutbufIcEE;
HEAP32[((__ZTINSt3__111__stdoutbufIcEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__111__stdoutbufIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__111__stdoutbufIcEE)|0);
HEAP32[((__ZTINSt3__111__stdoutbufIcEE+8)>>2)]=__ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTVNSt3__110__stdinbufIcEE+4)>>2)]=__ZTINSt3__110__stdinbufIcEE;
HEAP32[((__ZTINSt3__110__stdinbufIcEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110__stdinbufIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110__stdinbufIcEE)|0);
HEAP32[((__ZTINSt3__110__stdinbufIcEE+8)>>2)]=__ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTVNSt3__114__shared_countE+4)>>2)]=__ZTINSt3__114__shared_countE;
HEAP32[((__ZTINSt3__114__shared_countE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__114__shared_countE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__114__shared_countE)|0);
HEAP32[((__ZTVSt11logic_error+4)>>2)]=__ZTISt11logic_error;
HEAP32[((__ZTVSt13runtime_error+4)>>2)]=__ZTISt13runtime_error;
HEAP32[((__ZTISt11logic_error)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTISt11logic_error+4)>>2)]=((STRING_TABLE.__ZTSSt11logic_error)|0);
HEAP32[((__ZTISt11logic_error+8)>>2)]=__ZTISt9exception;
HEAP32[((__ZTVSt12length_error+4)>>2)]=__ZTISt12length_error;
HEAP32[((__ZTISt12length_error)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTISt12length_error+4)>>2)]=((STRING_TABLE.__ZTSSt12length_error)|0);
HEAP32[((__ZTISt12length_error+8)>>2)]=__ZTISt11logic_error;
HEAP32[((__ZTISt13runtime_error)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTISt13runtime_error+4)>>2)]=((STRING_TABLE.__ZTSSt13runtime_error)|0);
HEAP32[((__ZTISt13runtime_error+8)>>2)]=__ZTISt9exception;
HEAP32[((__ZTVNSt3__114error_categoryE+4)>>2)]=__ZTINSt3__114error_categoryE;
HEAP32[((__ZTVNSt3__112system_errorE+4)>>2)]=__ZTINSt3__112system_errorE;
HEAP32[((__ZTINSt3__112system_errorE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__112system_errorE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__112system_errorE)|0);
HEAP32[((__ZTINSt3__112system_errorE+8)>>2)]=__ZTISt13runtime_error;
HEAP32[((__ZTINSt3__114error_categoryE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__114error_categoryE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__114error_categoryE)|0);
HEAP32[((__ZTVNSt3__112__do_messageE+4)>>2)]=__ZTINSt3__112__do_messageE;
HEAP32[((__ZTINSt3__112__do_messageE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__112__do_messageE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__112__do_messageE)|0);
HEAP32[((__ZTINSt3__112__do_messageE+8)>>2)]=__ZTINSt3__114error_categoryE;
HEAP32[((__ZTVSt9exception+4)>>2)]=__ZTISt9exception;
HEAP32[((__ZTISt9exception)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTISt9exception+4)>>2)]=((STRING_TABLE.__ZTSSt9exception)|0);
HEAP32[((__ZTVNSt3__19basic_iosIcNS_11char_traitsIcEEEE+4)>>2)]=__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTVNSt3__19basic_iosIwNS_11char_traitsIwEEEE+4)>>2)]=__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__115basic_streambufIcNS_11char_traitsIcEEEE+4)>>2)]=__ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTVNSt3__115basic_streambufIwNS_11char_traitsIwEEEE+4)>>2)]=__ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+8)>>2)]=__ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+28)>>2)]=__ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTTNSt3__113basic_istreamIcNS_11char_traitsIcEEEE)>>2)]=(((__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+12)|0));
HEAP32[((__ZTTNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+4)>>2)]=(((__ZTVNSt3__113basic_istreamIcNS_11char_traitsIcEEEE+32)|0));
HEAP32[((__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+8)>>2)]=__ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+28)>>2)]=__ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTTNSt3__113basic_istreamIwNS_11char_traitsIwEEEE)>>2)]=(((__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+12)|0));
HEAP32[((__ZTTNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+4)>>2)]=(((__ZTVNSt3__113basic_istreamIwNS_11char_traitsIwEEEE+32)|0));
HEAP32[((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+8)>>2)]=__ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+28)>>2)]=__ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTTNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE)>>2)]=(((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+12)|0));
HEAP32[((__ZTTNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+4)>>2)]=(((__ZTVNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+32)|0));
HEAP32[((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+8)>>2)]=__ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+28)>>2)]=__ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTTNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE)>>2)]=(((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+12)|0));
HEAP32[((__ZTTNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+4)>>2)]=(((__ZTVNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+32)|0));
HEAP32[((__ZTVNSt3__18ios_base7failureE+4)>>2)]=__ZTINSt3__18ios_base7failureE;
HEAP32[((__ZTVNSt3__18ios_baseE+4)>>2)]=__ZTINSt3__18ios_baseE;
HEAP32[((__ZTINSt3__18ios_base7failureE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18ios_base7failureE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18ios_base7failureE)|0);
HEAP32[((__ZTINSt3__18ios_base7failureE+8)>>2)]=__ZTINSt3__112system_errorE;
HEAP32[((__ZTINSt3__18ios_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18ios_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18ios_baseE)|0);
HEAP32[((__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19basic_iosIcNS_11char_traitsIcEEEE)|0);
HEAP32[((__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE+8)>>2)]=__ZTINSt3__18ios_baseE;
HEAP32[((__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19basic_iosIwNS_11char_traitsIwEEEE)|0);
HEAP32[((__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE+8)>>2)]=__ZTINSt3__18ios_baseE;
HEAP32[((__ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__115basic_streambufIcNS_11char_traitsIcEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__115basic_streambufIcNS_11char_traitsIcEEEE)|0);
HEAP32[((__ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__115basic_streambufIwNS_11char_traitsIwEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__115basic_streambufIwNS_11char_traitsIwEEEE)|0);
HEAP32[((__ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__113basic_istreamIcNS_11char_traitsIcEEEE)|0);
HEAP32[((__ZTINSt3__113basic_istreamIcNS_11char_traitsIcEEEE+16)>>2)]=__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__113basic_istreamIwNS_11char_traitsIwEEEE)|0);
HEAP32[((__ZTINSt3__113basic_istreamIwNS_11char_traitsIwEEEE+16)>>2)]=__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__113basic_ostreamIcNS_11char_traitsIcEEEE)|0);
HEAP32[((__ZTINSt3__113basic_ostreamIcNS_11char_traitsIcEEEE+16)>>2)]=__ZTINSt3__19basic_iosIcNS_11char_traitsIcEEEE;
HEAP32[((__ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__113basic_ostreamIwNS_11char_traitsIwEEEE)|0);
HEAP32[((__ZTINSt3__113basic_ostreamIwNS_11char_traitsIwEEEE+16)>>2)]=__ZTINSt3__19basic_iosIwNS_11char_traitsIwEEEE;
HEAP32[((__ZTVNSt3__119__iostream_categoryE+4)>>2)]=__ZTINSt3__119__iostream_categoryE;
HEAP32[((__ZTINSt3__119__iostream_categoryE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__119__iostream_categoryE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__119__iostream_categoryE)|0);
HEAP32[((__ZTINSt3__119__iostream_categoryE+8)>>2)]=__ZTINSt3__112__do_messageE;
HEAP32[((__ZTVNSt3__17collateIcEE+4)>>2)]=__ZTINSt3__17collateIcEE;
HEAP32[((__ZTVNSt3__17collateIwEE+4)>>2)]=__ZTINSt3__17collateIwEE;
HEAP32[((__ZTVNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=__ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=__ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=__ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=__ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+52)>>2)]=__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+52)>>2)]=__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=__ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=__ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__110moneypunctIcLb0EEE+4)>>2)]=__ZTINSt3__110moneypunctIcLb0EEE;
HEAP32[((__ZTVNSt3__110moneypunctIcLb1EEE+4)>>2)]=__ZTINSt3__110moneypunctIcLb1EEE;
HEAP32[((__ZTVNSt3__110moneypunctIwLb0EEE+4)>>2)]=__ZTINSt3__110moneypunctIwLb0EEE;
HEAP32[((__ZTVNSt3__110moneypunctIwLb1EEE+4)>>2)]=__ZTINSt3__110moneypunctIwLb1EEE;
HEAP32[((__ZTVNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=__ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=__ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=__ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE;
HEAP32[((__ZTVNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=__ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE;
HEAP32[((__ZTVNSt3__18messagesIcEE+4)>>2)]=__ZTINSt3__18messagesIcEE;
HEAP32[((__ZTVNSt3__18messagesIwEE+4)>>2)]=__ZTINSt3__18messagesIwEE;
HEAP32[((__ZTVNSt3__16locale5__impE+4)>>2)]=__ZTINSt3__16locale5__impE;
HEAP32[((__ZTVNSt3__15ctypeIcEE+4)>>2)]=__ZTINSt3__15ctypeIcEE;
HEAP32[((__ZTVNSt3__17codecvtIwc10_mbstate_tEE+4)>>2)]=__ZTINSt3__17codecvtIwc10_mbstate_tEE;
HEAP32[((__ZTVNSt3__18numpunctIcEE+4)>>2)]=__ZTINSt3__18numpunctIcEE;
HEAP32[((__ZTVNSt3__18numpunctIwEE+4)>>2)]=__ZTINSt3__18numpunctIwEE;
HEAP32[((__ZTVNSt3__16locale5facetE+4)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__16locale5facetE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__16locale5facetE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__16locale5facetE)|0);
HEAP32[((__ZTINSt3__16locale5facetE+8)>>2)]=__ZTINSt3__114__shared_countE;
HEAP32[((__ZTVNSt3__15ctypeIwEE+4)>>2)]=__ZTINSt3__15ctypeIwEE;
HEAP32[((__ZTINSt3__110ctype_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110ctype_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110ctype_baseE)|0);
HEAP32[((__ZTINSt3__15ctypeIwEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__15ctypeIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__15ctypeIwEE)|0);
HEAP32[((__ZTINSt3__15ctypeIwEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__15ctypeIwEE+24)>>2)]=__ZTINSt3__110ctype_baseE;
HEAP32[((__ZTINSt3__15ctypeIcEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__15ctypeIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__15ctypeIcEE)|0);
HEAP32[((__ZTINSt3__15ctypeIcEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__15ctypeIcEE+24)>>2)]=__ZTINSt3__110ctype_baseE;
HEAP32[((__ZTVNSt3__17codecvtIcc10_mbstate_tEE+4)>>2)]=__ZTINSt3__17codecvtIcc10_mbstate_tEE;
HEAP32[((__ZTINSt3__112codecvt_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__112codecvt_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__112codecvt_baseE)|0);
HEAP32[((__ZTINSt3__17codecvtIcc10_mbstate_tEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17codecvtIcc10_mbstate_tEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17codecvtIcc10_mbstate_tEE)|0);
HEAP32[((__ZTINSt3__17codecvtIcc10_mbstate_tEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17codecvtIcc10_mbstate_tEE+24)>>2)]=__ZTINSt3__112codecvt_baseE;
HEAP32[((__ZTINSt3__17codecvtIwc10_mbstate_tEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17codecvtIwc10_mbstate_tEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17codecvtIwc10_mbstate_tEE)|0);
HEAP32[((__ZTINSt3__17codecvtIwc10_mbstate_tEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17codecvtIwc10_mbstate_tEE+24)>>2)]=__ZTINSt3__112codecvt_baseE;
HEAP32[((__ZTVNSt3__17codecvtItc10_mbstate_tEE+4)>>2)]=__ZTINSt3__17codecvtItc10_mbstate_tEE;
HEAP32[((__ZTINSt3__17codecvtItc10_mbstate_tEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17codecvtItc10_mbstate_tEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17codecvtItc10_mbstate_tEE)|0);
HEAP32[((__ZTINSt3__17codecvtItc10_mbstate_tEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17codecvtItc10_mbstate_tEE+24)>>2)]=__ZTINSt3__112codecvt_baseE;
HEAP32[((__ZTVNSt3__17codecvtIjc10_mbstate_tEE+4)>>2)]=__ZTINSt3__17codecvtIjc10_mbstate_tEE;
HEAP32[((__ZTINSt3__17codecvtIjc10_mbstate_tEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17codecvtIjc10_mbstate_tEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17codecvtIjc10_mbstate_tEE)|0);
HEAP32[((__ZTINSt3__17codecvtIjc10_mbstate_tEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17codecvtIjc10_mbstate_tEE+24)>>2)]=__ZTINSt3__112codecvt_baseE;
HEAP32[((__ZTVNSt3__116__narrow_to_utf8ILj32EEE+4)>>2)]=__ZTINSt3__116__narrow_to_utf8ILj32EEE;
HEAP32[((__ZTINSt3__116__narrow_to_utf8ILj32EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__116__narrow_to_utf8ILj32EEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__116__narrow_to_utf8ILj32EEE)|0);
HEAP32[((__ZTINSt3__116__narrow_to_utf8ILj32EEE+8)>>2)]=__ZTINSt3__17codecvtIjc10_mbstate_tEE;
HEAP32[((__ZTVNSt3__117__widen_from_utf8ILj32EEE+4)>>2)]=__ZTINSt3__117__widen_from_utf8ILj32EEE;
HEAP32[((__ZTINSt3__117__widen_from_utf8ILj32EEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__117__widen_from_utf8ILj32EEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__117__widen_from_utf8ILj32EEE)|0);
HEAP32[((__ZTINSt3__117__widen_from_utf8ILj32EEE+8)>>2)]=__ZTINSt3__17codecvtIjc10_mbstate_tEE;
HEAP32[((__ZTINSt3__18numpunctIcEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18numpunctIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18numpunctIcEE)|0);
HEAP32[((__ZTINSt3__18numpunctIcEE+8)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18numpunctIwEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18numpunctIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18numpunctIwEE)|0);
HEAP32[((__ZTINSt3__18numpunctIwEE+8)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__16locale5__impE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__16locale5__impE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__16locale5__impE)|0);
HEAP32[((__ZTINSt3__16locale5__impE+8)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17collateIcEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17collateIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17collateIcEE)|0);
HEAP32[((__ZTINSt3__17collateIcEE+8)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17collateIwEE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17collateIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17collateIwEE)|0);
HEAP32[((__ZTINSt3__17collateIwEE+8)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__110money_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110money_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110money_baseE)|0);
HEAP32[((__ZTINSt3__110moneypunctIcLb0EEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110moneypunctIcLb0EEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110moneypunctIcLb0EEE)|0);
HEAP32[((__ZTINSt3__110moneypunctIcLb0EEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__110moneypunctIcLb0EEE+24)>>2)]=__ZTINSt3__110money_baseE;
HEAP32[((__ZTINSt3__110moneypunctIcLb1EEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110moneypunctIcLb1EEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110moneypunctIcLb1EEE)|0);
HEAP32[((__ZTINSt3__110moneypunctIcLb1EEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__110moneypunctIcLb1EEE+24)>>2)]=__ZTINSt3__110money_baseE;
HEAP32[((__ZTINSt3__110moneypunctIwLb0EEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110moneypunctIwLb0EEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110moneypunctIwLb0EEE)|0);
HEAP32[((__ZTINSt3__110moneypunctIwLb0EEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__110moneypunctIwLb0EEE+24)>>2)]=__ZTINSt3__110money_baseE;
HEAP32[((__ZTINSt3__110moneypunctIwLb1EEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110moneypunctIwLb1EEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110moneypunctIwLb1EEE)|0);
HEAP32[((__ZTINSt3__110moneypunctIwLb1EEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__110moneypunctIwLb1EEE+24)>>2)]=__ZTINSt3__110money_baseE;
HEAP32[((__ZTINSt3__19time_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19time_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19time_baseE)|0);
HEAP32[((__ZTINSt3__120__time_get_c_storageIcEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__120__time_get_c_storageIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__120__time_get_c_storageIcEE)|0);
HEAP32[((__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE)|0);
HEAP32[((__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+24)>>2)]=__ZTINSt3__19time_baseE;
HEAP32[((__ZTINSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+32)>>2)]=__ZTINSt3__120__time_get_c_storageIcEE;
HEAP32[((__ZTINSt3__120__time_get_c_storageIwEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__120__time_get_c_storageIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__120__time_get_c_storageIwEE)|0);
HEAP32[((__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE)|0);
HEAP32[((__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+24)>>2)]=__ZTINSt3__19time_baseE;
HEAP32[((__ZTINSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+32)>>2)]=__ZTINSt3__120__time_get_c_storageIwEE;
HEAP32[((__ZTINSt3__110__time_putE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__110__time_putE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__110__time_putE)|0);
HEAP32[((__ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE)|0);
HEAP32[((__ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+24)>>2)]=__ZTINSt3__110__time_putE;
HEAP32[((__ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE)|0);
HEAP32[((__ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+24)>>2)]=__ZTINSt3__110__time_putE;
HEAP32[((__ZTINSt3__113messages_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__113messages_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__113messages_baseE)|0);
HEAP32[((__ZTINSt3__18messagesIcEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18messagesIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18messagesIcEE)|0);
HEAP32[((__ZTINSt3__18messagesIcEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18messagesIcEE+24)>>2)]=__ZTINSt3__113messages_baseE;
HEAP32[((__ZTINSt3__18messagesIwEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__18messagesIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__18messagesIwEE)|0);
HEAP32[((__ZTINSt3__18messagesIwEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__18messagesIwEE+24)>>2)]=__ZTINSt3__113messages_baseE;
HEAP32[((__ZTINSt3__114__num_get_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__114__num_get_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__114__num_get_baseE)|0);
HEAP32[((__ZTINSt3__19__num_getIcEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19__num_getIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19__num_getIcEE)|0);
HEAP32[((__ZTINSt3__19__num_getIcEE+16)>>2)]=__ZTINSt3__114__num_get_baseE;
HEAP32[((__ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE)|0);
HEAP32[((__ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+24)>>2)]=__ZTINSt3__19__num_getIcEE;
HEAP32[((__ZTINSt3__19__num_getIwEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19__num_getIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19__num_getIwEE)|0);
HEAP32[((__ZTINSt3__19__num_getIwEE+16)>>2)]=__ZTINSt3__114__num_get_baseE;
HEAP32[((__ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE)|0);
HEAP32[((__ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+24)>>2)]=__ZTINSt3__19__num_getIwEE;
HEAP32[((__ZTINSt3__114__num_put_baseE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__114__num_put_baseE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__114__num_put_baseE)|0);
HEAP32[((__ZTINSt3__19__num_putIcEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19__num_putIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19__num_putIcEE)|0);
HEAP32[((__ZTINSt3__19__num_putIcEE+16)>>2)]=__ZTINSt3__114__num_put_baseE;
HEAP32[((__ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE)|0);
HEAP32[((__ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+24)>>2)]=__ZTINSt3__19__num_putIcEE;
HEAP32[((__ZTINSt3__19__num_putIwEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19__num_putIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19__num_putIwEE)|0);
HEAP32[((__ZTINSt3__19__num_putIwEE+16)>>2)]=__ZTINSt3__114__num_put_baseE;
HEAP32[((__ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE)|0);
HEAP32[((__ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+24)>>2)]=__ZTINSt3__19__num_putIwEE;
HEAP32[((__ZTINSt3__111__money_getIcEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__111__money_getIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__111__money_getIcEE)|0);
HEAP32[((__ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE)|0);
HEAP32[((__ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEE+24)>>2)]=__ZTINSt3__111__money_getIcEE;
HEAP32[((__ZTINSt3__111__money_getIwEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__111__money_getIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__111__money_getIwEE)|0);
HEAP32[((__ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE)|0);
HEAP32[((__ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEE+24)>>2)]=__ZTINSt3__111__money_getIwEE;
HEAP32[((__ZTINSt3__111__money_putIcEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__111__money_putIcEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__111__money_putIcEE)|0);
HEAP32[((__ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE)|0);
HEAP32[((__ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEE+24)>>2)]=__ZTINSt3__111__money_putIcEE;
HEAP32[((__ZTINSt3__111__money_putIwEE)>>2)]=(((__ZTVN10__cxxabiv117__class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__111__money_putIwEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__111__money_putIwEE)|0);
HEAP32[((__ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE)>>2)]=(((__ZTVN10__cxxabiv121__vmi_class_type_infoE+8)|0));
HEAP32[((__ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+4)>>2)]=((STRING_TABLE.__ZTSNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE)|0);
HEAP32[((__ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+16)>>2)]=__ZTINSt3__16locale5facetE;
HEAP32[((__ZTINSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEE+24)>>2)]=__ZTINSt3__111__money_putIwEE;
HEAP32[((__ZTVNSt3__120__time_get_c_storageIwEE+4)>>2)]=__ZTINSt3__120__time_get_c_storageIwEE;
HEAP32[((__ZTVNSt3__120__time_get_c_storageIcEE+4)>>2)]=__ZTINSt3__120__time_get_c_storageIcEE;
HEAP32[((__ZTVSt8bad_cast+4)>>2)]=__ZTISt8bad_cast;
HEAP32[((__ZTISt8bad_cast)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTISt8bad_cast+4)>>2)]=((STRING_TABLE.__ZTSSt8bad_cast)|0);
HEAP32[((__ZTISt8bad_cast+8)>>2)]=__ZTISt9exception;
HEAP32[((__ZTIN10__cxxabiv116__shim_type_infoE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTIN10__cxxabiv116__shim_type_infoE+4)>>2)]=((STRING_TABLE.__ZTSN10__cxxabiv116__shim_type_infoE)|0);
HEAP32[((__ZTIN10__cxxabiv116__shim_type_infoE+8)>>2)]=__ZTISt9type_info;
HEAP32[((__ZTIN10__cxxabiv117__class_type_infoE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTIN10__cxxabiv117__class_type_infoE+4)>>2)]=((STRING_TABLE.__ZTSN10__cxxabiv117__class_type_infoE)|0);
HEAP32[((__ZTIN10__cxxabiv117__class_type_infoE+8)>>2)]=__ZTIN10__cxxabiv116__shim_type_infoE;
HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE+4)>>2)]=__ZTIN10__cxxabiv117__class_type_infoE;
HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE+4)>>2)]=__ZTIN10__cxxabiv120__si_class_type_infoE;
HEAP32[((__ZTIN10__cxxabiv120__si_class_type_infoE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTIN10__cxxabiv120__si_class_type_infoE+4)>>2)]=((STRING_TABLE.__ZTSN10__cxxabiv120__si_class_type_infoE)|0);
HEAP32[((__ZTIN10__cxxabiv120__si_class_type_infoE+8)>>2)]=__ZTIN10__cxxabiv117__class_type_infoE;
HEAP32[((__ZTVN10__cxxabiv121__vmi_class_type_infoE+4)>>2)]=__ZTIN10__cxxabiv121__vmi_class_type_infoE;
HEAP32[((__ZTIN10__cxxabiv121__vmi_class_type_infoE)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTIN10__cxxabiv121__vmi_class_type_infoE+4)>>2)]=((STRING_TABLE.__ZTSN10__cxxabiv121__vmi_class_type_infoE)|0);
HEAP32[((__ZTIN10__cxxabiv121__vmi_class_type_infoE+8)>>2)]=__ZTIN10__cxxabiv117__class_type_infoE;
HEAP32[((__ZTVSt9bad_alloc+4)>>2)]=__ZTISt9bad_alloc;
HEAP32[((__ZTISt9bad_alloc)>>2)]=(((__ZTVN10__cxxabiv120__si_class_type_infoE+8)|0));
HEAP32[((__ZTISt9bad_alloc+4)>>2)]=((STRING_TABLE.__ZTSSt9bad_alloc)|0);
HEAP32[((__ZTISt9bad_alloc+8)>>2)]=__ZTISt9exception;
__ZN18mini_osd_interfaceC1Ev = 8716;
__ZN18mini_osd_interfaceD1Ev = 8718;
__ZN12i8748_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 8720;
__ZN12i8049_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 8722;
__ZN10z80_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 8724;
__ZN25device_z80daisy_interfaceD1Ev = 8726;
__ZN15z80_daisy_chain11daisy_entryC1EP8device_t = 8728;
__ZN17input_port_configC1ER8device_tPKc = 8730;
__ZN18input_field_configC1ER17input_port_configijjPKc = 8732;
__ZN20input_setting_configC1ER18input_field_configjPKc = 8734;
__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seq = 8736;
__ZN16input_type_entryC1Ej12ioport_groupiPKcS2_9input_seqS3_S3_ = 8738;
__ZN12timer_deviceC1ERK14machine_configPKcP8device_tj = 8740;
__ZN15cartslot_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 8742;
__ZN20software_list_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 8744;
__ZN13resource_poolC1Ei = 8746;
__ZN13resource_poolD1Ev = 8748;
__ZN11cli_optionsC1Ev = 8750;
__ZN12cli_frontendC1ER11cli_optionsR13osd_interface = 8752;
__ZN12cli_frontendD1Ev = 8754;
__ZN16media_identifierC1ER11cli_options = 8756;
__ZN14machine_configC1ERK11game_driverR11emu_options = 8758;
__ZN14machine_configD1Ev = 8760;
__ZN11device_listC1ER13resource_pool = 8762;
__ZN8device_tD1Ev = 8764;
__ZN8device_t16auto_finder_baseD1Ev = 8766;
__ZN16device_interfaceD1Ev = 8768;
__ZN18address_map_entry8C1ER11address_mapjj = 8770;
__ZN11address_mapC1ERK8device_t16address_spacenum = 8772;
__ZN11address_mapD1Ev = 8774;
__ZN22device_image_interfaceD1Ev = 8776;
__ZN20address_space_configC1Ev = 8778;
__ZN23device_memory_interfaceD1Ev = 8780;
__ZN12joystick_mapC1Ev = 8782;
__ZN10input_codeC1ER12input_device13input_item_id = 8784;
__ZN12input_deviceC1ER11input_classiPKcPv = 8786;
__ZN11input_classC1ER13input_manager18input_device_classbb = 8788;
__ZN13input_managerC1ER15running_machine = 8790;
__ZN24input_device_switch_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E = 8792;
__ZN26input_device_relative_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E = 8794;
__ZN26input_device_absolute_itemC1ER12input_devicePKcPv13input_item_idPFiS4_S4_E = 8796;
__ZN12device_debugC1ER8device_t = 8798;
__ZN12device_debugD1Ev = 8800;
__ZN12device_debug10breakpointC1ER12symbol_tableijPKcS4_ = 8802;
__ZN12device_debug10watchpointC1ER12symbol_tableiR13address_spaceijjPKcS6_ = 8804;
__ZN12device_debug6tracerC1ERS_R7__sFILEbPKc = 8806;
__ZN12device_debug6tracerD1Ev = 8808;
__ZN12device_debug12dasm_commentC1EPKcjjj = 8810;
__ZN12save_managerC1ER15running_machine = 8812;
__ZN12save_manager14state_callbackC1E8delegateIFvvEE = 8814;
__ZN12save_manager11state_entryC1EPvPKchj = 8816;
__ZN15running_machineC1ERK14machine_configR13osd_interfaceb = 8818;
__ZN15running_machineD1Ev = 8820;
__ZN13memory_regionC1ER15running_machinePKcjh12endianness_t = 8822;
__ZN13memory_regionD1Ev = 8824;
__ZN15running_machine22notifier_callback_itemC1E8delegateIFvvEE = 8826;
__ZN15running_machine22logerror_callback_itemC1EPFvRS_PKcE = 8828;
__ZN13driver_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_ = 8830;
__ZN13driver_deviceD1Ev = 8832;
__ZN11system_timeC1Ev = 8834;
__ZN13osd_interfaceD1Ev = 8836;
__ZN21render_primitive_listC1Ev = 8838;
__ZN21render_primitive_listD1Ev = 8840;
__ZN14render_textureC1Ev = 8842;
__ZN14render_textureD1Ev = 8844;
__ZN16render_containerC1ER14render_managerP13screen_device = 8846;
__ZN16render_containerD1Ev = 8848;
__ZN16render_container13user_settingsC1Ev = 8850;
__ZN13render_targetC1ER14render_managerPKcj = 8852;
__ZN13render_targetD1Ev = 8854;
__ZN14render_managerC1ER15running_machine = 8856;
__ZN14render_managerD1Ev = 8858;
__ZN13screen_deviceC1ERK14machine_configPKcP8device_tj = 8860;
__ZN13screen_deviceD1Ev = 8862;
__ZN9emu_timerC1Ev = 8864;
__ZN9emu_timerD1Ev = 8866;
__ZN16device_schedulerC1ER15running_machine = 8868;
__ZN16device_schedulerD1Ev = 8870;
__ZN13address_spaceD1Ev = 8872;
__ZN13address_tableD1Ev = 8874;
__ZN18address_table_readC1ER13address_spaceb = 8876;
__ZN18address_table_readD1Ev = 8878;
__ZN19address_table_writeC1ER13address_spaceb = 8880;
__ZN19address_table_writeD1Ev = 8882;
__ZN16direct_read_dataC1ER13address_space = 8884;
__ZN16direct_read_dataD1Ev = 8886;
__ZN12memory_blockC1ER13address_spacejjPv = 8888;
__ZN12memory_blockD1Ev = 8890;
__ZN11memory_bankC1ER13address_spaceijjPKc = 8892;
__ZN11memory_bankD1Ev = 8894;
__ZN13handler_entryD1Ev = 8896;
__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPKNS_11__list_nodeIS2_S3_EE = 8898;
__ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC1ESC_ = 8900;
__ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC1ESE_ = 8902;
__ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC1ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE = 8904;
__ZNSt3__121__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPKNS_11__tree_nodeIS8_PvEEiEC1ENS_15__tree_iteratorIS8_PSB_iEE = 8906;
__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC1EPNS_11__list_nodeIS2_S3_EE = 8908;
__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC1ENS_15__list_iteratorIS2_S3_EE = 8910;
__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED1Ev = 8912;
__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC1ERSG_ = 8914;
__ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEC1ERSC_ = 8916;
__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1EPSB_SE_ = 8918;
__ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ESC_SF_ = 8920;
__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC1ENS_4__rvISF_EE = 8922;
__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED1Ev = 8924;
__ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC1ERS7_j = 8926;
__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC1EPS5_S9_ = 8928;
__ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC1ES6_SA_ = 8930;
__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEC1ERKS8_ = 8932;
__ZNSt3__119__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEELb1EEC1ES8_ = 8934;
__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC1ERKSC_ = 8936;
__ZNSt3__117__compressed_pairIjNS_19__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEENS_4lessIhEELb1EEEEC1EjSA_ = 8938;
__ZNSt3__117__compressed_pairINS_15__tree_end_nodeIPNS_16__tree_node_baseIPvEEEENS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS7_ISC_EEEEEES3_EEEEEC1Ev = 8940;
__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC1Ev = 8942;
__ZNSt3__117__compressed_pairIjNS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC1Eji = 8944;
__ZNSt3__116__list_node_baseIN12_GLOBAL__N_18subrangeEPvEC1Ev = 8946;
__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED1Ev = 8948;
__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED2Ev = 8950;
__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED1Ev = 8952;
__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEED1Ev = 8954;
__ZNSt3__14pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEEED1Ev = 8956;
__ZN12_GLOBAL__N_18subrangeC1Ejj = 8958;
__ZN10cpu_deviceD1Ev = 8960;
__ZN17legacy_cpu_deviceD1Ev = 8962;
__ZN18device_state_entryC1EiPKcPvh = 8964;
__ZN22device_state_interfaceD1Ev = 8966;
__ZN18legacy_device_baseD1Ev = 8968;
__ZN24device_execute_interfaceD1Ev = 8970;
__ZN24device_execute_interface12device_inputC1Ev = 8972;
__ZN15cheat_parameterC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node = 8974;
__ZN12cheat_scriptC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node = 8976;
__ZN12cheat_script12script_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb = 8978;
__ZN12cheat_script12script_entry15output_argumentC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node = 8980;
__ZN11cheat_entryC1ER13cheat_managerR12symbol_tablePKcR14_xml_data_node = 8982;
__ZN11cheat_entryD1Ev = 8984;
__ZN13cheat_managerC1ER15running_machine = 8986;
__ZN12sound_streamC1ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE = 8988;
__ZN12sound_stream12stream_inputC1Ev = 8990;
__ZN12sound_stream13stream_outputC1Ev = 8992;
__ZN13sound_managerC1ER15running_machine = 8994;
__ZN13sound_managerD1Ev = 8996;
__ZN17driver_enumeratorC1ER11emu_options = 8998;
__ZN17driver_enumeratorC1ER11emu_optionsPKc = 9000;
__ZN17driver_enumeratorC1ER11emu_optionsRK11game_driver = 9002;
__ZN17driver_enumeratorD1Ev = 9004;
__ZN17driver_enumerator12config_entryC1ER14machine_configi = 9006;
__ZN17driver_enumerator12config_entryD1Ev = 9008;
__ZN14layout_elementC1ER15running_machineR14_xml_data_nodePKc = 9010;
__ZN14layout_elementD1Ev = 9012;
__ZN14layout_element7textureC1Ev = 9014;
__ZN14layout_element7textureD1Ev = 9016;
__ZN14layout_element9componentC1ER15running_machineR14_xml_data_nodePKc = 9018;
__ZN14layout_element9componentD1Ev = 9020;
__ZN11layout_viewC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE = 9022;
__ZN11layout_viewD1Ev = 9024;
__ZN11layout_view4itemC1ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE = 9026;
__ZN11layout_view4itemD1Ev = 9028;
__ZN11layout_fileC1ER15running_machineR14_xml_data_nodePKc = 9030;
__ZN11layout_fileD1Ev = 9032;
__ZN11render_fontC1ER14render_managerPKc = 9034;
__ZN11render_fontD1Ev = 9036;
__ZN12symbol_entryD1Ev = 9038;
__ZN20integer_symbol_entryC1ER12symbol_tablePKcNS0_10read_writeEPy = 9040;
__ZN20integer_symbol_entryC1ER12symbol_tablePKcPvPFyS1_S4_EPFvS1_S4_yE = 9042;
__ZN21function_symbol_entryC1ER12symbol_tablePKcPviiPFyS1_S4_iPKyE = 9044;
__ZN12symbol_tableC1EPvPS_ = 9046;
__ZN17parsed_expressionC1EP12symbol_tablePKcPy = 9048;
__ZN17parsed_expression11parse_tokenC1Ei = 9050;
__ZN13media_auditorC1ERK17driver_enumerator = 9052;
__ZN12audit_recordC1ERK9rom_entryNS_10media_typeE = 9054;
__ZN12audit_recordC1EPKcNS_10media_typeE = 9056;
__ZN13video_managerC1ER15running_machine = 9058;
__ZN8hash_crcC1Ev = 9060;
__ZN8hash_md5C1Ev = 9062;
__ZN9hash_sha1C1Ev = 9064;
__ZN15hash_collectionC1Ev = 9066;
__ZN15hash_collectionC1EPKc = 9068;
__ZN15hash_collectionD1Ev = 9070;
__ZN16info_xml_creatorC1ER17driver_enumerator = 9072;
__ZN17debug_view_sourceD1Ev = 9074;
__ZN22debug_view_source_listC1ER15running_machine = 9076;
__ZN22debug_view_source_listD1Ev = 9078;
__ZN10debug_viewD1Ev = 9080;
__ZN18debug_view_managerC1ER15running_machine = 9082;
__ZN18debug_view_managerD1Ev = 9084;
__ZN21debug_view_expressionC1ER15running_machine = 9086;
__ZN21debug_view_expressionD1Ev = 9088;
__ZN22device_sound_interfaceD1Ev = 9090;
__ZN23device_disasm_interfaceD1Ev = 9092;
__ZN24legacy_image_device_baseD1Ev = 9094;
__ZN13path_iteratorC1EPKc = 9096;
__ZN15file_enumeratorC1EPKc = 9098;
__ZN15file_enumeratorD1Ev = 9100;
__ZN8emu_fileC1Ej = 9102;
__ZN8emu_fileC1EPKcj = 9104;
__ZN8emu_fileD1Ev = 9106;
__ZN20dummy_profiler_stateC1Ev = 9108;
__ZN10ram_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 9110;
__ZN14speaker_deviceC1ERK14machine_configPKcP8device_tj = 9112;
__ZN14speaker_deviceD1Ev = 9114;
__ZN21cassette_image_deviceC1ERK14machine_configPKcP8device_tj = 9116;
__ZN21cassette_image_deviceD1Ev = 9118;
__ZN16bitbanger_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 9120;
__ZN16laserdisc_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 9122;
__ZN18debug_view_textbufD1Ev = 9124;
__ZN18debug_view_consoleC1ER15running_machinePFvR10debug_viewPvES4_ = 9126;
__ZN14debug_view_logC1ER15running_machinePFvR10debug_viewPvES4_ = 9128;
__ZN23debug_view_state_sourceC1EPKcR8device_t = 9130;
__ZN16debug_view_stateC1ER15running_machinePFvR10debug_viewPvES4_ = 9132;
__ZN16debug_view_stateD1Ev = 9134;
__ZN16debug_view_state10state_itemC1EiPKch = 9136;
__ZN24debug_view_disasm_sourceC1EPKcR8device_t = 9138;
__ZN17debug_view_disasmC1ER15running_machinePFvR10debug_viewPvES4_ = 9140;
__ZN17debug_view_disasmD1Ev = 9142;
__ZN24debug_view_memory_sourceC1EPKcR13address_space = 9144;
__ZN24debug_view_memory_sourceC1EPKcRK13memory_region = 9146;
__ZN24debug_view_memory_sourceC1EPKcPvii = 9148;
__ZN17debug_view_memoryC1ER15running_machinePFvR10debug_viewPvES4_ = 9150;
__ZN14ppi8255_deviceC1ERK14machine_configPKcP8device_tj = 9152;
__ZN13z80ctc_deviceC1ERK14machine_configPKcP8device_tj = 9154;
__ZN13z80ctc_device11ctc_channelC1Ev = 9156;
__ZN25devcb_resolved_write_lineC1Ev = 9158;
__ZN20devcb_resolved_read8C1Ev = 9160;
__ZN21devcb_resolved_write8C1Ev = 9162;
__ZN14samples_deviceC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j = 9164;
__ZN8bitmap_tC1Ev = 9166;
__ZN8bitmap_tC1Eii14_bitmap_formatii = 9168;
__ZN8bitmap_tC1EPviii14_bitmap_format = 9170;
__ZN8bitmap_tD1Ev = 9172;
__ZN7astringD1Ev = 9174;
__ZN12core_options5entryC1ERK13options_entry = 9176;
__ZN12core_optionsD1Ev = 9178;
__ZNSt3__18ios_base4InitC1Ev = 9180;
__ZNSt3__18ios_base4InitD1Ev = 9182;
__ZNSt3__114__shared_countD1Ev = 9184;
__ZNSt11logic_errorD1Ev = 9186;
__ZNSt13runtime_errorC1EPKc = 9188;
__ZNSt13runtime_errorD1Ev = 9190;
__ZNSt12length_errorD1Ev = 9192;
__ZNSt12length_errorD2Ev = 9186;
__ZN12_GLOBAL__N_114__libcpp_nmstrD1Ev = 9194;
__ZN12_GLOBAL__N_114__libcpp_nmstrC1EPKc = 9196;
__ZNSt3__114error_categoryD1Ev = 9198;
__ZNSt3__112system_errorD1Ev = 9200;
__ZNSt9exceptionD1Ev = 9202;
__ZNSt3__18ios_base7failureC1EPKcRKNS_10error_codeE = 9204;
__ZNSt3__18ios_base7failureD1Ev = 9206;
__ZNSt3__18ios_baseD1Ev = 9208;
__ZNSt3__16locale5__impC1Ej = 9210;
__ZNSt3__16locale5__impD1Ev = 9212;
__ZNSt3__16localeC1Ev = 9214;
__ZNSt3__16localeC1ERKS0_ = 9216;
__ZNSt3__16localeD1Ev = 9218;
__ZNSt3__16locale5facetD1Ev = 9220;
__ZNSt3__15ctypeIwED1Ev = 9222;
__ZNSt3__15ctypeIwED2Ev = 9220;
__ZNSt3__15ctypeIcEC1EPKjbj = 9224;
__ZNSt3__15ctypeIcED1Ev = 9226;
__ZNSt3__17codecvtIcc10_mbstate_tED1Ev = 9228;
__ZNSt3__17codecvtIcc10_mbstate_tED2Ev = 9220;
__ZNSt3__17codecvtIwc10_mbstate_tEC1Ej = 9230;
__ZNSt3__17codecvtIwc10_mbstate_tED1Ev = 9232;
__ZNSt3__17codecvtItc10_mbstate_tED1Ev = 9234;
__ZNSt3__17codecvtItc10_mbstate_tED2Ev = 9220;
__ZNSt3__17codecvtIjc10_mbstate_tED1Ev = 9236;
__ZNSt3__17codecvtIjc10_mbstate_tED2Ev = 9220;
__ZNSt3__116__narrow_to_utf8ILj32EED1Ev = 9238;
__ZNSt3__116__narrow_to_utf8ILj32EED2Ev = 9236;
__ZNSt3__117__widen_from_utf8ILj32EED1Ev = 9240;
__ZNSt3__117__widen_from_utf8ILj32EED2Ev = 9236;
__ZNSt3__18numpunctIcEC1Ej = 9242;
__ZNSt3__18numpunctIwEC1Ej = 9244;
__ZNSt3__18numpunctIcED1Ev = 9246;
__ZNSt3__18numpunctIwED1Ev = 9248;
__ZNSt3__117__call_once_paramINS_12_GLOBAL__N_111__fake_bindEEC1ERKS2_ = 9250;
__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED1Ev = 9252;
__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEEC1EPS2_ = 9254;
__ZNSt3__117__compressed_pairIPNS_6locale5facetENS_12_GLOBAL__N_17releaseEEC1ES3_i = 9256;
__ZNSt3__112_GLOBAL__N_111__fake_bindC1EMNS_6locale2idEFvvEPS3_ = 9258;
__ZNSt8bad_castC1Ev = 9260;
__ZNSt8bad_castD1Ev = 9262;
__ZN10__cxxabiv117__class_type_infoD1Ev = 9264;
__ZN10__cxxabiv117__class_type_infoD2Ev = 9266;
__ZN10__cxxabiv120__si_class_type_infoD1Ev = 9268;
__ZN10__cxxabiv120__si_class_type_infoD2Ev = 9264;
__ZN10__cxxabiv121__vmi_class_type_infoD1Ev = 9270;
__ZN10__cxxabiv121__vmi_class_type_infoD2Ev = 9264;
__ZNSt9bad_allocC1Ev = 9272;
__ZNSt9bad_allocD1Ev = 9274;
FUNCTION_TABLE = [0,0,__ZNSt9bad_allocD2Ev,0,__Z21driver_device_creatorI13driver_deviceEP8device_tRK14machine_configPKcS2_j,0,__Z21driver_device_creatorI12coleco_stateEP8device_tRK14machine_configPKcS2_j,0,__ZL32construct_address_map_coleco_mapR11address_mapRK8device_t,0,__ZL35construct_address_map_coleco_io_mapR11address_mapRK8device_t,0,__ZL16coleco_interruptP8device_t,0,__ZL15paddle_callbackR12timer_devicePvi,0,__ZN14emu_fatalerrorD1Ev,0,__ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI12coleco_stateEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI12coleco_stateEEP22delegate_generic_classR18delegate_late_bind,0,__ZN12coleco_state12paddle_off_wER13address_spacejhh,0,__ZN12coleco_state11paddle_on_wER13address_spacejhh,0,__ZN12coleco_state10paddle_1_rER13address_spacejh,0,__ZN12coleco_state10paddle_2_rER13address_spacejh,0,__Z15TMS9928A_vram_rP13address_spacej,0,__Z15TMS9928A_vram_wP13address_spacejh,0,__Z19TMS9928A_register_rP13address_spacej,0,__Z19TMS9928A_register_wP13address_spacejh,0,__ZL20cpu_init_mcs48_noromP17legacy_cpu_devicePFiP8device_tiE,0,__ZL21cpu_init_mcs48_4k_romP17legacy_cpu_devicePFiP8device_tiE,0,__Z21cpu_disassemble_upi41P17legacy_cpu_devicePcjPKhS3_i,0,__Z21cpu_disassemble_mcs48P17legacy_cpu_devicePcjPKhS3_i,0,__ZL35construct_address_map_program_10bitR11address_mapRK8device_t,0,__ZL35construct_address_map_program_11bitR11address_mapRK8device_t,0,__ZL35construct_address_map_program_12bitR11address_mapRK8device_t,0,__ZL31construct_address_map_data_6bitR11address_mapRK8device_t,0,__ZL31construct_address_map_data_7bitR11address_mapRK8device_t,0,__ZL31construct_address_map_data_8bitR11address_mapRK8device_t,0,__ZL21cpu_init_upi41_1k_romP17legacy_cpu_devicePFiP8device_tiE,0,__ZL21cpu_init_mcs48_1k_romP17legacy_cpu_devicePFiP8device_tiE,0,__ZL21cpu_init_upi41_2k_romP17legacy_cpu_devicePFiP8device_tiE,0,__ZL21cpu_init_mcs48_2k_romP17legacy_cpu_devicePFiP8device_tiE,0,__Z21legacy_device_creatorI12i8748_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZL18keyboard_get_statePvS_,0,__Z18cpu_get_info_i8748P17legacy_cpu_devicejP7cpuinfo,0,__Z21legacy_device_creatorI12i8049_deviceEP8device_tRK14machine_configPKcS2_j,0,__Z18cpu_get_info_i8049P17legacy_cpu_devicejP7cpuinfo,0,__ZL18cpu_set_info_mcs48P17legacy_cpu_devicejP7cpuinfo,0,__ZL15cpu_reset_mcs48P17legacy_cpu_device,0,__ZL17cpu_execute_mcs48P17legacy_cpu_device,0,__ZL22cpu_state_import_mcs48P17legacy_cpu_deviceRK18device_state_entry,0,__ZL22cpu_state_export_mcs48P17legacy_cpu_deviceRK18device_state_entry,0,__ZL23cpu_string_export_mcs48P17legacy_cpu_deviceRK18device_state_entryR7astring,0,__ZN13delegate_baseIvPvi8_noparamS1_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind,0,__ZL16cpu_set_info_z80P17legacy_cpu_devicejP7cpuinfo,0,__ZL12cpu_init_z80P17legacy_cpu_devicePFiP8device_tiE,0,__ZL13cpu_reset_z80P17legacy_cpu_device,0,__ZL12cpu_exit_z80P17legacy_cpu_device,0,__ZL15cpu_execute_z80P17legacy_cpu_device,0,__Z19cpu_disassemble_z80P17legacy_cpu_devicePcjPKhS3_i,0,__ZL20cpu_state_import_z80P17legacy_cpu_deviceRK18device_state_entry,0,__ZL20cpu_state_export_z80P17legacy_cpu_deviceRK18device_state_entry,0,__ZL21cpu_string_export_z80P17legacy_cpu_deviceRK18device_state_entryR7astring,0,__Z21legacy_device_creatorI10z80_deviceEP8device_tRK14machine_configPKcS2_j,0,__Z16cpu_get_info_z80P17legacy_cpu_devicejP7cpuinfo,0,__ZL15input_port_exitR15running_machine,0,__ZL21frame_update_callbackR15running_machine,0,__ZL20load_config_callbackR15running_machineiP14_xml_data_node,0,__ZL20save_config_callbackR15running_machineiP14_xml_data_node,0,__ZL13execute_inputR15running_machineiiPPKc,0,__ZL15execute_dumpkbdR15running_machineiiPPKc,0,__ZL16inputx_timerprocR15running_machinePvi,0,__ZL15clear_keybufferR15running_machine,0,__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind,0,__Z25mame_file_output_callbackPvPKcPc,0,__Z25mame_null_output_callbackPvPKcPc,0,__Z22screen_update_tms9928aP13screen_deviceP8bitmap_tPK10_rectangle,0,__ZL21palette_init_tms9928aR15running_machinePKh,0,__Z20video_start_tms9928aR15running_machine,0,__ZL21device_start_cartslotP8device_t,0,__ZL20device_load_cartslotR22device_image_interface,0,__ZL22device_unload_cartslotR22device_image_interface,0,__ZL33device_image_get_devices_cartslotR22device_image_interface,0,__ZL29device_softlist_load_cartslotR22device_image_interfacePcS1_P9rom_entry,0,__Z21legacy_device_creatorI15cartslot_deviceEP8device_tRK14machine_configPKcS2_j,0,__Z26device_get_config_cartslotPK8device_tjP10deviceinfo,0,__ZL12expat_mallocj,0,__ZL13expat_reallocPvj,0,__ZL10expat_freePv,0,__ZL13start_handlerPvPKcPS1_,0,__ZL11end_handlerPvPKc,0,__ZL12data_handlerPvPKci,0,__ZL26device_start_software_listP8device_t,0,__ZL35device_validity_check_software_listPK11game_driverPK8device_tR11emu_options,0,__Z21legacy_device_creatorI20software_list_deviceEP8device_tRK14machine_configPKcS2_j,0,__Z31device_get_config_software_listPK8device_tjP10deviceinfo,0,__ZN13resource_poolD2Ev,0,__ZN11device_list9reset_allEv,0,__ZN11device_list4exitEv,0,__ZN11device_list11presave_allEv,0,__ZN11device_list12postload_allEv,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI11device_listEEP22delegate_generic_classR18delegate_late_bind,0,__ZN11input_class14frame_callbackEv,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI11input_classEEP22delegate_generic_classR18delegate_late_bind,0,__ZL10get_cpunumR12symbol_tablePv,0,__ZL9get_beamxR12symbol_tablePv,0,__ZL9get_beamyR12symbol_tablePv,0,__ZL9get_frameR12symbol_tablePv,0,__ZL9on_vblankR15running_machineR13screen_deviceb,0,__ZL14debug_cpu_exitR15running_machine,0,__ZL19expression_validatePvPKc16expression_space,0,__ZL22expression_read_memoryPvPKc16expression_spaceji,0,__ZL23expression_write_memoryPvPKc16expression_spacejiy,0,__ZN13emu_exceptionD1Ev,0,__ZN12device_debug10get_cyclesER12symbol_tablePv,0,__ZN12device_debug12get_logunmapER12symbol_tablePv,0,__ZN12device_debug12set_logunmapER12symbol_tablePvy,0,__ZN12device_debug9get_stateER12symbol_tablePv,0,__ZN12device_debug9set_stateER12symbol_tablePvy,0,__ZN12device_debug14get_current_pcER12symbol_tablePv,0,__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind,0,__Z10popmessagePKcz,0,__ZN15running_machine10soft_resetEPvi,0,__ZN15running_machine16logfile_callbackERS_PKc,0,__ZN27device_missing_dependenciesD1Ev,0,__ZN16render_container13overlay_scaleER8bitmap_tRKS0_RK10_rectanglePv,0,__ZN14render_manager11config_loadEiP14_xml_data_node,0,__ZN14render_manager11config_saveEiP14_xml_data_node,0,__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI14render_managerEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13screen_device28static_vblank_begin_callbackER15running_machinePvi,0,__ZN13screen_device26static_vblank_end_callbackER15running_machinePvi,0,__ZN13screen_device25static_scanline0_callbackER15running_machinePvi,0,__ZN13screen_device31static_scanline_update_callbackER15running_machinePvi,0,__ZN16device_scheduler7presaveEv,0,__ZN16device_scheduler8postloadEv,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI16device_schedulerEEP22delegate_generic_classR18delegate_late_bind,0,__ZL13bank_reattachR15running_machine,0,__ZN18address_table_read7unmap_rIhEET_R13address_spacejS1_,0,__ZN18address_table_read5nop_rIhEET_R13address_spacejS1_,0,__ZN18address_table_read12watchpoint_rIhEET_R13address_spacejS1_,0,__ZN18address_table_read7unmap_rItEET_R13address_spacejS1_,0,__ZN18address_table_read5nop_rItEET_R13address_spacejS1_,0,__ZN18address_table_read12watchpoint_rItEET_R13address_spacejS1_,0,__ZN18address_table_read7unmap_rIjEET_R13address_spacejS1_,0,__ZN18address_table_read5nop_rIjEET_R13address_spacejS1_,0,__ZN18address_table_read12watchpoint_rIjEET_R13address_spacejS1_,0,__ZN18address_table_read7unmap_rIyEET_R13address_spacejS1_,0,__ZN18address_table_read5nop_rIyEET_R13address_spacejS1_,0,__ZN18address_table_read12watchpoint_rIyEET_R13address_spacejS1_,0,__ZN18handler_entry_read12read_stub_16ER13address_spacejt,0,__ZN18handler_entry_read12read_stub_32ER13address_spacejj,0,__ZN18handler_entry_read12read_stub_64ER13address_spacejy,0,__ZN19address_table_write7unmap_wIhEEvR13address_spacejT_S3_,0,__ZN19address_table_write5nop_wIhEEvR13address_spacejT_S3_,0,__ZN19address_table_write12watchpoint_wIhEEvR13address_spacejT_S3_,0,__ZN19address_table_write7unmap_wItEEvR13address_spacejT_S3_,0,__ZN19address_table_write5nop_wItEEvR13address_spacejT_S3_,0,__ZN19address_table_write12watchpoint_wItEEvR13address_spacejT_S3_,0,__ZN19address_table_write7unmap_wIjEEvR13address_spacejT_S3_,0,__ZN19address_table_write5nop_wIjEEvR13address_spacejT_S3_,0,__ZN19address_table_write12watchpoint_wIjEEvR13address_spacejT_S3_,0,__ZN19address_table_write7unmap_wIyEEvR13address_spacejT_S3_,0,__ZN19address_table_write5nop_wIyEEvR13address_spacejT_S3_,0,__ZN19address_table_write12watchpoint_wIyEEvR13address_spacejT_S3_,0,__ZN19handler_entry_write13write_stub_16ER13address_spacejtt,0,__ZN19handler_entry_write13write_stub_32ER13address_spacejjj,0,__ZN19handler_entry_write13write_stub_64ER13address_spacejyy,0,__ZN18handler_entry_read16read_stub_legacyER13address_spacejh,0,__ZN18handler_entry_read16read_stub_legacyER13address_spacejt,0,__ZN18handler_entry_read16read_stub_legacyER13address_spacejj,0,__ZN18handler_entry_read16read_stub_legacyER13address_spacejy,0,__ZN18handler_entry_read16read_stub_ioportIhEET_R13address_spacejS1_,0,__ZN18handler_entry_read16read_stub_ioportItEET_R13address_spacejS1_,0,__ZN18handler_entry_read16read_stub_ioportIjEET_R13address_spacejS1_,0,__ZN18handler_entry_read16read_stub_ioportIyEET_R13address_spacejS1_,0,__ZN19handler_entry_write17write_stub_legacyER13address_spacejhh,0,__ZN19handler_entry_write17write_stub_legacyER13address_spacejtt,0,__ZN19handler_entry_write17write_stub_legacyER13address_spacejjj,0,__ZN19handler_entry_write17write_stub_legacyER13address_spacejyy,0,__ZN19handler_entry_write17write_stub_ioportIhEEvR13address_spacejT_S3_,0,__ZN19handler_entry_write17write_stub_ioportItEEvR13address_spacejT_S3_,0,__ZN19handler_entry_write17write_stub_ioportIjEEvR13address_spacejT_S3_,0,__ZN19handler_entry_write17write_stub_ioportIyEEvR13address_spacejT_S3_,0,__ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejyyE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejjjE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejttE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIyR13address_spacejy8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIjR13address_spacejj8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseItR13address_spacejt8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejyyE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejjjE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejttE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIyR13address_spacejy8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIjR13address_spacejj8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseItR13address_spacejt8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificItL12endianness_t1ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificItL12endianness_t1ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificItL12endianness_t0ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificItL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificItL12endianness_t0ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE16read_byte_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE16read_word_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE17read_dword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE17read_qword_staticEPS1_j,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE17write_byte_staticEPS1_jh,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE17write_word_staticEPS1_jt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE18write_dword_staticEPS1_jj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE18write_qword_staticEPS1_jy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy,0,__ZN24device_execute_interface28static_standard_irq_callbackEP8device_ti,0,__ZN24device_execute_interface38static_trigger_partial_frame_interruptER15running_machinePvi,0,__ZN24device_execute_interface33static_trigger_periodic_interruptER15running_machinePvi,0,__ZN24device_execute_interface9on_vblankER13screen_deviceb,0,__ZN24device_execute_interface12device_input24static_empty_event_queueER15running_machinePvi,0,__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI24device_execute_interfaceEEP22delegate_generic_classR18delegate_late_bind,0,__ZL22machine_start____emptyR15running_machine,0,__ZN13cheat_manager12frame_updateEv,0,__ZN13cheat_manager15execute_frombcdER12symbol_tablePviPKy,0,__ZN13cheat_manager13execute_tobcdER12symbol_tablePviPKy,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13cheat_managerEEP22delegate_generic_classR18delegate_late_bind,0,__ZN12sound_stream8postloadEv,0,__ZN12sound_stream25device_stream_update_stubEP8device_tPS_PvPPiS5_i,0,__ZN13sound_manager11config_loadEiP14_xml_data_node,0,__ZN13sound_manager11config_saveEiP14_xml_data_node,0,__ZN13sound_manager5pauseEv,0,__ZN13sound_manager6resumeEv,0,__ZN13sound_manager5resetEv,0,__ZN13sound_manager13update_staticER15running_machinePvi,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13sound_managerEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI13sound_managerEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI12sound_streamEEP22delegate_generic_classR18delegate_late_bind,0,__ZL15interrupt_resetR15running_machine,0,__ZL13counters_loadR15running_machineiP14_xml_data_node,0,__ZL13counters_saveR15running_machineiP14_xml_data_node,0,__Z13memcard_ejectR15running_machine,0,__ZL12output_pauseR15running_machine,0,__ZL13output_resumeR15running_machine,0,__ZL11output_exitR15running_machine,0,__ZL12palette_exitR15running_machine,0,__ZL15palette_presaveR15running_machine,0,__ZL16palette_postloadR15running_machine,0,__Z16image_unload_allR15running_machine,0,__ZL15image_dirs_loadR15running_machineiP14_xml_data_node,0,__ZL15image_dirs_saveR15running_machineiP14_xml_data_node,0,__ZL12tilemap_exitR15running_machine,0,__ZL25scanline_draw_masked_nullPvPKtPKhiiiPKjPhjh,0,__ZL25scanline_draw_opaque_nullPvPKtiPKjPhjh,0,__ZL26scanline_draw_masked_ind16PvPKtPKhiiiPKjPhjh,0,__ZL26scanline_draw_opaque_ind16PvPKtiPKjPhjh,0,__ZL32scanline_draw_masked_rgb32_alphaPvPKtPKhiiiPKjPhjh,0,__ZL26scanline_draw_masked_rgb32PvPKtPKhiiiPKjPhjh,0,__ZL32scanline_draw_opaque_rgb32_alphaPvPKtiPKjPhjh,0,__ZL26scanline_draw_opaque_rgb32PvPKtiPKjPhjh,0,__ZL32scanline_draw_masked_rgb16_alphaPvPKtPKhiiiPKjPhjh,0,__ZL26scanline_draw_masked_rgb16PvPKtPKhiiiPKjPhjh,0,__ZL32scanline_draw_opaque_rgb16_alphaPvPKtiPKjPhjh,0,__ZL26scanline_draw_opaque_rgb16PvPKtiPKjPhjh,0,__ZL13debugger_exitR15running_machine,0,__Z42debugger_flush_all_traces_on_abnormal_exitv,0,__Z25debug_errorlog_write_lineR15running_machinePKc,0,__ZL8rom_exitR15running_machine,0,__Z21ui_input_frame_updateR15running_machine,0,__ZL14handler_ingameR15running_machineP16render_containerj,0,__ZN7astringD2Ev,0,__ZL7ui_exitR15running_machine,0,__ZL18handler_messageboxR15running_machineP16render_containerj,0,__ZL21handler_messagebox_okR15running_machineP16render_containerj,0,__ZL25handler_messagebox_anykeyR15running_machineP16render_containerj,0,__Z18ui_menu_ui_handlerR15running_machineP16render_containerj,0,__ZL13slider_volumeR15running_machinePvP7astringi,0,__ZL15slider_mixervolR15running_machinePvP7astringi,0,__ZL15slider_adjusterR15running_machinePvP7astringi,0,__ZL16slider_overclockR15running_machinePvP7astringi,0,__ZL14slider_refreshR15running_machinePvP7astringi,0,__ZL17slider_brightnessR15running_machinePvP7astringi,0,__ZL15slider_contrastR15running_machinePvP7astringi,0,__ZL12slider_gammaR15running_machinePvP7astringi,0,__ZL13slider_xscaleR15running_machinePvP7astringi,0,__ZL14slider_xoffsetR15running_machinePvP7astringi,0,__ZL13slider_yscaleR15running_machinePvP7astringi,0,__ZL14slider_yoffsetR15running_machinePvP7astringi,0,__ZL17slider_overxscaleR15running_machinePvP7astringi,0,__ZL18slider_overxoffsetR15running_machinePvP7astringi,0,__ZL17slider_overyscaleR15running_machinePvP7astringi,0,__ZL18slider_overyoffsetR15running_machinePvP7astringi,0,__ZL14slider_flickerR15running_machinePvP7astringi,0,__ZL11slider_beamR15running_machinePvP7astringi,0,__ZL20handler_confirm_quitR15running_machineP16render_containerj,0,__Z20ui_slider_ui_handlerR15running_machineP16render_containerj,0,__Z17ui_gfx_ui_handlerR15running_machineP16render_containerj,0,__ZL17handler_load_saveR15running_machineP16render_containerj,0,__ZL17watchdog_callbackR15running_machinePvi,0,__ZL23watchdog_internal_resetR15running_machine,0,__ZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePv,0,__ZL9on_vblankR15running_machineR13screen_deviceb4048,0,__ZL14crosshair_exitR15running_machine,0,__ZL14crosshair_loadR15running_machineiP14_xml_data_node,0,__ZL14crosshair_saveR15running_machineiP14_xml_data_node,0,__ZL7animateR15running_machineR13screen_deviceb,0,__ZL18debug_console_exitR15running_machine,0,__ZL20menu_render_triangleR8bitmap_tRKS_RK10_rectanglePv,0,__ZL12ui_menu_exitR15running_machine,0,__ZL14menu_quit_gameR15running_machineP7ui_menuPvS3_,0,__ZL12menu_slidersR15running_machineP7ui_menuPvS3_,0,__ZL9menu_mainR15running_machineP7ui_menuPvS3_,0,__ZL16menu_select_gameR15running_machineP7ui_menuPvS3_,0,__ZL17menu_input_groupsR15running_machineP7ui_menuPvS3_,0,__ZL30menu_select_game_custom_renderR15running_machineP7ui_menuPvS3_ffffff,0,__ZL18menu_input_generalR15running_machineP7ui_menuPvS3_,0,__ZL24menu_input_compare_itemsPKvS0_,0,__ZL26menu_sliders_custom_renderR15running_machineP7ui_menuPvS3_ffffff,0,__ZL18menu_video_targetsR15running_machineP7ui_menuPvS3_,0,__ZL18menu_video_optionsR15running_machineP7ui_menuPvS3_,0,__ZL19menu_input_specificR15running_machineP7ui_menuPvS3_,0,__ZL26menu_settings_dip_switchesR15running_machineP7ui_menuPvS3_,0,__ZL27menu_settings_driver_configR15running_machineP7ui_menuPvS3_,0,__ZL24menu_settings_categoriesR15running_machineP7ui_menuPvS3_,0,__ZL11menu_analogR15running_machineP7ui_menuPvS3_,0,__ZL16menu_bookkeepingR15running_machineP7ui_menuPvS3_,0,__ZL14menu_game_infoR15running_machineP7ui_menuPvS3_,0,__Z24ui_image_menu_image_infoR15running_machineP7ui_menuPvS3_,0,__Z26ui_image_menu_file_managerR15running_machineP7ui_menuPvS3_,0,__Z25ui_mess_menu_tape_controlR15running_machineP7ui_menuPvS3_,0,__Z30ui_mess_menu_bitbanger_controlR15running_machineP7ui_menuPvS3_,0,__ZL20ui_menu_slot_devicesR15running_machineP7ui_menuPvS3_,0,__ZL21ui_menu_keyboard_modeR15running_machineP7ui_menuPvS3_,0,__ZL14menu_crosshairR15running_machineP7ui_menuPvS3_,0,__ZL10menu_cheatR15running_machineP7ui_menuPvS3_,0,__ZL16menu_memory_cardR15running_machineP7ui_menuPvS3_,0,__ZL27menu_settings_custom_renderR15running_machineP7ui_menuPvS3_ffffff,0,__ZL13debugint_exitR15running_machine,0,__ZL24on_view_opcodes_activateP5DViewPK14_ui_menu_event,0,__ZL25on_run_to_cursor_activateP5DViewPK14_ui_menu_event,0,__ZL22on_disasm_cpu_activateP5DViewPK14_ui_menu_event,0,__ZL25on_memory_window_activateP5DViewPK14_ui_menu_event,0,__ZL30on_disassembly_window_activateP5DViewPK14_ui_menu_event,0,__ZL22on_log_window_activateP5DViewPK14_ui_menu_event,0,__ZL15on_run_activateP5DViewPK14_ui_menu_event,0,__ZL19on_run_cpu_activateP5DViewPK14_ui_menu_event,0,__ZL19on_run_irq_activateP5DViewPK14_ui_menu_event,0,__ZL19on_run_vbl_activateP5DViewPK14_ui_menu_event,0,__ZL21on_step_into_activateP5DViewPK14_ui_menu_event,0,__ZL21on_step_over_activateP5DViewPK14_ui_menu_event,0,__ZL22on_soft_reset_activateP5DViewPK14_ui_menu_event,0,__ZL22on_hard_reset_activateP5DViewPK14_ui_menu_event,0,__ZL17on_close_activateP5DViewPK14_ui_menu_event,0,__ZL16on_exit_activateP5DViewPK14_ui_menu_event,0,__ZL12dview_updateR10debug_viewPv,0,__ZN11driver_list20driver_sort_callbackEPKvS1_,0,__ZN18render_screen_listD1Ev,0,__ZN14layout_element13element_scaleER8bitmap_tRKS0_RK10_rectanglePv,0,__ZN20integer_symbol_entry15internal_getterER12symbol_tablePv,0,__ZN20integer_symbol_entry15internal_setterER12symbol_tablePvy,0,__ZN13video_manager4exitEv,0,__ZN13video_manager8postloadEv,0,__ZN13video_manager26screenless_update_callbackEPvi,0,__ZN13delegate_baseIvPvi8_noparamS1_E16late_bind_helperI13video_managerEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13video_managerEEP22delegate_generic_classR18delegate_late_bind,0,__ZL16device_start_ramP8device_t,0,__ZL25device_validity_check_ramPK11game_driverPK8device_tR11emu_options,0,__Z21legacy_device_creatorI10ram_deviceEP8device_tRK14machine_configPKcS2_j,0,__Z21device_get_config_ramPK8device_tjP10deviceinfo,0,__ZL11ui_gfx_exitR15running_machine,0,__ZL22device_start_bitbangerP8device_t,0,__ZL21device_load_bitbangerR22device_image_interface,0,__ZL23device_unload_bitbangerR22device_image_interface,0,__Z21legacy_device_creatorI16bitbanger_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZL22bitbanger_output_timerR15running_machinePvi,0,__ZL21bitbanger_input_timerR15running_machinePvi,0,__Z27device_get_config_bitbangerPK8device_tjP10deviceinfo,0,__ZL22device_start_laserdiscP8device_t,0,__ZL21device_stop_laserdiscP8device_t,0,__ZL22device_reset_laserdiscP8device_t,0,__Z21legacy_device_creatorI16laserdisc_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZL18configuration_loadR15running_machineiP14_xml_data_node,0,__ZL18configuration_saveR15running_machineiP14_xml_data_node,0,__Z27device_get_config_laserdiscPK8device_tjP10deviceinfo,0,__ZL20vblank_state_changedP8device_tR13screen_deviceb,0,__ZL21perform_player_updateR15running_machinePvi,0,__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind,0,__ZL11execute_minR12symbol_tablePviPKy,0,__ZL11execute_maxR12symbol_tablePviPKy,0,__ZL10execute_ifR12symbol_tablePviPKy,0,__ZL10global_getR12symbol_tablePv,0,__ZL10global_setR12symbol_tablePvy,0,__ZL12execute_helpR15running_machineiiPPKc,0,__ZL13execute_printR15running_machineiiPPKc,0,__ZL14execute_printfR15running_machineiiPPKc,0,__ZL16execute_logerrorR15running_machineiiPPKc,0,__ZL16execute_tracelogR15running_machineiiPPKc,0,__ZL12execute_quitR15running_machineiiPPKc,0,__ZL10execute_doR15running_machineiiPPKc,0,__ZL12execute_stepR15running_machineiiPPKc,0,__ZL12execute_overR15running_machineiiPPKc,0,__ZL11execute_outR15running_machineiiPPKc,0,__ZL10execute_goR15running_machineiiPPKc,0,__ZL17execute_go_vblankR15running_machineiiPPKc,0,__ZL20execute_go_interruptR15running_machineiiPPKc,0,__ZL15execute_go_timeR15running_machineiiPPKc,0,__ZL12execute_nextR15running_machineiiPPKc,0,__ZL13execute_focusR15running_machineiiPPKc,0,__ZL14execute_ignoreR15running_machineiiPPKc,0,__ZL15execute_observeR15running_machineiiPPKc,0,__ZL15execute_commentR15running_machineiiPPKc,0,__ZL19execute_comment_delR15running_machineiiPPKc,0,__ZL20execute_comment_saveR15running_machineiiPPKc,0,__ZL13execute_bpsetR15running_machineiiPPKc,0,__ZL15execute_bpclearR15running_machineiiPPKc,0,__ZL19execute_bpdisenableR15running_machineiiPPKc,0,__ZL14execute_bplistR15running_machineiiPPKc,0,__ZL13execute_wpsetR15running_machineiiPPKc,0,__ZL15execute_wpclearR15running_machineiiPPKc,0,__ZL19execute_wpdisenableR15running_machineiiPPKc,0,__ZL14execute_wplistR15running_machineiiPPKc,0,__ZL15execute_hotspotR15running_machineiiPPKc,0,__ZL12execute_saveR15running_machineiiPPKc,0,__ZL12execute_loadR15running_machineiiPPKc,0,__ZL12execute_dumpR15running_machineiiPPKc,0,__ZL17execute_cheatinitR15running_machineiiPPKc,0,__ZL17execute_cheatnextR15running_machineiiPPKc,0,__ZL17execute_cheatlistR15running_machineiiPPKc,0,__ZL17execute_cheatundoR15running_machineiiPPKc,0,__ZL12execute_findR15running_machineiiPPKc,0,__ZL12execute_dasmR15running_machineiiPPKc,0,__ZL13execute_traceR15running_machineiiPPKc,0,__ZL17execute_traceoverR15running_machineiiPPKc,0,__ZL18execute_traceflushR15running_machineiiPPKc,0,__ZL15execute_historyR15running_machineiiPPKc,0,__ZL12execute_snapR15running_machineiiPPKc,0,__ZL14execute_sourceR15running_machineiiPPKc,0,__ZL11execute_mapR15running_machineiiPPKc,0,__ZL15execute_memdumpR15running_machineiiPPKc,0,__ZL15execute_symlistR15running_machineiiPPKc,0,__ZL17execute_softresetR15running_machineiiPPKc,0,__ZL17execute_hardresetR15running_machineiiPPKc,0,__ZL14execute_imagesR15running_machineiiPPKc,0,__ZL13execute_mountR15running_machineiiPPKc,0,__ZL15execute_unmountR15running_machineiiPPKc,0,__ZL18debug_command_exitR15running_machine,0,__ZL19symbol_sort_comparePKvS0_,0,__ZL25file_manager_render_extraR15running_machineP7ui_menuPvS3_ffffff,0,__ZL26file_manager_destroy_stateP7ui_menuPv,0,__ZL18menu_file_selectorR15running_machineP7ui_menuPvS3_,0,__ZL16menu_file_createR15running_machineP7ui_menuPvS3_,0,__Z22ui_image_menu_softwareR15running_machineP7ui_menuPvS3_,0,__ZL24file_create_render_extraR15running_machineP7ui_menuPvS3_ffffff,0,__ZL26file_selector_render_extraR15running_machineP7ui_menuPvS3_ffffff,0,__ZL22is_valid_filename_charj,0,__ZL20menu_confirm_save_asR15running_machineP7ui_menuPvS3_,0,__ZL33construct_address_map_ldv1000_mapR11address_mapRK8device_t,0,__ZL37construct_address_map_ldv1000_portmapR11address_mapRK8device_t,0,__ZL15multijump_timerR12timer_devicePvi,0,__ZL9vsync_offR15running_machinePvi,0,__ZL14vbi_data_fetchR15running_machinePvi,0,__Z9ppi8255_rP8device_tj,0,__Z9ppi8255_wP8device_tjh,0,__ZL22decoder_display_port_rP13address_spacej,0,__ZL22decoder_display_port_wP13address_spacejh,0,__ZL12controller_rP13address_spacej,0,__ZL12controller_wP13address_spacejh,0,__Z8z80ctc_rP8device_tj,0,__Z8z80ctc_wP8device_tjh,0,__Z27ui_mess_menu_software_partsR15running_machineP7ui_menuPvS3_,0,__ZL36construct_address_map_pr8210_portmapR11address_mapRK8device_t,0,__Z26ui_mess_menu_software_listR15running_machineP7ui_menuPvS3_,0,__ZL38construct_address_map_simutrek_portmapR11address_mapRK8device_t,0,__ZL9vsync_offR15running_machinePvi6076,0,__ZL14vbi_data_fetchR15running_machinePvi6077,0,__ZL7irq_offR15running_machinePvi,0,__ZL23simutrek_latched_data_wR15running_machinePvi,0,__ZL15simutrek_data_rP13address_spacej,0,__ZL16simutrek_port2_rP13address_spacej,0,__ZL16simutrek_port2_wP13address_spacejh,0,__ZL13simutrek_t0_rP13address_spacej,0,__ZL12pr8210_pia_rP13address_spacej,0,__ZL12pr8210_pia_wP13address_spacejh,0,__ZL12pr8210_bus_rP13address_spacej,0,__ZL14pr8210_port1_wP13address_spacejh,0,__ZL14pr8210_port2_wP13address_spacejh,0,__ZL11pr8210_t0_rP13address_spacej,0,__ZL11pr8210_t1_rP13address_spacej,0,__ZL35construct_address_map_vp931_portmapR11address_mapRK8device_t,0,__ZL11track_timerR12timer_devicePvi,0,__ZL7erp_offR15running_machinePvi,0,__ZL14vbi_data_fetchR15running_machinePvi6106,0,__ZL15deferred_data_wR15running_machinePvi,0,__ZL7irq_offR15running_machinePvi6107,0,__ZL14datastrobe_offR15running_machinePvi,0,__ZL8keypad_rP13address_spacej,0,__ZL9output0_wP13address_spacejh,0,__ZL9unknown_rP13address_spacej,0,__ZL9output1_wP13address_spacejh,0,__ZL7datic_rP13address_spacej,0,__ZL5lcd_wP13address_spacejh,0,__ZL17from_controller_rP13address_spacej,0,__ZL15to_controller_wP13address_spacejh,0,__ZL7port1_rP13address_spacej,0,__ZL7port1_wP13address_spacejh,0,__ZL7port2_rP13address_spacej,0,__ZL7port2_wP13address_spacejh,0,__ZL4t0_rP13address_spacej,0,__ZL4t1_rP13address_spacej,0,__ZN13z80ctc_device11ctc_channel21static_timer_callbackER15running_machinePvi,0,__ZN25devcb_resolved_write_line7to_nullEi,0,__ZN25devcb_resolved_write_line7to_portEi,0,__ZN25devcb_resolved_write_line9to_write8Ei,0,__ZN25devcb_resolved_write_line8to_inputEi,0,__ZN20devcb_resolved_read813from_constantEj,0,__ZN20devcb_resolved_read89from_portEj,0,__ZN20devcb_resolved_read813from_readlineEj,0,__ZN21devcb_resolved_write87to_nullEjh,0,__ZN21devcb_resolved_write87to_portEjh,0,__ZN21devcb_resolved_write812to_writelineEjh,0,__ZN21devcb_resolved_write88to_inputEjh,0,__ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI13address_spaceEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI21devcb_resolved_write8EEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI13address_spaceEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI20devcb_resolved_read8EEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvi8_noparamS0_S0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind,0,__ZN13delegate_baseIvi8_noparamS0_S0_E16late_bind_helperI25devcb_resolved_write_lineEEP22delegate_generic_classR18delegate_late_bind,0,__ZL20device_start_samplesP8device_t,0,__Z21legacy_device_creatorI14samples_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZL19sample_update_soundP8device_tP12sound_streamPvPPiS5_i,0,__ZL16samples_postloadP13_samples_info,0,__Z25device_get_config_samplesPK8device_tjP10deviceinfo,0,__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13_samples_infoEEP22delegate_generic_classR18delegate_late_bind,0,__ZL15memory_destructPvj,0,__ZL12expat_mallocj7269,0,__ZL13expat_reallocPvj7270,0,__ZL10expat_freePv7271,0,__ZL19expat_element_startPvPKcPS1_,0,__ZL17expat_element_endPvPKc,0,__ZL10expat_dataPvPKci,0,__ZL15zlib_fast_allocPvjj,0,__ZL14zlib_fast_freePvS_,0,__ZL19async_read_callbackPvi,0,__ZL21metadata_hash_comparePKvS0_,0,__ZL17tree_node_comparePKvS0_,0,_malloc,0,_realloc,0,_free,0,__ZL19prologInitProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL14errorProcessorP16XML_ParserStructPKcS2_PS2_,0,_XmlInitEncodingNS,0,_XmlInitEncoding,0,__ZL16contentProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL22ignoreSectionProcessorP16XML_ParserStructPKcS2_PS2_,0,_XmlParseXmlDeclNS,0,_XmlParseXmlDecl,0,__ZL15prologProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL23internalEntityProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL21cdataSectionProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL15epilogProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL30externalEntityContentProcessorP16XML_ParserStructPKcS2_PS2_,0,__ZL7prolog0P12prolog_stateiPKcS2_PK8encoding,0,__ZL7prolog1P12prolog_stateiPKcS2_PK8encoding,0,__ZL8doctype0P12prolog_stateiPKcS2_PK8encoding,0,__ZL5errorP12prolog_stateiPKcS2_PK8encoding,0,__ZL9condSect0P12prolog_stateiPKcS2_PK8encoding,0,__ZL9condSect1P12prolog_stateiPKcS2_PK8encoding,0,__ZL9condSect2P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity0P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist0P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element0P12prolog_stateiPKcS2_PK8encoding,0,__ZL9notation0P12prolog_stateiPKcS2_PK8encoding,0,__ZL8doctype5P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity1P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity2P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist1P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element1P12prolog_stateiPKcS2_PK8encoding,0,__ZL9notation1P12prolog_stateiPKcS2_PK8encoding,0,_XmlInitUnknownEncodingNS,0,_XmlInitUnknownEncoding,0,__ZL7prolog2P12prolog_stateiPKcS2_PK8encoding,0,__ZL9notation3P12prolog_stateiPKcS2_PK8encoding,0,__ZL9notation2P12prolog_stateiPKcS2_PK8encoding,0,__ZL9declCloseP12prolog_stateiPKcS2_PK8encoding,0,__ZL9notation4P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element2P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element3P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element6P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element7P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element4P12prolog_stateiPKcS2_PK8encoding,0,__ZL8element5P12prolog_stateiPKcS2_PK8encoding,0,__ZL14internalSubsetP12prolog_stateiPKcS2_PK8encoding,0,__ZL15externalSubset1P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist2P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist8P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist5P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist3P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist9P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist6P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist4P12prolog_stateiPKcS2_PK8encoding,0,__ZL8attlist7P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity7P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity4P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity3P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity5P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity6P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity9P12prolog_stateiPKcS2_PK8encoding,0,__ZL7entity8P12prolog_stateiPKcS2_PK8encoding,0,__ZL8entity10P12prolog_stateiPKcS2_PK8encoding,0,__ZL8doctype1P12prolog_stateiPKcS2_PK8encoding,0,__ZL8doctype3P12prolog_stateiPKcS2_PK8encoding,0,__ZL8doctype2P12prolog_stateiPKcS2_PK8encoding,0,__ZL8doctype4P12prolog_stateiPKcS2_PK8encoding,0,__ZL14unknown_isNamePK8encodingPKc,0,__ZL16unknown_isNmstrtPK8encodingPKc,0,__ZL17unknown_isInvalidPK8encodingPKc,0,__ZL14unknown_toUtf8PK8encodingPPKcS3_PPcS3_,0,__ZL15unknown_toUtf16PK8encodingPPKcS3_PPtPKt,0,__ZL14initScanPrologPK8encodingPKcS3_PS3_,0,__ZL15initScanContentPK8encodingPKcS3_PS3_,0,__ZL18initUpdatePositionPK8encodingPKcS3_P8position,0,__ZL12findEncodingPK8encodingPKcS3_,0,__ZL16initScanPrologNSPK8encodingPKcS3_PS3_,0,__ZL17initScanContentNSPK8encodingPKcS3_PS3_,0,__ZL14findEncodingNSPK8encodingPKcS3_,0,_zcalloc,0,_zcfree,0,__ZNSt3__110__stdinbufIcED1Ev,0,__ZNSt3__111__stdoutbufIcED1Ev,0,__ZNSt3__110__stdinbufIwED1Ev,0,__ZNSt3__111__stdoutbufIwED1Ev,0,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__18ios_base4InitD2Ev,0,__ZNSt11logic_errorD2Ev,0,__ZNSt3__18ios_base7failureD2Ev,0,__ZNSt3__119__iostream_categoryD1Ev,0,_uselocale,0,__ZNSt3__112__do_nothingEPv,0,__ZNSt13runtime_errorD2Ev,0,__ZNSt3__16locale2id6__initEv,0,__ZNSt8bad_castD2Ev,0,__ZNSt3__117__call_once_proxyINS_12_GLOBAL__N_111__fake_bindEEEvPv,0,___cxx_global_array_dtor143,0,___cxx_global_array_dtor128,0,___cxx_global_array_dtor104,0,___cxx_global_array_dtor80,0,___cxx_global_array_dtor77,0,___cxx_global_array_dtor,0,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,0,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev,0,__ZN20resource_pool_objectI13driver_deviceED1Ev,0,__ZN20resource_pool_objectI13driver_deviceED0Ev,0,__ZN18resource_pool_itemD1Ev,0,__ZN18resource_pool_itemD0Ev,0,__ZL20coleco_vdp_interruptR15running_machinei,0,__ZL31construct_machine_config_colecoR14machine_configP8device_t,0,__Z23construct_ioport_colecoR8device_tR11tagged_listI17input_port_configER7astring,0,__ZN12coleco_stateD1Ev,0,__ZN12coleco_stateD0Ev,0,__ZNK13driver_device17device_rom_regionEv,0,__ZNK8device_t24device_mconfig_additionsEv,0,__ZNK13driver_device18device_input_portsEv,0,__ZN8device_t22device_config_completeEv,0,__ZNK8device_t21device_validity_checkER11emu_optionsRK11game_driver,0,__ZN13driver_device12device_startEv,0,__ZN8device_t11device_stopEv,0,__ZN13driver_device12device_resetEv,0,__ZN8device_t15device_pre_saveEv,0,__ZN8device_t16device_post_loadEv,0,__ZN8device_t20device_clock_changedEv,0,__ZN8device_t18device_debug_setupEv,0,__ZN8device_t12device_timerER9emu_timerjiPv,0,__ZN13driver_device13screen_updateER13screen_deviceR8bitmap_tRK10_rectangle,0,__ZN13driver_device10screen_eofEv,0,__ZN13driver_device12driver_startEv,0,__ZN12coleco_state13machine_startEv,0,__ZN13driver_device11sound_startEv,0,__ZN13driver_device11video_startEv,0,__ZN13driver_device12driver_resetEv,0,__ZN12coleco_state13machine_resetEv,0,__ZN13driver_device11sound_resetEv,0,__ZN13driver_device11video_resetEv,0,__ZN14emu_fatalerrorD0Ev,0,__ZNKSt9exception4whatEv,0,__ZN13emu_exceptionD0Ev,0,__ZN8device_t15required_deviceI10cpu_deviceED1Ev,0,__ZN8device_t15required_deviceI10cpu_deviceED0Ev,0,__ZN8device_t15required_deviceI10cpu_deviceE6finditERS_,0,__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED1Ev,0,__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED0Ev,0,___cxa_pure_virtual,0,__ZN20resource_pool_objectI12coleco_stateED1Ev,0,__ZN20resource_pool_objectI12coleco_stateED0Ev,0,__ZN18mini_osd_interfaceD2Ev,0,__ZN18mini_osd_interfaceD0Ev,0,__ZN18mini_osd_interface4initER15running_machine,0,__ZN18mini_osd_interface6updateEb,0,__ZN13osd_interface13init_debuggerEv,0,__ZN13osd_interface17wait_for_debuggerER8device_tb,0,__ZN18mini_osd_interface19update_audio_streamEPKsi,0,__ZN18mini_osd_interface16set_mastervolumeEi,0,__ZN18mini_osd_interface25customize_input_type_listER11simple_listI16input_type_entryE,0,__ZN13osd_interface9font_openEPKcRi,0,__ZN13osd_interface10font_closeEPv,0,__ZN13osd_interface15font_get_bitmapEPvjRiS1_S1_,0,__ZN13osd_interface15get_slider_listEv,0,__ZN12i8748_deviceD1Ev,0,__ZN12i8748_deviceD0Ev,0,__ZNK17legacy_cpu_device17device_rom_regionEv,0,__ZNK17legacy_cpu_device24device_mconfig_additionsEv,0,__ZNK17legacy_cpu_device18device_input_portsEv,0,__ZN17legacy_cpu_device12device_startEv,0,__ZN17legacy_cpu_device11device_stopEv,0,__ZN17legacy_cpu_device12device_resetEv,0,__ZN17legacy_cpu_device18device_debug_setupEv,0,__ZNK17legacy_cpu_device24execute_clocks_to_cyclesEy,0,__ZNK17legacy_cpu_device24execute_cycles_to_clocksEy,0,__ZNK17legacy_cpu_device18execute_min_cyclesEv,0,__ZNK17legacy_cpu_device18execute_max_cyclesEv,0,__ZNK17legacy_cpu_device19execute_input_linesEv,0,__ZNK17legacy_cpu_device26execute_default_irq_vectorEv,0,__ZN17legacy_cpu_device11execute_runEv,0,__ZN17legacy_cpu_device12execute_burnEi,0,__ZN17legacy_cpu_device17execute_set_inputEii,0,__ZNK17legacy_cpu_device19memory_space_configE16address_spacenum,0,__ZN17legacy_cpu_device16memory_translateE16address_spacenumiRj,0,__ZN17legacy_cpu_device11memory_readE16address_spacenumjiRy,0,__ZN17legacy_cpu_device12memory_writeE16address_spacenumjiy,0,__ZN17legacy_cpu_device13memory_readopEjiRy,0,__ZN17legacy_cpu_device12state_importERK18device_state_entry,0,__ZN17legacy_cpu_device12state_exportERK18device_state_entry,0,__ZN17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring,0,__ZNK17legacy_cpu_device23disasm_min_opcode_bytesEv,0,__ZNK17legacy_cpu_device23disasm_max_opcode_bytesEv,0,__ZN17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j,0,__ZThn356_N12i8748_deviceD1Ev,0,__ZThn356_N12i8748_deviceD0Ev,0,__ZN16device_interface25interface_config_completeEv,0,__ZNK24device_execute_interface24interface_validity_checkER11emu_optionsRK11game_driver,0,__ZN24device_execute_interface19interface_pre_startEv,0,__ZN24device_execute_interface20interface_post_startEv,0,__ZN24device_execute_interface19interface_pre_resetEv,0,__ZN24device_execute_interface20interface_post_resetEv,0,__ZN16device_interface18interface_pre_stopEv,0,__ZN16device_interface19interface_post_stopEv,0,__ZN16device_interface18interface_pre_saveEv,0,__ZN16device_interface19interface_post_loadEv,0,__ZN24device_execute_interface23interface_clock_changedEv,0,__ZN16device_interface21interface_debug_setupEv,0,__ZThn356_NK17legacy_cpu_device24execute_clocks_to_cyclesEy,0,__ZThn356_NK17legacy_cpu_device24execute_cycles_to_clocksEy,0,__ZThn356_NK17legacy_cpu_device18execute_min_cyclesEv,0,__ZThn356_NK17legacy_cpu_device18execute_max_cyclesEv,0,__ZThn356_NK17legacy_cpu_device19execute_input_linesEv,0,__ZThn356_NK17legacy_cpu_device26execute_default_irq_vectorEv,0,__ZThn356_N17legacy_cpu_device11execute_runEv,0,__ZThn356_N17legacy_cpu_device12execute_burnEi,0,__ZThn356_N17legacy_cpu_device17execute_set_inputEii,0,__ZThn5968_N12i8748_deviceD1Ev,0,__ZThn5968_N12i8748_deviceD0Ev,0,__ZNK23device_memory_interface24interface_validity_checkER11emu_optionsRK11game_driver,0,__ZN16device_interface19interface_pre_startEv,0,__ZN16device_interface20interface_post_startEv,0,__ZN16device_interface19interface_pre_resetEv,0,__ZN16device_interface20interface_post_resetEv,0,__ZN16device_interface23interface_clock_changedEv,0,__ZThn5968_NK17legacy_cpu_device19memory_space_configE16address_spacenum,0,__ZThn5968_N17legacy_cpu_device16memory_translateE16address_spacenumiRj,0,__ZThn5968_N17legacy_cpu_device11memory_readE16address_spacenumjiRy,0,__ZThn5968_N17legacy_cpu_device12memory_writeE16address_spacenumjiy,0,__ZThn5968_N17legacy_cpu_device13memory_readopEjiRy,0,__ZThn6012_N12i8748_deviceD1Ev,0,__ZThn6012_N12i8748_deviceD0Ev,0,__ZNK16device_interface24interface_validity_checkER11emu_optionsRK11game_driver,0,__ZN22device_state_interface20interface_post_startEv,0,__ZThn6012_N17legacy_cpu_device12state_importERK18device_state_entry,0,__ZThn6012_N17legacy_cpu_device12state_exportERK18device_state_entry,0,__ZN22device_state_interface19state_string_importERK18device_state_entryR7astring,0,__ZThn6012_N17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring,0,__ZThn7088_N12i8748_deviceD1Ev,0,__ZThn7088_N12i8748_deviceD0Ev,0,__ZThn7088_NK17legacy_cpu_device23disasm_min_opcode_bytesEv,0,__ZThn7088_NK17legacy_cpu_device23disasm_max_opcode_bytesEv,0,__ZThn7088_N17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j,0,__ZN12i8049_deviceD1Ev,0,__ZN12i8049_deviceD0Ev,0,__ZThn356_N12i8049_deviceD1Ev,0,__ZThn356_N12i8049_deviceD0Ev,0,__ZThn5968_N12i8049_deviceD1Ev,0,__ZThn5968_N12i8049_deviceD0Ev,0,__ZThn6012_N12i8049_deviceD1Ev,0,__ZThn6012_N12i8049_deviceD0Ev,0,__ZThn7088_N12i8049_deviceD1Ev,0,__ZThn7088_N12i8049_deviceD0Ev,0,__ZN20resource_pool_objectI12i8049_deviceED1Ev,0,__ZN20resource_pool_objectI12i8049_deviceED0Ev,0,__ZN20resource_pool_objectI12i8748_deviceED1Ev,0,__ZN20resource_pool_objectI12i8748_deviceED0Ev,0,__ZL3nopP12_mcs48_state,0,__ZL7illegalP12_mcs48_state,0,__ZL8split_02P12_mcs48_state,0,__ZL7add_a_nP12_mcs48_state,0,__ZL5jmp_0P12_mcs48_state,0,__ZL4en_iP12_mcs48_state,0,__ZL5dec_aP12_mcs48_state,0,__ZL8split_08P12_mcs48_state,0,__ZL7in_a_p1P12_mcs48_state,0,__ZL7in_a_p2P12_mcs48_state,0,__ZL9movd_a_p4P12_mcs48_state,0,__ZL9movd_a_p5P12_mcs48_state,0,__ZL9movd_a_p6P12_mcs48_state,0,__ZL9movd_a_p7P12_mcs48_state,0,__ZL7inc_xr0P12_mcs48_state,0,__ZL7inc_xr1P12_mcs48_state,0,__ZL4jb_0P12_mcs48_state,0,__ZL7adc_a_nP12_mcs48_state,0,__ZL6call_0P12_mcs48_state,0,__ZL5dis_iP12_mcs48_state,0,__ZL3jtfP12_mcs48_state,0,__ZL5inc_aP12_mcs48_state,0,__ZL6inc_r0P12_mcs48_state,0,__ZL6inc_r1P12_mcs48_state,0,__ZL6inc_r2P12_mcs48_state,0,__ZL6inc_r3P12_mcs48_state,0,__ZL6inc_r4P12_mcs48_state,0,__ZL6inc_r5P12_mcs48_state,0,__ZL6inc_r6P12_mcs48_state,0,__ZL6inc_r7P12_mcs48_state,0,__ZL9xch_a_xr0P12_mcs48_state,0,__ZL9xch_a_xr1P12_mcs48_state,0,__ZL8split_22P12_mcs48_state,0,__ZL7mov_a_nP12_mcs48_state,0,__ZL5jmp_1P12_mcs48_state,0,__ZL8en_tcntiP12_mcs48_state,0,__ZL5jnt_0P12_mcs48_state,0,__ZL5clr_aP12_mcs48_state,0,__ZL8xch_a_r0P12_mcs48_state,0,__ZL8xch_a_r1P12_mcs48_state,0,__ZL8xch_a_r2P12_mcs48_state,0,__ZL8xch_a_r3P12_mcs48_state,0,__ZL8xch_a_r4P12_mcs48_state,0,__ZL8xch_a_r5P12_mcs48_state,0,__ZL8xch_a_r6P12_mcs48_state,0,__ZL8xch_a_r7P12_mcs48_state,0,__ZL10xchd_a_xr0P12_mcs48_state,0,__ZL10xchd_a_xr1P12_mcs48_state,0,__ZL4jb_1P12_mcs48_state,0,__ZL6call_1P12_mcs48_state,0,__ZL9dis_tcntiP12_mcs48_state,0,__ZL4jt_0P12_mcs48_state,0,__ZL5cpl_aP12_mcs48_state,0,__ZL9outl_p1_aP12_mcs48_state,0,__ZL9outl_p2_aP12_mcs48_state,0,__ZL9movd_p4_aP12_mcs48_state,0,__ZL9movd_p5_aP12_mcs48_state,0,__ZL9movd_p6_aP12_mcs48_state,0,__ZL9movd_p7_aP12_mcs48_state,0,__ZL9orl_a_xr0P12_mcs48_state,0,__ZL9orl_a_xr1P12_mcs48_state,0,__ZL7mov_a_tP12_mcs48_state,0,__ZL7orl_a_nP12_mcs48_state,0,__ZL5jmp_2P12_mcs48_state,0,__ZL8strt_cntP12_mcs48_state,0,__ZL5jnt_1P12_mcs48_state,0,__ZL6swap_aP12_mcs48_state,0,__ZL8orl_a_r0P12_mcs48_state,0,__ZL8orl_a_r1P12_mcs48_state,0,__ZL8orl_a_r2P12_mcs48_state,0,__ZL8orl_a_r3P12_mcs48_state,0,__ZL8orl_a_r4P12_mcs48_state,0,__ZL8orl_a_r5P12_mcs48_state,0,__ZL8orl_a_r6P12_mcs48_state,0,__ZL8orl_a_r7P12_mcs48_state,0,__ZL9anl_a_xr0P12_mcs48_state,0,__ZL9anl_a_xr1P12_mcs48_state,0,__ZL4jb_2P12_mcs48_state,0,__ZL7anl_a_nP12_mcs48_state,0,__ZL6call_2P12_mcs48_state,0,__ZL6strt_tP12_mcs48_state,0,__ZL4jt_1P12_mcs48_state,0,__ZL4da_aP12_mcs48_state,0,__ZL8anl_a_r0P12_mcs48_state,0,__ZL8anl_a_r1P12_mcs48_state,0,__ZL8anl_a_r2P12_mcs48_state,0,__ZL8anl_a_r3P12_mcs48_state,0,__ZL8anl_a_r4P12_mcs48_state,0,__ZL8anl_a_r5P12_mcs48_state,0,__ZL8anl_a_r6P12_mcs48_state,0,__ZL8anl_a_r7P12_mcs48_state,0,__ZL9add_a_xr0P12_mcs48_state,0,__ZL9add_a_xr1P12_mcs48_state,0,__ZL7mov_t_aP12_mcs48_state,0,__ZL5jmp_3P12_mcs48_state,0,__ZL9stop_tcntP12_mcs48_state,0,__ZL5rrc_aP12_mcs48_state,0,__ZL8add_a_r0P12_mcs48_state,0,__ZL8add_a_r1P12_mcs48_state,0,__ZL8add_a_r2P12_mcs48_state,0,__ZL8add_a_r3P12_mcs48_state,0,__ZL8add_a_r4P12_mcs48_state,0,__ZL8add_a_r5P12_mcs48_state,0,__ZL8add_a_r6P12_mcs48_state,0,__ZL8add_a_r7P12_mcs48_state,0,__ZL9adc_a_xr0P12_mcs48_state,0,__ZL9adc_a_xr1P12_mcs48_state,0,__ZL4jb_3P12_mcs48_state,0,__ZL6call_3P12_mcs48_state,0,__ZL8split_75P12_mcs48_state,0,__ZL3jf1P12_mcs48_state,0,__ZL4rr_aP12_mcs48_state,0,__ZL8adc_a_r0P12_mcs48_state,0,__ZL8adc_a_r1P12_mcs48_state,0,__ZL8adc_a_r2P12_mcs48_state,0,__ZL8adc_a_r3P12_mcs48_state,0,__ZL8adc_a_r4P12_mcs48_state,0,__ZL8adc_a_r5P12_mcs48_state,0,__ZL8adc_a_r6P12_mcs48_state,0,__ZL8adc_a_r7P12_mcs48_state,0,__ZL8split_80P12_mcs48_state,0,__ZL8split_81P12_mcs48_state,0,__ZL3retP12_mcs48_state,0,__ZL5jmp_4P12_mcs48_state,0,__ZL6clr_f0P12_mcs48_state,0,__ZL8split_86P12_mcs48_state,0,__ZL8split_88P12_mcs48_state,0,__ZL8orl_p1_nP12_mcs48_state,0,__ZL8orl_p2_nP12_mcs48_state,0,__ZL9orld_p4_aP12_mcs48_state,0,__ZL9orld_p5_aP12_mcs48_state,0,__ZL9orld_p6_aP12_mcs48_state,0,__ZL9orld_p7_aP12_mcs48_state,0,__ZL8split_90P12_mcs48_state,0,__ZL8split_91P12_mcs48_state,0,__ZL4jb_4P12_mcs48_state,0,__ZL4retrP12_mcs48_state,0,__ZL6call_4P12_mcs48_state,0,__ZL6cpl_f0P12_mcs48_state,0,__ZL3jnzP12_mcs48_state,0,__ZL5clr_cP12_mcs48_state,0,__ZL8split_98P12_mcs48_state,0,__ZL8anl_p1_nP12_mcs48_state,0,__ZL8anl_p2_nP12_mcs48_state,0,__ZL9anld_p4_aP12_mcs48_state,0,__ZL9anld_p5_aP12_mcs48_state,0,__ZL9anld_p6_aP12_mcs48_state,0,__ZL9anld_p7_aP12_mcs48_state,0,__ZL9mov_xr0_aP12_mcs48_state,0,__ZL9mov_xr1_aP12_mcs48_state,0,__ZL9movp_a_xaP12_mcs48_state,0,__ZL5jmp_5P12_mcs48_state,0,__ZL6clr_f1P12_mcs48_state,0,__ZL5cpl_cP12_mcs48_state,0,__ZL8mov_r0_aP12_mcs48_state,0,__ZL8mov_r1_aP12_mcs48_state,0,__ZL8mov_r2_aP12_mcs48_state,0,__ZL8mov_r3_aP12_mcs48_state,0,__ZL8mov_r4_aP12_mcs48_state,0,__ZL8mov_r5_aP12_mcs48_state,0,__ZL8mov_r6_aP12_mcs48_state,0,__ZL8mov_r7_aP12_mcs48_state,0,__ZL9mov_xr0_nP12_mcs48_state,0,__ZL9mov_xr1_nP12_mcs48_state,0,__ZL4jb_5P12_mcs48_state,0,__ZL7jmpp_xaP12_mcs48_state,0,__ZL6call_5P12_mcs48_state,0,__ZL6cpl_f1P12_mcs48_state,0,__ZL3jf0P12_mcs48_state,0,__ZL8mov_r0_nP12_mcs48_state,0,__ZL8mov_r1_nP12_mcs48_state,0,__ZL8mov_r2_nP12_mcs48_state,0,__ZL8mov_r3_nP12_mcs48_state,0,__ZL8mov_r4_nP12_mcs48_state,0,__ZL8mov_r5_nP12_mcs48_state,0,__ZL8mov_r6_nP12_mcs48_state,0,__ZL8mov_r7_nP12_mcs48_state,0,__ZL5jmp_6P12_mcs48_state,0,__ZL7sel_rb0P12_mcs48_state,0,__ZL2jzP12_mcs48_state,0,__ZL9mov_a_pswP12_mcs48_state,0,__ZL6dec_r0P12_mcs48_state,0,__ZL6dec_r1P12_mcs48_state,0,__ZL6dec_r2P12_mcs48_state,0,__ZL6dec_r3P12_mcs48_state,0,__ZL6dec_r4P12_mcs48_state,0,__ZL6dec_r5P12_mcs48_state,0,__ZL6dec_r6P12_mcs48_state,0,__ZL6dec_r7P12_mcs48_state,0,__ZL9xrl_a_xr0P12_mcs48_state,0,__ZL9xrl_a_xr1P12_mcs48_state,0,__ZL4jb_6P12_mcs48_state,0,__ZL7xrl_a_nP12_mcs48_state,0,__ZL6call_6P12_mcs48_state,0,__ZL7sel_rb1P12_mcs48_state,0,__ZL8split_d6P12_mcs48_state,0,__ZL9mov_psw_aP12_mcs48_state,0,__ZL8xrl_a_r0P12_mcs48_state,0,__ZL8xrl_a_r1P12_mcs48_state,0,__ZL8xrl_a_r2P12_mcs48_state,0,__ZL8xrl_a_r3P12_mcs48_state,0,__ZL8xrl_a_r4P12_mcs48_state,0,__ZL8xrl_a_r5P12_mcs48_state,0,__ZL8xrl_a_r6P12_mcs48_state,0,__ZL8xrl_a_r7P12_mcs48_state,0,__ZL10movp3_a_xaP12_mcs48_state,0,__ZL5jmp_7P12_mcs48_state,0,__ZL8split_e5P12_mcs48_state,0,__ZL3jncP12_mcs48_state,0,__ZL4rl_aP12_mcs48_state,0,__ZL7djnz_r0P12_mcs48_state,0,__ZL7djnz_r1P12_mcs48_state,0,__ZL7djnz_r2P12_mcs48_state,0,__ZL7djnz_r3P12_mcs48_state,0,__ZL7djnz_r4P12_mcs48_state,0,__ZL7djnz_r5P12_mcs48_state,0,__ZL7djnz_r6P12_mcs48_state,0,__ZL7djnz_r7P12_mcs48_state,0,__ZL9mov_a_xr0P12_mcs48_state,0,__ZL9mov_a_xr1P12_mcs48_state,0,__ZL4jb_7P12_mcs48_state,0,__ZL6call_7P12_mcs48_state,0,__ZL8split_f5P12_mcs48_state,0,__ZL2jcP12_mcs48_state,0,__ZL5rlc_aP12_mcs48_state,0,__ZL8mov_a_r0P12_mcs48_state,0,__ZL8mov_a_r1P12_mcs48_state,0,__ZL8mov_a_r2P12_mcs48_state,0,__ZL8mov_a_r3P12_mcs48_state,0,__ZL8mov_a_r4P12_mcs48_state,0,__ZL8mov_a_r5P12_mcs48_state,0,__ZL8mov_a_r6P12_mcs48_state,0,__ZL8mov_a_r7P12_mcs48_state,0,__ZN10z80_deviceD1Ev,0,__ZN10z80_deviceD0Ev,0,__ZThn356_N10z80_deviceD1Ev,0,__ZThn356_N10z80_deviceD0Ev,0,__ZThn5968_N10z80_deviceD1Ev,0,__ZThn5968_N10z80_deviceD0Ev,0,__ZThn6012_N10z80_deviceD1Ev,0,__ZThn6012_N10z80_deviceD0Ev,0,__ZThn7088_N10z80_deviceD1Ev,0,__ZThn7088_N10z80_deviceD0Ev,0,__ZN20resource_pool_objectI10z80_deviceED1Ev,0,__ZN20resource_pool_objectI10z80_deviceED0Ev,0,__ZL5fd_00P10_z80_state,0,__ZL5fd_01P10_z80_state,0,__ZL5fd_02P10_z80_state,0,__ZL5fd_03P10_z80_state,0,__ZL5fd_04P10_z80_state,0,__ZL5fd_05P10_z80_state,0,__ZL5fd_06P10_z80_state,0,__ZL5fd_07P10_z80_state,0,__ZL5fd_08P10_z80_state,0,__ZL5fd_09P10_z80_state,0,__ZL5fd_0aP10_z80_state,0,__ZL5fd_0bP10_z80_state,0,__ZL5fd_0cP10_z80_state,0,__ZL5fd_0dP10_z80_state,0,__ZL5fd_0eP10_z80_state,0,__ZL5fd_0fP10_z80_state,0,__ZL5fd_10P10_z80_state,0,__ZL5fd_11P10_z80_state,0,__ZL5fd_12P10_z80_state,0,__ZL5fd_13P10_z80_state,0,__ZL5fd_14P10_z80_state,0,__ZL5fd_15P10_z80_state,0,__ZL5fd_16P10_z80_state,0,__ZL5fd_17P10_z80_state,0,__ZL5fd_18P10_z80_state,0,__ZL5fd_19P10_z80_state,0,__ZL5fd_1aP10_z80_state,0,__ZL5fd_1bP10_z80_state,0,__ZL5fd_1cP10_z80_state,0,__ZL5fd_1dP10_z80_state,0,__ZL5fd_1eP10_z80_state,0,__ZL5fd_1fP10_z80_state,0,__ZL5fd_20P10_z80_state,0,__ZL5fd_21P10_z80_state,0,__ZL5fd_22P10_z80_state,0,__ZL5fd_23P10_z80_state,0,__ZL5fd_24P10_z80_state,0,__ZL5fd_25P10_z80_state,0,__ZL5fd_26P10_z80_state,0,__ZL5fd_27P10_z80_state,0,__ZL5fd_28P10_z80_state,0,__ZL5fd_29P10_z80_state,0,__ZL5fd_2aP10_z80_state,0,__ZL5fd_2bP10_z80_state,0,__ZL5fd_2cP10_z80_state,0,__ZL5fd_2dP10_z80_state,0,__ZL5fd_2eP10_z80_state,0,__ZL5fd_2fP10_z80_state,0,__ZL5fd_30P10_z80_state,0,__ZL5fd_31P10_z80_state,0,__ZL5fd_32P10_z80_state,0,__ZL5fd_33P10_z80_state,0,__ZL5fd_34P10_z80_state,0,__ZL5fd_35P10_z80_state,0,__ZL5fd_36P10_z80_state,0,__ZL5fd_37P10_z80_state,0,__ZL5fd_38P10_z80_state,0,__ZL5fd_39P10_z80_state,0,__ZL5fd_3aP10_z80_state,0,__ZL5fd_3bP10_z80_state,0,__ZL5fd_3cP10_z80_state,0,__ZL5fd_3dP10_z80_state,0,__ZL5fd_3eP10_z80_state,0,__ZL5fd_3fP10_z80_state,0,__ZL5fd_40P10_z80_state,0,__ZL5fd_41P10_z80_state,0,__ZL5fd_42P10_z80_state,0,__ZL5fd_43P10_z80_state,0,__ZL5fd_44P10_z80_state,0,__ZL5fd_45P10_z80_state,0,__ZL5fd_46P10_z80_state,0,__ZL5fd_47P10_z80_state,0,__ZL5fd_48P10_z80_state,0,__ZL5fd_49P10_z80_state,0,__ZL5fd_4aP10_z80_state,0,__ZL5fd_4bP10_z80_state,0,__ZL5fd_4cP10_z80_state,0,__ZL5fd_4dP10_z80_state,0,__ZL5fd_4eP10_z80_state,0,__ZL5fd_4fP10_z80_state,0,__ZL5fd_50P10_z80_state,0,__ZL5fd_51P10_z80_state,0,__ZL5fd_52P10_z80_state,0,__ZL5fd_53P10_z80_state,0,__ZL5fd_54P10_z80_state,0,__ZL5fd_55P10_z80_state,0,__ZL5fd_56P10_z80_state,0,__ZL5fd_57P10_z80_state,0,__ZL5fd_58P10_z80_state,0,__ZL5fd_59P10_z80_state,0,__ZL5fd_5aP10_z80_state,0,__ZL5fd_5bP10_z80_state,0,__ZL5fd_5cP10_z80_state,0,__ZL5fd_5dP10_z80_state,0,__ZL5fd_5eP10_z80_state,0,__ZL5fd_5fP10_z80_state,0,__ZL5fd_60P10_z80_state,0,__ZL5fd_61P10_z80_state,0,__ZL5fd_62P10_z80_state,0,__ZL5fd_63P10_z80_state,0,__ZL5fd_64P10_z80_state,0,__ZL5fd_65P10_z80_state,0,__ZL5fd_66P10_z80_state,0,__ZL5fd_67P10_z80_state,0,__ZL5fd_68P10_z80_state,0,__ZL5fd_69P10_z80_state,0,__ZL5fd_6aP10_z80_state,0,__ZL5fd_6bP10_z80_state,0,__ZL5fd_6cP10_z80_state,0,__ZL5fd_6dP10_z80_state,0,__ZL5fd_6eP10_z80_state,0,__ZL5fd_6fP10_z80_state,0,__ZL5fd_70P10_z80_state,0,__ZL5fd_71P10_z80_state,0,__ZL5fd_72P10_z80_state,0,__ZL5fd_73P10_z80_state,0,__ZL5fd_74P10_z80_state,0,__ZL5fd_75P10_z80_state,0,__ZL5fd_76P10_z80_state,0,__ZL5fd_77P10_z80_state,0,__ZL5fd_78P10_z80_state,0,__ZL5fd_79P10_z80_state,0,__ZL5fd_7aP10_z80_state,0,__ZL5fd_7bP10_z80_state,0,__ZL5fd_7cP10_z80_state,0,__ZL5fd_7dP10_z80_state,0,__ZL5fd_7eP10_z80_state,0,__ZL5fd_7fP10_z80_state,0,__ZL5fd_80P10_z80_state,0,__ZL5fd_81P10_z80_state,0,__ZL5fd_82P10_z80_state,0,__ZL5fd_83P10_z80_state,0,__ZL5fd_84P10_z80_state,0,__ZL5fd_85P10_z80_state,0,__ZL5fd_86P10_z80_state,0,__ZL5fd_87P10_z80_state,0,__ZL5fd_88P10_z80_state,0,__ZL5fd_89P10_z80_state,0,__ZL5fd_8aP10_z80_state,0,__ZL5fd_8bP10_z80_state,0,__ZL5fd_8cP10_z80_state,0,__ZL5fd_8dP10_z80_state,0,__ZL5fd_8eP10_z80_state,0,__ZL5fd_8fP10_z80_state,0,__ZL5fd_90P10_z80_state,0,__ZL5fd_91P10_z80_state,0,__ZL5fd_92P10_z80_state,0,__ZL5fd_93P10_z80_state,0,__ZL5fd_94P10_z80_state,0,__ZL5fd_95P10_z80_state,0,__ZL5fd_96P10_z80_state,0,__ZL5fd_97P10_z80_state,0,__ZL5fd_98P10_z80_state,0,__ZL5fd_99P10_z80_state,0,__ZL5fd_9aP10_z80_state,0,__ZL5fd_9bP10_z80_state,0,__ZL5fd_9cP10_z80_state,0,__ZL5fd_9dP10_z80_state,0,__ZL5fd_9eP10_z80_state,0,__ZL5fd_9fP10_z80_state,0,__ZL5fd_a0P10_z80_state,0,__ZL5fd_a1P10_z80_state,0,__ZL5fd_a2P10_z80_state,0,__ZL5fd_a3P10_z80_state,0,__ZL5fd_a4P10_z80_state,0,__ZL5fd_a5P10_z80_state,0,__ZL5fd_a6P10_z80_state,0,__ZL5fd_a7P10_z80_state,0,__ZL5fd_a8P10_z80_state,0,__ZL5fd_a9P10_z80_state,0,__ZL5fd_aaP10_z80_state,0,__ZL5fd_abP10_z80_state,0,__ZL5fd_acP10_z80_state,0,__ZL5fd_adP10_z80_state,0,__ZL5fd_aeP10_z80_state,0,__ZL5fd_afP10_z80_state,0,__ZL5fd_b0P10_z80_state,0,__ZL5fd_b1P10_z80_state,0,__ZL5fd_b2P10_z80_state,0,__ZL5fd_b3P10_z80_state,0,__ZL5fd_b4P10_z80_state,0,__ZL5fd_b5P10_z80_state,0,__ZL5fd_b6P10_z80_state,0,__ZL5fd_b7P10_z80_state,0,__ZL5fd_b8P10_z80_state,0,__ZL5fd_b9P10_z80_state,0,__ZL5fd_baP10_z80_state,0,__ZL5fd_bbP10_z80_state,0,__ZL5fd_bcP10_z80_state,0,__ZL5fd_bdP10_z80_state,0,__ZL5fd_beP10_z80_state,0,__ZL5fd_bfP10_z80_state,0,__ZL5fd_c0P10_z80_state,0,__ZL5fd_c1P10_z80_state,0,__ZL5fd_c2P10_z80_state,0,__ZL5fd_c3P10_z80_state,0,__ZL5fd_c4P10_z80_state,0,__ZL5fd_c5P10_z80_state,0,__ZL5fd_c6P10_z80_state,0,__ZL5fd_c7P10_z80_state,0,__ZL5fd_c8P10_z80_state,0,__ZL5fd_c9P10_z80_state,0,__ZL5fd_caP10_z80_state,0,__ZL5fd_cbP10_z80_state,0,__ZL5fd_ccP10_z80_state,0,__ZL5fd_cdP10_z80_state,0,__ZL5fd_ceP10_z80_state,0,__ZL5fd_cfP10_z80_state,0,__ZL5fd_d0P10_z80_state,0,__ZL5fd_d1P10_z80_state,0,__ZL5fd_d2P10_z80_state,0,__ZL5fd_d3P10_z80_state,0,__ZL5fd_d4P10_z80_state,0,__ZL5fd_d5P10_z80_state,0,__ZL5fd_d6P10_z80_state,0,__ZL5fd_d7P10_z80_state,0,__ZL5fd_d8P10_z80_state,0,__ZL5fd_d9P10_z80_state,0,__ZL5fd_daP10_z80_state,0,__ZL5fd_dbP10_z80_state,0,__ZL5fd_dcP10_z80_state,0,__ZL5fd_ddP10_z80_state,0,__ZL5fd_deP10_z80_state,0,__ZL5fd_dfP10_z80_state,0,__ZL5fd_e0P10_z80_state,0,__ZL5fd_e1P10_z80_state,0,__ZL5fd_e2P10_z80_state,0,__ZL5fd_e3P10_z80_state,0,__ZL5fd_e4P10_z80_state,0,__ZL5fd_e5P10_z80_state,0,__ZL5fd_e6P10_z80_state,0,__ZL5fd_e7P10_z80_state,0,__ZL5fd_e8P10_z80_state,0,__ZL5fd_e9P10_z80_state,0,__ZL5fd_eaP10_z80_state,0,__ZL5fd_ebP10_z80_state,0,__ZL5fd_ecP10_z80_state,0,__ZL5fd_edP10_z80_state,0,__ZL5fd_eeP10_z80_state,0,__ZL5fd_efP10_z80_state,0,__ZL5fd_f0P10_z80_state,0,__ZL5fd_f1P10_z80_state,0,__ZL5fd_f2P10_z80_state,0,__ZL5fd_f3P10_z80_state,0,__ZL5fd_f4P10_z80_state,0,__ZL5fd_f5P10_z80_state,0,__ZL5fd_f6P10_z80_state,0,__ZL5fd_f7P10_z80_state,0,__ZL5fd_f8P10_z80_state,0,__ZL5fd_f9P10_z80_state,0,__ZL5fd_faP10_z80_state,0,__ZL5fd_fbP10_z80_state,0,__ZL5fd_fcP10_z80_state,0,__ZL5fd_fdP10_z80_state,0,__ZL5fd_feP10_z80_state,0,__ZL5fd_ffP10_z80_state,0,__ZL7xycb_00P10_z80_state,0,__ZL7xycb_01P10_z80_state,0,__ZL7xycb_02P10_z80_state,0,__ZL7xycb_03P10_z80_state,0,__ZL7xycb_04P10_z80_state,0,__ZL7xycb_05P10_z80_state,0,__ZL7xycb_06P10_z80_state,0,__ZL7xycb_07P10_z80_state,0,__ZL7xycb_08P10_z80_state,0,__ZL7xycb_09P10_z80_state,0,__ZL7xycb_0aP10_z80_state,0,__ZL7xycb_0bP10_z80_state,0,__ZL7xycb_0cP10_z80_state,0,__ZL7xycb_0dP10_z80_state,0,__ZL7xycb_0eP10_z80_state,0,__ZL7xycb_0fP10_z80_state,0,__ZL7xycb_10P10_z80_state,0,__ZL7xycb_11P10_z80_state,0,__ZL7xycb_12P10_z80_state,0,__ZL7xycb_13P10_z80_state,0,__ZL7xycb_14P10_z80_state,0,__ZL7xycb_15P10_z80_state,0,__ZL7xycb_16P10_z80_state,0,__ZL7xycb_17P10_z80_state,0,__ZL7xycb_18P10_z80_state,0,__ZL7xycb_19P10_z80_state,0,__ZL7xycb_1aP10_z80_state,0,__ZL7xycb_1bP10_z80_state,0,__ZL7xycb_1cP10_z80_state,0,__ZL7xycb_1dP10_z80_state,0,__ZL7xycb_1eP10_z80_state,0,__ZL7xycb_1fP10_z80_state,0,__ZL7xycb_20P10_z80_state,0,__ZL7xycb_21P10_z80_state,0,__ZL7xycb_22P10_z80_state,0,__ZL7xycb_23P10_z80_state,0,__ZL7xycb_24P10_z80_state,0,__ZL7xycb_25P10_z80_state,0,__ZL7xycb_26P10_z80_state,0,__ZL7xycb_27P10_z80_state,0,__ZL7xycb_28P10_z80_state,0,__ZL7xycb_29P10_z80_state,0,__ZL7xycb_2aP10_z80_state,0,__ZL7xycb_2bP10_z80_state,0,__ZL7xycb_2cP10_z80_state,0,__ZL7xycb_2dP10_z80_state,0,__ZL7xycb_2eP10_z80_state,0,__ZL7xycb_2fP10_z80_state,0,__ZL7xycb_30P10_z80_state,0,__ZL7xycb_31P10_z80_state,0,__ZL7xycb_32P10_z80_state,0,__ZL7xycb_33P10_z80_state,0,__ZL7xycb_34P10_z80_state,0,__ZL7xycb_35P10_z80_state,0,__ZL7xycb_36P10_z80_state,0,__ZL7xycb_37P10_z80_state,0,__ZL7xycb_38P10_z80_state,0,__ZL7xycb_39P10_z80_state,0,__ZL7xycb_3aP10_z80_state,0,__ZL7xycb_3bP10_z80_state,0,__ZL7xycb_3cP10_z80_state,0,__ZL7xycb_3dP10_z80_state,0,__ZL7xycb_3eP10_z80_state,0,__ZL7xycb_3fP10_z80_state,0,__ZL7xycb_40P10_z80_state,0,__ZL7xycb_41P10_z80_state,0,__ZL7xycb_42P10_z80_state,0,__ZL7xycb_43P10_z80_state,0,__ZL7xycb_44P10_z80_state,0,__ZL7xycb_45P10_z80_state,0,__ZL7xycb_46P10_z80_state,0,__ZL7xycb_47P10_z80_state,0,__ZL7xycb_48P10_z80_state,0,__ZL7xycb_49P10_z80_state,0,__ZL7xycb_4aP10_z80_state,0,__ZL7xycb_4bP10_z80_state,0,__ZL7xycb_4cP10_z80_state,0,__ZL7xycb_4dP10_z80_state,0,__ZL7xycb_4eP10_z80_state,0,__ZL7xycb_4fP10_z80_state,0,__ZL7xycb_50P10_z80_state,0,__ZL7xycb_51P10_z80_state,0,__ZL7xycb_52P10_z80_state,0,__ZL7xycb_53P10_z80_state,0,__ZL7xycb_54P10_z80_state,0,__ZL7xycb_55P10_z80_state,0,__ZL7xycb_56P10_z80_state,0,__ZL7xycb_57P10_z80_state,0,__ZL7xycb_58P10_z80_state,0,__ZL7xycb_59P10_z80_state,0,__ZL7xycb_5aP10_z80_state,0,__ZL7xycb_5bP10_z80_state,0,__ZL7xycb_5cP10_z80_state,0,__ZL7xycb_5dP10_z80_state,0,__ZL7xycb_5eP10_z80_state,0,__ZL7xycb_5fP10_z80_state,0,__ZL7xycb_60P10_z80_state,0,__ZL7xycb_61P10_z80_state,0,__ZL7xycb_62P10_z80_state,0,__ZL7xycb_63P10_z80_state,0,__ZL7xycb_64P10_z80_state,0,__ZL7xycb_65P10_z80_state,0,__ZL7xycb_66P10_z80_state,0,__ZL7xycb_67P10_z80_state,0,__ZL7xycb_68P10_z80_state,0,__ZL7xycb_69P10_z80_state,0,__ZL7xycb_6aP10_z80_state,0,__ZL7xycb_6bP10_z80_state,0,__ZL7xycb_6cP10_z80_state,0,__ZL7xycb_6dP10_z80_state,0,__ZL7xycb_6eP10_z80_state,0,__ZL7xycb_6fP10_z80_state,0,__ZL7xycb_70P10_z80_state,0,__ZL7xycb_71P10_z80_state,0,__ZL7xycb_72P10_z80_state,0,__ZL7xycb_73P10_z80_state,0,__ZL7xycb_74P10_z80_state,0,__ZL7xycb_75P10_z80_state,0,__ZL7xycb_76P10_z80_state,0,__ZL7xycb_77P10_z80_state,0,__ZL7xycb_78P10_z80_state,0,__ZL7xycb_79P10_z80_state,0,__ZL7xycb_7aP10_z80_state,0,__ZL7xycb_7bP10_z80_state,0,__ZL7xycb_7cP10_z80_state,0,__ZL7xycb_7dP10_z80_state,0,__ZL7xycb_7eP10_z80_state,0,__ZL7xycb_7fP10_z80_state,0,__ZL7xycb_80P10_z80_state,0,__ZL7xycb_81P10_z80_state,0,__ZL7xycb_82P10_z80_state,0,__ZL7xycb_83P10_z80_state,0,__ZL7xycb_84P10_z80_state,0,__ZL7xycb_85P10_z80_state,0,__ZL7xycb_86P10_z80_state,0,__ZL7xycb_87P10_z80_state,0,__ZL7xycb_88P10_z80_state,0,__ZL7xycb_89P10_z80_state,0,__ZL7xycb_8aP10_z80_state,0,__ZL7xycb_8bP10_z80_state,0,__ZL7xycb_8cP10_z80_state,0,__ZL7xycb_8dP10_z80_state,0,__ZL7xycb_8eP10_z80_state,0,__ZL7xycb_8fP10_z80_state,0,__ZL7xycb_90P10_z80_state,0,__ZL7xycb_91P10_z80_state,0,__ZL7xycb_92P10_z80_state,0,__ZL7xycb_93P10_z80_state,0,__ZL7xycb_94P10_z80_state,0,__ZL7xycb_95P10_z80_state,0,__ZL7xycb_96P10_z80_state,0,__ZL7xycb_97P10_z80_state,0,__ZL7xycb_98P10_z80_state,0,__ZL7xycb_99P10_z80_state,0,__ZL7xycb_9aP10_z80_state,0,__ZL7xycb_9bP10_z80_state,0,__ZL7xycb_9cP10_z80_state,0,__ZL7xycb_9dP10_z80_state,0,__ZL7xycb_9eP10_z80_state,0,__ZL7xycb_9fP10_z80_state,0,__ZL7xycb_a0P10_z80_state,0,__ZL7xycb_a1P10_z80_state,0,__ZL7xycb_a2P10_z80_state,0,__ZL7xycb_a3P10_z80_state,0,__ZL7xycb_a4P10_z80_state,0,__ZL7xycb_a5P10_z80_state,0,__ZL7xycb_a6P10_z80_state,0,__ZL7xycb_a7P10_z80_state,0,__ZL7xycb_a8P10_z80_state,0,__ZL7xycb_a9P10_z80_state,0,__ZL7xycb_aaP10_z80_state,0,__ZL7xycb_abP10_z80_state,0,__ZL7xycb_acP10_z80_state,0,__ZL7xycb_adP10_z80_state,0,__ZL7xycb_aeP10_z80_state,0,__ZL7xycb_afP10_z80_state,0,__ZL7xycb_b0P10_z80_state,0,__ZL7xycb_b1P10_z80_state,0,__ZL7xycb_b2P10_z80_state,0,__ZL7xycb_b3P10_z80_state,0,__ZL7xycb_b4P10_z80_state,0,__ZL7xycb_b5P10_z80_state,0,__ZL7xycb_b6P10_z80_state,0,__ZL7xycb_b7P10_z80_state,0,__ZL7xycb_b8P10_z80_state,0,__ZL7xycb_b9P10_z80_state,0,__ZL7xycb_baP10_z80_state,0,__ZL7xycb_bbP10_z80_state,0,__ZL7xycb_bcP10_z80_state,0,__ZL7xycb_bdP10_z80_state,0,__ZL7xycb_beP10_z80_state,0,__ZL7xycb_bfP10_z80_state,0,__ZL7xycb_c0P10_z80_state,0,__ZL7xycb_c1P10_z80_state,0,__ZL7xycb_c2P10_z80_state,0,__ZL7xycb_c3P10_z80_state,0,__ZL7xycb_c4P10_z80_state,0,__ZL7xycb_c5P10_z80_state,0,__ZL7xycb_c6P10_z80_state,0,__ZL7xycb_c7P10_z80_state,0,__ZL7xycb_c8P10_z80_state,0,__ZL7xycb_c9P10_z80_state,0,__ZL7xycb_caP10_z80_state,0,__ZL7xycb_cbP10_z80_state,0,__ZL7xycb_ccP10_z80_state,0,__ZL7xycb_cdP10_z80_state,0,__ZL7xycb_ceP10_z80_state,0,__ZL7xycb_cfP10_z80_state,0,__ZL7xycb_d0P10_z80_state,0,__ZL7xycb_d1P10_z80_state,0,__ZL7xycb_d2P10_z80_state,0,__ZL7xycb_d3P10_z80_state,0,__ZL7xycb_d4P10_z80_state,0,__ZL7xycb_d5P10_z80_state,0,__ZL7xycb_d6P10_z80_state,0,__ZL7xycb_d7P10_z80_state,0,__ZL7xycb_d8P10_z80_state,0,__ZL7xycb_d9P10_z80_state,0,__ZL7xycb_daP10_z80_state,0,__ZL7xycb_dbP10_z80_state,0,__ZL7xycb_dcP10_z80_state,0,__ZL7xycb_ddP10_z80_state,0,__ZL7xycb_deP10_z80_state,0,__ZL7xycb_dfP10_z80_state,0,__ZL7xycb_e0P10_z80_state,0,__ZL7xycb_e1P10_z80_state,0,__ZL7xycb_e2P10_z80_state,0,__ZL7xycb_e3P10_z80_state,0,__ZL7xycb_e4P10_z80_state,0,__ZL7xycb_e5P10_z80_state,0,__ZL7xycb_e6P10_z80_state,0,__ZL7xycb_e7P10_z80_state,0,__ZL7xycb_e8P10_z80_state,0,__ZL7xycb_e9P10_z80_state,0,__ZL7xycb_eaP10_z80_state,0,__ZL7xycb_ebP10_z80_state,0,__ZL7xycb_ecP10_z80_state,0,__ZL7xycb_edP10_z80_state,0,__ZL7xycb_eeP10_z80_state,0,__ZL7xycb_efP10_z80_state,0,__ZL7xycb_f0P10_z80_state,0,__ZL7xycb_f1P10_z80_state,0,__ZL7xycb_f2P10_z80_state,0,__ZL7xycb_f3P10_z80_state,0,__ZL7xycb_f4P10_z80_state,0,__ZL7xycb_f5P10_z80_state,0,__ZL7xycb_f6P10_z80_state,0,__ZL7xycb_f7P10_z80_state,0,__ZL7xycb_f8P10_z80_state,0,__ZL7xycb_f9P10_z80_state,0,__ZL7xycb_faP10_z80_state,0,__ZL7xycb_fbP10_z80_state,0,__ZL7xycb_fcP10_z80_state,0,__ZL7xycb_fdP10_z80_state,0,__ZL7xycb_feP10_z80_state,0,__ZL7xycb_ffP10_z80_state,0,__ZL5ed_00P10_z80_state,0,__ZL5ed_01P10_z80_state,0,__ZL5ed_02P10_z80_state,0,__ZL5ed_03P10_z80_state,0,__ZL5ed_04P10_z80_state,0,__ZL5ed_05P10_z80_state,0,__ZL5ed_06P10_z80_state,0,__ZL5ed_07P10_z80_state,0,__ZL5ed_08P10_z80_state,0,__ZL5ed_09P10_z80_state,0,__ZL5ed_0aP10_z80_state,0,__ZL5ed_0bP10_z80_state,0,__ZL5ed_0cP10_z80_state,0,__ZL5ed_0dP10_z80_state,0,__ZL5ed_0eP10_z80_state,0,__ZL5ed_0fP10_z80_state,0,__ZL5ed_10P10_z80_state,0,__ZL5ed_11P10_z80_state,0,__ZL5ed_12P10_z80_state,0,__ZL5ed_13P10_z80_state,0,__ZL5ed_14P10_z80_state,0,__ZL5ed_15P10_z80_state,0,__ZL5ed_16P10_z80_state,0,__ZL5ed_17P10_z80_state,0,__ZL5ed_18P10_z80_state,0,__ZL5ed_19P10_z80_state,0,__ZL5ed_1aP10_z80_state,0,__ZL5ed_1bP10_z80_state,0,__ZL5ed_1cP10_z80_state,0,__ZL5ed_1dP10_z80_state,0,__ZL5ed_1eP10_z80_state,0,__ZL5ed_1fP10_z80_state,0,__ZL5ed_20P10_z80_state,0,__ZL5ed_21P10_z80_state,0,__ZL5ed_22P10_z80_state,0,__ZL5ed_23P10_z80_state,0,__ZL5ed_24P10_z80_state,0,__ZL5ed_25P10_z80_state,0,__ZL5ed_26P10_z80_state,0,__ZL5ed_27P10_z80_state,0,__ZL5ed_28P10_z80_state,0,__ZL5ed_29P10_z80_state,0,__ZL5ed_2aP10_z80_state,0,__ZL5ed_2bP10_z80_state,0,__ZL5ed_2cP10_z80_state,0,__ZL5ed_2dP10_z80_state,0,__ZL5ed_2eP10_z80_state,0,__ZL5ed_2fP10_z80_state,0,__ZL5ed_30P10_z80_state,0,__ZL5ed_31P10_z80_state,0,__ZL5ed_32P10_z80_state,0,__ZL5ed_33P10_z80_state,0,__ZL5ed_34P10_z80_state,0,__ZL5ed_35P10_z80_state,0,__ZL5ed_36P10_z80_state,0,__ZL5ed_37P10_z80_state,0,__ZL5ed_38P10_z80_state,0,__ZL5ed_39P10_z80_state,0,__ZL5ed_3aP10_z80_state,0,__ZL5ed_3bP10_z80_state,0,__ZL5ed_3cP10_z80_state,0,__ZL5ed_3dP10_z80_state,0,__ZL5ed_3eP10_z80_state,0,__ZL5ed_3fP10_z80_state,0,__ZL5ed_40P10_z80_state,0,__ZL5ed_41P10_z80_state,0,__ZL5ed_42P10_z80_state,0,__ZL5ed_43P10_z80_state,0,__ZL5ed_44P10_z80_state,0,__ZL5ed_45P10_z80_state,0,__ZL5ed_46P10_z80_state,0,__ZL5ed_47P10_z80_state,0,__ZL5ed_48P10_z80_state,0,__ZL5ed_49P10_z80_state,0,__ZL5ed_4aP10_z80_state,0,__ZL5ed_4bP10_z80_state,0,__ZL5ed_4cP10_z80_state,0,__ZL5ed_4dP10_z80_state,0,__ZL5ed_4eP10_z80_state,0,__ZL5ed_4fP10_z80_state,0,__ZL5ed_50P10_z80_state,0,__ZL5ed_51P10_z80_state,0,__ZL5ed_52P10_z80_state,0,__ZL5ed_53P10_z80_state,0,__ZL5ed_54P10_z80_state,0,__ZL5ed_55P10_z80_state,0,__ZL5ed_56P10_z80_state,0,__ZL5ed_57P10_z80_state,0,__ZL5ed_58P10_z80_state,0,__ZL5ed_59P10_z80_state,0,__ZL5ed_5aP10_z80_state,0,__ZL5ed_5bP10_z80_state,0,__ZL5ed_5cP10_z80_state,0,__ZL5ed_5dP10_z80_state,0,__ZL5ed_5eP10_z80_state,0,__ZL5ed_5fP10_z80_state,0,__ZL5ed_60P10_z80_state,0,__ZL5ed_61P10_z80_state,0,__ZL5ed_62P10_z80_state,0,__ZL5ed_63P10_z80_state,0,__ZL5ed_64P10_z80_state,0,__ZL5ed_65P10_z80_state,0,__ZL5ed_66P10_z80_state,0,__ZL5ed_67P10_z80_state,0,__ZL5ed_68P10_z80_state,0,__ZL5ed_69P10_z80_state,0,__ZL5ed_6aP10_z80_state,0,__ZL5ed_6bP10_z80_state,0,__ZL5ed_6cP10_z80_state,0,__ZL5ed_6dP10_z80_state,0,__ZL5ed_6eP10_z80_state,0,__ZL5ed_6fP10_z80_state,0,__ZL5ed_70P10_z80_state,0,__ZL5ed_71P10_z80_state,0,__ZL5ed_72P10_z80_state,0,__ZL5ed_73P10_z80_state,0,__ZL5ed_74P10_z80_state,0,__ZL5ed_75P10_z80_state,0,__ZL5ed_76P10_z80_state,0,__ZL5ed_77P10_z80_state,0,__ZL5ed_78P10_z80_state,0,__ZL5ed_79P10_z80_state,0,__ZL5ed_7aP10_z80_state,0,__ZL5ed_7bP10_z80_state,0,__ZL5ed_7cP10_z80_state,0,__ZL5ed_7dP10_z80_state,0,__ZL5ed_7eP10_z80_state,0,__ZL5ed_7fP10_z80_state,0,__ZL5ed_80P10_z80_state,0,__ZL5ed_81P10_z80_state,0,__ZL5ed_82P10_z80_state,0,__ZL5ed_83P10_z80_state,0,__ZL5ed_84P10_z80_state,0,__ZL5ed_85P10_z80_state,0,__ZL5ed_86P10_z80_state,0,__ZL5ed_87P10_z80_state,0,__ZL5ed_88P10_z80_state,0,__ZL5ed_89P10_z80_state,0,__ZL5ed_8aP10_z80_state,0,__ZL5ed_8bP10_z80_state,0,__ZL5ed_8cP10_z80_state,0,__ZL5ed_8dP10_z80_state,0,__ZL5ed_8eP10_z80_state,0,__ZL5ed_8fP10_z80_state,0,__ZL5ed_90P10_z80_state,0,__ZL5ed_91P10_z80_state,0,__ZL5ed_92P10_z80_state,0,__ZL5ed_93P10_z80_state,0,__ZL5ed_94P10_z80_state,0,__ZL5ed_95P10_z80_state,0,__ZL5ed_96P10_z80_state,0,__ZL5ed_97P10_z80_state,0,__ZL5ed_98P10_z80_state,0,__ZL5ed_99P10_z80_state,0,__ZL5ed_9aP10_z80_state,0,__ZL5ed_9bP10_z80_state,0,__ZL5ed_9cP10_z80_state,0,__ZL5ed_9dP10_z80_state,0,__ZL5ed_9eP10_z80_state,0,__ZL5ed_9fP10_z80_state,0,__ZL5ed_a0P10_z80_state,0,__ZL5ed_a1P10_z80_state,0,__ZL5ed_a2P10_z80_state,0,__ZL5ed_a3P10_z80_state,0,__ZL5ed_a4P10_z80_state,0,__ZL5ed_a5P10_z80_state,0,__ZL5ed_a6P10_z80_state,0,__ZL5ed_a7P10_z80_state,0,__ZL5ed_a8P10_z80_state,0,__ZL5ed_a9P10_z80_state,0,__ZL5ed_aaP10_z80_state,0,__ZL5ed_abP10_z80_state,0,__ZL5ed_acP10_z80_state,0,__ZL5ed_adP10_z80_state,0,__ZL5ed_aeP10_z80_state,0,__ZL5ed_afP10_z80_state,0,__ZL5ed_b0P10_z80_state,0,__ZL5ed_b1P10_z80_state,0,__ZL5ed_b2P10_z80_state,0,__ZL5ed_b3P10_z80_state,0,__ZL5ed_b4P10_z80_state,0,__ZL5ed_b5P10_z80_state,0,__ZL5ed_b6P10_z80_state,0,__ZL5ed_b7P10_z80_state,0,__ZL5ed_b8P10_z80_state,0,__ZL5ed_b9P10_z80_state,0,__ZL5ed_baP10_z80_state,0,__ZL5ed_bbP10_z80_state,0,__ZL5ed_bcP10_z80_state,0,__ZL5ed_bdP10_z80_state,0,__ZL5ed_beP10_z80_state,0,__ZL5ed_bfP10_z80_state,0,__ZL5ed_c0P10_z80_state,0,__ZL5ed_c1P10_z80_state,0,__ZL5ed_c2P10_z80_state,0,__ZL5ed_c3P10_z80_state,0,__ZL5ed_c4P10_z80_state,0,__ZL5ed_c5P10_z80_state,0,__ZL5ed_c6P10_z80_state,0,__ZL5ed_c7P10_z80_state,0,__ZL5ed_c8P10_z80_state,0,__ZL5ed_c9P10_z80_state,0,__ZL5ed_caP10_z80_state,0,__ZL5ed_cbP10_z80_state,0,__ZL5ed_ccP10_z80_state,0,__ZL5ed_cdP10_z80_state,0,__ZL5ed_ceP10_z80_state,0,__ZL5ed_cfP10_z80_state,0,__ZL5ed_d0P10_z80_state,0,__ZL5ed_d1P10_z80_state,0,__ZL5ed_d2P10_z80_state,0,__ZL5ed_d3P10_z80_state,0,__ZL5ed_d4P10_z80_state,0,__ZL5ed_d5P10_z80_state,0,__ZL5ed_d6P10_z80_state,0,__ZL5ed_d7P10_z80_state,0,__ZL5ed_d8P10_z80_state,0,__ZL5ed_d9P10_z80_state,0,__ZL5ed_daP10_z80_state,0,__ZL5ed_dbP10_z80_state,0,__ZL5ed_dcP10_z80_state,0,__ZL5ed_ddP10_z80_state,0,__ZL5ed_deP10_z80_state,0,__ZL5ed_dfP10_z80_state,0,__ZL5ed_e0P10_z80_state,0,__ZL5ed_e1P10_z80_state,0,__ZL5ed_e2P10_z80_state,0,__ZL5ed_e3P10_z80_state,0,__ZL5ed_e4P10_z80_state,0,__ZL5ed_e5P10_z80_state,0,__ZL5ed_e6P10_z80_state,0,__ZL5ed_e7P10_z80_state,0,__ZL5ed_e8P10_z80_state,0,__ZL5ed_e9P10_z80_state,0,__ZL5ed_eaP10_z80_state,0,__ZL5ed_ebP10_z80_state,0,__ZL5ed_ecP10_z80_state,0,__ZL5ed_edP10_z80_state,0,__ZL5ed_eeP10_z80_state,0,__ZL5ed_efP10_z80_state,0,__ZL5ed_f0P10_z80_state,0,__ZL5ed_f1P10_z80_state,0,__ZL5ed_f2P10_z80_state,0,__ZL5ed_f3P10_z80_state,0,__ZL5ed_f4P10_z80_state,0,__ZL5ed_f5P10_z80_state,0,__ZL5ed_f6P10_z80_state,0,__ZL5ed_f7P10_z80_state,0,__ZL5ed_f8P10_z80_state,0,__ZL5ed_f9P10_z80_state,0,__ZL5ed_faP10_z80_state,0,__ZL5ed_fbP10_z80_state,0,__ZL5ed_fcP10_z80_state,0,__ZL5ed_fdP10_z80_state,0,__ZL5ed_feP10_z80_state,0,__ZL5ed_ffP10_z80_state,0,__ZL5dd_00P10_z80_state,0,__ZL5dd_01P10_z80_state,0,__ZL5dd_02P10_z80_state,0,__ZL5dd_03P10_z80_state,0,__ZL5dd_04P10_z80_state,0,__ZL5dd_05P10_z80_state,0,__ZL5dd_06P10_z80_state,0,__ZL5dd_07P10_z80_state,0,__ZL5dd_08P10_z80_state,0,__ZL5dd_09P10_z80_state,0,__ZL5dd_0aP10_z80_state,0,__ZL5dd_0bP10_z80_state,0,__ZL5dd_0cP10_z80_state,0,__ZL5dd_0dP10_z80_state,0,__ZL5dd_0eP10_z80_state,0,__ZL5dd_0fP10_z80_state,0,__ZL5dd_10P10_z80_state,0,__ZL5dd_11P10_z80_state,0,__ZL5dd_12P10_z80_state,0,__ZL5dd_13P10_z80_state,0,__ZL5dd_14P10_z80_state,0,__ZL5dd_15P10_z80_state,0,__ZL5dd_16P10_z80_state,0,__ZL5dd_17P10_z80_state,0,__ZL5dd_18P10_z80_state,0,__ZL5dd_19P10_z80_state,0,__ZL5dd_1aP10_z80_state,0,__ZL5dd_1bP10_z80_state,0,__ZL5dd_1cP10_z80_state,0,__ZL5dd_1dP10_z80_state,0,__ZL5dd_1eP10_z80_state,0,__ZL5dd_1fP10_z80_state,0,__ZL5dd_20P10_z80_state,0,__ZL5dd_21P10_z80_state,0,__ZL5dd_22P10_z80_state,0,__ZL5dd_23P10_z80_state,0,__ZL5dd_24P10_z80_state,0,__ZL5dd_25P10_z80_state,0,__ZL5dd_26P10_z80_state,0,__ZL5dd_27P10_z80_state,0,__ZL5dd_28P10_z80_state,0,__ZL5dd_29P10_z80_state,0,__ZL5dd_2aP10_z80_state,0,__ZL5dd_2bP10_z80_state,0,__ZL5dd_2cP10_z80_state,0,__ZL5dd_2dP10_z80_state,0,__ZL5dd_2eP10_z80_state,0,__ZL5dd_2fP10_z80_state,0,__ZL5dd_30P10_z80_state,0,__ZL5dd_31P10_z80_state,0,__ZL5dd_32P10_z80_state,0,__ZL5dd_33P10_z80_state,0,__ZL5dd_34P10_z80_state,0,__ZL5dd_35P10_z80_state,0,__ZL5dd_36P10_z80_state,0,__ZL5dd_37P10_z80_state,0,__ZL5dd_38P10_z80_state,0,__ZL5dd_39P10_z80_state,0,__ZL5dd_3aP10_z80_state,0,__ZL5dd_3bP10_z80_state,0,__ZL5dd_3cP10_z80_state,0,__ZL5dd_3dP10_z80_state,0,__ZL5dd_3eP10_z80_state,0,__ZL5dd_3fP10_z80_state,0,__ZL5dd_40P10_z80_state,0,__ZL5dd_41P10_z80_state,0,__ZL5dd_42P10_z80_state,0,__ZL5dd_43P10_z80_state,0,__ZL5dd_44P10_z80_state,0,__ZL5dd_45P10_z80_state,0,__ZL5dd_46P10_z80_state,0,__ZL5dd_47P10_z80_state,0,__ZL5dd_48P10_z80_state,0,__ZL5dd_49P10_z80_state,0,__ZL5dd_4aP10_z80_state,0,__ZL5dd_4bP10_z80_state,0,__ZL5dd_4cP10_z80_state,0,__ZL5dd_4dP10_z80_state,0,__ZL5dd_4eP10_z80_state,0,__ZL5dd_4fP10_z80_state,0,__ZL5dd_50P10_z80_state,0,__ZL5dd_51P10_z80_state,0,__ZL5dd_52P10_z80_state,0,__ZL5dd_53P10_z80_state,0,__ZL5dd_54P10_z80_state,0,__ZL5dd_55P10_z80_state,0,__ZL5dd_56P10_z80_state,0,__ZL5dd_57P10_z80_state,0,__ZL5dd_58P10_z80_state,0,__ZL5dd_59P10_z80_state,0,__ZL5dd_5aP10_z80_state,0,__ZL5dd_5bP10_z80_state,0,__ZL5dd_5cP10_z80_state,0,__ZL5dd_5dP10_z80_state,0,__ZL5dd_5eP10_z80_state,0,__ZL5dd_5fP10_z80_state,0,__ZL5dd_60P10_z80_state,0,__ZL5dd_61P10_z80_state,0,__ZL5dd_62P10_z80_state,0,__ZL5dd_63P10_z80_state,0,__ZL5dd_64P10_z80_state,0,__ZL5dd_65P10_z80_state,0,__ZL5dd_66P10_z80_state,0,__ZL5dd_67P10_z80_state,0,__ZL5dd_68P10_z80_state,0,__ZL5dd_69P10_z80_state,0,__ZL5dd_6aP10_z80_state,0,__ZL5dd_6bP10_z80_state,0,__ZL5dd_6cP10_z80_state,0,__ZL5dd_6dP10_z80_state,0,__ZL5dd_6eP10_z80_state,0,__ZL5dd_6fP10_z80_state,0,__ZL5dd_70P10_z80_state,0,__ZL5dd_71P10_z80_state,0,__ZL5dd_72P10_z80_state,0,__ZL5dd_73P10_z80_state,0,__ZL5dd_74P10_z80_state,0,__ZL5dd_75P10_z80_state,0,__ZL5dd_76P10_z80_state,0,__ZL5dd_77P10_z80_state,0,__ZL5dd_78P10_z80_state,0,__ZL5dd_79P10_z80_state,0,__ZL5dd_7aP10_z80_state,0,__ZL5dd_7bP10_z80_state,0,__ZL5dd_7cP10_z80_state,0,__ZL5dd_7dP10_z80_state,0,__ZL5dd_7eP10_z80_state,0,__ZL5dd_7fP10_z80_state,0,__ZL5dd_80P10_z80_state,0,__ZL5dd_81P10_z80_state,0,__ZL5dd_82P10_z80_state,0,__ZL5dd_83P10_z80_state,0,__ZL5dd_84P10_z80_state,0,__ZL5dd_85P10_z80_state,0,__ZL5dd_86P10_z80_state,0,__ZL5dd_87P10_z80_state,0,__ZL5dd_88P10_z80_state,0,__ZL5dd_89P10_z80_state,0,__ZL5dd_8aP10_z80_state,0,__ZL5dd_8bP10_z80_state,0,__ZL5dd_8cP10_z80_state,0,__ZL5dd_8dP10_z80_state,0,__ZL5dd_8eP10_z80_state,0,__ZL5dd_8fP10_z80_state,0,__ZL5dd_90P10_z80_state,0,__ZL5dd_91P10_z80_state,0,__ZL5dd_92P10_z80_state,0,__ZL5dd_93P10_z80_state,0,__ZL5dd_94P10_z80_state,0,__ZL5dd_95P10_z80_state,0,__ZL5dd_96P10_z80_state,0,__ZL5dd_97P10_z80_state,0,__ZL5dd_98P10_z80_state,0,__ZL5dd_99P10_z80_state,0,__ZL5dd_9aP10_z80_state,0,__ZL5dd_9bP10_z80_state,0,__ZL5dd_9cP10_z80_state,0,__ZL5dd_9dP10_z80_state,0,__ZL5dd_9eP10_z80_state,0,__ZL5dd_9fP10_z80_state,0,__ZL5dd_a0P10_z80_state,0,__ZL5dd_a1P10_z80_state,0,__ZL5dd_a2P10_z80_state,0,__ZL5dd_a3P10_z80_state,0,__ZL5dd_a4P10_z80_state,0,__ZL5dd_a5P10_z80_state,0,__ZL5dd_a6P10_z80_state,0,__ZL5dd_a7P10_z80_state,0,__ZL5dd_a8P10_z80_state,0,__ZL5dd_a9P10_z80_state,0,__ZL5dd_aaP10_z80_state,0,__ZL5dd_abP10_z80_state,0,__ZL5dd_acP10_z80_state,0,__ZL5dd_adP10_z80_state,0,__ZL5dd_aeP10_z80_state,0,__ZL5dd_afP10_z80_state,0,__ZL5dd_b0P10_z80_state,0,__ZL5dd_b1P10_z80_state,0,__ZL5dd_b2P10_z80_state,0,__ZL5dd_b3P10_z80_state,0,__ZL5dd_b4P10_z80_state,0,__ZL5dd_b5P10_z80_state,0,__ZL5dd_b6P10_z80_state,0,__ZL5dd_b7P10_z80_state,0,__ZL5dd_b8P10_z80_state,0,__ZL5dd_b9P10_z80_state,0,__ZL5dd_baP10_z80_state,0,__ZL5dd_bbP10_z80_state,0,__ZL5dd_bcP10_z80_state,0,__ZL5dd_bdP10_z80_state,0,__ZL5dd_beP10_z80_state,0,__ZL5dd_bfP10_z80_state,0,__ZL5dd_c0P10_z80_state,0,__ZL5dd_c1P10_z80_state,0,__ZL5dd_c2P10_z80_state,0,__ZL5dd_c3P10_z80_state,0,__ZL5dd_c4P10_z80_state,0,__ZL5dd_c5P10_z80_state,0,__ZL5dd_c6P10_z80_state,0,__ZL5dd_c7P10_z80_state,0,__ZL5dd_c8P10_z80_state,0,__ZL5dd_c9P10_z80_state,0,__ZL5dd_caP10_z80_state,0,__ZL5dd_cbP10_z80_state,0,__ZL5dd_ccP10_z80_state,0,__ZL5dd_cdP10_z80_state,0,__ZL5dd_ceP10_z80_state,0,__ZL5dd_cfP10_z80_state,0,__ZL5dd_d0P10_z80_state,0,__ZL5dd_d1P10_z80_state,0,__ZL5dd_d2P10_z80_state,0,__ZL5dd_d3P10_z80_state,0,__ZL5dd_d4P10_z80_state,0,__ZL5dd_d5P10_z80_state,0,__ZL5dd_d6P10_z80_state,0,__ZL5dd_d7P10_z80_state,0,__ZL5dd_d8P10_z80_state,0,__ZL5dd_d9P10_z80_state,0,__ZL5dd_daP10_z80_state,0,__ZL5dd_dbP10_z80_state,0,__ZL5dd_dcP10_z80_state,0,__ZL5dd_ddP10_z80_state,0,__ZL5dd_deP10_z80_state,0,__ZL5dd_dfP10_z80_state,0,__ZL5dd_e0P10_z80_state,0,__ZL5dd_e1P10_z80_state,0,__ZL5dd_e2P10_z80_state,0,__ZL5dd_e3P10_z80_state,0,__ZL5dd_e4P10_z80_state,0,__ZL5dd_e5P10_z80_state,0,__ZL5dd_e6P10_z80_state,0,__ZL5dd_e7P10_z80_state,0,__ZL5dd_e8P10_z80_state,0,__ZL5dd_e9P10_z80_state,0,__ZL5dd_eaP10_z80_state,0,__ZL5dd_ebP10_z80_state,0,__ZL5dd_ecP10_z80_state,0,__ZL5dd_edP10_z80_state,0,__ZL5dd_eeP10_z80_state,0,__ZL5dd_efP10_z80_state,0,__ZL5dd_f0P10_z80_state,0,__ZL5dd_f1P10_z80_state,0,__ZL5dd_f2P10_z80_state,0,__ZL5dd_f3P10_z80_state,0,__ZL5dd_f4P10_z80_state,0,__ZL5dd_f5P10_z80_state,0,__ZL5dd_f6P10_z80_state,0,__ZL5dd_f7P10_z80_state,0,__ZL5dd_f8P10_z80_state,0,__ZL5dd_f9P10_z80_state,0,__ZL5dd_faP10_z80_state,0,__ZL5dd_fbP10_z80_state,0,__ZL5dd_fcP10_z80_state,0,__ZL5dd_fdP10_z80_state,0,__ZL5dd_feP10_z80_state,0,__ZL5dd_ffP10_z80_state,0,__ZL5cb_00P10_z80_state,0,__ZL5cb_01P10_z80_state,0,__ZL5cb_02P10_z80_state,0,__ZL5cb_03P10_z80_state,0,__ZL5cb_04P10_z80_state,0,__ZL5cb_05P10_z80_state,0,__ZL5cb_06P10_z80_state,0,__ZL5cb_07P10_z80_state,0,__ZL5cb_08P10_z80_state,0,__ZL5cb_09P10_z80_state,0,__ZL5cb_0aP10_z80_state,0,__ZL5cb_0bP10_z80_state,0,__ZL5cb_0cP10_z80_state,0,__ZL5cb_0dP10_z80_state,0,__ZL5cb_0eP10_z80_state,0,__ZL5cb_0fP10_z80_state,0,__ZL5cb_10P10_z80_state,0,__ZL5cb_11P10_z80_state,0,__ZL5cb_12P10_z80_state,0,__ZL5cb_13P10_z80_state,0,__ZL5cb_14P10_z80_state,0,__ZL5cb_15P10_z80_state,0,__ZL5cb_16P10_z80_state,0,__ZL5cb_17P10_z80_state,0,__ZL5cb_18P10_z80_state,0,__ZL5cb_19P10_z80_state,0,__ZL5cb_1aP10_z80_state,0,__ZL5cb_1bP10_z80_state,0,__ZL5cb_1cP10_z80_state,0,__ZL5cb_1dP10_z80_state,0,__ZL5cb_1eP10_z80_state,0,__ZL5cb_1fP10_z80_state,0,__ZL5cb_20P10_z80_state,0,__ZL5cb_21P10_z80_state,0,__ZL5cb_22P10_z80_state,0,__ZL5cb_23P10_z80_state,0,__ZL5cb_24P10_z80_state,0,__ZL5cb_25P10_z80_state,0,__ZL5cb_26P10_z80_state,0,__ZL5cb_27P10_z80_state,0,__ZL5cb_28P10_z80_state,0,__ZL5cb_29P10_z80_state,0,__ZL5cb_2aP10_z80_state,0,__ZL5cb_2bP10_z80_state,0,__ZL5cb_2cP10_z80_state,0,__ZL5cb_2dP10_z80_state,0,__ZL5cb_2eP10_z80_state,0,__ZL5cb_2fP10_z80_state,0,__ZL5cb_30P10_z80_state,0,__ZL5cb_31P10_z80_state,0,__ZL5cb_32P10_z80_state,0,__ZL5cb_33P10_z80_state,0,__ZL5cb_34P10_z80_state,0,__ZL5cb_35P10_z80_state,0,__ZL5cb_36P10_z80_state,0,__ZL5cb_37P10_z80_state,0,__ZL5cb_38P10_z80_state,0,__ZL5cb_39P10_z80_state,0,__ZL5cb_3aP10_z80_state,0,__ZL5cb_3bP10_z80_state,0,__ZL5cb_3cP10_z80_state,0,__ZL5cb_3dP10_z80_state,0,__ZL5cb_3eP10_z80_state,0,__ZL5cb_3fP10_z80_state,0,__ZL5cb_40P10_z80_state,0,__ZL5cb_41P10_z80_state,0,__ZL5cb_42P10_z80_state,0,__ZL5cb_43P10_z80_state,0,__ZL5cb_44P10_z80_state,0,__ZL5cb_45P10_z80_state,0,__ZL5cb_46P10_z80_state,0,__ZL5cb_47P10_z80_state,0,__ZL5cb_48P10_z80_state,0,__ZL5cb_49P10_z80_state,0,__ZL5cb_4aP10_z80_state,0,__ZL5cb_4bP10_z80_state,0,__ZL5cb_4cP10_z80_state,0,__ZL5cb_4dP10_z80_state,0,__ZL5cb_4eP10_z80_state,0,__ZL5cb_4fP10_z80_state,0,__ZL5cb_50P10_z80_state,0,__ZL5cb_51P10_z80_state,0,__ZL5cb_52P10_z80_state,0,__ZL5cb_53P10_z80_state,0,__ZL5cb_54P10_z80_state,0,__ZL5cb_55P10_z80_state,0,__ZL5cb_56P10_z80_state,0,__ZL5cb_57P10_z80_state,0,__ZL5cb_58P10_z80_state,0,__ZL5cb_59P10_z80_state,0,__ZL5cb_5aP10_z80_state,0,__ZL5cb_5bP10_z80_state,0,__ZL5cb_5cP10_z80_state,0,__ZL5cb_5dP10_z80_state,0,__ZL5cb_5eP10_z80_state,0,__ZL5cb_5fP10_z80_state,0,__ZL5cb_60P10_z80_state,0,__ZL5cb_61P10_z80_state,0,__ZL5cb_62P10_z80_state,0,__ZL5cb_63P10_z80_state,0,__ZL5cb_64P10_z80_state,0,__ZL5cb_65P10_z80_state,0,__ZL5cb_66P10_z80_state,0,__ZL5cb_67P10_z80_state,0,__ZL5cb_68P10_z80_state,0,__ZL5cb_69P10_z80_state,0,__ZL5cb_6aP10_z80_state,0,__ZL5cb_6bP10_z80_state,0,__ZL5cb_6cP10_z80_state,0,__ZL5cb_6dP10_z80_state,0,__ZL5cb_6eP10_z80_state,0,__ZL5cb_6fP10_z80_state,0,__ZL5cb_70P10_z80_state,0,__ZL5cb_71P10_z80_state,0,__ZL5cb_72P10_z80_state,0,__ZL5cb_73P10_z80_state,0,__ZL5cb_74P10_z80_state,0,__ZL5cb_75P10_z80_state,0,__ZL5cb_76P10_z80_state,0,__ZL5cb_77P10_z80_state,0,__ZL5cb_78P10_z80_state,0,__ZL5cb_79P10_z80_state,0,__ZL5cb_7aP10_z80_state,0,__ZL5cb_7bP10_z80_state,0,__ZL5cb_7cP10_z80_state,0,__ZL5cb_7dP10_z80_state,0,__ZL5cb_7eP10_z80_state,0,__ZL5cb_7fP10_z80_state,0,__ZL5cb_80P10_z80_state,0,__ZL5cb_81P10_z80_state,0,__ZL5cb_82P10_z80_state,0,__ZL5cb_83P10_z80_state,0,__ZL5cb_84P10_z80_state,0,__ZL5cb_85P10_z80_state,0,__ZL5cb_86P10_z80_state,0,__ZL5cb_87P10_z80_state,0,__ZL5cb_88P10_z80_state,0,__ZL5cb_89P10_z80_state,0,__ZL5cb_8aP10_z80_state,0,__ZL5cb_8bP10_z80_state,0,__ZL5cb_8cP10_z80_state,0,__ZL5cb_8dP10_z80_state,0,__ZL5cb_8eP10_z80_state,0,__ZL5cb_8fP10_z80_state,0,__ZL5cb_90P10_z80_state,0,__ZL5cb_91P10_z80_state,0,__ZL5cb_92P10_z80_state,0,__ZL5cb_93P10_z80_state,0,__ZL5cb_94P10_z80_state,0,__ZL5cb_95P10_z80_state,0,__ZL5cb_96P10_z80_state,0,__ZL5cb_97P10_z80_state,0,__ZL5cb_98P10_z80_state,0,__ZL5cb_99P10_z80_state,0,__ZL5cb_9aP10_z80_state,0,__ZL5cb_9bP10_z80_state,0,__ZL5cb_9cP10_z80_state,0,__ZL5cb_9dP10_z80_state,0,__ZL5cb_9eP10_z80_state,0,__ZL5cb_9fP10_z80_state,0,__ZL5cb_a0P10_z80_state,0,__ZL5cb_a1P10_z80_state,0,__ZL5cb_a2P10_z80_state,0,__ZL5cb_a3P10_z80_state,0,__ZL5cb_a4P10_z80_state,0,__ZL5cb_a5P10_z80_state,0,__ZL5cb_a6P10_z80_state,0,__ZL5cb_a7P10_z80_state,0,__ZL5cb_a8P10_z80_state,0,__ZL5cb_a9P10_z80_state,0,__ZL5cb_aaP10_z80_state,0,__ZL5cb_abP10_z80_state,0,__ZL5cb_acP10_z80_state,0,__ZL5cb_adP10_z80_state,0,__ZL5cb_aeP10_z80_state,0,__ZL5cb_afP10_z80_state,0,__ZL5cb_b0P10_z80_state,0,__ZL5cb_b1P10_z80_state,0,__ZL5cb_b2P10_z80_state,0,__ZL5cb_b3P10_z80_state,0,__ZL5cb_b4P10_z80_state,0,__ZL5cb_b5P10_z80_state,0,__ZL5cb_b6P10_z80_state,0,__ZL5cb_b7P10_z80_state,0,__ZL5cb_b8P10_z80_state,0,__ZL5cb_b9P10_z80_state,0,__ZL5cb_baP10_z80_state,0,__ZL5cb_bbP10_z80_state,0,__ZL5cb_bcP10_z80_state,0,__ZL5cb_bdP10_z80_state,0,__ZL5cb_beP10_z80_state,0,__ZL5cb_bfP10_z80_state,0,__ZL5cb_c0P10_z80_state,0,__ZL5cb_c1P10_z80_state,0,__ZL5cb_c2P10_z80_state,0,__ZL5cb_c3P10_z80_state,0,__ZL5cb_c4P10_z80_state,0,__ZL5cb_c5P10_z80_state,0,__ZL5cb_c6P10_z80_state,0,__ZL5cb_c7P10_z80_state,0,__ZL5cb_c8P10_z80_state,0,__ZL5cb_c9P10_z80_state,0,__ZL5cb_caP10_z80_state,0,__ZL5cb_cbP10_z80_state,0,__ZL5cb_ccP10_z80_state,0,__ZL5cb_cdP10_z80_state,0,__ZL5cb_ceP10_z80_state,0,__ZL5cb_cfP10_z80_state,0,__ZL5cb_d0P10_z80_state,0,__ZL5cb_d1P10_z80_state,0,__ZL5cb_d2P10_z80_state,0,__ZL5cb_d3P10_z80_state,0,__ZL5cb_d4P10_z80_state,0,__ZL5cb_d5P10_z80_state,0,__ZL5cb_d6P10_z80_state,0,__ZL5cb_d7P10_z80_state,0,__ZL5cb_d8P10_z80_state,0,__ZL5cb_d9P10_z80_state,0,__ZL5cb_daP10_z80_state,0,__ZL5cb_dbP10_z80_state,0,__ZL5cb_dcP10_z80_state,0,__ZL5cb_ddP10_z80_state,0,__ZL5cb_deP10_z80_state,0,__ZL5cb_dfP10_z80_state,0,__ZL5cb_e0P10_z80_state,0,__ZL5cb_e1P10_z80_state,0,__ZL5cb_e2P10_z80_state,0,__ZL5cb_e3P10_z80_state,0,__ZL5cb_e4P10_z80_state,0,__ZL5cb_e5P10_z80_state,0,__ZL5cb_e6P10_z80_state,0,__ZL5cb_e7P10_z80_state,0,__ZL5cb_e8P10_z80_state,0,__ZL5cb_e9P10_z80_state,0,__ZL5cb_eaP10_z80_state,0,__ZL5cb_ebP10_z80_state,0,__ZL5cb_ecP10_z80_state,0,__ZL5cb_edP10_z80_state,0,__ZL5cb_eeP10_z80_state,0,__ZL5cb_efP10_z80_state,0,__ZL5cb_f0P10_z80_state,0,__ZL5cb_f1P10_z80_state,0,__ZL5cb_f2P10_z80_state,0,__ZL5cb_f3P10_z80_state,0,__ZL5cb_f4P10_z80_state,0,__ZL5cb_f5P10_z80_state,0,__ZL5cb_f6P10_z80_state,0,__ZL5cb_f7P10_z80_state,0,__ZL5cb_f8P10_z80_state,0,__ZL5cb_f9P10_z80_state,0,__ZL5cb_faP10_z80_state,0,__ZL5cb_fbP10_z80_state,0,__ZL5cb_fcP10_z80_state,0,__ZL5cb_fdP10_z80_state,0,__ZL5cb_feP10_z80_state,0,__ZL5cb_ffP10_z80_state,0,__ZN19resource_pool_arrayIhED1Ev,0,__ZN19resource_pool_arrayIhED0Ev,0,__ZN25device_z80daisy_interfaceD2Ev,0,__ZN25device_z80daisy_interfaceD0Ev,0,__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED1Ev,0,__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED0Ev,0,__ZN20resource_pool_objectI20input_setting_configED1Ev,0,__ZN20resource_pool_objectI20input_setting_configED0Ev,0,__ZN20resource_pool_objectI18input_field_configED1Ev,0,__ZN20resource_pool_objectI18input_field_configED0Ev,0,__ZN20resource_pool_objectI17input_port_configED1Ev,0,__ZN20resource_pool_objectI17input_port_configED0Ev,0,__ZN11simple_listI23input_field_diplocationED1Ev,0,__ZN11simple_listI23input_field_diplocationED0Ev,0,__ZN11simple_listI20input_setting_configED1Ev,0,__ZN11simple_listI20input_setting_configED0Ev,0,__ZN11simple_listI18input_field_configED1Ev,0,__ZN11simple_listI18input_field_configED0Ev,0,__ZN20resource_pool_objectI19_input_port_privateED1Ev,0,__ZN20resource_pool_objectI19_input_port_privateED0Ev,0,__ZN11simple_listI16input_type_entryED1Ev,0,__ZN11simple_listI16input_type_entryED0Ev,0,__ZN20resource_pool_objectI16input_type_entryED1Ev,0,__ZN20resource_pool_objectI16input_type_entryED0Ev,0,__ZN20resource_pool_objectI11_key_bufferED1Ev,0,__ZN20resource_pool_objectI11_key_bufferED0Ev,0,__ZN19resource_pool_arrayI12_inputx_codeED1Ev,0,__ZN19resource_pool_arrayI12_inputx_codeED0Ev,0,__ZN20resource_pool_objectI8emu_fileED1Ev,0,__ZN20resource_pool_objectI8emu_fileED0Ev,0,__ZN19resource_pool_arrayI10input_codeED1Ev,0,__ZN19resource_pool_arrayI10input_codeED0Ev,0,__ZN19resource_pool_arrayIcED1Ev,0,__ZN19resource_pool_arrayIcED0Ev,0,__ZN20resource_pool_objectI18_device_field_infoED1Ev,0,__ZN20resource_pool_objectI18_device_field_infoED0Ev,0,__ZN20resource_pool_objectI19_analog_field_stateED1Ev,0,__ZN20resource_pool_objectI19_analog_field_stateED0Ev,0,__ZN20resource_pool_objectI18_input_field_stateED1Ev,0,__ZN20resource_pool_objectI18_input_field_stateED0Ev,0,__ZN20resource_pool_objectI17_input_port_stateED1Ev,0,__ZN20resource_pool_objectI17_input_port_stateED0Ev,0,__ZL10draw_mode0P8device_tP8bitmap_tPK10_rectangle,0,__ZL10draw_mode1P8device_tP8bitmap_tPK10_rectangle,0,__ZL10draw_mode2P8device_tP8bitmap_tPK10_rectangle,0,__ZL11draw_mode12P8device_tP8bitmap_tPK10_rectangle,0,__ZL10draw_mode3P8device_tP8bitmap_tPK10_rectangle,0,__ZL14draw_modebogusP8device_tP8bitmap_tPK10_rectangle,0,__ZL11draw_mode23P8device_tP8bitmap_tPK10_rectangle,0,__ZN20resource_pool_objectI8bitmap_tED1Ev,0,__ZN20resource_pool_objectI8bitmap_tED0Ev,0,__Z14device_creatorI12timer_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZN12timer_deviceD1Ev,0,__ZN12timer_deviceD0Ev,0,__ZNK8device_t17device_rom_regionEv,0,__ZNK8device_t18device_input_portsEv,0,__ZNK12timer_device21device_validity_checkER11emu_optionsRK11game_driver,0,__ZN12timer_device12device_startEv,0,__ZN12timer_device12device_resetEv,0,__ZN12timer_device12device_timerER9emu_timerjiPv,0,__ZN20resource_pool_objectI12timer_deviceED1Ev,0,__ZN20resource_pool_objectI12timer_deviceED0Ev,0,__ZN15cartslot_deviceD1Ev,0,__ZN15cartslot_deviceD0Ev,0,__ZNK18legacy_device_base17device_rom_regionEv,0,__ZNK18legacy_device_base24device_mconfig_additionsEv,0,__ZNK18legacy_device_base18device_input_portsEv,0,__ZN24legacy_image_device_base22device_config_completeEv,0,__ZNK18legacy_device_base21device_validity_checkER11emu_optionsRK11game_driver,0,__ZN18legacy_device_base12device_startEv,0,__ZN18legacy_device_base11device_stopEv,0,__ZN18legacy_device_base12device_resetEv,0,__ZN24legacy_image_device_base9call_loadEv,0,__ZN24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry,0,__ZN24legacy_image_device_base11call_createEiP18_option_resolution,0,__ZN24legacy_image_device_base11call_unloadEv,0,__ZN24legacy_image_device_base12call_displayEv,0,__ZN24legacy_image_device_base17call_display_infoEv,0,__ZNK24legacy_image_device_base16get_partial_hashEv,0,__ZN24legacy_image_device_base16call_get_devicesEv,0,__ZN24legacy_image_device_base24get_device_specific_callEv,0,__ZNK24legacy_image_device_base10image_typeEv,0,__ZNK24legacy_image_device_base11is_readableEv,0,__ZNK24legacy_image_device_base12is_writeableEv,0,__ZNK24legacy_image_device_base12is_creatableEv,0,__ZNK24legacy_image_device_base14must_be_loadedEv,0,__ZNK24legacy_image_device_base16is_reset_on_loadEv,0,__ZNK24legacy_image_device_base15image_interfaceEv,0,__ZNK24legacy_image_device_base15file_extensionsEv,0,__ZNK24legacy_image_device_base19create_option_guideEv,0,__ZThn368_N15cartslot_deviceD1Ev,0,__ZThn368_N15cartslot_deviceD0Ev,0,__ZNK22device_image_interface19device_compute_hashER15hash_collectionPKvjPKc,0,__ZThn368_N24legacy_image_device_base9call_loadEv,0,__ZThn368_N24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry,0,__ZThn368_N24legacy_image_device_base11call_createEiP18_option_resolution,0,__ZThn368_N24legacy_image_device_base11call_unloadEv,0,__ZThn368_N24legacy_image_device_base12call_displayEv,0,__ZThn368_N24legacy_image_device_base17call_display_infoEv,0,__ZThn368_N24legacy_image_device_base16call_get_devicesEv,0,__ZThn368_N24legacy_image_device_base24get_device_specific_callEv,0,__ZThn368_NK24legacy_image_device_base16get_partial_hashEv,0,__ZThn368_NK24legacy_image_device_base10image_typeEv,0,__ZThn368_NK24legacy_image_device_base11is_readableEv,0,__ZThn368_NK24legacy_image_device_base12is_writeableEv,0,__ZThn368_NK24legacy_image_device_base12is_creatableEv,0,__ZThn368_NK24legacy_image_device_base14must_be_loadedEv,0,__ZThn368_NK24legacy_image_device_base16is_reset_on_loadEv,0,__ZThn368_NK24legacy_image_device_base15image_interfaceEv,0,__ZThn368_NK24legacy_image_device_base15file_extensionsEv,0,__ZThn368_NK24legacy_image_device_base19create_option_guideEv,0,__ZN20resource_pool_objectI15cartslot_deviceED1Ev,0,__ZN20resource_pool_objectI15cartslot_deviceED0Ev,0,__ZN20software_list_deviceD1Ev,0,__ZN20software_list_deviceD0Ev,0,__ZN20resource_pool_objectI20software_list_deviceED1Ev,0,__ZN20resource_pool_objectI20software_list_deviceED0Ev,0,__ZN20resource_pool_objectI12feature_listED1Ev,0,__ZN20resource_pool_objectI12feature_listED0Ev,0,__ZN20resource_pool_objectI13software_partED1Ev,0,__ZN20resource_pool_objectI13software_partED0Ev,0,__ZN20resource_pool_objectI13software_infoED1Ev,0,__ZN20resource_pool_objectI13software_infoED0Ev,0,__ZN19resource_pool_arrayIiED1Ev,0,__ZN19resource_pool_arrayIiED0Ev,0,__ZN11cli_optionsD1Ev,0,__ZN11cli_optionsD0Ev,0,__ZN12cli_frontend7listxmlEPKc,0,__ZN12cli_frontend8listfullEPKc,0,__ZN12cli_frontend10listsourceEPKc,0,__ZN12cli_frontend10listclonesEPKc,0,__ZN12cli_frontend12listbrothersEPKc,0,__ZN12cli_frontend7listcrcEPKc,0,__ZN12cli_frontend11listdevicesEPKc,0,__ZN12cli_frontend9listslotsEPKc,0,__ZN12cli_frontend8listromsEPKc,0,__ZN12cli_frontend11listsamplesEPKc,0,__ZN12cli_frontend10verifyromsEPKc,0,__ZN12cli_frontend13verifysamplesEPKc,0,__ZN12cli_frontend9listmediaEPKc,0,__ZN12cli_frontend12listsoftwareEPKc,0,__ZN12cli_frontend8romidentEPKc,0,__ZN19resource_pool_arrayI7astringED1Ev,0,__ZN19resource_pool_arrayI7astringED0Ev,0,__ZN11simple_listI12audit_recordED1Ev,0,__ZN11simple_listI12audit_recordED0Ev,0,__ZN11simple_listI8device_tED1Ev,0,__ZN11simple_listI8device_tED0Ev,0,__ZN8device_tD2Ev,0,__ZN8device_tD0Ev,0,__ZN8device_t12device_resetEv,0,__ZN8device_t16auto_finder_baseD2Ev,0,__ZN8device_t16auto_finder_baseD0Ev,0,__ZN16device_interfaceD2Ev,0,__ZN16device_interfaceD0Ev,0,__ZN20resource_pool_objectI12device_debugED1Ev,0,__ZN20resource_pool_objectI12device_debugED0Ev,0,__ZN18delegate_late_bindD1Ev,0,__ZN18delegate_late_bindD0Ev,0,__ZN20resource_pool_objectI18address_map_entry8ED1Ev,0,__ZN20resource_pool_objectI18address_map_entry8ED0Ev,0,__ZN11simple_listI17address_map_entryED1Ev,0,__ZN11simple_listI17address_map_entryED0Ev,0,__ZN22device_image_interfaceD2Ev,0,__ZN22device_image_interfaceD0Ev,0,__ZN22device_image_interface9call_loadEv,0,__ZN22device_image_interface18call_softlist_loadEPcS0_P9rom_entry,0,__ZN22device_image_interface11call_createEiP18_option_resolution,0,__ZN22device_image_interface11call_unloadEv,0,__ZN22device_image_interface12call_displayEv,0,__ZN22device_image_interface17call_display_infoEv,0,__ZN22device_image_interface16call_get_devicesEv,0,__ZN22device_image_interface24get_device_specific_callEv,0,__ZNK22device_image_interface16get_partial_hashEv,0,__ZNK22device_image_interface15image_interfaceEv,0,__ZN23device_memory_interfaceD2Ev,0,__ZN23device_memory_interfaceD0Ev,0,__ZN23device_memory_interface16memory_translateE16address_spacenumiRj,0,__ZN23device_memory_interface11memory_readE16address_spacenumjiRy,0,__ZN23device_memory_interface12memory_writeE16address_spacenumjiy,0,__ZN23device_memory_interface13memory_readopEjiRy,0,__ZN20resource_pool_objectI11address_mapED1Ev,0,__ZN20resource_pool_objectI11address_mapED0Ev,0,__ZN17input_device_itemD1Ev,0,__ZN17input_device_itemD0Ev,0,__ZN24input_device_switch_itemD1Ev,0,__ZN24input_device_switch_itemD0Ev,0,__ZN24input_device_switch_item14read_as_switchE19input_item_modifier,0,__ZN24input_device_switch_item16read_as_relativeE19input_item_modifier,0,__ZN24input_device_switch_item16read_as_absoluteE19input_item_modifier,0,__ZN26input_device_relative_itemD1Ev,0,__ZN26input_device_relative_itemD0Ev,0,__ZN26input_device_relative_item14read_as_switchE19input_item_modifier,0,__ZN26input_device_relative_item16read_as_relativeE19input_item_modifier,0,__ZN26input_device_relative_item16read_as_absoluteE19input_item_modifier,0,__ZN26input_device_absolute_itemD1Ev,0,__ZN26input_device_absolute_itemD0Ev,0,__ZN26input_device_absolute_item14read_as_switchE19input_item_modifier,0,__ZN26input_device_absolute_item16read_as_relativeE19input_item_modifier,0,__ZN26input_device_absolute_item16read_as_absoluteE19input_item_modifier,0,__ZN20resource_pool_objectI12input_deviceED1Ev,0,__ZN20resource_pool_objectI12input_deviceED0Ev,0,__ZN20resource_pool_objectI26input_device_absolute_itemED1Ev,0,__ZN20resource_pool_objectI26input_device_absolute_itemED0Ev,0,__ZN20resource_pool_objectI26input_device_relative_itemED1Ev,0,__ZN20resource_pool_objectI26input_device_relative_itemED0Ev,0,__ZN20resource_pool_objectI24input_device_switch_itemED1Ev,0,__ZN20resource_pool_objectI24input_device_switch_itemED0Ev,0,__ZN20resource_pool_objectIN12device_debug6tracerEED1Ev,0,__ZN20resource_pool_objectIN12device_debug6tracerEED0Ev,0,__ZN20resource_pool_objectIN12device_debug12dasm_commentEED1Ev,0,__ZN20resource_pool_objectIN12device_debug12dasm_commentEED0Ev,0,__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED1Ev,0,__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED0Ev,0,__ZN20resource_pool_objectIN12device_debug10watchpointEED1Ev,0,__ZN20resource_pool_objectIN12device_debug10watchpointEED0Ev,0,__ZN20resource_pool_objectIN12device_debug10breakpointEED1Ev,0,__ZN20resource_pool_objectIN12device_debug10breakpointEED0Ev,0,__ZN11simple_listIN12device_debug12dasm_commentEED1Ev,0,__ZN11simple_listIN12device_debug12dasm_commentEED0Ev,0,__ZN20resource_pool_objectI12symbol_tableED1Ev,0,__ZN20resource_pool_objectI12symbol_tableED0Ev,0,__ZN20resource_pool_objectI17_debugcpu_privateED1Ev,0,__ZN20resource_pool_objectI17_debugcpu_privateED0Ev,0,__ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev,0,__ZN11simple_listIN17parsed_expression11parse_tokenEED0Ev,0,__ZN11simple_listIN17parsed_expression17expression_stringEED1Ev,0,__ZN11simple_listIN17parsed_expression17expression_stringEED0Ev,0,__ZN11simple_listI12symbol_entryED1Ev,0,__ZN11simple_listI12symbol_entryED0Ev,0,__ZN20resource_pool_objectIN12save_manager11state_entryEED1Ev,0,__ZN20resource_pool_objectIN12save_manager11state_entryEED0Ev,0,__ZN20resource_pool_objectIN12save_manager14state_callbackEED1Ev,0,__ZN20resource_pool_objectIN12save_manager14state_callbackEED0Ev,0,__ZN11simple_listIN12save_manager14state_callbackEED1Ev,0,__ZN11simple_listIN12save_manager14state_callbackEED0Ev,0,__ZN11simple_listIN12save_manager11state_entryEED1Ev,0,__ZN11simple_listIN12save_manager11state_entryEED0Ev,0,__ZN13driver_deviceD2Ev,0,__ZN13driver_deviceD0Ev,0,__ZN13driver_device13machine_startEv,0,__ZN13driver_device13machine_resetEv,0,__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED1Ev,0,__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED0Ev,0,__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED1Ev,0,__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED0Ev,0,__ZN20resource_pool_objectI13memory_regionED1Ev,0,__ZN20resource_pool_objectI13memory_regionED0Ev,0,__ZN20resource_pool_objectI13cheat_managerED1Ev,0,__ZN20resource_pool_objectI13cheat_managerED0Ev,0,__ZN11simple_listI11cheat_entryED1Ev,0,__ZN11simple_listI11cheat_entryED0Ev,0,__ZN20resource_pool_objectI13sound_managerED1Ev,0,__ZN20resource_pool_objectI13sound_managerED0Ev,0,__ZN20resource_pool_objectI13video_managerED1Ev,0,__ZN20resource_pool_objectI13video_managerED0Ev,0,__ZN20resource_pool_objectI14render_managerED1Ev,0,__ZN20resource_pool_objectI14render_managerED0Ev,0,__ZN20resource_pool_objectI13input_managerED1Ev,0,__ZN20resource_pool_objectI13input_managerED0Ev,0,__ZN11simple_listIN15running_machine22logerror_callback_itemEED1Ev,0,__ZN11simple_listIN15running_machine22logerror_callback_itemEED0Ev,0,__ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev,0,__ZN11simple_listIN15running_machine22notifier_callback_itemEED0Ev,0,__ZN11simple_listI17input_port_configED1Ev,0,__ZN11simple_listI17input_port_configED0Ev,0,__ZN11simple_listI13memory_regionED1Ev,0,__ZN11simple_listI13memory_regionED0Ev,0,__ZN27device_missing_dependenciesD0Ev,0,__ZN13osd_interfaceD2Ev,0,__ZN13osd_interfaceD0Ev,0,__ZN13osd_interface4initER15running_machine,0,__ZN13osd_interface6updateEb,0,__ZN13osd_interface19update_audio_streamEPKsi,0,__ZN13osd_interface16set_mastervolumeEi,0,__ZN13osd_interface25customize_input_type_listER11simple_listI16input_type_entryE,0,__ZN20resource_pool_objectI11render_fontED1Ev,0,__ZN20resource_pool_objectI11render_fontED0Ev,0,__ZN20resource_pool_objectI14render_textureED1Ev,0,__ZN20resource_pool_objectI14render_textureED0Ev,0,__ZN20resource_pool_objectI13render_targetED1Ev,0,__ZN20resource_pool_objectI13render_targetED0Ev,0,__ZN11simple_listI13render_targetED1Ev,0,__ZN11simple_listI13render_targetED0Ev,0,__ZN20resource_pool_objectI16render_containerED1Ev,0,__ZN20resource_pool_objectI16render_containerED0Ev,0,__ZN11simple_listI14render_textureED1Ev,0,__ZN11simple_listI14render_textureED0Ev,0,__ZN20resource_pool_objectI11layout_fileED1Ev,0,__ZN20resource_pool_objectI11layout_fileED0Ev,0,__ZN11simple_listI16render_containerED1Ev,0,__ZN11simple_listI16render_containerED0Ev,0,__ZN20resource_pool_objectI11simple_listI11layout_fileEED1Ev,0,__ZN20resource_pool_objectI11simple_listI11layout_fileEED0Ev,0,__ZN11simple_listI11layout_fileED1Ev,0,__ZN11simple_listI11layout_fileED0Ev,0,__ZN20resource_pool_objectIN16render_container4itemEED1Ev,0,__ZN20resource_pool_objectIN16render_container4itemEED0Ev,0,__ZN11simple_listIN16render_container4itemEED1Ev,0,__ZN11simple_listIN16render_container4itemEED0Ev,0,__ZN19resource_pool_arrayIjED1Ev,0,__ZN19resource_pool_arrayIjED0Ev,0,__ZN11simple_listIN21render_primitive_list9referenceEED1Ev,0,__ZN11simple_listIN21render_primitive_list9referenceEED0Ev,0,__ZN11simple_listI16render_primitiveED1Ev,0,__ZN11simple_listI16render_primitiveED0Ev,0,__ZN20resource_pool_objectI16render_primitiveED1Ev,0,__ZN20resource_pool_objectI16render_primitiveED0Ev,0,__ZN20resource_pool_objectIN21render_primitive_list9referenceEED1Ev,0,__ZN20resource_pool_objectIN21render_primitive_list9referenceEED0Ev,0,__Z14device_creatorI13screen_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZN13screen_deviceD2Ev,0,__ZN13screen_deviceD0Ev,0,__ZNK13screen_device21device_validity_checkER11emu_optionsRK11game_driver,0,__ZN13screen_device12device_startEv,0,__ZN13screen_device11device_stopEv,0,__ZN13screen_device16device_post_loadEv,0,__ZN20resource_pool_objectIN13screen_device13callback_itemEED1Ev,0,__ZN20resource_pool_objectIN13screen_device13callback_itemEED0Ev,0,__ZN11simple_listIN13screen_device13callback_itemEED1Ev,0,__ZN11simple_listIN13screen_device13callback_itemEED0Ev,0,__ZN20resource_pool_objectI13screen_deviceED1Ev,0,__ZN20resource_pool_objectI13screen_deviceED0Ev,0,__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED1Ev,0,__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED0Ev,0,__ZN11simple_listI9emu_timerED1Ev,0,__ZN11simple_listI9emu_timerED0Ev,0,__ZN20resource_pool_objectI9emu_timerED1Ev,0,__ZN20resource_pool_objectI9emu_timerED0Ev,0,__ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev,0,__ZN11simple_listIN16device_scheduler12quantum_slotEED0Ev,0,__ZN13address_spaceD2Ev,0,__ZN13address_spaceD0Ev,0,__ZN13address_tableD2Ev,0,__ZN13address_tableD0Ev,0,__ZN18address_table_readD2Ev,0,__ZN18address_table_readD0Ev,0,__ZNK18address_table_read7handlerEj,0,__ZN19address_table_writeD2Ev,0,__ZN19address_table_writeD0Ev,0,__ZNK19address_table_write7handlerEj,0,__ZN13handler_entryD2Ev,0,__ZN13handler_entryD0Ev,0,__ZN13handler_entry4copyEPS_,0,__ZN18handler_entry_readD1Ev,0,__ZN18handler_entry_readD0Ev,0,__ZNK18handler_entry_read4nameEv,0,__ZNK18handler_entry_read12subunit_nameEi,0,__ZN18handler_entry_read4copyEP13handler_entry,0,__ZN18handler_entry_read14remove_subunitEi,0,__ZN19handler_entry_writeD1Ev,0,__ZN19handler_entry_writeD0Ev,0,__ZNK19handler_entry_write4nameEv,0,__ZNK19handler_entry_write12subunit_nameEi,0,__ZN19handler_entry_write4copyEP13handler_entry,0,__ZN19handler_entry_write14remove_subunitEi,0,__ZN20resource_pool_objectIN11memory_bank14bank_referenceEED1Ev,0,__ZN20resource_pool_objectIN11memory_bank14bank_referenceEED0Ev,0,__ZN11simple_listIN11memory_bank14bank_referenceEED1Ev,0,__ZN11simple_listIN11memory_bank14bank_referenceEED0Ev,0,__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED1Ev,0,__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED0Ev,0,__ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev,0,__ZN11simple_listIN16direct_read_data12direct_rangeEED0Ev,0,__ZN20resource_pool_objectI19handler_entry_writeED1Ev,0,__ZN20resource_pool_objectI19handler_entry_writeED0Ev,0,__ZN20resource_pool_objectI18handler_entry_readED1Ev,0,__ZN20resource_pool_objectI18handler_entry_readED0Ev,0,__ZN19resource_pool_arrayIN13address_table13subtable_dataEED1Ev,0,__ZN19resource_pool_arrayIN13address_table13subtable_dataEED0Ev,0,__ZN20resource_pool_objectI11memory_bankED1Ev,0,__ZN20resource_pool_objectI11memory_bankED0Ev,0,__ZN20resource_pool_objectI12memory_blockED1Ev,0,__ZN20resource_pool_objectI12memory_blockED0Ev,0,__ZN20resource_pool_objectI12memory_shareED1Ev,0,__ZN20resource_pool_objectI12memory_shareED0Ev,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED0Ev,0,__ZN22address_space_specificIyL12endianness_t1ELb0EED1Ev,0,__ZN22address_space_specificIyL12endianness_t1ELb0EED0Ev,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIyL12endianness_t1ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE9read_byteEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE9read_wordEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE9read_wordEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_dwordEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_qwordEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10write_byteEjh,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10write_wordEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE10write_wordEjtt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE4readEv,0,__ZN22address_space_specificIyL12endianness_t1ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED0Ev,0,__ZN22address_space_specificIyL12endianness_t1ELb1EED1Ev,0,__ZN22address_space_specificIyL12endianness_t1ELb1EED0Ev,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIyL12endianness_t1ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE9read_byteEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE9read_wordEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE9read_wordEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_dwordEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_qwordEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10write_byteEjh,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10write_wordEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE10write_wordEjtt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE4readEv,0,__ZN22address_space_specificIyL12endianness_t1ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED0Ev,0,__ZN22address_space_specificIyL12endianness_t0ELb0EED1Ev,0,__ZN22address_space_specificIyL12endianness_t0ELb0EED0Ev,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIyL12endianness_t0ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE9read_byteEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE9read_wordEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE9read_wordEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_dwordEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_qwordEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10write_byteEjh,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10write_wordEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE10write_wordEjtt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE4readEv,0,__ZN22address_space_specificIyL12endianness_t0ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED0Ev,0,__ZN22address_space_specificIyL12endianness_t0ELb1EED1Ev,0,__ZN22address_space_specificIyL12endianness_t0ELb1EED0Ev,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIyL12endianness_t0ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE9read_byteEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE9read_wordEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE9read_wordEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_dwordEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_qwordEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10write_byteEjh,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10write_wordEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE10write_wordEjtt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_dwordEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_qwordEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE4readEv,0,__ZN22address_space_specificIyL12endianness_t0ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED0Ev,0,__ZN22address_space_specificIjL12endianness_t1ELb0EED1Ev,0,__ZN22address_space_specificIjL12endianness_t1ELb0EED0Ev,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIjL12endianness_t1ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE9read_byteEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE9read_wordEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE9read_wordEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_dwordEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_qwordEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10write_byteEjh,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10write_wordEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE10write_wordEjtt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE4readEv,0,__ZN22address_space_specificIjL12endianness_t1ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED0Ev,0,__ZN22address_space_specificIjL12endianness_t1ELb1EED1Ev,0,__ZN22address_space_specificIjL12endianness_t1ELb1EED0Ev,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIjL12endianness_t1ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE9read_byteEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE9read_wordEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE9read_wordEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_dwordEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_qwordEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10write_byteEjh,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10write_wordEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE10write_wordEjtt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE4readEv,0,__ZN22address_space_specificIjL12endianness_t1ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED0Ev,0,__ZN22address_space_specificIjL12endianness_t0ELb0EED1Ev,0,__ZN22address_space_specificIjL12endianness_t0ELb0EED0Ev,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIjL12endianness_t0ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE9read_byteEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE9read_wordEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE9read_wordEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_dwordEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_qwordEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10write_byteEjh,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10write_wordEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE10write_wordEjtt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE4readEv,0,__ZN22address_space_specificIjL12endianness_t0ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED0Ev,0,__ZN22address_space_specificIjL12endianness_t0ELb1EED1Ev,0,__ZN22address_space_specificIjL12endianness_t0ELb1EED0Ev,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIjL12endianness_t0ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE9read_byteEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE9read_wordEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE9read_wordEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_dwordEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_qwordEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10write_byteEjh,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10write_wordEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE10write_wordEjtt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_dwordEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_qwordEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE4readEv,0,__ZN22address_space_specificIjL12endianness_t0ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED0Ev,0,__ZN22address_space_specificItL12endianness_t1ELb0EED1Ev,0,__ZN22address_space_specificItL12endianness_t1ELb0EED0Ev,0,__ZN22address_space_specificItL12endianness_t1ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificItL12endianness_t1ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificItL12endianness_t1ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificItL12endianness_t1ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE9read_byteEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE9read_wordEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE9read_wordEjt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10read_dwordEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10read_dwordEjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10read_qwordEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10read_qwordEjy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10write_byteEjh,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10write_wordEjt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE10write_wordEjtt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificItL12endianness_t1ELb0EE11write_dwordEjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificItL12endianness_t1ELb0EE11write_qwordEjy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificItL12endianness_t1ELb0EE4readEv,0,__ZN22address_space_specificItL12endianness_t1ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED0Ev,0,__ZN22address_space_specificItL12endianness_t1ELb1EED1Ev,0,__ZN22address_space_specificItL12endianness_t1ELb1EED0Ev,0,__ZN22address_space_specificItL12endianness_t1ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificItL12endianness_t1ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificItL12endianness_t1ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificItL12endianness_t1ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE9read_byteEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE9read_wordEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE9read_wordEjt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10read_dwordEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10read_dwordEjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10read_qwordEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10read_qwordEjy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10write_byteEjh,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10write_wordEjt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE10write_wordEjtt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificItL12endianness_t1ELb1EE11write_dwordEjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificItL12endianness_t1ELb1EE11write_qwordEjy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificItL12endianness_t1ELb1EE4readEv,0,__ZN22address_space_specificItL12endianness_t1ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED0Ev,0,__ZN22address_space_specificItL12endianness_t0ELb0EED1Ev,0,__ZN22address_space_specificItL12endianness_t0ELb0EED0Ev,0,__ZN22address_space_specificItL12endianness_t0ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificItL12endianness_t0ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificItL12endianness_t0ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificItL12endianness_t0ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE9read_byteEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE9read_wordEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE9read_wordEjt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10read_dwordEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10read_dwordEjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10read_qwordEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10read_qwordEjy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10write_byteEjh,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10write_wordEjt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE10write_wordEjtt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificItL12endianness_t0ELb0EE11write_dwordEjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificItL12endianness_t0ELb0EE11write_qwordEjy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificItL12endianness_t0ELb0EE4readEv,0,__ZN22address_space_specificItL12endianness_t0ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED0Ev,0,__ZN22address_space_specificItL12endianness_t0ELb1EED1Ev,0,__ZN22address_space_specificItL12endianness_t0ELb1EED0Ev,0,__ZN22address_space_specificItL12endianness_t0ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificItL12endianness_t0ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificItL12endianness_t0ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificItL12endianness_t0ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE9read_byteEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE9read_wordEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE9read_wordEjt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10read_dwordEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10read_dwordEjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10read_qwordEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10read_qwordEjy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10write_byteEjh,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10write_wordEjt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE10write_wordEjtt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificItL12endianness_t0ELb1EE11write_dwordEjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificItL12endianness_t0ELb1EE11write_qwordEjy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificItL12endianness_t0ELb1EE4readEv,0,__ZN22address_space_specificItL12endianness_t0ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED0Ev,0,__ZN22address_space_specificIhL12endianness_t1ELb0EED1Ev,0,__ZN22address_space_specificIhL12endianness_t1ELb0EED0Ev,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIhL12endianness_t1ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE9read_byteEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE9read_wordEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE9read_wordEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_dwordEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_qwordEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10write_byteEjh,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10write_wordEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE10write_wordEjtt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE4readEv,0,__ZN22address_space_specificIhL12endianness_t1ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED0Ev,0,__ZN22address_space_specificIhL12endianness_t1ELb1EED1Ev,0,__ZN22address_space_specificIhL12endianness_t1ELb1EED0Ev,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIhL12endianness_t1ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE9read_byteEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE9read_wordEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE9read_wordEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_dwordEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_qwordEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10write_byteEjh,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10write_wordEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE10write_wordEjtt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE4readEv,0,__ZN22address_space_specificIhL12endianness_t1ELb1EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED0Ev,0,__ZN22address_space_specificIhL12endianness_t0ELb0EED1Ev,0,__ZN22address_space_specificIhL12endianness_t0ELb0EED0Ev,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIhL12endianness_t0ELb0EE9accessorsER14data_accessors,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE12get_read_ptrEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE13get_write_ptrEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE9read_byteEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE9read_wordEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE9read_wordEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE19read_word_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE19read_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_dwordEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_dword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_qwordEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_qword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10write_byteEjh,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10write_wordEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE10write_wordEjtt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE20write_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_dwordEjjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_qwordEjyy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE4readEv,0,__ZN22address_space_specificIhL12endianness_t0ELb0EE5writeEv,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED1Ev,0,__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED0Ev,0,__ZN22address_space_specificIhL12endianness_t0ELb1EED1Ev,0,__ZN22address_space_specificIhL12endianness_t0ELb1EED0Ev,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE23enable_read_watchpointsEb,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE24enable_write_watchpointsEb,0,__ZNK22address_space_specificIhL12endianness_t0ELb1EE9accessorsER14data_accessors,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE12get_read_ptrEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE13get_write_ptrEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE9read_byteEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE9read_wordEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE9read_wordEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE19read_word_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE19read_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_dwordEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_dword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_qwordEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_qword_unalignedEj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10write_byteEjh,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10write_wordEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE10write_wordEjtt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE20write_word_unalignedEjt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE20write_word_unalignedEjtt,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_dwordEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_dwordEjjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_dword_unalignedEjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_dword_unalignedEjjj,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_qwordEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_qwordEjyy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_qword_unalignedEjy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_qword_unalignedEjyy,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE4readEv,0,__ZN22address_space_specificIhL12endianness_t0ELb1EE5writeEv,0,__ZN20resource_pool_objectI16direct_read_dataED1Ev,0,__ZN20resource_pool_objectI16direct_read_dataED0Ev,0,__ZN20resource_pool_objectI15_memory_privateED1Ev,0,__ZN20resource_pool_objectI15_memory_privateED0Ev,0,__ZN11simple_listI13address_spaceED1Ev,0,__ZN11simple_listI13address_spaceED0Ev,0,__ZN11simple_listI12memory_blockED1Ev,0,__ZN11simple_listI12memory_blockED0Ev,0,__ZN11simple_listI11memory_bankED1Ev,0,__ZN11simple_listI11memory_bankED0Ev,0,__ZN10cpu_deviceD2Ev,0,__ZN10cpu_deviceD0Ev,0,__ZThn356_N10cpu_deviceD1Ev,0,__ZThn356_N10cpu_deviceD0Ev,0,__ZNK24device_execute_interface24execute_clocks_to_cyclesEy,0,__ZNK24device_execute_interface24execute_cycles_to_clocksEy,0,__ZNK24device_execute_interface18execute_min_cyclesEv,0,__ZNK24device_execute_interface18execute_max_cyclesEv,0,__ZNK24device_execute_interface19execute_input_linesEv,0,__ZNK24device_execute_interface26execute_default_irq_vectorEv,0,__ZN24device_execute_interface12execute_burnEi,0,__ZN24device_execute_interface17execute_set_inputEii,0,__ZThn5968_N10cpu_deviceD1Ev,0,__ZThn5968_N10cpu_deviceD0Ev,0,__ZThn6012_N10cpu_deviceD1Ev,0,__ZThn6012_N10cpu_deviceD0Ev,0,__ZN22device_state_interface12state_importERK18device_state_entry,0,__ZN22device_state_interface12state_exportERK18device_state_entry,0,__ZN22device_state_interface19state_string_exportERK18device_state_entryR7astring,0,__ZThn7088_N10cpu_deviceD1Ev,0,__ZThn7088_N10cpu_deviceD0Ev,0,__ZN17legacy_cpu_deviceD2Ev,0,__ZN17legacy_cpu_deviceD0Ev,0,__ZThn356_N17legacy_cpu_deviceD1Ev,0,__ZThn356_N17legacy_cpu_deviceD0Ev,0,__ZThn5968_N17legacy_cpu_deviceD1Ev,0,__ZThn5968_N17legacy_cpu_deviceD0Ev,0,__ZThn6012_N17legacy_cpu_deviceD1Ev,0,__ZThn6012_N17legacy_cpu_deviceD0Ev,0,__ZThn7088_N17legacy_cpu_deviceD1Ev,0,__ZThn7088_N17legacy_cpu_deviceD0Ev,0,__ZN22device_state_interfaceD2Ev,0,__ZN22device_state_interfaceD0Ev,0,__ZN20resource_pool_objectI18device_state_entryED1Ev,0,__ZN20resource_pool_objectI18device_state_entryED0Ev,0,__ZN11simple_listI18device_state_entryED1Ev,0,__ZN11simple_listI18device_state_entryED0Ev,0,__ZN18legacy_device_baseD2Ev,0,__ZN18legacy_device_baseD0Ev,0,__ZN24legacy_sound_device_baseD1Ev,0,__ZN24legacy_sound_device_baseD0Ev,0,__ZN24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i,0,__ZThn368_N24legacy_sound_device_baseD1Ev,0,__ZThn368_N24legacy_sound_device_baseD0Ev,0,__ZNK22device_sound_interface24interface_validity_checkER11emu_optionsRK11game_driver,0,__ZN22device_sound_interface19interface_pre_startEv,0,__ZN22device_sound_interface20interface_post_startEv,0,__ZN22device_sound_interface19interface_pre_resetEv,0,__ZThn368_N24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i,0,__ZN24device_execute_interfaceD2Ev,0,__ZN24device_execute_interfaceD0Ev,0,__ZL33construct_machine_config____emptyR14machine_configP8device_t,0,__ZN20resource_pool_objectI11cheat_entryED1Ev,0,__ZN20resource_pool_objectI11cheat_entryED0Ev,0,__ZN20resource_pool_objectI12cheat_scriptED1Ev,0,__ZN20resource_pool_objectI12cheat_scriptED0Ev,0,__ZN20resource_pool_objectI15cheat_parameterED1Ev,0,__ZN20resource_pool_objectI15cheat_parameterED0Ev,0,__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED1Ev,0,__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED0Ev,0,__ZN11simple_listIN12cheat_script12script_entry15output_argumentEED1Ev,0,__ZN11simple_listIN12cheat_script12script_entry15output_argumentEED0Ev,0,__ZN20resource_pool_objectIN12cheat_script12script_entryEED1Ev,0,__ZN20resource_pool_objectIN12cheat_script12script_entryEED0Ev,0,__ZN11simple_listIN12cheat_script12script_entryEED1Ev,0,__ZN11simple_listIN12cheat_script12script_entryEED0Ev,0,__ZN20resource_pool_objectIN15cheat_parameter4itemEED1Ev,0,__ZN20resource_pool_objectIN15cheat_parameter4itemEED0Ev,0,__ZN11simple_listIN15cheat_parameter4itemEED1Ev,0,__ZN11simple_listIN15cheat_parameter4itemEED0Ev,0,__ZN20resource_pool_objectI12sound_streamED1Ev,0,__ZN20resource_pool_objectI12sound_streamED0Ev,0,__ZN19resource_pool_arrayIsED1Ev,0,__ZN19resource_pool_arrayIsED0Ev,0,__ZN11simple_listI12sound_streamED1Ev,0,__ZN11simple_listI12sound_streamED0Ev,0,__ZN19resource_pool_arrayIN12sound_stream13stream_outputEED1Ev,0,__ZN19resource_pool_arrayIN12sound_stream13stream_outputEED0Ev,0,__ZN19resource_pool_arrayIPiED1Ev,0,__ZN19resource_pool_arrayIPiED0Ev,0,__ZN19resource_pool_arrayIN12sound_stream12stream_inputEED1Ev,0,__ZN19resource_pool_arrayIN12sound_stream12stream_inputEED0Ev,0,__ZN20resource_pool_objectI11gfx_elementED1Ev,0,__ZN20resource_pool_objectI11gfx_elementED0Ev,0,__ZN20resource_pool_objectI12_config_typeED1Ev,0,__ZN20resource_pool_objectI12_config_typeED0Ev,0,__ZN20resource_pool_objectI24_generic_machine_privateED1Ev,0,__ZN20resource_pool_objectI24_generic_machine_privateED0Ev,0,__ZN20resource_pool_objectI12_output_itemED1Ev,0,__ZN20resource_pool_objectI12_output_itemED0Ev,0,__ZN19resource_pool_arrayIfED1Ev,0,__ZN19resource_pool_arrayIfED0Ev,0,__ZN20resource_pool_objectI16_palette_privateED1Ev,0,__ZN20resource_pool_objectI16_palette_privateED0Ev,0,__ZL17image_fseek_thunkPvxi,0,__ZL17image_fread_thunkPvS_j,0,__ZL18image_fwrite_thunkPvPKvj,0,__ZL17image_fsize_thunkPv,0,__ZN20resource_pool_objectI14_machine_entryED1Ev,0,__ZN20resource_pool_objectI14_machine_entryED0Ev,0,__ZN20resource_pool_objectI18debug_view_managerED1Ev,0,__ZN20resource_pool_objectI18debug_view_managerED0Ev,0,__ZN20resource_pool_objectI16_romload_privateED1Ev,0,__ZN20resource_pool_objectI16_romload_privateED0Ev,0,__ZN20resource_pool_objectI9_open_chdED1Ev,0,__ZN20resource_pool_objectI9_open_chdED0Ev,0,__ZN20resource_pool_objectI17_ui_input_privateED1Ev,0,__ZN20resource_pool_objectI17_ui_input_privateED0Ev,0,__ZN20resource_pool_objectI22_generic_audio_privateED1Ev,0,__ZN20resource_pool_objectI22_generic_audio_privateED0Ev,0,__ZN20resource_pool_objectI22_generic_video_privateED1Ev,0,__ZN20resource_pool_objectI22_generic_video_privateED0Ev,0,__ZN20resource_pool_objectI14_debug_commandED1Ev,0,__ZN20resource_pool_objectI14_debug_commandED0Ev,0,__ZN19resource_pool_arrayI13_ui_menu_itemED1Ev,0,__ZN19resource_pool_arrayI13_ui_menu_itemED0Ev,0,__ZN20resource_pool_objectI7ui_menuED1Ev,0,__ZN20resource_pool_objectI7ui_menuED0Ev,0,__ZN20resource_pool_objectI17driver_enumeratorED1Ev,0,__ZN20resource_pool_objectI17driver_enumeratorED0Ev,0,__ZN20resource_pool_objectI5DViewED1Ev,0,__ZN20resource_pool_objectI5DViewED0Ev,0,__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED1Ev,0,__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED0Ev,0,__ZN20resource_pool_objectI14machine_configED1Ev,0,__ZN20resource_pool_objectI14machine_configED0Ev,0,__ZN11simple_listIN17driver_enumerator12config_entryEED1Ev,0,__ZN11simple_listIN17driver_enumerator12config_entryEED0Ev,0,__ZN19resource_pool_arrayIP14machine_configED1Ev,0,__ZN19resource_pool_arrayIP14machine_configED0Ev,0,__ZN11emu_optionsD1Ev,0,__ZN11emu_optionsD0Ev,0,__ZN14layout_elementD2Ev,0,__ZN14layout_elementD0Ev,0,__ZN11layout_viewD2Ev,0,__ZN11layout_viewD0Ev,0,__ZN11layout_view4itemD2Ev,0,__ZN11layout_view4itemD0Ev,0,__ZN11layout_fileD2Ev,0,__ZN11layout_fileD0Ev,0,__ZN20resource_pool_objectI11layout_viewED1Ev,0,__ZN20resource_pool_objectI11layout_viewED0Ev,0,__ZN20resource_pool_objectI14layout_elementED1Ev,0,__ZN20resource_pool_objectI14layout_elementED0Ev,0,__ZN11simple_listI11layout_viewED1Ev,0,__ZN11simple_listI11layout_viewED0Ev,0,__ZN11simple_listI14layout_elementED1Ev,0,__ZN11simple_listI14layout_elementED0Ev,0,__ZN20resource_pool_objectIN11layout_view4itemEED1Ev,0,__ZN20resource_pool_objectIN11layout_view4itemEED0Ev,0,__ZN11simple_listIN11layout_view4itemEED1Ev,0,__ZN11simple_listIN11layout_view4itemEED0Ev,0,__ZN19resource_pool_arrayIN14layout_element7textureEED1Ev,0,__ZN19resource_pool_arrayIN14layout_element7textureEED0Ev,0,__ZN20resource_pool_objectIN14layout_element9componentEED1Ev,0,__ZN20resource_pool_objectIN14layout_element9componentEED0Ev,0,__ZN11simple_listIN14layout_element9componentEED1Ev,0,__ZN11simple_listIN14layout_element9componentEED0Ev,0,__ZN20resource_pool_objectIN18render_screen_list4itemEED1Ev,0,__ZN20resource_pool_objectIN18render_screen_list4itemEED0Ev,0,__ZN11simple_listIN18render_screen_list4itemEED1Ev,0,__ZN11simple_listIN18render_screen_list4itemEED0Ev,0,__ZN11render_fontD2Ev,0,__ZN11render_fontD0Ev,0,__ZN19resource_pool_arrayIN11render_font5glyphEED1Ev,0,__ZN19resource_pool_arrayIN11render_font5glyphEED0Ev,0,__ZN12symbol_entryD2Ev,0,__ZN12symbol_entryD0Ev,0,__ZN20integer_symbol_entryD1Ev,0,__ZN20integer_symbol_entryD0Ev,0,__ZNK20integer_symbol_entry7is_lvalEv,0,__ZNK20integer_symbol_entry5valueEv,0,__ZN20integer_symbol_entry9set_valueEy,0,__ZN21function_symbol_entryD1Ev,0,__ZN21function_symbol_entryD0Ev,0,__ZNK21function_symbol_entry7is_lvalEv,0,__ZNK21function_symbol_entry5valueEv,0,__ZN21function_symbol_entry9set_valueEy,0,__ZN21function_symbol_entry7executeEiPKy,0,__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED1Ev,0,__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED0Ev,0,__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED1Ev,0,__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED0Ev,0,__ZN20resource_pool_objectI21function_symbol_entryED1Ev,0,__ZN20resource_pool_objectI21function_symbol_entryED0Ev,0,__ZN20resource_pool_objectI20integer_symbol_entryED1Ev,0,__ZN20resource_pool_objectI20integer_symbol_entryED0Ev,0,__ZN20resource_pool_objectI12audit_recordED1Ev,0,__ZN20resource_pool_objectI12audit_recordED0Ev,0,__ZN9hash_baseD1Ev,0,__ZN9hash_baseD0Ev,0,__ZN8hash_crcD1Ev,0,__ZN8hash_crcD0Ev,0,__ZN8hash_crc5beginEv,0,__ZN8hash_crc6bufferEPKhj,0,__ZN8hash_crc3endEv,0,__ZN8hash_md5D1Ev,0,__ZN8hash_md5D0Ev,0,__ZN8hash_md55beginEv,0,__ZN8hash_md56bufferEPKhj,0,__ZN8hash_md53endEv,0,__ZN9hash_sha1D1Ev,0,__ZN9hash_sha1D0Ev,0,__ZN9hash_sha15beginEv,0,__ZN9hash_sha16bufferEPKhj,0,__ZN9hash_sha13endEv,0,__ZN20resource_pool_objectI9hash_sha1ED1Ev,0,__ZN20resource_pool_objectI9hash_sha1ED0Ev,0,__ZN20resource_pool_objectI8hash_md5ED1Ev,0,__ZN20resource_pool_objectI8hash_md5ED0Ev,0,__ZN20resource_pool_objectI8hash_crcED1Ev,0,__ZN20resource_pool_objectI8hash_crcED0Ev,0,__ZN11simple_listI9hash_baseED1Ev,0,__ZN11simple_listI9hash_baseED0Ev,0,__ZN17debug_view_sourceD2Ev,0,__ZN17debug_view_sourceD0Ev,0,__ZN10debug_viewD2Ev,0,__ZN10debug_viewD0Ev,0,__ZN10debug_view11view_notifyE23debug_view_notification,0,__ZN10debug_view9view_charEi,0,__ZN20resource_pool_objectI14debug_view_logED1Ev,0,__ZN20resource_pool_objectI14debug_view_logED0Ev,0,__ZN20resource_pool_objectI17debug_view_memoryED1Ev,0,__ZN20resource_pool_objectI17debug_view_memoryED0Ev,0,__ZN20resource_pool_objectI17debug_view_disasmED1Ev,0,__ZN20resource_pool_objectI17debug_view_disasmED0Ev,0,__ZN20resource_pool_objectI16debug_view_stateED1Ev,0,__ZN20resource_pool_objectI16debug_view_stateED0Ev,0,__ZN20resource_pool_objectI18debug_view_consoleED1Ev,0,__ZN20resource_pool_objectI18debug_view_consoleED0Ev,0,__ZN19resource_pool_arrayI15debug_view_charED1Ev,0,__ZN19resource_pool_arrayI15debug_view_charED0Ev,0,__ZN22device_sound_interfaceD2Ev,0,__ZN22device_sound_interfaceD0Ev,0,__ZN11simple_listIN22device_sound_interface11sound_routeEED1Ev,0,__ZN11simple_listIN22device_sound_interface11sound_routeEED0Ev,0,__ZN23device_disasm_interfaceD2Ev,0,__ZN23device_disasm_interfaceD0Ev,0,__ZN24legacy_image_device_baseD2Ev,0,__ZN24legacy_image_device_baseD0Ev,0,__ZThn368_N24legacy_image_device_baseD1Ev,0,__ZThn368_N24legacy_image_device_baseD0Ev,0,__ZN20resource_pool_objectI19image_device_formatED1Ev,0,__ZN20resource_pool_objectI19image_device_formatED0Ev,0,__ZN8emu_fileD2Ev,0,__ZN8emu_fileD0Ev,0,__ZN10ram_deviceD1Ev,0,__ZN10ram_deviceD0Ev,0,__ZN20resource_pool_objectI10ram_deviceED1Ev,0,__ZN20resource_pool_objectI10ram_deviceED0Ev,0,__Z14device_creatorI14speaker_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZN14speaker_deviceD2Ev,0,__ZN14speaker_deviceD0Ev,0,__ZN14speaker_device12device_startEv,0,__ZN14speaker_device16device_post_loadEv,0,__ZN14speaker_device19sound_stream_updateER12sound_streamPPiS3_i,0,__ZThn356_N14speaker_deviceD1Ev,0,__ZThn356_N14speaker_deviceD0Ev,0,__ZThn356_N14speaker_device19sound_stream_updateER12sound_streamPPiS3_i,0,__ZN20resource_pool_objectI14speaker_deviceED1Ev,0,__ZN20resource_pool_objectI14speaker_deviceED0Ev,0,__Z14device_creatorI21cassette_image_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZN21cassette_image_deviceD2Ev,0,__ZN21cassette_image_deviceD0Ev,0,__ZN21cassette_image_device22device_config_completeEv,0,__ZN21cassette_image_device12device_startEv,0,__ZN21cassette_image_device9call_loadEv,0,__ZN21cassette_image_device11call_unloadEv,0,__ZN21cassette_image_device12call_displayEv,0,__ZN21cassette_image_device17call_display_infoEv,0,__ZN21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry,0,__ZNK21cassette_image_device10image_typeEv,0,__ZNK21cassette_image_device11is_readableEv,0,__ZNK21cassette_image_device12is_writeableEv,0,__ZNK21cassette_image_device12is_creatableEv,0,__ZNK21cassette_image_device14must_be_loadedEv,0,__ZNK21cassette_image_device16is_reset_on_loadEv,0,__ZNK21cassette_image_device15image_interfaceEv,0,__ZNK21cassette_image_device15file_extensionsEv,0,__ZNK21cassette_image_device19create_option_guideEv,0,__ZThn376_N21cassette_image_deviceD1Ev,0,__ZThn376_N21cassette_image_deviceD0Ev,0,__ZThn376_N21cassette_image_device9call_loadEv,0,__ZThn376_N21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry,0,__ZThn376_N21cassette_image_device11call_unloadEv,0,__ZThn376_N21cassette_image_device12call_displayEv,0,__ZThn376_N21cassette_image_device17call_display_infoEv,0,__ZThn376_NK21cassette_image_device10image_typeEv,0,__ZThn376_NK21cassette_image_device11is_readableEv,0,__ZThn376_NK21cassette_image_device12is_writeableEv,0,__ZThn376_NK21cassette_image_device12is_creatableEv,0,__ZThn376_NK21cassette_image_device14must_be_loadedEv,0,__ZThn376_NK21cassette_image_device16is_reset_on_loadEv,0,__ZThn376_NK21cassette_image_device15image_interfaceEv,0,__ZThn376_NK21cassette_image_device15file_extensionsEv,0,__ZThn376_NK21cassette_image_device19create_option_guideEv,0,__ZN20resource_pool_objectI21cassette_image_deviceED1Ev,0,__ZN20resource_pool_objectI21cassette_image_deviceED0Ev,0,__ZN16bitbanger_deviceD1Ev,0,__ZN16bitbanger_deviceD0Ev,0,__ZThn368_N16bitbanger_deviceD1Ev,0,__ZThn368_N16bitbanger_deviceD0Ev,0,__ZN20resource_pool_objectI16bitbanger_deviceED1Ev,0,__ZN20resource_pool_objectI16bitbanger_deviceED0Ev,0,__ZN16laserdisc_deviceD1Ev,0,__ZN16laserdisc_deviceD0Ev,0,__ZN20resource_pool_objectI16laserdisc_deviceED1Ev,0,__ZN20resource_pool_objectI16laserdisc_deviceED0Ev,0,__ZN20resource_pool_objectI12_ldcore_dataED1Ev,0,__ZN20resource_pool_objectI12_ldcore_dataED0Ev,0,__ZN19resource_pool_arrayI10_cheat_mapED1Ev,0,__ZN19resource_pool_arrayI10_cheat_mapED0Ev,0,__ZN18debug_view_textbufD2Ev,0,__ZN18debug_view_textbufD0Ev,0,__ZN18debug_view_textbuf11view_updateEv,0,__ZN18debug_view_textbuf11view_notifyE23debug_view_notification,0,__ZN18debug_view_consoleD1Ev,0,__ZN18debug_view_consoleD0Ev,0,__ZN14debug_view_logD1Ev,0,__ZN14debug_view_logD0Ev,0,__ZN23debug_view_state_sourceD1Ev,0,__ZN23debug_view_state_sourceD0Ev,0,__ZN16debug_view_stateD2Ev,0,__ZN16debug_view_stateD0Ev,0,__ZN16debug_view_state11view_updateEv,0,__ZN16debug_view_state11view_notifyE23debug_view_notification,0,__ZN20resource_pool_objectIN16debug_view_state10state_itemEED1Ev,0,__ZN20resource_pool_objectIN16debug_view_state10state_itemEED0Ev,0,__ZN20resource_pool_objectI23debug_view_state_sourceED1Ev,0,__ZN20resource_pool_objectI23debug_view_state_sourceED0Ev,0,__ZN24debug_view_disasm_sourceD1Ev,0,__ZN24debug_view_disasm_sourceD0Ev,0,__ZN17debug_view_disasmD2Ev,0,__ZN17debug_view_disasmD0Ev,0,__ZN17debug_view_disasm11view_updateEv,0,__ZN17debug_view_disasm11view_notifyE23debug_view_notification,0,__ZN17debug_view_disasm9view_charEi,0,__ZN20resource_pool_objectI24debug_view_disasm_sourceED1Ev,0,__ZN20resource_pool_objectI24debug_view_disasm_sourceED0Ev,0,__ZN24debug_view_memory_sourceD1Ev,0,__ZN24debug_view_memory_sourceD0Ev,0,__ZN17debug_view_memoryD1Ev,0,__ZN17debug_view_memoryD0Ev,0,__ZN17debug_view_memory11view_updateEv,0,__ZN17debug_view_memory11view_notifyE23debug_view_notification,0,__ZN17debug_view_memory9view_charEi,0,__ZN20resource_pool_objectI24debug_view_memory_sourceED1Ev,0,__ZN20resource_pool_objectI24debug_view_memory_sourceED0Ev,0,__ZL12ppi0_portb_rP8device_tj,0,__ZL12ppi0_portc_rP8device_tj,0,__ZL12ppi0_porta_wP8device_tjh,0,__ZL12ppi0_portc_wP8device_tjh,0,__ZL12ppi1_porta_rP8device_tj,0,__ZL12ppi1_portb_wP8device_tjh,0,__ZL12ppi1_portc_wP8device_tjh,0,__ZL13ctc_interruptP8device_ti,0,__ZL32construct_machine_config_ldv1000R14machine_configP8device_t,0,__ZL12ldv1000_initP16_laserdisc_state,0,__ZL13ldv1000_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL14ldv1000_updateP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL14ldv1000_data_wP16_laserdisc_statehh,0,__ZL16ldv1000_status_rP16_laserdisc_state,0,__ZL23ldv1000_status_strobe_rP16_laserdisc_state,0,__ZL24ldv1000_command_strobe_rP16_laserdisc_state,0,__ZL31construct_machine_config_pr8210R14machine_configP8device_t,0,__ZL11pr8210_initP16_laserdisc_state,0,__ZL12pr8210_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL13pr8210_updateP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL14pr8210_overlayP16_laserdisc_stateP8bitmap_t,0,__ZL16pr8210_control_wP16_laserdisc_statehh,0,__ZL33construct_machine_config_simutrekR14machine_configP8device_t,0,__ZL13simutrek_initP16_laserdisc_state,0,__ZL14simutrek_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL15simutrek_updateP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL15simutrek_data_wP16_laserdisc_statehh,0,__ZL16simutrek_ready_rP16_laserdisc_state,0,__ZL17simutrek_status_rP16_laserdisc_state,0,__ZL30construct_machine_config_vp931R14machine_configP8device_t,0,__ZL10vp931_initP16_laserdisc_state,0,__ZL11vp931_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL12vp931_updateP16_laserdisc_statePK13_vbi_metadatai8attotime,0,__ZL12vp931_data_wP16_laserdisc_statehh,0,__ZL12vp931_data_rP16_laserdisc_state,0,__ZL11vp931_readyP16_laserdisc_state,0,__ZL16vp931_data_readyP16_laserdisc_state,0,__Z14device_creatorI14ppi8255_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZN14ppi8255_deviceD1Ev,0,__ZN14ppi8255_deviceD0Ev,0,__ZN14ppi8255_device22device_config_completeEv,0,__ZN14ppi8255_device12device_startEv,0,__ZN14ppi8255_device12device_resetEv,0,__ZN14ppi8255_device16device_post_loadEv,0,__ZN14ppi8255_device20device_clock_changedEv,0,__ZN20resource_pool_objectI14ppi8255_deviceED1Ev,0,__ZN20resource_pool_objectI14ppi8255_deviceED0Ev,0,__Z14device_creatorI13z80ctc_deviceEP8device_tRK14machine_configPKcS2_j,0,__ZN13z80ctc_deviceD1Ev,0,__ZN13z80ctc_deviceD0Ev,0,__ZN13z80ctc_device22device_config_completeEv,0,__ZN13z80ctc_device12device_startEv,0,__ZN13z80ctc_device12device_resetEv,0,__ZN13z80ctc_device18z80daisy_irq_stateEv,0,__ZN13z80ctc_device16z80daisy_irq_ackEv,0,__ZN13z80ctc_device17z80daisy_irq_retiEv,0,__ZThn356_N13z80ctc_deviceD1Ev,0,__ZThn356_N13z80ctc_deviceD0Ev,0,__ZThn356_N13z80ctc_device18z80daisy_irq_stateEv,0,__ZThn356_N13z80ctc_device16z80daisy_irq_ackEv,0,__ZThn356_N13z80ctc_device17z80daisy_irq_retiEv,0,__ZN20resource_pool_objectI13z80ctc_deviceED1Ev,0,__ZN20resource_pool_objectI13z80ctc_deviceED0Ev,0,__ZN14samples_deviceD1Ev,0,__ZN14samples_deviceD0Ev,0,__ZThn368_N14samples_deviceD1Ev,0,__ZThn368_N14samples_deviceD0Ev,0,__ZN20resource_pool_objectI14samples_deviceED1Ev,0,__ZN20resource_pool_objectI14samples_deviceED0Ev,0,__ZN19resource_pool_arrayI15_sample_channelED1Ev,0,__ZN19resource_pool_arrayI15_sample_channelED0Ev,0,__ZN12core_optionsD2Ev,0,__ZN12core_optionsD0Ev,0,__ZL15zlib_codec_initP9_chd_file,0,__ZL15zlib_codec_freeP9_chd_file,0,__ZL19zlib_codec_compressP9_chd_filePKvPj,0,__ZL21zlib_codec_decompressP9_chd_filejPv,0,__ZL13av_codec_initP9_chd_file,0,__ZL13av_codec_freeP9_chd_file,0,__ZL17av_codec_compressP9_chd_filePKvPj,0,__ZL19av_codec_decompressP9_chd_filejPv,0,__ZL15av_codec_configP9_chd_fileiPv,0,__ZL16normal_prologTokPK8encodingPKcS3_PS3_,0,__ZL17normal_contentTokPK8encodingPKcS3_PS3_,0,__ZL22normal_cdataSectionTokPK8encodingPKcS3_PS3_,0,__ZL23normal_ignoreSectionTokPK8encodingPKcS3_PS3_,0,__ZL24normal_attributeValueTokPK8encodingPKcS3_PS3_,0,__ZL21normal_entityValueTokPK8encodingPKcS3_PS3_,0,__ZL15normal_sameNamePK8encodingPKcS3_,0,__ZL23normal_nameMatchesAsciiPK8encodingPKcS3_S3_,0,__ZL17normal_nameLengthPK8encodingPKc,0,__ZL12normal_skipSPK8encodingPKc,0,__ZL14normal_getAttsPK8encodingPKciP9ATTRIBUTE,0,__ZL20normal_charRefNumberPK8encodingPKc,0,__ZL27normal_predefinedEntityNamePK8encodingPKcS3_,0,__ZL21normal_updatePositionPK8encodingPKcS3_P8position,0,__ZL17normal_isPublicIdPK8encodingPKcS3_PS3_,0,__ZL12ascii_toUtf8PK8encodingPPKcS3_PPcS3_,0,__ZL14latin1_toUtf16PK8encodingPPKcS3_PPtPKt,0,__ZL17little2_prologTokPK8encodingPKcS3_PS3_,0,__ZL18little2_contentTokPK8encodingPKcS3_PS3_,0,__ZL23little2_cdataSectionTokPK8encodingPKcS3_PS3_,0,__ZL24little2_ignoreSectionTokPK8encodingPKcS3_PS3_,0,__ZL25little2_attributeValueTokPK8encodingPKcS3_PS3_,0,__ZL22little2_entityValueTokPK8encodingPKcS3_PS3_,0,__ZL16little2_sameNamePK8encodingPKcS3_,0,__ZL24little2_nameMatchesAsciiPK8encodingPKcS3_S3_,0,__ZL18little2_nameLengthPK8encodingPKc,0,__ZL13little2_skipSPK8encodingPKc,0,__ZL15little2_getAttsPK8encodingPKciP9ATTRIBUTE,0,__ZL21little2_charRefNumberPK8encodingPKc,0,__ZL28little2_predefinedEntityNamePK8encodingPKcS3_,0,__ZL22little2_updatePositionPK8encodingPKcS3_P8position,0,__ZL18little2_isPublicIdPK8encodingPKcS3_PS3_,0,__ZL14little2_toUtf8PK8encodingPPKcS3_PPcS3_,0,__ZL15little2_toUtf16PK8encodingPPKcS3_PPtPKt,0,__ZL14big2_prologTokPK8encodingPKcS3_PS3_,0,__ZL15big2_contentTokPK8encodingPKcS3_PS3_,0,__ZL20big2_cdataSectionTokPK8encodingPKcS3_PS3_,0,__ZL21big2_ignoreSectionTokPK8encodingPKcS3_PS3_,0,__ZL22big2_attributeValueTokPK8encodingPKcS3_PS3_,0,__ZL19big2_entityValueTokPK8encodingPKcS3_PS3_,0,__ZL13big2_sameNamePK8encodingPKcS3_,0,__ZL21big2_nameMatchesAsciiPK8encodingPKcS3_S3_,0,__ZL15big2_nameLengthPK8encodingPKc,0,__ZL10big2_skipSPK8encodingPKc,0,__ZL12big2_getAttsPK8encodingPKciP9ATTRIBUTE,0,__ZL18big2_charRefNumberPK8encodingPKc,0,__ZL25big2_predefinedEntityNamePK8encodingPKcS3_,0,__ZL19big2_updatePositionPK8encodingPKcS3_P8position,0,__ZL15big2_isPublicIdPK8encodingPKcS3_PS3_,0,__ZL11big2_toUtf8PK8encodingPPKcS3_PPcS3_,0,__ZL12big2_toUtf16PK8encodingPPKcS3_PPtPKt,0,__ZL11utf8_toUtf8PK8encodingPPKcS3_PPcS3_,0,__ZL12utf8_toUtf16PK8encodingPPKcS3_PPtPKt,0,__ZL12utf8_isName2PK8encodingPKc,0,__ZL12utf8_isName3PK8encodingPKc,0,__ZL7isNeverPK8encodingPKc,0,__ZL14utf8_isNmstrt2PK8encodingPKc,0,__ZL14utf8_isNmstrt3PK8encodingPKc,0,__ZL15utf8_isInvalid2PK8encodingPKc,0,__ZL15utf8_isInvalid3PK8encodingPKc,0,__ZL15utf8_isInvalid4PK8encodingPKc,0,__ZL13latin1_toUtf8PK8encodingPPKcS3_PPcS3_,0,__ZL16wavfile_identifyP15_cassette_imageP15CassetteOptions,0,__ZL12wavfile_loadP15_cassette_image,0,__ZL12wavfile_saveP15_cassette_imagePK12CassetteInfo,0,_deflate_stored,0,_deflate_fast,0,_deflate_slow,0,__ZNSt3__111__stdoutbufIwED0Ev,0,__ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI10_mbstate_tEEj,0,__ZNSt3__111__stdoutbufIwE4syncEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi,0,__ZNSt3__111__stdoutbufIwE8overflowEj,0,__ZNSt3__110__stdinbufIwED0Ev,0,__ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv,0,__ZNSt3__110__stdinbufIwE9underflowEv,0,__ZNSt3__110__stdinbufIwE5uflowEv,0,__ZNSt3__110__stdinbufIwE9pbackfailEj,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj,0,__ZNSt3__111__stdoutbufIcED0Ev,0,__ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI10_mbstate_tEEj,0,__ZNSt3__111__stdoutbufIcE4syncEv,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci,0,__ZNSt3__111__stdoutbufIcE8overflowEi,0,__ZNSt3__110__stdinbufIcED0Ev,0,__ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv,0,__ZNSt3__110__stdinbufIcE9underflowEv,0,__ZNSt3__110__stdinbufIcE5uflowEv,0,__ZNSt3__110__stdinbufIcE9pbackfailEi,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi,0,__ZNSt3__114__shared_countD2Ev,0,__ZNSt3__114__shared_countD0Ev,0,__ZNSt11logic_errorD2Ev,0,__ZNSt11logic_errorD0Ev,0,__ZNKSt11logic_error4whatEv,0,__ZNSt13runtime_errorD0Ev,0,__ZNKSt13runtime_error4whatEv,0,__ZNSt12length_errorD0Ev,0,__ZNSt3__114error_categoryD2Ev,0,__ZNSt3__114error_categoryD0Ev,0,__ZNKSt3__114error_category23default_error_conditionEi,0,__ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE,0,__ZNKSt3__114error_category10equivalentERKNS_10error_codeEi,0,__ZNSt3__112system_errorD2Ev,0,__ZNSt3__112system_errorD0Ev,0,__ZNSt3__112__do_messageD1Ev,0,__ZNSt3__112__do_messageD0Ev,0,__ZNKSt3__112__do_message7messageEi,0,__ZNSt9exceptionD2Ev,0,__ZNSt9exceptionD0Ev,0,__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__19basic_iosIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__19basic_iosIwNS_11char_traitsIwEEED0Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev,0,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE,0,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,0,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,0,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,0,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,0,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,0,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,0,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,0,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,0,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,0,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,0,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,0,__ZNSt3__18ios_base7failureD0Ev,0,__ZNSt3__18ios_baseD2Ev,0,__ZNSt3__18ios_baseD0Ev,0,__ZNSt3__119__iostream_categoryD0Ev,0,__ZNKSt3__119__iostream_category4nameEv,0,__ZNKSt3__119__iostream_category7messageEi,0,__ZNSt3__17collateIcED1Ev,0,__ZNSt3__17collateIcED0Ev,0,__ZNSt3__16locale5facet16__on_zero_sharedEv,0,__ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_,0,__ZNKSt3__17collateIcE12do_transformEPKcS3_,0,__ZNKSt3__17collateIcE7do_hashEPKcS3_,0,__ZNSt3__17collateIwED1Ev,0,__ZNSt3__17collateIwED0Ev,0,__ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_,0,__ZNKSt3__17collateIwE12do_transformEPKwS3_,0,__ZNKSt3__17collateIwE7do_hashEPKwS3_,0,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,0,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,0,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,0,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,0,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce,0,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv,0,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe,0,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv,0,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,0,__ZNKSt3__120__time_get_c_storageIcE7__weeksEv,0,__ZNKSt3__120__time_get_c_storageIcE8__monthsEv,0,__ZNKSt3__120__time_get_c_storageIcE7__am_pmEv,0,__ZNKSt3__120__time_get_c_storageIcE3__cEv,0,__ZNKSt3__120__time_get_c_storageIcE3__rEv,0,__ZNKSt3__120__time_get_c_storageIcE3__xEv,0,__ZNKSt3__120__time_get_c_storageIcE3__XEv,0,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,0,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,0,__ZNKSt3__120__time_get_c_storageIwE7__weeksEv,0,__ZNKSt3__120__time_get_c_storageIwE8__monthsEv,0,__ZNKSt3__120__time_get_c_storageIwE7__am_pmEv,0,__ZNKSt3__120__time_get_c_storageIwE3__cEv,0,__ZNKSt3__120__time_get_c_storageIwE3__rEv,0,__ZNKSt3__120__time_get_c_storageIwE3__xEv,0,__ZNKSt3__120__time_get_c_storageIwE3__XEv,0,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc,0,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc,0,__ZNSt3__110moneypunctIcLb0EED1Ev,0,__ZNSt3__110moneypunctIcLb0EED0Ev,0,__ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv,0,__ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv,0,__ZNKSt3__110moneypunctIcLb0EE11do_groupingEv,0,__ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv,0,__ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv,0,__ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv,0,__ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv,0,__ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv,0,__ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv,0,__ZNSt3__110moneypunctIcLb1EED1Ev,0,__ZNSt3__110moneypunctIcLb1EED0Ev,0,__ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv,0,__ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv,0,__ZNKSt3__110moneypunctIcLb1EE11do_groupingEv,0,__ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv,0,__ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv,0,__ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv,0,__ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv,0,__ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv,0,__ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv,0,__ZNSt3__110moneypunctIwLb0EED1Ev,0,__ZNSt3__110moneypunctIwLb0EED0Ev,0,__ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv,0,__ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv,0,__ZNKSt3__110moneypunctIwLb0EE11do_groupingEv,0,__ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv,0,__ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv,0,__ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv,0,__ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv,0,__ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv,0,__ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv,0,__ZNSt3__110moneypunctIwLb1EED1Ev,0,__ZNSt3__110moneypunctIwLb1EED0Ev,0,__ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv,0,__ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv,0,__ZNKSt3__110moneypunctIwLb1EE11do_groupingEv,0,__ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv,0,__ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv,0,__ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv,0,__ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv,0,__ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv,0,__ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv,0,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,0,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE,0,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,0,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE,0,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,0,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,0,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce,0,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE,0,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,0,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,0,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe,0,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE,0,__ZNSt3__18messagesIcED1Ev,0,__ZNSt3__18messagesIcED0Ev,0,__ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,0,__ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,0,__ZNKSt3__18messagesIcE8do_closeEi,0,__ZNSt3__18messagesIwED1Ev,0,__ZNSt3__18messagesIwED0Ev,0,__ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,0,__ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE,0,__ZNKSt3__18messagesIwE8do_closeEi,0,__ZNSt3__16locale5__impD2Ev,0,__ZNSt3__16locale5__impD0Ev,0,__ZNSt3__15ctypeIcED2Ev,0,__ZNSt3__15ctypeIcED0Ev,0,__ZNKSt3__15ctypeIcE10do_toupperEc,0,__ZNKSt3__15ctypeIcE10do_toupperEPcPKc,0,__ZNKSt3__15ctypeIcE10do_tolowerEc,0,__ZNKSt3__15ctypeIcE10do_tolowerEPcPKc,0,__ZNKSt3__15ctypeIcE8do_widenEc,0,__ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc,0,__ZNKSt3__15ctypeIcE9do_narrowEcc,0,__ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc,0,__ZNSt3__17codecvtIwc10_mbstate_tED2Ev,0,__ZNSt3__17codecvtIwc10_mbstate_tED0Ev,0,__ZNKSt3__17codecvtIwc10_mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_,0,__ZNKSt3__17codecvtIwc10_mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_,0,__ZNKSt3__17codecvtIwc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__17codecvtIwc10_mbstate_tE11do_encodingEv,0,__ZNKSt3__17codecvtIwc10_mbstate_tE16do_always_noconvEv,0,__ZNKSt3__17codecvtIwc10_mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNKSt3__17codecvtIwc10_mbstate_tE13do_max_lengthEv,0,__ZNSt3__18numpunctIcED2Ev,0,__ZNSt3__18numpunctIcED0Ev,0,__ZNKSt3__18numpunctIcE16do_decimal_pointEv,0,__ZNKSt3__18numpunctIcE16do_thousands_sepEv,0,__ZNKSt3__18numpunctIcE11do_groupingEv,0,__ZNKSt3__18numpunctIcE11do_truenameEv,0,__ZNKSt3__18numpunctIcE12do_falsenameEv,0,__ZNSt3__18numpunctIwED2Ev,0,__ZNSt3__18numpunctIwED0Ev,0,__ZNKSt3__18numpunctIwE16do_decimal_pointEv,0,__ZNKSt3__18numpunctIwE16do_thousands_sepEv,0,__ZNKSt3__18numpunctIwE11do_groupingEv,0,__ZNKSt3__18numpunctIwE11do_truenameEv,0,__ZNKSt3__18numpunctIwE12do_falsenameEv,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__16locale5facetD0Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__15ctypeIwED0Ev,0,__ZNKSt3__15ctypeIwE5do_isEjw,0,__ZNKSt3__15ctypeIwE5do_isEPKwS3_Pj,0,__ZNKSt3__15ctypeIwE10do_scan_isEjPKwS3_,0,__ZNKSt3__15ctypeIwE11do_scan_notEjPKwS3_,0,__ZNKSt3__15ctypeIwE10do_toupperEw,0,__ZNKSt3__15ctypeIwE10do_toupperEPwPKw,0,__ZNKSt3__15ctypeIwE10do_tolowerEw,0,__ZNKSt3__15ctypeIwE10do_tolowerEPwPKw,0,__ZNKSt3__15ctypeIwE8do_widenEc,0,__ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw,0,__ZNKSt3__15ctypeIwE9do_narrowEwc,0,__ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__17codecvtIcc10_mbstate_tED0Ev,0,__ZNKSt3__17codecvtIcc10_mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_,0,__ZNKSt3__17codecvtIcc10_mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_,0,__ZNKSt3__17codecvtIcc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__17codecvtIcc10_mbstate_tE11do_encodingEv,0,__ZNKSt3__17codecvtIcc10_mbstate_tE16do_always_noconvEv,0,__ZNKSt3__17codecvtIcc10_mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNKSt3__17codecvtIcc10_mbstate_tE13do_max_lengthEv,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__17codecvtItc10_mbstate_tED0Ev,0,__ZNKSt3__17codecvtItc10_mbstate_tE6do_outERS1_PKtS5_RS5_PcS7_RS7_,0,__ZNKSt3__17codecvtItc10_mbstate_tE5do_inERS1_PKcS5_RS5_PtS7_RS7_,0,__ZNKSt3__17codecvtItc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__17codecvtItc10_mbstate_tE11do_encodingEv,0,__ZNKSt3__17codecvtItc10_mbstate_tE16do_always_noconvEv,0,__ZNKSt3__17codecvtItc10_mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNKSt3__17codecvtItc10_mbstate_tE13do_max_lengthEv,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__17codecvtIjc10_mbstate_tED0Ev,0,__ZNKSt3__17codecvtIjc10_mbstate_tE6do_outERS1_PKjS5_RS5_PcS7_RS7_,0,__ZNKSt3__17codecvtIjc10_mbstate_tE5do_inERS1_PKcS5_RS5_PjS7_RS7_,0,__ZNKSt3__17codecvtIjc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_,0,__ZNKSt3__17codecvtIjc10_mbstate_tE11do_encodingEv,0,__ZNKSt3__17codecvtIjc10_mbstate_tE16do_always_noconvEv,0,__ZNKSt3__17codecvtIjc10_mbstate_tE9do_lengthERS1_PKcS5_j,0,__ZNKSt3__17codecvtIjc10_mbstate_tE13do_max_lengthEv,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__116__narrow_to_utf8ILj32EED0Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__117__widen_from_utf8ILj32EED0Ev,0,__ZNSt8bad_castD0Ev,0,__ZNKSt8bad_cast4whatEv,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZN10__cxxabiv117__class_type_infoD0Ev,0,__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv,0,__ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i,0,__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi,0,__ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZN10__cxxabiv120__si_class_type_infoD0Ev,0,__ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i,0,__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi,0,__ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZN10__cxxabiv121__vmi_class_type_infoD0Ev,0,__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i,0,__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi,0,__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,0,__ZNSt9bad_allocD0Ev,0,__ZNKSt9bad_alloc4whatEv,0,__ZN18mini_osd_interfaceC2Ev,0,__ZN18mini_osd_interfaceD2Ev,0,__ZN12i8748_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN12i8049_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN10z80_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN25device_z80daisy_interfaceD2Ev,0,__ZN15z80_daisy_chain11daisy_entryC2EP8device_t,0,__ZN17input_port_configC2ER8device_tPKc,0,__ZN18input_field_configC2ER17input_port_configijjPKc,0,__ZN20input_setting_configC2ER18input_field_configjPKc,0,__ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seq,0,__ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seqS3_S3_,0,__ZN12timer_deviceC2ERK14machine_configPKcP8device_tj,0,__ZN15cartslot_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN20software_list_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN13resource_poolC2Ei,0,__ZN13resource_poolD2Ev,0,__ZN11cli_optionsC2Ev,0,__ZN12cli_frontendC2ER11cli_optionsR13osd_interface,0,__ZN12cli_frontendD2Ev,0,__ZN16media_identifierC2ER11cli_options,0,__ZN14machine_configC2ERK11game_driverR11emu_options,0,__ZN14machine_configD2Ev,0,__ZN11device_listC2ER13resource_pool,0,__ZN8device_tD2Ev,0,__ZN8device_t16auto_finder_baseD2Ev,0,__ZN16device_interfaceD2Ev,0,__ZN18address_map_entry8C2ER11address_mapjj,0,__ZN11address_mapC2ERK8device_t16address_spacenum,0,__ZN11address_mapD2Ev,0,__ZN22device_image_interfaceD2Ev,0,__ZN20address_space_configC2Ev,0,__ZN23device_memory_interfaceD2Ev,0,__ZN12joystick_mapC2Ev,0,__ZN10input_codeC2ER12input_device13input_item_id,0,__ZN12input_deviceC2ER11input_classiPKcPv,0,__ZN11input_classC2ER13input_manager18input_device_classbb,0,__ZN13input_managerC2ER15running_machine,0,__ZN24input_device_switch_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E,0,__ZN26input_device_relative_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E,0,__ZN26input_device_absolute_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E,0,__ZN12device_debugC2ER8device_t,0,__ZN12device_debugD2Ev,0,__ZN12device_debug10breakpointC2ER12symbol_tableijPKcS4_,0,__ZN12device_debug10watchpointC2ER12symbol_tableiR13address_spaceijjPKcS6_,0,__ZN12device_debug6tracerC2ERS_R7__sFILEbPKc,0,__ZN12device_debug6tracerD2Ev,0,__ZN12device_debug12dasm_commentC2EPKcjjj,0,__ZN12save_managerC2ER15running_machine,0,__ZN12save_manager14state_callbackC2E8delegateIFvvEE,0,__ZN12save_manager11state_entryC2EPvPKchj,0,__ZN15running_machineC2ERK14machine_configR13osd_interfaceb,0,__ZN15running_machineD2Ev,0,__ZN13memory_regionC2ER15running_machinePKcjh12endianness_t,0,__ZN13memory_regionD2Ev,0,__ZN15running_machine22notifier_callback_itemC2E8delegateIFvvEE,0,__ZN15running_machine22logerror_callback_itemC2EPFvRS_PKcE,0,__ZN13driver_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_,0,__ZN13driver_deviceD2Ev,0,__ZN11system_timeC2Ev,0,__ZN13osd_interfaceD2Ev,0,__ZN21render_primitive_listC2Ev,0,__ZN21render_primitive_listD2Ev,0,__ZN14render_textureC2Ev,0,__ZN14render_textureD2Ev,0,__ZN16render_containerC2ER14render_managerP13screen_device,0,__ZN16render_containerD2Ev,0,__ZN16render_container13user_settingsC2Ev,0,__ZN13render_targetC2ER14render_managerPKcj,0,__ZN13render_targetD2Ev,0,__ZN14render_managerC2ER15running_machine,0,__ZN14render_managerD2Ev,0,__ZN13screen_deviceC2ERK14machine_configPKcP8device_tj,0,__ZN13screen_deviceD2Ev,0,__ZN9emu_timerC2Ev,0,__ZN9emu_timerD2Ev,0,__ZN16device_schedulerC2ER15running_machine,0,__ZN16device_schedulerD2Ev,0,__ZN13address_spaceD2Ev,0,__ZN13address_tableD2Ev,0,__ZN18address_table_readC2ER13address_spaceb,0,__ZN18address_table_readD2Ev,0,__ZN19address_table_writeC2ER13address_spaceb,0,__ZN19address_table_writeD2Ev,0,__ZN16direct_read_dataC2ER13address_space,0,__ZN16direct_read_dataD2Ev,0,__ZN12memory_blockC2ER13address_spacejjPv,0,__ZN12memory_blockD2Ev,0,__ZN11memory_bankC2ER13address_spaceijjPKc,0,__ZN11memory_bankD2Ev,0,__ZN13handler_entryD2Ev,0,__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC2EPKNS_11__list_nodeIS2_S3_EE,0,__ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC2ESC_,0,__ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC2ESE_,0,__ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC2ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE,0,__ZNSt3__121__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPKNS_11__tree_nodeIS8_PvEEiEC2ENS_15__tree_iteratorIS8_PSB_iEE,0,__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC2EPNS_11__list_nodeIS2_S3_EE,0,__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC2ENS_15__list_iteratorIS2_S3_EE,0,__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED2Ev,0,__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC2ERSG_,0,__ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEC2ERSC_,0,__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2EPSB_SE_,0,__ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ESC_SF_,0,__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ENS_4__rvISF_EE,0,__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED2Ev,0,__ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC2ERS7_j,0,__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2EPS5_S9_,0,__ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2ES6_SA_,0,__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEC2ERKS8_,0,__ZNSt3__119__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEELb1EEC2ES8_,0,__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC2ERKSC_,0,__ZNSt3__117__compressed_pairIjNS_19__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEENS_4lessIhEELb1EEEEC2EjSA_,0,__ZNSt3__117__compressed_pairINS_15__tree_end_nodeIPNS_16__tree_node_baseIPvEEEENS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS7_ISC_EEEEEES3_EEEEEC2Ev,0,__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC2Ev,0,__ZNSt3__117__compressed_pairIjNS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC2Eji,0,__ZNSt3__116__list_node_baseIN12_GLOBAL__N_18subrangeEPvEC2Ev,0,__ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED2Ev,0,__ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED2Ev,0,__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED2Ev,0,__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEED2Ev,0,__ZNSt3__14pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEEED2Ev,0,__ZN12_GLOBAL__N_18subrangeC2Ejj,0,__ZN10cpu_deviceD2Ev,0,__ZN17legacy_cpu_deviceD2Ev,0,__ZN18device_state_entryC2EiPKcPvh,0,__ZN22device_state_interfaceD2Ev,0,__ZN18legacy_device_baseD2Ev,0,__ZN24device_execute_interfaceD2Ev,0,__ZN24device_execute_interface12device_inputC2Ev,0,__ZN15cheat_parameterC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node,0,__ZN12cheat_scriptC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node,0,__ZN12cheat_script12script_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb,0,__ZN12cheat_script12script_entry15output_argumentC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node,0,__ZN11cheat_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node,0,__ZN11cheat_entryD2Ev,0,__ZN13cheat_managerC2ER15running_machine,0,__ZN12sound_streamC2ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE,0,__ZN12sound_stream12stream_inputC2Ev,0,__ZN12sound_stream13stream_outputC2Ev,0,__ZN13sound_managerC2ER15running_machine,0,__ZN13sound_managerD2Ev,0,__ZN17driver_enumeratorC2ER11emu_options,0,__ZN17driver_enumeratorC2ER11emu_optionsPKc,0,__ZN17driver_enumeratorC2ER11emu_optionsRK11game_driver,0,__ZN17driver_enumeratorD2Ev,0,__ZN17driver_enumerator12config_entryC2ER14machine_configi,0,__ZN17driver_enumerator12config_entryD2Ev,0,__ZN14layout_elementC2ER15running_machineR14_xml_data_nodePKc,0,__ZN14layout_elementD2Ev,0,__ZN14layout_element7textureC2Ev,0,__ZN14layout_element7textureD2Ev,0,__ZN14layout_element9componentC2ER15running_machineR14_xml_data_nodePKc,0,__ZN14layout_element9componentD2Ev,0,__ZN11layout_viewC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE,0,__ZN11layout_viewD2Ev,0,__ZN11layout_view4itemC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE,0,__ZN11layout_view4itemD2Ev,0,__ZN11layout_fileC2ER15running_machineR14_xml_data_nodePKc,0,__ZN11layout_fileD2Ev,0,__ZN11render_fontC2ER14render_managerPKc,0,__ZN11render_fontD2Ev,0,__ZN12symbol_entryD2Ev,0,__ZN20integer_symbol_entryC2ER12symbol_tablePKcNS0_10read_writeEPy,0,__ZN20integer_symbol_entryC2ER12symbol_tablePKcPvPFyS1_S4_EPFvS1_S4_yE,0,__ZN21function_symbol_entryC2ER12symbol_tablePKcPviiPFyS1_S4_iPKyE,0,__ZN12symbol_tableC2EPvPS_,0,__ZN17parsed_expressionC2EP12symbol_tablePKcPy,0,__ZN17parsed_expression11parse_tokenC2Ei,0,__ZN13media_auditorC2ERK17driver_enumerator,0,__ZN12audit_recordC2ERK9rom_entryNS_10media_typeE,0,__ZN12audit_recordC2EPKcNS_10media_typeE,0,__ZN13video_managerC2ER15running_machine,0,__ZN8hash_crcC2Ev,0,__ZN8hash_md5C2Ev,0,__ZN9hash_sha1C2Ev,0,__ZN15hash_collectionC2Ev,0,__ZN15hash_collectionC2EPKc,0,__ZN15hash_collectionD2Ev,0,__ZN16info_xml_creatorC2ER17driver_enumerator,0,__ZN17debug_view_sourceD2Ev,0,__ZN22debug_view_source_listC2ER15running_machine,0,__ZN22debug_view_source_listD2Ev,0,__ZN10debug_viewD2Ev,0,__ZN18debug_view_managerC2ER15running_machine,0,__ZN18debug_view_managerD2Ev,0,__ZN21debug_view_expressionC2ER15running_machine,0,__ZN21debug_view_expressionD2Ev,0,__ZN22device_sound_interfaceD2Ev,0,__ZN23device_disasm_interfaceD2Ev,0,__ZN24legacy_image_device_baseD2Ev,0,__ZN13path_iteratorC2EPKc,0,__ZN15file_enumeratorC2EPKc,0,__ZN15file_enumeratorD2Ev,0,__ZN8emu_fileC2Ej,0,__ZN8emu_fileC2EPKcj,0,__ZN8emu_fileD2Ev,0,__ZN20dummy_profiler_stateC2Ev,0,__ZN10ram_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN14speaker_deviceC2ERK14machine_configPKcP8device_tj,0,__ZN14speaker_deviceD2Ev,0,__ZN21cassette_image_deviceC2ERK14machine_configPKcP8device_tj,0,__ZN21cassette_image_deviceD2Ev,0,__ZN16bitbanger_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN16laserdisc_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN18debug_view_textbufD2Ev,0,__ZN18debug_view_consoleC2ER15running_machinePFvR10debug_viewPvES4_,0,__ZN14debug_view_logC2ER15running_machinePFvR10debug_viewPvES4_,0,__ZN23debug_view_state_sourceC2EPKcR8device_t,0,__ZN16debug_view_stateC2ER15running_machinePFvR10debug_viewPvES4_,0,__ZN16debug_view_stateD2Ev,0,__ZN16debug_view_state10state_itemC2EiPKch,0,__ZN24debug_view_disasm_sourceC2EPKcR8device_t,0,__ZN17debug_view_disasmC2ER15running_machinePFvR10debug_viewPvES4_,0,__ZN17debug_view_disasmD2Ev,0,__ZN24debug_view_memory_sourceC2EPKcR13address_space,0,__ZN24debug_view_memory_sourceC2EPKcRK13memory_region,0,__ZN24debug_view_memory_sourceC2EPKcPvii,0,__ZN17debug_view_memoryC2ER15running_machinePFvR10debug_viewPvES4_,0,__ZN14ppi8255_deviceC2ERK14machine_configPKcP8device_tj,0,__ZN13z80ctc_deviceC2ERK14machine_configPKcP8device_tj,0,__ZN13z80ctc_device11ctc_channelC2Ev,0,__ZN25devcb_resolved_write_lineC2Ev,0,__ZN20devcb_resolved_read8C2Ev,0,__ZN21devcb_resolved_write8C2Ev,0,__ZN14samples_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j,0,__ZN8bitmap_tC2Ev,0,__ZN8bitmap_tC2Eii14_bitmap_formatii,0,__ZN8bitmap_tC2EPviii14_bitmap_format,0,__ZN8bitmap_tD2Ev,0,__ZN7astringD2Ev,0,__ZN12core_options5entryC2ERK13options_entry,0,__ZN12core_optionsD2Ev,0,__ZNSt3__18ios_base4InitC2Ev,0,__ZNSt3__18ios_base4InitD2Ev,0,__ZNSt3__114__shared_countD2Ev,0,__ZNSt11logic_errorD2Ev,0,__ZNSt13runtime_errorC2EPKc,0,__ZNSt13runtime_errorD2Ev,0,__ZNSt11logic_errorD2Ev,0,__ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev,0,__ZN12_GLOBAL__N_114__libcpp_nmstrC2EPKc,0,__ZNSt3__114error_categoryD2Ev,0,__ZNSt3__112system_errorD2Ev,0,__ZNSt9exceptionD2Ev,0,__ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE,0,__ZNSt3__18ios_base7failureD2Ev,0,__ZNSt3__18ios_baseD2Ev,0,__ZNSt3__16locale5__impC2Ej,0,__ZNSt3__16locale5__impD2Ev,0,__ZNSt3__16localeC2Ev,0,__ZNSt3__16localeC2ERKS0_,0,__ZNSt3__16localeD2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__15ctypeIcEC2EPKjbj,0,__ZNSt3__15ctypeIcED2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__17codecvtIwc10_mbstate_tEC2Ej,0,__ZNSt3__17codecvtIwc10_mbstate_tED2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__16locale5facetD2Ev,0,__ZNSt3__18numpunctIcEC2Ej,0,__ZNSt3__18numpunctIwEC2Ej,0,__ZNSt3__18numpunctIcED2Ev,0,__ZNSt3__18numpunctIwED2Ev,0,__ZNSt3__117__call_once_paramINS_12_GLOBAL__N_111__fake_bindEEC2ERKS2_,0,__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED2Ev,0,__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEEC2EPS2_,0,__ZNSt3__117__compressed_pairIPNS_6locale5facetENS_12_GLOBAL__N_17releaseEEC2ES3_i,0,__ZNSt3__112_GLOBAL__N_111__fake_bindC2EMNS_6locale2idEFvvEPS3_,0,__ZNSt8bad_castC2Ev,0,__ZNSt8bad_castD2Ev,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZN10__cxxabiv116__shim_type_infoD2Ev,0,__ZNSt9bad_allocC2Ev,0,__ZNSt9bad_allocD2Ev,0]; Module["FUNCTION_TABLE"] = FUNCTION_TABLE;


function run(args) {
  args = args || Module['arguments'];

  initRuntime();

  var ret = null;
  if (Module['_main']) {
    ret = Module.callMain(args);
    exitRuntime();
  }
  return ret;
}
Module['run'] = run;

// {{PRE_RUN_ADDITIONS}}

if (Module['preRun']) {
  Module['preRun']();
}


if (!Module['noInitialRun']) {
  var ret = run();
}

// {{POST_RUN_ADDITIONS}}

if (Module['postRun']) {
  Module['postRun']();
}





  // {{MODULE_ADDITIONS}}


// EMSCRIPTEN_GENERATED_FUNCTIONS: ["__ZN18resource_pool_itemD2Ev","__ZN18resource_pool_itemC2EPvj","__ZNK8device_t7machineEv","__ZN12coleco_state12paddle_off_wER13address_spacejhh","__ZN12coleco_state11paddle_on_wER13address_spacejhh","__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEptEv","__ZNK13memory_region4baseEv","__ZN7astringC1Ev","__ZN20resource_pool_objectI13driver_deviceEC1EPS0_","__ZN20resource_pool_objectI13driver_deviceEC2EPS0_","__ZN20resource_pool_objectI13driver_deviceED1Ev","__ZN18resource_pool_itemD1Ev","__ZN7astringC2Ev","__ZN12coleco_state10paddle_1_rER13address_spacejh","__ZN12coleco_state10paddle_2_rER13address_spacejh","__ZN12coleco_state13machine_startEv","__ZN12coleco_state13machine_resetEv","__ZN24device_execute_interface21set_input_line_vectorEii","__ZN15running_machine6regionEPKc","__Z21driver_device_creatorI13driver_deviceEP8device_tRK14machine_configPKcS2_j","__ZN13resource_pool10add_objectI13driver_deviceEEPT_S3_","__ZN20resource_pool_objectI13driver_deviceED0Ev","__ZN20resource_pool_objectI13driver_deviceED2Ev","__ZN18resource_pool_itemD0Ev","__Z8downcastIP12coleco_state13driver_deviceET_PT0_","__ZN13emu_exceptionC2Ev","__ZN10input_codeC2E18input_device_classi16input_item_class19input_item_modifier13input_item_id","__ZN8attotimeC2Eix","__ZN16device_interface6deviceEv","__ZN22device_image_interface14software_entryEv","__ZN12coleco_stateD1Ev","__ZN8device_t15required_deviceI10cpu_deviceED1Ev","__ZN8device_t15required_deviceI10cpu_deviceED2Ev","__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED2Ev","__ZN10input_codeC1E18input_device_classi16input_item_class19input_item_modifier13input_item_id","__ZL16coleco_interruptP8device_t","__ZL15paddle_callbackR12timer_devicePvi","__ZN8attotime9from_msecEx","__ZN8attotimeC1Eix","__ZNK15running_machine11driver_dataI12coleco_stateEEPT_v","__ZN24device_execute_interface14set_input_lineEii","__ZN22device_image_interface6lengthEv","__ZN22device_image_interface5freadEPvj","__ZN14emu_fatalerrorC1EPKcz","__ZN14emu_fatalerrorD1Ev","__ZN14emu_fatalerrorD2Ev","__ZN13emu_exceptionD2Ev","__ZL31construct_machine_config_colecoR14machine_configP8device_t","__ZN12coleco_stateD0Ev","__ZN12coleco_stateD2Ev","__Z21driver_device_creatorI12coleco_stateEP8device_tRK14machine_configPKcS2_j","__ZN22device_image_interface14check_for_fileEv","__ZN21delegate_internal_mfpC2IM12coleco_stateFhR13address_spacejhEEET_","__ZN21delegate_internal_mfpC2IM12coleco_stateFvR13address_spacejhhEEET_","__ZN17address_map_entry10set_mirrorEj","__ZN21delegate_internal_mfpC2ERKS_","__ZN17address_map_entry13set_read_typeE16map_handler_type","__ZN17address_map_entry14set_write_typeE16map_handler_type","__ZN13emu_exceptionD1Ev","__ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEE","__ZN8delegateIFvR13address_spacejhhEEC1I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_","__ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_","__ZN18address_map_entry811set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEE","__ZN8delegateIFhR13address_spacejhEEC1I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_","__ZN8delegateIFhR13address_spacejhEEC2I12coleco_stateEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseIhR13address_spacejh8_noparamEC2I12coleco_stateEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM12coleco_stateFhR13address_spacejhEEET_","__ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI12coleco_stateEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIhR13address_spacejh8_noparamE4bindEP22delegate_generic_class","__ZN8delegateIFhR13address_spacejhEEC1ERKS3_","__ZN8delegateIFhR13address_spacejhEEC2ERKS3_","__ZN13delegate_baseIhR13address_spacejh8_noparamEC2ERKS3_","__ZN21delegate_internal_mfpC1ERKS_","__ZN8delegateIFvR13address_spacejhhEEC2I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejhhEC2I12coleco_stateEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM12coleco_stateFvR13address_spacejhhEEET_","__ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI12coleco_stateEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejhhE4bindEP22delegate_generic_class","__ZN8delegateIFvR13address_spacejhhEEC1ERKS3_","__ZN8delegateIFvR13address_spacejhhEEC2ERKS3_","__ZN13delegate_baseIvR13address_spacejhhEC2ERKS2_","__ZN12coleco_stateC1ERK14machine_configPFP8device_tS2_PKcS4_jES6_","__ZN8device_t15required_deviceI10cpu_deviceEC1ERS_PKc","__ZN8device_t15required_deviceI10cpu_deviceEC2ERS_PKc","__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EEC2ERS_PKc","__ZN14emu_fatalerrorD0Ev","__ZN13emu_exceptionD0Ev","__ZN13resource_pool10add_objectI12coleco_stateEEPT_S3_","__ZN12coleco_stateC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_","__Z8downcastIP10cpu_device8device_tET_PT0_","__ZL11tagmap_hashPKc","__ZN24device_execute_interface12device_input10set_vectorEi","__ZN8device_t15required_deviceI10cpu_deviceE6finditERS_","__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED1Ev","__ZN20resource_pool_objectI12coleco_stateEC1EPS0_","__ZN20resource_pool_objectI12coleco_stateEC2EPS0_","__ZN20resource_pool_objectI12coleco_stateED1Ev","__ZL32construct_address_map_coleco_mapR11address_mapRK8device_t","__ZL35construct_address_map_coleco_io_mapR11address_mapRK8device_t","__ZNK11tagged_listI13memory_regionE4findEPKc","__ZNK8tagmap_tIP13memory_regionE14find_hash_onlyEPKc","__ZL21tagmap_find_hash_onlyPK7_tagmapPKc","__ZL20coleco_vdp_interruptR15running_machinei","__Z19coleco_scan_paddlesR15running_machinePiS1_","__ZN8device_t15required_deviceI10cpu_deviceED0Ev","__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EE10set_targetES2_","__ZN8device_t16auto_finder_typeIP10cpu_deviceLb1EED0Ev","__ZN20resource_pool_objectI12coleco_stateED0Ev","__ZN20resource_pool_objectI12coleco_stateED2Ev","__Z19coleco_paddle1_readR15running_machineii","__Z19coleco_paddle2_readR15running_machineii","__Z23construct_ioport_colecoR8device_tR11tagged_listI17input_port_configER7astring","__ZL22construct_ioport_ctrl1R8device_tR11tagged_listI17input_port_configER7astring","__ZL22construct_ioport_ctrl2R8device_tR11tagged_listI17input_port_configER7astring","__ZL21construct_ioport_sac1R8device_tR11tagged_listI17input_port_configER7astring","__ZN11cli_optionsD1Ev","__ZN18mini_osd_interfaceC2Ev","__ZN18mini_osd_interfaceD2Ev","__ZL21construct_ioport_sac2R8device_tR11tagged_listI17input_port_configER7astring","__ZL24construct_ioport_drivingR8device_tR11tagged_listI17input_port_configER7astring","__ZL23construct_ioport_rollerR8device_tR11tagged_listI17input_port_configER7astring","_main","__ZN18mini_osd_interfaceD0Ev","__ZN18mini_osd_interface19update_audio_streamEPKsi","__ZN18mini_osd_interface16set_mastervolumeEi","__ZN18mini_osd_interface25customize_input_type_listER11simple_listI16input_type_entryE","__ZL18keyboard_get_statePvS_","__Z8downcastIP17legacy_cpu_device8device_tET_PT0_","__ZNK15running_machine6renderEv","__ZNK15running_machine5inputEv","__ZN13input_manager12device_classE18input_device_class","__ZgtRK8attotimeS1_","__ZNK13osd_interface7machineEv","__ZN15running_machine9schedulerEv","__ZN18mini_osd_interface6updateEb","__ZN21render_primitive_list12acquire_lockEv","__ZN21render_primitive_list12release_lockEv","__ZNK15running_machine4timeEv","__ZN8attotime12from_secondsEi","__ZN14emu_fatalerrorC1EPKcPc","__ZN14emu_fatalerrorC2EPKcPc","__ZN11cli_optionsD2Ev","__ZN11emu_optionsD2Ev","__ZL14get_safe_tokenP8device_t","__ZN16device_scheduler11synchronizeEPFvR15running_machinePviEPKciS2_","__Z18cpu_get_info_i8748P17legacy_cpu_devicejP7cpuinfo","__Z18cpu_get_info_i8049P17legacy_cpu_devicejP7cpuinfo","__ZN12i8748_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN18mini_osd_interface4initER15running_machine","__Z10fatalerrorPKcz","__ZL22mcs48_generic_get_infoP17legacy_cpu_devicejP7cpuinfohiiPKc","__Z21legacy_device_creatorI12i8748_deviceEP8device_tRK14machine_configPKcS2_j","__ZNK17legacy_cpu_device19memory_space_configE16address_spacenum","__ZN12i8049_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZNK17legacy_cpu_device17device_rom_regionEv","__ZNK17legacy_cpu_device24device_mconfig_additionsEv","__ZNK17legacy_cpu_device18device_input_portsEv","__ZNK17legacy_cpu_device18execute_min_cyclesEv","__ZNK17legacy_cpu_device18execute_max_cyclesEv","__ZNK17legacy_cpu_device19execute_input_linesEv","__ZNK17legacy_cpu_device26execute_default_irq_vectorEv","__ZN17legacy_cpu_device17execute_set_inputEii","__ZNK17legacy_cpu_device23disasm_min_opcode_bytesEv","__ZNK17legacy_cpu_device23disasm_max_opcode_bytesEv","__ZThn356_NK17legacy_cpu_device18execute_min_cyclesEv","__ZThn356_NK17legacy_cpu_device18execute_max_cyclesEv","__ZThn356_NK17legacy_cpu_device19execute_input_linesEv","__ZThn356_NK17legacy_cpu_device26execute_default_irq_vectorEv","__ZThn356_N17legacy_cpu_device17execute_set_inputEii","__ZThn5968_NK17legacy_cpu_device19memory_space_configE16address_spacenum","__ZThn7088_NK17legacy_cpu_device23disasm_min_opcode_bytesEv","__ZThn7088_NK17legacy_cpu_device23disasm_max_opcode_bytesEv","__ZN12i8049_deviceD1Ev","__ZThn356_N12i8049_deviceD1Ev","__ZThn356_N12i8049_deviceD0Ev","__ZThn5968_N12i8049_deviceD1Ev","__ZThn5968_N12i8049_deviceD0Ev","__ZThn6012_N12i8049_deviceD1Ev","__ZThn6012_N12i8049_deviceD0Ev","__ZThn7088_N12i8049_deviceD1Ev","__ZThn7088_N12i8049_deviceD0Ev","__ZN12i8748_deviceD1Ev","__ZThn356_N12i8748_deviceD1Ev","__ZThn356_N12i8748_deviceD0Ev","__ZThn5968_N12i8748_deviceD1Ev","__ZThn5968_N12i8748_deviceD0Ev","__ZThn6012_N12i8748_deviceD1Ev","__ZThn6012_N12i8748_deviceD0Ev","__ZThn7088_N12i8748_deviceD1Ev","__ZThn7088_N12i8748_deviceD0Ev","__ZN12i8748_deviceD2Ev","__ZN12i8049_deviceD2Ev","__ZN20resource_pool_objectI12i8049_deviceEC1EPS0_","__ZN20resource_pool_objectI12i8049_deviceEC2EPS0_","__Z21legacy_device_creatorI12i8049_deviceEP8device_tRK14machine_configPKcS2_j","__ZN12i8049_deviceD0Ev","__ZN12i8748_deviceD0Ev","__ZN13resource_pool10add_objectI12i8049_deviceEEPT_S3_","__ZNK17legacy_cpu_device5tokenEv","__ZN20resource_pool_objectI12i8049_deviceED1Ev","__ZN20resource_pool_objectI12i8748_deviceEC1EPS0_","__ZN20resource_pool_objectI12i8748_deviceEC2EPS0_","__ZN20resource_pool_objectI12i8748_deviceED1Ev","__ZL20cpu_init_mcs48_noromP17legacy_cpu_devicePFiP8device_tiE","__ZL21cpu_init_upi41_1k_romP17legacy_cpu_devicePFiP8device_tiE","__ZL21cpu_init_mcs48_1k_romP17legacy_cpu_devicePFiP8device_tiE","__ZL21cpu_init_upi41_2k_romP17legacy_cpu_devicePFiP8device_tiE","__ZL21cpu_init_mcs48_2k_romP17legacy_cpu_devicePFiP8device_tiE","__ZL21cpu_init_mcs48_4k_romP17legacy_cpu_devicePFiP8device_tiE","__ZL35construct_address_map_program_10bitR11address_mapRK8device_t","__ZL35construct_address_map_program_11bitR11address_mapRK8device_t","__ZL35construct_address_map_program_12bitR11address_mapRK8device_t","__ZL31construct_address_map_data_6bitR11address_mapRK8device_t","__ZL31construct_address_map_data_7bitR11address_mapRK8device_t","__ZL31construct_address_map_data_8bitR11address_mapRK8device_t","__ZL18cpu_get_info_mcs48P17legacy_cpu_devicejP7cpuinfo","__ZN20resource_pool_objectI12i8049_deviceED0Ev","__ZN20resource_pool_objectI12i8049_deviceED2Ev","__ZN13resource_pool10add_objectI12i8748_deviceEEPT_S3_","__ZN20resource_pool_objectI12i8748_deviceED0Ev","__ZN20resource_pool_objectI12i8748_deviceED2Ev","__ZL3nopP12_mcs48_state","__ZNK18device_state_entry5indexEv","__ZL5dec_aP12_mcs48_state","__ZL18cpu_set_info_mcs48P17legacy_cpu_devicejP7cpuinfo","__ZL15cpu_reset_mcs48P17legacy_cpu_device","__ZL17cpu_execute_mcs48P17legacy_cpu_device","__ZL23cpu_string_export_mcs48P17legacy_cpu_deviceRK18device_state_entryR7astring","__ZN7astring6printfEPKcz","__ZL13update_regptrP12_mcs48_state","__ZL10check_irqsP12_mcs48_state","__ZL11burn_cyclesP12_mcs48_statei","__ZL25debugger_instruction_hookP8device_tj","__ZL12opcode_fetchP12_mcs48_state","__ZL7illegalP12_mcs48_state","__ZL8split_02P12_mcs48_state","__ZL7add_a_nP12_mcs48_state","__ZL5jmp_0P12_mcs48_state","__ZL4en_iP12_mcs48_state","__ZL8split_08P12_mcs48_state","__ZL7in_a_p1P12_mcs48_state","__ZL7in_a_p2P12_mcs48_state","__ZL9movd_a_p4P12_mcs48_state","__ZL9movd_a_p5P12_mcs48_state","__ZL9movd_a_p6P12_mcs48_state","__ZL9movd_a_p7P12_mcs48_state","__ZL22cpu_state_import_mcs48P17legacy_cpu_deviceRK18device_state_entry","__ZL22cpu_state_export_mcs48P17legacy_cpu_deviceRK18device_state_entry","__ZL5dis_iP12_mcs48_state","__ZL5inc_aP12_mcs48_state","__ZL6inc_r0P12_mcs48_state","__ZL6inc_r1P12_mcs48_state","__ZL6inc_r2P12_mcs48_state","__ZL6inc_r3P12_mcs48_state","__ZL6inc_r4P12_mcs48_state","__ZL6inc_r5P12_mcs48_state","__ZL6inc_r6P12_mcs48_state","__ZL6inc_r7P12_mcs48_state","__ZL5clr_aP12_mcs48_state","__ZL8xch_a_r0P12_mcs48_state","__ZL8xch_a_r1P12_mcs48_state","__ZL8xch_a_r2P12_mcs48_state","__ZL8xch_a_r3P12_mcs48_state","__ZL8xch_a_r4P12_mcs48_state","__ZL8xch_a_r5P12_mcs48_state","__ZL8xch_a_r6P12_mcs48_state","__ZL8xch_a_r7P12_mcs48_state","__ZL9dis_tcntiP12_mcs48_state","__ZL5cpl_aP12_mcs48_state","__ZL7mov_a_tP12_mcs48_state","__ZL7inc_xr0P12_mcs48_state","__ZL7inc_xr1P12_mcs48_state","__ZL4jb_0P12_mcs48_state","__ZL7adc_a_nP12_mcs48_state","__ZL6call_0P12_mcs48_state","__ZL3jtfP12_mcs48_state","__ZL9xch_a_xr0P12_mcs48_state","__ZL9xch_a_xr1P12_mcs48_state","__ZL8split_22P12_mcs48_state","__ZL7mov_a_nP12_mcs48_state","__ZL5jmp_1P12_mcs48_state","__ZL8en_tcntiP12_mcs48_state","__ZL5jnt_0P12_mcs48_state","__ZL10xchd_a_xr0P12_mcs48_state","__ZL10xchd_a_xr1P12_mcs48_state","__ZL4jb_1P12_mcs48_state","__ZL6call_1P12_mcs48_state","__ZL4jt_0P12_mcs48_state","__ZL9outl_p1_aP12_mcs48_state","__ZL9outl_p2_aP12_mcs48_state","__ZL9movd_p4_aP12_mcs48_state","__ZL9movd_p5_aP12_mcs48_state","__ZL9movd_p6_aP12_mcs48_state","__ZL9movd_p7_aP12_mcs48_state","__ZL9orl_a_xr0P12_mcs48_state","__ZL9orl_a_xr1P12_mcs48_state","__ZL7orl_a_nP12_mcs48_state","__ZL5jmp_2P12_mcs48_state","__ZL8strt_cntP12_mcs48_state","__ZL5jnt_1P12_mcs48_state","__ZL6swap_aP12_mcs48_state","__ZL8orl_a_r0P12_mcs48_state","__ZL8orl_a_r1P12_mcs48_state","__ZL8orl_a_r2P12_mcs48_state","__ZL8orl_a_r3P12_mcs48_state","__ZL8orl_a_r4P12_mcs48_state","__ZL8orl_a_r5P12_mcs48_state","__ZL8orl_a_r6P12_mcs48_state","__ZL8orl_a_r7P12_mcs48_state","__ZL6strt_tP12_mcs48_state","__ZL4da_aP12_mcs48_state","__ZL8anl_a_r0P12_mcs48_state","__ZL8anl_a_r1P12_mcs48_state","__ZL8anl_a_r2P12_mcs48_state","__ZL8anl_a_r3P12_mcs48_state","__ZL8anl_a_r4P12_mcs48_state","__ZL8anl_a_r5P12_mcs48_state","__ZL8anl_a_r6P12_mcs48_state","__ZL8anl_a_r7P12_mcs48_state","__ZL7mov_t_aP12_mcs48_state","__ZL9stop_tcntP12_mcs48_state","__ZL5rrc_aP12_mcs48_state","__ZL4rr_aP12_mcs48_state","__ZL9anl_a_xr0P12_mcs48_state","__ZL9anl_a_xr1P12_mcs48_state","__ZL4jb_2P12_mcs48_state","__ZL7anl_a_nP12_mcs48_state","__ZL6call_2P12_mcs48_state","__ZL4jt_1P12_mcs48_state","__ZL9add_a_xr0P12_mcs48_state","__ZL9add_a_xr1P12_mcs48_state","__ZL5jmp_3P12_mcs48_state","__ZL8add_a_r0P12_mcs48_state","__ZL8add_a_r1P12_mcs48_state","__ZL8add_a_r2P12_mcs48_state","__ZL8add_a_r3P12_mcs48_state","__ZL8add_a_r4P12_mcs48_state","__ZL8add_a_r5P12_mcs48_state","__ZL8add_a_r6P12_mcs48_state","__ZL8add_a_r7P12_mcs48_state","__ZL9adc_a_xr0P12_mcs48_state","__ZL9adc_a_xr1P12_mcs48_state","__ZL4jb_3P12_mcs48_state","__ZL6call_3P12_mcs48_state","__ZL8split_75P12_mcs48_state","__ZL3jf1P12_mcs48_state","__ZL8adc_a_r0P12_mcs48_state","__ZL8adc_a_r1P12_mcs48_state","__ZL8adc_a_r2P12_mcs48_state","__ZL8adc_a_r3P12_mcs48_state","__ZL8adc_a_r4P12_mcs48_state","__ZL8adc_a_r5P12_mcs48_state","__ZL8adc_a_r6P12_mcs48_state","__ZL8adc_a_r7P12_mcs48_state","__ZL8split_80P12_mcs48_state","__ZL6clr_f0P12_mcs48_state","__ZL6cpl_f0P12_mcs48_state","__ZL5clr_cP12_mcs48_state","__ZL6clr_f1P12_mcs48_state","__ZL5cpl_cP12_mcs48_state","__ZL8mov_r0_aP12_mcs48_state","__ZL8mov_r1_aP12_mcs48_state","__ZL8mov_r2_aP12_mcs48_state","__ZL8mov_r3_aP12_mcs48_state","__ZL8mov_r4_aP12_mcs48_state","__ZL8mov_r5_aP12_mcs48_state","__ZL8mov_r6_aP12_mcs48_state","__ZL8mov_r7_aP12_mcs48_state","__ZL6cpl_f1P12_mcs48_state","__ZL9mov_a_pswP12_mcs48_state","__ZL6dec_r0P12_mcs48_state","__ZL6dec_r1P12_mcs48_state","__ZL6dec_r2P12_mcs48_state","__ZL6dec_r3P12_mcs48_state","__ZL6dec_r4P12_mcs48_state","__ZL6dec_r5P12_mcs48_state","__ZL6dec_r6P12_mcs48_state","__ZL8split_81P12_mcs48_state","__ZL3retP12_mcs48_state","__ZL5jmp_4P12_mcs48_state","__ZL8split_86P12_mcs48_state","__ZL8split_88P12_mcs48_state","__ZL8orl_p1_nP12_mcs48_state","__ZL8orl_p2_nP12_mcs48_state","__ZL9orld_p4_aP12_mcs48_state","__ZL9orld_p5_aP12_mcs48_state","__ZL9orld_p6_aP12_mcs48_state","__ZL9orld_p7_aP12_mcs48_state","__ZL8split_90P12_mcs48_state","__ZL8split_91P12_mcs48_state","__ZL4jb_4P12_mcs48_state","__ZL4retrP12_mcs48_state","__ZL6call_4P12_mcs48_state","__ZL3jnzP12_mcs48_state","__ZL8split_98P12_mcs48_state","__ZL8anl_p1_nP12_mcs48_state","__ZL8anl_p2_nP12_mcs48_state","__ZL9anld_p4_aP12_mcs48_state","__ZL9anld_p5_aP12_mcs48_state","__ZL9anld_p6_aP12_mcs48_state","__ZL9anld_p7_aP12_mcs48_state","__ZL9mov_xr0_aP12_mcs48_state","__ZL9mov_xr1_aP12_mcs48_state","__ZL9movp_a_xaP12_mcs48_state","__ZL5jmp_5P12_mcs48_state","__ZL9mov_xr0_nP12_mcs48_state","__ZL9mov_xr1_nP12_mcs48_state","__ZL4jb_5P12_mcs48_state","__ZL7jmpp_xaP12_mcs48_state","__ZL6call_5P12_mcs48_state","__ZL3jf0P12_mcs48_state","__ZL8mov_r0_nP12_mcs48_state","__ZL8mov_r1_nP12_mcs48_state","__ZL8mov_r2_nP12_mcs48_state","__ZL8mov_r3_nP12_mcs48_state","__ZL8mov_r4_nP12_mcs48_state","__ZL8mov_r5_nP12_mcs48_state","__ZL8mov_r6_nP12_mcs48_state","__ZL8mov_r7_nP12_mcs48_state","__ZL5jmp_6P12_mcs48_state","__ZL7sel_rb0P12_mcs48_state","__ZL2jzP12_mcs48_state","__ZL6dec_r7P12_mcs48_state","__ZL8xrl_a_r0P12_mcs48_state","__ZL8xrl_a_r1P12_mcs48_state","__ZL8xrl_a_r2P12_mcs48_state","__ZL8xrl_a_r3P12_mcs48_state","__ZL8xrl_a_r4P12_mcs48_state","__ZL8xrl_a_r5P12_mcs48_state","__ZL8xrl_a_r6P12_mcs48_state","__ZL8xrl_a_r7P12_mcs48_state","__ZL4rl_aP12_mcs48_state","__ZL5rlc_aP12_mcs48_state","__ZL8mov_a_r0P12_mcs48_state","__ZL8mov_a_r1P12_mcs48_state","__ZL8mov_a_r2P12_mcs48_state","__ZL8mov_a_r3P12_mcs48_state","__ZL8mov_a_r4P12_mcs48_state","__ZL8mov_a_r5P12_mcs48_state","__ZL8mov_a_r6P12_mcs48_state","__ZL8mov_a_r7P12_mcs48_state","__ZL7sel_mb1P12_mcs48_state","__ZL9xrl_a_xr0P12_mcs48_state","__ZL9xrl_a_xr1P12_mcs48_state","__ZL4jb_6P12_mcs48_state","__ZL7xrl_a_nP12_mcs48_state","__ZL6call_6P12_mcs48_state","__ZL7sel_rb1P12_mcs48_state","__ZL8split_d6P12_mcs48_state","__ZL9mov_psw_aP12_mcs48_state","__ZL10movp3_a_xaP12_mcs48_state","__ZL5jmp_7P12_mcs48_state","__ZL8split_e5P12_mcs48_state","__ZL3jncP12_mcs48_state","__ZL7djnz_r0P12_mcs48_state","__ZL7djnz_r1P12_mcs48_state","__ZL7djnz_r2P12_mcs48_state","__ZL7djnz_r3P12_mcs48_state","__ZL7djnz_r4P12_mcs48_state","__ZL7djnz_r5P12_mcs48_state","__ZL7djnz_r6P12_mcs48_state","__ZL7djnz_r7P12_mcs48_state","__ZL9mov_a_xr0P12_mcs48_state","__ZL9mov_a_xr1P12_mcs48_state","__ZL4jb_7P12_mcs48_state","__ZL6call_7P12_mcs48_state","__ZL8split_f5P12_mcs48_state","__ZL2jcP12_mcs48_state","__ZL11execute_jccP12_mcs48_stateh","__ZL14argument_fetchP12_mcs48_state","__ZN16direct_read_data13read_raw_byteEjj","__ZN16direct_read_data16address_is_validEj","__ZL8en_flagsP12_mcs48_state","__ZL12execute_callP12_mcs48_statet","__ZL11execute_jmpP12_mcs48_statet","__ZL7sel_mb0P12_mcs48_state","__ZL7p2_maskP12_mcs48_state","__ZL9mov_sts_aP12_mcs48_state","__ZL12execute_addcP12_mcs48_stateh","__ZL11execute_addP12_mcs48_stateh","__ZL11push_pc_pswP12_mcs48_state","__ZL6en_dmaP12_mcs48_state","__ZL5jnibfP12_mcs48_state","__ZL18expander_operationP12_mcs48_statehh","__ZL9anl_bus_nP12_mcs48_state","__ZL11pull_pc_pswP12_mcs48_state","__ZL10movx_xr1_aP12_mcs48_state","__ZL10movx_xr0_aP12_mcs48_state","__ZL9orl_bus_nP12_mcs48_state","__ZL3jniP12_mcs48_state","__ZL4jobfP12_mcs48_state","__ZL7pull_pcP12_mcs48_state","__ZL10movx_a_xr1P12_mcs48_state","__ZL10movx_a_xr0P12_mcs48_state","__ZL8ent0_clkP12_mcs48_state","__ZL8in_a_dbbP12_mcs48_state","__ZL9ins_a_busP12_mcs48_state","__ZL10outl_bus_aP12_mcs48_state","__ZL9out_dbb_aP12_mcs48_state","__ZNK8device_t5debugEv","__ZNK23device_memory_interface5spaceE16address_spacenum","__ZNK13address_space6directEv","__ZN8device_t9interfaceERP22device_state_interface","__ZN18device_state_entry6noshowEv","__ZN18device_state_entry10callimportEv","__ZN18device_state_entry10callexportEv","__ZNK16device_scheduler7machineEv","__ZN21delegate_internal_mfpC2Ev","__ZN16direct_read_data19read_decrypted_byteEjj","__ZN22device_state_interface9state_addItEER18device_state_entryiPKcRT_","__ZN18device_state_entry4maskEy","__ZN22device_state_interface9state_addIhEER18device_state_entryiPKcRT_","__ZN7astring6formatEPKcz","__ZNK7astringcvPKcEv","__ZN8device_t9save_itemItEEvRT_PKci","__ZN8device_t9save_itemIhEEvRT_PKci","__ZN12save_manager9save_itemIhEEvPKcS2_iRT_S2_","__ZNK8device_t4nameEv","__ZNK8device_t3tagEv","__ZN12save_manager9save_itemItEEvPKcS2_iRT_S2_","__ZN16device_scheduler9timer_setE8attotimePFvR15running_machinePviEPKciS3_","__ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_","__ZN8delegateIFvPviEEC2I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E20static_ref_func_typeEPKcPS6_","__ZN13delegate_baseIvPvi8_noparamS1_EC2I15running_machineEEN15delegate_traitsIT_vS0_iS1_S1_E20static_ref_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1Ev","__ZN13delegate_baseIvPvi8_noparamS1_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvPvi8_noparamS1_E4bindEP22delegate_generic_class","__ZL14get_safe_tokenP8device_t305","__ZL10mcs48_initP17legacy_cpu_devicePFiP8device_tiEht","__Z16cpu_get_info_z80P17legacy_cpu_devicejP7cpuinfo","__ZL16cpu_set_info_z80P17legacy_cpu_devicejP7cpuinfo","__ZL12cpu_init_z80P17legacy_cpu_devicePFiP8device_tiE","__ZL13cpu_reset_z80P17legacy_cpu_device","__ZL12cpu_exit_z80P17legacy_cpu_device","__ZL15cpu_execute_z80P17legacy_cpu_device","__ZL21cpu_string_export_z80P17legacy_cpu_deviceRK18device_state_entryR7astring","__ZN10z80_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN10z80_deviceD1Ev","__ZThn356_N10z80_deviceD1Ev","__ZThn356_N10z80_deviceD0Ev","__ZThn5968_N10z80_deviceD1Ev","__ZThn5968_N10z80_deviceD0Ev","__ZThn6012_N10z80_deviceD1Ev","__ZThn6012_N10z80_deviceD0Ev","__ZThn7088_N10z80_deviceD1Ev","__ZThn7088_N10z80_deviceD0Ev","__ZN10z80_deviceD2Ev","__ZN20resource_pool_objectI10z80_deviceEC1EPS0_","__ZN20resource_pool_objectI10z80_deviceEC2EPS0_","__ZN20resource_pool_objectI10z80_deviceED1Ev","__ZL4WM16P10_z80_statejP4PAIR","__ZL20cpu_state_import_z80P17legacy_cpu_deviceRK18device_state_entry","__ZL20cpu_state_export_z80P17legacy_cpu_deviceRK18device_state_entry","__Z21legacy_device_creatorI10z80_deviceEP8device_tRK14machine_configPKcS2_j","__ZN10z80_deviceD0Ev","__ZN13resource_pool10add_objectI10z80_deviceEEPT_S3_","__ZN20resource_pool_objectI10z80_deviceED0Ev","__ZN20resource_pool_objectI10z80_deviceED2Ev","__ZL5op_00P10_z80_state","__ZL5op_03P10_z80_state","__ZL5op_07P10_z80_state","__ZL5op_09P10_z80_state","__ZL5op_0bP10_z80_state","__ZL5op_0fP10_z80_state","__ZL14take_interruptP10_z80_state","__ZL25debugger_instruction_hookP8device_tj306","__ZL3ROPP10_z80_state","__ZL5op_01P10_z80_state","__ZL5op_02P10_z80_state","__ZL5op_04P10_z80_state","__ZL5op_05P10_z80_state","__ZL5op_06P10_z80_state","__ZL5op_08P10_z80_state","__ZL5op_0aP10_z80_state","__ZL5op_0cP10_z80_state","__ZL5op_0dP10_z80_state","__ZL5op_0eP10_z80_state","__ZL5op_10P10_z80_state","__ZL5op_11P10_z80_state","__ZL5op_12P10_z80_state","__ZL5op_13P10_z80_state","__ZL5op_17P10_z80_state","__ZL5op_19P10_z80_state","__ZL5op_1bP10_z80_state","__ZL5op_1fP10_z80_state","__ZL5op_23P10_z80_state","__ZL5op_27P10_z80_state","__ZL5op_29P10_z80_state","__ZL5op_2bP10_z80_state","__ZL5op_14P10_z80_state","__ZL5op_15P10_z80_state","__ZL5op_16P10_z80_state","__ZL5op_18P10_z80_state","__ZL5op_1aP10_z80_state","__ZL5op_1cP10_z80_state","__ZL5op_1dP10_z80_state","__ZL5op_1eP10_z80_state","__ZL5op_20P10_z80_state","__ZL5op_21P10_z80_state","__ZL5op_22P10_z80_state","__ZL5op_24P10_z80_state","__ZL5op_25P10_z80_state","__ZL5op_26P10_z80_state","__ZL5op_28P10_z80_state","__ZL5op_2aP10_z80_state","__ZL5op_2cP10_z80_state","__ZL5op_40P10_z80_state","__ZL5op_49P10_z80_state","__ZL5op_52P10_z80_state","__ZL5op_2fP10_z80_state","__ZL5op_33P10_z80_state","__ZL5op_37P10_z80_state","__ZL5op_39P10_z80_state","__ZL5op_3bP10_z80_state","__ZL5op_3fP10_z80_state","__ZL5op_41P10_z80_state","__ZL5op_42P10_z80_state","__ZL5op_43P10_z80_state","__ZL5op_44P10_z80_state","__ZL5op_45P10_z80_state","__ZL5op_47P10_z80_state","__ZL5op_48P10_z80_state","__ZL5op_4aP10_z80_state","__ZL5op_4bP10_z80_state","__ZL5op_4cP10_z80_state","__ZL5op_4dP10_z80_state","__ZL5op_4fP10_z80_state","__ZL5op_50P10_z80_state","__ZL5op_51P10_z80_state","__ZL5op_53P10_z80_state","__ZL5op_54P10_z80_state","__ZL5op_55P10_z80_state","__ZL5op_57P10_z80_state","__ZL5op_58P10_z80_state","__ZL5op_2dP10_z80_state","__ZL5op_2eP10_z80_state","__ZL5op_30P10_z80_state","__ZL5op_31P10_z80_state","__ZL5op_32P10_z80_state","__ZL5op_34P10_z80_state","__ZL5op_35P10_z80_state","__ZL5op_36P10_z80_state","__ZL5op_38P10_z80_state","__ZL5op_3aP10_z80_state","__ZL5op_3cP10_z80_state","__ZL5op_3dP10_z80_state","__ZL5op_3eP10_z80_state","__ZL5op_46P10_z80_state","__ZL5op_4eP10_z80_state","__ZL5op_56P10_z80_state","__ZL5op_5bP10_z80_state","__ZL5op_64P10_z80_state","__ZL5op_6dP10_z80_state","__ZL5op_7fP10_z80_state","__ZL5op_59P10_z80_state","__ZL5op_5aP10_z80_state","__ZL5op_5cP10_z80_state","__ZL5op_5dP10_z80_state","__ZL5op_5fP10_z80_state","__ZL5op_60P10_z80_state","__ZL5op_61P10_z80_state","__ZL5op_62P10_z80_state","__ZL5op_63P10_z80_state","__ZL5op_65P10_z80_state","__ZL5op_67P10_z80_state","__ZL5op_68P10_z80_state","__ZL5op_69P10_z80_state","__ZL5op_6aP10_z80_state","__ZL5op_6bP10_z80_state","__ZL5op_6cP10_z80_state","__ZL5op_6fP10_z80_state","__ZL5op_78P10_z80_state","__ZL5op_79P10_z80_state","__ZL5op_7aP10_z80_state","__ZL5op_7bP10_z80_state","__ZL5op_7cP10_z80_state","__ZL5op_7dP10_z80_state","__ZL5op_80P10_z80_state","__ZL5op_81P10_z80_state","__ZL5op_82P10_z80_state","__ZL5op_83P10_z80_state","__ZL5op_84P10_z80_state","__ZL5op_85P10_z80_state","__ZL5op_5eP10_z80_state","__ZL5op_66P10_z80_state","__ZL5op_6eP10_z80_state","__ZL5op_70P10_z80_state","__ZL5op_71P10_z80_state","__ZL5op_72P10_z80_state","__ZL5op_73P10_z80_state","__ZL5op_74P10_z80_state","__ZL5op_75P10_z80_state","__ZL5op_76P10_z80_state","__ZL5op_77P10_z80_state","__ZL5op_7eP10_z80_state","__ZL5op_87P10_z80_state","__ZL5op_88P10_z80_state","__ZL5op_89P10_z80_state","__ZL5op_8aP10_z80_state","__ZL5op_8bP10_z80_state","__ZL5op_8cP10_z80_state","__ZL5op_8dP10_z80_state","__ZL5op_8fP10_z80_state","__ZL5op_90P10_z80_state","__ZL5op_91P10_z80_state","__ZL5op_92P10_z80_state","__ZL5op_93P10_z80_state","__ZL5op_94P10_z80_state","__ZL5op_95P10_z80_state","__ZL5op_86P10_z80_state","__ZL5op_8eP10_z80_state","__ZL5op_96P10_z80_state","__ZL5op_97P10_z80_state","__ZL5op_98P10_z80_state","__ZL5op_99P10_z80_state","__ZL5op_9aP10_z80_state","__ZL5op_9bP10_z80_state","__ZL5op_9cP10_z80_state","__ZL5op_9dP10_z80_state","__ZL5op_9fP10_z80_state","__ZL5op_a0P10_z80_state","__ZL5op_a1P10_z80_state","__ZL5op_a2P10_z80_state","__ZL5op_a3P10_z80_state","__ZL5op_a4P10_z80_state","__ZL5op_a5P10_z80_state","__ZL5op_a7P10_z80_state","__ZL5op_a8P10_z80_state","__ZL5op_a9P10_z80_state","__ZL5op_9eP10_z80_state","__ZL5op_a6P10_z80_state","__ZL5op_aaP10_z80_state","__ZL5op_abP10_z80_state","__ZL5op_acP10_z80_state","__ZL5op_adP10_z80_state","__ZL5op_afP10_z80_state","__ZL5op_b0P10_z80_state","__ZL5op_b1P10_z80_state","__ZL5op_b2P10_z80_state","__ZL5op_b3P10_z80_state","__ZL5op_b4P10_z80_state","__ZL5op_b5P10_z80_state","__ZL5op_b7P10_z80_state","__ZL5op_b8P10_z80_state","__ZL5op_b9P10_z80_state","__ZL5op_baP10_z80_state","__ZL5op_bbP10_z80_state","__ZL5op_bcP10_z80_state","__ZL5op_bdP10_z80_state","__ZL5op_bfP10_z80_state","__ZL5op_aeP10_z80_state","__ZL5op_b6P10_z80_state","__ZL5op_beP10_z80_state","__ZL5op_c0P10_z80_state","__ZL5op_c1P10_z80_state","__ZL5op_c2P10_z80_state","__ZL5op_c3P10_z80_state","__ZL5op_c4P10_z80_state","__ZL5op_c5P10_z80_state","__ZL5op_c6P10_z80_state","__ZL5op_c7P10_z80_state","__ZL5op_c8P10_z80_state","__ZL5op_c9P10_z80_state","__ZL5op_caP10_z80_state","__ZL5op_cbP10_z80_state","__ZL5op_ccP10_z80_state","__ZL5op_cdP10_z80_state","__ZL5op_ceP10_z80_state","__ZL5op_cfP10_z80_state","__ZL5op_d0P10_z80_state","__ZL5op_d1P10_z80_state","__ZL5op_d2P10_z80_state","__ZL5op_d3P10_z80_state","__ZL5op_d4P10_z80_state","__ZL5op_d5P10_z80_state","__ZL5op_d6P10_z80_state","__ZL5op_d7P10_z80_state","__ZL5op_d8P10_z80_state","__ZL5op_d9P10_z80_state","__ZL5op_daP10_z80_state","__ZL5op_dbP10_z80_state","__ZL5op_dcP10_z80_state","__ZL5op_ddP10_z80_state","__ZL5op_deP10_z80_state","__ZL5op_dfP10_z80_state","__ZL5op_e0P10_z80_state","__ZL5op_e1P10_z80_state","__ZL5op_e2P10_z80_state","__ZL5op_e3P10_z80_state","__ZL5op_e9P10_z80_state","__ZL5op_f3P10_z80_state","__ZL5op_e4P10_z80_state","__ZL5op_e5P10_z80_state","__ZL5op_e6P10_z80_state","__ZL5op_e7P10_z80_state","__ZL5op_e8P10_z80_state","__ZL5op_eaP10_z80_state","__ZL5op_ebP10_z80_state","__ZL5op_ecP10_z80_state","__ZL5op_edP10_z80_state","__ZL5op_eeP10_z80_state","__ZL5op_efP10_z80_state","__ZL5op_f0P10_z80_state","__ZL5op_f1P10_z80_state","__ZL5op_f2P10_z80_state","__ZL5op_f4P10_z80_state","__ZL5op_f5P10_z80_state","__ZL5op_f6P10_z80_state","__ZL5op_f7P10_z80_state","__ZL5op_f9P10_z80_state","__ZL5op_fbP10_z80_state","__ZL5fd_09P10_z80_state","__ZL5fd_19P10_z80_state","__ZL5fd_23P10_z80_state","__ZL5op_f8P10_z80_state","__ZL5op_faP10_z80_state","__ZL5op_fcP10_z80_state","__ZL5op_fdP10_z80_state","__ZL5op_feP10_z80_state","__ZL5op_ffP10_z80_state","__ZL3ARGP10_z80_state","__ZL5fd_00P10_z80_state","__ZL5fd_01P10_z80_state","__ZL5fd_02P10_z80_state","__ZL5fd_03P10_z80_state","__ZL5fd_04P10_z80_state","__ZL5fd_05P10_z80_state","__ZL5fd_06P10_z80_state","__ZL5fd_07P10_z80_state","__ZL5fd_08P10_z80_state","__ZL5fd_0aP10_z80_state","__ZL5fd_0bP10_z80_state","__ZL5fd_0cP10_z80_state","__ZL5fd_0dP10_z80_state","__ZL5fd_0eP10_z80_state","__ZL5fd_0fP10_z80_state","__ZL5fd_10P10_z80_state","__ZL5fd_11P10_z80_state","__ZL5fd_12P10_z80_state","__ZL5fd_13P10_z80_state","__ZL5fd_14P10_z80_state","__ZL5fd_15P10_z80_state","__ZL5fd_16P10_z80_state","__ZL5fd_17P10_z80_state","__ZL5fd_18P10_z80_state","__ZL5fd_1aP10_z80_state","__ZL5fd_1bP10_z80_state","__ZL5fd_1cP10_z80_state","__ZL5fd_1dP10_z80_state","__ZL5fd_1eP10_z80_state","__ZL5fd_1fP10_z80_state","__ZL5fd_20P10_z80_state","__ZL5fd_21P10_z80_state","__ZL5fd_22P10_z80_state","__ZL5fd_24P10_z80_state","__ZL5fd_25P10_z80_state","__ZL5fd_26P10_z80_state","__ZL5fd_27P10_z80_state","__ZL5fd_28P10_z80_state","__ZL5fd_29P10_z80_state","__ZL5fd_2bP10_z80_state","__ZL5fd_39P10_z80_state","__ZL5fd_44P10_z80_state","__ZL5fd_45P10_z80_state","__ZL5fd_4cP10_z80_state","__ZL5fd_4dP10_z80_state","__ZL5fd_54P10_z80_state","__ZL5fd_55P10_z80_state","__ZL5fd_5cP10_z80_state","__ZL5fd_5dP10_z80_state","__ZL5fd_2aP10_z80_state","__ZL5fd_2cP10_z80_state","__ZL5fd_2dP10_z80_state","__ZL5fd_2eP10_z80_state","__ZL5fd_2fP10_z80_state","__ZL5fd_30P10_z80_state","__ZL5fd_31P10_z80_state","__ZL5fd_32P10_z80_state","__ZL5fd_33P10_z80_state","__ZL5fd_34P10_z80_state","__ZL5fd_35P10_z80_state","__ZL5fd_36P10_z80_state","__ZL5fd_37P10_z80_state","__ZL5fd_38P10_z80_state","__ZL5fd_3aP10_z80_state","__ZL5fd_3bP10_z80_state","__ZL5fd_3cP10_z80_state","__ZL5fd_3dP10_z80_state","__ZL5fd_3eP10_z80_state","__ZL5fd_3fP10_z80_state","__ZL5fd_40P10_z80_state","__ZL5fd_41P10_z80_state","__ZL5fd_42P10_z80_state","__ZL5fd_43P10_z80_state","__ZL5fd_46P10_z80_state","__ZL5fd_47P10_z80_state","__ZL5fd_48P10_z80_state","__ZL5fd_49P10_z80_state","__ZL5fd_4aP10_z80_state","__ZL5fd_4bP10_z80_state","__ZL5fd_4eP10_z80_state","__ZL5fd_4fP10_z80_state","__ZL5fd_50P10_z80_state","__ZL5fd_51P10_z80_state","__ZL5fd_52P10_z80_state","__ZL5fd_53P10_z80_state","__ZL5fd_56P10_z80_state","__ZL5fd_57P10_z80_state","__ZL5fd_58P10_z80_state","__ZL5fd_59P10_z80_state","__ZL5fd_5aP10_z80_state","__ZL5fd_5bP10_z80_state","__ZL5fd_64P10_z80_state","__ZL5fd_6dP10_z80_state","__ZL5fd_60P10_z80_state","__ZL5fd_61P10_z80_state","__ZL5fd_62P10_z80_state","__ZL5fd_63P10_z80_state","__ZL5fd_65P10_z80_state","__ZL5fd_67P10_z80_state","__ZL5fd_68P10_z80_state","__ZL5fd_69P10_z80_state","__ZL5fd_6aP10_z80_state","__ZL5fd_6bP10_z80_state","__ZL5fd_6cP10_z80_state","__ZL5fd_6fP10_z80_state","__ZL5fd_7cP10_z80_state","__ZL5fd_7dP10_z80_state","__ZL5fd_84P10_z80_state","__ZL5fd_85P10_z80_state","__ZL5fd_5eP10_z80_state","__ZL5fd_5fP10_z80_state","__ZL5fd_66P10_z80_state","__ZL5fd_6eP10_z80_state","__ZL5fd_70P10_z80_state","__ZL5fd_71P10_z80_state","__ZL5fd_72P10_z80_state","__ZL5fd_73P10_z80_state","__ZL5fd_74P10_z80_state","__ZL5fd_75P10_z80_state","__ZL5fd_76P10_z80_state","__ZL5fd_77P10_z80_state","__ZL5fd_78P10_z80_state","__ZL5fd_79P10_z80_state","__ZL5fd_7aP10_z80_state","__ZL5fd_7bP10_z80_state","__ZL5fd_7eP10_z80_state","__ZL5fd_7fP10_z80_state","__ZL5fd_80P10_z80_state","__ZL5fd_81P10_z80_state","__ZL5fd_82P10_z80_state","__ZL5fd_83P10_z80_state","__ZL5fd_8cP10_z80_state","__ZL5fd_8dP10_z80_state","__ZL5fd_94P10_z80_state","__ZL5fd_95P10_z80_state","__ZL5fd_9cP10_z80_state","__ZL5fd_9dP10_z80_state","__ZL5fd_a4P10_z80_state","__ZL5fd_a5P10_z80_state","__ZL5fd_86P10_z80_state","__ZL5fd_87P10_z80_state","__ZL5fd_88P10_z80_state","__ZL5fd_89P10_z80_state","__ZL5fd_8aP10_z80_state","__ZL5fd_8bP10_z80_state","__ZL5fd_8eP10_z80_state","__ZL5fd_8fP10_z80_state","__ZL5fd_90P10_z80_state","__ZL5fd_91P10_z80_state","__ZL5fd_92P10_z80_state","__ZL5fd_93P10_z80_state","__ZL5fd_96P10_z80_state","__ZL5fd_97P10_z80_state","__ZL5fd_98P10_z80_state","__ZL5fd_99P10_z80_state","__ZL5fd_9aP10_z80_state","__ZL5fd_9bP10_z80_state","__ZL5fd_9eP10_z80_state","__ZL5fd_9fP10_z80_state","__ZL5fd_a0P10_z80_state","__ZL5fd_a1P10_z80_state","__ZL5fd_a2P10_z80_state","__ZL5fd_a3P10_z80_state","__ZL5fd_acP10_z80_state","__ZL5fd_adP10_z80_state","__ZL5fd_b4P10_z80_state","__ZL5fd_b5P10_z80_state","__ZL5fd_bcP10_z80_state","__ZL5fd_bdP10_z80_state","__ZL5fd_a6P10_z80_state","__ZL5fd_a7P10_z80_state","__ZL5fd_a8P10_z80_state","__ZL5fd_a9P10_z80_state","__ZL5fd_aaP10_z80_state","__ZL5fd_abP10_z80_state","__ZL5fd_aeP10_z80_state","__ZL5fd_afP10_z80_state","__ZL5fd_b0P10_z80_state","__ZL5fd_b1P10_z80_state","__ZL5fd_b2P10_z80_state","__ZL5fd_b3P10_z80_state","__ZL5fd_b6P10_z80_state","__ZL5fd_b7P10_z80_state","__ZL5fd_b8P10_z80_state","__ZL5fd_b9P10_z80_state","__ZL5fd_baP10_z80_state","__ZL5fd_bbP10_z80_state","__ZL5fd_beP10_z80_state","__ZL5fd_bfP10_z80_state","__ZL5fd_c0P10_z80_state","__ZL5fd_c1P10_z80_state","__ZL5fd_c2P10_z80_state","__ZL5fd_c3P10_z80_state","__ZL5fd_c4P10_z80_state","__ZL5fd_c5P10_z80_state","__ZL5fd_c6P10_z80_state","__ZL5fd_c7P10_z80_state","__ZL5fd_c8P10_z80_state","__ZL5fd_c9P10_z80_state","__ZL5fd_caP10_z80_state","__ZL5fd_cbP10_z80_state","__ZL5fd_ccP10_z80_state","__ZL5fd_cdP10_z80_state","__ZL5fd_ceP10_z80_state","__ZL5fd_cfP10_z80_state","__ZL5fd_d0P10_z80_state","__ZL5fd_d1P10_z80_state","__ZL5fd_d2P10_z80_state","__ZL5fd_d3P10_z80_state","__ZL5fd_d4P10_z80_state","__ZL5fd_d5P10_z80_state","__ZL5fd_d6P10_z80_state","__ZL5fd_d7P10_z80_state","__ZL5fd_d8P10_z80_state","__ZL5fd_e9P10_z80_state","__ZL5fd_f9P10_z80_state","__ZL5fd_d9P10_z80_state","__ZL5fd_daP10_z80_state","__ZL5fd_dbP10_z80_state","__ZL5fd_dcP10_z80_state","__ZL5fd_ddP10_z80_state","__ZL5fd_deP10_z80_state","__ZL5fd_dfP10_z80_state","__ZL5fd_e0P10_z80_state","__ZL5fd_e1P10_z80_state","__ZL5fd_e2P10_z80_state","__ZL5fd_e3P10_z80_state","__ZL5fd_e4P10_z80_state","__ZL5fd_e5P10_z80_state","__ZL5fd_e6P10_z80_state","__ZL5fd_e7P10_z80_state","__ZL5fd_e8P10_z80_state","__ZL5fd_eaP10_z80_state","__ZL5fd_ebP10_z80_state","__ZL5fd_ecP10_z80_state","__ZL5fd_edP10_z80_state","__ZL5fd_eeP10_z80_state","__ZL5fd_efP10_z80_state","__ZL5fd_f0P10_z80_state","__ZL5fd_f1P10_z80_state","__ZL5fd_f2P10_z80_state","__ZL5fd_f3P10_z80_state","__ZL5fd_f4P10_z80_state","__ZL5fd_f5P10_z80_state","__ZL5fd_f6P10_z80_state","__ZL5fd_f7P10_z80_state","__ZL5fd_f8P10_z80_state","__ZL5fd_faP10_z80_state","__ZL5fd_fbP10_z80_state","__ZL5fd_fcP10_z80_state","__ZL5fd_fdP10_z80_state","__ZL5fd_feP10_z80_state","__ZL5fd_ffP10_z80_state","__ZL9illegal_1P10_z80_state","__ZL4RM16P10_z80_statejP4PAIR","__ZL7xycb_00P10_z80_state","__ZL7xycb_01P10_z80_state","__ZL7xycb_02P10_z80_state","__ZL7xycb_03P10_z80_state","__ZL7xycb_04P10_z80_state","__ZL7xycb_05P10_z80_state","__ZL7xycb_06P10_z80_state","__ZL7xycb_07P10_z80_state","__ZL7xycb_08P10_z80_state","__ZL7xycb_09P10_z80_state","__ZL7xycb_0aP10_z80_state","__ZL7xycb_0bP10_z80_state","__ZL7xycb_0cP10_z80_state","__ZL7xycb_0dP10_z80_state","__ZL7xycb_0eP10_z80_state","__ZL7xycb_0fP10_z80_state","__ZL7xycb_10P10_z80_state","__ZL7xycb_11P10_z80_state","__ZL7xycb_12P10_z80_state","__ZL7xycb_13P10_z80_state","__ZL7xycb_14P10_z80_state","__ZL7xycb_15P10_z80_state","__ZL7xycb_16P10_z80_state","__ZL7xycb_17P10_z80_state","__ZL7xycb_18P10_z80_state","__ZL7xycb_19P10_z80_state","__ZL7xycb_1aP10_z80_state","__ZL7xycb_1bP10_z80_state","__ZL7xycb_1cP10_z80_state","__ZL7xycb_1dP10_z80_state","__ZL7xycb_1eP10_z80_state","__ZL7xycb_1fP10_z80_state","__ZL7xycb_20P10_z80_state","__ZL7xycb_21P10_z80_state","__ZL7xycb_22P10_z80_state","__ZL7xycb_23P10_z80_state","__ZL7xycb_24P10_z80_state","__ZL7xycb_25P10_z80_state","__ZL7xycb_26P10_z80_state","__ZL7xycb_27P10_z80_state","__ZL7xycb_28P10_z80_state","__ZL7xycb_29P10_z80_state","__ZL7xycb_2aP10_z80_state","__ZL7xycb_2bP10_z80_state","__ZL7xycb_2cP10_z80_state","__ZL7xycb_2dP10_z80_state","__ZL7xycb_2eP10_z80_state","__ZL7xycb_2fP10_z80_state","__ZL7xycb_30P10_z80_state","__ZL7xycb_31P10_z80_state","__ZL7xycb_32P10_z80_state","__ZL7xycb_33P10_z80_state","__ZL7xycb_34P10_z80_state","__ZL7xycb_35P10_z80_state","__ZL7xycb_36P10_z80_state","__ZL7xycb_37P10_z80_state","__ZL7xycb_38P10_z80_state","__ZL7xycb_39P10_z80_state","__ZL7xycb_3aP10_z80_state","__ZL7xycb_3bP10_z80_state","__ZL7xycb_3cP10_z80_state","__ZL7xycb_3dP10_z80_state","__ZL7xycb_3eP10_z80_state","__ZL7xycb_3fP10_z80_state","__ZL7xycb_40P10_z80_state","__ZL7xycb_41P10_z80_state","__ZL7xycb_42P10_z80_state","__ZL7xycb_43P10_z80_state","__ZL7xycb_44P10_z80_state","__ZL7xycb_45P10_z80_state","__ZL7xycb_46P10_z80_state","__ZL7xycb_47P10_z80_state","__ZL7xycb_48P10_z80_state","__ZL7xycb_49P10_z80_state","__ZL7xycb_4aP10_z80_state","__ZL7xycb_4bP10_z80_state","__ZL7xycb_4cP10_z80_state","__ZL7xycb_4dP10_z80_state","__ZL7xycb_4eP10_z80_state","__ZL7xycb_4fP10_z80_state","__ZL7xycb_50P10_z80_state","__ZL7xycb_51P10_z80_state","__ZL7xycb_52P10_z80_state","__ZL7xycb_53P10_z80_state","__ZL7xycb_54P10_z80_state","__ZL7xycb_55P10_z80_state","__ZL7xycb_56P10_z80_state","__ZL7xycb_57P10_z80_state","__ZL7xycb_58P10_z80_state","__ZL7xycb_59P10_z80_state","__ZL7xycb_5aP10_z80_state","__ZL7xycb_5bP10_z80_state","__ZL7xycb_5cP10_z80_state","__ZL7xycb_5dP10_z80_state","__ZL7xycb_5eP10_z80_state","__ZL7xycb_5fP10_z80_state","__ZL7xycb_60P10_z80_state","__ZL7xycb_61P10_z80_state","__ZL7xycb_62P10_z80_state","__ZL7xycb_63P10_z80_state","__ZL7xycb_64P10_z80_state","__ZL7xycb_65P10_z80_state","__ZL7xycb_66P10_z80_state","__ZL7xycb_67P10_z80_state","__ZL7xycb_68P10_z80_state","__ZL7xycb_69P10_z80_state","__ZL7xycb_6aP10_z80_state","__ZL7xycb_6bP10_z80_state","__ZL7xycb_6cP10_z80_state","__ZL7xycb_6dP10_z80_state","__ZL7xycb_6eP10_z80_state","__ZL7xycb_6fP10_z80_state","__ZL7xycb_70P10_z80_state","__ZL7xycb_71P10_z80_state","__ZL7xycb_72P10_z80_state","__ZL7xycb_73P10_z80_state","__ZL7xycb_74P10_z80_state","__ZL7xycb_75P10_z80_state","__ZL7xycb_76P10_z80_state","__ZL7xycb_77P10_z80_state","__ZL7xycb_78P10_z80_state","__ZL7xycb_79P10_z80_state","__ZL7xycb_7aP10_z80_state","__ZL7xycb_7bP10_z80_state","__ZL7xycb_7cP10_z80_state","__ZL7xycb_7dP10_z80_state","__ZL7xycb_7eP10_z80_state","__ZL7xycb_7fP10_z80_state","__ZL7xycb_80P10_z80_state","__ZL7xycb_81P10_z80_state","__ZL7xycb_82P10_z80_state","__ZL7xycb_83P10_z80_state","__ZL7xycb_84P10_z80_state","__ZL7xycb_85P10_z80_state","__ZL7xycb_86P10_z80_state","__ZL7xycb_87P10_z80_state","__ZL7xycb_88P10_z80_state","__ZL7xycb_89P10_z80_state","__ZL7xycb_8aP10_z80_state","__ZL7xycb_8bP10_z80_state","__ZL7xycb_8cP10_z80_state","__ZL7xycb_8dP10_z80_state","__ZL7xycb_8eP10_z80_state","__ZL7xycb_8fP10_z80_state","__ZL7xycb_90P10_z80_state","__ZL7xycb_91P10_z80_state","__ZL7xycb_92P10_z80_state","__ZL7xycb_93P10_z80_state","__ZL7xycb_94P10_z80_state","__ZL7xycb_95P10_z80_state","__ZL7xycb_96P10_z80_state","__ZL7xycb_97P10_z80_state","__ZL7xycb_98P10_z80_state","__ZL7xycb_99P10_z80_state","__ZL7xycb_9aP10_z80_state","__ZL7xycb_9bP10_z80_state","__ZL7xycb_9cP10_z80_state","__ZL7xycb_9dP10_z80_state","__ZL7xycb_9eP10_z80_state","__ZL7xycb_9fP10_z80_state","__ZL7xycb_a0P10_z80_state","__ZL7xycb_a1P10_z80_state","__ZL7xycb_a2P10_z80_state","__ZL7xycb_a3P10_z80_state","__ZL7xycb_a4P10_z80_state","__ZL7xycb_a5P10_z80_state","__ZL7xycb_a6P10_z80_state","__ZL7xycb_a7P10_z80_state","__ZL7xycb_a8P10_z80_state","__ZL7xycb_a9P10_z80_state","__ZL7xycb_aaP10_z80_state","__ZL7xycb_abP10_z80_state","__ZL7xycb_acP10_z80_state","__ZL7xycb_adP10_z80_state","__ZL7xycb_aeP10_z80_state","__ZL7xycb_afP10_z80_state","__ZL7xycb_b0P10_z80_state","__ZL7xycb_b1P10_z80_state","__ZL7xycb_b2P10_z80_state","__ZL7xycb_b3P10_z80_state","__ZL7xycb_b4P10_z80_state","__ZL7xycb_b5P10_z80_state","__ZL7xycb_b6P10_z80_state","__ZL7xycb_b7P10_z80_state","__ZL7xycb_b8P10_z80_state","__ZL7xycb_b9P10_z80_state","__ZL7xycb_baP10_z80_state","__ZL7xycb_bbP10_z80_state","__ZL7xycb_bcP10_z80_state","__ZL7xycb_bdP10_z80_state","__ZL7xycb_beP10_z80_state","__ZL7xycb_bfP10_z80_state","__ZL7xycb_c0P10_z80_state","__ZL7xycb_c1P10_z80_state","__ZL7xycb_c2P10_z80_state","__ZL7xycb_c3P10_z80_state","__ZL7xycb_c4P10_z80_state","__ZL7xycb_c5P10_z80_state","__ZL7xycb_c6P10_z80_state","__ZL7xycb_c7P10_z80_state","__ZL7xycb_c8P10_z80_state","__ZL7xycb_c9P10_z80_state","__ZL7xycb_caP10_z80_state","__ZL7xycb_cbP10_z80_state","__ZL7xycb_ccP10_z80_state","__ZL7xycb_cdP10_z80_state","__ZL7xycb_ceP10_z80_state","__ZL7xycb_cfP10_z80_state","__ZL7xycb_d0P10_z80_state","__ZL7xycb_d1P10_z80_state","__ZL7xycb_d2P10_z80_state","__ZL7xycb_d3P10_z80_state","__ZL7xycb_d4P10_z80_state","__ZL7xycb_d5P10_z80_state","__ZL7xycb_d6P10_z80_state","__ZL7xycb_d7P10_z80_state","__ZL7xycb_d8P10_z80_state","__ZL7xycb_d9P10_z80_state","__ZL7xycb_daP10_z80_state","__ZL7xycb_dbP10_z80_state","__ZL7xycb_dcP10_z80_state","__ZL7xycb_ddP10_z80_state","__ZL7xycb_deP10_z80_state","__ZL7xycb_dfP10_z80_state","__ZL7xycb_e0P10_z80_state","__ZL7xycb_e1P10_z80_state","__ZL7xycb_e2P10_z80_state","__ZL7xycb_e3P10_z80_state","__ZL7xycb_e4P10_z80_state","__ZL7xycb_e5P10_z80_state","__ZL7xycb_e6P10_z80_state","__ZL7xycb_e7P10_z80_state","__ZL7xycb_e8P10_z80_state","__ZL7xycb_e9P10_z80_state","__ZL7xycb_eaP10_z80_state","__ZL7xycb_ebP10_z80_state","__ZL7xycb_ecP10_z80_state","__ZL7xycb_edP10_z80_state","__ZL7xycb_eeP10_z80_state","__ZL7xycb_efP10_z80_state","__ZL7xycb_f0P10_z80_state","__ZL7xycb_f1P10_z80_state","__ZL7xycb_f2P10_z80_state","__ZL3SEThh","__ZL3REShh","__ZL3SRLP10_z80_stateh","__ZL3SLLP10_z80_stateh","__ZL3SRAP10_z80_stateh","__ZL3SLAP10_z80_stateh","__ZL2RRP10_z80_stateh","__ZL2RLP10_z80_stateh","__ZL3RRCP10_z80_stateh","__ZL3RLCP10_z80_stateh","__ZL3DECP10_z80_stateh","__ZL3INCP10_z80_stateh","__ZL7xycb_f3P10_z80_state","__ZL7xycb_f4P10_z80_state","__ZL7xycb_f5P10_z80_state","__ZL7xycb_f6P10_z80_state","__ZL7xycb_f7P10_z80_state","__ZL7xycb_f8P10_z80_state","__ZL7xycb_f9P10_z80_state","__ZL7xycb_faP10_z80_state","__ZL7xycb_fbP10_z80_state","__ZL7xycb_fcP10_z80_state","__ZL7xycb_fdP10_z80_state","__ZL7xycb_feP10_z80_state","__ZL7xycb_ffP10_z80_state","__ZL5ARG16P10_z80_state","__ZL5ed_00P10_z80_state","__ZL5ed_01P10_z80_state","__ZL5ed_02P10_z80_state","__ZL5ed_03P10_z80_state","__ZL5ed_04P10_z80_state","__ZL5ed_05P10_z80_state","__ZL5ed_06P10_z80_state","__ZL5ed_07P10_z80_state","__ZL5ed_08P10_z80_state","__ZL5ed_09P10_z80_state","__ZL5ed_0aP10_z80_state","__ZL5ed_0bP10_z80_state","__ZL5ed_42P10_z80_state","__ZL5ed_44P10_z80_state","__ZL5ed_46P10_z80_state","__ZL5ed_47P10_z80_state","__ZL5ed_4aP10_z80_state","__ZL5ed_4cP10_z80_state","__ZL5ed_0cP10_z80_state","__ZL5ed_0dP10_z80_state","__ZL5ed_0eP10_z80_state","__ZL5ed_0fP10_z80_state","__ZL5ed_10P10_z80_state","__ZL5ed_11P10_z80_state","__ZL5ed_12P10_z80_state","__ZL5ed_13P10_z80_state","__ZL5ed_14P10_z80_state","__ZL5ed_15P10_z80_state","__ZL5ed_16P10_z80_state","__ZL5ed_17P10_z80_state","__ZL5ed_18P10_z80_state","__ZL5ed_19P10_z80_state","__ZL5ed_1aP10_z80_state","__ZL5ed_1bP10_z80_state","__ZL5ed_1cP10_z80_state","__ZL5ed_1dP10_z80_state","__ZL5ed_1eP10_z80_state","__ZL5ed_1fP10_z80_state","__ZL5ed_20P10_z80_state","__ZL5ed_21P10_z80_state","__ZL5ed_22P10_z80_state","__ZL5ed_23P10_z80_state","__ZL5ed_24P10_z80_state","__ZL5ed_25P10_z80_state","__ZL5ed_26P10_z80_state","__ZL5ed_27P10_z80_state","__ZL5ed_28P10_z80_state","__ZL5ed_29P10_z80_state","__ZL5ed_2aP10_z80_state","__ZL5ed_2bP10_z80_state","__ZL5ed_2cP10_z80_state","__ZL5ed_2dP10_z80_state","__ZL5ed_2eP10_z80_state","__ZL5ed_2fP10_z80_state","__ZL5ed_30P10_z80_state","__ZL5ed_31P10_z80_state","__ZL5ed_32P10_z80_state","__ZL5ed_33P10_z80_state","__ZL5ed_34P10_z80_state","__ZL5ed_35P10_z80_state","__ZL5ed_36P10_z80_state","__ZL5ed_37P10_z80_state","__ZL5ed_38P10_z80_state","__ZL5ed_39P10_z80_state","__ZL5ed_3aP10_z80_state","__ZL5ed_3bP10_z80_state","__ZL5ed_3cP10_z80_state","__ZL5ed_3dP10_z80_state","__ZL5ed_3eP10_z80_state","__ZL5ed_3fP10_z80_state","__ZL5ed_40P10_z80_state","__ZL5ed_41P10_z80_state","__ZL5ed_43P10_z80_state","__ZL5ed_45P10_z80_state","__ZL5ed_48P10_z80_state","__ZL5ed_49P10_z80_state","__ZL5ed_4bP10_z80_state","__ZL5ed_4eP10_z80_state","__ZL5ed_4fP10_z80_state","__ZL5ed_52P10_z80_state","__ZL5ed_54P10_z80_state","__ZL5ed_56P10_z80_state","__ZL5ed_57P10_z80_state","__ZL5ed_5aP10_z80_state","__ZL5ed_5cP10_z80_state","__ZL5ed_5eP10_z80_state","__ZL5ed_5fP10_z80_state","__ZL5ed_4dP10_z80_state","__ZL5ed_50P10_z80_state","__ZL5ed_51P10_z80_state","__ZL5ed_53P10_z80_state","__ZL5ed_55P10_z80_state","__ZL5ed_58P10_z80_state","__ZL5ed_59P10_z80_state","__ZL5ed_5bP10_z80_state","__ZL5ed_5dP10_z80_state","__ZL5ed_60P10_z80_state","__ZL5ed_61P10_z80_state","__ZL5ed_62P10_z80_state","__ZL5ed_64P10_z80_state","__ZL5ed_66P10_z80_state","__ZL5ed_6aP10_z80_state","__ZL5ed_6cP10_z80_state","__ZL5ed_6eP10_z80_state","__ZL5ed_72P10_z80_state","__ZL5ed_63P10_z80_state","__ZL5ed_65P10_z80_state","__ZL5ed_67P10_z80_state","__ZL5ed_68P10_z80_state","__ZL5ed_69P10_z80_state","__ZL5ed_6bP10_z80_state","__ZL5ed_6dP10_z80_state","__ZL5ed_6fP10_z80_state","__ZL5ed_70P10_z80_state","__ZL5ed_71P10_z80_state","__ZL5ed_73P10_z80_state","__ZL5ed_74P10_z80_state","__ZL5ed_76P10_z80_state","__ZL5ed_7aP10_z80_state","__ZL5ed_7cP10_z80_state","__ZL5ed_7eP10_z80_state","__ZL5ed_75P10_z80_state","__ZL5ed_77P10_z80_state","__ZL5ed_78P10_z80_state","__ZL5ed_79P10_z80_state","__ZL5ed_7bP10_z80_state","__ZL5ed_7dP10_z80_state","__ZL5ed_7fP10_z80_state","__ZL5ed_80P10_z80_state","__ZL5ed_81P10_z80_state","__ZL5ed_82P10_z80_state","__ZL5ed_83P10_z80_state","__ZL5ed_84P10_z80_state","__ZL5ed_85P10_z80_state","__ZL5ed_86P10_z80_state","__ZL5ed_87P10_z80_state","__ZL5ed_88P10_z80_state","__ZL5ed_89P10_z80_state","__ZL5ed_8aP10_z80_state","__ZL5ed_8bP10_z80_state","__ZL5ed_8cP10_z80_state","__ZL5ed_8dP10_z80_state","__ZL5ed_8eP10_z80_state","__ZL5ed_8fP10_z80_state","__ZL5ed_90P10_z80_state","__ZL5ed_91P10_z80_state","__ZL5ed_92P10_z80_state","__ZL5ed_93P10_z80_state","__ZL5ed_94P10_z80_state","__ZL5ed_95P10_z80_state","__ZL5ed_96P10_z80_state","__ZL5ed_97P10_z80_state","__ZL5ed_98P10_z80_state","__ZL5ed_99P10_z80_state","__ZL5ed_9aP10_z80_state","__ZL5ed_9bP10_z80_state","__ZL5ed_9cP10_z80_state","__ZL5ed_9dP10_z80_state","__ZL5ed_9eP10_z80_state","__ZL5ed_9fP10_z80_state","__ZL5ed_a0P10_z80_state","__ZL5ed_a1P10_z80_state","__ZL5ed_a2P10_z80_state","__ZL5ed_a3P10_z80_state","__ZL5ed_a4P10_z80_state","__ZL5ed_a5P10_z80_state","__ZL5ed_a6P10_z80_state","__ZL5ed_a7P10_z80_state","__ZL5ed_a8P10_z80_state","__ZL5ed_a9P10_z80_state","__ZL5ed_aaP10_z80_state","__ZL5ed_abP10_z80_state","__ZL5ed_acP10_z80_state","__ZL5ed_adP10_z80_state","__ZL5ed_aeP10_z80_state","__ZL5ed_afP10_z80_state","__ZL5ed_b0P10_z80_state","__ZL5ed_b1P10_z80_state","__ZL5ed_b2P10_z80_state","__ZL5ed_b3P10_z80_state","__ZL5ed_b4P10_z80_state","__ZL5ed_b5P10_z80_state","__ZL5ed_b6P10_z80_state","__ZL5ed_b7P10_z80_state","__ZL5ed_b8P10_z80_state","__ZL5ed_b9P10_z80_state","__ZL5ed_baP10_z80_state","__ZL5dd_09P10_z80_state","__ZL5ed_bbP10_z80_state","__ZL5ed_bcP10_z80_state","__ZL5ed_bdP10_z80_state","__ZL5ed_beP10_z80_state","__ZL5ed_bfP10_z80_state","__ZL5ed_c0P10_z80_state","__ZL5ed_c1P10_z80_state","__ZL5ed_c2P10_z80_state","__ZL5ed_c3P10_z80_state","__ZL5ed_c4P10_z80_state","__ZL5ed_c5P10_z80_state","__ZL5ed_c6P10_z80_state","__ZL5ed_c7P10_z80_state","__ZL5ed_c8P10_z80_state","__ZL5ed_c9P10_z80_state","__ZL5ed_caP10_z80_state","__ZL5ed_cbP10_z80_state","__ZL5ed_ccP10_z80_state","__ZL5ed_cdP10_z80_state","__ZL5ed_ceP10_z80_state","__ZL5ed_cfP10_z80_state","__ZL5ed_d0P10_z80_state","__ZL5ed_d1P10_z80_state","__ZL5ed_d2P10_z80_state","__ZL5ed_d3P10_z80_state","__ZL5ed_d4P10_z80_state","__ZL5ed_d5P10_z80_state","__ZL5ed_d6P10_z80_state","__ZL5ed_d7P10_z80_state","__ZL5ed_d8P10_z80_state","__ZL5ed_d9P10_z80_state","__ZL5ed_daP10_z80_state","__ZL5ed_dbP10_z80_state","__ZL5ed_dcP10_z80_state","__ZL5ed_ddP10_z80_state","__ZL5ed_deP10_z80_state","__ZL5ed_dfP10_z80_state","__ZL5ed_e0P10_z80_state","__ZL5ed_e1P10_z80_state","__ZL5ed_e2P10_z80_state","__ZL5ed_e3P10_z80_state","__ZL5ed_e4P10_z80_state","__ZL5ed_e5P10_z80_state","__ZL5ed_e6P10_z80_state","__ZL5ed_e7P10_z80_state","__ZL5ed_e8P10_z80_state","__ZL5ed_e9P10_z80_state","__ZL5ed_eaP10_z80_state","__ZL5ed_ebP10_z80_state","__ZL5ed_ecP10_z80_state","__ZL5ed_edP10_z80_state","__ZL5ed_eeP10_z80_state","__ZL5ed_efP10_z80_state","__ZL5ed_f0P10_z80_state","__ZL5ed_f1P10_z80_state","__ZL5ed_f2P10_z80_state","__ZL5ed_f3P10_z80_state","__ZL5ed_f4P10_z80_state","__ZL5ed_f5P10_z80_state","__ZL5ed_f6P10_z80_state","__ZL5ed_f7P10_z80_state","__ZL5ed_f8P10_z80_state","__ZL5ed_f9P10_z80_state","__ZL5ed_faP10_z80_state","__ZL5ed_fbP10_z80_state","__ZL5ed_fcP10_z80_state","__ZL5ed_fdP10_z80_state","__ZL5ed_feP10_z80_state","__ZL5ed_ffP10_z80_state","__ZL9illegal_2P10_z80_state","__ZL5dd_00P10_z80_state","__ZL5dd_01P10_z80_state","__ZL5dd_02P10_z80_state","__ZL5dd_03P10_z80_state","__ZL5dd_04P10_z80_state","__ZL5dd_05P10_z80_state","__ZL5dd_06P10_z80_state","__ZL5dd_07P10_z80_state","__ZL5dd_08P10_z80_state","__ZL5dd_0aP10_z80_state","__ZL5dd_0bP10_z80_state","__ZL5dd_0cP10_z80_state","__ZL5dd_0dP10_z80_state","__ZL5dd_0eP10_z80_state","__ZL5dd_0fP10_z80_state","__ZL5dd_10P10_z80_state","__ZL5dd_11P10_z80_state","__ZL5dd_12P10_z80_state","__ZL5dd_13P10_z80_state","__ZL5dd_14P10_z80_state","__ZL5dd_15P10_z80_state","__ZL5dd_16P10_z80_state","__ZL5dd_17P10_z80_state","__ZL5dd_18P10_z80_state","__ZL5dd_19P10_z80_state","__ZL5dd_23P10_z80_state","__ZL5dd_29P10_z80_state","__ZL5dd_2bP10_z80_state","__ZL5dd_39P10_z80_state","__ZL5dd_44P10_z80_state","__ZL5dd_45P10_z80_state","__ZL5dd_4cP10_z80_state","__ZL5dd_4dP10_z80_state","__ZL5dd_1aP10_z80_state","__ZL5dd_1bP10_z80_state","__ZL5dd_1cP10_z80_state","__ZL5dd_1dP10_z80_state","__ZL5dd_1eP10_z80_state","__ZL5dd_1fP10_z80_state","__ZL5dd_20P10_z80_state","__ZL5dd_21P10_z80_state","__ZL5dd_22P10_z80_state","__ZL5dd_24P10_z80_state","__ZL5dd_25P10_z80_state","__ZL5dd_26P10_z80_state","__ZL5dd_27P10_z80_state","__ZL5dd_28P10_z80_state","__ZL5dd_2aP10_z80_state","__ZL5dd_2cP10_z80_state","__ZL5dd_2dP10_z80_state","__ZL5dd_2eP10_z80_state","__ZL5dd_2fP10_z80_state","__ZL5dd_30P10_z80_state","__ZL5dd_31P10_z80_state","__ZL5dd_32P10_z80_state","__ZL5dd_33P10_z80_state","__ZL5dd_34P10_z80_state","__ZL5dd_35P10_z80_state","__ZL5dd_36P10_z80_state","__ZL5dd_37P10_z80_state","__ZL5dd_38P10_z80_state","__ZL5dd_3aP10_z80_state","__ZL5dd_3bP10_z80_state","__ZL5dd_3cP10_z80_state","__ZL5dd_3dP10_z80_state","__ZL5dd_3eP10_z80_state","__ZL5dd_3fP10_z80_state","__ZL5dd_40P10_z80_state","__ZL5dd_41P10_z80_state","__ZL5dd_42P10_z80_state","__ZL5dd_43P10_z80_state","__ZL5dd_46P10_z80_state","__ZL5dd_47P10_z80_state","__ZL5dd_48P10_z80_state","__ZL5dd_49P10_z80_state","__ZL5dd_4aP10_z80_state","__ZL5dd_4bP10_z80_state","__ZL5dd_64P10_z80_state","__ZL5dd_6dP10_z80_state","__ZL5dd_54P10_z80_state","__ZL5dd_55P10_z80_state","__ZL5dd_5cP10_z80_state","__ZL5dd_5dP10_z80_state","__ZL5dd_60P10_z80_state","__ZL5dd_61P10_z80_state","__ZL5dd_62P10_z80_state","__ZL5dd_63P10_z80_state","__ZL5dd_65P10_z80_state","__ZL5dd_67P10_z80_state","__ZL5dd_68P10_z80_state","__ZL5dd_69P10_z80_state","__ZL5dd_6aP10_z80_state","__ZL5dd_6bP10_z80_state","__ZL5dd_6cP10_z80_state","__ZL5dd_6fP10_z80_state","__ZL5dd_4eP10_z80_state","__ZL5dd_4fP10_z80_state","__ZL5dd_50P10_z80_state","__ZL5dd_51P10_z80_state","__ZL5dd_52P10_z80_state","__ZL5dd_53P10_z80_state","__ZL5dd_56P10_z80_state","__ZL5dd_57P10_z80_state","__ZL5dd_58P10_z80_state","__ZL5dd_59P10_z80_state","__ZL5dd_5aP10_z80_state","__ZL5dd_5bP10_z80_state","__ZL5dd_5eP10_z80_state","__ZL5dd_5fP10_z80_state","__ZL5dd_66P10_z80_state","__ZL5dd_6eP10_z80_state","__ZL5dd_70P10_z80_state","__ZL5dd_71P10_z80_state","__ZL5dd_72P10_z80_state","__ZL5dd_73P10_z80_state","__ZL5dd_74P10_z80_state","__ZL5dd_75P10_z80_state","__ZL5dd_76P10_z80_state","__ZL5dd_77P10_z80_state","__ZL5dd_78P10_z80_state","__ZL5dd_79P10_z80_state","__ZL5dd_7aP10_z80_state","__ZL5dd_7cP10_z80_state","__ZL5dd_7dP10_z80_state","__ZL5dd_84P10_z80_state","__ZL5dd_85P10_z80_state","__ZL5dd_8cP10_z80_state","__ZL5dd_8dP10_z80_state","__ZL5dd_94P10_z80_state","__ZL5dd_95P10_z80_state","__ZL5dd_9cP10_z80_state","__ZL5dd_9dP10_z80_state","__ZL5dd_7bP10_z80_state","__ZL5dd_7eP10_z80_state","__ZL5dd_7fP10_z80_state","__ZL5dd_80P10_z80_state","__ZL5dd_81P10_z80_state","__ZL5dd_82P10_z80_state","__ZL5dd_83P10_z80_state","__ZL5dd_86P10_z80_state","__ZL5dd_87P10_z80_state","__ZL5dd_88P10_z80_state","__ZL5dd_89P10_z80_state","__ZL5dd_8aP10_z80_state","__ZL5dd_8bP10_z80_state","__ZL5dd_8eP10_z80_state","__ZL5dd_8fP10_z80_state","__ZL5dd_90P10_z80_state","__ZL5dd_91P10_z80_state","__ZL5dd_92P10_z80_state","__ZL5dd_93P10_z80_state","__ZL5dd_96P10_z80_state","__ZL5dd_97P10_z80_state","__ZL5dd_98P10_z80_state","__ZL5dd_99P10_z80_state","__ZL5dd_9aP10_z80_state","__ZL5dd_9bP10_z80_state","__ZL5dd_a4P10_z80_state","__ZL5dd_a5P10_z80_state","__ZL5dd_acP10_z80_state","__ZL5dd_adP10_z80_state","__ZL5dd_b4P10_z80_state","__ZL5dd_b5P10_z80_state","__ZL5dd_bcP10_z80_state","__ZL5dd_bdP10_z80_state","__ZL5dd_9eP10_z80_state","__ZL5dd_9fP10_z80_state","__ZL5dd_a0P10_z80_state","__ZL5dd_a1P10_z80_state","__ZL5dd_a2P10_z80_state","__ZL5dd_a3P10_z80_state","__ZL5dd_a6P10_z80_state","__ZL5dd_a7P10_z80_state","__ZL5dd_a8P10_z80_state","__ZL5dd_a9P10_z80_state","__ZL5dd_aaP10_z80_state","__ZL5dd_abP10_z80_state","__ZL5dd_aeP10_z80_state","__ZL5dd_afP10_z80_state","__ZL5dd_b0P10_z80_state","__ZL5dd_b1P10_z80_state","__ZL5dd_b2P10_z80_state","__ZL5dd_b3P10_z80_state","__ZL5dd_b6P10_z80_state","__ZL5dd_b7P10_z80_state","__ZL5dd_b8P10_z80_state","__ZL5dd_b9P10_z80_state","__ZL5dd_baP10_z80_state","__ZL5dd_bbP10_z80_state","__ZL5dd_beP10_z80_state","__ZL5dd_bfP10_z80_state","__ZL5dd_c0P10_z80_state","__ZL5dd_c1P10_z80_state","__ZL5dd_c2P10_z80_state","__ZL5dd_c3P10_z80_state","__ZL5dd_c4P10_z80_state","__ZL5dd_c5P10_z80_state","__ZL5dd_e9P10_z80_state","__ZL5dd_f9P10_z80_state","__ZL5dd_c6P10_z80_state","__ZL5dd_c7P10_z80_state","__ZL5dd_c8P10_z80_state","__ZL5dd_c9P10_z80_state","__ZL5dd_caP10_z80_state","__ZL5dd_cbP10_z80_state","__ZL5dd_ccP10_z80_state","__ZL5dd_cdP10_z80_state","__ZL5dd_ceP10_z80_state","__ZL5dd_cfP10_z80_state","__ZL5dd_d0P10_z80_state","__ZL5dd_d1P10_z80_state","__ZL5dd_d2P10_z80_state","__ZL5dd_d3P10_z80_state","__ZL5dd_d4P10_z80_state","__ZL5dd_d5P10_z80_state","__ZL5dd_d6P10_z80_state","__ZL5dd_d7P10_z80_state","__ZL5dd_d8P10_z80_state","__ZL5dd_d9P10_z80_state","__ZL5dd_daP10_z80_state","__ZL5dd_dbP10_z80_state","__ZL5dd_dcP10_z80_state","__ZL5dd_ddP10_z80_state","__ZL5dd_deP10_z80_state","__ZL5dd_dfP10_z80_state","__ZL5dd_e0P10_z80_state","__ZL5dd_e1P10_z80_state","__ZL5dd_e2P10_z80_state","__ZL5dd_e3P10_z80_state","__ZL5dd_e4P10_z80_state","__ZL5dd_e5P10_z80_state","__ZL5dd_e6P10_z80_state","__ZL5dd_e7P10_z80_state","__ZL5dd_e8P10_z80_state","__ZL5dd_eaP10_z80_state","__ZL5dd_ebP10_z80_state","__ZL5dd_ecP10_z80_state","__ZL5dd_edP10_z80_state","__ZL5dd_eeP10_z80_state","__ZL5dd_efP10_z80_state","__ZL5dd_f0P10_z80_state","__ZL5dd_f1P10_z80_state","__ZL5dd_f2P10_z80_state","__ZL5dd_f3P10_z80_state","__ZL5dd_f4P10_z80_state","__ZL5dd_f5P10_z80_state","__ZL5dd_f6P10_z80_state","__ZL5dd_f7P10_z80_state","__ZL5dd_f8P10_z80_state","__ZL5dd_faP10_z80_state","__ZL5dd_fbP10_z80_state","__ZL5dd_fcP10_z80_state","__ZL5dd_fdP10_z80_state","__ZL5dd_feP10_z80_state","__ZL5dd_ffP10_z80_state","__ZL5cb_00P10_z80_state","__ZL5cb_01P10_z80_state","__ZL5cb_02P10_z80_state","__ZL5cb_03P10_z80_state","__ZL5cb_04P10_z80_state","__ZL5cb_05P10_z80_state","__ZL5cb_06P10_z80_state","__ZL5cb_07P10_z80_state","__ZL5cb_08P10_z80_state","__ZL5cb_09P10_z80_state","__ZL5cb_0aP10_z80_state","__ZL5cb_0bP10_z80_state","__ZL5cb_0cP10_z80_state","__ZL5cb_0dP10_z80_state","__ZL5cb_0eP10_z80_state","__ZL5cb_0fP10_z80_state","__ZL5cb_10P10_z80_state","__ZL5cb_40P10_z80_state","__ZL5cb_41P10_z80_state","__ZL5cb_11P10_z80_state","__ZL5cb_12P10_z80_state","__ZL5cb_13P10_z80_state","__ZL5cb_14P10_z80_state","__ZL5cb_15P10_z80_state","__ZL5cb_16P10_z80_state","__ZL5cb_17P10_z80_state","__ZL5cb_18P10_z80_state","__ZL5cb_19P10_z80_state","__ZL5cb_1aP10_z80_state","__ZL5cb_1bP10_z80_state","__ZL5cb_1cP10_z80_state","__ZL5cb_1dP10_z80_state","__ZL5cb_1eP10_z80_state","__ZL5cb_1fP10_z80_state","__ZL5cb_20P10_z80_state","__ZL5cb_21P10_z80_state","__ZL5cb_22P10_z80_state","__ZL5cb_23P10_z80_state","__ZL5cb_24P10_z80_state","__ZL5cb_25P10_z80_state","__ZL5cb_26P10_z80_state","__ZL5cb_27P10_z80_state","__ZL5cb_28P10_z80_state","__ZL5cb_29P10_z80_state","__ZL5cb_2aP10_z80_state","__ZL5cb_2bP10_z80_state","__ZL5cb_2cP10_z80_state","__ZL5cb_2dP10_z80_state","__ZL5cb_2eP10_z80_state","__ZL5cb_2fP10_z80_state","__ZL5cb_30P10_z80_state","__ZL5cb_31P10_z80_state","__ZL5cb_32P10_z80_state","__ZL5cb_33P10_z80_state","__ZL5cb_34P10_z80_state","__ZL5cb_35P10_z80_state","__ZL5cb_36P10_z80_state","__ZL5cb_37P10_z80_state","__ZL5cb_38P10_z80_state","__ZL5cb_39P10_z80_state","__ZL5cb_3aP10_z80_state","__ZL5cb_3bP10_z80_state","__ZL5cb_3cP10_z80_state","__ZL5cb_3dP10_z80_state","__ZL5cb_3eP10_z80_state","__ZL5cb_3fP10_z80_state","__ZL5cb_42P10_z80_state","__ZL5cb_43P10_z80_state","__ZL5cb_44P10_z80_state","__ZL5cb_45P10_z80_state","__ZL5cb_47P10_z80_state","__ZL5cb_48P10_z80_state","__ZL5cb_49P10_z80_state","__ZL5cb_4aP10_z80_state","__ZL5cb_4bP10_z80_state","__ZL5cb_4cP10_z80_state","__ZL5cb_4dP10_z80_state","__ZL5cb_4fP10_z80_state","__ZL5cb_50P10_z80_state","__ZL5cb_51P10_z80_state","__ZL5cb_52P10_z80_state","__ZL5cb_53P10_z80_state","__ZL5cb_54P10_z80_state","__ZL5cb_55P10_z80_state","__ZL5cb_46P10_z80_state","__ZL5cb_4eP10_z80_state","__ZL5cb_56P10_z80_state","__ZL5cb_57P10_z80_state","__ZL5cb_58P10_z80_state","__ZL5cb_59P10_z80_state","__ZL5cb_5aP10_z80_state","__ZL5cb_5bP10_z80_state","__ZL5cb_5cP10_z80_state","__ZL5cb_5dP10_z80_state","__ZL5cb_5fP10_z80_state","__ZL5cb_60P10_z80_state","__ZL5cb_61P10_z80_state","__ZL5cb_62P10_z80_state","__ZL5cb_63P10_z80_state","__ZL5cb_64P10_z80_state","__ZL5cb_65P10_z80_state","__ZL5cb_67P10_z80_state","__ZL5cb_68P10_z80_state","__ZL5cb_69P10_z80_state","__ZL5cb_6aP10_z80_state","__ZL5cb_6bP10_z80_state","__ZL5cb_5eP10_z80_state","__ZL5cb_66P10_z80_state","__ZL5cb_6cP10_z80_state","__ZL5cb_6dP10_z80_state","__ZL5cb_6fP10_z80_state","__ZL5cb_70P10_z80_state","__ZL5cb_71P10_z80_state","__ZL5cb_72P10_z80_state","__ZL5cb_73P10_z80_state","__ZL5cb_74P10_z80_state","__ZL5cb_75P10_z80_state","__ZL5cb_77P10_z80_state","__ZL5cb_78P10_z80_state","__ZL5cb_79P10_z80_state","__ZL5cb_7aP10_z80_state","__ZL5cb_7bP10_z80_state","__ZL5cb_7cP10_z80_state","__ZL5cb_7dP10_z80_state","__ZL5cb_7fP10_z80_state","__ZL5cb_6eP10_z80_state","__ZL5cb_76P10_z80_state","__ZL5cb_7eP10_z80_state","__ZL5cb_80P10_z80_state","__ZL5cb_81P10_z80_state","__ZL5cb_82P10_z80_state","__ZL5cb_83P10_z80_state","__ZL5cb_84P10_z80_state","__ZL5cb_85P10_z80_state","__ZL5cb_86P10_z80_state","__ZL5cb_87P10_z80_state","__ZL5cb_88P10_z80_state","__ZL5cb_89P10_z80_state","__ZL5cb_8aP10_z80_state","__ZL5cb_8bP10_z80_state","__ZL5cb_8cP10_z80_state","__ZL5cb_8dP10_z80_state","__ZL5cb_8eP10_z80_state","__ZL5cb_8fP10_z80_state","__ZL5cb_90P10_z80_state","__ZL5cb_91P10_z80_state","__ZL5cb_92P10_z80_state","__ZL5cb_93P10_z80_state","__ZL5cb_94P10_z80_state","__ZL5cb_95P10_z80_state","__ZL5cb_96P10_z80_state","__ZL5cb_97P10_z80_state","__ZL5cb_98P10_z80_state","__ZL5cb_99P10_z80_state","__ZL5cb_9aP10_z80_state","__ZL5cb_9bP10_z80_state","__ZL5cb_9cP10_z80_state","__ZL5cb_9dP10_z80_state","__ZL5cb_9eP10_z80_state","__ZL5cb_9fP10_z80_state","__ZL5cb_a0P10_z80_state","__ZL5cb_a1P10_z80_state","__ZL5cb_a2P10_z80_state","__ZL5cb_a3P10_z80_state","__ZL5cb_a4P10_z80_state","__ZL5cb_a5P10_z80_state","__ZL5cb_a6P10_z80_state","__ZL5cb_a7P10_z80_state","__ZL5cb_a8P10_z80_state","__ZL5cb_a9P10_z80_state","__ZL5cb_aaP10_z80_state","__ZL5cb_abP10_z80_state","__ZL5cb_acP10_z80_state","__ZL5cb_adP10_z80_state","__ZL5cb_aeP10_z80_state","__ZL5cb_afP10_z80_state","__ZL5cb_b0P10_z80_state","__ZL5cb_b1P10_z80_state","__ZL5cb_b2P10_z80_state","__ZL5cb_b3P10_z80_state","__ZL5cb_b4P10_z80_state","__ZL5cb_b5P10_z80_state","__ZL5cb_b6P10_z80_state","__ZL5cb_b7P10_z80_state","__ZL5cb_b8P10_z80_state","__ZL5cb_b9P10_z80_state","__ZL5cb_baP10_z80_state","__ZL5cb_bbP10_z80_state","__ZL5cb_bcP10_z80_state","__ZL5cb_bdP10_z80_state","__ZL5cb_beP10_z80_state","__ZL5cb_bfP10_z80_state","__ZL5cb_c0P10_z80_state","__ZL5cb_c1P10_z80_state","__ZL5cb_c2P10_z80_state","__ZL5cb_c3P10_z80_state","__ZL5cb_c4P10_z80_state","__ZL5cb_c5P10_z80_state","__ZL5cb_c6P10_z80_state","__ZL5cb_c7P10_z80_state","__ZL5cb_c8P10_z80_state","__ZL5cb_c9P10_z80_state","__ZL5cb_caP10_z80_state","__ZL5cb_cbP10_z80_state","__ZL5cb_ccP10_z80_state","__ZL5cb_cdP10_z80_state","__ZL5cb_ceP10_z80_state","__ZL5cb_cfP10_z80_state","__ZL5cb_d0P10_z80_state","__ZL5cb_d1P10_z80_state","__ZL5cb_d2P10_z80_state","__ZL5cb_d3P10_z80_state","__ZL5cb_d4P10_z80_state","__ZL5cb_d5P10_z80_state","__ZL5cb_d6P10_z80_state","__ZL5cb_d7P10_z80_state","__ZL5cb_d8P10_z80_state","__ZL5cb_d9P10_z80_state","__ZL5cb_daP10_z80_state","__ZL5cb_dbP10_z80_state","__ZL5cb_dcP10_z80_state","__ZL5cb_ddP10_z80_state","__ZL5cb_deP10_z80_state","__ZL5cb_dfP10_z80_state","__ZL5cb_e0P10_z80_state","__ZL5cb_e1P10_z80_state","__ZL5cb_e2P10_z80_state","__ZL5cb_e3P10_z80_state","__ZL5cb_e4P10_z80_state","__ZL5cb_e5P10_z80_state","__ZL5cb_e6P10_z80_state","__ZL5cb_e7P10_z80_state","__ZL5cb_e8P10_z80_state","__ZL5cb_e9P10_z80_state","__ZL5cb_eaP10_z80_state","__ZL5cb_ebP10_z80_state","__ZL5cb_ecP10_z80_state","__ZL5cb_edP10_z80_state","__ZL5cb_eeP10_z80_state","__ZL5cb_efP10_z80_state","__ZNK15z80_daisy_chain7presentEv","__ZNK8device_t13static_configEv","__ZL5cb_f0P10_z80_state","__ZL5cb_f1P10_z80_state","__ZL5cb_f2P10_z80_state","__ZL5cb_f3P10_z80_state","__ZL5cb_f4P10_z80_state","__ZL5cb_f5P10_z80_state","__ZL5cb_f6P10_z80_state","__ZL5cb_f7P10_z80_state","__ZL5cb_f8P10_z80_state","__ZL5cb_f9P10_z80_state","__ZL5cb_faP10_z80_state","__ZL5cb_fbP10_z80_state","__ZL5cb_fcP10_z80_state","__ZL5cb_fdP10_z80_state","__ZL5cb_feP10_z80_state","__ZL5cb_ffP10_z80_state","__ZL12cpu_burn_z80P17legacy_cpu_devicei","__ZN12save_manager9save_itemIhLj4EEEvPKcS2_iRAT0__T_S2_","__ZN19resource_pool_arrayIhEC1EPhi","__ZN19resource_pool_arrayIhEC2EPhi","__ZN19resource_pool_arrayIhED1Ev","__ZL12set_irq_lineP10_z80_stateii","__ZN25device_z80daisy_interfaceC2ERK14machine_configR8device_t","__ZN25device_z80daisy_interfaceD2Ev","__ZN13resource_pool9add_arrayIhEEPT_S2_i","__ZN19resource_pool_arrayIhED0Ev","__ZN19resource_pool_arrayIhED2Ev","__ZN25device_z80daisy_interfaceD0Ev","__ZN15running_machine7respoolEv","__ZN8device_t9interfaceI25device_z80daisy_interfaceEEbRPT_","__ZN15z80_daisy_chain5resetEv","__ZN15z80_daisy_chain16update_irq_stateEv","__ZN15z80_daisy_chain15call_ack_deviceEv","__ZN15z80_daisy_chain16call_reti_deviceEv","__ZN15z80_daisy_chain11daisy_entryC2EP8device_t","__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEEC1EPS1_","__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEEC2EPS1_","__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED1Ev","__ZN15z80_daisy_chain4initEP8device_tPK16z80_daisy_config","__ZN13resource_pool10add_objectIN15z80_daisy_chain11daisy_entryEEEPT_S4_","__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED0Ev","__ZN20resource_pool_objectIN15z80_daisy_chain11daisy_entryEED2Ev","__Z20construct_core_typesR11simple_listI16input_type_entryE","__ZN11simple_listI16input_type_entryE6appendERS0_","__ZN7astringcvbEv","__ZNK8device_t4nextEv","__ZN9input_seqC1E10input_codeS0_S0_S0_S0_S0_S0_","__ZN10input_codeC1ERKS_","__ZN19_input_port_privateC1Ev","__ZN8delegateIFvvEEC1I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_","__ZL15input_port_exitR15running_machine","__ZL21frame_update_callbackR15running_machine","__ZL15init_port_typesR15running_machine","__ZNK15running_machine10devicelistEv","__ZNK11tagged_listI8device_tE5firstEv","__Z20input_port_list_initR8device_tR11tagged_listI17input_port_configER7astring","__ZNK7astring4cstrEv","__ZN13resource_pool10add_objectI16input_type_entryEEPT_S3_","__Z15input_port_initR15running_machine","__ZN13resource_pool10add_objectI19_input_port_privateEEPT_S3_","__ZN8delegateIFviP14_xml_data_nodeEEC1I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_","__ZL15init_port_stateR15running_machine","__ZL20load_config_callbackR15running_machineiP14_xml_data_node","__ZL20save_config_callbackR15running_machineiP14_xml_data_node","__ZL13playback_initR15running_machine","__ZNK17input_port_config4nextEv","__ZNK18input_field_config4nextEv","__Z15input_type_nameR15running_machineii","__Z14input_type_seqR15running_machineii15_input_seq_type","__ZNK18input_field_config11settinglistEv","__ZNK11simple_listI20input_setting_configE5countEv","__ZNK8device_t11input_portsEv","__ZN7astring5resetEv","__ZNK11tagged_listI17input_port_configE5firstEv","__ZN17input_port_config15collapse_fieldsER7astring","__Z27input_field_by_tag_and_maskRK11tagged_listI17input_port_configEPKcj","__ZNK11tagged_listI17input_port_configE4findEPKc","__ZNK17input_port_config11first_fieldEv","__Z16input_field_namePK18input_field_config","__ZNK18input_field_config7machineEv","__Z15input_field_seqPK18input_field_config15_input_seq_type","__ZNK9input_seq10is_defaultEv","__Z29input_field_get_user_settingsPK18input_field_configP26_input_field_user_settings","__ZL11record_initR15running_machine","__Z20input_type_is_analogi","__ZNK11simple_listI20input_setting_configE5firstEv","__ZNK18input_field_config4portEv","__ZNK17input_port_config5ownerEv","__ZNK20input_setting_config4nextEv","__Z16input_type_groupR15running_machineii","__Z29input_field_set_user_settingsPK18input_field_configPK26_input_field_user_settings","__ZNK9input_seqeqERKS_","__ZN9input_seq11set_defaultEv","__Z24input_field_setting_namePK18input_field_config","__Z32input_field_has_previous_settingPK18input_field_config","__Z35input_field_select_previous_settingPK18input_field_config","__Z28input_field_has_next_settingPK18input_field_config","__Z31input_field_select_next_settingPK18input_field_config","__Z20input_condition_trueR15running_machinePK16_input_conditionR8device_t","__Z15input_type_listR15running_machine","__ZNK8attotime14as_attosecondsEv","__Z18input_type_set_seqR15running_machineii15_input_seq_typePK9input_seq","__Z18input_type_pressedR15running_machineii","__ZN15running_machine4portEPKc","__ZNK17input_port_config7machineEv","__ZNK13delegate_baseIjRK18input_field_configPv8_noparamS4_EclES2_S3_","__ZNK13screen_device6vblankEv","__ZmiRK8attotimeS1_","__ZL21apply_analog_settingsiP19_analog_field_state","__ZNK8device_t6subtagER7astringPKc","__Z20input_port_read_safeR15running_machinePKcj","__Z22input_port_read_directPK17input_port_config","__Z15input_port_readR15running_machinePKc","__ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_E6isnullEv","__Z28input_port_string_from_tokenPKc","__ZNK8device_t20input_ports_defaultsEv","__Z33input_port_get_crosshair_positionR15running_machineiPfS1_","__ZNK13delegate_baseIfRK18input_field_configf8_noparamS3_EclES2_f","__Z26input_port_update_defaultsR15running_machine","__Z23input_port_write_directPK17input_port_configjj","__ZNK13delegate_baseIvRK18input_field_configPvjjEclES2_S3_jj","__ZN11simple_listI18input_field_configEC1ER13resource_pool","__ZN7astringC1EPKc","__ZN11simple_listI18input_field_configED1Ev","__Z18port_default_valuePKcjjR8device_t","__ZN17input_port_configC2ER8device_tPKc","__ZNK17input_port_config8modcountEv","__ZN11simple_listI18input_field_configE10detach_allEv","__ZNK18input_field_config8modcountEv","__ZN17input_port_config9fieldlistEv","__ZNK11simple_listI18input_field_configE5firstEv","__ZN18input_field_config10diploclistEv","__ZL13find_charinfoj","__ZN8delegateIFjRK18input_field_configPvEEC1Ev","__ZN8delegateIFvRK18input_field_configPvjjEEC1Ev","__ZN8delegateIFfRK18input_field_configfEEC1Ev","__ZN11simple_listI20input_setting_configEC1ER13resource_pool","__ZN11simple_listI23input_field_diplocationEC1ER13resource_pool","__ZN11simple_listI23input_field_diplocationED1Ev","__ZN11simple_listI20input_setting_configED1Ev","__ZN20input_setting_configC2ER18input_field_configjPKc","__Z19field_config_insertR18input_field_configRjR7astring","__ZN7astring9catprintfEPKcz","__ZNK17input_port_config3tagEv","__ZL15condition_equalPK16_input_conditionS1_","__ZN11simple_listI18input_field_configE6removeERS0_","__ZN11simple_listI18input_field_configE13insert_beforeERS0_PS0_","__ZN11simple_listI23input_field_diplocationE5resetEv","__ZN7astring3cpyEPKci","__ZN7astring3cpyEPKc","__Z26input_machine_has_keyboardR15running_machine","__Z33validate_natural_keyboard_staticsv","__ZN18input_field_configC2ER17input_port_configijjPKc","__Z15inputx_can_postR15running_machine","__ZL10get_bufferR15running_machine","__Z11inputx_initR15running_machine","__ZL13execute_inputR15running_machineiiPPKc","__ZL15execute_dumpkbdR15running_machineiiPPKc","__Z12inputx_postcR15running_machinej","__ZL17inputx_postc_rateR15running_machinej8attotime","__Z16inputx_post_utf8R15running_machinePKc","__ZL22inputx_postn_utf8_rateR15running_machinePKcj8attotime","__Z21input_category_activeR15running_machinei","__ZN26_input_field_user_settingsC1Ev","__ZL11build_codesR15running_machinePK17input_port_config","__ZL15setup_keybufferR15running_machine","__ZN11simple_listI18input_field_configE6appendERS0_","__Z19ioconfig_alloc_portR11tagged_listI17input_port_configER8device_tPKc","__ZN11tagged_listI17input_port_configE6appendEPKcRS0_","__ZN13resource_pool10add_objectI17input_port_configEEPT_S3_","__Z20ioconfig_alloc_fieldR17input_port_configijjPKc","__ZN13resource_pool10add_objectI18input_field_configEEPT_S3_","__ZN18input_field_config11settinglistEv","__ZN11simple_listI20input_setting_configE6appendERS0_","__Z17ioconfig_add_codeR18input_field_configi10input_code","__ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seq","__ZN16input_type_entryC2Ej12ioport_groupiPKcS2_9input_seqS3_S3_","__ZN20resource_pool_objectI20input_setting_configEC1EPS0_","__ZN20resource_pool_objectI20input_setting_configEC2EPS0_","__ZN20resource_pool_objectI20input_setting_configED1Ev","__ZN20resource_pool_objectI18input_field_configEC1EPS0_","__ZN20resource_pool_objectI18input_field_configEC2EPS0_","__ZN20resource_pool_objectI18input_field_configED1Ev","__Z22ioconfig_alloc_settingR18input_field_configjPKc","__ZN13resource_pool10add_objectI20input_setting_configEEPT_S3_","__ZN20resource_pool_objectI20input_setting_configED0Ev","__ZN20resource_pool_objectI20input_setting_configED2Ev","__ZN20resource_pool_objectI18input_field_configED0Ev","__ZN11simple_listI17input_port_configE6appendERS0_","__ZN11simple_listI23input_field_diplocationE6detachERS0_","__ZN11simple_listI18input_field_configE6detachERS0_","__ZN18input_field_configD1Ev","__ZN20resource_pool_objectI17input_port_configEC1EPS0_","__ZN20resource_pool_objectI17input_port_configEC2EPS0_","__ZN20resource_pool_objectI17input_port_configED1Ev","__ZN17input_port_configD1Ev","__ZN8tagmap_tIP17input_port_configE15add_unique_hashEPKcS1_b","__ZN11simple_listI23input_field_diplocationE6removeERS0_","__ZN11simple_listI23input_field_diplocationED2Ev","__ZN11simple_listI20input_setting_configED2Ev","__ZN11simple_listI20input_setting_configE5resetEv","__ZN20resource_pool_objectI18input_field_configED2Ev","__ZN18input_field_configD2Ev","__ZN20resource_pool_objectI17input_port_configED0Ev","__ZN20resource_pool_objectI17input_port_configED2Ev","__ZN17input_port_configD2Ev","__ZN11simple_listI23input_field_diplocationED0Ev","__ZN11simple_listI20input_setting_configE6detachERS0_","__ZN11simple_listI23input_field_diplocationEC2ER13resource_pool","__ZN11simple_listI20input_setting_configEC2ER13resource_pool","__ZN11simple_listI18input_field_configEC2ER13resource_pool","__ZNK11simple_listI17input_port_configE5firstEv","__ZN11simple_listI20input_setting_configE6removeERS0_","__ZN8delegateIFfRK18input_field_configfEEC2Ev","__ZN13delegate_baseIfRK18input_field_configf8_noparamS3_EC2Ev","__ZN8delegateIFvRK18input_field_configPvjjEEC2Ev","__ZN13delegate_baseIvRK18input_field_configPvjjEC2Ev","__ZN8delegateIFjRK18input_field_configPvEEC2Ev","__ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_EC2Ev","__ZN11simple_listI18input_field_configED2Ev","__ZN11simple_listI18input_field_configE5resetEv","__ZN8delegateIFviP14_xml_data_nodeEEC2I15running_machineEEN15delegate_traitsIT_viS1_8_noparamS8_E20static_ref_func_typeEPKcPS7_","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I15running_machineEEN15delegate_traitsIT_viS1_S2_S2_E20static_ref_func_typeEPKcPS7_","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E4bindEP22delegate_generic_class","__ZN8delegateIFvvEEC2I15running_machineEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E20static_ref_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I15running_machineEEN15delegate_traitsIT_vS0_S0_S0_S0_E20static_ref_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIv8_noparamS0_S0_S0_E4bindEP22delegate_generic_class","__ZN20resource_pool_objectI19_input_port_privateEC1EPS0_","__ZN20resource_pool_objectI19_input_port_privateEC2EPS0_","__ZN20resource_pool_objectI19_input_port_privateED1Ev","__ZN19_input_port_privateD1Ev","__ZN19_input_port_privateD2Ev","__ZN11simple_listI16input_type_entryED1Ev","__ZN11simple_listI20input_setting_configED0Ev","__ZN11simple_listI18input_field_configED0Ev","__ZN20resource_pool_objectI19_input_port_privateED0Ev","__ZN20resource_pool_objectI19_input_port_privateED2Ev","__ZN11simple_listI16input_type_entryE6detachERS0_","__ZL11tagmap_hashPKc451","__ZNK11simple_listI8device_tE5firstEv","__ZN11simple_listI16input_type_entryED2Ev","__ZN11simple_listI16input_type_entryE5resetEv","__ZN11simple_listI16input_type_entryE6removeERS0_","__ZN20resource_pool_objectI16input_type_entryEC1EPS0_","__ZN20resource_pool_objectI16input_type_entryEC2EPS0_","__ZN20resource_pool_objectI16input_type_entryED1Ev","__ZNK8tagmap_tIP17input_port_configE14find_hash_onlyEPKc","__ZL21tagmap_find_hash_onlyPK7_tagmapPKc450","__ZL23inputx_postn_coded_rateR15running_machinePKcj8attotime","__ZN26_input_field_user_settingsC2Ev","__ZN11simple_listI16input_type_entryED0Ev","__ZN20resource_pool_objectI16input_type_entryED0Ev","__ZN20resource_pool_objectI16input_type_entryED2Ev","__ZL17code_point_stringR15running_machinej","__ZneRK8attotimeS1_","__ZL9find_codeP12_inputx_codej","__ZL15clear_keybufferR15running_machine","__ZL17inputx_postn_rateR15running_machinePKjj8attotime","__ZL11buffer_fullR15running_machine","__ZL21can_post_key_directlyR15running_machinej","__ZL17internal_post_keyR15running_machinej","__ZL22can_post_key_alternateR15running_machinej","__ZL12choose_delayP19_input_port_privatej","__ZN16device_scheduler11timer_allocEPFvR15running_machinePviEPKcS2_","__ZL16inputx_timerprocR15running_machinePvi","__ZN20resource_pool_objectI11_key_bufferEC1EPS0_","__ZN20resource_pool_objectI11_key_bufferEC2EPS0_","__ZN20resource_pool_objectI11_key_bufferED1Ev","__ZN13resource_pool10add_objectI11_key_bufferEEPT_S3_","__ZN8attotimeC2Ev","__ZL17get_keyboard_codePK18input_field_configi","__ZNK15running_machine6systemEv","__ZN8attotimeC1Ev","__ZL9scan_keysR15running_machinePK17input_port_configP12_inputx_codePS3_PPK18input_field_configii","__ZN19resource_pool_arrayI12_inputx_codeEC1EPS0_i","__ZN19resource_pool_arrayI12_inputx_codeEC2EPS0_i","__ZN19resource_pool_arrayI12_inputx_codeED1Ev","__ZNK15running_machine7optionsEv","__ZNK11emu_options6recordEv","__ZNK11emu_options15input_directoryEv","__ZN20resource_pool_objectI8emu_fileEC1EPS0_","__ZN20resource_pool_objectI8emu_fileEC2EPS0_","__ZN20resource_pool_objectI8emu_fileED1Ev","__ZN20resource_pool_objectI11_key_bufferED0Ev","__ZN20resource_pool_objectI11_key_bufferED2Ev","__ZN13resource_pool9add_arrayI12_inputx_codeEEPT_S3_i","__ZN19resource_pool_arrayI12_inputx_codeED0Ev","__ZN19resource_pool_arrayI12_inputx_codeED2Ev","__ZN13resource_pool10add_objectI8emu_fileEEPT_S3_","__ZL26save_this_input_field_typei","__ZNK14machine_config7optionsEv","__ZNK11emu_options8playbackEv","__ZL19save_default_inputsR15running_machineP14_xml_data_node","__ZL16save_game_inputsR15running_machineP14_xml_data_node","__ZNK9input_seqneERKS_","__ZL12get_port_tagPK17input_port_configPc","__ZL25input_field_type_to_tokenR15running_machineii","__ZN20resource_pool_objectI8emu_fileED0Ev","__ZN20resource_pool_objectI8emu_fileED2Ev","__ZNK11simple_listI16input_type_entryE5firstEv","__ZNK16input_type_entry4nextEv","__ZL12frame_updateR15running_machine","__ZL13save_sequenceR15running_machineP14_xml_data_nodeiiRK9input_seq","__ZL16load_remap_tableR15running_machineP14_xml_data_node","__ZN20dummy_profiler_state5startE12profile_type","__ZNK10input_codeneERKS_","__ZL25token_to_input_field_typeR15running_machinePKcPi","__ZL17token_to_seq_typePKc","__ZL19load_default_configR15running_machineP14_xml_data_nodeiiPK9input_seq","__ZL16load_game_configR15running_machineP14_xml_data_nodeiiPK9input_seq","__ZNK9input_seqixEi","__ZN19resource_pool_arrayI10input_codeEC1EPS0_i","__ZN19resource_pool_arrayI10input_codeEC2EPS0_i","__ZN19resource_pool_arrayI10input_codeED1Ev","__ZL14playback_frameR15running_machine8attotime","__ZN13resource_pool9add_arrayI10input_codeEEPT_S3_i","__ZN19resource_pool_arrayI10input_codeED0Ev","__ZN19resource_pool_arrayI10input_codeED2Ev","__ZL12record_frameR15running_machine8attotime","__ZL30frame_update_digital_joysticksR15running_machine","__ZL25frame_update_analog_fieldR15running_machineP19_analog_field_state","__ZN20dummy_profiler_state4stopEv","__ZL29frame_get_digital_field_statePK18input_field_configi","__ZL22input_port_update_hookR15running_machinePK17input_port_configPj","__ZL13playback_portPK17input_port_config","__ZL11record_portPK17input_port_config","__ZL19record_write_uint32R15running_machinej","__ZL18record_write_uint8R15running_machineh","__ZL10record_endR15running_machinePKc","__ZL20playback_read_uint32R15running_machine","__ZL19playback_read_uint8R15running_machine","__ZL12playback_endR15running_machinePKc","__ZNK11emu_options12coin_lockoutEv","__ZNK12core_options10bool_valueEPKc","__ZL20apply_analog_min_maxPK19_analog_field_statei","__ZNK15running_machine5videoEv","__ZNK13video_manager13speed_percentEv","__ZNK15running_machine6pausedEv","__ZL19record_write_uint64R15running_machiney","__ZL20playback_read_uint64R15running_machine","__ZN7astringC2EPKc","__ZNK11emu_options12joystick_mapEv","__ZN18_input_field_stateC1Ev","__ZN13resource_pool10add_objectI17_input_port_stateEEPT_S3_","__ZN13resource_pool10add_objectI18_input_field_stateEEPT_S3_","__ZNK13delegate_baseIjRK18input_field_configPv8_noparamS4_E6isnullEv","__ZNK13delegate_baseIvRK18input_field_configPvjjE6isnullEv","__Z14get_device_tagRK8device_tPKcR7astring","__ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_E9late_bindER18delegate_late_bind","__ZN13delegate_baseIvRK18input_field_configPvjjE9late_bindER18delegate_late_bind","__ZN15running_machine6deviceEPKc","__ZN13delegate_baseIfRK18input_field_configf8_noparamS3_E9late_bindER18delegate_late_bind","__ZL21get_keyboard_key_namePK18input_field_config","__ZL23init_field_analog_statePK18input_field_config","__ZL22init_field_device_infoPK18input_field_configPKc","__ZNK11input_class7enabledEv","__ZN11input_class6enableEb","__ZNK8device_t5ownerEv","__ZL23init_autoselect_devicesR15running_machineiiiPKcS2_","__ZN19resource_pool_arrayIcEC1EPci","__ZN19resource_pool_arrayIcEC2EPci","__ZN19resource_pool_arrayIcED1Ev","__ZL15inputx_key_namej","__ZN13delegate_baseIfRK18input_field_configf8_noparamS3_E4bindEP22delegate_generic_class","__ZNK11tagged_listI8device_tE4findEPKc","__ZNK8tagmap_tIP8device_tE14find_hash_onlyEPKc","__ZN13delegate_baseIvRK18input_field_configPvjjE4bindEP22delegate_generic_class","__ZN13delegate_baseIjRK18input_field_configPv8_noparamS4_E4bindEP22delegate_generic_class","__ZN20resource_pool_objectI18_device_field_infoEC1EPS0_","__ZN20resource_pool_objectI18_device_field_infoEC2EPS0_","__ZN20resource_pool_objectI18_device_field_infoED1Ev","__ZN13resource_pool9add_arrayIcEEPT_S2_i","__ZN19resource_pool_arrayIcED0Ev","__ZN19resource_pool_arrayIcED2Ev","__ZN13resource_pool10add_objectI18_device_field_infoEEPT_S3_","__ZNK15running_machine3osdEv","__ZN20resource_pool_objectI19_analog_field_stateEC1EPS0_","__ZN20resource_pool_objectI19_analog_field_stateEC2EPS0_","__ZN20resource_pool_objectI19_analog_field_stateED1Ev","__ZN18_input_field_stateC2Ev","__ZN20resource_pool_objectI18_input_field_stateEC1EPS0_","__ZN20resource_pool_objectI18_input_field_stateEC2EPS0_","__ZN20resource_pool_objectI18_input_field_stateED1Ev","__ZN20resource_pool_objectI17_input_port_stateEC1EPS0_","__ZN20resource_pool_objectI17_input_port_stateEC2EPS0_","__ZN20resource_pool_objectI17_input_port_stateED1Ev","__ZN7astring3cpyERKS_","__ZN7astring3catEPKc","__ZN20resource_pool_objectI18_device_field_infoED0Ev","__ZN20resource_pool_objectI18_device_field_infoED2Ev","__ZN13resource_pool10add_objectI19_analog_field_stateEEPT_S3_","__ZN20resource_pool_objectI19_analog_field_stateED0Ev","__ZN20resource_pool_objectI19_analog_field_stateED2Ev","__ZN20resource_pool_objectI18_input_field_stateED0Ev","__ZN20resource_pool_objectI18_input_field_stateED2Ev","__ZN20resource_pool_objectI17_input_port_stateED0Ev","__ZN20resource_pool_objectI17_input_port_stateED2Ev","__Z25mame_null_output_callbackPvPKcPc","__ZltRK8attotimeS1_","__ZNK10input_codeeqERKS_","__ZNK14machine_config10devicelistEv","__ZN11simple_listI16input_type_entryEC2ER13resource_pool","__ZN10input_codeC2ERKS_","__ZNK15running_machine18new_driver_pendingEv","__ZNK15running_machine15new_driver_nameEv","__ZNK15running_machine12exit_pendingEv","__Z14TMS9928A_resetv","__ZN7astring3insEiPKc","__ZN11simple_listI16input_type_entryEC1ER13resource_pool","__ZN9input_seqC2E10input_codeS0_S0_S0_S0_S0_S0_","__ZNK11emu_options7verboseEv","__ZNK11emu_options11read_configEv","__Z25mame_file_output_callbackPvPKcPc","__Z17mame_printf_errorPKcz","__Z19mame_printf_warningPKcz","__Z16mame_printf_infoPKcz","__Z19mame_printf_verbosePKcz","__Z17mame_printf_debugPKcz","__ZN7astring7vprintfEPKcPc","__ZNK7astring3lenEv","__Z8logerrorPKcz","__ZN19_input_port_privateC2Ev","__Z12mame_executeR11emu_optionsR13osd_interface","__Z10popmessagePKcz","__Z15TMS9928A_vram_rP13address_spacej","__Z15TMS9928A_vram_wP13address_spacejh","__ZNK13address_space7machineEv","__ZL15change_registerR15running_machineih","__Z19TMS9928A_register_rP13address_spacej","__Z19TMS9928A_register_wP13address_spacejh","__Z22screen_update_tms9928aP13screen_deviceP8bitmap_tPK10_rectangle","__ZL17palette_get_colorR15running_machinej","__ZL17palette_set_colorR15running_machinejj","__ZNK13video_manager15skip_this_frameEv","__ZL12draw_spritesP8device_tP8bitmap_tPK10_rectangle","__Z18TMS9928A_interruptR15running_machine","__Z18TMS9928A_configurePK18TMS9928a_interface","__Z20video_start_tms9928aR15running_machine","__ZNK13screen_device5widthEv","__ZNK13screen_device6heightEv","__ZNK13screen_device6formatEv","__ZN15running_machine4saveEv","__ZL21palette_init_tms9928aR15running_machinePKh","__ZL18palette_set_colorsR15running_machinejPKji","__ZNK13screen_device12frame_periodEv","__ZN12save_manager9save_itemIiEEvPKcS2_iRT_S2_","__ZL14TMS9928A_startR15running_machinePK18TMS9928a_interface","__Z33construct_machine_config_tms9928aR14machine_configP8device_t","__ZN13resource_pool10add_objectI8bitmap_tEEPT_S3_","__ZNK8device_t7startedEv","__ZN12save_manager12save_pointerIhEEvPKcS2_iPT_S2_j","__ZN20resource_pool_objectI8bitmap_tEC1EPS0_","__ZN20resource_pool_objectI8bitmap_tEC2EPS0_","__ZN20resource_pool_objectI8bitmap_tED1Ev","__ZL10draw_mode0P8device_tP8bitmap_tPK10_rectangle","__ZL10draw_mode1P8device_tP8bitmap_tPK10_rectangle","__ZL10draw_mode2P8device_tP8bitmap_tPK10_rectangle","__ZN20resource_pool_objectI8bitmap_tED0Ev","__ZN20resource_pool_objectI8bitmap_tED2Ev","__ZL11draw_mode12P8device_tP8bitmap_tPK10_rectangle","__ZL10draw_mode3P8device_tP8bitmap_tPK10_rectangle","__ZL14draw_modebogusP8device_tP8bitmap_tPK10_rectangle","__Z8downcastIR12timer_device8device_tET_RT0_","__ZleRK8attotimeS1_","__ZL11draw_mode23P8device_tP8bitmap_tPK10_rectangle","__ZN12timer_deviceC2ERK14machine_configPKcP8device_tj","__ZN12timer_device24static_configure_genericER8device_tPFvRS_PviE","__ZN12timer_device25static_configure_periodicER8device_tPFvRS_PviE8attotime","__ZNK12timer_device21device_validity_checkER11emu_optionsRK11game_driver","__ZN12timer_device12device_startEv","__ZN15running_machine6deviceI13screen_deviceEEPT_PKc","__ZN8device_t9save_itemIbEEvRT_PKci","__Z14device_creatorI12timer_deviceEP8device_tRK14machine_configPKcS2_j","__Z8downcastIP13screen_device8device_tET_PT0_","__ZN12timer_device12device_timerER9emu_timerjiPv","__ZN12timer_deviceD1Ev","__ZN12save_manager9save_itemIbEEvPKcS2_iRT_S2_","__ZN20resource_pool_objectI12timer_deviceEC1EPS0_","__ZN20resource_pool_objectI12timer_deviceEC2EPS0_","__ZN20resource_pool_objectI12timer_deviceED1Ev","__ZN12timer_deviceD2Ev","__ZL9get_tokenP8device_t","__ZN12timer_device12device_resetEv","__ZN12timer_deviceD0Ev","__ZN13resource_pool10add_objectI12timer_deviceEEPT_S3_","__ZN20resource_pool_objectI12timer_deviceED0Ev","__ZN20resource_pool_objectI12timer_deviceED2Ev","__Z8downcastIPK24legacy_image_device_baseK8device_tET_PT0_","__ZNK18legacy_device_base13inline_configEv","__Z26device_get_config_cartslotPK8device_tjP10deviceinfo","__ZL10get_configPK8device_t","__ZL21device_start_cartslotP8device_t","__ZL20device_load_cartslotR22device_image_interface","__ZL22device_unload_cartslotR22device_image_interface","__ZL33device_image_get_devices_cartslotR22device_image_interface","__ZL29device_softlist_load_cartslotR22device_image_interfacePcS1_P9rom_entry","__ZN15cartslot_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZNK18legacy_device_base17device_rom_regionEv","__ZNK18legacy_device_base24device_mconfig_additionsEv","__ZNK18legacy_device_base18device_input_portsEv","__ZN15cartslot_deviceD1Ev","__ZNK24legacy_image_device_base10image_typeEv","__ZNK24legacy_image_device_base11is_readableEv","__ZNK24legacy_image_device_base12is_writeableEv","__ZNK24legacy_image_device_base12is_creatableEv","__ZNK24legacy_image_device_base14must_be_loadedEv","__ZNK24legacy_image_device_base16is_reset_on_loadEv","__ZNK24legacy_image_device_base15image_interfaceEv","__ZNK24legacy_image_device_base15file_extensionsEv","__ZNK24legacy_image_device_base19create_option_guideEv","__Z21legacy_device_creatorI15cartslot_deviceEP8device_tRK14machine_configPKcS2_j","__ZN15cartslot_deviceD0Ev","__ZNK15running_machine6configEv","__ZThn368_N15cartslot_deviceD1Ev","__ZThn368_N15cartslot_deviceD0Ev","__ZThn368_NK24legacy_image_device_base10image_typeEv","__ZThn368_NK24legacy_image_device_base11is_readableEv","__ZThn368_NK24legacy_image_device_base12is_writeableEv","__ZThn368_NK24legacy_image_device_base12is_creatableEv","__ZThn368_NK24legacy_image_device_base14must_be_loadedEv","__ZThn368_NK24legacy_image_device_base16is_reset_on_loadEv","__ZThn368_NK24legacy_image_device_base15image_interfaceEv","__ZThn368_NK24legacy_image_device_base15file_extensionsEv","__ZThn368_NK24legacy_image_device_base19create_option_guideEv","__ZN15cartslot_deviceD2Ev","__ZN20resource_pool_objectI15cartslot_deviceEC1EPS0_","__ZN20resource_pool_objectI15cartslot_deviceEC2EPS0_","__ZN20resource_pool_objectI15cartslot_deviceED1Ev","__ZN22device_image_interface6existsEv","__ZN22device_image_interface8filenameEv","__ZL17process_cartridgeP22device_image_interface13_process_mode","__ZN13resource_pool10add_objectI15cartslot_deviceEEPT_S3_","__ZN20resource_pool_objectI15cartslot_deviceED0Ev","__ZN20resource_pool_objectI15cartslot_deviceED2Ev","__ZL12identify_pcbR22device_image_interface","__Z8downcastIPK18legacy_device_baseK8device_tET_PT0_","__Z8downcastIP18legacy_device_base8device_tET_PT0_","__ZN8device_t9interfaceERP23device_memory_interface","__ZNK8device_t6memoryEv","__ZNK18legacy_device_base5tokenEv","__ZL14load_cartridgeP22device_image_interfacePK9rom_entryS3_13_process_mode","__ZN22device_image_interface5fseekExi","__ZNK23device_memory_interface12space_configE16address_spacenum","__Z18software_get_cloneR11emu_optionsPcPKc","__Z18software_list_findP14_software_listPKcP13software_info","__Z19software_list_closeP14_software_list","__Z20software_get_supportR11emu_optionsPcPKc","__Z18software_list_openR11emu_optionsPKciPFvS2_E","__Z19software_list_parseP14_software_listPFvPKcEPv","__ZL10expat_freePv","__ZL12expat_mallocj","__ZL13expat_reallocPvj","__ZL13start_handlerPvPKcPS1_","__Z29software_list_get_descriptionP14_software_list","__ZL11end_handlerPvPKc","__ZL12data_handlerPvPKci","__ZL11parse_errorP12_parse_statePKcz","__ZL23software_list_get_countP14_software_list","__ZNK11emu_options9hash_pathEv","__Z18software_find_partP13software_infoPKcS2_","__Z33software_list_find_approx_matchesP14_software_listPKciPP13software_infoS2_","__ZN13resource_pool9add_arrayIiEEPT_S2_i","__Z8downcastIPK18legacy_device_base8device_tET_PT0_","__Z18software_part_nextP13software_part","__ZNK8device_t8typenextEv","__ZL24softlist_penalty_comparePKcS0_","__Z24software_display_matchesRK11device_listR11emu_optionsPKcS5_","__Z18load_software_partP22device_image_interfacePKcPP13software_infoPP13software_partPPc","__ZN14emu_fatalerrorC1ERKS_","__ZL19software_name_splitR15running_machinePKcPPcS4_S4_","__ZN13resource_pool10add_objectI13software_infoEEPT_S3_","__ZL26device_start_software_listP8device_t","__Z25software_part_get_featureP13software_partPKc","__Z31device_get_config_software_listPK8device_tjP10deviceinfo","__ZN13resource_pool10add_objectI13software_partEEPT_S3_","__ZN13resource_pool10add_objectI12feature_listEEPT_S3_","__ZN20software_list_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN20software_list_deviceD1Ev","__ZL35device_validity_check_software_listPK11game_driverPK8device_tR11emu_options","__Z21legacy_device_creatorI20software_list_deviceEP8device_tRK14machine_configPKcS2_j","__ZN20software_list_deviceD2Ev","__ZN20resource_pool_objectI20software_list_deviceEC1EPS0_","__ZN20resource_pool_objectI20software_list_deviceEC2EPS0_","__ZN20resource_pool_objectI20software_list_deviceED1Ev","__ZN20resource_pool_objectI12feature_listEC1EPS0_","__ZN20resource_pool_objectI12feature_listEC2EPS0_","__ZN20resource_pool_objectI12feature_listED1Ev","__ZN20resource_pool_objectI13software_partEC1EPS0_","__ZN20resource_pool_objectI13software_partEC2EPS0_","__ZN20resource_pool_objectI13software_partED1Ev","__ZN20resource_pool_objectI13software_infoEC1EPS0_","__ZN20resource_pool_objectI13software_infoEC2EPS0_","__ZN20resource_pool_objectI13software_infoED1Ev","__ZN20software_list_deviceD0Ev","__ZN13resource_pool10add_objectI20software_list_deviceEEPT_S3_","__ZN20resource_pool_objectI20software_list_deviceED0Ev","__ZN20resource_pool_objectI20software_list_deviceED2Ev","__ZN20resource_pool_objectI12feature_listED0Ev","__ZN20resource_pool_objectI12feature_listED2Ev","__ZN20resource_pool_objectI13software_partED0Ev","__ZN20resource_pool_objectI13software_partED2Ev","__ZNSt9exceptionC2ERKS_","__ZL21software_romdata_nextP9rom_entry","__ZL11tagmap_hashPKc1743","__ZN19resource_pool_arrayIiEC1EPii","__ZN19resource_pool_arrayIiEC2EPii","__ZN19resource_pool_arrayIiED1Ev","__ZN8tagmap_tIP13software_infoEC1Ev","__ZN8tagmap_tIP13software_infoE3addEPKcS1_b","__ZNK8tagmap_tIP13software_infoE4findEPKc","__ZL21software_find_romdataP13software_partPKc","__ZN8tagmap_tIP13software_infoED1Ev","__ZN8tagmap_tIP13software_infoED2Ev","__ZN8tagmap_tIP13software_infoE5resetEv","__ZL11tagmap_findPK7_tagmapPKc","__ZL21tagmap_find_prehashedPK7_tagmapPKcj","__ZN8tagmap_tIP13software_infoEC2Ev","__ZN14emu_fatalerrorC2ERKS_","__ZN13emu_exceptionC2ERKS_","__ZL13add_rom_entryP14_software_listPKcS2_jjj","__ZL17add_software_partP14_software_listPKcS2_","__ZN20resource_pool_objectI13software_infoED0Ev","__ZN20resource_pool_objectI13software_infoED2Ev","__ZN19resource_pool_arrayIiED0Ev","__ZN19resource_pool_arrayIiED2Ev","__Z16dump_unfreed_memv","__Z12track_memoryb","__ZL11add_featureP14_software_listPcS1_","__ZL11unknown_tagP12_parse_statePKc","__ZL8add_infoP14_software_listPcS1_","___cxx_global_var_init","__Z16malloc_file_linejPKci","__ZN12memory_entry8allocateEjPvPKci","__Z22malloc_array_file_linejPKci","__Z14free_file_linePvPKci","__ZN12memory_entry4findEPv","__ZN12memory_entry7releaseEPS_","__ZN13resource_pool5clearEv","__ZN13resource_pool3addER18resource_pool_item","__ZN13resource_poolC2Ei","__ZN13resource_poolD2Ev","__ZN13resource_pool6removeEPv","__ZN12memory_entry12acquire_lockEv","__ZN12memory_entry12release_lockEv","__GLOBAL__I_a","__ZN12cli_frontendC2ER11cli_optionsR13osd_interface","__ZN12cli_frontendD2Ev","__ZN11cli_optionsC2Ev","__ZN12cli_frontend7executeEiPPc","__ZNK14emu_fatalerror6stringEv","__ZNK14emu_fatalerror8exitcodeEv","__ZN11driver_list6driverEi","__ZNK17driver_enumerator5countEv","__ZNK12core_options7commandEv","__ZNK11emu_options11system_nameEv","__ZN14emu_fatalerrorC1EiPKcz","__ZN7astring9trimspaceEv","__ZNK11emu_options13software_nameEv","__ZNK11device_list5firstIK22device_image_interfaceEEbRPT_","__ZNK22device_image_interface19brief_instance_nameEv","__ZNK16device_interface4nextIK22device_image_interfaceEEbRPT_","__ZNK17driver_enumerator6driverEv","__ZN12cli_frontend16execute_commandsEPKc","__ZN12cli_frontend7listxmlEPKc","__ZN12cli_frontend8listfullEPKc","__ZN12cli_frontend10listsourceEPKc","__ZN17driver_enumerator5resetEv","__ZNK17driver_enumerator8includedEi","__ZNK17driver_enumerator7currentEv","__ZN17driver_enumerator5cloneEv","__ZN17driver_enumerator7includeEv","__ZN17driver_enumerator11exclude_allEv","__ZNK17driver_enumerator6configEv","__ZN12cli_frontend10listclonesEPKc","__ZN12cli_frontend12listbrothersEPKc","__ZN12cli_frontend7listcrcEPKc","__ZNK8device_t4typeEv","__ZNK8device_t5clockEv","__ZNK15hash_collection4flagEc","__ZNK14machine_config12first_deviceEv","__ZN12cli_frontend8listromsEPKc","__ZN12cli_frontend11listsamplesEPKc","__ZN12cli_frontend11listdevicesEPKc","__ZNK16device_interface6deviceEv","__ZNK21device_slot_interface19get_slot_interfacesEv","__ZNK11device_list5firstIK21device_slot_interfaceEEbRPT_","__ZNK16device_interface4nextIK21device_slot_interfaceEEbRPT_","__ZNK22device_image_interface13instance_nameEv","__ZNK7astring3chrEii","__ZN7astringC1ERKS_ii","__ZN12cli_frontend9listslotsEPKc","__ZN12cli_frontend9listmediaEPKc","__ZN13media_auditorD1Ev","__ZN12cli_frontend10verifyromsEPKc","__ZN12cli_frontend13verifysamplesEPKc","__ZN12cli_frontend12listsoftwareEPKc","__ZNK9hash_base4nameEv","__ZNK9hash_base4nextEv","__ZNK16media_identifier7matchesEv","__ZNK16media_identifier5totalEv","__ZNK16media_identifier7nonromsEv","__ZNK7astringeqEPKc","__ZN7astringaSEPKc","__ZNK15hash_collection5firstEv","__ZN16media_identifierD1Ev","__ZN12cli_frontend12display_helpEv","__ZN16media_identifierC2ER11cli_options","__ZN7astringC1EPKcS1_S1_","__ZN13resource_pool9add_arrayI7astringEEPT_S3_i","__ZN12cli_frontend8romidentEPKc","__ZN16media_identifier8identifyEPKc","__ZN16media_identifier13identify_fileEPKc","__ZNK17driver_enumerator7optionsEv","__ZN15hash_collection7computeEPKhjPKc","__ZN19resource_pool_arrayI7astringEC1EPS0_i","__ZN19resource_pool_arrayI7astringEC2EPS0_i","__ZN19resource_pool_arrayI7astringED1Ev","__ZN16media_identifier13identify_dataEPKcPKhi","__ZN16media_identifier12find_by_hashERK15hash_collectioni","__ZN11cli_optionsD0Ev","__ZN19resource_pool_arrayI7astringED0Ev","__ZNK11simple_listI9hash_baseE5firstEv","__ZN11simple_listI12audit_recordE6detachERS0_","__ZN17driver_enumerator7includeEi","__ZN12core_options9unadornedEi","__ZNK8device_t4nextIK21device_slot_interfaceEEbRPT_","__ZN8device_t9interfaceIK21device_slot_interfaceEEbRPT_","__ZNK8device_t4nextIK22device_image_interfaceEEbRPT_","__ZN8device_t9interfaceIK22device_image_interfaceEEbRPT_","__ZN7astringC2EPKcS1_S1_","__ZN16media_identifierD2Ev","__ZNK7astring3cmpEPKc","__ZN13media_auditorD2Ev","__ZN11simple_listI12audit_recordED1Ev","__ZN11simple_listI12audit_recordED2Ev","__ZN11simple_listI12audit_recordE5resetEv","__ZN11simple_listI12audit_recordE6removeERS0_","__ZN7astringC2ERKS_ii","__ZN7astring9cpysubstrERKS_ii","__ZN11driver_list5cloneEi","__ZN19resource_pool_arrayI7astringED2Ev","__ZN11simple_listI12audit_recordED0Ev","__ZNK21device_slot_interface16get_default_cardEv","__ZNK8device_t10configuredEv","__ZN11simple_listI8device_tE6appendERS0_","__ZN11simple_listI8device_tE6detachERS0_","__ZNK11device_list5firstI21device_slot_interfaceEEbRPT_","__ZNK16device_interface4nextI21device_slot_interfaceEEbRPT_","__ZN11device_listD1Ev","__ZN14machine_configD2Ev","__ZNK14machine_config12first_screenEv","__ZN14machine_config21device_add_subdevicesEP8device_t","__ZNK8device_t24machine_config_additionsEv","__ZN8tagmap_tIP8device_tE6removeES1_","__ZN8tagmap_tIP8device_tE15add_unique_hashEPKcS1_b","__ZN11simple_listI8device_tE6removeERS0_","__ZNK8device_t4nextI21device_slot_interfaceEEbRPT_","__ZN8device_t9interfaceI21device_slot_interfaceEEbRPT_","__ZN11device_listD2Ev","__ZN14machine_configC2ERK11game_driverR11emu_options","__ZN14machine_config10device_addEP8device_tPKcPFS1_RKS_S3_S1_jEj","__ZN11tagged_listI8device_tE6appendEPKcRS0_","__ZN14machine_config11device_findEP8device_tPKc","__ZN11tagged_listI8device_tED2Ev","__Z22get_temp_string_bufferv","__ZNK11device_list7machineEv","__ZN8tagmap_tIP8device_tED1Ev","__ZN11simple_listI8device_tED1Ev","__ZN11simple_listI8device_tED2Ev","__ZN11simple_listI8device_tE5resetEv","__ZN8tagmap_tIP8device_tED2Ev","__ZN8tagmap_tIP8device_tE5resetEv","__ZN11device_listC2ER13resource_pool","__ZN11device_list15set_machine_allER15running_machine","__ZN8device_t11set_machineER15running_machine","__ZN11device_list9start_allEv","__ZN8delegateIFvvEEC1I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN11device_list9reset_allEv","__ZN11device_list4exitEv","__ZN11device_list11presave_allEv","__ZN11device_list12postload_allEv","__ZN11tagged_listI8device_tE6detachERS0_","__ZN11simple_listI8device_tED0Ev","__ZN11tagged_listI8device_tEC2ER13resource_pool","__ZN11device_list17start_new_devicesEv","__ZN8device_t5startEv","__ZN18delegate_late_bindD2Ev","__ZN18delegate_late_bindC2Ev","__ZN8device_t16static_set_clockERS_j","__ZN8device_t5resetEv","__ZN11device_list8stop_allEv","__ZN8device_t4stopEv","__ZNK11device_list5firstEPFP8device_tRK14machine_configPKcS1_jE","__ZNK11device_list5countEPFP8device_tRK14machine_configPKcS1_jE","__ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jERS0_","__ZNK11device_list7indexofEPFP8device_tRK14machine_configPKcS1_jES6_","__ZNK11device_list4findEPFP8device_tRK14machine_configPKcS1_jEi","__ZN11tagged_listI8device_tE5resetEv","__ZN8device_t8pre_saveEv","__ZN8device_t9post_loadEv","__ZN8device_tC2ERK14machine_configPFPS_S2_PKcS3_jES5_S5_S3_j","__ZN8device_tD0Ev","__ZN8device_tD2Ev","__ZN8device_t22device_config_completeEv","__ZNK8device_t21device_validity_checkER11emu_optionsRK11game_driver","__ZNK8device_t17device_rom_regionEv","__ZNK8device_t24device_mconfig_additionsEv","__ZNK8device_t18device_input_portsEv","__ZN8device_t12device_resetEv","__ZN8device_t11device_stopEv","__ZN8device_t15device_pre_saveEv","__ZN8device_t16device_post_loadEv","__ZN8device_t20device_clock_changedEv","__ZN8device_t18device_debug_setupEv","__ZN8device_t12device_timerER9emu_timerjiPv","__ZN8device_t16auto_finder_baseD2Ev","__ZNK8device_t7mconfigEv","__ZNK16device_interface14interface_nextEv","__ZL14divu_64x32_remyjPj","__ZN8device_t9interfaceERP24device_execute_interface","__ZN8device_t20register_auto_finderERNS_16auto_finder_baseE","__ZNK8device_t10siblingtagER7astringPKc","__ZN8device_t15config_completeEv","__ZNK8device_t14validity_checkER11emu_optionsRK11game_driver","__ZN8device_t20notify_clock_changedEv","__ZN8device_t15set_clock_scaleEd","__ZNK8device_t18clocks_to_attotimeEy","__ZN8device_t11timer_allocEjPv","__ZNK12save_manager18registration_countEv","__ZN8device_t9interfaceI22device_sound_interfaceEEbRPT_","__ZN8device_t11debug_setupEv","__ZN8device_t9save_itemIjEEvRT_PKci","__ZN8device_t9save_itemIdEEvRT_PKci","__ZN8device_t16auto_finder_baseC2ERS_PKc","__ZN8device_t16auto_finder_base11find_deviceERS_PKc","__ZNK8device_t9subdeviceEPKc","__ZNK8device_t13siblingdeviceEPKc","__ZN13resource_pool10add_objectI12device_debugEEPT_S3_","__ZN8device_t16auto_finder_baseD0Ev","__ZN16device_interfaceD2Ev","__ZN16device_interface25interface_config_completeEv","__ZNK16device_interface24interface_validity_checkER11emu_optionsRK11game_driver","__ZN16device_interface19interface_pre_startEv","__ZN16device_interface20interface_post_startEv","__ZN16device_interface19interface_pre_resetEv","__ZN16device_interface20interface_post_resetEv","__ZN16device_interface18interface_pre_stopEv","__ZN16device_interface19interface_post_stopEv","__ZN16device_interface18interface_pre_saveEv","__ZN16device_interface19interface_post_loadEv","__ZN16device_interface23interface_clock_changedEv","__ZN16device_interface21interface_debug_setupEv","__ZN21delegate_internal_mfpC2IM11device_listFvvEEET_","__ZN16device_interfaceC2ER8device_t","__ZN11simple_listI8device_tEC2ER13resource_pool","__ZNK11simple_listIN12save_manager11state_entryEE5countEv","__ZN12save_manager9save_itemIdEEvPKcS2_iRT_S2_","__ZN12save_manager9save_itemIjEEvPKcS2_iRT_S2_","__ZN20resource_pool_objectI12device_debugEC1EPS0_","__ZN20resource_pool_objectI12device_debugEC2EPS0_","__ZN20resource_pool_objectI12device_debugED1Ev","__ZN8delegateIFvvEEC2I11device_listEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I11device_listEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM11device_listFvvEEET_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI11device_listEEP22delegate_generic_classR18delegate_late_bind","__ZN11simple_listI8device_tEC1ER13resource_pool","__ZN8tagmap_tIP8device_tEC1Ev","__ZN8tagmap_tIP8device_tEC2Ev","__ZN18delegate_late_bindD1Ev","__ZN16device_interfaceD0Ev","__ZN20resource_pool_objectI12device_debugED0Ev","__ZN20resource_pool_objectI12device_debugED2Ev","__ZN18delegate_late_bindD0Ev","__ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcy","__ZN17address_map_entry20internal_set_handlerEPFvP13address_spacejhEPKcy","__ZNK13delegate_baseIhR13address_spacejh8_noparamE4nameEv","__ZNK13delegate_baseIvR13address_spacejhhE4nameEv","__ZNK13delegate_baseItR13address_spacejt8_noparamE4nameEv","__ZNK13delegate_baseIvR13address_spacejttE4nameEv","__ZNK13delegate_baseIjR13address_spacejj8_noparamE4nameEv","__ZNK13delegate_baseIvR13address_spacejjjE4nameEv","__ZNK13delegate_baseIyR13address_spacejy8_noparamE4nameEv","__ZNK13delegate_baseIvR13address_spacejyyE4nameEv","__ZN16map_handler_dataC1Ev","__ZN8delegateIFhR13address_spacejhEEC1Ev","__ZN8delegateIFtR13address_spacejtEEC1Ev","__ZN8delegateIFjR13address_spacejjEEC1Ev","__ZN8delegateIFyR13address_spacejyEEC1Ev","__ZN8delegateIFvR13address_spacejhhEEC1Ev","__ZN8delegateIFvR13address_spacejttEEC1Ev","__ZN8delegateIFvR13address_spacejjjEEC1Ev","__ZN8delegateIFvR13address_spacejyyEEC1Ev","__ZN16map_handler_dataD1Ev","__ZN16map_handler_data7set_tagERK8device_tPKc","__ZN17address_map_entry20internal_set_handlerEPFhP13address_spacejEPKcPFvS1_jhES5_y","__ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFhPS0_jES4_y","__ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFvPS0_jhES4_y","__ZN17address_map_entry20internal_set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_y","__ZN17address_map_entry20internal_set_handlerERK8device_tPKc8delegateIFhR13address_spacejhEEy","__ZN8delegateIFhR13address_spacejhEEaSERKS3_","__ZN17address_map_entry20internal_set_handlerERK8device_tPKc8delegateIFvR13address_spacejhhEEy","__ZN8delegateIFvR13address_spacejhhEEaSERKS3_","__ZN8delegateIFtR13address_spacejtEEaSERKS3_","__ZN8delegateIFvR13address_spacejttEEaSERKS3_","__ZN8delegateIFtR13address_spacejtEEC1ERKS3_","__ZN8delegateIFvR13address_spacejttEEC1ERKS3_","__ZN8delegateIFjR13address_spacejjEEaSERKS3_","__ZN8delegateIFvR13address_spacejjjEEaSERKS3_","__ZN8delegateIFjR13address_spacejjEEC1ERKS3_","__ZN8delegateIFvR13address_spacejjjEEC1ERKS3_","__ZN8delegateIFyR13address_spacejyEEaSERKS3_","__ZN8delegateIFvR13address_spacejyyEEaSERKS3_","__ZN8delegateIFyR13address_spacejyEEC1ERKS3_","__ZN8delegateIFvR13address_spacejyyEEC1ERKS3_","__ZN18address_map_entry8C2ER11address_mapjj","__ZN17address_map_entryC2ER11address_mapjj","__ZNK23device_memory_interface11address_mapE16address_spacenum","__ZN11address_map9configureE16address_spacenumh","__ZN11address_map15set_global_maskEj","__ZN11simple_listI17address_map_entryE6appendERS0_","__ZN11simple_listI17address_map_entryEC1ER13resource_pool","__ZNK8device_t9interfaceIK23device_memory_interfaceEEbRPT_","__ZN11simple_listI17address_map_entryED1Ev","__ZN11address_mapD2Ev","__ZN20resource_pool_objectI18address_map_entry8EC1EPS0_","__ZN20resource_pool_objectI18address_map_entry8EC2EPS0_","__ZN20resource_pool_objectI18address_map_entry8ED1Ev","__ZN11address_mapC2ERK8device_t16address_spacenum","__ZN11address_map3addEjjP18address_map_entry8","__ZN13resource_pool10add_objectI18address_map_entry8EEPT_S3_","__ZN17address_map_entryD2Ev","__ZN20resource_pool_objectI18address_map_entry8ED0Ev","__ZN11simple_listI17address_map_entryE6detachERS0_","__ZN11simple_listI17address_map_entryEC2ER13resource_pool","__ZN21delegate_internal_mfpaSERKS_","__ZN18address_map_entry8D1Ev","__ZN18address_map_entry8D2Ev","__ZN11simple_listI17address_map_entryED2Ev","__ZN11simple_listI17address_map_entryE5resetEv","__ZN11simple_listI17address_map_entryE6removeERS0_","__ZN8delegateIFvR13address_spacejyyEEC2Ev","__ZN13delegate_baseIvR13address_spacejyyEC2Ev","__ZN8delegateIFvR13address_spacejjjEEC2Ev","__ZN13delegate_baseIvR13address_spacejjjEC2Ev","__ZN8delegateIFvR13address_spacejttEEC2Ev","__ZN13delegate_baseIvR13address_spacejttEC2Ev","__ZN8delegateIFvR13address_spacejhhEEC2Ev","__ZN13delegate_baseIvR13address_spacejhhEC2Ev","__ZN8delegateIFyR13address_spacejyEEC2Ev","__ZN13delegate_baseIyR13address_spacejy8_noparamEC2Ev","__ZN8delegateIFjR13address_spacejjEEC2Ev","__ZN13delegate_baseIjR13address_spacejj8_noparamEC2Ev","__ZN8delegateIFtR13address_spacejtEEC2Ev","__ZN13delegate_baseItR13address_spacejt8_noparamEC2Ev","__ZN8delegateIFhR13address_spacejhEEC2Ev","__ZN13delegate_baseIhR13address_spacejh8_noparamEC2Ev","__ZN8delegateIFvR13address_spacejyyEEC2ERKS3_","__ZN13delegate_baseIvR13address_spacejyyEC2ERKS2_","__ZN8delegateIFyR13address_spacejyEEC2ERKS3_","__ZN13delegate_baseIyR13address_spacejy8_noparamEC2ERKS3_","__ZN13delegate_baseIvR13address_spacejyyEaSERKS2_","__ZN13delegate_baseIyR13address_spacejy8_noparamEaSERKS3_","__ZN8delegateIFvR13address_spacejjjEEC2ERKS3_","__ZN13delegate_baseIvR13address_spacejjjEC2ERKS2_","__ZN8delegateIFjR13address_spacejjEEC2ERKS3_","__ZN13delegate_baseIjR13address_spacejj8_noparamEC2ERKS3_","__ZN13delegate_baseIvR13address_spacejjjEaSERKS2_","__ZN13delegate_baseIjR13address_spacejj8_noparamEaSERKS3_","__ZN8delegateIFvR13address_spacejttEEC2ERKS3_","__ZN20resource_pool_objectI18address_map_entry8ED2Ev","__ZN11simple_listI17address_map_entryED0Ev","__ZN13delegate_baseIvR13address_spacejttEC2ERKS2_","__ZN8delegateIFtR13address_spacejtEEC2ERKS3_","__ZN13delegate_baseItR13address_spacejt8_noparamEC2ERKS3_","__ZN13delegate_baseIvR13address_spacejttEaSERKS2_","__ZN13delegate_baseItR13address_spacejt8_noparamEaSERKS3_","__ZN13delegate_baseIvR13address_spacejhhEaSERKS2_","__ZN13delegate_baseIhR13address_spacejh8_noparamEaSERKS3_","__ZN16map_handler_dataD2Ev","__ZN16map_handler_dataC2Ev","__ZN22device_image_interfaceC2ERK14machine_configR8device_t","__ZN22device_image_interfaceD0Ev","__ZN22device_image_interface16find_device_typeE10iodevice_t","__ZNK13memory_region5bytesEv","__ZN22device_image_interface15device_typenameE10iodevice_t","__ZN22device_image_interface20device_brieftypenameE10iodevice_t","__ZNK22device_image_interface19device_compute_hashER15hash_collectionPKvjPKc","__ZN22device_image_interface18set_image_filenameEPKc","__ZNK7astring4rchrEii","__ZN7astringaSERKS_","__ZN7astring6substrEii","__ZN22device_image_interface28device_get_creatable_formatsEv","__ZN22device_image_interface11clear_errorEv","__ZN22device_image_interface5errorEv","__ZN22device_image_interface8basenameEv","__ZN22device_image_interface28try_change_working_directoryEPKc","__ZN22device_image_interface23setup_working_directoryEv","__ZN11driver_list4findERK11game_driver","__ZN11driver_list15compatible_withEi","__ZN22device_image_interface17working_directoryEv","__ZN22device_image_interface19get_software_regionEPKc","__ZN22device_image_interface26get_software_region_lengthEPKc","__ZN22device_image_interfaceD2Ev","__ZN22device_image_interface9is_loadedEv","__ZN22device_image_interface11get_featureEPKc","__ZN22device_image_interface8run_hashEPFvR15hash_collectionPKhmPKcES1_S5_","__ZN22device_image_interface15image_checkhashEv","__ZN22device_image_interface3crcEv","__ZN22device_image_interface19determine_open_planEiPj","__ZN22device_image_interface18load_image_by_pathEjPKc","__ZN7astring3catERKS_","__ZN7astring3delEii","__ZN7astringC1ERKS_","__ZN22device_image_interface13load_softwareEPcS0_P9rom_entry","__ZN22device_image_interface9call_loadEv","__ZN22device_image_interface18call_softlist_loadEPcS0_P9rom_entry","__ZN22device_image_interface11call_createEiP18_option_resolution","__ZN22device_image_interface11call_unloadEv","__ZN22device_image_interface12call_displayEv","__ZN22device_image_interface17call_display_infoEv","__ZN22device_image_interface16call_get_devicesEv","__ZN22device_image_interface24get_device_specific_callEv","__ZNK22device_image_interface16get_partial_hashEv","__ZNK22device_image_interface15image_interfaceEv","__ZNK15running_machine5phaseEv","__ZN22device_image_interface16has_been_createdEv","__ZNK22device_image_interface10formatlistEv","__ZN20address_space_configC2Ev","__ZN22device_image_interface6unloadEv","__ZN22device_image_interface11finish_loadEv","__ZN22device_image_interface5clearEv","__ZN22device_image_interface4loadEPKc","__ZN22device_image_interface6createEPKcPK19image_device_formatP18_option_resolution","__ZN22device_image_interface12update_namesEv","__ZN7astringC2ERKS_","__ZN7astring3insEiRKS_","__ZN22device_image_interface13load_internalEPKcbiP18_option_resolution","__ZN23device_memory_interface16memory_translateE16address_spacenumiRj","__ZN23device_memory_interface11memory_readE16address_spacenumjiRy","__ZN23device_memory_interface13memory_readopEjiRy","__ZN23device_memory_interface17set_address_spaceE16address_spacenumR13address_space","__ZN23device_memory_interface12memory_writeE16address_spacenumjiy","__ZN23device_memory_interfaceC2ERK14machine_configR8device_t","__ZN23device_memory_interfaceD2Ev","__ZN23device_memory_interfaceD0Ev","__ZN23device_memory_interface18static_set_addrmapER8device_t16address_spacenumPFvR11address_mapRKS0_E","__ZNK23device_memory_interface24interface_validity_checkER11emu_optionsRK11game_driver","__ZppR16address_spacenumi","__ZNK11simple_listI17address_map_entryE5firstEv","__ZNK20address_space_config9addr2byteEj","__ZNK20address_space_config13addr2byte_endEj","__ZNK17address_map_entry4nextEv","__ZNK7astring3cmpERKS_","__ZN20resource_pool_objectI11address_mapEC1EPS0_","__ZN20resource_pool_objectI11address_mapEC2EPS0_","__ZN20resource_pool_objectI11address_mapED1Ev","___cxx_global_var_init2460","___cxx_global_var_init1","___cxx_global_var_init2","___cxx_global_var_init3","___cxx_global_var_init4","__ZN12joystick_map5parseEPKc","__ZN13resource_pool10add_objectI11address_mapEEPT_S3_","__ZN20resource_pool_objectI11address_mapED0Ev","__ZN20resource_pool_objectI11address_mapED2Ev","__ZN12joystick_mapC2Ev","__ZN12joystick_map6updateEii","__ZNK12input_device4itemE13input_item_id","__ZNK12input_device8devindexEv","__ZNK17input_device_item9itemclassEv","__ZNK17input_device_item6itemidEv","__ZNK10input_code10item_classEv","__ZNK11input_class7managerEv","__ZNK13input_manager7machineEv","__ZNK12joystick_map9to_stringER7astring","__ZN10input_codeC2ER12input_device13input_item_id","__ZNK12input_device8devclassEv","__ZN9input_seqpLE10input_code","__ZNK9input_seq6lengthEv","__ZN9input_seqoRE10input_code","__ZNK9input_seq8is_validEv","__ZNK10input_code8internalEv","__ZN9input_seq3setE10input_codeS0_S0_S0_S0_S0_S0_","__ZN9input_seq9backspaceEv","__ZN9input_seq7replaceE10input_codeS0_","__ZN12input_deviceC2ER11input_classiPKcPv","__ZppR13input_item_idi","__ZN11input_class19standard_item_classE13input_item_id","__ZNK11emu_options17joystick_deadzoneEv","__ZNK11emu_options19joystick_saturationEv","__ZNK11emu_options9steadykeyEv","__ZNK11emu_options16offscreen_reloadEv","__ZNK12input_device7machineEv","__ZN12joystick_mapD1Ev","__ZN12input_device8add_itemEPKc13input_item_idPFiPvS3_ES3_","__ZN13resource_pool10add_objectI24input_device_switch_itemEEPT_S3_","__Z8downcastIP24input_device_switch_item17input_device_itemET_PT0_","__ZN24input_device_switch_item27steadykey_update_to_currentEv","__ZNK12input_device29apply_deadzone_and_saturationEi","__ZNK12input_device15apply_steadykeyEv","__ZN24input_device_switch_item17steadykey_changedEv","__ZN11input_classC2ER13input_manager18input_device_classbb","__ZNK11input_class7machineEv","__ZN8delegateIFvvEEC1I11input_classEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN11input_class14frame_callbackEv","__ZN11input_class10add_deviceEPKcPv","__ZN13resource_pool10add_objectI26input_device_relative_itemEEPT_S3_","__ZN13resource_pool10add_objectI26input_device_absolute_itemEEPT_S3_","__ZN11input_class10add_deviceEiPKcPv","__ZppR18input_device_classi","__ZNK17code_string_tableixEj","__ZNK10input_code12device_classEv","__ZNK10input_code12device_indexEv","__ZNK11input_class5multiEv","__ZNK11input_class8maxindexEv","__ZN10input_code16set_device_indexEi","__ZNK10input_code13item_modifierEv","__ZNK11input_class6deviceEi","__ZNK12input_device7maxitemEv","__ZN17input_device_item10set_memoryEi","__ZN13input_managerC2ER15running_machine","__ZNK11emu_options14multi_keyboardEv","__ZNK11emu_options5mouseEv","__ZNK11emu_options11multi_mouseEv","__ZNK11emu_options8joystickEv","__ZNK11emu_options8lightgunEv","__ZN13input_manager12reset_memoryEv","__ZN13input_manager10code_valueE10input_code","__ZNK13input_manager16device_from_codeE10input_code","__ZNK13input_manager14item_from_codeE10input_code","__ZN13input_manager17code_pressed_onceE10input_code","__ZN13input_manager12code_pressedE10input_code","__ZN13input_manager13reset_pollingEv","__ZN13resource_pool10add_objectI12input_deviceEEPT_S3_","__ZN10input_code14set_item_classE16input_item_class","__ZNK10input_code7item_idEv","__ZN10input_code17set_item_modifierE19input_item_modifier","__ZNK17input_device_item6memoryEv","__ZNK17input_device_item6deviceEv","__ZN13input_manager13poll_switchesEv","__ZN13input_manager15code_check_axisER17input_device_item10input_code","__ZN13input_manager9poll_axesEv","__ZNK13input_manager16code_from_itemidE13input_item_id","__ZNK17input_device_item4nameEv","__ZNK13input_manager9code_nameER7astring10input_code","__ZNK17input_device_item5tokenEv","__ZNK17code_string_tableixEPKc","__ZN13input_manager11seq_pressedERK9input_seq","__ZNK13input_manager13code_to_tokenER7astring10input_code","__ZN13input_manager15code_from_tokenEPKc","__ZN13input_manager14seq_axis_valueERK9input_seqR16input_item_class","__ZN13input_manager14seq_poll_startE16input_item_classPK9input_seq","__ZN9input_seq5resetEv","__ZN13input_manager8seq_pollEv","__ZNK13input_manager8seq_nameER7astringRK9input_seq","__ZN24input_device_switch_item16read_as_relativeE19input_item_modifier","__ZN24input_device_switch_item16read_as_absoluteE19input_item_modifier","__ZNK12input_device22lightgun_reload_buttonEv","__ZNK12input_device17steadykey_enabledEv","__ZN12input_device16set_joystick_mapERK12joystick_map","__ZN7astring7toupperEv","__ZN7astring6delchrEi","__ZN24input_device_switch_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E","__ZN24input_device_switch_item14read_as_switchE19input_item_modifier","__ZN17input_device_item12update_valueEv","__ZN26input_device_relative_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E","__ZN26input_device_relative_item14read_as_switchE19input_item_modifier","__ZN26input_device_relative_item16read_as_relativeE19input_item_modifier","__ZNK13input_manager13seq_to_tokensER7astringRK9input_seq","__ZN13input_manager15seq_from_tokensER9input_seqPKc","__ZN13input_manager23set_global_joystick_mapEPKc","__ZN17input_device_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E16input_item_class","__ZN26input_device_relative_item16read_as_absoluteE19input_item_modifier","__ZN26input_device_absolute_item16read_as_relativeE19input_item_modifier","__ZN12input_device6joymapEv","__ZNK17input_device_item7currentEv","__ZN26input_device_absolute_itemC2ER12input_devicePKcPv13input_item_idPFiS4_S4_E","__ZN26input_device_absolute_item14read_as_switchE19input_item_modifier","__ZN26input_device_absolute_item16read_as_absoluteE19input_item_modifier","__ZN24input_device_switch_itemD1Ev","__ZN26input_device_relative_itemD1Ev","__ZN26input_device_absolute_itemD1Ev","__ZN17input_device_itemD1Ev","__ZN20resource_pool_objectI12input_deviceEC1EPS0_","__ZN20resource_pool_objectI12input_deviceEC2EPS0_","__ZN20resource_pool_objectI12input_deviceED1Ev","__ZN24input_device_switch_itemD0Ev","__ZN26input_device_relative_itemD0Ev","__ZN26input_device_absolute_itemD0Ev","__ZN17input_device_itemD0Ev","__ZN17input_device_itemD2Ev","__ZN20resource_pool_objectI12input_deviceED0Ev","__ZN21delegate_internal_mfpC2IM11input_classFvvEEET_","__ZNK12input_device8internalEv","__ZNK11input_class8devclassEv","__ZN12input_deviceD1Ev","__ZN8delegateIFvvEEC2I11input_classEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I11input_classEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM11input_classFvvEEET_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI11input_classEEP22delegate_generic_classR18delegate_late_bind","__ZN20resource_pool_objectI26input_device_absolute_itemEC1EPS0_","__ZN20resource_pool_objectI26input_device_absolute_itemEC2EPS0_","__ZN20resource_pool_objectI26input_device_absolute_itemED1Ev","__ZN20resource_pool_objectI26input_device_relative_itemEC1EPS0_","__ZN20resource_pool_objectI26input_device_relative_itemEC2EPS0_","__ZN20resource_pool_objectI26input_device_relative_itemED1Ev","__ZN20resource_pool_objectI24input_device_switch_itemEC1EPS0_","__ZN20resource_pool_objectI24input_device_switch_itemEC2EPS0_","__ZN20resource_pool_objectI24input_device_switch_itemED1Ev","__ZN26input_device_absolute_itemD2Ev","__ZN26input_device_relative_itemD2Ev","__ZN24input_device_switch_itemD2Ev","__ZN12joystick_mapaSERKS_","__ZN12joystick_map4copyERKS_","__ZN12joystick_mapD2Ev","__ZNK12core_options11float_valueEPKc","__ZN20resource_pool_objectI12input_deviceED2Ev","__ZN12input_deviceD2Ev","__ZN20resource_pool_objectI26input_device_absolute_itemED0Ev","__ZN20resource_pool_objectI26input_device_absolute_itemED2Ev","__ZN20resource_pool_objectI26input_device_relative_itemED0Ev","__ZN20resource_pool_objectI26input_device_relative_itemED2Ev","__ZN20resource_pool_objectI24input_device_switch_itemED0Ev","__ZN20resource_pool_objectI24input_device_switch_itemED2Ev","__ZNK15running_machine12first_screenEv","__GLOBAL__I_a2487","__Z26debug_cpu_configure_memoryR15running_machineR12symbol_table","__ZL10get_cpunumR12symbol_tablePv","__ZL9get_beamxR12symbol_tablePv","__ZL9get_beamyR12symbol_tablePv","__ZL9get_frameR12symbol_tablePv","__ZN8delegateIFvR13screen_devicebEEC1I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_","__ZL9on_vblankR15running_machineR13screen_deviceb","__ZL14debug_cpu_exitR15running_machine","__Z14debug_cpu_initR15running_machine","__ZN13resource_pool10add_objectI17_debugcpu_privateEEPT_S3_","__ZN13resource_pool10add_objectI12symbol_tableEEPT_S3_","__Z25debug_cpu_get_visible_cpuR15running_machine","__Z33debug_cpu_within_instruction_hookR15running_machine","__Z20debug_cpu_is_stoppedR15running_machine","__Z29debug_cpu_get_global_symtableR15running_machine","__ZN12device_debug8symtableEv","__ZL19expression_validatePvPKc16expression_space","__ZL22expression_read_memoryPvPKc16expression_spaceji","__ZL23expression_write_memoryPvPKc16expression_spacejiy","__Z22debug_cpu_flush_tracesR15running_machine","__ZN12device_debug11trace_flushEv","__Z30debug_cpu_get_visible_symtableR15running_machine","__Z23debug_cpu_source_scriptR15running_machinePKc","__ZN13emu_exceptionC1Ev","__ZNK12device_debug13comment_countEv","__ZNK11emu_options17comment_directoryEv","__ZNK15running_machine8basenameEv","__Z18debug_comment_saveR15running_machine","__ZN12device_debug14comment_exportER14_xml_data_node","__Z18debug_comment_loadR15running_machine","__ZNK13address_space6deviceEv","__ZNK13address_space8spacenumEv","__ZNK13address_space11logbytemaskEv","__ZN13address_space19set_debugger_accessEb","__Z19debug_cpu_translateP13address_spaceiPj","__ZN23device_memory_interface9translateE16address_spacenumiRj","__Z15debug_read_byteP13address_spaceji","__ZN23device_memory_interface4readE16address_spacenumjiRy","__Z15debug_read_wordP13address_spaceji","__ZNK13address_space10endiannessEv","__Z16debug_read_dwordP13address_spaceji","__Z16debug_read_qwordP13address_spaceji","__Z17debug_read_memoryP13address_spacejii","__Z16debug_write_byteP13address_spacejhi","__ZN23device_memory_interface5writeE16address_spacenumjiy","__ZN12device_debug14comment_importER14_xml_data_node","__Z16debug_write_wordP13address_spacejti","__Z17debug_write_dwordP13address_spacejji","__Z17debug_write_qwordP13address_spacejyi","__Z18debug_write_memoryP13address_spacejyii","__ZNK13address_space8bytemaskEv","__ZN23device_memory_interface6readopEjiRy","__ZNK13address_space10data_widthEv","__ZN16direct_read_data13read_raw_wordEjj","__ZN16direct_read_data19read_decrypted_wordEjj","__ZN16direct_read_data14read_raw_dwordEjj","__ZN16direct_read_data20read_decrypted_dwordEjj","__ZN16direct_read_data14read_raw_qwordEjj","__ZN16direct_read_data20read_decrypted_qwordEjj","__Z17debug_read_opcodeP13address_spacejii","__ZNK18device_state_entry4nextEv","__ZNK15running_machine10debug_viewEv","__ZN11simple_listIN12device_debug12dasm_commentEEC1ER13resource_pool","__ZN8device_t9interfaceI23device_disasm_interfaceEEbRPT_","__ZN12device_debug10get_cyclesER12symbol_tablePv","__ZN12device_debug12get_logunmapER12symbol_tablePv","__ZN12device_debug12set_logunmapER12symbol_tablePvy","__ZNK22device_state_interface11state_firstEv","__ZNK18device_state_entry6symbolEv","__ZN7astring7tolowerEv","__ZN12device_debug9get_stateER12symbol_tablePv","__ZN12device_debug9set_stateER12symbol_tablePvy","__ZNK12device_debug16min_opcode_bytesEv","__ZN12symbol_table4findEPKc","__ZN12device_debug14get_current_pcER12symbol_tablePv","__ZN11simple_listIN12device_debug12dasm_commentEED1Ev","__ZN12symbol_tableD1Ev","__ZN12device_debug20breakpoint_clear_allEv","__ZN12device_debug20watchpoint_clear_allEv","__ZN12device_debug10start_hookE8attotime","__ZL21reset_transient_flagsR15running_machine","__ZN12device_debugC2ER8device_t","__ZN12device_debugD2Ev","__ZN12device_debug24halt_on_next_instructionEPKcz","__ZN12device_debug19compute_debug_flagsEv","__ZN12device_debug9stop_hookEv","__ZN12device_debug14interrupt_hookEi","__ZN12device_debug16instruction_hookEj","__ZN12device_debug6tracer6updateEj","__ZgeRK8attotimeS1_","__ZNK8attotime9as_doubleEv","__ZNK15running_machine5soundEv","__ZNK15running_machine23scheduled_event_pendingEv","__ZN12device_debug16breakpoint_checkEj","__ZN13sound_manager13debugger_muteEb","__ZL19process_source_fileR15running_machine","__ZNK12device_debug2pcEv","__ZN12device_debug16memory_read_hookER13address_spacejy","__ZN12device_debug24prepare_for_step_overoutEj","__ZN12device_debug16watchpoint_checkER13address_spaceijyy","__ZN12device_debug13hotspot_checkER13address_spacej","__ZN12device_debug17memory_write_hookER13address_spacejyy","__ZNK12device_debug11disassembleEPcjPKhS2_","__ZN23device_disasm_interface11disassembleEPcjPKhS2_j","__ZN12device_debug6ignoreEb","__ZN12device_debug14go_next_deviceEv","__ZN12device_debug11single_stepEi","__ZN12device_debug16single_step_overEi","__ZN12device_debug15single_step_outEv","__ZN12device_debug2goEj","__ZN12device_debug9go_vblankEv","__ZN12device_debug12go_interruptEi","__ZN12device_debug15go_millisecondsEy","__ZplRK8attotimeS1_","__ZN12device_debug14breakpoint_setEjPKcS1_","__ZNK12device_debug10breakpoint5indexEv","__ZNK12device_debug10breakpoint4nextEv","__ZNK12device_debug10watchpoint5indexEv","__ZN12device_debug23breakpoint_update_flagsEv","__ZN12device_debug16breakpoint_clearEi","__ZN12device_debug17breakpoint_enableEib","__ZN12device_debug21breakpoint_enable_allEb","__ZN12device_debug23watchpoint_update_flagsER13address_space","__ZN12device_debug16watchpoint_clearEi","__ZN13resource_pool10add_objectIN12device_debug10breakpointEEEPT_S4_","__ZN12device_debug14watchpoint_setER13address_spaceijjPKcS3_","__ZN13resource_pool10add_objectIN12device_debug10watchpointEEEPT_S4_","__ZNK12device_debug10watchpoint4nextEv","__ZNK12device_debug10history_pcEi","__ZN12device_debug17watchpoint_enableEib","__ZN12device_debug21watchpoint_enable_allEb","__ZNK12device_debug20compute_opcode_crc32Ej","__ZN12device_debug13hotspot_trackEii","__ZN13resource_pool9add_arrayIN12device_debug13hotspot_entryEEEPT_S4_i","__ZN12device_debug11comment_addEjPKcj","__ZNK11simple_listIN12device_debug12dasm_commentEE5firstEv","__ZNK12device_debug12dasm_comment4nextEv","__ZN11simple_listIN12device_debug12dasm_commentEE7prependERS1_","__ZN11simple_listIN12device_debug12dasm_commentEE6appendERS1_","__ZNK13address_space11logaddrmaskEv","__ZN11simple_listIN12device_debug12dasm_commentEE6removeERS1_","__ZN12device_debug14comment_removeEj","__ZNK12device_debug12comment_textEj","__ZNK23device_disasm_interface16max_opcode_bytesEv","__ZNK13address_space15address_to_byteEj","__ZN12device_debug12trace_printfEPKcz","__ZN12device_debug6tracer7vprintfEPKcPc","__ZNK15running_machine20save_or_load_pendingEv","__ZN12device_debug12dasm_wrappedER7astringj","__ZN12device_debug10breakpoint3hitEj","__ZN13resource_pool10add_objectIN12device_debug12dasm_commentEEEPT_S4_","__ZN12device_debug5traceEP7__sFILEbPKc","__ZN13resource_pool10add_objectIN12device_debug6tracerEEEPT_S4_","__ZNK13address_space4nameEv","__ZNK12symbol_table9globalrefEv","__ZNK13address_space9log_unmapEv","__ZN13address_space13set_log_unmapEb","__ZN11simple_listIN12device_debug12dasm_commentEE6detachERS1_","__ZN12device_debug10watchpoint3hitEiji","__ZN22device_state_interface2pcEv","__ZNK13address_space15byte_to_addressEj","__ZNK12device_debug16max_opcode_bytesEv","__ZN7astring6expandEi","__ZN17parsed_expressionD1Ev","__ZNK17parsed_expression8is_emptyEv","__ZN17parsed_expression7executeEv","__ZN12device_debug6tracerC2ERS_R7__sFILEbPKc","__ZNK12device_debug12logaddrcharsE16address_spacenum","__ZN12device_debug6tracer5flushEv","__ZN12device_debug12dasm_commentC2EPKcjjj","__ZN20resource_pool_objectIN12device_debug6tracerEEC1EPS1_","__ZN20resource_pool_objectIN12device_debug6tracerEEC2EPS1_","__ZN20resource_pool_objectIN12device_debug6tracerEED1Ev","__ZN20resource_pool_objectIN12device_debug12dasm_commentEEC1EPS1_","__ZN20resource_pool_objectIN12device_debug12dasm_commentEEC2EPS1_","__ZN12device_debug10breakpointC2ER12symbol_tableijPKcS4_","__ZN12device_debug10watchpointC2ER12symbol_tableiR13address_spaceijjPKcS6_","__ZN12device_debug6tracerD2Ev","__ZN20resource_pool_objectIN12device_debug6tracerEED0Ev","__ZN20resource_pool_objectIN12device_debug6tracerEED2Ev","__ZN20resource_pool_objectIN12device_debug12dasm_commentEED1Ev","__ZN12device_debug12dasm_commentD1Ev","__ZN12device_debug12dasm_commentD2Ev","__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEEC1EPS1_i","__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEEC2EPS1_i","__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED1Ev","__ZN20resource_pool_objectIN12device_debug10watchpointEEC1EPS1_","__ZN20resource_pool_objectIN12device_debug10watchpointEEC2EPS1_","__ZN20resource_pool_objectIN12device_debug10watchpointEED1Ev","__ZN12device_debug10watchpointD1Ev","__ZN20resource_pool_objectIN12device_debug10breakpointEEC1EPS1_","__ZN20resource_pool_objectIN12device_debug10breakpointEEC2EPS1_","__ZN20resource_pool_objectIN12device_debug10breakpointEED1Ev","__ZN20resource_pool_objectIN12device_debug12dasm_commentEED0Ev","__ZN20resource_pool_objectIN12device_debug12dasm_commentEED2Ev","__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED0Ev","__ZN19resource_pool_arrayIN12device_debug13hotspot_entryEED2Ev","__ZN20resource_pool_objectIN12device_debug10watchpointEED0Ev","__ZN20resource_pool_objectIN12device_debug10watchpointEED2Ev","__ZN12device_debug10watchpointD2Ev","__ZN20resource_pool_objectIN12device_debug10breakpointEED0Ev","__ZN11simple_listIN12device_debug12dasm_commentEEC2ER13resource_pool","__ZNK13address_space12logaddrcharsEv","__ZNK11simple_listIN17parsed_expression11parse_tokenEE5countEv","__ZN12device_debug10breakpointD1Ev","__ZN11simple_listIN12device_debug12dasm_commentEED2Ev","__ZN11simple_listIN12device_debug12dasm_commentEE5resetEv","__ZN8delegateIFvR13screen_devicebEEC2I15running_machineEEN15delegate_traitsIT_vS1_b8_noparamS8_E20static_ref_func_typeEPKcPS7_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I15running_machineEEN15delegate_traitsIT_vS1_bS2_S2_E20static_ref_func_typeEPKcPS7_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI15running_machineEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E4bindEP22delegate_generic_class","__ZN20resource_pool_objectI12symbol_tableEC1EPS0_","__ZN20resource_pool_objectI12symbol_tableEC2EPS0_","__ZN20resource_pool_objectI12symbol_tableED1Ev","__ZN20resource_pool_objectI17_debugcpu_privateEC1EPS0_","__ZN20resource_pool_objectI17_debugcpu_privateEC2EPS0_","__ZN20resource_pool_objectI17_debugcpu_privateED1Ev","__ZN20resource_pool_objectIN12device_debug10breakpointEED2Ev","__ZN12device_debug10breakpointD2Ev","__ZN11simple_listIN12device_debug12dasm_commentEED0Ev","__ZN20resource_pool_objectI12symbol_tableED0Ev","__ZN20resource_pool_objectI12symbol_tableED2Ev","__ZN20resource_pool_objectI17_debugcpu_privateED0Ev","__ZN20resource_pool_objectI17_debugcpu_privateED2Ev","__ZN11simple_listIN17parsed_expression11parse_tokenEE6detachERS1_","__ZN11simple_listIN17parsed_expression17expression_stringEE6detachERS1_","__ZNK20address_space_config9byte2addrEj","__ZNK7astringcvbEv","__ZN12device_debug20reset_transient_flagEv","__ZN11simple_listI12symbol_entryE6detachERS0_","__ZN11simple_listIN17parsed_expression17expression_stringEED1Ev","__ZN11simple_listIN17parsed_expression11parse_tokenEED1Ev","__ZN11simple_listIN17parsed_expression11parse_tokenEED2Ev","__ZN11simple_listIN17parsed_expression11parse_tokenEE5resetEv","__ZN11simple_listIN17parsed_expression11parse_tokenEE6removeERS1_","__ZN11simple_listIN17parsed_expression17expression_stringEED2Ev","__ZN11simple_listIN17parsed_expression17expression_stringEE5resetEv","__ZN11simple_listIN17parsed_expression17expression_stringEE6removeERS1_","__ZN12symbol_tableD2Ev","__ZN11tagged_listI12symbol_entryED1Ev","__ZN8tagmap_tIP12symbol_entryED1Ev","__ZN11simple_listI12symbol_entryED1Ev","__ZN11simple_listI12symbol_entryED2Ev","__ZN11simple_listI12symbol_entryE5resetEv","__ZN11simple_listI12symbol_entryE6removeERS0_","__ZN8tagmap_tIP12symbol_entryED2Ev","__ZN8tagmap_tIP12symbol_entryE5resetEv","__ZNK11tagged_listI12symbol_entryE4findEPKc","__ZNK8tagmap_tIP12symbol_entryE14find_hash_onlyEPKc","__ZN17parsed_expressionD2Ev","__ZN11simple_listIN17parsed_expression11parse_tokenEED0Ev","__ZN11simple_listIN17parsed_expression17expression_stringEED0Ev","__ZN11tagged_listI12symbol_entryED2Ev","__ZN11simple_listI12symbol_entryED0Ev","__ZL11tagmap_hashPKc2554","__ZNK11simple_listI18device_state_entryE5firstEv","__ZNK13screen_device12frame_numberEv","__ZNK23device_memory_interface5spaceEi","__ZNK13memory_region10endiannessEv","__ZNK13memory_region5widthEv","__ZL21tagmap_find_hash_onlyPK7_tagmapPKc2553","__ZNK11device_list5firstI24device_execute_interfaceEEbRPT_","__ZNK16device_interface4nextI24device_execute_interfaceEEbRPT_","__ZNK8device_t4nextI24device_execute_interfaceEEbRPT_","__ZL21expression_get_deviceR15running_machinePKc","__ZL31expression_write_program_directP13address_spaceijiy","__ZL30expression_write_memory_regionR15running_machinePKcjiy","__ZN16direct_read_data18read_decrypted_ptrEjj","__ZL30expression_read_program_directP13address_spaceiji","__ZNK20address_space_config10data_widthEv","__ZNK20address_space_config10endiannessEv","__ZNK11simple_listIN12device_debug12dasm_commentEE5countEv","__ZNK11simple_listIN12save_manager11state_entryEE4findEi","__ZNK11simple_listIN12save_manager14state_callbackEE5firstEv","__ZNK13delegate_baseIv8_noparamS0_S0_S0_E4nameEv","__ZNK12save_manager14state_callback4nextEv","__ZN11simple_listIN12save_manager14state_callbackEE6appendERS1_","__ZNK12save_manager7machineEv","__ZL29expression_read_memory_regionR15running_machinePKcji","__ZN11simple_listIN12save_manager11state_entryEEC1ER13resource_pool","__ZN11simple_listIN12save_manager14state_callbackEEC1ER13resource_pool","__ZN11simple_listIN12save_manager14state_callbackEED1Ev","__ZN11simple_listIN12save_manager11state_entryEED1Ev","__ZN12save_manager18allow_registrationEb","__ZNK12save_manager13dump_registryEv","__ZNK12save_manager12indexed_itemEiRPvRjS2_","__ZNK13delegate_baseIv8_noparamS0_S0_S0_EeqERKS1_","__ZN8delegateIFvvEEC1ERKS1_","__ZN12save_managerC2ER15running_machine","__ZN12save_manager16register_presaveE8delegateIFvvEE","__ZN13resource_pool10add_objectIN12save_manager14state_callbackEEEPT_S4_","__ZNK11simple_listIN12save_manager11state_entryEE5firstEv","__ZNK12save_manager11state_entry4nextEv","__ZNK7astringgtERKS_","__ZNK7astringeqERKS_","__ZN11simple_listIN12save_manager11state_entryEE12insert_afterERS1_PS1_","__ZNK12save_manager9signatureEv","__ZN12save_manager15validate_headerEPKhPKcjPFvS3_zES3_","__ZN12save_manager17register_postloadE8delegateIFvvEE","__ZN12save_manager11save_memoryEPKcS1_jS1_Pvjj","__ZN13resource_pool10add_objectIN12save_manager11state_entryEEEPT_S4_","__ZN12save_manager11state_entry9flip_dataEv","__ZN11simple_listIN12save_manager11state_entryEE7prependERS1_","__ZN12save_manager9read_fileER8emu_file","__ZNK13delegate_baseIv8_noparamS0_S0_S0_EclEv","__ZN12save_manager10write_fileER8emu_file","__ZN12save_manager14state_callbackC2E8delegateIFvvEE","__ZN12save_manager11state_entryC2EPvPKchj","__ZN20resource_pool_objectIN12save_manager11state_entryEEC1EPS1_","__ZN20resource_pool_objectIN12save_manager11state_entryEEC2EPS1_","__ZN20resource_pool_objectIN12save_manager11state_entryEED1Ev","__ZN12save_manager11state_entryD1Ev","__ZN12save_manager11state_entryD2Ev","__ZN20resource_pool_objectIN12save_manager14state_callbackEEC1EPS1_","__ZN20resource_pool_objectIN12save_manager14state_callbackEEC2EPS1_","__ZN20resource_pool_objectIN12save_manager14state_callbackEED1Ev","__ZN20resource_pool_objectIN12save_manager11state_entryEED0Ev","__ZN20resource_pool_objectIN12save_manager11state_entryEED2Ev","__ZNK21delegate_internal_mfpeqERKS_","__ZN11simple_listIN12save_manager14state_callbackEE6detachERS1_","__ZN11simple_listIN12save_manager11state_entryEE6detachERS1_","__ZN11simple_listIN12save_manager14state_callbackEEC2ER13resource_pool","__ZN11simple_listIN12save_manager11state_entryEEC2ER13resource_pool","__ZN11simple_listIN12save_manager14state_callbackEED2Ev","__ZN11simple_listIN12save_manager14state_callbackEE5resetEv","__ZN11simple_listIN12save_manager14state_callbackEE6removeERS1_","__ZN11simple_listIN12save_manager11state_entryEED2Ev","__ZN11simple_listIN12save_manager11state_entryEE5resetEv","__ZN11simple_listIN12save_manager11state_entryEE6removeERS1_","__ZN8delegateIFvvEEC2ERKS1_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2ERKS1_","__ZN20resource_pool_objectIN12save_manager14state_callbackEED0Ev","__ZN20resource_pool_objectIN12save_manager14state_callbackEED2Ev","__ZN11simple_listIN12save_manager14state_callbackEED0Ev","__ZN11simple_listIN12save_manager11state_entryEED0Ev","__ZNK14machine_config7gamedrvEv","__ZNK16device_scheduler19currently_executingEv","__ZN11tagged_listI17input_port_configEC1ER13resource_pool","__ZN11tagged_listI13memory_regionEC1ER13resource_pool","__ZNK11emu_options11sample_rateEv","__ZN11simple_listIN15running_machine22notifier_callback_itemEEC1ER13resource_pool","__ZN11simple_listIN15running_machine22notifier_callback_itemEED1Ev","__ZN11simple_listIN15running_machine22logerror_callback_itemEEC1ER13resource_pool","__ZN15running_machine6deviceI13driver_deviceEEPT_PKc","__ZNK11emu_options5debugEv","__ZNK11emu_options14debug_internalEv","__ZN11simple_listIN15running_machine22logerror_callback_itemEED1Ev","__ZN12save_managerD1Ev","__ZN11tagged_listI13memory_regionED1Ev","__ZN11tagged_listI17input_port_configED1Ev","__ZN15running_machine16describe_contextEv","__ZN15running_machineC2ERK14machine_configR13osd_interfaceb","__ZN15running_machineD2Ev","__ZN15running_machine5startEv","__ZN13resource_pool10add_objectI13input_managerEEPT_S3_","__ZN8delegateIFvPviEEC1I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_","__ZN15running_machine10soft_resetEPvi","__ZNK11emu_options5stateEv","__ZN15running_machine13schedule_loadEPKc","__ZNK11emu_options8autosaveEv","__ZN13resource_pool10add_objectI14render_managerEEPT_S3_","__ZN13resource_pool10add_objectI13video_managerEEPT_S3_","__ZN13resource_pool10add_objectI13sound_managerEEPT_S3_","__ZN13resource_pool10add_objectI13cheat_managerEEPT_S3_","__ZN15running_machine18add_dynamic_deviceER8device_tPFPS0_RK14machine_configPKcS2_jES7_j","__ZNK11emu_options3logEv","__ZN15running_machine16logfile_callbackERS_PKc","__ZN13sound_manager7ui_muteEb","__ZN15running_machine3runEb","__ZN15running_machine21add_logerror_callbackEPFvRS_PKcE","__ZNK14render_manager12ui_containerEv","__ZN15running_machine14call_notifiersE20machine_notification","__ZN15running_machine13schedule_exitEv","__ZN15running_machine13schedule_saveEPKc","__ZN15running_machine19schedule_hard_resetEv","__ZN15running_machine19schedule_soft_resetEv","__ZN15running_machine6resumeEv","__ZN15running_machine19schedule_new_driverERK11game_driver","__ZN15running_machine21set_saveload_filenameEPKc","__ZNK11emu_options15state_directoryEv","__ZN15running_machine5pauseEv","__ZN15running_machine11region_freeEPKc","__ZN11tagged_listI13memory_regionE6removeEPKc","__ZN15running_machine15handle_saveloadEv","__ZN15running_machine12region_allocEPKcjh12endianness_t","__ZN11tagged_listI13memory_regionE6appendEPKcRS0_","__ZN13resource_pool10add_objectI13memory_regionEEPT_S3_","__ZN11simple_listIN15running_machine22notifier_callback_itemEE7prependERS1_","__ZN11simple_listIN15running_machine22notifier_callback_itemEE6appendERS1_","__ZN11simple_listIN15running_machine22logerror_callback_itemEE6appendERS1_","__ZNK11simple_listIN15running_machine22logerror_callback_itemEE5firstEv","__ZNK15running_machine22logerror_callback_item4nextEv","__ZN15running_machine4randEv","__ZNK11simple_listIN15running_machine22notifier_callback_itemEE5firstEv","__ZNK15running_machine22notifier_callback_item4nextEv","__ZN8emu_file15remove_on_closeEv","__ZN15running_machine8logerrorEPKcz","__ZN15running_machine9vlogerrorEPKcPc","__ZN15running_machine13base_datetimeER11system_time","__ZN11system_time3setEl","__ZN15running_machine12add_notifierE20machine_notification8delegateIFvvEE","__ZN13resource_pool10add_objectIN15running_machine22notifier_callback_itemEEEPT_S4_","__ZN13resource_pool10add_objectIN15running_machine22logerror_callback_itemEEEPT_S4_","__ZN13driver_device12driver_startEv","__ZN13driver_device12driver_resetEv","__ZN13driver_device13screen_updateER13screen_deviceR8bitmap_tRK10_rectangle","__ZN13driver_device10screen_eofEv","__Z8downcastIR13driver_device8device_tET_RT0_","__ZNK13memory_region7machineEv","__ZN15running_machine22logerror_callback_itemC2EPFvRS_PKcE","__ZNK13driver_device17device_rom_regionEv","__ZNK13driver_device18device_input_portsEv","__ZN11system_time9full_time3setER2tm","__ZN15running_machine22notifier_callback_itemC2E8delegateIFvvEE","__ZN13driver_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_","__ZN13driver_deviceD2Ev","__ZN13driver_device15static_set_gameER8device_tRK11game_driver","__ZN11driver_list5cloneERK11game_driver","__ZN13driver_device19static_set_callbackER8device_tNS_13callback_typeEPFvR15running_machineE","__ZN13driver_device23static_set_palette_initER8device_tPFvR15running_machinePKhE","__ZN13driver_device13machine_startEv","__ZN13driver_device11sound_startEv","__ZN13driver_device11video_startEv","__ZN13driver_device13machine_resetEv","__ZN13driver_device11sound_resetEv","__ZN13driver_device11video_resetEv","__ZN27device_missing_dependenciesC1Ev","__ZN27device_missing_dependenciesD1Ev","__ZN13driver_device12device_resetEv","__ZN11system_timeC2Ev","__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEEC1EPS1_","__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEEC2EPS1_","__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED1Ev","__ZN13memory_regionC2ER15running_machinePKcjh12endianness_t","__ZN13memory_regionD2Ev","__ZN13driver_deviceD0Ev","__ZN13driver_device12device_startEv","__ZN11simple_listI13memory_regionE6detachERS0_","__ZN11simple_listI13memory_regionE6appendERS0_","__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEEC1EPS1_","__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEEC2EPS1_","__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED1Ev","__ZN11tagged_listI13memory_regionE6removeERS0_","__ZN8tagmap_tIP13memory_regionE6removeES1_","__ZN11simple_listI13memory_regionE6removeERS0_","__ZN20resource_pool_objectI13memory_regionEC1EPS0_","__ZN20resource_pool_objectI13memory_regionEC2EPS0_","__ZN20resource_pool_objectI13memory_regionED1Ev","__ZN8tagmap_tIP13memory_regionE15add_unique_hashEPKcS1_b","__ZN20resource_pool_objectI13cheat_managerEC1EPS0_","__ZN20resource_pool_objectI13cheat_managerEC2EPS0_","__ZN20resource_pool_objectI13cheat_managerED1Ev","__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED0Ev","__ZN20resource_pool_objectIN15running_machine22logerror_callback_itemEED2Ev","__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED0Ev","__ZN20resource_pool_objectIN15running_machine22notifier_callback_itemEED2Ev","__ZN20resource_pool_objectI13memory_regionED0Ev","__ZN20resource_pool_objectI13memory_regionED2Ev","__ZN20resource_pool_objectI13cheat_managerED0Ev","__ZN11simple_listI11cheat_entryE6detachERS0_","__ZN13cheat_managerD1Ev","__ZN11simple_listI11cheat_entryED1Ev","__ZN11simple_listI11cheat_entryED2Ev","__ZN11simple_listI11cheat_entryE5resetEv","__ZN11simple_listI11cheat_entryE6removeERS0_","__ZN20resource_pool_objectI13sound_managerEC1EPS0_","__ZN20resource_pool_objectI13sound_managerEC2EPS0_","__ZN20resource_pool_objectI13sound_managerED1Ev","__ZN20resource_pool_objectI13video_managerEC1EPS0_","__ZN20resource_pool_objectI13video_managerEC2EPS0_","__ZN20resource_pool_objectI13video_managerED1Ev","__ZN20resource_pool_objectI13cheat_managerED2Ev","__ZN13cheat_managerD2Ev","__ZN11simple_listI11cheat_entryED0Ev","__ZN20resource_pool_objectI13sound_managerED0Ev","__ZN20resource_pool_objectI13sound_managerED2Ev","__ZN20resource_pool_objectI13video_managerED0Ev","__ZN20resource_pool_objectI13video_managerED2Ev","__ZN21delegate_internal_mfpC2IM15running_machineFvPviEEET_","__Z8downcastIP13driver_device8device_tET_PT0_","__ZN11simple_listIN15running_machine22logerror_callback_itemEE6detachERS1_","__ZN8delegateIFvPviEEC2I15running_machineEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_","__ZN13delegate_baseIvPvi8_noparamS1_EC2I15running_machineEEN15delegate_traitsIT_vS0_iS1_S1_E16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM15running_machineFvPviEEET_","__ZN20resource_pool_objectI14render_managerEC1EPS0_","__ZN20resource_pool_objectI14render_managerEC2EPS0_","__ZN20resource_pool_objectI14render_managerED1Ev","__ZN20resource_pool_objectI13input_managerEC1EPS0_","__ZN20resource_pool_objectI13input_managerEC2EPS0_","__ZN20resource_pool_objectI13input_managerED1Ev","__ZN11simple_listIN15running_machine22logerror_callback_itemEED2Ev","__ZN11simple_listIN15running_machine22logerror_callback_itemEE5resetEv","__ZN11simple_listIN15running_machine22logerror_callback_itemEE6removeERS1_","__ZN11simple_listIN15running_machine22notifier_callback_itemEED2Ev","__ZN11simple_listIN15running_machine22notifier_callback_itemEE5resetEv","__ZN11simple_listIN15running_machine22notifier_callback_itemEE6removeERS1_","__ZN20resource_pool_objectI14render_managerED0Ev","__ZN20resource_pool_objectI14render_managerED2Ev","__ZN20resource_pool_objectI13input_managerED0Ev","__ZN20resource_pool_objectI13input_managerED2Ev","__ZN11simple_listIN15running_machine22logerror_callback_itemEED0Ev","__ZN11simple_listIN15running_machine22notifier_callback_itemEED0Ev","__ZN11simple_listIN15running_machine22notifier_callback_itemEE6detachERS1_","__ZN11simple_listIN15running_machine22notifier_callback_itemEEC2ER13resource_pool","__ZN11simple_listI17input_port_configE6detachERS0_","__ZN11simple_listI17input_port_configEC2ER13resource_pool","__ZN11simple_listIN15running_machine22logerror_callback_itemEEC2ER13resource_pool","__ZN11simple_listI13memory_regionEC2ER13resource_pool","__ZN11simple_listI17input_port_configEC1ER13resource_pool","__ZN8tagmap_tIP17input_port_configEC1Ev","__ZN11simple_listI17input_port_configED1Ev","__ZN11simple_listI17input_port_configED2Ev","__ZN11simple_listI17input_port_configE5resetEv","__ZN11simple_listI17input_port_configE6removeERS0_","__ZN8tagmap_tIP17input_port_configEC2Ev","__ZN11simple_listI13memory_regionEC1ER13resource_pool","__ZN8tagmap_tIP13memory_regionEC1Ev","__ZN11simple_listI13memory_regionED1Ev","__ZN11simple_listI13memory_regionED2Ev","__ZN11simple_listI13memory_regionE5resetEv","__ZN8tagmap_tIP13memory_regionEC2Ev","__ZN27device_missing_dependenciesD2Ev","__ZN27device_missing_dependenciesC2Ev","__ZN8tagmap_tIP17input_port_configED1Ev","__ZN8tagmap_tIP17input_port_configED2Ev","__ZN8tagmap_tIP17input_port_configE5resetEv","__ZN8tagmap_tIP13memory_regionED1Ev","__ZN8tagmap_tIP13memory_regionED2Ev","__ZN8tagmap_tIP13memory_regionE5resetEv","__ZNK12core_options9int_valueEPKc","__ZN11tagged_listI17input_port_configEC2ER13resource_pool","__ZN11simple_listI17input_port_configED0Ev","__ZN11tagged_listI13memory_regionEC2ER13resource_pool","__ZN11simple_listI13memory_regionED0Ev","__ZN27device_missing_dependenciesD0Ev","__ZN11tagged_listI17input_port_configED2Ev","__ZN11tagged_listI13memory_regionED2Ev","__ZN12save_managerD2Ev","__ZN13osd_interfaceD2Ev","__ZN13osd_interface13init_debuggerEv","__ZN13osd_interface19update_audio_streamEPKsi","__ZN13osd_interface16set_mastervolumeEi","__ZN13osd_interface25customize_input_type_listER11simple_listI16input_type_entryE","__ZN13osd_interface9font_openEPKcRi","__ZN13osd_interface10font_closeEPv","__ZN13osd_interface15font_get_bitmapEPvjRiS1_S1_","__ZN13osd_interface15get_slider_listEv","__ZN13osd_interface6updateEb","__ZN13osd_interface17wait_for_debuggerER8device_tb","__ZN13osd_interfaceC2Ev","__ZN13osd_interface4initER15running_machine","__ZN11simple_listI16render_primitiveE6appendERS0_","__ZN14render_texture5resetER14render_managerPFvR8bitmap_tRKS2_RK10_rectanglePvES9_","__ZNK14render_manager7machineEv","__ZN16render_primitive5resetEv","__ZN11simple_listI16render_primitiveEC1ER13resource_pool","__ZN11simple_listIN21render_primitive_list9referenceEEC1ER13resource_pool","__ZN15fixed_allocatorI16render_primitiveEC1ER13resource_pool","__ZN15fixed_allocatorIN21render_primitive_list9referenceEEC1ER13resource_pool","__ZN15fixed_allocatorIN21render_primitive_list9referenceEED1Ev","__ZN15fixed_allocatorI16render_primitiveED1Ev","__ZN11simple_listIN21render_primitive_list9referenceEED1Ev","__ZN11simple_listI16render_primitiveED1Ev","__ZN21render_primitive_list11release_allEv","__ZN15fixed_allocatorI16render_primitiveE11reclaim_allER11simple_listIS0_E","__ZN15fixed_allocatorIN21render_primitive_list9referenceEE11reclaim_allER11simple_listIS1_E","__ZN21render_primitive_list16append_or_returnER16render_primitiveb","__ZN15fixed_allocatorI16render_primitiveE7reclaimERS0_","__ZN14render_textureC2Ev","__ZN14render_textureD2Ev","__ZN14render_texture7releaseEv","__ZN14render_manager14invalidate_allEPv","__ZN13osd_interfaceD0Ev","__ZN21render_primitive_listC2Ev","__ZN21render_primitive_listD2Ev","__ZN14render_texture10set_bitmapEP8bitmap_tPK10_rectangleiP10_palette_t","__ZN14render_texture8hq_scaleER8bitmap_tRKS0_RK10_rectanglePv","__ZN21render_primitive_list13add_referenceEPv","__ZNK21render_primitive_list13has_referenceEPv","__ZN14render_texture10get_scaledEjjR14render_texinfoR21render_primitive_list","__ZNK16render_container37has_brightness_contrast_gamma_changesEv","__ZN16render_container16bcg_lookup_tableEiP10_palette_t","__ZN14render_texture20get_adjusted_paletteER16render_container","__ZN16render_container13overlay_scaleER8bitmap_tRKS0_RK10_rectanglePv","__ZN16render_container31apply_brightness_contrast_gammaEh","__ZN11simple_listIN16render_container4itemEEC1ER13resource_pool","__ZN15fixed_allocatorIN16render_container4itemEEC1ER13resource_pool","__ZN16render_container5emptyEv","__ZNK11emu_options10brightnessEv","__ZNK11emu_options8contrastEv","__ZNK11emu_options5gammaEv","__ZN16render_container17recompute_lookupsEv","__ZN15fixed_allocatorIN16render_container4itemEED1Ev","__ZN11simple_listIN16render_container4itemEED1Ev","__ZN14render_manager12texture_freeEP14render_texture","__ZN16render_container11set_overlayEP8bitmap_t","__ZN14render_manager13texture_allocEPFvR8bitmap_tRKS0_RK10_rectanglePvES7_","__ZN16render_container17set_user_settingsERKNS_13user_settingsE","__ZN16render_container8add_lineEfffffjj","__ZN13resource_pool9add_arrayIjEEPT_S2_i","__ZN16render_containerC2ER14render_managerP13screen_device","__ZN16render_containerD2Ev","__ZL7pal5bith","__ZN11simple_listIN16render_container4itemEE6appendERS1_","__ZN16render_container13user_settingsC2Ev","__ZN16render_container11add_genericEhffffj","__ZN16render_container8add_quadEffffjP14render_texturej","__ZN16render_container8add_charEffffjR11render_fontt","__ZL31apply_brightness_contrast_gammahfff","__ZN16render_container34apply_brightness_contrast_gamma_fpEf","__ZL34apply_brightness_contrast_gamma_fpffff","__ZN16render_container14update_paletteEv","__ZN15fixed_allocatorIN16render_container4itemEE5allocEv","__ZN19render_layer_config21set_backdrops_enabledEb","__ZN19render_layer_config20set_overlays_enabledEb","__ZN19render_layer_config18set_bezels_enabledEb","__ZN19render_layer_config19set_cpanels_enabledEb","__ZN19render_layer_config20set_marquees_enabledEb","__ZN11simple_listI11layout_fileEC1ER13resource_pool","__ZN19render_layer_configC1Ev","__ZN11simple_listI16render_containerEC1ER13resource_pool","__ZNK11emu_options13use_backdropsEv","__ZNK11emu_options12use_overlaysEv","__ZNK11emu_options10use_bezelsEv","__ZNK11emu_options11use_cpanelsEv","__ZNK11emu_options12use_marqueesEv","__ZN13render_targetC2ER14render_managerPKcj","__ZN13resource_pool10add_objectI11simple_listI11layout_fileEEEPT_S5_","__ZN19render_layer_config18set_zoom_to_screenEb","__ZNK13render_target6hiddenEv","__ZN14render_manager13set_ui_targetER13render_target","__ZNK14render_manager9ui_targetEv","__ZNK11simple_listI13render_targetE7indexofERKS0_","__ZN13render_target10set_boundsEiif","__ZNK11emu_options12artwork_cropEv","__ZNK11emu_options6rotateEv","__ZL19orientation_reversei","__ZNK11emu_options3rorEv","__ZNK11emu_options8auto_rorEv","__ZL15orientation_addii","__ZNK11emu_options3rolEv","__ZNK11emu_options8auto_rolEv","__ZNK11emu_options5flipxEv","__ZNK11emu_options5flipyEv","__ZN13render_target8set_viewEi","__ZN11simple_listI16render_containerED1Ev","__ZNK13render_target12is_ui_targetEv","__ZNK13render_target5indexEv","__ZNK13render_target13view_by_indexEi","__ZN13render_target17load_layout_filesEPKcb","__ZN13render_targetD2Ev","__ZNK11layout_view7screensEv","__ZN11layout_view4item6screenEv","__ZNK13screen_device11screen_typeEv","__ZNK13screen_device12visible_areaEv","__ZNK11layout_view4item6boundsEv","__ZN13render_target15configured_viewEPKcii","__ZNK11layout_view4nameEv","__ZNK13screen_device11next_screenEv","__ZNK18render_screen_list5countEv","__ZNK18render_screen_list8containsER13screen_device","__ZNK13render_target10view_indexER11layout_view","__ZN13render_target9view_nameEi","__ZN13render_target12view_screensEi","__ZN13render_target20compute_visible_areaEiifiRiS0_","__ZNK11layout_view16effective_aspectE19render_layer_config","__ZL20render_round_nearestf","__ZNK11tagged_listI8device_tE5countEv","__ZN13render_target20compute_minimum_sizeERiS0_","__ZppR10item_layeri","__Z17apply_orientationR13render_boundsi","__Z16normalize_boundsR13render_bounds","__ZNK13screen_device9containerEv","__ZNK16render_container11orientationEv","__ZNK11layout_view4item4nextEv","__ZNK11layout_view13layer_enabledE10item_layer","__ZNK11layout_view4item5colorEv","__ZNK11layout_view4item11orientationEv","__ZN13render_target14get_primitivesEv","__Z23get_layer_and_blendmodeRK11layout_viewiRi","__ZN13render_target24add_container_primitivesER21render_primitive_listRK16object_transformR16render_containeri","__ZNK11layout_view4item7elementEv","__ZL20set_render_bounds_xyP13render_boundsffff","__ZL16set_render_colorP12render_colorffff","__ZNK11simple_listI16render_containerE5firstEv","__ZNK16render_container4nextEv","__ZN11simple_listI16render_containerE6appendERS0_","__ZN13render_target22add_element_primitivesER21render_primitive_listRK16object_transformR14layout_elementii","__ZN21render_primitive_list5allocEN16render_primitive14primitive_typeE","__ZN21render_primitive_list6appendER16render_primitive","__ZN13render_target19map_point_containerEiiR16render_containerRfS2_","__ZN13render_target18map_point_internalEiiP16render_containerRfS2_RPKcRj","__ZN13render_target15map_point_inputEiiRPKcRjRfS4_","__ZN13render_target14invalidate_allEPv","__ZN13render_target11debug_allocEv","__ZN13render_target37add_clear_and_optimize_primitive_listER21render_primitive_list","__ZN11simple_listI16render_containerE7prependERS0_","__ZN11simple_listI16render_containerE6detachERS0_","__ZNK11simple_listI11layout_fileE5countEv","__ZNK13render_target7managerEv","__ZN11simple_listI11layout_fileE6appendERS0_","__ZN13render_target10debug_freeER16render_container","__ZN11simple_listI16render_containerE6removeERS0_","__ZN13render_target9debug_topER16render_container","__ZN13render_target19update_layer_configEv","__ZN7astringC1EPKcS1_","__ZNK11emu_options8art_pathEv","__ZN14render_manager15container_allocEP13screen_device","__ZN13render_target16load_layout_fileEPKcS1_","__ZL18sect_render_boundsP13render_boundsPKS_","__ZNK16render_container6yscaleEv","__ZNK16render_container6xscaleEv","__ZNK16render_container7yoffsetEv","__ZNK16render_container7xoffsetEv","__ZNK16render_container4item6boundsEv","__ZNK16render_container4item8internalEv","__ZNK16render_container4item5colorEv","__ZNK16render_container4item4typeEv","__ZNK16render_container4item5widthEv","__ZNK16render_container4item5flagsEv","__ZNK16render_container4item7textureEv","__ZNK14render_texture6formatEv","__ZNK16render_container4item4nextEv","__ZNK16render_container7overlayEv","__ZNK19render_layer_config22screen_overlay_enabledEv","__ZL20set_render_bounds_whP13render_boundsffff","__ZNK14layout_element8maxstateEv","__ZNK11simple_listI11layout_fileE5firstEv","__ZNK11layout_view4nextEv","__ZNK11layout_file4nextEv","__ZN13render_target15set_orientationEi","__ZNK13render_target11orientationEv","__ZNK16render_container10first_itemEv","__ZNK11layout_view4item9has_inputEv","__ZNK11layout_view4item18input_tag_and_maskERj","__ZNK11layout_file10first_viewEv","__ZNK11layout_view7has_artEv","__ZN13render_target11config_loadER14_xml_data_node","__ZN13render_target21set_backdrops_enabledEb","__ZN13render_target20set_overlays_enabledEb","__ZN13render_target18set_bezels_enabledEb","__ZN13render_target19set_cpanels_enabledEb","__ZN13render_target20set_marquees_enabledEb","__ZN13render_target18set_zoom_to_screenEb","__ZNK16render_container17get_user_settingsERNS_13user_settingsE","__ZN13resource_pool10add_objectI11layout_fileEEPT_S3_","__ZNK19render_layer_configneERKS_","__ZNK19render_layer_config17backdrops_enabledEv","__ZNK19render_layer_config16overlays_enabledEv","__ZNK19render_layer_config14bezels_enabledEv","__ZNK19render_layer_config15cpanels_enabledEv","__ZNK19render_layer_config16marquees_enabledEv","__ZNK19render_layer_config14zoom_to_screenEv","__ZN13render_target18init_clear_extentsEv","__ZN13render_target11config_saveER14_xml_data_node","__ZN13render_target19remove_clear_extentERK13render_bounds","__ZN13render_target17add_clear_extentsER21render_primitive_list","__ZNK16render_primitive4nextEv","__ZN11simple_listI16render_primitiveE12prepend_listERS1_","__ZNK21render_primitive_list5firstEv","__ZN11simple_listI13render_targetEC1ER13resource_pool","__ZN15fixed_allocatorI14render_textureEC1ER13resource_pool","__ZN8delegateIFviP14_xml_data_nodeEEC1I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_","__ZN14render_manager11config_loadEiP14_xml_data_node","__ZN14render_managerC2ER15running_machine","__ZN13resource_pool10add_objectI16render_containerEEPT_S3_","__ZN13screen_device13set_containerER16render_container","__ZNK11simple_listI13render_targetE5firstEv","__ZNK13render_target4nextEv","__ZNK13render_target15max_update_rateEv","__ZN11simple_listI13render_targetE6appendERS0_","__ZN14render_manager11config_saveEiP14_xml_data_node","__ZN15fixed_allocatorI14render_textureED1Ev","__ZN11simple_listI13render_targetED1Ev","__ZN14render_manager14container_freeEP16render_container","__ZN11simple_listI16render_containerE5resetEv","__ZNK14render_manager7is_liveER13screen_device","__ZNK13render_target4viewEv","__ZNK14render_manager15max_update_rateEv","__ZN14render_manager11target_freeEP13render_target","__ZN11simple_listI13render_targetE6removeERS0_","__ZN14render_managerD2Ev","__ZN14render_manager12target_allocEPKcj","__ZN13resource_pool10add_objectI13render_targetEEPT_S3_","__ZNK13render_target6heightEv","__ZNK13render_target5widthEv","__ZNK13render_target12pixel_aspectEv","__ZNK11simple_listI16render_containerE4findEi","__ZN11simple_listI14render_textureE6appendERS0_","__ZN11simple_listI14render_textureE11detach_headEv","__ZNK11simple_listI14render_textureE4poolEv","__ZNK14render_manager15target_by_indexEi","__ZN14render_manager9ui_aspectEv","__ZN15fixed_allocatorI14render_textureE7reclaimEPS0_","__ZN14render_manager9font_freeEP11render_font","__ZN20resource_pool_objectI11render_fontEC1EPS0_","__ZN20resource_pool_objectI11render_fontEC2EPS0_","__ZN20resource_pool_objectI11render_fontED1Ev","__ZN15fixed_allocatorI14render_textureE5allocEv","__ZN14render_manager10font_allocEPKc","__ZN13resource_pool10add_objectI11render_fontEEPT_S3_","__ZN20resource_pool_objectI11render_fontED0Ev","__ZN20resource_pool_objectI11render_fontED2Ev","__ZN21delegate_internal_mfpC2IM14render_managerFviP14_xml_data_nodeEEET_","__ZN11simple_listI13render_targetE6detachERS0_","__ZN20resource_pool_objectI14render_textureEC1EPS0_","__ZN20resource_pool_objectI14render_textureEC2EPS0_","__ZN20resource_pool_objectI14render_textureED1Ev","__ZN20resource_pool_objectI13render_targetEC1EPS0_","__ZN20resource_pool_objectI13render_targetEC2EPS0_","__ZN20resource_pool_objectI13render_targetED1Ev","__ZN8delegateIFviP14_xml_data_nodeEEC2I14render_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I14render_managerEEN15delegate_traitsIT_viS1_S2_S2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM14render_managerFviP14_xml_data_nodeEEET_","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI14render_managerEEP22delegate_generic_classR18delegate_late_bind","__ZN11simple_listI13render_targetED2Ev","__ZN11simple_listI13render_targetE5resetEv","__ZN13resource_pool10add_objectI14render_textureEEPT_S3_","__ZN20resource_pool_objectI14render_textureED0Ev","__ZN20resource_pool_objectI14render_textureED2Ev","__ZN20resource_pool_objectI13render_targetED0Ev","__ZN20resource_pool_objectI13render_targetED2Ev","__ZN11simple_listI14render_textureEC2ER13resource_pool","__ZN11simple_listI14render_textureE6detachERS0_","__ZN11simple_listI13render_targetEC2ER13resource_pool","__ZNK11simple_listI16render_primitiveE5countEv","__ZNK11simple_listI16render_primitiveE4lastEv","__ZN11simple_listI16render_primitiveE10detach_allEv","__ZNK11simple_listI8device_tE5countEv","__ZN20resource_pool_objectI16render_containerEC1EPS0_","__ZN20resource_pool_objectI16render_containerEC2EPS0_","__ZN20resource_pool_objectI16render_containerED1Ev","__ZN15fixed_allocatorI14render_textureEC2ER13resource_pool","__ZN11simple_listI14render_textureEC1ER13resource_pool","__ZN11simple_listI14render_textureED1Ev","__ZN11simple_listI14render_textureED2Ev","__ZN11simple_listI14render_textureE5resetEv","__ZN11simple_listI14render_textureE6removeERS0_","__ZN20resource_pool_objectI11layout_fileEC1EPS0_","__ZN20resource_pool_objectI11layout_fileEC2EPS0_","__ZN20resource_pool_objectI11layout_fileED1Ev","__ZN11simple_listI16render_containerED2Ev","__ZN11simple_listI13render_targetED0Ev","__ZN20resource_pool_objectI16render_containerED0Ev","__ZN20resource_pool_objectI16render_containerED2Ev","__ZN11simple_listI14render_textureED0Ev","__ZN20resource_pool_objectI11layout_fileED0Ev","__ZN20resource_pool_objectI11layout_fileED2Ev","__ZN11simple_listI16render_containerEC2ER13resource_pool","__ZN11simple_listI11layout_fileEC2ER13resource_pool","__ZN11simple_listI11layout_fileE6detachERS0_","__ZN11simple_listIN16render_container4itemEE11detach_headEv","__ZNK11simple_listIN16render_container4itemEE4poolEv","__ZN20resource_pool_objectI11simple_listI11layout_fileEEC1EPS2_","__ZN20resource_pool_objectI11simple_listI11layout_fileEEC2EPS2_","__ZN20resource_pool_objectI11simple_listI11layout_fileEED1Ev","__ZN11simple_listI11layout_fileED1Ev","__ZN11simple_listI11layout_fileED2Ev","__ZN11simple_listI11layout_fileE5resetEv","__ZN11simple_listI11layout_fileE6removeERS0_","__ZN20resource_pool_objectIN16render_container4itemEEC1EPS1_","__ZN20resource_pool_objectIN16render_container4itemEEC2EPS1_","__ZN20resource_pool_objectIN16render_container4itemEED1Ev","__ZN11simple_listI16render_containerED0Ev","__ZN20resource_pool_objectI11simple_listI11layout_fileEED0Ev","__ZN20resource_pool_objectI11simple_listI11layout_fileEED2Ev","__ZN11simple_listI11layout_fileED0Ev","__ZN13resource_pool10add_objectIN16render_container4itemEEEPT_S4_","__ZN20resource_pool_objectIN16render_container4itemEED0Ev","__ZN20resource_pool_objectIN16render_container4itemEED2Ev","__ZN11simple_listIN16render_container4itemEE6detachERS1_","__ZN11simple_listIN16render_container4itemEEC2ER13resource_pool","__ZNK11simple_listIN21render_primitive_list9referenceEE5countEv","__ZNK11simple_listIN21render_primitive_list9referenceEE4lastEv","__ZN11simple_listIN21render_primitive_list9referenceEE10detach_allEv","__ZN11simple_listIN21render_primitive_list9referenceEE6detachERS1_","__ZN11simple_listIN16render_container4itemEED2Ev","__ZN11simple_listIN16render_container4itemEE5resetEv","__ZN11simple_listIN16render_container4itemEE6removeERS1_","__ZN15fixed_allocatorIN16render_container4itemEEC2ER13resource_pool","__ZN19resource_pool_arrayIjEC1EPji","__ZN19resource_pool_arrayIjEC2EPji","__ZN19resource_pool_arrayIjED1Ev","__ZN11simple_listIN21render_primitive_list9referenceEE11append_listERS2_","__ZN11simple_listI16render_primitiveE11append_listERS1_","__ZN11simple_listIN21render_primitive_list9referenceEED2Ev","__ZN11simple_listIN21render_primitive_list9referenceEE5resetEv","__ZN11simple_listIN21render_primitive_list9referenceEE6removeERS1_","__ZN11simple_listI16render_primitiveED2Ev","__ZN11simple_listI16render_primitiveE5resetEv","__ZN11simple_listIN16render_container4itemEED0Ev","__ZN19resource_pool_arrayIjED0Ev","__ZN19resource_pool_arrayIjED2Ev","__ZN11simple_listIN21render_primitive_list9referenceEED0Ev","__ZL22orientation_swap_flipsi","__ZN11simple_listI16render_primitiveE6detachERS0_","__ZN11simple_listIN21render_primitive_list9referenceEEC2ER13resource_pool","__ZN11simple_listI16render_primitiveEC2ER13resource_pool","__ZNK11simple_listI16render_primitiveE5firstEv","__ZNK11simple_listIN11layout_view4itemEE5countEv","__ZNK11simple_listI11layout_viewE5firstEv","__ZNK11simple_listIN16render_container4itemEE5firstEv","__ZN11simple_listI16render_primitiveE11detach_headEv","__ZNK11simple_listI16render_primitiveE4poolEv","__ZNK11simple_listIN18render_screen_list4itemEE5firstEv","__ZNK11simple_listIN18render_screen_list4itemEE5countEv","__ZN19render_layer_configC2Ev","__ZNK11simple_listIN16render_container4itemEE5countEv","__ZNK11simple_listIN16render_container4itemEE4lastEv","__ZN11simple_listIN16render_container4itemEE10detach_allEv","__ZNK11simple_listIN21render_primitive_list9referenceEE5firstEv","__ZNK21render_primitive_list9reference4nextEv","__ZN11simple_listI16render_primitiveE6removeERS0_","__ZN15fixed_allocatorIN21render_primitive_list9referenceEEC2ER13resource_pool","__ZN15fixed_allocatorI16render_primitiveEC2ER13resource_pool","__ZN15fixed_allocatorI14render_textureED2Ev","__ZN7astringC2EPKcS1_","__ZN20resource_pool_objectI16render_primitiveEC1EPS0_","__ZN20resource_pool_objectI16render_primitiveEC2EPS0_","__ZN20resource_pool_objectI16render_primitiveED1Ev","__ZN15fixed_allocatorIN16render_container4itemEED2Ev","__ZN15fixed_allocatorIN16render_container4itemEE11reclaim_allER11simple_listIS1_E","__ZN11simple_listIN16render_container4itemEE11append_listERS2_","__ZN11simple_listI16render_primitiveED0Ev","__ZN15fixed_allocatorI16render_primitiveE5allocEv","__ZN13resource_pool10add_objectI16render_primitiveEEPT_S3_","__ZN20resource_pool_objectI16render_primitiveED0Ev","__ZN20resource_pool_objectI16render_primitiveED2Ev","__ZN11simple_listIN21render_primitive_list9referenceEE6appendERS1_","__ZN11simple_listIN21render_primitive_list9referenceEE11detach_headEv","__ZNK11simple_listIN21render_primitive_list9referenceEE4poolEv","__ZN20resource_pool_objectIN21render_primitive_list9referenceEEC1EPS1_","__ZN20resource_pool_objectIN21render_primitive_list9referenceEEC2EPS1_","__ZN20resource_pool_objectIN21render_primitive_list9referenceEED1Ev","__ZN15fixed_allocatorI16render_primitiveED2Ev","__ZN15fixed_allocatorIN21render_primitive_list9referenceEED2Ev","___cxx_global_var_init2817","__ZN8attotime7from_hzEd","__ZN11simple_listIN13screen_device13callback_itemEEC1ER13resource_pool","__ZN15fixed_allocatorIN21render_primitive_list9referenceEE5allocEv","__ZN13resource_pool10add_objectIN21render_primitive_list9referenceEEEPT_S4_","__ZN20resource_pool_objectIN21render_primitive_list9referenceEED0Ev","__ZN20resource_pool_objectIN21render_primitive_list9referenceEED2Ev","__Z14device_creatorI13screen_deviceEP8device_tRK14machine_configPKcS2_j","__ZN13screen_deviceC2ERK14machine_configPKcP8device_tj","__ZN13screen_deviceD0Ev","__Z8downcastIR13screen_device8device_tET_RT0_","__ZN11simple_listIN13screen_device13callback_itemEED1Ev","__ZN13screen_device17static_set_formatER8device_t14_bitmap_format","__ZN13screen_device15static_set_typeER8device_t16screen_type_enum","__ZN13screen_device18static_set_refreshER8device_tx","__ZN13screen_device22static_set_vblank_timeER8device_tx","__ZN13screen_device15static_set_sizeER8device_ttt","__ZN13screen_device18static_set_visareaER8device_tssss","__ZN13screen_device24static_set_screen_updateER8device_tPFjPS_P8bitmap_tPK10_rectangleE","__ZNK13screen_device21device_validity_checkER11emu_optionsRK11game_driver","__ZN13screen_device28static_vblank_begin_callbackER15running_machinePvi","__ZN13screen_device26static_vblank_end_callbackER15running_machinePvi","__ZN13screen_device25static_scanline0_callbackER15running_machinePvi","__ZN13screen_device31static_scanline_update_callbackER15running_machinePvi","__ZN13screen_device9configureEiiRK10_rectanglex","__ZN13screen_deviceD2Ev","__ZN13screen_device12device_startEv","__ZNK13screen_device14time_until_posEii","__ZNK11emu_options6burninEv","__ZNK11emu_options9snap_sizeEv","__ZNK11emu_options6effectEv","__ZN8device_t9save_itemIiEEvRT_PKci","__ZN8device_t9save_itemIxEEvRT_PKci","__ZN8device_t9save_itemI8attotimeEEvRT_PKci","__ZN8device_t9save_itemIyEEvRT_PKci","__ZN13screen_device11device_stopEv","__ZN13screen_device19load_effect_overlayEPKc","__ZN13screen_device16device_post_loadEv","__ZN13screen_device15finalize_burninEv","__ZNK13screen_device4vposEv","__ZNK13screen_device23time_until_vblank_startEv","__ZN13screen_device18scanline0_callbackEv","__ZN13screen_device21vblank_begin_callbackEv","__ZN13screen_device14update_partialEi","__ZN13screen_device13screen_updateER8bitmap_tRK10_rectangle","__ZNK13screen_device4hposEv","__ZNK13screen_device21time_until_vblank_endEv","__ZN13screen_device22realloc_screen_bitmapsEv","__ZNK11simple_listIN13screen_device13callback_itemEE5firstEv","__ZNK13screen_device13callback_item4nextEv","__ZN11simple_listIN13screen_device13callback_itemEE6appendERS1_","__ZN8attotimepLERKS_","__ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EeqERKS3_","__ZN13screen_device13callback_itemC1E8delegateIFvRS_bEE","__ZN8delegateIFvR13screen_devicebEEC1ERKS3_","__ZNK13delegate_baseIvR13screen_deviceb8_noparamS2_EclES1_b","__ZN13screen_device19vblank_end_callbackEv","__ZN13screen_device24scanline_update_callbackEi","__ZN13screen_device12update_quadsEv","__ZN13screen_device24register_vblank_callbackE8delegateIFvRS_bEE","__ZN13resource_pool10add_objectIN13screen_device13callback_itemEEEPT_S4_","__Z8downcastIP13driver_deviceS0_ET_PT0_","__ZN13screen_device13update_burninEv","__ZNK11emu_options18snapshot_directoryEv","__ZNK15running_machine11driver_dataI13driver_deviceEEPT_v","__ZN13screen_device10screen_eofEv","__ZN20resource_pool_objectIN13screen_device13callback_itemEEC1EPS1_","__ZN20resource_pool_objectIN13screen_device13callback_itemEEC2EPS1_","__ZN20resource_pool_objectIN13screen_device13callback_itemEED1Ev","__ZN12save_manager9save_itemIyEEvPKcS2_iRT_S2_","__ZN12save_manager9save_itemIxEEvPKcS2_iRT_S2_","__ZN11simple_listIN13screen_device13callback_itemEED2Ev","__ZN11simple_listIN13screen_device13callback_itemEE5resetEv","__ZN11simple_listIN13screen_device13callback_itemEE6removeERS1_","__ZN20resource_pool_objectIN13screen_device13callback_itemEED0Ev","__ZN20resource_pool_objectIN13screen_device13callback_itemEED2Ev","__ZN12save_manager9save_itemI8attotimeEEvPKcS3_iRT_S3_","__ZN11simple_listIN13screen_device13callback_itemEED0Ev","__ZN9emu_timerD2Ev","__ZN11simple_listIN13screen_device13callback_itemEE6detachERS1_","__ZN11simple_listIN13screen_device13callback_itemEEC2ER13resource_pool","__ZN20resource_pool_objectI13screen_deviceEC1EPS0_","__ZN20resource_pool_objectI13screen_deviceEC2EPS0_","__ZN20resource_pool_objectI13screen_deviceED1Ev","__ZN8delegateIFvR13screen_devicebEEC2ERKS3_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2ERKS3_","__ZN13screen_device13callback_itemC2E8delegateIFvRS_bEE","__GLOBAL__I_a2842","__ZN9emu_timerC2Ev","__ZN8delegateIFvPviEEC1Ev","__ZN9emu_timer4initER15running_machine8delegateIFvPviEES3_b","__ZN8delegateIFvPviEEaSERKS2_","__ZN13resource_pool10add_objectI13screen_deviceEEPT_S3_","__ZN20resource_pool_objectI13screen_deviceED0Ev","__ZN20resource_pool_objectI13screen_deviceED2Ev","__ZN9emu_timer13register_saveEv","__ZNK9emu_timer7machineEv","__ZN16device_scheduler17timer_list_removeER9emu_timer","__ZNK16device_scheduler11first_timerEv","__ZNK13delegate_baseIvPvi8_noparamS1_E4nameEv","__ZNK9emu_timer4nextEv","__ZN16device_scheduler17timer_list_insertER9emu_timer","__ZN9emu_timer4initER8device_tjPvb","__ZN9emu_timer7releaseEv","__ZN9emu_timer6enableEb","__ZN9emu_timer6adjustE8attotimeiS0_","__ZNK16device_scheduler4timeEv","__ZN16device_scheduler15abort_timesliceEv","__ZNK9emu_timer9remainingEv","__ZN9emu_timer20schedule_next_periodEv","__ZNK9emu_timer4dumpEv","__ZN15fixed_allocatorI9emu_timerEC1ER13resource_pool","__ZN11simple_listIN16device_scheduler12quantum_slotEEC1ER13resource_pool","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEEC1ER13resource_pool","__ZN12save_manager9save_itemI8attotimeEEvRT_PKci","__ZN8delegateIFvvEEC1I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN16device_scheduler7presaveEv","__ZN16device_schedulerC2ER15running_machine","__ZN15fixed_allocatorI9emu_timerE5allocEv","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED1Ev","__ZN11simple_listIN16device_scheduler12quantum_slotEED1Ev","__ZN15fixed_allocatorI9emu_timerED1Ev","__ZN15fixed_allocatorI9emu_timerE7reclaimERS0_","__ZNK16device_scheduler8can_saveEv","__ZNK9emu_timer6expireEv","__ZNK16device_scheduler11dump_timersEv","__ZN16device_scheduler9timesliceEv","__ZN16device_scheduler8postloadEv","__ZN16device_schedulerD2Ev","__ZN16device_scheduler20rebuild_execute_listEv","__ZNK11simple_listIN16device_scheduler12quantum_slotEE5firstEv","__ZL10divu_64x32yj","__ZN11simple_listI9emu_timerE6appendERS0_","__ZN11simple_listI9emu_timerE11detach_headEv","__ZNK16device_scheduler12quantum_slot4nextEv","__ZeqRK8attotimeS1_","__ZN11simple_listIN16device_scheduler12quantum_slotEE11detach_headEv","__ZN16device_scheduler14execute_timersEv","__ZL23debugger_start_cpu_hookP8device_t8attotime","__ZL22debugger_stop_cpu_hookP8device_t","__Z3maxRK8attotimeS1_","__ZN16device_scheduler9timer_setE8attotime8delegateIFvPviEEiS2_","__ZN16device_scheduler16boost_interleaveE8attotimeS0_","__ZN16device_scheduler22add_scheduling_quantumE8attotimeS0_","__ZN16device_scheduler11timer_allocE8delegateIFvPviEES1_","__ZN8delegateIFvPviEEC1ERKS2_","__ZN16device_scheduler11timer_allocER8device_tjPv","__ZN16device_scheduler14eat_all_cyclesEv","__ZN11simple_listI9emu_timerEC1ER13resource_pool","__ZN11simple_listI9emu_timerED1Ev","__ZN16device_scheduler26compute_perfect_interleaveEv","__Z3minRK8attotimeS1_","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE7reclaimEPS1_","__ZN8device_t13timer_expiredER9emu_timerjiPv","__ZNK13delegate_baseIvPvi8_noparamS1_E6isnullEv","__ZN11simple_listIN16device_scheduler12quantum_slotEE6detachERS1_","__ZN11simple_listIN16device_scheduler12quantum_slotEE7prependERS1_","__ZNK11simple_listIN16device_scheduler12quantum_slotEE4poolEv","__ZN11simple_listIN16device_scheduler12quantum_slotEE6appendERS1_","__ZN11simple_listI9emu_timerEC2ER13resource_pool","__ZNK13delegate_baseIvPvi8_noparamS1_EclES0_i","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE7reclaimERS1_","__ZN11simple_listIN16device_scheduler12quantum_slotEE12insert_afterERS1_PS1_","__ZN16device_scheduler12quantum_slotC1Ev","__ZN16device_scheduler12quantum_slotC2Ev","__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEEC1EPS1_","__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEEC2EPS1_","__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED1Ev","__ZN8delegateIFvvEEC2I16device_schedulerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I16device_schedulerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM16device_schedulerFvvEEET_","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEE5allocEv","__ZN13resource_pool10add_objectIN16device_scheduler12quantum_slotEEEPT_S4_","__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED0Ev","__ZN20resource_pool_objectIN16device_scheduler12quantum_slotEED2Ev","__ZN11simple_listI9emu_timerED0Ev","__ZN21delegate_internal_mfpC2IM16device_schedulerFvvEEET_","__ZNK11simple_listI9emu_timerE4poolEv","__ZN11simple_listI9emu_timerE6detachERS0_","__ZN11simple_listIN16device_scheduler12quantum_slotEEC2ER13resource_pool","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI16device_schedulerEEP22delegate_generic_classR18delegate_late_bind","__ZN20resource_pool_objectI9emu_timerEC1EPS0_","__ZN20resource_pool_objectI9emu_timerEC2EPS0_","__ZN20resource_pool_objectI9emu_timerED1Ev","__ZN11simple_listIN16device_scheduler12quantum_slotEED2Ev","__ZN11simple_listIN16device_scheduler12quantum_slotEE5resetEv","__ZN11simple_listIN16device_scheduler12quantum_slotEE6removeERS1_","__ZN11simple_listI9emu_timerED2Ev","__ZN11simple_listI9emu_timerE5resetEv","__ZN11simple_listI9emu_timerE6removeERS0_","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEEC2ER13resource_pool","__ZN15fixed_allocatorI9emu_timerEC2ER13resource_pool","__ZN8delegateIFvPviEEC2Ev","__ZN13delegate_baseIvPvi8_noparamS1_EC2Ev","__ZN8delegateIFvPviEEC2ERKS2_","__ZN13delegate_baseIvPvi8_noparamS1_EC2ERKS2_","__ZN15fixed_allocatorI9emu_timerED2Ev","__ZN15fixed_allocatorIN16device_scheduler12quantum_slotEED2Ev","__ZN13delegate_baseIvPvi8_noparamS1_EaSERKS2_","__ZN13resource_pool10add_objectI9emu_timerEEPT_S3_","__ZN20resource_pool_objectI9emu_timerED0Ev","__ZN20resource_pool_objectI9emu_timerED2Ev","__ZN11simple_listIN16device_scheduler12quantum_slotEED0Ev","__ZN11simple_listI13address_spaceE6appendERS0_","__ZN15_memory_privateC1Ev","__ZNK11device_list5firstI23device_memory_interfaceEEbRPT_","__Z11memory_initR15running_machine","__ZN13resource_pool10add_objectI15_memory_privateEEPT_S3_","__ZN13address_space8allocateER15running_machineRK20address_space_configR23device_memory_interface16address_spacenum","__ZNK11simple_listI13address_spaceE5firstEv","__ZNK13address_space4nextEv","__ZNK16device_interface4nextI23device_memory_interfaceEEbRPT_","__ZN13address_space17populate_from_mapEv","__ZN13address_space11prepare_mapEv","__ZL16generate_memdumpR15running_machine","__ZN13address_space13locate_memoryEv","__ZL13bank_reattachR15running_machine","__ZNK8tagmap_tIP11memory_bankE14find_hash_onlyEPKc","__ZN13address_space15allocate_memoryEv","__ZNK11memory_bank5entryEv","__ZNK12memory_share3ptrEv","__ZNK20address_space_config4nameEv","__ZNK8tagmap_tIP12memory_shareE4findEPKc","__Z11memory_dumpR15running_machineP7__sFILE","__ZN13address_space8dump_mapEP7__sFILE13read_or_write","__ZNK13address_space19address_to_byte_endEj","__ZN13address_spaceD2Ev","__ZN11memory_bank9set_entryEi","__ZN11memory_bank8set_baseEPv","__ZN13address_spaceC2ER23device_memory_interface16address_spacenumb","__ZN13resource_pool10add_objectI16direct_read_dataEEPT_S3_","__ZN13address_spaceD0Ev","__ZN22address_space_specificIhL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t0ELb0EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIhL12endianness_t1ELb0EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t0ELb0EEEEPT_S5_","__ZN22address_space_specificItL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificItL12endianness_t1ELb0EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t0ELb0EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIjL12endianness_t1ELb0EEEEPT_S5_","__ZN22address_space_specificIyL12endianness_t0ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t0ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t1ELb1EEC1ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t1ELb0EEC1ER23device_memory_interface16address_spacenum","__ZN13address_space16adjust_addressesERjS0_S0_S0_","__ZN12memory_shareC1EjPv","__ZN8tagmap_tIP12memory_shareE3addEPKcS1_b","__ZN13address_table17mask_all_handlersEj","__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t0ELb0EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb1EEEEPT_S5_","__ZN13resource_pool10add_objectI22address_space_specificIyL12endianness_t1ELb0EEEEPT_S5_","__ZN13resource_pool10add_objectI12memory_shareEEPT_S3_","__ZN13address_space18populate_map_entryERK17address_map_entry13read_or_write","__ZN13address_space13unmap_genericEjjjj13read_or_writeb","__ZN8delegateIFhR13address_spacejhEEC1ERK13delegate_baseIhS1_jh8_noparamER18delegate_late_bind","__ZN8delegateIFtR13address_spacejtEEC1ERK13delegate_baseItS1_jt8_noparamER18delegate_late_bind","__ZN8delegateIFjR13address_spacejjEEC1ERK13delegate_baseIjS1_jj8_noparamER18delegate_late_bind","__ZN8delegateIFyR13address_spacejyEEC1ERK13delegate_baseIyS1_jy8_noparamER18delegate_late_bind","__ZN13address_space19install_ram_genericEjjjj13read_or_writePv","__ZN13address_space20install_read_handlerEjjjj8delegateIFhRS_jhEEy","__ZN13address_space20install_read_handlerEjjjj8delegateIFtRS_jtEEy","__ZN13address_space20install_read_handlerEjjjj8delegateIFjRS_jjEEy","__ZN13address_space20install_read_handlerEjjjj8delegateIFyRS_jyEEy","__ZN8delegateIFvR13address_spacejhhEEC1ERK13delegate_baseIvS1_jhhER18delegate_late_bind","__ZN8delegateIFvR13address_spacejttEEC1ERK13delegate_baseIvS1_jttER18delegate_late_bind","__ZN8delegateIFvR13address_spacejjjEEC1ERK13delegate_baseIvS1_jjjER18delegate_late_bind","__ZN8delegateIFvR13address_spacejyyEEC1ERK13delegate_baseIvS1_jyyER18delegate_late_bind","__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jhhEEy","__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jttEEy","__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jjjEEy","__ZN13address_space21install_write_handlerEjjjj8delegateIFvRS_jyyEEy","__ZN13address_space27install_legacy_read_handlerEjjjjPFhPS_jEPKcy","__ZN13address_space27install_legacy_read_handlerEjjjjPFtPS_jtEPKcy","__ZN13address_space27install_legacy_read_handlerEjjjjPFjPS_jjEPKcy","__ZN13address_space27install_legacy_read_handlerEjjjjPFyPS_jyEPKcy","__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jhEPKcy","__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jttEPKcy","__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jjjEPKcy","__ZN13address_space28install_legacy_write_handlerEjjjjPFvPS_jyyEPKcy","__ZNK11simple_listI12memory_blockE4lastEv","__ZN11simple_listI12memory_blockE6appendERS0_","__ZN13address_space20install_bank_genericEjjjjPKcS1_","__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFhPS0_jEPKcy","__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFtPS0_jtEPKcy","__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFjPS0_jjEPKcy","__ZN13address_space27install_legacy_read_handlerER8device_tjjjjPFyPS0_jyEPKcy","__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jhEPKcy","__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jttEPKcy","__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jjjEPKcy","__ZN13address_space28install_legacy_write_handlerER8device_tjjjjPFvPS0_jyyEPKcy","__ZN13address_space22install_readwrite_portEjjjjPKcS1_","__ZNK12memory_block4nextEv","__ZNK11simple_listI12memory_blockE5firstEv","__ZNK12memory_block9bytestartEv","__ZNK12memory_block7byteendEv","__ZNK12memory_block4dataEv","__ZNK11simple_listI11memory_bankE5firstEv","__ZNK11memory_bank4baseEv","__ZNK11memory_bank9bytestartEv","__ZNK11memory_bank9anonymousEv","__ZNK11memory_bank4nextEv","__ZN12memory_share7set_ptrEPv","__ZN13address_space25block_assign_intersectingEjjPh","__ZN13address_space19needs_backing_storeEPK17address_map_entry","__ZNK15running_machine11driver_dataIvEEPT_v","__ZNK11memory_bank16references_spaceER13address_space13read_or_write","__ZN13address_space18get_handler_stringE13read_or_writej","__ZNK13address_table12handler_nameEh","__ZNK13address_table6lookupEj","__ZN13resource_pool10add_objectI12memory_blockEEPT_S3_","__ZNK13handler_entry9bytestartEv","__ZNK13address_table12derive_rangeEjRjS0_","__ZN13address_table9map_rangeEjjjjh","__ZNK19handler_entry_proxyI18handler_entry_readE10set_ioportERK17input_port_config","__ZN19handler_entry_proxyI18handler_entry_readED1Ev","__ZN18address_table_read17handler_map_rangeEjjjjy","__ZNK19handler_entry_proxyI19handler_entry_writeE10set_ioportERK17input_port_config","__ZN19handler_entry_proxyI19handler_entry_writeED1Ev","__ZN19address_table_write17handler_map_rangeEjjjjy","__ZNK11memory_bank5indexEv","__ZN13address_space19find_backing_memoryEjj","__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFhR13address_spacejhEEEEvT_","__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejhhEEEEvT_","__ZN13address_space21bank_find_or_allocateEPKcjjjj13read_or_write","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP13address_spacejEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejhEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFhP8device_tjEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjhEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFtR13address_spacejtEEEEvT_","__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejttEEEEvT_","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP13address_spacejtEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejttEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFtP8device_tjtEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjttEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFjR13address_spacejjEEEEvT_","__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejjjEEEEvT_","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP13address_spacejjEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejjjEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFjP8device_tjjEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjjjEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI18handler_entry_readE12set_delegateI8delegateIFyR13address_spacejyEEEEvT_","__ZNK19handler_entry_proxyI19handler_entry_writeE12set_delegateI8delegateIFvR13address_spacejyyEEEEvT_","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP13address_spacejyEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP13address_spacejyyEEEvRS3_T_PKc","__ZNK12memory_block8containsER13address_spacejj","__ZNK11memory_bank15matches_exactlyEjj","__ZN11simple_listI11memory_bankE6appendERS0_","__ZNK19handler_entry_proxyI18handler_entry_readE15set_legacy_funcIPFyP8device_tjyEEEvRS3_T_PKc","__ZNK19handler_entry_proxyI19handler_entry_writeE15set_legacy_funcIPFvP8device_tjyyEEEvRS3_T_PKc","__ZN8tagmap_tIP11memory_bankE15add_unique_hashEPKcS1_b","__ZN13resource_pool10add_objectI11memory_bankEEPT_S3_","__ZN11memory_bank13add_referenceER13address_space13read_or_write","__ZN13address_table13subtable_dataC1Ev","__ZN13address_tableD2Ev","__ZN13handler_entry9configureEjjj","__ZN13address_tableC2ER13address_spaceb","__ZN13resource_pool9add_arrayIN13address_table13subtable_dataEEEPT_S4_i","__ZN13address_tableD0Ev","__ZN13address_table23populate_range_mirroredEjjjh","__ZN16direct_read_data12force_updateEh","__ZN13address_table11setup_rangeEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE","__ZN13address_table17setup_range_solidEjjjjRNSt3__14listIjNS0_9allocatorIjEEEE","__ZN13address_table16get_free_handlerEv","__ZN13address_table18setup_range_maskedEjjjjyRNSt3__14listIjNS0_9allocatorIjEEEE","__ZNSt3__14listIjNS_9allocatorIjEEE9push_backERKj","__ZN13handler_entry17overriden_by_maskEy","__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE9push_backERKS2_","__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEixERSA_","__ZN13address_table14subtable_closeEj","__ZNK13handler_entry8bytemaskEv","__ZNK13address_table11level2_bitsEv","__ZN13address_table11handler_refEhi","__ZN13address_table14populate_rangeEjjh","__ZN13handler_entry26clear_conflicting_subunitsEy","__ZN13address_table12subtable_ptrEh","__ZN13address_table13subtable_openEj","__ZN13address_table13handler_unrefEh","__ZN16direct_read_data26remove_intersecting_rangesEjj","__ZNK13address_table12level1_indexEj","__ZN13address_table16subtable_releaseEh","__ZN13address_table16subtable_reallocEh","__ZNK13handler_entry18mirrored_start_endEjRjS0_","__ZN13handler_entry10apply_maskEj","__ZNK13address_table12level2_indexEhj","__ZN13address_table14subtable_mergeEv","__ZNK11memory_bank4nameEv","__ZNK13handler_entry11descriptionEPc","__ZN13address_table14subtable_allocEv","__ZN18handler_entry_readC1Eh12endianness_tPPh","__ZN8delegateIFhR13address_spacejhEEC1I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_","__ZN18address_table_read7unmap_rIhEET_R13address_spacejS1_","__ZN18address_table_read5nop_rIhEET_R13address_spacejS1_","__ZN18address_table_readC2ER13address_spaceb","__ZN13resource_pool10add_objectI18handler_entry_readEEPT_S3_","__ZN18handler_entry_read12set_delegateE8delegateIFhR13address_spacejhEEyPKNS_11legacy_infoE","__ZN18address_table_read12watchpoint_rIhEET_R13address_spacejS1_","__ZN8delegateIFtR13address_spacejtEEC1I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_","__ZN18address_table_read7unmap_rItEET_R13address_spacejS1_","__ZN18address_table_read5nop_rItEET_R13address_spacejS1_","__ZN18address_table_read12watchpoint_rItEET_R13address_spacejS1_","__ZN8delegateIFjR13address_spacejjEEC1I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_","__ZN18address_table_read7unmap_rIjEET_R13address_spacejS1_","__ZN18address_table_read5nop_rIjEET_R13address_spacejS1_","__ZN18address_table_read12watchpoint_rIjEET_R13address_spacejS1_","__ZN8delegateIFyR13address_spacejyEEC1I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_","__ZN18address_table_read7unmap_rIyEET_R13address_spacejS1_","__ZN18address_table_read5nop_rIyEET_R13address_spacejS1_","__ZN18address_table_read12watchpoint_rIyEET_R13address_spacejS1_","__ZN18handler_entry_read12set_delegateE8delegateIFtR13address_spacejtEEyPKNS_11legacy_infoE","__ZN18handler_entry_read12set_delegateE8delegateIFjR13address_spacejjEEyPKNS_11legacy_infoE","__ZN18handler_entry_read12set_delegateE8delegateIFyR13address_spacejyEEyPKNS_11legacy_infoE","__ZNK18address_table_read7handlerEj","__ZN19handler_entry_writeC1Eh12endianness_tPPh","__ZN18address_table_readD0Ev","__ZN18address_table_readD2Ev","__ZN19address_table_writeC2ER13address_spaceb","__ZN13resource_pool10add_objectI19handler_entry_writeEEPT_S3_","__ZN19address_table_write5nop_wIhEEvR13address_spacejT_S3_","__ZN19address_table_write5nop_wItEEvR13address_spacejT_S3_","__ZN19address_table_write5nop_wIjEEvR13address_spacejT_S3_","__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejhhEEyPKNS_11legacy_infoE","__ZN8delegateIFvR13address_spacejhhEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_","__ZN19address_table_write7unmap_wIhEEvR13address_spacejT_S3_","__ZN19address_table_write12watchpoint_wIhEEvR13address_spacejT_S3_","__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejttEEyPKNS_11legacy_infoE","__ZN8delegateIFvR13address_spacejttEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_","__ZN19address_table_write7unmap_wItEEvR13address_spacejT_S3_","__ZN19address_table_write12watchpoint_wItEEvR13address_spacejT_S3_","__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejjjEEyPKNS_11legacy_infoE","__ZN8delegateIFvR13address_spacejjjEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_","__ZN19address_table_write7unmap_wIjEEvR13address_spacejT_S3_","__ZN19address_table_write12watchpoint_wIjEEvR13address_spacejT_S3_","__ZN19handler_entry_write12set_delegateE8delegateIFvR13address_spacejyyEEyPKNS_11legacy_infoE","__ZN8delegateIFvR13address_spacejyyEEC1I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_","__ZN19address_table_write5nop_wIyEEvR13address_spacejT_S3_","__ZNK19address_table_write7handlerEj","__ZNK13delegate_baseIjR16direct_read_dataj8_noparamS2_E6isnullEv","__ZN19address_table_write7unmap_wIyEEvR13address_spacejT_S3_","__ZN19address_table_write12watchpoint_wIyEEvR13address_spacejT_S3_","__ZN11simple_listIN16direct_read_data12direct_rangeEEC1ER13resource_pool","__ZN11simple_listIN16direct_read_data12direct_rangeEED1Ev","__ZN8delegateIFjR16direct_read_datajEEC1Ev","__ZN16direct_read_data17set_direct_regionERj","__ZNK13delegate_baseIjR16direct_read_dataj8_noparamS2_EclES1_j","__ZN19address_table_writeD0Ev","__ZN19address_table_writeD2Ev","__ZN16direct_read_dataC2ER13address_space","__ZN16direct_read_dataD2Ev","__ZNK18address_table_read12handler_readEj","__ZNK11simple_listIN16direct_read_data12direct_rangeEE5firstEv","__ZNK16direct_read_data12direct_range4nextEv","__ZN11simple_listIN16direct_read_data12direct_rangeEE6detachERS1_","__ZN11simple_listIN16direct_read_data12direct_rangeEE7prependERS1_","__ZNK13address_table11lookup_liveEj","__ZN16direct_read_data12direct_rangeC1Ev","__ZN16direct_read_data10find_rangeEjRh","__ZN13resource_pool10add_objectIN16direct_read_data12direct_rangeEEEPT_S4_","__ZNK13memory_region3endEv","__ZNK13memory_region4nextEv","__ZNK12memory_block7machineEv","__ZNK12save_manager20registration_allowedEv","__ZNK11memory_bank7machineEv","__ZNK11simple_listIN11memory_bank14bank_referenceEE5firstEv","__ZNK11memory_bank14bank_reference7matchesER13address_space13read_or_write","__ZNK11memory_bank14bank_reference4nextEv","__ZN11simple_listIN11memory_bank14bank_referenceEE6appendERS1_","__ZNK15running_machine12first_regionEv","__ZN12memory_blockD2Ev","__ZN11simple_listIN11memory_bank14bank_referenceEEC1ER13resource_pool","__ZN11simple_listIN11memory_bank14bank_referenceEED1Ev","__ZN12memory_blockC2ER13address_spacejjPv","__ZN11memory_bankC2ER13address_spaceijjPKc","__ZN11memory_bankD2Ev","__ZN13handler_entryD2Ev","__ZNK11memory_bank14bank_reference5spaceEv","__ZN16direct_read_data12force_updateEv","__ZN13handler_entryC2Eh12endianness_tPPh","__ZN13handler_entry20reconfigure_subunitsEj","__ZN13handler_entry18configure_subunitsEyiRiS0_","__ZN11memory_bank14bank_referenceC1ER13address_space13read_or_write","__ZN11memory_bank21invalidate_referencesEv","__ZN13handler_entry4copyEPS_","__ZN18handler_entry_read4copyEP13handler_entry","__ZN18handler_entry_read14access_handleraSERKS0_","__ZNK18handler_entry_read4nameEv","__ZNK18handler_entry_read12subunit_nameEi","__ZN13resource_pool10add_objectIN11memory_bank14bank_referenceEEEPT_S4_","__ZN13handler_entryD0Ev","__ZNK13delegate_baseIhR13address_spacejh8_noparamE10has_objectEv","__ZNK13delegate_baseItR13address_spacejt8_noparamE10has_objectEv","__ZNK13delegate_baseIjR13address_spacejj8_noparamE10has_objectEv","__ZNK13delegate_baseIyR13address_spacejy8_noparamE10has_objectEv","__ZN18handler_entry_read14remove_subunitEi","__ZN8delegateIFtR13address_spacejtEEC1I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_","__ZN18handler_entry_read12read_stub_16ER13address_spacejt","__ZN8delegateIFjR13address_spacejjEEC1I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_","__ZN18handler_entry_read12read_stub_32ER13address_spacejj","__ZN8delegateIFyR13address_spacejyEEC1I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_","__ZN18handler_entry_read12read_stub_64ER13address_spacejy","__ZN18handler_entry_read15set_legacy_funcER13address_spacePFhPS0_jEPKcy","__ZN8delegateIFhR13address_spacejhEEC1I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_","__ZN18handler_entry_read16read_stub_legacyER13address_spacejh","__ZN18handler_entry_read15set_legacy_funcER13address_spacePFtPS0_jtEPKcy","__ZN18handler_entry_read16read_stub_legacyER13address_spacejt","__ZN18handler_entry_read15set_legacy_funcER13address_spacePFjPS0_jjEPKcy","__ZN18handler_entry_read16read_stub_legacyER13address_spacejj","__ZN18handler_entry_read15set_legacy_funcER13address_spacePFyPS0_jyEPKcy","__ZN18handler_entry_read16read_stub_legacyER13address_spacejy","__ZN18handler_entry_read15set_legacy_funcER8device_tPFhPS0_jEPKcy","__ZNK13address_space5unmapEv","__ZN18handler_entry_read15set_legacy_funcER8device_tPFtPS0_jtEPKcy","__ZN18handler_entry_read15set_legacy_funcER8device_tPFjPS0_jjEPKcy","__ZN18handler_entry_read15set_legacy_funcER8device_tPFyPS0_jyEPKcy","__ZN18handler_entry_read10set_ioportERK17input_port_config","__ZN18handler_entry_read16read_stub_ioportIhEET_R13address_spacejS1_","__ZN18handler_entry_read16read_stub_ioportItEET_R13address_spacejS1_","__ZN18handler_entry_read16read_stub_ioportIjEET_R13address_spacejS1_","__ZN18handler_entry_read16read_stub_ioportIyEET_R13address_spacejS1_","__ZNK13delegate_baseIhR13address_spacejh8_noparamEclES1_jh","__ZNK13delegate_baseItR13address_spacejt8_noparamEclES1_jt","__ZNK13delegate_baseIjR13address_spacejj8_noparamEclES1_jj","__ZN19handler_entry_write4copyEP13handler_entry","__ZN19handler_entry_write14access_handleraSERKS0_","__ZNK19handler_entry_write4nameEv","__ZNK19handler_entry_write12subunit_nameEi","__ZN19handler_entry_write14remove_subunitEi","__ZN8delegateIFvR13address_spacejttEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_","__ZN19handler_entry_write13write_stub_16ER13address_spacejtt","__ZN8delegateIFvR13address_spacejjjEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_","__ZN19handler_entry_write13write_stub_32ER13address_spacejjj","__ZN8delegateIFvR13address_spacejyyEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_","__ZN19handler_entry_write13write_stub_64ER13address_spacejyy","__ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jhEPKcy","__ZN8delegateIFvR13address_spacejhhEEC1I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_","__ZN19handler_entry_write17write_stub_legacyER13address_spacejhh","__ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jttEPKcy","__ZN19handler_entry_write17write_stub_legacyER13address_spacejtt","__ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jjjEPKcy","__ZN19handler_entry_write17write_stub_legacyER13address_spacejjj","__ZN19handler_entry_write15set_legacy_funcER13address_spacePFvPS0_jyyEPKcy","__ZN19handler_entry_write17write_stub_legacyER13address_spacejyy","__ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jhEPKcy","__ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jttEPKcy","__ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jjjEPKcy","__ZN19handler_entry_write15set_legacy_funcER8device_tPFvPS0_jyyEPKcy","__ZN19handler_entry_write10set_ioportERK17input_port_config","__ZN19handler_entry_write17write_stub_ioportIhEEvR13address_spacejT_S3_","__ZN19handler_entry_write17write_stub_ioportItEEvR13address_spacejT_S3_","__ZN19handler_entry_write17write_stub_ioportIjEEvR13address_spacejT_S3_","__ZN19handler_entry_write17write_stub_ioportIyEEvR13address_spacejT_S3_","__ZNK13delegate_baseIvR13address_spacejhhEclES1_jhh","__ZNK13delegate_baseIvR13address_spacejttEclES1_jtt","__ZNK13delegate_baseIvR13address_spacejjjEclES1_jjj","__ZN18handler_entry_readD1Ev","__ZN19handler_entry_writeD1Ev","__ZN18handler_entry_readD0Ev","__ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejhhEEET_","__ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejyyEEET_","__ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejjjEEET_","__ZN21delegate_internal_mfpC2IM19handler_entry_writeFvR13address_spacejttEEET_","__ZN21delegate_internal_mfpC2IM18handler_entry_readFhR13address_spacejhEEET_","__ZN21delegate_internal_mfpC2IM18handler_entry_readFyR13address_spacejyEEET_","__ZN21delegate_internal_mfpC2IM18handler_entry_readFjR13address_spacejjEEET_","__ZN8delegateIFvR13address_spacejhhEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejhhEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejhhEEET_","__ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFvR13address_spacejyyEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejyyEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejyyEEET_","__ZN13delegate_baseIvR13address_spacejyyE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejyyE4bindEP22delegate_generic_class","__ZN8delegateIFvR13address_spacejjjEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejjjEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejjjEEET_","__ZN13delegate_baseIvR13address_spacejjjE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejjjE4bindEP22delegate_generic_class","__ZN8delegateIFvR13address_spacejttEEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejttEC2I19handler_entry_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19handler_entry_writeFvR13address_spacejttEEET_","__ZN13delegate_baseIvR13address_spacejttE16late_bind_helperI19handler_entry_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejttE4bindEP22delegate_generic_class","__ZN8delegateIFhR13address_spacejhEEC2I18handler_entry_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseIhR13address_spacejh8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18handler_entry_readFhR13address_spacejhEEET_","__ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFyR13address_spacejyEEC2I18handler_entry_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseIyR13address_spacejy8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_yS1_jyS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18handler_entry_readFyR13address_spacejyEEET_","__ZN13delegate_baseIyR13address_spacejy8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIyR13address_spacejy8_noparamE4bindEP22delegate_generic_class","__ZN8delegateIFjR13address_spacejjEEC2I18handler_entry_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseIjR13address_spacejj8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_jS1_jjS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18handler_entry_readFjR13address_spacejjEEET_","__ZN13delegate_baseIjR13address_spacejj8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIjR13address_spacejj8_noparamE4bindEP22delegate_generic_class","__ZN19handler_entry_writeD0Ev","__ZN21delegate_internal_mfpC2IM18handler_entry_readFtR13address_spacejtEEET_","__ZN11simple_listIN11memory_bank14bank_referenceEE6detachERS1_","__ZN11simple_listIN11memory_bank14bank_referenceEEC2ER13resource_pool","__ZN8delegateIFtR13address_spacejtEEC2I18handler_entry_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseItR13address_spacejt8_noparamEC2I18handler_entry_readEEN15delegate_traitsIT_tS1_jtS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18handler_entry_readFtR13address_spacejtEEET_","__ZN13delegate_baseItR13address_spacejt8_noparamE16late_bind_helperI18handler_entry_readEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseItR13address_spacejt8_noparamE4bindEP22delegate_generic_class","__ZN20resource_pool_objectIN11memory_bank14bank_referenceEEC1EPS1_","__ZN20resource_pool_objectIN11memory_bank14bank_referenceEEC2EPS1_","__ZN20resource_pool_objectIN11memory_bank14bank_referenceEED1Ev","__ZN11simple_listIN11memory_bank14bank_referenceEED2Ev","__ZN11simple_listIN11memory_bank14bank_referenceEE5resetEv","__ZN11simple_listIN11memory_bank14bank_referenceEE6removeERS1_","__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEEC1EPS1_","__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEEC2EPS1_","__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED1Ev","__ZN11simple_listIN16direct_read_data12direct_rangeEED2Ev","__ZN11simple_listIN16direct_read_data12direct_rangeEE5resetEv","__ZN11simple_listIN16direct_read_data12direct_rangeEE6removeERS1_","__ZN8delegateIFjR16direct_read_datajEEC2Ev","__ZN13delegate_baseIjR16direct_read_dataj8_noparamS2_EC2Ev","__ZN20resource_pool_objectIN11memory_bank14bank_referenceEED0Ev","__ZN20resource_pool_objectIN11memory_bank14bank_referenceEED2Ev","__ZN11simple_listIN11memory_bank14bank_referenceEED0Ev","__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED0Ev","__ZN20resource_pool_objectIN16direct_read_data12direct_rangeEED2Ev","__ZN11simple_listIN16direct_read_data12direct_rangeEED0Ev","__ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejyyEEET_","__ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejjjEEET_","__ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejttEEET_","__ZN21delegate_internal_mfpC2IM19address_table_writeFvR13address_spacejhhEEET_","__ZN21delegate_internal_mfpC2IM18address_table_readFyR13address_spacejyEEET_","__ZN21delegate_internal_mfpC2IM18address_table_readFjR13address_spacejjEEET_","__ZN21delegate_internal_mfpC2IM18address_table_readFtR13address_spacejtEEET_","__ZN11simple_listIN16direct_read_data12direct_rangeEEC2ER13resource_pool","__ZNK13address_space15debugger_accessEv","__ZNK13address_space9addrcharsEv","__ZN8delegateIFvR13address_spacejyyEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejyyEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jyyE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejyyEEET_","__ZN13delegate_baseIvR13address_spacejyyE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFvR13address_spacejjjEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejjjEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jjjE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejjjEEET_","__ZN13delegate_baseIvR13address_spacejjjE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFvR13address_spacejttEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejttEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jttE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejttEEET_","__ZN13delegate_baseIvR13address_spacejttE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFvR13address_spacejhhEEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13address_spacejhhEC2I19address_table_writeEEN15delegate_traitsIT_vS1_jhhE16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM19address_table_writeFvR13address_spacejhhEEET_","__ZN13delegate_baseIvR13address_spacejhhE16late_bind_helperI19address_table_writeEEP22delegate_generic_classR18delegate_late_bind","__ZN20resource_pool_objectI19handler_entry_writeEC1EPS0_","__ZN20resource_pool_objectI19handler_entry_writeEC2EPS0_","__ZN20resource_pool_objectI19handler_entry_writeED1Ev","__ZN8delegateIFyR13address_spacejyEEC2I18address_table_readEEN15delegate_traitsIT_yS1_jy8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseIyR13address_spacejy8_noparamEC2I18address_table_readEEN15delegate_traitsIT_yS1_jyS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18address_table_readFyR13address_spacejyEEET_","__ZN13delegate_baseIyR13address_spacejy8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFjR13address_spacejjEEC2I18address_table_readEEN15delegate_traitsIT_jS1_jj8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseIjR13address_spacejj8_noparamEC2I18address_table_readEEN15delegate_traitsIT_jS1_jjS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18address_table_readFjR13address_spacejjEEET_","__ZN13delegate_baseIjR13address_spacejj8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFtR13address_spacejtEEC2I18address_table_readEEN15delegate_traitsIT_tS1_jt8_noparamE16member_func_typeEPKcPS7_","__ZN13delegate_baseItR13address_spacejt8_noparamEC2I18address_table_readEEN15delegate_traitsIT_tS1_jtS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18address_table_readFtR13address_spacejtEEET_","__ZN13delegate_baseItR13address_spacejt8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFhR13address_spacejhEEC2I18address_table_readEEN15delegate_traitsIT_hS1_jh8_noparamE16member_func_typeEPKcPS7_","__ZN20resource_pool_objectI19handler_entry_writeED0Ev","__ZN20resource_pool_objectI19handler_entry_writeED2Ev","__ZN21delegate_internal_mfpC2IM18address_table_readFhR13address_spacejhEEET_","__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC2EPKNS_11__list_nodeIS2_S3_EE","__ZNSt3__115__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPNS_11__tree_nodeIS8_PvEEiEC2ESC_","__ZNSt3__121__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEEPKNS_11__tree_nodeIS8_PvEEiEC2ENS_15__tree_iteratorIS8_PSB_iEE","__ZNSt3__115__list_iteratorIN12_GLOBAL__N_18subrangeEPvEC2EPNS_11__list_nodeIS2_S3_EE","__ZNSt3__121__list_const_iteratorIN12_GLOBAL__N_18subrangeEPvEC2ENS_15__list_iteratorIS2_S3_EE","__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_","__ZN13delegate_baseIhR13address_spacejh8_noparamEC2I18address_table_readEEN15delegate_traitsIT_hS1_jhS2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM18address_table_readFhR13address_spacejhEEET_","__ZN13delegate_baseIhR13address_spacejh8_noparamE16late_bind_helperI18address_table_readEEP22delegate_generic_classR18delegate_late_bind","__ZN20resource_pool_objectI18handler_entry_readEC1EPS0_","__ZN20resource_pool_objectI18handler_entry_readEC2EPS0_","__ZN20resource_pool_objectI18handler_entry_readED1Ev","__ZNSt3__114__map_iteratorINS_15__tree_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPNS_11__tree_nodeIS9_PvEEiEEEC2ESE_","__ZNSt3__120__map_const_iteratorINS_21__tree_const_iteratorINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPKNS_11__tree_nodeIS9_PvEEiEEEC2ENS_14__map_iteratorINS_15__tree_iteratorIS9_PSC_iEEEE","__ZN20resource_pool_objectI18handler_entry_readED0Ev","__ZN20resource_pool_objectI18handler_entry_readED2Ev","__ZNSt3__111__tree_nextIPKNS_16__tree_node_baseIPvEEEET_S6_","__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE16__insert_node_atEPNS_16__tree_node_baseIPvEERSI_SI_","__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEE16__construct_nodeERSA_","__ZNSt3__14__rvINS_10unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS6_EEEEEEPvEENS_21__map_node_destructorINS7_ISC_EEEEEEEC2ERSG_","__ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_","__ZNSt3__118__tree_left_rotateIPNS_16__tree_node_baseIPvEEEEvT_","__ZNSt3__119__tree_right_rotateIPNS_16__tree_node_baseIPvEEEEvT_","__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEED2Ev","__ZNSt3__119__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEELb1EEC2ES8_","__ZNSt3__121__map_node_destructorINS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS1_IS6_EEEEEEPvEEEEEC2ERSC_","__ZNSt3__122__allocator_destructorINS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC2ERS7_j","__ZNSt3__117__compressed_pairINS_15__tree_end_nodeIPNS_16__tree_node_baseIPvEEEENS_9allocatorINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS7_ISC_EEEEEES3_EEEEEC2Ev","__ZNSt3__117__compressed_pairIjNS_9allocatorINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEEEEEC2Eji","__ZNSt3__116__list_node_baseIN12_GLOBAL__N_18subrangeEPvEC2Ev","__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2EPSB_SE_","__ZNSt3__117__compressed_pairIPNS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ESC_SF_","__ZNSt3__110unique_ptrINS_11__tree_nodeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS5_EEEEEEPvEENS_21__map_node_destructorINS6_ISB_EEEEEC2ENS_4__rvISF_EE","__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2EPS5_S9_","__ZNSt3__117__compressed_pairIPNS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEEC2ES6_SA_","__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEEC2ERKS8_","__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEEC2ERKSC_","__ZNSt3__117__compressed_pairIjNS_19__map_value_compareIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEENS_4lessIhEELb1EEEEC2EjSA_","__ZNSt3__14listIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEEC2Ev","__ZN19resource_pool_arrayIN13address_table13subtable_dataEEC1EPS1_i","__ZN19resource_pool_arrayIN13address_table13subtable_dataEEC2EPS1_i","__ZN19resource_pool_arrayIN13address_table13subtable_dataEED1Ev","__ZNSt3__110unique_ptrINS_11__list_nodeIN12_GLOBAL__N_18subrangeEPvEENS_22__allocator_destructorINS_9allocatorIS5_EEEEED2Ev","__ZN19resource_pool_arrayIN13address_table13subtable_dataEED0Ev","__ZN19resource_pool_arrayIN13address_table13subtable_dataEED2Ev","__Z8downcastIPv13driver_deviceET_PT0_","__ZN20resource_pool_objectI11memory_bankEC1EPS0_","__ZN20resource_pool_objectI11memory_bankEC2EPS0_","__ZN20resource_pool_objectI11memory_bankED1Ev","__ZN20resource_pool_objectI12memory_blockEC1EPS0_","__ZN20resource_pool_objectI12memory_blockEC2EPS0_","__ZN20resource_pool_objectI12memory_blockED1Ev","__ZN8delegateIFvR13address_spacejyyEEC2ERK13delegate_baseIvS1_jyyER18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejyyEC2ERKS2_R18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejyyE9late_bindER18delegate_late_bind","__ZN8delegateIFvR13address_spacejjjEEC2ERK13delegate_baseIvS1_jjjER18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejjjEC2ERKS2_R18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejjjE9late_bindER18delegate_late_bind","__ZN8delegateIFvR13address_spacejttEEC2ERK13delegate_baseIvS1_jttER18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejttEC2ERKS2_R18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejttE9late_bindER18delegate_late_bind","__ZN8delegateIFvR13address_spacejhhEEC2ERK13delegate_baseIvS1_jhhER18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejhhEC2ERKS2_R18delegate_late_bind","__ZN13delegate_baseIvR13address_spacejhhE9late_bindER18delegate_late_bind","__ZN8delegateIFyR13address_spacejyEEC2ERK13delegate_baseIyS1_jy8_noparamER18delegate_late_bind","__ZN13delegate_baseIyR13address_spacejy8_noparamEC2ERKS3_R18delegate_late_bind","__ZN13delegate_baseIyR13address_spacejy8_noparamE9late_bindER18delegate_late_bind","__ZN8delegateIFjR13address_spacejjEEC2ERK13delegate_baseIjS1_jj8_noparamER18delegate_late_bind","__ZN13delegate_baseIjR13address_spacejj8_noparamEC2ERKS3_R18delegate_late_bind","__ZN13delegate_baseIjR13address_spacejj8_noparamE9late_bindER18delegate_late_bind","__ZN8delegateIFtR13address_spacejtEEC2ERK13delegate_baseItS1_jt8_noparamER18delegate_late_bind","__ZN20resource_pool_objectI11memory_bankED0Ev","__ZN20resource_pool_objectI11memory_bankED2Ev","__ZN20resource_pool_objectI12memory_blockED0Ev","__ZN20resource_pool_objectI12memory_blockED2Ev","__ZNK22address_space_specificIyL12endianness_t1ELb0EE9accessorsER14data_accessors","__ZN13delegate_baseItR13address_spacejt8_noparamEC2ERKS3_R18delegate_late_bind","__ZN13delegate_baseItR13address_spacejt8_noparamE9late_bindER18delegate_late_bind","__ZN8delegateIFhR13address_spacejhEEC2ERK13delegate_baseIhS1_jh8_noparamER18delegate_late_bind","__ZN13delegate_baseIhR13address_spacejh8_noparamEC2ERKS3_R18delegate_late_bind","__ZN13delegate_baseIhR13address_spacejh8_noparamE9late_bindER18delegate_late_bind","__ZN20resource_pool_objectI12memory_shareEC1EPS0_","__ZN20resource_pool_objectI12memory_shareEC2EPS0_","__ZN20resource_pool_objectI12memory_shareED1Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED1Ev","__ZN22address_space_specificIyL12endianness_t1ELb0EED1Ev","__ZN22address_space_specificIyL12endianness_t1ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificIyL12endianness_t1ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificIyL12endianness_t1ELb0EE12get_read_ptrEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE13get_write_ptrEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE9read_byteEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE9read_wordEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE9read_wordEjt","__ZN22address_space_specificIyL12endianness_t1ELb0EE19read_word_unalignedEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_dwordEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_dwordEjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_qwordEj","__ZN20resource_pool_objectI12memory_shareED0Ev","__ZN20resource_pool_objectI12memory_shareED2Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb0EEED2Ev","__ZN22address_space_specificIyL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t1ELb0EED0Ev","__ZN22address_space_specificIyL12endianness_t1ELb0EE4readEv","__ZN22address_space_specificIyL12endianness_t1ELb0EE5writeEv","__ZNK19address_table_write13handler_writeEj","__ZNK13handler_entry10byteoffsetEj","__ZNK13handler_entry6ramptrEj","__ZNK13address_table17lookup_live_smallEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE10read_qwordEjy","__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t1ELb0EE10write_byteEjh","__ZN22address_space_specificIyL12endianness_t1ELb0EE10write_wordEjt","__ZN22address_space_specificIyL12endianness_t1ELb0EE10write_wordEjtt","__ZN22address_space_specificIyL12endianness_t1ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t1ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_dwordEjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_dwordEjjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_qwordEjy","__ZN22address_space_specificIyL12endianness_t1ELb0EE11write_qwordEjyy","__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t1ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjyy","__ZNK22address_space_specificIyL12endianness_t1ELb0EE12write_lookupEj","__ZNK19handler_entry_write7write64ER13address_spacejyy","__ZNK13delegate_baseIvR13address_spacejyyEclES1_jyy","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_nativeEjy","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_","__ZN13address_table18enable_watchpointsEb","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEjy","__ZNK22address_space_specificIyL12endianness_t1ELb0EE11read_lookupEj","__ZNK18handler_entry_read6read64ER13address_spacejy","__ZNK13delegate_baseIyR13address_spacejy8_noparamEclES1_jy","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_nativeEj","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t1ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t1ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t1ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIyL12endianness_t1ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIyL12endianness_t1ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIyL12endianness_t1ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED1Ev","__ZN22address_space_specificIyL12endianness_t1ELb0EED2Ev","__ZNK22address_space_specificIyL12endianness_t1ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificIyL12endianness_t1ELb1EE4readEv","__ZN22address_space_specificIyL12endianness_t1ELb1EE5writeEv","__ZN22address_space_specificIyL12endianness_t1ELb1EED1Ev","__ZN22address_space_specificIyL12endianness_t1ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificIyL12endianness_t1ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificIyL12endianness_t1ELb1EE12get_read_ptrEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE13get_write_ptrEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE9read_byteEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE9read_wordEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE9read_wordEjt","__ZN22address_space_specificIyL12endianness_t1ELb1EE19read_word_unalignedEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_dwordEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_dwordEjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_qwordEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE10read_qwordEjy","__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t1ELb1EE10write_byteEjh","__ZN22address_space_specificIyL12endianness_t1ELb1EE10write_wordEjt","__ZN22address_space_specificIyL12endianness_t1ELb1EE10write_wordEjtt","__ZN22address_space_specificIyL12endianness_t1ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t1ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_dwordEjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_dwordEjjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_qwordEjy","__ZN22address_space_specificIyL12endianness_t1ELb1EE11write_qwordEjyy","__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t1ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t1ELb1EEED2Ev","__ZN22address_space_specificIyL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t1ELb1EED0Ev","__ZNK13address_table18level1_index_largeEj","__ZNK13address_table18level2_index_largeEhj","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjyy","__ZNK22address_space_specificIyL12endianness_t1ELb1EE12write_lookupEj","__ZNK13address_table17lookup_live_largeEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_nativeEjy","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEjy","__ZNK22address_space_specificIyL12endianness_t1ELb1EE11read_lookupEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_nativeEj","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_","__ZNK22address_space_specificIyL12endianness_t0ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t1ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t1ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t1ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t1ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIyL12endianness_t1ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIyL12endianness_t1ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIyL12endianness_t1ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED1Ev","__ZN22address_space_specificIyL12endianness_t0ELb0EED1Ev","__ZN22address_space_specificIyL12endianness_t0ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificIyL12endianness_t0ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificIyL12endianness_t0ELb0EE12get_read_ptrEj","__ZN22address_space_specificIyL12endianness_t1ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb0EEED2Ev","__ZN22address_space_specificIyL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t0ELb0EED0Ev","__ZN22address_space_specificIyL12endianness_t0ELb0EE4readEv","__ZN22address_space_specificIyL12endianness_t0ELb0EE5writeEv","__ZN22address_space_specificIyL12endianness_t0ELb0EE13get_write_ptrEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE9read_byteEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE9read_wordEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE9read_wordEjt","__ZN22address_space_specificIyL12endianness_t0ELb0EE19read_word_unalignedEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_dwordEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_dwordEjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_qwordEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE10read_qwordEjy","__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t0ELb0EE10write_byteEjh","__ZN22address_space_specificIyL12endianness_t0ELb0EE10write_wordEjt","__ZN22address_space_specificIyL12endianness_t0ELb0EE10write_wordEjtt","__ZN22address_space_specificIyL12endianness_t0ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t0ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_dwordEjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_dwordEjjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_qwordEjy","__ZN22address_space_specificIyL12endianness_t0ELb0EE11write_qwordEjyy","__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t0ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjyy","__ZNK22address_space_specificIyL12endianness_t0ELb0EE12write_lookupEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_nativeEjy","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEjy","__ZNK22address_space_specificIyL12endianness_t0ELb0EE11read_lookupEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_nativeEj","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t0ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t0ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t0ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIyL12endianness_t0ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIyL12endianness_t0ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIyL12endianness_t0ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED1Ev","__ZN22address_space_specificIyL12endianness_t0ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED0Ev","__ZNK22address_space_specificIyL12endianness_t0ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificIyL12endianness_t0ELb1EE4readEv","__ZN22address_space_specificIyL12endianness_t0ELb1EE5writeEv","__ZN22address_space_specificIyL12endianness_t0ELb1EED1Ev","__ZN22address_space_specificIyL12endianness_t0ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificIyL12endianness_t0ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificIyL12endianness_t0ELb1EE12get_read_ptrEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE13get_write_ptrEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE9read_byteEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE9read_wordEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE9read_wordEjt","__ZN22address_space_specificIyL12endianness_t0ELb1EE19read_word_unalignedEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_dwordEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_dwordEjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_qwordEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE10read_qwordEjy","__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t0ELb1EE10write_byteEjh","__ZN22address_space_specificIyL12endianness_t0ELb1EE10write_wordEjt","__ZN22address_space_specificIyL12endianness_t0ELb1EE10write_wordEjtt","__ZN22address_space_specificIyL12endianness_t0ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificIyL12endianness_t0ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_dwordEjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_dwordEjjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_qwordEjy","__ZN22address_space_specificIyL12endianness_t0ELb1EE11write_qwordEjyy","__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificIyL12endianness_t0ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjyy","__ZNK22address_space_specificIyL12endianness_t0ELb1EE12write_lookupEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN20resource_pool_objectI22address_space_specificIyL12endianness_t0ELb1EEED2Ev","__ZN22address_space_specificIyL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIyL12endianness_t0ELb1EED0Ev","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_nativeEjy","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEjy","__ZNK22address_space_specificIyL12endianness_t0ELb1EE11read_lookupEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_nativeEj","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIyL12endianness_t0ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t0ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificIyL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t0ELb1EE17read_qword_staticEPS1_j","__ZNK22address_space_specificIjL12endianness_t1ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificIyL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t0ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIyL12endianness_t0ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificIyL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIyL12endianness_t0ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIyL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIyL12endianness_t0ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIyL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED1Ev","__ZN22address_space_specificIjL12endianness_t1ELb0EED1Ev","__ZN22address_space_specificIjL12endianness_t1ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificIjL12endianness_t1ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificIjL12endianness_t1ELb0EE12get_read_ptrEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE13get_write_ptrEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE9read_byteEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE9read_wordEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE9read_wordEjt","__ZN22address_space_specificIjL12endianness_t1ELb0EE19read_word_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_dwordEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_dwordEjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_qwordEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE10read_qwordEjy","__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t1ELb0EE10write_byteEjh","__ZN22address_space_specificIjL12endianness_t1ELb0EE10write_wordEjt","__ZN22address_space_specificIjL12endianness_t1ELb0EE10write_wordEjtt","__ZN22address_space_specificIjL12endianness_t1ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t1ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_dwordEjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_dwordEjjj","__ZN22address_space_specificIyL12endianness_t0ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb0EEED2Ev","__ZN22address_space_specificIjL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t1ELb0EED0Ev","__ZN22address_space_specificIjL12endianness_t1ELb0EE4readEv","__ZN22address_space_specificIjL12endianness_t1ELb0EE5writeEv","__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_qwordEjy","__ZN22address_space_specificIjL12endianness_t1ELb0EE11write_qwordEjyy","__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t1ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjjj","__ZNK22address_space_specificIjL12endianness_t1ELb0EE12write_lookupEj","__ZNK19handler_entry_write7write32ER13address_spacejjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_nativeEjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEjj","__ZNK22address_space_specificIjL12endianness_t1ELb0EE11read_lookupEj","__ZNK18handler_entry_read6read32ER13address_spacejj","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_nativeEj","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t1ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t1ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t1ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIjL12endianness_t1ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIjL12endianness_t1ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIjL12endianness_t1ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED1Ev","__ZN22address_space_specificIjL12endianness_t1ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t1ELb1EEED2Ev","__ZN22address_space_specificIjL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum","__ZNK22address_space_specificIjL12endianness_t1ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificIjL12endianness_t1ELb1EE4readEv","__ZN22address_space_specificIjL12endianness_t1ELb1EE5writeEv","__ZN22address_space_specificIjL12endianness_t1ELb1EED1Ev","__ZN22address_space_specificIjL12endianness_t1ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificIjL12endianness_t1ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificIjL12endianness_t1ELb1EE12get_read_ptrEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE13get_write_ptrEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE9read_byteEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE9read_wordEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE9read_wordEjt","__ZN22address_space_specificIjL12endianness_t1ELb1EE19read_word_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_dwordEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_dwordEjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_qwordEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE10read_qwordEjy","__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t1ELb1EE10write_byteEjh","__ZN22address_space_specificIjL12endianness_t1ELb1EE10write_wordEjt","__ZN22address_space_specificIjL12endianness_t1ELb1EE10write_wordEjtt","__ZN22address_space_specificIjL12endianness_t1ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t1ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_dwordEjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_dwordEjjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_qwordEjy","__ZN22address_space_specificIjL12endianness_t1ELb1EE11write_qwordEjyy","__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t1ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjjj","__ZNK22address_space_specificIjL12endianness_t1ELb1EE12write_lookupEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EED0Ev","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_nativeEjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEjj","__ZNK22address_space_specificIjL12endianness_t1ELb1EE11read_lookupEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_nativeEj","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_","__ZNK22address_space_specificIjL12endianness_t0ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificIjL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t1ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t1ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t1ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t1ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIjL12endianness_t1ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIjL12endianness_t1ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIjL12endianness_t1ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED1Ev","__ZN22address_space_specificIjL12endianness_t0ELb0EED1Ev","__ZN22address_space_specificIjL12endianness_t0ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificIjL12endianness_t0ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificIjL12endianness_t0ELb0EE12get_read_ptrEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE13get_write_ptrEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE9read_byteEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE9read_wordEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE9read_wordEjt","__ZN22address_space_specificIjL12endianness_t0ELb0EE19read_word_unalignedEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_dwordEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_dwordEjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_qwordEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE10read_qwordEjy","__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificIjL12endianness_t1ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb0EEED2Ev","__ZN22address_space_specificIjL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t0ELb0EED0Ev","__ZN22address_space_specificIjL12endianness_t0ELb0EE4readEv","__ZN22address_space_specificIjL12endianness_t0ELb0EE5writeEv","__ZN22address_space_specificIjL12endianness_t0ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t0ELb0EE10write_byteEjh","__ZN22address_space_specificIjL12endianness_t0ELb0EE10write_wordEjt","__ZN22address_space_specificIjL12endianness_t0ELb0EE10write_wordEjtt","__ZN22address_space_specificIjL12endianness_t0ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t0ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_dwordEjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_dwordEjjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_qwordEjy","__ZN22address_space_specificIjL12endianness_t0ELb0EE11write_qwordEjyy","__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t0ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjjj","__ZNK22address_space_specificIjL12endianness_t0ELb0EE12write_lookupEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_nativeEjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEjj","__ZNK22address_space_specificIjL12endianness_t0ELb0EE11read_lookupEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_nativeEj","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t0ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t0ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t0ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIjL12endianness_t0ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIjL12endianness_t0ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIjL12endianness_t0ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED1Ev","__ZN22address_space_specificIjL12endianness_t0ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIjL12endianness_t0ELb1EEED2Ev","__ZNK22address_space_specificIjL12endianness_t0ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificIjL12endianness_t0ELb1EE4readEv","__ZN22address_space_specificIjL12endianness_t0ELb1EE5writeEv","__ZN22address_space_specificIjL12endianness_t0ELb1EED1Ev","__ZN22address_space_specificIjL12endianness_t0ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificIjL12endianness_t0ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificIjL12endianness_t0ELb1EE12get_read_ptrEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE13get_write_ptrEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE9read_byteEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE9read_wordEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE9read_wordEjt","__ZN22address_space_specificIjL12endianness_t0ELb1EE19read_word_unalignedEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_dwordEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_dwordEjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_qwordEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE10read_qwordEjy","__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t0ELb1EE10write_byteEjh","__ZN22address_space_specificIjL12endianness_t0ELb1EE10write_wordEjt","__ZN22address_space_specificIjL12endianness_t0ELb1EE10write_wordEjtt","__ZN22address_space_specificIjL12endianness_t0ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificIjL12endianness_t0ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_dwordEjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_dwordEjjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_qwordEjy","__ZN22address_space_specificIjL12endianness_t0ELb1EE11write_qwordEjyy","__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificIjL12endianness_t0ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjjj","__ZNK22address_space_specificIjL12endianness_t0ELb1EE12write_lookupEj","__ZN22address_space_specificIjL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIjL12endianness_t0ELb1EED0Ev","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_nativeEjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEjj","__ZNK22address_space_specificIjL12endianness_t0ELb1EE11read_lookupEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_nativeEj","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_","__ZNK22address_space_specificItL12endianness_t1ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificIjL12endianness_t0ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t0ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t0ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificIjL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t0ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIjL12endianness_t0ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificIjL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIjL12endianness_t0ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIjL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIjL12endianness_t0ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIjL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED1Ev","__ZN22address_space_specificItL12endianness_t1ELb0EED1Ev","__ZN22address_space_specificItL12endianness_t1ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificItL12endianness_t1ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificItL12endianness_t1ELb0EE12get_read_ptrEj","__ZN22address_space_specificItL12endianness_t1ELb0EE13get_write_ptrEj","__ZN22address_space_specificItL12endianness_t1ELb0EE9read_byteEj","__ZN22address_space_specificItL12endianness_t1ELb0EE9read_wordEj","__ZN22address_space_specificItL12endianness_t1ELb0EE9read_wordEjt","__ZN22address_space_specificItL12endianness_t1ELb0EE19read_word_unalignedEj","__ZN22address_space_specificItL12endianness_t1ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t1ELb0EE10read_dwordEj","__ZN22address_space_specificItL12endianness_t1ELb0EE10read_dwordEjj","__ZN22address_space_specificItL12endianness_t1ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificItL12endianness_t1ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t1ELb0EE10read_qwordEj","__ZN22address_space_specificIjL12endianness_t0ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb0EEED2Ev","__ZN22address_space_specificItL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t1ELb0EED0Ev","__ZN22address_space_specificItL12endianness_t1ELb0EE4readEv","__ZN22address_space_specificItL12endianness_t1ELb0EE5writeEv","__ZN22address_space_specificItL12endianness_t1ELb0EE10read_qwordEjy","__ZN22address_space_specificItL12endianness_t1ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificItL12endianness_t1ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t1ELb0EE10write_byteEjh","__ZN22address_space_specificItL12endianness_t1ELb0EE10write_wordEjt","__ZN22address_space_specificItL12endianness_t1ELb0EE10write_wordEjtt","__ZN22address_space_specificItL12endianness_t1ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t1ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificItL12endianness_t1ELb0EE11write_dwordEjj","__ZN22address_space_specificItL12endianness_t1ELb0EE11write_dwordEjjj","__ZN22address_space_specificItL12endianness_t1ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t1ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificItL12endianness_t1ELb0EE11write_qwordEjy","__ZN22address_space_specificItL12endianness_t1ELb0EE11write_qwordEjyy","__ZN22address_space_specificItL12endianness_t1ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t1ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjtt","__ZNK22address_space_specificItL12endianness_t1ELb0EE12write_lookupEj","__ZNK19handler_entry_write7write16ER13address_spacejtt","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_nativeEjt","__ZN22address_space_specificItL12endianness_t1ELb0EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEjt","__ZNK22address_space_specificItL12endianness_t1ELb0EE11read_lookupEj","__ZNK18handler_entry_read6read16ER13address_spacejt","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_nativeEj","__ZN22address_space_specificItL12endianness_t1ELb0EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t1ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t1ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t1ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificItL12endianness_t1ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificItL12endianness_t1ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj","__ZNK22address_space_specificItL12endianness_t1ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificItL12endianness_t1ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED1Ev","__ZN22address_space_specificItL12endianness_t1ELb1EED1Ev","__ZN22address_space_specificItL12endianness_t1ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificItL12endianness_t1ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificItL12endianness_t1ELb1EE12get_read_ptrEj","__ZN22address_space_specificItL12endianness_t1ELb1EE13get_write_ptrEj","__ZN22address_space_specificItL12endianness_t1ELb1EE9read_byteEj","__ZN22address_space_specificItL12endianness_t1ELb1EE9read_wordEj","__ZN22address_space_specificItL12endianness_t1ELb1EE9read_wordEjt","__ZN22address_space_specificItL12endianness_t1ELb1EE19read_word_unalignedEj","__ZN22address_space_specificItL12endianness_t1ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t1ELb1EE10read_dwordEj","__ZN22address_space_specificItL12endianness_t1ELb1EE10read_dwordEjj","__ZN22address_space_specificItL12endianness_t1ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificItL12endianness_t1ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t1ELb1EE10read_qwordEj","__ZN22address_space_specificItL12endianness_t1ELb1EE10read_qwordEjy","__ZN22address_space_specificItL12endianness_t1ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificItL12endianness_t1ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t1ELb1EE10write_byteEjh","__ZN22address_space_specificItL12endianness_t1ELb1EE10write_wordEjt","__ZN22address_space_specificItL12endianness_t1ELb1EE10write_wordEjtt","__ZN22address_space_specificItL12endianness_t1ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t1ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificItL12endianness_t1ELb1EE11write_dwordEjj","__ZN22address_space_specificItL12endianness_t1ELb1EE11write_dwordEjjj","__ZN22address_space_specificItL12endianness_t1ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t1ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificItL12endianness_t1ELb1EE11write_qwordEjy","__ZN22address_space_specificItL12endianness_t1ELb1EE11write_qwordEjyy","__ZN22address_space_specificItL12endianness_t1ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t1ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificItL12endianness_t1ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t1ELb1EEED2Ev","__ZN22address_space_specificItL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t1ELb1EED0Ev","__ZN22address_space_specificItL12endianness_t1ELb1EE4readEv","__ZN22address_space_specificItL12endianness_t1ELb1EE5writeEv","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjtt","__ZNK22address_space_specificItL12endianness_t1ELb1EE12write_lookupEj","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_nativeEjt","__ZN22address_space_specificItL12endianness_t1ELb1EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEjt","__ZNK22address_space_specificItL12endianness_t1ELb1EE11read_lookupEj","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_nativeEj","__ZN22address_space_specificItL12endianness_t1ELb1EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t1ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t1ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t1ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t1ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificItL12endianness_t1ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificItL12endianness_t1ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificItL12endianness_t1ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED1Ev","__ZN22address_space_specificItL12endianness_t1ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED0Ev","__ZNK22address_space_specificItL12endianness_t0ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificItL12endianness_t0ELb0EE4readEv","__ZN22address_space_specificItL12endianness_t0ELb0EE5writeEv","__ZN22address_space_specificItL12endianness_t0ELb0EED1Ev","__ZN22address_space_specificItL12endianness_t0ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificItL12endianness_t0ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificItL12endianness_t0ELb0EE12get_read_ptrEj","__ZN22address_space_specificItL12endianness_t0ELb0EE13get_write_ptrEj","__ZN22address_space_specificItL12endianness_t0ELb0EE9read_byteEj","__ZN22address_space_specificItL12endianness_t0ELb0EE9read_wordEj","__ZN22address_space_specificItL12endianness_t0ELb0EE9read_wordEjt","__ZN22address_space_specificItL12endianness_t0ELb0EE19read_word_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t0ELb0EE10read_dwordEj","__ZN22address_space_specificItL12endianness_t0ELb0EE10read_dwordEjj","__ZN22address_space_specificItL12endianness_t0ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t0ELb0EE10read_qwordEj","__ZN22address_space_specificItL12endianness_t0ELb0EE10read_qwordEjy","__ZN22address_space_specificItL12endianness_t0ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t0ELb0EE10write_byteEjh","__ZN22address_space_specificItL12endianness_t0ELb0EE10write_wordEjt","__ZN22address_space_specificItL12endianness_t0ELb0EE10write_wordEjtt","__ZN22address_space_specificItL12endianness_t0ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t0ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificItL12endianness_t0ELb0EE11write_dwordEjj","__ZN22address_space_specificItL12endianness_t0ELb0EE11write_dwordEjjj","__ZN22address_space_specificItL12endianness_t0ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t0ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificItL12endianness_t0ELb0EE11write_qwordEjy","__ZN22address_space_specificItL12endianness_t0ELb0EE11write_qwordEjyy","__ZN22address_space_specificItL12endianness_t0ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t0ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjtt","__ZNK22address_space_specificItL12endianness_t0ELb0EE12write_lookupEj","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb0EEED2Ev","__ZN22address_space_specificItL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t0ELb0EED0Ev","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_nativeEjt","__ZN22address_space_specificItL12endianness_t0ELb0EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEjt","__ZNK22address_space_specificItL12endianness_t0ELb0EE11read_lookupEj","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_nativeEj","__ZN22address_space_specificItL12endianness_t0ELb0EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t0ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t0ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t0ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificItL12endianness_t0ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificItL12endianness_t0ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificItL12endianness_t0ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED1Ev","__ZN22address_space_specificItL12endianness_t0ELb1EED1Ev","__ZN22address_space_specificItL12endianness_t0ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificItL12endianness_t0ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificItL12endianness_t0ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificItL12endianness_t0ELb1EEED2Ev","__ZN22address_space_specificItL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificItL12endianness_t0ELb1EED0Ev","__ZNK22address_space_specificItL12endianness_t0ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificItL12endianness_t0ELb1EE4readEv","__ZN22address_space_specificItL12endianness_t0ELb1EE5writeEv","__ZN22address_space_specificItL12endianness_t0ELb1EE12get_read_ptrEj","__ZN22address_space_specificItL12endianness_t0ELb1EE13get_write_ptrEj","__ZN22address_space_specificItL12endianness_t0ELb1EE9read_byteEj","__ZN22address_space_specificItL12endianness_t0ELb1EE9read_wordEj","__ZN22address_space_specificItL12endianness_t0ELb1EE9read_wordEjt","__ZN22address_space_specificItL12endianness_t0ELb1EE19read_word_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t0ELb1EE10read_dwordEj","__ZN22address_space_specificItL12endianness_t0ELb1EE10read_dwordEjj","__ZN22address_space_specificItL12endianness_t0ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t0ELb1EE10read_qwordEj","__ZN22address_space_specificItL12endianness_t0ELb1EE10read_qwordEjy","__ZN22address_space_specificItL12endianness_t0ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t0ELb1EE10write_byteEjh","__ZN22address_space_specificItL12endianness_t0ELb1EE10write_wordEjt","__ZN22address_space_specificItL12endianness_t0ELb1EE10write_wordEjtt","__ZN22address_space_specificItL12endianness_t0ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificItL12endianness_t0ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificItL12endianness_t0ELb1EE11write_dwordEjj","__ZN22address_space_specificItL12endianness_t0ELb1EE11write_dwordEjjj","__ZN22address_space_specificItL12endianness_t0ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificItL12endianness_t0ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificItL12endianness_t0ELb1EE11write_qwordEjy","__ZN22address_space_specificItL12endianness_t0ELb1EE11write_qwordEjyy","__ZN22address_space_specificItL12endianness_t0ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificItL12endianness_t0ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjtt","__ZNK22address_space_specificItL12endianness_t0ELb1EE12write_lookupEj","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_nativeEjt","__ZN22address_space_specificItL12endianness_t0ELb1EE12write_directIhLb1EEEvjT_S3_","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEjt","__ZNK22address_space_specificItL12endianness_t0ELb1EE11read_lookupEj","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_","__ZNK22address_space_specificIhL12endianness_t1ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_nativeEj","__ZN22address_space_specificItL12endianness_t0ELb1EE11read_directIhLb1EEET_jS3_","__ZN22address_space_specificItL12endianness_t0ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t0ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t0ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificItL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t0ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificItL12endianness_t0ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificItL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificItL12endianness_t0ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificItL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificItL12endianness_t0ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificItL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED1Ev","__ZN22address_space_specificIhL12endianness_t1ELb0EED1Ev","__ZN22address_space_specificIhL12endianness_t1ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificIhL12endianness_t1ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificIhL12endianness_t1ELb0EE12get_read_ptrEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE13get_write_ptrEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE9read_byteEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE9read_wordEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE9read_wordEjt","__ZN22address_space_specificIhL12endianness_t1ELb0EE19read_word_unalignedEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_dwordEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_dwordEjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificItL12endianness_t0ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb0EEED2Ev","__ZN22address_space_specificIhL12endianness_t1ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t1ELb0EED0Ev","__ZN22address_space_specificIhL12endianness_t1ELb0EE4readEv","__ZN22address_space_specificIhL12endianness_t1ELb0EE5writeEv","__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_qwordEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE10read_qwordEjy","__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t1ELb0EE10write_byteEjh","__ZN22address_space_specificIhL12endianness_t1ELb0EE10write_wordEjt","__ZN22address_space_specificIhL12endianness_t1ELb0EE10write_wordEjtt","__ZN22address_space_specificIhL12endianness_t1ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t1ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_dwordEjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_dwordEjjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_qwordEjy","__ZN22address_space_specificIhL12endianness_t1ELb0EE11write_qwordEjyy","__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t1ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjhh","__ZNK22address_space_specificIhL12endianness_t1ELb0EE12write_lookupEj","__ZNK19handler_entry_write6write8ER13address_spacejhh","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE12write_nativeEjh","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEjh","__ZNK22address_space_specificIhL12endianness_t1ELb0EE11read_lookupEj","__ZNK18handler_entry_read5read8ER13address_spacejh","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_directItLb1EEET_jS3_","__ZNK22address_space_specificIhL12endianness_t1ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificIhL12endianness_t1ELb0EE11read_nativeEj","__ZN22address_space_specificIhL12endianness_t1ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t1ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t1ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t1ELb0EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIhL12endianness_t1ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t1ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIhL12endianness_t1ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t1ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIhL12endianness_t1ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t1ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED1Ev","__ZN22address_space_specificIhL12endianness_t1ELb1EED1Ev","__ZN22address_space_specificIhL12endianness_t1ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificIhL12endianness_t1ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificIhL12endianness_t1ELb1EE12get_read_ptrEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE13get_write_ptrEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE9read_byteEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE9read_wordEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE9read_wordEjt","__ZN22address_space_specificIhL12endianness_t1ELb1EE19read_word_unalignedEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_dwordEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_dwordEjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_qwordEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE10read_qwordEjy","__ZN22address_space_specificIhL12endianness_t1ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t1ELb1EEED2Ev","__ZN22address_space_specificIhL12endianness_t1ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t1ELb1EED0Ev","__ZN22address_space_specificIhL12endianness_t1ELb1EE4readEv","__ZN22address_space_specificIhL12endianness_t1ELb1EE5writeEv","__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t1ELb1EE10write_byteEjh","__ZN22address_space_specificIhL12endianness_t1ELb1EE10write_wordEjt","__ZN22address_space_specificIhL12endianness_t1ELb1EE10write_wordEjtt","__ZN22address_space_specificIhL12endianness_t1ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t1ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_dwordEjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_dwordEjjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_qwordEjy","__ZN22address_space_specificIhL12endianness_t1ELb1EE11write_qwordEjyy","__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t1ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjhh","__ZNK22address_space_specificIhL12endianness_t1ELb1EE12write_lookupEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE12write_nativeEjh","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEjh","__ZNK22address_space_specificIhL12endianness_t1ELb1EE11read_lookupEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_directItLb1EEET_jS3_","__ZNK22address_space_specificIhL12endianness_t0ELb0EE9accessorsER14data_accessors","__ZN22address_space_specificIhL12endianness_t1ELb1EE11read_nativeEj","__ZN22address_space_specificIhL12endianness_t1ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t1ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t1ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t1ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t1ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIhL12endianness_t1ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t1ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIhL12endianness_t1ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t1ELb1EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIhL12endianness_t1ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t1ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED1Ev","__ZN22address_space_specificIhL12endianness_t0ELb0EED1Ev","__ZN22address_space_specificIhL12endianness_t0ELb0EE23enable_read_watchpointsEb","__ZN22address_space_specificIhL12endianness_t0ELb0EE24enable_write_watchpointsEb","__ZN22address_space_specificIhL12endianness_t0ELb0EE12get_read_ptrEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE13get_write_ptrEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE9read_byteEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE9read_wordEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE9read_wordEjt","__ZN22address_space_specificIhL12endianness_t0ELb0EE19read_word_unalignedEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE19read_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_dwordEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_dwordEjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_dword_unalignedEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_qwordEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE10read_qwordEjy","__ZN22address_space_specificIhL12endianness_t1ELb1EED2Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb0EEED2Ev","__ZN22address_space_specificIhL12endianness_t0ELb0EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t0ELb0EED0Ev","__ZN22address_space_specificIhL12endianness_t0ELb0EE4readEv","__ZN22address_space_specificIhL12endianness_t0ELb0EE5writeEv","__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_qword_unalignedEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE20read_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t0ELb0EE10write_byteEjh","__ZN22address_space_specificIhL12endianness_t0ELb0EE10write_wordEjt","__ZN22address_space_specificIhL12endianness_t0ELb0EE10write_wordEjtt","__ZN22address_space_specificIhL12endianness_t0ELb0EE20write_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t0ELb0EE20write_word_unalignedEjtt","__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_dwordEjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_dwordEjjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_dword_unalignedEjjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_qwordEjy","__ZN22address_space_specificIhL12endianness_t0ELb0EE11write_qwordEjyy","__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t0ELb0EE21write_qword_unalignedEjyy","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjhh","__ZNK22address_space_specificIhL12endianness_t0ELb0EE12write_lookupEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE12write_nativeEjh","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEjh","__ZNK22address_space_specificIhL12endianness_t0ELb0EE11read_lookupEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb0EE11read_nativeEj","__ZN22address_space_specificIhL12endianness_t0ELb0EE16read_byte_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb0EE16read_word_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb0EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t0ELb0EE17read_dword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb0EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t0ELb0EE17read_qword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb0EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t0ELb0EE17write_byte_staticEPS1_jh","__ZNK22address_space_specificIhL12endianness_t0ELb1EE9accessorsER14data_accessors","__ZN22address_space_specificIhL12endianness_t0ELb0EE17write_word_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t0ELb0EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIhL12endianness_t0ELb0EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t0ELb0EE25write_dword_masked_staticEPS1_jjj","__ZN22address_space_specificIhL12endianness_t0ELb0EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t0ELb0EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEEC1EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEEC2EPS2_","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED1Ev","__ZN22address_space_specificIhL12endianness_t0ELb1EED1Ev","__ZN22address_space_specificIhL12endianness_t0ELb1EE23enable_read_watchpointsEb","__ZN22address_space_specificIhL12endianness_t0ELb1EE24enable_write_watchpointsEb","__ZN22address_space_specificIhL12endianness_t0ELb1EE12get_read_ptrEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE13get_write_ptrEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE9read_byteEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE9read_wordEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE9read_wordEjt","__ZN22address_space_specificIhL12endianness_t0ELb1EE19read_word_unalignedEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE19read_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_dwordEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_dwordEjj","__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_dword_unalignedEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_qwordEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE10read_qwordEjy","__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_qword_unalignedEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE20read_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t0ELb1EE10write_byteEjh","__ZN22address_space_specificIhL12endianness_t0ELb1EE10write_wordEjt","__ZN22address_space_specificIhL12endianness_t0ELb1EE10write_wordEjtt","__ZN22address_space_specificIhL12endianness_t0ELb1EE20write_word_unalignedEjt","__ZN22address_space_specificIhL12endianness_t0ELb1EE20write_word_unalignedEjtt","__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_dwordEjj","__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_dwordEjjj","__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_dword_unalignedEjj","__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_dword_unalignedEjjj","__ZN22address_space_specificIhL12endianness_t0ELb0EED2Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED0Ev","__ZN20resource_pool_objectI22address_space_specificIhL12endianness_t0ELb1EEED2Ev","__ZN22address_space_specificIhL12endianness_t0ELb1EEC2ER23device_memory_interface16address_spacenum","__ZN22address_space_specificIhL12endianness_t0ELb1EED0Ev","__ZN22address_space_specificIhL12endianness_t0ELb1EE4readEv","__ZN22address_space_specificIhL12endianness_t0ELb1EE5writeEv","__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_qwordEjy","__ZN22address_space_specificIhL12endianness_t0ELb1EE11write_qwordEjyy","__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_qword_unalignedEjy","__ZN22address_space_specificIhL12endianness_t0ELb1EE21write_qword_unalignedEjyy","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjhh","__ZNK22address_space_specificIhL12endianness_t0ELb1EE12write_lookupEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIyLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directIjLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb0EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_directItLb1EEEvjT_S3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE12write_nativeEjh","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEjh","__ZNK22address_space_specificIhL12endianness_t0ELb1EE11read_lookupEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIyLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directIjLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb0EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_directItLb1EEET_jS3_","__ZN22address_space_specificIhL12endianness_t0ELb1EE11read_nativeEj","__ZN22address_space_specificIhL12endianness_t0ELb1EE16read_byte_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb1EE16read_word_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb1EE23read_word_masked_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t0ELb1EE17read_dword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb1EE24read_dword_masked_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t0ELb1EE17read_qword_staticEPS1_j","__ZN22address_space_specificIhL12endianness_t0ELb1EE24read_qword_masked_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t0ELb1EE17write_byte_staticEPS1_jh","__ZN22address_space_specificIhL12endianness_t0ELb1EE17write_word_staticEPS1_jt","__ZN22address_space_specificIhL12endianness_t0ELb1EE24write_word_masked_staticEPS1_jtt","__ZN22address_space_specificIhL12endianness_t0ELb1EE18write_dword_staticEPS1_jj","__ZN22address_space_specificIhL12endianness_t0ELb1EE25write_dword_masked_staticEPS1_jjj","__ZL11tagmap_hashPKc3112","__ZN22address_space_specificIhL12endianness_t0ELb1EE18write_qword_staticEPS1_jy","__ZN22address_space_specificIhL12endianness_t0ELb1EE25write_qword_masked_staticEPS1_jyy","__ZN20resource_pool_objectI16direct_read_dataEC1EPS0_","__ZN20resource_pool_objectI16direct_read_dataEC2EPS0_","__ZN20resource_pool_objectI16direct_read_dataED1Ev","__ZL11tagmap_findPK7_tagmapPKc3110","__ZL21tagmap_find_prehashedPK7_tagmapPKcj3111","__ZL21tagmap_find_hash_onlyPK7_tagmapPKc3113","__ZNK8device_t4nextI23device_memory_interfaceEEbRPT_","__ZN20resource_pool_objectI15_memory_privateEC1EPS0_","__ZN20resource_pool_objectI15_memory_privateEC2EPS0_","__ZN20resource_pool_objectI15_memory_privateED1Ev","__ZN15_memory_privateD1Ev","__ZN8tagmap_tIP12memory_shareED1Ev","__ZN22address_space_specificIhL12endianness_t0ELb1EED2Ev","__ZN20resource_pool_objectI16direct_read_dataED0Ev","__ZN20resource_pool_objectI16direct_read_dataED2Ev","__ZN20resource_pool_objectI15_memory_privateED0Ev","__ZN20resource_pool_objectI15_memory_privateED2Ev","__ZN15_memory_privateD2Ev","__ZN11simple_listI13address_spaceE6detachERS0_","__ZN11simple_listI12memory_blockE6detachERS0_","__ZN11simple_listI11memory_bankE6detachERS0_","__ZN11memory_bank14bank_referenceC2ER13address_space13read_or_write","__ZNK11simple_listI13memory_regionE5firstEv","__ZN16direct_read_data12direct_rangeC2Ev","__ZN8tagmap_tIP11memory_bankED1Ev","__ZN11simple_listI11memory_bankED1Ev","__ZN11simple_listI12memory_blockED1Ev","__ZN11simple_listI13address_spaceED1Ev","__ZN11simple_listI13address_spaceED2Ev","__ZN11simple_listI13address_spaceE5resetEv","__ZN11simple_listI13address_spaceE6removeERS0_","__ZN11simple_listI12memory_blockED2Ev","__ZN11simple_listI12memory_blockE5resetEv","__ZN11simple_listI12memory_blockE6removeERS0_","__ZN11simple_listI11memory_bankED2Ev","__ZN11simple_listI11memory_bankE5resetEv","__ZN11simple_listI11memory_bankE6removeERS0_","__ZN8tagmap_tIP11memory_bankED2Ev","__ZN8tagmap_tIP11memory_bankE5resetEv","__ZN8tagmap_tIP12memory_shareED2Ev","__ZN8tagmap_tIP12memory_shareE5resetEv","__ZN19handler_entry_writeD2Ev","__ZN18handler_entry_readD2Ev","__ZNK11tagged_listI13memory_regionE5firstEv","__ZN19handler_entry_write14access_handlerC1Ev","__ZN19handler_entry_write14access_handlerC2Ev","__ZN11simple_listI13address_spaceED0Ev","__ZN11simple_listI12memory_blockED0Ev","__ZN11simple_listI11memory_bankED0Ev","__ZN19handler_entry_writeC2Eh12endianness_tPPh","__ZN13handler_entry11deconfigureEv","__ZN12_GLOBAL__N_18subrangeC2Ejj","__ZN13address_table13subtable_dataC2Ev","__ZN18handler_entry_read14access_handlerC1Ev","__ZN18handler_entry_read14access_handlerC2Ev","__ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEED2Ev","__ZNSt3__13mapIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEENS_4lessIhEENS4_INS_4pairIKhS6_EEEEED2Ev","__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEED2Ev","__ZNSt3__14pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS3_EEEEED2Ev","__ZN19handler_entry_proxyI19handler_entry_writeED2Ev","__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED1Ev","__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev","__ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEED2Ev","__ZN18handler_entry_readC2Eh12endianness_tPPh","__ZNSt3__110__list_impIN12_GLOBAL__N_18subrangeENS_9allocatorIS2_EEE5clearEv","__ZNSt3__16__treeINS_4pairIhNS_4listIN12_GLOBAL__N_18subrangeENS_9allocatorIS4_EEEEEENS_19__map_value_compareIhS7_NS_4lessIhEELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE","__ZNSt3__110__list_impIP19handler_entry_writeNS_9allocatorIS2_EEE5clearEv","__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEE9push_backERKS2_","__ZN19handler_entry_proxyI19handler_entry_writeEC1ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy","__ZNSt3__14listIjNS_9allocatorIjEEED1Ev","__ZNSt3__14listIjNS_9allocatorIjEEED2Ev","__ZNSt3__110__list_impIjNS_9allocatorIjEEED2Ev","__ZN19handler_entry_proxyI19handler_entry_writeEC2ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy","__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC1ERKS5_","__ZNSt3__110__list_impIjNS_9allocatorIjEEE5clearEv","__ZNSt3__14listIP19handler_entry_writeNS_9allocatorIS2_EEEC2ERKS5_","__ZN19handler_entry_proxyI18handler_entry_readED2Ev","__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED1Ev","__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEED2Ev","__ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEED2Ev","__ZNSt3__110__list_impIP18handler_entry_readNS_9allocatorIS2_EEE5clearEv","__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEE9push_backERKS2_","__ZN12memory_shareC2EjPv","__ZN11simple_listI11memory_bankEC2ER13resource_pool","__ZN11simple_listI12memory_blockEC2ER13resource_pool","__ZN11simple_listI13address_spaceEC2ER13resource_pool","__ZN19handler_entry_proxyI18handler_entry_readEC1ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy","__ZN19handler_entry_proxyI18handler_entry_readEC2ERKNSt3__14listIPS0_NS2_9allocatorIS4_EEEEy","__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC1ERKS5_","__ZN11simple_listI13address_spaceEC1ER13resource_pool","__ZN11simple_listI12memory_blockEC1ER13resource_pool","__ZN11simple_listI11memory_bankEC1ER13resource_pool","__ZN8tagmap_tIP11memory_bankEC1Ev","__ZN8tagmap_tIP12memory_shareEC1Ev","__ZN8tagmap_tIP12memory_shareEC2Ev","__ZN8tagmap_tIP11memory_bankEC2Ev","__ZNSt3__14listIP18handler_entry_readNS_9allocatorIS2_EEEC2ERKS5_","__ZN15_memory_privateC2Ev","__ZThn356_N10cpu_deviceD0Ev","__ZThn5968_N10cpu_deviceD0Ev","__ZThn6012_N10cpu_deviceD0Ev","__ZThn7088_N10cpu_deviceD0Ev","__ZThn356_N10cpu_deviceD1Ev","__ZThn5968_N10cpu_deviceD1Ev","__ZThn6012_N10cpu_deviceD1Ev","__ZThn7088_N10cpu_deviceD1Ev","__ZN10cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S6_S4_j","__ZN10cpu_deviceD0Ev","__ZN10cpu_deviceD2Ev","__ZNK17legacy_cpu_device14get_legacy_fctEj","__ZNK17legacy_cpu_device14get_legacy_intEj","__ZNK17legacy_cpu_device17get_legacy_stringEj","__ZThn356_N17legacy_cpu_deviceD0Ev","__ZThn5968_N17legacy_cpu_deviceD0Ev","__ZThn6012_N17legacy_cpu_deviceD0Ev","__ZThn7088_N17legacy_cpu_deviceD0Ev","__ZThn356_N17legacy_cpu_deviceD1Ev","__ZThn5968_N17legacy_cpu_deviceD1Ev","__ZThn6012_N17legacy_cpu_deviceD1Ev","__ZThn7088_N17legacy_cpu_deviceD1Ev","__ZN17legacy_cpu_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPS_jP7cpuinfoE","__ZN17legacy_cpu_deviceD0Ev","__ZN17legacy_cpu_deviceD2Ev","__ZNK11simple_listI18device_state_entryE5countEv","__ZN22device_state_interface9state_addIyEER18device_state_entryiPKcRT_","__ZNK17legacy_cpu_device14get_legacy_ptrEj","__ZN17legacy_cpu_device12device_resetEv","__ZN17legacy_cpu_device11device_stopEv","__ZNK17legacy_cpu_device24execute_clocks_to_cyclesEy","__ZThn356_NK17legacy_cpu_device24execute_clocks_to_cyclesEy","__ZNK17legacy_cpu_device24execute_cycles_to_clocksEy","__ZThn356_NK17legacy_cpu_device24execute_cycles_to_clocksEy","__ZN17legacy_cpu_device11execute_runEv","__ZThn356_N17legacy_cpu_device11execute_runEv","__ZN17legacy_cpu_device12execute_burnEi","__ZThn356_N17legacy_cpu_device12execute_burnEi","__ZN17legacy_cpu_device16memory_translateE16address_spacenumiRj","__ZThn5968_N17legacy_cpu_device16memory_translateE16address_spacenumiRj","__ZN17legacy_cpu_device11memory_readE16address_spacenumjiRy","__ZThn5968_N17legacy_cpu_device11memory_readE16address_spacenumjiRy","__ZN17legacy_cpu_device12memory_writeE16address_spacenumjiy","__ZThn5968_N17legacy_cpu_device12memory_writeE16address_spacenumjiy","__ZN17legacy_cpu_device13memory_readopEjiRy","__ZThn5968_N17legacy_cpu_device13memory_readopEjiRy","__ZN17legacy_cpu_device18device_debug_setupEv","__ZN17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j","__ZNK23device_disasm_interface16min_opcode_bytesEv","__ZThn7088_N17legacy_cpu_device18disasm_disassembleEPcjPKhS2_j","__ZN17legacy_cpu_device14set_legacy_intEjx","__ZN17legacy_cpu_device12device_startEv","__ZN17legacy_cpu_device12state_importERK18device_state_entry","__ZThn6012_N17legacy_cpu_device12state_importERK18device_state_entry","__ZN17legacy_cpu_device12state_exportERK18device_state_entry","__ZThn6012_N17legacy_cpu_device12state_exportERK18device_state_entry","__ZN17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring","__ZThn6012_N17legacy_cpu_device19state_string_exportERK18device_state_entryR7astring","__ZN18device_state_entry16format_from_maskEv","__ZN18device_state_entryC2EiPKcPvh","__ZN18device_state_entry9formatstrEPKc","__ZNK18device_state_entry5valueEv","__ZNK18device_state_entry9set_valueEy","__ZN7astring3catEPKci","__ZN11simple_listI18device_state_entryEC1ER13resource_pool","__ZNK18device_state_entry6formatER7astringPKcb","__ZN22device_state_interfaceC2ERK14machine_configR8device_t","__ZN22device_state_interfaceD0Ev","__ZN22device_state_interface12state_importERK18device_state_entry","__ZN22device_state_interface12state_exportERK18device_state_entry","__ZN22device_state_interface19state_string_importERK18device_state_entryR7astring","__ZN22device_state_interface19state_string_exportERK18device_state_entryR7astring","__ZNK18device_state_entry12needs_exportEv","__ZNK18device_state_entry19needs_custom_stringEv","__ZNK18device_state_entry12needs_importEv","__ZN11simple_listI18device_state_entryE6appendERS0_","__ZN11simple_listI18device_state_entryED1Ev","__ZN22device_state_interface5stateEi","__ZN22device_state_interface16state_find_entryEi","__ZN22device_state_interface9set_stateEiy","__ZN20resource_pool_objectI18device_state_entryEC1EPS0_","__ZN20resource_pool_objectI18device_state_entryEC2EPS0_","__ZN20resource_pool_objectI18device_state_entryED1Ev","__ZN22device_state_interfaceD2Ev","__ZN22device_state_interface12state_stringEiR7astring","__ZN22device_state_interface23state_string_max_lengthEi","__ZN22device_state_interface9state_addEiPKcPvh","__ZN13resource_pool10add_objectI18device_state_entryEEPT_S3_","__ZN22device_state_interface20interface_post_startEv","__ZN11simple_listI18device_state_entryE6detachERS0_","__ZN11simple_listI18device_state_entryEC2ER13resource_pool","__ZN18device_state_entryD1Ev","__ZN11simple_listI18device_state_entryED2Ev","__ZN11simple_listI18device_state_entryE5resetEv","__ZN11simple_listI18device_state_entryE6removeERS0_","__ZN7astring3insEiPKci","__ZNK18legacy_device_base14get_legacy_intEj","__ZNK18legacy_device_base17get_legacy_stringEj","__ZN20resource_pool_objectI18device_state_entryED0Ev","__ZN20resource_pool_objectI18device_state_entryED2Ev","__ZN18device_state_entryD2Ev","__ZN11simple_listI18device_state_entryED0Ev","__ZN18legacy_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE","__Z8downcastIR18legacy_device_base8device_tET_RT0_","__ZNK18legacy_device_base14get_legacy_ptrEj","__ZNK18legacy_device_base14get_legacy_fctEj","__ZNK18legacy_device_base21device_validity_checkER11emu_optionsRK11game_driver","__ZN18legacy_device_base12device_startEv","__ZN18legacy_device_base12device_resetEv","__ZN18legacy_device_base11device_stopEv","__ZThn368_N24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i","__ZN24legacy_sound_device_baseD1Ev","__ZThn368_N24legacy_sound_device_baseD1Ev","__ZThn368_N24legacy_sound_device_baseD0Ev","__ZN24device_execute_interfaceD2Ev","__ZN18legacy_device_baseD0Ev","__ZN18legacy_device_baseD2Ev","__ZN18legacy_device_base19static_set_inline32ER8device_tjjj","__ZN24legacy_sound_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE","__ZN24legacy_sound_device_base19sound_stream_updateER12sound_streamPPiS3_i","__ZN24legacy_sound_device_baseD0Ev","__ZN24legacy_sound_device_baseD2Ev","__ZN24device_execute_interfaceC2ERK14machine_configR8device_t","__ZN24device_execute_interfaceD0Ev","__ZNK24device_execute_interface18execute_min_cyclesEv","__ZNK24device_execute_interface18execute_max_cyclesEv","__ZNK24device_execute_interface19execute_input_linesEv","__ZNK24device_execute_interface26execute_default_irq_vectorEv","__ZN24device_execute_interface12execute_burnEi","__ZN24device_execute_interface17execute_set_inputEii","__ZNK24device_execute_interface24execute_clocks_to_cyclesEy","__ZNK24device_execute_interface24execute_cycles_to_clocksEy","__ZNK24device_execute_interface8disabledEv","__ZNK24device_execute_interface9executingEv","__ZNK24device_execute_interface16cycles_remainingEv","__ZN24device_execute_interface10eat_cyclesEi","__ZN24device_execute_interface15abort_timesliceEv","__ZN24device_execute_interface7suspendEjb","__ZN24device_execute_interface6resumeEj","__ZN24device_execute_interface7triggerEi","__ZNK24device_execute_interface10local_timeEv","__ZNK24device_execute_interface18cycles_to_attotimeEy","__ZNK24device_execute_interface12total_cyclesEv","__ZNK24device_execute_interface24interface_validity_checkER11emu_optionsRK11game_driver","__ZN24device_execute_interface19interface_pre_startEv","__ZNK11tagged_listI8device_tE7indexofERKS0_","__ZN24device_execute_interface12device_input5startEPS_i","__ZN24device_execute_interface38static_trigger_partial_frame_interruptER15running_machinePvi","__ZN24device_execute_interface33static_trigger_periodic_interruptER15running_machinePvi","__ZN24device_execute_interface19interface_pre_resetEv","__ZN24device_execute_interface21static_set_vblank_intER8device_tPFvPS0_EPKci","__ZN24device_execute_interface20interface_post_startEv","__ZN24device_execute_interface9suspendedEj","__ZN24device_execute_interface20interface_post_resetEv","__ZN24device_execute_interface12device_input5resetEv","__ZN8delegateIFvR13screen_devicebEEC1I24device_execute_interfaceEEN15delegate_traitsIT_vS1_b8_noparamS8_E16member_func_typeEPKcPS7_","__ZN24device_execute_interface9on_vblankER13screen_deviceb","__ZN24device_execute_interface23interface_clock_changedEv","__ZNK24device_execute_interface16clocks_to_cyclesEy","__ZN24device_execute_interface28static_standard_irq_callbackEP8device_ti","__ZN24device_execute_interface21standard_irq_callbackEi","__ZN24device_execute_interface12device_input20default_irq_callbackEv","__ZL23debugger_interrupt_hookP8device_ti","__ZNK24device_execute_interface15minimum_quantumEv","__ZNK24device_execute_interface10min_cyclesEv","__ZdvRK8attotimej","__ZN24device_execute_interface31trigger_partial_frame_interruptEv","__ZN24device_execute_interface26trigger_periodic_interruptEv","__ZN24device_execute_interface12device_inputC2Ev","__ZNK24device_execute_interface18default_irq_vectorEv","__ZN24device_execute_interface12device_input17empty_event_queueEv","__Z14device_executeP8device_t","__ZN24device_execute_interface12device_input16set_state_syncedEii","__ZL10mulu_32x32jj3374","__ZL9mul_32x32ii","__ZN21delegate_internal_mfpC2IM24device_execute_interfaceFvR13screen_devicebEEET_","__ZNK11simple_listI8device_tE7indexofERKS0_","__ZL14divu_64x32_remyjPj3373","__ZNK21delegate_internal_mfp18convert_to_genericERP22delegate_generic_class","__ZN24device_execute_interface12device_input24static_empty_event_queueER15running_machinePvi","__ZN24device_execute_interface24signal_interrupt_triggerEv","__ZN8delegateIFvR13screen_devicebEEC2I24device_execute_interfaceEEN15delegate_traitsIT_vS1_b8_noparamS8_E16member_func_typeEPKcPS7_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I24device_execute_interfaceEEN15delegate_traitsIT_vS1_bS2_S2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM24device_execute_interfaceFvR13screen_devicebEEET_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI24device_execute_interfaceEEP22delegate_generic_classR18delegate_late_bind","__ZNK24device_execute_interface16cycles_to_clocksEy","___cxx_global_var_init3371","___cxx_global_var_init13372","__ZN8attotimemLEj","__ZN8attotimedVEj","__ZNK8attotime9as_stringEi","__GLOBAL__I_a3379","__ZL22machine_start____emptyR15running_machine","__ZL33construct_machine_config____emptyR14machine_configP8device_t","__ZNK13cheat_manager7machineEv","__ZN11simple_listIN15cheat_parameter4itemEE6appendERS1_","__ZN17number_and_formatcvRyEv","__ZNK15cheat_parameter4item5valueEv","__ZNK17number_and_formatcvRKyEv","__ZNK11simple_listIN15cheat_parameter4itemEE5firstEv","__ZNK15cheat_parameter4item4nextEv","__ZN17number_and_formatC1Eyi","__ZN11simple_listIN15cheat_parameter4itemEEC1ER13resource_pool","__ZN15cheat_parameter4itemC1EPKcyi","__ZN11simple_listIN15cheat_parameter4itemEED1Ev","__ZN15cheat_parameter4textEv","__ZNK15cheat_parameter12has_itemlistEv","__ZNK15cheat_parameter4item4textEv","__ZN15cheat_parameterC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node","__ZN13resource_pool10add_objectIN15cheat_parameter4itemEEEPT_S4_","__ZNK17number_and_format6formatER7astring","__ZN15cheat_parameter17set_minimum_stateEv","__ZN15cheat_parameter14set_prev_stateEv","__ZN15cheat_parameter14set_next_stateEv","__ZNK15cheat_parameter4saveER8emu_file","__ZN11simple_listIN12cheat_script12script_entryEE6appendERS1_","__ZNK13cheat_manager7enabledEv","__ZNK11simple_listIN12cheat_script12script_entryEE5firstEv","__ZN11simple_listIN12cheat_script12script_entryEEC1ER13resource_pool","__ZN11simple_listIN12cheat_script12script_entryEED1Ev","__ZN12cheat_script7executeER13cheat_managerRy","__ZN12cheat_scriptC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node","__ZN13resource_pool10add_objectIN12cheat_script12script_entryEEEPT_S4_","__ZNK12cheat_script12script_entry4nextEv","__ZNK12cheat_script4saveER8emu_file","__ZN12cheat_script12script_entry7executeER13cheat_managerRy","__ZNK12cheat_script12script_entry4saveER8emu_file","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6appendERS2_","__ZNK12cheat_script12script_entry15output_argument5countEv","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEEC1ER13resource_pool","__ZN12cheat_script12script_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_nodeb","__ZN13resource_pool10add_objectIN12cheat_script12script_entry15output_argumentEEEPT_S5_","__ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5firstEv","__ZNK12cheat_script12script_entry15output_argument4nextEv","__ZN13cheat_manager18get_output_astringEii","__ZNK11simple_listIN12cheat_script12script_entry15output_argumentEE5countEv","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEED1Ev","__ZNK17parsed_expression15original_stringEv","__ZN13cheat_manager16quote_expressionER7astringRK17parsed_expression","__ZN12cheat_script12script_entry15validate_formatEPKci","__ZN12cheat_script12script_entry15output_argument6valuesERyPy","__ZNK12cheat_script12script_entry15output_argument4saveER8emu_file","__ZN12cheat_script12script_entry15output_argumentC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node","__ZN11cheat_entryC2ER13cheat_managerR12symbol_tablePKcR14_xml_data_node","__ZN13resource_pool10add_objectI15cheat_parameterEEPT_S3_","__ZN11cheat_entry16script_for_stateE12script_state","__ZNK12cheat_script5stateEv","__ZNK11cheat_entry4saveER8emu_file","__ZN11cheat_entry8activateEv","__ZNK11cheat_entry10is_oneshotEv","__ZN11cheat_entry17execute_on_scriptEv","__ZNK11cheat_entry20is_oneshot_parameterEv","__ZN11cheat_entry21execute_change_scriptEv","__ZN11cheat_entry20select_default_stateEv","__ZN11cheat_entry9set_stateE12script_state","__ZN11cheat_entry21select_previous_stateEv","__ZNK11cheat_entry8is_onoffEv","__ZNK15cheat_parameter10is_minimumEv","__ZN11cheat_entry17select_next_stateEv","__ZN13resource_pool10add_objectI12cheat_scriptEEPT_S3_","__ZN11cheat_entryD2Ev","__ZN13cheat_manager15execute_frombcdER12symbol_tablePviPKy","__ZN13cheat_manager13execute_tobcdER12symbol_tablePviPKy","__ZNK11simple_listI11cheat_entryE5firstEv","__ZNK11cheat_entry5stateEv","__ZNK11cheat_entry4nextEv","__ZN11cheat_entry9menu_textER7astringS1_Rj","__ZNK11cheat_entry12is_text_onlyEv","__ZNK15cheat_parameter10is_maximumEv","__ZN11cheat_entry18execute_off_scriptEv","__ZN11simple_listI11cheat_entryEC1ER13resource_pool","__ZNK11emu_options5cheatEv","__ZN8delegateIFvvEEC1I13cheat_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13cheat_manager12frame_updateEv","__ZN13cheat_manager10set_enableEb","__ZNK11device_list5firstI22device_image_interfaceEEbRPT_","__ZN13cheat_managerC2ER15running_machine","__ZN13cheat_manager6reloadEv","__ZNK11simple_listI11cheat_entryE5countEv","__ZN11simple_listI11cheat_entryE6appendERS0_","__ZNK16device_interface4nextI22device_image_interfaceEEbRPT_","__ZNK11emu_options10cheat_pathEv","__ZN13cheat_manager11render_textER16render_container","__ZN7astring7replaceEiPKcS1_","__ZN11cheat_entry12frame_updateEv","__ZNK8emu_file8fullpathEv","__ZN20resource_pool_objectI11cheat_entryEC1EPS0_","__ZN13cheat_manager11load_cheatsEPKc","__ZN13cheat_manager8save_allEPKc","__ZN13resource_pool10add_objectI11cheat_entryEEPT_S3_","__ZN21delegate_internal_mfpC2IM13cheat_managerFvvEEET_","__ZN11simple_listI11cheat_entryEC2ER13resource_pool","__ZN20resource_pool_objectI11cheat_entryEC2EPS0_","__ZN20resource_pool_objectI11cheat_entryED1Ev","__ZNK8device_t4nextI22device_image_interfaceEEbRPT_","__ZN8device_t9interfaceI22device_image_interfaceEEbRPT_","__ZN8delegateIFvvEEC2I13cheat_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13cheat_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM13cheat_managerFvvEEET_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13cheat_managerEEP22delegate_generic_classR18delegate_late_bind","__ZN20resource_pool_objectI12cheat_scriptEC1EPS0_","__ZN20resource_pool_objectI12cheat_scriptEC2EPS0_","__ZN20resource_pool_objectI12cheat_scriptED1Ev","__ZN12cheat_scriptD1Ev","__ZN12cheat_scriptD2Ev","__ZN20resource_pool_objectI15cheat_parameterEC1EPS0_","__ZN20resource_pool_objectI15cheat_parameterEC2EPS0_","__ZN20resource_pool_objectI15cheat_parameterED1Ev","__ZN20resource_pool_objectI11cheat_entryED0Ev","__ZN20resource_pool_objectI11cheat_entryED2Ev","__ZN20resource_pool_objectI12cheat_scriptED0Ev","__ZN20resource_pool_objectI12cheat_scriptED2Ev","__ZN20resource_pool_objectI15cheat_parameterED0Ev","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6detachERS2_","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEEC2ER13resource_pool","__ZN15cheat_parameterD1Ev","__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEEC1EPS2_","__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEEC2EPS2_","__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED1Ev","__ZN12cheat_script12script_entry15output_argumentD1Ev","__ZN12cheat_script12script_entry15output_argumentD2Ev","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEED2Ev","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEE5resetEv","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEE6removeERS2_","__ZN20resource_pool_objectIN12cheat_script12script_entryEEC1EPS1_","__ZN20resource_pool_objectIN12cheat_script12script_entryEEC2EPS1_","__ZN20resource_pool_objectIN12cheat_script12script_entryEED1Ev","__ZN20resource_pool_objectI15cheat_parameterED2Ev","__ZN15cheat_parameterD2Ev","__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED0Ev","__ZN20resource_pool_objectIN12cheat_script12script_entry15output_argumentEED2Ev","__ZN11simple_listIN12cheat_script12script_entry15output_argumentEED0Ev","__ZN20resource_pool_objectIN12cheat_script12script_entryEED0Ev","__ZN11simple_listIN12cheat_script12script_entryEE6detachERS1_","__ZN11simple_listIN12cheat_script12script_entryEEC2ER13resource_pool","__ZN12cheat_script12script_entryD1Ev","__ZN11simple_listIN12cheat_script12script_entryEED2Ev","__ZN11simple_listIN12cheat_script12script_entryEE5resetEv","__ZN11simple_listIN12cheat_script12script_entryEE6removeERS1_","__ZN20resource_pool_objectIN15cheat_parameter4itemEEC1EPS1_","__ZN20resource_pool_objectIN15cheat_parameter4itemEEC2EPS1_","__ZN20resource_pool_objectIN15cheat_parameter4itemEED1Ev","__ZN15cheat_parameter4itemD1Ev","__ZN15cheat_parameter4itemD2Ev","__ZN11simple_listIN15cheat_parameter4itemEED2Ev","__ZN11simple_listIN15cheat_parameter4itemEE5resetEv","__ZN11simple_listIN15cheat_parameter4itemEE6removeERS1_","__ZN20resource_pool_objectIN12cheat_script12script_entryEED2Ev","__ZN12cheat_script12script_entryD2Ev","__ZN11simple_listIN12cheat_script12script_entryEED0Ev","__ZN20resource_pool_objectIN15cheat_parameter4itemEED0Ev","__ZN20resource_pool_objectIN15cheat_parameter4itemEED2Ev","__ZN11simple_listIN15cheat_parameter4itemEED0Ev","__ZN11simple_listIN15cheat_parameter4itemEE6detachERS1_","__ZN11simple_listIN15cheat_parameter4itemEEC2ER13resource_pool","__ZNK11cheat_entry14has_run_scriptEv","__ZNK11cheat_entry14has_off_scriptEv","__ZNK11simple_listIN15cheat_parameter4itemEE5countEv","__ZNK11simple_listIN15cheat_parameter4itemEE4lastEv","__ZNK11cheat_entry13has_on_scriptEv","__ZNK11cheat_entry17has_change_scriptEv","__ZN17number_and_formatC2Eyi","__ZN11cheat_entry18execute_run_scriptEv","___cxx_global_var_init3571","__ZN15cheat_parameter4itemC2EPKcyi","__ZN12sound_streamC2ER8device_tiiiPvPFvPS0_PS_S2_PPiS6_iE","__ZNK11simple_listI12sound_streamE5countEv","__ZNK12sound_stream10input_gainEi","__ZNK12sound_stream18initial_input_gainEi","__ZNK12sound_stream6deviceEv","__ZN12sound_stream25device_stream_update_stubEP8device_tPS_PvPPiS5_i","__ZN8delegateIFvvEEC1I12sound_streamEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN12sound_stream8postloadEv","__ZN12save_manager9save_itemIsEEvPKcS2_iRT_S2_","__ZN12sound_stream26recompute_sample_rate_dataEv","__ZNK13sound_manager11last_updateEv","__ZNK12sound_stream10input_nameEiR7astring","__ZN13resource_pool9add_arrayIN12sound_stream12stream_inputEEEPT_S4_i","__ZN13resource_pool9add_arrayIPiEEPT_S3_i","__ZN13resource_pool9add_arrayIN12sound_stream13stream_outputEEEPT_S4_i","__ZNK12sound_stream11sample_rateEv","__ZNK13sound_manager18update_attosecondsEv","__ZN12sound_stream6updateEv","__ZN12sound_stream16generate_samplesEi","__ZN12sound_stream24output_since_last_updateEiRi","__ZN12sound_stream15set_sample_rateEi","__ZN12sound_stream14set_input_gainEif","__ZN12sound_stream22update_with_accountingEb","__ZN12sound_stream25apply_sample_rate_changesEv","__ZN12sound_stream9set_inputEiPS_if","__ZN12sound_stream25allocate_resample_buffersEv","__ZN12sound_stream12stream_inputC2Ev","__ZN12sound_stream13stream_outputC2Ev","__ZN12sound_stream23generate_resampled_dataERNS_12stream_inputEj","__ZN12sound_stream23allocate_output_buffersEv","__ZNK15running_machine11sample_rateEv","__ZN13sound_manager13update_staticER15running_machinePvi","__ZNK11emu_options5soundEv","__ZN11simple_listI12sound_streamEC1ER13resource_pool","__ZNK11emu_options9wav_writeEv","__ZNK11emu_options9avi_writeEv","__ZN8delegateIFviP14_xml_data_nodeEEC1I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_","__ZN13sound_manager11config_loadEiP14_xml_data_node","__ZN13sound_managerC2ER15running_machine","__ZN13resource_pool9add_arrayIsEEPT_S2_i","__Z8downcastIP14speaker_device8device_tET_PT0_","__ZN11simple_listI12sound_streamE6appendERS0_","__ZNK13sound_manager7machineEv","__ZN13sound_manager11config_saveEiP14_xml_data_node","__ZN8delegateIFvvEEC1I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13sound_manager5pauseEv","__ZN13sound_manager6resumeEv","__ZN13sound_manager5resetEv","__ZN13sound_manager15set_attenuationEi","__ZNK11emu_options6volumeEv","__ZN11simple_listI12sound_streamED1Ev","__ZNK13sound_manager21indexed_speaker_inputEiR13speaker_input","__ZNK14speaker_device12next_speakerEv","__ZN13sound_manager4muteEbh","__ZNK11device_list5firstI22device_sound_interfaceEEbRPT_","__ZN13sound_managerD2Ev","__ZN13sound_manager12stream_allocER8device_tiiiPvPFvPS0_P12sound_streamS2_PPiS7_iE","__ZN13resource_pool10add_objectI12sound_streamEEPT_S3_","__ZN21delegate_internal_mfpC2IM13sound_managerFvvEEET_","__ZN21delegate_internal_mfpC2IM13sound_managerFviP14_xml_data_nodeEEET_","__ZNK13video_manager12speed_factorEv","__ZNK11simple_listI12sound_streamE5firstEv","__ZNK12sound_stream4nextEv","__ZNK16device_interface4nextI22device_sound_interfaceEEbRPT_","__ZN13sound_manager6updateEv","__ZNK8device_t4nextI22device_sound_interfaceEEbRPT_","__ZN20resource_pool_objectI12sound_streamEC1EPS0_","__ZN20resource_pool_objectI12sound_streamEC2EPS0_","__ZN20resource_pool_objectI12sound_streamED1Ev","__ZN8delegateIFvvEEC2I13sound_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13sound_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM13sound_managerFvvEEET_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13sound_managerEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFviP14_xml_data_nodeEEC2I13sound_managerEEN15delegate_traitsIT_viS1_8_noparamS8_E16member_func_typeEPKcPS7_","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2I13sound_managerEEN15delegate_traitsIT_viS1_S2_S2_E16member_func_typeEPKcPS7_","__ZN21delegate_internal_mfpC1IM13sound_managerFviP14_xml_data_nodeEEET_","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_E16late_bind_helperI13sound_managerEEP22delegate_generic_classR18delegate_late_bind","__ZN19resource_pool_arrayIsEC1EPsi","__ZN19resource_pool_arrayIsEC2EPsi","__ZN19resource_pool_arrayIsED1Ev","__ZN20resource_pool_objectI12sound_streamED0Ev","__ZN20resource_pool_objectI12sound_streamED2Ev","__ZN19resource_pool_arrayIsED0Ev","__ZN19resource_pool_arrayIsED2Ev","__ZN21delegate_internal_mfpC2IM12sound_streamFvvEEET_","__ZN11simple_listI12sound_streamE6detachERS0_","__ZN11simple_listI12sound_streamEC2ER13resource_pool","__ZN11simple_listI12sound_streamED2Ev","__ZN11simple_listI12sound_streamE5resetEv","__ZN11simple_listI12sound_streamE6removeERS0_","__ZN8delegateIFvvEEC2I12sound_streamEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I12sound_streamEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM12sound_streamFvvEEET_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI12sound_streamEEP22delegate_generic_classR18delegate_late_bind","__ZN19resource_pool_arrayIN12sound_stream13stream_outputEEC1EPS1_i","__ZN19resource_pool_arrayIN12sound_stream13stream_outputEEC2EPS1_i","__ZN19resource_pool_arrayIN12sound_stream13stream_outputEED1Ev","__ZN19resource_pool_arrayIPiEC1EPS0_i","__ZN19resource_pool_arrayIPiEC2EPS0_i","__ZN19resource_pool_arrayIPiED1Ev","__ZN19resource_pool_arrayIN12sound_stream12stream_inputEEC1EPS1_i","__ZN19resource_pool_arrayIN12sound_stream12stream_inputEEC2EPS1_i","__ZN19resource_pool_arrayIN12sound_stream12stream_inputEED1Ev","__ZN11simple_listI12sound_streamED0Ev","__ZN19resource_pool_arrayIN12sound_stream13stream_outputEED0Ev","__ZN19resource_pool_arrayIN12sound_stream13stream_outputEED2Ev","__ZN19resource_pool_arrayIPiED0Ev","__ZN19resource_pool_arrayIPiED2Ev","__ZN19resource_pool_arrayIN12sound_stream12stream_inputEED0Ev","__GLOBAL__I_a3574","__Z8gfx_initR15running_machine","__ZN19resource_pool_arrayIN12sound_stream12stream_inputEED2Ev","__Z17gfx_element_allocR15running_machinePK11_gfx_layoutPKhjj","__ZNK11gfx_element7machineEv","__ZNK15running_machine12total_colorsEv","__ZN11gfx_elementC1ER15running_machine","__Z18gfx_element_decodePK11gfx_elementj","__ZL10decodecharPK11gfx_elementjPKh","__Z16gfx_element_freeP11gfx_element","__ZN13resource_pool6removeEPKv","__ZN13resource_pool10add_objectI11gfx_elementEEPT_S3_","__Z10copybitmapP8bitmap_tS0_iiiiPK10_rectangle","__Z11config_initR15running_machine","__ZL7readbitPKhj","__ZL13calc_penusagePK11gfx_elementj","__ZN11gfx_elementC2ER15running_machine","__ZN20resource_pool_objectI11gfx_elementEC1EPS0_","__ZN20resource_pool_objectI11gfx_elementEC2EPS0_","__ZN20resource_pool_objectI11gfx_elementED1Ev","__ZN12_config_typeC1Ev","__ZN8delegateIFviP14_xml_data_nodeEEaSERKS3_","__ZN20resource_pool_objectI11gfx_elementED0Ev","__ZN20resource_pool_objectI11gfx_elementED2Ev","__Z15config_registerR15running_machinePKc8delegateIFviP14_xml_data_nodeEES7_","__ZN13resource_pool10add_objectI12_config_typeEEPT_S3_","__ZNK11emu_options5ctrlrEv","__ZNK13delegate_baseIviP14_xml_data_node8_noparamS2_EclEiS1_","__ZNK11emu_options10ctrlr_pathEv","__ZL15config_load_xmlR15running_machineR8emu_filei","__ZNK11emu_options13cfg_directoryEv","__ZL15config_save_xmlR15running_machineR8emu_filei","__ZN20resource_pool_objectI12_config_typeEC1EPS0_","__ZN20resource_pool_objectI12_config_typeEC2EPS0_","__ZN20resource_pool_objectI12_config_typeED1Ev","__Z20config_load_settingsR15running_machine","__Z20config_save_settingsR15running_machine","__ZL15interrupt_resetR15running_machine","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EaSERKS3_","__ZN12_config_typeC2Ev","__ZN8delegateIFviP14_xml_data_nodeEEC1Ev","__ZN8delegateIFviP14_xml_data_nodeEEC2Ev","__ZN13delegate_baseIviP14_xml_data_node8_noparamS2_EC2Ev","__ZN12save_manager9save_itemIA8_jEEvRT_PKci","__ZN12save_manager9save_itemIA8_hEEvRT_PKci","__ZL13counters_loadR15running_machineiP14_xml_data_node","__ZL13counters_saveR15running_machineiP14_xml_data_node","__ZN12save_manager9save_itemIiEEvRT_PKci","__ZN20resource_pool_objectI12_config_typeED0Ev","__ZN20resource_pool_objectI12_config_typeED2Ev","__Z20generic_machine_initR15running_machine","__ZN13resource_pool10add_objectI24_generic_machine_privateEEPT_S3_","__Z21get_dispensed_ticketsR15running_machine","__Z22coin_counter_get_countR15running_machinei","__Z22coin_lockout_get_stateR15running_machinei","__ZNK11device_list5firstI22device_nvram_interfaceEEbRPT_","__ZNK11emu_options15nvram_directoryEv","__ZN22device_nvram_interface10nvram_loadER8emu_file","__ZNK16device_interface4nextI22device_nvram_interfaceEEbRPT_","__ZN22device_nvram_interface11nvram_resetEv","__ZN22device_nvram_interface10nvram_saveER8emu_file","__ZL12memcard_nameiPc","__ZNK11emu_options17memcard_directoryEv","__Z13memcard_ejectR15running_machine","__Z10nvram_loadR15running_machine","__Z10nvram_saveR15running_machine","__Z14memcard_createR15running_machineii","__Z14memcard_insertR15running_machinei","__Z15memcard_presentR15running_machine","__Z21device_set_input_lineP8device_tii","__ZNK8device_t4nextI22device_nvram_interfaceEEbRPT_","__ZN8device_t9interfaceI22device_nvram_interfaceEEbRPT_","__ZN12save_manager9save_itemIhLj8EEEvPKcS2_iRAT0__T_S2_","__ZN12save_manager9save_itemIjLj8EEEvPKcS2_iRAT0__T_S2_","__ZN20resource_pool_objectI24_generic_machine_privateEC1EPS0_","__ZN20resource_pool_objectI24_generic_machine_privateEC2EPS0_","__ZN20resource_pool_objectI24_generic_machine_privateED1Ev","__Z11output_initR15running_machine","__ZL12output_pauseR15running_machine","__ZL13output_resumeR15running_machine","__ZL11output_exitR15running_machine","__Z16output_set_valuePKci","__ZL9find_itemPKc","__Z16output_get_valuePKc","__ZL8get_hashPKc","__ZN20resource_pool_objectI24_generic_machine_privateED0Ev","__ZN20resource_pool_objectI24_generic_machine_privateED2Ev","__ZL15create_new_itemPKci","__ZN13resource_pool10add_objectI12_output_itemEEPT_S3_","__ZN20resource_pool_objectI12_output_itemEC1EPS0_","__ZN20resource_pool_objectI12_output_itemEC2EPS0_","__ZN20resource_pool_objectI12_output_itemED1Ev","__ZL12palette_exitR15running_machine","__ZL11copy_stringPKc","__ZN20resource_pool_objectI12_output_itemED0Ev","__ZN20resource_pool_objectI12_output_itemED2Ev","__Z12palette_initR15running_machine","__ZN13resource_pool10add_objectI16_palette_privateEEPT_S3_","__ZL16allocate_paletteR15running_machineP16_palette_private","__ZL21allocate_color_tablesR15running_machineP16_palette_private","__ZL22allocate_shadow_tablesR15running_machineP16_palette_private","__ZN13resource_pool9add_arrayIfEEPT_S2_i","__ZL7pal5bith3666","__ZL9rgb_clampi","__ZL12rgb_to_rgb15j3667","__ZL7pal1bith","__Z28colortable_palette_get_colorP12colortable_tj","__Z27colortable_palette_get_sizeP12colortable_t","__ZN12save_manager12save_pointerIjEEvPT_PKcji","__ZN12save_manager12save_pointerIfEEvPT_PKcji","__ZL15palette_presaveR15running_machine","__ZL16palette_postloadR15running_machine","__ZN12save_manager12save_pointerIfEEvPKcS2_iPT_S2_j","__ZN12save_manager12save_pointerIjEEvPKcS2_iPT_S2_j","__ZN19resource_pool_arrayIfEC1EPfi","__ZN19resource_pool_arrayIfEC2EPfi","__ZN19resource_pool_arrayIfED1Ev","__ZN20resource_pool_objectI16_palette_privateEC1EPS0_","__ZN20resource_pool_objectI16_palette_privateEC2EPS0_","__ZN20resource_pool_objectI16_palette_privateED1Ev","__ZL21configure_rgb_shadowsR15running_machineif","__ZL17image_fseek_thunkPvxi","__ZL17image_fread_thunkPvS_j","__ZL18image_fwrite_thunkPvPKvj","__ZL17image_fsize_thunkPv","__Z16image_unload_allR15running_machine","__ZN19resource_pool_arrayIfED0Ev","__ZN19resource_pool_arrayIfED2Ev","__ZN20resource_pool_objectI16_palette_privateED0Ev","__ZN20resource_pool_objectI16_palette_privateED2Ev","__ZN22device_image_interface14set_init_phaseEv","__Z10image_initR15running_machine","__ZL15image_dirs_loadR15running_machineiP14_xml_data_node","__ZL15image_dirs_saveR15running_machineiP14_xml_data_node","__Z18image_info_astringR15running_machineP7astring","__ZL15strip_extensionPKc","__ZN22device_image_interface8longnameEv","__ZN22device_image_interface12manufacturerEv","__ZL21image_options_extractR15running_machine","__Z17image_device_initR15running_machine","__Z19fatalerror_exitcodeR15running_machineiPKcz","__Z21image_postdevice_initR15running_machine","__ZN22device_image_interface9supportedEv","__ZL10stripspacePKc","__ZN22device_image_interface4yearEv","__Z32image_add_device_with_subdevicesP8device_tPFS0_RK14machine_configPKcS0_jES5_j","__ZN22device_image_interface21set_working_directoryEPKc","__ZN14emu_fatalerrorC1EiPKcPc","__ZN14emu_fatalerrorC2EiPKcPc","__ZNK11emu_options12write_configEv","__ZNK11emu_options8ini_pathEv","__ZN22device_image_interface6fwriteEPKvj","__ZL12tilemap_exitR15running_machine","__Z26image_battery_load_by_nameR11emu_optionsPKcPvii","__Z26image_battery_save_by_nameR11emu_optionsPKcPKvi","__ZL12write_configR11emu_optionsPKcPK11game_driver","__Z12tilemap_initR15running_machine","__ZNK9tilemap_t7machineEv","__ZL20gfx_elements_changedP9tilemap_t","__ZL25configure_blit_parametersP16_blit_parametersP9tilemap_tP8bitmap_tPK10_rectanglejhh","__Z13tilemap_countR15running_machine","__ZL15indexed_tilemapR15running_machinei","__ZL21tilemap_draw_instanceP9tilemap_tPK16_blit_parametersii","__Z21tilemap_size_by_indexR15running_machineiPjS1_","__Z21tilemap_draw_by_indexR15running_machineP8bitmap_tijj","__ZL15alpha_blend_r32jjh3730","__ZL15alpha_blend_r16jjh3731","__ZL26scanline_draw_masked_ind16PvPKtPKhiiiPKjPhjh","__ZL26scanline_draw_masked_rgb32PvPKtPKhiiiPKjPhjh","__ZL26scanline_draw_masked_rgb16PvPKtPKhiiiPKjPhjh","__ZL32scanline_draw_masked_rgb32_alphaPvPKtPKhiiiPKjPhjh","__ZL32scanline_draw_masked_rgb16_alphaPvPKtPKhiiiPKjPhjh","__ZL9tile_drawP9tilemap_tPKhjjjhhhh","__ZL18tile_apply_bitmaskP9tilemap_tPKhjjhh","__ZL25scanline_draw_masked_nullPvPKtPKhiiiPKjPhjh","__ZL25scanline_draw_opaque_nullPvPKtiPKjPhjh","__ZL11tile_updateP9tilemap_tjjj","__ZL26scanline_draw_opaque_rgb32PvPKtiPKjPhjh","__ZL26scanline_draw_opaque_rgb16PvPKtiPKjPhjh","__ZL32scanline_draw_opaque_rgb32_alphaPvPKtiPKjPhjh","__ZL32scanline_draw_opaque_rgb16_alphaPvPKtiPKjPhjh","__ZL26scanline_draw_opaque_ind16PvPKtiPKjPhjh","__ZL15tilemap_disposeP9tilemap_t","__Z12validate_tagRK11game_driverPKcS3_","__ZN8tagmap_tIPK11game_driverEC1Ev","__ZN8tagmap_tIjEC1Ev","__Z16validate_driversR11emu_optionsPK11game_driver","__ZL16validate_inlinesv","__ZL17get_profile_ticksv","__ZL28input_port_string_from_indexj","__ZN8tagmap_tIjE3addEPKcjb","__ZN12region_arrayC1Ev","__ZL15validate_driverR17driver_enumeratorR8tagmap_tIPK11game_driverES6_","__ZL13validate_romsR17driver_enumeratorP12region_arrayR8tagmap_tIPK11game_driverE","__ZL16validate_displayR17driver_enumerator","__ZL15validate_inputsR17driver_enumeratorR8tagmap_tIjER11tagged_listI17input_port_configE","__ZL12validate_gfxR17driver_enumeratorP12region_array","__ZL16validate_devicesR17driver_enumeratorRK11tagged_listI17input_port_configEP12region_array","__ZN12region_arrayD1Ev","__ZN8tagmap_tIjED1Ev","__ZN8tagmap_tIPK11game_driverED1Ev","__ZN8tagmap_tIjED2Ev","__ZN8tagmap_tIjE5resetEv","__ZN8tagmap_tIjEC2Ev","__ZN8tagmap_tIPK11game_driverED2Ev","__ZN8tagmap_tIPK11game_driverE5resetEv","__ZN8tagmap_tIPK11game_driverEC2Ev","__ZN12region_entryD1Ev","__ZN12region_entryD2Ev","__ZNK8device_t10rom_regionEv","__ZNK8device_t9shortnameEv","__ZN12region_arrayD2Ev","__ZN11driver_list5totalEv","__ZL11tagmap_hashPKc3840","__ZL27validate_analog_input_fieldP18input_field_configRK11game_driverPb","__ZL21validate_dip_settingsP18input_field_configRK11game_driverR8tagmap_tIjEPb","__ZL16get_defstr_indexR8tagmap_tIjEPKcRK11game_driverPb","__ZNK8tagmap_tIjE4findEPKc","__ZL11tagmap_findPK7_tagmapPKc3838","__ZL21tagmap_find_prehashedPK7_tagmapPKcj3839","__ZN8tagmap_tIPK11game_driverE3addEPKcS2_b","__ZNK8tagmap_tIPK11game_driverE4findEPKc","__ZN11driver_list14non_bios_cloneEi","__ZN11driver_list15compatible_withERK11game_driver","__ZL17atomic_exchange32PVii","__ZL9mul_32x32ii3841","__ZL10mulu_32x32jj3842","__ZL12mul_32x32_hiii","__ZL13mulu_32x32_hijj","__ZL15mul_32x32_shiftiih","__ZL16mulu_32x32_shiftjjh","__ZL15div_32x32_shiftiih","__ZL16divu_32x32_shiftjjh","__ZL12recip_approxf","__ZL19count_leading_zerosj","__ZL18count_leading_onesj","__ZL18compare_exchange32PViii","__ZL12atomic_add32PVii","__ZL9div_64x32xi","__ZL10divu_64x32yj3843","__ZL13div_64x32_remxiPi","__ZL14divu_64x32_remyjPj3844","__ZL9mod_64x32xi","__ZL10modu_64x32yj","__ZNK11device_list5firstIK22device_sound_interfaceEEbRPT_","__ZN8device_t9interfaceIK22device_sound_interfaceEEbRPT_","__ZN12region_entryC1Ev","__ZN12region_entryC2Ev","__ZL18atomic_increment32PVi","__ZL18atomic_decrement32PVi","__ZL13debugger_exitR15running_machine","__ZN12region_arrayC2Ev","__Z13debugger_initR15running_machine","__ZN13resource_pool10add_objectI18debug_view_managerEEPT_S3_","__Z42debugger_flush_all_traces_on_abnormal_exitv","__Z24debugger_refresh_displayR15running_machine","__ZN20resource_pool_objectI14_machine_entryEC1EPS0_","__ZN20resource_pool_objectI14_machine_entryEC2EPS0_","__ZN20resource_pool_objectI14_machine_entryED1Ev","__ZN20resource_pool_objectI18debug_view_managerEC1EPS0_","__ZN20resource_pool_objectI18debug_view_managerEC2EPS0_","__ZN20resource_pool_objectI18debug_view_managerED1Ev","__ZNK11emu_options10media_pathEv","__ZN13resource_pool10add_objectI14_machine_entryEEPT_S3_","__ZN20resource_pool_objectI14_machine_entryED0Ev","__ZN20resource_pool_objectI14_machine_entryED2Ev","__ZN20resource_pool_objectI18debug_view_managerED0Ev","__ZN20resource_pool_objectI18debug_view_managerED2Ev","__Z19common_process_fileR11emu_optionsPKcS2_PK9rom_entryPP8emu_file","__Z15rom_next_regionPK9rom_entry","__Z14rom_first_filePK9rom_entry","__Z13rom_next_filePK9rom_entry","__Z13rom_file_sizePK9rom_entry","__Z15get_disk_handleR15running_machinePKc","__Z16rom_first_sourceRK14machine_config","__Z15rom_next_sourceRK8device_t","__Z16rom_first_regionRK8device_t","__Z15rom_region_nameR7astringPK11game_driverPK8device_tPK9rom_entry","__Z19common_process_fileR11emu_optionsPKcbjPK9rom_entryPP8emu_file","__ZL15add_disk_handleR15running_machineP9_open_chd","__Z15open_disk_imageR11emu_optionsPK11game_driverPK9rom_entryPP8emu_filePP9_chd_filePKc","__ZNK16_romload_private7machineEv","__ZL26normalize_flags_for_deviceR15running_machinePKcRhR12endianness_t","__ZNK13memory_region4nameEv","__Z25load_software_part_regionP8device_tPcS1_P9rom_entry","__ZL19region_post_processP16_romload_privatePKcb","__ZL19process_rom_entriesP16_romload_privatePKcPK9rom_entry","__ZL20process_disk_entriesP16_romload_privatePKcPK9rom_entryS2_","__ZN16_romload_privateC1Ev","__ZL8rom_exitR15running_machine","__ZL18determine_bios_romP16_romload_private","__ZL10count_romsP16_romload_private","__ZL24display_rom_load_resultsP16_romload_private","__Z8rom_initR15running_machine","__ZN13resource_pool10add_objectI16_romload_privateEEPT_S3_","__Z17rom_load_warningsR15running_machine","__Z17rom_load_knownbadR15running_machine","__ZN20resource_pool_objectI16_romload_privateEC1EPS0_","__ZN20resource_pool_objectI16_romload_privateEC2EPS0_","__ZN20resource_pool_objectI16_romload_privateED1Ev","__ZN16_romload_privateD1Ev","__ZN16_romload_privateD2Ev","__ZNK11emu_options4biosEv","__ZN16_romload_privateC2Ev","__ZL27display_loading_rom_messageP16_romload_privatePKc","__ZNK15hash_collectionneERKS_","__ZL19process_region_listP16_romload_private","__ZN20resource_pool_objectI16_romload_privateED0Ev","__ZN20resource_pool_objectI16_romload_privateED2Ev","__ZL32dump_wrong_and_correct_checksumsP16_romload_privateRK15hash_collectionS3_","__ZN8emu_file13set_openflagsEj","__ZNK9hash_base11parse_errorEv","__ZNK11emu_options14diff_directoryEv","__ZL14open_disk_diffR11emu_optionsPK9rom_entryP9_chd_filePP8emu_filePS5_","__ZL13fill_rom_dataP16_romload_privatePK9rom_entry","__ZL13copy_rom_dataP16_romload_privatePK9rom_entry","__ZL13open_rom_fileP16_romload_privatePKcPK9rom_entry","__ZL19handle_missing_fileP16_romload_privatePK9rom_entry","__ZL9rom_freadP16_romload_privatePhi","__ZL11fill_randomR15running_machinePhj","__ZL13read_rom_dataP16_romload_privatePK9rom_entry","__ZL22verify_length_and_hashP16_romload_privatePKcjRK15hash_collection","__Z14ui_input_resetR15running_machine","__Z19ui_input_find_mouseR15running_machinePiS1_S1_","__ZN20resource_pool_objectI9_open_chdEC1EPS0_","__ZN20resource_pool_objectI9_open_chdEC2EPS0_","__ZN20resource_pool_objectI9_open_chdED1Ev","__Z21ui_input_frame_updateR15running_machine","__Z18ui_input_pop_eventR15running_machineP9_ui_event","__Z16ui_input_pressedR15running_machinei","__Z23ui_input_pressed_repeatR15running_machineii","__ZN20resource_pool_objectI17_ui_input_privateEC1EPS0_","__ZN20resource_pool_objectI17_ui_input_privateEC2EPS0_","__ZN20resource_pool_objectI17_ui_input_privateED1Ev","__ZN13resource_pool10add_objectI9_open_chdEEPT_S3_","__ZN20resource_pool_objectI9_open_chdED0Ev","__ZN20resource_pool_objectI9_open_chdED2Ev","__Z13ui_input_initR15running_machine","__ZN13resource_pool10add_objectI17_ui_input_privateEEPT_S3_","__ZL14ui_set_handlerPFjR15running_machineP16render_containerjEj","___cxx_global_var_init4019","__Z7ui_initR15running_machine","__ZL7ui_exitR15running_machine","__ZL18handler_messageboxR15running_machineP16render_containerj","__ZNK11emu_options16natural_keyboardEv","__Z26ui_display_startup_screensR15running_machineii","__ZNK11emu_options14seconds_to_runEv","__ZNK11emu_options13skip_gameinfoEv","__ZN20resource_pool_objectI17_ui_input_privateED0Ev","__ZN20resource_pool_objectI17_ui_input_privateED2Ev","__ZL11slider_initR15running_machine","__ZL17disclaimer_stringR15running_machineR7astring","__ZL21handler_messagebox_okR15running_machineP16render_containerj","__ZL14handler_ingameR15running_machineP16render_containerj","__Z17game_info_astringR15running_machineR7astring","__ZL25handler_messagebox_anykeyR15running_machineP16render_containerj","__Z19ui_set_startup_textR15running_machinePKci","__ZL15warnings_stringR15running_machineR7astring","__ZNK15running_machine5cheatEv","__ZNK11render_font12pixel_heightEv","__Z20ui_update_and_renderR15running_machineP16render_container","__ZNK11emu_options16pause_brightnessEv","__ZN16render_container8add_rectEffffjj","__Z16ui_draw_text_boxP16render_containerPKciffj","__Z11ui_get_fontR15running_machine","__ZNK11emu_options7ui_fontEv","__Z18ui_get_line_heightR15running_machine","__Z17ui_get_char_widthR15running_machinej","__Z19ui_get_string_widthR15running_machinePKc","__Z20ui_draw_outlined_boxP16render_containerffffj","__Z20ui_get_show_profilerv","__Z18ui_get_slider_listv","__Z27ui_get_use_natural_keyboardR15running_machine","__ZL17is_breakable_charj","__ZN20dummy_profiler_state6enableEb","__Z17ui_is_menu_activev","__ZNK16render_container7managerEv","__Z15ui_set_show_fpsi","__Z15ui_get_show_fpsv","__Z17ui_draw_text_fullP16render_containerPKcfffiiijjPfS3_","__Z13ui_popup_timeiPKcz","__Z16ui_show_fps_tempd","__Z20ui_set_show_profileri","__Z12ui_show_menuv","__ZL22slider_get_screen_descR13screen_device","__Z8ui_pasteR15running_machine","__Z23ui_image_handler_ingameR15running_machine","__ZNK13screen_device6xscaleEv","__ZNK13screen_device6yscaleEv","__ZNK13screen_device7xoffsetEv","__ZNK13screen_device7yoffsetEv","__ZL13slider_volumeR15running_machinePvP7astringi","__ZL15slider_mixervolR15running_machinePvP7astringi","__ZL15slider_adjusterR15running_machinePvP7astringi","__ZL16slider_overclockR15running_machinePvP7astringi","__ZL14slider_refreshR15running_machinePvP7astringi","__ZL17slider_brightnessR15running_machinePvP7astringi","__ZL15slider_contrastR15running_machinePvP7astringi","__ZL12slider_gammaR15running_machinePvP7astringi","__ZL13slider_xscaleR15running_machinePvP7astringi","__ZL14slider_xoffsetR15running_machinePvP7astringi","__ZL13slider_yscaleR15running_machinePvP7astringi","__ZL14slider_yoffsetR15running_machinePvP7astringi","__ZL25slider_get_laserdisc_descP8device_t","__Z27ui_set_use_natural_keyboardR15running_machinei","__ZL12slider_allocR15running_machinePKciiiiPFiS0_PvP7astringiES3_","__ZNK13screen_device19refresh_attosecondsEv","__ZNK8device_t11clock_scaleEv","__ZNK13sound_manager11attenuationEv","__ZNK15running_machine9ui_activeEv","__ZN15running_machine13set_ui_activeEb","__ZNK13video_manager12is_recordingEv","__ZNK13video_manager9frameskipEv","__ZN13video_manager13set_throttledEb","__ZNK13video_manager9throttledEv","__ZN13video_manager15set_fastforwardEb","__ZL17slider_overxscaleR15running_machinePvP7astringi","__ZL18slider_overxoffsetR15running_machinePvP7astringi","__ZL17slider_overyscaleR15running_machinePvP7astringi","__ZL18slider_overyoffsetR15running_machinePvP7astringi","__ZL14slider_flickerR15running_machinePvP7astringi","__ZL11slider_beamR15running_machinePvP7astringi","__ZN20dummy_profiler_state4textER15running_machineR7astring","__ZL24process_natural_keyboardR15running_machine","__ZNK11emu_options12confirm_quitEv","__ZL17handler_load_saveR15running_machineP16render_containerj","__GLOBAL__I_a4036","__Z13watchdog_initR15running_machine","__ZL17watchdog_callbackR15running_machinePvi","__ZL23watchdog_internal_resetR15running_machine","__ZN12save_manager9save_itemIhEEvRT_PKci","__ZL20handler_confirm_quitR15running_machineP16render_containerj","__Z14watchdog_resetR15running_machine","__ZL9on_vblankR15running_machineR13screen_deviceb4048","__Z14crosshair_initR15running_machine","__ZL14crosshair_exitR15running_machine","__ZL14crosshair_loadR15running_machineiP14_xml_data_node","__ZL13create_bitmapR15running_machinei","__Z19crosshair_get_usageR15running_machine","__Z20multicart_error_text21_multicart_open_error","__ZL14crosshair_saveR15running_machineiP14_xml_data_node","__ZL7animateR15running_machineR13screen_deviceb","__Z27crosshair_get_user_settingsR15running_machinehP24_crosshair_user_settings","__Z27crosshair_set_user_settingsR15running_machinehP24_crosshair_user_settings","__Z16crosshair_renderR13screen_device","__ZNK11emu_options14crosshair_pathEv","__Z14multicart_openR11emu_optionsPKcS2_21_multicart_load_flagsPP12_multicart_t","__ZL9find_fileP9_zip_filePKc","__ZL27find_pcb_and_resource_nodesP14_xml_data_nodePS0_S1_","__ZL18load_all_resourcesR11emu_optionsP21_multicart_load_state","__ZL16load_all_socketsP21_multicart_load_state","__Z15multicart_closeR11emu_optionsP12_multicart_t","__ZL18save_ram_resourcesR11emu_optionsP12_multicart_t","__ZL11load_socketP21_multicart_load_stateP14_xml_data_node","__ZL17get_resource_typePKc","__ZL13load_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_node24_multicart_resource_type","__ZL17load_rom_resourceP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource","__ZL28resample_argb_bitmap_averagePjjjjPKjjjjPK12render_colorjj","__ZL18astring_assemble_3P7astringPKcS2_S2_4092","__ZL12astring_catcP7astringPKc4093","__ZL18astring_assemble_2P7astringPKcS2_4094","__ZL13find_file_crcP9_zip_filePKcj","__Z30render_resample_argb_bitmap_hqPvjjjPK8bitmap_tPK10_rectanglePK12render_color","__ZL17load_ram_resourceR11emu_optionsP21_multicart_load_stateP14_xml_data_nodeP19_multicart_resource","__ZL29resample_argb_bitmap_bilinearPjjjjPKjjjjPK12render_colorjj","__Z16render_clip_lineP13render_boundsPKS_","__Z16render_clip_quadP13render_boundsPKS_P17render_quad_texuv","__Z15render_load_pngR8emu_filePKcS2_P8bitmap_tPb","__ZL18copy_png_to_bitmapP8bitmap_tPK9_png_infoPb","__ZL18compute_brightnessj","__ZL24copy_png_alpha_to_bitmapP8bitmap_tPK9_png_infoPb","__ZN12save_manager9save_itemIA4_tEEvRT_PKci","__ZN12save_manager9save_itemIA4_hEEvRT_PKci","__ZN12save_manager9save_itemItLj4EEEvPKcS2_iRAT0__T_S2_","__ZN20resource_pool_objectI22_generic_audio_privateEC1EPS0_","__ZN20resource_pool_objectI22_generic_audio_privateEC2EPS0_","__ZN20resource_pool_objectI22_generic_audio_privateED1Ev","__Z18generic_sound_initR15running_machine","__ZN13resource_pool10add_objectI22_generic_audio_privateEEPT_S3_","__ZN12save_manager12save_pointerIhEEvPT_PKcji","__ZN20resource_pool_objectI22_generic_video_privateEC1EPS0_","__ZN20resource_pool_objectI22_generic_video_privateEC2EPS0_","__ZN20resource_pool_objectI22_generic_video_privateED1Ev","__Z18debug_console_initR15running_machine","__ZN20resource_pool_objectI22_generic_audio_privateED0Ev","__ZN20resource_pool_objectI22_generic_audio_privateED2Ev","__Z18generic_video_initR15running_machine","__ZN13resource_pool10add_objectI22_generic_video_privateEEPT_S3_","__ZN20resource_pool_objectI22_generic_video_privateED0Ev","__ZN20resource_pool_objectI22_generic_video_privateED2Ev","__Z22debug_cmderr_to_stringj","__ZL18debug_console_exitR15running_machine","__Z29debug_console_execute_commandR15running_machinePKci","__Z30debug_console_validate_commandR15running_machinePKc","__Z20debug_console_printfR15running_machinePKcz","__ZL22internal_parse_commandR15running_machinePKci","__Z25debug_console_get_textbufv","__Z26debug_errorlog_get_textbufv","__ZNK16expression_errorcvNS_10error_codeEEv","__Z25debug_errorlog_write_lineR15running_machinePKc","__ZN20resource_pool_objectI14_debug_commandEC1EPS0_","__ZN20resource_pool_objectI14_debug_commandEC2EPS0_","__ZN20resource_pool_objectI14_debug_commandED1Ev","__Z30debug_console_register_commandR15running_machinePKcjiiiPFvS0_iiPS2_E","__ZN13resource_pool10add_objectI14_debug_commandEEPT_S3_","__Z21debug_console_vprintfR15running_machinePKcPc","__Z25debug_console_printf_wrapR15running_machineiPKcz","__ZN20resource_pool_objectI14_debug_commandED0Ev","__ZN20resource_pool_objectI14_debug_commandED2Ev","__ZL24internal_execute_commandR15running_machineiiPPc","__ZL14trim_parameterPPci","__Z19ui_menu_stack_resetR15running_machine","__ZL20menu_render_triangleR8bitmap_tRKS_RK10_rectanglePv","__ZL12ui_menu_exitR15running_machine","__Z12ui_menu_initR15running_machine","__ZNK7ui_menu7machineEv","__Z17ui_menu_populatedP7ui_menu","__ZN7ui_menuC1ER15running_machine","__Z13ui_menu_resetP7ui_menu22_ui_menu_reset_options","__Z12ui_menu_freeP7ui_menu","__ZL14menu_quit_gameR15running_machineP7ui_menuPvS3_","__Z13ui_menu_allocR15running_machineP16render_containerPFvS0_P7ui_menuPvS5_ES5_","__ZN13resource_pool10add_objectI7ui_menuEEPT_S3_","__Z19ui_menu_item_appendP7ui_menuPKcS2_jPv","__Z19ui_menu_pool_strdupP7ui_menuPKc","__Z15ui_menu_processR15running_machineP7ui_menuj","__ZL26ui_menu_validate_selectionP7ui_menui","__ZL21ui_menu_draw_text_boxP7ui_menu","__ZN13resource_pool9add_arrayI13_ui_menu_itemEEPT_S3_i","__ZL12ui_menu_drawR15running_machineP7ui_menui","__Z25ui_menu_set_custom_renderP7ui_menuPFvR15running_machineS0_PvS3_ffffffEff","__Z21ui_menu_get_selectionP7ui_menu","__ZL21ui_menu_handle_eventsP7ui_menu","__ZL19ui_menu_handle_keysP7ui_menuj","__Z19ui_menu_alloc_stateP7ui_menujPFvS0_PvE","__Z18ui_menu_pool_allocP7ui_menuj","__Z21ui_menu_set_selectionP7ui_menuPv","__Z28ui_menu_is_force_game_selectv","__Z17ui_menu_stack_popR15running_machine","__Z18ui_menu_stack_pushP7ui_menu","__Z18ui_menu_ui_handlerR15running_machineP16render_containerj","__ZL9menu_mainR15running_machineP7ui_menuPvS3_","__ZL23ui_menu_clear_free_listR15running_machine","__Z20ui_slider_ui_handlerR15running_machineP16render_containerj","__ZL12menu_slidersR15running_machineP7ui_menuPvS3_","__Z25ui_menu_force_game_selectR15running_machineP16render_container","__Z25ui_slot_get_current_indexR15running_machineP21device_slot_interface","__Z18ui_slot_get_lengthR15running_machineP21device_slot_interface","__Z16ui_slot_get_nextR15running_machineP21device_slot_interface","__Z16ui_slot_get_prevR15running_machineP21device_slot_interface","__Z18ui_get_slot_deviceR15running_machineP21device_slot_interface","__ZN19resource_pool_arrayI13_ui_menu_itemEC1EPS0_i","__ZN19resource_pool_arrayI13_ui_menu_itemEC2EPS0_i","__ZN19resource_pool_arrayI13_ui_menu_itemED1Ev","__ZN20resource_pool_objectI7ui_menuEC1EPS0_","__ZN20resource_pool_objectI7ui_menuEC2EPS0_","__ZN20resource_pool_objectI7ui_menuED1Ev","__ZL16menu_select_gameR15running_machineP7ui_menuPvS3_","__Z18ui_set_slot_deviceR15running_machineP21device_slot_interfacePKc","__ZN19resource_pool_arrayI13_ui_menu_itemED0Ev","__ZN19resource_pool_arrayI13_ui_menu_itemED2Ev","__ZL25menu_select_game_populateR15running_machineP7ui_menuP18_select_game_state","__ZL17menu_input_groupsR15running_machineP7ui_menuPvS3_","__ZL26menu_input_groups_populateR15running_machineP7ui_menuPv","__ZL18menu_input_generalR15running_machineP7ui_menuPvS3_","__ZL17menu_input_commonR15running_machineP7ui_menuPvS3_","__ZN20resource_pool_objectI7ui_menuED0Ev","__ZN20resource_pool_objectI7ui_menuED2Ev","__ZppR15_input_seq_typei","__ZNK13input_manager14seq_poll_finalEv","__ZL19toggle_none_defaultR9input_seqS0_RKS_","__ZL21get_field_default_seqP18input_field_config15_input_seq_type","__ZL27menu_input_general_populateR15running_machineP7ui_menuP17_input_menu_statei","__ZL28menu_input_specific_populateR15running_machineP7ui_menuP17_input_menu_state","__ZL28menu_input_populate_and_sortR15running_machineP7ui_menuP16_input_item_dataP17_input_menu_state","__ZL24menu_input_compare_itemsPKvS0_","__ZL30menu_select_game_custom_renderR15running_machineP7ui_menuPvS3_ffffff","__ZL34menu_select_game_build_driver_listP7ui_menuP18_select_game_state","__ZN20resource_pool_objectI17driver_enumeratorEC1EPS0_","__ZN20resource_pool_objectI17driver_enumeratorEC2EPS0_","__ZN20resource_pool_objectI17driver_enumeratorED1Ev","__ZN13resource_pool10add_objectI17driver_enumeratorEEPT_S3_","__ZN20resource_pool_objectI17driver_enumeratorED0Ev","__ZN20resource_pool_objectI17driver_enumeratorED2Ev","__ZL21menu_sliders_populateR15running_machineP7ui_menui","__ZL26menu_sliders_custom_renderR15running_machineP7ui_menuPvS3_ffffff","__ZL18menu_main_populateR15running_machineP7ui_menuPv","__ZL19menu_input_specificR15running_machineP7ui_menuPvS3_","__ZL26menu_settings_dip_switchesR15running_machineP7ui_menuPvS3_","__ZL27menu_settings_driver_configR15running_machineP7ui_menuPvS3_","__ZL24menu_settings_categoriesR15running_machineP7ui_menuPvS3_","__ZL11menu_analogR15running_machineP7ui_menuPvS3_","__ZL16menu_bookkeepingR15running_machineP7ui_menuPvS3_","__ZL20ui_menu_slot_devicesR15running_machineP7ui_menuPvS3_","__ZL21ui_menu_keyboard_modeR15running_machineP7ui_menuPvS3_","__ZL18menu_video_targetsR15running_machineP7ui_menuPvS3_","__ZL14menu_game_infoR15running_machineP7ui_menuPvS3_","__ZL18menu_video_optionsR15running_machineP7ui_menuPvS3_","__ZL14menu_crosshairR15running_machineP7ui_menuPvS3_","__ZNK13cheat_manager5firstEv","__ZL10menu_cheatR15running_machineP7ui_menuPvS3_","__ZL16menu_memory_cardR15running_machineP7ui_menuPvS3_","__ZL25menu_memory_card_populateR15running_machineP7ui_menui","__ZNK11cheat_entry7commentEv","__ZNK14render_manager12first_targetEv","__ZL19menu_cheat_populateR15running_machineP7ui_menu","__ZL23menu_crosshair_populateR15running_machineP7ui_menu","__ZL27menu_video_options_populateR15running_machineP7ui_menuP13render_target","__ZL22orientation_swap_flipsi4284","__ZL15orientation_addii4283","__ZNK13render_target17backdrops_enabledEv","__ZNK13render_target16overlays_enabledEv","__ZNK13render_target14bezels_enabledEv","__ZNK13render_target15cpanels_enabledEv","__ZNK13render_target16marquees_enabledEv","__ZNK13render_target14zoom_to_screenEv","__ZL27menu_video_targets_populateR15running_machineP7ui_menu","__ZL26menu_slot_devices_populateR15running_machineP7ui_menuPv","__ZL20menu_settings_commonR15running_machineP7ui_menuPvj","__ZL25menu_bookkeeping_populateR15running_machineP7ui_menuP8attotime","__ZL20menu_analog_populateR15running_machineP7ui_menu","__ZL19count_leading_zerosj4285","__ZNK11simple_listI23input_field_diplocationE5countEv","__ZNK11simple_listI23input_field_diplocationE5firstEv","__ZNK23input_field_diplocation4nextEv","__ZN7ui_menuC2ER15running_machine","__ZL22menu_settings_populateR15running_machineP7ui_menuP20_settings_menu_statej","__ZL27menu_settings_custom_renderR15running_machineP7ui_menuPvS3_ffffff","__ZL31menu_settings_custom_render_oneP16render_containerffffPK15_dip_descriptorj","__ZL18item_is_selectablePK13_ui_menu_item","__ZL23exclusive_input_pressedP7ui_menuii","__Z13debugint_initR15running_machine","__ZL13debugint_exitR15running_machine","__Z26debugint_wait_for_debuggerR8device_tb","__ZL15dview_set_titleP5DView7astring","__ZL14set_focus_viewP5DView","__ZL12update_viewsv","__ZL12handle_menusR15running_machine","__ZL12handle_mouseR15running_machine","__Z27debugint_update_during_gameR15running_machine","__ZL11dview_allocP13render_targetR15running_machine15debug_view_typei","__ZL17followers_set_cpuP8device_t","__ZL14dview_is_stateP5DViewi","__ZL18dview_is_state_allP5DViewi","__ZL15dview_set_stateP5DViewii","__ZL14dview_on_mouseP5DViewiii","__ZL9map_pointP5DViewiiPiS1_","__ZL16dview_xy_in_rectP5DViewiii","__ZN13debug_view_xyC1Eii","__Z8downcastIP17debug_view_disasm10debug_viewET_PT0_","__Z8downcastIP17debug_view_memory10debug_viewET_PT0_","__ZL14rect_get_widthP10_rectangle","__ZL15rect_get_heightP10_rectangle","__ZN10debug_view12begin_updateEv","__ZN13debug_view_xyC2Eii","__ZNK5DView7machineEv","__ZNK17debug_view_disasm12right_columnEv","__ZN10debug_view16visible_positionEv","__ZN10debug_view16cursor_supportedEv","__ZN10debug_view13flush_updatesEv","__ZL13handle_editorR15running_machine","__ZL13render_editorP10DView_edit","__ZL14process_stringP5DViewPKc","__ZL14dview_get_rectP5DViewiP10_rectangle","__ZL14CreateMainMenuR15running_machine","__ZL25on_memory_window_activateP5DViewPK14_ui_menu_event","__ZNK10debug_view6sourceEv","__ZNK17debug_view_source4nextEv","__ZNK10debug_view11source_listEv","__ZNK22debug_view_source_list4headEv","__ZNK17debug_view_source6deviceEv","__ZL24on_view_opcodes_activateP5DViewPK14_ui_menu_event","__ZL25on_run_to_cursor_activateP5DViewPK14_ui_menu_event","__ZNK17debug_view_source4nameEv","__ZL15on_run_activateP5DViewPK14_ui_menu_event","__ZL19on_run_cpu_activateP5DViewPK14_ui_menu_event","__ZL19on_run_irq_activateP5DViewPK14_ui_menu_event","__ZL19on_run_vbl_activateP5DViewPK14_ui_menu_event","__ZL21on_step_into_activateP5DViewPK14_ui_menu_event","__ZL21on_step_over_activateP5DViewPK14_ui_menu_event","__ZL22on_soft_reset_activateP5DViewPK14_ui_menu_event","__ZL22on_hard_reset_activateP5DViewPK14_ui_menu_event","__ZL17on_close_activateP5DViewPK14_ui_menu_event","__ZL16on_exit_activateP5DViewPK14_ui_menu_event","__ZL10dview_freeP5DView","__ZN10debug_view14cursor_visibleEv","__ZL17dview_update_viewP5DView","__ZL22on_disasm_cpu_activateP5DViewPK14_ui_menu_event","__ZL30on_disassembly_window_activateP5DViewPK14_ui_menu_event","__ZL22on_log_window_activateP5DViewPK14_ui_menu_event","__ZNK10debug_view8viewdataEv","__ZL19dview_size_allocateP5DView","__ZL10dview_drawP5DView","__ZN10debug_view12visible_sizeEv","__ZL11dview_clearP5DView","__ZL16dview_draw_titleP5DView","__ZL23dview_draw_outlined_boxP5DViewiiiiij","__ZL17map_attr_to_fg_bghPjS_","__ZL14dview_draw_boxP5DViewiiiiij","__ZL15dview_draw_charP5DViewiiiijt","__ZL14dview_draw_hsbP5DView","__ZL14dview_draw_vsbP5DView","__ZL15dview_draw_sizeP5DView","__ZN10debug_view10total_sizeEv","__ZN5DViewC1EP13render_targetR15running_machine15debug_view_typei","__ZN10DView_editC1Ev","__ZL12dview_updateR10debug_viewPv","__ZN10DView_editD1Ev","__ZN10DView_editD2Ev","__ZN10DView_editC2Ev","__ZN20resource_pool_objectI5DViewEC1EPS0_","__ZN20resource_pool_objectI5DViewEC2EPS0_","__ZN20resource_pool_objectI5DViewED1Ev","__ZN13resource_pool10add_objectI5DViewEEPT_S3_","__ZN5DViewC2EP13render_targetR15running_machine15debug_view_typei","__ZN20resource_pool_objectI5DViewED0Ev","__ZN11driver_listC2Ev","__ZN5DViewD1Ev","__ZN11driver_list4findEPKc","__ZN11driver_list20driver_sort_callbackEPKvS1_","__ZN11driver_list7matchesEPKcS1_","__ZN11driver_list15penalty_compareEPKcS1_","__ZN11simple_listIN17driver_enumerator12config_entryEEC1ER13resource_pool","__ZN17driver_enumerator11include_allEv","__ZN11simple_listIN17driver_enumerator12config_entryEED1Ev","__ZN20resource_pool_objectI5DViewED2Ev","__ZN5DViewD2Ev","__ZN17driver_enumeratorC2ER11emu_options","__ZN13resource_pool9add_arrayIP14machine_configEEPT_S4_i","__ZN17driver_enumerator6filterEPKc","__ZN17driver_enumerator6filterERK11game_driver","__ZN17driver_enumeratorC2ER11emu_optionsPKc","__ZN17driver_enumeratorC2ER11emu_optionsRK11game_driver","__ZN17driver_enumeratorD2Ev","__ZNK11simple_listIN17driver_enumerator12config_entryEE5countEv","__ZNK11simple_listIN17driver_enumerator12config_entryEE5firstEv","__ZNK17driver_enumerator12config_entry5indexEv","__ZN11simple_listIN17driver_enumerator12config_entryEE6appendERS1_","__ZN17driver_enumerator4nextEv","__ZN17driver_enumerator13next_excludedEv","__ZN11simple_listIN17driver_enumerator12config_entryEE6removeERS1_","__ZNK17driver_enumerator6configEi","__ZN13resource_pool10add_objectI14machine_configEEPT_S3_","__ZN13resource_pool10add_objectIN17driver_enumerator12config_entryEEEPT_S4_","__ZN17driver_enumerator12config_entryC2ER14machine_configi","__ZN17driver_enumerator12config_entryD2Ev","__ZN20resource_pool_objectIN17driver_enumerator12config_entryEEC1EPS1_","__ZN20resource_pool_objectIN17driver_enumerator12config_entryEEC2EPS1_","__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED1Ev","__ZN20resource_pool_objectI14machine_configEC1EPS0_","__ZN20resource_pool_objectI14machine_configEC2EPS0_","__ZN20resource_pool_objectI14machine_configED1Ev","__ZN17driver_enumerator24find_approximate_matchesEPKciPi","__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED0Ev","__ZN20resource_pool_objectIN17driver_enumerator12config_entryEED2Ev","__ZN20resource_pool_objectI14machine_configED0Ev","__ZN11simple_listIN17driver_enumerator12config_entryEE6detachERS1_","__ZN11simple_listIN17driver_enumerator12config_entryEEC2ER13resource_pool","__ZN11simple_listIN17driver_enumerator12config_entryEED2Ev","__ZN11simple_listIN17driver_enumerator12config_entryEE5resetEv","__ZN19resource_pool_arrayIP14machine_configEC1EPS1_i","__ZN19resource_pool_arrayIP14machine_configEC2EPS1_i","__ZN19resource_pool_arrayIP14machine_configED1Ev","__ZN20resource_pool_objectI14machine_configED2Ev","__ZN11simple_listIN17driver_enumerator12config_entryEED0Ev","__ZN19resource_pool_arrayIP14machine_configED0Ev","__ZN19resource_pool_arrayIP14machine_configED2Ev","__ZNK12core_options5firstEv","__ZNK12core_options5entry4nextEv","___cxx_global_var_init4595","__ZN11emu_options21remove_device_optionsEv","__ZN11emu_optionsC2Ev","__ZN11emu_options18add_device_optionsEv","__ZNK11emu_options6systemEv","__ZNK12core_options5entry5flagsEv","__ZNK7astringneEPKc","__ZN11emu_options13device_optionER22device_image_interface","__ZN11emu_optionsD1Ev","__GLOBAL__I_a4608","___cxx_global_var_init4692","__ZN18render_screen_listC1ER13resource_pool","__ZN18render_screen_listD1Ev","__ZN11emu_options18parse_command_lineEiPPcR7astring","__ZN11emu_options19parse_standard_inisER7astring","__ZN11emu_options13parse_one_iniEPKciP7astring","__ZN11emu_options15set_system_nameEPKc","__ZN11emu_optionsD0Ev","__Z12parse_boundsR15running_machineP14_xml_data_nodeR13render_bounds","__ZL34xml_get_attribute_float_with_substR15running_machineR14_xml_data_nodePKcf","__ZN11simple_listIN14layout_element9componentEEC1ER13resource_pool","__Z11parse_colorR15running_machineP14_xml_data_nodeR12render_color","__ZN14layout_elementC2ER15running_machineR14_xml_data_nodePKc","__ZN11simple_listIN14layout_element9componentEE6appendERS1_","__ZL19union_render_boundsP13render_boundsPKS_","__ZNK11simple_listIN14layout_element9componentEE5firstEv","__ZNK14layout_element9component4nextEv","__ZNK14layout_element7machineEv","__ZL35xml_get_attribute_string_with_substR15running_machineR14_xml_data_nodePKcS4_","__ZL32xml_get_attribute_int_with_substR15running_machineR14_xml_data_nodePKci","__ZN11simple_listIN14layout_element9componentEED1Ev","__ZN14layout_element13state_textureEi","__ZN13resource_pool10add_objectIN14layout_element9componentEEEPT_S4_","__ZN13resource_pool9add_arrayIN14layout_element7textureEEEPT_S4_i","__ZN14layout_elementD0Ev","__ZN14layout_elementD2Ev","__ZNK14layout_element9component6boundsEv","__ZN14layout_element7textureC2Ev","__ZN14layout_element13element_scaleER8bitmap_tRKS0_RK10_rectanglePv","__ZL20render_round_nearestf4695","__ZN14layout_element7textureD2Ev","__ZN14layout_element9component4drawER15running_machineR8bitmap_tRK10_rectanglei","__ZN14layout_element9componentC2ER15running_machineR14_xml_data_nodePKc","__ZN14layout_element9component9draw_rectER8bitmap_tRK10_rectangle","__ZN14layout_element9component9draw_diskER8bitmap_tRK10_rectangle","__ZN14layout_element9componentD2Ev","__ZN14layout_element9component11load_bitmapEv","__ZN14layout_element9component9draw_textER15running_machineR8bitmap_tRK10_rectangle","__ZN14layout_element9component12draw_led7segER8bitmap_tRK10_rectanglei","__ZN14layout_element9component13draw_led14segER8bitmap_tRK10_rectanglei","__ZN14layout_element9component13draw_led16segER8bitmap_tRK10_rectanglei","__ZN14layout_element9component15draw_led14segscER8bitmap_tRK10_rectanglei","__ZN14layout_element9component23draw_segment_horizontalER8bitmap_tiiiij","__ZN14layout_element9component21draw_segment_verticalER8bitmap_tiiiij","__ZN14layout_element9component15draw_led16segscER8bitmap_tRK10_rectanglei","__ZN14layout_element9component14draw_dotmatrixER8bitmap_tRK10_rectanglei","__ZN14layout_element9component10apply_skewER8bitmap_ti","__ZN14layout_element9component28draw_segment_horizontal_capsER8bitmap_tiiiiij","__ZN14layout_element9component26draw_segment_vertical_capsER8bitmap_tiiiiij","__ZN14layout_element9component23draw_segment_diagonal_1ER8bitmap_tiiiiij","__ZN14layout_element9component23draw_segment_diagonal_2ER8bitmap_tiiiiij","__ZN14layout_element9component20draw_segment_decimalER8bitmap_tiiij","__ZN11layout_viewC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE","__ZN11simple_listIN11layout_view4itemEE6appendERS1_","__ZN11simple_listIN11layout_view4itemEEC1ER13resource_pool","__ZN11layout_view9recomputeE19render_layer_config","__ZN11simple_listIN11layout_view4itemEED1Ev","__ZN13resource_pool10add_objectIN11layout_view4itemEEEPT_S4_","__ZN11layout_viewD0Ev","__ZN11layout_viewD2Ev","__ZNK11simple_listIN11layout_view4itemEE5firstEv","__ZNK11simple_listI14layout_elementE5firstEv","__ZNK14layout_element4nextEv","__ZNK14layout_element13default_stateEv","__ZNK11layout_view10first_itemE10item_layer","__ZN18render_screen_list5resetEv","__ZNK14layout_element4nameEv","__ZN18render_screen_list3addER13screen_device","__ZN11layout_view4itemC2ER15running_machineR14_xml_data_nodeR11simple_listI14layout_elementE","__ZL17parse_orientationR15running_machineP14_xml_data_nodeRi","__ZN11layout_view4itemD0Ev","__ZN11layout_view4itemD2Ev","__ZN11simple_listI14layout_elementE6appendERS0_","__ZN11simple_listI11layout_viewE6appendERS0_","__ZNK11layout_view4item5stateEv","__ZN11simple_listI14layout_elementEC1ER13resource_pool","__ZN11simple_listI11layout_viewEC1ER13resource_pool","__ZN11layout_fileC2ER15running_machineR14_xml_data_nodePKc","__ZN13resource_pool10add_objectI14layout_elementEEPT_S3_","__ZN13resource_pool10add_objectI11layout_viewEEPT_S3_","__ZN11simple_listI11layout_viewE6detachERS0_","__ZN11simple_listI11layout_viewED1Ev","__ZN11simple_listI14layout_elementED1Ev","__ZN20resource_pool_objectI11layout_viewEC1EPS0_","__ZN20resource_pool_objectI11layout_viewEC2EPS0_","__ZN20resource_pool_objectI11layout_viewED1Ev","__ZN20resource_pool_objectI14layout_elementEC1EPS0_","__ZN20resource_pool_objectI14layout_elementEC2EPS0_","__ZN20resource_pool_objectI14layout_elementED1Ev","__ZN11simple_listI11layout_viewED2Ev","__ZN11simple_listI11layout_viewE5resetEv","__ZN11simple_listI11layout_viewE6removeERS0_","__ZN11simple_listI14layout_elementED2Ev","__ZN11simple_listI14layout_elementE5resetEv","__ZN11simple_listI14layout_elementE6removeERS0_","__ZN11layout_fileD0Ev","__ZN11layout_fileD2Ev","__ZN20resource_pool_objectI11layout_viewED0Ev","__ZN20resource_pool_objectI11layout_viewED2Ev","__ZN20resource_pool_objectI14layout_elementED0Ev","__ZN20resource_pool_objectI14layout_elementED2Ev","__ZN11simple_listI11layout_viewED0Ev","__ZN11simple_listI14layout_elementED0Ev","__ZN11simple_listI14layout_elementE6detachERS0_","__ZN11simple_listI11layout_viewEC2ER13resource_pool","__ZN11simple_listI14layout_elementEC2ER13resource_pool","__ZN11simple_listIN11layout_view4itemEE6detachERS1_","__ZN11simple_listIN11layout_view4itemEEC2ER13resource_pool","__ZN20resource_pool_objectIN11layout_view4itemEEC1EPS1_","__ZN20resource_pool_objectIN11layout_view4itemEEC2EPS1_","__ZN20resource_pool_objectIN11layout_view4itemEED1Ev","__ZN11simple_listIN11layout_view4itemEED2Ev","__ZN11simple_listIN11layout_view4itemEE5resetEv","__ZN11simple_listIN11layout_view4itemEE6removeERS1_","__ZN19resource_pool_arrayIN14layout_element7textureEEC1EPS1_i","__ZN19resource_pool_arrayIN14layout_element7textureEEC2EPS1_i","__ZN19resource_pool_arrayIN14layout_element7textureEED1Ev","__ZN20resource_pool_objectIN14layout_element9componentEEC1EPS1_","__ZN20resource_pool_objectIN14layout_element9componentEEC2EPS1_","__ZN20resource_pool_objectIN14layout_element9componentEED1Ev","__ZN20resource_pool_objectIN11layout_view4itemEED0Ev","__ZN20resource_pool_objectIN11layout_view4itemEED2Ev","__ZN11simple_listIN11layout_view4itemEED0Ev","__ZN19resource_pool_arrayIN14layout_element7textureEED0Ev","__ZN19resource_pool_arrayIN14layout_element7textureEED2Ev","__ZN11simple_listIN14layout_element9componentEE6detachERS1_","__ZN11simple_listIN14layout_element9componentEEC2ER13resource_pool","__ZN11simple_listIN18render_screen_list4itemEE6appendERS1_","__ZNK11simple_listIN18render_screen_list4itemEE4poolEv","__ZN18render_screen_list4itemC2ER13screen_device","__ZN11simple_listIN14layout_element9componentEED2Ev","__ZN11simple_listIN14layout_element9componentEE5resetEv","__ZN11simple_listIN14layout_element9componentEE6removeERS1_","__ZN18render_screen_list4itemC1ER13screen_device","__ZN20resource_pool_objectIN18render_screen_list4itemEEC1EPS1_","__ZN20resource_pool_objectIN18render_screen_list4itemEEC2EPS1_","__ZN20resource_pool_objectIN18render_screen_list4itemEED1Ev","__ZN11simple_listIN18render_screen_list4itemEE5resetEv","__ZN11simple_listIN18render_screen_list4itemEE6removeERS1_","__ZN20resource_pool_objectIN14layout_element9componentEED0Ev","__ZN20resource_pool_objectIN14layout_element9componentEED2Ev","__ZN11simple_listIN14layout_element9componentEED0Ev","__ZN13resource_pool10add_objectIN18render_screen_list4itemEEEPT_S4_","__ZN20resource_pool_objectIN18render_screen_list4itemEED0Ev","__ZN20resource_pool_objectIN18render_screen_list4itemEED2Ev","__Z3gcdii","__ZN11simple_listIN18render_screen_list4itemEE6detachERS1_","__ZN11simple_listIN18render_screen_list4itemEEC2ER13resource_pool","__ZL18get_variable_valueR15running_machinePKcPPc","__Z15reduce_fractionRiS_","__ZN18render_screen_listD2Ev","__ZN11simple_listIN18render_screen_list4itemEED1Ev","__ZN11simple_listIN18render_screen_list4itemEED2Ev","__ZN18render_screen_listC2ER13resource_pool","__ZN11simple_listIN18render_screen_list4itemEEC1ER13resource_pool","__GLOBAL__I_a4702","__ZN11simple_listIN18render_screen_list4itemEED0Ev","__ZN11render_fontC2ER14render_managerPKc","__ZN11render_font15load_cached_bdfEPKc","__ZN11render_fontD2Ev","__ZN11render_font11load_cachedER8emu_filej","__ZN11render_fontD0Ev","__Z9next_linePKc","__ZN11render_font27get_char_texture_and_boundsEffjR13render_bounds","__ZN11render_font11char_expandEjRNS_5glyphE","__ZN11render_font8get_charEj","__ZNK11render_font7managerEv","__ZN11render_font28get_scaled_bitmap_and_boundsER8bitmap_tffjR10_rectangle","__ZN11render_font10char_widthEffj","__ZN11render_font12string_widthEffPKc","__ZN11render_font16utf8string_widthEffPKc","__ZNK11emu_options9font_pathEv","__ZN11render_font8load_bdfEv","__ZN11render_font11save_cachedEPKcj","__ZNK21function_symbol_entry7is_lvalEv","__ZNK16expression_error11code_stringEv","__ZN20integer_symbol_entry15internal_getterER12symbol_tablePv","__ZN20integer_symbol_entry15internal_setterER12symbol_tablePvy","__ZNK20integer_symbol_entry7is_lvalEv","__ZN19resource_pool_arrayIN11render_font5glyphEEC1EPS1_i","__ZN19resource_pool_arrayIN11render_font5glyphEEC2EPS1_i","__ZN19resource_pool_arrayIN11render_font5glyphEED1Ev","__ZN12symbol_entryC2ER12symbol_tableNS_11symbol_typeEPKcPv","__ZN12symbol_entryD2Ev","__ZN20integer_symbol_entryC2ER12symbol_tablePKcNS0_10read_writeEPy","__ZN20integer_symbol_entryC2ER12symbol_tablePKcPvPFyS1_S4_EPFvS1_S4_yE","__ZNK20integer_symbol_entry5valueEv","__ZN21function_symbol_entryC2ER12symbol_tablePKcPviiPFyS1_S4_iPKyE","__ZN13resource_pool9add_arrayIN11render_font5glyphEEEPT_S4_i","__ZN19resource_pool_arrayIN11render_font5glyphEED0Ev","__ZN19resource_pool_arrayIN11render_font5glyphEED2Ev","__ZN12symbol_entryD0Ev","__ZN20integer_symbol_entry9set_valueEy","__ZNK21function_symbol_entry5valueEv","__ZN21function_symbol_entry9set_valueEy","__ZN12symbol_table16configure_memoryEPvPFN16expression_error10error_codeES0_PKc16expression_spaceEPFyS0_S4_S5_jiEPFvS0_S4_S5_jiyE","__ZN12symbol_tableC2EPvPS_","__ZN11tagged_listI12symbol_entryEC1ER13resource_pool","__ZN11tagged_listI12symbol_entryE6removeEPKc","__ZN21function_symbol_entry7executeEiPKy","__ZN12symbol_table3addEPKcNS_10read_writeEPy","__ZN11tagged_listI12symbol_entryE6appendEPKcRS0_","__ZN13resource_pool10add_objectI20integer_symbol_entryEEPT_S3_","__ZN12symbol_table3addEPKcPvPFyRS_S2_EPFvS3_S2_yE","__ZN12symbol_table3addEPKcPviiPFyRS_S2_iPKyE","__ZN12symbol_table9find_deepEPKc","__ZN12symbol_table12memory_validEPKc16expression_space","__ZN12symbol_table12memory_valueEPKc16expression_spaceji","__ZN12symbol_table16set_memory_valueEPKc16expression_spacejiy","__ZN11simple_listIN17parsed_expression11parse_tokenEEC1ER13resource_pool","__ZN11simple_listIN17parsed_expression17expression_stringEEC1ER13resource_pool","__ZN17parsed_expression5parseEPKc","__ZN13resource_pool10add_objectI21function_symbol_entryEEPT_S3_","__ZN17parsed_expressionC2EP12symbol_tablePKcPy","__ZN17parsed_expression24parse_string_into_tokensEv","__ZN11simple_listIN17parsed_expression11parse_tokenEE6appendERS1_","__ZN17parsed_expression11parse_token18configure_operatorEhh","__ZN17parsed_expression11parse_token17set_right_to_leftEv","__ZN17parsed_expression16infix_to_postfixEv","__ZN13resource_pool10add_objectIN17parsed_expression11parse_tokenEEEPT_S4_","__ZN17parsed_expression19parse_quoted_stringERNS_11parse_tokenERPKc","__ZN17parsed_expression17parse_quoted_charERNS_11parse_tokenERPKc","__ZN17parsed_expression22parse_symbol_or_numberERNS_11parse_tokenERPKc","__ZNK17parsed_expression11parse_token6offsetEv","__ZN17parsed_expression11parse_token16configure_symbolER12symbol_entry","__ZNK12symbol_entry11is_functionEv","__ZN17parsed_expression11parse_token16configure_numberEy","__ZN17parsed_expression11parse_token16configure_stringEPKc","__ZN11simple_listIN17parsed_expression17expression_stringEE6appendERS1_","__ZN16expression_errorC1ENS_10error_codeEi","__ZN17parsed_expression17expression_stringC1EPKci","__ZN17parsed_expression17expression_stringcvPKcEv","__ZN17parsed_expression21parse_memory_operatorERNS_11parse_tokenEPKc","__ZN17parsed_expression12parse_numberERNS_11parse_tokenEPKciN16expression_error10error_codeE","__ZN13resource_pool10add_objectIN17parsed_expression17expression_stringEEEPT_S4_","__ZN17parsed_expression11parse_token15set_memory_sizeEi","__ZN17parsed_expression11parse_token16set_memory_spaceE16expression_space","__ZN17parsed_expression11parse_token17set_memory_sourceEPKc","__ZNK17parsed_expression11parse_token4nextEv","__ZNK17parsed_expression11parse_token6optypeEv","__ZN17parsed_expression11parse_token22set_function_separatorEv","__ZNK17parsed_expression11parse_token9is_symbolEv","__ZNK17parsed_expression11parse_token9is_numberEv","__ZN17parsed_expression10peek_tokenEi","__ZNK17parsed_expression11parse_token21is_function_separatorEv","__ZN11simple_listIN17parsed_expression11parse_tokenEE10detach_allEv","__ZNK17parsed_expression11parse_token9is_stringEv","__ZNK17parsed_expression11parse_token11is_operatorEv","__ZN11simple_listIN17parsed_expression11parse_tokenEE7prependERS1_","__ZN11simple_listIN17parsed_expression11parse_tokenEE11detach_headEv","__ZNK17parsed_expression11parse_token10precedenceEv","__ZNK11simple_listIN17parsed_expression11parse_tokenEE5firstEv","__ZNK17parsed_expression11parse_token13right_to_leftEv","__ZNK17parsed_expression11parse_token11is_operatorEh","__ZN17parsed_expression18normalize_operatorEPNS_11parse_tokenERS0_","__ZN17parsed_expression11parse_token10set_offsetERKS0_","__ZN17parsed_expression11parse_token14get_lval_valueEP12symbol_table","__ZN17parsed_expression14execute_tokensEv","__ZN17parsed_expression10push_tokenERNS_11parse_tokenE","__ZN17parsed_expression14pop_token_lvalERNS_11parse_tokenE","__Z8downcastIP21function_symbol_entry12symbol_entryET_PT0_","__ZNK17parsed_expression11parse_token5valueEv","__ZN17parsed_expression11parse_token10set_offsetERKS0_S2_","__ZN17parsed_expression11parse_token16configure_memoryEjRS0_","__ZN17parsed_expression11parse_tokenC2Ei","__ZNK17parsed_expression11parse_token9is_memoryEv","__ZNK17parsed_expression11parse_token12memory_spaceEv","__ZNK17parsed_expression11parse_token7addressEv","__ZNK17parsed_expression11parse_token11memory_sizeEv","__ZNK17parsed_expression11parse_token6symbolEv","__ZN17parsed_expression11parse_token14set_lval_valueEP12symbol_tabley","__ZN20integer_symbol_entryD1Ev","__ZN21function_symbol_entryD1Ev","__ZN20resource_pool_objectIN17parsed_expression17expression_stringEEC1EPS1_","__ZN20resource_pool_objectIN17parsed_expression17expression_stringEEC2EPS1_","__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED1Ev","__ZN17parsed_expression14pop_token_rvalERNS_11parse_tokenE","__ZN17parsed_expression16execute_functionERNS_11parse_tokenE","__ZN17parsed_expression9pop_tokenERNS_11parse_tokenE","__ZN20integer_symbol_entryD0Ev","__ZN21function_symbol_entryD0Ev","__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED0Ev","__ZN11simple_listI12symbol_entryE6appendERS0_","__ZN11simple_listI12symbol_entryEC2ER13resource_pool","__ZN11simple_listIN17parsed_expression17expression_stringEEC2ER13resource_pool","__ZN11simple_listIN17parsed_expression11parse_tokenEEC2ER13resource_pool","__ZN17parsed_expression17expression_stringD1Ev","__ZN17parsed_expression17expression_stringD2Ev","__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEEC1EPS1_","__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEEC2EPS1_","__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED1Ev","__ZN20resource_pool_objectI21function_symbol_entryEC1EPS0_","__ZN20resource_pool_objectI21function_symbol_entryEC2EPS0_","__ZN20resource_pool_objectI21function_symbol_entryED1Ev","__ZN20resource_pool_objectI20integer_symbol_entryEC1EPS0_","__ZN20resource_pool_objectI20integer_symbol_entryEC2EPS0_","__ZN20resource_pool_objectI20integer_symbol_entryED1Ev","__ZN8tagmap_tIP12symbol_entryE15add_unique_hashEPKcS1_b","__ZN11tagged_listI12symbol_entryE6removeERS0_","__ZN8tagmap_tIP12symbol_entryE6removeES1_","__ZN11simple_listI12symbol_entryEC1ER13resource_pool","__ZN8tagmap_tIP12symbol_entryEC1Ev","__ZN8tagmap_tIP12symbol_entryEC2Ev","__ZN21function_symbol_entryD2Ev","__ZN20integer_symbol_entryD2Ev","__ZN20resource_pool_objectIN17parsed_expression17expression_stringEED2Ev","__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED0Ev","__ZN20resource_pool_objectIN17parsed_expression11parse_tokenEED2Ev","__ZN20resource_pool_objectI21function_symbol_entryED0Ev","__ZN20resource_pool_objectI21function_symbol_entryED2Ev","__ZN20resource_pool_objectI20integer_symbol_entryED0Ev","__ZN20resource_pool_objectI20integer_symbol_entryED2Ev","__ZN11tagged_listI12symbol_entryEC2ER13resource_pool","__ZN16expression_errorC2ENS_10error_codeEi","__ZNK17parsed_expression11parse_token7is_lvalEv","__ZN17parsed_expression17expression_stringC2EPKci","__ZN7astringC1EPKci","__ZN7astringC2EPKci","__ZN13media_auditorC2ERK17driver_enumerator","__ZN11simple_listI12audit_recordEC1ER13resource_pool","__ZNK8device_t10searchpathEv","__ZN13media_auditor11audit_mediaEPKc","__ZN13media_auditor19also_used_by_parentERK15hash_collection","__ZNK12audit_record6statusEv","__ZN13media_auditor13audit_one_romEPK9rom_entry","__ZN13media_auditor14audit_one_diskEPK9rom_entry","__ZN13media_auditor9summarizeEP7astring","__ZN11simple_listI12audit_recordE6appendERS0_","__ZN12audit_record10set_statusENS_12audit_statusENS_15audit_substatusE","__ZNK11simple_listI12audit_recordE5countEv","__ZNK11simple_listI12audit_recordE5firstEv","__ZNK12audit_record9substatusEv","__ZNK12audit_record4nameEv","__ZNK12audit_record15expected_lengthEv","__ZNK12audit_record15expected_hashesEv","__ZNK12audit_record13actual_hashesEv","__ZNK12audit_record13actual_lengthEv","__ZNK12audit_record4nextEv","__ZNK11emu_options11sample_pathEv","__ZN12audit_record10set_actualERK15hash_collectiony","__ZN13media_auditor14compute_statusER12audit_recordPK9rom_entryb","__ZN13media_auditor13audit_samplesEv","__ZN13resource_pool10add_objectI12audit_recordEEPT_S3_","__ZN12audit_recordC2ERK9rom_entryNS_10media_typeE","__ZN11simple_listI12audit_recordEC2ER13resource_pool","__ZN20resource_pool_objectI12audit_recordEC1EPS0_","__ZN20resource_pool_objectI12audit_recordEC2EPS0_","__ZN20resource_pool_objectI12audit_recordED1Ev","__ZN12audit_recordD1Ev","__ZN13video_managerC2ER15running_machine","__ZNK11emu_options8throttleEv","__ZNK11emu_options14auto_frameskipEv","__ZNK13video_manager22original_speed_settingEv","__ZNK11emu_options9frameskipEv","__ZN8delegateIFvvEEC1I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13video_manager4exitEv","__ZN13video_manager8postloadEv","__ZN13video_manager20update_refresh_speedEv","__ZNK11emu_options9snap_viewEv","__ZN13render_target26set_screen_overlay_enabledEb","__ZN12audit_recordC2EPKcNS_10media_typeE","__ZN20resource_pool_objectI12audit_recordED0Ev","__ZN20resource_pool_objectI12audit_recordED2Ev","__ZN12audit_recordD2Ev","__ZN13video_manager13set_frameskipEi","__ZNK13video_manager7machineEv","__ZNK11emu_options9mng_writeEv","__ZN8delegateIFvPviEEC1I13video_managerEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_","__ZN13video_manager26screenless_update_callbackEPvi","__ZN13video_manager12frame_updateEb","__ZNK11emu_options15update_in_pauseEv","__ZN13video_manager21finish_screen_updatesEv","__ZNK13video_manager18effective_throttleEv","__ZN13video_manager15begin_recordingEPKcNS_12movie_formatE","__ZNK13video_manager19effective_frameskipEv","__ZNK13screen_device15partial_updatesEv","__ZN13video_manager15update_throttleE8attotime","__ZN13video_manager16update_frameskipEv","__ZL32debugger_within_instruction_hookR15running_machine","__ZN13video_manager10speed_textER7astring","__ZNK13video_manager23effective_autoframeskipEv","__ZN13video_manager15recompute_speedE8attotime","__ZN13video_manager13save_snapshotEP13screen_deviceR8emu_file","__ZN13video_manager22create_snapshot_bitmapEP8device_t","__ZN13video_manager28save_active_screen_snapshotsEv","__ZN13video_manager13end_recordingEv","__ZN13video_manager22add_sound_to_recordingEPKsi","__ZmlRK8attotimej","__ZN13video_manager9open_nextER8emu_filePKc","__ZN13video_manager12record_frameEv","__ZN21delegate_internal_mfpC2IM13video_managerFvPviEEET_","__ZN21delegate_internal_mfpC2IM13video_managerFvvEEET_","__ZNK8emu_file9openflagsEv","__ZN13video_manager20throttle_until_ticksEx","__ZNK11emu_options5sleepEv","__ZNK11emu_options13refresh_speedEv","__ZNK11emu_options9snap_nameEv","__ZNK7astring4findEiRKS_","__ZNK7astring4findEiPKc","__ZN7astring7replaceEiRKS_S1_","__ZN8delegateIFvPviEEC2I13video_managerEEN15delegate_traitsIT_vS0_i8_noparamS7_E16member_func_typeEPKcPS6_","__ZN13delegate_baseIvPvi8_noparamS1_EC2I13video_managerEEN15delegate_traitsIT_vS0_iS1_S1_E16member_func_typeEPKcPS6_","__ZN21delegate_internal_mfpC1IM13video_managerFvPviEEET_","__ZN13delegate_baseIvPvi8_noparamS1_E16late_bind_helperI13video_managerEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFvvEEC2I13video_managerEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13video_managerEEN15delegate_traitsIT_vS0_S0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM13video_managerFvvEEET_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13video_managerEEP22delegate_generic_classR18delegate_late_bind","__ZL22rgb888_draw_primitivesRK21render_primitive_listPvjjj","__ZL16rgb888_draw_linePK16render_primitivePviij","__ZL16rgb888_draw_rectPK16render_primitivePviij","__ZL13round_nearestf","__ZL35rgb888_setup_and_draw_textured_quadPK16render_primitivePviij","__ZL31rgb888_draw_quad_palette16_nonePK16render_primitivePvjP16_quad_setup_data","__ZL30rgb888_draw_quad_palette16_addPK16render_primitivePvjP16_quad_setup_data","__ZL33rgb888_draw_quad_palettea16_alphaPK16render_primitivePvjP16_quad_setup_data","__ZL27rgb888_draw_quad_yuy16_nonePK16render_primitivePvjP16_quad_setup_data","__ZL22rgb888_draw_quad_rgb15PK16render_primitivePvjP16_quad_setup_data","__ZL22rgb888_draw_quad_rgb32PK16render_primitivePvjP16_quad_setup_data","__ZL26rgb888_draw_quad_rgb32_addPK16render_primitivePvjP16_quad_setup_data","__ZL29rgb888_draw_quad_argb32_alphaPK16render_primitivePvjP16_quad_setup_data","__ZL32rgb888_draw_quad_argb32_multiplyPK16render_primitivePvjP16_quad_setup_data","__ZL27rgb888_draw_quad_argb32_addPK16render_primitivePvjP16_quad_setup_data","__ZL20rgba_bilinear_filterjjjjhh","__ZL19rgb_bilinear_filterjjjjhh","__ZL25get_texel_argb32_bilinearPK14render_texinfoii","__ZL24get_texel_rgb32_bilinearPK14render_texinfoii","__ZL24get_texel_rgb15_bilinearPK14render_texinfoii","__ZL10ycc_to_rgbj","__ZL14clamp16_shift8j","__ZL15div_32x32_shiftiih4901","__ZL12mul_32x32_hiii4902","__ZN9hash_base7fromhexEc","__ZL20rgb888_draw_aa_pixelPvjiij","__ZN19render_layer_config26set_screen_overlay_enabledEb","__ZL24get_texel_yuy16_bilinearPK14render_texinfoii","__ZL29get_texel_palette16a_bilinearPK14render_texinfoii","__ZL28get_texel_palette16_bilinearPK14render_texinfoii","__ZNK11emu_options5speedEv","__ZN9hash_baseC2EcPKchPh","__ZN9hash_base11from_bufferEPKhi","__ZNK8hash_crccvjEv","__ZN8hash_crc3endEv","__ZNK9hash_base2idEv","__ZN9hash_base6stringER7astring","__ZN9hash_base11from_stringERPKci","__ZN8hash_crcC2Ev","__ZN8hash_crc5beginEv","__ZN8hash_crc6bufferEPKhj","__ZN8hash_md5C2Ev","__ZN8hash_md55beginEv","__ZN8hash_md56bufferEPKhj","__ZN8hash_md53endEv","__ZN9hash_sha1C2Ev","__ZN9hash_sha15beginEv","__ZN9hash_sha16bufferEPKhj","__ZN9hash_sha13endEv","__ZN11simple_listI9hash_baseEC1ER13resource_pool","__ZN15hash_collection20from_internal_stringEPKc","__ZN11simple_listI9hash_baseED1Ev","__ZN15hash_collection8copyfromERKS_","__ZN15hash_collectionaSERKS_","__ZNK15hash_collectioneqERKS_","__ZNK15hash_collection4hashEc","__ZNK9hash_baseneERKS_","__ZNK15hash_collection10hash_typesER7astring","__ZN7astring3catEc","__ZN15hash_collection5resetEv","__ZN11simple_listI9hash_baseE5resetEv","__ZN15hash_collectionC2Ev","__ZN15hash_collectionC2EPKc","__ZN15hash_collectionD2Ev","__Z8downcastIPK8hash_crc9hash_baseET_PT0_","__ZN11simple_listI9hash_baseE6appendERS0_","__ZN15hash_collection15add_from_bufferEcPKhi","__ZN11simple_listI9hash_baseE6removeERS0_","__ZN15hash_collection15add_from_stringEcPKci","__ZNK15hash_collection3crcERj","__ZN15hash_collection7add_crcEj","__ZN15hash_collection5beginEPKc","__ZN15hash_collection6bufferEPKhj","__ZN15hash_collection11alloc_by_idEc","__ZNK15hash_collection12macro_stringER7astring","__ZN9hash_baseD2Ev","__ZNK9hash_base11in_progressEv","__ZN9hash_base6bufferEv","__ZNK9hash_base6lengthEv","__ZN15hash_collection3endEv","__ZN8hash_crcD1Ev","__ZN8hash_md5D1Ev","__ZN9hash_sha1D1Ev","__ZN9hash_baseD1Ev","__ZN20resource_pool_objectI9hash_sha1EC1EPS0_","__ZN13resource_pool10add_objectI8hash_crcEEPT_S3_","__ZN13resource_pool10add_objectI8hash_md5EEPT_S3_","__ZN13resource_pool10add_objectI9hash_sha1EEPT_S3_","__ZN8hash_crcD0Ev","__ZN8hash_md5D0Ev","__ZN9hash_sha1D0Ev","__ZN9hash_baseD0Ev","__ZN11simple_listI9hash_baseE6detachERS0_","__ZN11simple_listI9hash_baseEC2ER13resource_pool","__ZN16info_xml_creatorC2ER17driver_enumerator","__ZN20resource_pool_objectI9hash_sha1EC2EPS0_","__ZN20resource_pool_objectI9hash_sha1ED1Ev","__ZN20resource_pool_objectI8hash_md5EC1EPS0_","__ZN20resource_pool_objectI8hash_md5EC2EPS0_","__ZN20resource_pool_objectI8hash_md5ED1Ev","__ZN20resource_pool_objectI8hash_crcEC1EPS0_","__ZN20resource_pool_objectI8hash_crcEC2EPS0_","__ZN20resource_pool_objectI8hash_crcED1Ev","__ZN11simple_listI9hash_baseED2Ev","__ZN9hash_sha1D2Ev","__ZN8hash_md5D2Ev","__ZN8hash_crcD2Ev","__ZN16info_xml_creator6outputEP7__sFILE","__ZN20resource_pool_objectI9hash_sha1ED0Ev","__ZN20resource_pool_objectI9hash_sha1ED2Ev","__ZN20resource_pool_objectI8hash_md5ED0Ev","__ZN20resource_pool_objectI8hash_md5ED2Ev","__ZN20resource_pool_objectI8hash_crcED0Ev","__ZN20resource_pool_objectI8hash_crcED2Ev","__ZN11simple_listI9hash_baseED0Ev","__ZN16info_xml_creator15output_sampleofEv","__ZN16info_xml_creator11output_biosEv","__ZN16info_xml_creator10output_oneEv","__ZN16info_xml_creator13output_sampleEv","__ZN16info_xml_creator12output_chipsEv","__ZN16info_xml_creator10output_romEv","__ZN16info_xml_creator14output_displayEv","__ZN16info_xml_creator12output_soundEv","__ZN16info_xml_creator12output_inputERK11tagged_listI17input_port_configE","__ZN16info_xml_creator15output_switchesERK11tagged_listI17input_port_configEiPKcS6_","__ZN16info_xml_creator17output_categoriesERK11tagged_listI17input_port_configE","__ZN16info_xml_creator16output_adjustersERK11tagged_listI17input_port_configE","__ZN16info_xml_creator13output_driverEv","__ZN16info_xml_creator12output_slotsEv","__ZN16info_xml_creator13output_imagesEv","__ZNK13screen_device24oldstyle_vblank_suppliedEv","__ZN22debug_view_source_listC2ER15running_machine","__ZNK22debug_view_source_list7machineEv","__ZN22debug_view_source_list6appendER17debug_view_source","__ZNK22debug_view_source_list12match_deviceEP8device_t","__ZN16info_xml_creator20output_software_listEv","__ZNK22device_image_interface15image_type_nameEv","__ZN17debug_view_sourceC2EPKcP8device_t","__ZN17debug_view_sourceD2Ev","__ZN22debug_view_source_listD2Ev","__ZN22debug_view_source_list5resetEv","__ZN16info_xml_creator17output_ramoptionsEv","__ZN16info_xml_creator14get_merge_nameERK15hash_collection","__ZN17debug_view_sourceD0Ev","__ZN10debug_view11view_notifyE23debug_view_notification","__ZNK10debug_view7machineEv","__ZN10debug_view27adjust_visible_x_for_cursorEv","__ZN10debug_view27adjust_visible_y_for_cursorEv","__ZN10debug_viewD2Ev","__ZN10debug_view17flush_osd_updatesEv","__ZN10debug_view16set_visible_sizeE13debug_view_xy","__ZN10debug_view20set_visible_positionE13debug_view_xy","__ZN10debug_view19set_cursor_positionE13debug_view_xy","__ZN10debug_view18set_cursor_visibleEb","__ZN10debug_view10set_sourceERK17debug_view_source","__ZN10debug_viewC2ER15running_machine15debug_view_typePFvRS_PvES4_","__ZN13resource_pool9add_arrayI15debug_view_charEEPT_S3_i","__ZN10debug_viewD0Ev","__ZN10debug_view10end_updateEv","__ZN10debug_view9view_charEi","__ZN18debug_view_managerC2ER15running_machine","__ZNK18debug_view_manager7machineEv","__ZN18debug_view_manager6appendEP10debug_view","__ZN18debug_view_managerD2Ev","__ZN18debug_view_manager10alloc_viewE15debug_view_typePFvR10debug_viewPvES3_","__ZNK10debug_view4typeEv","__ZNK10debug_view4nextEv","__ZN18debug_view_manager9free_viewER10debug_view","__ZN18debug_view_manager10update_allE15debug_view_type","__ZN10debug_view12force_updateEv","__ZN18debug_view_manager17flush_osd_updatesEv","__ZN21debug_view_expression11set_contextEP12symbol_table","__ZN13resource_pool10add_objectI18debug_view_consoleEEPT_S3_","__ZN13resource_pool10add_objectI16debug_view_stateEEPT_S3_","__ZN13resource_pool10add_objectI17debug_view_disasmEEPT_S3_","__ZN13resource_pool10add_objectI17debug_view_memoryEEPT_S3_","__ZN13resource_pool10add_objectI14debug_view_logEEPT_S3_","__ZN21debug_view_expressionC2ER15running_machine","__ZN21debug_view_expressionD2Ev","__ZN17parsed_expression11set_symbolsEP12symbol_table","__ZNK21debug_view_expression7machineEv","__ZN20resource_pool_objectI14debug_view_logEC1EPS0_","__ZN20resource_pool_objectI14debug_view_logEC2EPS0_","__ZN20resource_pool_objectI14debug_view_logED1Ev","__ZN20resource_pool_objectI17debug_view_memoryEC1EPS0_","__ZN20resource_pool_objectI17debug_view_memoryEC2EPS0_","__ZN20resource_pool_objectI17debug_view_memoryED1Ev","__ZN20resource_pool_objectI17debug_view_disasmEC1EPS0_","__ZN20resource_pool_objectI17debug_view_disasmEC2EPS0_","__ZN20resource_pool_objectI17debug_view_disasmED1Ev","__ZN20resource_pool_objectI16debug_view_stateEC1EPS0_","__ZN20resource_pool_objectI16debug_view_stateEC2EPS0_","__ZN20resource_pool_objectI16debug_view_stateED1Ev","__ZN21debug_view_expression9recomputeEv","__ZN20resource_pool_objectI14debug_view_logED0Ev","__ZN20resource_pool_objectI14debug_view_logED2Ev","__ZN20resource_pool_objectI17debug_view_memoryED0Ev","__ZN20resource_pool_objectI17debug_view_memoryED2Ev","__ZN20resource_pool_objectI17debug_view_disasmED0Ev","__ZN20resource_pool_objectI17debug_view_disasmED2Ev","__ZN20resource_pool_objectI16debug_view_stateED0Ev","__ZNK12sound_stream11input_countEv","__ZNK12sound_stream12output_countEv","__ZN20resource_pool_objectI18debug_view_consoleEC1EPS0_","__ZN20resource_pool_objectI18debug_view_consoleEC2EPS0_","__ZN20resource_pool_objectI18debug_view_consoleED1Ev","__ZN19resource_pool_arrayI15debug_view_charEC1EPS0_i","__ZN19resource_pool_arrayI15debug_view_charEC2EPS0_i","__ZN19resource_pool_arrayI15debug_view_charED1Ev","__ZN11simple_listIN22device_sound_interface11sound_routeEEC1ER13resource_pool","__ZN11simple_listIN22device_sound_interface11sound_routeEED1Ev","__ZN11simple_listIN22device_sound_interface11sound_routeEE5resetEv","__ZNK22device_sound_interface6inputsEv","__ZNK13sound_manager12first_streamEv","__ZNK22device_sound_interface7outputsEv","__ZN22device_sound_interface21input_to_stream_inputEiRi","__ZN20resource_pool_objectI16debug_view_stateED2Ev","__ZN20resource_pool_objectI18debug_view_consoleED0Ev","__ZN20resource_pool_objectI18debug_view_consoleED2Ev","__ZN19resource_pool_arrayI15debug_view_charED0Ev","__ZN19resource_pool_arrayI15debug_view_charED2Ev","__ZN22device_sound_interfaceC2ERK14machine_configR8device_t","__ZN22device_sound_interfaceD0Ev","__ZN22device_sound_interfaceD2Ev","__ZNK22device_sound_interface11sound_route4nextEv","__ZN11simple_listIN22device_sound_interface11sound_routeEE6detachERS1_","__ZN11simple_listIN22device_sound_interface11sound_routeEEC2ER13resource_pool","__ZNK11simple_listIN22device_sound_interface11sound_routeEE5firstEv","__ZN22device_sound_interface23output_to_stream_outputEiRi","__ZNK22device_sound_interface24interface_validity_checkER11emu_optionsRK11game_driver","__ZNK22device_sound_interface11first_routeEv","__ZNK8device_t9interfaceIK22device_sound_interfaceEEbRPT_","__ZN22device_sound_interface19interface_pre_resetEv","__ZN11simple_listIN22device_sound_interface11sound_routeEE6removeERS1_","__ZN11simple_listIN22device_sound_interface11sound_routeEED2Ev","__ZN23device_disasm_interfaceC2ERK14machine_configR8device_t","__ZN22device_sound_interface19interface_pre_startEv","__ZN22device_sound_interface20interface_post_startEv","__ZN11simple_listIN22device_sound_interface11sound_routeEED0Ev","__ZN23device_disasm_interfaceD2Ev","__ZThn368_N24legacy_image_device_baseD0Ev","__ZThn368_N24legacy_image_device_baseD1Ev","__ZN19image_device_formatC1Ev","__ZN24legacy_image_device_base9call_loadEv","__ZThn368_N24legacy_image_device_base9call_loadEv","__ZN24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry","__ZThn368_N24legacy_image_device_base18call_softlist_loadEPcS0_P9rom_entry","__ZN24legacy_image_device_base11call_createEiP18_option_resolution","__ZThn368_N24legacy_image_device_base11call_createEiP18_option_resolution","__ZN24legacy_image_device_base11call_unloadEv","__ZN23device_disasm_interfaceD0Ev","__ZN24legacy_image_device_baseD0Ev","__ZN24legacy_image_device_baseD2Ev","__ZN24legacy_image_device_baseC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_jPFvPKS3_jP10deviceinfoE","__ZN24legacy_image_device_base22device_config_completeEv","__ZN13resource_pool10add_objectI19image_device_formatEEPT_S3_","__ZN13path_iteratorC2EPKc","__ZThn368_N24legacy_image_device_base11call_unloadEv","__ZN24legacy_image_device_base12call_displayEv","__ZThn368_N24legacy_image_device_base12call_displayEv","__ZN24legacy_image_device_base17call_display_infoEv","__ZThn368_N24legacy_image_device_base17call_display_infoEv","__ZN24legacy_image_device_base16call_get_devicesEv","__ZThn368_N24legacy_image_device_base16call_get_devicesEv","__ZNK24legacy_image_device_base16get_partial_hashEv","__ZThn368_NK24legacy_image_device_base16get_partial_hashEv","__ZN24legacy_image_device_base24get_device_specific_callEv","__ZThn368_N24legacy_image_device_base24get_device_specific_callEv","__ZN20resource_pool_objectI19image_device_formatEC1EPS0_","__ZN20resource_pool_objectI19image_device_formatEC2EPS0_","__ZN20resource_pool_objectI19image_device_formatED1Ev","__ZN19image_device_formatD1Ev","__ZN13path_iterator4nextER7astringPKc","__ZN15file_enumeratorC2EPKc","__ZN15file_enumerator4nextEv","__ZN20resource_pool_objectI19image_device_formatED0Ev","__ZN20resource_pool_objectI19image_device_formatED2Ev","__ZN19image_device_formatD2Ev","__ZN19image_device_formatC2Ev","__ZN15file_enumeratorD2Ev","__ZN8emu_file5closeEv","__ZN8emu_filecvP10_core_fileEv","__ZN8emu_fileC2Ej","__ZN8emu_fileC2EPKcj","__ZN8emu_fileD0Ev","__ZN8emu_fileD2Ev","__ZN8emu_file16load_zipped_fileEv","__ZN8emu_filecvR10_core_fileEv","__ZN13path_iterator5resetEv","__ZN8emu_file4openEPKc","__ZN8emu_file9open_nextEv","__ZN7astringC1EPKcS1_S1_S1_","__ZN8emu_file4openEPKcj","__ZN8emu_file8open_ramEPKvj","__ZN8emu_file8compressEi","__ZN8emu_file6hashesEPKc","__ZN8emu_file4openEPKcS1_","__ZN8emu_file4openEPKcS1_S1_","__ZN8emu_file4openEPKcS1_S1_S1_","__ZN8emu_file4openEPKcS1_S1_j","__ZN8emu_file14attempt_zippedEv","__ZN20dummy_profiler_stateC2Ev","__ZN8emu_file18zip_header_is_pathERK16_zip_file_header","__ZN8emu_file4seekExi","__ZN8emu_file3eofEv","__ZN8emu_file4sizeEv","__ZN8emu_file4readEPvj","__ZN8emu_file5writeEPKvj","__ZN8emu_file4putsEPKc","__ZN8emu_file6printfEPKcz","__ZN8emu_file7vprintfEPKcPc","__ZN7astring9inssubstrEiRKS_ii","__ZN8emu_file18zip_filename_matchERK16_zip_file_headerRK7astring","__ZNK7astring4icmpEPKc","__ZN7astringC2EPKcS1_S1_S1_","___cxx_global_var_init5326","__GLOBAL__I_a5328","__Z16ram_parse_stringPKc","__Z21device_get_config_ramPK8device_tjP10deviceinfo","__ZL16device_start_ramP8device_t","__ZL25device_validity_check_ramPK11game_driverPK8device_tR11emu_options","__ZL14get_safe_tokenP8device_t5350","__ZN10ram_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN10ram_deviceD1Ev","__ZN10ram_deviceD2Ev","__ZN20resource_pool_objectI10ram_deviceEC1EPS0_","__ZN20resource_pool_objectI10ram_deviceEC2EPS0_","__ZN20resource_pool_objectI10ram_deviceED1Ev","__Z21legacy_device_creatorI10ram_deviceEP8device_tRK14machine_configPKcS2_j","__ZN10ram_deviceD0Ev","__ZN13resource_pool10add_objectI10ram_deviceEEPT_S3_","__ZN20resource_pool_objectI10ram_deviceED0Ev","__ZN14speaker_device19sound_stream_updateER12sound_streamPPiS3_i","__ZNK11emu_options8ram_sizeEv","__ZN8device_t12save_pointerIhEEvPT_PKcji","__ZThn356_N14speaker_deviceD0Ev","__ZThn356_N14speaker_deviceD1Ev","__ZN14speaker_device12device_startEv","__ZN14speaker_device16device_post_loadEv","__ZThn356_N14speaker_device19sound_stream_updateER12sound_streamPPiS3_i","__ZN14speaker_device3mixEPiS0_Rib","__ZN20resource_pool_objectI10ram_deviceED2Ev","__Z14device_creatorI14speaker_deviceEP8device_tRK14machine_configPKcS2_j","__ZN14speaker_deviceC2ERK14machine_configPKcP8device_tj","__ZN14speaker_deviceD0Ev","__ZN14speaker_deviceD2Ev","__ZN20resource_pool_objectI14speaker_deviceEC1EPS0_","__ZN20resource_pool_objectI14speaker_deviceEC2EPS0_","__ZN20resource_pool_objectI14speaker_deviceED1Ev","__Z11ui_gfx_initR15running_machine","__ZL11ui_gfx_exitR15running_machine","__Z17ui_gfx_ui_handlerR15running_machineP16render_containerj","__ZN13resource_pool10add_objectI14speaker_deviceEEPT_S3_","__ZN20resource_pool_objectI14speaker_deviceED0Ev","__ZN20resource_pool_objectI14speaker_deviceED2Ev","__ZL15palette_handlerR15running_machineP16render_containerP13_ui_gfx_state","__ZL14gfxset_handlerR15running_machineP16render_containerP13_ui_gfx_state","__ZL15tilemap_handlerR15running_machineP16render_containerP13_ui_gfx_state","__ZL21tilemap_update_bitmapR15running_machineP13_ui_gfx_stateii","__ZL22orientation_swap_flipsi5374","__ZL19tilemap_handle_keysR15running_machineP13_ui_gfx_stateii","__ZL15orientation_addii5373","__ZN16render_container9add_pointEfffjj","__ZL20gfxset_update_bitmapR15running_machineP13_ui_gfx_stateiiP11gfx_element","__ZL18gfxset_handle_keysR15running_machineP13_ui_gfx_stateii","__ZL16gfxset_draw_itemR15running_machinePK11gfx_elementiP8bitmap_tiiii","__ZL20gfx_element_get_dataPK11gfx_elementj5375","__ZN21cassette_image_device11is_motor_onEv","__ZL19palette_handle_keysR15running_machineP13_ui_gfx_state","__ZThn376_N21cassette_image_deviceD0Ev","__ZThn376_N21cassette_image_deviceD1Ev","__ZN21cassette_image_device22device_config_completeEv","__ZN21cassette_image_device6updateEv","__ZN21cassette_image_device10get_lengthEv","__Z14device_creatorI21cassette_image_deviceEP8device_tRK14machine_configPKcS2_j","__ZN21cassette_image_deviceC2ERK14machine_configPKcP8device_tj","__ZN21cassette_image_deviceD0Ev","__ZN21cassette_image_deviceD2Ev","__ZNK21cassette_image_device10image_typeEv","__ZNK21cassette_image_device11is_readableEv","__ZNK21cassette_image_device12is_writeableEv","__ZNK21cassette_image_device12is_creatableEv","__ZNK21cassette_image_device14must_be_loadedEv","__ZNK21cassette_image_device16is_reset_on_loadEv","__ZNK21cassette_image_device19create_option_guideEv","__ZN21cassette_image_device12device_startEv","__ZN22device_image_interface11is_readonlyEv","__ZN22device_image_interface13make_readonlyEv","__ZN21cassette_image_device9get_stateEv","__ZNK21cassette_image_device15image_interfaceEv","__ZNK21cassette_image_device15file_extensionsEv","__ZN21cassette_image_device12change_stateE15_cassette_stateS0_","__ZN21cassette_image_device12get_positionEv","__ZN21cassette_image_device4seekEdi","__ZN21cassette_image_device9call_loadEv","__ZN22device_image_interface8filetypeEv","__ZThn376_N21cassette_image_device9call_loadEv","__ZN21cassette_image_device11call_unloadEv","__ZThn376_N21cassette_image_device11call_unloadEv","__ZN21cassette_image_device12call_displayEv","__ZThn376_N21cassette_image_device12call_displayEv","__ZN21cassette_image_device17call_display_infoEv","__ZN21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry","__ZThn376_N21cassette_image_device18call_softlist_loadEPcS0_P9rom_entry","__ZThn376_N21cassette_image_device17call_display_infoEv","__ZThn376_NK21cassette_image_device10image_typeEv","__ZThn376_NK21cassette_image_device11is_readableEv","__ZThn376_NK21cassette_image_device12is_writeableEv","__ZThn376_NK21cassette_image_device12is_creatableEv","__ZThn376_NK21cassette_image_device14must_be_loadedEv","__ZThn376_NK21cassette_image_device16is_reset_on_loadEv","__ZThn376_NK21cassette_image_device15image_interfaceEv","__ZThn376_NK21cassette_image_device15file_extensionsEv","__ZThn376_NK21cassette_image_device19create_option_guideEv","__ZN20resource_pool_objectI21cassette_image_deviceEC1EPS0_","__ZN20resource_pool_objectI21cassette_image_deviceEC2EPS0_","__ZN20resource_pool_objectI21cassette_image_deviceED1Ev","__ZN13resource_pool10add_objectI21cassette_image_deviceEEPT_S3_","__Z21bitbanger_mode_stringP8device_t","__ZL9get_tokenP8device_t5425","__Z18bitbanger_inc_modeP8device_tb","__Z18bitbanger_dec_modeP8device_tb","__Z21bitbanger_tune_stringP8device_t","__Z21bitbanger_baud_stringP8device_t","__Z18bitbanger_inc_baudP8device_tb","__ZL20bitbanger_baud_valueP8device_t","__Z18bitbanger_dec_baudP8device_tb","__Z18bitbanger_inc_tuneP8device_tb","__Z18bitbanger_dec_tuneP8device_tb","__Z27device_get_config_bitbangerPK8device_tjP10deviceinfo","__ZL21device_load_bitbangerR22device_image_interface","__ZL23device_unload_bitbangerR22device_image_interface","__ZN16bitbanger_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN20resource_pool_objectI21cassette_image_deviceED0Ev","__ZN20resource_pool_objectI21cassette_image_deviceED2Ev","__ZL22device_start_bitbangerP8device_t","__Z21legacy_device_creatorI16bitbanger_deviceEP8device_tRK14machine_configPKcS2_j","__ZN16bitbanger_deviceD1Ev","__ZThn368_N16bitbanger_deviceD1Ev","__ZThn368_N16bitbanger_deviceD0Ev","__ZN16bitbanger_deviceD2Ev","__ZN20resource_pool_objectI16bitbanger_deviceEC1EPS0_","__ZN20resource_pool_objectI16bitbanger_deviceEC2EPS0_","__ZN20resource_pool_objectI16bitbanger_deviceED1Ev","__ZL10get_configP8device_t","__ZL22bitbanger_output_timerR15running_machinePvi","__ZL21bitbanger_input_timerR15running_machinePvi","__ZL27bitbanger_bytes_to_bits_81NP8device_t","__ZL12native_inputP8device_tPvj","__ZL13native_outputP8device_th","__ZN9emu_timer5resetE8attotime","__ZL20bitbanger_tune_valueP8device_t","__ZL14get_safe_tokenP8device_t5459","__ZN16bitbanger_deviceD0Ev","__ZN13resource_pool10add_objectI16bitbanger_deviceEEPT_S3_","__ZN20resource_pool_objectI16bitbanger_deviceED0Ev","__ZN20resource_pool_objectI16bitbanger_deviceED2Ev","__Z24ldcore_set_video_squelchP16_laserdisc_stateh","__ZL19add_and_clamp_trackP12_ldcore_datai","__Z24laserdisc_get_field_codeP8device_tjh","__Z21ldcore_get_safe_tokenP8device_t","__Z24ldcore_set_audio_squelchP16_laserdisc_statehh","__ZL12update_audioP16_laserdisc_state","__Z23ldcore_set_slider_speedP16_laserdisc_statei","__ZL17update_slider_posP12_ldcore_data8attotime","__Z21ldcore_advance_sliderP16_laserdisc_statei","__Z26ldcore_get_slider_positionP16_laserdisc_state","__Z20laserdisc_get_configP8device_tP17_laserdisc_config","__Z20laserdisc_set_configP8device_tPK17_laserdisc_config","__Z27device_get_config_laserdiscPK8device_tjP10deviceinfo","__ZL13get_interfacePK8device_t","__ZL21device_stop_laserdiscP8device_t","__ZN16laserdisc_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN16laserdisc_deviceD1Ev","__ZL22device_start_laserdiscP8device_t","__ZL22device_reset_laserdiscP8device_t","__Z21legacy_device_creatorI16laserdisc_deviceEP8device_tRK14machine_configPKcS2_j","__ZN16laserdisc_deviceD2Ev","__ZN20resource_pool_objectI16laserdisc_deviceEC1EPS0_","__ZN20resource_pool_objectI16laserdisc_deviceEC2EPS0_","__ZN20resource_pool_objectI16laserdisc_deviceED1Ev","__ZN12_ldcore_dataC1Ev","__ZN16laserdisc_deviceD0Ev","__ZN13resource_pool10add_objectI16laserdisc_deviceEEPT_S3_","__ZN20resource_pool_objectI16laserdisc_deviceED0Ev","__ZN20resource_pool_objectI16laserdisc_deviceED2Ev","__ZN13resource_pool10add_objectI12_ldcore_dataEEPT_S3_","__ZL9init_discP8device_t","__ZL10init_videoP8device_t","__ZL16fillbitmap_yuy16P8bitmap_thhh","__ZL18configuration_loadR15running_machineiP14_xml_data_node","__ZL18configuration_saveR15running_machineiP14_xml_data_node","__ZN8delegateIFvR13screen_devicebEEC1I8device_tEEN15delegate_traitsIT_vS1_b8_noparamS8_E16static_func_typeEPKcPS7_","__ZL20vblank_state_changedP8device_tR13screen_deviceb","__ZL21perform_player_updateR15running_machinePvi","__ZL10init_audioP8device_t","__ZL18process_track_dataP8device_t","__ZL15read_track_dataP16_laserdisc_state","__ZN8delegateIFvR13screen_devicebEEC2I8device_tEEN15delegate_traitsIT_vS1_b8_noparamS8_E16static_func_typeEPKcPS7_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_EC2I8device_tEEN15delegate_traitsIT_vS1_bS2_S2_E16static_func_typeEPKcPS7_","__ZN13delegate_baseIvR13screen_deviceb8_noparamS2_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind","__ZN12_ldcore_dataC2Ev","__ZN20resource_pool_objectI12_ldcore_dataEC1EPS0_","__ZN20resource_pool_objectI12_ldcore_dataEC2EPS0_","__ZN20resource_pool_objectI12_ldcore_dataED1Ev","__ZN20resource_pool_objectI12_ldcore_dataED0Ev","__Z18vector_get_flickerv","__Z15vector_get_beamv","__Z15vector_set_beamf","__Z18vector_set_flickerf","__Z17text_buffer_clearP12_text_buffer","__ZN12_ldcore_dataD1Ev","__ZN12_ldcore_dataD2Ev","__Z8wav_openPKcii","__Z9wav_closeP9_wav_file","__Z15wav_add_data_16P9_wav_filePsi","__Z17text_buffer_allocjj","__Z16text_buffer_freeP12_text_buffer","__Z17text_buffer_printP12_text_bufferPKc","__ZN20resource_pool_objectI12_ldcore_dataED2Ev","__Z21text_buffer_max_widthP12_text_buffer","__Z21text_buffer_num_linesP12_text_buffer","__Z32text_buffer_line_index_to_seqnumP12_text_bufferj","__ZL11buffer_usedP12_text_buffer","__ZL11execute_minR12symbol_tablePviPKy","__ZL11execute_maxR12symbol_tablePviPKy","__ZL10execute_ifR12symbol_tablePviPKy","__Z22text_buffer_print_wrapP12_text_bufferPKci","__ZL12buffer_spaceP12_text_buffer","__Z27text_buffer_get_seqnum_lineP12_text_bufferj","__Z18debug_command_initR15running_machine","__ZL10global_getR12symbol_tablePv","__ZL10global_setR12symbol_tablePvy","__ZL12execute_helpR15running_machineiiPPKc","__ZL13execute_printR15running_machineiiPPKc","__ZL14execute_printfR15running_machineiiPPKc","__ZL16execute_logerrorR15running_machineiiPPKc","__ZL16execute_tracelogR15running_machineiiPPKc","__ZL12execute_quitR15running_machineiiPPKc","__ZL10execute_doR15running_machineiiPPKc","__ZL12execute_stepR15running_machineiiPPKc","__ZL12execute_overR15running_machineiiPPKc","__ZL11execute_outR15running_machineiiPPKc","__ZL10execute_goR15running_machineiiPPKc","__ZL17execute_go_vblankR15running_machineiiPPKc","__ZL20execute_go_interruptR15running_machineiiPPKc","__ZL15execute_go_timeR15running_machineiiPPKc","__ZL12execute_nextR15running_machineiiPPKc","__ZL13execute_focusR15running_machineiiPPKc","__ZL15execute_commentR15running_machineiiPPKc","__ZL19execute_comment_delR15running_machineiiPPKc","__ZL20execute_comment_saveR15running_machineiiPPKc","__ZL15execute_bpclearR15running_machineiiPPKc","__ZL14execute_ignoreR15running_machineiiPPKc","__ZL15execute_observeR15running_machineiiPPKc","__ZL13execute_bpsetR15running_machineiiPPKc","__ZL19execute_bpdisenableR15running_machineiiPPKc","__ZL15execute_wpclearR15running_machineiiPPKc","__ZL19execute_wpdisenableR15running_machineiiPPKc","__ZL14execute_bplistR15running_machineiiPPKc","__ZL13execute_wpsetR15running_machineiiPPKc","__ZL15execute_hotspotR15running_machineiiPPKc","__ZL12execute_saveR15running_machineiiPPKc","__ZL12execute_loadR15running_machineiiPPKc","__ZL14execute_wplistR15running_machineiiPPKc","__ZL12execute_dumpR15running_machineiiPPKc","__ZL17execute_cheatinitR15running_machineiiPPKc","__ZL17execute_cheatnextR15running_machineiiPPKc","__ZL17execute_cheatlistR15running_machineiiPPKc","__ZL17execute_cheatundoR15running_machineiiPPKc","__ZL12execute_findR15running_machineiiPPKc","__ZL12execute_dasmR15running_machineiiPPKc","__ZL13execute_traceR15running_machineiiPPKc","__ZL17execute_traceoverR15running_machineiiPPKc","__ZL18execute_traceflushR15running_machineiiPPKc","__ZL15execute_historyR15running_machineiiPPKc","__ZL14execute_sourceR15running_machineiiPPKc","__ZL11execute_mapR15running_machineiiPPKc","__ZL12execute_snapR15running_machineiiPPKc","__ZNK16expression_error6offsetEv","__ZNK12symbol_entry4nextEv","__ZNK11simple_listI12symbol_entryE5firstEv","__ZL15execute_memdumpR15running_machineiiPPKc","__ZL15execute_symlistR15running_machineiiPPKc","__ZL17execute_softresetR15running_machineiiPPKc","__ZL17execute_hardresetR15running_machineiiPPKc","__ZL14execute_imagesR15running_machineiiPPKc","__ZL13execute_mountR15running_machineiiPPKc","__ZL15execute_unmountR15running_machineiiPPKc","__ZL18debug_command_exitR15running_machine","__ZNK11emu_options12debug_scriptEv","__Z33debug_command_parameter_cpu_spaceR15running_machinePKciPP13address_space","__ZNK12symbol_table5firstEv","__ZNK12symbol_entry4nameEv","__ZL19symbol_sort_comparePKvS0_","__ZNK11tagged_listI12symbol_entryE5firstEv","__Z30debug_command_parameter_numberR15running_machinePKcPy","__Z27debug_command_parameter_cpuR15running_machinePKcPP8device_t","__ZL15cheat_byte_swapPK13_cheat_systemy","__ZL17cheat_sign_extendPK13_cheat_systemy","__ZNK13address_space3mapEv","__ZNK12device_debug24hotspot_tracking_enabledEv","__ZNK12device_debug16watchpoint_firstE16address_spacenum","__ZNK12device_debug10watchpoint5spaceEv","__ZNK12device_debug10watchpoint7enabledEv","__ZNK12device_debug10watchpoint7addressEv","__ZNK12device_debug10watchpoint6lengthEv","__ZNK12device_debug10watchpoint4typeEv","__ZNK20address_space_config13byte2addr_endEj","__ZL22execute_trace_internalR15running_machineiiPPKci","__ZL31debug_command_parameter_commandR15running_machinePKc","__ZL19cheat_read_extendedPK13_cheat_systemP13address_spacej","__ZL22cheat_address_is_validP13address_spacej","__ZN19resource_pool_arrayI10_cheat_mapEC1EPS0_i","__ZN19resource_pool_arrayI10_cheat_mapEC2EPS0_i","__ZN19resource_pool_arrayI10_cheat_mapED1Ev","__ZNK13address_space19byte_to_address_endEj","__ZNK12device_debug10watchpoint9conditionEv","__ZNK12device_debug10watchpoint6actionEv","__ZN13resource_pool9add_arrayI10_cheat_mapEEPT_S3_i","__ZN19resource_pool_arrayI10_cheat_mapED0Ev","__ZN19resource_pool_arrayI10_cheat_mapED2Ev","__ZL34debug_command_parameter_expressionR15running_machinePKcR17parsed_expression","__ZNK12device_debug16breakpoint_firstEv","__ZNK12device_debug10breakpoint7enabledEv","__ZNK12device_debug10breakpoint7addressEv","__ZNK12device_debug9observingEv","__ZNK12device_debug10breakpoint9conditionEv","__ZNK12device_debug10breakpoint6actionEv","__ZL11mini_printfR15running_machinePcPKciPy","__Z26ui_image_menu_file_managerR15running_machineP7ui_menuPvS3_","__ZL26file_manager_destroy_stateP7ui_menuPv","__ZL21fix_working_directoryP22device_image_interface","__ZL26menu_file_manager_populateR15running_machineP7ui_menuPv","__ZL18menu_file_selectorR15running_machineP7ui_menuPvS3_","__Z24ui_image_menu_image_infoR15running_machineP7ui_menuPvS3_","__Z19tapecontrol_gettimeP7astringP21cassette_image_devicePiS3_","__Z25ui_mess_menu_tape_controlR15running_machineP7ui_menuPvS3_","__ZL14cassette_countR15running_machine","__Z30ui_mess_menu_bitbanger_controlR15running_machineP7ui_menuPvS3_","__ZL31menu_bitbanger_control_populateR15running_machineP7ui_menuP29_bitbanger_control_menu_state","__ZL15bitbanger_countR15running_machine","__ZL26menu_tape_control_populateR15running_machineP7ui_menuP24_tape_control_menu_state","__ZL22is_valid_filename_charj","__ZL27menu_file_selector_populateR15running_machineP7ui_menuP25_file_selector_menu_state","__ZL16menu_file_createR15running_machineP7ui_menuPvS3_","__ZL10check_pathPKc","__ZL15input_characterPcjjPFijE","__ZL20menu_confirm_save_asR15running_machineP7ui_menuPvS3_","__ZL29menu_confirm_save_as_populateR15running_machineP7ui_menuPv","__ZL18astring_assemble_2P7astringPKcS2_5806","__ZL24file_create_render_extraR15running_machineP7ui_menuPvS3_ffffff","__ZL17extra_text_renderR15running_machineP7ui_menuPvS3_ffffffPKcS5_","__ZL25menu_file_create_populateR15running_machineP7ui_menuPvS3_","__ZL16create_new_imageP22device_image_interfacePKcS2_Pi","__ZN22device_image_interface10part_entryEv","__ZL19extra_text_draw_boxR16render_containerffffPKci","__ZL12astring_catcP7astringPKc5807","__ZL26append_file_selector_entryP7ui_menuP25_file_selector_menu_state25_file_selector_entry_typePKcS5_","__ZL33append_dirent_file_selector_entryP7ui_menuP25_file_selector_menu_statePK20_osd_directory_entry","__ZL36append_file_selector_entry_menu_itemP7ui_menuPK20_file_selector_entry","__ZL26file_selector_render_extraR15running_machineP7ui_menuPvS3_ffffff","__ZL29compare_file_selector_entriesPK20_file_selector_entryS1_","__ZL25file_manager_render_extraR15running_machineP7ui_menuPvS3_ffffff","__ZN18debug_view_textbufC2ER15running_machine15debug_view_typePFvR10debug_viewPvES5_R12_text_buffer","__ZN18debug_view_textbufD2Ev","__ZN18debug_view_textbuf11view_updateEv","__ZN18debug_view_textbufD0Ev","__ZNK22debug_view_source_list5countEv","__ZN18debug_view_textbuf11view_notifyE23debug_view_notification","__ZN18debug_view_consoleC2ER15running_machinePFvR10debug_viewPvES4_","__ZN14debug_view_logC2ER15running_machinePFvR10debug_viewPvES4_","__ZN14debug_view_logD1Ev","__ZN18debug_view_consoleD1Ev","__ZN18debug_view_consoleD2Ev","__ZN14debug_view_logD2Ev","__ZN23debug_view_state_sourceC2EPKcR8device_t","__ZN16debug_view_state5resetEv","__ZN14debug_view_logD0Ev","__ZN18debug_view_consoleD0Ev","__ZN16debug_view_stateC2ER15running_machinePFvR10debug_viewPvES4_","__ZN16debug_view_state17enumerate_sourcesEv","__ZN16debug_view_stateD0Ev","__ZN16debug_view_stateD2Ev","__ZNK11device_list5firstI22device_state_interfaceEEbRPT_","__ZNK16device_interface4nextI22device_state_interfaceEEbRPT_","__ZN13resource_pool10add_objectI23debug_view_state_sourceEEPT_S3_","__ZN16debug_view_state9recomputeEv","__Z8downcastIRK23debug_view_state_sourceK17debug_view_sourceET_RT0_","__ZNK18device_state_entry7visibleEv","__ZN16debug_view_state11view_notifyE23debug_view_notification","__ZN16debug_view_state10state_itemC2EiPKch","__ZN23debug_view_state_sourceD1Ev","__ZN23debug_view_state_sourceD2Ev","__ZN20resource_pool_objectIN16debug_view_state10state_itemEEC1EPS1_","__ZN20resource_pool_objectIN16debug_view_state10state_itemEEC2EPS1_","__ZN20resource_pool_objectIN16debug_view_state10state_itemEED1Ev","__ZN13resource_pool10add_objectIN16debug_view_state10state_itemEEEPT_S4_","__ZN16debug_view_state11view_updateEv","__ZN23debug_view_state_sourceD0Ev","__ZN16debug_view_state10state_itemD1Ev","__ZN16debug_view_state10state_itemD2Ev","__ZN20resource_pool_objectI23debug_view_state_sourceEC1EPS0_","__ZN20resource_pool_objectI23debug_view_state_sourceEC2EPS0_","__ZN20resource_pool_objectI23debug_view_state_sourceED1Ev","__ZNK8device_t4nextI22device_state_interfaceEEbRPT_","__ZN20resource_pool_objectIN16debug_view_state10state_itemEED0Ev","__ZN20resource_pool_objectIN16debug_view_state10state_itemEED2Ev","__ZN20resource_pool_objectI23debug_view_state_sourceED0Ev","__ZN20resource_pool_objectI23debug_view_state_sourceED2Ev","__ZN24debug_view_disasm_sourceC2EPKcR8device_t","__ZN17debug_view_disasmC2ER15running_machinePFvR10debug_viewPvES4_","__Z8downcastIRK24debug_view_disasm_sourceK17debug_view_sourceET_RT0_","__Z8downcastIPK24debug_view_disasm_sourceK17debug_view_sourceET_PT0_","__ZNK24debug_view_disasm_source6deviceEv","__ZNK11device_list5firstI23device_disasm_interfaceEEbRPT_","__ZNK16device_interface4nextI23device_disasm_interfaceEEbRPT_","__ZN17debug_view_disasm11view_notifyE23debug_view_notification","__ZN17debug_view_disasm17enumerate_sourcesEv","__ZN17debug_view_disasmD0Ev","__ZN17debug_view_disasmD2Ev","__ZN13resource_pool10add_objectI24debug_view_disasm_sourceEEPT_S3_","__ZN17debug_view_disasm9view_charEi","__ZN17debug_view_disasm17find_pc_backwardsEji","__ZN17debug_view_disasm14generate_bytesEjiiPcib","__Z12device_stateP8device_t","__ZNK16direct_read_data9decryptedEv","__ZNK16direct_read_data3rawEv","__ZNK12device_debug20comment_change_countEv","__ZN17debug_view_disasm9recomputeEjii","__ZNK21debug_view_expression5dirtyEv","__ZNK21debug_view_expression10last_valueEv","__ZN17debug_view_disasm11view_updateEv","__ZN21debug_view_expression5valueEv","__ZN17debug_view_disasm16selected_addressEv","__ZN17debug_view_disasm14set_expressionEPKc","__ZN21debug_view_expression10set_stringEPKc","__ZN17debug_view_disasm16set_right_columnE19disasm_right_column","__ZN24debug_view_disasm_sourceD1Ev","__ZN24debug_view_disasm_sourceD2Ev","__ZN20resource_pool_objectI24debug_view_disasm_sourceEC1EPS0_","__ZN20resource_pool_objectI24debug_view_disasm_sourceEC2EPS0_","__ZN20resource_pool_objectI24debug_view_disasm_sourceED1Ev","__ZN24debug_view_disasm_sourceD0Ev","__ZNK13memory_regioncvPvEv","__ZNK8device_t4nextI23device_disasm_interfaceEEbRPT_","__ZN24debug_view_memory_sourceC2EPKcPvii","__ZN20resource_pool_objectI24debug_view_disasm_sourceED0Ev","__ZN20resource_pool_objectI24debug_view_disasm_sourceED2Ev","__ZN24debug_view_memory_sourceC2EPKcR13address_space","__ZN24debug_view_memory_sourceC2EPKcRK13memory_region","__ZN17debug_view_memoryC2ER15running_machinePFvR10debug_viewPvES4_","__ZN17debug_view_memory11view_notifyE23debug_view_notification","__ZN17debug_view_memory17enumerate_sourcesEv","__ZN13resource_pool10add_objectI24debug_view_memory_sourceEEPT_S3_","__Z8downcastIRK24debug_view_memory_sourceK17debug_view_sourceET_RT0_","__ZN17debug_view_memory14set_cursor_posENS_10cursor_posE","__ZN17debug_view_memory14get_cursor_posEv","__ZN17debug_view_memory11view_updateEv","__ZNK17debug_view_memory7section8containsEi","__ZN17debug_view_memory15needs_recomputeEv","__ZN17debug_view_memory9recomputeEv","__ZN17debug_view_memory4readEhjRy","__ZN17debug_view_memory9view_charEi","__ZN17debug_view_memory5writeEhjy","__ZN17debug_view_memory10cursor_posC1Ejh","__ZN17debug_view_memory14set_expressionEPKc","__ZN17debug_view_memoryD1Ev","__ZN24debug_view_memory_sourceD1Ev","__ZN24debug_view_memory_sourceD2Ev","__ZN20resource_pool_objectI24debug_view_memory_sourceEC1EPS0_","__ZN20resource_pool_objectI24debug_view_memory_sourceEC2EPS0_","__ZN20resource_pool_objectI24debug_view_memory_sourceED1Ev","__ZN17debug_view_memoryD0Ev","__ZN24debug_view_memory_sourceD0Ev","__ZN17debug_view_memory10cursor_posC2Ejh","__ZL12ppi0_portb_rP8device_tj","__ZL12ppi0_portc_rP8device_tj","__ZL12ppi0_porta_wP8device_tjh","__ZL12ppi0_portc_wP8device_tjh","__ZL12ppi1_porta_rP8device_tj","__ZL12ppi1_portb_wP8device_tjh","__ZL12ppi1_portc_wP8device_tjh","__ZL13ctc_interruptP8device_ti","__ZL13ldv1000_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZN20resource_pool_objectI24debug_view_memory_sourceED0Ev","__ZN20resource_pool_objectI24debug_view_memory_sourceED2Ev","__ZN17debug_view_memoryD2Ev","__ZL32construct_machine_config_ldv1000R14machine_configP8device_t","__ZL12ldv1000_initP16_laserdisc_state","__ZL14ldv1000_updateP16_laserdisc_statePK13_vbi_metadatai8attotime","__Z8downcastIP12timer_device8device_tET_PT0_","__ZL14ldv1000_data_wP16_laserdisc_statehh","__ZL16ldv1000_status_rP16_laserdisc_state","__ZL23ldv1000_status_strobe_rP16_laserdisc_state","__ZL24ldv1000_command_strobe_rP16_laserdisc_state","__ZL9vsync_offR15running_machinePvi","__ZN12timer_device7set_ptrEPv","__ZN8device_t24static_set_static_configERS_PKv","__ZN12timer_device6adjustE8attotimeiS0_","__ZN8attotime9from_usecEx","__ZNK13screen_device11scan_periodEv","__ZL14vbi_data_fetchR15running_machinePvi","__ZL33construct_address_map_ldv1000_mapR11address_mapRK8device_t","__ZL37construct_address_map_ldv1000_portmapR11address_mapRK8device_t","__ZL15multijump_timerR12timer_devicePvi","__ZL22decoder_display_port_rP13address_spacej","__ZL22decoder_display_port_wP13address_spacejh","__ZN18address_map_entry811set_handlerEPFhP13address_spacejEPKc","__ZL12controller_rP13address_spacej","__ZN18address_map_entry811set_handlerEPFvP13address_spacejhEPKc","__ZL12controller_wP13address_spacejh","__ZN18address_map_entry811set_handlerERK8device_tPKcPFhPS0_jES4_PFvS5_jhES4_","__Z27ui_mess_menu_software_partsR15running_machineP7ui_menuPvS3_","__Z25swinfo_has_multiple_partsP13software_infoPKc","__Z26ui_mess_menu_software_listR15running_machineP7ui_menuPvS3_","__ZL38ui_mess_menu_populate_software_entriesR15running_machineP7ui_menuP20_software_menu_state","__ZL36ui_mess_menu_populate_software_partsR15running_machineP7ui_menuPKcS4_S4_","__Z22ui_image_menu_softwareR15running_machineP7ui_menuPvS3_","__ZL35ui_mess_menu_populate_software_listR15running_machineP7ui_menuP22device_image_interface","__ZL21append_software_entryP7ui_menuP20_software_menu_stateP13software_infoPcP22device_image_interface","__ZL24compare_software_entriesPK21_software_entry_stateS1_i","__Z14debug_get_helpPKc","__ZL31construct_machine_config_pr8210R14machine_configP8device_t","__ZL13pr8210_updateP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZL16simutrek_ready_rP16_laserdisc_state","__ZL17simutrek_status_rP16_laserdisc_state","__ZL23simutrek_latched_data_wR15running_machinePvi","__ZL12pr8210_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZL14pr8210_overlayP16_laserdisc_stateP8bitmap_t","__ZL16pr8210_control_wP16_laserdisc_statehh","__ZL14simutrek_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZL15simutrek_updateP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZL15simutrek_data_wP16_laserdisc_statehh","__ZL20update_audio_squelchP16_laserdisc_state","__ZL7irq_offR15running_machinePvi","__ZL38construct_address_map_simutrek_portmapR11address_mapRK8device_t","__ZL15simutrek_data_rP13address_spacej","__ZL16simutrek_port2_rP13address_spacej","__ZL11pr8210_initP16_laserdisc_state","__ZL33construct_machine_config_simutrekR14machine_configP8device_t","__ZL13simutrek_initP16_laserdisc_state","__ZL13overlay_eraseP8bitmap_tff","__ZL17overlay_draw_charP8bitmap_thf","__ZL9vsync_offR15running_machinePvi6076","__ZL16simutrek_port2_wP13address_spacejh","__ZL13simutrek_t0_rP13address_spacej","__ZL18overlay_draw_groupP8bitmap_tPKhif","__ZL14vbi_data_fetchR15running_machinePvi6077","__ZL36construct_address_map_pr8210_portmapR11address_mapRK8device_t","__ZL11pr8210_t1_rP13address_spacej","__ZL11vp931_readyP16_laserdisc_state","__ZL16vp931_data_readyP16_laserdisc_state","__ZL12pr8210_pia_rP13address_spacej","__ZL12pr8210_pia_wP13address_spacejh","__ZL12pr8210_bus_rP13address_spacej","__ZL14pr8210_port1_wP13address_spacejh","__ZL14pr8210_port2_wP13address_spacejh","__ZL11pr8210_t0_rP13address_spacej","__ZL20update_video_squelchP16_laserdisc_state","__ZL11vp931_vsyncP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZL12vp931_updateP16_laserdisc_statePK13_vbi_metadatai8attotime","__ZL12vp931_data_wP16_laserdisc_statehh","__ZL12vp931_data_rP16_laserdisc_state","__ZL30construct_machine_config_vp931R14machine_configP8device_t","__ZL10vp931_initP16_laserdisc_state","__ZL8keypad_rP13address_spacej","__ZL9unknown_rP13address_spacej","__ZL5lcd_wP13address_spacejh","__ZL7port2_wP13address_spacejh","__ZL15deferred_data_wR15running_machinePvi","__ZL14datastrobe_offR15running_machinePvi","__ZL7erp_offR15running_machinePvi","__ZL14vbi_data_fetchR15running_machinePvi6106","__ZN8attotime9from_nsecEx","__ZL7irq_offR15running_machinePvi6107","__ZL35construct_address_map_vp931_portmapR11address_mapRK8device_t","__ZL11track_timerR12timer_devicePvi","__ZL9output0_wP13address_spacejh","__ZL9output1_wP13address_spacejh","__ZL7datic_rP13address_spacej","__ZL17from_controller_rP13address_spacej","__ZL15to_controller_wP13address_spacejh","__ZL7port1_rP13address_spacej","__ZL7port1_wP13address_spacejh","__ZL7port2_rP13address_spacej","__ZL4t0_rP13address_spacej","__ZL4t1_rP13address_spacej","__ZN12timer_device5resetEv","__ZN14ppi8255_device22device_config_completeEv","__ZN14ppi8255_device12device_startEv","__ZN8device_t9save_itemIA3_hEEvRT_PKci","__ZN14ppi8255_device12device_resetEv","__ZN14ppi8255_device8set_modeEii","__Z14device_creatorI14ppi8255_deviceEP8device_tRK14machine_configPKcS2_j","__ZN14ppi8255_deviceC2ERK14machine_configPKcP8device_tj","__Z8downcastIP14ppi8255_device8device_tET_PT0_","__ZN14ppi8255_device29ppi8255_get_handshake_signalsEiPh","__ZN14ppi8255_device13ppi8255_inputEih","__ZN14ppi8255_device18ppi8255_write_portEi","__ZN14ppi8255_device17ppi8255_read_portEi","__ZNK13delegate_baseIhj8_noparamS0_S0_EclEj","__Z9ppi8255_rP8device_tj","__ZN14ppi8255_device9ppi8255_rEj","__ZNK13delegate_baseIvjh8_noparamS0_EclEjh","__Z9ppi8255_wP8device_tjh","__ZN14ppi8255_device9ppi8255_wEjh","__ZN14ppi8255_deviceD1Ev","__ZN14ppi8255_device16device_post_loadEv","__ZN14ppi8255_device20device_clock_changedEv","__ZN12save_manager9save_itemIhLj3EEEvPKcS2_iRAT0__T_S2_","__ZN20resource_pool_objectI14ppi8255_deviceEC1EPS0_","__ZN20resource_pool_objectI14ppi8255_deviceEC2EPS0_","__ZN20resource_pool_objectI14ppi8255_deviceED1Ev","__ZN14ppi8255_deviceD2Ev","__ZN13z80ctc_device22device_config_completeEv","__ZN13z80ctc_device12device_startEv","__ZN14ppi8255_deviceD0Ev","__ZN13resource_pool10add_objectI14ppi8255_deviceEEPT_S3_","__ZN20resource_pool_objectI14ppi8255_deviceED0Ev","__ZN20resource_pool_objectI14ppi8255_deviceED2Ev","__Z14device_creatorI13z80ctc_deviceEP8device_tRK14machine_configPKcS2_j","__ZN13z80ctc_deviceC2ERK14machine_configPKcP8device_tj","__Z8downcastIP13z80ctc_device8device_tET_PT0_","__ZN13z80ctc_device18z80daisy_irq_stateEv","__ZN13z80ctc_device11ctc_channel5startEPS_ibRK16devcb_write_line","__ZN13z80ctc_device12device_resetEv","__ZN13z80ctc_device11ctc_channel5resetEv","__ZN13z80ctc_device15interrupt_checkEv","__ZThn356_N13z80ctc_device18z80daisy_irq_stateEv","__ZN13z80ctc_device16z80daisy_irq_ackEv","__ZThn356_N13z80ctc_device16z80daisy_irq_ackEv","__ZN13z80ctc_device17z80daisy_irq_retiEv","__ZThn356_N13z80ctc_device17z80daisy_irq_retiEv","__ZNK13delegate_baseIvi8_noparamS0_S0_EclEi","__ZN13z80ctc_device11ctc_channelC2Ev","__ZN13z80ctc_device11ctc_channel21static_timer_callbackER15running_machinePvi","__ZNK13z80ctc_device11ctc_channel6periodEv","__ZN13z80ctc_device11ctc_channel4readEv","__ZN13z80ctc_device11ctc_channel5writeEh","__ZN13z80ctc_device11ctc_channel7triggerEh","__ZN13z80ctc_device11ctc_channel14timer_callbackEv","__Z8z80ctc_wP8device_tjh","__ZNK15running_machine11driver_dataEv","__ZN13z80ctc_device5writeEih","__Z8z80ctc_rP8device_tj","__ZN13z80ctc_device4readEi","__ZN13z80ctc_device7triggerEih","__Z13z80ctc_trg1_wP8device_ti","__Z13z80ctc_trg2_wP8device_ti","__ZN13z80ctc_deviceD1Ev","__ZThn356_N13z80ctc_deviceD1Ev","__ZThn356_N13z80ctc_deviceD0Ev","__ZN20resource_pool_objectI13z80ctc_deviceEC1EPS0_","__ZN20resource_pool_objectI13z80ctc_deviceEC2EPS0_","__ZN20resource_pool_objectI13z80ctc_deviceED1Ev","__ZN13z80ctc_deviceD0Ev","__ZN13resource_pool10add_objectI13z80ctc_deviceEEPT_S3_","__ZN20resource_pool_objectI13z80ctc_deviceED0Ev","__ZN20resource_pool_objectI13z80ctc_deviceED2Ev","__ZN13z80ctc_deviceD2Ev","__ZN14devcb_resolver12resolve_portEPKcR8device_t","__ZN14devcb_resolver14resolve_deviceEiPKcR8device_t","__ZN14devcb_resolver25resolve_execute_interfaceEPKcR8device_t","__ZN25devcb_resolved_write_line7to_nullEi","__ZN21devcb_resolved_write87to_nullEjh","__ZN20devcb_resolved_read813from_constantEj","__ZN25devcb_resolved_write_lineC2Ev","__ZN8delegateIFviEEC2Ev","__ZN25devcb_resolved_write_line7resolveERK16devcb_write_lineR8device_t","__ZN8delegateIFviEEaSERKS1_","__ZN8delegateIFviEEC1I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_","__ZN25devcb_resolved_write_line7to_portEi","__ZN8delegateIFviEEC1I8device_tEEN15delegate_traitsIT_vi8_noparamS6_S6_E16static_func_typeEPKcPS5_","__ZN25devcb_resolved_write_line9to_write8Ei","__ZN25devcb_resolved_write_line8to_inputEi","__ZN20devcb_resolved_read8C2Ev","__ZN8delegateIFhjEEC2Ev","__ZN20devcb_resolved_read87resolveERK11devcb_read8R8device_t","__ZN8delegateIFhjEEaSERKS1_","__ZN8delegateIFhjEEC1I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_","__ZN20devcb_resolved_read89from_portEj","__ZN8delegateIFhjEEC1I8device_tEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_","__ZN20devcb_resolved_read813from_readlineEj","__ZN8delegateIFhjEEC1I13address_spaceEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_","__ZN21devcb_resolved_write8C2Ev","__ZN8delegateIFvjhEEC2Ev","__ZN21devcb_resolved_write87resolveERK12devcb_write8R8device_t","__ZN8delegateIFvjhEEaSERKS1_","__ZN8delegateIFvjhEEC1I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_","__ZN21devcb_resolved_write87to_portEjh","__ZN8delegateIFvjhEEC1I8device_tEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_","__ZN14devcb_resolver13resolve_spaceEiPKcR8device_t","__ZN21delegate_internal_mfpC2IM21devcb_resolved_write8FvjhEEET_","__ZN21delegate_internal_mfpC2IM20devcb_resolved_read8FhjEEET_","__ZN21delegate_internal_mfpC2IM25devcb_resolved_write_lineFviEEET_","__ZN21devcb_resolved_write812to_writelineEjh","__ZN8delegateIFvjhEEC1I13address_spaceEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_","__ZN21devcb_resolved_write88to_inputEjh","__ZN8delegateIFvjhEEC2I13address_spaceEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIvjh8_noparamS0_EC2I13address_spaceEEN15delegate_traitsIT_vjhS0_S0_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI13address_spaceEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvjh8_noparamS0_E4bindEP22delegate_generic_class","__ZN8delegateIFvjhEEC2I8device_tEEN15delegate_traitsIT_vjh8_noparamS6_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIvjh8_noparamS0_EC2I8device_tEEN15delegate_traitsIT_vjhS0_S0_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFvjhEEC2I21devcb_resolved_write8EEN15delegate_traitsIT_vjh8_noparamS6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIvjh8_noparamS0_EC2I21devcb_resolved_write8EEN15delegate_traitsIT_vjhS0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM21devcb_resolved_write8FvjhEEET_","__ZN13delegate_baseIvjh8_noparamS0_E16late_bind_helperI21devcb_resolved_write8EEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFhjEEC2I13address_spaceEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIhj8_noparamS0_S0_EC2I13address_spaceEEN15delegate_traitsIT_hjS0_S0_S0_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI13address_spaceEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIhj8_noparamS0_S0_E4bindEP22delegate_generic_class","__ZN8delegateIFhjEEC2I8device_tEEN15delegate_traitsIT_hj8_noparamS6_S6_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIhj8_noparamS0_S0_EC2I8device_tEEN15delegate_traitsIT_hjS0_S0_S0_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFhjEEC2I20devcb_resolved_read8EEN15delegate_traitsIT_hj8_noparamS6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIhj8_noparamS0_S0_EC2I20devcb_resolved_read8EEN15delegate_traitsIT_hjS0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM20devcb_resolved_read8FhjEEET_","__ZN13delegate_baseIhj8_noparamS0_S0_E16late_bind_helperI20devcb_resolved_read8EEP22delegate_generic_classR18delegate_late_bind","__ZN8delegateIFviEEC2I8device_tEEN15delegate_traitsIT_vi8_noparamS6_S6_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIvi8_noparamS0_S0_EC2I8device_tEEN15delegate_traitsIT_viS0_S0_S0_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIvi8_noparamS0_S0_E16late_bind_helperI8device_tEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvi8_noparamS0_S0_E4bindEP22delegate_generic_class","__ZN8delegateIFviEEC2I25devcb_resolved_write_lineEEN15delegate_traitsIT_vi8_noparamS6_S6_E16member_func_typeEPKcPS5_","__ZN13delegate_baseIvi8_noparamS0_S0_EC2I25devcb_resolved_write_lineEEN15delegate_traitsIT_viS0_S0_S0_E16member_func_typeEPKcPS5_","__ZN21delegate_internal_mfpC1IM25devcb_resolved_write_lineFviEEET_","__ZN13delegate_baseIvi8_noparamS0_S0_E16late_bind_helperI25devcb_resolved_write_lineEEP22delegate_generic_classR18delegate_late_bind","__ZN13delegate_baseIvjh8_noparamS0_EC2Ev","__ZN13delegate_baseIhj8_noparamS0_S0_EC2Ev","__ZN13delegate_baseIvi8_noparamS0_S0_EC2Ev","__ZN13delegate_baseIvjh8_noparamS0_EaSERKS1_","__ZN13delegate_baseIhj8_noparamS0_S0_EaSERKS1_","__ZN13delegate_baseIvi8_noparamS0_S0_EaSERKS1_","__ZL4signa","__ZL4offsa","__Z19cpu_disassemble_z80P17legacy_cpu_devicePcjPKhS3_i","__Z21cpu_disassemble_mcs48P17legacy_cpu_devicePcjPKhS3_i","__ZL11common_dasmP8device_tPcjPKhS3_i","__Z21cpu_disassemble_upi41P17legacy_cpu_devicePcjPKhS3_i","__ZNK11emu_options7samplesEv","__ZL14get_safe_tokenP8device_t6917","__Z25device_get_config_samplesPK8device_tjP10deviceinfo","__Z11readsamplesR15running_machinePKPKcS2_","__ZL15read_wav_sampleR15running_machineR8emu_fileP14_loaded_sample","__ZN14samples_deviceC2ERK14machine_configPFP8device_tS2_PKcS4_jES6_S4_j","__ZN14samples_deviceD1Ev","__ZThn368_N14samples_deviceD1Ev","__ZThn368_N14samples_deviceD0Ev","__ZN14samples_deviceD2Ev","__ZN20resource_pool_objectI14samples_deviceEC1EPS0_","__ZN20resource_pool_objectI14samples_deviceEC2EPS0_","__ZN20resource_pool_objectI14samples_deviceED1Ev","__ZL20device_start_samplesP8device_t","__Z21legacy_device_creatorI14samples_deviceEP8device_tRK14machine_configPKcS2_j","__ZN14samples_deviceD0Ev","__ZN13resource_pool10add_objectI14samples_deviceEEPT_S3_","__ZN20resource_pool_objectI14samples_deviceED0Ev","__ZN20resource_pool_objectI14samples_deviceED2Ev","__ZL16samples_postloadP13_samples_info","__ZL19sample_update_soundP8device_tP12sound_streamPvPPiS5_i","__ZN8delegateIFvvEEC1I13_samples_infoEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16static_func_typeEPKcPS5_","__ZN8delegateIFvvEEC2I13_samples_infoEEN15delegate_traitsIT_v8_noparamS6_S6_S6_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_EC2I13_samples_infoEEN15delegate_traitsIT_vS0_S0_S0_S0_E16static_func_typeEPKcPS5_","__ZN13delegate_baseIv8_noparamS0_S0_S0_E16late_bind_helperI13_samples_infoEEP22delegate_generic_classR18delegate_late_bind","__ZN19resource_pool_arrayI15_sample_channelEC1EPS0_i","__ZN19resource_pool_arrayI15_sample_channelEC2EPS0_i","__ZN19resource_pool_arrayI15_sample_channelED1Ev","__Z8png_freeP9_png_info","__ZN13resource_pool9add_arrayI15_sample_channelEEPT_S3_i","__ZN19resource_pool_arrayI15_sample_channelED0Ev","__ZN19resource_pool_arrayI15_sample_channelED2Ev","__Z13png_read_fileP10_core_fileP9_png_info","__ZL13verify_headerP10_core_file","__ZL10read_chunkP10_core_filePPhPjS3_","__ZL13process_chunkP12_png_privatePhjjPi","__ZL13process_imageP12_png_private","__ZL9put_32bitPhj","__Z22png_expand_buffer_8bitP9_png_info","__Z12png_add_textP9_png_infoPKcS2_","__Z16png_write_bitmapP10_core_fileP9_png_infoP8bitmap_tiPKj","__ZL16write_png_streamP10_core_fileP9_png_infoPK8bitmap_tiPKj","__Z17mng_capture_startP10_core_fileP8bitmap_td","__ZL11write_chunkP10_core_filePKhjj","__Z17mng_capture_frameP10_core_fileP9_png_infoP8bitmap_tiPKj","__Z16mng_capture_stopP10_core_file","__ZL8put_8bitPhh","__ZL7pal5bith6937","__ZL16compute_rowbytesPK9_png_info","__ZL11compute_bppPK9_png_info","__ZL31convert_bitmap_to_image_paletteP9_png_infoPK8bitmap_tiPKj","__ZL27convert_bitmap_to_image_rgbP9_png_infoPK8bitmap_tiPKj","__ZL20write_deflated_chunkP10_core_filePhjj","__ZL10fetch_8bitPh","__ZL12rgb_to_rgb15j6940","__ZL11fetch_32bitPh","__ZL12unfilter_rowiPhS_S_ii","__Z13palette_allocjj","__ZL21internal_palette_freeP10_palette_t","__ZL9rgb_clampi6971","__Z11palette_refP10_palette_t","__Z22palette_get_num_colorsP10_palette_t","__Z22palette_get_num_groupsP10_palette_t","__Z23palette_get_black_entryP10_palette_t","__Z23palette_get_white_entryP10_palette_t","__Z26palette_client_get_paletteP15_palette_client","__Z23palette_entry_get_colorP10_palette_tj","__Z22palette_entry_list_rawP10_palette_t","__Z27palette_entry_list_adjustedP10_palette_t","__Z33palette_entry_list_adjusted_rgb15P10_palette_t","__Z26palette_entry_get_contrastP10_palette_tj","__Z13palette_derefP10_palette_t","__Z20palette_client_allocP10_palette_t","__Z19palette_client_freeP15_palette_client","__Z29palette_client_get_dirty_listP15_palette_clientPjS1_","__Z23palette_entry_set_colorP10_palette_tjj","__ZL21update_adjusted_colorP10_palette_tjj","__Z26palette_entry_set_contrastP10_palette_tjf","__Z26palette_group_set_contrastP10_palette_tjf","__Z20bitmap_format_to_bpp14_bitmap_format","__Z19vbi_metadata_unpackP13_vbi_metadataPjPKh","__ZN8bitmap_tC2Ev","__ZL20adjust_palette_entryjffPKh","__ZN8bitmap_tD2Ev","__Z18bitmap_set_paletteP8bitmap_tP10_palette_t","__ZN8bitmap_tC2Eii14_bitmap_formatii","__ZN8bitmap_tC2EPviii14_bitmap_format","__ZL9sect_rectP10_rectanglePKS_6986","__Z11bitmap_fillP8bitmap_tPK10_rectanglej","__Z10avi_createPKcPK15_avi_movie_infoPP9_avi_file","__ZL19soundbuf_initializeP9_avi_file","__ZL21write_initial_headersP9_avi_file","__Z9avi_closeP9_avi_file","__ZL14soundbuf_flushP9_avi_filei","__ZL11chunk_closeP9_avi_file","__ZL16write_idx1_chunkP9_avi_file","__ZL16write_strh_chunkP9_avi_fileP11_avi_streami","__Z16avi_error_string10_avi_error","__ZL21framenum_to_samplenumP9_avi_filej","__ZL16get_video_streamP9_avi_file","__ZL22get_chunkid_for_streamP9_avi_fileP11_avi_stream","__ZL16get_audio_streamP9_avi_fileiPi","__ZL16write_indx_chunkP9_avi_fileP11_avi_streami","__ZL16write_avih_chunkP9_avi_filei","__ZL17expand_tempbufferP9_avi_filej","__ZL20soundbuf_write_chunkP9_avi_filej","__ZL21rgb32_compress_to_rgbP11_avi_streamPK8bitmap_tPhj","__ZL17compute_idx1_sizeP9_avi_file","__ZL21set_stream_chunk_infoP11_avi_streamjyj","__ZL11chunk_writeP9_avi_filejPKvj","__Z28avi_append_video_frame_rgb32P9_avi_filePK8bitmap_t","__Z24avi_append_sound_samplesP9_avi_fileiPKsjj","__ZL15chunk_overwriteP9_avi_filejPKvjPyi","__Z17is_path_separatorc","__ZL10put_32bitsPhj","__ZL10put_16bitsPht","__ZL10put_64bitsPhy","__ZL10chunk_openP9_avi_filejjj","__ZL16write_strf_chunkP9_avi_fileP11_avi_stream","__Z14zippath_parentP7astringPKc","__ZL17parse_parent_pathPKcPiS1_","__Z15zippath_combineP7astringPKcS2_","__ZL18astring_assemble_3P7astringPKcS2_S2_7041","__ZL18astring_assemble_2P7astringPKcS2_7042","__ZL21is_zip_file_separatorc","__Z13zippath_fopenPKcjPP10_core_fileP7astring","__ZL11is_zip_filePKc","__ZL21zippath_find_sub_pathP9_zip_filePKcP19_osd_dir_entry_type","__ZL25create_core_file_from_zipP9_zip_filePK16_zip_file_headerPP10_core_file","__Z15zippath_opendirPKcPP18_zippath_directory","__Z14zippath_is_zipP18_zippath_directory","__ZL15zippath_resolvePKcP19_osd_dir_entry_typePP9_zip_fileP7astring","__ZL7is_rootPKc","__Z16zippath_closedirP18_zippath_directory","__Z15zippath_readdirP18_zippath_directory","__ZL17get_relative_pathP18_zippath_directoryPK16_zip_file_header","__ZL21is_zip_path_separatorc","__ZL25file_error_from_zip_error10_zip_error","__Z10core_fseekP10_core_filexi","__Z10core_ftellP10_core_file","__Z9core_feofP10_core_file","__Z10core_fsizeP10_core_file","__ZL14next_path_charPKcPi","__ZL12astring_catcP7astringPKc7053","__Z10core_fopenPKcjPP10_core_file","__Z11core_fcloseP10_core_file","__Z14core_fopen_ramPKvjjPP10_core_file","__ZL23core_fopen_ram_internalPKvjijPP10_core_file","__Z19core_fopen_ram_copyPKvjjPP10_core_file","__Z14core_fcompressP10_core_filei","__Z11core_ungetciP10_core_file","__Z10core_freadP10_core_filePvj","__ZL16safe_buffer_copyPKvjjPvjj","__ZL16osd_or_zlib_readP10_core_filePvyjPj","__Z10core_fgetcP10_core_file","__ZL22is_directory_separatorc","__Z10core_fgetsPciP10_core_file","__Z12core_fbufferP10_core_file","__Z10core_floadPKcPPvPj","__Z11core_fwriteP10_core_filePKvj","__ZL17osd_or_zlib_writeP10_core_filePKvyjPj","__Z10core_fputsP10_core_filePKc","__Z13core_vfprintfP10_core_filePKcPc","__Z12core_fprintfP10_core_filePKcz","__Z26core_filename_extract_baseP7astringPKci","__Z23core_filename_ends_withPKcS0_","__Z13zip_file_openPKcPP9_zip_file","__ZL8read_ecdP9_zip_file","__ZL13free_zip_fileP9_zip_file","__Z14zip_file_closeP9_zip_file","__Z20zip_file_cache_clearv","__Z19zip_file_first_fileP9_zip_file","__ZL10read_dwordPh","__ZL9read_wordPh","__ZN7astring4initEv","__Z18zip_file_next_fileP9_zip_file","__Z19zip_file_decompressP9_zip_filePvj","__ZL26get_compressed_data_offsetP9_zip_filePy","__ZL22decompress_data_type_0P9_zip_fileyPvj","__ZL22decompress_data_type_8P9_zip_fileyPvj","___cxx_global_var_init7109","__ZN7astringD2Ev","__Z13astring_allocv","__Z12astring_freeP7astring","__Z14astring_expandP7astringi","__ZL16normalize_substrPiS_i","__Z9astring_cPK7astring","__Z12astring_cmpcPK7astringPKc","__ZL11ensure_roomP7astringi","__Z11astring_cpyP7astringPKS_","__Z12astring_cpycP7astringPKc","__Z13astring_cpychP7astringPKci","__Z17astring_cpysubstrP7astringPKS_ii","__Z11astring_insP7astringiPKS_","__Z12astring_inscP7astringiPKc","__Z13astring_inschP7astringiPKci","__Z17astring_inssubstrP7astringiPKS_ii","__Z14astring_substrP7astringii","__Z11astring_delP7astringii","__Z14astring_printfP7astringPKcz","__Z15astring_vprintfP7astringPKcPc","__Z17astring_catprintfP7astringPKcz","__ZL12astring_catcP7astringPKc7144","__Z18astring_catvprintfP7astringPKcPc","__Z11astring_lenPK7astring","__Z11astring_cmpPK7astringS1_","__Z13astring_icmpcPK7astringPKc","__Z11astring_chrPK7astringii","__ZL16safe_string_basePci","__Z12astring_rchrPK7astringii","__Z12astring_findPK7astringiS1_","__Z13astring_findcPK7astringiPKc","__Z14astring_delchrP7astringi","__Z19core_i64_hex_formatyh","__Z15astring_replaceP7astringiPKS_S2_","__Z16astring_replacecP7astringiPKcS2_","__Z15astring_toupperP7astring","__Z15astring_tolowerP7astring","__Z17astring_trimspaceP7astring","__GLOBAL__I_a7177","__Z12core_stricmpPKcS0_","__Z13core_strnicmpPKcS0_j","__Z15core_strwildcmpPKcS0_","__Z11core_strdupPKc","__ZL5ishexc","__ZL6hexvalc","__ZL7isdelimc","__ZL12jed_set_fuseP9_jed_datajh","__Z9jed_parsePKvjP9_jed_data","__ZL13process_fieldP9_jed_dataPKhS2_P11_parse_info","__Z13jedbin_outputPK9_jed_dataPvj","__ZL11suck_numberPPKh","__Z14pool_alloc_libPFvPKcE","__ZL11hash_objectPv","__ZL15get_object_typeP12_object_poolj","__Z18pool_type_registerP12_object_pooljPKcPFvPvjE","__ZL15memory_destructPvj","__ZL14report_failureP12_object_poolPKcz","__Z10pool_clearP12_object_pool","__Z13pool_free_libP12_object_pool","__Z25pool_object_add_file_lineP12_object_pooljPvjPKci","__Z18pool_object_removeP12_object_poolPvi","__Z21pool_malloc_file_lineP12_object_pooljPKci","__Z22pool_realloc_file_lineP12_object_poolPvjPKci","__Z21pool_strdup_file_lineP12_object_poolPKcS2_i","__Z15xml_file_createv","__Z13xml_file_readP10_core_fileP18_xml_parse_options","__ZL18expat_setup_parserP15_xml_parse_infoP18_xml_parse_options","__Z13xml_file_freeP14_xml_data_node","__Z15xml_string_readPKcP18_xml_parse_options","__Z14xml_file_writeP14_xml_data_nodeP10_core_file","__ZL20write_node_recursiveP14_xml_data_nodeiP10_core_file","__ZL19free_node_recursiveP14_xml_data_node","__Z15xml_get_siblingP14_xml_data_nodePKc","__Z17xml_get_attributeP14_xml_data_nodePKc","__Z13xml_add_childP14_xml_data_nodePKcS2_","__ZL9add_childP14_xml_data_nodePKcS2_","__Z15xml_delete_nodeP14_xml_data_node","__Z24xml_get_attribute_stringP14_xml_data_nodePKcS2_","__Z21xml_get_attribute_intP14_xml_data_nodePKci","__Z28xml_get_attribute_int_formatP14_xml_data_nodePKc","__Z23xml_get_attribute_floatP14_xml_data_nodePKcf","__Z17xml_set_attributeP14_xml_data_nodePKcS2_","__ZL10copystringPKc","__ZL13add_attributeP14_xml_data_nodePKcS2_","__Z21xml_set_attribute_intP14_xml_data_nodePKci","__Z23xml_set_attribute_floatP14_xml_data_nodePKcf","__Z20xml_normalize_stringPKc","__ZL16copystring_lowerPKc","__ZL12expat_mallocj7269","__ZL13expat_reallocPvj7270","__ZL10expat_freePv7271","__ZL19expat_element_startPvPKcPS1_","__ZL17expat_element_endPvPKc","__ZL10expat_dataPvPKci","__ZN12core_options5entry9set_valueEPKci","__ZN12core_options5entry17set_default_valueEPKc","__ZN12core_options5entry6revertEi","__ZN8tagmap_tIPN12core_options5entryEEC1Ev","__ZN8tagmap_tIPN12core_options5entryEED1Ev","__ZN12core_options11add_entriesEPK13options_entryb","__ZN12core_optionsD0Ev","__ZN12core_options12remove_entryERNS_5entryE","__ZNK12core_options5entry9is_headerEv","__ZNK12core_options5valueEPKc","__ZNK12core_options5entry4nameEv","__ZNK8tagmap_tIPN12core_options5entryEE4findEPKc","__ZNK12core_options5entry5valueEv","__ZN12core_options5entryD1Ev","__ZN12core_options5entryC2ERK13options_entry","__ZN12core_optionsC2Ev","__ZN12core_optionsD2Ev","__ZNK12core_options5entry4typeEv","__ZN12core_options18parse_command_lineEiPPciR7astring","__ZN12core_options14parse_ini_fileER10_core_fileiiR7astring","__ZN12core_options6revertEi","__ZN12core_options12append_entryERNS_5entryE","__ZN12core_options21validate_and_set_dataERNS_5entryEPKciR7astring","__ZNK12core_options5entry11descriptionEv","__ZNK12core_options5entry5seqidEv","__ZL11tagmap_hashPKc7342","__ZN12core_options10output_iniER7astringPKS_","__ZNK12core_options5entry10is_commandEv","__ZN12core_options11output_helpER7astring","__ZNK12core_options5seqidEPKc","__ZN12core_options9set_valueEPKcS1_iR7astring","__ZN8tagmap_tIPN12core_options5entryEE5resetEv","__ZN8tagmap_tIPN12core_options5entryEE3addEPKcS2_b","__ZN8tagmap_tIPN12core_options5entryEE6removeEPKc","__ZNK12core_options5entry9has_rangeEv","__ZNK12core_options5entry7minimumEv","__ZNK12core_options5entry7maximumEv","__ZL11tagmap_findPK7_tagmapPKc7340","__ZL21tagmap_find_prehashedPK7_tagmapPKcj7341","__ZN8tagmap_tIPN12core_options5entryEED2Ev","__ZN8tagmap_tIPN12core_options5entryEEC2Ev","__ZL15zlib_codec_initP9_chd_file","__ZL15zlib_codec_freeP9_chd_file","__ZN12core_options9set_valueEPKciiR7astring","__ZN12core_options5entryD2Ev","__ZL19zlib_codec_compressP9_chd_filePKvPj","__ZL21zlib_codec_decompressP9_chd_filejPv","__ZL13av_codec_initP9_chd_file","__ZL13av_codec_freeP9_chd_file","__ZL17av_codec_compressP9_chd_filePKvPj","__ZL19av_codec_decompressP9_chd_filejPv","__ZL15av_codec_configP9_chd_fileiPv","__Z15chd_create_fileP10_core_fileyjjP9_chd_file","__ZL15header_validatePK11_chd_header","__ZL12header_writeP10_core_filePK11_chd_header","__ZL17map_write_initialP10_core_fileP9_chd_filePK11_chd_header","__Z13chd_open_fileP10_core_fileiP9_chd_filePS2_","__Z18chd_clone_metadataP9_chd_fileS0_","__Z9chd_closeP9_chd_file","__Z16chd_error_string10_chd_error","__ZL11header_readP10_core_fileP11_chd_header","__ZL8map_readP9_chd_file","__Z8chd_openPKciP9_chd_filePS2_","__ZL22wait_for_pending_asyncP9_chd_file","__Z14chd_get_headerP9_chd_file","__Z8chd_readP9_chd_filejPv","__ZL21hunk_read_into_memoryP9_chd_filejPh","__Z14chd_read_asyncP9_chd_filejPv","__ZL21queue_async_operationP9_chd_filePFPvS1_iE","__ZL19async_read_callbackPvi","__Z18chd_async_completeP9_chd_file","__Z16chd_get_metadataP9_chd_filejjPvjPjS2_Ph","__ZL19metadata_find_entryP9_chd_filejjP15_metadata_entry","__ZL20put_bigendian_uint32Phj","__ZL20put_bigendian_uint64Phy","__Z16chd_set_metadataP9_chd_filejjPKvjh","__ZL19metadata_set_lengthP9_chd_fileyj","__ZL26metadata_set_previous_nextP9_chd_fileyy","__ZL21metadata_compute_hashP9_chd_filePKhPh","__Z16chd_codec_configP9_chd_fileiPv","__ZL17av_codec_postinitP9_chd_file","__Z13uchar_isvalidj","__ZL16av_raw_data_sizePKh","__ZL14zlib_fast_freePvS_","__ZL20get_bigendian_uint32PKh","__ZL20get_bigendian_uint64PKh","__ZL20get_bigendian_uint16PKh","__ZL20put_bigendian_uint16Pht","__Z15uchar_from_utf8PjPKcj","__Z16uchar_from_utf16PjPKtj","__ZL15zlib_fast_allocPvjj","__ZL21metadata_hash_comparePKvS0_","__ZL11map_extractPKhP10_map_entry","__ZL15map_extract_oldPKhP10_map_entryj","__ZL12map_assemblePhP10_map_entry","_osd_work_item_queue","__Z17uchar_from_utf16fPjPKtj","__Z18utf8_previous_charPKc","__Z9sha1_initP8sha1_ctx","__ZL11READ_UINT32PKh","__Z15utf8_from_ucharPcjj","__Z20utf8_is_valid_stringPKc","__Z11sha1_updateP8sha1_ctxjPKh","__ZL10sha1_blockP8sha1_ctxPKh","__Z10sha1_finalP8sha1_ctx","__ZL14sha1_transformPjS_","__ZL12WRITE_UINT32Phj","__Z7MD5InitP10MD5Context","__Z11sha1_digestPK8sha1_ctxjPh","__Z9MD5UpdateP10MD5ContextPKhj","__Z12MD5TransformPjPKj","__ZL11tagmap_hashPKc7437","__Z8MD5FinalPhP10MD5Context","__Z12tagmap_resetP7_tagmap","__Z10tagmap_addP7_tagmapPKcPvh","__ZL17tagmap_add_commonP7_tagmapPKcPvhh","__Z22tagmap_add_unique_hashP7_tagmapPKcPvh","__Z13tagmap_removeP7_tagmapPKc","__Z20tagmap_remove_objectP7_tagmapPv","__Z11avcomp_initjjj","__Z11avcomp_freeP13_avcomp_state","__Z22avcomp_config_compressP13_avcomp_statePK25_av_codec_compress_config","__Z24avcomp_config_decompressP13_avcomp_statePK27_av_codec_decompress_config","__Z18avcomp_encode_dataP13_avcomp_statePKhPhPj","__ZL12encode_audioP13_avcomp_stateiiPPKhiPhS4_","__ZL12encode_videoP13_avcomp_stateiiPKhjjPhPj","__Z18avcomp_decode_dataP13_avcomp_statePKhjPh","__ZL12decode_audioP13_avcomp_stateiiPKhPPhjS2_","__ZL12decode_videoP13_avcomp_stateiiPKhjPhjj","__ZL21decode_video_losslessP13_avcomp_stateiiPKhjPhjj","__ZL21encode_video_losslessP13_avcomp_stateiiPKhjjPhPj","__Z22huffman_create_contextPP16_huffman_contexti","__Z20huffman_free_contextP16_huffman_context","__Z19huffman_import_treeP16_huffman_contextPKhjPj","__ZL11import_treeP16_huffman_contextPKhjPjj","__Z19huffman_export_treeP16_huffman_contextPhjPj","__ZL11export_treeP16_huffman_contextPhjPjj","__Z28huffman_deltarle_import_treeP16_huffman_contextPKhjPj","__Z28huffman_deltarle_export_treeP16_huffman_contextPhjPj","__Z32huffman_compute_tree_interleavediPP16_huffman_contextPKhjjjj","__ZL20compute_optimal_treeP16_huffman_contextPKjj","__Z41huffman_deltarle_compute_tree_interleavediPP16_huffman_contextPKhjjjj","__ZL16rlecount_to_codei","__ZL16code_to_rlecounti","__ZL21bit_buffer_write_initP11_bit_bufferPhj","__ZL16bit_buffer_writeP11_bit_bufferji","__ZL16bit_buffer_flushP11_bit_buffer","__ZL20bit_buffer_read_initP11_bit_bufferPKhj","__Z31huffman_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj","__Z40huffman_deltarle_encode_data_interleavediPP16_huffman_contextPKhjjjjPhjPj","__ZL18build_lookup_tableP16_huffman_contextj","__ZL15bit_buffer_peekP11_bit_bufferi","__ZL17bit_buffer_removeP11_bit_bufferi","__ZL22bit_buffer_read_offsetP11_bit_buffer","__Z31huffman_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj","__Z40huffman_deltarle_decode_data_interleavediPP16_huffman_contextPKhjPhjjjjPj","__ZL17tree_node_comparePKvS0_","__ZL45huffman_deltarle_decode_data_interleaved_0102PP16_huffman_contextPKhjPhjjjjPj","__ZL18huffman_build_treeP16_huffman_contextPKjjjj","__ZL22assign_canonical_codesP16_huffman_contextj","__ZL15bit_buffer_readP11_bit_bufferi","__ZL19write_rle_tree_bitsP11_bit_bufferiii","_XML_ParserCreate_MM","__ZL12parserCreatePKcPK25XML_Memory_Handling_SuiteS0_P3DTD","__ZL9poolClearP11STRING_POOL","__ZL10setContextP16XML_ParserStructPKc","_XML_ParserFree","_XML_SetUserData","_XML_SetElementHandler","_XML_SetCharacterDataHandler","__ZL14errorProcessorP16XML_ParserStructPKcS2_PS2_","__ZL10parserInitP16XML_ParserStructPKc","__ZL14poolCopyStringP11STRING_POOLPKc","__ZL15destroyBindingsP7bindingP16XML_ParserStruct","__ZL11poolDestroyP11STRING_POOL","__ZL10dtdDestroyP3DTDhPK25XML_Memory_Handling_Suite","_XML_Parse","_XML_GetErrorCode","_XML_ErrorString","_XML_GetBuffer","_XML_ParseBuffer","_XML_GetCurrentLineNumber","_XML_GetCurrentColumnNumber","__ZL13reportDefaultP16XML_ParserStructPK8encodingPKcS5_","__ZL17hashTableIterInitP15HASH_TABLE_ITERPK10HASH_TABLE","__ZL17hashTableIterNextP15HASH_TABLE_ITER","__ZL8poolGrowP11STRING_POOL","__ZL4hashPKc","__ZL5keyeqPKcS0_","__ZL6lookupP10HASH_TABLEPKcj","__ZL16hashTableDestroyP10HASH_TABLE","__ZL10addBindingP16XML_ParserStructP6prefixPK12attribute_idPKcPP7binding","__ZL18initializeEncodingP16XML_ParserStruct","__ZL15prologProcessorP16XML_ParserStructPKcS2_PS2_","__ZL8doPrologP16XML_ParserStructPK8encodingPKcS5_iS5_PS5_h","__ZL17normalizePublicIdPc","__ZL14processXmlDeclP16XML_ParserStructiPKcS2_","__ZL15poolStoreStringP11STRING_POOLPK8encodingPKcS5_","__ZL16contentProcessorP16XML_ParserStructPKcS2_PS2_","__ZL14getElementTypeP16XML_ParserStructPK8encodingPKcS5_","__ZL14getAttributeIdP16XML_ParserStructPK8encodingPKcS5_","__ZL16poolAppendStringP11STRING_POOLPKc","__ZL10poolAppendP11STRING_POOLPK8encodingPKcS5_","__ZL15defineAttributeP12ELEMENT_TYPEP12attribute_idhhPKcP16XML_ParserStruct","__ZL19storeAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL","__ZL16storeEntityValueP16XML_ParserStructPK8encodingPKcS5_","__ZL15doIgnoreSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h","__ZL22ignoreSectionProcessorP16XML_ParserStructPKcS2_PS2_","__ZL14normalizeLinesPc","__ZL16nextScaffoldPartP16XML_ParserStruct","__ZL21processInternalEntityP16XML_ParserStructP6ENTITYh","__ZL11build_modelP16XML_ParserStruct","__ZL27reportProcessingInstructionP16XML_ParserStructPK8encodingPKcS5_","__ZL13reportCommentP16XML_ParserStructPK8encodingPKcS5_","__ZL10build_nodeP16XML_ParserStructiP6XML_cpPS2_PPc","__ZL9doContentP16XML_ParserStructiPK8encodingPKcS5_PS5_h","__ZL23internalEntityProcessorP16XML_ParserStructPKcS2_PS2_","__ZL10getContextP16XML_ParserStruct","__ZL9storeAttsP16XML_ParserStructPK8encodingPKcP8TAG_NAMEPP7binding","__ZL15epilogProcessorP16XML_ParserStructPKcS2_PS2_","__ZL14doCdataSectionP16XML_ParserStructPK8encodingPPKcS5_S6_h","__ZL21cdataSectionProcessorP16XML_ParserStructPKcS2_PS2_","__ZL30externalEntityContentProcessorP16XML_ParserStructPKcS2_PS2_","__ZL13storeRawNamesP16XML_ParserStruct","__ZL20setElementTypePrefixP16XML_ParserStructP12ELEMENT_TYPE","__ZL20appendAttributeValueP16XML_ParserStructPK8encodinghPKcS5_P11STRING_POOL","__ZL5errorP12prolog_stateiPKcS2_PK8encoding","__ZL8poolInitP11STRING_POOLPK25XML_Memory_Handling_Suite","__ZL13hashTableInitP10HASH_TABLEPK25XML_Memory_Handling_Suite","_XmlPrologStateInit","__ZL6commonP12prolog_statei","__ZL21handleUnknownEncodingP16XML_ParserStructPKc","__ZL19prologInitProcessorP16XML_ParserStructPKcS2_PS2_","__ZL9dtdCreatePK25XML_Memory_Handling_Suite","__ZL7prolog0P12prolog_stateiPKcS2_PK8encoding","__ZL15externalSubset1P12prolog_stateiPKcS2_PK8encoding","__ZL9condSect0P12prolog_stateiPKcS2_PK8encoding","__ZL14internalSubsetP12prolog_stateiPKcS2_PK8encoding","__ZL7entity0P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist0P12prolog_stateiPKcS2_PK8encoding","__ZL8element0P12prolog_stateiPKcS2_PK8encoding","__ZL9notation0P12prolog_stateiPKcS2_PK8encoding","__ZL8doctype5P12prolog_stateiPKcS2_PK8encoding","__ZL7prolog2P12prolog_stateiPKcS2_PK8encoding","__ZL9notation1P12prolog_stateiPKcS2_PK8encoding","__ZL9notation3P12prolog_stateiPKcS2_PK8encoding","__ZL9notation2P12prolog_stateiPKcS2_PK8encoding","__ZL9notation4P12prolog_stateiPKcS2_PK8encoding","__ZL9declCloseP12prolog_stateiPKcS2_PK8encoding","__ZL8element1P12prolog_stateiPKcS2_PK8encoding","__ZL8element2P12prolog_stateiPKcS2_PK8encoding","__ZL8element3P12prolog_stateiPKcS2_PK8encoding","__ZL8element6P12prolog_stateiPKcS2_PK8encoding","__ZL8element7P12prolog_stateiPKcS2_PK8encoding","__ZL8element4P12prolog_stateiPKcS2_PK8encoding","__ZL8element5P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist1P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist2P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist8P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist5P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist3P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist4P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist6P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist7P12prolog_stateiPKcS2_PK8encoding","__ZL8attlist9P12prolog_stateiPKcS2_PK8encoding","__ZL7entity1P12prolog_stateiPKcS2_PK8encoding","__ZL7entity2P12prolog_stateiPKcS2_PK8encoding","__ZL7entity4P12prolog_stateiPKcS2_PK8encoding","__ZL7entity3P12prolog_stateiPKcS2_PK8encoding","__ZL7entity5P12prolog_stateiPKcS2_PK8encoding","__ZL7entity6P12prolog_stateiPKcS2_PK8encoding","__ZL7entity7P12prolog_stateiPKcS2_PK8encoding","__ZL7entity9P12prolog_stateiPKcS2_PK8encoding","__ZL7entity8P12prolog_stateiPKcS2_PK8encoding","__ZL8entity10P12prolog_stateiPKcS2_PK8encoding","__ZL9condSect1P12prolog_stateiPKcS2_PK8encoding","__ZL9condSect2P12prolog_stateiPKcS2_PK8encoding","__ZL7prolog1P12prolog_stateiPKcS2_PK8encoding","__ZL8doctype0P12prolog_stateiPKcS2_PK8encoding","__ZL8doctype1P12prolog_stateiPKcS2_PK8encoding","__ZL8doctype3P12prolog_stateiPKcS2_PK8encoding","__ZL8doctype2P12prolog_stateiPKcS2_PK8encoding","__ZL8doctype4P12prolog_stateiPKcS2_PK8encoding","__ZL16normal_prologTokPK8encodingPKcS3_PS3_","__ZL17normal_contentTokPK8encodingPKcS3_PS3_","__ZL22normal_cdataSectionTokPK8encodingPKcS3_PS3_","__ZL15normal_sameNamePK8encodingPKcS3_","__ZL23normal_nameMatchesAsciiPK8encodingPKcS3_S3_","__ZL23normal_ignoreSectionTokPK8encodingPKcS3_PS3_","__ZL24normal_attributeValueTokPK8encodingPKcS3_PS3_","__ZL21normal_entityValueTokPK8encodingPKcS3_PS3_","__ZL17normal_nameLengthPK8encodingPKc","__ZL12normal_skipSPK8encodingPKc","__ZL14normal_getAttsPK8encodingPKciP9ATTRIBUTE","__ZL27normal_predefinedEntityNamePK8encodingPKcS3_","__ZL20normal_charRefNumberPK8encodingPKc","_XmlSizeOfUnknownEncoding","__ZL21normal_updatePositionPK8encodingPKcS3_P8position","__ZL17normal_isPublicIdPK8encodingPKcS3_PS3_","__ZL12ascii_toUtf8PK8encodingPPKcS3_PPcS3_","__ZL14latin1_toUtf16PK8encodingPPKcS3_PPtPKt","_XmlUtf8Encode","_XmlInitUnknownEncoding","_XmlGetUtf8InternalEncoding","__ZL18checkCharRefNumberi","__ZL14unknown_isNamePK8encodingPKc","__ZL16unknown_isNmstrtPK8encodingPKc","__ZL17unknown_isInvalidPK8encodingPKc","__ZL14unknown_toUtf8PK8encodingPPKcS3_PPcS3_","__ZL15unknown_toUtf16PK8encodingPPKcS3_PPtPKt","_XmlInitEncoding","__ZL16getEncodingIndexPKc","__ZL14initScanPrologPK8encodingPKcS3_PS3_","__ZL15initScanContentPK8encodingPKcS3_PS3_","__ZL18initUpdatePositionPK8encodingPKcS3_P8position","_XmlParseXmlDecl","_XmlGetUtf8InternalEncodingNS","__ZL7streqciPKcS0_","__ZL14doParseXmlDeclPFPK8encodingS1_PKcS3_EiS1_S3_S3_PS3_S6_S6_S6_PS1_Pi","__ZL12findEncodingPK8encodingPKcS3_","_XmlInitEncodingNS","__ZL16initScanPrologNSPK8encodingPKcS3_PS3_","__ZL17initScanContentNSPK8encodingPKcS3_PS3_","_XmlParseXmlDeclNS","__ZL14findEncodingNSPK8encodingPKcS3_","_XmlInitUnknownEncodingNS","__ZL17little2_prologTokPK8encodingPKcS3_PS3_","__ZL18little2_contentTokPK8encodingPKcS3_PS3_","__ZL23little2_cdataSectionTokPK8encodingPKcS3_PS3_","__ZL24little2_ignoreSectionTokPK8encodingPKcS3_PS3_","__ZL24little2_nameMatchesAsciiPK8encodingPKcS3_S3_","__ZL25little2_attributeValueTokPK8encodingPKcS3_PS3_","__ZL22little2_entityValueTokPK8encodingPKcS3_PS3_","__ZL16little2_sameNamePK8encodingPKcS3_","__ZL18little2_nameLengthPK8encodingPKc","__ZL13little2_skipSPK8encodingPKc","__ZL15little2_getAttsPK8encodingPKciP9ATTRIBUTE","__ZL21little2_charRefNumberPK8encodingPKc","__ZL28little2_predefinedEntityNamePK8encodingPKcS3_","__ZL14little2_toUtf8PK8encodingPPKcS3_PPcS3_","__ZL22little2_updatePositionPK8encodingPKcS3_P8position","__ZL18little2_isPublicIdPK8encodingPKcS3_PS3_","__ZL17unicode_byte_typecc","__ZL15little2_toUtf16PK8encodingPPKcS3_PPtPKt","__ZL15little2_scanRefPK8encodingPKcS3_PS3_","__ZL19little2_scanPercentPK8encodingPKcS3_PS3_","__ZL19little2_scanCharRefPK8encodingPKcS3_PS3_","__ZL22little2_scanHexCharRefPK8encodingPKcS3_PS3_","__ZL14little2_scanLtPK8encodingPKcS3_PS3_","__ZL24little2_scanCdataSectionPK8encodingPKcS3_PS3_","__ZL19little2_scanCommentPK8encodingPKcS3_PS3_","__ZL14little2_scanPiPK8encodingPKcS3_PS3_","__ZL18little2_scanEndTagPK8encodingPKcS3_PS3_","__ZL16little2_scanAttsPK8encodingPKcS3_PS3_","__ZL21little2_checkPiTargetPK8encodingPKcS3_Pi","__ZL15little2_scanLitiPK8encodingPKcS3_PS3_","__ZL16little2_scanDeclPK8encodingPKcS3_PS3_","__ZL21little2_scanPoundNamePK8encodingPKcS3_PS3_","__ZL14big2_prologTokPK8encodingPKcS3_PS3_","__ZL15big2_contentTokPK8encodingPKcS3_PS3_","__ZL20big2_cdataSectionTokPK8encodingPKcS3_PS3_","__ZL21big2_ignoreSectionTokPK8encodingPKcS3_PS3_","__ZL21big2_nameMatchesAsciiPK8encodingPKcS3_S3_","__ZL22big2_attributeValueTokPK8encodingPKcS3_PS3_","__ZL19big2_entityValueTokPK8encodingPKcS3_PS3_","__ZL13big2_sameNamePK8encodingPKcS3_","__ZL15big2_nameLengthPK8encodingPKc","__ZL10big2_skipSPK8encodingPKc","__ZL12big2_getAttsPK8encodingPKciP9ATTRIBUTE","__ZL18big2_charRefNumberPK8encodingPKc","__ZL25big2_predefinedEntityNamePK8encodingPKcS3_","__ZL11big2_toUtf8PK8encodingPPKcS3_PPcS3_","__ZL19big2_updatePositionPK8encodingPKcS3_P8position","__ZL15big2_isPublicIdPK8encodingPKcS3_PS3_","__ZL12big2_toUtf16PK8encodingPPKcS3_PPtPKt","__ZL12big2_scanRefPK8encodingPKcS3_PS3_","__ZL16big2_scanPercentPK8encodingPKcS3_PS3_","__ZL16big2_scanCharRefPK8encodingPKcS3_PS3_","__ZL19big2_scanHexCharRefPK8encodingPKcS3_PS3_","__ZL11big2_scanLtPK8encodingPKcS3_PS3_","__ZL21big2_scanCdataSectionPK8encodingPKcS3_PS3_","__ZL16big2_scanCommentPK8encodingPKcS3_PS3_","__ZL11big2_scanPiPK8encodingPKcS3_PS3_","__ZL15big2_scanEndTagPK8encodingPKcS3_PS3_","__ZL13big2_scanAttsPK8encodingPKcS3_PS3_","__ZL18big2_checkPiTargetPK8encodingPKcS3_Pi","__ZL12big2_scanLitiPK8encodingPKcS3_PS3_","__ZL13big2_scanDeclPK8encodingPKcS3_PS3_","__ZL18big2_scanPoundNamePK8encodingPKcS3_PS3_","__ZL7isNeverPK8encodingPKc","__ZL11utf8_toUtf8PK8encodingPPKcS3_PPcS3_","__ZL12utf8_toUtf16PK8encodingPPKcS3_PPtPKt","__ZL12utf8_isName2PK8encodingPKc","__ZL12utf8_isName3PK8encodingPKc","__ZL14utf8_isNmstrt2PK8encodingPKc","__ZL14utf8_isNmstrt3PK8encodingPKc","__ZL15utf8_isInvalid2PK8encodingPKc","__ZL15utf8_isInvalid3PK8encodingPKc","__ZL15utf8_isInvalid4PK8encodingPKc","__ZL13latin1_toUtf8PK8encodingPPKcS3_PPcS3_","__ZL7isSpacei","__ZL8initScanPKPK8encodingPK13INIT_ENCODINGiPKcS8_PS8_","__ZL20parsePseudoAttributePK8encodingPKcS3_PS3_S4_S4_S4_","__ZL7toAsciiPK8encodingPKcS3_","__ZL21normal_scanHexCharRefPK8encodingPKcS3_PS3_","__ZL14normal_scanRefPK8encodingPKcS3_PS3_","__ZL18normal_scanPercentPK8encodingPKcS3_PS3_","__ZL18normal_scanCharRefPK8encodingPKcS3_PS3_","__ZL13normal_scanLtPK8encodingPKcS3_PS3_","__ZL23normal_scanCdataSectionPK8encodingPKcS3_PS3_","__ZL18normal_scanCommentPK8encodingPKcS3_PS3_","__ZL13normal_scanPiPK8encodingPKcS3_PS3_","__ZL17normal_scanEndTagPK8encodingPKcS3_PS3_","__ZL15normal_scanAttsPK8encodingPKcS3_PS3_","__ZL20normal_checkPiTargetPK8encodingPKcS3_Pi","__ZL14normal_scanLitiPK8encodingPKcS3_PS3_","__ZL15normal_scanDeclPK8encodingPKcS3_PS3_","__ZL20normal_scanPoundNamePK8encodingPKcS3_PS3_","__ZL25waveform_bytes_per_samplei","__ZL10map_doubledyyy","__Z21cassette_open_choicesPvPK8io_procsPKcPKPK14CassetteFormatiPP15_cassette_image","__ZL13cassette_initPK14CassetteFormatPvPK8io_procsi","__ZL11good_formatPK14CassetteFormatPKci","__ZL19cassette_finishinit9casserr_tP15_cassette_imagePS1_","__Z15cassette_createPvPK8io_procsPK14CassetteFormatPK15CassetteOptionsiPP15_cassette_image","__Z13cassette_saveP15_cassette_image","__ZL21cassette_perform_saveP15_cassette_image","__Z17cassette_get_infoP15_cassette_imageP12CassetteInfo","__Z14cassette_closeP15_cassette_image","__Z19cassette_image_readP15_cassette_imagePvyj","__Z20cassette_image_writeP15_cassette_imagePKvyj","__Z19cassette_image_sizeP15_cassette_image","__Z20cassette_get_samplesP15_cassette_imageiddjjPvi","__ZL27compute_manipulation_rangesP15_cassette_imageiddP19manipulation_ranges","__ZL12interpolate8i","__ZL13interpolate16i","__ZL12extrapolate8a","__ZL13extrapolate16s","__ZL8my_roundd","__ZL13lookup_sampleP15_cassette_imageijiPPi","__Z20cassette_put_samplesP15_cassette_imageiddjjPKvi","__Z19cassette_get_sampleP15_cassette_imageiddPi","__Z19cassette_put_sampleP15_cassette_imageiddi","__Z21cassette_read_samplesP15_cassette_imageiddjyi","__Z22cassette_write_samplesP15_cassette_imageiddjyi","__Z20image_find_extensionPKcS0_","__ZL8is_delimc","__ZL29image_internal_find_extensionPKcS0_","__Z23image_specify_extensionPcjPKc","__ZL16wavfile_identifyP15_cassette_imageP15CassetteOptions","__ZL12wavfile_loadP15_cassette_image","__ZL12wavfile_saveP15_cassette_imagePK12CassetteInfo","__ZL12put_leuint32Pvj","__ZL12put_leuint16Pvt","__ZL15wavfile_processP15_cassette_imageP15CassetteOptionsi","__ZL12get_leuint32PKv","__ZL12get_leuint16PKv","__Z15io_generic_readP10io_genericPvyj","__Z15io_generic_sizeP10io_generic","__ZL15io_generic_seekP10io_genericy","__Z16io_generic_writeP10io_genericPKvyj","_crc32_little","_crc32_big","_inflateReset","_crc32","_inflateInit2_","_inflateInit_","_inflate","_fixedtables","_updatewindow","_inflateEnd","_deflateInit_","_deflateInit2_","_deflateEnd","_deflateReset","_lm_init","_deflate","_putShortMSB","_flush_pending","_deflate_stored","_deflate_fast","_deflate_slow","_longest_match","_longest_match_fast","_fill_window","_read_buf","_inflate_fast","_inflate_table","_zcalloc","_zcfree","_tr_static_init","_adler32","_init_block","__tr_init","__tr_stored_block","_copy_block","_bi_flush","_set_data_type","__tr_align","__tr_flush_block","_build_tree","_build_bl_tree","_compress_block","_bi_windup","_send_all_trees","_send_tree","_bi_reverse","_scan_tree","_pqdownheap","_gen_bitlen","_gen_codes","_osd_get_clipboard_text","_osd_ticks_per_second","_osd_lock_alloc","_osd_get_volume_name","_osd_opendir","_osd_readdir","_osd_closedir","_osd_is_absolute_path","_osd_break_into_debugger","_osd_work_queue_alloc","_osd_work_queue_free","_osd_lock_acquire","_osd_lock_release","_osd_lock_free","_osd_uchar_from_osdchar","_osd_work_item_wait","_osd_work_item_result","_osd_sleep","_osd_open","_osd_close","_osd_read","_osd_write","_osd_rmfile","_osd_stat","_osd_get_full_path","_osd_malloc","_osd_malloc_array","_osd_free","_osd_work_item_queue_multiple","_osd_work_item_release","_osd_ticks","__ZNSt3__112__do_messageD2Ev","__ZNSt3__112__do_messageC2Ev","___cxx_global_var_init1775","__ZNSt3__110__stdinbufIcEC1EP7__sFILE","__ZNSt3__110__stdinbufIcED1Ev","___cxx_global_var_init11776","__ZNSt3__111__stdoutbufIcEC1EP7__sFILE","__ZNSt3__111__stdoutbufIcED1Ev","___cxx_global_var_init21777","___cxx_global_var_init31778","__ZNSt3__110__stdinbufIwEC1EP7__sFILE","__ZNSt3__110__stdinbufIwED1Ev","___cxx_global_var_init41779","__ZNSt3__111__stdoutbufIwEC1EP7__sFILE","__ZNSt3__111__stdoutbufIwED1Ev","___cxx_global_var_init5","___cxx_global_var_init6","___cxx_global_var_init7","___cxx_global_var_init8","___cxx_global_var_init9","___cxx_global_var_init10","__ZNSt3__18ios_base4InitC2Ev","___cxx_global_var_init14","__ZNSt3__18ios_base4InitD2Ev","___cxx_global_var_init11","___cxx_global_var_init12","___cxx_global_var_init13","__ZNSt3__111__stdoutbufIwEC2EP7__sFILE","__ZNSt3__111__stdoutbufIwED0Ev","__ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE","__ZNSt3__111__stdoutbufIwE4syncEv","__ZNSt3__111__stdoutbufIwE8overflowEj","__ZNSt3__110__stdinbufIwED0Ev","__ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE","__ZNSt3__110__stdinbufIwE9underflowEv","__ZNSt3__110__stdinbufIwE5uflowEv","__ZNSt3__110__stdinbufIwEC2EP7__sFILE","__ZNSt3__110__stdinbufIwE9pbackfailEj","__ZNSt3__110__stdinbufIwE9__getcharEb","__ZNSt3__111__stdoutbufIcED0Ev","__ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE","__ZNSt3__111__stdoutbufIcE4syncEv","__ZNSt3__111__stdoutbufIcEC2EP7__sFILE","__ZNSt3__111__stdoutbufIcE8overflowEi","__ZNSt3__110__stdinbufIcED0Ev","__ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE","__ZNSt3__110__stdinbufIcE9underflowEv","__ZNSt3__110__stdinbufIcE5uflowEv","__ZNSt3__110__stdinbufIcE9pbackfailEi","__ZNSt3__110__stdinbufIcEC2EP7__sFILE","__ZNSt3__114__shared_countD2Ev","__ZNSt3__114error_categoryD2Ev","__ZNSt3__112_GLOBAL__N_19incrementIlEET_RS2_","__ZNSt3__112_GLOBAL__N_19decrementIlEET_RS2_","__ZNSt3__114error_categoryC2Ev","__ZNK12_GLOBAL__N_114__libcpp_nmstr5c_strEv","__ZNK12_GLOBAL__N_114__libcpp_nmstr5countEv","__ZNSt3__110__stdinbufIcE9__getcharEb","__ZNSt3__111__stdoutbufIwED2Ev","__ZNSt3__110__stdinbufIwED2Ev","__ZNSt3__111__stdoutbufIcED2Ev","__ZNSt3__110__stdinbufIcED2Ev","__GLOBAL__I_a1780","__ZNSt3__114__shared_countD0Ev","__ZNSt3__114__shared_count12__add_sharedEv","__ZNSt3__114__shared_count16__release_sharedEv","__ZNSt11logic_errorC2EPKc","__ZNSt11logic_errorD0Ev","__ZNSt11logic_errorD2Ev","__ZNKSt11logic_error4whatEv","__ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE","__ZNSt13runtime_errorC2EPKc","__ZNSt13runtime_errorD0Ev","__ZNSt13runtime_errorD2Ev","__ZNKSt13runtime_error4whatEv","__ZNSt12length_errorD0Ev","__ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev","__ZN12_GLOBAL__N_114__libcpp_nmstrC2EPKc","__ZNSt3__114error_categoryD0Ev","__ZNKSt3__114error_category23default_error_conditionEi","__ZNKSt3__114error_category10equivalentERKNS_10error_codeEi","__ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE","__ZNKSt3__112__do_message7messageEi","__ZNKSt3__110error_code7messageEv","__ZNSt3__112system_errorD0Ev","__ZNSt3__112system_errorD2Ev","__ZNSt3__112__do_messageD1Ev","__ZNSt3__112__do_messageD0Ev","__ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE","__ZNSt3__112system_errorC2ENS_10error_codeEPKc","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj","__ZNSt3__111__call_onceERVmPvPFvS2_E","__ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj","__ZNSt9exceptionD2Ev","__ZNKSt9exception4whatEv","__ZSt13get_terminatev","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj","__ZNSt9exceptionD0Ev","__ZNSt3__18ios_baseD2Ev","__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED0Ev","__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED1Ev","__ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev","__ZSt9terminatev","__ZSt18uncaught_exceptionv","__ZNSt3__18ios_base5clearEj","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj","__ZNSt3__18ios_base16__call_callbacksENS0_5eventE","__ZNKSt3__18ios_base6getlocEv","__ZNSt3__18ios_base4initEPv","__ZNSt3__19basic_iosIwNS_11char_traitsIwEEED0Ev","__ZNSt3__19basic_iosIwNS_11char_traitsIwEEED1Ev","__ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI10_mbstate_tEEj","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv","__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI10_mbstate_tEEj","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv","__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi","__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev","__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED2Ev","__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED2Ev","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev","__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev","__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev","__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev","__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev","__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev","__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev","__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev","__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv","__ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv","__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED2Ev","__ZNKSt3__119__iostream_category4nameEv","___cxx_global_var_init270","__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev","__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev","__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC1ERS3_","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD1Ev","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev","__ZNKSt3__119__iostream_category7messageEi","__ZNSt3__117iostream_categoryEv","__ZNSt3__119__iostream_categoryC1Ev","__ZNSt3__119__iostream_categoryD1Ev","__ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE","__ZNSt3__18ios_base7failureD0Ev","__ZNSt3__18ios_base7failureD2Ev","__ZNSt3__18ios_baseD0Ev","__ZNSt3__119__iostream_categoryD0Ev","__ZNSt3__119__iostream_categoryD2Ev","__ZNSt3__119__iostream_categoryC2Ev","__ZNSt3__17collateIcED0Ev","__ZNSt3__17collateIcED1Ev","__ZNSt3__17collateIcED2Ev","__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev","__ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_","__ZNKSt3__17collateIcE7do_hashEPKcS3_","___cxx_global_var_init1271","__ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_","__ZNKSt3__17collateIwE7do_hashEPKwS3_","___cxx_global_var_init2272","__ZNSt3__16locale5facetD2Ev","__ZNKSt3__17collateIcE12do_transformEPKcS3_","__ZNSt3__17collateIwED0Ev","__ZNSt3__17collateIwED1Ev","__ZNSt3__17collateIwED2Ev","__ZNKSt3__17collateIwE12do_transformEPKwS3_","__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev","__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb","__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb","__ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl","__ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc","__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_","__ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji","__ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj","__ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx","__ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt","__ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_","__ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm","__ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf","__ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_","__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_","__ZNSt3__115__num_get_floatIfEET_PKcS3_Rj","__ZNSt3__115__num_get_floatIdEET_PKcS3_Rj","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd","__ZNSt3__115__num_get_floatIeEET_PKcS3_Rj","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe","__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv","___cxx_global_var_init3273","__ZNSt3__16__clocEv","__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev","__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev","__ZNSt3__110__sscanf_lEPKcPvS1_z","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb","__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl","__ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw","__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf","__ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_","__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe","___cxx_global_var_init4274","__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev","__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev","__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv","__ZNSt3__114__num_put_base12__format_intEPcPKcbj","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl","__ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE","__ZNSt3__111__sprintf_lEPcPvPKcz","__ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE","__ZNSt3__116__pad_and_outputIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd","__ZNSt3__114__num_put_base14__format_floatEPcPKcj","__ZNSt3__112__snprintf_lEPcjPvPKcz","__ZNSt3__112__asprintf_lEPPcPvPKcz","__ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce","___cxx_global_var_init9275","__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev","__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev","__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl","__ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE","__ZNSt3__116__pad_and_outputIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEET0_S5_PKT_S8_S8_RNS_8ios_baseES6_","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd","__ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe","__ZNSt3__120__time_get_c_storageIcEC2Ev","__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv","___cxx_global_var_init10276","__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev","__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE","__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE","__ZNSt3__120__time_get_c_storageIwEC2Ev","__ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv","___cxx_global_var_init15","__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev","__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE","__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE","___cxx_global_var_init20","__ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi","__ZNSt3__110__time_putD2Ev","__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev","__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev","___cxx_global_var_init21","__ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc","__ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc","__ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc","__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev","__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev","__ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv","__ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv","___cxx_global_var_init22","__ZNKSt3__110moneypunctIcLb0EE11do_groupingEv","__ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv","__ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv","__ZNSt3__110moneypunctIcLb0EED0Ev","__ZNSt3__110moneypunctIcLb0EED1Ev","__ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc","__ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv","__ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv","__ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv","__ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv","__ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv","__ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv","___cxx_global_var_init23","__ZNKSt3__110moneypunctIcLb1EE11do_groupingEv","__ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv","__ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv","___cxx_global_var_init24","__ZNKSt3__110moneypunctIwLb0EE11do_groupingEv","__ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv","__ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv","__ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv","__ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv","__ZNSt3__110moneypunctIcLb1EED0Ev","__ZNSt3__110moneypunctIcLb1EED1Ev","__ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv","__ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv","__ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv","__ZNSt3__110moneypunctIwLb0EED0Ev","__ZNSt3__110moneypunctIwLb0EED1Ev","__ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv","__ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv","__ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv","__ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv","__ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv","___cxx_global_var_init25","__ZNKSt3__110moneypunctIwLb1EE11do_groupingEv","__ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv","__ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv","___cxx_global_var_init26","__ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv","__ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv","__ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv","__ZNSt3__110moneypunctIwLb1EED0Ev","__ZNSt3__110moneypunctIwLb1EED1Ev","__ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv","__ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv","__ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv","__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev","__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev","__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe","__ZNSt3__112__do_nothingEPv","__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_","__ZNSt3__121__throw_runtime_errorEPKc","__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_","__ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri","__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SD_SC_SC_RKT1_Rjb","__ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_","__ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_","___cxx_global_var_init29","__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev","__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev","__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe","__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_","__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_","__ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri","__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SD_SC_SC_RKT1_Rjb","__ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_","___cxx_global_var_init30","__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev","__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev","__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce","__ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri","__ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i","__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE","___cxx_global_var_init32","__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev","__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev","__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe","__ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri","__ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i","__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE","___cxx_global_var_init33","__ZNSt3__18messagesIcED0Ev","__ZNSt3__18messagesIcED1Ev","__ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE","__ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE","___cxx_global_var_init34","__ZNKSt3__18messagesIcE8do_closeEi","__ZNSt3__18messagesIwED0Ev","__ZNSt3__18messagesIwED1Ev","__ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE","__ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE","__ZNSt3__112_GLOBAL__N_14makeINS_7collateIcEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7collateIwEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIwEEiEERT_T0_","__ZNKSt3__18messagesIwE8do_closeEi","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC1Ej","__ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_","__ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_","__ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_5ctypeIcEEPjbiEERT_T0_T1_T2_","__ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_","__ZNSt3__17codecvtIwc10_mbstate_tED2Ev","__ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv","__ZNSt3__16locale5__impC2Ej","__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIcc10_mbstate_tEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtItc10_mbstate_tEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIjc10_mbstate_tEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb0EEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_7codecvtIcc10_mbstate_tEEEEvPT_","__ZNSt3__16locale5__imp7installINS_7codecvtIwc10_mbstate_tEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_7codecvtIwc10_mbstate_tEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_7codecvtItc10_mbstate_tEEEEvPT_","__ZNSt3__16locale5__imp7installINS_7codecvtIjc10_mbstate_tEEEEvPT_","__ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_8numpunctIcEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_8numpunctIwEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_","__ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIcLb1EEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb0EEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_10moneypunctIwLb1EEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_","__ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_","__ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_","__ZNSt3__112_GLOBAL__N_14makeINS_8messagesIcEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_8messagesIwEEiEERT_T0_","__ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_","__ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_","__ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED1Ev","__ZNSt3__16locale7classicEv","__ZNSt3__16locale5__impD0Ev","__ZNSt3__112_GLOBAL__N_14makeINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEiEERT_T0_","__ZNSt3__112_GLOBAL__N_14makeINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEiEERT_T0_","__ZNSt3__16locale5__imp7installEPNS0_5facetEl","__ZNSt3__16locale5__impD2Ev","__ZNSt3__15ctypeIcE13classic_tableEv","__ZNSt3__15ctypeIcE21__classic_upper_tableEv","__ZNSt3__15ctypeIcE21__classic_lower_tableEv","__ZNKSt3__15ctypeIwE8do_widenEc","__ZNKSt3__15ctypeIwE9do_narrowEwc","__ZNKSt3__16locale5__imp9has_facetEl","__ZNSt3__16locale2id6__initEv","___cxx_global_var_init41","__ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj","__ZNSt3__16locale5__imp12make_classicEv","__ZNSt3__112_GLOBAL__N_14makeINS_6locale5__impEiEERT_T0_","__ZNSt3__16locale5__imp11make_globalEv","__ZNSt3__16locale8__globalEv","__ZNSt3__16localeC2ERKS0_","__ZNSt3__16localeD2Ev","__ZNSt3__16locale2id5__getEv","__ZNKSt3__16locale9use_facetERNS0_2idE","__ZNSt3__16locale5facetD0Ev","__ZNSt3__15ctypeIwED0Ev","__ZNKSt3__15ctypeIwE5do_isEjw","__ZNKSt3__15ctypeIwE5do_isEPKwS3_Pj","__ZNKSt3__15ctypeIwE10do_scan_isEjPKwS3_","__ZNKSt3__15ctypeIwE11do_scan_notEjPKwS3_","__ZNKSt3__15ctypeIwE10do_toupperEw","__ZNKSt3__15ctypeIwE10do_toupperEPwPKw","__ZNKSt3__15ctypeIwE10do_tolowerEw","__ZNKSt3__15ctypeIwE10do_tolowerEPwPKw","__ZNKSt3__16locale5__imp9use_facetEl","__ZNSt3__16localeC2Ev","__ZNSt3__16locale5facet16__on_zero_sharedEv","__ZNKSt3__15ctypeIcE8do_widenEc","__ZNKSt3__17codecvtIcc10_mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_","__ZNKSt3__17codecvtIcc10_mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_","__ZNKSt3__17codecvtIcc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_","__ZNKSt3__17codecvtIcc10_mbstate_tE11do_encodingEv","__ZNKSt3__17codecvtIcc10_mbstate_tE16do_always_noconvEv","__ZNKSt3__17codecvtIcc10_mbstate_tE13do_max_lengthEv","__ZNKSt3__15ctypeIcE9do_narrowEcc","__ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc","___cxx_global_var_init42","__ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc","__ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc","___cxx_global_var_init45","___cxx_global_var_init46","__ZNSt3__15ctypeIcED0Ev","__ZNSt3__15ctypeIcED2Ev","__ZNKSt3__15ctypeIcE10do_toupperEc","__ZNKSt3__15ctypeIcE10do_toupperEPcPKc","__ZNKSt3__15ctypeIcE10do_tolowerEc","__ZNKSt3__15ctypeIcE10do_tolowerEPcPKc","__ZNSt3__17codecvtIcc10_mbstate_tED0Ev","__ZNKSt3__17codecvtIcc10_mbstate_tE9do_lengthERS1_PKcS5_j","__ZNSt3__17codecvtIwc10_mbstate_tED0Ev","__ZNSt3__15ctypeIcEC2EPKjbj","__ZNSt3__17codecvtIwc10_mbstate_tEC2Ej","__ZNKSt3__17codecvtIwc10_mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_","__ZNKSt3__17codecvtIwc10_mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_","__ZNKSt3__17codecvtIwc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_","__ZNKSt3__17codecvtIwc10_mbstate_tE11do_encodingEv","__ZNKSt3__17codecvtIwc10_mbstate_tE16do_always_noconvEv","__ZNKSt3__17codecvtIwc10_mbstate_tE9do_lengthERS1_PKcS5_j","___cxx_global_var_init48","__ZNSt3__17codecvtItc10_mbstate_tED0Ev","__ZNKSt3__17codecvtItc10_mbstate_tE6do_outERS1_PKtS5_RS5_PcS7_RS7_","__ZNKSt3__17codecvtIwc10_mbstate_tE13do_max_lengthEv","__ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE","__ZNKSt3__17codecvtItc10_mbstate_tE5do_inERS1_PKcS5_RS5_PtS7_RS7_","__ZNKSt3__17codecvtItc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_","__ZNKSt3__17codecvtItc10_mbstate_tE11do_encodingEv","__ZNKSt3__17codecvtItc10_mbstate_tE16do_always_noconvEv","__ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE","__ZNKSt3__17codecvtItc10_mbstate_tE9do_lengthERS1_PKcS5_j","__ZNKSt3__17codecvtItc10_mbstate_tE13do_max_lengthEv","__ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE","___cxx_global_var_init49","__ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE","__ZNSt3__17codecvtIjc10_mbstate_tED0Ev","__ZNKSt3__17codecvtIjc10_mbstate_tE6do_outERS1_PKjS5_RS5_PcS7_RS7_","__ZNKSt3__17codecvtIjc10_mbstate_tE10do_unshiftERS1_PcS4_RS4_","__ZNKSt3__17codecvtIjc10_mbstate_tE11do_encodingEv","__ZNKSt3__17codecvtIjc10_mbstate_tE16do_always_noconvEv","__ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE","__ZNKSt3__17codecvtIjc10_mbstate_tE5do_inERS1_PKcS5_RS5_PjS7_RS7_","__ZNKSt3__17codecvtIjc10_mbstate_tE9do_lengthERS1_PKcS5_j","__ZNKSt3__17codecvtIjc10_mbstate_tE13do_max_lengthEv","__ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE","___cxx_global_var_init50","___cxx_global_var_init51","__ZNSt3__116__narrow_to_utf8ILj32EED0Ev","__ZNSt3__117__widen_from_utf8ILj32EED0Ev","__ZNSt3__18numpunctIcEC2Ej","__ZNKSt3__18numpunctIcE16do_decimal_pointEv","__ZNKSt3__18numpunctIwE16do_decimal_pointEv","__ZNKSt3__18numpunctIcE16do_thousands_sepEv","__ZNKSt3__18numpunctIwE16do_thousands_sepEv","__ZNSt3__18numpunctIcED0Ev","__ZNSt3__18numpunctIwED0Ev","__ZNKSt3__18numpunctIcE11do_groupingEv","__ZNKSt3__18numpunctIwE11do_groupingEv","__ZNKSt3__18numpunctIcE11do_truenameEv","__ZNKSt3__18numpunctIwE11do_truenameEv","__ZNKSt3__18numpunctIcE12do_falsenameEv","__ZNKSt3__18numpunctIwE12do_falsenameEv","__ZNKSt3__120__time_get_c_storageIcE7__weeksEv","__ZNSt3__18numpunctIwEC2Ej","__ZNSt3__18numpunctIcED2Ev","__ZNSt3__18numpunctIwED2Ev","__ZNKSt3__120__time_get_c_storageIwE7__weeksEv","__ZNKSt3__120__time_get_c_storageIcE8__monthsEv","__ZNSt3__1L10init_weeksEv","__ZNSt3__1L11init_wweeksEv","__ZNKSt3__120__time_get_c_storageIwE8__monthsEv","__ZNSt3__1L11init_monthsEv","__ZNKSt3__120__time_get_c_storageIcE7__am_pmEv","__ZNKSt3__120__time_get_c_storageIwE7__am_pmEv","__ZNSt3__1L12init_wmonthsEv","__ZNSt3__1L10init_am_pmEv","__ZNKSt3__120__time_get_c_storageIcE3__xEv","__ZNKSt3__120__time_get_c_storageIwE3__xEv","__ZNKSt3__120__time_get_c_storageIcE3__XEv","__ZNKSt3__120__time_get_c_storageIwE3__XEv","__ZNKSt3__120__time_get_c_storageIcE3__cEv","__ZNKSt3__120__time_get_c_storageIwE3__cEv","__ZNSt3__1L11init_wam_pmEv","__ZNKSt3__120__time_get_c_storageIcE3__rEv","__ZNKSt3__120__time_get_c_storageIwE3__rEv","__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_","__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_","__ZNSt3__117__call_once_proxyINS_12_GLOBAL__N_111__fake_bindEEEvPv","__ZNKSt3__112_GLOBAL__N_111__fake_bindclEv","__ZNSt3__117__call_once_paramINS_12_GLOBAL__N_111__fake_bindEEC2ERKS2_","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC1EjjS6_","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED1Ev","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endINS_13move_iteratorIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESD_SD_","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE10push_frontERKS3_","__ZNSt3__117__compressed_pairIPNS_6locale5facetENS_12_GLOBAL__N_17releaseEEC2ES3_i","__ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_","__ZNSt3__112_GLOBAL__N_17releaseclEPNS_6locale5facetE","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj","__ZNKSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8max_sizeEv","__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEED2Ev","__ZNSt3__110unique_ptrINS_6locale5facetENS_12_GLOBAL__N_17releaseEEC2EPS2_","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej","__ZNKSt8bad_cast4whatEv","__ZNSt8bad_castC2Ev","__ZNSt3__112_GLOBAL__N_111__fake_bindC2EMNS_6locale2idEFvvEPS3_","__ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi","__ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev","__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev","__GLOBAL__I_a285","__ZNSt8bad_castD0Ev","__ZNSt8bad_castD2Ev","__ZN10__cxxabiv116__shim_type_infoD2Ev","__ZN10__cxxabiv117__class_type_infoD0Ev","__ZN10__cxxabiv120__si_class_type_infoD0Ev","__ZN10__cxxabiv121__vmi_class_type_infoD0Ev","__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv","__ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi","__ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi","___cxx_global_array_dtor","___cxx_global_array_dtor77","___cxx_global_array_dtor80","___cxx_global_array_dtor104","___cxx_global_array_dtor128","___cxx_global_array_dtor143","__ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i","__ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi","__ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi","__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi","___dynamic_cast","__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi","__ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i","__ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi","__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi","__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvi","__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i","__ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i","__ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i","_malloc","_tmalloc_small","_tmalloc_large","_sys_alloc","_free","_sys_trim","_realloc","_release_unused_segments","_mmap_resize","_segment_holding","_init_top","_mmap_alloc","_init_bins","_internal_realloc","_init_mparams","_prepend_alloc","__ZNKSt9bad_alloc4whatEv","__ZSt15get_new_handlerv","__ZNSt9bad_allocC2Ev","__ZdlPv","__ZdaPv","__ZNSt9bad_allocD0Ev","__ZNSt9bad_allocD2Ev","_add_segment","__Znwj","__Znaj","__ZSt17__throw_bad_allocv"]

